/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 107;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 34,
  Feature_HasStdExtZicondBit = 36,
  Feature_HasStdExtZihintpauseBit = 22,
  Feature_HasStdExtZimopBit = 33,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 37,
  Feature_HasStdExtZmmulBit = 23,
  Feature_HasStdExtMBit = 24,
  Feature_HasStdExtABit = 26,
  Feature_HasStdExtZtsoBit = 28,
  Feature_NotHasStdExtZtsoBit = 27,
  Feature_HasStdExtZabhaBit = 31,
  Feature_HasStdExtZacasBit = 30,
  Feature_NoStdExtZacasBit = 29,
  Feature_HasStdExtZalasrBit = 32,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 38,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtZcaBit = 20,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtZbaBit = 44,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 41,
  Feature_NoStdExtZbbBit = 43,
  Feature_HasStdExtZbcBit = 46,
  Feature_HasStdExtZbsBit = 40,
  Feature_HasStdExtZbkbBit = 42,
  Feature_NoStdExtZbkbBit = 104,
  Feature_HasStdExtZbkxBit = 47,
  Feature_HasStdExtZbbOrZbkbBit = 39,
  Feature_HasStdExtZbcOrZbkcBit = 45,
  Feature_HasStdExtZkndBit = 48,
  Feature_HasStdExtZkneBit = 50,
  Feature_HasStdExtZkndOrZkneBit = 49,
  Feature_HasStdExtZknhBit = 51,
  Feature_HasStdExtZksedBit = 52,
  Feature_HasStdExtZkshBit = 53,
  Feature_HasStdExtZvkbBit = 61,
  Feature_HasStdExtZvbbBit = 60,
  Feature_HasStdExtZvbcBit = 65,
  Feature_HasStdExtZvkgBit = 62,
  Feature_HasStdExtZvknedBit = 63,
  Feature_HasStdExtZvknhaBit = 66,
  Feature_HasStdExtZvknhbBit = 67,
  Feature_HasStdExtZvksedBit = 68,
  Feature_HasStdExtZvkshBit = 64,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 56,
  Feature_HasVInstructionsAnyFBit = 55,
  Feature_HasVInstructionsF16MinimalBit = 58,
  Feature_HasVInstructionsF16Bit = 54,
  Feature_HasVInstructionsF64Bit = 59,
  Feature_HasVInstructionsFullMultiplyBit = 57,
  Feature_HasVendorXVentanaCondOpsBit = 69,
  Feature_HasVendorXTHeadBaBit = 70,
  Feature_HasVendorXTHeadBbBit = 71,
  Feature_HasVendorXTHeadBsBit = 72,
  Feature_HasVendorXTHeadCondMovBit = 73,
  Feature_HasVendorXTHeadFMemIdxBit = 78,
  Feature_HasVendorXTHeadMacBit = 74,
  Feature_HasVendorXTHeadMemIdxBit = 77,
  Feature_HasVendorXTHeadMemPairBit = 76,
  Feature_HasVendorXTHeadVdotBit = 75,
  Feature_HasVendorXSfvcpBit = 79,
  Feature_HasVendorXSfvqmaccdodBit = 80,
  Feature_HasVendorXSfvqmaccqoqBit = 81,
  Feature_HasVendorXSfvfnrclipxfqfBit = 82,
  Feature_HasVendorXCVbitmanipBit = 84,
  Feature_HasVendorXCVmacBit = 87,
  Feature_HasVendorXCVmemBit = 83,
  Feature_HasVendorXCValuBit = 85,
  Feature_HasVendorXCVbiBit = 86,
  Feature_UseCCMovInsnBit = 102,
  Feature_HasVendorXMIPSCBOPBit = 101,
  Feature_NotHasVendorXMIPSCBOPBit = 35,
  Feature_HasVendorXqciaBit = 92,
  Feature_HasVendorXqciacBit = 88,
  Feature_HasVendorXqcibiBit = 93,
  Feature_HasVendorXqcibmBit = 94,
  Feature_HasVendorXqcicliBit = 98,
  Feature_HasVendorXqcicmBit = 96,
  Feature_HasVendorXqcicsBit = 100,
  Feature_NoVendorXqcicsBit = 97,
  Feature_HasVendorXqcicsOrXqcicmBit = 99,
  Feature_HasVendorXqciintBit = 95,
  Feature_HasVendorXqciliaBit = 89,
  Feature_HasVendorXqciloBit = 90,
  Feature_HasVendorXqcislsBit = 91,
  Feature_HasVendorXAndesPerfBit = 103,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 25,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 106,
  Feature_HwMode0Bit = 105,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZihintpause())
    Features.set(Feature_HasStdExtZihintpauseBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtZca())
    Features.set(Feature_HasStdExtZcaBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_HasVendorXMIPSCBOPBit);
  if (!Subtarget->hasVendorXMIPSCBOP())
    Features.set(Feature_NotHasVendorXMIPSCBOPBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqciac())
    Features.set(Feature_HasVendorXqciacBit);
  if (Subtarget->hasVendorXqcibi())
    Features.set(Feature_HasVendorXqcibiBit);
  if (Subtarget->hasVendorXqcibm())
    Features.set(Feature_HasVendorXqcibmBit);
  if (Subtarget->hasVendorXqcicli())
    Features.set(Feature_HasVendorXqcicliBit);
  if (Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicmBit);
  if (Subtarget->hasVendorXqcics())
    Features.set(Feature_HasVendorXqcicsBit);
  if (!Subtarget->hasVendorXqcics())
    Features.set(Feature_NoVendorXqcicsBit);
  if (Subtarget->hasVendorXqcics() || Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicsOrXqcicmBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZihintpause_HwMode0,
  GIFBS_HasStdExtZihintpause_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqciac_IsRV32_HwMode0,
  GIFBS_HasVendorXqciac_IsRV32_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcics_IsRV32_HwMode0,
  GIFBS_HasVendorXqcics_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciacBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciacBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicsBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicsBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicliBit, Feature_HasVendorXqcicsOrXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicliBit, Feature_HasVendorXqcicsOrXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_NoVendorXqcicsBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9976,
  GICXXPred_MI_Predicate_anonymous_9978,
  GICXXPred_MI_Predicate_anonymous_10068,
  GICXXPred_MI_Predicate_anonymous_10082,
  GICXXPred_MI_Predicate_anonymous_10086,
  GICXXPred_MI_Predicate_anonymous_10088,
  GICXXPred_MI_Predicate_anonymous_10090,
  GICXXPred_MI_Predicate_anonymous_10092,
  GICXXPred_MI_Predicate_anonymous_10095,
  GICXXPred_MI_Predicate_anonymous_10097,
  GICXXPred_MI_Predicate_anonymous_10110,
  GICXXPred_MI_Predicate_anonymous_10123,
  GICXXPred_MI_Predicate_anonymous_11319,
  GICXXPred_MI_Predicate_or_disjoint,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9976: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9978: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10068: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10082: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10086: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10088: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10090: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10092: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10095: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10097: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10110: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10123: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11319: {
     return hasAllHUsers(MI); 
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_bare_simm13_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm20_li,
  GICXXPred_I64_Predicate_simm21_lsb0_jal,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm13_lsb0: {
    return isShiftedInt<12, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm20_li: {
    return isInt<20>(Imm);
  }
  case GICXXPred_I64_Predicate_simm21_lsb0_jal: {
    return isShiftedInt<20, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7: {
    return isUInt<7>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(337), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2457144),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1146),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61537),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80770),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107824),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110558),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(113292),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(116071), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118805),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(128763),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(141384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(156291), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(156352), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(156413), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(156504), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(156871),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(157069),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(157267),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(157847),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(158057),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(158255),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(158294),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(158333),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(167311),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(168425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(169059), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(175959),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(180845),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(183755), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(186665),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(189575),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(190487),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(193397),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(196307),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(199217),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(202127),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(205037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(207947), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(208165),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2206458), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2208026), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     366 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2211147),
     /*     370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2214622),
     /*     374 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2215665),
     /*     378 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2219352),
     /*     382 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2227948),
     /*     386 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2230979), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     398 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2233918),
     /*     402 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2236858),
     /*     406 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2239768),
     /*     410 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2266845), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     422 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2274307), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     466 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2285292),
     /*     470 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2288026),
     /*     474 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2290760),
     /*     478 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2293613),
     /*     482 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2296466),
     /*     486 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2299319),
     /*     490 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2302172),
     /*     494 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2302230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     530 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2302288),
     /*     534 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2304716),
     /*     538 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2307144),
     /*     542 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2309572), GIMT_Encode4(0),
     /*     550 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2326217), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     598 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2328645),
     /*     602 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2330616),
     /*     606 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2331069),
     /*     610 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2332605),
     /*     614 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2337491),
     /*     618 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2342377),
     /*     622 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2347663), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2352949),
     /*     638 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2354920), GIMT_Encode4(0),
     /*     646 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2360982),
     /*     650 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2361172),
     /*     654 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2363257), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     666 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2365342),
     /*     670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2365468),
     /*     674 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2365594),
     /*     678 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2367679), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     718 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2369764),
     /*     722 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2372540),
     /*     726 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2375316),
     /*     730 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2378092),
     /*     734 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2380868),
     /*     738 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2381026),
     /*     742 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2381606),
     /*     746 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2381816), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2381832), GIMT_Encode4(0),
     /*     798 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2384460), GIMT_Encode4(0),
     /*     806 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2387230),
     /*     810 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2389781),
     /*     814 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2392316),
     /*     818 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2394862), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     866 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2395060),
     /*     870 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2397236),
     /*     874 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2397434),
     /*     878 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2397632), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     906 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2397830),
     /*     910 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2400258),
     /*     914 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2402686),
     /*     918 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2405114), GIMT_Encode4(0),
     /*     926 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2407542),
     /*     930 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2424187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     966 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2426363),
     /*     970 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2426376), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1066 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2426389),
     /*    1070 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2426484),
     /*    1074 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2426514),
     /*    1078 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2426551),
     /*    1082 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2426588),
     /*    1086 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2426948),
     /*    1090 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2427146),
     /*    1094 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2427344),
     /*    1098 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2427404),
     /*    1102 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2427441),
     /*    1106 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2427566),
     /*    1110 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2427687), GIMT_Encode4(0),
     /*    1118 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2427734),
     /*    1122 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2427781),
     /*    1126 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2427828),
     /*    1130 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2428477),
     /*    1134 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2429126),
     /*    1138 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2433384),
     /*    1142 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2445264),
     /*    1146 */ // Label 0: @1146
     /*    1146 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61536),
     /*    1157 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1281),
     /*    1161 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(3996), GIMT_Encode4(0),
     /*    1169 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11896),
     /*    1173 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(12291),
     /*    1177 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(15416),
     /*    1181 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18541), GIMT_Encode4(0),
     /*    1189 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21666),
     /*    1193 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(22061),
     /*    1197 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(25186),
     /*    1201 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(28311), GIMT_Encode4(0),
     /*    1209 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(31436),
     /*    1213 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31831),
     /*    1217 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34956),
     /*    1221 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(38081), GIMT_Encode4(0),
     /*    1229 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(41206),
     /*    1233 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41601),
     /*    1237 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44726),
     /*    1241 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47851), GIMT_Encode4(0),
     /*    1249 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50976),
     /*    1253 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(51371),
     /*    1257 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54496), GIMT_Encode4(0),
     /*    1265 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57621),
     /*    1269 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(58016), GIMT_Encode4(0),
     /*    1277 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(61141),
     /*    1281 */ // Label 126: @1281
     /*    1281 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3995),
     /*    1286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1292 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1340), // Rule ID 2572 //
     /*    1297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1304 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1308 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1327 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1338 */     GIR_RootConstrainSelectedInstOperands,
     /*    1339 */     // GIR_Coverage, 2572,
     /*    1339 */     GIR_EraseRootFromParent_Done,
     /*    1340 */   // Label 152: @1340
     /*    1340 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1388), // Rule ID 2582 //
     /*    1345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1352 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1356 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1375 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1386 */     GIR_RootConstrainSelectedInstOperands,
     /*    1387 */     // GIR_Coverage, 2582,
     /*    1387 */     GIR_EraseRootFromParent_Done,
     /*    1388 */   // Label 153: @1388
     /*    1388 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1436), // Rule ID 2592 //
     /*    1393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1400 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1404 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1423 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1434 */     GIR_RootConstrainSelectedInstOperands,
     /*    1435 */     // GIR_Coverage, 2592,
     /*    1435 */     GIR_EraseRootFromParent_Done,
     /*    1436 */   // Label 154: @1436
     /*    1436 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1487), // Rule ID 62538 //
     /*    1441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1448 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1471 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1485 */     GIR_RootConstrainSelectedInstOperands,
     /*    1486 */     // GIR_Coverage, 62538,
     /*    1486 */     GIR_EraseRootFromParent_Done,
     /*    1487 */   // Label 155: @1487
     /*    1487 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1538), // Rule ID 62542 //
     /*    1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1499 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1503 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1522 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1536 */     GIR_RootConstrainSelectedInstOperands,
     /*    1537 */     // GIR_Coverage, 62542,
     /*    1537 */     GIR_EraseRootFromParent_Done,
     /*    1538 */   // Label 156: @1538
     /*    1538 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1589), // Rule ID 62546 //
     /*    1543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1550 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1554 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1573 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1587 */     GIR_RootConstrainSelectedInstOperands,
     /*    1588 */     // GIR_Coverage, 62546,
     /*    1588 */     GIR_EraseRootFromParent_Done,
     /*    1589 */   // Label 157: @1589
     /*    1589 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1637), // Rule ID 65117 //
     /*    1594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1601 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    1605 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    1609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1624 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1635 */     GIR_RootConstrainSelectedInstOperands,
     /*    1636 */     // GIR_Coverage, 65117,
     /*    1636 */     GIR_EraseRootFromParent_Done,
     /*    1637 */   // Label 158: @1637
     /*    1637 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1685), // Rule ID 65127 //
     /*    1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1649 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    1653 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    1657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1672 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1683 */     GIR_RootConstrainSelectedInstOperands,
     /*    1684 */     // GIR_Coverage, 65127,
     /*    1684 */     GIR_EraseRootFromParent_Done,
     /*    1685 */   // Label 159: @1685
     /*    1685 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1733), // Rule ID 65137 //
     /*    1690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1697 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    1701 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    1705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1720 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:33:x, GPR:{ *:[i32] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1731 */     GIR_RootConstrainSelectedInstOperands,
     /*    1732 */     // GIR_Coverage, 65137,
     /*    1732 */     GIR_EraseRootFromParent_Done,
     /*    1733 */   // Label 160: @1733
     /*    1733 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1781), // Rule ID 65596 //
     /*    1738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1753 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1768 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1779 */     GIR_RootConstrainSelectedInstOperands,
     /*    1780 */     // GIR_Coverage, 65596,
     /*    1780 */     GIR_EraseRootFromParent_Done,
     /*    1781 */   // Label 161: @1781
     /*    1781 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1829), // Rule ID 65604 //
     /*    1786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1793 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1801 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1816 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1827 */     GIR_RootConstrainSelectedInstOperands,
     /*    1828 */     // GIR_Coverage, 65604,
     /*    1828 */     GIR_EraseRootFromParent_Done,
     /*    1829 */   // Label 162: @1829
     /*    1829 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1877), // Rule ID 65612 //
     /*    1834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1841 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1849 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1864 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1875 */     GIR_RootConstrainSelectedInstOperands,
     /*    1876 */     // GIR_Coverage, 65612,
     /*    1876 */     GIR_EraseRootFromParent_Done,
     /*    1877 */   // Label 163: @1877
     /*    1877 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1928), // Rule ID 74430 //
     /*    1882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1889 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1897 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1912 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1926 */     GIR_RootConstrainSelectedInstOperands,
     /*    1927 */     // GIR_Coverage, 74430,
     /*    1927 */     GIR_EraseRootFromParent_Done,
     /*    1928 */   // Label 164: @1928
     /*    1928 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1979), // Rule ID 74434 //
     /*    1933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1940 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1948 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1963 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1977 */     GIR_RootConstrainSelectedInstOperands,
     /*    1978 */     // GIR_Coverage, 74434,
     /*    1978 */     GIR_EraseRootFromParent_Done,
     /*    1979 */   // Label 165: @1979
     /*    1979 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2030), // Rule ID 74438 //
     /*    1984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1991 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1999 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    2003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2014 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    2014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2028 */     GIR_RootConstrainSelectedInstOperands,
     /*    2029 */     // GIR_Coverage, 74438,
     /*    2029 */     GIR_EraseRootFromParent_Done,
     /*    2030 */   // Label 166: @2030
     /*    2030 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2078), // Rule ID 74456 //
     /*    2035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2042 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2050 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2065 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, sh1add_op:{ *:[i32] }:$rs1:$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2076 */     GIR_RootConstrainSelectedInstOperands,
     /*    2077 */     // GIR_Coverage, 74456,
     /*    2077 */     GIR_EraseRootFromParent_Done,
     /*    2078 */   // Label 167: @2078
     /*    2078 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2126), // Rule ID 74464 //
     /*    2083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2090 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2098 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2113 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, sh2add_op:{ *:[i32] }:$rs1:$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2124 */     GIR_RootConstrainSelectedInstOperands,
     /*    2125 */     // GIR_Coverage, 74464,
     /*    2125 */     GIR_EraseRootFromParent_Done,
     /*    2126 */   // Label 168: @2126
     /*    2126 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2174), // Rule ID 74472 //
     /*    2131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2138 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    2142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2146 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    2150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2161 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:33:y, sh3add_op:{ *:[i32] }:$rs1:$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2172 */     GIR_RootConstrainSelectedInstOperands,
     /*    2173 */     // GIR_Coverage, 74472,
     /*    2173 */     GIR_EraseRootFromParent_Done,
     /*    2174 */   // Label 169: @2174
     /*    2174 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2242), // Rule ID 2566 //
     /*    2179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2186 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2215 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2229 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2240 */     GIR_RootConstrainSelectedInstOperands,
     /*    2241 */     // GIR_Coverage, 2566,
     /*    2241 */     GIR_EraseRootFromParent_Done,
     /*    2242 */   // Label 170: @2242
     /*    2242 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2310), // Rule ID 2576 //
     /*    2247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2254 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2279 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2283 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2297 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2308 */     GIR_RootConstrainSelectedInstOperands,
     /*    2309 */     // GIR_Coverage, 2576,
     /*    2309 */     GIR_EraseRootFromParent_Done,
     /*    2310 */   // Label 171: @2310
     /*    2310 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2378), // Rule ID 2586 //
     /*    2315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2322 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2347 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2351 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2365 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2376 */     GIR_RootConstrainSelectedInstOperands,
     /*    2377 */     // GIR_Coverage, 2586,
     /*    2377 */     GIR_EraseRootFromParent_Done,
     /*    2378 */   // Label 172: @2378
     /*    2378 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2446), // Rule ID 65111 //
     /*    2383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2390 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    2394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2415 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2419 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    2423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2433 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2444 */     GIR_RootConstrainSelectedInstOperands,
     /*    2445 */     // GIR_Coverage, 65111,
     /*    2445 */     GIR_EraseRootFromParent_Done,
     /*    2446 */   // Label 173: @2446
     /*    2446 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2514), // Rule ID 65121 //
     /*    2451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2458 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    2462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2487 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    2491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2501 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2512 */     GIR_RootConstrainSelectedInstOperands,
     /*    2513 */     // GIR_Coverage, 65121,
     /*    2513 */     GIR_EraseRootFromParent_Done,
     /*    2514 */   // Label 174: @2514
     /*    2514 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2582), // Rule ID 65131 //
     /*    2519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2526 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    2530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2555 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    2559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2569 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2580 */     GIR_RootConstrainSelectedInstOperands,
     /*    2581 */     // GIR_Coverage, 65131,
     /*    2581 */     GIR_EraseRootFromParent_Done,
     /*    2582 */   // Label 175: @2582
     /*    2582 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2650), // Rule ID 65592 //
     /*    2587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2594 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2602 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2627 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2637 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2648 */     GIR_RootConstrainSelectedInstOperands,
     /*    2649 */     // GIR_Coverage, 65592,
     /*    2649 */     GIR_EraseRootFromParent_Done,
     /*    2650 */   // Label 176: @2650
     /*    2650 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2718), // Rule ID 65600 //
     /*    2655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2662 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2670 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2695 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2705 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2716 */     GIR_RootConstrainSelectedInstOperands,
     /*    2717 */     // GIR_Coverage, 65600,
     /*    2717 */     GIR_EraseRootFromParent_Done,
     /*    2718 */   // Label 177: @2718
     /*    2718 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2786), // Rule ID 65608 //
     /*    2723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2730 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2738 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2773 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2784 */     GIR_RootConstrainSelectedInstOperands,
     /*    2785 */     // GIR_Coverage, 65608,
     /*    2785 */     GIR_EraseRootFromParent_Done,
     /*    2786 */   // Label 178: @2786
     /*    2786 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2854), // Rule ID 74452 //
     /*    2791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2798 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2806 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2841 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2852 */     GIR_RootConstrainSelectedInstOperands,
     /*    2853 */     // GIR_Coverage, 74452,
     /*    2853 */     GIR_EraseRootFromParent_Done,
     /*    2854 */   // Label 179: @2854
     /*    2854 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2922), // Rule ID 74460 //
     /*    2859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2866 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2909 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2920 */     GIR_RootConstrainSelectedInstOperands,
     /*    2921 */     // GIR_Coverage, 74460,
     /*    2921 */     GIR_EraseRootFromParent_Done,
     /*    2922 */   // Label 180: @2922
     /*    2922 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2990), // Rule ID 74468 //
     /*    2927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2934 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2942 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2977 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2988 */     GIR_RootConstrainSelectedInstOperands,
     /*    2989 */     // GIR_Coverage, 74468,
     /*    2989 */     GIR_EraseRootFromParent_Done,
     /*    2990 */   // Label 181: @2990
     /*    2990 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3069), // Rule ID 62532 //
     /*    2995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    3006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3039 */     // MIs[2] Operand 1
     /*    3039 */     // No operand predicates
     /*    3039 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3053 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3067 */     GIR_RootConstrainSelectedInstOperands,
     /*    3068 */     // GIR_Coverage, 62532,
     /*    3068 */     GIR_EraseRootFromParent_Done,
     /*    3069 */   // Label 182: @3069
     /*    3069 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3148), // Rule ID 64533 //
     /*    3074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode0),
     /*    3077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    3085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3118 */     // MIs[2] Operand 1
     /*    3118 */     // No operand predicates
     /*    3118 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    3122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3132 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x, GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3146 */     GIR_RootConstrainSelectedInstOperands,
     /*    3147 */     // GIR_Coverage, 64533,
     /*    3147 */     GIR_EraseRootFromParent_Done,
     /*    3148 */   // Label 183: @3148
     /*    3148 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3227), // Rule ID 64534 //
     /*    3153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3160 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    3164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3197 */     // MIs[2] Operand 1
     /*    3197 */     // No operand predicates
     /*    3197 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    3201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3211 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x, GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3225 */     GIR_RootConstrainSelectedInstOperands,
     /*    3226 */     // GIR_Coverage, 64534,
     /*    3226 */     GIR_EraseRootFromParent_Done,
     /*    3227 */   // Label 184: @3227
     /*    3227 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3306), // Rule ID 74426 //
     /*    3232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3239 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3247 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3284 */     // MIs[2] Operand 1
     /*    3284 */     // No operand predicates
     /*    3284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3290 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3304 */     GIR_RootConstrainSelectedInstOperands,
     /*    3305 */     // GIR_Coverage, 74426,
     /*    3305 */     GIR_EraseRootFromParent_Done,
     /*    3306 */   // Label 185: @3306
     /*    3306 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3385), // Rule ID 74447 //
     /*    3311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode0),
     /*    3314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3318 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    3322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3326 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    3330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3363 */     // MIs[2] Operand 1
     /*    3363 */     // No operand predicates
     /*    3363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3369 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3383 */     GIR_RootConstrainSelectedInstOperands,
     /*    3384 */     // GIR_Coverage, 74447,
     /*    3384 */     GIR_EraseRootFromParent_Done,
     /*    3385 */   // Label 186: @3385
     /*    3385 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3464), // Rule ID 74448 //
     /*    3390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3397 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    3401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3405 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    3409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5gt3),
     /*    3442 */     // MIs[2] Operand 1
     /*    3442 */     // No operand predicates
     /*    3442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3448 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (QC_SHLADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5gt3>>:$imm)
     /*    3448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLADD),
     /*    3451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*    3462 */     GIR_RootConstrainSelectedInstOperands,
     /*    3463 */     // GIR_Coverage, 74448,
     /*    3463 */     GIR_EraseRootFromParent_Done,
     /*    3464 */   // Label 187: @3464
     /*    3464 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3531), // Rule ID 74444 //
     /*    3469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3509 */     // MIs[2] Operand 1
     /*    3509 */     // No operand predicates
     /*    3509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3515 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12), GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MULIADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*    3515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MULIADD),
     /*    3518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm12
     /*    3529 */     GIR_RootConstrainSelectedInstOperands,
     /*    3530 */     // GIR_Coverage, 74444,
     /*    3530 */     GIR_EraseRootFromParent_Done,
     /*    3531 */   // Label 188: @3531
     /*    3531 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3580), // Rule ID 121 //
     /*    3536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3551 */     // MIs[1] Operand 1
     /*    3551 */     // No operand predicates
     /*    3551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3563 */     // MIs[2] Operand 1
     /*    3563 */     // No operand predicates
     /*    3563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3565 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3570 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3578 */     GIR_RootConstrainSelectedInstOperands,
     /*    3579 */     // GIR_Coverage, 121,
     /*    3579 */     GIR_EraseRootFromParent_Done,
     /*    3580 */   // Label 189: @3580
     /*    3580 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3647), // Rule ID 64530 //
     /*    3585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqciac_IsRV32_HwMode1),
     /*    3588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3629 */     // MIs[2] Operand 1
     /*    3629 */     // No operand predicates
     /*    3629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3631 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))  =>  (QC_MULIADD:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*    3631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MULIADD),
     /*    3634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm12
     /*    3645 */     GIR_RootConstrainSelectedInstOperands,
     /*    3646 */     // GIR_Coverage, 64530,
     /*    3646 */     GIR_EraseRootFromParent_Done,
     /*    3647 */   // Label 190: @3647
     /*    3647 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3689), // Rule ID 81 //
     /*    3652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3675 */     // MIs[1] Operand 1
     /*    3675 */     // No operand predicates
     /*    3675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3677 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3687 */     GIR_RootConstrainSelectedInstOperands,
     /*    3688 */     // GIR_Coverage, 81,
     /*    3688 */     GIR_EraseRootFromParent_Done,
     /*    3689 */   // Label 191: @3689
     /*    3689 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3761), // Rule ID 296 //
     /*    3694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3717 */     // MIs[1] Operand 1
     /*    3717 */     // No operand predicates
     /*    3717 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*    3721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3723 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3739 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3754 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3759 */     GIR_RootConstrainSelectedInstOperands,
     /*    3760 */     // GIR_Coverage, 296,
     /*    3760 */     GIR_EraseRootFromParent_Done,
     /*    3761 */   // Label 192: @3761
     /*    3761 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3803), // Rule ID 64537 //
     /*    3766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3789 */     // MIs[1] Operand 1
     /*    3789 */     // No operand predicates
     /*    3789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3791 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3801 */     GIR_RootConstrainSelectedInstOperands,
     /*    3802 */     // GIR_Coverage, 64537,
     /*    3802 */     GIR_EraseRootFromParent_Done,
     /*    3803 */   // Label 193: @3803
     /*    3803 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3845), // Rule ID 64541 //
     /*    3808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3831 */     // MIs[1] Operand 1
     /*    3831 */     // No operand predicates
     /*    3831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3833 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3843 */     GIR_RootConstrainSelectedInstOperands,
     /*    3844 */     // GIR_Coverage, 64541,
     /*    3844 */     GIR_EraseRootFromParent_Done,
     /*    3845 */   // Label 194: @3845
     /*    3845 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3906), // Rule ID 74440 //
     /*    3850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3889 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3904 */     GIR_RootConstrainSelectedInstOperands,
     /*    3905 */     // GIR_Coverage, 74440,
     /*    3905 */     GIR_EraseRootFromParent_Done,
     /*    3906 */   // Label 195: @3906
     /*    3906 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3967), // Rule ID 62599 //
     /*    3911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3950 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3965 */     GIR_RootConstrainSelectedInstOperands,
     /*    3966 */     // GIR_Coverage, 62599,
     /*    3966 */     GIR_EraseRootFromParent_Done,
     /*    3967 */   // Label 196: @3967
     /*    3967 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3994), // Rule ID 79 //
     /*    3972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3987 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    3992 */     GIR_RootConstrainSelectedInstOperands,
     /*    3993 */     // GIR_Coverage, 79,
     /*    3993 */     GIR_Done,
     /*    3994 */   // Label 197: @3994
     /*    3994 */   GIM_Reject,
     /*    3995 */ // Label 151: @3995
     /*    3995 */ GIM_Reject,
     /*    3996 */ // Label 127: @3996
     /*    3996 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11895),
     /*    4001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    4004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    4007 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4102), // Rule ID 2612 //
     /*    4012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4019 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    4023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4060 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4064 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4075 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    4079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4089 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4100 */     GIR_RootConstrainSelectedInstOperands,
     /*    4101 */     // GIR_Coverage, 2612,
     /*    4101 */     GIR_EraseRootFromParent_Done,
     /*    4102 */   // Label 199: @4102
     /*    4102 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4197), // Rule ID 2616 //
     /*    4107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4114 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    4118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4155 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4159 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4170 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    4174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4184 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4195 */     GIR_RootConstrainSelectedInstOperands,
     /*    4196 */     // GIR_Coverage, 2616,
     /*    4196 */     GIR_EraseRootFromParent_Done,
     /*    4197 */   // Label 200: @4197
     /*    4197 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4292), // Rule ID 65167 //
     /*    4202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4209 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    4213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4250 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4254 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4265 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    4269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4279 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4290 */     GIR_RootConstrainSelectedInstOperands,
     /*    4291 */     // GIR_Coverage, 65167,
     /*    4291 */     GIR_EraseRootFromParent_Done,
     /*    4292 */   // Label 201: @4292
     /*    4292 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4387), // Rule ID 65171 //
     /*    4297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4304 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    4308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4345 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4349 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4360 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    4364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4374 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4385 */     GIR_RootConstrainSelectedInstOperands,
     /*    4386 */     // GIR_Coverage, 65171,
     /*    4386 */     GIR_EraseRootFromParent_Done,
     /*    4387 */   // Label 202: @4387
     /*    4387 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4482), // Rule ID 2607 //
     /*    4392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4399 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    4403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4440 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4455 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    4459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4469 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4480 */     GIR_RootConstrainSelectedInstOperands,
     /*    4481 */     // GIR_Coverage, 2607,
     /*    4481 */     GIR_EraseRootFromParent_Done,
     /*    4482 */   // Label 203: @4482
     /*    4482 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4577), // Rule ID 2626 //
     /*    4487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4494 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4535 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4546 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4550 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4564 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4575 */     GIR_RootConstrainSelectedInstOperands,
     /*    4576 */     // GIR_Coverage, 2626,
     /*    4576 */     GIR_EraseRootFromParent_Done,
     /*    4577 */   // Label 204: @4577
     /*    4577 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4672), // Rule ID 2631 //
     /*    4582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4589 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4630 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4641 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4645 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4659 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4670 */     GIR_RootConstrainSelectedInstOperands,
     /*    4671 */     // GIR_Coverage, 2631,
     /*    4671 */     GIR_EraseRootFromParent_Done,
     /*    4672 */   // Label 205: @4672
     /*    4672 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4767), // Rule ID 65152 //
     /*    4677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4684 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    4688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4725 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4740 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    4744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4754 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4765 */     GIR_RootConstrainSelectedInstOperands,
     /*    4766 */     // GIR_Coverage, 65152,
     /*    4766 */     GIR_EraseRootFromParent_Done,
     /*    4767 */   // Label 206: @4767
     /*    4767 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4862), // Rule ID 65157 //
     /*    4772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4779 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    4783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4820 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4835 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    4839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4849 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4860 */     GIR_RootConstrainSelectedInstOperands,
     /*    4861 */     // GIR_Coverage, 65157,
     /*    4861 */     GIR_EraseRootFromParent_Done,
     /*    4862 */   // Label 207: @4862
     /*    4862 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(4957), // Rule ID 65162 //
     /*    4867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    4878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4915 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4930 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    4934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4944 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4955 */     GIR_RootConstrainSelectedInstOperands,
     /*    4956 */     // GIR_Coverage, 65162,
     /*    4956 */     GIR_EraseRootFromParent_Done,
     /*    4957 */   // Label 208: @4957
     /*    4957 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5052), // Rule ID 65622 //
     /*    4962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4969 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4977 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5018 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    5022 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    5033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5039 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5050 */     GIR_RootConstrainSelectedInstOperands,
     /*    5051 */     // GIR_Coverage, 65622,
     /*    5051 */     GIR_EraseRootFromParent_Done,
     /*    5052 */   // Label 209: @5052
     /*    5052 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5147), // Rule ID 65626 //
     /*    5057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    5068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5072 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    5076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5113 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    5117 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    5128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5134 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5145 */     GIR_RootConstrainSelectedInstOperands,
     /*    5146 */     // GIR_Coverage, 65626,
     /*    5146 */     GIR_EraseRootFromParent_Done,
     /*    5147 */   // Label 210: @5147
     /*    5147 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5242), // Rule ID 74490 //
     /*    5152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5159 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    5163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    5171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5208 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    5212 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    5223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5229 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5240 */     GIR_RootConstrainSelectedInstOperands,
     /*    5241 */     // GIR_Coverage, 74490,
     /*    5241 */     GIR_EraseRootFromParent_Done,
     /*    5242 */   // Label 211: @5242
     /*    5242 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5337), // Rule ID 74494 //
     /*    5247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5254 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    5258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    5266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    5307 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    5318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5324 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5335 */     GIR_RootConstrainSelectedInstOperands,
     /*    5336 */     // GIR_Coverage, 74494,
     /*    5336 */     GIR_EraseRootFromParent_Done,
     /*    5337 */   // Label 212: @5337
     /*    5337 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5432), // Rule ID 65618 //
     /*    5342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5349 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    5353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5357 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    5361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5398 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5419 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5430 */     GIR_RootConstrainSelectedInstOperands,
     /*    5431 */     // GIR_Coverage, 65618,
     /*    5431 */     GIR_EraseRootFromParent_Done,
     /*    5432 */   // Label 213: @5432
     /*    5432 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5527), // Rule ID 65634 //
     /*    5437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5444 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    5448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    5456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5493 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5514 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5525 */     GIR_RootConstrainSelectedInstOperands,
     /*    5526 */     // GIR_Coverage, 65634,
     /*    5526 */     GIR_EraseRootFromParent_Done,
     /*    5527 */   // Label 214: @5527
     /*    5527 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5622), // Rule ID 65638 //
     /*    5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5588 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5599 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5609 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5620 */     GIR_RootConstrainSelectedInstOperands,
     /*    5621 */     // GIR_Coverage, 65638,
     /*    5621 */     GIR_EraseRootFromParent_Done,
     /*    5622 */   // Label 215: @5622
     /*    5622 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5717), // Rule ID 74478 //
     /*    5627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5634 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    5638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5642 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    5646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5683 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5704 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5715 */     GIR_RootConstrainSelectedInstOperands,
     /*    5716 */     // GIR_Coverage, 74478,
     /*    5716 */     GIR_EraseRootFromParent_Done,
     /*    5717 */   // Label 216: @5717
     /*    5717 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5812), // Rule ID 74482 //
     /*    5722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    5733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    5741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5778 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5799 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5810 */     GIR_RootConstrainSelectedInstOperands,
     /*    5811 */     // GIR_Coverage, 74482,
     /*    5811 */     GIR_EraseRootFromParent_Done,
     /*    5812 */   // Label 217: @5812
     /*    5812 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5907), // Rule ID 74486 //
     /*    5817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5824 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    5828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5832 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    5836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5873 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5894 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5905 */     GIR_RootConstrainSelectedInstOperands,
     /*    5906 */     // GIR_Coverage, 74486,
     /*    5906 */     GIR_EraseRootFromParent_Done,
     /*    5907 */   // Label 218: @5907
     /*    5907 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5955), // Rule ID 2571 //
     /*    5912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5919 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5923 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5942 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5953 */     GIR_RootConstrainSelectedInstOperands,
     /*    5954 */     // GIR_Coverage, 2571,
     /*    5954 */     GIR_EraseRootFromParent_Done,
     /*    5955 */   // Label 219: @5955
     /*    5955 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6003), // Rule ID 2581 //
     /*    5960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5967 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5971 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5990 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6001 */     GIR_RootConstrainSelectedInstOperands,
     /*    6002 */     // GIR_Coverage, 2581,
     /*    6002 */     GIR_EraseRootFromParent_Done,
     /*    6003 */   // Label 220: @6003
     /*    6003 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6051), // Rule ID 2591 //
     /*    6008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6015 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    6019 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    6023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6038 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6049 */     GIR_RootConstrainSelectedInstOperands,
     /*    6050 */     // GIR_Coverage, 2591,
     /*    6050 */     GIR_EraseRootFromParent_Done,
     /*    6051 */   // Label 221: @6051
     /*    6051 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6099), // Rule ID 2610 //
     /*    6056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6063 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    6067 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    6071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6086 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6097 */     GIR_RootConstrainSelectedInstOperands,
     /*    6098 */     // GIR_Coverage, 2610,
     /*    6098 */     GIR_EraseRootFromParent_Done,
     /*    6099 */   // Label 222: @6099
     /*    6099 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6147), // Rule ID 2629 //
     /*    6104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6111 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    6115 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    6119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6134 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6145 */     GIR_RootConstrainSelectedInstOperands,
     /*    6146 */     // GIR_Coverage, 2629,
     /*    6146 */     GIR_EraseRootFromParent_Done,
     /*    6147 */   // Label 223: @6147
     /*    6147 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6195), // Rule ID 2634 //
     /*    6152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6159 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    6163 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    6167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6182 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6193 */     GIR_RootConstrainSelectedInstOperands,
     /*    6194 */     // GIR_Coverage, 2634,
     /*    6194 */     GIR_EraseRootFromParent_Done,
     /*    6195 */   // Label 224: @6195
     /*    6195 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6246), // Rule ID 62537 //
     /*    6200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6207 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    6211 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    6215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6230 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6244 */     GIR_RootConstrainSelectedInstOperands,
     /*    6245 */     // GIR_Coverage, 62537,
     /*    6245 */     GIR_EraseRootFromParent_Done,
     /*    6246 */   // Label 225: @6246
     /*    6246 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6297), // Rule ID 62541 //
     /*    6251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6258 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    6262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    6266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6281 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6295 */     GIR_RootConstrainSelectedInstOperands,
     /*    6296 */     // GIR_Coverage, 62541,
     /*    6296 */     GIR_EraseRootFromParent_Done,
     /*    6297 */   // Label 226: @6297
     /*    6297 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6348), // Rule ID 62545 //
     /*    6302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6309 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    6313 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    6317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6332 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6346 */     GIR_RootConstrainSelectedInstOperands,
     /*    6347 */     // GIR_Coverage, 62545,
     /*    6347 */     GIR_EraseRootFromParent_Done,
     /*    6348 */   // Label 227: @6348
     /*    6348 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6396), // Rule ID 65116 //
     /*    6353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6360 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    6364 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    6368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6383 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6394 */     GIR_RootConstrainSelectedInstOperands,
     /*    6395 */     // GIR_Coverage, 65116,
     /*    6395 */     GIR_EraseRootFromParent_Done,
     /*    6396 */   // Label 228: @6396
     /*    6396 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6444), // Rule ID 65126 //
     /*    6401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6408 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    6412 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    6416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6431 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6442 */     GIR_RootConstrainSelectedInstOperands,
     /*    6443 */     // GIR_Coverage, 65126,
     /*    6443 */     GIR_EraseRootFromParent_Done,
     /*    6444 */   // Label 229: @6444
     /*    6444 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6492), // Rule ID 65136 //
     /*    6449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6456 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    6460 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    6464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6479 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6490 */     GIR_RootConstrainSelectedInstOperands,
     /*    6491 */     // GIR_Coverage, 65136,
     /*    6491 */     GIR_EraseRootFromParent_Done,
     /*    6492 */   // Label 230: @6492
     /*    6492 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6540), // Rule ID 65155 //
     /*    6497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6504 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    6508 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    6512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6527 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6538 */     GIR_RootConstrainSelectedInstOperands,
     /*    6539 */     // GIR_Coverage, 65155,
     /*    6539 */     GIR_EraseRootFromParent_Done,
     /*    6540 */   // Label 231: @6540
     /*    6540 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6588), // Rule ID 65160 //
     /*    6545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6552 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    6556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    6560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6575 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6586 */     GIR_RootConstrainSelectedInstOperands,
     /*    6587 */     // GIR_Coverage, 65160,
     /*    6587 */     GIR_EraseRootFromParent_Done,
     /*    6588 */   // Label 232: @6588
     /*    6588 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6636), // Rule ID 65165 //
     /*    6593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6600 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    6604 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    6608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6623 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6634 */     GIR_RootConstrainSelectedInstOperands,
     /*    6635 */     // GIR_Coverage, 65165,
     /*    6635 */     GIR_EraseRootFromParent_Done,
     /*    6636 */   // Label 233: @6636
     /*    6636 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6684), // Rule ID 65595 //
     /*    6641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6648 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6656 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6671 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6682 */     GIR_RootConstrainSelectedInstOperands,
     /*    6683 */     // GIR_Coverage, 65595,
     /*    6683 */     GIR_EraseRootFromParent_Done,
     /*    6684 */   // Label 234: @6684
     /*    6684 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6732), // Rule ID 65603 //
     /*    6689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6696 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6719 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6730 */     GIR_RootConstrainSelectedInstOperands,
     /*    6731 */     // GIR_Coverage, 65603,
     /*    6731 */     GIR_EraseRootFromParent_Done,
     /*    6732 */   // Label 235: @6732
     /*    6732 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6780), // Rule ID 65611 //
     /*    6737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6744 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6752 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6767 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6778 */     GIR_RootConstrainSelectedInstOperands,
     /*    6779 */     // GIR_Coverage, 65611,
     /*    6779 */     GIR_EraseRootFromParent_Done,
     /*    6780 */   // Label 236: @6780
     /*    6780 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6828), // Rule ID 65620 //
     /*    6785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6792 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6800 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6815 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6826 */     GIR_RootConstrainSelectedInstOperands,
     /*    6827 */     // GIR_Coverage, 65620,
     /*    6827 */     GIR_EraseRootFromParent_Done,
     /*    6828 */   // Label 237: @6828
     /*    6828 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6876), // Rule ID 65636 //
     /*    6833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6840 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6848 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6863 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6874 */     GIR_RootConstrainSelectedInstOperands,
     /*    6875 */     // GIR_Coverage, 65636,
     /*    6875 */     GIR_EraseRootFromParent_Done,
     /*    6876 */   // Label 238: @6876
     /*    6876 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6924), // Rule ID 65640 //
     /*    6881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6888 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6896 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6911 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6922 */     GIR_RootConstrainSelectedInstOperands,
     /*    6923 */     // GIR_Coverage, 65640,
     /*    6923 */     GIR_EraseRootFromParent_Done,
     /*    6924 */   // Label 239: @6924
     /*    6924 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6975), // Rule ID 74429 //
     /*    6929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6944 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6959 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6973 */     GIR_RootConstrainSelectedInstOperands,
     /*    6974 */     // GIR_Coverage, 74429,
     /*    6974 */     GIR_EraseRootFromParent_Done,
     /*    6975 */   // Label 240: @6975
     /*    6975 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7026), // Rule ID 74433 //
     /*    6980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6987 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6995 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    6999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    7010 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    7010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    7013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    7021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    7024 */     GIR_RootConstrainSelectedInstOperands,
     /*    7025 */     // GIR_Coverage, 74433,
     /*    7025 */     GIR_EraseRootFromParent_Done,
     /*    7026 */   // Label 241: @7026
     /*    7026 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(7077), // Rule ID 74437 //
     /*    7031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    7034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7038 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    7042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7046 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    7050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    7061 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    7061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    7064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    7072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7075 */     GIR_RootConstrainSelectedInstOperands,
     /*    7076 */     // GIR_Coverage, 74437,
     /*    7076 */     GIR_EraseRootFromParent_Done,
     /*    7077 */   // Label 242: @7077
     /*    7077 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(7125), // Rule ID 74455 //
     /*    7082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    7093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    7101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    7112 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, sh1add_op:{ *:[i64] }:$rs1:$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    7115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7123 */     GIR_RootConstrainSelectedInstOperands,
     /*    7124 */     // GIR_Coverage, 74455,
     /*    7124 */     GIR_EraseRootFromParent_Done,
     /*    7125 */   // Label 243: @7125
     /*    7125 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7173), // Rule ID 74463 //
     /*    7130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7137 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    7141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7145 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    7149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    7160 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, sh2add_op:{ *:[i64] }:$rs1:$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    7163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7171 */     GIR_RootConstrainSelectedInstOperands,
     /*    7172 */     // GIR_Coverage, 74463,
     /*    7172 */     GIR_EraseRootFromParent_Done,
     /*    7173 */   // Label 244: @7173
     /*    7173 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7221), // Rule ID 74471 //
     /*    7178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    7181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7185 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    7189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7193 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    7197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    7208 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, sh3add_op:{ *:[i64] }:$rs1:$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    7211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7219 */     GIR_RootConstrainSelectedInstOperands,
     /*    7220 */     // GIR_Coverage, 74471,
     /*    7220 */     GIR_EraseRootFromParent_Done,
     /*    7221 */   // Label 245: @7221
     /*    7221 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7269), // Rule ID 74480 //
     /*    7226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7233 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    7237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7241 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    7245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    7256 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7267 */     GIR_RootConstrainSelectedInstOperands,
     /*    7268 */     // GIR_Coverage, 74480,
     /*    7268 */     GIR_EraseRootFromParent_Done,
     /*    7269 */   // Label 246: @7269
     /*    7269 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7317), // Rule ID 74484 //
     /*    7274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7281 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    7285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7289 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    7293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    7304 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7315 */     GIR_RootConstrainSelectedInstOperands,
     /*    7316 */     // GIR_Coverage, 74484,
     /*    7316 */     GIR_EraseRootFromParent_Done,
     /*    7317 */   // Label 247: @7317
     /*    7317 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7365), // Rule ID 74488 //
     /*    7322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7329 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    7333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7337 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    7341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    7352 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    7355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    7361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7363 */     GIR_RootConstrainSelectedInstOperands,
     /*    7364 */     // GIR_Coverage, 74488,
     /*    7364 */     GIR_EraseRootFromParent_Done,
     /*    7365 */   // Label 248: @7365
     /*    7365 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7440), // Rule ID 2602 //
     /*    7370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7377 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    7381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7402 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7413 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    7417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7427 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    7430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7438 */     GIR_RootConstrainSelectedInstOperands,
     /*    7439 */     // GIR_Coverage, 2602,
     /*    7439 */     GIR_EraseRootFromParent_Done,
     /*    7440 */   // Label 249: @7440
     /*    7440 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7535), // Rule ID 2614 //
     /*    7445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    7456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7477 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7488 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7502 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7533 */     GIR_RootConstrainSelectedInstOperands,
     /*    7534 */     // GIR_Coverage, 2614,
     /*    7534 */     GIR_EraseRootFromParent_Done,
     /*    7535 */   // Label 250: @7535
     /*    7535 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7630), // Rule ID 2618 //
     /*    7540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7572 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7583 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7597 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7628 */     GIR_RootConstrainSelectedInstOperands,
     /*    7629 */     // GIR_Coverage, 2618,
     /*    7629 */     GIR_EraseRootFromParent_Done,
     /*    7630 */   // Label 251: @7630
     /*    7630 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7725), // Rule ID 2620 //
     /*    7635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7642 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7667 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7678 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7692 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7723 */     GIR_RootConstrainSelectedInstOperands,
     /*    7724 */     // GIR_Coverage, 2620,
     /*    7724 */     GIR_EraseRootFromParent_Done,
     /*    7725 */   // Label 252: @7725
     /*    7725 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7820), // Rule ID 2622 //
     /*    7730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7762 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7773 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7787 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7818 */     GIR_RootConstrainSelectedInstOperands,
     /*    7819 */     // GIR_Coverage, 2622,
     /*    7819 */     GIR_EraseRootFromParent_Done,
     /*    7820 */   // Label 253: @7820
     /*    7820 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7915), // Rule ID 2636 //
     /*    7825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7832 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7857 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7868 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7882 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7913 */     GIR_RootConstrainSelectedInstOperands,
     /*    7914 */     // GIR_Coverage, 2636,
     /*    7914 */     GIR_EraseRootFromParent_Done,
     /*    7915 */   // Label 254: @7915
     /*    7915 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8010), // Rule ID 2638 //
     /*    7920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7927 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7952 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7963 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7977 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8008 */     GIR_RootConstrainSelectedInstOperands,
     /*    8009 */     // GIR_Coverage, 2638,
     /*    8009 */     GIR_EraseRootFromParent_Done,
     /*    8010 */   // Label 255: @8010
     /*    8010 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8105), // Rule ID 2640 //
     /*    8015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8022 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    8026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8047 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8058 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    8062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8072 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8103 */     GIR_RootConstrainSelectedInstOperands,
     /*    8104 */     // GIR_Coverage, 2640,
     /*    8104 */     GIR_EraseRootFromParent_Done,
     /*    8105 */   // Label 256: @8105
     /*    8105 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8180), // Rule ID 65147 //
     /*    8110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8117 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    8121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8142 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8153 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    8157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8167 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    8170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8178 */     GIR_RootConstrainSelectedInstOperands,
     /*    8179 */     // GIR_Coverage, 65147,
     /*    8179 */     GIR_EraseRootFromParent_Done,
     /*    8180 */   // Label 257: @8180
     /*    8180 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8275), // Rule ID 65169 //
     /*    8185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8192 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    8196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8217 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8228 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    8232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8242 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8273 */     GIR_RootConstrainSelectedInstOperands,
     /*    8274 */     // GIR_Coverage, 65169,
     /*    8274 */     GIR_EraseRootFromParent_Done,
     /*    8275 */   // Label 258: @8275
     /*    8275 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8370), // Rule ID 65173 //
     /*    8280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8287 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    8291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8312 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    8323 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    8327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8337 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8368 */     GIR_RootConstrainSelectedInstOperands,
     /*    8369 */     // GIR_Coverage, 65173,
     /*    8369 */     GIR_EraseRootFromParent_Done,
     /*    8370 */   // Label 259: @8370
     /*    8370 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8465), // Rule ID 65175 //
     /*    8375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8382 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8407 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8418 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8432 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8463 */     GIR_RootConstrainSelectedInstOperands,
     /*    8464 */     // GIR_Coverage, 65175,
     /*    8464 */     GIR_EraseRootFromParent_Done,
     /*    8465 */   // Label 260: @8465
     /*    8465 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8560), // Rule ID 65177 //
     /*    8470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8477 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8502 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8513 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8527 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8558 */     GIR_RootConstrainSelectedInstOperands,
     /*    8559 */     // GIR_Coverage, 65177,
     /*    8559 */     GIR_EraseRootFromParent_Done,
     /*    8560 */   // Label 261: @8560
     /*    8560 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8655), // Rule ID 65179 //
     /*    8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8572 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8597 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8608 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8622 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8653 */     GIR_RootConstrainSelectedInstOperands,
     /*    8654 */     // GIR_Coverage, 65179,
     /*    8654 */     GIR_EraseRootFromParent_Done,
     /*    8655 */   // Label 262: @8655
     /*    8655 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8750), // Rule ID 65181 //
     /*    8660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8667 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8692 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8703 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8717 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8748 */     GIR_RootConstrainSelectedInstOperands,
     /*    8749 */     // GIR_Coverage, 65181,
     /*    8749 */     GIR_EraseRootFromParent_Done,
     /*    8750 */   // Label 263: @8750
     /*    8750 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8845), // Rule ID 65183 //
     /*    8755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8762 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:49:x
     /*    8766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8787 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8798 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:49:y
     /*    8802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8812 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:49:x, GPR:{ *:[i64] }:$rs2:$pred:49:y)<<P:49:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8843 */     GIR_RootConstrainSelectedInstOperands,
     /*    8844 */     // GIR_Coverage, 65183,
     /*    8844 */     GIR_EraseRootFromParent_Done,
     /*    8845 */   // Label 264: @8845
     /*    8845 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8913), // Rule ID 2565 //
     /*    8850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8882 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8886 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8900 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8911 */     GIR_RootConstrainSelectedInstOperands,
     /*    8912 */     // GIR_Coverage, 2565,
     /*    8912 */     GIR_EraseRootFromParent_Done,
     /*    8913 */   // Label 265: @8913
     /*    8913 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8981), // Rule ID 2575 //
     /*    8918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8925 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8954 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8968 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8979 */     GIR_RootConstrainSelectedInstOperands,
     /*    8980 */     // GIR_Coverage, 2575,
     /*    8980 */     GIR_EraseRootFromParent_Done,
     /*    8981 */   // Label 266: @8981
     /*    8981 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9049), // Rule ID 2585 //
     /*    8986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8993 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    8997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9018 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    9022 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    9026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9036 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9047 */     GIR_RootConstrainSelectedInstOperands,
     /*    9048 */     // GIR_Coverage, 2585,
     /*    9048 */     GIR_EraseRootFromParent_Done,
     /*    9049 */   // Label 267: @9049
     /*    9049 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9117), // Rule ID 65110 //
     /*    9054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9061 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    9065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9086 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    9090 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    9094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9104 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    9107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9115 */     GIR_RootConstrainSelectedInstOperands,
     /*    9116 */     // GIR_Coverage, 65110,
     /*    9116 */     GIR_EraseRootFromParent_Done,
     /*    9117 */   // Label 268: @9117
     /*    9117 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9185), // Rule ID 65120 //
     /*    9122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9129 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    9133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9154 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    9158 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    9162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9172 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    9175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9183 */     GIR_RootConstrainSelectedInstOperands,
     /*    9184 */     // GIR_Coverage, 65120,
     /*    9184 */     GIR_EraseRootFromParent_Done,
     /*    9185 */   // Label 269: @9185
     /*    9185 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9253), // Rule ID 65130 //
     /*    9190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    9193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9197 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    9201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    9209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    9226 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    9230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9240 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    9243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9251 */     GIR_RootConstrainSelectedInstOperands,
     /*    9252 */     // GIR_Coverage, 65130,
     /*    9252 */     GIR_EraseRootFromParent_Done,
     /*    9253 */   // Label 270: @9253
     /*    9253 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9328), // Rule ID 65614 //
     /*    9258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9265 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    9269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9273 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    9277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9298 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9315 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    9318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9326 */     GIR_RootConstrainSelectedInstOperands,
     /*    9327 */     // GIR_Coverage, 65614,
     /*    9327 */     GIR_EraseRootFromParent_Done,
     /*    9328 */   // Label 271: @9328
     /*    9328 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9423), // Rule ID 65624 //
     /*    9333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    9344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9348 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    9352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9373 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9390 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    9414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9421 */     GIR_RootConstrainSelectedInstOperands,
     /*    9422 */     // GIR_Coverage, 65624,
     /*    9422 */     GIR_EraseRootFromParent_Done,
     /*    9423 */   // Label 272: @9423
     /*    9423 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9518), // Rule ID 65628 //
     /*    9428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9435 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    9439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9443 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    9447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9468 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9485 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9516 */     GIR_RootConstrainSelectedInstOperands,
     /*    9517 */     // GIR_Coverage, 65628,
     /*    9517 */     GIR_EraseRootFromParent_Done,
     /*    9518 */   // Label 273: @9518
     /*    9518 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9613), // Rule ID 65630 //
     /*    9523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9530 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9563 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9580 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9611 */     GIR_RootConstrainSelectedInstOperands,
     /*    9612 */     // GIR_Coverage, 65630,
     /*    9612 */     GIR_EraseRootFromParent_Done,
     /*    9613 */   // Label 274: @9613
     /*    9613 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9708), // Rule ID 65632 //
     /*    9618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9625 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9658 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9675 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9706 */     GIR_RootConstrainSelectedInstOperands,
     /*    9707 */     // GIR_Coverage, 65632,
     /*    9707 */     GIR_EraseRootFromParent_Done,
     /*    9708 */   // Label 275: @9708
     /*    9708 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9803), // Rule ID 65642 //
     /*    9713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9720 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9728 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9753 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9770 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9801 */     GIR_RootConstrainSelectedInstOperands,
     /*    9802 */     // GIR_Coverage, 65642,
     /*    9802 */     GIR_EraseRootFromParent_Done,
     /*    9803 */   // Label 276: @9803
     /*    9803 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9898), // Rule ID 65644 //
     /*    9808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9848 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9865 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9896 */     GIR_RootConstrainSelectedInstOperands,
     /*    9897 */     // GIR_Coverage, 65644,
     /*    9897 */     GIR_EraseRootFromParent_Done,
     /*    9898 */   // Label 277: @9898
     /*    9898 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(9993), // Rule ID 65646 //
     /*    9903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9910 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9918 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9943 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9960 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9991 */     GIR_RootConstrainSelectedInstOperands,
     /*    9992 */     // GIR_Coverage, 65646,
     /*    9992 */     GIR_EraseRootFromParent_Done,
     /*    9993 */   // Label 278: @9993
     /*    9993 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10068), // Rule ID 74474 //
     /*    9998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10005 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*   10009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10013 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*   10017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10038 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   10049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10055 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*   10058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10066 */     GIR_RootConstrainSelectedInstOperands,
     /*   10067 */     // GIR_Coverage, 74474,
     /*   10067 */     GIR_EraseRootFromParent_Done,
     /*   10068 */   // Label 279: @10068
     /*   10068 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10163), // Rule ID 74492 //
     /*   10073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10080 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*   10084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10088 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*   10092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10113 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*   10124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10130 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10161 */     GIR_RootConstrainSelectedInstOperands,
     /*   10162 */     // GIR_Coverage, 74492,
     /*   10162 */     GIR_EraseRootFromParent_Done,
     /*   10163 */   // Label 280: @10163
     /*   10163 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10258), // Rule ID 74496 //
     /*   10168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10175 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*   10179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10183 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*   10187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10208 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*   10219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10225 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10256 */     GIR_RootConstrainSelectedInstOperands,
     /*   10257 */     // GIR_Coverage, 74496,
     /*   10257 */     GIR_EraseRootFromParent_Done,
     /*   10258 */   // Label 281: @10258
     /*   10258 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10353), // Rule ID 74498 //
     /*   10263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10270 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*   10274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*   10282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10303 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10320 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10351 */     GIR_RootConstrainSelectedInstOperands,
     /*   10352 */     // GIR_Coverage, 74498,
     /*   10352 */     GIR_EraseRootFromParent_Done,
     /*   10353 */   // Label 282: @10353
     /*   10353 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10448), // Rule ID 74500 //
     /*   10358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10365 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*   10369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10373 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10398 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*   10409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10415 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*   10422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10446 */     GIR_RootConstrainSelectedInstOperands,
     /*   10447 */     // GIR_Coverage, 74500,
     /*   10447 */     GIR_EraseRootFromParent_Done,
     /*   10448 */   // Label 283: @10448
     /*   10448 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10543), // Rule ID 74502 //
     /*   10453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10460 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10468 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10493 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10510 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10541 */     GIR_RootConstrainSelectedInstOperands,
     /*   10542 */     // GIR_Coverage, 74502,
     /*   10542 */     GIR_EraseRootFromParent_Done,
     /*   10543 */   // Label 284: @10543
     /*   10543 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10638), // Rule ID 74504 //
     /*   10548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10555 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10563 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10588 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10605 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10636 */     GIR_RootConstrainSelectedInstOperands,
     /*   10637 */     // GIR_Coverage, 74504,
     /*   10637 */     GIR_EraseRootFromParent_Done,
     /*   10638 */   // Label 285: @10638
     /*   10638 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10733), // Rule ID 74506 //
     /*   10643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10650 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:49:y
     /*   10654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10658 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:49:x
     /*   10662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10683 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10700 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:49:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:49:x)<<P:49:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10731 */     GIR_RootConstrainSelectedInstOperands,
     /*   10732 */     // GIR_Coverage, 74506,
     /*   10732 */     GIR_EraseRootFromParent_Done,
     /*   10733 */   // Label 286: @10733
     /*   10733 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10801), // Rule ID 65591 //
     /*   10738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10753 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10778 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10788 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10799 */     GIR_RootConstrainSelectedInstOperands,
     /*   10800 */     // GIR_Coverage, 65591,
     /*   10800 */     GIR_EraseRootFromParent_Done,
     /*   10801 */   // Label 287: @10801
     /*   10801 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10869), // Rule ID 65599 //
     /*   10806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10813 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10821 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10846 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10856 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10867 */     GIR_RootConstrainSelectedInstOperands,
     /*   10868 */     // GIR_Coverage, 65599,
     /*   10868 */     GIR_EraseRootFromParent_Done,
     /*   10869 */   // Label 288: @10869
     /*   10869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10937), // Rule ID 65607 //
     /*   10874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10881 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10889 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10914 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10924 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10935 */     GIR_RootConstrainSelectedInstOperands,
     /*   10936 */     // GIR_Coverage, 65607,
     /*   10936 */     GIR_EraseRootFromParent_Done,
     /*   10937 */   // Label 289: @10937
     /*   10937 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(11005), // Rule ID 74451 //
     /*   10942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10949 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*   10953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10957 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*   10961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10982 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10992 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   10995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11003 */     GIR_RootConstrainSelectedInstOperands,
     /*   11004 */     // GIR_Coverage, 74451,
     /*   11004 */     GIR_EraseRootFromParent_Done,
     /*   11005 */   // Label 290: @11005
     /*   11005 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11073), // Rule ID 74459 //
     /*   11010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   11013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11017 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*   11021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11025 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*   11029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   11054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11060 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   11063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11071 */     GIR_RootConstrainSelectedInstOperands,
     /*   11072 */     // GIR_Coverage, 74459,
     /*   11072 */     GIR_EraseRootFromParent_Done,
     /*   11073 */   // Label 291: @11073
     /*   11073 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11141), // Rule ID 74467 //
     /*   11078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   11081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11085 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*   11089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*   11097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   11122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11128 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   11131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11139 */     GIR_RootConstrainSelectedInstOperands,
     /*   11140 */     // GIR_Coverage, 74467,
     /*   11140 */     GIR_EraseRootFromParent_Done,
     /*   11141 */   // Label 292: @11141
     /*   11141 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11220), // Rule ID 62531 //
     /*   11146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   11149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11153 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   11157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   11182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   11190 */     // MIs[2] Operand 1
     /*   11190 */     // No operand predicates
     /*   11190 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   11194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11204 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   11204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   11207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   11211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   11215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   11218 */     GIR_RootConstrainSelectedInstOperands,
     /*   11219 */     // GIR_Coverage, 62531,
     /*   11219 */     GIR_EraseRootFromParent_Done,
     /*   11220 */   // Label 293: @11220
     /*   11220 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11299), // Rule ID 74425 //
     /*   11225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   11228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11232 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   11236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11240 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   11244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   11252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   11269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   11277 */     // MIs[2] Operand 1
     /*   11277 */     // No operand predicates
     /*   11277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   11281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11283 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   11283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   11286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   11294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   11297 */     GIR_RootConstrainSelectedInstOperands,
     /*   11298 */     // GIR_Coverage, 74425,
     /*   11298 */     GIR_EraseRootFromParent_Done,
     /*   11299 */   // Label 294: @11299
     /*   11299 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11348), // Rule ID 120 //
     /*   11304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   11319 */     // MIs[1] Operand 1
     /*   11319 */     // No operand predicates
     /*   11319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   11323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11331 */     // MIs[2] Operand 1
     /*   11331 */     // No operand predicates
     /*   11331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   11333 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   11333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11338 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   11343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   11346 */     GIR_RootConstrainSelectedInstOperands,
     /*   11347 */     // GIR_Coverage, 120,
     /*   11347 */     GIR_EraseRootFromParent_Done,
     /*   11348 */   // Label 295: @11348
     /*   11348 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11394), // Rule ID 275 //
     /*   11353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11376 */     // MIs[1] Operand 1
     /*   11376 */     // No operand predicates
     /*   11376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11382 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10082>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11392 */     GIR_RootConstrainSelectedInstOperands,
     /*   11393 */     // GIR_Coverage, 275,
     /*   11393 */     GIR_EraseRootFromParent_Done,
     /*   11394 */   // Label 296: @11394
     /*   11394 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11470), // Rule ID 297 //
     /*   11399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11422 */     // MIs[1] Operand 1
     /*   11422 */     // No operand predicates
     /*   11422 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*   11426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11432 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)<<P:Predicate_anonymous_10082>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   11458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11463 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11468 */     GIR_RootConstrainSelectedInstOperands,
     /*   11469 */     // GIR_Coverage, 297,
     /*   11469 */     GIR_EraseRootFromParent_Done,
     /*   11470 */   // Label 297: @11470
     /*   11470 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11535), // Rule ID 74441 //
     /*   11475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11518 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10082>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11533 */     GIR_RootConstrainSelectedInstOperands,
     /*   11534 */     // GIR_Coverage, 74441,
     /*   11534 */     GIR_EraseRootFromParent_Done,
     /*   11535 */   // Label 298: @11535
     /*   11535 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11600), // Rule ID 62602 //
     /*   11540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11583 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10082>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11598 */     GIR_RootConstrainSelectedInstOperands,
     /*   11599 */     // GIR_Coverage, 62602,
     /*   11599 */     GIR_EraseRootFromParent_Done,
     /*   11600 */   // Label 299: @11600
     /*   11600 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11642), // Rule ID 80 //
     /*   11605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11628 */     // MIs[1] Operand 1
     /*   11628 */     // No operand predicates
     /*   11628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11630 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11640 */     GIR_RootConstrainSelectedInstOperands,
     /*   11641 */     // GIR_Coverage, 80,
     /*   11641 */     GIR_EraseRootFromParent_Done,
     /*   11642 */   // Label 300: @11642
     /*   11642 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11714), // Rule ID 295 //
     /*   11647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11670 */     // MIs[1] Operand 1
     /*   11670 */     // No operand predicates
     /*   11670 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10110),
     /*   11674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11676 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10110>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11692 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11707 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11712 */     GIR_RootConstrainSelectedInstOperands,
     /*   11713 */     // GIR_Coverage, 295,
     /*   11713 */     GIR_EraseRootFromParent_Done,
     /*   11714 */   // Label 301: @11714
     /*   11714 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11775), // Rule ID 74439 //
     /*   11719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11758 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11773 */     GIR_RootConstrainSelectedInstOperands,
     /*   11774 */     // GIR_Coverage, 74439,
     /*   11774 */     GIR_EraseRootFromParent_Done,
     /*   11775 */   // Label 302: @11775
     /*   11775 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11836), // Rule ID 62598 //
     /*   11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11819 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11834 */     GIR_RootConstrainSelectedInstOperands,
     /*   11835 */     // GIR_Coverage, 62598,
     /*   11835 */     GIR_EraseRootFromParent_Done,
     /*   11836 */   // Label 303: @11836
     /*   11836 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11867), // Rule ID 274 //
     /*   11841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10082),
     /*   11860 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10082>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11865 */     GIR_RootConstrainSelectedInstOperands,
     /*   11866 */     // GIR_Coverage, 274,
     /*   11866 */     GIR_Done,
     /*   11867 */   // Label 304: @11867
     /*   11867 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11894), // Rule ID 78 //
     /*   11872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11887 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11892 */     GIR_RootConstrainSelectedInstOperands,
     /*   11893 */     // GIR_Coverage, 78,
     /*   11893 */     GIR_Done,
     /*   11894 */   // Label 305: @11894
     /*   11894 */   GIM_Reject,
     /*   11895 */ // Label 198: @11895
     /*   11895 */ GIM_Reject,
     /*   11896 */ // Label 128: @11896
     /*   11896 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(12290),
     /*   11901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11911 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11979), // Rule ID 69389 //
     /*   11916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11953 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11977 */     GIR_RootConstrainSelectedInstOperands,
     /*   11978 */     // GIR_Coverage, 69389,
     /*   11978 */     GIR_EraseRootFromParent_Done,
     /*   11979 */   // Label 307: @11979
     /*   11979 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(12047), // Rule ID 69390 //
     /*   11984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12003 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12021 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12045 */     GIR_RootConstrainSelectedInstOperands,
     /*   12046 */     // GIR_Coverage, 69390,
     /*   12046 */     GIR_EraseRootFromParent_Done,
     /*   12047 */   // Label 308: @12047
     /*   12047 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12115), // Rule ID 45922 //
     /*   12052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12075 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12089 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   12104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12113 */     GIR_RootConstrainSelectedInstOperands,
     /*   12114 */     // GIR_Coverage, 45922,
     /*   12114 */     GIR_EraseRootFromParent_Done,
     /*   12115 */   // Label 309: @12115
     /*   12115 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12183), // Rule ID 45923 //
     /*   12120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   12143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12157 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   12160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   12172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12181 */     GIR_RootConstrainSelectedInstOperands,
     /*   12182 */     // GIR_Coverage, 45923,
     /*   12182 */     GIR_EraseRootFromParent_Done,
     /*   12183 */   // Label 310: @12183
     /*   12183 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12236), // Rule ID 45750 //
     /*   12188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12199 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   12199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   12202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   12216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12234 */     GIR_RootConstrainSelectedInstOperands,
     /*   12235 */     // GIR_Coverage, 45750,
     /*   12235 */     GIR_EraseRootFromParent_Done,
     /*   12236 */   // Label 311: @12236
     /*   12236 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12289), // Rule ID 45751 //
     /*   12241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12252 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   12252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   12255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   12269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   12276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12287 */     GIR_RootConstrainSelectedInstOperands,
     /*   12288 */     // GIR_Coverage, 45751,
     /*   12288 */     GIR_EraseRootFromParent_Done,
     /*   12289 */   // Label 312: @12289
     /*   12289 */   GIM_Reject,
     /*   12290 */ // Label 306: @12290
     /*   12290 */ GIM_Reject,
     /*   12291 */ // Label 129: @12291
     /*   12291 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(15415),
     /*   12296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12306 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12402), // Rule ID 69303 //
     /*   12311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12359 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12363 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12376 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12400 */     GIR_RootConstrainSelectedInstOperands,
     /*   12401 */     // GIR_Coverage, 69303,
     /*   12401 */     GIR_EraseRootFromParent_Done,
     /*   12402 */   // Label 314: @12402
     /*   12402 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12498), // Rule ID 69304 //
     /*   12407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12472 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12496 */     GIR_RootConstrainSelectedInstOperands,
     /*   12497 */     // GIR_Coverage, 69304,
     /*   12497 */     GIR_EraseRootFromParent_Done,
     /*   12498 */   // Label 315: @12498
     /*   12498 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12594), // Rule ID 71129 //
     /*   12503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12568 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12592 */     GIR_RootConstrainSelectedInstOperands,
     /*   12593 */     // GIR_Coverage, 71129,
     /*   12593 */     GIR_EraseRootFromParent_Done,
     /*   12594 */   // Label 316: @12594
     /*   12594 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12690), // Rule ID 71130 //
     /*   12599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12664 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12688 */     GIR_RootConstrainSelectedInstOperands,
     /*   12689 */     // GIR_Coverage, 71130,
     /*   12689 */     GIR_EraseRootFromParent_Done,
     /*   12690 */   // Label 317: @12690
     /*   12690 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12786), // Rule ID 71131 //
     /*   12695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12747 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12749 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12760 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12784 */     GIR_RootConstrainSelectedInstOperands,
     /*   12785 */     // GIR_Coverage, 71131,
     /*   12785 */     GIR_EraseRootFromParent_Done,
     /*   12786 */   // Label 318: @12786
     /*   12786 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(12882), // Rule ID 71132 //
     /*   12791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12843 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12856 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12880 */     GIR_RootConstrainSelectedInstOperands,
     /*   12881 */     // GIR_Coverage, 71132,
     /*   12881 */     GIR_EraseRootFromParent_Done,
     /*   12882 */   // Label 319: @12882
     /*   12882 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(12978), // Rule ID 71007 //
     /*   12887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12939 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12952 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12976 */     GIR_RootConstrainSelectedInstOperands,
     /*   12977 */     // GIR_Coverage, 71007,
     /*   12977 */     GIR_EraseRootFromParent_Done,
     /*   12978 */   // Label 320: @12978
     /*   12978 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13074), // Rule ID 71008 //
     /*   12983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13035 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13048 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   13055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13072 */     GIR_RootConstrainSelectedInstOperands,
     /*   13073 */     // GIR_Coverage, 71008,
     /*   13073 */     GIR_EraseRootFromParent_Done,
     /*   13074 */   // Label 321: @13074
     /*   13074 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13170), // Rule ID 45834 //
     /*   13079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13102 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13116 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13135 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13137 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13144 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   13147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13168 */     GIR_RootConstrainSelectedInstOperands,
     /*   13169 */     // GIR_Coverage, 45834,
     /*   13169 */     GIR_EraseRootFromParent_Done,
     /*   13170 */   // Label 322: @13170
     /*   13170 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13266), // Rule ID 45835 //
     /*   13175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13212 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13231 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13233 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13240 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   13243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13264 */     GIR_RootConstrainSelectedInstOperands,
     /*   13265 */     // GIR_Coverage, 45835,
     /*   13265 */     GIR_EraseRootFromParent_Done,
     /*   13266 */   // Label 323: @13266
     /*   13266 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13362), // Rule ID 52154 //
     /*   13271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13294 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13323 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13327 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13336 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13360 */     GIR_RootConstrainSelectedInstOperands,
     /*   13361 */     // GIR_Coverage, 52154,
     /*   13361 */     GIR_EraseRootFromParent_Done,
     /*   13362 */   // Label 324: @13362
     /*   13362 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13458), // Rule ID 52155 //
     /*   13367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13390 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13404 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13423 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13432 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13456 */     GIR_RootConstrainSelectedInstOperands,
     /*   13457 */     // GIR_Coverage, 52155,
     /*   13457 */     GIR_EraseRootFromParent_Done,
     /*   13458 */   // Label 325: @13458
     /*   13458 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13554), // Rule ID 71127 //
     /*   13463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13500 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13515 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13519 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13528 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13552 */     GIR_RootConstrainSelectedInstOperands,
     /*   13553 */     // GIR_Coverage, 71127,
     /*   13553 */     GIR_EraseRootFromParent_Done,
     /*   13554 */   // Label 326: @13554
     /*   13554 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13650), // Rule ID 71128 //
     /*   13559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13582 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13611 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13615 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13617 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13624 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13648 */     GIR_RootConstrainSelectedInstOperands,
     /*   13649 */     // GIR_Coverage, 71128,
     /*   13649 */     GIR_EraseRootFromParent_Done,
     /*   13650 */   // Label 327: @13650
     /*   13650 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13746), // Rule ID 52094 //
     /*   13655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13692 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13711 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13713 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13720 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13744 */     GIR_RootConstrainSelectedInstOperands,
     /*   13745 */     // GIR_Coverage, 52094,
     /*   13745 */     GIR_EraseRootFromParent_Done,
     /*   13746 */   // Label 328: @13746
     /*   13746 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13842), // Rule ID 52095 //
     /*   13751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13788 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13807 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13816 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13840 */     GIR_RootConstrainSelectedInstOperands,
     /*   13841 */     // GIR_Coverage, 52095,
     /*   13841 */     GIR_EraseRootFromParent_Done,
     /*   13842 */   // Label 329: @13842
     /*   13842 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13931), // Rule ID 46680 //
     /*   13847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13881 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13890 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13929 */     GIR_RootConstrainSelectedInstOperands,
     /*   13930 */     // GIR_Coverage, 46680,
     /*   13930 */     GIR_EraseRootFromParent_Done,
     /*   13931 */   // Label 330: @13931
     /*   13931 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14020), // Rule ID 46681 //
     /*   13936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13970 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13979 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14018 */     GIR_RootConstrainSelectedInstOperands,
     /*   14019 */     // GIR_Coverage, 46681,
     /*   14019 */     GIR_EraseRootFromParent_Done,
     /*   14020 */   // Label 331: @14020
     /*   14020 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14109), // Rule ID 45826 //
     /*   14025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14059 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14068 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   14085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14107 */     GIR_RootConstrainSelectedInstOperands,
     /*   14108 */     // GIR_Coverage, 45826,
     /*   14108 */     GIR_EraseRootFromParent_Done,
     /*   14109 */   // Label 332: @14109
     /*   14109 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14198), // Rule ID 45827 //
     /*   14114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14157 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   14174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14196 */     GIR_RootConstrainSelectedInstOperands,
     /*   14197 */     // GIR_Coverage, 45827,
     /*   14197 */     GIR_EraseRootFromParent_Done,
     /*   14198 */   // Label 333: @14198
     /*   14198 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14287), // Rule ID 46560 //
     /*   14203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14237 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14246 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   14246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   14263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14285 */     GIR_RootConstrainSelectedInstOperands,
     /*   14286 */     // GIR_Coverage, 46560,
     /*   14286 */     GIR_EraseRootFromParent_Done,
     /*   14287 */   // Label 334: @14287
     /*   14287 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14376), // Rule ID 46561 //
     /*   14292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   14318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14326 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   14335 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   14335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   14352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   14361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14374 */     GIR_RootConstrainSelectedInstOperands,
     /*   14375 */     // GIR_Coverage, 46561,
     /*   14375 */     GIR_EraseRootFromParent_Done,
     /*   14376 */   // Label 335: @14376
     /*   14376 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14444), // Rule ID 70699 //
     /*   14381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14418 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14442 */     GIR_RootConstrainSelectedInstOperands,
     /*   14443 */     // GIR_Coverage, 70699,
     /*   14443 */     GIR_EraseRootFromParent_Done,
     /*   14444 */   // Label 336: @14444
     /*   14444 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14512), // Rule ID 70700 //
     /*   14449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14486 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14510 */     GIR_RootConstrainSelectedInstOperands,
     /*   14511 */     // GIR_Coverage, 70700,
     /*   14511 */     GIR_EraseRootFromParent_Done,
     /*   14512 */   // Label 337: @14512
     /*   14512 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14567), // Rule ID 69691 //
     /*   14517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14545 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14565 */     GIR_RootConstrainSelectedInstOperands,
     /*   14566 */     // GIR_Coverage, 69691,
     /*   14566 */     GIR_EraseRootFromParent_Done,
     /*   14567 */   // Label 338: @14567
     /*   14567 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14622), // Rule ID 69692 //
     /*   14572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14600 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14620 */     GIR_RootConstrainSelectedInstOperands,
     /*   14621 */     // GIR_Coverage, 69692,
     /*   14621 */     GIR_EraseRootFromParent_Done,
     /*   14622 */   // Label 339: @14622
     /*   14622 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14677), // Rule ID 69299 //
     /*   14627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14655 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14675 */     GIR_RootConstrainSelectedInstOperands,
     /*   14676 */     // GIR_Coverage, 69299,
     /*   14676 */     GIR_EraseRootFromParent_Done,
     /*   14677 */   // Label 340: @14677
     /*   14677 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14732), // Rule ID 69300 //
     /*   14682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14710 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14730 */     GIR_RootConstrainSelectedInstOperands,
     /*   14731 */     // GIR_Coverage, 69300,
     /*   14731 */     GIR_EraseRootFromParent_Done,
     /*   14732 */   // Label 341: @14732
     /*   14732 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14787), // Rule ID 69601 //
     /*   14737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14765 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14785 */     GIR_RootConstrainSelectedInstOperands,
     /*   14786 */     // GIR_Coverage, 69601,
     /*   14786 */     GIR_EraseRootFromParent_Done,
     /*   14787 */   // Label 342: @14787
     /*   14787 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14842), // Rule ID 69602 //
     /*   14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14820 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14840 */     GIR_RootConstrainSelectedInstOperands,
     /*   14841 */     // GIR_Coverage, 69602,
     /*   14841 */     GIR_EraseRootFromParent_Done,
     /*   14842 */   // Label 343: @14842
     /*   14842 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14910), // Rule ID 51874 //
     /*   14847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14870 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14884 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14908 */     GIR_RootConstrainSelectedInstOperands,
     /*   14909 */     // GIR_Coverage, 51874,
     /*   14909 */     GIR_EraseRootFromParent_Done,
     /*   14910 */   // Label 344: @14910
     /*   14910 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14978), // Rule ID 51875 //
     /*   14915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14938 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14952 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14976 */     GIR_RootConstrainSelectedInstOperands,
     /*   14977 */     // GIR_Coverage, 51875,
     /*   14977 */     GIR_EraseRootFromParent_Done,
     /*   14978 */   // Label 345: @14978
     /*   14978 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(15033), // Rule ID 46740 //
     /*   14983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15011 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15031 */     GIR_RootConstrainSelectedInstOperands,
     /*   15032 */     // GIR_Coverage, 46740,
     /*   15032 */     GIR_EraseRootFromParent_Done,
     /*   15033 */   // Label 346: @15033
     /*   15033 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(15088), // Rule ID 46741 //
     /*   15038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15066 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15086 */     GIR_RootConstrainSelectedInstOperands,
     /*   15087 */     // GIR_Coverage, 46741,
     /*   15087 */     GIR_EraseRootFromParent_Done,
     /*   15088 */   // Label 347: @15088
     /*   15088 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15143), // Rule ID 45830 //
     /*   15093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15121 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   15124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15141 */     GIR_RootConstrainSelectedInstOperands,
     /*   15142 */     // GIR_Coverage, 45830,
     /*   15142 */     GIR_EraseRootFromParent_Done,
     /*   15143 */   // Label 348: @15143
     /*   15143 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15198), // Rule ID 45831 //
     /*   15148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15176 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   15179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15196 */     GIR_RootConstrainSelectedInstOperands,
     /*   15197 */     // GIR_Coverage, 45831,
     /*   15197 */     GIR_EraseRootFromParent_Done,
     /*   15198 */   // Label 349: @15198
     /*   15198 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15253), // Rule ID 46620 //
     /*   15203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15231 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   15231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15251 */     GIR_RootConstrainSelectedInstOperands,
     /*   15252 */     // GIR_Coverage, 46620,
     /*   15252 */     GIR_EraseRootFromParent_Done,
     /*   15253 */   // Label 350: @15253
     /*   15253 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15308), // Rule ID 46621 //
     /*   15258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   15277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   15286 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   15286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   15289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   15293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   15297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15306 */     GIR_RootConstrainSelectedInstOperands,
     /*   15307 */     // GIR_Coverage, 46621,
     /*   15307 */     GIR_EraseRootFromParent_Done,
     /*   15308 */   // Label 351: @15308
     /*   15308 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15361), // Rule ID 46106 //
     /*   15313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15324 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   15324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   15327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   15341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15359 */     GIR_RootConstrainSelectedInstOperands,
     /*   15360 */     // GIR_Coverage, 46106,
     /*   15360 */     GIR_EraseRootFromParent_Done,
     /*   15361 */   // Label 352: @15361
     /*   15361 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15414), // Rule ID 46107 //
     /*   15366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15377 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   15377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   15380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   15394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   15401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   15403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15412 */     GIR_RootConstrainSelectedInstOperands,
     /*   15413 */     // GIR_Coverage, 46107,
     /*   15413 */     GIR_EraseRootFromParent_Done,
     /*   15414 */   // Label 353: @15414
     /*   15414 */   GIM_Reject,
     /*   15415 */ // Label 313: @15415
     /*   15415 */ GIM_Reject,
     /*   15416 */ // Label 130: @15416
     /*   15416 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18540),
     /*   15421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15431 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15527), // Rule ID 70905 //
     /*   15436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15488 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15490 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15501 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15525 */     GIR_RootConstrainSelectedInstOperands,
     /*   15526 */     // GIR_Coverage, 70905,
     /*   15526 */     GIR_EraseRootFromParent_Done,
     /*   15527 */   // Label 355: @15527
     /*   15527 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15623), // Rule ID 70906 //
     /*   15532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15584 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15597 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15621 */     GIR_RootConstrainSelectedInstOperands,
     /*   15622 */     // GIR_Coverage, 70906,
     /*   15622 */     GIR_EraseRootFromParent_Done,
     /*   15623 */   // Label 356: @15623
     /*   15623 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15719), // Rule ID 71165 //
     /*   15628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15680 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15693 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15717 */     GIR_RootConstrainSelectedInstOperands,
     /*   15718 */     // GIR_Coverage, 71165,
     /*   15718 */     GIR_EraseRootFromParent_Done,
     /*   15719 */   // Label 357: @15719
     /*   15719 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15815), // Rule ID 71166 //
     /*   15724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15776 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15778 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15789 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15813 */     GIR_RootConstrainSelectedInstOperands,
     /*   15814 */     // GIR_Coverage, 71166,
     /*   15814 */     GIR_EraseRootFromParent_Done,
     /*   15815 */   // Label 358: @15815
     /*   15815 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(15911), // Rule ID 71167 //
     /*   15820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15853 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15868 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15872 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15874 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15885 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15909 */     GIR_RootConstrainSelectedInstOperands,
     /*   15910 */     // GIR_Coverage, 71167,
     /*   15910 */     GIR_EraseRootFromParent_Done,
     /*   15911 */   // Label 359: @15911
     /*   15911 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16007), // Rule ID 71168 //
     /*   15916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15968 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15970 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15981 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16005 */     GIR_RootConstrainSelectedInstOperands,
     /*   16006 */     // GIR_Coverage, 71168,
     /*   16006 */     GIR_EraseRootFromParent_Done,
     /*   16007 */   // Label 360: @16007
     /*   16007 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16103), // Rule ID 71019 //
     /*   16012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16045 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16064 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16077 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   16084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16101 */     GIR_RootConstrainSelectedInstOperands,
     /*   16102 */     // GIR_Coverage, 71019,
     /*   16102 */     GIR_EraseRootFromParent_Done,
     /*   16103 */   // Label 361: @16103
     /*   16103 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16199), // Rule ID 71020 //
     /*   16108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16141 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16160 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16162 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16173 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   16180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16197 */     GIR_RootConstrainSelectedInstOperands,
     /*   16198 */     // GIR_Coverage, 71020,
     /*   16198 */     GIR_EraseRootFromParent_Done,
     /*   16199 */   // Label 362: @16199
     /*   16199 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16295), // Rule ID 52048 //
     /*   16204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16227 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16260 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16262 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16269 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   16272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16293 */     GIR_RootConstrainSelectedInstOperands,
     /*   16294 */     // GIR_Coverage, 52048,
     /*   16294 */     GIR_EraseRootFromParent_Done,
     /*   16295 */   // Label 363: @16295
     /*   16295 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16391), // Rule ID 52049 //
     /*   16300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16356 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16358 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16365 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   16368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16389 */     GIR_RootConstrainSelectedInstOperands,
     /*   16390 */     // GIR_Coverage, 52049,
     /*   16390 */     GIR_EraseRootFromParent_Done,
     /*   16391 */   // Label 364: @16391
     /*   16391 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16487), // Rule ID 52166 //
     /*   16396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16419 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16452 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16454 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16461 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16485 */     GIR_RootConstrainSelectedInstOperands,
     /*   16486 */     // GIR_Coverage, 52166,
     /*   16486 */     GIR_EraseRootFromParent_Done,
     /*   16487 */   // Label 365: @16487
     /*   16487 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16583), // Rule ID 52167 //
     /*   16492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16515 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16548 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16550 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16557 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16581 */     GIR_RootConstrainSelectedInstOperands,
     /*   16582 */     // GIR_Coverage, 52167,
     /*   16582 */     GIR_EraseRootFromParent_Done,
     /*   16583 */   // Label 366: @16583
     /*   16583 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16679), // Rule ID 71163 //
     /*   16588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16644 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16653 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16677 */     GIR_RootConstrainSelectedInstOperands,
     /*   16678 */     // GIR_Coverage, 71163,
     /*   16678 */     GIR_EraseRootFromParent_Done,
     /*   16679 */   // Label 367: @16679
     /*   16679 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16775), // Rule ID 71164 //
     /*   16684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16707 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16740 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16749 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16773 */     GIR_RootConstrainSelectedInstOperands,
     /*   16774 */     // GIR_Coverage, 71164,
     /*   16774 */     GIR_EraseRootFromParent_Done,
     /*   16775 */   // Label 368: @16775
     /*   16775 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16871), // Rule ID 52106 //
     /*   16780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16803 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16836 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16838 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16845 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16869 */     GIR_RootConstrainSelectedInstOperands,
     /*   16870 */     // GIR_Coverage, 52106,
     /*   16870 */     GIR_EraseRootFromParent_Done,
     /*   16871 */   // Label 369: @16871
     /*   16871 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(16967), // Rule ID 52107 //
     /*   16876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16913 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16932 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16941 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16965 */     GIR_RootConstrainSelectedInstOperands,
     /*   16966 */     // GIR_Coverage, 52107,
     /*   16966 */     GIR_EraseRootFromParent_Done,
     /*   16967 */   // Label 370: @16967
     /*   16967 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17056), // Rule ID 46704 //
     /*   16972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17015 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17054 */     GIR_RootConstrainSelectedInstOperands,
     /*   17055 */     // GIR_Coverage, 46704,
     /*   17055 */     GIR_EraseRootFromParent_Done,
     /*   17056 */   // Label 371: @17056
     /*   17056 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 46705 //
     /*   17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17104 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17143 */     GIR_RootConstrainSelectedInstOperands,
     /*   17144 */     // GIR_Coverage, 46705,
     /*   17144 */     GIR_EraseRootFromParent_Done,
     /*   17145 */   // Label 372: @17145
     /*   17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17234), // Rule ID 46468 //
     /*   17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17193 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   17210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17232 */     GIR_RootConstrainSelectedInstOperands,
     /*   17233 */     // GIR_Coverage, 46468,
     /*   17233 */     GIR_EraseRootFromParent_Done,
     /*   17234 */   // Label 373: @17234
     /*   17234 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17323), // Rule ID 46469 //
     /*   17239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17282 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   17299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17321 */     GIR_RootConstrainSelectedInstOperands,
     /*   17322 */     // GIR_Coverage, 46469,
     /*   17322 */     GIR_EraseRootFromParent_Done,
     /*   17323 */   // Label 374: @17323
     /*   17323 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17412), // Rule ID 46584 //
     /*   17328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17371 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   17371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17410 */     GIR_RootConstrainSelectedInstOperands,
     /*   17411 */     // GIR_Coverage, 46584,
     /*   17411 */     GIR_EraseRootFromParent_Done,
     /*   17412 */   // Label 375: @17412
     /*   17412 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17501), // Rule ID 46585 //
     /*   17417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   17443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   17460 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   17460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17499 */     GIR_RootConstrainSelectedInstOperands,
     /*   17500 */     // GIR_Coverage, 46585,
     /*   17500 */     GIR_EraseRootFromParent_Done,
     /*   17501 */   // Label 376: @17501
     /*   17501 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17569), // Rule ID 70715 //
     /*   17506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17525 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17543 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17567 */     GIR_RootConstrainSelectedInstOperands,
     /*   17568 */     // GIR_Coverage, 70715,
     /*   17568 */     GIR_EraseRootFromParent_Done,
     /*   17569 */   // Label 377: @17569
     /*   17569 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17637), // Rule ID 70716 //
     /*   17574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17593 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17611 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17635 */     GIR_RootConstrainSelectedInstOperands,
     /*   17636 */     // GIR_Coverage, 70716,
     /*   17636 */     GIR_EraseRootFromParent_Done,
     /*   17637 */   // Label 378: @17637
     /*   17637 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17692), // Rule ID 69715 //
     /*   17642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17670 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17690 */     GIR_RootConstrainSelectedInstOperands,
     /*   17691 */     // GIR_Coverage, 69715,
     /*   17691 */     GIR_EraseRootFromParent_Done,
     /*   17692 */   // Label 379: @17692
     /*   17692 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17747), // Rule ID 69716 //
     /*   17697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17725 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17745 */     GIR_RootConstrainSelectedInstOperands,
     /*   17746 */     // GIR_Coverage, 69716,
     /*   17746 */     GIR_EraseRootFromParent_Done,
     /*   17747 */   // Label 380: @17747
     /*   17747 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17802), // Rule ID 69535 //
     /*   17752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17780 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17800 */     GIR_RootConstrainSelectedInstOperands,
     /*   17801 */     // GIR_Coverage, 69535,
     /*   17801 */     GIR_EraseRootFromParent_Done,
     /*   17802 */   // Label 381: @17802
     /*   17802 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17857), // Rule ID 69536 //
     /*   17807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17835 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17855 */     GIR_RootConstrainSelectedInstOperands,
     /*   17856 */     // GIR_Coverage, 69536,
     /*   17856 */     GIR_EraseRootFromParent_Done,
     /*   17857 */   // Label 382: @17857
     /*   17857 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17912), // Rule ID 69625 //
     /*   17862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17890 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17910 */     GIR_RootConstrainSelectedInstOperands,
     /*   17911 */     // GIR_Coverage, 69625,
     /*   17911 */     GIR_EraseRootFromParent_Done,
     /*   17912 */   // Label 383: @17912
     /*   17912 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17967), // Rule ID 69626 //
     /*   17917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17945 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17965 */     GIR_RootConstrainSelectedInstOperands,
     /*   17966 */     // GIR_Coverage, 69626,
     /*   17966 */     GIR_EraseRootFromParent_Done,
     /*   17967 */   // Label 384: @17967
     /*   17967 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(18035), // Rule ID 51882 //
     /*   17972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18009 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   18012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   18018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18033 */     GIR_RootConstrainSelectedInstOperands,
     /*   18034 */     // GIR_Coverage, 51882,
     /*   18034 */     GIR_EraseRootFromParent_Done,
     /*   18035 */   // Label 385: @18035
     /*   18035 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(18103), // Rule ID 51883 //
     /*   18040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   18063 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18077 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   18080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   18086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18101 */     GIR_RootConstrainSelectedInstOperands,
     /*   18102 */     // GIR_Coverage, 51883,
     /*   18102 */     GIR_EraseRootFromParent_Done,
     /*   18103 */   // Label 386: @18103
     /*   18103 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18158), // Rule ID 46764 //
     /*   18108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   18123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18136 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18156 */     GIR_RootConstrainSelectedInstOperands,
     /*   18157 */     // GIR_Coverage, 46764,
     /*   18157 */     GIR_EraseRootFromParent_Done,
     /*   18158 */   // Label 387: @18158
     /*   18158 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18213), // Rule ID 46765 //
     /*   18163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   18178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18191 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18211 */     GIR_RootConstrainSelectedInstOperands,
     /*   18212 */     // GIR_Coverage, 46765,
     /*   18212 */     GIR_EraseRootFromParent_Done,
     /*   18213 */   // Label 388: @18213
     /*   18213 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18268), // Rule ID 46524 //
     /*   18218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18246 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   18249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18266 */     GIR_RootConstrainSelectedInstOperands,
     /*   18267 */     // GIR_Coverage, 46524,
     /*   18267 */     GIR_EraseRootFromParent_Done,
     /*   18268 */   // Label 389: @18268
     /*   18268 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18323), // Rule ID 46525 //
     /*   18273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18301 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   18304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18321 */     GIR_RootConstrainSelectedInstOperands,
     /*   18322 */     // GIR_Coverage, 46525,
     /*   18322 */     GIR_EraseRootFromParent_Done,
     /*   18323 */   // Label 390: @18323
     /*   18323 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18378), // Rule ID 46644 //
     /*   18328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18356 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   18356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18376 */     GIR_RootConstrainSelectedInstOperands,
     /*   18377 */     // GIR_Coverage, 46644,
     /*   18377 */     GIR_EraseRootFromParent_Done,
     /*   18378 */   // Label 391: @18378
     /*   18378 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18433), // Rule ID 46645 //
     /*   18383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   18402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   18411 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   18411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   18414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   18418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   18428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18431 */     GIR_RootConstrainSelectedInstOperands,
     /*   18432 */     // GIR_Coverage, 46645,
     /*   18432 */     GIR_EraseRootFromParent_Done,
     /*   18433 */   // Label 392: @18433
     /*   18433 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18486), // Rule ID 46114 //
     /*   18438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18449 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   18449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18484 */     GIR_RootConstrainSelectedInstOperands,
     /*   18485 */     // GIR_Coverage, 46114,
     /*   18485 */     GIR_EraseRootFromParent_Done,
     /*   18486 */   // Label 393: @18486
     /*   18486 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18539), // Rule ID 46115 //
     /*   18491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18502 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18537 */     GIR_RootConstrainSelectedInstOperands,
     /*   18538 */     // GIR_Coverage, 46115,
     /*   18538 */     GIR_EraseRootFromParent_Done,
     /*   18539 */   // Label 394: @18539
     /*   18539 */   GIM_Reject,
     /*   18540 */ // Label 354: @18540
     /*   18540 */ GIM_Reject,
     /*   18541 */ // Label 131: @18541
     /*   18541 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(21665),
     /*   18546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18556 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18652), // Rule ID 70915 //
     /*   18561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18626 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18650 */     GIR_RootConstrainSelectedInstOperands,
     /*   18651 */     // GIR_Coverage, 70915,
     /*   18651 */     GIR_EraseRootFromParent_Done,
     /*   18652 */   // Label 396: @18652
     /*   18652 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18748), // Rule ID 70916 //
     /*   18657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18722 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18746 */     GIR_RootConstrainSelectedInstOperands,
     /*   18747 */     // GIR_Coverage, 70916,
     /*   18747 */     GIR_EraseRootFromParent_Done,
     /*   18748 */   // Label 397: @18748
     /*   18748 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18844), // Rule ID 71195 //
     /*   18753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18805 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18818 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18842 */     GIR_RootConstrainSelectedInstOperands,
     /*   18843 */     // GIR_Coverage, 71195,
     /*   18843 */     GIR_EraseRootFromParent_Done,
     /*   18844 */   // Label 398: @18844
     /*   18844 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18940), // Rule ID 71196 //
     /*   18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18882 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18901 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18914 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18938 */     GIR_RootConstrainSelectedInstOperands,
     /*   18939 */     // GIR_Coverage, 71196,
     /*   18939 */     GIR_EraseRootFromParent_Done,
     /*   18940 */   // Label 399: @18940
     /*   18940 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19036), // Rule ID 71197 //
     /*   18945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18978 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18993 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18997 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18999 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19010 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19034 */     GIR_RootConstrainSelectedInstOperands,
     /*   19035 */     // GIR_Coverage, 71197,
     /*   19035 */     GIR_EraseRootFromParent_Done,
     /*   19036 */   // Label 400: @19036
     /*   19036 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19132), // Rule ID 71198 //
     /*   19041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19060 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19093 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19095 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19106 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19130 */     GIR_RootConstrainSelectedInstOperands,
     /*   19131 */     // GIR_Coverage, 71198,
     /*   19131 */     GIR_EraseRootFromParent_Done,
     /*   19132 */   // Label 401: @19132
     /*   19132 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19228), // Rule ID 71029 //
     /*   19137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19156 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19170 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19189 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19191 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19202 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19226 */     GIR_RootConstrainSelectedInstOperands,
     /*   19227 */     // GIR_Coverage, 71029,
     /*   19227 */     GIR_EraseRootFromParent_Done,
     /*   19228 */   // Label 402: @19228
     /*   19228 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19324), // Rule ID 71030 //
     /*   19233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19266 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19281 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19285 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19287 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19298 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   19305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19322 */     GIR_RootConstrainSelectedInstOperands,
     /*   19323 */     // GIR_Coverage, 71030,
     /*   19323 */     GIR_EraseRootFromParent_Done,
     /*   19324 */   // Label 403: @19324
     /*   19324 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19420), // Rule ID 52058 //
     /*   19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19352 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19385 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19394 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19418 */     GIR_RootConstrainSelectedInstOperands,
     /*   19419 */     // GIR_Coverage, 52058,
     /*   19419 */     GIR_EraseRootFromParent_Done,
     /*   19420 */   // Label 404: @19420
     /*   19420 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19516), // Rule ID 52059 //
     /*   19425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19481 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19490 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19514 */     GIR_RootConstrainSelectedInstOperands,
     /*   19515 */     // GIR_Coverage, 52059,
     /*   19515 */     GIR_EraseRootFromParent_Done,
     /*   19516 */   // Label 405: @19516
     /*   19516 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19612), // Rule ID 52176 //
     /*   19521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19577 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19586 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19610 */     GIR_RootConstrainSelectedInstOperands,
     /*   19611 */     // GIR_Coverage, 52176,
     /*   19611 */     GIR_EraseRootFromParent_Done,
     /*   19612 */   // Label 406: @19612
     /*   19612 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19708), // Rule ID 52177 //
     /*   19617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19673 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19682 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19706 */     GIR_RootConstrainSelectedInstOperands,
     /*   19707 */     // GIR_Coverage, 52177,
     /*   19707 */     GIR_EraseRootFromParent_Done,
     /*   19708 */   // Label 407: @19708
     /*   19708 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19804), // Rule ID 71193 //
     /*   19713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19769 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19778 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19802 */     GIR_RootConstrainSelectedInstOperands,
     /*   19803 */     // GIR_Coverage, 71193,
     /*   19803 */     GIR_EraseRootFromParent_Done,
     /*   19804 */   // Label 408: @19804
     /*   19804 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19900), // Rule ID 71194 //
     /*   19809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19865 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19874 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19898 */     GIR_RootConstrainSelectedInstOperands,
     /*   19899 */     // GIR_Coverage, 71194,
     /*   19899 */     GIR_EraseRootFromParent_Done,
     /*   19900 */   // Label 409: @19900
     /*   19900 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(19996), // Rule ID 52116 //
     /*   19905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19957 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19961 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19970 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19994 */     GIR_RootConstrainSelectedInstOperands,
     /*   19995 */     // GIR_Coverage, 52116,
     /*   19995 */     GIR_EraseRootFromParent_Done,
     /*   19996 */   // Label 410: @19996
     /*   19996 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20092), // Rule ID 52117 //
     /*   20001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20038 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20057 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20066 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   20069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   20073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20090 */     GIR_RootConstrainSelectedInstOperands,
     /*   20091 */     // GIR_Coverage, 52117,
     /*   20091 */     GIR_EraseRootFromParent_Done,
     /*   20092 */   // Label 411: @20092
     /*   20092 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20181), // Rule ID 46724 //
     /*   20097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20131 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20140 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20179 */     GIR_RootConstrainSelectedInstOperands,
     /*   20180 */     // GIR_Coverage, 46724,
     /*   20180 */     GIR_EraseRootFromParent_Done,
     /*   20181 */   // Label 412: @20181
     /*   20181 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20270), // Rule ID 46725 //
     /*   20186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20220 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20229 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20268 */     GIR_RootConstrainSelectedInstOperands,
     /*   20269 */     // GIR_Coverage, 46725,
     /*   20269 */     GIR_EraseRootFromParent_Done,
     /*   20270 */   // Label 413: @20270
     /*   20270 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20359), // Rule ID 46488 //
     /*   20275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20290 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20309 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20318 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   20335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20357 */     GIR_RootConstrainSelectedInstOperands,
     /*   20358 */     // GIR_Coverage, 46488,
     /*   20358 */     GIR_EraseRootFromParent_Done,
     /*   20359 */   // Label 414: @20359
     /*   20359 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20448), // Rule ID 46489 //
     /*   20364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20398 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20407 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   20424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20446 */     GIR_RootConstrainSelectedInstOperands,
     /*   20447 */     // GIR_Coverage, 46489,
     /*   20447 */     GIR_EraseRootFromParent_Done,
     /*   20448 */   // Label 415: @20448
     /*   20448 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20537), // Rule ID 46604 //
     /*   20453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20487 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20496 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20535 */     GIR_RootConstrainSelectedInstOperands,
     /*   20536 */     // GIR_Coverage, 46604,
     /*   20536 */     GIR_EraseRootFromParent_Done,
     /*   20537 */   // Label 416: @20537
     /*   20537 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20626), // Rule ID 46605 //
     /*   20542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20576 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20585 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20624 */     GIR_RootConstrainSelectedInstOperands,
     /*   20625 */     // GIR_Coverage, 46605,
     /*   20625 */     GIR_EraseRootFromParent_Done,
     /*   20626 */   // Label 417: @20626
     /*   20626 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20694), // Rule ID 70747 //
     /*   20631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20650 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20668 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20692 */     GIR_RootConstrainSelectedInstOperands,
     /*   20693 */     // GIR_Coverage, 70747,
     /*   20693 */     GIR_EraseRootFromParent_Done,
     /*   20694 */   // Label 418: @20694
     /*   20694 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20762), // Rule ID 70748 //
     /*   20699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20736 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20760 */     GIR_RootConstrainSelectedInstOperands,
     /*   20761 */     // GIR_Coverage, 70748,
     /*   20761 */     GIR_EraseRootFromParent_Done,
     /*   20762 */   // Label 419: @20762
     /*   20762 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20817), // Rule ID 69735 //
     /*   20767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20795 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20815 */     GIR_RootConstrainSelectedInstOperands,
     /*   20816 */     // GIR_Coverage, 69735,
     /*   20816 */     GIR_EraseRootFromParent_Done,
     /*   20817 */   // Label 420: @20817
     /*   20817 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20872), // Rule ID 69736 //
     /*   20822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20837 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20850 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20870 */     GIR_RootConstrainSelectedInstOperands,
     /*   20871 */     // GIR_Coverage, 69736,
     /*   20871 */     GIR_EraseRootFromParent_Done,
     /*   20872 */   // Label 421: @20872
     /*   20872 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20927), // Rule ID 69555 //
     /*   20877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20905 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20925 */     GIR_RootConstrainSelectedInstOperands,
     /*   20926 */     // GIR_Coverage, 69555,
     /*   20926 */     GIR_EraseRootFromParent_Done,
     /*   20927 */   // Label 422: @20927
     /*   20927 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20982), // Rule ID 69556 //
     /*   20932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20947 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20960 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20980 */     GIR_RootConstrainSelectedInstOperands,
     /*   20981 */     // GIR_Coverage, 69556,
     /*   20981 */     GIR_EraseRootFromParent_Done,
     /*   20982 */   // Label 423: @20982
     /*   20982 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(21037), // Rule ID 69645 //
     /*   20987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21015 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21035 */     GIR_RootConstrainSelectedInstOperands,
     /*   21036 */     // GIR_Coverage, 69645,
     /*   21036 */     GIR_EraseRootFromParent_Done,
     /*   21037 */   // Label 424: @21037
     /*   21037 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(21092), // Rule ID 69646 //
     /*   21042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21070 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21090 */     GIR_RootConstrainSelectedInstOperands,
     /*   21091 */     // GIR_Coverage, 69646,
     /*   21091 */     GIR_EraseRootFromParent_Done,
     /*   21092 */   // Label 425: @21092
     /*   21092 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21160), // Rule ID 51898 //
     /*   21097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   21116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   21120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21134 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   21134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   21137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21158 */     GIR_RootConstrainSelectedInstOperands,
     /*   21159 */     // GIR_Coverage, 51898,
     /*   21159 */     GIR_EraseRootFromParent_Done,
     /*   21160 */   // Label 426: @21160
     /*   21160 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21228), // Rule ID 51899 //
     /*   21165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   21184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   21188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21202 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   21202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   21205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21226 */     GIR_RootConstrainSelectedInstOperands,
     /*   21227 */     // GIR_Coverage, 51899,
     /*   21227 */     GIR_EraseRootFromParent_Done,
     /*   21228 */   // Label 427: @21228
     /*   21228 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21283), // Rule ID 46784 //
     /*   21233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   21248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21261 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21281 */     GIR_RootConstrainSelectedInstOperands,
     /*   21282 */     // GIR_Coverage, 46784,
     /*   21282 */     GIR_EraseRootFromParent_Done,
     /*   21283 */   // Label 428: @21283
     /*   21283 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21338), // Rule ID 46785 //
     /*   21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21316 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21336 */     GIR_RootConstrainSelectedInstOperands,
     /*   21337 */     // GIR_Coverage, 46785,
     /*   21337 */     GIR_EraseRootFromParent_Done,
     /*   21338 */   // Label 429: @21338
     /*   21338 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21393), // Rule ID 46544 //
     /*   21343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21362 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21371 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   21374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21391 */     GIR_RootConstrainSelectedInstOperands,
     /*   21392 */     // GIR_Coverage, 46544,
     /*   21392 */     GIR_EraseRootFromParent_Done,
     /*   21393 */   // Label 430: @21393
     /*   21393 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21448), // Rule ID 46545 //
     /*   21398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21426 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   21429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21446 */     GIR_RootConstrainSelectedInstOperands,
     /*   21447 */     // GIR_Coverage, 46545,
     /*   21447 */     GIR_EraseRootFromParent_Done,
     /*   21448 */   // Label 431: @21448
     /*   21448 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21503), // Rule ID 46664 //
     /*   21453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   21456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21481 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21501 */     GIR_RootConstrainSelectedInstOperands,
     /*   21502 */     // GIR_Coverage, 46664,
     /*   21502 */     GIR_EraseRootFromParent_Done,
     /*   21503 */   // Label 432: @21503
     /*   21503 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21558), // Rule ID 46665 //
     /*   21508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21527 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21536 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21556 */     GIR_RootConstrainSelectedInstOperands,
     /*   21557 */     // GIR_Coverage, 46665,
     /*   21557 */     GIR_EraseRootFromParent_Done,
     /*   21558 */   // Label 433: @21558
     /*   21558 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21611), // Rule ID 46130 //
     /*   21563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21574 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21609 */     GIR_RootConstrainSelectedInstOperands,
     /*   21610 */     // GIR_Coverage, 46130,
     /*   21610 */     GIR_EraseRootFromParent_Done,
     /*   21611 */   // Label 434: @21611
     /*   21611 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21664), // Rule ID 46131 //
     /*   21616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21627 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21662 */     GIR_RootConstrainSelectedInstOperands,
     /*   21663 */     // GIR_Coverage, 46131,
     /*   21663 */     GIR_EraseRootFromParent_Done,
     /*   21664 */   // Label 435: @21664
     /*   21664 */   GIM_Reject,
     /*   21665 */ // Label 395: @21665
     /*   21665 */ GIM_Reject,
     /*   21666 */ // Label 132: @21666
     /*   21666 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(22060),
     /*   21671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21681 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21749), // Rule ID 70683 //
     /*   21686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21705 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21723 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21747 */     GIR_RootConstrainSelectedInstOperands,
     /*   21748 */     // GIR_Coverage, 70683,
     /*   21748 */     GIR_EraseRootFromParent_Done,
     /*   21749 */   // Label 437: @21749
     /*   21749 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21817), // Rule ID 70684 //
     /*   21754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21791 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21815 */     GIR_RootConstrainSelectedInstOperands,
     /*   21816 */     // GIR_Coverage, 70684,
     /*   21816 */     GIR_EraseRootFromParent_Done,
     /*   21817 */   // Label 438: @21817
     /*   21817 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21885), // Rule ID 51866 //
     /*   21822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21859 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21883 */     GIR_RootConstrainSelectedInstOperands,
     /*   21884 */     // GIR_Coverage, 51866,
     /*   21884 */     GIR_EraseRootFromParent_Done,
     /*   21885 */   // Label 439: @21885
     /*   21885 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21953), // Rule ID 51867 //
     /*   21890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21927 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21951 */     GIR_RootConstrainSelectedInstOperands,
     /*   21952 */     // GIR_Coverage, 51867,
     /*   21952 */     GIR_EraseRootFromParent_Done,
     /*   21953 */   // Label 440: @21953
     /*   21953 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22006), // Rule ID 46098 //
     /*   21958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21969 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22004 */     GIR_RootConstrainSelectedInstOperands,
     /*   22005 */     // GIR_Coverage, 46098,
     /*   22005 */     GIR_EraseRootFromParent_Done,
     /*   22006 */   // Label 441: @22006
     /*   22006 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22059), // Rule ID 46099 //
     /*   22011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22022 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   22022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   22025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   22039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   22046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22057 */     GIR_RootConstrainSelectedInstOperands,
     /*   22058 */     // GIR_Coverage, 46099,
     /*   22058 */     GIR_EraseRootFromParent_Done,
     /*   22059 */   // Label 442: @22059
     /*   22059 */   GIM_Reject,
     /*   22060 */ // Label 436: @22060
     /*   22060 */ GIM_Reject,
     /*   22061 */ // Label 133: @22061
     /*   22061 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(25185),
     /*   22066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22076 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22172), // Rule ID 70895 //
     /*   22081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22146 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22170 */     GIR_RootConstrainSelectedInstOperands,
     /*   22171 */     // GIR_Coverage, 70895,
     /*   22171 */     GIR_EraseRootFromParent_Done,
     /*   22172 */   // Label 444: @22172
     /*   22172 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22268), // Rule ID 70896 //
     /*   22177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22242 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22266 */     GIR_RootConstrainSelectedInstOperands,
     /*   22267 */     // GIR_Coverage, 70896,
     /*   22267 */     GIR_EraseRootFromParent_Done,
     /*   22268 */   // Label 445: @22268
     /*   22268 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22364), // Rule ID 71135 //
     /*   22273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22338 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22362 */     GIR_RootConstrainSelectedInstOperands,
     /*   22363 */     // GIR_Coverage, 71135,
     /*   22363 */     GIR_EraseRootFromParent_Done,
     /*   22364 */   // Label 446: @22364
     /*   22364 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22460), // Rule ID 71136 //
     /*   22369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22434 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22458 */     GIR_RootConstrainSelectedInstOperands,
     /*   22459 */     // GIR_Coverage, 71136,
     /*   22459 */     GIR_EraseRootFromParent_Done,
     /*   22460 */   // Label 447: @22460
     /*   22460 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22556), // Rule ID 71137 //
     /*   22465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22517 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22530 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22554 */     GIR_RootConstrainSelectedInstOperands,
     /*   22555 */     // GIR_Coverage, 71137,
     /*   22555 */     GIR_EraseRootFromParent_Done,
     /*   22556 */   // Label 448: @22556
     /*   22556 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22652), // Rule ID 71138 //
     /*   22561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22626 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22650 */     GIR_RootConstrainSelectedInstOperands,
     /*   22651 */     // GIR_Coverage, 71138,
     /*   22651 */     GIR_EraseRootFromParent_Done,
     /*   22652 */   // Label 449: @22652
     /*   22652 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22748), // Rule ID 71009 //
     /*   22657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22722 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22746 */     GIR_RootConstrainSelectedInstOperands,
     /*   22747 */     // GIR_Coverage, 71009,
     /*   22747 */     GIR_EraseRootFromParent_Done,
     /*   22748 */   // Label 450: @22748
     /*   22748 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22844), // Rule ID 71010 //
     /*   22753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22805 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22818 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22842 */     GIR_RootConstrainSelectedInstOperands,
     /*   22843 */     // GIR_Coverage, 71010,
     /*   22843 */     GIR_EraseRootFromParent_Done,
     /*   22844 */   // Label 451: @22844
     /*   22844 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22940), // Rule ID 52038 //
     /*   22849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22872 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22905 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22914 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22938 */     GIR_RootConstrainSelectedInstOperands,
     /*   22939 */     // GIR_Coverage, 52038,
     /*   22939 */     GIR_EraseRootFromParent_Done,
     /*   22940 */   // Label 452: @22940
     /*   22940 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23036), // Rule ID 52039 //
     /*   22945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22982 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22997 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23001 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23010 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   23013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23034 */     GIR_RootConstrainSelectedInstOperands,
     /*   23035 */     // GIR_Coverage, 52039,
     /*   23035 */     GIR_EraseRootFromParent_Done,
     /*   23036 */   // Label 453: @23036
     /*   23036 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23132), // Rule ID 52156 //
     /*   23041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23078 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23093 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23097 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23099 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23106 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23130 */     GIR_RootConstrainSelectedInstOperands,
     /*   23131 */     // GIR_Coverage, 52156,
     /*   23131 */     GIR_EraseRootFromParent_Done,
     /*   23132 */   // Label 454: @23132
     /*   23132 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23228), // Rule ID 52157 //
     /*   23137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23174 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23193 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23202 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23226 */     GIR_RootConstrainSelectedInstOperands,
     /*   23227 */     // GIR_Coverage, 52157,
     /*   23227 */     GIR_EraseRootFromParent_Done,
     /*   23228 */   // Label 455: @23228
     /*   23228 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23324), // Rule ID 71133 //
     /*   23233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23289 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23298 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   23309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   23313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23322 */     GIR_RootConstrainSelectedInstOperands,
     /*   23323 */     // GIR_Coverage, 71133,
     /*   23323 */     GIR_EraseRootFromParent_Done,
     /*   23324 */   // Label 456: @23324
     /*   23324 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23420), // Rule ID 71134 //
     /*   23329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23352 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23385 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23394 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   23397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   23405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   23409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23418 */     GIR_RootConstrainSelectedInstOperands,
     /*   23419 */     // GIR_Coverage, 71134,
     /*   23419 */     GIR_EraseRootFromParent_Done,
     /*   23420 */   // Label 457: @23420
     /*   23420 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23516), // Rule ID 52096 //
     /*   23425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23481 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23490 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23514 */     GIR_RootConstrainSelectedInstOperands,
     /*   23515 */     // GIR_Coverage, 52096,
     /*   23515 */     GIR_EraseRootFromParent_Done,
     /*   23516 */   // Label 458: @23516
     /*   23516 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23612), // Rule ID 52097 //
     /*   23521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23577 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23586 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23610 */     GIR_RootConstrainSelectedInstOperands,
     /*   23611 */     // GIR_Coverage, 52097,
     /*   23611 */     GIR_EraseRootFromParent_Done,
     /*   23612 */   // Label 459: @23612
     /*   23612 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23701), // Rule ID 46684 //
     /*   23617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23660 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23699 */     GIR_RootConstrainSelectedInstOperands,
     /*   23700 */     // GIR_Coverage, 46684,
     /*   23700 */     GIR_EraseRootFromParent_Done,
     /*   23701 */   // Label 460: @23701
     /*   23701 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23790), // Rule ID 46685 //
     /*   23706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23749 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23788 */     GIR_RootConstrainSelectedInstOperands,
     /*   23789 */     // GIR_Coverage, 46685,
     /*   23789 */     GIR_EraseRootFromParent_Done,
     /*   23790 */   // Label 461: @23790
     /*   23790 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23879), // Rule ID 46448 //
     /*   23795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23838 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23877 */     GIR_RootConstrainSelectedInstOperands,
     /*   23878 */     // GIR_Coverage, 46448,
     /*   23878 */     GIR_EraseRootFromParent_Done,
     /*   23879 */   // Label 462: @23879
     /*   23879 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23968), // Rule ID 46449 //
     /*   23884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23927 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23966 */     GIR_RootConstrainSelectedInstOperands,
     /*   23967 */     // GIR_Coverage, 46449,
     /*   23967 */     GIR_EraseRootFromParent_Done,
     /*   23968 */   // Label 463: @23968
     /*   23968 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(24057), // Rule ID 46564 //
     /*   23973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24007 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   24016 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   24016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   24033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   24042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24055 */     GIR_RootConstrainSelectedInstOperands,
     /*   24056 */     // GIR_Coverage, 46564,
     /*   24056 */     GIR_EraseRootFromParent_Done,
     /*   24057 */   // Label 464: @24057
     /*   24057 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24146), // Rule ID 46565 //
     /*   24062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   24088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   24105 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   24105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   24122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24144 */     GIR_RootConstrainSelectedInstOperands,
     /*   24145 */     // GIR_Coverage, 46565,
     /*   24145 */     GIR_EraseRootFromParent_Done,
     /*   24146 */   // Label 465: @24146
     /*   24146 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24214), // Rule ID 70707 //
     /*   24151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24170 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24188 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24212 */     GIR_RootConstrainSelectedInstOperands,
     /*   24213 */     // GIR_Coverage, 70707,
     /*   24213 */     GIR_EraseRootFromParent_Done,
     /*   24214 */   // Label 466: @24214
     /*   24214 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24282), // Rule ID 70708 //
     /*   24219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24238 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24256 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24280 */     GIR_RootConstrainSelectedInstOperands,
     /*   24281 */     // GIR_Coverage, 70708,
     /*   24281 */     GIR_EraseRootFromParent_Done,
     /*   24282 */   // Label 467: @24282
     /*   24282 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24337), // Rule ID 69695 //
     /*   24287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24315 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24335 */     GIR_RootConstrainSelectedInstOperands,
     /*   24336 */     // GIR_Coverage, 69695,
     /*   24336 */     GIR_EraseRootFromParent_Done,
     /*   24337 */   // Label 468: @24337
     /*   24337 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24392), // Rule ID 69696 //
     /*   24342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24370 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24390 */     GIR_RootConstrainSelectedInstOperands,
     /*   24391 */     // GIR_Coverage, 69696,
     /*   24391 */     GIR_EraseRootFromParent_Done,
     /*   24392 */   // Label 469: @24392
     /*   24392 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24447), // Rule ID 69515 //
     /*   24397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24425 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24445 */     GIR_RootConstrainSelectedInstOperands,
     /*   24446 */     // GIR_Coverage, 69515,
     /*   24446 */     GIR_EraseRootFromParent_Done,
     /*   24447 */   // Label 470: @24447
     /*   24447 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24502), // Rule ID 69516 //
     /*   24452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24480 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24500 */     GIR_RootConstrainSelectedInstOperands,
     /*   24501 */     // GIR_Coverage, 69516,
     /*   24501 */     GIR_EraseRootFromParent_Done,
     /*   24502 */   // Label 471: @24502
     /*   24502 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24557), // Rule ID 69605 //
     /*   24507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24535 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24555 */     GIR_RootConstrainSelectedInstOperands,
     /*   24556 */     // GIR_Coverage, 69605,
     /*   24556 */     GIR_EraseRootFromParent_Done,
     /*   24557 */   // Label 472: @24557
     /*   24557 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24612), // Rule ID 69606 //
     /*   24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24590 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24610 */     GIR_RootConstrainSelectedInstOperands,
     /*   24611 */     // GIR_Coverage, 69606,
     /*   24611 */     GIR_EraseRootFromParent_Done,
     /*   24612 */   // Label 473: @24612
     /*   24612 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24680), // Rule ID 51878 //
     /*   24617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24654 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24678 */     GIR_RootConstrainSelectedInstOperands,
     /*   24679 */     // GIR_Coverage, 51878,
     /*   24679 */     GIR_EraseRootFromParent_Done,
     /*   24680 */   // Label 474: @24680
     /*   24680 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24748), // Rule ID 51879 //
     /*   24685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24708 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24722 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24746 */     GIR_RootConstrainSelectedInstOperands,
     /*   24747 */     // GIR_Coverage, 51879,
     /*   24747 */     GIR_EraseRootFromParent_Done,
     /*   24748 */   // Label 475: @24748
     /*   24748 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24803), // Rule ID 46744 //
     /*   24753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24781 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24801 */     GIR_RootConstrainSelectedInstOperands,
     /*   24802 */     // GIR_Coverage, 46744,
     /*   24802 */     GIR_EraseRootFromParent_Done,
     /*   24803 */   // Label 476: @24803
     /*   24803 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24858), // Rule ID 46745 //
     /*   24808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24836 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24856 */     GIR_RootConstrainSelectedInstOperands,
     /*   24857 */     // GIR_Coverage, 46745,
     /*   24857 */     GIR_EraseRootFromParent_Done,
     /*   24858 */   // Label 477: @24858
     /*   24858 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24913), // Rule ID 46504 //
     /*   24863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24882 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24891 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24911 */     GIR_RootConstrainSelectedInstOperands,
     /*   24912 */     // GIR_Coverage, 46504,
     /*   24912 */     GIR_EraseRootFromParent_Done,
     /*   24913 */   // Label 478: @24913
     /*   24913 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24968), // Rule ID 46505 //
     /*   24918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24946 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24966 */     GIR_RootConstrainSelectedInstOperands,
     /*   24967 */     // GIR_Coverage, 46505,
     /*   24967 */     GIR_EraseRootFromParent_Done,
     /*   24968 */   // Label 479: @24968
     /*   24968 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(25023), // Rule ID 46624 //
     /*   24973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24992 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25001 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   25001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   25004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   25008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25021 */     GIR_RootConstrainSelectedInstOperands,
     /*   25022 */     // GIR_Coverage, 46624,
     /*   25022 */     GIR_EraseRootFromParent_Done,
     /*   25023 */   // Label 480: @25023
     /*   25023 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25078), // Rule ID 46625 //
     /*   25028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   25047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25056 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   25056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   25059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   25063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25076 */     GIR_RootConstrainSelectedInstOperands,
     /*   25077 */     // GIR_Coverage, 46625,
     /*   25077 */     GIR_EraseRootFromParent_Done,
     /*   25078 */   // Label 481: @25078
     /*   25078 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25131), // Rule ID 46110 //
     /*   25083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25094 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   25094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   25097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   25111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25129 */     GIR_RootConstrainSelectedInstOperands,
     /*   25130 */     // GIR_Coverage, 46110,
     /*   25130 */     GIR_EraseRootFromParent_Done,
     /*   25131 */   // Label 482: @25131
     /*   25131 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25184), // Rule ID 46111 //
     /*   25136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25147 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   25147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   25150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   25164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   25171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25182 */     GIR_RootConstrainSelectedInstOperands,
     /*   25183 */     // GIR_Coverage, 46111,
     /*   25183 */     GIR_EraseRootFromParent_Done,
     /*   25184 */   // Label 483: @25184
     /*   25184 */   GIM_Reject,
     /*   25185 */ // Label 443: @25185
     /*   25185 */ GIM_Reject,
     /*   25186 */ // Label 134: @25186
     /*   25186 */ GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(28310),
     /*   25191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25201 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25297), // Rule ID 70907 //
     /*   25206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25258 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25271 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25295 */     GIR_RootConstrainSelectedInstOperands,
     /*   25296 */     // GIR_Coverage, 70907,
     /*   25296 */     GIR_EraseRootFromParent_Done,
     /*   25297 */   // Label 485: @25297
     /*   25297 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25393), // Rule ID 70908 //
     /*   25302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25354 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25356 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25367 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25391 */     GIR_RootConstrainSelectedInstOperands,
     /*   25392 */     // GIR_Coverage, 70908,
     /*   25392 */     GIR_EraseRootFromParent_Done,
     /*   25393 */   // Label 486: @25393
     /*   25393 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25489), // Rule ID 71171 //
     /*   25398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25450 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25452 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25463 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25487 */     GIR_RootConstrainSelectedInstOperands,
     /*   25488 */     // GIR_Coverage, 71171,
     /*   25488 */     GIR_EraseRootFromParent_Done,
     /*   25489 */   // Label 487: @25489
     /*   25489 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25585), // Rule ID 71172 //
     /*   25494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25546 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25548 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25559 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25583 */     GIR_RootConstrainSelectedInstOperands,
     /*   25584 */     // GIR_Coverage, 71172,
     /*   25584 */     GIR_EraseRootFromParent_Done,
     /*   25585 */   // Label 488: @25585
     /*   25585 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25681), // Rule ID 71173 //
     /*   25590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25623 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25642 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25644 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25655 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25679 */     GIR_RootConstrainSelectedInstOperands,
     /*   25680 */     // GIR_Coverage, 71173,
     /*   25680 */     GIR_EraseRootFromParent_Done,
     /*   25681 */   // Label 489: @25681
     /*   25681 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25777), // Rule ID 71174 //
     /*   25686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25705 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25719 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25738 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25740 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25751 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25775 */     GIR_RootConstrainSelectedInstOperands,
     /*   25776 */     // GIR_Coverage, 71174,
     /*   25776 */     GIR_EraseRootFromParent_Done,
     /*   25777 */   // Label 490: @25777
     /*   25777 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25873), // Rule ID 71021 //
     /*   25782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25815 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25834 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25836 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25847 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25871 */     GIR_RootConstrainSelectedInstOperands,
     /*   25872 */     // GIR_Coverage, 71021,
     /*   25872 */     GIR_EraseRootFromParent_Done,
     /*   25873 */   // Label 491: @25873
     /*   25873 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(25969), // Rule ID 71022 //
     /*   25878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25911 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25926 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25930 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25932 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25943 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25967 */     GIR_RootConstrainSelectedInstOperands,
     /*   25968 */     // GIR_Coverage, 71022,
     /*   25968 */     GIR_EraseRootFromParent_Done,
     /*   25969 */   // Label 492: @25969
     /*   25969 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26065), // Rule ID 52050 //
     /*   25974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26011 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26030 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26032 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26039 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   26042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26063 */     GIR_RootConstrainSelectedInstOperands,
     /*   26064 */     // GIR_Coverage, 52050,
     /*   26064 */     GIR_EraseRootFromParent_Done,
     /*   26065 */   // Label 493: @26065
     /*   26065 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26161), // Rule ID 52051 //
     /*   26070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26093 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26126 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26128 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26135 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   26138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26159 */     GIR_RootConstrainSelectedInstOperands,
     /*   26160 */     // GIR_Coverage, 52051,
     /*   26160 */     GIR_EraseRootFromParent_Done,
     /*   26161 */   // Label 494: @26161
     /*   26161 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26257), // Rule ID 52168 //
     /*   26166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26203 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26222 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26224 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26231 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26255 */     GIR_RootConstrainSelectedInstOperands,
     /*   26256 */     // GIR_Coverage, 52168,
     /*   26256 */     GIR_EraseRootFromParent_Done,
     /*   26257 */   // Label 495: @26257
     /*   26257 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26353), // Rule ID 52169 //
     /*   26262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26299 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26318 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26320 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26327 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26351 */     GIR_RootConstrainSelectedInstOperands,
     /*   26352 */     // GIR_Coverage, 52169,
     /*   26352 */     GIR_EraseRootFromParent_Done,
     /*   26353 */   // Label 496: @26353
     /*   26353 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26449), // Rule ID 71169 //
     /*   26358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26414 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26416 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26423 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26447 */     GIR_RootConstrainSelectedInstOperands,
     /*   26448 */     // GIR_Coverage, 71169,
     /*   26448 */     GIR_EraseRootFromParent_Done,
     /*   26449 */   // Label 497: @26449
     /*   26449 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26545), // Rule ID 71170 //
     /*   26454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26491 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26510 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26519 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26543 */     GIR_RootConstrainSelectedInstOperands,
     /*   26544 */     // GIR_Coverage, 71170,
     /*   26544 */     GIR_EraseRootFromParent_Done,
     /*   26545 */   // Label 498: @26545
     /*   26545 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26641), // Rule ID 52108 //
     /*   26550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26573 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26587 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26606 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26608 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26615 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26639 */     GIR_RootConstrainSelectedInstOperands,
     /*   26640 */     // GIR_Coverage, 52108,
     /*   26640 */     GIR_EraseRootFromParent_Done,
     /*   26641 */   // Label 499: @26641
     /*   26641 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26737), // Rule ID 52109 //
     /*   26646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26683 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26702 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26704 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26711 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26735 */     GIR_RootConstrainSelectedInstOperands,
     /*   26736 */     // GIR_Coverage, 52109,
     /*   26736 */     GIR_EraseRootFromParent_Done,
     /*   26737 */   // Label 500: @26737
     /*   26737 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26826), // Rule ID 46708 //
     /*   26742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26785 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26824 */     GIR_RootConstrainSelectedInstOperands,
     /*   26825 */     // GIR_Coverage, 46708,
     /*   26825 */     GIR_EraseRootFromParent_Done,
     /*   26826 */   // Label 501: @26826
     /*   26826 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26915), // Rule ID 46709 //
     /*   26831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26874 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26913 */     GIR_RootConstrainSelectedInstOperands,
     /*   26914 */     // GIR_Coverage, 46709,
     /*   26914 */     GIR_EraseRootFromParent_Done,
     /*   26915 */   // Label 502: @26915
     /*   26915 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(27004), // Rule ID 46472 //
     /*   26920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26963 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27002 */     GIR_RootConstrainSelectedInstOperands,
     /*   27003 */     // GIR_Coverage, 46472,
     /*   27003 */     GIR_EraseRootFromParent_Done,
     /*   27004 */   // Label 503: @27004
     /*   27004 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27093), // Rule ID 46473 //
     /*   27009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27052 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   27052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   27069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27091 */     GIR_RootConstrainSelectedInstOperands,
     /*   27092 */     // GIR_Coverage, 46473,
     /*   27092 */     GIR_EraseRootFromParent_Done,
     /*   27093 */   // Label 504: @27093
     /*   27093 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27182), // Rule ID 46588 //
     /*   27098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27141 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   27141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   27158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27180 */     GIR_RootConstrainSelectedInstOperands,
     /*   27181 */     // GIR_Coverage, 46588,
     /*   27181 */     GIR_EraseRootFromParent_Done,
     /*   27182 */   // Label 505: @27182
     /*   27182 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27271), // Rule ID 46589 //
     /*   27187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   27213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   27230 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   27230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   27247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   27256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27269 */     GIR_RootConstrainSelectedInstOperands,
     /*   27270 */     // GIR_Coverage, 46589,
     /*   27270 */     GIR_EraseRootFromParent_Done,
     /*   27271 */   // Label 506: @27271
     /*   27271 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27339), // Rule ID 70739 //
     /*   27276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27313 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27337 */     GIR_RootConstrainSelectedInstOperands,
     /*   27338 */     // GIR_Coverage, 70739,
     /*   27338 */     GIR_EraseRootFromParent_Done,
     /*   27339 */   // Label 507: @27339
     /*   27339 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27407), // Rule ID 70740 //
     /*   27344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27381 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27405 */     GIR_RootConstrainSelectedInstOperands,
     /*   27406 */     // GIR_Coverage, 70740,
     /*   27406 */     GIR_EraseRootFromParent_Done,
     /*   27407 */   // Label 508: @27407
     /*   27407 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27462), // Rule ID 69719 //
     /*   27412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27440 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27460 */     GIR_RootConstrainSelectedInstOperands,
     /*   27461 */     // GIR_Coverage, 69719,
     /*   27461 */     GIR_EraseRootFromParent_Done,
     /*   27462 */   // Label 509: @27462
     /*   27462 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27517), // Rule ID 69720 //
     /*   27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27495 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27515 */     GIR_RootConstrainSelectedInstOperands,
     /*   27516 */     // GIR_Coverage, 69720,
     /*   27516 */     GIR_EraseRootFromParent_Done,
     /*   27517 */   // Label 510: @27517
     /*   27517 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27572), // Rule ID 69539 //
     /*   27522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27550 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27570 */     GIR_RootConstrainSelectedInstOperands,
     /*   27571 */     // GIR_Coverage, 69539,
     /*   27571 */     GIR_EraseRootFromParent_Done,
     /*   27572 */   // Label 511: @27572
     /*   27572 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27627), // Rule ID 69540 //
     /*   27577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27605 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27625 */     GIR_RootConstrainSelectedInstOperands,
     /*   27626 */     // GIR_Coverage, 69540,
     /*   27626 */     GIR_EraseRootFromParent_Done,
     /*   27627 */   // Label 512: @27627
     /*   27627 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27682), // Rule ID 69629 //
     /*   27632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27660 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27680 */     GIR_RootConstrainSelectedInstOperands,
     /*   27681 */     // GIR_Coverage, 69629,
     /*   27681 */     GIR_EraseRootFromParent_Done,
     /*   27682 */   // Label 513: @27682
     /*   27682 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27737), // Rule ID 69630 //
     /*   27687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27715 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27735 */     GIR_RootConstrainSelectedInstOperands,
     /*   27736 */     // GIR_Coverage, 69630,
     /*   27736 */     GIR_EraseRootFromParent_Done,
     /*   27737 */   // Label 514: @27737
     /*   27737 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27805), // Rule ID 51894 //
     /*   27742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27779 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27803 */     GIR_RootConstrainSelectedInstOperands,
     /*   27804 */     // GIR_Coverage, 51894,
     /*   27804 */     GIR_EraseRootFromParent_Done,
     /*   27805 */   // Label 515: @27805
     /*   27805 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27873), // Rule ID 51895 //
     /*   27810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27847 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27871 */     GIR_RootConstrainSelectedInstOperands,
     /*   27872 */     // GIR_Coverage, 51895,
     /*   27872 */     GIR_EraseRootFromParent_Done,
     /*   27873 */   // Label 516: @27873
     /*   27873 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27928), // Rule ID 46768 //
     /*   27878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27906 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27926 */     GIR_RootConstrainSelectedInstOperands,
     /*   27927 */     // GIR_Coverage, 46768,
     /*   27927 */     GIR_EraseRootFromParent_Done,
     /*   27928 */   // Label 517: @27928
     /*   27928 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27983), // Rule ID 46769 //
     /*   27933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27952 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27961 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27981 */     GIR_RootConstrainSelectedInstOperands,
     /*   27982 */     // GIR_Coverage, 46769,
     /*   27982 */     GIR_EraseRootFromParent_Done,
     /*   27983 */   // Label 518: @27983
     /*   27983 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(28038), // Rule ID 46528 //
     /*   27988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28016 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   28016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   28019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28036 */     GIR_RootConstrainSelectedInstOperands,
     /*   28037 */     // GIR_Coverage, 46528,
     /*   28037 */     GIR_EraseRootFromParent_Done,
     /*   28038 */   // Label 519: @28038
     /*   28038 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(28093), // Rule ID 46529 //
     /*   28043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28071 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   28071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   28074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28091 */     GIR_RootConstrainSelectedInstOperands,
     /*   28092 */     // GIR_Coverage, 46529,
     /*   28092 */     GIR_EraseRootFromParent_Done,
     /*   28093 */   // Label 520: @28093
     /*   28093 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28148), // Rule ID 46648 //
     /*   28098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28126 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   28126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   28129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28146 */     GIR_RootConstrainSelectedInstOperands,
     /*   28147 */     // GIR_Coverage, 46648,
     /*   28147 */     GIR_EraseRootFromParent_Done,
     /*   28148 */   // Label 521: @28148
     /*   28148 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28203), // Rule ID 46649 //
     /*   28153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   28172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   28181 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   28181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   28184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   28188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   28192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   28198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28201 */     GIR_RootConstrainSelectedInstOperands,
     /*   28202 */     // GIR_Coverage, 46649,
     /*   28202 */     GIR_EraseRootFromParent_Done,
     /*   28203 */   // Label 522: @28203
     /*   28203 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28256), // Rule ID 46126 //
     /*   28208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28219 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   28219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   28222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   28236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   28245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28254 */     GIR_RootConstrainSelectedInstOperands,
     /*   28255 */     // GIR_Coverage, 46126,
     /*   28255 */     GIR_EraseRootFromParent_Done,
     /*   28256 */   // Label 523: @28256
     /*   28256 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28309), // Rule ID 46127 //
     /*   28261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28272 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   28272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   28275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   28289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   28296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   28298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28307 */     GIR_RootConstrainSelectedInstOperands,
     /*   28308 */     // GIR_Coverage, 46127,
     /*   28308 */     GIR_EraseRootFromParent_Done,
     /*   28309 */   // Label 524: @28309
     /*   28309 */   GIM_Reject,
     /*   28310 */ // Label 484: @28310
     /*   28310 */ GIM_Reject,
     /*   28311 */ // Label 135: @28311
     /*   28311 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(31435),
     /*   28316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28326 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28422), // Rule ID 70917 //
     /*   28331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28383 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28385 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28396 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28420 */     GIR_RootConstrainSelectedInstOperands,
     /*   28421 */     // GIR_Coverage, 70917,
     /*   28421 */     GIR_EraseRootFromParent_Done,
     /*   28422 */   // Label 526: @28422
     /*   28422 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28518), // Rule ID 70918 //
     /*   28427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28460 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28479 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28481 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28492 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28516 */     GIR_RootConstrainSelectedInstOperands,
     /*   28517 */     // GIR_Coverage, 70918,
     /*   28517 */     GIR_EraseRootFromParent_Done,
     /*   28518 */   // Label 527: @28518
     /*   28518 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28614), // Rule ID 71201 //
     /*   28523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28556 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28571 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28575 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28588 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28612 */     GIR_RootConstrainSelectedInstOperands,
     /*   28613 */     // GIR_Coverage, 71201,
     /*   28613 */     GIR_EraseRootFromParent_Done,
     /*   28614 */   // Label 528: @28614
     /*   28614 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28710), // Rule ID 71202 //
     /*   28619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28638 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28671 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28684 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28708 */     GIR_RootConstrainSelectedInstOperands,
     /*   28709 */     // GIR_Coverage, 71202,
     /*   28709 */     GIR_EraseRootFromParent_Done,
     /*   28710 */   // Label 529: @28710
     /*   28710 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28806), // Rule ID 71203 //
     /*   28715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28748 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28767 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28769 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28780 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28804 */     GIR_RootConstrainSelectedInstOperands,
     /*   28805 */     // GIR_Coverage, 71203,
     /*   28805 */     GIR_EraseRootFromParent_Done,
     /*   28806 */   // Label 530: @28806
     /*   28806 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(28902), // Rule ID 71204 //
     /*   28811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28830 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28844 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28859 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28863 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28876 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28900 */     GIR_RootConstrainSelectedInstOperands,
     /*   28901 */     // GIR_Coverage, 71204,
     /*   28901 */     GIR_EraseRootFromParent_Done,
     /*   28902 */   // Label 531: @28902
     /*   28902 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(28998), // Rule ID 71031 //
     /*   28907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28926 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28959 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28961 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28972 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28996 */     GIR_RootConstrainSelectedInstOperands,
     /*   28997 */     // GIR_Coverage, 71031,
     /*   28997 */     GIR_EraseRootFromParent_Done,
     /*   28998 */   // Label 532: @28998
     /*   28998 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29094), // Rule ID 71032 //
     /*   29003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29036 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29055 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29057 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29068 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   29075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29092 */     GIR_RootConstrainSelectedInstOperands,
     /*   29093 */     // GIR_Coverage, 71032,
     /*   29093 */     GIR_EraseRootFromParent_Done,
     /*   29094 */   // Label 533: @29094
     /*   29094 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29190), // Rule ID 52060 //
     /*   29099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29155 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29164 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   29167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29188 */     GIR_RootConstrainSelectedInstOperands,
     /*   29189 */     // GIR_Coverage, 52060,
     /*   29189 */     GIR_EraseRootFromParent_Done,
     /*   29190 */   // Label 534: @29190
     /*   29190 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29286), // Rule ID 52061 //
     /*   29195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29251 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29260 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   29263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29284 */     GIR_RootConstrainSelectedInstOperands,
     /*   29285 */     // GIR_Coverage, 52061,
     /*   29285 */     GIR_EraseRootFromParent_Done,
     /*   29286 */   // Label 535: @29286
     /*   29286 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29382), // Rule ID 52178 //
     /*   29291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29328 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29347 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29349 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29356 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29380 */     GIR_RootConstrainSelectedInstOperands,
     /*   29381 */     // GIR_Coverage, 52178,
     /*   29381 */     GIR_EraseRootFromParent_Done,
     /*   29382 */   // Label 536: @29382
     /*   29382 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29478), // Rule ID 52179 //
     /*   29387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29443 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29452 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29476 */     GIR_RootConstrainSelectedInstOperands,
     /*   29477 */     // GIR_Coverage, 52179,
     /*   29477 */     GIR_EraseRootFromParent_Done,
     /*   29478 */   // Label 537: @29478
     /*   29478 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29574), // Rule ID 71199 //
     /*   29483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29539 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29541 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29548 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29572 */     GIR_RootConstrainSelectedInstOperands,
     /*   29573 */     // GIR_Coverage, 71199,
     /*   29573 */     GIR_EraseRootFromParent_Done,
     /*   29574 */   // Label 538: @29574
     /*   29574 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29670), // Rule ID 71200 //
     /*   29579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29616 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29635 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29637 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29644 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29668 */     GIR_RootConstrainSelectedInstOperands,
     /*   29669 */     // GIR_Coverage, 71200,
     /*   29669 */     GIR_EraseRootFromParent_Done,
     /*   29670 */   // Label 539: @29670
     /*   29670 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29766), // Rule ID 52118 //
     /*   29675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29712 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29727 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29731 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29740 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29764 */     GIR_RootConstrainSelectedInstOperands,
     /*   29765 */     // GIR_Coverage, 52118,
     /*   29765 */     GIR_EraseRootFromParent_Done,
     /*   29766 */   // Label 540: @29766
     /*   29766 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29862), // Rule ID 52119 //
     /*   29771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29808 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29827 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29836 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29860 */     GIR_RootConstrainSelectedInstOperands,
     /*   29861 */     // GIR_Coverage, 52119,
     /*   29861 */     GIR_EraseRootFromParent_Done,
     /*   29862 */   // Label 541: @29862
     /*   29862 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29951), // Rule ID 46728 //
     /*   29867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29882 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29901 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29910 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29949 */     GIR_RootConstrainSelectedInstOperands,
     /*   29950 */     // GIR_Coverage, 46728,
     /*   29950 */     GIR_EraseRootFromParent_Done,
     /*   29951 */   // Label 542: @29951
     /*   29951 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30040), // Rule ID 46729 //
     /*   29956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29990 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29999 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30038 */     GIR_RootConstrainSelectedInstOperands,
     /*   30039 */     // GIR_Coverage, 46729,
     /*   30039 */     GIR_EraseRootFromParent_Done,
     /*   30040 */   // Label 543: @30040
     /*   30040 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30129), // Rule ID 46492 //
     /*   30045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30060 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30079 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30088 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   30088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   30105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30127 */     GIR_RootConstrainSelectedInstOperands,
     /*   30128 */     // GIR_Coverage, 46492,
     /*   30128 */     GIR_EraseRootFromParent_Done,
     /*   30129 */   // Label 544: @30129
     /*   30129 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30218), // Rule ID 46493 //
     /*   30134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30168 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30177 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   30177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   30194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30216 */     GIR_RootConstrainSelectedInstOperands,
     /*   30217 */     // GIR_Coverage, 46493,
     /*   30217 */     GIR_EraseRootFromParent_Done,
     /*   30218 */   // Label 545: @30218
     /*   30218 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30307), // Rule ID 46608 //
     /*   30223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30238 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30257 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30266 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   30266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30305 */     GIR_RootConstrainSelectedInstOperands,
     /*   30306 */     // GIR_Coverage, 46608,
     /*   30306 */     GIR_EraseRootFromParent_Done,
     /*   30307 */   // Label 546: @30307
     /*   30307 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30396), // Rule ID 46609 //
     /*   30312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   30338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30346 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   30355 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   30355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   30372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   30381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30394 */     GIR_RootConstrainSelectedInstOperands,
     /*   30395 */     // GIR_Coverage, 46609,
     /*   30395 */     GIR_EraseRootFromParent_Done,
     /*   30396 */   // Label 547: @30396
     /*   30396 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30464), // Rule ID 70827 //
     /*   30401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30420 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30438 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30462 */     GIR_RootConstrainSelectedInstOperands,
     /*   30463 */     // GIR_Coverage, 70827,
     /*   30463 */     GIR_EraseRootFromParent_Done,
     /*   30464 */   // Label 548: @30464
     /*   30464 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30532), // Rule ID 70828 //
     /*   30469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30506 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30530 */     GIR_RootConstrainSelectedInstOperands,
     /*   30531 */     // GIR_Coverage, 70828,
     /*   30531 */     GIR_EraseRootFromParent_Done,
     /*   30532 */   // Label 549: @30532
     /*   30532 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30587), // Rule ID 69739 //
     /*   30537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30565 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30585 */     GIR_RootConstrainSelectedInstOperands,
     /*   30586 */     // GIR_Coverage, 69739,
     /*   30586 */     GIR_EraseRootFromParent_Done,
     /*   30587 */   // Label 550: @30587
     /*   30587 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30642), // Rule ID 69740 //
     /*   30592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30607 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30620 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30640 */     GIR_RootConstrainSelectedInstOperands,
     /*   30641 */     // GIR_Coverage, 69740,
     /*   30641 */     GIR_EraseRootFromParent_Done,
     /*   30642 */   // Label 551: @30642
     /*   30642 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30697), // Rule ID 69559 //
     /*   30647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30675 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30695 */     GIR_RootConstrainSelectedInstOperands,
     /*   30696 */     // GIR_Coverage, 69559,
     /*   30696 */     GIR_EraseRootFromParent_Done,
     /*   30697 */   // Label 552: @30697
     /*   30697 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30752), // Rule ID 69560 //
     /*   30702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30730 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30750 */     GIR_RootConstrainSelectedInstOperands,
     /*   30751 */     // GIR_Coverage, 69560,
     /*   30751 */     GIR_EraseRootFromParent_Done,
     /*   30752 */   // Label 553: @30752
     /*   30752 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30807), // Rule ID 69649 //
     /*   30757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30785 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30805 */     GIR_RootConstrainSelectedInstOperands,
     /*   30806 */     // GIR_Coverage, 69649,
     /*   30806 */     GIR_EraseRootFromParent_Done,
     /*   30807 */   // Label 554: @30807
     /*   30807 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30862), // Rule ID 69650 //
     /*   30812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30840 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30860 */     GIR_RootConstrainSelectedInstOperands,
     /*   30861 */     // GIR_Coverage, 69650,
     /*   30861 */     GIR_EraseRootFromParent_Done,
     /*   30862 */   // Label 555: @30862
     /*   30862 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30930), // Rule ID 51938 //
     /*   30867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30904 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30928 */     GIR_RootConstrainSelectedInstOperands,
     /*   30929 */     // GIR_Coverage, 51938,
     /*   30929 */     GIR_EraseRootFromParent_Done,
     /*   30930 */   // Label 556: @30930
     /*   30930 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30998), // Rule ID 51939 //
     /*   30935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30972 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30996 */     GIR_RootConstrainSelectedInstOperands,
     /*   30997 */     // GIR_Coverage, 51939,
     /*   30997 */     GIR_EraseRootFromParent_Done,
     /*   30998 */   // Label 557: @30998
     /*   30998 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(31053), // Rule ID 46788 //
     /*   31003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31031 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31051 */     GIR_RootConstrainSelectedInstOperands,
     /*   31052 */     // GIR_Coverage, 46788,
     /*   31052 */     GIR_EraseRootFromParent_Done,
     /*   31053 */   // Label 558: @31053
     /*   31053 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(31108), // Rule ID 46789 //
     /*   31058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31086 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31106 */     GIR_RootConstrainSelectedInstOperands,
     /*   31107 */     // GIR_Coverage, 46789,
     /*   31107 */     GIR_EraseRootFromParent_Done,
     /*   31108 */   // Label 559: @31108
     /*   31108 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31163), // Rule ID 46548 //
     /*   31113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31141 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   31144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31161 */     GIR_RootConstrainSelectedInstOperands,
     /*   31162 */     // GIR_Coverage, 46548,
     /*   31162 */     GIR_EraseRootFromParent_Done,
     /*   31163 */   // Label 560: @31163
     /*   31163 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31218), // Rule ID 46549 //
     /*   31168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31196 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   31199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31216 */     GIR_RootConstrainSelectedInstOperands,
     /*   31217 */     // GIR_Coverage, 46549,
     /*   31217 */     GIR_EraseRootFromParent_Done,
     /*   31218 */   // Label 561: @31218
     /*   31218 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31273), // Rule ID 46668 //
     /*   31223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   31226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31251 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   31251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31271 */     GIR_RootConstrainSelectedInstOperands,
     /*   31272 */     // GIR_Coverage, 46668,
     /*   31272 */     GIR_EraseRootFromParent_Done,
     /*   31273 */   // Label 562: @31273
     /*   31273 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31328), // Rule ID 46669 //
     /*   31278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   31281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   31297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31306 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   31306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   31309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   31323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31326 */     GIR_RootConstrainSelectedInstOperands,
     /*   31327 */     // GIR_Coverage, 46669,
     /*   31327 */     GIR_EraseRootFromParent_Done,
     /*   31328 */   // Label 563: @31328
     /*   31328 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31381), // Rule ID 46170 //
     /*   31333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   31336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31344 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   31344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   31361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31379 */     GIR_RootConstrainSelectedInstOperands,
     /*   31380 */     // GIR_Coverage, 46170,
     /*   31380 */     GIR_EraseRootFromParent_Done,
     /*   31381 */   // Label 564: @31381
     /*   31381 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31434), // Rule ID 46171 //
     /*   31386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   31389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31397 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   31397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   31400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   31414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   31429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31432 */     GIR_RootConstrainSelectedInstOperands,
     /*   31433 */     // GIR_Coverage, 46171,
     /*   31433 */     GIR_EraseRootFromParent_Done,
     /*   31434 */   // Label 565: @31434
     /*   31434 */   GIM_Reject,
     /*   31435 */ // Label 525: @31435
     /*   31435 */ GIM_Reject,
     /*   31436 */ // Label 136: @31436
     /*   31436 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31830),
     /*   31441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31451 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(31519), // Rule ID 70691 //
     /*   31456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31493 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31517 */     GIR_RootConstrainSelectedInstOperands,
     /*   31518 */     // GIR_Coverage, 70691,
     /*   31518 */     GIR_EraseRootFromParent_Done,
     /*   31519 */   // Label 567: @31519
     /*   31519 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31587), // Rule ID 70692 //
     /*   31524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31561 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31585 */     GIR_RootConstrainSelectedInstOperands,
     /*   31586 */     // GIR_Coverage, 70692,
     /*   31586 */     GIR_EraseRootFromParent_Done,
     /*   31587 */   // Label 568: @31587
     /*   31587 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31655), // Rule ID 51870 //
     /*   31592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31615 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31629 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31653 */     GIR_RootConstrainSelectedInstOperands,
     /*   31654 */     // GIR_Coverage, 51870,
     /*   31654 */     GIR_EraseRootFromParent_Done,
     /*   31655 */   // Label 569: @31655
     /*   31655 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31723), // Rule ID 51871 //
     /*   31660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31697 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31721 */     GIR_RootConstrainSelectedInstOperands,
     /*   31722 */     // GIR_Coverage, 51871,
     /*   31722 */     GIR_EraseRootFromParent_Done,
     /*   31723 */   // Label 570: @31723
     /*   31723 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31776), // Rule ID 46102 //
     /*   31728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31739 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31774 */     GIR_RootConstrainSelectedInstOperands,
     /*   31775 */     // GIR_Coverage, 46102,
     /*   31775 */     GIR_EraseRootFromParent_Done,
     /*   31776 */   // Label 571: @31776
     /*   31776 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31829), // Rule ID 46103 //
     /*   31781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31792 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31827 */     GIR_RootConstrainSelectedInstOperands,
     /*   31828 */     // GIR_Coverage, 46103,
     /*   31828 */     GIR_EraseRootFromParent_Done,
     /*   31829 */   // Label 572: @31829
     /*   31829 */   GIM_Reject,
     /*   31830 */ // Label 566: @31830
     /*   31830 */ GIM_Reject,
     /*   31831 */ // Label 137: @31831
     /*   31831 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(34955),
     /*   31836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31846 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(31942), // Rule ID 70897 //
     /*   31851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31870 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31903 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31916 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31940 */     GIR_RootConstrainSelectedInstOperands,
     /*   31941 */     // GIR_Coverage, 70897,
     /*   31941 */     GIR_EraseRootFromParent_Done,
     /*   31942 */   // Label 574: @31942
     /*   31942 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32038), // Rule ID 70898 //
     /*   31947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31980 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31999 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32001 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32012 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32036 */     GIR_RootConstrainSelectedInstOperands,
     /*   32037 */     // GIR_Coverage, 70898,
     /*   32037 */     GIR_EraseRootFromParent_Done,
     /*   32038 */   // Label 575: @32038
     /*   32038 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32134), // Rule ID 71141 //
     /*   32043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32091 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32095 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32097 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32108 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32132 */     GIR_RootConstrainSelectedInstOperands,
     /*   32133 */     // GIR_Coverage, 71141,
     /*   32133 */     GIR_EraseRootFromParent_Done,
     /*   32134 */   // Label 576: @32134
     /*   32134 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32230), // Rule ID 71142 //
     /*   32139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32158 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32172 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32191 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32204 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32228 */     GIR_RootConstrainSelectedInstOperands,
     /*   32229 */     // GIR_Coverage, 71142,
     /*   32229 */     GIR_EraseRootFromParent_Done,
     /*   32230 */   // Label 577: @32230
     /*   32230 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32326), // Rule ID 71143 //
     /*   32235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32268 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32287 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32289 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32300 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32324 */     GIR_RootConstrainSelectedInstOperands,
     /*   32325 */     // GIR_Coverage, 71143,
     /*   32325 */     GIR_EraseRootFromParent_Done,
     /*   32326 */   // Label 578: @32326
     /*   32326 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32422), // Rule ID 71144 //
     /*   32331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32383 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32385 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32396 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32420 */     GIR_RootConstrainSelectedInstOperands,
     /*   32421 */     // GIR_Coverage, 71144,
     /*   32421 */     GIR_EraseRootFromParent_Done,
     /*   32422 */   // Label 579: @32422
     /*   32422 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32518), // Rule ID 71011 //
     /*   32427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32460 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32479 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32481 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32492 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32516 */     GIR_RootConstrainSelectedInstOperands,
     /*   32517 */     // GIR_Coverage, 71011,
     /*   32517 */     GIR_EraseRootFromParent_Done,
     /*   32518 */   // Label 580: @32518
     /*   32518 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32614), // Rule ID 71012 //
     /*   32523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32556 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32571 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32575 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32588 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32612 */     GIR_RootConstrainSelectedInstOperands,
     /*   32613 */     // GIR_Coverage, 71012,
     /*   32613 */     GIR_EraseRootFromParent_Done,
     /*   32614 */   // Label 581: @32614
     /*   32614 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32710), // Rule ID 52040 //
     /*   32619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32656 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32675 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32677 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32684 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32708 */     GIR_RootConstrainSelectedInstOperands,
     /*   32709 */     // GIR_Coverage, 52040,
     /*   32709 */     GIR_EraseRootFromParent_Done,
     /*   32710 */   // Label 582: @32710
     /*   32710 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32806), // Rule ID 52041 //
     /*   32715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32752 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32767 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32771 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32773 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32780 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32804 */     GIR_RootConstrainSelectedInstOperands,
     /*   32805 */     // GIR_Coverage, 52041,
     /*   32805 */     GIR_EraseRootFromParent_Done,
     /*   32806 */   // Label 583: @32806
     /*   32806 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(32902), // Rule ID 52158 //
     /*   32811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32867 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32876 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32900 */     GIR_RootConstrainSelectedInstOperands,
     /*   32901 */     // GIR_Coverage, 52158,
     /*   32901 */     GIR_EraseRootFromParent_Done,
     /*   32902 */   // Label 584: @32902
     /*   32902 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(32998), // Rule ID 52159 //
     /*   32907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32963 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32965 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32972 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32996 */     GIR_RootConstrainSelectedInstOperands,
     /*   32997 */     // GIR_Coverage, 52159,
     /*   32997 */     GIR_EraseRootFromParent_Done,
     /*   32998 */   // Label 585: @32998
     /*   32998 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33094), // Rule ID 71139 //
     /*   33003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33040 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33055 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33059 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33061 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33068 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   33071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   33079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   33083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33092 */     GIR_RootConstrainSelectedInstOperands,
     /*   33093 */     // GIR_Coverage, 71139,
     /*   33093 */     GIR_EraseRootFromParent_Done,
     /*   33094 */   // Label 586: @33094
     /*   33094 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33190), // Rule ID 71140 //
     /*   33099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33155 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33164 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   33167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   33175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   33179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33188 */     GIR_RootConstrainSelectedInstOperands,
     /*   33189 */     // GIR_Coverage, 71140,
     /*   33189 */     GIR_EraseRootFromParent_Done,
     /*   33190 */   // Label 587: @33190
     /*   33190 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33286), // Rule ID 52098 //
     /*   33195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33251 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33260 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   33263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33284 */     GIR_RootConstrainSelectedInstOperands,
     /*   33285 */     // GIR_Coverage, 52098,
     /*   33285 */     GIR_EraseRootFromParent_Done,
     /*   33286 */   // Label 588: @33286
     /*   33286 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33382), // Rule ID 52099 //
     /*   33291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33328 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33347 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33349 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33356 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   33359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   33363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33380 */     GIR_RootConstrainSelectedInstOperands,
     /*   33381 */     // GIR_Coverage, 52099,
     /*   33381 */     GIR_EraseRootFromParent_Done,
     /*   33382 */   // Label 589: @33382
     /*   33382 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33471), // Rule ID 46688 //
     /*   33387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33421 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33430 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33469 */     GIR_RootConstrainSelectedInstOperands,
     /*   33470 */     // GIR_Coverage, 46688,
     /*   33470 */     GIR_EraseRootFromParent_Done,
     /*   33471 */   // Label 590: @33471
     /*   33471 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33560), // Rule ID 46689 //
     /*   33476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33510 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33519 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33558 */     GIR_RootConstrainSelectedInstOperands,
     /*   33559 */     // GIR_Coverage, 46689,
     /*   33559 */     GIR_EraseRootFromParent_Done,
     /*   33560 */   // Label 591: @33560
     /*   33560 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33649), // Rule ID 46452 //
     /*   33565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33599 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33608 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33647 */     GIR_RootConstrainSelectedInstOperands,
     /*   33648 */     // GIR_Coverage, 46452,
     /*   33648 */     GIR_EraseRootFromParent_Done,
     /*   33649 */   // Label 592: @33649
     /*   33649 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33738), // Rule ID 46453 //
     /*   33654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33688 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33697 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33736 */     GIR_RootConstrainSelectedInstOperands,
     /*   33737 */     // GIR_Coverage, 46453,
     /*   33737 */     GIR_EraseRootFromParent_Done,
     /*   33738 */   // Label 593: @33738
     /*   33738 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33827), // Rule ID 46568 //
     /*   33743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33777 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33786 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33825 */     GIR_RootConstrainSelectedInstOperands,
     /*   33826 */     // GIR_Coverage, 46568,
     /*   33826 */     GIR_EraseRootFromParent_Done,
     /*   33827 */   // Label 594: @33827
     /*   33827 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33916), // Rule ID 46569 //
     /*   33832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33866 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33875 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33914 */     GIR_RootConstrainSelectedInstOperands,
     /*   33915 */     // GIR_Coverage, 46569,
     /*   33915 */     GIR_EraseRootFromParent_Done,
     /*   33916 */   // Label 595: @33916
     /*   33916 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33984), // Rule ID 70731 //
     /*   33921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33940 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33958 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33982 */     GIR_RootConstrainSelectedInstOperands,
     /*   33983 */     // GIR_Coverage, 70731,
     /*   33983 */     GIR_EraseRootFromParent_Done,
     /*   33984 */   // Label 596: @33984
     /*   33984 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(34052), // Rule ID 70732 //
     /*   33989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34008 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34026 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34050 */     GIR_RootConstrainSelectedInstOperands,
     /*   34051 */     // GIR_Coverage, 70732,
     /*   34051 */     GIR_EraseRootFromParent_Done,
     /*   34052 */   // Label 597: @34052
     /*   34052 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(34107), // Rule ID 69699 //
     /*   34057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34085 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34105 */     GIR_RootConstrainSelectedInstOperands,
     /*   34106 */     // GIR_Coverage, 69699,
     /*   34106 */     GIR_EraseRootFromParent_Done,
     /*   34107 */   // Label 598: @34107
     /*   34107 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34162), // Rule ID 69700 //
     /*   34112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34140 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34160 */     GIR_RootConstrainSelectedInstOperands,
     /*   34161 */     // GIR_Coverage, 69700,
     /*   34161 */     GIR_EraseRootFromParent_Done,
     /*   34162 */   // Label 599: @34162
     /*   34162 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34217), // Rule ID 69519 //
     /*   34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34195 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34215 */     GIR_RootConstrainSelectedInstOperands,
     /*   34216 */     // GIR_Coverage, 69519,
     /*   34216 */     GIR_EraseRootFromParent_Done,
     /*   34217 */   // Label 600: @34217
     /*   34217 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34272), // Rule ID 69520 //
     /*   34222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34250 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34270 */     GIR_RootConstrainSelectedInstOperands,
     /*   34271 */     // GIR_Coverage, 69520,
     /*   34271 */     GIR_EraseRootFromParent_Done,
     /*   34272 */   // Label 601: @34272
     /*   34272 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34327), // Rule ID 69609 //
     /*   34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34305 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34325 */     GIR_RootConstrainSelectedInstOperands,
     /*   34326 */     // GIR_Coverage, 69609,
     /*   34326 */     GIR_EraseRootFromParent_Done,
     /*   34327 */   // Label 602: @34327
     /*   34327 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34382), // Rule ID 69610 //
     /*   34332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34360 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34380 */     GIR_RootConstrainSelectedInstOperands,
     /*   34381 */     // GIR_Coverage, 69610,
     /*   34381 */     GIR_EraseRootFromParent_Done,
     /*   34382 */   // Label 603: @34382
     /*   34382 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34450), // Rule ID 51890 //
     /*   34387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34424 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34448 */     GIR_RootConstrainSelectedInstOperands,
     /*   34449 */     // GIR_Coverage, 51890,
     /*   34449 */     GIR_EraseRootFromParent_Done,
     /*   34450 */   // Label 604: @34450
     /*   34450 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34518), // Rule ID 51891 //
     /*   34455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34492 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34516 */     GIR_RootConstrainSelectedInstOperands,
     /*   34517 */     // GIR_Coverage, 51891,
     /*   34517 */     GIR_EraseRootFromParent_Done,
     /*   34518 */   // Label 605: @34518
     /*   34518 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34573), // Rule ID 46748 //
     /*   34523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34551 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34571 */     GIR_RootConstrainSelectedInstOperands,
     /*   34572 */     // GIR_Coverage, 46748,
     /*   34572 */     GIR_EraseRootFromParent_Done,
     /*   34573 */   // Label 606: @34573
     /*   34573 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34628), // Rule ID 46749 //
     /*   34578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34606 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34626 */     GIR_RootConstrainSelectedInstOperands,
     /*   34627 */     // GIR_Coverage, 46749,
     /*   34627 */     GIR_EraseRootFromParent_Done,
     /*   34628 */   // Label 607: @34628
     /*   34628 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(34683), // Rule ID 46508 //
     /*   34633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34652 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34661 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34681 */     GIR_RootConstrainSelectedInstOperands,
     /*   34682 */     // GIR_Coverage, 46508,
     /*   34682 */     GIR_EraseRootFromParent_Done,
     /*   34683 */   // Label 608: @34683
     /*   34683 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34738), // Rule ID 46509 //
     /*   34688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34707 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34716 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34736 */     GIR_RootConstrainSelectedInstOperands,
     /*   34737 */     // GIR_Coverage, 46509,
     /*   34737 */     GIR_EraseRootFromParent_Done,
     /*   34738 */   // Label 609: @34738
     /*   34738 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34793), // Rule ID 46628 //
     /*   34743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34762 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34771 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34791 */     GIR_RootConstrainSelectedInstOperands,
     /*   34792 */     // GIR_Coverage, 46628,
     /*   34792 */     GIR_EraseRootFromParent_Done,
     /*   34793 */   // Label 610: @34793
     /*   34793 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34848), // Rule ID 46629 //
     /*   34798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34826 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34846 */     GIR_RootConstrainSelectedInstOperands,
     /*   34847 */     // GIR_Coverage, 46629,
     /*   34847 */     GIR_EraseRootFromParent_Done,
     /*   34848 */   // Label 611: @34848
     /*   34848 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34901), // Rule ID 46122 //
     /*   34853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34864 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34899 */     GIR_RootConstrainSelectedInstOperands,
     /*   34900 */     // GIR_Coverage, 46122,
     /*   34900 */     GIR_EraseRootFromParent_Done,
     /*   34901 */   // Label 612: @34901
     /*   34901 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34954), // Rule ID 46123 //
     /*   34906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34917 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34952 */     GIR_RootConstrainSelectedInstOperands,
     /*   34953 */     // GIR_Coverage, 46123,
     /*   34953 */     GIR_EraseRootFromParent_Done,
     /*   34954 */   // Label 613: @34954
     /*   34954 */   GIM_Reject,
     /*   34955 */ // Label 573: @34955
     /*   34955 */ GIM_Reject,
     /*   34956 */ // Label 138: @34956
     /*   34956 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38080),
     /*   34961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34971 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35067), // Rule ID 70909 //
     /*   34976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35009 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35028 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35041 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35065 */     GIR_RootConstrainSelectedInstOperands,
     /*   35066 */     // GIR_Coverage, 70909,
     /*   35066 */     GIR_EraseRootFromParent_Done,
     /*   35067 */   // Label 615: @35067
     /*   35067 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35163), // Rule ID 70910 //
     /*   35072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35124 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35137 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35161 */     GIR_RootConstrainSelectedInstOperands,
     /*   35162 */     // GIR_Coverage, 70910,
     /*   35162 */     GIR_EraseRootFromParent_Done,
     /*   35163 */   // Label 616: @35163
     /*   35163 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35259), // Rule ID 71177 //
     /*   35168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35201 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35220 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35222 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35233 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35257 */     GIR_RootConstrainSelectedInstOperands,
     /*   35258 */     // GIR_Coverage, 71177,
     /*   35258 */     GIR_EraseRootFromParent_Done,
     /*   35259 */   // Label 617: @35259
     /*   35259 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35355), // Rule ID 71178 //
     /*   35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35316 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35318 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35329 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35353 */     GIR_RootConstrainSelectedInstOperands,
     /*   35354 */     // GIR_Coverage, 71178,
     /*   35354 */     GIR_EraseRootFromParent_Done,
     /*   35355 */   // Label 618: @35355
     /*   35355 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35451), // Rule ID 71179 //
     /*   35360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35393 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35412 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35414 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35425 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35449 */     GIR_RootConstrainSelectedInstOperands,
     /*   35450 */     // GIR_Coverage, 71179,
     /*   35450 */     GIR_EraseRootFromParent_Done,
     /*   35451 */   // Label 619: @35451
     /*   35451 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35547), // Rule ID 71180 //
     /*   35456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35489 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35508 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35521 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35545 */     GIR_RootConstrainSelectedInstOperands,
     /*   35546 */     // GIR_Coverage, 71180,
     /*   35546 */     GIR_EraseRootFromParent_Done,
     /*   35547 */   // Label 620: @35547
     /*   35547 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35643), // Rule ID 71023 //
     /*   35552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35604 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35606 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35617 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35641 */     GIR_RootConstrainSelectedInstOperands,
     /*   35642 */     // GIR_Coverage, 71023,
     /*   35642 */     GIR_EraseRootFromParent_Done,
     /*   35643 */   // Label 621: @35643
     /*   35643 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35739), // Rule ID 71024 //
     /*   35648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35681 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35696 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35700 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35702 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35713 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35737 */     GIR_RootConstrainSelectedInstOperands,
     /*   35738 */     // GIR_Coverage, 71024,
     /*   35738 */     GIR_EraseRootFromParent_Done,
     /*   35739 */   // Label 622: @35739
     /*   35739 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35835), // Rule ID 52052 //
     /*   35744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35781 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35800 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35809 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35833 */     GIR_RootConstrainSelectedInstOperands,
     /*   35834 */     // GIR_Coverage, 52052,
     /*   35834 */     GIR_EraseRootFromParent_Done,
     /*   35835 */   // Label 623: @35835
     /*   35835 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(35931), // Rule ID 52053 //
     /*   35840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35896 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35905 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35929 */     GIR_RootConstrainSelectedInstOperands,
     /*   35930 */     // GIR_Coverage, 52053,
     /*   35930 */     GIR_EraseRootFromParent_Done,
     /*   35931 */   // Label 624: @35931
     /*   35931 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36027), // Rule ID 52170 //
     /*   35936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35959 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35992 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36001 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36025 */     GIR_RootConstrainSelectedInstOperands,
     /*   36026 */     // GIR_Coverage, 52170,
     /*   36026 */     GIR_EraseRootFromParent_Done,
     /*   36027 */   // Label 625: @36027
     /*   36027 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36123), // Rule ID 52171 //
     /*   36032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36069 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36088 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36097 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36121 */     GIR_RootConstrainSelectedInstOperands,
     /*   36122 */     // GIR_Coverage, 52171,
     /*   36122 */     GIR_EraseRootFromParent_Done,
     /*   36123 */   // Label 626: @36123
     /*   36123 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36219), // Rule ID 71175 //
     /*   36128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36184 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36193 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   36204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   36208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36217 */     GIR_RootConstrainSelectedInstOperands,
     /*   36218 */     // GIR_Coverage, 71175,
     /*   36218 */     GIR_EraseRootFromParent_Done,
     /*   36219 */   // Label 627: @36219
     /*   36219 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36315), // Rule ID 71176 //
     /*   36224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36247 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36280 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36289 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   36292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   36300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   36304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36313 */     GIR_RootConstrainSelectedInstOperands,
     /*   36314 */     // GIR_Coverage, 71176,
     /*   36314 */     GIR_EraseRootFromParent_Done,
     /*   36315 */   // Label 628: @36315
     /*   36315 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36411), // Rule ID 52110 //
     /*   36320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36376 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36378 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36385 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36409 */     GIR_RootConstrainSelectedInstOperands,
     /*   36410 */     // GIR_Coverage, 52110,
     /*   36410 */     GIR_EraseRootFromParent_Done,
     /*   36411 */   // Label 629: @36411
     /*   36411 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36507), // Rule ID 52111 //
     /*   36416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   36445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   36464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36472 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36474 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36481 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36505 */     GIR_RootConstrainSelectedInstOperands,
     /*   36506 */     // GIR_Coverage, 52111,
     /*   36506 */     GIR_EraseRootFromParent_Done,
     /*   36507 */   // Label 630: @36507
     /*   36507 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36596), // Rule ID 46712 //
     /*   36512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36527 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36546 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36555 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36594 */     GIR_RootConstrainSelectedInstOperands,
     /*   36595 */     // GIR_Coverage, 46712,
     /*   36595 */     GIR_EraseRootFromParent_Done,
     /*   36596 */   // Label 631: @36596
     /*   36596 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36685), // Rule ID 46713 //
     /*   36601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36644 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36683 */     GIR_RootConstrainSelectedInstOperands,
     /*   36684 */     // GIR_Coverage, 46713,
     /*   36684 */     GIR_EraseRootFromParent_Done,
     /*   36685 */   // Label 632: @36685
     /*   36685 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36774), // Rule ID 46476 //
     /*   36690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36705 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36724 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36733 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36772 */     GIR_RootConstrainSelectedInstOperands,
     /*   36773 */     // GIR_Coverage, 46476,
     /*   36773 */     GIR_EraseRootFromParent_Done,
     /*   36774 */   // Label 633: @36774
     /*   36774 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36863), // Rule ID 46477 //
     /*   36779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36813 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36822 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36861 */     GIR_RootConstrainSelectedInstOperands,
     /*   36862 */     // GIR_Coverage, 46477,
     /*   36862 */     GIR_EraseRootFromParent_Done,
     /*   36863 */   // Label 634: @36863
     /*   36863 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36952), // Rule ID 46592 //
     /*   36868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36883 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36902 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36911 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36950 */     GIR_RootConstrainSelectedInstOperands,
     /*   36951 */     // GIR_Coverage, 46592,
     /*   36951 */     GIR_EraseRootFromParent_Done,
     /*   36952 */   // Label 635: @36952
     /*   36952 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(37041), // Rule ID 46593 //
     /*   36957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36991 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   37000 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   37000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   37017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   37026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37039 */     GIR_RootConstrainSelectedInstOperands,
     /*   37040 */     // GIR_Coverage, 46593,
     /*   37040 */     GIR_EraseRootFromParent_Done,
     /*   37041 */   // Label 636: @37041
     /*   37041 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(37109), // Rule ID 70803 //
     /*   37046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37083 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37107 */     GIR_RootConstrainSelectedInstOperands,
     /*   37108 */     // GIR_Coverage, 70803,
     /*   37108 */     GIR_EraseRootFromParent_Done,
     /*   37109 */   // Label 637: @37109
     /*   37109 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37177), // Rule ID 70804 //
     /*   37114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37151 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37175 */     GIR_RootConstrainSelectedInstOperands,
     /*   37176 */     // GIR_Coverage, 70804,
     /*   37176 */     GIR_EraseRootFromParent_Done,
     /*   37177 */   // Label 638: @37177
     /*   37177 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37232), // Rule ID 69723 //
     /*   37182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37210 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37230 */     GIR_RootConstrainSelectedInstOperands,
     /*   37231 */     // GIR_Coverage, 69723,
     /*   37231 */     GIR_EraseRootFromParent_Done,
     /*   37232 */   // Label 639: @37232
     /*   37232 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37287), // Rule ID 69724 //
     /*   37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37265 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37285 */     GIR_RootConstrainSelectedInstOperands,
     /*   37286 */     // GIR_Coverage, 69724,
     /*   37286 */     GIR_EraseRootFromParent_Done,
     /*   37287 */   // Label 640: @37287
     /*   37287 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37342), // Rule ID 69543 //
     /*   37292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37320 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37340 */     GIR_RootConstrainSelectedInstOperands,
     /*   37341 */     // GIR_Coverage, 69543,
     /*   37341 */     GIR_EraseRootFromParent_Done,
     /*   37342 */   // Label 641: @37342
     /*   37342 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37397), // Rule ID 69544 //
     /*   37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37362 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37375 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37395 */     GIR_RootConstrainSelectedInstOperands,
     /*   37396 */     // GIR_Coverage, 69544,
     /*   37396 */     GIR_EraseRootFromParent_Done,
     /*   37397 */   // Label 642: @37397
     /*   37397 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37452), // Rule ID 69633 //
     /*   37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37430 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37450 */     GIR_RootConstrainSelectedInstOperands,
     /*   37451 */     // GIR_Coverage, 69633,
     /*   37451 */     GIR_EraseRootFromParent_Done,
     /*   37452 */   // Label 643: @37452
     /*   37452 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37507), // Rule ID 69634 //
     /*   37457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37485 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37505 */     GIR_RootConstrainSelectedInstOperands,
     /*   37506 */     // GIR_Coverage, 69634,
     /*   37506 */     GIR_EraseRootFromParent_Done,
     /*   37507 */   // Label 644: @37507
     /*   37507 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37575), // Rule ID 51926 //
     /*   37512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37549 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37573 */     GIR_RootConstrainSelectedInstOperands,
     /*   37574 */     // GIR_Coverage, 51926,
     /*   37574 */     GIR_EraseRootFromParent_Done,
     /*   37575 */   // Label 645: @37575
     /*   37575 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37643), // Rule ID 51927 //
     /*   37580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37617 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37641 */     GIR_RootConstrainSelectedInstOperands,
     /*   37642 */     // GIR_Coverage, 51927,
     /*   37642 */     GIR_EraseRootFromParent_Done,
     /*   37643 */   // Label 646: @37643
     /*   37643 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37698), // Rule ID 46772 //
     /*   37648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37676 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37696 */     GIR_RootConstrainSelectedInstOperands,
     /*   37697 */     // GIR_Coverage, 46772,
     /*   37697 */     GIR_EraseRootFromParent_Done,
     /*   37698 */   // Label 647: @37698
     /*   37698 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37753), // Rule ID 46773 //
     /*   37703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37731 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37751 */     GIR_RootConstrainSelectedInstOperands,
     /*   37752 */     // GIR_Coverage, 46773,
     /*   37752 */     GIR_EraseRootFromParent_Done,
     /*   37753 */   // Label 648: @37753
     /*   37753 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(37808), // Rule ID 46532 //
     /*   37758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37777 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37786 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37806 */     GIR_RootConstrainSelectedInstOperands,
     /*   37807 */     // GIR_Coverage, 46532,
     /*   37807 */     GIR_EraseRootFromParent_Done,
     /*   37808 */   // Label 649: @37808
     /*   37808 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37863), // Rule ID 46533 //
     /*   37813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37841 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37861 */     GIR_RootConstrainSelectedInstOperands,
     /*   37862 */     // GIR_Coverage, 46533,
     /*   37862 */     GIR_EraseRootFromParent_Done,
     /*   37863 */   // Label 650: @37863
     /*   37863 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37918), // Rule ID 46652 //
     /*   37868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37896 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37916 */     GIR_RootConstrainSelectedInstOperands,
     /*   37917 */     // GIR_Coverage, 46652,
     /*   37917 */     GIR_EraseRootFromParent_Done,
     /*   37918 */   // Label 651: @37918
     /*   37918 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37973), // Rule ID 46653 //
     /*   37923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37951 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37971 */     GIR_RootConstrainSelectedInstOperands,
     /*   37972 */     // GIR_Coverage, 46653,
     /*   37972 */     GIR_EraseRootFromParent_Done,
     /*   37973 */   // Label 652: @37973
     /*   37973 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38026), // Rule ID 46158 //
     /*   37978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37989 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   38006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   38015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38024 */     GIR_RootConstrainSelectedInstOperands,
     /*   38025 */     // GIR_Coverage, 46158,
     /*   38025 */     GIR_EraseRootFromParent_Done,
     /*   38026 */   // Label 653: @38026
     /*   38026 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38079), // Rule ID 46159 //
     /*   38031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38042 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   38042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   38045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   38059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   38066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   38068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38077 */     GIR_RootConstrainSelectedInstOperands,
     /*   38078 */     // GIR_Coverage, 46159,
     /*   38078 */     GIR_EraseRootFromParent_Done,
     /*   38079 */   // Label 654: @38079
     /*   38079 */   GIM_Reject,
     /*   38080 */ // Label 614: @38080
     /*   38080 */ GIM_Reject,
     /*   38081 */ // Label 139: @38081
     /*   38081 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41205),
     /*   38086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38096 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38192), // Rule ID 70919 //
     /*   38101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38153 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38166 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38190 */     GIR_RootConstrainSelectedInstOperands,
     /*   38191 */     // GIR_Coverage, 70919,
     /*   38191 */     GIR_EraseRootFromParent_Done,
     /*   38192 */   // Label 656: @38192
     /*   38192 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38288), // Rule ID 70920 //
     /*   38197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38230 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38249 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38251 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38262 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38286 */     GIR_RootConstrainSelectedInstOperands,
     /*   38287 */     // GIR_Coverage, 70920,
     /*   38287 */     GIR_EraseRootFromParent_Done,
     /*   38288 */   // Label 657: @38288
     /*   38288 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38384), // Rule ID 71207 //
     /*   38293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38326 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38341 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38345 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38358 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38382 */     GIR_RootConstrainSelectedInstOperands,
     /*   38383 */     // GIR_Coverage, 71207,
     /*   38383 */     GIR_EraseRootFromParent_Done,
     /*   38384 */   // Label 658: @38384
     /*   38384 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38480), // Rule ID 71208 //
     /*   38389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38408 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38437 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38441 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38443 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38454 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38478 */     GIR_RootConstrainSelectedInstOperands,
     /*   38479 */     // GIR_Coverage, 71208,
     /*   38479 */     GIR_EraseRootFromParent_Done,
     /*   38480 */   // Label 659: @38480
     /*   38480 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38576), // Rule ID 71209 //
     /*   38485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38504 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38518 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38537 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38550 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38574 */     GIR_RootConstrainSelectedInstOperands,
     /*   38575 */     // GIR_Coverage, 71209,
     /*   38575 */     GIR_EraseRootFromParent_Done,
     /*   38576 */   // Label 660: @38576
     /*   38576 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38672), // Rule ID 71210 //
     /*   38581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38614 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38633 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38635 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38646 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38670 */     GIR_RootConstrainSelectedInstOperands,
     /*   38671 */     // GIR_Coverage, 71210,
     /*   38671 */     GIR_EraseRootFromParent_Done,
     /*   38672 */   // Label 661: @38672
     /*   38672 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38768), // Rule ID 71033 //
     /*   38677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38696 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38729 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38731 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38742 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38766 */     GIR_RootConstrainSelectedInstOperands,
     /*   38767 */     // GIR_Coverage, 71033,
     /*   38767 */     GIR_EraseRootFromParent_Done,
     /*   38768 */   // Label 662: @38768
     /*   38768 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38864), // Rule ID 71034 //
     /*   38773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38806 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38825 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38827 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38838 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38862 */     GIR_RootConstrainSelectedInstOperands,
     /*   38863 */     // GIR_Coverage, 71034,
     /*   38863 */     GIR_EraseRootFromParent_Done,
     /*   38864 */   // Label 663: @38864
     /*   38864 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(38960), // Rule ID 52062 //
     /*   38869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38925 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38934 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38958 */     GIR_RootConstrainSelectedInstOperands,
     /*   38959 */     // GIR_Coverage, 52062,
     /*   38959 */     GIR_EraseRootFromParent_Done,
     /*   38960 */   // Label 664: @38960
     /*   38960 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39056), // Rule ID 52063 //
     /*   38965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39021 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39030 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   39033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39054 */     GIR_RootConstrainSelectedInstOperands,
     /*   39055 */     // GIR_Coverage, 52063,
     /*   39055 */     GIR_EraseRootFromParent_Done,
     /*   39056 */   // Label 665: @39056
     /*   39056 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39152), // Rule ID 52180 //
     /*   39061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39098 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39117 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39126 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39150 */     GIR_RootConstrainSelectedInstOperands,
     /*   39151 */     // GIR_Coverage, 52180,
     /*   39151 */     GIR_EraseRootFromParent_Done,
     /*   39152 */   // Label 666: @39152
     /*   39152 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39248), // Rule ID 52181 //
     /*   39157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39180 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39209 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39213 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39215 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39222 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39246 */     GIR_RootConstrainSelectedInstOperands,
     /*   39247 */     // GIR_Coverage, 52181,
     /*   39247 */     GIR_EraseRootFromParent_Done,
     /*   39248 */   // Label 667: @39248
     /*   39248 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39344), // Rule ID 71205 //
     /*   39253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39290 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39309 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39311 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39318 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   39329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   39333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39342 */     GIR_RootConstrainSelectedInstOperands,
     /*   39343 */     // GIR_Coverage, 71205,
     /*   39343 */     GIR_EraseRootFromParent_Done,
     /*   39344 */   // Label 668: @39344
     /*   39344 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39440), // Rule ID 71206 //
     /*   39349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39405 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39414 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   39417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   39425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   39429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39438 */     GIR_RootConstrainSelectedInstOperands,
     /*   39439 */     // GIR_Coverage, 71206,
     /*   39439 */     GIR_EraseRootFromParent_Done,
     /*   39440 */   // Label 669: @39440
     /*   39440 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39536), // Rule ID 52120 //
     /*   39445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39482 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39501 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39510 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39534 */     GIR_RootConstrainSelectedInstOperands,
     /*   39535 */     // GIR_Coverage, 52120,
     /*   39535 */     GIR_EraseRootFromParent_Done,
     /*   39536 */   // Label 670: @39536
     /*   39536 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39632), // Rule ID 52121 //
     /*   39541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39578 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39597 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39599 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39606 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39630 */     GIR_RootConstrainSelectedInstOperands,
     /*   39631 */     // GIR_Coverage, 52121,
     /*   39631 */     GIR_EraseRootFromParent_Done,
     /*   39632 */   // Label 671: @39632
     /*   39632 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39721), // Rule ID 46732 //
     /*   39637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39652 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39671 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39680 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39719 */     GIR_RootConstrainSelectedInstOperands,
     /*   39720 */     // GIR_Coverage, 46732,
     /*   39720 */     GIR_EraseRootFromParent_Done,
     /*   39721 */   // Label 672: @39721
     /*   39721 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39810), // Rule ID 46733 //
     /*   39726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39760 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39769 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39808 */     GIR_RootConstrainSelectedInstOperands,
     /*   39809 */     // GIR_Coverage, 46733,
     /*   39809 */     GIR_EraseRootFromParent_Done,
     /*   39810 */   // Label 673: @39810
     /*   39810 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39899), // Rule ID 46496 //
     /*   39815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39830 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39849 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39858 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39897 */     GIR_RootConstrainSelectedInstOperands,
     /*   39898 */     // GIR_Coverage, 46496,
     /*   39898 */     GIR_EraseRootFromParent_Done,
     /*   39899 */   // Label 674: @39899
     /*   39899 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39988), // Rule ID 46497 //
     /*   39904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39938 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39947 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39986 */     GIR_RootConstrainSelectedInstOperands,
     /*   39987 */     // GIR_Coverage, 46497,
     /*   39987 */     GIR_EraseRootFromParent_Done,
     /*   39988 */   // Label 675: @39988
     /*   39988 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40077), // Rule ID 46612 //
     /*   39993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40008 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40027 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40036 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   40036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   40053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   40062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40075 */     GIR_RootConstrainSelectedInstOperands,
     /*   40076 */     // GIR_Coverage, 46612,
     /*   40076 */     GIR_EraseRootFromParent_Done,
     /*   40077 */   // Label 676: @40077
     /*   40077 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40166), // Rule ID 46613 //
     /*   40082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40097 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   40108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40116 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   40125 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   40125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   40142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   40151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40164 */     GIR_RootConstrainSelectedInstOperands,
     /*   40165 */     // GIR_Coverage, 46613,
     /*   40165 */     GIR_EraseRootFromParent_Done,
     /*   40166 */   // Label 677: @40166
     /*   40166 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40234), // Rule ID 70835 //
     /*   40171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40208 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40232 */     GIR_RootConstrainSelectedInstOperands,
     /*   40233 */     // GIR_Coverage, 70835,
     /*   40233 */     GIR_EraseRootFromParent_Done,
     /*   40234 */   // Label 678: @40234
     /*   40234 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40302), // Rule ID 70836 //
     /*   40239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40276 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40300 */     GIR_RootConstrainSelectedInstOperands,
     /*   40301 */     // GIR_Coverage, 70836,
     /*   40301 */     GIR_EraseRootFromParent_Done,
     /*   40302 */   // Label 679: @40302
     /*   40302 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40357), // Rule ID 69743 //
     /*   40307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40335 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40355 */     GIR_RootConstrainSelectedInstOperands,
     /*   40356 */     // GIR_Coverage, 69743,
     /*   40356 */     GIR_EraseRootFromParent_Done,
     /*   40357 */   // Label 680: @40357
     /*   40357 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40412), // Rule ID 69744 //
     /*   40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40377 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40390 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40410 */     GIR_RootConstrainSelectedInstOperands,
     /*   40411 */     // GIR_Coverage, 69744,
     /*   40411 */     GIR_EraseRootFromParent_Done,
     /*   40412 */   // Label 681: @40412
     /*   40412 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40467), // Rule ID 69563 //
     /*   40417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40445 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40465 */     GIR_RootConstrainSelectedInstOperands,
     /*   40466 */     // GIR_Coverage, 69563,
     /*   40466 */     GIR_EraseRootFromParent_Done,
     /*   40467 */   // Label 682: @40467
     /*   40467 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40522), // Rule ID 69564 //
     /*   40472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40487 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40500 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40520 */     GIR_RootConstrainSelectedInstOperands,
     /*   40521 */     // GIR_Coverage, 69564,
     /*   40521 */     GIR_EraseRootFromParent_Done,
     /*   40522 */   // Label 683: @40522
     /*   40522 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40577), // Rule ID 69653 //
     /*   40527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40555 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40575 */     GIR_RootConstrainSelectedInstOperands,
     /*   40576 */     // GIR_Coverage, 69653,
     /*   40576 */     GIR_EraseRootFromParent_Done,
     /*   40577 */   // Label 684: @40577
     /*   40577 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40632), // Rule ID 69654 //
     /*   40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40610 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40630 */     GIR_RootConstrainSelectedInstOperands,
     /*   40631 */     // GIR_Coverage, 69654,
     /*   40631 */     GIR_EraseRootFromParent_Done,
     /*   40632 */   // Label 685: @40632
     /*   40632 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40700), // Rule ID 51942 //
     /*   40637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40674 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40698 */     GIR_RootConstrainSelectedInstOperands,
     /*   40699 */     // GIR_Coverage, 51942,
     /*   40699 */     GIR_EraseRootFromParent_Done,
     /*   40700 */   // Label 686: @40700
     /*   40700 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40768), // Rule ID 51943 //
     /*   40705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40742 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40766 */     GIR_RootConstrainSelectedInstOperands,
     /*   40767 */     // GIR_Coverage, 51943,
     /*   40767 */     GIR_EraseRootFromParent_Done,
     /*   40768 */   // Label 687: @40768
     /*   40768 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40823), // Rule ID 46792 //
     /*   40773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40801 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40821 */     GIR_RootConstrainSelectedInstOperands,
     /*   40822 */     // GIR_Coverage, 46792,
     /*   40822 */     GIR_EraseRootFromParent_Done,
     /*   40823 */   // Label 688: @40823
     /*   40823 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40878), // Rule ID 46793 //
     /*   40828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40856 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40876 */     GIR_RootConstrainSelectedInstOperands,
     /*   40877 */     // GIR_Coverage, 46793,
     /*   40877 */     GIR_EraseRootFromParent_Done,
     /*   40878 */   // Label 689: @40878
     /*   40878 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(40933), // Rule ID 46552 //
     /*   40883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40911 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40931 */     GIR_RootConstrainSelectedInstOperands,
     /*   40932 */     // GIR_Coverage, 46552,
     /*   40932 */     GIR_EraseRootFromParent_Done,
     /*   40933 */   // Label 690: @40933
     /*   40933 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40988), // Rule ID 46553 //
     /*   40938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40966 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40986 */     GIR_RootConstrainSelectedInstOperands,
     /*   40987 */     // GIR_Coverage, 46553,
     /*   40987 */     GIR_EraseRootFromParent_Done,
     /*   40988 */   // Label 691: @40988
     /*   40988 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(41043), // Rule ID 46672 //
     /*   40993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   41012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41021 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   41021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   41024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   41038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41041 */     GIR_RootConstrainSelectedInstOperands,
     /*   41042 */     // GIR_Coverage, 46672,
     /*   41042 */     GIR_EraseRootFromParent_Done,
     /*   41043 */   // Label 692: @41043
     /*   41043 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(41098), // Rule ID 46673 //
     /*   41048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   41051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   41067 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41076 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   41076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   41079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   41093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41096 */     GIR_RootConstrainSelectedInstOperands,
     /*   41097 */     // GIR_Coverage, 46673,
     /*   41097 */     GIR_EraseRootFromParent_Done,
     /*   41098 */   // Label 693: @41098
     /*   41098 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41151), // Rule ID 46174 //
     /*   41103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   41106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41114 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   41114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   41117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   41131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   41146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41149 */     GIR_RootConstrainSelectedInstOperands,
     /*   41150 */     // GIR_Coverage, 46174,
     /*   41150 */     GIR_EraseRootFromParent_Done,
     /*   41151 */   // Label 694: @41151
     /*   41151 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41204), // Rule ID 46175 //
     /*   41156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   41159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41167 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   41167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   41170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   41184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   41199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41202 */     GIR_RootConstrainSelectedInstOperands,
     /*   41203 */     // GIR_Coverage, 46175,
     /*   41203 */     GIR_EraseRootFromParent_Done,
     /*   41204 */   // Label 695: @41204
     /*   41204 */   GIM_Reject,
     /*   41205 */ // Label 655: @41205
     /*   41205 */ GIM_Reject,
     /*   41206 */ // Label 140: @41206
     /*   41206 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41600),
     /*   41211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41221 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(41289), // Rule ID 70723 //
     /*   41226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41263 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41287 */     GIR_RootConstrainSelectedInstOperands,
     /*   41288 */     // GIR_Coverage, 70723,
     /*   41288 */     GIR_EraseRootFromParent_Done,
     /*   41289 */   // Label 697: @41289
     /*   41289 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41357), // Rule ID 70724 //
     /*   41294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41313 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41331 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41355 */     GIR_RootConstrainSelectedInstOperands,
     /*   41356 */     // GIR_Coverage, 70724,
     /*   41356 */     GIR_EraseRootFromParent_Done,
     /*   41357 */   // Label 698: @41357
     /*   41357 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41425), // Rule ID 51886 //
     /*   41362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41385 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41399 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41423 */     GIR_RootConstrainSelectedInstOperands,
     /*   41424 */     // GIR_Coverage, 51886,
     /*   41424 */     GIR_EraseRootFromParent_Done,
     /*   41425 */   // Label 699: @41425
     /*   41425 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41493), // Rule ID 51887 //
     /*   41430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   41453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41467 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41491 */     GIR_RootConstrainSelectedInstOperands,
     /*   41492 */     // GIR_Coverage, 51887,
     /*   41492 */     GIR_EraseRootFromParent_Done,
     /*   41493 */   // Label 700: @41493
     /*   41493 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41546), // Rule ID 46118 //
     /*   41498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41509 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41544 */     GIR_RootConstrainSelectedInstOperands,
     /*   41545 */     // GIR_Coverage, 46118,
     /*   41545 */     GIR_EraseRootFromParent_Done,
     /*   41546 */   // Label 701: @41546
     /*   41546 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41599), // Rule ID 46119 //
     /*   41551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41562 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41597 */     GIR_RootConstrainSelectedInstOperands,
     /*   41598 */     // GIR_Coverage, 46119,
     /*   41598 */     GIR_EraseRootFromParent_Done,
     /*   41599 */   // Label 702: @41599
     /*   41599 */   GIM_Reject,
     /*   41600 */ // Label 696: @41600
     /*   41600 */ GIM_Reject,
     /*   41601 */ // Label 141: @41601
     /*   41601 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(44725),
     /*   41606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41616 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41712), // Rule ID 70899 //
     /*   41621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41673 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41686 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41710 */     GIR_RootConstrainSelectedInstOperands,
     /*   41711 */     // GIR_Coverage, 70899,
     /*   41711 */     GIR_EraseRootFromParent_Done,
     /*   41712 */   // Label 704: @41712
     /*   41712 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41808), // Rule ID 70900 //
     /*   41717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41769 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41782 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41806 */     GIR_RootConstrainSelectedInstOperands,
     /*   41807 */     // GIR_Coverage, 70900,
     /*   41807 */     GIR_EraseRootFromParent_Done,
     /*   41808 */   // Label 705: @41808
     /*   41808 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(41904), // Rule ID 71147 //
     /*   41813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41865 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41878 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41902 */     GIR_RootConstrainSelectedInstOperands,
     /*   41903 */     // GIR_Coverage, 71147,
     /*   41903 */     GIR_EraseRootFromParent_Done,
     /*   41904 */   // Label 706: @41904
     /*   41904 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42000), // Rule ID 71148 //
     /*   41909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41957 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41961 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41974 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41998 */     GIR_RootConstrainSelectedInstOperands,
     /*   41999 */     // GIR_Coverage, 71148,
     /*   41999 */     GIR_EraseRootFromParent_Done,
     /*   42000 */   // Label 707: @42000
     /*   42000 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42096), // Rule ID 71149 //
     /*   42005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42038 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42057 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42070 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42094 */     GIR_RootConstrainSelectedInstOperands,
     /*   42095 */     // GIR_Coverage, 71149,
     /*   42095 */     GIR_EraseRootFromParent_Done,
     /*   42096 */   // Label 708: @42096
     /*   42096 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42192), // Rule ID 71150 //
     /*   42101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42153 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42166 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42190 */     GIR_RootConstrainSelectedInstOperands,
     /*   42191 */     // GIR_Coverage, 71150,
     /*   42191 */     GIR_EraseRootFromParent_Done,
     /*   42192 */   // Label 709: @42192
     /*   42192 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42288), // Rule ID 71013 //
     /*   42197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42230 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42249 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42251 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42262 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42286 */     GIR_RootConstrainSelectedInstOperands,
     /*   42287 */     // GIR_Coverage, 71013,
     /*   42287 */     GIR_EraseRootFromParent_Done,
     /*   42288 */   // Label 710: @42288
     /*   42288 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42384), // Rule ID 71014 //
     /*   42293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42326 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42341 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42345 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42358 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   42365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42382 */     GIR_RootConstrainSelectedInstOperands,
     /*   42383 */     // GIR_Coverage, 71014,
     /*   42383 */     GIR_EraseRootFromParent_Done,
     /*   42384 */   // Label 711: @42384
     /*   42384 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42480), // Rule ID 52042 //
     /*   42389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42441 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42445 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42447 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42454 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42478 */     GIR_RootConstrainSelectedInstOperands,
     /*   42479 */     // GIR_Coverage, 52042,
     /*   42479 */     GIR_EraseRootFromParent_Done,
     /*   42480 */   // Label 712: @42480
     /*   42480 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42576), // Rule ID 52043 //
     /*   42485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42508 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42541 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42543 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42550 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42574 */     GIR_RootConstrainSelectedInstOperands,
     /*   42575 */     // GIR_Coverage, 52043,
     /*   42575 */     GIR_EraseRootFromParent_Done,
     /*   42576 */   // Label 713: @42576
     /*   42576 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42672), // Rule ID 52160 //
     /*   42581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42633 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42637 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42646 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42670 */     GIR_RootConstrainSelectedInstOperands,
     /*   42671 */     // GIR_Coverage, 52160,
     /*   42671 */     GIR_EraseRootFromParent_Done,
     /*   42672 */   // Label 714: @42672
     /*   42672 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42768), // Rule ID 52161 //
     /*   42677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42700 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42729 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42733 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42735 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42742 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42766 */     GIR_RootConstrainSelectedInstOperands,
     /*   42767 */     // GIR_Coverage, 52161,
     /*   42767 */     GIR_EraseRootFromParent_Done,
     /*   42768 */   // Label 715: @42768
     /*   42768 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42864), // Rule ID 71145 //
     /*   42773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42810 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42829 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42838 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42862 */     GIR_RootConstrainSelectedInstOperands,
     /*   42863 */     // GIR_Coverage, 71145,
     /*   42863 */     GIR_EraseRootFromParent_Done,
     /*   42864 */   // Label 716: @42864
     /*   42864 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(42960), // Rule ID 71146 //
     /*   42869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42925 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42934 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42958 */     GIR_RootConstrainSelectedInstOperands,
     /*   42959 */     // GIR_Coverage, 71146,
     /*   42959 */     GIR_EraseRootFromParent_Done,
     /*   42960 */   // Label 717: @42960
     /*   42960 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43056), // Rule ID 52100 //
     /*   42965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43021 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43030 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   43033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   43037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43054 */     GIR_RootConstrainSelectedInstOperands,
     /*   43055 */     // GIR_Coverage, 52100,
     /*   43055 */     GIR_EraseRootFromParent_Done,
     /*   43056 */   // Label 718: @43056
     /*   43056 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43152), // Rule ID 52101 //
     /*   43061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43098 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43117 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43119 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43126 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   43129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   43133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43150 */     GIR_RootConstrainSelectedInstOperands,
     /*   43151 */     // GIR_Coverage, 52101,
     /*   43151 */     GIR_EraseRootFromParent_Done,
     /*   43152 */   // Label 719: @43152
     /*   43152 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43241), // Rule ID 46692 //
     /*   43157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43191 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43200 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43239 */     GIR_RootConstrainSelectedInstOperands,
     /*   43240 */     // GIR_Coverage, 46692,
     /*   43240 */     GIR_EraseRootFromParent_Done,
     /*   43241 */   // Label 720: @43241
     /*   43241 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43330), // Rule ID 46693 //
     /*   43246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43280 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43289 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43328 */     GIR_RootConstrainSelectedInstOperands,
     /*   43329 */     // GIR_Coverage, 46693,
     /*   43329 */     GIR_EraseRootFromParent_Done,
     /*   43330 */   // Label 721: @43330
     /*   43330 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43419), // Rule ID 46456 //
     /*   43335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43369 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43378 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43417 */     GIR_RootConstrainSelectedInstOperands,
     /*   43418 */     // GIR_Coverage, 46456,
     /*   43418 */     GIR_EraseRootFromParent_Done,
     /*   43419 */   // Label 722: @43419
     /*   43419 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43508), // Rule ID 46457 //
     /*   43424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43458 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43467 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43506 */     GIR_RootConstrainSelectedInstOperands,
     /*   43507 */     // GIR_Coverage, 46457,
     /*   43507 */     GIR_EraseRootFromParent_Done,
     /*   43508 */   // Label 723: @43508
     /*   43508 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43597), // Rule ID 46572 //
     /*   43513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43528 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43556 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43595 */     GIR_RootConstrainSelectedInstOperands,
     /*   43596 */     // GIR_Coverage, 46572,
     /*   43596 */     GIR_EraseRootFromParent_Done,
     /*   43597 */   // Label 724: @43597
     /*   43597 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43686), // Rule ID 46573 //
     /*   43602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43636 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43645 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43684 */     GIR_RootConstrainSelectedInstOperands,
     /*   43685 */     // GIR_Coverage, 46573,
     /*   43685 */     GIR_EraseRootFromParent_Done,
     /*   43686 */   // Label 725: @43686
     /*   43686 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43754), // Rule ID 70779 //
     /*   43691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43728 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43752 */     GIR_RootConstrainSelectedInstOperands,
     /*   43753 */     // GIR_Coverage, 70779,
     /*   43753 */     GIR_EraseRootFromParent_Done,
     /*   43754 */   // Label 726: @43754
     /*   43754 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43822), // Rule ID 70780 //
     /*   43759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43796 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43820 */     GIR_RootConstrainSelectedInstOperands,
     /*   43821 */     // GIR_Coverage, 70780,
     /*   43821 */     GIR_EraseRootFromParent_Done,
     /*   43822 */   // Label 727: @43822
     /*   43822 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43877), // Rule ID 69703 //
     /*   43827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43855 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43875 */     GIR_RootConstrainSelectedInstOperands,
     /*   43876 */     // GIR_Coverage, 69703,
     /*   43876 */     GIR_EraseRootFromParent_Done,
     /*   43877 */   // Label 728: @43877
     /*   43877 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43932), // Rule ID 69704 //
     /*   43882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43910 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43930 */     GIR_RootConstrainSelectedInstOperands,
     /*   43931 */     // GIR_Coverage, 69704,
     /*   43931 */     GIR_EraseRootFromParent_Done,
     /*   43932 */   // Label 729: @43932
     /*   43932 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43987), // Rule ID 69523 //
     /*   43937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43952 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43965 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43985 */     GIR_RootConstrainSelectedInstOperands,
     /*   43986 */     // GIR_Coverage, 69523,
     /*   43986 */     GIR_EraseRootFromParent_Done,
     /*   43987 */   // Label 730: @43987
     /*   43987 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(44042), // Rule ID 69524 //
     /*   43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44020 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44040 */     GIR_RootConstrainSelectedInstOperands,
     /*   44041 */     // GIR_Coverage, 69524,
     /*   44041 */     GIR_EraseRootFromParent_Done,
     /*   44042 */   // Label 731: @44042
     /*   44042 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(44097), // Rule ID 69613 //
     /*   44047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44075 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44095 */     GIR_RootConstrainSelectedInstOperands,
     /*   44096 */     // GIR_Coverage, 69613,
     /*   44096 */     GIR_EraseRootFromParent_Done,
     /*   44097 */   // Label 732: @44097
     /*   44097 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44152), // Rule ID 69614 //
     /*   44102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44130 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44150 */     GIR_RootConstrainSelectedInstOperands,
     /*   44151 */     // GIR_Coverage, 69614,
     /*   44151 */     GIR_EraseRootFromParent_Done,
     /*   44152 */   // Label 733: @44152
     /*   44152 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44220), // Rule ID 51914 //
     /*   44157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   44180 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44194 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   44197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   44203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44218 */     GIR_RootConstrainSelectedInstOperands,
     /*   44219 */     // GIR_Coverage, 51914,
     /*   44219 */     GIR_EraseRootFromParent_Done,
     /*   44220 */   // Label 734: @44220
     /*   44220 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44288), // Rule ID 51915 //
     /*   44225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   44248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44262 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   44265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   44271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44286 */     GIR_RootConstrainSelectedInstOperands,
     /*   44287 */     // GIR_Coverage, 51915,
     /*   44287 */     GIR_EraseRootFromParent_Done,
     /*   44288 */   // Label 735: @44288
     /*   44288 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44343), // Rule ID 46752 //
     /*   44293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44321 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44341 */     GIR_RootConstrainSelectedInstOperands,
     /*   44342 */     // GIR_Coverage, 46752,
     /*   44342 */     GIR_EraseRootFromParent_Done,
     /*   44343 */   // Label 736: @44343
     /*   44343 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44398), // Rule ID 46753 //
     /*   44348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44376 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44396 */     GIR_RootConstrainSelectedInstOperands,
     /*   44397 */     // GIR_Coverage, 46753,
     /*   44397 */     GIR_EraseRootFromParent_Done,
     /*   44398 */   // Label 737: @44398
     /*   44398 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(44453), // Rule ID 46512 //
     /*   44403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44431 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44451 */     GIR_RootConstrainSelectedInstOperands,
     /*   44452 */     // GIR_Coverage, 46512,
     /*   44452 */     GIR_EraseRootFromParent_Done,
     /*   44453 */   // Label 738: @44453
     /*   44453 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44508), // Rule ID 46513 //
     /*   44458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44486 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44506 */     GIR_RootConstrainSelectedInstOperands,
     /*   44507 */     // GIR_Coverage, 46513,
     /*   44507 */     GIR_EraseRootFromParent_Done,
     /*   44508 */   // Label 739: @44508
     /*   44508 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44563), // Rule ID 46632 //
     /*   44513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44541 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44561 */     GIR_RootConstrainSelectedInstOperands,
     /*   44562 */     // GIR_Coverage, 46632,
     /*   44562 */     GIR_EraseRootFromParent_Done,
     /*   44563 */   // Label 740: @44563
     /*   44563 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44618), // Rule ID 46633 //
     /*   44568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44596 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44616 */     GIR_RootConstrainSelectedInstOperands,
     /*   44617 */     // GIR_Coverage, 46633,
     /*   44617 */     GIR_EraseRootFromParent_Done,
     /*   44618 */   // Label 741: @44618
     /*   44618 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44671), // Rule ID 46146 //
     /*   44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44634 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44669 */     GIR_RootConstrainSelectedInstOperands,
     /*   44670 */     // GIR_Coverage, 46146,
     /*   44670 */     GIR_EraseRootFromParent_Done,
     /*   44671 */   // Label 742: @44671
     /*   44671 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44724), // Rule ID 46147 //
     /*   44676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44687 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44722 */     GIR_RootConstrainSelectedInstOperands,
     /*   44723 */     // GIR_Coverage, 46147,
     /*   44723 */     GIR_EraseRootFromParent_Done,
     /*   44724 */   // Label 743: @44724
     /*   44724 */   GIM_Reject,
     /*   44725 */ // Label 703: @44725
     /*   44725 */ GIM_Reject,
     /*   44726 */ // Label 142: @44726
     /*   44726 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47850),
     /*   44731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44741 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44837), // Rule ID 70911 //
     /*   44746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44779 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44798 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44800 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44811 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44835 */     GIR_RootConstrainSelectedInstOperands,
     /*   44836 */     // GIR_Coverage, 70911,
     /*   44836 */     GIR_EraseRootFromParent_Done,
     /*   44837 */   // Label 745: @44837
     /*   44837 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(44933), // Rule ID 70912 //
     /*   44842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44875 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44894 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44907 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44931 */     GIR_RootConstrainSelectedInstOperands,
     /*   44932 */     // GIR_Coverage, 70912,
     /*   44932 */     GIR_EraseRootFromParent_Done,
     /*   44933 */   // Label 746: @44933
     /*   44933 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45029), // Rule ID 71183 //
     /*   44938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44971 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44990 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44992 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45003 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45027 */     GIR_RootConstrainSelectedInstOperands,
     /*   45028 */     // GIR_Coverage, 71183,
     /*   45028 */     GIR_EraseRootFromParent_Done,
     /*   45029 */   // Label 747: @45029
     /*   45029 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45125), // Rule ID 71184 //
     /*   45034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45067 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45086 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45088 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45099 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45123 */     GIR_RootConstrainSelectedInstOperands,
     /*   45124 */     // GIR_Coverage, 71184,
     /*   45124 */     GIR_EraseRootFromParent_Done,
     /*   45125 */   // Label 748: @45125
     /*   45125 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45221), // Rule ID 71185 //
     /*   45130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45182 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45184 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45195 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45219 */     GIR_RootConstrainSelectedInstOperands,
     /*   45220 */     // GIR_Coverage, 71185,
     /*   45220 */     GIR_EraseRootFromParent_Done,
     /*   45221 */   // Label 749: @45221
     /*   45221 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45317), // Rule ID 71186 //
     /*   45226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45259 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45278 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45280 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45291 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45315 */     GIR_RootConstrainSelectedInstOperands,
     /*   45316 */     // GIR_Coverage, 71186,
     /*   45316 */     GIR_EraseRootFromParent_Done,
     /*   45317 */   // Label 750: @45317
     /*   45317 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45413), // Rule ID 71025 //
     /*   45322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45355 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45370 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45374 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45376 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45387 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45411 */     GIR_RootConstrainSelectedInstOperands,
     /*   45412 */     // GIR_Coverage, 71025,
     /*   45412 */     GIR_EraseRootFromParent_Done,
     /*   45413 */   // Label 751: @45413
     /*   45413 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45509), // Rule ID 71026 //
     /*   45418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45470 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45472 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45483 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45507 */     GIR_RootConstrainSelectedInstOperands,
     /*   45508 */     // GIR_Coverage, 71026,
     /*   45508 */     GIR_EraseRootFromParent_Done,
     /*   45509 */   // Label 752: @45509
     /*   45509 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45605), // Rule ID 52054 //
     /*   45514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45551 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45570 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45572 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45579 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45603 */     GIR_RootConstrainSelectedInstOperands,
     /*   45604 */     // GIR_Coverage, 52054,
     /*   45604 */     GIR_EraseRootFromParent_Done,
     /*   45605 */   // Label 753: @45605
     /*   45605 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45701), // Rule ID 52055 //
     /*   45610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45666 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45668 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45675 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45699 */     GIR_RootConstrainSelectedInstOperands,
     /*   45700 */     // GIR_Coverage, 52055,
     /*   45700 */     GIR_EraseRootFromParent_Done,
     /*   45701 */   // Label 754: @45701
     /*   45701 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45797), // Rule ID 52172 //
     /*   45706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45758 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45762 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45771 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45795 */     GIR_RootConstrainSelectedInstOperands,
     /*   45796 */     // GIR_Coverage, 52172,
     /*   45796 */     GIR_EraseRootFromParent_Done,
     /*   45797 */   // Label 755: @45797
     /*   45797 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(45893), // Rule ID 52173 //
     /*   45802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45825 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45839 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45858 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45860 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45867 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45891 */     GIR_RootConstrainSelectedInstOperands,
     /*   45892 */     // GIR_Coverage, 52173,
     /*   45892 */     GIR_EraseRootFromParent_Done,
     /*   45893 */   // Label 756: @45893
     /*   45893 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(45989), // Rule ID 71181 //
     /*   45898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45954 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45956 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45963 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45987 */     GIR_RootConstrainSelectedInstOperands,
     /*   45988 */     // GIR_Coverage, 71181,
     /*   45988 */     GIR_EraseRootFromParent_Done,
     /*   45989 */   // Label 757: @45989
     /*   45989 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46085), // Rule ID 71182 //
     /*   45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46031 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46046 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46050 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46052 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46059 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   46062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   46070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   46074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46083 */     GIR_RootConstrainSelectedInstOperands,
     /*   46084 */     // GIR_Coverage, 71182,
     /*   46084 */     GIR_EraseRootFromParent_Done,
     /*   46085 */   // Label 758: @46085
     /*   46085 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46181), // Rule ID 52112 //
     /*   46090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46127 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46146 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46148 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46155 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   46158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46179 */     GIR_RootConstrainSelectedInstOperands,
     /*   46180 */     // GIR_Coverage, 52112,
     /*   46180 */     GIR_EraseRootFromParent_Done,
     /*   46181 */   // Label 759: @46181
     /*   46181 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46277), // Rule ID 52113 //
     /*   46186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46209 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46223 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46242 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46244 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46251 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   46254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   46258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46275 */     GIR_RootConstrainSelectedInstOperands,
     /*   46276 */     // GIR_Coverage, 52113,
     /*   46276 */     GIR_EraseRootFromParent_Done,
     /*   46277 */   // Label 760: @46277
     /*   46277 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46366), // Rule ID 46716 //
     /*   46282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46325 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46364 */     GIR_RootConstrainSelectedInstOperands,
     /*   46365 */     // GIR_Coverage, 46716,
     /*   46365 */     GIR_EraseRootFromParent_Done,
     /*   46366 */   // Label 761: @46366
     /*   46366 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46455), // Rule ID 46717 //
     /*   46371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46414 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46453 */     GIR_RootConstrainSelectedInstOperands,
     /*   46454 */     // GIR_Coverage, 46717,
     /*   46454 */     GIR_EraseRootFromParent_Done,
     /*   46455 */   // Label 762: @46455
     /*   46455 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46544), // Rule ID 46480 //
     /*   46460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46503 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46542 */     GIR_RootConstrainSelectedInstOperands,
     /*   46543 */     // GIR_Coverage, 46480,
     /*   46543 */     GIR_EraseRootFromParent_Done,
     /*   46544 */   // Label 763: @46544
     /*   46544 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46633), // Rule ID 46481 //
     /*   46549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46592 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46631 */     GIR_RootConstrainSelectedInstOperands,
     /*   46632 */     // GIR_Coverage, 46481,
     /*   46632 */     GIR_EraseRootFromParent_Done,
     /*   46633 */   // Label 764: @46633
     /*   46633 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46722), // Rule ID 46596 //
     /*   46638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46681 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46720 */     GIR_RootConstrainSelectedInstOperands,
     /*   46721 */     // GIR_Coverage, 46596,
     /*   46721 */     GIR_EraseRootFromParent_Done,
     /*   46722 */   // Label 765: @46722
     /*   46722 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46811), // Rule ID 46597 //
     /*   46727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46770 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46809 */     GIR_RootConstrainSelectedInstOperands,
     /*   46810 */     // GIR_Coverage, 46597,
     /*   46810 */     GIR_EraseRootFromParent_Done,
     /*   46811 */   // Label 766: @46811
     /*   46811 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46879), // Rule ID 70811 //
     /*   46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46853 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46877 */     GIR_RootConstrainSelectedInstOperands,
     /*   46878 */     // GIR_Coverage, 70811,
     /*   46878 */     GIR_EraseRootFromParent_Done,
     /*   46879 */   // Label 767: @46879
     /*   46879 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46947), // Rule ID 70812 //
     /*   46884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46903 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46921 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46945 */     GIR_RootConstrainSelectedInstOperands,
     /*   46946 */     // GIR_Coverage, 70812,
     /*   46946 */     GIR_EraseRootFromParent_Done,
     /*   46947 */   // Label 768: @46947
     /*   46947 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(47002), // Rule ID 69727 //
     /*   46952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46967 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46980 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47000 */     GIR_RootConstrainSelectedInstOperands,
     /*   47001 */     // GIR_Coverage, 69727,
     /*   47001 */     GIR_EraseRootFromParent_Done,
     /*   47002 */   // Label 769: @47002
     /*   47002 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(47057), // Rule ID 69728 //
     /*   47007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47035 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47055 */     GIR_RootConstrainSelectedInstOperands,
     /*   47056 */     // GIR_Coverage, 69728,
     /*   47056 */     GIR_EraseRootFromParent_Done,
     /*   47057 */   // Label 770: @47057
     /*   47057 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47112), // Rule ID 69547 //
     /*   47062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47090 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47110 */     GIR_RootConstrainSelectedInstOperands,
     /*   47111 */     // GIR_Coverage, 69547,
     /*   47111 */     GIR_EraseRootFromParent_Done,
     /*   47112 */   // Label 771: @47112
     /*   47112 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47167), // Rule ID 69548 //
     /*   47117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47145 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47165 */     GIR_RootConstrainSelectedInstOperands,
     /*   47166 */     // GIR_Coverage, 69548,
     /*   47166 */     GIR_EraseRootFromParent_Done,
     /*   47167 */   // Label 772: @47167
     /*   47167 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47222), // Rule ID 69637 //
     /*   47172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47200 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47220 */     GIR_RootConstrainSelectedInstOperands,
     /*   47221 */     // GIR_Coverage, 69637,
     /*   47221 */     GIR_EraseRootFromParent_Done,
     /*   47222 */   // Label 773: @47222
     /*   47222 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47277), // Rule ID 69638 //
     /*   47227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47255 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47275 */     GIR_RootConstrainSelectedInstOperands,
     /*   47276 */     // GIR_Coverage, 69638,
     /*   47276 */     GIR_EraseRootFromParent_Done,
     /*   47277 */   // Label 774: @47277
     /*   47277 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47345), // Rule ID 51930 //
     /*   47282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   47305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47319 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   47322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   47328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47343 */     GIR_RootConstrainSelectedInstOperands,
     /*   47344 */     // GIR_Coverage, 51930,
     /*   47344 */     GIR_EraseRootFromParent_Done,
     /*   47345 */   // Label 775: @47345
     /*   47345 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47413), // Rule ID 51931 //
     /*   47350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   47373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47387 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   47390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   47396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47411 */     GIR_RootConstrainSelectedInstOperands,
     /*   47412 */     // GIR_Coverage, 51931,
     /*   47412 */     GIR_EraseRootFromParent_Done,
     /*   47413 */   // Label 776: @47413
     /*   47413 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47468), // Rule ID 46776 //
     /*   47418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47446 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47466 */     GIR_RootConstrainSelectedInstOperands,
     /*   47467 */     // GIR_Coverage, 46776,
     /*   47467 */     GIR_EraseRootFromParent_Done,
     /*   47468 */   // Label 777: @47468
     /*   47468 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47523), // Rule ID 46777 //
     /*   47473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47501 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47521 */     GIR_RootConstrainSelectedInstOperands,
     /*   47522 */     // GIR_Coverage, 46777,
     /*   47522 */     GIR_EraseRootFromParent_Done,
     /*   47523 */   // Label 778: @47523
     /*   47523 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(47578), // Rule ID 46536 //
     /*   47528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47556 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47576 */     GIR_RootConstrainSelectedInstOperands,
     /*   47577 */     // GIR_Coverage, 46536,
     /*   47577 */     GIR_EraseRootFromParent_Done,
     /*   47578 */   // Label 779: @47578
     /*   47578 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47633), // Rule ID 46537 //
     /*   47583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47611 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47631 */     GIR_RootConstrainSelectedInstOperands,
     /*   47632 */     // GIR_Coverage, 46537,
     /*   47632 */     GIR_EraseRootFromParent_Done,
     /*   47633 */   // Label 780: @47633
     /*   47633 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47688), // Rule ID 46656 //
     /*   47638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47666 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47686 */     GIR_RootConstrainSelectedInstOperands,
     /*   47687 */     // GIR_Coverage, 46656,
     /*   47687 */     GIR_EraseRootFromParent_Done,
     /*   47688 */   // Label 781: @47688
     /*   47688 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47743), // Rule ID 46657 //
     /*   47693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47721 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47741 */     GIR_RootConstrainSelectedInstOperands,
     /*   47742 */     // GIR_Coverage, 46657,
     /*   47742 */     GIR_EraseRootFromParent_Done,
     /*   47743 */   // Label 782: @47743
     /*   47743 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47796), // Rule ID 46162 //
     /*   47748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47759 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47794 */     GIR_RootConstrainSelectedInstOperands,
     /*   47795 */     // GIR_Coverage, 46162,
     /*   47795 */     GIR_EraseRootFromParent_Done,
     /*   47796 */   // Label 783: @47796
     /*   47796 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47849), // Rule ID 46163 //
     /*   47801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47812 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47847 */     GIR_RootConstrainSelectedInstOperands,
     /*   47848 */     // GIR_Coverage, 46163,
     /*   47848 */     GIR_EraseRootFromParent_Done,
     /*   47849 */   // Label 784: @47849
     /*   47849 */   GIM_Reject,
     /*   47850 */ // Label 744: @47850
     /*   47850 */ GIM_Reject,
     /*   47851 */ // Label 143: @47851
     /*   47851 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(50975),
     /*   47856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47866 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(47962), // Rule ID 70921 //
     /*   47871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47904 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47923 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47925 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47936 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47960 */     GIR_RootConstrainSelectedInstOperands,
     /*   47961 */     // GIR_Coverage, 70921,
     /*   47961 */     GIR_EraseRootFromParent_Done,
     /*   47962 */   // Label 786: @47962
     /*   47962 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48058), // Rule ID 70922 //
     /*   47967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48000 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48019 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48032 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48056 */     GIR_RootConstrainSelectedInstOperands,
     /*   48057 */     // GIR_Coverage, 70922,
     /*   48057 */     GIR_EraseRootFromParent_Done,
     /*   48058 */   // Label 787: @48058
     /*   48058 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48154), // Rule ID 71213 //
     /*   48063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48115 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48117 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48128 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48152 */     GIR_RootConstrainSelectedInstOperands,
     /*   48153 */     // GIR_Coverage, 71213,
     /*   48153 */     GIR_EraseRootFromParent_Done,
     /*   48154 */   // Label 788: @48154
     /*   48154 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48250), // Rule ID 71214 //
     /*   48159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48178 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48192 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48211 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48224 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48248 */     GIR_RootConstrainSelectedInstOperands,
     /*   48249 */     // GIR_Coverage, 71214,
     /*   48249 */     GIR_EraseRootFromParent_Done,
     /*   48250 */   // Label 789: @48250
     /*   48250 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48346), // Rule ID 71215 //
     /*   48255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48288 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48303 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48307 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48309 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48320 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48344 */     GIR_RootConstrainSelectedInstOperands,
     /*   48345 */     // GIR_Coverage, 71215,
     /*   48345 */     GIR_EraseRootFromParent_Done,
     /*   48346 */   // Label 790: @48346
     /*   48346 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48442), // Rule ID 71216 //
     /*   48351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48384 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48403 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48405 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48416 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48440 */     GIR_RootConstrainSelectedInstOperands,
     /*   48441 */     // GIR_Coverage, 71216,
     /*   48441 */     GIR_EraseRootFromParent_Done,
     /*   48442 */   // Label 791: @48442
     /*   48442 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48538), // Rule ID 71035 //
     /*   48447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48499 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48501 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48512 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48536 */     GIR_RootConstrainSelectedInstOperands,
     /*   48537 */     // GIR_Coverage, 71035,
     /*   48537 */     GIR_EraseRootFromParent_Done,
     /*   48538 */   // Label 792: @48538
     /*   48538 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48634), // Rule ID 71036 //
     /*   48543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48576 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48591 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48595 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48597 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48608 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48632 */     GIR_RootConstrainSelectedInstOperands,
     /*   48633 */     // GIR_Coverage, 71036,
     /*   48633 */     GIR_EraseRootFromParent_Done,
     /*   48634 */   // Label 793: @48634
     /*   48634 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48730), // Rule ID 52064 //
     /*   48639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48695 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48697 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48704 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48728 */     GIR_RootConstrainSelectedInstOperands,
     /*   48729 */     // GIR_Coverage, 52064,
     /*   48729 */     GIR_EraseRootFromParent_Done,
     /*   48730 */   // Label 794: @48730
     /*   48730 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48826), // Rule ID 52065 //
     /*   48735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48772 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48791 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48793 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48800 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48824 */     GIR_RootConstrainSelectedInstOperands,
     /*   48825 */     // GIR_Coverage, 52065,
     /*   48825 */     GIR_EraseRootFromParent_Done,
     /*   48826 */   // Label 795: @48826
     /*   48826 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(48922), // Rule ID 52182 //
     /*   48831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48868 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48883 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48887 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48889 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48896 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48920 */     GIR_RootConstrainSelectedInstOperands,
     /*   48921 */     // GIR_Coverage, 52182,
     /*   48921 */     GIR_EraseRootFromParent_Done,
     /*   48922 */   // Label 796: @48922
     /*   48922 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49018), // Rule ID 52183 //
     /*   48927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48964 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48983 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48985 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48992 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49016 */     GIR_RootConstrainSelectedInstOperands,
     /*   49017 */     // GIR_Coverage, 52183,
     /*   49017 */     GIR_EraseRootFromParent_Done,
     /*   49018 */   // Label 797: @49018
     /*   49018 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49114), // Rule ID 71211 //
     /*   49023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49046 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49060 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49075 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49079 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49081 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49088 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   49099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   49103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49112 */     GIR_RootConstrainSelectedInstOperands,
     /*   49113 */     // GIR_Coverage, 71211,
     /*   49113 */     GIR_EraseRootFromParent_Done,
     /*   49114 */   // Label 798: @49114
     /*   49114 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49210), // Rule ID 71212 //
     /*   49119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49156 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49175 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49177 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49184 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   49187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   49195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   49199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49208 */     GIR_RootConstrainSelectedInstOperands,
     /*   49209 */     // GIR_Coverage, 71212,
     /*   49209 */     GIR_EraseRootFromParent_Done,
     /*   49210 */   // Label 799: @49210
     /*   49210 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49306), // Rule ID 52122 //
     /*   49215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49238 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49271 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49273 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49280 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   49283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49304 */     GIR_RootConstrainSelectedInstOperands,
     /*   49305 */     // GIR_Coverage, 52122,
     /*   49305 */     GIR_EraseRootFromParent_Done,
     /*   49306 */   // Label 800: @49306
     /*   49306 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49402), // Rule ID 52123 //
     /*   49311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49348 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49363 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49367 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49369 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   49376 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   49379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   49383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   49391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49400 */     GIR_RootConstrainSelectedInstOperands,
     /*   49401 */     // GIR_Coverage, 52123,
     /*   49401 */     GIR_EraseRootFromParent_Done,
     /*   49402 */   // Label 801: @49402
     /*   49402 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49491), // Rule ID 46736 //
     /*   49407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49450 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49489 */     GIR_RootConstrainSelectedInstOperands,
     /*   49490 */     // GIR_Coverage, 46736,
     /*   49490 */     GIR_EraseRootFromParent_Done,
     /*   49491 */   // Label 802: @49491
     /*   49491 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49580), // Rule ID 46737 //
     /*   49496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49539 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49578 */     GIR_RootConstrainSelectedInstOperands,
     /*   49579 */     // GIR_Coverage, 46737,
     /*   49579 */     GIR_EraseRootFromParent_Done,
     /*   49580 */   // Label 803: @49580
     /*   49580 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49669), // Rule ID 46500 //
     /*   49585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49628 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49667 */     GIR_RootConstrainSelectedInstOperands,
     /*   49668 */     // GIR_Coverage, 46500,
     /*   49668 */     GIR_EraseRootFromParent_Done,
     /*   49669 */   // Label 804: @49669
     /*   49669 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49758), // Rule ID 46501 //
     /*   49674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49717 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49756 */     GIR_RootConstrainSelectedInstOperands,
     /*   49757 */     // GIR_Coverage, 46501,
     /*   49757 */     GIR_EraseRootFromParent_Done,
     /*   49758 */   // Label 805: @49758
     /*   49758 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49847), // Rule ID 46616 //
     /*   49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49806 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49845 */     GIR_RootConstrainSelectedInstOperands,
     /*   49846 */     // GIR_Coverage, 46616,
     /*   49846 */     GIR_EraseRootFromParent_Done,
     /*   49847 */   // Label 806: @49847
     /*   49847 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49936), // Rule ID 46617 //
     /*   49852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49895 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49934 */     GIR_RootConstrainSelectedInstOperands,
     /*   49935 */     // GIR_Coverage, 46617,
     /*   49935 */     GIR_EraseRootFromParent_Done,
     /*   49936 */   // Label 807: @49936
     /*   49936 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(50004), // Rule ID 70843 //
     /*   49941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49978 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50002 */     GIR_RootConstrainSelectedInstOperands,
     /*   50003 */     // GIR_Coverage, 70843,
     /*   50003 */     GIR_EraseRootFromParent_Done,
     /*   50004 */   // Label 808: @50004
     /*   50004 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(50072), // Rule ID 70844 //
     /*   50009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50046 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50070 */     GIR_RootConstrainSelectedInstOperands,
     /*   50071 */     // GIR_Coverage, 70844,
     /*   50071 */     GIR_EraseRootFromParent_Done,
     /*   50072 */   // Label 809: @50072
     /*   50072 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50127), // Rule ID 69747 //
     /*   50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50092 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50105 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50125 */     GIR_RootConstrainSelectedInstOperands,
     /*   50126 */     // GIR_Coverage, 69747,
     /*   50126 */     GIR_EraseRootFromParent_Done,
     /*   50127 */   // Label 810: @50127
     /*   50127 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50182), // Rule ID 69748 //
     /*   50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50160 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50180 */     GIR_RootConstrainSelectedInstOperands,
     /*   50181 */     // GIR_Coverage, 69748,
     /*   50181 */     GIR_EraseRootFromParent_Done,
     /*   50182 */   // Label 811: @50182
     /*   50182 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50237), // Rule ID 69567 //
     /*   50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50215 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50235 */     GIR_RootConstrainSelectedInstOperands,
     /*   50236 */     // GIR_Coverage, 69567,
     /*   50236 */     GIR_EraseRootFromParent_Done,
     /*   50237 */   // Label 812: @50237
     /*   50237 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50292), // Rule ID 69568 //
     /*   50242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50270 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50290 */     GIR_RootConstrainSelectedInstOperands,
     /*   50291 */     // GIR_Coverage, 69568,
     /*   50291 */     GIR_EraseRootFromParent_Done,
     /*   50292 */   // Label 813: @50292
     /*   50292 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50347), // Rule ID 69657 //
     /*   50297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50325 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50345 */     GIR_RootConstrainSelectedInstOperands,
     /*   50346 */     // GIR_Coverage, 69657,
     /*   50346 */     GIR_EraseRootFromParent_Done,
     /*   50347 */   // Label 814: @50347
     /*   50347 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50402), // Rule ID 69658 //
     /*   50352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50380 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50400 */     GIR_RootConstrainSelectedInstOperands,
     /*   50401 */     // GIR_Coverage, 69658,
     /*   50401 */     GIR_EraseRootFromParent_Done,
     /*   50402 */   // Label 815: @50402
     /*   50402 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50470), // Rule ID 51946 //
     /*   50407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50444 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   50444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50468 */     GIR_RootConstrainSelectedInstOperands,
     /*   50469 */     // GIR_Coverage, 51946,
     /*   50469 */     GIR_EraseRootFromParent_Done,
     /*   50470 */   // Label 816: @50470
     /*   50470 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50538), // Rule ID 51947 //
     /*   50475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50512 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50536 */     GIR_RootConstrainSelectedInstOperands,
     /*   50537 */     // GIR_Coverage, 51947,
     /*   50537 */     GIR_EraseRootFromParent_Done,
     /*   50538 */   // Label 817: @50538
     /*   50538 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50593), // Rule ID 46796 //
     /*   50543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50571 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50591 */     GIR_RootConstrainSelectedInstOperands,
     /*   50592 */     // GIR_Coverage, 46796,
     /*   50592 */     GIR_EraseRootFromParent_Done,
     /*   50593 */   // Label 818: @50593
     /*   50593 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50648), // Rule ID 46797 //
     /*   50598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50626 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50646 */     GIR_RootConstrainSelectedInstOperands,
     /*   50647 */     // GIR_Coverage, 46797,
     /*   50647 */     GIR_EraseRootFromParent_Done,
     /*   50648 */   // Label 819: @50648
     /*   50648 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50703), // Rule ID 46556 //
     /*   50653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50681 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50701 */     GIR_RootConstrainSelectedInstOperands,
     /*   50702 */     // GIR_Coverage, 46556,
     /*   50702 */     GIR_EraseRootFromParent_Done,
     /*   50703 */   // Label 820: @50703
     /*   50703 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50758), // Rule ID 46557 //
     /*   50708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50736 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50756 */     GIR_RootConstrainSelectedInstOperands,
     /*   50757 */     // GIR_Coverage, 46557,
     /*   50757 */     GIR_EraseRootFromParent_Done,
     /*   50758 */   // Label 821: @50758
     /*   50758 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50813), // Rule ID 46676 //
     /*   50763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50791 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50811 */     GIR_RootConstrainSelectedInstOperands,
     /*   50812 */     // GIR_Coverage, 46676,
     /*   50812 */     GIR_EraseRootFromParent_Done,
     /*   50813 */   // Label 822: @50813
     /*   50813 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50868), // Rule ID 46677 //
     /*   50818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50837 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50846 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50866 */     GIR_RootConstrainSelectedInstOperands,
     /*   50867 */     // GIR_Coverage, 46677,
     /*   50867 */     GIR_EraseRootFromParent_Done,
     /*   50868 */   // Label 823: @50868
     /*   50868 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50921), // Rule ID 46178 //
     /*   50873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50884 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50919 */     GIR_RootConstrainSelectedInstOperands,
     /*   50920 */     // GIR_Coverage, 46178,
     /*   50920 */     GIR_EraseRootFromParent_Done,
     /*   50921 */   // Label 824: @50921
     /*   50921 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50974), // Rule ID 46179 //
     /*   50926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50937 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50972 */     GIR_RootConstrainSelectedInstOperands,
     /*   50973 */     // GIR_Coverage, 46179,
     /*   50973 */     GIR_EraseRootFromParent_Done,
     /*   50974 */   // Label 825: @50974
     /*   50974 */   GIM_Reject,
     /*   50975 */ // Label 785: @50975
     /*   50975 */ GIM_Reject,
     /*   50976 */ // Label 144: @50976
     /*   50976 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(51370),
     /*   50981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50991 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(51059), // Rule ID 70755 //
     /*   50996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51033 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51057 */     GIR_RootConstrainSelectedInstOperands,
     /*   51058 */     // GIR_Coverage, 70755,
     /*   51058 */     GIR_EraseRootFromParent_Done,
     /*   51059 */   // Label 827: @51059
     /*   51059 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51127), // Rule ID 70756 //
     /*   51064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51101 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51125 */     GIR_RootConstrainSelectedInstOperands,
     /*   51126 */     // GIR_Coverage, 70756,
     /*   51126 */     GIR_EraseRootFromParent_Done,
     /*   51127 */   // Label 828: @51127
     /*   51127 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51195), // Rule ID 51902 //
     /*   51132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51155 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51169 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   51184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51193 */     GIR_RootConstrainSelectedInstOperands,
     /*   51194 */     // GIR_Coverage, 51902,
     /*   51194 */     GIR_EraseRootFromParent_Done,
     /*   51195 */   // Label 829: @51195
     /*   51195 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51263), // Rule ID 51903 //
     /*   51200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   51223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   51237 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   51240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   51246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   51250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   51252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51261 */     GIR_RootConstrainSelectedInstOperands,
     /*   51262 */     // GIR_Coverage, 51903,
     /*   51262 */     GIR_EraseRootFromParent_Done,
     /*   51263 */   // Label 830: @51263
     /*   51263 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51316), // Rule ID 46134 //
     /*   51268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51279 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   51279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   51282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   51296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51314 */     GIR_RootConstrainSelectedInstOperands,
     /*   51315 */     // GIR_Coverage, 46134,
     /*   51315 */     GIR_EraseRootFromParent_Done,
     /*   51316 */   // Label 831: @51316
     /*   51316 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51369), // Rule ID 46135 //
     /*   51321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51332 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   51332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   51335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   51349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   51356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   51358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51367 */     GIR_RootConstrainSelectedInstOperands,
     /*   51368 */     // GIR_Coverage, 46135,
     /*   51368 */     GIR_EraseRootFromParent_Done,
     /*   51369 */   // Label 832: @51369
     /*   51369 */   GIM_Reject,
     /*   51370 */ // Label 826: @51370
     /*   51370 */ GIM_Reject,
     /*   51371 */ // Label 145: @51371
     /*   51371 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54495),
     /*   51376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51386 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51482), // Rule ID 70901 //
     /*   51391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51443 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51456 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51480 */     GIR_RootConstrainSelectedInstOperands,
     /*   51481 */     // GIR_Coverage, 70901,
     /*   51481 */     GIR_EraseRootFromParent_Done,
     /*   51482 */   // Label 834: @51482
     /*   51482 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51578), // Rule ID 70902 //
     /*   51487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51539 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51541 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51552 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51576 */     GIR_RootConstrainSelectedInstOperands,
     /*   51577 */     // GIR_Coverage, 70902,
     /*   51577 */     GIR_EraseRootFromParent_Done,
     /*   51578 */   // Label 835: @51578
     /*   51578 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51674), // Rule ID 71153 //
     /*   51583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51616 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51635 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51637 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51648 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51672 */     GIR_RootConstrainSelectedInstOperands,
     /*   51673 */     // GIR_Coverage, 71153,
     /*   51673 */     GIR_EraseRootFromParent_Done,
     /*   51674 */   // Label 836: @51674
     /*   51674 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51770), // Rule ID 71154 //
     /*   51679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51712 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51727 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51731 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51744 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51768 */     GIR_RootConstrainSelectedInstOperands,
     /*   51769 */     // GIR_Coverage, 71154,
     /*   51769 */     GIR_EraseRootFromParent_Done,
     /*   51770 */   // Label 837: @51770
     /*   51770 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51866), // Rule ID 71155 //
     /*   51775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51808 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51827 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51840 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51864 */     GIR_RootConstrainSelectedInstOperands,
     /*   51865 */     // GIR_Coverage, 71155,
     /*   51865 */     GIR_EraseRootFromParent_Done,
     /*   51866 */   // Label 838: @51866
     /*   51866 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(51962), // Rule ID 71156 //
     /*   51871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51904 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51923 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51925 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51936 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51960 */     GIR_RootConstrainSelectedInstOperands,
     /*   51961 */     // GIR_Coverage, 71156,
     /*   51961 */     GIR_EraseRootFromParent_Done,
     /*   51962 */   // Label 839: @51962
     /*   51962 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52058), // Rule ID 71015 //
     /*   51967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52000 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52019 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52032 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   52039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52056 */     GIR_RootConstrainSelectedInstOperands,
     /*   52057 */     // GIR_Coverage, 71015,
     /*   52057 */     GIR_EraseRootFromParent_Done,
     /*   52058 */   // Label 840: @52058
     /*   52058 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52154), // Rule ID 71016 //
     /*   52063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52115 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52117 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52128 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   52135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52152 */     GIR_RootConstrainSelectedInstOperands,
     /*   52153 */     // GIR_Coverage, 71016,
     /*   52153 */     GIR_EraseRootFromParent_Done,
     /*   52154 */   // Label 841: @52154
     /*   52154 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52250), // Rule ID 52044 //
     /*   52159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52211 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52215 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52217 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52224 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   52227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52248 */     GIR_RootConstrainSelectedInstOperands,
     /*   52249 */     // GIR_Coverage, 52044,
     /*   52249 */     GIR_EraseRootFromParent_Done,
     /*   52250 */   // Label 842: @52250
     /*   52250 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52346), // Rule ID 52045 //
     /*   52255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52292 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52311 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52320 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   52323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52344 */     GIR_RootConstrainSelectedInstOperands,
     /*   52345 */     // GIR_Coverage, 52045,
     /*   52345 */     GIR_EraseRootFromParent_Done,
     /*   52346 */   // Label 843: @52346
     /*   52346 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52442), // Rule ID 52162 //
     /*   52351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52388 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52407 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52416 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52440 */     GIR_RootConstrainSelectedInstOperands,
     /*   52441 */     // GIR_Coverage, 52162,
     /*   52441 */     GIR_EraseRootFromParent_Done,
     /*   52442 */   // Label 844: @52442
     /*   52442 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52538), // Rule ID 52163 //
     /*   52447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52470 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52499 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52503 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52512 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52536 */     GIR_RootConstrainSelectedInstOperands,
     /*   52537 */     // GIR_Coverage, 52163,
     /*   52537 */     GIR_EraseRootFromParent_Done,
     /*   52538 */   // Label 845: @52538
     /*   52538 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52634), // Rule ID 71151 //
     /*   52543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52580 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52599 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52601 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52608 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52632 */     GIR_RootConstrainSelectedInstOperands,
     /*   52633 */     // GIR_Coverage, 71151,
     /*   52633 */     GIR_EraseRootFromParent_Done,
     /*   52634 */   // Label 846: @52634
     /*   52634 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52730), // Rule ID 71152 //
     /*   52639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52695 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52697 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52704 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52728 */     GIR_RootConstrainSelectedInstOperands,
     /*   52729 */     // GIR_Coverage, 71152,
     /*   52729 */     GIR_EraseRootFromParent_Done,
     /*   52730 */   // Label 847: @52730
     /*   52730 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52826), // Rule ID 52102 //
     /*   52735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52772 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52791 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52793 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52800 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52824 */     GIR_RootConstrainSelectedInstOperands,
     /*   52825 */     // GIR_Coverage, 52102,
     /*   52825 */     GIR_EraseRootFromParent_Done,
     /*   52826 */   // Label 848: @52826
     /*   52826 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52922), // Rule ID 52103 //
     /*   52831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52868 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52883 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52887 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52889 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52896 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52920 */     GIR_RootConstrainSelectedInstOperands,
     /*   52921 */     // GIR_Coverage, 52103,
     /*   52921 */     GIR_EraseRootFromParent_Done,
     /*   52922 */   // Label 849: @52922
     /*   52922 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53011), // Rule ID 46696 //
     /*   52927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52961 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52970 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53009 */     GIR_RootConstrainSelectedInstOperands,
     /*   53010 */     // GIR_Coverage, 46696,
     /*   53010 */     GIR_EraseRootFromParent_Done,
     /*   53011 */   // Label 850: @53011
     /*   53011 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53100), // Rule ID 46697 //
     /*   53016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53050 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53059 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53098 */     GIR_RootConstrainSelectedInstOperands,
     /*   53099 */     // GIR_Coverage, 46697,
     /*   53099 */     GIR_EraseRootFromParent_Done,
     /*   53100 */   // Label 851: @53100
     /*   53100 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53189), // Rule ID 46460 //
     /*   53105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53139 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53148 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   53165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53187 */     GIR_RootConstrainSelectedInstOperands,
     /*   53188 */     // GIR_Coverage, 46460,
     /*   53188 */     GIR_EraseRootFromParent_Done,
     /*   53189 */   // Label 852: @53189
     /*   53189 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53278), // Rule ID 46461 //
     /*   53194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53209 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53228 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53237 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   53254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53276 */     GIR_RootConstrainSelectedInstOperands,
     /*   53277 */     // GIR_Coverage, 46461,
     /*   53277 */     GIR_EraseRootFromParent_Done,
     /*   53278 */   // Label 853: @53278
     /*   53278 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53367), // Rule ID 46576 //
     /*   53283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53298 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53326 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53365 */     GIR_RootConstrainSelectedInstOperands,
     /*   53366 */     // GIR_Coverage, 46576,
     /*   53366 */     GIR_EraseRootFromParent_Done,
     /*   53367 */   // Label 854: @53367
     /*   53367 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53456), // Rule ID 46577 //
     /*   53372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53387 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   53398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53406 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   53415 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   53432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   53441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53454 */     GIR_RootConstrainSelectedInstOperands,
     /*   53455 */     // GIR_Coverage, 46577,
     /*   53455 */     GIR_EraseRootFromParent_Done,
     /*   53456 */   // Label 855: @53456
     /*   53456 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53524), // Rule ID 70787 //
     /*   53461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53498 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53522 */     GIR_RootConstrainSelectedInstOperands,
     /*   53523 */     // GIR_Coverage, 70787,
     /*   53523 */     GIR_EraseRootFromParent_Done,
     /*   53524 */   // Label 856: @53524
     /*   53524 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53592), // Rule ID 70788 //
     /*   53529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53566 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53590 */     GIR_RootConstrainSelectedInstOperands,
     /*   53591 */     // GIR_Coverage, 70788,
     /*   53591 */     GIR_EraseRootFromParent_Done,
     /*   53592 */   // Label 857: @53592
     /*   53592 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53647), // Rule ID 69707 //
     /*   53597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53625 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53645 */     GIR_RootConstrainSelectedInstOperands,
     /*   53646 */     // GIR_Coverage, 69707,
     /*   53646 */     GIR_EraseRootFromParent_Done,
     /*   53647 */   // Label 858: @53647
     /*   53647 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53702), // Rule ID 69708 //
     /*   53652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53680 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53700 */     GIR_RootConstrainSelectedInstOperands,
     /*   53701 */     // GIR_Coverage, 69708,
     /*   53701 */     GIR_EraseRootFromParent_Done,
     /*   53702 */   // Label 859: @53702
     /*   53702 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53757), // Rule ID 69527 //
     /*   53707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53735 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53755 */     GIR_RootConstrainSelectedInstOperands,
     /*   53756 */     // GIR_Coverage, 69527,
     /*   53756 */     GIR_EraseRootFromParent_Done,
     /*   53757 */   // Label 860: @53757
     /*   53757 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53812), // Rule ID 69528 //
     /*   53762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53777 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53790 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53810 */     GIR_RootConstrainSelectedInstOperands,
     /*   53811 */     // GIR_Coverage, 69528,
     /*   53811 */     GIR_EraseRootFromParent_Done,
     /*   53812 */   // Label 861: @53812
     /*   53812 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53867), // Rule ID 69617 //
     /*   53817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53845 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53865 */     GIR_RootConstrainSelectedInstOperands,
     /*   53866 */     // GIR_Coverage, 69617,
     /*   53866 */     GIR_EraseRootFromParent_Done,
     /*   53867 */   // Label 862: @53867
     /*   53867 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53922), // Rule ID 69618 //
     /*   53872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53900 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53920 */     GIR_RootConstrainSelectedInstOperands,
     /*   53921 */     // GIR_Coverage, 69618,
     /*   53921 */     GIR_EraseRootFromParent_Done,
     /*   53922 */   // Label 863: @53922
     /*   53922 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53990), // Rule ID 51918 //
     /*   53927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53964 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53988 */     GIR_RootConstrainSelectedInstOperands,
     /*   53989 */     // GIR_Coverage, 51918,
     /*   53989 */     GIR_EraseRootFromParent_Done,
     /*   53990 */   // Label 864: @53990
     /*   53990 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(54058), // Rule ID 51919 //
     /*   53995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   54018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54032 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   54035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   54041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54056 */     GIR_RootConstrainSelectedInstOperands,
     /*   54057 */     // GIR_Coverage, 51919,
     /*   54057 */     GIR_EraseRootFromParent_Done,
     /*   54058 */   // Label 865: @54058
     /*   54058 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(54113), // Rule ID 46756 //
     /*   54063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   54078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54091 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54111 */     GIR_RootConstrainSelectedInstOperands,
     /*   54112 */     // GIR_Coverage, 46756,
     /*   54112 */     GIR_EraseRootFromParent_Done,
     /*   54113 */   // Label 866: @54113
     /*   54113 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54168), // Rule ID 46757 //
     /*   54118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   54133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54146 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54166 */     GIR_RootConstrainSelectedInstOperands,
     /*   54167 */     // GIR_Coverage, 46757,
     /*   54167 */     GIR_EraseRootFromParent_Done,
     /*   54168 */   // Label 867: @54168
     /*   54168 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(54223), // Rule ID 46516 //
     /*   54173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54201 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   54204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54221 */     GIR_RootConstrainSelectedInstOperands,
     /*   54222 */     // GIR_Coverage, 46516,
     /*   54222 */     GIR_EraseRootFromParent_Done,
     /*   54223 */   // Label 868: @54223
     /*   54223 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54278), // Rule ID 46517 //
     /*   54228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54247 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54256 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   54259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54276 */     GIR_RootConstrainSelectedInstOperands,
     /*   54277 */     // GIR_Coverage, 46517,
     /*   54277 */     GIR_EraseRootFromParent_Done,
     /*   54278 */   // Label 869: @54278
     /*   54278 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54333), // Rule ID 46636 //
     /*   54283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54311 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54331 */     GIR_RootConstrainSelectedInstOperands,
     /*   54332 */     // GIR_Coverage, 46636,
     /*   54332 */     GIR_EraseRootFromParent_Done,
     /*   54333 */   // Label 870: @54333
     /*   54333 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54388), // Rule ID 46637 //
     /*   54338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   54357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   54364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   54366 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   54369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   54373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   54377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54386 */     GIR_RootConstrainSelectedInstOperands,
     /*   54387 */     // GIR_Coverage, 46637,
     /*   54387 */     GIR_EraseRootFromParent_Done,
     /*   54388 */   // Label 871: @54388
     /*   54388 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54441), // Rule ID 46150 //
     /*   54393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54404 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   54404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   54407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   54411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54439 */     GIR_RootConstrainSelectedInstOperands,
     /*   54440 */     // GIR_Coverage, 46150,
     /*   54440 */     GIR_EraseRootFromParent_Done,
     /*   54441 */   // Label 872: @54441
     /*   54441 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54494), // Rule ID 46151 //
     /*   54446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54457 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   54457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   54460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   54464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54492 */     GIR_RootConstrainSelectedInstOperands,
     /*   54493 */     // GIR_Coverage, 46151,
     /*   54493 */     GIR_EraseRootFromParent_Done,
     /*   54494 */   // Label 873: @54494
     /*   54494 */   GIM_Reject,
     /*   54495 */ // Label 833: @54495
     /*   54495 */ GIM_Reject,
     /*   54496 */ // Label 146: @54496
     /*   54496 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(57620),
     /*   54501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54511 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54607), // Rule ID 70913 //
     /*   54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54549 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54568 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54570 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54581 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54605 */     GIR_RootConstrainSelectedInstOperands,
     /*   54606 */     // GIR_Coverage, 70913,
     /*   54606 */     GIR_EraseRootFromParent_Done,
     /*   54607 */   // Label 875: @54607
     /*   54607 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54703), // Rule ID 70914 //
     /*   54612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54645 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54664 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54666 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54677 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54701 */     GIR_RootConstrainSelectedInstOperands,
     /*   54702 */     // GIR_Coverage, 70914,
     /*   54702 */     GIR_EraseRootFromParent_Done,
     /*   54703 */   // Label 876: @54703
     /*   54703 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54799), // Rule ID 71189 //
     /*   54708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54760 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54762 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54773 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54797 */     GIR_RootConstrainSelectedInstOperands,
     /*   54798 */     // GIR_Coverage, 71189,
     /*   54798 */     GIR_EraseRootFromParent_Done,
     /*   54799 */   // Label 877: @54799
     /*   54799 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54895), // Rule ID 71190 //
     /*   54804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54823 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54837 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54856 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54858 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54869 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54893 */     GIR_RootConstrainSelectedInstOperands,
     /*   54894 */     // GIR_Coverage, 71190,
     /*   54894 */     GIR_EraseRootFromParent_Done,
     /*   54895 */   // Label 878: @54895
     /*   54895 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54991), // Rule ID 71191 //
     /*   54900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54933 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54952 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54954 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54965 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54989 */     GIR_RootConstrainSelectedInstOperands,
     /*   54990 */     // GIR_Coverage, 71191,
     /*   54990 */     GIR_EraseRootFromParent_Done,
     /*   54991 */   // Label 879: @54991
     /*   54991 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55087), // Rule ID 71192 //
     /*   54996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55029 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55048 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55050 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55061 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55085 */     GIR_RootConstrainSelectedInstOperands,
     /*   55086 */     // GIR_Coverage, 71192,
     /*   55086 */     GIR_EraseRootFromParent_Done,
     /*   55087 */   // Label 880: @55087
     /*   55087 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55183), // Rule ID 71027 //
     /*   55092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55125 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55144 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55146 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55157 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55181 */     GIR_RootConstrainSelectedInstOperands,
     /*   55182 */     // GIR_Coverage, 71027,
     /*   55182 */     GIR_EraseRootFromParent_Done,
     /*   55183 */   // Label 881: @55183
     /*   55183 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55279), // Rule ID 71028 //
     /*   55188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55240 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55242 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55253 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   55260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55277 */     GIR_RootConstrainSelectedInstOperands,
     /*   55278 */     // GIR_Coverage, 71028,
     /*   55278 */     GIR_EraseRootFromParent_Done,
     /*   55279 */   // Label 882: @55279
     /*   55279 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55375), // Rule ID 52056 //
     /*   55284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55340 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55342 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55349 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   55352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55373 */     GIR_RootConstrainSelectedInstOperands,
     /*   55374 */     // GIR_Coverage, 52056,
     /*   55374 */     GIR_EraseRootFromParent_Done,
     /*   55375 */   // Label 883: @55375
     /*   55375 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55471), // Rule ID 52057 //
     /*   55380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55403 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55417 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55436 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55445 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   55448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55469 */     GIR_RootConstrainSelectedInstOperands,
     /*   55470 */     // GIR_Coverage, 52057,
     /*   55470 */     GIR_EraseRootFromParent_Done,
     /*   55471 */   // Label 884: @55471
     /*   55471 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55567), // Rule ID 52174 //
     /*   55476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55499 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55513 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55532 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55534 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55541 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55565 */     GIR_RootConstrainSelectedInstOperands,
     /*   55566 */     // GIR_Coverage, 52174,
     /*   55566 */     GIR_EraseRootFromParent_Done,
     /*   55567 */   // Label 885: @55567
     /*   55567 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55663), // Rule ID 52175 //
     /*   55572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55609 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55628 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55630 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55637 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55661 */     GIR_RootConstrainSelectedInstOperands,
     /*   55662 */     // GIR_Coverage, 52175,
     /*   55662 */     GIR_EraseRootFromParent_Done,
     /*   55663 */   // Label 886: @55663
     /*   55663 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55759), // Rule ID 71187 //
     /*   55668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55705 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55724 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55726 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55733 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55757 */     GIR_RootConstrainSelectedInstOperands,
     /*   55758 */     // GIR_Coverage, 71187,
     /*   55758 */     GIR_EraseRootFromParent_Done,
     /*   55759 */   // Label 887: @55759
     /*   55759 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55855), // Rule ID 71188 //
     /*   55764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55787 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55801 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55820 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55822 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55829 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55853 */     GIR_RootConstrainSelectedInstOperands,
     /*   55854 */     // GIR_Coverage, 71188,
     /*   55854 */     GIR_EraseRootFromParent_Done,
     /*   55855 */   // Label 888: @55855
     /*   55855 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55951), // Rule ID 52114 //
     /*   55860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55883 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55897 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55916 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55918 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55925 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55949 */     GIR_RootConstrainSelectedInstOperands,
     /*   55950 */     // GIR_Coverage, 52114,
     /*   55950 */     GIR_EraseRootFromParent_Done,
     /*   55951 */   // Label 889: @55951
     /*   55951 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56047), // Rule ID 52115 //
     /*   55956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55993 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   56004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56008 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56012 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   56014 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   56021 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   56024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   56028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   56036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56045 */     GIR_RootConstrainSelectedInstOperands,
     /*   56046 */     // GIR_Coverage, 52115,
     /*   56046 */     GIR_EraseRootFromParent_Done,
     /*   56047 */   // Label 890: @56047
     /*   56047 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56136), // Rule ID 46720 //
     /*   56052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56067 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56086 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56095 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56134 */     GIR_RootConstrainSelectedInstOperands,
     /*   56135 */     // GIR_Coverage, 46720,
     /*   56135 */     GIR_EraseRootFromParent_Done,
     /*   56136 */   // Label 891: @56136
     /*   56136 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56225), // Rule ID 46721 //
     /*   56141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56156 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56184 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56223 */     GIR_RootConstrainSelectedInstOperands,
     /*   56224 */     // GIR_Coverage, 46721,
     /*   56224 */     GIR_EraseRootFromParent_Done,
     /*   56225 */   // Label 892: @56225
     /*   56225 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56314), // Rule ID 46484 //
     /*   56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56264 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56273 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   56290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56312 */     GIR_RootConstrainSelectedInstOperands,
     /*   56313 */     // GIR_Coverage, 46484,
     /*   56313 */     GIR_EraseRootFromParent_Done,
     /*   56314 */   // Label 893: @56314
     /*   56314 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56403), // Rule ID 46485 //
     /*   56319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56353 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56362 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   56379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56401 */     GIR_RootConstrainSelectedInstOperands,
     /*   56402 */     // GIR_Coverage, 46485,
     /*   56402 */     GIR_EraseRootFromParent_Done,
     /*   56403 */   // Label 894: @56403
     /*   56403 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56492), // Rule ID 46600 //
     /*   56408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56423 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56442 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56451 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56490 */     GIR_RootConstrainSelectedInstOperands,
     /*   56491 */     // GIR_Coverage, 46600,
     /*   56491 */     GIR_EraseRootFromParent_Done,
     /*   56492 */   // Label 895: @56492
     /*   56492 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56581), // Rule ID 46601 //
     /*   56497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56512 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56531 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56540 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56579 */     GIR_RootConstrainSelectedInstOperands,
     /*   56580 */     // GIR_Coverage, 46601,
     /*   56580 */     GIR_EraseRootFromParent_Done,
     /*   56581 */   // Label 896: @56581
     /*   56581 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56649), // Rule ID 70819 //
     /*   56586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56605 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56623 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56647 */     GIR_RootConstrainSelectedInstOperands,
     /*   56648 */     // GIR_Coverage, 70819,
     /*   56648 */     GIR_EraseRootFromParent_Done,
     /*   56649 */   // Label 897: @56649
     /*   56649 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56717), // Rule ID 70820 //
     /*   56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56673 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56691 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56715 */     GIR_RootConstrainSelectedInstOperands,
     /*   56716 */     // GIR_Coverage, 70820,
     /*   56716 */     GIR_EraseRootFromParent_Done,
     /*   56717 */   // Label 898: @56717
     /*   56717 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56772), // Rule ID 69731 //
     /*   56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56737 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56750 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56770 */     GIR_RootConstrainSelectedInstOperands,
     /*   56771 */     // GIR_Coverage, 69731,
     /*   56771 */     GIR_EraseRootFromParent_Done,
     /*   56772 */   // Label 899: @56772
     /*   56772 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56827), // Rule ID 69732 //
     /*   56777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56805 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56825 */     GIR_RootConstrainSelectedInstOperands,
     /*   56826 */     // GIR_Coverage, 69732,
     /*   56826 */     GIR_EraseRootFromParent_Done,
     /*   56827 */   // Label 900: @56827
     /*   56827 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56882), // Rule ID 69551 //
     /*   56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56860 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56880 */     GIR_RootConstrainSelectedInstOperands,
     /*   56881 */     // GIR_Coverage, 69551,
     /*   56881 */     GIR_EraseRootFromParent_Done,
     /*   56882 */   // Label 901: @56882
     /*   56882 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56937), // Rule ID 69552 //
     /*   56887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56915 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56935 */     GIR_RootConstrainSelectedInstOperands,
     /*   56936 */     // GIR_Coverage, 69552,
     /*   56936 */     GIR_EraseRootFromParent_Done,
     /*   56937 */   // Label 902: @56937
     /*   56937 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56992), // Rule ID 69641 //
     /*   56942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56970 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56990 */     GIR_RootConstrainSelectedInstOperands,
     /*   56991 */     // GIR_Coverage, 69641,
     /*   56991 */     GIR_EraseRootFromParent_Done,
     /*   56992 */   // Label 903: @56992
     /*   56992 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(57047), // Rule ID 69642 //
     /*   56997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57025 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57045 */     GIR_RootConstrainSelectedInstOperands,
     /*   57046 */     // GIR_Coverage, 69642,
     /*   57046 */     GIR_EraseRootFromParent_Done,
     /*   57047 */   // Label 904: @57047
     /*   57047 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(57115), // Rule ID 51934 //
     /*   57052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   57071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   57075 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57089 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   57089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   57092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57113 */     GIR_RootConstrainSelectedInstOperands,
     /*   57114 */     // GIR_Coverage, 51934,
     /*   57114 */     GIR_EraseRootFromParent_Done,
     /*   57115 */   // Label 905: @57115
     /*   57115 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57183), // Rule ID 51935 //
     /*   57120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   57139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   57143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57157 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   57157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   57160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57181 */     GIR_RootConstrainSelectedInstOperands,
     /*   57182 */     // GIR_Coverage, 51935,
     /*   57182 */     GIR_EraseRootFromParent_Done,
     /*   57183 */   // Label 906: @57183
     /*   57183 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57238), // Rule ID 46780 //
     /*   57188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57216 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57236 */     GIR_RootConstrainSelectedInstOperands,
     /*   57237 */     // GIR_Coverage, 46780,
     /*   57237 */     GIR_EraseRootFromParent_Done,
     /*   57238 */   // Label 907: @57238
     /*   57238 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57293), // Rule ID 46781 //
     /*   57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57271 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57291 */     GIR_RootConstrainSelectedInstOperands,
     /*   57292 */     // GIR_Coverage, 46781,
     /*   57292 */     GIR_EraseRootFromParent_Done,
     /*   57293 */   // Label 908: @57293
     /*   57293 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57348), // Rule ID 46540 //
     /*   57298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57317 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57326 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   57329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57346 */     GIR_RootConstrainSelectedInstOperands,
     /*   57347 */     // GIR_Coverage, 46540,
     /*   57347 */     GIR_EraseRootFromParent_Done,
     /*   57348 */   // Label 909: @57348
     /*   57348 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57403), // Rule ID 46541 //
     /*   57353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57381 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   57384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57401 */     GIR_RootConstrainSelectedInstOperands,
     /*   57402 */     // GIR_Coverage, 46541,
     /*   57402 */     GIR_EraseRootFromParent_Done,
     /*   57403 */   // Label 910: @57403
     /*   57403 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57458), // Rule ID 46660 //
     /*   57408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57436 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   57436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57456 */     GIR_RootConstrainSelectedInstOperands,
     /*   57457 */     // GIR_Coverage, 46660,
     /*   57457 */     GIR_EraseRootFromParent_Done,
     /*   57458 */   // Label 911: @57458
     /*   57458 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57513), // Rule ID 46661 //
     /*   57463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57491 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57511 */     GIR_RootConstrainSelectedInstOperands,
     /*   57512 */     // GIR_Coverage, 46661,
     /*   57512 */     GIR_EraseRootFromParent_Done,
     /*   57513 */   // Label 912: @57513
     /*   57513 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57566), // Rule ID 46166 //
     /*   57518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57529 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57564 */     GIR_RootConstrainSelectedInstOperands,
     /*   57565 */     // GIR_Coverage, 46166,
     /*   57565 */     GIR_EraseRootFromParent_Done,
     /*   57566 */   // Label 913: @57566
     /*   57566 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57619), // Rule ID 46167 //
     /*   57571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57582 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57617 */     GIR_RootConstrainSelectedInstOperands,
     /*   57618 */     // GIR_Coverage, 46167,
     /*   57618 */     GIR_EraseRootFromParent_Done,
     /*   57619 */   // Label 914: @57619
     /*   57619 */   GIM_Reject,
     /*   57620 */ // Label 874: @57620
     /*   57620 */ GIM_Reject,
     /*   57621 */ // Label 147: @57621
     /*   57621 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(58015),
     /*   57626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57636 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57704), // Rule ID 70763 //
     /*   57641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57678 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57702 */     GIR_RootConstrainSelectedInstOperands,
     /*   57703 */     // GIR_Coverage, 70763,
     /*   57703 */     GIR_EraseRootFromParent_Done,
     /*   57704 */   // Label 916: @57704
     /*   57704 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57772), // Rule ID 70764 //
     /*   57709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57728 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57746 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57770 */     GIR_RootConstrainSelectedInstOperands,
     /*   57771 */     // GIR_Coverage, 70764,
     /*   57771 */     GIR_EraseRootFromParent_Done,
     /*   57772 */   // Label 917: @57772
     /*   57772 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57840), // Rule ID 51906 //
     /*   57777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57814 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57838 */     GIR_RootConstrainSelectedInstOperands,
     /*   57839 */     // GIR_Coverage, 51906,
     /*   57839 */     GIR_EraseRootFromParent_Done,
     /*   57840 */   // Label 918: @57840
     /*   57840 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57908), // Rule ID 51907 //
     /*   57845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57882 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57906 */     GIR_RootConstrainSelectedInstOperands,
     /*   57907 */     // GIR_Coverage, 51907,
     /*   57907 */     GIR_EraseRootFromParent_Done,
     /*   57908 */   // Label 919: @57908
     /*   57908 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57961), // Rule ID 46138 //
     /*   57913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57924 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57959 */     GIR_RootConstrainSelectedInstOperands,
     /*   57960 */     // GIR_Coverage, 46138,
     /*   57960 */     GIR_EraseRootFromParent_Done,
     /*   57961 */   // Label 920: @57961
     /*   57961 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58014), // Rule ID 46139 //
     /*   57966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57977 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   58001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58012 */     GIR_RootConstrainSelectedInstOperands,
     /*   58013 */     // GIR_Coverage, 46139,
     /*   58013 */     GIR_EraseRootFromParent_Done,
     /*   58014 */   // Label 921: @58014
     /*   58014 */   GIM_Reject,
     /*   58015 */ // Label 915: @58015
     /*   58015 */ GIM_Reject,
     /*   58016 */ // Label 148: @58016
     /*   58016 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(61140),
     /*   58021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58031 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58127), // Rule ID 70903 //
     /*   58036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58069 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58088 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58101 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58125 */     GIR_RootConstrainSelectedInstOperands,
     /*   58126 */     // GIR_Coverage, 70903,
     /*   58126 */     GIR_EraseRootFromParent_Done,
     /*   58127 */   // Label 923: @58127
     /*   58127 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58223), // Rule ID 70904 //
     /*   58132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58184 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58197 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58221 */     GIR_RootConstrainSelectedInstOperands,
     /*   58222 */     // GIR_Coverage, 70904,
     /*   58222 */     GIR_EraseRootFromParent_Done,
     /*   58223 */   // Label 924: @58223
     /*   58223 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58319), // Rule ID 71159 //
     /*   58228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58247 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58280 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58293 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58317 */     GIR_RootConstrainSelectedInstOperands,
     /*   58318 */     // GIR_Coverage, 71159,
     /*   58318 */     GIR_EraseRootFromParent_Done,
     /*   58319 */   // Label 925: @58319
     /*   58319 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58415), // Rule ID 71160 //
     /*   58324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58376 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58378 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58389 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58413 */     GIR_RootConstrainSelectedInstOperands,
     /*   58414 */     // GIR_Coverage, 71160,
     /*   58414 */     GIR_EraseRootFromParent_Done,
     /*   58415 */   // Label 926: @58415
     /*   58415 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58511), // Rule ID 71161 //
     /*   58420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58472 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58474 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58485 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58509 */     GIR_RootConstrainSelectedInstOperands,
     /*   58510 */     // GIR_Coverage, 71161,
     /*   58510 */     GIR_EraseRootFromParent_Done,
     /*   58511 */   // Label 927: @58511
     /*   58511 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58607), // Rule ID 71162 //
     /*   58516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58549 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58568 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58570 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58581 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58605 */     GIR_RootConstrainSelectedInstOperands,
     /*   58606 */     // GIR_Coverage, 71162,
     /*   58606 */     GIR_EraseRootFromParent_Done,
     /*   58607 */   // Label 928: @58607
     /*   58607 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58703), // Rule ID 71017 //
     /*   58612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58645 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58664 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58666 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58677 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58701 */     GIR_RootConstrainSelectedInstOperands,
     /*   58702 */     // GIR_Coverage, 71017,
     /*   58702 */     GIR_EraseRootFromParent_Done,
     /*   58703 */   // Label 929: @58703
     /*   58703 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58799), // Rule ID 71018 //
     /*   58708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58760 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58762 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58773 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58797 */     GIR_RootConstrainSelectedInstOperands,
     /*   58798 */     // GIR_Coverage, 71018,
     /*   58798 */     GIR_EraseRootFromParent_Done,
     /*   58799 */   // Label 930: @58799
     /*   58799 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(58895), // Rule ID 52046 //
     /*   58804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58841 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58860 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58862 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58869 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58893 */     GIR_RootConstrainSelectedInstOperands,
     /*   58894 */     // GIR_Coverage, 52046,
     /*   58894 */     GIR_EraseRootFromParent_Done,
     /*   58895 */   // Label 931: @58895
     /*   58895 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(58991), // Rule ID 52047 //
     /*   58900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58956 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58958 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58965 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58989 */     GIR_RootConstrainSelectedInstOperands,
     /*   58990 */     // GIR_Coverage, 52047,
     /*   58990 */     GIR_EraseRootFromParent_Done,
     /*   58991 */   // Label 932: @58991
     /*   58991 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59087), // Rule ID 52164 //
     /*   58996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59019 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59052 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59061 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59085 */     GIR_RootConstrainSelectedInstOperands,
     /*   59086 */     // GIR_Coverage, 52164,
     /*   59086 */     GIR_EraseRootFromParent_Done,
     /*   59087 */   // Label 933: @59087
     /*   59087 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59183), // Rule ID 52165 //
     /*   59092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59129 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59148 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59150 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59157 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59181 */     GIR_RootConstrainSelectedInstOperands,
     /*   59182 */     // GIR_Coverage, 52165,
     /*   59182 */     GIR_EraseRootFromParent_Done,
     /*   59183 */   // Label 934: @59183
     /*   59183 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59279), // Rule ID 71157 //
     /*   59188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59211 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59244 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59253 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   59264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   59268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59277 */     GIR_RootConstrainSelectedInstOperands,
     /*   59278 */     // GIR_Coverage, 71157,
     /*   59278 */     GIR_EraseRootFromParent_Done,
     /*   59279 */   // Label 935: @59279
     /*   59279 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59375), // Rule ID 71158 //
     /*   59284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59340 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59342 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59349 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   59352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   59360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   59364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59373 */     GIR_RootConstrainSelectedInstOperands,
     /*   59374 */     // GIR_Coverage, 71158,
     /*   59374 */     GIR_EraseRootFromParent_Done,
     /*   59375 */   // Label 936: @59375
     /*   59375 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59471), // Rule ID 52104 //
     /*   59380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59403 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59417 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59436 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59445 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59469 */     GIR_RootConstrainSelectedInstOperands,
     /*   59470 */     // GIR_Coverage, 52104,
     /*   59470 */     GIR_EraseRootFromParent_Done,
     /*   59471 */   // Label 937: @59471
     /*   59471 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59567), // Rule ID 52105 //
     /*   59476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59499 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59513 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59532 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59534 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59541 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59565 */     GIR_RootConstrainSelectedInstOperands,
     /*   59566 */     // GIR_Coverage, 52105,
     /*   59566 */     GIR_EraseRootFromParent_Done,
     /*   59567 */   // Label 938: @59567
     /*   59567 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59656), // Rule ID 46700 //
     /*   59572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59615 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59654 */     GIR_RootConstrainSelectedInstOperands,
     /*   59655 */     // GIR_Coverage, 46700,
     /*   59655 */     GIR_EraseRootFromParent_Done,
     /*   59656 */   // Label 939: @59656
     /*   59656 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59745), // Rule ID 46701 //
     /*   59661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59704 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59743 */     GIR_RootConstrainSelectedInstOperands,
     /*   59744 */     // GIR_Coverage, 46701,
     /*   59744 */     GIR_EraseRootFromParent_Done,
     /*   59745 */   // Label 940: @59745
     /*   59745 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59834), // Rule ID 46464 //
     /*   59750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59793 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59832 */     GIR_RootConstrainSelectedInstOperands,
     /*   59833 */     // GIR_Coverage, 46464,
     /*   59833 */     GIR_EraseRootFromParent_Done,
     /*   59834 */   // Label 941: @59834
     /*   59834 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59923), // Rule ID 46465 //
     /*   59839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59882 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59921 */     GIR_RootConstrainSelectedInstOperands,
     /*   59922 */     // GIR_Coverage, 46465,
     /*   59922 */     GIR_EraseRootFromParent_Done,
     /*   59923 */   // Label 942: @59923
     /*   59923 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(60012), // Rule ID 46580 //
     /*   59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59971 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60010 */     GIR_RootConstrainSelectedInstOperands,
     /*   60011 */     // GIR_Coverage, 46580,
     /*   60011 */     GIR_EraseRootFromParent_Done,
     /*   60012 */   // Label 943: @60012
     /*   60012 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(60101), // Rule ID 46581 //
     /*   60017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60060 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   60060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   60077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60099 */     GIR_RootConstrainSelectedInstOperands,
     /*   60100 */     // GIR_Coverage, 46581,
     /*   60100 */     GIR_EraseRootFromParent_Done,
     /*   60101 */   // Label 944: @60101
     /*   60101 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60169), // Rule ID 70795 //
     /*   60106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60125 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60143 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60167 */     GIR_RootConstrainSelectedInstOperands,
     /*   60168 */     // GIR_Coverage, 70795,
     /*   60168 */     GIR_EraseRootFromParent_Done,
     /*   60169 */   // Label 945: @60169
     /*   60169 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60237), // Rule ID 70796 //
     /*   60174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60193 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60211 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60235 */     GIR_RootConstrainSelectedInstOperands,
     /*   60236 */     // GIR_Coverage, 70796,
     /*   60236 */     GIR_EraseRootFromParent_Done,
     /*   60237 */   // Label 946: @60237
     /*   60237 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60292), // Rule ID 69711 //
     /*   60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60270 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60290 */     GIR_RootConstrainSelectedInstOperands,
     /*   60291 */     // GIR_Coverage, 69711,
     /*   60291 */     GIR_EraseRootFromParent_Done,
     /*   60292 */   // Label 947: @60292
     /*   60292 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60347), // Rule ID 69712 //
     /*   60297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60325 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60345 */     GIR_RootConstrainSelectedInstOperands,
     /*   60346 */     // GIR_Coverage, 69712,
     /*   60346 */     GIR_EraseRootFromParent_Done,
     /*   60347 */   // Label 948: @60347
     /*   60347 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60402), // Rule ID 69531 //
     /*   60352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60380 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60400 */     GIR_RootConstrainSelectedInstOperands,
     /*   60401 */     // GIR_Coverage, 69531,
     /*   60401 */     GIR_EraseRootFromParent_Done,
     /*   60402 */   // Label 949: @60402
     /*   60402 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60457), // Rule ID 69532 //
     /*   60407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60435 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60455 */     GIR_RootConstrainSelectedInstOperands,
     /*   60456 */     // GIR_Coverage, 69532,
     /*   60456 */     GIR_EraseRootFromParent_Done,
     /*   60457 */   // Label 950: @60457
     /*   60457 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60512), // Rule ID 69621 //
     /*   60462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60490 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60510 */     GIR_RootConstrainSelectedInstOperands,
     /*   60511 */     // GIR_Coverage, 69621,
     /*   60511 */     GIR_EraseRootFromParent_Done,
     /*   60512 */   // Label 951: @60512
     /*   60512 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60567), // Rule ID 69622 //
     /*   60517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60545 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60565 */     GIR_RootConstrainSelectedInstOperands,
     /*   60566 */     // GIR_Coverage, 69622,
     /*   60566 */     GIR_EraseRootFromParent_Done,
     /*   60567 */   // Label 952: @60567
     /*   60567 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60635), // Rule ID 51922 //
     /*   60572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60595 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60609 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60633 */     GIR_RootConstrainSelectedInstOperands,
     /*   60634 */     // GIR_Coverage, 51922,
     /*   60634 */     GIR_EraseRootFromParent_Done,
     /*   60635 */   // Label 953: @60635
     /*   60635 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60703), // Rule ID 51923 //
     /*   60640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60677 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60701 */     GIR_RootConstrainSelectedInstOperands,
     /*   60702 */     // GIR_Coverage, 51923,
     /*   60702 */     GIR_EraseRootFromParent_Done,
     /*   60703 */   // Label 954: @60703
     /*   60703 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60758), // Rule ID 46760 //
     /*   60708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60736 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60756 */     GIR_RootConstrainSelectedInstOperands,
     /*   60757 */     // GIR_Coverage, 46760,
     /*   60757 */     GIR_EraseRootFromParent_Done,
     /*   60758 */   // Label 955: @60758
     /*   60758 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60813), // Rule ID 46761 //
     /*   60763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60791 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60811 */     GIR_RootConstrainSelectedInstOperands,
     /*   60812 */     // GIR_Coverage, 46761,
     /*   60812 */     GIR_EraseRootFromParent_Done,
     /*   60813 */   // Label 956: @60813
     /*   60813 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(60868), // Rule ID 46520 //
     /*   60818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60837 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60846 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60866 */     GIR_RootConstrainSelectedInstOperands,
     /*   60867 */     // GIR_Coverage, 46520,
     /*   60867 */     GIR_EraseRootFromParent_Done,
     /*   60868 */   // Label 957: @60868
     /*   60868 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60923), // Rule ID 46521 //
     /*   60873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60901 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60921 */     GIR_RootConstrainSelectedInstOperands,
     /*   60922 */     // GIR_Coverage, 46521,
     /*   60922 */     GIR_EraseRootFromParent_Done,
     /*   60923 */   // Label 958: @60923
     /*   60923 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60978), // Rule ID 46640 //
     /*   60928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60947 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60956 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60976 */     GIR_RootConstrainSelectedInstOperands,
     /*   60977 */     // GIR_Coverage, 46640,
     /*   60977 */     GIR_EraseRootFromParent_Done,
     /*   60978 */   // Label 959: @60978
     /*   60978 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(61033), // Rule ID 46641 //
     /*   60983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   61002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   61009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61011 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   61014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61031 */     GIR_RootConstrainSelectedInstOperands,
     /*   61032 */     // GIR_Coverage, 46641,
     /*   61032 */     GIR_EraseRootFromParent_Done,
     /*   61033 */   // Label 960: @61033
     /*   61033 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(61086), // Rule ID 46154 //
     /*   61038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61049 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   61049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61084 */     GIR_RootConstrainSelectedInstOperands,
     /*   61085 */     // GIR_Coverage, 46154,
     /*   61085 */     GIR_EraseRootFromParent_Done,
     /*   61086 */   // Label 961: @61086
     /*   61086 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61139), // Rule ID 46155 //
     /*   61091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61102 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   61102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   61105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   61134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61137 */     GIR_RootConstrainSelectedInstOperands,
     /*   61138 */     // GIR_Coverage, 46155,
     /*   61138 */     GIR_EraseRootFromParent_Done,
     /*   61139 */   // Label 962: @61139
     /*   61139 */   GIM_Reject,
     /*   61140 */ // Label 922: @61140
     /*   61140 */ GIM_Reject,
     /*   61141 */ // Label 149: @61141
     /*   61141 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61535),
     /*   61146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61156 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(61224), // Rule ID 70771 //
     /*   61161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61180 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61198 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61222 */     GIR_RootConstrainSelectedInstOperands,
     /*   61223 */     // GIR_Coverage, 70771,
     /*   61223 */     GIR_EraseRootFromParent_Done,
     /*   61224 */   // Label 964: @61224
     /*   61224 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(61292), // Rule ID 70772 //
     /*   61229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61266 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61290 */     GIR_RootConstrainSelectedInstOperands,
     /*   61291 */     // GIR_Coverage, 70772,
     /*   61291 */     GIR_EraseRootFromParent_Done,
     /*   61292 */   // Label 965: @61292
     /*   61292 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(61360), // Rule ID 51910 //
     /*   61297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61334 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61358 */     GIR_RootConstrainSelectedInstOperands,
     /*   61359 */     // GIR_Coverage, 51910,
     /*   61359 */     GIR_EraseRootFromParent_Done,
     /*   61360 */   // Label 966: @61360
     /*   61360 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(61428), // Rule ID 51911 //
     /*   61365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   61384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   61388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61402 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   61405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61426 */     GIR_RootConstrainSelectedInstOperands,
     /*   61427 */     // GIR_Coverage, 51911,
     /*   61427 */     GIR_EraseRootFromParent_Done,
     /*   61428 */   // Label 967: @61428
     /*   61428 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(61481), // Rule ID 46142 //
     /*   61433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61444 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61479 */     GIR_RootConstrainSelectedInstOperands,
     /*   61480 */     // GIR_Coverage, 46142,
     /*   61480 */     GIR_EraseRootFromParent_Done,
     /*   61481 */   // Label 968: @61481
     /*   61481 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(61534), // Rule ID 46143 //
     /*   61486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61497 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61532 */     GIR_RootConstrainSelectedInstOperands,
     /*   61533 */     // GIR_Coverage, 46143,
     /*   61533 */     GIR_EraseRootFromParent_Done,
     /*   61534 */   // Label 969: @61534
     /*   61534 */   GIM_Reject,
     /*   61535 */ // Label 963: @61535
     /*   61535 */ GIM_Reject,
     /*   61536 */ // Label 150: @61536
     /*   61536 */ GIM_Reject,
     /*   61537 */ // Label 1: @61537
     /*   61537 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 994*/ GIMT_Encode4(80769),
     /*   61548 */ /*GILLT_s32*//*Label 970*/ GIMT_Encode4(61672),
     /*   61552 */ /*GILLT_s64*//*Label 971*/ GIMT_Encode4(61919), GIMT_Encode4(0),
     /*   61560 */ /*GILLT_nxv1s8*//*Label 972*/ GIMT_Encode4(62195),
     /*   61564 */ /*GILLT_nxv1s16*//*Label 973*/ GIMT_Encode4(62442),
     /*   61568 */ /*GILLT_nxv1s32*//*Label 974*/ GIMT_Encode4(63565),
     /*   61572 */ /*GILLT_nxv1s64*//*Label 975*/ GIMT_Encode4(64688), GIMT_Encode4(0),
     /*   61580 */ /*GILLT_nxv2s8*//*Label 976*/ GIMT_Encode4(65811),
     /*   61584 */ /*GILLT_nxv2s16*//*Label 977*/ GIMT_Encode4(66058),
     /*   61588 */ /*GILLT_nxv2s32*//*Label 978*/ GIMT_Encode4(67181),
     /*   61592 */ /*GILLT_nxv2s64*//*Label 979*/ GIMT_Encode4(68304), GIMT_Encode4(0),
     /*   61600 */ /*GILLT_nxv4s8*//*Label 980*/ GIMT_Encode4(69427),
     /*   61604 */ /*GILLT_nxv4s16*//*Label 981*/ GIMT_Encode4(69674),
     /*   61608 */ /*GILLT_nxv4s32*//*Label 982*/ GIMT_Encode4(70797),
     /*   61612 */ /*GILLT_nxv4s64*//*Label 983*/ GIMT_Encode4(71920), GIMT_Encode4(0),
     /*   61620 */ /*GILLT_nxv8s8*//*Label 984*/ GIMT_Encode4(73043),
     /*   61624 */ /*GILLT_nxv8s16*//*Label 985*/ GIMT_Encode4(73290),
     /*   61628 */ /*GILLT_nxv8s32*//*Label 986*/ GIMT_Encode4(74413),
     /*   61632 */ /*GILLT_nxv8s64*//*Label 987*/ GIMT_Encode4(75536), GIMT_Encode4(0),
     /*   61640 */ /*GILLT_nxv16s8*//*Label 988*/ GIMT_Encode4(76659),
     /*   61644 */ /*GILLT_nxv16s16*//*Label 989*/ GIMT_Encode4(76906),
     /*   61648 */ /*GILLT_nxv16s32*//*Label 990*/ GIMT_Encode4(78029), GIMT_Encode4(0),
     /*   61656 */ /*GILLT_nxv32s8*//*Label 991*/ GIMT_Encode4(79152),
     /*   61660 */ /*GILLT_nxv32s16*//*Label 992*/ GIMT_Encode4(79399), GIMT_Encode4(0),
     /*   61668 */ /*GILLT_nxv64s8*//*Label 993*/ GIMT_Encode4(80522),
     /*   61672 */ // Label 970: @61672
     /*   61672 */ GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61918),
     /*   61677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61687 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61762), // Rule ID 104 //
     /*   61692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61728 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61760 */     GIR_RootConstrainSelectedInstOperands,
     /*   61761 */     // GIR_Coverage, 104,
     /*   61761 */     GIR_EraseRootFromParent_Done,
     /*   61762 */   // Label 996: @61762
     /*   61762 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61837), // Rule ID 105 //
     /*   61767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61797 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61803 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61835 */     GIR_RootConstrainSelectedInstOperands,
     /*   61836 */     // GIR_Coverage, 105,
     /*   61836 */     GIR_EraseRootFromParent_Done,
     /*   61837 */   // Label 997: @61837
     /*   61837 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61894), // Rule ID 62601 //
     /*   61842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61877 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61892 */     GIR_RootConstrainSelectedInstOperands,
     /*   61893 */     // GIR_Coverage, 62601,
     /*   61893 */     GIR_EraseRootFromParent_Done,
     /*   61894 */   // Label 998: @61894
     /*   61894 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61917), // Rule ID 83 //
     /*   61899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61910 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61915 */     GIR_RootConstrainSelectedInstOperands,
     /*   61916 */     // GIR_Coverage, 83,
     /*   61916 */     GIR_Done,
     /*   61917 */   // Label 999: @61917
     /*   61917 */   GIM_Reject,
     /*   61918 */ // Label 995: @61918
     /*   61918 */ GIM_Reject,
     /*   61919 */ // Label 971: @61919
     /*   61919 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(62194),
     /*   61924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61930 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(62009), // Rule ID 106 //
     /*   61935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61969 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61975 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61991 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   61994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   62007 */     GIR_RootConstrainSelectedInstOperands,
     /*   62008 */     // GIR_Coverage, 106,
     /*   62008 */     GIR_EraseRootFromParent_Done,
     /*   62009 */   // Label 1001: @62009
     /*   62009 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(62074), // Rule ID 62603 //
     /*   62014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   62017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   62041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10086),
     /*   62055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62057 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10086>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   62060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   62062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   62064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62072 */     GIR_RootConstrainSelectedInstOperands,
     /*   62073 */     // GIR_Coverage, 62603,
     /*   62073 */     GIR_EraseRootFromParent_Done,
     /*   62074 */   // Label 1002: @62074
     /*   62074 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(62135), // Rule ID 62600 //
     /*   62079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   62082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   62102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   62106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62118 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   62121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   62123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   62125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   62133 */     GIR_RootConstrainSelectedInstOperands,
     /*   62134 */     // GIR_Coverage, 62600,
     /*   62134 */     GIR_EraseRootFromParent_Done,
     /*   62135 */   // Label 1003: @62135
     /*   62135 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(62166), // Rule ID 277 //
     /*   62140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   62143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10086),
     /*   62159 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10086>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   62164 */     GIR_RootConstrainSelectedInstOperands,
     /*   62165 */     // GIR_Coverage, 277,
     /*   62165 */     GIR_Done,
     /*   62166 */   // Label 1004: @62166
     /*   62166 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(62193), // Rule ID 82 //
     /*   62171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   62174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   62186 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   62186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   62191 */     GIR_RootConstrainSelectedInstOperands,
     /*   62192 */     // GIR_Coverage, 82,
     /*   62192 */     GIR_Done,
     /*   62193 */   // Label 1005: @62193
     /*   62193 */   GIM_Reject,
     /*   62194 */ // Label 1000: @62194
     /*   62194 */ GIM_Reject,
     /*   62195 */ // Label 972: @62195
     /*   62195 */ GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62441),
     /*   62200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62214 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62278), // Rule ID 51950 //
     /*   62219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62238 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62252 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   62255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62276 */     GIR_RootConstrainSelectedInstOperands,
     /*   62277 */     // GIR_Coverage, 51950,
     /*   62277 */     GIR_EraseRootFromParent_Done,
     /*   62278 */   // Label 1007: @62278
     /*   62278 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62342), // Rule ID 51951 //
     /*   62283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   62302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62316 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   62319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62340 */     GIR_RootConstrainSelectedInstOperands,
     /*   62341 */     // GIR_Coverage, 51951,
     /*   62341 */     GIR_EraseRootFromParent_Done,
     /*   62342 */   // Label 1008: @62342
     /*   62342 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62391), // Rule ID 46224 //
     /*   62347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62354 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   62357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   62371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62389 */     GIR_RootConstrainSelectedInstOperands,
     /*   62390 */     // GIR_Coverage, 46224,
     /*   62390 */     GIR_EraseRootFromParent_Done,
     /*   62391 */   // Label 1009: @62391
     /*   62391 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62440), // Rule ID 46225 //
     /*   62396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62403 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   62406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   62420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62438 */     GIR_RootConstrainSelectedInstOperands,
     /*   62439 */     // GIR_Coverage, 46225,
     /*   62439 */     GIR_EraseRootFromParent_Done,
     /*   62440 */   // Label 1010: @62440
     /*   62440 */   GIM_Reject,
     /*   62441 */ // Label 1006: @62441
     /*   62441 */ GIM_Reject,
     /*   62442 */ // Label 973: @62442
     /*   62442 */ GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(63564),
     /*   62447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62457 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62546), // Rule ID 47220 //
     /*   62462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62505 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62544 */     GIR_RootConstrainSelectedInstOperands,
     /*   62545 */     // GIR_Coverage, 47220,
     /*   62545 */     GIR_EraseRootFromParent_Done,
     /*   62546 */   // Label 1012: @62546
     /*   62546 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62635), // Rule ID 47221 //
     /*   62551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62594 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62633 */     GIR_RootConstrainSelectedInstOperands,
     /*   62634 */     // GIR_Coverage, 47221,
     /*   62634 */     GIR_EraseRootFromParent_Done,
     /*   62635 */   // Label 1013: @62635
     /*   62635 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62724), // Rule ID 46980 //
     /*   62640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62674 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62683 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62722 */     GIR_RootConstrainSelectedInstOperands,
     /*   62723 */     // GIR_Coverage, 46980,
     /*   62723 */     GIR_EraseRootFromParent_Done,
     /*   62724 */   // Label 1014: @62724
     /*   62724 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62813), // Rule ID 46981 //
     /*   62729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62763 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62772 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62811 */     GIR_RootConstrainSelectedInstOperands,
     /*   62812 */     // GIR_Coverage, 46981,
     /*   62812 */     GIR_EraseRootFromParent_Done,
     /*   62813 */   // Label 1015: @62813
     /*   62813 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62902), // Rule ID 47100 //
     /*   62818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62852 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62861 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62900 */     GIR_RootConstrainSelectedInstOperands,
     /*   62901 */     // GIR_Coverage, 47100,
     /*   62901 */     GIR_EraseRootFromParent_Done,
     /*   62902 */   // Label 1016: @62902
     /*   62902 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62991), // Rule ID 47101 //
     /*   62907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62950 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62989 */     GIR_RootConstrainSelectedInstOperands,
     /*   62990 */     // GIR_Coverage, 47101,
     /*   62990 */     GIR_EraseRootFromParent_Done,
     /*   62991 */   // Label 1017: @62991
     /*   62991 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(63059), // Rule ID 51962 //
     /*   62996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   63019 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63033 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   63036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63057 */     GIR_RootConstrainSelectedInstOperands,
     /*   63058 */     // GIR_Coverage, 51962,
     /*   63058 */     GIR_EraseRootFromParent_Done,
     /*   63059 */   // Label 1018: @63059
     /*   63059 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(63127), // Rule ID 51963 //
     /*   63064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   63087 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63101 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   63104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63125 */     GIR_RootConstrainSelectedInstOperands,
     /*   63126 */     // GIR_Coverage, 51963,
     /*   63126 */     GIR_EraseRootFromParent_Done,
     /*   63127 */   // Label 1019: @63127
     /*   63127 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63182), // Rule ID 47280 //
     /*   63132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63160 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63180 */     GIR_RootConstrainSelectedInstOperands,
     /*   63181 */     // GIR_Coverage, 47280,
     /*   63181 */     GIR_EraseRootFromParent_Done,
     /*   63182 */   // Label 1020: @63182
     /*   63182 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63237), // Rule ID 47281 //
     /*   63187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63215 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63235 */     GIR_RootConstrainSelectedInstOperands,
     /*   63236 */     // GIR_Coverage, 47281,
     /*   63236 */     GIR_EraseRootFromParent_Done,
     /*   63237 */   // Label 1021: @63237
     /*   63237 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(63292), // Rule ID 47040 //
     /*   63242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63270 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   63273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63290 */     GIR_RootConstrainSelectedInstOperands,
     /*   63291 */     // GIR_Coverage, 47040,
     /*   63291 */     GIR_EraseRootFromParent_Done,
     /*   63292 */   // Label 1022: @63292
     /*   63292 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63347), // Rule ID 47041 //
     /*   63297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63325 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   63328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63345 */     GIR_RootConstrainSelectedInstOperands,
     /*   63346 */     // GIR_Coverage, 47041,
     /*   63346 */     GIR_EraseRootFromParent_Done,
     /*   63347 */   // Label 1023: @63347
     /*   63347 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63402), // Rule ID 47160 //
     /*   63352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63380 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   63380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63400 */     GIR_RootConstrainSelectedInstOperands,
     /*   63401 */     // GIR_Coverage, 47160,
     /*   63401 */     GIR_EraseRootFromParent_Done,
     /*   63402 */   // Label 1024: @63402
     /*   63402 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63457), // Rule ID 47161 //
     /*   63407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   63426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63435 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   63435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   63438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63455 */     GIR_RootConstrainSelectedInstOperands,
     /*   63456 */     // GIR_Coverage, 47161,
     /*   63456 */     GIR_EraseRootFromParent_Done,
     /*   63457 */   // Label 1025: @63457
     /*   63457 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63510), // Rule ID 46236 //
     /*   63462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63473 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63508 */     GIR_RootConstrainSelectedInstOperands,
     /*   63509 */     // GIR_Coverage, 46236,
     /*   63509 */     GIR_EraseRootFromParent_Done,
     /*   63510 */   // Label 1026: @63510
     /*   63510 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63563), // Rule ID 46237 //
     /*   63515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63526 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63561 */     GIR_RootConstrainSelectedInstOperands,
     /*   63562 */     // GIR_Coverage, 46237,
     /*   63562 */     GIR_EraseRootFromParent_Done,
     /*   63563 */   // Label 1027: @63563
     /*   63563 */   GIM_Reject,
     /*   63564 */ // Label 1011: @63564
     /*   63564 */ GIM_Reject,
     /*   63565 */ // Label 974: @63565
     /*   63565 */ GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(64687),
     /*   63570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63580 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63669), // Rule ID 47244 //
     /*   63585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63628 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63667 */     GIR_RootConstrainSelectedInstOperands,
     /*   63668 */     // GIR_Coverage, 47244,
     /*   63668 */     GIR_EraseRootFromParent_Done,
     /*   63669 */   // Label 1029: @63669
     /*   63669 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63758), // Rule ID 47245 //
     /*   63674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63717 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63756 */     GIR_RootConstrainSelectedInstOperands,
     /*   63757 */     // GIR_Coverage, 47245,
     /*   63757 */     GIR_EraseRootFromParent_Done,
     /*   63758 */   // Label 1030: @63758
     /*   63758 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63847), // Rule ID 47004 //
     /*   63763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63806 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63845 */     GIR_RootConstrainSelectedInstOperands,
     /*   63846 */     // GIR_Coverage, 47004,
     /*   63846 */     GIR_EraseRootFromParent_Done,
     /*   63847 */   // Label 1031: @63847
     /*   63847 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63936), // Rule ID 47005 //
     /*   63852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63895 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63934 */     GIR_RootConstrainSelectedInstOperands,
     /*   63935 */     // GIR_Coverage, 47005,
     /*   63935 */     GIR_EraseRootFromParent_Done,
     /*   63936 */   // Label 1032: @63936
     /*   63936 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(64025), // Rule ID 47124 //
     /*   63941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63984 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   64001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64023 */     GIR_RootConstrainSelectedInstOperands,
     /*   64024 */     // GIR_Coverage, 47124,
     /*   64024 */     GIR_EraseRootFromParent_Done,
     /*   64025 */   // Label 1033: @64025
     /*   64025 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64114), // Rule ID 47125 //
     /*   64030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64073 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   64073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   64090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64112 */     GIR_RootConstrainSelectedInstOperands,
     /*   64113 */     // GIR_Coverage, 47125,
     /*   64113 */     GIR_EraseRootFromParent_Done,
     /*   64114 */   // Label 1034: @64114
     /*   64114 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64182), // Rule ID 51970 //
     /*   64119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   64142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64156 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64180 */     GIR_RootConstrainSelectedInstOperands,
     /*   64181 */     // GIR_Coverage, 51970,
     /*   64181 */     GIR_EraseRootFromParent_Done,
     /*   64182 */   // Label 1035: @64182
     /*   64182 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64250), // Rule ID 51971 //
     /*   64187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   64210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64224 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64248 */     GIR_RootConstrainSelectedInstOperands,
     /*   64249 */     // GIR_Coverage, 51971,
     /*   64249 */     GIR_EraseRootFromParent_Done,
     /*   64250 */   // Label 1036: @64250
     /*   64250 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64305), // Rule ID 47304 //
     /*   64255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64283 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64303 */     GIR_RootConstrainSelectedInstOperands,
     /*   64304 */     // GIR_Coverage, 47304,
     /*   64304 */     GIR_EraseRootFromParent_Done,
     /*   64305 */   // Label 1037: @64305
     /*   64305 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64360), // Rule ID 47305 //
     /*   64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64329 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64338 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64358 */     GIR_RootConstrainSelectedInstOperands,
     /*   64359 */     // GIR_Coverage, 47305,
     /*   64359 */     GIR_EraseRootFromParent_Done,
     /*   64360 */   // Label 1038: @64360
     /*   64360 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(64415), // Rule ID 47064 //
     /*   64365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64393 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   64396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64413 */     GIR_RootConstrainSelectedInstOperands,
     /*   64414 */     // GIR_Coverage, 47064,
     /*   64414 */     GIR_EraseRootFromParent_Done,
     /*   64415 */   // Label 1039: @64415
     /*   64415 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64470), // Rule ID 47065 //
     /*   64420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64448 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   64451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64468 */     GIR_RootConstrainSelectedInstOperands,
     /*   64469 */     // GIR_Coverage, 47065,
     /*   64469 */     GIR_EraseRootFromParent_Done,
     /*   64470 */   // Label 1040: @64470
     /*   64470 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64525), // Rule ID 47184 //
     /*   64475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64503 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64523 */     GIR_RootConstrainSelectedInstOperands,
     /*   64524 */     // GIR_Coverage, 47184,
     /*   64524 */     GIR_EraseRootFromParent_Done,
     /*   64525 */   // Label 1041: @64525
     /*   64525 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64580), // Rule ID 47185 //
     /*   64530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64558 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64578 */     GIR_RootConstrainSelectedInstOperands,
     /*   64579 */     // GIR_Coverage, 47185,
     /*   64579 */     GIR_EraseRootFromParent_Done,
     /*   64580 */   // Label 1042: @64580
     /*   64580 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64633), // Rule ID 46244 //
     /*   64585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64596 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64631 */     GIR_RootConstrainSelectedInstOperands,
     /*   64632 */     // GIR_Coverage, 46244,
     /*   64632 */     GIR_EraseRootFromParent_Done,
     /*   64633 */   // Label 1043: @64633
     /*   64633 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64686), // Rule ID 46245 //
     /*   64638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64649 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64684 */     GIR_RootConstrainSelectedInstOperands,
     /*   64685 */     // GIR_Coverage, 46245,
     /*   64685 */     GIR_EraseRootFromParent_Done,
     /*   64686 */   // Label 1044: @64686
     /*   64686 */   GIM_Reject,
     /*   64687 */ // Label 1028: @64687
     /*   64687 */ GIM_Reject,
     /*   64688 */ // Label 975: @64688
     /*   64688 */ GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(65810),
     /*   64693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64703 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64792), // Rule ID 47264 //
     /*   64708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64742 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64751 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64790 */     GIR_RootConstrainSelectedInstOperands,
     /*   64791 */     // GIR_Coverage, 47264,
     /*   64791 */     GIR_EraseRootFromParent_Done,
     /*   64792 */   // Label 1046: @64792
     /*   64792 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64881), // Rule ID 47265 //
     /*   64797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64831 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64840 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64879 */     GIR_RootConstrainSelectedInstOperands,
     /*   64880 */     // GIR_Coverage, 47265,
     /*   64880 */     GIR_EraseRootFromParent_Done,
     /*   64881 */   // Label 1047: @64881
     /*   64881 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64970), // Rule ID 47024 //
     /*   64886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64929 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64968 */     GIR_RootConstrainSelectedInstOperands,
     /*   64969 */     // GIR_Coverage, 47024,
     /*   64969 */     GIR_EraseRootFromParent_Done,
     /*   64970 */   // Label 1048: @64970
     /*   64970 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65059), // Rule ID 47025 //
     /*   64975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64990 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65009 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65018 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   65018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   65035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65057 */     GIR_RootConstrainSelectedInstOperands,
     /*   65058 */     // GIR_Coverage, 47025,
     /*   65058 */     GIR_EraseRootFromParent_Done,
     /*   65059 */   // Label 1049: @65059
     /*   65059 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65148), // Rule ID 47144 //
     /*   65064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65079 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65098 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65107 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   65107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65146 */     GIR_RootConstrainSelectedInstOperands,
     /*   65147 */     // GIR_Coverage, 47144,
     /*   65147 */     GIR_EraseRootFromParent_Done,
     /*   65148 */   // Label 1050: @65148
     /*   65148 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65237), // Rule ID 47145 //
     /*   65153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65168 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65187 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65196 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   65196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65235 */     GIR_RootConstrainSelectedInstOperands,
     /*   65236 */     // GIR_Coverage, 47145,
     /*   65236 */     GIR_EraseRootFromParent_Done,
     /*   65237 */   // Label 1051: @65237
     /*   65237 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65305), // Rule ID 51986 //
     /*   65242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   65261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   65265 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65279 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   65279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65303 */     GIR_RootConstrainSelectedInstOperands,
     /*   65304 */     // GIR_Coverage, 51986,
     /*   65304 */     GIR_EraseRootFromParent_Done,
     /*   65305 */   // Label 1052: @65305
     /*   65305 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65373), // Rule ID 51987 //
     /*   65310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   65329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   65333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65347 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   65347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65371 */     GIR_RootConstrainSelectedInstOperands,
     /*   65372 */     // GIR_Coverage, 51987,
     /*   65372 */     GIR_EraseRootFromParent_Done,
     /*   65373 */   // Label 1053: @65373
     /*   65373 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65428), // Rule ID 47324 //
     /*   65378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65406 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65426 */     GIR_RootConstrainSelectedInstOperands,
     /*   65427 */     // GIR_Coverage, 47324,
     /*   65427 */     GIR_EraseRootFromParent_Done,
     /*   65428 */   // Label 1054: @65428
     /*   65428 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65483), // Rule ID 47325 //
     /*   65433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65461 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65481 */     GIR_RootConstrainSelectedInstOperands,
     /*   65482 */     // GIR_Coverage, 47325,
     /*   65482 */     GIR_EraseRootFromParent_Done,
     /*   65483 */   // Label 1055: @65483
     /*   65483 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65538), // Rule ID 47084 //
     /*   65488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65516 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65536 */     GIR_RootConstrainSelectedInstOperands,
     /*   65537 */     // GIR_Coverage, 47084,
     /*   65537 */     GIR_EraseRootFromParent_Done,
     /*   65538 */   // Label 1056: @65538
     /*   65538 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65593), // Rule ID 47085 //
     /*   65543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65571 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65591 */     GIR_RootConstrainSelectedInstOperands,
     /*   65592 */     // GIR_Coverage, 47085,
     /*   65592 */     GIR_EraseRootFromParent_Done,
     /*   65593 */   // Label 1057: @65593
     /*   65593 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65648), // Rule ID 47204 //
     /*   65598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65626 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65646 */     GIR_RootConstrainSelectedInstOperands,
     /*   65647 */     // GIR_Coverage, 47204,
     /*   65647 */     GIR_EraseRootFromParent_Done,
     /*   65648 */   // Label 1058: @65648
     /*   65648 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65703), // Rule ID 47205 //
     /*   65653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65681 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65701 */     GIR_RootConstrainSelectedInstOperands,
     /*   65702 */     // GIR_Coverage, 47205,
     /*   65702 */     GIR_EraseRootFromParent_Done,
     /*   65703 */   // Label 1059: @65703
     /*   65703 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65756), // Rule ID 46260 //
     /*   65708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65719 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65754 */     GIR_RootConstrainSelectedInstOperands,
     /*   65755 */     // GIR_Coverage, 46260,
     /*   65755 */     GIR_EraseRootFromParent_Done,
     /*   65756 */   // Label 1060: @65756
     /*   65756 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(65809), // Rule ID 46261 //
     /*   65761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65772 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65807 */     GIR_RootConstrainSelectedInstOperands,
     /*   65808 */     // GIR_Coverage, 46261,
     /*   65808 */     GIR_EraseRootFromParent_Done,
     /*   65809 */   // Label 1061: @65809
     /*   65809 */   GIM_Reject,
     /*   65810 */ // Label 1045: @65810
     /*   65810 */ GIM_Reject,
     /*   65811 */ // Label 976: @65811
     /*   65811 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(66057),
     /*   65816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65830 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65894), // Rule ID 51954 //
     /*   65835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65868 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65892 */     GIR_RootConstrainSelectedInstOperands,
     /*   65893 */     // GIR_Coverage, 51954,
     /*   65893 */     GIR_EraseRootFromParent_Done,
     /*   65894 */   // Label 1063: @65894
     /*   65894 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65958), // Rule ID 51955 //
     /*   65899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65932 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65956 */     GIR_RootConstrainSelectedInstOperands,
     /*   65957 */     // GIR_Coverage, 51955,
     /*   65957 */     GIR_EraseRootFromParent_Done,
     /*   65958 */   // Label 1064: @65958
     /*   65958 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(66007), // Rule ID 46228 //
     /*   65963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65970 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66005 */     GIR_RootConstrainSelectedInstOperands,
     /*   66006 */     // GIR_Coverage, 46228,
     /*   66006 */     GIR_EraseRootFromParent_Done,
     /*   66007 */   // Label 1065: @66007
     /*   66007 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66056), // Rule ID 46229 //
     /*   66012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66019 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   66022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   66036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66054 */     GIR_RootConstrainSelectedInstOperands,
     /*   66055 */     // GIR_Coverage, 46229,
     /*   66055 */     GIR_EraseRootFromParent_Done,
     /*   66056 */   // Label 1066: @66056
     /*   66056 */   GIM_Reject,
     /*   66057 */ // Label 1062: @66057
     /*   66057 */ GIM_Reject,
     /*   66058 */ // Label 977: @66058
     /*   66058 */ GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(67180),
     /*   66063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66073 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66162), // Rule ID 47224 //
     /*   66078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66093 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66112 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66121 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66160 */     GIR_RootConstrainSelectedInstOperands,
     /*   66161 */     // GIR_Coverage, 47224,
     /*   66161 */     GIR_EraseRootFromParent_Done,
     /*   66162 */   // Label 1068: @66162
     /*   66162 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66251), // Rule ID 47225 //
     /*   66167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66201 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66210 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66249 */     GIR_RootConstrainSelectedInstOperands,
     /*   66250 */     // GIR_Coverage, 47225,
     /*   66250 */     GIR_EraseRootFromParent_Done,
     /*   66251 */   // Label 1069: @66251
     /*   66251 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66340), // Rule ID 46984 //
     /*   66256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66290 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66299 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   66316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66338 */     GIR_RootConstrainSelectedInstOperands,
     /*   66339 */     // GIR_Coverage, 46984,
     /*   66339 */     GIR_EraseRootFromParent_Done,
     /*   66340 */   // Label 1070: @66340
     /*   66340 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66429), // Rule ID 46985 //
     /*   66345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66379 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66388 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   66405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66427 */     GIR_RootConstrainSelectedInstOperands,
     /*   66428 */     // GIR_Coverage, 46985,
     /*   66428 */     GIR_EraseRootFromParent_Done,
     /*   66429 */   // Label 1071: @66429
     /*   66429 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66518), // Rule ID 47104 //
     /*   66434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66449 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66468 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66477 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66516 */     GIR_RootConstrainSelectedInstOperands,
     /*   66517 */     // GIR_Coverage, 47104,
     /*   66517 */     GIR_EraseRootFromParent_Done,
     /*   66518 */   // Label 1072: @66518
     /*   66518 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66607), // Rule ID 47105 //
     /*   66523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66538 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66557 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66566 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66605 */     GIR_RootConstrainSelectedInstOperands,
     /*   66606 */     // GIR_Coverage, 47105,
     /*   66606 */     GIR_EraseRootFromParent_Done,
     /*   66607 */   // Label 1073: @66607
     /*   66607 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66675), // Rule ID 51966 //
     /*   66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66649 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66673 */     GIR_RootConstrainSelectedInstOperands,
     /*   66674 */     // GIR_Coverage, 51966,
     /*   66674 */     GIR_EraseRootFromParent_Done,
     /*   66675 */   // Label 1074: @66675
     /*   66675 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66743), // Rule ID 51967 //
     /*   66680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66703 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66717 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66741 */     GIR_RootConstrainSelectedInstOperands,
     /*   66742 */     // GIR_Coverage, 51967,
     /*   66742 */     GIR_EraseRootFromParent_Done,
     /*   66743 */   // Label 1075: @66743
     /*   66743 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66798), // Rule ID 47284 //
     /*   66748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66776 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66796 */     GIR_RootConstrainSelectedInstOperands,
     /*   66797 */     // GIR_Coverage, 47284,
     /*   66797 */     GIR_EraseRootFromParent_Done,
     /*   66798 */   // Label 1076: @66798
     /*   66798 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66853), // Rule ID 47285 //
     /*   66803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66831 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66851 */     GIR_RootConstrainSelectedInstOperands,
     /*   66852 */     // GIR_Coverage, 47285,
     /*   66852 */     GIR_EraseRootFromParent_Done,
     /*   66853 */   // Label 1077: @66853
     /*   66853 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(66908), // Rule ID 47044 //
     /*   66858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66886 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66906 */     GIR_RootConstrainSelectedInstOperands,
     /*   66907 */     // GIR_Coverage, 47044,
     /*   66907 */     GIR_EraseRootFromParent_Done,
     /*   66908 */   // Label 1078: @66908
     /*   66908 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66963), // Rule ID 47045 //
     /*   66913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66941 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66961 */     GIR_RootConstrainSelectedInstOperands,
     /*   66962 */     // GIR_Coverage, 47045,
     /*   66962 */     GIR_EraseRootFromParent_Done,
     /*   66963 */   // Label 1079: @66963
     /*   66963 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(67018), // Rule ID 47164 //
     /*   66968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66996 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67016 */     GIR_RootConstrainSelectedInstOperands,
     /*   67017 */     // GIR_Coverage, 47164,
     /*   67017 */     GIR_EraseRootFromParent_Done,
     /*   67018 */   // Label 1080: @67018
     /*   67018 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(67073), // Rule ID 47165 //
     /*   67023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   67042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67051 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   67051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   67054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67071 */     GIR_RootConstrainSelectedInstOperands,
     /*   67072 */     // GIR_Coverage, 47165,
     /*   67072 */     GIR_EraseRootFromParent_Done,
     /*   67073 */   // Label 1081: @67073
     /*   67073 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67126), // Rule ID 46240 //
     /*   67078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67089 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   67092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   67106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67124 */     GIR_RootConstrainSelectedInstOperands,
     /*   67125 */     // GIR_Coverage, 46240,
     /*   67125 */     GIR_EraseRootFromParent_Done,
     /*   67126 */   // Label 1082: @67126
     /*   67126 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67179), // Rule ID 46241 //
     /*   67131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67142 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   67145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   67159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67177 */     GIR_RootConstrainSelectedInstOperands,
     /*   67178 */     // GIR_Coverage, 46241,
     /*   67178 */     GIR_EraseRootFromParent_Done,
     /*   67179 */   // Label 1083: @67179
     /*   67179 */   GIM_Reject,
     /*   67180 */ // Label 1067: @67180
     /*   67180 */ GIM_Reject,
     /*   67181 */ // Label 978: @67181
     /*   67181 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(68303),
     /*   67186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67196 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67285), // Rule ID 47248 //
     /*   67201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67235 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67244 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67283 */     GIR_RootConstrainSelectedInstOperands,
     /*   67284 */     // GIR_Coverage, 47248,
     /*   67284 */     GIR_EraseRootFromParent_Done,
     /*   67285 */   // Label 1085: @67285
     /*   67285 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67374), // Rule ID 47249 //
     /*   67290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67324 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67333 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67372 */     GIR_RootConstrainSelectedInstOperands,
     /*   67373 */     // GIR_Coverage, 47249,
     /*   67373 */     GIR_EraseRootFromParent_Done,
     /*   67374 */   // Label 1086: @67374
     /*   67374 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67463), // Rule ID 47008 //
     /*   67379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67394 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67413 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67422 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67461 */     GIR_RootConstrainSelectedInstOperands,
     /*   67462 */     // GIR_Coverage, 47008,
     /*   67462 */     GIR_EraseRootFromParent_Done,
     /*   67463 */   // Label 1087: @67463
     /*   67463 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67552), // Rule ID 47009 //
     /*   67468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67502 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67511 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67550 */     GIR_RootConstrainSelectedInstOperands,
     /*   67551 */     // GIR_Coverage, 47009,
     /*   67551 */     GIR_EraseRootFromParent_Done,
     /*   67552 */   // Label 1088: @67552
     /*   67552 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67641), // Rule ID 47128 //
     /*   67557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67572 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67591 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67600 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67639 */     GIR_RootConstrainSelectedInstOperands,
     /*   67640 */     // GIR_Coverage, 47128,
     /*   67640 */     GIR_EraseRootFromParent_Done,
     /*   67641 */   // Label 1089: @67641
     /*   67641 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67730), // Rule ID 47129 //
     /*   67646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67680 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67689 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67728 */     GIR_RootConstrainSelectedInstOperands,
     /*   67729 */     // GIR_Coverage, 47129,
     /*   67729 */     GIR_EraseRootFromParent_Done,
     /*   67730 */   // Label 1090: @67730
     /*   67730 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67798), // Rule ID 51982 //
     /*   67735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67772 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67796 */     GIR_RootConstrainSelectedInstOperands,
     /*   67797 */     // GIR_Coverage, 51982,
     /*   67797 */     GIR_EraseRootFromParent_Done,
     /*   67798 */   // Label 1091: @67798
     /*   67798 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67866), // Rule ID 51983 //
     /*   67803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67840 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67864 */     GIR_RootConstrainSelectedInstOperands,
     /*   67865 */     // GIR_Coverage, 51983,
     /*   67865 */     GIR_EraseRootFromParent_Done,
     /*   67866 */   // Label 1092: @67866
     /*   67866 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67921), // Rule ID 47308 //
     /*   67871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67899 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67919 */     GIR_RootConstrainSelectedInstOperands,
     /*   67920 */     // GIR_Coverage, 47308,
     /*   67920 */     GIR_EraseRootFromParent_Done,
     /*   67921 */   // Label 1093: @67921
     /*   67921 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67976), // Rule ID 47309 //
     /*   67926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67945 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67954 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67974 */     GIR_RootConstrainSelectedInstOperands,
     /*   67975 */     // GIR_Coverage, 47309,
     /*   67975 */     GIR_EraseRootFromParent_Done,
     /*   67976 */   // Label 1094: @67976
     /*   67976 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68031), // Rule ID 47068 //
     /*   67981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68000 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68009 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   68009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   68012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68029 */     GIR_RootConstrainSelectedInstOperands,
     /*   68030 */     // GIR_Coverage, 47068,
     /*   68030 */     GIR_EraseRootFromParent_Done,
     /*   68031 */   // Label 1095: @68031
     /*   68031 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(68086), // Rule ID 47069 //
     /*   68036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68064 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   68064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   68067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68084 */     GIR_RootConstrainSelectedInstOperands,
     /*   68085 */     // GIR_Coverage, 47069,
     /*   68085 */     GIR_EraseRootFromParent_Done,
     /*   68086 */   // Label 1096: @68086
     /*   68086 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68141), // Rule ID 47188 //
     /*   68091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68110 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68119 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   68119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   68122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68139 */     GIR_RootConstrainSelectedInstOperands,
     /*   68140 */     // GIR_Coverage, 47188,
     /*   68140 */     GIR_EraseRootFromParent_Done,
     /*   68141 */   // Label 1097: @68141
     /*   68141 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68196), // Rule ID 47189 //
     /*   68146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   68165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68174 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   68174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   68177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   68191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68194 */     GIR_RootConstrainSelectedInstOperands,
     /*   68195 */     // GIR_Coverage, 47189,
     /*   68195 */     GIR_EraseRootFromParent_Done,
     /*   68196 */   // Label 1098: @68196
     /*   68196 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68249), // Rule ID 46256 //
     /*   68201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68212 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   68215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68247 */     GIR_RootConstrainSelectedInstOperands,
     /*   68248 */     // GIR_Coverage, 46256,
     /*   68248 */     GIR_EraseRootFromParent_Done,
     /*   68249 */   // Label 1099: @68249
     /*   68249 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68302), // Rule ID 46257 //
     /*   68254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68265 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   68268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68300 */     GIR_RootConstrainSelectedInstOperands,
     /*   68301 */     // GIR_Coverage, 46257,
     /*   68301 */     GIR_EraseRootFromParent_Done,
     /*   68302 */   // Label 1100: @68302
     /*   68302 */   GIM_Reject,
     /*   68303 */ // Label 1084: @68303
     /*   68303 */ GIM_Reject,
     /*   68304 */ // Label 979: @68304
     /*   68304 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(69426),
     /*   68309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68319 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68408), // Rule ID 47268 //
     /*   68324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68339 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68358 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68367 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68406 */     GIR_RootConstrainSelectedInstOperands,
     /*   68407 */     // GIR_Coverage, 47268,
     /*   68407 */     GIR_EraseRootFromParent_Done,
     /*   68408 */   // Label 1102: @68408
     /*   68408 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68497), // Rule ID 47269 //
     /*   68413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68428 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68456 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68495 */     GIR_RootConstrainSelectedInstOperands,
     /*   68496 */     // GIR_Coverage, 47269,
     /*   68496 */     GIR_EraseRootFromParent_Done,
     /*   68497 */   // Label 1103: @68497
     /*   68497 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68586), // Rule ID 47028 //
     /*   68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68517 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68545 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68584 */     GIR_RootConstrainSelectedInstOperands,
     /*   68585 */     // GIR_Coverage, 47028,
     /*   68585 */     GIR_EraseRootFromParent_Done,
     /*   68586 */   // Label 1104: @68586
     /*   68586 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68675), // Rule ID 47029 //
     /*   68591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68634 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68673 */     GIR_RootConstrainSelectedInstOperands,
     /*   68674 */     // GIR_Coverage, 47029,
     /*   68674 */     GIR_EraseRootFromParent_Done,
     /*   68675 */   // Label 1105: @68675
     /*   68675 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68764), // Rule ID 47148 //
     /*   68680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68695 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68723 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68762 */     GIR_RootConstrainSelectedInstOperands,
     /*   68763 */     // GIR_Coverage, 47148,
     /*   68763 */     GIR_EraseRootFromParent_Done,
     /*   68764 */   // Label 1106: @68764
     /*   68764 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68853), // Rule ID 47149 //
     /*   68769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68803 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68812 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68851 */     GIR_RootConstrainSelectedInstOperands,
     /*   68852 */     // GIR_Coverage, 47149,
     /*   68852 */     GIR_EraseRootFromParent_Done,
     /*   68853 */   // Label 1107: @68853
     /*   68853 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68921), // Rule ID 52026 //
     /*   68858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68895 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68919 */     GIR_RootConstrainSelectedInstOperands,
     /*   68920 */     // GIR_Coverage, 52026,
     /*   68920 */     GIR_EraseRootFromParent_Done,
     /*   68921 */   // Label 1108: @68921
     /*   68921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68989), // Rule ID 52027 //
     /*   68926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68963 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68987 */     GIR_RootConstrainSelectedInstOperands,
     /*   68988 */     // GIR_Coverage, 52027,
     /*   68988 */     GIR_EraseRootFromParent_Done,
     /*   68989 */   // Label 1109: @68989
     /*   68989 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(69044), // Rule ID 47328 //
     /*   68994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69013 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69022 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69042 */     GIR_RootConstrainSelectedInstOperands,
     /*   69043 */     // GIR_Coverage, 47328,
     /*   69043 */     GIR_EraseRootFromParent_Done,
     /*   69044 */   // Label 1110: @69044
     /*   69044 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(69099), // Rule ID 47329 //
     /*   69049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69077 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69097 */     GIR_RootConstrainSelectedInstOperands,
     /*   69098 */     // GIR_Coverage, 47329,
     /*   69098 */     GIR_EraseRootFromParent_Done,
     /*   69099 */   // Label 1111: @69099
     /*   69099 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69154), // Rule ID 47088 //
     /*   69104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   69107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69123 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69132 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69152 */     GIR_RootConstrainSelectedInstOperands,
     /*   69153 */     // GIR_Coverage, 47088,
     /*   69153 */     GIR_EraseRootFromParent_Done,
     /*   69154 */   // Label 1112: @69154
     /*   69154 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69209), // Rule ID 47089 //
     /*   69159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69178 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69187 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69207 */     GIR_RootConstrainSelectedInstOperands,
     /*   69208 */     // GIR_Coverage, 47089,
     /*   69208 */     GIR_EraseRootFromParent_Done,
     /*   69209 */   // Label 1113: @69209
     /*   69209 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69264), // Rule ID 47208 //
     /*   69214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   69217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69242 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   69242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69262 */     GIR_RootConstrainSelectedInstOperands,
     /*   69263 */     // GIR_Coverage, 47208,
     /*   69263 */     GIR_EraseRootFromParent_Done,
     /*   69264 */   // Label 1114: @69264
     /*   69264 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69319), // Rule ID 47209 //
     /*   69269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   69272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   69288 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69297 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   69297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   69314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69317 */     GIR_RootConstrainSelectedInstOperands,
     /*   69318 */     // GIR_Coverage, 47209,
     /*   69318 */     GIR_EraseRootFromParent_Done,
     /*   69319 */   // Label 1115: @69319
     /*   69319 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69372), // Rule ID 46300 //
     /*   69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   69327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69335 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   69335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   69338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69370 */     GIR_RootConstrainSelectedInstOperands,
     /*   69371 */     // GIR_Coverage, 46300,
     /*   69371 */     GIR_EraseRootFromParent_Done,
     /*   69372 */   // Label 1116: @69372
     /*   69372 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(69425), // Rule ID 46301 //
     /*   69377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   69380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69388 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   69388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   69391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   69420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69423 */     GIR_RootConstrainSelectedInstOperands,
     /*   69424 */     // GIR_Coverage, 46301,
     /*   69424 */     GIR_EraseRootFromParent_Done,
     /*   69425 */   // Label 1117: @69425
     /*   69425 */   GIM_Reject,
     /*   69426 */ // Label 1101: @69426
     /*   69426 */ GIM_Reject,
     /*   69427 */ // Label 980: @69427
     /*   69427 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69673),
     /*   69432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69446 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69510), // Rule ID 51958 //
     /*   69451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69470 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69484 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69508 */     GIR_RootConstrainSelectedInstOperands,
     /*   69509 */     // GIR_Coverage, 51958,
     /*   69509 */     GIR_EraseRootFromParent_Done,
     /*   69510 */   // Label 1119: @69510
     /*   69510 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69574), // Rule ID 51959 //
     /*   69515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69548 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69572 */     GIR_RootConstrainSelectedInstOperands,
     /*   69573 */     // GIR_Coverage, 51959,
     /*   69573 */     GIR_EraseRootFromParent_Done,
     /*   69574 */   // Label 1120: @69574
     /*   69574 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69623), // Rule ID 46232 //
     /*   69579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69586 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69621 */     GIR_RootConstrainSelectedInstOperands,
     /*   69622 */     // GIR_Coverage, 46232,
     /*   69622 */     GIR_EraseRootFromParent_Done,
     /*   69623 */   // Label 1121: @69623
     /*   69623 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69672), // Rule ID 46233 //
     /*   69628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69635 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69670 */     GIR_RootConstrainSelectedInstOperands,
     /*   69671 */     // GIR_Coverage, 46233,
     /*   69671 */     GIR_EraseRootFromParent_Done,
     /*   69672 */   // Label 1122: @69672
     /*   69672 */   GIM_Reject,
     /*   69673 */ // Label 1118: @69673
     /*   69673 */ GIM_Reject,
     /*   69674 */ // Label 981: @69674
     /*   69674 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70796),
     /*   69679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69689 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69778), // Rule ID 47228 //
     /*   69694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69737 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69776 */     GIR_RootConstrainSelectedInstOperands,
     /*   69777 */     // GIR_Coverage, 47228,
     /*   69777 */     GIR_EraseRootFromParent_Done,
     /*   69778 */   // Label 1124: @69778
     /*   69778 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69867), // Rule ID 47229 //
     /*   69783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69826 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69865 */     GIR_RootConstrainSelectedInstOperands,
     /*   69866 */     // GIR_Coverage, 47229,
     /*   69866 */     GIR_EraseRootFromParent_Done,
     /*   69867 */   // Label 1125: @69867
     /*   69867 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69956), // Rule ID 46988 //
     /*   69872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69915 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69954 */     GIR_RootConstrainSelectedInstOperands,
     /*   69955 */     // GIR_Coverage, 46988,
     /*   69955 */     GIR_EraseRootFromParent_Done,
     /*   69956 */   // Label 1126: @69956
     /*   69956 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70045), // Rule ID 46989 //
     /*   69961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70004 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   70004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   70021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70043 */     GIR_RootConstrainSelectedInstOperands,
     /*   70044 */     // GIR_Coverage, 46989,
     /*   70044 */     GIR_EraseRootFromParent_Done,
     /*   70045 */   // Label 1127: @70045
     /*   70045 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70134), // Rule ID 47108 //
     /*   70050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70093 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   70093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   70110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70132 */     GIR_RootConstrainSelectedInstOperands,
     /*   70133 */     // GIR_Coverage, 47108,
     /*   70133 */     GIR_EraseRootFromParent_Done,
     /*   70134 */   // Label 1128: @70134
     /*   70134 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70223), // Rule ID 47109 //
     /*   70139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70182 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   70182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   70199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70221 */     GIR_RootConstrainSelectedInstOperands,
     /*   70222 */     // GIR_Coverage, 47109,
     /*   70222 */     GIR_EraseRootFromParent_Done,
     /*   70223 */   // Label 1129: @70223
     /*   70223 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70291), // Rule ID 51978 //
     /*   70228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   70251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70265 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   70265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   70268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70289 */     GIR_RootConstrainSelectedInstOperands,
     /*   70290 */     // GIR_Coverage, 51978,
     /*   70290 */     GIR_EraseRootFromParent_Done,
     /*   70291 */   // Label 1130: @70291
     /*   70291 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70359), // Rule ID 51979 //
     /*   70296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   70319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70333 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   70333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   70336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70357 */     GIR_RootConstrainSelectedInstOperands,
     /*   70358 */     // GIR_Coverage, 51979,
     /*   70358 */     GIR_EraseRootFromParent_Done,
     /*   70359 */   // Label 1131: @70359
     /*   70359 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70414), // Rule ID 47288 //
     /*   70364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70392 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70412 */     GIR_RootConstrainSelectedInstOperands,
     /*   70413 */     // GIR_Coverage, 47288,
     /*   70413 */     GIR_EraseRootFromParent_Done,
     /*   70414 */   // Label 1132: @70414
     /*   70414 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70469), // Rule ID 47289 //
     /*   70419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70447 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70467 */     GIR_RootConstrainSelectedInstOperands,
     /*   70468 */     // GIR_Coverage, 47289,
     /*   70468 */     GIR_EraseRootFromParent_Done,
     /*   70469 */   // Label 1133: @70469
     /*   70469 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(70524), // Rule ID 47048 //
     /*   70474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70502 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70522 */     GIR_RootConstrainSelectedInstOperands,
     /*   70523 */     // GIR_Coverage, 47048,
     /*   70523 */     GIR_EraseRootFromParent_Done,
     /*   70524 */   // Label 1134: @70524
     /*   70524 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70579), // Rule ID 47049 //
     /*   70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70557 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70577 */     GIR_RootConstrainSelectedInstOperands,
     /*   70578 */     // GIR_Coverage, 47049,
     /*   70578 */     GIR_EraseRootFromParent_Done,
     /*   70579 */   // Label 1135: @70579
     /*   70579 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70634), // Rule ID 47168 //
     /*   70584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70603 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70612 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70632 */     GIR_RootConstrainSelectedInstOperands,
     /*   70633 */     // GIR_Coverage, 47168,
     /*   70633 */     GIR_EraseRootFromParent_Done,
     /*   70634 */   // Label 1136: @70634
     /*   70634 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70689), // Rule ID 47169 //
     /*   70639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70667 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70687 */     GIR_RootConstrainSelectedInstOperands,
     /*   70688 */     // GIR_Coverage, 47169,
     /*   70688 */     GIR_EraseRootFromParent_Done,
     /*   70689 */   // Label 1137: @70689
     /*   70689 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70742), // Rule ID 46252 //
     /*   70694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70705 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70740 */     GIR_RootConstrainSelectedInstOperands,
     /*   70741 */     // GIR_Coverage, 46252,
     /*   70741 */     GIR_EraseRootFromParent_Done,
     /*   70742 */   // Label 1138: @70742
     /*   70742 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70795), // Rule ID 46253 //
     /*   70747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70758 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70793 */     GIR_RootConstrainSelectedInstOperands,
     /*   70794 */     // GIR_Coverage, 46253,
     /*   70794 */     GIR_EraseRootFromParent_Done,
     /*   70795 */   // Label 1139: @70795
     /*   70795 */   GIM_Reject,
     /*   70796 */ // Label 1123: @70796
     /*   70796 */ GIM_Reject,
     /*   70797 */ // Label 982: @70797
     /*   70797 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71919),
     /*   70802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70812 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70901), // Rule ID 47252 //
     /*   70817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70851 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70860 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70899 */     GIR_RootConstrainSelectedInstOperands,
     /*   70900 */     // GIR_Coverage, 47252,
     /*   70900 */     GIR_EraseRootFromParent_Done,
     /*   70901 */   // Label 1141: @70901
     /*   70901 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(70990), // Rule ID 47253 //
     /*   70906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70949 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70988 */     GIR_RootConstrainSelectedInstOperands,
     /*   70989 */     // GIR_Coverage, 47253,
     /*   70989 */     GIR_EraseRootFromParent_Done,
     /*   70990 */   // Label 1142: @70990
     /*   70990 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71079), // Rule ID 47012 //
     /*   70995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71029 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71038 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   71055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71077 */     GIR_RootConstrainSelectedInstOperands,
     /*   71078 */     // GIR_Coverage, 47012,
     /*   71078 */     GIR_EraseRootFromParent_Done,
     /*   71079 */   // Label 1143: @71079
     /*   71079 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71168), // Rule ID 47013 //
     /*   71084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71118 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71127 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   71144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71166 */     GIR_RootConstrainSelectedInstOperands,
     /*   71167 */     // GIR_Coverage, 47013,
     /*   71167 */     GIR_EraseRootFromParent_Done,
     /*   71168 */   // Label 1144: @71168
     /*   71168 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71257), // Rule ID 47132 //
     /*   71173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71207 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71216 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   71216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   71233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71255 */     GIR_RootConstrainSelectedInstOperands,
     /*   71256 */     // GIR_Coverage, 47132,
     /*   71256 */     GIR_EraseRootFromParent_Done,
     /*   71257 */   // Label 1145: @71257
     /*   71257 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71346), // Rule ID 47133 //
     /*   71262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71305 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   71305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   71322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71344 */     GIR_RootConstrainSelectedInstOperands,
     /*   71345 */     // GIR_Coverage, 47133,
     /*   71345 */     GIR_EraseRootFromParent_Done,
     /*   71346 */   // Label 1146: @71346
     /*   71346 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71414), // Rule ID 52014 //
     /*   71351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   71374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71388 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   71388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   71391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71412 */     GIR_RootConstrainSelectedInstOperands,
     /*   71413 */     // GIR_Coverage, 52014,
     /*   71413 */     GIR_EraseRootFromParent_Done,
     /*   71414 */   // Label 1147: @71414
     /*   71414 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71482), // Rule ID 52015 //
     /*   71419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   71442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71456 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   71459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71480 */     GIR_RootConstrainSelectedInstOperands,
     /*   71481 */     // GIR_Coverage, 52015,
     /*   71481 */     GIR_EraseRootFromParent_Done,
     /*   71482 */   // Label 1148: @71482
     /*   71482 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71537), // Rule ID 47312 //
     /*   71487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71515 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71535 */     GIR_RootConstrainSelectedInstOperands,
     /*   71536 */     // GIR_Coverage, 47312,
     /*   71536 */     GIR_EraseRootFromParent_Done,
     /*   71537 */   // Label 1149: @71537
     /*   71537 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71592), // Rule ID 47313 //
     /*   71542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71570 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71590 */     GIR_RootConstrainSelectedInstOperands,
     /*   71591 */     // GIR_Coverage, 47313,
     /*   71591 */     GIR_EraseRootFromParent_Done,
     /*   71592 */   // Label 1150: @71592
     /*   71592 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71647), // Rule ID 47072 //
     /*   71597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71625 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71645 */     GIR_RootConstrainSelectedInstOperands,
     /*   71646 */     // GIR_Coverage, 47072,
     /*   71646 */     GIR_EraseRootFromParent_Done,
     /*   71647 */   // Label 1151: @71647
     /*   71647 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71702), // Rule ID 47073 //
     /*   71652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71680 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71700 */     GIR_RootConstrainSelectedInstOperands,
     /*   71701 */     // GIR_Coverage, 47073,
     /*   71701 */     GIR_EraseRootFromParent_Done,
     /*   71702 */   // Label 1152: @71702
     /*   71702 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71757), // Rule ID 47192 //
     /*   71707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71735 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71755 */     GIR_RootConstrainSelectedInstOperands,
     /*   71756 */     // GIR_Coverage, 47192,
     /*   71756 */     GIR_EraseRootFromParent_Done,
     /*   71757 */   // Label 1153: @71757
     /*   71757 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71812), // Rule ID 47193 //
     /*   71762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71790 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71810 */     GIR_RootConstrainSelectedInstOperands,
     /*   71811 */     // GIR_Coverage, 47193,
     /*   71811 */     GIR_EraseRootFromParent_Done,
     /*   71812 */   // Label 1154: @71812
     /*   71812 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71865), // Rule ID 46288 //
     /*   71817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71828 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71863 */     GIR_RootConstrainSelectedInstOperands,
     /*   71864 */     // GIR_Coverage, 46288,
     /*   71864 */     GIR_EraseRootFromParent_Done,
     /*   71865 */   // Label 1155: @71865
     /*   71865 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71918), // Rule ID 46289 //
     /*   71870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71881 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71916 */     GIR_RootConstrainSelectedInstOperands,
     /*   71917 */     // GIR_Coverage, 46289,
     /*   71917 */     GIR_EraseRootFromParent_Done,
     /*   71918 */   // Label 1156: @71918
     /*   71918 */   GIM_Reject,
     /*   71919 */ // Label 1140: @71919
     /*   71919 */ GIM_Reject,
     /*   71920 */ // Label 983: @71920
     /*   71920 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(73042),
     /*   71925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71935 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72024), // Rule ID 47272 //
     /*   71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71983 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72022 */     GIR_RootConstrainSelectedInstOperands,
     /*   72023 */     // GIR_Coverage, 47272,
     /*   72023 */     GIR_EraseRootFromParent_Done,
     /*   72024 */   // Label 1158: @72024
     /*   72024 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72113), // Rule ID 47273 //
     /*   72029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72063 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72072 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72111 */     GIR_RootConstrainSelectedInstOperands,
     /*   72112 */     // GIR_Coverage, 47273,
     /*   72112 */     GIR_EraseRootFromParent_Done,
     /*   72113 */   // Label 1159: @72113
     /*   72113 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72202), // Rule ID 47032 //
     /*   72118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72161 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72200 */     GIR_RootConstrainSelectedInstOperands,
     /*   72201 */     // GIR_Coverage, 47032,
     /*   72201 */     GIR_EraseRootFromParent_Done,
     /*   72202 */   // Label 1160: @72202
     /*   72202 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72291), // Rule ID 47033 //
     /*   72207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72250 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72289 */     GIR_RootConstrainSelectedInstOperands,
     /*   72290 */     // GIR_Coverage, 47033,
     /*   72290 */     GIR_EraseRootFromParent_Done,
     /*   72291 */   // Label 1161: @72291
     /*   72291 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72380), // Rule ID 47152 //
     /*   72296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72330 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72339 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   72339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72378 */     GIR_RootConstrainSelectedInstOperands,
     /*   72379 */     // GIR_Coverage, 47152,
     /*   72379 */     GIR_EraseRootFromParent_Done,
     /*   72380 */   // Label 1162: @72380
     /*   72380 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72469), // Rule ID 47153 //
     /*   72385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72419 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72428 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   72428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72467 */     GIR_RootConstrainSelectedInstOperands,
     /*   72468 */     // GIR_Coverage, 47153,
     /*   72468 */     GIR_EraseRootFromParent_Done,
     /*   72469 */   // Label 1163: @72469
     /*   72469 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72537), // Rule ID 52030 //
     /*   72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72497 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72511 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72535 */     GIR_RootConstrainSelectedInstOperands,
     /*   72536 */     // GIR_Coverage, 52030,
     /*   72536 */     GIR_EraseRootFromParent_Done,
     /*   72537 */   // Label 1164: @72537
     /*   72537 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72605), // Rule ID 52031 //
     /*   72542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72579 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72603 */     GIR_RootConstrainSelectedInstOperands,
     /*   72604 */     // GIR_Coverage, 52031,
     /*   72604 */     GIR_EraseRootFromParent_Done,
     /*   72605 */   // Label 1165: @72605
     /*   72605 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72660), // Rule ID 47332 //
     /*   72610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72629 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72638 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72658 */     GIR_RootConstrainSelectedInstOperands,
     /*   72659 */     // GIR_Coverage, 47332,
     /*   72659 */     GIR_EraseRootFromParent_Done,
     /*   72660 */   // Label 1166: @72660
     /*   72660 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72715), // Rule ID 47333 //
     /*   72665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72693 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72713 */     GIR_RootConstrainSelectedInstOperands,
     /*   72714 */     // GIR_Coverage, 47333,
     /*   72714 */     GIR_EraseRootFromParent_Done,
     /*   72715 */   // Label 1167: @72715
     /*   72715 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72770), // Rule ID 47092 //
     /*   72720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72739 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72748 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72768 */     GIR_RootConstrainSelectedInstOperands,
     /*   72769 */     // GIR_Coverage, 47092,
     /*   72769 */     GIR_EraseRootFromParent_Done,
     /*   72770 */   // Label 1168: @72770
     /*   72770 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72825), // Rule ID 47093 //
     /*   72775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72803 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72823 */     GIR_RootConstrainSelectedInstOperands,
     /*   72824 */     // GIR_Coverage, 47093,
     /*   72824 */     GIR_EraseRootFromParent_Done,
     /*   72825 */   // Label 1169: @72825
     /*   72825 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72880), // Rule ID 47212 //
     /*   72830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72849 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72858 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72878 */     GIR_RootConstrainSelectedInstOperands,
     /*   72879 */     // GIR_Coverage, 47212,
     /*   72879 */     GIR_EraseRootFromParent_Done,
     /*   72880 */   // Label 1170: @72880
     /*   72880 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72935), // Rule ID 47213 //
     /*   72885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72913 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72933 */     GIR_RootConstrainSelectedInstOperands,
     /*   72934 */     // GIR_Coverage, 47213,
     /*   72934 */     GIR_EraseRootFromParent_Done,
     /*   72935 */   // Label 1171: @72935
     /*   72935 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72988), // Rule ID 46304 //
     /*   72940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72951 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72986 */     GIR_RootConstrainSelectedInstOperands,
     /*   72987 */     // GIR_Coverage, 46304,
     /*   72987 */     GIR_EraseRootFromParent_Done,
     /*   72988 */   // Label 1172: @72988
     /*   72988 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73041), // Rule ID 46305 //
     /*   72993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73004 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   73004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   73007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   73021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   73036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73039 */     GIR_RootConstrainSelectedInstOperands,
     /*   73040 */     // GIR_Coverage, 46305,
     /*   73040 */     GIR_EraseRootFromParent_Done,
     /*   73041 */   // Label 1173: @73041
     /*   73041 */   GIM_Reject,
     /*   73042 */ // Label 1157: @73042
     /*   73042 */ GIM_Reject,
     /*   73043 */ // Label 984: @73043
     /*   73043 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(73289),
     /*   73048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73062 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73126), // Rule ID 51974 //
     /*   73067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73100 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   73103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73124 */     GIR_RootConstrainSelectedInstOperands,
     /*   73125 */     // GIR_Coverage, 51974,
     /*   73125 */     GIR_EraseRootFromParent_Done,
     /*   73126 */   // Label 1175: @73126
     /*   73126 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73190), // Rule ID 51975 //
     /*   73131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   73150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73164 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   73167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73188 */     GIR_RootConstrainSelectedInstOperands,
     /*   73189 */     // GIR_Coverage, 51975,
     /*   73189 */     GIR_EraseRootFromParent_Done,
     /*   73190 */   // Label 1176: @73190
     /*   73190 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73239), // Rule ID 46248 //
     /*   73195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73202 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   73205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   73219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73237 */     GIR_RootConstrainSelectedInstOperands,
     /*   73238 */     // GIR_Coverage, 46248,
     /*   73238 */     GIR_EraseRootFromParent_Done,
     /*   73239 */   // Label 1177: @73239
     /*   73239 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73288), // Rule ID 46249 //
     /*   73244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73251 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   73254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   73268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73286 */     GIR_RootConstrainSelectedInstOperands,
     /*   73287 */     // GIR_Coverage, 46249,
     /*   73287 */     GIR_EraseRootFromParent_Done,
     /*   73288 */   // Label 1178: @73288
     /*   73288 */   GIM_Reject,
     /*   73289 */ // Label 1174: @73289
     /*   73289 */ GIM_Reject,
     /*   73290 */ // Label 985: @73290
     /*   73290 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(74412),
     /*   73295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73305 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73394), // Rule ID 47232 //
     /*   73310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73353 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73392 */     GIR_RootConstrainSelectedInstOperands,
     /*   73393 */     // GIR_Coverage, 47232,
     /*   73393 */     GIR_EraseRootFromParent_Done,
     /*   73394 */   // Label 1180: @73394
     /*   73394 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73483), // Rule ID 47233 //
     /*   73399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73442 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73481 */     GIR_RootConstrainSelectedInstOperands,
     /*   73482 */     // GIR_Coverage, 47233,
     /*   73482 */     GIR_EraseRootFromParent_Done,
     /*   73483 */   // Label 1181: @73483
     /*   73483 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73572), // Rule ID 46992 //
     /*   73488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73531 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73570 */     GIR_RootConstrainSelectedInstOperands,
     /*   73571 */     // GIR_Coverage, 46992,
     /*   73571 */     GIR_EraseRootFromParent_Done,
     /*   73572 */   // Label 1182: @73572
     /*   73572 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73661), // Rule ID 46993 //
     /*   73577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73620 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73659 */     GIR_RootConstrainSelectedInstOperands,
     /*   73660 */     // GIR_Coverage, 46993,
     /*   73660 */     GIR_EraseRootFromParent_Done,
     /*   73661 */   // Label 1183: @73661
     /*   73661 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73750), // Rule ID 47112 //
     /*   73666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73709 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73748 */     GIR_RootConstrainSelectedInstOperands,
     /*   73749 */     // GIR_Coverage, 47112,
     /*   73749 */     GIR_EraseRootFromParent_Done,
     /*   73750 */   // Label 1184: @73750
     /*   73750 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73839), // Rule ID 47113 //
     /*   73755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73798 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73837 */     GIR_RootConstrainSelectedInstOperands,
     /*   73838 */     // GIR_Coverage, 47113,
     /*   73838 */     GIR_EraseRootFromParent_Done,
     /*   73839 */   // Label 1185: @73839
     /*   73839 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73907), // Rule ID 52002 //
     /*   73844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73881 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73905 */     GIR_RootConstrainSelectedInstOperands,
     /*   73906 */     // GIR_Coverage, 52002,
     /*   73906 */     GIR_EraseRootFromParent_Done,
     /*   73907 */   // Label 1186: @73907
     /*   73907 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73975), // Rule ID 52003 //
     /*   73912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73949 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73973 */     GIR_RootConstrainSelectedInstOperands,
     /*   73974 */     // GIR_Coverage, 52003,
     /*   73974 */     GIR_EraseRootFromParent_Done,
     /*   73975 */   // Label 1187: @73975
     /*   73975 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(74030), // Rule ID 47292 //
     /*   73980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74008 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74028 */     GIR_RootConstrainSelectedInstOperands,
     /*   74029 */     // GIR_Coverage, 47292,
     /*   74029 */     GIR_EraseRootFromParent_Done,
     /*   74030 */   // Label 1188: @74030
     /*   74030 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(74085), // Rule ID 47293 //
     /*   74035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74063 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74083 */     GIR_RootConstrainSelectedInstOperands,
     /*   74084 */     // GIR_Coverage, 47293,
     /*   74084 */     GIR_EraseRootFromParent_Done,
     /*   74085 */   // Label 1189: @74085
     /*   74085 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(74140), // Rule ID 47052 //
     /*   74090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74118 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   74121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74138 */     GIR_RootConstrainSelectedInstOperands,
     /*   74139 */     // GIR_Coverage, 47052,
     /*   74139 */     GIR_EraseRootFromParent_Done,
     /*   74140 */   // Label 1190: @74140
     /*   74140 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74195), // Rule ID 47053 //
     /*   74145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74164 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74173 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   74176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74193 */     GIR_RootConstrainSelectedInstOperands,
     /*   74194 */     // GIR_Coverage, 47053,
     /*   74194 */     GIR_EraseRootFromParent_Done,
     /*   74195 */   // Label 1191: @74195
     /*   74195 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74250), // Rule ID 47172 //
     /*   74200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74219 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74228 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74248 */     GIR_RootConstrainSelectedInstOperands,
     /*   74249 */     // GIR_Coverage, 47172,
     /*   74249 */     GIR_EraseRootFromParent_Done,
     /*   74250 */   // Label 1192: @74250
     /*   74250 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74305), // Rule ID 47173 //
     /*   74255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   74274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   74281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74283 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   74286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74303 */     GIR_RootConstrainSelectedInstOperands,
     /*   74304 */     // GIR_Coverage, 47173,
     /*   74304 */     GIR_EraseRootFromParent_Done,
     /*   74305 */   // Label 1193: @74305
     /*   74305 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74358), // Rule ID 46276 //
     /*   74310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74321 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   74324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   74338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74356 */     GIR_RootConstrainSelectedInstOperands,
     /*   74357 */     // GIR_Coverage, 46276,
     /*   74357 */     GIR_EraseRootFromParent_Done,
     /*   74358 */   // Label 1194: @74358
     /*   74358 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74411), // Rule ID 46277 //
     /*   74363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74374 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   74377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   74391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74409 */     GIR_RootConstrainSelectedInstOperands,
     /*   74410 */     // GIR_Coverage, 46277,
     /*   74410 */     GIR_EraseRootFromParent_Done,
     /*   74411 */   // Label 1195: @74411
     /*   74411 */   GIM_Reject,
     /*   74412 */ // Label 1179: @74412
     /*   74412 */ GIM_Reject,
     /*   74413 */ // Label 986: @74413
     /*   74413 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(75535),
     /*   74418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74428 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74517), // Rule ID 47256 //
     /*   74433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74467 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74476 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74515 */     GIR_RootConstrainSelectedInstOperands,
     /*   74516 */     // GIR_Coverage, 47256,
     /*   74516 */     GIR_EraseRootFromParent_Done,
     /*   74517 */   // Label 1197: @74517
     /*   74517 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74606), // Rule ID 47257 //
     /*   74522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74556 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74565 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74604 */     GIR_RootConstrainSelectedInstOperands,
     /*   74605 */     // GIR_Coverage, 47257,
     /*   74605 */     GIR_EraseRootFromParent_Done,
     /*   74606 */   // Label 1198: @74606
     /*   74606 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74695), // Rule ID 47016 //
     /*   74611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74645 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74654 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74693 */     GIR_RootConstrainSelectedInstOperands,
     /*   74694 */     // GIR_Coverage, 47016,
     /*   74694 */     GIR_EraseRootFromParent_Done,
     /*   74695 */   // Label 1199: @74695
     /*   74695 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74784), // Rule ID 47017 //
     /*   74700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74734 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74743 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74782 */     GIR_RootConstrainSelectedInstOperands,
     /*   74783 */     // GIR_Coverage, 47017,
     /*   74783 */     GIR_EraseRootFromParent_Done,
     /*   74784 */   // Label 1200: @74784
     /*   74784 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74873), // Rule ID 47136 //
     /*   74789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74804 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74823 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74832 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74871 */     GIR_RootConstrainSelectedInstOperands,
     /*   74872 */     // GIR_Coverage, 47136,
     /*   74872 */     GIR_EraseRootFromParent_Done,
     /*   74873 */   // Label 1201: @74873
     /*   74873 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74962), // Rule ID 47137 //
     /*   74878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74893 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74912 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74921 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74960 */     GIR_RootConstrainSelectedInstOperands,
     /*   74961 */     // GIR_Coverage, 47137,
     /*   74961 */     GIR_EraseRootFromParent_Done,
     /*   74962 */   // Label 1202: @74962
     /*   74962 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(75030), // Rule ID 52018 //
     /*   74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74990 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75004 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   75007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75028 */     GIR_RootConstrainSelectedInstOperands,
     /*   75029 */     // GIR_Coverage, 52018,
     /*   75029 */     GIR_EraseRootFromParent_Done,
     /*   75030 */   // Label 1203: @75030
     /*   75030 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75098), // Rule ID 52019 //
     /*   75035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   75058 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75072 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   75075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75096 */     GIR_RootConstrainSelectedInstOperands,
     /*   75097 */     // GIR_Coverage, 52019,
     /*   75097 */     GIR_EraseRootFromParent_Done,
     /*   75098 */   // Label 1204: @75098
     /*   75098 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75153), // Rule ID 47316 //
     /*   75103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75131 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75151 */     GIR_RootConstrainSelectedInstOperands,
     /*   75152 */     // GIR_Coverage, 47316,
     /*   75152 */     GIR_EraseRootFromParent_Done,
     /*   75153 */   // Label 1205: @75153
     /*   75153 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75208), // Rule ID 47317 //
     /*   75158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75186 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75206 */     GIR_RootConstrainSelectedInstOperands,
     /*   75207 */     // GIR_Coverage, 47317,
     /*   75207 */     GIR_EraseRootFromParent_Done,
     /*   75208 */   // Label 1206: @75208
     /*   75208 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75263), // Rule ID 47076 //
     /*   75213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75241 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   75244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75261 */     GIR_RootConstrainSelectedInstOperands,
     /*   75262 */     // GIR_Coverage, 47076,
     /*   75262 */     GIR_EraseRootFromParent_Done,
     /*   75263 */   // Label 1207: @75263
     /*   75263 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75318), // Rule ID 47077 //
     /*   75268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75296 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   75299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75316 */     GIR_RootConstrainSelectedInstOperands,
     /*   75317 */     // GIR_Coverage, 47077,
     /*   75317 */     GIR_EraseRootFromParent_Done,
     /*   75318 */   // Label 1208: @75318
     /*   75318 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75373), // Rule ID 47196 //
     /*   75323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75351 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75371 */     GIR_RootConstrainSelectedInstOperands,
     /*   75372 */     // GIR_Coverage, 47196,
     /*   75372 */     GIR_EraseRootFromParent_Done,
     /*   75373 */   // Label 1209: @75373
     /*   75373 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75428), // Rule ID 47197 //
     /*   75378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   75397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   75404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75406 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   75409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75426 */     GIR_RootConstrainSelectedInstOperands,
     /*   75427 */     // GIR_Coverage, 47197,
     /*   75427 */     GIR_EraseRootFromParent_Done,
     /*   75428 */   // Label 1210: @75428
     /*   75428 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75481), // Rule ID 46292 //
     /*   75433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75444 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75479 */     GIR_RootConstrainSelectedInstOperands,
     /*   75480 */     // GIR_Coverage, 46292,
     /*   75480 */     GIR_EraseRootFromParent_Done,
     /*   75481 */   // Label 1211: @75481
     /*   75481 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75534), // Rule ID 46293 //
     /*   75486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75497 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75532 */     GIR_RootConstrainSelectedInstOperands,
     /*   75533 */     // GIR_Coverage, 46293,
     /*   75533 */     GIR_EraseRootFromParent_Done,
     /*   75534 */   // Label 1212: @75534
     /*   75534 */   GIM_Reject,
     /*   75535 */ // Label 1196: @75535
     /*   75535 */ GIM_Reject,
     /*   75536 */ // Label 987: @75536
     /*   75536 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(76658),
     /*   75541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75551 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75640), // Rule ID 47276 //
     /*   75556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75590 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75599 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75638 */     GIR_RootConstrainSelectedInstOperands,
     /*   75639 */     // GIR_Coverage, 47276,
     /*   75639 */     GIR_EraseRootFromParent_Done,
     /*   75640 */   // Label 1214: @75640
     /*   75640 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75729), // Rule ID 47277 //
     /*   75645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75688 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75727 */     GIR_RootConstrainSelectedInstOperands,
     /*   75728 */     // GIR_Coverage, 47277,
     /*   75728 */     GIR_EraseRootFromParent_Done,
     /*   75729 */   // Label 1215: @75729
     /*   75729 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75818), // Rule ID 47036 //
     /*   75734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75749 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75777 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75816 */     GIR_RootConstrainSelectedInstOperands,
     /*   75817 */     // GIR_Coverage, 47036,
     /*   75817 */     GIR_EraseRootFromParent_Done,
     /*   75818 */   // Label 1216: @75818
     /*   75818 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75907), // Rule ID 47037 //
     /*   75823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75857 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75866 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75905 */     GIR_RootConstrainSelectedInstOperands,
     /*   75906 */     // GIR_Coverage, 47037,
     /*   75906 */     GIR_EraseRootFromParent_Done,
     /*   75907 */   // Label 1217: @75907
     /*   75907 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75996), // Rule ID 47156 //
     /*   75912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75955 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75994 */     GIR_RootConstrainSelectedInstOperands,
     /*   75995 */     // GIR_Coverage, 47156,
     /*   75995 */     GIR_EraseRootFromParent_Done,
     /*   75996 */   // Label 1218: @75996
     /*   75996 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76085), // Rule ID 47157 //
     /*   76001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76035 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76044 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   76044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   76061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76083 */     GIR_RootConstrainSelectedInstOperands,
     /*   76084 */     // GIR_Coverage, 47157,
     /*   76084 */     GIR_EraseRootFromParent_Done,
     /*   76085 */   // Label 1219: @76085
     /*   76085 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76153), // Rule ID 52034 //
     /*   76090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   76109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   76113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76127 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   76127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76151 */     GIR_RootConstrainSelectedInstOperands,
     /*   76152 */     // GIR_Coverage, 52034,
     /*   76152 */     GIR_EraseRootFromParent_Done,
     /*   76153 */   // Label 1220: @76153
     /*   76153 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76221), // Rule ID 52035 //
     /*   76158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   76177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   76181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76195 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   76195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76219 */     GIR_RootConstrainSelectedInstOperands,
     /*   76220 */     // GIR_Coverage, 52035,
     /*   76220 */     GIR_EraseRootFromParent_Done,
     /*   76221 */   // Label 1221: @76221
     /*   76221 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76276), // Rule ID 47336 //
     /*   76226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76254 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76274 */     GIR_RootConstrainSelectedInstOperands,
     /*   76275 */     // GIR_Coverage, 47336,
     /*   76275 */     GIR_EraseRootFromParent_Done,
     /*   76276 */   // Label 1222: @76276
     /*   76276 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76331), // Rule ID 47337 //
     /*   76281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76309 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76329 */     GIR_RootConstrainSelectedInstOperands,
     /*   76330 */     // GIR_Coverage, 47337,
     /*   76330 */     GIR_EraseRootFromParent_Done,
     /*   76331 */   // Label 1223: @76331
     /*   76331 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76386), // Rule ID 47096 //
     /*   76336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76364 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   76367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76384 */     GIR_RootConstrainSelectedInstOperands,
     /*   76385 */     // GIR_Coverage, 47096,
     /*   76385 */     GIR_EraseRootFromParent_Done,
     /*   76386 */   // Label 1224: @76386
     /*   76386 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76441), // Rule ID 47097 //
     /*   76391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76419 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   76422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76439 */     GIR_RootConstrainSelectedInstOperands,
     /*   76440 */     // GIR_Coverage, 47097,
     /*   76440 */     GIR_EraseRootFromParent_Done,
     /*   76441 */   // Label 1225: @76441
     /*   76441 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76496), // Rule ID 47216 //
     /*   76446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   76449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76474 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76494 */     GIR_RootConstrainSelectedInstOperands,
     /*   76495 */     // GIR_Coverage, 47216,
     /*   76495 */     GIR_EraseRootFromParent_Done,
     /*   76496 */   // Label 1226: @76496
     /*   76496 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76551), // Rule ID 47217 //
     /*   76501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76529 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76549 */     GIR_RootConstrainSelectedInstOperands,
     /*   76550 */     // GIR_Coverage, 47217,
     /*   76550 */     GIR_EraseRootFromParent_Done,
     /*   76551 */   // Label 1227: @76551
     /*   76551 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76604), // Rule ID 46308 //
     /*   76556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76567 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76602 */     GIR_RootConstrainSelectedInstOperands,
     /*   76603 */     // GIR_Coverage, 46308,
     /*   76603 */     GIR_EraseRootFromParent_Done,
     /*   76604 */   // Label 1228: @76604
     /*   76604 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(76657), // Rule ID 46309 //
     /*   76609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76620 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76655 */     GIR_RootConstrainSelectedInstOperands,
     /*   76656 */     // GIR_Coverage, 46309,
     /*   76656 */     GIR_EraseRootFromParent_Done,
     /*   76657 */   // Label 1229: @76657
     /*   76657 */   GIM_Reject,
     /*   76658 */ // Label 1213: @76658
     /*   76658 */ GIM_Reject,
     /*   76659 */ // Label 988: @76659
     /*   76659 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76905),
     /*   76664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76678 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76742), // Rule ID 51990 //
     /*   76683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76716 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76740 */     GIR_RootConstrainSelectedInstOperands,
     /*   76741 */     // GIR_Coverage, 51990,
     /*   76741 */     GIR_EraseRootFromParent_Done,
     /*   76742 */   // Label 1231: @76742
     /*   76742 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76806), // Rule ID 51991 //
     /*   76747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76780 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76804 */     GIR_RootConstrainSelectedInstOperands,
     /*   76805 */     // GIR_Coverage, 51991,
     /*   76805 */     GIR_EraseRootFromParent_Done,
     /*   76806 */   // Label 1232: @76806
     /*   76806 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76855), // Rule ID 46264 //
     /*   76811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76818 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76853 */     GIR_RootConstrainSelectedInstOperands,
     /*   76854 */     // GIR_Coverage, 46264,
     /*   76854 */     GIR_EraseRootFromParent_Done,
     /*   76855 */   // Label 1233: @76855
     /*   76855 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76904), // Rule ID 46265 //
     /*   76860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76867 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76902 */     GIR_RootConstrainSelectedInstOperands,
     /*   76903 */     // GIR_Coverage, 46265,
     /*   76903 */     GIR_EraseRootFromParent_Done,
     /*   76904 */   // Label 1234: @76904
     /*   76904 */   GIM_Reject,
     /*   76905 */ // Label 1230: @76905
     /*   76905 */ GIM_Reject,
     /*   76906 */ // Label 989: @76906
     /*   76906 */ GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78028),
     /*   76911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76921 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77010), // Rule ID 47236 //
     /*   76926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76969 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77008 */     GIR_RootConstrainSelectedInstOperands,
     /*   77009 */     // GIR_Coverage, 47236,
     /*   77009 */     GIR_EraseRootFromParent_Done,
     /*   77010 */   // Label 1236: @77010
     /*   77010 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77099), // Rule ID 47237 //
     /*   77015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77058 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77097 */     GIR_RootConstrainSelectedInstOperands,
     /*   77098 */     // GIR_Coverage, 47237,
     /*   77098 */     GIR_EraseRootFromParent_Done,
     /*   77099 */   // Label 1237: @77099
     /*   77099 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77188), // Rule ID 46996 //
     /*   77104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77147 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   77164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77186 */     GIR_RootConstrainSelectedInstOperands,
     /*   77187 */     // GIR_Coverage, 46996,
     /*   77187 */     GIR_EraseRootFromParent_Done,
     /*   77188 */   // Label 1238: @77188
     /*   77188 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77277), // Rule ID 46997 //
     /*   77193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77236 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   77253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77275 */     GIR_RootConstrainSelectedInstOperands,
     /*   77276 */     // GIR_Coverage, 46997,
     /*   77276 */     GIR_EraseRootFromParent_Done,
     /*   77277 */   // Label 1239: @77277
     /*   77277 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77366), // Rule ID 47116 //
     /*   77282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77325 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77364 */     GIR_RootConstrainSelectedInstOperands,
     /*   77365 */     // GIR_Coverage, 47116,
     /*   77365 */     GIR_EraseRootFromParent_Done,
     /*   77366 */   // Label 1240: @77366
     /*   77366 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77455), // Rule ID 47117 //
     /*   77371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77414 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   77431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77453 */     GIR_RootConstrainSelectedInstOperands,
     /*   77454 */     // GIR_Coverage, 47117,
     /*   77454 */     GIR_EraseRootFromParent_Done,
     /*   77455 */   // Label 1241: @77455
     /*   77455 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77523), // Rule ID 52006 //
     /*   77460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77497 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77521 */     GIR_RootConstrainSelectedInstOperands,
     /*   77522 */     // GIR_Coverage, 52006,
     /*   77522 */     GIR_EraseRootFromParent_Done,
     /*   77523 */   // Label 1242: @77523
     /*   77523 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77591), // Rule ID 52007 //
     /*   77528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77565 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77589 */     GIR_RootConstrainSelectedInstOperands,
     /*   77590 */     // GIR_Coverage, 52007,
     /*   77590 */     GIR_EraseRootFromParent_Done,
     /*   77591 */   // Label 1243: @77591
     /*   77591 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77646), // Rule ID 47296 //
     /*   77596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77615 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77624 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77644 */     GIR_RootConstrainSelectedInstOperands,
     /*   77645 */     // GIR_Coverage, 47296,
     /*   77645 */     GIR_EraseRootFromParent_Done,
     /*   77646 */   // Label 1244: @77646
     /*   77646 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77701), // Rule ID 47297 //
     /*   77651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77679 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77699 */     GIR_RootConstrainSelectedInstOperands,
     /*   77700 */     // GIR_Coverage, 47297,
     /*   77700 */     GIR_EraseRootFromParent_Done,
     /*   77701 */   // Label 1245: @77701
     /*   77701 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(77756), // Rule ID 47056 //
     /*   77706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77725 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77734 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77754 */     GIR_RootConstrainSelectedInstOperands,
     /*   77755 */     // GIR_Coverage, 47056,
     /*   77755 */     GIR_EraseRootFromParent_Done,
     /*   77756 */   // Label 1246: @77756
     /*   77756 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77811), // Rule ID 47057 //
     /*   77761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77789 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77809 */     GIR_RootConstrainSelectedInstOperands,
     /*   77810 */     // GIR_Coverage, 47057,
     /*   77810 */     GIR_EraseRootFromParent_Done,
     /*   77811 */   // Label 1247: @77811
     /*   77811 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77866), // Rule ID 47176 //
     /*   77816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77835 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77844 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77864 */     GIR_RootConstrainSelectedInstOperands,
     /*   77865 */     // GIR_Coverage, 47176,
     /*   77865 */     GIR_EraseRootFromParent_Done,
     /*   77866 */   // Label 1248: @77866
     /*   77866 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77921), // Rule ID 47177 //
     /*   77871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77899 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77919 */     GIR_RootConstrainSelectedInstOperands,
     /*   77920 */     // GIR_Coverage, 47177,
     /*   77920 */     GIR_EraseRootFromParent_Done,
     /*   77921 */   // Label 1249: @77921
     /*   77921 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77974), // Rule ID 46280 //
     /*   77926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77937 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77972 */     GIR_RootConstrainSelectedInstOperands,
     /*   77973 */     // GIR_Coverage, 46280,
     /*   77973 */     GIR_EraseRootFromParent_Done,
     /*   77974 */   // Label 1250: @77974
     /*   77974 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78027), // Rule ID 46281 //
     /*   77979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77990 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78025 */     GIR_RootConstrainSelectedInstOperands,
     /*   78026 */     // GIR_Coverage, 46281,
     /*   78026 */     GIR_EraseRootFromParent_Done,
     /*   78027 */   // Label 1251: @78027
     /*   78027 */   GIM_Reject,
     /*   78028 */ // Label 1235: @78028
     /*   78028 */ GIM_Reject,
     /*   78029 */ // Label 990: @78029
     /*   78029 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79151),
     /*   78034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78044 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78133), // Rule ID 47260 //
     /*   78049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78092 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78131 */     GIR_RootConstrainSelectedInstOperands,
     /*   78132 */     // GIR_Coverage, 47260,
     /*   78132 */     GIR_EraseRootFromParent_Done,
     /*   78133 */   // Label 1253: @78133
     /*   78133 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78222), // Rule ID 47261 //
     /*   78138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78153 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78172 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78181 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78220 */     GIR_RootConstrainSelectedInstOperands,
     /*   78221 */     // GIR_Coverage, 47261,
     /*   78221 */     GIR_EraseRootFromParent_Done,
     /*   78222 */   // Label 1254: @78222
     /*   78222 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78311), // Rule ID 47020 //
     /*   78227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78270 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   78287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78309 */     GIR_RootConstrainSelectedInstOperands,
     /*   78310 */     // GIR_Coverage, 47020,
     /*   78310 */     GIR_EraseRootFromParent_Done,
     /*   78311 */   // Label 1255: @78311
     /*   78311 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78400), // Rule ID 47021 //
     /*   78316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78331 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78350 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78359 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   78376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78398 */     GIR_RootConstrainSelectedInstOperands,
     /*   78399 */     // GIR_Coverage, 47021,
     /*   78399 */     GIR_EraseRootFromParent_Done,
     /*   78400 */   // Label 1256: @78400
     /*   78400 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78489), // Rule ID 47140 //
     /*   78405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78420 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78439 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78448 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78487 */     GIR_RootConstrainSelectedInstOperands,
     /*   78488 */     // GIR_Coverage, 47140,
     /*   78488 */     GIR_EraseRootFromParent_Done,
     /*   78489 */   // Label 1257: @78489
     /*   78489 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78578), // Rule ID 47141 //
     /*   78494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78509 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78528 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78537 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78576 */     GIR_RootConstrainSelectedInstOperands,
     /*   78577 */     // GIR_Coverage, 47141,
     /*   78577 */     GIR_EraseRootFromParent_Done,
     /*   78578 */   // Label 1258: @78578
     /*   78578 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78646), // Rule ID 52022 //
     /*   78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78620 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78644 */     GIR_RootConstrainSelectedInstOperands,
     /*   78645 */     // GIR_Coverage, 52022,
     /*   78645 */     GIR_EraseRootFromParent_Done,
     /*   78646 */   // Label 1259: @78646
     /*   78646 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78714), // Rule ID 52023 //
     /*   78651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78688 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78712 */     GIR_RootConstrainSelectedInstOperands,
     /*   78713 */     // GIR_Coverage, 52023,
     /*   78713 */     GIR_EraseRootFromParent_Done,
     /*   78714 */   // Label 1260: @78714
     /*   78714 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78769), // Rule ID 47320 //
     /*   78719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78747 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78767 */     GIR_RootConstrainSelectedInstOperands,
     /*   78768 */     // GIR_Coverage, 47320,
     /*   78768 */     GIR_EraseRootFromParent_Done,
     /*   78769 */   // Label 1261: @78769
     /*   78769 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78824), // Rule ID 47321 //
     /*   78774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78802 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78822 */     GIR_RootConstrainSelectedInstOperands,
     /*   78823 */     // GIR_Coverage, 47321,
     /*   78823 */     GIR_EraseRootFromParent_Done,
     /*   78824 */   // Label 1262: @78824
     /*   78824 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78879), // Rule ID 47080 //
     /*   78829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78857 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78877 */     GIR_RootConstrainSelectedInstOperands,
     /*   78878 */     // GIR_Coverage, 47080,
     /*   78878 */     GIR_EraseRootFromParent_Done,
     /*   78879 */   // Label 1263: @78879
     /*   78879 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78934), // Rule ID 47081 //
     /*   78884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78903 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78912 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78932 */     GIR_RootConstrainSelectedInstOperands,
     /*   78933 */     // GIR_Coverage, 47081,
     /*   78933 */     GIR_EraseRootFromParent_Done,
     /*   78934 */   // Label 1264: @78934
     /*   78934 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78989), // Rule ID 47200 //
     /*   78939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78967 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78987 */     GIR_RootConstrainSelectedInstOperands,
     /*   78988 */     // GIR_Coverage, 47200,
     /*   78988 */     GIR_EraseRootFromParent_Done,
     /*   78989 */   // Label 1265: @78989
     /*   78989 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(79044), // Rule ID 47201 //
     /*   78994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   79013 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79022 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79042 */     GIR_RootConstrainSelectedInstOperands,
     /*   79043 */     // GIR_Coverage, 47201,
     /*   79043 */     GIR_EraseRootFromParent_Done,
     /*   79044 */   // Label 1266: @79044
     /*   79044 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(79097), // Rule ID 46296 //
     /*   79049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79060 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   79060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   79063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79095 */     GIR_RootConstrainSelectedInstOperands,
     /*   79096 */     // GIR_Coverage, 46296,
     /*   79096 */     GIR_EraseRootFromParent_Done,
     /*   79097 */   // Label 1267: @79097
     /*   79097 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(79150), // Rule ID 46297 //
     /*   79102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79113 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   79113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   79116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   79145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79148 */     GIR_RootConstrainSelectedInstOperands,
     /*   79149 */     // GIR_Coverage, 46297,
     /*   79149 */     GIR_EraseRootFromParent_Done,
     /*   79150 */   // Label 1268: @79150
     /*   79150 */   GIM_Reject,
     /*   79151 */ // Label 1252: @79151
     /*   79151 */ GIM_Reject,
     /*   79152 */ // Label 991: @79152
     /*   79152 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79398),
     /*   79157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79171 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79235), // Rule ID 51994 //
     /*   79176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79209 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   79212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79233 */     GIR_RootConstrainSelectedInstOperands,
     /*   79234 */     // GIR_Coverage, 51994,
     /*   79234 */     GIR_EraseRootFromParent_Done,
     /*   79235 */   // Label 1270: @79235
     /*   79235 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79299), // Rule ID 51995 //
     /*   79240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   79259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79273 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   79276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79297 */     GIR_RootConstrainSelectedInstOperands,
     /*   79298 */     // GIR_Coverage, 51995,
     /*   79298 */     GIR_EraseRootFromParent_Done,
     /*   79299 */   // Label 1271: @79299
     /*   79299 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79348), // Rule ID 46268 //
     /*   79304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79311 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   79314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   79328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79346 */     GIR_RootConstrainSelectedInstOperands,
     /*   79347 */     // GIR_Coverage, 46268,
     /*   79347 */     GIR_EraseRootFromParent_Done,
     /*   79348 */   // Label 1272: @79348
     /*   79348 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79397), // Rule ID 46269 //
     /*   79353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79360 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   79363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   79377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79395 */     GIR_RootConstrainSelectedInstOperands,
     /*   79396 */     // GIR_Coverage, 46269,
     /*   79396 */     GIR_EraseRootFromParent_Done,
     /*   79397 */   // Label 1273: @79397
     /*   79397 */   GIM_Reject,
     /*   79398 */ // Label 1269: @79398
     /*   79398 */ GIM_Reject,
     /*   79399 */ // Label 992: @79399
     /*   79399 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(80521),
     /*   79404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79414 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79503), // Rule ID 47240 //
     /*   79419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79462 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79501 */     GIR_RootConstrainSelectedInstOperands,
     /*   79502 */     // GIR_Coverage, 47240,
     /*   79502 */     GIR_EraseRootFromParent_Done,
     /*   79503 */   // Label 1275: @79503
     /*   79503 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79592), // Rule ID 47241 //
     /*   79508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79551 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79590 */     GIR_RootConstrainSelectedInstOperands,
     /*   79591 */     // GIR_Coverage, 47241,
     /*   79591 */     GIR_EraseRootFromParent_Done,
     /*   79592 */   // Label 1276: @79592
     /*   79592 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79681), // Rule ID 47000 //
     /*   79597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79640 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79679 */     GIR_RootConstrainSelectedInstOperands,
     /*   79680 */     // GIR_Coverage, 47000,
     /*   79680 */     GIR_EraseRootFromParent_Done,
     /*   79681 */   // Label 1277: @79681
     /*   79681 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79770), // Rule ID 47001 //
     /*   79686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79729 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79768 */     GIR_RootConstrainSelectedInstOperands,
     /*   79769 */     // GIR_Coverage, 47001,
     /*   79769 */     GIR_EraseRootFromParent_Done,
     /*   79770 */   // Label 1278: @79770
     /*   79770 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79859), // Rule ID 47120 //
     /*   79775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79818 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79857 */     GIR_RootConstrainSelectedInstOperands,
     /*   79858 */     // GIR_Coverage, 47120,
     /*   79858 */     GIR_EraseRootFromParent_Done,
     /*   79859 */   // Label 1279: @79859
     /*   79859 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79948), // Rule ID 47121 //
     /*   79864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79879 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79907 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79946 */     GIR_RootConstrainSelectedInstOperands,
     /*   79947 */     // GIR_Coverage, 47121,
     /*   79947 */     GIR_EraseRootFromParent_Done,
     /*   79948 */   // Label 1280: @79948
     /*   79948 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(80016), // Rule ID 52010 //
     /*   79953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79990 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80014 */     GIR_RootConstrainSelectedInstOperands,
     /*   80015 */     // GIR_Coverage, 52010,
     /*   80015 */     GIR_EraseRootFromParent_Done,
     /*   80016 */   // Label 1281: @80016
     /*   80016 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(80084), // Rule ID 52011 //
     /*   80021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   80040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   80044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80058 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   80058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80082 */     GIR_RootConstrainSelectedInstOperands,
     /*   80083 */     // GIR_Coverage, 52011,
     /*   80083 */     GIR_EraseRootFromParent_Done,
     /*   80084 */   // Label 1282: @80084
     /*   80084 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80139), // Rule ID 47300 //
     /*   80089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80117 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80137 */     GIR_RootConstrainSelectedInstOperands,
     /*   80138 */     // GIR_Coverage, 47300,
     /*   80138 */     GIR_EraseRootFromParent_Done,
     /*   80139 */   // Label 1283: @80139
     /*   80139 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80194), // Rule ID 47301 //
     /*   80144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80172 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80192 */     GIR_RootConstrainSelectedInstOperands,
     /*   80193 */     // GIR_Coverage, 47301,
     /*   80193 */     GIR_EraseRootFromParent_Done,
     /*   80194 */   // Label 1284: @80194
     /*   80194 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80249), // Rule ID 47060 //
     /*   80199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80227 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   80230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80247 */     GIR_RootConstrainSelectedInstOperands,
     /*   80248 */     // GIR_Coverage, 47060,
     /*   80248 */     GIR_EraseRootFromParent_Done,
     /*   80249 */   // Label 1285: @80249
     /*   80249 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80304), // Rule ID 47061 //
     /*   80254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80282 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   80285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80302 */     GIR_RootConstrainSelectedInstOperands,
     /*   80303 */     // GIR_Coverage, 47061,
     /*   80303 */     GIR_EraseRootFromParent_Done,
     /*   80304 */   // Label 1286: @80304
     /*   80304 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80359), // Rule ID 47180 //
     /*   80309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80337 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80357 */     GIR_RootConstrainSelectedInstOperands,
     /*   80358 */     // GIR_Coverage, 47180,
     /*   80358 */     GIR_EraseRootFromParent_Done,
     /*   80359 */   // Label 1287: @80359
     /*   80359 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80414), // Rule ID 47181 //
     /*   80364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   80383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   80390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80392 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   80395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80412 */     GIR_RootConstrainSelectedInstOperands,
     /*   80413 */     // GIR_Coverage, 47181,
     /*   80413 */     GIR_EraseRootFromParent_Done,
     /*   80414 */   // Label 1288: @80414
     /*   80414 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80467), // Rule ID 46284 //
     /*   80419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80430 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   80430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80465 */     GIR_RootConstrainSelectedInstOperands,
     /*   80466 */     // GIR_Coverage, 46284,
     /*   80466 */     GIR_EraseRootFromParent_Done,
     /*   80467 */   // Label 1289: @80467
     /*   80467 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(80520), // Rule ID 46285 //
     /*   80472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80483 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80518 */     GIR_RootConstrainSelectedInstOperands,
     /*   80519 */     // GIR_Coverage, 46285,
     /*   80519 */     GIR_EraseRootFromParent_Done,
     /*   80520 */   // Label 1290: @80520
     /*   80520 */   GIM_Reject,
     /*   80521 */ // Label 1274: @80521
     /*   80521 */ GIM_Reject,
     /*   80522 */ // Label 993: @80522
     /*   80522 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(80768),
     /*   80527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80541 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(80605), // Rule ID 51998 //
     /*   80546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80579 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80603 */     GIR_RootConstrainSelectedInstOperands,
     /*   80604 */     // GIR_Coverage, 51998,
     /*   80604 */     GIR_EraseRootFromParent_Done,
     /*   80605 */   // Label 1292: @80605
     /*   80605 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(80669), // Rule ID 51999 //
     /*   80610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80629 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80643 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80667 */     GIR_RootConstrainSelectedInstOperands,
     /*   80668 */     // GIR_Coverage, 51999,
     /*   80668 */     GIR_EraseRootFromParent_Done,
     /*   80669 */   // Label 1293: @80669
     /*   80669 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(80718), // Rule ID 46272 //
     /*   80674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80681 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80716 */     GIR_RootConstrainSelectedInstOperands,
     /*   80717 */     // GIR_Coverage, 46272,
     /*   80717 */     GIR_EraseRootFromParent_Done,
     /*   80718 */   // Label 1294: @80718
     /*   80718 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(80767), // Rule ID 46273 //
     /*   80723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80730 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80765 */     GIR_RootConstrainSelectedInstOperands,
     /*   80766 */     // GIR_Coverage, 46273,
     /*   80766 */     GIR_EraseRootFromParent_Done,
     /*   80767 */   // Label 1295: @80767
     /*   80767 */   GIM_Reject,
     /*   80768 */ // Label 1291: @80768
     /*   80768 */ GIM_Reject,
     /*   80769 */ // Label 994: @80769
     /*   80769 */ GIM_Reject,
     /*   80770 */ // Label 2: @80770
     /*   80770 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1320*/ GIMT_Encode4(107823),
     /*   80781 */ /*GILLT_s32*//*Label 1296*/ GIMT_Encode4(80905),
     /*   80785 */ /*GILLT_s64*//*Label 1297*/ GIMT_Encode4(80939), GIMT_Encode4(0),
     /*   80793 */ /*GILLT_nxv1s8*//*Label 1298*/ GIMT_Encode4(81143),
     /*   80797 */ /*GILLT_nxv1s16*//*Label 1299*/ GIMT_Encode4(81258),
     /*   80801 */ /*GILLT_nxv1s32*//*Label 1300*/ GIMT_Encode4(82983),
     /*   80805 */ /*GILLT_nxv1s64*//*Label 1301*/ GIMT_Encode4(84708), GIMT_Encode4(0),
     /*   80813 */ /*GILLT_nxv2s8*//*Label 1302*/ GIMT_Encode4(86433),
     /*   80817 */ /*GILLT_nxv2s16*//*Label 1303*/ GIMT_Encode4(86548),
     /*   80821 */ /*GILLT_nxv2s32*//*Label 1304*/ GIMT_Encode4(88273),
     /*   80825 */ /*GILLT_nxv2s64*//*Label 1305*/ GIMT_Encode4(89998), GIMT_Encode4(0),
     /*   80833 */ /*GILLT_nxv4s8*//*Label 1306*/ GIMT_Encode4(91723),
     /*   80837 */ /*GILLT_nxv4s16*//*Label 1307*/ GIMT_Encode4(91838),
     /*   80841 */ /*GILLT_nxv4s32*//*Label 1308*/ GIMT_Encode4(93563),
     /*   80845 */ /*GILLT_nxv4s64*//*Label 1309*/ GIMT_Encode4(95288), GIMT_Encode4(0),
     /*   80853 */ /*GILLT_nxv8s8*//*Label 1310*/ GIMT_Encode4(97013),
     /*   80857 */ /*GILLT_nxv8s16*//*Label 1311*/ GIMT_Encode4(97128),
     /*   80861 */ /*GILLT_nxv8s32*//*Label 1312*/ GIMT_Encode4(98853),
     /*   80865 */ /*GILLT_nxv8s64*//*Label 1313*/ GIMT_Encode4(100578), GIMT_Encode4(0),
     /*   80873 */ /*GILLT_nxv16s8*//*Label 1314*/ GIMT_Encode4(102303),
     /*   80877 */ /*GILLT_nxv16s16*//*Label 1315*/ GIMT_Encode4(102418),
     /*   80881 */ /*GILLT_nxv16s32*//*Label 1316*/ GIMT_Encode4(104143), GIMT_Encode4(0),
     /*   80889 */ /*GILLT_nxv32s8*//*Label 1317*/ GIMT_Encode4(105868),
     /*   80893 */ /*GILLT_nxv32s16*//*Label 1318*/ GIMT_Encode4(105983), GIMT_Encode4(0),
     /*   80901 */ /*GILLT_nxv64s8*//*Label 1319*/ GIMT_Encode4(107708),
     /*   80905 */ // Label 1296: @80905
     /*   80905 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80938), // Rule ID 302 //
     /*   80910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80931 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80936 */   GIR_RootConstrainSelectedInstOperands,
     /*   80937 */   // GIR_Coverage, 302,
     /*   80937 */   GIR_Done,
     /*   80938 */ // Label 1321: @80938
     /*   80938 */ GIM_Reject,
     /*   80939 */ // Label 1297: @80939
     /*   80939 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81142),
     /*   80944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80950 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(81083), // Rule ID 324 //
     /*   80955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80983 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   81002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   81006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   81010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81015 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   81026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81028 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   81028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   81031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   81035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81040 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81044 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   81047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   81049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   81052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   81056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   81068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   81073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   81081 */     GIR_RootConstrainSelectedInstOperands,
     /*   81082 */     // GIR_Coverage, 324,
     /*   81082 */     GIR_EraseRootFromParent_Done,
     /*   81083 */   // Label 1323: @81083
     /*   81083 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(81114), // Rule ID 317 //
     /*   81088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   81091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10123),
     /*   81107 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10123>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   81107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   81112 */     GIR_RootConstrainSelectedInstOperands,
     /*   81113 */     // GIR_Coverage, 317,
     /*   81113 */     GIR_Done,
     /*   81114 */   // Label 1324: @81114
     /*   81114 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(81141), // Rule ID 301 //
     /*   81119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   81122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   81134 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   81134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   81139 */     GIR_RootConstrainSelectedInstOperands,
     /*   81140 */     // GIR_Coverage, 301,
     /*   81140 */     GIR_Done,
     /*   81141 */   // Label 1325: @81141
     /*   81141 */   GIM_Reject,
     /*   81142 */ // Label 1322: @81142
     /*   81142 */ GIM_Reject,
     /*   81143 */ // Label 1298: @81143
     /*   81143 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81257),
     /*   81148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   81154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81166 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81211), // Rule ID 50860 //
     /*   81171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81174 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   81177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   81191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81209 */     GIR_RootConstrainSelectedInstOperands,
     /*   81210 */     // GIR_Coverage, 50860,
     /*   81210 */     GIR_EraseRootFromParent_Done,
     /*   81211 */   // Label 1327: @81211
     /*   81211 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81256), // Rule ID 50861 //
     /*   81216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81219 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   81222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   81236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81254 */     GIR_RootConstrainSelectedInstOperands,
     /*   81255 */     // GIR_Coverage, 50861,
     /*   81255 */     GIR_EraseRootFromParent_Done,
     /*   81256 */   // Label 1328: @81256
     /*   81256 */   GIM_Reject,
     /*   81257 */ // Label 1326: @81257
     /*   81257 */ GIM_Reject,
     /*   81258 */ // Label 1299: @81258
     /*   81258 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82982),
     /*   81263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   81266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   81269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81273 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81362), // Rule ID 51626 //
     /*   81278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81293 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81312 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81321 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81360 */     GIR_RootConstrainSelectedInstOperands,
     /*   81361 */     // GIR_Coverage, 51626,
     /*   81361 */     GIR_EraseRootFromParent_Done,
     /*   81362 */   // Label 1330: @81362
     /*   81362 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81451), // Rule ID 51627 //
     /*   81367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81401 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81410 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81449 */     GIR_RootConstrainSelectedInstOperands,
     /*   81450 */     // GIR_Coverage, 51627,
     /*   81450 */     GIR_EraseRootFromParent_Done,
     /*   81451 */   // Label 1331: @81451
     /*   81451 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81540), // Rule ID 70623 //
     /*   81456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81490 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81499 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81538 */     GIR_RootConstrainSelectedInstOperands,
     /*   81539 */     // GIR_Coverage, 70623,
     /*   81539 */     GIR_EraseRootFromParent_Done,
     /*   81540 */   // Label 1332: @81540
     /*   81540 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81629), // Rule ID 70624 //
     /*   81545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81588 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81627 */     GIR_RootConstrainSelectedInstOperands,
     /*   81628 */     // GIR_Coverage, 70624,
     /*   81628 */     GIR_EraseRootFromParent_Done,
     /*   81629 */   // Label 1333: @81629
     /*   81629 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81718), // Rule ID 70503 //
     /*   81634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81677 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81716 */     GIR_RootConstrainSelectedInstOperands,
     /*   81717 */     // GIR_Coverage, 70503,
     /*   81717 */     GIR_EraseRootFromParent_Done,
     /*   81718 */   // Label 1334: @81718
     /*   81718 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81807), // Rule ID 70504 //
     /*   81723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81766 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81805 */     GIR_RootConstrainSelectedInstOperands,
     /*   81806 */     // GIR_Coverage, 70504,
     /*   81806 */     GIR_EraseRootFromParent_Done,
     /*   81807 */   // Label 1335: @81807
     /*   81807 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81896), // Rule ID 51806 //
     /*   81812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81855 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81894 */     GIR_RootConstrainSelectedInstOperands,
     /*   81895 */     // GIR_Coverage, 51806,
     /*   81895 */     GIR_EraseRootFromParent_Done,
     /*   81896 */   // Label 1336: @81896
     /*   81896 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(81985), // Rule ID 51807 //
     /*   81901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81944 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81983 */     GIR_RootConstrainSelectedInstOperands,
     /*   81984 */     // GIR_Coverage, 51807,
     /*   81984 */     GIR_EraseRootFromParent_Done,
     /*   81985 */   // Label 1337: @81985
     /*   81985 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82074), // Rule ID 51506 //
     /*   81990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82033 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   82050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82072 */     GIR_RootConstrainSelectedInstOperands,
     /*   82073 */     // GIR_Coverage, 51506,
     /*   82073 */     GIR_EraseRootFromParent_Done,
     /*   82074 */   // Label 1338: @82074
     /*   82074 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82163), // Rule ID 51507 //
     /*   82079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82122 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   82139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82161 */     GIR_RootConstrainSelectedInstOperands,
     /*   82162 */     // GIR_Coverage, 51507,
     /*   82162 */     GIR_EraseRootFromParent_Done,
     /*   82163 */   // Label 1339: @82163
     /*   82163 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82252), // Rule ID 51746 //
     /*   82168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82211 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82250 */     GIR_RootConstrainSelectedInstOperands,
     /*   82251 */     // GIR_Coverage, 51746,
     /*   82251 */     GIR_EraseRootFromParent_Done,
     /*   82252 */   // Label 1340: @82252
     /*   82252 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82341), // Rule ID 51747 //
     /*   82257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82300 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82339 */     GIR_RootConstrainSelectedInstOperands,
     /*   82340 */     // GIR_Coverage, 51747,
     /*   82340 */     GIR_EraseRootFromParent_Done,
     /*   82341 */   // Label 1341: @82341
     /*   82341 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82430), // Rule ID 51686 //
     /*   82346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82389 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82428 */     GIR_RootConstrainSelectedInstOperands,
     /*   82429 */     // GIR_Coverage, 51686,
     /*   82429 */     GIR_EraseRootFromParent_Done,
     /*   82430 */   // Label 1342: @82430
     /*   82430 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82519), // Rule ID 51687 //
     /*   82435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82478 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82517 */     GIR_RootConstrainSelectedInstOperands,
     /*   82518 */     // GIR_Coverage, 51687,
     /*   82518 */     GIR_EraseRootFromParent_Done,
     /*   82519 */   // Label 1343: @82519
     /*   82519 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(82608), // Rule ID 70563 //
     /*   82524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82567 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82606 */     GIR_RootConstrainSelectedInstOperands,
     /*   82607 */     // GIR_Coverage, 70563,
     /*   82607 */     GIR_EraseRootFromParent_Done,
     /*   82608 */   // Label 1344: @82608
     /*   82608 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82697), // Rule ID 70564 //
     /*   82613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82656 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82695 */     GIR_RootConstrainSelectedInstOperands,
     /*   82696 */     // GIR_Coverage, 70564,
     /*   82696 */     GIR_EraseRootFromParent_Done,
     /*   82697 */   // Label 1345: @82697
     /*   82697 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82786), // Rule ID 51566 //
     /*   82702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82745 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82784 */     GIR_RootConstrainSelectedInstOperands,
     /*   82785 */     // GIR_Coverage, 51566,
     /*   82785 */     GIR_EraseRootFromParent_Done,
     /*   82786 */   // Label 1346: @82786
     /*   82786 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82875), // Rule ID 51567 //
     /*   82791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82834 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82873 */     GIR_RootConstrainSelectedInstOperands,
     /*   82874 */     // GIR_Coverage, 51567,
     /*   82874 */     GIR_EraseRootFromParent_Done,
     /*   82875 */   // Label 1347: @82875
     /*   82875 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82928), // Rule ID 50872 //
     /*   82880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82891 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82926 */     GIR_RootConstrainSelectedInstOperands,
     /*   82927 */     // GIR_Coverage, 50872,
     /*   82927 */     GIR_EraseRootFromParent_Done,
     /*   82928 */   // Label 1348: @82928
     /*   82928 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82981), // Rule ID 50873 //
     /*   82933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82944 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82979 */     GIR_RootConstrainSelectedInstOperands,
     /*   82980 */     // GIR_Coverage, 50873,
     /*   82980 */     GIR_EraseRootFromParent_Done,
     /*   82981 */   // Label 1349: @82981
     /*   82981 */   GIM_Reject,
     /*   82982 */ // Label 1329: @82982
     /*   82982 */ GIM_Reject,
     /*   82983 */ // Label 1300: @82983
     /*   82983 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(84707),
     /*   82988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   82994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82998 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83087), // Rule ID 51650 //
     /*   83003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83046 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83085 */     GIR_RootConstrainSelectedInstOperands,
     /*   83086 */     // GIR_Coverage, 51650,
     /*   83086 */     GIR_EraseRootFromParent_Done,
     /*   83087 */   // Label 1351: @83087
     /*   83087 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83176), // Rule ID 51651 //
     /*   83092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83126 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83135 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83174 */     GIR_RootConstrainSelectedInstOperands,
     /*   83175 */     // GIR_Coverage, 51651,
     /*   83175 */     GIR_EraseRootFromParent_Done,
     /*   83176 */   // Label 1352: @83176
     /*   83176 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83265), // Rule ID 70647 //
     /*   83181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83224 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83263 */     GIR_RootConstrainSelectedInstOperands,
     /*   83264 */     // GIR_Coverage, 70647,
     /*   83264 */     GIR_EraseRootFromParent_Done,
     /*   83265 */   // Label 1353: @83265
     /*   83265 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83354), // Rule ID 70648 //
     /*   83270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83304 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83313 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83352 */     GIR_RootConstrainSelectedInstOperands,
     /*   83353 */     // GIR_Coverage, 70648,
     /*   83353 */     GIR_EraseRootFromParent_Done,
     /*   83354 */   // Label 1354: @83354
     /*   83354 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83443), // Rule ID 70527 //
     /*   83359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83393 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83402 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83441 */     GIR_RootConstrainSelectedInstOperands,
     /*   83442 */     // GIR_Coverage, 70527,
     /*   83442 */     GIR_EraseRootFromParent_Done,
     /*   83443 */   // Label 1355: @83443
     /*   83443 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83532), // Rule ID 70528 //
     /*   83448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83463 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83482 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83491 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83530 */     GIR_RootConstrainSelectedInstOperands,
     /*   83531 */     // GIR_Coverage, 70528,
     /*   83531 */     GIR_EraseRootFromParent_Done,
     /*   83532 */   // Label 1356: @83532
     /*   83532 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83621), // Rule ID 51830 //
     /*   83537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83580 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83619 */     GIR_RootConstrainSelectedInstOperands,
     /*   83620 */     // GIR_Coverage, 51830,
     /*   83620 */     GIR_EraseRootFromParent_Done,
     /*   83621 */   // Label 1357: @83621
     /*   83621 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83710), // Rule ID 51831 //
     /*   83626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83669 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83708 */     GIR_RootConstrainSelectedInstOperands,
     /*   83709 */     // GIR_Coverage, 51831,
     /*   83709 */     GIR_EraseRootFromParent_Done,
     /*   83710 */   // Label 1358: @83710
     /*   83710 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83799), // Rule ID 51530 //
     /*   83715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83758 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83797 */     GIR_RootConstrainSelectedInstOperands,
     /*   83798 */     // GIR_Coverage, 51530,
     /*   83798 */     GIR_EraseRootFromParent_Done,
     /*   83799 */   // Label 1359: @83799
     /*   83799 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83888), // Rule ID 51531 //
     /*   83804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83847 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83886 */     GIR_RootConstrainSelectedInstOperands,
     /*   83887 */     // GIR_Coverage, 51531,
     /*   83887 */     GIR_EraseRootFromParent_Done,
     /*   83888 */   // Label 1360: @83888
     /*   83888 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(83977), // Rule ID 51770 //
     /*   83893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83936 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83975 */     GIR_RootConstrainSelectedInstOperands,
     /*   83976 */     // GIR_Coverage, 51770,
     /*   83976 */     GIR_EraseRootFromParent_Done,
     /*   83977 */   // Label 1361: @83977
     /*   83977 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84066), // Rule ID 51771 //
     /*   83982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84025 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84064 */     GIR_RootConstrainSelectedInstOperands,
     /*   84065 */     // GIR_Coverage, 51771,
     /*   84065 */     GIR_EraseRootFromParent_Done,
     /*   84066 */   // Label 1362: @84066
     /*   84066 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84155), // Rule ID 51710 //
     /*   84071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84114 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84153 */     GIR_RootConstrainSelectedInstOperands,
     /*   84154 */     // GIR_Coverage, 51710,
     /*   84154 */     GIR_EraseRootFromParent_Done,
     /*   84155 */   // Label 1363: @84155
     /*   84155 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84244), // Rule ID 51711 //
     /*   84160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84203 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84242 */     GIR_RootConstrainSelectedInstOperands,
     /*   84243 */     // GIR_Coverage, 51711,
     /*   84243 */     GIR_EraseRootFromParent_Done,
     /*   84244 */   // Label 1364: @84244
     /*   84244 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(84333), // Rule ID 70587 //
     /*   84249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84292 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84331 */     GIR_RootConstrainSelectedInstOperands,
     /*   84332 */     // GIR_Coverage, 70587,
     /*   84332 */     GIR_EraseRootFromParent_Done,
     /*   84333 */   // Label 1365: @84333
     /*   84333 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84422), // Rule ID 70588 //
     /*   84338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84381 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   84398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84420 */     GIR_RootConstrainSelectedInstOperands,
     /*   84421 */     // GIR_Coverage, 70588,
     /*   84421 */     GIR_EraseRootFromParent_Done,
     /*   84422 */   // Label 1366: @84422
     /*   84422 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84511), // Rule ID 51590 //
     /*   84427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84470 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84509 */     GIR_RootConstrainSelectedInstOperands,
     /*   84510 */     // GIR_Coverage, 51590,
     /*   84510 */     GIR_EraseRootFromParent_Done,
     /*   84511 */   // Label 1367: @84511
     /*   84511 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84600), // Rule ID 51591 //
     /*   84516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84559 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84598 */     GIR_RootConstrainSelectedInstOperands,
     /*   84599 */     // GIR_Coverage, 51591,
     /*   84599 */     GIR_EraseRootFromParent_Done,
     /*   84600 */   // Label 1368: @84600
     /*   84600 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84653), // Rule ID 50880 //
     /*   84605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84616 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84651 */     GIR_RootConstrainSelectedInstOperands,
     /*   84652 */     // GIR_Coverage, 50880,
     /*   84652 */     GIR_EraseRootFromParent_Done,
     /*   84653 */   // Label 1369: @84653
     /*   84653 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84706), // Rule ID 50881 //
     /*   84658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84669 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84704 */     GIR_RootConstrainSelectedInstOperands,
     /*   84705 */     // GIR_Coverage, 50881,
     /*   84705 */     GIR_EraseRootFromParent_Done,
     /*   84706 */   // Label 1370: @84706
     /*   84706 */   GIM_Reject,
     /*   84707 */ // Label 1350: @84707
     /*   84707 */ GIM_Reject,
     /*   84708 */ // Label 1301: @84708
     /*   84708 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(86432),
     /*   84713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84723 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84812), // Rule ID 51670 //
     /*   84728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84762 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84771 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84810 */     GIR_RootConstrainSelectedInstOperands,
     /*   84811 */     // GIR_Coverage, 51670,
     /*   84811 */     GIR_EraseRootFromParent_Done,
     /*   84812 */   // Label 1372: @84812
     /*   84812 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84901), // Rule ID 51671 //
     /*   84817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84851 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84860 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84899 */     GIR_RootConstrainSelectedInstOperands,
     /*   84900 */     // GIR_Coverage, 51671,
     /*   84900 */     GIR_EraseRootFromParent_Done,
     /*   84901 */   // Label 1373: @84901
     /*   84901 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(84990), // Rule ID 70667 //
     /*   84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84949 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84988 */     GIR_RootConstrainSelectedInstOperands,
     /*   84989 */     // GIR_Coverage, 70667,
     /*   84989 */     GIR_EraseRootFromParent_Done,
     /*   84990 */   // Label 1374: @84990
     /*   84990 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85079), // Rule ID 70668 //
     /*   84995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85010 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85029 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85038 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85077 */     GIR_RootConstrainSelectedInstOperands,
     /*   85078 */     // GIR_Coverage, 70668,
     /*   85078 */     GIR_EraseRootFromParent_Done,
     /*   85079 */   // Label 1375: @85079
     /*   85079 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85168), // Rule ID 70547 //
     /*   85084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85118 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85127 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85166 */     GIR_RootConstrainSelectedInstOperands,
     /*   85167 */     // GIR_Coverage, 70547,
     /*   85167 */     GIR_EraseRootFromParent_Done,
     /*   85168 */   // Label 1376: @85168
     /*   85168 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85257), // Rule ID 70548 //
     /*   85173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85188 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85207 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85216 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85255 */     GIR_RootConstrainSelectedInstOperands,
     /*   85256 */     // GIR_Coverage, 70548,
     /*   85256 */     GIR_EraseRootFromParent_Done,
     /*   85257 */   // Label 1377: @85257
     /*   85257 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85346), // Rule ID 51850 //
     /*   85262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85305 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85344 */     GIR_RootConstrainSelectedInstOperands,
     /*   85345 */     // GIR_Coverage, 51850,
     /*   85345 */     GIR_EraseRootFromParent_Done,
     /*   85346 */   // Label 1378: @85346
     /*   85346 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85435), // Rule ID 51851 //
     /*   85351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85394 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85433 */     GIR_RootConstrainSelectedInstOperands,
     /*   85434 */     // GIR_Coverage, 51851,
     /*   85434 */     GIR_EraseRootFromParent_Done,
     /*   85435 */   // Label 1379: @85435
     /*   85435 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85524), // Rule ID 51550 //
     /*   85440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85483 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85522 */     GIR_RootConstrainSelectedInstOperands,
     /*   85523 */     // GIR_Coverage, 51550,
     /*   85523 */     GIR_EraseRootFromParent_Done,
     /*   85524 */   // Label 1380: @85524
     /*   85524 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85613), // Rule ID 51551 //
     /*   85529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85572 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85611 */     GIR_RootConstrainSelectedInstOperands,
     /*   85612 */     // GIR_Coverage, 51551,
     /*   85612 */     GIR_EraseRootFromParent_Done,
     /*   85613 */   // Label 1381: @85613
     /*   85613 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85702), // Rule ID 51790 //
     /*   85618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85661 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85700 */     GIR_RootConstrainSelectedInstOperands,
     /*   85701 */     // GIR_Coverage, 51790,
     /*   85701 */     GIR_EraseRootFromParent_Done,
     /*   85702 */   // Label 1382: @85702
     /*   85702 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85791), // Rule ID 51791 //
     /*   85707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85750 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85789 */     GIR_RootConstrainSelectedInstOperands,
     /*   85790 */     // GIR_Coverage, 51791,
     /*   85790 */     GIR_EraseRootFromParent_Done,
     /*   85791 */   // Label 1383: @85791
     /*   85791 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85880), // Rule ID 51730 //
     /*   85796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85839 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85878 */     GIR_RootConstrainSelectedInstOperands,
     /*   85879 */     // GIR_Coverage, 51730,
     /*   85879 */     GIR_EraseRootFromParent_Done,
     /*   85880 */   // Label 1384: @85880
     /*   85880 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85969), // Rule ID 51731 //
     /*   85885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85919 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85928 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85967 */     GIR_RootConstrainSelectedInstOperands,
     /*   85968 */     // GIR_Coverage, 51731,
     /*   85968 */     GIR_EraseRootFromParent_Done,
     /*   85969 */   // Label 1385: @85969
     /*   85969 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86058), // Rule ID 70607 //
     /*   85974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86017 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   86034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86056 */     GIR_RootConstrainSelectedInstOperands,
     /*   86057 */     // GIR_Coverage, 70607,
     /*   86057 */     GIR_EraseRootFromParent_Done,
     /*   86058 */   // Label 1386: @86058
     /*   86058 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86147), // Rule ID 70608 //
     /*   86063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86097 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86106 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   86123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86145 */     GIR_RootConstrainSelectedInstOperands,
     /*   86146 */     // GIR_Coverage, 70608,
     /*   86146 */     GIR_EraseRootFromParent_Done,
     /*   86147 */   // Label 1387: @86147
     /*   86147 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86236), // Rule ID 51610 //
     /*   86152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86195 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   86212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86234 */     GIR_RootConstrainSelectedInstOperands,
     /*   86235 */     // GIR_Coverage, 51610,
     /*   86235 */     GIR_EraseRootFromParent_Done,
     /*   86236 */   // Label 1388: @86236
     /*   86236 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(86325), // Rule ID 51611 //
     /*   86241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   86275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86284 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   86301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86323 */     GIR_RootConstrainSelectedInstOperands,
     /*   86324 */     // GIR_Coverage, 51611,
     /*   86324 */     GIR_EraseRootFromParent_Done,
     /*   86325 */   // Label 1389: @86325
     /*   86325 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86378), // Rule ID 50896 //
     /*   86330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   86333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86341 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   86341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   86358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   86373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86376 */     GIR_RootConstrainSelectedInstOperands,
     /*   86377 */     // GIR_Coverage, 50896,
     /*   86377 */     GIR_EraseRootFromParent_Done,
     /*   86378 */   // Label 1390: @86378
     /*   86378 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86431), // Rule ID 50897 //
     /*   86383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   86386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86394 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   86394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   86397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   86411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   86426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86429 */     GIR_RootConstrainSelectedInstOperands,
     /*   86430 */     // GIR_Coverage, 50897,
     /*   86430 */     GIR_EraseRootFromParent_Done,
     /*   86431 */   // Label 1391: @86431
     /*   86431 */   GIM_Reject,
     /*   86432 */ // Label 1371: @86432
     /*   86432 */ GIM_Reject,
     /*   86433 */ // Label 1302: @86433
     /*   86433 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86547),
     /*   86438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   86444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86456 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86501), // Rule ID 50864 //
     /*   86461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86464 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86499 */     GIR_RootConstrainSelectedInstOperands,
     /*   86500 */     // GIR_Coverage, 50864,
     /*   86500 */     GIR_EraseRootFromParent_Done,
     /*   86501 */   // Label 1393: @86501
     /*   86501 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86546), // Rule ID 50865 //
     /*   86506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86509 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86544 */     GIR_RootConstrainSelectedInstOperands,
     /*   86545 */     // GIR_Coverage, 50865,
     /*   86545 */     GIR_EraseRootFromParent_Done,
     /*   86546 */   // Label 1394: @86546
     /*   86546 */   GIM_Reject,
     /*   86547 */ // Label 1392: @86547
     /*   86547 */ GIM_Reject,
     /*   86548 */ // Label 1303: @86548
     /*   86548 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(88272),
     /*   86553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86563 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86652), // Rule ID 51630 //
     /*   86568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86583 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86611 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86650 */     GIR_RootConstrainSelectedInstOperands,
     /*   86651 */     // GIR_Coverage, 51630,
     /*   86651 */     GIR_EraseRootFromParent_Done,
     /*   86652 */   // Label 1396: @86652
     /*   86652 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86741), // Rule ID 51631 //
     /*   86657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86691 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86700 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86739 */     GIR_RootConstrainSelectedInstOperands,
     /*   86740 */     // GIR_Coverage, 51631,
     /*   86740 */     GIR_EraseRootFromParent_Done,
     /*   86741 */   // Label 1397: @86741
     /*   86741 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86830), // Rule ID 70627 //
     /*   86746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86780 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86789 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86828 */     GIR_RootConstrainSelectedInstOperands,
     /*   86829 */     // GIR_Coverage, 70627,
     /*   86829 */     GIR_EraseRootFromParent_Done,
     /*   86830 */   // Label 1398: @86830
     /*   86830 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86919), // Rule ID 70628 //
     /*   86835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86869 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86878 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86917 */     GIR_RootConstrainSelectedInstOperands,
     /*   86918 */     // GIR_Coverage, 70628,
     /*   86918 */     GIR_EraseRootFromParent_Done,
     /*   86919 */   // Label 1399: @86919
     /*   86919 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87008), // Rule ID 70507 //
     /*   86924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86939 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86967 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87006 */     GIR_RootConstrainSelectedInstOperands,
     /*   87007 */     // GIR_Coverage, 70507,
     /*   87007 */     GIR_EraseRootFromParent_Done,
     /*   87008 */   // Label 1400: @87008
     /*   87008 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87097), // Rule ID 70508 //
     /*   87013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87056 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87095 */     GIR_RootConstrainSelectedInstOperands,
     /*   87096 */     // GIR_Coverage, 70508,
     /*   87096 */     GIR_EraseRootFromParent_Done,
     /*   87097 */   // Label 1401: @87097
     /*   87097 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87186), // Rule ID 51810 //
     /*   87102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87145 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87184 */     GIR_RootConstrainSelectedInstOperands,
     /*   87185 */     // GIR_Coverage, 51810,
     /*   87185 */     GIR_EraseRootFromParent_Done,
     /*   87186 */   // Label 1402: @87186
     /*   87186 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87275), // Rule ID 51811 //
     /*   87191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87234 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87273 */     GIR_RootConstrainSelectedInstOperands,
     /*   87274 */     // GIR_Coverage, 51811,
     /*   87274 */     GIR_EraseRootFromParent_Done,
     /*   87275 */   // Label 1403: @87275
     /*   87275 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87364), // Rule ID 51510 //
     /*   87280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87323 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   87340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87362 */     GIR_RootConstrainSelectedInstOperands,
     /*   87363 */     // GIR_Coverage, 51510,
     /*   87363 */     GIR_EraseRootFromParent_Done,
     /*   87364 */   // Label 1404: @87364
     /*   87364 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87453), // Rule ID 51511 //
     /*   87369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87412 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   87429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87451 */     GIR_RootConstrainSelectedInstOperands,
     /*   87452 */     // GIR_Coverage, 51511,
     /*   87452 */     GIR_EraseRootFromParent_Done,
     /*   87453 */   // Label 1405: @87453
     /*   87453 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87542), // Rule ID 51750 //
     /*   87458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87501 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87540 */     GIR_RootConstrainSelectedInstOperands,
     /*   87541 */     // GIR_Coverage, 51750,
     /*   87541 */     GIR_EraseRootFromParent_Done,
     /*   87542 */   // Label 1406: @87542
     /*   87542 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87631), // Rule ID 51751 //
     /*   87547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87590 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87629 */     GIR_RootConstrainSelectedInstOperands,
     /*   87630 */     // GIR_Coverage, 51751,
     /*   87630 */     GIR_EraseRootFromParent_Done,
     /*   87631 */   // Label 1407: @87631
     /*   87631 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87720), // Rule ID 51690 //
     /*   87636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87679 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87718 */     GIR_RootConstrainSelectedInstOperands,
     /*   87719 */     // GIR_Coverage, 51690,
     /*   87719 */     GIR_EraseRootFromParent_Done,
     /*   87720 */   // Label 1408: @87720
     /*   87720 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87809), // Rule ID 51691 //
     /*   87725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87768 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87807 */     GIR_RootConstrainSelectedInstOperands,
     /*   87808 */     // GIR_Coverage, 51691,
     /*   87808 */     GIR_EraseRootFromParent_Done,
     /*   87809 */   // Label 1409: @87809
     /*   87809 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(87898), // Rule ID 70567 //
     /*   87814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87857 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87896 */     GIR_RootConstrainSelectedInstOperands,
     /*   87897 */     // GIR_Coverage, 70567,
     /*   87897 */     GIR_EraseRootFromParent_Done,
     /*   87898 */   // Label 1410: @87898
     /*   87898 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87987), // Rule ID 70568 //
     /*   87903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87946 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87985 */     GIR_RootConstrainSelectedInstOperands,
     /*   87986 */     // GIR_Coverage, 70568,
     /*   87986 */     GIR_EraseRootFromParent_Done,
     /*   87987 */   // Label 1411: @87987
     /*   87987 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88076), // Rule ID 51570 //
     /*   87992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88035 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   88052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88074 */     GIR_RootConstrainSelectedInstOperands,
     /*   88075 */     // GIR_Coverage, 51570,
     /*   88075 */     GIR_EraseRootFromParent_Done,
     /*   88076 */   // Label 1412: @88076
     /*   88076 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88165), // Rule ID 51571 //
     /*   88081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   88115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88124 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   88141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88163 */     GIR_RootConstrainSelectedInstOperands,
     /*   88164 */     // GIR_Coverage, 51571,
     /*   88164 */     GIR_EraseRootFromParent_Done,
     /*   88165 */   // Label 1413: @88165
     /*   88165 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88218), // Rule ID 50876 //
     /*   88170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88181 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   88198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88216 */     GIR_RootConstrainSelectedInstOperands,
     /*   88217 */     // GIR_Coverage, 50876,
     /*   88217 */     GIR_EraseRootFromParent_Done,
     /*   88218 */   // Label 1414: @88218
     /*   88218 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88271), // Rule ID 50877 //
     /*   88223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88234 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   88237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   88251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88269 */     GIR_RootConstrainSelectedInstOperands,
     /*   88270 */     // GIR_Coverage, 50877,
     /*   88270 */     GIR_EraseRootFromParent_Done,
     /*   88271 */   // Label 1415: @88271
     /*   88271 */   GIM_Reject,
     /*   88272 */ // Label 1395: @88272
     /*   88272 */ GIM_Reject,
     /*   88273 */ // Label 1304: @88273
     /*   88273 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(89997),
     /*   88278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   88281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   88284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88288 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88377), // Rule ID 51654 //
     /*   88293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88327 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88336 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88375 */     GIR_RootConstrainSelectedInstOperands,
     /*   88376 */     // GIR_Coverage, 51654,
     /*   88376 */     GIR_EraseRootFromParent_Done,
     /*   88377 */   // Label 1417: @88377
     /*   88377 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88466), // Rule ID 51655 //
     /*   88382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88425 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88464 */     GIR_RootConstrainSelectedInstOperands,
     /*   88465 */     // GIR_Coverage, 51655,
     /*   88465 */     GIR_EraseRootFromParent_Done,
     /*   88466 */   // Label 1418: @88466
     /*   88466 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88555), // Rule ID 70651 //
     /*   88471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88505 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88514 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88553 */     GIR_RootConstrainSelectedInstOperands,
     /*   88554 */     // GIR_Coverage, 70651,
     /*   88554 */     GIR_EraseRootFromParent_Done,
     /*   88555 */   // Label 1419: @88555
     /*   88555 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88644), // Rule ID 70652 //
     /*   88560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88575 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88603 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88642 */     GIR_RootConstrainSelectedInstOperands,
     /*   88643 */     // GIR_Coverage, 70652,
     /*   88643 */     GIR_EraseRootFromParent_Done,
     /*   88644 */   // Label 1420: @88644
     /*   88644 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88733), // Rule ID 70531 //
     /*   88649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88664 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88683 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88692 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88731 */     GIR_RootConstrainSelectedInstOperands,
     /*   88732 */     // GIR_Coverage, 70531,
     /*   88732 */     GIR_EraseRootFromParent_Done,
     /*   88733 */   // Label 1421: @88733
     /*   88733 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88822), // Rule ID 70532 //
     /*   88738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88772 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88781 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88820 */     GIR_RootConstrainSelectedInstOperands,
     /*   88821 */     // GIR_Coverage, 70532,
     /*   88821 */     GIR_EraseRootFromParent_Done,
     /*   88822 */   // Label 1422: @88822
     /*   88822 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88911), // Rule ID 51834 //
     /*   88827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88870 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88909 */     GIR_RootConstrainSelectedInstOperands,
     /*   88910 */     // GIR_Coverage, 51834,
     /*   88910 */     GIR_EraseRootFromParent_Done,
     /*   88911 */   // Label 1423: @88911
     /*   88911 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89000), // Rule ID 51835 //
     /*   88916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88959 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88998 */     GIR_RootConstrainSelectedInstOperands,
     /*   88999 */     // GIR_Coverage, 51835,
     /*   88999 */     GIR_EraseRootFromParent_Done,
     /*   89000 */   // Label 1424: @89000
     /*   89000 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89089), // Rule ID 51534 //
     /*   89005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89048 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   89065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89087 */     GIR_RootConstrainSelectedInstOperands,
     /*   89088 */     // GIR_Coverage, 51534,
     /*   89088 */     GIR_EraseRootFromParent_Done,
     /*   89089 */   // Label 1425: @89089
     /*   89089 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89178), // Rule ID 51535 //
     /*   89094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89137 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   89154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89176 */     GIR_RootConstrainSelectedInstOperands,
     /*   89177 */     // GIR_Coverage, 51535,
     /*   89177 */     GIR_EraseRootFromParent_Done,
     /*   89178 */   // Label 1426: @89178
     /*   89178 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89267), // Rule ID 51774 //
     /*   89183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89226 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89265 */     GIR_RootConstrainSelectedInstOperands,
     /*   89266 */     // GIR_Coverage, 51774,
     /*   89266 */     GIR_EraseRootFromParent_Done,
     /*   89267 */   // Label 1427: @89267
     /*   89267 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89356), // Rule ID 51775 //
     /*   89272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89315 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89354 */     GIR_RootConstrainSelectedInstOperands,
     /*   89355 */     // GIR_Coverage, 51775,
     /*   89355 */     GIR_EraseRootFromParent_Done,
     /*   89356 */   // Label 1428: @89356
     /*   89356 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89445), // Rule ID 51714 //
     /*   89361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89404 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89443 */     GIR_RootConstrainSelectedInstOperands,
     /*   89444 */     // GIR_Coverage, 51714,
     /*   89444 */     GIR_EraseRootFromParent_Done,
     /*   89445 */   // Label 1429: @89445
     /*   89445 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89534), // Rule ID 51715 //
     /*   89450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89493 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89532 */     GIR_RootConstrainSelectedInstOperands,
     /*   89533 */     // GIR_Coverage, 51715,
     /*   89533 */     GIR_EraseRootFromParent_Done,
     /*   89534 */   // Label 1430: @89534
     /*   89534 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(89623), // Rule ID 70591 //
     /*   89539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89582 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89621 */     GIR_RootConstrainSelectedInstOperands,
     /*   89622 */     // GIR_Coverage, 70591,
     /*   89622 */     GIR_EraseRootFromParent_Done,
     /*   89623 */   // Label 1431: @89623
     /*   89623 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89712), // Rule ID 70592 //
     /*   89628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89671 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89710 */     GIR_RootConstrainSelectedInstOperands,
     /*   89711 */     // GIR_Coverage, 70592,
     /*   89711 */     GIR_EraseRootFromParent_Done,
     /*   89712 */   // Label 1432: @89712
     /*   89712 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89801), // Rule ID 51594 //
     /*   89717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89760 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89799 */     GIR_RootConstrainSelectedInstOperands,
     /*   89800 */     // GIR_Coverage, 51594,
     /*   89800 */     GIR_EraseRootFromParent_Done,
     /*   89801 */   // Label 1433: @89801
     /*   89801 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89890), // Rule ID 51595 //
     /*   89806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89849 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89888 */     GIR_RootConstrainSelectedInstOperands,
     /*   89889 */     // GIR_Coverage, 51595,
     /*   89889 */     GIR_EraseRootFromParent_Done,
     /*   89890 */   // Label 1434: @89890
     /*   89890 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89943), // Rule ID 50892 //
     /*   89895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89906 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89941 */     GIR_RootConstrainSelectedInstOperands,
     /*   89942 */     // GIR_Coverage, 50892,
     /*   89942 */     GIR_EraseRootFromParent_Done,
     /*   89943 */   // Label 1435: @89943
     /*   89943 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(89996), // Rule ID 50893 //
     /*   89948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89959 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89994 */     GIR_RootConstrainSelectedInstOperands,
     /*   89995 */     // GIR_Coverage, 50893,
     /*   89995 */     GIR_EraseRootFromParent_Done,
     /*   89996 */   // Label 1436: @89996
     /*   89996 */   GIM_Reject,
     /*   89997 */ // Label 1416: @89997
     /*   89997 */ GIM_Reject,
     /*   89998 */ // Label 1305: @89998
     /*   89998 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91722),
     /*   90003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   90006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   90009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90013 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90102), // Rule ID 51674 //
     /*   90018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90052 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90061 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90100 */     GIR_RootConstrainSelectedInstOperands,
     /*   90101 */     // GIR_Coverage, 51674,
     /*   90101 */     GIR_EraseRootFromParent_Done,
     /*   90102 */   // Label 1438: @90102
     /*   90102 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90191), // Rule ID 51675 //
     /*   90107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90141 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90150 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90189 */     GIR_RootConstrainSelectedInstOperands,
     /*   90190 */     // GIR_Coverage, 51675,
     /*   90190 */     GIR_EraseRootFromParent_Done,
     /*   90191 */   // Label 1439: @90191
     /*   90191 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90280), // Rule ID 70671 //
     /*   90196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90211 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90230 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90239 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90278 */     GIR_RootConstrainSelectedInstOperands,
     /*   90279 */     // GIR_Coverage, 70671,
     /*   90279 */     GIR_EraseRootFromParent_Done,
     /*   90280 */   // Label 1440: @90280
     /*   90280 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90369), // Rule ID 70672 //
     /*   90285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90319 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90328 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90367 */     GIR_RootConstrainSelectedInstOperands,
     /*   90368 */     // GIR_Coverage, 70672,
     /*   90368 */     GIR_EraseRootFromParent_Done,
     /*   90369 */   // Label 1441: @90369
     /*   90369 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90458), // Rule ID 70551 //
     /*   90374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90389 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90408 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90417 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90456 */     GIR_RootConstrainSelectedInstOperands,
     /*   90457 */     // GIR_Coverage, 70551,
     /*   90457 */     GIR_EraseRootFromParent_Done,
     /*   90458 */   // Label 1442: @90458
     /*   90458 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90547), // Rule ID 70552 //
     /*   90463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90497 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90506 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90545 */     GIR_RootConstrainSelectedInstOperands,
     /*   90546 */     // GIR_Coverage, 70552,
     /*   90546 */     GIR_EraseRootFromParent_Done,
     /*   90547 */   // Label 1443: @90547
     /*   90547 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90636), // Rule ID 51854 //
     /*   90552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90595 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90634 */     GIR_RootConstrainSelectedInstOperands,
     /*   90635 */     // GIR_Coverage, 51854,
     /*   90635 */     GIR_EraseRootFromParent_Done,
     /*   90636 */   // Label 1444: @90636
     /*   90636 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90725), // Rule ID 51855 //
     /*   90641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90684 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90723 */     GIR_RootConstrainSelectedInstOperands,
     /*   90724 */     // GIR_Coverage, 51855,
     /*   90724 */     GIR_EraseRootFromParent_Done,
     /*   90725 */   // Label 1445: @90725
     /*   90725 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90814), // Rule ID 51554 //
     /*   90730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90773 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90812 */     GIR_RootConstrainSelectedInstOperands,
     /*   90813 */     // GIR_Coverage, 51554,
     /*   90813 */     GIR_EraseRootFromParent_Done,
     /*   90814 */   // Label 1446: @90814
     /*   90814 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90903), // Rule ID 51555 //
     /*   90819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90853 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90862 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90901 */     GIR_RootConstrainSelectedInstOperands,
     /*   90902 */     // GIR_Coverage, 51555,
     /*   90902 */     GIR_EraseRootFromParent_Done,
     /*   90903 */   // Label 1447: @90903
     /*   90903 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(90992), // Rule ID 51794 //
     /*   90908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90951 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90990 */     GIR_RootConstrainSelectedInstOperands,
     /*   90991 */     // GIR_Coverage, 51794,
     /*   90991 */     GIR_EraseRootFromParent_Done,
     /*   90992 */   // Label 1448: @90992
     /*   90992 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91081), // Rule ID 51795 //
     /*   90997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91031 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91040 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91079 */     GIR_RootConstrainSelectedInstOperands,
     /*   91080 */     // GIR_Coverage, 51795,
     /*   91080 */     GIR_EraseRootFromParent_Done,
     /*   91081 */   // Label 1449: @91081
     /*   91081 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91170), // Rule ID 51734 //
     /*   91086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91120 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91129 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91168 */     GIR_RootConstrainSelectedInstOperands,
     /*   91169 */     // GIR_Coverage, 51734,
     /*   91169 */     GIR_EraseRootFromParent_Done,
     /*   91170 */   // Label 1450: @91170
     /*   91170 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91259), // Rule ID 51735 //
     /*   91175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91218 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91257 */     GIR_RootConstrainSelectedInstOperands,
     /*   91258 */     // GIR_Coverage, 51735,
     /*   91258 */     GIR_EraseRootFromParent_Done,
     /*   91259 */   // Label 1451: @91259
     /*   91259 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91348), // Rule ID 70611 //
     /*   91264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91279 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91307 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91346 */     GIR_RootConstrainSelectedInstOperands,
     /*   91347 */     // GIR_Coverage, 70611,
     /*   91347 */     GIR_EraseRootFromParent_Done,
     /*   91348 */   // Label 1452: @91348
     /*   91348 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91437), // Rule ID 70612 //
     /*   91353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91396 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   91413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91435 */     GIR_RootConstrainSelectedInstOperands,
     /*   91436 */     // GIR_Coverage, 70612,
     /*   91436 */     GIR_EraseRootFromParent_Done,
     /*   91437 */   // Label 1453: @91437
     /*   91437 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91526), // Rule ID 51614 //
     /*   91442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91485 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91524 */     GIR_RootConstrainSelectedInstOperands,
     /*   91525 */     // GIR_Coverage, 51614,
     /*   91525 */     GIR_EraseRootFromParent_Done,
     /*   91526 */   // Label 1454: @91526
     /*   91526 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(91615), // Rule ID 51615 //
     /*   91531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91574 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91613 */     GIR_RootConstrainSelectedInstOperands,
     /*   91614 */     // GIR_Coverage, 51615,
     /*   91614 */     GIR_EraseRootFromParent_Done,
     /*   91615 */   // Label 1455: @91615
     /*   91615 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91668), // Rule ID 50936 //
     /*   91620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91631 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91666 */     GIR_RootConstrainSelectedInstOperands,
     /*   91667 */     // GIR_Coverage, 50936,
     /*   91667 */     GIR_EraseRootFromParent_Done,
     /*   91668 */   // Label 1456: @91668
     /*   91668 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91721), // Rule ID 50937 //
     /*   91673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91684 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91719 */     GIR_RootConstrainSelectedInstOperands,
     /*   91720 */     // GIR_Coverage, 50937,
     /*   91720 */     GIR_EraseRootFromParent_Done,
     /*   91721 */   // Label 1457: @91721
     /*   91721 */   GIM_Reject,
     /*   91722 */ // Label 1437: @91722
     /*   91722 */ GIM_Reject,
     /*   91723 */ // Label 1306: @91723
     /*   91723 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91837),
     /*   91728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91746 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91791), // Rule ID 50868 //
     /*   91751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91754 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91789 */     GIR_RootConstrainSelectedInstOperands,
     /*   91790 */     // GIR_Coverage, 50868,
     /*   91790 */     GIR_EraseRootFromParent_Done,
     /*   91791 */   // Label 1459: @91791
     /*   91791 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91836), // Rule ID 50869 //
     /*   91796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91799 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91834 */     GIR_RootConstrainSelectedInstOperands,
     /*   91835 */     // GIR_Coverage, 50869,
     /*   91835 */     GIR_EraseRootFromParent_Done,
     /*   91836 */   // Label 1460: @91836
     /*   91836 */   GIM_Reject,
     /*   91837 */ // Label 1458: @91837
     /*   91837 */ GIM_Reject,
     /*   91838 */ // Label 1307: @91838
     /*   91838 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93562),
     /*   91843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91853 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(91942), // Rule ID 51634 //
     /*   91858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91901 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91940 */     GIR_RootConstrainSelectedInstOperands,
     /*   91941 */     // GIR_Coverage, 51634,
     /*   91941 */     GIR_EraseRootFromParent_Done,
     /*   91942 */   // Label 1462: @91942
     /*   91942 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92031), // Rule ID 51635 //
     /*   91947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91990 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92029 */     GIR_RootConstrainSelectedInstOperands,
     /*   92030 */     // GIR_Coverage, 51635,
     /*   92030 */     GIR_EraseRootFromParent_Done,
     /*   92031 */   // Label 1463: @92031
     /*   92031 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92120), // Rule ID 70631 //
     /*   92036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92079 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92118 */     GIR_RootConstrainSelectedInstOperands,
     /*   92119 */     // GIR_Coverage, 70631,
     /*   92119 */     GIR_EraseRootFromParent_Done,
     /*   92120 */   // Label 1464: @92120
     /*   92120 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92209), // Rule ID 70632 //
     /*   92125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92168 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92207 */     GIR_RootConstrainSelectedInstOperands,
     /*   92208 */     // GIR_Coverage, 70632,
     /*   92208 */     GIR_EraseRootFromParent_Done,
     /*   92209 */   // Label 1465: @92209
     /*   92209 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92298), // Rule ID 70511 //
     /*   92214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92257 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92296 */     GIR_RootConstrainSelectedInstOperands,
     /*   92297 */     // GIR_Coverage, 70511,
     /*   92297 */     GIR_EraseRootFromParent_Done,
     /*   92298 */   // Label 1466: @92298
     /*   92298 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92387), // Rule ID 70512 //
     /*   92303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92346 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92385 */     GIR_RootConstrainSelectedInstOperands,
     /*   92386 */     // GIR_Coverage, 70512,
     /*   92386 */     GIR_EraseRootFromParent_Done,
     /*   92387 */   // Label 1467: @92387
     /*   92387 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92476), // Rule ID 51814 //
     /*   92392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92435 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92474 */     GIR_RootConstrainSelectedInstOperands,
     /*   92475 */     // GIR_Coverage, 51814,
     /*   92475 */     GIR_EraseRootFromParent_Done,
     /*   92476 */   // Label 1468: @92476
     /*   92476 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92565), // Rule ID 51815 //
     /*   92481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92515 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92524 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92563 */     GIR_RootConstrainSelectedInstOperands,
     /*   92564 */     // GIR_Coverage, 51815,
     /*   92564 */     GIR_EraseRootFromParent_Done,
     /*   92565 */   // Label 1469: @92565
     /*   92565 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92654), // Rule ID 51514 //
     /*   92570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92613 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92652 */     GIR_RootConstrainSelectedInstOperands,
     /*   92653 */     // GIR_Coverage, 51514,
     /*   92653 */     GIR_EraseRootFromParent_Done,
     /*   92654 */   // Label 1470: @92654
     /*   92654 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92743), // Rule ID 51515 //
     /*   92659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92693 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92702 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92741 */     GIR_RootConstrainSelectedInstOperands,
     /*   92742 */     // GIR_Coverage, 51515,
     /*   92742 */     GIR_EraseRootFromParent_Done,
     /*   92743 */   // Label 1471: @92743
     /*   92743 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92832), // Rule ID 51754 //
     /*   92748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92791 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92830 */     GIR_RootConstrainSelectedInstOperands,
     /*   92831 */     // GIR_Coverage, 51754,
     /*   92831 */     GIR_EraseRootFromParent_Done,
     /*   92832 */   // Label 1472: @92832
     /*   92832 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(92921), // Rule ID 51755 //
     /*   92837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92880 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92919 */     GIR_RootConstrainSelectedInstOperands,
     /*   92920 */     // GIR_Coverage, 51755,
     /*   92920 */     GIR_EraseRootFromParent_Done,
     /*   92921 */   // Label 1473: @92921
     /*   92921 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93010), // Rule ID 51694 //
     /*   92926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92969 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93008 */     GIR_RootConstrainSelectedInstOperands,
     /*   93009 */     // GIR_Coverage, 51694,
     /*   93009 */     GIR_EraseRootFromParent_Done,
     /*   93010 */   // Label 1474: @93010
     /*   93010 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93099), // Rule ID 51695 //
     /*   93015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93058 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93097 */     GIR_RootConstrainSelectedInstOperands,
     /*   93098 */     // GIR_Coverage, 51695,
     /*   93098 */     GIR_EraseRootFromParent_Done,
     /*   93099 */   // Label 1475: @93099
     /*   93099 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93188), // Rule ID 70571 //
     /*   93104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93147 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   93164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93186 */     GIR_RootConstrainSelectedInstOperands,
     /*   93187 */     // GIR_Coverage, 70571,
     /*   93187 */     GIR_EraseRootFromParent_Done,
     /*   93188 */   // Label 1476: @93188
     /*   93188 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93277), // Rule ID 70572 //
     /*   93193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93236 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   93253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93275 */     GIR_RootConstrainSelectedInstOperands,
     /*   93276 */     // GIR_Coverage, 70572,
     /*   93276 */     GIR_EraseRootFromParent_Done,
     /*   93277 */   // Label 1477: @93277
     /*   93277 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93366), // Rule ID 51574 //
     /*   93282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93325 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93364 */     GIR_RootConstrainSelectedInstOperands,
     /*   93365 */     // GIR_Coverage, 51574,
     /*   93365 */     GIR_EraseRootFromParent_Done,
     /*   93366 */   // Label 1478: @93366
     /*   93366 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93455), // Rule ID 51575 //
     /*   93371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   93405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93414 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   93431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93453 */     GIR_RootConstrainSelectedInstOperands,
     /*   93454 */     // GIR_Coverage, 51575,
     /*   93454 */     GIR_EraseRootFromParent_Done,
     /*   93455 */   // Label 1479: @93455
     /*   93455 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93508), // Rule ID 50888 //
     /*   93460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93471 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93506 */     GIR_RootConstrainSelectedInstOperands,
     /*   93507 */     // GIR_Coverage, 50888,
     /*   93507 */     GIR_EraseRootFromParent_Done,
     /*   93508 */   // Label 1480: @93508
     /*   93508 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93561), // Rule ID 50889 //
     /*   93513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93524 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93559 */     GIR_RootConstrainSelectedInstOperands,
     /*   93560 */     // GIR_Coverage, 50889,
     /*   93560 */     GIR_EraseRootFromParent_Done,
     /*   93561 */   // Label 1481: @93561
     /*   93561 */   GIM_Reject,
     /*   93562 */ // Label 1461: @93562
     /*   93562 */ GIM_Reject,
     /*   93563 */ // Label 1308: @93563
     /*   93563 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95287),
     /*   93568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93578 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93667), // Rule ID 51658 //
     /*   93583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93626 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93665 */     GIR_RootConstrainSelectedInstOperands,
     /*   93666 */     // GIR_Coverage, 51658,
     /*   93666 */     GIR_EraseRootFromParent_Done,
     /*   93667 */   // Label 1483: @93667
     /*   93667 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93756), // Rule ID 51659 //
     /*   93672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93715 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93754 */     GIR_RootConstrainSelectedInstOperands,
     /*   93755 */     // GIR_Coverage, 51659,
     /*   93755 */     GIR_EraseRootFromParent_Done,
     /*   93756 */   // Label 1484: @93756
     /*   93756 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93845), // Rule ID 70655 //
     /*   93761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93804 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93843 */     GIR_RootConstrainSelectedInstOperands,
     /*   93844 */     // GIR_Coverage, 70655,
     /*   93844 */     GIR_EraseRootFromParent_Done,
     /*   93845 */   // Label 1485: @93845
     /*   93845 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(93934), // Rule ID 70656 //
     /*   93850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93893 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93932 */     GIR_RootConstrainSelectedInstOperands,
     /*   93933 */     // GIR_Coverage, 70656,
     /*   93933 */     GIR_EraseRootFromParent_Done,
     /*   93934 */   // Label 1486: @93934
     /*   93934 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94023), // Rule ID 70535 //
     /*   93939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93982 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94021 */     GIR_RootConstrainSelectedInstOperands,
     /*   94022 */     // GIR_Coverage, 70535,
     /*   94022 */     GIR_EraseRootFromParent_Done,
     /*   94023 */   // Label 1487: @94023
     /*   94023 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94112), // Rule ID 70536 //
     /*   94028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94062 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94071 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94110 */     GIR_RootConstrainSelectedInstOperands,
     /*   94111 */     // GIR_Coverage, 70536,
     /*   94111 */     GIR_EraseRootFromParent_Done,
     /*   94112 */   // Label 1488: @94112
     /*   94112 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94201), // Rule ID 51838 //
     /*   94117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94151 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94160 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94199 */     GIR_RootConstrainSelectedInstOperands,
     /*   94200 */     // GIR_Coverage, 51838,
     /*   94200 */     GIR_EraseRootFromParent_Done,
     /*   94201 */   // Label 1489: @94201
     /*   94201 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94290), // Rule ID 51839 //
     /*   94206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94221 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94249 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94288 */     GIR_RootConstrainSelectedInstOperands,
     /*   94289 */     // GIR_Coverage, 51839,
     /*   94289 */     GIR_EraseRootFromParent_Done,
     /*   94290 */   // Label 1490: @94290
     /*   94290 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94379), // Rule ID 51538 //
     /*   94295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94338 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   94355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94377 */     GIR_RootConstrainSelectedInstOperands,
     /*   94378 */     // GIR_Coverage, 51538,
     /*   94378 */     GIR_EraseRootFromParent_Done,
     /*   94379 */   // Label 1491: @94379
     /*   94379 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94468), // Rule ID 51539 //
     /*   94384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94399 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94427 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   94444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94466 */     GIR_RootConstrainSelectedInstOperands,
     /*   94467 */     // GIR_Coverage, 51539,
     /*   94467 */     GIR_EraseRootFromParent_Done,
     /*   94468 */   // Label 1492: @94468
     /*   94468 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94557), // Rule ID 51778 //
     /*   94473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94516 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94555 */     GIR_RootConstrainSelectedInstOperands,
     /*   94556 */     // GIR_Coverage, 51778,
     /*   94556 */     GIR_EraseRootFromParent_Done,
     /*   94557 */   // Label 1493: @94557
     /*   94557 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94646), // Rule ID 51779 //
     /*   94562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94605 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94644 */     GIR_RootConstrainSelectedInstOperands,
     /*   94645 */     // GIR_Coverage, 51779,
     /*   94645 */     GIR_EraseRootFromParent_Done,
     /*   94646 */   // Label 1494: @94646
     /*   94646 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94735), // Rule ID 51718 //
     /*   94651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94694 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94733 */     GIR_RootConstrainSelectedInstOperands,
     /*   94734 */     // GIR_Coverage, 51718,
     /*   94734 */     GIR_EraseRootFromParent_Done,
     /*   94735 */   // Label 1495: @94735
     /*   94735 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94824), // Rule ID 51719 //
     /*   94740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94783 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94822 */     GIR_RootConstrainSelectedInstOperands,
     /*   94823 */     // GIR_Coverage, 51719,
     /*   94823 */     GIR_EraseRootFromParent_Done,
     /*   94824 */   // Label 1496: @94824
     /*   94824 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(94913), // Rule ID 70595 //
     /*   94829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94872 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94911 */     GIR_RootConstrainSelectedInstOperands,
     /*   94912 */     // GIR_Coverage, 70595,
     /*   94912 */     GIR_EraseRootFromParent_Done,
     /*   94913 */   // Label 1497: @94913
     /*   94913 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95002), // Rule ID 70596 //
     /*   94918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94961 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95000 */     GIR_RootConstrainSelectedInstOperands,
     /*   95001 */     // GIR_Coverage, 70596,
     /*   95001 */     GIR_EraseRootFromParent_Done,
     /*   95002 */   // Label 1498: @95002
     /*   95002 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95091), // Rule ID 51598 //
     /*   95007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95050 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   95067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95089 */     GIR_RootConstrainSelectedInstOperands,
     /*   95090 */     // GIR_Coverage, 51598,
     /*   95090 */     GIR_EraseRootFromParent_Done,
     /*   95091 */   // Label 1499: @95091
     /*   95091 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95180), // Rule ID 51599 //
     /*   95096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   95130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   95137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95139 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   95156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95178 */     GIR_RootConstrainSelectedInstOperands,
     /*   95179 */     // GIR_Coverage, 51599,
     /*   95179 */     GIR_EraseRootFromParent_Done,
     /*   95180 */   // Label 1500: @95180
     /*   95180 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95233), // Rule ID 50924 //
     /*   95185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95196 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   95213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95231 */     GIR_RootConstrainSelectedInstOperands,
     /*   95232 */     // GIR_Coverage, 50924,
     /*   95232 */     GIR_EraseRootFromParent_Done,
     /*   95233 */   // Label 1501: @95233
     /*   95233 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95286), // Rule ID 50925 //
     /*   95238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95249 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   95252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   95266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95284 */     GIR_RootConstrainSelectedInstOperands,
     /*   95285 */     // GIR_Coverage, 50925,
     /*   95285 */     GIR_EraseRootFromParent_Done,
     /*   95286 */   // Label 1502: @95286
     /*   95286 */   GIM_Reject,
     /*   95287 */ // Label 1482: @95287
     /*   95287 */ GIM_Reject,
     /*   95288 */ // Label 1309: @95288
     /*   95288 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97012),
     /*   95293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   95296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   95299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95303 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95392), // Rule ID 51678 //
     /*   95308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95351 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95390 */     GIR_RootConstrainSelectedInstOperands,
     /*   95391 */     // GIR_Coverage, 51678,
     /*   95391 */     GIR_EraseRootFromParent_Done,
     /*   95392 */   // Label 1504: @95392
     /*   95392 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95481), // Rule ID 51679 //
     /*   95397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95440 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95479 */     GIR_RootConstrainSelectedInstOperands,
     /*   95480 */     // GIR_Coverage, 51679,
     /*   95480 */     GIR_EraseRootFromParent_Done,
     /*   95481 */   // Label 1505: @95481
     /*   95481 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95570), // Rule ID 70675 //
     /*   95486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95529 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95568 */     GIR_RootConstrainSelectedInstOperands,
     /*   95569 */     // GIR_Coverage, 70675,
     /*   95569 */     GIR_EraseRootFromParent_Done,
     /*   95570 */   // Label 1506: @95570
     /*   95570 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95659), // Rule ID 70676 //
     /*   95575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95590 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95609 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95618 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95657 */     GIR_RootConstrainSelectedInstOperands,
     /*   95658 */     // GIR_Coverage, 70676,
     /*   95658 */     GIR_EraseRootFromParent_Done,
     /*   95659 */   // Label 1507: @95659
     /*   95659 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95748), // Rule ID 70555 //
     /*   95664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95679 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95698 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95707 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95746 */     GIR_RootConstrainSelectedInstOperands,
     /*   95747 */     // GIR_Coverage, 70555,
     /*   95747 */     GIR_EraseRootFromParent_Done,
     /*   95748 */   // Label 1508: @95748
     /*   95748 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95837), // Rule ID 70556 //
     /*   95753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95768 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95787 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95796 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95835 */     GIR_RootConstrainSelectedInstOperands,
     /*   95836 */     // GIR_Coverage, 70556,
     /*   95836 */     GIR_EraseRootFromParent_Done,
     /*   95837 */   // Label 1509: @95837
     /*   95837 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(95926), // Rule ID 51858 //
     /*   95842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95885 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95924 */     GIR_RootConstrainSelectedInstOperands,
     /*   95925 */     // GIR_Coverage, 51858,
     /*   95925 */     GIR_EraseRootFromParent_Done,
     /*   95926 */   // Label 1510: @95926
     /*   95926 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96015), // Rule ID 51859 //
     /*   95931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95974 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96013 */     GIR_RootConstrainSelectedInstOperands,
     /*   96014 */     // GIR_Coverage, 51859,
     /*   96014 */     GIR_EraseRootFromParent_Done,
     /*   96015 */   // Label 1511: @96015
     /*   96015 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96104), // Rule ID 51558 //
     /*   96020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96035 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96063 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   96080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96102 */     GIR_RootConstrainSelectedInstOperands,
     /*   96103 */     // GIR_Coverage, 51558,
     /*   96103 */     GIR_EraseRootFromParent_Done,
     /*   96104 */   // Label 1512: @96104
     /*   96104 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96193), // Rule ID 51559 //
     /*   96109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96124 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96152 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   96169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96191 */     GIR_RootConstrainSelectedInstOperands,
     /*   96192 */     // GIR_Coverage, 51559,
     /*   96192 */     GIR_EraseRootFromParent_Done,
     /*   96193 */   // Label 1513: @96193
     /*   96193 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96282), // Rule ID 51798 //
     /*   96198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96241 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96280 */     GIR_RootConstrainSelectedInstOperands,
     /*   96281 */     // GIR_Coverage, 51798,
     /*   96281 */     GIR_EraseRootFromParent_Done,
     /*   96282 */   // Label 1514: @96282
     /*   96282 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96371), // Rule ID 51799 //
     /*   96287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96330 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96369 */     GIR_RootConstrainSelectedInstOperands,
     /*   96370 */     // GIR_Coverage, 51799,
     /*   96370 */     GIR_EraseRootFromParent_Done,
     /*   96371 */   // Label 1515: @96371
     /*   96371 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96460), // Rule ID 51738 //
     /*   96376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96410 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96419 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96458 */     GIR_RootConstrainSelectedInstOperands,
     /*   96459 */     // GIR_Coverage, 51738,
     /*   96459 */     GIR_EraseRootFromParent_Done,
     /*   96460 */   // Label 1516: @96460
     /*   96460 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96549), // Rule ID 51739 //
     /*   96465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96499 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96508 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96547 */     GIR_RootConstrainSelectedInstOperands,
     /*   96548 */     // GIR_Coverage, 51739,
     /*   96548 */     GIR_EraseRootFromParent_Done,
     /*   96549 */   // Label 1517: @96549
     /*   96549 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96638), // Rule ID 70615 //
     /*   96554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96569 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96588 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96597 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96636 */     GIR_RootConstrainSelectedInstOperands,
     /*   96637 */     // GIR_Coverage, 70615,
     /*   96637 */     GIR_EraseRootFromParent_Done,
     /*   96638 */   // Label 1518: @96638
     /*   96638 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96727), // Rule ID 70616 //
     /*   96643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96677 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96686 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96725 */     GIR_RootConstrainSelectedInstOperands,
     /*   96726 */     // GIR_Coverage, 70616,
     /*   96726 */     GIR_EraseRootFromParent_Done,
     /*   96727 */   // Label 1519: @96727
     /*   96727 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96816), // Rule ID 51618 //
     /*   96732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96775 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96814 */     GIR_RootConstrainSelectedInstOperands,
     /*   96815 */     // GIR_Coverage, 51618,
     /*   96815 */     GIR_EraseRootFromParent_Done,
     /*   96816 */   // Label 1520: @96816
     /*   96816 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(96905), // Rule ID 51619 //
     /*   96821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96864 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96903 */     GIR_RootConstrainSelectedInstOperands,
     /*   96904 */     // GIR_Coverage, 51619,
     /*   96904 */     GIR_EraseRootFromParent_Done,
     /*   96905 */   // Label 1521: @96905
     /*   96905 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96958), // Rule ID 50940 //
     /*   96910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96921 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96956 */     GIR_RootConstrainSelectedInstOperands,
     /*   96957 */     // GIR_Coverage, 50940,
     /*   96957 */     GIR_EraseRootFromParent_Done,
     /*   96958 */   // Label 1522: @96958
     /*   96958 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97011), // Rule ID 50941 //
     /*   96963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96974 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   97006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97009 */     GIR_RootConstrainSelectedInstOperands,
     /*   97010 */     // GIR_Coverage, 50941,
     /*   97010 */     GIR_EraseRootFromParent_Done,
     /*   97011 */   // Label 1523: @97011
     /*   97011 */   GIM_Reject,
     /*   97012 */ // Label 1503: @97012
     /*   97012 */ GIM_Reject,
     /*   97013 */ // Label 1310: @97013
     /*   97013 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97127),
     /*   97018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   97024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97036 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97081), // Rule ID 50884 //
     /*   97041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97044 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   97047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   97061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97079 */     GIR_RootConstrainSelectedInstOperands,
     /*   97080 */     // GIR_Coverage, 50884,
     /*   97080 */     GIR_EraseRootFromParent_Done,
     /*   97081 */   // Label 1525: @97081
     /*   97081 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97126), // Rule ID 50885 //
     /*   97086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97089 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   97092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   97106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97124 */     GIR_RootConstrainSelectedInstOperands,
     /*   97125 */     // GIR_Coverage, 50885,
     /*   97125 */     GIR_EraseRootFromParent_Done,
     /*   97126 */   // Label 1526: @97126
     /*   97126 */   GIM_Reject,
     /*   97127 */ // Label 1524: @97127
     /*   97127 */ GIM_Reject,
     /*   97128 */ // Label 1311: @97128
     /*   97128 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98852),
     /*   97133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   97136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   97139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97143 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97232), // Rule ID 51638 //
     /*   97148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97182 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97191 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97230 */     GIR_RootConstrainSelectedInstOperands,
     /*   97231 */     // GIR_Coverage, 51638,
     /*   97231 */     GIR_EraseRootFromParent_Done,
     /*   97232 */   // Label 1528: @97232
     /*   97232 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97321), // Rule ID 51639 //
     /*   97237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97271 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97280 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97319 */     GIR_RootConstrainSelectedInstOperands,
     /*   97320 */     // GIR_Coverage, 51639,
     /*   97320 */     GIR_EraseRootFromParent_Done,
     /*   97321 */   // Label 1529: @97321
     /*   97321 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97410), // Rule ID 70635 //
     /*   97326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97360 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97369 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97408 */     GIR_RootConstrainSelectedInstOperands,
     /*   97409 */     // GIR_Coverage, 70635,
     /*   97409 */     GIR_EraseRootFromParent_Done,
     /*   97410 */   // Label 1530: @97410
     /*   97410 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97499), // Rule ID 70636 //
     /*   97415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97430 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97449 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97458 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97497 */     GIR_RootConstrainSelectedInstOperands,
     /*   97498 */     // GIR_Coverage, 70636,
     /*   97498 */     GIR_EraseRootFromParent_Done,
     /*   97499 */   // Label 1531: @97499
     /*   97499 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97588), // Rule ID 70515 //
     /*   97504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97519 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97538 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97547 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97586 */     GIR_RootConstrainSelectedInstOperands,
     /*   97587 */     // GIR_Coverage, 70515,
     /*   97587 */     GIR_EraseRootFromParent_Done,
     /*   97588 */   // Label 1532: @97588
     /*   97588 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97677), // Rule ID 70516 //
     /*   97593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97608 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97636 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97675 */     GIR_RootConstrainSelectedInstOperands,
     /*   97676 */     // GIR_Coverage, 70516,
     /*   97676 */     GIR_EraseRootFromParent_Done,
     /*   97677 */   // Label 1533: @97677
     /*   97677 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97766), // Rule ID 51818 //
     /*   97682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97725 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97764 */     GIR_RootConstrainSelectedInstOperands,
     /*   97765 */     // GIR_Coverage, 51818,
     /*   97765 */     GIR_EraseRootFromParent_Done,
     /*   97766 */   // Label 1534: @97766
     /*   97766 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97855), // Rule ID 51819 //
     /*   97771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97814 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97853 */     GIR_RootConstrainSelectedInstOperands,
     /*   97854 */     // GIR_Coverage, 51819,
     /*   97854 */     GIR_EraseRootFromParent_Done,
     /*   97855 */   // Label 1535: @97855
     /*   97855 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(97944), // Rule ID 51518 //
     /*   97860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97903 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97942 */     GIR_RootConstrainSelectedInstOperands,
     /*   97943 */     // GIR_Coverage, 51518,
     /*   97943 */     GIR_EraseRootFromParent_Done,
     /*   97944 */   // Label 1536: @97944
     /*   97944 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98033), // Rule ID 51519 //
     /*   97949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97992 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   98009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98031 */     GIR_RootConstrainSelectedInstOperands,
     /*   98032 */     // GIR_Coverage, 51519,
     /*   98032 */     GIR_EraseRootFromParent_Done,
     /*   98033 */   // Label 1537: @98033
     /*   98033 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98122), // Rule ID 51758 //
     /*   98038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98081 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98120 */     GIR_RootConstrainSelectedInstOperands,
     /*   98121 */     // GIR_Coverage, 51758,
     /*   98121 */     GIR_EraseRootFromParent_Done,
     /*   98122 */   // Label 1538: @98122
     /*   98122 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98211), // Rule ID 51759 //
     /*   98127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98161 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98170 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98209 */     GIR_RootConstrainSelectedInstOperands,
     /*   98210 */     // GIR_Coverage, 51759,
     /*   98210 */     GIR_EraseRootFromParent_Done,
     /*   98211 */   // Label 1539: @98211
     /*   98211 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98300), // Rule ID 51698 //
     /*   98216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98250 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98259 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98298 */     GIR_RootConstrainSelectedInstOperands,
     /*   98299 */     // GIR_Coverage, 51698,
     /*   98299 */     GIR_EraseRootFromParent_Done,
     /*   98300 */   // Label 1540: @98300
     /*   98300 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98389), // Rule ID 51699 //
     /*   98305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98339 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98348 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98387 */     GIR_RootConstrainSelectedInstOperands,
     /*   98388 */     // GIR_Coverage, 51699,
     /*   98388 */     GIR_EraseRootFromParent_Done,
     /*   98389 */   // Label 1541: @98389
     /*   98389 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(98478), // Rule ID 70575 //
     /*   98394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98437 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98476 */     GIR_RootConstrainSelectedInstOperands,
     /*   98477 */     // GIR_Coverage, 70575,
     /*   98477 */     GIR_EraseRootFromParent_Done,
     /*   98478 */   // Label 1542: @98478
     /*   98478 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98567), // Rule ID 70576 //
     /*   98483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98517 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98526 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98565 */     GIR_RootConstrainSelectedInstOperands,
     /*   98566 */     // GIR_Coverage, 70576,
     /*   98566 */     GIR_EraseRootFromParent_Done,
     /*   98567 */   // Label 1543: @98567
     /*   98567 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98656), // Rule ID 51578 //
     /*   98572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98615 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98654 */     GIR_RootConstrainSelectedInstOperands,
     /*   98655 */     // GIR_Coverage, 51578,
     /*   98655 */     GIR_EraseRootFromParent_Done,
     /*   98656 */   // Label 1544: @98656
     /*   98656 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98745), // Rule ID 51579 //
     /*   98661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98704 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98743 */     GIR_RootConstrainSelectedInstOperands,
     /*   98744 */     // GIR_Coverage, 51579,
     /*   98744 */     GIR_EraseRootFromParent_Done,
     /*   98745 */   // Label 1545: @98745
     /*   98745 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98798), // Rule ID 50912 //
     /*   98750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98761 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98796 */     GIR_RootConstrainSelectedInstOperands,
     /*   98797 */     // GIR_Coverage, 50912,
     /*   98797 */     GIR_EraseRootFromParent_Done,
     /*   98798 */   // Label 1546: @98798
     /*   98798 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98851), // Rule ID 50913 //
     /*   98803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98814 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98849 */     GIR_RootConstrainSelectedInstOperands,
     /*   98850 */     // GIR_Coverage, 50913,
     /*   98850 */     GIR_EraseRootFromParent_Done,
     /*   98851 */   // Label 1547: @98851
     /*   98851 */   GIM_Reject,
     /*   98852 */ // Label 1527: @98852
     /*   98852 */ GIM_Reject,
     /*   98853 */ // Label 1312: @98853
     /*   98853 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100577),
     /*   98858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98868 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(98957), // Rule ID 51662 //
     /*   98873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98888 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98907 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98916 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98955 */     GIR_RootConstrainSelectedInstOperands,
     /*   98956 */     // GIR_Coverage, 51662,
     /*   98956 */     GIR_EraseRootFromParent_Done,
     /*   98957 */   // Label 1549: @98957
     /*   98957 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99046), // Rule ID 51663 //
     /*   98962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98977 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99005 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99044 */     GIR_RootConstrainSelectedInstOperands,
     /*   99045 */     // GIR_Coverage, 51663,
     /*   99045 */     GIR_EraseRootFromParent_Done,
     /*   99046 */   // Label 1550: @99046
     /*   99046 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99135), // Rule ID 70659 //
     /*   99051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99094 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99133 */     GIR_RootConstrainSelectedInstOperands,
     /*   99134 */     // GIR_Coverage, 70659,
     /*   99134 */     GIR_EraseRootFromParent_Done,
     /*   99135 */   // Label 1551: @99135
     /*   99135 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99224), // Rule ID 70660 //
     /*   99140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99155 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99174 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99183 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99222 */     GIR_RootConstrainSelectedInstOperands,
     /*   99223 */     // GIR_Coverage, 70660,
     /*   99223 */     GIR_EraseRootFromParent_Done,
     /*   99224 */   // Label 1552: @99224
     /*   99224 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99313), // Rule ID 70539 //
     /*   99229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99263 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99272 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99311 */     GIR_RootConstrainSelectedInstOperands,
     /*   99312 */     // GIR_Coverage, 70539,
     /*   99312 */     GIR_EraseRootFromParent_Done,
     /*   99313 */   // Label 1553: @99313
     /*   99313 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99402), // Rule ID 70540 //
     /*   99318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99352 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99361 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99400 */     GIR_RootConstrainSelectedInstOperands,
     /*   99401 */     // GIR_Coverage, 70540,
     /*   99401 */     GIR_EraseRootFromParent_Done,
     /*   99402 */   // Label 1554: @99402
     /*   99402 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99491), // Rule ID 51842 //
     /*   99407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99450 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99489 */     GIR_RootConstrainSelectedInstOperands,
     /*   99490 */     // GIR_Coverage, 51842,
     /*   99490 */     GIR_EraseRootFromParent_Done,
     /*   99491 */   // Label 1555: @99491
     /*   99491 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99580), // Rule ID 51843 //
     /*   99496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99539 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99578 */     GIR_RootConstrainSelectedInstOperands,
     /*   99579 */     // GIR_Coverage, 51843,
     /*   99579 */     GIR_EraseRootFromParent_Done,
     /*   99580 */   // Label 1556: @99580
     /*   99580 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99669), // Rule ID 51542 //
     /*   99585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99628 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99667 */     GIR_RootConstrainSelectedInstOperands,
     /*   99668 */     // GIR_Coverage, 51542,
     /*   99668 */     GIR_EraseRootFromParent_Done,
     /*   99669 */   // Label 1557: @99669
     /*   99669 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99758), // Rule ID 51543 //
     /*   99674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99717 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99756 */     GIR_RootConstrainSelectedInstOperands,
     /*   99757 */     // GIR_Coverage, 51543,
     /*   99757 */     GIR_EraseRootFromParent_Done,
     /*   99758 */   // Label 1558: @99758
     /*   99758 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99847), // Rule ID 51782 //
     /*   99763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99806 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99845 */     GIR_RootConstrainSelectedInstOperands,
     /*   99846 */     // GIR_Coverage, 51782,
     /*   99846 */     GIR_EraseRootFromParent_Done,
     /*   99847 */   // Label 1559: @99847
     /*   99847 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(99936), // Rule ID 51783 //
     /*   99852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99895 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99934 */     GIR_RootConstrainSelectedInstOperands,
     /*   99935 */     // GIR_Coverage, 51783,
     /*   99935 */     GIR_EraseRootFromParent_Done,
     /*   99936 */   // Label 1560: @99936
     /*   99936 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100025), // Rule ID 51722 //
     /*   99941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99984 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100023 */     GIR_RootConstrainSelectedInstOperands,
     /*  100024 */     // GIR_Coverage, 51722,
     /*  100024 */     GIR_EraseRootFromParent_Done,
     /*  100025 */   // Label 1561: @100025
     /*  100025 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100114), // Rule ID 51723 //
     /*  100030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100073 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100112 */     GIR_RootConstrainSelectedInstOperands,
     /*  100113 */     // GIR_Coverage, 51723,
     /*  100113 */     GIR_EraseRootFromParent_Done,
     /*  100114 */   // Label 1562: @100114
     /*  100114 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(100203), // Rule ID 70599 //
     /*  100119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100162 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  100179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100201 */     GIR_RootConstrainSelectedInstOperands,
     /*  100202 */     // GIR_Coverage, 70599,
     /*  100202 */     GIR_EraseRootFromParent_Done,
     /*  100203 */   // Label 1563: @100203
     /*  100203 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100292), // Rule ID 70600 //
     /*  100208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100251 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  100268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100290 */     GIR_RootConstrainSelectedInstOperands,
     /*  100291 */     // GIR_Coverage, 70600,
     /*  100291 */     GIR_EraseRootFromParent_Done,
     /*  100292 */   // Label 1564: @100292
     /*  100292 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100381), // Rule ID 51602 //
     /*  100297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100340 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100379 */     GIR_RootConstrainSelectedInstOperands,
     /*  100380 */     // GIR_Coverage, 51602,
     /*  100380 */     GIR_EraseRootFromParent_Done,
     /*  100381 */   // Label 1565: @100381
     /*  100381 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100470), // Rule ID 51603 //
     /*  100386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  100420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  100427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100429 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  100446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100468 */     GIR_RootConstrainSelectedInstOperands,
     /*  100469 */     // GIR_Coverage, 51603,
     /*  100469 */     GIR_EraseRootFromParent_Done,
     /*  100470 */   // Label 1566: @100470
     /*  100470 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100523), // Rule ID 50928 //
     /*  100475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100486 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100521 */     GIR_RootConstrainSelectedInstOperands,
     /*  100522 */     // GIR_Coverage, 50928,
     /*  100522 */     GIR_EraseRootFromParent_Done,
     /*  100523 */   // Label 1567: @100523
     /*  100523 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100576), // Rule ID 50929 //
     /*  100528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100539 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100574 */     GIR_RootConstrainSelectedInstOperands,
     /*  100575 */     // GIR_Coverage, 50929,
     /*  100575 */     GIR_EraseRootFromParent_Done,
     /*  100576 */   // Label 1568: @100576
     /*  100576 */   GIM_Reject,
     /*  100577 */ // Label 1548: @100577
     /*  100577 */ GIM_Reject,
     /*  100578 */ // Label 1313: @100578
     /*  100578 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102302),
     /*  100583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100593 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100682), // Rule ID 51682 //
     /*  100598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100641 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100680 */     GIR_RootConstrainSelectedInstOperands,
     /*  100681 */     // GIR_Coverage, 51682,
     /*  100681 */     GIR_EraseRootFromParent_Done,
     /*  100682 */   // Label 1570: @100682
     /*  100682 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100771), // Rule ID 51683 //
     /*  100687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100730 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100769 */     GIR_RootConstrainSelectedInstOperands,
     /*  100770 */     // GIR_Coverage, 51683,
     /*  100770 */     GIR_EraseRootFromParent_Done,
     /*  100771 */   // Label 1571: @100771
     /*  100771 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100860), // Rule ID 70679 //
     /*  100776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100810 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100819 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100858 */     GIR_RootConstrainSelectedInstOperands,
     /*  100859 */     // GIR_Coverage, 70679,
     /*  100859 */     GIR_EraseRootFromParent_Done,
     /*  100860 */   // Label 1572: @100860
     /*  100860 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(100949), // Rule ID 70680 //
     /*  100865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100880 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100899 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100908 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100947 */     GIR_RootConstrainSelectedInstOperands,
     /*  100948 */     // GIR_Coverage, 70680,
     /*  100948 */     GIR_EraseRootFromParent_Done,
     /*  100949 */   // Label 1573: @100949
     /*  100949 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101038), // Rule ID 70559 //
     /*  100954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100969 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100988 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100997 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101036 */     GIR_RootConstrainSelectedInstOperands,
     /*  101037 */     // GIR_Coverage, 70559,
     /*  101037 */     GIR_EraseRootFromParent_Done,
     /*  101038 */   // Label 1574: @101038
     /*  101038 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101127), // Rule ID 70560 //
     /*  101043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101058 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101077 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101086 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101125 */     GIR_RootConstrainSelectedInstOperands,
     /*  101126 */     // GIR_Coverage, 70560,
     /*  101126 */     GIR_EraseRootFromParent_Done,
     /*  101127 */   // Label 1575: @101127
     /*  101127 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101216), // Rule ID 51862 //
     /*  101132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101175 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101214 */     GIR_RootConstrainSelectedInstOperands,
     /*  101215 */     // GIR_Coverage, 51862,
     /*  101215 */     GIR_EraseRootFromParent_Done,
     /*  101216 */   // Label 1576: @101216
     /*  101216 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101305), // Rule ID 51863 //
     /*  101221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101264 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101303 */     GIR_RootConstrainSelectedInstOperands,
     /*  101304 */     // GIR_Coverage, 51863,
     /*  101304 */     GIR_EraseRootFromParent_Done,
     /*  101305 */   // Label 1577: @101305
     /*  101305 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101394), // Rule ID 51562 //
     /*  101310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101353 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  101370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101392 */     GIR_RootConstrainSelectedInstOperands,
     /*  101393 */     // GIR_Coverage, 51562,
     /*  101393 */     GIR_EraseRootFromParent_Done,
     /*  101394 */   // Label 1578: @101394
     /*  101394 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101483), // Rule ID 51563 //
     /*  101399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101442 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  101459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101481 */     GIR_RootConstrainSelectedInstOperands,
     /*  101482 */     // GIR_Coverage, 51563,
     /*  101482 */     GIR_EraseRootFromParent_Done,
     /*  101483 */   // Label 1579: @101483
     /*  101483 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101572), // Rule ID 51802 //
     /*  101488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101531 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101570 */     GIR_RootConstrainSelectedInstOperands,
     /*  101571 */     // GIR_Coverage, 51802,
     /*  101571 */     GIR_EraseRootFromParent_Done,
     /*  101572 */   // Label 1580: @101572
     /*  101572 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101661), // Rule ID 51803 //
     /*  101577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101620 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101659 */     GIR_RootConstrainSelectedInstOperands,
     /*  101660 */     // GIR_Coverage, 51803,
     /*  101660 */     GIR_EraseRootFromParent_Done,
     /*  101661 */   // Label 1581: @101661
     /*  101661 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101750), // Rule ID 51742 //
     /*  101666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101709 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101748 */     GIR_RootConstrainSelectedInstOperands,
     /*  101749 */     // GIR_Coverage, 51742,
     /*  101749 */     GIR_EraseRootFromParent_Done,
     /*  101750 */   // Label 1582: @101750
     /*  101750 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101839), // Rule ID 51743 //
     /*  101755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101798 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101837 */     GIR_RootConstrainSelectedInstOperands,
     /*  101838 */     // GIR_Coverage, 51743,
     /*  101838 */     GIR_EraseRootFromParent_Done,
     /*  101839 */   // Label 1583: @101839
     /*  101839 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101928), // Rule ID 70619 //
     /*  101844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101887 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101926 */     GIR_RootConstrainSelectedInstOperands,
     /*  101927 */     // GIR_Coverage, 70619,
     /*  101927 */     GIR_EraseRootFromParent_Done,
     /*  101928 */   // Label 1584: @101928
     /*  101928 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(102017), // Rule ID 70620 //
     /*  101933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101976 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102015 */     GIR_RootConstrainSelectedInstOperands,
     /*  102016 */     // GIR_Coverage, 70620,
     /*  102016 */     GIR_EraseRootFromParent_Done,
     /*  102017 */   // Label 1585: @102017
     /*  102017 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(102106), // Rule ID 51622 //
     /*  102022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  102025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102065 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  102065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102104 */     GIR_RootConstrainSelectedInstOperands,
     /*  102105 */     // GIR_Coverage, 51622,
     /*  102105 */     GIR_EraseRootFromParent_Done,
     /*  102106 */   // Label 1586: @102106
     /*  102106 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(102195), // Rule ID 51623 //
     /*  102111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  102114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  102145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102154 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  102154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  102190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102193 */     GIR_RootConstrainSelectedInstOperands,
     /*  102194 */     // GIR_Coverage, 51623,
     /*  102194 */     GIR_EraseRootFromParent_Done,
     /*  102195 */   // Label 1587: @102195
     /*  102195 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102248), // Rule ID 50944 //
     /*  102200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  102203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102211 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  102211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  102228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  102243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102246 */     GIR_RootConstrainSelectedInstOperands,
     /*  102247 */     // GIR_Coverage, 50944,
     /*  102247 */     GIR_EraseRootFromParent_Done,
     /*  102248 */   // Label 1588: @102248
     /*  102248 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102301), // Rule ID 50945 //
     /*  102253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  102256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  102264 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  102264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  102267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  102281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  102296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102299 */     GIR_RootConstrainSelectedInstOperands,
     /*  102300 */     // GIR_Coverage, 50945,
     /*  102300 */     GIR_EraseRootFromParent_Done,
     /*  102301 */   // Label 1589: @102301
     /*  102301 */   GIM_Reject,
     /*  102302 */ // Label 1569: @102302
     /*  102302 */ GIM_Reject,
     /*  102303 */ // Label 1314: @102303
     /*  102303 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102417),
     /*  102308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  102314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102326 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102371), // Rule ID 50900 //
     /*  102331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102334 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  102337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  102351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102369 */     GIR_RootConstrainSelectedInstOperands,
     /*  102370 */     // GIR_Coverage, 50900,
     /*  102370 */     GIR_EraseRootFromParent_Done,
     /*  102371 */   // Label 1591: @102371
     /*  102371 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102416), // Rule ID 50901 //
     /*  102376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102379 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  102382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  102396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  102403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  102405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102414 */     GIR_RootConstrainSelectedInstOperands,
     /*  102415 */     // GIR_Coverage, 50901,
     /*  102415 */     GIR_EraseRootFromParent_Done,
     /*  102416 */   // Label 1592: @102416
     /*  102416 */   GIM_Reject,
     /*  102417 */ // Label 1590: @102417
     /*  102417 */ GIM_Reject,
     /*  102418 */ // Label 1315: @102418
     /*  102418 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104142),
     /*  102423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  102426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  102429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102433 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102522), // Rule ID 51642 //
     /*  102438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102472 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102481 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102520 */     GIR_RootConstrainSelectedInstOperands,
     /*  102521 */     // GIR_Coverage, 51642,
     /*  102521 */     GIR_EraseRootFromParent_Done,
     /*  102522 */   // Label 1594: @102522
     /*  102522 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102611), // Rule ID 51643 //
     /*  102527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102561 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102570 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102609 */     GIR_RootConstrainSelectedInstOperands,
     /*  102610 */     // GIR_Coverage, 51643,
     /*  102610 */     GIR_EraseRootFromParent_Done,
     /*  102611 */   // Label 1595: @102611
     /*  102611 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102700), // Rule ID 70639 //
     /*  102616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102659 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102698 */     GIR_RootConstrainSelectedInstOperands,
     /*  102699 */     // GIR_Coverage, 70639,
     /*  102699 */     GIR_EraseRootFromParent_Done,
     /*  102700 */   // Label 1596: @102700
     /*  102700 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102789), // Rule ID 70640 //
     /*  102705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102720 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102739 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102748 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102787 */     GIR_RootConstrainSelectedInstOperands,
     /*  102788 */     // GIR_Coverage, 70640,
     /*  102788 */     GIR_EraseRootFromParent_Done,
     /*  102789 */   // Label 1597: @102789
     /*  102789 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102878), // Rule ID 70519 //
     /*  102794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102809 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102828 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102837 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102876 */     GIR_RootConstrainSelectedInstOperands,
     /*  102877 */     // GIR_Coverage, 70519,
     /*  102877 */     GIR_EraseRootFromParent_Done,
     /*  102878 */   // Label 1598: @102878
     /*  102878 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(102967), // Rule ID 70520 //
     /*  102883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102898 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102917 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102926 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102965 */     GIR_RootConstrainSelectedInstOperands,
     /*  102966 */     // GIR_Coverage, 70520,
     /*  102966 */     GIR_EraseRootFromParent_Done,
     /*  102967 */   // Label 1599: @102967
     /*  102967 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103056), // Rule ID 51822 //
     /*  102972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103015 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103054 */     GIR_RootConstrainSelectedInstOperands,
     /*  103055 */     // GIR_Coverage, 51822,
     /*  103055 */     GIR_EraseRootFromParent_Done,
     /*  103056 */   // Label 1600: @103056
     /*  103056 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103145), // Rule ID 51823 //
     /*  103061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103104 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103143 */     GIR_RootConstrainSelectedInstOperands,
     /*  103144 */     // GIR_Coverage, 51823,
     /*  103144 */     GIR_EraseRootFromParent_Done,
     /*  103145 */   // Label 1601: @103145
     /*  103145 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103234), // Rule ID 51522 //
     /*  103150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103193 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  103210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103232 */     GIR_RootConstrainSelectedInstOperands,
     /*  103233 */     // GIR_Coverage, 51522,
     /*  103233 */     GIR_EraseRootFromParent_Done,
     /*  103234 */   // Label 1602: @103234
     /*  103234 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103323), // Rule ID 51523 //
     /*  103239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103282 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  103299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103321 */     GIR_RootConstrainSelectedInstOperands,
     /*  103322 */     // GIR_Coverage, 51523,
     /*  103322 */     GIR_EraseRootFromParent_Done,
     /*  103323 */   // Label 1603: @103323
     /*  103323 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103412), // Rule ID 51762 //
     /*  103328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103371 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103410 */     GIR_RootConstrainSelectedInstOperands,
     /*  103411 */     // GIR_Coverage, 51762,
     /*  103411 */     GIR_EraseRootFromParent_Done,
     /*  103412 */   // Label 1604: @103412
     /*  103412 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103501), // Rule ID 51763 //
     /*  103417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103460 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103499 */     GIR_RootConstrainSelectedInstOperands,
     /*  103500 */     // GIR_Coverage, 51763,
     /*  103500 */     GIR_EraseRootFromParent_Done,
     /*  103501 */   // Label 1605: @103501
     /*  103501 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103590), // Rule ID 51702 //
     /*  103506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103549 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103588 */     GIR_RootConstrainSelectedInstOperands,
     /*  103589 */     // GIR_Coverage, 51702,
     /*  103589 */     GIR_EraseRootFromParent_Done,
     /*  103590 */   // Label 1606: @103590
     /*  103590 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103679), // Rule ID 51703 //
     /*  103595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103638 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103677 */     GIR_RootConstrainSelectedInstOperands,
     /*  103678 */     // GIR_Coverage, 51703,
     /*  103678 */     GIR_EraseRootFromParent_Done,
     /*  103679 */   // Label 1607: @103679
     /*  103679 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(103768), // Rule ID 70579 //
     /*  103684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103727 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103766 */     GIR_RootConstrainSelectedInstOperands,
     /*  103767 */     // GIR_Coverage, 70579,
     /*  103767 */     GIR_EraseRootFromParent_Done,
     /*  103768 */   // Label 1608: @103768
     /*  103768 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103857), // Rule ID 70580 //
     /*  103773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103816 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103855 */     GIR_RootConstrainSelectedInstOperands,
     /*  103856 */     // GIR_Coverage, 70580,
     /*  103856 */     GIR_EraseRootFromParent_Done,
     /*  103857 */   // Label 1609: @103857
     /*  103857 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103946), // Rule ID 51582 //
     /*  103862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103905 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103944 */     GIR_RootConstrainSelectedInstOperands,
     /*  103945 */     // GIR_Coverage, 51582,
     /*  103945 */     GIR_EraseRootFromParent_Done,
     /*  103946 */   // Label 1610: @103946
     /*  103946 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(104035), // Rule ID 51583 //
     /*  103951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103994 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  104011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104033 */     GIR_RootConstrainSelectedInstOperands,
     /*  104034 */     // GIR_Coverage, 51583,
     /*  104034 */     GIR_EraseRootFromParent_Done,
     /*  104035 */   // Label 1611: @104035
     /*  104035 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104088), // Rule ID 50916 //
     /*  104040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104051 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  104054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  104068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104086 */     GIR_RootConstrainSelectedInstOperands,
     /*  104087 */     // GIR_Coverage, 50916,
     /*  104087 */     GIR_EraseRootFromParent_Done,
     /*  104088 */   // Label 1612: @104088
     /*  104088 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104141), // Rule ID 50917 //
     /*  104093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104104 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  104107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  104121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104139 */     GIR_RootConstrainSelectedInstOperands,
     /*  104140 */     // GIR_Coverage, 50917,
     /*  104140 */     GIR_EraseRootFromParent_Done,
     /*  104141 */   // Label 1613: @104141
     /*  104141 */   GIM_Reject,
     /*  104142 */ // Label 1593: @104142
     /*  104142 */ GIM_Reject,
     /*  104143 */ // Label 1316: @104143
     /*  104143 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(105867),
     /*  104148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  104151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  104154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  104158 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104247), // Rule ID 51666 //
     /*  104163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104178 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104197 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104206 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104245 */     GIR_RootConstrainSelectedInstOperands,
     /*  104246 */     // GIR_Coverage, 51666,
     /*  104246 */     GIR_EraseRootFromParent_Done,
     /*  104247 */   // Label 1615: @104247
     /*  104247 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104336), // Rule ID 51667 //
     /*  104252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104267 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104286 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104295 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104334 */     GIR_RootConstrainSelectedInstOperands,
     /*  104335 */     // GIR_Coverage, 51667,
     /*  104335 */     GIR_EraseRootFromParent_Done,
     /*  104336 */   // Label 1616: @104336
     /*  104336 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104425), // Rule ID 70663 //
     /*  104341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104375 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104384 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104423 */     GIR_RootConstrainSelectedInstOperands,
     /*  104424 */     // GIR_Coverage, 70663,
     /*  104424 */     GIR_EraseRootFromParent_Done,
     /*  104425 */   // Label 1617: @104425
     /*  104425 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104514), // Rule ID 70664 //
     /*  104430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104464 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104473 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104512 */     GIR_RootConstrainSelectedInstOperands,
     /*  104513 */     // GIR_Coverage, 70664,
     /*  104513 */     GIR_EraseRootFromParent_Done,
     /*  104514 */   // Label 1618: @104514
     /*  104514 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104603), // Rule ID 70543 //
     /*  104519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104553 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104562 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104601 */     GIR_RootConstrainSelectedInstOperands,
     /*  104602 */     // GIR_Coverage, 70543,
     /*  104602 */     GIR_EraseRootFromParent_Done,
     /*  104603 */   // Label 1619: @104603
     /*  104603 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104692), // Rule ID 70544 //
     /*  104608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104623 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104651 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104690 */     GIR_RootConstrainSelectedInstOperands,
     /*  104691 */     // GIR_Coverage, 70544,
     /*  104691 */     GIR_EraseRootFromParent_Done,
     /*  104692 */   // Label 1620: @104692
     /*  104692 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104781), // Rule ID 51846 //
     /*  104697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104731 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104740 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104779 */     GIR_RootConstrainSelectedInstOperands,
     /*  104780 */     // GIR_Coverage, 51846,
     /*  104780 */     GIR_EraseRootFromParent_Done,
     /*  104781 */   // Label 1621: @104781
     /*  104781 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104870), // Rule ID 51847 //
     /*  104786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104820 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104829 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104868 */     GIR_RootConstrainSelectedInstOperands,
     /*  104869 */     // GIR_Coverage, 51847,
     /*  104869 */     GIR_EraseRootFromParent_Done,
     /*  104870 */   // Label 1622: @104870
     /*  104870 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(104959), // Rule ID 51546 //
     /*  104875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104918 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104957 */     GIR_RootConstrainSelectedInstOperands,
     /*  104958 */     // GIR_Coverage, 51546,
     /*  104958 */     GIR_EraseRootFromParent_Done,
     /*  104959 */   // Label 1623: @104959
     /*  104959 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105048), // Rule ID 51547 //
     /*  104964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104998 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105007 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  105024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105046 */     GIR_RootConstrainSelectedInstOperands,
     /*  105047 */     // GIR_Coverage, 51547,
     /*  105047 */     GIR_EraseRootFromParent_Done,
     /*  105048 */   // Label 1624: @105048
     /*  105048 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105137), // Rule ID 51786 //
     /*  105053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105087 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105096 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105135 */     GIR_RootConstrainSelectedInstOperands,
     /*  105136 */     // GIR_Coverage, 51786,
     /*  105136 */     GIR_EraseRootFromParent_Done,
     /*  105137 */   // Label 1625: @105137
     /*  105137 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105226), // Rule ID 51787 //
     /*  105142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105185 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105224 */     GIR_RootConstrainSelectedInstOperands,
     /*  105225 */     // GIR_Coverage, 51787,
     /*  105225 */     GIR_EraseRootFromParent_Done,
     /*  105226 */   // Label 1626: @105226
     /*  105226 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105315), // Rule ID 51726 //
     /*  105231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105274 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105313 */     GIR_RootConstrainSelectedInstOperands,
     /*  105314 */     // GIR_Coverage, 51726,
     /*  105314 */     GIR_EraseRootFromParent_Done,
     /*  105315 */   // Label 1627: @105315
     /*  105315 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105404), // Rule ID 51727 //
     /*  105320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105363 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105402 */     GIR_RootConstrainSelectedInstOperands,
     /*  105403 */     // GIR_Coverage, 51727,
     /*  105403 */     GIR_EraseRootFromParent_Done,
     /*  105404 */   // Label 1628: @105404
     /*  105404 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105493), // Rule ID 70603 //
     /*  105409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105452 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105491 */     GIR_RootConstrainSelectedInstOperands,
     /*  105492 */     // GIR_Coverage, 70603,
     /*  105492 */     GIR_EraseRootFromParent_Done,
     /*  105493 */   // Label 1629: @105493
     /*  105493 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105582), // Rule ID 70604 //
     /*  105498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105532 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105541 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105580 */     GIR_RootConstrainSelectedInstOperands,
     /*  105581 */     // GIR_Coverage, 70604,
     /*  105581 */     GIR_EraseRootFromParent_Done,
     /*  105582 */   // Label 1630: @105582
     /*  105582 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105671), // Rule ID 51606 //
     /*  105587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105621 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105630 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105669 */     GIR_RootConstrainSelectedInstOperands,
     /*  105670 */     // GIR_Coverage, 51606,
     /*  105670 */     GIR_EraseRootFromParent_Done,
     /*  105671 */   // Label 1631: @105671
     /*  105671 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105760), // Rule ID 51607 //
     /*  105676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105719 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105758 */     GIR_RootConstrainSelectedInstOperands,
     /*  105759 */     // GIR_Coverage, 51607,
     /*  105759 */     GIR_EraseRootFromParent_Done,
     /*  105760 */   // Label 1632: @105760
     /*  105760 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105813), // Rule ID 50932 //
     /*  105765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105776 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105811 */     GIR_RootConstrainSelectedInstOperands,
     /*  105812 */     // GIR_Coverage, 50932,
     /*  105812 */     GIR_EraseRootFromParent_Done,
     /*  105813 */   // Label 1633: @105813
     /*  105813 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105866), // Rule ID 50933 //
     /*  105818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105829 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105864 */     GIR_RootConstrainSelectedInstOperands,
     /*  105865 */     // GIR_Coverage, 50933,
     /*  105865 */     GIR_EraseRootFromParent_Done,
     /*  105866 */   // Label 1634: @105866
     /*  105866 */   GIM_Reject,
     /*  105867 */ // Label 1614: @105867
     /*  105867 */ GIM_Reject,
     /*  105868 */ // Label 1317: @105868
     /*  105868 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105982),
     /*  105873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105891 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105936), // Rule ID 50904 //
     /*  105896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105899 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105934 */     GIR_RootConstrainSelectedInstOperands,
     /*  105935 */     // GIR_Coverage, 50904,
     /*  105935 */     GIR_EraseRootFromParent_Done,
     /*  105936 */   // Label 1636: @105936
     /*  105936 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105981), // Rule ID 50905 //
     /*  105941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105944 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105979 */     GIR_RootConstrainSelectedInstOperands,
     /*  105980 */     // GIR_Coverage, 50905,
     /*  105980 */     GIR_EraseRootFromParent_Done,
     /*  105981 */   // Label 1637: @105981
     /*  105981 */   GIM_Reject,
     /*  105982 */ // Label 1635: @105982
     /*  105982 */ GIM_Reject,
     /*  105983 */ // Label 1318: @105983
     /*  105983 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(107707),
     /*  105988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105998 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106087), // Rule ID 51646 //
     /*  106003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106037 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106046 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106085 */     GIR_RootConstrainSelectedInstOperands,
     /*  106086 */     // GIR_Coverage, 51646,
     /*  106086 */     GIR_EraseRootFromParent_Done,
     /*  106087 */   // Label 1639: @106087
     /*  106087 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106176), // Rule ID 51647 //
     /*  106092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106126 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106135 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106174 */     GIR_RootConstrainSelectedInstOperands,
     /*  106175 */     // GIR_Coverage, 51647,
     /*  106175 */     GIR_EraseRootFromParent_Done,
     /*  106176 */   // Label 1640: @106176
     /*  106176 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106265), // Rule ID 70643 //
     /*  106181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106224 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106263 */     GIR_RootConstrainSelectedInstOperands,
     /*  106264 */     // GIR_Coverage, 70643,
     /*  106264 */     GIR_EraseRootFromParent_Done,
     /*  106265 */   // Label 1641: @106265
     /*  106265 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106354), // Rule ID 70644 //
     /*  106270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106304 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106313 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106352 */     GIR_RootConstrainSelectedInstOperands,
     /*  106353 */     // GIR_Coverage, 70644,
     /*  106353 */     GIR_EraseRootFromParent_Done,
     /*  106354 */   // Label 1642: @106354
     /*  106354 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106443), // Rule ID 70523 //
     /*  106359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106393 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106402 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106441 */     GIR_RootConstrainSelectedInstOperands,
     /*  106442 */     // GIR_Coverage, 70523,
     /*  106442 */     GIR_EraseRootFromParent_Done,
     /*  106443 */   // Label 1643: @106443
     /*  106443 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106532), // Rule ID 70524 //
     /*  106448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106463 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106482 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106491 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106530 */     GIR_RootConstrainSelectedInstOperands,
     /*  106531 */     // GIR_Coverage, 70524,
     /*  106531 */     GIR_EraseRootFromParent_Done,
     /*  106532 */   // Label 1644: @106532
     /*  106532 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106621), // Rule ID 51826 //
     /*  106537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106580 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106619 */     GIR_RootConstrainSelectedInstOperands,
     /*  106620 */     // GIR_Coverage, 51826,
     /*  106620 */     GIR_EraseRootFromParent_Done,
     /*  106621 */   // Label 1645: @106621
     /*  106621 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106710), // Rule ID 51827 //
     /*  106626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106669 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106708 */     GIR_RootConstrainSelectedInstOperands,
     /*  106709 */     // GIR_Coverage, 51827,
     /*  106709 */     GIR_EraseRootFromParent_Done,
     /*  106710 */   // Label 1646: @106710
     /*  106710 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106799), // Rule ID 51526 //
     /*  106715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106758 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106797 */     GIR_RootConstrainSelectedInstOperands,
     /*  106798 */     // GIR_Coverage, 51526,
     /*  106798 */     GIR_EraseRootFromParent_Done,
     /*  106799 */   // Label 1647: @106799
     /*  106799 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106888), // Rule ID 51527 //
     /*  106804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106847 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106886 */     GIR_RootConstrainSelectedInstOperands,
     /*  106887 */     // GIR_Coverage, 51527,
     /*  106887 */     GIR_EraseRootFromParent_Done,
     /*  106888 */   // Label 1648: @106888
     /*  106888 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106977), // Rule ID 51766 //
     /*  106893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106936 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106975 */     GIR_RootConstrainSelectedInstOperands,
     /*  106976 */     // GIR_Coverage, 51766,
     /*  106976 */     GIR_EraseRootFromParent_Done,
     /*  106977 */   // Label 1649: @106977
     /*  106977 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107066), // Rule ID 51767 //
     /*  106982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107025 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107064 */     GIR_RootConstrainSelectedInstOperands,
     /*  107065 */     // GIR_Coverage, 51767,
     /*  107065 */     GIR_EraseRootFromParent_Done,
     /*  107066 */   // Label 1650: @107066
     /*  107066 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107155), // Rule ID 51706 //
     /*  107071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  107101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107114 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107153 */     GIR_RootConstrainSelectedInstOperands,
     /*  107154 */     // GIR_Coverage, 51706,
     /*  107154 */     GIR_EraseRootFromParent_Done,
     /*  107155 */   // Label 1651: @107155
     /*  107155 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107244), // Rule ID 51707 //
     /*  107160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  107190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107203 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107242 */     GIR_RootConstrainSelectedInstOperands,
     /*  107243 */     // GIR_Coverage, 51707,
     /*  107243 */     GIR_EraseRootFromParent_Done,
     /*  107244 */   // Label 1652: @107244
     /*  107244 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107333), // Rule ID 70583 //
     /*  107249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  107279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107292 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  107318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  107322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107331 */     GIR_RootConstrainSelectedInstOperands,
     /*  107332 */     // GIR_Coverage, 70583,
     /*  107332 */     GIR_EraseRootFromParent_Done,
     /*  107333 */   // Label 1653: @107333
     /*  107333 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107422), // Rule ID 70584 //
     /*  107338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  107368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107381 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  107398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  107407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  107411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107420 */     GIR_RootConstrainSelectedInstOperands,
     /*  107421 */     // GIR_Coverage, 70584,
     /*  107421 */     GIR_EraseRootFromParent_Done,
     /*  107422 */   // Label 1654: @107422
     /*  107422 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107511), // Rule ID 51586 //
     /*  107427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107470 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107509 */     GIR_RootConstrainSelectedInstOperands,
     /*  107510 */     // GIR_Coverage, 51586,
     /*  107510 */     GIR_EraseRootFromParent_Done,
     /*  107511 */   // Label 1655: @107511
     /*  107511 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107600), // Rule ID 51587 //
     /*  107516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107559 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107598 */     GIR_RootConstrainSelectedInstOperands,
     /*  107599 */     // GIR_Coverage, 51587,
     /*  107599 */     GIR_EraseRootFromParent_Done,
     /*  107600 */   // Label 1656: @107600
     /*  107600 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107653), // Rule ID 50920 //
     /*  107605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107616 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107651 */     GIR_RootConstrainSelectedInstOperands,
     /*  107652 */     // GIR_Coverage, 50920,
     /*  107652 */     GIR_EraseRootFromParent_Done,
     /*  107653 */   // Label 1657: @107653
     /*  107653 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107706), // Rule ID 50921 //
     /*  107658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107669 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107704 */     GIR_RootConstrainSelectedInstOperands,
     /*  107705 */     // GIR_Coverage, 50921,
     /*  107705 */     GIR_EraseRootFromParent_Done,
     /*  107706 */   // Label 1658: @107706
     /*  107706 */   GIM_Reject,
     /*  107707 */ // Label 1638: @107707
     /*  107707 */ GIM_Reject,
     /*  107708 */ // Label 1319: @107708
     /*  107708 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107822),
     /*  107713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107731 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107776), // Rule ID 50908 //
     /*  107736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107739 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107774 */     GIR_RootConstrainSelectedInstOperands,
     /*  107775 */     // GIR_Coverage, 50908,
     /*  107775 */     GIR_EraseRootFromParent_Done,
     /*  107776 */   // Label 1660: @107776
     /*  107776 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107821), // Rule ID 50909 //
     /*  107781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107784 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107819 */     GIR_RootConstrainSelectedInstOperands,
     /*  107820 */     // GIR_Coverage, 50909,
     /*  107820 */     GIR_EraseRootFromParent_Done,
     /*  107821 */   // Label 1661: @107821
     /*  107821 */   GIM_Reject,
     /*  107822 */ // Label 1659: @107822
     /*  107822 */ GIM_Reject,
     /*  107823 */ // Label 1320: @107823
     /*  107823 */ GIM_Reject,
     /*  107824 */ // Label 3: @107824
     /*  107824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1686*/ GIMT_Encode4(110557),
     /*  107835 */ /*GILLT_s32*//*Label 1662*/ GIMT_Encode4(107959),
     /*  107839 */ /*GILLT_s64*//*Label 1663*/ GIMT_Encode4(107993), GIMT_Encode4(0),
     /*  107847 */ /*GILLT_nxv1s8*//*Label 1664*/ GIMT_Encode4(108027),
     /*  107851 */ /*GILLT_nxv1s16*//*Label 1665*/ GIMT_Encode4(108142),
     /*  107855 */ /*GILLT_nxv1s32*//*Label 1666*/ GIMT_Encode4(108257),
     /*  107859 */ /*GILLT_nxv1s64*//*Label 1667*/ GIMT_Encode4(108372), GIMT_Encode4(0),
     /*  107867 */ /*GILLT_nxv2s8*//*Label 1668*/ GIMT_Encode4(108487),
     /*  107871 */ /*GILLT_nxv2s16*//*Label 1669*/ GIMT_Encode4(108602),
     /*  107875 */ /*GILLT_nxv2s32*//*Label 1670*/ GIMT_Encode4(108717),
     /*  107879 */ /*GILLT_nxv2s64*//*Label 1671*/ GIMT_Encode4(108832), GIMT_Encode4(0),
     /*  107887 */ /*GILLT_nxv4s8*//*Label 1672*/ GIMT_Encode4(108947),
     /*  107891 */ /*GILLT_nxv4s16*//*Label 1673*/ GIMT_Encode4(109062),
     /*  107895 */ /*GILLT_nxv4s32*//*Label 1674*/ GIMT_Encode4(109177),
     /*  107899 */ /*GILLT_nxv4s64*//*Label 1675*/ GIMT_Encode4(109292), GIMT_Encode4(0),
     /*  107907 */ /*GILLT_nxv8s8*//*Label 1676*/ GIMT_Encode4(109407),
     /*  107911 */ /*GILLT_nxv8s16*//*Label 1677*/ GIMT_Encode4(109522),
     /*  107915 */ /*GILLT_nxv8s32*//*Label 1678*/ GIMT_Encode4(109637),
     /*  107919 */ /*GILLT_nxv8s64*//*Label 1679*/ GIMT_Encode4(109752), GIMT_Encode4(0),
     /*  107927 */ /*GILLT_nxv16s8*//*Label 1680*/ GIMT_Encode4(109867),
     /*  107931 */ /*GILLT_nxv16s16*//*Label 1681*/ GIMT_Encode4(109982),
     /*  107935 */ /*GILLT_nxv16s32*//*Label 1682*/ GIMT_Encode4(110097), GIMT_Encode4(0),
     /*  107943 */ /*GILLT_nxv32s8*//*Label 1683*/ GIMT_Encode4(110212),
     /*  107947 */ /*GILLT_nxv32s16*//*Label 1684*/ GIMT_Encode4(110327), GIMT_Encode4(0),
     /*  107955 */ /*GILLT_nxv64s8*//*Label 1685*/ GIMT_Encode4(110442),
     /*  107959 */ // Label 1662: @107959
     /*  107959 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107992), // Rule ID 310 //
     /*  107964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107985 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107990 */   GIR_RootConstrainSelectedInstOperands,
     /*  107991 */   // GIR_Coverage, 310,
     /*  107991 */   GIR_Done,
     /*  107992 */ // Label 1687: @107992
     /*  107992 */ GIM_Reject,
     /*  107993 */ // Label 1663: @107993
     /*  107993 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108026), // Rule ID 309 //
     /*  107998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  108001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  108004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  108007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108019 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  108024 */   GIR_RootConstrainSelectedInstOperands,
     /*  108025 */   // GIR_Coverage, 309,
     /*  108025 */   GIR_Done,
     /*  108026 */ // Label 1688: @108026
     /*  108026 */ GIM_Reject,
     /*  108027 */ // Label 1664: @108027
     /*  108027 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108141),
     /*  108032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  108035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  108038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108050 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108095), // Rule ID 51212 //
     /*  108055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108058 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  108061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  108075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108093 */     GIR_RootConstrainSelectedInstOperands,
     /*  108094 */     // GIR_Coverage, 51212,
     /*  108094 */     GIR_EraseRootFromParent_Done,
     /*  108095 */   // Label 1690: @108095
     /*  108095 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108140), // Rule ID 51213 //
     /*  108100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108103 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  108106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  108120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108138 */     GIR_RootConstrainSelectedInstOperands,
     /*  108139 */     // GIR_Coverage, 51213,
     /*  108139 */     GIR_EraseRootFromParent_Done,
     /*  108140 */   // Label 1691: @108140
     /*  108140 */   GIM_Reject,
     /*  108141 */ // Label 1689: @108141
     /*  108141 */ GIM_Reject,
     /*  108142 */ // Label 1665: @108142
     /*  108142 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108256),
     /*  108147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  108150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  108153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108165 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108210), // Rule ID 51224 //
     /*  108170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108173 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  108176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  108190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108208 */     GIR_RootConstrainSelectedInstOperands,
     /*  108209 */     // GIR_Coverage, 51224,
     /*  108209 */     GIR_EraseRootFromParent_Done,
     /*  108210 */   // Label 1693: @108210
     /*  108210 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108255), // Rule ID 51225 //
     /*  108215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108218 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  108221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  108235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108253 */     GIR_RootConstrainSelectedInstOperands,
     /*  108254 */     // GIR_Coverage, 51225,
     /*  108254 */     GIR_EraseRootFromParent_Done,
     /*  108255 */   // Label 1694: @108255
     /*  108255 */   GIM_Reject,
     /*  108256 */ // Label 1692: @108256
     /*  108256 */ GIM_Reject,
     /*  108257 */ // Label 1666: @108257
     /*  108257 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108371),
     /*  108262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  108265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  108268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108280 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108325), // Rule ID 51232 //
     /*  108285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108288 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  108291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  108305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108323 */     GIR_RootConstrainSelectedInstOperands,
     /*  108324 */     // GIR_Coverage, 51232,
     /*  108324 */     GIR_EraseRootFromParent_Done,
     /*  108325 */   // Label 1696: @108325
     /*  108325 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108370), // Rule ID 51233 //
     /*  108330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108333 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  108336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  108350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108368 */     GIR_RootConstrainSelectedInstOperands,
     /*  108369 */     // GIR_Coverage, 51233,
     /*  108369 */     GIR_EraseRootFromParent_Done,
     /*  108370 */   // Label 1697: @108370
     /*  108370 */   GIM_Reject,
     /*  108371 */ // Label 1695: @108371
     /*  108371 */ GIM_Reject,
     /*  108372 */ // Label 1667: @108372
     /*  108372 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108486),
     /*  108377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  108380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  108383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108395 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108440), // Rule ID 51248 //
     /*  108400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108403 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  108406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  108420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108438 */     GIR_RootConstrainSelectedInstOperands,
     /*  108439 */     // GIR_Coverage, 51248,
     /*  108439 */     GIR_EraseRootFromParent_Done,
     /*  108440 */   // Label 1699: @108440
     /*  108440 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108485), // Rule ID 51249 //
     /*  108445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108448 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  108451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  108465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108483 */     GIR_RootConstrainSelectedInstOperands,
     /*  108484 */     // GIR_Coverage, 51249,
     /*  108484 */     GIR_EraseRootFromParent_Done,
     /*  108485 */   // Label 1700: @108485
     /*  108485 */   GIM_Reject,
     /*  108486 */ // Label 1698: @108486
     /*  108486 */ GIM_Reject,
     /*  108487 */ // Label 1668: @108487
     /*  108487 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108601),
     /*  108492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108510 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108555), // Rule ID 51216 //
     /*  108515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108518 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108553 */     GIR_RootConstrainSelectedInstOperands,
     /*  108554 */     // GIR_Coverage, 51216,
     /*  108554 */     GIR_EraseRootFromParent_Done,
     /*  108555 */   // Label 1702: @108555
     /*  108555 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108600), // Rule ID 51217 //
     /*  108560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108563 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108598 */     GIR_RootConstrainSelectedInstOperands,
     /*  108599 */     // GIR_Coverage, 51217,
     /*  108599 */     GIR_EraseRootFromParent_Done,
     /*  108600 */   // Label 1703: @108600
     /*  108600 */   GIM_Reject,
     /*  108601 */ // Label 1701: @108601
     /*  108601 */ GIM_Reject,
     /*  108602 */ // Label 1669: @108602
     /*  108602 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108716),
     /*  108607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108625 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108670), // Rule ID 51228 //
     /*  108630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108633 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108668 */     GIR_RootConstrainSelectedInstOperands,
     /*  108669 */     // GIR_Coverage, 51228,
     /*  108669 */     GIR_EraseRootFromParent_Done,
     /*  108670 */   // Label 1705: @108670
     /*  108670 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108715), // Rule ID 51229 //
     /*  108675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108678 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108713 */     GIR_RootConstrainSelectedInstOperands,
     /*  108714 */     // GIR_Coverage, 51229,
     /*  108714 */     GIR_EraseRootFromParent_Done,
     /*  108715 */   // Label 1706: @108715
     /*  108715 */   GIM_Reject,
     /*  108716 */ // Label 1704: @108716
     /*  108716 */ GIM_Reject,
     /*  108717 */ // Label 1670: @108717
     /*  108717 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108831),
     /*  108722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108740 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108785), // Rule ID 51244 //
     /*  108745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108748 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108783 */     GIR_RootConstrainSelectedInstOperands,
     /*  108784 */     // GIR_Coverage, 51244,
     /*  108784 */     GIR_EraseRootFromParent_Done,
     /*  108785 */   // Label 1708: @108785
     /*  108785 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108830), // Rule ID 51245 //
     /*  108790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108793 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108828 */     GIR_RootConstrainSelectedInstOperands,
     /*  108829 */     // GIR_Coverage, 51245,
     /*  108829 */     GIR_EraseRootFromParent_Done,
     /*  108830 */   // Label 1709: @108830
     /*  108830 */   GIM_Reject,
     /*  108831 */ // Label 1707: @108831
     /*  108831 */ GIM_Reject,
     /*  108832 */ // Label 1671: @108832
     /*  108832 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108946),
     /*  108837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108855 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108900), // Rule ID 51288 //
     /*  108860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108863 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108898 */     GIR_RootConstrainSelectedInstOperands,
     /*  108899 */     // GIR_Coverage, 51288,
     /*  108899 */     GIR_EraseRootFromParent_Done,
     /*  108900 */   // Label 1711: @108900
     /*  108900 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108945), // Rule ID 51289 //
     /*  108905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108908 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108943 */     GIR_RootConstrainSelectedInstOperands,
     /*  108944 */     // GIR_Coverage, 51289,
     /*  108944 */     GIR_EraseRootFromParent_Done,
     /*  108945 */   // Label 1712: @108945
     /*  108945 */   GIM_Reject,
     /*  108946 */ // Label 1710: @108946
     /*  108946 */ GIM_Reject,
     /*  108947 */ // Label 1672: @108947
     /*  108947 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109061),
     /*  108952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108970 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109015), // Rule ID 51220 //
     /*  108975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108978 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109013 */     GIR_RootConstrainSelectedInstOperands,
     /*  109014 */     // GIR_Coverage, 51220,
     /*  109014 */     GIR_EraseRootFromParent_Done,
     /*  109015 */   // Label 1714: @109015
     /*  109015 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109060), // Rule ID 51221 //
     /*  109020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109023 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  109026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  109040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109058 */     GIR_RootConstrainSelectedInstOperands,
     /*  109059 */     // GIR_Coverage, 51221,
     /*  109059 */     GIR_EraseRootFromParent_Done,
     /*  109060 */   // Label 1715: @109060
     /*  109060 */   GIM_Reject,
     /*  109061 */ // Label 1713: @109061
     /*  109061 */ GIM_Reject,
     /*  109062 */ // Label 1673: @109062
     /*  109062 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109176),
     /*  109067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  109070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  109073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109085 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109130), // Rule ID 51240 //
     /*  109090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109093 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  109096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  109110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109128 */     GIR_RootConstrainSelectedInstOperands,
     /*  109129 */     // GIR_Coverage, 51240,
     /*  109129 */     GIR_EraseRootFromParent_Done,
     /*  109130 */   // Label 1717: @109130
     /*  109130 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109175), // Rule ID 51241 //
     /*  109135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109138 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  109141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  109155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109173 */     GIR_RootConstrainSelectedInstOperands,
     /*  109174 */     // GIR_Coverage, 51241,
     /*  109174 */     GIR_EraseRootFromParent_Done,
     /*  109175 */   // Label 1718: @109175
     /*  109175 */   GIM_Reject,
     /*  109176 */ // Label 1716: @109176
     /*  109176 */ GIM_Reject,
     /*  109177 */ // Label 1674: @109177
     /*  109177 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109291),
     /*  109182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  109185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  109188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109200 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109245), // Rule ID 51276 //
     /*  109205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109208 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  109211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  109225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109243 */     GIR_RootConstrainSelectedInstOperands,
     /*  109244 */     // GIR_Coverage, 51276,
     /*  109244 */     GIR_EraseRootFromParent_Done,
     /*  109245 */   // Label 1720: @109245
     /*  109245 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109290), // Rule ID 51277 //
     /*  109250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109253 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  109256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  109270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109288 */     GIR_RootConstrainSelectedInstOperands,
     /*  109289 */     // GIR_Coverage, 51277,
     /*  109289 */     GIR_EraseRootFromParent_Done,
     /*  109290 */   // Label 1721: @109290
     /*  109290 */   GIM_Reject,
     /*  109291 */ // Label 1719: @109291
     /*  109291 */ GIM_Reject,
     /*  109292 */ // Label 1675: @109292
     /*  109292 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109406),
     /*  109297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  109300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  109303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109315 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109360), // Rule ID 51292 //
     /*  109320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109323 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  109326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  109340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109358 */     GIR_RootConstrainSelectedInstOperands,
     /*  109359 */     // GIR_Coverage, 51292,
     /*  109359 */     GIR_EraseRootFromParent_Done,
     /*  109360 */   // Label 1723: @109360
     /*  109360 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109405), // Rule ID 51293 //
     /*  109365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109368 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  109371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  109385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109403 */     GIR_RootConstrainSelectedInstOperands,
     /*  109404 */     // GIR_Coverage, 51293,
     /*  109404 */     GIR_EraseRootFromParent_Done,
     /*  109405 */   // Label 1724: @109405
     /*  109405 */   GIM_Reject,
     /*  109406 */ // Label 1722: @109406
     /*  109406 */ GIM_Reject,
     /*  109407 */ // Label 1676: @109407
     /*  109407 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109521),
     /*  109412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  109415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  109418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109430 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109475), // Rule ID 51236 //
     /*  109435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109438 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109473 */     GIR_RootConstrainSelectedInstOperands,
     /*  109474 */     // GIR_Coverage, 51236,
     /*  109474 */     GIR_EraseRootFromParent_Done,
     /*  109475 */   // Label 1726: @109475
     /*  109475 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109520), // Rule ID 51237 //
     /*  109480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109483 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109518 */     GIR_RootConstrainSelectedInstOperands,
     /*  109519 */     // GIR_Coverage, 51237,
     /*  109519 */     GIR_EraseRootFromParent_Done,
     /*  109520 */   // Label 1727: @109520
     /*  109520 */   GIM_Reject,
     /*  109521 */ // Label 1725: @109521
     /*  109521 */ GIM_Reject,
     /*  109522 */ // Label 1677: @109522
     /*  109522 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109636),
     /*  109527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109545 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109590), // Rule ID 51264 //
     /*  109550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109553 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109588 */     GIR_RootConstrainSelectedInstOperands,
     /*  109589 */     // GIR_Coverage, 51264,
     /*  109589 */     GIR_EraseRootFromParent_Done,
     /*  109590 */   // Label 1729: @109590
     /*  109590 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109635), // Rule ID 51265 //
     /*  109595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109598 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109633 */     GIR_RootConstrainSelectedInstOperands,
     /*  109634 */     // GIR_Coverage, 51265,
     /*  109634 */     GIR_EraseRootFromParent_Done,
     /*  109635 */   // Label 1730: @109635
     /*  109635 */   GIM_Reject,
     /*  109636 */ // Label 1728: @109636
     /*  109636 */ GIM_Reject,
     /*  109637 */ // Label 1678: @109637
     /*  109637 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109751),
     /*  109642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109660 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109705), // Rule ID 51280 //
     /*  109665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109668 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109703 */     GIR_RootConstrainSelectedInstOperands,
     /*  109704 */     // GIR_Coverage, 51280,
     /*  109704 */     GIR_EraseRootFromParent_Done,
     /*  109705 */   // Label 1732: @109705
     /*  109705 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109750), // Rule ID 51281 //
     /*  109710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109713 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109748 */     GIR_RootConstrainSelectedInstOperands,
     /*  109749 */     // GIR_Coverage, 51281,
     /*  109749 */     GIR_EraseRootFromParent_Done,
     /*  109750 */   // Label 1733: @109750
     /*  109750 */   GIM_Reject,
     /*  109751 */ // Label 1731: @109751
     /*  109751 */ GIM_Reject,
     /*  109752 */ // Label 1679: @109752
     /*  109752 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109866),
     /*  109757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109775 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109820), // Rule ID 51296 //
     /*  109780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109783 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109818 */     GIR_RootConstrainSelectedInstOperands,
     /*  109819 */     // GIR_Coverage, 51296,
     /*  109819 */     GIR_EraseRootFromParent_Done,
     /*  109820 */   // Label 1735: @109820
     /*  109820 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109865), // Rule ID 51297 //
     /*  109825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109828 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109863 */     GIR_RootConstrainSelectedInstOperands,
     /*  109864 */     // GIR_Coverage, 51297,
     /*  109864 */     GIR_EraseRootFromParent_Done,
     /*  109865 */   // Label 1736: @109865
     /*  109865 */   GIM_Reject,
     /*  109866 */ // Label 1734: @109866
     /*  109866 */ GIM_Reject,
     /*  109867 */ // Label 1680: @109867
     /*  109867 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109981),
     /*  109872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109890 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109935), // Rule ID 51252 //
     /*  109895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109898 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109933 */     GIR_RootConstrainSelectedInstOperands,
     /*  109934 */     // GIR_Coverage, 51252,
     /*  109934 */     GIR_EraseRootFromParent_Done,
     /*  109935 */   // Label 1738: @109935
     /*  109935 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109980), // Rule ID 51253 //
     /*  109940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109943 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109978 */     GIR_RootConstrainSelectedInstOperands,
     /*  109979 */     // GIR_Coverage, 51253,
     /*  109979 */     GIR_EraseRootFromParent_Done,
     /*  109980 */   // Label 1739: @109980
     /*  109980 */   GIM_Reject,
     /*  109981 */ // Label 1737: @109981
     /*  109981 */ GIM_Reject,
     /*  109982 */ // Label 1681: @109982
     /*  109982 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110096),
     /*  109987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  109993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110005 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110050), // Rule ID 51268 //
     /*  110010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110013 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  110030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110048 */     GIR_RootConstrainSelectedInstOperands,
     /*  110049 */     // GIR_Coverage, 51268,
     /*  110049 */     GIR_EraseRootFromParent_Done,
     /*  110050 */   // Label 1741: @110050
     /*  110050 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110095), // Rule ID 51269 //
     /*  110055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110058 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  110075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110093 */     GIR_RootConstrainSelectedInstOperands,
     /*  110094 */     // GIR_Coverage, 51269,
     /*  110094 */     GIR_EraseRootFromParent_Done,
     /*  110095 */   // Label 1742: @110095
     /*  110095 */   GIM_Reject,
     /*  110096 */ // Label 1740: @110096
     /*  110096 */ GIM_Reject,
     /*  110097 */ // Label 1682: @110097
     /*  110097 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110211),
     /*  110102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  110105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  110108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110120 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110165), // Rule ID 51284 //
     /*  110125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110128 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  110131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  110145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110163 */     GIR_RootConstrainSelectedInstOperands,
     /*  110164 */     // GIR_Coverage, 51284,
     /*  110164 */     GIR_EraseRootFromParent_Done,
     /*  110165 */   // Label 1744: @110165
     /*  110165 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110210), // Rule ID 51285 //
     /*  110170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110173 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  110176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  110190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110208 */     GIR_RootConstrainSelectedInstOperands,
     /*  110209 */     // GIR_Coverage, 51285,
     /*  110209 */     GIR_EraseRootFromParent_Done,
     /*  110210 */   // Label 1745: @110210
     /*  110210 */   GIM_Reject,
     /*  110211 */ // Label 1743: @110211
     /*  110211 */ GIM_Reject,
     /*  110212 */ // Label 1683: @110212
     /*  110212 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110326),
     /*  110217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  110220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  110223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110235 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110280), // Rule ID 51256 //
     /*  110240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110243 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  110246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  110260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110278 */     GIR_RootConstrainSelectedInstOperands,
     /*  110279 */     // GIR_Coverage, 51256,
     /*  110279 */     GIR_EraseRootFromParent_Done,
     /*  110280 */   // Label 1747: @110280
     /*  110280 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110325), // Rule ID 51257 //
     /*  110285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110288 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  110291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  110305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110323 */     GIR_RootConstrainSelectedInstOperands,
     /*  110324 */     // GIR_Coverage, 51257,
     /*  110324 */     GIR_EraseRootFromParent_Done,
     /*  110325 */   // Label 1748: @110325
     /*  110325 */   GIM_Reject,
     /*  110326 */ // Label 1746: @110326
     /*  110326 */ GIM_Reject,
     /*  110327 */ // Label 1684: @110327
     /*  110327 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110441),
     /*  110332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  110335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  110338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110350 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110395), // Rule ID 51272 //
     /*  110355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110358 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  110361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  110375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110393 */     GIR_RootConstrainSelectedInstOperands,
     /*  110394 */     // GIR_Coverage, 51272,
     /*  110394 */     GIR_EraseRootFromParent_Done,
     /*  110395 */   // Label 1750: @110395
     /*  110395 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110440), // Rule ID 51273 //
     /*  110400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110403 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  110406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  110420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110438 */     GIR_RootConstrainSelectedInstOperands,
     /*  110439 */     // GIR_Coverage, 51273,
     /*  110439 */     GIR_EraseRootFromParent_Done,
     /*  110440 */   // Label 1751: @110440
     /*  110440 */   GIM_Reject,
     /*  110441 */ // Label 1749: @110441
     /*  110441 */ GIM_Reject,
     /*  110442 */ // Label 1685: @110442
     /*  110442 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110556),
     /*  110447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  110450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  110453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110465 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110510), // Rule ID 51260 //
     /*  110470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110473 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110508 */     GIR_RootConstrainSelectedInstOperands,
     /*  110509 */     // GIR_Coverage, 51260,
     /*  110509 */     GIR_EraseRootFromParent_Done,
     /*  110510 */   // Label 1753: @110510
     /*  110510 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110555), // Rule ID 51261 //
     /*  110515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110518 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110553 */     GIR_RootConstrainSelectedInstOperands,
     /*  110554 */     // GIR_Coverage, 51261,
     /*  110554 */     GIR_EraseRootFromParent_Done,
     /*  110555 */   // Label 1754: @110555
     /*  110555 */   GIM_Reject,
     /*  110556 */ // Label 1752: @110556
     /*  110556 */ GIM_Reject,
     /*  110557 */ // Label 1686: @110557
     /*  110557 */ GIM_Reject,
     /*  110558 */ // Label 4: @110558
     /*  110558 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1779*/ GIMT_Encode4(113291),
     /*  110569 */ /*GILLT_s32*//*Label 1755*/ GIMT_Encode4(110693),
     /*  110573 */ /*GILLT_s64*//*Label 1756*/ GIMT_Encode4(110727), GIMT_Encode4(0),
     /*  110581 */ /*GILLT_nxv1s8*//*Label 1757*/ GIMT_Encode4(110761),
     /*  110585 */ /*GILLT_nxv1s16*//*Label 1758*/ GIMT_Encode4(110876),
     /*  110589 */ /*GILLT_nxv1s32*//*Label 1759*/ GIMT_Encode4(110991),
     /*  110593 */ /*GILLT_nxv1s64*//*Label 1760*/ GIMT_Encode4(111106), GIMT_Encode4(0),
     /*  110601 */ /*GILLT_nxv2s8*//*Label 1761*/ GIMT_Encode4(111221),
     /*  110605 */ /*GILLT_nxv2s16*//*Label 1762*/ GIMT_Encode4(111336),
     /*  110609 */ /*GILLT_nxv2s32*//*Label 1763*/ GIMT_Encode4(111451),
     /*  110613 */ /*GILLT_nxv2s64*//*Label 1764*/ GIMT_Encode4(111566), GIMT_Encode4(0),
     /*  110621 */ /*GILLT_nxv4s8*//*Label 1765*/ GIMT_Encode4(111681),
     /*  110625 */ /*GILLT_nxv4s16*//*Label 1766*/ GIMT_Encode4(111796),
     /*  110629 */ /*GILLT_nxv4s32*//*Label 1767*/ GIMT_Encode4(111911),
     /*  110633 */ /*GILLT_nxv4s64*//*Label 1768*/ GIMT_Encode4(112026), GIMT_Encode4(0),
     /*  110641 */ /*GILLT_nxv8s8*//*Label 1769*/ GIMT_Encode4(112141),
     /*  110645 */ /*GILLT_nxv8s16*//*Label 1770*/ GIMT_Encode4(112256),
     /*  110649 */ /*GILLT_nxv8s32*//*Label 1771*/ GIMT_Encode4(112371),
     /*  110653 */ /*GILLT_nxv8s64*//*Label 1772*/ GIMT_Encode4(112486), GIMT_Encode4(0),
     /*  110661 */ /*GILLT_nxv16s8*//*Label 1773*/ GIMT_Encode4(112601),
     /*  110665 */ /*GILLT_nxv16s16*//*Label 1774*/ GIMT_Encode4(112716),
     /*  110669 */ /*GILLT_nxv16s32*//*Label 1775*/ GIMT_Encode4(112831), GIMT_Encode4(0),
     /*  110677 */ /*GILLT_nxv32s8*//*Label 1776*/ GIMT_Encode4(112946),
     /*  110681 */ /*GILLT_nxv32s16*//*Label 1777*/ GIMT_Encode4(113061), GIMT_Encode4(0),
     /*  110689 */ /*GILLT_nxv64s8*//*Label 1778*/ GIMT_Encode4(113176),
     /*  110693 */ // Label 1755: @110693
     /*  110693 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110726), // Rule ID 312 //
     /*  110698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110719 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110724 */   GIR_RootConstrainSelectedInstOperands,
     /*  110725 */   // GIR_Coverage, 312,
     /*  110725 */   GIR_Done,
     /*  110726 */ // Label 1780: @110726
     /*  110726 */ GIM_Reject,
     /*  110727 */ // Label 1756: @110727
     /*  110727 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110760), // Rule ID 311 //
     /*  110732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110753 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110758 */   GIR_RootConstrainSelectedInstOperands,
     /*  110759 */   // GIR_Coverage, 311,
     /*  110759 */   GIR_Done,
     /*  110760 */ // Label 1781: @110760
     /*  110760 */ GIM_Reject,
     /*  110761 */ // Label 1757: @110761
     /*  110761 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110875),
     /*  110766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110784 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110829), // Rule ID 51124 //
     /*  110789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110792 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110827 */     GIR_RootConstrainSelectedInstOperands,
     /*  110828 */     // GIR_Coverage, 51124,
     /*  110828 */     GIR_EraseRootFromParent_Done,
     /*  110829 */   // Label 1783: @110829
     /*  110829 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110874), // Rule ID 51125 //
     /*  110834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110837 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110872 */     GIR_RootConstrainSelectedInstOperands,
     /*  110873 */     // GIR_Coverage, 51125,
     /*  110873 */     GIR_EraseRootFromParent_Done,
     /*  110874 */   // Label 1784: @110874
     /*  110874 */   GIM_Reject,
     /*  110875 */ // Label 1782: @110875
     /*  110875 */ GIM_Reject,
     /*  110876 */ // Label 1758: @110876
     /*  110876 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110990),
     /*  110881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110899 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110944), // Rule ID 51136 //
     /*  110904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110907 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110942 */     GIR_RootConstrainSelectedInstOperands,
     /*  110943 */     // GIR_Coverage, 51136,
     /*  110943 */     GIR_EraseRootFromParent_Done,
     /*  110944 */   // Label 1786: @110944
     /*  110944 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110989), // Rule ID 51137 //
     /*  110949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110952 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110987 */     GIR_RootConstrainSelectedInstOperands,
     /*  110988 */     // GIR_Coverage, 51137,
     /*  110988 */     GIR_EraseRootFromParent_Done,
     /*  110989 */   // Label 1787: @110989
     /*  110989 */   GIM_Reject,
     /*  110990 */ // Label 1785: @110990
     /*  110990 */ GIM_Reject,
     /*  110991 */ // Label 1759: @110991
     /*  110991 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111105),
     /*  110996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  110999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  111002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111014 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111059), // Rule ID 51144 //
     /*  111019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111022 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  111025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  111039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111057 */     GIR_RootConstrainSelectedInstOperands,
     /*  111058 */     // GIR_Coverage, 51144,
     /*  111058 */     GIR_EraseRootFromParent_Done,
     /*  111059 */   // Label 1789: @111059
     /*  111059 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111104), // Rule ID 51145 //
     /*  111064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111067 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  111070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  111084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111102 */     GIR_RootConstrainSelectedInstOperands,
     /*  111103 */     // GIR_Coverage, 51145,
     /*  111103 */     GIR_EraseRootFromParent_Done,
     /*  111104 */   // Label 1790: @111104
     /*  111104 */   GIM_Reject,
     /*  111105 */ // Label 1788: @111105
     /*  111105 */ GIM_Reject,
     /*  111106 */ // Label 1760: @111106
     /*  111106 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111220),
     /*  111111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  111114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  111117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111129 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111174), // Rule ID 51160 //
     /*  111134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111137 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  111140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  111154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111172 */     GIR_RootConstrainSelectedInstOperands,
     /*  111173 */     // GIR_Coverage, 51160,
     /*  111173 */     GIR_EraseRootFromParent_Done,
     /*  111174 */   // Label 1792: @111174
     /*  111174 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(111219), // Rule ID 51161 //
     /*  111179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111182 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  111185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  111199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111217 */     GIR_RootConstrainSelectedInstOperands,
     /*  111218 */     // GIR_Coverage, 51161,
     /*  111218 */     GIR_EraseRootFromParent_Done,
     /*  111219 */   // Label 1793: @111219
     /*  111219 */   GIM_Reject,
     /*  111220 */ // Label 1791: @111220
     /*  111220 */ GIM_Reject,
     /*  111221 */ // Label 1761: @111221
     /*  111221 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111335),
     /*  111226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  111229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  111232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111244 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111289), // Rule ID 51128 //
     /*  111249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111252 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  111255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  111269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111287 */     GIR_RootConstrainSelectedInstOperands,
     /*  111288 */     // GIR_Coverage, 51128,
     /*  111288 */     GIR_EraseRootFromParent_Done,
     /*  111289 */   // Label 1795: @111289
     /*  111289 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111334), // Rule ID 51129 //
     /*  111294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111297 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  111300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  111314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111332 */     GIR_RootConstrainSelectedInstOperands,
     /*  111333 */     // GIR_Coverage, 51129,
     /*  111333 */     GIR_EraseRootFromParent_Done,
     /*  111334 */   // Label 1796: @111334
     /*  111334 */   GIM_Reject,
     /*  111335 */ // Label 1794: @111335
     /*  111335 */ GIM_Reject,
     /*  111336 */ // Label 1762: @111336
     /*  111336 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111450),
     /*  111341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  111344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  111347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111359 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111404), // Rule ID 51140 //
     /*  111364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111367 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  111370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  111384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111402 */     GIR_RootConstrainSelectedInstOperands,
     /*  111403 */     // GIR_Coverage, 51140,
     /*  111403 */     GIR_EraseRootFromParent_Done,
     /*  111404 */   // Label 1798: @111404
     /*  111404 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111449), // Rule ID 51141 //
     /*  111409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111412 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  111415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  111429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111447 */     GIR_RootConstrainSelectedInstOperands,
     /*  111448 */     // GIR_Coverage, 51141,
     /*  111448 */     GIR_EraseRootFromParent_Done,
     /*  111449 */   // Label 1799: @111449
     /*  111449 */   GIM_Reject,
     /*  111450 */ // Label 1797: @111450
     /*  111450 */ GIM_Reject,
     /*  111451 */ // Label 1763: @111451
     /*  111451 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111565),
     /*  111456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  111459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  111462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111474 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111519), // Rule ID 51156 //
     /*  111479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111482 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111517 */     GIR_RootConstrainSelectedInstOperands,
     /*  111518 */     // GIR_Coverage, 51156,
     /*  111518 */     GIR_EraseRootFromParent_Done,
     /*  111519 */   // Label 1801: @111519
     /*  111519 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111564), // Rule ID 51157 //
     /*  111524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111527 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111562 */     GIR_RootConstrainSelectedInstOperands,
     /*  111563 */     // GIR_Coverage, 51157,
     /*  111563 */     GIR_EraseRootFromParent_Done,
     /*  111564 */   // Label 1802: @111564
     /*  111564 */   GIM_Reject,
     /*  111565 */ // Label 1800: @111565
     /*  111565 */ GIM_Reject,
     /*  111566 */ // Label 1764: @111566
     /*  111566 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111680),
     /*  111571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111589 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111634), // Rule ID 51200 //
     /*  111594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111597 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111632 */     GIR_RootConstrainSelectedInstOperands,
     /*  111633 */     // GIR_Coverage, 51200,
     /*  111633 */     GIR_EraseRootFromParent_Done,
     /*  111634 */   // Label 1804: @111634
     /*  111634 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111679), // Rule ID 51201 //
     /*  111639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111642 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111677 */     GIR_RootConstrainSelectedInstOperands,
     /*  111678 */     // GIR_Coverage, 51201,
     /*  111678 */     GIR_EraseRootFromParent_Done,
     /*  111679 */   // Label 1805: @111679
     /*  111679 */   GIM_Reject,
     /*  111680 */ // Label 1803: @111680
     /*  111680 */ GIM_Reject,
     /*  111681 */ // Label 1765: @111681
     /*  111681 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111795),
     /*  111686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111704 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111749), // Rule ID 51132 //
     /*  111709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111712 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111747 */     GIR_RootConstrainSelectedInstOperands,
     /*  111748 */     // GIR_Coverage, 51132,
     /*  111748 */     GIR_EraseRootFromParent_Done,
     /*  111749 */   // Label 1807: @111749
     /*  111749 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111794), // Rule ID 51133 //
     /*  111754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111757 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111792 */     GIR_RootConstrainSelectedInstOperands,
     /*  111793 */     // GIR_Coverage, 51133,
     /*  111793 */     GIR_EraseRootFromParent_Done,
     /*  111794 */   // Label 1808: @111794
     /*  111794 */   GIM_Reject,
     /*  111795 */ // Label 1806: @111795
     /*  111795 */ GIM_Reject,
     /*  111796 */ // Label 1766: @111796
     /*  111796 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111910),
     /*  111801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111819 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111864), // Rule ID 51152 //
     /*  111824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111827 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111862 */     GIR_RootConstrainSelectedInstOperands,
     /*  111863 */     // GIR_Coverage, 51152,
     /*  111863 */     GIR_EraseRootFromParent_Done,
     /*  111864 */   // Label 1810: @111864
     /*  111864 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111909), // Rule ID 51153 //
     /*  111869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111872 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111907 */     GIR_RootConstrainSelectedInstOperands,
     /*  111908 */     // GIR_Coverage, 51153,
     /*  111908 */     GIR_EraseRootFromParent_Done,
     /*  111909 */   // Label 1811: @111909
     /*  111909 */   GIM_Reject,
     /*  111910 */ // Label 1809: @111910
     /*  111910 */ GIM_Reject,
     /*  111911 */ // Label 1767: @111911
     /*  111911 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112025),
     /*  111916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111934 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111979), // Rule ID 51188 //
     /*  111939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111942 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111977 */     GIR_RootConstrainSelectedInstOperands,
     /*  111978 */     // GIR_Coverage, 51188,
     /*  111978 */     GIR_EraseRootFromParent_Done,
     /*  111979 */   // Label 1813: @111979
     /*  111979 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112024), // Rule ID 51189 //
     /*  111984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111987 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  112004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112022 */     GIR_RootConstrainSelectedInstOperands,
     /*  112023 */     // GIR_Coverage, 51189,
     /*  112023 */     GIR_EraseRootFromParent_Done,
     /*  112024 */   // Label 1814: @112024
     /*  112024 */   GIM_Reject,
     /*  112025 */ // Label 1812: @112025
     /*  112025 */ GIM_Reject,
     /*  112026 */ // Label 1768: @112026
     /*  112026 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112140),
     /*  112031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  112034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  112037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112049 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112094), // Rule ID 51204 //
     /*  112054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112057 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  112060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  112074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112092 */     GIR_RootConstrainSelectedInstOperands,
     /*  112093 */     // GIR_Coverage, 51204,
     /*  112093 */     GIR_EraseRootFromParent_Done,
     /*  112094 */   // Label 1816: @112094
     /*  112094 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112139), // Rule ID 51205 //
     /*  112099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112102 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  112105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  112119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112137 */     GIR_RootConstrainSelectedInstOperands,
     /*  112138 */     // GIR_Coverage, 51205,
     /*  112138 */     GIR_EraseRootFromParent_Done,
     /*  112139 */   // Label 1817: @112139
     /*  112139 */   GIM_Reject,
     /*  112140 */ // Label 1815: @112140
     /*  112140 */ GIM_Reject,
     /*  112141 */ // Label 1769: @112141
     /*  112141 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112255),
     /*  112146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  112149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  112152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112164 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112209), // Rule ID 51148 //
     /*  112169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112172 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  112175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  112189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112207 */     GIR_RootConstrainSelectedInstOperands,
     /*  112208 */     // GIR_Coverage, 51148,
     /*  112208 */     GIR_EraseRootFromParent_Done,
     /*  112209 */   // Label 1819: @112209
     /*  112209 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112254), // Rule ID 51149 //
     /*  112214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112217 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  112220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  112234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112252 */     GIR_RootConstrainSelectedInstOperands,
     /*  112253 */     // GIR_Coverage, 51149,
     /*  112253 */     GIR_EraseRootFromParent_Done,
     /*  112254 */   // Label 1820: @112254
     /*  112254 */   GIM_Reject,
     /*  112255 */ // Label 1818: @112255
     /*  112255 */ GIM_Reject,
     /*  112256 */ // Label 1770: @112256
     /*  112256 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112370),
     /*  112261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  112264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  112267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112279 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112324), // Rule ID 51176 //
     /*  112284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112287 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  112290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  112304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112322 */     GIR_RootConstrainSelectedInstOperands,
     /*  112323 */     // GIR_Coverage, 51176,
     /*  112323 */     GIR_EraseRootFromParent_Done,
     /*  112324 */   // Label 1822: @112324
     /*  112324 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112369), // Rule ID 51177 //
     /*  112329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112332 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  112335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  112349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112367 */     GIR_RootConstrainSelectedInstOperands,
     /*  112368 */     // GIR_Coverage, 51177,
     /*  112368 */     GIR_EraseRootFromParent_Done,
     /*  112369 */   // Label 1823: @112369
     /*  112369 */   GIM_Reject,
     /*  112370 */ // Label 1821: @112370
     /*  112370 */ GIM_Reject,
     /*  112371 */ // Label 1771: @112371
     /*  112371 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112485),
     /*  112376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  112379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  112382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112394 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112439), // Rule ID 51192 //
     /*  112399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112402 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  112405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  112419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112437 */     GIR_RootConstrainSelectedInstOperands,
     /*  112438 */     // GIR_Coverage, 51192,
     /*  112438 */     GIR_EraseRootFromParent_Done,
     /*  112439 */   // Label 1825: @112439
     /*  112439 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112484), // Rule ID 51193 //
     /*  112444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112447 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  112450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  112464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112482 */     GIR_RootConstrainSelectedInstOperands,
     /*  112483 */     // GIR_Coverage, 51193,
     /*  112483 */     GIR_EraseRootFromParent_Done,
     /*  112484 */   // Label 1826: @112484
     /*  112484 */   GIM_Reject,
     /*  112485 */ // Label 1824: @112485
     /*  112485 */ GIM_Reject,
     /*  112486 */ // Label 1772: @112486
     /*  112486 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112600),
     /*  112491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112509 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112554), // Rule ID 51208 //
     /*  112514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112517 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112552 */     GIR_RootConstrainSelectedInstOperands,
     /*  112553 */     // GIR_Coverage, 51208,
     /*  112553 */     GIR_EraseRootFromParent_Done,
     /*  112554 */   // Label 1828: @112554
     /*  112554 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112599), // Rule ID 51209 //
     /*  112559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112562 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112597 */     GIR_RootConstrainSelectedInstOperands,
     /*  112598 */     // GIR_Coverage, 51209,
     /*  112598 */     GIR_EraseRootFromParent_Done,
     /*  112599 */   // Label 1829: @112599
     /*  112599 */   GIM_Reject,
     /*  112600 */ // Label 1827: @112600
     /*  112600 */ GIM_Reject,
     /*  112601 */ // Label 1773: @112601
     /*  112601 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112715),
     /*  112606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112624 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112669), // Rule ID 51164 //
     /*  112629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112632 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112667 */     GIR_RootConstrainSelectedInstOperands,
     /*  112668 */     // GIR_Coverage, 51164,
     /*  112668 */     GIR_EraseRootFromParent_Done,
     /*  112669 */   // Label 1831: @112669
     /*  112669 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112714), // Rule ID 51165 //
     /*  112674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112677 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112712 */     GIR_RootConstrainSelectedInstOperands,
     /*  112713 */     // GIR_Coverage, 51165,
     /*  112713 */     GIR_EraseRootFromParent_Done,
     /*  112714 */   // Label 1832: @112714
     /*  112714 */   GIM_Reject,
     /*  112715 */ // Label 1830: @112715
     /*  112715 */ GIM_Reject,
     /*  112716 */ // Label 1774: @112716
     /*  112716 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112830),
     /*  112721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112739 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112784), // Rule ID 51180 //
     /*  112744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112747 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112782 */     GIR_RootConstrainSelectedInstOperands,
     /*  112783 */     // GIR_Coverage, 51180,
     /*  112783 */     GIR_EraseRootFromParent_Done,
     /*  112784 */   // Label 1834: @112784
     /*  112784 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112829), // Rule ID 51181 //
     /*  112789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112792 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112827 */     GIR_RootConstrainSelectedInstOperands,
     /*  112828 */     // GIR_Coverage, 51181,
     /*  112828 */     GIR_EraseRootFromParent_Done,
     /*  112829 */   // Label 1835: @112829
     /*  112829 */   GIM_Reject,
     /*  112830 */ // Label 1833: @112830
     /*  112830 */ GIM_Reject,
     /*  112831 */ // Label 1775: @112831
     /*  112831 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112945),
     /*  112836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112854 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112899), // Rule ID 51196 //
     /*  112859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112862 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112897 */     GIR_RootConstrainSelectedInstOperands,
     /*  112898 */     // GIR_Coverage, 51196,
     /*  112898 */     GIR_EraseRootFromParent_Done,
     /*  112899 */   // Label 1837: @112899
     /*  112899 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112944), // Rule ID 51197 //
     /*  112904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112907 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112942 */     GIR_RootConstrainSelectedInstOperands,
     /*  112943 */     // GIR_Coverage, 51197,
     /*  112943 */     GIR_EraseRootFromParent_Done,
     /*  112944 */   // Label 1838: @112944
     /*  112944 */   GIM_Reject,
     /*  112945 */ // Label 1836: @112945
     /*  112945 */ GIM_Reject,
     /*  112946 */ // Label 1776: @112946
     /*  112946 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113060),
     /*  112951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112969 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113014), // Rule ID 51168 //
     /*  112974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112977 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113012 */     GIR_RootConstrainSelectedInstOperands,
     /*  113013 */     // GIR_Coverage, 51168,
     /*  113013 */     GIR_EraseRootFromParent_Done,
     /*  113014 */   // Label 1840: @113014
     /*  113014 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113059), // Rule ID 51169 //
     /*  113019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113022 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  113025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  113039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113057 */     GIR_RootConstrainSelectedInstOperands,
     /*  113058 */     // GIR_Coverage, 51169,
     /*  113058 */     GIR_EraseRootFromParent_Done,
     /*  113059 */   // Label 1841: @113059
     /*  113059 */   GIM_Reject,
     /*  113060 */ // Label 1839: @113060
     /*  113060 */ GIM_Reject,
     /*  113061 */ // Label 1777: @113061
     /*  113061 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113175),
     /*  113066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  113069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  113072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113084 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113129), // Rule ID 51184 //
     /*  113089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113092 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  113095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  113109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113127 */     GIR_RootConstrainSelectedInstOperands,
     /*  113128 */     // GIR_Coverage, 51184,
     /*  113128 */     GIR_EraseRootFromParent_Done,
     /*  113129 */   // Label 1843: @113129
     /*  113129 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113174), // Rule ID 51185 //
     /*  113134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113137 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  113140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  113154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113172 */     GIR_RootConstrainSelectedInstOperands,
     /*  113173 */     // GIR_Coverage, 51185,
     /*  113173 */     GIR_EraseRootFromParent_Done,
     /*  113174 */   // Label 1844: @113174
     /*  113174 */   GIM_Reject,
     /*  113175 */ // Label 1842: @113175
     /*  113175 */ GIM_Reject,
     /*  113176 */ // Label 1778: @113176
     /*  113176 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113290),
     /*  113181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  113184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  113187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113199 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113244), // Rule ID 51172 //
     /*  113204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113207 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  113210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  113224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113242 */     GIR_RootConstrainSelectedInstOperands,
     /*  113243 */     // GIR_Coverage, 51172,
     /*  113243 */     GIR_EraseRootFromParent_Done,
     /*  113244 */   // Label 1846: @113244
     /*  113244 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113289), // Rule ID 51173 //
     /*  113249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113252 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  113255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  113269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113287 */     GIR_RootConstrainSelectedInstOperands,
     /*  113288 */     // GIR_Coverage, 51173,
     /*  113288 */     GIR_EraseRootFromParent_Done,
     /*  113289 */   // Label 1847: @113289
     /*  113289 */   GIM_Reject,
     /*  113290 */ // Label 1845: @113290
     /*  113290 */ GIM_Reject,
     /*  113291 */ // Label 1779: @113291
     /*  113291 */ GIM_Reject,
     /*  113292 */ // Label 5: @113292
     /*  113292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(116070),
     /*  113303 */ /*GILLT_s32*//*Label 1848*/ GIMT_Encode4(113427),
     /*  113307 */ /*GILLT_s64*//*Label 1849*/ GIMT_Encode4(113461), GIMT_Encode4(0),
     /*  113315 */ /*GILLT_nxv1s8*//*Label 1850*/ GIMT_Encode4(113540),
     /*  113319 */ /*GILLT_nxv1s16*//*Label 1851*/ GIMT_Encode4(113655),
     /*  113323 */ /*GILLT_nxv1s32*//*Label 1852*/ GIMT_Encode4(113770),
     /*  113327 */ /*GILLT_nxv1s64*//*Label 1853*/ GIMT_Encode4(113885), GIMT_Encode4(0),
     /*  113335 */ /*GILLT_nxv2s8*//*Label 1854*/ GIMT_Encode4(114000),
     /*  113339 */ /*GILLT_nxv2s16*//*Label 1855*/ GIMT_Encode4(114115),
     /*  113343 */ /*GILLT_nxv2s32*//*Label 1856*/ GIMT_Encode4(114230),
     /*  113347 */ /*GILLT_nxv2s64*//*Label 1857*/ GIMT_Encode4(114345), GIMT_Encode4(0),
     /*  113355 */ /*GILLT_nxv4s8*//*Label 1858*/ GIMT_Encode4(114460),
     /*  113359 */ /*GILLT_nxv4s16*//*Label 1859*/ GIMT_Encode4(114575),
     /*  113363 */ /*GILLT_nxv4s32*//*Label 1860*/ GIMT_Encode4(114690),
     /*  113367 */ /*GILLT_nxv4s64*//*Label 1861*/ GIMT_Encode4(114805), GIMT_Encode4(0),
     /*  113375 */ /*GILLT_nxv8s8*//*Label 1862*/ GIMT_Encode4(114920),
     /*  113379 */ /*GILLT_nxv8s16*//*Label 1863*/ GIMT_Encode4(115035),
     /*  113383 */ /*GILLT_nxv8s32*//*Label 1864*/ GIMT_Encode4(115150),
     /*  113387 */ /*GILLT_nxv8s64*//*Label 1865*/ GIMT_Encode4(115265), GIMT_Encode4(0),
     /*  113395 */ /*GILLT_nxv16s8*//*Label 1866*/ GIMT_Encode4(115380),
     /*  113399 */ /*GILLT_nxv16s16*//*Label 1867*/ GIMT_Encode4(115495),
     /*  113403 */ /*GILLT_nxv16s32*//*Label 1868*/ GIMT_Encode4(115610), GIMT_Encode4(0),
     /*  113411 */ /*GILLT_nxv32s8*//*Label 1869*/ GIMT_Encode4(115725),
     /*  113415 */ /*GILLT_nxv32s16*//*Label 1870*/ GIMT_Encode4(115840), GIMT_Encode4(0),
     /*  113423 */ /*GILLT_nxv64s8*//*Label 1871*/ GIMT_Encode4(115955),
     /*  113427 */ // Label 1848: @113427
     /*  113427 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113460), // Rule ID 314 //
     /*  113432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  113435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  113438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  113441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113453 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  113453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113458 */   GIR_RootConstrainSelectedInstOperands,
     /*  113459 */   // GIR_Coverage, 314,
     /*  113459 */   GIR_Done,
     /*  113460 */ // Label 1873: @113460
     /*  113460 */ GIM_Reject,
     /*  113461 */ // Label 1849: @113461
     /*  113461 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113539),
     /*  113466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113476 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113515), // Rule ID 323 //
     /*  113481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113498 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113513 */     GIR_RootConstrainSelectedInstOperands,
     /*  113514 */     // GIR_Coverage, 323,
     /*  113514 */     GIR_EraseRootFromParent_Done,
     /*  113515 */   // Label 1875: @113515
     /*  113515 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113538), // Rule ID 313 //
     /*  113520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113531 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113536 */     GIR_RootConstrainSelectedInstOperands,
     /*  113537 */     // GIR_Coverage, 313,
     /*  113537 */     GIR_Done,
     /*  113538 */   // Label 1876: @113538
     /*  113538 */   GIM_Reject,
     /*  113539 */ // Label 1874: @113539
     /*  113539 */ GIM_Reject,
     /*  113540 */ // Label 1850: @113540
     /*  113540 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113654),
     /*  113545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113563 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113608), // Rule ID 51388 //
     /*  113568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113571 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113606 */     GIR_RootConstrainSelectedInstOperands,
     /*  113607 */     // GIR_Coverage, 51388,
     /*  113607 */     GIR_EraseRootFromParent_Done,
     /*  113608 */   // Label 1878: @113608
     /*  113608 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113653), // Rule ID 51389 //
     /*  113613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113616 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113651 */     GIR_RootConstrainSelectedInstOperands,
     /*  113652 */     // GIR_Coverage, 51389,
     /*  113652 */     GIR_EraseRootFromParent_Done,
     /*  113653 */   // Label 1879: @113653
     /*  113653 */   GIM_Reject,
     /*  113654 */ // Label 1877: @113654
     /*  113654 */ GIM_Reject,
     /*  113655 */ // Label 1851: @113655
     /*  113655 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113769),
     /*  113660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113678 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113723), // Rule ID 51400 //
     /*  113683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113686 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113721 */     GIR_RootConstrainSelectedInstOperands,
     /*  113722 */     // GIR_Coverage, 51400,
     /*  113722 */     GIR_EraseRootFromParent_Done,
     /*  113723 */   // Label 1881: @113723
     /*  113723 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113768), // Rule ID 51401 //
     /*  113728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113731 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113766 */     GIR_RootConstrainSelectedInstOperands,
     /*  113767 */     // GIR_Coverage, 51401,
     /*  113767 */     GIR_EraseRootFromParent_Done,
     /*  113768 */   // Label 1882: @113768
     /*  113768 */   GIM_Reject,
     /*  113769 */ // Label 1880: @113769
     /*  113769 */ GIM_Reject,
     /*  113770 */ // Label 1852: @113770
     /*  113770 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113884),
     /*  113775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113793 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113838), // Rule ID 51408 //
     /*  113798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113801 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113836 */     GIR_RootConstrainSelectedInstOperands,
     /*  113837 */     // GIR_Coverage, 51408,
     /*  113837 */     GIR_EraseRootFromParent_Done,
     /*  113838 */   // Label 1884: @113838
     /*  113838 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113883), // Rule ID 51409 //
     /*  113843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113846 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113881 */     GIR_RootConstrainSelectedInstOperands,
     /*  113882 */     // GIR_Coverage, 51409,
     /*  113882 */     GIR_EraseRootFromParent_Done,
     /*  113883 */   // Label 1885: @113883
     /*  113883 */   GIM_Reject,
     /*  113884 */ // Label 1883: @113884
     /*  113884 */ GIM_Reject,
     /*  113885 */ // Label 1853: @113885
     /*  113885 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113999),
     /*  113890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113908 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113953), // Rule ID 51424 //
     /*  113913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113916 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113951 */     GIR_RootConstrainSelectedInstOperands,
     /*  113952 */     // GIR_Coverage, 51424,
     /*  113952 */     GIR_EraseRootFromParent_Done,
     /*  113953 */   // Label 1887: @113953
     /*  113953 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113998), // Rule ID 51425 //
     /*  113958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113961 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113996 */     GIR_RootConstrainSelectedInstOperands,
     /*  113997 */     // GIR_Coverage, 51425,
     /*  113997 */     GIR_EraseRootFromParent_Done,
     /*  113998 */   // Label 1888: @113998
     /*  113998 */   GIM_Reject,
     /*  113999 */ // Label 1886: @113999
     /*  113999 */ GIM_Reject,
     /*  114000 */ // Label 1854: @114000
     /*  114000 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(114114),
     /*  114005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  114008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  114011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114023 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(114068), // Rule ID 51392 //
     /*  114028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114031 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  114034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  114048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114066 */     GIR_RootConstrainSelectedInstOperands,
     /*  114067 */     // GIR_Coverage, 51392,
     /*  114067 */     GIR_EraseRootFromParent_Done,
     /*  114068 */   // Label 1890: @114068
     /*  114068 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114113), // Rule ID 51393 //
     /*  114073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114076 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  114079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  114093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114111 */     GIR_RootConstrainSelectedInstOperands,
     /*  114112 */     // GIR_Coverage, 51393,
     /*  114112 */     GIR_EraseRootFromParent_Done,
     /*  114113 */   // Label 1891: @114113
     /*  114113 */   GIM_Reject,
     /*  114114 */ // Label 1889: @114114
     /*  114114 */ GIM_Reject,
     /*  114115 */ // Label 1855: @114115
     /*  114115 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114229),
     /*  114120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  114123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  114126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114138 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114183), // Rule ID 51404 //
     /*  114143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114146 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  114149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  114163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114181 */     GIR_RootConstrainSelectedInstOperands,
     /*  114182 */     // GIR_Coverage, 51404,
     /*  114182 */     GIR_EraseRootFromParent_Done,
     /*  114183 */   // Label 1893: @114183
     /*  114183 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114228), // Rule ID 51405 //
     /*  114188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114191 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  114194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  114208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114226 */     GIR_RootConstrainSelectedInstOperands,
     /*  114227 */     // GIR_Coverage, 51405,
     /*  114227 */     GIR_EraseRootFromParent_Done,
     /*  114228 */   // Label 1894: @114228
     /*  114228 */   GIM_Reject,
     /*  114229 */ // Label 1892: @114229
     /*  114229 */ GIM_Reject,
     /*  114230 */ // Label 1856: @114230
     /*  114230 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114344),
     /*  114235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  114238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  114241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114253 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114298), // Rule ID 51420 //
     /*  114258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114261 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  114264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  114278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114296 */     GIR_RootConstrainSelectedInstOperands,
     /*  114297 */     // GIR_Coverage, 51420,
     /*  114297 */     GIR_EraseRootFromParent_Done,
     /*  114298 */   // Label 1896: @114298
     /*  114298 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114343), // Rule ID 51421 //
     /*  114303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114306 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  114309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  114323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114341 */     GIR_RootConstrainSelectedInstOperands,
     /*  114342 */     // GIR_Coverage, 51421,
     /*  114342 */     GIR_EraseRootFromParent_Done,
     /*  114343 */   // Label 1897: @114343
     /*  114343 */   GIM_Reject,
     /*  114344 */ // Label 1895: @114344
     /*  114344 */ GIM_Reject,
     /*  114345 */ // Label 1857: @114345
     /*  114345 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114459),
     /*  114350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  114353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  114356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114368 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114413), // Rule ID 51464 //
     /*  114373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114376 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  114379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  114393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114411 */     GIR_RootConstrainSelectedInstOperands,
     /*  114412 */     // GIR_Coverage, 51464,
     /*  114412 */     GIR_EraseRootFromParent_Done,
     /*  114413 */   // Label 1899: @114413
     /*  114413 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114458), // Rule ID 51465 //
     /*  114418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114421 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  114424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  114438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114456 */     GIR_RootConstrainSelectedInstOperands,
     /*  114457 */     // GIR_Coverage, 51465,
     /*  114457 */     GIR_EraseRootFromParent_Done,
     /*  114458 */   // Label 1900: @114458
     /*  114458 */   GIM_Reject,
     /*  114459 */ // Label 1898: @114459
     /*  114459 */ GIM_Reject,
     /*  114460 */ // Label 1858: @114460
     /*  114460 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114574),
     /*  114465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114483 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114528), // Rule ID 51396 //
     /*  114488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114491 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114526 */     GIR_RootConstrainSelectedInstOperands,
     /*  114527 */     // GIR_Coverage, 51396,
     /*  114527 */     GIR_EraseRootFromParent_Done,
     /*  114528 */   // Label 1902: @114528
     /*  114528 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114573), // Rule ID 51397 //
     /*  114533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114536 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114571 */     GIR_RootConstrainSelectedInstOperands,
     /*  114572 */     // GIR_Coverage, 51397,
     /*  114572 */     GIR_EraseRootFromParent_Done,
     /*  114573 */   // Label 1903: @114573
     /*  114573 */   GIM_Reject,
     /*  114574 */ // Label 1901: @114574
     /*  114574 */ GIM_Reject,
     /*  114575 */ // Label 1859: @114575
     /*  114575 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114689),
     /*  114580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114598 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114643), // Rule ID 51416 //
     /*  114603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114606 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114641 */     GIR_RootConstrainSelectedInstOperands,
     /*  114642 */     // GIR_Coverage, 51416,
     /*  114642 */     GIR_EraseRootFromParent_Done,
     /*  114643 */   // Label 1905: @114643
     /*  114643 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114688), // Rule ID 51417 //
     /*  114648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114651 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114686 */     GIR_RootConstrainSelectedInstOperands,
     /*  114687 */     // GIR_Coverage, 51417,
     /*  114687 */     GIR_EraseRootFromParent_Done,
     /*  114688 */   // Label 1906: @114688
     /*  114688 */   GIM_Reject,
     /*  114689 */ // Label 1904: @114689
     /*  114689 */ GIM_Reject,
     /*  114690 */ // Label 1860: @114690
     /*  114690 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114804),
     /*  114695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114713 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114758), // Rule ID 51452 //
     /*  114718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114721 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114756 */     GIR_RootConstrainSelectedInstOperands,
     /*  114757 */     // GIR_Coverage, 51452,
     /*  114757 */     GIR_EraseRootFromParent_Done,
     /*  114758 */   // Label 1908: @114758
     /*  114758 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114803), // Rule ID 51453 //
     /*  114763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114766 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114801 */     GIR_RootConstrainSelectedInstOperands,
     /*  114802 */     // GIR_Coverage, 51453,
     /*  114802 */     GIR_EraseRootFromParent_Done,
     /*  114803 */   // Label 1909: @114803
     /*  114803 */   GIM_Reject,
     /*  114804 */ // Label 1907: @114804
     /*  114804 */ GIM_Reject,
     /*  114805 */ // Label 1861: @114805
     /*  114805 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114919),
     /*  114810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114828 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114873), // Rule ID 51468 //
     /*  114833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114836 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114871 */     GIR_RootConstrainSelectedInstOperands,
     /*  114872 */     // GIR_Coverage, 51468,
     /*  114872 */     GIR_EraseRootFromParent_Done,
     /*  114873 */   // Label 1911: @114873
     /*  114873 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114918), // Rule ID 51469 //
     /*  114878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114881 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114916 */     GIR_RootConstrainSelectedInstOperands,
     /*  114917 */     // GIR_Coverage, 51469,
     /*  114917 */     GIR_EraseRootFromParent_Done,
     /*  114918 */   // Label 1912: @114918
     /*  114918 */   GIM_Reject,
     /*  114919 */ // Label 1910: @114919
     /*  114919 */ GIM_Reject,
     /*  114920 */ // Label 1862: @114920
     /*  114920 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115034),
     /*  114925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114943 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114988), // Rule ID 51412 //
     /*  114948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114951 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114986 */     GIR_RootConstrainSelectedInstOperands,
     /*  114987 */     // GIR_Coverage, 51412,
     /*  114987 */     GIR_EraseRootFromParent_Done,
     /*  114988 */   // Label 1914: @114988
     /*  114988 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115033), // Rule ID 51413 //
     /*  114993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114996 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  115013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115031 */     GIR_RootConstrainSelectedInstOperands,
     /*  115032 */     // GIR_Coverage, 51413,
     /*  115032 */     GIR_EraseRootFromParent_Done,
     /*  115033 */   // Label 1915: @115033
     /*  115033 */   GIM_Reject,
     /*  115034 */ // Label 1913: @115034
     /*  115034 */ GIM_Reject,
     /*  115035 */ // Label 1863: @115035
     /*  115035 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115149),
     /*  115040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  115043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  115046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115058 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(115103), // Rule ID 51440 //
     /*  115063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115066 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  115069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  115083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115101 */     GIR_RootConstrainSelectedInstOperands,
     /*  115102 */     // GIR_Coverage, 51440,
     /*  115102 */     GIR_EraseRootFromParent_Done,
     /*  115103 */   // Label 1917: @115103
     /*  115103 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(115148), // Rule ID 51441 //
     /*  115108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115111 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  115114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  115128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115146 */     GIR_RootConstrainSelectedInstOperands,
     /*  115147 */     // GIR_Coverage, 51441,
     /*  115147 */     GIR_EraseRootFromParent_Done,
     /*  115148 */   // Label 1918: @115148
     /*  115148 */   GIM_Reject,
     /*  115149 */ // Label 1916: @115149
     /*  115149 */ GIM_Reject,
     /*  115150 */ // Label 1864: @115150
     /*  115150 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115264),
     /*  115155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  115158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  115161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115173 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(115218), // Rule ID 51456 //
     /*  115178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115181 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  115184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  115198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115216 */     GIR_RootConstrainSelectedInstOperands,
     /*  115217 */     // GIR_Coverage, 51456,
     /*  115217 */     GIR_EraseRootFromParent_Done,
     /*  115218 */   // Label 1920: @115218
     /*  115218 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115263), // Rule ID 51457 //
     /*  115223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115226 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  115229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  115243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115261 */     GIR_RootConstrainSelectedInstOperands,
     /*  115262 */     // GIR_Coverage, 51457,
     /*  115262 */     GIR_EraseRootFromParent_Done,
     /*  115263 */   // Label 1921: @115263
     /*  115263 */   GIM_Reject,
     /*  115264 */ // Label 1919: @115264
     /*  115264 */ GIM_Reject,
     /*  115265 */ // Label 1865: @115265
     /*  115265 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115379),
     /*  115270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  115273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  115276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115288 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115333), // Rule ID 51472 //
     /*  115293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  115296 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  115296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  115299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  115313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  115328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115331 */     GIR_RootConstrainSelectedInstOperands,
     /*  115332 */     // GIR_Coverage, 51472,
     /*  115332 */     GIR_EraseRootFromParent_Done,
     /*  115333 */   // Label 1923: @115333
     /*  115333 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115378), // Rule ID 51473 //
     /*  115338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  115341 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  115341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  115344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  115358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  115373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115376 */     GIR_RootConstrainSelectedInstOperands,
     /*  115377 */     // GIR_Coverage, 51473,
     /*  115377 */     GIR_EraseRootFromParent_Done,
     /*  115378 */   // Label 1924: @115378
     /*  115378 */   GIM_Reject,
     /*  115379 */ // Label 1922: @115379
     /*  115379 */ GIM_Reject,
     /*  115380 */ // Label 1866: @115380
     /*  115380 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115494),
     /*  115385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  115388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  115391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  115403 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115448), // Rule ID 51428 //
     /*  115408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115411 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  115414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115446 */     GIR_RootConstrainSelectedInstOperands,
     /*  115447 */     // GIR_Coverage, 51428,
     /*  115447 */     GIR_EraseRootFromParent_Done,
     /*  115448 */   // Label 1926: @115448
     /*  115448 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115493), // Rule ID 51429 //
     /*  115453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115456 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  115459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115491 */     GIR_RootConstrainSelectedInstOperands,
     /*  115492 */     // GIR_Coverage, 51429,
     /*  115492 */     GIR_EraseRootFromParent_Done,
     /*  115493 */   // Label 1927: @115493
     /*  115493 */   GIM_Reject,
     /*  115494 */ // Label 1925: @115494
     /*  115494 */ GIM_Reject,
     /*  115495 */ // Label 1867: @115495
     /*  115495 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115609),
     /*  115500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115518 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115563), // Rule ID 51444 //
     /*  115523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115526 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115561 */     GIR_RootConstrainSelectedInstOperands,
     /*  115562 */     // GIR_Coverage, 51444,
     /*  115562 */     GIR_EraseRootFromParent_Done,
     /*  115563 */   // Label 1929: @115563
     /*  115563 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115608), // Rule ID 51445 //
     /*  115568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115571 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115606 */     GIR_RootConstrainSelectedInstOperands,
     /*  115607 */     // GIR_Coverage, 51445,
     /*  115607 */     GIR_EraseRootFromParent_Done,
     /*  115608 */   // Label 1930: @115608
     /*  115608 */   GIM_Reject,
     /*  115609 */ // Label 1928: @115609
     /*  115609 */ GIM_Reject,
     /*  115610 */ // Label 1868: @115610
     /*  115610 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115724),
     /*  115615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115633 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115678), // Rule ID 51460 //
     /*  115638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115641 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115676 */     GIR_RootConstrainSelectedInstOperands,
     /*  115677 */     // GIR_Coverage, 51460,
     /*  115677 */     GIR_EraseRootFromParent_Done,
     /*  115678 */   // Label 1932: @115678
     /*  115678 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115723), // Rule ID 51461 //
     /*  115683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115686 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115721 */     GIR_RootConstrainSelectedInstOperands,
     /*  115722 */     // GIR_Coverage, 51461,
     /*  115722 */     GIR_EraseRootFromParent_Done,
     /*  115723 */   // Label 1933: @115723
     /*  115723 */   GIM_Reject,
     /*  115724 */ // Label 1931: @115724
     /*  115724 */ GIM_Reject,
     /*  115725 */ // Label 1869: @115725
     /*  115725 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115839),
     /*  115730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115748 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115793), // Rule ID 51432 //
     /*  115753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115756 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115791 */     GIR_RootConstrainSelectedInstOperands,
     /*  115792 */     // GIR_Coverage, 51432,
     /*  115792 */     GIR_EraseRootFromParent_Done,
     /*  115793 */   // Label 1935: @115793
     /*  115793 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115838), // Rule ID 51433 //
     /*  115798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115801 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115836 */     GIR_RootConstrainSelectedInstOperands,
     /*  115837 */     // GIR_Coverage, 51433,
     /*  115837 */     GIR_EraseRootFromParent_Done,
     /*  115838 */   // Label 1936: @115838
     /*  115838 */   GIM_Reject,
     /*  115839 */ // Label 1934: @115839
     /*  115839 */ GIM_Reject,
     /*  115840 */ // Label 1870: @115840
     /*  115840 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(115954),
     /*  115845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115863 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(115908), // Rule ID 51448 //
     /*  115868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115871 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115906 */     GIR_RootConstrainSelectedInstOperands,
     /*  115907 */     // GIR_Coverage, 51448,
     /*  115907 */     GIR_EraseRootFromParent_Done,
     /*  115908 */   // Label 1938: @115908
     /*  115908 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(115953), // Rule ID 51449 //
     /*  115913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115916 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115951 */     GIR_RootConstrainSelectedInstOperands,
     /*  115952 */     // GIR_Coverage, 51449,
     /*  115952 */     GIR_EraseRootFromParent_Done,
     /*  115953 */   // Label 1939: @115953
     /*  115953 */   GIM_Reject,
     /*  115954 */ // Label 1937: @115954
     /*  115954 */ GIM_Reject,
     /*  115955 */ // Label 1871: @115955
     /*  115955 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(116069),
     /*  115960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115978 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(116023), // Rule ID 51436 //
     /*  115983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115986 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  116003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116021 */     GIR_RootConstrainSelectedInstOperands,
     /*  116022 */     // GIR_Coverage, 51436,
     /*  116022 */     GIR_EraseRootFromParent_Done,
     /*  116023 */   // Label 1941: @116023
     /*  116023 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(116068), // Rule ID 51437 //
     /*  116028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116031 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  116034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  116048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116066 */     GIR_RootConstrainSelectedInstOperands,
     /*  116067 */     // GIR_Coverage, 51437,
     /*  116067 */     GIR_EraseRootFromParent_Done,
     /*  116068 */   // Label 1942: @116068
     /*  116068 */   GIM_Reject,
     /*  116069 */ // Label 1940: @116069
     /*  116069 */ GIM_Reject,
     /*  116070 */ // Label 1872: @116070
     /*  116070 */ GIM_Reject,
     /*  116071 */ // Label 6: @116071
     /*  116071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1967*/ GIMT_Encode4(118804),
     /*  116082 */ /*GILLT_s32*//*Label 1943*/ GIMT_Encode4(116206),
     /*  116086 */ /*GILLT_s64*//*Label 1944*/ GIMT_Encode4(116240), GIMT_Encode4(0),
     /*  116094 */ /*GILLT_nxv1s8*//*Label 1945*/ GIMT_Encode4(116274),
     /*  116098 */ /*GILLT_nxv1s16*//*Label 1946*/ GIMT_Encode4(116389),
     /*  116102 */ /*GILLT_nxv1s32*//*Label 1947*/ GIMT_Encode4(116504),
     /*  116106 */ /*GILLT_nxv1s64*//*Label 1948*/ GIMT_Encode4(116619), GIMT_Encode4(0),
     /*  116114 */ /*GILLT_nxv2s8*//*Label 1949*/ GIMT_Encode4(116734),
     /*  116118 */ /*GILLT_nxv2s16*//*Label 1950*/ GIMT_Encode4(116849),
     /*  116122 */ /*GILLT_nxv2s32*//*Label 1951*/ GIMT_Encode4(116964),
     /*  116126 */ /*GILLT_nxv2s64*//*Label 1952*/ GIMT_Encode4(117079), GIMT_Encode4(0),
     /*  116134 */ /*GILLT_nxv4s8*//*Label 1953*/ GIMT_Encode4(117194),
     /*  116138 */ /*GILLT_nxv4s16*//*Label 1954*/ GIMT_Encode4(117309),
     /*  116142 */ /*GILLT_nxv4s32*//*Label 1955*/ GIMT_Encode4(117424),
     /*  116146 */ /*GILLT_nxv4s64*//*Label 1956*/ GIMT_Encode4(117539), GIMT_Encode4(0),
     /*  116154 */ /*GILLT_nxv8s8*//*Label 1957*/ GIMT_Encode4(117654),
     /*  116158 */ /*GILLT_nxv8s16*//*Label 1958*/ GIMT_Encode4(117769),
     /*  116162 */ /*GILLT_nxv8s32*//*Label 1959*/ GIMT_Encode4(117884),
     /*  116166 */ /*GILLT_nxv8s64*//*Label 1960*/ GIMT_Encode4(117999), GIMT_Encode4(0),
     /*  116174 */ /*GILLT_nxv16s8*//*Label 1961*/ GIMT_Encode4(118114),
     /*  116178 */ /*GILLT_nxv16s16*//*Label 1962*/ GIMT_Encode4(118229),
     /*  116182 */ /*GILLT_nxv16s32*//*Label 1963*/ GIMT_Encode4(118344), GIMT_Encode4(0),
     /*  116190 */ /*GILLT_nxv32s8*//*Label 1964*/ GIMT_Encode4(118459),
     /*  116194 */ /*GILLT_nxv32s16*//*Label 1965*/ GIMT_Encode4(118574), GIMT_Encode4(0),
     /*  116202 */ /*GILLT_nxv64s8*//*Label 1966*/ GIMT_Encode4(118689),
     /*  116206 */ // Label 1943: @116206
     /*  116206 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(116239), // Rule ID 316 //
     /*  116211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  116214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  116217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  116220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116232 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  116232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  116237 */   GIR_RootConstrainSelectedInstOperands,
     /*  116238 */   // GIR_Coverage, 316,
     /*  116238 */   GIR_Done,
     /*  116239 */ // Label 1968: @116239
     /*  116239 */ GIM_Reject,
     /*  116240 */ // Label 1944: @116240
     /*  116240 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116273), // Rule ID 315 //
     /*  116245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  116248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  116251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  116254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116266 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  116271 */   GIR_RootConstrainSelectedInstOperands,
     /*  116272 */   // GIR_Coverage, 315,
     /*  116272 */   GIR_Done,
     /*  116273 */ // Label 1969: @116273
     /*  116273 */ GIM_Reject,
     /*  116274 */ // Label 1945: @116274
     /*  116274 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116388),
     /*  116279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  116282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  116285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116297 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116342), // Rule ID 51300 //
     /*  116302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116305 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  116308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  116322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116340 */     GIR_RootConstrainSelectedInstOperands,
     /*  116341 */     // GIR_Coverage, 51300,
     /*  116341 */     GIR_EraseRootFromParent_Done,
     /*  116342 */   // Label 1971: @116342
     /*  116342 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116387), // Rule ID 51301 //
     /*  116347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116350 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  116353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  116367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116385 */     GIR_RootConstrainSelectedInstOperands,
     /*  116386 */     // GIR_Coverage, 51301,
     /*  116386 */     GIR_EraseRootFromParent_Done,
     /*  116387 */   // Label 1972: @116387
     /*  116387 */   GIM_Reject,
     /*  116388 */ // Label 1970: @116388
     /*  116388 */ GIM_Reject,
     /*  116389 */ // Label 1946: @116389
     /*  116389 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116503),
     /*  116394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  116397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  116400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116412 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116457), // Rule ID 51312 //
     /*  116417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116420 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116455 */     GIR_RootConstrainSelectedInstOperands,
     /*  116456 */     // GIR_Coverage, 51312,
     /*  116456 */     GIR_EraseRootFromParent_Done,
     /*  116457 */   // Label 1974: @116457
     /*  116457 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116502), // Rule ID 51313 //
     /*  116462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116465 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116500 */     GIR_RootConstrainSelectedInstOperands,
     /*  116501 */     // GIR_Coverage, 51313,
     /*  116501 */     GIR_EraseRootFromParent_Done,
     /*  116502 */   // Label 1975: @116502
     /*  116502 */   GIM_Reject,
     /*  116503 */ // Label 1973: @116503
     /*  116503 */ GIM_Reject,
     /*  116504 */ // Label 1947: @116504
     /*  116504 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116618),
     /*  116509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116527 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116572), // Rule ID 51320 //
     /*  116532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116535 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116570 */     GIR_RootConstrainSelectedInstOperands,
     /*  116571 */     // GIR_Coverage, 51320,
     /*  116571 */     GIR_EraseRootFromParent_Done,
     /*  116572 */   // Label 1977: @116572
     /*  116572 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116617), // Rule ID 51321 //
     /*  116577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116580 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116615 */     GIR_RootConstrainSelectedInstOperands,
     /*  116616 */     // GIR_Coverage, 51321,
     /*  116616 */     GIR_EraseRootFromParent_Done,
     /*  116617 */   // Label 1978: @116617
     /*  116617 */   GIM_Reject,
     /*  116618 */ // Label 1976: @116618
     /*  116618 */ GIM_Reject,
     /*  116619 */ // Label 1948: @116619
     /*  116619 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116733),
     /*  116624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116642 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116687), // Rule ID 51336 //
     /*  116647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116650 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116685 */     GIR_RootConstrainSelectedInstOperands,
     /*  116686 */     // GIR_Coverage, 51336,
     /*  116686 */     GIR_EraseRootFromParent_Done,
     /*  116687 */   // Label 1980: @116687
     /*  116687 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116732), // Rule ID 51337 //
     /*  116692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116695 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116730 */     GIR_RootConstrainSelectedInstOperands,
     /*  116731 */     // GIR_Coverage, 51337,
     /*  116731 */     GIR_EraseRootFromParent_Done,
     /*  116732 */   // Label 1981: @116732
     /*  116732 */   GIM_Reject,
     /*  116733 */ // Label 1979: @116733
     /*  116733 */ GIM_Reject,
     /*  116734 */ // Label 1949: @116734
     /*  116734 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116848),
     /*  116739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116757 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116802), // Rule ID 51304 //
     /*  116762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116765 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116800 */     GIR_RootConstrainSelectedInstOperands,
     /*  116801 */     // GIR_Coverage, 51304,
     /*  116801 */     GIR_EraseRootFromParent_Done,
     /*  116802 */   // Label 1983: @116802
     /*  116802 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116847), // Rule ID 51305 //
     /*  116807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116810 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116845 */     GIR_RootConstrainSelectedInstOperands,
     /*  116846 */     // GIR_Coverage, 51305,
     /*  116846 */     GIR_EraseRootFromParent_Done,
     /*  116847 */   // Label 1984: @116847
     /*  116847 */   GIM_Reject,
     /*  116848 */ // Label 1982: @116848
     /*  116848 */ GIM_Reject,
     /*  116849 */ // Label 1950: @116849
     /*  116849 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116963),
     /*  116854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116872 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116917), // Rule ID 51316 //
     /*  116877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116880 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116915 */     GIR_RootConstrainSelectedInstOperands,
     /*  116916 */     // GIR_Coverage, 51316,
     /*  116916 */     GIR_EraseRootFromParent_Done,
     /*  116917 */   // Label 1986: @116917
     /*  116917 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116962), // Rule ID 51317 //
     /*  116922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116925 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116960 */     GIR_RootConstrainSelectedInstOperands,
     /*  116961 */     // GIR_Coverage, 51317,
     /*  116961 */     GIR_EraseRootFromParent_Done,
     /*  116962 */   // Label 1987: @116962
     /*  116962 */   GIM_Reject,
     /*  116963 */ // Label 1985: @116963
     /*  116963 */ GIM_Reject,
     /*  116964 */ // Label 1951: @116964
     /*  116964 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(117078),
     /*  116969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116987 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(117032), // Rule ID 51332 //
     /*  116992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116995 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  117012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117030 */     GIR_RootConstrainSelectedInstOperands,
     /*  117031 */     // GIR_Coverage, 51332,
     /*  117031 */     GIR_EraseRootFromParent_Done,
     /*  117032 */   // Label 1989: @117032
     /*  117032 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(117077), // Rule ID 51333 //
     /*  117037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117040 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  117043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  117057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117075 */     GIR_RootConstrainSelectedInstOperands,
     /*  117076 */     // GIR_Coverage, 51333,
     /*  117076 */     GIR_EraseRootFromParent_Done,
     /*  117077 */   // Label 1990: @117077
     /*  117077 */   GIM_Reject,
     /*  117078 */ // Label 1988: @117078
     /*  117078 */ GIM_Reject,
     /*  117079 */ // Label 1952: @117079
     /*  117079 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(117193),
     /*  117084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  117087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  117090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117102 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(117147), // Rule ID 51376 //
     /*  117107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117110 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  117113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  117127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117145 */     GIR_RootConstrainSelectedInstOperands,
     /*  117146 */     // GIR_Coverage, 51376,
     /*  117146 */     GIR_EraseRootFromParent_Done,
     /*  117147 */   // Label 1992: @117147
     /*  117147 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(117192), // Rule ID 51377 //
     /*  117152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117155 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  117158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  117172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117190 */     GIR_RootConstrainSelectedInstOperands,
     /*  117191 */     // GIR_Coverage, 51377,
     /*  117191 */     GIR_EraseRootFromParent_Done,
     /*  117192 */   // Label 1993: @117192
     /*  117192 */   GIM_Reject,
     /*  117193 */ // Label 1991: @117193
     /*  117193 */ GIM_Reject,
     /*  117194 */ // Label 1953: @117194
     /*  117194 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117308),
     /*  117199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  117202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  117205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117217 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117262), // Rule ID 51308 //
     /*  117222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117225 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  117228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  117242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117260 */     GIR_RootConstrainSelectedInstOperands,
     /*  117261 */     // GIR_Coverage, 51308,
     /*  117261 */     GIR_EraseRootFromParent_Done,
     /*  117262 */   // Label 1995: @117262
     /*  117262 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117307), // Rule ID 51309 //
     /*  117267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117270 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  117273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  117287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117305 */     GIR_RootConstrainSelectedInstOperands,
     /*  117306 */     // GIR_Coverage, 51309,
     /*  117306 */     GIR_EraseRootFromParent_Done,
     /*  117307 */   // Label 1996: @117307
     /*  117307 */   GIM_Reject,
     /*  117308 */ // Label 1994: @117308
     /*  117308 */ GIM_Reject,
     /*  117309 */ // Label 1954: @117309
     /*  117309 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117423),
     /*  117314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  117317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  117320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117332 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117377), // Rule ID 51328 //
     /*  117337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117340 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  117343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  117357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117375 */     GIR_RootConstrainSelectedInstOperands,
     /*  117376 */     // GIR_Coverage, 51328,
     /*  117376 */     GIR_EraseRootFromParent_Done,
     /*  117377 */   // Label 1998: @117377
     /*  117377 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117422), // Rule ID 51329 //
     /*  117382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117385 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  117388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  117402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117420 */     GIR_RootConstrainSelectedInstOperands,
     /*  117421 */     // GIR_Coverage, 51329,
     /*  117421 */     GIR_EraseRootFromParent_Done,
     /*  117422 */   // Label 1999: @117422
     /*  117422 */   GIM_Reject,
     /*  117423 */ // Label 1997: @117423
     /*  117423 */ GIM_Reject,
     /*  117424 */ // Label 1955: @117424
     /*  117424 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117538),
     /*  117429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  117432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  117435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117447 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117492), // Rule ID 51364 //
     /*  117452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117455 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117490 */     GIR_RootConstrainSelectedInstOperands,
     /*  117491 */     // GIR_Coverage, 51364,
     /*  117491 */     GIR_EraseRootFromParent_Done,
     /*  117492 */   // Label 2001: @117492
     /*  117492 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117537), // Rule ID 51365 //
     /*  117497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117500 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117535 */     GIR_RootConstrainSelectedInstOperands,
     /*  117536 */     // GIR_Coverage, 51365,
     /*  117536 */     GIR_EraseRootFromParent_Done,
     /*  117537 */   // Label 2002: @117537
     /*  117537 */   GIM_Reject,
     /*  117538 */ // Label 2000: @117538
     /*  117538 */ GIM_Reject,
     /*  117539 */ // Label 1956: @117539
     /*  117539 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117653),
     /*  117544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117562 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117607), // Rule ID 51380 //
     /*  117567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117570 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117605 */     GIR_RootConstrainSelectedInstOperands,
     /*  117606 */     // GIR_Coverage, 51380,
     /*  117606 */     GIR_EraseRootFromParent_Done,
     /*  117607 */   // Label 2004: @117607
     /*  117607 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117652), // Rule ID 51381 //
     /*  117612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117615 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117650 */     GIR_RootConstrainSelectedInstOperands,
     /*  117651 */     // GIR_Coverage, 51381,
     /*  117651 */     GIR_EraseRootFromParent_Done,
     /*  117652 */   // Label 2005: @117652
     /*  117652 */   GIM_Reject,
     /*  117653 */ // Label 2003: @117653
     /*  117653 */ GIM_Reject,
     /*  117654 */ // Label 1957: @117654
     /*  117654 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117768),
     /*  117659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117677 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117722), // Rule ID 51324 //
     /*  117682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117685 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117720 */     GIR_RootConstrainSelectedInstOperands,
     /*  117721 */     // GIR_Coverage, 51324,
     /*  117721 */     GIR_EraseRootFromParent_Done,
     /*  117722 */   // Label 2007: @117722
     /*  117722 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117767), // Rule ID 51325 //
     /*  117727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117730 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117765 */     GIR_RootConstrainSelectedInstOperands,
     /*  117766 */     // GIR_Coverage, 51325,
     /*  117766 */     GIR_EraseRootFromParent_Done,
     /*  117767 */   // Label 2008: @117767
     /*  117767 */   GIM_Reject,
     /*  117768 */ // Label 2006: @117768
     /*  117768 */ GIM_Reject,
     /*  117769 */ // Label 1958: @117769
     /*  117769 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117883),
     /*  117774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117792 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117837), // Rule ID 51352 //
     /*  117797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117800 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117835 */     GIR_RootConstrainSelectedInstOperands,
     /*  117836 */     // GIR_Coverage, 51352,
     /*  117836 */     GIR_EraseRootFromParent_Done,
     /*  117837 */   // Label 2010: @117837
     /*  117837 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117882), // Rule ID 51353 //
     /*  117842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117845 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117880 */     GIR_RootConstrainSelectedInstOperands,
     /*  117881 */     // GIR_Coverage, 51353,
     /*  117881 */     GIR_EraseRootFromParent_Done,
     /*  117882 */   // Label 2011: @117882
     /*  117882 */   GIM_Reject,
     /*  117883 */ // Label 2009: @117883
     /*  117883 */ GIM_Reject,
     /*  117884 */ // Label 1959: @117884
     /*  117884 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(117998),
     /*  117889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117907 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117952), // Rule ID 51368 //
     /*  117912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117915 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117950 */     GIR_RootConstrainSelectedInstOperands,
     /*  117951 */     // GIR_Coverage, 51368,
     /*  117951 */     GIR_EraseRootFromParent_Done,
     /*  117952 */   // Label 2013: @117952
     /*  117952 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117997), // Rule ID 51369 //
     /*  117957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117960 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117995 */     GIR_RootConstrainSelectedInstOperands,
     /*  117996 */     // GIR_Coverage, 51369,
     /*  117996 */     GIR_EraseRootFromParent_Done,
     /*  117997 */   // Label 2014: @117997
     /*  117997 */   GIM_Reject,
     /*  117998 */ // Label 2012: @117998
     /*  117998 */ GIM_Reject,
     /*  117999 */ // Label 1960: @117999
     /*  117999 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(118113),
     /*  118004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  118007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  118010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118022 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(118067), // Rule ID 51384 //
     /*  118027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  118030 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  118030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  118033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  118047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  118062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118065 */     GIR_RootConstrainSelectedInstOperands,
     /*  118066 */     // GIR_Coverage, 51384,
     /*  118066 */     GIR_EraseRootFromParent_Done,
     /*  118067 */   // Label 2016: @118067
     /*  118067 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(118112), // Rule ID 51385 //
     /*  118072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  118075 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  118075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  118078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  118092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  118107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118110 */     GIR_RootConstrainSelectedInstOperands,
     /*  118111 */     // GIR_Coverage, 51385,
     /*  118111 */     GIR_EraseRootFromParent_Done,
     /*  118112 */   // Label 2017: @118112
     /*  118112 */   GIM_Reject,
     /*  118113 */ // Label 2015: @118113
     /*  118113 */ GIM_Reject,
     /*  118114 */ // Label 1961: @118114
     /*  118114 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(118228),
     /*  118119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  118122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  118125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118137 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(118182), // Rule ID 51340 //
     /*  118142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118145 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  118148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  118162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118180 */     GIR_RootConstrainSelectedInstOperands,
     /*  118181 */     // GIR_Coverage, 51340,
     /*  118181 */     GIR_EraseRootFromParent_Done,
     /*  118182 */   // Label 2019: @118182
     /*  118182 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(118227), // Rule ID 51341 //
     /*  118187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118190 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  118193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  118207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118225 */     GIR_RootConstrainSelectedInstOperands,
     /*  118226 */     // GIR_Coverage, 51341,
     /*  118226 */     GIR_EraseRootFromParent_Done,
     /*  118227 */   // Label 2020: @118227
     /*  118227 */   GIM_Reject,
     /*  118228 */ // Label 2018: @118228
     /*  118228 */ GIM_Reject,
     /*  118229 */ // Label 1962: @118229
     /*  118229 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118343),
     /*  118234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  118237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  118240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118252 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118297), // Rule ID 51356 //
     /*  118257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118260 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  118263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  118277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118295 */     GIR_RootConstrainSelectedInstOperands,
     /*  118296 */     // GIR_Coverage, 51356,
     /*  118296 */     GIR_EraseRootFromParent_Done,
     /*  118297 */   // Label 2022: @118297
     /*  118297 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118342), // Rule ID 51357 //
     /*  118302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118305 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  118308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  118322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118340 */     GIR_RootConstrainSelectedInstOperands,
     /*  118341 */     // GIR_Coverage, 51357,
     /*  118341 */     GIR_EraseRootFromParent_Done,
     /*  118342 */   // Label 2023: @118342
     /*  118342 */   GIM_Reject,
     /*  118343 */ // Label 2021: @118343
     /*  118343 */ GIM_Reject,
     /*  118344 */ // Label 1963: @118344
     /*  118344 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118458),
     /*  118349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  118352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  118355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118367 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118412), // Rule ID 51372 //
     /*  118372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118375 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  118375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  118378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  118392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118410 */     GIR_RootConstrainSelectedInstOperands,
     /*  118411 */     // GIR_Coverage, 51372,
     /*  118411 */     GIR_EraseRootFromParent_Done,
     /*  118412 */   // Label 2025: @118412
     /*  118412 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118457), // Rule ID 51373 //
     /*  118417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118420 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  118420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  118423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  118437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118455 */     GIR_RootConstrainSelectedInstOperands,
     /*  118456 */     // GIR_Coverage, 51373,
     /*  118456 */     GIR_EraseRootFromParent_Done,
     /*  118457 */   // Label 2026: @118457
     /*  118457 */   GIM_Reject,
     /*  118458 */ // Label 2024: @118458
     /*  118458 */ GIM_Reject,
     /*  118459 */ // Label 1964: @118459
     /*  118459 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118573),
     /*  118464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118482 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118527), // Rule ID 51344 //
     /*  118487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118490 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118525 */     GIR_RootConstrainSelectedInstOperands,
     /*  118526 */     // GIR_Coverage, 51344,
     /*  118526 */     GIR_EraseRootFromParent_Done,
     /*  118527 */   // Label 2028: @118527
     /*  118527 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118572), // Rule ID 51345 //
     /*  118532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118535 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118570 */     GIR_RootConstrainSelectedInstOperands,
     /*  118571 */     // GIR_Coverage, 51345,
     /*  118571 */     GIR_EraseRootFromParent_Done,
     /*  118572 */   // Label 2029: @118572
     /*  118572 */   GIM_Reject,
     /*  118573 */ // Label 2027: @118573
     /*  118573 */ GIM_Reject,
     /*  118574 */ // Label 1965: @118574
     /*  118574 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(118688),
     /*  118579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118597 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(118642), // Rule ID 51360 //
     /*  118602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118605 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118640 */     GIR_RootConstrainSelectedInstOperands,
     /*  118641 */     // GIR_Coverage, 51360,
     /*  118641 */     GIR_EraseRootFromParent_Done,
     /*  118642 */   // Label 2031: @118642
     /*  118642 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(118687), // Rule ID 51361 //
     /*  118647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118650 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118685 */     GIR_RootConstrainSelectedInstOperands,
     /*  118686 */     // GIR_Coverage, 51361,
     /*  118686 */     GIR_EraseRootFromParent_Done,
     /*  118687 */   // Label 2032: @118687
     /*  118687 */   GIM_Reject,
     /*  118688 */ // Label 2030: @118688
     /*  118688 */ GIM_Reject,
     /*  118689 */ // Label 1966: @118689
     /*  118689 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118803),
     /*  118694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118712 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118757), // Rule ID 51348 //
     /*  118717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118720 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118755 */     GIR_RootConstrainSelectedInstOperands,
     /*  118756 */     // GIR_Coverage, 51348,
     /*  118756 */     GIR_EraseRootFromParent_Done,
     /*  118757 */   // Label 2034: @118757
     /*  118757 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118802), // Rule ID 51349 //
     /*  118762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118765 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118800 */     GIR_RootConstrainSelectedInstOperands,
     /*  118801 */     // GIR_Coverage, 51349,
     /*  118801 */     GIR_EraseRootFromParent_Done,
     /*  118802 */   // Label 2035: @118802
     /*  118802 */   GIM_Reject,
     /*  118803 */ // Label 2033: @118803
     /*  118803 */ GIM_Reject,
     /*  118804 */ // Label 1967: @118804
     /*  118804 */ GIM_Reject,
     /*  118805 */ // Label 7: @118805
     /*  118805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2067*/ GIMT_Encode4(128762),
     /*  118816 */ /*GILLT_s32*//*Label 2036*/ GIMT_Encode4(118940),
     /*  118820 */ /*GILLT_s64*//*Label 2037*/ GIMT_Encode4(120634),
     /*  118824 */ /*GILLT_nxv1s1*//*Label 2038*/ GIMT_Encode4(121955),
     /*  118828 */ /*GILLT_nxv1s8*//*Label 2039*/ GIMT_Encode4(122566),
     /*  118832 */ /*GILLT_nxv1s16*//*Label 2040*/ GIMT_Encode4(122681),
     /*  118836 */ /*GILLT_nxv1s32*//*Label 2041*/ GIMT_Encode4(122796),
     /*  118840 */ /*GILLT_nxv1s64*//*Label 2042*/ GIMT_Encode4(122911),
     /*  118844 */ /*GILLT_nxv2s1*//*Label 2043*/ GIMT_Encode4(123026),
     /*  118848 */ /*GILLT_nxv2s8*//*Label 2044*/ GIMT_Encode4(123637),
     /*  118852 */ /*GILLT_nxv2s16*//*Label 2045*/ GIMT_Encode4(123752),
     /*  118856 */ /*GILLT_nxv2s32*//*Label 2046*/ GIMT_Encode4(123867),
     /*  118860 */ /*GILLT_nxv2s64*//*Label 2047*/ GIMT_Encode4(123982),
     /*  118864 */ /*GILLT_nxv4s1*//*Label 2048*/ GIMT_Encode4(124097),
     /*  118868 */ /*GILLT_nxv4s8*//*Label 2049*/ GIMT_Encode4(124708),
     /*  118872 */ /*GILLT_nxv4s16*//*Label 2050*/ GIMT_Encode4(124823),
     /*  118876 */ /*GILLT_nxv4s32*//*Label 2051*/ GIMT_Encode4(124938),
     /*  118880 */ /*GILLT_nxv4s64*//*Label 2052*/ GIMT_Encode4(125053),
     /*  118884 */ /*GILLT_nxv8s1*//*Label 2053*/ GIMT_Encode4(125168),
     /*  118888 */ /*GILLT_nxv8s8*//*Label 2054*/ GIMT_Encode4(125779),
     /*  118892 */ /*GILLT_nxv8s16*//*Label 2055*/ GIMT_Encode4(125894),
     /*  118896 */ /*GILLT_nxv8s32*//*Label 2056*/ GIMT_Encode4(126009),
     /*  118900 */ /*GILLT_nxv8s64*//*Label 2057*/ GIMT_Encode4(126124),
     /*  118904 */ /*GILLT_nxv16s1*//*Label 2058*/ GIMT_Encode4(126239),
     /*  118908 */ /*GILLT_nxv16s8*//*Label 2059*/ GIMT_Encode4(126850),
     /*  118912 */ /*GILLT_nxv16s16*//*Label 2060*/ GIMT_Encode4(126965),
     /*  118916 */ /*GILLT_nxv16s32*//*Label 2061*/ GIMT_Encode4(127080),
     /*  118920 */ /*GILLT_nxv32s1*//*Label 2062*/ GIMT_Encode4(127195),
     /*  118924 */ /*GILLT_nxv32s8*//*Label 2063*/ GIMT_Encode4(127806),
     /*  118928 */ /*GILLT_nxv32s16*//*Label 2064*/ GIMT_Encode4(127921),
     /*  118932 */ /*GILLT_nxv64s1*//*Label 2065*/ GIMT_Encode4(128036),
     /*  118936 */ /*GILLT_nxv64s8*//*Label 2066*/ GIMT_Encode4(128647),
     /*  118940 */ // Label 2036: @118940
     /*  118940 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120633),
     /*  118945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118951 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119040), // Rule ID 65566 //
     /*  118956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119000 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119004 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119024 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119038 */     GIR_RootConstrainSelectedInstOperands,
     /*  119039 */     // GIR_Coverage, 65566,
     /*  119039 */     GIR_EraseRootFromParent_Done,
     /*  119040 */   // Label 2069: @119040
     /*  119040 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119129), // Rule ID 2546 //
     /*  119045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  119048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119093 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119113 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119127 */     GIR_RootConstrainSelectedInstOperands,
     /*  119128 */     // GIR_Coverage, 2546,
     /*  119128 */     GIR_EraseRootFromParent_Done,
     /*  119129 */   // Label 2070: @119129
     /*  119129 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119208), // Rule ID 2473 //
     /*  119134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119173 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119194 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119206 */     GIR_RootConstrainSelectedInstOperands,
     /*  119207 */     // GIR_Coverage, 2473,
     /*  119207 */     GIR_EraseRootFromParent_Done,
     /*  119208 */   // Label 2071: @119208
     /*  119208 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119287), // Rule ID 65554 //
     /*  119213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  119256 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119273 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119285 */     GIR_RootConstrainSelectedInstOperands,
     /*  119286 */     // GIR_Coverage, 65554,
     /*  119286 */     GIR_EraseRootFromParent_Done,
     /*  119287 */   // Label 2072: @119287
     /*  119287 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119352), // Rule ID 2493 //
     /*  119292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  119332 */     // MIs[2] Operand 1
     /*  119332 */     // No operand predicates
     /*  119332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119338 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  119338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  119341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  119350 */     GIR_RootConstrainSelectedInstOperands,
     /*  119351 */     // GIR_Coverage, 2493,
     /*  119351 */     GIR_EraseRootFromParent_Done,
     /*  119352 */   // Label 2073: @119352
     /*  119352 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119417), // Rule ID 62577 //
     /*  119357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  119360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  119397 */     // MIs[2] Operand 1
     /*  119397 */     // No operand predicates
     /*  119397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119403 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  119403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  119406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  119415 */     GIR_RootConstrainSelectedInstOperands,
     /*  119416 */     // GIR_Coverage, 62577,
     /*  119416 */     GIR_EraseRootFromParent_Done,
     /*  119417 */   // Label 2074: @119417
     /*  119417 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119479), // Rule ID 2481 //
     /*  119422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  119437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  119454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119463 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119477 */     GIR_RootConstrainSelectedInstOperands,
     /*  119478 */     // GIR_Coverage, 2481,
     /*  119478 */     GIR_EraseRootFromParent_Done,
     /*  119479 */   // Label 2075: @119479
     /*  119479 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119535), // Rule ID 2475 //
     /*  119484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119522 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119533 */     GIR_RootConstrainSelectedInstOperands,
     /*  119534 */     // GIR_Coverage, 2475,
     /*  119534 */     GIR_EraseRootFromParent_Done,
     /*  119535 */   // Label 2076: @119535
     /*  119535 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119591), // Rule ID 65540 //
     /*  119540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119568 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119578 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119589 */     GIR_RootConstrainSelectedInstOperands,
     /*  119590 */     // GIR_Coverage, 65540,
     /*  119590 */     GIR_EraseRootFromParent_Done,
     /*  119591 */   // Label 2077: @119591
     /*  119591 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119647), // Rule ID 65556 //
     /*  119596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119623 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119634 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119645 */     GIR_RootConstrainSelectedInstOperands,
     /*  119646 */     // GIR_Coverage, 65556,
     /*  119646 */     GIR_EraseRootFromParent_Done,
     /*  119647 */   // Label 2078: @119647
     /*  119647 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119703), // Rule ID 2447 //
     /*  119652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119690 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119701 */     GIR_RootConstrainSelectedInstOperands,
     /*  119702 */     // GIR_Coverage, 2447,
     /*  119702 */     GIR_EraseRootFromParent_Done,
     /*  119703 */   // Label 2079: @119703
     /*  119703 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119739), // Rule ID 64478 //
     /*  119708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119719 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119730 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119737 */     GIR_RootConstrainSelectedInstOperands,
     /*  119738 */     // GIR_Coverage, 64478,
     /*  119738 */     GIR_EraseRootFromParent_Done,
     /*  119739 */   // Label 2080: @119739
     /*  119739 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119775), // Rule ID 64480 //
     /*  119744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119755 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119766 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119773 */     GIR_RootConstrainSelectedInstOperands,
     /*  119774 */     // GIR_Coverage, 64480,
     /*  119774 */     GIR_EraseRootFromParent_Done,
     /*  119775 */   // Label 2081: @119775
     /*  119775 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119811), // Rule ID 2557 //
     /*  119780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119791 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119802 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119809 */     GIR_RootConstrainSelectedInstOperands,
     /*  119810 */     // GIR_Coverage, 2557,
     /*  119810 */     GIR_EraseRootFromParent_Done,
     /*  119811 */   // Label 2082: @119811
     /*  119811 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119847), // Rule ID 2558 //
     /*  119816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119827 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119838 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119845 */     GIR_RootConstrainSelectedInstOperands,
     /*  119846 */     // GIR_Coverage, 2558,
     /*  119846 */     GIR_EraseRootFromParent_Done,
     /*  119847 */   // Label 2083: @119847
     /*  119847 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119889), // Rule ID 2560 //
     /*  119852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119863 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119874 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119887 */     GIR_RootConstrainSelectedInstOperands,
     /*  119888 */     // GIR_Coverage, 2560,
     /*  119888 */     GIR_EraseRootFromParent_Done,
     /*  119889 */   // Label 2084: @119889
     /*  119889 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(119931), // Rule ID 2561 //
     /*  119894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119905 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119916 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119929 */     GIR_RootConstrainSelectedInstOperands,
     /*  119930 */     // GIR_Coverage, 2561,
     /*  119930 */     GIR_EraseRootFromParent_Done,
     /*  119931 */   // Label 2085: @119931
     /*  119931 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119966), // Rule ID 64623 //
     /*  119936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119951 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  119951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119964 */     GIR_RootConstrainSelectedInstOperands,
     /*  119965 */     // GIR_Coverage, 64623,
     /*  119965 */     GIR_EraseRootFromParent_Done,
     /*  119966 */   // Label 2086: @119966
     /*  119966 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(120001), // Rule ID 64624 //
     /*  119971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119986 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  119986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119999 */     GIR_RootConstrainSelectedInstOperands,
     /*  120000 */     // GIR_Coverage, 64624,
     /*  120000 */     GIR_EraseRootFromParent_Done,
     /*  120001 */   // Label 2087: @120001
     /*  120001 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(120036), // Rule ID 64625 //
     /*  120006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  120021 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i64] }, 0:{ *:[i64] })
     /*  120021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  120031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120034 */     GIR_RootConstrainSelectedInstOperands,
     /*  120035 */     // GIR_Coverage, 64625,
     /*  120035 */     GIR_EraseRootFromParent_Done,
     /*  120036 */   // Label 2088: @120036
     /*  120036 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(120071), // Rule ID 64626 //
     /*  120041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  120056 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i32] }, 0:{ *:[i32] })
     /*  120056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  120066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120069 */     GIR_RootConstrainSelectedInstOperands,
     /*  120070 */     // GIR_Coverage, 64626,
     /*  120070 */     GIR_EraseRootFromParent_Done,
     /*  120071 */   // Label 2089: @120071
     /*  120071 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(120113), // Rule ID 64627 //
     /*  120076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120087 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120098 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i64] }, 0:{ *:[i64] })
     /*  120098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  120108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120111 */     GIR_RootConstrainSelectedInstOperands,
     /*  120112 */     // GIR_Coverage, 64627,
     /*  120112 */     GIR_EraseRootFromParent_Done,
     /*  120113 */   // Label 2090: @120113
     /*  120113 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(120155), // Rule ID 64628 //
     /*  120118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120129 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120140 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i32] }, 0:{ *:[i32] })
     /*  120140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  120150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120153 */     GIR_RootConstrainSelectedInstOperands,
     /*  120154 */     // GIR_Coverage, 64628,
     /*  120154 */     GIR_EraseRootFromParent_Done,
     /*  120155 */   // Label 2091: @120155
     /*  120155 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(120197), // Rule ID 64629 //
     /*  120160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120171 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  120182 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i64] }, 0:{ *:[i64] })
     /*  120182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  120192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120195 */     GIR_RootConstrainSelectedInstOperands,
     /*  120196 */     // GIR_Coverage, 64629,
     /*  120196 */     GIR_EraseRootFromParent_Done,
     /*  120197 */   // Label 2092: @120197
     /*  120197 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120239), // Rule ID 64630 //
     /*  120202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120213 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  120224 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i32] }, 0:{ *:[i32] })
     /*  120224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  120234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120237 */     GIR_RootConstrainSelectedInstOperands,
     /*  120238 */     // GIR_Coverage, 64630,
     /*  120238 */     GIR_EraseRootFromParent_Done,
     /*  120239 */   // Label 2093: @120239
     /*  120239 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120281), // Rule ID 64631 //
     /*  120244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120255 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  120266 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i64] }, 0:{ *:[i64] })
     /*  120266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  120276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120279 */     GIR_RootConstrainSelectedInstOperands,
     /*  120280 */     // GIR_Coverage, 64631,
     /*  120280 */     GIR_EraseRootFromParent_Done,
     /*  120281 */   // Label 2094: @120281
     /*  120281 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120323), // Rule ID 64632 //
     /*  120286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120297 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  120308 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i32] }, 0:{ *:[i32] })
     /*  120308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  120318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120321 */     GIR_RootConstrainSelectedInstOperands,
     /*  120322 */     // GIR_Coverage, 64632,
     /*  120322 */     GIR_EraseRootFromParent_Done,
     /*  120323 */   // Label 2095: @120323
     /*  120323 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120365), // Rule ID 64633 //
     /*  120328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  120331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120339 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  120350 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i64] }, 0:{ *:[i64] })
     /*  120350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  120360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120363 */     GIR_RootConstrainSelectedInstOperands,
     /*  120364 */     // GIR_Coverage, 64633,
     /*  120364 */     GIR_EraseRootFromParent_Done,
     /*  120365 */   // Label 2096: @120365
     /*  120365 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(120407), // Rule ID 64634 //
     /*  120370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  120373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120381 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  120392 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i32] }, 0:{ *:[i32] })
     /*  120392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  120395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  120402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120405 */     GIR_RootConstrainSelectedInstOperands,
     /*  120406 */     // GIR_Coverage, 64634,
     /*  120406 */     GIR_EraseRootFromParent_Done,
     /*  120407 */   // Label 2097: @120407
     /*  120407 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120449), // Rule ID 91 //
     /*  120412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  120435 */     // MIs[1] Operand 1
     /*  120435 */     // No operand predicates
     /*  120435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120437 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  120437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  120440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120447 */     GIR_RootConstrainSelectedInstOperands,
     /*  120448 */     // GIR_Coverage, 91,
     /*  120448 */     GIR_EraseRootFromParent_Done,
     /*  120449 */   // Label 2098: @120449
     /*  120449 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120521), // Rule ID 109 //
     /*  120454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120473 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120477 */     // MIs[1] Operand 1
     /*  120477 */     // No operand predicates
     /*  120477 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /*  120481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120483 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  120483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  120486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120499 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120514 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120519 */     GIR_RootConstrainSelectedInstOperands,
     /*  120520 */     // GIR_Coverage, 109,
     /*  120520 */     GIR_EraseRootFromParent_Done,
     /*  120521 */   // Label 2099: @120521
     /*  120521 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120563), // Rule ID 64538 //
     /*  120526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  120549 */     // MIs[1] Operand 1
     /*  120549 */     // No operand predicates
     /*  120549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120551 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  120551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  120554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  120556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120561 */     GIR_RootConstrainSelectedInstOperands,
     /*  120562 */     // GIR_Coverage, 64538,
     /*  120562 */     GIR_EraseRootFromParent_Done,
     /*  120563 */   // Label 2100: @120563
     /*  120563 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120605), // Rule ID 64542 //
     /*  120568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  120591 */     // MIs[1] Operand 1
     /*  120591 */     // No operand predicates
     /*  120591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120593 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  120593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  120596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120603 */     GIR_RootConstrainSelectedInstOperands,
     /*  120604 */     // GIR_Coverage, 64542,
     /*  120604 */     GIR_EraseRootFromParent_Done,
     /*  120605 */   // Label 2101: @120605
     /*  120605 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120632), // Rule ID 89 //
     /*  120610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120625 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  120625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  120630 */     GIR_RootConstrainSelectedInstOperands,
     /*  120631 */     // GIR_Coverage, 89,
     /*  120631 */     GIR_Done,
     /*  120632 */   // Label 2102: @120632
     /*  120632 */   GIM_Reject,
     /*  120633 */ // Label 2068: @120633
     /*  120633 */ GIM_Reject,
     /*  120634 */ // Label 2037: @120634
     /*  120634 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(121954),
     /*  120639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  120642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  120645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120649 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120734), // Rule ID 65565 //
     /*  120654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120694 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120698 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120718 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120732 */     GIR_RootConstrainSelectedInstOperands,
     /*  120733 */     // GIR_Coverage, 65565,
     /*  120733 */     GIR_EraseRootFromParent_Done,
     /*  120734 */   // Label 2104: @120734
     /*  120734 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120819), // Rule ID 2545 //
     /*  120739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120783 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120803 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120817 */     GIR_RootConstrainSelectedInstOperands,
     /*  120818 */     // GIR_Coverage, 2545,
     /*  120818 */     GIR_EraseRootFromParent_Done,
     /*  120819 */   // Label 2105: @120819
     /*  120819 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120894), // Rule ID 2472 //
     /*  120824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120859 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120880 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120892 */     GIR_RootConstrainSelectedInstOperands,
     /*  120893 */     // GIR_Coverage, 2472,
     /*  120893 */     GIR_EraseRootFromParent_Done,
     /*  120894 */   // Label 2106: @120894
     /*  120894 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120969), // Rule ID 65553 //
     /*  120899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120955 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120967 */     GIR_RootConstrainSelectedInstOperands,
     /*  120968 */     // GIR_Coverage, 65553,
     /*  120968 */     GIR_EraseRootFromParent_Done,
     /*  120969 */   // Label 2107: @120969
     /*  120969 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(121030), // Rule ID 2492 //
     /*  120974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  121010 */     // MIs[2] Operand 1
     /*  121010 */     // No operand predicates
     /*  121010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121016 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  121016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  121019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  121028 */     GIR_RootConstrainSelectedInstOperands,
     /*  121029 */     // GIR_Coverage, 2492,
     /*  121029 */     GIR_EraseRootFromParent_Done,
     /*  121030 */   // Label 2108: @121030
     /*  121030 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(121091), // Rule ID 62576 //
     /*  121035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  121038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  121046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  121071 */     // MIs[2] Operand 1
     /*  121071 */     // No operand predicates
     /*  121071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121077 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  121077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  121080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  121089 */     GIR_RootConstrainSelectedInstOperands,
     /*  121090 */     // GIR_Coverage, 62576,
     /*  121090 */     GIR_EraseRootFromParent_Done,
     /*  121091 */   // Label 2109: @121091
     /*  121091 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(121149), // Rule ID 2480 //
     /*  121096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  121107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  121124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  121133 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  121136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  121142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  121147 */     GIR_RootConstrainSelectedInstOperands,
     /*  121148 */     // GIR_Coverage, 2480,
     /*  121148 */     GIR_EraseRootFromParent_Done,
     /*  121149 */   // Label 2110: @121149
     /*  121149 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121201), // Rule ID 2474 //
     /*  121154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  121165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121173 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  121177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121188 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  121191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121199 */     GIR_RootConstrainSelectedInstOperands,
     /*  121200 */     // GIR_Coverage, 2474,
     /*  121200 */     GIR_EraseRootFromParent_Done,
     /*  121201 */   // Label 2111: @121201
     /*  121201 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121253), // Rule ID 65539 //
     /*  121206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  121209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  121234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121240 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  121243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121251 */     GIR_RootConstrainSelectedInstOperands,
     /*  121252 */     // GIR_Coverage, 65539,
     /*  121252 */     GIR_EraseRootFromParent_Done,
     /*  121253 */   // Label 2112: @121253
     /*  121253 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121305), // Rule ID 65555 //
     /*  121258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  121261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  121273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121281 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  121285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121292 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  121295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121303 */     GIR_RootConstrainSelectedInstOperands,
     /*  121304 */     // GIR_Coverage, 65555,
     /*  121304 */     GIR_EraseRootFromParent_Done,
     /*  121305 */   // Label 2113: @121305
     /*  121305 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121357), // Rule ID 2446 //
     /*  121310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  121313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  121329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  121333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  121342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121344 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  121347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121355 */     GIR_RootConstrainSelectedInstOperands,
     /*  121356 */     // GIR_Coverage, 2446,
     /*  121356 */     GIR_EraseRootFromParent_Done,
     /*  121357 */   // Label 2114: @121357
     /*  121357 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121389), // Rule ID 64477 //
     /*  121362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  121365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121369 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121380 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  121380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  121383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121387 */     GIR_RootConstrainSelectedInstOperands,
     /*  121388 */     // GIR_Coverage, 64477,
     /*  121388 */     GIR_EraseRootFromParent_Done,
     /*  121389 */   // Label 2115: @121389
     /*  121389 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121421), // Rule ID 64479 //
     /*  121394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  121397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121401 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  121412 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  121412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  121415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121419 */     GIR_RootConstrainSelectedInstOperands,
     /*  121420 */     // GIR_Coverage, 64479,
     /*  121420 */     GIR_EraseRootFromParent_Done,
     /*  121421 */   // Label 2116: @121421
     /*  121421 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121478), // Rule ID 262 //
     /*  121426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  121429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121433 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121444 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  121444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  121463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  121476 */     GIR_RootConstrainSelectedInstOperands,
     /*  121477 */     // GIR_Coverage, 262,
     /*  121477 */     GIR_EraseRootFromParent_Done,
     /*  121478 */   // Label 2117: @121478
     /*  121478 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121510), // Rule ID 2559 //
     /*  121483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  121486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121490 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121501 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  121501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  121504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121508 */     GIR_RootConstrainSelectedInstOperands,
     /*  121509 */     // GIR_Coverage, 2559,
     /*  121509 */     GIR_EraseRootFromParent_Done,
     /*  121510 */   // Label 2118: @121510
     /*  121510 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121548), // Rule ID 2562 //
     /*  121515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  121518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121522 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121533 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  121536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121546 */     GIR_RootConstrainSelectedInstOperands,
     /*  121547 */     // GIR_Coverage, 2562,
     /*  121547 */     GIR_EraseRootFromParent_Done,
     /*  121548 */   // Label 2119: @121548
     /*  121548 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121586), // Rule ID 2605 //
     /*  121553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121560 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121571 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  121574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121584 */     GIR_RootConstrainSelectedInstOperands,
     /*  121585 */     // GIR_Coverage, 2605,
     /*  121585 */     GIR_EraseRootFromParent_Done,
     /*  121586 */   // Label 2120: @121586
     /*  121586 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121624), // Rule ID 65150 //
     /*  121591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  121594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121598 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121609 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  121612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121622 */     GIR_RootConstrainSelectedInstOperands,
     /*  121623 */     // GIR_Coverage, 65150,
     /*  121623 */     GIR_EraseRootFromParent_Done,
     /*  121624 */   // Label 2121: @121624
     /*  121624 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(121662), // Rule ID 90 //
     /*  121629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  121648 */     // MIs[1] Operand 1
     /*  121648 */     // No operand predicates
     /*  121648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121650 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  121650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  121653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  121660 */     GIR_RootConstrainSelectedInstOperands,
     /*  121661 */     // GIR_Coverage, 90,
     /*  121661 */     GIR_EraseRootFromParent_Done,
     /*  121662 */   // Label 2122: @121662
     /*  121662 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121730), // Rule ID 107 //
     /*  121667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  121686 */     // MIs[1] Operand 1
     /*  121686 */     // No operand predicates
     /*  121686 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9976),
     /*  121690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121692 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9976>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121708 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121723 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121728 */     GIR_RootConstrainSelectedInstOperands,
     /*  121729 */     // GIR_Coverage, 107,
     /*  121729 */     GIR_EraseRootFromParent_Done,
     /*  121730 */   // Label 2123: @121730
     /*  121730 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121798), // Rule ID 108 //
     /*  121735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121750 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  121754 */     // MIs[1] Operand 1
     /*  121754 */     // No operand predicates
     /*  121754 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /*  121758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121760 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121776 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121791 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121796 */     GIR_RootConstrainSelectedInstOperands,
     /*  121797 */     // GIR_Coverage, 108,
     /*  121797 */     GIR_EraseRootFromParent_Done,
     /*  121798 */   // Label 2124: @121798
     /*  121798 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121866), // Rule ID 264 //
     /*  121803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  121806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  121822 */     // MIs[1] Operand 1
     /*  121822 */     // No operand predicates
     /*  121822 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10068),
     /*  121826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121828 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10068>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  121835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121844 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121859 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121864 */     GIR_RootConstrainSelectedInstOperands,
     /*  121865 */     // GIR_Coverage, 264,
     /*  121865 */     GIR_EraseRootFromParent_Done,
     /*  121866 */   // Label 2125: @121866
     /*  121866 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121930), // Rule ID 2624 //
     /*  121871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121886 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  121890 */     // MIs[1] Operand 1
     /*  121890 */     // No operand predicates
     /*  121890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121892 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  121892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121908 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  121918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121923 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121928 */     GIR_RootConstrainSelectedInstOperands,
     /*  121929 */     // GIR_Coverage, 2624,
     /*  121929 */     GIR_EraseRootFromParent_Done,
     /*  121930 */   // Label 2126: @121930
     /*  121930 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121953), // Rule ID 88 //
     /*  121935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121946 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121951 */     GIR_RootConstrainSelectedInstOperands,
     /*  121952 */     // GIR_Coverage, 88,
     /*  121952 */     GIR_Done,
     /*  121953 */   // Label 2127: @121953
     /*  121953 */   GIM_Reject,
     /*  121954 */ // Label 2103: @121954
     /*  121954 */ GIM_Reject,
     /*  121955 */ // Label 2038: @121955
     /*  121955 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(122565),
     /*  121960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121970 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(122036), // Rule ID 71765 //
     /*  121975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122017 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122034 */     GIR_RootConstrainSelectedInstOperands,
     /*  122035 */     // GIR_Coverage, 71765,
     /*  122035 */     GIR_EraseRootFromParent_Done,
     /*  122036 */   // Label 2129: @122036
     /*  122036 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122102), // Rule ID 71766 //
     /*  122041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122083 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122100 */     GIR_RootConstrainSelectedInstOperands,
     /*  122101 */     // GIR_Coverage, 71766,
     /*  122101 */     GIR_EraseRootFromParent_Done,
     /*  122102 */   // Label 2130: @122102
     /*  122102 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122168), // Rule ID 71763 //
     /*  122107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122149 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122166 */     GIR_RootConstrainSelectedInstOperands,
     /*  122167 */     // GIR_Coverage, 71763,
     /*  122167 */     GIR_EraseRootFromParent_Done,
     /*  122168 */   // Label 2131: @122168
     /*  122168 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122234), // Rule ID 71764 //
     /*  122173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122215 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122232 */     GIR_RootConstrainSelectedInstOperands,
     /*  122233 */     // GIR_Coverage, 71764,
     /*  122233 */     GIR_EraseRootFromParent_Done,
     /*  122234 */   // Label 2132: @122234
     /*  122234 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122300), // Rule ID 71761 //
     /*  122239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122281 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122298 */     GIR_RootConstrainSelectedInstOperands,
     /*  122299 */     // GIR_Coverage, 71761,
     /*  122299 */     GIR_EraseRootFromParent_Done,
     /*  122300 */   // Label 2133: @122300
     /*  122300 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122366), // Rule ID 71762 //
     /*  122305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122347 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122364 */     GIR_RootConstrainSelectedInstOperands,
     /*  122365 */     // GIR_Coverage, 71762,
     /*  122365 */     GIR_EraseRootFromParent_Done,
     /*  122366 */   // Label 2134: @122366
     /*  122366 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122432), // Rule ID 53176 //
     /*  122371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122413 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122430 */     GIR_RootConstrainSelectedInstOperands,
     /*  122431 */     // GIR_Coverage, 53176,
     /*  122431 */     GIR_EraseRootFromParent_Done,
     /*  122432 */   // Label 2135: @122432
     /*  122432 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122498), // Rule ID 53177 //
     /*  122437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  122456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  122460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122479 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122496 */     GIR_RootConstrainSelectedInstOperands,
     /*  122497 */     // GIR_Coverage, 53177,
     /*  122497 */     GIR_EraseRootFromParent_Done,
     /*  122498 */   // Label 2136: @122498
     /*  122498 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122531), // Rule ID 53164 //
     /*  122503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122514 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122529 */     GIR_RootConstrainSelectedInstOperands,
     /*  122530 */     // GIR_Coverage, 53164,
     /*  122530 */     GIR_EraseRootFromParent_Done,
     /*  122531 */   // Label 2137: @122531
     /*  122531 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122564), // Rule ID 53165 //
     /*  122536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122547 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122562 */     GIR_RootConstrainSelectedInstOperands,
     /*  122563 */     // GIR_Coverage, 53165,
     /*  122563 */     GIR_EraseRootFromParent_Done,
     /*  122564 */   // Label 2138: @122564
     /*  122564 */   GIM_Reject,
     /*  122565 */ // Label 2128: @122565
     /*  122565 */ GIM_Reject,
     /*  122566 */ // Label 2039: @122566
     /*  122566 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122680),
     /*  122571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  122574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122589 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122634), // Rule ID 47656 //
     /*  122594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122597 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122632 */     GIR_RootConstrainSelectedInstOperands,
     /*  122633 */     // GIR_Coverage, 47656,
     /*  122633 */     GIR_EraseRootFromParent_Done,
     /*  122634 */   // Label 2140: @122634
     /*  122634 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122679), // Rule ID 47657 //
     /*  122639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122642 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122677 */     GIR_RootConstrainSelectedInstOperands,
     /*  122678 */     // GIR_Coverage, 47657,
     /*  122678 */     GIR_EraseRootFromParent_Done,
     /*  122679 */   // Label 2141: @122679
     /*  122679 */   GIM_Reject,
     /*  122680 */ // Label 2139: @122680
     /*  122680 */ GIM_Reject,
     /*  122681 */ // Label 2040: @122681
     /*  122681 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122795),
     /*  122686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  122689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122704 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122749), // Rule ID 47668 //
     /*  122709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122712 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122747 */     GIR_RootConstrainSelectedInstOperands,
     /*  122748 */     // GIR_Coverage, 47668,
     /*  122748 */     GIR_EraseRootFromParent_Done,
     /*  122749 */   // Label 2143: @122749
     /*  122749 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122794), // Rule ID 47669 //
     /*  122754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122757 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122792 */     GIR_RootConstrainSelectedInstOperands,
     /*  122793 */     // GIR_Coverage, 47669,
     /*  122793 */     GIR_EraseRootFromParent_Done,
     /*  122794 */   // Label 2144: @122794
     /*  122794 */   GIM_Reject,
     /*  122795 */ // Label 2142: @122795
     /*  122795 */ GIM_Reject,
     /*  122796 */ // Label 2041: @122796
     /*  122796 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(122910),
     /*  122801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  122804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122819 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122864), // Rule ID 47676 //
     /*  122824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122827 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122862 */     GIR_RootConstrainSelectedInstOperands,
     /*  122863 */     // GIR_Coverage, 47676,
     /*  122863 */     GIR_EraseRootFromParent_Done,
     /*  122864 */   // Label 2146: @122864
     /*  122864 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122909), // Rule ID 47677 //
     /*  122869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122872 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  122872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122907 */     GIR_RootConstrainSelectedInstOperands,
     /*  122908 */     // GIR_Coverage, 47677,
     /*  122908 */     GIR_EraseRootFromParent_Done,
     /*  122909 */   // Label 2147: @122909
     /*  122909 */   GIM_Reject,
     /*  122910 */ // Label 2145: @122910
     /*  122910 */ GIM_Reject,
     /*  122911 */ // Label 2042: @122911
     /*  122911 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123025),
     /*  122916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  122919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  122922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122934 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122979), // Rule ID 47692 //
     /*  122939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122942 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122977 */     GIR_RootConstrainSelectedInstOperands,
     /*  122978 */     // GIR_Coverage, 47692,
     /*  122978 */     GIR_EraseRootFromParent_Done,
     /*  122979 */   // Label 2149: @122979
     /*  122979 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123024), // Rule ID 47693 //
     /*  122984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122987 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123022 */     GIR_RootConstrainSelectedInstOperands,
     /*  123023 */     // GIR_Coverage, 47693,
     /*  123023 */     GIR_EraseRootFromParent_Done,
     /*  123024 */   // Label 2150: @123024
     /*  123024 */   GIM_Reject,
     /*  123025 */ // Label 2148: @123025
     /*  123025 */ GIM_Reject,
     /*  123026 */ // Label 2043: @123026
     /*  123026 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123636),
     /*  123031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123041 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123107), // Rule ID 71793 //
     /*  123046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123088 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123105 */     GIR_RootConstrainSelectedInstOperands,
     /*  123106 */     // GIR_Coverage, 71793,
     /*  123106 */     GIR_EraseRootFromParent_Done,
     /*  123107 */   // Label 2152: @123107
     /*  123107 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123173), // Rule ID 71794 //
     /*  123112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123154 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123171 */     GIR_RootConstrainSelectedInstOperands,
     /*  123172 */     // GIR_Coverage, 71794,
     /*  123172 */     GIR_EraseRootFromParent_Done,
     /*  123173 */   // Label 2153: @123173
     /*  123173 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123239), // Rule ID 71791 //
     /*  123178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123220 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123237 */     GIR_RootConstrainSelectedInstOperands,
     /*  123238 */     // GIR_Coverage, 71791,
     /*  123238 */     GIR_EraseRootFromParent_Done,
     /*  123239 */   // Label 2154: @123239
     /*  123239 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123305), // Rule ID 71792 //
     /*  123244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123286 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123303 */     GIR_RootConstrainSelectedInstOperands,
     /*  123304 */     // GIR_Coverage, 71792,
     /*  123304 */     GIR_EraseRootFromParent_Done,
     /*  123305 */   // Label 2155: @123305
     /*  123305 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123371), // Rule ID 71789 //
     /*  123310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123352 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123369 */     GIR_RootConstrainSelectedInstOperands,
     /*  123370 */     // GIR_Coverage, 71789,
     /*  123370 */     GIR_EraseRootFromParent_Done,
     /*  123371 */   // Label 2156: @123371
     /*  123371 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123437), // Rule ID 71790 //
     /*  123376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123418 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123435 */     GIR_RootConstrainSelectedInstOperands,
     /*  123436 */     // GIR_Coverage, 71790,
     /*  123436 */     GIR_EraseRootFromParent_Done,
     /*  123437 */   // Label 2157: @123437
     /*  123437 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123503), // Rule ID 53194 //
     /*  123442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123484 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123501 */     GIR_RootConstrainSelectedInstOperands,
     /*  123502 */     // GIR_Coverage, 53194,
     /*  123502 */     GIR_EraseRootFromParent_Done,
     /*  123503 */   // Label 2158: @123503
     /*  123503 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123569), // Rule ID 53195 //
     /*  123508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123550 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123567 */     GIR_RootConstrainSelectedInstOperands,
     /*  123568 */     // GIR_Coverage, 53195,
     /*  123568 */     GIR_EraseRootFromParent_Done,
     /*  123569 */   // Label 2159: @123569
     /*  123569 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123602), // Rule ID 53182 //
     /*  123574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123585 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123600 */     GIR_RootConstrainSelectedInstOperands,
     /*  123601 */     // GIR_Coverage, 53182,
     /*  123601 */     GIR_EraseRootFromParent_Done,
     /*  123602 */   // Label 2160: @123602
     /*  123602 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123635), // Rule ID 53183 //
     /*  123607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123618 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123633 */     GIR_RootConstrainSelectedInstOperands,
     /*  123634 */     // GIR_Coverage, 53183,
     /*  123634 */     GIR_EraseRootFromParent_Done,
     /*  123635 */   // Label 2161: @123635
     /*  123635 */   GIM_Reject,
     /*  123636 */ // Label 2151: @123636
     /*  123636 */ GIM_Reject,
     /*  123637 */ // Label 2044: @123637
     /*  123637 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123751),
     /*  123642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  123645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  123648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123660 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123705), // Rule ID 47660 //
     /*  123665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123668 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123703 */     GIR_RootConstrainSelectedInstOperands,
     /*  123704 */     // GIR_Coverage, 47660,
     /*  123704 */     GIR_EraseRootFromParent_Done,
     /*  123705 */   // Label 2163: @123705
     /*  123705 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123750), // Rule ID 47661 //
     /*  123710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123713 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123748 */     GIR_RootConstrainSelectedInstOperands,
     /*  123749 */     // GIR_Coverage, 47661,
     /*  123749 */     GIR_EraseRootFromParent_Done,
     /*  123750 */   // Label 2164: @123750
     /*  123750 */   GIM_Reject,
     /*  123751 */ // Label 2162: @123751
     /*  123751 */ GIM_Reject,
     /*  123752 */ // Label 2045: @123752
     /*  123752 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123866),
     /*  123757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  123760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  123763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123775 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123820), // Rule ID 47672 //
     /*  123780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123783 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123818 */     GIR_RootConstrainSelectedInstOperands,
     /*  123819 */     // GIR_Coverage, 47672,
     /*  123819 */     GIR_EraseRootFromParent_Done,
     /*  123820 */   // Label 2166: @123820
     /*  123820 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123865), // Rule ID 47673 //
     /*  123825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123828 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123863 */     GIR_RootConstrainSelectedInstOperands,
     /*  123864 */     // GIR_Coverage, 47673,
     /*  123864 */     GIR_EraseRootFromParent_Done,
     /*  123865 */   // Label 2167: @123865
     /*  123865 */   GIM_Reject,
     /*  123866 */ // Label 2165: @123866
     /*  123866 */ GIM_Reject,
     /*  123867 */ // Label 2046: @123867
     /*  123867 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(123981),
     /*  123872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  123875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123890 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123935), // Rule ID 47688 //
     /*  123895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123898 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  123898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123933 */     GIR_RootConstrainSelectedInstOperands,
     /*  123934 */     // GIR_Coverage, 47688,
     /*  123934 */     GIR_EraseRootFromParent_Done,
     /*  123935 */   // Label 2169: @123935
     /*  123935 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123980), // Rule ID 47689 //
     /*  123940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123943 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123978 */     GIR_RootConstrainSelectedInstOperands,
     /*  123979 */     // GIR_Coverage, 47689,
     /*  123979 */     GIR_EraseRootFromParent_Done,
     /*  123980 */   // Label 2170: @123980
     /*  123980 */   GIM_Reject,
     /*  123981 */ // Label 2168: @123981
     /*  123981 */ GIM_Reject,
     /*  123982 */ // Label 2047: @123982
     /*  123982 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124096),
     /*  123987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  123993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124005 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124050), // Rule ID 47732 //
     /*  124010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124013 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  124016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124048 */     GIR_RootConstrainSelectedInstOperands,
     /*  124049 */     // GIR_Coverage, 47732,
     /*  124049 */     GIR_EraseRootFromParent_Done,
     /*  124050 */   // Label 2172: @124050
     /*  124050 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124095), // Rule ID 47733 //
     /*  124055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124058 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  124061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124093 */     GIR_RootConstrainSelectedInstOperands,
     /*  124094 */     // GIR_Coverage, 47733,
     /*  124094 */     GIR_EraseRootFromParent_Done,
     /*  124095 */   // Label 2173: @124095
     /*  124095 */   GIM_Reject,
     /*  124096 */ // Label 2171: @124096
     /*  124096 */ GIM_Reject,
     /*  124097 */ // Label 2048: @124097
     /*  124097 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124707),
     /*  124102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124112 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124178), // Rule ID 71821 //
     /*  124117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124159 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124176 */     GIR_RootConstrainSelectedInstOperands,
     /*  124177 */     // GIR_Coverage, 71821,
     /*  124177 */     GIR_EraseRootFromParent_Done,
     /*  124178 */   // Label 2175: @124178
     /*  124178 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124244), // Rule ID 71822 //
     /*  124183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124225 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124242 */     GIR_RootConstrainSelectedInstOperands,
     /*  124243 */     // GIR_Coverage, 71822,
     /*  124243 */     GIR_EraseRootFromParent_Done,
     /*  124244 */   // Label 2176: @124244
     /*  124244 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124310), // Rule ID 71819 //
     /*  124249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124291 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124308 */     GIR_RootConstrainSelectedInstOperands,
     /*  124309 */     // GIR_Coverage, 71819,
     /*  124309 */     GIR_EraseRootFromParent_Done,
     /*  124310 */   // Label 2177: @124310
     /*  124310 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124376), // Rule ID 71820 //
     /*  124315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124357 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124374 */     GIR_RootConstrainSelectedInstOperands,
     /*  124375 */     // GIR_Coverage, 71820,
     /*  124375 */     GIR_EraseRootFromParent_Done,
     /*  124376 */   // Label 2178: @124376
     /*  124376 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124442), // Rule ID 71817 //
     /*  124381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124423 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124440 */     GIR_RootConstrainSelectedInstOperands,
     /*  124441 */     // GIR_Coverage, 71817,
     /*  124441 */     GIR_EraseRootFromParent_Done,
     /*  124442 */   // Label 2179: @124442
     /*  124442 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124508), // Rule ID 71818 //
     /*  124447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124489 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124506 */     GIR_RootConstrainSelectedInstOperands,
     /*  124507 */     // GIR_Coverage, 71818,
     /*  124507 */     GIR_EraseRootFromParent_Done,
     /*  124508 */   // Label 2180: @124508
     /*  124508 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124574), // Rule ID 53212 //
     /*  124513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124555 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124572 */     GIR_RootConstrainSelectedInstOperands,
     /*  124573 */     // GIR_Coverage, 53212,
     /*  124573 */     GIR_EraseRootFromParent_Done,
     /*  124574 */   // Label 2181: @124574
     /*  124574 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124640), // Rule ID 53213 //
     /*  124579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124621 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124638 */     GIR_RootConstrainSelectedInstOperands,
     /*  124639 */     // GIR_Coverage, 53213,
     /*  124639 */     GIR_EraseRootFromParent_Done,
     /*  124640 */   // Label 2182: @124640
     /*  124640 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124673), // Rule ID 53200 //
     /*  124645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124656 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124671 */     GIR_RootConstrainSelectedInstOperands,
     /*  124672 */     // GIR_Coverage, 53200,
     /*  124672 */     GIR_EraseRootFromParent_Done,
     /*  124673 */   // Label 2183: @124673
     /*  124673 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124706), // Rule ID 53201 //
     /*  124678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124689 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124704 */     GIR_RootConstrainSelectedInstOperands,
     /*  124705 */     // GIR_Coverage, 53201,
     /*  124705 */     GIR_EraseRootFromParent_Done,
     /*  124706 */   // Label 2184: @124706
     /*  124706 */   GIM_Reject,
     /*  124707 */ // Label 2174: @124707
     /*  124707 */ GIM_Reject,
     /*  124708 */ // Label 2049: @124708
     /*  124708 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124822),
     /*  124713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  124716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  124719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124731 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124776), // Rule ID 47664 //
     /*  124736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124739 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124774 */     GIR_RootConstrainSelectedInstOperands,
     /*  124775 */     // GIR_Coverage, 47664,
     /*  124775 */     GIR_EraseRootFromParent_Done,
     /*  124776 */   // Label 2186: @124776
     /*  124776 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124821), // Rule ID 47665 //
     /*  124781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124784 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124819 */     GIR_RootConstrainSelectedInstOperands,
     /*  124820 */     // GIR_Coverage, 47665,
     /*  124820 */     GIR_EraseRootFromParent_Done,
     /*  124821 */   // Label 2187: @124821
     /*  124821 */   GIM_Reject,
     /*  124822 */ // Label 2185: @124822
     /*  124822 */ GIM_Reject,
     /*  124823 */ // Label 2050: @124823
     /*  124823 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124937),
     /*  124828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  124831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  124834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124846 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124891), // Rule ID 47684 //
     /*  124851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124854 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124889 */     GIR_RootConstrainSelectedInstOperands,
     /*  124890 */     // GIR_Coverage, 47684,
     /*  124890 */     GIR_EraseRootFromParent_Done,
     /*  124891 */   // Label 2189: @124891
     /*  124891 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124936), // Rule ID 47685 //
     /*  124896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124899 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  124899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124934 */     GIR_RootConstrainSelectedInstOperands,
     /*  124935 */     // GIR_Coverage, 47685,
     /*  124935 */     GIR_EraseRootFromParent_Done,
     /*  124936 */   // Label 2190: @124936
     /*  124936 */   GIM_Reject,
     /*  124937 */ // Label 2188: @124937
     /*  124937 */ GIM_Reject,
     /*  124938 */ // Label 2051: @124938
     /*  124938 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125052),
     /*  124943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124961 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125006), // Rule ID 47720 //
     /*  124966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124969 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125004 */     GIR_RootConstrainSelectedInstOperands,
     /*  125005 */     // GIR_Coverage, 47720,
     /*  125005 */     GIR_EraseRootFromParent_Done,
     /*  125006 */   // Label 2192: @125006
     /*  125006 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125051), // Rule ID 47721 //
     /*  125011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125014 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  125017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125049 */     GIR_RootConstrainSelectedInstOperands,
     /*  125050 */     // GIR_Coverage, 47721,
     /*  125050 */     GIR_EraseRootFromParent_Done,
     /*  125051 */   // Label 2193: @125051
     /*  125051 */   GIM_Reject,
     /*  125052 */ // Label 2191: @125052
     /*  125052 */ GIM_Reject,
     /*  125053 */ // Label 2052: @125053
     /*  125053 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125167),
     /*  125058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  125061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  125064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125076 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125121), // Rule ID 47736 //
     /*  125081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125084 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  125087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125119 */     GIR_RootConstrainSelectedInstOperands,
     /*  125120 */     // GIR_Coverage, 47736,
     /*  125120 */     GIR_EraseRootFromParent_Done,
     /*  125121 */   // Label 2195: @125121
     /*  125121 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125166), // Rule ID 47737 //
     /*  125126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125129 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  125132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125164 */     GIR_RootConstrainSelectedInstOperands,
     /*  125165 */     // GIR_Coverage, 47737,
     /*  125165 */     GIR_EraseRootFromParent_Done,
     /*  125166 */   // Label 2196: @125166
     /*  125166 */   GIM_Reject,
     /*  125167 */ // Label 2194: @125167
     /*  125167 */ GIM_Reject,
     /*  125168 */ // Label 2053: @125168
     /*  125168 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125778),
     /*  125173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125183 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125249), // Rule ID 71849 //
     /*  125188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125230 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125247 */     GIR_RootConstrainSelectedInstOperands,
     /*  125248 */     // GIR_Coverage, 71849,
     /*  125248 */     GIR_EraseRootFromParent_Done,
     /*  125249 */   // Label 2198: @125249
     /*  125249 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125315), // Rule ID 71850 //
     /*  125254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125296 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125313 */     GIR_RootConstrainSelectedInstOperands,
     /*  125314 */     // GIR_Coverage, 71850,
     /*  125314 */     GIR_EraseRootFromParent_Done,
     /*  125315 */   // Label 2199: @125315
     /*  125315 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125381), // Rule ID 71847 //
     /*  125320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125362 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125379 */     GIR_RootConstrainSelectedInstOperands,
     /*  125380 */     // GIR_Coverage, 71847,
     /*  125380 */     GIR_EraseRootFromParent_Done,
     /*  125381 */   // Label 2200: @125381
     /*  125381 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125447), // Rule ID 71848 //
     /*  125386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125428 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125445 */     GIR_RootConstrainSelectedInstOperands,
     /*  125446 */     // GIR_Coverage, 71848,
     /*  125446 */     GIR_EraseRootFromParent_Done,
     /*  125447 */   // Label 2201: @125447
     /*  125447 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125513), // Rule ID 71845 //
     /*  125452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125494 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125511 */     GIR_RootConstrainSelectedInstOperands,
     /*  125512 */     // GIR_Coverage, 71845,
     /*  125512 */     GIR_EraseRootFromParent_Done,
     /*  125513 */   // Label 2202: @125513
     /*  125513 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125579), // Rule ID 71846 //
     /*  125518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125560 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125577 */     GIR_RootConstrainSelectedInstOperands,
     /*  125578 */     // GIR_Coverage, 71846,
     /*  125578 */     GIR_EraseRootFromParent_Done,
     /*  125579 */   // Label 2203: @125579
     /*  125579 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125645), // Rule ID 53230 //
     /*  125584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125626 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125643 */     GIR_RootConstrainSelectedInstOperands,
     /*  125644 */     // GIR_Coverage, 53230,
     /*  125644 */     GIR_EraseRootFromParent_Done,
     /*  125645 */   // Label 2204: @125645
     /*  125645 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125711), // Rule ID 53231 //
     /*  125650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125692 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125709 */     GIR_RootConstrainSelectedInstOperands,
     /*  125710 */     // GIR_Coverage, 53231,
     /*  125710 */     GIR_EraseRootFromParent_Done,
     /*  125711 */   // Label 2205: @125711
     /*  125711 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125744), // Rule ID 53218 //
     /*  125716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125727 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125742 */     GIR_RootConstrainSelectedInstOperands,
     /*  125743 */     // GIR_Coverage, 53218,
     /*  125743 */     GIR_EraseRootFromParent_Done,
     /*  125744 */   // Label 2206: @125744
     /*  125744 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125777), // Rule ID 53219 //
     /*  125749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125760 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125775 */     GIR_RootConstrainSelectedInstOperands,
     /*  125776 */     // GIR_Coverage, 53219,
     /*  125776 */     GIR_EraseRootFromParent_Done,
     /*  125777 */   // Label 2207: @125777
     /*  125777 */   GIM_Reject,
     /*  125778 */ // Label 2197: @125778
     /*  125778 */ GIM_Reject,
     /*  125779 */ // Label 2054: @125779
     /*  125779 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125893),
     /*  125784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  125787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  125790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125802 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125847), // Rule ID 47680 //
     /*  125807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125810 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125845 */     GIR_RootConstrainSelectedInstOperands,
     /*  125846 */     // GIR_Coverage, 47680,
     /*  125846 */     GIR_EraseRootFromParent_Done,
     /*  125847 */   // Label 2209: @125847
     /*  125847 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125892), // Rule ID 47681 //
     /*  125852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125855 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125890 */     GIR_RootConstrainSelectedInstOperands,
     /*  125891 */     // GIR_Coverage, 47681,
     /*  125891 */     GIR_EraseRootFromParent_Done,
     /*  125892 */   // Label 2210: @125892
     /*  125892 */   GIM_Reject,
     /*  125893 */ // Label 2208: @125893
     /*  125893 */ GIM_Reject,
     /*  125894 */ // Label 2055: @125894
     /*  125894 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126008),
     /*  125899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  125902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  125905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125917 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125962), // Rule ID 47708 //
     /*  125922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125925 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  125925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125960 */     GIR_RootConstrainSelectedInstOperands,
     /*  125961 */     // GIR_Coverage, 47708,
     /*  125961 */     GIR_EraseRootFromParent_Done,
     /*  125962 */   // Label 2212: @125962
     /*  125962 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126007), // Rule ID 47709 //
     /*  125967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125970 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126005 */     GIR_RootConstrainSelectedInstOperands,
     /*  126006 */     // GIR_Coverage, 47709,
     /*  126006 */     GIR_EraseRootFromParent_Done,
     /*  126007 */   // Label 2213: @126007
     /*  126007 */   GIM_Reject,
     /*  126008 */ // Label 2211: @126008
     /*  126008 */ GIM_Reject,
     /*  126009 */ // Label 2056: @126009
     /*  126009 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126123),
     /*  126014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  126017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  126020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126032 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126077), // Rule ID 47724 //
     /*  126037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126040 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  126043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126075 */     GIR_RootConstrainSelectedInstOperands,
     /*  126076 */     // GIR_Coverage, 47724,
     /*  126076 */     GIR_EraseRootFromParent_Done,
     /*  126077 */   // Label 2215: @126077
     /*  126077 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126122), // Rule ID 47725 //
     /*  126082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126085 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  126088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126120 */     GIR_RootConstrainSelectedInstOperands,
     /*  126121 */     // GIR_Coverage, 47725,
     /*  126121 */     GIR_EraseRootFromParent_Done,
     /*  126122 */   // Label 2216: @126122
     /*  126122 */   GIM_Reject,
     /*  126123 */ // Label 2214: @126123
     /*  126123 */ GIM_Reject,
     /*  126124 */ // Label 2057: @126124
     /*  126124 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126238),
     /*  126129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  126132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  126135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126147 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126192), // Rule ID 47740 //
     /*  126152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  126155 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  126155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  126158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126190 */     GIR_RootConstrainSelectedInstOperands,
     /*  126191 */     // GIR_Coverage, 47740,
     /*  126191 */     GIR_EraseRootFromParent_Done,
     /*  126192 */   // Label 2218: @126192
     /*  126192 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126237), // Rule ID 47741 //
     /*  126197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  126200 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  126200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  126203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  126232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126235 */     GIR_RootConstrainSelectedInstOperands,
     /*  126236 */     // GIR_Coverage, 47741,
     /*  126236 */     GIR_EraseRootFromParent_Done,
     /*  126237 */   // Label 2219: @126237
     /*  126237 */   GIM_Reject,
     /*  126238 */ // Label 2217: @126238
     /*  126238 */ GIM_Reject,
     /*  126239 */ // Label 2058: @126239
     /*  126239 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126849),
     /*  126244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126254 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126320), // Rule ID 71877 //
     /*  126259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126301 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126318 */     GIR_RootConstrainSelectedInstOperands,
     /*  126319 */     // GIR_Coverage, 71877,
     /*  126319 */     GIR_EraseRootFromParent_Done,
     /*  126320 */   // Label 2221: @126320
     /*  126320 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126386), // Rule ID 71878 //
     /*  126325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126367 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126384 */     GIR_RootConstrainSelectedInstOperands,
     /*  126385 */     // GIR_Coverage, 71878,
     /*  126385 */     GIR_EraseRootFromParent_Done,
     /*  126386 */   // Label 2222: @126386
     /*  126386 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126452), // Rule ID 71875 //
     /*  126391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126433 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126450 */     GIR_RootConstrainSelectedInstOperands,
     /*  126451 */     // GIR_Coverage, 71875,
     /*  126451 */     GIR_EraseRootFromParent_Done,
     /*  126452 */   // Label 2223: @126452
     /*  126452 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126518), // Rule ID 71876 //
     /*  126457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126499 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126516 */     GIR_RootConstrainSelectedInstOperands,
     /*  126517 */     // GIR_Coverage, 71876,
     /*  126517 */     GIR_EraseRootFromParent_Done,
     /*  126518 */   // Label 2224: @126518
     /*  126518 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126584), // Rule ID 71873 //
     /*  126523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126565 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126582 */     GIR_RootConstrainSelectedInstOperands,
     /*  126583 */     // GIR_Coverage, 71873,
     /*  126583 */     GIR_EraseRootFromParent_Done,
     /*  126584 */   // Label 2225: @126584
     /*  126584 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126650), // Rule ID 71874 //
     /*  126589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126631 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126648 */     GIR_RootConstrainSelectedInstOperands,
     /*  126649 */     // GIR_Coverage, 71874,
     /*  126649 */     GIR_EraseRootFromParent_Done,
     /*  126650 */   // Label 2226: @126650
     /*  126650 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126716), // Rule ID 53248 //
     /*  126655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126697 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126714 */     GIR_RootConstrainSelectedInstOperands,
     /*  126715 */     // GIR_Coverage, 53248,
     /*  126715 */     GIR_EraseRootFromParent_Done,
     /*  126716 */   // Label 2227: @126716
     /*  126716 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126782), // Rule ID 53249 //
     /*  126721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126763 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126780 */     GIR_RootConstrainSelectedInstOperands,
     /*  126781 */     // GIR_Coverage, 53249,
     /*  126781 */     GIR_EraseRootFromParent_Done,
     /*  126782 */   // Label 2228: @126782
     /*  126782 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126815), // Rule ID 53236 //
     /*  126787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126798 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126813 */     GIR_RootConstrainSelectedInstOperands,
     /*  126814 */     // GIR_Coverage, 53236,
     /*  126814 */     GIR_EraseRootFromParent_Done,
     /*  126815 */   // Label 2229: @126815
     /*  126815 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126848), // Rule ID 53237 //
     /*  126820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126831 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126846 */     GIR_RootConstrainSelectedInstOperands,
     /*  126847 */     // GIR_Coverage, 53237,
     /*  126847 */     GIR_EraseRootFromParent_Done,
     /*  126848 */   // Label 2230: @126848
     /*  126848 */   GIM_Reject,
     /*  126849 */ // Label 2220: @126849
     /*  126849 */ GIM_Reject,
     /*  126850 */ // Label 2059: @126850
     /*  126850 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126964),
     /*  126855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  126858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126873 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126918), // Rule ID 47696 //
     /*  126878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126881 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126916 */     GIR_RootConstrainSelectedInstOperands,
     /*  126917 */     // GIR_Coverage, 47696,
     /*  126917 */     GIR_EraseRootFromParent_Done,
     /*  126918 */   // Label 2232: @126918
     /*  126918 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126963), // Rule ID 47697 //
     /*  126923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126926 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126961 */     GIR_RootConstrainSelectedInstOperands,
     /*  126962 */     // GIR_Coverage, 47697,
     /*  126962 */     GIR_EraseRootFromParent_Done,
     /*  126963 */   // Label 2233: @126963
     /*  126963 */   GIM_Reject,
     /*  126964 */ // Label 2231: @126964
     /*  126964 */ GIM_Reject,
     /*  126965 */ // Label 2060: @126965
     /*  126965 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127079),
     /*  126970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126988 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127033), // Rule ID 47712 //
     /*  126993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126996 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  126996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127031 */     GIR_RootConstrainSelectedInstOperands,
     /*  127032 */     // GIR_Coverage, 47712,
     /*  127032 */     GIR_EraseRootFromParent_Done,
     /*  127033 */   // Label 2235: @127033
     /*  127033 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127078), // Rule ID 47713 //
     /*  127038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127041 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  127044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127076 */     GIR_RootConstrainSelectedInstOperands,
     /*  127077 */     // GIR_Coverage, 47713,
     /*  127077 */     GIR_EraseRootFromParent_Done,
     /*  127078 */   // Label 2236: @127078
     /*  127078 */   GIM_Reject,
     /*  127079 */ // Label 2234: @127079
     /*  127079 */ GIM_Reject,
     /*  127080 */ // Label 2061: @127080
     /*  127080 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127194),
     /*  127085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  127088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  127091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127103 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127148), // Rule ID 47728 //
     /*  127108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127111 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  127111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  127114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127146 */     GIR_RootConstrainSelectedInstOperands,
     /*  127147 */     // GIR_Coverage, 47728,
     /*  127147 */     GIR_EraseRootFromParent_Done,
     /*  127148 */   // Label 2238: @127148
     /*  127148 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127193), // Rule ID 47729 //
     /*  127153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127156 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  127156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  127159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  127188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127191 */     GIR_RootConstrainSelectedInstOperands,
     /*  127192 */     // GIR_Coverage, 47729,
     /*  127192 */     GIR_EraseRootFromParent_Done,
     /*  127193 */   // Label 2239: @127193
     /*  127193 */   GIM_Reject,
     /*  127194 */ // Label 2237: @127194
     /*  127194 */ GIM_Reject,
     /*  127195 */ // Label 2062: @127195
     /*  127195 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127805),
     /*  127200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127210 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127276), // Rule ID 71905 //
     /*  127215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127257 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127274 */     GIR_RootConstrainSelectedInstOperands,
     /*  127275 */     // GIR_Coverage, 71905,
     /*  127275 */     GIR_EraseRootFromParent_Done,
     /*  127276 */   // Label 2241: @127276
     /*  127276 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127342), // Rule ID 71906 //
     /*  127281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127323 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127340 */     GIR_RootConstrainSelectedInstOperands,
     /*  127341 */     // GIR_Coverage, 71906,
     /*  127341 */     GIR_EraseRootFromParent_Done,
     /*  127342 */   // Label 2242: @127342
     /*  127342 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127408), // Rule ID 71903 //
     /*  127347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127389 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127406 */     GIR_RootConstrainSelectedInstOperands,
     /*  127407 */     // GIR_Coverage, 71903,
     /*  127407 */     GIR_EraseRootFromParent_Done,
     /*  127408 */   // Label 2243: @127408
     /*  127408 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127474), // Rule ID 71904 //
     /*  127413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127455 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127472 */     GIR_RootConstrainSelectedInstOperands,
     /*  127473 */     // GIR_Coverage, 71904,
     /*  127473 */     GIR_EraseRootFromParent_Done,
     /*  127474 */   // Label 2244: @127474
     /*  127474 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127540), // Rule ID 71901 //
     /*  127479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127521 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127538 */     GIR_RootConstrainSelectedInstOperands,
     /*  127539 */     // GIR_Coverage, 71901,
     /*  127539 */     GIR_EraseRootFromParent_Done,
     /*  127540 */   // Label 2245: @127540
     /*  127540 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127606), // Rule ID 71902 //
     /*  127545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127587 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127604 */     GIR_RootConstrainSelectedInstOperands,
     /*  127605 */     // GIR_Coverage, 71902,
     /*  127605 */     GIR_EraseRootFromParent_Done,
     /*  127606 */   // Label 2246: @127606
     /*  127606 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127672), // Rule ID 53266 //
     /*  127611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127653 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127670 */     GIR_RootConstrainSelectedInstOperands,
     /*  127671 */     // GIR_Coverage, 53266,
     /*  127671 */     GIR_EraseRootFromParent_Done,
     /*  127672 */   // Label 2247: @127672
     /*  127672 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127738), // Rule ID 53267 //
     /*  127677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127719 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127736 */     GIR_RootConstrainSelectedInstOperands,
     /*  127737 */     // GIR_Coverage, 53267,
     /*  127737 */     GIR_EraseRootFromParent_Done,
     /*  127738 */   // Label 2248: @127738
     /*  127738 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127771), // Rule ID 53254 //
     /*  127743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127754 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127769 */     GIR_RootConstrainSelectedInstOperands,
     /*  127770 */     // GIR_Coverage, 53254,
     /*  127770 */     GIR_EraseRootFromParent_Done,
     /*  127771 */   // Label 2249: @127771
     /*  127771 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127804), // Rule ID 53255 //
     /*  127776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127787 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127802 */     GIR_RootConstrainSelectedInstOperands,
     /*  127803 */     // GIR_Coverage, 53255,
     /*  127803 */     GIR_EraseRootFromParent_Done,
     /*  127804 */   // Label 2250: @127804
     /*  127804 */   GIM_Reject,
     /*  127805 */ // Label 2240: @127805
     /*  127805 */ GIM_Reject,
     /*  127806 */ // Label 2063: @127806
     /*  127806 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(127920),
     /*  127811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  127814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  127817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127829 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127874), // Rule ID 47700 //
     /*  127834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127837 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127872 */     GIR_RootConstrainSelectedInstOperands,
     /*  127873 */     // GIR_Coverage, 47700,
     /*  127873 */     GIR_EraseRootFromParent_Done,
     /*  127874 */   // Label 2252: @127874
     /*  127874 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(127919), // Rule ID 47701 //
     /*  127879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127882 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127917 */     GIR_RootConstrainSelectedInstOperands,
     /*  127918 */     // GIR_Coverage, 47701,
     /*  127918 */     GIR_EraseRootFromParent_Done,
     /*  127919 */   // Label 2253: @127919
     /*  127919 */   GIM_Reject,
     /*  127920 */ // Label 2251: @127920
     /*  127920 */ GIM_Reject,
     /*  127921 */ // Label 2064: @127921
     /*  127921 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(128035),
     /*  127926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  127929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127944 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(127989), // Rule ID 47716 //
     /*  127949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127952 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127987 */     GIR_RootConstrainSelectedInstOperands,
     /*  127988 */     // GIR_Coverage, 47716,
     /*  127988 */     GIR_EraseRootFromParent_Done,
     /*  127989 */   // Label 2255: @127989
     /*  127989 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128034), // Rule ID 47717 //
     /*  127994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127997 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  128000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  128029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128032 */     GIR_RootConstrainSelectedInstOperands,
     /*  128033 */     // GIR_Coverage, 47717,
     /*  128033 */     GIR_EraseRootFromParent_Done,
     /*  128034 */   // Label 2256: @128034
     /*  128034 */   GIM_Reject,
     /*  128035 */ // Label 2254: @128035
     /*  128035 */ GIM_Reject,
     /*  128036 */ // Label 2065: @128036
     /*  128036 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128646),
     /*  128041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128051 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128117), // Rule ID 71933 //
     /*  128056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128098 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128115 */     GIR_RootConstrainSelectedInstOperands,
     /*  128116 */     // GIR_Coverage, 71933,
     /*  128116 */     GIR_EraseRootFromParent_Done,
     /*  128117 */   // Label 2258: @128117
     /*  128117 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128183), // Rule ID 71934 //
     /*  128122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128164 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128181 */     GIR_RootConstrainSelectedInstOperands,
     /*  128182 */     // GIR_Coverage, 71934,
     /*  128182 */     GIR_EraseRootFromParent_Done,
     /*  128183 */   // Label 2259: @128183
     /*  128183 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128249), // Rule ID 71931 //
     /*  128188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128230 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128247 */     GIR_RootConstrainSelectedInstOperands,
     /*  128248 */     // GIR_Coverage, 71931,
     /*  128248 */     GIR_EraseRootFromParent_Done,
     /*  128249 */   // Label 2260: @128249
     /*  128249 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128315), // Rule ID 71932 //
     /*  128254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128296 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  128303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128313 */     GIR_RootConstrainSelectedInstOperands,
     /*  128314 */     // GIR_Coverage, 71932,
     /*  128314 */     GIR_EraseRootFromParent_Done,
     /*  128315 */   // Label 2261: @128315
     /*  128315 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128381), // Rule ID 71929 //
     /*  128320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128362 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128379 */     GIR_RootConstrainSelectedInstOperands,
     /*  128380 */     // GIR_Coverage, 71929,
     /*  128380 */     GIR_EraseRootFromParent_Done,
     /*  128381 */   // Label 2262: @128381
     /*  128381 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128447), // Rule ID 71930 //
     /*  128386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128428 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  128439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128445 */     GIR_RootConstrainSelectedInstOperands,
     /*  128446 */     // GIR_Coverage, 71930,
     /*  128446 */     GIR_EraseRootFromParent_Done,
     /*  128447 */   // Label 2263: @128447
     /*  128447 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(128513), // Rule ID 53284 //
     /*  128452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128494 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128511 */     GIR_RootConstrainSelectedInstOperands,
     /*  128512 */     // GIR_Coverage, 53284,
     /*  128512 */     GIR_EraseRootFromParent_Done,
     /*  128513 */   // Label 2264: @128513
     /*  128513 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(128579), // Rule ID 53285 //
     /*  128518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128560 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128577 */     GIR_RootConstrainSelectedInstOperands,
     /*  128578 */     // GIR_Coverage, 53285,
     /*  128578 */     GIR_EraseRootFromParent_Done,
     /*  128579 */   // Label 2265: @128579
     /*  128579 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(128612), // Rule ID 53272 //
     /*  128584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128595 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128610 */     GIR_RootConstrainSelectedInstOperands,
     /*  128611 */     // GIR_Coverage, 53272,
     /*  128611 */     GIR_EraseRootFromParent_Done,
     /*  128612 */   // Label 2266: @128612
     /*  128612 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(128645), // Rule ID 53273 //
     /*  128617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128628 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128643 */     GIR_RootConstrainSelectedInstOperands,
     /*  128644 */     // GIR_Coverage, 53273,
     /*  128644 */     GIR_EraseRootFromParent_Done,
     /*  128645 */   // Label 2267: @128645
     /*  128645 */   GIM_Reject,
     /*  128646 */ // Label 2257: @128646
     /*  128646 */ GIM_Reject,
     /*  128647 */ // Label 2066: @128647
     /*  128647 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(128761),
     /*  128652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  128655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  128658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128670 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(128715), // Rule ID 47704 //
     /*  128675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128678 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  128678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128713 */     GIR_RootConstrainSelectedInstOperands,
     /*  128714 */     // GIR_Coverage, 47704,
     /*  128714 */     GIR_EraseRootFromParent_Done,
     /*  128715 */   // Label 2269: @128715
     /*  128715 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(128760), // Rule ID 47705 //
     /*  128720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128723 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  128723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128758 */     GIR_RootConstrainSelectedInstOperands,
     /*  128759 */     // GIR_Coverage, 47705,
     /*  128759 */     GIR_EraseRootFromParent_Done,
     /*  128760 */   // Label 2270: @128760
     /*  128760 */   GIM_Reject,
     /*  128761 */ // Label 2268: @128761
     /*  128761 */ GIM_Reject,
     /*  128762 */ // Label 2067: @128762
     /*  128762 */ GIM_Reject,
     /*  128763 */ // Label 8: @128763
     /*  128763 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2302*/ GIMT_Encode4(141383),
     /*  128774 */ /*GILLT_s32*//*Label 2271*/ GIMT_Encode4(128898),
     /*  128778 */ /*GILLT_s64*//*Label 2272*/ GIMT_Encode4(131628),
     /*  128782 */ /*GILLT_nxv1s1*//*Label 2273*/ GIMT_Encode4(134576),
     /*  128786 */ /*GILLT_nxv1s8*//*Label 2274*/ GIMT_Encode4(135187),
     /*  128790 */ /*GILLT_nxv1s16*//*Label 2275*/ GIMT_Encode4(135302),
     /*  128794 */ /*GILLT_nxv1s32*//*Label 2276*/ GIMT_Encode4(135417),
     /*  128798 */ /*GILLT_nxv1s64*//*Label 2277*/ GIMT_Encode4(135532),
     /*  128802 */ /*GILLT_nxv2s1*//*Label 2278*/ GIMT_Encode4(135647),
     /*  128806 */ /*GILLT_nxv2s8*//*Label 2279*/ GIMT_Encode4(136258),
     /*  128810 */ /*GILLT_nxv2s16*//*Label 2280*/ GIMT_Encode4(136373),
     /*  128814 */ /*GILLT_nxv2s32*//*Label 2281*/ GIMT_Encode4(136488),
     /*  128818 */ /*GILLT_nxv2s64*//*Label 2282*/ GIMT_Encode4(136603),
     /*  128822 */ /*GILLT_nxv4s1*//*Label 2283*/ GIMT_Encode4(136718),
     /*  128826 */ /*GILLT_nxv4s8*//*Label 2284*/ GIMT_Encode4(137329),
     /*  128830 */ /*GILLT_nxv4s16*//*Label 2285*/ GIMT_Encode4(137444),
     /*  128834 */ /*GILLT_nxv4s32*//*Label 2286*/ GIMT_Encode4(137559),
     /*  128838 */ /*GILLT_nxv4s64*//*Label 2287*/ GIMT_Encode4(137674),
     /*  128842 */ /*GILLT_nxv8s1*//*Label 2288*/ GIMT_Encode4(137789),
     /*  128846 */ /*GILLT_nxv8s8*//*Label 2289*/ GIMT_Encode4(138400),
     /*  128850 */ /*GILLT_nxv8s16*//*Label 2290*/ GIMT_Encode4(138515),
     /*  128854 */ /*GILLT_nxv8s32*//*Label 2291*/ GIMT_Encode4(138630),
     /*  128858 */ /*GILLT_nxv8s64*//*Label 2292*/ GIMT_Encode4(138745),
     /*  128862 */ /*GILLT_nxv16s1*//*Label 2293*/ GIMT_Encode4(138860),
     /*  128866 */ /*GILLT_nxv16s8*//*Label 2294*/ GIMT_Encode4(139471),
     /*  128870 */ /*GILLT_nxv16s16*//*Label 2295*/ GIMT_Encode4(139586),
     /*  128874 */ /*GILLT_nxv16s32*//*Label 2296*/ GIMT_Encode4(139701),
     /*  128878 */ /*GILLT_nxv32s1*//*Label 2297*/ GIMT_Encode4(139816),
     /*  128882 */ /*GILLT_nxv32s8*//*Label 2298*/ GIMT_Encode4(140427),
     /*  128886 */ /*GILLT_nxv32s16*//*Label 2299*/ GIMT_Encode4(140542),
     /*  128890 */ /*GILLT_nxv64s1*//*Label 2300*/ GIMT_Encode4(140657),
     /*  128894 */ /*GILLT_nxv64s8*//*Label 2301*/ GIMT_Encode4(141268),
     /*  128898 */ // Label 2271: @128898
     /*  128898 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(131627),
     /*  128903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  128906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  128909 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(129104), // Rule ID 65583 //
     /*  128914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128953 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128969 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128977 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128981 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128985 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128989 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128993 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128997 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129001 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129005 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129009 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  129013 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129029 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129036 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129043 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  129060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  129065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  129084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  129089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129102 */     GIR_RootConstrainSelectedInstOperands,
     /*  129103 */     // GIR_Coverage, 65583,
     /*  129103 */     GIR_EraseRootFromParent_Done,
     /*  129104 */   // Label 2304: @129104
     /*  129104 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(129299), // Rule ID 65585 //
     /*  129109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  129136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129148 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129172 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129176 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129180 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129184 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129188 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129192 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129196 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129200 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129204 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129208 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129224 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129231 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129238 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  129279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129297 */     GIR_RootConstrainSelectedInstOperands,
     /*  129298 */     // GIR_Coverage, 65585,
     /*  129298 */     GIR_EraseRootFromParent_Done,
     /*  129299 */   // Label 2305: @129299
     /*  129299 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(129494), // Rule ID 65579 //
     /*  129304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129367 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129371 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129375 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129379 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  129383 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129387 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129391 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129395 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129399 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  129403 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129419 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129426 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129433 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  129450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  129455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129492 */     GIR_RootConstrainSelectedInstOperands,
     /*  129493 */     // GIR_Coverage, 65579,
     /*  129493 */     GIR_EraseRootFromParent_Done,
     /*  129494 */   // Label 2306: @129494
     /*  129494 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(129689), // Rule ID 65581 //
     /*  129499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129538 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129554 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129562 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129566 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129570 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129574 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129578 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129582 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129586 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129590 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129594 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129598 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129614 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129621 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129628 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129687 */     GIR_RootConstrainSelectedInstOperands,
     /*  129688 */     // GIR_Coverage, 65581,
     /*  129688 */     GIR_EraseRootFromParent_Done,
     /*  129689 */   // Label 2307: @129689
     /*  129689 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(129884), // Rule ID 65573 //
     /*  129694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129733 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129749 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129753 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129761 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129765 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129773 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129777 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129781 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129785 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129789 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129793 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129802 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129809 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129816 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129823 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129882 */     GIR_RootConstrainSelectedInstOperands,
     /*  129883 */     // GIR_Coverage, 65573,
     /*  129883 */     GIR_EraseRootFromParent_Done,
     /*  129884 */   // Label 2308: @129884
     /*  129884 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130079), // Rule ID 65577 //
     /*  129889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129928 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129944 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129948 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129960 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129964 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129968 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129972 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129976 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129980 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129984 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129988 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129997 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130004 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130011 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130018 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  130035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  130040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  130059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  130064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130077 */     GIR_RootConstrainSelectedInstOperands,
     /*  130078 */     // GIR_Coverage, 65577,
     /*  130078 */     GIR_EraseRootFromParent_Done,
     /*  130079 */   // Label 2309: @130079
     /*  130079 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130274), // Rule ID 2553 //
     /*  130084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130123 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  130131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130135 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  130139 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  130143 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  130147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  130151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130155 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  130159 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  130163 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  130167 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130171 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  130175 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  130179 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  130183 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130192 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130199 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130206 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130213 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  130230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  130235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  130254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  130259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130272 */     GIR_RootConstrainSelectedInstOperands,
     /*  130273 */     // GIR_Coverage, 2553,
     /*  130273 */     GIR_EraseRootFromParent_Done,
     /*  130274 */   // Label 2310: @130274
     /*  130274 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130469), // Rule ID 65575 //
     /*  130279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130318 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  130326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  130334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  130338 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  130342 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  130346 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130350 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  130354 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  130358 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  130362 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130366 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  130370 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  130374 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  130378 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130387 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130394 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130401 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130408 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  130408 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  130411 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130415 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  130425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  130430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  130449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  130454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130467 */     GIR_RootConstrainSelectedInstOperands,
     /*  130468 */     // GIR_Coverage, 65575,
     /*  130468 */     GIR_EraseRootFromParent_Done,
     /*  130469 */   // Label 2311: @130469
     /*  130469 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(130574), // Rule ID 2548 //
     /*  130474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130497 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  130501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130517 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130537 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130572 */     GIR_RootConstrainSelectedInstOperands,
     /*  130573 */     // GIR_Coverage, 2548,
     /*  130573 */     GIR_EraseRootFromParent_Done,
     /*  130574 */   // Label 2312: @130574
     /*  130574 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130679), // Rule ID 65568 //
     /*  130579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130602 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130622 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130642 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130677 */     GIR_RootConstrainSelectedInstOperands,
     /*  130678 */     // GIR_Coverage, 65568,
     /*  130678 */     GIR_EraseRootFromParent_Done,
     /*  130679 */   // Label 2313: @130679
     /*  130679 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(130768), // Rule ID 65562 //
     /*  130684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130728 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130732 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130752 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130766 */     GIR_RootConstrainSelectedInstOperands,
     /*  130767 */     // GIR_Coverage, 65562,
     /*  130767 */     GIR_EraseRootFromParent_Done,
     /*  130768 */   // Label 2314: @130768
     /*  130768 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(130857), // Rule ID 2542 //
     /*  130773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130817 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130821 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130841 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130855 */     GIR_RootConstrainSelectedInstOperands,
     /*  130856 */     // GIR_Coverage, 2542,
     /*  130856 */     GIR_EraseRootFromParent_Done,
     /*  130857 */   // Label 2315: @130857
     /*  130857 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(130922), // Rule ID 65564 //
     /*  130862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130885 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130905 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130920 */     GIR_RootConstrainSelectedInstOperands,
     /*  130921 */     // GIR_Coverage, 65564,
     /*  130921 */     GIR_EraseRootFromParent_Done,
     /*  130922 */   // Label 2316: @130922
     /*  130922 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(130987), // Rule ID 2544 //
     /*  130927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130970 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130985 */     GIR_RootConstrainSelectedInstOperands,
     /*  130986 */     // GIR_Coverage, 2544,
     /*  130986 */     GIR_EraseRootFromParent_Done,
     /*  130987 */   // Label 2317: @130987
     /*  130987 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131053), // Rule ID 65570 //
     /*  130992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  131024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  131028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131037 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131051 */     GIR_RootConstrainSelectedInstOperands,
     /*  131052 */     // GIR_Coverage, 65570,
     /*  131052 */     GIR_EraseRootFromParent_Done,
     /*  131053 */   // Label 2318: @131053
     /*  131053 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131119), // Rule ID 2550 //
     /*  131058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  131061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131086 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  131090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  131094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131103 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131117 */     GIR_RootConstrainSelectedInstOperands,
     /*  131118 */     // GIR_Coverage, 2550,
     /*  131118 */     GIR_EraseRootFromParent_Done,
     /*  131119 */   // Label 2319: @131119
     /*  131119 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131181), // Rule ID 2551 //
     /*  131124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  131127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131152 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  131156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  131165 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131179 */     GIR_RootConstrainSelectedInstOperands,
     /*  131180 */     // GIR_Coverage, 2551,
     /*  131180 */     GIR_EraseRootFromParent_Done,
     /*  131181 */   // Label 2320: @131181
     /*  131181 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131243), // Rule ID 65571 //
     /*  131186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  131189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  131218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  131227 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  131237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131241 */     GIR_RootConstrainSelectedInstOperands,
     /*  131242 */     // GIR_Coverage, 65571,
     /*  131242 */     GIR_EraseRootFromParent_Done,
     /*  131243 */   // Label 2321: @131243
     /*  131243 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(131302), // Rule ID 2477 //
     /*  131248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  131251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  131275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  131288 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  131291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  131300 */     GIR_RootConstrainSelectedInstOperands,
     /*  131301 */     // GIR_Coverage, 2477,
     /*  131301 */     GIR_EraseRootFromParent_Done,
     /*  131302 */   // Label 2322: @131302
     /*  131302 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(131361), // Rule ID 65558 //
     /*  131307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  131310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  131338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  131347 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  131350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  131359 */     GIR_RootConstrainSelectedInstOperands,
     /*  131360 */     // GIR_Coverage, 65558,
     /*  131360 */     GIR_EraseRootFromParent_Done,
     /*  131361 */   // Label 2323: @131361
     /*  131361 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(131417), // Rule ID 65542 //
     /*  131366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  131369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  131398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131404 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  131407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131415 */     GIR_RootConstrainSelectedInstOperands,
     /*  131416 */     // GIR_Coverage, 65542,
     /*  131416 */     GIR_EraseRootFromParent_Done,
     /*  131417 */   // Label 2324: @131417
     /*  131417 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(131473), // Rule ID 2449 //
     /*  131422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  131425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  131445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  131449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131454 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  131458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131460 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  131463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131471 */     GIR_RootConstrainSelectedInstOperands,
     /*  131472 */     // GIR_Coverage, 2449,
     /*  131472 */     GIR_EraseRootFromParent_Done,
     /*  131473 */   // Label 2325: @131473
     /*  131473 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(131515), // Rule ID 87 //
     /*  131478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  131501 */     // MIs[1] Operand 1
     /*  131501 */     // No operand predicates
     /*  131501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131503 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131513 */     GIR_RootConstrainSelectedInstOperands,
     /*  131514 */     // GIR_Coverage, 87,
     /*  131514 */     GIR_EraseRootFromParent_Done,
     /*  131515 */   // Label 2326: @131515
     /*  131515 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(131557), // Rule ID 64539 //
     /*  131520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  131543 */     // MIs[1] Operand 1
     /*  131543 */     // No operand predicates
     /*  131543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131545 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  131545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  131548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  131550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131555 */     GIR_RootConstrainSelectedInstOperands,
     /*  131556 */     // GIR_Coverage, 64539,
     /*  131556 */     GIR_EraseRootFromParent_Done,
     /*  131557 */   // Label 2327: @131557
     /*  131557 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(131599), // Rule ID 64543 //
     /*  131562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  131585 */     // MIs[1] Operand 1
     /*  131585 */     // No operand predicates
     /*  131585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131587 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  131587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  131590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131597 */     GIR_RootConstrainSelectedInstOperands,
     /*  131598 */     // GIR_Coverage, 64543,
     /*  131598 */     GIR_EraseRootFromParent_Done,
     /*  131599 */   // Label 2328: @131599
     /*  131599 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(131626), // Rule ID 85 //
     /*  131604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131619 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  131624 */     GIR_RootConstrainSelectedInstOperands,
     /*  131625 */     // GIR_Coverage, 85,
     /*  131625 */     GIR_Done,
     /*  131626 */   // Label 2329: @131626
     /*  131626 */   GIM_Reject,
     /*  131627 */ // Label 2303: @131627
     /*  131627 */ GIM_Reject,
     /*  131628 */ // Label 2272: @131628
     /*  131628 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(134575),
     /*  131633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  131636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  131639 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(131834), // Rule ID 65582 //
     /*  131644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131683 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131707 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131711 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131715 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131719 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131723 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131727 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131731 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131735 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131739 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131743 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131759 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131766 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131773 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131832 */     GIR_RootConstrainSelectedInstOperands,
     /*  131833 */     // GIR_Coverage, 65582,
     /*  131833 */     GIR_EraseRootFromParent_Done,
     /*  131834 */   // Label 2331: @131834
     /*  131834 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132029), // Rule ID 65584 //
     /*  131839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131902 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131906 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131910 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131914 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131918 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131922 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131926 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131930 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131934 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131938 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131954 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131961 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131968 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  132009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  132014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132027 */     GIR_RootConstrainSelectedInstOperands,
     /*  132028 */     // GIR_Coverage, 65584,
     /*  132028 */     GIR_EraseRootFromParent_Done,
     /*  132029 */   // Label 2332: @132029
     /*  132029 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(132224), // Rule ID 65578 //
     /*  132034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132073 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  132081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132093 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  132097 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132101 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132105 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132109 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  132113 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  132117 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132121 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132125 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132129 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  132133 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132149 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132156 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132163 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  132180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  132185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  132204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  132209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132222 */     GIR_RootConstrainSelectedInstOperands,
     /*  132223 */     // GIR_Coverage, 65578,
     /*  132223 */     GIR_EraseRootFromParent_Done,
     /*  132224 */   // Label 2333: @132224
     /*  132224 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(132419), // Rule ID 65580 //
     /*  132229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  132276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132284 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  132292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132296 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132300 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132304 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  132308 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  132312 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132316 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132320 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132324 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  132328 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132344 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132351 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132358 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  132375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  132380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  132399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  132404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132417 */     GIR_RootConstrainSelectedInstOperands,
     /*  132418 */     // GIR_Coverage, 65580,
     /*  132418 */     GIR_EraseRootFromParent_Done,
     /*  132419 */   // Label 2334: @132419
     /*  132419 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(132614), // Rule ID 65572 //
     /*  132424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132463 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132483 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132511 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132515 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132519 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132523 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132532 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132539 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132546 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132553 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132612 */     GIR_RootConstrainSelectedInstOperands,
     /*  132613 */     // GIR_Coverage, 65572,
     /*  132613 */     GIR_EraseRootFromParent_Done,
     /*  132614 */   // Label 2335: @132614
     /*  132614 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(132809), // Rule ID 65576 //
     /*  132619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132678 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132694 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132698 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132702 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132706 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132710 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132714 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132718 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132727 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132734 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132741 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132748 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132807 */     GIR_RootConstrainSelectedInstOperands,
     /*  132808 */     // GIR_Coverage, 65576,
     /*  132808 */     GIR_EraseRootFromParent_Done,
     /*  132809 */   // Label 2336: @132809
     /*  132809 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133004), // Rule ID 2552 //
     /*  132814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132853 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132865 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132869 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132873 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132877 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132881 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132885 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132889 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132893 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132897 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132901 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132905 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132909 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132913 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132922 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132929 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132936 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132943 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132943 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132946 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132950 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  133002 */     GIR_RootConstrainSelectedInstOperands,
     /*  133003 */     // GIR_Coverage, 2552,
     /*  133003 */     GIR_EraseRootFromParent_Done,
     /*  133004 */   // Label 2337: @133004
     /*  133004 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133199), // Rule ID 65574 //
     /*  133009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  133012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  133024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133048 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  133056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  133064 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  133068 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  133072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  133076 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  133080 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  133084 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  133088 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  133092 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133096 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  133100 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  133104 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  133108 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  133110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133117 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133124 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  133131 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  133138 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  133138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  133141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  133155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  133160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  133162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  133179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  133184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  133197 */     GIR_RootConstrainSelectedInstOperands,
     /*  133198 */     // GIR_Coverage, 65574,
     /*  133198 */     GIR_EraseRootFromParent_Done,
     /*  133199 */   // Label 2338: @133199
     /*  133199 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133304), // Rule ID 2547 //
     /*  133204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133227 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  133231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  133235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133247 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133267 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  133267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  133294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  133302 */     GIR_RootConstrainSelectedInstOperands,
     /*  133303 */     // GIR_Coverage, 2547,
     /*  133303 */     GIR_EraseRootFromParent_Done,
     /*  133304 */   // Label 2339: @133304
     /*  133304 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133409), // Rule ID 65567 //
     /*  133309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133332 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  133340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  133356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133372 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  133372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  133375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  133399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  133407 */     GIR_RootConstrainSelectedInstOperands,
     /*  133408 */     // GIR_Coverage, 65567,
     /*  133408 */     GIR_EraseRootFromParent_Done,
     /*  133409 */   // Label 2340: @133409
     /*  133409 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133498), // Rule ID 65561 //
     /*  133414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133458 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133462 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133482 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133496 */     GIR_RootConstrainSelectedInstOperands,
     /*  133497 */     // GIR_Coverage, 65561,
     /*  133497 */     GIR_EraseRootFromParent_Done,
     /*  133498 */   // Label 2341: @133498
     /*  133498 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133587), // Rule ID 2541 //
     /*  133503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133551 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133571 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133585 */     GIR_RootConstrainSelectedInstOperands,
     /*  133586 */     // GIR_Coverage, 2541,
     /*  133586 */     GIR_EraseRootFromParent_Done,
     /*  133587 */   // Label 2342: @133587
     /*  133587 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133652), // Rule ID 65563 //
     /*  133592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133615 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133635 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133650 */     GIR_RootConstrainSelectedInstOperands,
     /*  133651 */     // GIR_Coverage, 65563,
     /*  133651 */     GIR_EraseRootFromParent_Done,
     /*  133652 */   // Label 2343: @133652
     /*  133652 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133717), // Rule ID 2543 //
     /*  133657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133700 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133715 */     GIR_RootConstrainSelectedInstOperands,
     /*  133716 */     // GIR_Coverage, 2543,
     /*  133716 */     GIR_EraseRootFromParent_Done,
     /*  133717 */   // Label 2344: @133717
     /*  133717 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133802), // Rule ID 65588 //
     /*  133722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133762 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133766 */     // MIs[1] Operand 2
     /*  133766 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133786 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133800 */     GIR_RootConstrainSelectedInstOperands,
     /*  133801 */     // GIR_Coverage, 65588,
     /*  133801 */     GIR_EraseRootFromParent_Done,
     /*  133802 */   // Label 2345: @133802
     /*  133802 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133887), // Rule ID 2556 //
     /*  133807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133847 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133851 */     // MIs[1] Operand 2
     /*  133851 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133871 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133885 */     GIR_RootConstrainSelectedInstOperands,
     /*  133886 */     // GIR_Coverage, 2556,
     /*  133886 */     GIR_EraseRootFromParent_Done,
     /*  133887 */   // Label 2346: @133887
     /*  133887 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(133953), // Rule ID 65569 //
     /*  133892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  133928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133937 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133951 */     GIR_RootConstrainSelectedInstOperands,
     /*  133952 */     // GIR_Coverage, 65569,
     /*  133952 */     GIR_EraseRootFromParent_Done,
     /*  133953 */   // Label 2347: @133953
     /*  133953 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134019), // Rule ID 65587 //
     /*  133958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133986 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10095),
     /*  133994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  134003 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10095>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  134006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134017 */     GIR_RootConstrainSelectedInstOperands,
     /*  134018 */     // GIR_Coverage, 65587,
     /*  134018 */     GIR_EraseRootFromParent_Done,
     /*  134019 */   // Label 2348: @134019
     /*  134019 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134085), // Rule ID 2549 //
     /*  134024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  134027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  134056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11319),
     /*  134060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  134069 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11319>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  134072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134083 */     GIR_RootConstrainSelectedInstOperands,
     /*  134084 */     // GIR_Coverage, 2549,
     /*  134084 */     GIR_EraseRootFromParent_Done,
     /*  134085 */   // Label 2349: @134085
     /*  134085 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134151), // Rule ID 2555 //
     /*  134090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  134122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10095),
     /*  134126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  134135 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10095>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  134138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134149 */     GIR_RootConstrainSelectedInstOperands,
     /*  134150 */     // GIR_Coverage, 2555,
     /*  134150 */     GIR_EraseRootFromParent_Done,
     /*  134151 */   // Label 2350: @134151
     /*  134151 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134213), // Rule ID 2554 //
     /*  134156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  134188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  134197 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  134200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134211 */     GIR_RootConstrainSelectedInstOperands,
     /*  134212 */     // GIR_Coverage, 2554,
     /*  134212 */     GIR_EraseRootFromParent_Done,
     /*  134213 */   // Label 2351: @134213
     /*  134213 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134275), // Rule ID 65586 //
     /*  134218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  134221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134246 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  134250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  134259 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  134262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  134269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134273 */     GIR_RootConstrainSelectedInstOperands,
     /*  134274 */     // GIR_Coverage, 65586,
     /*  134274 */     GIR_EraseRootFromParent_Done,
     /*  134275 */   // Label 2352: @134275
     /*  134275 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134334), // Rule ID 2476 //
     /*  134280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  134283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  134307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  134320 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  134323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  134332 */     GIR_RootConstrainSelectedInstOperands,
     /*  134333 */     // GIR_Coverage, 2476,
     /*  134333 */     GIR_EraseRootFromParent_Done,
     /*  134334 */   // Label 2353: @134334
     /*  134334 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134393), // Rule ID 65557 //
     /*  134339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  134342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  134358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  134370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  134379 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  134382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  134391 */     GIR_RootConstrainSelectedInstOperands,
     /*  134392 */     // GIR_Coverage, 65557,
     /*  134392 */     GIR_EraseRootFromParent_Done,
     /*  134393 */   // Label 2354: @134393
     /*  134393 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134449), // Rule ID 65541 //
     /*  134398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  134401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134426 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134436 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134447 */     GIR_RootConstrainSelectedInstOperands,
     /*  134448 */     // GIR_Coverage, 65541,
     /*  134448 */     GIR_EraseRootFromParent_Done,
     /*  134449 */   // Label 2355: @134449
     /*  134449 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134505), // Rule ID 2448 //
     /*  134454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  134457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134486 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134492 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134503 */     GIR_RootConstrainSelectedInstOperands,
     /*  134504 */     // GIR_Coverage, 2448,
     /*  134504 */     GIR_EraseRootFromParent_Done,
     /*  134505 */   // Label 2356: @134505
     /*  134505 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134547), // Rule ID 86 //
     /*  134510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  134533 */     // MIs[1] Operand 1
     /*  134533 */     // No operand predicates
     /*  134533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134535 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  134535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  134538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  134545 */     GIR_RootConstrainSelectedInstOperands,
     /*  134546 */     // GIR_Coverage, 86,
     /*  134546 */     GIR_EraseRootFromParent_Done,
     /*  134547 */   // Label 2357: @134547
     /*  134547 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134574), // Rule ID 84 //
     /*  134552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134567 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  134572 */     GIR_RootConstrainSelectedInstOperands,
     /*  134573 */     // GIR_Coverage, 84,
     /*  134573 */     GIR_Done,
     /*  134574 */   // Label 2358: @134574
     /*  134574 */   GIM_Reject,
     /*  134575 */ // Label 2330: @134575
     /*  134575 */ GIM_Reject,
     /*  134576 */ // Label 2273: @134576
     /*  134576 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135186),
     /*  134581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134591 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134657), // Rule ID 71771 //
     /*  134596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134638 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134655 */     GIR_RootConstrainSelectedInstOperands,
     /*  134656 */     // GIR_Coverage, 71771,
     /*  134656 */     GIR_EraseRootFromParent_Done,
     /*  134657 */   // Label 2360: @134657
     /*  134657 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134723), // Rule ID 71772 //
     /*  134662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134704 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134721 */     GIR_RootConstrainSelectedInstOperands,
     /*  134722 */     // GIR_Coverage, 71772,
     /*  134722 */     GIR_EraseRootFromParent_Done,
     /*  134723 */   // Label 2361: @134723
     /*  134723 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134789), // Rule ID 71769 //
     /*  134728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134770 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134787 */     GIR_RootConstrainSelectedInstOperands,
     /*  134788 */     // GIR_Coverage, 71769,
     /*  134788 */     GIR_EraseRootFromParent_Done,
     /*  134789 */   // Label 2362: @134789
     /*  134789 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134855), // Rule ID 71770 //
     /*  134794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134836 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134853 */     GIR_RootConstrainSelectedInstOperands,
     /*  134854 */     // GIR_Coverage, 71770,
     /*  134854 */     GIR_EraseRootFromParent_Done,
     /*  134855 */   // Label 2363: @134855
     /*  134855 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(134921), // Rule ID 71767 //
     /*  134860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134902 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134919 */     GIR_RootConstrainSelectedInstOperands,
     /*  134920 */     // GIR_Coverage, 71767,
     /*  134920 */     GIR_EraseRootFromParent_Done,
     /*  134921 */   // Label 2364: @134921
     /*  134921 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134987), // Rule ID 71768 //
     /*  134926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134968 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134985 */     GIR_RootConstrainSelectedInstOperands,
     /*  134986 */     // GIR_Coverage, 71768,
     /*  134986 */     GIR_EraseRootFromParent_Done,
     /*  134987 */   // Label 2365: @134987
     /*  134987 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135053), // Rule ID 53178 //
     /*  134992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  135011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  135015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135034 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  135037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135051 */     GIR_RootConstrainSelectedInstOperands,
     /*  135052 */     // GIR_Coverage, 53178,
     /*  135052 */     GIR_EraseRootFromParent_Done,
     /*  135053 */   // Label 2366: @135053
     /*  135053 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135119), // Rule ID 53179 //
     /*  135058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  135077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  135081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135100 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  135103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135117 */     GIR_RootConstrainSelectedInstOperands,
     /*  135118 */     // GIR_Coverage, 53179,
     /*  135118 */     GIR_EraseRootFromParent_Done,
     /*  135119 */   // Label 2367: @135119
     /*  135119 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135152), // Rule ID 53166 //
     /*  135124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135135 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  135138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135150 */     GIR_RootConstrainSelectedInstOperands,
     /*  135151 */     // GIR_Coverage, 53166,
     /*  135151 */     GIR_EraseRootFromParent_Done,
     /*  135152 */   // Label 2368: @135152
     /*  135152 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135185), // Rule ID 53167 //
     /*  135157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135168 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  135171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135183 */     GIR_RootConstrainSelectedInstOperands,
     /*  135184 */     // GIR_Coverage, 53167,
     /*  135184 */     GIR_EraseRootFromParent_Done,
     /*  135185 */   // Label 2369: @135185
     /*  135185 */   GIM_Reject,
     /*  135186 */ // Label 2359: @135186
     /*  135186 */ GIM_Reject,
     /*  135187 */ // Label 2274: @135187
     /*  135187 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135301),
     /*  135192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  135195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  135198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135210 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135255), // Rule ID 47788 //
     /*  135215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135218 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  135221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  135235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135253 */     GIR_RootConstrainSelectedInstOperands,
     /*  135254 */     // GIR_Coverage, 47788,
     /*  135254 */     GIR_EraseRootFromParent_Done,
     /*  135255 */   // Label 2371: @135255
     /*  135255 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135300), // Rule ID 47789 //
     /*  135260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135263 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  135266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  135280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135298 */     GIR_RootConstrainSelectedInstOperands,
     /*  135299 */     // GIR_Coverage, 47789,
     /*  135299 */     GIR_EraseRootFromParent_Done,
     /*  135300 */   // Label 2372: @135300
     /*  135300 */   GIM_Reject,
     /*  135301 */ // Label 2370: @135301
     /*  135301 */ GIM_Reject,
     /*  135302 */ // Label 2275: @135302
     /*  135302 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135416),
     /*  135307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  135310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  135313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135325 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135370), // Rule ID 47800 //
     /*  135330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135333 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  135336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135368 */     GIR_RootConstrainSelectedInstOperands,
     /*  135369 */     // GIR_Coverage, 47800,
     /*  135369 */     GIR_EraseRootFromParent_Done,
     /*  135370 */   // Label 2374: @135370
     /*  135370 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135415), // Rule ID 47801 //
     /*  135375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135378 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  135381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135413 */     GIR_RootConstrainSelectedInstOperands,
     /*  135414 */     // GIR_Coverage, 47801,
     /*  135414 */     GIR_EraseRootFromParent_Done,
     /*  135415 */   // Label 2375: @135415
     /*  135415 */   GIM_Reject,
     /*  135416 */ // Label 2373: @135416
     /*  135416 */ GIM_Reject,
     /*  135417 */ // Label 2276: @135417
     /*  135417 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135531),
     /*  135422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  135425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  135428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135440 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135485), // Rule ID 47808 //
     /*  135445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135448 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  135448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135483 */     GIR_RootConstrainSelectedInstOperands,
     /*  135484 */     // GIR_Coverage, 47808,
     /*  135484 */     GIR_EraseRootFromParent_Done,
     /*  135485 */   // Label 2377: @135485
     /*  135485 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135530), // Rule ID 47809 //
     /*  135490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135493 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135528 */     GIR_RootConstrainSelectedInstOperands,
     /*  135529 */     // GIR_Coverage, 47809,
     /*  135529 */     GIR_EraseRootFromParent_Done,
     /*  135530 */   // Label 2378: @135530
     /*  135530 */   GIM_Reject,
     /*  135531 */ // Label 2376: @135531
     /*  135531 */ GIM_Reject,
     /*  135532 */ // Label 2277: @135532
     /*  135532 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135646),
     /*  135537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  135540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  135543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135555 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135600), // Rule ID 47824 //
     /*  135560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135563 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135598 */     GIR_RootConstrainSelectedInstOperands,
     /*  135599 */     // GIR_Coverage, 47824,
     /*  135599 */     GIR_EraseRootFromParent_Done,
     /*  135600 */   // Label 2380: @135600
     /*  135600 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135645), // Rule ID 47825 //
     /*  135605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135608 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135643 */     GIR_RootConstrainSelectedInstOperands,
     /*  135644 */     // GIR_Coverage, 47825,
     /*  135644 */     GIR_EraseRootFromParent_Done,
     /*  135645 */   // Label 2381: @135645
     /*  135645 */   GIM_Reject,
     /*  135646 */ // Label 2379: @135646
     /*  135646 */ GIM_Reject,
     /*  135647 */ // Label 2278: @135647
     /*  135647 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136257),
     /*  135652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135662 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135728), // Rule ID 71799 //
     /*  135667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135709 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135726 */     GIR_RootConstrainSelectedInstOperands,
     /*  135727 */     // GIR_Coverage, 71799,
     /*  135727 */     GIR_EraseRootFromParent_Done,
     /*  135728 */   // Label 2383: @135728
     /*  135728 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135794), // Rule ID 71800 //
     /*  135733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135775 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135792 */     GIR_RootConstrainSelectedInstOperands,
     /*  135793 */     // GIR_Coverage, 71800,
     /*  135793 */     GIR_EraseRootFromParent_Done,
     /*  135794 */   // Label 2384: @135794
     /*  135794 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135860), // Rule ID 71797 //
     /*  135799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135841 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135858 */     GIR_RootConstrainSelectedInstOperands,
     /*  135859 */     // GIR_Coverage, 71797,
     /*  135859 */     GIR_EraseRootFromParent_Done,
     /*  135860 */   // Label 2385: @135860
     /*  135860 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135926), // Rule ID 71798 //
     /*  135865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135907 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135924 */     GIR_RootConstrainSelectedInstOperands,
     /*  135925 */     // GIR_Coverage, 71798,
     /*  135925 */     GIR_EraseRootFromParent_Done,
     /*  135926 */   // Label 2386: @135926
     /*  135926 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(135992), // Rule ID 71795 //
     /*  135931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135973 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135990 */     GIR_RootConstrainSelectedInstOperands,
     /*  135991 */     // GIR_Coverage, 71795,
     /*  135991 */     GIR_EraseRootFromParent_Done,
     /*  135992 */   // Label 2387: @135992
     /*  135992 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136058), // Rule ID 71796 //
     /*  135997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136039 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136056 */     GIR_RootConstrainSelectedInstOperands,
     /*  136057 */     // GIR_Coverage, 71796,
     /*  136057 */     GIR_EraseRootFromParent_Done,
     /*  136058 */   // Label 2388: @136058
     /*  136058 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(136124), // Rule ID 53196 //
     /*  136063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136105 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136122 */     GIR_RootConstrainSelectedInstOperands,
     /*  136123 */     // GIR_Coverage, 53196,
     /*  136123 */     GIR_EraseRootFromParent_Done,
     /*  136124 */   // Label 2389: @136124
     /*  136124 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(136190), // Rule ID 53197 //
     /*  136129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  136148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  136152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136171 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  136174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136188 */     GIR_RootConstrainSelectedInstOperands,
     /*  136189 */     // GIR_Coverage, 53197,
     /*  136189 */     GIR_EraseRootFromParent_Done,
     /*  136190 */   // Label 2390: @136190
     /*  136190 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(136223), // Rule ID 53184 //
     /*  136195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136206 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  136209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136221 */     GIR_RootConstrainSelectedInstOperands,
     /*  136222 */     // GIR_Coverage, 53184,
     /*  136222 */     GIR_EraseRootFromParent_Done,
     /*  136223 */   // Label 2391: @136223
     /*  136223 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136256), // Rule ID 53185 //
     /*  136228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136239 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  136242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136254 */     GIR_RootConstrainSelectedInstOperands,
     /*  136255 */     // GIR_Coverage, 53185,
     /*  136255 */     GIR_EraseRootFromParent_Done,
     /*  136256 */   // Label 2392: @136256
     /*  136256 */   GIM_Reject,
     /*  136257 */ // Label 2382: @136257
     /*  136257 */ GIM_Reject,
     /*  136258 */ // Label 2279: @136258
     /*  136258 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136372),
     /*  136263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  136266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  136269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136281 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136326), // Rule ID 47792 //
     /*  136286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136289 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  136292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  136306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136324 */     GIR_RootConstrainSelectedInstOperands,
     /*  136325 */     // GIR_Coverage, 47792,
     /*  136325 */     GIR_EraseRootFromParent_Done,
     /*  136326 */   // Label 2394: @136326
     /*  136326 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136371), // Rule ID 47793 //
     /*  136331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136334 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  136337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  136351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136369 */     GIR_RootConstrainSelectedInstOperands,
     /*  136370 */     // GIR_Coverage, 47793,
     /*  136370 */     GIR_EraseRootFromParent_Done,
     /*  136371 */   // Label 2395: @136371
     /*  136371 */   GIM_Reject,
     /*  136372 */ // Label 2393: @136372
     /*  136372 */ GIM_Reject,
     /*  136373 */ // Label 2280: @136373
     /*  136373 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136487),
     /*  136378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  136381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  136384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136396 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136441), // Rule ID 47804 //
     /*  136401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136404 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  136404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  136407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136439 */     GIR_RootConstrainSelectedInstOperands,
     /*  136440 */     // GIR_Coverage, 47804,
     /*  136440 */     GIR_EraseRootFromParent_Done,
     /*  136441 */   // Label 2397: @136441
     /*  136441 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136486), // Rule ID 47805 //
     /*  136446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136449 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  136449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  136452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136484 */     GIR_RootConstrainSelectedInstOperands,
     /*  136485 */     // GIR_Coverage, 47805,
     /*  136485 */     GIR_EraseRootFromParent_Done,
     /*  136486 */   // Label 2398: @136486
     /*  136486 */   GIM_Reject,
     /*  136487 */ // Label 2396: @136487
     /*  136487 */ GIM_Reject,
     /*  136488 */ // Label 2281: @136488
     /*  136488 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136602),
     /*  136493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  136496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136511 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136556), // Rule ID 47820 //
     /*  136516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136519 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136554 */     GIR_RootConstrainSelectedInstOperands,
     /*  136555 */     // GIR_Coverage, 47820,
     /*  136555 */     GIR_EraseRootFromParent_Done,
     /*  136556 */   // Label 2400: @136556
     /*  136556 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136601), // Rule ID 47821 //
     /*  136561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136564 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136599 */     GIR_RootConstrainSelectedInstOperands,
     /*  136600 */     // GIR_Coverage, 47821,
     /*  136600 */     GIR_EraseRootFromParent_Done,
     /*  136601 */   // Label 2401: @136601
     /*  136601 */   GIM_Reject,
     /*  136602 */ // Label 2399: @136602
     /*  136602 */ GIM_Reject,
     /*  136603 */ // Label 2282: @136603
     /*  136603 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136717),
     /*  136608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  136611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  136614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136626 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136671), // Rule ID 47864 //
     /*  136631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136634 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136669 */     GIR_RootConstrainSelectedInstOperands,
     /*  136670 */     // GIR_Coverage, 47864,
     /*  136670 */     GIR_EraseRootFromParent_Done,
     /*  136671 */   // Label 2403: @136671
     /*  136671 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136716), // Rule ID 47865 //
     /*  136676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136679 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136714 */     GIR_RootConstrainSelectedInstOperands,
     /*  136715 */     // GIR_Coverage, 47865,
     /*  136715 */     GIR_EraseRootFromParent_Done,
     /*  136716 */   // Label 2404: @136716
     /*  136716 */   GIM_Reject,
     /*  136717 */ // Label 2402: @136717
     /*  136717 */ GIM_Reject,
     /*  136718 */ // Label 2283: @136718
     /*  136718 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(137328),
     /*  136723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136733 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136799), // Rule ID 71827 //
     /*  136738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136780 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136797 */     GIR_RootConstrainSelectedInstOperands,
     /*  136798 */     // GIR_Coverage, 71827,
     /*  136798 */     GIR_EraseRootFromParent_Done,
     /*  136799 */   // Label 2406: @136799
     /*  136799 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136865), // Rule ID 71828 //
     /*  136804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136846 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136863 */     GIR_RootConstrainSelectedInstOperands,
     /*  136864 */     // GIR_Coverage, 71828,
     /*  136864 */     GIR_EraseRootFromParent_Done,
     /*  136865 */   // Label 2407: @136865
     /*  136865 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136931), // Rule ID 71825 //
     /*  136870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136912 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136929 */     GIR_RootConstrainSelectedInstOperands,
     /*  136930 */     // GIR_Coverage, 71825,
     /*  136930 */     GIR_EraseRootFromParent_Done,
     /*  136931 */   // Label 2408: @136931
     /*  136931 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(136997), // Rule ID 71826 //
     /*  136936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136978 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136995 */     GIR_RootConstrainSelectedInstOperands,
     /*  136996 */     // GIR_Coverage, 71826,
     /*  136996 */     GIR_EraseRootFromParent_Done,
     /*  136997 */   // Label 2409: @136997
     /*  136997 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(137063), // Rule ID 71823 //
     /*  137002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137044 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137061 */     GIR_RootConstrainSelectedInstOperands,
     /*  137062 */     // GIR_Coverage, 71823,
     /*  137062 */     GIR_EraseRootFromParent_Done,
     /*  137063 */   // Label 2410: @137063
     /*  137063 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(137129), // Rule ID 71824 //
     /*  137068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137110 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137127 */     GIR_RootConstrainSelectedInstOperands,
     /*  137128 */     // GIR_Coverage, 71824,
     /*  137128 */     GIR_EraseRootFromParent_Done,
     /*  137129 */   // Label 2411: @137129
     /*  137129 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(137195), // Rule ID 53214 //
     /*  137134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137176 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137193 */     GIR_RootConstrainSelectedInstOperands,
     /*  137194 */     // GIR_Coverage, 53214,
     /*  137194 */     GIR_EraseRootFromParent_Done,
     /*  137195 */   // Label 2412: @137195
     /*  137195 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137261), // Rule ID 53215 //
     /*  137200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  137219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  137223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137242 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  137245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137259 */     GIR_RootConstrainSelectedInstOperands,
     /*  137260 */     // GIR_Coverage, 53215,
     /*  137260 */     GIR_EraseRootFromParent_Done,
     /*  137261 */   // Label 2413: @137261
     /*  137261 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137294), // Rule ID 53202 //
     /*  137266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137277 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  137280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137292 */     GIR_RootConstrainSelectedInstOperands,
     /*  137293 */     // GIR_Coverage, 53202,
     /*  137293 */     GIR_EraseRootFromParent_Done,
     /*  137294 */   // Label 2414: @137294
     /*  137294 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137327), // Rule ID 53203 //
     /*  137299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137310 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  137313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137325 */     GIR_RootConstrainSelectedInstOperands,
     /*  137326 */     // GIR_Coverage, 53203,
     /*  137326 */     GIR_EraseRootFromParent_Done,
     /*  137327 */   // Label 2415: @137327
     /*  137327 */   GIM_Reject,
     /*  137328 */ // Label 2405: @137328
     /*  137328 */ GIM_Reject,
     /*  137329 */ // Label 2284: @137329
     /*  137329 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137443),
     /*  137334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  137337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  137340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137352 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137397), // Rule ID 47796 //
     /*  137357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137360 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  137363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  137377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137395 */     GIR_RootConstrainSelectedInstOperands,
     /*  137396 */     // GIR_Coverage, 47796,
     /*  137396 */     GIR_EraseRootFromParent_Done,
     /*  137397 */   // Label 2417: @137397
     /*  137397 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137442), // Rule ID 47797 //
     /*  137402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137405 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  137405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  137408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  137422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137440 */     GIR_RootConstrainSelectedInstOperands,
     /*  137441 */     // GIR_Coverage, 47797,
     /*  137441 */     GIR_EraseRootFromParent_Done,
     /*  137442 */   // Label 2418: @137442
     /*  137442 */   GIM_Reject,
     /*  137443 */ // Label 2416: @137443
     /*  137443 */ GIM_Reject,
     /*  137444 */ // Label 2285: @137444
     /*  137444 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137558),
     /*  137449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  137452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  137455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137467 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137512), // Rule ID 47816 //
     /*  137472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137475 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137510 */     GIR_RootConstrainSelectedInstOperands,
     /*  137511 */     // GIR_Coverage, 47816,
     /*  137511 */     GIR_EraseRootFromParent_Done,
     /*  137512 */   // Label 2420: @137512
     /*  137512 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137557), // Rule ID 47817 //
     /*  137517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137520 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137555 */     GIR_RootConstrainSelectedInstOperands,
     /*  137556 */     // GIR_Coverage, 47817,
     /*  137556 */     GIR_EraseRootFromParent_Done,
     /*  137557 */   // Label 2421: @137557
     /*  137557 */   GIM_Reject,
     /*  137558 */ // Label 2419: @137558
     /*  137558 */ GIM_Reject,
     /*  137559 */ // Label 2286: @137559
     /*  137559 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137673),
     /*  137564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  137567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137582 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137627), // Rule ID 47852 //
     /*  137587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137590 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137625 */     GIR_RootConstrainSelectedInstOperands,
     /*  137626 */     // GIR_Coverage, 47852,
     /*  137626 */     GIR_EraseRootFromParent_Done,
     /*  137627 */   // Label 2423: @137627
     /*  137627 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137672), // Rule ID 47853 //
     /*  137632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137635 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137670 */     GIR_RootConstrainSelectedInstOperands,
     /*  137671 */     // GIR_Coverage, 47853,
     /*  137671 */     GIR_EraseRootFromParent_Done,
     /*  137672 */   // Label 2424: @137672
     /*  137672 */   GIM_Reject,
     /*  137673 */ // Label 2422: @137673
     /*  137673 */ GIM_Reject,
     /*  137674 */ // Label 2287: @137674
     /*  137674 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137788),
     /*  137679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  137682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  137685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137697 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137742), // Rule ID 47868 //
     /*  137702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137705 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137740 */     GIR_RootConstrainSelectedInstOperands,
     /*  137741 */     // GIR_Coverage, 47868,
     /*  137741 */     GIR_EraseRootFromParent_Done,
     /*  137742 */   // Label 2426: @137742
     /*  137742 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137787), // Rule ID 47869 //
     /*  137747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137750 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137785 */     GIR_RootConstrainSelectedInstOperands,
     /*  137786 */     // GIR_Coverage, 47869,
     /*  137786 */     GIR_EraseRootFromParent_Done,
     /*  137787 */   // Label 2427: @137787
     /*  137787 */   GIM_Reject,
     /*  137788 */ // Label 2425: @137788
     /*  137788 */ GIM_Reject,
     /*  137789 */ // Label 2288: @137789
     /*  137789 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(138399),
     /*  137794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137804 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137870), // Rule ID 71855 //
     /*  137809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137851 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137868 */     GIR_RootConstrainSelectedInstOperands,
     /*  137869 */     // GIR_Coverage, 71855,
     /*  137869 */     GIR_EraseRootFromParent_Done,
     /*  137870 */   // Label 2429: @137870
     /*  137870 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137936), // Rule ID 71856 //
     /*  137875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137917 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137934 */     GIR_RootConstrainSelectedInstOperands,
     /*  137935 */     // GIR_Coverage, 71856,
     /*  137935 */     GIR_EraseRootFromParent_Done,
     /*  137936 */   // Label 2430: @137936
     /*  137936 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(138002), // Rule ID 71853 //
     /*  137941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137983 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138000 */     GIR_RootConstrainSelectedInstOperands,
     /*  138001 */     // GIR_Coverage, 71853,
     /*  138001 */     GIR_EraseRootFromParent_Done,
     /*  138002 */   // Label 2431: @138002
     /*  138002 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(138068), // Rule ID 71854 //
     /*  138007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138049 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138066 */     GIR_RootConstrainSelectedInstOperands,
     /*  138067 */     // GIR_Coverage, 71854,
     /*  138067 */     GIR_EraseRootFromParent_Done,
     /*  138068 */   // Label 2432: @138068
     /*  138068 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138134), // Rule ID 71851 //
     /*  138073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138115 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138132 */     GIR_RootConstrainSelectedInstOperands,
     /*  138133 */     // GIR_Coverage, 71851,
     /*  138133 */     GIR_EraseRootFromParent_Done,
     /*  138134 */   // Label 2433: @138134
     /*  138134 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(138200), // Rule ID 71852 //
     /*  138139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138181 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138198 */     GIR_RootConstrainSelectedInstOperands,
     /*  138199 */     // GIR_Coverage, 71852,
     /*  138199 */     GIR_EraseRootFromParent_Done,
     /*  138200 */   // Label 2434: @138200
     /*  138200 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138266), // Rule ID 53232 //
     /*  138205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138247 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138264 */     GIR_RootConstrainSelectedInstOperands,
     /*  138265 */     // GIR_Coverage, 53232,
     /*  138265 */     GIR_EraseRootFromParent_Done,
     /*  138266 */   // Label 2435: @138266
     /*  138266 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138332), // Rule ID 53233 //
     /*  138271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  138290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  138294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138313 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  138316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138330 */     GIR_RootConstrainSelectedInstOperands,
     /*  138331 */     // GIR_Coverage, 53233,
     /*  138331 */     GIR_EraseRootFromParent_Done,
     /*  138332 */   // Label 2436: @138332
     /*  138332 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138365), // Rule ID 53220 //
     /*  138337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138348 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  138351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138363 */     GIR_RootConstrainSelectedInstOperands,
     /*  138364 */     // GIR_Coverage, 53220,
     /*  138364 */     GIR_EraseRootFromParent_Done,
     /*  138365 */   // Label 2437: @138365
     /*  138365 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138398), // Rule ID 53221 //
     /*  138370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138381 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  138384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138396 */     GIR_RootConstrainSelectedInstOperands,
     /*  138397 */     // GIR_Coverage, 53221,
     /*  138397 */     GIR_EraseRootFromParent_Done,
     /*  138398 */   // Label 2438: @138398
     /*  138398 */   GIM_Reject,
     /*  138399 */ // Label 2428: @138399
     /*  138399 */ GIM_Reject,
     /*  138400 */ // Label 2289: @138400
     /*  138400 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138514),
     /*  138405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  138408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  138411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138423 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138468), // Rule ID 47812 //
     /*  138428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138431 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  138431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138466 */     GIR_RootConstrainSelectedInstOperands,
     /*  138467 */     // GIR_Coverage, 47812,
     /*  138467 */     GIR_EraseRootFromParent_Done,
     /*  138468 */   // Label 2440: @138468
     /*  138468 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138513), // Rule ID 47813 //
     /*  138473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138476 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138511 */     GIR_RootConstrainSelectedInstOperands,
     /*  138512 */     // GIR_Coverage, 47813,
     /*  138512 */     GIR_EraseRootFromParent_Done,
     /*  138513 */   // Label 2441: @138513
     /*  138513 */   GIM_Reject,
     /*  138514 */ // Label 2439: @138514
     /*  138514 */ GIM_Reject,
     /*  138515 */ // Label 2290: @138515
     /*  138515 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138629),
     /*  138520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  138523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  138526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138538 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138583), // Rule ID 47840 //
     /*  138543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138546 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138581 */     GIR_RootConstrainSelectedInstOperands,
     /*  138582 */     // GIR_Coverage, 47840,
     /*  138582 */     GIR_EraseRootFromParent_Done,
     /*  138583 */   // Label 2443: @138583
     /*  138583 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138628), // Rule ID 47841 //
     /*  138588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138591 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138626 */     GIR_RootConstrainSelectedInstOperands,
     /*  138627 */     // GIR_Coverage, 47841,
     /*  138627 */     GIR_EraseRootFromParent_Done,
     /*  138628 */   // Label 2444: @138628
     /*  138628 */   GIM_Reject,
     /*  138629 */ // Label 2442: @138629
     /*  138629 */ GIM_Reject,
     /*  138630 */ // Label 2291: @138630
     /*  138630 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(138744),
     /*  138635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  138638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  138641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138653 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138698), // Rule ID 47856 //
     /*  138658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138661 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138696 */     GIR_RootConstrainSelectedInstOperands,
     /*  138697 */     // GIR_Coverage, 47856,
     /*  138697 */     GIR_EraseRootFromParent_Done,
     /*  138698 */   // Label 2446: @138698
     /*  138698 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138743), // Rule ID 47857 //
     /*  138703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138706 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138741 */     GIR_RootConstrainSelectedInstOperands,
     /*  138742 */     // GIR_Coverage, 47857,
     /*  138742 */     GIR_EraseRootFromParent_Done,
     /*  138743 */   // Label 2447: @138743
     /*  138743 */   GIM_Reject,
     /*  138744 */ // Label 2445: @138744
     /*  138744 */ GIM_Reject,
     /*  138745 */ // Label 2292: @138745
     /*  138745 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138859),
     /*  138750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  138753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138768 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138813), // Rule ID 47872 //
     /*  138773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138776 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  138776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138811 */     GIR_RootConstrainSelectedInstOperands,
     /*  138812 */     // GIR_Coverage, 47872,
     /*  138812 */     GIR_EraseRootFromParent_Done,
     /*  138813 */   // Label 2449: @138813
     /*  138813 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138858), // Rule ID 47873 //
     /*  138818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138821 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  138821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138856 */     GIR_RootConstrainSelectedInstOperands,
     /*  138857 */     // GIR_Coverage, 47873,
     /*  138857 */     GIR_EraseRootFromParent_Done,
     /*  138858 */   // Label 2450: @138858
     /*  138858 */   GIM_Reject,
     /*  138859 */ // Label 2448: @138859
     /*  138859 */ GIM_Reject,
     /*  138860 */ // Label 2293: @138860
     /*  138860 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(139470),
     /*  138865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138875 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138941), // Rule ID 71883 //
     /*  138880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138922 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138939 */     GIR_RootConstrainSelectedInstOperands,
     /*  138940 */     // GIR_Coverage, 71883,
     /*  138940 */     GIR_EraseRootFromParent_Done,
     /*  138941 */   // Label 2452: @138941
     /*  138941 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(139007), // Rule ID 71884 //
     /*  138946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138988 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139005 */     GIR_RootConstrainSelectedInstOperands,
     /*  139006 */     // GIR_Coverage, 71884,
     /*  139006 */     GIR_EraseRootFromParent_Done,
     /*  139007 */   // Label 2453: @139007
     /*  139007 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(139073), // Rule ID 71881 //
     /*  139012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139054 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139071 */     GIR_RootConstrainSelectedInstOperands,
     /*  139072 */     // GIR_Coverage, 71881,
     /*  139072 */     GIR_EraseRootFromParent_Done,
     /*  139073 */   // Label 2454: @139073
     /*  139073 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139139), // Rule ID 71882 //
     /*  139078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139120 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139137 */     GIR_RootConstrainSelectedInstOperands,
     /*  139138 */     // GIR_Coverage, 71882,
     /*  139138 */     GIR_EraseRootFromParent_Done,
     /*  139139 */   // Label 2455: @139139
     /*  139139 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139205), // Rule ID 71879 //
     /*  139144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139186 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139203 */     GIR_RootConstrainSelectedInstOperands,
     /*  139204 */     // GIR_Coverage, 71879,
     /*  139204 */     GIR_EraseRootFromParent_Done,
     /*  139205 */   // Label 2456: @139205
     /*  139205 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139271), // Rule ID 71880 //
     /*  139210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139252 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139269 */     GIR_RootConstrainSelectedInstOperands,
     /*  139270 */     // GIR_Coverage, 71880,
     /*  139270 */     GIR_EraseRootFromParent_Done,
     /*  139271 */   // Label 2457: @139271
     /*  139271 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139337), // Rule ID 53250 //
     /*  139276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139318 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139335 */     GIR_RootConstrainSelectedInstOperands,
     /*  139336 */     // GIR_Coverage, 53250,
     /*  139336 */     GIR_EraseRootFromParent_Done,
     /*  139337 */   // Label 2458: @139337
     /*  139337 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139403), // Rule ID 53251 //
     /*  139342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  139361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  139365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139384 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  139387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139401 */     GIR_RootConstrainSelectedInstOperands,
     /*  139402 */     // GIR_Coverage, 53251,
     /*  139402 */     GIR_EraseRootFromParent_Done,
     /*  139403 */   // Label 2459: @139403
     /*  139403 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139436), // Rule ID 53238 //
     /*  139408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139419 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  139422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139434 */     GIR_RootConstrainSelectedInstOperands,
     /*  139435 */     // GIR_Coverage, 53238,
     /*  139435 */     GIR_EraseRootFromParent_Done,
     /*  139436 */   // Label 2460: @139436
     /*  139436 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139469), // Rule ID 53239 //
     /*  139441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139452 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  139455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139467 */     GIR_RootConstrainSelectedInstOperands,
     /*  139468 */     // GIR_Coverage, 53239,
     /*  139468 */     GIR_EraseRootFromParent_Done,
     /*  139469 */   // Label 2461: @139469
     /*  139469 */   GIM_Reject,
     /*  139470 */ // Label 2451: @139470
     /*  139470 */ GIM_Reject,
     /*  139471 */ // Label 2294: @139471
     /*  139471 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139585),
     /*  139476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  139479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139494 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139539), // Rule ID 47828 //
     /*  139499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139502 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139537 */     GIR_RootConstrainSelectedInstOperands,
     /*  139538 */     // GIR_Coverage, 47828,
     /*  139538 */     GIR_EraseRootFromParent_Done,
     /*  139539 */   // Label 2463: @139539
     /*  139539 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139584), // Rule ID 47829 //
     /*  139544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139547 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139582 */     GIR_RootConstrainSelectedInstOperands,
     /*  139583 */     // GIR_Coverage, 47829,
     /*  139583 */     GIR_EraseRootFromParent_Done,
     /*  139584 */   // Label 2464: @139584
     /*  139584 */   GIM_Reject,
     /*  139585 */ // Label 2462: @139585
     /*  139585 */ GIM_Reject,
     /*  139586 */ // Label 2295: @139586
     /*  139586 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139700),
     /*  139591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  139594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  139597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139609 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139654), // Rule ID 47844 //
     /*  139614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139617 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139652 */     GIR_RootConstrainSelectedInstOperands,
     /*  139653 */     // GIR_Coverage, 47844,
     /*  139653 */     GIR_EraseRootFromParent_Done,
     /*  139654 */   // Label 2466: @139654
     /*  139654 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139699), // Rule ID 47845 //
     /*  139659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139662 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139697 */     GIR_RootConstrainSelectedInstOperands,
     /*  139698 */     // GIR_Coverage, 47845,
     /*  139698 */     GIR_EraseRootFromParent_Done,
     /*  139699 */   // Label 2467: @139699
     /*  139699 */   GIM_Reject,
     /*  139700 */ // Label 2465: @139700
     /*  139700 */ GIM_Reject,
     /*  139701 */ // Label 2296: @139701
     /*  139701 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139815),
     /*  139706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  139709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  139712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139724 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139769), // Rule ID 47860 //
     /*  139729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139732 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  139732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139767 */     GIR_RootConstrainSelectedInstOperands,
     /*  139768 */     // GIR_Coverage, 47860,
     /*  139768 */     GIR_EraseRootFromParent_Done,
     /*  139769 */   // Label 2469: @139769
     /*  139769 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(139814), // Rule ID 47861 //
     /*  139774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139777 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  139777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139812 */     GIR_RootConstrainSelectedInstOperands,
     /*  139813 */     // GIR_Coverage, 47861,
     /*  139813 */     GIR_EraseRootFromParent_Done,
     /*  139814 */   // Label 2470: @139814
     /*  139814 */   GIM_Reject,
     /*  139815 */ // Label 2468: @139815
     /*  139815 */ GIM_Reject,
     /*  139816 */ // Label 2297: @139816
     /*  139816 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(140426),
     /*  139821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139831 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139897), // Rule ID 71911 //
     /*  139836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139878 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139895 */     GIR_RootConstrainSelectedInstOperands,
     /*  139896 */     // GIR_Coverage, 71911,
     /*  139896 */     GIR_EraseRootFromParent_Done,
     /*  139897 */   // Label 2472: @139897
     /*  139897 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139963), // Rule ID 71912 //
     /*  139902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139944 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139961 */     GIR_RootConstrainSelectedInstOperands,
     /*  139962 */     // GIR_Coverage, 71912,
     /*  139962 */     GIR_EraseRootFromParent_Done,
     /*  139963 */   // Label 2473: @139963
     /*  139963 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(140029), // Rule ID 71909 //
     /*  139968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140010 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140027 */     GIR_RootConstrainSelectedInstOperands,
     /*  140028 */     // GIR_Coverage, 71909,
     /*  140028 */     GIR_EraseRootFromParent_Done,
     /*  140029 */   // Label 2474: @140029
     /*  140029 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(140095), // Rule ID 71910 //
     /*  140034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140076 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140093 */     GIR_RootConstrainSelectedInstOperands,
     /*  140094 */     // GIR_Coverage, 71910,
     /*  140094 */     GIR_EraseRootFromParent_Done,
     /*  140095 */   // Label 2475: @140095
     /*  140095 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140161), // Rule ID 71907 //
     /*  140100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140142 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140159 */     GIR_RootConstrainSelectedInstOperands,
     /*  140160 */     // GIR_Coverage, 71907,
     /*  140160 */     GIR_EraseRootFromParent_Done,
     /*  140161 */   // Label 2476: @140161
     /*  140161 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140227), // Rule ID 71908 //
     /*  140166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140208 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140225 */     GIR_RootConstrainSelectedInstOperands,
     /*  140226 */     // GIR_Coverage, 71908,
     /*  140226 */     GIR_EraseRootFromParent_Done,
     /*  140227 */   // Label 2477: @140227
     /*  140227 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140293), // Rule ID 53268 //
     /*  140232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140274 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140291 */     GIR_RootConstrainSelectedInstOperands,
     /*  140292 */     // GIR_Coverage, 53268,
     /*  140292 */     GIR_EraseRootFromParent_Done,
     /*  140293 */   // Label 2478: @140293
     /*  140293 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140359), // Rule ID 53269 //
     /*  140298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  140317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  140321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140340 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  140343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140357 */     GIR_RootConstrainSelectedInstOperands,
     /*  140358 */     // GIR_Coverage, 53269,
     /*  140358 */     GIR_EraseRootFromParent_Done,
     /*  140359 */   // Label 2479: @140359
     /*  140359 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140392), // Rule ID 53256 //
     /*  140364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140375 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  140378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140390 */     GIR_RootConstrainSelectedInstOperands,
     /*  140391 */     // GIR_Coverage, 53256,
     /*  140391 */     GIR_EraseRootFromParent_Done,
     /*  140392 */   // Label 2480: @140392
     /*  140392 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140425), // Rule ID 53257 //
     /*  140397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140408 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  140411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140423 */     GIR_RootConstrainSelectedInstOperands,
     /*  140424 */     // GIR_Coverage, 53257,
     /*  140424 */     GIR_EraseRootFromParent_Done,
     /*  140425 */   // Label 2481: @140425
     /*  140425 */   GIM_Reject,
     /*  140426 */ // Label 2471: @140426
     /*  140426 */ GIM_Reject,
     /*  140427 */ // Label 2298: @140427
     /*  140427 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140541),
     /*  140432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  140435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  140438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  140450 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140495), // Rule ID 47832 //
     /*  140455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140458 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140493 */     GIR_RootConstrainSelectedInstOperands,
     /*  140494 */     // GIR_Coverage, 47832,
     /*  140494 */     GIR_EraseRootFromParent_Done,
     /*  140495 */   // Label 2483: @140495
     /*  140495 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(140540), // Rule ID 47833 //
     /*  140500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140503 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140538 */     GIR_RootConstrainSelectedInstOperands,
     /*  140539 */     // GIR_Coverage, 47833,
     /*  140539 */     GIR_EraseRootFromParent_Done,
     /*  140540 */   // Label 2484: @140540
     /*  140540 */   GIM_Reject,
     /*  140541 */ // Label 2482: @140541
     /*  140541 */ GIM_Reject,
     /*  140542 */ // Label 2299: @140542
     /*  140542 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(140656),
     /*  140547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  140550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140565 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(140610), // Rule ID 47848 //
     /*  140570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140573 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  140573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140608 */     GIR_RootConstrainSelectedInstOperands,
     /*  140609 */     // GIR_Coverage, 47848,
     /*  140609 */     GIR_EraseRootFromParent_Done,
     /*  140610 */   // Label 2486: @140610
     /*  140610 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(140655), // Rule ID 47849 //
     /*  140615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140618 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  140618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140653 */     GIR_RootConstrainSelectedInstOperands,
     /*  140654 */     // GIR_Coverage, 47849,
     /*  140654 */     GIR_EraseRootFromParent_Done,
     /*  140655 */   // Label 2487: @140655
     /*  140655 */   GIM_Reject,
     /*  140656 */ // Label 2485: @140656
     /*  140656 */ GIM_Reject,
     /*  140657 */ // Label 2300: @140657
     /*  140657 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(141267),
     /*  140662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140672 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(140738), // Rule ID 71939 //
     /*  140677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140719 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140736 */     GIR_RootConstrainSelectedInstOperands,
     /*  140737 */     // GIR_Coverage, 71939,
     /*  140737 */     GIR_EraseRootFromParent_Done,
     /*  140738 */   // Label 2489: @140738
     /*  140738 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(140804), // Rule ID 71940 //
     /*  140743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140785 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140802 */     GIR_RootConstrainSelectedInstOperands,
     /*  140803 */     // GIR_Coverage, 71940,
     /*  140803 */     GIR_EraseRootFromParent_Done,
     /*  140804 */   // Label 2490: @140804
     /*  140804 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(140870), // Rule ID 71937 //
     /*  140809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140851 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140868 */     GIR_RootConstrainSelectedInstOperands,
     /*  140869 */     // GIR_Coverage, 71937,
     /*  140869 */     GIR_EraseRootFromParent_Done,
     /*  140870 */   // Label 2491: @140870
     /*  140870 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(140936), // Rule ID 71938 //
     /*  140875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140917 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140934 */     GIR_RootConstrainSelectedInstOperands,
     /*  140935 */     // GIR_Coverage, 71938,
     /*  140935 */     GIR_EraseRootFromParent_Done,
     /*  140936 */   // Label 2492: @140936
     /*  140936 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(141002), // Rule ID 71935 //
     /*  140941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140983 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141000 */     GIR_RootConstrainSelectedInstOperands,
     /*  141001 */     // GIR_Coverage, 71935,
     /*  141001 */     GIR_EraseRootFromParent_Done,
     /*  141002 */   // Label 2493: @141002
     /*  141002 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(141068), // Rule ID 71936 //
     /*  141007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141049 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141066 */     GIR_RootConstrainSelectedInstOperands,
     /*  141067 */     // GIR_Coverage, 71936,
     /*  141067 */     GIR_EraseRootFromParent_Done,
     /*  141068 */   // Label 2494: @141068
     /*  141068 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(141134), // Rule ID 53286 //
     /*  141073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141115 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141132 */     GIR_RootConstrainSelectedInstOperands,
     /*  141133 */     // GIR_Coverage, 53286,
     /*  141133 */     GIR_EraseRootFromParent_Done,
     /*  141134 */   // Label 2495: @141134
     /*  141134 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(141200), // Rule ID 53287 //
     /*  141139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  141158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  141162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141181 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  141184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141198 */     GIR_RootConstrainSelectedInstOperands,
     /*  141199 */     // GIR_Coverage, 53287,
     /*  141199 */     GIR_EraseRootFromParent_Done,
     /*  141200 */   // Label 2496: @141200
     /*  141200 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(141233), // Rule ID 53274 //
     /*  141205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141216 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  141219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141231 */     GIR_RootConstrainSelectedInstOperands,
     /*  141232 */     // GIR_Coverage, 53274,
     /*  141232 */     GIR_EraseRootFromParent_Done,
     /*  141233 */   // Label 2497: @141233
     /*  141233 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(141266), // Rule ID 53275 //
     /*  141238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141249 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  141252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141264 */     GIR_RootConstrainSelectedInstOperands,
     /*  141265 */     // GIR_Coverage, 53275,
     /*  141265 */     GIR_EraseRootFromParent_Done,
     /*  141266 */   // Label 2498: @141266
     /*  141266 */   GIM_Reject,
     /*  141267 */ // Label 2488: @141267
     /*  141267 */ GIM_Reject,
     /*  141268 */ // Label 2301: @141268
     /*  141268 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(141382),
     /*  141273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  141276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  141279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  141291 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(141336), // Rule ID 47836 //
     /*  141296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141299 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  141299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  141302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  141316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141334 */     GIR_RootConstrainSelectedInstOperands,
     /*  141335 */     // GIR_Coverage, 47836,
     /*  141335 */     GIR_EraseRootFromParent_Done,
     /*  141336 */   // Label 2500: @141336
     /*  141336 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(141381), // Rule ID 47837 //
     /*  141341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141344 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  141344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  141347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  141361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141379 */     GIR_RootConstrainSelectedInstOperands,
     /*  141380 */     // GIR_Coverage, 47837,
     /*  141380 */     GIR_EraseRootFromParent_Done,
     /*  141381 */   // Label 2501: @141381
     /*  141381 */   GIM_Reject,
     /*  141382 */ // Label 2499: @141382
     /*  141382 */ GIM_Reject,
     /*  141383 */ // Label 2302: @141383
     /*  141383 */ GIM_Reject,
     /*  141384 */ // Label 9: @141384
     /*  141384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2533*/ GIMT_Encode4(156290),
     /*  141395 */ /*GILLT_s32*//*Label 2502*/ GIMT_Encode4(141519),
     /*  141399 */ /*GILLT_s64*//*Label 2503*/ GIMT_Encode4(142057),
     /*  141403 */ /*GILLT_nxv1s1*//*Label 2504*/ GIMT_Encode4(142483),
     /*  141407 */ /*GILLT_nxv1s8*//*Label 2505*/ GIMT_Encode4(144094),
     /*  141411 */ /*GILLT_nxv1s16*//*Label 2506*/ GIMT_Encode4(144209),
     /*  141415 */ /*GILLT_nxv1s32*//*Label 2507*/ GIMT_Encode4(144324),
     /*  141419 */ /*GILLT_nxv1s64*//*Label 2508*/ GIMT_Encode4(144439),
     /*  141423 */ /*GILLT_nxv2s1*//*Label 2509*/ GIMT_Encode4(144554),
     /*  141427 */ /*GILLT_nxv2s8*//*Label 2510*/ GIMT_Encode4(146165),
     /*  141431 */ /*GILLT_nxv2s16*//*Label 2511*/ GIMT_Encode4(146280),
     /*  141435 */ /*GILLT_nxv2s32*//*Label 2512*/ GIMT_Encode4(146395),
     /*  141439 */ /*GILLT_nxv2s64*//*Label 2513*/ GIMT_Encode4(146510),
     /*  141443 */ /*GILLT_nxv4s1*//*Label 2514*/ GIMT_Encode4(146625),
     /*  141447 */ /*GILLT_nxv4s8*//*Label 2515*/ GIMT_Encode4(148236),
     /*  141451 */ /*GILLT_nxv4s16*//*Label 2516*/ GIMT_Encode4(148351),
     /*  141455 */ /*GILLT_nxv4s32*//*Label 2517*/ GIMT_Encode4(148466),
     /*  141459 */ /*GILLT_nxv4s64*//*Label 2518*/ GIMT_Encode4(148581),
     /*  141463 */ /*GILLT_nxv8s1*//*Label 2519*/ GIMT_Encode4(148696),
     /*  141467 */ /*GILLT_nxv8s8*//*Label 2520*/ GIMT_Encode4(150307),
     /*  141471 */ /*GILLT_nxv8s16*//*Label 2521*/ GIMT_Encode4(150422),
     /*  141475 */ /*GILLT_nxv8s32*//*Label 2522*/ GIMT_Encode4(150537),
     /*  141479 */ /*GILLT_nxv8s64*//*Label 2523*/ GIMT_Encode4(150652),
     /*  141483 */ /*GILLT_nxv16s1*//*Label 2524*/ GIMT_Encode4(150767),
     /*  141487 */ /*GILLT_nxv16s8*//*Label 2525*/ GIMT_Encode4(152378),
     /*  141491 */ /*GILLT_nxv16s16*//*Label 2526*/ GIMT_Encode4(152493),
     /*  141495 */ /*GILLT_nxv16s32*//*Label 2527*/ GIMT_Encode4(152608),
     /*  141499 */ /*GILLT_nxv32s1*//*Label 2528*/ GIMT_Encode4(152723),
     /*  141503 */ /*GILLT_nxv32s8*//*Label 2529*/ GIMT_Encode4(154334),
     /*  141507 */ /*GILLT_nxv32s16*//*Label 2530*/ GIMT_Encode4(154449),
     /*  141511 */ /*GILLT_nxv64s1*//*Label 2531*/ GIMT_Encode4(154564),
     /*  141515 */ /*GILLT_nxv64s8*//*Label 2532*/ GIMT_Encode4(156175),
     /*  141519 */ // Label 2502: @141519
     /*  141519 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(142056),
     /*  141524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  141527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  141530 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141613), // Rule ID 2485 //
     /*  141535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141558 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141575 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  141575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  141578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141587 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141611 */     GIR_RootConstrainSelectedInstOperands,
     /*  141612 */     // GIR_Coverage, 2485,
     /*  141612 */     GIR_EraseRootFromParent_Done,
     /*  141613 */   // Label 2535: @141613
     /*  141613 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(141672), // Rule ID 2479 //
     /*  141618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141641 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141658 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141670 */     GIR_RootConstrainSelectedInstOperands,
     /*  141671 */     // GIR_Coverage, 2479,
     /*  141671 */     GIR_EraseRootFromParent_Done,
     /*  141672 */   // Label 2536: @141672
     /*  141672 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141731), // Rule ID 65560 //
     /*  141677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141717 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141729 */     GIR_RootConstrainSelectedInstOperands,
     /*  141730 */     // GIR_Coverage, 65560,
     /*  141730 */     GIR_EraseRootFromParent_Done,
     /*  141731 */   // Label 2537: @141731
     /*  141731 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141787), // Rule ID 65544 //
     /*  141736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141774 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141785 */     GIR_RootConstrainSelectedInstOperands,
     /*  141786 */     // GIR_Coverage, 65544,
     /*  141786 */     GIR_EraseRootFromParent_Done,
     /*  141787 */   // Label 2538: @141787
     /*  141787 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(141846), // Rule ID 2453 //
     /*  141792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141831 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141844 */     GIR_RootConstrainSelectedInstOperands,
     /*  141845 */     // GIR_Coverage, 2453,
     /*  141845 */     GIR_EraseRootFromParent_Done,
     /*  141846 */   // Label 2539: @141846
     /*  141846 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141902), // Rule ID 65546 //
     /*  141851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141883 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141889 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  141900 */     GIR_RootConstrainSelectedInstOperands,
     /*  141901 */     // GIR_Coverage, 65546,
     /*  141901 */     GIR_EraseRootFromParent_Done,
     /*  141902 */   // Label 2540: @141902
     /*  141902 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141944), // Rule ID 95 //
     /*  141907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141930 */     // MIs[1] Operand 1
     /*  141930 */     // No operand predicates
     /*  141930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141932 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  141932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141942 */     GIR_RootConstrainSelectedInstOperands,
     /*  141943 */     // GIR_Coverage, 95,
     /*  141943 */     GIR_EraseRootFromParent_Done,
     /*  141944 */   // Label 2541: @141944
     /*  141944 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141986), // Rule ID 64540 //
     /*  141949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141972 */     // MIs[1] Operand 1
     /*  141972 */     // No operand predicates
     /*  141972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141974 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141984 */     GIR_RootConstrainSelectedInstOperands,
     /*  141985 */     // GIR_Coverage, 64540,
     /*  141985 */     GIR_EraseRootFromParent_Done,
     /*  141986 */   // Label 2542: @141986
     /*  141986 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(142028), // Rule ID 64544 //
     /*  141991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  142002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  142014 */     // MIs[1] Operand 1
     /*  142014 */     // No operand predicates
     /*  142014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142016 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  142016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  142019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  142026 */     GIR_RootConstrainSelectedInstOperands,
     /*  142027 */     // GIR_Coverage, 64544,
     /*  142027 */     GIR_EraseRootFromParent_Done,
     /*  142028 */   // Label 2543: @142028
     /*  142028 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(142055), // Rule ID 93 //
     /*  142033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  142036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142048 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  142048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142053 */     GIR_RootConstrainSelectedInstOperands,
     /*  142054 */     // GIR_Coverage, 93,
     /*  142054 */     GIR_Done,
     /*  142055 */   // Label 2544: @142055
     /*  142055 */   GIM_Reject,
     /*  142056 */ // Label 2534: @142056
     /*  142056 */ GIM_Reject,
     /*  142057 */ // Label 2503: @142057
     /*  142057 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(142482),
     /*  142062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  142065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  142068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142072 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(142151), // Rule ID 2484 //
     /*  142077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  142100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  142104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142113 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  142113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  142116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  142120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  142125 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  142131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  142138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  142141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  142146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142149 */     GIR_RootConstrainSelectedInstOperands,
     /*  142150 */     // GIR_Coverage, 2484,
     /*  142150 */     GIR_EraseRootFromParent_Done,
     /*  142151 */   // Label 2546: @142151
     /*  142151 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142206), // Rule ID 2478 //
     /*  142156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  142179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142192 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  142195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  142199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142204 */     GIR_RootConstrainSelectedInstOperands,
     /*  142205 */     // GIR_Coverage, 2478,
     /*  142205 */     GIR_EraseRootFromParent_Done,
     /*  142206 */   // Label 2547: @142206
     /*  142206 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(142261), // Rule ID 65559 //
     /*  142211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  142214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  142226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  142238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  142247 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  142250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  142259 */     GIR_RootConstrainSelectedInstOperands,
     /*  142260 */     // GIR_Coverage, 65559,
     /*  142260 */     GIR_EraseRootFromParent_Done,
     /*  142261 */   // Label 2548: @142261
     /*  142261 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142313), // Rule ID 65543 //
     /*  142266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  142294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142300 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142311 */     GIR_RootConstrainSelectedInstOperands,
     /*  142312 */     // GIR_Coverage, 65543,
     /*  142312 */     GIR_EraseRootFromParent_Done,
     /*  142313 */   // Label 2549: @142313
     /*  142313 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142368), // Rule ID 2452 //
     /*  142318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  142351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142353 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142366 */     GIR_RootConstrainSelectedInstOperands,
     /*  142367 */     // GIR_Coverage, 2452,
     /*  142367 */     GIR_EraseRootFromParent_Done,
     /*  142368 */   // Label 2550: @142368
     /*  142368 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142420), // Rule ID 65545 //
     /*  142373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  142376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  142396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142401 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  142405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142407 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  142410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142418 */     GIR_RootConstrainSelectedInstOperands,
     /*  142419 */     // GIR_Coverage, 65545,
     /*  142419 */     GIR_EraseRootFromParent_Done,
     /*  142420 */   // Label 2551: @142420
     /*  142420 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142458), // Rule ID 94 //
     /*  142425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  142440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  142444 */     // MIs[1] Operand 1
     /*  142444 */     // No operand predicates
     /*  142444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142446 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  142446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  142449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  142453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  142456 */     GIR_RootConstrainSelectedInstOperands,
     /*  142457 */     // GIR_Coverage, 94,
     /*  142457 */     GIR_EraseRootFromParent_Done,
     /*  142458 */   // Label 2552: @142458
     /*  142458 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142481), // Rule ID 92 //
     /*  142463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142474 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142479 */     GIR_RootConstrainSelectedInstOperands,
     /*  142480 */     // GIR_Coverage, 92,
     /*  142480 */     GIR_Done,
     /*  142481 */   // Label 2553: @142481
     /*  142481 */   GIM_Reject,
     /*  142482 */ // Label 2545: @142482
     /*  142482 */ GIM_Reject,
     /*  142483 */ // Label 2504: @142483
     /*  142483 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144093),
     /*  142488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142498 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142567), // Rule ID 53170 //
     /*  142503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142546 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142565 */     GIR_RootConstrainSelectedInstOperands,
     /*  142566 */     // GIR_Coverage, 53170,
     /*  142566 */     GIR_EraseRootFromParent_Done,
     /*  142567 */   // Label 2555: @142567
     /*  142567 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142636), // Rule ID 53171 //
     /*  142572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142615 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142634 */     GIR_RootConstrainSelectedInstOperands,
     /*  142635 */     // GIR_Coverage, 53171,
     /*  142635 */     GIR_EraseRootFromParent_Done,
     /*  142636 */   // Label 2556: @142636
     /*  142636 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142705), // Rule ID 53172 //
     /*  142641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142684 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142703 */     GIR_RootConstrainSelectedInstOperands,
     /*  142704 */     // GIR_Coverage, 53172,
     /*  142704 */     GIR_EraseRootFromParent_Done,
     /*  142705 */   // Label 2557: @142705
     /*  142705 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142774), // Rule ID 53173 //
     /*  142710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142753 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142772 */     GIR_RootConstrainSelectedInstOperands,
     /*  142773 */     // GIR_Coverage, 53173,
     /*  142773 */     GIR_EraseRootFromParent_Done,
     /*  142774 */   // Label 2558: @142774
     /*  142774 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(142840), // Rule ID 71753 //
     /*  142779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142821 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142838 */     GIR_RootConstrainSelectedInstOperands,
     /*  142839 */     // GIR_Coverage, 71753,
     /*  142839 */     GIR_EraseRootFromParent_Done,
     /*  142840 */   // Label 2559: @142840
     /*  142840 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(142906), // Rule ID 71754 //
     /*  142845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142887 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142904 */     GIR_RootConstrainSelectedInstOperands,
     /*  142905 */     // GIR_Coverage, 71754,
     /*  142905 */     GIR_EraseRootFromParent_Done,
     /*  142906 */   // Label 2560: @142906
     /*  142906 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(142972), // Rule ID 71751 //
     /*  142911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142953 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142970 */     GIR_RootConstrainSelectedInstOperands,
     /*  142971 */     // GIR_Coverage, 71751,
     /*  142971 */     GIR_EraseRootFromParent_Done,
     /*  142972 */   // Label 2561: @142972
     /*  142972 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(143038), // Rule ID 71752 //
     /*  142977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143019 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143036 */     GIR_RootConstrainSelectedInstOperands,
     /*  143037 */     // GIR_Coverage, 71752,
     /*  143037 */     GIR_EraseRootFromParent_Done,
     /*  143038 */   // Label 2562: @143038
     /*  143038 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143107), // Rule ID 53174 //
     /*  143043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143086 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143105 */     GIR_RootConstrainSelectedInstOperands,
     /*  143106 */     // GIR_Coverage, 53174,
     /*  143106 */     GIR_EraseRootFromParent_Done,
     /*  143107 */   // Label 2563: @143107
     /*  143107 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143176), // Rule ID 53175 //
     /*  143112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143155 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143174 */     GIR_RootConstrainSelectedInstOperands,
     /*  143175 */     // GIR_Coverage, 53175,
     /*  143175 */     GIR_EraseRootFromParent_Done,
     /*  143176 */   // Label 2564: @143176
     /*  143176 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143245), // Rule ID 71747 //
     /*  143181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143224 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143243 */     GIR_RootConstrainSelectedInstOperands,
     /*  143244 */     // GIR_Coverage, 71747,
     /*  143244 */     GIR_EraseRootFromParent_Done,
     /*  143245 */   // Label 2565: @143245
     /*  143245 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143314), // Rule ID 71748 //
     /*  143250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143293 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143312 */     GIR_RootConstrainSelectedInstOperands,
     /*  143313 */     // GIR_Coverage, 71748,
     /*  143313 */     GIR_EraseRootFromParent_Done,
     /*  143314 */   // Label 2566: @143314
     /*  143314 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143383), // Rule ID 71749 //
     /*  143319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143362 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  143365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143381 */     GIR_RootConstrainSelectedInstOperands,
     /*  143382 */     // GIR_Coverage, 71749,
     /*  143382 */     GIR_EraseRootFromParent_Done,
     /*  143383 */   // Label 2567: @143383
     /*  143383 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143452), // Rule ID 71750 //
     /*  143388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143431 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  143434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143450 */     GIR_RootConstrainSelectedInstOperands,
     /*  143451 */     // GIR_Coverage, 71750,
     /*  143451 */     GIR_EraseRootFromParent_Done,
     /*  143452 */   // Label 2568: @143452
     /*  143452 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143521), // Rule ID 71755 //
     /*  143457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143500 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143519 */     GIR_RootConstrainSelectedInstOperands,
     /*  143520 */     // GIR_Coverage, 71755,
     /*  143520 */     GIR_EraseRootFromParent_Done,
     /*  143521 */   // Label 2569: @143521
     /*  143521 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143590), // Rule ID 71756 //
     /*  143526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143569 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143588 */     GIR_RootConstrainSelectedInstOperands,
     /*  143589 */     // GIR_Coverage, 71756,
     /*  143589 */     GIR_EraseRootFromParent_Done,
     /*  143590 */   // Label 2570: @143590
     /*  143590 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143656), // Rule ID 71759 //
     /*  143595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143637 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143654 */     GIR_RootConstrainSelectedInstOperands,
     /*  143655 */     // GIR_Coverage, 71759,
     /*  143655 */     GIR_EraseRootFromParent_Done,
     /*  143656 */   // Label 2571: @143656
     /*  143656 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143722), // Rule ID 71760 //
     /*  143661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143703 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143720 */     GIR_RootConstrainSelectedInstOperands,
     /*  143721 */     // GIR_Coverage, 71760,
     /*  143721 */     GIR_EraseRootFromParent_Done,
     /*  143722 */   // Label 2572: @143722
     /*  143722 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143788), // Rule ID 71757 //
     /*  143727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143769 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143786 */     GIR_RootConstrainSelectedInstOperands,
     /*  143787 */     // GIR_Coverage, 71757,
     /*  143787 */     GIR_EraseRootFromParent_Done,
     /*  143788 */   // Label 2573: @143788
     /*  143788 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143854), // Rule ID 71758 //
     /*  143793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143835 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143852 */     GIR_RootConstrainSelectedInstOperands,
     /*  143853 */     // GIR_Coverage, 71758,
     /*  143853 */     GIR_EraseRootFromParent_Done,
     /*  143854 */   // Label 2574: @143854
     /*  143854 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(143897), // Rule ID 71773 //
     /*  143859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143880 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143895 */     GIR_RootConstrainSelectedInstOperands,
     /*  143896 */     // GIR_Coverage, 71773,
     /*  143896 */     GIR_EraseRootFromParent_Done,
     /*  143897 */   // Label 2575: @143897
     /*  143897 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143940), // Rule ID 71774 //
     /*  143902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143923 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143938 */     GIR_RootConstrainSelectedInstOperands,
     /*  143939 */     // GIR_Coverage, 71774,
     /*  143939 */     GIR_EraseRootFromParent_Done,
     /*  143940 */   // Label 2576: @143940
     /*  143940 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143983), // Rule ID 53180 //
     /*  143945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143966 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143981 */     GIR_RootConstrainSelectedInstOperands,
     /*  143982 */     // GIR_Coverage, 53180,
     /*  143982 */     GIR_EraseRootFromParent_Done,
     /*  143983 */   // Label 2577: @143983
     /*  143983 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(144026), // Rule ID 53181 //
     /*  143988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  144009 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  144012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  144016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  144018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144024 */     GIR_RootConstrainSelectedInstOperands,
     /*  144025 */     // GIR_Coverage, 53181,
     /*  144025 */     GIR_EraseRootFromParent_Done,
     /*  144026 */   // Label 2578: @144026
     /*  144026 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(144059), // Rule ID 53168 //
     /*  144031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144042 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  144045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144057 */     GIR_RootConstrainSelectedInstOperands,
     /*  144058 */     // GIR_Coverage, 53168,
     /*  144058 */     GIR_EraseRootFromParent_Done,
     /*  144059 */   // Label 2579: @144059
     /*  144059 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(144092), // Rule ID 53169 //
     /*  144064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144075 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  144078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144090 */     GIR_RootConstrainSelectedInstOperands,
     /*  144091 */     // GIR_Coverage, 53169,
     /*  144091 */     GIR_EraseRootFromParent_Done,
     /*  144092 */   // Label 2580: @144092
     /*  144092 */   GIM_Reject,
     /*  144093 */ // Label 2554: @144093
     /*  144093 */ GIM_Reject,
     /*  144094 */ // Label 2505: @144094
     /*  144094 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(144208),
     /*  144099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  144102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  144105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144117 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(144162), // Rule ID 47920 //
     /*  144122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144125 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  144125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  144128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  144142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144160 */     GIR_RootConstrainSelectedInstOperands,
     /*  144161 */     // GIR_Coverage, 47920,
     /*  144161 */     GIR_EraseRootFromParent_Done,
     /*  144162 */   // Label 2582: @144162
     /*  144162 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(144207), // Rule ID 47921 //
     /*  144167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144170 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  144170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  144173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  144187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144205 */     GIR_RootConstrainSelectedInstOperands,
     /*  144206 */     // GIR_Coverage, 47921,
     /*  144206 */     GIR_EraseRootFromParent_Done,
     /*  144207 */   // Label 2583: @144207
     /*  144207 */   GIM_Reject,
     /*  144208 */ // Label 2581: @144208
     /*  144208 */ GIM_Reject,
     /*  144209 */ // Label 2506: @144209
     /*  144209 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144323),
     /*  144214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  144217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  144220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144232 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144277), // Rule ID 47932 //
     /*  144237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144240 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  144240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  144243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  144257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  144272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144275 */     GIR_RootConstrainSelectedInstOperands,
     /*  144276 */     // GIR_Coverage, 47932,
     /*  144276 */     GIR_EraseRootFromParent_Done,
     /*  144277 */   // Label 2585: @144277
     /*  144277 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144322), // Rule ID 47933 //
     /*  144282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144285 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  144285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  144288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  144302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  144317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144320 */     GIR_RootConstrainSelectedInstOperands,
     /*  144321 */     // GIR_Coverage, 47933,
     /*  144321 */     GIR_EraseRootFromParent_Done,
     /*  144322 */   // Label 2586: @144322
     /*  144322 */   GIM_Reject,
     /*  144323 */ // Label 2584: @144323
     /*  144323 */ GIM_Reject,
     /*  144324 */ // Label 2507: @144324
     /*  144324 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(144438),
     /*  144329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  144332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  144335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144347 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144392), // Rule ID 47940 //
     /*  144352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144355 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  144355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  144358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  144372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144390 */     GIR_RootConstrainSelectedInstOperands,
     /*  144391 */     // GIR_Coverage, 47940,
     /*  144391 */     GIR_EraseRootFromParent_Done,
     /*  144392 */   // Label 2588: @144392
     /*  144392 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144437), // Rule ID 47941 //
     /*  144397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144400 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  144400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  144403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  144417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  144432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144435 */     GIR_RootConstrainSelectedInstOperands,
     /*  144436 */     // GIR_Coverage, 47941,
     /*  144436 */     GIR_EraseRootFromParent_Done,
     /*  144437 */   // Label 2589: @144437
     /*  144437 */   GIM_Reject,
     /*  144438 */ // Label 2587: @144438
     /*  144438 */ GIM_Reject,
     /*  144439 */ // Label 2508: @144439
     /*  144439 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144553),
     /*  144444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  144447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  144450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144462 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144507), // Rule ID 47956 //
     /*  144467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144470 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  144470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144505 */     GIR_RootConstrainSelectedInstOperands,
     /*  144506 */     // GIR_Coverage, 47956,
     /*  144506 */     GIR_EraseRootFromParent_Done,
     /*  144507 */   // Label 2591: @144507
     /*  144507 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144552), // Rule ID 47957 //
     /*  144512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144515 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  144515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144550 */     GIR_RootConstrainSelectedInstOperands,
     /*  144551 */     // GIR_Coverage, 47957,
     /*  144551 */     GIR_EraseRootFromParent_Done,
     /*  144552 */   // Label 2592: @144552
     /*  144552 */   GIM_Reject,
     /*  144553 */ // Label 2590: @144553
     /*  144553 */ GIM_Reject,
     /*  144554 */ // Label 2509: @144554
     /*  144554 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146164),
     /*  144559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144569 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144638), // Rule ID 53188 //
     /*  144574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144617 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144636 */     GIR_RootConstrainSelectedInstOperands,
     /*  144637 */     // GIR_Coverage, 53188,
     /*  144637 */     GIR_EraseRootFromParent_Done,
     /*  144638 */   // Label 2594: @144638
     /*  144638 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144707), // Rule ID 53189 //
     /*  144643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144686 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144705 */     GIR_RootConstrainSelectedInstOperands,
     /*  144706 */     // GIR_Coverage, 53189,
     /*  144706 */     GIR_EraseRootFromParent_Done,
     /*  144707 */   // Label 2595: @144707
     /*  144707 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(144776), // Rule ID 53190 //
     /*  144712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144755 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144774 */     GIR_RootConstrainSelectedInstOperands,
     /*  144775 */     // GIR_Coverage, 53190,
     /*  144775 */     GIR_EraseRootFromParent_Done,
     /*  144776 */   // Label 2596: @144776
     /*  144776 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(144845), // Rule ID 53191 //
     /*  144781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144824 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144843 */     GIR_RootConstrainSelectedInstOperands,
     /*  144844 */     // GIR_Coverage, 53191,
     /*  144844 */     GIR_EraseRootFromParent_Done,
     /*  144845 */   // Label 2597: @144845
     /*  144845 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(144911), // Rule ID 71781 //
     /*  144850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144892 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144909 */     GIR_RootConstrainSelectedInstOperands,
     /*  144910 */     // GIR_Coverage, 71781,
     /*  144910 */     GIR_EraseRootFromParent_Done,
     /*  144911 */   // Label 2598: @144911
     /*  144911 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(144977), // Rule ID 71782 //
     /*  144916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144958 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144975 */     GIR_RootConstrainSelectedInstOperands,
     /*  144976 */     // GIR_Coverage, 71782,
     /*  144976 */     GIR_EraseRootFromParent_Done,
     /*  144977 */   // Label 2599: @144977
     /*  144977 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(145043), // Rule ID 71779 //
     /*  144982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145024 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145041 */     GIR_RootConstrainSelectedInstOperands,
     /*  145042 */     // GIR_Coverage, 71779,
     /*  145042 */     GIR_EraseRootFromParent_Done,
     /*  145043 */   // Label 2600: @145043
     /*  145043 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145109), // Rule ID 71780 //
     /*  145048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145090 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145107 */     GIR_RootConstrainSelectedInstOperands,
     /*  145108 */     // GIR_Coverage, 71780,
     /*  145108 */     GIR_EraseRootFromParent_Done,
     /*  145109 */   // Label 2601: @145109
     /*  145109 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145178), // Rule ID 53192 //
     /*  145114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145157 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145176 */     GIR_RootConstrainSelectedInstOperands,
     /*  145177 */     // GIR_Coverage, 53192,
     /*  145177 */     GIR_EraseRootFromParent_Done,
     /*  145178 */   // Label 2602: @145178
     /*  145178 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145247), // Rule ID 53193 //
     /*  145183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145226 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145245 */     GIR_RootConstrainSelectedInstOperands,
     /*  145246 */     // GIR_Coverage, 53193,
     /*  145246 */     GIR_EraseRootFromParent_Done,
     /*  145247 */   // Label 2603: @145247
     /*  145247 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145316), // Rule ID 71775 //
     /*  145252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145295 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145314 */     GIR_RootConstrainSelectedInstOperands,
     /*  145315 */     // GIR_Coverage, 71775,
     /*  145315 */     GIR_EraseRootFromParent_Done,
     /*  145316 */   // Label 2604: @145316
     /*  145316 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145385), // Rule ID 71776 //
     /*  145321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145364 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145383 */     GIR_RootConstrainSelectedInstOperands,
     /*  145384 */     // GIR_Coverage, 71776,
     /*  145384 */     GIR_EraseRootFromParent_Done,
     /*  145385 */   // Label 2605: @145385
     /*  145385 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145454), // Rule ID 71777 //
     /*  145390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145433 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145452 */     GIR_RootConstrainSelectedInstOperands,
     /*  145453 */     // GIR_Coverage, 71777,
     /*  145453 */     GIR_EraseRootFromParent_Done,
     /*  145454 */   // Label 2606: @145454
     /*  145454 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145523), // Rule ID 71778 //
     /*  145459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145502 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145521 */     GIR_RootConstrainSelectedInstOperands,
     /*  145522 */     // GIR_Coverage, 71778,
     /*  145522 */     GIR_EraseRootFromParent_Done,
     /*  145523 */   // Label 2607: @145523
     /*  145523 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145592), // Rule ID 71783 //
     /*  145528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145571 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145590 */     GIR_RootConstrainSelectedInstOperands,
     /*  145591 */     // GIR_Coverage, 71783,
     /*  145591 */     GIR_EraseRootFromParent_Done,
     /*  145592 */   // Label 2608: @145592
     /*  145592 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145661), // Rule ID 71784 //
     /*  145597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145640 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145659 */     GIR_RootConstrainSelectedInstOperands,
     /*  145660 */     // GIR_Coverage, 71784,
     /*  145660 */     GIR_EraseRootFromParent_Done,
     /*  145661 */   // Label 2609: @145661
     /*  145661 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145727), // Rule ID 71787 //
     /*  145666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145708 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145725 */     GIR_RootConstrainSelectedInstOperands,
     /*  145726 */     // GIR_Coverage, 71787,
     /*  145726 */     GIR_EraseRootFromParent_Done,
     /*  145727 */   // Label 2610: @145727
     /*  145727 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145793), // Rule ID 71788 //
     /*  145732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145774 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145791 */     GIR_RootConstrainSelectedInstOperands,
     /*  145792 */     // GIR_Coverage, 71788,
     /*  145792 */     GIR_EraseRootFromParent_Done,
     /*  145793 */   // Label 2611: @145793
     /*  145793 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145859), // Rule ID 71785 //
     /*  145798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145840 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145857 */     GIR_RootConstrainSelectedInstOperands,
     /*  145858 */     // GIR_Coverage, 71785,
     /*  145858 */     GIR_EraseRootFromParent_Done,
     /*  145859 */   // Label 2612: @145859
     /*  145859 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145925), // Rule ID 71786 //
     /*  145864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145906 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145923 */     GIR_RootConstrainSelectedInstOperands,
     /*  145924 */     // GIR_Coverage, 71786,
     /*  145924 */     GIR_EraseRootFromParent_Done,
     /*  145925 */   // Label 2613: @145925
     /*  145925 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(145968), // Rule ID 71801 //
     /*  145930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145951 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145966 */     GIR_RootConstrainSelectedInstOperands,
     /*  145967 */     // GIR_Coverage, 71801,
     /*  145967 */     GIR_EraseRootFromParent_Done,
     /*  145968 */   // Label 2614: @145968
     /*  145968 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(146011), // Rule ID 71802 //
     /*  145973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145994 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  146001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  146003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146009 */     GIR_RootConstrainSelectedInstOperands,
     /*  146010 */     // GIR_Coverage, 71802,
     /*  146010 */     GIR_EraseRootFromParent_Done,
     /*  146011 */   // Label 2615: @146011
     /*  146011 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(146054), // Rule ID 53198 //
     /*  146016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  146037 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  146040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146052 */     GIR_RootConstrainSelectedInstOperands,
     /*  146053 */     // GIR_Coverage, 53198,
     /*  146053 */     GIR_EraseRootFromParent_Done,
     /*  146054 */   // Label 2616: @146054
     /*  146054 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(146097), // Rule ID 53199 //
     /*  146059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  146080 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  146083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  146089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146095 */     GIR_RootConstrainSelectedInstOperands,
     /*  146096 */     // GIR_Coverage, 53199,
     /*  146096 */     GIR_EraseRootFromParent_Done,
     /*  146097 */   // Label 2617: @146097
     /*  146097 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(146130), // Rule ID 53186 //
     /*  146102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146113 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  146116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146128 */     GIR_RootConstrainSelectedInstOperands,
     /*  146129 */     // GIR_Coverage, 53186,
     /*  146129 */     GIR_EraseRootFromParent_Done,
     /*  146130 */   // Label 2618: @146130
     /*  146130 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(146163), // Rule ID 53187 //
     /*  146135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146146 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  146149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146161 */     GIR_RootConstrainSelectedInstOperands,
     /*  146162 */     // GIR_Coverage, 53187,
     /*  146162 */     GIR_EraseRootFromParent_Done,
     /*  146163 */   // Label 2619: @146163
     /*  146163 */   GIM_Reject,
     /*  146164 */ // Label 2593: @146164
     /*  146164 */ GIM_Reject,
     /*  146165 */ // Label 2510: @146165
     /*  146165 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146279),
     /*  146170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  146173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  146176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146188 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(146233), // Rule ID 47924 //
     /*  146193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146196 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  146196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  146199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  146213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146231 */     GIR_RootConstrainSelectedInstOperands,
     /*  146232 */     // GIR_Coverage, 47924,
     /*  146232 */     GIR_EraseRootFromParent_Done,
     /*  146233 */   // Label 2621: @146233
     /*  146233 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146278), // Rule ID 47925 //
     /*  146238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146241 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  146241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  146244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  146258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146276 */     GIR_RootConstrainSelectedInstOperands,
     /*  146277 */     // GIR_Coverage, 47925,
     /*  146277 */     GIR_EraseRootFromParent_Done,
     /*  146278 */   // Label 2622: @146278
     /*  146278 */   GIM_Reject,
     /*  146279 */ // Label 2620: @146279
     /*  146279 */ GIM_Reject,
     /*  146280 */ // Label 2511: @146280
     /*  146280 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146394),
     /*  146285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  146288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  146291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146303 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146348), // Rule ID 47936 //
     /*  146308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146311 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  146311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  146314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  146328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146346 */     GIR_RootConstrainSelectedInstOperands,
     /*  146347 */     // GIR_Coverage, 47936,
     /*  146347 */     GIR_EraseRootFromParent_Done,
     /*  146348 */   // Label 2624: @146348
     /*  146348 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146393), // Rule ID 47937 //
     /*  146353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146356 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  146356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  146359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  146373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  146388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146391 */     GIR_RootConstrainSelectedInstOperands,
     /*  146392 */     // GIR_Coverage, 47937,
     /*  146392 */     GIR_EraseRootFromParent_Done,
     /*  146393 */   // Label 2625: @146393
     /*  146393 */   GIM_Reject,
     /*  146394 */ // Label 2623: @146394
     /*  146394 */ GIM_Reject,
     /*  146395 */ // Label 2512: @146395
     /*  146395 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(146509),
     /*  146400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  146403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  146406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146418 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146463), // Rule ID 47952 //
     /*  146423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146426 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  146426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146461 */     GIR_RootConstrainSelectedInstOperands,
     /*  146462 */     // GIR_Coverage, 47952,
     /*  146462 */     GIR_EraseRootFromParent_Done,
     /*  146463 */   // Label 2627: @146463
     /*  146463 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146508), // Rule ID 47953 //
     /*  146468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146471 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  146471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146506 */     GIR_RootConstrainSelectedInstOperands,
     /*  146507 */     // GIR_Coverage, 47953,
     /*  146507 */     GIR_EraseRootFromParent_Done,
     /*  146508 */   // Label 2628: @146508
     /*  146508 */   GIM_Reject,
     /*  146509 */ // Label 2626: @146509
     /*  146509 */ GIM_Reject,
     /*  146510 */ // Label 2513: @146510
     /*  146510 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146624),
     /*  146515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  146518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  146521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146533 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146578), // Rule ID 47996 //
     /*  146538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  146541 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  146541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146576 */     GIR_RootConstrainSelectedInstOperands,
     /*  146577 */     // GIR_Coverage, 47996,
     /*  146577 */     GIR_EraseRootFromParent_Done,
     /*  146578 */   // Label 2630: @146578
     /*  146578 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146623), // Rule ID 47997 //
     /*  146583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  146586 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  146586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146621 */     GIR_RootConstrainSelectedInstOperands,
     /*  146622 */     // GIR_Coverage, 47997,
     /*  146622 */     GIR_EraseRootFromParent_Done,
     /*  146623 */   // Label 2631: @146623
     /*  146623 */   GIM_Reject,
     /*  146624 */ // Label 2629: @146624
     /*  146624 */ GIM_Reject,
     /*  146625 */ // Label 2514: @146625
     /*  146625 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148235),
     /*  146630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146640 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146709), // Rule ID 53206 //
     /*  146645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146688 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146707 */     GIR_RootConstrainSelectedInstOperands,
     /*  146708 */     // GIR_Coverage, 53206,
     /*  146708 */     GIR_EraseRootFromParent_Done,
     /*  146709 */   // Label 2633: @146709
     /*  146709 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(146778), // Rule ID 53207 //
     /*  146714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146757 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146776 */     GIR_RootConstrainSelectedInstOperands,
     /*  146777 */     // GIR_Coverage, 53207,
     /*  146777 */     GIR_EraseRootFromParent_Done,
     /*  146778 */   // Label 2634: @146778
     /*  146778 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(146847), // Rule ID 53208 //
     /*  146783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146826 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146845 */     GIR_RootConstrainSelectedInstOperands,
     /*  146846 */     // GIR_Coverage, 53208,
     /*  146846 */     GIR_EraseRootFromParent_Done,
     /*  146847 */   // Label 2635: @146847
     /*  146847 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(146916), // Rule ID 53209 //
     /*  146852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146895 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146914 */     GIR_RootConstrainSelectedInstOperands,
     /*  146915 */     // GIR_Coverage, 53209,
     /*  146915 */     GIR_EraseRootFromParent_Done,
     /*  146916 */   // Label 2636: @146916
     /*  146916 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(146982), // Rule ID 71809 //
     /*  146921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146963 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146980 */     GIR_RootConstrainSelectedInstOperands,
     /*  146981 */     // GIR_Coverage, 71809,
     /*  146981 */     GIR_EraseRootFromParent_Done,
     /*  146982 */   // Label 2637: @146982
     /*  146982 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(147048), // Rule ID 71810 //
     /*  146987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147029 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147046 */     GIR_RootConstrainSelectedInstOperands,
     /*  147047 */     // GIR_Coverage, 71810,
     /*  147047 */     GIR_EraseRootFromParent_Done,
     /*  147048 */   // Label 2638: @147048
     /*  147048 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147114), // Rule ID 71807 //
     /*  147053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147095 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147112 */     GIR_RootConstrainSelectedInstOperands,
     /*  147113 */     // GIR_Coverage, 71807,
     /*  147113 */     GIR_EraseRootFromParent_Done,
     /*  147114 */   // Label 2639: @147114
     /*  147114 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147180), // Rule ID 71808 //
     /*  147119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147161 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147178 */     GIR_RootConstrainSelectedInstOperands,
     /*  147179 */     // GIR_Coverage, 71808,
     /*  147179 */     GIR_EraseRootFromParent_Done,
     /*  147180 */   // Label 2640: @147180
     /*  147180 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147249), // Rule ID 53210 //
     /*  147185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147228 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147247 */     GIR_RootConstrainSelectedInstOperands,
     /*  147248 */     // GIR_Coverage, 53210,
     /*  147248 */     GIR_EraseRootFromParent_Done,
     /*  147249 */   // Label 2641: @147249
     /*  147249 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147318), // Rule ID 53211 //
     /*  147254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147297 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147316 */     GIR_RootConstrainSelectedInstOperands,
     /*  147317 */     // GIR_Coverage, 53211,
     /*  147317 */     GIR_EraseRootFromParent_Done,
     /*  147318 */   // Label 2642: @147318
     /*  147318 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147387), // Rule ID 71803 //
     /*  147323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147366 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147385 */     GIR_RootConstrainSelectedInstOperands,
     /*  147386 */     // GIR_Coverage, 71803,
     /*  147386 */     GIR_EraseRootFromParent_Done,
     /*  147387 */   // Label 2643: @147387
     /*  147387 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147456), // Rule ID 71804 //
     /*  147392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147435 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147454 */     GIR_RootConstrainSelectedInstOperands,
     /*  147455 */     // GIR_Coverage, 71804,
     /*  147455 */     GIR_EraseRootFromParent_Done,
     /*  147456 */   // Label 2644: @147456
     /*  147456 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147525), // Rule ID 71805 //
     /*  147461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147504 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147523 */     GIR_RootConstrainSelectedInstOperands,
     /*  147524 */     // GIR_Coverage, 71805,
     /*  147524 */     GIR_EraseRootFromParent_Done,
     /*  147525 */   // Label 2645: @147525
     /*  147525 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147594), // Rule ID 71806 //
     /*  147530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147573 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147592 */     GIR_RootConstrainSelectedInstOperands,
     /*  147593 */     // GIR_Coverage, 71806,
     /*  147593 */     GIR_EraseRootFromParent_Done,
     /*  147594 */   // Label 2646: @147594
     /*  147594 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147663), // Rule ID 71811 //
     /*  147599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147642 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147661 */     GIR_RootConstrainSelectedInstOperands,
     /*  147662 */     // GIR_Coverage, 71811,
     /*  147662 */     GIR_EraseRootFromParent_Done,
     /*  147663 */   // Label 2647: @147663
     /*  147663 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147732), // Rule ID 71812 //
     /*  147668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147711 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147730 */     GIR_RootConstrainSelectedInstOperands,
     /*  147731 */     // GIR_Coverage, 71812,
     /*  147731 */     GIR_EraseRootFromParent_Done,
     /*  147732 */   // Label 2648: @147732
     /*  147732 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147798), // Rule ID 71815 //
     /*  147737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147779 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147796 */     GIR_RootConstrainSelectedInstOperands,
     /*  147797 */     // GIR_Coverage, 71815,
     /*  147797 */     GIR_EraseRootFromParent_Done,
     /*  147798 */   // Label 2649: @147798
     /*  147798 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147864), // Rule ID 71816 //
     /*  147803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147845 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147862 */     GIR_RootConstrainSelectedInstOperands,
     /*  147863 */     // GIR_Coverage, 71816,
     /*  147863 */     GIR_EraseRootFromParent_Done,
     /*  147864 */   // Label 2650: @147864
     /*  147864 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147930), // Rule ID 71813 //
     /*  147869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147911 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147928 */     GIR_RootConstrainSelectedInstOperands,
     /*  147929 */     // GIR_Coverage, 71813,
     /*  147929 */     GIR_EraseRootFromParent_Done,
     /*  147930 */   // Label 2651: @147930
     /*  147930 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(147996), // Rule ID 71814 //
     /*  147935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147977 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147994 */     GIR_RootConstrainSelectedInstOperands,
     /*  147995 */     // GIR_Coverage, 71814,
     /*  147995 */     GIR_EraseRootFromParent_Done,
     /*  147996 */   // Label 2652: @147996
     /*  147996 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(148039), // Rule ID 71829 //
     /*  148001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148022 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148037 */     GIR_RootConstrainSelectedInstOperands,
     /*  148038 */     // GIR_Coverage, 71829,
     /*  148038 */     GIR_EraseRootFromParent_Done,
     /*  148039 */   // Label 2653: @148039
     /*  148039 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(148082), // Rule ID 71830 //
     /*  148044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148065 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  148074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148080 */     GIR_RootConstrainSelectedInstOperands,
     /*  148081 */     // GIR_Coverage, 71830,
     /*  148081 */     GIR_EraseRootFromParent_Done,
     /*  148082 */   // Label 2654: @148082
     /*  148082 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(148125), // Rule ID 53216 //
     /*  148087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148108 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148123 */     GIR_RootConstrainSelectedInstOperands,
     /*  148124 */     // GIR_Coverage, 53216,
     /*  148124 */     GIR_EraseRootFromParent_Done,
     /*  148125 */   // Label 2655: @148125
     /*  148125 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(148168), // Rule ID 53217 //
     /*  148130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  148151 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  148154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  148160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148166 */     GIR_RootConstrainSelectedInstOperands,
     /*  148167 */     // GIR_Coverage, 53217,
     /*  148167 */     GIR_EraseRootFromParent_Done,
     /*  148168 */   // Label 2656: @148168
     /*  148168 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(148201), // Rule ID 53204 //
     /*  148173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148184 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  148187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148199 */     GIR_RootConstrainSelectedInstOperands,
     /*  148200 */     // GIR_Coverage, 53204,
     /*  148200 */     GIR_EraseRootFromParent_Done,
     /*  148201 */   // Label 2657: @148201
     /*  148201 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(148234), // Rule ID 53205 //
     /*  148206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148217 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  148220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148232 */     GIR_RootConstrainSelectedInstOperands,
     /*  148233 */     // GIR_Coverage, 53205,
     /*  148233 */     GIR_EraseRootFromParent_Done,
     /*  148234 */   // Label 2658: @148234
     /*  148234 */   GIM_Reject,
     /*  148235 */ // Label 2632: @148235
     /*  148235 */ GIM_Reject,
     /*  148236 */ // Label 2515: @148236
     /*  148236 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148350),
     /*  148241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  148244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  148247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148259 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148304), // Rule ID 47928 //
     /*  148264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148267 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  148267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  148270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  148284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148302 */     GIR_RootConstrainSelectedInstOperands,
     /*  148303 */     // GIR_Coverage, 47928,
     /*  148303 */     GIR_EraseRootFromParent_Done,
     /*  148304 */   // Label 2660: @148304
     /*  148304 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148349), // Rule ID 47929 //
     /*  148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148312 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  148312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  148315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  148329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148347 */     GIR_RootConstrainSelectedInstOperands,
     /*  148348 */     // GIR_Coverage, 47929,
     /*  148348 */     GIR_EraseRootFromParent_Done,
     /*  148349 */   // Label 2661: @148349
     /*  148349 */   GIM_Reject,
     /*  148350 */ // Label 2659: @148350
     /*  148350 */ GIM_Reject,
     /*  148351 */ // Label 2516: @148351
     /*  148351 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148465),
     /*  148356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  148359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  148362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148374 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148419), // Rule ID 47948 //
     /*  148379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148382 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  148382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  148385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  148399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  148414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148417 */     GIR_RootConstrainSelectedInstOperands,
     /*  148418 */     // GIR_Coverage, 47948,
     /*  148418 */     GIR_EraseRootFromParent_Done,
     /*  148419 */   // Label 2663: @148419
     /*  148419 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148464), // Rule ID 47949 //
     /*  148424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148427 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  148427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  148430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  148444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  148459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148462 */     GIR_RootConstrainSelectedInstOperands,
     /*  148463 */     // GIR_Coverage, 47949,
     /*  148463 */     GIR_EraseRootFromParent_Done,
     /*  148464 */   // Label 2664: @148464
     /*  148464 */   GIM_Reject,
     /*  148465 */ // Label 2662: @148465
     /*  148465 */ GIM_Reject,
     /*  148466 */ // Label 2517: @148466
     /*  148466 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(148580),
     /*  148471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  148474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148489 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148534), // Rule ID 47984 //
     /*  148494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148497 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  148497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148532 */     GIR_RootConstrainSelectedInstOperands,
     /*  148533 */     // GIR_Coverage, 47984,
     /*  148533 */     GIR_EraseRootFromParent_Done,
     /*  148534 */   // Label 2666: @148534
     /*  148534 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148579), // Rule ID 47985 //
     /*  148539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148542 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  148542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148577 */     GIR_RootConstrainSelectedInstOperands,
     /*  148578 */     // GIR_Coverage, 47985,
     /*  148578 */     GIR_EraseRootFromParent_Done,
     /*  148579 */   // Label 2667: @148579
     /*  148579 */   GIM_Reject,
     /*  148580 */ // Label 2665: @148580
     /*  148580 */ GIM_Reject,
     /*  148581 */ // Label 2518: @148581
     /*  148581 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148695),
     /*  148586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  148589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148604 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148649), // Rule ID 48000 //
     /*  148609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  148612 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  148612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148647 */     GIR_RootConstrainSelectedInstOperands,
     /*  148648 */     // GIR_Coverage, 48000,
     /*  148648 */     GIR_EraseRootFromParent_Done,
     /*  148649 */   // Label 2669: @148649
     /*  148649 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148694), // Rule ID 48001 //
     /*  148654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  148657 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  148657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148692 */     GIR_RootConstrainSelectedInstOperands,
     /*  148693 */     // GIR_Coverage, 48001,
     /*  148693 */     GIR_EraseRootFromParent_Done,
     /*  148694 */   // Label 2670: @148694
     /*  148694 */   GIM_Reject,
     /*  148695 */ // Label 2668: @148695
     /*  148695 */ GIM_Reject,
     /*  148696 */ // Label 2519: @148696
     /*  148696 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150306),
     /*  148701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148711 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(148780), // Rule ID 53224 //
     /*  148716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148759 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148778 */     GIR_RootConstrainSelectedInstOperands,
     /*  148779 */     // GIR_Coverage, 53224,
     /*  148779 */     GIR_EraseRootFromParent_Done,
     /*  148780 */   // Label 2672: @148780
     /*  148780 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(148849), // Rule ID 53225 //
     /*  148785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148828 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148847 */     GIR_RootConstrainSelectedInstOperands,
     /*  148848 */     // GIR_Coverage, 53225,
     /*  148848 */     GIR_EraseRootFromParent_Done,
     /*  148849 */   // Label 2673: @148849
     /*  148849 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(148918), // Rule ID 53226 //
     /*  148854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148897 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148916 */     GIR_RootConstrainSelectedInstOperands,
     /*  148917 */     // GIR_Coverage, 53226,
     /*  148917 */     GIR_EraseRootFromParent_Done,
     /*  148918 */   // Label 2674: @148918
     /*  148918 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(148987), // Rule ID 53227 //
     /*  148923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148966 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148985 */     GIR_RootConstrainSelectedInstOperands,
     /*  148986 */     // GIR_Coverage, 53227,
     /*  148986 */     GIR_EraseRootFromParent_Done,
     /*  148987 */   // Label 2675: @148987
     /*  148987 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(149053), // Rule ID 71837 //
     /*  148992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149034 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149051 */     GIR_RootConstrainSelectedInstOperands,
     /*  149052 */     // GIR_Coverage, 71837,
     /*  149052 */     GIR_EraseRootFromParent_Done,
     /*  149053 */   // Label 2676: @149053
     /*  149053 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149119), // Rule ID 71838 //
     /*  149058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149100 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149117 */     GIR_RootConstrainSelectedInstOperands,
     /*  149118 */     // GIR_Coverage, 71838,
     /*  149118 */     GIR_EraseRootFromParent_Done,
     /*  149119 */   // Label 2677: @149119
     /*  149119 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149185), // Rule ID 71835 //
     /*  149124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149166 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149183 */     GIR_RootConstrainSelectedInstOperands,
     /*  149184 */     // GIR_Coverage, 71835,
     /*  149184 */     GIR_EraseRootFromParent_Done,
     /*  149185 */   // Label 2678: @149185
     /*  149185 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149251), // Rule ID 71836 //
     /*  149190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149232 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149249 */     GIR_RootConstrainSelectedInstOperands,
     /*  149250 */     // GIR_Coverage, 71836,
     /*  149250 */     GIR_EraseRootFromParent_Done,
     /*  149251 */   // Label 2679: @149251
     /*  149251 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149320), // Rule ID 53228 //
     /*  149256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149299 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149318 */     GIR_RootConstrainSelectedInstOperands,
     /*  149319 */     // GIR_Coverage, 53228,
     /*  149319 */     GIR_EraseRootFromParent_Done,
     /*  149320 */   // Label 2680: @149320
     /*  149320 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149389), // Rule ID 53229 //
     /*  149325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149368 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149387 */     GIR_RootConstrainSelectedInstOperands,
     /*  149388 */     // GIR_Coverage, 53229,
     /*  149388 */     GIR_EraseRootFromParent_Done,
     /*  149389 */   // Label 2681: @149389
     /*  149389 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149458), // Rule ID 71831 //
     /*  149394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149437 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149456 */     GIR_RootConstrainSelectedInstOperands,
     /*  149457 */     // GIR_Coverage, 71831,
     /*  149457 */     GIR_EraseRootFromParent_Done,
     /*  149458 */   // Label 2682: @149458
     /*  149458 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149527), // Rule ID 71832 //
     /*  149463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149506 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149525 */     GIR_RootConstrainSelectedInstOperands,
     /*  149526 */     // GIR_Coverage, 71832,
     /*  149526 */     GIR_EraseRootFromParent_Done,
     /*  149527 */   // Label 2683: @149527
     /*  149527 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149596), // Rule ID 71833 //
     /*  149532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149575 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149594 */     GIR_RootConstrainSelectedInstOperands,
     /*  149595 */     // GIR_Coverage, 71833,
     /*  149595 */     GIR_EraseRootFromParent_Done,
     /*  149596 */   // Label 2684: @149596
     /*  149596 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149665), // Rule ID 71834 //
     /*  149601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149644 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149663 */     GIR_RootConstrainSelectedInstOperands,
     /*  149664 */     // GIR_Coverage, 71834,
     /*  149664 */     GIR_EraseRootFromParent_Done,
     /*  149665 */   // Label 2685: @149665
     /*  149665 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149734), // Rule ID 71839 //
     /*  149670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149713 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149732 */     GIR_RootConstrainSelectedInstOperands,
     /*  149733 */     // GIR_Coverage, 71839,
     /*  149733 */     GIR_EraseRootFromParent_Done,
     /*  149734 */   // Label 2686: @149734
     /*  149734 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149803), // Rule ID 71840 //
     /*  149739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149782 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149801 */     GIR_RootConstrainSelectedInstOperands,
     /*  149802 */     // GIR_Coverage, 71840,
     /*  149802 */     GIR_EraseRootFromParent_Done,
     /*  149803 */   // Label 2687: @149803
     /*  149803 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149869), // Rule ID 71843 //
     /*  149808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149850 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149867 */     GIR_RootConstrainSelectedInstOperands,
     /*  149868 */     // GIR_Coverage, 71843,
     /*  149868 */     GIR_EraseRootFromParent_Done,
     /*  149869 */   // Label 2688: @149869
     /*  149869 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149935), // Rule ID 71844 //
     /*  149874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149916 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149933 */     GIR_RootConstrainSelectedInstOperands,
     /*  149934 */     // GIR_Coverage, 71844,
     /*  149934 */     GIR_EraseRootFromParent_Done,
     /*  149935 */   // Label 2689: @149935
     /*  149935 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(150001), // Rule ID 71841 //
     /*  149940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149982 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149999 */     GIR_RootConstrainSelectedInstOperands,
     /*  150000 */     // GIR_Coverage, 71841,
     /*  150000 */     GIR_EraseRootFromParent_Done,
     /*  150001 */   // Label 2690: @150001
     /*  150001 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(150067), // Rule ID 71842 //
     /*  150006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  150025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  150029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150048 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  150051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150065 */     GIR_RootConstrainSelectedInstOperands,
     /*  150066 */     // GIR_Coverage, 71842,
     /*  150066 */     GIR_EraseRootFromParent_Done,
     /*  150067 */   // Label 2691: @150067
     /*  150067 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(150110), // Rule ID 71857 //
     /*  150072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150093 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150108 */     GIR_RootConstrainSelectedInstOperands,
     /*  150109 */     // GIR_Coverage, 71857,
     /*  150109 */     GIR_EraseRootFromParent_Done,
     /*  150110 */   // Label 2692: @150110
     /*  150110 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(150153), // Rule ID 71858 //
     /*  150115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150136 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150151 */     GIR_RootConstrainSelectedInstOperands,
     /*  150152 */     // GIR_Coverage, 71858,
     /*  150152 */     GIR_EraseRootFromParent_Done,
     /*  150153 */   // Label 2693: @150153
     /*  150153 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(150196), // Rule ID 53234 //
     /*  150158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150179 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150194 */     GIR_RootConstrainSelectedInstOperands,
     /*  150195 */     // GIR_Coverage, 53234,
     /*  150195 */     GIR_EraseRootFromParent_Done,
     /*  150196 */   // Label 2694: @150196
     /*  150196 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150239), // Rule ID 53235 //
     /*  150201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150222 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  150225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150237 */     GIR_RootConstrainSelectedInstOperands,
     /*  150238 */     // GIR_Coverage, 53235,
     /*  150238 */     GIR_EraseRootFromParent_Done,
     /*  150239 */   // Label 2695: @150239
     /*  150239 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150272), // Rule ID 53222 //
     /*  150244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150255 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  150258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150270 */     GIR_RootConstrainSelectedInstOperands,
     /*  150271 */     // GIR_Coverage, 53222,
     /*  150271 */     GIR_EraseRootFromParent_Done,
     /*  150272 */   // Label 2696: @150272
     /*  150272 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150305), // Rule ID 53223 //
     /*  150277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150288 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  150291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150303 */     GIR_RootConstrainSelectedInstOperands,
     /*  150304 */     // GIR_Coverage, 53223,
     /*  150304 */     GIR_EraseRootFromParent_Done,
     /*  150305 */   // Label 2697: @150305
     /*  150305 */   GIM_Reject,
     /*  150306 */ // Label 2671: @150306
     /*  150306 */ GIM_Reject,
     /*  150307 */ // Label 2520: @150307
     /*  150307 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150421),
     /*  150312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  150315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  150318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150330 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150375), // Rule ID 47944 //
     /*  150335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150338 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  150338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  150341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  150355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150373 */     GIR_RootConstrainSelectedInstOperands,
     /*  150374 */     // GIR_Coverage, 47944,
     /*  150374 */     GIR_EraseRootFromParent_Done,
     /*  150375 */   // Label 2699: @150375
     /*  150375 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150420), // Rule ID 47945 //
     /*  150380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150383 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  150383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  150386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  150400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150418 */     GIR_RootConstrainSelectedInstOperands,
     /*  150419 */     // GIR_Coverage, 47945,
     /*  150419 */     GIR_EraseRootFromParent_Done,
     /*  150420 */   // Label 2700: @150420
     /*  150420 */   GIM_Reject,
     /*  150421 */ // Label 2698: @150421
     /*  150421 */ GIM_Reject,
     /*  150422 */ // Label 2521: @150422
     /*  150422 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150536),
     /*  150427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  150430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  150433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  150445 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150490), // Rule ID 47972 //
     /*  150450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150453 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  150453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150488 */     GIR_RootConstrainSelectedInstOperands,
     /*  150489 */     // GIR_Coverage, 47972,
     /*  150489 */     GIR_EraseRootFromParent_Done,
     /*  150490 */   // Label 2702: @150490
     /*  150490 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150535), // Rule ID 47973 //
     /*  150495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150498 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  150498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150533 */     GIR_RootConstrainSelectedInstOperands,
     /*  150534 */     // GIR_Coverage, 47973,
     /*  150534 */     GIR_EraseRootFromParent_Done,
     /*  150535 */   // Label 2703: @150535
     /*  150535 */   GIM_Reject,
     /*  150536 */ // Label 2701: @150536
     /*  150536 */ GIM_Reject,
     /*  150537 */ // Label 2522: @150537
     /*  150537 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(150651),
     /*  150542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  150545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150560 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150605), // Rule ID 47988 //
     /*  150565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150568 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  150568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150603 */     GIR_RootConstrainSelectedInstOperands,
     /*  150604 */     // GIR_Coverage, 47988,
     /*  150604 */     GIR_EraseRootFromParent_Done,
     /*  150605 */   // Label 2705: @150605
     /*  150605 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150650), // Rule ID 47989 //
     /*  150610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150613 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  150613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150648 */     GIR_RootConstrainSelectedInstOperands,
     /*  150649 */     // GIR_Coverage, 47989,
     /*  150649 */     GIR_EraseRootFromParent_Done,
     /*  150650 */   // Label 2706: @150650
     /*  150650 */   GIM_Reject,
     /*  150651 */ // Label 2704: @150651
     /*  150651 */ GIM_Reject,
     /*  150652 */ // Label 2523: @150652
     /*  150652 */ GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150766),
     /*  150657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  150660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  150663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150675 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150720), // Rule ID 48004 //
     /*  150680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  150683 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  150683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150718 */     GIR_RootConstrainSelectedInstOperands,
     /*  150719 */     // GIR_Coverage, 48004,
     /*  150719 */     GIR_EraseRootFromParent_Done,
     /*  150720 */   // Label 2708: @150720
     /*  150720 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150765), // Rule ID 48005 //
     /*  150725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  150728 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  150728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150763 */     GIR_RootConstrainSelectedInstOperands,
     /*  150764 */     // GIR_Coverage, 48005,
     /*  150764 */     GIR_EraseRootFromParent_Done,
     /*  150765 */   // Label 2709: @150765
     /*  150765 */   GIM_Reject,
     /*  150766 */ // Label 2707: @150766
     /*  150766 */ GIM_Reject,
     /*  150767 */ // Label 2524: @150767
     /*  150767 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(152377),
     /*  150772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150782 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(150851), // Rule ID 53242 //
     /*  150787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150830 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150849 */     GIR_RootConstrainSelectedInstOperands,
     /*  150850 */     // GIR_Coverage, 53242,
     /*  150850 */     GIR_EraseRootFromParent_Done,
     /*  150851 */   // Label 2711: @150851
     /*  150851 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(150920), // Rule ID 53243 //
     /*  150856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150899 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150918 */     GIR_RootConstrainSelectedInstOperands,
     /*  150919 */     // GIR_Coverage, 53243,
     /*  150919 */     GIR_EraseRootFromParent_Done,
     /*  150920 */   // Label 2712: @150920
     /*  150920 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(150989), // Rule ID 53244 //
     /*  150925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150968 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150987 */     GIR_RootConstrainSelectedInstOperands,
     /*  150988 */     // GIR_Coverage, 53244,
     /*  150988 */     GIR_EraseRootFromParent_Done,
     /*  150989 */   // Label 2713: @150989
     /*  150989 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(151058), // Rule ID 53245 //
     /*  150994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151037 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151056 */     GIR_RootConstrainSelectedInstOperands,
     /*  151057 */     // GIR_Coverage, 53245,
     /*  151057 */     GIR_EraseRootFromParent_Done,
     /*  151058 */   // Label 2714: @151058
     /*  151058 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151124), // Rule ID 71865 //
     /*  151063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151105 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151122 */     GIR_RootConstrainSelectedInstOperands,
     /*  151123 */     // GIR_Coverage, 71865,
     /*  151123 */     GIR_EraseRootFromParent_Done,
     /*  151124 */   // Label 2715: @151124
     /*  151124 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151190), // Rule ID 71866 //
     /*  151129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151171 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151188 */     GIR_RootConstrainSelectedInstOperands,
     /*  151189 */     // GIR_Coverage, 71866,
     /*  151189 */     GIR_EraseRootFromParent_Done,
     /*  151190 */   // Label 2716: @151190
     /*  151190 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151256), // Rule ID 71863 //
     /*  151195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151237 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151254 */     GIR_RootConstrainSelectedInstOperands,
     /*  151255 */     // GIR_Coverage, 71863,
     /*  151255 */     GIR_EraseRootFromParent_Done,
     /*  151256 */   // Label 2717: @151256
     /*  151256 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151322), // Rule ID 71864 //
     /*  151261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151303 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151320 */     GIR_RootConstrainSelectedInstOperands,
     /*  151321 */     // GIR_Coverage, 71864,
     /*  151321 */     GIR_EraseRootFromParent_Done,
     /*  151322 */   // Label 2718: @151322
     /*  151322 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151391), // Rule ID 53246 //
     /*  151327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151370 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151389 */     GIR_RootConstrainSelectedInstOperands,
     /*  151390 */     // GIR_Coverage, 53246,
     /*  151390 */     GIR_EraseRootFromParent_Done,
     /*  151391 */   // Label 2719: @151391
     /*  151391 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151460), // Rule ID 53247 //
     /*  151396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151439 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151458 */     GIR_RootConstrainSelectedInstOperands,
     /*  151459 */     // GIR_Coverage, 53247,
     /*  151459 */     GIR_EraseRootFromParent_Done,
     /*  151460 */   // Label 2720: @151460
     /*  151460 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151529), // Rule ID 71859 //
     /*  151465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151508 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151527 */     GIR_RootConstrainSelectedInstOperands,
     /*  151528 */     // GIR_Coverage, 71859,
     /*  151528 */     GIR_EraseRootFromParent_Done,
     /*  151529 */   // Label 2721: @151529
     /*  151529 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151598), // Rule ID 71860 //
     /*  151534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151577 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151596 */     GIR_RootConstrainSelectedInstOperands,
     /*  151597 */     // GIR_Coverage, 71860,
     /*  151597 */     GIR_EraseRootFromParent_Done,
     /*  151598 */   // Label 2722: @151598
     /*  151598 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151667), // Rule ID 71861 //
     /*  151603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151646 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151665 */     GIR_RootConstrainSelectedInstOperands,
     /*  151666 */     // GIR_Coverage, 71861,
     /*  151666 */     GIR_EraseRootFromParent_Done,
     /*  151667 */   // Label 2723: @151667
     /*  151667 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151736), // Rule ID 71862 //
     /*  151672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151715 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151734 */     GIR_RootConstrainSelectedInstOperands,
     /*  151735 */     // GIR_Coverage, 71862,
     /*  151735 */     GIR_EraseRootFromParent_Done,
     /*  151736 */   // Label 2724: @151736
     /*  151736 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151805), // Rule ID 71867 //
     /*  151741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151784 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151803 */     GIR_RootConstrainSelectedInstOperands,
     /*  151804 */     // GIR_Coverage, 71867,
     /*  151804 */     GIR_EraseRootFromParent_Done,
     /*  151805 */   // Label 2725: @151805
     /*  151805 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151874), // Rule ID 71868 //
     /*  151810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151853 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151872 */     GIR_RootConstrainSelectedInstOperands,
     /*  151873 */     // GIR_Coverage, 71868,
     /*  151873 */     GIR_EraseRootFromParent_Done,
     /*  151874 */   // Label 2726: @151874
     /*  151874 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151940), // Rule ID 71871 //
     /*  151879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151921 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151938 */     GIR_RootConstrainSelectedInstOperands,
     /*  151939 */     // GIR_Coverage, 71871,
     /*  151939 */     GIR_EraseRootFromParent_Done,
     /*  151940 */   // Label 2727: @151940
     /*  151940 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(152006), // Rule ID 71872 //
     /*  151945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151987 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152004 */     GIR_RootConstrainSelectedInstOperands,
     /*  152005 */     // GIR_Coverage, 71872,
     /*  152005 */     GIR_EraseRootFromParent_Done,
     /*  152006 */   // Label 2728: @152006
     /*  152006 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152072), // Rule ID 71869 //
     /*  152011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  152030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  152034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152053 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  152056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152070 */     GIR_RootConstrainSelectedInstOperands,
     /*  152071 */     // GIR_Coverage, 71869,
     /*  152071 */     GIR_EraseRootFromParent_Done,
     /*  152072 */   // Label 2729: @152072
     /*  152072 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152138), // Rule ID 71870 //
     /*  152077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  152096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  152100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152119 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  152122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152136 */     GIR_RootConstrainSelectedInstOperands,
     /*  152137 */     // GIR_Coverage, 71870,
     /*  152137 */     GIR_EraseRootFromParent_Done,
     /*  152138 */   // Label 2730: @152138
     /*  152138 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152181), // Rule ID 71885 //
     /*  152143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152164 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152179 */     GIR_RootConstrainSelectedInstOperands,
     /*  152180 */     // GIR_Coverage, 71885,
     /*  152180 */     GIR_EraseRootFromParent_Done,
     /*  152181 */   // Label 2731: @152181
     /*  152181 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152224), // Rule ID 71886 //
     /*  152186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152207 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  152216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152222 */     GIR_RootConstrainSelectedInstOperands,
     /*  152223 */     // GIR_Coverage, 71886,
     /*  152223 */     GIR_EraseRootFromParent_Done,
     /*  152224 */   // Label 2732: @152224
     /*  152224 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152267), // Rule ID 53252 //
     /*  152229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152250 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152265 */     GIR_RootConstrainSelectedInstOperands,
     /*  152266 */     // GIR_Coverage, 53252,
     /*  152266 */     GIR_EraseRootFromParent_Done,
     /*  152267 */   // Label 2733: @152267
     /*  152267 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152310), // Rule ID 53253 //
     /*  152272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  152293 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  152296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  152302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152308 */     GIR_RootConstrainSelectedInstOperands,
     /*  152309 */     // GIR_Coverage, 53253,
     /*  152309 */     GIR_EraseRootFromParent_Done,
     /*  152310 */   // Label 2734: @152310
     /*  152310 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152343), // Rule ID 53240 //
     /*  152315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152326 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  152329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152341 */     GIR_RootConstrainSelectedInstOperands,
     /*  152342 */     // GIR_Coverage, 53240,
     /*  152342 */     GIR_EraseRootFromParent_Done,
     /*  152343 */   // Label 2735: @152343
     /*  152343 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152376), // Rule ID 53241 //
     /*  152348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152359 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  152362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152374 */     GIR_RootConstrainSelectedInstOperands,
     /*  152375 */     // GIR_Coverage, 53241,
     /*  152375 */     GIR_EraseRootFromParent_Done,
     /*  152376 */   // Label 2736: @152376
     /*  152376 */   GIM_Reject,
     /*  152377 */ // Label 2710: @152377
     /*  152377 */ GIM_Reject,
     /*  152378 */ // Label 2525: @152378
     /*  152378 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152492),
     /*  152383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  152386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  152389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  152401 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152446), // Rule ID 47960 //
     /*  152406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152409 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  152409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  152412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152444 */     GIR_RootConstrainSelectedInstOperands,
     /*  152445 */     // GIR_Coverage, 47960,
     /*  152445 */     GIR_EraseRootFromParent_Done,
     /*  152446 */   // Label 2738: @152446
     /*  152446 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152491), // Rule ID 47961 //
     /*  152451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152454 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  152454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  152457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152489 */     GIR_RootConstrainSelectedInstOperands,
     /*  152490 */     // GIR_Coverage, 47961,
     /*  152490 */     GIR_EraseRootFromParent_Done,
     /*  152491 */   // Label 2739: @152491
     /*  152491 */   GIM_Reject,
     /*  152492 */ // Label 2737: @152492
     /*  152492 */ GIM_Reject,
     /*  152493 */ // Label 2526: @152493
     /*  152493 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(152607),
     /*  152498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  152501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  152504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152516 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152561), // Rule ID 47976 //
     /*  152521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152524 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  152524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152559 */     GIR_RootConstrainSelectedInstOperands,
     /*  152560 */     // GIR_Coverage, 47976,
     /*  152560 */     GIR_EraseRootFromParent_Done,
     /*  152561 */   // Label 2741: @152561
     /*  152561 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152606), // Rule ID 47977 //
     /*  152566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152569 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  152569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152604 */     GIR_RootConstrainSelectedInstOperands,
     /*  152605 */     // GIR_Coverage, 47977,
     /*  152605 */     GIR_EraseRootFromParent_Done,
     /*  152606 */   // Label 2742: @152606
     /*  152606 */   GIM_Reject,
     /*  152607 */ // Label 2740: @152607
     /*  152607 */ GIM_Reject,
     /*  152608 */ // Label 2527: @152608
     /*  152608 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152722),
     /*  152613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  152616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152631 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152676), // Rule ID 47992 //
     /*  152636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152639 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  152639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152674 */     GIR_RootConstrainSelectedInstOperands,
     /*  152675 */     // GIR_Coverage, 47992,
     /*  152675 */     GIR_EraseRootFromParent_Done,
     /*  152676 */   // Label 2744: @152676
     /*  152676 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152721), // Rule ID 47993 //
     /*  152681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152684 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  152684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152719 */     GIR_RootConstrainSelectedInstOperands,
     /*  152720 */     // GIR_Coverage, 47993,
     /*  152720 */     GIR_EraseRootFromParent_Done,
     /*  152721 */   // Label 2745: @152721
     /*  152721 */   GIM_Reject,
     /*  152722 */ // Label 2743: @152722
     /*  152722 */ GIM_Reject,
     /*  152723 */ // Label 2528: @152723
     /*  152723 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154333),
     /*  152728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152738 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(152807), // Rule ID 53260 //
     /*  152743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152786 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152805 */     GIR_RootConstrainSelectedInstOperands,
     /*  152806 */     // GIR_Coverage, 53260,
     /*  152806 */     GIR_EraseRootFromParent_Done,
     /*  152807 */   // Label 2747: @152807
     /*  152807 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(152876), // Rule ID 53261 //
     /*  152812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152855 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152874 */     GIR_RootConstrainSelectedInstOperands,
     /*  152875 */     // GIR_Coverage, 53261,
     /*  152875 */     GIR_EraseRootFromParent_Done,
     /*  152876 */   // Label 2748: @152876
     /*  152876 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(152945), // Rule ID 53262 //
     /*  152881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152924 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152943 */     GIR_RootConstrainSelectedInstOperands,
     /*  152944 */     // GIR_Coverage, 53262,
     /*  152944 */     GIR_EraseRootFromParent_Done,
     /*  152945 */   // Label 2749: @152945
     /*  152945 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(153014), // Rule ID 53263 //
     /*  152950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152993 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153012 */     GIR_RootConstrainSelectedInstOperands,
     /*  153013 */     // GIR_Coverage, 53263,
     /*  153013 */     GIR_EraseRootFromParent_Done,
     /*  153014 */   // Label 2750: @153014
     /*  153014 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153080), // Rule ID 71893 //
     /*  153019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153061 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153078 */     GIR_RootConstrainSelectedInstOperands,
     /*  153079 */     // GIR_Coverage, 71893,
     /*  153079 */     GIR_EraseRootFromParent_Done,
     /*  153080 */   // Label 2751: @153080
     /*  153080 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153146), // Rule ID 71894 //
     /*  153085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153127 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153144 */     GIR_RootConstrainSelectedInstOperands,
     /*  153145 */     // GIR_Coverage, 71894,
     /*  153145 */     GIR_EraseRootFromParent_Done,
     /*  153146 */   // Label 2752: @153146
     /*  153146 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153212), // Rule ID 71891 //
     /*  153151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153193 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153210 */     GIR_RootConstrainSelectedInstOperands,
     /*  153211 */     // GIR_Coverage, 71891,
     /*  153211 */     GIR_EraseRootFromParent_Done,
     /*  153212 */   // Label 2753: @153212
     /*  153212 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153278), // Rule ID 71892 //
     /*  153217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153259 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153276 */     GIR_RootConstrainSelectedInstOperands,
     /*  153277 */     // GIR_Coverage, 71892,
     /*  153277 */     GIR_EraseRootFromParent_Done,
     /*  153278 */   // Label 2754: @153278
     /*  153278 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153347), // Rule ID 53264 //
     /*  153283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153326 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153345 */     GIR_RootConstrainSelectedInstOperands,
     /*  153346 */     // GIR_Coverage, 53264,
     /*  153346 */     GIR_EraseRootFromParent_Done,
     /*  153347 */   // Label 2755: @153347
     /*  153347 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153416), // Rule ID 53265 //
     /*  153352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153395 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153414 */     GIR_RootConstrainSelectedInstOperands,
     /*  153415 */     // GIR_Coverage, 53265,
     /*  153415 */     GIR_EraseRootFromParent_Done,
     /*  153416 */   // Label 2756: @153416
     /*  153416 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153485), // Rule ID 71887 //
     /*  153421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153464 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153483 */     GIR_RootConstrainSelectedInstOperands,
     /*  153484 */     // GIR_Coverage, 71887,
     /*  153484 */     GIR_EraseRootFromParent_Done,
     /*  153485 */   // Label 2757: @153485
     /*  153485 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153554), // Rule ID 71888 //
     /*  153490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153533 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153552 */     GIR_RootConstrainSelectedInstOperands,
     /*  153553 */     // GIR_Coverage, 71888,
     /*  153553 */     GIR_EraseRootFromParent_Done,
     /*  153554 */   // Label 2758: @153554
     /*  153554 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153623), // Rule ID 71889 //
     /*  153559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153602 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153621 */     GIR_RootConstrainSelectedInstOperands,
     /*  153622 */     // GIR_Coverage, 71889,
     /*  153622 */     GIR_EraseRootFromParent_Done,
     /*  153623 */   // Label 2759: @153623
     /*  153623 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153692), // Rule ID 71890 //
     /*  153628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153671 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153690 */     GIR_RootConstrainSelectedInstOperands,
     /*  153691 */     // GIR_Coverage, 71890,
     /*  153691 */     GIR_EraseRootFromParent_Done,
     /*  153692 */   // Label 2760: @153692
     /*  153692 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153761), // Rule ID 71895 //
     /*  153697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153740 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153759 */     GIR_RootConstrainSelectedInstOperands,
     /*  153760 */     // GIR_Coverage, 71895,
     /*  153760 */     GIR_EraseRootFromParent_Done,
     /*  153761 */   // Label 2761: @153761
     /*  153761 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153830), // Rule ID 71896 //
     /*  153766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153809 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153828 */     GIR_RootConstrainSelectedInstOperands,
     /*  153829 */     // GIR_Coverage, 71896,
     /*  153829 */     GIR_EraseRootFromParent_Done,
     /*  153830 */   // Label 2762: @153830
     /*  153830 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153896), // Rule ID 71899 //
     /*  153835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153877 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153894 */     GIR_RootConstrainSelectedInstOperands,
     /*  153895 */     // GIR_Coverage, 71899,
     /*  153895 */     GIR_EraseRootFromParent_Done,
     /*  153896 */   // Label 2763: @153896
     /*  153896 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153962), // Rule ID 71900 //
     /*  153901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153943 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153960 */     GIR_RootConstrainSelectedInstOperands,
     /*  153961 */     // GIR_Coverage, 71900,
     /*  153961 */     GIR_EraseRootFromParent_Done,
     /*  153962 */   // Label 2764: @153962
     /*  153962 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154028), // Rule ID 71897 //
     /*  153967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154009 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  154012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154026 */     GIR_RootConstrainSelectedInstOperands,
     /*  154027 */     // GIR_Coverage, 71897,
     /*  154027 */     GIR_EraseRootFromParent_Done,
     /*  154028 */   // Label 2765: @154028
     /*  154028 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154094), // Rule ID 71898 //
     /*  154033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  154052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  154056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154075 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  154078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154092 */     GIR_RootConstrainSelectedInstOperands,
     /*  154093 */     // GIR_Coverage, 71898,
     /*  154093 */     GIR_EraseRootFromParent_Done,
     /*  154094 */   // Label 2766: @154094
     /*  154094 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154137), // Rule ID 71913 //
     /*  154099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154120 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154135 */     GIR_RootConstrainSelectedInstOperands,
     /*  154136 */     // GIR_Coverage, 71913,
     /*  154136 */     GIR_EraseRootFromParent_Done,
     /*  154137 */   // Label 2767: @154137
     /*  154137 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154180), // Rule ID 71914 //
     /*  154142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154163 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  154172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154178 */     GIR_RootConstrainSelectedInstOperands,
     /*  154179 */     // GIR_Coverage, 71914,
     /*  154179 */     GIR_EraseRootFromParent_Done,
     /*  154180 */   // Label 2768: @154180
     /*  154180 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154223), // Rule ID 53270 //
     /*  154185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154206 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154221 */     GIR_RootConstrainSelectedInstOperands,
     /*  154222 */     // GIR_Coverage, 53270,
     /*  154222 */     GIR_EraseRootFromParent_Done,
     /*  154223 */   // Label 2769: @154223
     /*  154223 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154266), // Rule ID 53271 //
     /*  154228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  154249 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  154252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  154258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154264 */     GIR_RootConstrainSelectedInstOperands,
     /*  154265 */     // GIR_Coverage, 53271,
     /*  154265 */     GIR_EraseRootFromParent_Done,
     /*  154266 */   // Label 2770: @154266
     /*  154266 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154299), // Rule ID 53258 //
     /*  154271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154282 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  154285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154297 */     GIR_RootConstrainSelectedInstOperands,
     /*  154298 */     // GIR_Coverage, 53258,
     /*  154298 */     GIR_EraseRootFromParent_Done,
     /*  154299 */   // Label 2771: @154299
     /*  154299 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154332), // Rule ID 53259 //
     /*  154304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154315 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  154318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154330 */     GIR_RootConstrainSelectedInstOperands,
     /*  154331 */     // GIR_Coverage, 53259,
     /*  154331 */     GIR_EraseRootFromParent_Done,
     /*  154332 */   // Label 2772: @154332
     /*  154332 */   GIM_Reject,
     /*  154333 */ // Label 2746: @154333
     /*  154333 */ GIM_Reject,
     /*  154334 */ // Label 2529: @154334
     /*  154334 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154448),
     /*  154339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  154342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  154345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  154357 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154402), // Rule ID 47964 //
     /*  154362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154365 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  154365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  154368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  154382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154400 */     GIR_RootConstrainSelectedInstOperands,
     /*  154401 */     // GIR_Coverage, 47964,
     /*  154401 */     GIR_EraseRootFromParent_Done,
     /*  154402 */   // Label 2774: @154402
     /*  154402 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154447), // Rule ID 47965 //
     /*  154407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154410 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  154410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  154413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  154427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154445 */     GIR_RootConstrainSelectedInstOperands,
     /*  154446 */     // GIR_Coverage, 47965,
     /*  154446 */     GIR_EraseRootFromParent_Done,
     /*  154447 */   // Label 2775: @154447
     /*  154447 */   GIM_Reject,
     /*  154448 */ // Label 2773: @154448
     /*  154448 */ GIM_Reject,
     /*  154449 */ // Label 2530: @154449
     /*  154449 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154563),
     /*  154454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  154457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  154460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154472 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154517), // Rule ID 47980 //
     /*  154477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154480 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  154480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154515 */     GIR_RootConstrainSelectedInstOperands,
     /*  154516 */     // GIR_Coverage, 47980,
     /*  154516 */     GIR_EraseRootFromParent_Done,
     /*  154517 */   // Label 2777: @154517
     /*  154517 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154562), // Rule ID 47981 //
     /*  154522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154525 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  154525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154560 */     GIR_RootConstrainSelectedInstOperands,
     /*  154561 */     // GIR_Coverage, 47981,
     /*  154561 */     GIR_EraseRootFromParent_Done,
     /*  154562 */   // Label 2778: @154562
     /*  154562 */   GIM_Reject,
     /*  154563 */ // Label 2776: @154563
     /*  154563 */ GIM_Reject,
     /*  154564 */ // Label 2531: @154564
     /*  154564 */ GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(156174),
     /*  154569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154579 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154648), // Rule ID 53278 //
     /*  154584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154627 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154646 */     GIR_RootConstrainSelectedInstOperands,
     /*  154647 */     // GIR_Coverage, 53278,
     /*  154647 */     GIR_EraseRootFromParent_Done,
     /*  154648 */   // Label 2780: @154648
     /*  154648 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154717), // Rule ID 53279 //
     /*  154653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154696 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154715 */     GIR_RootConstrainSelectedInstOperands,
     /*  154716 */     // GIR_Coverage, 53279,
     /*  154716 */     GIR_EraseRootFromParent_Done,
     /*  154717 */   // Label 2781: @154717
     /*  154717 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154786), // Rule ID 53280 //
     /*  154722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154765 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154784 */     GIR_RootConstrainSelectedInstOperands,
     /*  154785 */     // GIR_Coverage, 53280,
     /*  154785 */     GIR_EraseRootFromParent_Done,
     /*  154786 */   // Label 2782: @154786
     /*  154786 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154855), // Rule ID 53281 //
     /*  154791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154834 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154853 */     GIR_RootConstrainSelectedInstOperands,
     /*  154854 */     // GIR_Coverage, 53281,
     /*  154854 */     GIR_EraseRootFromParent_Done,
     /*  154855 */   // Label 2783: @154855
     /*  154855 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154921), // Rule ID 71921 //
     /*  154860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154902 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154919 */     GIR_RootConstrainSelectedInstOperands,
     /*  154920 */     // GIR_Coverage, 71921,
     /*  154920 */     GIR_EraseRootFromParent_Done,
     /*  154921 */   // Label 2784: @154921
     /*  154921 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154987), // Rule ID 71922 //
     /*  154926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154968 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154985 */     GIR_RootConstrainSelectedInstOperands,
     /*  154986 */     // GIR_Coverage, 71922,
     /*  154986 */     GIR_EraseRootFromParent_Done,
     /*  154987 */   // Label 2785: @154987
     /*  154987 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155053), // Rule ID 71919 //
     /*  154992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155034 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155051 */     GIR_RootConstrainSelectedInstOperands,
     /*  155052 */     // GIR_Coverage, 71919,
     /*  155052 */     GIR_EraseRootFromParent_Done,
     /*  155053 */   // Label 2786: @155053
     /*  155053 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155119), // Rule ID 71920 //
     /*  155058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155100 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155117 */     GIR_RootConstrainSelectedInstOperands,
     /*  155118 */     // GIR_Coverage, 71920,
     /*  155118 */     GIR_EraseRootFromParent_Done,
     /*  155119 */   // Label 2787: @155119
     /*  155119 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155188), // Rule ID 53282 //
     /*  155124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155167 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  155180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155186 */     GIR_RootConstrainSelectedInstOperands,
     /*  155187 */     // GIR_Coverage, 53282,
     /*  155187 */     GIR_EraseRootFromParent_Done,
     /*  155188 */   // Label 2788: @155188
     /*  155188 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155257), // Rule ID 53283 //
     /*  155193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155236 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  155249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155255 */     GIR_RootConstrainSelectedInstOperands,
     /*  155256 */     // GIR_Coverage, 53283,
     /*  155256 */     GIR_EraseRootFromParent_Done,
     /*  155257 */   // Label 2789: @155257
     /*  155257 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155326), // Rule ID 71915 //
     /*  155262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  155285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155305 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155324 */     GIR_RootConstrainSelectedInstOperands,
     /*  155325 */     // GIR_Coverage, 71915,
     /*  155325 */     GIR_EraseRootFromParent_Done,
     /*  155326 */   // Label 2790: @155326
     /*  155326 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155395), // Rule ID 71916 //
     /*  155331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  155354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155374 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155393 */     GIR_RootConstrainSelectedInstOperands,
     /*  155394 */     // GIR_Coverage, 71916,
     /*  155394 */     GIR_EraseRootFromParent_Done,
     /*  155395 */   // Label 2791: @155395
     /*  155395 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155464), // Rule ID 71917 //
     /*  155400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155443 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155462 */     GIR_RootConstrainSelectedInstOperands,
     /*  155463 */     // GIR_Coverage, 71917,
     /*  155463 */     GIR_EraseRootFromParent_Done,
     /*  155464 */   // Label 2792: @155464
     /*  155464 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155533), // Rule ID 71918 //
     /*  155469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155512 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155531 */     GIR_RootConstrainSelectedInstOperands,
     /*  155532 */     // GIR_Coverage, 71918,
     /*  155532 */     GIR_EraseRootFromParent_Done,
     /*  155533 */   // Label 2793: @155533
     /*  155533 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155602), // Rule ID 71923 //
     /*  155538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155581 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155600 */     GIR_RootConstrainSelectedInstOperands,
     /*  155601 */     // GIR_Coverage, 71923,
     /*  155601 */     GIR_EraseRootFromParent_Done,
     /*  155602 */   // Label 2794: @155602
     /*  155602 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155671), // Rule ID 71924 //
     /*  155607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155650 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155669 */     GIR_RootConstrainSelectedInstOperands,
     /*  155670 */     // GIR_Coverage, 71924,
     /*  155670 */     GIR_EraseRootFromParent_Done,
     /*  155671 */   // Label 2795: @155671
     /*  155671 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155737), // Rule ID 71927 //
     /*  155676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155718 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155735 */     GIR_RootConstrainSelectedInstOperands,
     /*  155736 */     // GIR_Coverage, 71927,
     /*  155736 */     GIR_EraseRootFromParent_Done,
     /*  155737 */   // Label 2796: @155737
     /*  155737 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155803), // Rule ID 71928 //
     /*  155742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155784 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155801 */     GIR_RootConstrainSelectedInstOperands,
     /*  155802 */     // GIR_Coverage, 71928,
     /*  155802 */     GIR_EraseRootFromParent_Done,
     /*  155803 */   // Label 2797: @155803
     /*  155803 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155869), // Rule ID 71925 //
     /*  155808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155850 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155867 */     GIR_RootConstrainSelectedInstOperands,
     /*  155868 */     // GIR_Coverage, 71925,
     /*  155868 */     GIR_EraseRootFromParent_Done,
     /*  155869 */   // Label 2798: @155869
     /*  155869 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155935), // Rule ID 71926 //
     /*  155874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155916 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155933 */     GIR_RootConstrainSelectedInstOperands,
     /*  155934 */     // GIR_Coverage, 71926,
     /*  155934 */     GIR_EraseRootFromParent_Done,
     /*  155935 */   // Label 2799: @155935
     /*  155935 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155978), // Rule ID 71941 //
     /*  155940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155961 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155976 */     GIR_RootConstrainSelectedInstOperands,
     /*  155977 */     // GIR_Coverage, 71941,
     /*  155977 */     GIR_EraseRootFromParent_Done,
     /*  155978 */   // Label 2800: @155978
     /*  155978 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156021), // Rule ID 71942 //
     /*  155983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156004 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  156011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  156013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156019 */     GIR_RootConstrainSelectedInstOperands,
     /*  156020 */     // GIR_Coverage, 71942,
     /*  156020 */     GIR_EraseRootFromParent_Done,
     /*  156021 */   // Label 2801: @156021
     /*  156021 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156064), // Rule ID 53288 //
     /*  156026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  156037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  156041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  156045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156047 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  156047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156062 */     GIR_RootConstrainSelectedInstOperands,
     /*  156063 */     // GIR_Coverage, 53288,
     /*  156063 */     GIR_EraseRootFromParent_Done,
     /*  156064 */   // Label 2802: @156064
     /*  156064 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156107), // Rule ID 53289 //
     /*  156069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  156080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  156084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  156088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  156090 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  156093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  156099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156105 */     GIR_RootConstrainSelectedInstOperands,
     /*  156106 */     // GIR_Coverage, 53289,
     /*  156106 */     GIR_EraseRootFromParent_Done,
     /*  156107 */   // Label 2803: @156107
     /*  156107 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156140), // Rule ID 53276 //
     /*  156112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156123 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  156123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  156126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156138 */     GIR_RootConstrainSelectedInstOperands,
     /*  156139 */     // GIR_Coverage, 53276,
     /*  156139 */     GIR_EraseRootFromParent_Done,
     /*  156140 */   // Label 2804: @156140
     /*  156140 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156173), // Rule ID 53277 //
     /*  156145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  156156 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  156156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  156159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156171 */     GIR_RootConstrainSelectedInstOperands,
     /*  156172 */     // GIR_Coverage, 53277,
     /*  156172 */     GIR_EraseRootFromParent_Done,
     /*  156173 */   // Label 2805: @156173
     /*  156173 */   GIM_Reject,
     /*  156174 */ // Label 2779: @156174
     /*  156174 */ GIM_Reject,
     /*  156175 */ // Label 2532: @156175
     /*  156175 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156289),
     /*  156180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  156183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  156186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  156198 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156243), // Rule ID 47968 //
     /*  156203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  156206 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  156206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  156209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  156223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156241 */     GIR_RootConstrainSelectedInstOperands,
     /*  156242 */     // GIR_Coverage, 47968,
     /*  156242 */     GIR_EraseRootFromParent_Done,
     /*  156243 */   // Label 2807: @156243
     /*  156243 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156288), // Rule ID 47969 //
     /*  156248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  156251 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  156251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  156254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  156268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  156277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  156280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  156286 */     GIR_RootConstrainSelectedInstOperands,
     /*  156287 */     // GIR_Coverage, 47969,
     /*  156287 */     GIR_EraseRootFromParent_Done,
     /*  156288 */   // Label 2808: @156288
     /*  156288 */   GIM_Reject,
     /*  156289 */ // Label 2806: @156289
     /*  156289 */ GIM_Reject,
     /*  156290 */ // Label 2533: @156290
     /*  156290 */ GIM_Reject,
     /*  156291 */ // Label 10: @156291
     /*  156291 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156351),
     /*  156296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  156300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156304 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156327), // Rule ID 116 //
     /*  156309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  156312 */     // MIs[0] Operand 1
     /*  156312 */     // No operand predicates
     /*  156312 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  156312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  156315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156317 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  156322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156325 */     GIR_RootConstrainSelectedInstOperands,
     /*  156326 */     // GIR_Coverage, 116,
     /*  156326 */     GIR_EraseRootFromParent_Done,
     /*  156327 */   // Label 2810: @156327
     /*  156327 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156350), // Rule ID 117 //
     /*  156332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  156335 */     // MIs[0] Operand 1
     /*  156335 */     // No operand predicates
     /*  156335 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  156335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  156338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156340 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  156345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  156348 */     GIR_RootConstrainSelectedInstOperands,
     /*  156349 */     // GIR_Coverage, 117,
     /*  156349 */     GIR_EraseRootFromParent_Done,
     /*  156350 */   // Label 2811: @156350
     /*  156350 */   GIM_Reject,
     /*  156351 */ // Label 2809: @156351
     /*  156351 */ GIM_Reject,
     /*  156352 */ // Label 11: @156352
     /*  156352 */ GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156412),
     /*  156357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  156360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  156363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  156369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156381 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156396), // Rule ID 56 //
     /*  156386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  156389 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  156389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  156394 */     GIR_RootConstrainSelectedInstOperands,
     /*  156395 */     // GIR_Coverage, 56,
     /*  156395 */     GIR_Done,
     /*  156396 */   // Label 2813: @156396
     /*  156396 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156411), // Rule ID 57 //
     /*  156401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  156404 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  156404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  156409 */     GIR_RootConstrainSelectedInstOperands,
     /*  156410 */     // GIR_Coverage, 57,
     /*  156410 */     GIR_Done,
     /*  156411 */   // Label 2814: @156411
     /*  156411 */   GIM_Reject,
     /*  156412 */ // Label 2812: @156412
     /*  156412 */ GIM_Reject,
     /*  156413 */ // Label 12: @156413
     /*  156413 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(156503),
     /*  156418 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  156421 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  156424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  156430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156442 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(156457), // Rule ID 54 //
     /*  156447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  156450 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  156450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156455 */     GIR_RootConstrainSelectedInstOperands,
     /*  156456 */     // GIR_Coverage, 54,
     /*  156456 */     GIR_Done,
     /*  156457 */   // Label 2816: @156457
     /*  156457 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156472), // Rule ID 55 //
     /*  156462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  156465 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  156465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156470 */     GIR_RootConstrainSelectedInstOperands,
     /*  156471 */     // GIR_Coverage, 55,
     /*  156471 */     GIR_Done,
     /*  156472 */   // Label 2817: @156472
     /*  156472 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156487), // Rule ID 2404 //
     /*  156477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  156480 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156485 */     GIR_RootConstrainSelectedInstOperands,
     /*  156486 */     // GIR_Coverage, 2404,
     /*  156486 */     GIR_Done,
     /*  156487 */   // Label 2818: @156487
     /*  156487 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156502), // Rule ID 2405 //
     /*  156492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  156495 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156500 */     GIR_RootConstrainSelectedInstOperands,
     /*  156501 */     // GIR_Coverage, 2405,
     /*  156501 */     GIR_Done,
     /*  156502 */   // Label 2819: @156502
     /*  156502 */   GIM_Reject,
     /*  156503 */ // Label 2815: @156503
     /*  156503 */ GIM_Reject,
     /*  156504 */ // Label 13: @156504
     /*  156504 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2822*/ GIMT_Encode4(156870),
     /*  156515 */ /*GILLT_s32*//*Label 2820*/ GIMT_Encode4(156523),
     /*  156519 */ /*GILLT_s64*//*Label 2821*/ GIMT_Encode4(156760),
     /*  156523 */ // Label 2820: @156523
     /*  156523 */ GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(156759),
     /*  156528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156531 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156554), // Rule ID 1447 //
     /*  156536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156547 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156552 */     GIR_RootConstrainSelectedInstOperands,
     /*  156553 */     // GIR_Coverage, 1447,
     /*  156553 */     GIR_Done,
     /*  156554 */   // Label 2824: @156554
     /*  156554 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156577), // Rule ID 1448 //
     /*  156559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156570 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156575 */     GIR_RootConstrainSelectedInstOperands,
     /*  156576 */     // GIR_Coverage, 1448,
     /*  156576 */     GIR_Done,
     /*  156577 */   // Label 2825: @156577
     /*  156577 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156600), // Rule ID 1449 //
     /*  156582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156593 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156598 */     GIR_RootConstrainSelectedInstOperands,
     /*  156599 */     // GIR_Coverage, 1449,
     /*  156599 */     GIR_Done,
     /*  156600 */   // Label 2826: @156600
     /*  156600 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156623), // Rule ID 1450 //
     /*  156605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156616 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156621 */     GIR_RootConstrainSelectedInstOperands,
     /*  156622 */     // GIR_Coverage, 1450,
     /*  156622 */     GIR_Done,
     /*  156623 */   // Label 2827: @156623
     /*  156623 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156661), // Rule ID 1451 //
     /*  156628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156639 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156644 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156660 */     // GIR_Coverage, 1451,
     /*  156660 */     GIR_EraseRootFromParent_Done,
     /*  156661 */   // Label 2828: @156661
     /*  156661 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156699), // Rule ID 1452 //
     /*  156666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156677 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156682 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156698 */     // GIR_Coverage, 1452,
     /*  156698 */     GIR_EraseRootFromParent_Done,
     /*  156699 */   // Label 2829: @156699
     /*  156699 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156758), // Rule ID 1453 //
     /*  156704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156715 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  156715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  156718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  156732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  156742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156757 */     // GIR_Coverage, 1453,
     /*  156757 */     GIR_EraseRootFromParent_Done,
     /*  156758 */   // Label 2830: @156758
     /*  156758 */   GIM_Reject,
     /*  156759 */ // Label 2823: @156759
     /*  156759 */ GIM_Reject,
     /*  156760 */ // Label 2821: @156760
     /*  156760 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156869),
     /*  156765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156768 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156791), // Rule ID 1900 //
     /*  156773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156784 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  156784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  156789 */     GIR_RootConstrainSelectedInstOperands,
     /*  156790 */     // GIR_Coverage, 1900,
     /*  156790 */     GIR_Done,
     /*  156791 */   // Label 2832: @156791
     /*  156791 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156814), // Rule ID 1901 //
     /*  156796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156807 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  156807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  156812 */     GIR_RootConstrainSelectedInstOperands,
     /*  156813 */     // GIR_Coverage, 1901,
     /*  156813 */     GIR_Done,
     /*  156814 */   // Label 2833: @156814
     /*  156814 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156841), // Rule ID 1928 //
     /*  156819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156830 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  156830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156840 */     // GIR_Coverage, 1928,
     /*  156840 */     GIR_Done,
     /*  156841 */   // Label 2834: @156841
     /*  156841 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156868), // Rule ID 1929 //
     /*  156846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156857 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  156857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156867 */     // GIR_Coverage, 1929,
     /*  156867 */     GIR_Done,
     /*  156868 */   // Label 2835: @156868
     /*  156868 */   GIM_Reject,
     /*  156869 */ // Label 2831: @156869
     /*  156869 */ GIM_Reject,
     /*  156870 */ // Label 2822: @156870
     /*  156870 */ GIM_Reject,
     /*  156871 */ // Label 14: @156871
     /*  156871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2839*/ GIMT_Encode4(157068),
     /*  156882 */ /*GILLT_s16*//*Label 2836*/ GIMT_Encode4(156894),
     /*  156886 */ /*GILLT_s32*//*Label 2837*/ GIMT_Encode4(156952),
     /*  156890 */ /*GILLT_s64*//*Label 2838*/ GIMT_Encode4(157010),
     /*  156894 */ // Label 2836: @156894
     /*  156894 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156951),
     /*  156899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156910 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156930), // Rule ID 2436 //
     /*  156915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156918 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  156918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156928 */     GIR_RootConstrainSelectedInstOperands,
     /*  156929 */     // GIR_Coverage, 2436,
     /*  156929 */     GIR_EraseRootFromParent_Done,
     /*  156930 */   // Label 2841: @156930
     /*  156930 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156950), // Rule ID 2437 //
     /*  156935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156938 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  156938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156948 */     GIR_RootConstrainSelectedInstOperands,
     /*  156949 */     // GIR_Coverage, 2437,
     /*  156949 */     GIR_EraseRootFromParent_Done,
     /*  156950 */   // Label 2842: @156950
     /*  156950 */   GIM_Reject,
     /*  156951 */ // Label 2840: @156951
     /*  156951 */ GIM_Reject,
     /*  156952 */ // Label 2837: @156952
     /*  156952 */ GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(157009),
     /*  156957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156968 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(156988), // Rule ID 2354 //
     /*  156973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156976 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156986 */     GIR_RootConstrainSelectedInstOperands,
     /*  156987 */     // GIR_Coverage, 2354,
     /*  156987 */     GIR_EraseRootFromParent_Done,
     /*  156988 */   // Label 2844: @156988
     /*  156988 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(157008), // Rule ID 2355 //
     /*  156993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156996 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  156996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157006 */     GIR_RootConstrainSelectedInstOperands,
     /*  157007 */     // GIR_Coverage, 2355,
     /*  157007 */     GIR_EraseRootFromParent_Done,
     /*  157008 */   // Label 2845: @157008
     /*  157008 */   GIM_Reject,
     /*  157009 */ // Label 2843: @157009
     /*  157009 */ GIM_Reject,
     /*  157010 */ // Label 2838: @157010
     /*  157010 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157067),
     /*  157015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157026 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(157046), // Rule ID 2394 //
     /*  157031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157034 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  157034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157044 */     GIR_RootConstrainSelectedInstOperands,
     /*  157045 */     // GIR_Coverage, 2394,
     /*  157045 */     GIR_EraseRootFromParent_Done,
     /*  157046 */   // Label 2847: @157046
     /*  157046 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(157066), // Rule ID 2395 //
     /*  157051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157054 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  157054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  157064 */     GIR_RootConstrainSelectedInstOperands,
     /*  157065 */     // GIR_Coverage, 2395,
     /*  157065 */     GIR_EraseRootFromParent_Done,
     /*  157066 */   // Label 2848: @157066
     /*  157066 */   GIM_Reject,
     /*  157067 */ // Label 2846: @157067
     /*  157067 */ GIM_Reject,
     /*  157068 */ // Label 2839: @157068
     /*  157068 */ GIM_Reject,
     /*  157069 */ // Label 15: @157069
     /*  157069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2852*/ GIMT_Encode4(157266),
     /*  157080 */ /*GILLT_s16*//*Label 2849*/ GIMT_Encode4(157092),
     /*  157084 */ /*GILLT_s32*//*Label 2850*/ GIMT_Encode4(157150),
     /*  157088 */ /*GILLT_s64*//*Label 2851*/ GIMT_Encode4(157208),
     /*  157092 */ // Label 2849: @157092
     /*  157092 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157149),
     /*  157097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157108 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157128), // Rule ID 2420 //
     /*  157113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157116 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  157116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157126 */     GIR_RootConstrainSelectedInstOperands,
     /*  157127 */     // GIR_Coverage, 2420,
     /*  157127 */     GIR_EraseRootFromParent_Done,
     /*  157128 */   // Label 2854: @157128
     /*  157128 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157148), // Rule ID 2421 //
     /*  157133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157136 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  157136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157146 */     GIR_RootConstrainSelectedInstOperands,
     /*  157147 */     // GIR_Coverage, 2421,
     /*  157147 */     GIR_EraseRootFromParent_Done,
     /*  157148 */   // Label 2855: @157148
     /*  157148 */   GIM_Reject,
     /*  157149 */ // Label 2853: @157149
     /*  157149 */ GIM_Reject,
     /*  157150 */ // Label 2850: @157150
     /*  157150 */ GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157207),
     /*  157155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157166 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157186), // Rule ID 2338 //
     /*  157171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157174 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  157174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157184 */     GIR_RootConstrainSelectedInstOperands,
     /*  157185 */     // GIR_Coverage, 2338,
     /*  157185 */     GIR_EraseRootFromParent_Done,
     /*  157186 */   // Label 2857: @157186
     /*  157186 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157206), // Rule ID 2339 //
     /*  157191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157194 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  157194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157204 */     GIR_RootConstrainSelectedInstOperands,
     /*  157205 */     // GIR_Coverage, 2339,
     /*  157205 */     GIR_EraseRootFromParent_Done,
     /*  157206 */   // Label 2858: @157206
     /*  157206 */   GIM_Reject,
     /*  157207 */ // Label 2856: @157207
     /*  157207 */ GIM_Reject,
     /*  157208 */ // Label 2851: @157208
     /*  157208 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157265),
     /*  157213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157224 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157244), // Rule ID 2378 //
     /*  157229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157232 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  157232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157242 */     GIR_RootConstrainSelectedInstOperands,
     /*  157243 */     // GIR_Coverage, 2378,
     /*  157243 */     GIR_EraseRootFromParent_Done,
     /*  157244 */   // Label 2860: @157244
     /*  157244 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157264), // Rule ID 2379 //
     /*  157249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157252 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  157252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  157262 */     GIR_RootConstrainSelectedInstOperands,
     /*  157263 */     // GIR_Coverage, 2379,
     /*  157263 */     GIR_EraseRootFromParent_Done,
     /*  157264 */   // Label 2861: @157264
     /*  157264 */   GIM_Reject,
     /*  157265 */ // Label 2859: @157265
     /*  157265 */ GIM_Reject,
     /*  157266 */ // Label 2852: @157266
     /*  157266 */ GIM_Reject,
     /*  157267 */ // Label 16: @157267
     /*  157267 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2864*/ GIMT_Encode4(157846),
     /*  157278 */ /*GILLT_s32*//*Label 2862*/ GIMT_Encode4(157286),
     /*  157282 */ /*GILLT_s64*//*Label 2863*/ GIMT_Encode4(157659),
     /*  157286 */ // Label 2862: @157286
     /*  157286 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157317), // Rule ID 1466 //
     /*  157291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  157294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157305 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  157308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157315 */   GIR_RootConstrainSelectedInstOperands,
     /*  157316 */   // GIR_Coverage, 1466,
     /*  157316 */   GIR_EraseRootFromParent_Done,
     /*  157317 */ // Label 2865: @157317
     /*  157317 */ GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(157348), // Rule ID 1467 //
     /*  157322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  157325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157336 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  157336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  157339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157341 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157346 */   GIR_RootConstrainSelectedInstOperands,
     /*  157347 */   // GIR_Coverage, 1467,
     /*  157347 */   GIR_EraseRootFromParent_Done,
     /*  157348 */ // Label 2866: @157348
     /*  157348 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(157379), // Rule ID 1492 //
     /*  157353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  157356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157367 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  157370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157372 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157377 */   GIR_RootConstrainSelectedInstOperands,
     /*  157378 */   // GIR_Coverage, 1492,
     /*  157378 */   GIR_EraseRootFromParent_Done,
     /*  157379 */ // Label 2867: @157379
     /*  157379 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(157410), // Rule ID 1493 //
     /*  157384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  157387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157398 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  157398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  157401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157408 */   GIR_RootConstrainSelectedInstOperands,
     /*  157409 */   // GIR_Coverage, 1493,
     /*  157409 */   GIR_EraseRootFromParent_Done,
     /*  157410 */ // Label 2868: @157410
     /*  157410 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(157441), // Rule ID 1860 //
     /*  157415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  157418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157429 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  157432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157439 */   GIR_RootConstrainSelectedInstOperands,
     /*  157440 */   // GIR_Coverage, 1860,
     /*  157440 */   GIR_EraseRootFromParent_Done,
     /*  157441 */ // Label 2869: @157441
     /*  157441 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157472), // Rule ID 1861 //
     /*  157446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  157449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157460 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  157463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157470 */   GIR_RootConstrainSelectedInstOperands,
     /*  157471 */   // GIR_Coverage, 1861,
     /*  157471 */   GIR_EraseRootFromParent_Done,
     /*  157472 */ // Label 2870: @157472
     /*  157472 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157503), // Rule ID 1886 //
     /*  157477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  157480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157491 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157501 */   GIR_RootConstrainSelectedInstOperands,
     /*  157502 */   // GIR_Coverage, 1886,
     /*  157502 */   GIR_EraseRootFromParent_Done,
     /*  157503 */ // Label 2871: @157503
     /*  157503 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157534), // Rule ID 1887 //
     /*  157508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  157511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157522 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157532 */   GIR_RootConstrainSelectedInstOperands,
     /*  157533 */   // GIR_Coverage, 1887,
     /*  157533 */   GIR_EraseRootFromParent_Done,
     /*  157534 */ // Label 2872: @157534
     /*  157534 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157565), // Rule ID 2202 //
     /*  157539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  157542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157553 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157563 */   GIR_RootConstrainSelectedInstOperands,
     /*  157564 */   // GIR_Coverage, 2202,
     /*  157564 */   GIR_EraseRootFromParent_Done,
     /*  157565 */ // Label 2873: @157565
     /*  157565 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157596), // Rule ID 2203 //
     /*  157570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  157573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157584 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157594 */   GIR_RootConstrainSelectedInstOperands,
     /*  157595 */   // GIR_Coverage, 2203,
     /*  157595 */   GIR_EraseRootFromParent_Done,
     /*  157596 */ // Label 2874: @157596
     /*  157596 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157627), // Rule ID 2228 //
     /*  157601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  157604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157615 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157625 */   GIR_RootConstrainSelectedInstOperands,
     /*  157626 */   // GIR_Coverage, 2228,
     /*  157626 */   GIR_EraseRootFromParent_Done,
     /*  157627 */ // Label 2875: @157627
     /*  157627 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157658), // Rule ID 2229 //
     /*  157632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  157635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157646 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157651 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157656 */   GIR_RootConstrainSelectedInstOperands,
     /*  157657 */   // GIR_Coverage, 2229,
     /*  157657 */   GIR_EraseRootFromParent_Done,
     /*  157658 */ // Label 2876: @157658
     /*  157658 */ GIM_Reject,
     /*  157659 */ // Label 2863: @157659
     /*  157659 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157690), // Rule ID 1519 //
     /*  157664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157678 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157683 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157688 */   GIR_RootConstrainSelectedInstOperands,
     /*  157689 */   // GIR_Coverage, 1519,
     /*  157689 */   GIR_EraseRootFromParent_Done,
     /*  157690 */ // Label 2877: @157690
     /*  157690 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157721), // Rule ID 1547 //
     /*  157695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157709 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157714 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157719 */   GIR_RootConstrainSelectedInstOperands,
     /*  157720 */   // GIR_Coverage, 1547,
     /*  157720 */   GIR_EraseRootFromParent_Done,
     /*  157721 */ // Label 2878: @157721
     /*  157721 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(157752), // Rule ID 1917 //
     /*  157726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157740 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157750 */   GIR_RootConstrainSelectedInstOperands,
     /*  157751 */   // GIR_Coverage, 1917,
     /*  157751 */   GIR_EraseRootFromParent_Done,
     /*  157752 */ // Label 2879: @157752
     /*  157752 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(157783), // Rule ID 1945 //
     /*  157757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157771 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157776 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157781 */   GIR_RootConstrainSelectedInstOperands,
     /*  157782 */   // GIR_Coverage, 1945,
     /*  157782 */   GIR_EraseRootFromParent_Done,
     /*  157783 */ // Label 2880: @157783
     /*  157783 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(157814), // Rule ID 2253 //
     /*  157788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157802 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157812 */   GIR_RootConstrainSelectedInstOperands,
     /*  157813 */   // GIR_Coverage, 2253,
     /*  157813 */   GIR_EraseRootFromParent_Done,
     /*  157814 */ // Label 2881: @157814
     /*  157814 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(157845), // Rule ID 2279 //
     /*  157819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157833 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157838 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157843 */   GIR_RootConstrainSelectedInstOperands,
     /*  157844 */   // GIR_Coverage, 2279,
     /*  157844 */   GIR_EraseRootFromParent_Done,
     /*  157845 */ // Label 2882: @157845
     /*  157845 */ GIM_Reject,
     /*  157846 */ // Label 2864: @157846
     /*  157846 */ GIM_Reject,
     /*  157847 */ // Label 17: @157847
     /*  157847 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158056),
     /*  157852 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157855 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2887*/ GIMT_Encode4(158055),
     /*  157866 */   /*GILLT_s16*//*Label 2884*/ GIMT_Encode4(157878),
     /*  157870 */   /*GILLT_s32*//*Label 2885*/ GIMT_Encode4(157937),
     /*  157874 */   /*GILLT_s64*//*Label 2886*/ GIMT_Encode4(157996),
     /*  157878 */   // Label 2884: @157878
     /*  157878 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157936),
     /*  157883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157887 */     GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157911), // Rule ID 2255 //
     /*  157892 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157895 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157899 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157904 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157906 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157909 */       GIR_RootConstrainSelectedInstOperands,
     /*  157910 */       // GIR_Coverage, 2255,
     /*  157910 */       GIR_EraseRootFromParent_Done,
     /*  157911 */     // Label 2889: @157911
     /*  157911 */     GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157935), // Rule ID 2281 //
     /*  157916 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157919 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157923 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157928 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157930 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157933 */       GIR_RootConstrainSelectedInstOperands,
     /*  157934 */       // GIR_Coverage, 2281,
     /*  157934 */       GIR_EraseRootFromParent_Done,
     /*  157935 */     // Label 2890: @157935
     /*  157935 */     GIM_Reject,
     /*  157936 */   // Label 2888: @157936
     /*  157936 */   GIM_Reject,
     /*  157937 */   // Label 2885: @157937
     /*  157937 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(157995),
     /*  157942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157946 */     GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(157970), // Rule ID 1521 //
     /*  157951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157954 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157958 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157958 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157961 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157963 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157965 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157968 */       GIR_RootConstrainSelectedInstOperands,
     /*  157969 */       // GIR_Coverage, 1521,
     /*  157969 */       GIR_EraseRootFromParent_Done,
     /*  157970 */     // Label 2892: @157970
     /*  157970 */     GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(157994), // Rule ID 1549 //
     /*  157975 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157978 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157982 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157982 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157985 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157987 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157989 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157992 */       GIR_RootConstrainSelectedInstOperands,
     /*  157993 */       // GIR_Coverage, 1549,
     /*  157993 */       GIR_EraseRootFromParent_Done,
     /*  157994 */     // Label 2893: @157994
     /*  157994 */     GIM_Reject,
     /*  157995 */   // Label 2891: @157995
     /*  157995 */   GIM_Reject,
     /*  157996 */   // Label 2886: @157996
     /*  157996 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158054),
     /*  158001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158005 */     GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158029), // Rule ID 1919 //
     /*  158010 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  158013 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158017 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  158017 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  158020 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158022 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158024 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  158027 */       GIR_RootConstrainSelectedInstOperands,
     /*  158028 */       // GIR_Coverage, 1919,
     /*  158028 */       GIR_EraseRootFromParent_Done,
     /*  158029 */     // Label 2895: @158029
     /*  158029 */     GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158053), // Rule ID 1947 //
     /*  158034 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  158037 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158041 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  158041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  158044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158046 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158048 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  158051 */       GIR_RootConstrainSelectedInstOperands,
     /*  158052 */       // GIR_Coverage, 1947,
     /*  158052 */       GIR_EraseRootFromParent_Done,
     /*  158053 */     // Label 2896: @158053
     /*  158053 */     GIM_Reject,
     /*  158054 */   // Label 2894: @158054
     /*  158054 */   GIM_Reject,
     /*  158055 */   // Label 2887: @158055
     /*  158055 */   GIM_Reject,
     /*  158056 */ // Label 2883: @158056
     /*  158056 */ GIM_Reject,
     /*  158057 */ // Label 18: @158057
     /*  158057 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(158254),
     /*  158068 */ /*GILLT_s16*//*Label 2897*/ GIMT_Encode4(158080),
     /*  158072 */ /*GILLT_s32*//*Label 2898*/ GIMT_Encode4(158138),
     /*  158076 */ /*GILLT_s64*//*Label 2899*/ GIMT_Encode4(158196),
     /*  158080 */ // Label 2897: @158080
     /*  158080 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158137),
     /*  158085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  158088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158096 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158116), // Rule ID 2424 //
     /*  158101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  158104 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  158104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  158107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158114 */     GIR_RootConstrainSelectedInstOperands,
     /*  158115 */     // GIR_Coverage, 2424,
     /*  158115 */     GIR_EraseRootFromParent_Done,
     /*  158116 */   // Label 2902: @158116
     /*  158116 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158136), // Rule ID 2425 //
     /*  158121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  158124 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  158124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  158127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158134 */     GIR_RootConstrainSelectedInstOperands,
     /*  158135 */     // GIR_Coverage, 2425,
     /*  158135 */     GIR_EraseRootFromParent_Done,
     /*  158136 */   // Label 2903: @158136
     /*  158136 */   GIM_Reject,
     /*  158137 */ // Label 2901: @158137
     /*  158137 */ GIM_Reject,
     /*  158138 */ // Label 2898: @158138
     /*  158138 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(158195),
     /*  158143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  158146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  158150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  158154 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158174), // Rule ID 2342 //
     /*  158159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  158162 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  158162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  158165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158172 */     GIR_RootConstrainSelectedInstOperands,
     /*  158173 */     // GIR_Coverage, 2342,
     /*  158173 */     GIR_EraseRootFromParent_Done,
     /*  158174 */   // Label 2905: @158174
     /*  158174 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158194), // Rule ID 2343 //
     /*  158179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  158182 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  158182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  158185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158192 */     GIR_RootConstrainSelectedInstOperands,
     /*  158193 */     // GIR_Coverage, 2343,
     /*  158193 */     GIR_EraseRootFromParent_Done,
     /*  158194 */   // Label 2906: @158194
     /*  158194 */   GIM_Reject,
     /*  158195 */ // Label 2904: @158195
     /*  158195 */ GIM_Reject,
     /*  158196 */ // Label 2899: @158196
     /*  158196 */ GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158253),
     /*  158201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  158204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  158212 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158232), // Rule ID 2382 //
     /*  158217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  158220 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  158220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  158223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158230 */     GIR_RootConstrainSelectedInstOperands,
     /*  158231 */     // GIR_Coverage, 2382,
     /*  158231 */     GIR_EraseRootFromParent_Done,
     /*  158232 */   // Label 2908: @158232
     /*  158232 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(158252), // Rule ID 2383 //
     /*  158237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  158240 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  158240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  158243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158250 */     GIR_RootConstrainSelectedInstOperands,
     /*  158251 */     // GIR_Coverage, 2383,
     /*  158251 */     GIR_EraseRootFromParent_Done,
     /*  158252 */   // Label 2909: @158252
     /*  158252 */   GIM_Reject,
     /*  158253 */ // Label 2907: @158253
     /*  158253 */ GIM_Reject,
     /*  158254 */ // Label 2900: @158254
     /*  158254 */ GIM_Reject,
     /*  158255 */ // Label 19: @158255
     /*  158255 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(158293), // Rule ID 291 //
     /*  158260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158263 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  158266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158270 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  158270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  158273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158275 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  158285 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  158291 */   GIR_RootConstrainSelectedInstOperands,
     /*  158292 */   // GIR_Coverage, 291,
     /*  158292 */   GIR_EraseRootFromParent_Done,
     /*  158293 */ // Label 2910: @158293
     /*  158293 */ GIM_Reject,
     /*  158294 */ // Label 20: @158294
     /*  158294 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(158332), // Rule ID 292 //
     /*  158299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158302 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  158305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158309 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  158309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  158312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158314 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  158324 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  158330 */   GIR_RootConstrainSelectedInstOperands,
     /*  158331 */   // GIR_Coverage, 292,
     /*  158331 */   GIR_EraseRootFromParent_Done,
     /*  158332 */ // Label 2911: @158332
     /*  158332 */ GIM_Reject,
     /*  158333 */ // Label 21: @158333
     /*  158333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2946*/ GIMT_Encode4(167310),
     /*  158344 */ /*GILLT_p0s32*//*Label 2912*/ GIMT_Encode4(158480),
     /*  158348 */ /*GILLT_p0s64*//*Label 2913*/ GIMT_Encode4(158574),
     /*  158352 */ /*GILLT_s16*//*Label 2914*/ GIMT_Encode4(158668),
     /*  158356 */ /*GILLT_s32*//*Label 2915*/ GIMT_Encode4(159323),
     /*  158360 */ /*GILLT_s64*//*Label 2916*/ GIMT_Encode4(160778),
     /*  158364 */ /*GILLT_nxv1s1*//*Label 2917*/ GIMT_Encode4(162004),
     /*  158368 */ /*GILLT_nxv1s8*//*Label 2918*/ GIMT_Encode4(162124),
     /*  158372 */ /*GILLT_nxv1s16*//*Label 2919*/ GIMT_Encode4(162252),
     /*  158376 */ /*GILLT_nxv1s32*//*Label 2920*/ GIMT_Encode4(162490),
     /*  158380 */ /*GILLT_nxv1s64*//*Label 2921*/ GIMT_Encode4(162728),
     /*  158384 */ /*GILLT_nxv2s1*//*Label 2922*/ GIMT_Encode4(162966),
     /*  158388 */ /*GILLT_nxv2s8*//*Label 2923*/ GIMT_Encode4(163086),
     /*  158392 */ /*GILLT_nxv2s16*//*Label 2924*/ GIMT_Encode4(163214),
     /*  158396 */ /*GILLT_nxv2s32*//*Label 2925*/ GIMT_Encode4(163452),
     /*  158400 */ /*GILLT_nxv2s64*//*Label 2926*/ GIMT_Encode4(163690),
     /*  158404 */ /*GILLT_nxv4s1*//*Label 2927*/ GIMT_Encode4(163928),
     /*  158408 */ /*GILLT_nxv4s8*//*Label 2928*/ GIMT_Encode4(164048),
     /*  158412 */ /*GILLT_nxv4s16*//*Label 2929*/ GIMT_Encode4(164176),
     /*  158416 */ /*GILLT_nxv4s32*//*Label 2930*/ GIMT_Encode4(164414),
     /*  158420 */ /*GILLT_nxv4s64*//*Label 2931*/ GIMT_Encode4(164652),
     /*  158424 */ /*GILLT_nxv8s1*//*Label 2932*/ GIMT_Encode4(164890),
     /*  158428 */ /*GILLT_nxv8s8*//*Label 2933*/ GIMT_Encode4(165010),
     /*  158432 */ /*GILLT_nxv8s16*//*Label 2934*/ GIMT_Encode4(165138),
     /*  158436 */ /*GILLT_nxv8s32*//*Label 2935*/ GIMT_Encode4(165376),
     /*  158440 */ /*GILLT_nxv8s64*//*Label 2936*/ GIMT_Encode4(165614),
     /*  158444 */ /*GILLT_nxv16s1*//*Label 2937*/ GIMT_Encode4(165852),
     /*  158448 */ /*GILLT_nxv16s8*//*Label 2938*/ GIMT_Encode4(165972),
     /*  158452 */ /*GILLT_nxv16s16*//*Label 2939*/ GIMT_Encode4(166100),
     /*  158456 */ /*GILLT_nxv16s32*//*Label 2940*/ GIMT_Encode4(166338),
     /*  158460 */ /*GILLT_nxv32s1*//*Label 2941*/ GIMT_Encode4(166576),
     /*  158464 */ /*GILLT_nxv32s8*//*Label 2942*/ GIMT_Encode4(166696),
     /*  158468 */ /*GILLT_nxv32s16*//*Label 2943*/ GIMT_Encode4(166824),
     /*  158472 */ /*GILLT_nxv64s1*//*Label 2944*/ GIMT_Encode4(167062),
     /*  158476 */ /*GILLT_nxv64s8*//*Label 2945*/ GIMT_Encode4(167182),
     /*  158480 */ // Label 2912: @158480
     /*  158480 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158573),
     /*  158485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158488 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158500 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158536), // Rule ID 65421 //
     /*  158505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  158508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158515 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158534 */     GIR_RootConstrainSelectedInstOperands,
     /*  158535 */     // GIR_Coverage, 65421,
     /*  158535 */     GIR_EraseRootFromParent_Done,
     /*  158536 */   // Label 2948: @158536
     /*  158536 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158572), // Rule ID 65425 //
     /*  158541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  158544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158551 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158570 */     GIR_RootConstrainSelectedInstOperands,
     /*  158571 */     // GIR_Coverage, 65425,
     /*  158571 */     GIR_EraseRootFromParent_Done,
     /*  158572 */   // Label 2949: @158572
     /*  158572 */   GIM_Reject,
     /*  158573 */ // Label 2947: @158573
     /*  158573 */ GIM_Reject,
     /*  158574 */ // Label 2913: @158574
     /*  158574 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158667),
     /*  158579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158594 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158630), // Rule ID 65420 //
     /*  158599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  158602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158609 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158628 */     GIR_RootConstrainSelectedInstOperands,
     /*  158629 */     // GIR_Coverage, 65420,
     /*  158629 */     GIR_EraseRootFromParent_Done,
     /*  158630 */   // Label 2951: @158630
     /*  158630 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(158666), // Rule ID 65424 //
     /*  158635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158645 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158664 */     GIR_RootConstrainSelectedInstOperands,
     /*  158665 */     // GIR_Coverage, 65424,
     /*  158665 */     GIR_EraseRootFromParent_Done,
     /*  158666 */   // Label 2952: @158666
     /*  158666 */   GIM_Reject,
     /*  158667 */ // Label 2950: @158667
     /*  158667 */ GIM_Reject,
     /*  158668 */ // Label 2914: @158668
     /*  158668 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(158719), // Rule ID 2150 //
     /*  158673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  158676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158698 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158717 */   GIR_RootConstrainSelectedInstOperands,
     /*  158718 */   // GIR_Coverage, 2150,
     /*  158718 */   GIR_EraseRootFromParent_Done,
     /*  158719 */ // Label 2953: @158719
     /*  158719 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(158770), // Rule ID 2151 //
     /*  158724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  158727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158749 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158768 */   GIR_RootConstrainSelectedInstOperands,
     /*  158769 */   // GIR_Coverage, 2151,
     /*  158769 */   GIR_EraseRootFromParent_Done,
     /*  158770 */ // Label 2954: @158770
     /*  158770 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(158821), // Rule ID 2156 //
     /*  158775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  158778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158781 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158800 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158819 */   GIR_RootConstrainSelectedInstOperands,
     /*  158820 */   // GIR_Coverage, 2156,
     /*  158820 */   GIR_EraseRootFromParent_Done,
     /*  158821 */ // Label 2955: @158821
     /*  158821 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(158872), // Rule ID 2157 //
     /*  158826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  158829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158832 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158851 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158870 */   GIR_RootConstrainSelectedInstOperands,
     /*  158871 */   // GIR_Coverage, 2157,
     /*  158871 */   GIR_EraseRootFromParent_Done,
     /*  158872 */ // Label 2956: @158872
     /*  158872 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(158923), // Rule ID 65428 //
     /*  158877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158902 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158917 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158921 */   GIR_RootConstrainSelectedInstOperands,
     /*  158922 */   // GIR_Coverage, 65428,
     /*  158922 */   GIR_EraseRootFromParent_Done,
     /*  158923 */ // Label 2957: @158923
     /*  158923 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(158974), // Rule ID 65429 //
     /*  158928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158953 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158972 */   GIR_RootConstrainSelectedInstOperands,
     /*  158973 */   // GIR_Coverage, 65429,
     /*  158973 */   GIR_EraseRootFromParent_Done,
     /*  158974 */ // Label 2958: @158974
     /*  158974 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(159032), // Rule ID 65432 //
     /*  158979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158985 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159011 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159030 */   GIR_RootConstrainSelectedInstOperands,
     /*  159031 */   // GIR_Coverage, 65432,
     /*  159031 */   GIR_EraseRootFromParent_Done,
     /*  159032 */ // Label 2959: @159032
     /*  159032 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(159090), // Rule ID 65433 //
     /*  159037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159043 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159069 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159088 */   GIR_RootConstrainSelectedInstOperands,
     /*  159089 */   // GIR_Coverage, 65433,
     /*  159089 */   GIR_EraseRootFromParent_Done,
     /*  159090 */ // Label 2960: @159090
     /*  159090 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159148), // Rule ID 65436 //
     /*  159095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  159098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159127 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159146 */   GIR_RootConstrainSelectedInstOperands,
     /*  159147 */   // GIR_Coverage, 65436,
     /*  159147 */   GIR_EraseRootFromParent_Done,
     /*  159148 */ // Label 2961: @159148
     /*  159148 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159206), // Rule ID 65437 //
     /*  159153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159185 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159200 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159204 */   GIR_RootConstrainSelectedInstOperands,
     /*  159205 */   // GIR_Coverage, 65437,
     /*  159205 */   GIR_EraseRootFromParent_Done,
     /*  159206 */ // Label 2962: @159206
     /*  159206 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159264), // Rule ID 65438 //
     /*  159211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  159214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159232 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159243 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159262 */   GIR_RootConstrainSelectedInstOperands,
     /*  159263 */   // GIR_Coverage, 65438,
     /*  159263 */   GIR_EraseRootFromParent_Done,
     /*  159264 */ // Label 2963: @159264
     /*  159264 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(159322), // Rule ID 65439 //
     /*  159269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159301 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159320 */   GIR_RootConstrainSelectedInstOperands,
     /*  159321 */   // GIR_Coverage, 65439,
     /*  159321 */   GIR_EraseRootFromParent_Done,
     /*  159322 */ // Label 2964: @159322
     /*  159322 */ GIM_Reject,
     /*  159323 */ // Label 2915: @159323
     /*  159323 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(159381), // Rule ID 237 //
     /*  159328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159334 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159353 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159360 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159379 */   GIR_RootConstrainSelectedInstOperands,
     /*  159380 */   // GIR_Coverage, 237,
     /*  159380 */   GIR_EraseRootFromParent_Done,
     /*  159381 */ // Label 2965: @159381
     /*  159381 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(159439), // Rule ID 241 //
     /*  159386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159418 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159437 */   GIR_RootConstrainSelectedInstOperands,
     /*  159438 */   // GIR_Coverage, 241,
     /*  159438 */   GIR_EraseRootFromParent_Done,
     /*  159439 */ // Label 2966: @159439
     /*  159439 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(159490), // Rule ID 242 //
     /*  159444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  159447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159469 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159488 */   GIR_RootConstrainSelectedInstOperands,
     /*  159489 */   // GIR_Coverage, 242,
     /*  159489 */   GIR_EraseRootFromParent_Done,
     /*  159490 */ // Label 2967: @159490
     /*  159490 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(159541), // Rule ID 243 //
     /*  159495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159498 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159501 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159509 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159513 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159520 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159539 */   GIR_RootConstrainSelectedInstOperands,
     /*  159540 */   // GIR_Coverage, 243,
     /*  159540 */   GIR_EraseRootFromParent_Done,
     /*  159541 */ // Label 2968: @159541
     /*  159541 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(159602), // Rule ID 326 //
     /*  159546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159549 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159552 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159556 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159563 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159581 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159600 */   GIR_RootConstrainSelectedInstOperands,
     /*  159601 */   // GIR_Coverage, 326,
     /*  159601 */   GIR_EraseRootFromParent_Done,
     /*  159602 */ // Label 2969: @159602
     /*  159602 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(159663), // Rule ID 330 //
     /*  159607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159610 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159613 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159624 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159642 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159661 */   GIR_RootConstrainSelectedInstOperands,
     /*  159662 */   // GIR_Coverage, 330,
     /*  159662 */   GIR_EraseRootFromParent_Done,
     /*  159663 */ // Label 2970: @159663
     /*  159663 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(159724), // Rule ID 344 //
     /*  159668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  159671 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159678 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159685 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159703 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10146>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159722 */   GIR_RootConstrainSelectedInstOperands,
     /*  159723 */   // GIR_Coverage, 344,
     /*  159723 */   GIR_EraseRootFromParent_Done,
     /*  159724 */ // Label 2971: @159724
     /*  159724 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(159785), // Rule ID 346 //
     /*  159729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159732 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159735 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159739 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159746 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159757 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159764 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159783 */   GIR_RootConstrainSelectedInstOperands,
     /*  159784 */   // GIR_Coverage, 346,
     /*  159784 */   GIR_EraseRootFromParent_Done,
     /*  159785 */ // Label 2972: @159785
     /*  159785 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(159836), // Rule ID 1437 //
     /*  159790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  159793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159796 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159815 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159834 */   GIR_RootConstrainSelectedInstOperands,
     /*  159835 */   // GIR_Coverage, 1437,
     /*  159835 */   GIR_EraseRootFromParent_Done,
     /*  159836 */ // Label 2973: @159836
     /*  159836 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(159887), // Rule ID 1438 //
     /*  159841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  159844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159866 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159885 */   GIR_RootConstrainSelectedInstOperands,
     /*  159886 */   // GIR_Coverage, 1438,
     /*  159886 */   GIR_EraseRootFromParent_Done,
     /*  159887 */ // Label 2974: @159887
     /*  159887 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(159938), // Rule ID 1443 //
     /*  159892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  159895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159917 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159936 */   GIR_RootConstrainSelectedInstOperands,
     /*  159937 */   // GIR_Coverage, 1443,
     /*  159937 */   GIR_EraseRootFromParent_Done,
     /*  159938 */ // Label 2975: @159938
     /*  159938 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(159989), // Rule ID 1444 //
     /*  159943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  159946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159968 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159987 */   GIR_RootConstrainSelectedInstOperands,
     /*  159988 */   // GIR_Coverage, 1444,
     /*  159988 */   GIR_EraseRootFromParent_Done,
     /*  159989 */ // Label 2976: @159989
     /*  159989 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(160047), // Rule ID 65444 //
     /*  159994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  159997 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160026 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160045 */   GIR_RootConstrainSelectedInstOperands,
     /*  160046 */   // GIR_Coverage, 65444,
     /*  160046 */   GIR_EraseRootFromParent_Done,
     /*  160047 */ // Label 2977: @160047
     /*  160047 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(160105), // Rule ID 65445 //
     /*  160052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160055 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160084 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160103 */   GIR_RootConstrainSelectedInstOperands,
     /*  160104 */   // GIR_Coverage, 65445,
     /*  160104 */   GIR_EraseRootFromParent_Done,
     /*  160105 */ // Label 2978: @160105
     /*  160105 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160163), // Rule ID 65448 //
     /*  160110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160116 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160131 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160142 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160161 */   GIR_RootConstrainSelectedInstOperands,
     /*  160162 */   // GIR_Coverage, 65448,
     /*  160162 */   GIR_EraseRootFromParent_Done,
     /*  160163 */ // Label 2979: @160163
     /*  160163 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160221), // Rule ID 65449 //
     /*  160168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160174 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160193 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160200 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160219 */   GIR_RootConstrainSelectedInstOperands,
     /*  160220 */   // GIR_Coverage, 65449,
     /*  160220 */   GIR_EraseRootFromParent_Done,
     /*  160221 */ // Label 2980: @160221
     /*  160221 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160279), // Rule ID 65450 //
     /*  160226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160229 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160232 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160236 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160258 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160277 */   GIR_RootConstrainSelectedInstOperands,
     /*  160278 */   // GIR_Coverage, 65450,
     /*  160278 */   GIR_EraseRootFromParent_Done,
     /*  160279 */ // Label 2981: @160279
     /*  160279 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160337), // Rule ID 65451 //
     /*  160284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160287 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160290 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160294 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160305 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160309 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160316 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160335 */   GIR_RootConstrainSelectedInstOperands,
     /*  160336 */   // GIR_Coverage, 65451,
     /*  160336 */   GIR_EraseRootFromParent_Done,
     /*  160337 */ // Label 2982: @160337
     /*  160337 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(160381), // Rule ID 1102 //
     /*  160342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160345 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160348 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160352 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160366 */   // MIs[0] rs1
     /*  160366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160374 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160379 */   GIR_RootConstrainSelectedInstOperands,
     /*  160380 */   // GIR_Coverage, 1102,
     /*  160380 */   GIR_Done,
     /*  160381 */ // Label 2983: @160381
     /*  160381 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(160425), // Rule ID 1106 //
     /*  160386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160410 */   // MIs[0] rs1
     /*  160410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160418 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160423 */   GIR_RootConstrainSelectedInstOperands,
     /*  160424 */   // GIR_Coverage, 1106,
     /*  160424 */   GIR_Done,
     /*  160425 */ // Label 2984: @160425
     /*  160425 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(160469), // Rule ID 1110 //
     /*  160430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160433 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160436 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160440 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160454 */   // MIs[0] rs1
     /*  160454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160462 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160467 */   GIR_RootConstrainSelectedInstOperands,
     /*  160468 */   // GIR_Coverage, 1110,
     /*  160468 */   GIR_Done,
     /*  160469 */ // Label 2985: @160469
     /*  160469 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(160513), // Rule ID 1114 //
     /*  160474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160477 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160480 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160484 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160491 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160498 */   // MIs[0] rs1
     /*  160498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160506 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160511 */   GIR_RootConstrainSelectedInstOperands,
     /*  160512 */   // GIR_Coverage, 1114,
     /*  160512 */   GIR_Done,
     /*  160513 */ // Label 2986: @160513
     /*  160513 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(160557), // Rule ID 1130 //
     /*  160518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160542 */   // MIs[0] rs1
     /*  160542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160550 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10656>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160555 */   GIR_RootConstrainSelectedInstOperands,
     /*  160556 */   // GIR_Coverage, 1130,
     /*  160556 */   GIR_Done,
     /*  160557 */ // Label 2987: @160557
     /*  160557 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(160601), // Rule ID 1132 //
     /*  160562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160568 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160586 */   // MIs[0] rs1
     /*  160586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160594 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10658>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160599 */   GIR_RootConstrainSelectedInstOperands,
     /*  160600 */   // GIR_Coverage, 1132,
     /*  160600 */   GIR_Done,
     /*  160601 */ // Label 2988: @160601
     /*  160601 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(160645), // Rule ID 1134 //
     /*  160606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160609 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160612 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160630 */   // MIs[0] rs1
     /*  160630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160638 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160643 */   GIR_RootConstrainSelectedInstOperands,
     /*  160644 */   // GIR_Coverage, 1134,
     /*  160644 */   GIR_Done,
     /*  160645 */ // Label 2989: @160645
     /*  160645 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(160689), // Rule ID 1138 //
     /*  160650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160653 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160656 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160660 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160674 */   // MIs[0] rs1
     /*  160674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160682 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160687 */   GIR_RootConstrainSelectedInstOperands,
     /*  160688 */   // GIR_Coverage, 1138,
     /*  160688 */   GIR_Done,
     /*  160689 */ // Label 2990: @160689
     /*  160689 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(160733), // Rule ID 1142 //
     /*  160694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160711 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160718 */   // MIs[0] rs1
     /*  160718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160726 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10664>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160731 */   GIR_RootConstrainSelectedInstOperands,
     /*  160732 */   // GIR_Coverage, 1142,
     /*  160732 */   GIR_Done,
     /*  160733 */ // Label 2991: @160733
     /*  160733 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(160777), // Rule ID 1144 //
     /*  160738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160762 */   // MIs[0] rs1
     /*  160762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160770 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10666>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160775 */   GIR_RootConstrainSelectedInstOperands,
     /*  160776 */   // GIR_Coverage, 1144,
     /*  160776 */   GIR_Done,
     /*  160777 */ // Label 2992: @160777
     /*  160777 */ GIM_Reject,
     /*  160778 */ // Label 2916: @160778
     /*  160778 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(160836), // Rule ID 236 //
     /*  160783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160789 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160815 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160834 */   GIR_RootConstrainSelectedInstOperands,
     /*  160835 */   // GIR_Coverage, 236,
     /*  160835 */   GIR_EraseRootFromParent_Done,
     /*  160836 */ // Label 2993: @160836
     /*  160836 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(160894), // Rule ID 240 //
     /*  160841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160847 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160851 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160873 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160892 */   GIR_RootConstrainSelectedInstOperands,
     /*  160893 */   // GIR_Coverage, 240,
     /*  160893 */   GIR_EraseRootFromParent_Done,
     /*  160894 */ // Label 2994: @160894
     /*  160894 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(160952), // Rule ID 286 //
     /*  160899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160905 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160909 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160924 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160931 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160950 */   GIR_RootConstrainSelectedInstOperands,
     /*  160951 */   // GIR_Coverage, 286,
     /*  160951 */   GIR_EraseRootFromParent_Done,
     /*  160952 */ // Label 2995: @160952
     /*  160952 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(161003), // Rule ID 288 //
     /*  160957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160982 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161001 */   GIR_RootConstrainSelectedInstOperands,
     /*  161002 */   // GIR_Coverage, 288,
     /*  161002 */   GIR_EraseRootFromParent_Done,
     /*  161003 */ // Label 2996: @161003
     /*  161003 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(161064), // Rule ID 325 //
     /*  161008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161011 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161014 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161025 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161043 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  161046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161062 */   GIR_RootConstrainSelectedInstOperands,
     /*  161063 */   // GIR_Coverage, 325,
     /*  161063 */   GIR_EraseRootFromParent_Done,
     /*  161064 */ // Label 2997: @161064
     /*  161064 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(161125), // Rule ID 329 //
     /*  161069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161075 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161086 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161093 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161104 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161123 */   GIR_RootConstrainSelectedInstOperands,
     /*  161124 */   // GIR_Coverage, 329,
     /*  161124 */   GIR_EraseRootFromParent_Done,
     /*  161125 */ // Label 2998: @161125
     /*  161125 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161186), // Rule ID 343 //
     /*  161130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  161133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161136 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161147 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161165 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10146>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161184 */   GIR_RootConstrainSelectedInstOperands,
     /*  161185 */   // GIR_Coverage, 343,
     /*  161185 */   GIR_EraseRootFromParent_Done,
     /*  161186 */ // Label 2999: @161186
     /*  161186 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161247), // Rule ID 345 //
     /*  161191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161197 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161208 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161226 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161241 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161245 */   GIR_RootConstrainSelectedInstOperands,
     /*  161246 */   // GIR_Coverage, 345,
     /*  161246 */   GIR_EraseRootFromParent_Done,
     /*  161247 */ // Label 3000: @161247
     /*  161247 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161308), // Rule ID 351 //
     /*  161252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161255 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161262 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161269 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161287 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10152>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161306 */   GIR_RootConstrainSelectedInstOperands,
     /*  161307 */   // GIR_Coverage, 351,
     /*  161307 */   GIR_EraseRootFromParent_Done,
     /*  161308 */ // Label 3001: @161308
     /*  161308 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(161359), // Rule ID 1835 //
     /*  161313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  161316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161327 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161338 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161357 */   GIR_RootConstrainSelectedInstOperands,
     /*  161358 */   // GIR_Coverage, 1835,
     /*  161358 */   GIR_EraseRootFromParent_Done,
     /*  161359 */ // Label 3002: @161359
     /*  161359 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(161410), // Rule ID 1836 //
     /*  161364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  161367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161370 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161389 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161408 */   GIR_RootConstrainSelectedInstOperands,
     /*  161409 */   // GIR_Coverage, 1836,
     /*  161409 */   GIR_EraseRootFromParent_Done,
     /*  161410 */ // Label 3003: @161410
     /*  161410 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(161461), // Rule ID 1840 //
     /*  161415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  161418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161440 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161459 */   GIR_RootConstrainSelectedInstOperands,
     /*  161460 */   // GIR_Coverage, 1840,
     /*  161460 */   GIR_EraseRootFromParent_Done,
     /*  161461 */ // Label 3004: @161461
     /*  161461 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(161512), // Rule ID 1844 //
     /*  161466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161491 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161510 */   GIR_RootConstrainSelectedInstOperands,
     /*  161511 */   // GIR_Coverage, 1844,
     /*  161511 */   GIR_EraseRootFromParent_Done,
     /*  161512 */ // Label 3005: @161512
     /*  161512 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(161563), // Rule ID 1845 //
     /*  161517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161523 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161542 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161561 */   GIR_RootConstrainSelectedInstOperands,
     /*  161562 */   // GIR_Coverage, 1845,
     /*  161562 */   GIR_EraseRootFromParent_Done,
     /*  161563 */ // Label 3006: @161563
     /*  161563 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(161607), // Rule ID 1101 //
     /*  161568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161571 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161574 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161592 */   // MIs[0] rs1
     /*  161592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161600 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161605 */   GIR_RootConstrainSelectedInstOperands,
     /*  161606 */   // GIR_Coverage, 1101,
     /*  161606 */   GIR_Done,
     /*  161607 */ // Label 3007: @161607
     /*  161607 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(161651), // Rule ID 1105 //
     /*  161612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161615 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161618 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161636 */   // MIs[0] rs1
     /*  161636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161644 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161649 */   GIR_RootConstrainSelectedInstOperands,
     /*  161650 */   // GIR_Coverage, 1105,
     /*  161650 */   GIR_Done,
     /*  161651 */ // Label 3008: @161651
     /*  161651 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(161695), // Rule ID 1109 //
     /*  161656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161680 */   // MIs[0] rs1
     /*  161680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161688 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161693 */   GIR_RootConstrainSelectedInstOperands,
     /*  161694 */   // GIR_Coverage, 1109,
     /*  161694 */   GIR_Done,
     /*  161695 */ // Label 3009: @161695
     /*  161695 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(161739), // Rule ID 1113 //
     /*  161700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161703 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161706 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161717 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161724 */   // MIs[0] rs1
     /*  161724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161732 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161737 */   GIR_RootConstrainSelectedInstOperands,
     /*  161738 */   // GIR_Coverage, 1113,
     /*  161738 */   GIR_Done,
     /*  161739 */ // Label 3010: @161739
     /*  161739 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(161783), // Rule ID 1129 //
     /*  161744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161747 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161768 */   // MIs[0] rs1
     /*  161768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161776 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10656>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161781 */   GIR_RootConstrainSelectedInstOperands,
     /*  161782 */   // GIR_Coverage, 1129,
     /*  161782 */   GIR_Done,
     /*  161783 */ // Label 3011: @161783
     /*  161783 */ GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(161827), // Rule ID 1131 //
     /*  161788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161798 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161812 */   // MIs[0] rs1
     /*  161812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161820 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10658>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161825 */   GIR_RootConstrainSelectedInstOperands,
     /*  161826 */   // GIR_Coverage, 1131,
     /*  161826 */   GIR_Done,
     /*  161827 */ // Label 3012: @161827
     /*  161827 */ GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(161871), // Rule ID 1133 //
     /*  161832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161838 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161856 */   // MIs[0] rs1
     /*  161856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161864 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161869 */   GIR_RootConstrainSelectedInstOperands,
     /*  161870 */   // GIR_Coverage, 1133,
     /*  161870 */   GIR_Done,
     /*  161871 */ // Label 3013: @161871
     /*  161871 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(161915), // Rule ID 1137 //
     /*  161876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161879 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161882 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161900 */   // MIs[0] rs1
     /*  161900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161908 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161913 */   GIR_RootConstrainSelectedInstOperands,
     /*  161914 */   // GIR_Coverage, 1137,
     /*  161914 */   GIR_Done,
     /*  161915 */ // Label 3014: @161915
     /*  161915 */ GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(161959), // Rule ID 1141 //
     /*  161920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161923 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161926 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161944 */   // MIs[0] rs1
     /*  161944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161952 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10664>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161957 */   GIR_RootConstrainSelectedInstOperands,
     /*  161958 */   // GIR_Coverage, 1141,
     /*  161958 */   GIR_Done,
     /*  161959 */ // Label 3015: @161959
     /*  161959 */ GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162003), // Rule ID 1143 //
     /*  161964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161967 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161988 */   // MIs[0] rs1
     /*  161988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161996 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10666>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162001 */   GIR_RootConstrainSelectedInstOperands,
     /*  162002 */   // GIR_Coverage, 1143,
     /*  162002 */   GIR_Done,
     /*  162003 */ // Label 3016: @162003
     /*  162003 */ GIM_Reject,
     /*  162004 */ // Label 2917: @162004
     /*  162004 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162123),
     /*  162009 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162012 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162028 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(162075), // Rule ID 45746 //
     /*  162033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162036 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162073 */     GIR_RootConstrainSelectedInstOperands,
     /*  162074 */     // GIR_Coverage, 45746,
     /*  162074 */     GIR_EraseRootFromParent_Done,
     /*  162075 */   // Label 3018: @162075
     /*  162075 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(162122), // Rule ID 45747 //
     /*  162080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162083 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162120 */     GIR_RootConstrainSelectedInstOperands,
     /*  162121 */     // GIR_Coverage, 45747,
     /*  162121 */     GIR_EraseRootFromParent_Done,
     /*  162122 */   // Label 3019: @162122
     /*  162122 */   GIM_Reject,
     /*  162123 */ // Label 3017: @162123
     /*  162123 */ GIM_Reject,
     /*  162124 */ // Label 2918: @162124
     /*  162124 */ GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(162251),
     /*  162129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162140 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162195), // Rule ID 45742 //
     /*  162145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162148 */     // MIs[0] rs1
     /*  162148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162156 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162193 */     GIR_RootConstrainSelectedInstOperands,
     /*  162194 */     // GIR_Coverage, 45742,
     /*  162194 */     GIR_EraseRootFromParent_Done,
     /*  162195 */   // Label 3021: @162195
     /*  162195 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(162250), // Rule ID 45743 //
     /*  162200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162203 */     // MIs[0] rs1
     /*  162203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162211 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162248 */     GIR_RootConstrainSelectedInstOperands,
     /*  162249 */     // GIR_Coverage, 45743,
     /*  162249 */     GIR_EraseRootFromParent_Done,
     /*  162250 */   // Label 3022: @162250
     /*  162250 */   GIM_Reject,
     /*  162251 */ // Label 3020: @162251
     /*  162251 */ GIM_Reject,
     /*  162252 */ // Label 2919: @162252
     /*  162252 */ GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162489),
     /*  162257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162268 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162323), // Rule ID 45938 //
     /*  162273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162276 */     // MIs[0] rs1
     /*  162276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162284 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162321 */     GIR_RootConstrainSelectedInstOperands,
     /*  162322 */     // GIR_Coverage, 45938,
     /*  162322 */     GIR_EraseRootFromParent_Done,
     /*  162323 */   // Label 3024: @162323
     /*  162323 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(162378), // Rule ID 45939 //
     /*  162328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162331 */     // MIs[0] rs1
     /*  162331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162339 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162376 */     GIR_RootConstrainSelectedInstOperands,
     /*  162377 */     // GIR_Coverage, 45939,
     /*  162377 */     GIR_EraseRootFromParent_Done,
     /*  162378 */   // Label 3025: @162378
     /*  162378 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(162433), // Rule ID 46014 //
     /*  162383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162386 */     // MIs[0] rs1
     /*  162386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162394 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162431 */     GIR_RootConstrainSelectedInstOperands,
     /*  162432 */     // GIR_Coverage, 46014,
     /*  162432 */     GIR_EraseRootFromParent_Done,
     /*  162433 */   // Label 3026: @162433
     /*  162433 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(162488), // Rule ID 46015 //
     /*  162438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162441 */     // MIs[0] rs1
     /*  162441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162449 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162486 */     GIR_RootConstrainSelectedInstOperands,
     /*  162487 */     // GIR_Coverage, 46015,
     /*  162487 */     GIR_EraseRootFromParent_Done,
     /*  162488 */   // Label 3027: @162488
     /*  162488 */   GIM_Reject,
     /*  162489 */ // Label 3023: @162489
     /*  162489 */ GIM_Reject,
     /*  162490 */ // Label 2920: @162490
     /*  162490 */ GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(162727),
     /*  162495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162506 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(162561), // Rule ID 45946 //
     /*  162511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162514 */     // MIs[0] rs1
     /*  162514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162522 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162559 */     GIR_RootConstrainSelectedInstOperands,
     /*  162560 */     // GIR_Coverage, 45946,
     /*  162560 */     GIR_EraseRootFromParent_Done,
     /*  162561 */   // Label 3029: @162561
     /*  162561 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(162616), // Rule ID 45947 //
     /*  162566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162569 */     // MIs[0] rs1
     /*  162569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162577 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162614 */     GIR_RootConstrainSelectedInstOperands,
     /*  162615 */     // GIR_Coverage, 45947,
     /*  162615 */     GIR_EraseRootFromParent_Done,
     /*  162616 */   // Label 3030: @162616
     /*  162616 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(162671), // Rule ID 46022 //
     /*  162621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162624 */     // MIs[0] rs1
     /*  162624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162632 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162669 */     GIR_RootConstrainSelectedInstOperands,
     /*  162670 */     // GIR_Coverage, 46022,
     /*  162670 */     GIR_EraseRootFromParent_Done,
     /*  162671 */   // Label 3031: @162671
     /*  162671 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(162726), // Rule ID 46023 //
     /*  162676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  162679 */     // MIs[0] rs1
     /*  162679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162687 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162724 */     GIR_RootConstrainSelectedInstOperands,
     /*  162725 */     // GIR_Coverage, 46023,
     /*  162725 */     GIR_EraseRootFromParent_Done,
     /*  162726 */   // Label 3032: @162726
     /*  162726 */   GIM_Reject,
     /*  162727 */ // Label 3028: @162727
     /*  162727 */ GIM_Reject,
     /*  162728 */ // Label 2921: @162728
     /*  162728 */ GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(162965),
     /*  162733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162744 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(162799), // Rule ID 45962 //
     /*  162749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  162752 */     // MIs[0] rs1
     /*  162752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162760 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162797 */     GIR_RootConstrainSelectedInstOperands,
     /*  162798 */     // GIR_Coverage, 45962,
     /*  162798 */     GIR_EraseRootFromParent_Done,
     /*  162799 */   // Label 3034: @162799
     /*  162799 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(162854), // Rule ID 45963 //
     /*  162804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  162807 */     // MIs[0] rs1
     /*  162807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162815 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162852 */     GIR_RootConstrainSelectedInstOperands,
     /*  162853 */     // GIR_Coverage, 45963,
     /*  162853 */     GIR_EraseRootFromParent_Done,
     /*  162854 */   // Label 3035: @162854
     /*  162854 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(162909), // Rule ID 46034 //
     /*  162859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  162862 */     // MIs[0] rs1
     /*  162862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162870 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162907 */     GIR_RootConstrainSelectedInstOperands,
     /*  162908 */     // GIR_Coverage, 46034,
     /*  162908 */     GIR_EraseRootFromParent_Done,
     /*  162909 */   // Label 3036: @162909
     /*  162909 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(162964), // Rule ID 46035 //
     /*  162914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  162917 */     // MIs[0] rs1
     /*  162917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162925 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162962 */     GIR_RootConstrainSelectedInstOperands,
     /*  162963 */     // GIR_Coverage, 46035,
     /*  162963 */     GIR_EraseRootFromParent_Done,
     /*  162964 */   // Label 3037: @162964
     /*  162964 */   GIM_Reject,
     /*  162965 */ // Label 3033: @162965
     /*  162965 */ GIM_Reject,
     /*  162966 */ // Label 2922: @162966
     /*  162966 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163085),
     /*  162971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162974 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162982 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162990 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163037), // Rule ID 46074 //
     /*  162995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162998 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163035 */     GIR_RootConstrainSelectedInstOperands,
     /*  163036 */     // GIR_Coverage, 46074,
     /*  163036 */     GIR_EraseRootFromParent_Done,
     /*  163037 */   // Label 3039: @163037
     /*  163037 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163084), // Rule ID 46075 //
     /*  163042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163045 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163082 */     GIR_RootConstrainSelectedInstOperands,
     /*  163083 */     // GIR_Coverage, 46075,
     /*  163083 */     GIR_EraseRootFromParent_Done,
     /*  163084 */   // Label 3040: @163084
     /*  163084 */   GIM_Reject,
     /*  163085 */ // Label 3038: @163085
     /*  163085 */ GIM_Reject,
     /*  163086 */ // Label 2923: @163086
     /*  163086 */ GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163213),
     /*  163091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163102 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163157), // Rule ID 45930 //
     /*  163107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163110 */     // MIs[0] rs1
     /*  163110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163118 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163155 */     GIR_RootConstrainSelectedInstOperands,
     /*  163156 */     // GIR_Coverage, 45930,
     /*  163156 */     GIR_EraseRootFromParent_Done,
     /*  163157 */   // Label 3042: @163157
     /*  163157 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163212), // Rule ID 45931 //
     /*  163162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163165 */     // MIs[0] rs1
     /*  163165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163173 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163210 */     GIR_RootConstrainSelectedInstOperands,
     /*  163211 */     // GIR_Coverage, 45931,
     /*  163211 */     GIR_EraseRootFromParent_Done,
     /*  163212 */   // Label 3043: @163212
     /*  163212 */   GIM_Reject,
     /*  163213 */ // Label 3041: @163213
     /*  163213 */ GIM_Reject,
     /*  163214 */ // Label 2924: @163214
     /*  163214 */ GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163451),
     /*  163219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163230 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163285), // Rule ID 45942 //
     /*  163235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163238 */     // MIs[0] rs1
     /*  163238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163246 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163283 */     GIR_RootConstrainSelectedInstOperands,
     /*  163284 */     // GIR_Coverage, 45942,
     /*  163284 */     GIR_EraseRootFromParent_Done,
     /*  163285 */   // Label 3045: @163285
     /*  163285 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163340), // Rule ID 45943 //
     /*  163290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163293 */     // MIs[0] rs1
     /*  163293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163301 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163338 */     GIR_RootConstrainSelectedInstOperands,
     /*  163339 */     // GIR_Coverage, 45943,
     /*  163339 */     GIR_EraseRootFromParent_Done,
     /*  163340 */   // Label 3046: @163340
     /*  163340 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(163395), // Rule ID 46018 //
     /*  163345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163348 */     // MIs[0] rs1
     /*  163348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163356 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163393 */     GIR_RootConstrainSelectedInstOperands,
     /*  163394 */     // GIR_Coverage, 46018,
     /*  163394 */     GIR_EraseRootFromParent_Done,
     /*  163395 */   // Label 3047: @163395
     /*  163395 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(163450), // Rule ID 46019 //
     /*  163400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163403 */     // MIs[0] rs1
     /*  163403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163411 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163448 */     GIR_RootConstrainSelectedInstOperands,
     /*  163449 */     // GIR_Coverage, 46019,
     /*  163449 */     GIR_EraseRootFromParent_Done,
     /*  163450 */   // Label 3048: @163450
     /*  163450 */   GIM_Reject,
     /*  163451 */ // Label 3044: @163451
     /*  163451 */ GIM_Reject,
     /*  163452 */ // Label 2925: @163452
     /*  163452 */ GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(163689),
     /*  163457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163468 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(163523), // Rule ID 45958 //
     /*  163473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163476 */     // MIs[0] rs1
     /*  163476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163484 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163521 */     GIR_RootConstrainSelectedInstOperands,
     /*  163522 */     // GIR_Coverage, 45958,
     /*  163522 */     GIR_EraseRootFromParent_Done,
     /*  163523 */   // Label 3050: @163523
     /*  163523 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(163578), // Rule ID 45959 //
     /*  163528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163531 */     // MIs[0] rs1
     /*  163531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163539 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163576 */     GIR_RootConstrainSelectedInstOperands,
     /*  163577 */     // GIR_Coverage, 45959,
     /*  163577 */     GIR_EraseRootFromParent_Done,
     /*  163578 */   // Label 3051: @163578
     /*  163578 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(163633), // Rule ID 46030 //
     /*  163583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163586 */     // MIs[0] rs1
     /*  163586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163594 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163631 */     GIR_RootConstrainSelectedInstOperands,
     /*  163632 */     // GIR_Coverage, 46030,
     /*  163632 */     GIR_EraseRootFromParent_Done,
     /*  163633 */   // Label 3052: @163633
     /*  163633 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(163688), // Rule ID 46031 //
     /*  163638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163641 */     // MIs[0] rs1
     /*  163641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163649 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163686 */     GIR_RootConstrainSelectedInstOperands,
     /*  163687 */     // GIR_Coverage, 46031,
     /*  163687 */     GIR_EraseRootFromParent_Done,
     /*  163688 */   // Label 3053: @163688
     /*  163688 */   GIM_Reject,
     /*  163689 */ // Label 3049: @163689
     /*  163689 */ GIM_Reject,
     /*  163690 */ // Label 2926: @163690
     /*  163690 */ GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(163927),
     /*  163695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163706 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(163761), // Rule ID 46002 //
     /*  163711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163714 */     // MIs[0] rs1
     /*  163714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163722 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163759 */     GIR_RootConstrainSelectedInstOperands,
     /*  163760 */     // GIR_Coverage, 46002,
     /*  163760 */     GIR_EraseRootFromParent_Done,
     /*  163761 */   // Label 3055: @163761
     /*  163761 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(163816), // Rule ID 46003 //
     /*  163766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163769 */     // MIs[0] rs1
     /*  163769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163777 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163814 */     GIR_RootConstrainSelectedInstOperands,
     /*  163815 */     // GIR_Coverage, 46003,
     /*  163815 */     GIR_EraseRootFromParent_Done,
     /*  163816 */   // Label 3056: @163816
     /*  163816 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(163871), // Rule ID 46062 //
     /*  163821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163824 */     // MIs[0] rs1
     /*  163824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163832 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163869 */     GIR_RootConstrainSelectedInstOperands,
     /*  163870 */     // GIR_Coverage, 46062,
     /*  163870 */     GIR_EraseRootFromParent_Done,
     /*  163871 */   // Label 3057: @163871
     /*  163871 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(163926), // Rule ID 46063 //
     /*  163876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163879 */     // MIs[0] rs1
     /*  163879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163887 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163924 */     GIR_RootConstrainSelectedInstOperands,
     /*  163925 */     // GIR_Coverage, 46063,
     /*  163925 */     GIR_EraseRootFromParent_Done,
     /*  163926 */   // Label 3058: @163926
     /*  163926 */   GIM_Reject,
     /*  163927 */ // Label 3054: @163927
     /*  163927 */ GIM_Reject,
     /*  163928 */ // Label 2927: @163928
     /*  163928 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164047),
     /*  163933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163952 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(163999), // Rule ID 46078 //
     /*  163957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163960 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163997 */     GIR_RootConstrainSelectedInstOperands,
     /*  163998 */     // GIR_Coverage, 46078,
     /*  163998 */     GIR_EraseRootFromParent_Done,
     /*  163999 */   // Label 3060: @163999
     /*  163999 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164046), // Rule ID 46079 //
     /*  164004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164007 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164044 */     GIR_RootConstrainSelectedInstOperands,
     /*  164045 */     // GIR_Coverage, 46079,
     /*  164045 */     GIR_EraseRootFromParent_Done,
     /*  164046 */   // Label 3061: @164046
     /*  164046 */   GIM_Reject,
     /*  164047 */ // Label 3059: @164047
     /*  164047 */ GIM_Reject,
     /*  164048 */ // Label 2928: @164048
     /*  164048 */ GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164175),
     /*  164053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164056 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164064 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164119), // Rule ID 45934 //
     /*  164069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164072 */     // MIs[0] rs1
     /*  164072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164080 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164117 */     GIR_RootConstrainSelectedInstOperands,
     /*  164118 */     // GIR_Coverage, 45934,
     /*  164118 */     GIR_EraseRootFromParent_Done,
     /*  164119 */   // Label 3063: @164119
     /*  164119 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164174), // Rule ID 45935 //
     /*  164124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164127 */     // MIs[0] rs1
     /*  164127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164135 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164172 */     GIR_RootConstrainSelectedInstOperands,
     /*  164173 */     // GIR_Coverage, 45935,
     /*  164173 */     GIR_EraseRootFromParent_Done,
     /*  164174 */   // Label 3064: @164174
     /*  164174 */   GIM_Reject,
     /*  164175 */ // Label 3062: @164175
     /*  164175 */ GIM_Reject,
     /*  164176 */ // Label 2929: @164176
     /*  164176 */ GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164413),
     /*  164181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164192 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164247), // Rule ID 45954 //
     /*  164197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164200 */     // MIs[0] rs1
     /*  164200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164208 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164245 */     GIR_RootConstrainSelectedInstOperands,
     /*  164246 */     // GIR_Coverage, 45954,
     /*  164246 */     GIR_EraseRootFromParent_Done,
     /*  164247 */   // Label 3066: @164247
     /*  164247 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164302), // Rule ID 45955 //
     /*  164252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164255 */     // MIs[0] rs1
     /*  164255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164263 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164300 */     GIR_RootConstrainSelectedInstOperands,
     /*  164301 */     // GIR_Coverage, 45955,
     /*  164301 */     GIR_EraseRootFromParent_Done,
     /*  164302 */   // Label 3067: @164302
     /*  164302 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164357), // Rule ID 46026 //
     /*  164307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164310 */     // MIs[0] rs1
     /*  164310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164318 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164355 */     GIR_RootConstrainSelectedInstOperands,
     /*  164356 */     // GIR_Coverage, 46026,
     /*  164356 */     GIR_EraseRootFromParent_Done,
     /*  164357 */   // Label 3068: @164357
     /*  164357 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164412), // Rule ID 46027 //
     /*  164362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164365 */     // MIs[0] rs1
     /*  164365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164373 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164410 */     GIR_RootConstrainSelectedInstOperands,
     /*  164411 */     // GIR_Coverage, 46027,
     /*  164411 */     GIR_EraseRootFromParent_Done,
     /*  164412 */   // Label 3069: @164412
     /*  164412 */   GIM_Reject,
     /*  164413 */ // Label 3065: @164413
     /*  164413 */ GIM_Reject,
     /*  164414 */ // Label 2930: @164414
     /*  164414 */ GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164651),
     /*  164419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164430 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164485), // Rule ID 45990 //
     /*  164435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164438 */     // MIs[0] rs1
     /*  164438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164446 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164483 */     GIR_RootConstrainSelectedInstOperands,
     /*  164484 */     // GIR_Coverage, 45990,
     /*  164484 */     GIR_EraseRootFromParent_Done,
     /*  164485 */   // Label 3071: @164485
     /*  164485 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(164540), // Rule ID 45991 //
     /*  164490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164493 */     // MIs[0] rs1
     /*  164493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164501 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164538 */     GIR_RootConstrainSelectedInstOperands,
     /*  164539 */     // GIR_Coverage, 45991,
     /*  164539 */     GIR_EraseRootFromParent_Done,
     /*  164540 */   // Label 3072: @164540
     /*  164540 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(164595), // Rule ID 46050 //
     /*  164545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164548 */     // MIs[0] rs1
     /*  164548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164556 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164593 */     GIR_RootConstrainSelectedInstOperands,
     /*  164594 */     // GIR_Coverage, 46050,
     /*  164594 */     GIR_EraseRootFromParent_Done,
     /*  164595 */   // Label 3073: @164595
     /*  164595 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(164650), // Rule ID 46051 //
     /*  164600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164603 */     // MIs[0] rs1
     /*  164603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164611 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164648 */     GIR_RootConstrainSelectedInstOperands,
     /*  164649 */     // GIR_Coverage, 46051,
     /*  164649 */     GIR_EraseRootFromParent_Done,
     /*  164650 */   // Label 3074: @164650
     /*  164650 */   GIM_Reject,
     /*  164651 */ // Label 3070: @164651
     /*  164651 */ GIM_Reject,
     /*  164652 */ // Label 2931: @164652
     /*  164652 */ GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(164889),
     /*  164657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164668 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(164723), // Rule ID 46006 //
     /*  164673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164676 */     // MIs[0] rs1
     /*  164676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164684 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164721 */     GIR_RootConstrainSelectedInstOperands,
     /*  164722 */     // GIR_Coverage, 46006,
     /*  164722 */     GIR_EraseRootFromParent_Done,
     /*  164723 */   // Label 3076: @164723
     /*  164723 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(164778), // Rule ID 46007 //
     /*  164728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164731 */     // MIs[0] rs1
     /*  164731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164739 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164776 */     GIR_RootConstrainSelectedInstOperands,
     /*  164777 */     // GIR_Coverage, 46007,
     /*  164777 */     GIR_EraseRootFromParent_Done,
     /*  164778 */   // Label 3077: @164778
     /*  164778 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(164833), // Rule ID 46066 //
     /*  164783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164786 */     // MIs[0] rs1
     /*  164786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164794 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164831 */     GIR_RootConstrainSelectedInstOperands,
     /*  164832 */     // GIR_Coverage, 46066,
     /*  164832 */     GIR_EraseRootFromParent_Done,
     /*  164833 */   // Label 3078: @164833
     /*  164833 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(164888), // Rule ID 46067 //
     /*  164838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164841 */     // MIs[0] rs1
     /*  164841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164849 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164886 */     GIR_RootConstrainSelectedInstOperands,
     /*  164887 */     // GIR_Coverage, 46067,
     /*  164887 */     GIR_EraseRootFromParent_Done,
     /*  164888 */   // Label 3079: @164888
     /*  164888 */   GIM_Reject,
     /*  164889 */ // Label 3075: @164889
     /*  164889 */ GIM_Reject,
     /*  164890 */ // Label 2932: @164890
     /*  164890 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165009),
     /*  164895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164914 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(164961), // Rule ID 46082 //
     /*  164919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164922 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164959 */     GIR_RootConstrainSelectedInstOperands,
     /*  164960 */     // GIR_Coverage, 46082,
     /*  164960 */     GIR_EraseRootFromParent_Done,
     /*  164961 */   // Label 3081: @164961
     /*  164961 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165008), // Rule ID 46083 //
     /*  164966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164969 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165006 */     GIR_RootConstrainSelectedInstOperands,
     /*  165007 */     // GIR_Coverage, 46083,
     /*  165007 */     GIR_EraseRootFromParent_Done,
     /*  165008 */   // Label 3082: @165008
     /*  165008 */   GIM_Reject,
     /*  165009 */ // Label 3080: @165009
     /*  165009 */ GIM_Reject,
     /*  165010 */ // Label 2933: @165010
     /*  165010 */ GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165137),
     /*  165015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165026 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165081), // Rule ID 45950 //
     /*  165031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165034 */     // MIs[0] rs1
     /*  165034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165042 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165079 */     GIR_RootConstrainSelectedInstOperands,
     /*  165080 */     // GIR_Coverage, 45950,
     /*  165080 */     GIR_EraseRootFromParent_Done,
     /*  165081 */   // Label 3084: @165081
     /*  165081 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165136), // Rule ID 45951 //
     /*  165086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165089 */     // MIs[0] rs1
     /*  165089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165097 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165134 */     GIR_RootConstrainSelectedInstOperands,
     /*  165135 */     // GIR_Coverage, 45951,
     /*  165135 */     GIR_EraseRootFromParent_Done,
     /*  165136 */   // Label 3085: @165136
     /*  165136 */   GIM_Reject,
     /*  165137 */ // Label 3083: @165137
     /*  165137 */ GIM_Reject,
     /*  165138 */ // Label 2934: @165138
     /*  165138 */ GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165375),
     /*  165143 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165154 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165209), // Rule ID 45978 //
     /*  165159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165162 */     // MIs[0] rs1
     /*  165162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165170 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165207 */     GIR_RootConstrainSelectedInstOperands,
     /*  165208 */     // GIR_Coverage, 45978,
     /*  165208 */     GIR_EraseRootFromParent_Done,
     /*  165209 */   // Label 3087: @165209
     /*  165209 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165264), // Rule ID 45979 //
     /*  165214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165217 */     // MIs[0] rs1
     /*  165217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165225 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165262 */     GIR_RootConstrainSelectedInstOperands,
     /*  165263 */     // GIR_Coverage, 45979,
     /*  165263 */     GIR_EraseRootFromParent_Done,
     /*  165264 */   // Label 3088: @165264
     /*  165264 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165319), // Rule ID 46038 //
     /*  165269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165272 */     // MIs[0] rs1
     /*  165272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165280 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165317 */     GIR_RootConstrainSelectedInstOperands,
     /*  165318 */     // GIR_Coverage, 46038,
     /*  165318 */     GIR_EraseRootFromParent_Done,
     /*  165319 */   // Label 3089: @165319
     /*  165319 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165374), // Rule ID 46039 //
     /*  165324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165327 */     // MIs[0] rs1
     /*  165327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165335 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165372 */     GIR_RootConstrainSelectedInstOperands,
     /*  165373 */     // GIR_Coverage, 46039,
     /*  165373 */     GIR_EraseRootFromParent_Done,
     /*  165374 */   // Label 3090: @165374
     /*  165374 */   GIM_Reject,
     /*  165375 */ // Label 3086: @165375
     /*  165375 */ GIM_Reject,
     /*  165376 */ // Label 2935: @165376
     /*  165376 */ GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165613),
     /*  165381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165392 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165447), // Rule ID 45994 //
     /*  165397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165400 */     // MIs[0] rs1
     /*  165400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165408 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165445 */     GIR_RootConstrainSelectedInstOperands,
     /*  165446 */     // GIR_Coverage, 45994,
     /*  165446 */     GIR_EraseRootFromParent_Done,
     /*  165447 */   // Label 3092: @165447
     /*  165447 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165502), // Rule ID 45995 //
     /*  165452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165455 */     // MIs[0] rs1
     /*  165455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165463 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165500 */     GIR_RootConstrainSelectedInstOperands,
     /*  165501 */     // GIR_Coverage, 45995,
     /*  165501 */     GIR_EraseRootFromParent_Done,
     /*  165502 */   // Label 3093: @165502
     /*  165502 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165557), // Rule ID 46054 //
     /*  165507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165510 */     // MIs[0] rs1
     /*  165510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165518 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165555 */     GIR_RootConstrainSelectedInstOperands,
     /*  165556 */     // GIR_Coverage, 46054,
     /*  165556 */     GIR_EraseRootFromParent_Done,
     /*  165557 */   // Label 3094: @165557
     /*  165557 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165612), // Rule ID 46055 //
     /*  165562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165565 */     // MIs[0] rs1
     /*  165565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165573 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165610 */     GIR_RootConstrainSelectedInstOperands,
     /*  165611 */     // GIR_Coverage, 46055,
     /*  165611 */     GIR_EraseRootFromParent_Done,
     /*  165612 */   // Label 3095: @165612
     /*  165612 */   GIM_Reject,
     /*  165613 */ // Label 3091: @165613
     /*  165613 */ GIM_Reject,
     /*  165614 */ // Label 2936: @165614
     /*  165614 */ GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165851),
     /*  165619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165630 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165685), // Rule ID 46010 //
     /*  165635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165638 */     // MIs[0] rs1
     /*  165638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165646 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165683 */     GIR_RootConstrainSelectedInstOperands,
     /*  165684 */     // GIR_Coverage, 46010,
     /*  165684 */     GIR_EraseRootFromParent_Done,
     /*  165685 */   // Label 3097: @165685
     /*  165685 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165740), // Rule ID 46011 //
     /*  165690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165693 */     // MIs[0] rs1
     /*  165693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165701 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165738 */     GIR_RootConstrainSelectedInstOperands,
     /*  165739 */     // GIR_Coverage, 46011,
     /*  165739 */     GIR_EraseRootFromParent_Done,
     /*  165740 */   // Label 3098: @165740
     /*  165740 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165795), // Rule ID 46070 //
     /*  165745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165748 */     // MIs[0] rs1
     /*  165748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165756 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165793 */     GIR_RootConstrainSelectedInstOperands,
     /*  165794 */     // GIR_Coverage, 46070,
     /*  165794 */     GIR_EraseRootFromParent_Done,
     /*  165795 */   // Label 3099: @165795
     /*  165795 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165850), // Rule ID 46071 //
     /*  165800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165803 */     // MIs[0] rs1
     /*  165803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165811 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165848 */     GIR_RootConstrainSelectedInstOperands,
     /*  165849 */     // GIR_Coverage, 46071,
     /*  165849 */     GIR_EraseRootFromParent_Done,
     /*  165850 */   // Label 3100: @165850
     /*  165850 */   GIM_Reject,
     /*  165851 */ // Label 3096: @165851
     /*  165851 */ GIM_Reject,
     /*  165852 */ // Label 2937: @165852
     /*  165852 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(165971),
     /*  165857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165876 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(165923), // Rule ID 46086 //
     /*  165881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165884 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165921 */     GIR_RootConstrainSelectedInstOperands,
     /*  165922 */     // GIR_Coverage, 46086,
     /*  165922 */     GIR_EraseRootFromParent_Done,
     /*  165923 */   // Label 3102: @165923
     /*  165923 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(165970), // Rule ID 46087 //
     /*  165928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165931 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165968 */     GIR_RootConstrainSelectedInstOperands,
     /*  165969 */     // GIR_Coverage, 46087,
     /*  165969 */     GIR_EraseRootFromParent_Done,
     /*  165970 */   // Label 3103: @165970
     /*  165970 */   GIM_Reject,
     /*  165971 */ // Label 3101: @165971
     /*  165971 */ GIM_Reject,
     /*  165972 */ // Label 2938: @165972
     /*  165972 */ GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166099),
     /*  165977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165988 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166043), // Rule ID 45966 //
     /*  165993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165996 */     // MIs[0] rs1
     /*  165996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166004 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166041 */     GIR_RootConstrainSelectedInstOperands,
     /*  166042 */     // GIR_Coverage, 45966,
     /*  166042 */     GIR_EraseRootFromParent_Done,
     /*  166043 */   // Label 3105: @166043
     /*  166043 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166098), // Rule ID 45967 //
     /*  166048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166051 */     // MIs[0] rs1
     /*  166051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166059 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166096 */     GIR_RootConstrainSelectedInstOperands,
     /*  166097 */     // GIR_Coverage, 45967,
     /*  166097 */     GIR_EraseRootFromParent_Done,
     /*  166098 */   // Label 3106: @166098
     /*  166098 */   GIM_Reject,
     /*  166099 */ // Label 3104: @166099
     /*  166099 */ GIM_Reject,
     /*  166100 */ // Label 2939: @166100
     /*  166100 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166337),
     /*  166105 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166108 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166116 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166171), // Rule ID 45982 //
     /*  166121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166124 */     // MIs[0] rs1
     /*  166124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166132 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166169 */     GIR_RootConstrainSelectedInstOperands,
     /*  166170 */     // GIR_Coverage, 45982,
     /*  166170 */     GIR_EraseRootFromParent_Done,
     /*  166171 */   // Label 3108: @166171
     /*  166171 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166226), // Rule ID 45983 //
     /*  166176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166179 */     // MIs[0] rs1
     /*  166179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166187 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166224 */     GIR_RootConstrainSelectedInstOperands,
     /*  166225 */     // GIR_Coverage, 45983,
     /*  166225 */     GIR_EraseRootFromParent_Done,
     /*  166226 */   // Label 3109: @166226
     /*  166226 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166281), // Rule ID 46042 //
     /*  166231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166234 */     // MIs[0] rs1
     /*  166234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166242 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166279 */     GIR_RootConstrainSelectedInstOperands,
     /*  166280 */     // GIR_Coverage, 46042,
     /*  166280 */     GIR_EraseRootFromParent_Done,
     /*  166281 */   // Label 3110: @166281
     /*  166281 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166336), // Rule ID 46043 //
     /*  166286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166289 */     // MIs[0] rs1
     /*  166289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166297 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166334 */     GIR_RootConstrainSelectedInstOperands,
     /*  166335 */     // GIR_Coverage, 46043,
     /*  166335 */     GIR_EraseRootFromParent_Done,
     /*  166336 */   // Label 3111: @166336
     /*  166336 */   GIM_Reject,
     /*  166337 */ // Label 3107: @166337
     /*  166337 */ GIM_Reject,
     /*  166338 */ // Label 2940: @166338
     /*  166338 */ GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166575),
     /*  166343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166354 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166409), // Rule ID 45998 //
     /*  166359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166362 */     // MIs[0] rs1
     /*  166362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166370 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166407 */     GIR_RootConstrainSelectedInstOperands,
     /*  166408 */     // GIR_Coverage, 45998,
     /*  166408 */     GIR_EraseRootFromParent_Done,
     /*  166409 */   // Label 3113: @166409
     /*  166409 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166464), // Rule ID 45999 //
     /*  166414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166417 */     // MIs[0] rs1
     /*  166417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166425 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166462 */     GIR_RootConstrainSelectedInstOperands,
     /*  166463 */     // GIR_Coverage, 45999,
     /*  166463 */     GIR_EraseRootFromParent_Done,
     /*  166464 */   // Label 3114: @166464
     /*  166464 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166519), // Rule ID 46058 //
     /*  166469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166472 */     // MIs[0] rs1
     /*  166472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166480 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166517 */     GIR_RootConstrainSelectedInstOperands,
     /*  166518 */     // GIR_Coverage, 46058,
     /*  166518 */     GIR_EraseRootFromParent_Done,
     /*  166519 */   // Label 3115: @166519
     /*  166519 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166574), // Rule ID 46059 //
     /*  166524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166527 */     // MIs[0] rs1
     /*  166527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166535 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166572 */     GIR_RootConstrainSelectedInstOperands,
     /*  166573 */     // GIR_Coverage, 46059,
     /*  166573 */     GIR_EraseRootFromParent_Done,
     /*  166574 */   // Label 3116: @166574
     /*  166574 */   GIM_Reject,
     /*  166575 */ // Label 3112: @166575
     /*  166575 */ GIM_Reject,
     /*  166576 */ // Label 2941: @166576
     /*  166576 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166695),
     /*  166581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166600 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166647), // Rule ID 46090 //
     /*  166605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166608 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166645 */     GIR_RootConstrainSelectedInstOperands,
     /*  166646 */     // GIR_Coverage, 46090,
     /*  166646 */     GIR_EraseRootFromParent_Done,
     /*  166647 */   // Label 3118: @166647
     /*  166647 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166694), // Rule ID 46091 //
     /*  166652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166655 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166692 */     GIR_RootConstrainSelectedInstOperands,
     /*  166693 */     // GIR_Coverage, 46091,
     /*  166693 */     GIR_EraseRootFromParent_Done,
     /*  166694 */   // Label 3119: @166694
     /*  166694 */   GIM_Reject,
     /*  166695 */ // Label 3117: @166695
     /*  166695 */ GIM_Reject,
     /*  166696 */ // Label 2942: @166696
     /*  166696 */ GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166823),
     /*  166701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166712 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166767), // Rule ID 45970 //
     /*  166717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166720 */     // MIs[0] rs1
     /*  166720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166728 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166765 */     GIR_RootConstrainSelectedInstOperands,
     /*  166766 */     // GIR_Coverage, 45970,
     /*  166766 */     GIR_EraseRootFromParent_Done,
     /*  166767 */   // Label 3121: @166767
     /*  166767 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166822), // Rule ID 45971 //
     /*  166772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166775 */     // MIs[0] rs1
     /*  166775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166783 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166820 */     GIR_RootConstrainSelectedInstOperands,
     /*  166821 */     // GIR_Coverage, 45971,
     /*  166821 */     GIR_EraseRootFromParent_Done,
     /*  166822 */   // Label 3122: @166822
     /*  166822 */   GIM_Reject,
     /*  166823 */ // Label 3120: @166823
     /*  166823 */ GIM_Reject,
     /*  166824 */ // Label 2943: @166824
     /*  166824 */ GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167061),
     /*  166829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166832 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166840 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166895), // Rule ID 45986 //
     /*  166845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166848 */     // MIs[0] rs1
     /*  166848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166856 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166893 */     GIR_RootConstrainSelectedInstOperands,
     /*  166894 */     // GIR_Coverage, 45986,
     /*  166894 */     GIR_EraseRootFromParent_Done,
     /*  166895 */   // Label 3124: @166895
     /*  166895 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166950), // Rule ID 45987 //
     /*  166900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166903 */     // MIs[0] rs1
     /*  166903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166911 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166948 */     GIR_RootConstrainSelectedInstOperands,
     /*  166949 */     // GIR_Coverage, 45987,
     /*  166949 */     GIR_EraseRootFromParent_Done,
     /*  166950 */   // Label 3125: @166950
     /*  166950 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167005), // Rule ID 46046 //
     /*  166955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166958 */     // MIs[0] rs1
     /*  166958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166966 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167003 */     GIR_RootConstrainSelectedInstOperands,
     /*  167004 */     // GIR_Coverage, 46046,
     /*  167004 */     GIR_EraseRootFromParent_Done,
     /*  167005 */   // Label 3126: @167005
     /*  167005 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167060), // Rule ID 46047 //
     /*  167010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  167013 */     // MIs[0] rs1
     /*  167013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167021 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167058 */     GIR_RootConstrainSelectedInstOperands,
     /*  167059 */     // GIR_Coverage, 46047,
     /*  167059 */     GIR_EraseRootFromParent_Done,
     /*  167060 */   // Label 3127: @167060
     /*  167060 */   GIM_Reject,
     /*  167061 */ // Label 3123: @167061
     /*  167061 */ GIM_Reject,
     /*  167062 */ // Label 2944: @167062
     /*  167062 */ GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167181),
     /*  167067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167086 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167133), // Rule ID 46094 //
     /*  167091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167094 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  167094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167131 */     GIR_RootConstrainSelectedInstOperands,
     /*  167132 */     // GIR_Coverage, 46094,
     /*  167132 */     GIR_EraseRootFromParent_Done,
     /*  167133 */   // Label 3129: @167133
     /*  167133 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167180), // Rule ID 46095 //
     /*  167138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167141 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167178 */     GIR_RootConstrainSelectedInstOperands,
     /*  167179 */     // GIR_Coverage, 46095,
     /*  167179 */     GIR_EraseRootFromParent_Done,
     /*  167180 */   // Label 3130: @167180
     /*  167180 */   GIM_Reject,
     /*  167181 */ // Label 3128: @167181
     /*  167181 */ GIM_Reject,
     /*  167182 */ // Label 2945: @167182
     /*  167182 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167309),
     /*  167187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167198 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167253), // Rule ID 45974 //
     /*  167203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167206 */     // MIs[0] rs1
     /*  167206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167214 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167251 */     GIR_RootConstrainSelectedInstOperands,
     /*  167252 */     // GIR_Coverage, 45974,
     /*  167252 */     GIR_EraseRootFromParent_Done,
     /*  167253 */   // Label 3132: @167253
     /*  167253 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167308), // Rule ID 45975 //
     /*  167258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167261 */     // MIs[0] rs1
     /*  167261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167269 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167306 */     GIR_RootConstrainSelectedInstOperands,
     /*  167307 */     // GIR_Coverage, 45975,
     /*  167307 */     GIR_EraseRootFromParent_Done,
     /*  167308 */   // Label 3133: @167308
     /*  167308 */   GIM_Reject,
     /*  167309 */ // Label 3131: @167309
     /*  167309 */ GIM_Reject,
     /*  167310 */ // Label 2946: @167310
     /*  167310 */ GIM_Reject,
     /*  167311 */ // Label 22: @167311
     /*  167311 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3136*/ GIMT_Encode4(168424),
     /*  167322 */ /*GILLT_s32*//*Label 3134*/ GIMT_Encode4(167330),
     /*  167326 */ /*GILLT_s64*//*Label 3135*/ GIMT_Encode4(167850),
     /*  167330 */ // Label 3134: @167330
     /*  167330 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167384), // Rule ID 235 //
     /*  167335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167341 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167363 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167382 */   GIR_RootConstrainSelectedInstOperands,
     /*  167383 */   // GIR_Coverage, 235,
     /*  167383 */   GIR_EraseRootFromParent_Done,
     /*  167384 */ // Label 3137: @167384
     /*  167384 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167438), // Rule ID 239 //
     /*  167389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167417 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167436 */   GIR_RootConstrainSelectedInstOperands,
     /*  167437 */   // GIR_Coverage, 239,
     /*  167437 */   GIR_EraseRootFromParent_Done,
     /*  167438 */ // Label 3138: @167438
     /*  167438 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167495), // Rule ID 328 //
     /*  167443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167446 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167456 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167474 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167493 */   GIR_RootConstrainSelectedInstOperands,
     /*  167494 */   // GIR_Coverage, 328,
     /*  167494 */   GIR_EraseRootFromParent_Done,
     /*  167495 */ // Label 3139: @167495
     /*  167495 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167552), // Rule ID 332 //
     /*  167500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167503 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167506 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167513 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167520 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167524 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167531 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167550 */   GIR_RootConstrainSelectedInstOperands,
     /*  167551 */   // GIR_Coverage, 332,
     /*  167551 */   GIR_EraseRootFromParent_Done,
     /*  167552 */ // Label 3140: @167552
     /*  167552 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167609), // Rule ID 348 //
     /*  167557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  167560 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167570 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167588 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167607 */   GIR_RootConstrainSelectedInstOperands,
     /*  167608 */   // GIR_Coverage, 348,
     /*  167608 */   GIR_EraseRootFromParent_Done,
     /*  167609 */ // Label 3141: @167609
     /*  167609 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167649), // Rule ID 1104 //
     /*  167614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167634 */   // MIs[0] rs1
     /*  167634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167642 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167647 */   GIR_RootConstrainSelectedInstOperands,
     /*  167648 */   // GIR_Coverage, 1104,
     /*  167648 */   GIR_Done,
     /*  167649 */ // Label 3142: @167649
     /*  167649 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167689), // Rule ID 1108 //
     /*  167654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167660 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167674 */   // MIs[0] rs1
     /*  167674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167682 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167687 */   GIR_RootConstrainSelectedInstOperands,
     /*  167688 */   // GIR_Coverage, 1108,
     /*  167688 */   GIR_Done,
     /*  167689 */ // Label 3143: @167689
     /*  167689 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167729), // Rule ID 1112 //
     /*  167694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167714 */   // MIs[0] rs1
     /*  167714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167722 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167727 */   GIR_RootConstrainSelectedInstOperands,
     /*  167728 */   // GIR_Coverage, 1112,
     /*  167728 */   GIR_Done,
     /*  167729 */ // Label 3144: @167729
     /*  167729 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167769), // Rule ID 1116 //
     /*  167734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167737 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167740 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167747 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167754 */   // MIs[0] rs1
     /*  167754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167762 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167767 */   GIR_RootConstrainSelectedInstOperands,
     /*  167768 */   // GIR_Coverage, 1116,
     /*  167768 */   GIR_Done,
     /*  167769 */ // Label 3145: @167769
     /*  167769 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167809), // Rule ID 1136 //
     /*  167774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167794 */   // MIs[0] rs1
     /*  167794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167802 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167807 */   GIR_RootConstrainSelectedInstOperands,
     /*  167808 */   // GIR_Coverage, 1136,
     /*  167808 */   GIR_Done,
     /*  167809 */ // Label 3146: @167809
     /*  167809 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167849), // Rule ID 1140 //
     /*  167814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167817 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167834 */   // MIs[0] rs1
     /*  167834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167842 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167847 */   GIR_RootConstrainSelectedInstOperands,
     /*  167848 */   // GIR_Coverage, 1140,
     /*  167848 */   GIR_Done,
     /*  167849 */ // Label 3147: @167849
     /*  167849 */ GIM_Reject,
     /*  167850 */ // Label 3135: @167850
     /*  167850 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167904), // Rule ID 234 //
     /*  167855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167861 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167883 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167902 */   GIR_RootConstrainSelectedInstOperands,
     /*  167903 */   // GIR_Coverage, 234,
     /*  167903 */   GIR_EraseRootFromParent_Done,
     /*  167904 */ // Label 3148: @167904
     /*  167904 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167958), // Rule ID 238 //
     /*  167909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167915 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167937 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167956 */   GIR_RootConstrainSelectedInstOperands,
     /*  167957 */   // GIR_Coverage, 238,
     /*  167957 */   GIR_EraseRootFromParent_Done,
     /*  167958 */ // Label 3149: @167958
     /*  167958 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168012), // Rule ID 285 //
     /*  167963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  167966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167980 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167984 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167991 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168010 */   GIR_RootConstrainSelectedInstOperands,
     /*  168011 */   // GIR_Coverage, 285,
     /*  168011 */   GIR_EraseRootFromParent_Done,
     /*  168012 */ // Label 3150: @168012
     /*  168012 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168069), // Rule ID 327 //
     /*  168017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168030 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168048 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10132>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168063 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168067 */   GIR_RootConstrainSelectedInstOperands,
     /*  168068 */   // GIR_Coverage, 327,
     /*  168068 */   GIR_EraseRootFromParent_Done,
     /*  168069 */ // Label 3151: @168069
     /*  168069 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(168126), // Rule ID 331 //
     /*  168074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168077 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168087 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168098 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168105 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10134>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168124 */   GIR_RootConstrainSelectedInstOperands,
     /*  168125 */   // GIR_Coverage, 331,
     /*  168125 */   GIR_EraseRootFromParent_Done,
     /*  168126 */ // Label 3152: @168126
     /*  168126 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168183), // Rule ID 347 //
     /*  168131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  168134 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168144 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168162 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10148>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  168165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168181 */   GIR_RootConstrainSelectedInstOperands,
     /*  168182 */   // GIR_Coverage, 347,
     /*  168182 */   GIR_EraseRootFromParent_Done,
     /*  168183 */ // Label 3153: @168183
     /*  168183 */ GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168223), // Rule ID 1103 //
     /*  168188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168208 */   // MIs[0] rs1
     /*  168208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168216 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10636>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168221 */   GIR_RootConstrainSelectedInstOperands,
     /*  168222 */   // GIR_Coverage, 1103,
     /*  168222 */   GIR_Done,
     /*  168223 */ // Label 3154: @168223
     /*  168223 */ GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168263), // Rule ID 1107 //
     /*  168228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168248 */   // MIs[0] rs1
     /*  168248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168256 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10638>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168261 */   GIR_RootConstrainSelectedInstOperands,
     /*  168262 */   // GIR_Coverage, 1107,
     /*  168262 */   GIR_Done,
     /*  168263 */ // Label 3155: @168263
     /*  168263 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168303), // Rule ID 1111 //
     /*  168268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168288 */   // MIs[0] rs1
     /*  168288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168296 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10640>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168301 */   GIR_RootConstrainSelectedInstOperands,
     /*  168302 */   // GIR_Coverage, 1111,
     /*  168302 */   GIR_Done,
     /*  168303 */ // Label 3156: @168303
     /*  168303 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168343), // Rule ID 1115 //
     /*  168308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  168311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168328 */   // MIs[0] rs1
     /*  168328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168336 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10642>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168341 */   GIR_RootConstrainSelectedInstOperands,
     /*  168342 */   // GIR_Coverage, 1115,
     /*  168342 */   GIR_Done,
     /*  168343 */ // Label 3157: @168343
     /*  168343 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168383), // Rule ID 1135 //
     /*  168348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  168351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168368 */   // MIs[0] rs1
     /*  168368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168376 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10660>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  168381 */   GIR_RootConstrainSelectedInstOperands,
     /*  168382 */   // GIR_Coverage, 1135,
     /*  168382 */   GIR_Done,
     /*  168383 */ // Label 3158: @168383
     /*  168383 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168423), // Rule ID 1139 //
     /*  168388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  168391 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168408 */   // MIs[0] rs1
     /*  168408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  168412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168416 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10662>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  168416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  168421 */   GIR_RootConstrainSelectedInstOperands,
     /*  168422 */   // GIR_Coverage, 1139,
     /*  168422 */   GIR_Done,
     /*  168423 */ // Label 3159: @168423
     /*  168423 */ GIM_Reject,
     /*  168424 */ // Label 3136: @168424
     /*  168424 */ GIM_Reject,
     /*  168425 */ // Label 23: @168425
     /*  168425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3162*/ GIMT_Encode4(169058),
     /*  168436 */ /*GILLT_s32*//*Label 3160*/ GIMT_Encode4(168444),
     /*  168440 */ /*GILLT_s64*//*Label 3161*/ GIMT_Encode4(168724),
     /*  168444 */ // Label 3160: @168444
     /*  168444 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168498), // Rule ID 245 //
     /*  168449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168477 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168496 */   GIR_RootConstrainSelectedInstOperands,
     /*  168497 */   // GIR_Coverage, 245,
     /*  168497 */   GIR_EraseRootFromParent_Done,
     /*  168498 */ // Label 3163: @168498
     /*  168498 */ GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168552), // Rule ID 247 //
     /*  168503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168509 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168520 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168524 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168531 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168550 */   GIR_RootConstrainSelectedInstOperands,
     /*  168551 */   // GIR_Coverage, 247,
     /*  168551 */   GIR_EraseRootFromParent_Done,
     /*  168552 */ // Label 3164: @168552
     /*  168552 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168609), // Rule ID 334 //
     /*  168557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168560 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168570 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168588 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10136>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168607 */   GIR_RootConstrainSelectedInstOperands,
     /*  168608 */   // GIR_Coverage, 334,
     /*  168608 */   GIR_EraseRootFromParent_Done,
     /*  168609 */ // Label 3165: @168609
     /*  168609 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168666), // Rule ID 336 //
     /*  168614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168627 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168645 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10138>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168664 */   GIR_RootConstrainSelectedInstOperands,
     /*  168665 */   // GIR_Coverage, 336,
     /*  168665 */   GIR_EraseRootFromParent_Done,
     /*  168666 */ // Label 3166: @168666
     /*  168666 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(168723), // Rule ID 350 //
     /*  168671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168674 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168684 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168702 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10150>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168721 */   GIR_RootConstrainSelectedInstOperands,
     /*  168722 */   // GIR_Coverage, 350,
     /*  168722 */   GIR_EraseRootFromParent_Done,
     /*  168723 */ // Label 3167: @168723
     /*  168723 */ GIM_Reject,
     /*  168724 */ // Label 3161: @168724
     /*  168724 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(168778), // Rule ID 244 //
     /*  168729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168735 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168746 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168750 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168757 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168776 */   GIR_RootConstrainSelectedInstOperands,
     /*  168777 */   // GIR_Coverage, 244,
     /*  168777 */   GIR_EraseRootFromParent_Done,
     /*  168778 */ // Label 3168: @168778
     /*  168778 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(168832), // Rule ID 246 //
     /*  168783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168811 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168830 */   GIR_RootConstrainSelectedInstOperands,
     /*  168831 */   // GIR_Coverage, 246,
     /*  168831 */   GIR_EraseRootFromParent_Done,
     /*  168832 */ // Label 3169: @168832
     /*  168832 */ GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(168886), // Rule ID 287 //
     /*  168837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168865 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168880 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168884 */   GIR_RootConstrainSelectedInstOperands,
     /*  168885 */   // GIR_Coverage, 287,
     /*  168885 */   GIR_EraseRootFromParent_Done,
     /*  168886 */ // Label 3170: @168886
     /*  168886 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(168943), // Rule ID 333 //
     /*  168891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168894 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168904 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168911 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168922 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10136>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168941 */   GIR_RootConstrainSelectedInstOperands,
     /*  168942 */   // GIR_Coverage, 333,
     /*  168942 */   GIR_EraseRootFromParent_Done,
     /*  168943 */ // Label 3171: @168943
     /*  168943 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169000), // Rule ID 335 //
     /*  168948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168961 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168979 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10138>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168998 */   GIR_RootConstrainSelectedInstOperands,
     /*  168999 */   // GIR_Coverage, 335,
     /*  168999 */   GIR_EraseRootFromParent_Done,
     /*  169000 */ // Label 3172: @169000
     /*  169000 */ GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169057), // Rule ID 349 //
     /*  169005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169008 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169011 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169018 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169036 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10150>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  169039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169055 */   GIR_RootConstrainSelectedInstOperands,
     /*  169056 */   // GIR_Coverage, 349,
     /*  169056 */   GIR_EraseRootFromParent_Done,
     /*  169057 */ // Label 3173: @169057
     /*  169057 */ GIM_Reject,
     /*  169058 */ // Label 3162: @169058
     /*  169058 */ GIM_Reject,
     /*  169059 */ // Label 24: @169059
     /*  169059 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3208*/ GIMT_Encode4(175958),
     /*  169070 */ /*GILLT_p0s32*//*Label 3174*/ GIMT_Encode4(169206),
     /*  169074 */ /*GILLT_p0s64*//*Label 3175*/ GIMT_Encode4(169300),
     /*  169078 */ /*GILLT_s16*//*Label 3176*/ GIMT_Encode4(169394),
     /*  169082 */ /*GILLT_s32*//*Label 3177*/ GIMT_Encode4(170033),
     /*  169086 */ /*GILLT_s64*//*Label 3178*/ GIMT_Encode4(171335),
     /*  169090 */ /*GILLT_nxv1s1*//*Label 3179*/ GIMT_Encode4(172412),
     /*  169094 */ /*GILLT_nxv1s8*//*Label 3180*/ GIMT_Encode4(172492),
     /*  169098 */ /*GILLT_nxv1s16*//*Label 3181*/ GIMT_Encode4(172580),
     /*  169102 */ /*GILLT_nxv1s32*//*Label 3182*/ GIMT_Encode4(172738),
     /*  169106 */ /*GILLT_nxv1s64*//*Label 3183*/ GIMT_Encode4(172896),
     /*  169110 */ /*GILLT_nxv2s1*//*Label 3184*/ GIMT_Encode4(173054),
     /*  169114 */ /*GILLT_nxv2s8*//*Label 3185*/ GIMT_Encode4(173134),
     /*  169118 */ /*GILLT_nxv2s16*//*Label 3186*/ GIMT_Encode4(173222),
     /*  169122 */ /*GILLT_nxv2s32*//*Label 3187*/ GIMT_Encode4(173380),
     /*  169126 */ /*GILLT_nxv2s64*//*Label 3188*/ GIMT_Encode4(173538),
     /*  169130 */ /*GILLT_nxv4s1*//*Label 3189*/ GIMT_Encode4(173696),
     /*  169134 */ /*GILLT_nxv4s8*//*Label 3190*/ GIMT_Encode4(173776),
     /*  169138 */ /*GILLT_nxv4s16*//*Label 3191*/ GIMT_Encode4(173864),
     /*  169142 */ /*GILLT_nxv4s32*//*Label 3192*/ GIMT_Encode4(174022),
     /*  169146 */ /*GILLT_nxv4s64*//*Label 3193*/ GIMT_Encode4(174180),
     /*  169150 */ /*GILLT_nxv8s1*//*Label 3194*/ GIMT_Encode4(174338),
     /*  169154 */ /*GILLT_nxv8s8*//*Label 3195*/ GIMT_Encode4(174418),
     /*  169158 */ /*GILLT_nxv8s16*//*Label 3196*/ GIMT_Encode4(174506),
     /*  169162 */ /*GILLT_nxv8s32*//*Label 3197*/ GIMT_Encode4(174664),
     /*  169166 */ /*GILLT_nxv8s64*//*Label 3198*/ GIMT_Encode4(174822),
     /*  169170 */ /*GILLT_nxv16s1*//*Label 3199*/ GIMT_Encode4(174980),
     /*  169174 */ /*GILLT_nxv16s8*//*Label 3200*/ GIMT_Encode4(175060),
     /*  169178 */ /*GILLT_nxv16s16*//*Label 3201*/ GIMT_Encode4(175148),
     /*  169182 */ /*GILLT_nxv16s32*//*Label 3202*/ GIMT_Encode4(175306),
     /*  169186 */ /*GILLT_nxv32s1*//*Label 3203*/ GIMT_Encode4(175464),
     /*  169190 */ /*GILLT_nxv32s8*//*Label 3204*/ GIMT_Encode4(175544),
     /*  169194 */ /*GILLT_nxv32s16*//*Label 3205*/ GIMT_Encode4(175632),
     /*  169198 */ /*GILLT_nxv64s1*//*Label 3206*/ GIMT_Encode4(175790),
     /*  169202 */ /*GILLT_nxv64s8*//*Label 3207*/ GIMT_Encode4(175870),
     /*  169206 */ // Label 3174: @169206
     /*  169206 */ GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(169299),
     /*  169211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169226 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(169262), // Rule ID 65423 //
     /*  169231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  169234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169241 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169244 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169260 */     GIR_RootConstrainSelectedInstOperands,
     /*  169261 */     // GIR_Coverage, 65423,
     /*  169261 */     GIR_EraseRootFromParent_Done,
     /*  169262 */   // Label 3210: @169262
     /*  169262 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(169298), // Rule ID 65427 //
     /*  169267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  169270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169277 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  169280 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169296 */     GIR_RootConstrainSelectedInstOperands,
     /*  169297 */     // GIR_Coverage, 65427,
     /*  169297 */     GIR_EraseRootFromParent_Done,
     /*  169298 */   // Label 3211: @169298
     /*  169298 */   GIM_Reject,
     /*  169299 */ // Label 3209: @169299
     /*  169299 */ GIM_Reject,
     /*  169300 */ // Label 3175: @169300
     /*  169300 */ GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(169393),
     /*  169305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169320 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(169356), // Rule ID 65422 //
     /*  169325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  169328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169335 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169338 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169354 */     GIR_RootConstrainSelectedInstOperands,
     /*  169355 */     // GIR_Coverage, 65422,
     /*  169355 */     GIR_EraseRootFromParent_Done,
     /*  169356 */   // Label 3213: @169356
     /*  169356 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(169392), // Rule ID 65426 //
     /*  169361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169371 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  169374 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169390 */     GIR_RootConstrainSelectedInstOperands,
     /*  169391 */     // GIR_Coverage, 65426,
     /*  169391 */     GIR_EraseRootFromParent_Done,
     /*  169392 */   // Label 3214: @169392
     /*  169392 */   GIM_Reject,
     /*  169393 */ // Label 3212: @169393
     /*  169393 */ GIM_Reject,
     /*  169394 */ // Label 3176: @169394
     /*  169394 */ GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(169448), // Rule ID 65440 //
     /*  169399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169402 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169427 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169430 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169446 */   GIR_RootConstrainSelectedInstOperands,
     /*  169447 */   // GIR_Coverage, 65440,
     /*  169447 */   GIR_EraseRootFromParent_Done,
     /*  169448 */ // Label 3215: @169448
     /*  169448 */ GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(169502), // Rule ID 65441 //
     /*  169453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169456 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169470 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169474 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169481 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169484 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169500 */   GIR_RootConstrainSelectedInstOperands,
     /*  169501 */   // GIR_Coverage, 65441,
     /*  169501 */   GIR_EraseRootFromParent_Done,
     /*  169502 */ // Label 3216: @169502
     /*  169502 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(169556), // Rule ID 65442 //
     /*  169507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169510 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169535 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169538 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169554 */   GIR_RootConstrainSelectedInstOperands,
     /*  169555 */   // GIR_Coverage, 65442,
     /*  169555 */   GIR_EraseRootFromParent_Done,
     /*  169556 */ // Label 3217: @169556
     /*  169556 */ GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(169610), // Rule ID 65443 //
     /*  169561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169564 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169567 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169589 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169592 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169608 */   GIR_RootConstrainSelectedInstOperands,
     /*  169609 */   // GIR_Coverage, 65443,
     /*  169609 */   GIR_EraseRootFromParent_Done,
     /*  169610 */ // Label 3218: @169610
     /*  169610 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(169661), // Rule ID 2152 //
     /*  169615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  169618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169621 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169640 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169643 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169659 */   GIR_RootConstrainSelectedInstOperands,
     /*  169660 */   // GIR_Coverage, 2152,
     /*  169660 */   GIR_EraseRootFromParent_Done,
     /*  169661 */ // Label 3219: @169661
     /*  169661 */ GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(169712), // Rule ID 2153 //
     /*  169666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  169669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169691 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169694 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169710 */   GIR_RootConstrainSelectedInstOperands,
     /*  169711 */   // GIR_Coverage, 2153,
     /*  169711 */   GIR_EraseRootFromParent_Done,
     /*  169712 */ // Label 3220: @169712
     /*  169712 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(169763), // Rule ID 2158 //
     /*  169717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  169720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169742 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169745 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169761 */   GIR_RootConstrainSelectedInstOperands,
     /*  169762 */   // GIR_Coverage, 2158,
     /*  169762 */   GIR_EraseRootFromParent_Done,
     /*  169763 */ // Label 3221: @169763
     /*  169763 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(169814), // Rule ID 2159 //
     /*  169768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  169771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169786 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169793 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169796 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169812 */   GIR_RootConstrainSelectedInstOperands,
     /*  169813 */   // GIR_Coverage, 2159,
     /*  169813 */   GIR_EraseRootFromParent_Done,
     /*  169814 */ // Label 3222: @169814
     /*  169814 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(169865), // Rule ID 65430 //
     /*  169819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169844 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169847 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169863 */   GIR_RootConstrainSelectedInstOperands,
     /*  169864 */   // GIR_Coverage, 65430,
     /*  169864 */   GIR_EraseRootFromParent_Done,
     /*  169865 */ // Label 3223: @169865
     /*  169865 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(169916), // Rule ID 65431 //
     /*  169870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169895 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169898 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169914 */   GIR_RootConstrainSelectedInstOperands,
     /*  169915 */   // GIR_Coverage, 65431,
     /*  169915 */   GIR_EraseRootFromParent_Done,
     /*  169916 */ // Label 3224: @169916
     /*  169916 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(169974), // Rule ID 65434 //
     /*  169921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169927 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169931 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169953 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169956 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169972 */   GIR_RootConstrainSelectedInstOperands,
     /*  169973 */   // GIR_Coverage, 65434,
     /*  169973 */   GIR_EraseRootFromParent_Done,
     /*  169974 */ // Label 3225: @169974
     /*  169974 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(170032), // Rule ID 65435 //
     /*  169979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169985 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170011 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170014 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170030 */   GIR_RootConstrainSelectedInstOperands,
     /*  170031 */   // GIR_Coverage, 65435,
     /*  170031 */   GIR_EraseRootFromParent_Done,
     /*  170032 */ // Label 3226: @170032
     /*  170032 */ GIM_Reject,
     /*  170033 */ // Label 3177: @170033
     /*  170033 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(170090), // Rule ID 338 //
     /*  170038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170041 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170051 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170069 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10140>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170072 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170088 */   GIR_RootConstrainSelectedInstOperands,
     /*  170089 */   // GIR_Coverage, 338,
     /*  170089 */   GIR_EraseRootFromParent_Done,
     /*  170090 */ // Label 3227: @170090
     /*  170090 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(170147), // Rule ID 340 //
     /*  170095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170108 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170119 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170126 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10142>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170129 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170145 */   GIR_RootConstrainSelectedInstOperands,
     /*  170146 */   // GIR_Coverage, 340,
     /*  170146 */   GIR_EraseRootFromParent_Done,
     /*  170147 */ // Label 3228: @170147
     /*  170147 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(170204), // Rule ID 342 //
     /*  170152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170165 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170183 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10144>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170186 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170202 */   GIR_RootConstrainSelectedInstOperands,
     /*  170203 */   // GIR_Coverage, 342,
     /*  170203 */   GIR_EraseRootFromParent_Done,
     /*  170204 */ // Label 3229: @170204
     /*  170204 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(170258), // Rule ID 65446 //
     /*  170209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  170212 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170237 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170240 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170256 */   GIR_RootConstrainSelectedInstOperands,
     /*  170257 */   // GIR_Coverage, 65446,
     /*  170257 */   GIR_EraseRootFromParent_Done,
     /*  170258 */ // Label 3230: @170258
     /*  170258 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(170312), // Rule ID 65447 //
     /*  170263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  170266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170269 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170291 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170294 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170310 */   GIR_RootConstrainSelectedInstOperands,
     /*  170311 */   // GIR_Coverage, 65447,
     /*  170311 */   GIR_EraseRootFromParent_Done,
     /*  170312 */ // Label 3231: @170312
     /*  170312 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(170370), // Rule ID 249 //
     /*  170317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170323 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170349 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170352 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170368 */   GIR_RootConstrainSelectedInstOperands,
     /*  170369 */   // GIR_Coverage, 249,
     /*  170369 */   GIR_EraseRootFromParent_Done,
     /*  170370 */ // Label 3232: @170370
     /*  170370 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(170428), // Rule ID 251 //
     /*  170375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170381 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170407 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170410 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170426 */   GIR_RootConstrainSelectedInstOperands,
     /*  170427 */   // GIR_Coverage, 251,
     /*  170427 */   GIR_EraseRootFromParent_Done,
     /*  170428 */ // Label 3233: @170428
     /*  170428 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(170479), // Rule ID 252 //
     /*  170433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170458 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170461 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170477 */   GIR_RootConstrainSelectedInstOperands,
     /*  170478 */   // GIR_Coverage, 252,
     /*  170478 */   GIR_EraseRootFromParent_Done,
     /*  170479 */ // Label 3234: @170479
     /*  170479 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(170530), // Rule ID 253 //
     /*  170484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170487 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170509 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170512 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170528 */   GIR_RootConstrainSelectedInstOperands,
     /*  170529 */   // GIR_Coverage, 253,
     /*  170529 */   GIR_EraseRootFromParent_Done,
     /*  170530 */ // Label 3235: @170530
     /*  170530 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(170581), // Rule ID 1439 //
     /*  170535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  170538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170560 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170563 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170579 */   GIR_RootConstrainSelectedInstOperands,
     /*  170580 */   // GIR_Coverage, 1439,
     /*  170580 */   GIR_EraseRootFromParent_Done,
     /*  170581 */ // Label 3236: @170581
     /*  170581 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(170632), // Rule ID 1440 //
     /*  170586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  170589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170611 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170614 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170630 */   GIR_RootConstrainSelectedInstOperands,
     /*  170631 */   // GIR_Coverage, 1440,
     /*  170631 */   GIR_EraseRootFromParent_Done,
     /*  170632 */ // Label 3237: @170632
     /*  170632 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(170683), // Rule ID 1445 //
     /*  170637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  170640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170662 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170665 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170681 */   GIR_RootConstrainSelectedInstOperands,
     /*  170682 */   // GIR_Coverage, 1445,
     /*  170682 */   GIR_EraseRootFromParent_Done,
     /*  170683 */ // Label 3238: @170683
     /*  170683 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(170734), // Rule ID 1446 //
     /*  170688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  170691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170713 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170716 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170732 */   GIR_RootConstrainSelectedInstOperands,
     /*  170733 */   // GIR_Coverage, 1446,
     /*  170733 */   GIR_EraseRootFromParent_Done,
     /*  170734 */ // Label 3239: @170734
     /*  170734 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(170792), // Rule ID 65452 //
     /*  170739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170742 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170745 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170771 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170774 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170790 */   GIR_RootConstrainSelectedInstOperands,
     /*  170791 */   // GIR_Coverage, 65452,
     /*  170791 */   GIR_EraseRootFromParent_Done,
     /*  170792 */ // Label 3240: @170792
     /*  170792 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(170850), // Rule ID 65453 //
     /*  170797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170803 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170822 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170829 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170832 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170848 */   GIR_RootConstrainSelectedInstOperands,
     /*  170849 */   // GIR_Coverage, 65453,
     /*  170849 */   GIR_EraseRootFromParent_Done,
     /*  170850 */ // Label 3241: @170850
     /*  170850 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(170908), // Rule ID 65454 //
     /*  170855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170861 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170887 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170890 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170906 */   GIR_RootConstrainSelectedInstOperands,
     /*  170907 */   // GIR_Coverage, 65454,
     /*  170907 */   GIR_EraseRootFromParent_Done,
     /*  170908 */ // Label 3242: @170908
     /*  170908 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(170966), // Rule ID 65455 //
     /*  170913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170919 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170945 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170948 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170964 */   GIR_RootConstrainSelectedInstOperands,
     /*  170965 */   // GIR_Coverage, 65455,
     /*  170965 */   GIR_EraseRootFromParent_Done,
     /*  170966 */ // Label 3243: @170966
     /*  170966 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(171012), // Rule ID 1118 //
     /*  170971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170974 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170991 */   // MIs[0] rs1
     /*  170991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170999 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10644>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171002 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171004 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171010 */   GIR_RootConstrainSelectedInstOperands,
     /*  171011 */   // GIR_Coverage, 1118,
     /*  171011 */   GIR_EraseRootFromParent_Done,
     /*  171012 */ // Label 3244: @171012
     /*  171012 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(171058), // Rule ID 1120 //
     /*  171017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171037 */   // MIs[0] rs1
     /*  171037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171045 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10646>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171050 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171056 */   GIR_RootConstrainSelectedInstOperands,
     /*  171057 */   // GIR_Coverage, 1120,
     /*  171057 */   GIR_EraseRootFromParent_Done,
     /*  171058 */ // Label 3245: @171058
     /*  171058 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(171104), // Rule ID 1122 //
     /*  171063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171066 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171083 */   // MIs[0] rs1
     /*  171083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171091 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10648>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171094 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171096 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171102 */   GIR_RootConstrainSelectedInstOperands,
     /*  171103 */   // GIR_Coverage, 1122,
     /*  171103 */   GIR_EraseRootFromParent_Done,
     /*  171104 */ // Label 3246: @171104
     /*  171104 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(171150), // Rule ID 1124 //
     /*  171109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171112 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171115 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171129 */   // MIs[0] rs1
     /*  171129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171137 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10650>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171142 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171148 */   GIR_RootConstrainSelectedInstOperands,
     /*  171149 */   // GIR_Coverage, 1124,
     /*  171149 */   GIR_EraseRootFromParent_Done,
     /*  171150 */ // Label 3247: @171150
     /*  171150 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(171196), // Rule ID 1126 //
     /*  171155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171158 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171175 */   // MIs[0] rs1
     /*  171175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171183 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10652>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171188 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171194 */   GIR_RootConstrainSelectedInstOperands,
     /*  171195 */   // GIR_Coverage, 1126,
     /*  171195 */   GIR_EraseRootFromParent_Done,
     /*  171196 */ // Label 3248: @171196
     /*  171196 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(171242), // Rule ID 1128 //
     /*  171201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  171204 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171207 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171221 */   // MIs[0] rs1
     /*  171221 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171229 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10654>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171232 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171234 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171240 */   GIR_RootConstrainSelectedInstOperands,
     /*  171241 */   // GIR_Coverage, 1128,
     /*  171241 */   GIR_EraseRootFromParent_Done,
     /*  171242 */ // Label 3249: @171242
     /*  171242 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(171288), // Rule ID 1146 //
     /*  171247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  171250 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171253 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171260 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171267 */   // MIs[0] rs1
     /*  171267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171275 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10668>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171280 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171286 */   GIR_RootConstrainSelectedInstOperands,
     /*  171287 */   // GIR_Coverage, 1146,
     /*  171287 */   GIR_EraseRootFromParent_Done,
     /*  171288 */ // Label 3250: @171288
     /*  171288 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(171334), // Rule ID 1148 //
     /*  171293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  171296 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171313 */   // MIs[0] rs1
     /*  171313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171321 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10670>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  171321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171324 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171326 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171332 */   GIR_RootConstrainSelectedInstOperands,
     /*  171333 */   // GIR_Coverage, 1148,
     /*  171333 */   GIR_EraseRootFromParent_Done,
     /*  171334 */ // Label 3251: @171334
     /*  171334 */ GIM_Reject,
     /*  171335 */ // Label 3178: @171335
     /*  171335 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(171392), // Rule ID 337 //
     /*  171340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171353 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171371 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10140>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171374 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171390 */   GIR_RootConstrainSelectedInstOperands,
     /*  171391 */   // GIR_Coverage, 337,
     /*  171391 */   GIR_EraseRootFromParent_Done,
     /*  171392 */ // Label 3252: @171392
     /*  171392 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(171449), // Rule ID 339 //
     /*  171397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171400 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171410 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171428 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10142>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171431 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171447 */   GIR_RootConstrainSelectedInstOperands,
     /*  171448 */   // GIR_Coverage, 339,
     /*  171448 */   GIR_EraseRootFromParent_Done,
     /*  171449 */ // Label 3253: @171449
     /*  171449 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(171506), // Rule ID 341 //
     /*  171454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171467 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171485 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10144>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171488 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171504 */   GIR_RootConstrainSelectedInstOperands,
     /*  171505 */   // GIR_Coverage, 341,
     /*  171505 */   GIR_EraseRootFromParent_Done,
     /*  171506 */ // Label 3254: @171506
     /*  171506 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(171563), // Rule ID 352 //
     /*  171511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171514 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171517 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171524 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171542 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10154>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171545 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171561 */   GIR_RootConstrainSelectedInstOperands,
     /*  171562 */   // GIR_Coverage, 352,
     /*  171562 */   GIR_EraseRootFromParent_Done,
     /*  171563 */ // Label 3255: @171563
     /*  171563 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(171621), // Rule ID 248 //
     /*  171568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171574 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171600 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171603 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171615 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171619 */   GIR_RootConstrainSelectedInstOperands,
     /*  171620 */   // GIR_Coverage, 248,
     /*  171620 */   GIR_EraseRootFromParent_Done,
     /*  171621 */ // Label 3256: @171621
     /*  171621 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(171679), // Rule ID 250 //
     /*  171626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171632 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171658 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171661 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171677 */   GIR_RootConstrainSelectedInstOperands,
     /*  171678 */   // GIR_Coverage, 250,
     /*  171678 */   GIR_EraseRootFromParent_Done,
     /*  171679 */ // Label 3257: @171679
     /*  171679 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(171737), // Rule ID 289 //
     /*  171684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171690 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171705 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171709 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171716 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171719 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171731 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171735 */   GIR_RootConstrainSelectedInstOperands,
     /*  171736 */   // GIR_Coverage, 289,
     /*  171736 */   GIR_EraseRootFromParent_Done,
     /*  171737 */ // Label 3258: @171737
     /*  171737 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(171788), // Rule ID 290 //
     /*  171742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171760 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171767 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171770 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171786 */   GIR_RootConstrainSelectedInstOperands,
     /*  171787 */   // GIR_Coverage, 290,
     /*  171787 */   GIR_EraseRootFromParent_Done,
     /*  171788 */ // Label 3259: @171788
     /*  171788 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(171839), // Rule ID 1837 //
     /*  171793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  171796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171818 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171821 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171837 */   GIR_RootConstrainSelectedInstOperands,
     /*  171838 */   // GIR_Coverage, 1837,
     /*  171838 */   GIR_EraseRootFromParent_Done,
     /*  171839 */ // Label 3260: @171839
     /*  171839 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(171890), // Rule ID 1838 //
     /*  171844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  171847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171869 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171872 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171888 */   GIR_RootConstrainSelectedInstOperands,
     /*  171889 */   // GIR_Coverage, 1838,
     /*  171889 */   GIR_EraseRootFromParent_Done,
     /*  171890 */ // Label 3261: @171890
     /*  171890 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(171941), // Rule ID 1841 //
     /*  171895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  171898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171920 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171923 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171939 */   GIR_RootConstrainSelectedInstOperands,
     /*  171940 */   // GIR_Coverage, 1841,
     /*  171940 */   GIR_EraseRootFromParent_Done,
     /*  171941 */ // Label 3262: @171941
     /*  171941 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(171992), // Rule ID 1846 //
     /*  171946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  171949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171971 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171974 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171990 */   GIR_RootConstrainSelectedInstOperands,
     /*  171991 */   // GIR_Coverage, 1846,
     /*  171991 */   GIR_EraseRootFromParent_Done,
     /*  171992 */ // Label 3263: @171992
     /*  171992 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(172043), // Rule ID 1847 //
     /*  171997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  172000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172003 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  172011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172022 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  172022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  172025 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172041 */   GIR_RootConstrainSelectedInstOperands,
     /*  172042 */   // GIR_Coverage, 1847,
     /*  172042 */   GIR_EraseRootFromParent_Done,
     /*  172043 */ // Label 3264: @172043
     /*  172043 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(172089), // Rule ID 1117 //
     /*  172048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172051 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172068 */   // MIs[0] rs1
     /*  172068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172076 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10644>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  172079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172081 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172087 */   GIR_RootConstrainSelectedInstOperands,
     /*  172088 */   // GIR_Coverage, 1117,
     /*  172088 */   GIR_EraseRootFromParent_Done,
     /*  172089 */ // Label 3265: @172089
     /*  172089 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(172135), // Rule ID 1119 //
     /*  172094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172114 */   // MIs[0] rs1
     /*  172114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172122 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10646>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  172125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172127 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172133 */   GIR_RootConstrainSelectedInstOperands,
     /*  172134 */   // GIR_Coverage, 1119,
     /*  172134 */   GIR_EraseRootFromParent_Done,
     /*  172135 */ // Label 3266: @172135
     /*  172135 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(172181), // Rule ID 1121 //
     /*  172140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172143 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172160 */   // MIs[0] rs1
     /*  172160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172168 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10648>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  172171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172173 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172179 */   GIR_RootConstrainSelectedInstOperands,
     /*  172180 */   // GIR_Coverage, 1121,
     /*  172180 */   GIR_EraseRootFromParent_Done,
     /*  172181 */ // Label 3267: @172181
     /*  172181 */ GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(172227), // Rule ID 1123 //
     /*  172186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172189 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172192 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172206 */   // MIs[0] rs1
     /*  172206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172214 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10650>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  172217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172219 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172221 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172225 */   GIR_RootConstrainSelectedInstOperands,
     /*  172226 */   // GIR_Coverage, 1123,
     /*  172226 */   GIR_EraseRootFromParent_Done,
     /*  172227 */ // Label 3268: @172227
     /*  172227 */ GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(172273), // Rule ID 1125 //
     /*  172232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  172245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172252 */   // MIs[0] rs1
     /*  172252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172260 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10652>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  172263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172265 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172271 */   GIR_RootConstrainSelectedInstOperands,
     /*  172272 */   // GIR_Coverage, 1125,
     /*  172272 */   GIR_EraseRootFromParent_Done,
     /*  172273 */ // Label 3269: @172273
     /*  172273 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(172319), // Rule ID 1127 //
     /*  172278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  172281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  172291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172298 */   // MIs[0] rs1
     /*  172298 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172306 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10654>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  172309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172311 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172317 */   GIR_RootConstrainSelectedInstOperands,
     /*  172318 */   // GIR_Coverage, 1127,
     /*  172318 */   GIR_EraseRootFromParent_Done,
     /*  172319 */ // Label 3270: @172319
     /*  172319 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(172365), // Rule ID 1145 //
     /*  172324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  172327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172330 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  172337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  172340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172344 */   // MIs[0] rs1
     /*  172344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172352 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10668>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  172355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172357 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172363 */   GIR_RootConstrainSelectedInstOperands,
     /*  172364 */   // GIR_Coverage, 1145,
     /*  172364 */   GIR_EraseRootFromParent_Done,
     /*  172365 */ // Label 3271: @172365
     /*  172365 */ GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(172411), // Rule ID 1147 //
     /*  172370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  172373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  172376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  172383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  172386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172390 */   // MIs[0] rs1
     /*  172390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172398 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10670>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  172398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  172401 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172403 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172409 */   GIR_RootConstrainSelectedInstOperands,
     /*  172410 */   // GIR_Coverage, 1147,
     /*  172410 */   GIR_EraseRootFromParent_Done,
     /*  172411 */ // Label 3272: @172411
     /*  172411 */ GIM_Reject,
     /*  172412 */ // Label 3179: @172412
     /*  172412 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(172491),
     /*  172417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172436 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(172463), // Rule ID 45748 //
     /*  172441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172444 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172447 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172461 */     GIR_RootConstrainSelectedInstOperands,
     /*  172462 */     // GIR_Coverage, 45748,
     /*  172462 */     GIR_EraseRootFromParent_Done,
     /*  172463 */   // Label 3274: @172463
     /*  172463 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(172490), // Rule ID 45749 //
     /*  172468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172471 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172474 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172488 */     GIR_RootConstrainSelectedInstOperands,
     /*  172489 */     // GIR_Coverage, 45749,
     /*  172489 */     GIR_EraseRootFromParent_Done,
     /*  172490 */   // Label 3275: @172490
     /*  172490 */   GIM_Reject,
     /*  172491 */ // Label 3273: @172491
     /*  172491 */ GIM_Reject,
     /*  172492 */ // Label 3180: @172492
     /*  172492 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(172579),
     /*  172497 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172500 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172508 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(172543), // Rule ID 45744 //
     /*  172513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172516 */     // MIs[0] rs1
     /*  172516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172524 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172527 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172541 */     GIR_RootConstrainSelectedInstOperands,
     /*  172542 */     // GIR_Coverage, 45744,
     /*  172542 */     GIR_EraseRootFromParent_Done,
     /*  172543 */   // Label 3277: @172543
     /*  172543 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(172578), // Rule ID 45745 //
     /*  172548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172551 */     // MIs[0] rs1
     /*  172551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172559 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172562 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172576 */     GIR_RootConstrainSelectedInstOperands,
     /*  172577 */     // GIR_Coverage, 45745,
     /*  172577 */     GIR_EraseRootFromParent_Done,
     /*  172578 */   // Label 3278: @172578
     /*  172578 */   GIM_Reject,
     /*  172579 */ // Label 3276: @172579
     /*  172579 */ GIM_Reject,
     /*  172580 */ // Label 3181: @172580
     /*  172580 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(172737),
     /*  172585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172596 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(172631), // Rule ID 45940 //
     /*  172601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172604 */     // MIs[0] rs1
     /*  172604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172612 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172615 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172629 */     GIR_RootConstrainSelectedInstOperands,
     /*  172630 */     // GIR_Coverage, 45940,
     /*  172630 */     GIR_EraseRootFromParent_Done,
     /*  172631 */   // Label 3280: @172631
     /*  172631 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(172666), // Rule ID 45941 //
     /*  172636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172639 */     // MIs[0] rs1
     /*  172639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172647 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172650 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172664 */     GIR_RootConstrainSelectedInstOperands,
     /*  172665 */     // GIR_Coverage, 45941,
     /*  172665 */     GIR_EraseRootFromParent_Done,
     /*  172666 */   // Label 3281: @172666
     /*  172666 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(172701), // Rule ID 46016 //
     /*  172671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172674 */     // MIs[0] rs1
     /*  172674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172682 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172685 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172699 */     GIR_RootConstrainSelectedInstOperands,
     /*  172700 */     // GIR_Coverage, 46016,
     /*  172700 */     GIR_EraseRootFromParent_Done,
     /*  172701 */   // Label 3282: @172701
     /*  172701 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(172736), // Rule ID 46017 //
     /*  172706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172709 */     // MIs[0] rs1
     /*  172709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172717 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172720 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172734 */     GIR_RootConstrainSelectedInstOperands,
     /*  172735 */     // GIR_Coverage, 46017,
     /*  172735 */     GIR_EraseRootFromParent_Done,
     /*  172736 */   // Label 3283: @172736
     /*  172736 */   GIM_Reject,
     /*  172737 */ // Label 3279: @172737
     /*  172737 */ GIM_Reject,
     /*  172738 */ // Label 3182: @172738
     /*  172738 */ GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(172895),
     /*  172743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172754 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(172789), // Rule ID 45948 //
     /*  172759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172762 */     // MIs[0] rs1
     /*  172762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172770 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172773 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172787 */     GIR_RootConstrainSelectedInstOperands,
     /*  172788 */     // GIR_Coverage, 45948,
     /*  172788 */     GIR_EraseRootFromParent_Done,
     /*  172789 */   // Label 3285: @172789
     /*  172789 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(172824), // Rule ID 45949 //
     /*  172794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172797 */     // MIs[0] rs1
     /*  172797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172805 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172808 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172822 */     GIR_RootConstrainSelectedInstOperands,
     /*  172823 */     // GIR_Coverage, 45949,
     /*  172823 */     GIR_EraseRootFromParent_Done,
     /*  172824 */   // Label 3286: @172824
     /*  172824 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(172859), // Rule ID 46024 //
     /*  172829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  172832 */     // MIs[0] rs1
     /*  172832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172840 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172843 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172857 */     GIR_RootConstrainSelectedInstOperands,
     /*  172858 */     // GIR_Coverage, 46024,
     /*  172858 */     GIR_EraseRootFromParent_Done,
     /*  172859 */   // Label 3287: @172859
     /*  172859 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(172894), // Rule ID 46025 //
     /*  172864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  172867 */     // MIs[0] rs1
     /*  172867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172875 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172878 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172892 */     GIR_RootConstrainSelectedInstOperands,
     /*  172893 */     // GIR_Coverage, 46025,
     /*  172893 */     GIR_EraseRootFromParent_Done,
     /*  172894 */   // Label 3288: @172894
     /*  172894 */   GIM_Reject,
     /*  172895 */ // Label 3284: @172895
     /*  172895 */ GIM_Reject,
     /*  172896 */ // Label 3183: @172896
     /*  172896 */ GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(173053),
     /*  172901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172912 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(172947), // Rule ID 45964 //
     /*  172917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172920 */     // MIs[0] rs1
     /*  172920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172928 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172931 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172945 */     GIR_RootConstrainSelectedInstOperands,
     /*  172946 */     // GIR_Coverage, 45964,
     /*  172946 */     GIR_EraseRootFromParent_Done,
     /*  172947 */   // Label 3290: @172947
     /*  172947 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(172982), // Rule ID 45965 //
     /*  172952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172955 */     // MIs[0] rs1
     /*  172955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172963 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172966 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172980 */     GIR_RootConstrainSelectedInstOperands,
     /*  172981 */     // GIR_Coverage, 45965,
     /*  172981 */     GIR_EraseRootFromParent_Done,
     /*  172982 */   // Label 3291: @172982
     /*  172982 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(173017), // Rule ID 46036 //
     /*  172987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172990 */     // MIs[0] rs1
     /*  172990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172998 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  173001 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173015 */     GIR_RootConstrainSelectedInstOperands,
     /*  173016 */     // GIR_Coverage, 46036,
     /*  173016 */     GIR_EraseRootFromParent_Done,
     /*  173017 */   // Label 3292: @173017
     /*  173017 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(173052), // Rule ID 46037 //
     /*  173022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173025 */     // MIs[0] rs1
     /*  173025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173033 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  173036 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173050 */     GIR_RootConstrainSelectedInstOperands,
     /*  173051 */     // GIR_Coverage, 46037,
     /*  173051 */     GIR_EraseRootFromParent_Done,
     /*  173052 */   // Label 3293: @173052
     /*  173052 */   GIM_Reject,
     /*  173053 */ // Label 3289: @173053
     /*  173053 */ GIM_Reject,
     /*  173054 */ // Label 3184: @173054
     /*  173054 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(173133),
     /*  173059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173078 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(173105), // Rule ID 46076 //
     /*  173083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173086 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  173089 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173103 */     GIR_RootConstrainSelectedInstOperands,
     /*  173104 */     // GIR_Coverage, 46076,
     /*  173104 */     GIR_EraseRootFromParent_Done,
     /*  173105 */   // Label 3295: @173105
     /*  173105 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(173132), // Rule ID 46077 //
     /*  173110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173113 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  173116 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173130 */     GIR_RootConstrainSelectedInstOperands,
     /*  173131 */     // GIR_Coverage, 46077,
     /*  173131 */     GIR_EraseRootFromParent_Done,
     /*  173132 */   // Label 3296: @173132
     /*  173132 */   GIM_Reject,
     /*  173133 */ // Label 3294: @173133
     /*  173133 */ GIM_Reject,
     /*  173134 */ // Label 3185: @173134
     /*  173134 */ GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(173221),
     /*  173139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173150 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(173185), // Rule ID 45932 //
     /*  173155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173158 */     // MIs[0] rs1
     /*  173158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173166 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  173169 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173183 */     GIR_RootConstrainSelectedInstOperands,
     /*  173184 */     // GIR_Coverage, 45932,
     /*  173184 */     GIR_EraseRootFromParent_Done,
     /*  173185 */   // Label 3298: @173185
     /*  173185 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(173220), // Rule ID 45933 //
     /*  173190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173193 */     // MIs[0] rs1
     /*  173193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173201 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  173204 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173218 */     GIR_RootConstrainSelectedInstOperands,
     /*  173219 */     // GIR_Coverage, 45933,
     /*  173219 */     GIR_EraseRootFromParent_Done,
     /*  173220 */   // Label 3299: @173220
     /*  173220 */   GIM_Reject,
     /*  173221 */ // Label 3297: @173221
     /*  173221 */ GIM_Reject,
     /*  173222 */ // Label 3186: @173222
     /*  173222 */ GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(173379),
     /*  173227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173238 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(173273), // Rule ID 45944 //
     /*  173243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173246 */     // MIs[0] rs1
     /*  173246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173254 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173257 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173271 */     GIR_RootConstrainSelectedInstOperands,
     /*  173272 */     // GIR_Coverage, 45944,
     /*  173272 */     GIR_EraseRootFromParent_Done,
     /*  173273 */   // Label 3301: @173273
     /*  173273 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(173308), // Rule ID 45945 //
     /*  173278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173281 */     // MIs[0] rs1
     /*  173281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173289 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173292 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173306 */     GIR_RootConstrainSelectedInstOperands,
     /*  173307 */     // GIR_Coverage, 45945,
     /*  173307 */     GIR_EraseRootFromParent_Done,
     /*  173308 */   // Label 3302: @173308
     /*  173308 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(173343), // Rule ID 46020 //
     /*  173313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173316 */     // MIs[0] rs1
     /*  173316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173324 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173327 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173341 */     GIR_RootConstrainSelectedInstOperands,
     /*  173342 */     // GIR_Coverage, 46020,
     /*  173342 */     GIR_EraseRootFromParent_Done,
     /*  173343 */   // Label 3303: @173343
     /*  173343 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(173378), // Rule ID 46021 //
     /*  173348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173351 */     // MIs[0] rs1
     /*  173351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173359 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  173362 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173376 */     GIR_RootConstrainSelectedInstOperands,
     /*  173377 */     // GIR_Coverage, 46021,
     /*  173377 */     GIR_EraseRootFromParent_Done,
     /*  173378 */   // Label 3304: @173378
     /*  173378 */   GIM_Reject,
     /*  173379 */ // Label 3300: @173379
     /*  173379 */ GIM_Reject,
     /*  173380 */ // Label 3187: @173380
     /*  173380 */ GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(173537),
     /*  173385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173396 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(173431), // Rule ID 45960 //
     /*  173401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173404 */     // MIs[0] rs1
     /*  173404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173412 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173415 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173429 */     GIR_RootConstrainSelectedInstOperands,
     /*  173430 */     // GIR_Coverage, 45960,
     /*  173430 */     GIR_EraseRootFromParent_Done,
     /*  173431 */   // Label 3306: @173431
     /*  173431 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(173466), // Rule ID 45961 //
     /*  173436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173439 */     // MIs[0] rs1
     /*  173439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173447 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173450 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173464 */     GIR_RootConstrainSelectedInstOperands,
     /*  173465 */     // GIR_Coverage, 45961,
     /*  173465 */     GIR_EraseRootFromParent_Done,
     /*  173466 */   // Label 3307: @173466
     /*  173466 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(173501), // Rule ID 46032 //
     /*  173471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173474 */     // MIs[0] rs1
     /*  173474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173482 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173485 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173499 */     GIR_RootConstrainSelectedInstOperands,
     /*  173500 */     // GIR_Coverage, 46032,
     /*  173500 */     GIR_EraseRootFromParent_Done,
     /*  173501 */   // Label 3308: @173501
     /*  173501 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(173536), // Rule ID 46033 //
     /*  173506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173509 */     // MIs[0] rs1
     /*  173509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173517 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173520 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173534 */     GIR_RootConstrainSelectedInstOperands,
     /*  173535 */     // GIR_Coverage, 46033,
     /*  173535 */     GIR_EraseRootFromParent_Done,
     /*  173536 */   // Label 3309: @173536
     /*  173536 */   GIM_Reject,
     /*  173537 */ // Label 3305: @173537
     /*  173537 */ GIM_Reject,
     /*  173538 */ // Label 3188: @173538
     /*  173538 */ GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(173695),
     /*  173543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173554 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(173589), // Rule ID 46004 //
     /*  173559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173562 */     // MIs[0] rs1
     /*  173562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173570 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173573 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173587 */     GIR_RootConstrainSelectedInstOperands,
     /*  173588 */     // GIR_Coverage, 46004,
     /*  173588 */     GIR_EraseRootFromParent_Done,
     /*  173589 */   // Label 3311: @173589
     /*  173589 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(173624), // Rule ID 46005 //
     /*  173594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173597 */     // MIs[0] rs1
     /*  173597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173605 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173608 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173622 */     GIR_RootConstrainSelectedInstOperands,
     /*  173623 */     // GIR_Coverage, 46005,
     /*  173623 */     GIR_EraseRootFromParent_Done,
     /*  173624 */   // Label 3312: @173624
     /*  173624 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(173659), // Rule ID 46064 //
     /*  173629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173632 */     // MIs[0] rs1
     /*  173632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173640 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173643 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173657 */     GIR_RootConstrainSelectedInstOperands,
     /*  173658 */     // GIR_Coverage, 46064,
     /*  173658 */     GIR_EraseRootFromParent_Done,
     /*  173659 */   // Label 3313: @173659
     /*  173659 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(173694), // Rule ID 46065 //
     /*  173664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173667 */     // MIs[0] rs1
     /*  173667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173675 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173678 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173692 */     GIR_RootConstrainSelectedInstOperands,
     /*  173693 */     // GIR_Coverage, 46065,
     /*  173693 */     GIR_EraseRootFromParent_Done,
     /*  173694 */   // Label 3314: @173694
     /*  173694 */   GIM_Reject,
     /*  173695 */ // Label 3310: @173695
     /*  173695 */ GIM_Reject,
     /*  173696 */ // Label 3189: @173696
     /*  173696 */ GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(173775),
     /*  173701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173720 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(173747), // Rule ID 46080 //
     /*  173725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173728 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173731 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173745 */     GIR_RootConstrainSelectedInstOperands,
     /*  173746 */     // GIR_Coverage, 46080,
     /*  173746 */     GIR_EraseRootFromParent_Done,
     /*  173747 */   // Label 3316: @173747
     /*  173747 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(173774), // Rule ID 46081 //
     /*  173752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173755 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173758 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173772 */     GIR_RootConstrainSelectedInstOperands,
     /*  173773 */     // GIR_Coverage, 46081,
     /*  173773 */     GIR_EraseRootFromParent_Done,
     /*  173774 */   // Label 3317: @173774
     /*  173774 */   GIM_Reject,
     /*  173775 */ // Label 3315: @173775
     /*  173775 */ GIM_Reject,
     /*  173776 */ // Label 3190: @173776
     /*  173776 */ GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(173863),
     /*  173781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173792 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(173827), // Rule ID 45936 //
     /*  173797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173800 */     // MIs[0] rs1
     /*  173800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173808 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173811 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173825 */     GIR_RootConstrainSelectedInstOperands,
     /*  173826 */     // GIR_Coverage, 45936,
     /*  173826 */     GIR_EraseRootFromParent_Done,
     /*  173827 */   // Label 3319: @173827
     /*  173827 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(173862), // Rule ID 45937 //
     /*  173832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173835 */     // MIs[0] rs1
     /*  173835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173843 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173846 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173860 */     GIR_RootConstrainSelectedInstOperands,
     /*  173861 */     // GIR_Coverage, 45937,
     /*  173861 */     GIR_EraseRootFromParent_Done,
     /*  173862 */   // Label 3320: @173862
     /*  173862 */   GIM_Reject,
     /*  173863 */ // Label 3318: @173863
     /*  173863 */ GIM_Reject,
     /*  173864 */ // Label 3191: @173864
     /*  173864 */ GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(174021),
     /*  173869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173880 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(173915), // Rule ID 45956 //
     /*  173885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173888 */     // MIs[0] rs1
     /*  173888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173896 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173899 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173913 */     GIR_RootConstrainSelectedInstOperands,
     /*  173914 */     // GIR_Coverage, 45956,
     /*  173914 */     GIR_EraseRootFromParent_Done,
     /*  173915 */   // Label 3322: @173915
     /*  173915 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(173950), // Rule ID 45957 //
     /*  173920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173923 */     // MIs[0] rs1
     /*  173923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173931 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173934 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173948 */     GIR_RootConstrainSelectedInstOperands,
     /*  173949 */     // GIR_Coverage, 45957,
     /*  173949 */     GIR_EraseRootFromParent_Done,
     /*  173950 */   // Label 3323: @173950
     /*  173950 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(173985), // Rule ID 46028 //
     /*  173955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173958 */     // MIs[0] rs1
     /*  173958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173966 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173969 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173983 */     GIR_RootConstrainSelectedInstOperands,
     /*  173984 */     // GIR_Coverage, 46028,
     /*  173984 */     GIR_EraseRootFromParent_Done,
     /*  173985 */   // Label 3324: @173985
     /*  173985 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(174020), // Rule ID 46029 //
     /*  173990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173993 */     // MIs[0] rs1
     /*  173993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174001 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  174004 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174018 */     GIR_RootConstrainSelectedInstOperands,
     /*  174019 */     // GIR_Coverage, 46029,
     /*  174019 */     GIR_EraseRootFromParent_Done,
     /*  174020 */   // Label 3325: @174020
     /*  174020 */   GIM_Reject,
     /*  174021 */ // Label 3321: @174021
     /*  174021 */ GIM_Reject,
     /*  174022 */ // Label 3192: @174022
     /*  174022 */ GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(174179),
     /*  174027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174038 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(174073), // Rule ID 45992 //
     /*  174043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174046 */     // MIs[0] rs1
     /*  174046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174054 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174057 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174071 */     GIR_RootConstrainSelectedInstOperands,
     /*  174072 */     // GIR_Coverage, 45992,
     /*  174072 */     GIR_EraseRootFromParent_Done,
     /*  174073 */   // Label 3327: @174073
     /*  174073 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(174108), // Rule ID 45993 //
     /*  174078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174081 */     // MIs[0] rs1
     /*  174081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174089 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174092 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174106 */     GIR_RootConstrainSelectedInstOperands,
     /*  174107 */     // GIR_Coverage, 45993,
     /*  174107 */     GIR_EraseRootFromParent_Done,
     /*  174108 */   // Label 3328: @174108
     /*  174108 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(174143), // Rule ID 46052 //
     /*  174113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174116 */     // MIs[0] rs1
     /*  174116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174124 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174127 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174141 */     GIR_RootConstrainSelectedInstOperands,
     /*  174142 */     // GIR_Coverage, 46052,
     /*  174142 */     GIR_EraseRootFromParent_Done,
     /*  174143 */   // Label 3329: @174143
     /*  174143 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(174178), // Rule ID 46053 //
     /*  174148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174151 */     // MIs[0] rs1
     /*  174151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174159 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  174162 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174176 */     GIR_RootConstrainSelectedInstOperands,
     /*  174177 */     // GIR_Coverage, 46053,
     /*  174177 */     GIR_EraseRootFromParent_Done,
     /*  174178 */   // Label 3330: @174178
     /*  174178 */   GIM_Reject,
     /*  174179 */ // Label 3326: @174179
     /*  174179 */ GIM_Reject,
     /*  174180 */ // Label 3193: @174180
     /*  174180 */ GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(174337),
     /*  174185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174196 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(174231), // Rule ID 46008 //
     /*  174201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174204 */     // MIs[0] rs1
     /*  174204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174212 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174215 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174229 */     GIR_RootConstrainSelectedInstOperands,
     /*  174230 */     // GIR_Coverage, 46008,
     /*  174230 */     GIR_EraseRootFromParent_Done,
     /*  174231 */   // Label 3332: @174231
     /*  174231 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(174266), // Rule ID 46009 //
     /*  174236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174239 */     // MIs[0] rs1
     /*  174239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174247 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174250 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174264 */     GIR_RootConstrainSelectedInstOperands,
     /*  174265 */     // GIR_Coverage, 46009,
     /*  174265 */     GIR_EraseRootFromParent_Done,
     /*  174266 */   // Label 3333: @174266
     /*  174266 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(174301), // Rule ID 46068 //
     /*  174271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174274 */     // MIs[0] rs1
     /*  174274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174282 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174285 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174299 */     GIR_RootConstrainSelectedInstOperands,
     /*  174300 */     // GIR_Coverage, 46068,
     /*  174300 */     GIR_EraseRootFromParent_Done,
     /*  174301 */   // Label 3334: @174301
     /*  174301 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(174336), // Rule ID 46069 //
     /*  174306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174309 */     // MIs[0] rs1
     /*  174309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174317 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  174320 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174334 */     GIR_RootConstrainSelectedInstOperands,
     /*  174335 */     // GIR_Coverage, 46069,
     /*  174335 */     GIR_EraseRootFromParent_Done,
     /*  174336 */   // Label 3335: @174336
     /*  174336 */   GIM_Reject,
     /*  174337 */ // Label 3331: @174337
     /*  174337 */ GIM_Reject,
     /*  174338 */ // Label 3194: @174338
     /*  174338 */ GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(174417),
     /*  174343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174362 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(174389), // Rule ID 46084 //
     /*  174367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174370 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  174373 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174387 */     GIR_RootConstrainSelectedInstOperands,
     /*  174388 */     // GIR_Coverage, 46084,
     /*  174388 */     GIR_EraseRootFromParent_Done,
     /*  174389 */   // Label 3337: @174389
     /*  174389 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(174416), // Rule ID 46085 //
     /*  174394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174397 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  174400 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174414 */     GIR_RootConstrainSelectedInstOperands,
     /*  174415 */     // GIR_Coverage, 46085,
     /*  174415 */     GIR_EraseRootFromParent_Done,
     /*  174416 */   // Label 3338: @174416
     /*  174416 */   GIM_Reject,
     /*  174417 */ // Label 3336: @174417
     /*  174417 */ GIM_Reject,
     /*  174418 */ // Label 3195: @174418
     /*  174418 */ GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(174505),
     /*  174423 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174426 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174434 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(174469), // Rule ID 45952 //
     /*  174439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174442 */     // MIs[0] rs1
     /*  174442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174450 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174453 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174467 */     GIR_RootConstrainSelectedInstOperands,
     /*  174468 */     // GIR_Coverage, 45952,
     /*  174468 */     GIR_EraseRootFromParent_Done,
     /*  174469 */   // Label 3340: @174469
     /*  174469 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(174504), // Rule ID 45953 //
     /*  174474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174477 */     // MIs[0] rs1
     /*  174477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174485 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174488 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174502 */     GIR_RootConstrainSelectedInstOperands,
     /*  174503 */     // GIR_Coverage, 45953,
     /*  174503 */     GIR_EraseRootFromParent_Done,
     /*  174504 */   // Label 3341: @174504
     /*  174504 */   GIM_Reject,
     /*  174505 */ // Label 3339: @174505
     /*  174505 */ GIM_Reject,
     /*  174506 */ // Label 3196: @174506
     /*  174506 */ GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(174663),
     /*  174511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174522 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(174557), // Rule ID 45980 //
     /*  174527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174530 */     // MIs[0] rs1
     /*  174530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174538 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174541 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174555 */     GIR_RootConstrainSelectedInstOperands,
     /*  174556 */     // GIR_Coverage, 45980,
     /*  174556 */     GIR_EraseRootFromParent_Done,
     /*  174557 */   // Label 3343: @174557
     /*  174557 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(174592), // Rule ID 45981 //
     /*  174562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174565 */     // MIs[0] rs1
     /*  174565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174573 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174576 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174590 */     GIR_RootConstrainSelectedInstOperands,
     /*  174591 */     // GIR_Coverage, 45981,
     /*  174591 */     GIR_EraseRootFromParent_Done,
     /*  174592 */   // Label 3344: @174592
     /*  174592 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(174627), // Rule ID 46040 //
     /*  174597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174600 */     // MIs[0] rs1
     /*  174600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174608 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174611 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174625 */     GIR_RootConstrainSelectedInstOperands,
     /*  174626 */     // GIR_Coverage, 46040,
     /*  174626 */     GIR_EraseRootFromParent_Done,
     /*  174627 */   // Label 3345: @174627
     /*  174627 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(174662), // Rule ID 46041 //
     /*  174632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174635 */     // MIs[0] rs1
     /*  174635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174643 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174646 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174660 */     GIR_RootConstrainSelectedInstOperands,
     /*  174661 */     // GIR_Coverage, 46041,
     /*  174661 */     GIR_EraseRootFromParent_Done,
     /*  174662 */   // Label 3346: @174662
     /*  174662 */   GIM_Reject,
     /*  174663 */ // Label 3342: @174663
     /*  174663 */ GIM_Reject,
     /*  174664 */ // Label 3197: @174664
     /*  174664 */ GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(174821),
     /*  174669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174680 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(174715), // Rule ID 45996 //
     /*  174685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174688 */     // MIs[0] rs1
     /*  174688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174696 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174699 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174713 */     GIR_RootConstrainSelectedInstOperands,
     /*  174714 */     // GIR_Coverage, 45996,
     /*  174714 */     GIR_EraseRootFromParent_Done,
     /*  174715 */   // Label 3348: @174715
     /*  174715 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(174750), // Rule ID 45997 //
     /*  174720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174723 */     // MIs[0] rs1
     /*  174723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174731 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174734 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174748 */     GIR_RootConstrainSelectedInstOperands,
     /*  174749 */     // GIR_Coverage, 45997,
     /*  174749 */     GIR_EraseRootFromParent_Done,
     /*  174750 */   // Label 3349: @174750
     /*  174750 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(174785), // Rule ID 46056 //
     /*  174755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174758 */     // MIs[0] rs1
     /*  174758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174766 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174769 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174783 */     GIR_RootConstrainSelectedInstOperands,
     /*  174784 */     // GIR_Coverage, 46056,
     /*  174784 */     GIR_EraseRootFromParent_Done,
     /*  174785 */   // Label 3350: @174785
     /*  174785 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(174820), // Rule ID 46057 //
     /*  174790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174793 */     // MIs[0] rs1
     /*  174793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174801 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174804 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174818 */     GIR_RootConstrainSelectedInstOperands,
     /*  174819 */     // GIR_Coverage, 46057,
     /*  174819 */     GIR_EraseRootFromParent_Done,
     /*  174820 */   // Label 3351: @174820
     /*  174820 */   GIM_Reject,
     /*  174821 */ // Label 3347: @174821
     /*  174821 */ GIM_Reject,
     /*  174822 */ // Label 3198: @174822
     /*  174822 */ GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(174979),
     /*  174827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174838 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(174873), // Rule ID 46012 //
     /*  174843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174846 */     // MIs[0] rs1
     /*  174846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174854 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174857 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174871 */     GIR_RootConstrainSelectedInstOperands,
     /*  174872 */     // GIR_Coverage, 46012,
     /*  174872 */     GIR_EraseRootFromParent_Done,
     /*  174873 */   // Label 3353: @174873
     /*  174873 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(174908), // Rule ID 46013 //
     /*  174878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174881 */     // MIs[0] rs1
     /*  174881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174889 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174892 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174906 */     GIR_RootConstrainSelectedInstOperands,
     /*  174907 */     // GIR_Coverage, 46013,
     /*  174907 */     GIR_EraseRootFromParent_Done,
     /*  174908 */   // Label 3354: @174908
     /*  174908 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(174943), // Rule ID 46072 //
     /*  174913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174916 */     // MIs[0] rs1
     /*  174916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174924 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174927 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174941 */     GIR_RootConstrainSelectedInstOperands,
     /*  174942 */     // GIR_Coverage, 46072,
     /*  174942 */     GIR_EraseRootFromParent_Done,
     /*  174943 */   // Label 3355: @174943
     /*  174943 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(174978), // Rule ID 46073 //
     /*  174948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174951 */     // MIs[0] rs1
     /*  174951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174959 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174962 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174976 */     GIR_RootConstrainSelectedInstOperands,
     /*  174977 */     // GIR_Coverage, 46073,
     /*  174977 */     GIR_EraseRootFromParent_Done,
     /*  174978 */   // Label 3356: @174978
     /*  174978 */   GIM_Reject,
     /*  174979 */ // Label 3352: @174979
     /*  174979 */ GIM_Reject,
     /*  174980 */ // Label 3199: @174980
     /*  174980 */ GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(175059),
     /*  174985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174988 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175004 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(175031), // Rule ID 46088 //
     /*  175009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175012 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  175015 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175029 */     GIR_RootConstrainSelectedInstOperands,
     /*  175030 */     // GIR_Coverage, 46088,
     /*  175030 */     GIR_EraseRootFromParent_Done,
     /*  175031 */   // Label 3358: @175031
     /*  175031 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(175058), // Rule ID 46089 //
     /*  175036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175039 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  175042 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175056 */     GIR_RootConstrainSelectedInstOperands,
     /*  175057 */     // GIR_Coverage, 46089,
     /*  175057 */     GIR_EraseRootFromParent_Done,
     /*  175058 */   // Label 3359: @175058
     /*  175058 */   GIM_Reject,
     /*  175059 */ // Label 3357: @175059
     /*  175059 */ GIM_Reject,
     /*  175060 */ // Label 3200: @175060
     /*  175060 */ GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(175147),
     /*  175065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  175076 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(175111), // Rule ID 45968 //
     /*  175081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175084 */     // MIs[0] rs1
     /*  175084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175092 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  175095 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175109 */     GIR_RootConstrainSelectedInstOperands,
     /*  175110 */     // GIR_Coverage, 45968,
     /*  175110 */     GIR_EraseRootFromParent_Done,
     /*  175111 */   // Label 3361: @175111
     /*  175111 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(175146), // Rule ID 45969 //
     /*  175116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175119 */     // MIs[0] rs1
     /*  175119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175127 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  175130 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175144 */     GIR_RootConstrainSelectedInstOperands,
     /*  175145 */     // GIR_Coverage, 45969,
     /*  175145 */     GIR_EraseRootFromParent_Done,
     /*  175146 */   // Label 3362: @175146
     /*  175146 */   GIM_Reject,
     /*  175147 */ // Label 3360: @175147
     /*  175147 */ GIM_Reject,
     /*  175148 */ // Label 3201: @175148
     /*  175148 */ GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(175305),
     /*  175153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175164 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(175199), // Rule ID 45984 //
     /*  175169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175172 */     // MIs[0] rs1
     /*  175172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175180 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175183 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175197 */     GIR_RootConstrainSelectedInstOperands,
     /*  175198 */     // GIR_Coverage, 45984,
     /*  175198 */     GIR_EraseRootFromParent_Done,
     /*  175199 */   // Label 3364: @175199
     /*  175199 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(175234), // Rule ID 45985 //
     /*  175204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175207 */     // MIs[0] rs1
     /*  175207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175215 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175218 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175232 */     GIR_RootConstrainSelectedInstOperands,
     /*  175233 */     // GIR_Coverage, 45985,
     /*  175233 */     GIR_EraseRootFromParent_Done,
     /*  175234 */   // Label 3365: @175234
     /*  175234 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(175269), // Rule ID 46044 //
     /*  175239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175242 */     // MIs[0] rs1
     /*  175242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175250 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175253 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175267 */     GIR_RootConstrainSelectedInstOperands,
     /*  175268 */     // GIR_Coverage, 46044,
     /*  175268 */     GIR_EraseRootFromParent_Done,
     /*  175269 */   // Label 3366: @175269
     /*  175269 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(175304), // Rule ID 46045 //
     /*  175274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175277 */     // MIs[0] rs1
     /*  175277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175285 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  175288 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175302 */     GIR_RootConstrainSelectedInstOperands,
     /*  175303 */     // GIR_Coverage, 46045,
     /*  175303 */     GIR_EraseRootFromParent_Done,
     /*  175304 */   // Label 3367: @175304
     /*  175304 */   GIM_Reject,
     /*  175305 */ // Label 3363: @175305
     /*  175305 */ GIM_Reject,
     /*  175306 */ // Label 3202: @175306
     /*  175306 */ GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(175463),
     /*  175311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175314 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175322 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(175357), // Rule ID 46000 //
     /*  175327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175330 */     // MIs[0] rs1
     /*  175330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175338 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  175338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175341 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175355 */     GIR_RootConstrainSelectedInstOperands,
     /*  175356 */     // GIR_Coverage, 46000,
     /*  175356 */     GIR_EraseRootFromParent_Done,
     /*  175357 */   // Label 3369: @175357
     /*  175357 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(175392), // Rule ID 46001 //
     /*  175362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175365 */     // MIs[0] rs1
     /*  175365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175373 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  175373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175376 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175390 */     GIR_RootConstrainSelectedInstOperands,
     /*  175391 */     // GIR_Coverage, 46001,
     /*  175391 */     GIR_EraseRootFromParent_Done,
     /*  175392 */   // Label 3370: @175392
     /*  175392 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(175427), // Rule ID 46060 //
     /*  175397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  175400 */     // MIs[0] rs1
     /*  175400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175408 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  175408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175411 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175425 */     GIR_RootConstrainSelectedInstOperands,
     /*  175426 */     // GIR_Coverage, 46060,
     /*  175426 */     GIR_EraseRootFromParent_Done,
     /*  175427 */   // Label 3371: @175427
     /*  175427 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(175462), // Rule ID 46061 //
     /*  175432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  175435 */     // MIs[0] rs1
     /*  175435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175443 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  175443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  175446 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175460 */     GIR_RootConstrainSelectedInstOperands,
     /*  175461 */     // GIR_Coverage, 46061,
     /*  175461 */     GIR_EraseRootFromParent_Done,
     /*  175462 */   // Label 3372: @175462
     /*  175462 */   GIM_Reject,
     /*  175463 */ // Label 3368: @175463
     /*  175463 */ GIM_Reject,
     /*  175464 */ // Label 3203: @175464
     /*  175464 */ GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(175543),
     /*  175469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175488 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(175515), // Rule ID 46092 //
     /*  175493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175496 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175499 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175513 */     GIR_RootConstrainSelectedInstOperands,
     /*  175514 */     // GIR_Coverage, 46092,
     /*  175514 */     GIR_EraseRootFromParent_Done,
     /*  175515 */   // Label 3374: @175515
     /*  175515 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(175542), // Rule ID 46093 //
     /*  175520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175523 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175526 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175540 */     GIR_RootConstrainSelectedInstOperands,
     /*  175541 */     // GIR_Coverage, 46093,
     /*  175541 */     GIR_EraseRootFromParent_Done,
     /*  175542 */   // Label 3375: @175542
     /*  175542 */   GIM_Reject,
     /*  175543 */ // Label 3373: @175543
     /*  175543 */ GIM_Reject,
     /*  175544 */ // Label 3204: @175544
     /*  175544 */ GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(175631),
     /*  175549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175560 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(175595), // Rule ID 45972 //
     /*  175565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175568 */     // MIs[0] rs1
     /*  175568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175576 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175579 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175593 */     GIR_RootConstrainSelectedInstOperands,
     /*  175594 */     // GIR_Coverage, 45972,
     /*  175594 */     GIR_EraseRootFromParent_Done,
     /*  175595 */   // Label 3377: @175595
     /*  175595 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(175630), // Rule ID 45973 //
     /*  175600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175603 */     // MIs[0] rs1
     /*  175603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175611 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175614 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175628 */     GIR_RootConstrainSelectedInstOperands,
     /*  175629 */     // GIR_Coverage, 45973,
     /*  175629 */     GIR_EraseRootFromParent_Done,
     /*  175630 */   // Label 3378: @175630
     /*  175630 */   GIM_Reject,
     /*  175631 */ // Label 3376: @175631
     /*  175631 */ GIM_Reject,
     /*  175632 */ // Label 3205: @175632
     /*  175632 */ GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(175789),
     /*  175637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175648 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(175683), // Rule ID 45988 //
     /*  175653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175656 */     // MIs[0] rs1
     /*  175656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175664 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175667 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175681 */     GIR_RootConstrainSelectedInstOperands,
     /*  175682 */     // GIR_Coverage, 45988,
     /*  175682 */     GIR_EraseRootFromParent_Done,
     /*  175683 */   // Label 3380: @175683
     /*  175683 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(175718), // Rule ID 45989 //
     /*  175688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175691 */     // MIs[0] rs1
     /*  175691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175699 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175702 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175716 */     GIR_RootConstrainSelectedInstOperands,
     /*  175717 */     // GIR_Coverage, 45989,
     /*  175717 */     GIR_EraseRootFromParent_Done,
     /*  175718 */   // Label 3381: @175718
     /*  175718 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(175753), // Rule ID 46048 //
     /*  175723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175726 */     // MIs[0] rs1
     /*  175726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175734 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175737 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175751 */     GIR_RootConstrainSelectedInstOperands,
     /*  175752 */     // GIR_Coverage, 46048,
     /*  175752 */     GIR_EraseRootFromParent_Done,
     /*  175753 */   // Label 3382: @175753
     /*  175753 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(175788), // Rule ID 46049 //
     /*  175758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175761 */     // MIs[0] rs1
     /*  175761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175769 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175772 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175786 */     GIR_RootConstrainSelectedInstOperands,
     /*  175787 */     // GIR_Coverage, 46049,
     /*  175787 */     GIR_EraseRootFromParent_Done,
     /*  175788 */   // Label 3383: @175788
     /*  175788 */   GIM_Reject,
     /*  175789 */ // Label 3379: @175789
     /*  175789 */ GIM_Reject,
     /*  175790 */ // Label 3206: @175790
     /*  175790 */ GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(175869),
     /*  175795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175814 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(175841), // Rule ID 46096 //
     /*  175819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175822 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175825 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175839 */     GIR_RootConstrainSelectedInstOperands,
     /*  175840 */     // GIR_Coverage, 46096,
     /*  175840 */     GIR_EraseRootFromParent_Done,
     /*  175841 */   // Label 3385: @175841
     /*  175841 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(175868), // Rule ID 46097 //
     /*  175846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175849 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175852 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175866 */     GIR_RootConstrainSelectedInstOperands,
     /*  175867 */     // GIR_Coverage, 46097,
     /*  175867 */     GIR_EraseRootFromParent_Done,
     /*  175868 */   // Label 3386: @175868
     /*  175868 */   GIM_Reject,
     /*  175869 */ // Label 3384: @175869
     /*  175869 */ GIM_Reject,
     /*  175870 */ // Label 3207: @175870
     /*  175870 */ GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(175957),
     /*  175875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175886 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175921), // Rule ID 45976 //
     /*  175891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175894 */     // MIs[0] rs1
     /*  175894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175902 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175905 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175919 */     GIR_RootConstrainSelectedInstOperands,
     /*  175920 */     // GIR_Coverage, 45976,
     /*  175920 */     GIR_EraseRootFromParent_Done,
     /*  175921 */   // Label 3388: @175921
     /*  175921 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175956), // Rule ID 45977 //
     /*  175926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175929 */     // MIs[0] rs1
     /*  175929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175937 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175940 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175954 */     GIR_RootConstrainSelectedInstOperands,
     /*  175955 */     // GIR_Coverage, 45977,
     /*  175955 */     GIR_EraseRootFromParent_Done,
     /*  175956 */   // Label 3389: @175956
     /*  175956 */   GIM_Reject,
     /*  175957 */ // Label 3387: @175957
     /*  175957 */ GIM_Reject,
     /*  175958 */ // Label 3208: @175958
     /*  175958 */ GIM_Reject,
     /*  175959 */ // Label 25: @175959
     /*  175959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3392*/ GIMT_Encode4(180844),
     /*  175970 */ /*GILLT_s32*//*Label 3390*/ GIMT_Encode4(175978),
     /*  175974 */ /*GILLT_s64*//*Label 3391*/ GIMT_Encode4(177971),
     /*  175978 */ // Label 3390: @175978
     /*  175978 */ GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(177970),
     /*  175983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  175986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175989 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(176055), // Rule ID 655 //
     /*  175994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176011 */     // MIs[0] addr
     /*  176011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176027 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  176027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176035 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176040 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176042 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176044 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  176049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176053 */     GIR_RootConstrainSelectedInstOperands,
     /*  176054 */     // GIR_Coverage, 655,
     /*  176054 */     GIR_EraseRootFromParent_Done,
     /*  176055 */   // Label 3394: @176055
     /*  176055 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(176121), // Rule ID 657 //
     /*  176060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176077 */     // MIs[0] addr
     /*  176077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176093 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  176093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176101 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176106 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176108 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176110 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176119 */     GIR_RootConstrainSelectedInstOperands,
     /*  176120 */     // GIR_Coverage, 657,
     /*  176120 */     GIR_EraseRootFromParent_Done,
     /*  176121 */   // Label 3395: @176121
     /*  176121 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(176187), // Rule ID 659 //
     /*  176126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176143 */     // MIs[0] addr
     /*  176143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176159 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  176159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176167 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176172 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176174 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176176 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176185 */     GIR_RootConstrainSelectedInstOperands,
     /*  176186 */     // GIR_Coverage, 659,
     /*  176186 */     GIR_EraseRootFromParent_Done,
     /*  176187 */   // Label 3396: @176187
     /*  176187 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(176253), // Rule ID 661 //
     /*  176192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176209 */     // MIs[0] addr
     /*  176209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176225 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  176225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176233 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176238 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176240 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176242 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176251 */     GIR_RootConstrainSelectedInstOperands,
     /*  176252 */     // GIR_Coverage, 661,
     /*  176252 */     GIR_EraseRootFromParent_Done,
     /*  176253 */   // Label 3397: @176253
     /*  176253 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(176319), // Rule ID 663 //
     /*  176258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  176261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176275 */     // MIs[0] addr
     /*  176275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176291 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  176291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  176294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  176297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  176299 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  176304 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176306 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176308 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  176313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176317 */     GIR_RootConstrainSelectedInstOperands,
     /*  176318 */     // GIR_Coverage, 663,
     /*  176318 */     GIR_EraseRootFromParent_Done,
     /*  176319 */   // Label 3398: @176319
     /*  176319 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(176374), // Rule ID 672 //
     /*  176324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176341 */     // MIs[0] addr
     /*  176341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176357 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176362 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176364 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176366 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176372 */     GIR_RootConstrainSelectedInstOperands,
     /*  176373 */     // GIR_Coverage, 672,
     /*  176373 */     GIR_EraseRootFromParent_Done,
     /*  176374 */   // Label 3399: @176374
     /*  176374 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(176429), // Rule ID 674 //
     /*  176379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176396 */     // MIs[0] addr
     /*  176396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176412 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  176415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176417 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176419 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176421 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176427 */     GIR_RootConstrainSelectedInstOperands,
     /*  176428 */     // GIR_Coverage, 674,
     /*  176428 */     GIR_EraseRootFromParent_Done,
     /*  176429 */   // Label 3400: @176429
     /*  176429 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(176484), // Rule ID 676 //
     /*  176434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176451 */     // MIs[0] addr
     /*  176451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176467 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  176470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176472 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176474 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176476 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176482 */     GIR_RootConstrainSelectedInstOperands,
     /*  176483 */     // GIR_Coverage, 676,
     /*  176483 */     GIR_EraseRootFromParent_Done,
     /*  176484 */   // Label 3401: @176484
     /*  176484 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(176539), // Rule ID 678 //
     /*  176489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176506 */     // MIs[0] addr
     /*  176506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176522 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176527 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176529 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176531 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176537 */     GIR_RootConstrainSelectedInstOperands,
     /*  176538 */     // GIR_Coverage, 678,
     /*  176538 */     GIR_EraseRootFromParent_Done,
     /*  176539 */   // Label 3402: @176539
     /*  176539 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(176594), // Rule ID 680 //
     /*  176544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176561 */     // MIs[0] addr
     /*  176561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176577 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176582 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176584 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176586 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176592 */     GIR_RootConstrainSelectedInstOperands,
     /*  176593 */     // GIR_Coverage, 680,
     /*  176593 */     GIR_EraseRootFromParent_Done,
     /*  176594 */   // Label 3403: @176594
     /*  176594 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(176649), // Rule ID 682 //
     /*  176599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176616 */     // MIs[0] addr
     /*  176616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176632 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176637 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176639 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176641 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176647 */     GIR_RootConstrainSelectedInstOperands,
     /*  176648 */     // GIR_Coverage, 682,
     /*  176648 */     GIR_EraseRootFromParent_Done,
     /*  176649 */   // Label 3404: @176649
     /*  176649 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(176704), // Rule ID 684 //
     /*  176654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176671 */     // MIs[0] addr
     /*  176671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176687 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176692 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176694 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176696 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176702 */     GIR_RootConstrainSelectedInstOperands,
     /*  176703 */     // GIR_Coverage, 684,
     /*  176703 */     GIR_EraseRootFromParent_Done,
     /*  176704 */   // Label 3405: @176704
     /*  176704 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(176759), // Rule ID 686 //
     /*  176709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176726 */     // MIs[0] addr
     /*  176726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176742 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176747 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176749 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176751 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176757 */     GIR_RootConstrainSelectedInstOperands,
     /*  176758 */     // GIR_Coverage, 686,
     /*  176758 */     GIR_EraseRootFromParent_Done,
     /*  176759 */   // Label 3406: @176759
     /*  176759 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(176814), // Rule ID 688 //
     /*  176764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176767 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176781 */     // MIs[0] addr
     /*  176781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176797 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176802 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176804 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176806 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176812 */     GIR_RootConstrainSelectedInstOperands,
     /*  176813 */     // GIR_Coverage, 688,
     /*  176813 */     GIR_EraseRootFromParent_Done,
     /*  176814 */   // Label 3407: @176814
     /*  176814 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176869), // Rule ID 690 //
     /*  176819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176836 */     // MIs[0] addr
     /*  176836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176852 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176857 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176859 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176861 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176867 */     GIR_RootConstrainSelectedInstOperands,
     /*  176868 */     // GIR_Coverage, 690,
     /*  176868 */     GIR_EraseRootFromParent_Done,
     /*  176869 */   // Label 3408: @176869
     /*  176869 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176924), // Rule ID 1062 //
     /*  176874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176891 */     // MIs[0] addr
     /*  176891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176907 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176912 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176914 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176916 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176922 */     GIR_RootConstrainSelectedInstOperands,
     /*  176923 */     // GIR_Coverage, 1062,
     /*  176923 */     GIR_EraseRootFromParent_Done,
     /*  176924 */   // Label 3409: @176924
     /*  176924 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176979), // Rule ID 1064 //
     /*  176929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176946 */     // MIs[0] addr
     /*  176946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176962 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  176965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176967 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176969 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176971 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176977 */     GIR_RootConstrainSelectedInstOperands,
     /*  176978 */     // GIR_Coverage, 1064,
     /*  176978 */     GIR_EraseRootFromParent_Done,
     /*  176979 */   // Label 3410: @176979
     /*  176979 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(177034), // Rule ID 1066 //
     /*  176984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177001 */     // MIs[0] addr
     /*  177001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177017 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  177020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177022 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177024 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177026 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177032 */     GIR_RootConstrainSelectedInstOperands,
     /*  177033 */     // GIR_Coverage, 1066,
     /*  177033 */     GIR_EraseRootFromParent_Done,
     /*  177034 */   // Label 3411: @177034
     /*  177034 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(177089), // Rule ID 1068 //
     /*  177039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177056 */     // MIs[0] addr
     /*  177056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177072 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  177075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177077 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177079 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177081 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177087 */     GIR_RootConstrainSelectedInstOperands,
     /*  177088 */     // GIR_Coverage, 1068,
     /*  177088 */     GIR_EraseRootFromParent_Done,
     /*  177089 */   // Label 3412: @177089
     /*  177089 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(177144), // Rule ID 1070 //
     /*  177094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177111 */     // MIs[0] addr
     /*  177111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177127 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  177130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177132 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177134 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177136 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177142 */     GIR_RootConstrainSelectedInstOperands,
     /*  177143 */     // GIR_Coverage, 1070,
     /*  177143 */     GIR_EraseRootFromParent_Done,
     /*  177144 */   // Label 3413: @177144
     /*  177144 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(177199), // Rule ID 1072 //
     /*  177149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177166 */     // MIs[0] addr
     /*  177166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177182 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177187 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177189 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177191 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177197 */     GIR_RootConstrainSelectedInstOperands,
     /*  177198 */     // GIR_Coverage, 1072,
     /*  177198 */     GIR_EraseRootFromParent_Done,
     /*  177199 */   // Label 3414: @177199
     /*  177199 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(177254), // Rule ID 1074 //
     /*  177204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177221 */     // MIs[0] addr
     /*  177221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177237 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177242 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177244 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177246 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177252 */     GIR_RootConstrainSelectedInstOperands,
     /*  177253 */     // GIR_Coverage, 1074,
     /*  177253 */     GIR_EraseRootFromParent_Done,
     /*  177254 */   // Label 3415: @177254
     /*  177254 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(177309), // Rule ID 1076 //
     /*  177259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177276 */     // MIs[0] addr
     /*  177276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177292 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177297 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177299 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177301 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177307 */     GIR_RootConstrainSelectedInstOperands,
     /*  177308 */     // GIR_Coverage, 1076,
     /*  177308 */     GIR_EraseRootFromParent_Done,
     /*  177309 */   // Label 3416: @177309
     /*  177309 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(177364), // Rule ID 1078 //
     /*  177314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177331 */     // MIs[0] addr
     /*  177331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177347 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177352 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177354 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177356 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177362 */     GIR_RootConstrainSelectedInstOperands,
     /*  177363 */     // GIR_Coverage, 1078,
     /*  177363 */     GIR_EraseRootFromParent_Done,
     /*  177364 */   // Label 3417: @177364
     /*  177364 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(177419), // Rule ID 1080 //
     /*  177369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  177379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177386 */     // MIs[0] addr
     /*  177386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177402 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  177405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177407 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177409 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177411 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177417 */     GIR_RootConstrainSelectedInstOperands,
     /*  177418 */     // GIR_Coverage, 1080,
     /*  177418 */     GIR_EraseRootFromParent_Done,
     /*  177419 */   // Label 3418: @177419
     /*  177419 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(177474), // Rule ID 1082 //
     /*  177424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177441 */     // MIs[0] addr
     /*  177441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177457 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177462 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177464 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177466 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177472 */     GIR_RootConstrainSelectedInstOperands,
     /*  177473 */     // GIR_Coverage, 1082,
     /*  177473 */     GIR_EraseRootFromParent_Done,
     /*  177474 */   // Label 3419: @177474
     /*  177474 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(177529), // Rule ID 1084 //
     /*  177479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177496 */     // MIs[0] addr
     /*  177496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177512 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  177515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177517 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177519 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177521 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177527 */     GIR_RootConstrainSelectedInstOperands,
     /*  177528 */     // GIR_Coverage, 1084,
     /*  177528 */     GIR_EraseRootFromParent_Done,
     /*  177529 */   // Label 3420: @177529
     /*  177529 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(177584), // Rule ID 1086 //
     /*  177534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177551 */     // MIs[0] addr
     /*  177551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177567 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  177570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177572 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177574 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177576 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177582 */     GIR_RootConstrainSelectedInstOperands,
     /*  177583 */     // GIR_Coverage, 1086,
     /*  177583 */     GIR_EraseRootFromParent_Done,
     /*  177584 */   // Label 3421: @177584
     /*  177584 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(177639), // Rule ID 1088 //
     /*  177589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177606 */     // MIs[0] addr
     /*  177606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177622 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177627 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177629 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177631 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177637 */     GIR_RootConstrainSelectedInstOperands,
     /*  177638 */     // GIR_Coverage, 1088,
     /*  177638 */     GIR_EraseRootFromParent_Done,
     /*  177639 */   // Label 3422: @177639
     /*  177639 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(177694), // Rule ID 1090 //
     /*  177644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177661 */     // MIs[0] addr
     /*  177661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177677 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177682 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177684 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177686 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177692 */     GIR_RootConstrainSelectedInstOperands,
     /*  177693 */     // GIR_Coverage, 1090,
     /*  177693 */     GIR_EraseRootFromParent_Done,
     /*  177694 */   // Label 3423: @177694
     /*  177694 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(177749), // Rule ID 1092 //
     /*  177699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177702 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177716 */     // MIs[0] addr
     /*  177716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177732 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177737 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177739 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177741 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177747 */     GIR_RootConstrainSelectedInstOperands,
     /*  177748 */     // GIR_Coverage, 1092,
     /*  177748 */     GIR_EraseRootFromParent_Done,
     /*  177749 */   // Label 3424: @177749
     /*  177749 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(177804), // Rule ID 1094 //
     /*  177754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177757 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177764 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177771 */     // MIs[0] addr
     /*  177771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177787 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177792 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177794 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177796 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177802 */     GIR_RootConstrainSelectedInstOperands,
     /*  177803 */     // GIR_Coverage, 1094,
     /*  177803 */     GIR_EraseRootFromParent_Done,
     /*  177804 */   // Label 3425: @177804
     /*  177804 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(177859), // Rule ID 1096 //
     /*  177809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177826 */     // MIs[0] addr
     /*  177826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177842 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177847 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177849 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177851 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177857 */     GIR_RootConstrainSelectedInstOperands,
     /*  177858 */     // GIR_Coverage, 1096,
     /*  177858 */     GIR_EraseRootFromParent_Done,
     /*  177859 */   // Label 3426: @177859
     /*  177859 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(177914), // Rule ID 1098 //
     /*  177864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177881 */     // MIs[0] addr
     /*  177881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177897 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177902 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177904 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177906 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177912 */     GIR_RootConstrainSelectedInstOperands,
     /*  177913 */     // GIR_Coverage, 1098,
     /*  177913 */     GIR_EraseRootFromParent_Done,
     /*  177914 */   // Label 3427: @177914
     /*  177914 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(177969), // Rule ID 1100 //
     /*  177919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177922 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177929 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177936 */     // MIs[0] addr
     /*  177936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177952 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177957 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177959 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177961 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177967 */     GIR_RootConstrainSelectedInstOperands,
     /*  177968 */     // GIR_Coverage, 1100,
     /*  177968 */     GIR_EraseRootFromParent_Done,
     /*  177969 */   // Label 3428: @177969
     /*  177969 */   GIM_Reject,
     /*  177970 */ // Label 3393: @177970
     /*  177970 */ GIM_Reject,
     /*  177971 */ // Label 3391: @177971
     /*  177971 */ GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(180843),
     /*  177976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  177979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  177982 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(178048), // Rule ID 654 //
     /*  177987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178004 */     // MIs[0] addr
     /*  178004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178020 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  178020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178028 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178033 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178035 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178037 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  178042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178046 */     GIR_RootConstrainSelectedInstOperands,
     /*  178047 */     // GIR_Coverage, 654,
     /*  178047 */     GIR_EraseRootFromParent_Done,
     /*  178048 */   // Label 3430: @178048
     /*  178048 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(178114), // Rule ID 656 //
     /*  178053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178070 */     // MIs[0] addr
     /*  178070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178086 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  178086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178094 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178099 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178101 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178103 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178112 */     GIR_RootConstrainSelectedInstOperands,
     /*  178113 */     // GIR_Coverage, 656,
     /*  178113 */     GIR_EraseRootFromParent_Done,
     /*  178114 */   // Label 3431: @178114
     /*  178114 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(178180), // Rule ID 658 //
     /*  178119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178136 */     // MIs[0] addr
     /*  178136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178152 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178160 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178165 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178167 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178169 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178178 */     GIR_RootConstrainSelectedInstOperands,
     /*  178179 */     // GIR_Coverage, 658,
     /*  178179 */     GIR_EraseRootFromParent_Done,
     /*  178180 */   // Label 3432: @178180
     /*  178180 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(178246), // Rule ID 660 //
     /*  178185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178202 */     // MIs[0] addr
     /*  178202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178218 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178226 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178231 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178233 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178235 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178244 */     GIR_RootConstrainSelectedInstOperands,
     /*  178245 */     // GIR_Coverage, 660,
     /*  178245 */     GIR_EraseRootFromParent_Done,
     /*  178246 */   // Label 3433: @178246
     /*  178246 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(178312), // Rule ID 662 //
     /*  178251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  178254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178268 */     // MIs[0] addr
     /*  178268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178284 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  178290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178292 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178297 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178299 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178301 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178310 */     GIR_RootConstrainSelectedInstOperands,
     /*  178311 */     // GIR_Coverage, 662,
     /*  178311 */     GIR_EraseRootFromParent_Done,
     /*  178312 */   // Label 3434: @178312
     /*  178312 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(178378), // Rule ID 664 //
     /*  178317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178334 */     // MIs[0] addr
     /*  178334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178350 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  178350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178358 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178363 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178365 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178367 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  178372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178376 */     GIR_RootConstrainSelectedInstOperands,
     /*  178377 */     // GIR_Coverage, 664,
     /*  178377 */     GIR_EraseRootFromParent_Done,
     /*  178378 */   // Label 3435: @178378
     /*  178378 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(178444), // Rule ID 665 //
     /*  178383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178400 */     // MIs[0] addr
     /*  178400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178416 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  178416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178424 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178429 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178431 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178433 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178442 */     GIR_RootConstrainSelectedInstOperands,
     /*  178443 */     // GIR_Coverage, 665,
     /*  178443 */     GIR_EraseRootFromParent_Done,
     /*  178444 */   // Label 3436: @178444
     /*  178444 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(178510), // Rule ID 666 //
     /*  178449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178466 */     // MIs[0] addr
     /*  178466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178482 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178490 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178495 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178497 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178499 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178508 */     GIR_RootConstrainSelectedInstOperands,
     /*  178509 */     // GIR_Coverage, 666,
     /*  178509 */     GIR_EraseRootFromParent_Done,
     /*  178510 */   // Label 3437: @178510
     /*  178510 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(178576), // Rule ID 667 //
     /*  178515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178532 */     // MIs[0] addr
     /*  178532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178548 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178556 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178561 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178563 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178565 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178574 */     GIR_RootConstrainSelectedInstOperands,
     /*  178575 */     // GIR_Coverage, 667,
     /*  178575 */     GIR_EraseRootFromParent_Done,
     /*  178576 */   // Label 3438: @178576
     /*  178576 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(178642), // Rule ID 668 //
     /*  178581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178598 */     // MIs[0] addr
     /*  178598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178614 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178622 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178627 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178629 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178631 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178640 */     GIR_RootConstrainSelectedInstOperands,
     /*  178641 */     // GIR_Coverage, 668,
     /*  178641 */     GIR_EraseRootFromParent_Done,
     /*  178642 */   // Label 3439: @178642
     /*  178642 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(178697), // Rule ID 671 //
     /*  178647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178664 */     // MIs[0] addr
     /*  178664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178680 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178685 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178687 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178689 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178695 */     GIR_RootConstrainSelectedInstOperands,
     /*  178696 */     // GIR_Coverage, 671,
     /*  178696 */     GIR_EraseRootFromParent_Done,
     /*  178697 */   // Label 3440: @178697
     /*  178697 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(178752), // Rule ID 673 //
     /*  178702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178719 */     // MIs[0] addr
     /*  178719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178735 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  178738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178740 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178742 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178744 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178750 */     GIR_RootConstrainSelectedInstOperands,
     /*  178751 */     // GIR_Coverage, 673,
     /*  178751 */     GIR_EraseRootFromParent_Done,
     /*  178752 */   // Label 3441: @178752
     /*  178752 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(178807), // Rule ID 675 //
     /*  178757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178774 */     // MIs[0] addr
     /*  178774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178790 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  178793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178795 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178797 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178799 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178805 */     GIR_RootConstrainSelectedInstOperands,
     /*  178806 */     // GIR_Coverage, 675,
     /*  178806 */     GIR_EraseRootFromParent_Done,
     /*  178807 */   // Label 3442: @178807
     /*  178807 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(178862), // Rule ID 677 //
     /*  178812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178829 */     // MIs[0] addr
     /*  178829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178845 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178850 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178852 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178854 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178860 */     GIR_RootConstrainSelectedInstOperands,
     /*  178861 */     // GIR_Coverage, 677,
     /*  178861 */     GIR_EraseRootFromParent_Done,
     /*  178862 */   // Label 3443: @178862
     /*  178862 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(178917), // Rule ID 679 //
     /*  178867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178884 */     // MIs[0] addr
     /*  178884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178900 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178905 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178907 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178909 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178915 */     GIR_RootConstrainSelectedInstOperands,
     /*  178916 */     // GIR_Coverage, 679,
     /*  178916 */     GIR_EraseRootFromParent_Done,
     /*  178917 */   // Label 3444: @178917
     /*  178917 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(178972), // Rule ID 681 //
     /*  178922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178939 */     // MIs[0] addr
     /*  178939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178955 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178960 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178962 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178964 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178970 */     GIR_RootConstrainSelectedInstOperands,
     /*  178971 */     // GIR_Coverage, 681,
     /*  178971 */     GIR_EraseRootFromParent_Done,
     /*  178972 */   // Label 3445: @178972
     /*  178972 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(179027), // Rule ID 683 //
     /*  178977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178994 */     // MIs[0] addr
     /*  178994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179010 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179015 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179017 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179019 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179025 */     GIR_RootConstrainSelectedInstOperands,
     /*  179026 */     // GIR_Coverage, 683,
     /*  179026 */     GIR_EraseRootFromParent_Done,
     /*  179027 */   // Label 3446: @179027
     /*  179027 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(179082), // Rule ID 685 //
     /*  179032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179049 */     // MIs[0] addr
     /*  179049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179065 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179070 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179072 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179074 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179080 */     GIR_RootConstrainSelectedInstOperands,
     /*  179081 */     // GIR_Coverage, 685,
     /*  179081 */     GIR_EraseRootFromParent_Done,
     /*  179082 */   // Label 3447: @179082
     /*  179082 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(179137), // Rule ID 687 //
     /*  179087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179104 */     // MIs[0] addr
     /*  179104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179120 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179125 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179127 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179129 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179135 */     GIR_RootConstrainSelectedInstOperands,
     /*  179136 */     // GIR_Coverage, 687,
     /*  179136 */     GIR_EraseRootFromParent_Done,
     /*  179137 */   // Label 3448: @179137
     /*  179137 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(179192), // Rule ID 689 //
     /*  179142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179159 */     // MIs[0] addr
     /*  179159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179175 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179180 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179182 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179184 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179190 */     GIR_RootConstrainSelectedInstOperands,
     /*  179191 */     // GIR_Coverage, 689,
     /*  179191 */     GIR_EraseRootFromParent_Done,
     /*  179192 */   // Label 3449: @179192
     /*  179192 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(179247), // Rule ID 691 //
     /*  179197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179214 */     // MIs[0] addr
     /*  179214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179230 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179235 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179237 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179239 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179245 */     GIR_RootConstrainSelectedInstOperands,
     /*  179246 */     // GIR_Coverage, 691,
     /*  179246 */     GIR_EraseRootFromParent_Done,
     /*  179247 */   // Label 3450: @179247
     /*  179247 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(179302), // Rule ID 692 //
     /*  179252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179269 */     // MIs[0] addr
     /*  179269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179285 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  179288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179290 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179292 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179294 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179300 */     GIR_RootConstrainSelectedInstOperands,
     /*  179301 */     // GIR_Coverage, 692,
     /*  179301 */     GIR_EraseRootFromParent_Done,
     /*  179302 */   // Label 3451: @179302
     /*  179302 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(179357), // Rule ID 693 //
     /*  179307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179324 */     // MIs[0] addr
     /*  179324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179340 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  179343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179345 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179347 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179349 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179355 */     GIR_RootConstrainSelectedInstOperands,
     /*  179356 */     // GIR_Coverage, 693,
     /*  179356 */     GIR_EraseRootFromParent_Done,
     /*  179357 */   // Label 3452: @179357
     /*  179357 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(179412), // Rule ID 694 //
     /*  179362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179379 */     // MIs[0] addr
     /*  179379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179395 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  179398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179400 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179402 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179404 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179410 */     GIR_RootConstrainSelectedInstOperands,
     /*  179411 */     // GIR_Coverage, 694,
     /*  179411 */     GIR_EraseRootFromParent_Done,
     /*  179412 */   // Label 3453: @179412
     /*  179412 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(179467), // Rule ID 695 //
     /*  179417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  179420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179434 */     // MIs[0] addr
     /*  179434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179450 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  179453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179455 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179457 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179459 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179465 */     GIR_RootConstrainSelectedInstOperands,
     /*  179466 */     // GIR_Coverage, 695,
     /*  179466 */     GIR_EraseRootFromParent_Done,
     /*  179467 */   // Label 3454: @179467
     /*  179467 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(179522), // Rule ID 696 //
     /*  179472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179489 */     // MIs[0] addr
     /*  179489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179505 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179510 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179512 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179514 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179520 */     GIR_RootConstrainSelectedInstOperands,
     /*  179521 */     // GIR_Coverage, 696,
     /*  179521 */     GIR_EraseRootFromParent_Done,
     /*  179522 */   // Label 3455: @179522
     /*  179522 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(179577), // Rule ID 697 //
     /*  179527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179544 */     // MIs[0] addr
     /*  179544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179560 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179565 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179567 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179569 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179575 */     GIR_RootConstrainSelectedInstOperands,
     /*  179576 */     // GIR_Coverage, 697,
     /*  179576 */     GIR_EraseRootFromParent_Done,
     /*  179577 */   // Label 3456: @179577
     /*  179577 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(179632), // Rule ID 698 //
     /*  179582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179599 */     // MIs[0] addr
     /*  179599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179615 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179620 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179622 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179624 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179630 */     GIR_RootConstrainSelectedInstOperands,
     /*  179631 */     // GIR_Coverage, 698,
     /*  179631 */     GIR_EraseRootFromParent_Done,
     /*  179632 */   // Label 3457: @179632
     /*  179632 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(179687), // Rule ID 699 //
     /*  179637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179654 */     // MIs[0] addr
     /*  179654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179670 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179675 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179677 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179679 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179685 */     GIR_RootConstrainSelectedInstOperands,
     /*  179686 */     // GIR_Coverage, 699,
     /*  179686 */     GIR_EraseRootFromParent_Done,
     /*  179687 */   // Label 3458: @179687
     /*  179687 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(179742), // Rule ID 700 //
     /*  179692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179709 */     // MIs[0] addr
     /*  179709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179725 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179730 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179732 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179734 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179740 */     GIR_RootConstrainSelectedInstOperands,
     /*  179741 */     // GIR_Coverage, 700,
     /*  179741 */     GIR_EraseRootFromParent_Done,
     /*  179742 */   // Label 3459: @179742
     /*  179742 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(179797), // Rule ID 1061 //
     /*  179747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179764 */     // MIs[0] addr
     /*  179764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179780 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179785 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179787 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179789 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179795 */     GIR_RootConstrainSelectedInstOperands,
     /*  179796 */     // GIR_Coverage, 1061,
     /*  179796 */     GIR_EraseRootFromParent_Done,
     /*  179797 */   // Label 3460: @179797
     /*  179797 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(179852), // Rule ID 1063 //
     /*  179802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179819 */     // MIs[0] addr
     /*  179819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179835 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  179838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179840 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179842 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179844 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179850 */     GIR_RootConstrainSelectedInstOperands,
     /*  179851 */     // GIR_Coverage, 1063,
     /*  179851 */     GIR_EraseRootFromParent_Done,
     /*  179852 */   // Label 3461: @179852
     /*  179852 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(179907), // Rule ID 1065 //
     /*  179857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179874 */     // MIs[0] addr
     /*  179874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179890 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  179893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179895 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179897 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179899 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179905 */     GIR_RootConstrainSelectedInstOperands,
     /*  179906 */     // GIR_Coverage, 1065,
     /*  179906 */     GIR_EraseRootFromParent_Done,
     /*  179907 */   // Label 3462: @179907
     /*  179907 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(179962), // Rule ID 1067 //
     /*  179912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179929 */     // MIs[0] addr
     /*  179929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179945 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179950 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179952 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179954 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179960 */     GIR_RootConstrainSelectedInstOperands,
     /*  179961 */     // GIR_Coverage, 1067,
     /*  179961 */     GIR_EraseRootFromParent_Done,
     /*  179962 */   // Label 3463: @179962
     /*  179962 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(180017), // Rule ID 1069 //
     /*  179967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179984 */     // MIs[0] addr
     /*  179984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180000 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180005 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180007 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180009 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180015 */     GIR_RootConstrainSelectedInstOperands,
     /*  180016 */     // GIR_Coverage, 1069,
     /*  180016 */     GIR_EraseRootFromParent_Done,
     /*  180017 */   // Label 3464: @180017
     /*  180017 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(180072), // Rule ID 1071 //
     /*  180022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180039 */     // MIs[0] addr
     /*  180039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180055 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180060 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180062 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180064 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180070 */     GIR_RootConstrainSelectedInstOperands,
     /*  180071 */     // GIR_Coverage, 1071,
     /*  180071 */     GIR_EraseRootFromParent_Done,
     /*  180072 */   // Label 3465: @180072
     /*  180072 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(180127), // Rule ID 1073 //
     /*  180077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180094 */     // MIs[0] addr
     /*  180094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180110 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180115 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180117 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180119 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180125 */     GIR_RootConstrainSelectedInstOperands,
     /*  180126 */     // GIR_Coverage, 1073,
     /*  180126 */     GIR_EraseRootFromParent_Done,
     /*  180127 */   // Label 3466: @180127
     /*  180127 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(180182), // Rule ID 1075 //
     /*  180132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180135 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180149 */     // MIs[0] addr
     /*  180149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180165 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180170 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180172 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180174 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180180 */     GIR_RootConstrainSelectedInstOperands,
     /*  180181 */     // GIR_Coverage, 1075,
     /*  180181 */     GIR_EraseRootFromParent_Done,
     /*  180182 */   // Label 3467: @180182
     /*  180182 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(180237), // Rule ID 1077 //
     /*  180187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180204 */     // MIs[0] addr
     /*  180204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180220 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180225 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180227 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180229 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180235 */     GIR_RootConstrainSelectedInstOperands,
     /*  180236 */     // GIR_Coverage, 1077,
     /*  180236 */     GIR_EraseRootFromParent_Done,
     /*  180237 */   // Label 3468: @180237
     /*  180237 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(180292), // Rule ID 1079 //
     /*  180242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180259 */     // MIs[0] addr
     /*  180259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180275 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180280 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180282 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180284 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180290 */     GIR_RootConstrainSelectedInstOperands,
     /*  180291 */     // GIR_Coverage, 1079,
     /*  180291 */     GIR_EraseRootFromParent_Done,
     /*  180292 */   // Label 3469: @180292
     /*  180292 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(180347), // Rule ID 1081 //
     /*  180297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180314 */     // MIs[0] addr
     /*  180314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180330 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180335 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180337 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180339 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180345 */     GIR_RootConstrainSelectedInstOperands,
     /*  180346 */     // GIR_Coverage, 1081,
     /*  180346 */     GIR_EraseRootFromParent_Done,
     /*  180347 */   // Label 3470: @180347
     /*  180347 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(180402), // Rule ID 1083 //
     /*  180352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180369 */     // MIs[0] addr
     /*  180369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180385 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  180388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180390 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180392 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180394 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180400 */     GIR_RootConstrainSelectedInstOperands,
     /*  180401 */     // GIR_Coverage, 1083,
     /*  180401 */     GIR_EraseRootFromParent_Done,
     /*  180402 */   // Label 3471: @180402
     /*  180402 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(180457), // Rule ID 1085 //
     /*  180407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180424 */     // MIs[0] addr
     /*  180424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180440 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  180443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180445 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180447 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180449 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180455 */     GIR_RootConstrainSelectedInstOperands,
     /*  180456 */     // GIR_Coverage, 1085,
     /*  180456 */     GIR_EraseRootFromParent_Done,
     /*  180457 */   // Label 3472: @180457
     /*  180457 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(180512), // Rule ID 1087 //
     /*  180462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180479 */     // MIs[0] addr
     /*  180479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180495 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180500 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180502 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180504 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180510 */     GIR_RootConstrainSelectedInstOperands,
     /*  180511 */     // GIR_Coverage, 1087,
     /*  180511 */     GIR_EraseRootFromParent_Done,
     /*  180512 */   // Label 3473: @180512
     /*  180512 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(180567), // Rule ID 1089 //
     /*  180517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180527 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180534 */     // MIs[0] addr
     /*  180534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180550 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180555 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180557 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180559 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180565 */     GIR_RootConstrainSelectedInstOperands,
     /*  180566 */     // GIR_Coverage, 1089,
     /*  180566 */     GIR_EraseRootFromParent_Done,
     /*  180567 */   // Label 3474: @180567
     /*  180567 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(180622), // Rule ID 1091 //
     /*  180572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180589 */     // MIs[0] addr
     /*  180589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180605 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180610 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180612 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180614 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180620 */     GIR_RootConstrainSelectedInstOperands,
     /*  180621 */     // GIR_Coverage, 1091,
     /*  180621 */     GIR_EraseRootFromParent_Done,
     /*  180622 */   // Label 3475: @180622
     /*  180622 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(180677), // Rule ID 1093 //
     /*  180627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180644 */     // MIs[0] addr
     /*  180644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180660 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180665 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180667 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180669 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180675 */     GIR_RootConstrainSelectedInstOperands,
     /*  180676 */     // GIR_Coverage, 1093,
     /*  180676 */     GIR_EraseRootFromParent_Done,
     /*  180677 */   // Label 3476: @180677
     /*  180677 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(180732), // Rule ID 1095 //
     /*  180682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180685 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180699 */     // MIs[0] addr
     /*  180699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180715 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180720 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180722 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180724 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180730 */     GIR_RootConstrainSelectedInstOperands,
     /*  180731 */     // GIR_Coverage, 1095,
     /*  180731 */     GIR_EraseRootFromParent_Done,
     /*  180732 */   // Label 3477: @180732
     /*  180732 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(180787), // Rule ID 1097 //
     /*  180737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180754 */     // MIs[0] addr
     /*  180754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180770 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180775 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180777 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180779 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180785 */     GIR_RootConstrainSelectedInstOperands,
     /*  180786 */     // GIR_Coverage, 1097,
     /*  180786 */     GIR_EraseRootFromParent_Done,
     /*  180787 */   // Label 3478: @180787
     /*  180787 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(180842), // Rule ID 1099 //
     /*  180792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180809 */     // MIs[0] addr
     /*  180809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180825 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180830 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180832 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180834 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180840 */     GIR_RootConstrainSelectedInstOperands,
     /*  180841 */     // GIR_Coverage, 1099,
     /*  180841 */     GIR_EraseRootFromParent_Done,
     /*  180842 */   // Label 3479: @180842
     /*  180842 */   GIM_Reject,
     /*  180843 */ // Label 3429: @180843
     /*  180843 */ GIM_Reject,
     /*  180844 */ // Label 3392: @180844
     /*  180844 */ GIM_Reject,
     /*  180845 */ // Label 26: @180845
     /*  180845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3482*/ GIMT_Encode4(183754),
     /*  180856 */ /*GILLT_s32*//*Label 3480*/ GIMT_Encode4(180864),
     /*  180860 */ /*GILLT_s64*//*Label 3481*/ GIMT_Encode4(182104),
     /*  180864 */ // Label 3480: @180864
     /*  180864 */ GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(182103),
     /*  180869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  180872 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(180913), // Rule ID 354 //
     /*  180877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180894 */     // MIs[0] rs1
     /*  180894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180906 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180911 */     GIR_RootConstrainSelectedInstOperands,
     /*  180912 */     // GIR_Coverage, 354,
     /*  180912 */     GIR_Done,
     /*  180913 */   // Label 3484: @180913
     /*  180913 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(180954), // Rule ID 356 //
     /*  180918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180935 */     // MIs[0] rs1
     /*  180935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180947 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  180952 */     GIR_RootConstrainSelectedInstOperands,
     /*  180953 */     // GIR_Coverage, 356,
     /*  180953 */     GIR_Done,
     /*  180954 */   // Label 3485: @180954
     /*  180954 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(180995), // Rule ID 358 //
     /*  180959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180976 */     // MIs[0] rs1
     /*  180976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180988 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  180993 */     GIR_RootConstrainSelectedInstOperands,
     /*  180994 */     // GIR_Coverage, 358,
     /*  180994 */     GIR_Done,
     /*  180995 */   // Label 3486: @180995
     /*  180995 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(181036), // Rule ID 360 //
     /*  181000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  181003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181017 */     // MIs[0] rs1
     /*  181017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181029 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181034 */     GIR_RootConstrainSelectedInstOperands,
     /*  181035 */     // GIR_Coverage, 360,
     /*  181035 */     GIR_Done,
     /*  181036 */   // Label 3487: @181036
     /*  181036 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(181077), // Rule ID 362 //
     /*  181041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  181044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181058 */     // MIs[0] rs1
     /*  181058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181070 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181075 */     GIR_RootConstrainSelectedInstOperands,
     /*  181076 */     // GIR_Coverage, 362,
     /*  181076 */     GIR_Done,
     /*  181077 */   // Label 3488: @181077
     /*  181077 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(181118), // Rule ID 364 //
     /*  181082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181099 */     // MIs[0] rs1
     /*  181099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181111 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181116 */     GIR_RootConstrainSelectedInstOperands,
     /*  181117 */     // GIR_Coverage, 364,
     /*  181117 */     GIR_Done,
     /*  181118 */   // Label 3489: @181118
     /*  181118 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(181159), // Rule ID 366 //
     /*  181123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181140 */     // MIs[0] rs1
     /*  181140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181152 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181157 */     GIR_RootConstrainSelectedInstOperands,
     /*  181158 */     // GIR_Coverage, 366,
     /*  181158 */     GIR_Done,
     /*  181159 */   // Label 3490: @181159
     /*  181159 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(181200), // Rule ID 368 //
     /*  181164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181181 */     // MIs[0] rs1
     /*  181181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181193 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181198 */     GIR_RootConstrainSelectedInstOperands,
     /*  181199 */     // GIR_Coverage, 368,
     /*  181199 */     GIR_Done,
     /*  181200 */   // Label 3491: @181200
     /*  181200 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(181241), // Rule ID 370 //
     /*  181205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181208 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181222 */     // MIs[0] rs1
     /*  181222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181234 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181239 */     GIR_RootConstrainSelectedInstOperands,
     /*  181240 */     // GIR_Coverage, 370,
     /*  181240 */     GIR_Done,
     /*  181241 */   // Label 3492: @181241
     /*  181241 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(181282), // Rule ID 372 //
     /*  181246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  181249 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181263 */     // MIs[0] rs1
     /*  181263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181275 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181280 */     GIR_RootConstrainSelectedInstOperands,
     /*  181281 */     // GIR_Coverage, 372,
     /*  181281 */     GIR_Done,
     /*  181282 */   // Label 3493: @181282
     /*  181282 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(181323), // Rule ID 702 //
     /*  181287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181290 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181304 */     // MIs[0] rs1
     /*  181304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181316 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181321 */     GIR_RootConstrainSelectedInstOperands,
     /*  181322 */     // GIR_Coverage, 702,
     /*  181322 */     GIR_Done,
     /*  181323 */   // Label 3494: @181323
     /*  181323 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(181364), // Rule ID 704 //
     /*  181328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181345 */     // MIs[0] rs1
     /*  181345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181357 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  181362 */     GIR_RootConstrainSelectedInstOperands,
     /*  181363 */     // GIR_Coverage, 704,
     /*  181363 */     GIR_Done,
     /*  181364 */   // Label 3495: @181364
     /*  181364 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(181405), // Rule ID 706 //
     /*  181369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181386 */     // MIs[0] rs1
     /*  181386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181398 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  181403 */     GIR_RootConstrainSelectedInstOperands,
     /*  181404 */     // GIR_Coverage, 706,
     /*  181404 */     GIR_Done,
     /*  181405 */   // Label 3496: @181405
     /*  181405 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(181446), // Rule ID 708 //
     /*  181410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181427 */     // MIs[0] rs1
     /*  181427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181439 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181444 */     GIR_RootConstrainSelectedInstOperands,
     /*  181445 */     // GIR_Coverage, 708,
     /*  181445 */     GIR_Done,
     /*  181446 */   // Label 3497: @181446
     /*  181446 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(181487), // Rule ID 710 //
     /*  181451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181454 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181468 */     // MIs[0] rs1
     /*  181468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181480 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181485 */     GIR_RootConstrainSelectedInstOperands,
     /*  181486 */     // GIR_Coverage, 710,
     /*  181486 */     GIR_Done,
     /*  181487 */   // Label 3498: @181487
     /*  181487 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(181528), // Rule ID 712 //
     /*  181492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181509 */     // MIs[0] rs1
     /*  181509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181521 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181526 */     GIR_RootConstrainSelectedInstOperands,
     /*  181527 */     // GIR_Coverage, 712,
     /*  181527 */     GIR_Done,
     /*  181528 */   // Label 3499: @181528
     /*  181528 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(181569), // Rule ID 714 //
     /*  181533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181543 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181550 */     // MIs[0] rs1
     /*  181550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181562 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181567 */     GIR_RootConstrainSelectedInstOperands,
     /*  181568 */     // GIR_Coverage, 714,
     /*  181568 */     GIR_Done,
     /*  181569 */   // Label 3500: @181569
     /*  181569 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(181610), // Rule ID 716 //
     /*  181574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181584 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181591 */     // MIs[0] rs1
     /*  181591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181603 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181608 */     GIR_RootConstrainSelectedInstOperands,
     /*  181609 */     // GIR_Coverage, 716,
     /*  181609 */     GIR_Done,
     /*  181610 */   // Label 3501: @181610
     /*  181610 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(181651), // Rule ID 718 //
     /*  181615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181632 */     // MIs[0] rs1
     /*  181632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181644 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181649 */     GIR_RootConstrainSelectedInstOperands,
     /*  181650 */     // GIR_Coverage, 718,
     /*  181650 */     GIR_Done,
     /*  181651 */   // Label 3502: @181651
     /*  181651 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(181692), // Rule ID 720 //
     /*  181656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181673 */     // MIs[0] rs1
     /*  181673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181685 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181690 */     GIR_RootConstrainSelectedInstOperands,
     /*  181691 */     // GIR_Coverage, 720,
     /*  181691 */     GIR_Done,
     /*  181692 */   // Label 3503: @181692
     /*  181692 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(181733), // Rule ID 882 //
     /*  181697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181714 */     // MIs[0] rs1
     /*  181714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181726 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181731 */     GIR_RootConstrainSelectedInstOperands,
     /*  181732 */     // GIR_Coverage, 882,
     /*  181732 */     GIR_Done,
     /*  181733 */   // Label 3504: @181733
     /*  181733 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(181774), // Rule ID 884 //
     /*  181738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181755 */     // MIs[0] rs1
     /*  181755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181767 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  181772 */     GIR_RootConstrainSelectedInstOperands,
     /*  181773 */     // GIR_Coverage, 884,
     /*  181773 */     GIR_Done,
     /*  181774 */   // Label 3505: @181774
     /*  181774 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(181815), // Rule ID 886 //
     /*  181779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181796 */     // MIs[0] rs1
     /*  181796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181808 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  181813 */     GIR_RootConstrainSelectedInstOperands,
     /*  181814 */     // GIR_Coverage, 886,
     /*  181814 */     GIR_Done,
     /*  181815 */   // Label 3506: @181815
     /*  181815 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(181856), // Rule ID 888 //
     /*  181820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181837 */     // MIs[0] rs1
     /*  181837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181849 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181854 */     GIR_RootConstrainSelectedInstOperands,
     /*  181855 */     // GIR_Coverage, 888,
     /*  181855 */     GIR_Done,
     /*  181856 */   // Label 3507: @181856
     /*  181856 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(181897), // Rule ID 890 //
     /*  181861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181878 */     // MIs[0] rs1
     /*  181878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181890 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181895 */     GIR_RootConstrainSelectedInstOperands,
     /*  181896 */     // GIR_Coverage, 890,
     /*  181896 */     GIR_Done,
     /*  181897 */   // Label 3508: @181897
     /*  181897 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(181938), // Rule ID 892 //
     /*  181902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181919 */     // MIs[0] rs1
     /*  181919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181931 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181936 */     GIR_RootConstrainSelectedInstOperands,
     /*  181937 */     // GIR_Coverage, 892,
     /*  181937 */     GIR_Done,
     /*  181938 */   // Label 3509: @181938
     /*  181938 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(181979), // Rule ID 894 //
     /*  181943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181960 */     // MIs[0] rs1
     /*  181960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181972 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181977 */     GIR_RootConstrainSelectedInstOperands,
     /*  181978 */     // GIR_Coverage, 894,
     /*  181978 */     GIR_Done,
     /*  181979 */   // Label 3510: @181979
     /*  181979 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(182020), // Rule ID 896 //
     /*  181984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182001 */     // MIs[0] rs1
     /*  182001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182013 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182018 */     GIR_RootConstrainSelectedInstOperands,
     /*  182019 */     // GIR_Coverage, 896,
     /*  182019 */     GIR_Done,
     /*  182020 */   // Label 3511: @182020
     /*  182020 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(182061), // Rule ID 898 //
     /*  182025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  182028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182042 */     // MIs[0] rs1
     /*  182042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182054 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182059 */     GIR_RootConstrainSelectedInstOperands,
     /*  182060 */     // GIR_Coverage, 898,
     /*  182060 */     GIR_Done,
     /*  182061 */   // Label 3512: @182061
     /*  182061 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(182102), // Rule ID 900 //
     /*  182066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  182069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182076 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182083 */     // MIs[0] rs1
     /*  182083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182095 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182100 */     GIR_RootConstrainSelectedInstOperands,
     /*  182101 */     // GIR_Coverage, 900,
     /*  182101 */     GIR_Done,
     /*  182102 */   // Label 3513: @182102
     /*  182102 */   GIM_Reject,
     /*  182103 */ // Label 3483: @182103
     /*  182103 */ GIM_Reject,
     /*  182104 */ // Label 3481: @182104
     /*  182104 */ GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(183753),
     /*  182109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  182112 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(182153), // Rule ID 353 //
     /*  182117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182134 */     // MIs[0] rs1
     /*  182134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182146 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182151 */     GIR_RootConstrainSelectedInstOperands,
     /*  182152 */     // GIR_Coverage, 353,
     /*  182152 */     GIR_Done,
     /*  182153 */   // Label 3515: @182153
     /*  182153 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(182194), // Rule ID 355 //
     /*  182158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182175 */     // MIs[0] rs1
     /*  182175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182187 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  182192 */     GIR_RootConstrainSelectedInstOperands,
     /*  182193 */     // GIR_Coverage, 355,
     /*  182193 */     GIR_Done,
     /*  182194 */   // Label 3516: @182194
     /*  182194 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(182235), // Rule ID 357 //
     /*  182199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182216 */     // MIs[0] rs1
     /*  182216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182228 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  182233 */     GIR_RootConstrainSelectedInstOperands,
     /*  182234 */     // GIR_Coverage, 357,
     /*  182234 */     GIR_Done,
     /*  182235 */   // Label 3517: @182235
     /*  182235 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(182276), // Rule ID 359 //
     /*  182240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182257 */     // MIs[0] rs1
     /*  182257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182269 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  182274 */     GIR_RootConstrainSelectedInstOperands,
     /*  182275 */     // GIR_Coverage, 359,
     /*  182275 */     GIR_Done,
     /*  182276 */   // Label 3518: @182276
     /*  182276 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(182317), // Rule ID 361 //
     /*  182281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  182284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182298 */     // MIs[0] rs1
     /*  182298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182310 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  182315 */     GIR_RootConstrainSelectedInstOperands,
     /*  182316 */     // GIR_Coverage, 361,
     /*  182316 */     GIR_Done,
     /*  182317 */   // Label 3519: @182317
     /*  182317 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(182358), // Rule ID 363 //
     /*  182322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182339 */     // MIs[0] rs1
     /*  182339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182351 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182356 */     GIR_RootConstrainSelectedInstOperands,
     /*  182357 */     // GIR_Coverage, 363,
     /*  182357 */     GIR_Done,
     /*  182358 */   // Label 3520: @182358
     /*  182358 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(182399), // Rule ID 365 //
     /*  182363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182380 */     // MIs[0] rs1
     /*  182380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182392 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182397 */     GIR_RootConstrainSelectedInstOperands,
     /*  182398 */     // GIR_Coverage, 365,
     /*  182398 */     GIR_Done,
     /*  182399 */   // Label 3521: @182399
     /*  182399 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(182440), // Rule ID 367 //
     /*  182404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182407 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182414 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182421 */     // MIs[0] rs1
     /*  182421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182433 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182438 */     GIR_RootConstrainSelectedInstOperands,
     /*  182439 */     // GIR_Coverage, 367,
     /*  182439 */     GIR_Done,
     /*  182440 */   // Label 3522: @182440
     /*  182440 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(182481), // Rule ID 369 //
     /*  182445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182462 */     // MIs[0] rs1
     /*  182462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182474 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182479 */     GIR_RootConstrainSelectedInstOperands,
     /*  182480 */     // GIR_Coverage, 369,
     /*  182480 */     GIR_Done,
     /*  182481 */   // Label 3523: @182481
     /*  182481 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(182522), // Rule ID 371 //
     /*  182486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182489 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182503 */     // MIs[0] rs1
     /*  182503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182515 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182520 */     GIR_RootConstrainSelectedInstOperands,
     /*  182521 */     // GIR_Coverage, 371,
     /*  182521 */     GIR_Done,
     /*  182522 */   // Label 3524: @182522
     /*  182522 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(182563), // Rule ID 533 //
     /*  182527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182544 */     // MIs[0] rs1
     /*  182544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182556 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182561 */     GIR_RootConstrainSelectedInstOperands,
     /*  182562 */     // GIR_Coverage, 533,
     /*  182562 */     GIR_Done,
     /*  182563 */   // Label 3525: @182563
     /*  182563 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(182604), // Rule ID 534 //
     /*  182568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182585 */     // MIs[0] rs1
     /*  182585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182597 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  182602 */     GIR_RootConstrainSelectedInstOperands,
     /*  182603 */     // GIR_Coverage, 534,
     /*  182603 */     GIR_Done,
     /*  182604 */   // Label 3526: @182604
     /*  182604 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(182645), // Rule ID 535 //
     /*  182609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182626 */     // MIs[0] rs1
     /*  182626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182638 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  182643 */     GIR_RootConstrainSelectedInstOperands,
     /*  182644 */     // GIR_Coverage, 535,
     /*  182644 */     GIR_Done,
     /*  182645 */   // Label 3527: @182645
     /*  182645 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(182686), // Rule ID 536 //
     /*  182650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182667 */     // MIs[0] rs1
     /*  182667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182679 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182684 */     GIR_RootConstrainSelectedInstOperands,
     /*  182685 */     // GIR_Coverage, 536,
     /*  182685 */     GIR_Done,
     /*  182686 */   // Label 3528: @182686
     /*  182686 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(182727), // Rule ID 537 //
     /*  182691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182708 */     // MIs[0] rs1
     /*  182708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182720 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182725 */     GIR_RootConstrainSelectedInstOperands,
     /*  182726 */     // GIR_Coverage, 537,
     /*  182726 */     GIR_Done,
     /*  182727 */   // Label 3529: @182727
     /*  182727 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(182768), // Rule ID 538 //
     /*  182732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182749 */     // MIs[0] rs1
     /*  182749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182761 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182766 */     GIR_RootConstrainSelectedInstOperands,
     /*  182767 */     // GIR_Coverage, 538,
     /*  182767 */     GIR_Done,
     /*  182768 */   // Label 3530: @182768
     /*  182768 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(182809), // Rule ID 539 //
     /*  182773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182790 */     // MIs[0] rs1
     /*  182790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182802 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182807 */     GIR_RootConstrainSelectedInstOperands,
     /*  182808 */     // GIR_Coverage, 539,
     /*  182808 */     GIR_Done,
     /*  182809 */   // Label 3531: @182809
     /*  182809 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(182850), // Rule ID 540 //
     /*  182814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182817 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182824 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182831 */     // MIs[0] rs1
     /*  182831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182843 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182848 */     GIR_RootConstrainSelectedInstOperands,
     /*  182849 */     // GIR_Coverage, 540,
     /*  182849 */     GIR_Done,
     /*  182850 */   // Label 3532: @182850
     /*  182850 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(182891), // Rule ID 541 //
     /*  182855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182872 */     // MIs[0] rs1
     /*  182872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182884 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182889 */     GIR_RootConstrainSelectedInstOperands,
     /*  182890 */     // GIR_Coverage, 541,
     /*  182890 */     GIR_Done,
     /*  182891 */   // Label 3533: @182891
     /*  182891 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(182932), // Rule ID 542 //
     /*  182896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182913 */     // MIs[0] rs1
     /*  182913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182925 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182930 */     GIR_RootConstrainSelectedInstOperands,
     /*  182931 */     // GIR_Coverage, 542,
     /*  182931 */     GIR_Done,
     /*  182932 */   // Label 3534: @182932
     /*  182932 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(182973), // Rule ID 701 //
     /*  182937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182954 */     // MIs[0] rs1
     /*  182954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182966 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182971 */     GIR_RootConstrainSelectedInstOperands,
     /*  182972 */     // GIR_Coverage, 701,
     /*  182972 */     GIR_Done,
     /*  182973 */   // Label 3535: @182973
     /*  182973 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(183014), // Rule ID 703 //
     /*  182978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182995 */     // MIs[0] rs1
     /*  182995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183007 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  183012 */     GIR_RootConstrainSelectedInstOperands,
     /*  183013 */     // GIR_Coverage, 703,
     /*  183013 */     GIR_Done,
     /*  183014 */   // Label 3536: @183014
     /*  183014 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(183055), // Rule ID 705 //
     /*  183019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183036 */     // MIs[0] rs1
     /*  183036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183048 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  183053 */     GIR_RootConstrainSelectedInstOperands,
     /*  183054 */     // GIR_Coverage, 705,
     /*  183054 */     GIR_Done,
     /*  183055 */   // Label 3537: @183055
     /*  183055 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(183096), // Rule ID 707 //
     /*  183060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183077 */     // MIs[0] rs1
     /*  183077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183089 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  183094 */     GIR_RootConstrainSelectedInstOperands,
     /*  183095 */     // GIR_Coverage, 707,
     /*  183095 */     GIR_Done,
     /*  183096 */   // Label 3538: @183096
     /*  183096 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(183137), // Rule ID 709 //
     /*  183101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183118 */     // MIs[0] rs1
     /*  183118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183130 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  183135 */     GIR_RootConstrainSelectedInstOperands,
     /*  183136 */     // GIR_Coverage, 709,
     /*  183136 */     GIR_Done,
     /*  183137 */   // Label 3539: @183137
     /*  183137 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(183178), // Rule ID 711 //
     /*  183142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183159 */     // MIs[0] rs1
     /*  183159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183171 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183176 */     GIR_RootConstrainSelectedInstOperands,
     /*  183177 */     // GIR_Coverage, 711,
     /*  183177 */     GIR_Done,
     /*  183178 */   // Label 3540: @183178
     /*  183178 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(183219), // Rule ID 713 //
     /*  183183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183200 */     // MIs[0] rs1
     /*  183200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183212 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183217 */     GIR_RootConstrainSelectedInstOperands,
     /*  183218 */     // GIR_Coverage, 713,
     /*  183218 */     GIR_Done,
     /*  183219 */   // Label 3541: @183219
     /*  183219 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(183260), // Rule ID 715 //
     /*  183224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183241 */     // MIs[0] rs1
     /*  183241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183253 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183258 */     GIR_RootConstrainSelectedInstOperands,
     /*  183259 */     // GIR_Coverage, 715,
     /*  183259 */     GIR_Done,
     /*  183260 */   // Label 3542: @183260
     /*  183260 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(183301), // Rule ID 717 //
     /*  183265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183282 */     // MIs[0] rs1
     /*  183282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183294 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183299 */     GIR_RootConstrainSelectedInstOperands,
     /*  183300 */     // GIR_Coverage, 717,
     /*  183300 */     GIR_Done,
     /*  183301 */   // Label 3543: @183301
     /*  183301 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(183342), // Rule ID 719 //
     /*  183306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183323 */     // MIs[0] rs1
     /*  183323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183335 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  183340 */     GIR_RootConstrainSelectedInstOperands,
     /*  183341 */     // GIR_Coverage, 719,
     /*  183341 */     GIR_Done,
     /*  183342 */   // Label 3544: @183342
     /*  183342 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(183383), // Rule ID 881 //
     /*  183347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183364 */     // MIs[0] rs1
     /*  183364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183376 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183381 */     GIR_RootConstrainSelectedInstOperands,
     /*  183382 */     // GIR_Coverage, 881,
     /*  183382 */     GIR_Done,
     /*  183383 */   // Label 3545: @183383
     /*  183383 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(183424), // Rule ID 883 //
     /*  183388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183405 */     // MIs[0] rs1
     /*  183405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183417 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  183422 */     GIR_RootConstrainSelectedInstOperands,
     /*  183423 */     // GIR_Coverage, 883,
     /*  183423 */     GIR_Done,
     /*  183424 */   // Label 3546: @183424
     /*  183424 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(183465), // Rule ID 885 //
     /*  183429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183446 */     // MIs[0] rs1
     /*  183446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183458 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  183463 */     GIR_RootConstrainSelectedInstOperands,
     /*  183464 */     // GIR_Coverage, 885,
     /*  183464 */     GIR_Done,
     /*  183465 */   // Label 3547: @183465
     /*  183465 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(183506), // Rule ID 887 //
     /*  183470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183487 */     // MIs[0] rs1
     /*  183487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183499 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183504 */     GIR_RootConstrainSelectedInstOperands,
     /*  183505 */     // GIR_Coverage, 887,
     /*  183505 */     GIR_Done,
     /*  183506 */   // Label 3548: @183506
     /*  183506 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(183547), // Rule ID 889 //
     /*  183511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183528 */     // MIs[0] rs1
     /*  183528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183540 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183545 */     GIR_RootConstrainSelectedInstOperands,
     /*  183546 */     // GIR_Coverage, 889,
     /*  183546 */     GIR_Done,
     /*  183547 */   // Label 3549: @183547
     /*  183547 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(183588), // Rule ID 891 //
     /*  183552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183569 */     // MIs[0] rs1
     /*  183569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183581 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183586 */     GIR_RootConstrainSelectedInstOperands,
     /*  183587 */     // GIR_Coverage, 891,
     /*  183587 */     GIR_Done,
     /*  183588 */   // Label 3550: @183588
     /*  183588 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(183629), // Rule ID 893 //
     /*  183593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183610 */     // MIs[0] rs1
     /*  183610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183622 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183627 */     GIR_RootConstrainSelectedInstOperands,
     /*  183628 */     // GIR_Coverage, 893,
     /*  183628 */     GIR_Done,
     /*  183629 */   // Label 3551: @183629
     /*  183629 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(183670), // Rule ID 895 //
     /*  183634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183651 */     // MIs[0] rs1
     /*  183651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183663 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183668 */     GIR_RootConstrainSelectedInstOperands,
     /*  183669 */     // GIR_Coverage, 895,
     /*  183669 */     GIR_Done,
     /*  183670 */   // Label 3552: @183670
     /*  183670 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(183711), // Rule ID 897 //
     /*  183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183692 */     // MIs[0] rs1
     /*  183692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183704 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183709 */     GIR_RootConstrainSelectedInstOperands,
     /*  183710 */     // GIR_Coverage, 897,
     /*  183710 */     GIR_Done,
     /*  183711 */   // Label 3553: @183711
     /*  183711 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(183752), // Rule ID 899 //
     /*  183716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183733 */     // MIs[0] rs1
     /*  183733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183745 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183750 */     GIR_RootConstrainSelectedInstOperands,
     /*  183751 */     // GIR_Coverage, 899,
     /*  183751 */     GIR_Done,
     /*  183752 */   // Label 3554: @183752
     /*  183752 */   GIM_Reject,
     /*  183753 */ // Label 3514: @183753
     /*  183753 */ GIM_Reject,
     /*  183754 */ // Label 3482: @183754
     /*  183754 */ GIM_Reject,
     /*  183755 */ // Label 27: @183755
     /*  183755 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3557*/ GIMT_Encode4(186664),
     /*  183766 */ /*GILLT_s32*//*Label 3555*/ GIMT_Encode4(183774),
     /*  183770 */ /*GILLT_s64*//*Label 3556*/ GIMT_Encode4(185014),
     /*  183774 */ // Label 3555: @183774
     /*  183774 */ GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(185013),
     /*  183779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  183782 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(183823), // Rule ID 374 //
     /*  183787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183797 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183804 */     // MIs[0] rs1
     /*  183804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183816 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183821 */     GIR_RootConstrainSelectedInstOperands,
     /*  183822 */     // GIR_Coverage, 374,
     /*  183822 */     GIR_Done,
     /*  183823 */   // Label 3559: @183823
     /*  183823 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(183864), // Rule ID 376 //
     /*  183828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183845 */     // MIs[0] rs1
     /*  183845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183857 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  183862 */     GIR_RootConstrainSelectedInstOperands,
     /*  183863 */     // GIR_Coverage, 376,
     /*  183863 */     GIR_Done,
     /*  183864 */   // Label 3560: @183864
     /*  183864 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(183905), // Rule ID 378 //
     /*  183869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183886 */     // MIs[0] rs1
     /*  183886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183898 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  183903 */     GIR_RootConstrainSelectedInstOperands,
     /*  183904 */     // GIR_Coverage, 378,
     /*  183904 */     GIR_Done,
     /*  183905 */   // Label 3561: @183905
     /*  183905 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183946), // Rule ID 380 //
     /*  183910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183927 */     // MIs[0] rs1
     /*  183927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183939 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183944 */     GIR_RootConstrainSelectedInstOperands,
     /*  183945 */     // GIR_Coverage, 380,
     /*  183945 */     GIR_Done,
     /*  183946 */   // Label 3562: @183946
     /*  183946 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183987), // Rule ID 382 //
     /*  183951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183968 */     // MIs[0] rs1
     /*  183968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183980 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183985 */     GIR_RootConstrainSelectedInstOperands,
     /*  183986 */     // GIR_Coverage, 382,
     /*  183986 */     GIR_Done,
     /*  183987 */   // Label 3563: @183987
     /*  183987 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(184028), // Rule ID 384 //
     /*  183992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184009 */     // MIs[0] rs1
     /*  184009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184021 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184026 */     GIR_RootConstrainSelectedInstOperands,
     /*  184027 */     // GIR_Coverage, 384,
     /*  184027 */     GIR_Done,
     /*  184028 */   // Label 3564: @184028
     /*  184028 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(184069), // Rule ID 386 //
     /*  184033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184050 */     // MIs[0] rs1
     /*  184050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184062 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184067 */     GIR_RootConstrainSelectedInstOperands,
     /*  184068 */     // GIR_Coverage, 386,
     /*  184068 */     GIR_Done,
     /*  184069 */   // Label 3565: @184069
     /*  184069 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(184110), // Rule ID 388 //
     /*  184074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184091 */     // MIs[0] rs1
     /*  184091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184103 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184108 */     GIR_RootConstrainSelectedInstOperands,
     /*  184109 */     // GIR_Coverage, 388,
     /*  184109 */     GIR_Done,
     /*  184110 */   // Label 3566: @184110
     /*  184110 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(184151), // Rule ID 390 //
     /*  184115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184132 */     // MIs[0] rs1
     /*  184132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184144 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184149 */     GIR_RootConstrainSelectedInstOperands,
     /*  184150 */     // GIR_Coverage, 390,
     /*  184150 */     GIR_Done,
     /*  184151 */   // Label 3567: @184151
     /*  184151 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(184192), // Rule ID 392 //
     /*  184156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184159 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184166 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184173 */     // MIs[0] rs1
     /*  184173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184185 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184190 */     GIR_RootConstrainSelectedInstOperands,
     /*  184191 */     // GIR_Coverage, 392,
     /*  184191 */     GIR_Done,
     /*  184192 */   // Label 3568: @184192
     /*  184192 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(184233), // Rule ID 722 //
     /*  184197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184214 */     // MIs[0] rs1
     /*  184214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184226 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184231 */     GIR_RootConstrainSelectedInstOperands,
     /*  184232 */     // GIR_Coverage, 722,
     /*  184232 */     GIR_Done,
     /*  184233 */   // Label 3569: @184233
     /*  184233 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(184274), // Rule ID 724 //
     /*  184238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184255 */     // MIs[0] rs1
     /*  184255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184267 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  184272 */     GIR_RootConstrainSelectedInstOperands,
     /*  184273 */     // GIR_Coverage, 724,
     /*  184273 */     GIR_Done,
     /*  184274 */   // Label 3570: @184274
     /*  184274 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(184315), // Rule ID 726 //
     /*  184279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184282 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184296 */     // MIs[0] rs1
     /*  184296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184308 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  184313 */     GIR_RootConstrainSelectedInstOperands,
     /*  184314 */     // GIR_Coverage, 726,
     /*  184314 */     GIR_Done,
     /*  184315 */   // Label 3571: @184315
     /*  184315 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(184356), // Rule ID 728 //
     /*  184320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184323 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184337 */     // MIs[0] rs1
     /*  184337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184349 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  184354 */     GIR_RootConstrainSelectedInstOperands,
     /*  184355 */     // GIR_Coverage, 728,
     /*  184355 */     GIR_Done,
     /*  184356 */   // Label 3572: @184356
     /*  184356 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184397), // Rule ID 730 //
     /*  184361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184364 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184378 */     // MIs[0] rs1
     /*  184378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184390 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  184395 */     GIR_RootConstrainSelectedInstOperands,
     /*  184396 */     // GIR_Coverage, 730,
     /*  184396 */     GIR_Done,
     /*  184397 */   // Label 3573: @184397
     /*  184397 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(184438), // Rule ID 732 //
     /*  184402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184405 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184419 */     // MIs[0] rs1
     /*  184419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184431 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184436 */     GIR_RootConstrainSelectedInstOperands,
     /*  184437 */     // GIR_Coverage, 732,
     /*  184437 */     GIR_Done,
     /*  184438 */   // Label 3574: @184438
     /*  184438 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(184479), // Rule ID 734 //
     /*  184443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184460 */     // MIs[0] rs1
     /*  184460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184472 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184477 */     GIR_RootConstrainSelectedInstOperands,
     /*  184478 */     // GIR_Coverage, 734,
     /*  184478 */     GIR_Done,
     /*  184479 */   // Label 3575: @184479
     /*  184479 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(184520), // Rule ID 736 //
     /*  184484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184487 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184494 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184501 */     // MIs[0] rs1
     /*  184501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184513 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184518 */     GIR_RootConstrainSelectedInstOperands,
     /*  184519 */     // GIR_Coverage, 736,
     /*  184519 */     GIR_Done,
     /*  184520 */   // Label 3576: @184520
     /*  184520 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(184561), // Rule ID 738 //
     /*  184525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184542 */     // MIs[0] rs1
     /*  184542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184554 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184559 */     GIR_RootConstrainSelectedInstOperands,
     /*  184560 */     // GIR_Coverage, 738,
     /*  184560 */     GIR_Done,
     /*  184561 */   // Label 3577: @184561
     /*  184561 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(184602), // Rule ID 740 //
     /*  184566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184583 */     // MIs[0] rs1
     /*  184583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184595 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184600 */     GIR_RootConstrainSelectedInstOperands,
     /*  184601 */     // GIR_Coverage, 740,
     /*  184601 */     GIR_Done,
     /*  184602 */   // Label 3578: @184602
     /*  184602 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(184643), // Rule ID 902 //
     /*  184607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184624 */     // MIs[0] rs1
     /*  184624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184636 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184641 */     GIR_RootConstrainSelectedInstOperands,
     /*  184642 */     // GIR_Coverage, 902,
     /*  184642 */     GIR_Done,
     /*  184643 */   // Label 3579: @184643
     /*  184643 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(184684), // Rule ID 904 //
     /*  184648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184658 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184665 */     // MIs[0] rs1
     /*  184665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184677 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  184682 */     GIR_RootConstrainSelectedInstOperands,
     /*  184683 */     // GIR_Coverage, 904,
     /*  184683 */     GIR_Done,
     /*  184684 */   // Label 3580: @184684
     /*  184684 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(184725), // Rule ID 906 //
     /*  184689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184699 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184706 */     // MIs[0] rs1
     /*  184706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184718 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  184723 */     GIR_RootConstrainSelectedInstOperands,
     /*  184724 */     // GIR_Coverage, 906,
     /*  184724 */     GIR_Done,
     /*  184725 */   // Label 3581: @184725
     /*  184725 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(184766), // Rule ID 908 //
     /*  184730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184747 */     // MIs[0] rs1
     /*  184747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184759 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184764 */     GIR_RootConstrainSelectedInstOperands,
     /*  184765 */     // GIR_Coverage, 908,
     /*  184765 */     GIR_Done,
     /*  184766 */   // Label 3582: @184766
     /*  184766 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(184807), // Rule ID 910 //
     /*  184771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184788 */     // MIs[0] rs1
     /*  184788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184800 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184805 */     GIR_RootConstrainSelectedInstOperands,
     /*  184806 */     // GIR_Coverage, 910,
     /*  184806 */     GIR_Done,
     /*  184807 */   // Label 3583: @184807
     /*  184807 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184848), // Rule ID 912 //
     /*  184812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184829 */     // MIs[0] rs1
     /*  184829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184841 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184846 */     GIR_RootConstrainSelectedInstOperands,
     /*  184847 */     // GIR_Coverage, 912,
     /*  184847 */     GIR_Done,
     /*  184848 */   // Label 3584: @184848
     /*  184848 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184889), // Rule ID 914 //
     /*  184853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184870 */     // MIs[0] rs1
     /*  184870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184882 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184887 */     GIR_RootConstrainSelectedInstOperands,
     /*  184888 */     // GIR_Coverage, 914,
     /*  184888 */     GIR_Done,
     /*  184889 */   // Label 3585: @184889
     /*  184889 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184930), // Rule ID 916 //
     /*  184894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184911 */     // MIs[0] rs1
     /*  184911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184923 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184928 */     GIR_RootConstrainSelectedInstOperands,
     /*  184929 */     // GIR_Coverage, 916,
     /*  184929 */     GIR_Done,
     /*  184930 */   // Label 3586: @184930
     /*  184930 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184971), // Rule ID 918 //
     /*  184935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184952 */     // MIs[0] rs1
     /*  184952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184964 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184969 */     GIR_RootConstrainSelectedInstOperands,
     /*  184970 */     // GIR_Coverage, 918,
     /*  184970 */     GIR_Done,
     /*  184971 */   // Label 3587: @184971
     /*  184971 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(185012), // Rule ID 920 //
     /*  184976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184979 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184986 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184993 */     // MIs[0] rs1
     /*  184993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185005 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185010 */     GIR_RootConstrainSelectedInstOperands,
     /*  185011 */     // GIR_Coverage, 920,
     /*  185011 */     GIR_Done,
     /*  185012 */   // Label 3588: @185012
     /*  185012 */   GIM_Reject,
     /*  185013 */ // Label 3558: @185013
     /*  185013 */ GIM_Reject,
     /*  185014 */ // Label 3556: @185014
     /*  185014 */ GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(186663),
     /*  185019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  185022 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(185063), // Rule ID 373 //
     /*  185027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185044 */     // MIs[0] rs1
     /*  185044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185056 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185061 */     GIR_RootConstrainSelectedInstOperands,
     /*  185062 */     // GIR_Coverage, 373,
     /*  185062 */     GIR_Done,
     /*  185063 */   // Label 3590: @185063
     /*  185063 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(185104), // Rule ID 375 //
     /*  185068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185085 */     // MIs[0] rs1
     /*  185085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185097 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  185102 */     GIR_RootConstrainSelectedInstOperands,
     /*  185103 */     // GIR_Coverage, 375,
     /*  185103 */     GIR_Done,
     /*  185104 */   // Label 3591: @185104
     /*  185104 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(185145), // Rule ID 377 //
     /*  185109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185126 */     // MIs[0] rs1
     /*  185126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185138 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  185143 */     GIR_RootConstrainSelectedInstOperands,
     /*  185144 */     // GIR_Coverage, 377,
     /*  185144 */     GIR_Done,
     /*  185145 */   // Label 3592: @185145
     /*  185145 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(185186), // Rule ID 379 //
     /*  185150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185167 */     // MIs[0] rs1
     /*  185167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185179 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  185184 */     GIR_RootConstrainSelectedInstOperands,
     /*  185185 */     // GIR_Coverage, 379,
     /*  185185 */     GIR_Done,
     /*  185186 */   // Label 3593: @185186
     /*  185186 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(185227), // Rule ID 381 //
     /*  185191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185208 */     // MIs[0] rs1
     /*  185208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185220 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  185225 */     GIR_RootConstrainSelectedInstOperands,
     /*  185226 */     // GIR_Coverage, 381,
     /*  185226 */     GIR_Done,
     /*  185227 */   // Label 3594: @185227
     /*  185227 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(185268), // Rule ID 383 //
     /*  185232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185249 */     // MIs[0] rs1
     /*  185249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185261 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185266 */     GIR_RootConstrainSelectedInstOperands,
     /*  185267 */     // GIR_Coverage, 383,
     /*  185267 */     GIR_Done,
     /*  185268 */   // Label 3595: @185268
     /*  185268 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(185309), // Rule ID 385 //
     /*  185273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185290 */     // MIs[0] rs1
     /*  185290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185302 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185307 */     GIR_RootConstrainSelectedInstOperands,
     /*  185308 */     // GIR_Coverage, 385,
     /*  185308 */     GIR_Done,
     /*  185309 */   // Label 3596: @185309
     /*  185309 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185350), // Rule ID 387 //
     /*  185314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185331 */     // MIs[0] rs1
     /*  185331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185343 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185348 */     GIR_RootConstrainSelectedInstOperands,
     /*  185349 */     // GIR_Coverage, 387,
     /*  185349 */     GIR_Done,
     /*  185350 */   // Label 3597: @185350
     /*  185350 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185391), // Rule ID 389 //
     /*  185355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185372 */     // MIs[0] rs1
     /*  185372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185384 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185389 */     GIR_RootConstrainSelectedInstOperands,
     /*  185390 */     // GIR_Coverage, 389,
     /*  185390 */     GIR_Done,
     /*  185391 */   // Label 3598: @185391
     /*  185391 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185432), // Rule ID 391 //
     /*  185396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185399 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185406 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185413 */     // MIs[0] rs1
     /*  185413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185425 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  185430 */     GIR_RootConstrainSelectedInstOperands,
     /*  185431 */     // GIR_Coverage, 391,
     /*  185431 */     GIR_Done,
     /*  185432 */   // Label 3599: @185432
     /*  185432 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185473), // Rule ID 543 //
     /*  185437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185454 */     // MIs[0] rs1
     /*  185454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185466 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185471 */     GIR_RootConstrainSelectedInstOperands,
     /*  185472 */     // GIR_Coverage, 543,
     /*  185472 */     GIR_Done,
     /*  185473 */   // Label 3600: @185473
     /*  185473 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(185514), // Rule ID 544 //
     /*  185478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185481 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185488 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185495 */     // MIs[0] rs1
     /*  185495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185507 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  185512 */     GIR_RootConstrainSelectedInstOperands,
     /*  185513 */     // GIR_Coverage, 544,
     /*  185513 */     GIR_Done,
     /*  185514 */   // Label 3601: @185514
     /*  185514 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(185555), // Rule ID 545 //
     /*  185519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185536 */     // MIs[0] rs1
     /*  185536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185548 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  185553 */     GIR_RootConstrainSelectedInstOperands,
     /*  185554 */     // GIR_Coverage, 545,
     /*  185554 */     GIR_Done,
     /*  185555 */   // Label 3602: @185555
     /*  185555 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(185596), // Rule ID 546 //
     /*  185560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185577 */     // MIs[0] rs1
     /*  185577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185589 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185594 */     GIR_RootConstrainSelectedInstOperands,
     /*  185595 */     // GIR_Coverage, 546,
     /*  185595 */     GIR_Done,
     /*  185596 */   // Label 3603: @185596
     /*  185596 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(185637), // Rule ID 547 //
     /*  185601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185618 */     // MIs[0] rs1
     /*  185618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185630 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185635 */     GIR_RootConstrainSelectedInstOperands,
     /*  185636 */     // GIR_Coverage, 547,
     /*  185636 */     GIR_Done,
     /*  185637 */   // Label 3604: @185637
     /*  185637 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(185678), // Rule ID 548 //
     /*  185642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185659 */     // MIs[0] rs1
     /*  185659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185671 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185676 */     GIR_RootConstrainSelectedInstOperands,
     /*  185677 */     // GIR_Coverage, 548,
     /*  185677 */     GIR_Done,
     /*  185678 */   // Label 3605: @185678
     /*  185678 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(185719), // Rule ID 549 //
     /*  185683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185700 */     // MIs[0] rs1
     /*  185700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185712 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185717 */     GIR_RootConstrainSelectedInstOperands,
     /*  185718 */     // GIR_Coverage, 549,
     /*  185718 */     GIR_Done,
     /*  185719 */   // Label 3606: @185719
     /*  185719 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(185760), // Rule ID 550 //
     /*  185724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185741 */     // MIs[0] rs1
     /*  185741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185753 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185758 */     GIR_RootConstrainSelectedInstOperands,
     /*  185759 */     // GIR_Coverage, 550,
     /*  185759 */     GIR_Done,
     /*  185760 */   // Label 3607: @185760
     /*  185760 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(185801), // Rule ID 551 //
     /*  185765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185782 */     // MIs[0] rs1
     /*  185782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185794 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185799 */     GIR_RootConstrainSelectedInstOperands,
     /*  185800 */     // GIR_Coverage, 551,
     /*  185800 */     GIR_Done,
     /*  185801 */   // Label 3608: @185801
     /*  185801 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(185842), // Rule ID 552 //
     /*  185806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185823 */     // MIs[0] rs1
     /*  185823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185835 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185840 */     GIR_RootConstrainSelectedInstOperands,
     /*  185841 */     // GIR_Coverage, 552,
     /*  185841 */     GIR_Done,
     /*  185842 */   // Label 3609: @185842
     /*  185842 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185883), // Rule ID 721 //
     /*  185847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185864 */     // MIs[0] rs1
     /*  185864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185876 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185881 */     GIR_RootConstrainSelectedInstOperands,
     /*  185882 */     // GIR_Coverage, 721,
     /*  185882 */     GIR_Done,
     /*  185883 */   // Label 3610: @185883
     /*  185883 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185924), // Rule ID 723 //
     /*  185888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185905 */     // MIs[0] rs1
     /*  185905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185917 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  185922 */     GIR_RootConstrainSelectedInstOperands,
     /*  185923 */     // GIR_Coverage, 723,
     /*  185923 */     GIR_Done,
     /*  185924 */   // Label 3611: @185924
     /*  185924 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185965), // Rule ID 725 //
     /*  185929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185946 */     // MIs[0] rs1
     /*  185946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185958 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  185963 */     GIR_RootConstrainSelectedInstOperands,
     /*  185964 */     // GIR_Coverage, 725,
     /*  185964 */     GIR_Done,
     /*  185965 */   // Label 3612: @185965
     /*  185965 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(186006), // Rule ID 727 //
     /*  185970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185987 */     // MIs[0] rs1
     /*  185987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185999 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  186004 */     GIR_RootConstrainSelectedInstOperands,
     /*  186005 */     // GIR_Coverage, 727,
     /*  186005 */     GIR_Done,
     /*  186006 */   // Label 3613: @186006
     /*  186006 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(186047), // Rule ID 729 //
     /*  186011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186028 */     // MIs[0] rs1
     /*  186028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186040 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  186045 */     GIR_RootConstrainSelectedInstOperands,
     /*  186046 */     // GIR_Coverage, 729,
     /*  186046 */     GIR_Done,
     /*  186047 */   // Label 3614: @186047
     /*  186047 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(186088), // Rule ID 731 //
     /*  186052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186069 */     // MIs[0] rs1
     /*  186069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186081 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186086 */     GIR_RootConstrainSelectedInstOperands,
     /*  186087 */     // GIR_Coverage, 731,
     /*  186087 */     GIR_Done,
     /*  186088 */   // Label 3615: @186088
     /*  186088 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(186129), // Rule ID 733 //
     /*  186093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186110 */     // MIs[0] rs1
     /*  186110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186122 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186127 */     GIR_RootConstrainSelectedInstOperands,
     /*  186128 */     // GIR_Coverage, 733,
     /*  186128 */     GIR_Done,
     /*  186129 */   // Label 3616: @186129
     /*  186129 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(186170), // Rule ID 735 //
     /*  186134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186151 */     // MIs[0] rs1
     /*  186151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186163 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186168 */     GIR_RootConstrainSelectedInstOperands,
     /*  186169 */     // GIR_Coverage, 735,
     /*  186169 */     GIR_Done,
     /*  186170 */   // Label 3617: @186170
     /*  186170 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(186211), // Rule ID 737 //
     /*  186175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186192 */     // MIs[0] rs1
     /*  186192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186204 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186209 */     GIR_RootConstrainSelectedInstOperands,
     /*  186210 */     // GIR_Coverage, 737,
     /*  186210 */     GIR_Done,
     /*  186211 */   // Label 3618: @186211
     /*  186211 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(186252), // Rule ID 739 //
     /*  186216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186233 */     // MIs[0] rs1
     /*  186233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186245 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  186250 */     GIR_RootConstrainSelectedInstOperands,
     /*  186251 */     // GIR_Coverage, 739,
     /*  186251 */     GIR_Done,
     /*  186252 */   // Label 3619: @186252
     /*  186252 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(186293), // Rule ID 901 //
     /*  186257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186274 */     // MIs[0] rs1
     /*  186274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186286 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186291 */     GIR_RootConstrainSelectedInstOperands,
     /*  186292 */     // GIR_Coverage, 901,
     /*  186292 */     GIR_Done,
     /*  186293 */   // Label 3620: @186293
     /*  186293 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(186334), // Rule ID 903 //
     /*  186298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186315 */     // MIs[0] rs1
     /*  186315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186327 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  186332 */     GIR_RootConstrainSelectedInstOperands,
     /*  186333 */     // GIR_Coverage, 903,
     /*  186333 */     GIR_Done,
     /*  186334 */   // Label 3621: @186334
     /*  186334 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(186375), // Rule ID 905 //
     /*  186339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186356 */     // MIs[0] rs1
     /*  186356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186368 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  186373 */     GIR_RootConstrainSelectedInstOperands,
     /*  186374 */     // GIR_Coverage, 905,
     /*  186374 */     GIR_Done,
     /*  186375 */   // Label 3622: @186375
     /*  186375 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186416), // Rule ID 907 //
     /*  186380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186397 */     // MIs[0] rs1
     /*  186397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186409 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  186414 */     GIR_RootConstrainSelectedInstOperands,
     /*  186415 */     // GIR_Coverage, 907,
     /*  186415 */     GIR_Done,
     /*  186416 */   // Label 3623: @186416
     /*  186416 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(186457), // Rule ID 909 //
     /*  186421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186438 */     // MIs[0] rs1
     /*  186438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186450 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  186455 */     GIR_RootConstrainSelectedInstOperands,
     /*  186456 */     // GIR_Coverage, 909,
     /*  186456 */     GIR_Done,
     /*  186457 */   // Label 3624: @186457
     /*  186457 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(186498), // Rule ID 911 //
     /*  186462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186479 */     // MIs[0] rs1
     /*  186479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186491 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186496 */     GIR_RootConstrainSelectedInstOperands,
     /*  186497 */     // GIR_Coverage, 911,
     /*  186497 */     GIR_Done,
     /*  186498 */   // Label 3625: @186498
     /*  186498 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(186539), // Rule ID 913 //
     /*  186503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186520 */     // MIs[0] rs1
     /*  186520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186532 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186537 */     GIR_RootConstrainSelectedInstOperands,
     /*  186538 */     // GIR_Coverage, 913,
     /*  186538 */     GIR_Done,
     /*  186539 */   // Label 3626: @186539
     /*  186539 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(186580), // Rule ID 915 //
     /*  186544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186561 */     // MIs[0] rs1
     /*  186561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186573 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186578 */     GIR_RootConstrainSelectedInstOperands,
     /*  186579 */     // GIR_Coverage, 915,
     /*  186579 */     GIR_Done,
     /*  186580 */   // Label 3627: @186580
     /*  186580 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(186621), // Rule ID 917 //
     /*  186585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186602 */     // MIs[0] rs1
     /*  186602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186614 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186619 */     GIR_RootConstrainSelectedInstOperands,
     /*  186620 */     // GIR_Coverage, 917,
     /*  186620 */     GIR_Done,
     /*  186621 */   // Label 3628: @186621
     /*  186621 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(186662), // Rule ID 919 //
     /*  186626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186643 */     // MIs[0] rs1
     /*  186643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186655 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186660 */     GIR_RootConstrainSelectedInstOperands,
     /*  186661 */     // GIR_Coverage, 919,
     /*  186661 */     GIR_Done,
     /*  186662 */   // Label 3629: @186662
     /*  186662 */   GIM_Reject,
     /*  186663 */ // Label 3589: @186663
     /*  186663 */ GIM_Reject,
     /*  186664 */ // Label 3557: @186664
     /*  186664 */ GIM_Reject,
     /*  186665 */ // Label 28: @186665
     /*  186665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3632*/ GIMT_Encode4(189574),
     /*  186676 */ /*GILLT_s32*//*Label 3630*/ GIMT_Encode4(186684),
     /*  186680 */ /*GILLT_s64*//*Label 3631*/ GIMT_Encode4(187924),
     /*  186684 */ // Label 3630: @186684
     /*  186684 */ GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(187923),
     /*  186689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  186692 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186733), // Rule ID 394 //
     /*  186697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186714 */     // MIs[0] rs1
     /*  186714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186726 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186731 */     GIR_RootConstrainSelectedInstOperands,
     /*  186732 */     // GIR_Coverage, 394,
     /*  186732 */     GIR_Done,
     /*  186733 */   // Label 3634: @186733
     /*  186733 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186774), // Rule ID 396 //
     /*  186738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186755 */     // MIs[0] rs1
     /*  186755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186767 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  186772 */     GIR_RootConstrainSelectedInstOperands,
     /*  186773 */     // GIR_Coverage, 396,
     /*  186773 */     GIR_Done,
     /*  186774 */   // Label 3635: @186774
     /*  186774 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186815), // Rule ID 398 //
     /*  186779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186796 */     // MIs[0] rs1
     /*  186796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186808 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  186813 */     GIR_RootConstrainSelectedInstOperands,
     /*  186814 */     // GIR_Coverage, 398,
     /*  186814 */     GIR_Done,
     /*  186815 */   // Label 3636: @186815
     /*  186815 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186856), // Rule ID 400 //
     /*  186820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186837 */     // MIs[0] rs1
     /*  186837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186849 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186854 */     GIR_RootConstrainSelectedInstOperands,
     /*  186855 */     // GIR_Coverage, 400,
     /*  186855 */     GIR_Done,
     /*  186856 */   // Label 3637: @186856
     /*  186856 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186897), // Rule ID 402 //
     /*  186861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186878 */     // MIs[0] rs1
     /*  186878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186890 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186895 */     GIR_RootConstrainSelectedInstOperands,
     /*  186896 */     // GIR_Coverage, 402,
     /*  186896 */     GIR_Done,
     /*  186897 */   // Label 3638: @186897
     /*  186897 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186938), // Rule ID 404 //
     /*  186902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186919 */     // MIs[0] rs1
     /*  186919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186931 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186936 */     GIR_RootConstrainSelectedInstOperands,
     /*  186937 */     // GIR_Coverage, 404,
     /*  186937 */     GIR_Done,
     /*  186938 */   // Label 3639: @186938
     /*  186938 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186979), // Rule ID 406 //
     /*  186943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186960 */     // MIs[0] rs1
     /*  186960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186972 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186977 */     GIR_RootConstrainSelectedInstOperands,
     /*  186978 */     // GIR_Coverage, 406,
     /*  186978 */     GIR_Done,
     /*  186979 */   // Label 3640: @186979
     /*  186979 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(187020), // Rule ID 408 //
     /*  186984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187001 */     // MIs[0] rs1
     /*  187001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187013 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187018 */     GIR_RootConstrainSelectedInstOperands,
     /*  187019 */     // GIR_Coverage, 408,
     /*  187019 */     GIR_Done,
     /*  187020 */   // Label 3641: @187020
     /*  187020 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(187061), // Rule ID 410 //
     /*  187025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187042 */     // MIs[0] rs1
     /*  187042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187054 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187059 */     GIR_RootConstrainSelectedInstOperands,
     /*  187060 */     // GIR_Coverage, 410,
     /*  187060 */     GIR_Done,
     /*  187061 */   // Label 3642: @187061
     /*  187061 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(187102), // Rule ID 412 //
     /*  187066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187076 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187083 */     // MIs[0] rs1
     /*  187083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187095 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187100 */     GIR_RootConstrainSelectedInstOperands,
     /*  187101 */     // GIR_Coverage, 412,
     /*  187101 */     GIR_Done,
     /*  187102 */   // Label 3643: @187102
     /*  187102 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(187143), // Rule ID 742 //
     /*  187107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187110 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187117 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187124 */     // MIs[0] rs1
     /*  187124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187136 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187141 */     GIR_RootConstrainSelectedInstOperands,
     /*  187142 */     // GIR_Coverage, 742,
     /*  187142 */     GIR_Done,
     /*  187143 */   // Label 3644: @187143
     /*  187143 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(187184), // Rule ID 744 //
     /*  187148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187165 */     // MIs[0] rs1
     /*  187165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187177 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  187182 */     GIR_RootConstrainSelectedInstOperands,
     /*  187183 */     // GIR_Coverage, 744,
     /*  187183 */     GIR_Done,
     /*  187184 */   // Label 3645: @187184
     /*  187184 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(187225), // Rule ID 746 //
     /*  187189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187192 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187199 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187206 */     // MIs[0] rs1
     /*  187206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187218 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  187223 */     GIR_RootConstrainSelectedInstOperands,
     /*  187224 */     // GIR_Coverage, 746,
     /*  187224 */     GIR_Done,
     /*  187225 */   // Label 3646: @187225
     /*  187225 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(187266), // Rule ID 748 //
     /*  187230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187247 */     // MIs[0] rs1
     /*  187247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187259 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187264 */     GIR_RootConstrainSelectedInstOperands,
     /*  187265 */     // GIR_Coverage, 748,
     /*  187265 */     GIR_Done,
     /*  187266 */   // Label 3647: @187266
     /*  187266 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(187307), // Rule ID 750 //
     /*  187271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187274 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187281 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187288 */     // MIs[0] rs1
     /*  187288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187300 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187305 */     GIR_RootConstrainSelectedInstOperands,
     /*  187306 */     // GIR_Coverage, 750,
     /*  187306 */     GIR_Done,
     /*  187307 */   // Label 3648: @187307
     /*  187307 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(187348), // Rule ID 752 //
     /*  187312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187315 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187329 */     // MIs[0] rs1
     /*  187329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187341 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187346 */     GIR_RootConstrainSelectedInstOperands,
     /*  187347 */     // GIR_Coverage, 752,
     /*  187347 */     GIR_Done,
     /*  187348 */   // Label 3649: @187348
     /*  187348 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187389), // Rule ID 754 //
     /*  187353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187356 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187370 */     // MIs[0] rs1
     /*  187370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187382 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187387 */     GIR_RootConstrainSelectedInstOperands,
     /*  187388 */     // GIR_Coverage, 754,
     /*  187388 */     GIR_Done,
     /*  187389 */   // Label 3650: @187389
     /*  187389 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(187430), // Rule ID 756 //
     /*  187394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187397 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187404 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187411 */     // MIs[0] rs1
     /*  187411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187423 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187428 */     GIR_RootConstrainSelectedInstOperands,
     /*  187429 */     // GIR_Coverage, 756,
     /*  187429 */     GIR_Done,
     /*  187430 */   // Label 3651: @187430
     /*  187430 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(187471), // Rule ID 758 //
     /*  187435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187438 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187445 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187452 */     // MIs[0] rs1
     /*  187452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187464 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187469 */     GIR_RootConstrainSelectedInstOperands,
     /*  187470 */     // GIR_Coverage, 758,
     /*  187470 */     GIR_Done,
     /*  187471 */   // Label 3652: @187471
     /*  187471 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(187512), // Rule ID 760 //
     /*  187476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187479 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187486 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187493 */     // MIs[0] rs1
     /*  187493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187505 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187510 */     GIR_RootConstrainSelectedInstOperands,
     /*  187511 */     // GIR_Coverage, 760,
     /*  187511 */     GIR_Done,
     /*  187512 */   // Label 3653: @187512
     /*  187512 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(187553), // Rule ID 922 //
     /*  187517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187527 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187534 */     // MIs[0] rs1
     /*  187534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187546 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187551 */     GIR_RootConstrainSelectedInstOperands,
     /*  187552 */     // GIR_Coverage, 922,
     /*  187552 */     GIR_Done,
     /*  187553 */   // Label 3654: @187553
     /*  187553 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(187594), // Rule ID 924 //
     /*  187558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187568 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187575 */     // MIs[0] rs1
     /*  187575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187587 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  187592 */     GIR_RootConstrainSelectedInstOperands,
     /*  187593 */     // GIR_Coverage, 924,
     /*  187593 */     GIR_Done,
     /*  187594 */   // Label 3655: @187594
     /*  187594 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187635), // Rule ID 926 //
     /*  187599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187616 */     // MIs[0] rs1
     /*  187616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187628 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  187633 */     GIR_RootConstrainSelectedInstOperands,
     /*  187634 */     // GIR_Coverage, 926,
     /*  187634 */     GIR_Done,
     /*  187635 */   // Label 3656: @187635
     /*  187635 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187676), // Rule ID 928 //
     /*  187640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187657 */     // MIs[0] rs1
     /*  187657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187669 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187674 */     GIR_RootConstrainSelectedInstOperands,
     /*  187675 */     // GIR_Coverage, 928,
     /*  187675 */     GIR_Done,
     /*  187676 */   // Label 3657: @187676
     /*  187676 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(187717), // Rule ID 930 //
     /*  187681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187698 */     // MIs[0] rs1
     /*  187698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187710 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187715 */     GIR_RootConstrainSelectedInstOperands,
     /*  187716 */     // GIR_Coverage, 930,
     /*  187716 */     GIR_Done,
     /*  187717 */   // Label 3658: @187717
     /*  187717 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187758), // Rule ID 932 //
     /*  187722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187739 */     // MIs[0] rs1
     /*  187739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187751 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187756 */     GIR_RootConstrainSelectedInstOperands,
     /*  187757 */     // GIR_Coverage, 932,
     /*  187757 */     GIR_Done,
     /*  187758 */   // Label 3659: @187758
     /*  187758 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187799), // Rule ID 934 //
     /*  187763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187780 */     // MIs[0] rs1
     /*  187780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187792 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187797 */     GIR_RootConstrainSelectedInstOperands,
     /*  187798 */     // GIR_Coverage, 934,
     /*  187798 */     GIR_Done,
     /*  187799 */   // Label 3660: @187799
     /*  187799 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187840), // Rule ID 936 //
     /*  187804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187821 */     // MIs[0] rs1
     /*  187821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187833 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187838 */     GIR_RootConstrainSelectedInstOperands,
     /*  187839 */     // GIR_Coverage, 936,
     /*  187839 */     GIR_Done,
     /*  187840 */   // Label 3661: @187840
     /*  187840 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187881), // Rule ID 938 //
     /*  187845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187862 */     // MIs[0] rs1
     /*  187862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187874 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187879 */     GIR_RootConstrainSelectedInstOperands,
     /*  187880 */     // GIR_Coverage, 938,
     /*  187880 */     GIR_Done,
     /*  187881 */   // Label 3662: @187881
     /*  187881 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187922), // Rule ID 940 //
     /*  187886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187889 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187896 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187903 */     // MIs[0] rs1
     /*  187903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187915 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187920 */     GIR_RootConstrainSelectedInstOperands,
     /*  187921 */     // GIR_Coverage, 940,
     /*  187921 */     GIR_Done,
     /*  187922 */   // Label 3663: @187922
     /*  187922 */   GIM_Reject,
     /*  187923 */ // Label 3633: @187923
     /*  187923 */ GIM_Reject,
     /*  187924 */ // Label 3631: @187924
     /*  187924 */ GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(189573),
     /*  187929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  187932 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187973), // Rule ID 393 //
     /*  187937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187954 */     // MIs[0] rs1
     /*  187954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187966 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187971 */     GIR_RootConstrainSelectedInstOperands,
     /*  187972 */     // GIR_Coverage, 393,
     /*  187972 */     GIR_Done,
     /*  187973 */   // Label 3665: @187973
     /*  187973 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(188014), // Rule ID 395 //
     /*  187978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187995 */     // MIs[0] rs1
     /*  187995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188007 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  188012 */     GIR_RootConstrainSelectedInstOperands,
     /*  188013 */     // GIR_Coverage, 395,
     /*  188013 */     GIR_Done,
     /*  188014 */   // Label 3666: @188014
     /*  188014 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(188055), // Rule ID 397 //
     /*  188019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188036 */     // MIs[0] rs1
     /*  188036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188048 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  188053 */     GIR_RootConstrainSelectedInstOperands,
     /*  188054 */     // GIR_Coverage, 397,
     /*  188054 */     GIR_Done,
     /*  188055 */   // Label 3667: @188055
     /*  188055 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(188096), // Rule ID 399 //
     /*  188060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188077 */     // MIs[0] rs1
     /*  188077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188089 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  188094 */     GIR_RootConstrainSelectedInstOperands,
     /*  188095 */     // GIR_Coverage, 399,
     /*  188095 */     GIR_Done,
     /*  188096 */   // Label 3668: @188096
     /*  188096 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(188137), // Rule ID 401 //
     /*  188101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188118 */     // MIs[0] rs1
     /*  188118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188130 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  188135 */     GIR_RootConstrainSelectedInstOperands,
     /*  188136 */     // GIR_Coverage, 401,
     /*  188136 */     GIR_Done,
     /*  188137 */   // Label 3669: @188137
     /*  188137 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(188178), // Rule ID 403 //
     /*  188142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188159 */     // MIs[0] rs1
     /*  188159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188171 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188176 */     GIR_RootConstrainSelectedInstOperands,
     /*  188177 */     // GIR_Coverage, 403,
     /*  188177 */     GIR_Done,
     /*  188178 */   // Label 3670: @188178
     /*  188178 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(188219), // Rule ID 405 //
     /*  188183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188200 */     // MIs[0] rs1
     /*  188200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188212 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188217 */     GIR_RootConstrainSelectedInstOperands,
     /*  188218 */     // GIR_Coverage, 405,
     /*  188218 */     GIR_Done,
     /*  188219 */   // Label 3671: @188219
     /*  188219 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(188260), // Rule ID 407 //
     /*  188224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188241 */     // MIs[0] rs1
     /*  188241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188253 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188258 */     GIR_RootConstrainSelectedInstOperands,
     /*  188259 */     // GIR_Coverage, 407,
     /*  188259 */     GIR_Done,
     /*  188260 */   // Label 3672: @188260
     /*  188260 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(188301), // Rule ID 409 //
     /*  188265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188282 */     // MIs[0] rs1
     /*  188282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188294 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188299 */     GIR_RootConstrainSelectedInstOperands,
     /*  188300 */     // GIR_Coverage, 409,
     /*  188300 */     GIR_Done,
     /*  188301 */   // Label 3673: @188301
     /*  188301 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(188342), // Rule ID 411 //
     /*  188306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188323 */     // MIs[0] rs1
     /*  188323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188335 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  188340 */     GIR_RootConstrainSelectedInstOperands,
     /*  188341 */     // GIR_Coverage, 411,
     /*  188341 */     GIR_Done,
     /*  188342 */   // Label 3674: @188342
     /*  188342 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(188383), // Rule ID 553 //
     /*  188347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188364 */     // MIs[0] rs1
     /*  188364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188376 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188381 */     GIR_RootConstrainSelectedInstOperands,
     /*  188382 */     // GIR_Coverage, 553,
     /*  188382 */     GIR_Done,
     /*  188383 */   // Label 3675: @188383
     /*  188383 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(188424), // Rule ID 554 //
     /*  188388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188405 */     // MIs[0] rs1
     /*  188405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188417 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  188422 */     GIR_RootConstrainSelectedInstOperands,
     /*  188423 */     // GIR_Coverage, 554,
     /*  188423 */     GIR_Done,
     /*  188424 */   // Label 3676: @188424
     /*  188424 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(188465), // Rule ID 555 //
     /*  188429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188446 */     // MIs[0] rs1
     /*  188446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188458 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  188463 */     GIR_RootConstrainSelectedInstOperands,
     /*  188464 */     // GIR_Coverage, 555,
     /*  188464 */     GIR_Done,
     /*  188465 */   // Label 3677: @188465
     /*  188465 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(188506), // Rule ID 556 //
     /*  188470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188487 */     // MIs[0] rs1
     /*  188487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188499 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188504 */     GIR_RootConstrainSelectedInstOperands,
     /*  188505 */     // GIR_Coverage, 556,
     /*  188505 */     GIR_Done,
     /*  188506 */   // Label 3678: @188506
     /*  188506 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(188547), // Rule ID 557 //
     /*  188511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188528 */     // MIs[0] rs1
     /*  188528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188540 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188545 */     GIR_RootConstrainSelectedInstOperands,
     /*  188546 */     // GIR_Coverage, 557,
     /*  188546 */     GIR_Done,
     /*  188547 */   // Label 3679: @188547
     /*  188547 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(188588), // Rule ID 558 //
     /*  188552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188569 */     // MIs[0] rs1
     /*  188569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188581 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188586 */     GIR_RootConstrainSelectedInstOperands,
     /*  188587 */     // GIR_Coverage, 558,
     /*  188587 */     GIR_Done,
     /*  188588 */   // Label 3680: @188588
     /*  188588 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(188629), // Rule ID 559 //
     /*  188593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188610 */     // MIs[0] rs1
     /*  188610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188622 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188627 */     GIR_RootConstrainSelectedInstOperands,
     /*  188628 */     // GIR_Coverage, 559,
     /*  188628 */     GIR_Done,
     /*  188629 */   // Label 3681: @188629
     /*  188629 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188670), // Rule ID 560 //
     /*  188634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188651 */     // MIs[0] rs1
     /*  188651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188663 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188668 */     GIR_RootConstrainSelectedInstOperands,
     /*  188669 */     // GIR_Coverage, 560,
     /*  188669 */     GIR_Done,
     /*  188670 */   // Label 3682: @188670
     /*  188670 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188711), // Rule ID 561 //
     /*  188675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188692 */     // MIs[0] rs1
     /*  188692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188704 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188709 */     GIR_RootConstrainSelectedInstOperands,
     /*  188710 */     // GIR_Coverage, 561,
     /*  188710 */     GIR_Done,
     /*  188711 */   // Label 3683: @188711
     /*  188711 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188752), // Rule ID 562 //
     /*  188716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188733 */     // MIs[0] rs1
     /*  188733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188745 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188750 */     GIR_RootConstrainSelectedInstOperands,
     /*  188751 */     // GIR_Coverage, 562,
     /*  188751 */     GIR_Done,
     /*  188752 */   // Label 3684: @188752
     /*  188752 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188793), // Rule ID 741 //
     /*  188757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188774 */     // MIs[0] rs1
     /*  188774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188786 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188791 */     GIR_RootConstrainSelectedInstOperands,
     /*  188792 */     // GIR_Coverage, 741,
     /*  188792 */     GIR_Done,
     /*  188793 */   // Label 3685: @188793
     /*  188793 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188834), // Rule ID 743 //
     /*  188798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188815 */     // MIs[0] rs1
     /*  188815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188827 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  188832 */     GIR_RootConstrainSelectedInstOperands,
     /*  188833 */     // GIR_Coverage, 743,
     /*  188833 */     GIR_Done,
     /*  188834 */   // Label 3686: @188834
     /*  188834 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188875), // Rule ID 745 //
     /*  188839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188856 */     // MIs[0] rs1
     /*  188856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188868 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  188873 */     GIR_RootConstrainSelectedInstOperands,
     /*  188874 */     // GIR_Coverage, 745,
     /*  188874 */     GIR_Done,
     /*  188875 */   // Label 3687: @188875
     /*  188875 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188916), // Rule ID 747 //
     /*  188880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188897 */     // MIs[0] rs1
     /*  188897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188909 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188914 */     GIR_RootConstrainSelectedInstOperands,
     /*  188915 */     // GIR_Coverage, 747,
     /*  188915 */     GIR_Done,
     /*  188916 */   // Label 3688: @188916
     /*  188916 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188957), // Rule ID 749 //
     /*  188921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188938 */     // MIs[0] rs1
     /*  188938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188950 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188955 */     GIR_RootConstrainSelectedInstOperands,
     /*  188956 */     // GIR_Coverage, 749,
     /*  188956 */     GIR_Done,
     /*  188957 */   // Label 3689: @188957
     /*  188957 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188998), // Rule ID 751 //
     /*  188962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188979 */     // MIs[0] rs1
     /*  188979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188991 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188996 */     GIR_RootConstrainSelectedInstOperands,
     /*  188997 */     // GIR_Coverage, 751,
     /*  188997 */     GIR_Done,
     /*  188998 */   // Label 3690: @188998
     /*  188998 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(189039), // Rule ID 753 //
     /*  189003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189020 */     // MIs[0] rs1
     /*  189020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189032 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189037 */     GIR_RootConstrainSelectedInstOperands,
     /*  189038 */     // GIR_Coverage, 753,
     /*  189038 */     GIR_Done,
     /*  189039 */   // Label 3691: @189039
     /*  189039 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(189080), // Rule ID 755 //
     /*  189044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189061 */     // MIs[0] rs1
     /*  189061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189073 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189078 */     GIR_RootConstrainSelectedInstOperands,
     /*  189079 */     // GIR_Coverage, 755,
     /*  189079 */     GIR_Done,
     /*  189080 */   // Label 3692: @189080
     /*  189080 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(189121), // Rule ID 757 //
     /*  189085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189102 */     // MIs[0] rs1
     /*  189102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189114 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189119 */     GIR_RootConstrainSelectedInstOperands,
     /*  189120 */     // GIR_Coverage, 757,
     /*  189120 */     GIR_Done,
     /*  189121 */   // Label 3693: @189121
     /*  189121 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(189162), // Rule ID 759 //
     /*  189126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189143 */     // MIs[0] rs1
     /*  189143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189155 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  189160 */     GIR_RootConstrainSelectedInstOperands,
     /*  189161 */     // GIR_Coverage, 759,
     /*  189161 */     GIR_Done,
     /*  189162 */   // Label 3694: @189162
     /*  189162 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(189203), // Rule ID 921 //
     /*  189167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189184 */     // MIs[0] rs1
     /*  189184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189196 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189201 */     GIR_RootConstrainSelectedInstOperands,
     /*  189202 */     // GIR_Coverage, 921,
     /*  189202 */     GIR_Done,
     /*  189203 */   // Label 3695: @189203
     /*  189203 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(189244), // Rule ID 923 //
     /*  189208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189218 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189225 */     // MIs[0] rs1
     /*  189225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189237 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  189242 */     GIR_RootConstrainSelectedInstOperands,
     /*  189243 */     // GIR_Coverage, 923,
     /*  189243 */     GIR_Done,
     /*  189244 */   // Label 3696: @189244
     /*  189244 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(189285), // Rule ID 925 //
     /*  189249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189266 */     // MIs[0] rs1
     /*  189266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189278 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  189283 */     GIR_RootConstrainSelectedInstOperands,
     /*  189284 */     // GIR_Coverage, 925,
     /*  189284 */     GIR_Done,
     /*  189285 */   // Label 3697: @189285
     /*  189285 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(189326), // Rule ID 927 //
     /*  189290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189307 */     // MIs[0] rs1
     /*  189307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189319 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  189324 */     GIR_RootConstrainSelectedInstOperands,
     /*  189325 */     // GIR_Coverage, 927,
     /*  189325 */     GIR_Done,
     /*  189326 */   // Label 3698: @189326
     /*  189326 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(189367), // Rule ID 929 //
     /*  189331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189348 */     // MIs[0] rs1
     /*  189348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189360 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  189365 */     GIR_RootConstrainSelectedInstOperands,
     /*  189366 */     // GIR_Coverage, 929,
     /*  189366 */     GIR_Done,
     /*  189367 */   // Label 3699: @189367
     /*  189367 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(189408), // Rule ID 931 //
     /*  189372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189389 */     // MIs[0] rs1
     /*  189389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189401 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189406 */     GIR_RootConstrainSelectedInstOperands,
     /*  189407 */     // GIR_Coverage, 931,
     /*  189407 */     GIR_Done,
     /*  189408 */   // Label 3700: @189408
     /*  189408 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(189449), // Rule ID 933 //
     /*  189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189430 */     // MIs[0] rs1
     /*  189430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189442 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189447 */     GIR_RootConstrainSelectedInstOperands,
     /*  189448 */     // GIR_Coverage, 933,
     /*  189448 */     GIR_Done,
     /*  189449 */   // Label 3701: @189449
     /*  189449 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(189490), // Rule ID 935 //
     /*  189454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189471 */     // MIs[0] rs1
     /*  189471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189483 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189488 */     GIR_RootConstrainSelectedInstOperands,
     /*  189489 */     // GIR_Coverage, 935,
     /*  189489 */     GIR_Done,
     /*  189490 */   // Label 3702: @189490
     /*  189490 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(189531), // Rule ID 937 //
     /*  189495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189512 */     // MIs[0] rs1
     /*  189512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189524 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189529 */     GIR_RootConstrainSelectedInstOperands,
     /*  189530 */     // GIR_Coverage, 937,
     /*  189530 */     GIR_Done,
     /*  189531 */   // Label 3703: @189531
     /*  189531 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(189572), // Rule ID 939 //
     /*  189536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189553 */     // MIs[0] rs1
     /*  189553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189565 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189570 */     GIR_RootConstrainSelectedInstOperands,
     /*  189571 */     // GIR_Coverage, 939,
     /*  189571 */     GIR_Done,
     /*  189572 */   // Label 3704: @189572
     /*  189572 */   GIM_Reject,
     /*  189573 */ // Label 3664: @189573
     /*  189573 */ GIM_Reject,
     /*  189574 */ // Label 3632: @189574
     /*  189574 */ GIM_Reject,
     /*  189575 */ // Label 29: @189575
     /*  189575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3707*/ GIMT_Encode4(190486),
     /*  189586 */ /*GILLT_s32*//*Label 3705*/ GIMT_Encode4(189594),
     /*  189590 */ /*GILLT_s64*//*Label 3706*/ GIMT_Encode4(189876),
     /*  189594 */ // Label 3705: @189594
     /*  189594 */ GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(189875),
     /*  189599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  189602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189609 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189662), // Rule ID 624 //
     /*  189614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189624 */     // MIs[0] addr
     /*  189624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189636 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  189636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189644 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189649 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189651 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189660 */     GIR_RootConstrainSelectedInstOperands,
     /*  189661 */     // GIR_Coverage, 624,
     /*  189661 */     GIR_EraseRootFromParent_Done,
     /*  189662 */   // Label 3709: @189662
     /*  189662 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189715), // Rule ID 626 //
     /*  189667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189677 */     // MIs[0] addr
     /*  189677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189689 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  189689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189697 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189702 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189704 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189713 */     GIR_RootConstrainSelectedInstOperands,
     /*  189714 */     // GIR_Coverage, 626,
     /*  189714 */     GIR_EraseRootFromParent_Done,
     /*  189715 */   // Label 3710: @189715
     /*  189715 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189768), // Rule ID 628 //
     /*  189720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189730 */     // MIs[0] addr
     /*  189730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189742 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  189742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189750 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189755 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189757 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189766 */     GIR_RootConstrainSelectedInstOperands,
     /*  189767 */     // GIR_Coverage, 628,
     /*  189767 */     GIR_EraseRootFromParent_Done,
     /*  189768 */   // Label 3711: @189768
     /*  189768 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189821), // Rule ID 630 //
     /*  189773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189783 */     // MIs[0] addr
     /*  189783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189795 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  189795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189803 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189808 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189810 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189819 */     GIR_RootConstrainSelectedInstOperands,
     /*  189820 */     // GIR_Coverage, 630,
     /*  189820 */     GIR_EraseRootFromParent_Done,
     /*  189821 */   // Label 3712: @189821
     /*  189821 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189874), // Rule ID 632 //
     /*  189826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189836 */     // MIs[0] addr
     /*  189836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189848 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  189848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189856 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189861 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189863 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189872 */     GIR_RootConstrainSelectedInstOperands,
     /*  189873 */     // GIR_Coverage, 632,
     /*  189873 */     GIR_EraseRootFromParent_Done,
     /*  189874 */   // Label 3713: @189874
     /*  189874 */   GIM_Reject,
     /*  189875 */ // Label 3708: @189875
     /*  189875 */ GIM_Reject,
     /*  189876 */ // Label 3706: @189876
     /*  189876 */ GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(190485),
     /*  189881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  189884 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189944), // Rule ID 623 //
     /*  189889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189906 */     // MIs[0] addr
     /*  189906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189918 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189926 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189931 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189933 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189942 */     GIR_RootConstrainSelectedInstOperands,
     /*  189943 */     // GIR_Coverage, 623,
     /*  189943 */     GIR_EraseRootFromParent_Done,
     /*  189944 */   // Label 3715: @189944
     /*  189944 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(190004), // Rule ID 625 //
     /*  189949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189966 */     // MIs[0] addr
     /*  189966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189978 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189986 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189991 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189993 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190002 */     GIR_RootConstrainSelectedInstOperands,
     /*  190003 */     // GIR_Coverage, 625,
     /*  190003 */     GIR_EraseRootFromParent_Done,
     /*  190004 */   // Label 3716: @190004
     /*  190004 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(190064), // Rule ID 627 //
     /*  190009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190012 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190019 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190026 */     // MIs[0] addr
     /*  190026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190038 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  190038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190046 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190051 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190053 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190062 */     GIR_RootConstrainSelectedInstOperands,
     /*  190063 */     // GIR_Coverage, 627,
     /*  190063 */     GIR_EraseRootFromParent_Done,
     /*  190064 */   // Label 3717: @190064
     /*  190064 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(190124), // Rule ID 629 //
     /*  190069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190086 */     // MIs[0] addr
     /*  190086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190098 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  190098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190106 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190111 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190113 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190122 */     GIR_RootConstrainSelectedInstOperands,
     /*  190123 */     // GIR_Coverage, 629,
     /*  190123 */     GIR_EraseRootFromParent_Done,
     /*  190124 */   // Label 3718: @190124
     /*  190124 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(190184), // Rule ID 631 //
     /*  190129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  190132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190146 */     // MIs[0] addr
     /*  190146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190158 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  190158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  190164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190166 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190171 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190173 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190182 */     GIR_RootConstrainSelectedInstOperands,
     /*  190183 */     // GIR_Coverage, 631,
     /*  190183 */     GIR_EraseRootFromParent_Done,
     /*  190184 */   // Label 3719: @190184
     /*  190184 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(190244), // Rule ID 641 //
     /*  190189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190192 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190199 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190206 */     // MIs[0] addr
     /*  190206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190218 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  190218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190226 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190231 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190233 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  190238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190242 */     GIR_RootConstrainSelectedInstOperands,
     /*  190243 */     // GIR_Coverage, 641,
     /*  190243 */     GIR_EraseRootFromParent_Done,
     /*  190244 */   // Label 3720: @190244
     /*  190244 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(190304), // Rule ID 642 //
     /*  190249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190266 */     // MIs[0] addr
     /*  190266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190278 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  190278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190286 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190291 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190293 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  190298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190302 */     GIR_RootConstrainSelectedInstOperands,
     /*  190303 */     // GIR_Coverage, 642,
     /*  190303 */     GIR_EraseRootFromParent_Done,
     /*  190304 */   // Label 3721: @190304
     /*  190304 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(190364), // Rule ID 643 //
     /*  190309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190326 */     // MIs[0] addr
     /*  190326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190338 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  190338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190346 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190351 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190353 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  190358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190362 */     GIR_RootConstrainSelectedInstOperands,
     /*  190363 */     // GIR_Coverage, 643,
     /*  190363 */     GIR_EraseRootFromParent_Done,
     /*  190364 */   // Label 3722: @190364
     /*  190364 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(190424), // Rule ID 644 //
     /*  190369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190386 */     // MIs[0] addr
     /*  190386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190398 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  190398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190406 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190411 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190413 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  190418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190422 */     GIR_RootConstrainSelectedInstOperands,
     /*  190423 */     // GIR_Coverage, 644,
     /*  190423 */     GIR_EraseRootFromParent_Done,
     /*  190424 */   // Label 3723: @190424
     /*  190424 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(190484), // Rule ID 645 //
     /*  190429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  190432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  190439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190446 */     // MIs[0] addr
     /*  190446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  190450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190458 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  190458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  190461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  190464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190466 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190471 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190473 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190482 */     GIR_RootConstrainSelectedInstOperands,
     /*  190483 */     // GIR_Coverage, 645,
     /*  190483 */     GIR_EraseRootFromParent_Done,
     /*  190484 */   // Label 3724: @190484
     /*  190484 */   GIM_Reject,
     /*  190485 */ // Label 3714: @190485
     /*  190485 */ GIM_Reject,
     /*  190486 */ // Label 3707: @190486
     /*  190486 */ GIM_Reject,
     /*  190487 */ // Label 30: @190487
     /*  190487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3727*/ GIMT_Encode4(193396),
     /*  190498 */ /*GILLT_s32*//*Label 3725*/ GIMT_Encode4(190506),
     /*  190502 */ /*GILLT_s64*//*Label 3726*/ GIMT_Encode4(191746),
     /*  190506 */ // Label 3725: @190506
     /*  190506 */ GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(191745),
     /*  190511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190514 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(190555), // Rule ID 414 //
     /*  190519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190529 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190536 */     // MIs[0] rs1
     /*  190536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190548 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190553 */     GIR_RootConstrainSelectedInstOperands,
     /*  190554 */     // GIR_Coverage, 414,
     /*  190554 */     GIR_Done,
     /*  190555 */   // Label 3729: @190555
     /*  190555 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(190596), // Rule ID 416 //
     /*  190560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190577 */     // MIs[0] rs1
     /*  190577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190589 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  190594 */     GIR_RootConstrainSelectedInstOperands,
     /*  190595 */     // GIR_Coverage, 416,
     /*  190595 */     GIR_Done,
     /*  190596 */   // Label 3730: @190596
     /*  190596 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(190637), // Rule ID 418 //
     /*  190601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190604 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190611 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190618 */     // MIs[0] rs1
     /*  190618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190630 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  190635 */     GIR_RootConstrainSelectedInstOperands,
     /*  190636 */     // GIR_Coverage, 418,
     /*  190636 */     GIR_Done,
     /*  190637 */   // Label 3731: @190637
     /*  190637 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(190678), // Rule ID 420 //
     /*  190642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190659 */     // MIs[0] rs1
     /*  190659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190671 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190676 */     GIR_RootConstrainSelectedInstOperands,
     /*  190677 */     // GIR_Coverage, 420,
     /*  190677 */     GIR_Done,
     /*  190678 */   // Label 3732: @190678
     /*  190678 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(190719), // Rule ID 422 //
     /*  190683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190700 */     // MIs[0] rs1
     /*  190700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190712 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190717 */     GIR_RootConstrainSelectedInstOperands,
     /*  190718 */     // GIR_Coverage, 422,
     /*  190718 */     GIR_Done,
     /*  190719 */   // Label 3733: @190719
     /*  190719 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(190760), // Rule ID 424 //
     /*  190724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190727 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190741 */     // MIs[0] rs1
     /*  190741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190753 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190758 */     GIR_RootConstrainSelectedInstOperands,
     /*  190759 */     // GIR_Coverage, 424,
     /*  190759 */     GIR_Done,
     /*  190760 */   // Label 3734: @190760
     /*  190760 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(190801), // Rule ID 426 //
     /*  190765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190768 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190775 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190782 */     // MIs[0] rs1
     /*  190782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190794 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190799 */     GIR_RootConstrainSelectedInstOperands,
     /*  190800 */     // GIR_Coverage, 426,
     /*  190800 */     GIR_Done,
     /*  190801 */   // Label 3735: @190801
     /*  190801 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190842), // Rule ID 428 //
     /*  190806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190809 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190816 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190823 */     // MIs[0] rs1
     /*  190823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190835 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190840 */     GIR_RootConstrainSelectedInstOperands,
     /*  190841 */     // GIR_Coverage, 428,
     /*  190841 */     GIR_Done,
     /*  190842 */   // Label 3736: @190842
     /*  190842 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190883), // Rule ID 430 //
     /*  190847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190864 */     // MIs[0] rs1
     /*  190864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190876 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190881 */     GIR_RootConstrainSelectedInstOperands,
     /*  190882 */     // GIR_Coverage, 430,
     /*  190882 */     GIR_Done,
     /*  190883 */   // Label 3737: @190883
     /*  190883 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190924), // Rule ID 432 //
     /*  190888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190905 */     // MIs[0] rs1
     /*  190905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190917 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190922 */     GIR_RootConstrainSelectedInstOperands,
     /*  190923 */     // GIR_Coverage, 432,
     /*  190923 */     GIR_Done,
     /*  190924 */   // Label 3738: @190924
     /*  190924 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190965), // Rule ID 762 //
     /*  190929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190946 */     // MIs[0] rs1
     /*  190946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190958 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190963 */     GIR_RootConstrainSelectedInstOperands,
     /*  190964 */     // GIR_Coverage, 762,
     /*  190964 */     GIR_Done,
     /*  190965 */   // Label 3739: @190965
     /*  190965 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(191006), // Rule ID 764 //
     /*  190970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190987 */     // MIs[0] rs1
     /*  190987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190999 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  191004 */     GIR_RootConstrainSelectedInstOperands,
     /*  191005 */     // GIR_Coverage, 764,
     /*  191005 */     GIR_Done,
     /*  191006 */   // Label 3740: @191006
     /*  191006 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(191047), // Rule ID 766 //
     /*  191011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191028 */     // MIs[0] rs1
     /*  191028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191040 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  191045 */     GIR_RootConstrainSelectedInstOperands,
     /*  191046 */     // GIR_Coverage, 766,
     /*  191046 */     GIR_Done,
     /*  191047 */   // Label 3741: @191047
     /*  191047 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(191088), // Rule ID 768 //
     /*  191052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191069 */     // MIs[0] rs1
     /*  191069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191081 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191086 */     GIR_RootConstrainSelectedInstOperands,
     /*  191087 */     // GIR_Coverage, 768,
     /*  191087 */     GIR_Done,
     /*  191088 */   // Label 3742: @191088
     /*  191088 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(191129), // Rule ID 770 //
     /*  191093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191110 */     // MIs[0] rs1
     /*  191110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191122 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191127 */     GIR_RootConstrainSelectedInstOperands,
     /*  191128 */     // GIR_Coverage, 770,
     /*  191128 */     GIR_Done,
     /*  191129 */   // Label 3743: @191129
     /*  191129 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(191170), // Rule ID 772 //
     /*  191134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191151 */     // MIs[0] rs1
     /*  191151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191163 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191168 */     GIR_RootConstrainSelectedInstOperands,
     /*  191169 */     // GIR_Coverage, 772,
     /*  191169 */     GIR_Done,
     /*  191170 */   // Label 3744: @191170
     /*  191170 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(191211), // Rule ID 774 //
     /*  191175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191192 */     // MIs[0] rs1
     /*  191192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191204 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191209 */     GIR_RootConstrainSelectedInstOperands,
     /*  191210 */     // GIR_Coverage, 774,
     /*  191210 */     GIR_Done,
     /*  191211 */   // Label 3745: @191211
     /*  191211 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(191252), // Rule ID 776 //
     /*  191216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191233 */     // MIs[0] rs1
     /*  191233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191245 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191250 */     GIR_RootConstrainSelectedInstOperands,
     /*  191251 */     // GIR_Coverage, 776,
     /*  191251 */     GIR_Done,
     /*  191252 */   // Label 3746: @191252
     /*  191252 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(191293), // Rule ID 778 //
     /*  191257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191274 */     // MIs[0] rs1
     /*  191274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191286 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191291 */     GIR_RootConstrainSelectedInstOperands,
     /*  191292 */     // GIR_Coverage, 778,
     /*  191292 */     GIR_Done,
     /*  191293 */   // Label 3747: @191293
     /*  191293 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(191334), // Rule ID 780 //
     /*  191298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191315 */     // MIs[0] rs1
     /*  191315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191327 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191332 */     GIR_RootConstrainSelectedInstOperands,
     /*  191333 */     // GIR_Coverage, 780,
     /*  191333 */     GIR_Done,
     /*  191334 */   // Label 3748: @191334
     /*  191334 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(191375), // Rule ID 942 //
     /*  191339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191356 */     // MIs[0] rs1
     /*  191356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191368 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191373 */     GIR_RootConstrainSelectedInstOperands,
     /*  191374 */     // GIR_Coverage, 942,
     /*  191374 */     GIR_Done,
     /*  191375 */   // Label 3749: @191375
     /*  191375 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(191416), // Rule ID 944 //
     /*  191380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191397 */     // MIs[0] rs1
     /*  191397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191409 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  191414 */     GIR_RootConstrainSelectedInstOperands,
     /*  191415 */     // GIR_Coverage, 944,
     /*  191415 */     GIR_Done,
     /*  191416 */   // Label 3750: @191416
     /*  191416 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(191457), // Rule ID 946 //
     /*  191421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191438 */     // MIs[0] rs1
     /*  191438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191450 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  191455 */     GIR_RootConstrainSelectedInstOperands,
     /*  191456 */     // GIR_Coverage, 946,
     /*  191456 */     GIR_Done,
     /*  191457 */   // Label 3751: @191457
     /*  191457 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(191498), // Rule ID 948 //
     /*  191462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191479 */     // MIs[0] rs1
     /*  191479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191491 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191496 */     GIR_RootConstrainSelectedInstOperands,
     /*  191497 */     // GIR_Coverage, 948,
     /*  191497 */     GIR_Done,
     /*  191498 */   // Label 3752: @191498
     /*  191498 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(191539), // Rule ID 950 //
     /*  191503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191520 */     // MIs[0] rs1
     /*  191520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191532 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191537 */     GIR_RootConstrainSelectedInstOperands,
     /*  191538 */     // GIR_Coverage, 950,
     /*  191538 */     GIR_Done,
     /*  191539 */   // Label 3753: @191539
     /*  191539 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(191580), // Rule ID 952 //
     /*  191544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191561 */     // MIs[0] rs1
     /*  191561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191573 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191578 */     GIR_RootConstrainSelectedInstOperands,
     /*  191579 */     // GIR_Coverage, 952,
     /*  191579 */     GIR_Done,
     /*  191580 */   // Label 3754: @191580
     /*  191580 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(191621), // Rule ID 954 //
     /*  191585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191602 */     // MIs[0] rs1
     /*  191602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191614 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191619 */     GIR_RootConstrainSelectedInstOperands,
     /*  191620 */     // GIR_Coverage, 954,
     /*  191620 */     GIR_Done,
     /*  191621 */   // Label 3755: @191621
     /*  191621 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(191662), // Rule ID 956 //
     /*  191626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191643 */     // MIs[0] rs1
     /*  191643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191655 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191660 */     GIR_RootConstrainSelectedInstOperands,
     /*  191661 */     // GIR_Coverage, 956,
     /*  191661 */     GIR_Done,
     /*  191662 */   // Label 3756: @191662
     /*  191662 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(191703), // Rule ID 958 //
     /*  191667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191684 */     // MIs[0] rs1
     /*  191684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191696 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191701 */     GIR_RootConstrainSelectedInstOperands,
     /*  191702 */     // GIR_Coverage, 958,
     /*  191702 */     GIR_Done,
     /*  191703 */   // Label 3757: @191703
     /*  191703 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(191744), // Rule ID 960 //
     /*  191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191725 */     // MIs[0] rs1
     /*  191725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191737 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191742 */     GIR_RootConstrainSelectedInstOperands,
     /*  191743 */     // GIR_Coverage, 960,
     /*  191743 */     GIR_Done,
     /*  191744 */   // Label 3758: @191744
     /*  191744 */   GIM_Reject,
     /*  191745 */ // Label 3728: @191745
     /*  191745 */ GIM_Reject,
     /*  191746 */ // Label 3726: @191746
     /*  191746 */ GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(193395),
     /*  191751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191754 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(191795), // Rule ID 413 //
     /*  191759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191776 */     // MIs[0] rs1
     /*  191776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191788 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191793 */     GIR_RootConstrainSelectedInstOperands,
     /*  191794 */     // GIR_Coverage, 413,
     /*  191794 */     GIR_Done,
     /*  191795 */   // Label 3760: @191795
     /*  191795 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(191836), // Rule ID 415 //
     /*  191800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191817 */     // MIs[0] rs1
     /*  191817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191829 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  191834 */     GIR_RootConstrainSelectedInstOperands,
     /*  191835 */     // GIR_Coverage, 415,
     /*  191835 */     GIR_Done,
     /*  191836 */   // Label 3761: @191836
     /*  191836 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191877), // Rule ID 417 //
     /*  191841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191858 */     // MIs[0] rs1
     /*  191858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191870 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  191875 */     GIR_RootConstrainSelectedInstOperands,
     /*  191876 */     // GIR_Coverage, 417,
     /*  191876 */     GIR_Done,
     /*  191877 */   // Label 3762: @191877
     /*  191877 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191918), // Rule ID 419 //
     /*  191882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191899 */     // MIs[0] rs1
     /*  191899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191911 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191916 */     GIR_RootConstrainSelectedInstOperands,
     /*  191917 */     // GIR_Coverage, 419,
     /*  191917 */     GIR_Done,
     /*  191918 */   // Label 3763: @191918
     /*  191918 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191959), // Rule ID 421 //
     /*  191923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191940 */     // MIs[0] rs1
     /*  191940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191952 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191957 */     GIR_RootConstrainSelectedInstOperands,
     /*  191958 */     // GIR_Coverage, 421,
     /*  191958 */     GIR_Done,
     /*  191959 */   // Label 3764: @191959
     /*  191959 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(192000), // Rule ID 423 //
     /*  191964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191981 */     // MIs[0] rs1
     /*  191981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191993 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191998 */     GIR_RootConstrainSelectedInstOperands,
     /*  191999 */     // GIR_Coverage, 423,
     /*  191999 */     GIR_Done,
     /*  192000 */   // Label 3765: @192000
     /*  192000 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(192041), // Rule ID 425 //
     /*  192005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192022 */     // MIs[0] rs1
     /*  192022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192034 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192039 */     GIR_RootConstrainSelectedInstOperands,
     /*  192040 */     // GIR_Coverage, 425,
     /*  192040 */     GIR_Done,
     /*  192041 */   // Label 3766: @192041
     /*  192041 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(192082), // Rule ID 427 //
     /*  192046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192063 */     // MIs[0] rs1
     /*  192063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192075 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192080 */     GIR_RootConstrainSelectedInstOperands,
     /*  192081 */     // GIR_Coverage, 427,
     /*  192081 */     GIR_Done,
     /*  192082 */   // Label 3767: @192082
     /*  192082 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(192123), // Rule ID 429 //
     /*  192087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192104 */     // MIs[0] rs1
     /*  192104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192116 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192121 */     GIR_RootConstrainSelectedInstOperands,
     /*  192122 */     // GIR_Coverage, 429,
     /*  192122 */     GIR_Done,
     /*  192123 */   // Label 3768: @192123
     /*  192123 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(192164), // Rule ID 431 //
     /*  192128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  192131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192145 */     // MIs[0] rs1
     /*  192145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192157 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  192162 */     GIR_RootConstrainSelectedInstOperands,
     /*  192163 */     // GIR_Coverage, 431,
     /*  192163 */     GIR_Done,
     /*  192164 */   // Label 3769: @192164
     /*  192164 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(192205), // Rule ID 563 //
     /*  192169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192186 */     // MIs[0] rs1
     /*  192186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192198 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192203 */     GIR_RootConstrainSelectedInstOperands,
     /*  192204 */     // GIR_Coverage, 563,
     /*  192204 */     GIR_Done,
     /*  192205 */   // Label 3770: @192205
     /*  192205 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(192246), // Rule ID 564 //
     /*  192210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192227 */     // MIs[0] rs1
     /*  192227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192239 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  192244 */     GIR_RootConstrainSelectedInstOperands,
     /*  192245 */     // GIR_Coverage, 564,
     /*  192245 */     GIR_Done,
     /*  192246 */   // Label 3771: @192246
     /*  192246 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(192287), // Rule ID 565 //
     /*  192251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192268 */     // MIs[0] rs1
     /*  192268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192280 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  192285 */     GIR_RootConstrainSelectedInstOperands,
     /*  192286 */     // GIR_Coverage, 565,
     /*  192286 */     GIR_Done,
     /*  192287 */   // Label 3772: @192287
     /*  192287 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(192328), // Rule ID 566 //
     /*  192292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192309 */     // MIs[0] rs1
     /*  192309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192321 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  192326 */     GIR_RootConstrainSelectedInstOperands,
     /*  192327 */     // GIR_Coverage, 566,
     /*  192327 */     GIR_Done,
     /*  192328 */   // Label 3773: @192328
     /*  192328 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(192369), // Rule ID 567 //
     /*  192333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  192336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192350 */     // MIs[0] rs1
     /*  192350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192362 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  192367 */     GIR_RootConstrainSelectedInstOperands,
     /*  192368 */     // GIR_Coverage, 567,
     /*  192368 */     GIR_Done,
     /*  192369 */   // Label 3774: @192369
     /*  192369 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(192410), // Rule ID 568 //
     /*  192374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192391 */     // MIs[0] rs1
     /*  192391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192403 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192408 */     GIR_RootConstrainSelectedInstOperands,
     /*  192409 */     // GIR_Coverage, 568,
     /*  192409 */     GIR_Done,
     /*  192410 */   // Label 3775: @192410
     /*  192410 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(192451), // Rule ID 569 //
     /*  192415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192432 */     // MIs[0] rs1
     /*  192432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192444 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192449 */     GIR_RootConstrainSelectedInstOperands,
     /*  192450 */     // GIR_Coverage, 569,
     /*  192450 */     GIR_Done,
     /*  192451 */   // Label 3776: @192451
     /*  192451 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(192492), // Rule ID 570 //
     /*  192456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192473 */     // MIs[0] rs1
     /*  192473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192485 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192490 */     GIR_RootConstrainSelectedInstOperands,
     /*  192491 */     // GIR_Coverage, 570,
     /*  192491 */     GIR_Done,
     /*  192492 */   // Label 3777: @192492
     /*  192492 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(192533), // Rule ID 571 //
     /*  192497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192514 */     // MIs[0] rs1
     /*  192514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192526 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192531 */     GIR_RootConstrainSelectedInstOperands,
     /*  192532 */     // GIR_Coverage, 571,
     /*  192532 */     GIR_Done,
     /*  192533 */   // Label 3778: @192533
     /*  192533 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(192574), // Rule ID 572 //
     /*  192538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192555 */     // MIs[0] rs1
     /*  192555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192567 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192572 */     GIR_RootConstrainSelectedInstOperands,
     /*  192573 */     // GIR_Coverage, 572,
     /*  192573 */     GIR_Done,
     /*  192574 */   // Label 3779: @192574
     /*  192574 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(192615), // Rule ID 761 //
     /*  192579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192596 */     // MIs[0] rs1
     /*  192596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192608 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192613 */     GIR_RootConstrainSelectedInstOperands,
     /*  192614 */     // GIR_Coverage, 761,
     /*  192614 */     GIR_Done,
     /*  192615 */   // Label 3780: @192615
     /*  192615 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(192656), // Rule ID 763 //
     /*  192620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192637 */     // MIs[0] rs1
     /*  192637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192649 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  192654 */     GIR_RootConstrainSelectedInstOperands,
     /*  192655 */     // GIR_Coverage, 763,
     /*  192655 */     GIR_Done,
     /*  192656 */   // Label 3781: @192656
     /*  192656 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(192697), // Rule ID 765 //
     /*  192661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192678 */     // MIs[0] rs1
     /*  192678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192690 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  192695 */     GIR_RootConstrainSelectedInstOperands,
     /*  192696 */     // GIR_Coverage, 765,
     /*  192696 */     GIR_Done,
     /*  192697 */   // Label 3782: @192697
     /*  192697 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(192738), // Rule ID 767 //
     /*  192702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192719 */     // MIs[0] rs1
     /*  192719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192731 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192736 */     GIR_RootConstrainSelectedInstOperands,
     /*  192737 */     // GIR_Coverage, 767,
     /*  192737 */     GIR_Done,
     /*  192738 */   // Label 3783: @192738
     /*  192738 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(192779), // Rule ID 769 //
     /*  192743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192760 */     // MIs[0] rs1
     /*  192760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192772 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192777 */     GIR_RootConstrainSelectedInstOperands,
     /*  192778 */     // GIR_Coverage, 769,
     /*  192778 */     GIR_Done,
     /*  192779 */   // Label 3784: @192779
     /*  192779 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(192820), // Rule ID 771 //
     /*  192784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192801 */     // MIs[0] rs1
     /*  192801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192813 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192818 */     GIR_RootConstrainSelectedInstOperands,
     /*  192819 */     // GIR_Coverage, 771,
     /*  192819 */     GIR_Done,
     /*  192820 */   // Label 3785: @192820
     /*  192820 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(192861), // Rule ID 773 //
     /*  192825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192842 */     // MIs[0] rs1
     /*  192842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192854 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192859 */     GIR_RootConstrainSelectedInstOperands,
     /*  192860 */     // GIR_Coverage, 773,
     /*  192860 */     GIR_Done,
     /*  192861 */   // Label 3786: @192861
     /*  192861 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(192902), // Rule ID 775 //
     /*  192866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192883 */     // MIs[0] rs1
     /*  192883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192895 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192900 */     GIR_RootConstrainSelectedInstOperands,
     /*  192901 */     // GIR_Coverage, 775,
     /*  192901 */     GIR_Done,
     /*  192902 */   // Label 3787: @192902
     /*  192902 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192943), // Rule ID 777 //
     /*  192907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192924 */     // MIs[0] rs1
     /*  192924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192936 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192941 */     GIR_RootConstrainSelectedInstOperands,
     /*  192942 */     // GIR_Coverage, 777,
     /*  192942 */     GIR_Done,
     /*  192943 */   // Label 3788: @192943
     /*  192943 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192984), // Rule ID 779 //
     /*  192948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192965 */     // MIs[0] rs1
     /*  192965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192977 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192982 */     GIR_RootConstrainSelectedInstOperands,
     /*  192983 */     // GIR_Coverage, 779,
     /*  192983 */     GIR_Done,
     /*  192984 */   // Label 3789: @192984
     /*  192984 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(193025), // Rule ID 941 //
     /*  192989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193006 */     // MIs[0] rs1
     /*  193006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193018 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193023 */     GIR_RootConstrainSelectedInstOperands,
     /*  193024 */     // GIR_Coverage, 941,
     /*  193024 */     GIR_Done,
     /*  193025 */   // Label 3790: @193025
     /*  193025 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(193066), // Rule ID 943 //
     /*  193030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193047 */     // MIs[0] rs1
     /*  193047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193059 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  193064 */     GIR_RootConstrainSelectedInstOperands,
     /*  193065 */     // GIR_Coverage, 943,
     /*  193065 */     GIR_Done,
     /*  193066 */   // Label 3791: @193066
     /*  193066 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(193107), // Rule ID 945 //
     /*  193071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193088 */     // MIs[0] rs1
     /*  193088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193100 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  193105 */     GIR_RootConstrainSelectedInstOperands,
     /*  193106 */     // GIR_Coverage, 945,
     /*  193106 */     GIR_Done,
     /*  193107 */   // Label 3792: @193107
     /*  193107 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(193148), // Rule ID 947 //
     /*  193112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193129 */     // MIs[0] rs1
     /*  193129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193141 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  193146 */     GIR_RootConstrainSelectedInstOperands,
     /*  193147 */     // GIR_Coverage, 947,
     /*  193147 */     GIR_Done,
     /*  193148 */   // Label 3793: @193148
     /*  193148 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(193189), // Rule ID 949 //
     /*  193153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  193156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193170 */     // MIs[0] rs1
     /*  193170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193182 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  193187 */     GIR_RootConstrainSelectedInstOperands,
     /*  193188 */     // GIR_Coverage, 949,
     /*  193188 */     GIR_Done,
     /*  193189 */   // Label 3794: @193189
     /*  193189 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(193230), // Rule ID 951 //
     /*  193194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193211 */     // MIs[0] rs1
     /*  193211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193223 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193228 */     GIR_RootConstrainSelectedInstOperands,
     /*  193229 */     // GIR_Coverage, 951,
     /*  193229 */     GIR_Done,
     /*  193230 */   // Label 3795: @193230
     /*  193230 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(193271), // Rule ID 953 //
     /*  193235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193252 */     // MIs[0] rs1
     /*  193252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193264 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193269 */     GIR_RootConstrainSelectedInstOperands,
     /*  193270 */     // GIR_Coverage, 953,
     /*  193270 */     GIR_Done,
     /*  193271 */   // Label 3796: @193271
     /*  193271 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(193312), // Rule ID 955 //
     /*  193276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193293 */     // MIs[0] rs1
     /*  193293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193305 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193310 */     GIR_RootConstrainSelectedInstOperands,
     /*  193311 */     // GIR_Coverage, 955,
     /*  193311 */     GIR_Done,
     /*  193312 */   // Label 3797: @193312
     /*  193312 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(193353), // Rule ID 957 //
     /*  193317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193334 */     // MIs[0] rs1
     /*  193334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193346 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193351 */     GIR_RootConstrainSelectedInstOperands,
     /*  193352 */     // GIR_Coverage, 957,
     /*  193352 */     GIR_Done,
     /*  193353 */   // Label 3798: @193353
     /*  193353 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(193394), // Rule ID 959 //
     /*  193358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  193361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193375 */     // MIs[0] rs1
     /*  193375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193387 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  193392 */     GIR_RootConstrainSelectedInstOperands,
     /*  193393 */     // GIR_Coverage, 959,
     /*  193393 */     GIR_Done,
     /*  193394 */   // Label 3799: @193394
     /*  193394 */   GIM_Reject,
     /*  193395 */ // Label 3759: @193395
     /*  193395 */ GIM_Reject,
     /*  193396 */ // Label 3727: @193396
     /*  193396 */ GIM_Reject,
     /*  193397 */ // Label 31: @193397
     /*  193397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3802*/ GIMT_Encode4(196306),
     /*  193408 */ /*GILLT_s32*//*Label 3800*/ GIMT_Encode4(193416),
     /*  193412 */ /*GILLT_s64*//*Label 3801*/ GIMT_Encode4(194656),
     /*  193416 */ // Label 3800: @193416
     /*  193416 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(194655),
     /*  193421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  193424 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(193465), // Rule ID 434 //
     /*  193429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193446 */     // MIs[0] rs1
     /*  193446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193458 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193463 */     GIR_RootConstrainSelectedInstOperands,
     /*  193464 */     // GIR_Coverage, 434,
     /*  193464 */     GIR_Done,
     /*  193465 */   // Label 3804: @193465
     /*  193465 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(193506), // Rule ID 436 //
     /*  193470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193487 */     // MIs[0] rs1
     /*  193487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193499 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  193504 */     GIR_RootConstrainSelectedInstOperands,
     /*  193505 */     // GIR_Coverage, 436,
     /*  193505 */     GIR_Done,
     /*  193506 */   // Label 3805: @193506
     /*  193506 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(193547), // Rule ID 438 //
     /*  193511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193528 */     // MIs[0] rs1
     /*  193528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193540 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  193545 */     GIR_RootConstrainSelectedInstOperands,
     /*  193546 */     // GIR_Coverage, 438,
     /*  193546 */     GIR_Done,
     /*  193547 */   // Label 3806: @193547
     /*  193547 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(193588), // Rule ID 440 //
     /*  193552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193562 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193569 */     // MIs[0] rs1
     /*  193569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193581 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193586 */     GIR_RootConstrainSelectedInstOperands,
     /*  193587 */     // GIR_Coverage, 440,
     /*  193587 */     GIR_Done,
     /*  193588 */   // Label 3807: @193588
     /*  193588 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(193629), // Rule ID 442 //
     /*  193593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193610 */     // MIs[0] rs1
     /*  193610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193622 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193627 */     GIR_RootConstrainSelectedInstOperands,
     /*  193628 */     // GIR_Coverage, 442,
     /*  193628 */     GIR_Done,
     /*  193629 */   // Label 3808: @193629
     /*  193629 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(193670), // Rule ID 444 //
     /*  193634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193651 */     // MIs[0] rs1
     /*  193651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193663 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193668 */     GIR_RootConstrainSelectedInstOperands,
     /*  193669 */     // GIR_Coverage, 444,
     /*  193669 */     GIR_Done,
     /*  193670 */   // Label 3809: @193670
     /*  193670 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(193711), // Rule ID 446 //
     /*  193675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193692 */     // MIs[0] rs1
     /*  193692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193704 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193709 */     GIR_RootConstrainSelectedInstOperands,
     /*  193710 */     // GIR_Coverage, 446,
     /*  193710 */     GIR_Done,
     /*  193711 */   // Label 3810: @193711
     /*  193711 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(193752), // Rule ID 448 //
     /*  193716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193719 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193726 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193733 */     // MIs[0] rs1
     /*  193733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193745 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193750 */     GIR_RootConstrainSelectedInstOperands,
     /*  193751 */     // GIR_Coverage, 448,
     /*  193751 */     GIR_Done,
     /*  193752 */   // Label 3811: @193752
     /*  193752 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(193793), // Rule ID 450 //
     /*  193757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193774 */     // MIs[0] rs1
     /*  193774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193786 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193791 */     GIR_RootConstrainSelectedInstOperands,
     /*  193792 */     // GIR_Coverage, 450,
     /*  193792 */     GIR_Done,
     /*  193793 */   // Label 3812: @193793
     /*  193793 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(193834), // Rule ID 452 //
     /*  193798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193815 */     // MIs[0] rs1
     /*  193815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193827 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193832 */     GIR_RootConstrainSelectedInstOperands,
     /*  193833 */     // GIR_Coverage, 452,
     /*  193833 */     GIR_Done,
     /*  193834 */   // Label 3813: @193834
     /*  193834 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(193875), // Rule ID 782 //
     /*  193839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193856 */     // MIs[0] rs1
     /*  193856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193868 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193873 */     GIR_RootConstrainSelectedInstOperands,
     /*  193874 */     // GIR_Coverage, 782,
     /*  193874 */     GIR_Done,
     /*  193875 */   // Label 3814: @193875
     /*  193875 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193916), // Rule ID 784 //
     /*  193880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193897 */     // MIs[0] rs1
     /*  193897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193909 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  193914 */     GIR_RootConstrainSelectedInstOperands,
     /*  193915 */     // GIR_Coverage, 784,
     /*  193915 */     GIR_Done,
     /*  193916 */   // Label 3815: @193916
     /*  193916 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193957), // Rule ID 786 //
     /*  193921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193938 */     // MIs[0] rs1
     /*  193938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193950 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  193955 */     GIR_RootConstrainSelectedInstOperands,
     /*  193956 */     // GIR_Coverage, 786,
     /*  193956 */     GIR_Done,
     /*  193957 */   // Label 3816: @193957
     /*  193957 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193998), // Rule ID 788 //
     /*  193962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193979 */     // MIs[0] rs1
     /*  193979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193991 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193996 */     GIR_RootConstrainSelectedInstOperands,
     /*  193997 */     // GIR_Coverage, 788,
     /*  193997 */     GIR_Done,
     /*  193998 */   // Label 3817: @193998
     /*  193998 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(194039), // Rule ID 790 //
     /*  194003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194020 */     // MIs[0] rs1
     /*  194020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194032 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  194037 */     GIR_RootConstrainSelectedInstOperands,
     /*  194038 */     // GIR_Coverage, 790,
     /*  194038 */     GIR_Done,
     /*  194039 */   // Label 3818: @194039
     /*  194039 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(194080), // Rule ID 792 //
     /*  194044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194061 */     // MIs[0] rs1
     /*  194061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194073 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194078 */     GIR_RootConstrainSelectedInstOperands,
     /*  194079 */     // GIR_Coverage, 792,
     /*  194079 */     GIR_Done,
     /*  194080 */   // Label 3819: @194080
     /*  194080 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(194121), // Rule ID 794 //
     /*  194085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194102 */     // MIs[0] rs1
     /*  194102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194114 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194119 */     GIR_RootConstrainSelectedInstOperands,
     /*  194120 */     // GIR_Coverage, 794,
     /*  194120 */     GIR_Done,
     /*  194121 */   // Label 3820: @194121
     /*  194121 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(194162), // Rule ID 796 //
     /*  194126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194143 */     // MIs[0] rs1
     /*  194143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194155 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194160 */     GIR_RootConstrainSelectedInstOperands,
     /*  194161 */     // GIR_Coverage, 796,
     /*  194161 */     GIR_Done,
     /*  194162 */   // Label 3821: @194162
     /*  194162 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(194203), // Rule ID 798 //
     /*  194167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194184 */     // MIs[0] rs1
     /*  194184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194196 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194201 */     GIR_RootConstrainSelectedInstOperands,
     /*  194202 */     // GIR_Coverage, 798,
     /*  194202 */     GIR_Done,
     /*  194203 */   // Label 3822: @194203
     /*  194203 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(194244), // Rule ID 800 //
     /*  194208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194218 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194225 */     // MIs[0] rs1
     /*  194225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194237 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194242 */     GIR_RootConstrainSelectedInstOperands,
     /*  194243 */     // GIR_Coverage, 800,
     /*  194243 */     GIR_Done,
     /*  194244 */   // Label 3823: @194244
     /*  194244 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(194285), // Rule ID 962 //
     /*  194249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194266 */     // MIs[0] rs1
     /*  194266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194278 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194283 */     GIR_RootConstrainSelectedInstOperands,
     /*  194284 */     // GIR_Coverage, 962,
     /*  194284 */     GIR_Done,
     /*  194285 */   // Label 3824: @194285
     /*  194285 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(194326), // Rule ID 964 //
     /*  194290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194307 */     // MIs[0] rs1
     /*  194307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194319 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  194324 */     GIR_RootConstrainSelectedInstOperands,
     /*  194325 */     // GIR_Coverage, 964,
     /*  194325 */     GIR_Done,
     /*  194326 */   // Label 3825: @194326
     /*  194326 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(194367), // Rule ID 966 //
     /*  194331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194348 */     // MIs[0] rs1
     /*  194348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194360 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  194365 */     GIR_RootConstrainSelectedInstOperands,
     /*  194366 */     // GIR_Coverage, 966,
     /*  194366 */     GIR_Done,
     /*  194367 */   // Label 3826: @194367
     /*  194367 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(194408), // Rule ID 968 //
     /*  194372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194389 */     // MIs[0] rs1
     /*  194389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194401 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  194406 */     GIR_RootConstrainSelectedInstOperands,
     /*  194407 */     // GIR_Coverage, 968,
     /*  194407 */     GIR_Done,
     /*  194408 */   // Label 3827: @194408
     /*  194408 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(194449), // Rule ID 970 //
     /*  194413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194430 */     // MIs[0] rs1
     /*  194430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194442 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  194447 */     GIR_RootConstrainSelectedInstOperands,
     /*  194448 */     // GIR_Coverage, 970,
     /*  194448 */     GIR_Done,
     /*  194449 */   // Label 3828: @194449
     /*  194449 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(194490), // Rule ID 972 //
     /*  194454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194471 */     // MIs[0] rs1
     /*  194471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194483 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194488 */     GIR_RootConstrainSelectedInstOperands,
     /*  194489 */     // GIR_Coverage, 972,
     /*  194489 */     GIR_Done,
     /*  194490 */   // Label 3829: @194490
     /*  194490 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(194531), // Rule ID 974 //
     /*  194495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194512 */     // MIs[0] rs1
     /*  194512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194524 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194529 */     GIR_RootConstrainSelectedInstOperands,
     /*  194530 */     // GIR_Coverage, 974,
     /*  194530 */     GIR_Done,
     /*  194531 */   // Label 3830: @194531
     /*  194531 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(194572), // Rule ID 976 //
     /*  194536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194553 */     // MIs[0] rs1
     /*  194553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194565 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194570 */     GIR_RootConstrainSelectedInstOperands,
     /*  194571 */     // GIR_Coverage, 976,
     /*  194571 */     GIR_Done,
     /*  194572 */   // Label 3831: @194572
     /*  194572 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(194613), // Rule ID 978 //
     /*  194577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194594 */     // MIs[0] rs1
     /*  194594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194606 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194611 */     GIR_RootConstrainSelectedInstOperands,
     /*  194612 */     // GIR_Coverage, 978,
     /*  194612 */     GIR_Done,
     /*  194613 */   // Label 3832: @194613
     /*  194613 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(194654), // Rule ID 980 //
     /*  194618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194635 */     // MIs[0] rs1
     /*  194635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194647 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194652 */     GIR_RootConstrainSelectedInstOperands,
     /*  194653 */     // GIR_Coverage, 980,
     /*  194653 */     GIR_Done,
     /*  194654 */   // Label 3833: @194654
     /*  194654 */   GIM_Reject,
     /*  194655 */ // Label 3803: @194655
     /*  194655 */ GIM_Reject,
     /*  194656 */ // Label 3801: @194656
     /*  194656 */ GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(196305),
     /*  194661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  194664 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(194705), // Rule ID 433 //
     /*  194669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194686 */     // MIs[0] rs1
     /*  194686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194698 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194703 */     GIR_RootConstrainSelectedInstOperands,
     /*  194704 */     // GIR_Coverage, 433,
     /*  194704 */     GIR_Done,
     /*  194705 */   // Label 3835: @194705
     /*  194705 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(194746), // Rule ID 435 //
     /*  194710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194727 */     // MIs[0] rs1
     /*  194727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194739 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  194744 */     GIR_RootConstrainSelectedInstOperands,
     /*  194745 */     // GIR_Coverage, 435,
     /*  194745 */     GIR_Done,
     /*  194746 */   // Label 3836: @194746
     /*  194746 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(194787), // Rule ID 437 //
     /*  194751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194768 */     // MIs[0] rs1
     /*  194768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194780 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  194785 */     GIR_RootConstrainSelectedInstOperands,
     /*  194786 */     // GIR_Coverage, 437,
     /*  194786 */     GIR_Done,
     /*  194787 */   // Label 3837: @194787
     /*  194787 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(194828), // Rule ID 439 //
     /*  194792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194809 */     // MIs[0] rs1
     /*  194809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194821 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194826 */     GIR_RootConstrainSelectedInstOperands,
     /*  194827 */     // GIR_Coverage, 439,
     /*  194827 */     GIR_Done,
     /*  194828 */   // Label 3838: @194828
     /*  194828 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(194869), // Rule ID 441 //
     /*  194833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194850 */     // MIs[0] rs1
     /*  194850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194862 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194867 */     GIR_RootConstrainSelectedInstOperands,
     /*  194868 */     // GIR_Coverage, 441,
     /*  194868 */     GIR_Done,
     /*  194869 */   // Label 3839: @194869
     /*  194869 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(194910), // Rule ID 443 //
     /*  194874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194891 */     // MIs[0] rs1
     /*  194891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194903 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194908 */     GIR_RootConstrainSelectedInstOperands,
     /*  194909 */     // GIR_Coverage, 443,
     /*  194909 */     GIR_Done,
     /*  194910 */   // Label 3840: @194910
     /*  194910 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(194951), // Rule ID 445 //
     /*  194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194932 */     // MIs[0] rs1
     /*  194932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194944 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194949 */     GIR_RootConstrainSelectedInstOperands,
     /*  194950 */     // GIR_Coverage, 445,
     /*  194950 */     GIR_Done,
     /*  194951 */   // Label 3841: @194951
     /*  194951 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194992), // Rule ID 447 //
     /*  194956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194973 */     // MIs[0] rs1
     /*  194973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194985 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194990 */     GIR_RootConstrainSelectedInstOperands,
     /*  194991 */     // GIR_Coverage, 447,
     /*  194991 */     GIR_Done,
     /*  194992 */   // Label 3842: @194992
     /*  194992 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(195033), // Rule ID 449 //
     /*  194997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195014 */     // MIs[0] rs1
     /*  195014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195026 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  195031 */     GIR_RootConstrainSelectedInstOperands,
     /*  195032 */     // GIR_Coverage, 449,
     /*  195032 */     GIR_Done,
     /*  195033 */   // Label 3843: @195033
     /*  195033 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(195074), // Rule ID 451 //
     /*  195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195055 */     // MIs[0] rs1
     /*  195055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195067 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  195072 */     GIR_RootConstrainSelectedInstOperands,
     /*  195073 */     // GIR_Coverage, 451,
     /*  195073 */     GIR_Done,
     /*  195074 */   // Label 3844: @195074
     /*  195074 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(195115), // Rule ID 573 //
     /*  195079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195096 */     // MIs[0] rs1
     /*  195096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195108 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195113 */     GIR_RootConstrainSelectedInstOperands,
     /*  195114 */     // GIR_Coverage, 573,
     /*  195114 */     GIR_Done,
     /*  195115 */   // Label 3845: @195115
     /*  195115 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(195156), // Rule ID 574 //
     /*  195120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195137 */     // MIs[0] rs1
     /*  195137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195149 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  195154 */     GIR_RootConstrainSelectedInstOperands,
     /*  195155 */     // GIR_Coverage, 574,
     /*  195155 */     GIR_Done,
     /*  195156 */   // Label 3846: @195156
     /*  195156 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(195197), // Rule ID 575 //
     /*  195161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195178 */     // MIs[0] rs1
     /*  195178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195190 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  195195 */     GIR_RootConstrainSelectedInstOperands,
     /*  195196 */     // GIR_Coverage, 575,
     /*  195196 */     GIR_Done,
     /*  195197 */   // Label 3847: @195197
     /*  195197 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(195238), // Rule ID 576 //
     /*  195202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195219 */     // MIs[0] rs1
     /*  195219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195231 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  195236 */     GIR_RootConstrainSelectedInstOperands,
     /*  195237 */     // GIR_Coverage, 576,
     /*  195237 */     GIR_Done,
     /*  195238 */   // Label 3848: @195238
     /*  195238 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(195279), // Rule ID 577 //
     /*  195243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195260 */     // MIs[0] rs1
     /*  195260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195272 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  195277 */     GIR_RootConstrainSelectedInstOperands,
     /*  195278 */     // GIR_Coverage, 577,
     /*  195278 */     GIR_Done,
     /*  195279 */   // Label 3849: @195279
     /*  195279 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(195320), // Rule ID 578 //
     /*  195284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195301 */     // MIs[0] rs1
     /*  195301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195313 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195318 */     GIR_RootConstrainSelectedInstOperands,
     /*  195319 */     // GIR_Coverage, 578,
     /*  195319 */     GIR_Done,
     /*  195320 */   // Label 3850: @195320
     /*  195320 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(195361), // Rule ID 579 //
     /*  195325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195342 */     // MIs[0] rs1
     /*  195342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195354 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195359 */     GIR_RootConstrainSelectedInstOperands,
     /*  195360 */     // GIR_Coverage, 579,
     /*  195360 */     GIR_Done,
     /*  195361 */   // Label 3851: @195361
     /*  195361 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(195402), // Rule ID 580 //
     /*  195366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195383 */     // MIs[0] rs1
     /*  195383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195395 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195400 */     GIR_RootConstrainSelectedInstOperands,
     /*  195401 */     // GIR_Coverage, 580,
     /*  195401 */     GIR_Done,
     /*  195402 */   // Label 3852: @195402
     /*  195402 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(195443), // Rule ID 581 //
     /*  195407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195424 */     // MIs[0] rs1
     /*  195424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195436 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195441 */     GIR_RootConstrainSelectedInstOperands,
     /*  195442 */     // GIR_Coverage, 581,
     /*  195442 */     GIR_Done,
     /*  195443 */   // Label 3853: @195443
     /*  195443 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(195484), // Rule ID 582 //
     /*  195448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195451 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195458 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195465 */     // MIs[0] rs1
     /*  195465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195477 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195482 */     GIR_RootConstrainSelectedInstOperands,
     /*  195483 */     // GIR_Coverage, 582,
     /*  195483 */     GIR_Done,
     /*  195484 */   // Label 3854: @195484
     /*  195484 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(195525), // Rule ID 781 //
     /*  195489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195506 */     // MIs[0] rs1
     /*  195506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195518 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195523 */     GIR_RootConstrainSelectedInstOperands,
     /*  195524 */     // GIR_Coverage, 781,
     /*  195524 */     GIR_Done,
     /*  195525 */   // Label 3855: @195525
     /*  195525 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(195566), // Rule ID 783 //
     /*  195530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195547 */     // MIs[0] rs1
     /*  195547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195559 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  195564 */     GIR_RootConstrainSelectedInstOperands,
     /*  195565 */     // GIR_Coverage, 783,
     /*  195565 */     GIR_Done,
     /*  195566 */   // Label 3856: @195566
     /*  195566 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(195607), // Rule ID 785 //
     /*  195571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195588 */     // MIs[0] rs1
     /*  195588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195600 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  195605 */     GIR_RootConstrainSelectedInstOperands,
     /*  195606 */     // GIR_Coverage, 785,
     /*  195606 */     GIR_Done,
     /*  195607 */   // Label 3857: @195607
     /*  195607 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(195648), // Rule ID 787 //
     /*  195612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195629 */     // MIs[0] rs1
     /*  195629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195641 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195646 */     GIR_RootConstrainSelectedInstOperands,
     /*  195647 */     // GIR_Coverage, 787,
     /*  195647 */     GIR_Done,
     /*  195648 */   // Label 3858: @195648
     /*  195648 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(195689), // Rule ID 789 //
     /*  195653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195670 */     // MIs[0] rs1
     /*  195670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195682 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195687 */     GIR_RootConstrainSelectedInstOperands,
     /*  195688 */     // GIR_Coverage, 789,
     /*  195688 */     GIR_Done,
     /*  195689 */   // Label 3859: @195689
     /*  195689 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(195730), // Rule ID 791 //
     /*  195694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195711 */     // MIs[0] rs1
     /*  195711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195723 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195728 */     GIR_RootConstrainSelectedInstOperands,
     /*  195729 */     // GIR_Coverage, 791,
     /*  195729 */     GIR_Done,
     /*  195730 */   // Label 3860: @195730
     /*  195730 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(195771), // Rule ID 793 //
     /*  195735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195752 */     // MIs[0] rs1
     /*  195752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195764 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195769 */     GIR_RootConstrainSelectedInstOperands,
     /*  195770 */     // GIR_Coverage, 793,
     /*  195770 */     GIR_Done,
     /*  195771 */   // Label 3861: @195771
     /*  195771 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(195812), // Rule ID 795 //
     /*  195776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195793 */     // MIs[0] rs1
     /*  195793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195805 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195810 */     GIR_RootConstrainSelectedInstOperands,
     /*  195811 */     // GIR_Coverage, 795,
     /*  195811 */     GIR_Done,
     /*  195812 */   // Label 3862: @195812
     /*  195812 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(195853), // Rule ID 797 //
     /*  195817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195834 */     // MIs[0] rs1
     /*  195834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195846 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195851 */     GIR_RootConstrainSelectedInstOperands,
     /*  195852 */     // GIR_Coverage, 797,
     /*  195852 */     GIR_Done,
     /*  195853 */   // Label 3863: @195853
     /*  195853 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(195894), // Rule ID 799 //
     /*  195858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195875 */     // MIs[0] rs1
     /*  195875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195887 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195892 */     GIR_RootConstrainSelectedInstOperands,
     /*  195893 */     // GIR_Coverage, 799,
     /*  195893 */     GIR_Done,
     /*  195894 */   // Label 3864: @195894
     /*  195894 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(195935), // Rule ID 961 //
     /*  195899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195916 */     // MIs[0] rs1
     /*  195916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195928 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195933 */     GIR_RootConstrainSelectedInstOperands,
     /*  195934 */     // GIR_Coverage, 961,
     /*  195934 */     GIR_Done,
     /*  195935 */   // Label 3865: @195935
     /*  195935 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(195976), // Rule ID 963 //
     /*  195940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195957 */     // MIs[0] rs1
     /*  195957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195969 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  195974 */     GIR_RootConstrainSelectedInstOperands,
     /*  195975 */     // GIR_Coverage, 963,
     /*  195975 */     GIR_Done,
     /*  195976 */   // Label 3866: @195976
     /*  195976 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(196017), // Rule ID 965 //
     /*  195981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195998 */     // MIs[0] rs1
     /*  195998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196010 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  196015 */     GIR_RootConstrainSelectedInstOperands,
     /*  196016 */     // GIR_Coverage, 965,
     /*  196016 */     GIR_Done,
     /*  196017 */   // Label 3867: @196017
     /*  196017 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(196058), // Rule ID 967 //
     /*  196022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196039 */     // MIs[0] rs1
     /*  196039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196051 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  196056 */     GIR_RootConstrainSelectedInstOperands,
     /*  196057 */     // GIR_Coverage, 967,
     /*  196057 */     GIR_Done,
     /*  196058 */   // Label 3868: @196058
     /*  196058 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(196099), // Rule ID 969 //
     /*  196063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196080 */     // MIs[0] rs1
     /*  196080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196092 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  196097 */     GIR_RootConstrainSelectedInstOperands,
     /*  196098 */     // GIR_Coverage, 969,
     /*  196098 */     GIR_Done,
     /*  196099 */   // Label 3869: @196099
     /*  196099 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(196140), // Rule ID 971 //
     /*  196104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196121 */     // MIs[0] rs1
     /*  196121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196133 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196138 */     GIR_RootConstrainSelectedInstOperands,
     /*  196139 */     // GIR_Coverage, 971,
     /*  196139 */     GIR_Done,
     /*  196140 */   // Label 3870: @196140
     /*  196140 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(196181), // Rule ID 973 //
     /*  196145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196162 */     // MIs[0] rs1
     /*  196162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196174 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196179 */     GIR_RootConstrainSelectedInstOperands,
     /*  196180 */     // GIR_Coverage, 973,
     /*  196180 */     GIR_Done,
     /*  196181 */   // Label 3871: @196181
     /*  196181 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(196222), // Rule ID 975 //
     /*  196186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196203 */     // MIs[0] rs1
     /*  196203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196215 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196220 */     GIR_RootConstrainSelectedInstOperands,
     /*  196221 */     // GIR_Coverage, 975,
     /*  196221 */     GIR_Done,
     /*  196222 */   // Label 3872: @196222
     /*  196222 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(196263), // Rule ID 977 //
     /*  196227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196244 */     // MIs[0] rs1
     /*  196244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196256 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196261 */     GIR_RootConstrainSelectedInstOperands,
     /*  196262 */     // GIR_Coverage, 977,
     /*  196262 */     GIR_Done,
     /*  196263 */   // Label 3873: @196263
     /*  196263 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(196304), // Rule ID 979 //
     /*  196268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196285 */     // MIs[0] rs1
     /*  196285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196297 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  196302 */     GIR_RootConstrainSelectedInstOperands,
     /*  196303 */     // GIR_Coverage, 979,
     /*  196303 */     GIR_Done,
     /*  196304 */   // Label 3874: @196304
     /*  196304 */   GIM_Reject,
     /*  196305 */ // Label 3834: @196305
     /*  196305 */ GIM_Reject,
     /*  196306 */ // Label 3802: @196306
     /*  196306 */ GIM_Reject,
     /*  196307 */ // Label 32: @196307
     /*  196307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3877*/ GIMT_Encode4(199216),
     /*  196318 */ /*GILLT_s32*//*Label 3875*/ GIMT_Encode4(196326),
     /*  196322 */ /*GILLT_s64*//*Label 3876*/ GIMT_Encode4(197566),
     /*  196326 */ // Label 3875: @196326
     /*  196326 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(197565),
     /*  196331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  196334 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(196375), // Rule ID 454 //
     /*  196339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196342 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196349 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196356 */     // MIs[0] rs1
     /*  196356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196368 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196373 */     GIR_RootConstrainSelectedInstOperands,
     /*  196374 */     // GIR_Coverage, 454,
     /*  196374 */     GIR_Done,
     /*  196375 */   // Label 3879: @196375
     /*  196375 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(196416), // Rule ID 456 //
     /*  196380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196383 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196397 */     // MIs[0] rs1
     /*  196397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196409 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  196414 */     GIR_RootConstrainSelectedInstOperands,
     /*  196415 */     // GIR_Coverage, 456,
     /*  196415 */     GIR_Done,
     /*  196416 */   // Label 3880: @196416
     /*  196416 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(196457), // Rule ID 458 //
     /*  196421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196424 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196431 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196438 */     // MIs[0] rs1
     /*  196438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196450 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  196455 */     GIR_RootConstrainSelectedInstOperands,
     /*  196456 */     // GIR_Coverage, 458,
     /*  196456 */     GIR_Done,
     /*  196457 */   // Label 3881: @196457
     /*  196457 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(196498), // Rule ID 460 //
     /*  196462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196479 */     // MIs[0] rs1
     /*  196479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196491 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196496 */     GIR_RootConstrainSelectedInstOperands,
     /*  196497 */     // GIR_Coverage, 460,
     /*  196497 */     GIR_Done,
     /*  196498 */   // Label 3882: @196498
     /*  196498 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(196539), // Rule ID 462 //
     /*  196503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196520 */     // MIs[0] rs1
     /*  196520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196532 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196537 */     GIR_RootConstrainSelectedInstOperands,
     /*  196538 */     // GIR_Coverage, 462,
     /*  196538 */     GIR_Done,
     /*  196539 */   // Label 3883: @196539
     /*  196539 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(196580), // Rule ID 464 //
     /*  196544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196561 */     // MIs[0] rs1
     /*  196561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196573 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196578 */     GIR_RootConstrainSelectedInstOperands,
     /*  196579 */     // GIR_Coverage, 464,
     /*  196579 */     GIR_Done,
     /*  196580 */   // Label 3884: @196580
     /*  196580 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(196621), // Rule ID 466 //
     /*  196585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196602 */     // MIs[0] rs1
     /*  196602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196614 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196619 */     GIR_RootConstrainSelectedInstOperands,
     /*  196620 */     // GIR_Coverage, 466,
     /*  196620 */     GIR_Done,
     /*  196621 */   // Label 3885: @196621
     /*  196621 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(196662), // Rule ID 468 //
     /*  196626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196629 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196643 */     // MIs[0] rs1
     /*  196643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196655 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196660 */     GIR_RootConstrainSelectedInstOperands,
     /*  196661 */     // GIR_Coverage, 468,
     /*  196661 */     GIR_Done,
     /*  196662 */   // Label 3886: @196662
     /*  196662 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(196703), // Rule ID 470 //
     /*  196667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196670 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196677 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196684 */     // MIs[0] rs1
     /*  196684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196696 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196701 */     GIR_RootConstrainSelectedInstOperands,
     /*  196702 */     // GIR_Coverage, 470,
     /*  196702 */     GIR_Done,
     /*  196703 */   // Label 3887: @196703
     /*  196703 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(196744), // Rule ID 472 //
     /*  196708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196725 */     // MIs[0] rs1
     /*  196725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196737 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196742 */     GIR_RootConstrainSelectedInstOperands,
     /*  196743 */     // GIR_Coverage, 472,
     /*  196743 */     GIR_Done,
     /*  196744 */   // Label 3888: @196744
     /*  196744 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(196785), // Rule ID 802 //
     /*  196749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196766 */     // MIs[0] rs1
     /*  196766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196778 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196783 */     GIR_RootConstrainSelectedInstOperands,
     /*  196784 */     // GIR_Coverage, 802,
     /*  196784 */     GIR_Done,
     /*  196785 */   // Label 3889: @196785
     /*  196785 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(196826), // Rule ID 804 //
     /*  196790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196807 */     // MIs[0] rs1
     /*  196807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196819 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  196824 */     GIR_RootConstrainSelectedInstOperands,
     /*  196825 */     // GIR_Coverage, 804,
     /*  196825 */     GIR_Done,
     /*  196826 */   // Label 3890: @196826
     /*  196826 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(196867), // Rule ID 806 //
     /*  196831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196848 */     // MIs[0] rs1
     /*  196848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196860 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  196865 */     GIR_RootConstrainSelectedInstOperands,
     /*  196866 */     // GIR_Coverage, 806,
     /*  196866 */     GIR_Done,
     /*  196867 */   // Label 3891: @196867
     /*  196867 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(196908), // Rule ID 808 //
     /*  196872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196875 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196882 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196889 */     // MIs[0] rs1
     /*  196889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196901 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196906 */     GIR_RootConstrainSelectedInstOperands,
     /*  196907 */     // GIR_Coverage, 808,
     /*  196907 */     GIR_Done,
     /*  196908 */   // Label 3892: @196908
     /*  196908 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(196949), // Rule ID 810 //
     /*  196913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196930 */     // MIs[0] rs1
     /*  196930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196942 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196947 */     GIR_RootConstrainSelectedInstOperands,
     /*  196948 */     // GIR_Coverage, 810,
     /*  196948 */     GIR_Done,
     /*  196949 */   // Label 3893: @196949
     /*  196949 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(196990), // Rule ID 812 //
     /*  196954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196964 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196971 */     // MIs[0] rs1
     /*  196971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196983 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196988 */     GIR_RootConstrainSelectedInstOperands,
     /*  196989 */     // GIR_Coverage, 812,
     /*  196989 */     GIR_Done,
     /*  196990 */   // Label 3894: @196990
     /*  196990 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(197031), // Rule ID 814 //
     /*  196995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197012 */     // MIs[0] rs1
     /*  197012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197024 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197029 */     GIR_RootConstrainSelectedInstOperands,
     /*  197030 */     // GIR_Coverage, 814,
     /*  197030 */     GIR_Done,
     /*  197031 */   // Label 3895: @197031
     /*  197031 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(197072), // Rule ID 816 //
     /*  197036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197039 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197053 */     // MIs[0] rs1
     /*  197053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197065 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197070 */     GIR_RootConstrainSelectedInstOperands,
     /*  197071 */     // GIR_Coverage, 816,
     /*  197071 */     GIR_Done,
     /*  197072 */   // Label 3896: @197072
     /*  197072 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(197113), // Rule ID 818 //
     /*  197077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197094 */     // MIs[0] rs1
     /*  197094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197106 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197111 */     GIR_RootConstrainSelectedInstOperands,
     /*  197112 */     // GIR_Coverage, 818,
     /*  197112 */     GIR_Done,
     /*  197113 */   // Label 3897: @197113
     /*  197113 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(197154), // Rule ID 820 //
     /*  197118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197135 */     // MIs[0] rs1
     /*  197135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197147 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197152 */     GIR_RootConstrainSelectedInstOperands,
     /*  197153 */     // GIR_Coverage, 820,
     /*  197153 */     GIR_Done,
     /*  197154 */   // Label 3898: @197154
     /*  197154 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(197195), // Rule ID 982 //
     /*  197159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197176 */     // MIs[0] rs1
     /*  197176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197188 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197193 */     GIR_RootConstrainSelectedInstOperands,
     /*  197194 */     // GIR_Coverage, 982,
     /*  197194 */     GIR_Done,
     /*  197195 */   // Label 3899: @197195
     /*  197195 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(197236), // Rule ID 984 //
     /*  197200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197217 */     // MIs[0] rs1
     /*  197217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197229 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  197234 */     GIR_RootConstrainSelectedInstOperands,
     /*  197235 */     // GIR_Coverage, 984,
     /*  197235 */     GIR_Done,
     /*  197236 */   // Label 3900: @197236
     /*  197236 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(197277), // Rule ID 986 //
     /*  197241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197258 */     // MIs[0] rs1
     /*  197258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197270 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  197275 */     GIR_RootConstrainSelectedInstOperands,
     /*  197276 */     // GIR_Coverage, 986,
     /*  197276 */     GIR_Done,
     /*  197277 */   // Label 3901: @197277
     /*  197277 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(197318), // Rule ID 988 //
     /*  197282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197299 */     // MIs[0] rs1
     /*  197299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197311 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  197316 */     GIR_RootConstrainSelectedInstOperands,
     /*  197317 */     // GIR_Coverage, 988,
     /*  197317 */     GIR_Done,
     /*  197318 */   // Label 3902: @197318
     /*  197318 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(197359), // Rule ID 990 //
     /*  197323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197333 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197340 */     // MIs[0] rs1
     /*  197340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197352 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  197357 */     GIR_RootConstrainSelectedInstOperands,
     /*  197358 */     // GIR_Coverage, 990,
     /*  197358 */     GIR_Done,
     /*  197359 */   // Label 3903: @197359
     /*  197359 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(197400), // Rule ID 992 //
     /*  197364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197367 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197374 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197381 */     // MIs[0] rs1
     /*  197381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197393 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197398 */     GIR_RootConstrainSelectedInstOperands,
     /*  197399 */     // GIR_Coverage, 992,
     /*  197399 */     GIR_Done,
     /*  197400 */   // Label 3904: @197400
     /*  197400 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(197441), // Rule ID 994 //
     /*  197405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197422 */     // MIs[0] rs1
     /*  197422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197434 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197439 */     GIR_RootConstrainSelectedInstOperands,
     /*  197440 */     // GIR_Coverage, 994,
     /*  197440 */     GIR_Done,
     /*  197441 */   // Label 3905: @197441
     /*  197441 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(197482), // Rule ID 996 //
     /*  197446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197463 */     // MIs[0] rs1
     /*  197463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197475 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197480 */     GIR_RootConstrainSelectedInstOperands,
     /*  197481 */     // GIR_Coverage, 996,
     /*  197481 */     GIR_Done,
     /*  197482 */   // Label 3906: @197482
     /*  197482 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(197523), // Rule ID 998 //
     /*  197487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197504 */     // MIs[0] rs1
     /*  197504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197516 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197521 */     GIR_RootConstrainSelectedInstOperands,
     /*  197522 */     // GIR_Coverage, 998,
     /*  197522 */     GIR_Done,
     /*  197523 */   // Label 3907: @197523
     /*  197523 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(197564), // Rule ID 1000 //
     /*  197528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197545 */     // MIs[0] rs1
     /*  197545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197557 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197562 */     GIR_RootConstrainSelectedInstOperands,
     /*  197563 */     // GIR_Coverage, 1000,
     /*  197563 */     GIR_Done,
     /*  197564 */   // Label 3908: @197564
     /*  197564 */   GIM_Reject,
     /*  197565 */ // Label 3878: @197565
     /*  197565 */ GIM_Reject,
     /*  197566 */ // Label 3876: @197566
     /*  197566 */ GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(199215),
     /*  197571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  197574 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(197615), // Rule ID 453 //
     /*  197579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197596 */     // MIs[0] rs1
     /*  197596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197608 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197613 */     GIR_RootConstrainSelectedInstOperands,
     /*  197614 */     // GIR_Coverage, 453,
     /*  197614 */     GIR_Done,
     /*  197615 */   // Label 3910: @197615
     /*  197615 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(197656), // Rule ID 455 //
     /*  197620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197637 */     // MIs[0] rs1
     /*  197637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197649 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  197654 */     GIR_RootConstrainSelectedInstOperands,
     /*  197655 */     // GIR_Coverage, 455,
     /*  197655 */     GIR_Done,
     /*  197656 */   // Label 3911: @197656
     /*  197656 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(197697), // Rule ID 457 //
     /*  197661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197664 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197671 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197678 */     // MIs[0] rs1
     /*  197678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197690 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  197695 */     GIR_RootConstrainSelectedInstOperands,
     /*  197696 */     // GIR_Coverage, 457,
     /*  197696 */     GIR_Done,
     /*  197697 */   // Label 3912: @197697
     /*  197697 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(197738), // Rule ID 459 //
     /*  197702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197719 */     // MIs[0] rs1
     /*  197719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197731 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197736 */     GIR_RootConstrainSelectedInstOperands,
     /*  197737 */     // GIR_Coverage, 459,
     /*  197737 */     GIR_Done,
     /*  197738 */   // Label 3913: @197738
     /*  197738 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(197779), // Rule ID 461 //
     /*  197743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197760 */     // MIs[0] rs1
     /*  197760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197772 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197777 */     GIR_RootConstrainSelectedInstOperands,
     /*  197778 */     // GIR_Coverage, 461,
     /*  197778 */     GIR_Done,
     /*  197779 */   // Label 3914: @197779
     /*  197779 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(197820), // Rule ID 463 //
     /*  197784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197801 */     // MIs[0] rs1
     /*  197801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197813 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197818 */     GIR_RootConstrainSelectedInstOperands,
     /*  197819 */     // GIR_Coverage, 463,
     /*  197819 */     GIR_Done,
     /*  197820 */   // Label 3915: @197820
     /*  197820 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(197861), // Rule ID 465 //
     /*  197825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197842 */     // MIs[0] rs1
     /*  197842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197854 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197854 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197859 */     GIR_RootConstrainSelectedInstOperands,
     /*  197860 */     // GIR_Coverage, 465,
     /*  197860 */     GIR_Done,
     /*  197861 */   // Label 3916: @197861
     /*  197861 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(197902), // Rule ID 467 //
     /*  197866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197883 */     // MIs[0] rs1
     /*  197883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197895 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197900 */     GIR_RootConstrainSelectedInstOperands,
     /*  197901 */     // GIR_Coverage, 467,
     /*  197901 */     GIR_Done,
     /*  197902 */   // Label 3917: @197902
     /*  197902 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(197943), // Rule ID 469 //
     /*  197907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197924 */     // MIs[0] rs1
     /*  197924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197936 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197941 */     GIR_RootConstrainSelectedInstOperands,
     /*  197942 */     // GIR_Coverage, 469,
     /*  197942 */     GIR_Done,
     /*  197943 */   // Label 3918: @197943
     /*  197943 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(197984), // Rule ID 471 //
     /*  197948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197965 */     // MIs[0] rs1
     /*  197965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197977 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197982 */     GIR_RootConstrainSelectedInstOperands,
     /*  197983 */     // GIR_Coverage, 471,
     /*  197983 */     GIR_Done,
     /*  197984 */   // Label 3919: @197984
     /*  197984 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(198025), // Rule ID 583 //
     /*  197989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198006 */     // MIs[0] rs1
     /*  198006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198018 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198023 */     GIR_RootConstrainSelectedInstOperands,
     /*  198024 */     // GIR_Coverage, 583,
     /*  198024 */     GIR_Done,
     /*  198025 */   // Label 3920: @198025
     /*  198025 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(198066), // Rule ID 584 //
     /*  198030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198047 */     // MIs[0] rs1
     /*  198047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198059 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  198064 */     GIR_RootConstrainSelectedInstOperands,
     /*  198065 */     // GIR_Coverage, 584,
     /*  198065 */     GIR_Done,
     /*  198066 */   // Label 3921: @198066
     /*  198066 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(198107), // Rule ID 585 //
     /*  198071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198088 */     // MIs[0] rs1
     /*  198088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198100 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  198105 */     GIR_RootConstrainSelectedInstOperands,
     /*  198106 */     // GIR_Coverage, 585,
     /*  198106 */     GIR_Done,
     /*  198107 */   // Label 3922: @198107
     /*  198107 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(198148), // Rule ID 586 //
     /*  198112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198129 */     // MIs[0] rs1
     /*  198129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198141 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  198146 */     GIR_RootConstrainSelectedInstOperands,
     /*  198147 */     // GIR_Coverage, 586,
     /*  198147 */     GIR_Done,
     /*  198148 */   // Label 3923: @198148
     /*  198148 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(198189), // Rule ID 587 //
     /*  198153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198170 */     // MIs[0] rs1
     /*  198170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198182 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  198187 */     GIR_RootConstrainSelectedInstOperands,
     /*  198188 */     // GIR_Coverage, 587,
     /*  198188 */     GIR_Done,
     /*  198189 */   // Label 3924: @198189
     /*  198189 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(198230), // Rule ID 588 //
     /*  198194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198211 */     // MIs[0] rs1
     /*  198211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198223 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198228 */     GIR_RootConstrainSelectedInstOperands,
     /*  198229 */     // GIR_Coverage, 588,
     /*  198229 */     GIR_Done,
     /*  198230 */   // Label 3925: @198230
     /*  198230 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(198271), // Rule ID 589 //
     /*  198235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198252 */     // MIs[0] rs1
     /*  198252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198264 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198269 */     GIR_RootConstrainSelectedInstOperands,
     /*  198270 */     // GIR_Coverage, 589,
     /*  198270 */     GIR_Done,
     /*  198271 */   // Label 3926: @198271
     /*  198271 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(198312), // Rule ID 590 //
     /*  198276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198293 */     // MIs[0] rs1
     /*  198293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198305 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198310 */     GIR_RootConstrainSelectedInstOperands,
     /*  198311 */     // GIR_Coverage, 590,
     /*  198311 */     GIR_Done,
     /*  198312 */   // Label 3927: @198312
     /*  198312 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(198353), // Rule ID 591 //
     /*  198317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198334 */     // MIs[0] rs1
     /*  198334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198346 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198351 */     GIR_RootConstrainSelectedInstOperands,
     /*  198352 */     // GIR_Coverage, 591,
     /*  198352 */     GIR_Done,
     /*  198353 */   // Label 3928: @198353
     /*  198353 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(198394), // Rule ID 592 //
     /*  198358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198361 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198375 */     // MIs[0] rs1
     /*  198375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198387 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  198392 */     GIR_RootConstrainSelectedInstOperands,
     /*  198393 */     // GIR_Coverage, 592,
     /*  198393 */     GIR_Done,
     /*  198394 */   // Label 3929: @198394
     /*  198394 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(198435), // Rule ID 801 //
     /*  198399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198416 */     // MIs[0] rs1
     /*  198416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198428 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198433 */     GIR_RootConstrainSelectedInstOperands,
     /*  198434 */     // GIR_Coverage, 801,
     /*  198434 */     GIR_Done,
     /*  198435 */   // Label 3930: @198435
     /*  198435 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(198476), // Rule ID 803 //
     /*  198440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198457 */     // MIs[0] rs1
     /*  198457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198469 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  198474 */     GIR_RootConstrainSelectedInstOperands,
     /*  198475 */     // GIR_Coverage, 803,
     /*  198475 */     GIR_Done,
     /*  198476 */   // Label 3931: @198476
     /*  198476 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198517), // Rule ID 805 //
     /*  198481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198498 */     // MIs[0] rs1
     /*  198498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198510 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  198515 */     GIR_RootConstrainSelectedInstOperands,
     /*  198516 */     // GIR_Coverage, 805,
     /*  198516 */     GIR_Done,
     /*  198517 */   // Label 3932: @198517
     /*  198517 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198558), // Rule ID 807 //
     /*  198522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198539 */     // MIs[0] rs1
     /*  198539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198551 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198556 */     GIR_RootConstrainSelectedInstOperands,
     /*  198557 */     // GIR_Coverage, 807,
     /*  198557 */     GIR_Done,
     /*  198558 */   // Label 3933: @198558
     /*  198558 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198599), // Rule ID 809 //
     /*  198563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198580 */     // MIs[0] rs1
     /*  198580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198592 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198597 */     GIR_RootConstrainSelectedInstOperands,
     /*  198598 */     // GIR_Coverage, 809,
     /*  198598 */     GIR_Done,
     /*  198599 */   // Label 3934: @198599
     /*  198599 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198640), // Rule ID 811 //
     /*  198604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198621 */     // MIs[0] rs1
     /*  198621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198633 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198638 */     GIR_RootConstrainSelectedInstOperands,
     /*  198639 */     // GIR_Coverage, 811,
     /*  198639 */     GIR_Done,
     /*  198640 */   // Label 3935: @198640
     /*  198640 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198681), // Rule ID 813 //
     /*  198645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198662 */     // MIs[0] rs1
     /*  198662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198674 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198679 */     GIR_RootConstrainSelectedInstOperands,
     /*  198680 */     // GIR_Coverage, 813,
     /*  198680 */     GIR_Done,
     /*  198681 */   // Label 3936: @198681
     /*  198681 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198722), // Rule ID 815 //
     /*  198686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198703 */     // MIs[0] rs1
     /*  198703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198715 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198720 */     GIR_RootConstrainSelectedInstOperands,
     /*  198721 */     // GIR_Coverage, 815,
     /*  198721 */     GIR_Done,
     /*  198722 */   // Label 3937: @198722
     /*  198722 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198763), // Rule ID 817 //
     /*  198727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198744 */     // MIs[0] rs1
     /*  198744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198756 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198761 */     GIR_RootConstrainSelectedInstOperands,
     /*  198762 */     // GIR_Coverage, 817,
     /*  198762 */     GIR_Done,
     /*  198763 */   // Label 3938: @198763
     /*  198763 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198804), // Rule ID 819 //
     /*  198768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198785 */     // MIs[0] rs1
     /*  198785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198797 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198802 */     GIR_RootConstrainSelectedInstOperands,
     /*  198803 */     // GIR_Coverage, 819,
     /*  198803 */     GIR_Done,
     /*  198804 */   // Label 3939: @198804
     /*  198804 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198845), // Rule ID 981 //
     /*  198809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198826 */     // MIs[0] rs1
     /*  198826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198838 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198843 */     GIR_RootConstrainSelectedInstOperands,
     /*  198844 */     // GIR_Coverage, 981,
     /*  198844 */     GIR_Done,
     /*  198845 */   // Label 3940: @198845
     /*  198845 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198886), // Rule ID 983 //
     /*  198850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198867 */     // MIs[0] rs1
     /*  198867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198879 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  198884 */     GIR_RootConstrainSelectedInstOperands,
     /*  198885 */     // GIR_Coverage, 983,
     /*  198885 */     GIR_Done,
     /*  198886 */   // Label 3941: @198886
     /*  198886 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198927), // Rule ID 985 //
     /*  198891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198908 */     // MIs[0] rs1
     /*  198908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198920 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  198925 */     GIR_RootConstrainSelectedInstOperands,
     /*  198926 */     // GIR_Coverage, 985,
     /*  198926 */     GIR_Done,
     /*  198927 */   // Label 3942: @198927
     /*  198927 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198968), // Rule ID 987 //
     /*  198932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198949 */     // MIs[0] rs1
     /*  198949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198961 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198966 */     GIR_RootConstrainSelectedInstOperands,
     /*  198967 */     // GIR_Coverage, 987,
     /*  198967 */     GIR_Done,
     /*  198968 */   // Label 3943: @198968
     /*  198968 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(199009), // Rule ID 989 //
     /*  198973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198990 */     // MIs[0] rs1
     /*  198990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199002 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  199007 */     GIR_RootConstrainSelectedInstOperands,
     /*  199008 */     // GIR_Coverage, 989,
     /*  199008 */     GIR_Done,
     /*  199009 */   // Label 3944: @199009
     /*  199009 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(199050), // Rule ID 991 //
     /*  199014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199024 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199031 */     // MIs[0] rs1
     /*  199031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199043 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199048 */     GIR_RootConstrainSelectedInstOperands,
     /*  199049 */     // GIR_Coverage, 991,
     /*  199049 */     GIR_Done,
     /*  199050 */   // Label 3945: @199050
     /*  199050 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(199091), // Rule ID 993 //
     /*  199055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199072 */     // MIs[0] rs1
     /*  199072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199084 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199089 */     GIR_RootConstrainSelectedInstOperands,
     /*  199090 */     // GIR_Coverage, 993,
     /*  199090 */     GIR_Done,
     /*  199091 */   // Label 3946: @199091
     /*  199091 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(199132), // Rule ID 995 //
     /*  199096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199113 */     // MIs[0] rs1
     /*  199113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199125 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199130 */     GIR_RootConstrainSelectedInstOperands,
     /*  199131 */     // GIR_Coverage, 995,
     /*  199131 */     GIR_Done,
     /*  199132 */   // Label 3947: @199132
     /*  199132 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(199173), // Rule ID 997 //
     /*  199137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199154 */     // MIs[0] rs1
     /*  199154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199166 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199171 */     GIR_RootConstrainSelectedInstOperands,
     /*  199172 */     // GIR_Coverage, 997,
     /*  199172 */     GIR_Done,
     /*  199173 */   // Label 3948: @199173
     /*  199173 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(199214), // Rule ID 999 //
     /*  199178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199195 */     // MIs[0] rs1
     /*  199195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199207 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  199212 */     GIR_RootConstrainSelectedInstOperands,
     /*  199213 */     // GIR_Coverage, 999,
     /*  199213 */     GIR_Done,
     /*  199214 */   // Label 3949: @199214
     /*  199214 */   GIM_Reject,
     /*  199215 */ // Label 3909: @199215
     /*  199215 */ GIM_Reject,
     /*  199216 */ // Label 3877: @199216
     /*  199216 */ GIM_Reject,
     /*  199217 */ // Label 33: @199217
     /*  199217 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3952*/ GIMT_Encode4(202126),
     /*  199228 */ /*GILLT_s32*//*Label 3950*/ GIMT_Encode4(199236),
     /*  199232 */ /*GILLT_s64*//*Label 3951*/ GIMT_Encode4(200476),
     /*  199236 */ // Label 3950: @199236
     /*  199236 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(200475),
     /*  199241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  199244 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199285), // Rule ID 474 //
     /*  199249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199252 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199266 */     // MIs[0] rs1
     /*  199266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199278 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199283 */     GIR_RootConstrainSelectedInstOperands,
     /*  199284 */     // GIR_Coverage, 474,
     /*  199284 */     GIR_Done,
     /*  199285 */   // Label 3954: @199285
     /*  199285 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199326), // Rule ID 476 //
     /*  199290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199307 */     // MIs[0] rs1
     /*  199307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199319 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  199324 */     GIR_RootConstrainSelectedInstOperands,
     /*  199325 */     // GIR_Coverage, 476,
     /*  199325 */     GIR_Done,
     /*  199326 */   // Label 3955: @199326
     /*  199326 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199367), // Rule ID 478 //
     /*  199331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199334 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199348 */     // MIs[0] rs1
     /*  199348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199360 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  199365 */     GIR_RootConstrainSelectedInstOperands,
     /*  199366 */     // GIR_Coverage, 478,
     /*  199366 */     GIR_Done,
     /*  199367 */   // Label 3956: @199367
     /*  199367 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199408), // Rule ID 480 //
     /*  199372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199389 */     // MIs[0] rs1
     /*  199389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199401 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199406 */     GIR_RootConstrainSelectedInstOperands,
     /*  199407 */     // GIR_Coverage, 480,
     /*  199407 */     GIR_Done,
     /*  199408 */   // Label 3957: @199408
     /*  199408 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(199449), // Rule ID 482 //
     /*  199413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199430 */     // MIs[0] rs1
     /*  199430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199442 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199447 */     GIR_RootConstrainSelectedInstOperands,
     /*  199448 */     // GIR_Coverage, 482,
     /*  199448 */     GIR_Done,
     /*  199449 */   // Label 3958: @199449
     /*  199449 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(199490), // Rule ID 484 //
     /*  199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199471 */     // MIs[0] rs1
     /*  199471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199483 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199488 */     GIR_RootConstrainSelectedInstOperands,
     /*  199489 */     // GIR_Coverage, 484,
     /*  199489 */     GIR_Done,
     /*  199490 */   // Label 3959: @199490
     /*  199490 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(199531), // Rule ID 486 //
     /*  199495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199512 */     // MIs[0] rs1
     /*  199512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199524 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199529 */     GIR_RootConstrainSelectedInstOperands,
     /*  199530 */     // GIR_Coverage, 486,
     /*  199530 */     GIR_Done,
     /*  199531 */   // Label 3960: @199531
     /*  199531 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(199572), // Rule ID 488 //
     /*  199536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199553 */     // MIs[0] rs1
     /*  199553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199565 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199570 */     GIR_RootConstrainSelectedInstOperands,
     /*  199571 */     // GIR_Coverage, 488,
     /*  199571 */     GIR_Done,
     /*  199572 */   // Label 3961: @199572
     /*  199572 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(199613), // Rule ID 490 //
     /*  199577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199594 */     // MIs[0] rs1
     /*  199594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199606 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199611 */     GIR_RootConstrainSelectedInstOperands,
     /*  199612 */     // GIR_Coverage, 490,
     /*  199612 */     GIR_Done,
     /*  199613 */   // Label 3962: @199613
     /*  199613 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(199654), // Rule ID 492 //
     /*  199618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199635 */     // MIs[0] rs1
     /*  199635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199647 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199652 */     GIR_RootConstrainSelectedInstOperands,
     /*  199653 */     // GIR_Coverage, 492,
     /*  199653 */     GIR_Done,
     /*  199654 */   // Label 3963: @199654
     /*  199654 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(199695), // Rule ID 822 //
     /*  199659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199676 */     // MIs[0] rs1
     /*  199676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199688 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199693 */     GIR_RootConstrainSelectedInstOperands,
     /*  199694 */     // GIR_Coverage, 822,
     /*  199694 */     GIR_Done,
     /*  199695 */   // Label 3964: @199695
     /*  199695 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(199736), // Rule ID 824 //
     /*  199700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199717 */     // MIs[0] rs1
     /*  199717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199729 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  199734 */     GIR_RootConstrainSelectedInstOperands,
     /*  199735 */     // GIR_Coverage, 824,
     /*  199735 */     GIR_Done,
     /*  199736 */   // Label 3965: @199736
     /*  199736 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(199777), // Rule ID 826 //
     /*  199741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199758 */     // MIs[0] rs1
     /*  199758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199770 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  199775 */     GIR_RootConstrainSelectedInstOperands,
     /*  199776 */     // GIR_Coverage, 826,
     /*  199776 */     GIR_Done,
     /*  199777 */   // Label 3966: @199777
     /*  199777 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199818), // Rule ID 828 //
     /*  199782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199799 */     // MIs[0] rs1
     /*  199799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199811 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199816 */     GIR_RootConstrainSelectedInstOperands,
     /*  199817 */     // GIR_Coverage, 828,
     /*  199817 */     GIR_Done,
     /*  199818 */   // Label 3967: @199818
     /*  199818 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199859), // Rule ID 830 //
     /*  199823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199840 */     // MIs[0] rs1
     /*  199840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199852 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199857 */     GIR_RootConstrainSelectedInstOperands,
     /*  199858 */     // GIR_Coverage, 830,
     /*  199858 */     GIR_Done,
     /*  199859 */   // Label 3968: @199859
     /*  199859 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199900), // Rule ID 832 //
     /*  199864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199881 */     // MIs[0] rs1
     /*  199881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199893 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199898 */     GIR_RootConstrainSelectedInstOperands,
     /*  199899 */     // GIR_Coverage, 832,
     /*  199899 */     GIR_Done,
     /*  199900 */   // Label 3969: @199900
     /*  199900 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199941), // Rule ID 834 //
     /*  199905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199922 */     // MIs[0] rs1
     /*  199922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199934 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199939 */     GIR_RootConstrainSelectedInstOperands,
     /*  199940 */     // GIR_Coverage, 834,
     /*  199940 */     GIR_Done,
     /*  199941 */   // Label 3970: @199941
     /*  199941 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199982), // Rule ID 836 //
     /*  199946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199963 */     // MIs[0] rs1
     /*  199963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199975 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199980 */     GIR_RootConstrainSelectedInstOperands,
     /*  199981 */     // GIR_Coverage, 836,
     /*  199981 */     GIR_Done,
     /*  199982 */   // Label 3971: @199982
     /*  199982 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(200023), // Rule ID 838 //
     /*  199987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200004 */     // MIs[0] rs1
     /*  200004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200016 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200021 */     GIR_RootConstrainSelectedInstOperands,
     /*  200022 */     // GIR_Coverage, 838,
     /*  200022 */     GIR_Done,
     /*  200023 */   // Label 3972: @200023
     /*  200023 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(200064), // Rule ID 840 //
     /*  200028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200045 */     // MIs[0] rs1
     /*  200045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200057 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200062 */     GIR_RootConstrainSelectedInstOperands,
     /*  200063 */     // GIR_Coverage, 840,
     /*  200063 */     GIR_Done,
     /*  200064 */   // Label 3973: @200064
     /*  200064 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(200105), // Rule ID 1002 //
     /*  200069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200086 */     // MIs[0] rs1
     /*  200086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200098 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200103 */     GIR_RootConstrainSelectedInstOperands,
     /*  200104 */     // GIR_Coverage, 1002,
     /*  200104 */     GIR_Done,
     /*  200105 */   // Label 3974: @200105
     /*  200105 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(200146), // Rule ID 1004 //
     /*  200110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200127 */     // MIs[0] rs1
     /*  200127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200139 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  200144 */     GIR_RootConstrainSelectedInstOperands,
     /*  200145 */     // GIR_Coverage, 1004,
     /*  200145 */     GIR_Done,
     /*  200146 */   // Label 3975: @200146
     /*  200146 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(200187), // Rule ID 1006 //
     /*  200151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200161 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200168 */     // MIs[0] rs1
     /*  200168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200180 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  200185 */     GIR_RootConstrainSelectedInstOperands,
     /*  200186 */     // GIR_Coverage, 1006,
     /*  200186 */     GIR_Done,
     /*  200187 */   // Label 3976: @200187
     /*  200187 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200228), // Rule ID 1008 //
     /*  200192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200209 */     // MIs[0] rs1
     /*  200209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200221 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200226 */     GIR_RootConstrainSelectedInstOperands,
     /*  200227 */     // GIR_Coverage, 1008,
     /*  200227 */     GIR_Done,
     /*  200228 */   // Label 3977: @200228
     /*  200228 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(200269), // Rule ID 1010 //
     /*  200233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200250 */     // MIs[0] rs1
     /*  200250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200262 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200267 */     GIR_RootConstrainSelectedInstOperands,
     /*  200268 */     // GIR_Coverage, 1010,
     /*  200268 */     GIR_Done,
     /*  200269 */   // Label 3978: @200269
     /*  200269 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200310), // Rule ID 1012 //
     /*  200274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200291 */     // MIs[0] rs1
     /*  200291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200303 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200308 */     GIR_RootConstrainSelectedInstOperands,
     /*  200309 */     // GIR_Coverage, 1012,
     /*  200309 */     GIR_Done,
     /*  200310 */   // Label 3979: @200310
     /*  200310 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200351), // Rule ID 1014 //
     /*  200315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200332 */     // MIs[0] rs1
     /*  200332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200344 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200349 */     GIR_RootConstrainSelectedInstOperands,
     /*  200350 */     // GIR_Coverage, 1014,
     /*  200350 */     GIR_Done,
     /*  200351 */   // Label 3980: @200351
     /*  200351 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200392), // Rule ID 1016 //
     /*  200356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200373 */     // MIs[0] rs1
     /*  200373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200385 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200390 */     GIR_RootConstrainSelectedInstOperands,
     /*  200391 */     // GIR_Coverage, 1016,
     /*  200391 */     GIR_Done,
     /*  200392 */   // Label 3981: @200392
     /*  200392 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200433), // Rule ID 1018 //
     /*  200397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200414 */     // MIs[0] rs1
     /*  200414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200426 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200431 */     GIR_RootConstrainSelectedInstOperands,
     /*  200432 */     // GIR_Coverage, 1018,
     /*  200432 */     GIR_Done,
     /*  200433 */   // Label 3982: @200433
     /*  200433 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200474), // Rule ID 1020 //
     /*  200438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200455 */     // MIs[0] rs1
     /*  200455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200467 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200472 */     GIR_RootConstrainSelectedInstOperands,
     /*  200473 */     // GIR_Coverage, 1020,
     /*  200473 */     GIR_Done,
     /*  200474 */   // Label 3983: @200474
     /*  200474 */   GIM_Reject,
     /*  200475 */ // Label 3953: @200475
     /*  200475 */ GIM_Reject,
     /*  200476 */ // Label 3951: @200476
     /*  200476 */ GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(202125),
     /*  200481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200484 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200525), // Rule ID 473 //
     /*  200489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200506 */     // MIs[0] rs1
     /*  200506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200518 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200523 */     GIR_RootConstrainSelectedInstOperands,
     /*  200524 */     // GIR_Coverage, 473,
     /*  200524 */     GIR_Done,
     /*  200525 */   // Label 3985: @200525
     /*  200525 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200566), // Rule ID 475 //
     /*  200530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200547 */     // MIs[0] rs1
     /*  200547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200559 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  200564 */     GIR_RootConstrainSelectedInstOperands,
     /*  200565 */     // GIR_Coverage, 475,
     /*  200565 */     GIR_Done,
     /*  200566 */   // Label 3986: @200566
     /*  200566 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200607), // Rule ID 477 //
     /*  200571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200588 */     // MIs[0] rs1
     /*  200588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200600 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  200605 */     GIR_RootConstrainSelectedInstOperands,
     /*  200606 */     // GIR_Coverage, 477,
     /*  200606 */     GIR_Done,
     /*  200607 */   // Label 3987: @200607
     /*  200607 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200648), // Rule ID 479 //
     /*  200612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200615 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200629 */     // MIs[0] rs1
     /*  200629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200641 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200646 */     GIR_RootConstrainSelectedInstOperands,
     /*  200647 */     // GIR_Coverage, 479,
     /*  200647 */     GIR_Done,
     /*  200648 */   // Label 3988: @200648
     /*  200648 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200689), // Rule ID 481 //
     /*  200653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200670 */     // MIs[0] rs1
     /*  200670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200682 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200687 */     GIR_RootConstrainSelectedInstOperands,
     /*  200688 */     // GIR_Coverage, 481,
     /*  200688 */     GIR_Done,
     /*  200689 */   // Label 3989: @200689
     /*  200689 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200730), // Rule ID 483 //
     /*  200694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200711 */     // MIs[0] rs1
     /*  200711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200723 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200728 */     GIR_RootConstrainSelectedInstOperands,
     /*  200729 */     // GIR_Coverage, 483,
     /*  200729 */     GIR_Done,
     /*  200730 */   // Label 3990: @200730
     /*  200730 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200771), // Rule ID 485 //
     /*  200735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200752 */     // MIs[0] rs1
     /*  200752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200764 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200769 */     GIR_RootConstrainSelectedInstOperands,
     /*  200770 */     // GIR_Coverage, 485,
     /*  200770 */     GIR_Done,
     /*  200771 */   // Label 3991: @200771
     /*  200771 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200812), // Rule ID 487 //
     /*  200776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200793 */     // MIs[0] rs1
     /*  200793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200805 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200810 */     GIR_RootConstrainSelectedInstOperands,
     /*  200811 */     // GIR_Coverage, 487,
     /*  200811 */     GIR_Done,
     /*  200812 */   // Label 3992: @200812
     /*  200812 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200853), // Rule ID 489 //
     /*  200817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200834 */     // MIs[0] rs1
     /*  200834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200846 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200851 */     GIR_RootConstrainSelectedInstOperands,
     /*  200852 */     // GIR_Coverage, 489,
     /*  200852 */     GIR_Done,
     /*  200853 */   // Label 3993: @200853
     /*  200853 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200894), // Rule ID 491 //
     /*  200858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200875 */     // MIs[0] rs1
     /*  200875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200887 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200892 */     GIR_RootConstrainSelectedInstOperands,
     /*  200893 */     // GIR_Coverage, 491,
     /*  200893 */     GIR_Done,
     /*  200894 */   // Label 3994: @200894
     /*  200894 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200935), // Rule ID 593 //
     /*  200899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200916 */     // MIs[0] rs1
     /*  200916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200928 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200933 */     GIR_RootConstrainSelectedInstOperands,
     /*  200934 */     // GIR_Coverage, 593,
     /*  200934 */     GIR_Done,
     /*  200935 */   // Label 3995: @200935
     /*  200935 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200976), // Rule ID 594 //
     /*  200940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200957 */     // MIs[0] rs1
     /*  200957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200969 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  200974 */     GIR_RootConstrainSelectedInstOperands,
     /*  200975 */     // GIR_Coverage, 594,
     /*  200975 */     GIR_Done,
     /*  200976 */   // Label 3996: @200976
     /*  200976 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(201017), // Rule ID 595 //
     /*  200981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200998 */     // MIs[0] rs1
     /*  200998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201010 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  201015 */     GIR_RootConstrainSelectedInstOperands,
     /*  201016 */     // GIR_Coverage, 595,
     /*  201016 */     GIR_Done,
     /*  201017 */   // Label 3997: @201017
     /*  201017 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(201058), // Rule ID 596 //
     /*  201022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201039 */     // MIs[0] rs1
     /*  201039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201051 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  201056 */     GIR_RootConstrainSelectedInstOperands,
     /*  201057 */     // GIR_Coverage, 596,
     /*  201057 */     GIR_Done,
     /*  201058 */   // Label 3998: @201058
     /*  201058 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(201099), // Rule ID 597 //
     /*  201063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201080 */     // MIs[0] rs1
     /*  201080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201092 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  201097 */     GIR_RootConstrainSelectedInstOperands,
     /*  201098 */     // GIR_Coverage, 597,
     /*  201098 */     GIR_Done,
     /*  201099 */   // Label 3999: @201099
     /*  201099 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(201140), // Rule ID 598 //
     /*  201104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201121 */     // MIs[0] rs1
     /*  201121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201133 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201138 */     GIR_RootConstrainSelectedInstOperands,
     /*  201139 */     // GIR_Coverage, 598,
     /*  201139 */     GIR_Done,
     /*  201140 */   // Label 4000: @201140
     /*  201140 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(201181), // Rule ID 599 //
     /*  201145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201162 */     // MIs[0] rs1
     /*  201162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201174 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201179 */     GIR_RootConstrainSelectedInstOperands,
     /*  201180 */     // GIR_Coverage, 599,
     /*  201180 */     GIR_Done,
     /*  201181 */   // Label 4001: @201181
     /*  201181 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201222), // Rule ID 600 //
     /*  201186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201203 */     // MIs[0] rs1
     /*  201203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201215 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201220 */     GIR_RootConstrainSelectedInstOperands,
     /*  201221 */     // GIR_Coverage, 600,
     /*  201221 */     GIR_Done,
     /*  201222 */   // Label 4002: @201222
     /*  201222 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201263), // Rule ID 601 //
     /*  201227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201244 */     // MIs[0] rs1
     /*  201244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201256 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201261 */     GIR_RootConstrainSelectedInstOperands,
     /*  201262 */     // GIR_Coverage, 601,
     /*  201262 */     GIR_Done,
     /*  201263 */   // Label 4003: @201263
     /*  201263 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201304), // Rule ID 602 //
     /*  201268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201285 */     // MIs[0] rs1
     /*  201285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201297 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  201302 */     GIR_RootConstrainSelectedInstOperands,
     /*  201303 */     // GIR_Coverage, 602,
     /*  201303 */     GIR_Done,
     /*  201304 */   // Label 4004: @201304
     /*  201304 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201345), // Rule ID 821 //
     /*  201309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201326 */     // MIs[0] rs1
     /*  201326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201338 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201343 */     GIR_RootConstrainSelectedInstOperands,
     /*  201344 */     // GIR_Coverage, 821,
     /*  201344 */     GIR_Done,
     /*  201345 */   // Label 4005: @201345
     /*  201345 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201386), // Rule ID 823 //
     /*  201350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201367 */     // MIs[0] rs1
     /*  201367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201379 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  201384 */     GIR_RootConstrainSelectedInstOperands,
     /*  201385 */     // GIR_Coverage, 823,
     /*  201385 */     GIR_Done,
     /*  201386 */   // Label 4006: @201386
     /*  201386 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201427), // Rule ID 825 //
     /*  201391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201408 */     // MIs[0] rs1
     /*  201408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201420 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  201425 */     GIR_RootConstrainSelectedInstOperands,
     /*  201426 */     // GIR_Coverage, 825,
     /*  201426 */     GIR_Done,
     /*  201427 */   // Label 4007: @201427
     /*  201427 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201468), // Rule ID 827 //
     /*  201432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201449 */     // MIs[0] rs1
     /*  201449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201461 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201466 */     GIR_RootConstrainSelectedInstOperands,
     /*  201467 */     // GIR_Coverage, 827,
     /*  201467 */     GIR_Done,
     /*  201468 */   // Label 4008: @201468
     /*  201468 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201509), // Rule ID 829 //
     /*  201473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201490 */     // MIs[0] rs1
     /*  201490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201502 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201507 */     GIR_RootConstrainSelectedInstOperands,
     /*  201508 */     // GIR_Coverage, 829,
     /*  201508 */     GIR_Done,
     /*  201509 */   // Label 4009: @201509
     /*  201509 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201550), // Rule ID 831 //
     /*  201514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201531 */     // MIs[0] rs1
     /*  201531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201543 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201548 */     GIR_RootConstrainSelectedInstOperands,
     /*  201549 */     // GIR_Coverage, 831,
     /*  201549 */     GIR_Done,
     /*  201550 */   // Label 4010: @201550
     /*  201550 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201591), // Rule ID 833 //
     /*  201555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201572 */     // MIs[0] rs1
     /*  201572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201584 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201589 */     GIR_RootConstrainSelectedInstOperands,
     /*  201590 */     // GIR_Coverage, 833,
     /*  201590 */     GIR_Done,
     /*  201591 */   // Label 4011: @201591
     /*  201591 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201632), // Rule ID 835 //
     /*  201596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201613 */     // MIs[0] rs1
     /*  201613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201625 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201630 */     GIR_RootConstrainSelectedInstOperands,
     /*  201631 */     // GIR_Coverage, 835,
     /*  201631 */     GIR_Done,
     /*  201632 */   // Label 4012: @201632
     /*  201632 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201673), // Rule ID 837 //
     /*  201637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201654 */     // MIs[0] rs1
     /*  201654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201666 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201671 */     GIR_RootConstrainSelectedInstOperands,
     /*  201672 */     // GIR_Coverage, 837,
     /*  201672 */     GIR_Done,
     /*  201673 */   // Label 4013: @201673
     /*  201673 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201714), // Rule ID 839 //
     /*  201678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201695 */     // MIs[0] rs1
     /*  201695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201707 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201712 */     GIR_RootConstrainSelectedInstOperands,
     /*  201713 */     // GIR_Coverage, 839,
     /*  201713 */     GIR_Done,
     /*  201714 */   // Label 4014: @201714
     /*  201714 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201755), // Rule ID 1001 //
     /*  201719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201736 */     // MIs[0] rs1
     /*  201736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201748 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201753 */     GIR_RootConstrainSelectedInstOperands,
     /*  201754 */     // GIR_Coverage, 1001,
     /*  201754 */     GIR_Done,
     /*  201755 */   // Label 4015: @201755
     /*  201755 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201796), // Rule ID 1003 //
     /*  201760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201777 */     // MIs[0] rs1
     /*  201777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201789 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  201794 */     GIR_RootConstrainSelectedInstOperands,
     /*  201795 */     // GIR_Coverage, 1003,
     /*  201795 */     GIR_Done,
     /*  201796 */   // Label 4016: @201796
     /*  201796 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201837), // Rule ID 1005 //
     /*  201801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201818 */     // MIs[0] rs1
     /*  201818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201830 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  201835 */     GIR_RootConstrainSelectedInstOperands,
     /*  201836 */     // GIR_Coverage, 1005,
     /*  201836 */     GIR_Done,
     /*  201837 */   // Label 4017: @201837
     /*  201837 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201878), // Rule ID 1007 //
     /*  201842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201859 */     // MIs[0] rs1
     /*  201859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201871 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201876 */     GIR_RootConstrainSelectedInstOperands,
     /*  201877 */     // GIR_Coverage, 1007,
     /*  201877 */     GIR_Done,
     /*  201878 */   // Label 4018: @201878
     /*  201878 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201919), // Rule ID 1009 //
     /*  201883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201900 */     // MIs[0] rs1
     /*  201900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201912 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201917 */     GIR_RootConstrainSelectedInstOperands,
     /*  201918 */     // GIR_Coverage, 1009,
     /*  201918 */     GIR_Done,
     /*  201919 */   // Label 4019: @201919
     /*  201919 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201960), // Rule ID 1011 //
     /*  201924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201927 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201941 */     // MIs[0] rs1
     /*  201941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201953 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201958 */     GIR_RootConstrainSelectedInstOperands,
     /*  201959 */     // GIR_Coverage, 1011,
     /*  201959 */     GIR_Done,
     /*  201960 */   // Label 4020: @201960
     /*  201960 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202001), // Rule ID 1013 //
     /*  201965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201968 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201982 */     // MIs[0] rs1
     /*  201982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201994 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201999 */     GIR_RootConstrainSelectedInstOperands,
     /*  202000 */     // GIR_Coverage, 1013,
     /*  202000 */     GIR_Done,
     /*  202001 */   // Label 4021: @202001
     /*  202001 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202042), // Rule ID 1015 //
     /*  202006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202009 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202023 */     // MIs[0] rs1
     /*  202023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202035 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202040 */     GIR_RootConstrainSelectedInstOperands,
     /*  202041 */     // GIR_Coverage, 1015,
     /*  202041 */     GIR_Done,
     /*  202042 */   // Label 4022: @202042
     /*  202042 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202083), // Rule ID 1017 //
     /*  202047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202064 */     // MIs[0] rs1
     /*  202064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202076 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202081 */     GIR_RootConstrainSelectedInstOperands,
     /*  202082 */     // GIR_Coverage, 1017,
     /*  202082 */     GIR_Done,
     /*  202083 */   // Label 4023: @202083
     /*  202083 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202124), // Rule ID 1019 //
     /*  202088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202105 */     // MIs[0] rs1
     /*  202105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202117 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  202122 */     GIR_RootConstrainSelectedInstOperands,
     /*  202123 */     // GIR_Coverage, 1019,
     /*  202123 */     GIR_Done,
     /*  202124 */   // Label 4024: @202124
     /*  202124 */   GIM_Reject,
     /*  202125 */ // Label 3984: @202125
     /*  202125 */ GIM_Reject,
     /*  202126 */ // Label 3952: @202126
     /*  202126 */ GIM_Reject,
     /*  202127 */ // Label 34: @202127
     /*  202127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4027*/ GIMT_Encode4(205036),
     /*  202138 */ /*GILLT_s32*//*Label 4025*/ GIMT_Encode4(202146),
     /*  202142 */ /*GILLT_s64*//*Label 4026*/ GIMT_Encode4(203386),
     /*  202146 */ // Label 4025: @202146
     /*  202146 */ GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203385),
     /*  202151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  202154 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202195), // Rule ID 494 //
     /*  202159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202176 */     // MIs[0] rs1
     /*  202176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202188 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202193 */     GIR_RootConstrainSelectedInstOperands,
     /*  202194 */     // GIR_Coverage, 494,
     /*  202194 */     GIR_Done,
     /*  202195 */   // Label 4029: @202195
     /*  202195 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202236), // Rule ID 496 //
     /*  202200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202203 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202217 */     // MIs[0] rs1
     /*  202217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202229 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  202234 */     GIR_RootConstrainSelectedInstOperands,
     /*  202235 */     // GIR_Coverage, 496,
     /*  202235 */     GIR_Done,
     /*  202236 */   // Label 4030: @202236
     /*  202236 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202277), // Rule ID 498 //
     /*  202241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202258 */     // MIs[0] rs1
     /*  202258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202270 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  202275 */     GIR_RootConstrainSelectedInstOperands,
     /*  202276 */     // GIR_Coverage, 498,
     /*  202276 */     GIR_Done,
     /*  202277 */   // Label 4031: @202277
     /*  202277 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202318), // Rule ID 500 //
     /*  202282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202299 */     // MIs[0] rs1
     /*  202299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202311 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202316 */     GIR_RootConstrainSelectedInstOperands,
     /*  202317 */     // GIR_Coverage, 500,
     /*  202317 */     GIR_Done,
     /*  202318 */   // Label 4032: @202318
     /*  202318 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202359), // Rule ID 502 //
     /*  202323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202333 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202340 */     // MIs[0] rs1
     /*  202340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202352 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202357 */     GIR_RootConstrainSelectedInstOperands,
     /*  202358 */     // GIR_Coverage, 502,
     /*  202358 */     GIR_Done,
     /*  202359 */   // Label 4033: @202359
     /*  202359 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202400), // Rule ID 504 //
     /*  202364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202367 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202374 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202381 */     // MIs[0] rs1
     /*  202381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202393 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202398 */     GIR_RootConstrainSelectedInstOperands,
     /*  202399 */     // GIR_Coverage, 504,
     /*  202399 */     GIR_Done,
     /*  202400 */   // Label 4034: @202400
     /*  202400 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202441), // Rule ID 506 //
     /*  202405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202422 */     // MIs[0] rs1
     /*  202422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202434 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202439 */     GIR_RootConstrainSelectedInstOperands,
     /*  202440 */     // GIR_Coverage, 506,
     /*  202440 */     GIR_Done,
     /*  202441 */   // Label 4035: @202441
     /*  202441 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202482), // Rule ID 508 //
     /*  202446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202463 */     // MIs[0] rs1
     /*  202463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202475 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202480 */     GIR_RootConstrainSelectedInstOperands,
     /*  202481 */     // GIR_Coverage, 508,
     /*  202481 */     GIR_Done,
     /*  202482 */   // Label 4036: @202482
     /*  202482 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202523), // Rule ID 510 //
     /*  202487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202504 */     // MIs[0] rs1
     /*  202504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202516 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202521 */     GIR_RootConstrainSelectedInstOperands,
     /*  202522 */     // GIR_Coverage, 510,
     /*  202522 */     GIR_Done,
     /*  202523 */   // Label 4037: @202523
     /*  202523 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202564), // Rule ID 512 //
     /*  202528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202545 */     // MIs[0] rs1
     /*  202545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202557 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202562 */     GIR_RootConstrainSelectedInstOperands,
     /*  202563 */     // GIR_Coverage, 512,
     /*  202563 */     GIR_Done,
     /*  202564 */   // Label 4038: @202564
     /*  202564 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202605), // Rule ID 842 //
     /*  202569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202586 */     // MIs[0] rs1
     /*  202586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202598 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202603 */     GIR_RootConstrainSelectedInstOperands,
     /*  202604 */     // GIR_Coverage, 842,
     /*  202604 */     GIR_Done,
     /*  202605 */   // Label 4039: @202605
     /*  202605 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202646), // Rule ID 844 //
     /*  202610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202627 */     // MIs[0] rs1
     /*  202627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202639 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  202644 */     GIR_RootConstrainSelectedInstOperands,
     /*  202645 */     // GIR_Coverage, 844,
     /*  202645 */     GIR_Done,
     /*  202646 */   // Label 4040: @202646
     /*  202646 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202687), // Rule ID 846 //
     /*  202651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202668 */     // MIs[0] rs1
     /*  202668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202680 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  202685 */     GIR_RootConstrainSelectedInstOperands,
     /*  202686 */     // GIR_Coverage, 846,
     /*  202686 */     GIR_Done,
     /*  202687 */   // Label 4041: @202687
     /*  202687 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202728), // Rule ID 848 //
     /*  202692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202709 */     // MIs[0] rs1
     /*  202709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202721 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202726 */     GIR_RootConstrainSelectedInstOperands,
     /*  202727 */     // GIR_Coverage, 848,
     /*  202727 */     GIR_Done,
     /*  202728 */   // Label 4042: @202728
     /*  202728 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202769), // Rule ID 850 //
     /*  202733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202750 */     // MIs[0] rs1
     /*  202750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202762 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202767 */     GIR_RootConstrainSelectedInstOperands,
     /*  202768 */     // GIR_Coverage, 850,
     /*  202768 */     GIR_Done,
     /*  202769 */   // Label 4043: @202769
     /*  202769 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202810), // Rule ID 852 //
     /*  202774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202791 */     // MIs[0] rs1
     /*  202791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202803 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202808 */     GIR_RootConstrainSelectedInstOperands,
     /*  202809 */     // GIR_Coverage, 852,
     /*  202809 */     GIR_Done,
     /*  202810 */   // Label 4044: @202810
     /*  202810 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202851), // Rule ID 854 //
     /*  202815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202832 */     // MIs[0] rs1
     /*  202832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202844 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202849 */     GIR_RootConstrainSelectedInstOperands,
     /*  202850 */     // GIR_Coverage, 854,
     /*  202850 */     GIR_Done,
     /*  202851 */   // Label 4045: @202851
     /*  202851 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202892), // Rule ID 856 //
     /*  202856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202873 */     // MIs[0] rs1
     /*  202873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202885 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202890 */     GIR_RootConstrainSelectedInstOperands,
     /*  202891 */     // GIR_Coverage, 856,
     /*  202891 */     GIR_Done,
     /*  202892 */   // Label 4046: @202892
     /*  202892 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(202933), // Rule ID 858 //
     /*  202897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202914 */     // MIs[0] rs1
     /*  202914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202926 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202931 */     GIR_RootConstrainSelectedInstOperands,
     /*  202932 */     // GIR_Coverage, 858,
     /*  202932 */     GIR_Done,
     /*  202933 */   // Label 4047: @202933
     /*  202933 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(202974), // Rule ID 860 //
     /*  202938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202955 */     // MIs[0] rs1
     /*  202955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202967 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202972 */     GIR_RootConstrainSelectedInstOperands,
     /*  202973 */     // GIR_Coverage, 860,
     /*  202973 */     GIR_Done,
     /*  202974 */   // Label 4048: @202974
     /*  202974 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203015), // Rule ID 1022 //
     /*  202979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202996 */     // MIs[0] rs1
     /*  202996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203008 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203013 */     GIR_RootConstrainSelectedInstOperands,
     /*  203014 */     // GIR_Coverage, 1022,
     /*  203014 */     GIR_Done,
     /*  203015 */   // Label 4049: @203015
     /*  203015 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203056), // Rule ID 1024 //
     /*  203020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203037 */     // MIs[0] rs1
     /*  203037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203049 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  203054 */     GIR_RootConstrainSelectedInstOperands,
     /*  203055 */     // GIR_Coverage, 1024,
     /*  203055 */     GIR_Done,
     /*  203056 */   // Label 4050: @203056
     /*  203056 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203097), // Rule ID 1026 //
     /*  203061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203078 */     // MIs[0] rs1
     /*  203078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203090 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  203095 */     GIR_RootConstrainSelectedInstOperands,
     /*  203096 */     // GIR_Coverage, 1026,
     /*  203096 */     GIR_Done,
     /*  203097 */   // Label 4051: @203097
     /*  203097 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203138), // Rule ID 1028 //
     /*  203102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203119 */     // MIs[0] rs1
     /*  203119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203131 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203136 */     GIR_RootConstrainSelectedInstOperands,
     /*  203137 */     // GIR_Coverage, 1028,
     /*  203137 */     GIR_Done,
     /*  203138 */   // Label 4052: @203138
     /*  203138 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203179), // Rule ID 1030 //
     /*  203143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203160 */     // MIs[0] rs1
     /*  203160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203172 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203177 */     GIR_RootConstrainSelectedInstOperands,
     /*  203178 */     // GIR_Coverage, 1030,
     /*  203178 */     GIR_Done,
     /*  203179 */   // Label 4053: @203179
     /*  203179 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203220), // Rule ID 1032 //
     /*  203184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203201 */     // MIs[0] rs1
     /*  203201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203213 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203218 */     GIR_RootConstrainSelectedInstOperands,
     /*  203219 */     // GIR_Coverage, 1032,
     /*  203219 */     GIR_Done,
     /*  203220 */   // Label 4054: @203220
     /*  203220 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203261), // Rule ID 1034 //
     /*  203225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203242 */     // MIs[0] rs1
     /*  203242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203254 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203259 */     GIR_RootConstrainSelectedInstOperands,
     /*  203260 */     // GIR_Coverage, 1034,
     /*  203260 */     GIR_Done,
     /*  203261 */   // Label 4055: @203261
     /*  203261 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203302), // Rule ID 1036 //
     /*  203266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203283 */     // MIs[0] rs1
     /*  203283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203295 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203300 */     GIR_RootConstrainSelectedInstOperands,
     /*  203301 */     // GIR_Coverage, 1036,
     /*  203301 */     GIR_Done,
     /*  203302 */   // Label 4056: @203302
     /*  203302 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203343), // Rule ID 1038 //
     /*  203307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203324 */     // MIs[0] rs1
     /*  203324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203336 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203341 */     GIR_RootConstrainSelectedInstOperands,
     /*  203342 */     // GIR_Coverage, 1038,
     /*  203342 */     GIR_Done,
     /*  203343 */   // Label 4057: @203343
     /*  203343 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203384), // Rule ID 1040 //
     /*  203348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203365 */     // MIs[0] rs1
     /*  203365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203377 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203382 */     GIR_RootConstrainSelectedInstOperands,
     /*  203383 */     // GIR_Coverage, 1040,
     /*  203383 */     GIR_Done,
     /*  203384 */   // Label 4058: @203384
     /*  203384 */   GIM_Reject,
     /*  203385 */ // Label 4028: @203385
     /*  203385 */ GIM_Reject,
     /*  203386 */ // Label 4026: @203386
     /*  203386 */ GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205035),
     /*  203391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  203394 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203435), // Rule ID 493 //
     /*  203399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203416 */     // MIs[0] rs1
     /*  203416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203428 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203433 */     GIR_RootConstrainSelectedInstOperands,
     /*  203434 */     // GIR_Coverage, 493,
     /*  203434 */     GIR_Done,
     /*  203435 */   // Label 4060: @203435
     /*  203435 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203476), // Rule ID 495 //
     /*  203440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203457 */     // MIs[0] rs1
     /*  203457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203469 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  203474 */     GIR_RootConstrainSelectedInstOperands,
     /*  203475 */     // GIR_Coverage, 495,
     /*  203475 */     GIR_Done,
     /*  203476 */   // Label 4061: @203476
     /*  203476 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203517), // Rule ID 497 //
     /*  203481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203498 */     // MIs[0] rs1
     /*  203498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203510 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  203515 */     GIR_RootConstrainSelectedInstOperands,
     /*  203516 */     // GIR_Coverage, 497,
     /*  203516 */     GIR_Done,
     /*  203517 */   // Label 4062: @203517
     /*  203517 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203558), // Rule ID 499 //
     /*  203522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203525 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203532 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203539 */     // MIs[0] rs1
     /*  203539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203551 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203556 */     GIR_RootConstrainSelectedInstOperands,
     /*  203557 */     // GIR_Coverage, 499,
     /*  203557 */     GIR_Done,
     /*  203558 */   // Label 4063: @203558
     /*  203558 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203599), // Rule ID 501 //
     /*  203563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203580 */     // MIs[0] rs1
     /*  203580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203592 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203597 */     GIR_RootConstrainSelectedInstOperands,
     /*  203598 */     // GIR_Coverage, 501,
     /*  203598 */     GIR_Done,
     /*  203599 */   // Label 4064: @203599
     /*  203599 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(203640), // Rule ID 503 //
     /*  203604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203621 */     // MIs[0] rs1
     /*  203621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203633 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203638 */     GIR_RootConstrainSelectedInstOperands,
     /*  203639 */     // GIR_Coverage, 503,
     /*  203639 */     GIR_Done,
     /*  203640 */   // Label 4065: @203640
     /*  203640 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(203681), // Rule ID 505 //
     /*  203645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203662 */     // MIs[0] rs1
     /*  203662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203674 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203679 */     GIR_RootConstrainSelectedInstOperands,
     /*  203680 */     // GIR_Coverage, 505,
     /*  203680 */     GIR_Done,
     /*  203681 */   // Label 4066: @203681
     /*  203681 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(203722), // Rule ID 507 //
     /*  203686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203703 */     // MIs[0] rs1
     /*  203703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203715 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203720 */     GIR_RootConstrainSelectedInstOperands,
     /*  203721 */     // GIR_Coverage, 507,
     /*  203721 */     GIR_Done,
     /*  203722 */   // Label 4067: @203722
     /*  203722 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(203763), // Rule ID 509 //
     /*  203727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203744 */     // MIs[0] rs1
     /*  203744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203756 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203761 */     GIR_RootConstrainSelectedInstOperands,
     /*  203762 */     // GIR_Coverage, 509,
     /*  203762 */     GIR_Done,
     /*  203763 */   // Label 4068: @203763
     /*  203763 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(203804), // Rule ID 511 //
     /*  203768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203785 */     // MIs[0] rs1
     /*  203785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203797 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203802 */     GIR_RootConstrainSelectedInstOperands,
     /*  203803 */     // GIR_Coverage, 511,
     /*  203803 */     GIR_Done,
     /*  203804 */   // Label 4069: @203804
     /*  203804 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(203845), // Rule ID 603 //
     /*  203809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203826 */     // MIs[0] rs1
     /*  203826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203838 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203843 */     GIR_RootConstrainSelectedInstOperands,
     /*  203844 */     // GIR_Coverage, 603,
     /*  203844 */     GIR_Done,
     /*  203845 */   // Label 4070: @203845
     /*  203845 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(203886), // Rule ID 604 //
     /*  203850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203867 */     // MIs[0] rs1
     /*  203867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203879 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  203884 */     GIR_RootConstrainSelectedInstOperands,
     /*  203885 */     // GIR_Coverage, 604,
     /*  203885 */     GIR_Done,
     /*  203886 */   // Label 4071: @203886
     /*  203886 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(203927), // Rule ID 605 //
     /*  203891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203908 */     // MIs[0] rs1
     /*  203908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203920 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  203925 */     GIR_RootConstrainSelectedInstOperands,
     /*  203926 */     // GIR_Coverage, 605,
     /*  203926 */     GIR_Done,
     /*  203927 */   // Label 4072: @203927
     /*  203927 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(203968), // Rule ID 606 //
     /*  203932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203949 */     // MIs[0] rs1
     /*  203949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203961 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203966 */     GIR_RootConstrainSelectedInstOperands,
     /*  203967 */     // GIR_Coverage, 606,
     /*  203967 */     GIR_Done,
     /*  203968 */   // Label 4073: @203968
     /*  203968 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204009), // Rule ID 607 //
     /*  203973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203990 */     // MIs[0] rs1
     /*  203990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204002 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  204007 */     GIR_RootConstrainSelectedInstOperands,
     /*  204008 */     // GIR_Coverage, 607,
     /*  204008 */     GIR_Done,
     /*  204009 */   // Label 4074: @204009
     /*  204009 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204050), // Rule ID 608 //
     /*  204014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204024 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204031 */     // MIs[0] rs1
     /*  204031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204043 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204048 */     GIR_RootConstrainSelectedInstOperands,
     /*  204049 */     // GIR_Coverage, 608,
     /*  204049 */     GIR_Done,
     /*  204050 */   // Label 4075: @204050
     /*  204050 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204091), // Rule ID 609 //
     /*  204055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204072 */     // MIs[0] rs1
     /*  204072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204084 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204089 */     GIR_RootConstrainSelectedInstOperands,
     /*  204090 */     // GIR_Coverage, 609,
     /*  204090 */     GIR_Done,
     /*  204091 */   // Label 4076: @204091
     /*  204091 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204132), // Rule ID 610 //
     /*  204096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204113 */     // MIs[0] rs1
     /*  204113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204125 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204130 */     GIR_RootConstrainSelectedInstOperands,
     /*  204131 */     // GIR_Coverage, 610,
     /*  204131 */     GIR_Done,
     /*  204132 */   // Label 4077: @204132
     /*  204132 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204173), // Rule ID 611 //
     /*  204137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204154 */     // MIs[0] rs1
     /*  204154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204166 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204171 */     GIR_RootConstrainSelectedInstOperands,
     /*  204172 */     // GIR_Coverage, 611,
     /*  204172 */     GIR_Done,
     /*  204173 */   // Label 4078: @204173
     /*  204173 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204214), // Rule ID 612 //
     /*  204178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204195 */     // MIs[0] rs1
     /*  204195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204207 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  204212 */     GIR_RootConstrainSelectedInstOperands,
     /*  204213 */     // GIR_Coverage, 612,
     /*  204213 */     GIR_Done,
     /*  204214 */   // Label 4079: @204214
     /*  204214 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204255), // Rule ID 841 //
     /*  204219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204236 */     // MIs[0] rs1
     /*  204236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204248 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204253 */     GIR_RootConstrainSelectedInstOperands,
     /*  204254 */     // GIR_Coverage, 841,
     /*  204254 */     GIR_Done,
     /*  204255 */   // Label 4080: @204255
     /*  204255 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204296), // Rule ID 843 //
     /*  204260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204277 */     // MIs[0] rs1
     /*  204277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204289 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  204294 */     GIR_RootConstrainSelectedInstOperands,
     /*  204295 */     // GIR_Coverage, 843,
     /*  204295 */     GIR_Done,
     /*  204296 */   // Label 4081: @204296
     /*  204296 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204337), // Rule ID 845 //
     /*  204301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204318 */     // MIs[0] rs1
     /*  204318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204330 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  204335 */     GIR_RootConstrainSelectedInstOperands,
     /*  204336 */     // GIR_Coverage, 845,
     /*  204336 */     GIR_Done,
     /*  204337 */   // Label 4082: @204337
     /*  204337 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204378), // Rule ID 847 //
     /*  204342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204352 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204359 */     // MIs[0] rs1
     /*  204359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204371 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  204376 */     GIR_RootConstrainSelectedInstOperands,
     /*  204377 */     // GIR_Coverage, 847,
     /*  204377 */     GIR_Done,
     /*  204378 */   // Label 4083: @204378
     /*  204378 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204419), // Rule ID 849 //
     /*  204383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204400 */     // MIs[0] rs1
     /*  204400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204412 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  204417 */     GIR_RootConstrainSelectedInstOperands,
     /*  204418 */     // GIR_Coverage, 849,
     /*  204418 */     GIR_Done,
     /*  204419 */   // Label 4084: @204419
     /*  204419 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(204460), // Rule ID 851 //
     /*  204424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204441 */     // MIs[0] rs1
     /*  204441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204453 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204458 */     GIR_RootConstrainSelectedInstOperands,
     /*  204459 */     // GIR_Coverage, 851,
     /*  204459 */     GIR_Done,
     /*  204460 */   // Label 4085: @204460
     /*  204460 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(204501), // Rule ID 853 //
     /*  204465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204482 */     // MIs[0] rs1
     /*  204482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204494 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204499 */     GIR_RootConstrainSelectedInstOperands,
     /*  204500 */     // GIR_Coverage, 853,
     /*  204500 */     GIR_Done,
     /*  204501 */   // Label 4086: @204501
     /*  204501 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(204542), // Rule ID 855 //
     /*  204506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204523 */     // MIs[0] rs1
     /*  204523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204535 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204540 */     GIR_RootConstrainSelectedInstOperands,
     /*  204541 */     // GIR_Coverage, 855,
     /*  204541 */     GIR_Done,
     /*  204542 */   // Label 4087: @204542
     /*  204542 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(204583), // Rule ID 857 //
     /*  204547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204564 */     // MIs[0] rs1
     /*  204564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204576 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204581 */     GIR_RootConstrainSelectedInstOperands,
     /*  204582 */     // GIR_Coverage, 857,
     /*  204582 */     GIR_Done,
     /*  204583 */   // Label 4088: @204583
     /*  204583 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(204624), // Rule ID 859 //
     /*  204588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204605 */     // MIs[0] rs1
     /*  204605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204617 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204622 */     GIR_RootConstrainSelectedInstOperands,
     /*  204623 */     // GIR_Coverage, 859,
     /*  204623 */     GIR_Done,
     /*  204624 */   // Label 4089: @204624
     /*  204624 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(204665), // Rule ID 1021 //
     /*  204629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204646 */     // MIs[0] rs1
     /*  204646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204658 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204663 */     GIR_RootConstrainSelectedInstOperands,
     /*  204664 */     // GIR_Coverage, 1021,
     /*  204664 */     GIR_Done,
     /*  204665 */   // Label 4090: @204665
     /*  204665 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(204706), // Rule ID 1023 //
     /*  204670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204687 */     // MIs[0] rs1
     /*  204687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204699 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  204704 */     GIR_RootConstrainSelectedInstOperands,
     /*  204705 */     // GIR_Coverage, 1023,
     /*  204705 */     GIR_Done,
     /*  204706 */   // Label 4091: @204706
     /*  204706 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(204747), // Rule ID 1025 //
     /*  204711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204728 */     // MIs[0] rs1
     /*  204728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204740 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  204745 */     GIR_RootConstrainSelectedInstOperands,
     /*  204746 */     // GIR_Coverage, 1025,
     /*  204746 */     GIR_Done,
     /*  204747 */   // Label 4092: @204747
     /*  204747 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(204788), // Rule ID 1027 //
     /*  204752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204769 */     // MIs[0] rs1
     /*  204769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204781 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204786 */     GIR_RootConstrainSelectedInstOperands,
     /*  204787 */     // GIR_Coverage, 1027,
     /*  204787 */     GIR_Done,
     /*  204788 */   // Label 4093: @204788
     /*  204788 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(204829), // Rule ID 1029 //
     /*  204793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204810 */     // MIs[0] rs1
     /*  204810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204822 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204827 */     GIR_RootConstrainSelectedInstOperands,
     /*  204828 */     // GIR_Coverage, 1029,
     /*  204828 */     GIR_Done,
     /*  204829 */   // Label 4094: @204829
     /*  204829 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(204870), // Rule ID 1031 //
     /*  204834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204851 */     // MIs[0] rs1
     /*  204851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204863 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204868 */     GIR_RootConstrainSelectedInstOperands,
     /*  204869 */     // GIR_Coverage, 1031,
     /*  204869 */     GIR_Done,
     /*  204870 */   // Label 4095: @204870
     /*  204870 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(204911), // Rule ID 1033 //
     /*  204875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204892 */     // MIs[0] rs1
     /*  204892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204904 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204909 */     GIR_RootConstrainSelectedInstOperands,
     /*  204910 */     // GIR_Coverage, 1033,
     /*  204910 */     GIR_Done,
     /*  204911 */   // Label 4096: @204911
     /*  204911 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(204952), // Rule ID 1035 //
     /*  204916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204933 */     // MIs[0] rs1
     /*  204933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204945 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204950 */     GIR_RootConstrainSelectedInstOperands,
     /*  204951 */     // GIR_Coverage, 1035,
     /*  204951 */     GIR_Done,
     /*  204952 */   // Label 4097: @204952
     /*  204952 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(204993), // Rule ID 1037 //
     /*  204957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204974 */     // MIs[0] rs1
     /*  204974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204986 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204991 */     GIR_RootConstrainSelectedInstOperands,
     /*  204992 */     // GIR_Coverage, 1037,
     /*  204992 */     GIR_Done,
     /*  204993 */   // Label 4098: @204993
     /*  204993 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(205034), // Rule ID 1039 //
     /*  204998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205015 */     // MIs[0] rs1
     /*  205015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205027 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  205032 */     GIR_RootConstrainSelectedInstOperands,
     /*  205033 */     // GIR_Coverage, 1039,
     /*  205033 */     GIR_Done,
     /*  205034 */   // Label 4099: @205034
     /*  205034 */   GIM_Reject,
     /*  205035 */ // Label 4059: @205035
     /*  205035 */ GIM_Reject,
     /*  205036 */ // Label 4027: @205036
     /*  205036 */ GIM_Reject,
     /*  205037 */ // Label 35: @205037
     /*  205037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4102*/ GIMT_Encode4(207946),
     /*  205048 */ /*GILLT_s32*//*Label 4100*/ GIMT_Encode4(205056),
     /*  205052 */ /*GILLT_s64*//*Label 4101*/ GIMT_Encode4(206296),
     /*  205056 */ // Label 4100: @205056
     /*  205056 */ GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206295),
     /*  205061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  205064 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(205105), // Rule ID 514 //
     /*  205069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205086 */     // MIs[0] rs1
     /*  205086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205098 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205103 */     GIR_RootConstrainSelectedInstOperands,
     /*  205104 */     // GIR_Coverage, 514,
     /*  205104 */     GIR_Done,
     /*  205105 */   // Label 4104: @205105
     /*  205105 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(205146), // Rule ID 516 //
     /*  205110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205127 */     // MIs[0] rs1
     /*  205127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205139 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  205144 */     GIR_RootConstrainSelectedInstOperands,
     /*  205145 */     // GIR_Coverage, 516,
     /*  205145 */     GIR_Done,
     /*  205146 */   // Label 4105: @205146
     /*  205146 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(205187), // Rule ID 518 //
     /*  205151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205161 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205168 */     // MIs[0] rs1
     /*  205168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205180 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  205185 */     GIR_RootConstrainSelectedInstOperands,
     /*  205186 */     // GIR_Coverage, 518,
     /*  205186 */     GIR_Done,
     /*  205187 */   // Label 4106: @205187
     /*  205187 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(205228), // Rule ID 520 //
     /*  205192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205209 */     // MIs[0] rs1
     /*  205209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205221 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205226 */     GIR_RootConstrainSelectedInstOperands,
     /*  205227 */     // GIR_Coverage, 520,
     /*  205227 */     GIR_Done,
     /*  205228 */   // Label 4107: @205228
     /*  205228 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(205269), // Rule ID 522 //
     /*  205233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205250 */     // MIs[0] rs1
     /*  205250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205262 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205267 */     GIR_RootConstrainSelectedInstOperands,
     /*  205268 */     // GIR_Coverage, 522,
     /*  205268 */     GIR_Done,
     /*  205269 */   // Label 4108: @205269
     /*  205269 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(205310), // Rule ID 524 //
     /*  205274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205291 */     // MIs[0] rs1
     /*  205291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205303 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205308 */     GIR_RootConstrainSelectedInstOperands,
     /*  205309 */     // GIR_Coverage, 524,
     /*  205309 */     GIR_Done,
     /*  205310 */   // Label 4109: @205310
     /*  205310 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(205351), // Rule ID 526 //
     /*  205315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205332 */     // MIs[0] rs1
     /*  205332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205344 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205349 */     GIR_RootConstrainSelectedInstOperands,
     /*  205350 */     // GIR_Coverage, 526,
     /*  205350 */     GIR_Done,
     /*  205351 */   // Label 4110: @205351
     /*  205351 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(205392), // Rule ID 528 //
     /*  205356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205373 */     // MIs[0] rs1
     /*  205373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205385 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205390 */     GIR_RootConstrainSelectedInstOperands,
     /*  205391 */     // GIR_Coverage, 528,
     /*  205391 */     GIR_Done,
     /*  205392 */   // Label 4111: @205392
     /*  205392 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(205433), // Rule ID 530 //
     /*  205397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205414 */     // MIs[0] rs1
     /*  205414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205426 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205431 */     GIR_RootConstrainSelectedInstOperands,
     /*  205432 */     // GIR_Coverage, 530,
     /*  205432 */     GIR_Done,
     /*  205433 */   // Label 4112: @205433
     /*  205433 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(205474), // Rule ID 532 //
     /*  205438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205455 */     // MIs[0] rs1
     /*  205455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205467 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205472 */     GIR_RootConstrainSelectedInstOperands,
     /*  205473 */     // GIR_Coverage, 532,
     /*  205473 */     GIR_Done,
     /*  205474 */   // Label 4113: @205474
     /*  205474 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(205515), // Rule ID 862 //
     /*  205479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205496 */     // MIs[0] rs1
     /*  205496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205508 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205513 */     GIR_RootConstrainSelectedInstOperands,
     /*  205514 */     // GIR_Coverage, 862,
     /*  205514 */     GIR_Done,
     /*  205515 */   // Label 4114: @205515
     /*  205515 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(205556), // Rule ID 864 //
     /*  205520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205537 */     // MIs[0] rs1
     /*  205537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205549 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  205554 */     GIR_RootConstrainSelectedInstOperands,
     /*  205555 */     // GIR_Coverage, 864,
     /*  205555 */     GIR_Done,
     /*  205556 */   // Label 4115: @205556
     /*  205556 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(205597), // Rule ID 866 //
     /*  205561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205578 */     // MIs[0] rs1
     /*  205578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205590 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  205595 */     GIR_RootConstrainSelectedInstOperands,
     /*  205596 */     // GIR_Coverage, 866,
     /*  205596 */     GIR_Done,
     /*  205597 */   // Label 4116: @205597
     /*  205597 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(205638), // Rule ID 868 //
     /*  205602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205619 */     // MIs[0] rs1
     /*  205619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205631 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205636 */     GIR_RootConstrainSelectedInstOperands,
     /*  205637 */     // GIR_Coverage, 868,
     /*  205637 */     GIR_Done,
     /*  205638 */   // Label 4117: @205638
     /*  205638 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(205679), // Rule ID 870 //
     /*  205643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205660 */     // MIs[0] rs1
     /*  205660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205672 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205677 */     GIR_RootConstrainSelectedInstOperands,
     /*  205678 */     // GIR_Coverage, 870,
     /*  205678 */     GIR_Done,
     /*  205679 */   // Label 4118: @205679
     /*  205679 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(205720), // Rule ID 872 //
     /*  205684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205701 */     // MIs[0] rs1
     /*  205701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205713 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205718 */     GIR_RootConstrainSelectedInstOperands,
     /*  205719 */     // GIR_Coverage, 872,
     /*  205719 */     GIR_Done,
     /*  205720 */   // Label 4119: @205720
     /*  205720 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(205761), // Rule ID 874 //
     /*  205725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205742 */     // MIs[0] rs1
     /*  205742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205754 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205759 */     GIR_RootConstrainSelectedInstOperands,
     /*  205760 */     // GIR_Coverage, 874,
     /*  205760 */     GIR_Done,
     /*  205761 */   // Label 4120: @205761
     /*  205761 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(205802), // Rule ID 876 //
     /*  205766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205783 */     // MIs[0] rs1
     /*  205783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205795 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205800 */     GIR_RootConstrainSelectedInstOperands,
     /*  205801 */     // GIR_Coverage, 876,
     /*  205801 */     GIR_Done,
     /*  205802 */   // Label 4121: @205802
     /*  205802 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(205843), // Rule ID 878 //
     /*  205807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205824 */     // MIs[0] rs1
     /*  205824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205836 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205841 */     GIR_RootConstrainSelectedInstOperands,
     /*  205842 */     // GIR_Coverage, 878,
     /*  205842 */     GIR_Done,
     /*  205843 */   // Label 4122: @205843
     /*  205843 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(205884), // Rule ID 880 //
     /*  205848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205865 */     // MIs[0] rs1
     /*  205865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205877 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205882 */     GIR_RootConstrainSelectedInstOperands,
     /*  205883 */     // GIR_Coverage, 880,
     /*  205883 */     GIR_Done,
     /*  205884 */   // Label 4123: @205884
     /*  205884 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(205925), // Rule ID 1042 //
     /*  205889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205906 */     // MIs[0] rs1
     /*  205906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205918 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205923 */     GIR_RootConstrainSelectedInstOperands,
     /*  205924 */     // GIR_Coverage, 1042,
     /*  205924 */     GIR_Done,
     /*  205925 */   // Label 4124: @205925
     /*  205925 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(205966), // Rule ID 1044 //
     /*  205930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205947 */     // MIs[0] rs1
     /*  205947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205959 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  205964 */     GIR_RootConstrainSelectedInstOperands,
     /*  205965 */     // GIR_Coverage, 1044,
     /*  205965 */     GIR_Done,
     /*  205966 */   // Label 4125: @205966
     /*  205966 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(206007), // Rule ID 1046 //
     /*  205971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205988 */     // MIs[0] rs1
     /*  205988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206000 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  206005 */     GIR_RootConstrainSelectedInstOperands,
     /*  206006 */     // GIR_Coverage, 1046,
     /*  206006 */     GIR_Done,
     /*  206007 */   // Label 4126: @206007
     /*  206007 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(206048), // Rule ID 1048 //
     /*  206012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206029 */     // MIs[0] rs1
     /*  206029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206041 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206046 */     GIR_RootConstrainSelectedInstOperands,
     /*  206047 */     // GIR_Coverage, 1048,
     /*  206047 */     GIR_Done,
     /*  206048 */   // Label 4127: @206048
     /*  206048 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(206089), // Rule ID 1050 //
     /*  206053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206070 */     // MIs[0] rs1
     /*  206070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206082 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206087 */     GIR_RootConstrainSelectedInstOperands,
     /*  206088 */     // GIR_Coverage, 1050,
     /*  206088 */     GIR_Done,
     /*  206089 */   // Label 4128: @206089
     /*  206089 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(206130), // Rule ID 1052 //
     /*  206094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206111 */     // MIs[0] rs1
     /*  206111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206123 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206128 */     GIR_RootConstrainSelectedInstOperands,
     /*  206129 */     // GIR_Coverage, 1052,
     /*  206129 */     GIR_Done,
     /*  206130 */   // Label 4129: @206130
     /*  206130 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(206171), // Rule ID 1054 //
     /*  206135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206152 */     // MIs[0] rs1
     /*  206152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206164 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206169 */     GIR_RootConstrainSelectedInstOperands,
     /*  206170 */     // GIR_Coverage, 1054,
     /*  206170 */     GIR_Done,
     /*  206171 */   // Label 4130: @206171
     /*  206171 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(206212), // Rule ID 1056 //
     /*  206176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206193 */     // MIs[0] rs1
     /*  206193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206205 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206210 */     GIR_RootConstrainSelectedInstOperands,
     /*  206211 */     // GIR_Coverage, 1056,
     /*  206211 */     GIR_Done,
     /*  206212 */   // Label 4131: @206212
     /*  206212 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(206253), // Rule ID 1058 //
     /*  206217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206234 */     // MIs[0] rs1
     /*  206234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206246 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206251 */     GIR_RootConstrainSelectedInstOperands,
     /*  206252 */     // GIR_Coverage, 1058,
     /*  206252 */     GIR_Done,
     /*  206253 */   // Label 4132: @206253
     /*  206253 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(206294), // Rule ID 1060 //
     /*  206258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206275 */     // MIs[0] rs1
     /*  206275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206287 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206292 */     GIR_RootConstrainSelectedInstOperands,
     /*  206293 */     // GIR_Coverage, 1060,
     /*  206293 */     GIR_Done,
     /*  206294 */   // Label 4133: @206294
     /*  206294 */   GIM_Reject,
     /*  206295 */ // Label 4103: @206295
     /*  206295 */ GIM_Reject,
     /*  206296 */ // Label 4101: @206296
     /*  206296 */ GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(207945),
     /*  206301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  206304 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(206345), // Rule ID 513 //
     /*  206309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206326 */     // MIs[0] rs1
     /*  206326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206338 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206343 */     GIR_RootConstrainSelectedInstOperands,
     /*  206344 */     // GIR_Coverage, 513,
     /*  206344 */     GIR_Done,
     /*  206345 */   // Label 4135: @206345
     /*  206345 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(206386), // Rule ID 515 //
     /*  206350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206367 */     // MIs[0] rs1
     /*  206367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206379 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  206384 */     GIR_RootConstrainSelectedInstOperands,
     /*  206385 */     // GIR_Coverage, 515,
     /*  206385 */     GIR_Done,
     /*  206386 */   // Label 4136: @206386
     /*  206386 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(206427), // Rule ID 517 //
     /*  206391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206408 */     // MIs[0] rs1
     /*  206408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206420 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  206425 */     GIR_RootConstrainSelectedInstOperands,
     /*  206426 */     // GIR_Coverage, 517,
     /*  206426 */     GIR_Done,
     /*  206427 */   // Label 4137: @206427
     /*  206427 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(206468), // Rule ID 519 //
     /*  206432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206449 */     // MIs[0] rs1
     /*  206449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206461 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206466 */     GIR_RootConstrainSelectedInstOperands,
     /*  206467 */     // GIR_Coverage, 519,
     /*  206467 */     GIR_Done,
     /*  206468 */   // Label 4138: @206468
     /*  206468 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(206509), // Rule ID 521 //
     /*  206473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206490 */     // MIs[0] rs1
     /*  206490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206502 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206507 */     GIR_RootConstrainSelectedInstOperands,
     /*  206508 */     // GIR_Coverage, 521,
     /*  206508 */     GIR_Done,
     /*  206509 */   // Label 4139: @206509
     /*  206509 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(206550), // Rule ID 523 //
     /*  206514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206531 */     // MIs[0] rs1
     /*  206531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206543 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206548 */     GIR_RootConstrainSelectedInstOperands,
     /*  206549 */     // GIR_Coverage, 523,
     /*  206549 */     GIR_Done,
     /*  206550 */   // Label 4140: @206550
     /*  206550 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(206591), // Rule ID 525 //
     /*  206555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206572 */     // MIs[0] rs1
     /*  206572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206584 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206589 */     GIR_RootConstrainSelectedInstOperands,
     /*  206590 */     // GIR_Coverage, 525,
     /*  206590 */     GIR_Done,
     /*  206591 */   // Label 4141: @206591
     /*  206591 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(206632), // Rule ID 527 //
     /*  206596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206613 */     // MIs[0] rs1
     /*  206613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206625 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206630 */     GIR_RootConstrainSelectedInstOperands,
     /*  206631 */     // GIR_Coverage, 527,
     /*  206631 */     GIR_Done,
     /*  206632 */   // Label 4142: @206632
     /*  206632 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(206673), // Rule ID 529 //
     /*  206637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206654 */     // MIs[0] rs1
     /*  206654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206666 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206671 */     GIR_RootConstrainSelectedInstOperands,
     /*  206672 */     // GIR_Coverage, 529,
     /*  206672 */     GIR_Done,
     /*  206673 */   // Label 4143: @206673
     /*  206673 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(206714), // Rule ID 531 //
     /*  206678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206695 */     // MIs[0] rs1
     /*  206695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206707 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206712 */     GIR_RootConstrainSelectedInstOperands,
     /*  206713 */     // GIR_Coverage, 531,
     /*  206713 */     GIR_Done,
     /*  206714 */   // Label 4144: @206714
     /*  206714 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(206755), // Rule ID 613 //
     /*  206719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206736 */     // MIs[0] rs1
     /*  206736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206748 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206753 */     GIR_RootConstrainSelectedInstOperands,
     /*  206754 */     // GIR_Coverage, 613,
     /*  206754 */     GIR_Done,
     /*  206755 */   // Label 4145: @206755
     /*  206755 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(206796), // Rule ID 614 //
     /*  206760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206777 */     // MIs[0] rs1
     /*  206777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206789 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  206794 */     GIR_RootConstrainSelectedInstOperands,
     /*  206795 */     // GIR_Coverage, 614,
     /*  206795 */     GIR_Done,
     /*  206796 */   // Label 4146: @206796
     /*  206796 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(206837), // Rule ID 615 //
     /*  206801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206818 */     // MIs[0] rs1
     /*  206818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206830 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  206835 */     GIR_RootConstrainSelectedInstOperands,
     /*  206836 */     // GIR_Coverage, 615,
     /*  206836 */     GIR_Done,
     /*  206837 */   // Label 4147: @206837
     /*  206837 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(206878), // Rule ID 616 //
     /*  206842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206859 */     // MIs[0] rs1
     /*  206859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206871 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206876 */     GIR_RootConstrainSelectedInstOperands,
     /*  206877 */     // GIR_Coverage, 616,
     /*  206877 */     GIR_Done,
     /*  206878 */   // Label 4148: @206878
     /*  206878 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(206919), // Rule ID 617 //
     /*  206883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206900 */     // MIs[0] rs1
     /*  206900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206912 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206917 */     GIR_RootConstrainSelectedInstOperands,
     /*  206918 */     // GIR_Coverage, 617,
     /*  206918 */     GIR_Done,
     /*  206919 */   // Label 4149: @206919
     /*  206919 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(206960), // Rule ID 618 //
     /*  206924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206927 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206941 */     // MIs[0] rs1
     /*  206941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206953 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206958 */     GIR_RootConstrainSelectedInstOperands,
     /*  206959 */     // GIR_Coverage, 618,
     /*  206959 */     GIR_Done,
     /*  206960 */   // Label 4150: @206960
     /*  206960 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(207001), // Rule ID 619 //
     /*  206965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206968 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206982 */     // MIs[0] rs1
     /*  206982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206994 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206999 */     GIR_RootConstrainSelectedInstOperands,
     /*  207000 */     // GIR_Coverage, 619,
     /*  207000 */     GIR_Done,
     /*  207001 */   // Label 4151: @207001
     /*  207001 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(207042), // Rule ID 620 //
     /*  207006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207009 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207023 */     // MIs[0] rs1
     /*  207023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207035 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207040 */     GIR_RootConstrainSelectedInstOperands,
     /*  207041 */     // GIR_Coverage, 620,
     /*  207041 */     GIR_Done,
     /*  207042 */   // Label 4152: @207042
     /*  207042 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(207083), // Rule ID 621 //
     /*  207047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207064 */     // MIs[0] rs1
     /*  207064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207076 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207081 */     GIR_RootConstrainSelectedInstOperands,
     /*  207082 */     // GIR_Coverage, 621,
     /*  207082 */     GIR_Done,
     /*  207083 */   // Label 4153: @207083
     /*  207083 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(207124), // Rule ID 622 //
     /*  207088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207105 */     // MIs[0] rs1
     /*  207105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207117 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  207122 */     GIR_RootConstrainSelectedInstOperands,
     /*  207123 */     // GIR_Coverage, 622,
     /*  207123 */     GIR_Done,
     /*  207124 */   // Label 4154: @207124
     /*  207124 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(207165), // Rule ID 861 //
     /*  207129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207146 */     // MIs[0] rs1
     /*  207146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207158 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207163 */     GIR_RootConstrainSelectedInstOperands,
     /*  207164 */     // GIR_Coverage, 861,
     /*  207164 */     GIR_Done,
     /*  207165 */   // Label 4155: @207165
     /*  207165 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(207206), // Rule ID 863 //
     /*  207170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207173 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207187 */     // MIs[0] rs1
     /*  207187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207199 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  207204 */     GIR_RootConstrainSelectedInstOperands,
     /*  207205 */     // GIR_Coverage, 863,
     /*  207205 */     GIR_Done,
     /*  207206 */   // Label 4156: @207206
     /*  207206 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(207247), // Rule ID 865 //
     /*  207211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207228 */     // MIs[0] rs1
     /*  207228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207240 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  207245 */     GIR_RootConstrainSelectedInstOperands,
     /*  207246 */     // GIR_Coverage, 865,
     /*  207246 */     GIR_Done,
     /*  207247 */   // Label 4157: @207247
     /*  207247 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(207288), // Rule ID 867 //
     /*  207252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207269 */     // MIs[0] rs1
     /*  207269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207281 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  207286 */     GIR_RootConstrainSelectedInstOperands,
     /*  207287 */     // GIR_Coverage, 867,
     /*  207287 */     GIR_Done,
     /*  207288 */   // Label 4158: @207288
     /*  207288 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(207329), // Rule ID 869 //
     /*  207293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207310 */     // MIs[0] rs1
     /*  207310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207322 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  207327 */     GIR_RootConstrainSelectedInstOperands,
     /*  207328 */     // GIR_Coverage, 869,
     /*  207328 */     GIR_Done,
     /*  207329 */   // Label 4159: @207329
     /*  207329 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(207370), // Rule ID 871 //
     /*  207334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207351 */     // MIs[0] rs1
     /*  207351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207363 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207368 */     GIR_RootConstrainSelectedInstOperands,
     /*  207369 */     // GIR_Coverage, 871,
     /*  207369 */     GIR_Done,
     /*  207370 */   // Label 4160: @207370
     /*  207370 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(207411), // Rule ID 873 //
     /*  207375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207392 */     // MIs[0] rs1
     /*  207392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207404 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207409 */     GIR_RootConstrainSelectedInstOperands,
     /*  207410 */     // GIR_Coverage, 873,
     /*  207410 */     GIR_Done,
     /*  207411 */   // Label 4161: @207411
     /*  207411 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(207452), // Rule ID 875 //
     /*  207416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207433 */     // MIs[0] rs1
     /*  207433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207445 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207450 */     GIR_RootConstrainSelectedInstOperands,
     /*  207451 */     // GIR_Coverage, 875,
     /*  207451 */     GIR_Done,
     /*  207452 */   // Label 4162: @207452
     /*  207452 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(207493), // Rule ID 877 //
     /*  207457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207474 */     // MIs[0] rs1
     /*  207474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207486 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207491 */     GIR_RootConstrainSelectedInstOperands,
     /*  207492 */     // GIR_Coverage, 877,
     /*  207492 */     GIR_Done,
     /*  207493 */   // Label 4163: @207493
     /*  207493 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(207534), // Rule ID 879 //
     /*  207498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207515 */     // MIs[0] rs1
     /*  207515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207527 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207532 */     GIR_RootConstrainSelectedInstOperands,
     /*  207533 */     // GIR_Coverage, 879,
     /*  207533 */     GIR_Done,
     /*  207534 */   // Label 4164: @207534
     /*  207534 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(207575), // Rule ID 1041 //
     /*  207539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207556 */     // MIs[0] rs1
     /*  207556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207568 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207573 */     GIR_RootConstrainSelectedInstOperands,
     /*  207574 */     // GIR_Coverage, 1041,
     /*  207574 */     GIR_Done,
     /*  207575 */   // Label 4165: @207575
     /*  207575 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(207616), // Rule ID 1043 //
     /*  207580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207597 */     // MIs[0] rs1
     /*  207597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207609 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  207614 */     GIR_RootConstrainSelectedInstOperands,
     /*  207615 */     // GIR_Coverage, 1043,
     /*  207615 */     GIR_Done,
     /*  207616 */   // Label 4166: @207616
     /*  207616 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(207657), // Rule ID 1045 //
     /*  207621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207638 */     // MIs[0] rs1
     /*  207638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207650 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  207655 */     GIR_RootConstrainSelectedInstOperands,
     /*  207656 */     // GIR_Coverage, 1045,
     /*  207656 */     GIR_Done,
     /*  207657 */   // Label 4167: @207657
     /*  207657 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(207698), // Rule ID 1047 //
     /*  207662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207679 */     // MIs[0] rs1
     /*  207679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207691 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207696 */     GIR_RootConstrainSelectedInstOperands,
     /*  207697 */     // GIR_Coverage, 1047,
     /*  207697 */     GIR_Done,
     /*  207698 */   // Label 4168: @207698
     /*  207698 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(207739), // Rule ID 1049 //
     /*  207703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207720 */     // MIs[0] rs1
     /*  207720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207732 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207737 */     GIR_RootConstrainSelectedInstOperands,
     /*  207738 */     // GIR_Coverage, 1049,
     /*  207738 */     GIR_Done,
     /*  207739 */   // Label 4169: @207739
     /*  207739 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(207780), // Rule ID 1051 //
     /*  207744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207761 */     // MIs[0] rs1
     /*  207761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207773 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207778 */     GIR_RootConstrainSelectedInstOperands,
     /*  207779 */     // GIR_Coverage, 1051,
     /*  207779 */     GIR_Done,
     /*  207780 */   // Label 4170: @207780
     /*  207780 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(207821), // Rule ID 1053 //
     /*  207785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207802 */     // MIs[0] rs1
     /*  207802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207814 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207819 */     GIR_RootConstrainSelectedInstOperands,
     /*  207820 */     // GIR_Coverage, 1053,
     /*  207820 */     GIR_Done,
     /*  207821 */   // Label 4171: @207821
     /*  207821 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(207862), // Rule ID 1055 //
     /*  207826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207843 */     // MIs[0] rs1
     /*  207843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207855 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207860 */     GIR_RootConstrainSelectedInstOperands,
     /*  207861 */     // GIR_Coverage, 1055,
     /*  207861 */     GIR_Done,
     /*  207862 */   // Label 4172: @207862
     /*  207862 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(207903), // Rule ID 1057 //
     /*  207867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207884 */     // MIs[0] rs1
     /*  207884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207896 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207901 */     GIR_RootConstrainSelectedInstOperands,
     /*  207902 */     // GIR_Coverage, 1057,
     /*  207902 */     GIR_Done,
     /*  207903 */   // Label 4173: @207903
     /*  207903 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(207944), // Rule ID 1059 //
     /*  207908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207925 */     // MIs[0] rs1
     /*  207925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207937 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207942 */     GIR_RootConstrainSelectedInstOperands,
     /*  207943 */     // GIR_Coverage, 1059,
     /*  207943 */     GIR_Done,
     /*  207944 */   // Label 4174: @207944
     /*  207944 */   GIM_Reject,
     /*  207945 */ // Label 4134: @207945
     /*  207945 */ GIM_Reject,
     /*  207946 */ // Label 4102: @207946
     /*  207946 */ GIM_Reject,
     /*  207947 */ // Label 36: @207947
     /*  207947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4177*/ GIMT_Encode4(208164),
     /*  207958 */ /*GILLT_s32*//*Label 4175*/ GIMT_Encode4(207966),
     /*  207962 */ /*GILLT_s64*//*Label 4176*/ GIMT_Encode4(208065),
     /*  207966 */ // Label 4175: @207966
     /*  207966 */ GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(207992), // Rule ID 255 //
     /*  207971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207974 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207978 */   // MIs[0] Operand 1
     /*  207978 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207981 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  207981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207990 */   GIR_RootConstrainSelectedInstOperands,
     /*  207991 */   // GIR_Coverage, 255,
     /*  207991 */   GIR_EraseRootFromParent_Done,
     /*  207992 */ // Label 4178: @207992
     /*  207992 */ GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(208018), // Rule ID 257 //
     /*  207997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208000 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  208004 */   // MIs[0] Operand 1
     /*  208004 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208007 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  208007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  208016 */   GIR_RootConstrainSelectedInstOperands,
     /*  208017 */   // GIR_Coverage, 257,
     /*  208017 */   GIR_EraseRootFromParent_Done,
     /*  208018 */ // Label 4179: @208018
     /*  208018 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(208038), // Rule ID 259 //
     /*  208023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208026 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  208030 */   // MIs[0] Operand 1
     /*  208030 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208033 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  208033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  208036 */   GIR_RootConstrainSelectedInstOperands,
     /*  208037 */   // GIR_Coverage, 259,
     /*  208037 */   GIR_EraseRootFromParent_Done,
     /*  208038 */ // Label 4180: @208038
     /*  208038 */ GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(208064), // Rule ID 261 //
     /*  208043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208046 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  208050 */   // MIs[0] Operand 1
     /*  208050 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208053 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  208053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208062 */   GIR_RootConstrainSelectedInstOperands,
     /*  208063 */   // GIR_Coverage, 261,
     /*  208063 */   GIR_EraseRootFromParent_Done,
     /*  208064 */ // Label 4181: @208064
     /*  208064 */ GIM_Reject,
     /*  208065 */ // Label 4176: @208065
     /*  208065 */ GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(208091), // Rule ID 254 //
     /*  208070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208073 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  208077 */   // MIs[0] Operand 1
     /*  208077 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208080 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  208080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  208086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208089 */   GIR_RootConstrainSelectedInstOperands,
     /*  208090 */   // GIR_Coverage, 254,
     /*  208090 */   GIR_EraseRootFromParent_Done,
     /*  208091 */ // Label 4182: @208091
     /*  208091 */ GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(208117), // Rule ID 256 //
     /*  208096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208099 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  208103 */   // MIs[0] Operand 1
     /*  208103 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208106 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  208106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  208115 */   GIR_RootConstrainSelectedInstOperands,
     /*  208116 */   // GIR_Coverage, 256,
     /*  208116 */   GIR_EraseRootFromParent_Done,
     /*  208117 */ // Label 4183: @208117
     /*  208117 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(208137), // Rule ID 258 //
     /*  208122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208125 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  208129 */   // MIs[0] Operand 1
     /*  208129 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208132 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  208132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  208135 */   GIR_RootConstrainSelectedInstOperands,
     /*  208136 */   // GIR_Coverage, 258,
     /*  208136 */   GIR_EraseRootFromParent_Done,
     /*  208137 */ // Label 4184: @208137
     /*  208137 */ GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(208163), // Rule ID 260 //
     /*  208142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208145 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  208149 */   // MIs[0] Operand 1
     /*  208149 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  208152 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  208152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  208155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208161 */   GIR_RootConstrainSelectedInstOperands,
     /*  208162 */   // GIR_Coverage, 260,
     /*  208162 */   GIR_EraseRootFromParent_Done,
     /*  208163 */ // Label 4185: @208163
     /*  208163 */ GIM_Reject,
     /*  208164 */ // Label 4177: @208164
     /*  208164 */ GIM_Reject,
     /*  208165 */ // Label 37: @208165
     /*  208165 */ GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(209650),
     /*  208170 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  208173 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(208218), // Rule ID 2718 //
     /*  208178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  208206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208216 */     GIR_RootConstrainSelectedInstOperands,
     /*  208217 */     // GIR_Coverage, 2718,
     /*  208217 */     GIR_EraseRootFromParent_Done,
     /*  208218 */   // Label 4187: @208218
     /*  208218 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(208263), // Rule ID 2719 //
     /*  208223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  208251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208261 */     GIR_RootConstrainSelectedInstOperands,
     /*  208262 */     // GIR_Coverage, 2719,
     /*  208262 */     GIR_EraseRootFromParent_Done,
     /*  208263 */   // Label 4188: @208263
     /*  208263 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(208308), // Rule ID 23268 //
     /*  208268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208293 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  208296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208306 */     GIR_RootConstrainSelectedInstOperands,
     /*  208307 */     // GIR_Coverage, 23268,
     /*  208307 */     GIR_EraseRootFromParent_Done,
     /*  208308 */   // Label 4189: @208308
     /*  208308 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(208353), // Rule ID 23269 //
     /*  208313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  208341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208351 */     GIR_RootConstrainSelectedInstOperands,
     /*  208352 */     // GIR_Coverage, 23269,
     /*  208352 */     GIR_EraseRootFromParent_Done,
     /*  208353 */   // Label 4190: @208353
     /*  208353 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(208398), // Rule ID 23270 //
     /*  208358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  208386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208396 */     GIR_RootConstrainSelectedInstOperands,
     /*  208397 */     // GIR_Coverage, 23270,
     /*  208397 */     GIR_EraseRootFromParent_Done,
     /*  208398 */   // Label 4191: @208398
     /*  208398 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(208443), // Rule ID 23271 //
     /*  208403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  208431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208441 */     GIR_RootConstrainSelectedInstOperands,
     /*  208442 */     // GIR_Coverage, 23271,
     /*  208442 */     GIR_EraseRootFromParent_Done,
     /*  208443 */   // Label 4192: @208443
     /*  208443 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(208488), // Rule ID 23272 //
     /*  208448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208486 */     GIR_RootConstrainSelectedInstOperands,
     /*  208487 */     // GIR_Coverage, 23272,
     /*  208487 */     GIR_EraseRootFromParent_Done,
     /*  208488 */   // Label 4193: @208488
     /*  208488 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(208533), // Rule ID 23273 //
     /*  208493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208531 */     GIR_RootConstrainSelectedInstOperands,
     /*  208532 */     // GIR_Coverage, 23273,
     /*  208532 */     GIR_EraseRootFromParent_Done,
     /*  208533 */   // Label 4194: @208533
     /*  208533 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(208578), // Rule ID 23274 //
     /*  208538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208563 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208576 */     GIR_RootConstrainSelectedInstOperands,
     /*  208577 */     // GIR_Coverage, 23274,
     /*  208577 */     GIR_EraseRootFromParent_Done,
     /*  208578 */   // Label 4195: @208578
     /*  208578 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(208623), // Rule ID 23275 //
     /*  208583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208621 */     GIR_RootConstrainSelectedInstOperands,
     /*  208622 */     // GIR_Coverage, 23275,
     /*  208622 */     GIR_EraseRootFromParent_Done,
     /*  208623 */   // Label 4196: @208623
     /*  208623 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(208668), // Rule ID 23276 //
     /*  208628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208653 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208666 */     GIR_RootConstrainSelectedInstOperands,
     /*  208667 */     // GIR_Coverage, 23276,
     /*  208667 */     GIR_EraseRootFromParent_Done,
     /*  208668 */   // Label 4197: @208668
     /*  208668 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(208713), // Rule ID 23277 //
     /*  208673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208698 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208711 */     GIR_RootConstrainSelectedInstOperands,
     /*  208712 */     // GIR_Coverage, 23277,
     /*  208712 */     GIR_EraseRootFromParent_Done,
     /*  208713 */   // Label 4198: @208713
     /*  208713 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(208758), // Rule ID 23278 //
     /*  208718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208743 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208756 */     GIR_RootConstrainSelectedInstOperands,
     /*  208757 */     // GIR_Coverage, 23278,
     /*  208757 */     GIR_EraseRootFromParent_Done,
     /*  208758 */   // Label 4199: @208758
     /*  208758 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(208803), // Rule ID 23279 //
     /*  208763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208788 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11474:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208801 */     GIR_RootConstrainSelectedInstOperands,
     /*  208802 */     // GIR_Coverage, 23279,
     /*  208802 */     GIR_EraseRootFromParent_Done,
     /*  208803 */   // Label 4200: @208803
     /*  208803 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(208848), // Rule ID 23280 //
     /*  208808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208846 */     GIR_RootConstrainSelectedInstOperands,
     /*  208847 */     // GIR_Coverage, 23280,
     /*  208847 */     GIR_EraseRootFromParent_Done,
     /*  208848 */   // Label 4201: @208848
     /*  208848 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(208893), // Rule ID 23281 //
     /*  208853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208891 */     GIR_RootConstrainSelectedInstOperands,
     /*  208892 */     // GIR_Coverage, 23281,
     /*  208892 */     GIR_EraseRootFromParent_Done,
     /*  208893 */   // Label 4202: @208893
     /*  208893 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(208938), // Rule ID 23282 //
     /*  208898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208936 */     GIR_RootConstrainSelectedInstOperands,
     /*  208937 */     // GIR_Coverage, 23282,
     /*  208937 */     GIR_EraseRootFromParent_Done,
     /*  208938 */   // Label 4203: @208938
     /*  208938 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(208983), // Rule ID 23283 //
     /*  208943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208981 */     GIR_RootConstrainSelectedInstOperands,
     /*  208982 */     // GIR_Coverage, 23283,
     /*  208982 */     GIR_EraseRootFromParent_Done,
     /*  208983 */   // Label 4204: @208983
     /*  208983 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(209028), // Rule ID 23284 //
     /*  208988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209013 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  209016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209026 */     GIR_RootConstrainSelectedInstOperands,
     /*  209027 */     // GIR_Coverage, 23284,
     /*  209027 */     GIR_EraseRootFromParent_Done,
     /*  209028 */   // Label 4205: @209028
     /*  209028 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(209073), // Rule ID 23285 //
     /*  209033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  209044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  209061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209071 */     GIR_RootConstrainSelectedInstOperands,
     /*  209072 */     // GIR_Coverage, 23285,
     /*  209072 */     GIR_EraseRootFromParent_Done,
     /*  209073 */   // Label 4206: @209073
     /*  209073 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(209118), // Rule ID 23286 //
     /*  209078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209103 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  209106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209116 */     GIR_RootConstrainSelectedInstOperands,
     /*  209117 */     // GIR_Coverage, 23286,
     /*  209117 */     GIR_EraseRootFromParent_Done,
     /*  209118 */   // Label 4207: @209118
     /*  209118 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(209163), // Rule ID 23287 //
     /*  209123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  209134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  209151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209161 */     GIR_RootConstrainSelectedInstOperands,
     /*  209162 */     // GIR_Coverage, 23287,
     /*  209162 */     GIR_EraseRootFromParent_Done,
     /*  209163 */   // Label 4208: @209163
     /*  209163 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(209208), // Rule ID 23288 //
     /*  209168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209193 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  209196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209206 */     GIR_RootConstrainSelectedInstOperands,
     /*  209207 */     // GIR_Coverage, 23288,
     /*  209207 */     GIR_EraseRootFromParent_Done,
     /*  209208 */   // Label 4209: @209208
     /*  209208 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(209253), // Rule ID 23289 //
     /*  209213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  209224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  209241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209251 */     GIR_RootConstrainSelectedInstOperands,
     /*  209252 */     // GIR_Coverage, 23289,
     /*  209252 */     GIR_EraseRootFromParent_Done,
     /*  209253 */   // Label 4210: @209253
     /*  209253 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(209298), // Rule ID 23290 //
     /*  209258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209283 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  209286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209296 */     GIR_RootConstrainSelectedInstOperands,
     /*  209297 */     // GIR_Coverage, 23290,
     /*  209297 */     GIR_EraseRootFromParent_Done,
     /*  209298 */   // Label 4211: @209298
     /*  209298 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(209343), // Rule ID 23291 //
     /*  209303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  209314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209328 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  209331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209341 */     GIR_RootConstrainSelectedInstOperands,
     /*  209342 */     // GIR_Coverage, 23291,
     /*  209342 */     GIR_EraseRootFromParent_Done,
     /*  209343 */   // Label 4212: @209343
     /*  209343 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(209388), // Rule ID 23292 //
     /*  209348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  209359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209373 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  209376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209386 */     GIR_RootConstrainSelectedInstOperands,
     /*  209387 */     // GIR_Coverage, 23292,
     /*  209387 */     GIR_EraseRootFromParent_Done,
     /*  209388 */   // Label 4213: @209388
     /*  209388 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(209433), // Rule ID 23293 //
     /*  209393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  209401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  209404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209418 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11502:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  209421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209431 */     GIR_RootConstrainSelectedInstOperands,
     /*  209432 */     // GIR_Coverage, 23293,
     /*  209432 */     GIR_EraseRootFromParent_Done,
     /*  209433 */   // Label 4214: @209433
     /*  209433 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(209469), // Rule ID 2655 //
     /*  209438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  209441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  209446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209460 */     // (intrinsic_wo_chain:{ *:[i64] } 11016:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  209463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209467 */     GIR_RootConstrainSelectedInstOperands,
     /*  209468 */     // GIR_Coverage, 2655,
     /*  209468 */     GIR_EraseRootFromParent_Done,
     /*  209469 */   // Label 4215: @209469
     /*  209469 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(209505), // Rule ID 2676 //
     /*  209474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  209482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209496 */     // (intrinsic_wo_chain:{ *:[i64] } 11169:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  209499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209503 */     GIR_RootConstrainSelectedInstOperands,
     /*  209504 */     // GIR_Coverage, 2676,
     /*  209504 */     GIR_EraseRootFromParent_Done,
     /*  209505 */   // Label 4216: @209505
     /*  209505 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(209541), // Rule ID 2677 //
     /*  209510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  209518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209532 */     // (intrinsic_wo_chain:{ *:[i64] } 11172:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  209535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209539 */     GIR_RootConstrainSelectedInstOperands,
     /*  209540 */     // GIR_Coverage, 2677,
     /*  209540 */     GIR_EraseRootFromParent_Done,
     /*  209541 */   // Label 4217: @209541
     /*  209541 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(209577), // Rule ID 2678 //
     /*  209546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  209554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209568 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  209571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209575 */     GIR_RootConstrainSelectedInstOperands,
     /*  209576 */     // GIR_Coverage, 2678,
     /*  209576 */     GIR_EraseRootFromParent_Done,
     /*  209577 */   // Label 4218: @209577
     /*  209577 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(209613), // Rule ID 2679 //
     /*  209582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  209590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209604 */     // (intrinsic_wo_chain:{ *:[i64] } 11177:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  209607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209611 */     GIR_RootConstrainSelectedInstOperands,
     /*  209612 */     // GIR_Coverage, 2679,
     /*  209612 */     GIR_EraseRootFromParent_Done,
     /*  209613 */   // Label 4219: @209613
     /*  209613 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(209649), // Rule ID 64446 //
     /*  209618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  209621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  209626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209640 */     // (intrinsic_wo_chain:{ *:[i32] } 11036:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  209640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  209643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209647 */     GIR_RootConstrainSelectedInstOperands,
     /*  209648 */     // GIR_Coverage, 64446,
     /*  209648 */     GIR_EraseRootFromParent_Done,
     /*  209649 */   // Label 4220: @209649
     /*  209649 */   GIM_Reject,
     /*  209650 */ // Label 4186: @209650
     /*  209650 */ GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(216938),
     /*  209655 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  209658 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(209712), // Rule ID 2688 //
     /*  209663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209695 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209710 */     GIR_RootConstrainSelectedInstOperands,
     /*  209711 */     // GIR_Coverage, 2688,
     /*  209711 */     GIR_EraseRootFromParent_Done,
     /*  209712 */   // Label 4222: @209712
     /*  209712 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(209766), // Rule ID 2689 //
     /*  209717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209749 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209764 */     GIR_RootConstrainSelectedInstOperands,
     /*  209765 */     // GIR_Coverage, 2689,
     /*  209765 */     GIR_EraseRootFromParent_Done,
     /*  209766 */   // Label 4223: @209766
     /*  209766 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(209820), // Rule ID 2694 //
     /*  209771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209818 */     GIR_RootConstrainSelectedInstOperands,
     /*  209819 */     // GIR_Coverage, 2694,
     /*  209819 */     GIR_EraseRootFromParent_Done,
     /*  209820 */   // Label 4224: @209820
     /*  209820 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(209874), // Rule ID 2695 //
     /*  209825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209857 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209872 */     GIR_RootConstrainSelectedInstOperands,
     /*  209873 */     // GIR_Coverage, 2695,
     /*  209873 */     GIR_EraseRootFromParent_Done,
     /*  209874 */   // Label 4225: @209874
     /*  209874 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(209931), // Rule ID 2714 //
     /*  209879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209911 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  209911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209929 */     GIR_RootConstrainSelectedInstOperands,
     /*  209930 */     // GIR_Coverage, 2714,
     /*  209930 */     GIR_EraseRootFromParent_Done,
     /*  209931 */   // Label 4226: @209931
     /*  209931 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(209988), // Rule ID 2715 //
     /*  209936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209968 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  209968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209986 */     GIR_RootConstrainSelectedInstOperands,
     /*  209987 */     // GIR_Coverage, 2715,
     /*  209987 */     GIR_EraseRootFromParent_Done,
     /*  209988 */   // Label 4227: @209988
     /*  209988 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(210042), // Rule ID 23294 //
     /*  209993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210025 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  210028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210040 */     GIR_RootConstrainSelectedInstOperands,
     /*  210041 */     // GIR_Coverage, 23294,
     /*  210041 */     GIR_EraseRootFromParent_Done,
     /*  210042 */   // Label 4228: @210042
     /*  210042 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(210096), // Rule ID 23295 //
     /*  210047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210079 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  210082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210094 */     GIR_RootConstrainSelectedInstOperands,
     /*  210095 */     // GIR_Coverage, 23295,
     /*  210095 */     GIR_EraseRootFromParent_Done,
     /*  210096 */   // Label 4229: @210096
     /*  210096 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(210150), // Rule ID 23298 //
     /*  210101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210133 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  210136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210148 */     GIR_RootConstrainSelectedInstOperands,
     /*  210149 */     // GIR_Coverage, 23298,
     /*  210149 */     GIR_EraseRootFromParent_Done,
     /*  210150 */   // Label 4230: @210150
     /*  210150 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(210204), // Rule ID 23299 //
     /*  210155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210187 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  210190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210202 */     GIR_RootConstrainSelectedInstOperands,
     /*  210203 */     // GIR_Coverage, 23299,
     /*  210203 */     GIR_EraseRootFromParent_Done,
     /*  210204 */   // Label 4231: @210204
     /*  210204 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(210258), // Rule ID 23302 //
     /*  210209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210241 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  210244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210256 */     GIR_RootConstrainSelectedInstOperands,
     /*  210257 */     // GIR_Coverage, 23302,
     /*  210257 */     GIR_EraseRootFromParent_Done,
     /*  210258 */   // Label 4232: @210258
     /*  210258 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(210312), // Rule ID 23303 //
     /*  210263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210295 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  210298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210310 */     GIR_RootConstrainSelectedInstOperands,
     /*  210311 */     // GIR_Coverage, 23303,
     /*  210311 */     GIR_EraseRootFromParent_Done,
     /*  210312 */   // Label 4233: @210312
     /*  210312 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(210366), // Rule ID 23306 //
     /*  210317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210349 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  210352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210364 */     GIR_RootConstrainSelectedInstOperands,
     /*  210365 */     // GIR_Coverage, 23306,
     /*  210365 */     GIR_EraseRootFromParent_Done,
     /*  210366 */   // Label 4234: @210366
     /*  210366 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(210420), // Rule ID 23307 //
     /*  210371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210403 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  210406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210418 */     GIR_RootConstrainSelectedInstOperands,
     /*  210419 */     // GIR_Coverage, 23307,
     /*  210419 */     GIR_EraseRootFromParent_Done,
     /*  210420 */   // Label 4235: @210420
     /*  210420 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(210474), // Rule ID 23310 //
     /*  210425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210457 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210472 */     GIR_RootConstrainSelectedInstOperands,
     /*  210473 */     // GIR_Coverage, 23310,
     /*  210473 */     GIR_EraseRootFromParent_Done,
     /*  210474 */   // Label 4236: @210474
     /*  210474 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(210528), // Rule ID 23311 //
     /*  210479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210511 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210526 */     GIR_RootConstrainSelectedInstOperands,
     /*  210527 */     // GIR_Coverage, 23311,
     /*  210527 */     GIR_EraseRootFromParent_Done,
     /*  210528 */   // Label 4237: @210528
     /*  210528 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(210582), // Rule ID 23314 //
     /*  210533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210565 */     // (intrinsic_wo_chain:{ *:[i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210580 */     GIR_RootConstrainSelectedInstOperands,
     /*  210581 */     // GIR_Coverage, 23314,
     /*  210581 */     GIR_EraseRootFromParent_Done,
     /*  210582 */   // Label 4238: @210582
     /*  210582 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(210636), // Rule ID 23315 //
     /*  210587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210619 */     // (intrinsic_wo_chain:{ *:[i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210634 */     GIR_RootConstrainSelectedInstOperands,
     /*  210635 */     // GIR_Coverage, 23315,
     /*  210635 */     GIR_EraseRootFromParent_Done,
     /*  210636 */   // Label 4239: @210636
     /*  210636 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(210690), // Rule ID 23318 //
     /*  210641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210673 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210688 */     GIR_RootConstrainSelectedInstOperands,
     /*  210689 */     // GIR_Coverage, 23318,
     /*  210689 */     GIR_EraseRootFromParent_Done,
     /*  210690 */   // Label 4240: @210690
     /*  210690 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(210744), // Rule ID 23319 //
     /*  210695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210727 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210742 */     GIR_RootConstrainSelectedInstOperands,
     /*  210743 */     // GIR_Coverage, 23319,
     /*  210743 */     GIR_EraseRootFromParent_Done,
     /*  210744 */   // Label 4241: @210744
     /*  210744 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(210798), // Rule ID 23322 //
     /*  210749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210781 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210796 */     GIR_RootConstrainSelectedInstOperands,
     /*  210797 */     // GIR_Coverage, 23322,
     /*  210797 */     GIR_EraseRootFromParent_Done,
     /*  210798 */   // Label 4242: @210798
     /*  210798 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(210852), // Rule ID 23323 //
     /*  210803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210835 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210850 */     GIR_RootConstrainSelectedInstOperands,
     /*  210851 */     // GIR_Coverage, 23323,
     /*  210851 */     GIR_EraseRootFromParent_Done,
     /*  210852 */   // Label 4243: @210852
     /*  210852 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(210906), // Rule ID 23326 //
     /*  210857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210889 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210904 */     GIR_RootConstrainSelectedInstOperands,
     /*  210905 */     // GIR_Coverage, 23326,
     /*  210905 */     GIR_EraseRootFromParent_Done,
     /*  210906 */   // Label 4244: @210906
     /*  210906 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(210960), // Rule ID 23327 //
     /*  210911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210943 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210958 */     GIR_RootConstrainSelectedInstOperands,
     /*  210959 */     // GIR_Coverage, 23327,
     /*  210959 */     GIR_EraseRootFromParent_Done,
     /*  210960 */   // Label 4245: @210960
     /*  210960 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(211014), // Rule ID 23330 //
     /*  210965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210997 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  211000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211012 */     GIR_RootConstrainSelectedInstOperands,
     /*  211013 */     // GIR_Coverage, 23330,
     /*  211013 */     GIR_EraseRootFromParent_Done,
     /*  211014 */   // Label 4246: @211014
     /*  211014 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(211068), // Rule ID 23331 //
     /*  211019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211051 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  211054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211066 */     GIR_RootConstrainSelectedInstOperands,
     /*  211067 */     // GIR_Coverage, 23331,
     /*  211067 */     GIR_EraseRootFromParent_Done,
     /*  211068 */   // Label 4247: @211068
     /*  211068 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(211122), // Rule ID 23334 //
     /*  211073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211105 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  211108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211120 */     GIR_RootConstrainSelectedInstOperands,
     /*  211121 */     // GIR_Coverage, 23334,
     /*  211121 */     GIR_EraseRootFromParent_Done,
     /*  211122 */   // Label 4248: @211122
     /*  211122 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(211176), // Rule ID 23335 //
     /*  211127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211159 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  211162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211174 */     GIR_RootConstrainSelectedInstOperands,
     /*  211175 */     // GIR_Coverage, 23335,
     /*  211175 */     GIR_EraseRootFromParent_Done,
     /*  211176 */   // Label 4249: @211176
     /*  211176 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(211230), // Rule ID 23338 //
     /*  211181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211213 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  211216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211228 */     GIR_RootConstrainSelectedInstOperands,
     /*  211229 */     // GIR_Coverage, 23338,
     /*  211229 */     GIR_EraseRootFromParent_Done,
     /*  211230 */   // Label 4250: @211230
     /*  211230 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(211284), // Rule ID 23339 //
     /*  211235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211267 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  211270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211282 */     GIR_RootConstrainSelectedInstOperands,
     /*  211283 */     // GIR_Coverage, 23339,
     /*  211283 */     GIR_EraseRootFromParent_Done,
     /*  211284 */   // Label 4251: @211284
     /*  211284 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(211338), // Rule ID 23342 //
     /*  211289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  211300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211321 */     // (intrinsic_wo_chain:{ *:[i64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  211324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211336 */     GIR_RootConstrainSelectedInstOperands,
     /*  211337 */     // GIR_Coverage, 23342,
     /*  211337 */     GIR_EraseRootFromParent_Done,
     /*  211338 */   // Label 4252: @211338
     /*  211338 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(211392), // Rule ID 23343 //
     /*  211343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  211351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  211354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211375 */     // (intrinsic_wo_chain:{ *:[i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  211378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  211382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211390 */     GIR_RootConstrainSelectedInstOperands,
     /*  211391 */     // GIR_Coverage, 23343,
     /*  211391 */     GIR_EraseRootFromParent_Done,
     /*  211392 */   // Label 4253: @211392
     /*  211392 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(211446), // Rule ID 23346 //
     /*  211397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211429 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211444 */     GIR_RootConstrainSelectedInstOperands,
     /*  211445 */     // GIR_Coverage, 23346,
     /*  211445 */     GIR_EraseRootFromParent_Done,
     /*  211446 */   // Label 4254: @211446
     /*  211446 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(211500), // Rule ID 23347 //
     /*  211451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211483 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211498 */     GIR_RootConstrainSelectedInstOperands,
     /*  211499 */     // GIR_Coverage, 23347,
     /*  211499 */     GIR_EraseRootFromParent_Done,
     /*  211500 */   // Label 4255: @211500
     /*  211500 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(211554), // Rule ID 23350 //
     /*  211505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211552 */     GIR_RootConstrainSelectedInstOperands,
     /*  211553 */     // GIR_Coverage, 23350,
     /*  211553 */     GIR_EraseRootFromParent_Done,
     /*  211554 */   // Label 4256: @211554
     /*  211554 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(211608), // Rule ID 23351 //
     /*  211559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211606 */     GIR_RootConstrainSelectedInstOperands,
     /*  211607 */     // GIR_Coverage, 23351,
     /*  211607 */     GIR_EraseRootFromParent_Done,
     /*  211608 */   // Label 4257: @211608
     /*  211608 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(211662), // Rule ID 23354 //
     /*  211613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211645 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211660 */     GIR_RootConstrainSelectedInstOperands,
     /*  211661 */     // GIR_Coverage, 23354,
     /*  211661 */     GIR_EraseRootFromParent_Done,
     /*  211662 */   // Label 4258: @211662
     /*  211662 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(211716), // Rule ID 23355 //
     /*  211667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211714 */     GIR_RootConstrainSelectedInstOperands,
     /*  211715 */     // GIR_Coverage, 23355,
     /*  211715 */     GIR_EraseRootFromParent_Done,
     /*  211716 */   // Label 4259: @211716
     /*  211716 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(211770), // Rule ID 23358 //
     /*  211721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211753 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211768 */     GIR_RootConstrainSelectedInstOperands,
     /*  211769 */     // GIR_Coverage, 23358,
     /*  211769 */     GIR_EraseRootFromParent_Done,
     /*  211770 */   // Label 4260: @211770
     /*  211770 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(211824), // Rule ID 23359 //
     /*  211775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211822 */     GIR_RootConstrainSelectedInstOperands,
     /*  211823 */     // GIR_Coverage, 23359,
     /*  211823 */     GIR_EraseRootFromParent_Done,
     /*  211824 */   // Label 4261: @211824
     /*  211824 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(211878), // Rule ID 23362 //
     /*  211829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211861 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211876 */     GIR_RootConstrainSelectedInstOperands,
     /*  211877 */     // GIR_Coverage, 23362,
     /*  211877 */     GIR_EraseRootFromParent_Done,
     /*  211878 */   // Label 4262: @211878
     /*  211878 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(211932), // Rule ID 23363 //
     /*  211883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211915 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211930 */     GIR_RootConstrainSelectedInstOperands,
     /*  211931 */     // GIR_Coverage, 23363,
     /*  211931 */     GIR_EraseRootFromParent_Done,
     /*  211932 */   // Label 4263: @211932
     /*  211932 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(211986), // Rule ID 23366 //
     /*  211937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211969 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211984 */     GIR_RootConstrainSelectedInstOperands,
     /*  211985 */     // GIR_Coverage, 23366,
     /*  211985 */     GIR_EraseRootFromParent_Done,
     /*  211986 */   // Label 4264: @211986
     /*  211986 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(212040), // Rule ID 23367 //
     /*  211991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212023 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11498:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  212026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212038 */     GIR_RootConstrainSelectedInstOperands,
     /*  212039 */     // GIR_Coverage, 23367,
     /*  212039 */     GIR_EraseRootFromParent_Done,
     /*  212040 */   // Label 4265: @212040
     /*  212040 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(212094), // Rule ID 23370 //
     /*  212045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  212080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212092 */     GIR_RootConstrainSelectedInstOperands,
     /*  212093 */     // GIR_Coverage, 23370,
     /*  212093 */     GIR_EraseRootFromParent_Done,
     /*  212094 */   // Label 4266: @212094
     /*  212094 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(212148), // Rule ID 23371 //
     /*  212099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212131 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  212134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212146 */     GIR_RootConstrainSelectedInstOperands,
     /*  212147 */     // GIR_Coverage, 23371,
     /*  212147 */     GIR_EraseRootFromParent_Done,
     /*  212148 */   // Label 4267: @212148
     /*  212148 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(212202), // Rule ID 23374 //
     /*  212153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212185 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  212188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212200 */     GIR_RootConstrainSelectedInstOperands,
     /*  212201 */     // GIR_Coverage, 23374,
     /*  212201 */     GIR_EraseRootFromParent_Done,
     /*  212202 */   // Label 4268: @212202
     /*  212202 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(212256), // Rule ID 23375 //
     /*  212207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212239 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  212242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212254 */     GIR_RootConstrainSelectedInstOperands,
     /*  212255 */     // GIR_Coverage, 23375,
     /*  212255 */     GIR_EraseRootFromParent_Done,
     /*  212256 */   // Label 4269: @212256
     /*  212256 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(212310), // Rule ID 23378 //
     /*  212261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212293 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  212296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212308 */     GIR_RootConstrainSelectedInstOperands,
     /*  212309 */     // GIR_Coverage, 23378,
     /*  212309 */     GIR_EraseRootFromParent_Done,
     /*  212310 */   // Label 4270: @212310
     /*  212310 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(212364), // Rule ID 23379 //
     /*  212315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212347 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  212350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212362 */     GIR_RootConstrainSelectedInstOperands,
     /*  212363 */     // GIR_Coverage, 23379,
     /*  212363 */     GIR_EraseRootFromParent_Done,
     /*  212364 */   // Label 4271: @212364
     /*  212364 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(212418), // Rule ID 23382 //
     /*  212369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212401 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  212404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212416 */     GIR_RootConstrainSelectedInstOperands,
     /*  212417 */     // GIR_Coverage, 23382,
     /*  212417 */     GIR_EraseRootFromParent_Done,
     /*  212418 */   // Label 4272: @212418
     /*  212418 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(212472), // Rule ID 23383 //
     /*  212423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212455 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  212458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212470 */     GIR_RootConstrainSelectedInstOperands,
     /*  212471 */     // GIR_Coverage, 23383,
     /*  212471 */     GIR_EraseRootFromParent_Done,
     /*  212472 */   // Label 4273: @212472
     /*  212472 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(212526), // Rule ID 23386 //
     /*  212477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212509 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212524 */     GIR_RootConstrainSelectedInstOperands,
     /*  212525 */     // GIR_Coverage, 23386,
     /*  212525 */     GIR_EraseRootFromParent_Done,
     /*  212526 */   // Label 4274: @212526
     /*  212526 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(212580), // Rule ID 23387 //
     /*  212531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212563 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212578 */     GIR_RootConstrainSelectedInstOperands,
     /*  212579 */     // GIR_Coverage, 23387,
     /*  212579 */     GIR_EraseRootFromParent_Done,
     /*  212580 */   // Label 4275: @212580
     /*  212580 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(212634), // Rule ID 23390 //
     /*  212585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212617 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212632 */     GIR_RootConstrainSelectedInstOperands,
     /*  212633 */     // GIR_Coverage, 23390,
     /*  212633 */     GIR_EraseRootFromParent_Done,
     /*  212634 */   // Label 4276: @212634
     /*  212634 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(212688), // Rule ID 23391 //
     /*  212639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212671 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212686 */     GIR_RootConstrainSelectedInstOperands,
     /*  212687 */     // GIR_Coverage, 23391,
     /*  212687 */     GIR_EraseRootFromParent_Done,
     /*  212688 */   // Label 4277: @212688
     /*  212688 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(212742), // Rule ID 23394 //
     /*  212693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212725 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212740 */     GIR_RootConstrainSelectedInstOperands,
     /*  212741 */     // GIR_Coverage, 23394,
     /*  212741 */     GIR_EraseRootFromParent_Done,
     /*  212742 */   // Label 4278: @212742
     /*  212742 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(212796), // Rule ID 23395 //
     /*  212747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212779 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11511:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212794 */     GIR_RootConstrainSelectedInstOperands,
     /*  212795 */     // GIR_Coverage, 23395,
     /*  212795 */     GIR_EraseRootFromParent_Done,
     /*  212796 */   // Label 4279: @212796
     /*  212796 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(212850), // Rule ID 23398 //
     /*  212801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212848 */     GIR_RootConstrainSelectedInstOperands,
     /*  212849 */     // GIR_Coverage, 23398,
     /*  212849 */     GIR_EraseRootFromParent_Done,
     /*  212850 */   // Label 4280: @212850
     /*  212850 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(212904), // Rule ID 23399 //
     /*  212855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212902 */     GIR_RootConstrainSelectedInstOperands,
     /*  212903 */     // GIR_Coverage, 23399,
     /*  212903 */     GIR_EraseRootFromParent_Done,
     /*  212904 */   // Label 4281: @212904
     /*  212904 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(212958), // Rule ID 23402 //
     /*  212909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212956 */     GIR_RootConstrainSelectedInstOperands,
     /*  212957 */     // GIR_Coverage, 23402,
     /*  212957 */     GIR_EraseRootFromParent_Done,
     /*  212958 */   // Label 4282: @212958
     /*  212958 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(213012), // Rule ID 23403 //
     /*  212963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213010 */     GIR_RootConstrainSelectedInstOperands,
     /*  213011 */     // GIR_Coverage, 23403,
     /*  213011 */     GIR_EraseRootFromParent_Done,
     /*  213012 */   // Label 4283: @213012
     /*  213012 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(213066), // Rule ID 23406 //
     /*  213017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213049 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  213052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213064 */     GIR_RootConstrainSelectedInstOperands,
     /*  213065 */     // GIR_Coverage, 23406,
     /*  213065 */     GIR_EraseRootFromParent_Done,
     /*  213066 */   // Label 4284: @213066
     /*  213066 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(213120), // Rule ID 23407 //
     /*  213071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  213082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213103 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  213106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213118 */     GIR_RootConstrainSelectedInstOperands,
     /*  213119 */     // GIR_Coverage, 23407,
     /*  213119 */     GIR_EraseRootFromParent_Done,
     /*  213120 */   // Label 4285: @213120
     /*  213120 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(213174), // Rule ID 23410 //
     /*  213125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213157 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  213160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213172 */     GIR_RootConstrainSelectedInstOperands,
     /*  213173 */     // GIR_Coverage, 23410,
     /*  213173 */     GIR_EraseRootFromParent_Done,
     /*  213174 */   // Label 4286: @213174
     /*  213174 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(213228), // Rule ID 23411 //
     /*  213179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  213190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213211 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  213214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213226 */     GIR_RootConstrainSelectedInstOperands,
     /*  213227 */     // GIR_Coverage, 23411,
     /*  213227 */     GIR_EraseRootFromParent_Done,
     /*  213228 */   // Label 4287: @213228
     /*  213228 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(213282), // Rule ID 23414 //
     /*  213233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213265 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  213268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213280 */     GIR_RootConstrainSelectedInstOperands,
     /*  213281 */     // GIR_Coverage, 23414,
     /*  213281 */     GIR_EraseRootFromParent_Done,
     /*  213282 */   // Label 4288: @213282
     /*  213282 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(213336), // Rule ID 23415 //
     /*  213287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  213298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213319 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  213322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213334 */     GIR_RootConstrainSelectedInstOperands,
     /*  213335 */     // GIR_Coverage, 23415,
     /*  213335 */     GIR_EraseRootFromParent_Done,
     /*  213336 */   // Label 4289: @213336
     /*  213336 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(213390), // Rule ID 23418 //
     /*  213341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213373 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  213376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213388 */     GIR_RootConstrainSelectedInstOperands,
     /*  213389 */     // GIR_Coverage, 23418,
     /*  213389 */     GIR_EraseRootFromParent_Done,
     /*  213390 */   // Label 4290: @213390
     /*  213390 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(213444), // Rule ID 23419 //
     /*  213395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  213406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213427 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  213430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213442 */     GIR_RootConstrainSelectedInstOperands,
     /*  213443 */     // GIR_Coverage, 23419,
     /*  213443 */     GIR_EraseRootFromParent_Done,
     /*  213444 */   // Label 4291: @213444
     /*  213444 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(213498), // Rule ID 23422 //
     /*  213449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213481 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213496 */     GIR_RootConstrainSelectedInstOperands,
     /*  213497 */     // GIR_Coverage, 23422,
     /*  213497 */     GIR_EraseRootFromParent_Done,
     /*  213498 */   // Label 4292: @213498
     /*  213498 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(213552), // Rule ID 23423 //
     /*  213503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213535 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11523:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213550 */     GIR_RootConstrainSelectedInstOperands,
     /*  213551 */     // GIR_Coverage, 23423,
     /*  213551 */     GIR_EraseRootFromParent_Done,
     /*  213552 */   // Label 4293: @213552
     /*  213552 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(213609), // Rule ID 23510 //
     /*  213557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213607 */     GIR_RootConstrainSelectedInstOperands,
     /*  213608 */     // GIR_Coverage, 23510,
     /*  213608 */     GIR_EraseRootFromParent_Done,
     /*  213609 */   // Label 4294: @213609
     /*  213609 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(213666), // Rule ID 23511 //
     /*  213614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213664 */     GIR_RootConstrainSelectedInstOperands,
     /*  213665 */     // GIR_Coverage, 23511,
     /*  213665 */     GIR_EraseRootFromParent_Done,
     /*  213666 */   // Label 4295: @213666
     /*  213666 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(213723), // Rule ID 23514 //
     /*  213671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213703 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213721 */     GIR_RootConstrainSelectedInstOperands,
     /*  213722 */     // GIR_Coverage, 23514,
     /*  213722 */     GIR_EraseRootFromParent_Done,
     /*  213723 */   // Label 4296: @213723
     /*  213723 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(213780), // Rule ID 23515 //
     /*  213728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213778 */     GIR_RootConstrainSelectedInstOperands,
     /*  213779 */     // GIR_Coverage, 23515,
     /*  213779 */     GIR_EraseRootFromParent_Done,
     /*  213780 */   // Label 4297: @213780
     /*  213780 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(213837), // Rule ID 23518 //
     /*  213785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213817 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213835 */     GIR_RootConstrainSelectedInstOperands,
     /*  213836 */     // GIR_Coverage, 23518,
     /*  213836 */     GIR_EraseRootFromParent_Done,
     /*  213837 */   // Label 4298: @213837
     /*  213837 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(213894), // Rule ID 23519 //
     /*  213842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213892 */     GIR_RootConstrainSelectedInstOperands,
     /*  213893 */     // GIR_Coverage, 23519,
     /*  213893 */     GIR_EraseRootFromParent_Done,
     /*  213894 */   // Label 4299: @213894
     /*  213894 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(213951), // Rule ID 23522 //
     /*  213899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213931 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213949 */     GIR_RootConstrainSelectedInstOperands,
     /*  213950 */     // GIR_Coverage, 23522,
     /*  213950 */     GIR_EraseRootFromParent_Done,
     /*  213951 */   // Label 4300: @213951
     /*  213951 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(214008), // Rule ID 23523 //
     /*  213956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213988 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214006 */     GIR_RootConstrainSelectedInstOperands,
     /*  214007 */     // GIR_Coverage, 23523,
     /*  214007 */     GIR_EraseRootFromParent_Done,
     /*  214008 */   // Label 4301: @214008
     /*  214008 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(214065), // Rule ID 23526 //
     /*  214013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214045 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  214048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214063 */     GIR_RootConstrainSelectedInstOperands,
     /*  214064 */     // GIR_Coverage, 23526,
     /*  214064 */     GIR_EraseRootFromParent_Done,
     /*  214065 */   // Label 4302: @214065
     /*  214065 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(214122), // Rule ID 23527 //
     /*  214070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  214081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  214084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  214105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214120 */     GIR_RootConstrainSelectedInstOperands,
     /*  214121 */     // GIR_Coverage, 23527,
     /*  214121 */     GIR_EraseRootFromParent_Done,
     /*  214122 */   // Label 4303: @214122
     /*  214122 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(214179), // Rule ID 23530 //
     /*  214127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214159 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214177 */     GIR_RootConstrainSelectedInstOperands,
     /*  214178 */     // GIR_Coverage, 23530,
     /*  214178 */     GIR_EraseRootFromParent_Done,
     /*  214179 */   // Label 4304: @214179
     /*  214179 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(214236), // Rule ID 23531 //
     /*  214184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  214195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  214198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214234 */     GIR_RootConstrainSelectedInstOperands,
     /*  214235 */     // GIR_Coverage, 23531,
     /*  214235 */     GIR_EraseRootFromParent_Done,
     /*  214236 */   // Label 4305: @214236
     /*  214236 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(214293), // Rule ID 23534 //
     /*  214241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214291 */     GIR_RootConstrainSelectedInstOperands,
     /*  214292 */     // GIR_Coverage, 23534,
     /*  214292 */     GIR_EraseRootFromParent_Done,
     /*  214293 */   // Label 4306: @214293
     /*  214293 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(214350), // Rule ID 23535 //
     /*  214298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  214309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  214312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214348 */     GIR_RootConstrainSelectedInstOperands,
     /*  214349 */     // GIR_Coverage, 23535,
     /*  214349 */     GIR_EraseRootFromParent_Done,
     /*  214350 */   // Label 4307: @214350
     /*  214350 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(214407), // Rule ID 23538 //
     /*  214355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  214366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  214369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214405 */     GIR_RootConstrainSelectedInstOperands,
     /*  214406 */     // GIR_Coverage, 23538,
     /*  214406 */     GIR_EraseRootFromParent_Done,
     /*  214407 */   // Label 4308: @214407
     /*  214407 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(214464), // Rule ID 23539 //
     /*  214412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  214423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  214426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214462 */     GIR_RootConstrainSelectedInstOperands,
     /*  214463 */     // GIR_Coverage, 23539,
     /*  214463 */     GIR_EraseRootFromParent_Done,
     /*  214464 */   // Label 4309: @214464
     /*  214464 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(214521), // Rule ID 23542 //
     /*  214469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214501 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214519 */     GIR_RootConstrainSelectedInstOperands,
     /*  214520 */     // GIR_Coverage, 23542,
     /*  214520 */     GIR_EraseRootFromParent_Done,
     /*  214521 */   // Label 4310: @214521
     /*  214521 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(214578), // Rule ID 23543 //
     /*  214526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214576 */     GIR_RootConstrainSelectedInstOperands,
     /*  214577 */     // GIR_Coverage, 23543,
     /*  214577 */     GIR_EraseRootFromParent_Done,
     /*  214578 */   // Label 4311: @214578
     /*  214578 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(214635), // Rule ID 23546 //
     /*  214583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214615 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214633 */     GIR_RootConstrainSelectedInstOperands,
     /*  214634 */     // GIR_Coverage, 23546,
     /*  214634 */     GIR_EraseRootFromParent_Done,
     /*  214635 */   // Label 4312: @214635
     /*  214635 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(214692), // Rule ID 23547 //
     /*  214640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214690 */     GIR_RootConstrainSelectedInstOperands,
     /*  214691 */     // GIR_Coverage, 23547,
     /*  214691 */     GIR_EraseRootFromParent_Done,
     /*  214692 */   // Label 4313: @214692
     /*  214692 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(214749), // Rule ID 23550 //
     /*  214697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214729 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214747 */     GIR_RootConstrainSelectedInstOperands,
     /*  214748 */     // GIR_Coverage, 23550,
     /*  214748 */     GIR_EraseRootFromParent_Done,
     /*  214749 */   // Label 4314: @214749
     /*  214749 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(214806), // Rule ID 23551 //
     /*  214754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214804 */     GIR_RootConstrainSelectedInstOperands,
     /*  214805 */     // GIR_Coverage, 23551,
     /*  214805 */     GIR_EraseRootFromParent_Done,
     /*  214806 */   // Label 4315: @214806
     /*  214806 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(214863), // Rule ID 23554 //
     /*  214811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214843 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214861 */     GIR_RootConstrainSelectedInstOperands,
     /*  214862 */     // GIR_Coverage, 23554,
     /*  214862 */     GIR_EraseRootFromParent_Done,
     /*  214863 */   // Label 4316: @214863
     /*  214863 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(214920), // Rule ID 23555 //
     /*  214868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214900 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214918 */     GIR_RootConstrainSelectedInstOperands,
     /*  214919 */     // GIR_Coverage, 23555,
     /*  214919 */     GIR_EraseRootFromParent_Done,
     /*  214920 */   // Label 4317: @214920
     /*  214920 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(214977), // Rule ID 23558 //
     /*  214925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214975 */     GIR_RootConstrainSelectedInstOperands,
     /*  214976 */     // GIR_Coverage, 23558,
     /*  214976 */     GIR_EraseRootFromParent_Done,
     /*  214977 */   // Label 4318: @214977
     /*  214977 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(215034), // Rule ID 23559 //
     /*  214982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215032 */     GIR_RootConstrainSelectedInstOperands,
     /*  215033 */     // GIR_Coverage, 23559,
     /*  215033 */     GIR_EraseRootFromParent_Done,
     /*  215034 */   // Label 4319: @215034
     /*  215034 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(215091), // Rule ID 23562 //
     /*  215039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215089 */     GIR_RootConstrainSelectedInstOperands,
     /*  215090 */     // GIR_Coverage, 23562,
     /*  215090 */     GIR_EraseRootFromParent_Done,
     /*  215091 */   // Label 4320: @215091
     /*  215091 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(215148), // Rule ID 23563 //
     /*  215096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  215107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  215110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215146 */     GIR_RootConstrainSelectedInstOperands,
     /*  215147 */     // GIR_Coverage, 23563,
     /*  215147 */     GIR_EraseRootFromParent_Done,
     /*  215148 */   // Label 4321: @215148
     /*  215148 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(215205), // Rule ID 23566 //
     /*  215153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  215164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  215167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215185 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  215185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215203 */     GIR_RootConstrainSelectedInstOperands,
     /*  215204 */     // GIR_Coverage, 23566,
     /*  215204 */     GIR_EraseRootFromParent_Done,
     /*  215205 */   // Label 4322: @215205
     /*  215205 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(215262), // Rule ID 23567 //
     /*  215210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  215221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  215224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  215242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  215257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215260 */     GIR_RootConstrainSelectedInstOperands,
     /*  215261 */     // GIR_Coverage, 23567,
     /*  215261 */     GIR_EraseRootFromParent_Done,
     /*  215262 */   // Label 4323: @215262
     /*  215262 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(215319), // Rule ID 23570 //
     /*  215267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  215278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  215281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215317 */     GIR_RootConstrainSelectedInstOperands,
     /*  215318 */     // GIR_Coverage, 23570,
     /*  215318 */     GIR_EraseRootFromParent_Done,
     /*  215319 */   // Label 4324: @215319
     /*  215319 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(215376), // Rule ID 23571 //
     /*  215324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  215335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  215338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215374 */     GIR_RootConstrainSelectedInstOperands,
     /*  215375 */     // GIR_Coverage, 23571,
     /*  215375 */     GIR_EraseRootFromParent_Done,
     /*  215376 */   // Label 4325: @215376
     /*  215376 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(215433), // Rule ID 23574 //
     /*  215381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  215392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  215395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215413 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215431 */     GIR_RootConstrainSelectedInstOperands,
     /*  215432 */     // GIR_Coverage, 23574,
     /*  215432 */     GIR_EraseRootFromParent_Done,
     /*  215433 */   // Label 4326: @215433
     /*  215433 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(215490), // Rule ID 23575 //
     /*  215438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  215449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  215452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215488 */     GIR_RootConstrainSelectedInstOperands,
     /*  215489 */     // GIR_Coverage, 23575,
     /*  215489 */     GIR_EraseRootFromParent_Done,
     /*  215490 */   // Label 4327: @215490
     /*  215490 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(215547), // Rule ID 23578 //
     /*  215495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215545 */     GIR_RootConstrainSelectedInstOperands,
     /*  215546 */     // GIR_Coverage, 23578,
     /*  215546 */     GIR_EraseRootFromParent_Done,
     /*  215547 */   // Label 4328: @215547
     /*  215547 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(215604), // Rule ID 23579 //
     /*  215552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215584 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215602 */     GIR_RootConstrainSelectedInstOperands,
     /*  215603 */     // GIR_Coverage, 23579,
     /*  215603 */     GIR_EraseRootFromParent_Done,
     /*  215604 */   // Label 4329: @215604
     /*  215604 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(215661), // Rule ID 23582 //
     /*  215609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215659 */     GIR_RootConstrainSelectedInstOperands,
     /*  215660 */     // GIR_Coverage, 23582,
     /*  215660 */     GIR_EraseRootFromParent_Done,
     /*  215661 */   // Label 4330: @215661
     /*  215661 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(215718), // Rule ID 23583 //
     /*  215666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11377:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215716 */     GIR_RootConstrainSelectedInstOperands,
     /*  215717 */     // GIR_Coverage, 23583,
     /*  215717 */     GIR_EraseRootFromParent_Done,
     /*  215718 */   // Label 4331: @215718
     /*  215718 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(215775), // Rule ID 23586 //
     /*  215723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215755 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215773 */     GIR_RootConstrainSelectedInstOperands,
     /*  215774 */     // GIR_Coverage, 23586,
     /*  215774 */     GIR_EraseRootFromParent_Done,
     /*  215775 */   // Label 4332: @215775
     /*  215775 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(215832), // Rule ID 23587 //
     /*  215780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11377:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215830 */     GIR_RootConstrainSelectedInstOperands,
     /*  215831 */     // GIR_Coverage, 23587,
     /*  215831 */     GIR_EraseRootFromParent_Done,
     /*  215832 */   // Label 4333: @215832
     /*  215832 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(215889), // Rule ID 23590 //
     /*  215837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215887 */     GIR_RootConstrainSelectedInstOperands,
     /*  215888 */     // GIR_Coverage, 23590,
     /*  215888 */     GIR_EraseRootFromParent_Done,
     /*  215889 */   // Label 4334: @215889
     /*  215889 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(215946), // Rule ID 23591 //
     /*  215894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11377:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215944 */     GIR_RootConstrainSelectedInstOperands,
     /*  215945 */     // GIR_Coverage, 23591,
     /*  215945 */     GIR_EraseRootFromParent_Done,
     /*  215946 */   // Label 4335: @215946
     /*  215946 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(215992), // Rule ID 2657 //
     /*  215951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  215959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215973 */     // MIs[0] rnum
     /*  215973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  215976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  215981 */     // (intrinsic_wo_chain:{ *:[i64] } 11017:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  215981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  215984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  215990 */     GIR_RootConstrainSelectedInstOperands,
     /*  215991 */     // GIR_Coverage, 2657,
     /*  215991 */     GIR_EraseRootFromParent_Done,
     /*  215992 */   // Label 4336: @215992
     /*  215992 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(216037), // Rule ID 64454 //
     /*  215997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  216000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  216005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216026 */     // (intrinsic_wo_chain:{ *:[i32] } 11027:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  216029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216035 */     GIR_RootConstrainSelectedInstOperands,
     /*  216036 */     // GIR_Coverage, 64454,
     /*  216036 */     GIR_EraseRootFromParent_Done,
     /*  216037 */   // Label 4337: @216037
     /*  216037 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(216082), // Rule ID 64481 //
     /*  216042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  216045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  216050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216071 */     // (intrinsic_wo_chain:{ *:[i32] } 11028:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  216074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216080 */     GIR_RootConstrainSelectedInstOperands,
     /*  216081 */     // GIR_Coverage, 64481,
     /*  216081 */     GIR_EraseRootFromParent_Done,
     /*  216082 */   // Label 4338: @216082
     /*  216082 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(216127), // Rule ID 2647 //
     /*  216087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  216090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  216095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216116 */     // (intrinsic_wo_chain:{ *:[i64] } 11735:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  216119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216125 */     GIR_RootConstrainSelectedInstOperands,
     /*  216126 */     // GIR_Coverage, 2647,
     /*  216126 */     GIR_EraseRootFromParent_Done,
     /*  216127 */   // Label 4339: @216127
     /*  216127 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(216172), // Rule ID 2648 //
     /*  216132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  216135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  216140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216161 */     // (intrinsic_wo_chain:{ *:[i32] } 11735:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  216164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216170 */     GIR_RootConstrainSelectedInstOperands,
     /*  216171 */     // GIR_Coverage, 2648,
     /*  216171 */     GIR_EraseRootFromParent_Done,
     /*  216172 */   // Label 4340: @216172
     /*  216172 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(216217), // Rule ID 2649 //
     /*  216177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  216180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  216185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216206 */     // (intrinsic_wo_chain:{ *:[i64] } 11736:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  216209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216215 */     GIR_RootConstrainSelectedInstOperands,
     /*  216216 */     // GIR_Coverage, 2649,
     /*  216216 */     GIR_EraseRootFromParent_Done,
     /*  216217 */   // Label 4341: @216217
     /*  216217 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(216262), // Rule ID 2650 //
     /*  216222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  216225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  216230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216251 */     // (intrinsic_wo_chain:{ *:[i32] } 11736:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  216254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216260 */     GIR_RootConstrainSelectedInstOperands,
     /*  216261 */     // GIR_Coverage, 2650,
     /*  216261 */     GIR_EraseRootFromParent_Done,
     /*  216262 */   // Label 4342: @216262
     /*  216262 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(216307), // Rule ID 2653 //
     /*  216267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  216270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  216275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216296 */     // (intrinsic_wo_chain:{ *:[i64] } 11012:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  216299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216305 */     GIR_RootConstrainSelectedInstOperands,
     /*  216306 */     // GIR_Coverage, 2653,
     /*  216306 */     GIR_EraseRootFromParent_Done,
     /*  216307 */   // Label 4343: @216307
     /*  216307 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(216352), // Rule ID 2654 //
     /*  216312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  216315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  216320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216341 */     // (intrinsic_wo_chain:{ *:[i64] } 11013:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  216344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216350 */     GIR_RootConstrainSelectedInstOperands,
     /*  216351 */     // GIR_Coverage, 2654,
     /*  216351 */     GIR_EraseRootFromParent_Done,
     /*  216352 */   // Label 4344: @216352
     /*  216352 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(216397), // Rule ID 2656 //
     /*  216357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  216360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  216365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216386 */     // (intrinsic_wo_chain:{ *:[i64] } 11018:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  216389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216395 */     GIR_RootConstrainSelectedInstOperands,
     /*  216396 */     // GIR_Coverage, 2656,
     /*  216396 */     GIR_EraseRootFromParent_Done,
     /*  216397 */   // Label 4345: @216397
     /*  216397 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(216442), // Rule ID 2660 //
     /*  216402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  216405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  216410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216431 */     // (intrinsic_wo_chain:{ *:[i64] } 11014:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  216434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216440 */     GIR_RootConstrainSelectedInstOperands,
     /*  216441 */     // GIR_Coverage, 2660,
     /*  216441 */     GIR_EraseRootFromParent_Done,
     /*  216442 */   // Label 4346: @216442
     /*  216442 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(216487), // Rule ID 2661 //
     /*  216447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  216450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  216455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  216458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  216461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216476 */     // (intrinsic_wo_chain:{ *:[i64] } 11015:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  216479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216485 */     GIR_RootConstrainSelectedInstOperands,
     /*  216486 */     // GIR_Coverage, 2661,
     /*  216486 */     GIR_EraseRootFromParent_Done,
     /*  216487 */   // Label 4347: @216487
     /*  216487 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(216532), // Rule ID 2670 //
     /*  216492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  216500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216521 */     // (intrinsic_wo_chain:{ *:[i32] } 11171:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  216524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216530 */     GIR_RootConstrainSelectedInstOperands,
     /*  216531 */     // GIR_Coverage, 2670,
     /*  216531 */     GIR_EraseRootFromParent_Done,
     /*  216532 */   // Label 4348: @216532
     /*  216532 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(216577), // Rule ID 2671 //
     /*  216537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  216545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216566 */     // (intrinsic_wo_chain:{ *:[i32] } 11170:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  216569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216575 */     GIR_RootConstrainSelectedInstOperands,
     /*  216576 */     // GIR_Coverage, 2671,
     /*  216576 */     GIR_EraseRootFromParent_Done,
     /*  216577 */   // Label 4349: @216577
     /*  216577 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(216622), // Rule ID 2672 //
     /*  216582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  216590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216611 */     // (intrinsic_wo_chain:{ *:[i32] } 11174:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  216614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216620 */     GIR_RootConstrainSelectedInstOperands,
     /*  216621 */     // GIR_Coverage, 2672,
     /*  216621 */     GIR_EraseRootFromParent_Done,
     /*  216622 */   // Label 4350: @216622
     /*  216622 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(216667), // Rule ID 2673 //
     /*  216627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  216635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216656 */     // (intrinsic_wo_chain:{ *:[i32] } 11173:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  216659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216665 */     GIR_RootConstrainSelectedInstOperands,
     /*  216666 */     // GIR_Coverage, 2673,
     /*  216666 */     GIR_EraseRootFromParent_Done,
     /*  216667 */   // Label 4351: @216667
     /*  216667 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(216712), // Rule ID 2674 //
     /*  216672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  216680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216701 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  216704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216710 */     GIR_RootConstrainSelectedInstOperands,
     /*  216711 */     // GIR_Coverage, 2674,
     /*  216711 */     GIR_EraseRootFromParent_Done,
     /*  216712 */   // Label 4352: @216712
     /*  216712 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(216757), // Rule ID 2675 //
     /*  216717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  216725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216746 */     // (intrinsic_wo_chain:{ *:[i32] } 11178:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  216749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216755 */     GIR_RootConstrainSelectedInstOperands,
     /*  216756 */     // GIR_Coverage, 2675,
     /*  216756 */     GIR_EraseRootFromParent_Done,
     /*  216757 */   // Label 4353: @216757
     /*  216757 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(216802), // Rule ID 64431 //
     /*  216762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  216770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216791 */     // (intrinsic_wo_chain:{ *:[i32] } 11037:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  216794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216800 */     GIR_RootConstrainSelectedInstOperands,
     /*  216801 */     // GIR_Coverage, 64431,
     /*  216801 */     GIR_EraseRootFromParent_Done,
     /*  216802 */   // Label 4354: @216802
     /*  216802 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(216847), // Rule ID 64433 //
     /*  216807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  216815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216836 */     // (intrinsic_wo_chain:{ *:[i32] } 11038:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  216839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216845 */     GIR_RootConstrainSelectedInstOperands,
     /*  216846 */     // GIR_Coverage, 64433,
     /*  216846 */     GIR_EraseRootFromParent_Done,
     /*  216847 */   // Label 4355: @216847
     /*  216847 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(216892), // Rule ID 64435 //
     /*  216852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  216860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216881 */     // (intrinsic_wo_chain:{ *:[i32] } 11033:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  216884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216890 */     GIR_RootConstrainSelectedInstOperands,
     /*  216891 */     // GIR_Coverage, 64435,
     /*  216891 */     GIR_EraseRootFromParent_Done,
     /*  216892 */   // Label 4356: @216892
     /*  216892 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(216937), // Rule ID 64437 //
     /*  216897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  216905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216926 */     // (intrinsic_wo_chain:{ *:[i32] } 11035:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  216929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216935 */     GIR_RootConstrainSelectedInstOperands,
     /*  216936 */     // GIR_Coverage, 64437,
     /*  216936 */     GIR_EraseRootFromParent_Done,
     /*  216937 */   // Label 4357: @216937
     /*  216937 */   GIM_Reject,
     /*  216938 */ // Label 4221: @216938
     /*  216938 */ GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(387843),
     /*  216943 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  216946 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(217020), // Rule ID 5468 //
     /*  216951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216991 */     // MIs[1] Operand 1
     /*  216991 */     // No operand predicates
     /*  216991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  217003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217018 */     GIR_RootConstrainSelectedInstOperands,
     /*  217019 */     // GIR_Coverage, 5468,
     /*  217019 */     GIR_EraseRootFromParent_Done,
     /*  217020 */   // Label 4359: @217020
     /*  217020 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(217094), // Rule ID 5469 //
     /*  217025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  217039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217065 */     // MIs[1] Operand 1
     /*  217065 */     // No operand predicates
     /*  217065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  217077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217092 */     GIR_RootConstrainSelectedInstOperands,
     /*  217093 */     // GIR_Coverage, 5469,
     /*  217093 */     GIR_EraseRootFromParent_Done,
     /*  217094 */   // Label 4360: @217094
     /*  217094 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(217168), // Rule ID 5470 //
     /*  217099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217139 */     // MIs[1] Operand 1
     /*  217139 */     // No operand predicates
     /*  217139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217166 */     GIR_RootConstrainSelectedInstOperands,
     /*  217167 */     // GIR_Coverage, 5470,
     /*  217167 */     GIR_EraseRootFromParent_Done,
     /*  217168 */   // Label 4361: @217168
     /*  217168 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(217242), // Rule ID 5471 //
     /*  217173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217213 */     // MIs[1] Operand 1
     /*  217213 */     // No operand predicates
     /*  217213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217222 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217240 */     GIR_RootConstrainSelectedInstOperands,
     /*  217241 */     // GIR_Coverage, 5471,
     /*  217241 */     GIR_EraseRootFromParent_Done,
     /*  217242 */   // Label 4362: @217242
     /*  217242 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(217316), // Rule ID 5472 //
     /*  217247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217287 */     // MIs[1] Operand 1
     /*  217287 */     // No operand predicates
     /*  217287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217314 */     GIR_RootConstrainSelectedInstOperands,
     /*  217315 */     // GIR_Coverage, 5472,
     /*  217315 */     GIR_EraseRootFromParent_Done,
     /*  217316 */   // Label 4363: @217316
     /*  217316 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(217390), // Rule ID 5473 //
     /*  217321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217361 */     // MIs[1] Operand 1
     /*  217361 */     // No operand predicates
     /*  217361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217388 */     GIR_RootConstrainSelectedInstOperands,
     /*  217389 */     // GIR_Coverage, 5473,
     /*  217389 */     GIR_EraseRootFromParent_Done,
     /*  217390 */   // Label 4364: @217390
     /*  217390 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(217464), // Rule ID 5474 //
     /*  217395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217435 */     // MIs[1] Operand 1
     /*  217435 */     // No operand predicates
     /*  217435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217462 */     GIR_RootConstrainSelectedInstOperands,
     /*  217463 */     // GIR_Coverage, 5474,
     /*  217463 */     GIR_EraseRootFromParent_Done,
     /*  217464 */   // Label 4365: @217464
     /*  217464 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(217538), // Rule ID 5475 //
     /*  217469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217509 */     // MIs[1] Operand 1
     /*  217509 */     // No operand predicates
     /*  217509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217536 */     GIR_RootConstrainSelectedInstOperands,
     /*  217537 */     // GIR_Coverage, 5475,
     /*  217537 */     GIR_EraseRootFromParent_Done,
     /*  217538 */   // Label 4366: @217538
     /*  217538 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(217612), // Rule ID 5476 //
     /*  217543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217583 */     // MIs[1] Operand 1
     /*  217583 */     // No operand predicates
     /*  217583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217610 */     GIR_RootConstrainSelectedInstOperands,
     /*  217611 */     // GIR_Coverage, 5476,
     /*  217611 */     GIR_EraseRootFromParent_Done,
     /*  217612 */   // Label 4367: @217612
     /*  217612 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(217686), // Rule ID 5477 //
     /*  217617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217657 */     // MIs[1] Operand 1
     /*  217657 */     // No operand predicates
     /*  217657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217666 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217684 */     GIR_RootConstrainSelectedInstOperands,
     /*  217685 */     // GIR_Coverage, 5477,
     /*  217685 */     GIR_EraseRootFromParent_Done,
     /*  217686 */   // Label 4368: @217686
     /*  217686 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(217760), // Rule ID 5478 //
     /*  217691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217731 */     // MIs[1] Operand 1
     /*  217731 */     // No operand predicates
     /*  217731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217758 */     GIR_RootConstrainSelectedInstOperands,
     /*  217759 */     // GIR_Coverage, 5478,
     /*  217759 */     GIR_EraseRootFromParent_Done,
     /*  217760 */   // Label 4369: @217760
     /*  217760 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(217834), // Rule ID 5479 //
     /*  217765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217805 */     // MIs[1] Operand 1
     /*  217805 */     // No operand predicates
     /*  217805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217832 */     GIR_RootConstrainSelectedInstOperands,
     /*  217833 */     // GIR_Coverage, 5479,
     /*  217833 */     GIR_EraseRootFromParent_Done,
     /*  217834 */   // Label 4370: @217834
     /*  217834 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(217908), // Rule ID 5480 //
     /*  217839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217879 */     // MIs[1] Operand 1
     /*  217879 */     // No operand predicates
     /*  217879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217906 */     GIR_RootConstrainSelectedInstOperands,
     /*  217907 */     // GIR_Coverage, 5480,
     /*  217907 */     GIR_EraseRootFromParent_Done,
     /*  217908 */   // Label 4371: @217908
     /*  217908 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(217982), // Rule ID 5481 //
     /*  217913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217953 */     // MIs[1] Operand 1
     /*  217953 */     // No operand predicates
     /*  217953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217980 */     GIR_RootConstrainSelectedInstOperands,
     /*  217981 */     // GIR_Coverage, 5481,
     /*  217981 */     GIR_EraseRootFromParent_Done,
     /*  217982 */   // Label 4372: @217982
     /*  217982 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(218056), // Rule ID 5482 //
     /*  217987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  218001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218027 */     // MIs[1] Operand 1
     /*  218027 */     // No operand predicates
     /*  218027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218054 */     GIR_RootConstrainSelectedInstOperands,
     /*  218055 */     // GIR_Coverage, 5482,
     /*  218055 */     GIR_EraseRootFromParent_Done,
     /*  218056 */   // Label 4373: @218056
     /*  218056 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(218130), // Rule ID 5483 //
     /*  218061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  218075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218101 */     // MIs[1] Operand 1
     /*  218101 */     // No operand predicates
     /*  218101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218128 */     GIR_RootConstrainSelectedInstOperands,
     /*  218129 */     // GIR_Coverage, 5483,
     /*  218129 */     GIR_EraseRootFromParent_Done,
     /*  218130 */   // Label 4374: @218130
     /*  218130 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(218204), // Rule ID 5484 //
     /*  218135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  218149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218175 */     // MIs[1] Operand 1
     /*  218175 */     // No operand predicates
     /*  218175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218202 */     GIR_RootConstrainSelectedInstOperands,
     /*  218203 */     // GIR_Coverage, 5484,
     /*  218203 */     GIR_EraseRootFromParent_Done,
     /*  218204 */   // Label 4375: @218204
     /*  218204 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(218278), // Rule ID 5485 //
     /*  218209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  218223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218249 */     // MIs[1] Operand 1
     /*  218249 */     // No operand predicates
     /*  218249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218276 */     GIR_RootConstrainSelectedInstOperands,
     /*  218277 */     // GIR_Coverage, 5485,
     /*  218277 */     GIR_EraseRootFromParent_Done,
     /*  218278 */   // Label 4376: @218278
     /*  218278 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(218352), // Rule ID 5486 //
     /*  218283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  218294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  218297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218323 */     // MIs[1] Operand 1
     /*  218323 */     // No operand predicates
     /*  218323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  218332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218350 */     GIR_RootConstrainSelectedInstOperands,
     /*  218351 */     // GIR_Coverage, 5486,
     /*  218351 */     GIR_EraseRootFromParent_Done,
     /*  218352 */   // Label 4377: @218352
     /*  218352 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(218426), // Rule ID 5487 //
     /*  218357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  218360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  218368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  218371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218397 */     // MIs[1] Operand 1
     /*  218397 */     // No operand predicates
     /*  218397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218406 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  218406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  218409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218424 */     GIR_RootConstrainSelectedInstOperands,
     /*  218425 */     // GIR_Coverage, 5487,
     /*  218425 */     GIR_EraseRootFromParent_Done,
     /*  218426 */   // Label 4378: @218426
     /*  218426 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(218500), // Rule ID 5488 //
     /*  218431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218471 */     // MIs[1] Operand 1
     /*  218471 */     // No operand predicates
     /*  218471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218498 */     GIR_RootConstrainSelectedInstOperands,
     /*  218499 */     // GIR_Coverage, 5488,
     /*  218499 */     GIR_EraseRootFromParent_Done,
     /*  218500 */   // Label 4379: @218500
     /*  218500 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(218574), // Rule ID 5489 //
     /*  218505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218545 */     // MIs[1] Operand 1
     /*  218545 */     // No operand predicates
     /*  218545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218572 */     GIR_RootConstrainSelectedInstOperands,
     /*  218573 */     // GIR_Coverage, 5489,
     /*  218573 */     GIR_EraseRootFromParent_Done,
     /*  218574 */   // Label 4380: @218574
     /*  218574 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(218648), // Rule ID 5490 //
     /*  218579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218619 */     // MIs[1] Operand 1
     /*  218619 */     // No operand predicates
     /*  218619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218646 */     GIR_RootConstrainSelectedInstOperands,
     /*  218647 */     // GIR_Coverage, 5490,
     /*  218647 */     GIR_EraseRootFromParent_Done,
     /*  218648 */   // Label 4381: @218648
     /*  218648 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(218722), // Rule ID 5491 //
     /*  218653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218693 */     // MIs[1] Operand 1
     /*  218693 */     // No operand predicates
     /*  218693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218702 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218720 */     GIR_RootConstrainSelectedInstOperands,
     /*  218721 */     // GIR_Coverage, 5491,
     /*  218721 */     GIR_EraseRootFromParent_Done,
     /*  218722 */   // Label 4382: @218722
     /*  218722 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(218796), // Rule ID 5492 //
     /*  218727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218767 */     // MIs[1] Operand 1
     /*  218767 */     // No operand predicates
     /*  218767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218776 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218794 */     GIR_RootConstrainSelectedInstOperands,
     /*  218795 */     // GIR_Coverage, 5492,
     /*  218795 */     GIR_EraseRootFromParent_Done,
     /*  218796 */   // Label 4383: @218796
     /*  218796 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(218870), // Rule ID 5493 //
     /*  218801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218841 */     // MIs[1] Operand 1
     /*  218841 */     // No operand predicates
     /*  218841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218850 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218868 */     GIR_RootConstrainSelectedInstOperands,
     /*  218869 */     // GIR_Coverage, 5493,
     /*  218869 */     GIR_EraseRootFromParent_Done,
     /*  218870 */   // Label 4384: @218870
     /*  218870 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(218944), // Rule ID 5494 //
     /*  218875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218915 */     // MIs[1] Operand 1
     /*  218915 */     // No operand predicates
     /*  218915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218924 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218942 */     GIR_RootConstrainSelectedInstOperands,
     /*  218943 */     // GIR_Coverage, 5494,
     /*  218943 */     GIR_EraseRootFromParent_Done,
     /*  218944 */   // Label 4385: @218944
     /*  218944 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(219018), // Rule ID 5495 //
     /*  218949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218989 */     // MIs[1] Operand 1
     /*  218989 */     // No operand predicates
     /*  218989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219016 */     GIR_RootConstrainSelectedInstOperands,
     /*  219017 */     // GIR_Coverage, 5495,
     /*  219017 */     GIR_EraseRootFromParent_Done,
     /*  219018 */   // Label 4386: @219018
     /*  219018 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219092), // Rule ID 5496 //
     /*  219023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219063 */     // MIs[1] Operand 1
     /*  219063 */     // No operand predicates
     /*  219063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219090 */     GIR_RootConstrainSelectedInstOperands,
     /*  219091 */     // GIR_Coverage, 5496,
     /*  219091 */     GIR_EraseRootFromParent_Done,
     /*  219092 */   // Label 4387: @219092
     /*  219092 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219166), // Rule ID 5497 //
     /*  219097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  219111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219137 */     // MIs[1] Operand 1
     /*  219137 */     // No operand predicates
     /*  219137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219164 */     GIR_RootConstrainSelectedInstOperands,
     /*  219165 */     // GIR_Coverage, 5497,
     /*  219165 */     GIR_EraseRootFromParent_Done,
     /*  219166 */   // Label 4388: @219166
     /*  219166 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219240), // Rule ID 5498 //
     /*  219171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  219182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219211 */     // MIs[1] Operand 1
     /*  219211 */     // No operand predicates
     /*  219211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219220 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219238 */     GIR_RootConstrainSelectedInstOperands,
     /*  219239 */     // GIR_Coverage, 5498,
     /*  219239 */     GIR_EraseRootFromParent_Done,
     /*  219240 */   // Label 4389: @219240
     /*  219240 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219314), // Rule ID 5499 //
     /*  219245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  219256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  219259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219285 */     // MIs[1] Operand 1
     /*  219285 */     // No operand predicates
     /*  219285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219294 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219312 */     GIR_RootConstrainSelectedInstOperands,
     /*  219313 */     // GIR_Coverage, 5499,
     /*  219313 */     GIR_EraseRootFromParent_Done,
     /*  219314 */   // Label 4390: @219314
     /*  219314 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219388), // Rule ID 5500 //
     /*  219319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219359 */     // MIs[1] Operand 1
     /*  219359 */     // No operand predicates
     /*  219359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219386 */     GIR_RootConstrainSelectedInstOperands,
     /*  219387 */     // GIR_Coverage, 5500,
     /*  219387 */     GIR_EraseRootFromParent_Done,
     /*  219388 */   // Label 4391: @219388
     /*  219388 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(219462), // Rule ID 5501 //
     /*  219393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  219407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219433 */     // MIs[1] Operand 1
     /*  219433 */     // No operand predicates
     /*  219433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219460 */     GIR_RootConstrainSelectedInstOperands,
     /*  219461 */     // GIR_Coverage, 5501,
     /*  219461 */     GIR_EraseRootFromParent_Done,
     /*  219462 */   // Label 4392: @219462
     /*  219462 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(219536), // Rule ID 5502 //
     /*  219467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219507 */     // MIs[1] Operand 1
     /*  219507 */     // No operand predicates
     /*  219507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219534 */     GIR_RootConstrainSelectedInstOperands,
     /*  219535 */     // GIR_Coverage, 5502,
     /*  219535 */     GIR_EraseRootFromParent_Done,
     /*  219536 */   // Label 4393: @219536
     /*  219536 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(219610), // Rule ID 5503 //
     /*  219541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219581 */     // MIs[1] Operand 1
     /*  219581 */     // No operand predicates
     /*  219581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219608 */     GIR_RootConstrainSelectedInstOperands,
     /*  219609 */     // GIR_Coverage, 5503,
     /*  219609 */     GIR_EraseRootFromParent_Done,
     /*  219610 */   // Label 4394: @219610
     /*  219610 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(219684), // Rule ID 5504 //
     /*  219615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219655 */     // MIs[1] Operand 1
     /*  219655 */     // No operand predicates
     /*  219655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219682 */     GIR_RootConstrainSelectedInstOperands,
     /*  219683 */     // GIR_Coverage, 5504,
     /*  219683 */     GIR_EraseRootFromParent_Done,
     /*  219684 */   // Label 4395: @219684
     /*  219684 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(219758), // Rule ID 5505 //
     /*  219689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219729 */     // MIs[1] Operand 1
     /*  219729 */     // No operand predicates
     /*  219729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219738 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219756 */     GIR_RootConstrainSelectedInstOperands,
     /*  219757 */     // GIR_Coverage, 5505,
     /*  219757 */     GIR_EraseRootFromParent_Done,
     /*  219758 */   // Label 4396: @219758
     /*  219758 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(219832), // Rule ID 5506 //
     /*  219763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219803 */     // MIs[1] Operand 1
     /*  219803 */     // No operand predicates
     /*  219803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219830 */     GIR_RootConstrainSelectedInstOperands,
     /*  219831 */     // GIR_Coverage, 5506,
     /*  219831 */     GIR_EraseRootFromParent_Done,
     /*  219832 */   // Label 4397: @219832
     /*  219832 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(219906), // Rule ID 5507 //
     /*  219837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219877 */     // MIs[1] Operand 1
     /*  219877 */     // No operand predicates
     /*  219877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219904 */     GIR_RootConstrainSelectedInstOperands,
     /*  219905 */     // GIR_Coverage, 5507,
     /*  219905 */     GIR_EraseRootFromParent_Done,
     /*  219906 */   // Label 4398: @219906
     /*  219906 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(219980), // Rule ID 5508 //
     /*  219911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219951 */     // MIs[1] Operand 1
     /*  219951 */     // No operand predicates
     /*  219951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219960 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219978 */     GIR_RootConstrainSelectedInstOperands,
     /*  219979 */     // GIR_Coverage, 5508,
     /*  219979 */     GIR_EraseRootFromParent_Done,
     /*  219980 */   // Label 4399: @219980
     /*  219980 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(220054), // Rule ID 5509 //
     /*  219985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220025 */     // MIs[1] Operand 1
     /*  220025 */     // No operand predicates
     /*  220025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  220034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  220037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220052 */     GIR_RootConstrainSelectedInstOperands,
     /*  220053 */     // GIR_Coverage, 5509,
     /*  220053 */     GIR_EraseRootFromParent_Done,
     /*  220054 */   // Label 4400: @220054
     /*  220054 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(220128), // Rule ID 5510 //
     /*  220059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  220062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220099 */     // MIs[1] Operand 1
     /*  220099 */     // No operand predicates
     /*  220099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  220108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  220111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220126 */     GIR_RootConstrainSelectedInstOperands,
     /*  220127 */     // GIR_Coverage, 5510,
     /*  220127 */     GIR_EraseRootFromParent_Done,
     /*  220128 */   // Label 4401: @220128
     /*  220128 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(220202), // Rule ID 5511 //
     /*  220133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  220136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  220147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  220161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220173 */     // MIs[1] Operand 1
     /*  220173 */     // No operand predicates
     /*  220173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  220182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  220185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220200 */     GIR_RootConstrainSelectedInstOperands,
     /*  220201 */     // GIR_Coverage, 5511,
     /*  220201 */     GIR_EraseRootFromParent_Done,
     /*  220202 */   // Label 4402: @220202
     /*  220202 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(220276), // Rule ID 7980 //
     /*  220207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220247 */     // MIs[1] Operand 1
     /*  220247 */     // No operand predicates
     /*  220247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  220259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220274 */     GIR_RootConstrainSelectedInstOperands,
     /*  220275 */     // GIR_Coverage, 7980,
     /*  220275 */     GIR_EraseRootFromParent_Done,
     /*  220276 */   // Label 4403: @220276
     /*  220276 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(220350), // Rule ID 7981 //
     /*  220281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220321 */     // MIs[1] Operand 1
     /*  220321 */     // No operand predicates
     /*  220321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  220333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220348 */     GIR_RootConstrainSelectedInstOperands,
     /*  220349 */     // GIR_Coverage, 7981,
     /*  220349 */     GIR_EraseRootFromParent_Done,
     /*  220350 */   // Label 4404: @220350
     /*  220350 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(220424), // Rule ID 7984 //
     /*  220355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220395 */     // MIs[1] Operand 1
     /*  220395 */     // No operand predicates
     /*  220395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220422 */     GIR_RootConstrainSelectedInstOperands,
     /*  220423 */     // GIR_Coverage, 7984,
     /*  220423 */     GIR_EraseRootFromParent_Done,
     /*  220424 */   // Label 4405: @220424
     /*  220424 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(220498), // Rule ID 7985 //
     /*  220429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220469 */     // MIs[1] Operand 1
     /*  220469 */     // No operand predicates
     /*  220469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220496 */     GIR_RootConstrainSelectedInstOperands,
     /*  220497 */     // GIR_Coverage, 7985,
     /*  220497 */     GIR_EraseRootFromParent_Done,
     /*  220498 */   // Label 4406: @220498
     /*  220498 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(220572), // Rule ID 7988 //
     /*  220503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220543 */     // MIs[1] Operand 1
     /*  220543 */     // No operand predicates
     /*  220543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220570 */     GIR_RootConstrainSelectedInstOperands,
     /*  220571 */     // GIR_Coverage, 7988,
     /*  220571 */     GIR_EraseRootFromParent_Done,
     /*  220572 */   // Label 4407: @220572
     /*  220572 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(220646), // Rule ID 7989 //
     /*  220577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220617 */     // MIs[1] Operand 1
     /*  220617 */     // No operand predicates
     /*  220617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220644 */     GIR_RootConstrainSelectedInstOperands,
     /*  220645 */     // GIR_Coverage, 7989,
     /*  220645 */     GIR_EraseRootFromParent_Done,
     /*  220646 */   // Label 4408: @220646
     /*  220646 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(220720), // Rule ID 7992 //
     /*  220651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220691 */     // MIs[1] Operand 1
     /*  220691 */     // No operand predicates
     /*  220691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220718 */     GIR_RootConstrainSelectedInstOperands,
     /*  220719 */     // GIR_Coverage, 7992,
     /*  220719 */     GIR_EraseRootFromParent_Done,
     /*  220720 */   // Label 4409: @220720
     /*  220720 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220794), // Rule ID 7993 //
     /*  220725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220765 */     // MIs[1] Operand 1
     /*  220765 */     // No operand predicates
     /*  220765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220792 */     GIR_RootConstrainSelectedInstOperands,
     /*  220793 */     // GIR_Coverage, 7993,
     /*  220793 */     GIR_EraseRootFromParent_Done,
     /*  220794 */   // Label 4410: @220794
     /*  220794 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220868), // Rule ID 7996 //
     /*  220799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220839 */     // MIs[1] Operand 1
     /*  220839 */     // No operand predicates
     /*  220839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220866 */     GIR_RootConstrainSelectedInstOperands,
     /*  220867 */     // GIR_Coverage, 7996,
     /*  220867 */     GIR_EraseRootFromParent_Done,
     /*  220868 */   // Label 4411: @220868
     /*  220868 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220942), // Rule ID 7997 //
     /*  220873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220913 */     // MIs[1] Operand 1
     /*  220913 */     // No operand predicates
     /*  220913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220940 */     GIR_RootConstrainSelectedInstOperands,
     /*  220941 */     // GIR_Coverage, 7997,
     /*  220941 */     GIR_EraseRootFromParent_Done,
     /*  220942 */   // Label 4412: @220942
     /*  220942 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221016), // Rule ID 8000 //
     /*  220947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220987 */     // MIs[1] Operand 1
     /*  220987 */     // No operand predicates
     /*  220987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220996 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221014 */     GIR_RootConstrainSelectedInstOperands,
     /*  221015 */     // GIR_Coverage, 8000,
     /*  221015 */     GIR_EraseRootFromParent_Done,
     /*  221016 */   // Label 4413: @221016
     /*  221016 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(221090), // Rule ID 8001 //
     /*  221021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221061 */     // MIs[1] Operand 1
     /*  221061 */     // No operand predicates
     /*  221061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  221073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221088 */     GIR_RootConstrainSelectedInstOperands,
     /*  221089 */     // GIR_Coverage, 8001,
     /*  221089 */     GIR_EraseRootFromParent_Done,
     /*  221090 */   // Label 4414: @221090
     /*  221090 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(221164), // Rule ID 8004 //
     /*  221095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221135 */     // MIs[1] Operand 1
     /*  221135 */     // No operand predicates
     /*  221135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221162 */     GIR_RootConstrainSelectedInstOperands,
     /*  221163 */     // GIR_Coverage, 8004,
     /*  221163 */     GIR_EraseRootFromParent_Done,
     /*  221164 */   // Label 4415: @221164
     /*  221164 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221238), // Rule ID 8005 //
     /*  221169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221209 */     // MIs[1] Operand 1
     /*  221209 */     // No operand predicates
     /*  221209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221236 */     GIR_RootConstrainSelectedInstOperands,
     /*  221237 */     // GIR_Coverage, 8005,
     /*  221237 */     GIR_EraseRootFromParent_Done,
     /*  221238 */   // Label 4416: @221238
     /*  221238 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221312), // Rule ID 8008 //
     /*  221243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221283 */     // MIs[1] Operand 1
     /*  221283 */     // No operand predicates
     /*  221283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221310 */     GIR_RootConstrainSelectedInstOperands,
     /*  221311 */     // GIR_Coverage, 8008,
     /*  221311 */     GIR_EraseRootFromParent_Done,
     /*  221312 */   // Label 4417: @221312
     /*  221312 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221386), // Rule ID 8009 //
     /*  221317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221357 */     // MIs[1] Operand 1
     /*  221357 */     // No operand predicates
     /*  221357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221384 */     GIR_RootConstrainSelectedInstOperands,
     /*  221385 */     // GIR_Coverage, 8009,
     /*  221385 */     GIR_EraseRootFromParent_Done,
     /*  221386 */   // Label 4418: @221386
     /*  221386 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221460), // Rule ID 8012 //
     /*  221391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221431 */     // MIs[1] Operand 1
     /*  221431 */     // No operand predicates
     /*  221431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221458 */     GIR_RootConstrainSelectedInstOperands,
     /*  221459 */     // GIR_Coverage, 8012,
     /*  221459 */     GIR_EraseRootFromParent_Done,
     /*  221460 */   // Label 4419: @221460
     /*  221460 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(221534), // Rule ID 8013 //
     /*  221465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221505 */     // MIs[1] Operand 1
     /*  221505 */     // No operand predicates
     /*  221505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221532 */     GIR_RootConstrainSelectedInstOperands,
     /*  221533 */     // GIR_Coverage, 8013,
     /*  221533 */     GIR_EraseRootFromParent_Done,
     /*  221534 */   // Label 4420: @221534
     /*  221534 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(221608), // Rule ID 8016 //
     /*  221539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221579 */     // MIs[1] Operand 1
     /*  221579 */     // No operand predicates
     /*  221579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221606 */     GIR_RootConstrainSelectedInstOperands,
     /*  221607 */     // GIR_Coverage, 8016,
     /*  221607 */     GIR_EraseRootFromParent_Done,
     /*  221608 */   // Label 4421: @221608
     /*  221608 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(221682), // Rule ID 8017 //
     /*  221613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221653 */     // MIs[1] Operand 1
     /*  221653 */     // No operand predicates
     /*  221653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221680 */     GIR_RootConstrainSelectedInstOperands,
     /*  221681 */     // GIR_Coverage, 8017,
     /*  221681 */     GIR_EraseRootFromParent_Done,
     /*  221682 */   // Label 4422: @221682
     /*  221682 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(221756), // Rule ID 8020 //
     /*  221687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221727 */     // MIs[1] Operand 1
     /*  221727 */     // No operand predicates
     /*  221727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221754 */     GIR_RootConstrainSelectedInstOperands,
     /*  221755 */     // GIR_Coverage, 8020,
     /*  221755 */     GIR_EraseRootFromParent_Done,
     /*  221756 */   // Label 4423: @221756
     /*  221756 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(221830), // Rule ID 8021 //
     /*  221761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221801 */     // MIs[1] Operand 1
     /*  221801 */     // No operand predicates
     /*  221801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221810 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221828 */     GIR_RootConstrainSelectedInstOperands,
     /*  221829 */     // GIR_Coverage, 8021,
     /*  221829 */     GIR_EraseRootFromParent_Done,
     /*  221830 */   // Label 4424: @221830
     /*  221830 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(221904), // Rule ID 8024 //
     /*  221835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221875 */     // MIs[1] Operand 1
     /*  221875 */     // No operand predicates
     /*  221875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221884 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221902 */     GIR_RootConstrainSelectedInstOperands,
     /*  221903 */     // GIR_Coverage, 8024,
     /*  221903 */     GIR_EraseRootFromParent_Done,
     /*  221904 */   // Label 4425: @221904
     /*  221904 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(221978), // Rule ID 8025 //
     /*  221909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221949 */     // MIs[1] Operand 1
     /*  221949 */     // No operand predicates
     /*  221949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221958 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221976 */     GIR_RootConstrainSelectedInstOperands,
     /*  221977 */     // GIR_Coverage, 8025,
     /*  221977 */     GIR_EraseRootFromParent_Done,
     /*  221978 */   // Label 4426: @221978
     /*  221978 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222052), // Rule ID 8028 //
     /*  221983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222023 */     // MIs[1] Operand 1
     /*  222023 */     // No operand predicates
     /*  222023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222032 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222050 */     GIR_RootConstrainSelectedInstOperands,
     /*  222051 */     // GIR_Coverage, 8028,
     /*  222051 */     GIR_EraseRootFromParent_Done,
     /*  222052 */   // Label 4427: @222052
     /*  222052 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222126), // Rule ID 8029 //
     /*  222057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222097 */     // MIs[1] Operand 1
     /*  222097 */     // No operand predicates
     /*  222097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222106 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222124 */     GIR_RootConstrainSelectedInstOperands,
     /*  222125 */     // GIR_Coverage, 8029,
     /*  222125 */     GIR_EraseRootFromParent_Done,
     /*  222126 */   // Label 4428: @222126
     /*  222126 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222200), // Rule ID 8032 //
     /*  222131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222171 */     // MIs[1] Operand 1
     /*  222171 */     // No operand predicates
     /*  222171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222198 */     GIR_RootConstrainSelectedInstOperands,
     /*  222199 */     // GIR_Coverage, 8032,
     /*  222199 */     GIR_EraseRootFromParent_Done,
     /*  222200 */   // Label 4429: @222200
     /*  222200 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222274), // Rule ID 8033 //
     /*  222205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222245 */     // MIs[1] Operand 1
     /*  222245 */     // No operand predicates
     /*  222245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222272 */     GIR_RootConstrainSelectedInstOperands,
     /*  222273 */     // GIR_Coverage, 8033,
     /*  222273 */     GIR_EraseRootFromParent_Done,
     /*  222274 */   // Label 4430: @222274
     /*  222274 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222348), // Rule ID 8036 //
     /*  222279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222319 */     // MIs[1] Operand 1
     /*  222319 */     // No operand predicates
     /*  222319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222328 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222346 */     GIR_RootConstrainSelectedInstOperands,
     /*  222347 */     // GIR_Coverage, 8036,
     /*  222347 */     GIR_EraseRootFromParent_Done,
     /*  222348 */   // Label 4431: @222348
     /*  222348 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222422), // Rule ID 8037 //
     /*  222353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222393 */     // MIs[1] Operand 1
     /*  222393 */     // No operand predicates
     /*  222393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222402 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222420 */     GIR_RootConstrainSelectedInstOperands,
     /*  222421 */     // GIR_Coverage, 8037,
     /*  222421 */     GIR_EraseRootFromParent_Done,
     /*  222422 */   // Label 4432: @222422
     /*  222422 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222496), // Rule ID 8040 //
     /*  222427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222467 */     // MIs[1] Operand 1
     /*  222467 */     // No operand predicates
     /*  222467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222494 */     GIR_RootConstrainSelectedInstOperands,
     /*  222495 */     // GIR_Coverage, 8040,
     /*  222495 */     GIR_EraseRootFromParent_Done,
     /*  222496 */   // Label 4433: @222496
     /*  222496 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222570), // Rule ID 8041 //
     /*  222501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222541 */     // MIs[1] Operand 1
     /*  222541 */     // No operand predicates
     /*  222541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222550 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222568 */     GIR_RootConstrainSelectedInstOperands,
     /*  222569 */     // GIR_Coverage, 8041,
     /*  222569 */     GIR_EraseRootFromParent_Done,
     /*  222570 */   // Label 4434: @222570
     /*  222570 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222644), // Rule ID 8044 //
     /*  222575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222615 */     // MIs[1] Operand 1
     /*  222615 */     // No operand predicates
     /*  222615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222624 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222642 */     GIR_RootConstrainSelectedInstOperands,
     /*  222643 */     // GIR_Coverage, 8044,
     /*  222643 */     GIR_EraseRootFromParent_Done,
     /*  222644 */   // Label 4435: @222644
     /*  222644 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222718), // Rule ID 8045 //
     /*  222649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222689 */     // MIs[1] Operand 1
     /*  222689 */     // No operand predicates
     /*  222689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222716 */     GIR_RootConstrainSelectedInstOperands,
     /*  222717 */     // GIR_Coverage, 8045,
     /*  222717 */     GIR_EraseRootFromParent_Done,
     /*  222718 */   // Label 4436: @222718
     /*  222718 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222792), // Rule ID 8048 //
     /*  222723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222763 */     // MIs[1] Operand 1
     /*  222763 */     // No operand predicates
     /*  222763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222790 */     GIR_RootConstrainSelectedInstOperands,
     /*  222791 */     // GIR_Coverage, 8048,
     /*  222791 */     GIR_EraseRootFromParent_Done,
     /*  222792 */   // Label 4437: @222792
     /*  222792 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(222866), // Rule ID 8049 //
     /*  222797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222837 */     // MIs[1] Operand 1
     /*  222837 */     // No operand predicates
     /*  222837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222846 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222864 */     GIR_RootConstrainSelectedInstOperands,
     /*  222865 */     // GIR_Coverage, 8049,
     /*  222865 */     GIR_EraseRootFromParent_Done,
     /*  222866 */   // Label 4438: @222866
     /*  222866 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(222940), // Rule ID 8052 //
     /*  222871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222911 */     // MIs[1] Operand 1
     /*  222911 */     // No operand predicates
     /*  222911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222938 */     GIR_RootConstrainSelectedInstOperands,
     /*  222939 */     // GIR_Coverage, 8052,
     /*  222939 */     GIR_EraseRootFromParent_Done,
     /*  222940 */   // Label 4439: @222940
     /*  222940 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223014), // Rule ID 8053 //
     /*  222945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222985 */     // MIs[1] Operand 1
     /*  222985 */     // No operand predicates
     /*  222985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223012 */     GIR_RootConstrainSelectedInstOperands,
     /*  223013 */     // GIR_Coverage, 8053,
     /*  223013 */     GIR_EraseRootFromParent_Done,
     /*  223014 */   // Label 4440: @223014
     /*  223014 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223088), // Rule ID 8056 //
     /*  223019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223059 */     // MIs[1] Operand 1
     /*  223059 */     // No operand predicates
     /*  223059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  223071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223086 */     GIR_RootConstrainSelectedInstOperands,
     /*  223087 */     // GIR_Coverage, 8056,
     /*  223087 */     GIR_EraseRootFromParent_Done,
     /*  223088 */   // Label 4441: @223088
     /*  223088 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223162), // Rule ID 8057 //
     /*  223093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223133 */     // MIs[1] Operand 1
     /*  223133 */     // No operand predicates
     /*  223133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  223145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223160 */     GIR_RootConstrainSelectedInstOperands,
     /*  223161 */     // GIR_Coverage, 8057,
     /*  223161 */     GIR_EraseRootFromParent_Done,
     /*  223162 */   // Label 4442: @223162
     /*  223162 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223236), // Rule ID 8060 //
     /*  223167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223207 */     // MIs[1] Operand 1
     /*  223207 */     // No operand predicates
     /*  223207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  223219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223234 */     GIR_RootConstrainSelectedInstOperands,
     /*  223235 */     // GIR_Coverage, 8060,
     /*  223235 */     GIR_EraseRootFromParent_Done,
     /*  223236 */   // Label 4443: @223236
     /*  223236 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223310), // Rule ID 8061 //
     /*  223241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223281 */     // MIs[1] Operand 1
     /*  223281 */     // No operand predicates
     /*  223281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  223293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223308 */     GIR_RootConstrainSelectedInstOperands,
     /*  223309 */     // GIR_Coverage, 8061,
     /*  223309 */     GIR_EraseRootFromParent_Done,
     /*  223310 */   // Label 4444: @223310
     /*  223310 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223384), // Rule ID 8064 //
     /*  223315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223355 */     // MIs[1] Operand 1
     /*  223355 */     // No operand predicates
     /*  223355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  223367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223382 */     GIR_RootConstrainSelectedInstOperands,
     /*  223383 */     // GIR_Coverage, 8064,
     /*  223383 */     GIR_EraseRootFromParent_Done,
     /*  223384 */   // Label 4445: @223384
     /*  223384 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223458), // Rule ID 8065 //
     /*  223389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223429 */     // MIs[1] Operand 1
     /*  223429 */     // No operand predicates
     /*  223429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  223441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223456 */     GIR_RootConstrainSelectedInstOperands,
     /*  223457 */     // GIR_Coverage, 8065,
     /*  223457 */     GIR_EraseRootFromParent_Done,
     /*  223458 */   // Label 4446: @223458
     /*  223458 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223532), // Rule ID 8244 //
     /*  223463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223503 */     // MIs[1] Operand 1
     /*  223503 */     // No operand predicates
     /*  223503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223530 */     GIR_RootConstrainSelectedInstOperands,
     /*  223531 */     // GIR_Coverage, 8244,
     /*  223531 */     GIR_EraseRootFromParent_Done,
     /*  223532 */   // Label 4447: @223532
     /*  223532 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223606), // Rule ID 8245 //
     /*  223537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223577 */     // MIs[1] Operand 1
     /*  223577 */     // No operand predicates
     /*  223577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223586 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223604 */     GIR_RootConstrainSelectedInstOperands,
     /*  223605 */     // GIR_Coverage, 8245,
     /*  223605 */     GIR_EraseRootFromParent_Done,
     /*  223606 */   // Label 4448: @223606
     /*  223606 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223680), // Rule ID 8248 //
     /*  223611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223651 */     // MIs[1] Operand 1
     /*  223651 */     // No operand predicates
     /*  223651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223678 */     GIR_RootConstrainSelectedInstOperands,
     /*  223679 */     // GIR_Coverage, 8248,
     /*  223679 */     GIR_EraseRootFromParent_Done,
     /*  223680 */   // Label 4449: @223680
     /*  223680 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223754), // Rule ID 8249 //
     /*  223685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223725 */     // MIs[1] Operand 1
     /*  223725 */     // No operand predicates
     /*  223725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223734 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223752 */     GIR_RootConstrainSelectedInstOperands,
     /*  223753 */     // GIR_Coverage, 8249,
     /*  223753 */     GIR_EraseRootFromParent_Done,
     /*  223754 */   // Label 4450: @223754
     /*  223754 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223828), // Rule ID 8252 //
     /*  223759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223799 */     // MIs[1] Operand 1
     /*  223799 */     // No operand predicates
     /*  223799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223826 */     GIR_RootConstrainSelectedInstOperands,
     /*  223827 */     // GIR_Coverage, 8252,
     /*  223827 */     GIR_EraseRootFromParent_Done,
     /*  223828 */   // Label 4451: @223828
     /*  223828 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223902), // Rule ID 8253 //
     /*  223833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223873 */     // MIs[1] Operand 1
     /*  223873 */     // No operand predicates
     /*  223873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223882 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223900 */     GIR_RootConstrainSelectedInstOperands,
     /*  223901 */     // GIR_Coverage, 8253,
     /*  223901 */     GIR_EraseRootFromParent_Done,
     /*  223902 */   // Label 4452: @223902
     /*  223902 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223976), // Rule ID 8256 //
     /*  223907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223947 */     // MIs[1] Operand 1
     /*  223947 */     // No operand predicates
     /*  223947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223974 */     GIR_RootConstrainSelectedInstOperands,
     /*  223975 */     // GIR_Coverage, 8256,
     /*  223975 */     GIR_EraseRootFromParent_Done,
     /*  223976 */   // Label 4453: @223976
     /*  223976 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224050), // Rule ID 8257 //
     /*  223981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224021 */     // MIs[1] Operand 1
     /*  224021 */     // No operand predicates
     /*  224021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  224033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224048 */     GIR_RootConstrainSelectedInstOperands,
     /*  224049 */     // GIR_Coverage, 8257,
     /*  224049 */     GIR_EraseRootFromParent_Done,
     /*  224050 */   // Label 4454: @224050
     /*  224050 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224124), // Rule ID 8260 //
     /*  224055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224095 */     // MIs[1] Operand 1
     /*  224095 */     // No operand predicates
     /*  224095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224122 */     GIR_RootConstrainSelectedInstOperands,
     /*  224123 */     // GIR_Coverage, 8260,
     /*  224123 */     GIR_EraseRootFromParent_Done,
     /*  224124 */   // Label 4455: @224124
     /*  224124 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224198), // Rule ID 8261 //
     /*  224129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224169 */     // MIs[1] Operand 1
     /*  224169 */     // No operand predicates
     /*  224169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224196 */     GIR_RootConstrainSelectedInstOperands,
     /*  224197 */     // GIR_Coverage, 8261,
     /*  224197 */     GIR_EraseRootFromParent_Done,
     /*  224198 */   // Label 4456: @224198
     /*  224198 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224272), // Rule ID 8264 //
     /*  224203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224243 */     // MIs[1] Operand 1
     /*  224243 */     // No operand predicates
     /*  224243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224270 */     GIR_RootConstrainSelectedInstOperands,
     /*  224271 */     // GIR_Coverage, 8264,
     /*  224271 */     GIR_EraseRootFromParent_Done,
     /*  224272 */   // Label 4457: @224272
     /*  224272 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(224346), // Rule ID 8265 //
     /*  224277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224317 */     // MIs[1] Operand 1
     /*  224317 */     // No operand predicates
     /*  224317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  224329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224344 */     GIR_RootConstrainSelectedInstOperands,
     /*  224345 */     // GIR_Coverage, 8265,
     /*  224345 */     GIR_EraseRootFromParent_Done,
     /*  224346 */   // Label 4458: @224346
     /*  224346 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(224420), // Rule ID 8268 //
     /*  224351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224391 */     // MIs[1] Operand 1
     /*  224391 */     // No operand predicates
     /*  224391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224418 */     GIR_RootConstrainSelectedInstOperands,
     /*  224419 */     // GIR_Coverage, 8268,
     /*  224419 */     GIR_EraseRootFromParent_Done,
     /*  224420 */   // Label 4459: @224420
     /*  224420 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(224494), // Rule ID 8269 //
     /*  224425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224465 */     // MIs[1] Operand 1
     /*  224465 */     // No operand predicates
     /*  224465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224474 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224492 */     GIR_RootConstrainSelectedInstOperands,
     /*  224493 */     // GIR_Coverage, 8269,
     /*  224493 */     GIR_EraseRootFromParent_Done,
     /*  224494 */   // Label 4460: @224494
     /*  224494 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224568), // Rule ID 8272 //
     /*  224499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224539 */     // MIs[1] Operand 1
     /*  224539 */     // No operand predicates
     /*  224539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224566 */     GIR_RootConstrainSelectedInstOperands,
     /*  224567 */     // GIR_Coverage, 8272,
     /*  224567 */     GIR_EraseRootFromParent_Done,
     /*  224568 */   // Label 4461: @224568
     /*  224568 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224642), // Rule ID 8273 //
     /*  224573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224613 */     // MIs[1] Operand 1
     /*  224613 */     // No operand predicates
     /*  224613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224640 */     GIR_RootConstrainSelectedInstOperands,
     /*  224641 */     // GIR_Coverage, 8273,
     /*  224641 */     GIR_EraseRootFromParent_Done,
     /*  224642 */   // Label 4462: @224642
     /*  224642 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224716), // Rule ID 8276 //
     /*  224647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224687 */     // MIs[1] Operand 1
     /*  224687 */     // No operand predicates
     /*  224687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224714 */     GIR_RootConstrainSelectedInstOperands,
     /*  224715 */     // GIR_Coverage, 8276,
     /*  224715 */     GIR_EraseRootFromParent_Done,
     /*  224716 */   // Label 4463: @224716
     /*  224716 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224790), // Rule ID 8277 //
     /*  224721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224761 */     // MIs[1] Operand 1
     /*  224761 */     // No operand predicates
     /*  224761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224788 */     GIR_RootConstrainSelectedInstOperands,
     /*  224789 */     // GIR_Coverage, 8277,
     /*  224789 */     GIR_EraseRootFromParent_Done,
     /*  224790 */   // Label 4464: @224790
     /*  224790 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224864), // Rule ID 8280 //
     /*  224795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224835 */     // MIs[1] Operand 1
     /*  224835 */     // No operand predicates
     /*  224835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224862 */     GIR_RootConstrainSelectedInstOperands,
     /*  224863 */     // GIR_Coverage, 8280,
     /*  224863 */     GIR_EraseRootFromParent_Done,
     /*  224864 */   // Label 4465: @224864
     /*  224864 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224938), // Rule ID 8281 //
     /*  224869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224909 */     // MIs[1] Operand 1
     /*  224909 */     // No operand predicates
     /*  224909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224918 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224936 */     GIR_RootConstrainSelectedInstOperands,
     /*  224937 */     // GIR_Coverage, 8281,
     /*  224937 */     GIR_EraseRootFromParent_Done,
     /*  224938 */   // Label 4466: @224938
     /*  224938 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225012), // Rule ID 8284 //
     /*  224943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224983 */     // MIs[1] Operand 1
     /*  224983 */     // No operand predicates
     /*  224983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225010 */     GIR_RootConstrainSelectedInstOperands,
     /*  225011 */     // GIR_Coverage, 8284,
     /*  225011 */     GIR_EraseRootFromParent_Done,
     /*  225012 */   // Label 4467: @225012
     /*  225012 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225086), // Rule ID 8285 //
     /*  225017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225057 */     // MIs[1] Operand 1
     /*  225057 */     // No operand predicates
     /*  225057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225066 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225084 */     GIR_RootConstrainSelectedInstOperands,
     /*  225085 */     // GIR_Coverage, 8285,
     /*  225085 */     GIR_EraseRootFromParent_Done,
     /*  225086 */   // Label 4468: @225086
     /*  225086 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225160), // Rule ID 8288 //
     /*  225091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225131 */     // MIs[1] Operand 1
     /*  225131 */     // No operand predicates
     /*  225131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225140 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225158 */     GIR_RootConstrainSelectedInstOperands,
     /*  225159 */     // GIR_Coverage, 8288,
     /*  225159 */     GIR_EraseRootFromParent_Done,
     /*  225160 */   // Label 4469: @225160
     /*  225160 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225234), // Rule ID 8289 //
     /*  225165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225205 */     // MIs[1] Operand 1
     /*  225205 */     // No operand predicates
     /*  225205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225214 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225232 */     GIR_RootConstrainSelectedInstOperands,
     /*  225233 */     // GIR_Coverage, 8289,
     /*  225233 */     GIR_EraseRootFromParent_Done,
     /*  225234 */   // Label 4470: @225234
     /*  225234 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225308), // Rule ID 8292 //
     /*  225239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225279 */     // MIs[1] Operand 1
     /*  225279 */     // No operand predicates
     /*  225279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225288 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225306 */     GIR_RootConstrainSelectedInstOperands,
     /*  225307 */     // GIR_Coverage, 8292,
     /*  225307 */     GIR_EraseRootFromParent_Done,
     /*  225308 */   // Label 4471: @225308
     /*  225308 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225382), // Rule ID 8293 //
     /*  225313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225353 */     // MIs[1] Operand 1
     /*  225353 */     // No operand predicates
     /*  225353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225362 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225380 */     GIR_RootConstrainSelectedInstOperands,
     /*  225381 */     // GIR_Coverage, 8293,
     /*  225381 */     GIR_EraseRootFromParent_Done,
     /*  225382 */   // Label 4472: @225382
     /*  225382 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225456), // Rule ID 8296 //
     /*  225387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225427 */     // MIs[1] Operand 1
     /*  225427 */     // No operand predicates
     /*  225427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225454 */     GIR_RootConstrainSelectedInstOperands,
     /*  225455 */     // GIR_Coverage, 8296,
     /*  225455 */     GIR_EraseRootFromParent_Done,
     /*  225456 */   // Label 4473: @225456
     /*  225456 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225530), // Rule ID 8297 //
     /*  225461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225501 */     // MIs[1] Operand 1
     /*  225501 */     // No operand predicates
     /*  225501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225528 */     GIR_RootConstrainSelectedInstOperands,
     /*  225529 */     // GIR_Coverage, 8297,
     /*  225529 */     GIR_EraseRootFromParent_Done,
     /*  225530 */   // Label 4474: @225530
     /*  225530 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225604), // Rule ID 8300 //
     /*  225535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225575 */     // MIs[1] Operand 1
     /*  225575 */     // No operand predicates
     /*  225575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225602 */     GIR_RootConstrainSelectedInstOperands,
     /*  225603 */     // GIR_Coverage, 8300,
     /*  225603 */     GIR_EraseRootFromParent_Done,
     /*  225604 */   // Label 4475: @225604
     /*  225604 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225678), // Rule ID 8301 //
     /*  225609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225649 */     // MIs[1] Operand 1
     /*  225649 */     // No operand predicates
     /*  225649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225658 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225676 */     GIR_RootConstrainSelectedInstOperands,
     /*  225677 */     // GIR_Coverage, 8301,
     /*  225677 */     GIR_EraseRootFromParent_Done,
     /*  225678 */   // Label 4476: @225678
     /*  225678 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225752), // Rule ID 8304 //
     /*  225683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225723 */     // MIs[1] Operand 1
     /*  225723 */     // No operand predicates
     /*  225723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225732 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225750 */     GIR_RootConstrainSelectedInstOperands,
     /*  225751 */     // GIR_Coverage, 8304,
     /*  225751 */     GIR_EraseRootFromParent_Done,
     /*  225752 */   // Label 4477: @225752
     /*  225752 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225826), // Rule ID 8305 //
     /*  225757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225797 */     // MIs[1] Operand 1
     /*  225797 */     // No operand predicates
     /*  225797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225806 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225824 */     GIR_RootConstrainSelectedInstOperands,
     /*  225825 */     // GIR_Coverage, 8305,
     /*  225825 */     GIR_EraseRootFromParent_Done,
     /*  225826 */   // Label 4478: @225826
     /*  225826 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225900), // Rule ID 8308 //
     /*  225831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225871 */     // MIs[1] Operand 1
     /*  225871 */     // No operand predicates
     /*  225871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225898 */     GIR_RootConstrainSelectedInstOperands,
     /*  225899 */     // GIR_Coverage, 8308,
     /*  225899 */     GIR_EraseRootFromParent_Done,
     /*  225900 */   // Label 4479: @225900
     /*  225900 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225974), // Rule ID 8309 //
     /*  225905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225945 */     // MIs[1] Operand 1
     /*  225945 */     // No operand predicates
     /*  225945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225972 */     GIR_RootConstrainSelectedInstOperands,
     /*  225973 */     // GIR_Coverage, 8309,
     /*  225973 */     GIR_EraseRootFromParent_Done,
     /*  225974 */   // Label 4480: @225974
     /*  225974 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226048), // Rule ID 8312 //
     /*  225979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226019 */     // MIs[1] Operand 1
     /*  226019 */     // No operand predicates
     /*  226019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226046 */     GIR_RootConstrainSelectedInstOperands,
     /*  226047 */     // GIR_Coverage, 8312,
     /*  226047 */     GIR_EraseRootFromParent_Done,
     /*  226048 */   // Label 4481: @226048
     /*  226048 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226122), // Rule ID 8313 //
     /*  226053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226093 */     // MIs[1] Operand 1
     /*  226093 */     // No operand predicates
     /*  226093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226120 */     GIR_RootConstrainSelectedInstOperands,
     /*  226121 */     // GIR_Coverage, 8313,
     /*  226121 */     GIR_EraseRootFromParent_Done,
     /*  226122 */   // Label 4482: @226122
     /*  226122 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226196), // Rule ID 8316 //
     /*  226127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226167 */     // MIs[1] Operand 1
     /*  226167 */     // No operand predicates
     /*  226167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226194 */     GIR_RootConstrainSelectedInstOperands,
     /*  226195 */     // GIR_Coverage, 8316,
     /*  226195 */     GIR_EraseRootFromParent_Done,
     /*  226196 */   // Label 4483: @226196
     /*  226196 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226270), // Rule ID 8317 //
     /*  226201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226241 */     // MIs[1] Operand 1
     /*  226241 */     // No operand predicates
     /*  226241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226268 */     GIR_RootConstrainSelectedInstOperands,
     /*  226269 */     // GIR_Coverage, 8317,
     /*  226269 */     GIR_EraseRootFromParent_Done,
     /*  226270 */   // Label 4484: @226270
     /*  226270 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226344), // Rule ID 8320 //
     /*  226275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226315 */     // MIs[1] Operand 1
     /*  226315 */     // No operand predicates
     /*  226315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226324 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  226327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226342 */     GIR_RootConstrainSelectedInstOperands,
     /*  226343 */     // GIR_Coverage, 8320,
     /*  226343 */     GIR_EraseRootFromParent_Done,
     /*  226344 */   // Label 4485: @226344
     /*  226344 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226418), // Rule ID 8321 //
     /*  226349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226389 */     // MIs[1] Operand 1
     /*  226389 */     // No operand predicates
     /*  226389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226398 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  226401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226416 */     GIR_RootConstrainSelectedInstOperands,
     /*  226417 */     // GIR_Coverage, 8321,
     /*  226417 */     GIR_EraseRootFromParent_Done,
     /*  226418 */   // Label 4486: @226418
     /*  226418 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226492), // Rule ID 8324 //
     /*  226423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226463 */     // MIs[1] Operand 1
     /*  226463 */     // No operand predicates
     /*  226463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226490 */     GIR_RootConstrainSelectedInstOperands,
     /*  226491 */     // GIR_Coverage, 8324,
     /*  226491 */     GIR_EraseRootFromParent_Done,
     /*  226492 */   // Label 4487: @226492
     /*  226492 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226566), // Rule ID 8325 //
     /*  226497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226537 */     // MIs[1] Operand 1
     /*  226537 */     // No operand predicates
     /*  226537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226564 */     GIR_RootConstrainSelectedInstOperands,
     /*  226565 */     // GIR_Coverage, 8325,
     /*  226565 */     GIR_EraseRootFromParent_Done,
     /*  226566 */   // Label 4488: @226566
     /*  226566 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226640), // Rule ID 8328 //
     /*  226571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226611 */     // MIs[1] Operand 1
     /*  226611 */     // No operand predicates
     /*  226611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226638 */     GIR_RootConstrainSelectedInstOperands,
     /*  226639 */     // GIR_Coverage, 8328,
     /*  226639 */     GIR_EraseRootFromParent_Done,
     /*  226640 */   // Label 4489: @226640
     /*  226640 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226714), // Rule ID 8329 //
     /*  226645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226685 */     // MIs[1] Operand 1
     /*  226685 */     // No operand predicates
     /*  226685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226712 */     GIR_RootConstrainSelectedInstOperands,
     /*  226713 */     // GIR_Coverage, 8329,
     /*  226713 */     GIR_EraseRootFromParent_Done,
     /*  226714 */   // Label 4490: @226714
     /*  226714 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226788), // Rule ID 8860 //
     /*  226719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226759 */     // MIs[1] Operand 1
     /*  226759 */     // No operand predicates
     /*  226759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226786 */     GIR_RootConstrainSelectedInstOperands,
     /*  226787 */     // GIR_Coverage, 8860,
     /*  226787 */     GIR_EraseRootFromParent_Done,
     /*  226788 */   // Label 4491: @226788
     /*  226788 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226862), // Rule ID 8861 //
     /*  226793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226833 */     // MIs[1] Operand 1
     /*  226833 */     // No operand predicates
     /*  226833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226842 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226860 */     GIR_RootConstrainSelectedInstOperands,
     /*  226861 */     // GIR_Coverage, 8861,
     /*  226861 */     GIR_EraseRootFromParent_Done,
     /*  226862 */   // Label 4492: @226862
     /*  226862 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226936), // Rule ID 8864 //
     /*  226867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226907 */     // MIs[1] Operand 1
     /*  226907 */     // No operand predicates
     /*  226907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226934 */     GIR_RootConstrainSelectedInstOperands,
     /*  226935 */     // GIR_Coverage, 8864,
     /*  226935 */     GIR_EraseRootFromParent_Done,
     /*  226936 */   // Label 4493: @226936
     /*  226936 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(227010), // Rule ID 8865 //
     /*  226941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226981 */     // MIs[1] Operand 1
     /*  226981 */     // No operand predicates
     /*  226981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227008 */     GIR_RootConstrainSelectedInstOperands,
     /*  227009 */     // GIR_Coverage, 8865,
     /*  227009 */     GIR_EraseRootFromParent_Done,
     /*  227010 */   // Label 4494: @227010
     /*  227010 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(227084), // Rule ID 8868 //
     /*  227015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227055 */     // MIs[1] Operand 1
     /*  227055 */     // No operand predicates
     /*  227055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227082 */     GIR_RootConstrainSelectedInstOperands,
     /*  227083 */     // GIR_Coverage, 8868,
     /*  227083 */     GIR_EraseRootFromParent_Done,
     /*  227084 */   // Label 4495: @227084
     /*  227084 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227158), // Rule ID 8869 //
     /*  227089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227129 */     // MIs[1] Operand 1
     /*  227129 */     // No operand predicates
     /*  227129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227138 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227156 */     GIR_RootConstrainSelectedInstOperands,
     /*  227157 */     // GIR_Coverage, 8869,
     /*  227157 */     GIR_EraseRootFromParent_Done,
     /*  227158 */   // Label 4496: @227158
     /*  227158 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227232), // Rule ID 8872 //
     /*  227163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227203 */     // MIs[1] Operand 1
     /*  227203 */     // No operand predicates
     /*  227203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227212 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  227215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227230 */     GIR_RootConstrainSelectedInstOperands,
     /*  227231 */     // GIR_Coverage, 8872,
     /*  227231 */     GIR_EraseRootFromParent_Done,
     /*  227232 */   // Label 4497: @227232
     /*  227232 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227306), // Rule ID 8873 //
     /*  227237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227277 */     // MIs[1] Operand 1
     /*  227277 */     // No operand predicates
     /*  227277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  227289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227304 */     GIR_RootConstrainSelectedInstOperands,
     /*  227305 */     // GIR_Coverage, 8873,
     /*  227305 */     GIR_EraseRootFromParent_Done,
     /*  227306 */   // Label 4498: @227306
     /*  227306 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227380), // Rule ID 8876 //
     /*  227311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227351 */     // MIs[1] Operand 1
     /*  227351 */     // No operand predicates
     /*  227351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227378 */     GIR_RootConstrainSelectedInstOperands,
     /*  227379 */     // GIR_Coverage, 8876,
     /*  227379 */     GIR_EraseRootFromParent_Done,
     /*  227380 */   // Label 4499: @227380
     /*  227380 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227454), // Rule ID 8877 //
     /*  227385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227425 */     // MIs[1] Operand 1
     /*  227425 */     // No operand predicates
     /*  227425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227452 */     GIR_RootConstrainSelectedInstOperands,
     /*  227453 */     // GIR_Coverage, 8877,
     /*  227453 */     GIR_EraseRootFromParent_Done,
     /*  227454 */   // Label 4500: @227454
     /*  227454 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227528), // Rule ID 8880 //
     /*  227459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227499 */     // MIs[1] Operand 1
     /*  227499 */     // No operand predicates
     /*  227499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227526 */     GIR_RootConstrainSelectedInstOperands,
     /*  227527 */     // GIR_Coverage, 8880,
     /*  227527 */     GIR_EraseRootFromParent_Done,
     /*  227528 */   // Label 4501: @227528
     /*  227528 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227602), // Rule ID 8881 //
     /*  227533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227573 */     // MIs[1] Operand 1
     /*  227573 */     // No operand predicates
     /*  227573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227600 */     GIR_RootConstrainSelectedInstOperands,
     /*  227601 */     // GIR_Coverage, 8881,
     /*  227601 */     GIR_EraseRootFromParent_Done,
     /*  227602 */   // Label 4502: @227602
     /*  227602 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227676), // Rule ID 8884 //
     /*  227607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227647 */     // MIs[1] Operand 1
     /*  227647 */     // No operand predicates
     /*  227647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227674 */     GIR_RootConstrainSelectedInstOperands,
     /*  227675 */     // GIR_Coverage, 8884,
     /*  227675 */     GIR_EraseRootFromParent_Done,
     /*  227676 */   // Label 4503: @227676
     /*  227676 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227750), // Rule ID 8885 //
     /*  227681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227721 */     // MIs[1] Operand 1
     /*  227721 */     // No operand predicates
     /*  227721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227748 */     GIR_RootConstrainSelectedInstOperands,
     /*  227749 */     // GIR_Coverage, 8885,
     /*  227749 */     GIR_EraseRootFromParent_Done,
     /*  227750 */   // Label 4504: @227750
     /*  227750 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227824), // Rule ID 8888 //
     /*  227755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227795 */     // MIs[1] Operand 1
     /*  227795 */     // No operand predicates
     /*  227795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227822 */     GIR_RootConstrainSelectedInstOperands,
     /*  227823 */     // GIR_Coverage, 8888,
     /*  227823 */     GIR_EraseRootFromParent_Done,
     /*  227824 */   // Label 4505: @227824
     /*  227824 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227898), // Rule ID 8889 //
     /*  227829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227869 */     // MIs[1] Operand 1
     /*  227869 */     // No operand predicates
     /*  227869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227896 */     GIR_RootConstrainSelectedInstOperands,
     /*  227897 */     // GIR_Coverage, 8889,
     /*  227897 */     GIR_EraseRootFromParent_Done,
     /*  227898 */   // Label 4506: @227898
     /*  227898 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227972), // Rule ID 8892 //
     /*  227903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227943 */     // MIs[1] Operand 1
     /*  227943 */     // No operand predicates
     /*  227943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227970 */     GIR_RootConstrainSelectedInstOperands,
     /*  227971 */     // GIR_Coverage, 8892,
     /*  227971 */     GIR_EraseRootFromParent_Done,
     /*  227972 */   // Label 4507: @227972
     /*  227972 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(228046), // Rule ID 8893 //
     /*  227977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228017 */     // MIs[1] Operand 1
     /*  228017 */     // No operand predicates
     /*  228017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228044 */     GIR_RootConstrainSelectedInstOperands,
     /*  228045 */     // GIR_Coverage, 8893,
     /*  228045 */     GIR_EraseRootFromParent_Done,
     /*  228046 */   // Label 4508: @228046
     /*  228046 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(228120), // Rule ID 8896 //
     /*  228051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228091 */     // MIs[1] Operand 1
     /*  228091 */     // No operand predicates
     /*  228091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228118 */     GIR_RootConstrainSelectedInstOperands,
     /*  228119 */     // GIR_Coverage, 8896,
     /*  228119 */     GIR_EraseRootFromParent_Done,
     /*  228120 */   // Label 4509: @228120
     /*  228120 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(228194), // Rule ID 8897 //
     /*  228125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228165 */     // MIs[1] Operand 1
     /*  228165 */     // No operand predicates
     /*  228165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  228177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228192 */     GIR_RootConstrainSelectedInstOperands,
     /*  228193 */     // GIR_Coverage, 8897,
     /*  228193 */     GIR_EraseRootFromParent_Done,
     /*  228194 */   // Label 4510: @228194
     /*  228194 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(228268), // Rule ID 8900 //
     /*  228199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228239 */     // MIs[1] Operand 1
     /*  228239 */     // No operand predicates
     /*  228239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228248 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228266 */     GIR_RootConstrainSelectedInstOperands,
     /*  228267 */     // GIR_Coverage, 8900,
     /*  228267 */     GIR_EraseRootFromParent_Done,
     /*  228268 */   // Label 4511: @228268
     /*  228268 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(228342), // Rule ID 8901 //
     /*  228273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228313 */     // MIs[1] Operand 1
     /*  228313 */     // No operand predicates
     /*  228313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228340 */     GIR_RootConstrainSelectedInstOperands,
     /*  228341 */     // GIR_Coverage, 8901,
     /*  228341 */     GIR_EraseRootFromParent_Done,
     /*  228342 */   // Label 4512: @228342
     /*  228342 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(228416), // Rule ID 8904 //
     /*  228347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228387 */     // MIs[1] Operand 1
     /*  228387 */     // No operand predicates
     /*  228387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228396 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228414 */     GIR_RootConstrainSelectedInstOperands,
     /*  228415 */     // GIR_Coverage, 8904,
     /*  228415 */     GIR_EraseRootFromParent_Done,
     /*  228416 */   // Label 4513: @228416
     /*  228416 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(228490), // Rule ID 8905 //
     /*  228421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228461 */     // MIs[1] Operand 1
     /*  228461 */     // No operand predicates
     /*  228461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228470 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228488 */     GIR_RootConstrainSelectedInstOperands,
     /*  228489 */     // GIR_Coverage, 8905,
     /*  228489 */     GIR_EraseRootFromParent_Done,
     /*  228490 */   // Label 4514: @228490
     /*  228490 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(228564), // Rule ID 8908 //
     /*  228495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228535 */     // MIs[1] Operand 1
     /*  228535 */     // No operand predicates
     /*  228535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228544 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228562 */     GIR_RootConstrainSelectedInstOperands,
     /*  228563 */     // GIR_Coverage, 8908,
     /*  228563 */     GIR_EraseRootFromParent_Done,
     /*  228564 */   // Label 4515: @228564
     /*  228564 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(228638), // Rule ID 8909 //
     /*  228569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228609 */     // MIs[1] Operand 1
     /*  228609 */     // No operand predicates
     /*  228609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228618 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228636 */     GIR_RootConstrainSelectedInstOperands,
     /*  228637 */     // GIR_Coverage, 8909,
     /*  228637 */     GIR_EraseRootFromParent_Done,
     /*  228638 */   // Label 4516: @228638
     /*  228638 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(228712), // Rule ID 8912 //
     /*  228643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228683 */     // MIs[1] Operand 1
     /*  228683 */     // No operand predicates
     /*  228683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228692 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228710 */     GIR_RootConstrainSelectedInstOperands,
     /*  228711 */     // GIR_Coverage, 8912,
     /*  228711 */     GIR_EraseRootFromParent_Done,
     /*  228712 */   // Label 4517: @228712
     /*  228712 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(228786), // Rule ID 8913 //
     /*  228717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228757 */     // MIs[1] Operand 1
     /*  228757 */     // No operand predicates
     /*  228757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228784 */     GIR_RootConstrainSelectedInstOperands,
     /*  228785 */     // GIR_Coverage, 8913,
     /*  228785 */     GIR_EraseRootFromParent_Done,
     /*  228786 */   // Label 4518: @228786
     /*  228786 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(228860), // Rule ID 8916 //
     /*  228791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228831 */     // MIs[1] Operand 1
     /*  228831 */     // No operand predicates
     /*  228831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228858 */     GIR_RootConstrainSelectedInstOperands,
     /*  228859 */     // GIR_Coverage, 8916,
     /*  228859 */     GIR_EraseRootFromParent_Done,
     /*  228860 */   // Label 4519: @228860
     /*  228860 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228934), // Rule ID 8917 //
     /*  228865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228905 */     // MIs[1] Operand 1
     /*  228905 */     // No operand predicates
     /*  228905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228914 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228932 */     GIR_RootConstrainSelectedInstOperands,
     /*  228933 */     // GIR_Coverage, 8917,
     /*  228933 */     GIR_EraseRootFromParent_Done,
     /*  228934 */   // Label 4520: @228934
     /*  228934 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(229008), // Rule ID 8920 //
     /*  228939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228979 */     // MIs[1] Operand 1
     /*  228979 */     // No operand predicates
     /*  228979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228988 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229006 */     GIR_RootConstrainSelectedInstOperands,
     /*  229007 */     // GIR_Coverage, 8920,
     /*  229007 */     GIR_EraseRootFromParent_Done,
     /*  229008 */   // Label 4521: @229008
     /*  229008 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(229082), // Rule ID 8921 //
     /*  229013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229053 */     // MIs[1] Operand 1
     /*  229053 */     // No operand predicates
     /*  229053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229062 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229080 */     GIR_RootConstrainSelectedInstOperands,
     /*  229081 */     // GIR_Coverage, 8921,
     /*  229081 */     GIR_EraseRootFromParent_Done,
     /*  229082 */   // Label 4522: @229082
     /*  229082 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(229156), // Rule ID 8924 //
     /*  229087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229127 */     // MIs[1] Operand 1
     /*  229127 */     // No operand predicates
     /*  229127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229154 */     GIR_RootConstrainSelectedInstOperands,
     /*  229155 */     // GIR_Coverage, 8924,
     /*  229155 */     GIR_EraseRootFromParent_Done,
     /*  229156 */   // Label 4523: @229156
     /*  229156 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(229230), // Rule ID 8925 //
     /*  229161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229201 */     // MIs[1] Operand 1
     /*  229201 */     // No operand predicates
     /*  229201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229228 */     GIR_RootConstrainSelectedInstOperands,
     /*  229229 */     // GIR_Coverage, 8925,
     /*  229229 */     GIR_EraseRootFromParent_Done,
     /*  229230 */   // Label 4524: @229230
     /*  229230 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(229304), // Rule ID 8928 //
     /*  229235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229275 */     // MIs[1] Operand 1
     /*  229275 */     // No operand predicates
     /*  229275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229302 */     GIR_RootConstrainSelectedInstOperands,
     /*  229303 */     // GIR_Coverage, 8928,
     /*  229303 */     GIR_EraseRootFromParent_Done,
     /*  229304 */   // Label 4525: @229304
     /*  229304 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(229378), // Rule ID 8929 //
     /*  229309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229349 */     // MIs[1] Operand 1
     /*  229349 */     // No operand predicates
     /*  229349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229376 */     GIR_RootConstrainSelectedInstOperands,
     /*  229377 */     // GIR_Coverage, 8929,
     /*  229377 */     GIR_EraseRootFromParent_Done,
     /*  229378 */   // Label 4526: @229378
     /*  229378 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(229452), // Rule ID 8932 //
     /*  229383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229423 */     // MIs[1] Operand 1
     /*  229423 */     // No operand predicates
     /*  229423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229450 */     GIR_RootConstrainSelectedInstOperands,
     /*  229451 */     // GIR_Coverage, 8932,
     /*  229451 */     GIR_EraseRootFromParent_Done,
     /*  229452 */   // Label 4527: @229452
     /*  229452 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(229526), // Rule ID 8933 //
     /*  229457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229497 */     // MIs[1] Operand 1
     /*  229497 */     // No operand predicates
     /*  229497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229506 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229524 */     GIR_RootConstrainSelectedInstOperands,
     /*  229525 */     // GIR_Coverage, 8933,
     /*  229525 */     GIR_EraseRootFromParent_Done,
     /*  229526 */   // Label 4528: @229526
     /*  229526 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(229600), // Rule ID 8936 //
     /*  229531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229571 */     // MIs[1] Operand 1
     /*  229571 */     // No operand predicates
     /*  229571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229598 */     GIR_RootConstrainSelectedInstOperands,
     /*  229599 */     // GIR_Coverage, 8936,
     /*  229599 */     GIR_EraseRootFromParent_Done,
     /*  229600 */   // Label 4529: @229600
     /*  229600 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(229674), // Rule ID 8937 //
     /*  229605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229645 */     // MIs[1] Operand 1
     /*  229645 */     // No operand predicates
     /*  229645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229672 */     GIR_RootConstrainSelectedInstOperands,
     /*  229673 */     // GIR_Coverage, 8937,
     /*  229673 */     GIR_EraseRootFromParent_Done,
     /*  229674 */   // Label 4530: @229674
     /*  229674 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(229748), // Rule ID 8940 //
     /*  229679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229719 */     // MIs[1] Operand 1
     /*  229719 */     // No operand predicates
     /*  229719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229746 */     GIR_RootConstrainSelectedInstOperands,
     /*  229747 */     // GIR_Coverage, 8940,
     /*  229747 */     GIR_EraseRootFromParent_Done,
     /*  229748 */   // Label 4531: @229748
     /*  229748 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(229822), // Rule ID 8941 //
     /*  229753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229793 */     // MIs[1] Operand 1
     /*  229793 */     // No operand predicates
     /*  229793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229820 */     GIR_RootConstrainSelectedInstOperands,
     /*  229821 */     // GIR_Coverage, 8941,
     /*  229821 */     GIR_EraseRootFromParent_Done,
     /*  229822 */   // Label 4532: @229822
     /*  229822 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(229896), // Rule ID 8944 //
     /*  229827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229867 */     // MIs[1] Operand 1
     /*  229867 */     // No operand predicates
     /*  229867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229894 */     GIR_RootConstrainSelectedInstOperands,
     /*  229895 */     // GIR_Coverage, 8944,
     /*  229895 */     GIR_EraseRootFromParent_Done,
     /*  229896 */   // Label 4533: @229896
     /*  229896 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(229970), // Rule ID 8945 //
     /*  229901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229941 */     // MIs[1] Operand 1
     /*  229941 */     // No operand predicates
     /*  229941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229968 */     GIR_RootConstrainSelectedInstOperands,
     /*  229969 */     // GIR_Coverage, 8945,
     /*  229969 */     GIR_EraseRootFromParent_Done,
     /*  229970 */   // Label 4534: @229970
     /*  229970 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(230044), // Rule ID 9124 //
     /*  229975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230015 */     // MIs[1] Operand 1
     /*  230015 */     // No operand predicates
     /*  230015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  230027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230042 */     GIR_RootConstrainSelectedInstOperands,
     /*  230043 */     // GIR_Coverage, 9124,
     /*  230043 */     GIR_EraseRootFromParent_Done,
     /*  230044 */   // Label 4535: @230044
     /*  230044 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(230118), // Rule ID 9125 //
     /*  230049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230089 */     // MIs[1] Operand 1
     /*  230089 */     // No operand predicates
     /*  230089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  230101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230116 */     GIR_RootConstrainSelectedInstOperands,
     /*  230117 */     // GIR_Coverage, 9125,
     /*  230117 */     GIR_EraseRootFromParent_Done,
     /*  230118 */   // Label 4536: @230118
     /*  230118 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(230192), // Rule ID 9128 //
     /*  230123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230163 */     // MIs[1] Operand 1
     /*  230163 */     // No operand predicates
     /*  230163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230190 */     GIR_RootConstrainSelectedInstOperands,
     /*  230191 */     // GIR_Coverage, 9128,
     /*  230191 */     GIR_EraseRootFromParent_Done,
     /*  230192 */   // Label 4537: @230192
     /*  230192 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(230266), // Rule ID 9129 //
     /*  230197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230237 */     // MIs[1] Operand 1
     /*  230237 */     // No operand predicates
     /*  230237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230264 */     GIR_RootConstrainSelectedInstOperands,
     /*  230265 */     // GIR_Coverage, 9129,
     /*  230265 */     GIR_EraseRootFromParent_Done,
     /*  230266 */   // Label 4538: @230266
     /*  230266 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(230340), // Rule ID 9132 //
     /*  230271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230311 */     // MIs[1] Operand 1
     /*  230311 */     // No operand predicates
     /*  230311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230338 */     GIR_RootConstrainSelectedInstOperands,
     /*  230339 */     // GIR_Coverage, 9132,
     /*  230339 */     GIR_EraseRootFromParent_Done,
     /*  230340 */   // Label 4539: @230340
     /*  230340 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(230414), // Rule ID 9133 //
     /*  230345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230385 */     // MIs[1] Operand 1
     /*  230385 */     // No operand predicates
     /*  230385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230412 */     GIR_RootConstrainSelectedInstOperands,
     /*  230413 */     // GIR_Coverage, 9133,
     /*  230413 */     GIR_EraseRootFromParent_Done,
     /*  230414 */   // Label 4540: @230414
     /*  230414 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(230488), // Rule ID 9136 //
     /*  230419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230459 */     // MIs[1] Operand 1
     /*  230459 */     // No operand predicates
     /*  230459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230486 */     GIR_RootConstrainSelectedInstOperands,
     /*  230487 */     // GIR_Coverage, 9136,
     /*  230487 */     GIR_EraseRootFromParent_Done,
     /*  230488 */   // Label 4541: @230488
     /*  230488 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(230562), // Rule ID 9137 //
     /*  230493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230533 */     // MIs[1] Operand 1
     /*  230533 */     // No operand predicates
     /*  230533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230560 */     GIR_RootConstrainSelectedInstOperands,
     /*  230561 */     // GIR_Coverage, 9137,
     /*  230561 */     GIR_EraseRootFromParent_Done,
     /*  230562 */   // Label 4542: @230562
     /*  230562 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(230636), // Rule ID 9140 //
     /*  230567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230607 */     // MIs[1] Operand 1
     /*  230607 */     // No operand predicates
     /*  230607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230634 */     GIR_RootConstrainSelectedInstOperands,
     /*  230635 */     // GIR_Coverage, 9140,
     /*  230635 */     GIR_EraseRootFromParent_Done,
     /*  230636 */   // Label 4543: @230636
     /*  230636 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(230710), // Rule ID 9141 //
     /*  230641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230681 */     // MIs[1] Operand 1
     /*  230681 */     // No operand predicates
     /*  230681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230708 */     GIR_RootConstrainSelectedInstOperands,
     /*  230709 */     // GIR_Coverage, 9141,
     /*  230709 */     GIR_EraseRootFromParent_Done,
     /*  230710 */   // Label 4544: @230710
     /*  230710 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(230784), // Rule ID 9144 //
     /*  230715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230755 */     // MIs[1] Operand 1
     /*  230755 */     // No operand predicates
     /*  230755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230764 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230782 */     GIR_RootConstrainSelectedInstOperands,
     /*  230783 */     // GIR_Coverage, 9144,
     /*  230783 */     GIR_EraseRootFromParent_Done,
     /*  230784 */   // Label 4545: @230784
     /*  230784 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(230858), // Rule ID 9145 //
     /*  230789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230829 */     // MIs[1] Operand 1
     /*  230829 */     // No operand predicates
     /*  230829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230838 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230856 */     GIR_RootConstrainSelectedInstOperands,
     /*  230857 */     // GIR_Coverage, 9145,
     /*  230857 */     GIR_EraseRootFromParent_Done,
     /*  230858 */   // Label 4546: @230858
     /*  230858 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(230932), // Rule ID 9148 //
     /*  230863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230903 */     // MIs[1] Operand 1
     /*  230903 */     // No operand predicates
     /*  230903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230930 */     GIR_RootConstrainSelectedInstOperands,
     /*  230931 */     // GIR_Coverage, 9148,
     /*  230931 */     GIR_EraseRootFromParent_Done,
     /*  230932 */   // Label 4547: @230932
     /*  230932 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(231006), // Rule ID 9149 //
     /*  230937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230977 */     // MIs[1] Operand 1
     /*  230977 */     // No operand predicates
     /*  230977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230986 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231004 */     GIR_RootConstrainSelectedInstOperands,
     /*  231005 */     // GIR_Coverage, 9149,
     /*  231005 */     GIR_EraseRootFromParent_Done,
     /*  231006 */   // Label 4548: @231006
     /*  231006 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(231080), // Rule ID 9152 //
     /*  231011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231051 */     // MIs[1] Operand 1
     /*  231051 */     // No operand predicates
     /*  231051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231078 */     GIR_RootConstrainSelectedInstOperands,
     /*  231079 */     // GIR_Coverage, 9152,
     /*  231079 */     GIR_EraseRootFromParent_Done,
     /*  231080 */   // Label 4549: @231080
     /*  231080 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(231154), // Rule ID 9153 //
     /*  231085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231125 */     // MIs[1] Operand 1
     /*  231125 */     // No operand predicates
     /*  231125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231152 */     GIR_RootConstrainSelectedInstOperands,
     /*  231153 */     // GIR_Coverage, 9153,
     /*  231153 */     GIR_EraseRootFromParent_Done,
     /*  231154 */   // Label 4550: @231154
     /*  231154 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(231228), // Rule ID 9156 //
     /*  231159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231199 */     // MIs[1] Operand 1
     /*  231199 */     // No operand predicates
     /*  231199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231226 */     GIR_RootConstrainSelectedInstOperands,
     /*  231227 */     // GIR_Coverage, 9156,
     /*  231227 */     GIR_EraseRootFromParent_Done,
     /*  231228 */   // Label 4551: @231228
     /*  231228 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(231302), // Rule ID 9157 //
     /*  231233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231273 */     // MIs[1] Operand 1
     /*  231273 */     // No operand predicates
     /*  231273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231300 */     GIR_RootConstrainSelectedInstOperands,
     /*  231301 */     // GIR_Coverage, 9157,
     /*  231301 */     GIR_EraseRootFromParent_Done,
     /*  231302 */   // Label 4552: @231302
     /*  231302 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(231376), // Rule ID 9160 //
     /*  231307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231347 */     // MIs[1] Operand 1
     /*  231347 */     // No operand predicates
     /*  231347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231374 */     GIR_RootConstrainSelectedInstOperands,
     /*  231375 */     // GIR_Coverage, 9160,
     /*  231375 */     GIR_EraseRootFromParent_Done,
     /*  231376 */   // Label 4553: @231376
     /*  231376 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(231450), // Rule ID 9161 //
     /*  231381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  231384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231421 */     // MIs[1] Operand 1
     /*  231421 */     // No operand predicates
     /*  231421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  231433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231448 */     GIR_RootConstrainSelectedInstOperands,
     /*  231449 */     // GIR_Coverage, 9161,
     /*  231449 */     GIR_EraseRootFromParent_Done,
     /*  231450 */   // Label 4554: @231450
     /*  231450 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(231524), // Rule ID 9164 //
     /*  231455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231495 */     // MIs[1] Operand 1
     /*  231495 */     // No operand predicates
     /*  231495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231522 */     GIR_RootConstrainSelectedInstOperands,
     /*  231523 */     // GIR_Coverage, 9164,
     /*  231523 */     GIR_EraseRootFromParent_Done,
     /*  231524 */   // Label 4555: @231524
     /*  231524 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(231598), // Rule ID 9165 //
     /*  231529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231569 */     // MIs[1] Operand 1
     /*  231569 */     // No operand predicates
     /*  231569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231596 */     GIR_RootConstrainSelectedInstOperands,
     /*  231597 */     // GIR_Coverage, 9165,
     /*  231597 */     GIR_EraseRootFromParent_Done,
     /*  231598 */   // Label 4556: @231598
     /*  231598 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(231672), // Rule ID 9168 //
     /*  231603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231643 */     // MIs[1] Operand 1
     /*  231643 */     // No operand predicates
     /*  231643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231652 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231670 */     GIR_RootConstrainSelectedInstOperands,
     /*  231671 */     // GIR_Coverage, 9168,
     /*  231671 */     GIR_EraseRootFromParent_Done,
     /*  231672 */   // Label 4557: @231672
     /*  231672 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(231746), // Rule ID 9169 //
     /*  231677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231717 */     // MIs[1] Operand 1
     /*  231717 */     // No operand predicates
     /*  231717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231726 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231744 */     GIR_RootConstrainSelectedInstOperands,
     /*  231745 */     // GIR_Coverage, 9169,
     /*  231745 */     GIR_EraseRootFromParent_Done,
     /*  231746 */   // Label 4558: @231746
     /*  231746 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(231820), // Rule ID 9172 //
     /*  231751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231791 */     // MIs[1] Operand 1
     /*  231791 */     // No operand predicates
     /*  231791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231800 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231818 */     GIR_RootConstrainSelectedInstOperands,
     /*  231819 */     // GIR_Coverage, 9172,
     /*  231819 */     GIR_EraseRootFromParent_Done,
     /*  231820 */   // Label 4559: @231820
     /*  231820 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(231894), // Rule ID 9173 //
     /*  231825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231865 */     // MIs[1] Operand 1
     /*  231865 */     // No operand predicates
     /*  231865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231874 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231892 */     GIR_RootConstrainSelectedInstOperands,
     /*  231893 */     // GIR_Coverage, 9173,
     /*  231893 */     GIR_EraseRootFromParent_Done,
     /*  231894 */   // Label 4560: @231894
     /*  231894 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(231968), // Rule ID 9176 //
     /*  231899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231939 */     // MIs[1] Operand 1
     /*  231939 */     // No operand predicates
     /*  231939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231966 */     GIR_RootConstrainSelectedInstOperands,
     /*  231967 */     // GIR_Coverage, 9176,
     /*  231967 */     GIR_EraseRootFromParent_Done,
     /*  231968 */   // Label 4561: @231968
     /*  231968 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(232042), // Rule ID 9177 //
     /*  231973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232013 */     // MIs[1] Operand 1
     /*  232013 */     // No operand predicates
     /*  232013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232040 */     GIR_RootConstrainSelectedInstOperands,
     /*  232041 */     // GIR_Coverage, 9177,
     /*  232041 */     GIR_EraseRootFromParent_Done,
     /*  232042 */   // Label 4562: @232042
     /*  232042 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(232116), // Rule ID 9180 //
     /*  232047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232087 */     // MIs[1] Operand 1
     /*  232087 */     // No operand predicates
     /*  232087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232114 */     GIR_RootConstrainSelectedInstOperands,
     /*  232115 */     // GIR_Coverage, 9180,
     /*  232115 */     GIR_EraseRootFromParent_Done,
     /*  232116 */   // Label 4563: @232116
     /*  232116 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(232190), // Rule ID 9181 //
     /*  232121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232161 */     // MIs[1] Operand 1
     /*  232161 */     // No operand predicates
     /*  232161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232188 */     GIR_RootConstrainSelectedInstOperands,
     /*  232189 */     // GIR_Coverage, 9181,
     /*  232189 */     GIR_EraseRootFromParent_Done,
     /*  232190 */   // Label 4564: @232190
     /*  232190 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(232264), // Rule ID 9184 //
     /*  232195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232235 */     // MIs[1] Operand 1
     /*  232235 */     // No operand predicates
     /*  232235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232244 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232262 */     GIR_RootConstrainSelectedInstOperands,
     /*  232263 */     // GIR_Coverage, 9184,
     /*  232263 */     GIR_EraseRootFromParent_Done,
     /*  232264 */   // Label 4565: @232264
     /*  232264 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(232338), // Rule ID 9185 //
     /*  232269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232309 */     // MIs[1] Operand 1
     /*  232309 */     // No operand predicates
     /*  232309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232318 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232336 */     GIR_RootConstrainSelectedInstOperands,
     /*  232337 */     // GIR_Coverage, 9185,
     /*  232337 */     GIR_EraseRootFromParent_Done,
     /*  232338 */   // Label 4566: @232338
     /*  232338 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(232412), // Rule ID 9188 //
     /*  232343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232383 */     // MIs[1] Operand 1
     /*  232383 */     // No operand predicates
     /*  232383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232410 */     GIR_RootConstrainSelectedInstOperands,
     /*  232411 */     // GIR_Coverage, 9188,
     /*  232411 */     GIR_EraseRootFromParent_Done,
     /*  232412 */   // Label 4567: @232412
     /*  232412 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(232486), // Rule ID 9189 //
     /*  232417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232457 */     // MIs[1] Operand 1
     /*  232457 */     // No operand predicates
     /*  232457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232466 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232484 */     GIR_RootConstrainSelectedInstOperands,
     /*  232485 */     // GIR_Coverage, 9189,
     /*  232485 */     GIR_EraseRootFromParent_Done,
     /*  232486 */   // Label 4568: @232486
     /*  232486 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(232560), // Rule ID 9192 //
     /*  232491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232531 */     // MIs[1] Operand 1
     /*  232531 */     // No operand predicates
     /*  232531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232558 */     GIR_RootConstrainSelectedInstOperands,
     /*  232559 */     // GIR_Coverage, 9192,
     /*  232559 */     GIR_EraseRootFromParent_Done,
     /*  232560 */   // Label 4569: @232560
     /*  232560 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(232634), // Rule ID 9193 //
     /*  232565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232605 */     // MIs[1] Operand 1
     /*  232605 */     // No operand predicates
     /*  232605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232632 */     GIR_RootConstrainSelectedInstOperands,
     /*  232633 */     // GIR_Coverage, 9193,
     /*  232633 */     GIR_EraseRootFromParent_Done,
     /*  232634 */   // Label 4570: @232634
     /*  232634 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(232708), // Rule ID 9196 //
     /*  232639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232679 */     // MIs[1] Operand 1
     /*  232679 */     // No operand predicates
     /*  232679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232706 */     GIR_RootConstrainSelectedInstOperands,
     /*  232707 */     // GIR_Coverage, 9196,
     /*  232707 */     GIR_EraseRootFromParent_Done,
     /*  232708 */   // Label 4571: @232708
     /*  232708 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(232782), // Rule ID 9197 //
     /*  232713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232753 */     // MIs[1] Operand 1
     /*  232753 */     // No operand predicates
     /*  232753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232780 */     GIR_RootConstrainSelectedInstOperands,
     /*  232781 */     // GIR_Coverage, 9197,
     /*  232781 */     GIR_EraseRootFromParent_Done,
     /*  232782 */   // Label 4572: @232782
     /*  232782 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(232856), // Rule ID 9200 //
     /*  232787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232827 */     // MIs[1] Operand 1
     /*  232827 */     // No operand predicates
     /*  232827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232836 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232854 */     GIR_RootConstrainSelectedInstOperands,
     /*  232855 */     // GIR_Coverage, 9200,
     /*  232855 */     GIR_EraseRootFromParent_Done,
     /*  232856 */   // Label 4573: @232856
     /*  232856 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(232930), // Rule ID 9201 //
     /*  232861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232901 */     // MIs[1] Operand 1
     /*  232901 */     // No operand predicates
     /*  232901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232928 */     GIR_RootConstrainSelectedInstOperands,
     /*  232929 */     // GIR_Coverage, 9201,
     /*  232929 */     GIR_EraseRootFromParent_Done,
     /*  232930 */   // Label 4574: @232930
     /*  232930 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(233004), // Rule ID 9204 //
     /*  232935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232975 */     // MIs[1] Operand 1
     /*  232975 */     // No operand predicates
     /*  232975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233002 */     GIR_RootConstrainSelectedInstOperands,
     /*  233003 */     // GIR_Coverage, 9204,
     /*  233003 */     GIR_EraseRootFromParent_Done,
     /*  233004 */   // Label 4575: @233004
     /*  233004 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(233078), // Rule ID 9205 //
     /*  233009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233049 */     // MIs[1] Operand 1
     /*  233049 */     // No operand predicates
     /*  233049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  233061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233076 */     GIR_RootConstrainSelectedInstOperands,
     /*  233077 */     // GIR_Coverage, 9205,
     /*  233077 */     GIR_EraseRootFromParent_Done,
     /*  233078 */   // Label 4576: @233078
     /*  233078 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(233152), // Rule ID 9208 //
     /*  233083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233123 */     // MIs[1] Operand 1
     /*  233123 */     // No operand predicates
     /*  233123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  233135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233150 */     GIR_RootConstrainSelectedInstOperands,
     /*  233151 */     // GIR_Coverage, 9208,
     /*  233151 */     GIR_EraseRootFromParent_Done,
     /*  233152 */   // Label 4577: @233152
     /*  233152 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(233226), // Rule ID 9209 //
     /*  233157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233197 */     // MIs[1] Operand 1
     /*  233197 */     // No operand predicates
     /*  233197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  233209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233224 */     GIR_RootConstrainSelectedInstOperands,
     /*  233225 */     // GIR_Coverage, 9209,
     /*  233225 */     GIR_EraseRootFromParent_Done,
     /*  233226 */   // Label 4578: @233226
     /*  233226 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(233300), // Rule ID 9300 //
     /*  233231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233271 */     // MIs[1] Operand 1
     /*  233271 */     // No operand predicates
     /*  233271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  233283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233298 */     GIR_RootConstrainSelectedInstOperands,
     /*  233299 */     // GIR_Coverage, 9300,
     /*  233299 */     GIR_EraseRootFromParent_Done,
     /*  233300 */   // Label 4579: @233300
     /*  233300 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(233374), // Rule ID 9301 //
     /*  233305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233345 */     // MIs[1] Operand 1
     /*  233345 */     // No operand predicates
     /*  233345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233354 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  233357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233372 */     GIR_RootConstrainSelectedInstOperands,
     /*  233373 */     // GIR_Coverage, 9301,
     /*  233373 */     GIR_EraseRootFromParent_Done,
     /*  233374 */   // Label 4580: @233374
     /*  233374 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(233448), // Rule ID 9304 //
     /*  233379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233419 */     // MIs[1] Operand 1
     /*  233419 */     // No operand predicates
     /*  233419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233446 */     GIR_RootConstrainSelectedInstOperands,
     /*  233447 */     // GIR_Coverage, 9304,
     /*  233447 */     GIR_EraseRootFromParent_Done,
     /*  233448 */   // Label 4581: @233448
     /*  233448 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(233522), // Rule ID 9305 //
     /*  233453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233493 */     // MIs[1] Operand 1
     /*  233493 */     // No operand predicates
     /*  233493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233520 */     GIR_RootConstrainSelectedInstOperands,
     /*  233521 */     // GIR_Coverage, 9305,
     /*  233521 */     GIR_EraseRootFromParent_Done,
     /*  233522 */   // Label 4582: @233522
     /*  233522 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(233596), // Rule ID 9308 //
     /*  233527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233567 */     // MIs[1] Operand 1
     /*  233567 */     // No operand predicates
     /*  233567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233594 */     GIR_RootConstrainSelectedInstOperands,
     /*  233595 */     // GIR_Coverage, 9308,
     /*  233595 */     GIR_EraseRootFromParent_Done,
     /*  233596 */   // Label 4583: @233596
     /*  233596 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(233670), // Rule ID 9309 //
     /*  233601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233641 */     // MIs[1] Operand 1
     /*  233641 */     // No operand predicates
     /*  233641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233668 */     GIR_RootConstrainSelectedInstOperands,
     /*  233669 */     // GIR_Coverage, 9309,
     /*  233669 */     GIR_EraseRootFromParent_Done,
     /*  233670 */   // Label 4584: @233670
     /*  233670 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(233744), // Rule ID 9312 //
     /*  233675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233715 */     // MIs[1] Operand 1
     /*  233715 */     // No operand predicates
     /*  233715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233742 */     GIR_RootConstrainSelectedInstOperands,
     /*  233743 */     // GIR_Coverage, 9312,
     /*  233743 */     GIR_EraseRootFromParent_Done,
     /*  233744 */   // Label 4585: @233744
     /*  233744 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(233818), // Rule ID 9313 //
     /*  233749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233789 */     // MIs[1] Operand 1
     /*  233789 */     // No operand predicates
     /*  233789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233816 */     GIR_RootConstrainSelectedInstOperands,
     /*  233817 */     // GIR_Coverage, 9313,
     /*  233817 */     GIR_EraseRootFromParent_Done,
     /*  233818 */   // Label 4586: @233818
     /*  233818 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(233892), // Rule ID 9316 //
     /*  233823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233863 */     // MIs[1] Operand 1
     /*  233863 */     // No operand predicates
     /*  233863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233890 */     GIR_RootConstrainSelectedInstOperands,
     /*  233891 */     // GIR_Coverage, 9316,
     /*  233891 */     GIR_EraseRootFromParent_Done,
     /*  233892 */   // Label 4587: @233892
     /*  233892 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(233966), // Rule ID 9317 //
     /*  233897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233937 */     // MIs[1] Operand 1
     /*  233937 */     // No operand predicates
     /*  233937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233946 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233964 */     GIR_RootConstrainSelectedInstOperands,
     /*  233965 */     // GIR_Coverage, 9317,
     /*  233965 */     GIR_EraseRootFromParent_Done,
     /*  233966 */   // Label 4588: @233966
     /*  233966 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(234040), // Rule ID 9320 //
     /*  233971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234011 */     // MIs[1] Operand 1
     /*  234011 */     // No operand predicates
     /*  234011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  234023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234038 */     GIR_RootConstrainSelectedInstOperands,
     /*  234039 */     // GIR_Coverage, 9320,
     /*  234039 */     GIR_EraseRootFromParent_Done,
     /*  234040 */   // Label 4589: @234040
     /*  234040 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(234114), // Rule ID 9321 //
     /*  234045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234085 */     // MIs[1] Operand 1
     /*  234085 */     // No operand predicates
     /*  234085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  234097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234112 */     GIR_RootConstrainSelectedInstOperands,
     /*  234113 */     // GIR_Coverage, 9321,
     /*  234113 */     GIR_EraseRootFromParent_Done,
     /*  234114 */   // Label 4590: @234114
     /*  234114 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(234188), // Rule ID 9324 //
     /*  234119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234159 */     // MIs[1] Operand 1
     /*  234159 */     // No operand predicates
     /*  234159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234186 */     GIR_RootConstrainSelectedInstOperands,
     /*  234187 */     // GIR_Coverage, 9324,
     /*  234187 */     GIR_EraseRootFromParent_Done,
     /*  234188 */   // Label 4591: @234188
     /*  234188 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(234262), // Rule ID 9325 //
     /*  234193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234233 */     // MIs[1] Operand 1
     /*  234233 */     // No operand predicates
     /*  234233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234260 */     GIR_RootConstrainSelectedInstOperands,
     /*  234261 */     // GIR_Coverage, 9325,
     /*  234261 */     GIR_EraseRootFromParent_Done,
     /*  234262 */   // Label 4592: @234262
     /*  234262 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(234336), // Rule ID 9328 //
     /*  234267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234307 */     // MIs[1] Operand 1
     /*  234307 */     // No operand predicates
     /*  234307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234334 */     GIR_RootConstrainSelectedInstOperands,
     /*  234335 */     // GIR_Coverage, 9328,
     /*  234335 */     GIR_EraseRootFromParent_Done,
     /*  234336 */   // Label 4593: @234336
     /*  234336 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(234410), // Rule ID 9329 //
     /*  234341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234381 */     // MIs[1] Operand 1
     /*  234381 */     // No operand predicates
     /*  234381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234408 */     GIR_RootConstrainSelectedInstOperands,
     /*  234409 */     // GIR_Coverage, 9329,
     /*  234409 */     GIR_EraseRootFromParent_Done,
     /*  234410 */   // Label 4594: @234410
     /*  234410 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(234484), // Rule ID 9332 //
     /*  234415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234455 */     // MIs[1] Operand 1
     /*  234455 */     // No operand predicates
     /*  234455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234482 */     GIR_RootConstrainSelectedInstOperands,
     /*  234483 */     // GIR_Coverage, 9332,
     /*  234483 */     GIR_EraseRootFromParent_Done,
     /*  234484 */   // Label 4595: @234484
     /*  234484 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(234558), // Rule ID 9333 //
     /*  234489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234529 */     // MIs[1] Operand 1
     /*  234529 */     // No operand predicates
     /*  234529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234556 */     GIR_RootConstrainSelectedInstOperands,
     /*  234557 */     // GIR_Coverage, 9333,
     /*  234557 */     GIR_EraseRootFromParent_Done,
     /*  234558 */   // Label 4596: @234558
     /*  234558 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(234632), // Rule ID 9336 //
     /*  234563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234603 */     // MIs[1] Operand 1
     /*  234603 */     // No operand predicates
     /*  234603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234630 */     GIR_RootConstrainSelectedInstOperands,
     /*  234631 */     // GIR_Coverage, 9336,
     /*  234631 */     GIR_EraseRootFromParent_Done,
     /*  234632 */   // Label 4597: @234632
     /*  234632 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(234706), // Rule ID 9337 //
     /*  234637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234677 */     // MIs[1] Operand 1
     /*  234677 */     // No operand predicates
     /*  234677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234704 */     GIR_RootConstrainSelectedInstOperands,
     /*  234705 */     // GIR_Coverage, 9337,
     /*  234705 */     GIR_EraseRootFromParent_Done,
     /*  234706 */   // Label 4598: @234706
     /*  234706 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(234780), // Rule ID 9340 //
     /*  234711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234751 */     // MIs[1] Operand 1
     /*  234751 */     // No operand predicates
     /*  234751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234760 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234778 */     GIR_RootConstrainSelectedInstOperands,
     /*  234779 */     // GIR_Coverage, 9340,
     /*  234779 */     GIR_EraseRootFromParent_Done,
     /*  234780 */   // Label 4599: @234780
     /*  234780 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(234854), // Rule ID 9341 //
     /*  234785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234825 */     // MIs[1] Operand 1
     /*  234825 */     // No operand predicates
     /*  234825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234852 */     GIR_RootConstrainSelectedInstOperands,
     /*  234853 */     // GIR_Coverage, 9341,
     /*  234853 */     GIR_EraseRootFromParent_Done,
     /*  234854 */   // Label 4600: @234854
     /*  234854 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(234928), // Rule ID 9344 //
     /*  234859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234899 */     // MIs[1] Operand 1
     /*  234899 */     // No operand predicates
     /*  234899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234908 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234926 */     GIR_RootConstrainSelectedInstOperands,
     /*  234927 */     // GIR_Coverage, 9344,
     /*  234927 */     GIR_EraseRootFromParent_Done,
     /*  234928 */   // Label 4601: @234928
     /*  234928 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(235002), // Rule ID 9345 //
     /*  234933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234973 */     // MIs[1] Operand 1
     /*  234973 */     // No operand predicates
     /*  234973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235000 */     GIR_RootConstrainSelectedInstOperands,
     /*  235001 */     // GIR_Coverage, 9345,
     /*  235001 */     GIR_EraseRootFromParent_Done,
     /*  235002 */   // Label 4602: @235002
     /*  235002 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(235076), // Rule ID 9348 //
     /*  235007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235047 */     // MIs[1] Operand 1
     /*  235047 */     // No operand predicates
     /*  235047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235056 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235074 */     GIR_RootConstrainSelectedInstOperands,
     /*  235075 */     // GIR_Coverage, 9348,
     /*  235075 */     GIR_EraseRootFromParent_Done,
     /*  235076 */   // Label 4603: @235076
     /*  235076 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(235150), // Rule ID 9349 //
     /*  235081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235121 */     // MIs[1] Operand 1
     /*  235121 */     // No operand predicates
     /*  235121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235130 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235148 */     GIR_RootConstrainSelectedInstOperands,
     /*  235149 */     // GIR_Coverage, 9349,
     /*  235149 */     GIR_EraseRootFromParent_Done,
     /*  235150 */   // Label 4604: @235150
     /*  235150 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(235224), // Rule ID 9352 //
     /*  235155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235195 */     // MIs[1] Operand 1
     /*  235195 */     // No operand predicates
     /*  235195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235222 */     GIR_RootConstrainSelectedInstOperands,
     /*  235223 */     // GIR_Coverage, 9352,
     /*  235223 */     GIR_EraseRootFromParent_Done,
     /*  235224 */   // Label 4605: @235224
     /*  235224 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(235298), // Rule ID 9353 //
     /*  235229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235269 */     // MIs[1] Operand 1
     /*  235269 */     // No operand predicates
     /*  235269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235296 */     GIR_RootConstrainSelectedInstOperands,
     /*  235297 */     // GIR_Coverage, 9353,
     /*  235297 */     GIR_EraseRootFromParent_Done,
     /*  235298 */   // Label 4606: @235298
     /*  235298 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(235372), // Rule ID 9356 //
     /*  235303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235343 */     // MIs[1] Operand 1
     /*  235343 */     // No operand predicates
     /*  235343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235370 */     GIR_RootConstrainSelectedInstOperands,
     /*  235371 */     // GIR_Coverage, 9356,
     /*  235371 */     GIR_EraseRootFromParent_Done,
     /*  235372 */   // Label 4607: @235372
     /*  235372 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(235446), // Rule ID 9357 //
     /*  235377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235417 */     // MIs[1] Operand 1
     /*  235417 */     // No operand predicates
     /*  235417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235444 */     GIR_RootConstrainSelectedInstOperands,
     /*  235445 */     // GIR_Coverage, 9357,
     /*  235445 */     GIR_EraseRootFromParent_Done,
     /*  235446 */   // Label 4608: @235446
     /*  235446 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(235520), // Rule ID 9360 //
     /*  235451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235491 */     // MIs[1] Operand 1
     /*  235491 */     // No operand predicates
     /*  235491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235500 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235518 */     GIR_RootConstrainSelectedInstOperands,
     /*  235519 */     // GIR_Coverage, 9360,
     /*  235519 */     GIR_EraseRootFromParent_Done,
     /*  235520 */   // Label 4609: @235520
     /*  235520 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(235594), // Rule ID 9361 //
     /*  235525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235565 */     // MIs[1] Operand 1
     /*  235565 */     // No operand predicates
     /*  235565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235574 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235592 */     GIR_RootConstrainSelectedInstOperands,
     /*  235593 */     // GIR_Coverage, 9361,
     /*  235593 */     GIR_EraseRootFromParent_Done,
     /*  235594 */   // Label 4610: @235594
     /*  235594 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(235668), // Rule ID 9364 //
     /*  235599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235639 */     // MIs[1] Operand 1
     /*  235639 */     // No operand predicates
     /*  235639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235648 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235666 */     GIR_RootConstrainSelectedInstOperands,
     /*  235667 */     // GIR_Coverage, 9364,
     /*  235667 */     GIR_EraseRootFromParent_Done,
     /*  235668 */   // Label 4611: @235668
     /*  235668 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(235742), // Rule ID 9365 //
     /*  235673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235713 */     // MIs[1] Operand 1
     /*  235713 */     // No operand predicates
     /*  235713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235740 */     GIR_RootConstrainSelectedInstOperands,
     /*  235741 */     // GIR_Coverage, 9365,
     /*  235741 */     GIR_EraseRootFromParent_Done,
     /*  235742 */   // Label 4612: @235742
     /*  235742 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(235816), // Rule ID 9368 //
     /*  235747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235787 */     // MIs[1] Operand 1
     /*  235787 */     // No operand predicates
     /*  235787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235814 */     GIR_RootConstrainSelectedInstOperands,
     /*  235815 */     // GIR_Coverage, 9368,
     /*  235815 */     GIR_EraseRootFromParent_Done,
     /*  235816 */   // Label 4613: @235816
     /*  235816 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(235890), // Rule ID 9369 //
     /*  235821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235861 */     // MIs[1] Operand 1
     /*  235861 */     // No operand predicates
     /*  235861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235888 */     GIR_RootConstrainSelectedInstOperands,
     /*  235889 */     // GIR_Coverage, 9369,
     /*  235889 */     GIR_EraseRootFromParent_Done,
     /*  235890 */   // Label 4614: @235890
     /*  235890 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(235964), // Rule ID 9372 //
     /*  235895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235935 */     // MIs[1] Operand 1
     /*  235935 */     // No operand predicates
     /*  235935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235962 */     GIR_RootConstrainSelectedInstOperands,
     /*  235963 */     // GIR_Coverage, 9372,
     /*  235963 */     GIR_EraseRootFromParent_Done,
     /*  235964 */   // Label 4615: @235964
     /*  235964 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(236038), // Rule ID 9373 //
     /*  235969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236009 */     // MIs[1] Operand 1
     /*  236009 */     // No operand predicates
     /*  236009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236036 */     GIR_RootConstrainSelectedInstOperands,
     /*  236037 */     // GIR_Coverage, 9373,
     /*  236037 */     GIR_EraseRootFromParent_Done,
     /*  236038 */   // Label 4616: @236038
     /*  236038 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(236112), // Rule ID 9376 //
     /*  236043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236083 */     // MIs[1] Operand 1
     /*  236083 */     // No operand predicates
     /*  236083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  236095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236110 */     GIR_RootConstrainSelectedInstOperands,
     /*  236111 */     // GIR_Coverage, 9376,
     /*  236111 */     GIR_EraseRootFromParent_Done,
     /*  236112 */   // Label 4617: @236112
     /*  236112 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(236186), // Rule ID 9377 //
     /*  236117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236157 */     // MIs[1] Operand 1
     /*  236157 */     // No operand predicates
     /*  236157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  236169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236184 */     GIR_RootConstrainSelectedInstOperands,
     /*  236185 */     // GIR_Coverage, 9377,
     /*  236185 */     GIR_EraseRootFromParent_Done,
     /*  236186 */   // Label 4618: @236186
     /*  236186 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(236260), // Rule ID 9380 //
     /*  236191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236231 */     // MIs[1] Operand 1
     /*  236231 */     // No operand predicates
     /*  236231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  236243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236258 */     GIR_RootConstrainSelectedInstOperands,
     /*  236259 */     // GIR_Coverage, 9380,
     /*  236259 */     GIR_EraseRootFromParent_Done,
     /*  236260 */   // Label 4619: @236260
     /*  236260 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(236334), // Rule ID 9381 //
     /*  236265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236305 */     // MIs[1] Operand 1
     /*  236305 */     // No operand predicates
     /*  236305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236314 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  236317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236332 */     GIR_RootConstrainSelectedInstOperands,
     /*  236333 */     // GIR_Coverage, 9381,
     /*  236333 */     GIR_EraseRootFromParent_Done,
     /*  236334 */   // Label 4620: @236334
     /*  236334 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(236408), // Rule ID 9384 //
     /*  236339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236379 */     // MIs[1] Operand 1
     /*  236379 */     // No operand predicates
     /*  236379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236406 */     GIR_RootConstrainSelectedInstOperands,
     /*  236407 */     // GIR_Coverage, 9384,
     /*  236407 */     GIR_EraseRootFromParent_Done,
     /*  236408 */   // Label 4621: @236408
     /*  236408 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(236482), // Rule ID 9385 //
     /*  236413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236453 */     // MIs[1] Operand 1
     /*  236453 */     // No operand predicates
     /*  236453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  236465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236480 */     GIR_RootConstrainSelectedInstOperands,
     /*  236481 */     // GIR_Coverage, 9385,
     /*  236481 */     GIR_EraseRootFromParent_Done,
     /*  236482 */   // Label 4622: @236482
     /*  236482 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(236556), // Rule ID 9476 //
     /*  236487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236527 */     // MIs[1] Operand 1
     /*  236527 */     // No operand predicates
     /*  236527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236554 */     GIR_RootConstrainSelectedInstOperands,
     /*  236555 */     // GIR_Coverage, 9476,
     /*  236555 */     GIR_EraseRootFromParent_Done,
     /*  236556 */   // Label 4623: @236556
     /*  236556 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(236630), // Rule ID 9477 //
     /*  236561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236601 */     // MIs[1] Operand 1
     /*  236601 */     // No operand predicates
     /*  236601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236628 */     GIR_RootConstrainSelectedInstOperands,
     /*  236629 */     // GIR_Coverage, 9477,
     /*  236629 */     GIR_EraseRootFromParent_Done,
     /*  236630 */   // Label 4624: @236630
     /*  236630 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(236704), // Rule ID 9480 //
     /*  236635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236675 */     // MIs[1] Operand 1
     /*  236675 */     // No operand predicates
     /*  236675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236702 */     GIR_RootConstrainSelectedInstOperands,
     /*  236703 */     // GIR_Coverage, 9480,
     /*  236703 */     GIR_EraseRootFromParent_Done,
     /*  236704 */   // Label 4625: @236704
     /*  236704 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(236778), // Rule ID 9481 //
     /*  236709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236749 */     // MIs[1] Operand 1
     /*  236749 */     // No operand predicates
     /*  236749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236776 */     GIR_RootConstrainSelectedInstOperands,
     /*  236777 */     // GIR_Coverage, 9481,
     /*  236777 */     GIR_EraseRootFromParent_Done,
     /*  236778 */   // Label 4626: @236778
     /*  236778 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(236852), // Rule ID 9484 //
     /*  236783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236823 */     // MIs[1] Operand 1
     /*  236823 */     // No operand predicates
     /*  236823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236850 */     GIR_RootConstrainSelectedInstOperands,
     /*  236851 */     // GIR_Coverage, 9484,
     /*  236851 */     GIR_EraseRootFromParent_Done,
     /*  236852 */   // Label 4627: @236852
     /*  236852 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(236926), // Rule ID 9485 //
     /*  236857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236897 */     // MIs[1] Operand 1
     /*  236897 */     // No operand predicates
     /*  236897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236924 */     GIR_RootConstrainSelectedInstOperands,
     /*  236925 */     // GIR_Coverage, 9485,
     /*  236925 */     GIR_EraseRootFromParent_Done,
     /*  236926 */   // Label 4628: @236926
     /*  236926 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(237000), // Rule ID 9488 //
     /*  236931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236971 */     // MIs[1] Operand 1
     /*  236971 */     // No operand predicates
     /*  236971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236980 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236998 */     GIR_RootConstrainSelectedInstOperands,
     /*  236999 */     // GIR_Coverage, 9488,
     /*  236999 */     GIR_EraseRootFromParent_Done,
     /*  237000 */   // Label 4629: @237000
     /*  237000 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(237074), // Rule ID 9489 //
     /*  237005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237045 */     // MIs[1] Operand 1
     /*  237045 */     // No operand predicates
     /*  237045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  237057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237072 */     GIR_RootConstrainSelectedInstOperands,
     /*  237073 */     // GIR_Coverage, 9489,
     /*  237073 */     GIR_EraseRootFromParent_Done,
     /*  237074 */   // Label 4630: @237074
     /*  237074 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(237148), // Rule ID 9492 //
     /*  237079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237119 */     // MIs[1] Operand 1
     /*  237119 */     // No operand predicates
     /*  237119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237146 */     GIR_RootConstrainSelectedInstOperands,
     /*  237147 */     // GIR_Coverage, 9492,
     /*  237147 */     GIR_EraseRootFromParent_Done,
     /*  237148 */   // Label 4631: @237148
     /*  237148 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(237222), // Rule ID 9493 //
     /*  237153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237193 */     // MIs[1] Operand 1
     /*  237193 */     // No operand predicates
     /*  237193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237220 */     GIR_RootConstrainSelectedInstOperands,
     /*  237221 */     // GIR_Coverage, 9493,
     /*  237221 */     GIR_EraseRootFromParent_Done,
     /*  237222 */   // Label 4632: @237222
     /*  237222 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(237296), // Rule ID 9496 //
     /*  237227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237267 */     // MIs[1] Operand 1
     /*  237267 */     // No operand predicates
     /*  237267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237294 */     GIR_RootConstrainSelectedInstOperands,
     /*  237295 */     // GIR_Coverage, 9496,
     /*  237295 */     GIR_EraseRootFromParent_Done,
     /*  237296 */   // Label 4633: @237296
     /*  237296 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(237370), // Rule ID 9497 //
     /*  237301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237341 */     // MIs[1] Operand 1
     /*  237341 */     // No operand predicates
     /*  237341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  237353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237368 */     GIR_RootConstrainSelectedInstOperands,
     /*  237369 */     // GIR_Coverage, 9497,
     /*  237369 */     GIR_EraseRootFromParent_Done,
     /*  237370 */   // Label 4634: @237370
     /*  237370 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(237444), // Rule ID 9500 //
     /*  237375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237415 */     // MIs[1] Operand 1
     /*  237415 */     // No operand predicates
     /*  237415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237442 */     GIR_RootConstrainSelectedInstOperands,
     /*  237443 */     // GIR_Coverage, 9500,
     /*  237443 */     GIR_EraseRootFromParent_Done,
     /*  237444 */   // Label 4635: @237444
     /*  237444 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(237518), // Rule ID 9501 //
     /*  237449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237489 */     // MIs[1] Operand 1
     /*  237489 */     // No operand predicates
     /*  237489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237516 */     GIR_RootConstrainSelectedInstOperands,
     /*  237517 */     // GIR_Coverage, 9501,
     /*  237517 */     GIR_EraseRootFromParent_Done,
     /*  237518 */   // Label 4636: @237518
     /*  237518 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(237592), // Rule ID 9504 //
     /*  237523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237563 */     // MIs[1] Operand 1
     /*  237563 */     // No operand predicates
     /*  237563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237590 */     GIR_RootConstrainSelectedInstOperands,
     /*  237591 */     // GIR_Coverage, 9504,
     /*  237591 */     GIR_EraseRootFromParent_Done,
     /*  237592 */   // Label 4637: @237592
     /*  237592 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(237666), // Rule ID 9505 //
     /*  237597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237637 */     // MIs[1] Operand 1
     /*  237637 */     // No operand predicates
     /*  237637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237664 */     GIR_RootConstrainSelectedInstOperands,
     /*  237665 */     // GIR_Coverage, 9505,
     /*  237665 */     GIR_EraseRootFromParent_Done,
     /*  237666 */   // Label 4638: @237666
     /*  237666 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(237740), // Rule ID 9508 //
     /*  237671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237711 */     // MIs[1] Operand 1
     /*  237711 */     // No operand predicates
     /*  237711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237738 */     GIR_RootConstrainSelectedInstOperands,
     /*  237739 */     // GIR_Coverage, 9508,
     /*  237739 */     GIR_EraseRootFromParent_Done,
     /*  237740 */   // Label 4639: @237740
     /*  237740 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(237814), // Rule ID 9509 //
     /*  237745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237785 */     // MIs[1] Operand 1
     /*  237785 */     // No operand predicates
     /*  237785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237812 */     GIR_RootConstrainSelectedInstOperands,
     /*  237813 */     // GIR_Coverage, 9509,
     /*  237813 */     GIR_EraseRootFromParent_Done,
     /*  237814 */   // Label 4640: @237814
     /*  237814 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(237888), // Rule ID 9512 //
     /*  237819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237859 */     // MIs[1] Operand 1
     /*  237859 */     // No operand predicates
     /*  237859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237886 */     GIR_RootConstrainSelectedInstOperands,
     /*  237887 */     // GIR_Coverage, 9512,
     /*  237887 */     GIR_EraseRootFromParent_Done,
     /*  237888 */   // Label 4641: @237888
     /*  237888 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(237962), // Rule ID 9513 //
     /*  237893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  237896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237933 */     // MIs[1] Operand 1
     /*  237933 */     // No operand predicates
     /*  237933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237960 */     GIR_RootConstrainSelectedInstOperands,
     /*  237961 */     // GIR_Coverage, 9513,
     /*  237961 */     GIR_EraseRootFromParent_Done,
     /*  237962 */   // Label 4642: @237962
     /*  237962 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(238036), // Rule ID 9516 //
     /*  237967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238007 */     // MIs[1] Operand 1
     /*  238007 */     // No operand predicates
     /*  238007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238034 */     GIR_RootConstrainSelectedInstOperands,
     /*  238035 */     // GIR_Coverage, 9516,
     /*  238035 */     GIR_EraseRootFromParent_Done,
     /*  238036 */   // Label 4643: @238036
     /*  238036 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(238110), // Rule ID 9517 //
     /*  238041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238081 */     // MIs[1] Operand 1
     /*  238081 */     // No operand predicates
     /*  238081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238090 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238108 */     GIR_RootConstrainSelectedInstOperands,
     /*  238109 */     // GIR_Coverage, 9517,
     /*  238109 */     GIR_EraseRootFromParent_Done,
     /*  238110 */   // Label 4644: @238110
     /*  238110 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(238184), // Rule ID 9520 //
     /*  238115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238155 */     // MIs[1] Operand 1
     /*  238155 */     // No operand predicates
     /*  238155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238164 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238182 */     GIR_RootConstrainSelectedInstOperands,
     /*  238183 */     // GIR_Coverage, 9520,
     /*  238183 */     GIR_EraseRootFromParent_Done,
     /*  238184 */   // Label 4645: @238184
     /*  238184 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(238258), // Rule ID 9521 //
     /*  238189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238229 */     // MIs[1] Operand 1
     /*  238229 */     // No operand predicates
     /*  238229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238238 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238256 */     GIR_RootConstrainSelectedInstOperands,
     /*  238257 */     // GIR_Coverage, 9521,
     /*  238257 */     GIR_EraseRootFromParent_Done,
     /*  238258 */   // Label 4646: @238258
     /*  238258 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(238332), // Rule ID 9524 //
     /*  238263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238303 */     // MIs[1] Operand 1
     /*  238303 */     // No operand predicates
     /*  238303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238312 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238330 */     GIR_RootConstrainSelectedInstOperands,
     /*  238331 */     // GIR_Coverage, 9524,
     /*  238331 */     GIR_EraseRootFromParent_Done,
     /*  238332 */   // Label 4647: @238332
     /*  238332 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(238406), // Rule ID 9525 //
     /*  238337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238377 */     // MIs[1] Operand 1
     /*  238377 */     // No operand predicates
     /*  238377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238386 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238404 */     GIR_RootConstrainSelectedInstOperands,
     /*  238405 */     // GIR_Coverage, 9525,
     /*  238405 */     GIR_EraseRootFromParent_Done,
     /*  238406 */   // Label 4648: @238406
     /*  238406 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(238480), // Rule ID 9528 //
     /*  238411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238451 */     // MIs[1] Operand 1
     /*  238451 */     // No operand predicates
     /*  238451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238478 */     GIR_RootConstrainSelectedInstOperands,
     /*  238479 */     // GIR_Coverage, 9528,
     /*  238479 */     GIR_EraseRootFromParent_Done,
     /*  238480 */   // Label 4649: @238480
     /*  238480 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(238554), // Rule ID 9529 //
     /*  238485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238525 */     // MIs[1] Operand 1
     /*  238525 */     // No operand predicates
     /*  238525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238552 */     GIR_RootConstrainSelectedInstOperands,
     /*  238553 */     // GIR_Coverage, 9529,
     /*  238553 */     GIR_EraseRootFromParent_Done,
     /*  238554 */   // Label 4650: @238554
     /*  238554 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(238628), // Rule ID 9532 //
     /*  238559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238599 */     // MIs[1] Operand 1
     /*  238599 */     // No operand predicates
     /*  238599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238626 */     GIR_RootConstrainSelectedInstOperands,
     /*  238627 */     // GIR_Coverage, 9532,
     /*  238627 */     GIR_EraseRootFromParent_Done,
     /*  238628 */   // Label 4651: @238628
     /*  238628 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(238702), // Rule ID 9533 //
     /*  238633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238673 */     // MIs[1] Operand 1
     /*  238673 */     // No operand predicates
     /*  238673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238682 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238700 */     GIR_RootConstrainSelectedInstOperands,
     /*  238701 */     // GIR_Coverage, 9533,
     /*  238701 */     GIR_EraseRootFromParent_Done,
     /*  238702 */   // Label 4652: @238702
     /*  238702 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(238776), // Rule ID 9536 //
     /*  238707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238747 */     // MIs[1] Operand 1
     /*  238747 */     // No operand predicates
     /*  238747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238756 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238774 */     GIR_RootConstrainSelectedInstOperands,
     /*  238775 */     // GIR_Coverage, 9536,
     /*  238775 */     GIR_EraseRootFromParent_Done,
     /*  238776 */   // Label 4653: @238776
     /*  238776 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(238850), // Rule ID 9537 //
     /*  238781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238821 */     // MIs[1] Operand 1
     /*  238821 */     // No operand predicates
     /*  238821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238830 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238848 */     GIR_RootConstrainSelectedInstOperands,
     /*  238849 */     // GIR_Coverage, 9537,
     /*  238849 */     GIR_EraseRootFromParent_Done,
     /*  238850 */   // Label 4654: @238850
     /*  238850 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(238924), // Rule ID 9540 //
     /*  238855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238895 */     // MIs[1] Operand 1
     /*  238895 */     // No operand predicates
     /*  238895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238922 */     GIR_RootConstrainSelectedInstOperands,
     /*  238923 */     // GIR_Coverage, 9540,
     /*  238923 */     GIR_EraseRootFromParent_Done,
     /*  238924 */   // Label 4655: @238924
     /*  238924 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(238998), // Rule ID 9541 //
     /*  238929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238969 */     // MIs[1] Operand 1
     /*  238969 */     // No operand predicates
     /*  238969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238996 */     GIR_RootConstrainSelectedInstOperands,
     /*  238997 */     // GIR_Coverage, 9541,
     /*  238997 */     GIR_EraseRootFromParent_Done,
     /*  238998 */   // Label 4656: @238998
     /*  238998 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(239072), // Rule ID 9544 //
     /*  239003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239043 */     // MIs[1] Operand 1
     /*  239043 */     // No operand predicates
     /*  239043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239070 */     GIR_RootConstrainSelectedInstOperands,
     /*  239071 */     // GIR_Coverage, 9544,
     /*  239071 */     GIR_EraseRootFromParent_Done,
     /*  239072 */   // Label 4657: @239072
     /*  239072 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(239146), // Rule ID 9545 //
     /*  239077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239117 */     // MIs[1] Operand 1
     /*  239117 */     // No operand predicates
     /*  239117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239144 */     GIR_RootConstrainSelectedInstOperands,
     /*  239145 */     // GIR_Coverage, 9545,
     /*  239145 */     GIR_EraseRootFromParent_Done,
     /*  239146 */   // Label 4658: @239146
     /*  239146 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(239220), // Rule ID 9548 //
     /*  239151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239191 */     // MIs[1] Operand 1
     /*  239191 */     // No operand predicates
     /*  239191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239218 */     GIR_RootConstrainSelectedInstOperands,
     /*  239219 */     // GIR_Coverage, 9548,
     /*  239219 */     GIR_EraseRootFromParent_Done,
     /*  239220 */   // Label 4659: @239220
     /*  239220 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(239294), // Rule ID 9549 //
     /*  239225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239265 */     // MIs[1] Operand 1
     /*  239265 */     // No operand predicates
     /*  239265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239292 */     GIR_RootConstrainSelectedInstOperands,
     /*  239293 */     // GIR_Coverage, 9549,
     /*  239293 */     GIR_EraseRootFromParent_Done,
     /*  239294 */   // Label 4660: @239294
     /*  239294 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(239368), // Rule ID 9552 //
     /*  239299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239339 */     // MIs[1] Operand 1
     /*  239339 */     // No operand predicates
     /*  239339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  239351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239366 */     GIR_RootConstrainSelectedInstOperands,
     /*  239367 */     // GIR_Coverage, 9552,
     /*  239367 */     GIR_EraseRootFromParent_Done,
     /*  239368 */   // Label 4661: @239368
     /*  239368 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(239442), // Rule ID 9553 //
     /*  239373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239413 */     // MIs[1] Operand 1
     /*  239413 */     // No operand predicates
     /*  239413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  239425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239440 */     GIR_RootConstrainSelectedInstOperands,
     /*  239441 */     // GIR_Coverage, 9553,
     /*  239441 */     GIR_EraseRootFromParent_Done,
     /*  239442 */   // Label 4662: @239442
     /*  239442 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(239516), // Rule ID 9556 //
     /*  239447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239487 */     // MIs[1] Operand 1
     /*  239487 */     // No operand predicates
     /*  239487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239514 */     GIR_RootConstrainSelectedInstOperands,
     /*  239515 */     // GIR_Coverage, 9556,
     /*  239515 */     GIR_EraseRootFromParent_Done,
     /*  239516 */   // Label 4663: @239516
     /*  239516 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(239590), // Rule ID 9557 //
     /*  239521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239561 */     // MIs[1] Operand 1
     /*  239561 */     // No operand predicates
     /*  239561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239588 */     GIR_RootConstrainSelectedInstOperands,
     /*  239589 */     // GIR_Coverage, 9557,
     /*  239589 */     GIR_EraseRootFromParent_Done,
     /*  239590 */   // Label 4664: @239590
     /*  239590 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(239664), // Rule ID 9560 //
     /*  239595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239635 */     // MIs[1] Operand 1
     /*  239635 */     // No operand predicates
     /*  239635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239662 */     GIR_RootConstrainSelectedInstOperands,
     /*  239663 */     // GIR_Coverage, 9560,
     /*  239663 */     GIR_EraseRootFromParent_Done,
     /*  239664 */   // Label 4665: @239664
     /*  239664 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(239738), // Rule ID 9561 //
     /*  239669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239709 */     // MIs[1] Operand 1
     /*  239709 */     // No operand predicates
     /*  239709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239736 */     GIR_RootConstrainSelectedInstOperands,
     /*  239737 */     // GIR_Coverage, 9561,
     /*  239737 */     GIR_EraseRootFromParent_Done,
     /*  239738 */   // Label 4666: @239738
     /*  239738 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(239794), // Rule ID 64451 //
     /*  239743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  239746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  239751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  239757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239765 */     // MIs[0] pts
     /*  239765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  239768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  239773 */     // MIs[0] radix
     /*  239773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  239776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  239781 */     // (intrinsic_wo_chain:{ *:[i32] } 11034:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  239781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  239784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239788 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  239790 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  239792 */     GIR_RootConstrainSelectedInstOperands,
     /*  239793 */     // GIR_Coverage, 64451,
     /*  239793 */     GIR_EraseRootFromParent_Done,
     /*  239794 */   // Label 4667: @239794
     /*  239794 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(239857), // Rule ID 2690 //
     /*  239799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  239802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  239810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239838 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  239838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239845 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239855 */     GIR_RootConstrainSelectedInstOperands,
     /*  239856 */     // GIR_Coverage, 2690,
     /*  239856 */     GIR_EraseRootFromParent_Done,
     /*  239857 */   // Label 4668: @239857
     /*  239857 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(239920), // Rule ID 2691 //
     /*  239862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  239865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239901 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  239901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239908 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239918 */     GIR_RootConstrainSelectedInstOperands,
     /*  239919 */     // GIR_Coverage, 2691,
     /*  239919 */     GIR_EraseRootFromParent_Done,
     /*  239920 */   // Label 4669: @239920
     /*  239920 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(239986), // Rule ID 2698 //
     /*  239925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  239964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239984 */     GIR_RootConstrainSelectedInstOperands,
     /*  239985 */     // GIR_Coverage, 2698,
     /*  239985 */     GIR_EraseRootFromParent_Done,
     /*  239986 */   // Label 4670: @239986
     /*  239986 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(240052), // Rule ID 2699 //
     /*  239991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  240002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  240030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  240033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240050 */     GIR_RootConstrainSelectedInstOperands,
     /*  240051 */     // GIR_Coverage, 2699,
     /*  240051 */     GIR_EraseRootFromParent_Done,
     /*  240052 */   // Label 4671: @240052
     /*  240052 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(240118), // Rule ID 2702 //
     /*  240057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  240099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240116 */     GIR_RootConstrainSelectedInstOperands,
     /*  240117 */     // GIR_Coverage, 2702,
     /*  240117 */     GIR_EraseRootFromParent_Done,
     /*  240118 */   // Label 4672: @240118
     /*  240118 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(240184), // Rule ID 2703 //
     /*  240123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  240165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240182 */     GIR_RootConstrainSelectedInstOperands,
     /*  240183 */     // GIR_Coverage, 2703,
     /*  240183 */     GIR_EraseRootFromParent_Done,
     /*  240184 */   // Label 4673: @240184
     /*  240184 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(240250), // Rule ID 2706 //
     /*  240189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  240192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  240197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240228 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  240231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240248 */     GIR_RootConstrainSelectedInstOperands,
     /*  240249 */     // GIR_Coverage, 2706,
     /*  240249 */     GIR_EraseRootFromParent_Done,
     /*  240250 */   // Label 4674: @240250
     /*  240250 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(240316), // Rule ID 2707 //
     /*  240255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  240258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  240263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  240297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240314 */     GIR_RootConstrainSelectedInstOperands,
     /*  240315 */     // GIR_Coverage, 2707,
     /*  240315 */     GIR_EraseRootFromParent_Done,
     /*  240316 */   // Label 4675: @240316
     /*  240316 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(240379), // Rule ID 2720 //
     /*  240321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  240329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  240363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240377 */     GIR_RootConstrainSelectedInstOperands,
     /*  240378 */     // GIR_Coverage, 2720,
     /*  240378 */     GIR_EraseRootFromParent_Done,
     /*  240379 */   // Label 4676: @240379
     /*  240379 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(240442), // Rule ID 2721 //
     /*  240384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  240392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240423 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  240426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240440 */     GIR_RootConstrainSelectedInstOperands,
     /*  240441 */     // GIR_Coverage, 2721,
     /*  240441 */     GIR_EraseRootFromParent_Done,
     /*  240442 */   // Label 4677: @240442
     /*  240442 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(240505), // Rule ID 2732 //
     /*  240447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240486 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240503 */     GIR_RootConstrainSelectedInstOperands,
     /*  240504 */     // GIR_Coverage, 2732,
     /*  240504 */     GIR_EraseRootFromParent_Done,
     /*  240505 */   // Label 4678: @240505
     /*  240505 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(240568), // Rule ID 2733 //
     /*  240510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240549 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240566 */     GIR_RootConstrainSelectedInstOperands,
     /*  240567 */     // GIR_Coverage, 2733,
     /*  240567 */     GIR_EraseRootFromParent_Done,
     /*  240568 */   // Label 4679: @240568
     /*  240568 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(240631), // Rule ID 2740 //
     /*  240573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240629 */     GIR_RootConstrainSelectedInstOperands,
     /*  240630 */     // GIR_Coverage, 2740,
     /*  240630 */     GIR_EraseRootFromParent_Done,
     /*  240631 */   // Label 4680: @240631
     /*  240631 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(240694), // Rule ID 2741 //
     /*  240636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240692 */     GIR_RootConstrainSelectedInstOperands,
     /*  240693 */     // GIR_Coverage, 2741,
     /*  240693 */     GIR_EraseRootFromParent_Done,
     /*  240694 */   // Label 4681: @240694
     /*  240694 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(240760), // Rule ID 2742 //
     /*  240699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  240702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240738 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240758 */     GIR_RootConstrainSelectedInstOperands,
     /*  240759 */     // GIR_Coverage, 2742,
     /*  240759 */     GIR_EraseRootFromParent_Done,
     /*  240760 */   // Label 4682: @240760
     /*  240760 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(240826), // Rule ID 2743 //
     /*  240765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  240768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240824 */     GIR_RootConstrainSelectedInstOperands,
     /*  240825 */     // GIR_Coverage, 2743,
     /*  240825 */     GIR_EraseRootFromParent_Done,
     /*  240826 */   // Label 4683: @240826
     /*  240826 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(240889), // Rule ID 2754 //
     /*  240831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  240870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240887 */     GIR_RootConstrainSelectedInstOperands,
     /*  240888 */     // GIR_Coverage, 2754,
     /*  240888 */     GIR_EraseRootFromParent_Done,
     /*  240889 */   // Label 4684: @240889
     /*  240889 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(240952), // Rule ID 2755 //
     /*  240894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240933 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  240933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240950 */     GIR_RootConstrainSelectedInstOperands,
     /*  240951 */     // GIR_Coverage, 2755,
     /*  240951 */     GIR_EraseRootFromParent_Done,
     /*  240952 */   // Label 4685: @240952
     /*  240952 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(241018), // Rule ID 4902 //
     /*  240957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241016 */     GIR_RootConstrainSelectedInstOperands,
     /*  241017 */     // GIR_Coverage, 4902,
     /*  241017 */     GIR_EraseRootFromParent_Done,
     /*  241018 */   // Label 4686: @241018
     /*  241018 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(241084), // Rule ID 4903 //
     /*  241023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  241034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  241037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  241040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241082 */     GIR_RootConstrainSelectedInstOperands,
     /*  241083 */     // GIR_Coverage, 4903,
     /*  241083 */     GIR_EraseRootFromParent_Done,
     /*  241084 */   // Label 4687: @241084
     /*  241084 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(241150), // Rule ID 4906 //
     /*  241089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  241100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  241106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241148 */     GIR_RootConstrainSelectedInstOperands,
     /*  241149 */     // GIR_Coverage, 4906,
     /*  241149 */     GIR_EraseRootFromParent_Done,
     /*  241150 */   // Label 4688: @241150
     /*  241150 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(241216), // Rule ID 4907 //
     /*  241155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  241166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  241169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  241172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11733:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241214 */     GIR_RootConstrainSelectedInstOperands,
     /*  241215 */     // GIR_Coverage, 4907,
     /*  241215 */     GIR_EraseRootFromParent_Done,
     /*  241216 */   // Label 4689: @241216
     /*  241216 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(241282), // Rule ID 4910 //
     /*  241221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  241232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  241238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241280 */     GIR_RootConstrainSelectedInstOperands,
     /*  241281 */     // GIR_Coverage, 4910,
     /*  241281 */     GIR_EraseRootFromParent_Done,
     /*  241282 */   // Label 4690: @241282
     /*  241282 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(241348), // Rule ID 4911 //
     /*  241287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  241298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  241304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241346 */     GIR_RootConstrainSelectedInstOperands,
     /*  241347 */     // GIR_Coverage, 4911,
     /*  241347 */     GIR_EraseRootFromParent_Done,
     /*  241348 */   // Label 4691: @241348
     /*  241348 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(241414), // Rule ID 4914 //
     /*  241353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  241364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  241370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241412 */     GIR_RootConstrainSelectedInstOperands,
     /*  241413 */     // GIR_Coverage, 4914,
     /*  241413 */     GIR_EraseRootFromParent_Done,
     /*  241414 */   // Label 4692: @241414
     /*  241414 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(241480), // Rule ID 4915 //
     /*  241419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  241430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  241436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241478 */     GIR_RootConstrainSelectedInstOperands,
     /*  241479 */     // GIR_Coverage, 4915,
     /*  241479 */     GIR_EraseRootFromParent_Done,
     /*  241480 */   // Label 4693: @241480
     /*  241480 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(241546), // Rule ID 4918 //
     /*  241485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241544 */     GIR_RootConstrainSelectedInstOperands,
     /*  241545 */     // GIR_Coverage, 4918,
     /*  241545 */     GIR_EraseRootFromParent_Done,
     /*  241546 */   // Label 4694: @241546
     /*  241546 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(241612), // Rule ID 4919 //
     /*  241551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241610 */     GIR_RootConstrainSelectedInstOperands,
     /*  241611 */     // GIR_Coverage, 4919,
     /*  241611 */     GIR_EraseRootFromParent_Done,
     /*  241612 */   // Label 4695: @241612
     /*  241612 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(241678), // Rule ID 4922 //
     /*  241617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241676 */     GIR_RootConstrainSelectedInstOperands,
     /*  241677 */     // GIR_Coverage, 4922,
     /*  241677 */     GIR_EraseRootFromParent_Done,
     /*  241678 */   // Label 4696: @241678
     /*  241678 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(241744), // Rule ID 4923 //
     /*  241683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241742 */     GIR_RootConstrainSelectedInstOperands,
     /*  241743 */     // GIR_Coverage, 4923,
     /*  241743 */     GIR_EraseRootFromParent_Done,
     /*  241744 */   // Label 4697: @241744
     /*  241744 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(241810), // Rule ID 4926 //
     /*  241749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241808 */     GIR_RootConstrainSelectedInstOperands,
     /*  241809 */     // GIR_Coverage, 4926,
     /*  241809 */     GIR_EraseRootFromParent_Done,
     /*  241810 */   // Label 4698: @241810
     /*  241810 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(241876), // Rule ID 4927 //
     /*  241815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241874 */     GIR_RootConstrainSelectedInstOperands,
     /*  241875 */     // GIR_Coverage, 4927,
     /*  241875 */     GIR_EraseRootFromParent_Done,
     /*  241876 */   // Label 4699: @241876
     /*  241876 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(241942), // Rule ID 4930 //
     /*  241881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241940 */     GIR_RootConstrainSelectedInstOperands,
     /*  241941 */     // GIR_Coverage, 4930,
     /*  241941 */     GIR_EraseRootFromParent_Done,
     /*  241942 */   // Label 4700: @241942
     /*  241942 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(242008), // Rule ID 4931 //
     /*  241947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242006 */     GIR_RootConstrainSelectedInstOperands,
     /*  242007 */     // GIR_Coverage, 4931,
     /*  242007 */     GIR_EraseRootFromParent_Done,
     /*  242008 */   // Label 4701: @242008
     /*  242008 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(242074), // Rule ID 4934 //
     /*  242013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242072 */     GIR_RootConstrainSelectedInstOperands,
     /*  242073 */     // GIR_Coverage, 4934,
     /*  242073 */     GIR_EraseRootFromParent_Done,
     /*  242074 */   // Label 4702: @242074
     /*  242074 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(242140), // Rule ID 4935 //
     /*  242079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242138 */     GIR_RootConstrainSelectedInstOperands,
     /*  242139 */     // GIR_Coverage, 4935,
     /*  242139 */     GIR_EraseRootFromParent_Done,
     /*  242140 */   // Label 4703: @242140
     /*  242140 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(242206), // Rule ID 4938 //
     /*  242145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242204 */     GIR_RootConstrainSelectedInstOperands,
     /*  242205 */     // GIR_Coverage, 4938,
     /*  242205 */     GIR_EraseRootFromParent_Done,
     /*  242206 */   // Label 4704: @242206
     /*  242206 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(242272), // Rule ID 4939 //
     /*  242211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  242228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242270 */     GIR_RootConstrainSelectedInstOperands,
     /*  242271 */     // GIR_Coverage, 4939,
     /*  242271 */     GIR_EraseRootFromParent_Done,
     /*  242272 */   // Label 4705: @242272
     /*  242272 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(242338), // Rule ID 4942 //
     /*  242277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  242294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  242319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242336 */     GIR_RootConstrainSelectedInstOperands,
     /*  242337 */     // GIR_Coverage, 4942,
     /*  242337 */     GIR_EraseRootFromParent_Done,
     /*  242338 */   // Label 4706: @242338
     /*  242338 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(242404), // Rule ID 4943 //
     /*  242343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  242360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  242385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242402 */     GIR_RootConstrainSelectedInstOperands,
     /*  242403 */     // GIR_Coverage, 4943,
     /*  242403 */     GIR_EraseRootFromParent_Done,
     /*  242404 */   // Label 4707: @242404
     /*  242404 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(242470), // Rule ID 4946 //
     /*  242409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242468 */     GIR_RootConstrainSelectedInstOperands,
     /*  242469 */     // GIR_Coverage, 4946,
     /*  242469 */     GIR_EraseRootFromParent_Done,
     /*  242470 */   // Label 4708: @242470
     /*  242470 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(242536), // Rule ID 4947 //
     /*  242475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242534 */     GIR_RootConstrainSelectedInstOperands,
     /*  242535 */     // GIR_Coverage, 4947,
     /*  242535 */     GIR_EraseRootFromParent_Done,
     /*  242536 */   // Label 4709: @242536
     /*  242536 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(242602), // Rule ID 4950 //
     /*  242541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242580 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242600 */     GIR_RootConstrainSelectedInstOperands,
     /*  242601 */     // GIR_Coverage, 4950,
     /*  242601 */     GIR_EraseRootFromParent_Done,
     /*  242602 */   // Label 4710: @242602
     /*  242602 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(242668), // Rule ID 4951 //
     /*  242607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242666 */     GIR_RootConstrainSelectedInstOperands,
     /*  242667 */     // GIR_Coverage, 4951,
     /*  242667 */     GIR_EraseRootFromParent_Done,
     /*  242668 */   // Label 4711: @242668
     /*  242668 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(242734), // Rule ID 4954 //
     /*  242673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242732 */     GIR_RootConstrainSelectedInstOperands,
     /*  242733 */     // GIR_Coverage, 4954,
     /*  242733 */     GIR_EraseRootFromParent_Done,
     /*  242734 */   // Label 4712: @242734
     /*  242734 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(242800), // Rule ID 4955 //
     /*  242739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242798 */     GIR_RootConstrainSelectedInstOperands,
     /*  242799 */     // GIR_Coverage, 4955,
     /*  242799 */     GIR_EraseRootFromParent_Done,
     /*  242800 */   // Label 4713: @242800
     /*  242800 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(242866), // Rule ID 4958 //
     /*  242805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242864 */     GIR_RootConstrainSelectedInstOperands,
     /*  242865 */     // GIR_Coverage, 4958,
     /*  242865 */     GIR_EraseRootFromParent_Done,
     /*  242866 */   // Label 4714: @242866
     /*  242866 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(242932), // Rule ID 4959 //
     /*  242871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242930 */     GIR_RootConstrainSelectedInstOperands,
     /*  242931 */     // GIR_Coverage, 4959,
     /*  242931 */     GIR_EraseRootFromParent_Done,
     /*  242932 */   // Label 4715: @242932
     /*  242932 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(242998), // Rule ID 4962 //
     /*  242937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242996 */     GIR_RootConstrainSelectedInstOperands,
     /*  242997 */     // GIR_Coverage, 4962,
     /*  242997 */     GIR_EraseRootFromParent_Done,
     /*  242998 */   // Label 4716: @242998
     /*  242998 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(243064), // Rule ID 4963 //
     /*  243003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  243014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  243017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11733:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243062 */     GIR_RootConstrainSelectedInstOperands,
     /*  243063 */     // GIR_Coverage, 4963,
     /*  243063 */     GIR_EraseRootFromParent_Done,
     /*  243064 */   // Label 4717: @243064
     /*  243064 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(243130), // Rule ID 4966 //
     /*  243069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  243080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  243083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243128 */     GIR_RootConstrainSelectedInstOperands,
     /*  243129 */     // GIR_Coverage, 4966,
     /*  243129 */     GIR_EraseRootFromParent_Done,
     /*  243130 */   // Label 4718: @243130
     /*  243130 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(243196), // Rule ID 4967 //
     /*  243135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  243146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  243149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243194 */     GIR_RootConstrainSelectedInstOperands,
     /*  243195 */     // GIR_Coverage, 4967,
     /*  243195 */     GIR_EraseRootFromParent_Done,
     /*  243196 */   // Label 4719: @243196
     /*  243196 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(243262), // Rule ID 4970 //
     /*  243201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  243212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  243215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243260 */     GIR_RootConstrainSelectedInstOperands,
     /*  243261 */     // GIR_Coverage, 4970,
     /*  243261 */     GIR_EraseRootFromParent_Done,
     /*  243262 */   // Label 4720: @243262
     /*  243262 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(243328), // Rule ID 4971 //
     /*  243267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  243278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  243281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243326 */     GIR_RootConstrainSelectedInstOperands,
     /*  243327 */     // GIR_Coverage, 4971,
     /*  243327 */     GIR_EraseRootFromParent_Done,
     /*  243328 */   // Label 4721: @243328
     /*  243328 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(243394), // Rule ID 4974 //
     /*  243333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  243344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  243347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  243350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  243372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243392 */     GIR_RootConstrainSelectedInstOperands,
     /*  243393 */     // GIR_Coverage, 4974,
     /*  243393 */     GIR_EraseRootFromParent_Done,
     /*  243394 */   // Label 4722: @243394
     /*  243394 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(243460), // Rule ID 4975 //
     /*  243399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  243410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  243413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  243416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  243438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  243455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243458 */     GIR_RootConstrainSelectedInstOperands,
     /*  243459 */     // GIR_Coverage, 4975,
     /*  243459 */     GIR_EraseRootFromParent_Done,
     /*  243460 */   // Label 4723: @243460
     /*  243460 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(243526), // Rule ID 4978 //
     /*  243465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243524 */     GIR_RootConstrainSelectedInstOperands,
     /*  243525 */     // GIR_Coverage, 4978,
     /*  243525 */     GIR_EraseRootFromParent_Done,
     /*  243526 */   // Label 4724: @243526
     /*  243526 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(243592), // Rule ID 4979 //
     /*  243531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243570 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243590 */     GIR_RootConstrainSelectedInstOperands,
     /*  243591 */     // GIR_Coverage, 4979,
     /*  243591 */     GIR_EraseRootFromParent_Done,
     /*  243592 */   // Label 4725: @243592
     /*  243592 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(243658), // Rule ID 4982 //
     /*  243597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243656 */     GIR_RootConstrainSelectedInstOperands,
     /*  243657 */     // GIR_Coverage, 4982,
     /*  243657 */     GIR_EraseRootFromParent_Done,
     /*  243658 */   // Label 4726: @243658
     /*  243658 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(243724), // Rule ID 4983 //
     /*  243663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243722 */     GIR_RootConstrainSelectedInstOperands,
     /*  243723 */     // GIR_Coverage, 4983,
     /*  243723 */     GIR_EraseRootFromParent_Done,
     /*  243724 */   // Label 4727: @243724
     /*  243724 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(243790), // Rule ID 4986 //
     /*  243729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243788 */     GIR_RootConstrainSelectedInstOperands,
     /*  243789 */     // GIR_Coverage, 4986,
     /*  243789 */     GIR_EraseRootFromParent_Done,
     /*  243790 */   // Label 4728: @243790
     /*  243790 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(243856), // Rule ID 4987 //
     /*  243795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243854 */     GIR_RootConstrainSelectedInstOperands,
     /*  243855 */     // GIR_Coverage, 4987,
     /*  243855 */     GIR_EraseRootFromParent_Done,
     /*  243856 */   // Label 4729: @243856
     /*  243856 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(243922), // Rule ID 4990 //
     /*  243861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243900 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243920 */     GIR_RootConstrainSelectedInstOperands,
     /*  243921 */     // GIR_Coverage, 4990,
     /*  243921 */     GIR_EraseRootFromParent_Done,
     /*  243922 */   // Label 4730: @243922
     /*  243922 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(243988), // Rule ID 4991 //
     /*  243927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243986 */     GIR_RootConstrainSelectedInstOperands,
     /*  243987 */     // GIR_Coverage, 4991,
     /*  243987 */     GIR_EraseRootFromParent_Done,
     /*  243988 */   // Label 4731: @243988
     /*  243988 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(244054), // Rule ID 4994 //
     /*  243993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  244004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  244007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  244035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244052 */     GIR_RootConstrainSelectedInstOperands,
     /*  244053 */     // GIR_Coverage, 4994,
     /*  244053 */     GIR_EraseRootFromParent_Done,
     /*  244054 */   // Label 4732: @244054
     /*  244054 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(244120), // Rule ID 4995 //
     /*  244059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  244070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  244073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11733:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  244101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244118 */     GIR_RootConstrainSelectedInstOperands,
     /*  244119 */     // GIR_Coverage, 4995,
     /*  244119 */     GIR_EraseRootFromParent_Done,
     /*  244120 */   // Label 4733: @244120
     /*  244120 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(244186), // Rule ID 4998 //
     /*  244125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  244167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244184 */     GIR_RootConstrainSelectedInstOperands,
     /*  244185 */     // GIR_Coverage, 4998,
     /*  244185 */     GIR_EraseRootFromParent_Done,
     /*  244186 */   // Label 4734: @244186
     /*  244186 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(244252), // Rule ID 4999 //
     /*  244191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  244202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  244205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11733:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  244233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244250 */     GIR_RootConstrainSelectedInstOperands,
     /*  244251 */     // GIR_Coverage, 4999,
     /*  244251 */     GIR_EraseRootFromParent_Done,
     /*  244252 */   // Label 4735: @244252
     /*  244252 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(244318), // Rule ID 5002 //
     /*  244257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  244268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  244271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  244299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244316 */     GIR_RootConstrainSelectedInstOperands,
     /*  244317 */     // GIR_Coverage, 5002,
     /*  244317 */     GIR_EraseRootFromParent_Done,
     /*  244318 */   // Label 4736: @244318
     /*  244318 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(244384), // Rule ID 5003 //
     /*  244323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  244334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  244337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11733:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  244365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244382 */     GIR_RootConstrainSelectedInstOperands,
     /*  244383 */     // GIR_Coverage, 5003,
     /*  244383 */     GIR_EraseRootFromParent_Done,
     /*  244384 */   // Label 4737: @244384
     /*  244384 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(244450), // Rule ID 5006 //
     /*  244389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  244392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  244428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244448 */     GIR_RootConstrainSelectedInstOperands,
     /*  244449 */     // GIR_Coverage, 5006,
     /*  244449 */     GIR_EraseRootFromParent_Done,
     /*  244450 */   // Label 4738: @244450
     /*  244450 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(244516), // Rule ID 5007 //
     /*  244455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  244458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11733:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244514 */     GIR_RootConstrainSelectedInstOperands,
     /*  244515 */     // GIR_Coverage, 5007,
     /*  244515 */     GIR_EraseRootFromParent_Done,
     /*  244516 */   // Label 4739: @244516
     /*  244516 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(244582), // Rule ID 5010 //
     /*  244521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244580 */     GIR_RootConstrainSelectedInstOperands,
     /*  244581 */     // GIR_Coverage, 5010,
     /*  244581 */     GIR_EraseRootFromParent_Done,
     /*  244582 */   // Label 4740: @244582
     /*  244582 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(244648), // Rule ID 5011 //
     /*  244587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244646 */     GIR_RootConstrainSelectedInstOperands,
     /*  244647 */     // GIR_Coverage, 5011,
     /*  244647 */     GIR_EraseRootFromParent_Done,
     /*  244648 */   // Label 4741: @244648
     /*  244648 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(244714), // Rule ID 5014 //
     /*  244653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244712 */     GIR_RootConstrainSelectedInstOperands,
     /*  244713 */     // GIR_Coverage, 5014,
     /*  244713 */     GIR_EraseRootFromParent_Done,
     /*  244714 */   // Label 4742: @244714
     /*  244714 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(244780), // Rule ID 5015 //
     /*  244719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244778 */     GIR_RootConstrainSelectedInstOperands,
     /*  244779 */     // GIR_Coverage, 5015,
     /*  244779 */     GIR_EraseRootFromParent_Done,
     /*  244780 */   // Label 4743: @244780
     /*  244780 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(244846), // Rule ID 5018 //
     /*  244785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244844 */     GIR_RootConstrainSelectedInstOperands,
     /*  244845 */     // GIR_Coverage, 5018,
     /*  244845 */     GIR_EraseRootFromParent_Done,
     /*  244846 */   // Label 4744: @244846
     /*  244846 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(244912), // Rule ID 5019 //
     /*  244851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244910 */     GIR_RootConstrainSelectedInstOperands,
     /*  244911 */     // GIR_Coverage, 5019,
     /*  244911 */     GIR_EraseRootFromParent_Done,
     /*  244912 */   // Label 4745: @244912
     /*  244912 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(244978), // Rule ID 5022 //
     /*  244917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244976 */     GIR_RootConstrainSelectedInstOperands,
     /*  244977 */     // GIR_Coverage, 5022,
     /*  244977 */     GIR_EraseRootFromParent_Done,
     /*  244978 */   // Label 4746: @244978
     /*  244978 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(245044), // Rule ID 5023 //
     /*  244983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  245000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245042 */     GIR_RootConstrainSelectedInstOperands,
     /*  245043 */     // GIR_Coverage, 5023,
     /*  245043 */     GIR_EraseRootFromParent_Done,
     /*  245044 */   // Label 4747: @245044
     /*  245044 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(245110), // Rule ID 5026 //
     /*  245049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  245060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  245063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  245066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245108 */     GIR_RootConstrainSelectedInstOperands,
     /*  245109 */     // GIR_Coverage, 5026,
     /*  245109 */     GIR_EraseRootFromParent_Done,
     /*  245110 */   // Label 4748: @245110
     /*  245110 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(245176), // Rule ID 5027 //
     /*  245115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  245126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  245129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  245132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245174 */     GIR_RootConstrainSelectedInstOperands,
     /*  245175 */     // GIR_Coverage, 5027,
     /*  245175 */     GIR_EraseRootFromParent_Done,
     /*  245176 */   // Label 4749: @245176
     /*  245176 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(245242), // Rule ID 5030 //
     /*  245181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  245192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  245195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  245198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  245220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245240 */     GIR_RootConstrainSelectedInstOperands,
     /*  245241 */     // GIR_Coverage, 5030,
     /*  245241 */     GIR_EraseRootFromParent_Done,
     /*  245242 */   // Label 4750: @245242
     /*  245242 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(245308), // Rule ID 5031 //
     /*  245247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  245258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  245261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  245264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  245286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  245303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245306 */     GIR_RootConstrainSelectedInstOperands,
     /*  245307 */     // GIR_Coverage, 5031,
     /*  245307 */     GIR_EraseRootFromParent_Done,
     /*  245308 */   // Label 4751: @245308
     /*  245308 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(245374), // Rule ID 5034 //
     /*  245313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  245355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245372 */     GIR_RootConstrainSelectedInstOperands,
     /*  245373 */     // GIR_Coverage, 5034,
     /*  245373 */     GIR_EraseRootFromParent_Done,
     /*  245374 */   // Label 4752: @245374
     /*  245374 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(245440), // Rule ID 5035 //
     /*  245379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  245421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245438 */     GIR_RootConstrainSelectedInstOperands,
     /*  245439 */     // GIR_Coverage, 5035,
     /*  245439 */     GIR_EraseRootFromParent_Done,
     /*  245440 */   // Label 4753: @245440
     /*  245440 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(245506), // Rule ID 5038 //
     /*  245445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245504 */     GIR_RootConstrainSelectedInstOperands,
     /*  245505 */     // GIR_Coverage, 5038,
     /*  245505 */     GIR_EraseRootFromParent_Done,
     /*  245506 */   // Label 4754: @245506
     /*  245506 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(245572), // Rule ID 5039 //
     /*  245511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245570 */     GIR_RootConstrainSelectedInstOperands,
     /*  245571 */     // GIR_Coverage, 5039,
     /*  245571 */     GIR_EraseRootFromParent_Done,
     /*  245572 */   // Label 4755: @245572
     /*  245572 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(245638), // Rule ID 5042 //
     /*  245577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245636 */     GIR_RootConstrainSelectedInstOperands,
     /*  245637 */     // GIR_Coverage, 5042,
     /*  245637 */     GIR_EraseRootFromParent_Done,
     /*  245638 */   // Label 4756: @245638
     /*  245638 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(245704), // Rule ID 5043 //
     /*  245643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245702 */     GIR_RootConstrainSelectedInstOperands,
     /*  245703 */     // GIR_Coverage, 5043,
     /*  245703 */     GIR_EraseRootFromParent_Done,
     /*  245704 */   // Label 4757: @245704
     /*  245704 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(245770), // Rule ID 5046 //
     /*  245709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245768 */     GIR_RootConstrainSelectedInstOperands,
     /*  245769 */     // GIR_Coverage, 5046,
     /*  245769 */     GIR_EraseRootFromParent_Done,
     /*  245770 */   // Label 4758: @245770
     /*  245770 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(245836), // Rule ID 5047 //
     /*  245775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245834 */     GIR_RootConstrainSelectedInstOperands,
     /*  245835 */     // GIR_Coverage, 5047,
     /*  245835 */     GIR_EraseRootFromParent_Done,
     /*  245836 */   // Label 4759: @245836
     /*  245836 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(245902), // Rule ID 5050 //
     /*  245841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245900 */     GIR_RootConstrainSelectedInstOperands,
     /*  245901 */     // GIR_Coverage, 5050,
     /*  245901 */     GIR_EraseRootFromParent_Done,
     /*  245902 */   // Label 4760: @245902
     /*  245902 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(245968), // Rule ID 5051 //
     /*  245907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245966 */     GIR_RootConstrainSelectedInstOperands,
     /*  245967 */     // GIR_Coverage, 5051,
     /*  245967 */     GIR_EraseRootFromParent_Done,
     /*  245968 */   // Label 4761: @245968
     /*  245968 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(246034), // Rule ID 5054 //
     /*  245973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  246015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246032 */     GIR_RootConstrainSelectedInstOperands,
     /*  246033 */     // GIR_Coverage, 5054,
     /*  246033 */     GIR_EraseRootFromParent_Done,
     /*  246034 */   // Label 4762: @246034
     /*  246034 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(246100), // Rule ID 5055 //
     /*  246039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  246056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  246081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246098 */     GIR_RootConstrainSelectedInstOperands,
     /*  246099 */     // GIR_Coverage, 5055,
     /*  246099 */     GIR_EraseRootFromParent_Done,
     /*  246100 */   // Label 4763: @246100
     /*  246100 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(246166), // Rule ID 5058 //
     /*  246105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  246122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  246147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246164 */     GIR_RootConstrainSelectedInstOperands,
     /*  246165 */     // GIR_Coverage, 5058,
     /*  246165 */     GIR_EraseRootFromParent_Done,
     /*  246166 */   // Label 4764: @246166
     /*  246166 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(246232), // Rule ID 5059 //
     /*  246171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  246188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  246213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246230 */     GIR_RootConstrainSelectedInstOperands,
     /*  246231 */     // GIR_Coverage, 5059,
     /*  246231 */     GIR_EraseRootFromParent_Done,
     /*  246232 */   // Label 4765: @246232
     /*  246232 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(246298), // Rule ID 5062 //
     /*  246237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  246279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246296 */     GIR_RootConstrainSelectedInstOperands,
     /*  246297 */     // GIR_Coverage, 5062,
     /*  246297 */     GIR_EraseRootFromParent_Done,
     /*  246298 */   // Label 4766: @246298
     /*  246298 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(246364), // Rule ID 5063 //
     /*  246303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  246345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246362 */     GIR_RootConstrainSelectedInstOperands,
     /*  246363 */     // GIR_Coverage, 5063,
     /*  246363 */     GIR_EraseRootFromParent_Done,
     /*  246364 */   // Label 4767: @246364
     /*  246364 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(246430), // Rule ID 5066 //
     /*  246369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246428 */     GIR_RootConstrainSelectedInstOperands,
     /*  246429 */     // GIR_Coverage, 5066,
     /*  246429 */     GIR_EraseRootFromParent_Done,
     /*  246430 */   // Label 4768: @246430
     /*  246430 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(246496), // Rule ID 5067 //
     /*  246435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246494 */     GIR_RootConstrainSelectedInstOperands,
     /*  246495 */     // GIR_Coverage, 5067,
     /*  246495 */     GIR_EraseRootFromParent_Done,
     /*  246496 */   // Label 4769: @246496
     /*  246496 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(246562), // Rule ID 5070 //
     /*  246501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246560 */     GIR_RootConstrainSelectedInstOperands,
     /*  246561 */     // GIR_Coverage, 5070,
     /*  246561 */     GIR_EraseRootFromParent_Done,
     /*  246562 */   // Label 4770: @246562
     /*  246562 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(246628), // Rule ID 5071 //
     /*  246567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246626 */     GIR_RootConstrainSelectedInstOperands,
     /*  246627 */     // GIR_Coverage, 5071,
     /*  246627 */     GIR_EraseRootFromParent_Done,
     /*  246628 */   // Label 4771: @246628
     /*  246628 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(246694), // Rule ID 5074 //
     /*  246633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246692 */     GIR_RootConstrainSelectedInstOperands,
     /*  246693 */     // GIR_Coverage, 5074,
     /*  246693 */     GIR_EraseRootFromParent_Done,
     /*  246694 */   // Label 4772: @246694
     /*  246694 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(246760), // Rule ID 5075 //
     /*  246699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246758 */     GIR_RootConstrainSelectedInstOperands,
     /*  246759 */     // GIR_Coverage, 5075,
     /*  246759 */     GIR_EraseRootFromParent_Done,
     /*  246760 */   // Label 4773: @246760
     /*  246760 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(246826), // Rule ID 5078 //
     /*  246765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246824 */     GIR_RootConstrainSelectedInstOperands,
     /*  246825 */     // GIR_Coverage, 5078,
     /*  246825 */     GIR_EraseRootFromParent_Done,
     /*  246826 */   // Label 4774: @246826
     /*  246826 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(246892), // Rule ID 5079 //
     /*  246831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246890 */     GIR_RootConstrainSelectedInstOperands,
     /*  246891 */     // GIR_Coverage, 5079,
     /*  246891 */     GIR_EraseRootFromParent_Done,
     /*  246892 */   // Label 4775: @246892
     /*  246892 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(246958), // Rule ID 5082 //
     /*  246897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246956 */     GIR_RootConstrainSelectedInstOperands,
     /*  246957 */     // GIR_Coverage, 5082,
     /*  246957 */     GIR_EraseRootFromParent_Done,
     /*  246958 */   // Label 4776: @246958
     /*  246958 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(247024), // Rule ID 5083 //
     /*  246963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247022 */     GIR_RootConstrainSelectedInstOperands,
     /*  247023 */     // GIR_Coverage, 5083,
     /*  247023 */     GIR_EraseRootFromParent_Done,
     /*  247024 */   // Label 4777: @247024
     /*  247024 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247090), // Rule ID 5086 //
     /*  247029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  247040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  247043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  247046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  247068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247088 */     GIR_RootConstrainSelectedInstOperands,
     /*  247089 */     // GIR_Coverage, 5086,
     /*  247089 */     GIR_EraseRootFromParent_Done,
     /*  247090 */   // Label 4778: @247090
     /*  247090 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247156), // Rule ID 5087 //
     /*  247095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  247106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  247109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  247112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  247134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247154 */     GIR_RootConstrainSelectedInstOperands,
     /*  247155 */     // GIR_Coverage, 5087,
     /*  247155 */     GIR_EraseRootFromParent_Done,
     /*  247156 */   // Label 4779: @247156
     /*  247156 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247222), // Rule ID 5090 //
     /*  247161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  247203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247220 */     GIR_RootConstrainSelectedInstOperands,
     /*  247221 */     // GIR_Coverage, 5090,
     /*  247221 */     GIR_EraseRootFromParent_Done,
     /*  247222 */   // Label 4780: @247222
     /*  247222 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247288), // Rule ID 5091 //
     /*  247227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  247269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247286 */     GIR_RootConstrainSelectedInstOperands,
     /*  247287 */     // GIR_Coverage, 5091,
     /*  247287 */     GIR_EraseRootFromParent_Done,
     /*  247288 */   // Label 4781: @247288
     /*  247288 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247354), // Rule ID 5094 //
     /*  247293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  247335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247352 */     GIR_RootConstrainSelectedInstOperands,
     /*  247353 */     // GIR_Coverage, 5094,
     /*  247353 */     GIR_EraseRootFromParent_Done,
     /*  247354 */   // Label 4782: @247354
     /*  247354 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247420), // Rule ID 5095 //
     /*  247359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  247401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247418 */     GIR_RootConstrainSelectedInstOperands,
     /*  247419 */     // GIR_Coverage, 5095,
     /*  247419 */     GIR_EraseRootFromParent_Done,
     /*  247420 */   // Label 4783: @247420
     /*  247420 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247486), // Rule ID 5098 //
     /*  247425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247484 */     GIR_RootConstrainSelectedInstOperands,
     /*  247485 */     // GIR_Coverage, 5098,
     /*  247485 */     GIR_EraseRootFromParent_Done,
     /*  247486 */   // Label 4784: @247486
     /*  247486 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247552), // Rule ID 5099 //
     /*  247491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247550 */     GIR_RootConstrainSelectedInstOperands,
     /*  247551 */     // GIR_Coverage, 5099,
     /*  247551 */     GIR_EraseRootFromParent_Done,
     /*  247552 */   // Label 4785: @247552
     /*  247552 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247618), // Rule ID 5102 //
     /*  247557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247616 */     GIR_RootConstrainSelectedInstOperands,
     /*  247617 */     // GIR_Coverage, 5102,
     /*  247617 */     GIR_EraseRootFromParent_Done,
     /*  247618 */   // Label 4786: @247618
     /*  247618 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(247684), // Rule ID 5103 //
     /*  247623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247662 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247682 */     GIR_RootConstrainSelectedInstOperands,
     /*  247683 */     // GIR_Coverage, 5103,
     /*  247683 */     GIR_EraseRootFromParent_Done,
     /*  247684 */   // Label 4787: @247684
     /*  247684 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(247750), // Rule ID 5106 //
     /*  247689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247748 */     GIR_RootConstrainSelectedInstOperands,
     /*  247749 */     // GIR_Coverage, 5106,
     /*  247749 */     GIR_EraseRootFromParent_Done,
     /*  247750 */   // Label 4788: @247750
     /*  247750 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(247816), // Rule ID 5107 //
     /*  247755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247814 */     GIR_RootConstrainSelectedInstOperands,
     /*  247815 */     // GIR_Coverage, 5107,
     /*  247815 */     GIR_EraseRootFromParent_Done,
     /*  247816 */   // Label 4789: @247816
     /*  247816 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(247882), // Rule ID 5110 //
     /*  247821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247880 */     GIR_RootConstrainSelectedInstOperands,
     /*  247881 */     // GIR_Coverage, 5110,
     /*  247881 */     GIR_EraseRootFromParent_Done,
     /*  247882 */   // Label 4790: @247882
     /*  247882 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(247948), // Rule ID 5111 //
     /*  247887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247946 */     GIR_RootConstrainSelectedInstOperands,
     /*  247947 */     // GIR_Coverage, 5111,
     /*  247947 */     GIR_EraseRootFromParent_Done,
     /*  247948 */   // Label 4791: @247948
     /*  247948 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(248014), // Rule ID 5114 //
     /*  247953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248012 */     GIR_RootConstrainSelectedInstOperands,
     /*  248013 */     // GIR_Coverage, 5114,
     /*  248013 */     GIR_EraseRootFromParent_Done,
     /*  248014 */   // Label 4792: @248014
     /*  248014 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(248080), // Rule ID 5115 //
     /*  248019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  248022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  248030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  248033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  248058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  248061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248078 */     GIR_RootConstrainSelectedInstOperands,
     /*  248079 */     // GIR_Coverage, 5115,
     /*  248079 */     GIR_EraseRootFromParent_Done,
     /*  248080 */   // Label 4793: @248080
     /*  248080 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248146), // Rule ID 5118 //
     /*  248085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  248088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  248096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  248099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  248124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  248127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248144 */     GIR_RootConstrainSelectedInstOperands,
     /*  248145 */     // GIR_Coverage, 5118,
     /*  248145 */     GIR_EraseRootFromParent_Done,
     /*  248146 */   // Label 4794: @248146
     /*  248146 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248212), // Rule ID 5119 //
     /*  248151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  248154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  248162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  248165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  248190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  248193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248210 */     GIR_RootConstrainSelectedInstOperands,
     /*  248211 */     // GIR_Coverage, 5119,
     /*  248211 */     GIR_EraseRootFromParent_Done,
     /*  248212 */   // Label 4795: @248212
     /*  248212 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248275), // Rule ID 5382 //
     /*  248217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  248231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248273 */     GIR_RootConstrainSelectedInstOperands,
     /*  248274 */     // GIR_Coverage, 5382,
     /*  248274 */     GIR_EraseRootFromParent_Done,
     /*  248275 */   // Label 4796: @248275
     /*  248275 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248338), // Rule ID 5383 //
     /*  248280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  248294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248336 */     GIR_RootConstrainSelectedInstOperands,
     /*  248337 */     // GIR_Coverage, 5383,
     /*  248337 */     GIR_EraseRootFromParent_Done,
     /*  248338 */   // Label 4797: @248338
     /*  248338 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248401), // Rule ID 5384 //
     /*  248343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  248357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248399 */     GIR_RootConstrainSelectedInstOperands,
     /*  248400 */     // GIR_Coverage, 5384,
     /*  248400 */     GIR_EraseRootFromParent_Done,
     /*  248401 */   // Label 4798: @248401
     /*  248401 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248464), // Rule ID 5385 //
     /*  248406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  248420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248445 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248462 */     GIR_RootConstrainSelectedInstOperands,
     /*  248463 */     // GIR_Coverage, 5385,
     /*  248463 */     GIR_EraseRootFromParent_Done,
     /*  248464 */   // Label 4799: @248464
     /*  248464 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248527), // Rule ID 5386 //
     /*  248469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248525 */     GIR_RootConstrainSelectedInstOperands,
     /*  248526 */     // GIR_Coverage, 5386,
     /*  248526 */     GIR_EraseRootFromParent_Done,
     /*  248527 */   // Label 4800: @248527
     /*  248527 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248590), // Rule ID 5387 //
     /*  248532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248571 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248588 */     GIR_RootConstrainSelectedInstOperands,
     /*  248589 */     // GIR_Coverage, 5387,
     /*  248589 */     GIR_EraseRootFromParent_Done,
     /*  248590 */   // Label 4801: @248590
     /*  248590 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248653), // Rule ID 5388 //
     /*  248595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248651 */     GIR_RootConstrainSelectedInstOperands,
     /*  248652 */     // GIR_Coverage, 5388,
     /*  248652 */     GIR_EraseRootFromParent_Done,
     /*  248653 */   // Label 4802: @248653
     /*  248653 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248716), // Rule ID 5389 //
     /*  248658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248714 */     GIR_RootConstrainSelectedInstOperands,
     /*  248715 */     // GIR_Coverage, 5389,
     /*  248715 */     GIR_EraseRootFromParent_Done,
     /*  248716 */   // Label 4803: @248716
     /*  248716 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248779), // Rule ID 5390 //
     /*  248721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248777 */     GIR_RootConstrainSelectedInstOperands,
     /*  248778 */     // GIR_Coverage, 5390,
     /*  248778 */     GIR_EraseRootFromParent_Done,
     /*  248779 */   // Label 4804: @248779
     /*  248779 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248842), // Rule ID 5391 //
     /*  248784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248840 */     GIR_RootConstrainSelectedInstOperands,
     /*  248841 */     // GIR_Coverage, 5391,
     /*  248841 */     GIR_EraseRootFromParent_Done,
     /*  248842 */   // Label 4805: @248842
     /*  248842 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248905), // Rule ID 5392 //
     /*  248847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248903 */     GIR_RootConstrainSelectedInstOperands,
     /*  248904 */     // GIR_Coverage, 5392,
     /*  248904 */     GIR_EraseRootFromParent_Done,
     /*  248905 */   // Label 4806: @248905
     /*  248905 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248968), // Rule ID 5393 //
     /*  248910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248966 */     GIR_RootConstrainSelectedInstOperands,
     /*  248967 */     // GIR_Coverage, 5393,
     /*  248967 */     GIR_EraseRootFromParent_Done,
     /*  248968 */   // Label 4807: @248968
     /*  248968 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249031), // Rule ID 5394 //
     /*  248973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249029 */     GIR_RootConstrainSelectedInstOperands,
     /*  249030 */     // GIR_Coverage, 5394,
     /*  249030 */     GIR_EraseRootFromParent_Done,
     /*  249031 */   // Label 4808: @249031
     /*  249031 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249094), // Rule ID 5395 //
     /*  249036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  249050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249092 */     GIR_RootConstrainSelectedInstOperands,
     /*  249093 */     // GIR_Coverage, 5395,
     /*  249093 */     GIR_EraseRootFromParent_Done,
     /*  249094 */   // Label 4809: @249094
     /*  249094 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249157), // Rule ID 5396 //
     /*  249099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249155 */     GIR_RootConstrainSelectedInstOperands,
     /*  249156 */     // GIR_Coverage, 5396,
     /*  249156 */     GIR_EraseRootFromParent_Done,
     /*  249157 */   // Label 4810: @249157
     /*  249157 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249220), // Rule ID 5397 //
     /*  249162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  249176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249201 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249218 */     GIR_RootConstrainSelectedInstOperands,
     /*  249219 */     // GIR_Coverage, 5397,
     /*  249219 */     GIR_EraseRootFromParent_Done,
     /*  249220 */   // Label 4811: @249220
     /*  249220 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249283), // Rule ID 5398 //
     /*  249225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  249228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  249242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  249264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249281 */     GIR_RootConstrainSelectedInstOperands,
     /*  249282 */     // GIR_Coverage, 5398,
     /*  249282 */     GIR_EraseRootFromParent_Done,
     /*  249283 */   // Label 4812: @249283
     /*  249283 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249346), // Rule ID 5399 //
     /*  249288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  249291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  249305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  249327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  249330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249344 */     GIR_RootConstrainSelectedInstOperands,
     /*  249345 */     // GIR_Coverage, 5399,
     /*  249345 */     GIR_EraseRootFromParent_Done,
     /*  249346 */   // Label 4813: @249346
     /*  249346 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249409), // Rule ID 5400 //
     /*  249351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  249365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  249368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249407 */     GIR_RootConstrainSelectedInstOperands,
     /*  249408 */     // GIR_Coverage, 5400,
     /*  249408 */     GIR_EraseRootFromParent_Done,
     /*  249409 */   // Label 4814: @249409
     /*  249409 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249472), // Rule ID 5401 //
     /*  249414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  249428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  249431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249453 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249470 */     GIR_RootConstrainSelectedInstOperands,
     /*  249471 */     // GIR_Coverage, 5401,
     /*  249471 */     GIR_EraseRootFromParent_Done,
     /*  249472 */   // Label 4815: @249472
     /*  249472 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249535), // Rule ID 5402 //
     /*  249477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249516 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249533 */     GIR_RootConstrainSelectedInstOperands,
     /*  249534 */     // GIR_Coverage, 5402,
     /*  249534 */     GIR_EraseRootFromParent_Done,
     /*  249535 */   // Label 4816: @249535
     /*  249535 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249598), // Rule ID 5403 //
     /*  249540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249579 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249596 */     GIR_RootConstrainSelectedInstOperands,
     /*  249597 */     // GIR_Coverage, 5403,
     /*  249597 */     GIR_EraseRootFromParent_Done,
     /*  249598 */   // Label 4817: @249598
     /*  249598 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249661), // Rule ID 5404 //
     /*  249603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249642 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249659 */     GIR_RootConstrainSelectedInstOperands,
     /*  249660 */     // GIR_Coverage, 5404,
     /*  249660 */     GIR_EraseRootFromParent_Done,
     /*  249661 */   // Label 4818: @249661
     /*  249661 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249724), // Rule ID 5405 //
     /*  249666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249705 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249722 */     GIR_RootConstrainSelectedInstOperands,
     /*  249723 */     // GIR_Coverage, 5405,
     /*  249723 */     GIR_EraseRootFromParent_Done,
     /*  249724 */   // Label 4819: @249724
     /*  249724 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249787), // Rule ID 5406 //
     /*  249729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249785 */     GIR_RootConstrainSelectedInstOperands,
     /*  249786 */     // GIR_Coverage, 5406,
     /*  249786 */     GIR_EraseRootFromParent_Done,
     /*  249787 */   // Label 4820: @249787
     /*  249787 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249850), // Rule ID 5407 //
     /*  249792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249848 */     GIR_RootConstrainSelectedInstOperands,
     /*  249849 */     // GIR_Coverage, 5407,
     /*  249849 */     GIR_EraseRootFromParent_Done,
     /*  249850 */   // Label 4821: @249850
     /*  249850 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249913), // Rule ID 5408 //
     /*  249855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249894 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249911 */     GIR_RootConstrainSelectedInstOperands,
     /*  249912 */     // GIR_Coverage, 5408,
     /*  249912 */     GIR_EraseRootFromParent_Done,
     /*  249913 */   // Label 4822: @249913
     /*  249913 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249976), // Rule ID 5409 //
     /*  249918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249957 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249974 */     GIR_RootConstrainSelectedInstOperands,
     /*  249975 */     // GIR_Coverage, 5409,
     /*  249975 */     GIR_EraseRootFromParent_Done,
     /*  249976 */   // Label 4823: @249976
     /*  249976 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250039), // Rule ID 5410 //
     /*  249981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250020 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250037 */     GIR_RootConstrainSelectedInstOperands,
     /*  250038 */     // GIR_Coverage, 5410,
     /*  250038 */     GIR_EraseRootFromParent_Done,
     /*  250039 */   // Label 4824: @250039
     /*  250039 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250102), // Rule ID 5411 //
     /*  250044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  250055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  250058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  250061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250083 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250100 */     GIR_RootConstrainSelectedInstOperands,
     /*  250101 */     // GIR_Coverage, 5411,
     /*  250101 */     GIR_EraseRootFromParent_Done,
     /*  250102 */   // Label 4825: @250102
     /*  250102 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250165), // Rule ID 5412 //
     /*  250107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250163 */     GIR_RootConstrainSelectedInstOperands,
     /*  250164 */     // GIR_Coverage, 5412,
     /*  250164 */     GIR_EraseRootFromParent_Done,
     /*  250165 */   // Label 4826: @250165
     /*  250165 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250228), // Rule ID 5413 //
     /*  250170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  250187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250209 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250226 */     GIR_RootConstrainSelectedInstOperands,
     /*  250227 */     // GIR_Coverage, 5413,
     /*  250227 */     GIR_EraseRootFromParent_Done,
     /*  250228 */   // Label 4827: @250228
     /*  250228 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250291), // Rule ID 5414 //
     /*  250233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250289 */     GIR_RootConstrainSelectedInstOperands,
     /*  250290 */     // GIR_Coverage, 5414,
     /*  250290 */     GIR_EraseRootFromParent_Done,
     /*  250291 */   // Label 4828: @250291
     /*  250291 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250354), // Rule ID 5415 //
     /*  250296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  250313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250352 */     GIR_RootConstrainSelectedInstOperands,
     /*  250353 */     // GIR_Coverage, 5415,
     /*  250353 */     GIR_EraseRootFromParent_Done,
     /*  250354 */   // Label 4829: @250354
     /*  250354 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250417), // Rule ID 5416 //
     /*  250359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  250370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  250376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250398 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250415 */     GIR_RootConstrainSelectedInstOperands,
     /*  250416 */     // GIR_Coverage, 5416,
     /*  250416 */     GIR_EraseRootFromParent_Done,
     /*  250417 */   // Label 4830: @250417
     /*  250417 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250480), // Rule ID 5417 //
     /*  250422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  250433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  250439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250461 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250478 */     GIR_RootConstrainSelectedInstOperands,
     /*  250479 */     // GIR_Coverage, 5417,
     /*  250479 */     GIR_EraseRootFromParent_Done,
     /*  250480 */   // Label 4831: @250480
     /*  250480 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250543), // Rule ID 5418 //
     /*  250485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250541 */     GIR_RootConstrainSelectedInstOperands,
     /*  250542 */     // GIR_Coverage, 5418,
     /*  250542 */     GIR_EraseRootFromParent_Done,
     /*  250543 */   // Label 4832: @250543
     /*  250543 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250606), // Rule ID 5419 //
     /*  250548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250587 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250604 */     GIR_RootConstrainSelectedInstOperands,
     /*  250605 */     // GIR_Coverage, 5419,
     /*  250605 */     GIR_EraseRootFromParent_Done,
     /*  250606 */   // Label 4833: @250606
     /*  250606 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250669), // Rule ID 5420 //
     /*  250611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250667 */     GIR_RootConstrainSelectedInstOperands,
     /*  250668 */     // GIR_Coverage, 5420,
     /*  250668 */     GIR_EraseRootFromParent_Done,
     /*  250669 */   // Label 4834: @250669
     /*  250669 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250732), // Rule ID 5421 //
     /*  250674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250730 */     GIR_RootConstrainSelectedInstOperands,
     /*  250731 */     // GIR_Coverage, 5421,
     /*  250731 */     GIR_EraseRootFromParent_Done,
     /*  250732 */   // Label 4835: @250732
     /*  250732 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250795), // Rule ID 5422 //
     /*  250737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250793 */     GIR_RootConstrainSelectedInstOperands,
     /*  250794 */     // GIR_Coverage, 5422,
     /*  250794 */     GIR_EraseRootFromParent_Done,
     /*  250795 */   // Label 4836: @250795
     /*  250795 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250858), // Rule ID 5423 //
     /*  250800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250839 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250856 */     GIR_RootConstrainSelectedInstOperands,
     /*  250857 */     // GIR_Coverage, 5423,
     /*  250857 */     GIR_EraseRootFromParent_Done,
     /*  250858 */   // Label 4837: @250858
     /*  250858 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250921), // Rule ID 5424 //
     /*  250863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250919 */     GIR_RootConstrainSelectedInstOperands,
     /*  250920 */     // GIR_Coverage, 5424,
     /*  250920 */     GIR_EraseRootFromParent_Done,
     /*  250921 */   // Label 4838: @250921
     /*  250921 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250984), // Rule ID 5425 //
     /*  250926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250965 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250982 */     GIR_RootConstrainSelectedInstOperands,
     /*  250983 */     // GIR_Coverage, 5425,
     /*  250983 */     GIR_EraseRootFromParent_Done,
     /*  250984 */   // Label 4839: @250984
     /*  250984 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251047), // Rule ID 5426 //
     /*  250989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251045 */     GIR_RootConstrainSelectedInstOperands,
     /*  251046 */     // GIR_Coverage, 5426,
     /*  251046 */     GIR_EraseRootFromParent_Done,
     /*  251047 */   // Label 4840: @251047
     /*  251047 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251110), // Rule ID 5427 //
     /*  251052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251091 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251108 */     GIR_RootConstrainSelectedInstOperands,
     /*  251109 */     // GIR_Coverage, 5427,
     /*  251109 */     GIR_EraseRootFromParent_Done,
     /*  251110 */   // Label 4841: @251110
     /*  251110 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251173), // Rule ID 5428 //
     /*  251115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251171 */     GIR_RootConstrainSelectedInstOperands,
     /*  251172 */     // GIR_Coverage, 5428,
     /*  251172 */     GIR_EraseRootFromParent_Done,
     /*  251173 */   // Label 4842: @251173
     /*  251173 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251236), // Rule ID 5429 //
     /*  251178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251217 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251234 */     GIR_RootConstrainSelectedInstOperands,
     /*  251235 */     // GIR_Coverage, 5429,
     /*  251235 */     GIR_EraseRootFromParent_Done,
     /*  251236 */   // Label 4843: @251236
     /*  251236 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251299), // Rule ID 5430 //
     /*  251241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251297 */     GIR_RootConstrainSelectedInstOperands,
     /*  251298 */     // GIR_Coverage, 5430,
     /*  251298 */     GIR_EraseRootFromParent_Done,
     /*  251299 */   // Label 4844: @251299
     /*  251299 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251362), // Rule ID 5431 //
     /*  251304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  251346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251360 */     GIR_RootConstrainSelectedInstOperands,
     /*  251361 */     // GIR_Coverage, 5431,
     /*  251361 */     GIR_EraseRootFromParent_Done,
     /*  251362 */   // Label 4845: @251362
     /*  251362 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251425), // Rule ID 5432 //
     /*  251367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251423 */     GIR_RootConstrainSelectedInstOperands,
     /*  251424 */     // GIR_Coverage, 5432,
     /*  251424 */     GIR_EraseRootFromParent_Done,
     /*  251425 */   // Label 4846: @251425
     /*  251425 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251488), // Rule ID 5433 //
     /*  251430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251486 */     GIR_RootConstrainSelectedInstOperands,
     /*  251487 */     // GIR_Coverage, 5433,
     /*  251487 */     GIR_EraseRootFromParent_Done,
     /*  251488 */   // Label 4847: @251488
     /*  251488 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251551), // Rule ID 5434 //
     /*  251493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251549 */     GIR_RootConstrainSelectedInstOperands,
     /*  251550 */     // GIR_Coverage, 5434,
     /*  251550 */     GIR_EraseRootFromParent_Done,
     /*  251551 */   // Label 4848: @251551
     /*  251551 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251614), // Rule ID 5435 //
     /*  251556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251612 */     GIR_RootConstrainSelectedInstOperands,
     /*  251613 */     // GIR_Coverage, 5435,
     /*  251613 */     GIR_EraseRootFromParent_Done,
     /*  251614 */   // Label 4849: @251614
     /*  251614 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251677), // Rule ID 5436 //
     /*  251619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251675 */     GIR_RootConstrainSelectedInstOperands,
     /*  251676 */     // GIR_Coverage, 5436,
     /*  251676 */     GIR_EraseRootFromParent_Done,
     /*  251677 */   // Label 4850: @251677
     /*  251677 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251740), // Rule ID 5437 //
     /*  251682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251721 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251738 */     GIR_RootConstrainSelectedInstOperands,
     /*  251739 */     // GIR_Coverage, 5437,
     /*  251739 */     GIR_EraseRootFromParent_Done,
     /*  251740 */   // Label 4851: @251740
     /*  251740 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251803), // Rule ID 5438 //
     /*  251745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251801 */     GIR_RootConstrainSelectedInstOperands,
     /*  251802 */     // GIR_Coverage, 5438,
     /*  251802 */     GIR_EraseRootFromParent_Done,
     /*  251803 */   // Label 4852: @251803
     /*  251803 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251866), // Rule ID 5439 //
     /*  251808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251864 */     GIR_RootConstrainSelectedInstOperands,
     /*  251865 */     // GIR_Coverage, 5439,
     /*  251865 */     GIR_EraseRootFromParent_Done,
     /*  251866 */   // Label 4853: @251866
     /*  251866 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251929), // Rule ID 5440 //
     /*  251871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251927 */     GIR_RootConstrainSelectedInstOperands,
     /*  251928 */     // GIR_Coverage, 5440,
     /*  251928 */     GIR_EraseRootFromParent_Done,
     /*  251929 */   // Label 4854: @251929
     /*  251929 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251992), // Rule ID 5441 //
     /*  251934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251973 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251990 */     GIR_RootConstrainSelectedInstOperands,
     /*  251991 */     // GIR_Coverage, 5441,
     /*  251991 */     GIR_EraseRootFromParent_Done,
     /*  251992 */   // Label 4855: @251992
     /*  251992 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(252055), // Rule ID 5442 //
     /*  251997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252036 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  252039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252053 */     GIR_RootConstrainSelectedInstOperands,
     /*  252054 */     // GIR_Coverage, 5442,
     /*  252054 */     GIR_EraseRootFromParent_Done,
     /*  252055 */   // Label 4856: @252055
     /*  252055 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252118), // Rule ID 5443 //
     /*  252060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252099 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  252102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252116 */     GIR_RootConstrainSelectedInstOperands,
     /*  252117 */     // GIR_Coverage, 5443,
     /*  252117 */     GIR_EraseRootFromParent_Done,
     /*  252118 */   // Label 4857: @252118
     /*  252118 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252181), // Rule ID 5444 //
     /*  252123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252179 */     GIR_RootConstrainSelectedInstOperands,
     /*  252180 */     // GIR_Coverage, 5444,
     /*  252180 */     GIR_EraseRootFromParent_Done,
     /*  252181 */   // Label 4858: @252181
     /*  252181 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252244), // Rule ID 5445 //
     /*  252186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252242 */     GIR_RootConstrainSelectedInstOperands,
     /*  252243 */     // GIR_Coverage, 5445,
     /*  252243 */     GIR_EraseRootFromParent_Done,
     /*  252244 */   // Label 4859: @252244
     /*  252244 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252307), // Rule ID 5446 //
     /*  252249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252288 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252305 */     GIR_RootConstrainSelectedInstOperands,
     /*  252306 */     // GIR_Coverage, 5446,
     /*  252306 */     GIR_EraseRootFromParent_Done,
     /*  252307 */   // Label 4860: @252307
     /*  252307 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252370), // Rule ID 5447 //
     /*  252312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252351 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252368 */     GIR_RootConstrainSelectedInstOperands,
     /*  252369 */     // GIR_Coverage, 5447,
     /*  252369 */     GIR_EraseRootFromParent_Done,
     /*  252370 */   // Label 4861: @252370
     /*  252370 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252433), // Rule ID 5448 //
     /*  252375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252414 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252431 */     GIR_RootConstrainSelectedInstOperands,
     /*  252432 */     // GIR_Coverage, 5448,
     /*  252432 */     GIR_EraseRootFromParent_Done,
     /*  252433 */   // Label 4862: @252433
     /*  252433 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252496), // Rule ID 5449 //
     /*  252438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252477 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252494 */     GIR_RootConstrainSelectedInstOperands,
     /*  252495 */     // GIR_Coverage, 5449,
     /*  252495 */     GIR_EraseRootFromParent_Done,
     /*  252496 */   // Label 4863: @252496
     /*  252496 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252559), // Rule ID 5450 //
     /*  252501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252557 */     GIR_RootConstrainSelectedInstOperands,
     /*  252558 */     // GIR_Coverage, 5450,
     /*  252558 */     GIR_EraseRootFromParent_Done,
     /*  252559 */   // Label 4864: @252559
     /*  252559 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252622), // Rule ID 5451 //
     /*  252564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252620 */     GIR_RootConstrainSelectedInstOperands,
     /*  252621 */     // GIR_Coverage, 5451,
     /*  252621 */     GIR_EraseRootFromParent_Done,
     /*  252622 */   // Label 4865: @252622
     /*  252622 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252685), // Rule ID 5452 //
     /*  252627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252683 */     GIR_RootConstrainSelectedInstOperands,
     /*  252684 */     // GIR_Coverage, 5452,
     /*  252684 */     GIR_EraseRootFromParent_Done,
     /*  252685 */   // Label 4866: @252685
     /*  252685 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252748), // Rule ID 5453 //
     /*  252690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252746 */     GIR_RootConstrainSelectedInstOperands,
     /*  252747 */     // GIR_Coverage, 5453,
     /*  252747 */     GIR_EraseRootFromParent_Done,
     /*  252748 */   // Label 4867: @252748
     /*  252748 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252811), // Rule ID 5454 //
     /*  252753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252809 */     GIR_RootConstrainSelectedInstOperands,
     /*  252810 */     // GIR_Coverage, 5454,
     /*  252810 */     GIR_EraseRootFromParent_Done,
     /*  252811 */   // Label 4868: @252811
     /*  252811 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252874), // Rule ID 5455 //
     /*  252816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252855 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252872 */     GIR_RootConstrainSelectedInstOperands,
     /*  252873 */     // GIR_Coverage, 5455,
     /*  252873 */     GIR_EraseRootFromParent_Done,
     /*  252874 */   // Label 4869: @252874
     /*  252874 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252937), // Rule ID 5456 //
     /*  252879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252935 */     GIR_RootConstrainSelectedInstOperands,
     /*  252936 */     // GIR_Coverage, 5456,
     /*  252936 */     GIR_EraseRootFromParent_Done,
     /*  252937 */   // Label 4870: @252937
     /*  252937 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(253000), // Rule ID 5457 //
     /*  252942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252981 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252998 */     GIR_RootConstrainSelectedInstOperands,
     /*  252999 */     // GIR_Coverage, 5457,
     /*  252999 */     GIR_EraseRootFromParent_Done,
     /*  253000 */   // Label 4871: @253000
     /*  253000 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(253063), // Rule ID 5458 //
     /*  253005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253061 */     GIR_RootConstrainSelectedInstOperands,
     /*  253062 */     // GIR_Coverage, 5458,
     /*  253062 */     GIR_EraseRootFromParent_Done,
     /*  253063 */   // Label 4872: @253063
     /*  253063 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253126), // Rule ID 5459 //
     /*  253068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253124 */     GIR_RootConstrainSelectedInstOperands,
     /*  253125 */     // GIR_Coverage, 5459,
     /*  253125 */     GIR_EraseRootFromParent_Done,
     /*  253126 */   // Label 4873: @253126
     /*  253126 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253189), // Rule ID 5460 //
     /*  253131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253187 */     GIR_RootConstrainSelectedInstOperands,
     /*  253188 */     // GIR_Coverage, 5460,
     /*  253188 */     GIR_EraseRootFromParent_Done,
     /*  253189 */   // Label 4874: @253189
     /*  253189 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253252), // Rule ID 5461 //
     /*  253194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253233 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253250 */     GIR_RootConstrainSelectedInstOperands,
     /*  253251 */     // GIR_Coverage, 5461,
     /*  253251 */     GIR_EraseRootFromParent_Done,
     /*  253252 */   // Label 4875: @253252
     /*  253252 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253315), // Rule ID 5462 //
     /*  253257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  253299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253313 */     GIR_RootConstrainSelectedInstOperands,
     /*  253314 */     // GIR_Coverage, 5462,
     /*  253314 */     GIR_EraseRootFromParent_Done,
     /*  253315 */   // Label 4876: @253315
     /*  253315 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253378), // Rule ID 5463 //
     /*  253320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  253362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253376 */     GIR_RootConstrainSelectedInstOperands,
     /*  253377 */     // GIR_Coverage, 5463,
     /*  253377 */     GIR_EraseRootFromParent_Done,
     /*  253378 */   // Label 4877: @253378
     /*  253378 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253441), // Rule ID 5464 //
     /*  253383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253439 */     GIR_RootConstrainSelectedInstOperands,
     /*  253440 */     // GIR_Coverage, 5464,
     /*  253440 */     GIR_EraseRootFromParent_Done,
     /*  253441 */   // Label 4878: @253441
     /*  253441 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253504), // Rule ID 5465 //
     /*  253446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  253460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253502 */     GIR_RootConstrainSelectedInstOperands,
     /*  253503 */     // GIR_Coverage, 5465,
     /*  253503 */     GIR_EraseRootFromParent_Done,
     /*  253504 */   // Label 4879: @253504
     /*  253504 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253567), // Rule ID 5466 //
     /*  253509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253565 */     GIR_RootConstrainSelectedInstOperands,
     /*  253566 */     // GIR_Coverage, 5466,
     /*  253566 */     GIR_EraseRootFromParent_Done,
     /*  253567 */   // Label 4880: @253567
     /*  253567 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253630), // Rule ID 5467 //
     /*  253572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253628 */     GIR_RootConstrainSelectedInstOperands,
     /*  253629 */     // GIR_Coverage, 5467,
     /*  253629 */     GIR_EraseRootFromParent_Done,
     /*  253630 */   // Label 4881: @253630
     /*  253630 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253693), // Rule ID 5688 //
     /*  253635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253691 */     GIR_RootConstrainSelectedInstOperands,
     /*  253692 */     // GIR_Coverage, 5688,
     /*  253692 */     GIR_EraseRootFromParent_Done,
     /*  253693 */   // Label 4882: @253693
     /*  253693 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253756), // Rule ID 5689 //
     /*  253698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253754 */     GIR_RootConstrainSelectedInstOperands,
     /*  253755 */     // GIR_Coverage, 5689,
     /*  253755 */     GIR_EraseRootFromParent_Done,
     /*  253756 */   // Label 4883: @253756
     /*  253756 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253819), // Rule ID 5690 //
     /*  253761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253817 */     GIR_RootConstrainSelectedInstOperands,
     /*  253818 */     // GIR_Coverage, 5690,
     /*  253818 */     GIR_EraseRootFromParent_Done,
     /*  253819 */   // Label 4884: @253819
     /*  253819 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253882), // Rule ID 5691 //
     /*  253824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253863 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253880 */     GIR_RootConstrainSelectedInstOperands,
     /*  253881 */     // GIR_Coverage, 5691,
     /*  253881 */     GIR_EraseRootFromParent_Done,
     /*  253882 */   // Label 4885: @253882
     /*  253882 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253945), // Rule ID 5692 //
     /*  253887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253943 */     GIR_RootConstrainSelectedInstOperands,
     /*  253944 */     // GIR_Coverage, 5692,
     /*  253944 */     GIR_EraseRootFromParent_Done,
     /*  253945 */   // Label 4886: @253945
     /*  253945 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(254008), // Rule ID 5693 //
     /*  253950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253989 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254006 */     GIR_RootConstrainSelectedInstOperands,
     /*  254007 */     // GIR_Coverage, 5693,
     /*  254007 */     GIR_EraseRootFromParent_Done,
     /*  254008 */   // Label 4887: @254008
     /*  254008 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(254071), // Rule ID 5694 //
     /*  254013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  254055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254069 */     GIR_RootConstrainSelectedInstOperands,
     /*  254070 */     // GIR_Coverage, 5694,
     /*  254070 */     GIR_EraseRootFromParent_Done,
     /*  254071 */   // Label 4888: @254071
     /*  254071 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(254134), // Rule ID 5695 //
     /*  254076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  254093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  254118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254132 */     GIR_RootConstrainSelectedInstOperands,
     /*  254133 */     // GIR_Coverage, 5695,
     /*  254133 */     GIR_EraseRootFromParent_Done,
     /*  254134 */   // Label 4889: @254134
     /*  254134 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(254197), // Rule ID 5696 //
     /*  254139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254195 */     GIR_RootConstrainSelectedInstOperands,
     /*  254196 */     // GIR_Coverage, 5696,
     /*  254196 */     GIR_EraseRootFromParent_Done,
     /*  254197 */   // Label 4890: @254197
     /*  254197 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(254260), // Rule ID 5697 //
     /*  254202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  254219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254258 */     GIR_RootConstrainSelectedInstOperands,
     /*  254259 */     // GIR_Coverage, 5697,
     /*  254259 */     GIR_EraseRootFromParent_Done,
     /*  254260 */   // Label 4891: @254260
     /*  254260 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(254323), // Rule ID 5698 //
     /*  254265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  254282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254321 */     GIR_RootConstrainSelectedInstOperands,
     /*  254322 */     // GIR_Coverage, 5698,
     /*  254322 */     GIR_EraseRootFromParent_Done,
     /*  254323 */   // Label 4892: @254323
     /*  254323 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(254386), // Rule ID 5699 //
     /*  254328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  254345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  254370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254384 */     GIR_RootConstrainSelectedInstOperands,
     /*  254385 */     // GIR_Coverage, 5699,
     /*  254385 */     GIR_EraseRootFromParent_Done,
     /*  254386 */   // Label 4893: @254386
     /*  254386 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(254449), // Rule ID 5700 //
     /*  254391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254447 */     GIR_RootConstrainSelectedInstOperands,
     /*  254448 */     // GIR_Coverage, 5700,
     /*  254448 */     GIR_EraseRootFromParent_Done,
     /*  254449 */   // Label 4894: @254449
     /*  254449 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254512), // Rule ID 5701 //
     /*  254454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254493 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254510 */     GIR_RootConstrainSelectedInstOperands,
     /*  254511 */     // GIR_Coverage, 5701,
     /*  254511 */     GIR_EraseRootFromParent_Done,
     /*  254512 */   // Label 4895: @254512
     /*  254512 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254575), // Rule ID 5702 //
     /*  254517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254573 */     GIR_RootConstrainSelectedInstOperands,
     /*  254574 */     // GIR_Coverage, 5702,
     /*  254574 */     GIR_EraseRootFromParent_Done,
     /*  254575 */   // Label 4896: @254575
     /*  254575 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254638), // Rule ID 5703 //
     /*  254580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254636 */     GIR_RootConstrainSelectedInstOperands,
     /*  254637 */     // GIR_Coverage, 5703,
     /*  254637 */     GIR_EraseRootFromParent_Done,
     /*  254638 */   // Label 4897: @254638
     /*  254638 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254701), // Rule ID 5704 //
     /*  254643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254699 */     GIR_RootConstrainSelectedInstOperands,
     /*  254700 */     // GIR_Coverage, 5704,
     /*  254700 */     GIR_EraseRootFromParent_Done,
     /*  254701 */   // Label 4898: @254701
     /*  254701 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254764), // Rule ID 5705 //
     /*  254706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254745 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254762 */     GIR_RootConstrainSelectedInstOperands,
     /*  254763 */     // GIR_Coverage, 5705,
     /*  254763 */     GIR_EraseRootFromParent_Done,
     /*  254764 */   // Label 4899: @254764
     /*  254764 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254827), // Rule ID 5706 //
     /*  254769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254825 */     GIR_RootConstrainSelectedInstOperands,
     /*  254826 */     // GIR_Coverage, 5706,
     /*  254826 */     GIR_EraseRootFromParent_Done,
     /*  254827 */   // Label 4900: @254827
     /*  254827 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254890), // Rule ID 5707 //
     /*  254832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254871 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254888 */     GIR_RootConstrainSelectedInstOperands,
     /*  254889 */     // GIR_Coverage, 5707,
     /*  254889 */     GIR_EraseRootFromParent_Done,
     /*  254890 */   // Label 4901: @254890
     /*  254890 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254953), // Rule ID 5708 //
     /*  254895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254951 */     GIR_RootConstrainSelectedInstOperands,
     /*  254952 */     // GIR_Coverage, 5708,
     /*  254952 */     GIR_EraseRootFromParent_Done,
     /*  254953 */   // Label 4902: @254953
     /*  254953 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(255016), // Rule ID 5709 //
     /*  254958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254997 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255014 */     GIR_RootConstrainSelectedInstOperands,
     /*  255015 */     // GIR_Coverage, 5709,
     /*  255015 */     GIR_EraseRootFromParent_Done,
     /*  255016 */   // Label 4903: @255016
     /*  255016 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(255079), // Rule ID 5710 //
     /*  255021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  255038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255077 */     GIR_RootConstrainSelectedInstOperands,
     /*  255078 */     // GIR_Coverage, 5710,
     /*  255078 */     GIR_EraseRootFromParent_Done,
     /*  255079 */   // Label 4904: @255079
     /*  255079 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(255142), // Rule ID 5711 //
     /*  255084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  255101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255140 */     GIR_RootConstrainSelectedInstOperands,
     /*  255141 */     // GIR_Coverage, 5711,
     /*  255141 */     GIR_EraseRootFromParent_Done,
     /*  255142 */   // Label 4905: @255142
     /*  255142 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(255205), // Rule ID 5712 //
     /*  255147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  255164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255186 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255203 */     GIR_RootConstrainSelectedInstOperands,
     /*  255204 */     // GIR_Coverage, 5712,
     /*  255204 */     GIR_EraseRootFromParent_Done,
     /*  255205 */   // Label 4906: @255205
     /*  255205 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(255268), // Rule ID 5713 //
     /*  255210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  255227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255249 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255266 */     GIR_RootConstrainSelectedInstOperands,
     /*  255267 */     // GIR_Coverage, 5713,
     /*  255267 */     GIR_EraseRootFromParent_Done,
     /*  255268 */   // Label 4907: @255268
     /*  255268 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(255331), // Rule ID 5714 //
     /*  255273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255329 */     GIR_RootConstrainSelectedInstOperands,
     /*  255330 */     // GIR_Coverage, 5714,
     /*  255330 */     GIR_EraseRootFromParent_Done,
     /*  255331 */   // Label 4908: @255331
     /*  255331 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(255394), // Rule ID 5715 //
     /*  255336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  255353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255392 */     GIR_RootConstrainSelectedInstOperands,
     /*  255393 */     // GIR_Coverage, 5715,
     /*  255393 */     GIR_EraseRootFromParent_Done,
     /*  255394 */   // Label 4909: @255394
     /*  255394 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(255457), // Rule ID 5716 //
     /*  255399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255455 */     GIR_RootConstrainSelectedInstOperands,
     /*  255456 */     // GIR_Coverage, 5716,
     /*  255456 */     GIR_EraseRootFromParent_Done,
     /*  255457 */   // Label 4910: @255457
     /*  255457 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(255520), // Rule ID 5717 //
     /*  255462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255518 */     GIR_RootConstrainSelectedInstOperands,
     /*  255519 */     // GIR_Coverage, 5717,
     /*  255519 */     GIR_EraseRootFromParent_Done,
     /*  255520 */   // Label 4911: @255520
     /*  255520 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(255583), // Rule ID 5718 //
     /*  255525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255564 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255581 */     GIR_RootConstrainSelectedInstOperands,
     /*  255582 */     // GIR_Coverage, 5718,
     /*  255582 */     GIR_EraseRootFromParent_Done,
     /*  255583 */   // Label 4912: @255583
     /*  255583 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(255646), // Rule ID 5719 //
     /*  255588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255627 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255644 */     GIR_RootConstrainSelectedInstOperands,
     /*  255645 */     // GIR_Coverage, 5719,
     /*  255645 */     GIR_EraseRootFromParent_Done,
     /*  255646 */   // Label 4913: @255646
     /*  255646 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(255709), // Rule ID 5720 //
     /*  255651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255707 */     GIR_RootConstrainSelectedInstOperands,
     /*  255708 */     // GIR_Coverage, 5720,
     /*  255708 */     GIR_EraseRootFromParent_Done,
     /*  255709 */   // Label 4914: @255709
     /*  255709 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(255772), // Rule ID 5721 //
     /*  255714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255770 */     GIR_RootConstrainSelectedInstOperands,
     /*  255771 */     // GIR_Coverage, 5721,
     /*  255771 */     GIR_EraseRootFromParent_Done,
     /*  255772 */   // Label 4915: @255772
     /*  255772 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(255835), // Rule ID 5722 //
     /*  255777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255833 */     GIR_RootConstrainSelectedInstOperands,
     /*  255834 */     // GIR_Coverage, 5722,
     /*  255834 */     GIR_EraseRootFromParent_Done,
     /*  255835 */   // Label 4916: @255835
     /*  255835 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(255898), // Rule ID 5723 //
     /*  255840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255896 */     GIR_RootConstrainSelectedInstOperands,
     /*  255897 */     // GIR_Coverage, 5723,
     /*  255897 */     GIR_EraseRootFromParent_Done,
     /*  255898 */   // Label 4917: @255898
     /*  255898 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255961), // Rule ID 5724 //
     /*  255903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255959 */     GIR_RootConstrainSelectedInstOperands,
     /*  255960 */     // GIR_Coverage, 5724,
     /*  255960 */     GIR_EraseRootFromParent_Done,
     /*  255961 */   // Label 4918: @255961
     /*  255961 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(256024), // Rule ID 5725 //
     /*  255966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256005 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256022 */     GIR_RootConstrainSelectedInstOperands,
     /*  256023 */     // GIR_Coverage, 5725,
     /*  256023 */     GIR_EraseRootFromParent_Done,
     /*  256024 */   // Label 4919: @256024
     /*  256024 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(256087), // Rule ID 5726 //
     /*  256029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  256046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  256071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256085 */     GIR_RootConstrainSelectedInstOperands,
     /*  256086 */     // GIR_Coverage, 5726,
     /*  256086 */     GIR_EraseRootFromParent_Done,
     /*  256087 */   // Label 4920: @256087
     /*  256087 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(256150), // Rule ID 5727 //
     /*  256092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  256109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  256134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256148 */     GIR_RootConstrainSelectedInstOperands,
     /*  256149 */     // GIR_Coverage, 5727,
     /*  256149 */     GIR_EraseRootFromParent_Done,
     /*  256150 */   // Label 4921: @256150
     /*  256150 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(256213), // Rule ID 5728 //
     /*  256155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  256172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  256197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256211 */     GIR_RootConstrainSelectedInstOperands,
     /*  256212 */     // GIR_Coverage, 5728,
     /*  256212 */     GIR_EraseRootFromParent_Done,
     /*  256213 */   // Label 4922: @256213
     /*  256213 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(256276), // Rule ID 5729 //
     /*  256218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  256235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  256260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256274 */     GIR_RootConstrainSelectedInstOperands,
     /*  256275 */     // GIR_Coverage, 5729,
     /*  256275 */     GIR_EraseRootFromParent_Done,
     /*  256276 */   // Label 4923: @256276
     /*  256276 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(256339), // Rule ID 5730 //
     /*  256281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  256298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256337 */     GIR_RootConstrainSelectedInstOperands,
     /*  256338 */     // GIR_Coverage, 5730,
     /*  256338 */     GIR_EraseRootFromParent_Done,
     /*  256339 */   // Label 4924: @256339
     /*  256339 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(256402), // Rule ID 5731 //
     /*  256344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  256361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  256386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256400 */     GIR_RootConstrainSelectedInstOperands,
     /*  256401 */     // GIR_Coverage, 5731,
     /*  256401 */     GIR_EraseRootFromParent_Done,
     /*  256402 */   // Label 4925: @256402
     /*  256402 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(256465), // Rule ID 5732 //
     /*  256407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256446 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256463 */     GIR_RootConstrainSelectedInstOperands,
     /*  256464 */     // GIR_Coverage, 5732,
     /*  256464 */     GIR_EraseRootFromParent_Done,
     /*  256465 */   // Label 4926: @256465
     /*  256465 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(256528), // Rule ID 5733 //
     /*  256470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256509 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256526 */     GIR_RootConstrainSelectedInstOperands,
     /*  256527 */     // GIR_Coverage, 5733,
     /*  256527 */     GIR_EraseRootFromParent_Done,
     /*  256528 */   // Label 4927: @256528
     /*  256528 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(256591), // Rule ID 5734 //
     /*  256533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256589 */     GIR_RootConstrainSelectedInstOperands,
     /*  256590 */     // GIR_Coverage, 5734,
     /*  256590 */     GIR_EraseRootFromParent_Done,
     /*  256591 */   // Label 4928: @256591
     /*  256591 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(256654), // Rule ID 5735 //
     /*  256596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256652 */     GIR_RootConstrainSelectedInstOperands,
     /*  256653 */     // GIR_Coverage, 5735,
     /*  256653 */     GIR_EraseRootFromParent_Done,
     /*  256654 */   // Label 4929: @256654
     /*  256654 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(256717), // Rule ID 5736 //
     /*  256659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256715 */     GIR_RootConstrainSelectedInstOperands,
     /*  256716 */     // GIR_Coverage, 5736,
     /*  256716 */     GIR_EraseRootFromParent_Done,
     /*  256717 */   // Label 4930: @256717
     /*  256717 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(256780), // Rule ID 5737 //
     /*  256722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256761 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256778 */     GIR_RootConstrainSelectedInstOperands,
     /*  256779 */     // GIR_Coverage, 5737,
     /*  256779 */     GIR_EraseRootFromParent_Done,
     /*  256780 */   // Label 4931: @256780
     /*  256780 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(256843), // Rule ID 5738 //
     /*  256785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256841 */     GIR_RootConstrainSelectedInstOperands,
     /*  256842 */     // GIR_Coverage, 5738,
     /*  256842 */     GIR_EraseRootFromParent_Done,
     /*  256843 */   // Label 4932: @256843
     /*  256843 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(256906), // Rule ID 5739 //
     /*  256848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256904 */     GIR_RootConstrainSelectedInstOperands,
     /*  256905 */     // GIR_Coverage, 5739,
     /*  256905 */     GIR_EraseRootFromParent_Done,
     /*  256906 */   // Label 4933: @256906
     /*  256906 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(256969), // Rule ID 5740 //
     /*  256911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256967 */     GIR_RootConstrainSelectedInstOperands,
     /*  256968 */     // GIR_Coverage, 5740,
     /*  256968 */     GIR_EraseRootFromParent_Done,
     /*  256969 */   // Label 4934: @256969
     /*  256969 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(257032), // Rule ID 5741 //
     /*  256974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257030 */     GIR_RootConstrainSelectedInstOperands,
     /*  257031 */     // GIR_Coverage, 5741,
     /*  257031 */     GIR_EraseRootFromParent_Done,
     /*  257032 */   // Label 4935: @257032
     /*  257032 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(257095), // Rule ID 5742 //
     /*  257037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257093 */     GIR_RootConstrainSelectedInstOperands,
     /*  257094 */     // GIR_Coverage, 5742,
     /*  257094 */     GIR_EraseRootFromParent_Done,
     /*  257095 */   // Label 4936: @257095
     /*  257095 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(257158), // Rule ID 5743 //
     /*  257100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  257142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257156 */     GIR_RootConstrainSelectedInstOperands,
     /*  257157 */     // GIR_Coverage, 5743,
     /*  257157 */     GIR_EraseRootFromParent_Done,
     /*  257158 */   // Label 4937: @257158
     /*  257158 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(257221), // Rule ID 5744 //
     /*  257163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257219 */     GIR_RootConstrainSelectedInstOperands,
     /*  257220 */     // GIR_Coverage, 5744,
     /*  257220 */     GIR_EraseRootFromParent_Done,
     /*  257221 */   // Label 4938: @257221
     /*  257221 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(257284), // Rule ID 5745 //
     /*  257226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257265 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257282 */     GIR_RootConstrainSelectedInstOperands,
     /*  257283 */     // GIR_Coverage, 5745,
     /*  257283 */     GIR_EraseRootFromParent_Done,
     /*  257284 */   // Label 4939: @257284
     /*  257284 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(257347), // Rule ID 5746 //
     /*  257289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257345 */     GIR_RootConstrainSelectedInstOperands,
     /*  257346 */     // GIR_Coverage, 5746,
     /*  257346 */     GIR_EraseRootFromParent_Done,
     /*  257347 */   // Label 4940: @257347
     /*  257347 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(257410), // Rule ID 5747 //
     /*  257352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257408 */     GIR_RootConstrainSelectedInstOperands,
     /*  257409 */     // GIR_Coverage, 5747,
     /*  257409 */     GIR_EraseRootFromParent_Done,
     /*  257410 */   // Label 4941: @257410
     /*  257410 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(257473), // Rule ID 5748 //
     /*  257415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257471 */     GIR_RootConstrainSelectedInstOperands,
     /*  257472 */     // GIR_Coverage, 5748,
     /*  257472 */     GIR_EraseRootFromParent_Done,
     /*  257473 */   // Label 4942: @257473
     /*  257473 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(257536), // Rule ID 5749 //
     /*  257478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257517 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257534 */     GIR_RootConstrainSelectedInstOperands,
     /*  257535 */     // GIR_Coverage, 5749,
     /*  257535 */     GIR_EraseRootFromParent_Done,
     /*  257536 */   // Label 4943: @257536
     /*  257536 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(257599), // Rule ID 5750 //
     /*  257541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257597 */     GIR_RootConstrainSelectedInstOperands,
     /*  257598 */     // GIR_Coverage, 5750,
     /*  257598 */     GIR_EraseRootFromParent_Done,
     /*  257599 */   // Label 4944: @257599
     /*  257599 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(257662), // Rule ID 5751 //
     /*  257604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  257607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257643 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  257643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257660 */     GIR_RootConstrainSelectedInstOperands,
     /*  257661 */     // GIR_Coverage, 5751,
     /*  257661 */     GIR_EraseRootFromParent_Done,
     /*  257662 */   // Label 4945: @257662
     /*  257662 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(257725), // Rule ID 5752 //
     /*  257667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257723 */     GIR_RootConstrainSelectedInstOperands,
     /*  257724 */     // GIR_Coverage, 5752,
     /*  257724 */     GIR_EraseRootFromParent_Done,
     /*  257725 */   // Label 4946: @257725
     /*  257725 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(257788), // Rule ID 5753 //
     /*  257730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257769 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257786 */     GIR_RootConstrainSelectedInstOperands,
     /*  257787 */     // GIR_Coverage, 5753,
     /*  257787 */     GIR_EraseRootFromParent_Done,
     /*  257788 */   // Label 4947: @257788
     /*  257788 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(257851), // Rule ID 5754 //
     /*  257793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257832 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257849 */     GIR_RootConstrainSelectedInstOperands,
     /*  257850 */     // GIR_Coverage, 5754,
     /*  257850 */     GIR_EraseRootFromParent_Done,
     /*  257851 */   // Label 4948: @257851
     /*  257851 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(257914), // Rule ID 5755 //
     /*  257856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257895 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257912 */     GIR_RootConstrainSelectedInstOperands,
     /*  257913 */     // GIR_Coverage, 5755,
     /*  257913 */     GIR_EraseRootFromParent_Done,
     /*  257914 */   // Label 4949: @257914
     /*  257914 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(257977), // Rule ID 5756 //
     /*  257919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257958 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257975 */     GIR_RootConstrainSelectedInstOperands,
     /*  257976 */     // GIR_Coverage, 5756,
     /*  257976 */     GIR_EraseRootFromParent_Done,
     /*  257977 */   // Label 4950: @257977
     /*  257977 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(258040), // Rule ID 5757 //
     /*  257982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258021 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258038 */     GIR_RootConstrainSelectedInstOperands,
     /*  258039 */     // GIR_Coverage, 5757,
     /*  258039 */     GIR_EraseRootFromParent_Done,
     /*  258040 */   // Label 4951: @258040
     /*  258040 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(258103), // Rule ID 5758 //
     /*  258045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258101 */     GIR_RootConstrainSelectedInstOperands,
     /*  258102 */     // GIR_Coverage, 5758,
     /*  258102 */     GIR_EraseRootFromParent_Done,
     /*  258103 */   // Label 4952: @258103
     /*  258103 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(258166), // Rule ID 5759 //
     /*  258108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258164 */     GIR_RootConstrainSelectedInstOperands,
     /*  258165 */     // GIR_Coverage, 5759,
     /*  258165 */     GIR_EraseRootFromParent_Done,
     /*  258166 */   // Label 4953: @258166
     /*  258166 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(258229), // Rule ID 5760 //
     /*  258171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258227 */     GIR_RootConstrainSelectedInstOperands,
     /*  258228 */     // GIR_Coverage, 5760,
     /*  258228 */     GIR_EraseRootFromParent_Done,
     /*  258229 */   // Label 4954: @258229
     /*  258229 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(258292), // Rule ID 5761 //
     /*  258234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258290 */     GIR_RootConstrainSelectedInstOperands,
     /*  258291 */     // GIR_Coverage, 5761,
     /*  258291 */     GIR_EraseRootFromParent_Done,
     /*  258292 */   // Label 4955: @258292
     /*  258292 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(258355), // Rule ID 5762 //
     /*  258297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258353 */     GIR_RootConstrainSelectedInstOperands,
     /*  258354 */     // GIR_Coverage, 5762,
     /*  258354 */     GIR_EraseRootFromParent_Done,
     /*  258355 */   // Label 4956: @258355
     /*  258355 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(258418), // Rule ID 5763 //
     /*  258360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258399 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258416 */     GIR_RootConstrainSelectedInstOperands,
     /*  258417 */     // GIR_Coverage, 5763,
     /*  258417 */     GIR_EraseRootFromParent_Done,
     /*  258418 */   // Label 4957: @258418
     /*  258418 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(258481), // Rule ID 5764 //
     /*  258423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258479 */     GIR_RootConstrainSelectedInstOperands,
     /*  258480 */     // GIR_Coverage, 5764,
     /*  258480 */     GIR_EraseRootFromParent_Done,
     /*  258481 */   // Label 4958: @258481
     /*  258481 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(258544), // Rule ID 5765 //
     /*  258486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258542 */     GIR_RootConstrainSelectedInstOperands,
     /*  258543 */     // GIR_Coverage, 5765,
     /*  258543 */     GIR_EraseRootFromParent_Done,
     /*  258544 */   // Label 4959: @258544
     /*  258544 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(258607), // Rule ID 5766 //
     /*  258549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258605 */     GIR_RootConstrainSelectedInstOperands,
     /*  258606 */     // GIR_Coverage, 5766,
     /*  258606 */     GIR_EraseRootFromParent_Done,
     /*  258607 */   // Label 4960: @258607
     /*  258607 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(258670), // Rule ID 5767 //
     /*  258612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258668 */     GIR_RootConstrainSelectedInstOperands,
     /*  258669 */     // GIR_Coverage, 5767,
     /*  258669 */     GIR_EraseRootFromParent_Done,
     /*  258670 */   // Label 4961: @258670
     /*  258670 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(258733), // Rule ID 5768 //
     /*  258675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258731 */     GIR_RootConstrainSelectedInstOperands,
     /*  258732 */     // GIR_Coverage, 5768,
     /*  258732 */     GIR_EraseRootFromParent_Done,
     /*  258733 */   // Label 4962: @258733
     /*  258733 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(258796), // Rule ID 5769 //
     /*  258738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258777 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258794 */     GIR_RootConstrainSelectedInstOperands,
     /*  258795 */     // GIR_Coverage, 5769,
     /*  258795 */     GIR_EraseRootFromParent_Done,
     /*  258796 */   // Label 4963: @258796
     /*  258796 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(258859), // Rule ID 5770 //
     /*  258801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258857 */     GIR_RootConstrainSelectedInstOperands,
     /*  258858 */     // GIR_Coverage, 5770,
     /*  258858 */     GIR_EraseRootFromParent_Done,
     /*  258859 */   // Label 4964: @258859
     /*  258859 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(258922), // Rule ID 5771 //
     /*  258864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258920 */     GIR_RootConstrainSelectedInstOperands,
     /*  258921 */     // GIR_Coverage, 5771,
     /*  258921 */     GIR_EraseRootFromParent_Done,
     /*  258922 */   // Label 4965: @258922
     /*  258922 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(258985), // Rule ID 5772 //
     /*  258927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258983 */     GIR_RootConstrainSelectedInstOperands,
     /*  258984 */     // GIR_Coverage, 5772,
     /*  258984 */     GIR_EraseRootFromParent_Done,
     /*  258985 */   // Label 4966: @258985
     /*  258985 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(259048), // Rule ID 5773 //
     /*  258990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259029 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  259032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259046 */     GIR_RootConstrainSelectedInstOperands,
     /*  259047 */     // GIR_Coverage, 5773,
     /*  259047 */     GIR_EraseRootFromParent_Done,
     /*  259048 */   // Label 4967: @259048
     /*  259048 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(259111), // Rule ID 5774 //
     /*  259053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  259095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259109 */     GIR_RootConstrainSelectedInstOperands,
     /*  259110 */     // GIR_Coverage, 5774,
     /*  259110 */     GIR_EraseRootFromParent_Done,
     /*  259111 */   // Label 4968: @259111
     /*  259111 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(259174), // Rule ID 5775 //
     /*  259116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259155 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  259158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259172 */     GIR_RootConstrainSelectedInstOperands,
     /*  259173 */     // GIR_Coverage, 5775,
     /*  259173 */     GIR_EraseRootFromParent_Done,
     /*  259174 */   // Label 4969: @259174
     /*  259174 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(259237), // Rule ID 7808 //
     /*  259179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  259196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259235 */     GIR_RootConstrainSelectedInstOperands,
     /*  259236 */     // GIR_Coverage, 7808,
     /*  259236 */     GIR_EraseRootFromParent_Done,
     /*  259237 */   // Label 4970: @259237
     /*  259237 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(259300), // Rule ID 7809 //
     /*  259242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  259259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259298 */     GIR_RootConstrainSelectedInstOperands,
     /*  259299 */     // GIR_Coverage, 7809,
     /*  259299 */     GIR_EraseRootFromParent_Done,
     /*  259300 */   // Label 4971: @259300
     /*  259300 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(259363), // Rule ID 7812 //
     /*  259305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  259319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  259322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259361 */     GIR_RootConstrainSelectedInstOperands,
     /*  259362 */     // GIR_Coverage, 7812,
     /*  259362 */     GIR_EraseRootFromParent_Done,
     /*  259363 */   // Label 4972: @259363
     /*  259363 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(259426), // Rule ID 7813 //
     /*  259368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  259382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  259385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259424 */     GIR_RootConstrainSelectedInstOperands,
     /*  259425 */     // GIR_Coverage, 7813,
     /*  259425 */     GIR_EraseRootFromParent_Done,
     /*  259426 */   // Label 4973: @259426
     /*  259426 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(259489), // Rule ID 7816 //
     /*  259431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259487 */     GIR_RootConstrainSelectedInstOperands,
     /*  259488 */     // GIR_Coverage, 7816,
     /*  259488 */     GIR_EraseRootFromParent_Done,
     /*  259489 */   // Label 4974: @259489
     /*  259489 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(259552), // Rule ID 7817 //
     /*  259494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259533 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259550 */     GIR_RootConstrainSelectedInstOperands,
     /*  259551 */     // GIR_Coverage, 7817,
     /*  259551 */     GIR_EraseRootFromParent_Done,
     /*  259552 */   // Label 4975: @259552
     /*  259552 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(259615), // Rule ID 7820 //
     /*  259557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259613 */     GIR_RootConstrainSelectedInstOperands,
     /*  259614 */     // GIR_Coverage, 7820,
     /*  259614 */     GIR_EraseRootFromParent_Done,
     /*  259615 */   // Label 4976: @259615
     /*  259615 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(259678), // Rule ID 7821 //
     /*  259620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259676 */     GIR_RootConstrainSelectedInstOperands,
     /*  259677 */     // GIR_Coverage, 7821,
     /*  259677 */     GIR_EraseRootFromParent_Done,
     /*  259678 */   // Label 4977: @259678
     /*  259678 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(259741), // Rule ID 7824 //
     /*  259683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259739 */     GIR_RootConstrainSelectedInstOperands,
     /*  259740 */     // GIR_Coverage, 7824,
     /*  259740 */     GIR_EraseRootFromParent_Done,
     /*  259741 */   // Label 4978: @259741
     /*  259741 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(259804), // Rule ID 7825 //
     /*  259746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259802 */     GIR_RootConstrainSelectedInstOperands,
     /*  259803 */     // GIR_Coverage, 7825,
     /*  259803 */     GIR_EraseRootFromParent_Done,
     /*  259804 */   // Label 4979: @259804
     /*  259804 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(259867), // Rule ID 7828 //
     /*  259809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259865 */     GIR_RootConstrainSelectedInstOperands,
     /*  259866 */     // GIR_Coverage, 7828,
     /*  259866 */     GIR_EraseRootFromParent_Done,
     /*  259867 */   // Label 4980: @259867
     /*  259867 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(259930), // Rule ID 7829 //
     /*  259872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259928 */     GIR_RootConstrainSelectedInstOperands,
     /*  259929 */     // GIR_Coverage, 7829,
     /*  259929 */     GIR_EraseRootFromParent_Done,
     /*  259930 */   // Label 4981: @259930
     /*  259930 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(259993), // Rule ID 7832 //
     /*  259935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259991 */     GIR_RootConstrainSelectedInstOperands,
     /*  259992 */     // GIR_Coverage, 7832,
     /*  259992 */     GIR_EraseRootFromParent_Done,
     /*  259993 */   // Label 4982: @259993
     /*  259993 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(260056), // Rule ID 7833 //
     /*  259998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  260015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260037 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260054 */     GIR_RootConstrainSelectedInstOperands,
     /*  260055 */     // GIR_Coverage, 7833,
     /*  260055 */     GIR_EraseRootFromParent_Done,
     /*  260056 */   // Label 4983: @260056
     /*  260056 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(260119), // Rule ID 7836 //
     /*  260061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260117 */     GIR_RootConstrainSelectedInstOperands,
     /*  260118 */     // GIR_Coverage, 7836,
     /*  260118 */     GIR_EraseRootFromParent_Done,
     /*  260119 */   // Label 4984: @260119
     /*  260119 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(260182), // Rule ID 7837 //
     /*  260124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  260141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260163 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260180 */     GIR_RootConstrainSelectedInstOperands,
     /*  260181 */     // GIR_Coverage, 7837,
     /*  260181 */     GIR_EraseRootFromParent_Done,
     /*  260182 */   // Label 4985: @260182
     /*  260182 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(260245), // Rule ID 7840 //
     /*  260187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260226 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260243 */     GIR_RootConstrainSelectedInstOperands,
     /*  260244 */     // GIR_Coverage, 7840,
     /*  260244 */     GIR_EraseRootFromParent_Done,
     /*  260245 */   // Label 4986: @260245
     /*  260245 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(260308), // Rule ID 7841 //
     /*  260250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  260267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260289 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  260289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  260292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260306 */     GIR_RootConstrainSelectedInstOperands,
     /*  260307 */     // GIR_Coverage, 7841,
     /*  260307 */     GIR_EraseRootFromParent_Done,
     /*  260308 */   // Label 4987: @260308
     /*  260308 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(260371), // Rule ID 7844 //
     /*  260313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  260327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  260330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260369 */     GIR_RootConstrainSelectedInstOperands,
     /*  260370 */     // GIR_Coverage, 7844,
     /*  260370 */     GIR_EraseRootFromParent_Done,
     /*  260371 */   // Label 4988: @260371
     /*  260371 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(260434), // Rule ID 7845 //
     /*  260376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  260390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  260393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260432 */     GIR_RootConstrainSelectedInstOperands,
     /*  260433 */     // GIR_Coverage, 7845,
     /*  260433 */     GIR_EraseRootFromParent_Done,
     /*  260434 */   // Label 4989: @260434
     /*  260434 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(260497), // Rule ID 7848 //
     /*  260439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260478 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260495 */     GIR_RootConstrainSelectedInstOperands,
     /*  260496 */     // GIR_Coverage, 7848,
     /*  260496 */     GIR_EraseRootFromParent_Done,
     /*  260497 */   // Label 4990: @260497
     /*  260497 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(260560), // Rule ID 7849 //
     /*  260502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260541 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260558 */     GIR_RootConstrainSelectedInstOperands,
     /*  260559 */     // GIR_Coverage, 7849,
     /*  260559 */     GIR_EraseRootFromParent_Done,
     /*  260560 */   // Label 4991: @260560
     /*  260560 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(260623), // Rule ID 7852 //
     /*  260565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260604 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260621 */     GIR_RootConstrainSelectedInstOperands,
     /*  260622 */     // GIR_Coverage, 7852,
     /*  260622 */     GIR_EraseRootFromParent_Done,
     /*  260623 */   // Label 4992: @260623
     /*  260623 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(260686), // Rule ID 7853 //
     /*  260628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260667 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260684 */     GIR_RootConstrainSelectedInstOperands,
     /*  260685 */     // GIR_Coverage, 7853,
     /*  260685 */     GIR_EraseRootFromParent_Done,
     /*  260686 */   // Label 4993: @260686
     /*  260686 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(260749), // Rule ID 7856 //
     /*  260691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260747 */     GIR_RootConstrainSelectedInstOperands,
     /*  260748 */     // GIR_Coverage, 7856,
     /*  260748 */     GIR_EraseRootFromParent_Done,
     /*  260749 */   // Label 4994: @260749
     /*  260749 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(260812), // Rule ID 7857 //
     /*  260754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260793 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260810 */     GIR_RootConstrainSelectedInstOperands,
     /*  260811 */     // GIR_Coverage, 7857,
     /*  260811 */     GIR_EraseRootFromParent_Done,
     /*  260812 */   // Label 4995: @260812
     /*  260812 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(260875), // Rule ID 7860 //
     /*  260817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260873 */     GIR_RootConstrainSelectedInstOperands,
     /*  260874 */     // GIR_Coverage, 7860,
     /*  260874 */     GIR_EraseRootFromParent_Done,
     /*  260875 */   // Label 4996: @260875
     /*  260875 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(260938), // Rule ID 7861 //
     /*  260880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260936 */     GIR_RootConstrainSelectedInstOperands,
     /*  260937 */     // GIR_Coverage, 7861,
     /*  260937 */     GIR_EraseRootFromParent_Done,
     /*  260938 */   // Label 4997: @260938
     /*  260938 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(261001), // Rule ID 7864 //
     /*  260943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260999 */     GIR_RootConstrainSelectedInstOperands,
     /*  261000 */     // GIR_Coverage, 7864,
     /*  261000 */     GIR_EraseRootFromParent_Done,
     /*  261001 */   // Label 4998: @261001
     /*  261001 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(261064), // Rule ID 7865 //
     /*  261006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  261023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261045 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261062 */     GIR_RootConstrainSelectedInstOperands,
     /*  261063 */     // GIR_Coverage, 7865,
     /*  261063 */     GIR_EraseRootFromParent_Done,
     /*  261064 */   // Label 4999: @261064
     /*  261064 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(261127), // Rule ID 7868 //
     /*  261069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  261086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261125 */     GIR_RootConstrainSelectedInstOperands,
     /*  261126 */     // GIR_Coverage, 7868,
     /*  261126 */     GIR_EraseRootFromParent_Done,
     /*  261127 */   // Label 5000: @261127
     /*  261127 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(261190), // Rule ID 7869 //
     /*  261132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  261149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261171 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261188 */     GIR_RootConstrainSelectedInstOperands,
     /*  261189 */     // GIR_Coverage, 7869,
     /*  261189 */     GIR_EraseRootFromParent_Done,
     /*  261190 */   // Label 5001: @261190
     /*  261190 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(261253), // Rule ID 7872 //
     /*  261195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261234 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261251 */     GIR_RootConstrainSelectedInstOperands,
     /*  261252 */     // GIR_Coverage, 7872,
     /*  261252 */     GIR_EraseRootFromParent_Done,
     /*  261253 */   // Label 5002: @261253
     /*  261253 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(261316), // Rule ID 7873 //
     /*  261258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  261275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261297 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261314 */     GIR_RootConstrainSelectedInstOperands,
     /*  261315 */     // GIR_Coverage, 7873,
     /*  261315 */     GIR_EraseRootFromParent_Done,
     /*  261316 */   // Label 5003: @261316
     /*  261316 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(261379), // Rule ID 7876 //
     /*  261321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  261335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261377 */     GIR_RootConstrainSelectedInstOperands,
     /*  261378 */     // GIR_Coverage, 7876,
     /*  261378 */     GIR_EraseRootFromParent_Done,
     /*  261379 */   // Label 5004: @261379
     /*  261379 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(261442), // Rule ID 7877 //
     /*  261384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  261398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  261401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261423 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261440 */     GIR_RootConstrainSelectedInstOperands,
     /*  261441 */     // GIR_Coverage, 7877,
     /*  261441 */     GIR_EraseRootFromParent_Done,
     /*  261442 */   // Label 5005: @261442
     /*  261442 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(261505), // Rule ID 7880 //
     /*  261447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261503 */     GIR_RootConstrainSelectedInstOperands,
     /*  261504 */     // GIR_Coverage, 7880,
     /*  261504 */     GIR_EraseRootFromParent_Done,
     /*  261505 */   // Label 5006: @261505
     /*  261505 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(261568), // Rule ID 7881 //
     /*  261510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261566 */     GIR_RootConstrainSelectedInstOperands,
     /*  261567 */     // GIR_Coverage, 7881,
     /*  261567 */     GIR_EraseRootFromParent_Done,
     /*  261568 */   // Label 5007: @261568
     /*  261568 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(261631), // Rule ID 7884 //
     /*  261573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261629 */     GIR_RootConstrainSelectedInstOperands,
     /*  261630 */     // GIR_Coverage, 7884,
     /*  261630 */     GIR_EraseRootFromParent_Done,
     /*  261631 */   // Label 5008: @261631
     /*  261631 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(261694), // Rule ID 7885 //
     /*  261636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261675 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261692 */     GIR_RootConstrainSelectedInstOperands,
     /*  261693 */     // GIR_Coverage, 7885,
     /*  261693 */     GIR_EraseRootFromParent_Done,
     /*  261694 */   // Label 5009: @261694
     /*  261694 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(261757), // Rule ID 7888 //
     /*  261699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261755 */     GIR_RootConstrainSelectedInstOperands,
     /*  261756 */     // GIR_Coverage, 7888,
     /*  261756 */     GIR_EraseRootFromParent_Done,
     /*  261757 */   // Label 5010: @261757
     /*  261757 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(261820), // Rule ID 7889 //
     /*  261762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261818 */     GIR_RootConstrainSelectedInstOperands,
     /*  261819 */     // GIR_Coverage, 7889,
     /*  261819 */     GIR_EraseRootFromParent_Done,
     /*  261820 */   // Label 5011: @261820
     /*  261820 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(261883), // Rule ID 7892 //
     /*  261825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261881 */     GIR_RootConstrainSelectedInstOperands,
     /*  261882 */     // GIR_Coverage, 7892,
     /*  261882 */     GIR_EraseRootFromParent_Done,
     /*  261883 */   // Label 5012: @261883
     /*  261883 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(261946), // Rule ID 7893 //
     /*  261888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261944 */     GIR_RootConstrainSelectedInstOperands,
     /*  261945 */     // GIR_Coverage, 7893,
     /*  261945 */     GIR_EraseRootFromParent_Done,
     /*  261946 */   // Label 5013: @261946
     /*  261946 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(262009), // Rule ID 7896 //
     /*  261951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262007 */     GIR_RootConstrainSelectedInstOperands,
     /*  262008 */     // GIR_Coverage, 7896,
     /*  262008 */     GIR_EraseRootFromParent_Done,
     /*  262009 */   // Label 5014: @262009
     /*  262009 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(262072), // Rule ID 7897 //
     /*  262014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262053 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262070 */     GIR_RootConstrainSelectedInstOperands,
     /*  262071 */     // GIR_Coverage, 7897,
     /*  262071 */     GIR_EraseRootFromParent_Done,
     /*  262072 */   // Label 5015: @262072
     /*  262072 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(262135), // Rule ID 7900 //
     /*  262077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262133 */     GIR_RootConstrainSelectedInstOperands,
     /*  262134 */     // GIR_Coverage, 7900,
     /*  262134 */     GIR_EraseRootFromParent_Done,
     /*  262135 */   // Label 5016: @262135
     /*  262135 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(262198), // Rule ID 7901 //
     /*  262140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262196 */     GIR_RootConstrainSelectedInstOperands,
     /*  262197 */     // GIR_Coverage, 7901,
     /*  262197 */     GIR_EraseRootFromParent_Done,
     /*  262198 */   // Label 5017: @262198
     /*  262198 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(262261), // Rule ID 7904 //
     /*  262203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262259 */     GIR_RootConstrainSelectedInstOperands,
     /*  262260 */     // GIR_Coverage, 7904,
     /*  262260 */     GIR_EraseRootFromParent_Done,
     /*  262261 */   // Label 5018: @262261
     /*  262261 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(262324), // Rule ID 7905 //
     /*  262266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  262308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262322 */     GIR_RootConstrainSelectedInstOperands,
     /*  262323 */     // GIR_Coverage, 7905,
     /*  262323 */     GIR_EraseRootFromParent_Done,
     /*  262324 */   // Label 5019: @262324
     /*  262324 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(262387), // Rule ID 7908 //
     /*  262329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262385 */     GIR_RootConstrainSelectedInstOperands,
     /*  262386 */     // GIR_Coverage, 7908,
     /*  262386 */     GIR_EraseRootFromParent_Done,
     /*  262387 */   // Label 5020: @262387
     /*  262387 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(262450), // Rule ID 7909 //
     /*  262392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262448 */     GIR_RootConstrainSelectedInstOperands,
     /*  262449 */     // GIR_Coverage, 7909,
     /*  262449 */     GIR_EraseRootFromParent_Done,
     /*  262450 */   // Label 5021: @262450
     /*  262450 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(262513), // Rule ID 7912 //
     /*  262455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262511 */     GIR_RootConstrainSelectedInstOperands,
     /*  262512 */     // GIR_Coverage, 7912,
     /*  262512 */     GIR_EraseRootFromParent_Done,
     /*  262513 */   // Label 5022: @262513
     /*  262513 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(262576), // Rule ID 7913 //
     /*  262518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262557 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262574 */     GIR_RootConstrainSelectedInstOperands,
     /*  262575 */     // GIR_Coverage, 7913,
     /*  262575 */     GIR_EraseRootFromParent_Done,
     /*  262576 */   // Label 5023: @262576
     /*  262576 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(262639), // Rule ID 7916 //
     /*  262581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262637 */     GIR_RootConstrainSelectedInstOperands,
     /*  262638 */     // GIR_Coverage, 7916,
     /*  262638 */     GIR_EraseRootFromParent_Done,
     /*  262639 */   // Label 5024: @262639
     /*  262639 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(262702), // Rule ID 7917 //
     /*  262644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262683 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262700 */     GIR_RootConstrainSelectedInstOperands,
     /*  262701 */     // GIR_Coverage, 7917,
     /*  262701 */     GIR_EraseRootFromParent_Done,
     /*  262702 */   // Label 5025: @262702
     /*  262702 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(262765), // Rule ID 7920 //
     /*  262707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262763 */     GIR_RootConstrainSelectedInstOperands,
     /*  262764 */     // GIR_Coverage, 7920,
     /*  262764 */     GIR_EraseRootFromParent_Done,
     /*  262765 */   // Label 5026: @262765
     /*  262765 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(262828), // Rule ID 7921 //
     /*  262770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262809 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262826 */     GIR_RootConstrainSelectedInstOperands,
     /*  262827 */     // GIR_Coverage, 7921,
     /*  262827 */     GIR_EraseRootFromParent_Done,
     /*  262828 */   // Label 5027: @262828
     /*  262828 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(262891), // Rule ID 7924 //
     /*  262833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262889 */     GIR_RootConstrainSelectedInstOperands,
     /*  262890 */     // GIR_Coverage, 7924,
     /*  262890 */     GIR_EraseRootFromParent_Done,
     /*  262891 */   // Label 5028: @262891
     /*  262891 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(262954), // Rule ID 7925 //
     /*  262896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262935 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262952 */     GIR_RootConstrainSelectedInstOperands,
     /*  262953 */     // GIR_Coverage, 7925,
     /*  262953 */     GIR_EraseRootFromParent_Done,
     /*  262954 */   // Label 5029: @262954
     /*  262954 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(263017), // Rule ID 7928 //
     /*  262959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  263001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263015 */     GIR_RootConstrainSelectedInstOperands,
     /*  263016 */     // GIR_Coverage, 7928,
     /*  263016 */     GIR_EraseRootFromParent_Done,
     /*  263017 */   // Label 5030: @263017
     /*  263017 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(263080), // Rule ID 7929 //
     /*  263022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263061 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  263064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263078 */     GIR_RootConstrainSelectedInstOperands,
     /*  263079 */     // GIR_Coverage, 7929,
     /*  263079 */     GIR_EraseRootFromParent_Done,
     /*  263080 */   // Label 5031: @263080
     /*  263080 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(263143), // Rule ID 7932 //
     /*  263085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263141 */     GIR_RootConstrainSelectedInstOperands,
     /*  263142 */     // GIR_Coverage, 7932,
     /*  263142 */     GIR_EraseRootFromParent_Done,
     /*  263143 */   // Label 5032: @263143
     /*  263143 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(263206), // Rule ID 7933 //
     /*  263148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263187 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263204 */     GIR_RootConstrainSelectedInstOperands,
     /*  263205 */     // GIR_Coverage, 7933,
     /*  263205 */     GIR_EraseRootFromParent_Done,
     /*  263206 */   // Label 5033: @263206
     /*  263206 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(263269), // Rule ID 7936 //
     /*  263211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263250 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263267 */     GIR_RootConstrainSelectedInstOperands,
     /*  263268 */     // GIR_Coverage, 7936,
     /*  263268 */     GIR_EraseRootFromParent_Done,
     /*  263269 */   // Label 5034: @263269
     /*  263269 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(263332), // Rule ID 7937 //
     /*  263274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263313 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263330 */     GIR_RootConstrainSelectedInstOperands,
     /*  263331 */     // GIR_Coverage, 7937,
     /*  263331 */     GIR_EraseRootFromParent_Done,
     /*  263332 */   // Label 5035: @263332
     /*  263332 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(263395), // Rule ID 7940 //
     /*  263337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263376 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263393 */     GIR_RootConstrainSelectedInstOperands,
     /*  263394 */     // GIR_Coverage, 7940,
     /*  263394 */     GIR_EraseRootFromParent_Done,
     /*  263395 */   // Label 5036: @263395
     /*  263395 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(263458), // Rule ID 7941 //
     /*  263400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263439 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263456 */     GIR_RootConstrainSelectedInstOperands,
     /*  263457 */     // GIR_Coverage, 7941,
     /*  263457 */     GIR_EraseRootFromParent_Done,
     /*  263458 */   // Label 5037: @263458
     /*  263458 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(263521), // Rule ID 7944 //
     /*  263463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263519 */     GIR_RootConstrainSelectedInstOperands,
     /*  263520 */     // GIR_Coverage, 7944,
     /*  263520 */     GIR_EraseRootFromParent_Done,
     /*  263521 */   // Label 5038: @263521
     /*  263521 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(263584), // Rule ID 7945 //
     /*  263526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263565 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263582 */     GIR_RootConstrainSelectedInstOperands,
     /*  263583 */     // GIR_Coverage, 7945,
     /*  263583 */     GIR_EraseRootFromParent_Done,
     /*  263584 */   // Label 5039: @263584
     /*  263584 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(263647), // Rule ID 7948 //
     /*  263589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263645 */     GIR_RootConstrainSelectedInstOperands,
     /*  263646 */     // GIR_Coverage, 7948,
     /*  263646 */     GIR_EraseRootFromParent_Done,
     /*  263647 */   // Label 5040: @263647
     /*  263647 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(263710), // Rule ID 7949 //
     /*  263652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263691 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263708 */     GIR_RootConstrainSelectedInstOperands,
     /*  263709 */     // GIR_Coverage, 7949,
     /*  263709 */     GIR_EraseRootFromParent_Done,
     /*  263710 */   // Label 5041: @263710
     /*  263710 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(263773), // Rule ID 7952 //
     /*  263715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263754 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263771 */     GIR_RootConstrainSelectedInstOperands,
     /*  263772 */     // GIR_Coverage, 7952,
     /*  263772 */     GIR_EraseRootFromParent_Done,
     /*  263773 */   // Label 5042: @263773
     /*  263773 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(263836), // Rule ID 7953 //
     /*  263778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263817 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263834 */     GIR_RootConstrainSelectedInstOperands,
     /*  263835 */     // GIR_Coverage, 7953,
     /*  263835 */     GIR_EraseRootFromParent_Done,
     /*  263836 */   // Label 5043: @263836
     /*  263836 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(263899), // Rule ID 7956 //
     /*  263841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263897 */     GIR_RootConstrainSelectedInstOperands,
     /*  263898 */     // GIR_Coverage, 7956,
     /*  263898 */     GIR_EraseRootFromParent_Done,
     /*  263899 */   // Label 5044: @263899
     /*  263899 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(263962), // Rule ID 7957 //
     /*  263904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263960 */     GIR_RootConstrainSelectedInstOperands,
     /*  263961 */     // GIR_Coverage, 7957,
     /*  263961 */     GIR_EraseRootFromParent_Done,
     /*  263962 */   // Label 5045: @263962
     /*  263962 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(264025), // Rule ID 7960 //
     /*  263967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264023 */     GIR_RootConstrainSelectedInstOperands,
     /*  264024 */     // GIR_Coverage, 7960,
     /*  264024 */     GIR_EraseRootFromParent_Done,
     /*  264025 */   // Label 5046: @264025
     /*  264025 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(264088), // Rule ID 7961 //
     /*  264030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264069 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264086 */     GIR_RootConstrainSelectedInstOperands,
     /*  264087 */     // GIR_Coverage, 7961,
     /*  264087 */     GIR_EraseRootFromParent_Done,
     /*  264088 */   // Label 5047: @264088
     /*  264088 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(264151), // Rule ID 7964 //
     /*  264093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264149 */     GIR_RootConstrainSelectedInstOperands,
     /*  264150 */     // GIR_Coverage, 7964,
     /*  264150 */     GIR_EraseRootFromParent_Done,
     /*  264151 */   // Label 5048: @264151
     /*  264151 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(264214), // Rule ID 7965 //
     /*  264156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264212 */     GIR_RootConstrainSelectedInstOperands,
     /*  264213 */     // GIR_Coverage, 7965,
     /*  264213 */     GIR_EraseRootFromParent_Done,
     /*  264214 */   // Label 5049: @264214
     /*  264214 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(264277), // Rule ID 7968 //
     /*  264219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  264261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264275 */     GIR_RootConstrainSelectedInstOperands,
     /*  264276 */     // GIR_Coverage, 7968,
     /*  264276 */     GIR_EraseRootFromParent_Done,
     /*  264277 */   // Label 5050: @264277
     /*  264277 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(264340), // Rule ID 7969 //
     /*  264282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264321 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  264324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264338 */     GIR_RootConstrainSelectedInstOperands,
     /*  264339 */     // GIR_Coverage, 7969,
     /*  264339 */     GIR_EraseRootFromParent_Done,
     /*  264340 */   // Label 5051: @264340
     /*  264340 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(264403), // Rule ID 7972 //
     /*  264345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264401 */     GIR_RootConstrainSelectedInstOperands,
     /*  264402 */     // GIR_Coverage, 7972,
     /*  264402 */     GIR_EraseRootFromParent_Done,
     /*  264403 */   // Label 5052: @264403
     /*  264403 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(264466), // Rule ID 7973 //
     /*  264408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  264450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264464 */     GIR_RootConstrainSelectedInstOperands,
     /*  264465 */     // GIR_Coverage, 7973,
     /*  264465 */     GIR_EraseRootFromParent_Done,
     /*  264466 */   // Label 5053: @264466
     /*  264466 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(264529), // Rule ID 7976 //
     /*  264471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264527 */     GIR_RootConstrainSelectedInstOperands,
     /*  264528 */     // GIR_Coverage, 7976,
     /*  264528 */     GIR_EraseRootFromParent_Done,
     /*  264529 */   // Label 5054: @264529
     /*  264529 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(264592), // Rule ID 7977 //
     /*  264534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264573 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264590 */     GIR_RootConstrainSelectedInstOperands,
     /*  264591 */     // GIR_Coverage, 7977,
     /*  264591 */     GIR_EraseRootFromParent_Done,
     /*  264592 */   // Label 5055: @264592
     /*  264592 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(264655), // Rule ID 8068 //
     /*  264597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264653 */     GIR_RootConstrainSelectedInstOperands,
     /*  264654 */     // GIR_Coverage, 8068,
     /*  264654 */     GIR_EraseRootFromParent_Done,
     /*  264655 */   // Label 5056: @264655
     /*  264655 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(264718), // Rule ID 8069 //
     /*  264660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264699 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264716 */     GIR_RootConstrainSelectedInstOperands,
     /*  264717 */     // GIR_Coverage, 8069,
     /*  264717 */     GIR_EraseRootFromParent_Done,
     /*  264718 */   // Label 5057: @264718
     /*  264718 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(264781), // Rule ID 8072 //
     /*  264723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264779 */     GIR_RootConstrainSelectedInstOperands,
     /*  264780 */     // GIR_Coverage, 8072,
     /*  264780 */     GIR_EraseRootFromParent_Done,
     /*  264781 */   // Label 5058: @264781
     /*  264781 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(264844), // Rule ID 8073 //
     /*  264786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264842 */     GIR_RootConstrainSelectedInstOperands,
     /*  264843 */     // GIR_Coverage, 8073,
     /*  264843 */     GIR_EraseRootFromParent_Done,
     /*  264844 */   // Label 5059: @264844
     /*  264844 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(264907), // Rule ID 8076 //
     /*  264849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264905 */     GIR_RootConstrainSelectedInstOperands,
     /*  264906 */     // GIR_Coverage, 8076,
     /*  264906 */     GIR_EraseRootFromParent_Done,
     /*  264907 */   // Label 5060: @264907
     /*  264907 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(264970), // Rule ID 8077 //
     /*  264912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264968 */     GIR_RootConstrainSelectedInstOperands,
     /*  264969 */     // GIR_Coverage, 8077,
     /*  264969 */     GIR_EraseRootFromParent_Done,
     /*  264970 */   // Label 5061: @264970
     /*  264970 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(265033), // Rule ID 8080 //
     /*  264975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  265017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265031 */     GIR_RootConstrainSelectedInstOperands,
     /*  265032 */     // GIR_Coverage, 8080,
     /*  265032 */     GIR_EraseRootFromParent_Done,
     /*  265033 */   // Label 5062: @265033
     /*  265033 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(265096), // Rule ID 8081 //
     /*  265038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  265055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  265080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265094 */     GIR_RootConstrainSelectedInstOperands,
     /*  265095 */     // GIR_Coverage, 8081,
     /*  265095 */     GIR_EraseRootFromParent_Done,
     /*  265096 */   // Label 5063: @265096
     /*  265096 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(265159), // Rule ID 8084 //
     /*  265101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  265118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265157 */     GIR_RootConstrainSelectedInstOperands,
     /*  265158 */     // GIR_Coverage, 8084,
     /*  265158 */     GIR_EraseRootFromParent_Done,
     /*  265159 */   // Label 5064: @265159
     /*  265159 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(265222), // Rule ID 8085 //
     /*  265164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  265181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265220 */     GIR_RootConstrainSelectedInstOperands,
     /*  265221 */     // GIR_Coverage, 8085,
     /*  265221 */     GIR_EraseRootFromParent_Done,
     /*  265222 */   // Label 5065: @265222
     /*  265222 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(265285), // Rule ID 8088 //
     /*  265227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  265244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265266 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265283 */     GIR_RootConstrainSelectedInstOperands,
     /*  265284 */     // GIR_Coverage, 8088,
     /*  265284 */     GIR_EraseRootFromParent_Done,
     /*  265285 */   // Label 5066: @265285
     /*  265285 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(265348), // Rule ID 8089 //
     /*  265290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  265307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265329 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  265332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265346 */     GIR_RootConstrainSelectedInstOperands,
     /*  265347 */     // GIR_Coverage, 8089,
     /*  265347 */     GIR_EraseRootFromParent_Done,
     /*  265348 */   // Label 5067: @265348
     /*  265348 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(265411), // Rule ID 8092 //
     /*  265353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  265370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265409 */     GIR_RootConstrainSelectedInstOperands,
     /*  265410 */     // GIR_Coverage, 8092,
     /*  265410 */     GIR_EraseRootFromParent_Done,
     /*  265411 */   // Label 5068: @265411
     /*  265411 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(265474), // Rule ID 8093 //
     /*  265416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  265433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265455 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265472 */     GIR_RootConstrainSelectedInstOperands,
     /*  265473 */     // GIR_Coverage, 8093,
     /*  265473 */     GIR_EraseRootFromParent_Done,
     /*  265474 */   // Label 5069: @265474
     /*  265474 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(265537), // Rule ID 8096 //
     /*  265479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265535 */     GIR_RootConstrainSelectedInstOperands,
     /*  265536 */     // GIR_Coverage, 8096,
     /*  265536 */     GIR_EraseRootFromParent_Done,
     /*  265537 */   // Label 5070: @265537
     /*  265537 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(265600), // Rule ID 8097 //
     /*  265542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265581 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265598 */     GIR_RootConstrainSelectedInstOperands,
     /*  265599 */     // GIR_Coverage, 8097,
     /*  265599 */     GIR_EraseRootFromParent_Done,
     /*  265600 */   // Label 5071: @265600
     /*  265600 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(265663), // Rule ID 8100 //
     /*  265605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265661 */     GIR_RootConstrainSelectedInstOperands,
     /*  265662 */     // GIR_Coverage, 8100,
     /*  265662 */     GIR_EraseRootFromParent_Done,
     /*  265663 */   // Label 5072: @265663
     /*  265663 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(265726), // Rule ID 8101 //
     /*  265668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265707 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265724 */     GIR_RootConstrainSelectedInstOperands,
     /*  265725 */     // GIR_Coverage, 8101,
     /*  265725 */     GIR_EraseRootFromParent_Done,
     /*  265726 */   // Label 5073: @265726
     /*  265726 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(265789), // Rule ID 8104 //
     /*  265731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265787 */     GIR_RootConstrainSelectedInstOperands,
     /*  265788 */     // GIR_Coverage, 8104,
     /*  265788 */     GIR_EraseRootFromParent_Done,
     /*  265789 */   // Label 5074: @265789
     /*  265789 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(265852), // Rule ID 8105 //
     /*  265794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265850 */     GIR_RootConstrainSelectedInstOperands,
     /*  265851 */     // GIR_Coverage, 8105,
     /*  265851 */     GIR_EraseRootFromParent_Done,
     /*  265852 */   // Label 5075: @265852
     /*  265852 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(265915), // Rule ID 8108 //
     /*  265857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265913 */     GIR_RootConstrainSelectedInstOperands,
     /*  265914 */     // GIR_Coverage, 8108,
     /*  265914 */     GIR_EraseRootFromParent_Done,
     /*  265915 */   // Label 5076: @265915
     /*  265915 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(265978), // Rule ID 8109 //
     /*  265920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265976 */     GIR_RootConstrainSelectedInstOperands,
     /*  265977 */     // GIR_Coverage, 8109,
     /*  265977 */     GIR_EraseRootFromParent_Done,
     /*  265978 */   // Label 5077: @265978
     /*  265978 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(266041), // Rule ID 8112 //
     /*  265983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  266000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266039 */     GIR_RootConstrainSelectedInstOperands,
     /*  266040 */     // GIR_Coverage, 8112,
     /*  266040 */     GIR_EraseRootFromParent_Done,
     /*  266041 */   // Label 5078: @266041
     /*  266041 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(266104), // Rule ID 8113 //
     /*  266046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  266063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266085 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266102 */     GIR_RootConstrainSelectedInstOperands,
     /*  266103 */     // GIR_Coverage, 8113,
     /*  266103 */     GIR_EraseRootFromParent_Done,
     /*  266104 */   // Label 5079: @266104
     /*  266104 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(266167), // Rule ID 8116 //
     /*  266109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  266126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266148 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266165 */     GIR_RootConstrainSelectedInstOperands,
     /*  266166 */     // GIR_Coverage, 8116,
     /*  266166 */     GIR_EraseRootFromParent_Done,
     /*  266167 */   // Label 5080: @266167
     /*  266167 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(266230), // Rule ID 8117 //
     /*  266172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  266189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266211 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266228 */     GIR_RootConstrainSelectedInstOperands,
     /*  266229 */     // GIR_Coverage, 8117,
     /*  266229 */     GIR_EraseRootFromParent_Done,
     /*  266230 */   // Label 5081: @266230
     /*  266230 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(266293), // Rule ID 8120 //
     /*  266235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  266252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266291 */     GIR_RootConstrainSelectedInstOperands,
     /*  266292 */     // GIR_Coverage, 8120,
     /*  266292 */     GIR_EraseRootFromParent_Done,
     /*  266293 */   // Label 5082: @266293
     /*  266293 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(266356), // Rule ID 8121 //
     /*  266298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  266315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266354 */     GIR_RootConstrainSelectedInstOperands,
     /*  266355 */     // GIR_Coverage, 8121,
     /*  266355 */     GIR_EraseRootFromParent_Done,
     /*  266356 */   // Label 5083: @266356
     /*  266356 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(266419), // Rule ID 8124 //
     /*  266361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  266378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266417 */     GIR_RootConstrainSelectedInstOperands,
     /*  266418 */     // GIR_Coverage, 8124,
     /*  266418 */     GIR_EraseRootFromParent_Done,
     /*  266419 */   // Label 5084: @266419
     /*  266419 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(266482), // Rule ID 8125 //
     /*  266424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  266441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266463 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266480 */     GIR_RootConstrainSelectedInstOperands,
     /*  266481 */     // GIR_Coverage, 8125,
     /*  266481 */     GIR_EraseRootFromParent_Done,
     /*  266482 */   // Label 5085: @266482
     /*  266482 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(266545), // Rule ID 8128 //
     /*  266487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266526 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266543 */     GIR_RootConstrainSelectedInstOperands,
     /*  266544 */     // GIR_Coverage, 8128,
     /*  266544 */     GIR_EraseRootFromParent_Done,
     /*  266545 */   // Label 5086: @266545
     /*  266545 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(266608), // Rule ID 8129 //
     /*  266550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266589 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266606 */     GIR_RootConstrainSelectedInstOperands,
     /*  266607 */     // GIR_Coverage, 8129,
     /*  266607 */     GIR_EraseRootFromParent_Done,
     /*  266608 */   // Label 5087: @266608
     /*  266608 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(266671), // Rule ID 8132 //
     /*  266613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266669 */     GIR_RootConstrainSelectedInstOperands,
     /*  266670 */     // GIR_Coverage, 8132,
     /*  266670 */     GIR_EraseRootFromParent_Done,
     /*  266671 */   // Label 5088: @266671
     /*  266671 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(266734), // Rule ID 8133 //
     /*  266676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266715 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266732 */     GIR_RootConstrainSelectedInstOperands,
     /*  266733 */     // GIR_Coverage, 8133,
     /*  266733 */     GIR_EraseRootFromParent_Done,
     /*  266734 */   // Label 5089: @266734
     /*  266734 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(266797), // Rule ID 8136 //
     /*  266739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266795 */     GIR_RootConstrainSelectedInstOperands,
     /*  266796 */     // GIR_Coverage, 8136,
     /*  266796 */     GIR_EraseRootFromParent_Done,
     /*  266797 */   // Label 5090: @266797
     /*  266797 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(266860), // Rule ID 8137 //
     /*  266802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266841 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266858 */     GIR_RootConstrainSelectedInstOperands,
     /*  266859 */     // GIR_Coverage, 8137,
     /*  266859 */     GIR_EraseRootFromParent_Done,
     /*  266860 */   // Label 5091: @266860
     /*  266860 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(266923), // Rule ID 8140 //
     /*  266865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266921 */     GIR_RootConstrainSelectedInstOperands,
     /*  266922 */     // GIR_Coverage, 8140,
     /*  266922 */     GIR_EraseRootFromParent_Done,
     /*  266923 */   // Label 5092: @266923
     /*  266923 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(266986), // Rule ID 8141 //
     /*  266928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266967 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266984 */     GIR_RootConstrainSelectedInstOperands,
     /*  266985 */     // GIR_Coverage, 8141,
     /*  266985 */     GIR_EraseRootFromParent_Done,
     /*  266986 */   // Label 5093: @266986
     /*  266986 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(267049), // Rule ID 8144 //
     /*  266991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  267008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  267033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267047 */     GIR_RootConstrainSelectedInstOperands,
     /*  267048 */     // GIR_Coverage, 8144,
     /*  267048 */     GIR_EraseRootFromParent_Done,
     /*  267049 */   // Label 5094: @267049
     /*  267049 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(267112), // Rule ID 8145 //
     /*  267054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  267071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267093 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  267096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267110 */     GIR_RootConstrainSelectedInstOperands,
     /*  267111 */     // GIR_Coverage, 8145,
     /*  267111 */     GIR_EraseRootFromParent_Done,
     /*  267112 */   // Label 5095: @267112
     /*  267112 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(267175), // Rule ID 8148 //
     /*  267117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  267134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267156 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  267159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267173 */     GIR_RootConstrainSelectedInstOperands,
     /*  267174 */     // GIR_Coverage, 8148,
     /*  267174 */     GIR_EraseRootFromParent_Done,
     /*  267175 */   // Label 5096: @267175
     /*  267175 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(267238), // Rule ID 8149 //
     /*  267180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  267197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267219 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  267222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267236 */     GIR_RootConstrainSelectedInstOperands,
     /*  267237 */     // GIR_Coverage, 8149,
     /*  267237 */     GIR_EraseRootFromParent_Done,
     /*  267238 */   // Label 5097: @267238
     /*  267238 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(267301), // Rule ID 8152 //
     /*  267243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  267260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  267285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267299 */     GIR_RootConstrainSelectedInstOperands,
     /*  267300 */     // GIR_Coverage, 8152,
     /*  267300 */     GIR_EraseRootFromParent_Done,
     /*  267301 */   // Label 5098: @267301
     /*  267301 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(267364), // Rule ID 8153 //
     /*  267306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  267323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  267348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267362 */     GIR_RootConstrainSelectedInstOperands,
     /*  267363 */     // GIR_Coverage, 8153,
     /*  267363 */     GIR_EraseRootFromParent_Done,
     /*  267364 */   // Label 5099: @267364
     /*  267364 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(267427), // Rule ID 8156 //
     /*  267369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267425 */     GIR_RootConstrainSelectedInstOperands,
     /*  267426 */     // GIR_Coverage, 8156,
     /*  267426 */     GIR_EraseRootFromParent_Done,
     /*  267427 */   // Label 5100: @267427
     /*  267427 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(267490), // Rule ID 8157 //
     /*  267432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267471 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267488 */     GIR_RootConstrainSelectedInstOperands,
     /*  267489 */     // GIR_Coverage, 8157,
     /*  267489 */     GIR_EraseRootFromParent_Done,
     /*  267490 */   // Label 5101: @267490
     /*  267490 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(267553), // Rule ID 8160 //
     /*  267495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267551 */     GIR_RootConstrainSelectedInstOperands,
     /*  267552 */     // GIR_Coverage, 8160,
     /*  267552 */     GIR_EraseRootFromParent_Done,
     /*  267553 */   // Label 5102: @267553
     /*  267553 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(267616), // Rule ID 8161 //
     /*  267558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267614 */     GIR_RootConstrainSelectedInstOperands,
     /*  267615 */     // GIR_Coverage, 8161,
     /*  267615 */     GIR_EraseRootFromParent_Done,
     /*  267616 */   // Label 5103: @267616
     /*  267616 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(267679), // Rule ID 8164 //
     /*  267621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267677 */     GIR_RootConstrainSelectedInstOperands,
     /*  267678 */     // GIR_Coverage, 8164,
     /*  267678 */     GIR_EraseRootFromParent_Done,
     /*  267679 */   // Label 5104: @267679
     /*  267679 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(267742), // Rule ID 8165 //
     /*  267684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267723 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267740 */     GIR_RootConstrainSelectedInstOperands,
     /*  267741 */     // GIR_Coverage, 8165,
     /*  267741 */     GIR_EraseRootFromParent_Done,
     /*  267742 */   // Label 5105: @267742
     /*  267742 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(267805), // Rule ID 8168 //
     /*  267747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267803 */     GIR_RootConstrainSelectedInstOperands,
     /*  267804 */     // GIR_Coverage, 8168,
     /*  267804 */     GIR_EraseRootFromParent_Done,
     /*  267805 */   // Label 5106: @267805
     /*  267805 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(267868), // Rule ID 8169 //
     /*  267810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267849 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267866 */     GIR_RootConstrainSelectedInstOperands,
     /*  267867 */     // GIR_Coverage, 8169,
     /*  267867 */     GIR_EraseRootFromParent_Done,
     /*  267868 */   // Label 5107: @267868
     /*  267868 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(267931), // Rule ID 8172 //
     /*  267873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267929 */     GIR_RootConstrainSelectedInstOperands,
     /*  267930 */     // GIR_Coverage, 8172,
     /*  267930 */     GIR_EraseRootFromParent_Done,
     /*  267931 */   // Label 5108: @267931
     /*  267931 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(267994), // Rule ID 8173 //
     /*  267936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267992 */     GIR_RootConstrainSelectedInstOperands,
     /*  267993 */     // GIR_Coverage, 8173,
     /*  267993 */     GIR_EraseRootFromParent_Done,
     /*  267994 */   // Label 5109: @267994
     /*  267994 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(268057), // Rule ID 8176 //
     /*  267999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  268041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268055 */     GIR_RootConstrainSelectedInstOperands,
     /*  268056 */     // GIR_Coverage, 8176,
     /*  268056 */     GIR_EraseRootFromParent_Done,
     /*  268057 */   // Label 5110: @268057
     /*  268057 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(268120), // Rule ID 8177 //
     /*  268062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268101 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  268104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268118 */     GIR_RootConstrainSelectedInstOperands,
     /*  268119 */     // GIR_Coverage, 8177,
     /*  268119 */     GIR_EraseRootFromParent_Done,
     /*  268120 */   // Label 5111: @268120
     /*  268120 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(268183), // Rule ID 8180 //
     /*  268125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268181 */     GIR_RootConstrainSelectedInstOperands,
     /*  268182 */     // GIR_Coverage, 8180,
     /*  268182 */     GIR_EraseRootFromParent_Done,
     /*  268183 */   // Label 5112: @268183
     /*  268183 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(268246), // Rule ID 8181 //
     /*  268188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268227 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268244 */     GIR_RootConstrainSelectedInstOperands,
     /*  268245 */     // GIR_Coverage, 8181,
     /*  268245 */     GIR_EraseRootFromParent_Done,
     /*  268246 */   // Label 5113: @268246
     /*  268246 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(268309), // Rule ID 8184 //
     /*  268251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268307 */     GIR_RootConstrainSelectedInstOperands,
     /*  268308 */     // GIR_Coverage, 8184,
     /*  268308 */     GIR_EraseRootFromParent_Done,
     /*  268309 */   // Label 5114: @268309
     /*  268309 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(268372), // Rule ID 8185 //
     /*  268314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268353 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268370 */     GIR_RootConstrainSelectedInstOperands,
     /*  268371 */     // GIR_Coverage, 8185,
     /*  268371 */     GIR_EraseRootFromParent_Done,
     /*  268372 */   // Label 5115: @268372
     /*  268372 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(268435), // Rule ID 8188 //
     /*  268377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268416 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268433 */     GIR_RootConstrainSelectedInstOperands,
     /*  268434 */     // GIR_Coverage, 8188,
     /*  268434 */     GIR_EraseRootFromParent_Done,
     /*  268435 */   // Label 5116: @268435
     /*  268435 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(268498), // Rule ID 8189 //
     /*  268440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268479 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268496 */     GIR_RootConstrainSelectedInstOperands,
     /*  268497 */     // GIR_Coverage, 8189,
     /*  268497 */     GIR_EraseRootFromParent_Done,
     /*  268498 */   // Label 5117: @268498
     /*  268498 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(268561), // Rule ID 8192 //
     /*  268503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268559 */     GIR_RootConstrainSelectedInstOperands,
     /*  268560 */     // GIR_Coverage, 8192,
     /*  268560 */     GIR_EraseRootFromParent_Done,
     /*  268561 */   // Label 5118: @268561
     /*  268561 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(268624), // Rule ID 8193 //
     /*  268566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  268605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268622 */     GIR_RootConstrainSelectedInstOperands,
     /*  268623 */     // GIR_Coverage, 8193,
     /*  268623 */     GIR_EraseRootFromParent_Done,
     /*  268624 */   // Label 5119: @268624
     /*  268624 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(268687), // Rule ID 8196 //
     /*  268629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268668 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268685 */     GIR_RootConstrainSelectedInstOperands,
     /*  268686 */     // GIR_Coverage, 8196,
     /*  268686 */     GIR_EraseRootFromParent_Done,
     /*  268687 */   // Label 5120: @268687
     /*  268687 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(268750), // Rule ID 8197 //
     /*  268692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268731 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268748 */     GIR_RootConstrainSelectedInstOperands,
     /*  268749 */     // GIR_Coverage, 8197,
     /*  268749 */     GIR_EraseRootFromParent_Done,
     /*  268750 */   // Label 5121: @268750
     /*  268750 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(268813), // Rule ID 8200 //
     /*  268755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268794 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268811 */     GIR_RootConstrainSelectedInstOperands,
     /*  268812 */     // GIR_Coverage, 8200,
     /*  268812 */     GIR_EraseRootFromParent_Done,
     /*  268813 */   // Label 5122: @268813
     /*  268813 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(268876), // Rule ID 8201 //
     /*  268818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268857 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268874 */     GIR_RootConstrainSelectedInstOperands,
     /*  268875 */     // GIR_Coverage, 8201,
     /*  268875 */     GIR_EraseRootFromParent_Done,
     /*  268876 */   // Label 5123: @268876
     /*  268876 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(268939), // Rule ID 8204 //
     /*  268881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268920 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268937 */     GIR_RootConstrainSelectedInstOperands,
     /*  268938 */     // GIR_Coverage, 8204,
     /*  268938 */     GIR_EraseRootFromParent_Done,
     /*  268939 */   // Label 5124: @268939
     /*  268939 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(269002), // Rule ID 8205 //
     /*  268944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268983 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269000 */     GIR_RootConstrainSelectedInstOperands,
     /*  269001 */     // GIR_Coverage, 8205,
     /*  269001 */     GIR_EraseRootFromParent_Done,
     /*  269002 */   // Label 5125: @269002
     /*  269002 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(269065), // Rule ID 8208 //
     /*  269007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269063 */     GIR_RootConstrainSelectedInstOperands,
     /*  269064 */     // GIR_Coverage, 8208,
     /*  269064 */     GIR_EraseRootFromParent_Done,
     /*  269065 */   // Label 5126: @269065
     /*  269065 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(269128), // Rule ID 8209 //
     /*  269070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269109 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269126 */     GIR_RootConstrainSelectedInstOperands,
     /*  269127 */     // GIR_Coverage, 8209,
     /*  269127 */     GIR_EraseRootFromParent_Done,
     /*  269128 */   // Label 5127: @269128
     /*  269128 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(269191), // Rule ID 8212 //
     /*  269133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269189 */     GIR_RootConstrainSelectedInstOperands,
     /*  269190 */     // GIR_Coverage, 8212,
     /*  269190 */     GIR_EraseRootFromParent_Done,
     /*  269191 */   // Label 5128: @269191
     /*  269191 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(269254), // Rule ID 8213 //
     /*  269196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269252 */     GIR_RootConstrainSelectedInstOperands,
     /*  269253 */     // GIR_Coverage, 8213,
     /*  269253 */     GIR_EraseRootFromParent_Done,
     /*  269254 */   // Label 5129: @269254
     /*  269254 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(269317), // Rule ID 8216 //
     /*  269259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269298 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269315 */     GIR_RootConstrainSelectedInstOperands,
     /*  269316 */     // GIR_Coverage, 8216,
     /*  269316 */     GIR_EraseRootFromParent_Done,
     /*  269317 */   // Label 5130: @269317
     /*  269317 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(269380), // Rule ID 8217 //
     /*  269322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269361 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269378 */     GIR_RootConstrainSelectedInstOperands,
     /*  269379 */     // GIR_Coverage, 8217,
     /*  269379 */     GIR_EraseRootFromParent_Done,
     /*  269380 */   // Label 5131: @269380
     /*  269380 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(269443), // Rule ID 8220 //
     /*  269385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  269399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269441 */     GIR_RootConstrainSelectedInstOperands,
     /*  269442 */     // GIR_Coverage, 8220,
     /*  269442 */     GIR_EraseRootFromParent_Done,
     /*  269443 */   // Label 5132: @269443
     /*  269443 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(269506), // Rule ID 8221 //
     /*  269448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  269462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269487 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269504 */     GIR_RootConstrainSelectedInstOperands,
     /*  269505 */     // GIR_Coverage, 8221,
     /*  269505 */     GIR_EraseRootFromParent_Done,
     /*  269506 */   // Label 5133: @269506
     /*  269506 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(269569), // Rule ID 8224 //
     /*  269511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269550 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269567 */     GIR_RootConstrainSelectedInstOperands,
     /*  269568 */     // GIR_Coverage, 8224,
     /*  269568 */     GIR_EraseRootFromParent_Done,
     /*  269569 */   // Label 5134: @269569
     /*  269569 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(269632), // Rule ID 8225 //
     /*  269574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269613 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269630 */     GIR_RootConstrainSelectedInstOperands,
     /*  269631 */     // GIR_Coverage, 8225,
     /*  269631 */     GIR_EraseRootFromParent_Done,
     /*  269632 */   // Label 5135: @269632
     /*  269632 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(269695), // Rule ID 8228 //
     /*  269637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269693 */     GIR_RootConstrainSelectedInstOperands,
     /*  269694 */     // GIR_Coverage, 8228,
     /*  269694 */     GIR_EraseRootFromParent_Done,
     /*  269695 */   // Label 5136: @269695
     /*  269695 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(269758), // Rule ID 8229 //
     /*  269700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269756 */     GIR_RootConstrainSelectedInstOperands,
     /*  269757 */     // GIR_Coverage, 8229,
     /*  269757 */     GIR_EraseRootFromParent_Done,
     /*  269758 */   // Label 5137: @269758
     /*  269758 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(269821), // Rule ID 8232 //
     /*  269763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269819 */     GIR_RootConstrainSelectedInstOperands,
     /*  269820 */     // GIR_Coverage, 8232,
     /*  269820 */     GIR_EraseRootFromParent_Done,
     /*  269821 */   // Label 5138: @269821
     /*  269821 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(269884), // Rule ID 8233 //
     /*  269826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269865 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269882 */     GIR_RootConstrainSelectedInstOperands,
     /*  269883 */     // GIR_Coverage, 8233,
     /*  269883 */     GIR_EraseRootFromParent_Done,
     /*  269884 */   // Label 5139: @269884
     /*  269884 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(269947), // Rule ID 8236 //
     /*  269889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269945 */     GIR_RootConstrainSelectedInstOperands,
     /*  269946 */     // GIR_Coverage, 8236,
     /*  269946 */     GIR_EraseRootFromParent_Done,
     /*  269947 */   // Label 5140: @269947
     /*  269947 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(270010), // Rule ID 8237 //
     /*  269952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269991 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270008 */     GIR_RootConstrainSelectedInstOperands,
     /*  270009 */     // GIR_Coverage, 8237,
     /*  270009 */     GIR_EraseRootFromParent_Done,
     /*  270010 */   // Label 5141: @270010
     /*  270010 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(270073), // Rule ID 8240 //
     /*  270015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  270057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270071 */     GIR_RootConstrainSelectedInstOperands,
     /*  270072 */     // GIR_Coverage, 8240,
     /*  270072 */     GIR_EraseRootFromParent_Done,
     /*  270073 */   // Label 5142: @270073
     /*  270073 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(270136), // Rule ID 8241 //
     /*  270078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270117 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  270120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270134 */     GIR_RootConstrainSelectedInstOperands,
     /*  270135 */     // GIR_Coverage, 8241,
     /*  270135 */     GIR_EraseRootFromParent_Done,
     /*  270136 */   // Label 5143: @270136
     /*  270136 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(270199), // Rule ID 8332 //
     /*  270141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  270158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  270183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270197 */     GIR_RootConstrainSelectedInstOperands,
     /*  270198 */     // GIR_Coverage, 8332,
     /*  270198 */     GIR_EraseRootFromParent_Done,
     /*  270199 */   // Label 5144: @270199
     /*  270199 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(270262), // Rule ID 8333 //
     /*  270204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  270221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  270246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270260 */     GIR_RootConstrainSelectedInstOperands,
     /*  270261 */     // GIR_Coverage, 8333,
     /*  270261 */     GIR_EraseRootFromParent_Done,
     /*  270262 */   // Label 5145: @270262
     /*  270262 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(270325), // Rule ID 8336 //
     /*  270267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  270284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270323 */     GIR_RootConstrainSelectedInstOperands,
     /*  270324 */     // GIR_Coverage, 8336,
     /*  270324 */     GIR_EraseRootFromParent_Done,
     /*  270325 */   // Label 5146: @270325
     /*  270325 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(270388), // Rule ID 8337 //
     /*  270330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  270347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270386 */     GIR_RootConstrainSelectedInstOperands,
     /*  270387 */     // GIR_Coverage, 8337,
     /*  270387 */     GIR_EraseRootFromParent_Done,
     /*  270388 */   // Label 5147: @270388
     /*  270388 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(270451), // Rule ID 8340 //
     /*  270393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270432 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270449 */     GIR_RootConstrainSelectedInstOperands,
     /*  270450 */     // GIR_Coverage, 8340,
     /*  270450 */     GIR_EraseRootFromParent_Done,
     /*  270451 */   // Label 5148: @270451
     /*  270451 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(270514), // Rule ID 8341 //
     /*  270456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270512 */     GIR_RootConstrainSelectedInstOperands,
     /*  270513 */     // GIR_Coverage, 8341,
     /*  270513 */     GIR_EraseRootFromParent_Done,
     /*  270514 */   // Label 5149: @270514
     /*  270514 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(270577), // Rule ID 8344 //
     /*  270519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270575 */     GIR_RootConstrainSelectedInstOperands,
     /*  270576 */     // GIR_Coverage, 8344,
     /*  270576 */     GIR_EraseRootFromParent_Done,
     /*  270577 */   // Label 5150: @270577
     /*  270577 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(270640), // Rule ID 8345 //
     /*  270582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270621 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270638 */     GIR_RootConstrainSelectedInstOperands,
     /*  270639 */     // GIR_Coverage, 8345,
     /*  270639 */     GIR_EraseRootFromParent_Done,
     /*  270640 */   // Label 5151: @270640
     /*  270640 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(270703), // Rule ID 8348 //
     /*  270645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270701 */     GIR_RootConstrainSelectedInstOperands,
     /*  270702 */     // GIR_Coverage, 8348,
     /*  270702 */     GIR_EraseRootFromParent_Done,
     /*  270703 */   // Label 5152: @270703
     /*  270703 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(270766), // Rule ID 8349 //
     /*  270708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270764 */     GIR_RootConstrainSelectedInstOperands,
     /*  270765 */     // GIR_Coverage, 8349,
     /*  270765 */     GIR_EraseRootFromParent_Done,
     /*  270766 */   // Label 5153: @270766
     /*  270766 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(270829), // Rule ID 8352 //
     /*  270771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270827 */     GIR_RootConstrainSelectedInstOperands,
     /*  270828 */     // GIR_Coverage, 8352,
     /*  270828 */     GIR_EraseRootFromParent_Done,
     /*  270829 */   // Label 5154: @270829
     /*  270829 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(270892), // Rule ID 8353 //
     /*  270834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270873 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270890 */     GIR_RootConstrainSelectedInstOperands,
     /*  270891 */     // GIR_Coverage, 8353,
     /*  270891 */     GIR_EraseRootFromParent_Done,
     /*  270892 */   // Label 5155: @270892
     /*  270892 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(270955), // Rule ID 8356 //
     /*  270897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270953 */     GIR_RootConstrainSelectedInstOperands,
     /*  270954 */     // GIR_Coverage, 8356,
     /*  270954 */     GIR_EraseRootFromParent_Done,
     /*  270955 */   // Label 5156: @270955
     /*  270955 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(271018), // Rule ID 8357 //
     /*  270960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270999 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271016 */     GIR_RootConstrainSelectedInstOperands,
     /*  271017 */     // GIR_Coverage, 8357,
     /*  271017 */     GIR_EraseRootFromParent_Done,
     /*  271018 */   // Label 5157: @271018
     /*  271018 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(271081), // Rule ID 8360 //
     /*  271023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  271040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271079 */     GIR_RootConstrainSelectedInstOperands,
     /*  271080 */     // GIR_Coverage, 8360,
     /*  271080 */     GIR_EraseRootFromParent_Done,
     /*  271081 */   // Label 5158: @271081
     /*  271081 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(271144), // Rule ID 8361 //
     /*  271086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  271103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271125 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271142 */     GIR_RootConstrainSelectedInstOperands,
     /*  271143 */     // GIR_Coverage, 8361,
     /*  271143 */     GIR_EraseRootFromParent_Done,
     /*  271144 */   // Label 5159: @271144
     /*  271144 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(271207), // Rule ID 8364 //
     /*  271149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  271166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271205 */     GIR_RootConstrainSelectedInstOperands,
     /*  271206 */     // GIR_Coverage, 8364,
     /*  271206 */     GIR_EraseRootFromParent_Done,
     /*  271207 */   // Label 5160: @271207
     /*  271207 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(271270), // Rule ID 8365 //
     /*  271212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  271229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271251 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271268 */     GIR_RootConstrainSelectedInstOperands,
     /*  271269 */     // GIR_Coverage, 8365,
     /*  271269 */     GIR_EraseRootFromParent_Done,
     /*  271270 */   // Label 5161: @271270
     /*  271270 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(271333), // Rule ID 8368 //
     /*  271275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  271292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271314 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271331 */     GIR_RootConstrainSelectedInstOperands,
     /*  271332 */     // GIR_Coverage, 8368,
     /*  271332 */     GIR_EraseRootFromParent_Done,
     /*  271333 */   // Label 5162: @271333
     /*  271333 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(271396), // Rule ID 8369 //
     /*  271338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  271355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271377 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  271380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271394 */     GIR_RootConstrainSelectedInstOperands,
     /*  271395 */     // GIR_Coverage, 8369,
     /*  271395 */     GIR_EraseRootFromParent_Done,
     /*  271396 */   // Label 5163: @271396
     /*  271396 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(271459), // Rule ID 8372 //
     /*  271401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271457 */     GIR_RootConstrainSelectedInstOperands,
     /*  271458 */     // GIR_Coverage, 8372,
     /*  271458 */     GIR_EraseRootFromParent_Done,
     /*  271459 */   // Label 5164: @271459
     /*  271459 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(271522), // Rule ID 8373 //
     /*  271464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271520 */     GIR_RootConstrainSelectedInstOperands,
     /*  271521 */     // GIR_Coverage, 8373,
     /*  271521 */     GIR_EraseRootFromParent_Done,
     /*  271522 */   // Label 5165: @271522
     /*  271522 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(271585), // Rule ID 8376 //
     /*  271527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271566 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271583 */     GIR_RootConstrainSelectedInstOperands,
     /*  271584 */     // GIR_Coverage, 8376,
     /*  271584 */     GIR_EraseRootFromParent_Done,
     /*  271585 */   // Label 5166: @271585
     /*  271585 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(271648), // Rule ID 8377 //
     /*  271590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271629 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271646 */     GIR_RootConstrainSelectedInstOperands,
     /*  271647 */     // GIR_Coverage, 8377,
     /*  271647 */     GIR_EraseRootFromParent_Done,
     /*  271648 */   // Label 5167: @271648
     /*  271648 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(271711), // Rule ID 8380 //
     /*  271653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271692 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271709 */     GIR_RootConstrainSelectedInstOperands,
     /*  271710 */     // GIR_Coverage, 8380,
     /*  271710 */     GIR_EraseRootFromParent_Done,
     /*  271711 */   // Label 5168: @271711
     /*  271711 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(271774), // Rule ID 8381 //
     /*  271716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271755 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271772 */     GIR_RootConstrainSelectedInstOperands,
     /*  271773 */     // GIR_Coverage, 8381,
     /*  271773 */     GIR_EraseRootFromParent_Done,
     /*  271774 */   // Label 5169: @271774
     /*  271774 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(271837), // Rule ID 8384 //
     /*  271779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271835 */     GIR_RootConstrainSelectedInstOperands,
     /*  271836 */     // GIR_Coverage, 8384,
     /*  271836 */     GIR_EraseRootFromParent_Done,
     /*  271837 */   // Label 5170: @271837
     /*  271837 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(271900), // Rule ID 8385 //
     /*  271842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271881 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271898 */     GIR_RootConstrainSelectedInstOperands,
     /*  271899 */     // GIR_Coverage, 8385,
     /*  271899 */     GIR_EraseRootFromParent_Done,
     /*  271900 */   // Label 5171: @271900
     /*  271900 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(271963), // Rule ID 8388 //
     /*  271905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271944 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271961 */     GIR_RootConstrainSelectedInstOperands,
     /*  271962 */     // GIR_Coverage, 8388,
     /*  271962 */     GIR_EraseRootFromParent_Done,
     /*  271963 */   // Label 5172: @271963
     /*  271963 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(272026), // Rule ID 8389 //
     /*  271968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272024 */     GIR_RootConstrainSelectedInstOperands,
     /*  272025 */     // GIR_Coverage, 8389,
     /*  272025 */     GIR_EraseRootFromParent_Done,
     /*  272026 */   // Label 5173: @272026
     /*  272026 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(272089), // Rule ID 8392 //
     /*  272031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  272048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272070 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272087 */     GIR_RootConstrainSelectedInstOperands,
     /*  272088 */     // GIR_Coverage, 8392,
     /*  272088 */     GIR_EraseRootFromParent_Done,
     /*  272089 */   // Label 5174: @272089
     /*  272089 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(272152), // Rule ID 8393 //
     /*  272094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  272111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272133 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272150 */     GIR_RootConstrainSelectedInstOperands,
     /*  272151 */     // GIR_Coverage, 8393,
     /*  272151 */     GIR_EraseRootFromParent_Done,
     /*  272152 */   // Label 5175: @272152
     /*  272152 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(272215), // Rule ID 8396 //
     /*  272157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  272174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272213 */     GIR_RootConstrainSelectedInstOperands,
     /*  272214 */     // GIR_Coverage, 8396,
     /*  272214 */     GIR_EraseRootFromParent_Done,
     /*  272215 */   // Label 5176: @272215
     /*  272215 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(272278), // Rule ID 8397 //
     /*  272220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  272237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272259 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272276 */     GIR_RootConstrainSelectedInstOperands,
     /*  272277 */     // GIR_Coverage, 8397,
     /*  272277 */     GIR_EraseRootFromParent_Done,
     /*  272278 */   // Label 5177: @272278
     /*  272278 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(272341), // Rule ID 8400 //
     /*  272283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  272300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272339 */     GIR_RootConstrainSelectedInstOperands,
     /*  272340 */     // GIR_Coverage, 8400,
     /*  272340 */     GIR_EraseRootFromParent_Done,
     /*  272341 */   // Label 5178: @272341
     /*  272341 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(272404), // Rule ID 8401 //
     /*  272346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  272363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272385 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272402 */     GIR_RootConstrainSelectedInstOperands,
     /*  272403 */     // GIR_Coverage, 8401,
     /*  272403 */     GIR_EraseRootFromParent_Done,
     /*  272404 */   // Label 5179: @272404
     /*  272404 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(272467), // Rule ID 8404 //
     /*  272409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272465 */     GIR_RootConstrainSelectedInstOperands,
     /*  272466 */     // GIR_Coverage, 8404,
     /*  272466 */     GIR_EraseRootFromParent_Done,
     /*  272467 */   // Label 5180: @272467
     /*  272467 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(272530), // Rule ID 8405 //
     /*  272472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272511 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272528 */     GIR_RootConstrainSelectedInstOperands,
     /*  272529 */     // GIR_Coverage, 8405,
     /*  272529 */     GIR_EraseRootFromParent_Done,
     /*  272530 */   // Label 5181: @272530
     /*  272530 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(272593), // Rule ID 8408 //
     /*  272535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272591 */     GIR_RootConstrainSelectedInstOperands,
     /*  272592 */     // GIR_Coverage, 8408,
     /*  272592 */     GIR_EraseRootFromParent_Done,
     /*  272593 */   // Label 5182: @272593
     /*  272593 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(272656), // Rule ID 8409 //
     /*  272598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272637 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272654 */     GIR_RootConstrainSelectedInstOperands,
     /*  272655 */     // GIR_Coverage, 8409,
     /*  272655 */     GIR_EraseRootFromParent_Done,
     /*  272656 */   // Label 5183: @272656
     /*  272656 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(272719), // Rule ID 8412 //
     /*  272661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272717 */     GIR_RootConstrainSelectedInstOperands,
     /*  272718 */     // GIR_Coverage, 8412,
     /*  272718 */     GIR_EraseRootFromParent_Done,
     /*  272719 */   // Label 5184: @272719
     /*  272719 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(272782), // Rule ID 8413 //
     /*  272724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272763 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272780 */     GIR_RootConstrainSelectedInstOperands,
     /*  272781 */     // GIR_Coverage, 8413,
     /*  272781 */     GIR_EraseRootFromParent_Done,
     /*  272782 */   // Label 5185: @272782
     /*  272782 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(272845), // Rule ID 8416 //
     /*  272787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272843 */     GIR_RootConstrainSelectedInstOperands,
     /*  272844 */     // GIR_Coverage, 8416,
     /*  272844 */     GIR_EraseRootFromParent_Done,
     /*  272845 */   // Label 5186: @272845
     /*  272845 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(272908), // Rule ID 8417 //
     /*  272850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272889 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272906 */     GIR_RootConstrainSelectedInstOperands,
     /*  272907 */     // GIR_Coverage, 8417,
     /*  272907 */     GIR_EraseRootFromParent_Done,
     /*  272908 */   // Label 5187: @272908
     /*  272908 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(272971), // Rule ID 8420 //
     /*  272913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272969 */     GIR_RootConstrainSelectedInstOperands,
     /*  272970 */     // GIR_Coverage, 8420,
     /*  272970 */     GIR_EraseRootFromParent_Done,
     /*  272971 */   // Label 5188: @272971
     /*  272971 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(273034), // Rule ID 8421 //
     /*  272976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  273018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273032 */     GIR_RootConstrainSelectedInstOperands,
     /*  273033 */     // GIR_Coverage, 8421,
     /*  273033 */     GIR_EraseRootFromParent_Done,
     /*  273034 */   // Label 5189: @273034
     /*  273034 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(273097), // Rule ID 8424 //
     /*  273039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273095 */     GIR_RootConstrainSelectedInstOperands,
     /*  273096 */     // GIR_Coverage, 8424,
     /*  273096 */     GIR_EraseRootFromParent_Done,
     /*  273097 */   // Label 5190: @273097
     /*  273097 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(273160), // Rule ID 8425 //
     /*  273102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273141 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273158 */     GIR_RootConstrainSelectedInstOperands,
     /*  273159 */     // GIR_Coverage, 8425,
     /*  273159 */     GIR_EraseRootFromParent_Done,
     /*  273160 */   // Label 5191: @273160
     /*  273160 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(273223), // Rule ID 8428 //
     /*  273165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273221 */     GIR_RootConstrainSelectedInstOperands,
     /*  273222 */     // GIR_Coverage, 8428,
     /*  273222 */     GIR_EraseRootFromParent_Done,
     /*  273223 */   // Label 5192: @273223
     /*  273223 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(273286), // Rule ID 8429 //
     /*  273228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273284 */     GIR_RootConstrainSelectedInstOperands,
     /*  273285 */     // GIR_Coverage, 8429,
     /*  273285 */     GIR_EraseRootFromParent_Done,
     /*  273286 */   // Label 5193: @273286
     /*  273286 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(273349), // Rule ID 8432 //
     /*  273291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273347 */     GIR_RootConstrainSelectedInstOperands,
     /*  273348 */     // GIR_Coverage, 8432,
     /*  273348 */     GIR_EraseRootFromParent_Done,
     /*  273349 */   // Label 5194: @273349
     /*  273349 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(273412), // Rule ID 8433 //
     /*  273354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  273396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273410 */     GIR_RootConstrainSelectedInstOperands,
     /*  273411 */     // GIR_Coverage, 8433,
     /*  273411 */     GIR_EraseRootFromParent_Done,
     /*  273412 */   // Label 5195: @273412
     /*  273412 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(273475), // Rule ID 8436 //
     /*  273417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273473 */     GIR_RootConstrainSelectedInstOperands,
     /*  273474 */     // GIR_Coverage, 8436,
     /*  273474 */     GIR_EraseRootFromParent_Done,
     /*  273475 */   // Label 5196: @273475
     /*  273475 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(273538), // Rule ID 8437 //
     /*  273480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273536 */     GIR_RootConstrainSelectedInstOperands,
     /*  273537 */     // GIR_Coverage, 8437,
     /*  273537 */     GIR_EraseRootFromParent_Done,
     /*  273538 */   // Label 5197: @273538
     /*  273538 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(273601), // Rule ID 8440 //
     /*  273543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273599 */     GIR_RootConstrainSelectedInstOperands,
     /*  273600 */     // GIR_Coverage, 8440,
     /*  273600 */     GIR_EraseRootFromParent_Done,
     /*  273601 */   // Label 5198: @273601
     /*  273601 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(273664), // Rule ID 8441 //
     /*  273606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273645 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273662 */     GIR_RootConstrainSelectedInstOperands,
     /*  273663 */     // GIR_Coverage, 8441,
     /*  273663 */     GIR_EraseRootFromParent_Done,
     /*  273664 */   // Label 5199: @273664
     /*  273664 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(273727), // Rule ID 8444 //
     /*  273669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273708 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273725 */     GIR_RootConstrainSelectedInstOperands,
     /*  273726 */     // GIR_Coverage, 8444,
     /*  273726 */     GIR_EraseRootFromParent_Done,
     /*  273727 */   // Label 5200: @273727
     /*  273727 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(273790), // Rule ID 8445 //
     /*  273732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273771 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273788 */     GIR_RootConstrainSelectedInstOperands,
     /*  273789 */     // GIR_Coverage, 8445,
     /*  273789 */     GIR_EraseRootFromParent_Done,
     /*  273790 */   // Label 5201: @273790
     /*  273790 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(273853), // Rule ID 8448 //
     /*  273795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273851 */     GIR_RootConstrainSelectedInstOperands,
     /*  273852 */     // GIR_Coverage, 8448,
     /*  273852 */     GIR_EraseRootFromParent_Done,
     /*  273853 */   // Label 5202: @273853
     /*  273853 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(273916), // Rule ID 8449 //
     /*  273858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273897 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273914 */     GIR_RootConstrainSelectedInstOperands,
     /*  273915 */     // GIR_Coverage, 8449,
     /*  273915 */     GIR_EraseRootFromParent_Done,
     /*  273916 */   // Label 5203: @273916
     /*  273916 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(273979), // Rule ID 8452 //
     /*  273921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273977 */     GIR_RootConstrainSelectedInstOperands,
     /*  273978 */     // GIR_Coverage, 8452,
     /*  273978 */     GIR_EraseRootFromParent_Done,
     /*  273979 */   // Label 5204: @273979
     /*  273979 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(274042), // Rule ID 8453 //
     /*  273984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274023 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274040 */     GIR_RootConstrainSelectedInstOperands,
     /*  274041 */     // GIR_Coverage, 8453,
     /*  274041 */     GIR_EraseRootFromParent_Done,
     /*  274042 */   // Label 5205: @274042
     /*  274042 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(274105), // Rule ID 8456 //
     /*  274047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274086 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274103 */     GIR_RootConstrainSelectedInstOperands,
     /*  274104 */     // GIR_Coverage, 8456,
     /*  274104 */     GIR_EraseRootFromParent_Done,
     /*  274105 */   // Label 5206: @274105
     /*  274105 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(274168), // Rule ID 8457 //
     /*  274110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274149 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  274152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274166 */     GIR_RootConstrainSelectedInstOperands,
     /*  274167 */     // GIR_Coverage, 8457,
     /*  274167 */     GIR_EraseRootFromParent_Done,
     /*  274168 */   // Label 5207: @274168
     /*  274168 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(274231), // Rule ID 8460 //
     /*  274173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274229 */     GIR_RootConstrainSelectedInstOperands,
     /*  274230 */     // GIR_Coverage, 8460,
     /*  274230 */     GIR_EraseRootFromParent_Done,
     /*  274231 */   // Label 5208: @274231
     /*  274231 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(274294), // Rule ID 8461 //
     /*  274236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274275 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274292 */     GIR_RootConstrainSelectedInstOperands,
     /*  274293 */     // GIR_Coverage, 8461,
     /*  274293 */     GIR_EraseRootFromParent_Done,
     /*  274294 */   // Label 5209: @274294
     /*  274294 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(274357), // Rule ID 8464 //
     /*  274299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274338 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274355 */     GIR_RootConstrainSelectedInstOperands,
     /*  274356 */     // GIR_Coverage, 8464,
     /*  274356 */     GIR_EraseRootFromParent_Done,
     /*  274357 */   // Label 5210: @274357
     /*  274357 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(274420), // Rule ID 8465 //
     /*  274362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274401 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274418 */     GIR_RootConstrainSelectedInstOperands,
     /*  274419 */     // GIR_Coverage, 8465,
     /*  274419 */     GIR_EraseRootFromParent_Done,
     /*  274420 */   // Label 5211: @274420
     /*  274420 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(274483), // Rule ID 8468 //
     /*  274425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274464 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274481 */     GIR_RootConstrainSelectedInstOperands,
     /*  274482 */     // GIR_Coverage, 8468,
     /*  274482 */     GIR_EraseRootFromParent_Done,
     /*  274483 */   // Label 5212: @274483
     /*  274483 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(274546), // Rule ID 8469 //
     /*  274488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274527 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274544 */     GIR_RootConstrainSelectedInstOperands,
     /*  274545 */     // GIR_Coverage, 8469,
     /*  274545 */     GIR_EraseRootFromParent_Done,
     /*  274546 */   // Label 5213: @274546
     /*  274546 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(274609), // Rule ID 8472 //
     /*  274551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274607 */     GIR_RootConstrainSelectedInstOperands,
     /*  274608 */     // GIR_Coverage, 8472,
     /*  274608 */     GIR_EraseRootFromParent_Done,
     /*  274609 */   // Label 5214: @274609
     /*  274609 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(274672), // Rule ID 8473 //
     /*  274614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274653 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274670 */     GIR_RootConstrainSelectedInstOperands,
     /*  274671 */     // GIR_Coverage, 8473,
     /*  274671 */     GIR_EraseRootFromParent_Done,
     /*  274672 */   // Label 5215: @274672
     /*  274672 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(274735), // Rule ID 8476 //
     /*  274677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274733 */     GIR_RootConstrainSelectedInstOperands,
     /*  274734 */     // GIR_Coverage, 8476,
     /*  274734 */     GIR_EraseRootFromParent_Done,
     /*  274735 */   // Label 5216: @274735
     /*  274735 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(274798), // Rule ID 8477 //
     /*  274740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274779 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274796 */     GIR_RootConstrainSelectedInstOperands,
     /*  274797 */     // GIR_Coverage, 8477,
     /*  274797 */     GIR_EraseRootFromParent_Done,
     /*  274798 */   // Label 5217: @274798
     /*  274798 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(274861), // Rule ID 8480 //
     /*  274803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274842 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274859 */     GIR_RootConstrainSelectedInstOperands,
     /*  274860 */     // GIR_Coverage, 8480,
     /*  274860 */     GIR_EraseRootFromParent_Done,
     /*  274861 */   // Label 5218: @274861
     /*  274861 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(274924), // Rule ID 8481 //
     /*  274866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274905 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274922 */     GIR_RootConstrainSelectedInstOperands,
     /*  274923 */     // GIR_Coverage, 8481,
     /*  274923 */     GIR_EraseRootFromParent_Done,
     /*  274924 */   // Label 5219: @274924
     /*  274924 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(274987), // Rule ID 8484 //
     /*  274929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274985 */     GIR_RootConstrainSelectedInstOperands,
     /*  274986 */     // GIR_Coverage, 8484,
     /*  274986 */     GIR_EraseRootFromParent_Done,
     /*  274987 */   // Label 5220: @274987
     /*  274987 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(275050), // Rule ID 8485 //
     /*  274992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275031 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275048 */     GIR_RootConstrainSelectedInstOperands,
     /*  275049 */     // GIR_Coverage, 8485,
     /*  275049 */     GIR_EraseRootFromParent_Done,
     /*  275050 */   // Label 5221: @275050
     /*  275050 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(275113), // Rule ID 8488 //
     /*  275055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275094 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275111 */     GIR_RootConstrainSelectedInstOperands,
     /*  275112 */     // GIR_Coverage, 8488,
     /*  275112 */     GIR_EraseRootFromParent_Done,
     /*  275113 */   // Label 5222: @275113
     /*  275113 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(275176), // Rule ID 8489 //
     /*  275118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275157 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275174 */     GIR_RootConstrainSelectedInstOperands,
     /*  275175 */     // GIR_Coverage, 8489,
     /*  275175 */     GIR_EraseRootFromParent_Done,
     /*  275176 */   // Label 5223: @275176
     /*  275176 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(275239), // Rule ID 8492 //
     /*  275181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275237 */     GIR_RootConstrainSelectedInstOperands,
     /*  275238 */     // GIR_Coverage, 8492,
     /*  275238 */     GIR_EraseRootFromParent_Done,
     /*  275239 */   // Label 5224: @275239
     /*  275239 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(275302), // Rule ID 8493 //
     /*  275244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275300 */     GIR_RootConstrainSelectedInstOperands,
     /*  275301 */     // GIR_Coverage, 8493,
     /*  275301 */     GIR_EraseRootFromParent_Done,
     /*  275302 */   // Label 5225: @275302
     /*  275302 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(275365), // Rule ID 8496 //
     /*  275307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275363 */     GIR_RootConstrainSelectedInstOperands,
     /*  275364 */     // GIR_Coverage, 8496,
     /*  275364 */     GIR_EraseRootFromParent_Done,
     /*  275365 */   // Label 5226: @275365
     /*  275365 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(275428), // Rule ID 8497 //
     /*  275370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275409 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  275412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275426 */     GIR_RootConstrainSelectedInstOperands,
     /*  275427 */     // GIR_Coverage, 8497,
     /*  275427 */     GIR_EraseRootFromParent_Done,
     /*  275428 */   // Label 5227: @275428
     /*  275428 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(275491), // Rule ID 8500 //
     /*  275433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275489 */     GIR_RootConstrainSelectedInstOperands,
     /*  275490 */     // GIR_Coverage, 8500,
     /*  275490 */     GIR_EraseRootFromParent_Done,
     /*  275491 */   // Label 5228: @275491
     /*  275491 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(275554), // Rule ID 8501 //
     /*  275496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275552 */     GIR_RootConstrainSelectedInstOperands,
     /*  275553 */     // GIR_Coverage, 8501,
     /*  275553 */     GIR_EraseRootFromParent_Done,
     /*  275554 */   // Label 5229: @275554
     /*  275554 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(275617), // Rule ID 8504 //
     /*  275559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275598 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275615 */     GIR_RootConstrainSelectedInstOperands,
     /*  275616 */     // GIR_Coverage, 8504,
     /*  275616 */     GIR_EraseRootFromParent_Done,
     /*  275617 */   // Label 5230: @275617
     /*  275617 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(275680), // Rule ID 8505 //
     /*  275622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275661 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275678 */     GIR_RootConstrainSelectedInstOperands,
     /*  275679 */     // GIR_Coverage, 8505,
     /*  275679 */     GIR_EraseRootFromParent_Done,
     /*  275680 */   // Label 5231: @275680
     /*  275680 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(275743), // Rule ID 8508 //
     /*  275685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275741 */     GIR_RootConstrainSelectedInstOperands,
     /*  275742 */     // GIR_Coverage, 8508,
     /*  275742 */     GIR_EraseRootFromParent_Done,
     /*  275743 */   // Label 5232: @275743
     /*  275743 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(275806), // Rule ID 8509 //
     /*  275748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275804 */     GIR_RootConstrainSelectedInstOperands,
     /*  275805 */     // GIR_Coverage, 8509,
     /*  275805 */     GIR_EraseRootFromParent_Done,
     /*  275806 */   // Label 5233: @275806
     /*  275806 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(275869), // Rule ID 8512 //
     /*  275811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275867 */     GIR_RootConstrainSelectedInstOperands,
     /*  275868 */     // GIR_Coverage, 8512,
     /*  275868 */     GIR_EraseRootFromParent_Done,
     /*  275869 */   // Label 5234: @275869
     /*  275869 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(275932), // Rule ID 8513 //
     /*  275874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275930 */     GIR_RootConstrainSelectedInstOperands,
     /*  275931 */     // GIR_Coverage, 8513,
     /*  275931 */     GIR_EraseRootFromParent_Done,
     /*  275932 */   // Label 5235: @275932
     /*  275932 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(275995), // Rule ID 8516 //
     /*  275937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275993 */     GIR_RootConstrainSelectedInstOperands,
     /*  275994 */     // GIR_Coverage, 8516,
     /*  275994 */     GIR_EraseRootFromParent_Done,
     /*  275995 */   // Label 5236: @275995
     /*  275995 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(276058), // Rule ID 8517 //
     /*  276000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  276017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276039 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276056 */     GIR_RootConstrainSelectedInstOperands,
     /*  276057 */     // GIR_Coverage, 8517,
     /*  276057 */     GIR_EraseRootFromParent_Done,
     /*  276058 */   // Label 5237: @276058
     /*  276058 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(276121), // Rule ID 8520 //
     /*  276063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  276105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276119 */     GIR_RootConstrainSelectedInstOperands,
     /*  276120 */     // GIR_Coverage, 8520,
     /*  276120 */     GIR_EraseRootFromParent_Done,
     /*  276121 */   // Label 5238: @276121
     /*  276121 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(276184), // Rule ID 8521 //
     /*  276126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  276143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  276168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276182 */     GIR_RootConstrainSelectedInstOperands,
     /*  276183 */     // GIR_Coverage, 8521,
     /*  276183 */     GIR_EraseRootFromParent_Done,
     /*  276184 */   // Label 5239: @276184
     /*  276184 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(276247), // Rule ID 8524 //
     /*  276189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276245 */     GIR_RootConstrainSelectedInstOperands,
     /*  276246 */     // GIR_Coverage, 8524,
     /*  276246 */     GIR_EraseRootFromParent_Done,
     /*  276247 */   // Label 5240: @276247
     /*  276247 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(276310), // Rule ID 8525 //
     /*  276252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  276269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276291 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276308 */     GIR_RootConstrainSelectedInstOperands,
     /*  276309 */     // GIR_Coverage, 8525,
     /*  276309 */     GIR_EraseRootFromParent_Done,
     /*  276310 */   // Label 5241: @276310
     /*  276310 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(276373), // Rule ID 8528 //
     /*  276315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276354 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276371 */     GIR_RootConstrainSelectedInstOperands,
     /*  276372 */     // GIR_Coverage, 8528,
     /*  276372 */     GIR_EraseRootFromParent_Done,
     /*  276373 */   // Label 5242: @276373
     /*  276373 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(276436), // Rule ID 8529 //
     /*  276378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  276395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276417 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  276420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276434 */     GIR_RootConstrainSelectedInstOperands,
     /*  276435 */     // GIR_Coverage, 8529,
     /*  276435 */     GIR_EraseRootFromParent_Done,
     /*  276436 */   // Label 5243: @276436
     /*  276436 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(276499), // Rule ID 8532 //
     /*  276441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276497 */     GIR_RootConstrainSelectedInstOperands,
     /*  276498 */     // GIR_Coverage, 8532,
     /*  276498 */     GIR_EraseRootFromParent_Done,
     /*  276499 */   // Label 5244: @276499
     /*  276499 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(276562), // Rule ID 8533 //
     /*  276504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276543 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276560 */     GIR_RootConstrainSelectedInstOperands,
     /*  276561 */     // GIR_Coverage, 8533,
     /*  276561 */     GIR_EraseRootFromParent_Done,
     /*  276562 */   // Label 5245: @276562
     /*  276562 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(276625), // Rule ID 8536 //
     /*  276567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276623 */     GIR_RootConstrainSelectedInstOperands,
     /*  276624 */     // GIR_Coverage, 8536,
     /*  276624 */     GIR_EraseRootFromParent_Done,
     /*  276625 */   // Label 5246: @276625
     /*  276625 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(276688), // Rule ID 8537 //
     /*  276630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276669 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276686 */     GIR_RootConstrainSelectedInstOperands,
     /*  276687 */     // GIR_Coverage, 8537,
     /*  276687 */     GIR_EraseRootFromParent_Done,
     /*  276688 */   // Label 5247: @276688
     /*  276688 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(276751), // Rule ID 8540 //
     /*  276693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276749 */     GIR_RootConstrainSelectedInstOperands,
     /*  276750 */     // GIR_Coverage, 8540,
     /*  276750 */     GIR_EraseRootFromParent_Done,
     /*  276751 */   // Label 5248: @276751
     /*  276751 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(276814), // Rule ID 8541 //
     /*  276756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276795 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276812 */     GIR_RootConstrainSelectedInstOperands,
     /*  276813 */     // GIR_Coverage, 8541,
     /*  276813 */     GIR_EraseRootFromParent_Done,
     /*  276814 */   // Label 5249: @276814
     /*  276814 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(276877), // Rule ID 8544 //
     /*  276819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276875 */     GIR_RootConstrainSelectedInstOperands,
     /*  276876 */     // GIR_Coverage, 8544,
     /*  276876 */     GIR_EraseRootFromParent_Done,
     /*  276877 */   // Label 5250: @276877
     /*  276877 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(276940), // Rule ID 8545 //
     /*  276882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276921 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276938 */     GIR_RootConstrainSelectedInstOperands,
     /*  276939 */     // GIR_Coverage, 8545,
     /*  276939 */     GIR_EraseRootFromParent_Done,
     /*  276940 */   // Label 5251: @276940
     /*  276940 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(277003), // Rule ID 8548 //
     /*  276945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277001 */     GIR_RootConstrainSelectedInstOperands,
     /*  277002 */     // GIR_Coverage, 8548,
     /*  277002 */     GIR_EraseRootFromParent_Done,
     /*  277003 */   // Label 5252: @277003
     /*  277003 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(277066), // Rule ID 8549 //
     /*  277008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  277025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277047 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277064 */     GIR_RootConstrainSelectedInstOperands,
     /*  277065 */     // GIR_Coverage, 8549,
     /*  277065 */     GIR_EraseRootFromParent_Done,
     /*  277066 */   // Label 5253: @277066
     /*  277066 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(277129), // Rule ID 8552 //
     /*  277071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277127 */     GIR_RootConstrainSelectedInstOperands,
     /*  277128 */     // GIR_Coverage, 8552,
     /*  277128 */     GIR_EraseRootFromParent_Done,
     /*  277129 */   // Label 5254: @277129
     /*  277129 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(277192), // Rule ID 8553 //
     /*  277134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  277151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277173 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277190 */     GIR_RootConstrainSelectedInstOperands,
     /*  277191 */     // GIR_Coverage, 8553,
     /*  277191 */     GIR_EraseRootFromParent_Done,
     /*  277192 */   // Label 5255: @277192
     /*  277192 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(277255), // Rule ID 8556 //
     /*  277197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277236 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277253 */     GIR_RootConstrainSelectedInstOperands,
     /*  277254 */     // GIR_Coverage, 8556,
     /*  277254 */     GIR_EraseRootFromParent_Done,
     /*  277255 */   // Label 5256: @277255
     /*  277255 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(277318), // Rule ID 8557 //
     /*  277260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  277277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277299 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277316 */     GIR_RootConstrainSelectedInstOperands,
     /*  277317 */     // GIR_Coverage, 8557,
     /*  277317 */     GIR_EraseRootFromParent_Done,
     /*  277318 */   // Label 5257: @277318
     /*  277318 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(277381), // Rule ID 8560 //
     /*  277323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277379 */     GIR_RootConstrainSelectedInstOperands,
     /*  277380 */     // GIR_Coverage, 8560,
     /*  277380 */     GIR_EraseRootFromParent_Done,
     /*  277381 */   // Label 5258: @277381
     /*  277381 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(277444), // Rule ID 8561 //
     /*  277386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  277403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277425 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277442 */     GIR_RootConstrainSelectedInstOperands,
     /*  277443 */     // GIR_Coverage, 8561,
     /*  277443 */     GIR_EraseRootFromParent_Done,
     /*  277444 */   // Label 5259: @277444
     /*  277444 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(277507), // Rule ID 8564 //
     /*  277449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277505 */     GIR_RootConstrainSelectedInstOperands,
     /*  277506 */     // GIR_Coverage, 8564,
     /*  277506 */     GIR_EraseRootFromParent_Done,
     /*  277507 */   // Label 5260: @277507
     /*  277507 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(277570), // Rule ID 8565 //
     /*  277512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277551 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277568 */     GIR_RootConstrainSelectedInstOperands,
     /*  277569 */     // GIR_Coverage, 8565,
     /*  277569 */     GIR_EraseRootFromParent_Done,
     /*  277570 */   // Label 5261: @277570
     /*  277570 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(277633), // Rule ID 8568 //
     /*  277575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277614 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277631 */     GIR_RootConstrainSelectedInstOperands,
     /*  277632 */     // GIR_Coverage, 8568,
     /*  277632 */     GIR_EraseRootFromParent_Done,
     /*  277633 */   // Label 5262: @277633
     /*  277633 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(277696), // Rule ID 8569 //
     /*  277638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277677 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277694 */     GIR_RootConstrainSelectedInstOperands,
     /*  277695 */     // GIR_Coverage, 8569,
     /*  277695 */     GIR_EraseRootFromParent_Done,
     /*  277696 */   // Label 5263: @277696
     /*  277696 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(277759), // Rule ID 8572 //
     /*  277701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277757 */     GIR_RootConstrainSelectedInstOperands,
     /*  277758 */     // GIR_Coverage, 8572,
     /*  277758 */     GIR_EraseRootFromParent_Done,
     /*  277759 */   // Label 5264: @277759
     /*  277759 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(277822), // Rule ID 8573 //
     /*  277764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277803 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277820 */     GIR_RootConstrainSelectedInstOperands,
     /*  277821 */     // GIR_Coverage, 8573,
     /*  277821 */     GIR_EraseRootFromParent_Done,
     /*  277822 */   // Label 5265: @277822
     /*  277822 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(277885), // Rule ID 8576 //
     /*  277827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277883 */     GIR_RootConstrainSelectedInstOperands,
     /*  277884 */     // GIR_Coverage, 8576,
     /*  277884 */     GIR_EraseRootFromParent_Done,
     /*  277885 */   // Label 5266: @277885
     /*  277885 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(277948), // Rule ID 8577 //
     /*  277890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277929 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277946 */     GIR_RootConstrainSelectedInstOperands,
     /*  277947 */     // GIR_Coverage, 8577,
     /*  277947 */     GIR_EraseRootFromParent_Done,
     /*  277948 */   // Label 5267: @277948
     /*  277948 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(278011), // Rule ID 8580 //
     /*  277953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278009 */     GIR_RootConstrainSelectedInstOperands,
     /*  278010 */     // GIR_Coverage, 8580,
     /*  278010 */     GIR_EraseRootFromParent_Done,
     /*  278011 */   // Label 5268: @278011
     /*  278011 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(278074), // Rule ID 8581 //
     /*  278016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  278033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278055 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278072 */     GIR_RootConstrainSelectedInstOperands,
     /*  278073 */     // GIR_Coverage, 8581,
     /*  278073 */     GIR_EraseRootFromParent_Done,
     /*  278074 */   // Label 5269: @278074
     /*  278074 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(278137), // Rule ID 8584 //
     /*  278079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  278121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278135 */     GIR_RootConstrainSelectedInstOperands,
     /*  278136 */     // GIR_Coverage, 8584,
     /*  278136 */     GIR_EraseRootFromParent_Done,
     /*  278137 */   // Label 5270: @278137
     /*  278137 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(278200), // Rule ID 8585 //
     /*  278142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  278159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278181 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  278184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278198 */     GIR_RootConstrainSelectedInstOperands,
     /*  278199 */     // GIR_Coverage, 8585,
     /*  278199 */     GIR_EraseRootFromParent_Done,
     /*  278200 */   // Label 5271: @278200
     /*  278200 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(278263), // Rule ID 8588 //
     /*  278205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  278247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278261 */     GIR_RootConstrainSelectedInstOperands,
     /*  278262 */     // GIR_Coverage, 8588,
     /*  278262 */     GIR_EraseRootFromParent_Done,
     /*  278263 */   // Label 5272: @278263
     /*  278263 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(278326), // Rule ID 8589 //
     /*  278268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  278285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278307 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  278310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278324 */     GIR_RootConstrainSelectedInstOperands,
     /*  278325 */     // GIR_Coverage, 8589,
     /*  278325 */     GIR_EraseRootFromParent_Done,
     /*  278326 */   // Label 5273: @278326
     /*  278326 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(278389), // Rule ID 8592 //
     /*  278331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278387 */     GIR_RootConstrainSelectedInstOperands,
     /*  278388 */     // GIR_Coverage, 8592,
     /*  278388 */     GIR_EraseRootFromParent_Done,
     /*  278389 */   // Label 5274: @278389
     /*  278389 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(278452), // Rule ID 8593 //
     /*  278394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  278411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278433 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  278436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278450 */     GIR_RootConstrainSelectedInstOperands,
     /*  278451 */     // GIR_Coverage, 8593,
     /*  278451 */     GIR_EraseRootFromParent_Done,
     /*  278452 */   // Label 5275: @278452
     /*  278452 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(278515), // Rule ID 8596 //
     /*  278457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278513 */     GIR_RootConstrainSelectedInstOperands,
     /*  278514 */     // GIR_Coverage, 8596,
     /*  278514 */     GIR_EraseRootFromParent_Done,
     /*  278515 */   // Label 5276: @278515
     /*  278515 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(278578), // Rule ID 8597 //
     /*  278520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278576 */     GIR_RootConstrainSelectedInstOperands,
     /*  278577 */     // GIR_Coverage, 8597,
     /*  278577 */     GIR_EraseRootFromParent_Done,
     /*  278578 */   // Label 5277: @278578
     /*  278578 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(278641), // Rule ID 8600 //
     /*  278583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278639 */     GIR_RootConstrainSelectedInstOperands,
     /*  278640 */     // GIR_Coverage, 8600,
     /*  278640 */     GIR_EraseRootFromParent_Done,
     /*  278641 */   // Label 5278: @278641
     /*  278641 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(278704), // Rule ID 8601 //
     /*  278646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278702 */     GIR_RootConstrainSelectedInstOperands,
     /*  278703 */     // GIR_Coverage, 8601,
     /*  278703 */     GIR_EraseRootFromParent_Done,
     /*  278704 */   // Label 5279: @278704
     /*  278704 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(278767), // Rule ID 8604 //
     /*  278709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278765 */     GIR_RootConstrainSelectedInstOperands,
     /*  278766 */     // GIR_Coverage, 8604,
     /*  278766 */     GIR_EraseRootFromParent_Done,
     /*  278767 */   // Label 5280: @278767
     /*  278767 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(278830), // Rule ID 8605 //
     /*  278772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278811 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278828 */     GIR_RootConstrainSelectedInstOperands,
     /*  278829 */     // GIR_Coverage, 8605,
     /*  278829 */     GIR_EraseRootFromParent_Done,
     /*  278830 */   // Label 5281: @278830
     /*  278830 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(278893), // Rule ID 8608 //
     /*  278835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278891 */     GIR_RootConstrainSelectedInstOperands,
     /*  278892 */     // GIR_Coverage, 8608,
     /*  278892 */     GIR_EraseRootFromParent_Done,
     /*  278893 */   // Label 5282: @278893
     /*  278893 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(278956), // Rule ID 8609 //
     /*  278898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278937 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278954 */     GIR_RootConstrainSelectedInstOperands,
     /*  278955 */     // GIR_Coverage, 8609,
     /*  278955 */     GIR_EraseRootFromParent_Done,
     /*  278956 */   // Label 5283: @278956
     /*  278956 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(279019), // Rule ID 8612 //
     /*  278961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279017 */     GIR_RootConstrainSelectedInstOperands,
     /*  279018 */     // GIR_Coverage, 8612,
     /*  279018 */     GIR_EraseRootFromParent_Done,
     /*  279019 */   // Label 5284: @279019
     /*  279019 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(279082), // Rule ID 8613 //
     /*  279024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279080 */     GIR_RootConstrainSelectedInstOperands,
     /*  279081 */     // GIR_Coverage, 8613,
     /*  279081 */     GIR_EraseRootFromParent_Done,
     /*  279082 */   // Label 5285: @279082
     /*  279082 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(279145), // Rule ID 8616 //
     /*  279087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279143 */     GIR_RootConstrainSelectedInstOperands,
     /*  279144 */     // GIR_Coverage, 8616,
     /*  279144 */     GIR_EraseRootFromParent_Done,
     /*  279145 */   // Label 5286: @279145
     /*  279145 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(279208), // Rule ID 8617 //
     /*  279150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279189 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  279192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279206 */     GIR_RootConstrainSelectedInstOperands,
     /*  279207 */     // GIR_Coverage, 8617,
     /*  279207 */     GIR_EraseRootFromParent_Done,
     /*  279208 */   // Label 5287: @279208
     /*  279208 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(279271), // Rule ID 8620 //
     /*  279213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279269 */     GIR_RootConstrainSelectedInstOperands,
     /*  279270 */     // GIR_Coverage, 8620,
     /*  279270 */     GIR_EraseRootFromParent_Done,
     /*  279271 */   // Label 5288: @279271
     /*  279271 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(279334), // Rule ID 8621 //
     /*  279276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279315 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279332 */     GIR_RootConstrainSelectedInstOperands,
     /*  279333 */     // GIR_Coverage, 8621,
     /*  279333 */     GIR_EraseRootFromParent_Done,
     /*  279334 */   // Label 5289: @279334
     /*  279334 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(279397), // Rule ID 8624 //
     /*  279339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279395 */     GIR_RootConstrainSelectedInstOperands,
     /*  279396 */     // GIR_Coverage, 8624,
     /*  279396 */     GIR_EraseRootFromParent_Done,
     /*  279397 */   // Label 5290: @279397
     /*  279397 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(279460), // Rule ID 8625 //
     /*  279402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279441 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279458 */     GIR_RootConstrainSelectedInstOperands,
     /*  279459 */     // GIR_Coverage, 8625,
     /*  279459 */     GIR_EraseRootFromParent_Done,
     /*  279460 */   // Label 5291: @279460
     /*  279460 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(279523), // Rule ID 8628 //
     /*  279465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279504 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279521 */     GIR_RootConstrainSelectedInstOperands,
     /*  279522 */     // GIR_Coverage, 8628,
     /*  279522 */     GIR_EraseRootFromParent_Done,
     /*  279523 */   // Label 5292: @279523
     /*  279523 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(279586), // Rule ID 8629 //
     /*  279528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279567 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279584 */     GIR_RootConstrainSelectedInstOperands,
     /*  279585 */     // GIR_Coverage, 8629,
     /*  279585 */     GIR_EraseRootFromParent_Done,
     /*  279586 */   // Label 5293: @279586
     /*  279586 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(279649), // Rule ID 8632 //
     /*  279591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  279594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  279630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279647 */     GIR_RootConstrainSelectedInstOperands,
     /*  279648 */     // GIR_Coverage, 8632,
     /*  279648 */     GIR_EraseRootFromParent_Done,
     /*  279649 */   // Label 5294: @279649
     /*  279649 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(279712), // Rule ID 8633 //
     /*  279654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279693 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279710 */     GIR_RootConstrainSelectedInstOperands,
     /*  279711 */     // GIR_Coverage, 8633,
     /*  279711 */     GIR_EraseRootFromParent_Done,
     /*  279712 */   // Label 5295: @279712
     /*  279712 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(279775), // Rule ID 8636 //
     /*  279717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279756 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279773 */     GIR_RootConstrainSelectedInstOperands,
     /*  279774 */     // GIR_Coverage, 8636,
     /*  279774 */     GIR_EraseRootFromParent_Done,
     /*  279775 */   // Label 5296: @279775
     /*  279775 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(279838), // Rule ID 8637 //
     /*  279780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279836 */     GIR_RootConstrainSelectedInstOperands,
     /*  279837 */     // GIR_Coverage, 8637,
     /*  279837 */     GIR_EraseRootFromParent_Done,
     /*  279838 */   // Label 5297: @279838
     /*  279838 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(279901), // Rule ID 8640 //
     /*  279843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279882 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279899 */     GIR_RootConstrainSelectedInstOperands,
     /*  279900 */     // GIR_Coverage, 8640,
     /*  279900 */     GIR_EraseRootFromParent_Done,
     /*  279901 */   // Label 5298: @279901
     /*  279901 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(279964), // Rule ID 8641 //
     /*  279906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279945 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279962 */     GIR_RootConstrainSelectedInstOperands,
     /*  279963 */     // GIR_Coverage, 8641,
     /*  279963 */     GIR_EraseRootFromParent_Done,
     /*  279964 */   // Label 5299: @279964
     /*  279964 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(280027), // Rule ID 8644 //
     /*  279969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280008 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280025 */     GIR_RootConstrainSelectedInstOperands,
     /*  280026 */     // GIR_Coverage, 8644,
     /*  280026 */     GIR_EraseRootFromParent_Done,
     /*  280027 */   // Label 5300: @280027
     /*  280027 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(280090), // Rule ID 8645 //
     /*  280032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280071 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280088 */     GIR_RootConstrainSelectedInstOperands,
     /*  280089 */     // GIR_Coverage, 8645,
     /*  280089 */     GIR_EraseRootFromParent_Done,
     /*  280090 */   // Label 5301: @280090
     /*  280090 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(280153), // Rule ID 8648 //
     /*  280095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280151 */     GIR_RootConstrainSelectedInstOperands,
     /*  280152 */     // GIR_Coverage, 8648,
     /*  280152 */     GIR_EraseRootFromParent_Done,
     /*  280153 */   // Label 5302: @280153
     /*  280153 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(280216), // Rule ID 8649 //
     /*  280158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280197 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280214 */     GIR_RootConstrainSelectedInstOperands,
     /*  280215 */     // GIR_Coverage, 8649,
     /*  280215 */     GIR_EraseRootFromParent_Done,
     /*  280216 */   // Label 5303: @280216
     /*  280216 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(280279), // Rule ID 8652 //
     /*  280221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280277 */     GIR_RootConstrainSelectedInstOperands,
     /*  280278 */     // GIR_Coverage, 8652,
     /*  280278 */     GIR_EraseRootFromParent_Done,
     /*  280279 */   // Label 5304: @280279
     /*  280279 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(280342), // Rule ID 8653 //
     /*  280284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280340 */     GIR_RootConstrainSelectedInstOperands,
     /*  280341 */     // GIR_Coverage, 8653,
     /*  280341 */     GIR_EraseRootFromParent_Done,
     /*  280342 */   // Label 5305: @280342
     /*  280342 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(280405), // Rule ID 8656 //
     /*  280347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280386 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280403 */     GIR_RootConstrainSelectedInstOperands,
     /*  280404 */     // GIR_Coverage, 8656,
     /*  280404 */     GIR_EraseRootFromParent_Done,
     /*  280405 */   // Label 5306: @280405
     /*  280405 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(280468), // Rule ID 8657 //
     /*  280410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280449 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280466 */     GIR_RootConstrainSelectedInstOperands,
     /*  280467 */     // GIR_Coverage, 8657,
     /*  280467 */     GIR_EraseRootFromParent_Done,
     /*  280468 */   // Label 5307: @280468
     /*  280468 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(280531), // Rule ID 8660 //
     /*  280473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280529 */     GIR_RootConstrainSelectedInstOperands,
     /*  280530 */     // GIR_Coverage, 8660,
     /*  280530 */     GIR_EraseRootFromParent_Done,
     /*  280531 */   // Label 5308: @280531
     /*  280531 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(280594), // Rule ID 8661 //
     /*  280536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280575 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280592 */     GIR_RootConstrainSelectedInstOperands,
     /*  280593 */     // GIR_Coverage, 8661,
     /*  280593 */     GIR_EraseRootFromParent_Done,
     /*  280594 */   // Label 5309: @280594
     /*  280594 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(280657), // Rule ID 8664 //
     /*  280599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280638 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280655 */     GIR_RootConstrainSelectedInstOperands,
     /*  280656 */     // GIR_Coverage, 8664,
     /*  280656 */     GIR_EraseRootFromParent_Done,
     /*  280657 */   // Label 5310: @280657
     /*  280657 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(280720), // Rule ID 8665 //
     /*  280662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280701 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280718 */     GIR_RootConstrainSelectedInstOperands,
     /*  280719 */     // GIR_Coverage, 8665,
     /*  280719 */     GIR_EraseRootFromParent_Done,
     /*  280720 */   // Label 5311: @280720
     /*  280720 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(280783), // Rule ID 8668 //
     /*  280725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280781 */     GIR_RootConstrainSelectedInstOperands,
     /*  280782 */     // GIR_Coverage, 8668,
     /*  280782 */     GIR_EraseRootFromParent_Done,
     /*  280783 */   // Label 5312: @280783
     /*  280783 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(280846), // Rule ID 8669 //
     /*  280788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280844 */     GIR_RootConstrainSelectedInstOperands,
     /*  280845 */     // GIR_Coverage, 8669,
     /*  280845 */     GIR_EraseRootFromParent_Done,
     /*  280846 */   // Label 5313: @280846
     /*  280846 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(280909), // Rule ID 8672 //
     /*  280851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280890 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280907 */     GIR_RootConstrainSelectedInstOperands,
     /*  280908 */     // GIR_Coverage, 8672,
     /*  280908 */     GIR_EraseRootFromParent_Done,
     /*  280909 */   // Label 5314: @280909
     /*  280909 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(280972), // Rule ID 8673 //
     /*  280914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280953 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280970 */     GIR_RootConstrainSelectedInstOperands,
     /*  280971 */     // GIR_Coverage, 8673,
     /*  280971 */     GIR_EraseRootFromParent_Done,
     /*  280972 */   // Label 5315: @280972
     /*  280972 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(281035), // Rule ID 8676 //
     /*  280977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  281019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281033 */     GIR_RootConstrainSelectedInstOperands,
     /*  281034 */     // GIR_Coverage, 8676,
     /*  281034 */     GIR_EraseRootFromParent_Done,
     /*  281035 */   // Label 5316: @281035
     /*  281035 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(281098), // Rule ID 8677 //
     /*  281040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281079 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  281082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281096 */     GIR_RootConstrainSelectedInstOperands,
     /*  281097 */     // GIR_Coverage, 8677,
     /*  281097 */     GIR_EraseRootFromParent_Done,
     /*  281098 */   // Label 5317: @281098
     /*  281098 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(281161), // Rule ID 8680 //
     /*  281103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  281145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281159 */     GIR_RootConstrainSelectedInstOperands,
     /*  281160 */     // GIR_Coverage, 8680,
     /*  281160 */     GIR_EraseRootFromParent_Done,
     /*  281161 */   // Label 5318: @281161
     /*  281161 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(281224), // Rule ID 8681 //
     /*  281166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281205 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  281208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281222 */     GIR_RootConstrainSelectedInstOperands,
     /*  281223 */     // GIR_Coverage, 8681,
     /*  281223 */     GIR_EraseRootFromParent_Done,
     /*  281224 */   // Label 5319: @281224
     /*  281224 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(281287), // Rule ID 8684 //
     /*  281229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  281271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281285 */     GIR_RootConstrainSelectedInstOperands,
     /*  281286 */     // GIR_Coverage, 8684,
     /*  281286 */     GIR_EraseRootFromParent_Done,
     /*  281287 */   // Label 5320: @281287
     /*  281287 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(281350), // Rule ID 8685 //
     /*  281292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  281309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281331 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  281334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281348 */     GIR_RootConstrainSelectedInstOperands,
     /*  281349 */     // GIR_Coverage, 8685,
     /*  281349 */     GIR_EraseRootFromParent_Done,
     /*  281350 */   // Label 5321: @281350
     /*  281350 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(281413), // Rule ID 8688 //
     /*  281355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  281372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281411 */     GIR_RootConstrainSelectedInstOperands,
     /*  281412 */     // GIR_Coverage, 8688,
     /*  281412 */     GIR_EraseRootFromParent_Done,
     /*  281413 */   // Label 5322: @281413
     /*  281413 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(281476), // Rule ID 8689 //
     /*  281418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  281435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281474 */     GIR_RootConstrainSelectedInstOperands,
     /*  281475 */     // GIR_Coverage, 8689,
     /*  281475 */     GIR_EraseRootFromParent_Done,
     /*  281476 */   // Label 5323: @281476
     /*  281476 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(281539), // Rule ID 8692 //
     /*  281481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281537 */     GIR_RootConstrainSelectedInstOperands,
     /*  281538 */     // GIR_Coverage, 8692,
     /*  281538 */     GIR_EraseRootFromParent_Done,
     /*  281539 */   // Label 5324: @281539
     /*  281539 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(281602), // Rule ID 8693 //
     /*  281544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281600 */     GIR_RootConstrainSelectedInstOperands,
     /*  281601 */     // GIR_Coverage, 8693,
     /*  281601 */     GIR_EraseRootFromParent_Done,
     /*  281602 */   // Label 5325: @281602
     /*  281602 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(281665), // Rule ID 8696 //
     /*  281607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281663 */     GIR_RootConstrainSelectedInstOperands,
     /*  281664 */     // GIR_Coverage, 8696,
     /*  281664 */     GIR_EraseRootFromParent_Done,
     /*  281665 */   // Label 5326: @281665
     /*  281665 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(281728), // Rule ID 8697 //
     /*  281670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281709 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281726 */     GIR_RootConstrainSelectedInstOperands,
     /*  281727 */     // GIR_Coverage, 8697,
     /*  281727 */     GIR_EraseRootFromParent_Done,
     /*  281728 */   // Label 5327: @281728
     /*  281728 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(281791), // Rule ID 8700 //
     /*  281733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281789 */     GIR_RootConstrainSelectedInstOperands,
     /*  281790 */     // GIR_Coverage, 8700,
     /*  281790 */     GIR_EraseRootFromParent_Done,
     /*  281791 */   // Label 5328: @281791
     /*  281791 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(281854), // Rule ID 8701 //
     /*  281796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281852 */     GIR_RootConstrainSelectedInstOperands,
     /*  281853 */     // GIR_Coverage, 8701,
     /*  281853 */     GIR_EraseRootFromParent_Done,
     /*  281854 */   // Label 5329: @281854
     /*  281854 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(281917), // Rule ID 8704 //
     /*  281859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281898 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281915 */     GIR_RootConstrainSelectedInstOperands,
     /*  281916 */     // GIR_Coverage, 8704,
     /*  281916 */     GIR_EraseRootFromParent_Done,
     /*  281917 */   // Label 5330: @281917
     /*  281917 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(281980), // Rule ID 8705 //
     /*  281922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281961 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281978 */     GIR_RootConstrainSelectedInstOperands,
     /*  281979 */     // GIR_Coverage, 8705,
     /*  281979 */     GIR_EraseRootFromParent_Done,
     /*  281980 */   // Label 5331: @281980
     /*  281980 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(282043), // Rule ID 8708 //
     /*  281985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282041 */     GIR_RootConstrainSelectedInstOperands,
     /*  282042 */     // GIR_Coverage, 8708,
     /*  282042 */     GIR_EraseRootFromParent_Done,
     /*  282043 */   // Label 5332: @282043
     /*  282043 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(282106), // Rule ID 8709 //
     /*  282048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  282065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282087 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282104 */     GIR_RootConstrainSelectedInstOperands,
     /*  282105 */     // GIR_Coverage, 8709,
     /*  282105 */     GIR_EraseRootFromParent_Done,
     /*  282106 */   // Label 5333: @282106
     /*  282106 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(282169), // Rule ID 8712 //
     /*  282111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282150 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282167 */     GIR_RootConstrainSelectedInstOperands,
     /*  282168 */     // GIR_Coverage, 8712,
     /*  282168 */     GIR_EraseRootFromParent_Done,
     /*  282169 */   // Label 5334: @282169
     /*  282169 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(282232), // Rule ID 8713 //
     /*  282174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  282191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282213 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282230 */     GIR_RootConstrainSelectedInstOperands,
     /*  282231 */     // GIR_Coverage, 8713,
     /*  282231 */     GIR_EraseRootFromParent_Done,
     /*  282232 */   // Label 5335: @282232
     /*  282232 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(282295), // Rule ID 8716 //
     /*  282237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  282254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282293 */     GIR_RootConstrainSelectedInstOperands,
     /*  282294 */     // GIR_Coverage, 8716,
     /*  282294 */     GIR_EraseRootFromParent_Done,
     /*  282295 */   // Label 5336: @282295
     /*  282295 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(282358), // Rule ID 8717 //
     /*  282300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  282317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282339 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282356 */     GIR_RootConstrainSelectedInstOperands,
     /*  282357 */     // GIR_Coverage, 8717,
     /*  282357 */     GIR_EraseRootFromParent_Done,
     /*  282358 */   // Label 5337: @282358
     /*  282358 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(282421), // Rule ID 8720 //
     /*  282363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  282380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  282402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282419 */     GIR_RootConstrainSelectedInstOperands,
     /*  282420 */     // GIR_Coverage, 8720,
     /*  282420 */     GIR_EraseRootFromParent_Done,
     /*  282421 */   // Label 5338: @282421
     /*  282421 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(282484), // Rule ID 8721 //
     /*  282426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  282429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  282443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  282465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282482 */     GIR_RootConstrainSelectedInstOperands,
     /*  282483 */     // GIR_Coverage, 8721,
     /*  282483 */     GIR_EraseRootFromParent_Done,
     /*  282484 */   // Label 5339: @282484
     /*  282484 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(282547), // Rule ID 8724 //
     /*  282489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282545 */     GIR_RootConstrainSelectedInstOperands,
     /*  282546 */     // GIR_Coverage, 8724,
     /*  282546 */     GIR_EraseRootFromParent_Done,
     /*  282547 */   // Label 5340: @282547
     /*  282547 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(282610), // Rule ID 8725 //
     /*  282552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282608 */     GIR_RootConstrainSelectedInstOperands,
     /*  282609 */     // GIR_Coverage, 8725,
     /*  282609 */     GIR_EraseRootFromParent_Done,
     /*  282610 */   // Label 5341: @282610
     /*  282610 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(282673), // Rule ID 8728 //
     /*  282615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282654 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282671 */     GIR_RootConstrainSelectedInstOperands,
     /*  282672 */     // GIR_Coverage, 8728,
     /*  282672 */     GIR_EraseRootFromParent_Done,
     /*  282673 */   // Label 5342: @282673
     /*  282673 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(282736), // Rule ID 8729 //
     /*  282678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282717 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282734 */     GIR_RootConstrainSelectedInstOperands,
     /*  282735 */     // GIR_Coverage, 8729,
     /*  282735 */     GIR_EraseRootFromParent_Done,
     /*  282736 */   // Label 5343: @282736
     /*  282736 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(282799), // Rule ID 8732 //
     /*  282741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282780 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282797 */     GIR_RootConstrainSelectedInstOperands,
     /*  282798 */     // GIR_Coverage, 8732,
     /*  282798 */     GIR_EraseRootFromParent_Done,
     /*  282799 */   // Label 5344: @282799
     /*  282799 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(282862), // Rule ID 8733 //
     /*  282804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282843 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282860 */     GIR_RootConstrainSelectedInstOperands,
     /*  282861 */     // GIR_Coverage, 8733,
     /*  282861 */     GIR_EraseRootFromParent_Done,
     /*  282862 */   // Label 5345: @282862
     /*  282862 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(282925), // Rule ID 8736 //
     /*  282867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282906 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282923 */     GIR_RootConstrainSelectedInstOperands,
     /*  282924 */     // GIR_Coverage, 8736,
     /*  282924 */     GIR_EraseRootFromParent_Done,
     /*  282925 */   // Label 5346: @282925
     /*  282925 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(282988), // Rule ID 8737 //
     /*  282930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282969 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282986 */     GIR_RootConstrainSelectedInstOperands,
     /*  282987 */     // GIR_Coverage, 8737,
     /*  282987 */     GIR_EraseRootFromParent_Done,
     /*  282988 */   // Label 5347: @282988
     /*  282988 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(283051), // Rule ID 8740 //
     /*  282993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283049 */     GIR_RootConstrainSelectedInstOperands,
     /*  283050 */     // GIR_Coverage, 8740,
     /*  283050 */     GIR_EraseRootFromParent_Done,
     /*  283051 */   // Label 5348: @283051
     /*  283051 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(283114), // Rule ID 8741 //
     /*  283056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  283073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283112 */     GIR_RootConstrainSelectedInstOperands,
     /*  283113 */     // GIR_Coverage, 8741,
     /*  283113 */     GIR_EraseRootFromParent_Done,
     /*  283114 */   // Label 5349: @283114
     /*  283114 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(283177), // Rule ID 8744 //
     /*  283119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283158 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283175 */     GIR_RootConstrainSelectedInstOperands,
     /*  283176 */     // GIR_Coverage, 8744,
     /*  283176 */     GIR_EraseRootFromParent_Done,
     /*  283177 */   // Label 5350: @283177
     /*  283177 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(283240), // Rule ID 8745 //
     /*  283182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  283199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283221 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283238 */     GIR_RootConstrainSelectedInstOperands,
     /*  283239 */     // GIR_Coverage, 8745,
     /*  283239 */     GIR_EraseRootFromParent_Done,
     /*  283240 */   // Label 5351: @283240
     /*  283240 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(283303), // Rule ID 8748 //
     /*  283245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  283262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283301 */     GIR_RootConstrainSelectedInstOperands,
     /*  283302 */     // GIR_Coverage, 8748,
     /*  283302 */     GIR_EraseRootFromParent_Done,
     /*  283303 */   // Label 5352: @283303
     /*  283303 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(283366), // Rule ID 8749 //
     /*  283308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  283325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283347 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283364 */     GIR_RootConstrainSelectedInstOperands,
     /*  283365 */     // GIR_Coverage, 8749,
     /*  283365 */     GIR_EraseRootFromParent_Done,
     /*  283366 */   // Label 5353: @283366
     /*  283366 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(283429), // Rule ID 8752 //
     /*  283371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  283388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283427 */     GIR_RootConstrainSelectedInstOperands,
     /*  283428 */     // GIR_Coverage, 8752,
     /*  283428 */     GIR_EraseRootFromParent_Done,
     /*  283429 */   // Label 5354: @283429
     /*  283429 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(283492), // Rule ID 8753 //
     /*  283434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  283451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283490 */     GIR_RootConstrainSelectedInstOperands,
     /*  283491 */     // GIR_Coverage, 8753,
     /*  283491 */     GIR_EraseRootFromParent_Done,
     /*  283492 */   // Label 5355: @283492
     /*  283492 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(283555), // Rule ID 8756 //
     /*  283497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283553 */     GIR_RootConstrainSelectedInstOperands,
     /*  283554 */     // GIR_Coverage, 8756,
     /*  283554 */     GIR_EraseRootFromParent_Done,
     /*  283555 */   // Label 5356: @283555
     /*  283555 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(283618), // Rule ID 8757 //
     /*  283560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283599 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283616 */     GIR_RootConstrainSelectedInstOperands,
     /*  283617 */     // GIR_Coverage, 8757,
     /*  283617 */     GIR_EraseRootFromParent_Done,
     /*  283618 */   // Label 5357: @283618
     /*  283618 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(283681), // Rule ID 8760 //
     /*  283623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283679 */     GIR_RootConstrainSelectedInstOperands,
     /*  283680 */     // GIR_Coverage, 8760,
     /*  283680 */     GIR_EraseRootFromParent_Done,
     /*  283681 */   // Label 5358: @283681
     /*  283681 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(283744), // Rule ID 8761 //
     /*  283686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283725 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283742 */     GIR_RootConstrainSelectedInstOperands,
     /*  283743 */     // GIR_Coverage, 8761,
     /*  283743 */     GIR_EraseRootFromParent_Done,
     /*  283744 */   // Label 5359: @283744
     /*  283744 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(283807), // Rule ID 8764 //
     /*  283749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283805 */     GIR_RootConstrainSelectedInstOperands,
     /*  283806 */     // GIR_Coverage, 8764,
     /*  283806 */     GIR_EraseRootFromParent_Done,
     /*  283807 */   // Label 5360: @283807
     /*  283807 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(283870), // Rule ID 8765 //
     /*  283812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283868 */     GIR_RootConstrainSelectedInstOperands,
     /*  283869 */     // GIR_Coverage, 8765,
     /*  283869 */     GIR_EraseRootFromParent_Done,
     /*  283870 */   // Label 5361: @283870
     /*  283870 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(283933), // Rule ID 8768 //
     /*  283875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283931 */     GIR_RootConstrainSelectedInstOperands,
     /*  283932 */     // GIR_Coverage, 8768,
     /*  283932 */     GIR_EraseRootFromParent_Done,
     /*  283933 */   // Label 5362: @283933
     /*  283933 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(283996), // Rule ID 8769 //
     /*  283938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283977 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283994 */     GIR_RootConstrainSelectedInstOperands,
     /*  283995 */     // GIR_Coverage, 8769,
     /*  283995 */     GIR_EraseRootFromParent_Done,
     /*  283996 */   // Label 5363: @283996
     /*  283996 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(284059), // Rule ID 8772 //
     /*  284001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  284043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284057 */     GIR_RootConstrainSelectedInstOperands,
     /*  284058 */     // GIR_Coverage, 8772,
     /*  284058 */     GIR_EraseRootFromParent_Done,
     /*  284059 */   // Label 5364: @284059
     /*  284059 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(284122), // Rule ID 8773 //
     /*  284064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  284106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284120 */     GIR_RootConstrainSelectedInstOperands,
     /*  284121 */     // GIR_Coverage, 8773,
     /*  284121 */     GIR_EraseRootFromParent_Done,
     /*  284122 */   // Label 5365: @284122
     /*  284122 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(284185), // Rule ID 8776 //
     /*  284127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284183 */     GIR_RootConstrainSelectedInstOperands,
     /*  284184 */     // GIR_Coverage, 8776,
     /*  284184 */     GIR_EraseRootFromParent_Done,
     /*  284185 */   // Label 5366: @284185
     /*  284185 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(284248), // Rule ID 8777 //
     /*  284190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284229 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284246 */     GIR_RootConstrainSelectedInstOperands,
     /*  284247 */     // GIR_Coverage, 8777,
     /*  284247 */     GIR_EraseRootFromParent_Done,
     /*  284248 */   // Label 5367: @284248
     /*  284248 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(284311), // Rule ID 8780 //
     /*  284253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284309 */     GIR_RootConstrainSelectedInstOperands,
     /*  284310 */     // GIR_Coverage, 8780,
     /*  284310 */     GIR_EraseRootFromParent_Done,
     /*  284311 */   // Label 5368: @284311
     /*  284311 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(284374), // Rule ID 8781 //
     /*  284316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284372 */     GIR_RootConstrainSelectedInstOperands,
     /*  284373 */     // GIR_Coverage, 8781,
     /*  284373 */     GIR_EraseRootFromParent_Done,
     /*  284374 */   // Label 5369: @284374
     /*  284374 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(284437), // Rule ID 8784 //
     /*  284379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284435 */     GIR_RootConstrainSelectedInstOperands,
     /*  284436 */     // GIR_Coverage, 8784,
     /*  284436 */     GIR_EraseRootFromParent_Done,
     /*  284437 */   // Label 5370: @284437
     /*  284437 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(284500), // Rule ID 8785 //
     /*  284442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284481 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284498 */     GIR_RootConstrainSelectedInstOperands,
     /*  284499 */     // GIR_Coverage, 8785,
     /*  284499 */     GIR_EraseRootFromParent_Done,
     /*  284500 */   // Label 5371: @284500
     /*  284500 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(284563), // Rule ID 8788 //
     /*  284505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284561 */     GIR_RootConstrainSelectedInstOperands,
     /*  284562 */     // GIR_Coverage, 8788,
     /*  284562 */     GIR_EraseRootFromParent_Done,
     /*  284563 */   // Label 5372: @284563
     /*  284563 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(284626), // Rule ID 8789 //
     /*  284568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284624 */     GIR_RootConstrainSelectedInstOperands,
     /*  284625 */     // GIR_Coverage, 8789,
     /*  284625 */     GIR_EraseRootFromParent_Done,
     /*  284626 */   // Label 5373: @284626
     /*  284626 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(284689), // Rule ID 8792 //
     /*  284631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284687 */     GIR_RootConstrainSelectedInstOperands,
     /*  284688 */     // GIR_Coverage, 8792,
     /*  284688 */     GIR_EraseRootFromParent_Done,
     /*  284689 */   // Label 5374: @284689
     /*  284689 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(284752), // Rule ID 8793 //
     /*  284694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284733 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284750 */     GIR_RootConstrainSelectedInstOperands,
     /*  284751 */     // GIR_Coverage, 8793,
     /*  284751 */     GIR_EraseRootFromParent_Done,
     /*  284752 */   // Label 5375: @284752
     /*  284752 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(284815), // Rule ID 8796 //
     /*  284757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284813 */     GIR_RootConstrainSelectedInstOperands,
     /*  284814 */     // GIR_Coverage, 8796,
     /*  284814 */     GIR_EraseRootFromParent_Done,
     /*  284815 */   // Label 5376: @284815
     /*  284815 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(284878), // Rule ID 8797 //
     /*  284820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284876 */     GIR_RootConstrainSelectedInstOperands,
     /*  284877 */     // GIR_Coverage, 8797,
     /*  284877 */     GIR_EraseRootFromParent_Done,
     /*  284878 */   // Label 5377: @284878
     /*  284878 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(284941), // Rule ID 8800 //
     /*  284883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284939 */     GIR_RootConstrainSelectedInstOperands,
     /*  284940 */     // GIR_Coverage, 8800,
     /*  284940 */     GIR_EraseRootFromParent_Done,
     /*  284941 */   // Label 5378: @284941
     /*  284941 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(285004), // Rule ID 8801 //
     /*  284946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284985 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285002 */     GIR_RootConstrainSelectedInstOperands,
     /*  285003 */     // GIR_Coverage, 8801,
     /*  285003 */     GIR_EraseRootFromParent_Done,
     /*  285004 */   // Label 5379: @285004
     /*  285004 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(285067), // Rule ID 8804 //
     /*  285009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285065 */     GIR_RootConstrainSelectedInstOperands,
     /*  285066 */     // GIR_Coverage, 8804,
     /*  285066 */     GIR_EraseRootFromParent_Done,
     /*  285067 */   // Label 5380: @285067
     /*  285067 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(285130), // Rule ID 8805 //
     /*  285072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285111 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285128 */     GIR_RootConstrainSelectedInstOperands,
     /*  285129 */     // GIR_Coverage, 8805,
     /*  285129 */     GIR_EraseRootFromParent_Done,
     /*  285130 */   // Label 5381: @285130
     /*  285130 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(285193), // Rule ID 8808 //
     /*  285135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285191 */     GIR_RootConstrainSelectedInstOperands,
     /*  285192 */     // GIR_Coverage, 8808,
     /*  285192 */     GIR_EraseRootFromParent_Done,
     /*  285193 */   // Label 5382: @285193
     /*  285193 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(285256), // Rule ID 8809 //
     /*  285198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285237 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  285240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285254 */     GIR_RootConstrainSelectedInstOperands,
     /*  285255 */     // GIR_Coverage, 8809,
     /*  285255 */     GIR_EraseRootFromParent_Done,
     /*  285256 */   // Label 5383: @285256
     /*  285256 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(285319), // Rule ID 8812 //
     /*  285261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285317 */     GIR_RootConstrainSelectedInstOperands,
     /*  285318 */     // GIR_Coverage, 8812,
     /*  285318 */     GIR_EraseRootFromParent_Done,
     /*  285319 */   // Label 5384: @285319
     /*  285319 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(285382), // Rule ID 8813 //
     /*  285324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285363 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285380 */     GIR_RootConstrainSelectedInstOperands,
     /*  285381 */     // GIR_Coverage, 8813,
     /*  285381 */     GIR_EraseRootFromParent_Done,
     /*  285382 */   // Label 5385: @285382
     /*  285382 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(285445), // Rule ID 8816 //
     /*  285387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  285401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285426 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285443 */     GIR_RootConstrainSelectedInstOperands,
     /*  285444 */     // GIR_Coverage, 8816,
     /*  285444 */     GIR_EraseRootFromParent_Done,
     /*  285445 */   // Label 5386: @285445
     /*  285445 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(285508), // Rule ID 8817 //
     /*  285450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  285464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285489 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285506 */     GIR_RootConstrainSelectedInstOperands,
     /*  285507 */     // GIR_Coverage, 8817,
     /*  285507 */     GIR_EraseRootFromParent_Done,
     /*  285508 */   // Label 5387: @285508
     /*  285508 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(285571), // Rule ID 8820 //
     /*  285513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285552 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285569 */     GIR_RootConstrainSelectedInstOperands,
     /*  285570 */     // GIR_Coverage, 8820,
     /*  285570 */     GIR_EraseRootFromParent_Done,
     /*  285571 */   // Label 5388: @285571
     /*  285571 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(285634), // Rule ID 8821 //
     /*  285576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285615 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285632 */     GIR_RootConstrainSelectedInstOperands,
     /*  285633 */     // GIR_Coverage, 8821,
     /*  285633 */     GIR_EraseRootFromParent_Done,
     /*  285634 */   // Label 5389: @285634
     /*  285634 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(285697), // Rule ID 8824 //
     /*  285639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285695 */     GIR_RootConstrainSelectedInstOperands,
     /*  285696 */     // GIR_Coverage, 8824,
     /*  285696 */     GIR_EraseRootFromParent_Done,
     /*  285697 */   // Label 5390: @285697
     /*  285697 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(285760), // Rule ID 8825 //
     /*  285702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285741 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285758 */     GIR_RootConstrainSelectedInstOperands,
     /*  285759 */     // GIR_Coverage, 8825,
     /*  285759 */     GIR_EraseRootFromParent_Done,
     /*  285760 */   // Label 5391: @285760
     /*  285760 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(285823), // Rule ID 8828 //
     /*  285765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285821 */     GIR_RootConstrainSelectedInstOperands,
     /*  285822 */     // GIR_Coverage, 8828,
     /*  285822 */     GIR_EraseRootFromParent_Done,
     /*  285823 */   // Label 5392: @285823
     /*  285823 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(285886), // Rule ID 8829 //
     /*  285828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285867 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285884 */     GIR_RootConstrainSelectedInstOperands,
     /*  285885 */     // GIR_Coverage, 8829,
     /*  285885 */     GIR_EraseRootFromParent_Done,
     /*  285886 */   // Label 5393: @285886
     /*  285886 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(285949), // Rule ID 8832 //
     /*  285891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285930 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285947 */     GIR_RootConstrainSelectedInstOperands,
     /*  285948 */     // GIR_Coverage, 8832,
     /*  285948 */     GIR_EraseRootFromParent_Done,
     /*  285949 */   // Label 5394: @285949
     /*  285949 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(286012), // Rule ID 8833 //
     /*  285954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285993 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286010 */     GIR_RootConstrainSelectedInstOperands,
     /*  286011 */     // GIR_Coverage, 8833,
     /*  286011 */     GIR_EraseRootFromParent_Done,
     /*  286012 */   // Label 5395: @286012
     /*  286012 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(286075), // Rule ID 8836 //
     /*  286017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286056 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286073 */     GIR_RootConstrainSelectedInstOperands,
     /*  286074 */     // GIR_Coverage, 8836,
     /*  286074 */     GIR_EraseRootFromParent_Done,
     /*  286075 */   // Label 5396: @286075
     /*  286075 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(286138), // Rule ID 8837 //
     /*  286080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286119 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286136 */     GIR_RootConstrainSelectedInstOperands,
     /*  286137 */     // GIR_Coverage, 8837,
     /*  286137 */     GIR_EraseRootFromParent_Done,
     /*  286138 */   // Label 5397: @286138
     /*  286138 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(286201), // Rule ID 8840 //
     /*  286143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286199 */     GIR_RootConstrainSelectedInstOperands,
     /*  286200 */     // GIR_Coverage, 8840,
     /*  286200 */     GIR_EraseRootFromParent_Done,
     /*  286201 */   // Label 5398: @286201
     /*  286201 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(286264), // Rule ID 8841 //
     /*  286206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286245 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286262 */     GIR_RootConstrainSelectedInstOperands,
     /*  286263 */     // GIR_Coverage, 8841,
     /*  286263 */     GIR_EraseRootFromParent_Done,
     /*  286264 */   // Label 5399: @286264
     /*  286264 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(286327), // Rule ID 8844 //
     /*  286269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286325 */     GIR_RootConstrainSelectedInstOperands,
     /*  286326 */     // GIR_Coverage, 8844,
     /*  286326 */     GIR_EraseRootFromParent_Done,
     /*  286327 */   // Label 5400: @286327
     /*  286327 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(286390), // Rule ID 8845 //
     /*  286332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286371 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286388 */     GIR_RootConstrainSelectedInstOperands,
     /*  286389 */     // GIR_Coverage, 8845,
     /*  286389 */     GIR_EraseRootFromParent_Done,
     /*  286390 */   // Label 5401: @286390
     /*  286390 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(286453), // Rule ID 8848 //
     /*  286395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286451 */     GIR_RootConstrainSelectedInstOperands,
     /*  286452 */     // GIR_Coverage, 8848,
     /*  286452 */     GIR_EraseRootFromParent_Done,
     /*  286453 */   // Label 5402: @286453
     /*  286453 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(286516), // Rule ID 8849 //
     /*  286458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286497 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286514 */     GIR_RootConstrainSelectedInstOperands,
     /*  286515 */     // GIR_Coverage, 8849,
     /*  286515 */     GIR_EraseRootFromParent_Done,
     /*  286516 */   // Label 5403: @286516
     /*  286516 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(286579), // Rule ID 8852 //
     /*  286521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286577 */     GIR_RootConstrainSelectedInstOperands,
     /*  286578 */     // GIR_Coverage, 8852,
     /*  286578 */     GIR_EraseRootFromParent_Done,
     /*  286579 */   // Label 5404: @286579
     /*  286579 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(286642), // Rule ID 8853 //
     /*  286584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286623 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286640 */     GIR_RootConstrainSelectedInstOperands,
     /*  286641 */     // GIR_Coverage, 8853,
     /*  286641 */     GIR_EraseRootFromParent_Done,
     /*  286642 */   // Label 5405: @286642
     /*  286642 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(286705), // Rule ID 8856 //
     /*  286647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286686 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286703 */     GIR_RootConstrainSelectedInstOperands,
     /*  286704 */     // GIR_Coverage, 8856,
     /*  286704 */     GIR_EraseRootFromParent_Done,
     /*  286705 */   // Label 5406: @286705
     /*  286705 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(286768), // Rule ID 8857 //
     /*  286710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286749 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286766 */     GIR_RootConstrainSelectedInstOperands,
     /*  286767 */     // GIR_Coverage, 8857,
     /*  286767 */     GIR_EraseRootFromParent_Done,
     /*  286768 */   // Label 5407: @286768
     /*  286768 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(286831), // Rule ID 8948 //
     /*  286773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286829 */     GIR_RootConstrainSelectedInstOperands,
     /*  286830 */     // GIR_Coverage, 8948,
     /*  286830 */     GIR_EraseRootFromParent_Done,
     /*  286831 */   // Label 5408: @286831
     /*  286831 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(286894), // Rule ID 8949 //
     /*  286836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286892 */     GIR_RootConstrainSelectedInstOperands,
     /*  286893 */     // GIR_Coverage, 8949,
     /*  286893 */     GIR_EraseRootFromParent_Done,
     /*  286894 */   // Label 5409: @286894
     /*  286894 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(286957), // Rule ID 8952 //
     /*  286899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286955 */     GIR_RootConstrainSelectedInstOperands,
     /*  286956 */     // GIR_Coverage, 8952,
     /*  286956 */     GIR_EraseRootFromParent_Done,
     /*  286957 */   // Label 5410: @286957
     /*  286957 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(287020), // Rule ID 8953 //
     /*  286962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287018 */     GIR_RootConstrainSelectedInstOperands,
     /*  287019 */     // GIR_Coverage, 8953,
     /*  287019 */     GIR_EraseRootFromParent_Done,
     /*  287020 */   // Label 5411: @287020
     /*  287020 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(287083), // Rule ID 8956 //
     /*  287025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  287042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287081 */     GIR_RootConstrainSelectedInstOperands,
     /*  287082 */     // GIR_Coverage, 8956,
     /*  287082 */     GIR_EraseRootFromParent_Done,
     /*  287083 */   // Label 5412: @287083
     /*  287083 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(287146), // Rule ID 8957 //
     /*  287088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  287105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287144 */     GIR_RootConstrainSelectedInstOperands,
     /*  287145 */     // GIR_Coverage, 8957,
     /*  287145 */     GIR_EraseRootFromParent_Done,
     /*  287146 */   // Label 5413: @287146
     /*  287146 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(287209), // Rule ID 8960 //
     /*  287151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  287168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287207 */     GIR_RootConstrainSelectedInstOperands,
     /*  287208 */     // GIR_Coverage, 8960,
     /*  287208 */     GIR_EraseRootFromParent_Done,
     /*  287209 */   // Label 5414: @287209
     /*  287209 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(287272), // Rule ID 8961 //
     /*  287214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  287231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287253 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  287256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287270 */     GIR_RootConstrainSelectedInstOperands,
     /*  287271 */     // GIR_Coverage, 8961,
     /*  287271 */     GIR_EraseRootFromParent_Done,
     /*  287272 */   // Label 5415: @287272
     /*  287272 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(287335), // Rule ID 8964 //
     /*  287277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  287294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287333 */     GIR_RootConstrainSelectedInstOperands,
     /*  287334 */     // GIR_Coverage, 8964,
     /*  287334 */     GIR_EraseRootFromParent_Done,
     /*  287335 */   // Label 5416: @287335
     /*  287335 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(287398), // Rule ID 8965 //
     /*  287340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  287357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287396 */     GIR_RootConstrainSelectedInstOperands,
     /*  287397 */     // GIR_Coverage, 8965,
     /*  287397 */     GIR_EraseRootFromParent_Done,
     /*  287398 */   // Label 5417: @287398
     /*  287398 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(287461), // Rule ID 8968 //
     /*  287403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287442 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287459 */     GIR_RootConstrainSelectedInstOperands,
     /*  287460 */     // GIR_Coverage, 8968,
     /*  287460 */     GIR_EraseRootFromParent_Done,
     /*  287461 */   // Label 5418: @287461
     /*  287461 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(287524), // Rule ID 8969 //
     /*  287466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287505 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287522 */     GIR_RootConstrainSelectedInstOperands,
     /*  287523 */     // GIR_Coverage, 8969,
     /*  287523 */     GIR_EraseRootFromParent_Done,
     /*  287524 */   // Label 5419: @287524
     /*  287524 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(287587), // Rule ID 8972 //
     /*  287529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287568 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287585 */     GIR_RootConstrainSelectedInstOperands,
     /*  287586 */     // GIR_Coverage, 8972,
     /*  287586 */     GIR_EraseRootFromParent_Done,
     /*  287587 */   // Label 5420: @287587
     /*  287587 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(287650), // Rule ID 8973 //
     /*  287592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287631 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287648 */     GIR_RootConstrainSelectedInstOperands,
     /*  287649 */     // GIR_Coverage, 8973,
     /*  287649 */     GIR_EraseRootFromParent_Done,
     /*  287650 */   // Label 5421: @287650
     /*  287650 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(287713), // Rule ID 8976 //
     /*  287655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287711 */     GIR_RootConstrainSelectedInstOperands,
     /*  287712 */     // GIR_Coverage, 8976,
     /*  287712 */     GIR_EraseRootFromParent_Done,
     /*  287713 */   // Label 5422: @287713
     /*  287713 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(287776), // Rule ID 8977 //
     /*  287718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287757 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287774 */     GIR_RootConstrainSelectedInstOperands,
     /*  287775 */     // GIR_Coverage, 8977,
     /*  287775 */     GIR_EraseRootFromParent_Done,
     /*  287776 */   // Label 5423: @287776
     /*  287776 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(287839), // Rule ID 8980 //
     /*  287781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287837 */     GIR_RootConstrainSelectedInstOperands,
     /*  287838 */     // GIR_Coverage, 8980,
     /*  287838 */     GIR_EraseRootFromParent_Done,
     /*  287839 */   // Label 5424: @287839
     /*  287839 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(287902), // Rule ID 8981 //
     /*  287844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287883 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287900 */     GIR_RootConstrainSelectedInstOperands,
     /*  287901 */     // GIR_Coverage, 8981,
     /*  287901 */     GIR_EraseRootFromParent_Done,
     /*  287902 */   // Label 5425: @287902
     /*  287902 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(287965), // Rule ID 8984 //
     /*  287907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287963 */     GIR_RootConstrainSelectedInstOperands,
     /*  287964 */     // GIR_Coverage, 8984,
     /*  287964 */     GIR_EraseRootFromParent_Done,
     /*  287965 */   // Label 5426: @287965
     /*  287965 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(288028), // Rule ID 8985 //
     /*  287970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288009 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  288012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288026 */     GIR_RootConstrainSelectedInstOperands,
     /*  288027 */     // GIR_Coverage, 8985,
     /*  288027 */     GIR_EraseRootFromParent_Done,
     /*  288028 */   // Label 5427: @288028
     /*  288028 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(288091), // Rule ID 8988 //
     /*  288033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  288050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288089 */     GIR_RootConstrainSelectedInstOperands,
     /*  288090 */     // GIR_Coverage, 8988,
     /*  288090 */     GIR_EraseRootFromParent_Done,
     /*  288091 */   // Label 5428: @288091
     /*  288091 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(288154), // Rule ID 8989 //
     /*  288096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  288113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288152 */     GIR_RootConstrainSelectedInstOperands,
     /*  288153 */     // GIR_Coverage, 8989,
     /*  288153 */     GIR_EraseRootFromParent_Done,
     /*  288154 */   // Label 5429: @288154
     /*  288154 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(288217), // Rule ID 8992 //
     /*  288159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  288176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288215 */     GIR_RootConstrainSelectedInstOperands,
     /*  288216 */     // GIR_Coverage, 8992,
     /*  288216 */     GIR_EraseRootFromParent_Done,
     /*  288217 */   // Label 5430: @288217
     /*  288217 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(288280), // Rule ID 8993 //
     /*  288222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  288239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288261 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288278 */     GIR_RootConstrainSelectedInstOperands,
     /*  288279 */     // GIR_Coverage, 8993,
     /*  288279 */     GIR_EraseRootFromParent_Done,
     /*  288280 */   // Label 5431: @288280
     /*  288280 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(288343), // Rule ID 8996 //
     /*  288285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  288302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288324 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288341 */     GIR_RootConstrainSelectedInstOperands,
     /*  288342 */     // GIR_Coverage, 8996,
     /*  288342 */     GIR_EraseRootFromParent_Done,
     /*  288343 */   // Label 5432: @288343
     /*  288343 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(288406), // Rule ID 8997 //
     /*  288348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  288365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288387 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288404 */     GIR_RootConstrainSelectedInstOperands,
     /*  288405 */     // GIR_Coverage, 8997,
     /*  288405 */     GIR_EraseRootFromParent_Done,
     /*  288406 */   // Label 5433: @288406
     /*  288406 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(288469), // Rule ID 9000 //
     /*  288411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288467 */     GIR_RootConstrainSelectedInstOperands,
     /*  288468 */     // GIR_Coverage, 9000,
     /*  288468 */     GIR_EraseRootFromParent_Done,
     /*  288469 */   // Label 5434: @288469
     /*  288469 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(288532), // Rule ID 9001 //
     /*  288474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288513 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288530 */     GIR_RootConstrainSelectedInstOperands,
     /*  288531 */     // GIR_Coverage, 9001,
     /*  288531 */     GIR_EraseRootFromParent_Done,
     /*  288532 */   // Label 5435: @288532
     /*  288532 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(288595), // Rule ID 9004 //
     /*  288537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288593 */     GIR_RootConstrainSelectedInstOperands,
     /*  288594 */     // GIR_Coverage, 9004,
     /*  288594 */     GIR_EraseRootFromParent_Done,
     /*  288595 */   // Label 5436: @288595
     /*  288595 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(288658), // Rule ID 9005 //
     /*  288600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288639 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288656 */     GIR_RootConstrainSelectedInstOperands,
     /*  288657 */     // GIR_Coverage, 9005,
     /*  288657 */     GIR_EraseRootFromParent_Done,
     /*  288658 */   // Label 5437: @288658
     /*  288658 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(288721), // Rule ID 9008 //
     /*  288663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288702 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288719 */     GIR_RootConstrainSelectedInstOperands,
     /*  288720 */     // GIR_Coverage, 9008,
     /*  288720 */     GIR_EraseRootFromParent_Done,
     /*  288721 */   // Label 5438: @288721
     /*  288721 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(288784), // Rule ID 9009 //
     /*  288726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288765 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288782 */     GIR_RootConstrainSelectedInstOperands,
     /*  288783 */     // GIR_Coverage, 9009,
     /*  288783 */     GIR_EraseRootFromParent_Done,
     /*  288784 */   // Label 5439: @288784
     /*  288784 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(288847), // Rule ID 9012 //
     /*  288789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288845 */     GIR_RootConstrainSelectedInstOperands,
     /*  288846 */     // GIR_Coverage, 9012,
     /*  288846 */     GIR_EraseRootFromParent_Done,
     /*  288847 */   // Label 5440: @288847
     /*  288847 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(288910), // Rule ID 9013 //
     /*  288852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288891 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288908 */     GIR_RootConstrainSelectedInstOperands,
     /*  288909 */     // GIR_Coverage, 9013,
     /*  288909 */     GIR_EraseRootFromParent_Done,
     /*  288910 */   // Label 5441: @288910
     /*  288910 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(288973), // Rule ID 9016 //
     /*  288915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288971 */     GIR_RootConstrainSelectedInstOperands,
     /*  288972 */     // GIR_Coverage, 9016,
     /*  288972 */     GIR_EraseRootFromParent_Done,
     /*  288973 */   // Label 5442: @288973
     /*  288973 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(289036), // Rule ID 9017 //
     /*  288978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289017 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289034 */     GIR_RootConstrainSelectedInstOperands,
     /*  289035 */     // GIR_Coverage, 9017,
     /*  289035 */     GIR_EraseRootFromParent_Done,
     /*  289036 */   // Label 5443: @289036
     /*  289036 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(289099), // Rule ID 9020 //
     /*  289041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  289058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289097 */     GIR_RootConstrainSelectedInstOperands,
     /*  289098 */     // GIR_Coverage, 9020,
     /*  289098 */     GIR_EraseRootFromParent_Done,
     /*  289099 */   // Label 5444: @289099
     /*  289099 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(289162), // Rule ID 9021 //
     /*  289104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  289121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289143 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289160 */     GIR_RootConstrainSelectedInstOperands,
     /*  289161 */     // GIR_Coverage, 9021,
     /*  289161 */     GIR_EraseRootFromParent_Done,
     /*  289162 */   // Label 5445: @289162
     /*  289162 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(289225), // Rule ID 9024 //
     /*  289167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  289184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289206 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  289209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289223 */     GIR_RootConstrainSelectedInstOperands,
     /*  289224 */     // GIR_Coverage, 9024,
     /*  289224 */     GIR_EraseRootFromParent_Done,
     /*  289225 */   // Label 5446: @289225
     /*  289225 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(289288), // Rule ID 9025 //
     /*  289230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  289247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289269 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  289272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289286 */     GIR_RootConstrainSelectedInstOperands,
     /*  289287 */     // GIR_Coverage, 9025,
     /*  289287 */     GIR_EraseRootFromParent_Done,
     /*  289288 */   // Label 5447: @289288
     /*  289288 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(289351), // Rule ID 9028 //
     /*  289293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  289310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289349 */     GIR_RootConstrainSelectedInstOperands,
     /*  289350 */     // GIR_Coverage, 9028,
     /*  289350 */     GIR_EraseRootFromParent_Done,
     /*  289351 */   // Label 5448: @289351
     /*  289351 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(289414), // Rule ID 9029 //
     /*  289356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  289373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289395 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  289398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289412 */     GIR_RootConstrainSelectedInstOperands,
     /*  289413 */     // GIR_Coverage, 9029,
     /*  289413 */     GIR_EraseRootFromParent_Done,
     /*  289414 */   // Label 5449: @289414
     /*  289414 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(289477), // Rule ID 9032 //
     /*  289419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289475 */     GIR_RootConstrainSelectedInstOperands,
     /*  289476 */     // GIR_Coverage, 9032,
     /*  289476 */     GIR_EraseRootFromParent_Done,
     /*  289477 */   // Label 5450: @289477
     /*  289477 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(289540), // Rule ID 9033 //
     /*  289482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289521 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289538 */     GIR_RootConstrainSelectedInstOperands,
     /*  289539 */     // GIR_Coverage, 9033,
     /*  289539 */     GIR_EraseRootFromParent_Done,
     /*  289540 */   // Label 5451: @289540
     /*  289540 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(289603), // Rule ID 9036 //
     /*  289545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289601 */     GIR_RootConstrainSelectedInstOperands,
     /*  289602 */     // GIR_Coverage, 9036,
     /*  289602 */     GIR_EraseRootFromParent_Done,
     /*  289603 */   // Label 5452: @289603
     /*  289603 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(289666), // Rule ID 9037 //
     /*  289608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289647 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289664 */     GIR_RootConstrainSelectedInstOperands,
     /*  289665 */     // GIR_Coverage, 9037,
     /*  289665 */     GIR_EraseRootFromParent_Done,
     /*  289666 */   // Label 5453: @289666
     /*  289666 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(289729), // Rule ID 9040 //
     /*  289671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289727 */     GIR_RootConstrainSelectedInstOperands,
     /*  289728 */     // GIR_Coverage, 9040,
     /*  289728 */     GIR_EraseRootFromParent_Done,
     /*  289729 */   // Label 5454: @289729
     /*  289729 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(289792), // Rule ID 9041 //
     /*  289734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289790 */     GIR_RootConstrainSelectedInstOperands,
     /*  289791 */     // GIR_Coverage, 9041,
     /*  289791 */     GIR_EraseRootFromParent_Done,
     /*  289792 */   // Label 5455: @289792
     /*  289792 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(289855), // Rule ID 9044 //
     /*  289797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289853 */     GIR_RootConstrainSelectedInstOperands,
     /*  289854 */     // GIR_Coverage, 9044,
     /*  289854 */     GIR_EraseRootFromParent_Done,
     /*  289855 */   // Label 5456: @289855
     /*  289855 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(289918), // Rule ID 9045 //
     /*  289860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289899 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289916 */     GIR_RootConstrainSelectedInstOperands,
     /*  289917 */     // GIR_Coverage, 9045,
     /*  289917 */     GIR_EraseRootFromParent_Done,
     /*  289918 */   // Label 5457: @289918
     /*  289918 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(289981), // Rule ID 9048 //
     /*  289923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289979 */     GIR_RootConstrainSelectedInstOperands,
     /*  289980 */     // GIR_Coverage, 9048,
     /*  289980 */     GIR_EraseRootFromParent_Done,
     /*  289981 */   // Label 5458: @289981
     /*  289981 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(290044), // Rule ID 9049 //
     /*  289986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290025 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  290028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290042 */     GIR_RootConstrainSelectedInstOperands,
     /*  290043 */     // GIR_Coverage, 9049,
     /*  290043 */     GIR_EraseRootFromParent_Done,
     /*  290044 */   // Label 5459: @290044
     /*  290044 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(290107), // Rule ID 9052 //
     /*  290049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290105 */     GIR_RootConstrainSelectedInstOperands,
     /*  290106 */     // GIR_Coverage, 9052,
     /*  290106 */     GIR_EraseRootFromParent_Done,
     /*  290107 */   // Label 5460: @290107
     /*  290107 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(290170), // Rule ID 9053 //
     /*  290112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290168 */     GIR_RootConstrainSelectedInstOperands,
     /*  290169 */     // GIR_Coverage, 9053,
     /*  290169 */     GIR_EraseRootFromParent_Done,
     /*  290170 */   // Label 5461: @290170
     /*  290170 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(290233), // Rule ID 9056 //
     /*  290175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290231 */     GIR_RootConstrainSelectedInstOperands,
     /*  290232 */     // GIR_Coverage, 9056,
     /*  290232 */     GIR_EraseRootFromParent_Done,
     /*  290233 */   // Label 5462: @290233
     /*  290233 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(290296), // Rule ID 9057 //
     /*  290238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290277 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  290280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290294 */     GIR_RootConstrainSelectedInstOperands,
     /*  290295 */     // GIR_Coverage, 9057,
     /*  290295 */     GIR_EraseRootFromParent_Done,
     /*  290296 */   // Label 5463: @290296
     /*  290296 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(290359), // Rule ID 9060 //
     /*  290301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290357 */     GIR_RootConstrainSelectedInstOperands,
     /*  290358 */     // GIR_Coverage, 9060,
     /*  290358 */     GIR_EraseRootFromParent_Done,
     /*  290359 */   // Label 5464: @290359
     /*  290359 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(290422), // Rule ID 9061 //
     /*  290364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290403 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290420 */     GIR_RootConstrainSelectedInstOperands,
     /*  290421 */     // GIR_Coverage, 9061,
     /*  290421 */     GIR_EraseRootFromParent_Done,
     /*  290422 */   // Label 5465: @290422
     /*  290422 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(290485), // Rule ID 9064 //
     /*  290427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290466 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290483 */     GIR_RootConstrainSelectedInstOperands,
     /*  290484 */     // GIR_Coverage, 9064,
     /*  290484 */     GIR_EraseRootFromParent_Done,
     /*  290485 */   // Label 5466: @290485
     /*  290485 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(290548), // Rule ID 9065 //
     /*  290490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290529 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290546 */     GIR_RootConstrainSelectedInstOperands,
     /*  290547 */     // GIR_Coverage, 9065,
     /*  290547 */     GIR_EraseRootFromParent_Done,
     /*  290548 */   // Label 5467: @290548
     /*  290548 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(290611), // Rule ID 9068 //
     /*  290553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290609 */     GIR_RootConstrainSelectedInstOperands,
     /*  290610 */     // GIR_Coverage, 9068,
     /*  290610 */     GIR_EraseRootFromParent_Done,
     /*  290611 */   // Label 5468: @290611
     /*  290611 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(290674), // Rule ID 9069 //
     /*  290616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290655 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290672 */     GIR_RootConstrainSelectedInstOperands,
     /*  290673 */     // GIR_Coverage, 9069,
     /*  290673 */     GIR_EraseRootFromParent_Done,
     /*  290674 */   // Label 5469: @290674
     /*  290674 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(290737), // Rule ID 9072 //
     /*  290679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290718 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290735 */     GIR_RootConstrainSelectedInstOperands,
     /*  290736 */     // GIR_Coverage, 9072,
     /*  290736 */     GIR_EraseRootFromParent_Done,
     /*  290737 */   // Label 5470: @290737
     /*  290737 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(290800), // Rule ID 9073 //
     /*  290742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290781 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290798 */     GIR_RootConstrainSelectedInstOperands,
     /*  290799 */     // GIR_Coverage, 9073,
     /*  290799 */     GIR_EraseRootFromParent_Done,
     /*  290800 */   // Label 5471: @290800
     /*  290800 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(290863), // Rule ID 9076 //
     /*  290805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290861 */     GIR_RootConstrainSelectedInstOperands,
     /*  290862 */     // GIR_Coverage, 9076,
     /*  290862 */     GIR_EraseRootFromParent_Done,
     /*  290863 */   // Label 5472: @290863
     /*  290863 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(290926), // Rule ID 9077 //
     /*  290868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290907 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290924 */     GIR_RootConstrainSelectedInstOperands,
     /*  290925 */     // GIR_Coverage, 9077,
     /*  290925 */     GIR_EraseRootFromParent_Done,
     /*  290926 */   // Label 5473: @290926
     /*  290926 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(290989), // Rule ID 9080 //
     /*  290931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290970 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290987 */     GIR_RootConstrainSelectedInstOperands,
     /*  290988 */     // GIR_Coverage, 9080,
     /*  290988 */     GIR_EraseRootFromParent_Done,
     /*  290989 */   // Label 5474: @290989
     /*  290989 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(291052), // Rule ID 9081 //
     /*  290994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291033 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291050 */     GIR_RootConstrainSelectedInstOperands,
     /*  291051 */     // GIR_Coverage, 9081,
     /*  291051 */     GIR_EraseRootFromParent_Done,
     /*  291052 */   // Label 5475: @291052
     /*  291052 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(291115), // Rule ID 9084 //
     /*  291057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291096 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291113 */     GIR_RootConstrainSelectedInstOperands,
     /*  291114 */     // GIR_Coverage, 9084,
     /*  291114 */     GIR_EraseRootFromParent_Done,
     /*  291115 */   // Label 5476: @291115
     /*  291115 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(291178), // Rule ID 9085 //
     /*  291120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291159 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291176 */     GIR_RootConstrainSelectedInstOperands,
     /*  291177 */     // GIR_Coverage, 9085,
     /*  291177 */     GIR_EraseRootFromParent_Done,
     /*  291178 */   // Label 5477: @291178
     /*  291178 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(291241), // Rule ID 9088 //
     /*  291183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291239 */     GIR_RootConstrainSelectedInstOperands,
     /*  291240 */     // GIR_Coverage, 9088,
     /*  291240 */     GIR_EraseRootFromParent_Done,
     /*  291241 */   // Label 5478: @291241
     /*  291241 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(291304), // Rule ID 9089 //
     /*  291246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291285 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291302 */     GIR_RootConstrainSelectedInstOperands,
     /*  291303 */     // GIR_Coverage, 9089,
     /*  291303 */     GIR_EraseRootFromParent_Done,
     /*  291304 */   // Label 5479: @291304
     /*  291304 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(291367), // Rule ID 9092 //
     /*  291309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291365 */     GIR_RootConstrainSelectedInstOperands,
     /*  291366 */     // GIR_Coverage, 9092,
     /*  291366 */     GIR_EraseRootFromParent_Done,
     /*  291367 */   // Label 5480: @291367
     /*  291367 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(291430), // Rule ID 9093 //
     /*  291372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291411 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291428 */     GIR_RootConstrainSelectedInstOperands,
     /*  291429 */     // GIR_Coverage, 9093,
     /*  291429 */     GIR_EraseRootFromParent_Done,
     /*  291430 */   // Label 5481: @291430
     /*  291430 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(291493), // Rule ID 9096 //
     /*  291435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291474 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291491 */     GIR_RootConstrainSelectedInstOperands,
     /*  291492 */     // GIR_Coverage, 9096,
     /*  291492 */     GIR_EraseRootFromParent_Done,
     /*  291493 */   // Label 5482: @291493
     /*  291493 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(291556), // Rule ID 9097 //
     /*  291498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291537 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291554 */     GIR_RootConstrainSelectedInstOperands,
     /*  291555 */     // GIR_Coverage, 9097,
     /*  291555 */     GIR_EraseRootFromParent_Done,
     /*  291556 */   // Label 5483: @291556
     /*  291556 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(291619), // Rule ID 9100 //
     /*  291561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291617 */     GIR_RootConstrainSelectedInstOperands,
     /*  291618 */     // GIR_Coverage, 9100,
     /*  291618 */     GIR_EraseRootFromParent_Done,
     /*  291619 */   // Label 5484: @291619
     /*  291619 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(291682), // Rule ID 9101 //
     /*  291624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291663 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291680 */     GIR_RootConstrainSelectedInstOperands,
     /*  291681 */     // GIR_Coverage, 9101,
     /*  291681 */     GIR_EraseRootFromParent_Done,
     /*  291682 */   // Label 5485: @291682
     /*  291682 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(291745), // Rule ID 9104 //
     /*  291687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291743 */     GIR_RootConstrainSelectedInstOperands,
     /*  291744 */     // GIR_Coverage, 9104,
     /*  291744 */     GIR_EraseRootFromParent_Done,
     /*  291745 */   // Label 5486: @291745
     /*  291745 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(291808), // Rule ID 9105 //
     /*  291750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291789 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291806 */     GIR_RootConstrainSelectedInstOperands,
     /*  291807 */     // GIR_Coverage, 9105,
     /*  291807 */     GIR_EraseRootFromParent_Done,
     /*  291808 */   // Label 5487: @291808
     /*  291808 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(291871), // Rule ID 9108 //
     /*  291813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291869 */     GIR_RootConstrainSelectedInstOperands,
     /*  291870 */     // GIR_Coverage, 9108,
     /*  291870 */     GIR_EraseRootFromParent_Done,
     /*  291871 */   // Label 5488: @291871
     /*  291871 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(291934), // Rule ID 9109 //
     /*  291876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291915 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291932 */     GIR_RootConstrainSelectedInstOperands,
     /*  291933 */     // GIR_Coverage, 9109,
     /*  291933 */     GIR_EraseRootFromParent_Done,
     /*  291934 */   // Label 5489: @291934
     /*  291934 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(291997), // Rule ID 9112 //
     /*  291939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291995 */     GIR_RootConstrainSelectedInstOperands,
     /*  291996 */     // GIR_Coverage, 9112,
     /*  291996 */     GIR_EraseRootFromParent_Done,
     /*  291997 */   // Label 5490: @291997
     /*  291997 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(292060), // Rule ID 9113 //
     /*  292002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292041 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  292044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292058 */     GIR_RootConstrainSelectedInstOperands,
     /*  292059 */     // GIR_Coverage, 9113,
     /*  292059 */     GIR_EraseRootFromParent_Done,
     /*  292060 */   // Label 5491: @292060
     /*  292060 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(292123), // Rule ID 9116 //
     /*  292065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  292107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292121 */     GIR_RootConstrainSelectedInstOperands,
     /*  292122 */     // GIR_Coverage, 9116,
     /*  292122 */     GIR_EraseRootFromParent_Done,
     /*  292123 */   // Label 5492: @292123
     /*  292123 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(292186), // Rule ID 9117 //
     /*  292128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  292170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292184 */     GIR_RootConstrainSelectedInstOperands,
     /*  292185 */     // GIR_Coverage, 9117,
     /*  292185 */     GIR_EraseRootFromParent_Done,
     /*  292186 */   // Label 5493: @292186
     /*  292186 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(292249), // Rule ID 9120 //
     /*  292191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  292233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292247 */     GIR_RootConstrainSelectedInstOperands,
     /*  292248 */     // GIR_Coverage, 9120,
     /*  292248 */     GIR_EraseRootFromParent_Done,
     /*  292249 */   // Label 5494: @292249
     /*  292249 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(292312), // Rule ID 9121 //
     /*  292254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292293 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  292296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292310 */     GIR_RootConstrainSelectedInstOperands,
     /*  292311 */     // GIR_Coverage, 9121,
     /*  292311 */     GIR_EraseRootFromParent_Done,
     /*  292312 */   // Label 5495: @292312
     /*  292312 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(292375), // Rule ID 9212 //
     /*  292317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  292359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292373 */     GIR_RootConstrainSelectedInstOperands,
     /*  292374 */     // GIR_Coverage, 9212,
     /*  292374 */     GIR_EraseRootFromParent_Done,
     /*  292375 */   // Label 5496: @292375
     /*  292375 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(292438), // Rule ID 9213 //
     /*  292380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292419 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  292422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292436 */     GIR_RootConstrainSelectedInstOperands,
     /*  292437 */     // GIR_Coverage, 9213,
     /*  292437 */     GIR_EraseRootFromParent_Done,
     /*  292438 */   // Label 5497: @292438
     /*  292438 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(292501), // Rule ID 9216 //
     /*  292443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292499 */     GIR_RootConstrainSelectedInstOperands,
     /*  292500 */     // GIR_Coverage, 9216,
     /*  292500 */     GIR_EraseRootFromParent_Done,
     /*  292501 */   // Label 5498: @292501
     /*  292501 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(292564), // Rule ID 9217 //
     /*  292506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292562 */     GIR_RootConstrainSelectedInstOperands,
     /*  292563 */     // GIR_Coverage, 9217,
     /*  292563 */     GIR_EraseRootFromParent_Done,
     /*  292564 */   // Label 5499: @292564
     /*  292564 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(292627), // Rule ID 9220 //
     /*  292569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292625 */     GIR_RootConstrainSelectedInstOperands,
     /*  292626 */     // GIR_Coverage, 9220,
     /*  292626 */     GIR_EraseRootFromParent_Done,
     /*  292627 */   // Label 5500: @292627
     /*  292627 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(292690), // Rule ID 9221 //
     /*  292632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292671 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292688 */     GIR_RootConstrainSelectedInstOperands,
     /*  292689 */     // GIR_Coverage, 9221,
     /*  292689 */     GIR_EraseRootFromParent_Done,
     /*  292690 */   // Label 5501: @292690
     /*  292690 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(292753), // Rule ID 9224 //
     /*  292695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292751 */     GIR_RootConstrainSelectedInstOperands,
     /*  292752 */     // GIR_Coverage, 9224,
     /*  292752 */     GIR_EraseRootFromParent_Done,
     /*  292753 */   // Label 5502: @292753
     /*  292753 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(292816), // Rule ID 9225 //
     /*  292758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292797 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292814 */     GIR_RootConstrainSelectedInstOperands,
     /*  292815 */     // GIR_Coverage, 9225,
     /*  292815 */     GIR_EraseRootFromParent_Done,
     /*  292816 */   // Label 5503: @292816
     /*  292816 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(292879), // Rule ID 9228 //
     /*  292821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292877 */     GIR_RootConstrainSelectedInstOperands,
     /*  292878 */     // GIR_Coverage, 9228,
     /*  292878 */     GIR_EraseRootFromParent_Done,
     /*  292879 */   // Label 5504: @292879
     /*  292879 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(292942), // Rule ID 9229 //
     /*  292884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292940 */     GIR_RootConstrainSelectedInstOperands,
     /*  292941 */     // GIR_Coverage, 9229,
     /*  292941 */     GIR_EraseRootFromParent_Done,
     /*  292942 */   // Label 5505: @292942
     /*  292942 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(293005), // Rule ID 9232 //
     /*  292947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292986 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293003 */     GIR_RootConstrainSelectedInstOperands,
     /*  293004 */     // GIR_Coverage, 9232,
     /*  293004 */     GIR_EraseRootFromParent_Done,
     /*  293005 */   // Label 5506: @293005
     /*  293005 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(293068), // Rule ID 9233 //
     /*  293010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293049 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  293052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293066 */     GIR_RootConstrainSelectedInstOperands,
     /*  293067 */     // GIR_Coverage, 9233,
     /*  293067 */     GIR_EraseRootFromParent_Done,
     /*  293068 */   // Label 5507: @293068
     /*  293068 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(293131), // Rule ID 9236 //
     /*  293073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293129 */     GIR_RootConstrainSelectedInstOperands,
     /*  293130 */     // GIR_Coverage, 9236,
     /*  293130 */     GIR_EraseRootFromParent_Done,
     /*  293131 */   // Label 5508: @293131
     /*  293131 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(293194), // Rule ID 9237 //
     /*  293136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293175 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293192 */     GIR_RootConstrainSelectedInstOperands,
     /*  293193 */     // GIR_Coverage, 9237,
     /*  293193 */     GIR_EraseRootFromParent_Done,
     /*  293194 */   // Label 5509: @293194
     /*  293194 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(293257), // Rule ID 9240 //
     /*  293199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293255 */     GIR_RootConstrainSelectedInstOperands,
     /*  293256 */     // GIR_Coverage, 9240,
     /*  293256 */     GIR_EraseRootFromParent_Done,
     /*  293257 */   // Label 5510: @293257
     /*  293257 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(293320), // Rule ID 9241 //
     /*  293262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293301 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293318 */     GIR_RootConstrainSelectedInstOperands,
     /*  293319 */     // GIR_Coverage, 9241,
     /*  293319 */     GIR_EraseRootFromParent_Done,
     /*  293320 */   // Label 5511: @293320
     /*  293320 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(293383), // Rule ID 9244 //
     /*  293325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293381 */     GIR_RootConstrainSelectedInstOperands,
     /*  293382 */     // GIR_Coverage, 9244,
     /*  293382 */     GIR_EraseRootFromParent_Done,
     /*  293383 */   // Label 5512: @293383
     /*  293383 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(293446), // Rule ID 9245 //
     /*  293388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293444 */     GIR_RootConstrainSelectedInstOperands,
     /*  293445 */     // GIR_Coverage, 9245,
     /*  293445 */     GIR_EraseRootFromParent_Done,
     /*  293446 */   // Label 5513: @293446
     /*  293446 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(293509), // Rule ID 9248 //
     /*  293451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293490 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293507 */     GIR_RootConstrainSelectedInstOperands,
     /*  293508 */     // GIR_Coverage, 9248,
     /*  293508 */     GIR_EraseRootFromParent_Done,
     /*  293509 */   // Label 5514: @293509
     /*  293509 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(293572), // Rule ID 9249 //
     /*  293514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293553 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293570 */     GIR_RootConstrainSelectedInstOperands,
     /*  293571 */     // GIR_Coverage, 9249,
     /*  293571 */     GIR_EraseRootFromParent_Done,
     /*  293572 */   // Label 5515: @293572
     /*  293572 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(293635), // Rule ID 9252 //
     /*  293577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293633 */     GIR_RootConstrainSelectedInstOperands,
     /*  293634 */     // GIR_Coverage, 9252,
     /*  293634 */     GIR_EraseRootFromParent_Done,
     /*  293635 */   // Label 5516: @293635
     /*  293635 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(293698), // Rule ID 9253 //
     /*  293640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293696 */     GIR_RootConstrainSelectedInstOperands,
     /*  293697 */     // GIR_Coverage, 9253,
     /*  293697 */     GIR_EraseRootFromParent_Done,
     /*  293698 */   // Label 5517: @293698
     /*  293698 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(293761), // Rule ID 9256 //
     /*  293703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293742 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293759 */     GIR_RootConstrainSelectedInstOperands,
     /*  293760 */     // GIR_Coverage, 9256,
     /*  293760 */     GIR_EraseRootFromParent_Done,
     /*  293761 */   // Label 5518: @293761
     /*  293761 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(293824), // Rule ID 9257 //
     /*  293766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293822 */     GIR_RootConstrainSelectedInstOperands,
     /*  293823 */     // GIR_Coverage, 9257,
     /*  293823 */     GIR_EraseRootFromParent_Done,
     /*  293824 */   // Label 5519: @293824
     /*  293824 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(293887), // Rule ID 9260 //
     /*  293829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293868 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293885 */     GIR_RootConstrainSelectedInstOperands,
     /*  293886 */     // GIR_Coverage, 9260,
     /*  293886 */     GIR_EraseRootFromParent_Done,
     /*  293887 */   // Label 5520: @293887
     /*  293887 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(293950), // Rule ID 9261 //
     /*  293892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293931 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293948 */     GIR_RootConstrainSelectedInstOperands,
     /*  293949 */     // GIR_Coverage, 9261,
     /*  293949 */     GIR_EraseRootFromParent_Done,
     /*  293950 */   // Label 5521: @293950
     /*  293950 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(294013), // Rule ID 9264 //
     /*  293955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293994 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294011 */     GIR_RootConstrainSelectedInstOperands,
     /*  294012 */     // GIR_Coverage, 9264,
     /*  294012 */     GIR_EraseRootFromParent_Done,
     /*  294013 */   // Label 5522: @294013
     /*  294013 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(294076), // Rule ID 9265 //
     /*  294018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294074 */     GIR_RootConstrainSelectedInstOperands,
     /*  294075 */     // GIR_Coverage, 9265,
     /*  294075 */     GIR_EraseRootFromParent_Done,
     /*  294076 */   // Label 5523: @294076
     /*  294076 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(294139), // Rule ID 9268 //
     /*  294081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294120 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294137 */     GIR_RootConstrainSelectedInstOperands,
     /*  294138 */     // GIR_Coverage, 9268,
     /*  294138 */     GIR_EraseRootFromParent_Done,
     /*  294139 */   // Label 5524: @294139
     /*  294139 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(294202), // Rule ID 9269 //
     /*  294144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294183 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294200 */     GIR_RootConstrainSelectedInstOperands,
     /*  294201 */     // GIR_Coverage, 9269,
     /*  294201 */     GIR_EraseRootFromParent_Done,
     /*  294202 */   // Label 5525: @294202
     /*  294202 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(294265), // Rule ID 9272 //
     /*  294207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294246 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294263 */     GIR_RootConstrainSelectedInstOperands,
     /*  294264 */     // GIR_Coverage, 9272,
     /*  294264 */     GIR_EraseRootFromParent_Done,
     /*  294265 */   // Label 5526: @294265
     /*  294265 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(294328), // Rule ID 9273 //
     /*  294270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294309 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294326 */     GIR_RootConstrainSelectedInstOperands,
     /*  294327 */     // GIR_Coverage, 9273,
     /*  294327 */     GIR_EraseRootFromParent_Done,
     /*  294328 */   // Label 5527: @294328
     /*  294328 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(294391), // Rule ID 9276 //
     /*  294333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294372 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294389 */     GIR_RootConstrainSelectedInstOperands,
     /*  294390 */     // GIR_Coverage, 9276,
     /*  294390 */     GIR_EraseRootFromParent_Done,
     /*  294391 */   // Label 5528: @294391
     /*  294391 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(294454), // Rule ID 9277 //
     /*  294396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294452 */     GIR_RootConstrainSelectedInstOperands,
     /*  294453 */     // GIR_Coverage, 9277,
     /*  294453 */     GIR_EraseRootFromParent_Done,
     /*  294454 */   // Label 5529: @294454
     /*  294454 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(294517), // Rule ID 9280 //
     /*  294459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294515 */     GIR_RootConstrainSelectedInstOperands,
     /*  294516 */     // GIR_Coverage, 9280,
     /*  294516 */     GIR_EraseRootFromParent_Done,
     /*  294517 */   // Label 5530: @294517
     /*  294517 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(294580), // Rule ID 9281 //
     /*  294522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294561 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294578 */     GIR_RootConstrainSelectedInstOperands,
     /*  294579 */     // GIR_Coverage, 9281,
     /*  294579 */     GIR_EraseRootFromParent_Done,
     /*  294580 */   // Label 5531: @294580
     /*  294580 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(294643), // Rule ID 9284 //
     /*  294585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294641 */     GIR_RootConstrainSelectedInstOperands,
     /*  294642 */     // GIR_Coverage, 9284,
     /*  294642 */     GIR_EraseRootFromParent_Done,
     /*  294643 */   // Label 5532: @294643
     /*  294643 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(294706), // Rule ID 9285 //
     /*  294648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294687 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294704 */     GIR_RootConstrainSelectedInstOperands,
     /*  294705 */     // GIR_Coverage, 9285,
     /*  294705 */     GIR_EraseRootFromParent_Done,
     /*  294706 */   // Label 5533: @294706
     /*  294706 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(294769), // Rule ID 9288 //
     /*  294711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294767 */     GIR_RootConstrainSelectedInstOperands,
     /*  294768 */     // GIR_Coverage, 9288,
     /*  294768 */     GIR_EraseRootFromParent_Done,
     /*  294769 */   // Label 5534: @294769
     /*  294769 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(294832), // Rule ID 9289 //
     /*  294774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294813 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294830 */     GIR_RootConstrainSelectedInstOperands,
     /*  294831 */     // GIR_Coverage, 9289,
     /*  294831 */     GIR_EraseRootFromParent_Done,
     /*  294832 */   // Label 5535: @294832
     /*  294832 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(294895), // Rule ID 9292 //
     /*  294837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294893 */     GIR_RootConstrainSelectedInstOperands,
     /*  294894 */     // GIR_Coverage, 9292,
     /*  294894 */     GIR_EraseRootFromParent_Done,
     /*  294895 */   // Label 5536: @294895
     /*  294895 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(294958), // Rule ID 9293 //
     /*  294900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294939 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294956 */     GIR_RootConstrainSelectedInstOperands,
     /*  294957 */     // GIR_Coverage, 9293,
     /*  294957 */     GIR_EraseRootFromParent_Done,
     /*  294958 */   // Label 5537: @294958
     /*  294958 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(295021), // Rule ID 9296 //
     /*  294963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  295005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295019 */     GIR_RootConstrainSelectedInstOperands,
     /*  295020 */     // GIR_Coverage, 9296,
     /*  295020 */     GIR_EraseRootFromParent_Done,
     /*  295021 */   // Label 5538: @295021
     /*  295021 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(295084), // Rule ID 9297 //
     /*  295026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295065 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  295068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295082 */     GIR_RootConstrainSelectedInstOperands,
     /*  295083 */     // GIR_Coverage, 9297,
     /*  295083 */     GIR_EraseRootFromParent_Done,
     /*  295084 */   // Label 5539: @295084
     /*  295084 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(295147), // Rule ID 9388 //
     /*  295089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  295131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295145 */     GIR_RootConstrainSelectedInstOperands,
     /*  295146 */     // GIR_Coverage, 9388,
     /*  295146 */     GIR_EraseRootFromParent_Done,
     /*  295147 */   // Label 5540: @295147
     /*  295147 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(295210), // Rule ID 9389 //
     /*  295152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295191 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  295194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295208 */     GIR_RootConstrainSelectedInstOperands,
     /*  295209 */     // GIR_Coverage, 9389,
     /*  295209 */     GIR_EraseRootFromParent_Done,
     /*  295210 */   // Label 5541: @295210
     /*  295210 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(295273), // Rule ID 9392 //
     /*  295215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295271 */     GIR_RootConstrainSelectedInstOperands,
     /*  295272 */     // GIR_Coverage, 9392,
     /*  295272 */     GIR_EraseRootFromParent_Done,
     /*  295273 */   // Label 5542: @295273
     /*  295273 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(295336), // Rule ID 9393 //
     /*  295278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295317 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295334 */     GIR_RootConstrainSelectedInstOperands,
     /*  295335 */     // GIR_Coverage, 9393,
     /*  295335 */     GIR_EraseRootFromParent_Done,
     /*  295336 */   // Label 5543: @295336
     /*  295336 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(295399), // Rule ID 9396 //
     /*  295341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295397 */     GIR_RootConstrainSelectedInstOperands,
     /*  295398 */     // GIR_Coverage, 9396,
     /*  295398 */     GIR_EraseRootFromParent_Done,
     /*  295399 */   // Label 5544: @295399
     /*  295399 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(295462), // Rule ID 9397 //
     /*  295404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295460 */     GIR_RootConstrainSelectedInstOperands,
     /*  295461 */     // GIR_Coverage, 9397,
     /*  295461 */     GIR_EraseRootFromParent_Done,
     /*  295462 */   // Label 5545: @295462
     /*  295462 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(295525), // Rule ID 9400 //
     /*  295467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295506 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295523 */     GIR_RootConstrainSelectedInstOperands,
     /*  295524 */     // GIR_Coverage, 9400,
     /*  295524 */     GIR_EraseRootFromParent_Done,
     /*  295525 */   // Label 5546: @295525
     /*  295525 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(295588), // Rule ID 9401 //
     /*  295530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295569 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295586 */     GIR_RootConstrainSelectedInstOperands,
     /*  295587 */     // GIR_Coverage, 9401,
     /*  295587 */     GIR_EraseRootFromParent_Done,
     /*  295588 */   // Label 5547: @295588
     /*  295588 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(295651), // Rule ID 9404 //
     /*  295593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295649 */     GIR_RootConstrainSelectedInstOperands,
     /*  295650 */     // GIR_Coverage, 9404,
     /*  295650 */     GIR_EraseRootFromParent_Done,
     /*  295651 */   // Label 5548: @295651
     /*  295651 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(295714), // Rule ID 9405 //
     /*  295656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295712 */     GIR_RootConstrainSelectedInstOperands,
     /*  295713 */     // GIR_Coverage, 9405,
     /*  295713 */     GIR_EraseRootFromParent_Done,
     /*  295714 */   // Label 5549: @295714
     /*  295714 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(295777), // Rule ID 9408 //
     /*  295719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295758 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295775 */     GIR_RootConstrainSelectedInstOperands,
     /*  295776 */     // GIR_Coverage, 9408,
     /*  295776 */     GIR_EraseRootFromParent_Done,
     /*  295777 */   // Label 5550: @295777
     /*  295777 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(295840), // Rule ID 9409 //
     /*  295782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295821 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295838 */     GIR_RootConstrainSelectedInstOperands,
     /*  295839 */     // GIR_Coverage, 9409,
     /*  295839 */     GIR_EraseRootFromParent_Done,
     /*  295840 */   // Label 5551: @295840
     /*  295840 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(295903), // Rule ID 9412 //
     /*  295845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295884 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295901 */     GIR_RootConstrainSelectedInstOperands,
     /*  295902 */     // GIR_Coverage, 9412,
     /*  295902 */     GIR_EraseRootFromParent_Done,
     /*  295903 */   // Label 5552: @295903
     /*  295903 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(295966), // Rule ID 9413 //
     /*  295908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295947 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295964 */     GIR_RootConstrainSelectedInstOperands,
     /*  295965 */     // GIR_Coverage, 9413,
     /*  295965 */     GIR_EraseRootFromParent_Done,
     /*  295966 */   // Label 5553: @295966
     /*  295966 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(296029), // Rule ID 9416 //
     /*  295971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296010 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296027 */     GIR_RootConstrainSelectedInstOperands,
     /*  296028 */     // GIR_Coverage, 9416,
     /*  296028 */     GIR_EraseRootFromParent_Done,
     /*  296029 */   // Label 5554: @296029
     /*  296029 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(296092), // Rule ID 9417 //
     /*  296034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296073 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296090 */     GIR_RootConstrainSelectedInstOperands,
     /*  296091 */     // GIR_Coverage, 9417,
     /*  296091 */     GIR_EraseRootFromParent_Done,
     /*  296092 */   // Label 5555: @296092
     /*  296092 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(296155), // Rule ID 9420 //
     /*  296097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296153 */     GIR_RootConstrainSelectedInstOperands,
     /*  296154 */     // GIR_Coverage, 9420,
     /*  296154 */     GIR_EraseRootFromParent_Done,
     /*  296155 */   // Label 5556: @296155
     /*  296155 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(296218), // Rule ID 9421 //
     /*  296160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296199 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296216 */     GIR_RootConstrainSelectedInstOperands,
     /*  296217 */     // GIR_Coverage, 9421,
     /*  296217 */     GIR_EraseRootFromParent_Done,
     /*  296218 */   // Label 5557: @296218
     /*  296218 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(296281), // Rule ID 9424 //
     /*  296223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296279 */     GIR_RootConstrainSelectedInstOperands,
     /*  296280 */     // GIR_Coverage, 9424,
     /*  296280 */     GIR_EraseRootFromParent_Done,
     /*  296281 */   // Label 5558: @296281
     /*  296281 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(296344), // Rule ID 9425 //
     /*  296286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296325 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  296328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296342 */     GIR_RootConstrainSelectedInstOperands,
     /*  296343 */     // GIR_Coverage, 9425,
     /*  296343 */     GIR_EraseRootFromParent_Done,
     /*  296344 */   // Label 5559: @296344
     /*  296344 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(296407), // Rule ID 9428 //
     /*  296349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296405 */     GIR_RootConstrainSelectedInstOperands,
     /*  296406 */     // GIR_Coverage, 9428,
     /*  296406 */     GIR_EraseRootFromParent_Done,
     /*  296407 */   // Label 5560: @296407
     /*  296407 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(296470), // Rule ID 9429 //
     /*  296412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296468 */     GIR_RootConstrainSelectedInstOperands,
     /*  296469 */     // GIR_Coverage, 9429,
     /*  296469 */     GIR_EraseRootFromParent_Done,
     /*  296470 */   // Label 5561: @296470
     /*  296470 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(296533), // Rule ID 9432 //
     /*  296475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296514 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296531 */     GIR_RootConstrainSelectedInstOperands,
     /*  296532 */     // GIR_Coverage, 9432,
     /*  296532 */     GIR_EraseRootFromParent_Done,
     /*  296533 */   // Label 5562: @296533
     /*  296533 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(296596), // Rule ID 9433 //
     /*  296538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296577 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296594 */     GIR_RootConstrainSelectedInstOperands,
     /*  296595 */     // GIR_Coverage, 9433,
     /*  296595 */     GIR_EraseRootFromParent_Done,
     /*  296596 */   // Label 5563: @296596
     /*  296596 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(296659), // Rule ID 9436 //
     /*  296601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296640 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296657 */     GIR_RootConstrainSelectedInstOperands,
     /*  296658 */     // GIR_Coverage, 9436,
     /*  296658 */     GIR_EraseRootFromParent_Done,
     /*  296659 */   // Label 5564: @296659
     /*  296659 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(296722), // Rule ID 9437 //
     /*  296664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296703 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296720 */     GIR_RootConstrainSelectedInstOperands,
     /*  296721 */     // GIR_Coverage, 9437,
     /*  296721 */     GIR_EraseRootFromParent_Done,
     /*  296722 */   // Label 5565: @296722
     /*  296722 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(296785), // Rule ID 9440 //
     /*  296727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296783 */     GIR_RootConstrainSelectedInstOperands,
     /*  296784 */     // GIR_Coverage, 9440,
     /*  296784 */     GIR_EraseRootFromParent_Done,
     /*  296785 */   // Label 5566: @296785
     /*  296785 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(296848), // Rule ID 9441 //
     /*  296790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296829 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296846 */     GIR_RootConstrainSelectedInstOperands,
     /*  296847 */     // GIR_Coverage, 9441,
     /*  296847 */     GIR_EraseRootFromParent_Done,
     /*  296848 */   // Label 5567: @296848
     /*  296848 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(296911), // Rule ID 9444 //
     /*  296853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296909 */     GIR_RootConstrainSelectedInstOperands,
     /*  296910 */     // GIR_Coverage, 9444,
     /*  296910 */     GIR_EraseRootFromParent_Done,
     /*  296911 */   // Label 5568: @296911
     /*  296911 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(296974), // Rule ID 9445 //
     /*  296916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296972 */     GIR_RootConstrainSelectedInstOperands,
     /*  296973 */     // GIR_Coverage, 9445,
     /*  296973 */     GIR_EraseRootFromParent_Done,
     /*  296974 */   // Label 5569: @296974
     /*  296974 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(297037), // Rule ID 9448 //
     /*  296979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297018 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297035 */     GIR_RootConstrainSelectedInstOperands,
     /*  297036 */     // GIR_Coverage, 9448,
     /*  297036 */     GIR_EraseRootFromParent_Done,
     /*  297037 */   // Label 5570: @297037
     /*  297037 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(297100), // Rule ID 9449 //
     /*  297042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297081 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297098 */     GIR_RootConstrainSelectedInstOperands,
     /*  297099 */     // GIR_Coverage, 9449,
     /*  297099 */     GIR_EraseRootFromParent_Done,
     /*  297100 */   // Label 5571: @297100
     /*  297100 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(297163), // Rule ID 9452 //
     /*  297105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297161 */     GIR_RootConstrainSelectedInstOperands,
     /*  297162 */     // GIR_Coverage, 9452,
     /*  297162 */     GIR_EraseRootFromParent_Done,
     /*  297163 */   // Label 5572: @297163
     /*  297163 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(297226), // Rule ID 9453 //
     /*  297168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297224 */     GIR_RootConstrainSelectedInstOperands,
     /*  297225 */     // GIR_Coverage, 9453,
     /*  297225 */     GIR_EraseRootFromParent_Done,
     /*  297226 */   // Label 5573: @297226
     /*  297226 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(297289), // Rule ID 9456 //
     /*  297231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297287 */     GIR_RootConstrainSelectedInstOperands,
     /*  297288 */     // GIR_Coverage, 9456,
     /*  297288 */     GIR_EraseRootFromParent_Done,
     /*  297289 */   // Label 5574: @297289
     /*  297289 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(297352), // Rule ID 9457 //
     /*  297294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297333 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297350 */     GIR_RootConstrainSelectedInstOperands,
     /*  297351 */     // GIR_Coverage, 9457,
     /*  297351 */     GIR_EraseRootFromParent_Done,
     /*  297352 */   // Label 5575: @297352
     /*  297352 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(297415), // Rule ID 9460 //
     /*  297357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297413 */     GIR_RootConstrainSelectedInstOperands,
     /*  297414 */     // GIR_Coverage, 9460,
     /*  297414 */     GIR_EraseRootFromParent_Done,
     /*  297415 */   // Label 5576: @297415
     /*  297415 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(297478), // Rule ID 9461 //
     /*  297420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297459 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297476 */     GIR_RootConstrainSelectedInstOperands,
     /*  297477 */     // GIR_Coverage, 9461,
     /*  297477 */     GIR_EraseRootFromParent_Done,
     /*  297478 */   // Label 5577: @297478
     /*  297478 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(297541), // Rule ID 9464 //
     /*  297483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297539 */     GIR_RootConstrainSelectedInstOperands,
     /*  297540 */     // GIR_Coverage, 9464,
     /*  297540 */     GIR_EraseRootFromParent_Done,
     /*  297541 */   // Label 5578: @297541
     /*  297541 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(297604), // Rule ID 9465 //
     /*  297546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297585 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297602 */     GIR_RootConstrainSelectedInstOperands,
     /*  297603 */     // GIR_Coverage, 9465,
     /*  297603 */     GIR_EraseRootFromParent_Done,
     /*  297604 */   // Label 5579: @297604
     /*  297604 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(297667), // Rule ID 9468 //
     /*  297609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297648 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297665 */     GIR_RootConstrainSelectedInstOperands,
     /*  297666 */     // GIR_Coverage, 9468,
     /*  297666 */     GIR_EraseRootFromParent_Done,
     /*  297667 */   // Label 5580: @297667
     /*  297667 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(297730), // Rule ID 9469 //
     /*  297672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297711 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297728 */     GIR_RootConstrainSelectedInstOperands,
     /*  297729 */     // GIR_Coverage, 9469,
     /*  297729 */     GIR_EraseRootFromParent_Done,
     /*  297730 */   // Label 5581: @297730
     /*  297730 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(297793), // Rule ID 9472 //
     /*  297735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297774 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297791 */     GIR_RootConstrainSelectedInstOperands,
     /*  297792 */     // GIR_Coverage, 9472,
     /*  297792 */     GIR_EraseRootFromParent_Done,
     /*  297793 */   // Label 5582: @297793
     /*  297793 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(297856), // Rule ID 9473 //
     /*  297798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297837 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297854 */     GIR_RootConstrainSelectedInstOperands,
     /*  297855 */     // GIR_Coverage, 9473,
     /*  297855 */     GIR_EraseRootFromParent_Done,
     /*  297856 */   // Label 5583: @297856
     /*  297856 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(297919), // Rule ID 9564 //
     /*  297861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297917 */     GIR_RootConstrainSelectedInstOperands,
     /*  297918 */     // GIR_Coverage, 9564,
     /*  297918 */     GIR_EraseRootFromParent_Done,
     /*  297919 */   // Label 5584: @297919
     /*  297919 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(297982), // Rule ID 9565 //
     /*  297924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297980 */     GIR_RootConstrainSelectedInstOperands,
     /*  297981 */     // GIR_Coverage, 9565,
     /*  297981 */     GIR_EraseRootFromParent_Done,
     /*  297982 */   // Label 5585: @297982
     /*  297982 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(298045), // Rule ID 9568 //
     /*  297987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  298004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298043 */     GIR_RootConstrainSelectedInstOperands,
     /*  298044 */     // GIR_Coverage, 9568,
     /*  298044 */     GIR_EraseRootFromParent_Done,
     /*  298045 */   // Label 5586: @298045
     /*  298045 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(298108), // Rule ID 9569 //
     /*  298050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  298067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298089 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298106 */     GIR_RootConstrainSelectedInstOperands,
     /*  298107 */     // GIR_Coverage, 9569,
     /*  298107 */     GIR_EraseRootFromParent_Done,
     /*  298108 */   // Label 5587: @298108
     /*  298108 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(298171), // Rule ID 9572 //
     /*  298113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  298130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  298155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298169 */     GIR_RootConstrainSelectedInstOperands,
     /*  298170 */     // GIR_Coverage, 9572,
     /*  298170 */     GIR_EraseRootFromParent_Done,
     /*  298171 */   // Label 5588: @298171
     /*  298171 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(298234), // Rule ID 9573 //
     /*  298176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  298193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298215 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  298218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298232 */     GIR_RootConstrainSelectedInstOperands,
     /*  298233 */     // GIR_Coverage, 9573,
     /*  298233 */     GIR_EraseRootFromParent_Done,
     /*  298234 */   // Label 5589: @298234
     /*  298234 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(298297), // Rule ID 9576 //
     /*  298239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  298256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298295 */     GIR_RootConstrainSelectedInstOperands,
     /*  298296 */     // GIR_Coverage, 9576,
     /*  298296 */     GIR_EraseRootFromParent_Done,
     /*  298297 */   // Label 5590: @298297
     /*  298297 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(298360), // Rule ID 9577 //
     /*  298302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  298319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298341 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298358 */     GIR_RootConstrainSelectedInstOperands,
     /*  298359 */     // GIR_Coverage, 9577,
     /*  298359 */     GIR_EraseRootFromParent_Done,
     /*  298360 */   // Label 5591: @298360
     /*  298360 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(298423), // Rule ID 9580 //
     /*  298365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  298379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  298382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298421 */     GIR_RootConstrainSelectedInstOperands,
     /*  298422 */     // GIR_Coverage, 9580,
     /*  298422 */     GIR_EraseRootFromParent_Done,
     /*  298423 */   // Label 5592: @298423
     /*  298423 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(298486), // Rule ID 9581 //
     /*  298428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  298442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  298445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298484 */     GIR_RootConstrainSelectedInstOperands,
     /*  298485 */     // GIR_Coverage, 9581,
     /*  298485 */     GIR_EraseRootFromParent_Done,
     /*  298486 */   // Label 5593: @298486
     /*  298486 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(298549), // Rule ID 9584 //
     /*  298491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298547 */     GIR_RootConstrainSelectedInstOperands,
     /*  298548 */     // GIR_Coverage, 9584,
     /*  298548 */     GIR_EraseRootFromParent_Done,
     /*  298549 */   // Label 5594: @298549
     /*  298549 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(298612), // Rule ID 9585 //
     /*  298554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298593 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298610 */     GIR_RootConstrainSelectedInstOperands,
     /*  298611 */     // GIR_Coverage, 9585,
     /*  298611 */     GIR_EraseRootFromParent_Done,
     /*  298612 */   // Label 5595: @298612
     /*  298612 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(298675), // Rule ID 9588 //
     /*  298617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298673 */     GIR_RootConstrainSelectedInstOperands,
     /*  298674 */     // GIR_Coverage, 9588,
     /*  298674 */     GIR_EraseRootFromParent_Done,
     /*  298675 */   // Label 5596: @298675
     /*  298675 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(298738), // Rule ID 9589 //
     /*  298680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298719 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298736 */     GIR_RootConstrainSelectedInstOperands,
     /*  298737 */     // GIR_Coverage, 9589,
     /*  298737 */     GIR_EraseRootFromParent_Done,
     /*  298738 */   // Label 5597: @298738
     /*  298738 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(298801), // Rule ID 9592 //
     /*  298743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298799 */     GIR_RootConstrainSelectedInstOperands,
     /*  298800 */     // GIR_Coverage, 9592,
     /*  298800 */     GIR_EraseRootFromParent_Done,
     /*  298801 */   // Label 5598: @298801
     /*  298801 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(298864), // Rule ID 9593 //
     /*  298806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298845 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298862 */     GIR_RootConstrainSelectedInstOperands,
     /*  298863 */     // GIR_Coverage, 9593,
     /*  298863 */     GIR_EraseRootFromParent_Done,
     /*  298864 */   // Label 5599: @298864
     /*  298864 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(298927), // Rule ID 9596 //
     /*  298869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298908 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298925 */     GIR_RootConstrainSelectedInstOperands,
     /*  298926 */     // GIR_Coverage, 9596,
     /*  298926 */     GIR_EraseRootFromParent_Done,
     /*  298927 */   // Label 5600: @298927
     /*  298927 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(298990), // Rule ID 9597 //
     /*  298932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298971 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298988 */     GIR_RootConstrainSelectedInstOperands,
     /*  298989 */     // GIR_Coverage, 9597,
     /*  298989 */     GIR_EraseRootFromParent_Done,
     /*  298990 */   // Label 5601: @298990
     /*  298990 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(299053), // Rule ID 9600 //
     /*  298995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  299012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299051 */     GIR_RootConstrainSelectedInstOperands,
     /*  299052 */     // GIR_Coverage, 9600,
     /*  299052 */     GIR_EraseRootFromParent_Done,
     /*  299053 */   // Label 5602: @299053
     /*  299053 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(299116), // Rule ID 9601 //
     /*  299058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  299075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299114 */     GIR_RootConstrainSelectedInstOperands,
     /*  299115 */     // GIR_Coverage, 9601,
     /*  299115 */     GIR_EraseRootFromParent_Done,
     /*  299116 */   // Label 5603: @299116
     /*  299116 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(299179), // Rule ID 9604 //
     /*  299121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  299138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299160 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299177 */     GIR_RootConstrainSelectedInstOperands,
     /*  299178 */     // GIR_Coverage, 9604,
     /*  299178 */     GIR_EraseRootFromParent_Done,
     /*  299179 */   // Label 5604: @299179
     /*  299179 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(299242), // Rule ID 9605 //
     /*  299184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  299201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299223 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299240 */     GIR_RootConstrainSelectedInstOperands,
     /*  299241 */     // GIR_Coverage, 9605,
     /*  299241 */     GIR_EraseRootFromParent_Done,
     /*  299242 */   // Label 5605: @299242
     /*  299242 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(299305), // Rule ID 9608 //
     /*  299247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  299264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299286 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299303 */     GIR_RootConstrainSelectedInstOperands,
     /*  299304 */     // GIR_Coverage, 9608,
     /*  299304 */     GIR_EraseRootFromParent_Done,
     /*  299305 */   // Label 5606: @299305
     /*  299305 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(299368), // Rule ID 9609 //
     /*  299310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  299327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299349 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299366 */     GIR_RootConstrainSelectedInstOperands,
     /*  299367 */     // GIR_Coverage, 9609,
     /*  299367 */     GIR_EraseRootFromParent_Done,
     /*  299368 */   // Label 5607: @299368
     /*  299368 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(299431), // Rule ID 9612 //
     /*  299373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  299387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  299390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299429 */     GIR_RootConstrainSelectedInstOperands,
     /*  299430 */     // GIR_Coverage, 9612,
     /*  299430 */     GIR_EraseRootFromParent_Done,
     /*  299431 */   // Label 5608: @299431
     /*  299431 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(299494), // Rule ID 9613 //
     /*  299436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  299450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  299453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299492 */     GIR_RootConstrainSelectedInstOperands,
     /*  299493 */     // GIR_Coverage, 9613,
     /*  299493 */     GIR_EraseRootFromParent_Done,
     /*  299494 */   // Label 5609: @299494
     /*  299494 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(299557), // Rule ID 9616 //
     /*  299499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299555 */     GIR_RootConstrainSelectedInstOperands,
     /*  299556 */     // GIR_Coverage, 9616,
     /*  299556 */     GIR_EraseRootFromParent_Done,
     /*  299557 */   // Label 5610: @299557
     /*  299557 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(299620), // Rule ID 9617 //
     /*  299562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299601 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299618 */     GIR_RootConstrainSelectedInstOperands,
     /*  299619 */     // GIR_Coverage, 9617,
     /*  299619 */     GIR_EraseRootFromParent_Done,
     /*  299620 */   // Label 5611: @299620
     /*  299620 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(299683), // Rule ID 9620 //
     /*  299625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299681 */     GIR_RootConstrainSelectedInstOperands,
     /*  299682 */     // GIR_Coverage, 9620,
     /*  299682 */     GIR_EraseRootFromParent_Done,
     /*  299683 */   // Label 5612: @299683
     /*  299683 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(299746), // Rule ID 9621 //
     /*  299688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299727 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299744 */     GIR_RootConstrainSelectedInstOperands,
     /*  299745 */     // GIR_Coverage, 9621,
     /*  299745 */     GIR_EraseRootFromParent_Done,
     /*  299746 */   // Label 5613: @299746
     /*  299746 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(299809), // Rule ID 9624 //
     /*  299751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299790 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299807 */     GIR_RootConstrainSelectedInstOperands,
     /*  299808 */     // GIR_Coverage, 9624,
     /*  299808 */     GIR_EraseRootFromParent_Done,
     /*  299809 */   // Label 5614: @299809
     /*  299809 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(299872), // Rule ID 9625 //
     /*  299814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299853 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299870 */     GIR_RootConstrainSelectedInstOperands,
     /*  299871 */     // GIR_Coverage, 9625,
     /*  299871 */     GIR_EraseRootFromParent_Done,
     /*  299872 */   // Label 5615: @299872
     /*  299872 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(299935), // Rule ID 9628 //
     /*  299877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299916 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299933 */     GIR_RootConstrainSelectedInstOperands,
     /*  299934 */     // GIR_Coverage, 9628,
     /*  299934 */     GIR_EraseRootFromParent_Done,
     /*  299935 */   // Label 5616: @299935
     /*  299935 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(299998), // Rule ID 9629 //
     /*  299940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299979 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299996 */     GIR_RootConstrainSelectedInstOperands,
     /*  299997 */     // GIR_Coverage, 9629,
     /*  299997 */     GIR_EraseRootFromParent_Done,
     /*  299998 */   // Label 5617: @299998
     /*  299998 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(300061), // Rule ID 9632 //
     /*  300003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  300020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300059 */     GIR_RootConstrainSelectedInstOperands,
     /*  300060 */     // GIR_Coverage, 9632,
     /*  300060 */     GIR_EraseRootFromParent_Done,
     /*  300061 */   // Label 5618: @300061
     /*  300061 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(300124), // Rule ID 9633 //
     /*  300066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  300083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300105 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300122 */     GIR_RootConstrainSelectedInstOperands,
     /*  300123 */     // GIR_Coverage, 9633,
     /*  300123 */     GIR_EraseRootFromParent_Done,
     /*  300124 */   // Label 5619: @300124
     /*  300124 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(300187), // Rule ID 9636 //
     /*  300129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  300146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  300171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300185 */     GIR_RootConstrainSelectedInstOperands,
     /*  300186 */     // GIR_Coverage, 9636,
     /*  300186 */     GIR_EraseRootFromParent_Done,
     /*  300187 */   // Label 5620: @300187
     /*  300187 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(300250), // Rule ID 9637 //
     /*  300192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  300209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300231 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11509:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  300234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300248 */     GIR_RootConstrainSelectedInstOperands,
     /*  300249 */     // GIR_Coverage, 9637,
     /*  300249 */     GIR_EraseRootFromParent_Done,
     /*  300250 */   // Label 5621: @300250
     /*  300250 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(300313), // Rule ID 9640 //
     /*  300255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  300269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  300272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  300297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300311 */     GIR_RootConstrainSelectedInstOperands,
     /*  300312 */     // GIR_Coverage, 9640,
     /*  300312 */     GIR_EraseRootFromParent_Done,
     /*  300313 */   // Label 5622: @300313
     /*  300313 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(300376), // Rule ID 9641 //
     /*  300318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  300332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  300335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300357 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11509:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  300360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300374 */     GIR_RootConstrainSelectedInstOperands,
     /*  300375 */     // GIR_Coverage, 9641,
     /*  300375 */     GIR_EraseRootFromParent_Done,
     /*  300376 */   // Label 5623: @300376
     /*  300376 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(300439), // Rule ID 9644 //
     /*  300381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  300395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  300398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300437 */     GIR_RootConstrainSelectedInstOperands,
     /*  300438 */     // GIR_Coverage, 9644,
     /*  300438 */     GIR_EraseRootFromParent_Done,
     /*  300439 */   // Label 5624: @300439
     /*  300439 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(300502), // Rule ID 9645 //
     /*  300444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  300452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  300458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  300461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11509:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300500 */     GIR_RootConstrainSelectedInstOperands,
     /*  300501 */     // GIR_Coverage, 9645,
     /*  300501 */     GIR_EraseRootFromParent_Done,
     /*  300502 */   // Label 5625: @300502
     /*  300502 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(300565), // Rule ID 9648 //
     /*  300507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300563 */     GIR_RootConstrainSelectedInstOperands,
     /*  300564 */     // GIR_Coverage, 9648,
     /*  300564 */     GIR_EraseRootFromParent_Done,
     /*  300565 */   // Label 5626: @300565
     /*  300565 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(300628), // Rule ID 9649 //
     /*  300570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300626 */     GIR_RootConstrainSelectedInstOperands,
     /*  300627 */     // GIR_Coverage, 9649,
     /*  300627 */     GIR_EraseRootFromParent_Done,
     /*  300628 */   // Label 5627: @300628
     /*  300628 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(300691), // Rule ID 9652 //
     /*  300633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300689 */     GIR_RootConstrainSelectedInstOperands,
     /*  300690 */     // GIR_Coverage, 9652,
     /*  300690 */     GIR_EraseRootFromParent_Done,
     /*  300691 */   // Label 5628: @300691
     /*  300691 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(300754), // Rule ID 9653 //
     /*  300696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300752 */     GIR_RootConstrainSelectedInstOperands,
     /*  300753 */     // GIR_Coverage, 9653,
     /*  300753 */     GIR_EraseRootFromParent_Done,
     /*  300754 */   // Label 5629: @300754
     /*  300754 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(300817), // Rule ID 9656 //
     /*  300759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300815 */     GIR_RootConstrainSelectedInstOperands,
     /*  300816 */     // GIR_Coverage, 9656,
     /*  300816 */     GIR_EraseRootFromParent_Done,
     /*  300817 */   // Label 5630: @300817
     /*  300817 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(300880), // Rule ID 9657 //
     /*  300822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300861 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300878 */     GIR_RootConstrainSelectedInstOperands,
     /*  300879 */     // GIR_Coverage, 9657,
     /*  300879 */     GIR_EraseRootFromParent_Done,
     /*  300880 */   // Label 5631: @300880
     /*  300880 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(300943), // Rule ID 9660 //
     /*  300885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300941 */     GIR_RootConstrainSelectedInstOperands,
     /*  300942 */     // GIR_Coverage, 9660,
     /*  300942 */     GIR_EraseRootFromParent_Done,
     /*  300943 */   // Label 5632: @300943
     /*  300943 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(301006), // Rule ID 9661 //
     /*  300948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301004 */     GIR_RootConstrainSelectedInstOperands,
     /*  301005 */     // GIR_Coverage, 9661,
     /*  301005 */     GIR_EraseRootFromParent_Done,
     /*  301006 */   // Label 5633: @301006
     /*  301006 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(301069), // Rule ID 9664 //
     /*  301011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301067 */     GIR_RootConstrainSelectedInstOperands,
     /*  301068 */     // GIR_Coverage, 9664,
     /*  301068 */     GIR_EraseRootFromParent_Done,
     /*  301069 */   // Label 5634: @301069
     /*  301069 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(301132), // Rule ID 9665 //
     /*  301074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301113 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301130 */     GIR_RootConstrainSelectedInstOperands,
     /*  301131 */     // GIR_Coverage, 9665,
     /*  301131 */     GIR_EraseRootFromParent_Done,
     /*  301132 */   // Label 5635: @301132
     /*  301132 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(301195), // Rule ID 9668 //
     /*  301137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301193 */     GIR_RootConstrainSelectedInstOperands,
     /*  301194 */     // GIR_Coverage, 9668,
     /*  301194 */     GIR_EraseRootFromParent_Done,
     /*  301195 */   // Label 5636: @301195
     /*  301195 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(301258), // Rule ID 9669 //
     /*  301200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  301242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301256 */     GIR_RootConstrainSelectedInstOperands,
     /*  301257 */     // GIR_Coverage, 9669,
     /*  301257 */     GIR_EraseRootFromParent_Done,
     /*  301258 */   // Label 5637: @301258
     /*  301258 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(301321), // Rule ID 9672 //
     /*  301263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301319 */     GIR_RootConstrainSelectedInstOperands,
     /*  301320 */     // GIR_Coverage, 9672,
     /*  301320 */     GIR_EraseRootFromParent_Done,
     /*  301321 */   // Label 5638: @301321
     /*  301321 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(301384), // Rule ID 9673 //
     /*  301326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301365 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301382 */     GIR_RootConstrainSelectedInstOperands,
     /*  301383 */     // GIR_Coverage, 9673,
     /*  301383 */     GIR_EraseRootFromParent_Done,
     /*  301384 */   // Label 5639: @301384
     /*  301384 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(301447), // Rule ID 9676 //
     /*  301389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301445 */     GIR_RootConstrainSelectedInstOperands,
     /*  301446 */     // GIR_Coverage, 9676,
     /*  301446 */     GIR_EraseRootFromParent_Done,
     /*  301447 */   // Label 5640: @301447
     /*  301447 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(301510), // Rule ID 9677 //
     /*  301452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301491 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301508 */     GIR_RootConstrainSelectedInstOperands,
     /*  301509 */     // GIR_Coverage, 9677,
     /*  301509 */     GIR_EraseRootFromParent_Done,
     /*  301510 */   // Label 5641: @301510
     /*  301510 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(301573), // Rule ID 9680 //
     /*  301515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301554 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301571 */     GIR_RootConstrainSelectedInstOperands,
     /*  301572 */     // GIR_Coverage, 9680,
     /*  301572 */     GIR_EraseRootFromParent_Done,
     /*  301573 */   // Label 5642: @301573
     /*  301573 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(301636), // Rule ID 9681 //
     /*  301578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301634 */     GIR_RootConstrainSelectedInstOperands,
     /*  301635 */     // GIR_Coverage, 9681,
     /*  301635 */     GIR_EraseRootFromParent_Done,
     /*  301636 */   // Label 5643: @301636
     /*  301636 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(301699), // Rule ID 9684 //
     /*  301641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301680 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301697 */     GIR_RootConstrainSelectedInstOperands,
     /*  301698 */     // GIR_Coverage, 9684,
     /*  301698 */     GIR_EraseRootFromParent_Done,
     /*  301699 */   // Label 5644: @301699
     /*  301699 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(301762), // Rule ID 9685 //
     /*  301704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301743 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301760 */     GIR_RootConstrainSelectedInstOperands,
     /*  301761 */     // GIR_Coverage, 9685,
     /*  301761 */     GIR_EraseRootFromParent_Done,
     /*  301762 */   // Label 5645: @301762
     /*  301762 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(301825), // Rule ID 9688 //
     /*  301767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301806 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301823 */     GIR_RootConstrainSelectedInstOperands,
     /*  301824 */     // GIR_Coverage, 9688,
     /*  301824 */     GIR_EraseRootFromParent_Done,
     /*  301825 */   // Label 5646: @301825
     /*  301825 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(301888), // Rule ID 9689 //
     /*  301830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301886 */     GIR_RootConstrainSelectedInstOperands,
     /*  301887 */     // GIR_Coverage, 9689,
     /*  301887 */     GIR_EraseRootFromParent_Done,
     /*  301888 */   // Label 5647: @301888
     /*  301888 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(301951), // Rule ID 9692 //
     /*  301893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301932 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301949 */     GIR_RootConstrainSelectedInstOperands,
     /*  301950 */     // GIR_Coverage, 9692,
     /*  301950 */     GIR_EraseRootFromParent_Done,
     /*  301951 */   // Label 5648: @301951
     /*  301951 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(302014), // Rule ID 9693 //
     /*  301956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301995 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302012 */     GIR_RootConstrainSelectedInstOperands,
     /*  302013 */     // GIR_Coverage, 9693,
     /*  302013 */     GIR_EraseRootFromParent_Done,
     /*  302014 */   // Label 5649: @302014
     /*  302014 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(302077), // Rule ID 9696 //
     /*  302019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302058 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302075 */     GIR_RootConstrainSelectedInstOperands,
     /*  302076 */     // GIR_Coverage, 9696,
     /*  302076 */     GIR_EraseRootFromParent_Done,
     /*  302077 */   // Label 5650: @302077
     /*  302077 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(302140), // Rule ID 9697 //
     /*  302082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302121 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302138 */     GIR_RootConstrainSelectedInstOperands,
     /*  302139 */     // GIR_Coverage, 9697,
     /*  302139 */     GIR_EraseRootFromParent_Done,
     /*  302140 */   // Label 5651: @302140
     /*  302140 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(302203), // Rule ID 9700 //
     /*  302145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302184 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302201 */     GIR_RootConstrainSelectedInstOperands,
     /*  302202 */     // GIR_Coverage, 9700,
     /*  302202 */     GIR_EraseRootFromParent_Done,
     /*  302203 */   // Label 5652: @302203
     /*  302203 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(302266), // Rule ID 9701 //
     /*  302208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302247 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302264 */     GIR_RootConstrainSelectedInstOperands,
     /*  302265 */     // GIR_Coverage, 9701,
     /*  302265 */     GIR_EraseRootFromParent_Done,
     /*  302266 */   // Label 5653: @302266
     /*  302266 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(302329), // Rule ID 9704 //
     /*  302271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302327 */     GIR_RootConstrainSelectedInstOperands,
     /*  302328 */     // GIR_Coverage, 9704,
     /*  302328 */     GIR_EraseRootFromParent_Done,
     /*  302329 */   // Label 5654: @302329
     /*  302329 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(302392), // Rule ID 9705 //
     /*  302334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302373 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302390 */     GIR_RootConstrainSelectedInstOperands,
     /*  302391 */     // GIR_Coverage, 9705,
     /*  302391 */     GIR_EraseRootFromParent_Done,
     /*  302392 */   // Label 5655: @302392
     /*  302392 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(302455), // Rule ID 9708 //
     /*  302397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302436 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302453 */     GIR_RootConstrainSelectedInstOperands,
     /*  302454 */     // GIR_Coverage, 9708,
     /*  302454 */     GIR_EraseRootFromParent_Done,
     /*  302455 */   // Label 5656: @302455
     /*  302455 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(302518), // Rule ID 9709 //
     /*  302460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302499 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302516 */     GIR_RootConstrainSelectedInstOperands,
     /*  302517 */     // GIR_Coverage, 9709,
     /*  302517 */     GIR_EraseRootFromParent_Done,
     /*  302518 */   // Label 5657: @302518
     /*  302518 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(302581), // Rule ID 9712 //
     /*  302523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302579 */     GIR_RootConstrainSelectedInstOperands,
     /*  302580 */     // GIR_Coverage, 9712,
     /*  302580 */     GIR_EraseRootFromParent_Done,
     /*  302581 */   // Label 5658: @302581
     /*  302581 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(302644), // Rule ID 9713 //
     /*  302586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302625 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302642 */     GIR_RootConstrainSelectedInstOperands,
     /*  302643 */     // GIR_Coverage, 9713,
     /*  302643 */     GIR_EraseRootFromParent_Done,
     /*  302644 */   // Label 5659: @302644
     /*  302644 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(302707), // Rule ID 9716 //
     /*  302649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302705 */     GIR_RootConstrainSelectedInstOperands,
     /*  302706 */     // GIR_Coverage, 9716,
     /*  302706 */     GIR_EraseRootFromParent_Done,
     /*  302707 */   // Label 5660: @302707
     /*  302707 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(302770), // Rule ID 9717 //
     /*  302712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302751 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302768 */     GIR_RootConstrainSelectedInstOperands,
     /*  302769 */     // GIR_Coverage, 9717,
     /*  302769 */     GIR_EraseRootFromParent_Done,
     /*  302770 */   // Label 5661: @302770
     /*  302770 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(302833), // Rule ID 9720 //
     /*  302775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302831 */     GIR_RootConstrainSelectedInstOperands,
     /*  302832 */     // GIR_Coverage, 9720,
     /*  302832 */     GIR_EraseRootFromParent_Done,
     /*  302833 */   // Label 5662: @302833
     /*  302833 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(302896), // Rule ID 9721 //
     /*  302838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302894 */     GIR_RootConstrainSelectedInstOperands,
     /*  302895 */     // GIR_Coverage, 9721,
     /*  302895 */     GIR_EraseRootFromParent_Done,
     /*  302896 */   // Label 5663: @302896
     /*  302896 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(302959), // Rule ID 9724 //
     /*  302901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302957 */     GIR_RootConstrainSelectedInstOperands,
     /*  302958 */     // GIR_Coverage, 9724,
     /*  302958 */     GIR_EraseRootFromParent_Done,
     /*  302959 */   // Label 5664: @302959
     /*  302959 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(303022), // Rule ID 9725 //
     /*  302964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11507:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  303006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303020 */     GIR_RootConstrainSelectedInstOperands,
     /*  303021 */     // GIR_Coverage, 9725,
     /*  303021 */     GIR_EraseRootFromParent_Done,
     /*  303022 */   // Label 5665: @303022
     /*  303022 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(303085), // Rule ID 9728 //
     /*  303027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  303069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303083 */     GIR_RootConstrainSelectedInstOperands,
     /*  303084 */     // GIR_Coverage, 9728,
     /*  303084 */     GIR_EraseRootFromParent_Done,
     /*  303085 */   // Label 5666: @303085
     /*  303085 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(303148), // Rule ID 9729 //
     /*  303090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303129 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11507:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  303132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303146 */     GIR_RootConstrainSelectedInstOperands,
     /*  303147 */     // GIR_Coverage, 9729,
     /*  303147 */     GIR_EraseRootFromParent_Done,
     /*  303148 */   // Label 5667: @303148
     /*  303148 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(303211), // Rule ID 9732 //
     /*  303153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  303195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303209 */     GIR_RootConstrainSelectedInstOperands,
     /*  303210 */     // GIR_Coverage, 9732,
     /*  303210 */     GIR_EraseRootFromParent_Done,
     /*  303211 */   // Label 5668: @303211
     /*  303211 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(303274), // Rule ID 9733 //
     /*  303216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303255 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11507:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  303258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303272 */     GIR_RootConstrainSelectedInstOperands,
     /*  303273 */     // GIR_Coverage, 9733,
     /*  303273 */     GIR_EraseRootFromParent_Done,
     /*  303274 */   // Label 5669: @303274
     /*  303274 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(303337), // Rule ID 9736 //
     /*  303279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  303321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303335 */     GIR_RootConstrainSelectedInstOperands,
     /*  303336 */     // GIR_Coverage, 9736,
     /*  303336 */     GIR_EraseRootFromParent_Done,
     /*  303337 */   // Label 5670: @303337
     /*  303337 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(303400), // Rule ID 9737 //
     /*  303342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303381 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  303384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303398 */     GIR_RootConstrainSelectedInstOperands,
     /*  303399 */     // GIR_Coverage, 9737,
     /*  303399 */     GIR_EraseRootFromParent_Done,
     /*  303400 */   // Label 5671: @303400
     /*  303400 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(303463), // Rule ID 9740 //
     /*  303405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303461 */     GIR_RootConstrainSelectedInstOperands,
     /*  303462 */     // GIR_Coverage, 9740,
     /*  303462 */     GIR_EraseRootFromParent_Done,
     /*  303463 */   // Label 5672: @303463
     /*  303463 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(303526), // Rule ID 9741 //
     /*  303468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303507 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303524 */     GIR_RootConstrainSelectedInstOperands,
     /*  303525 */     // GIR_Coverage, 9741,
     /*  303525 */     GIR_EraseRootFromParent_Done,
     /*  303526 */   // Label 5673: @303526
     /*  303526 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(303589), // Rule ID 9744 //
     /*  303531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303587 */     GIR_RootConstrainSelectedInstOperands,
     /*  303588 */     // GIR_Coverage, 9744,
     /*  303588 */     GIR_EraseRootFromParent_Done,
     /*  303589 */   // Label 5674: @303589
     /*  303589 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(303652), // Rule ID 9745 //
     /*  303594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303633 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303650 */     GIR_RootConstrainSelectedInstOperands,
     /*  303651 */     // GIR_Coverage, 9745,
     /*  303651 */     GIR_EraseRootFromParent_Done,
     /*  303652 */   // Label 5675: @303652
     /*  303652 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(303715), // Rule ID 9748 //
     /*  303657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303713 */     GIR_RootConstrainSelectedInstOperands,
     /*  303714 */     // GIR_Coverage, 9748,
     /*  303714 */     GIR_EraseRootFromParent_Done,
     /*  303715 */   // Label 5676: @303715
     /*  303715 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(303778), // Rule ID 9749 //
     /*  303720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303776 */     GIR_RootConstrainSelectedInstOperands,
     /*  303777 */     // GIR_Coverage, 9749,
     /*  303777 */     GIR_EraseRootFromParent_Done,
     /*  303778 */   // Label 5677: @303778
     /*  303778 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(303841), // Rule ID 9752 //
     /*  303783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303839 */     GIR_RootConstrainSelectedInstOperands,
     /*  303840 */     // GIR_Coverage, 9752,
     /*  303840 */     GIR_EraseRootFromParent_Done,
     /*  303841 */   // Label 5678: @303841
     /*  303841 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(303904), // Rule ID 9753 //
     /*  303846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303885 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303902 */     GIR_RootConstrainSelectedInstOperands,
     /*  303903 */     // GIR_Coverage, 9753,
     /*  303903 */     GIR_EraseRootFromParent_Done,
     /*  303904 */   // Label 5679: @303904
     /*  303904 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(303967), // Rule ID 9756 //
     /*  303909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303948 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303965 */     GIR_RootConstrainSelectedInstOperands,
     /*  303966 */     // GIR_Coverage, 9756,
     /*  303966 */     GIR_EraseRootFromParent_Done,
     /*  303967 */   // Label 5680: @303967
     /*  303967 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(304030), // Rule ID 9757 //
     /*  303972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304011 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  304014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304028 */     GIR_RootConstrainSelectedInstOperands,
     /*  304029 */     // GIR_Coverage, 9757,
     /*  304029 */     GIR_EraseRootFromParent_Done,
     /*  304030 */   // Label 5681: @304030
     /*  304030 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(304093), // Rule ID 9760 //
     /*  304035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304074 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304091 */     GIR_RootConstrainSelectedInstOperands,
     /*  304092 */     // GIR_Coverage, 9760,
     /*  304092 */     GIR_EraseRootFromParent_Done,
     /*  304093 */   // Label 5682: @304093
     /*  304093 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(304156), // Rule ID 9761 //
     /*  304098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304137 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304154 */     GIR_RootConstrainSelectedInstOperands,
     /*  304155 */     // GIR_Coverage, 9761,
     /*  304155 */     GIR_EraseRootFromParent_Done,
     /*  304156 */   // Label 5683: @304156
     /*  304156 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(304219), // Rule ID 9764 //
     /*  304161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304217 */     GIR_RootConstrainSelectedInstOperands,
     /*  304218 */     // GIR_Coverage, 9764,
     /*  304218 */     GIR_EraseRootFromParent_Done,
     /*  304219 */   // Label 5684: @304219
     /*  304219 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(304282), // Rule ID 9765 //
     /*  304224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304263 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304280 */     GIR_RootConstrainSelectedInstOperands,
     /*  304281 */     // GIR_Coverage, 9765,
     /*  304281 */     GIR_EraseRootFromParent_Done,
     /*  304282 */   // Label 5685: @304282
     /*  304282 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(304345), // Rule ID 9768 //
     /*  304287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304343 */     GIR_RootConstrainSelectedInstOperands,
     /*  304344 */     // GIR_Coverage, 9768,
     /*  304344 */     GIR_EraseRootFromParent_Done,
     /*  304345 */   // Label 5686: @304345
     /*  304345 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(304408), // Rule ID 9769 //
     /*  304350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304389 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304406 */     GIR_RootConstrainSelectedInstOperands,
     /*  304407 */     // GIR_Coverage, 9769,
     /*  304407 */     GIR_EraseRootFromParent_Done,
     /*  304408 */   // Label 5687: @304408
     /*  304408 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(304471), // Rule ID 9772 //
     /*  304413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  304452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304469 */     GIR_RootConstrainSelectedInstOperands,
     /*  304470 */     // GIR_Coverage, 9772,
     /*  304470 */     GIR_EraseRootFromParent_Done,
     /*  304471 */   // Label 5688: @304471
     /*  304471 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(304534), // Rule ID 9773 //
     /*  304476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304515 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304532 */     GIR_RootConstrainSelectedInstOperands,
     /*  304533 */     // GIR_Coverage, 9773,
     /*  304533 */     GIR_EraseRootFromParent_Done,
     /*  304534 */   // Label 5689: @304534
     /*  304534 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(304597), // Rule ID 9776 //
     /*  304539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304595 */     GIR_RootConstrainSelectedInstOperands,
     /*  304596 */     // GIR_Coverage, 9776,
     /*  304596 */     GIR_EraseRootFromParent_Done,
     /*  304597 */   // Label 5690: @304597
     /*  304597 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(304660), // Rule ID 9777 //
     /*  304602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304641 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304658 */     GIR_RootConstrainSelectedInstOperands,
     /*  304659 */     // GIR_Coverage, 9777,
     /*  304659 */     GIR_EraseRootFromParent_Done,
     /*  304660 */   // Label 5691: @304660
     /*  304660 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(304723), // Rule ID 9780 //
     /*  304665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304704 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304721 */     GIR_RootConstrainSelectedInstOperands,
     /*  304722 */     // GIR_Coverage, 9780,
     /*  304722 */     GIR_EraseRootFromParent_Done,
     /*  304723 */   // Label 5692: @304723
     /*  304723 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(304786), // Rule ID 9781 //
     /*  304728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304767 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304784 */     GIR_RootConstrainSelectedInstOperands,
     /*  304785 */     // GIR_Coverage, 9781,
     /*  304785 */     GIR_EraseRootFromParent_Done,
     /*  304786 */   // Label 5693: @304786
     /*  304786 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(304849), // Rule ID 9784 //
     /*  304791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304830 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304847 */     GIR_RootConstrainSelectedInstOperands,
     /*  304848 */     // GIR_Coverage, 9784,
     /*  304848 */     GIR_EraseRootFromParent_Done,
     /*  304849 */   // Label 5694: @304849
     /*  304849 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(304912), // Rule ID 9785 //
     /*  304854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304893 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304910 */     GIR_RootConstrainSelectedInstOperands,
     /*  304911 */     // GIR_Coverage, 9785,
     /*  304911 */     GIR_EraseRootFromParent_Done,
     /*  304912 */   // Label 5695: @304912
     /*  304912 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(304975), // Rule ID 9788 //
     /*  304917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304956 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304973 */     GIR_RootConstrainSelectedInstOperands,
     /*  304974 */     // GIR_Coverage, 9788,
     /*  304974 */     GIR_EraseRootFromParent_Done,
     /*  304975 */   // Label 5696: @304975
     /*  304975 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(305038), // Rule ID 9789 //
     /*  304980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305019 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305036 */     GIR_RootConstrainSelectedInstOperands,
     /*  305037 */     // GIR_Coverage, 9789,
     /*  305037 */     GIR_EraseRootFromParent_Done,
     /*  305038 */   // Label 5697: @305038
     /*  305038 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(305101), // Rule ID 9792 //
     /*  305043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305082 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305099 */     GIR_RootConstrainSelectedInstOperands,
     /*  305100 */     // GIR_Coverage, 9792,
     /*  305100 */     GIR_EraseRootFromParent_Done,
     /*  305101 */   // Label 5698: @305101
     /*  305101 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(305164), // Rule ID 9793 //
     /*  305106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305145 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305162 */     GIR_RootConstrainSelectedInstOperands,
     /*  305163 */     // GIR_Coverage, 9793,
     /*  305163 */     GIR_EraseRootFromParent_Done,
     /*  305164 */   // Label 5699: @305164
     /*  305164 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(305227), // Rule ID 9796 //
     /*  305169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305208 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305225 */     GIR_RootConstrainSelectedInstOperands,
     /*  305226 */     // GIR_Coverage, 9796,
     /*  305226 */     GIR_EraseRootFromParent_Done,
     /*  305227 */   // Label 5700: @305227
     /*  305227 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(305290), // Rule ID 9797 //
     /*  305232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305271 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305288 */     GIR_RootConstrainSelectedInstOperands,
     /*  305289 */     // GIR_Coverage, 9797,
     /*  305289 */     GIR_EraseRootFromParent_Done,
     /*  305290 */   // Label 5701: @305290
     /*  305290 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(305353), // Rule ID 9800 //
     /*  305295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305334 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305351 */     GIR_RootConstrainSelectedInstOperands,
     /*  305352 */     // GIR_Coverage, 9800,
     /*  305352 */     GIR_EraseRootFromParent_Done,
     /*  305353 */   // Label 5702: @305353
     /*  305353 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(305416), // Rule ID 9801 //
     /*  305358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305397 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305414 */     GIR_RootConstrainSelectedInstOperands,
     /*  305415 */     // GIR_Coverage, 9801,
     /*  305415 */     GIR_EraseRootFromParent_Done,
     /*  305416 */   // Label 5703: @305416
     /*  305416 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(305479), // Rule ID 9804 //
     /*  305421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305477 */     GIR_RootConstrainSelectedInstOperands,
     /*  305478 */     // GIR_Coverage, 9804,
     /*  305478 */     GIR_EraseRootFromParent_Done,
     /*  305479 */   // Label 5704: @305479
     /*  305479 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(305542), // Rule ID 9805 //
     /*  305484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305523 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305540 */     GIR_RootConstrainSelectedInstOperands,
     /*  305541 */     // GIR_Coverage, 9805,
     /*  305541 */     GIR_EraseRootFromParent_Done,
     /*  305542 */   // Label 5705: @305542
     /*  305542 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(305605), // Rule ID 9808 //
     /*  305547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305586 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305603 */     GIR_RootConstrainSelectedInstOperands,
     /*  305604 */     // GIR_Coverage, 9808,
     /*  305604 */     GIR_EraseRootFromParent_Done,
     /*  305605 */   // Label 5706: @305605
     /*  305605 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(305668), // Rule ID 9809 //
     /*  305610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305649 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305666 */     GIR_RootConstrainSelectedInstOperands,
     /*  305667 */     // GIR_Coverage, 9809,
     /*  305667 */     GIR_EraseRootFromParent_Done,
     /*  305668 */   // Label 5707: @305668
     /*  305668 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(305731), // Rule ID 9812 //
     /*  305673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305729 */     GIR_RootConstrainSelectedInstOperands,
     /*  305730 */     // GIR_Coverage, 9812,
     /*  305730 */     GIR_EraseRootFromParent_Done,
     /*  305731 */   // Label 5708: @305731
     /*  305731 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(305794), // Rule ID 9813 //
     /*  305736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11505:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305792 */     GIR_RootConstrainSelectedInstOperands,
     /*  305793 */     // GIR_Coverage, 9813,
     /*  305793 */     GIR_EraseRootFromParent_Done,
     /*  305794 */   // Label 5709: @305794
     /*  305794 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(305857), // Rule ID 9816 //
     /*  305799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305855 */     GIR_RootConstrainSelectedInstOperands,
     /*  305856 */     // GIR_Coverage, 9816,
     /*  305856 */     GIR_EraseRootFromParent_Done,
     /*  305857 */   // Label 5710: @305857
     /*  305857 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(305920), // Rule ID 9817 //
     /*  305862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305901 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11505:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305918 */     GIR_RootConstrainSelectedInstOperands,
     /*  305919 */     // GIR_Coverage, 9817,
     /*  305919 */     GIR_EraseRootFromParent_Done,
     /*  305920 */   // Label 5711: @305920
     /*  305920 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(305983), // Rule ID 9820 //
     /*  305925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305981 */     GIR_RootConstrainSelectedInstOperands,
     /*  305982 */     // GIR_Coverage, 9820,
     /*  305982 */     GIR_EraseRootFromParent_Done,
     /*  305983 */   // Label 5712: @305983
     /*  305983 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(306046), // Rule ID 9821 //
     /*  305988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11505:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  306030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306044 */     GIR_RootConstrainSelectedInstOperands,
     /*  306045 */     // GIR_Coverage, 9821,
     /*  306045 */     GIR_EraseRootFromParent_Done,
     /*  306046 */   // Label 5713: @306046
     /*  306046 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(306109), // Rule ID 9824 //
     /*  306051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  306093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306107 */     GIR_RootConstrainSelectedInstOperands,
     /*  306108 */     // GIR_Coverage, 9824,
     /*  306108 */     GIR_EraseRootFromParent_Done,
     /*  306109 */   // Label 5714: @306109
     /*  306109 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(306172), // Rule ID 9825 //
     /*  306114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306153 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  306156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306170 */     GIR_RootConstrainSelectedInstOperands,
     /*  306171 */     // GIR_Coverage, 9825,
     /*  306171 */     GIR_EraseRootFromParent_Done,
     /*  306172 */   // Label 5715: @306172
     /*  306172 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(306235), // Rule ID 9828 //
     /*  306177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306233 */     GIR_RootConstrainSelectedInstOperands,
     /*  306234 */     // GIR_Coverage, 9828,
     /*  306234 */     GIR_EraseRootFromParent_Done,
     /*  306235 */   // Label 5716: @306235
     /*  306235 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(306298), // Rule ID 9829 //
     /*  306240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306296 */     GIR_RootConstrainSelectedInstOperands,
     /*  306297 */     // GIR_Coverage, 9829,
     /*  306297 */     GIR_EraseRootFromParent_Done,
     /*  306298 */   // Label 5717: @306298
     /*  306298 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(306361), // Rule ID 9832 //
     /*  306303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306359 */     GIR_RootConstrainSelectedInstOperands,
     /*  306360 */     // GIR_Coverage, 9832,
     /*  306360 */     GIR_EraseRootFromParent_Done,
     /*  306361 */   // Label 5718: @306361
     /*  306361 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(306424), // Rule ID 9833 //
     /*  306366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306405 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306422 */     GIR_RootConstrainSelectedInstOperands,
     /*  306423 */     // GIR_Coverage, 9833,
     /*  306423 */     GIR_EraseRootFromParent_Done,
     /*  306424 */   // Label 5719: @306424
     /*  306424 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(306487), // Rule ID 9836 //
     /*  306429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306485 */     GIR_RootConstrainSelectedInstOperands,
     /*  306486 */     // GIR_Coverage, 9836,
     /*  306486 */     GIR_EraseRootFromParent_Done,
     /*  306487 */   // Label 5720: @306487
     /*  306487 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(306550), // Rule ID 9837 //
     /*  306492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306548 */     GIR_RootConstrainSelectedInstOperands,
     /*  306549 */     // GIR_Coverage, 9837,
     /*  306549 */     GIR_EraseRootFromParent_Done,
     /*  306550 */   // Label 5721: @306550
     /*  306550 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(306613), // Rule ID 9840 //
     /*  306555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306611 */     GIR_RootConstrainSelectedInstOperands,
     /*  306612 */     // GIR_Coverage, 9840,
     /*  306612 */     GIR_EraseRootFromParent_Done,
     /*  306613 */   // Label 5722: @306613
     /*  306613 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(306676), // Rule ID 9841 //
     /*  306618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306674 */     GIR_RootConstrainSelectedInstOperands,
     /*  306675 */     // GIR_Coverage, 9841,
     /*  306675 */     GIR_EraseRootFromParent_Done,
     /*  306676 */   // Label 5723: @306676
     /*  306676 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(306739), // Rule ID 9844 //
     /*  306681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306737 */     GIR_RootConstrainSelectedInstOperands,
     /*  306738 */     // GIR_Coverage, 9844,
     /*  306738 */     GIR_EraseRootFromParent_Done,
     /*  306739 */   // Label 5724: @306739
     /*  306739 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(306802), // Rule ID 9845 //
     /*  306744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306783 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306800 */     GIR_RootConstrainSelectedInstOperands,
     /*  306801 */     // GIR_Coverage, 9845,
     /*  306801 */     GIR_EraseRootFromParent_Done,
     /*  306802 */   // Label 5725: @306802
     /*  306802 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(306865), // Rule ID 9848 //
     /*  306807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306846 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306863 */     GIR_RootConstrainSelectedInstOperands,
     /*  306864 */     // GIR_Coverage, 9848,
     /*  306864 */     GIR_EraseRootFromParent_Done,
     /*  306865 */   // Label 5726: @306865
     /*  306865 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(306928), // Rule ID 9849 //
     /*  306870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306926 */     GIR_RootConstrainSelectedInstOperands,
     /*  306927 */     // GIR_Coverage, 9849,
     /*  306927 */     GIR_EraseRootFromParent_Done,
     /*  306928 */   // Label 5727: @306928
     /*  306928 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(306991), // Rule ID 9852 //
     /*  306933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306989 */     GIR_RootConstrainSelectedInstOperands,
     /*  306990 */     // GIR_Coverage, 9852,
     /*  306990 */     GIR_EraseRootFromParent_Done,
     /*  306991 */   // Label 5728: @306991
     /*  306991 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(307054), // Rule ID 9853 //
     /*  306996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307052 */     GIR_RootConstrainSelectedInstOperands,
     /*  307053 */     // GIR_Coverage, 9853,
     /*  307053 */     GIR_EraseRootFromParent_Done,
     /*  307054 */   // Label 5729: @307054
     /*  307054 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(307117), // Rule ID 9856 //
     /*  307059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307115 */     GIR_RootConstrainSelectedInstOperands,
     /*  307116 */     // GIR_Coverage, 9856,
     /*  307116 */     GIR_EraseRootFromParent_Done,
     /*  307117 */   // Label 5730: @307117
     /*  307117 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(307180), // Rule ID 9857 //
     /*  307122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307161 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307178 */     GIR_RootConstrainSelectedInstOperands,
     /*  307179 */     // GIR_Coverage, 9857,
     /*  307179 */     GIR_EraseRootFromParent_Done,
     /*  307180 */   // Label 5731: @307180
     /*  307180 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(307243), // Rule ID 9860 //
     /*  307185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307241 */     GIR_RootConstrainSelectedInstOperands,
     /*  307242 */     // GIR_Coverage, 9860,
     /*  307242 */     GIR_EraseRootFromParent_Done,
     /*  307243 */   // Label 5732: @307243
     /*  307243 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(307306), // Rule ID 9861 //
     /*  307248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307287 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  307290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307304 */     GIR_RootConstrainSelectedInstOperands,
     /*  307305 */     // GIR_Coverage, 9861,
     /*  307305 */     GIR_EraseRootFromParent_Done,
     /*  307306 */   // Label 5733: @307306
     /*  307306 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(307369), // Rule ID 9864 //
     /*  307311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307367 */     GIR_RootConstrainSelectedInstOperands,
     /*  307368 */     // GIR_Coverage, 9864,
     /*  307368 */     GIR_EraseRootFromParent_Done,
     /*  307369 */   // Label 5734: @307369
     /*  307369 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(307432), // Rule ID 9865 //
     /*  307374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307413 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307430 */     GIR_RootConstrainSelectedInstOperands,
     /*  307431 */     // GIR_Coverage, 9865,
     /*  307431 */     GIR_EraseRootFromParent_Done,
     /*  307432 */   // Label 5735: @307432
     /*  307432 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(307495), // Rule ID 9868 //
     /*  307437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307493 */     GIR_RootConstrainSelectedInstOperands,
     /*  307494 */     // GIR_Coverage, 9868,
     /*  307494 */     GIR_EraseRootFromParent_Done,
     /*  307495 */   // Label 5736: @307495
     /*  307495 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(307558), // Rule ID 9869 //
     /*  307500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307539 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307556 */     GIR_RootConstrainSelectedInstOperands,
     /*  307557 */     // GIR_Coverage, 9869,
     /*  307557 */     GIR_EraseRootFromParent_Done,
     /*  307558 */   // Label 5737: @307558
     /*  307558 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(307621), // Rule ID 9872 //
     /*  307563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307602 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307619 */     GIR_RootConstrainSelectedInstOperands,
     /*  307620 */     // GIR_Coverage, 9872,
     /*  307620 */     GIR_EraseRootFromParent_Done,
     /*  307621 */   // Label 5738: @307621
     /*  307621 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(307684), // Rule ID 9873 //
     /*  307626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307665 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307682 */     GIR_RootConstrainSelectedInstOperands,
     /*  307683 */     // GIR_Coverage, 9873,
     /*  307683 */     GIR_EraseRootFromParent_Done,
     /*  307684 */   // Label 5739: @307684
     /*  307684 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(307747), // Rule ID 9876 //
     /*  307689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307745 */     GIR_RootConstrainSelectedInstOperands,
     /*  307746 */     // GIR_Coverage, 9876,
     /*  307746 */     GIR_EraseRootFromParent_Done,
     /*  307747 */   // Label 5740: @307747
     /*  307747 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(307810), // Rule ID 9877 //
     /*  307752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307808 */     GIR_RootConstrainSelectedInstOperands,
     /*  307809 */     // GIR_Coverage, 9877,
     /*  307809 */     GIR_EraseRootFromParent_Done,
     /*  307810 */   // Label 5741: @307810
     /*  307810 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(307873), // Rule ID 9880 //
     /*  307815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307871 */     GIR_RootConstrainSelectedInstOperands,
     /*  307872 */     // GIR_Coverage, 9880,
     /*  307872 */     GIR_EraseRootFromParent_Done,
     /*  307873 */   // Label 5742: @307873
     /*  307873 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(307936), // Rule ID 9881 //
     /*  307878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307934 */     GIR_RootConstrainSelectedInstOperands,
     /*  307935 */     // GIR_Coverage, 9881,
     /*  307935 */     GIR_EraseRootFromParent_Done,
     /*  307936 */   // Label 5743: @307936
     /*  307936 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(307999), // Rule ID 9884 //
     /*  307941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307980 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307997 */     GIR_RootConstrainSelectedInstOperands,
     /*  307998 */     // GIR_Coverage, 9884,
     /*  307998 */     GIR_EraseRootFromParent_Done,
     /*  307999 */   // Label 5744: @307999
     /*  307999 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(308062), // Rule ID 9885 //
     /*  308004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308043 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308060 */     GIR_RootConstrainSelectedInstOperands,
     /*  308061 */     // GIR_Coverage, 9885,
     /*  308061 */     GIR_EraseRootFromParent_Done,
     /*  308062 */   // Label 5745: @308062
     /*  308062 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(308125), // Rule ID 9888 //
     /*  308067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308123 */     GIR_RootConstrainSelectedInstOperands,
     /*  308124 */     // GIR_Coverage, 9888,
     /*  308124 */     GIR_EraseRootFromParent_Done,
     /*  308125 */   // Label 5746: @308125
     /*  308125 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(308188), // Rule ID 9889 //
     /*  308130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308186 */     GIR_RootConstrainSelectedInstOperands,
     /*  308187 */     // GIR_Coverage, 9889,
     /*  308187 */     GIR_EraseRootFromParent_Done,
     /*  308188 */   // Label 5747: @308188
     /*  308188 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(308251), // Rule ID 9892 //
     /*  308193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308249 */     GIR_RootConstrainSelectedInstOperands,
     /*  308250 */     // GIR_Coverage, 9892,
     /*  308250 */     GIR_EraseRootFromParent_Done,
     /*  308251 */   // Label 5748: @308251
     /*  308251 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(308314), // Rule ID 9893 //
     /*  308256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308295 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308312 */     GIR_RootConstrainSelectedInstOperands,
     /*  308313 */     // GIR_Coverage, 9893,
     /*  308313 */     GIR_EraseRootFromParent_Done,
     /*  308314 */   // Label 5749: @308314
     /*  308314 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(308377), // Rule ID 9896 //
     /*  308319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308375 */     GIR_RootConstrainSelectedInstOperands,
     /*  308376 */     // GIR_Coverage, 9896,
     /*  308376 */     GIR_EraseRootFromParent_Done,
     /*  308377 */   // Label 5750: @308377
     /*  308377 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(308440), // Rule ID 9897 //
     /*  308382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308438 */     GIR_RootConstrainSelectedInstOperands,
     /*  308439 */     // GIR_Coverage, 9897,
     /*  308439 */     GIR_EraseRootFromParent_Done,
     /*  308440 */   // Label 5751: @308440
     /*  308440 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(308503), // Rule ID 9900 //
     /*  308445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308501 */     GIR_RootConstrainSelectedInstOperands,
     /*  308502 */     // GIR_Coverage, 9900,
     /*  308502 */     GIR_EraseRootFromParent_Done,
     /*  308503 */   // Label 5752: @308503
     /*  308503 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(308566), // Rule ID 9901 //
     /*  308508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11503:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308564 */     GIR_RootConstrainSelectedInstOperands,
     /*  308565 */     // GIR_Coverage, 9901,
     /*  308565 */     GIR_EraseRootFromParent_Done,
     /*  308566 */   // Label 5753: @308566
     /*  308566 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(308629), // Rule ID 9904 //
     /*  308571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308627 */     GIR_RootConstrainSelectedInstOperands,
     /*  308628 */     // GIR_Coverage, 9904,
     /*  308628 */     GIR_EraseRootFromParent_Done,
     /*  308629 */   // Label 5754: @308629
     /*  308629 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(308692), // Rule ID 9905 //
     /*  308634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11503:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308690 */     GIR_RootConstrainSelectedInstOperands,
     /*  308691 */     // GIR_Coverage, 9905,
     /*  308691 */     GIR_EraseRootFromParent_Done,
     /*  308692 */   // Label 5755: @308692
     /*  308692 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(308755), // Rule ID 9908 //
     /*  308697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308753 */     GIR_RootConstrainSelectedInstOperands,
     /*  308754 */     // GIR_Coverage, 9908,
     /*  308754 */     GIR_EraseRootFromParent_Done,
     /*  308755 */   // Label 5756: @308755
     /*  308755 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(308818), // Rule ID 9909 //
     /*  308760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11503:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308816 */     GIR_RootConstrainSelectedInstOperands,
     /*  308817 */     // GIR_Coverage, 9909,
     /*  308817 */     GIR_EraseRootFromParent_Done,
     /*  308818 */   // Label 5757: @308818
     /*  308818 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(308884), // Rule ID 13984 //
     /*  308823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308862 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308882 */     GIR_RootConstrainSelectedInstOperands,
     /*  308883 */     // GIR_Coverage, 13984,
     /*  308883 */     GIR_EraseRootFromParent_Done,
     /*  308884 */   // Label 5758: @308884
     /*  308884 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(308950), // Rule ID 13985 //
     /*  308889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308948 */     GIR_RootConstrainSelectedInstOperands,
     /*  308949 */     // GIR_Coverage, 13985,
     /*  308949 */     GIR_EraseRootFromParent_Done,
     /*  308950 */   // Label 5759: @308950
     /*  308950 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(309016), // Rule ID 13986 //
     /*  308955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309014 */     GIR_RootConstrainSelectedInstOperands,
     /*  309015 */     // GIR_Coverage, 13986,
     /*  309015 */     GIR_EraseRootFromParent_Done,
     /*  309016 */   // Label 5760: @309016
     /*  309016 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(309082), // Rule ID 13987 //
     /*  309021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  309032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309080 */     GIR_RootConstrainSelectedInstOperands,
     /*  309081 */     // GIR_Coverage, 13987,
     /*  309081 */     GIR_EraseRootFromParent_Done,
     /*  309082 */   // Label 5761: @309082
     /*  309082 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(309148), // Rule ID 13988 //
     /*  309087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  309098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309126 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309146 */     GIR_RootConstrainSelectedInstOperands,
     /*  309147 */     // GIR_Coverage, 13988,
     /*  309147 */     GIR_EraseRootFromParent_Done,
     /*  309148 */   // Label 5762: @309148
     /*  309148 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(309214), // Rule ID 13989 //
     /*  309153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  309164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309212 */     GIR_RootConstrainSelectedInstOperands,
     /*  309213 */     // GIR_Coverage, 13989,
     /*  309213 */     GIR_EraseRootFromParent_Done,
     /*  309214 */   // Label 5763: @309214
     /*  309214 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(309280), // Rule ID 13990 //
     /*  309219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  309230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309278 */     GIR_RootConstrainSelectedInstOperands,
     /*  309279 */     // GIR_Coverage, 13990,
     /*  309279 */     GIR_EraseRootFromParent_Done,
     /*  309280 */   // Label 5764: @309280
     /*  309280 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(309346), // Rule ID 13991 //
     /*  309285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  309296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  309327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309344 */     GIR_RootConstrainSelectedInstOperands,
     /*  309345 */     // GIR_Coverage, 13991,
     /*  309345 */     GIR_EraseRootFromParent_Done,
     /*  309346 */   // Label 5765: @309346
     /*  309346 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(309412), // Rule ID 13992 //
     /*  309351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  309362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309410 */     GIR_RootConstrainSelectedInstOperands,
     /*  309411 */     // GIR_Coverage, 13992,
     /*  309411 */     GIR_EraseRootFromParent_Done,
     /*  309412 */   // Label 5766: @309412
     /*  309412 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(309478), // Rule ID 13993 //
     /*  309417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  309428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309476 */     GIR_RootConstrainSelectedInstOperands,
     /*  309477 */     // GIR_Coverage, 13993,
     /*  309477 */     GIR_EraseRootFromParent_Done,
     /*  309478 */   // Label 5767: @309478
     /*  309478 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(309544), // Rule ID 13994 //
     /*  309483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309542 */     GIR_RootConstrainSelectedInstOperands,
     /*  309543 */     // GIR_Coverage, 13994,
     /*  309543 */     GIR_EraseRootFromParent_Done,
     /*  309544 */   // Label 5768: @309544
     /*  309544 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(309610), // Rule ID 13995 //
     /*  309549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309608 */     GIR_RootConstrainSelectedInstOperands,
     /*  309609 */     // GIR_Coverage, 13995,
     /*  309609 */     GIR_EraseRootFromParent_Done,
     /*  309610 */   // Label 5769: @309610
     /*  309610 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(309676), // Rule ID 13996 //
     /*  309615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309674 */     GIR_RootConstrainSelectedInstOperands,
     /*  309675 */     // GIR_Coverage, 13996,
     /*  309675 */     GIR_EraseRootFromParent_Done,
     /*  309676 */   // Label 5770: @309676
     /*  309676 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(309742), // Rule ID 13997 //
     /*  309681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309740 */     GIR_RootConstrainSelectedInstOperands,
     /*  309741 */     // GIR_Coverage, 13997,
     /*  309741 */     GIR_EraseRootFromParent_Done,
     /*  309742 */   // Label 5771: @309742
     /*  309742 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(309808), // Rule ID 13998 //
     /*  309747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309806 */     GIR_RootConstrainSelectedInstOperands,
     /*  309807 */     // GIR_Coverage, 13998,
     /*  309807 */     GIR_EraseRootFromParent_Done,
     /*  309808 */   // Label 5772: @309808
     /*  309808 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(309874), // Rule ID 13999 //
     /*  309813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309872 */     GIR_RootConstrainSelectedInstOperands,
     /*  309873 */     // GIR_Coverage, 13999,
     /*  309873 */     GIR_EraseRootFromParent_Done,
     /*  309874 */   // Label 5773: @309874
     /*  309874 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(309940), // Rule ID 14000 //
     /*  309879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309938 */     GIR_RootConstrainSelectedInstOperands,
     /*  309939 */     // GIR_Coverage, 14000,
     /*  309939 */     GIR_EraseRootFromParent_Done,
     /*  309940 */   // Label 5774: @309940
     /*  309940 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(310006), // Rule ID 14001 //
     /*  309945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310004 */     GIR_RootConstrainSelectedInstOperands,
     /*  310005 */     // GIR_Coverage, 14001,
     /*  310005 */     GIR_EraseRootFromParent_Done,
     /*  310006 */   // Label 5775: @310006
     /*  310006 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(310072), // Rule ID 14002 //
     /*  310011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  310022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310050 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  310053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310070 */     GIR_RootConstrainSelectedInstOperands,
     /*  310071 */     // GIR_Coverage, 14002,
     /*  310071 */     GIR_EraseRootFromParent_Done,
     /*  310072 */   // Label 5776: @310072
     /*  310072 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(310138), // Rule ID 14003 //
     /*  310077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  310088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  310119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310136 */     GIR_RootConstrainSelectedInstOperands,
     /*  310137 */     // GIR_Coverage, 14003,
     /*  310137 */     GIR_EraseRootFromParent_Done,
     /*  310138 */   // Label 5777: @310138
     /*  310138 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(310204), // Rule ID 14004 //
     /*  310143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  310154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310202 */     GIR_RootConstrainSelectedInstOperands,
     /*  310203 */     // GIR_Coverage, 14004,
     /*  310203 */     GIR_EraseRootFromParent_Done,
     /*  310204 */   // Label 5778: @310204
     /*  310204 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(310270), // Rule ID 14005 //
     /*  310209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  310220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310268 */     GIR_RootConstrainSelectedInstOperands,
     /*  310269 */     // GIR_Coverage, 14005,
     /*  310269 */     GIR_EraseRootFromParent_Done,
     /*  310270 */   // Label 5779: @310270
     /*  310270 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(310336), // Rule ID 14006 //
     /*  310275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  310286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310334 */     GIR_RootConstrainSelectedInstOperands,
     /*  310335 */     // GIR_Coverage, 14006,
     /*  310335 */     GIR_EraseRootFromParent_Done,
     /*  310336 */   // Label 5780: @310336
     /*  310336 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(310402), // Rule ID 14007 //
     /*  310341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  310352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310400 */     GIR_RootConstrainSelectedInstOperands,
     /*  310401 */     // GIR_Coverage, 14007,
     /*  310401 */     GIR_EraseRootFromParent_Done,
     /*  310402 */   // Label 5781: @310402
     /*  310402 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(310468), // Rule ID 14008 //
     /*  310407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310446 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  310446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310466 */     GIR_RootConstrainSelectedInstOperands,
     /*  310467 */     // GIR_Coverage, 14008,
     /*  310467 */     GIR_EraseRootFromParent_Done,
     /*  310468 */   // Label 5782: @310468
     /*  310468 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(310534), // Rule ID 14009 //
     /*  310473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310512 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310532 */     GIR_RootConstrainSelectedInstOperands,
     /*  310533 */     // GIR_Coverage, 14009,
     /*  310533 */     GIR_EraseRootFromParent_Done,
     /*  310534 */   // Label 5783: @310534
     /*  310534 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(310600), // Rule ID 14010 //
     /*  310539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310598 */     GIR_RootConstrainSelectedInstOperands,
     /*  310599 */     // GIR_Coverage, 14010,
     /*  310599 */     GIR_EraseRootFromParent_Done,
     /*  310600 */   // Label 5784: @310600
     /*  310600 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(310666), // Rule ID 14011 //
     /*  310605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310664 */     GIR_RootConstrainSelectedInstOperands,
     /*  310665 */     // GIR_Coverage, 14011,
     /*  310665 */     GIR_EraseRootFromParent_Done,
     /*  310666 */   // Label 5785: @310666
     /*  310666 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(310732), // Rule ID 14012 //
     /*  310671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310730 */     GIR_RootConstrainSelectedInstOperands,
     /*  310731 */     // GIR_Coverage, 14012,
     /*  310731 */     GIR_EraseRootFromParent_Done,
     /*  310732 */   // Label 5786: @310732
     /*  310732 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(310798), // Rule ID 14013 //
     /*  310737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310796 */     GIR_RootConstrainSelectedInstOperands,
     /*  310797 */     // GIR_Coverage, 14013,
     /*  310797 */     GIR_EraseRootFromParent_Done,
     /*  310798 */   // Label 5787: @310798
     /*  310798 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(310864), // Rule ID 14014 //
     /*  310803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310862 */     GIR_RootConstrainSelectedInstOperands,
     /*  310863 */     // GIR_Coverage, 14014,
     /*  310863 */     GIR_EraseRootFromParent_Done,
     /*  310864 */   // Label 5788: @310864
     /*  310864 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(310930), // Rule ID 14015 //
     /*  310869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310928 */     GIR_RootConstrainSelectedInstOperands,
     /*  310929 */     // GIR_Coverage, 14015,
     /*  310929 */     GIR_EraseRootFromParent_Done,
     /*  310930 */   // Label 5789: @310930
     /*  310930 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(310996), // Rule ID 14016 //
     /*  310935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310994 */     GIR_RootConstrainSelectedInstOperands,
     /*  310995 */     // GIR_Coverage, 14016,
     /*  310995 */     GIR_EraseRootFromParent_Done,
     /*  310996 */   // Label 5790: @310996
     /*  310996 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(311062), // Rule ID 14017 //
     /*  311001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  311012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311060 */     GIR_RootConstrainSelectedInstOperands,
     /*  311061 */     // GIR_Coverage, 14017,
     /*  311061 */     GIR_EraseRootFromParent_Done,
     /*  311062 */   // Label 5791: @311062
     /*  311062 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(311128), // Rule ID 14018 //
     /*  311067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311126 */     GIR_RootConstrainSelectedInstOperands,
     /*  311127 */     // GIR_Coverage, 14018,
     /*  311127 */     GIR_EraseRootFromParent_Done,
     /*  311128 */   // Label 5792: @311128
     /*  311128 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(311194), // Rule ID 14019 //
     /*  311133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  311144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311192 */     GIR_RootConstrainSelectedInstOperands,
     /*  311193 */     // GIR_Coverage, 14019,
     /*  311193 */     GIR_EraseRootFromParent_Done,
     /*  311194 */   // Label 5793: @311194
     /*  311194 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(311260), // Rule ID 14020 //
     /*  311199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311258 */     GIR_RootConstrainSelectedInstOperands,
     /*  311259 */     // GIR_Coverage, 14020,
     /*  311259 */     GIR_EraseRootFromParent_Done,
     /*  311260 */   // Label 5794: @311260
     /*  311260 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(311326), // Rule ID 14021 //
     /*  311265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  311276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311324 */     GIR_RootConstrainSelectedInstOperands,
     /*  311325 */     // GIR_Coverage, 14021,
     /*  311325 */     GIR_EraseRootFromParent_Done,
     /*  311326 */   // Label 5795: @311326
     /*  311326 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(311392), // Rule ID 14022 //
     /*  311331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311390 */     GIR_RootConstrainSelectedInstOperands,
     /*  311391 */     // GIR_Coverage, 14022,
     /*  311391 */     GIR_EraseRootFromParent_Done,
     /*  311392 */   // Label 5796: @311392
     /*  311392 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(311458), // Rule ID 14023 //
     /*  311397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  311408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311456 */     GIR_RootConstrainSelectedInstOperands,
     /*  311457 */     // GIR_Coverage, 14023,
     /*  311457 */     GIR_EraseRootFromParent_Done,
     /*  311458 */   // Label 5797: @311458
     /*  311458 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(311524), // Rule ID 14024 //
     /*  311463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311522 */     GIR_RootConstrainSelectedInstOperands,
     /*  311523 */     // GIR_Coverage, 14024,
     /*  311523 */     GIR_EraseRootFromParent_Done,
     /*  311524 */   // Label 5798: @311524
     /*  311524 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(311590), // Rule ID 14025 //
     /*  311529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311588 */     GIR_RootConstrainSelectedInstOperands,
     /*  311589 */     // GIR_Coverage, 14025,
     /*  311589 */     GIR_EraseRootFromParent_Done,
     /*  311590 */   // Label 5799: @311590
     /*  311590 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(311656), // Rule ID 14026 //
     /*  311595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311654 */     GIR_RootConstrainSelectedInstOperands,
     /*  311655 */     // GIR_Coverage, 14026,
     /*  311655 */     GIR_EraseRootFromParent_Done,
     /*  311656 */   // Label 5800: @311656
     /*  311656 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(311722), // Rule ID 14027 //
     /*  311661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311720 */     GIR_RootConstrainSelectedInstOperands,
     /*  311721 */     // GIR_Coverage, 14027,
     /*  311721 */     GIR_EraseRootFromParent_Done,
     /*  311722 */   // Label 5801: @311722
     /*  311722 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(311788), // Rule ID 14028 //
     /*  311727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311766 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311786 */     GIR_RootConstrainSelectedInstOperands,
     /*  311787 */     // GIR_Coverage, 14028,
     /*  311787 */     GIR_EraseRootFromParent_Done,
     /*  311788 */   // Label 5802: @311788
     /*  311788 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(311854), // Rule ID 14029 //
     /*  311793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311832 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311852 */     GIR_RootConstrainSelectedInstOperands,
     /*  311853 */     // GIR_Coverage, 14029,
     /*  311853 */     GIR_EraseRootFromParent_Done,
     /*  311854 */   // Label 5803: @311854
     /*  311854 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(311920), // Rule ID 14030 //
     /*  311859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311898 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311918 */     GIR_RootConstrainSelectedInstOperands,
     /*  311919 */     // GIR_Coverage, 14030,
     /*  311919 */     GIR_EraseRootFromParent_Done,
     /*  311920 */   // Label 5804: @311920
     /*  311920 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(311986), // Rule ID 14031 //
     /*  311925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311964 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311984 */     GIR_RootConstrainSelectedInstOperands,
     /*  311985 */     // GIR_Coverage, 14031,
     /*  311985 */     GIR_EraseRootFromParent_Done,
     /*  311986 */   // Label 5805: @311986
     /*  311986 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(312052), // Rule ID 14032 //
     /*  311991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312030 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312050 */     GIR_RootConstrainSelectedInstOperands,
     /*  312051 */     // GIR_Coverage, 14032,
     /*  312051 */     GIR_EraseRootFromParent_Done,
     /*  312052 */   // Label 5806: @312052
     /*  312052 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(312118), // Rule ID 14033 //
     /*  312057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312096 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312116 */     GIR_RootConstrainSelectedInstOperands,
     /*  312117 */     // GIR_Coverage, 14033,
     /*  312117 */     GIR_EraseRootFromParent_Done,
     /*  312118 */   // Label 5807: @312118
     /*  312118 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(312184), // Rule ID 14034 //
     /*  312123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  312134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  312137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312162 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312182 */     GIR_RootConstrainSelectedInstOperands,
     /*  312183 */     // GIR_Coverage, 14034,
     /*  312183 */     GIR_EraseRootFromParent_Done,
     /*  312184 */   // Label 5808: @312184
     /*  312184 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(312250), // Rule ID 14035 //
     /*  312189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  312200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  312203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  312206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312228 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312248 */     GIR_RootConstrainSelectedInstOperands,
     /*  312249 */     // GIR_Coverage, 14035,
     /*  312249 */     GIR_EraseRootFromParent_Done,
     /*  312250 */   // Label 5809: @312250
     /*  312250 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(312316), // Rule ID 14036 //
     /*  312255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  312272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312314 */     GIR_RootConstrainSelectedInstOperands,
     /*  312315 */     // GIR_Coverage, 14036,
     /*  312315 */     GIR_EraseRootFromParent_Done,
     /*  312316 */   // Label 5810: @312316
     /*  312316 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(312382), // Rule ID 14037 //
     /*  312321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  312332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  312335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  312338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312360 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312380 */     GIR_RootConstrainSelectedInstOperands,
     /*  312381 */     // GIR_Coverage, 14037,
     /*  312381 */     GIR_EraseRootFromParent_Done,
     /*  312382 */   // Label 5811: @312382
     /*  312382 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(312448), // Rule ID 14038 //
     /*  312387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312426 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312446 */     GIR_RootConstrainSelectedInstOperands,
     /*  312447 */     // GIR_Coverage, 14038,
     /*  312447 */     GIR_EraseRootFromParent_Done,
     /*  312448 */   // Label 5812: @312448
     /*  312448 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(312514), // Rule ID 14039 //
     /*  312453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  312464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312492 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312512 */     GIR_RootConstrainSelectedInstOperands,
     /*  312513 */     // GIR_Coverage, 14039,
     /*  312513 */     GIR_EraseRootFromParent_Done,
     /*  312514 */   // Label 5813: @312514
     /*  312514 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(312580), // Rule ID 14040 //
     /*  312519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312558 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312578 */     GIR_RootConstrainSelectedInstOperands,
     /*  312579 */     // GIR_Coverage, 14040,
     /*  312579 */     GIR_EraseRootFromParent_Done,
     /*  312580 */   // Label 5814: @312580
     /*  312580 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(312646), // Rule ID 14041 //
     /*  312585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312624 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312644 */     GIR_RootConstrainSelectedInstOperands,
     /*  312645 */     // GIR_Coverage, 14041,
     /*  312645 */     GIR_EraseRootFromParent_Done,
     /*  312646 */   // Label 5815: @312646
     /*  312646 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(312712), // Rule ID 14042 //
     /*  312651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312690 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312710 */     GIR_RootConstrainSelectedInstOperands,
     /*  312711 */     // GIR_Coverage, 14042,
     /*  312711 */     GIR_EraseRootFromParent_Done,
     /*  312712 */   // Label 5816: @312712
     /*  312712 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(312778), // Rule ID 14043 //
     /*  312717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312756 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312776 */     GIR_RootConstrainSelectedInstOperands,
     /*  312777 */     // GIR_Coverage, 14043,
     /*  312777 */     GIR_EraseRootFromParent_Done,
     /*  312778 */   // Label 5817: @312778
     /*  312778 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(312844), // Rule ID 14044 //
     /*  312783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312842 */     GIR_RootConstrainSelectedInstOperands,
     /*  312843 */     // GIR_Coverage, 14044,
     /*  312843 */     GIR_EraseRootFromParent_Done,
     /*  312844 */   // Label 5818: @312844
     /*  312844 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(312910), // Rule ID 14045 //
     /*  312849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312888 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312908 */     GIR_RootConstrainSelectedInstOperands,
     /*  312909 */     // GIR_Coverage, 14045,
     /*  312909 */     GIR_EraseRootFromParent_Done,
     /*  312910 */   // Label 5819: @312910
     /*  312910 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(312976), // Rule ID 14046 //
     /*  312915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312974 */     GIR_RootConstrainSelectedInstOperands,
     /*  312975 */     // GIR_Coverage, 14046,
     /*  312975 */     GIR_EraseRootFromParent_Done,
     /*  312976 */   // Label 5820: @312976
     /*  312976 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(313042), // Rule ID 14047 //
     /*  312981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313040 */     GIR_RootConstrainSelectedInstOperands,
     /*  313041 */     // GIR_Coverage, 14047,
     /*  313041 */     GIR_EraseRootFromParent_Done,
     /*  313042 */   // Label 5821: @313042
     /*  313042 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(313108), // Rule ID 14048 //
     /*  313047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  313061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313086 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313106 */     GIR_RootConstrainSelectedInstOperands,
     /*  313107 */     // GIR_Coverage, 14048,
     /*  313107 */     GIR_EraseRootFromParent_Done,
     /*  313108 */   // Label 5822: @313108
     /*  313108 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(313174), // Rule ID 14049 //
     /*  313113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  313127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313172 */     GIR_RootConstrainSelectedInstOperands,
     /*  313173 */     // GIR_Coverage, 14049,
     /*  313173 */     GIR_EraseRootFromParent_Done,
     /*  313174 */   // Label 5823: @313174
     /*  313174 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(313240), // Rule ID 14050 //
     /*  313179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  313190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  313193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  313196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313218 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313238 */     GIR_RootConstrainSelectedInstOperands,
     /*  313239 */     // GIR_Coverage, 14050,
     /*  313239 */     GIR_EraseRootFromParent_Done,
     /*  313240 */   // Label 5824: @313240
     /*  313240 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(313306), // Rule ID 14051 //
     /*  313245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  313256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  313259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  313262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313284 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313304 */     GIR_RootConstrainSelectedInstOperands,
     /*  313305 */     // GIR_Coverage, 14051,
     /*  313305 */     GIR_EraseRootFromParent_Done,
     /*  313306 */   // Label 5825: @313306
     /*  313306 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(313372), // Rule ID 14052 //
     /*  313311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  313328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313370 */     GIR_RootConstrainSelectedInstOperands,
     /*  313371 */     // GIR_Coverage, 14052,
     /*  313371 */     GIR_EraseRootFromParent_Done,
     /*  313372 */   // Label 5826: @313372
     /*  313372 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(313438), // Rule ID 14053 //
     /*  313377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  313388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  313391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  313394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313416 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313436 */     GIR_RootConstrainSelectedInstOperands,
     /*  313437 */     // GIR_Coverage, 14053,
     /*  313437 */     GIR_EraseRootFromParent_Done,
     /*  313438 */   // Label 5827: @313438
     /*  313438 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(313504), // Rule ID 14054 //
     /*  313443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313502 */     GIR_RootConstrainSelectedInstOperands,
     /*  313503 */     // GIR_Coverage, 14054,
     /*  313503 */     GIR_EraseRootFromParent_Done,
     /*  313504 */   // Label 5828: @313504
     /*  313504 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(313570), // Rule ID 14055 //
     /*  313509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313548 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313568 */     GIR_RootConstrainSelectedInstOperands,
     /*  313569 */     // GIR_Coverage, 14055,
     /*  313569 */     GIR_EraseRootFromParent_Done,
     /*  313570 */   // Label 5829: @313570
     /*  313570 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(313636), // Rule ID 14056 //
     /*  313575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313634 */     GIR_RootConstrainSelectedInstOperands,
     /*  313635 */     // GIR_Coverage, 14056,
     /*  313635 */     GIR_EraseRootFromParent_Done,
     /*  313636 */   // Label 5830: @313636
     /*  313636 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(313702), // Rule ID 14057 //
     /*  313641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313680 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313700 */     GIR_RootConstrainSelectedInstOperands,
     /*  313701 */     // GIR_Coverage, 14057,
     /*  313701 */     GIR_EraseRootFromParent_Done,
     /*  313702 */   // Label 5831: @313702
     /*  313702 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(313768), // Rule ID 19060 //
     /*  313707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313766 */     GIR_RootConstrainSelectedInstOperands,
     /*  313767 */     // GIR_Coverage, 19060,
     /*  313767 */     GIR_EraseRootFromParent_Done,
     /*  313768 */   // Label 5832: @313768
     /*  313768 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(313834), // Rule ID 19061 //
     /*  313773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313812 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313832 */     GIR_RootConstrainSelectedInstOperands,
     /*  313833 */     // GIR_Coverage, 19061,
     /*  313833 */     GIR_EraseRootFromParent_Done,
     /*  313834 */   // Label 5833: @313834
     /*  313834 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(313900), // Rule ID 19064 //
     /*  313839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313878 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313898 */     GIR_RootConstrainSelectedInstOperands,
     /*  313899 */     // GIR_Coverage, 19064,
     /*  313899 */     GIR_EraseRootFromParent_Done,
     /*  313900 */   // Label 5834: @313900
     /*  313900 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(313966), // Rule ID 19065 //
     /*  313905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313944 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313964 */     GIR_RootConstrainSelectedInstOperands,
     /*  313965 */     // GIR_Coverage, 19065,
     /*  313965 */     GIR_EraseRootFromParent_Done,
     /*  313966 */   // Label 5835: @313966
     /*  313966 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(314032), // Rule ID 19068 //
     /*  313971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314010 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  314013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314030 */     GIR_RootConstrainSelectedInstOperands,
     /*  314031 */     // GIR_Coverage, 19068,
     /*  314031 */     GIR_EraseRootFromParent_Done,
     /*  314032 */   // Label 5836: @314032
     /*  314032 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(314098), // Rule ID 19069 //
     /*  314037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  314048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  314051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  314054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11317:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  314079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314096 */     GIR_RootConstrainSelectedInstOperands,
     /*  314097 */     // GIR_Coverage, 19069,
     /*  314097 */     GIR_EraseRootFromParent_Done,
     /*  314098 */   // Label 5837: @314098
     /*  314098 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(314164), // Rule ID 19072 //
     /*  314103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  314114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  314117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  314145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314162 */     GIR_RootConstrainSelectedInstOperands,
     /*  314163 */     // GIR_Coverage, 19072,
     /*  314163 */     GIR_EraseRootFromParent_Done,
     /*  314164 */   // Label 5838: @314164
     /*  314164 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(314230), // Rule ID 19073 //
     /*  314169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  314180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  314183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  314186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314208 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  314211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314228 */     GIR_RootConstrainSelectedInstOperands,
     /*  314229 */     // GIR_Coverage, 19073,
     /*  314229 */     GIR_EraseRootFromParent_Done,
     /*  314230 */   // Label 5839: @314230
     /*  314230 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(314296), // Rule ID 19076 //
     /*  314235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  314246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  314249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  314252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  314277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314294 */     GIR_RootConstrainSelectedInstOperands,
     /*  314295 */     // GIR_Coverage, 19076,
     /*  314295 */     GIR_EraseRootFromParent_Done,
     /*  314296 */   // Label 5840: @314296
     /*  314296 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(314362), // Rule ID 19077 //
     /*  314301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  314312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  314315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  314318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314340 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  314343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314360 */     GIR_RootConstrainSelectedInstOperands,
     /*  314361 */     // GIR_Coverage, 19077,
     /*  314361 */     GIR_EraseRootFromParent_Done,
     /*  314362 */   // Label 5841: @314362
     /*  314362 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(314428), // Rule ID 19080 //
     /*  314367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314426 */     GIR_RootConstrainSelectedInstOperands,
     /*  314427 */     // GIR_Coverage, 19080,
     /*  314427 */     GIR_EraseRootFromParent_Done,
     /*  314428 */   // Label 5842: @314428
     /*  314428 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(314494), // Rule ID 19081 //
     /*  314433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  314444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  314447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314472 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314492 */     GIR_RootConstrainSelectedInstOperands,
     /*  314493 */     // GIR_Coverage, 19081,
     /*  314493 */     GIR_EraseRootFromParent_Done,
     /*  314494 */   // Label 5843: @314494
     /*  314494 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(314560), // Rule ID 19084 //
     /*  314499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314558 */     GIR_RootConstrainSelectedInstOperands,
     /*  314559 */     // GIR_Coverage, 19084,
     /*  314559 */     GIR_EraseRootFromParent_Done,
     /*  314560 */   // Label 5844: @314560
     /*  314560 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(314626), // Rule ID 19085 //
     /*  314565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314624 */     GIR_RootConstrainSelectedInstOperands,
     /*  314625 */     // GIR_Coverage, 19085,
     /*  314625 */     GIR_EraseRootFromParent_Done,
     /*  314626 */   // Label 5845: @314626
     /*  314626 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(314692), // Rule ID 19088 //
     /*  314631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314670 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314690 */     GIR_RootConstrainSelectedInstOperands,
     /*  314691 */     // GIR_Coverage, 19088,
     /*  314691 */     GIR_EraseRootFromParent_Done,
     /*  314692 */   // Label 5846: @314692
     /*  314692 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(314758), // Rule ID 19089 //
     /*  314697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314736 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314756 */     GIR_RootConstrainSelectedInstOperands,
     /*  314757 */     // GIR_Coverage, 19089,
     /*  314757 */     GIR_EraseRootFromParent_Done,
     /*  314758 */   // Label 5847: @314758
     /*  314758 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(314824), // Rule ID 19092 //
     /*  314763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314802 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314822 */     GIR_RootConstrainSelectedInstOperands,
     /*  314823 */     // GIR_Coverage, 19092,
     /*  314823 */     GIR_EraseRootFromParent_Done,
     /*  314824 */   // Label 5848: @314824
     /*  314824 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(314890), // Rule ID 19093 //
     /*  314829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314888 */     GIR_RootConstrainSelectedInstOperands,
     /*  314889 */     // GIR_Coverage, 19093,
     /*  314889 */     GIR_EraseRootFromParent_Done,
     /*  314890 */   // Label 5849: @314890
     /*  314890 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(314956), // Rule ID 19096 //
     /*  314895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314954 */     GIR_RootConstrainSelectedInstOperands,
     /*  314955 */     // GIR_Coverage, 19096,
     /*  314955 */     GIR_EraseRootFromParent_Done,
     /*  314956 */   // Label 5850: @314956
     /*  314956 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(315022), // Rule ID 19097 //
     /*  314961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315000 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  315003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315020 */     GIR_RootConstrainSelectedInstOperands,
     /*  315021 */     // GIR_Coverage, 19097,
     /*  315021 */     GIR_EraseRootFromParent_Done,
     /*  315022 */   // Label 5851: @315022
     /*  315022 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(315088), // Rule ID 19100 //
     /*  315027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  315038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  315041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315066 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  315069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315086 */     GIR_RootConstrainSelectedInstOperands,
     /*  315087 */     // GIR_Coverage, 19100,
     /*  315087 */     GIR_EraseRootFromParent_Done,
     /*  315088 */   // Label 5852: @315088
     /*  315088 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(315154), // Rule ID 19101 //
     /*  315093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  315104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  315107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315132 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  315135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315152 */     GIR_RootConstrainSelectedInstOperands,
     /*  315153 */     // GIR_Coverage, 19101,
     /*  315153 */     GIR_EraseRootFromParent_Done,
     /*  315154 */   // Label 5853: @315154
     /*  315154 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(315220), // Rule ID 19104 //
     /*  315159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  315170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  315173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315198 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  315201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315218 */     GIR_RootConstrainSelectedInstOperands,
     /*  315219 */     // GIR_Coverage, 19104,
     /*  315219 */     GIR_EraseRootFromParent_Done,
     /*  315220 */   // Label 5854: @315220
     /*  315220 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(315286), // Rule ID 19105 //
     /*  315225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  315236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  315239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  315242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  315267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315284 */     GIR_RootConstrainSelectedInstOperands,
     /*  315285 */     // GIR_Coverage, 19105,
     /*  315285 */     GIR_EraseRootFromParent_Done,
     /*  315286 */   // Label 5855: @315286
     /*  315286 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(315352), // Rule ID 19108 //
     /*  315291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  315302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  315305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  315333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315350 */     GIR_RootConstrainSelectedInstOperands,
     /*  315351 */     // GIR_Coverage, 19108,
     /*  315351 */     GIR_EraseRootFromParent_Done,
     /*  315352 */   // Label 5856: @315352
     /*  315352 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(315418), // Rule ID 19109 //
     /*  315357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  315368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  315371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  315374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315396 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  315399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315416 */     GIR_RootConstrainSelectedInstOperands,
     /*  315417 */     // GIR_Coverage, 19109,
     /*  315417 */     GIR_EraseRootFromParent_Done,
     /*  315418 */   // Label 5857: @315418
     /*  315418 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(315484), // Rule ID 19112 //
     /*  315423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315482 */     GIR_RootConstrainSelectedInstOperands,
     /*  315483 */     // GIR_Coverage, 19112,
     /*  315483 */     GIR_EraseRootFromParent_Done,
     /*  315484 */   // Label 5858: @315484
     /*  315484 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(315550), // Rule ID 19113 //
     /*  315489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315528 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315548 */     GIR_RootConstrainSelectedInstOperands,
     /*  315549 */     // GIR_Coverage, 19113,
     /*  315549 */     GIR_EraseRootFromParent_Done,
     /*  315550 */   // Label 5859: @315550
     /*  315550 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(315613), // Rule ID 19776 //
     /*  315555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315611 */     GIR_RootConstrainSelectedInstOperands,
     /*  315612 */     // GIR_Coverage, 19776,
     /*  315612 */     GIR_EraseRootFromParent_Done,
     /*  315613 */   // Label 5860: @315613
     /*  315613 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(315676), // Rule ID 19777 //
     /*  315618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315657 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315674 */     GIR_RootConstrainSelectedInstOperands,
     /*  315675 */     // GIR_Coverage, 19777,
     /*  315675 */     GIR_EraseRootFromParent_Done,
     /*  315676 */   // Label 5861: @315676
     /*  315676 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(315739), // Rule ID 19780 //
     /*  315681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315737 */     GIR_RootConstrainSelectedInstOperands,
     /*  315738 */     // GIR_Coverage, 19780,
     /*  315738 */     GIR_EraseRootFromParent_Done,
     /*  315739 */   // Label 5862: @315739
     /*  315739 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(315802), // Rule ID 19781 //
     /*  315744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315783 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315800 */     GIR_RootConstrainSelectedInstOperands,
     /*  315801 */     // GIR_Coverage, 19781,
     /*  315801 */     GIR_EraseRootFromParent_Done,
     /*  315802 */   // Label 5863: @315802
     /*  315802 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(315865), // Rule ID 19784 //
     /*  315807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315863 */     GIR_RootConstrainSelectedInstOperands,
     /*  315864 */     // GIR_Coverage, 19784,
     /*  315864 */     GIR_EraseRootFromParent_Done,
     /*  315865 */   // Label 5864: @315865
     /*  315865 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(315928), // Rule ID 19785 //
     /*  315870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315909 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315926 */     GIR_RootConstrainSelectedInstOperands,
     /*  315927 */     // GIR_Coverage, 19785,
     /*  315927 */     GIR_EraseRootFromParent_Done,
     /*  315928 */   // Label 5865: @315928
     /*  315928 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(315991), // Rule ID 19788 //
     /*  315933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315989 */     GIR_RootConstrainSelectedInstOperands,
     /*  315990 */     // GIR_Coverage, 19788,
     /*  315990 */     GIR_EraseRootFromParent_Done,
     /*  315991 */   // Label 5866: @315991
     /*  315991 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(316054), // Rule ID 19789 //
     /*  315996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  316010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  316013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316052 */     GIR_RootConstrainSelectedInstOperands,
     /*  316053 */     // GIR_Coverage, 19789,
     /*  316053 */     GIR_EraseRootFromParent_Done,
     /*  316054 */   // Label 5867: @316054
     /*  316054 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(316117), // Rule ID 19792 //
     /*  316059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  316073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316115 */     GIR_RootConstrainSelectedInstOperands,
     /*  316116 */     // GIR_Coverage, 19792,
     /*  316116 */     GIR_EraseRootFromParent_Done,
     /*  316117 */   // Label 5868: @316117
     /*  316117 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(316180), // Rule ID 19793 //
     /*  316122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  316136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  316139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316161 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316178 */     GIR_RootConstrainSelectedInstOperands,
     /*  316179 */     // GIR_Coverage, 19793,
     /*  316179 */     GIR_EraseRootFromParent_Done,
     /*  316180 */   // Label 5869: @316180
     /*  316180 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(316243), // Rule ID 19796 //
     /*  316185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  316199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  316202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316241 */     GIR_RootConstrainSelectedInstOperands,
     /*  316242 */     // GIR_Coverage, 19796,
     /*  316242 */     GIR_EraseRootFromParent_Done,
     /*  316243 */   // Label 5870: @316243
     /*  316243 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(316306), // Rule ID 19797 //
     /*  316248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  316262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  316265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316287 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  316290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316304 */     GIR_RootConstrainSelectedInstOperands,
     /*  316305 */     // GIR_Coverage, 19797,
     /*  316305 */     GIR_EraseRootFromParent_Done,
     /*  316306 */   // Label 5871: @316306
     /*  316306 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(316369), // Rule ID 19800 //
     /*  316311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  316325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316367 */     GIR_RootConstrainSelectedInstOperands,
     /*  316368 */     // GIR_Coverage, 19800,
     /*  316368 */     GIR_EraseRootFromParent_Done,
     /*  316369 */   // Label 5872: @316369
     /*  316369 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(316432), // Rule ID 19801 //
     /*  316374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  316388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  316391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316413 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316430 */     GIR_RootConstrainSelectedInstOperands,
     /*  316431 */     // GIR_Coverage, 19801,
     /*  316431 */     GIR_EraseRootFromParent_Done,
     /*  316432 */   // Label 5873: @316432
     /*  316432 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(316495), // Rule ID 19804 //
     /*  316437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316493 */     GIR_RootConstrainSelectedInstOperands,
     /*  316494 */     // GIR_Coverage, 19804,
     /*  316494 */     GIR_EraseRootFromParent_Done,
     /*  316495 */   // Label 5874: @316495
     /*  316495 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(316558), // Rule ID 19805 //
     /*  316500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316556 */     GIR_RootConstrainSelectedInstOperands,
     /*  316557 */     // GIR_Coverage, 19805,
     /*  316557 */     GIR_EraseRootFromParent_Done,
     /*  316558 */   // Label 5875: @316558
     /*  316558 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(316621), // Rule ID 19808 //
     /*  316563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316602 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316619 */     GIR_RootConstrainSelectedInstOperands,
     /*  316620 */     // GIR_Coverage, 19808,
     /*  316620 */     GIR_EraseRootFromParent_Done,
     /*  316621 */   // Label 5876: @316621
     /*  316621 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(316684), // Rule ID 19809 //
     /*  316626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316665 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316682 */     GIR_RootConstrainSelectedInstOperands,
     /*  316683 */     // GIR_Coverage, 19809,
     /*  316683 */     GIR_EraseRootFromParent_Done,
     /*  316684 */   // Label 5877: @316684
     /*  316684 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(316747), // Rule ID 19812 //
     /*  316689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316745 */     GIR_RootConstrainSelectedInstOperands,
     /*  316746 */     // GIR_Coverage, 19812,
     /*  316746 */     GIR_EraseRootFromParent_Done,
     /*  316747 */   // Label 5878: @316747
     /*  316747 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(316810), // Rule ID 19813 //
     /*  316752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316791 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316808 */     GIR_RootConstrainSelectedInstOperands,
     /*  316809 */     // GIR_Coverage, 19813,
     /*  316809 */     GIR_EraseRootFromParent_Done,
     /*  316810 */   // Label 5879: @316810
     /*  316810 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(316873), // Rule ID 19816 //
     /*  316815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316871 */     GIR_RootConstrainSelectedInstOperands,
     /*  316872 */     // GIR_Coverage, 19816,
     /*  316872 */     GIR_EraseRootFromParent_Done,
     /*  316873 */   // Label 5880: @316873
     /*  316873 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(316936), // Rule ID 19817 //
     /*  316878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316934 */     GIR_RootConstrainSelectedInstOperands,
     /*  316935 */     // GIR_Coverage, 19817,
     /*  316935 */     GIR_EraseRootFromParent_Done,
     /*  316936 */   // Label 5881: @316936
     /*  316936 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(316999), // Rule ID 19820 //
     /*  316941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316997 */     GIR_RootConstrainSelectedInstOperands,
     /*  316998 */     // GIR_Coverage, 19820,
     /*  316998 */     GIR_EraseRootFromParent_Done,
     /*  316999 */   // Label 5882: @316999
     /*  316999 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(317062), // Rule ID 19821 //
     /*  317004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  317018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  317021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317060 */     GIR_RootConstrainSelectedInstOperands,
     /*  317061 */     // GIR_Coverage, 19821,
     /*  317061 */     GIR_EraseRootFromParent_Done,
     /*  317062 */   // Label 5883: @317062
     /*  317062 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(317125), // Rule ID 19824 //
     /*  317067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  317081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  317109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317123 */     GIR_RootConstrainSelectedInstOperands,
     /*  317124 */     // GIR_Coverage, 19824,
     /*  317124 */     GIR_EraseRootFromParent_Done,
     /*  317125 */   // Label 5884: @317125
     /*  317125 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(317188), // Rule ID 19825 //
     /*  317130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  317144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  317147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  317172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317186 */     GIR_RootConstrainSelectedInstOperands,
     /*  317187 */     // GIR_Coverage, 19825,
     /*  317187 */     GIR_EraseRootFromParent_Done,
     /*  317188 */   // Label 5885: @317188
     /*  317188 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(317251), // Rule ID 19828 //
     /*  317193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  317207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  317235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317249 */     GIR_RootConstrainSelectedInstOperands,
     /*  317250 */     // GIR_Coverage, 19828,
     /*  317250 */     GIR_EraseRootFromParent_Done,
     /*  317251 */   // Label 5886: @317251
     /*  317251 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(317314), // Rule ID 19829 //
     /*  317256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  317270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  317273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  317298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317312 */     GIR_RootConstrainSelectedInstOperands,
     /*  317313 */     // GIR_Coverage, 19829,
     /*  317313 */     GIR_EraseRootFromParent_Done,
     /*  317314 */   // Label 5887: @317314
     /*  317314 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(317377), // Rule ID 19832 //
     /*  317319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317375 */     GIR_RootConstrainSelectedInstOperands,
     /*  317376 */     // GIR_Coverage, 19832,
     /*  317376 */     GIR_EraseRootFromParent_Done,
     /*  317377 */   // Label 5888: @317377
     /*  317377 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(317440), // Rule ID 19833 //
     /*  317382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317421 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  317424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317438 */     GIR_RootConstrainSelectedInstOperands,
     /*  317439 */     // GIR_Coverage, 19833,
     /*  317439 */     GIR_EraseRootFromParent_Done,
     /*  317440 */   // Label 5889: @317440
     /*  317440 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(317503), // Rule ID 19836 //
     /*  317445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317484 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317501 */     GIR_RootConstrainSelectedInstOperands,
     /*  317502 */     // GIR_Coverage, 19836,
     /*  317502 */     GIR_EraseRootFromParent_Done,
     /*  317503 */   // Label 5890: @317503
     /*  317503 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(317566), // Rule ID 19837 //
     /*  317508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317547 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317564 */     GIR_RootConstrainSelectedInstOperands,
     /*  317565 */     // GIR_Coverage, 19837,
     /*  317565 */     GIR_EraseRootFromParent_Done,
     /*  317566 */   // Label 5891: @317566
     /*  317566 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(317629), // Rule ID 19840 //
     /*  317571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317627 */     GIR_RootConstrainSelectedInstOperands,
     /*  317628 */     // GIR_Coverage, 19840,
     /*  317628 */     GIR_EraseRootFromParent_Done,
     /*  317629 */   // Label 5892: @317629
     /*  317629 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(317692), // Rule ID 19841 //
     /*  317634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317673 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317690 */     GIR_RootConstrainSelectedInstOperands,
     /*  317691 */     // GIR_Coverage, 19841,
     /*  317691 */     GIR_EraseRootFromParent_Done,
     /*  317692 */   // Label 5893: @317692
     /*  317692 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(317755), // Rule ID 19844 //
     /*  317697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317753 */     GIR_RootConstrainSelectedInstOperands,
     /*  317754 */     // GIR_Coverage, 19844,
     /*  317754 */     GIR_EraseRootFromParent_Done,
     /*  317755 */   // Label 5894: @317755
     /*  317755 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(317818), // Rule ID 19845 //
     /*  317760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317799 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317816 */     GIR_RootConstrainSelectedInstOperands,
     /*  317817 */     // GIR_Coverage, 19845,
     /*  317817 */     GIR_EraseRootFromParent_Done,
     /*  317818 */   // Label 5895: @317818
     /*  317818 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(317881), // Rule ID 19848 //
     /*  317823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317879 */     GIR_RootConstrainSelectedInstOperands,
     /*  317880 */     // GIR_Coverage, 19848,
     /*  317880 */     GIR_EraseRootFromParent_Done,
     /*  317881 */   // Label 5896: @317881
     /*  317881 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(317944), // Rule ID 19849 //
     /*  317886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317925 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317942 */     GIR_RootConstrainSelectedInstOperands,
     /*  317943 */     // GIR_Coverage, 19849,
     /*  317943 */     GIR_EraseRootFromParent_Done,
     /*  317944 */   // Label 5897: @317944
     /*  317944 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(318007), // Rule ID 19852 //
     /*  317949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318005 */     GIR_RootConstrainSelectedInstOperands,
     /*  318006 */     // GIR_Coverage, 19852,
     /*  318006 */     GIR_EraseRootFromParent_Done,
     /*  318007 */   // Label 5898: @318007
     /*  318007 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(318070), // Rule ID 19853 //
     /*  318012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  318026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  318054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318068 */     GIR_RootConstrainSelectedInstOperands,
     /*  318069 */     // GIR_Coverage, 19853,
     /*  318069 */     GIR_EraseRootFromParent_Done,
     /*  318070 */   // Label 5899: @318070
     /*  318070 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(318133), // Rule ID 19856 //
     /*  318075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  318089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  318117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318131 */     GIR_RootConstrainSelectedInstOperands,
     /*  318132 */     // GIR_Coverage, 19856,
     /*  318132 */     GIR_EraseRootFromParent_Done,
     /*  318133 */   // Label 5900: @318133
     /*  318133 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(318196), // Rule ID 19857 //
     /*  318138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  318152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  318180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318194 */     GIR_RootConstrainSelectedInstOperands,
     /*  318195 */     // GIR_Coverage, 19857,
     /*  318195 */     GIR_EraseRootFromParent_Done,
     /*  318196 */   // Label 5901: @318196
     /*  318196 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(318259), // Rule ID 19860 //
     /*  318201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  318215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  318243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318257 */     GIR_RootConstrainSelectedInstOperands,
     /*  318258 */     // GIR_Coverage, 19860,
     /*  318258 */     GIR_EraseRootFromParent_Done,
     /*  318259 */   // Label 5902: @318259
     /*  318259 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(318322), // Rule ID 19861 //
     /*  318264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  318278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318303 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  318306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318320 */     GIR_RootConstrainSelectedInstOperands,
     /*  318321 */     // GIR_Coverage, 19861,
     /*  318321 */     GIR_EraseRootFromParent_Done,
     /*  318322 */   // Label 5903: @318322
     /*  318322 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(318385), // Rule ID 19864 //
     /*  318327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  318341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  318369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318383 */     GIR_RootConstrainSelectedInstOperands,
     /*  318384 */     // GIR_Coverage, 19864,
     /*  318384 */     GIR_EraseRootFromParent_Done,
     /*  318385 */   // Label 5904: @318385
     /*  318385 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(318448), // Rule ID 19865 //
     /*  318390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  318404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318429 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  318432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318446 */     GIR_RootConstrainSelectedInstOperands,
     /*  318447 */     // GIR_Coverage, 19865,
     /*  318447 */     GIR_EraseRootFromParent_Done,
     /*  318448 */   // Label 5905: @318448
     /*  318448 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(318511), // Rule ID 19868 //
     /*  318453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318509 */     GIR_RootConstrainSelectedInstOperands,
     /*  318510 */     // GIR_Coverage, 19868,
     /*  318510 */     GIR_EraseRootFromParent_Done,
     /*  318511 */   // Label 5906: @318511
     /*  318511 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(318574), // Rule ID 19869 //
     /*  318516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318555 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318572 */     GIR_RootConstrainSelectedInstOperands,
     /*  318573 */     // GIR_Coverage, 19869,
     /*  318573 */     GIR_EraseRootFromParent_Done,
     /*  318574 */   // Label 5907: @318574
     /*  318574 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(318637), // Rule ID 19872 //
     /*  318579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318635 */     GIR_RootConstrainSelectedInstOperands,
     /*  318636 */     // GIR_Coverage, 19872,
     /*  318636 */     GIR_EraseRootFromParent_Done,
     /*  318637 */   // Label 5908: @318637
     /*  318637 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(318700), // Rule ID 19873 //
     /*  318642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318681 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318698 */     GIR_RootConstrainSelectedInstOperands,
     /*  318699 */     // GIR_Coverage, 19873,
     /*  318699 */     GIR_EraseRootFromParent_Done,
     /*  318700 */   // Label 5909: @318700
     /*  318700 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(318763), // Rule ID 19876 //
     /*  318705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318761 */     GIR_RootConstrainSelectedInstOperands,
     /*  318762 */     // GIR_Coverage, 19876,
     /*  318762 */     GIR_EraseRootFromParent_Done,
     /*  318763 */   // Label 5910: @318763
     /*  318763 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(318826), // Rule ID 19877 //
     /*  318768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318807 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318824 */     GIR_RootConstrainSelectedInstOperands,
     /*  318825 */     // GIR_Coverage, 19877,
     /*  318825 */     GIR_EraseRootFromParent_Done,
     /*  318826 */   // Label 5911: @318826
     /*  318826 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(318889), // Rule ID 19880 //
     /*  318831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318887 */     GIR_RootConstrainSelectedInstOperands,
     /*  318888 */     // GIR_Coverage, 19880,
     /*  318888 */     GIR_EraseRootFromParent_Done,
     /*  318889 */   // Label 5912: @318889
     /*  318889 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(318952), // Rule ID 19881 //
     /*  318894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318933 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318950 */     GIR_RootConstrainSelectedInstOperands,
     /*  318951 */     // GIR_Coverage, 19881,
     /*  318951 */     GIR_EraseRootFromParent_Done,
     /*  318952 */   // Label 5913: @318952
     /*  318952 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(319015), // Rule ID 19884 //
     /*  318957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319013 */     GIR_RootConstrainSelectedInstOperands,
     /*  319014 */     // GIR_Coverage, 19884,
     /*  319014 */     GIR_EraseRootFromParent_Done,
     /*  319015 */   // Label 5914: @319015
     /*  319015 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(319078), // Rule ID 19885 //
     /*  319020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  319034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319059 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  319062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319076 */     GIR_RootConstrainSelectedInstOperands,
     /*  319077 */     // GIR_Coverage, 19885,
     /*  319077 */     GIR_EraseRootFromParent_Done,
     /*  319078 */   // Label 5915: @319078
     /*  319078 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(319141), // Rule ID 19888 //
     /*  319083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  319097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  319125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319139 */     GIR_RootConstrainSelectedInstOperands,
     /*  319140 */     // GIR_Coverage, 19888,
     /*  319140 */     GIR_EraseRootFromParent_Done,
     /*  319141 */   // Label 5916: @319141
     /*  319141 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(319204), // Rule ID 19889 //
     /*  319146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  319160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319185 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  319188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319202 */     GIR_RootConstrainSelectedInstOperands,
     /*  319203 */     // GIR_Coverage, 19889,
     /*  319203 */     GIR_EraseRootFromParent_Done,
     /*  319204 */   // Label 5917: @319204
     /*  319204 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(319267), // Rule ID 19892 //
     /*  319209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  319223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  319251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319265 */     GIR_RootConstrainSelectedInstOperands,
     /*  319266 */     // GIR_Coverage, 19892,
     /*  319266 */     GIR_EraseRootFromParent_Done,
     /*  319267 */   // Label 5918: @319267
     /*  319267 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(319330), // Rule ID 19893 //
     /*  319272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  319286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  319289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  319304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  319314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319328 */     GIR_RootConstrainSelectedInstOperands,
     /*  319329 */     // GIR_Coverage, 19893,
     /*  319329 */     GIR_EraseRootFromParent_Done,
     /*  319330 */   // Label 5919: @319330
     /*  319330 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(319393), // Rule ID 19896 //
     /*  319335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  319377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319391 */     GIR_RootConstrainSelectedInstOperands,
     /*  319392 */     // GIR_Coverage, 19896,
     /*  319392 */     GIR_EraseRootFromParent_Done,
     /*  319393 */   // Label 5920: @319393
     /*  319393 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(319456), // Rule ID 19897 //
     /*  319398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319437 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  319440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319454 */     GIR_RootConstrainSelectedInstOperands,
     /*  319455 */     // GIR_Coverage, 19897,
     /*  319455 */     GIR_EraseRootFromParent_Done,
     /*  319456 */   // Label 5921: @319456
     /*  319456 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(319519), // Rule ID 19900 //
     /*  319461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319500 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319517 */     GIR_RootConstrainSelectedInstOperands,
     /*  319518 */     // GIR_Coverage, 19900,
     /*  319518 */     GIR_EraseRootFromParent_Done,
     /*  319519 */   // Label 5922: @319519
     /*  319519 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(319582), // Rule ID 19901 //
     /*  319524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319563 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319580 */     GIR_RootConstrainSelectedInstOperands,
     /*  319581 */     // GIR_Coverage, 19901,
     /*  319581 */     GIR_EraseRootFromParent_Done,
     /*  319582 */   // Label 5923: @319582
     /*  319582 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(319645), // Rule ID 19904 //
     /*  319587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319643 */     GIR_RootConstrainSelectedInstOperands,
     /*  319644 */     // GIR_Coverage, 19904,
     /*  319644 */     GIR_EraseRootFromParent_Done,
     /*  319645 */   // Label 5924: @319645
     /*  319645 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(319708), // Rule ID 19905 //
     /*  319650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319689 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319706 */     GIR_RootConstrainSelectedInstOperands,
     /*  319707 */     // GIR_Coverage, 19905,
     /*  319707 */     GIR_EraseRootFromParent_Done,
     /*  319708 */   // Label 5925: @319708
     /*  319708 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(319771), // Rule ID 19908 //
     /*  319713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319769 */     GIR_RootConstrainSelectedInstOperands,
     /*  319770 */     // GIR_Coverage, 19908,
     /*  319770 */     GIR_EraseRootFromParent_Done,
     /*  319771 */   // Label 5926: @319771
     /*  319771 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(319834), // Rule ID 19909 //
     /*  319776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319815 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319832 */     GIR_RootConstrainSelectedInstOperands,
     /*  319833 */     // GIR_Coverage, 19909,
     /*  319833 */     GIR_EraseRootFromParent_Done,
     /*  319834 */   // Label 5927: @319834
     /*  319834 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(319897), // Rule ID 19912 //
     /*  319839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319878 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319895 */     GIR_RootConstrainSelectedInstOperands,
     /*  319896 */     // GIR_Coverage, 19912,
     /*  319896 */     GIR_EraseRootFromParent_Done,
     /*  319897 */   // Label 5928: @319897
     /*  319897 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(319960), // Rule ID 19913 //
     /*  319902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319958 */     GIR_RootConstrainSelectedInstOperands,
     /*  319959 */     // GIR_Coverage, 19913,
     /*  319959 */     GIR_EraseRootFromParent_Done,
     /*  319960 */   // Label 5929: @319960
     /*  319960 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(320023), // Rule ID 19916 //
     /*  319965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  320007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320021 */     GIR_RootConstrainSelectedInstOperands,
     /*  320022 */     // GIR_Coverage, 19916,
     /*  320022 */     GIR_EraseRootFromParent_Done,
     /*  320023 */   // Label 5930: @320023
     /*  320023 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(320086), // Rule ID 19917 //
     /*  320028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  320042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  320045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  320070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320084 */     GIR_RootConstrainSelectedInstOperands,
     /*  320085 */     // GIR_Coverage, 19917,
     /*  320085 */     GIR_EraseRootFromParent_Done,
     /*  320086 */   // Label 5931: @320086
     /*  320086 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(320149), // Rule ID 19920 //
     /*  320091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  320105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  320108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320147 */     GIR_RootConstrainSelectedInstOperands,
     /*  320148 */     // GIR_Coverage, 19920,
     /*  320148 */     GIR_EraseRootFromParent_Done,
     /*  320149 */   // Label 5932: @320149
     /*  320149 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(320212), // Rule ID 19921 //
     /*  320154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  320168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  320171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320193 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320210 */     GIR_RootConstrainSelectedInstOperands,
     /*  320211 */     // GIR_Coverage, 19921,
     /*  320211 */     GIR_EraseRootFromParent_Done,
     /*  320212 */   // Label 5933: @320212
     /*  320212 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(320275), // Rule ID 19924 //
     /*  320217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  320231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  320234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320273 */     GIR_RootConstrainSelectedInstOperands,
     /*  320274 */     // GIR_Coverage, 19924,
     /*  320274 */     GIR_EraseRootFromParent_Done,
     /*  320275 */   // Label 5934: @320275
     /*  320275 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(320338), // Rule ID 19925 //
     /*  320280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  320294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  320297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320319 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320336 */     GIR_RootConstrainSelectedInstOperands,
     /*  320337 */     // GIR_Coverage, 19925,
     /*  320337 */     GIR_EraseRootFromParent_Done,
     /*  320338 */   // Label 5935: @320338
     /*  320338 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(320401), // Rule ID 19928 //
     /*  320343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320382 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320399 */     GIR_RootConstrainSelectedInstOperands,
     /*  320400 */     // GIR_Coverage, 19928,
     /*  320400 */     GIR_EraseRootFromParent_Done,
     /*  320401 */   // Label 5936: @320401
     /*  320401 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(320464), // Rule ID 19929 //
     /*  320406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320445 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320462 */     GIR_RootConstrainSelectedInstOperands,
     /*  320463 */     // GIR_Coverage, 19929,
     /*  320463 */     GIR_EraseRootFromParent_Done,
     /*  320464 */   // Label 5937: @320464
     /*  320464 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(320527), // Rule ID 19932 //
     /*  320469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320525 */     GIR_RootConstrainSelectedInstOperands,
     /*  320526 */     // GIR_Coverage, 19932,
     /*  320526 */     GIR_EraseRootFromParent_Done,
     /*  320527 */   // Label 5938: @320527
     /*  320527 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(320590), // Rule ID 19933 //
     /*  320532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320588 */     GIR_RootConstrainSelectedInstOperands,
     /*  320589 */     // GIR_Coverage, 19933,
     /*  320589 */     GIR_EraseRootFromParent_Done,
     /*  320590 */   // Label 5939: @320590
     /*  320590 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(320653), // Rule ID 19936 //
     /*  320595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320634 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320651 */     GIR_RootConstrainSelectedInstOperands,
     /*  320652 */     // GIR_Coverage, 19936,
     /*  320652 */     GIR_EraseRootFromParent_Done,
     /*  320653 */   // Label 5940: @320653
     /*  320653 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(320716), // Rule ID 19937 //
     /*  320658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320714 */     GIR_RootConstrainSelectedInstOperands,
     /*  320715 */     // GIR_Coverage, 19937,
     /*  320715 */     GIR_EraseRootFromParent_Done,
     /*  320716 */   // Label 5941: @320716
     /*  320716 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(320779), // Rule ID 19940 //
     /*  320721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320760 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320777 */     GIR_RootConstrainSelectedInstOperands,
     /*  320778 */     // GIR_Coverage, 19940,
     /*  320778 */     GIR_EraseRootFromParent_Done,
     /*  320779 */   // Label 5942: @320779
     /*  320779 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(320842), // Rule ID 19941 //
     /*  320784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320823 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320840 */     GIR_RootConstrainSelectedInstOperands,
     /*  320841 */     // GIR_Coverage, 19941,
     /*  320841 */     GIR_EraseRootFromParent_Done,
     /*  320842 */   // Label 5943: @320842
     /*  320842 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(320905), // Rule ID 19944 //
     /*  320847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320903 */     GIR_RootConstrainSelectedInstOperands,
     /*  320904 */     // GIR_Coverage, 19944,
     /*  320904 */     GIR_EraseRootFromParent_Done,
     /*  320905 */   // Label 5944: @320905
     /*  320905 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(320968), // Rule ID 19945 //
     /*  320910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320949 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320966 */     GIR_RootConstrainSelectedInstOperands,
     /*  320967 */     // GIR_Coverage, 19945,
     /*  320967 */     GIR_EraseRootFromParent_Done,
     /*  320968 */   // Label 5945: @320968
     /*  320968 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(321031), // Rule ID 19948 //
     /*  320973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  321015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321029 */     GIR_RootConstrainSelectedInstOperands,
     /*  321030 */     // GIR_Coverage, 19948,
     /*  321030 */     GIR_EraseRootFromParent_Done,
     /*  321031 */   // Label 5946: @321031
     /*  321031 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(321094), // Rule ID 19949 //
     /*  321036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  321050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  321053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  321078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321092 */     GIR_RootConstrainSelectedInstOperands,
     /*  321093 */     // GIR_Coverage, 19949,
     /*  321093 */     GIR_EraseRootFromParent_Done,
     /*  321094 */   // Label 5947: @321094
     /*  321094 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(321157), // Rule ID 19952 //
     /*  321099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  321113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  321116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  321141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321155 */     GIR_RootConstrainSelectedInstOperands,
     /*  321156 */     // GIR_Coverage, 19952,
     /*  321156 */     GIR_EraseRootFromParent_Done,
     /*  321157 */   // Label 5948: @321157
     /*  321157 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(321220), // Rule ID 19953 //
     /*  321162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  321176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  321179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321201 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  321204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321218 */     GIR_RootConstrainSelectedInstOperands,
     /*  321219 */     // GIR_Coverage, 19953,
     /*  321219 */     GIR_EraseRootFromParent_Done,
     /*  321220 */   // Label 5949: @321220
     /*  321220 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(321283), // Rule ID 19956 //
     /*  321225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  321239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  321267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321281 */     GIR_RootConstrainSelectedInstOperands,
     /*  321282 */     // GIR_Coverage, 19956,
     /*  321282 */     GIR_EraseRootFromParent_Done,
     /*  321283 */   // Label 5950: @321283
     /*  321283 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(321346), // Rule ID 19957 //
     /*  321288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  321302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  321330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321344 */     GIR_RootConstrainSelectedInstOperands,
     /*  321345 */     // GIR_Coverage, 19957,
     /*  321345 */     GIR_EraseRootFromParent_Done,
     /*  321346 */   // Label 5951: @321346
     /*  321346 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(321409), // Rule ID 19960 //
     /*  321351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  321393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321407 */     GIR_RootConstrainSelectedInstOperands,
     /*  321408 */     // GIR_Coverage, 19960,
     /*  321408 */     GIR_EraseRootFromParent_Done,
     /*  321409 */   // Label 5952: @321409
     /*  321409 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(321472), // Rule ID 19961 //
     /*  321414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321453 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  321456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321470 */     GIR_RootConstrainSelectedInstOperands,
     /*  321471 */     // GIR_Coverage, 19961,
     /*  321471 */     GIR_EraseRootFromParent_Done,
     /*  321472 */   // Label 5953: @321472
     /*  321472 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(321535), // Rule ID 19964 //
     /*  321477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321533 */     GIR_RootConstrainSelectedInstOperands,
     /*  321534 */     // GIR_Coverage, 19964,
     /*  321534 */     GIR_EraseRootFromParent_Done,
     /*  321535 */   // Label 5954: @321535
     /*  321535 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(321598), // Rule ID 19965 //
     /*  321540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321579 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321596 */     GIR_RootConstrainSelectedInstOperands,
     /*  321597 */     // GIR_Coverage, 19965,
     /*  321597 */     GIR_EraseRootFromParent_Done,
     /*  321598 */   // Label 5955: @321598
     /*  321598 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(321661), // Rule ID 19968 //
     /*  321603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321659 */     GIR_RootConstrainSelectedInstOperands,
     /*  321660 */     // GIR_Coverage, 19968,
     /*  321660 */     GIR_EraseRootFromParent_Done,
     /*  321661 */   // Label 5956: @321661
     /*  321661 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(321724), // Rule ID 19969 //
     /*  321666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321705 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321722 */     GIR_RootConstrainSelectedInstOperands,
     /*  321723 */     // GIR_Coverage, 19969,
     /*  321723 */     GIR_EraseRootFromParent_Done,
     /*  321724 */   // Label 5957: @321724
     /*  321724 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(321787), // Rule ID 19972 //
     /*  321729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321785 */     GIR_RootConstrainSelectedInstOperands,
     /*  321786 */     // GIR_Coverage, 19972,
     /*  321786 */     GIR_EraseRootFromParent_Done,
     /*  321787 */   // Label 5958: @321787
     /*  321787 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(321850), // Rule ID 19973 //
     /*  321792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321831 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321848 */     GIR_RootConstrainSelectedInstOperands,
     /*  321849 */     // GIR_Coverage, 19973,
     /*  321849 */     GIR_EraseRootFromParent_Done,
     /*  321850 */   // Label 5959: @321850
     /*  321850 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(321913), // Rule ID 19976 //
     /*  321855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321911 */     GIR_RootConstrainSelectedInstOperands,
     /*  321912 */     // GIR_Coverage, 19976,
     /*  321912 */     GIR_EraseRootFromParent_Done,
     /*  321913 */   // Label 5960: @321913
     /*  321913 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(321976), // Rule ID 19977 //
     /*  321918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321957 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321974 */     GIR_RootConstrainSelectedInstOperands,
     /*  321975 */     // GIR_Coverage, 19977,
     /*  321975 */     GIR_EraseRootFromParent_Done,
     /*  321976 */   // Label 5961: @321976
     /*  321976 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(322039), // Rule ID 19980 //
     /*  321981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  322023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322037 */     GIR_RootConstrainSelectedInstOperands,
     /*  322038 */     // GIR_Coverage, 19980,
     /*  322038 */     GIR_EraseRootFromParent_Done,
     /*  322039 */   // Label 5962: @322039
     /*  322039 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(322102), // Rule ID 19981 //
     /*  322044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  322058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322083 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  322086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322100 */     GIR_RootConstrainSelectedInstOperands,
     /*  322101 */     // GIR_Coverage, 19981,
     /*  322101 */     GIR_EraseRootFromParent_Done,
     /*  322102 */   // Label 5963: @322102
     /*  322102 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(322165), // Rule ID 19984 //
     /*  322107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  322121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  322149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322163 */     GIR_RootConstrainSelectedInstOperands,
     /*  322164 */     // GIR_Coverage, 19984,
     /*  322164 */     GIR_EraseRootFromParent_Done,
     /*  322165 */   // Label 5964: @322165
     /*  322165 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(322228), // Rule ID 19985 //
     /*  322170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  322184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322209 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  322212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322226 */     GIR_RootConstrainSelectedInstOperands,
     /*  322227 */     // GIR_Coverage, 19985,
     /*  322227 */     GIR_EraseRootFromParent_Done,
     /*  322228 */   // Label 5965: @322228
     /*  322228 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(322291), // Rule ID 19988 //
     /*  322233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  322244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  322247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  322275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322289 */     GIR_RootConstrainSelectedInstOperands,
     /*  322290 */     // GIR_Coverage, 19988,
     /*  322290 */     GIR_EraseRootFromParent_Done,
     /*  322291 */   // Label 5966: @322291
     /*  322291 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(322354), // Rule ID 19989 //
     /*  322296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  322307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  322310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  322313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  322328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322335 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  322338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322352 */     GIR_RootConstrainSelectedInstOperands,
     /*  322353 */     // GIR_Coverage, 19989,
     /*  322353 */     GIR_EraseRootFromParent_Done,
     /*  322354 */   // Label 5967: @322354
     /*  322354 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(322417), // Rule ID 19992 //
     /*  322359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  322401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322415 */     GIR_RootConstrainSelectedInstOperands,
     /*  322416 */     // GIR_Coverage, 19992,
     /*  322416 */     GIR_EraseRootFromParent_Done,
     /*  322417 */   // Label 5968: @322417
     /*  322417 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(322480), // Rule ID 19993 //
     /*  322422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322461 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  322464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322478 */     GIR_RootConstrainSelectedInstOperands,
     /*  322479 */     // GIR_Coverage, 19993,
     /*  322479 */     GIR_EraseRootFromParent_Done,
     /*  322480 */   // Label 5969: @322480
     /*  322480 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(322543), // Rule ID 19996 //
     /*  322485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322541 */     GIR_RootConstrainSelectedInstOperands,
     /*  322542 */     // GIR_Coverage, 19996,
     /*  322542 */     GIR_EraseRootFromParent_Done,
     /*  322543 */   // Label 5970: @322543
     /*  322543 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(322606), // Rule ID 19997 //
     /*  322548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322587 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322604 */     GIR_RootConstrainSelectedInstOperands,
     /*  322605 */     // GIR_Coverage, 19997,
     /*  322605 */     GIR_EraseRootFromParent_Done,
     /*  322606 */   // Label 5971: @322606
     /*  322606 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(322669), // Rule ID 20000 //
     /*  322611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322667 */     GIR_RootConstrainSelectedInstOperands,
     /*  322668 */     // GIR_Coverage, 20000,
     /*  322668 */     GIR_EraseRootFromParent_Done,
     /*  322669 */   // Label 5972: @322669
     /*  322669 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(322732), // Rule ID 20001 //
     /*  322674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322730 */     GIR_RootConstrainSelectedInstOperands,
     /*  322731 */     // GIR_Coverage, 20001,
     /*  322731 */     GIR_EraseRootFromParent_Done,
     /*  322732 */   // Label 5973: @322732
     /*  322732 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(322795), // Rule ID 20004 //
     /*  322737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322793 */     GIR_RootConstrainSelectedInstOperands,
     /*  322794 */     // GIR_Coverage, 20004,
     /*  322794 */     GIR_EraseRootFromParent_Done,
     /*  322795 */   // Label 5974: @322795
     /*  322795 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(322858), // Rule ID 20005 //
     /*  322800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322856 */     GIR_RootConstrainSelectedInstOperands,
     /*  322857 */     // GIR_Coverage, 20005,
     /*  322857 */     GIR_EraseRootFromParent_Done,
     /*  322858 */   // Label 5975: @322858
     /*  322858 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(322921), // Rule ID 20008 //
     /*  322863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322919 */     GIR_RootConstrainSelectedInstOperands,
     /*  322920 */     // GIR_Coverage, 20008,
     /*  322920 */     GIR_EraseRootFromParent_Done,
     /*  322921 */   // Label 5976: @322921
     /*  322921 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(322984), // Rule ID 20009 //
     /*  322926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322965 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322982 */     GIR_RootConstrainSelectedInstOperands,
     /*  322983 */     // GIR_Coverage, 20009,
     /*  322983 */     GIR_EraseRootFromParent_Done,
     /*  322984 */   // Label 5977: @322984
     /*  322984 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(323047), // Rule ID 20012 //
     /*  322989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  323006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  323021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  323031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323045 */     GIR_RootConstrainSelectedInstOperands,
     /*  323046 */     // GIR_Coverage, 20012,
     /*  323046 */     GIR_EraseRootFromParent_Done,
     /*  323047 */   // Label 5978: @323047
     /*  323047 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(323110), // Rule ID 20013 //
     /*  323052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  323069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  323084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  323094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323108 */     GIR_RootConstrainSelectedInstOperands,
     /*  323109 */     // GIR_Coverage, 20013,
     /*  323109 */     GIR_EraseRootFromParent_Done,
     /*  323110 */   // Label 5979: @323110
     /*  323110 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(323173), // Rule ID 20016 //
     /*  323115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  323129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  323132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323154 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  323157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323171 */     GIR_RootConstrainSelectedInstOperands,
     /*  323172 */     // GIR_Coverage, 20016,
     /*  323172 */     GIR_EraseRootFromParent_Done,
     /*  323173 */   // Label 5980: @323173
     /*  323173 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(323236), // Rule ID 20017 //
     /*  323178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  323192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  323195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323217 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  323220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323234 */     GIR_RootConstrainSelectedInstOperands,
     /*  323235 */     // GIR_Coverage, 20017,
     /*  323235 */     GIR_EraseRootFromParent_Done,
     /*  323236 */   // Label 5981: @323236
     /*  323236 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(323299), // Rule ID 20020 //
     /*  323241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  323255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  323258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323297 */     GIR_RootConstrainSelectedInstOperands,
     /*  323298 */     // GIR_Coverage, 20020,
     /*  323298 */     GIR_EraseRootFromParent_Done,
     /*  323299 */   // Label 5982: @323299
     /*  323299 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(323362), // Rule ID 20021 //
     /*  323304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  323318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  323321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323343 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323360 */     GIR_RootConstrainSelectedInstOperands,
     /*  323361 */     // GIR_Coverage, 20021,
     /*  323361 */     GIR_EraseRootFromParent_Done,
     /*  323362 */   // Label 5983: @323362
     /*  323362 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(323425), // Rule ID 20024 //
     /*  323367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323406 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323423 */     GIR_RootConstrainSelectedInstOperands,
     /*  323424 */     // GIR_Coverage, 20024,
     /*  323424 */     GIR_EraseRootFromParent_Done,
     /*  323425 */   // Label 5984: @323425
     /*  323425 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(323488), // Rule ID 20025 //
     /*  323430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323469 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323486 */     GIR_RootConstrainSelectedInstOperands,
     /*  323487 */     // GIR_Coverage, 20025,
     /*  323487 */     GIR_EraseRootFromParent_Done,
     /*  323488 */   // Label 5985: @323488
     /*  323488 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(323551), // Rule ID 20028 //
     /*  323493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323549 */     GIR_RootConstrainSelectedInstOperands,
     /*  323550 */     // GIR_Coverage, 20028,
     /*  323550 */     GIR_EraseRootFromParent_Done,
     /*  323551 */   // Label 5986: @323551
     /*  323551 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(323614), // Rule ID 20029 //
     /*  323556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323612 */     GIR_RootConstrainSelectedInstOperands,
     /*  323613 */     // GIR_Coverage, 20029,
     /*  323613 */     GIR_EraseRootFromParent_Done,
     /*  323614 */   // Label 5987: @323614
     /*  323614 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(323677), // Rule ID 20032 //
     /*  323619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323675 */     GIR_RootConstrainSelectedInstOperands,
     /*  323676 */     // GIR_Coverage, 20032,
     /*  323676 */     GIR_EraseRootFromParent_Done,
     /*  323677 */   // Label 5988: @323677
     /*  323677 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(323740), // Rule ID 20033 //
     /*  323682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323738 */     GIR_RootConstrainSelectedInstOperands,
     /*  323739 */     // GIR_Coverage, 20033,
     /*  323739 */     GIR_EraseRootFromParent_Done,
     /*  323740 */   // Label 5989: @323740
     /*  323740 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(323803), // Rule ID 20036 //
     /*  323745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323801 */     GIR_RootConstrainSelectedInstOperands,
     /*  323802 */     // GIR_Coverage, 20036,
     /*  323802 */     GIR_EraseRootFromParent_Done,
     /*  323803 */   // Label 5990: @323803
     /*  323803 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(323866), // Rule ID 20037 //
     /*  323808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323847 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323864 */     GIR_RootConstrainSelectedInstOperands,
     /*  323865 */     // GIR_Coverage, 20037,
     /*  323865 */     GIR_EraseRootFromParent_Done,
     /*  323866 */   // Label 5991: @323866
     /*  323866 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(323929), // Rule ID 20040 //
     /*  323871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323927 */     GIR_RootConstrainSelectedInstOperands,
     /*  323928 */     // GIR_Coverage, 20040,
     /*  323928 */     GIR_EraseRootFromParent_Done,
     /*  323929 */   // Label 5992: @323929
     /*  323929 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(323992), // Rule ID 20041 //
     /*  323934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323973 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323990 */     GIR_RootConstrainSelectedInstOperands,
     /*  323991 */     // GIR_Coverage, 20041,
     /*  323991 */     GIR_EraseRootFromParent_Done,
     /*  323992 */   // Label 5993: @323992
     /*  323992 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(324055), // Rule ID 20044 //
     /*  323997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  324014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324036 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324053 */     GIR_RootConstrainSelectedInstOperands,
     /*  324054 */     // GIR_Coverage, 20044,
     /*  324054 */     GIR_EraseRootFromParent_Done,
     /*  324055 */   // Label 5994: @324055
     /*  324055 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(324118), // Rule ID 20045 //
     /*  324060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  324077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324099 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324116 */     GIR_RootConstrainSelectedInstOperands,
     /*  324117 */     // GIR_Coverage, 20045,
     /*  324117 */     GIR_EraseRootFromParent_Done,
     /*  324118 */   // Label 5995: @324118
     /*  324118 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(324181), // Rule ID 20048 //
     /*  324123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  324134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  324137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  324140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324179 */     GIR_RootConstrainSelectedInstOperands,
     /*  324180 */     // GIR_Coverage, 20048,
     /*  324180 */     GIR_EraseRootFromParent_Done,
     /*  324181 */   // Label 5996: @324181
     /*  324181 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(324244), // Rule ID 20049 //
     /*  324186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  324197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  324200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  324203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324225 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324242 */     GIR_RootConstrainSelectedInstOperands,
     /*  324243 */     // GIR_Coverage, 20049,
     /*  324243 */     GIR_EraseRootFromParent_Done,
     /*  324244 */   // Label 5997: @324244
     /*  324244 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(324307), // Rule ID 20052 //
     /*  324249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  324263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324305 */     GIR_RootConstrainSelectedInstOperands,
     /*  324306 */     // GIR_Coverage, 20052,
     /*  324306 */     GIR_EraseRootFromParent_Done,
     /*  324307 */   // Label 5998: @324307
     /*  324307 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(324370), // Rule ID 20053 //
     /*  324312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  324326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  324329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324351 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324368 */     GIR_RootConstrainSelectedInstOperands,
     /*  324369 */     // GIR_Coverage, 20053,
     /*  324369 */     GIR_EraseRootFromParent_Done,
     /*  324370 */   // Label 5999: @324370
     /*  324370 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(324433), // Rule ID 20056 //
     /*  324375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324431 */     GIR_RootConstrainSelectedInstOperands,
     /*  324432 */     // GIR_Coverage, 20056,
     /*  324432 */     GIR_EraseRootFromParent_Done,
     /*  324433 */   // Label 6000: @324433
     /*  324433 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(324496), // Rule ID 20057 //
     /*  324438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324477 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324494 */     GIR_RootConstrainSelectedInstOperands,
     /*  324495 */     // GIR_Coverage, 20057,
     /*  324495 */     GIR_EraseRootFromParent_Done,
     /*  324496 */   // Label 6001: @324496
     /*  324496 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(324559), // Rule ID 20060 //
     /*  324501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324557 */     GIR_RootConstrainSelectedInstOperands,
     /*  324558 */     // GIR_Coverage, 20060,
     /*  324558 */     GIR_EraseRootFromParent_Done,
     /*  324559 */   // Label 6002: @324559
     /*  324559 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(324622), // Rule ID 20061 //
     /*  324564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324603 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324620 */     GIR_RootConstrainSelectedInstOperands,
     /*  324621 */     // GIR_Coverage, 20061,
     /*  324621 */     GIR_EraseRootFromParent_Done,
     /*  324622 */   // Label 6003: @324622
     /*  324622 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(324685), // Rule ID 20064 //
     /*  324627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324666 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324683 */     GIR_RootConstrainSelectedInstOperands,
     /*  324684 */     // GIR_Coverage, 20064,
     /*  324684 */     GIR_EraseRootFromParent_Done,
     /*  324685 */   // Label 6004: @324685
     /*  324685 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(324748), // Rule ID 20065 //
     /*  324690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324729 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324746 */     GIR_RootConstrainSelectedInstOperands,
     /*  324747 */     // GIR_Coverage, 20065,
     /*  324747 */     GIR_EraseRootFromParent_Done,
     /*  324748 */   // Label 6005: @324748
     /*  324748 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(324811), // Rule ID 20068 //
     /*  324753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324809 */     GIR_RootConstrainSelectedInstOperands,
     /*  324810 */     // GIR_Coverage, 20068,
     /*  324810 */     GIR_EraseRootFromParent_Done,
     /*  324811 */   // Label 6006: @324811
     /*  324811 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(324874), // Rule ID 20069 //
     /*  324816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324855 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324872 */     GIR_RootConstrainSelectedInstOperands,
     /*  324873 */     // GIR_Coverage, 20069,
     /*  324873 */     GIR_EraseRootFromParent_Done,
     /*  324874 */   // Label 6007: @324874
     /*  324874 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(324937), // Rule ID 20072 //
     /*  324879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324935 */     GIR_RootConstrainSelectedInstOperands,
     /*  324936 */     // GIR_Coverage, 20072,
     /*  324936 */     GIR_EraseRootFromParent_Done,
     /*  324937 */   // Label 6008: @324937
     /*  324937 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(325000), // Rule ID 20073 //
     /*  324942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324981 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324998 */     GIR_RootConstrainSelectedInstOperands,
     /*  324999 */     // GIR_Coverage, 20073,
     /*  324999 */     GIR_EraseRootFromParent_Done,
     /*  325000 */   // Label 6009: @325000
     /*  325000 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(325063), // Rule ID 20076 //
     /*  325005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  325047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325061 */     GIR_RootConstrainSelectedInstOperands,
     /*  325062 */     // GIR_Coverage, 20076,
     /*  325062 */     GIR_EraseRootFromParent_Done,
     /*  325063 */   // Label 6010: @325063
     /*  325063 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(325126), // Rule ID 20077 //
     /*  325068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325107 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  325110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325124 */     GIR_RootConstrainSelectedInstOperands,
     /*  325125 */     // GIR_Coverage, 20077,
     /*  325125 */     GIR_EraseRootFromParent_Done,
     /*  325126 */   // Label 6011: @325126
     /*  325126 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(325189), // Rule ID 20080 //
     /*  325131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  325145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325170 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  325173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325187 */     GIR_RootConstrainSelectedInstOperands,
     /*  325188 */     // GIR_Coverage, 20080,
     /*  325188 */     GIR_EraseRootFromParent_Done,
     /*  325189 */   // Label 6012: @325189
     /*  325189 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(325252), // Rule ID 20081 //
     /*  325194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  325208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325233 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  325236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325250 */     GIR_RootConstrainSelectedInstOperands,
     /*  325251 */     // GIR_Coverage, 20081,
     /*  325251 */     GIR_EraseRootFromParent_Done,
     /*  325252 */   // Label 6013: @325252
     /*  325252 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(325315), // Rule ID 20084 //
     /*  325257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  325271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325296 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  325299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325313 */     GIR_RootConstrainSelectedInstOperands,
     /*  325314 */     // GIR_Coverage, 20084,
     /*  325314 */     GIR_EraseRootFromParent_Done,
     /*  325315 */   // Label 6014: @325315
     /*  325315 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(325378), // Rule ID 20085 //
     /*  325320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  325334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325359 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  325362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325376 */     GIR_RootConstrainSelectedInstOperands,
     /*  325377 */     // GIR_Coverage, 20085,
     /*  325377 */     GIR_EraseRootFromParent_Done,
     /*  325378 */   // Label 6015: @325378
     /*  325378 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(325441), // Rule ID 20088 //
     /*  325383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325439 */     GIR_RootConstrainSelectedInstOperands,
     /*  325440 */     // GIR_Coverage, 20088,
     /*  325440 */     GIR_EraseRootFromParent_Done,
     /*  325441 */   // Label 6016: @325441
     /*  325441 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(325504), // Rule ID 20089 //
     /*  325446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325502 */     GIR_RootConstrainSelectedInstOperands,
     /*  325503 */     // GIR_Coverage, 20089,
     /*  325503 */     GIR_EraseRootFromParent_Done,
     /*  325504 */   // Label 6017: @325504
     /*  325504 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(325567), // Rule ID 20092 //
     /*  325509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325565 */     GIR_RootConstrainSelectedInstOperands,
     /*  325566 */     // GIR_Coverage, 20092,
     /*  325566 */     GIR_EraseRootFromParent_Done,
     /*  325567 */   // Label 6018: @325567
     /*  325567 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(325630), // Rule ID 20093 //
     /*  325572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325628 */     GIR_RootConstrainSelectedInstOperands,
     /*  325629 */     // GIR_Coverage, 20093,
     /*  325629 */     GIR_EraseRootFromParent_Done,
     /*  325630 */   // Label 6019: @325630
     /*  325630 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(325693), // Rule ID 20096 //
     /*  325635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325691 */     GIR_RootConstrainSelectedInstOperands,
     /*  325692 */     // GIR_Coverage, 20096,
     /*  325692 */     GIR_EraseRootFromParent_Done,
     /*  325693 */   // Label 6020: @325693
     /*  325693 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(325756), // Rule ID 20097 //
     /*  325698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325754 */     GIR_RootConstrainSelectedInstOperands,
     /*  325755 */     // GIR_Coverage, 20097,
     /*  325755 */     GIR_EraseRootFromParent_Done,
     /*  325756 */   // Label 6021: @325756
     /*  325756 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(325819), // Rule ID 20100 //
     /*  325761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325817 */     GIR_RootConstrainSelectedInstOperands,
     /*  325818 */     // GIR_Coverage, 20100,
     /*  325818 */     GIR_EraseRootFromParent_Done,
     /*  325819 */   // Label 6022: @325819
     /*  325819 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(325882), // Rule ID 20101 //
     /*  325824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325863 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325880 */     GIR_RootConstrainSelectedInstOperands,
     /*  325881 */     // GIR_Coverage, 20101,
     /*  325881 */     GIR_EraseRootFromParent_Done,
     /*  325882 */   // Label 6023: @325882
     /*  325882 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(325945), // Rule ID 20104 //
     /*  325887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325926 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325943 */     GIR_RootConstrainSelectedInstOperands,
     /*  325944 */     // GIR_Coverage, 20104,
     /*  325944 */     GIR_EraseRootFromParent_Done,
     /*  325945 */   // Label 6024: @325945
     /*  325945 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(326008), // Rule ID 20105 //
     /*  325950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325989 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326006 */     GIR_RootConstrainSelectedInstOperands,
     /*  326007 */     // GIR_Coverage, 20105,
     /*  326007 */     GIR_EraseRootFromParent_Done,
     /*  326008 */   // Label 6025: @326008
     /*  326008 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(326071), // Rule ID 20108 //
     /*  326013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  326024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  326027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  326030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  326045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326052 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  326055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326069 */     GIR_RootConstrainSelectedInstOperands,
     /*  326070 */     // GIR_Coverage, 20108,
     /*  326070 */     GIR_EraseRootFromParent_Done,
     /*  326071 */   // Label 6026: @326071
     /*  326071 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(326134), // Rule ID 20109 //
     /*  326076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  326087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  326090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  326093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  326108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326115 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  326118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326132 */     GIR_RootConstrainSelectedInstOperands,
     /*  326133 */     // GIR_Coverage, 20109,
     /*  326133 */     GIR_EraseRootFromParent_Done,
     /*  326134 */   // Label 6027: @326134
     /*  326134 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(326197), // Rule ID 20112 //
     /*  326139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  326153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326178 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  326181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326195 */     GIR_RootConstrainSelectedInstOperands,
     /*  326196 */     // GIR_Coverage, 20112,
     /*  326196 */     GIR_EraseRootFromParent_Done,
     /*  326197 */   // Label 6028: @326197
     /*  326197 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(326260), // Rule ID 20113 //
     /*  326202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  326216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326241 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  326244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326258 */     GIR_RootConstrainSelectedInstOperands,
     /*  326259 */     // GIR_Coverage, 20113,
     /*  326259 */     GIR_EraseRootFromParent_Done,
     /*  326260 */   // Label 6029: @326260
     /*  326260 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(326323), // Rule ID 20116 //
     /*  326265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  326279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  326307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326321 */     GIR_RootConstrainSelectedInstOperands,
     /*  326322 */     // GIR_Coverage, 20116,
     /*  326322 */     GIR_EraseRootFromParent_Done,
     /*  326323 */   // Label 6030: @326323
     /*  326323 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(326386), // Rule ID 20117 //
     /*  326328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  326342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  326370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326384 */     GIR_RootConstrainSelectedInstOperands,
     /*  326385 */     // GIR_Coverage, 20117,
     /*  326385 */     GIR_EraseRootFromParent_Done,
     /*  326386 */   // Label 6031: @326386
     /*  326386 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(326449), // Rule ID 20120 //
     /*  326391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326447 */     GIR_RootConstrainSelectedInstOperands,
     /*  326448 */     // GIR_Coverage, 20120,
     /*  326448 */     GIR_EraseRootFromParent_Done,
     /*  326449 */   // Label 6032: @326449
     /*  326449 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(326512), // Rule ID 20121 //
     /*  326454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326510 */     GIR_RootConstrainSelectedInstOperands,
     /*  326511 */     // GIR_Coverage, 20121,
     /*  326511 */     GIR_EraseRootFromParent_Done,
     /*  326512 */   // Label 6033: @326512
     /*  326512 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(326575), // Rule ID 20124 //
     /*  326517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326573 */     GIR_RootConstrainSelectedInstOperands,
     /*  326574 */     // GIR_Coverage, 20124,
     /*  326574 */     GIR_EraseRootFromParent_Done,
     /*  326575 */   // Label 6034: @326575
     /*  326575 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(326638), // Rule ID 20125 //
     /*  326580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326636 */     GIR_RootConstrainSelectedInstOperands,
     /*  326637 */     // GIR_Coverage, 20125,
     /*  326637 */     GIR_EraseRootFromParent_Done,
     /*  326638 */   // Label 6035: @326638
     /*  326638 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(326701), // Rule ID 20128 //
     /*  326643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326699 */     GIR_RootConstrainSelectedInstOperands,
     /*  326700 */     // GIR_Coverage, 20128,
     /*  326700 */     GIR_EraseRootFromParent_Done,
     /*  326701 */   // Label 6036: @326701
     /*  326701 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(326764), // Rule ID 20129 //
     /*  326706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326745 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326762 */     GIR_RootConstrainSelectedInstOperands,
     /*  326763 */     // GIR_Coverage, 20129,
     /*  326763 */     GIR_EraseRootFromParent_Done,
     /*  326764 */   // Label 6037: @326764
     /*  326764 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(326827), // Rule ID 20132 //
     /*  326769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326825 */     GIR_RootConstrainSelectedInstOperands,
     /*  326826 */     // GIR_Coverage, 20132,
     /*  326826 */     GIR_EraseRootFromParent_Done,
     /*  326827 */   // Label 6038: @326827
     /*  326827 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(326890), // Rule ID 20133 //
     /*  326832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326888 */     GIR_RootConstrainSelectedInstOperands,
     /*  326889 */     // GIR_Coverage, 20133,
     /*  326889 */     GIR_EraseRootFromParent_Done,
     /*  326890 */   // Label 6039: @326890
     /*  326890 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(326953), // Rule ID 20136 //
     /*  326895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326934 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326951 */     GIR_RootConstrainSelectedInstOperands,
     /*  326952 */     // GIR_Coverage, 20136,
     /*  326952 */     GIR_EraseRootFromParent_Done,
     /*  326953 */   // Label 6040: @326953
     /*  326953 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(327016), // Rule ID 20137 //
     /*  326958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326997 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  327000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327014 */     GIR_RootConstrainSelectedInstOperands,
     /*  327015 */     // GIR_Coverage, 20137,
     /*  327015 */     GIR_EraseRootFromParent_Done,
     /*  327016 */   // Label 6041: @327016
     /*  327016 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(327079), // Rule ID 20140 //
     /*  327021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  327038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327077 */     GIR_RootConstrainSelectedInstOperands,
     /*  327078 */     // GIR_Coverage, 20140,
     /*  327078 */     GIR_EraseRootFromParent_Done,
     /*  327079 */   // Label 6042: @327079
     /*  327079 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(327142), // Rule ID 20141 //
     /*  327084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  327101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327123 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327140 */     GIR_RootConstrainSelectedInstOperands,
     /*  327141 */     // GIR_Coverage, 20141,
     /*  327141 */     GIR_EraseRootFromParent_Done,
     /*  327142 */   // Label 6043: @327142
     /*  327142 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(327205), // Rule ID 20144 //
     /*  327147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  327164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327203 */     GIR_RootConstrainSelectedInstOperands,
     /*  327204 */     // GIR_Coverage, 20144,
     /*  327204 */     GIR_EraseRootFromParent_Done,
     /*  327205 */   // Label 6044: @327205
     /*  327205 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(327268), // Rule ID 20145 //
     /*  327210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  327224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  327227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327249 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  327252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327266 */     GIR_RootConstrainSelectedInstOperands,
     /*  327267 */     // GIR_Coverage, 20145,
     /*  327267 */     GIR_EraseRootFromParent_Done,
     /*  327268 */   // Label 6045: @327268
     /*  327268 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(327331), // Rule ID 20148 //
     /*  327273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  327290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327312 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327329 */     GIR_RootConstrainSelectedInstOperands,
     /*  327330 */     // GIR_Coverage, 20148,
     /*  327330 */     GIR_EraseRootFromParent_Done,
     /*  327331 */   // Label 6046: @327331
     /*  327331 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(327394), // Rule ID 20149 //
     /*  327336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  327350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  327353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327375 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327392 */     GIR_RootConstrainSelectedInstOperands,
     /*  327393 */     // GIR_Coverage, 20149,
     /*  327393 */     GIR_EraseRootFromParent_Done,
     /*  327394 */   // Label 6047: @327394
     /*  327394 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(327457), // Rule ID 20152 //
     /*  327399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327455 */     GIR_RootConstrainSelectedInstOperands,
     /*  327456 */     // GIR_Coverage, 20152,
     /*  327456 */     GIR_EraseRootFromParent_Done,
     /*  327457 */   // Label 6048: @327457
     /*  327457 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(327520), // Rule ID 20153 //
     /*  327462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327501 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327518 */     GIR_RootConstrainSelectedInstOperands,
     /*  327519 */     // GIR_Coverage, 20153,
     /*  327519 */     GIR_EraseRootFromParent_Done,
     /*  327520 */   // Label 6049: @327520
     /*  327520 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(327583), // Rule ID 20156 //
     /*  327525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327581 */     GIR_RootConstrainSelectedInstOperands,
     /*  327582 */     // GIR_Coverage, 20156,
     /*  327582 */     GIR_EraseRootFromParent_Done,
     /*  327583 */   // Label 6050: @327583
     /*  327583 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(327646), // Rule ID 20157 //
     /*  327588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327644 */     GIR_RootConstrainSelectedInstOperands,
     /*  327645 */     // GIR_Coverage, 20157,
     /*  327645 */     GIR_EraseRootFromParent_Done,
     /*  327646 */   // Label 6051: @327646
     /*  327646 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(327709), // Rule ID 20160 //
     /*  327651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327707 */     GIR_RootConstrainSelectedInstOperands,
     /*  327708 */     // GIR_Coverage, 20160,
     /*  327708 */     GIR_EraseRootFromParent_Done,
     /*  327709 */   // Label 6052: @327709
     /*  327709 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(327772), // Rule ID 20161 //
     /*  327714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327770 */     GIR_RootConstrainSelectedInstOperands,
     /*  327771 */     // GIR_Coverage, 20161,
     /*  327771 */     GIR_EraseRootFromParent_Done,
     /*  327772 */   // Label 6053: @327772
     /*  327772 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(327835), // Rule ID 20164 //
     /*  327777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327833 */     GIR_RootConstrainSelectedInstOperands,
     /*  327834 */     // GIR_Coverage, 20164,
     /*  327834 */     GIR_EraseRootFromParent_Done,
     /*  327835 */   // Label 6054: @327835
     /*  327835 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(327898), // Rule ID 20165 //
     /*  327840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327896 */     GIR_RootConstrainSelectedInstOperands,
     /*  327897 */     // GIR_Coverage, 20165,
     /*  327897 */     GIR_EraseRootFromParent_Done,
     /*  327898 */   // Label 6055: @327898
     /*  327898 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(327961), // Rule ID 20168 //
     /*  327903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327959 */     GIR_RootConstrainSelectedInstOperands,
     /*  327960 */     // GIR_Coverage, 20168,
     /*  327960 */     GIR_EraseRootFromParent_Done,
     /*  327961 */   // Label 6056: @327961
     /*  327961 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(328024), // Rule ID 20169 //
     /*  327966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328005 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328022 */     GIR_RootConstrainSelectedInstOperands,
     /*  328023 */     // GIR_Coverage, 20169,
     /*  328023 */     GIR_EraseRootFromParent_Done,
     /*  328024 */   // Label 6057: @328024
     /*  328024 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(328087), // Rule ID 20172 //
     /*  328029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  328043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  328046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328085 */     GIR_RootConstrainSelectedInstOperands,
     /*  328086 */     // GIR_Coverage, 20172,
     /*  328086 */     GIR_EraseRootFromParent_Done,
     /*  328087 */   // Label 6058: @328087
     /*  328087 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(328150), // Rule ID 20173 //
     /*  328092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  328106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  328109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328148 */     GIR_RootConstrainSelectedInstOperands,
     /*  328149 */     // GIR_Coverage, 20173,
     /*  328149 */     GIR_EraseRootFromParent_Done,
     /*  328150 */   // Label 6059: @328150
     /*  328150 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(328213), // Rule ID 20176 //
     /*  328155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  328169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  328172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328211 */     GIR_RootConstrainSelectedInstOperands,
     /*  328212 */     // GIR_Coverage, 20176,
     /*  328212 */     GIR_EraseRootFromParent_Done,
     /*  328213 */   // Label 6060: @328213
     /*  328213 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(328276), // Rule ID 20177 //
     /*  328218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  328232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  328235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328257 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328274 */     GIR_RootConstrainSelectedInstOperands,
     /*  328275 */     // GIR_Coverage, 20177,
     /*  328275 */     GIR_EraseRootFromParent_Done,
     /*  328276 */   // Label 6061: @328276
     /*  328276 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(328339), // Rule ID 20180 //
     /*  328281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  328295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  328298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328337 */     GIR_RootConstrainSelectedInstOperands,
     /*  328338 */     // GIR_Coverage, 20180,
     /*  328338 */     GIR_EraseRootFromParent_Done,
     /*  328339 */   // Label 6062: @328339
     /*  328339 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(328402), // Rule ID 20181 //
     /*  328344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  328358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  328361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328400 */     GIR_RootConstrainSelectedInstOperands,
     /*  328401 */     // GIR_Coverage, 20181,
     /*  328401 */     GIR_EraseRootFromParent_Done,
     /*  328402 */   // Label 6063: @328402
     /*  328402 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(328465), // Rule ID 20184 //
     /*  328407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328463 */     GIR_RootConstrainSelectedInstOperands,
     /*  328464 */     // GIR_Coverage, 20184,
     /*  328464 */     GIR_EraseRootFromParent_Done,
     /*  328465 */   // Label 6064: @328465
     /*  328465 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(328528), // Rule ID 20185 //
     /*  328470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328526 */     GIR_RootConstrainSelectedInstOperands,
     /*  328527 */     // GIR_Coverage, 20185,
     /*  328527 */     GIR_EraseRootFromParent_Done,
     /*  328528 */   // Label 6065: @328528
     /*  328528 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(328591), // Rule ID 20188 //
     /*  328533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328589 */     GIR_RootConstrainSelectedInstOperands,
     /*  328590 */     // GIR_Coverage, 20188,
     /*  328590 */     GIR_EraseRootFromParent_Done,
     /*  328591 */   // Label 6066: @328591
     /*  328591 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(328654), // Rule ID 20189 //
     /*  328596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328652 */     GIR_RootConstrainSelectedInstOperands,
     /*  328653 */     // GIR_Coverage, 20189,
     /*  328653 */     GIR_EraseRootFromParent_Done,
     /*  328654 */   // Label 6067: @328654
     /*  328654 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(328717), // Rule ID 20192 //
     /*  328659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328715 */     GIR_RootConstrainSelectedInstOperands,
     /*  328716 */     // GIR_Coverage, 20192,
     /*  328716 */     GIR_EraseRootFromParent_Done,
     /*  328717 */   // Label 6068: @328717
     /*  328717 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(328780), // Rule ID 20193 //
     /*  328722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328778 */     GIR_RootConstrainSelectedInstOperands,
     /*  328779 */     // GIR_Coverage, 20193,
     /*  328779 */     GIR_EraseRootFromParent_Done,
     /*  328780 */   // Label 6069: @328780
     /*  328780 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(328843), // Rule ID 20196 //
     /*  328785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328841 */     GIR_RootConstrainSelectedInstOperands,
     /*  328842 */     // GIR_Coverage, 20196,
     /*  328842 */     GIR_EraseRootFromParent_Done,
     /*  328843 */   // Label 6070: @328843
     /*  328843 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(328906), // Rule ID 20197 //
     /*  328848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328904 */     GIR_RootConstrainSelectedInstOperands,
     /*  328905 */     // GIR_Coverage, 20197,
     /*  328905 */     GIR_EraseRootFromParent_Done,
     /*  328906 */   // Label 6071: @328906
     /*  328906 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(328969), // Rule ID 20200 //
     /*  328911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328967 */     GIR_RootConstrainSelectedInstOperands,
     /*  328968 */     // GIR_Coverage, 20200,
     /*  328968 */     GIR_EraseRootFromParent_Done,
     /*  328969 */   // Label 6072: @328969
     /*  328969 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(329032), // Rule ID 20201 //
     /*  328974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  329016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329030 */     GIR_RootConstrainSelectedInstOperands,
     /*  329031 */     // GIR_Coverage, 20201,
     /*  329031 */     GIR_EraseRootFromParent_Done,
     /*  329032 */   // Label 6073: @329032
     /*  329032 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(329095), // Rule ID 20204 //
     /*  329037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  329051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  329079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329093 */     GIR_RootConstrainSelectedInstOperands,
     /*  329094 */     // GIR_Coverage, 20204,
     /*  329094 */     GIR_EraseRootFromParent_Done,
     /*  329095 */   // Label 6074: @329095
     /*  329095 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(329158), // Rule ID 20205 //
     /*  329100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  329114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  329142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329156 */     GIR_RootConstrainSelectedInstOperands,
     /*  329157 */     // GIR_Coverage, 20205,
     /*  329157 */     GIR_EraseRootFromParent_Done,
     /*  329158 */   // Label 6075: @329158
     /*  329158 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(329221), // Rule ID 20208 //
     /*  329163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  329177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329202 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  329205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329219 */     GIR_RootConstrainSelectedInstOperands,
     /*  329220 */     // GIR_Coverage, 20208,
     /*  329220 */     GIR_EraseRootFromParent_Done,
     /*  329221 */   // Label 6076: @329221
     /*  329221 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(329284), // Rule ID 20209 //
     /*  329226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  329240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329265 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  329268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329282 */     GIR_RootConstrainSelectedInstOperands,
     /*  329283 */     // GIR_Coverage, 20209,
     /*  329283 */     GIR_EraseRootFromParent_Done,
     /*  329284 */   // Label 6077: @329284
     /*  329284 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(329347), // Rule ID 20212 //
     /*  329289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  329303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  329331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329345 */     GIR_RootConstrainSelectedInstOperands,
     /*  329346 */     // GIR_Coverage, 20212,
     /*  329346 */     GIR_EraseRootFromParent_Done,
     /*  329347 */   // Label 6078: @329347
     /*  329347 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(329410), // Rule ID 20213 //
     /*  329352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  329366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  329394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329408 */     GIR_RootConstrainSelectedInstOperands,
     /*  329409 */     // GIR_Coverage, 20213,
     /*  329409 */     GIR_EraseRootFromParent_Done,
     /*  329410 */   // Label 6079: @329410
     /*  329410 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(329473), // Rule ID 20216 //
     /*  329415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329471 */     GIR_RootConstrainSelectedInstOperands,
     /*  329472 */     // GIR_Coverage, 20216,
     /*  329472 */     GIR_EraseRootFromParent_Done,
     /*  329473 */   // Label 6080: @329473
     /*  329473 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(329536), // Rule ID 20217 //
     /*  329478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329534 */     GIR_RootConstrainSelectedInstOperands,
     /*  329535 */     // GIR_Coverage, 20217,
     /*  329535 */     GIR_EraseRootFromParent_Done,
     /*  329536 */   // Label 6081: @329536
     /*  329536 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(329599), // Rule ID 20220 //
     /*  329541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329597 */     GIR_RootConstrainSelectedInstOperands,
     /*  329598 */     // GIR_Coverage, 20220,
     /*  329598 */     GIR_EraseRootFromParent_Done,
     /*  329599 */   // Label 6082: @329599
     /*  329599 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(329662), // Rule ID 20221 //
     /*  329604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329660 */     GIR_RootConstrainSelectedInstOperands,
     /*  329661 */     // GIR_Coverage, 20221,
     /*  329661 */     GIR_EraseRootFromParent_Done,
     /*  329662 */   // Label 6083: @329662
     /*  329662 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(329725), // Rule ID 20224 //
     /*  329667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329723 */     GIR_RootConstrainSelectedInstOperands,
     /*  329724 */     // GIR_Coverage, 20224,
     /*  329724 */     GIR_EraseRootFromParent_Done,
     /*  329725 */   // Label 6084: @329725
     /*  329725 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(329788), // Rule ID 20225 //
     /*  329730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329769 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329786 */     GIR_RootConstrainSelectedInstOperands,
     /*  329787 */     // GIR_Coverage, 20225,
     /*  329787 */     GIR_EraseRootFromParent_Done,
     /*  329788 */   // Label 6085: @329788
     /*  329788 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(329851), // Rule ID 20228 //
     /*  329793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329832 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329849 */     GIR_RootConstrainSelectedInstOperands,
     /*  329850 */     // GIR_Coverage, 20228,
     /*  329850 */     GIR_EraseRootFromParent_Done,
     /*  329851 */   // Label 6086: @329851
     /*  329851 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(329914), // Rule ID 20229 //
     /*  329856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329895 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329912 */     GIR_RootConstrainSelectedInstOperands,
     /*  329913 */     // GIR_Coverage, 20229,
     /*  329913 */     GIR_EraseRootFromParent_Done,
     /*  329914 */   // Label 6087: @329914
     /*  329914 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(329977), // Rule ID 20232 //
     /*  329919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329975 */     GIR_RootConstrainSelectedInstOperands,
     /*  329976 */     // GIR_Coverage, 20232,
     /*  329976 */     GIR_EraseRootFromParent_Done,
     /*  329977 */   // Label 6088: @329977
     /*  329977 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(330040), // Rule ID 20233 //
     /*  329982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  330024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330038 */     GIR_RootConstrainSelectedInstOperands,
     /*  330039 */     // GIR_Coverage, 20233,
     /*  330039 */     GIR_EraseRootFromParent_Done,
     /*  330040 */   // Label 6089: @330040
     /*  330040 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(330103), // Rule ID 20236 //
     /*  330045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  330087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330101 */     GIR_RootConstrainSelectedInstOperands,
     /*  330102 */     // GIR_Coverage, 20236,
     /*  330102 */     GIR_EraseRootFromParent_Done,
     /*  330103 */   // Label 6090: @330103
     /*  330103 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(330166), // Rule ID 20237 //
     /*  330108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  330150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330164 */     GIR_RootConstrainSelectedInstOperands,
     /*  330165 */     // GIR_Coverage, 20237,
     /*  330165 */     GIR_EraseRootFromParent_Done,
     /*  330166 */   // Label 6091: @330166
     /*  330166 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(330229), // Rule ID 20240 //
     /*  330171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  330185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  330213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330227 */     GIR_RootConstrainSelectedInstOperands,
     /*  330228 */     // GIR_Coverage, 20240,
     /*  330228 */     GIR_EraseRootFromParent_Done,
     /*  330229 */   // Label 6092: @330229
     /*  330229 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(330292), // Rule ID 20241 //
     /*  330234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  330248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  330276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330290 */     GIR_RootConstrainSelectedInstOperands,
     /*  330291 */     // GIR_Coverage, 20241,
     /*  330291 */     GIR_EraseRootFromParent_Done,
     /*  330292 */   // Label 6093: @330292
     /*  330292 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(330355), // Rule ID 20244 //
     /*  330297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  330311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  330339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330353 */     GIR_RootConstrainSelectedInstOperands,
     /*  330354 */     // GIR_Coverage, 20244,
     /*  330354 */     GIR_EraseRootFromParent_Done,
     /*  330355 */   // Label 6094: @330355
     /*  330355 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(330418), // Rule ID 20245 //
     /*  330360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  330374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  330402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330416 */     GIR_RootConstrainSelectedInstOperands,
     /*  330417 */     // GIR_Coverage, 20245,
     /*  330417 */     GIR_EraseRootFromParent_Done,
     /*  330418 */   // Label 6095: @330418
     /*  330418 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(330481), // Rule ID 20248 //
     /*  330423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330479 */     GIR_RootConstrainSelectedInstOperands,
     /*  330480 */     // GIR_Coverage, 20248,
     /*  330480 */     GIR_EraseRootFromParent_Done,
     /*  330481 */   // Label 6096: @330481
     /*  330481 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(330544), // Rule ID 20249 //
     /*  330486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330542 */     GIR_RootConstrainSelectedInstOperands,
     /*  330543 */     // GIR_Coverage, 20249,
     /*  330543 */     GIR_EraseRootFromParent_Done,
     /*  330544 */   // Label 6097: @330544
     /*  330544 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(330607), // Rule ID 20252 //
     /*  330549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330605 */     GIR_RootConstrainSelectedInstOperands,
     /*  330606 */     // GIR_Coverage, 20252,
     /*  330606 */     GIR_EraseRootFromParent_Done,
     /*  330607 */   // Label 6098: @330607
     /*  330607 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(330670), // Rule ID 20253 //
     /*  330612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330668 */     GIR_RootConstrainSelectedInstOperands,
     /*  330669 */     // GIR_Coverage, 20253,
     /*  330669 */     GIR_EraseRootFromParent_Done,
     /*  330670 */   // Label 6099: @330670
     /*  330670 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(330733), // Rule ID 20256 //
     /*  330675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330714 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330731 */     GIR_RootConstrainSelectedInstOperands,
     /*  330732 */     // GIR_Coverage, 20256,
     /*  330732 */     GIR_EraseRootFromParent_Done,
     /*  330733 */   // Label 6100: @330733
     /*  330733 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(330796), // Rule ID 20257 //
     /*  330738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330777 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330794 */     GIR_RootConstrainSelectedInstOperands,
     /*  330795 */     // GIR_Coverage, 20257,
     /*  330795 */     GIR_EraseRootFromParent_Done,
     /*  330796 */   // Label 6101: @330796
     /*  330796 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(330859), // Rule ID 20260 //
     /*  330801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330857 */     GIR_RootConstrainSelectedInstOperands,
     /*  330858 */     // GIR_Coverage, 20260,
     /*  330858 */     GIR_EraseRootFromParent_Done,
     /*  330859 */   // Label 6102: @330859
     /*  330859 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(330922), // Rule ID 20261 //
     /*  330864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330920 */     GIR_RootConstrainSelectedInstOperands,
     /*  330921 */     // GIR_Coverage, 20261,
     /*  330921 */     GIR_EraseRootFromParent_Done,
     /*  330922 */   // Label 6103: @330922
     /*  330922 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(330985), // Rule ID 20264 //
     /*  330927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330966 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330983 */     GIR_RootConstrainSelectedInstOperands,
     /*  330984 */     // GIR_Coverage, 20264,
     /*  330984 */     GIR_EraseRootFromParent_Done,
     /*  330985 */   // Label 6104: @330985
     /*  330985 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(331048), // Rule ID 20265 //
     /*  330990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331029 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  331032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331046 */     GIR_RootConstrainSelectedInstOperands,
     /*  331047 */     // GIR_Coverage, 20265,
     /*  331047 */     GIR_EraseRootFromParent_Done,
     /*  331048 */   // Label 6105: @331048
     /*  331048 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(331111), // Rule ID 20268 //
     /*  331053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  331067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  331095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331109 */     GIR_RootConstrainSelectedInstOperands,
     /*  331110 */     // GIR_Coverage, 20268,
     /*  331110 */     GIR_EraseRootFromParent_Done,
     /*  331111 */   // Label 6106: @331111
     /*  331111 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(331174), // Rule ID 20269 //
     /*  331116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  331130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331155 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  331158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331172 */     GIR_RootConstrainSelectedInstOperands,
     /*  331173 */     // GIR_Coverage, 20269,
     /*  331173 */     GIR_EraseRootFromParent_Done,
     /*  331174 */   // Label 6107: @331174
     /*  331174 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(331237), // Rule ID 20272 //
     /*  331179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  331221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331235 */     GIR_RootConstrainSelectedInstOperands,
     /*  331236 */     // GIR_Coverage, 20272,
     /*  331236 */     GIR_EraseRootFromParent_Done,
     /*  331237 */   // Label 6108: @331237
     /*  331237 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(331300), // Rule ID 20273 //
     /*  331242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  331256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  331284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331298 */     GIR_RootConstrainSelectedInstOperands,
     /*  331299 */     // GIR_Coverage, 20273,
     /*  331299 */     GIR_EraseRootFromParent_Done,
     /*  331300 */   // Label 6109: @331300
     /*  331300 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(331363), // Rule ID 20276 //
     /*  331305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  331319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  331347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331361 */     GIR_RootConstrainSelectedInstOperands,
     /*  331362 */     // GIR_Coverage, 20276,
     /*  331362 */     GIR_EraseRootFromParent_Done,
     /*  331363 */   // Label 6110: @331363
     /*  331363 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(331426), // Rule ID 20277 //
     /*  331368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  331382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  331410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331424 */     GIR_RootConstrainSelectedInstOperands,
     /*  331425 */     // GIR_Coverage, 20277,
     /*  331425 */     GIR_EraseRootFromParent_Done,
     /*  331426 */   // Label 6111: @331426
     /*  331426 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(331489), // Rule ID 20280 //
     /*  331431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331487 */     GIR_RootConstrainSelectedInstOperands,
     /*  331488 */     // GIR_Coverage, 20280,
     /*  331488 */     GIR_EraseRootFromParent_Done,
     /*  331489 */   // Label 6112: @331489
     /*  331489 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(331552), // Rule ID 20281 //
     /*  331494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331533 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331550 */     GIR_RootConstrainSelectedInstOperands,
     /*  331551 */     // GIR_Coverage, 20281,
     /*  331551 */     GIR_EraseRootFromParent_Done,
     /*  331552 */   // Label 6113: @331552
     /*  331552 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(331615), // Rule ID 20284 //
     /*  331557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331596 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331613 */     GIR_RootConstrainSelectedInstOperands,
     /*  331614 */     // GIR_Coverage, 20284,
     /*  331614 */     GIR_EraseRootFromParent_Done,
     /*  331615 */   // Label 6114: @331615
     /*  331615 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(331678), // Rule ID 20285 //
     /*  331620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331659 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331676 */     GIR_RootConstrainSelectedInstOperands,
     /*  331677 */     // GIR_Coverage, 20285,
     /*  331677 */     GIR_EraseRootFromParent_Done,
     /*  331678 */   // Label 6115: @331678
     /*  331678 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(331741), // Rule ID 20288 //
     /*  331683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331722 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331739 */     GIR_RootConstrainSelectedInstOperands,
     /*  331740 */     // GIR_Coverage, 20288,
     /*  331740 */     GIR_EraseRootFromParent_Done,
     /*  331741 */   // Label 6116: @331741
     /*  331741 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(331804), // Rule ID 20289 //
     /*  331746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331785 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331802 */     GIR_RootConstrainSelectedInstOperands,
     /*  331803 */     // GIR_Coverage, 20289,
     /*  331803 */     GIR_EraseRootFromParent_Done,
     /*  331804 */   // Label 6117: @331804
     /*  331804 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(331867), // Rule ID 20292 //
     /*  331809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331865 */     GIR_RootConstrainSelectedInstOperands,
     /*  331866 */     // GIR_Coverage, 20292,
     /*  331866 */     GIR_EraseRootFromParent_Done,
     /*  331867 */   // Label 6118: @331867
     /*  331867 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(331930), // Rule ID 20293 //
     /*  331872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331911 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331928 */     GIR_RootConstrainSelectedInstOperands,
     /*  331929 */     // GIR_Coverage, 20293,
     /*  331929 */     GIR_EraseRootFromParent_Done,
     /*  331930 */   // Label 6119: @331930
     /*  331930 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(331993), // Rule ID 20296 //
     /*  331935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331991 */     GIR_RootConstrainSelectedInstOperands,
     /*  331992 */     // GIR_Coverage, 20296,
     /*  331992 */     GIR_EraseRootFromParent_Done,
     /*  331993 */   // Label 6120: @331993
     /*  331993 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(332056), // Rule ID 20297 //
     /*  331998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  332012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332037 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  332040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332054 */     GIR_RootConstrainSelectedInstOperands,
     /*  332055 */     // GIR_Coverage, 20297,
     /*  332055 */     GIR_EraseRootFromParent_Done,
     /*  332056 */   // Label 6121: @332056
     /*  332056 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(332119), // Rule ID 20300 //
     /*  332061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  332075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  332103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332117 */     GIR_RootConstrainSelectedInstOperands,
     /*  332118 */     // GIR_Coverage, 20300,
     /*  332118 */     GIR_EraseRootFromParent_Done,
     /*  332119 */   // Label 6122: @332119
     /*  332119 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(332182), // Rule ID 20301 //
     /*  332124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  332138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332163 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  332166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332180 */     GIR_RootConstrainSelectedInstOperands,
     /*  332181 */     // GIR_Coverage, 20301,
     /*  332181 */     GIR_EraseRootFromParent_Done,
     /*  332182 */   // Label 6123: @332182
     /*  332182 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(332245), // Rule ID 20304 //
     /*  332187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  332201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  332229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332243 */     GIR_RootConstrainSelectedInstOperands,
     /*  332244 */     // GIR_Coverage, 20304,
     /*  332244 */     GIR_EraseRootFromParent_Done,
     /*  332245 */   // Label 6124: @332245
     /*  332245 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(332308), // Rule ID 20305 //
     /*  332250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  332264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332289 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  332292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332306 */     GIR_RootConstrainSelectedInstOperands,
     /*  332307 */     // GIR_Coverage, 20305,
     /*  332307 */     GIR_EraseRootFromParent_Done,
     /*  332308 */   // Label 6125: @332308
     /*  332308 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(332371), // Rule ID 20308 //
     /*  332313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  332327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  332355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332369 */     GIR_RootConstrainSelectedInstOperands,
     /*  332370 */     // GIR_Coverage, 20308,
     /*  332370 */     GIR_EraseRootFromParent_Done,
     /*  332371 */   // Label 6126: @332371
     /*  332371 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(332434), // Rule ID 20309 //
     /*  332376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  332390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  332418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332432 */     GIR_RootConstrainSelectedInstOperands,
     /*  332433 */     // GIR_Coverage, 20309,
     /*  332433 */     GIR_EraseRootFromParent_Done,
     /*  332434 */   // Label 6127: @332434
     /*  332434 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(332497), // Rule ID 20312 //
     /*  332439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332495 */     GIR_RootConstrainSelectedInstOperands,
     /*  332496 */     // GIR_Coverage, 20312,
     /*  332496 */     GIR_EraseRootFromParent_Done,
     /*  332497 */   // Label 6128: @332497
     /*  332497 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(332560), // Rule ID 20313 //
     /*  332502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332541 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332558 */     GIR_RootConstrainSelectedInstOperands,
     /*  332559 */     // GIR_Coverage, 20313,
     /*  332559 */     GIR_EraseRootFromParent_Done,
     /*  332560 */   // Label 6129: @332560
     /*  332560 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(332623), // Rule ID 20316 //
     /*  332565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332621 */     GIR_RootConstrainSelectedInstOperands,
     /*  332622 */     // GIR_Coverage, 20316,
     /*  332622 */     GIR_EraseRootFromParent_Done,
     /*  332623 */   // Label 6130: @332623
     /*  332623 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(332686), // Rule ID 20317 //
     /*  332628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332667 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332684 */     GIR_RootConstrainSelectedInstOperands,
     /*  332685 */     // GIR_Coverage, 20317,
     /*  332685 */     GIR_EraseRootFromParent_Done,
     /*  332686 */   // Label 6131: @332686
     /*  332686 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(332749), // Rule ID 20320 //
     /*  332691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332730 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332747 */     GIR_RootConstrainSelectedInstOperands,
     /*  332748 */     // GIR_Coverage, 20320,
     /*  332748 */     GIR_EraseRootFromParent_Done,
     /*  332749 */   // Label 6132: @332749
     /*  332749 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(332812), // Rule ID 20321 //
     /*  332754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332793 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332810 */     GIR_RootConstrainSelectedInstOperands,
     /*  332811 */     // GIR_Coverage, 20321,
     /*  332811 */     GIR_EraseRootFromParent_Done,
     /*  332812 */   // Label 6133: @332812
     /*  332812 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(332875), // Rule ID 20324 //
     /*  332817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332873 */     GIR_RootConstrainSelectedInstOperands,
     /*  332874 */     // GIR_Coverage, 20324,
     /*  332874 */     GIR_EraseRootFromParent_Done,
     /*  332875 */   // Label 6134: @332875
     /*  332875 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(332938), // Rule ID 20325 //
     /*  332880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332919 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332936 */     GIR_RootConstrainSelectedInstOperands,
     /*  332937 */     // GIR_Coverage, 20325,
     /*  332937 */     GIR_EraseRootFromParent_Done,
     /*  332938 */   // Label 6135: @332938
     /*  332938 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(333001), // Rule ID 20328 //
     /*  332943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332999 */     GIR_RootConstrainSelectedInstOperands,
     /*  333000 */     // GIR_Coverage, 20328,
     /*  333000 */     GIR_EraseRootFromParent_Done,
     /*  333001 */   // Label 6136: @333001
     /*  333001 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(333064), // Rule ID 20329 //
     /*  333006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333045 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  333048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333062 */     GIR_RootConstrainSelectedInstOperands,
     /*  333063 */     // GIR_Coverage, 20329,
     /*  333063 */     GIR_EraseRootFromParent_Done,
     /*  333064 */   // Label 6137: @333064
     /*  333064 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(333127), // Rule ID 20332 //
     /*  333069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  333111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333125 */     GIR_RootConstrainSelectedInstOperands,
     /*  333126 */     // GIR_Coverage, 20332,
     /*  333126 */     GIR_EraseRootFromParent_Done,
     /*  333127 */   // Label 6138: @333127
     /*  333127 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(333190), // Rule ID 20333 //
     /*  333132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  333174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333188 */     GIR_RootConstrainSelectedInstOperands,
     /*  333189 */     // GIR_Coverage, 20333,
     /*  333189 */     GIR_EraseRootFromParent_Done,
     /*  333190 */   // Label 6139: @333190
     /*  333190 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(333253), // Rule ID 20336 //
     /*  333195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  333237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333251 */     GIR_RootConstrainSelectedInstOperands,
     /*  333252 */     // GIR_Coverage, 20336,
     /*  333252 */     GIR_EraseRootFromParent_Done,
     /*  333253 */   // Label 6140: @333253
     /*  333253 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(333316), // Rule ID 20337 //
     /*  333258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  333272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  333300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333314 */     GIR_RootConstrainSelectedInstOperands,
     /*  333315 */     // GIR_Coverage, 20337,
     /*  333315 */     GIR_EraseRootFromParent_Done,
     /*  333316 */   // Label 6141: @333316
     /*  333316 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(333379), // Rule ID 20340 //
     /*  333321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  333335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  333363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333377 */     GIR_RootConstrainSelectedInstOperands,
     /*  333378 */     // GIR_Coverage, 20340,
     /*  333378 */     GIR_EraseRootFromParent_Done,
     /*  333379 */   // Label 6142: @333379
     /*  333379 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(333442), // Rule ID 20341 //
     /*  333384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  333398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333423 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  333426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333440 */     GIR_RootConstrainSelectedInstOperands,
     /*  333441 */     // GIR_Coverage, 20341,
     /*  333441 */     GIR_EraseRootFromParent_Done,
     /*  333442 */   // Label 6143: @333442
     /*  333442 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(333505), // Rule ID 20344 //
     /*  333447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333486 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333503 */     GIR_RootConstrainSelectedInstOperands,
     /*  333504 */     // GIR_Coverage, 20344,
     /*  333504 */     GIR_EraseRootFromParent_Done,
     /*  333505 */   // Label 6144: @333505
     /*  333505 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(333568), // Rule ID 20345 //
     /*  333510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333566 */     GIR_RootConstrainSelectedInstOperands,
     /*  333567 */     // GIR_Coverage, 20345,
     /*  333567 */     GIR_EraseRootFromParent_Done,
     /*  333568 */   // Label 6145: @333568
     /*  333568 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(333631), // Rule ID 20348 //
     /*  333573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333612 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333629 */     GIR_RootConstrainSelectedInstOperands,
     /*  333630 */     // GIR_Coverage, 20348,
     /*  333630 */     GIR_EraseRootFromParent_Done,
     /*  333631 */   // Label 6146: @333631
     /*  333631 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(333694), // Rule ID 20349 //
     /*  333636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333675 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333692 */     GIR_RootConstrainSelectedInstOperands,
     /*  333693 */     // GIR_Coverage, 20349,
     /*  333693 */     GIR_EraseRootFromParent_Done,
     /*  333694 */   // Label 6147: @333694
     /*  333694 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(333757), // Rule ID 20352 //
     /*  333699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333738 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333755 */     GIR_RootConstrainSelectedInstOperands,
     /*  333756 */     // GIR_Coverage, 20352,
     /*  333756 */     GIR_EraseRootFromParent_Done,
     /*  333757 */   // Label 6148: @333757
     /*  333757 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(333820), // Rule ID 20353 //
     /*  333762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333801 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333818 */     GIR_RootConstrainSelectedInstOperands,
     /*  333819 */     // GIR_Coverage, 20353,
     /*  333819 */     GIR_EraseRootFromParent_Done,
     /*  333820 */   // Label 6149: @333820
     /*  333820 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(333883), // Rule ID 20356 //
     /*  333825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333881 */     GIR_RootConstrainSelectedInstOperands,
     /*  333882 */     // GIR_Coverage, 20356,
     /*  333882 */     GIR_EraseRootFromParent_Done,
     /*  333883 */   // Label 6150: @333883
     /*  333883 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(333946), // Rule ID 20357 //
     /*  333888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333927 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333944 */     GIR_RootConstrainSelectedInstOperands,
     /*  333945 */     // GIR_Coverage, 20357,
     /*  333945 */     GIR_EraseRootFromParent_Done,
     /*  333946 */   // Label 6151: @333946
     /*  333946 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(334009), // Rule ID 20360 //
     /*  333951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334007 */     GIR_RootConstrainSelectedInstOperands,
     /*  334008 */     // GIR_Coverage, 20360,
     /*  334008 */     GIR_EraseRootFromParent_Done,
     /*  334009 */   // Label 6152: @334009
     /*  334009 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(334072), // Rule ID 20361 //
     /*  334014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  334028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334053 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  334056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334070 */     GIR_RootConstrainSelectedInstOperands,
     /*  334071 */     // GIR_Coverage, 20361,
     /*  334071 */     GIR_EraseRootFromParent_Done,
     /*  334072 */   // Label 6153: @334072
     /*  334072 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(334135), // Rule ID 20364 //
     /*  334077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  334091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  334119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334133 */     GIR_RootConstrainSelectedInstOperands,
     /*  334134 */     // GIR_Coverage, 20364,
     /*  334134 */     GIR_EraseRootFromParent_Done,
     /*  334135 */   // Label 6154: @334135
     /*  334135 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(334198), // Rule ID 20365 //
     /*  334140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  334154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334179 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  334182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334196 */     GIR_RootConstrainSelectedInstOperands,
     /*  334197 */     // GIR_Coverage, 20365,
     /*  334197 */     GIR_EraseRootFromParent_Done,
     /*  334198 */   // Label 6155: @334198
     /*  334198 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(334261), // Rule ID 20368 //
     /*  334203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  334217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  334245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334259 */     GIR_RootConstrainSelectedInstOperands,
     /*  334260 */     // GIR_Coverage, 20368,
     /*  334260 */     GIR_EraseRootFromParent_Done,
     /*  334261 */   // Label 6156: @334261
     /*  334261 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(334324), // Rule ID 20369 //
     /*  334266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  334280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334305 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  334308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334322 */     GIR_RootConstrainSelectedInstOperands,
     /*  334323 */     // GIR_Coverage, 20369,
     /*  334323 */     GIR_EraseRootFromParent_Done,
     /*  334324 */   // Label 6157: @334324
     /*  334324 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(334387), // Rule ID 20372 //
     /*  334329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  334371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334385 */     GIR_RootConstrainSelectedInstOperands,
     /*  334386 */     // GIR_Coverage, 20372,
     /*  334386 */     GIR_EraseRootFromParent_Done,
     /*  334387 */   // Label 6158: @334387
     /*  334387 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(334450), // Rule ID 20373 //
     /*  334392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  334400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334431 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  334434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334448 */     GIR_RootConstrainSelectedInstOperands,
     /*  334449 */     // GIR_Coverage, 20373,
     /*  334449 */     GIR_EraseRootFromParent_Done,
     /*  334450 */   // Label 6159: @334450
     /*  334450 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(334513), // Rule ID 20376 //
     /*  334455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334511 */     GIR_RootConstrainSelectedInstOperands,
     /*  334512 */     // GIR_Coverage, 20376,
     /*  334512 */     GIR_EraseRootFromParent_Done,
     /*  334513 */   // Label 6160: @334513
     /*  334513 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(334576), // Rule ID 20377 //
     /*  334518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334557 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334574 */     GIR_RootConstrainSelectedInstOperands,
     /*  334575 */     // GIR_Coverage, 20377,
     /*  334575 */     GIR_EraseRootFromParent_Done,
     /*  334576 */   // Label 6161: @334576
     /*  334576 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(334639), // Rule ID 20380 //
     /*  334581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334637 */     GIR_RootConstrainSelectedInstOperands,
     /*  334638 */     // GIR_Coverage, 20380,
     /*  334638 */     GIR_EraseRootFromParent_Done,
     /*  334639 */   // Label 6162: @334639
     /*  334639 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(334702), // Rule ID 20381 //
     /*  334644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334683 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334700 */     GIR_RootConstrainSelectedInstOperands,
     /*  334701 */     // GIR_Coverage, 20381,
     /*  334701 */     GIR_EraseRootFromParent_Done,
     /*  334702 */   // Label 6163: @334702
     /*  334702 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(334765), // Rule ID 20384 //
     /*  334707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334763 */     GIR_RootConstrainSelectedInstOperands,
     /*  334764 */     // GIR_Coverage, 20384,
     /*  334764 */     GIR_EraseRootFromParent_Done,
     /*  334765 */   // Label 6164: @334765
     /*  334765 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(334828), // Rule ID 20385 //
     /*  334770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334809 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334826 */     GIR_RootConstrainSelectedInstOperands,
     /*  334827 */     // GIR_Coverage, 20385,
     /*  334827 */     GIR_EraseRootFromParent_Done,
     /*  334828 */   // Label 6165: @334828
     /*  334828 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(334891), // Rule ID 20388 //
     /*  334833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334889 */     GIR_RootConstrainSelectedInstOperands,
     /*  334890 */     // GIR_Coverage, 20388,
     /*  334890 */     GIR_EraseRootFromParent_Done,
     /*  334891 */   // Label 6166: @334891
     /*  334891 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(334954), // Rule ID 20389 //
     /*  334896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334935 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334952 */     GIR_RootConstrainSelectedInstOperands,
     /*  334953 */     // GIR_Coverage, 20389,
     /*  334953 */     GIR_EraseRootFromParent_Done,
     /*  334954 */   // Label 6167: @334954
     /*  334954 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(335017), // Rule ID 20392 //
     /*  334959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335015 */     GIR_RootConstrainSelectedInstOperands,
     /*  335016 */     // GIR_Coverage, 20392,
     /*  335016 */     GIR_EraseRootFromParent_Done,
     /*  335017 */   // Label 6168: @335017
     /*  335017 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(335080), // Rule ID 20393 //
     /*  335022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  335036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  335039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335061 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335078 */     GIR_RootConstrainSelectedInstOperands,
     /*  335079 */     // GIR_Coverage, 20393,
     /*  335079 */     GIR_EraseRootFromParent_Done,
     /*  335080 */   // Label 6169: @335080
     /*  335080 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(335143), // Rule ID 20396 //
     /*  335085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  335099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  335102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335141 */     GIR_RootConstrainSelectedInstOperands,
     /*  335142 */     // GIR_Coverage, 20396,
     /*  335142 */     GIR_EraseRootFromParent_Done,
     /*  335143 */   // Label 6170: @335143
     /*  335143 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(335206), // Rule ID 20397 //
     /*  335148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  335162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  335165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  335190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335204 */     GIR_RootConstrainSelectedInstOperands,
     /*  335205 */     // GIR_Coverage, 20397,
     /*  335205 */     GIR_EraseRootFromParent_Done,
     /*  335206 */   // Label 6171: @335206
     /*  335206 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(335269), // Rule ID 20400 //
     /*  335211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  335225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  335228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335267 */     GIR_RootConstrainSelectedInstOperands,
     /*  335268 */     // GIR_Coverage, 20400,
     /*  335268 */     GIR_EraseRootFromParent_Done,
     /*  335269 */   // Label 6172: @335269
     /*  335269 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(335332), // Rule ID 20401 //
     /*  335274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  335288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  335291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335313 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335330 */     GIR_RootConstrainSelectedInstOperands,
     /*  335331 */     // GIR_Coverage, 20401,
     /*  335331 */     GIR_EraseRootFromParent_Done,
     /*  335332 */   // Label 6173: @335332
     /*  335332 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(335395), // Rule ID 20404 //
     /*  335337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  335354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335393 */     GIR_RootConstrainSelectedInstOperands,
     /*  335394 */     // GIR_Coverage, 20404,
     /*  335394 */     GIR_EraseRootFromParent_Done,
     /*  335395 */   // Label 6174: @335395
     /*  335395 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(335458), // Rule ID 20405 //
     /*  335400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  335417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335439 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335456 */     GIR_RootConstrainSelectedInstOperands,
     /*  335457 */     // GIR_Coverage, 20405,
     /*  335457 */     GIR_EraseRootFromParent_Done,
     /*  335458 */   // Label 6175: @335458
     /*  335458 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(335521), // Rule ID 20408 //
     /*  335463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335519 */     GIR_RootConstrainSelectedInstOperands,
     /*  335520 */     // GIR_Coverage, 20408,
     /*  335520 */     GIR_EraseRootFromParent_Done,
     /*  335521 */   // Label 6176: @335521
     /*  335521 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(335584), // Rule ID 20409 //
     /*  335526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335565 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335582 */     GIR_RootConstrainSelectedInstOperands,
     /*  335583 */     // GIR_Coverage, 20409,
     /*  335583 */     GIR_EraseRootFromParent_Done,
     /*  335584 */   // Label 6177: @335584
     /*  335584 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(335647), // Rule ID 20412 //
     /*  335589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335645 */     GIR_RootConstrainSelectedInstOperands,
     /*  335646 */     // GIR_Coverage, 20412,
     /*  335646 */     GIR_EraseRootFromParent_Done,
     /*  335647 */   // Label 6178: @335647
     /*  335647 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(335710), // Rule ID 20413 //
     /*  335652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335691 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335708 */     GIR_RootConstrainSelectedInstOperands,
     /*  335709 */     // GIR_Coverage, 20413,
     /*  335709 */     GIR_EraseRootFromParent_Done,
     /*  335710 */   // Label 6179: @335710
     /*  335710 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(335773), // Rule ID 20416 //
     /*  335715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335771 */     GIR_RootConstrainSelectedInstOperands,
     /*  335772 */     // GIR_Coverage, 20416,
     /*  335772 */     GIR_EraseRootFromParent_Done,
     /*  335773 */   // Label 6180: @335773
     /*  335773 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(335836), // Rule ID 20417 //
     /*  335778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335834 */     GIR_RootConstrainSelectedInstOperands,
     /*  335835 */     // GIR_Coverage, 20417,
     /*  335835 */     GIR_EraseRootFromParent_Done,
     /*  335836 */   // Label 6181: @335836
     /*  335836 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(335899), // Rule ID 20420 //
     /*  335841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335897 */     GIR_RootConstrainSelectedInstOperands,
     /*  335898 */     // GIR_Coverage, 20420,
     /*  335898 */     GIR_EraseRootFromParent_Done,
     /*  335899 */   // Label 6182: @335899
     /*  335899 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(335962), // Rule ID 20421 //
     /*  335904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335943 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335960 */     GIR_RootConstrainSelectedInstOperands,
     /*  335961 */     // GIR_Coverage, 20421,
     /*  335961 */     GIR_EraseRootFromParent_Done,
     /*  335962 */   // Label 6183: @335962
     /*  335962 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(336025), // Rule ID 20424 //
     /*  335967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  336009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336023 */     GIR_RootConstrainSelectedInstOperands,
     /*  336024 */     // GIR_Coverage, 20424,
     /*  336024 */     GIR_EraseRootFromParent_Done,
     /*  336025 */   // Label 6184: @336025
     /*  336025 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(336088), // Rule ID 20425 //
     /*  336030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  336044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  336047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336069 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  336072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336086 */     GIR_RootConstrainSelectedInstOperands,
     /*  336087 */     // GIR_Coverage, 20425,
     /*  336087 */     GIR_EraseRootFromParent_Done,
     /*  336088 */   // Label 6185: @336088
     /*  336088 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(336151), // Rule ID 20428 //
     /*  336093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  336107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  336110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  336135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336149 */     GIR_RootConstrainSelectedInstOperands,
     /*  336150 */     // GIR_Coverage, 20428,
     /*  336150 */     GIR_EraseRootFromParent_Done,
     /*  336151 */   // Label 6186: @336151
     /*  336151 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(336214), // Rule ID 20429 //
     /*  336156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  336170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  336173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  336198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336212 */     GIR_RootConstrainSelectedInstOperands,
     /*  336213 */     // GIR_Coverage, 20429,
     /*  336213 */     GIR_EraseRootFromParent_Done,
     /*  336214 */   // Label 6187: @336214
     /*  336214 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(336277), // Rule ID 20432 //
     /*  336219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  336233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  336236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  336261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336275 */     GIR_RootConstrainSelectedInstOperands,
     /*  336276 */     // GIR_Coverage, 20432,
     /*  336276 */     GIR_EraseRootFromParent_Done,
     /*  336277 */   // Label 6188: @336277
     /*  336277 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(336340), // Rule ID 20433 //
     /*  336282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  336290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  336296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  336299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  336324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336338 */     GIR_RootConstrainSelectedInstOperands,
     /*  336339 */     // GIR_Coverage, 20433,
     /*  336339 */     GIR_EraseRootFromParent_Done,
     /*  336340 */   // Label 6189: @336340
     /*  336340 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(336403), // Rule ID 20436 //
     /*  336345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  336387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336401 */     GIR_RootConstrainSelectedInstOperands,
     /*  336402 */     // GIR_Coverage, 20436,
     /*  336402 */     GIR_EraseRootFromParent_Done,
     /*  336403 */   // Label 6190: @336403
     /*  336403 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(336466), // Rule ID 20437 //
     /*  336408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  336425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336447 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  336450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336464 */     GIR_RootConstrainSelectedInstOperands,
     /*  336465 */     // GIR_Coverage, 20437,
     /*  336465 */     GIR_EraseRootFromParent_Done,
     /*  336466 */   // Label 6191: @336466
     /*  336466 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(336529), // Rule ID 20440 //
     /*  336471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336527 */     GIR_RootConstrainSelectedInstOperands,
     /*  336528 */     // GIR_Coverage, 20440,
     /*  336528 */     GIR_EraseRootFromParent_Done,
     /*  336529 */   // Label 6192: @336529
     /*  336529 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(336592), // Rule ID 20441 //
     /*  336534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336573 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336590 */     GIR_RootConstrainSelectedInstOperands,
     /*  336591 */     // GIR_Coverage, 20441,
     /*  336591 */     GIR_EraseRootFromParent_Done,
     /*  336592 */   // Label 6193: @336592
     /*  336592 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(336655), // Rule ID 20444 //
     /*  336597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336653 */     GIR_RootConstrainSelectedInstOperands,
     /*  336654 */     // GIR_Coverage, 20444,
     /*  336654 */     GIR_EraseRootFromParent_Done,
     /*  336655 */   // Label 6194: @336655
     /*  336655 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(336718), // Rule ID 20445 //
     /*  336660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336699 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336716 */     GIR_RootConstrainSelectedInstOperands,
     /*  336717 */     // GIR_Coverage, 20445,
     /*  336717 */     GIR_EraseRootFromParent_Done,
     /*  336718 */   // Label 6195: @336718
     /*  336718 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(336781), // Rule ID 20448 //
     /*  336723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336779 */     GIR_RootConstrainSelectedInstOperands,
     /*  336780 */     // GIR_Coverage, 20448,
     /*  336780 */     GIR_EraseRootFromParent_Done,
     /*  336781 */   // Label 6196: @336781
     /*  336781 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(336844), // Rule ID 20449 //
     /*  336786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336825 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336842 */     GIR_RootConstrainSelectedInstOperands,
     /*  336843 */     // GIR_Coverage, 20449,
     /*  336843 */     GIR_EraseRootFromParent_Done,
     /*  336844 */   // Label 6197: @336844
     /*  336844 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(336907), // Rule ID 20452 //
     /*  336849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336905 */     GIR_RootConstrainSelectedInstOperands,
     /*  336906 */     // GIR_Coverage, 20452,
     /*  336906 */     GIR_EraseRootFromParent_Done,
     /*  336907 */   // Label 6198: @336907
     /*  336907 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(336970), // Rule ID 20453 //
     /*  336912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336968 */     GIR_RootConstrainSelectedInstOperands,
     /*  336969 */     // GIR_Coverage, 20453,
     /*  336969 */     GIR_EraseRootFromParent_Done,
     /*  336970 */   // Label 6199: @336970
     /*  336970 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(337033), // Rule ID 20456 //
     /*  336975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  337017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337031 */     GIR_RootConstrainSelectedInstOperands,
     /*  337032 */     // GIR_Coverage, 20456,
     /*  337032 */     GIR_EraseRootFromParent_Done,
     /*  337033 */   // Label 6200: @337033
     /*  337033 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(337096), // Rule ID 20457 //
     /*  337038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  337080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337094 */     GIR_RootConstrainSelectedInstOperands,
     /*  337095 */     // GIR_Coverage, 20457,
     /*  337095 */     GIR_EraseRootFromParent_Done,
     /*  337096 */   // Label 6201: @337096
     /*  337096 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(337159), // Rule ID 20460 //
     /*  337101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  337115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  337118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337157 */     GIR_RootConstrainSelectedInstOperands,
     /*  337158 */     // GIR_Coverage, 20460,
     /*  337158 */     GIR_EraseRootFromParent_Done,
     /*  337159 */   // Label 6202: @337159
     /*  337159 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(337222), // Rule ID 20461 //
     /*  337164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  337178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  337181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337203 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337220 */     GIR_RootConstrainSelectedInstOperands,
     /*  337221 */     // GIR_Coverage, 20461,
     /*  337221 */     GIR_EraseRootFromParent_Done,
     /*  337222 */   // Label 6203: @337222
     /*  337222 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(337285), // Rule ID 20464 //
     /*  337227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  337241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  337244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337266 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337283 */     GIR_RootConstrainSelectedInstOperands,
     /*  337284 */     // GIR_Coverage, 20464,
     /*  337284 */     GIR_EraseRootFromParent_Done,
     /*  337285 */   // Label 6204: @337285
     /*  337285 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(337348), // Rule ID 20465 //
     /*  337290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  337304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  337307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337329 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337346 */     GIR_RootConstrainSelectedInstOperands,
     /*  337347 */     // GIR_Coverage, 20465,
     /*  337347 */     GIR_EraseRootFromParent_Done,
     /*  337348 */   // Label 6205: @337348
     /*  337348 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(337411), // Rule ID 20468 //
     /*  337353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  337370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337392 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337409 */     GIR_RootConstrainSelectedInstOperands,
     /*  337410 */     // GIR_Coverage, 20468,
     /*  337410 */     GIR_EraseRootFromParent_Done,
     /*  337411 */   // Label 6206: @337411
     /*  337411 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(337474), // Rule ID 20469 //
     /*  337416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  337433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337455 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337472 */     GIR_RootConstrainSelectedInstOperands,
     /*  337473 */     // GIR_Coverage, 20469,
     /*  337473 */     GIR_EraseRootFromParent_Done,
     /*  337474 */   // Label 6207: @337474
     /*  337474 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(337537), // Rule ID 20472 //
     /*  337479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337535 */     GIR_RootConstrainSelectedInstOperands,
     /*  337536 */     // GIR_Coverage, 20472,
     /*  337536 */     GIR_EraseRootFromParent_Done,
     /*  337537 */   // Label 6208: @337537
     /*  337537 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(337600), // Rule ID 20473 //
     /*  337542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337581 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337598 */     GIR_RootConstrainSelectedInstOperands,
     /*  337599 */     // GIR_Coverage, 20473,
     /*  337599 */     GIR_EraseRootFromParent_Done,
     /*  337600 */   // Label 6209: @337600
     /*  337600 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(337663), // Rule ID 20476 //
     /*  337605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337661 */     GIR_RootConstrainSelectedInstOperands,
     /*  337662 */     // GIR_Coverage, 20476,
     /*  337662 */     GIR_EraseRootFromParent_Done,
     /*  337663 */   // Label 6210: @337663
     /*  337663 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(337726), // Rule ID 20477 //
     /*  337668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337707 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337724 */     GIR_RootConstrainSelectedInstOperands,
     /*  337725 */     // GIR_Coverage, 20477,
     /*  337725 */     GIR_EraseRootFromParent_Done,
     /*  337726 */   // Label 6211: @337726
     /*  337726 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(337789), // Rule ID 20480 //
     /*  337731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337770 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337787 */     GIR_RootConstrainSelectedInstOperands,
     /*  337788 */     // GIR_Coverage, 20480,
     /*  337788 */     GIR_EraseRootFromParent_Done,
     /*  337789 */   // Label 6212: @337789
     /*  337789 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(337852), // Rule ID 20481 //
     /*  337794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337833 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337850 */     GIR_RootConstrainSelectedInstOperands,
     /*  337851 */     // GIR_Coverage, 20481,
     /*  337851 */     GIR_EraseRootFromParent_Done,
     /*  337852 */   // Label 6213: @337852
     /*  337852 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(337915), // Rule ID 20484 //
     /*  337857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337913 */     GIR_RootConstrainSelectedInstOperands,
     /*  337914 */     // GIR_Coverage, 20484,
     /*  337914 */     GIR_EraseRootFromParent_Done,
     /*  337915 */   // Label 6214: @337915
     /*  337915 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(337978), // Rule ID 20485 //
     /*  337920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337959 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337976 */     GIR_RootConstrainSelectedInstOperands,
     /*  337977 */     // GIR_Coverage, 20485,
     /*  337977 */     GIR_EraseRootFromParent_Done,
     /*  337978 */   // Label 6215: @337978
     /*  337978 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(338041), // Rule ID 20488 //
     /*  337983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  338025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338039 */     GIR_RootConstrainSelectedInstOperands,
     /*  338040 */     // GIR_Coverage, 20488,
     /*  338040 */     GIR_EraseRootFromParent_Done,
     /*  338041 */   // Label 6216: @338041
     /*  338041 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(338104), // Rule ID 20489 //
     /*  338046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  338060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338085 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  338088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338102 */     GIR_RootConstrainSelectedInstOperands,
     /*  338103 */     // GIR_Coverage, 20489,
     /*  338103 */     GIR_EraseRootFromParent_Done,
     /*  338104 */   // Label 6217: @338104
     /*  338104 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(338167), // Rule ID 20492 //
     /*  338109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  338112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  338123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  338126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  338151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338165 */     GIR_RootConstrainSelectedInstOperands,
     /*  338166 */     // GIR_Coverage, 20492,
     /*  338166 */     GIR_EraseRootFromParent_Done,
     /*  338167 */   // Label 6218: @338167
     /*  338167 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(338230), // Rule ID 20493 //
     /*  338172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  338180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  338186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  338189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338211 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  338214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338228 */     GIR_RootConstrainSelectedInstOperands,
     /*  338229 */     // GIR_Coverage, 20493,
     /*  338229 */     GIR_EraseRootFromParent_Done,
     /*  338230 */   // Label 6219: @338230
     /*  338230 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(338296), // Rule ID 20496 //
     /*  338235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  338246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338274 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338294 */     GIR_RootConstrainSelectedInstOperands,
     /*  338295 */     // GIR_Coverage, 20496,
     /*  338295 */     GIR_EraseRootFromParent_Done,
     /*  338296 */   // Label 6220: @338296
     /*  338296 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(338362), // Rule ID 20497 //
     /*  338301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  338312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338340 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338360 */     GIR_RootConstrainSelectedInstOperands,
     /*  338361 */     // GIR_Coverage, 20497,
     /*  338361 */     GIR_EraseRootFromParent_Done,
     /*  338362 */   // Label 6221: @338362
     /*  338362 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(338428), // Rule ID 20500 //
     /*  338367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  338378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338426 */     GIR_RootConstrainSelectedInstOperands,
     /*  338427 */     // GIR_Coverage, 20500,
     /*  338427 */     GIR_EraseRootFromParent_Done,
     /*  338428 */   // Label 6222: @338428
     /*  338428 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(338494), // Rule ID 20501 //
     /*  338433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  338444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338492 */     GIR_RootConstrainSelectedInstOperands,
     /*  338493 */     // GIR_Coverage, 20501,
     /*  338493 */     GIR_EraseRootFromParent_Done,
     /*  338494 */   // Label 6223: @338494
     /*  338494 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(338560), // Rule ID 20504 //
     /*  338499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338558 */     GIR_RootConstrainSelectedInstOperands,
     /*  338559 */     // GIR_Coverage, 20504,
     /*  338559 */     GIR_EraseRootFromParent_Done,
     /*  338560 */   // Label 6224: @338560
     /*  338560 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(338626), // Rule ID 20505 //
     /*  338565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338624 */     GIR_RootConstrainSelectedInstOperands,
     /*  338625 */     // GIR_Coverage, 20505,
     /*  338625 */     GIR_EraseRootFromParent_Done,
     /*  338626 */   // Label 6225: @338626
     /*  338626 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(338692), // Rule ID 20508 //
     /*  338631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338690 */     GIR_RootConstrainSelectedInstOperands,
     /*  338691 */     // GIR_Coverage, 20508,
     /*  338691 */     GIR_EraseRootFromParent_Done,
     /*  338692 */   // Label 6226: @338692
     /*  338692 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(338758), // Rule ID 20509 //
     /*  338697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338756 */     GIR_RootConstrainSelectedInstOperands,
     /*  338757 */     // GIR_Coverage, 20509,
     /*  338757 */     GIR_EraseRootFromParent_Done,
     /*  338758 */   // Label 6227: @338758
     /*  338758 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(338824), // Rule ID 20512 //
     /*  338763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338822 */     GIR_RootConstrainSelectedInstOperands,
     /*  338823 */     // GIR_Coverage, 20512,
     /*  338823 */     GIR_EraseRootFromParent_Done,
     /*  338824 */   // Label 6228: @338824
     /*  338824 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(338890), // Rule ID 20513 //
     /*  338829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338888 */     GIR_RootConstrainSelectedInstOperands,
     /*  338889 */     // GIR_Coverage, 20513,
     /*  338889 */     GIR_EraseRootFromParent_Done,
     /*  338890 */   // Label 6229: @338890
     /*  338890 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(338956), // Rule ID 20516 //
     /*  338895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338954 */     GIR_RootConstrainSelectedInstOperands,
     /*  338955 */     // GIR_Coverage, 20516,
     /*  338955 */     GIR_EraseRootFromParent_Done,
     /*  338956 */   // Label 6230: @338956
     /*  338956 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(339022), // Rule ID 20517 //
     /*  338961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339020 */     GIR_RootConstrainSelectedInstOperands,
     /*  339021 */     // GIR_Coverage, 20517,
     /*  339021 */     GIR_EraseRootFromParent_Done,
     /*  339022 */   // Label 6231: @339022
     /*  339022 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(339088), // Rule ID 20520 //
     /*  339027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  339038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  339041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  339044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339086 */     GIR_RootConstrainSelectedInstOperands,
     /*  339087 */     // GIR_Coverage, 20520,
     /*  339087 */     GIR_EraseRootFromParent_Done,
     /*  339088 */   // Label 6232: @339088
     /*  339088 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(339154), // Rule ID 20521 //
     /*  339093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  339104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  339107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  339110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339152 */     GIR_RootConstrainSelectedInstOperands,
     /*  339153 */     // GIR_Coverage, 20521,
     /*  339153 */     GIR_EraseRootFromParent_Done,
     /*  339154 */   // Label 6233: @339154
     /*  339154 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(339220), // Rule ID 20524 //
     /*  339159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  339170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  339173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  339176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339218 */     GIR_RootConstrainSelectedInstOperands,
     /*  339219 */     // GIR_Coverage, 20524,
     /*  339219 */     GIR_EraseRootFromParent_Done,
     /*  339220 */   // Label 6234: @339220
     /*  339220 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(339286), // Rule ID 20525 //
     /*  339225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  339236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  339239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  339242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339284 */     GIR_RootConstrainSelectedInstOperands,
     /*  339285 */     // GIR_Coverage, 20525,
     /*  339285 */     GIR_EraseRootFromParent_Done,
     /*  339286 */   // Label 6235: @339286
     /*  339286 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(339352), // Rule ID 20528 //
     /*  339291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  339302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339350 */     GIR_RootConstrainSelectedInstOperands,
     /*  339351 */     // GIR_Coverage, 20528,
     /*  339351 */     GIR_EraseRootFromParent_Done,
     /*  339352 */   // Label 6236: @339352
     /*  339352 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(339418), // Rule ID 20529 //
     /*  339357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  339368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339416 */     GIR_RootConstrainSelectedInstOperands,
     /*  339417 */     // GIR_Coverage, 20529,
     /*  339417 */     GIR_EraseRootFromParent_Done,
     /*  339418 */   // Label 6237: @339418
     /*  339418 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(339484), // Rule ID 20532 //
     /*  339423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339482 */     GIR_RootConstrainSelectedInstOperands,
     /*  339483 */     // GIR_Coverage, 20532,
     /*  339483 */     GIR_EraseRootFromParent_Done,
     /*  339484 */   // Label 6238: @339484
     /*  339484 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(339550), // Rule ID 20533 //
     /*  339489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339528 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339548 */     GIR_RootConstrainSelectedInstOperands,
     /*  339549 */     // GIR_Coverage, 20533,
     /*  339549 */     GIR_EraseRootFromParent_Done,
     /*  339550 */   // Label 6239: @339550
     /*  339550 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(339616), // Rule ID 20536 //
     /*  339555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339614 */     GIR_RootConstrainSelectedInstOperands,
     /*  339615 */     // GIR_Coverage, 20536,
     /*  339615 */     GIR_EraseRootFromParent_Done,
     /*  339616 */   // Label 6240: @339616
     /*  339616 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(339682), // Rule ID 20537 //
     /*  339621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339680 */     GIR_RootConstrainSelectedInstOperands,
     /*  339681 */     // GIR_Coverage, 20537,
     /*  339681 */     GIR_EraseRootFromParent_Done,
     /*  339682 */   // Label 6241: @339682
     /*  339682 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(339748), // Rule ID 20540 //
     /*  339687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339746 */     GIR_RootConstrainSelectedInstOperands,
     /*  339747 */     // GIR_Coverage, 20540,
     /*  339747 */     GIR_EraseRootFromParent_Done,
     /*  339748 */   // Label 6242: @339748
     /*  339748 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(339814), // Rule ID 20541 //
     /*  339753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339812 */     GIR_RootConstrainSelectedInstOperands,
     /*  339813 */     // GIR_Coverage, 20541,
     /*  339813 */     GIR_EraseRootFromParent_Done,
     /*  339814 */   // Label 6243: @339814
     /*  339814 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(339880), // Rule ID 20544 //
     /*  339819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339878 */     GIR_RootConstrainSelectedInstOperands,
     /*  339879 */     // GIR_Coverage, 20544,
     /*  339879 */     GIR_EraseRootFromParent_Done,
     /*  339880 */   // Label 6244: @339880
     /*  339880 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(339946), // Rule ID 20545 //
     /*  339885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339944 */     GIR_RootConstrainSelectedInstOperands,
     /*  339945 */     // GIR_Coverage, 20545,
     /*  339945 */     GIR_EraseRootFromParent_Done,
     /*  339946 */   // Label 6245: @339946
     /*  339946 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(340012), // Rule ID 20548 //
     /*  339951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340010 */     GIR_RootConstrainSelectedInstOperands,
     /*  340011 */     // GIR_Coverage, 20548,
     /*  340011 */     GIR_EraseRootFromParent_Done,
     /*  340012 */   // Label 6246: @340012
     /*  340012 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(340078), // Rule ID 20549 //
     /*  340017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  340025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  340028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  340031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  340034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  340059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340076 */     GIR_RootConstrainSelectedInstOperands,
     /*  340077 */     // GIR_Coverage, 20549,
     /*  340077 */     GIR_EraseRootFromParent_Done,
     /*  340078 */   // Label 6247: @340078
     /*  340078 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(340144), // Rule ID 20874 //
     /*  340083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  340125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340142 */     GIR_RootConstrainSelectedInstOperands,
     /*  340143 */     // GIR_Coverage, 20874,
     /*  340143 */     GIR_EraseRootFromParent_Done,
     /*  340144 */   // Label 6248: @340144
     /*  340144 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(340210), // Rule ID 20875 //
     /*  340149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  340160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  340163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  340166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  340191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340208 */     GIR_RootConstrainSelectedInstOperands,
     /*  340209 */     // GIR_Coverage, 20875,
     /*  340209 */     GIR_EraseRootFromParent_Done,
     /*  340210 */   // Label 6249: @340210
     /*  340210 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(340276), // Rule ID 20878 //
     /*  340215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340254 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340274 */     GIR_RootConstrainSelectedInstOperands,
     /*  340275 */     // GIR_Coverage, 20878,
     /*  340275 */     GIR_EraseRootFromParent_Done,
     /*  340276 */   // Label 6250: @340276
     /*  340276 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(340342), // Rule ID 20879 //
     /*  340281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  340292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  340295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  340298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340340 */     GIR_RootConstrainSelectedInstOperands,
     /*  340341 */     // GIR_Coverage, 20879,
     /*  340341 */     GIR_EraseRootFromParent_Done,
     /*  340342 */   // Label 6251: @340342
     /*  340342 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(340408), // Rule ID 20882 //
     /*  340347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340406 */     GIR_RootConstrainSelectedInstOperands,
     /*  340407 */     // GIR_Coverage, 20882,
     /*  340407 */     GIR_EraseRootFromParent_Done,
     /*  340408 */   // Label 6252: @340408
     /*  340408 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(340474), // Rule ID 20883 //
     /*  340413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  340424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  340455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340472 */     GIR_RootConstrainSelectedInstOperands,
     /*  340473 */     // GIR_Coverage, 20883,
     /*  340473 */     GIR_EraseRootFromParent_Done,
     /*  340474 */   // Label 6253: @340474
     /*  340474 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(340540), // Rule ID 20886 //
     /*  340479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340538 */     GIR_RootConstrainSelectedInstOperands,
     /*  340539 */     // GIR_Coverage, 20886,
     /*  340539 */     GIR_EraseRootFromParent_Done,
     /*  340540 */   // Label 6254: @340540
     /*  340540 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(340606), // Rule ID 20887 //
     /*  340545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340604 */     GIR_RootConstrainSelectedInstOperands,
     /*  340605 */     // GIR_Coverage, 20887,
     /*  340605 */     GIR_EraseRootFromParent_Done,
     /*  340606 */   // Label 6255: @340606
     /*  340606 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(340672), // Rule ID 20890 //
     /*  340611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340670 */     GIR_RootConstrainSelectedInstOperands,
     /*  340671 */     // GIR_Coverage, 20890,
     /*  340671 */     GIR_EraseRootFromParent_Done,
     /*  340672 */   // Label 6256: @340672
     /*  340672 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(340738), // Rule ID 20891 //
     /*  340677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340736 */     GIR_RootConstrainSelectedInstOperands,
     /*  340737 */     // GIR_Coverage, 20891,
     /*  340737 */     GIR_EraseRootFromParent_Done,
     /*  340738 */   // Label 6257: @340738
     /*  340738 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(340804), // Rule ID 20894 //
     /*  340743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340802 */     GIR_RootConstrainSelectedInstOperands,
     /*  340803 */     // GIR_Coverage, 20894,
     /*  340803 */     GIR_EraseRootFromParent_Done,
     /*  340804 */   // Label 6258: @340804
     /*  340804 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(340870), // Rule ID 20895 //
     /*  340809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340868 */     GIR_RootConstrainSelectedInstOperands,
     /*  340869 */     // GIR_Coverage, 20895,
     /*  340869 */     GIR_EraseRootFromParent_Done,
     /*  340870 */   // Label 6259: @340870
     /*  340870 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(340936), // Rule ID 20898 //
     /*  340875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340934 */     GIR_RootConstrainSelectedInstOperands,
     /*  340935 */     // GIR_Coverage, 20898,
     /*  340935 */     GIR_EraseRootFromParent_Done,
     /*  340936 */   // Label 6260: @340936
     /*  340936 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(341002), // Rule ID 20899 //
     /*  340941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341000 */     GIR_RootConstrainSelectedInstOperands,
     /*  341001 */     // GIR_Coverage, 20899,
     /*  341001 */     GIR_EraseRootFromParent_Done,
     /*  341002 */   // Label 6261: @341002
     /*  341002 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(341068), // Rule ID 20902 //
     /*  341007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  341018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  341021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  341024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341066 */     GIR_RootConstrainSelectedInstOperands,
     /*  341067 */     // GIR_Coverage, 20902,
     /*  341067 */     GIR_EraseRootFromParent_Done,
     /*  341068 */   // Label 6262: @341068
     /*  341068 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(341134), // Rule ID 20903 //
     /*  341073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  341084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  341087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  341090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341132 */     GIR_RootConstrainSelectedInstOperands,
     /*  341133 */     // GIR_Coverage, 20903,
     /*  341133 */     GIR_EraseRootFromParent_Done,
     /*  341134 */   // Label 6263: @341134
     /*  341134 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(341200), // Rule ID 20906 //
     /*  341139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  341150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  341153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  341156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341198 */     GIR_RootConstrainSelectedInstOperands,
     /*  341199 */     // GIR_Coverage, 20906,
     /*  341199 */     GIR_EraseRootFromParent_Done,
     /*  341200 */   // Label 6264: @341200
     /*  341200 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(341266), // Rule ID 20907 //
     /*  341205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  341216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  341219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  341222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341264 */     GIR_RootConstrainSelectedInstOperands,
     /*  341265 */     // GIR_Coverage, 20907,
     /*  341265 */     GIR_EraseRootFromParent_Done,
     /*  341266 */   // Label 6265: @341266
     /*  341266 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(341332), // Rule ID 20910 //
     /*  341271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  341282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  341285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  341288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341330 */     GIR_RootConstrainSelectedInstOperands,
     /*  341331 */     // GIR_Coverage, 20910,
     /*  341331 */     GIR_EraseRootFromParent_Done,
     /*  341332 */   // Label 6266: @341332
     /*  341332 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(341398), // Rule ID 20911 //
     /*  341337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  341348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  341351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  341354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341396 */     GIR_RootConstrainSelectedInstOperands,
     /*  341397 */     // GIR_Coverage, 20911,
     /*  341397 */     GIR_EraseRootFromParent_Done,
     /*  341398 */   // Label 6267: @341398
     /*  341398 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(341464), // Rule ID 20914 //
     /*  341403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341462 */     GIR_RootConstrainSelectedInstOperands,
     /*  341463 */     // GIR_Coverage, 20914,
     /*  341463 */     GIR_EraseRootFromParent_Done,
     /*  341464 */   // Label 6268: @341464
     /*  341464 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(341530), // Rule ID 20915 //
     /*  341469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341528 */     GIR_RootConstrainSelectedInstOperands,
     /*  341529 */     // GIR_Coverage, 20915,
     /*  341529 */     GIR_EraseRootFromParent_Done,
     /*  341530 */   // Label 6269: @341530
     /*  341530 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(341596), // Rule ID 20918 //
     /*  341535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341594 */     GIR_RootConstrainSelectedInstOperands,
     /*  341595 */     // GIR_Coverage, 20918,
     /*  341595 */     GIR_EraseRootFromParent_Done,
     /*  341596 */   // Label 6270: @341596
     /*  341596 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(341662), // Rule ID 20919 //
     /*  341601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341660 */     GIR_RootConstrainSelectedInstOperands,
     /*  341661 */     // GIR_Coverage, 20919,
     /*  341661 */     GIR_EraseRootFromParent_Done,
     /*  341662 */   // Label 6271: @341662
     /*  341662 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(341728), // Rule ID 20922 //
     /*  341667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341726 */     GIR_RootConstrainSelectedInstOperands,
     /*  341727 */     // GIR_Coverage, 20922,
     /*  341727 */     GIR_EraseRootFromParent_Done,
     /*  341728 */   // Label 6272: @341728
     /*  341728 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(341794), // Rule ID 20923 //
     /*  341733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341792 */     GIR_RootConstrainSelectedInstOperands,
     /*  341793 */     // GIR_Coverage, 20923,
     /*  341793 */     GIR_EraseRootFromParent_Done,
     /*  341794 */   // Label 6273: @341794
     /*  341794 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(341860), // Rule ID 20926 //
     /*  341799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341858 */     GIR_RootConstrainSelectedInstOperands,
     /*  341859 */     // GIR_Coverage, 20926,
     /*  341859 */     GIR_EraseRootFromParent_Done,
     /*  341860 */   // Label 6274: @341860
     /*  341860 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(341926), // Rule ID 20927 //
     /*  341865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341924 */     GIR_RootConstrainSelectedInstOperands,
     /*  341925 */     // GIR_Coverage, 20927,
     /*  341925 */     GIR_EraseRootFromParent_Done,
     /*  341926 */   // Label 6275: @341926
     /*  341926 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(341992), // Rule ID 20930 //
     /*  341931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341990 */     GIR_RootConstrainSelectedInstOperands,
     /*  341991 */     // GIR_Coverage, 20930,
     /*  341991 */     GIR_EraseRootFromParent_Done,
     /*  341992 */   // Label 6276: @341992
     /*  341992 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(342058), // Rule ID 20931 //
     /*  341997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  342005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  342008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  342011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  342014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  342039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342056 */     GIR_RootConstrainSelectedInstOperands,
     /*  342057 */     // GIR_Coverage, 20931,
     /*  342057 */     GIR_EraseRootFromParent_Done,
     /*  342058 */   // Label 6277: @342058
     /*  342058 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(342124), // Rule ID 20934 //
     /*  342063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  342074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  342077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  342080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  342105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342122 */     GIR_RootConstrainSelectedInstOperands,
     /*  342123 */     // GIR_Coverage, 20934,
     /*  342123 */     GIR_EraseRootFromParent_Done,
     /*  342124 */   // Label 6278: @342124
     /*  342124 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(342190), // Rule ID 20935 //
     /*  342129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  342140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  342143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  342146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  342171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342188 */     GIR_RootConstrainSelectedInstOperands,
     /*  342189 */     // GIR_Coverage, 20935,
     /*  342189 */     GIR_EraseRootFromParent_Done,
     /*  342190 */   // Label 6279: @342190
     /*  342190 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(342256), // Rule ID 20938 //
     /*  342195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  342206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  342209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  342212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342254 */     GIR_RootConstrainSelectedInstOperands,
     /*  342255 */     // GIR_Coverage, 20938,
     /*  342255 */     GIR_EraseRootFromParent_Done,
     /*  342256 */   // Label 6280: @342256
     /*  342256 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(342322), // Rule ID 20939 //
     /*  342261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  342272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  342275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  342278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342320 */     GIR_RootConstrainSelectedInstOperands,
     /*  342321 */     // GIR_Coverage, 20939,
     /*  342321 */     GIR_EraseRootFromParent_Done,
     /*  342322 */   // Label 6281: @342322
     /*  342322 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(342388), // Rule ID 20942 //
     /*  342327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  342338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  342341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  342344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342386 */     GIR_RootConstrainSelectedInstOperands,
     /*  342387 */     // GIR_Coverage, 20942,
     /*  342387 */     GIR_EraseRootFromParent_Done,
     /*  342388 */   // Label 6282: @342388
     /*  342388 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(342454), // Rule ID 20943 //
     /*  342393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  342404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  342407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  342410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342432 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  342435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342452 */     GIR_RootConstrainSelectedInstOperands,
     /*  342453 */     // GIR_Coverage, 20943,
     /*  342453 */     GIR_EraseRootFromParent_Done,
     /*  342454 */   // Label 6283: @342454
     /*  342454 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(342520), // Rule ID 20946 //
     /*  342459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342518 */     GIR_RootConstrainSelectedInstOperands,
     /*  342519 */     // GIR_Coverage, 20946,
     /*  342519 */     GIR_EraseRootFromParent_Done,
     /*  342520 */   // Label 6284: @342520
     /*  342520 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(342586), // Rule ID 20947 //
     /*  342525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342584 */     GIR_RootConstrainSelectedInstOperands,
     /*  342585 */     // GIR_Coverage, 20947,
     /*  342585 */     GIR_EraseRootFromParent_Done,
     /*  342586 */   // Label 6285: @342586
     /*  342586 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(342652), // Rule ID 20950 //
     /*  342591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342650 */     GIR_RootConstrainSelectedInstOperands,
     /*  342651 */     // GIR_Coverage, 20950,
     /*  342651 */     GIR_EraseRootFromParent_Done,
     /*  342652 */   // Label 6286: @342652
     /*  342652 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(342718), // Rule ID 20951 //
     /*  342657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342716 */     GIR_RootConstrainSelectedInstOperands,
     /*  342717 */     // GIR_Coverage, 20951,
     /*  342717 */     GIR_EraseRootFromParent_Done,
     /*  342718 */   // Label 6287: @342718
     /*  342718 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(342784), // Rule ID 20954 //
     /*  342723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342762 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342782 */     GIR_RootConstrainSelectedInstOperands,
     /*  342783 */     // GIR_Coverage, 20954,
     /*  342783 */     GIR_EraseRootFromParent_Done,
     /*  342784 */   // Label 6288: @342784
     /*  342784 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(342850), // Rule ID 20955 //
     /*  342789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342848 */     GIR_RootConstrainSelectedInstOperands,
     /*  342849 */     // GIR_Coverage, 20955,
     /*  342849 */     GIR_EraseRootFromParent_Done,
     /*  342850 */   // Label 6289: @342850
     /*  342850 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(342916), // Rule ID 20958 //
     /*  342855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342914 */     GIR_RootConstrainSelectedInstOperands,
     /*  342915 */     // GIR_Coverage, 20958,
     /*  342915 */     GIR_EraseRootFromParent_Done,
     /*  342916 */   // Label 6290: @342916
     /*  342916 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(342982), // Rule ID 20959 //
     /*  342921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342980 */     GIR_RootConstrainSelectedInstOperands,
     /*  342981 */     // GIR_Coverage, 20959,
     /*  342981 */     GIR_EraseRootFromParent_Done,
     /*  342982 */   // Label 6291: @342982
     /*  342982 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(343048), // Rule ID 20962 //
     /*  342987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  343001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343046 */     GIR_RootConstrainSelectedInstOperands,
     /*  343047 */     // GIR_Coverage, 20962,
     /*  343047 */     GIR_EraseRootFromParent_Done,
     /*  343048 */   // Label 6292: @343048
     /*  343048 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(343114), // Rule ID 20963 //
     /*  343053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  343064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  343067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343092 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343112 */     GIR_RootConstrainSelectedInstOperands,
     /*  343113 */     // GIR_Coverage, 20963,
     /*  343113 */     GIR_EraseRootFromParent_Done,
     /*  343114 */   // Label 6293: @343114
     /*  343114 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(343180), // Rule ID 20966 //
     /*  343119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  343130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  343133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  343136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343178 */     GIR_RootConstrainSelectedInstOperands,
     /*  343179 */     // GIR_Coverage, 20966,
     /*  343179 */     GIR_EraseRootFromParent_Done,
     /*  343180 */   // Label 6294: @343180
     /*  343180 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(343246), // Rule ID 20967 //
     /*  343185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  343196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  343199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  343202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343244 */     GIR_RootConstrainSelectedInstOperands,
     /*  343245 */     // GIR_Coverage, 20967,
     /*  343245 */     GIR_EraseRootFromParent_Done,
     /*  343246 */   // Label 6295: @343246
     /*  343246 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(343312), // Rule ID 20970 //
     /*  343251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  343268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343310 */     GIR_RootConstrainSelectedInstOperands,
     /*  343311 */     // GIR_Coverage, 20970,
     /*  343311 */     GIR_EraseRootFromParent_Done,
     /*  343312 */   // Label 6296: @343312
     /*  343312 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(343378), // Rule ID 20971 //
     /*  343317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  343334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343376 */     GIR_RootConstrainSelectedInstOperands,
     /*  343377 */     // GIR_Coverage, 20971,
     /*  343377 */     GIR_EraseRootFromParent_Done,
     /*  343378 */   // Label 6297: @343378
     /*  343378 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(343444), // Rule ID 20974 //
     /*  343383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343442 */     GIR_RootConstrainSelectedInstOperands,
     /*  343443 */     // GIR_Coverage, 20974,
     /*  343443 */     GIR_EraseRootFromParent_Done,
     /*  343444 */   // Label 6298: @343444
     /*  343444 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(343510), // Rule ID 20975 //
     /*  343449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343508 */     GIR_RootConstrainSelectedInstOperands,
     /*  343509 */     // GIR_Coverage, 20975,
     /*  343509 */     GIR_EraseRootFromParent_Done,
     /*  343510 */   // Label 6299: @343510
     /*  343510 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(343576), // Rule ID 20978 //
     /*  343515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343574 */     GIR_RootConstrainSelectedInstOperands,
     /*  343575 */     // GIR_Coverage, 20978,
     /*  343575 */     GIR_EraseRootFromParent_Done,
     /*  343576 */   // Label 6300: @343576
     /*  343576 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(343642), // Rule ID 20979 //
     /*  343581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343640 */     GIR_RootConstrainSelectedInstOperands,
     /*  343641 */     // GIR_Coverage, 20979,
     /*  343641 */     GIR_EraseRootFromParent_Done,
     /*  343642 */   // Label 6301: @343642
     /*  343642 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(343708), // Rule ID 20982 //
     /*  343647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343706 */     GIR_RootConstrainSelectedInstOperands,
     /*  343707 */     // GIR_Coverage, 20982,
     /*  343707 */     GIR_EraseRootFromParent_Done,
     /*  343708 */   // Label 6302: @343708
     /*  343708 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(343774), // Rule ID 20983 //
     /*  343713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343772 */     GIR_RootConstrainSelectedInstOperands,
     /*  343773 */     // GIR_Coverage, 20983,
     /*  343773 */     GIR_EraseRootFromParent_Done,
     /*  343774 */   // Label 6303: @343774
     /*  343774 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(343840), // Rule ID 20986 //
     /*  343779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343838 */     GIR_RootConstrainSelectedInstOperands,
     /*  343839 */     // GIR_Coverage, 20986,
     /*  343839 */     GIR_EraseRootFromParent_Done,
     /*  343840 */   // Label 6304: @343840
     /*  343840 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(343906), // Rule ID 20987 //
     /*  343845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343904 */     GIR_RootConstrainSelectedInstOperands,
     /*  343905 */     // GIR_Coverage, 20987,
     /*  343905 */     GIR_EraseRootFromParent_Done,
     /*  343906 */   // Label 6305: @343906
     /*  343906 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(343972), // Rule ID 20990 //
     /*  343911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343970 */     GIR_RootConstrainSelectedInstOperands,
     /*  343971 */     // GIR_Coverage, 20990,
     /*  343971 */     GIR_EraseRootFromParent_Done,
     /*  343972 */   // Label 6306: @343972
     /*  343972 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(344038), // Rule ID 20991 //
     /*  343977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  344016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  344019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344036 */     GIR_RootConstrainSelectedInstOperands,
     /*  344037 */     // GIR_Coverage, 20991,
     /*  344037 */     GIR_EraseRootFromParent_Done,
     /*  344038 */   // Label 6307: @344038
     /*  344038 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(344104), // Rule ID 21258 //
     /*  344043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  344085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344102 */     GIR_RootConstrainSelectedInstOperands,
     /*  344103 */     // GIR_Coverage, 21258,
     /*  344103 */     GIR_EraseRootFromParent_Done,
     /*  344104 */   // Label 6308: @344104
     /*  344104 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(344170), // Rule ID 21259 //
     /*  344109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  344151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344168 */     GIR_RootConstrainSelectedInstOperands,
     /*  344169 */     // GIR_Coverage, 21259,
     /*  344169 */     GIR_EraseRootFromParent_Done,
     /*  344170 */   // Label 6309: @344170
     /*  344170 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(344236), // Rule ID 21262 //
     /*  344175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344234 */     GIR_RootConstrainSelectedInstOperands,
     /*  344235 */     // GIR_Coverage, 21262,
     /*  344235 */     GIR_EraseRootFromParent_Done,
     /*  344236 */   // Label 6310: @344236
     /*  344236 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(344302), // Rule ID 21263 //
     /*  344241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344300 */     GIR_RootConstrainSelectedInstOperands,
     /*  344301 */     // GIR_Coverage, 21263,
     /*  344301 */     GIR_EraseRootFromParent_Done,
     /*  344302 */   // Label 6311: @344302
     /*  344302 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(344368), // Rule ID 21266 //
     /*  344307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344366 */     GIR_RootConstrainSelectedInstOperands,
     /*  344367 */     // GIR_Coverage, 21266,
     /*  344367 */     GIR_EraseRootFromParent_Done,
     /*  344368 */   // Label 6312: @344368
     /*  344368 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(344434), // Rule ID 21267 //
     /*  344373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344432 */     GIR_RootConstrainSelectedInstOperands,
     /*  344433 */     // GIR_Coverage, 21267,
     /*  344433 */     GIR_EraseRootFromParent_Done,
     /*  344434 */   // Label 6313: @344434
     /*  344434 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(344500), // Rule ID 21270 //
     /*  344439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344498 */     GIR_RootConstrainSelectedInstOperands,
     /*  344499 */     // GIR_Coverage, 21270,
     /*  344499 */     GIR_EraseRootFromParent_Done,
     /*  344500 */   // Label 6314: @344500
     /*  344500 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(344566), // Rule ID 21271 //
     /*  344505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344564 */     GIR_RootConstrainSelectedInstOperands,
     /*  344565 */     // GIR_Coverage, 21271,
     /*  344565 */     GIR_EraseRootFromParent_Done,
     /*  344566 */   // Label 6315: @344566
     /*  344566 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(344632), // Rule ID 21274 //
     /*  344571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344630 */     GIR_RootConstrainSelectedInstOperands,
     /*  344631 */     // GIR_Coverage, 21274,
     /*  344631 */     GIR_EraseRootFromParent_Done,
     /*  344632 */   // Label 6316: @344632
     /*  344632 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(344698), // Rule ID 21275 //
     /*  344637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344696 */     GIR_RootConstrainSelectedInstOperands,
     /*  344697 */     // GIR_Coverage, 21275,
     /*  344697 */     GIR_EraseRootFromParent_Done,
     /*  344698 */   // Label 6317: @344698
     /*  344698 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(344764), // Rule ID 21278 //
     /*  344703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344762 */     GIR_RootConstrainSelectedInstOperands,
     /*  344763 */     // GIR_Coverage, 21278,
     /*  344763 */     GIR_EraseRootFromParent_Done,
     /*  344764 */   // Label 6318: @344764
     /*  344764 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(344830), // Rule ID 21279 //
     /*  344769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344828 */     GIR_RootConstrainSelectedInstOperands,
     /*  344829 */     // GIR_Coverage, 21279,
     /*  344829 */     GIR_EraseRootFromParent_Done,
     /*  344830 */   // Label 6319: @344830
     /*  344830 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(344896), // Rule ID 21282 //
     /*  344835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344894 */     GIR_RootConstrainSelectedInstOperands,
     /*  344895 */     // GIR_Coverage, 21282,
     /*  344895 */     GIR_EraseRootFromParent_Done,
     /*  344896 */   // Label 6320: @344896
     /*  344896 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(344962), // Rule ID 21283 //
     /*  344901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344960 */     GIR_RootConstrainSelectedInstOperands,
     /*  344961 */     // GIR_Coverage, 21283,
     /*  344961 */     GIR_EraseRootFromParent_Done,
     /*  344962 */   // Label 6321: @344962
     /*  344962 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(345028), // Rule ID 21286 //
     /*  344967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  345009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345026 */     GIR_RootConstrainSelectedInstOperands,
     /*  345027 */     // GIR_Coverage, 21286,
     /*  345027 */     GIR_EraseRootFromParent_Done,
     /*  345028 */   // Label 6322: @345028
     /*  345028 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(345094), // Rule ID 21287 //
     /*  345033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  345075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345092 */     GIR_RootConstrainSelectedInstOperands,
     /*  345093 */     // GIR_Coverage, 21287,
     /*  345093 */     GIR_EraseRootFromParent_Done,
     /*  345094 */   // Label 6323: @345094
     /*  345094 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(345160), // Rule ID 21290 //
     /*  345099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  345141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345158 */     GIR_RootConstrainSelectedInstOperands,
     /*  345159 */     // GIR_Coverage, 21290,
     /*  345159 */     GIR_EraseRootFromParent_Done,
     /*  345160 */   // Label 6324: @345160
     /*  345160 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(345226), // Rule ID 21291 //
     /*  345165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  345173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  345207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345224 */     GIR_RootConstrainSelectedInstOperands,
     /*  345225 */     // GIR_Coverage, 21291,
     /*  345225 */     GIR_EraseRootFromParent_Done,
     /*  345226 */   // Label 6325: @345226
     /*  345226 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(345292), // Rule ID 21294 //
     /*  345231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  345273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345290 */     GIR_RootConstrainSelectedInstOperands,
     /*  345291 */     // GIR_Coverage, 21294,
     /*  345291 */     GIR_EraseRootFromParent_Done,
     /*  345292 */   // Label 6326: @345292
     /*  345292 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(345358), // Rule ID 21295 //
     /*  345297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  345339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345356 */     GIR_RootConstrainSelectedInstOperands,
     /*  345357 */     // GIR_Coverage, 21295,
     /*  345357 */     GIR_EraseRootFromParent_Done,
     /*  345358 */   // Label 6327: @345358
     /*  345358 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(345424), // Rule ID 21298 //
     /*  345363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345422 */     GIR_RootConstrainSelectedInstOperands,
     /*  345423 */     // GIR_Coverage, 21298,
     /*  345423 */     GIR_EraseRootFromParent_Done,
     /*  345424 */   // Label 6328: @345424
     /*  345424 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(345490), // Rule ID 21299 //
     /*  345429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345488 */     GIR_RootConstrainSelectedInstOperands,
     /*  345489 */     // GIR_Coverage, 21299,
     /*  345489 */     GIR_EraseRootFromParent_Done,
     /*  345490 */   // Label 6329: @345490
     /*  345490 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(345556), // Rule ID 21302 //
     /*  345495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345554 */     GIR_RootConstrainSelectedInstOperands,
     /*  345555 */     // GIR_Coverage, 21302,
     /*  345555 */     GIR_EraseRootFromParent_Done,
     /*  345556 */   // Label 6330: @345556
     /*  345556 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(345622), // Rule ID 21303 //
     /*  345561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345620 */     GIR_RootConstrainSelectedInstOperands,
     /*  345621 */     // GIR_Coverage, 21303,
     /*  345621 */     GIR_EraseRootFromParent_Done,
     /*  345622 */   // Label 6331: @345622
     /*  345622 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(345688), // Rule ID 21306 //
     /*  345627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345686 */     GIR_RootConstrainSelectedInstOperands,
     /*  345687 */     // GIR_Coverage, 21306,
     /*  345687 */     GIR_EraseRootFromParent_Done,
     /*  345688 */   // Label 6332: @345688
     /*  345688 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(345754), // Rule ID 21307 //
     /*  345693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345752 */     GIR_RootConstrainSelectedInstOperands,
     /*  345753 */     // GIR_Coverage, 21307,
     /*  345753 */     GIR_EraseRootFromParent_Done,
     /*  345754 */   // Label 6333: @345754
     /*  345754 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(345820), // Rule ID 21310 //
     /*  345759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345818 */     GIR_RootConstrainSelectedInstOperands,
     /*  345819 */     // GIR_Coverage, 21310,
     /*  345819 */     GIR_EraseRootFromParent_Done,
     /*  345820 */   // Label 6334: @345820
     /*  345820 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(345886), // Rule ID 21311 //
     /*  345825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345884 */     GIR_RootConstrainSelectedInstOperands,
     /*  345885 */     // GIR_Coverage, 21311,
     /*  345885 */     GIR_EraseRootFromParent_Done,
     /*  345886 */   // Label 6335: @345886
     /*  345886 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(345952), // Rule ID 21314 //
     /*  345891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345930 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345950 */     GIR_RootConstrainSelectedInstOperands,
     /*  345951 */     // GIR_Coverage, 21314,
     /*  345951 */     GIR_EraseRootFromParent_Done,
     /*  345952 */   // Label 6336: @345952
     /*  345952 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(346018), // Rule ID 21315 //
     /*  345957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346016 */     GIR_RootConstrainSelectedInstOperands,
     /*  346017 */     // GIR_Coverage, 21315,
     /*  346017 */     GIR_EraseRootFromParent_Done,
     /*  346018 */   // Label 6337: @346018
     /*  346018 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(346084), // Rule ID 21318 //
     /*  346023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  346065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346082 */     GIR_RootConstrainSelectedInstOperands,
     /*  346083 */     // GIR_Coverage, 21318,
     /*  346083 */     GIR_EraseRootFromParent_Done,
     /*  346084 */   // Label 6338: @346084
     /*  346084 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(346150), // Rule ID 21319 //
     /*  346089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  346100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  346103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  346131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346148 */     GIR_RootConstrainSelectedInstOperands,
     /*  346149 */     // GIR_Coverage, 21319,
     /*  346149 */     GIR_EraseRootFromParent_Done,
     /*  346150 */   // Label 6339: @346150
     /*  346150 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(346216), // Rule ID 21322 //
     /*  346155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  346197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346214 */     GIR_RootConstrainSelectedInstOperands,
     /*  346215 */     // GIR_Coverage, 21322,
     /*  346215 */     GIR_EraseRootFromParent_Done,
     /*  346216 */   // Label 6340: @346216
     /*  346216 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(346282), // Rule ID 21323 //
     /*  346221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  346232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  346235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  346263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346280 */     GIR_RootConstrainSelectedInstOperands,
     /*  346281 */     // GIR_Coverage, 21323,
     /*  346281 */     GIR_EraseRootFromParent_Done,
     /*  346282 */   // Label 6341: @346282
     /*  346282 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(346348), // Rule ID 21326 //
     /*  346287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  346290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  346298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  346301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  346329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346346 */     GIR_RootConstrainSelectedInstOperands,
     /*  346347 */     // GIR_Coverage, 21326,
     /*  346347 */     GIR_EraseRootFromParent_Done,
     /*  346348 */   // Label 6342: @346348
     /*  346348 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(346414), // Rule ID 21327 //
     /*  346353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  346356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  346361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  346364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  346367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  346395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346412 */     GIR_RootConstrainSelectedInstOperands,
     /*  346413 */     // GIR_Coverage, 21327,
     /*  346413 */     GIR_EraseRootFromParent_Done,
     /*  346414 */   // Label 6343: @346414
     /*  346414 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(346480), // Rule ID 21330 //
     /*  346419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346458 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346478 */     GIR_RootConstrainSelectedInstOperands,
     /*  346479 */     // GIR_Coverage, 21330,
     /*  346479 */     GIR_EraseRootFromParent_Done,
     /*  346480 */   // Label 6344: @346480
     /*  346480 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(346546), // Rule ID 21331 //
     /*  346485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346544 */     GIR_RootConstrainSelectedInstOperands,
     /*  346545 */     // GIR_Coverage, 21331,
     /*  346545 */     GIR_EraseRootFromParent_Done,
     /*  346546 */   // Label 6345: @346546
     /*  346546 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(346612), // Rule ID 21334 //
     /*  346551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346590 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346610 */     GIR_RootConstrainSelectedInstOperands,
     /*  346611 */     // GIR_Coverage, 21334,
     /*  346611 */     GIR_EraseRootFromParent_Done,
     /*  346612 */   // Label 6346: @346612
     /*  346612 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(346678), // Rule ID 21335 //
     /*  346617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346656 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346676 */     GIR_RootConstrainSelectedInstOperands,
     /*  346677 */     // GIR_Coverage, 21335,
     /*  346677 */     GIR_EraseRootFromParent_Done,
     /*  346678 */   // Label 6347: @346678
     /*  346678 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(346744), // Rule ID 21338 //
     /*  346683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346722 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346742 */     GIR_RootConstrainSelectedInstOperands,
     /*  346743 */     // GIR_Coverage, 21338,
     /*  346743 */     GIR_EraseRootFromParent_Done,
     /*  346744 */   // Label 6348: @346744
     /*  346744 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(346810), // Rule ID 21339 //
     /*  346749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346808 */     GIR_RootConstrainSelectedInstOperands,
     /*  346809 */     // GIR_Coverage, 21339,
     /*  346809 */     GIR_EraseRootFromParent_Done,
     /*  346810 */   // Label 6349: @346810
     /*  346810 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(346876), // Rule ID 21342 //
     /*  346815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346854 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346874 */     GIR_RootConstrainSelectedInstOperands,
     /*  346875 */     // GIR_Coverage, 21342,
     /*  346875 */     GIR_EraseRootFromParent_Done,
     /*  346876 */   // Label 6350: @346876
     /*  346876 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(346942), // Rule ID 21343 //
     /*  346881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346920 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346940 */     GIR_RootConstrainSelectedInstOperands,
     /*  346941 */     // GIR_Coverage, 21343,
     /*  346941 */     GIR_EraseRootFromParent_Done,
     /*  346942 */   // Label 6351: @346942
     /*  346942 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(347008), // Rule ID 21346 //
     /*  346947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346986 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347006 */     GIR_RootConstrainSelectedInstOperands,
     /*  347007 */     // GIR_Coverage, 21346,
     /*  347007 */     GIR_EraseRootFromParent_Done,
     /*  347008 */   // Label 6352: @347008
     /*  347008 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(347074), // Rule ID 21347 //
     /*  347013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  347024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  347027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  347030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347052 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  347055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347072 */     GIR_RootConstrainSelectedInstOperands,
     /*  347073 */     // GIR_Coverage, 21347,
     /*  347073 */     GIR_EraseRootFromParent_Done,
     /*  347074 */   // Label 6353: @347074
     /*  347074 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(347140), // Rule ID 21350 //
     /*  347079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  347090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  347093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  347096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347118 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  347121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347138 */     GIR_RootConstrainSelectedInstOperands,
     /*  347139 */     // GIR_Coverage, 21350,
     /*  347139 */     GIR_EraseRootFromParent_Done,
     /*  347140 */   // Label 6354: @347140
     /*  347140 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(347206), // Rule ID 21351 //
     /*  347145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  347156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  347159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  347162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347184 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  347187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347204 */     GIR_RootConstrainSelectedInstOperands,
     /*  347205 */     // GIR_Coverage, 21351,
     /*  347205 */     GIR_EraseRootFromParent_Done,
     /*  347206 */   // Label 6355: @347206
     /*  347206 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(347272), // Rule ID 21354 //
     /*  347211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  347253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347270 */     GIR_RootConstrainSelectedInstOperands,
     /*  347271 */     // GIR_Coverage, 21354,
     /*  347271 */     GIR_EraseRootFromParent_Done,
     /*  347272 */   // Label 6356: @347272
     /*  347272 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(347338), // Rule ID 21355 //
     /*  347277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347316 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  347319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347336 */     GIR_RootConstrainSelectedInstOperands,
     /*  347337 */     // GIR_Coverage, 21355,
     /*  347337 */     GIR_EraseRootFromParent_Done,
     /*  347338 */   // Label 6357: @347338
     /*  347338 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(347404), // Rule ID 21358 //
     /*  347343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347382 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  347385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347402 */     GIR_RootConstrainSelectedInstOperands,
     /*  347403 */     // GIR_Coverage, 21358,
     /*  347403 */     GIR_EraseRootFromParent_Done,
     /*  347404 */   // Label 6358: @347404
     /*  347404 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(347470), // Rule ID 21359 //
     /*  347409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347448 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  347451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347468 */     GIR_RootConstrainSelectedInstOperands,
     /*  347469 */     // GIR_Coverage, 21359,
     /*  347469 */     GIR_EraseRootFromParent_Done,
     /*  347470 */   // Label 6359: @347470
     /*  347470 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(347536), // Rule ID 21362 //
     /*  347475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347514 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347534 */     GIR_RootConstrainSelectedInstOperands,
     /*  347535 */     // GIR_Coverage, 21362,
     /*  347535 */     GIR_EraseRootFromParent_Done,
     /*  347536 */   // Label 6360: @347536
     /*  347536 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(347602), // Rule ID 21363 //
     /*  347541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347580 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347600 */     GIR_RootConstrainSelectedInstOperands,
     /*  347601 */     // GIR_Coverage, 21363,
     /*  347601 */     GIR_EraseRootFromParent_Done,
     /*  347602 */   // Label 6361: @347602
     /*  347602 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(347668), // Rule ID 21366 //
     /*  347607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347666 */     GIR_RootConstrainSelectedInstOperands,
     /*  347667 */     // GIR_Coverage, 21366,
     /*  347667 */     GIR_EraseRootFromParent_Done,
     /*  347668 */   // Label 6362: @347668
     /*  347668 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(347734), // Rule ID 21367 //
     /*  347673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347712 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347732 */     GIR_RootConstrainSelectedInstOperands,
     /*  347733 */     // GIR_Coverage, 21367,
     /*  347733 */     GIR_EraseRootFromParent_Done,
     /*  347734 */   // Label 6363: @347734
     /*  347734 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(347800), // Rule ID 21370 //
     /*  347739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347778 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347798 */     GIR_RootConstrainSelectedInstOperands,
     /*  347799 */     // GIR_Coverage, 21370,
     /*  347799 */     GIR_EraseRootFromParent_Done,
     /*  347800 */   // Label 6364: @347800
     /*  347800 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(347866), // Rule ID 21371 //
     /*  347805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347864 */     GIR_RootConstrainSelectedInstOperands,
     /*  347865 */     // GIR_Coverage, 21371,
     /*  347865 */     GIR_EraseRootFromParent_Done,
     /*  347866 */   // Label 6365: @347866
     /*  347866 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(347932), // Rule ID 21374 //
     /*  347871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347910 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347930 */     GIR_RootConstrainSelectedInstOperands,
     /*  347931 */     // GIR_Coverage, 21374,
     /*  347931 */     GIR_EraseRootFromParent_Done,
     /*  347932 */   // Label 6366: @347932
     /*  347932 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(347998), // Rule ID 21375 //
     /*  347937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347996 */     GIR_RootConstrainSelectedInstOperands,
     /*  347997 */     // GIR_Coverage, 21375,
     /*  347997 */     GIR_EraseRootFromParent_Done,
     /*  347998 */   // Label 6367: @347998
     /*  347998 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(348064), // Rule ID 21378 //
     /*  348003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348042 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  348045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348062 */     GIR_RootConstrainSelectedInstOperands,
     /*  348063 */     // GIR_Coverage, 21378,
     /*  348063 */     GIR_EraseRootFromParent_Done,
     /*  348064 */   // Label 6368: @348064
     /*  348064 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(348130), // Rule ID 21379 //
     /*  348069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11343:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  348111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348128 */     GIR_RootConstrainSelectedInstOperands,
     /*  348129 */     // GIR_Coverage, 21379,
     /*  348129 */     GIR_EraseRootFromParent_Done,
     /*  348130 */   // Label 6369: @348130
     /*  348130 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(348196), // Rule ID 21382 //
     /*  348135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348174 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  348177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348194 */     GIR_RootConstrainSelectedInstOperands,
     /*  348195 */     // GIR_Coverage, 21382,
     /*  348195 */     GIR_EraseRootFromParent_Done,
     /*  348196 */   // Label 6370: @348196
     /*  348196 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(348262), // Rule ID 21383 //
     /*  348201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348240 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11343:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  348243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348260 */     GIR_RootConstrainSelectedInstOperands,
     /*  348261 */     // GIR_Coverage, 21383,
     /*  348261 */     GIR_EraseRootFromParent_Done,
     /*  348262 */   // Label 6371: @348262
     /*  348262 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(348328), // Rule ID 21386 //
     /*  348267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348306 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  348309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348326 */     GIR_RootConstrainSelectedInstOperands,
     /*  348327 */     // GIR_Coverage, 21386,
     /*  348327 */     GIR_EraseRootFromParent_Done,
     /*  348328 */   // Label 6372: @348328
     /*  348328 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(348394), // Rule ID 21387 //
     /*  348333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  348341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348372 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11343:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  348375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348392 */     GIR_RootConstrainSelectedInstOperands,
     /*  348393 */     // GIR_Coverage, 21387,
     /*  348393 */     GIR_EraseRootFromParent_Done,
     /*  348394 */   // Label 6373: @348394
     /*  348394 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(348460), // Rule ID 21390 //
     /*  348399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348438 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348458 */     GIR_RootConstrainSelectedInstOperands,
     /*  348459 */     // GIR_Coverage, 21390,
     /*  348459 */     GIR_EraseRootFromParent_Done,
     /*  348460 */   // Label 6374: @348460
     /*  348460 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(348526), // Rule ID 21391 //
     /*  348465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348504 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348524 */     GIR_RootConstrainSelectedInstOperands,
     /*  348525 */     // GIR_Coverage, 21391,
     /*  348525 */     GIR_EraseRootFromParent_Done,
     /*  348526 */   // Label 6375: @348526
     /*  348526 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(348592), // Rule ID 21394 //
     /*  348531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348570 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348590 */     GIR_RootConstrainSelectedInstOperands,
     /*  348591 */     // GIR_Coverage, 21394,
     /*  348591 */     GIR_EraseRootFromParent_Done,
     /*  348592 */   // Label 6376: @348592
     /*  348592 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(348658), // Rule ID 21395 //
     /*  348597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348636 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348656 */     GIR_RootConstrainSelectedInstOperands,
     /*  348657 */     // GIR_Coverage, 21395,
     /*  348657 */     GIR_EraseRootFromParent_Done,
     /*  348658 */   // Label 6377: @348658
     /*  348658 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(348724), // Rule ID 21398 //
     /*  348663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348722 */     GIR_RootConstrainSelectedInstOperands,
     /*  348723 */     // GIR_Coverage, 21398,
     /*  348723 */     GIR_EraseRootFromParent_Done,
     /*  348724 */   // Label 6378: @348724
     /*  348724 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(348790), // Rule ID 21399 //
     /*  348729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348768 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348788 */     GIR_RootConstrainSelectedInstOperands,
     /*  348789 */     // GIR_Coverage, 21399,
     /*  348789 */     GIR_EraseRootFromParent_Done,
     /*  348790 */   // Label 6379: @348790
     /*  348790 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(348856), // Rule ID 21402 //
     /*  348795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348834 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348854 */     GIR_RootConstrainSelectedInstOperands,
     /*  348855 */     // GIR_Coverage, 21402,
     /*  348855 */     GIR_EraseRootFromParent_Done,
     /*  348856 */   // Label 6380: @348856
     /*  348856 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(348922), // Rule ID 21403 //
     /*  348861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348920 */     GIR_RootConstrainSelectedInstOperands,
     /*  348921 */     // GIR_Coverage, 21403,
     /*  348921 */     GIR_EraseRootFromParent_Done,
     /*  348922 */   // Label 6381: @348922
     /*  348922 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(348988), // Rule ID 21406 //
     /*  348927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348966 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348986 */     GIR_RootConstrainSelectedInstOperands,
     /*  348987 */     // GIR_Coverage, 21406,
     /*  348987 */     GIR_EraseRootFromParent_Done,
     /*  348988 */   // Label 6382: @348988
     /*  348988 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(349054), // Rule ID 21407 //
     /*  348993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  349004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  349007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  349010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349032 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  349035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349052 */     GIR_RootConstrainSelectedInstOperands,
     /*  349053 */     // GIR_Coverage, 21407,
     /*  349053 */     GIR_EraseRootFromParent_Done,
     /*  349054 */   // Label 6383: @349054
     /*  349054 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(349120), // Rule ID 21410 //
     /*  349059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349098 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  349101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349118 */     GIR_RootConstrainSelectedInstOperands,
     /*  349119 */     // GIR_Coverage, 21410,
     /*  349119 */     GIR_EraseRootFromParent_Done,
     /*  349120 */   // Label 6384: @349120
     /*  349120 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(349186), // Rule ID 21411 //
     /*  349125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  349136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  349139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  349142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349164 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  349167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349184 */     GIR_RootConstrainSelectedInstOperands,
     /*  349185 */     // GIR_Coverage, 21411,
     /*  349185 */     GIR_EraseRootFromParent_Done,
     /*  349186 */   // Label 6385: @349186
     /*  349186 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(349252), // Rule ID 21414 //
     /*  349191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  349233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349250 */     GIR_RootConstrainSelectedInstOperands,
     /*  349251 */     // GIR_Coverage, 21414,
     /*  349251 */     GIR_EraseRootFromParent_Done,
     /*  349252 */   // Label 6386: @349252
     /*  349252 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(349318), // Rule ID 21415 //
     /*  349257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  349299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349316 */     GIR_RootConstrainSelectedInstOperands,
     /*  349317 */     // GIR_Coverage, 21415,
     /*  349317 */     GIR_EraseRootFromParent_Done,
     /*  349318 */   // Label 6387: @349318
     /*  349318 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(349384), // Rule ID 21418 //
     /*  349323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349362 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  349365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349382 */     GIR_RootConstrainSelectedInstOperands,
     /*  349383 */     // GIR_Coverage, 21418,
     /*  349383 */     GIR_EraseRootFromParent_Done,
     /*  349384 */   // Label 6388: @349384
     /*  349384 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(349450), // Rule ID 21419 //
     /*  349389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349428 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  349431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349448 */     GIR_RootConstrainSelectedInstOperands,
     /*  349449 */     // GIR_Coverage, 21419,
     /*  349449 */     GIR_EraseRootFromParent_Done,
     /*  349450 */   // Label 6389: @349450
     /*  349450 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(349516), // Rule ID 21422 //
     /*  349455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349514 */     GIR_RootConstrainSelectedInstOperands,
     /*  349515 */     // GIR_Coverage, 21422,
     /*  349515 */     GIR_EraseRootFromParent_Done,
     /*  349516 */   // Label 6390: @349516
     /*  349516 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(349582), // Rule ID 21423 //
     /*  349521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349560 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349580 */     GIR_RootConstrainSelectedInstOperands,
     /*  349581 */     // GIR_Coverage, 21423,
     /*  349581 */     GIR_EraseRootFromParent_Done,
     /*  349582 */   // Label 6391: @349582
     /*  349582 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(349648), // Rule ID 21426 //
     /*  349587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349626 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349646 */     GIR_RootConstrainSelectedInstOperands,
     /*  349647 */     // GIR_Coverage, 21426,
     /*  349647 */     GIR_EraseRootFromParent_Done,
     /*  349648 */   // Label 6392: @349648
     /*  349648 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(349714), // Rule ID 21427 //
     /*  349653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349692 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349712 */     GIR_RootConstrainSelectedInstOperands,
     /*  349713 */     // GIR_Coverage, 21427,
     /*  349713 */     GIR_EraseRootFromParent_Done,
     /*  349714 */   // Label 6393: @349714
     /*  349714 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(349780), // Rule ID 21430 //
     /*  349719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349758 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349778 */     GIR_RootConstrainSelectedInstOperands,
     /*  349779 */     // GIR_Coverage, 21430,
     /*  349779 */     GIR_EraseRootFromParent_Done,
     /*  349780 */   // Label 6394: @349780
     /*  349780 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(349846), // Rule ID 21431 //
     /*  349785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349824 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349844 */     GIR_RootConstrainSelectedInstOperands,
     /*  349845 */     // GIR_Coverage, 21431,
     /*  349845 */     GIR_EraseRootFromParent_Done,
     /*  349846 */   // Label 6395: @349846
     /*  349846 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(349912), // Rule ID 21434 //
     /*  349851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349910 */     GIR_RootConstrainSelectedInstOperands,
     /*  349911 */     // GIR_Coverage, 21434,
     /*  349911 */     GIR_EraseRootFromParent_Done,
     /*  349912 */   // Label 6396: @349912
     /*  349912 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(349978), // Rule ID 21435 //
     /*  349917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349976 */     GIR_RootConstrainSelectedInstOperands,
     /*  349977 */     // GIR_Coverage, 21435,
     /*  349977 */     GIR_EraseRootFromParent_Done,
     /*  349978 */   // Label 6397: @349978
     /*  349978 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(350044), // Rule ID 21438 //
     /*  349983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350022 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  350025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350042 */     GIR_RootConstrainSelectedInstOperands,
     /*  350043 */     // GIR_Coverage, 21438,
     /*  350043 */     GIR_EraseRootFromParent_Done,
     /*  350044 */   // Label 6398: @350044
     /*  350044 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(350110), // Rule ID 21439 //
     /*  350049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350088 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  350091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350108 */     GIR_RootConstrainSelectedInstOperands,
     /*  350109 */     // GIR_Coverage, 21439,
     /*  350109 */     GIR_EraseRootFromParent_Done,
     /*  350110 */   // Label 6399: @350110
     /*  350110 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(350176), // Rule ID 21442 //
     /*  350115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  350118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350154 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  350157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350174 */     GIR_RootConstrainSelectedInstOperands,
     /*  350175 */     // GIR_Coverage, 21442,
     /*  350175 */     GIR_EraseRootFromParent_Done,
     /*  350176 */   // Label 6400: @350176
     /*  350176 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(350242), // Rule ID 21443 //
     /*  350181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350220 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  350223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350240 */     GIR_RootConstrainSelectedInstOperands,
     /*  350241 */     // GIR_Coverage, 21443,
     /*  350241 */     GIR_EraseRootFromParent_Done,
     /*  350242 */   // Label 6401: @350242
     /*  350242 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(350308), // Rule ID 21446 //
     /*  350247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  350250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  350289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350306 */     GIR_RootConstrainSelectedInstOperands,
     /*  350307 */     // GIR_Coverage, 21446,
     /*  350307 */     GIR_EraseRootFromParent_Done,
     /*  350308 */   // Label 6402: @350308
     /*  350308 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(350374), // Rule ID 21447 //
     /*  350313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  350316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  350321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  350355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350372 */     GIR_RootConstrainSelectedInstOperands,
     /*  350373 */     // GIR_Coverage, 21447,
     /*  350373 */     GIR_EraseRootFromParent_Done,
     /*  350374 */   // Label 6403: @350374
     /*  350374 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(350440), // Rule ID 21450 //
     /*  350379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350418 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350438 */     GIR_RootConstrainSelectedInstOperands,
     /*  350439 */     // GIR_Coverage, 21450,
     /*  350439 */     GIR_EraseRootFromParent_Done,
     /*  350440 */   // Label 6404: @350440
     /*  350440 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(350506), // Rule ID 21451 //
     /*  350445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350484 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350504 */     GIR_RootConstrainSelectedInstOperands,
     /*  350505 */     // GIR_Coverage, 21451,
     /*  350505 */     GIR_EraseRootFromParent_Done,
     /*  350506 */   // Label 6405: @350506
     /*  350506 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(350572), // Rule ID 21454 //
     /*  350511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350550 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350570 */     GIR_RootConstrainSelectedInstOperands,
     /*  350571 */     // GIR_Coverage, 21454,
     /*  350571 */     GIR_EraseRootFromParent_Done,
     /*  350572 */   // Label 6406: @350572
     /*  350572 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(350638), // Rule ID 21455 //
     /*  350577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350636 */     GIR_RootConstrainSelectedInstOperands,
     /*  350637 */     // GIR_Coverage, 21455,
     /*  350637 */     GIR_EraseRootFromParent_Done,
     /*  350638 */   // Label 6407: @350638
     /*  350638 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(350704), // Rule ID 21458 //
     /*  350643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350682 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350702 */     GIR_RootConstrainSelectedInstOperands,
     /*  350703 */     // GIR_Coverage, 21458,
     /*  350703 */     GIR_EraseRootFromParent_Done,
     /*  350704 */   // Label 6408: @350704
     /*  350704 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(350770), // Rule ID 21459 //
     /*  350709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350768 */     GIR_RootConstrainSelectedInstOperands,
     /*  350769 */     // GIR_Coverage, 21459,
     /*  350769 */     GIR_EraseRootFromParent_Done,
     /*  350770 */   // Label 6409: @350770
     /*  350770 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(350836), // Rule ID 21462 //
     /*  350775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350834 */     GIR_RootConstrainSelectedInstOperands,
     /*  350835 */     // GIR_Coverage, 21462,
     /*  350835 */     GIR_EraseRootFromParent_Done,
     /*  350836 */   // Label 6410: @350836
     /*  350836 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(350902), // Rule ID 21463 //
     /*  350841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350880 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350900 */     GIR_RootConstrainSelectedInstOperands,
     /*  350901 */     // GIR_Coverage, 21463,
     /*  350901 */     GIR_EraseRootFromParent_Done,
     /*  350902 */   // Label 6411: @350902
     /*  350902 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(350968), // Rule ID 21466 //
     /*  350907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350946 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350966 */     GIR_RootConstrainSelectedInstOperands,
     /*  350967 */     // GIR_Coverage, 21466,
     /*  350967 */     GIR_EraseRootFromParent_Done,
     /*  350968 */   // Label 6412: @350968
     /*  350968 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(351034), // Rule ID 21467 //
     /*  350973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  351015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351032 */     GIR_RootConstrainSelectedInstOperands,
     /*  351033 */     // GIR_Coverage, 21467,
     /*  351033 */     GIR_EraseRootFromParent_Done,
     /*  351034 */   // Label 6413: @351034
     /*  351034 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(351100), // Rule ID 21470 //
     /*  351039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351078 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  351081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351098 */     GIR_RootConstrainSelectedInstOperands,
     /*  351099 */     // GIR_Coverage, 21470,
     /*  351099 */     GIR_EraseRootFromParent_Done,
     /*  351100 */   // Label 6414: @351100
     /*  351100 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(351166), // Rule ID 21471 //
     /*  351105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  351147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351164 */     GIR_RootConstrainSelectedInstOperands,
     /*  351165 */     // GIR_Coverage, 21471,
     /*  351165 */     GIR_EraseRootFromParent_Done,
     /*  351166 */   // Label 6415: @351166
     /*  351166 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(351232), // Rule ID 21474 //
     /*  351171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351210 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  351213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351230 */     GIR_RootConstrainSelectedInstOperands,
     /*  351231 */     // GIR_Coverage, 21474,
     /*  351231 */     GIR_EraseRootFromParent_Done,
     /*  351232 */   // Label 6416: @351232
     /*  351232 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(351298), // Rule ID 21475 //
     /*  351237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  351279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351296 */     GIR_RootConstrainSelectedInstOperands,
     /*  351297 */     // GIR_Coverage, 21475,
     /*  351297 */     GIR_EraseRootFromParent_Done,
     /*  351298 */   // Label 6417: @351298
     /*  351298 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(351364), // Rule ID 21478 //
     /*  351303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  351345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351362 */     GIR_RootConstrainSelectedInstOperands,
     /*  351363 */     // GIR_Coverage, 21478,
     /*  351363 */     GIR_EraseRootFromParent_Done,
     /*  351364 */   // Label 6418: @351364
     /*  351364 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(351430), // Rule ID 21479 //
     /*  351369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351408 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  351411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351428 */     GIR_RootConstrainSelectedInstOperands,
     /*  351429 */     // GIR_Coverage, 21479,
     /*  351429 */     GIR_EraseRootFromParent_Done,
     /*  351430 */   // Label 6419: @351430
     /*  351430 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(351496), // Rule ID 21482 //
     /*  351435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  351438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351474 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351494 */     GIR_RootConstrainSelectedInstOperands,
     /*  351495 */     // GIR_Coverage, 21482,
     /*  351495 */     GIR_EraseRootFromParent_Done,
     /*  351496 */   // Label 6420: @351496
     /*  351496 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(351562), // Rule ID 21483 //
     /*  351501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351540 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351560 */     GIR_RootConstrainSelectedInstOperands,
     /*  351561 */     // GIR_Coverage, 21483,
     /*  351561 */     GIR_EraseRootFromParent_Done,
     /*  351562 */   // Label 6421: @351562
     /*  351562 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(351628), // Rule ID 21726 //
     /*  351567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351606 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351626 */     GIR_RootConstrainSelectedInstOperands,
     /*  351627 */     // GIR_Coverage, 21726,
     /*  351627 */     GIR_EraseRootFromParent_Done,
     /*  351628 */   // Label 6422: @351628
     /*  351628 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(351694), // Rule ID 21727 //
     /*  351633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351692 */     GIR_RootConstrainSelectedInstOperands,
     /*  351693 */     // GIR_Coverage, 21727,
     /*  351693 */     GIR_EraseRootFromParent_Done,
     /*  351694 */   // Label 6423: @351694
     /*  351694 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(351760), // Rule ID 21730 //
     /*  351699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351738 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351758 */     GIR_RootConstrainSelectedInstOperands,
     /*  351759 */     // GIR_Coverage, 21730,
     /*  351759 */     GIR_EraseRootFromParent_Done,
     /*  351760 */   // Label 6424: @351760
     /*  351760 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(351826), // Rule ID 21731 //
     /*  351765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351824 */     GIR_RootConstrainSelectedInstOperands,
     /*  351825 */     // GIR_Coverage, 21731,
     /*  351825 */     GIR_EraseRootFromParent_Done,
     /*  351826 */   // Label 6425: @351826
     /*  351826 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(351892), // Rule ID 21734 //
     /*  351831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351890 */     GIR_RootConstrainSelectedInstOperands,
     /*  351891 */     // GIR_Coverage, 21734,
     /*  351891 */     GIR_EraseRootFromParent_Done,
     /*  351892 */   // Label 6426: @351892
     /*  351892 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(351958), // Rule ID 21735 //
     /*  351897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351956 */     GIR_RootConstrainSelectedInstOperands,
     /*  351957 */     // GIR_Coverage, 21735,
     /*  351957 */     GIR_EraseRootFromParent_Done,
     /*  351958 */   // Label 6427: @351958
     /*  351958 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(352024), // Rule ID 21738 //
     /*  351963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352022 */     GIR_RootConstrainSelectedInstOperands,
     /*  352023 */     // GIR_Coverage, 21738,
     /*  352023 */     GIR_EraseRootFromParent_Done,
     /*  352024 */   // Label 6428: @352024
     /*  352024 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(352090), // Rule ID 21739 //
     /*  352029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  352040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  352043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  352046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11289:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352088 */     GIR_RootConstrainSelectedInstOperands,
     /*  352089 */     // GIR_Coverage, 21739,
     /*  352089 */     GIR_EraseRootFromParent_Done,
     /*  352090 */   // Label 6429: @352090
     /*  352090 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(352156), // Rule ID 21742 //
     /*  352095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  352112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352154 */     GIR_RootConstrainSelectedInstOperands,
     /*  352155 */     // GIR_Coverage, 21742,
     /*  352155 */     GIR_EraseRootFromParent_Done,
     /*  352156 */   // Label 6430: @352156
     /*  352156 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(352222), // Rule ID 21743 //
     /*  352161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  352172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  352175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  352178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352220 */     GIR_RootConstrainSelectedInstOperands,
     /*  352221 */     // GIR_Coverage, 21743,
     /*  352221 */     GIR_EraseRootFromParent_Done,
     /*  352222 */   // Label 6431: @352222
     /*  352222 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(352288), // Rule ID 21746 //
     /*  352227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  352244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352266 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352286 */     GIR_RootConstrainSelectedInstOperands,
     /*  352287 */     // GIR_Coverage, 21746,
     /*  352287 */     GIR_EraseRootFromParent_Done,
     /*  352288 */   // Label 6432: @352288
     /*  352288 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(352354), // Rule ID 21747 //
     /*  352293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  352304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  352307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  352310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352352 */     GIR_RootConstrainSelectedInstOperands,
     /*  352353 */     // GIR_Coverage, 21747,
     /*  352353 */     GIR_EraseRootFromParent_Done,
     /*  352354 */   // Label 6433: @352354
     /*  352354 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(352420), // Rule ID 21750 //
     /*  352359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  352370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  352373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  352376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352418 */     GIR_RootConstrainSelectedInstOperands,
     /*  352419 */     // GIR_Coverage, 21750,
     /*  352419 */     GIR_EraseRootFromParent_Done,
     /*  352420 */   // Label 6434: @352420
     /*  352420 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(352486), // Rule ID 21751 //
     /*  352425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  352436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  352439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  352442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352484 */     GIR_RootConstrainSelectedInstOperands,
     /*  352485 */     // GIR_Coverage, 21751,
     /*  352485 */     GIR_EraseRootFromParent_Done,
     /*  352486 */   // Label 6435: @352486
     /*  352486 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(352552), // Rule ID 21754 //
     /*  352491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352550 */     GIR_RootConstrainSelectedInstOperands,
     /*  352551 */     // GIR_Coverage, 21754,
     /*  352551 */     GIR_EraseRootFromParent_Done,
     /*  352552 */   // Label 6436: @352552
     /*  352552 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(352618), // Rule ID 21755 //
     /*  352557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352616 */     GIR_RootConstrainSelectedInstOperands,
     /*  352617 */     // GIR_Coverage, 21755,
     /*  352617 */     GIR_EraseRootFromParent_Done,
     /*  352618 */   // Label 6437: @352618
     /*  352618 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(352684), // Rule ID 21758 //
     /*  352623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352682 */     GIR_RootConstrainSelectedInstOperands,
     /*  352683 */     // GIR_Coverage, 21758,
     /*  352683 */     GIR_EraseRootFromParent_Done,
     /*  352684 */   // Label 6438: @352684
     /*  352684 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(352750), // Rule ID 21759 //
     /*  352689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11289:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352748 */     GIR_RootConstrainSelectedInstOperands,
     /*  352749 */     // GIR_Coverage, 21759,
     /*  352749 */     GIR_EraseRootFromParent_Done,
     /*  352750 */   // Label 6439: @352750
     /*  352750 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(352816), // Rule ID 21762 //
     /*  352755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352814 */     GIR_RootConstrainSelectedInstOperands,
     /*  352815 */     // GIR_Coverage, 21762,
     /*  352815 */     GIR_EraseRootFromParent_Done,
     /*  352816 */   // Label 6440: @352816
     /*  352816 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(352882), // Rule ID 21763 //
     /*  352821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352880 */     GIR_RootConstrainSelectedInstOperands,
     /*  352881 */     // GIR_Coverage, 21763,
     /*  352881 */     GIR_EraseRootFromParent_Done,
     /*  352882 */   // Label 6441: @352882
     /*  352882 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(352948), // Rule ID 21766 //
     /*  352887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352946 */     GIR_RootConstrainSelectedInstOperands,
     /*  352947 */     // GIR_Coverage, 21766,
     /*  352947 */     GIR_EraseRootFromParent_Done,
     /*  352948 */   // Label 6442: @352948
     /*  352948 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(353014), // Rule ID 21767 //
     /*  352953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353012 */     GIR_RootConstrainSelectedInstOperands,
     /*  353013 */     // GIR_Coverage, 21767,
     /*  353013 */     GIR_EraseRootFromParent_Done,
     /*  353014 */   // Label 6443: @353014
     /*  353014 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(353080), // Rule ID 21770 //
     /*  353019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  353036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  353061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353078 */     GIR_RootConstrainSelectedInstOperands,
     /*  353079 */     // GIR_Coverage, 21770,
     /*  353079 */     GIR_EraseRootFromParent_Done,
     /*  353080 */   // Label 6444: @353080
     /*  353080 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(353146), // Rule ID 21771 //
     /*  353085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  353102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  353127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353144 */     GIR_RootConstrainSelectedInstOperands,
     /*  353145 */     // GIR_Coverage, 21771,
     /*  353145 */     GIR_EraseRootFromParent_Done,
     /*  353146 */   // Label 6445: @353146
     /*  353146 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(353212), // Rule ID 21774 //
     /*  353151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  353168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  353193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353210 */     GIR_RootConstrainSelectedInstOperands,
     /*  353211 */     // GIR_Coverage, 21774,
     /*  353211 */     GIR_EraseRootFromParent_Done,
     /*  353212 */   // Label 6446: @353212
     /*  353212 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(353278), // Rule ID 21775 //
     /*  353217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  353234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  353259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353276 */     GIR_RootConstrainSelectedInstOperands,
     /*  353277 */     // GIR_Coverage, 21775,
     /*  353277 */     GIR_EraseRootFromParent_Done,
     /*  353278 */   // Label 6447: @353278
     /*  353278 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(353344), // Rule ID 21778 //
     /*  353283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  353300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  353325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353342 */     GIR_RootConstrainSelectedInstOperands,
     /*  353343 */     // GIR_Coverage, 21778,
     /*  353343 */     GIR_EraseRootFromParent_Done,
     /*  353344 */   // Label 6448: @353344
     /*  353344 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(353410), // Rule ID 21779 //
     /*  353349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  353360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  353363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  353366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  353391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353408 */     GIR_RootConstrainSelectedInstOperands,
     /*  353409 */     // GIR_Coverage, 21779,
     /*  353409 */     GIR_EraseRootFromParent_Done,
     /*  353410 */   // Label 6449: @353410
     /*  353410 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(353476), // Rule ID 21782 //
     /*  353415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353454 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353474 */     GIR_RootConstrainSelectedInstOperands,
     /*  353475 */     // GIR_Coverage, 21782,
     /*  353475 */     GIR_EraseRootFromParent_Done,
     /*  353476 */   // Label 6450: @353476
     /*  353476 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(353542), // Rule ID 21783 //
     /*  353481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353540 */     GIR_RootConstrainSelectedInstOperands,
     /*  353541 */     // GIR_Coverage, 21783,
     /*  353541 */     GIR_EraseRootFromParent_Done,
     /*  353542 */   // Label 6451: @353542
     /*  353542 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(353608), // Rule ID 21786 //
     /*  353547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353586 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353606 */     GIR_RootConstrainSelectedInstOperands,
     /*  353607 */     // GIR_Coverage, 21786,
     /*  353607 */     GIR_EraseRootFromParent_Done,
     /*  353608 */   // Label 6452: @353608
     /*  353608 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(353674), // Rule ID 21787 //
     /*  353613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353672 */     GIR_RootConstrainSelectedInstOperands,
     /*  353673 */     // GIR_Coverage, 21787,
     /*  353673 */     GIR_EraseRootFromParent_Done,
     /*  353674 */   // Label 6453: @353674
     /*  353674 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(353740), // Rule ID 21790 //
     /*  353679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353738 */     GIR_RootConstrainSelectedInstOperands,
     /*  353739 */     // GIR_Coverage, 21790,
     /*  353739 */     GIR_EraseRootFromParent_Done,
     /*  353740 */   // Label 6454: @353740
     /*  353740 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(353806), // Rule ID 21791 //
     /*  353745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353804 */     GIR_RootConstrainSelectedInstOperands,
     /*  353805 */     // GIR_Coverage, 21791,
     /*  353805 */     GIR_EraseRootFromParent_Done,
     /*  353806 */   // Label 6455: @353806
     /*  353806 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(353872), // Rule ID 21794 //
     /*  353811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353850 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353870 */     GIR_RootConstrainSelectedInstOperands,
     /*  353871 */     // GIR_Coverage, 21794,
     /*  353871 */     GIR_EraseRootFromParent_Done,
     /*  353872 */   // Label 6456: @353872
     /*  353872 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(353938), // Rule ID 21795 //
     /*  353877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353936 */     GIR_RootConstrainSelectedInstOperands,
     /*  353937 */     // GIR_Coverage, 21795,
     /*  353937 */     GIR_EraseRootFromParent_Done,
     /*  353938 */   // Label 6457: @353938
     /*  353938 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(354004), // Rule ID 21798 //
     /*  353943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354002 */     GIR_RootConstrainSelectedInstOperands,
     /*  354003 */     // GIR_Coverage, 21798,
     /*  354003 */     GIR_EraseRootFromParent_Done,
     /*  354004 */   // Label 6458: @354004
     /*  354004 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(354070), // Rule ID 21799 //
     /*  354009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  354020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  354023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11287:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354068 */     GIR_RootConstrainSelectedInstOperands,
     /*  354069 */     // GIR_Coverage, 21799,
     /*  354069 */     GIR_EraseRootFromParent_Done,
     /*  354070 */   // Label 6459: @354070
     /*  354070 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(354136), // Rule ID 21802 //
     /*  354075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  354086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  354089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354134 */     GIR_RootConstrainSelectedInstOperands,
     /*  354135 */     // GIR_Coverage, 21802,
     /*  354135 */     GIR_EraseRootFromParent_Done,
     /*  354136 */   // Label 6460: @354136
     /*  354136 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(354202), // Rule ID 21803 //
     /*  354141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  354152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  354155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354200 */     GIR_RootConstrainSelectedInstOperands,
     /*  354201 */     // GIR_Coverage, 21803,
     /*  354201 */     GIR_EraseRootFromParent_Done,
     /*  354202 */   // Label 6461: @354202
     /*  354202 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(354268), // Rule ID 21806 //
     /*  354207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  354218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  354221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  354224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354266 */     GIR_RootConstrainSelectedInstOperands,
     /*  354267 */     // GIR_Coverage, 21806,
     /*  354267 */     GIR_EraseRootFromParent_Done,
     /*  354268 */   // Label 6462: @354268
     /*  354268 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(354334), // Rule ID 21807 //
     /*  354273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  354276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  354284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  354287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  354290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354312 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  354312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  354329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354332 */     GIR_RootConstrainSelectedInstOperands,
     /*  354333 */     // GIR_Coverage, 21807,
     /*  354333 */     GIR_EraseRootFromParent_Done,
     /*  354334 */   // Label 6463: @354334
     /*  354334 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(354400), // Rule ID 21810 //
     /*  354339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  354381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354398 */     GIR_RootConstrainSelectedInstOperands,
     /*  354399 */     // GIR_Coverage, 21810,
     /*  354399 */     GIR_EraseRootFromParent_Done,
     /*  354400 */   // Label 6464: @354400
     /*  354400 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(354466), // Rule ID 21811 //
     /*  354405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  354447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354464 */     GIR_RootConstrainSelectedInstOperands,
     /*  354465 */     // GIR_Coverage, 21811,
     /*  354465 */     GIR_EraseRootFromParent_Done,
     /*  354466 */   // Label 6465: @354466
     /*  354466 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(354532), // Rule ID 21814 //
     /*  354471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354530 */     GIR_RootConstrainSelectedInstOperands,
     /*  354531 */     // GIR_Coverage, 21814,
     /*  354531 */     GIR_EraseRootFromParent_Done,
     /*  354532 */   // Label 6466: @354532
     /*  354532 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(354598), // Rule ID 21815 //
     /*  354537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354596 */     GIR_RootConstrainSelectedInstOperands,
     /*  354597 */     // GIR_Coverage, 21815,
     /*  354597 */     GIR_EraseRootFromParent_Done,
     /*  354598 */   // Label 6467: @354598
     /*  354598 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(354664), // Rule ID 21818 //
     /*  354603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354662 */     GIR_RootConstrainSelectedInstOperands,
     /*  354663 */     // GIR_Coverage, 21818,
     /*  354663 */     GIR_EraseRootFromParent_Done,
     /*  354664 */   // Label 6468: @354664
     /*  354664 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(354730), // Rule ID 21819 //
     /*  354669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354728 */     GIR_RootConstrainSelectedInstOperands,
     /*  354729 */     // GIR_Coverage, 21819,
     /*  354729 */     GIR_EraseRootFromParent_Done,
     /*  354730 */   // Label 6469: @354730
     /*  354730 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(354796), // Rule ID 21822 //
     /*  354735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354794 */     GIR_RootConstrainSelectedInstOperands,
     /*  354795 */     // GIR_Coverage, 21822,
     /*  354795 */     GIR_EraseRootFromParent_Done,
     /*  354796 */   // Label 6470: @354796
     /*  354796 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(354862), // Rule ID 21823 //
     /*  354801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354860 */     GIR_RootConstrainSelectedInstOperands,
     /*  354861 */     // GIR_Coverage, 21823,
     /*  354861 */     GIR_EraseRootFromParent_Done,
     /*  354862 */   // Label 6471: @354862
     /*  354862 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(354928), // Rule ID 21826 //
     /*  354867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354926 */     GIR_RootConstrainSelectedInstOperands,
     /*  354927 */     // GIR_Coverage, 21826,
     /*  354927 */     GIR_EraseRootFromParent_Done,
     /*  354928 */   // Label 6472: @354928
     /*  354928 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(354994), // Rule ID 21827 //
     /*  354933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354992 */     GIR_RootConstrainSelectedInstOperands,
     /*  354993 */     // GIR_Coverage, 21827,
     /*  354993 */     GIR_EraseRootFromParent_Done,
     /*  354994 */   // Label 6473: @354994
     /*  354994 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(355060), // Rule ID 21830 //
     /*  354999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  355041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355058 */     GIR_RootConstrainSelectedInstOperands,
     /*  355059 */     // GIR_Coverage, 21830,
     /*  355059 */     GIR_EraseRootFromParent_Done,
     /*  355060 */   // Label 6474: @355060
     /*  355060 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(355126), // Rule ID 21831 //
     /*  355065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  355107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355124 */     GIR_RootConstrainSelectedInstOperands,
     /*  355125 */     // GIR_Coverage, 21831,
     /*  355125 */     GIR_EraseRootFromParent_Done,
     /*  355126 */   // Label 6475: @355126
     /*  355126 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(355192), // Rule ID 21834 //
     /*  355131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  355173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355190 */     GIR_RootConstrainSelectedInstOperands,
     /*  355191 */     // GIR_Coverage, 21834,
     /*  355191 */     GIR_EraseRootFromParent_Done,
     /*  355192 */   // Label 6476: @355192
     /*  355192 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(355258), // Rule ID 21835 //
     /*  355197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  355239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355256 */     GIR_RootConstrainSelectedInstOperands,
     /*  355257 */     // GIR_Coverage, 21835,
     /*  355257 */     GIR_EraseRootFromParent_Done,
     /*  355258 */   // Label 6477: @355258
     /*  355258 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(355324), // Rule ID 21838 //
     /*  355263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  355305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355322 */     GIR_RootConstrainSelectedInstOperands,
     /*  355323 */     // GIR_Coverage, 21838,
     /*  355323 */     GIR_EraseRootFromParent_Done,
     /*  355324 */   // Label 6478: @355324
     /*  355324 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(355390), // Rule ID 21839 //
     /*  355329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  355371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355388 */     GIR_RootConstrainSelectedInstOperands,
     /*  355389 */     // GIR_Coverage, 21839,
     /*  355389 */     GIR_EraseRootFromParent_Done,
     /*  355390 */   // Label 6479: @355390
     /*  355390 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(355456), // Rule ID 21842 //
     /*  355395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  355398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355454 */     GIR_RootConstrainSelectedInstOperands,
     /*  355455 */     // GIR_Coverage, 21842,
     /*  355455 */     GIR_EraseRootFromParent_Done,
     /*  355456 */   // Label 6480: @355456
     /*  355456 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(355522), // Rule ID 21843 //
     /*  355461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  355464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355520 */     GIR_RootConstrainSelectedInstOperands,
     /*  355521 */     // GIR_Coverage, 21843,
     /*  355521 */     GIR_EraseRootFromParent_Done,
     /*  355522 */   // Label 6481: @355522
     /*  355522 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(355588), // Rule ID 21954 //
     /*  355527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355566 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355586 */     GIR_RootConstrainSelectedInstOperands,
     /*  355587 */     // GIR_Coverage, 21954,
     /*  355587 */     GIR_EraseRootFromParent_Done,
     /*  355588 */   // Label 6482: @355588
     /*  355588 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(355654), // Rule ID 21955 //
     /*  355593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355632 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355652 */     GIR_RootConstrainSelectedInstOperands,
     /*  355653 */     // GIR_Coverage, 21955,
     /*  355653 */     GIR_EraseRootFromParent_Done,
     /*  355654 */   // Label 6483: @355654
     /*  355654 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(355720), // Rule ID 21958 //
     /*  355659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355698 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355718 */     GIR_RootConstrainSelectedInstOperands,
     /*  355719 */     // GIR_Coverage, 21958,
     /*  355719 */     GIR_EraseRootFromParent_Done,
     /*  355720 */   // Label 6484: @355720
     /*  355720 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(355786), // Rule ID 21959 //
     /*  355725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355784 */     GIR_RootConstrainSelectedInstOperands,
     /*  355785 */     // GIR_Coverage, 21959,
     /*  355785 */     GIR_EraseRootFromParent_Done,
     /*  355786 */   // Label 6485: @355786
     /*  355786 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(355852), // Rule ID 21962 //
     /*  355791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355830 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355850 */     GIR_RootConstrainSelectedInstOperands,
     /*  355851 */     // GIR_Coverage, 21962,
     /*  355851 */     GIR_EraseRootFromParent_Done,
     /*  355852 */   // Label 6486: @355852
     /*  355852 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(355918), // Rule ID 21963 //
     /*  355857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355916 */     GIR_RootConstrainSelectedInstOperands,
     /*  355917 */     // GIR_Coverage, 21963,
     /*  355917 */     GIR_EraseRootFromParent_Done,
     /*  355918 */   // Label 6487: @355918
     /*  355918 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(355984), // Rule ID 21966 //
     /*  355923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355982 */     GIR_RootConstrainSelectedInstOperands,
     /*  355983 */     // GIR_Coverage, 21966,
     /*  355983 */     GIR_EraseRootFromParent_Done,
     /*  355984 */   // Label 6488: @355984
     /*  355984 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(356050), // Rule ID 21967 //
     /*  355989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  356031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356048 */     GIR_RootConstrainSelectedInstOperands,
     /*  356049 */     // GIR_Coverage, 21967,
     /*  356049 */     GIR_EraseRootFromParent_Done,
     /*  356050 */   // Label 6489: @356050
     /*  356050 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(356116), // Rule ID 21970 //
     /*  356055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  356058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356094 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  356097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356114 */     GIR_RootConstrainSelectedInstOperands,
     /*  356115 */     // GIR_Coverage, 21970,
     /*  356115 */     GIR_EraseRootFromParent_Done,
     /*  356116 */   // Label 6490: @356116
     /*  356116 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(356182), // Rule ID 21971 //
     /*  356121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  356124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356160 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  356163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356180 */     GIR_RootConstrainSelectedInstOperands,
     /*  356181 */     // GIR_Coverage, 21971,
     /*  356181 */     GIR_EraseRootFromParent_Done,
     /*  356182 */   // Label 6491: @356182
     /*  356182 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(356248), // Rule ID 21974 //
     /*  356187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356226 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  356229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356246 */     GIR_RootConstrainSelectedInstOperands,
     /*  356247 */     // GIR_Coverage, 21974,
     /*  356247 */     GIR_EraseRootFromParent_Done,
     /*  356248 */   // Label 6492: @356248
     /*  356248 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(356314), // Rule ID 21975 //
     /*  356253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356292 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  356295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356312 */     GIR_RootConstrainSelectedInstOperands,
     /*  356313 */     // GIR_Coverage, 21975,
     /*  356313 */     GIR_EraseRootFromParent_Done,
     /*  356314 */   // Label 6493: @356314
     /*  356314 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(356380), // Rule ID 21978 //
     /*  356319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356358 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  356361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356378 */     GIR_RootConstrainSelectedInstOperands,
     /*  356379 */     // GIR_Coverage, 21978,
     /*  356379 */     GIR_EraseRootFromParent_Done,
     /*  356380 */   // Label 6494: @356380
     /*  356380 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(356446), // Rule ID 21979 //
     /*  356385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  356427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356444 */     GIR_RootConstrainSelectedInstOperands,
     /*  356445 */     // GIR_Coverage, 21979,
     /*  356445 */     GIR_EraseRootFromParent_Done,
     /*  356446 */   // Label 6495: @356446
     /*  356446 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(356512), // Rule ID 21982 //
     /*  356451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356510 */     GIR_RootConstrainSelectedInstOperands,
     /*  356511 */     // GIR_Coverage, 21982,
     /*  356511 */     GIR_EraseRootFromParent_Done,
     /*  356512 */   // Label 6496: @356512
     /*  356512 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(356578), // Rule ID 21983 //
     /*  356517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356576 */     GIR_RootConstrainSelectedInstOperands,
     /*  356577 */     // GIR_Coverage, 21983,
     /*  356577 */     GIR_EraseRootFromParent_Done,
     /*  356578 */   // Label 6497: @356578
     /*  356578 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(356644), // Rule ID 21986 //
     /*  356583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356622 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356642 */     GIR_RootConstrainSelectedInstOperands,
     /*  356643 */     // GIR_Coverage, 21986,
     /*  356643 */     GIR_EraseRootFromParent_Done,
     /*  356644 */   // Label 6498: @356644
     /*  356644 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(356710), // Rule ID 21987 //
     /*  356649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356708 */     GIR_RootConstrainSelectedInstOperands,
     /*  356709 */     // GIR_Coverage, 21987,
     /*  356709 */     GIR_EraseRootFromParent_Done,
     /*  356710 */   // Label 6499: @356710
     /*  356710 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(356773), // Rule ID 23158 //
     /*  356715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356754 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356771 */     GIR_RootConstrainSelectedInstOperands,
     /*  356772 */     // GIR_Coverage, 23158,
     /*  356772 */     GIR_EraseRootFromParent_Done,
     /*  356773 */   // Label 6500: @356773
     /*  356773 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(356836), // Rule ID 23159 //
     /*  356778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356817 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356834 */     GIR_RootConstrainSelectedInstOperands,
     /*  356835 */     // GIR_Coverage, 23159,
     /*  356835 */     GIR_EraseRootFromParent_Done,
     /*  356836 */   // Label 6501: @356836
     /*  356836 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(356899), // Rule ID 23160 //
     /*  356841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356897 */     GIR_RootConstrainSelectedInstOperands,
     /*  356898 */     // GIR_Coverage, 23160,
     /*  356898 */     GIR_EraseRootFromParent_Done,
     /*  356899 */   // Label 6502: @356899
     /*  356899 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(356962), // Rule ID 23161 //
     /*  356904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356960 */     GIR_RootConstrainSelectedInstOperands,
     /*  356961 */     // GIR_Coverage, 23161,
     /*  356961 */     GIR_EraseRootFromParent_Done,
     /*  356962 */   // Label 6503: @356962
     /*  356962 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(357025), // Rule ID 23162 //
     /*  356967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  357009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357023 */     GIR_RootConstrainSelectedInstOperands,
     /*  357024 */     // GIR_Coverage, 23162,
     /*  357024 */     GIR_EraseRootFromParent_Done,
     /*  357025 */   // Label 6504: @357025
     /*  357025 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(357088), // Rule ID 23163 //
     /*  357030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357069 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  357072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357086 */     GIR_RootConstrainSelectedInstOperands,
     /*  357087 */     // GIR_Coverage, 23163,
     /*  357087 */     GIR_EraseRootFromParent_Done,
     /*  357088 */   // Label 6505: @357088
     /*  357088 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(357151), // Rule ID 23164 //
     /*  357093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  357135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357149 */     GIR_RootConstrainSelectedInstOperands,
     /*  357150 */     // GIR_Coverage, 23164,
     /*  357150 */     GIR_EraseRootFromParent_Done,
     /*  357151 */   // Label 6506: @357151
     /*  357151 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(357214), // Rule ID 23165 //
     /*  357156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  357198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357212 */     GIR_RootConstrainSelectedInstOperands,
     /*  357213 */     // GIR_Coverage, 23165,
     /*  357213 */     GIR_EraseRootFromParent_Done,
     /*  357214 */   // Label 6507: @357214
     /*  357214 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(357277), // Rule ID 23166 //
     /*  357219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357258 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  357261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357275 */     GIR_RootConstrainSelectedInstOperands,
     /*  357276 */     // GIR_Coverage, 23166,
     /*  357276 */     GIR_EraseRootFromParent_Done,
     /*  357277 */   // Label 6508: @357277
     /*  357277 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(357340), // Rule ID 23167 //
     /*  357282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357321 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  357324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357338 */     GIR_RootConstrainSelectedInstOperands,
     /*  357339 */     // GIR_Coverage, 23167,
     /*  357339 */     GIR_EraseRootFromParent_Done,
     /*  357340 */   // Label 6509: @357340
     /*  357340 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(357403), // Rule ID 23168 //
     /*  357345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357384 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  357387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357401 */     GIR_RootConstrainSelectedInstOperands,
     /*  357402 */     // GIR_Coverage, 23168,
     /*  357402 */     GIR_EraseRootFromParent_Done,
     /*  357403 */   // Label 6510: @357403
     /*  357403 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(357466), // Rule ID 23169 //
     /*  357408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  357416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357447 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  357450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357464 */     GIR_RootConstrainSelectedInstOperands,
     /*  357465 */     // GIR_Coverage, 23169,
     /*  357465 */     GIR_EraseRootFromParent_Done,
     /*  357466 */   // Label 6511: @357466
     /*  357466 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(357529), // Rule ID 23170 //
     /*  357471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357510 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357527 */     GIR_RootConstrainSelectedInstOperands,
     /*  357528 */     // GIR_Coverage, 23170,
     /*  357528 */     GIR_EraseRootFromParent_Done,
     /*  357529 */   // Label 6512: @357529
     /*  357529 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(357592), // Rule ID 23171 //
     /*  357534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357573 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357590 */     GIR_RootConstrainSelectedInstOperands,
     /*  357591 */     // GIR_Coverage, 23171,
     /*  357591 */     GIR_EraseRootFromParent_Done,
     /*  357592 */   // Label 6513: @357592
     /*  357592 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(357655), // Rule ID 23172 //
     /*  357597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357653 */     GIR_RootConstrainSelectedInstOperands,
     /*  357654 */     // GIR_Coverage, 23172,
     /*  357654 */     GIR_EraseRootFromParent_Done,
     /*  357655 */   // Label 6514: @357655
     /*  357655 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(357718), // Rule ID 23173 //
     /*  357660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357716 */     GIR_RootConstrainSelectedInstOperands,
     /*  357717 */     // GIR_Coverage, 23173,
     /*  357717 */     GIR_EraseRootFromParent_Done,
     /*  357718 */   // Label 6515: @357718
     /*  357718 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(357781), // Rule ID 23174 //
     /*  357723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357779 */     GIR_RootConstrainSelectedInstOperands,
     /*  357780 */     // GIR_Coverage, 23174,
     /*  357780 */     GIR_EraseRootFromParent_Done,
     /*  357781 */   // Label 6516: @357781
     /*  357781 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(357844), // Rule ID 23175 //
     /*  357786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357825 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357842 */     GIR_RootConstrainSelectedInstOperands,
     /*  357843 */     // GIR_Coverage, 23175,
     /*  357843 */     GIR_EraseRootFromParent_Done,
     /*  357844 */   // Label 6517: @357844
     /*  357844 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(357907), // Rule ID 23176 //
     /*  357849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357905 */     GIR_RootConstrainSelectedInstOperands,
     /*  357906 */     // GIR_Coverage, 23176,
     /*  357906 */     GIR_EraseRootFromParent_Done,
     /*  357907 */   // Label 6518: @357907
     /*  357907 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(357970), // Rule ID 23177 //
     /*  357912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357951 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357968 */     GIR_RootConstrainSelectedInstOperands,
     /*  357969 */     // GIR_Coverage, 23177,
     /*  357969 */     GIR_EraseRootFromParent_Done,
     /*  357970 */   // Label 6519: @357970
     /*  357970 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(358033), // Rule ID 23178 //
     /*  357975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358014 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  358017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358031 */     GIR_RootConstrainSelectedInstOperands,
     /*  358032 */     // GIR_Coverage, 23178,
     /*  358032 */     GIR_EraseRootFromParent_Done,
     /*  358033 */   // Label 6520: @358033
     /*  358033 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(358096), // Rule ID 23179 //
     /*  358038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358077 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  358080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358094 */     GIR_RootConstrainSelectedInstOperands,
     /*  358095 */     // GIR_Coverage, 23179,
     /*  358095 */     GIR_EraseRootFromParent_Done,
     /*  358096 */   // Label 6521: @358096
     /*  358096 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(358159), // Rule ID 23180 //
     /*  358101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358140 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  358143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358157 */     GIR_RootConstrainSelectedInstOperands,
     /*  358158 */     // GIR_Coverage, 23180,
     /*  358158 */     GIR_EraseRootFromParent_Done,
     /*  358159 */   // Label 6522: @358159
     /*  358159 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(358222), // Rule ID 23181 //
     /*  358164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358203 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  358206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358220 */     GIR_RootConstrainSelectedInstOperands,
     /*  358221 */     // GIR_Coverage, 23181,
     /*  358221 */     GIR_EraseRootFromParent_Done,
     /*  358222 */   // Label 6523: @358222
     /*  358222 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(358285), // Rule ID 23182 //
     /*  358227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358266 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  358269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358283 */     GIR_RootConstrainSelectedInstOperands,
     /*  358284 */     // GIR_Coverage, 23182,
     /*  358284 */     GIR_EraseRootFromParent_Done,
     /*  358285 */   // Label 6524: @358285
     /*  358285 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(358348), // Rule ID 23183 //
     /*  358290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  358298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358329 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11492:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  358332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358346 */     GIR_RootConstrainSelectedInstOperands,
     /*  358347 */     // GIR_Coverage, 23183,
     /*  358347 */     GIR_EraseRootFromParent_Done,
     /*  358348 */   // Label 6525: @358348
     /*  358348 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(358411), // Rule ID 23184 //
     /*  358353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  358395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358409 */     GIR_RootConstrainSelectedInstOperands,
     /*  358410 */     // GIR_Coverage, 23184,
     /*  358410 */     GIR_EraseRootFromParent_Done,
     /*  358411 */   // Label 6526: @358411
     /*  358411 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(358474), // Rule ID 23185 //
     /*  358416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  358458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358472 */     GIR_RootConstrainSelectedInstOperands,
     /*  358473 */     // GIR_Coverage, 23185,
     /*  358473 */     GIR_EraseRootFromParent_Done,
     /*  358474 */   // Label 6527: @358474
     /*  358474 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(358537), // Rule ID 23186 //
     /*  358479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358535 */     GIR_RootConstrainSelectedInstOperands,
     /*  358536 */     // GIR_Coverage, 23186,
     /*  358536 */     GIR_EraseRootFromParent_Done,
     /*  358537 */   // Label 6528: @358537
     /*  358537 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(358600), // Rule ID 23187 //
     /*  358542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358581 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358598 */     GIR_RootConstrainSelectedInstOperands,
     /*  358599 */     // GIR_Coverage, 23187,
     /*  358599 */     GIR_EraseRootFromParent_Done,
     /*  358600 */   // Label 6529: @358600
     /*  358600 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(358663), // Rule ID 23188 //
     /*  358605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358661 */     GIR_RootConstrainSelectedInstOperands,
     /*  358662 */     // GIR_Coverage, 23188,
     /*  358662 */     GIR_EraseRootFromParent_Done,
     /*  358663 */   // Label 6530: @358663
     /*  358663 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(358726), // Rule ID 23189 //
     /*  358668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358707 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358724 */     GIR_RootConstrainSelectedInstOperands,
     /*  358725 */     // GIR_Coverage, 23189,
     /*  358725 */     GIR_EraseRootFromParent_Done,
     /*  358726 */   // Label 6531: @358726
     /*  358726 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(358789), // Rule ID 23190 //
     /*  358731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358787 */     GIR_RootConstrainSelectedInstOperands,
     /*  358788 */     // GIR_Coverage, 23190,
     /*  358788 */     GIR_EraseRootFromParent_Done,
     /*  358789 */   // Label 6532: @358789
     /*  358789 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(358852), // Rule ID 23191 //
     /*  358794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358850 */     GIR_RootConstrainSelectedInstOperands,
     /*  358851 */     // GIR_Coverage, 23191,
     /*  358851 */     GIR_EraseRootFromParent_Done,
     /*  358852 */   // Label 6533: @358852
     /*  358852 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(358915), // Rule ID 23192 //
     /*  358857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358913 */     GIR_RootConstrainSelectedInstOperands,
     /*  358914 */     // GIR_Coverage, 23192,
     /*  358914 */     GIR_EraseRootFromParent_Done,
     /*  358915 */   // Label 6534: @358915
     /*  358915 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(358978), // Rule ID 23193 //
     /*  358920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358976 */     GIR_RootConstrainSelectedInstOperands,
     /*  358977 */     // GIR_Coverage, 23193,
     /*  358977 */     GIR_EraseRootFromParent_Done,
     /*  358978 */   // Label 6535: @358978
     /*  358978 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(359041), // Rule ID 23194 //
     /*  358983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359022 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  359025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359039 */     GIR_RootConstrainSelectedInstOperands,
     /*  359040 */     // GIR_Coverage, 23194,
     /*  359040 */     GIR_EraseRootFromParent_Done,
     /*  359041 */   // Label 6536: @359041
     /*  359041 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(359104), // Rule ID 23195 //
     /*  359046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359085 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  359088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359102 */     GIR_RootConstrainSelectedInstOperands,
     /*  359103 */     // GIR_Coverage, 23195,
     /*  359103 */     GIR_EraseRootFromParent_Done,
     /*  359104 */   // Label 6537: @359104
     /*  359104 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(359167), // Rule ID 23196 //
     /*  359109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359148 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  359151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359165 */     GIR_RootConstrainSelectedInstOperands,
     /*  359166 */     // GIR_Coverage, 23196,
     /*  359166 */     GIR_EraseRootFromParent_Done,
     /*  359167 */   // Label 6538: @359167
     /*  359167 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(359230), // Rule ID 23197 //
     /*  359172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  359180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359211 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11469:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  359214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359228 */     GIR_RootConstrainSelectedInstOperands,
     /*  359229 */     // GIR_Coverage, 23197,
     /*  359229 */     GIR_EraseRootFromParent_Done,
     /*  359230 */   // Label 6539: @359230
     /*  359230 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(359293), // Rule ID 23198 //
     /*  359235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  359277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359291 */     GIR_RootConstrainSelectedInstOperands,
     /*  359292 */     // GIR_Coverage, 23198,
     /*  359292 */     GIR_EraseRootFromParent_Done,
     /*  359293 */   // Label 6540: @359293
     /*  359293 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(359356), // Rule ID 23199 //
     /*  359298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359337 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  359340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359354 */     GIR_RootConstrainSelectedInstOperands,
     /*  359355 */     // GIR_Coverage, 23199,
     /*  359355 */     GIR_EraseRootFromParent_Done,
     /*  359356 */   // Label 6541: @359356
     /*  359356 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(359419), // Rule ID 23200 //
     /*  359361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359417 */     GIR_RootConstrainSelectedInstOperands,
     /*  359418 */     // GIR_Coverage, 23200,
     /*  359418 */     GIR_EraseRootFromParent_Done,
     /*  359419 */   // Label 6542: @359419
     /*  359419 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(359482), // Rule ID 23201 //
     /*  359424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359463 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359480 */     GIR_RootConstrainSelectedInstOperands,
     /*  359481 */     // GIR_Coverage, 23201,
     /*  359481 */     GIR_EraseRootFromParent_Done,
     /*  359482 */   // Label 6543: @359482
     /*  359482 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(359545), // Rule ID 23202 //
     /*  359487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359543 */     GIR_RootConstrainSelectedInstOperands,
     /*  359544 */     // GIR_Coverage, 23202,
     /*  359544 */     GIR_EraseRootFromParent_Done,
     /*  359545 */   // Label 6544: @359545
     /*  359545 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(359608), // Rule ID 23203 //
     /*  359550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359589 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359606 */     GIR_RootConstrainSelectedInstOperands,
     /*  359607 */     // GIR_Coverage, 23203,
     /*  359607 */     GIR_EraseRootFromParent_Done,
     /*  359608 */   // Label 6545: @359608
     /*  359608 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(359671), // Rule ID 23204 //
     /*  359613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359669 */     GIR_RootConstrainSelectedInstOperands,
     /*  359670 */     // GIR_Coverage, 23204,
     /*  359670 */     GIR_EraseRootFromParent_Done,
     /*  359671 */   // Label 6546: @359671
     /*  359671 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(359734), // Rule ID 23205 //
     /*  359676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359715 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359732 */     GIR_RootConstrainSelectedInstOperands,
     /*  359733 */     // GIR_Coverage, 23205,
     /*  359733 */     GIR_EraseRootFromParent_Done,
     /*  359734 */   // Label 6547: @359734
     /*  359734 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(359797), // Rule ID 23206 //
     /*  359739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359795 */     GIR_RootConstrainSelectedInstOperands,
     /*  359796 */     // GIR_Coverage, 23206,
     /*  359796 */     GIR_EraseRootFromParent_Done,
     /*  359797 */   // Label 6548: @359797
     /*  359797 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(359860), // Rule ID 23207 //
     /*  359802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359841 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359858 */     GIR_RootConstrainSelectedInstOperands,
     /*  359859 */     // GIR_Coverage, 23207,
     /*  359859 */     GIR_EraseRootFromParent_Done,
     /*  359860 */   // Label 6549: @359860
     /*  359860 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(359923), // Rule ID 23208 //
     /*  359865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359904 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359921 */     GIR_RootConstrainSelectedInstOperands,
     /*  359922 */     // GIR_Coverage, 23208,
     /*  359922 */     GIR_EraseRootFromParent_Done,
     /*  359923 */   // Label 6550: @359923
     /*  359923 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(359986), // Rule ID 23209 //
     /*  359928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359967 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359984 */     GIR_RootConstrainSelectedInstOperands,
     /*  359985 */     // GIR_Coverage, 23209,
     /*  359985 */     GIR_EraseRootFromParent_Done,
     /*  359986 */   // Label 6551: @359986
     /*  359986 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(360049), // Rule ID 23210 //
     /*  359991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360030 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  360033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360047 */     GIR_RootConstrainSelectedInstOperands,
     /*  360048 */     // GIR_Coverage, 23210,
     /*  360048 */     GIR_EraseRootFromParent_Done,
     /*  360049 */   // Label 6552: @360049
     /*  360049 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(360112), // Rule ID 23211 //
     /*  360054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  360062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360093 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11538:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  360096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360110 */     GIR_RootConstrainSelectedInstOperands,
     /*  360111 */     // GIR_Coverage, 23211,
     /*  360111 */     GIR_EraseRootFromParent_Done,
     /*  360112 */   // Label 6553: @360112
     /*  360112 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(360175), // Rule ID 23212 //
     /*  360117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360156 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  360159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360173 */     GIR_RootConstrainSelectedInstOperands,
     /*  360174 */     // GIR_Coverage, 23212,
     /*  360174 */     GIR_EraseRootFromParent_Done,
     /*  360175 */   // Label 6554: @360175
     /*  360175 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(360238), // Rule ID 23213 //
     /*  360180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360219 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  360222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360236 */     GIR_RootConstrainSelectedInstOperands,
     /*  360237 */     // GIR_Coverage, 23213,
     /*  360237 */     GIR_EraseRootFromParent_Done,
     /*  360238 */   // Label 6555: @360238
     /*  360238 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(360301), // Rule ID 23214 //
     /*  360243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  360285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360299 */     GIR_RootConstrainSelectedInstOperands,
     /*  360300 */     // GIR_Coverage, 23214,
     /*  360300 */     GIR_EraseRootFromParent_Done,
     /*  360301 */   // Label 6556: @360301
     /*  360301 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(360364), // Rule ID 23215 //
     /*  360306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360345 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  360348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360362 */     GIR_RootConstrainSelectedInstOperands,
     /*  360363 */     // GIR_Coverage, 23215,
     /*  360363 */     GIR_EraseRootFromParent_Done,
     /*  360364 */   // Label 6557: @360364
     /*  360364 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(360427), // Rule ID 23216 //
     /*  360369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360425 */     GIR_RootConstrainSelectedInstOperands,
     /*  360426 */     // GIR_Coverage, 23216,
     /*  360426 */     GIR_EraseRootFromParent_Done,
     /*  360427 */   // Label 6558: @360427
     /*  360427 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(360490), // Rule ID 23217 //
     /*  360432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360488 */     GIR_RootConstrainSelectedInstOperands,
     /*  360489 */     // GIR_Coverage, 23217,
     /*  360489 */     GIR_EraseRootFromParent_Done,
     /*  360490 */   // Label 6559: @360490
     /*  360490 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(360553), // Rule ID 23218 //
     /*  360495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360551 */     GIR_RootConstrainSelectedInstOperands,
     /*  360552 */     // GIR_Coverage, 23218,
     /*  360552 */     GIR_EraseRootFromParent_Done,
     /*  360553 */   // Label 6560: @360553
     /*  360553 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(360616), // Rule ID 23219 //
     /*  360558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360597 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360614 */     GIR_RootConstrainSelectedInstOperands,
     /*  360615 */     // GIR_Coverage, 23219,
     /*  360615 */     GIR_EraseRootFromParent_Done,
     /*  360616 */   // Label 6561: @360616
     /*  360616 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(360679), // Rule ID 23220 //
     /*  360621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360677 */     GIR_RootConstrainSelectedInstOperands,
     /*  360678 */     // GIR_Coverage, 23220,
     /*  360678 */     GIR_EraseRootFromParent_Done,
     /*  360679 */   // Label 6562: @360679
     /*  360679 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(360742), // Rule ID 23221 //
     /*  360684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360723 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360740 */     GIR_RootConstrainSelectedInstOperands,
     /*  360741 */     // GIR_Coverage, 23221,
     /*  360741 */     GIR_EraseRootFromParent_Done,
     /*  360742 */   // Label 6563: @360742
     /*  360742 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(360805), // Rule ID 23222 //
     /*  360747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360786 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360803 */     GIR_RootConstrainSelectedInstOperands,
     /*  360804 */     // GIR_Coverage, 23222,
     /*  360804 */     GIR_EraseRootFromParent_Done,
     /*  360805 */   // Label 6564: @360805
     /*  360805 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(360868), // Rule ID 23223 //
     /*  360810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360849 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360866 */     GIR_RootConstrainSelectedInstOperands,
     /*  360867 */     // GIR_Coverage, 23223,
     /*  360867 */     GIR_EraseRootFromParent_Done,
     /*  360868 */   // Label 6565: @360868
     /*  360868 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(360931), // Rule ID 23224 //
     /*  360873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360912 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360929 */     GIR_RootConstrainSelectedInstOperands,
     /*  360930 */     // GIR_Coverage, 23224,
     /*  360930 */     GIR_EraseRootFromParent_Done,
     /*  360931 */   // Label 6566: @360931
     /*  360931 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(360994), // Rule ID 23225 //
     /*  360936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360975 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11494:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360992 */     GIR_RootConstrainSelectedInstOperands,
     /*  360993 */     // GIR_Coverage, 23225,
     /*  360993 */     GIR_EraseRootFromParent_Done,
     /*  360994 */   // Label 6567: @360994
     /*  360994 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(361057), // Rule ID 23226 //
     /*  360999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  361041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361055 */     GIR_RootConstrainSelectedInstOperands,
     /*  361056 */     // GIR_Coverage, 23226,
     /*  361056 */     GIR_EraseRootFromParent_Done,
     /*  361057 */   // Label 6568: @361057
     /*  361057 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(361120), // Rule ID 23227 //
     /*  361062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361101 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  361104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361118 */     GIR_RootConstrainSelectedInstOperands,
     /*  361119 */     // GIR_Coverage, 23227,
     /*  361119 */     GIR_EraseRootFromParent_Done,
     /*  361120 */   // Label 6569: @361120
     /*  361120 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(361183), // Rule ID 23228 //
     /*  361125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  361167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361181 */     GIR_RootConstrainSelectedInstOperands,
     /*  361182 */     // GIR_Coverage, 23228,
     /*  361182 */     GIR_EraseRootFromParent_Done,
     /*  361183 */   // Label 6570: @361183
     /*  361183 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(361246), // Rule ID 23229 //
     /*  361188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361227 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  361230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361244 */     GIR_RootConstrainSelectedInstOperands,
     /*  361245 */     // GIR_Coverage, 23229,
     /*  361245 */     GIR_EraseRootFromParent_Done,
     /*  361246 */   // Label 6571: @361246
     /*  361246 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(361309), // Rule ID 23230 //
     /*  361251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  361293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361307 */     GIR_RootConstrainSelectedInstOperands,
     /*  361308 */     // GIR_Coverage, 23230,
     /*  361308 */     GIR_EraseRootFromParent_Done,
     /*  361309 */   // Label 6572: @361309
     /*  361309 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(361372), // Rule ID 23231 //
     /*  361314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361353 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  361356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361370 */     GIR_RootConstrainSelectedInstOperands,
     /*  361371 */     // GIR_Coverage, 23231,
     /*  361371 */     GIR_EraseRootFromParent_Done,
     /*  361372 */   // Label 6573: @361372
     /*  361372 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(361435), // Rule ID 23232 //
     /*  361377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361433 */     GIR_RootConstrainSelectedInstOperands,
     /*  361434 */     // GIR_Coverage, 23232,
     /*  361434 */     GIR_EraseRootFromParent_Done,
     /*  361435 */   // Label 6574: @361435
     /*  361435 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(361498), // Rule ID 23233 //
     /*  361440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361479 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361496 */     GIR_RootConstrainSelectedInstOperands,
     /*  361497 */     // GIR_Coverage, 23233,
     /*  361497 */     GIR_EraseRootFromParent_Done,
     /*  361498 */   // Label 6575: @361498
     /*  361498 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(361561), // Rule ID 23234 //
     /*  361503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361559 */     GIR_RootConstrainSelectedInstOperands,
     /*  361560 */     // GIR_Coverage, 23234,
     /*  361560 */     GIR_EraseRootFromParent_Done,
     /*  361561 */   // Label 6576: @361561
     /*  361561 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(361624), // Rule ID 23235 //
     /*  361566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361605 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361622 */     GIR_RootConstrainSelectedInstOperands,
     /*  361623 */     // GIR_Coverage, 23235,
     /*  361623 */     GIR_EraseRootFromParent_Done,
     /*  361624 */   // Label 6577: @361624
     /*  361624 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(361687), // Rule ID 23236 //
     /*  361629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361668 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361685 */     GIR_RootConstrainSelectedInstOperands,
     /*  361686 */     // GIR_Coverage, 23236,
     /*  361686 */     GIR_EraseRootFromParent_Done,
     /*  361687 */   // Label 6578: @361687
     /*  361687 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(361750), // Rule ID 23237 //
     /*  361692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361731 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361748 */     GIR_RootConstrainSelectedInstOperands,
     /*  361749 */     // GIR_Coverage, 23237,
     /*  361749 */     GIR_EraseRootFromParent_Done,
     /*  361750 */   // Label 6579: @361750
     /*  361750 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(361813), // Rule ID 23238 //
     /*  361755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361794 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361811 */     GIR_RootConstrainSelectedInstOperands,
     /*  361812 */     // GIR_Coverage, 23238,
     /*  361812 */     GIR_EraseRootFromParent_Done,
     /*  361813 */   // Label 6580: @361813
     /*  361813 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(361876), // Rule ID 23239 //
     /*  361818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361857 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11493:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361874 */     GIR_RootConstrainSelectedInstOperands,
     /*  361875 */     // GIR_Coverage, 23239,
     /*  361875 */     GIR_EraseRootFromParent_Done,
     /*  361876 */   // Label 6581: @361876
     /*  361876 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(361939), // Rule ID 23240 //
     /*  361881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361937 */     GIR_RootConstrainSelectedInstOperands,
     /*  361938 */     // GIR_Coverage, 23240,
     /*  361938 */     GIR_EraseRootFromParent_Done,
     /*  361939 */   // Label 6582: @361939
     /*  361939 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(362002), // Rule ID 23241 //
     /*  361944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362000 */     GIR_RootConstrainSelectedInstOperands,
     /*  362001 */     // GIR_Coverage, 23241,
     /*  362001 */     GIR_EraseRootFromParent_Done,
     /*  362002 */   // Label 6583: @362002
     /*  362002 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(362065), // Rule ID 23242 //
     /*  362007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362046 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  362049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362063 */     GIR_RootConstrainSelectedInstOperands,
     /*  362064 */     // GIR_Coverage, 23242,
     /*  362064 */     GIR_EraseRootFromParent_Done,
     /*  362065 */   // Label 6584: @362065
     /*  362065 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(362128), // Rule ID 23243 //
     /*  362070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362109 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  362112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362126 */     GIR_RootConstrainSelectedInstOperands,
     /*  362127 */     // GIR_Coverage, 23243,
     /*  362127 */     GIR_EraseRootFromParent_Done,
     /*  362128 */   // Label 6585: @362128
     /*  362128 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(362191), // Rule ID 23244 //
     /*  362133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  362175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362189 */     GIR_RootConstrainSelectedInstOperands,
     /*  362190 */     // GIR_Coverage, 23244,
     /*  362190 */     GIR_EraseRootFromParent_Done,
     /*  362191 */   // Label 6586: @362191
     /*  362191 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(362254), // Rule ID 23245 //
     /*  362196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362235 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  362238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362252 */     GIR_RootConstrainSelectedInstOperands,
     /*  362253 */     // GIR_Coverage, 23245,
     /*  362253 */     GIR_EraseRootFromParent_Done,
     /*  362254 */   // Label 6587: @362254
     /*  362254 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(362317), // Rule ID 23246 //
     /*  362259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  362301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362315 */     GIR_RootConstrainSelectedInstOperands,
     /*  362316 */     // GIR_Coverage, 23246,
     /*  362316 */     GIR_EraseRootFromParent_Done,
     /*  362317 */   // Label 6588: @362317
     /*  362317 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(362380), // Rule ID 23247 //
     /*  362322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362361 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  362364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362378 */     GIR_RootConstrainSelectedInstOperands,
     /*  362379 */     // GIR_Coverage, 23247,
     /*  362379 */     GIR_EraseRootFromParent_Done,
     /*  362380 */   // Label 6589: @362380
     /*  362380 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(362443), // Rule ID 23248 //
     /*  362385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362441 */     GIR_RootConstrainSelectedInstOperands,
     /*  362442 */     // GIR_Coverage, 23248,
     /*  362442 */     GIR_EraseRootFromParent_Done,
     /*  362443 */   // Label 6590: @362443
     /*  362443 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(362506), // Rule ID 23249 //
     /*  362448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362504 */     GIR_RootConstrainSelectedInstOperands,
     /*  362505 */     // GIR_Coverage, 23249,
     /*  362505 */     GIR_EraseRootFromParent_Done,
     /*  362506 */   // Label 6591: @362506
     /*  362506 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(362569), // Rule ID 23250 //
     /*  362511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362550 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362567 */     GIR_RootConstrainSelectedInstOperands,
     /*  362568 */     // GIR_Coverage, 23250,
     /*  362568 */     GIR_EraseRootFromParent_Done,
     /*  362569 */   // Label 6592: @362569
     /*  362569 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(362632), // Rule ID 23251 //
     /*  362574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362613 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362630 */     GIR_RootConstrainSelectedInstOperands,
     /*  362631 */     // GIR_Coverage, 23251,
     /*  362631 */     GIR_EraseRootFromParent_Done,
     /*  362632 */   // Label 6593: @362632
     /*  362632 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(362695), // Rule ID 23252 //
     /*  362637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362676 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362693 */     GIR_RootConstrainSelectedInstOperands,
     /*  362694 */     // GIR_Coverage, 23252,
     /*  362694 */     GIR_EraseRootFromParent_Done,
     /*  362695 */   // Label 6594: @362695
     /*  362695 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(362758), // Rule ID 23253 //
     /*  362700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362739 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11495:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362756 */     GIR_RootConstrainSelectedInstOperands,
     /*  362757 */     // GIR_Coverage, 23253,
     /*  362757 */     GIR_EraseRootFromParent_Done,
     /*  362758 */   // Label 6595: @362758
     /*  362758 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(362821), // Rule ID 23254 //
     /*  362763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362802 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362819 */     GIR_RootConstrainSelectedInstOperands,
     /*  362820 */     // GIR_Coverage, 23254,
     /*  362820 */     GIR_EraseRootFromParent_Done,
     /*  362821 */   // Label 6596: @362821
     /*  362821 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(362884), // Rule ID 23255 //
     /*  362826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362882 */     GIR_RootConstrainSelectedInstOperands,
     /*  362883 */     // GIR_Coverage, 23255,
     /*  362883 */     GIR_EraseRootFromParent_Done,
     /*  362884 */   // Label 6597: @362884
     /*  362884 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(362947), // Rule ID 23256 //
     /*  362889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362945 */     GIR_RootConstrainSelectedInstOperands,
     /*  362946 */     // GIR_Coverage, 23256,
     /*  362946 */     GIR_EraseRootFromParent_Done,
     /*  362947 */   // Label 6598: @362947
     /*  362947 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(363010), // Rule ID 23257 //
     /*  362952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363008 */     GIR_RootConstrainSelectedInstOperands,
     /*  363009 */     // GIR_Coverage, 23257,
     /*  363009 */     GIR_EraseRootFromParent_Done,
     /*  363010 */   // Label 6599: @363010
     /*  363010 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(363073), // Rule ID 23258 //
     /*  363015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363054 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  363057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363071 */     GIR_RootConstrainSelectedInstOperands,
     /*  363072 */     // GIR_Coverage, 23258,
     /*  363072 */     GIR_EraseRootFromParent_Done,
     /*  363073 */   // Label 6600: @363073
     /*  363073 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(363136), // Rule ID 23259 //
     /*  363078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  363120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363134 */     GIR_RootConstrainSelectedInstOperands,
     /*  363135 */     // GIR_Coverage, 23259,
     /*  363135 */     GIR_EraseRootFromParent_Done,
     /*  363136 */   // Label 6601: @363136
     /*  363136 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(363199), // Rule ID 23260 //
     /*  363141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  363183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363197 */     GIR_RootConstrainSelectedInstOperands,
     /*  363198 */     // GIR_Coverage, 23260,
     /*  363198 */     GIR_EraseRootFromParent_Done,
     /*  363199 */   // Label 6602: @363199
     /*  363199 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(363262), // Rule ID 23261 //
     /*  363204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363243 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  363246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363260 */     GIR_RootConstrainSelectedInstOperands,
     /*  363261 */     // GIR_Coverage, 23261,
     /*  363261 */     GIR_EraseRootFromParent_Done,
     /*  363262 */   // Label 6603: @363262
     /*  363262 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(363325), // Rule ID 23262 //
     /*  363267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  363309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363323 */     GIR_RootConstrainSelectedInstOperands,
     /*  363324 */     // GIR_Coverage, 23262,
     /*  363324 */     GIR_EraseRootFromParent_Done,
     /*  363325 */   // Label 6604: @363325
     /*  363325 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(363388), // Rule ID 23263 //
     /*  363330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363369 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  363372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363386 */     GIR_RootConstrainSelectedInstOperands,
     /*  363387 */     // GIR_Coverage, 23263,
     /*  363387 */     GIR_EraseRootFromParent_Done,
     /*  363388 */   // Label 6605: @363388
     /*  363388 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(363451), // Rule ID 23264 //
     /*  363393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363432 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363449 */     GIR_RootConstrainSelectedInstOperands,
     /*  363450 */     // GIR_Coverage, 23264,
     /*  363450 */     GIR_EraseRootFromParent_Done,
     /*  363451 */   // Label 6606: @363451
     /*  363451 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(363514), // Rule ID 23265 //
     /*  363456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363495 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363512 */     GIR_RootConstrainSelectedInstOperands,
     /*  363513 */     // GIR_Coverage, 23265,
     /*  363513 */     GIR_EraseRootFromParent_Done,
     /*  363514 */   // Label 6607: @363514
     /*  363514 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(363577), // Rule ID 23266 //
     /*  363519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363558 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363575 */     GIR_RootConstrainSelectedInstOperands,
     /*  363576 */     // GIR_Coverage, 23266,
     /*  363576 */     GIR_EraseRootFromParent_Done,
     /*  363577 */   // Label 6608: @363577
     /*  363577 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(363640), // Rule ID 23267 //
     /*  363582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363621 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11537:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363638 */     GIR_RootConstrainSelectedInstOperands,
     /*  363639 */     // GIR_Coverage, 23267,
     /*  363639 */     GIR_EraseRootFromParent_Done,
     /*  363640 */   // Label 6609: @363640
     /*  363640 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(363703), // Rule ID 23296 //
     /*  363645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363684 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363691 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363701 */     GIR_RootConstrainSelectedInstOperands,
     /*  363702 */     // GIR_Coverage, 23296,
     /*  363702 */     GIR_EraseRootFromParent_Done,
     /*  363703 */   // Label 6610: @363703
     /*  363703 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(363766), // Rule ID 23297 //
     /*  363708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363747 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363754 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363764 */     GIR_RootConstrainSelectedInstOperands,
     /*  363765 */     // GIR_Coverage, 23297,
     /*  363765 */     GIR_EraseRootFromParent_Done,
     /*  363766 */   // Label 6611: @363766
     /*  363766 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(363829), // Rule ID 23300 //
     /*  363771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363810 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363817 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363827 */     GIR_RootConstrainSelectedInstOperands,
     /*  363828 */     // GIR_Coverage, 23300,
     /*  363828 */     GIR_EraseRootFromParent_Done,
     /*  363829 */   // Label 6612: @363829
     /*  363829 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(363892), // Rule ID 23301 //
     /*  363834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363873 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363880 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363890 */     GIR_RootConstrainSelectedInstOperands,
     /*  363891 */     // GIR_Coverage, 23301,
     /*  363891 */     GIR_EraseRootFromParent_Done,
     /*  363892 */   // Label 6613: @363892
     /*  363892 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(363955), // Rule ID 23304 //
     /*  363897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363936 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363943 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363953 */     GIR_RootConstrainSelectedInstOperands,
     /*  363954 */     // GIR_Coverage, 23304,
     /*  363954 */     GIR_EraseRootFromParent_Done,
     /*  363955 */   // Label 6614: @363955
     /*  363955 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(364018), // Rule ID 23305 //
     /*  363960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363999 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  364002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364006 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364016 */     GIR_RootConstrainSelectedInstOperands,
     /*  364017 */     // GIR_Coverage, 23305,
     /*  364017 */     GIR_EraseRootFromParent_Done,
     /*  364018 */   // Label 6615: @364018
     /*  364018 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(364081), // Rule ID 23308 //
     /*  364023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364062 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  364065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364079 */     GIR_RootConstrainSelectedInstOperands,
     /*  364080 */     // GIR_Coverage, 23308,
     /*  364080 */     GIR_EraseRootFromParent_Done,
     /*  364081 */   // Label 6616: @364081
     /*  364081 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(364144), // Rule ID 23309 //
     /*  364086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364125 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  364128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364132 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364142 */     GIR_RootConstrainSelectedInstOperands,
     /*  364143 */     // GIR_Coverage, 23309,
     /*  364143 */     GIR_EraseRootFromParent_Done,
     /*  364144 */   // Label 6617: @364144
     /*  364144 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(364207), // Rule ID 23312 //
     /*  364149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364188 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  364191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364195 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364205 */     GIR_RootConstrainSelectedInstOperands,
     /*  364206 */     // GIR_Coverage, 23312,
     /*  364206 */     GIR_EraseRootFromParent_Done,
     /*  364207 */   // Label 6618: @364207
     /*  364207 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(364270), // Rule ID 23313 //
     /*  364212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364251 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  364254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364258 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364268 */     GIR_RootConstrainSelectedInstOperands,
     /*  364269 */     // GIR_Coverage, 23313,
     /*  364269 */     GIR_EraseRootFromParent_Done,
     /*  364270 */   // Label 6619: @364270
     /*  364270 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(364333), // Rule ID 23316 //
     /*  364275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364314 */     // (intrinsic_wo_chain:{ *:[i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  364317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364321 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364331 */     GIR_RootConstrainSelectedInstOperands,
     /*  364332 */     // GIR_Coverage, 23316,
     /*  364332 */     GIR_EraseRootFromParent_Done,
     /*  364333 */   // Label 6620: @364333
     /*  364333 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(364396), // Rule ID 23317 //
     /*  364338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  364346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364377 */     // (intrinsic_wo_chain:{ *:[i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  364380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364384 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364394 */     GIR_RootConstrainSelectedInstOperands,
     /*  364395 */     // GIR_Coverage, 23317,
     /*  364395 */     GIR_EraseRootFromParent_Done,
     /*  364396 */   // Label 6621: @364396
     /*  364396 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(364459), // Rule ID 23320 //
     /*  364401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364440 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364447 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364457 */     GIR_RootConstrainSelectedInstOperands,
     /*  364458 */     // GIR_Coverage, 23320,
     /*  364458 */     GIR_EraseRootFromParent_Done,
     /*  364459 */   // Label 6622: @364459
     /*  364459 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(364522), // Rule ID 23321 //
     /*  364464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364503 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364510 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364520 */     GIR_RootConstrainSelectedInstOperands,
     /*  364521 */     // GIR_Coverage, 23321,
     /*  364521 */     GIR_EraseRootFromParent_Done,
     /*  364522 */   // Label 6623: @364522
     /*  364522 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(364585), // Rule ID 23324 //
     /*  364527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364566 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364573 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364583 */     GIR_RootConstrainSelectedInstOperands,
     /*  364584 */     // GIR_Coverage, 23324,
     /*  364584 */     GIR_EraseRootFromParent_Done,
     /*  364585 */   // Label 6624: @364585
     /*  364585 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(364648), // Rule ID 23325 //
     /*  364590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364629 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364636 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364646 */     GIR_RootConstrainSelectedInstOperands,
     /*  364647 */     // GIR_Coverage, 23325,
     /*  364647 */     GIR_EraseRootFromParent_Done,
     /*  364648 */   // Label 6625: @364648
     /*  364648 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(364711), // Rule ID 23328 //
     /*  364653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364692 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364699 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364709 */     GIR_RootConstrainSelectedInstOperands,
     /*  364710 */     // GIR_Coverage, 23328,
     /*  364710 */     GIR_EraseRootFromParent_Done,
     /*  364711 */   // Label 6626: @364711
     /*  364711 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(364774), // Rule ID 23329 //
     /*  364716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364755 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364762 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364772 */     GIR_RootConstrainSelectedInstOperands,
     /*  364773 */     // GIR_Coverage, 23329,
     /*  364773 */     GIR_EraseRootFromParent_Done,
     /*  364774 */   // Label 6627: @364774
     /*  364774 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(364837), // Rule ID 23332 //
     /*  364779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364818 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364825 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364835 */     GIR_RootConstrainSelectedInstOperands,
     /*  364836 */     // GIR_Coverage, 23332,
     /*  364836 */     GIR_EraseRootFromParent_Done,
     /*  364837 */   // Label 6628: @364837
     /*  364837 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(364900), // Rule ID 23333 //
     /*  364842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364881 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364888 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364898 */     GIR_RootConstrainSelectedInstOperands,
     /*  364899 */     // GIR_Coverage, 23333,
     /*  364899 */     GIR_EraseRootFromParent_Done,
     /*  364900 */   // Label 6629: @364900
     /*  364900 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(364963), // Rule ID 23336 //
     /*  364905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364944 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364951 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364961 */     GIR_RootConstrainSelectedInstOperands,
     /*  364962 */     // GIR_Coverage, 23336,
     /*  364962 */     GIR_EraseRootFromParent_Done,
     /*  364963 */   // Label 6630: @364963
     /*  364963 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(365026), // Rule ID 23337 //
     /*  364968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365007 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  365010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365014 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365024 */     GIR_RootConstrainSelectedInstOperands,
     /*  365025 */     // GIR_Coverage, 23337,
     /*  365025 */     GIR_EraseRootFromParent_Done,
     /*  365026 */   // Label 6631: @365026
     /*  365026 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(365089), // Rule ID 23340 //
     /*  365031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  365034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  365042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365070 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  365073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365087 */     GIR_RootConstrainSelectedInstOperands,
     /*  365088 */     // GIR_Coverage, 23340,
     /*  365088 */     GIR_EraseRootFromParent_Done,
     /*  365089 */   // Label 6632: @365089
     /*  365089 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(365152), // Rule ID 23341 //
     /*  365094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  365097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  365105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365133 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  365136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365150 */     GIR_RootConstrainSelectedInstOperands,
     /*  365151 */     // GIR_Coverage, 23341,
     /*  365151 */     GIR_EraseRootFromParent_Done,
     /*  365152 */   // Label 6633: @365152
     /*  365152 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(365215), // Rule ID 23344 //
     /*  365157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  365160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  365168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365196 */     // (intrinsic_wo_chain:{ *:[i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  365199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365203 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365213 */     GIR_RootConstrainSelectedInstOperands,
     /*  365214 */     // GIR_Coverage, 23344,
     /*  365214 */     GIR_EraseRootFromParent_Done,
     /*  365215 */   // Label 6634: @365215
     /*  365215 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(365278), // Rule ID 23345 //
     /*  365220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  365223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  365228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  365231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  365244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  365252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365259 */     // (intrinsic_wo_chain:{ *:[i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  365262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365266 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  365268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365276 */     GIR_RootConstrainSelectedInstOperands,
     /*  365277 */     // GIR_Coverage, 23345,
     /*  365277 */     GIR_EraseRootFromParent_Done,
     /*  365278 */   // Label 6635: @365278
     /*  365278 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(365344), // Rule ID 23426 //
     /*  365283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  365294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  365297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365322 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365342 */     GIR_RootConstrainSelectedInstOperands,
     /*  365343 */     // GIR_Coverage, 23426,
     /*  365343 */     GIR_EraseRootFromParent_Done,
     /*  365344 */   // Label 6636: @365344
     /*  365344 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(365410), // Rule ID 23427 //
     /*  365349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  365360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  365363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365408 */     GIR_RootConstrainSelectedInstOperands,
     /*  365409 */     // GIR_Coverage, 23427,
     /*  365409 */     GIR_EraseRootFromParent_Done,
     /*  365410 */   // Label 6637: @365410
     /*  365410 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(365476), // Rule ID 23430 //
     /*  365415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365474 */     GIR_RootConstrainSelectedInstOperands,
     /*  365475 */     // GIR_Coverage, 23430,
     /*  365475 */     GIR_EraseRootFromParent_Done,
     /*  365476 */   // Label 6638: @365476
     /*  365476 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(365542), // Rule ID 23431 //
     /*  365481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365540 */     GIR_RootConstrainSelectedInstOperands,
     /*  365541 */     // GIR_Coverage, 23431,
     /*  365541 */     GIR_EraseRootFromParent_Done,
     /*  365542 */   // Label 6639: @365542
     /*  365542 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(365608), // Rule ID 23434 //
     /*  365547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365606 */     GIR_RootConstrainSelectedInstOperands,
     /*  365607 */     // GIR_Coverage, 23434,
     /*  365607 */     GIR_EraseRootFromParent_Done,
     /*  365608 */   // Label 6640: @365608
     /*  365608 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(365674), // Rule ID 23435 //
     /*  365613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365672 */     GIR_RootConstrainSelectedInstOperands,
     /*  365673 */     // GIR_Coverage, 23435,
     /*  365673 */     GIR_EraseRootFromParent_Done,
     /*  365674 */   // Label 6641: @365674
     /*  365674 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(365740), // Rule ID 23438 //
     /*  365679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365738 */     GIR_RootConstrainSelectedInstOperands,
     /*  365739 */     // GIR_Coverage, 23438,
     /*  365739 */     GIR_EraseRootFromParent_Done,
     /*  365740 */   // Label 6642: @365740
     /*  365740 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(365806), // Rule ID 23439 //
     /*  365745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365804 */     GIR_RootConstrainSelectedInstOperands,
     /*  365805 */     // GIR_Coverage, 23439,
     /*  365805 */     GIR_EraseRootFromParent_Done,
     /*  365806 */   // Label 6643: @365806
     /*  365806 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(365872), // Rule ID 23442 //
     /*  365811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365870 */     GIR_RootConstrainSelectedInstOperands,
     /*  365871 */     // GIR_Coverage, 23442,
     /*  365871 */     GIR_EraseRootFromParent_Done,
     /*  365872 */   // Label 6644: @365872
     /*  365872 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(365938), // Rule ID 23443 //
     /*  365877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365936 */     GIR_RootConstrainSelectedInstOperands,
     /*  365937 */     // GIR_Coverage, 23443,
     /*  365937 */     GIR_EraseRootFromParent_Done,
     /*  365938 */   // Label 6645: @365938
     /*  365938 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(366004), // Rule ID 23446 //
     /*  365943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366002 */     GIR_RootConstrainSelectedInstOperands,
     /*  366003 */     // GIR_Coverage, 23446,
     /*  366003 */     GIR_EraseRootFromParent_Done,
     /*  366004 */   // Label 6646: @366004
     /*  366004 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(366070), // Rule ID 23447 //
     /*  366009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  366020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  366023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366068 */     GIR_RootConstrainSelectedInstOperands,
     /*  366069 */     // GIR_Coverage, 23447,
     /*  366069 */     GIR_EraseRootFromParent_Done,
     /*  366070 */   // Label 6647: @366070
     /*  366070 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(366136), // Rule ID 23450 //
     /*  366075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  366086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  366089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366134 */     GIR_RootConstrainSelectedInstOperands,
     /*  366135 */     // GIR_Coverage, 23450,
     /*  366135 */     GIR_EraseRootFromParent_Done,
     /*  366136 */   // Label 6648: @366136
     /*  366136 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(366202), // Rule ID 23451 //
     /*  366141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  366152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  366155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366200 */     GIR_RootConstrainSelectedInstOperands,
     /*  366201 */     // GIR_Coverage, 23451,
     /*  366201 */     GIR_EraseRootFromParent_Done,
     /*  366202 */   // Label 6649: @366202
     /*  366202 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(366268), // Rule ID 23454 //
     /*  366207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  366218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  366221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366266 */     GIR_RootConstrainSelectedInstOperands,
     /*  366267 */     // GIR_Coverage, 23454,
     /*  366267 */     GIR_EraseRootFromParent_Done,
     /*  366268 */   // Label 6650: @366268
     /*  366268 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(366334), // Rule ID 23455 //
     /*  366273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  366284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  366287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366332 */     GIR_RootConstrainSelectedInstOperands,
     /*  366333 */     // GIR_Coverage, 23455,
     /*  366333 */     GIR_EraseRootFromParent_Done,
     /*  366334 */   // Label 6651: @366334
     /*  366334 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(366400), // Rule ID 23458 //
     /*  366339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  366342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  366350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  366353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  366378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366398 */     GIR_RootConstrainSelectedInstOperands,
     /*  366399 */     // GIR_Coverage, 23458,
     /*  366399 */     GIR_EraseRootFromParent_Done,
     /*  366400 */   // Label 6652: @366400
     /*  366400 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(366466), // Rule ID 23459 //
     /*  366405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  366408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  366416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  366419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  366444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  366447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366464 */     GIR_RootConstrainSelectedInstOperands,
     /*  366465 */     // GIR_Coverage, 23459,
     /*  366465 */     GIR_EraseRootFromParent_Done,
     /*  366466 */   // Label 6653: @366466
     /*  366466 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(366532), // Rule ID 23462 //
     /*  366471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366510 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366530 */     GIR_RootConstrainSelectedInstOperands,
     /*  366531 */     // GIR_Coverage, 23462,
     /*  366531 */     GIR_EraseRootFromParent_Done,
     /*  366532 */   // Label 6654: @366532
     /*  366532 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(366598), // Rule ID 23463 //
     /*  366537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366596 */     GIR_RootConstrainSelectedInstOperands,
     /*  366597 */     // GIR_Coverage, 23463,
     /*  366597 */     GIR_EraseRootFromParent_Done,
     /*  366598 */   // Label 6655: @366598
     /*  366598 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(366664), // Rule ID 23466 //
     /*  366603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366642 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366662 */     GIR_RootConstrainSelectedInstOperands,
     /*  366663 */     // GIR_Coverage, 23466,
     /*  366663 */     GIR_EraseRootFromParent_Done,
     /*  366664 */   // Label 6656: @366664
     /*  366664 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(366730), // Rule ID 23467 //
     /*  366669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366728 */     GIR_RootConstrainSelectedInstOperands,
     /*  366729 */     // GIR_Coverage, 23467,
     /*  366729 */     GIR_EraseRootFromParent_Done,
     /*  366730 */   // Label 6657: @366730
     /*  366730 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(366796), // Rule ID 23470 //
     /*  366735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366774 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366794 */     GIR_RootConstrainSelectedInstOperands,
     /*  366795 */     // GIR_Coverage, 23470,
     /*  366795 */     GIR_EraseRootFromParent_Done,
     /*  366796 */   // Label 6658: @366796
     /*  366796 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(366862), // Rule ID 23471 //
     /*  366801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366840 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366860 */     GIR_RootConstrainSelectedInstOperands,
     /*  366861 */     // GIR_Coverage, 23471,
     /*  366861 */     GIR_EraseRootFromParent_Done,
     /*  366862 */   // Label 6659: @366862
     /*  366862 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(366928), // Rule ID 23474 //
     /*  366867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366926 */     GIR_RootConstrainSelectedInstOperands,
     /*  366927 */     // GIR_Coverage, 23474,
     /*  366927 */     GIR_EraseRootFromParent_Done,
     /*  366928 */   // Label 6660: @366928
     /*  366928 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(366994), // Rule ID 23475 //
     /*  366933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366992 */     GIR_RootConstrainSelectedInstOperands,
     /*  366993 */     // GIR_Coverage, 23475,
     /*  366993 */     GIR_EraseRootFromParent_Done,
     /*  366994 */   // Label 6661: @366994
     /*  366994 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(367060), // Rule ID 23478 //
     /*  366999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367058 */     GIR_RootConstrainSelectedInstOperands,
     /*  367059 */     // GIR_Coverage, 23478,
     /*  367059 */     GIR_EraseRootFromParent_Done,
     /*  367060 */   // Label 6662: @367060
     /*  367060 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(367126), // Rule ID 23479 //
     /*  367065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  367076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  367079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367124 */     GIR_RootConstrainSelectedInstOperands,
     /*  367125 */     // GIR_Coverage, 23479,
     /*  367125 */     GIR_EraseRootFromParent_Done,
     /*  367126 */   // Label 6663: @367126
     /*  367126 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(367192), // Rule ID 23482 //
     /*  367131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  367142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  367145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367190 */     GIR_RootConstrainSelectedInstOperands,
     /*  367191 */     // GIR_Coverage, 23482,
     /*  367191 */     GIR_EraseRootFromParent_Done,
     /*  367192 */   // Label 6664: @367192
     /*  367192 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(367258), // Rule ID 23483 //
     /*  367197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  367208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  367211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367256 */     GIR_RootConstrainSelectedInstOperands,
     /*  367257 */     // GIR_Coverage, 23483,
     /*  367257 */     GIR_EraseRootFromParent_Done,
     /*  367258 */   // Label 6665: @367258
     /*  367258 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(367324), // Rule ID 23486 //
     /*  367263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  367274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  367277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367322 */     GIR_RootConstrainSelectedInstOperands,
     /*  367323 */     // GIR_Coverage, 23486,
     /*  367323 */     GIR_EraseRootFromParent_Done,
     /*  367324 */   // Label 6666: @367324
     /*  367324 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(367390), // Rule ID 23487 //
     /*  367329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  367340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  367343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367388 */     GIR_RootConstrainSelectedInstOperands,
     /*  367389 */     // GIR_Coverage, 23487,
     /*  367389 */     GIR_EraseRootFromParent_Done,
     /*  367390 */   // Label 6667: @367390
     /*  367390 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(367456), // Rule ID 23490 //
     /*  367395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367454 */     GIR_RootConstrainSelectedInstOperands,
     /*  367455 */     // GIR_Coverage, 23490,
     /*  367455 */     GIR_EraseRootFromParent_Done,
     /*  367456 */   // Label 6668: @367456
     /*  367456 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(367522), // Rule ID 23491 //
     /*  367461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367520 */     GIR_RootConstrainSelectedInstOperands,
     /*  367521 */     // GIR_Coverage, 23491,
     /*  367521 */     GIR_EraseRootFromParent_Done,
     /*  367522 */   // Label 6669: @367522
     /*  367522 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(367588), // Rule ID 23494 //
     /*  367527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367586 */     GIR_RootConstrainSelectedInstOperands,
     /*  367587 */     // GIR_Coverage, 23494,
     /*  367587 */     GIR_EraseRootFromParent_Done,
     /*  367588 */   // Label 6670: @367588
     /*  367588 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(367654), // Rule ID 23495 //
     /*  367593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367652 */     GIR_RootConstrainSelectedInstOperands,
     /*  367653 */     // GIR_Coverage, 23495,
     /*  367653 */     GIR_EraseRootFromParent_Done,
     /*  367654 */   // Label 6671: @367654
     /*  367654 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(367720), // Rule ID 23498 //
     /*  367659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367718 */     GIR_RootConstrainSelectedInstOperands,
     /*  367719 */     // GIR_Coverage, 23498,
     /*  367719 */     GIR_EraseRootFromParent_Done,
     /*  367720 */   // Label 6672: @367720
     /*  367720 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(367786), // Rule ID 23499 //
     /*  367725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367784 */     GIR_RootConstrainSelectedInstOperands,
     /*  367785 */     // GIR_Coverage, 23499,
     /*  367785 */     GIR_EraseRootFromParent_Done,
     /*  367786 */   // Label 6673: @367786
     /*  367786 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(367852), // Rule ID 23502 //
     /*  367791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367850 */     GIR_RootConstrainSelectedInstOperands,
     /*  367851 */     // GIR_Coverage, 23502,
     /*  367851 */     GIR_EraseRootFromParent_Done,
     /*  367852 */   // Label 6674: @367852
     /*  367852 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(367918), // Rule ID 23503 //
     /*  367857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367916 */     GIR_RootConstrainSelectedInstOperands,
     /*  367917 */     // GIR_Coverage, 23503,
     /*  367917 */     GIR_EraseRootFromParent_Done,
     /*  367918 */   // Label 6675: @367918
     /*  367918 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(367984), // Rule ID 23506 //
     /*  367923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367982 */     GIR_RootConstrainSelectedInstOperands,
     /*  367983 */     // GIR_Coverage, 23506,
     /*  367983 */     GIR_EraseRootFromParent_Done,
     /*  367984 */   // Label 6676: @367984
     /*  367984 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(368050), // Rule ID 23507 //
     /*  367989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  368000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  368003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  368028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  368031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368048 */     GIR_RootConstrainSelectedInstOperands,
     /*  368049 */     // GIR_Coverage, 23507,
     /*  368049 */     GIR_EraseRootFromParent_Done,
     /*  368050 */   // Label 6677: @368050
     /*  368050 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(368116), // Rule ID 60622 //
     /*  368055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  368072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368094 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  368097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368114 */     GIR_RootConstrainSelectedInstOperands,
     /*  368115 */     // GIR_Coverage, 60622,
     /*  368115 */     GIR_EraseRootFromParent_Done,
     /*  368116 */   // Label 6678: @368116
     /*  368116 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(368182), // Rule ID 60623 //
     /*  368121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  368132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  368135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  368138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  368163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368180 */     GIR_RootConstrainSelectedInstOperands,
     /*  368181 */     // GIR_Coverage, 60623,
     /*  368181 */     GIR_EraseRootFromParent_Done,
     /*  368182 */   // Label 6679: @368182
     /*  368182 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(368248), // Rule ID 60626 //
     /*  368187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  368204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368246 */     GIR_RootConstrainSelectedInstOperands,
     /*  368247 */     // GIR_Coverage, 60626,
     /*  368247 */     GIR_EraseRootFromParent_Done,
     /*  368248 */   // Label 6680: @368248
     /*  368248 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(368314), // Rule ID 60627 //
     /*  368253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  368270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368312 */     GIR_RootConstrainSelectedInstOperands,
     /*  368313 */     // GIR_Coverage, 60627,
     /*  368313 */     GIR_EraseRootFromParent_Done,
     /*  368314 */   // Label 6681: @368314
     /*  368314 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(368380), // Rule ID 60630 //
     /*  368319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  368336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368358 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368378 */     GIR_RootConstrainSelectedInstOperands,
     /*  368379 */     // GIR_Coverage, 60630,
     /*  368379 */     GIR_EraseRootFromParent_Done,
     /*  368380 */   // Label 6682: @368380
     /*  368380 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(368446), // Rule ID 60631 //
     /*  368385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  368402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368444 */     GIR_RootConstrainSelectedInstOperands,
     /*  368445 */     // GIR_Coverage, 60631,
     /*  368445 */     GIR_EraseRootFromParent_Done,
     /*  368446 */   // Label 6683: @368446
     /*  368446 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(368512), // Rule ID 60634 //
     /*  368451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368510 */     GIR_RootConstrainSelectedInstOperands,
     /*  368511 */     // GIR_Coverage, 60634,
     /*  368511 */     GIR_EraseRootFromParent_Done,
     /*  368512 */   // Label 6684: @368512
     /*  368512 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(368578), // Rule ID 60635 //
     /*  368517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368576 */     GIR_RootConstrainSelectedInstOperands,
     /*  368577 */     // GIR_Coverage, 60635,
     /*  368577 */     GIR_EraseRootFromParent_Done,
     /*  368578 */   // Label 6685: @368578
     /*  368578 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(368644), // Rule ID 60638 //
     /*  368583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368622 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368642 */     GIR_RootConstrainSelectedInstOperands,
     /*  368643 */     // GIR_Coverage, 60638,
     /*  368643 */     GIR_EraseRootFromParent_Done,
     /*  368644 */   // Label 6686: @368644
     /*  368644 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(368710), // Rule ID 60639 //
     /*  368649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368708 */     GIR_RootConstrainSelectedInstOperands,
     /*  368709 */     // GIR_Coverage, 60639,
     /*  368709 */     GIR_EraseRootFromParent_Done,
     /*  368710 */   // Label 6687: @368710
     /*  368710 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(368776), // Rule ID 60642 //
     /*  368715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368774 */     GIR_RootConstrainSelectedInstOperands,
     /*  368775 */     // GIR_Coverage, 60642,
     /*  368775 */     GIR_EraseRootFromParent_Done,
     /*  368776 */   // Label 6688: @368776
     /*  368776 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(368842), // Rule ID 60643 //
     /*  368781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368840 */     GIR_RootConstrainSelectedInstOperands,
     /*  368841 */     // GIR_Coverage, 60643,
     /*  368841 */     GIR_EraseRootFromParent_Done,
     /*  368842 */   // Label 6689: @368842
     /*  368842 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(368908), // Rule ID 60646 //
     /*  368847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368906 */     GIR_RootConstrainSelectedInstOperands,
     /*  368907 */     // GIR_Coverage, 60646,
     /*  368907 */     GIR_EraseRootFromParent_Done,
     /*  368908 */   // Label 6690: @368908
     /*  368908 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(368974), // Rule ID 60647 //
     /*  368913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11220:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368972 */     GIR_RootConstrainSelectedInstOperands,
     /*  368973 */     // GIR_Coverage, 60647,
     /*  368973 */     GIR_EraseRootFromParent_Done,
     /*  368974 */   // Label 6691: @368974
     /*  368974 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(369040), // Rule ID 60650 //
     /*  368979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369038 */     GIR_RootConstrainSelectedInstOperands,
     /*  369039 */     // GIR_Coverage, 60650,
     /*  369039 */     GIR_EraseRootFromParent_Done,
     /*  369040 */   // Label 6692: @369040
     /*  369040 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(369106), // Rule ID 60651 //
     /*  369045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  369062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11220:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369104 */     GIR_RootConstrainSelectedInstOperands,
     /*  369105 */     // GIR_Coverage, 60651,
     /*  369105 */     GIR_EraseRootFromParent_Done,
     /*  369106 */   // Label 6693: @369106
     /*  369106 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(369172), // Rule ID 60654 //
     /*  369111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369170 */     GIR_RootConstrainSelectedInstOperands,
     /*  369171 */     // GIR_Coverage, 60654,
     /*  369171 */     GIR_EraseRootFromParent_Done,
     /*  369172 */   // Label 6694: @369172
     /*  369172 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(369238), // Rule ID 60655 //
     /*  369177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  369194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369236 */     GIR_RootConstrainSelectedInstOperands,
     /*  369237 */     // GIR_Coverage, 60655,
     /*  369237 */     GIR_EraseRootFromParent_Done,
     /*  369238 */   // Label 6695: @369238
     /*  369238 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(369304), // Rule ID 60658 //
     /*  369243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  369260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369302 */     GIR_RootConstrainSelectedInstOperands,
     /*  369303 */     // GIR_Coverage, 60658,
     /*  369303 */     GIR_EraseRootFromParent_Done,
     /*  369304 */   // Label 6696: @369304
     /*  369304 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(369370), // Rule ID 60659 //
     /*  369309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  369326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  369351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369368 */     GIR_RootConstrainSelectedInstOperands,
     /*  369369 */     // GIR_Coverage, 60659,
     /*  369369 */     GIR_EraseRootFromParent_Done,
     /*  369370 */   // Label 6697: @369370
     /*  369370 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(369436), // Rule ID 60662 //
     /*  369375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  369392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369434 */     GIR_RootConstrainSelectedInstOperands,
     /*  369435 */     // GIR_Coverage, 60662,
     /*  369435 */     GIR_EraseRootFromParent_Done,
     /*  369436 */   // Label 6698: @369436
     /*  369436 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(369502), // Rule ID 60663 //
     /*  369441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  369458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369500 */     GIR_RootConstrainSelectedInstOperands,
     /*  369501 */     // GIR_Coverage, 60663,
     /*  369501 */     GIR_EraseRootFromParent_Done,
     /*  369502 */   // Label 6699: @369502
     /*  369502 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(369568), // Rule ID 60666 //
     /*  369507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369566 */     GIR_RootConstrainSelectedInstOperands,
     /*  369567 */     // GIR_Coverage, 60666,
     /*  369567 */     GIR_EraseRootFromParent_Done,
     /*  369568 */   // Label 6700: @369568
     /*  369568 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(369634), // Rule ID 60667 //
     /*  369573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369632 */     GIR_RootConstrainSelectedInstOperands,
     /*  369633 */     // GIR_Coverage, 60667,
     /*  369633 */     GIR_EraseRootFromParent_Done,
     /*  369634 */   // Label 6701: @369634
     /*  369634 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(369700), // Rule ID 60670 //
     /*  369639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369698 */     GIR_RootConstrainSelectedInstOperands,
     /*  369699 */     // GIR_Coverage, 60670,
     /*  369699 */     GIR_EraseRootFromParent_Done,
     /*  369700 */   // Label 6702: @369700
     /*  369700 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(369766), // Rule ID 60671 //
     /*  369705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369764 */     GIR_RootConstrainSelectedInstOperands,
     /*  369765 */     // GIR_Coverage, 60671,
     /*  369765 */     GIR_EraseRootFromParent_Done,
     /*  369766 */   // Label 6703: @369766
     /*  369766 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(369832), // Rule ID 60674 //
     /*  369771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369830 */     GIR_RootConstrainSelectedInstOperands,
     /*  369831 */     // GIR_Coverage, 60674,
     /*  369831 */     GIR_EraseRootFromParent_Done,
     /*  369832 */   // Label 6704: @369832
     /*  369832 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(369898), // Rule ID 60675 //
     /*  369837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369896 */     GIR_RootConstrainSelectedInstOperands,
     /*  369897 */     // GIR_Coverage, 60675,
     /*  369897 */     GIR_EraseRootFromParent_Done,
     /*  369898 */   // Label 6705: @369898
     /*  369898 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(369964), // Rule ID 60678 //
     /*  369903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369962 */     GIR_RootConstrainSelectedInstOperands,
     /*  369963 */     // GIR_Coverage, 60678,
     /*  369963 */     GIR_EraseRootFromParent_Done,
     /*  369964 */   // Label 6706: @369964
     /*  369964 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(370030), // Rule ID 60679 //
     /*  369969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370028 */     GIR_RootConstrainSelectedInstOperands,
     /*  370029 */     // GIR_Coverage, 60679,
     /*  370029 */     GIR_EraseRootFromParent_Done,
     /*  370030 */   // Label 6707: @370030
     /*  370030 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(370096), // Rule ID 60682 //
     /*  370035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  370052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370094 */     GIR_RootConstrainSelectedInstOperands,
     /*  370095 */     // GIR_Coverage, 60682,
     /*  370095 */     GIR_EraseRootFromParent_Done,
     /*  370096 */   // Label 6708: @370096
     /*  370096 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(370162), // Rule ID 60683 //
     /*  370101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  370118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370160 */     GIR_RootConstrainSelectedInstOperands,
     /*  370161 */     // GIR_Coverage, 60683,
     /*  370161 */     GIR_EraseRootFromParent_Done,
     /*  370162 */   // Label 6709: @370162
     /*  370162 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(370228), // Rule ID 60686 //
     /*  370167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370226 */     GIR_RootConstrainSelectedInstOperands,
     /*  370227 */     // GIR_Coverage, 60686,
     /*  370227 */     GIR_EraseRootFromParent_Done,
     /*  370228 */   // Label 6710: @370228
     /*  370228 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(370294), // Rule ID 60687 //
     /*  370233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  370250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370292 */     GIR_RootConstrainSelectedInstOperands,
     /*  370293 */     // GIR_Coverage, 60687,
     /*  370293 */     GIR_EraseRootFromParent_Done,
     /*  370294 */   // Label 6711: @370294
     /*  370294 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(370360), // Rule ID 60690 //
     /*  370299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370358 */     GIR_RootConstrainSelectedInstOperands,
     /*  370359 */     // GIR_Coverage, 60690,
     /*  370359 */     GIR_EraseRootFromParent_Done,
     /*  370360 */   // Label 6712: @370360
     /*  370360 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(370426), // Rule ID 60691 //
     /*  370365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  370382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370424 */     GIR_RootConstrainSelectedInstOperands,
     /*  370425 */     // GIR_Coverage, 60691,
     /*  370425 */     GIR_EraseRootFromParent_Done,
     /*  370426 */   // Label 6713: @370426
     /*  370426 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(370492), // Rule ID 60694 //
     /*  370431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370490 */     GIR_RootConstrainSelectedInstOperands,
     /*  370491 */     // GIR_Coverage, 60694,
     /*  370491 */     GIR_EraseRootFromParent_Done,
     /*  370492 */   // Label 6714: @370492
     /*  370492 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(370558), // Rule ID 60695 //
     /*  370497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370556 */     GIR_RootConstrainSelectedInstOperands,
     /*  370557 */     // GIR_Coverage, 60695,
     /*  370557 */     GIR_EraseRootFromParent_Done,
     /*  370558 */   // Label 6715: @370558
     /*  370558 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(370624), // Rule ID 60698 //
     /*  370563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370622 */     GIR_RootConstrainSelectedInstOperands,
     /*  370623 */     // GIR_Coverage, 60698,
     /*  370623 */     GIR_EraseRootFromParent_Done,
     /*  370624 */   // Label 6716: @370624
     /*  370624 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(370690), // Rule ID 60699 //
     /*  370629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370688 */     GIR_RootConstrainSelectedInstOperands,
     /*  370689 */     // GIR_Coverage, 60699,
     /*  370689 */     GIR_EraseRootFromParent_Done,
     /*  370690 */   // Label 6717: @370690
     /*  370690 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(370756), // Rule ID 60702 //
     /*  370695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370754 */     GIR_RootConstrainSelectedInstOperands,
     /*  370755 */     // GIR_Coverage, 60702,
     /*  370755 */     GIR_EraseRootFromParent_Done,
     /*  370756 */   // Label 6718: @370756
     /*  370756 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(370822), // Rule ID 60703 //
     /*  370761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370820 */     GIR_RootConstrainSelectedInstOperands,
     /*  370821 */     // GIR_Coverage, 60703,
     /*  370821 */     GIR_EraseRootFromParent_Done,
     /*  370822 */   // Label 6719: @370822
     /*  370822 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(370888), // Rule ID 60706 //
     /*  370827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370886 */     GIR_RootConstrainSelectedInstOperands,
     /*  370887 */     // GIR_Coverage, 60706,
     /*  370887 */     GIR_EraseRootFromParent_Done,
     /*  370888 */   // Label 6720: @370888
     /*  370888 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(370954), // Rule ID 60707 //
     /*  370893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370952 */     GIR_RootConstrainSelectedInstOperands,
     /*  370953 */     // GIR_Coverage, 60707,
     /*  370953 */     GIR_EraseRootFromParent_Done,
     /*  370954 */   // Label 6721: @370954
     /*  370954 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(371020), // Rule ID 60710 //
     /*  370959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370998 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  371001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371018 */     GIR_RootConstrainSelectedInstOperands,
     /*  371019 */     // GIR_Coverage, 60710,
     /*  371019 */     GIR_EraseRootFromParent_Done,
     /*  371020 */   // Label 6722: @371020
     /*  371020 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(371086), // Rule ID 60711 //
     /*  371025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  371067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371084 */     GIR_RootConstrainSelectedInstOperands,
     /*  371085 */     // GIR_Coverage, 60711,
     /*  371085 */     GIR_EraseRootFromParent_Done,
     /*  371086 */   // Label 6723: @371086
     /*  371086 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(371152), // Rule ID 60714 //
     /*  371091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371150 */     GIR_RootConstrainSelectedInstOperands,
     /*  371151 */     // GIR_Coverage, 60714,
     /*  371151 */     GIR_EraseRootFromParent_Done,
     /*  371152 */   // Label 6724: @371152
     /*  371152 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(371218), // Rule ID 60715 //
     /*  371157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371216 */     GIR_RootConstrainSelectedInstOperands,
     /*  371217 */     // GIR_Coverage, 60715,
     /*  371217 */     GIR_EraseRootFromParent_Done,
     /*  371218 */   // Label 6725: @371218
     /*  371218 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(371284), // Rule ID 60718 //
     /*  371223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371262 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371282 */     GIR_RootConstrainSelectedInstOperands,
     /*  371283 */     // GIR_Coverage, 60718,
     /*  371283 */     GIR_EraseRootFromParent_Done,
     /*  371284 */   // Label 6726: @371284
     /*  371284 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(371350), // Rule ID 60719 //
     /*  371289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371348 */     GIR_RootConstrainSelectedInstOperands,
     /*  371349 */     // GIR_Coverage, 60719,
     /*  371349 */     GIR_EraseRootFromParent_Done,
     /*  371350 */   // Label 6727: @371350
     /*  371350 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(371416), // Rule ID 60722 //
     /*  371355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371414 */     GIR_RootConstrainSelectedInstOperands,
     /*  371415 */     // GIR_Coverage, 60722,
     /*  371415 */     GIR_EraseRootFromParent_Done,
     /*  371416 */   // Label 6728: @371416
     /*  371416 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(371482), // Rule ID 60723 //
     /*  371421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  371463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371480 */     GIR_RootConstrainSelectedInstOperands,
     /*  371481 */     // GIR_Coverage, 60723,
     /*  371481 */     GIR_EraseRootFromParent_Done,
     /*  371482 */   // Label 6729: @371482
     /*  371482 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(371548), // Rule ID 60726 //
     /*  371487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371546 */     GIR_RootConstrainSelectedInstOperands,
     /*  371547 */     // GIR_Coverage, 60726,
     /*  371547 */     GIR_EraseRootFromParent_Done,
     /*  371548 */   // Label 6730: @371548
     /*  371548 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(371614), // Rule ID 60727 //
     /*  371553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371612 */     GIR_RootConstrainSelectedInstOperands,
     /*  371613 */     // GIR_Coverage, 60727,
     /*  371613 */     GIR_EraseRootFromParent_Done,
     /*  371614 */   // Label 6731: @371614
     /*  371614 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(371680), // Rule ID 60730 //
     /*  371619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371678 */     GIR_RootConstrainSelectedInstOperands,
     /*  371679 */     // GIR_Coverage, 60730,
     /*  371679 */     GIR_EraseRootFromParent_Done,
     /*  371680 */   // Label 6732: @371680
     /*  371680 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(371746), // Rule ID 60731 //
     /*  371685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371744 */     GIR_RootConstrainSelectedInstOperands,
     /*  371745 */     // GIR_Coverage, 60731,
     /*  371745 */     GIR_EraseRootFromParent_Done,
     /*  371746 */   // Label 6733: @371746
     /*  371746 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(371812), // Rule ID 60734 //
     /*  371751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371810 */     GIR_RootConstrainSelectedInstOperands,
     /*  371811 */     // GIR_Coverage, 60734,
     /*  371811 */     GIR_EraseRootFromParent_Done,
     /*  371812 */   // Label 6734: @371812
     /*  371812 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(371878), // Rule ID 60735 //
     /*  371817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11228:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371876 */     GIR_RootConstrainSelectedInstOperands,
     /*  371877 */     // GIR_Coverage, 60735,
     /*  371877 */     GIR_EraseRootFromParent_Done,
     /*  371878 */   // Label 6735: @371878
     /*  371878 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(371944), // Rule ID 60738 //
     /*  371883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371922 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371942 */     GIR_RootConstrainSelectedInstOperands,
     /*  371943 */     // GIR_Coverage, 60738,
     /*  371943 */     GIR_EraseRootFromParent_Done,
     /*  371944 */   // Label 6736: @371944
     /*  371944 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(372010), // Rule ID 60739 //
     /*  371949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372008 */     GIR_RootConstrainSelectedInstOperands,
     /*  372009 */     // GIR_Coverage, 60739,
     /*  372009 */     GIR_EraseRootFromParent_Done,
     /*  372010 */   // Label 6737: @372010
     /*  372010 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(372076), // Rule ID 60742 //
     /*  372015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372074 */     GIR_RootConstrainSelectedInstOperands,
     /*  372075 */     // GIR_Coverage, 60742,
     /*  372075 */     GIR_EraseRootFromParent_Done,
     /*  372076 */   // Label 6738: @372076
     /*  372076 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(372142), // Rule ID 60743 //
     /*  372081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372140 */     GIR_RootConstrainSelectedInstOperands,
     /*  372141 */     // GIR_Coverage, 60743,
     /*  372141 */     GIR_EraseRootFromParent_Done,
     /*  372142 */   // Label 6739: @372142
     /*  372142 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(372208), // Rule ID 60746 //
     /*  372147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372206 */     GIR_RootConstrainSelectedInstOperands,
     /*  372207 */     // GIR_Coverage, 60746,
     /*  372207 */     GIR_EraseRootFromParent_Done,
     /*  372208 */   // Label 6740: @372208
     /*  372208 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(372274), // Rule ID 60747 //
     /*  372213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  372255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372272 */     GIR_RootConstrainSelectedInstOperands,
     /*  372273 */     // GIR_Coverage, 60747,
     /*  372273 */     GIR_EraseRootFromParent_Done,
     /*  372274 */   // Label 6741: @372274
     /*  372274 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(372340), // Rule ID 60750 //
     /*  372279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372338 */     GIR_RootConstrainSelectedInstOperands,
     /*  372339 */     // GIR_Coverage, 60750,
     /*  372339 */     GIR_EraseRootFromParent_Done,
     /*  372340 */   // Label 6742: @372340
     /*  372340 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(372406), // Rule ID 60751 //
     /*  372345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372404 */     GIR_RootConstrainSelectedInstOperands,
     /*  372405 */     // GIR_Coverage, 60751,
     /*  372405 */     GIR_EraseRootFromParent_Done,
     /*  372406 */   // Label 6743: @372406
     /*  372406 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(372472), // Rule ID 60754 //
     /*  372411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372470 */     GIR_RootConstrainSelectedInstOperands,
     /*  372471 */     // GIR_Coverage, 60754,
     /*  372471 */     GIR_EraseRootFromParent_Done,
     /*  372472 */   // Label 6744: @372472
     /*  372472 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(372538), // Rule ID 60755 //
     /*  372477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372516 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372536 */     GIR_RootConstrainSelectedInstOperands,
     /*  372537 */     // GIR_Coverage, 60755,
     /*  372537 */     GIR_EraseRootFromParent_Done,
     /*  372538 */   // Label 6745: @372538
     /*  372538 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(372604), // Rule ID 60758 //
     /*  372543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372602 */     GIR_RootConstrainSelectedInstOperands,
     /*  372603 */     // GIR_Coverage, 60758,
     /*  372603 */     GIR_EraseRootFromParent_Done,
     /*  372604 */   // Label 6746: @372604
     /*  372604 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(372670), // Rule ID 60759 //
     /*  372609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372648 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372668 */     GIR_RootConstrainSelectedInstOperands,
     /*  372669 */     // GIR_Coverage, 60759,
     /*  372669 */     GIR_EraseRootFromParent_Done,
     /*  372670 */   // Label 6747: @372670
     /*  372670 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(372736), // Rule ID 60762 //
     /*  372675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372734 */     GIR_RootConstrainSelectedInstOperands,
     /*  372735 */     // GIR_Coverage, 60762,
     /*  372735 */     GIR_EraseRootFromParent_Done,
     /*  372736 */   // Label 6748: @372736
     /*  372736 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(372802), // Rule ID 60763 //
     /*  372741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372800 */     GIR_RootConstrainSelectedInstOperands,
     /*  372801 */     // GIR_Coverage, 60763,
     /*  372801 */     GIR_EraseRootFromParent_Done,
     /*  372802 */   // Label 6749: @372802
     /*  372802 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(372868), // Rule ID 60766 //
     /*  372807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372866 */     GIR_RootConstrainSelectedInstOperands,
     /*  372867 */     // GIR_Coverage, 60766,
     /*  372867 */     GIR_EraseRootFromParent_Done,
     /*  372868 */   // Label 6750: @372868
     /*  372868 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(372934), // Rule ID 60767 //
     /*  372873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372932 */     GIR_RootConstrainSelectedInstOperands,
     /*  372933 */     // GIR_Coverage, 60767,
     /*  372933 */     GIR_EraseRootFromParent_Done,
     /*  372934 */   // Label 6751: @372934
     /*  372934 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(373000), // Rule ID 60770 //
     /*  372939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372998 */     GIR_RootConstrainSelectedInstOperands,
     /*  372999 */     // GIR_Coverage, 60770,
     /*  372999 */     GIR_EraseRootFromParent_Done,
     /*  373000 */   // Label 6752: @373000
     /*  373000 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(373066), // Rule ID 60771 //
     /*  373005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373064 */     GIR_RootConstrainSelectedInstOperands,
     /*  373065 */     // GIR_Coverage, 60771,
     /*  373065 */     GIR_EraseRootFromParent_Done,
     /*  373066 */   // Label 6753: @373066
     /*  373066 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(373132), // Rule ID 60774 //
     /*  373071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373130 */     GIR_RootConstrainSelectedInstOperands,
     /*  373131 */     // GIR_Coverage, 60774,
     /*  373131 */     GIR_EraseRootFromParent_Done,
     /*  373132 */   // Label 6754: @373132
     /*  373132 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(373198), // Rule ID 60775 //
     /*  373137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373196 */     GIR_RootConstrainSelectedInstOperands,
     /*  373197 */     // GIR_Coverage, 60775,
     /*  373197 */     GIR_EraseRootFromParent_Done,
     /*  373198 */   // Label 6755: @373198
     /*  373198 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(373264), // Rule ID 60778 //
     /*  373203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373262 */     GIR_RootConstrainSelectedInstOperands,
     /*  373263 */     // GIR_Coverage, 60778,
     /*  373263 */     GIR_EraseRootFromParent_Done,
     /*  373264 */   // Label 6756: @373264
     /*  373264 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(373330), // Rule ID 60779 //
     /*  373269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373328 */     GIR_RootConstrainSelectedInstOperands,
     /*  373329 */     // GIR_Coverage, 60779,
     /*  373329 */     GIR_EraseRootFromParent_Done,
     /*  373330 */   // Label 6757: @373330
     /*  373330 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(373396), // Rule ID 60782 //
     /*  373335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373394 */     GIR_RootConstrainSelectedInstOperands,
     /*  373395 */     // GIR_Coverage, 60782,
     /*  373395 */     GIR_EraseRootFromParent_Done,
     /*  373396 */   // Label 6758: @373396
     /*  373396 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(373462), // Rule ID 60783 //
     /*  373401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373460 */     GIR_RootConstrainSelectedInstOperands,
     /*  373461 */     // GIR_Coverage, 60783,
     /*  373461 */     GIR_EraseRootFromParent_Done,
     /*  373462 */   // Label 6759: @373462
     /*  373462 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(373528), // Rule ID 60786 //
     /*  373467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373526 */     GIR_RootConstrainSelectedInstOperands,
     /*  373527 */     // GIR_Coverage, 60786,
     /*  373527 */     GIR_EraseRootFromParent_Done,
     /*  373528 */   // Label 6760: @373528
     /*  373528 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(373594), // Rule ID 60787 //
     /*  373533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373592 */     GIR_RootConstrainSelectedInstOperands,
     /*  373593 */     // GIR_Coverage, 60787,
     /*  373593 */     GIR_EraseRootFromParent_Done,
     /*  373594 */   // Label 6761: @373594
     /*  373594 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(373660), // Rule ID 60790 //
     /*  373599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373658 */     GIR_RootConstrainSelectedInstOperands,
     /*  373659 */     // GIR_Coverage, 60790,
     /*  373659 */     GIR_EraseRootFromParent_Done,
     /*  373660 */   // Label 6762: @373660
     /*  373660 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(373726), // Rule ID 60791 //
     /*  373665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373724 */     GIR_RootConstrainSelectedInstOperands,
     /*  373725 */     // GIR_Coverage, 60791,
     /*  373725 */     GIR_EraseRootFromParent_Done,
     /*  373726 */   // Label 6763: @373726
     /*  373726 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(373792), // Rule ID 60794 //
     /*  373731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373790 */     GIR_RootConstrainSelectedInstOperands,
     /*  373791 */     // GIR_Coverage, 60794,
     /*  373791 */     GIR_EraseRootFromParent_Done,
     /*  373792 */   // Label 6764: @373792
     /*  373792 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(373858), // Rule ID 60795 //
     /*  373797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373856 */     GIR_RootConstrainSelectedInstOperands,
     /*  373857 */     // GIR_Coverage, 60795,
     /*  373857 */     GIR_EraseRootFromParent_Done,
     /*  373858 */   // Label 6765: @373858
     /*  373858 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(373924), // Rule ID 60798 //
     /*  373863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373902 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373922 */     GIR_RootConstrainSelectedInstOperands,
     /*  373923 */     // GIR_Coverage, 60798,
     /*  373923 */     GIR_EraseRootFromParent_Done,
     /*  373924 */   // Label 6766: @373924
     /*  373924 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(373990), // Rule ID 60799 //
     /*  373929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373968 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373988 */     GIR_RootConstrainSelectedInstOperands,
     /*  373989 */     // GIR_Coverage, 60799,
     /*  373989 */     GIR_EraseRootFromParent_Done,
     /*  373990 */   // Label 6767: @373990
     /*  373990 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(374056), // Rule ID 60802 //
     /*  373995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374054 */     GIR_RootConstrainSelectedInstOperands,
     /*  374055 */     // GIR_Coverage, 60802,
     /*  374055 */     GIR_EraseRootFromParent_Done,
     /*  374056 */   // Label 6768: @374056
     /*  374056 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(374122), // Rule ID 60803 //
     /*  374061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374100 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374120 */     GIR_RootConstrainSelectedInstOperands,
     /*  374121 */     // GIR_Coverage, 60803,
     /*  374121 */     GIR_EraseRootFromParent_Done,
     /*  374122 */   // Label 6769: @374122
     /*  374122 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(374188), // Rule ID 60806 //
     /*  374127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374186 */     GIR_RootConstrainSelectedInstOperands,
     /*  374187 */     // GIR_Coverage, 60806,
     /*  374187 */     GIR_EraseRootFromParent_Done,
     /*  374188 */   // Label 6770: @374188
     /*  374188 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(374254), // Rule ID 60807 //
     /*  374193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374252 */     GIR_RootConstrainSelectedInstOperands,
     /*  374253 */     // GIR_Coverage, 60807,
     /*  374253 */     GIR_EraseRootFromParent_Done,
     /*  374254 */   // Label 6771: @374254
     /*  374254 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(374320), // Rule ID 60810 //
     /*  374259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374298 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374318 */     GIR_RootConstrainSelectedInstOperands,
     /*  374319 */     // GIR_Coverage, 60810,
     /*  374319 */     GIR_EraseRootFromParent_Done,
     /*  374320 */   // Label 6772: @374320
     /*  374320 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(374386), // Rule ID 60811 //
     /*  374325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  374367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374384 */     GIR_RootConstrainSelectedInstOperands,
     /*  374385 */     // GIR_Coverage, 60811,
     /*  374385 */     GIR_EraseRootFromParent_Done,
     /*  374386 */   // Label 6773: @374386
     /*  374386 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(374452), // Rule ID 60814 //
     /*  374391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374450 */     GIR_RootConstrainSelectedInstOperands,
     /*  374451 */     // GIR_Coverage, 60814,
     /*  374451 */     GIR_EraseRootFromParent_Done,
     /*  374452 */   // Label 6774: @374452
     /*  374452 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(374518), // Rule ID 60815 //
     /*  374457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374516 */     GIR_RootConstrainSelectedInstOperands,
     /*  374517 */     // GIR_Coverage, 60815,
     /*  374517 */     GIR_EraseRootFromParent_Done,
     /*  374518 */   // Label 6775: @374518
     /*  374518 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(374584), // Rule ID 60818 //
     /*  374523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374582 */     GIR_RootConstrainSelectedInstOperands,
     /*  374583 */     // GIR_Coverage, 60818,
     /*  374583 */     GIR_EraseRootFromParent_Done,
     /*  374584 */   // Label 6776: @374584
     /*  374584 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(374650), // Rule ID 60819 //
     /*  374589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374648 */     GIR_RootConstrainSelectedInstOperands,
     /*  374649 */     // GIR_Coverage, 60819,
     /*  374649 */     GIR_EraseRootFromParent_Done,
     /*  374650 */   // Label 6777: @374650
     /*  374650 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(374716), // Rule ID 60822 //
     /*  374655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374714 */     GIR_RootConstrainSelectedInstOperands,
     /*  374715 */     // GIR_Coverage, 60822,
     /*  374715 */     GIR_EraseRootFromParent_Done,
     /*  374716 */   // Label 6778: @374716
     /*  374716 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(374782), // Rule ID 60823 //
     /*  374721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374780 */     GIR_RootConstrainSelectedInstOperands,
     /*  374781 */     // GIR_Coverage, 60823,
     /*  374781 */     GIR_EraseRootFromParent_Done,
     /*  374782 */   // Label 6779: @374782
     /*  374782 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(374848), // Rule ID 60826 //
     /*  374787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374846 */     GIR_RootConstrainSelectedInstOperands,
     /*  374847 */     // GIR_Coverage, 60826,
     /*  374847 */     GIR_EraseRootFromParent_Done,
     /*  374848 */   // Label 6780: @374848
     /*  374848 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(374914), // Rule ID 60827 //
     /*  374853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374912 */     GIR_RootConstrainSelectedInstOperands,
     /*  374913 */     // GIR_Coverage, 60827,
     /*  374913 */     GIR_EraseRootFromParent_Done,
     /*  374914 */   // Label 6781: @374914
     /*  374914 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(374980), // Rule ID 60830 //
     /*  374919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374978 */     GIR_RootConstrainSelectedInstOperands,
     /*  374979 */     // GIR_Coverage, 60830,
     /*  374979 */     GIR_EraseRootFromParent_Done,
     /*  374980 */   // Label 6782: @374980
     /*  374980 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(375046), // Rule ID 60831 //
     /*  374985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375044 */     GIR_RootConstrainSelectedInstOperands,
     /*  375045 */     // GIR_Coverage, 60831,
     /*  375045 */     GIR_EraseRootFromParent_Done,
     /*  375046 */   // Label 6783: @375046
     /*  375046 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(375112), // Rule ID 60834 //
     /*  375051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375110 */     GIR_RootConstrainSelectedInstOperands,
     /*  375111 */     // GIR_Coverage, 60834,
     /*  375111 */     GIR_EraseRootFromParent_Done,
     /*  375112 */   // Label 6784: @375112
     /*  375112 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(375178), // Rule ID 60835 //
     /*  375117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  375159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375176 */     GIR_RootConstrainSelectedInstOperands,
     /*  375177 */     // GIR_Coverage, 60835,
     /*  375177 */     GIR_EraseRootFromParent_Done,
     /*  375178 */   // Label 6785: @375178
     /*  375178 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(375244), // Rule ID 60838 //
     /*  375183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375242 */     GIR_RootConstrainSelectedInstOperands,
     /*  375243 */     // GIR_Coverage, 60838,
     /*  375243 */     GIR_EraseRootFromParent_Done,
     /*  375244 */   // Label 6786: @375244
     /*  375244 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(375310), // Rule ID 60839 //
     /*  375249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375288 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375308 */     GIR_RootConstrainSelectedInstOperands,
     /*  375309 */     // GIR_Coverage, 60839,
     /*  375309 */     GIR_EraseRootFromParent_Done,
     /*  375310 */   // Label 6787: @375310
     /*  375310 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(375376), // Rule ID 60842 //
     /*  375315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375374 */     GIR_RootConstrainSelectedInstOperands,
     /*  375375 */     // GIR_Coverage, 60842,
     /*  375375 */     GIR_EraseRootFromParent_Done,
     /*  375376 */   // Label 6788: @375376
     /*  375376 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(375442), // Rule ID 60843 //
     /*  375381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375440 */     GIR_RootConstrainSelectedInstOperands,
     /*  375441 */     // GIR_Coverage, 60843,
     /*  375441 */     GIR_EraseRootFromParent_Done,
     /*  375442 */   // Label 6789: @375442
     /*  375442 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(375508), // Rule ID 60846 //
     /*  375447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375506 */     GIR_RootConstrainSelectedInstOperands,
     /*  375507 */     // GIR_Coverage, 60846,
     /*  375507 */     GIR_EraseRootFromParent_Done,
     /*  375508 */   // Label 6790: @375508
     /*  375508 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(375574), // Rule ID 60847 //
     /*  375513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375552 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375572 */     GIR_RootConstrainSelectedInstOperands,
     /*  375573 */     // GIR_Coverage, 60847,
     /*  375573 */     GIR_EraseRootFromParent_Done,
     /*  375574 */   // Label 6791: @375574
     /*  375574 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(375640), // Rule ID 60850 //
     /*  375579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375638 */     GIR_RootConstrainSelectedInstOperands,
     /*  375639 */     // GIR_Coverage, 60850,
     /*  375639 */     GIR_EraseRootFromParent_Done,
     /*  375640 */   // Label 6792: @375640
     /*  375640 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(375706), // Rule ID 60851 //
     /*  375645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375704 */     GIR_RootConstrainSelectedInstOperands,
     /*  375705 */     // GIR_Coverage, 60851,
     /*  375705 */     GIR_EraseRootFromParent_Done,
     /*  375706 */   // Label 6793: @375706
     /*  375706 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(375772), // Rule ID 60854 //
     /*  375711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375770 */     GIR_RootConstrainSelectedInstOperands,
     /*  375771 */     // GIR_Coverage, 60854,
     /*  375771 */     GIR_EraseRootFromParent_Done,
     /*  375772 */   // Label 6794: @375772
     /*  375772 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(375838), // Rule ID 60855 //
     /*  375777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375836 */     GIR_RootConstrainSelectedInstOperands,
     /*  375837 */     // GIR_Coverage, 60855,
     /*  375837 */     GIR_EraseRootFromParent_Done,
     /*  375838 */   // Label 6795: @375838
     /*  375838 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(375904), // Rule ID 60858 //
     /*  375843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375882 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375902 */     GIR_RootConstrainSelectedInstOperands,
     /*  375903 */     // GIR_Coverage, 60858,
     /*  375903 */     GIR_EraseRootFromParent_Done,
     /*  375904 */   // Label 6796: @375904
     /*  375904 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(375970), // Rule ID 60859 //
     /*  375909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375948 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375968 */     GIR_RootConstrainSelectedInstOperands,
     /*  375969 */     // GIR_Coverage, 60859,
     /*  375969 */     GIR_EraseRootFromParent_Done,
     /*  375970 */   // Label 6797: @375970
     /*  375970 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(376036), // Rule ID 60862 //
     /*  375975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376034 */     GIR_RootConstrainSelectedInstOperands,
     /*  376035 */     // GIR_Coverage, 60862,
     /*  376035 */     GIR_EraseRootFromParent_Done,
     /*  376036 */   // Label 6798: @376036
     /*  376036 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(376102), // Rule ID 60863 //
     /*  376041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376100 */     GIR_RootConstrainSelectedInstOperands,
     /*  376101 */     // GIR_Coverage, 60863,
     /*  376101 */     GIR_EraseRootFromParent_Done,
     /*  376102 */   // Label 6799: @376102
     /*  376102 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(376168), // Rule ID 60866 //
     /*  376107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376166 */     GIR_RootConstrainSelectedInstOperands,
     /*  376167 */     // GIR_Coverage, 60866,
     /*  376167 */     GIR_EraseRootFromParent_Done,
     /*  376168 */   // Label 6800: @376168
     /*  376168 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(376234), // Rule ID 60867 //
     /*  376173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376232 */     GIR_RootConstrainSelectedInstOperands,
     /*  376233 */     // GIR_Coverage, 60867,
     /*  376233 */     GIR_EraseRootFromParent_Done,
     /*  376234 */   // Label 6801: @376234
     /*  376234 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(376300), // Rule ID 60870 //
     /*  376239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376298 */     GIR_RootConstrainSelectedInstOperands,
     /*  376299 */     // GIR_Coverage, 60870,
     /*  376299 */     GIR_EraseRootFromParent_Done,
     /*  376300 */   // Label 6802: @376300
     /*  376300 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(376366), // Rule ID 60871 //
     /*  376305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376364 */     GIR_RootConstrainSelectedInstOperands,
     /*  376365 */     // GIR_Coverage, 60871,
     /*  376365 */     GIR_EraseRootFromParent_Done,
     /*  376366 */   // Label 6803: @376366
     /*  376366 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(376432), // Rule ID 60874 //
     /*  376371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376430 */     GIR_RootConstrainSelectedInstOperands,
     /*  376431 */     // GIR_Coverage, 60874,
     /*  376431 */     GIR_EraseRootFromParent_Done,
     /*  376432 */   // Label 6804: @376432
     /*  376432 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(376498), // Rule ID 60875 //
     /*  376437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376496 */     GIR_RootConstrainSelectedInstOperands,
     /*  376497 */     // GIR_Coverage, 60875,
     /*  376497 */     GIR_EraseRootFromParent_Done,
     /*  376498 */   // Label 6805: @376498
     /*  376498 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(376564), // Rule ID 60878 //
     /*  376503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376562 */     GIR_RootConstrainSelectedInstOperands,
     /*  376563 */     // GIR_Coverage, 60878,
     /*  376563 */     GIR_EraseRootFromParent_Done,
     /*  376564 */   // Label 6806: @376564
     /*  376564 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(376630), // Rule ID 60879 //
     /*  376569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376628 */     GIR_RootConstrainSelectedInstOperands,
     /*  376629 */     // GIR_Coverage, 60879,
     /*  376629 */     GIR_EraseRootFromParent_Done,
     /*  376630 */   // Label 6807: @376630
     /*  376630 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(376696), // Rule ID 60882 //
     /*  376635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376674 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376694 */     GIR_RootConstrainSelectedInstOperands,
     /*  376695 */     // GIR_Coverage, 60882,
     /*  376695 */     GIR_EraseRootFromParent_Done,
     /*  376696 */   // Label 6808: @376696
     /*  376696 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(376762), // Rule ID 60883 //
     /*  376701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376740 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376760 */     GIR_RootConstrainSelectedInstOperands,
     /*  376761 */     // GIR_Coverage, 60883,
     /*  376761 */     GIR_EraseRootFromParent_Done,
     /*  376762 */   // Label 6809: @376762
     /*  376762 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(376828), // Rule ID 60886 //
     /*  376767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376806 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376826 */     GIR_RootConstrainSelectedInstOperands,
     /*  376827 */     // GIR_Coverage, 60886,
     /*  376827 */     GIR_EraseRootFromParent_Done,
     /*  376828 */   // Label 6810: @376828
     /*  376828 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(376894), // Rule ID 60887 //
     /*  376833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376892 */     GIR_RootConstrainSelectedInstOperands,
     /*  376893 */     // GIR_Coverage, 60887,
     /*  376893 */     GIR_EraseRootFromParent_Done,
     /*  376894 */   // Label 6811: @376894
     /*  376894 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(376960), // Rule ID 60890 //
     /*  376899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376938 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376958 */     GIR_RootConstrainSelectedInstOperands,
     /*  376959 */     // GIR_Coverage, 60890,
     /*  376959 */     GIR_EraseRootFromParent_Done,
     /*  376960 */   // Label 6812: @376960
     /*  376960 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(377026), // Rule ID 60891 //
     /*  376965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377004 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377024 */     GIR_RootConstrainSelectedInstOperands,
     /*  377025 */     // GIR_Coverage, 60891,
     /*  377025 */     GIR_EraseRootFromParent_Done,
     /*  377026 */   // Label 6813: @377026
     /*  377026 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(377092), // Rule ID 60894 //
     /*  377031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377090 */     GIR_RootConstrainSelectedInstOperands,
     /*  377091 */     // GIR_Coverage, 60894,
     /*  377091 */     GIR_EraseRootFromParent_Done,
     /*  377092 */   // Label 6814: @377092
     /*  377092 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(377158), // Rule ID 60895 //
     /*  377097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377156 */     GIR_RootConstrainSelectedInstOperands,
     /*  377157 */     // GIR_Coverage, 60895,
     /*  377157 */     GIR_EraseRootFromParent_Done,
     /*  377158 */   // Label 6815: @377158
     /*  377158 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(377224), // Rule ID 60898 //
     /*  377163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377222 */     GIR_RootConstrainSelectedInstOperands,
     /*  377223 */     // GIR_Coverage, 60898,
     /*  377223 */     GIR_EraseRootFromParent_Done,
     /*  377224 */   // Label 6816: @377224
     /*  377224 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(377290), // Rule ID 60899 //
     /*  377229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  377271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377288 */     GIR_RootConstrainSelectedInstOperands,
     /*  377289 */     // GIR_Coverage, 60899,
     /*  377289 */     GIR_EraseRootFromParent_Done,
     /*  377290 */   // Label 6817: @377290
     /*  377290 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(377356), // Rule ID 60902 //
     /*  377295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377354 */     GIR_RootConstrainSelectedInstOperands,
     /*  377355 */     // GIR_Coverage, 60902,
     /*  377355 */     GIR_EraseRootFromParent_Done,
     /*  377356 */   // Label 6818: @377356
     /*  377356 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(377422), // Rule ID 60903 //
     /*  377361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377420 */     GIR_RootConstrainSelectedInstOperands,
     /*  377421 */     // GIR_Coverage, 60903,
     /*  377421 */     GIR_EraseRootFromParent_Done,
     /*  377422 */   // Label 6819: @377422
     /*  377422 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(377488), // Rule ID 60906 //
     /*  377427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377486 */     GIR_RootConstrainSelectedInstOperands,
     /*  377487 */     // GIR_Coverage, 60906,
     /*  377487 */     GIR_EraseRootFromParent_Done,
     /*  377488 */   // Label 6820: @377488
     /*  377488 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(377554), // Rule ID 60907 //
     /*  377493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377552 */     GIR_RootConstrainSelectedInstOperands,
     /*  377553 */     // GIR_Coverage, 60907,
     /*  377553 */     GIR_EraseRootFromParent_Done,
     /*  377554 */   // Label 6821: @377554
     /*  377554 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(377620), // Rule ID 60910 //
     /*  377559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377618 */     GIR_RootConstrainSelectedInstOperands,
     /*  377619 */     // GIR_Coverage, 60910,
     /*  377619 */     GIR_EraseRootFromParent_Done,
     /*  377620 */   // Label 6822: @377620
     /*  377620 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(377686), // Rule ID 60911 //
     /*  377625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377684 */     GIR_RootConstrainSelectedInstOperands,
     /*  377685 */     // GIR_Coverage, 60911,
     /*  377685 */     GIR_EraseRootFromParent_Done,
     /*  377686 */   // Label 6823: @377686
     /*  377686 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(377752), // Rule ID 60914 //
     /*  377691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377750 */     GIR_RootConstrainSelectedInstOperands,
     /*  377751 */     // GIR_Coverage, 60914,
     /*  377751 */     GIR_EraseRootFromParent_Done,
     /*  377752 */   // Label 6824: @377752
     /*  377752 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(377818), // Rule ID 60915 //
     /*  377757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377816 */     GIR_RootConstrainSelectedInstOperands,
     /*  377817 */     // GIR_Coverage, 60915,
     /*  377817 */     GIR_EraseRootFromParent_Done,
     /*  377818 */   // Label 6825: @377818
     /*  377818 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(377884), // Rule ID 60918 //
     /*  377823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377882 */     GIR_RootConstrainSelectedInstOperands,
     /*  377883 */     // GIR_Coverage, 60918,
     /*  377883 */     GIR_EraseRootFromParent_Done,
     /*  377884 */   // Label 6826: @377884
     /*  377884 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(377950), // Rule ID 60919 //
     /*  377889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377948 */     GIR_RootConstrainSelectedInstOperands,
     /*  377949 */     // GIR_Coverage, 60919,
     /*  377949 */     GIR_EraseRootFromParent_Done,
     /*  377950 */   // Label 6827: @377950
     /*  377950 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(378016), // Rule ID 60922 //
     /*  377955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378014 */     GIR_RootConstrainSelectedInstOperands,
     /*  378015 */     // GIR_Coverage, 60922,
     /*  378015 */     GIR_EraseRootFromParent_Done,
     /*  378016 */   // Label 6828: @378016
     /*  378016 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(378082), // Rule ID 60923 //
     /*  378021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378060 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  378063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378080 */     GIR_RootConstrainSelectedInstOperands,
     /*  378081 */     // GIR_Coverage, 60923,
     /*  378081 */     GIR_EraseRootFromParent_Done,
     /*  378082 */   // Label 6829: @378082
     /*  378082 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(378148), // Rule ID 60926 //
     /*  378087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378146 */     GIR_RootConstrainSelectedInstOperands,
     /*  378147 */     // GIR_Coverage, 60926,
     /*  378147 */     GIR_EraseRootFromParent_Done,
     /*  378148 */   // Label 6830: @378148
     /*  378148 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(378214), // Rule ID 60927 //
     /*  378153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378212 */     GIR_RootConstrainSelectedInstOperands,
     /*  378213 */     // GIR_Coverage, 60927,
     /*  378213 */     GIR_EraseRootFromParent_Done,
     /*  378214 */   // Label 6831: @378214
     /*  378214 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(378280), // Rule ID 60930 //
     /*  378219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378258 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378278 */     GIR_RootConstrainSelectedInstOperands,
     /*  378279 */     // GIR_Coverage, 60930,
     /*  378279 */     GIR_EraseRootFromParent_Done,
     /*  378280 */   // Label 6832: @378280
     /*  378280 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(378346), // Rule ID 60931 //
     /*  378285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378324 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378344 */     GIR_RootConstrainSelectedInstOperands,
     /*  378345 */     // GIR_Coverage, 60931,
     /*  378345 */     GIR_EraseRootFromParent_Done,
     /*  378346 */   // Label 6833: @378346
     /*  378346 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(378412), // Rule ID 60934 //
     /*  378351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378410 */     GIR_RootConstrainSelectedInstOperands,
     /*  378411 */     // GIR_Coverage, 60934,
     /*  378411 */     GIR_EraseRootFromParent_Done,
     /*  378412 */   // Label 6834: @378412
     /*  378412 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(378478), // Rule ID 60935 //
     /*  378417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378456 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378476 */     GIR_RootConstrainSelectedInstOperands,
     /*  378477 */     // GIR_Coverage, 60935,
     /*  378477 */     GIR_EraseRootFromParent_Done,
     /*  378478 */   // Label 6835: @378478
     /*  378478 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(378544), // Rule ID 60938 //
     /*  378483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378542 */     GIR_RootConstrainSelectedInstOperands,
     /*  378543 */     // GIR_Coverage, 60938,
     /*  378543 */     GIR_EraseRootFromParent_Done,
     /*  378544 */   // Label 6836: @378544
     /*  378544 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(378610), // Rule ID 60939 //
     /*  378549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378608 */     GIR_RootConstrainSelectedInstOperands,
     /*  378609 */     // GIR_Coverage, 60939,
     /*  378609 */     GIR_EraseRootFromParent_Done,
     /*  378610 */   // Label 6837: @378610
     /*  378610 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(378676), // Rule ID 60942 //
     /*  378615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378674 */     GIR_RootConstrainSelectedInstOperands,
     /*  378675 */     // GIR_Coverage, 60942,
     /*  378675 */     GIR_EraseRootFromParent_Done,
     /*  378676 */   // Label 6838: @378676
     /*  378676 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(378742), // Rule ID 60943 //
     /*  378681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378740 */     GIR_RootConstrainSelectedInstOperands,
     /*  378741 */     // GIR_Coverage, 60943,
     /*  378741 */     GIR_EraseRootFromParent_Done,
     /*  378742 */   // Label 6839: @378742
     /*  378742 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(378808), // Rule ID 60946 //
     /*  378747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378806 */     GIR_RootConstrainSelectedInstOperands,
     /*  378807 */     // GIR_Coverage, 60946,
     /*  378807 */     GIR_EraseRootFromParent_Done,
     /*  378808 */   // Label 6840: @378808
     /*  378808 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(378874), // Rule ID 60947 //
     /*  378813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378872 */     GIR_RootConstrainSelectedInstOperands,
     /*  378873 */     // GIR_Coverage, 60947,
     /*  378873 */     GIR_EraseRootFromParent_Done,
     /*  378874 */   // Label 6841: @378874
     /*  378874 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(378940), // Rule ID 60950 //
     /*  378879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378938 */     GIR_RootConstrainSelectedInstOperands,
     /*  378939 */     // GIR_Coverage, 60950,
     /*  378939 */     GIR_EraseRootFromParent_Done,
     /*  378940 */   // Label 6842: @378940
     /*  378940 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(379006), // Rule ID 60951 //
     /*  378945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379004 */     GIR_RootConstrainSelectedInstOperands,
     /*  379005 */     // GIR_Coverage, 60951,
     /*  379005 */     GIR_EraseRootFromParent_Done,
     /*  379006 */   // Label 6843: @379006
     /*  379006 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(379072), // Rule ID 60954 //
     /*  379011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379070 */     GIR_RootConstrainSelectedInstOperands,
     /*  379071 */     // GIR_Coverage, 60954,
     /*  379071 */     GIR_EraseRootFromParent_Done,
     /*  379072 */   // Label 6844: @379072
     /*  379072 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(379138), // Rule ID 60955 //
     /*  379077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379136 */     GIR_RootConstrainSelectedInstOperands,
     /*  379137 */     // GIR_Coverage, 60955,
     /*  379137 */     GIR_EraseRootFromParent_Done,
     /*  379138 */   // Label 6845: @379138
     /*  379138 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(379204), // Rule ID 60958 //
     /*  379143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379202 */     GIR_RootConstrainSelectedInstOperands,
     /*  379203 */     // GIR_Coverage, 60958,
     /*  379203 */     GIR_EraseRootFromParent_Done,
     /*  379204 */   // Label 6846: @379204
     /*  379204 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(379270), // Rule ID 60959 //
     /*  379209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379268 */     GIR_RootConstrainSelectedInstOperands,
     /*  379269 */     // GIR_Coverage, 60959,
     /*  379269 */     GIR_EraseRootFromParent_Done,
     /*  379270 */   // Label 6847: @379270
     /*  379270 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(379336), // Rule ID 60962 //
     /*  379275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  379317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379334 */     GIR_RootConstrainSelectedInstOperands,
     /*  379335 */     // GIR_Coverage, 60962,
     /*  379335 */     GIR_EraseRootFromParent_Done,
     /*  379336 */   // Label 6848: @379336
     /*  379336 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(379402), // Rule ID 60963 //
     /*  379341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379380 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  379383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379400 */     GIR_RootConstrainSelectedInstOperands,
     /*  379401 */     // GIR_Coverage, 60963,
     /*  379401 */     GIR_EraseRootFromParent_Done,
     /*  379402 */   // Label 6849: @379402
     /*  379402 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(379468), // Rule ID 60966 //
     /*  379407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379466 */     GIR_RootConstrainSelectedInstOperands,
     /*  379467 */     // GIR_Coverage, 60966,
     /*  379467 */     GIR_EraseRootFromParent_Done,
     /*  379468 */   // Label 6850: @379468
     /*  379468 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(379534), // Rule ID 60967 //
     /*  379473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379532 */     GIR_RootConstrainSelectedInstOperands,
     /*  379533 */     // GIR_Coverage, 60967,
     /*  379533 */     GIR_EraseRootFromParent_Done,
     /*  379534 */   // Label 6851: @379534
     /*  379534 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(379600), // Rule ID 60970 //
     /*  379539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379598 */     GIR_RootConstrainSelectedInstOperands,
     /*  379599 */     // GIR_Coverage, 60970,
     /*  379599 */     GIR_EraseRootFromParent_Done,
     /*  379600 */   // Label 6852: @379600
     /*  379600 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(379666), // Rule ID 60971 //
     /*  379605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379644 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379664 */     GIR_RootConstrainSelectedInstOperands,
     /*  379665 */     // GIR_Coverage, 60971,
     /*  379665 */     GIR_EraseRootFromParent_Done,
     /*  379666 */   // Label 6853: @379666
     /*  379666 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(379732), // Rule ID 61394 //
     /*  379671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379710 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379730 */     GIR_RootConstrainSelectedInstOperands,
     /*  379731 */     // GIR_Coverage, 61394,
     /*  379731 */     GIR_EraseRootFromParent_Done,
     /*  379732 */   // Label 6854: @379732
     /*  379732 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(379798), // Rule ID 61395 //
     /*  379737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379796 */     GIR_RootConstrainSelectedInstOperands,
     /*  379797 */     // GIR_Coverage, 61395,
     /*  379797 */     GIR_EraseRootFromParent_Done,
     /*  379798 */   // Label 6855: @379798
     /*  379798 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(379864), // Rule ID 61398 //
     /*  379803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379842 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379862 */     GIR_RootConstrainSelectedInstOperands,
     /*  379863 */     // GIR_Coverage, 61398,
     /*  379863 */     GIR_EraseRootFromParent_Done,
     /*  379864 */   // Label 6856: @379864
     /*  379864 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(379930), // Rule ID 61399 //
     /*  379869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379928 */     GIR_RootConstrainSelectedInstOperands,
     /*  379929 */     // GIR_Coverage, 61399,
     /*  379929 */     GIR_EraseRootFromParent_Done,
     /*  379930 */   // Label 6857: @379930
     /*  379930 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(379996), // Rule ID 61402 //
     /*  379935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379974 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379994 */     GIR_RootConstrainSelectedInstOperands,
     /*  379995 */     // GIR_Coverage, 61402,
     /*  379995 */     GIR_EraseRootFromParent_Done,
     /*  379996 */   // Label 6858: @379996
     /*  379996 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(380062), // Rule ID 61403 //
     /*  380001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380060 */     GIR_RootConstrainSelectedInstOperands,
     /*  380061 */     // GIR_Coverage, 61403,
     /*  380061 */     GIR_EraseRootFromParent_Done,
     /*  380062 */   // Label 6859: @380062
     /*  380062 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(380128), // Rule ID 61406 //
     /*  380067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  380109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380126 */     GIR_RootConstrainSelectedInstOperands,
     /*  380127 */     // GIR_Coverage, 61406,
     /*  380127 */     GIR_EraseRootFromParent_Done,
     /*  380128 */   // Label 6860: @380128
     /*  380128 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(380194), // Rule ID 61407 //
     /*  380133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  380175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380192 */     GIR_RootConstrainSelectedInstOperands,
     /*  380193 */     // GIR_Coverage, 61407,
     /*  380193 */     GIR_EraseRootFromParent_Done,
     /*  380194 */   // Label 6861: @380194
     /*  380194 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(380260), // Rule ID 61410 //
     /*  380199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380258 */     GIR_RootConstrainSelectedInstOperands,
     /*  380259 */     // GIR_Coverage, 61410,
     /*  380259 */     GIR_EraseRootFromParent_Done,
     /*  380260 */   // Label 6862: @380260
     /*  380260 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(380326), // Rule ID 61411 //
     /*  380265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380324 */     GIR_RootConstrainSelectedInstOperands,
     /*  380325 */     // GIR_Coverage, 61411,
     /*  380325 */     GIR_EraseRootFromParent_Done,
     /*  380326 */   // Label 6863: @380326
     /*  380326 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(380392), // Rule ID 61414 //
     /*  380331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380390 */     GIR_RootConstrainSelectedInstOperands,
     /*  380391 */     // GIR_Coverage, 61414,
     /*  380391 */     GIR_EraseRootFromParent_Done,
     /*  380392 */   // Label 6864: @380392
     /*  380392 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(380458), // Rule ID 61415 //
     /*  380397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  380439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380456 */     GIR_RootConstrainSelectedInstOperands,
     /*  380457 */     // GIR_Coverage, 61415,
     /*  380457 */     GIR_EraseRootFromParent_Done,
     /*  380458 */   // Label 6865: @380458
     /*  380458 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(380524), // Rule ID 61418 //
     /*  380463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380522 */     GIR_RootConstrainSelectedInstOperands,
     /*  380523 */     // GIR_Coverage, 61418,
     /*  380523 */     GIR_EraseRootFromParent_Done,
     /*  380524 */   // Label 6866: @380524
     /*  380524 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(380590), // Rule ID 61419 //
     /*  380529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11222:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380588 */     GIR_RootConstrainSelectedInstOperands,
     /*  380589 */     // GIR_Coverage, 61419,
     /*  380589 */     GIR_EraseRootFromParent_Done,
     /*  380590 */   // Label 6867: @380590
     /*  380590 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(380656), // Rule ID 61422 //
     /*  380595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380634 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380654 */     GIR_RootConstrainSelectedInstOperands,
     /*  380655 */     // GIR_Coverage, 61422,
     /*  380655 */     GIR_EraseRootFromParent_Done,
     /*  380656 */   // Label 6868: @380656
     /*  380656 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(380722), // Rule ID 61423 //
     /*  380661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11222:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380720 */     GIR_RootConstrainSelectedInstOperands,
     /*  380721 */     // GIR_Coverage, 61423,
     /*  380721 */     GIR_EraseRootFromParent_Done,
     /*  380722 */   // Label 6869: @380722
     /*  380722 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(380788), // Rule ID 61426 //
     /*  380727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380786 */     GIR_RootConstrainSelectedInstOperands,
     /*  380787 */     // GIR_Coverage, 61426,
     /*  380787 */     GIR_EraseRootFromParent_Done,
     /*  380788 */   // Label 6870: @380788
     /*  380788 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(380854), // Rule ID 61427 //
     /*  380793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380852 */     GIR_RootConstrainSelectedInstOperands,
     /*  380853 */     // GIR_Coverage, 61427,
     /*  380853 */     GIR_EraseRootFromParent_Done,
     /*  380854 */   // Label 6871: @380854
     /*  380854 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(380920), // Rule ID 61430 //
     /*  380859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380918 */     GIR_RootConstrainSelectedInstOperands,
     /*  380919 */     // GIR_Coverage, 61430,
     /*  380919 */     GIR_EraseRootFromParent_Done,
     /*  380920 */   // Label 6872: @380920
     /*  380920 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(380986), // Rule ID 61431 //
     /*  380925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380984 */     GIR_RootConstrainSelectedInstOperands,
     /*  380985 */     // GIR_Coverage, 61431,
     /*  380985 */     GIR_EraseRootFromParent_Done,
     /*  380986 */   // Label 6873: @380986
     /*  380986 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(381052), // Rule ID 61434 //
     /*  380991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381050 */     GIR_RootConstrainSelectedInstOperands,
     /*  381051 */     // GIR_Coverage, 61434,
     /*  381051 */     GIR_EraseRootFromParent_Done,
     /*  381052 */   // Label 6874: @381052
     /*  381052 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(381118), // Rule ID 61435 //
     /*  381057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381116 */     GIR_RootConstrainSelectedInstOperands,
     /*  381117 */     // GIR_Coverage, 61435,
     /*  381117 */     GIR_EraseRootFromParent_Done,
     /*  381118 */   // Label 6875: @381118
     /*  381118 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(381184), // Rule ID 61438 //
     /*  381123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381182 */     GIR_RootConstrainSelectedInstOperands,
     /*  381183 */     // GIR_Coverage, 61438,
     /*  381183 */     GIR_EraseRootFromParent_Done,
     /*  381184 */   // Label 6876: @381184
     /*  381184 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(381250), // Rule ID 61439 //
     /*  381189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381248 */     GIR_RootConstrainSelectedInstOperands,
     /*  381249 */     // GIR_Coverage, 61439,
     /*  381249 */     GIR_EraseRootFromParent_Done,
     /*  381250 */   // Label 6877: @381250
     /*  381250 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(381316), // Rule ID 61442 //
     /*  381255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381294 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381314 */     GIR_RootConstrainSelectedInstOperands,
     /*  381315 */     // GIR_Coverage, 61442,
     /*  381315 */     GIR_EraseRootFromParent_Done,
     /*  381316 */   // Label 6878: @381316
     /*  381316 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(381382), // Rule ID 61443 //
     /*  381321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381380 */     GIR_RootConstrainSelectedInstOperands,
     /*  381381 */     // GIR_Coverage, 61443,
     /*  381381 */     GIR_EraseRootFromParent_Done,
     /*  381382 */   // Label 6879: @381382
     /*  381382 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(381448), // Rule ID 61446 //
     /*  381387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381446 */     GIR_RootConstrainSelectedInstOperands,
     /*  381447 */     // GIR_Coverage, 61446,
     /*  381447 */     GIR_EraseRootFromParent_Done,
     /*  381448 */   // Label 6880: @381448
     /*  381448 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(381514), // Rule ID 61447 //
     /*  381453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381512 */     GIR_RootConstrainSelectedInstOperands,
     /*  381513 */     // GIR_Coverage, 61447,
     /*  381513 */     GIR_EraseRootFromParent_Done,
     /*  381514 */   // Label 6881: @381514
     /*  381514 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(381580), // Rule ID 61450 //
     /*  381519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381578 */     GIR_RootConstrainSelectedInstOperands,
     /*  381579 */     // GIR_Coverage, 61450,
     /*  381579 */     GIR_EraseRootFromParent_Done,
     /*  381580 */   // Label 6882: @381580
     /*  381580 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(381646), // Rule ID 61451 //
     /*  381585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381644 */     GIR_RootConstrainSelectedInstOperands,
     /*  381645 */     // GIR_Coverage, 61451,
     /*  381645 */     GIR_EraseRootFromParent_Done,
     /*  381646 */   // Label 6883: @381646
     /*  381646 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(381712), // Rule ID 61454 //
     /*  381651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381710 */     GIR_RootConstrainSelectedInstOperands,
     /*  381711 */     // GIR_Coverage, 61454,
     /*  381711 */     GIR_EraseRootFromParent_Done,
     /*  381712 */   // Label 6884: @381712
     /*  381712 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(381778), // Rule ID 61455 //
     /*  381717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381756 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381776 */     GIR_RootConstrainSelectedInstOperands,
     /*  381777 */     // GIR_Coverage, 61455,
     /*  381777 */     GIR_EraseRootFromParent_Done,
     /*  381778 */   // Label 6885: @381778
     /*  381778 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(381844), // Rule ID 61458 //
     /*  381783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381842 */     GIR_RootConstrainSelectedInstOperands,
     /*  381843 */     // GIR_Coverage, 61458,
     /*  381843 */     GIR_EraseRootFromParent_Done,
     /*  381844 */   // Label 6886: @381844
     /*  381844 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(381910), // Rule ID 61459 //
     /*  381849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381908 */     GIR_RootConstrainSelectedInstOperands,
     /*  381909 */     // GIR_Coverage, 61459,
     /*  381909 */     GIR_EraseRootFromParent_Done,
     /*  381910 */   // Label 6887: @381910
     /*  381910 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(381976), // Rule ID 61462 //
     /*  381915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381974 */     GIR_RootConstrainSelectedInstOperands,
     /*  381975 */     // GIR_Coverage, 61462,
     /*  381975 */     GIR_EraseRootFromParent_Done,
     /*  381976 */   // Label 6888: @381976
     /*  381976 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(382042), // Rule ID 61463 //
     /*  381981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382040 */     GIR_RootConstrainSelectedInstOperands,
     /*  382041 */     // GIR_Coverage, 61463,
     /*  382041 */     GIR_EraseRootFromParent_Done,
     /*  382042 */   // Label 6889: @382042
     /*  382042 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(382108), // Rule ID 61466 //
     /*  382047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382106 */     GIR_RootConstrainSelectedInstOperands,
     /*  382107 */     // GIR_Coverage, 61466,
     /*  382107 */     GIR_EraseRootFromParent_Done,
     /*  382108 */   // Label 6890: @382108
     /*  382108 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(382174), // Rule ID 61467 //
     /*  382113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382172 */     GIR_RootConstrainSelectedInstOperands,
     /*  382173 */     // GIR_Coverage, 61467,
     /*  382173 */     GIR_EraseRootFromParent_Done,
     /*  382174 */   // Label 6891: @382174
     /*  382174 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(382240), // Rule ID 61470 //
     /*  382179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  382221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382238 */     GIR_RootConstrainSelectedInstOperands,
     /*  382239 */     // GIR_Coverage, 61470,
     /*  382239 */     GIR_EraseRootFromParent_Done,
     /*  382240 */   // Label 6892: @382240
     /*  382240 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(382306), // Rule ID 61471 //
     /*  382245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  382287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382304 */     GIR_RootConstrainSelectedInstOperands,
     /*  382305 */     // GIR_Coverage, 61471,
     /*  382305 */     GIR_EraseRootFromParent_Done,
     /*  382306 */   // Label 6893: @382306
     /*  382306 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(382372), // Rule ID 61474 //
     /*  382311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382370 */     GIR_RootConstrainSelectedInstOperands,
     /*  382371 */     // GIR_Coverage, 61474,
     /*  382371 */     GIR_EraseRootFromParent_Done,
     /*  382372 */   // Label 6894: @382372
     /*  382372 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(382438), // Rule ID 61475 //
     /*  382377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  382419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382436 */     GIR_RootConstrainSelectedInstOperands,
     /*  382437 */     // GIR_Coverage, 61475,
     /*  382437 */     GIR_EraseRootFromParent_Done,
     /*  382438 */   // Label 6895: @382438
     /*  382438 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(382504), // Rule ID 61478 //
     /*  382443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382502 */     GIR_RootConstrainSelectedInstOperands,
     /*  382503 */     // GIR_Coverage, 61478,
     /*  382503 */     GIR_EraseRootFromParent_Done,
     /*  382504 */   // Label 6896: @382504
     /*  382504 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(382570), // Rule ID 61479 //
     /*  382509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382548 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382568 */     GIR_RootConstrainSelectedInstOperands,
     /*  382569 */     // GIR_Coverage, 61479,
     /*  382569 */     GIR_EraseRootFromParent_Done,
     /*  382570 */   // Label 6897: @382570
     /*  382570 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(382636), // Rule ID 61482 //
     /*  382575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382634 */     GIR_RootConstrainSelectedInstOperands,
     /*  382635 */     // GIR_Coverage, 61482,
     /*  382635 */     GIR_EraseRootFromParent_Done,
     /*  382636 */   // Label 6898: @382636
     /*  382636 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(382702), // Rule ID 61483 //
     /*  382641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382700 */     GIR_RootConstrainSelectedInstOperands,
     /*  382701 */     // GIR_Coverage, 61483,
     /*  382701 */     GIR_EraseRootFromParent_Done,
     /*  382702 */   // Label 6899: @382702
     /*  382702 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(382768), // Rule ID 61486 //
     /*  382707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382766 */     GIR_RootConstrainSelectedInstOperands,
     /*  382767 */     // GIR_Coverage, 61486,
     /*  382767 */     GIR_EraseRootFromParent_Done,
     /*  382768 */   // Label 6900: @382768
     /*  382768 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(382834), // Rule ID 61487 //
     /*  382773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382832 */     GIR_RootConstrainSelectedInstOperands,
     /*  382833 */     // GIR_Coverage, 61487,
     /*  382833 */     GIR_EraseRootFromParent_Done,
     /*  382834 */   // Label 6901: @382834
     /*  382834 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(382900), // Rule ID 61490 //
     /*  382839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382898 */     GIR_RootConstrainSelectedInstOperands,
     /*  382899 */     // GIR_Coverage, 61490,
     /*  382899 */     GIR_EraseRootFromParent_Done,
     /*  382900 */   // Label 6902: @382900
     /*  382900 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(382966), // Rule ID 61491 //
     /*  382905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382964 */     GIR_RootConstrainSelectedInstOperands,
     /*  382965 */     // GIR_Coverage, 61491,
     /*  382965 */     GIR_EraseRootFromParent_Done,
     /*  382966 */   // Label 6903: @382966
     /*  382966 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(383032), // Rule ID 61494 //
     /*  382971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  383013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383030 */     GIR_RootConstrainSelectedInstOperands,
     /*  383031 */     // GIR_Coverage, 61494,
     /*  383031 */     GIR_EraseRootFromParent_Done,
     /*  383032 */   // Label 6904: @383032
     /*  383032 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(383098), // Rule ID 61495 //
     /*  383037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  383079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383096 */     GIR_RootConstrainSelectedInstOperands,
     /*  383097 */     // GIR_Coverage, 61495,
     /*  383097 */     GIR_EraseRootFromParent_Done,
     /*  383098 */   // Label 6905: @383098
     /*  383098 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(383164), // Rule ID 61498 //
     /*  383103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383162 */     GIR_RootConstrainSelectedInstOperands,
     /*  383163 */     // GIR_Coverage, 61498,
     /*  383163 */     GIR_EraseRootFromParent_Done,
     /*  383164 */   // Label 6906: @383164
     /*  383164 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(383230), // Rule ID 61499 //
     /*  383169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383228 */     GIR_RootConstrainSelectedInstOperands,
     /*  383229 */     // GIR_Coverage, 61499,
     /*  383229 */     GIR_EraseRootFromParent_Done,
     /*  383230 */   // Label 6907: @383230
     /*  383230 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(383296), // Rule ID 61502 //
     /*  383235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383294 */     GIR_RootConstrainSelectedInstOperands,
     /*  383295 */     // GIR_Coverage, 61502,
     /*  383295 */     GIR_EraseRootFromParent_Done,
     /*  383296 */   // Label 6908: @383296
     /*  383296 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(383362), // Rule ID 61503 //
     /*  383301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  383343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383360 */     GIR_RootConstrainSelectedInstOperands,
     /*  383361 */     // GIR_Coverage, 61503,
     /*  383361 */     GIR_EraseRootFromParent_Done,
     /*  383362 */   // Label 6909: @383362
     /*  383362 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(383428), // Rule ID 61506 //
     /*  383367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383406 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383426 */     GIR_RootConstrainSelectedInstOperands,
     /*  383427 */     // GIR_Coverage, 61506,
     /*  383427 */     GIR_EraseRootFromParent_Done,
     /*  383428 */   // Label 6910: @383428
     /*  383428 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(383494), // Rule ID 61507 //
     /*  383433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11573:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383492 */     GIR_RootConstrainSelectedInstOperands,
     /*  383493 */     // GIR_Coverage, 61507,
     /*  383493 */     GIR_EraseRootFromParent_Done,
     /*  383494 */   // Label 6911: @383494
     /*  383494 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(383560), // Rule ID 61510 //
     /*  383499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383558 */     GIR_RootConstrainSelectedInstOperands,
     /*  383559 */     // GIR_Coverage, 61510,
     /*  383559 */     GIR_EraseRootFromParent_Done,
     /*  383560 */   // Label 6912: @383560
     /*  383560 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(383626), // Rule ID 61511 //
     /*  383565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383624 */     GIR_RootConstrainSelectedInstOperands,
     /*  383625 */     // GIR_Coverage, 61511,
     /*  383625 */     GIR_EraseRootFromParent_Done,
     /*  383626 */   // Label 6913: @383626
     /*  383626 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(383692), // Rule ID 61514 //
     /*  383631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383690 */     GIR_RootConstrainSelectedInstOperands,
     /*  383691 */     // GIR_Coverage, 61514,
     /*  383691 */     GIR_EraseRootFromParent_Done,
     /*  383692 */   // Label 6914: @383692
     /*  383692 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(383758), // Rule ID 61515 //
     /*  383697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383756 */     GIR_RootConstrainSelectedInstOperands,
     /*  383757 */     // GIR_Coverage, 61515,
     /*  383757 */     GIR_EraseRootFromParent_Done,
     /*  383758 */   // Label 6915: @383758
     /*  383758 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(383824), // Rule ID 61518 //
     /*  383763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383822 */     GIR_RootConstrainSelectedInstOperands,
     /*  383823 */     // GIR_Coverage, 61518,
     /*  383823 */     GIR_EraseRootFromParent_Done,
     /*  383824 */   // Label 6916: @383824
     /*  383824 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(383890), // Rule ID 61519 //
     /*  383829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383888 */     GIR_RootConstrainSelectedInstOperands,
     /*  383889 */     // GIR_Coverage, 61519,
     /*  383889 */     GIR_EraseRootFromParent_Done,
     /*  383890 */   // Label 6917: @383890
     /*  383890 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(383956), // Rule ID 61522 //
     /*  383895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383954 */     GIR_RootConstrainSelectedInstOperands,
     /*  383955 */     // GIR_Coverage, 61522,
     /*  383955 */     GIR_EraseRootFromParent_Done,
     /*  383956 */   // Label 6918: @383956
     /*  383956 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(384022), // Rule ID 61523 //
     /*  383961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384020 */     GIR_RootConstrainSelectedInstOperands,
     /*  384021 */     // GIR_Coverage, 61523,
     /*  384021 */     GIR_EraseRootFromParent_Done,
     /*  384022 */   // Label 6919: @384022
     /*  384022 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(384088), // Rule ID 61526 //
     /*  384027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384086 */     GIR_RootConstrainSelectedInstOperands,
     /*  384087 */     // GIR_Coverage, 61526,
     /*  384087 */     GIR_EraseRootFromParent_Done,
     /*  384088 */   // Label 6920: @384088
     /*  384088 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(384154), // Rule ID 61527 //
     /*  384093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384132 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384152 */     GIR_RootConstrainSelectedInstOperands,
     /*  384153 */     // GIR_Coverage, 61527,
     /*  384153 */     GIR_EraseRootFromParent_Done,
     /*  384154 */   // Label 6921: @384154
     /*  384154 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(384220), // Rule ID 61530 //
     /*  384159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384198 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384218 */     GIR_RootConstrainSelectedInstOperands,
     /*  384219 */     // GIR_Coverage, 61530,
     /*  384219 */     GIR_EraseRootFromParent_Done,
     /*  384220 */   // Label 6922: @384220
     /*  384220 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(384286), // Rule ID 61531 //
     /*  384225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384284 */     GIR_RootConstrainSelectedInstOperands,
     /*  384285 */     // GIR_Coverage, 61531,
     /*  384285 */     GIR_EraseRootFromParent_Done,
     /*  384286 */   // Label 6923: @384286
     /*  384286 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(384352), // Rule ID 61534 //
     /*  384291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384350 */     GIR_RootConstrainSelectedInstOperands,
     /*  384351 */     // GIR_Coverage, 61534,
     /*  384351 */     GIR_EraseRootFromParent_Done,
     /*  384352 */   // Label 6924: @384352
     /*  384352 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(384418), // Rule ID 61535 //
     /*  384357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384416 */     GIR_RootConstrainSelectedInstOperands,
     /*  384417 */     // GIR_Coverage, 61535,
     /*  384417 */     GIR_EraseRootFromParent_Done,
     /*  384418 */   // Label 6925: @384418
     /*  384418 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(384484), // Rule ID 61538 //
     /*  384423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384482 */     GIR_RootConstrainSelectedInstOperands,
     /*  384483 */     // GIR_Coverage, 61538,
     /*  384483 */     GIR_EraseRootFromParent_Done,
     /*  384484 */   // Label 6926: @384484
     /*  384484 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(384550), // Rule ID 61539 //
     /*  384489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384528 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384548 */     GIR_RootConstrainSelectedInstOperands,
     /*  384549 */     // GIR_Coverage, 61539,
     /*  384549 */     GIR_EraseRootFromParent_Done,
     /*  384550 */   // Label 6927: @384550
     /*  384550 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(384616), // Rule ID 61542 //
     /*  384555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384614 */     GIR_RootConstrainSelectedInstOperands,
     /*  384615 */     // GIR_Coverage, 61542,
     /*  384615 */     GIR_EraseRootFromParent_Done,
     /*  384616 */   // Label 6928: @384616
     /*  384616 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(384682), // Rule ID 61543 //
     /*  384621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384680 */     GIR_RootConstrainSelectedInstOperands,
     /*  384681 */     // GIR_Coverage, 61543,
     /*  384681 */     GIR_EraseRootFromParent_Done,
     /*  384682 */   // Label 6929: @384682
     /*  384682 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(384748), // Rule ID 61546 //
     /*  384687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384746 */     GIR_RootConstrainSelectedInstOperands,
     /*  384747 */     // GIR_Coverage, 61546,
     /*  384747 */     GIR_EraseRootFromParent_Done,
     /*  384748 */   // Label 6930: @384748
     /*  384748 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(384814), // Rule ID 61547 //
     /*  384753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384812 */     GIR_RootConstrainSelectedInstOperands,
     /*  384813 */     // GIR_Coverage, 61547,
     /*  384813 */     GIR_EraseRootFromParent_Done,
     /*  384814 */   // Label 6931: @384814
     /*  384814 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(384880), // Rule ID 61550 //
     /*  384819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384878 */     GIR_RootConstrainSelectedInstOperands,
     /*  384879 */     // GIR_Coverage, 61550,
     /*  384879 */     GIR_EraseRootFromParent_Done,
     /*  384880 */   // Label 6932: @384880
     /*  384880 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(384946), // Rule ID 61551 //
     /*  384885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384944 */     GIR_RootConstrainSelectedInstOperands,
     /*  384945 */     // GIR_Coverage, 61551,
     /*  384945 */     GIR_EraseRootFromParent_Done,
     /*  384946 */   // Label 6933: @384946
     /*  384946 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(385012), // Rule ID 61554 //
     /*  384951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385010 */     GIR_RootConstrainSelectedInstOperands,
     /*  385011 */     // GIR_Coverage, 61554,
     /*  385011 */     GIR_EraseRootFromParent_Done,
     /*  385012 */   // Label 6934: @385012
     /*  385012 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(385078), // Rule ID 61555 //
     /*  385017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385076 */     GIR_RootConstrainSelectedInstOperands,
     /*  385077 */     // GIR_Coverage, 61555,
     /*  385077 */     GIR_EraseRootFromParent_Done,
     /*  385078 */   // Label 6935: @385078
     /*  385078 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(385144), // Rule ID 61558 //
     /*  385083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  385125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385142 */     GIR_RootConstrainSelectedInstOperands,
     /*  385143 */     // GIR_Coverage, 61558,
     /*  385143 */     GIR_EraseRootFromParent_Done,
     /*  385144 */   // Label 6936: @385144
     /*  385144 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(385210), // Rule ID 61559 //
     /*  385149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  385191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385208 */     GIR_RootConstrainSelectedInstOperands,
     /*  385209 */     // GIR_Coverage, 61559,
     /*  385209 */     GIR_EraseRootFromParent_Done,
     /*  385210 */   // Label 6937: @385210
     /*  385210 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(385276), // Rule ID 61562 //
     /*  385215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  385257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385274 */     GIR_RootConstrainSelectedInstOperands,
     /*  385275 */     // GIR_Coverage, 61562,
     /*  385275 */     GIR_EraseRootFromParent_Done,
     /*  385276 */   // Label 6938: @385276
     /*  385276 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(385342), // Rule ID 61563 //
     /*  385281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  385323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385340 */     GIR_RootConstrainSelectedInstOperands,
     /*  385341 */     // GIR_Coverage, 61563,
     /*  385341 */     GIR_EraseRootFromParent_Done,
     /*  385342 */   // Label 6939: @385342
     /*  385342 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(385408), // Rule ID 61566 //
     /*  385347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385406 */     GIR_RootConstrainSelectedInstOperands,
     /*  385407 */     // GIR_Coverage, 61566,
     /*  385407 */     GIR_EraseRootFromParent_Done,
     /*  385408 */   // Label 6940: @385408
     /*  385408 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(385474), // Rule ID 61567 //
     /*  385413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  385455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385472 */     GIR_RootConstrainSelectedInstOperands,
     /*  385473 */     // GIR_Coverage, 61567,
     /*  385473 */     GIR_EraseRootFromParent_Done,
     /*  385474 */   // Label 6941: @385474
     /*  385474 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(385539), // Rule ID 64458 //
     /*  385479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385523 */     // MIs[1] Operand 1
     /*  385523 */     // No operand predicates
     /*  385523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385525 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  385528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385537 */     GIR_RootConstrainSelectedInstOperands,
     /*  385538 */     // GIR_Coverage, 64458,
     /*  385538 */     GIR_EraseRootFromParent_Done,
     /*  385539 */   // Label 6942: @385539
     /*  385539 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(385604), // Rule ID 64485 //
     /*  385544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385588 */     // MIs[1] Operand 1
     /*  385588 */     // No operand predicates
     /*  385588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385590 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  385593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385602 */     GIR_RootConstrainSelectedInstOperands,
     /*  385603 */     // GIR_Coverage, 64485,
     /*  385603 */     GIR_EraseRootFromParent_Done,
     /*  385604 */   // Label 6943: @385604
     /*  385604 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(385669), // Rule ID 64488 //
     /*  385609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385653 */     // MIs[1] Operand 1
     /*  385653 */     // No operand predicates
     /*  385653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385655 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  385658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385667 */     GIR_RootConstrainSelectedInstOperands,
     /*  385668 */     // GIR_Coverage, 64488,
     /*  385668 */     GIR_EraseRootFromParent_Done,
     /*  385669 */   // Label 6944: @385669
     /*  385669 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(385734), // Rule ID 64491 //
     /*  385674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  385682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385718 */     // MIs[1] Operand 1
     /*  385718 */     // No operand predicates
     /*  385718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385720 */     // (intrinsic_wo_chain:{ *:[i32] } 11026:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  385723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385732 */     GIR_RootConstrainSelectedInstOperands,
     /*  385733 */     // GIR_Coverage, 64491,
     /*  385733 */     GIR_EraseRootFromParent_Done,
     /*  385734 */   // Label 6945: @385734
     /*  385734 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(385799), // Rule ID 64494 //
     /*  385739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  385747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385783 */     // MIs[1] Operand 1
     /*  385783 */     // No operand predicates
     /*  385783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385785 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  385788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385797 */     GIR_RootConstrainSelectedInstOperands,
     /*  385798 */     // GIR_Coverage, 64494,
     /*  385798 */     GIR_EraseRootFromParent_Done,
     /*  385799 */   // Label 6946: @385799
     /*  385799 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(385864), // Rule ID 64497 //
     /*  385804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  385812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385848 */     // MIs[1] Operand 1
     /*  385848 */     // No operand predicates
     /*  385848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385850 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  385853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385862 */     GIR_RootConstrainSelectedInstOperands,
     /*  385863 */     // GIR_Coverage, 64497,
     /*  385863 */     GIR_EraseRootFromParent_Done,
     /*  385864 */   // Label 6947: @385864
     /*  385864 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(385929), // Rule ID 64500 //
     /*  385869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  385877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385913 */     // MIs[1] Operand 1
     /*  385913 */     // No operand predicates
     /*  385913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385915 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  385918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385927 */     GIR_RootConstrainSelectedInstOperands,
     /*  385928 */     // GIR_Coverage, 64500,
     /*  385928 */     GIR_EraseRootFromParent_Done,
     /*  385929 */   // Label 6948: @385929
     /*  385929 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(385994), // Rule ID 64503 //
     /*  385934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  385942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385978 */     // MIs[1] Operand 1
     /*  385978 */     // No operand predicates
     /*  385978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385980 */     // (intrinsic_wo_chain:{ *:[i32] } 11032:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  385983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385992 */     GIR_RootConstrainSelectedInstOperands,
     /*  385993 */     // GIR_Coverage, 64503,
     /*  385993 */     GIR_EraseRootFromParent_Done,
     /*  385994 */   // Label 6949: @385994
     /*  385994 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(386049), // Rule ID 2651 //
     /*  385999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  386002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  386007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386028 */     // MIs[0] imm
     /*  386028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386036 */     // (intrinsic_wo_chain:{ *:[i32] } 11008:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  386039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386045 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386047 */     GIR_RootConstrainSelectedInstOperands,
     /*  386048 */     // GIR_Coverage, 2651,
     /*  386048 */     GIR_EraseRootFromParent_Done,
     /*  386049 */   // Label 6950: @386049
     /*  386049 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(386104), // Rule ID 2652 //
     /*  386054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  386057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  386062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386083 */     // MIs[0] imm
     /*  386083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386091 */     // (intrinsic_wo_chain:{ *:[i32] } 11009:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  386094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386100 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386102 */     GIR_RootConstrainSelectedInstOperands,
     /*  386103 */     // GIR_Coverage, 2652,
     /*  386103 */     GIR_EraseRootFromParent_Done,
     /*  386104 */   // Label 6951: @386104
     /*  386104 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(386159), // Rule ID 2658 //
     /*  386109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  386112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  386117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386138 */     // MIs[0] imm
     /*  386138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386146 */     // (intrinsic_wo_chain:{ *:[i32] } 11010:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  386149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386155 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386157 */     GIR_RootConstrainSelectedInstOperands,
     /*  386158 */     // GIR_Coverage, 2658,
     /*  386158 */     GIR_EraseRootFromParent_Done,
     /*  386159 */   // Label 6952: @386159
     /*  386159 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(386214), // Rule ID 2659 //
     /*  386164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  386167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  386172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386193 */     // MIs[0] imm
     /*  386193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  386201 */     // (intrinsic_wo_chain:{ *:[i32] } 11011:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  386201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  386204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386210 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  386212 */     GIR_RootConstrainSelectedInstOperands,
     /*  386213 */     // GIR_Coverage, 2659,
     /*  386213 */     GIR_EraseRootFromParent_Done,
     /*  386214 */   // Label 6953: @386214
     /*  386214 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(386269), // Rule ID 64514 //
     /*  386219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  386227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386248 */     // MIs[0] imm5
     /*  386248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386256 */     // (intrinsic_wo_chain:{ *:[i32] } 11056:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  386259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386265 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386267 */     GIR_RootConstrainSelectedInstOperands,
     /*  386268 */     // GIR_Coverage, 64514,
     /*  386268 */     GIR_EraseRootFromParent_Done,
     /*  386269 */   // Label 6954: @386269
     /*  386269 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(386324), // Rule ID 64515 //
     /*  386274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  386282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386303 */     // MIs[0] imm5
     /*  386303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386311 */     // (intrinsic_wo_chain:{ *:[i32] } 11052:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  386314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386320 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386322 */     GIR_RootConstrainSelectedInstOperands,
     /*  386323 */     // GIR_Coverage, 64515,
     /*  386323 */     GIR_EraseRootFromParent_Done,
     /*  386324 */   // Label 6955: @386324
     /*  386324 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(386379), // Rule ID 64516 //
     /*  386329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  386337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386358 */     // MIs[0] imm5
     /*  386358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386366 */     // (intrinsic_wo_chain:{ *:[i32] } 11054:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  386369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386375 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386377 */     GIR_RootConstrainSelectedInstOperands,
     /*  386378 */     // GIR_Coverage, 64516,
     /*  386378 */     GIR_EraseRootFromParent_Done,
     /*  386379 */   // Label 6956: @386379
     /*  386379 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(386434), // Rule ID 64517 //
     /*  386384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  386392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386413 */     // MIs[0] imm5
     /*  386413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386421 */     // (intrinsic_wo_chain:{ *:[i32] } 11050:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  386424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386430 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386432 */     GIR_RootConstrainSelectedInstOperands,
     /*  386433 */     // GIR_Coverage, 64517,
     /*  386433 */     GIR_EraseRootFromParent_Done,
     /*  386434 */   // Label 6957: @386434
     /*  386434 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(386489), // Rule ID 64518 //
     /*  386439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  386447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386468 */     // MIs[0] imm5
     /*  386468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386476 */     // (intrinsic_wo_chain:{ *:[i32] } 11057:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  386479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386485 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386487 */     GIR_RootConstrainSelectedInstOperands,
     /*  386488 */     // GIR_Coverage, 64518,
     /*  386488 */     GIR_EraseRootFromParent_Done,
     /*  386489 */   // Label 6958: @386489
     /*  386489 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(386544), // Rule ID 64519 //
     /*  386494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  386502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386523 */     // MIs[0] imm5
     /*  386523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386531 */     // (intrinsic_wo_chain:{ *:[i32] } 11053:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  386534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386540 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386542 */     GIR_RootConstrainSelectedInstOperands,
     /*  386543 */     // GIR_Coverage, 64519,
     /*  386543 */     GIR_EraseRootFromParent_Done,
     /*  386544 */   // Label 6959: @386544
     /*  386544 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(386599), // Rule ID 64520 //
     /*  386549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  386557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386578 */     // MIs[0] imm5
     /*  386578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386586 */     // (intrinsic_wo_chain:{ *:[i32] } 11055:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  386589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386595 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386597 */     GIR_RootConstrainSelectedInstOperands,
     /*  386598 */     // GIR_Coverage, 64520,
     /*  386598 */     GIR_EraseRootFromParent_Done,
     /*  386599 */   // Label 6960: @386599
     /*  386599 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(386654), // Rule ID 64521 //
     /*  386604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  386612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386633 */     // MIs[0] imm5
     /*  386633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386641 */     // (intrinsic_wo_chain:{ *:[i32] } 11051:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  386644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386650 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386652 */     GIR_RootConstrainSelectedInstOperands,
     /*  386653 */     // GIR_Coverage, 64521,
     /*  386653 */     GIR_EraseRootFromParent_Done,
     /*  386654 */   // Label 6961: @386654
     /*  386654 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(386708), // Rule ID 64456 //
     /*  386659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386695 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386706 */     GIR_RootConstrainSelectedInstOperands,
     /*  386707 */     // GIR_Coverage, 64456,
     /*  386707 */     GIR_EraseRootFromParent_Done,
     /*  386708 */   // Label 6962: @386708
     /*  386708 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(386762), // Rule ID 64457 //
     /*  386713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386749 */     // (intrinsic_wo_chain:{ *:[i32] } 11023:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386760 */     GIR_RootConstrainSelectedInstOperands,
     /*  386761 */     // GIR_Coverage, 64457,
     /*  386761 */     GIR_EraseRootFromParent_Done,
     /*  386762 */   // Label 6963: @386762
     /*  386762 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(386816), // Rule ID 64483 //
     /*  386767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386803 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386814 */     GIR_RootConstrainSelectedInstOperands,
     /*  386815 */     // GIR_Coverage, 64483,
     /*  386815 */     GIR_EraseRootFromParent_Done,
     /*  386816 */   // Label 6964: @386816
     /*  386816 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(386870), // Rule ID 64484 //
     /*  386821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386857 */     // (intrinsic_wo_chain:{ *:[i32] } 11025:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386868 */     GIR_RootConstrainSelectedInstOperands,
     /*  386869 */     // GIR_Coverage, 64484,
     /*  386869 */     GIR_EraseRootFromParent_Done,
     /*  386870 */   // Label 6965: @386870
     /*  386870 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(386924), // Rule ID 64486 //
     /*  386875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386911 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386922 */     GIR_RootConstrainSelectedInstOperands,
     /*  386923 */     // GIR_Coverage, 64486,
     /*  386923 */     GIR_EraseRootFromParent_Done,
     /*  386924 */   // Label 6966: @386924
     /*  386924 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(386978), // Rule ID 64487 //
     /*  386929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386965 */     // (intrinsic_wo_chain:{ *:[i32] } 11024:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386976 */     GIR_RootConstrainSelectedInstOperands,
     /*  386977 */     // GIR_Coverage, 64487,
     /*  386977 */     GIR_EraseRootFromParent_Done,
     /*  386978 */   // Label 6967: @386978
     /*  386978 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(387032), // Rule ID 64489 //
     /*  386983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387019 */     // (intrinsic_wo_chain:{ *:[i32] } 11026:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  387022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387030 */     GIR_RootConstrainSelectedInstOperands,
     /*  387031 */     // GIR_Coverage, 64489,
     /*  387031 */     GIR_EraseRootFromParent_Done,
     /*  387032 */   // Label 6968: @387032
     /*  387032 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(387086), // Rule ID 64490 //
     /*  387037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  387045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387073 */     // (intrinsic_wo_chain:{ *:[i32] } 11026:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  387076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387084 */     GIR_RootConstrainSelectedInstOperands,
     /*  387085 */     // GIR_Coverage, 64490,
     /*  387085 */     GIR_EraseRootFromParent_Done,
     /*  387086 */   // Label 6969: @387086
     /*  387086 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(387140), // Rule ID 64492 //
     /*  387091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  387099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387127 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  387130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387138 */     GIR_RootConstrainSelectedInstOperands,
     /*  387139 */     // GIR_Coverage, 64492,
     /*  387139 */     GIR_EraseRootFromParent_Done,
     /*  387140 */   // Label 6970: @387140
     /*  387140 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(387194), // Rule ID 64493 //
     /*  387145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  387153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387181 */     // (intrinsic_wo_chain:{ *:[i32] } 11029:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  387184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387192 */     GIR_RootConstrainSelectedInstOperands,
     /*  387193 */     // GIR_Coverage, 64493,
     /*  387193 */     GIR_EraseRootFromParent_Done,
     /*  387194 */   // Label 6971: @387194
     /*  387194 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(387248), // Rule ID 64495 //
     /*  387199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  387207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387235 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  387238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387246 */     GIR_RootConstrainSelectedInstOperands,
     /*  387247 */     // GIR_Coverage, 64495,
     /*  387247 */     GIR_EraseRootFromParent_Done,
     /*  387248 */   // Label 6972: @387248
     /*  387248 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(387302), // Rule ID 64496 //
     /*  387253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  387261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387289 */     // (intrinsic_wo_chain:{ *:[i32] } 11031:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  387292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387300 */     GIR_RootConstrainSelectedInstOperands,
     /*  387301 */     // GIR_Coverage, 64496,
     /*  387301 */     GIR_EraseRootFromParent_Done,
     /*  387302 */   // Label 6973: @387302
     /*  387302 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(387356), // Rule ID 64498 //
     /*  387307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  387315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387343 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  387346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387354 */     GIR_RootConstrainSelectedInstOperands,
     /*  387355 */     // GIR_Coverage, 64498,
     /*  387355 */     GIR_EraseRootFromParent_Done,
     /*  387356 */   // Label 6974: @387356
     /*  387356 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(387410), // Rule ID 64499 //
     /*  387361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  387369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387397 */     // (intrinsic_wo_chain:{ *:[i32] } 11030:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  387400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387408 */     GIR_RootConstrainSelectedInstOperands,
     /*  387409 */     // GIR_Coverage, 64499,
     /*  387409 */     GIR_EraseRootFromParent_Done,
     /*  387410 */   // Label 6975: @387410
     /*  387410 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(387464), // Rule ID 64501 //
     /*  387415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  387418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387451 */     // (intrinsic_wo_chain:{ *:[i32] } 11032:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387462 */     GIR_RootConstrainSelectedInstOperands,
     /*  387463 */     // GIR_Coverage, 64501,
     /*  387463 */     GIR_EraseRootFromParent_Done,
     /*  387464 */   // Label 6976: @387464
     /*  387464 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(387518), // Rule ID 64502 //
     /*  387469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387505 */     // (intrinsic_wo_chain:{ *:[i32] } 11032:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387516 */     GIR_RootConstrainSelectedInstOperands,
     /*  387517 */     // GIR_Coverage, 64502,
     /*  387517 */     GIR_EraseRootFromParent_Done,
     /*  387518 */   // Label 6977: @387518
     /*  387518 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(387572), // Rule ID 64439 //
     /*  387523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  387526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387559 */     // (intrinsic_wo_chain:{ *:[i32] } 11039:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387570 */     GIR_RootConstrainSelectedInstOperands,
     /*  387571 */     // GIR_Coverage, 64439,
     /*  387571 */     GIR_EraseRootFromParent_Done,
     /*  387572 */   // Label 6978: @387572
     /*  387572 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(387626), // Rule ID 64440 //
     /*  387577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  387580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387613 */     // (intrinsic_wo_chain:{ *:[i32] } 11039:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387624 */     GIR_RootConstrainSelectedInstOperands,
     /*  387625 */     // GIR_Coverage, 64440,
     /*  387625 */     GIR_EraseRootFromParent_Done,
     /*  387626 */   // Label 6979: @387626
     /*  387626 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(387680), // Rule ID 64510 //
     /*  387631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387667 */     // (intrinsic_wo_chain:{ *:[i32] } 11040:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387678 */     GIR_RootConstrainSelectedInstOperands,
     /*  387679 */     // GIR_Coverage, 64510,
     /*  387679 */     GIR_EraseRootFromParent_Done,
     /*  387680 */   // Label 6980: @387680
     /*  387680 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(387734), // Rule ID 64511 //
     /*  387685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387721 */     // (intrinsic_wo_chain:{ *:[i32] } 11040:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387732 */     GIR_RootConstrainSelectedInstOperands,
     /*  387733 */     // GIR_Coverage, 64511,
     /*  387733 */     GIR_EraseRootFromParent_Done,
     /*  387734 */   // Label 6981: @387734
     /*  387734 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(387788), // Rule ID 64512 //
     /*  387739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387775 */     // (intrinsic_wo_chain:{ *:[i32] } 11049:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387786 */     GIR_RootConstrainSelectedInstOperands,
     /*  387787 */     // GIR_Coverage, 64512,
     /*  387787 */     GIR_EraseRootFromParent_Done,
     /*  387788 */   // Label 6982: @387788
     /*  387788 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(387842), // Rule ID 64513 //
     /*  387793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387829 */     // (intrinsic_wo_chain:{ *:[i32] } 11049:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387840 */     GIR_RootConstrainSelectedInstOperands,
     /*  387841 */     // GIR_Coverage, 64513,
     /*  387841 */     GIR_EraseRootFromParent_Done,
     /*  387842 */   // Label 6983: @387842
     /*  387842 */   GIM_Reject,
     /*  387843 */ // Label 4358: @387843
     /*  387843 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(906620),
     /*  387848 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  387851 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(387926), // Rule ID 62843 //
     /*  387856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387874 */     // MIs[0] op1
     /*  387874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387882 */     // MIs[0] op2
     /*  387882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387890 */     // MIs[0] op3
     /*  387890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387905 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387910 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387912 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387914 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387924 */     GIR_RootConstrainSelectedInstOperands,
     /*  387925 */     // GIR_Coverage, 62843,
     /*  387925 */     GIR_EraseRootFromParent_Done,
     /*  387926 */   // Label 6985: @387926
     /*  387926 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(388001), // Rule ID 62844 //
     /*  387931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387949 */     // MIs[0] op1
     /*  387949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387957 */     // MIs[0] op2
     /*  387957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387965 */     // MIs[0] op3
     /*  387965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF8),
     /*  387983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387985 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387987 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387989 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387999 */     GIR_RootConstrainSelectedInstOperands,
     /*  388000 */     // GIR_Coverage, 62844,
     /*  388000 */     GIR_EraseRootFromParent_Done,
     /*  388001 */   // Label 6986: @388001
     /*  388001 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(388076), // Rule ID 62875 //
     /*  388006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388024 */     // MIs[0] op1
     /*  388024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388032 */     // MIs[0] op2
     /*  388032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388040 */     // MIs[0] op3
     /*  388040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388055 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388074 */     GIR_RootConstrainSelectedInstOperands,
     /*  388075 */     // GIR_Coverage, 62875,
     /*  388075 */     GIR_EraseRootFromParent_Done,
     /*  388076 */   // Label 6987: @388076
     /*  388076 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(388151), // Rule ID 62876 //
     /*  388081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  388092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388099 */     // MIs[0] op1
     /*  388099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388107 */     // MIs[0] op2
     /*  388107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388115 */     // MIs[0] op3
     /*  388115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388135 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388137 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388139 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388149 */     GIR_RootConstrainSelectedInstOperands,
     /*  388150 */     // GIR_Coverage, 62876,
     /*  388150 */     GIR_EraseRootFromParent_Done,
     /*  388151 */   // Label 6988: @388151
     /*  388151 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(388226), // Rule ID 62919 //
     /*  388156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388174 */     // MIs[0] op1
     /*  388174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388182 */     // MIs[0] op2
     /*  388182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388190 */     // MIs[0] op3
     /*  388190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388205 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388224 */     GIR_RootConstrainSelectedInstOperands,
     /*  388225 */     // GIR_Coverage, 62919,
     /*  388225 */     GIR_EraseRootFromParent_Done,
     /*  388226 */   // Label 6989: @388226
     /*  388226 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(388301), // Rule ID 62920 //
     /*  388231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  388242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388249 */     // MIs[0] op1
     /*  388249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388257 */     // MIs[0] op2
     /*  388257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388265 */     // MIs[0] op3
     /*  388265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388280 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388299 */     GIR_RootConstrainSelectedInstOperands,
     /*  388300 */     // GIR_Coverage, 62920,
     /*  388300 */     GIR_EraseRootFromParent_Done,
     /*  388301 */   // Label 6990: @388301
     /*  388301 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(388376), // Rule ID 62963 //
     /*  388306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388324 */     // MIs[0] op1
     /*  388324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388332 */     // MIs[0] op2
     /*  388332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388340 */     // MIs[0] op3
     /*  388340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388355 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388360 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388362 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388364 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388374 */     GIR_RootConstrainSelectedInstOperands,
     /*  388375 */     // GIR_Coverage, 62963,
     /*  388375 */     GIR_EraseRootFromParent_Done,
     /*  388376 */   // Label 6991: @388376
     /*  388376 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(388451), // Rule ID 62964 //
     /*  388381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  388392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388399 */     // MIs[0] op1
     /*  388399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388407 */     // MIs[0] op2
     /*  388407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388415 */     // MIs[0] op3
     /*  388415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF4),
     /*  388433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388449 */     GIR_RootConstrainSelectedInstOperands,
     /*  388450 */     // GIR_Coverage, 62964,
     /*  388450 */     GIR_EraseRootFromParent_Done,
     /*  388451 */   // Label 6992: @388451
     /*  388451 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(388526), // Rule ID 63019 //
     /*  388456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388474 */     // MIs[0] op1
     /*  388474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388482 */     // MIs[0] op2
     /*  388482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388490 */     // MIs[0] op3
     /*  388490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388505 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388510 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388512 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388514 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388524 */     GIR_RootConstrainSelectedInstOperands,
     /*  388525 */     // GIR_Coverage, 63019,
     /*  388525 */     GIR_EraseRootFromParent_Done,
     /*  388526 */   // Label 6993: @388526
     /*  388526 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(388601), // Rule ID 63020 //
     /*  388531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388549 */     // MIs[0] op1
     /*  388549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388557 */     // MIs[0] op2
     /*  388557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388565 */     // MIs[0] op3
     /*  388565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388585 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388587 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388589 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388599 */     GIR_RootConstrainSelectedInstOperands,
     /*  388600 */     // GIR_Coverage, 63020,
     /*  388600 */     GIR_EraseRootFromParent_Done,
     /*  388601 */   // Label 6994: @388601
     /*  388601 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(388676), // Rule ID 63075 //
     /*  388606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388624 */     // MIs[0] op1
     /*  388624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388632 */     // MIs[0] op2
     /*  388632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388640 */     // MIs[0] op3
     /*  388640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388655 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388674 */     GIR_RootConstrainSelectedInstOperands,
     /*  388675 */     // GIR_Coverage, 63075,
     /*  388675 */     GIR_EraseRootFromParent_Done,
     /*  388676 */   // Label 6995: @388676
     /*  388676 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(388751), // Rule ID 63076 //
     /*  388681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388699 */     // MIs[0] op1
     /*  388699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388707 */     // MIs[0] op2
     /*  388707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388715 */     // MIs[0] op3
     /*  388715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_MF2),
     /*  388733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388749 */     GIR_RootConstrainSelectedInstOperands,
     /*  388750 */     // GIR_Coverage, 63076,
     /*  388750 */     GIR_EraseRootFromParent_Done,
     /*  388751 */   // Label 6996: @388751
     /*  388751 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(388826), // Rule ID 63131 //
     /*  388756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388774 */     // MIs[0] op1
     /*  388774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388782 */     // MIs[0] op2
     /*  388782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388790 */     // MIs[0] op3
     /*  388790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388805 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388824 */     GIR_RootConstrainSelectedInstOperands,
     /*  388825 */     // GIR_Coverage, 63131,
     /*  388825 */     GIR_EraseRootFromParent_Done,
     /*  388826 */   // Label 6997: @388826
     /*  388826 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(388901), // Rule ID 63132 //
     /*  388831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388849 */     // MIs[0] op1
     /*  388849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388857 */     // MIs[0] op2
     /*  388857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388865 */     // MIs[0] op3
     /*  388865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388899 */     GIR_RootConstrainSelectedInstOperands,
     /*  388900 */     // GIR_Coverage, 63132,
     /*  388900 */     GIR_EraseRootFromParent_Done,
     /*  388901 */   // Label 6998: @388901
     /*  388901 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(388976), // Rule ID 63175 //
     /*  388906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388924 */     // MIs[0] op1
     /*  388924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388932 */     // MIs[0] op2
     /*  388932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388940 */     // MIs[0] op3
     /*  388940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  388958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388974 */     GIR_RootConstrainSelectedInstOperands,
     /*  388975 */     // GIR_Coverage, 63175,
     /*  388975 */     GIR_EraseRootFromParent_Done,
     /*  388976 */   // Label 6999: @388976
     /*  388976 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(389051), // Rule ID 63176 //
     /*  388981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388999 */     // MIs[0] op1
     /*  388999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389007 */     // MIs[0] op2
     /*  389007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389015 */     // MIs[0] op3
     /*  389015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389035 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389037 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389039 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389049 */     GIR_RootConstrainSelectedInstOperands,
     /*  389050 */     // GIR_Coverage, 63176,
     /*  389050 */     GIR_EraseRootFromParent_Done,
     /*  389051 */   // Label 7000: @389051
     /*  389051 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(389126), // Rule ID 63231 //
     /*  389056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389074 */     // MIs[0] op1
     /*  389074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389082 */     // MIs[0] op2
     /*  389082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389090 */     // MIs[0] op3
     /*  389090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389105 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389110 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389112 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389114 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389124 */     GIR_RootConstrainSelectedInstOperands,
     /*  389125 */     // GIR_Coverage, 63231,
     /*  389125 */     GIR_EraseRootFromParent_Done,
     /*  389126 */   // Label 7001: @389126
     /*  389126 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(389201), // Rule ID 63232 //
     /*  389131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  389142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389149 */     // MIs[0] op1
     /*  389149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389157 */     // MIs[0] op2
     /*  389157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389160 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389165 */     // MIs[0] op3
     /*  389165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389185 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389187 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389189 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389199 */     GIR_RootConstrainSelectedInstOperands,
     /*  389200 */     // GIR_Coverage, 63232,
     /*  389200 */     GIR_EraseRootFromParent_Done,
     /*  389201 */   // Label 7002: @389201
     /*  389201 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(389276), // Rule ID 63287 //
     /*  389206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389224 */     // MIs[0] op1
     /*  389224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389232 */     // MIs[0] op2
     /*  389232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389240 */     // MIs[0] op3
     /*  389240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389255 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  389255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389274 */     GIR_RootConstrainSelectedInstOperands,
     /*  389275 */     // GIR_Coverage, 63287,
     /*  389275 */     GIR_EraseRootFromParent_Done,
     /*  389276 */   // Label 7003: @389276
     /*  389276 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(389351), // Rule ID 63288 //
     /*  389281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  389292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  389299 */     // MIs[0] op1
     /*  389299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389307 */     // MIs[0] op2
     /*  389307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389315 */     // MIs[0] op3
     /*  389315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  389330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M1),
     /*  389333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389335 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389337 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389339 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389349 */     GIR_RootConstrainSelectedInstOperands,
     /*  389350 */     // GIR_Coverage, 63288,
     /*  389350 */     GIR_EraseRootFromParent_Done,
     /*  389351 */   // Label 7004: @389351
     /*  389351 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(389426), // Rule ID 63343 //
     /*  389356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389374 */     // MIs[0] op1
     /*  389374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389382 */     // MIs[0] op2
     /*  389382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389390 */     // MIs[0] op3
     /*  389390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389410 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389412 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389414 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389424 */     GIR_RootConstrainSelectedInstOperands,
     /*  389425 */     // GIR_Coverage, 63343,
     /*  389425 */     GIR_EraseRootFromParent_Done,
     /*  389426 */   // Label 7005: @389426
     /*  389426 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(389501), // Rule ID 63344 //
     /*  389431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  389442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389449 */     // MIs[0] op1
     /*  389449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389457 */     // MIs[0] op2
     /*  389457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389465 */     // MIs[0] op3
     /*  389465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389485 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389487 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389489 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389499 */     GIR_RootConstrainSelectedInstOperands,
     /*  389500 */     // GIR_Coverage, 63344,
     /*  389500 */     GIR_EraseRootFromParent_Done,
     /*  389501 */   // Label 7006: @389501
     /*  389501 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(389576), // Rule ID 63387 //
     /*  389506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389524 */     // MIs[0] op1
     /*  389524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389532 */     // MIs[0] op2
     /*  389532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389540 */     // MIs[0] op3
     /*  389540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389555 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389574 */     GIR_RootConstrainSelectedInstOperands,
     /*  389575 */     // GIR_Coverage, 63387,
     /*  389575 */     GIR_EraseRootFromParent_Done,
     /*  389576 */   // Label 7007: @389576
     /*  389576 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(389651), // Rule ID 63388 //
     /*  389581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389599 */     // MIs[0] op1
     /*  389599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389607 */     // MIs[0] op2
     /*  389607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389615 */     // MIs[0] op3
     /*  389615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  389633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389635 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389637 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389639 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389649 */     GIR_RootConstrainSelectedInstOperands,
     /*  389650 */     // GIR_Coverage, 63388,
     /*  389650 */     GIR_EraseRootFromParent_Done,
     /*  389651 */   // Label 7008: @389651
     /*  389651 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(389726), // Rule ID 63431 //
     /*  389656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389674 */     // MIs[0] op1
     /*  389674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389682 */     // MIs[0] op2
     /*  389682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389690 */     // MIs[0] op3
     /*  389690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389705 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389724 */     GIR_RootConstrainSelectedInstOperands,
     /*  389725 */     // GIR_Coverage, 63431,
     /*  389725 */     GIR_EraseRootFromParent_Done,
     /*  389726 */   // Label 7009: @389726
     /*  389726 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(389801), // Rule ID 63432 //
     /*  389731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389749 */     // MIs[0] op1
     /*  389749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389757 */     // MIs[0] op2
     /*  389757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389765 */     // MIs[0] op3
     /*  389765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389780 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  389783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389785 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389787 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389789 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389799 */     GIR_RootConstrainSelectedInstOperands,
     /*  389800 */     // GIR_Coverage, 63432,
     /*  389800 */     GIR_EraseRootFromParent_Done,
     /*  389801 */   // Label 7010: @389801
     /*  389801 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(389876), // Rule ID 63475 //
     /*  389806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389824 */     // MIs[0] op1
     /*  389824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389832 */     // MIs[0] op2
     /*  389832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389840 */     // MIs[0] op3
     /*  389840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389860 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389862 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389864 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389874 */     GIR_RootConstrainSelectedInstOperands,
     /*  389875 */     // GIR_Coverage, 63475,
     /*  389875 */     GIR_EraseRootFromParent_Done,
     /*  389876 */   // Label 7011: @389876
     /*  389876 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(389951), // Rule ID 63476 //
     /*  389881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389899 */     // MIs[0] op1
     /*  389899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389907 */     // MIs[0] op2
     /*  389907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389915 */     // MIs[0] op3
     /*  389915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  389933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389935 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389937 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389939 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389949 */     GIR_RootConstrainSelectedInstOperands,
     /*  389950 */     // GIR_Coverage, 63476,
     /*  389950 */     GIR_EraseRootFromParent_Done,
     /*  389951 */   // Label 7012: @389951
     /*  389951 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(390026), // Rule ID 63531 //
     /*  389956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389974 */     // MIs[0] op1
     /*  389974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389982 */     // MIs[0] op2
     /*  389982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389990 */     // MIs[0] op3
     /*  389990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390005 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390010 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390012 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390014 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390024 */     GIR_RootConstrainSelectedInstOperands,
     /*  390025 */     // GIR_Coverage, 63531,
     /*  390025 */     GIR_EraseRootFromParent_Done,
     /*  390026 */   // Label 7013: @390026
     /*  390026 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(390101), // Rule ID 63532 //
     /*  390031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  390042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390049 */     // MIs[0] op1
     /*  390049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390057 */     // MIs[0] op2
     /*  390057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390065 */     // MIs[0] op3
     /*  390065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390085 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390087 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390089 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390099 */     GIR_RootConstrainSelectedInstOperands,
     /*  390100 */     // GIR_Coverage, 63532,
     /*  390100 */     GIR_EraseRootFromParent_Done,
     /*  390101 */   // Label 7014: @390101
     /*  390101 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(390176), // Rule ID 63587 //
     /*  390106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390124 */     // MIs[0] op1
     /*  390124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390132 */     // MIs[0] op2
     /*  390132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390140 */     // MIs[0] op3
     /*  390140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390155 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390160 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390162 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390164 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390174 */     GIR_RootConstrainSelectedInstOperands,
     /*  390175 */     // GIR_Coverage, 63587,
     /*  390175 */     GIR_EraseRootFromParent_Done,
     /*  390176 */   // Label 7015: @390176
     /*  390176 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(390251), // Rule ID 63588 //
     /*  390181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  390192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390199 */     // MIs[0] op1
     /*  390199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390207 */     // MIs[0] op2
     /*  390207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390215 */     // MIs[0] op3
     /*  390215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390249 */     GIR_RootConstrainSelectedInstOperands,
     /*  390250 */     // GIR_Coverage, 63588,
     /*  390250 */     GIR_EraseRootFromParent_Done,
     /*  390251 */   // Label 7016: @390251
     /*  390251 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(390326), // Rule ID 63643 //
     /*  390256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390274 */     // MIs[0] op1
     /*  390274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390282 */     // MIs[0] op2
     /*  390282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390290 */     // MIs[0] op3
     /*  390290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390324 */     GIR_RootConstrainSelectedInstOperands,
     /*  390325 */     // GIR_Coverage, 63643,
     /*  390325 */     GIR_EraseRootFromParent_Done,
     /*  390326 */   // Label 7017: @390326
     /*  390326 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(390401), // Rule ID 63644 //
     /*  390331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  390342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390349 */     // MIs[0] op1
     /*  390349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390357 */     // MIs[0] op2
     /*  390357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390365 */     // MIs[0] op3
     /*  390365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390385 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390387 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390389 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390399 */     GIR_RootConstrainSelectedInstOperands,
     /*  390400 */     // GIR_Coverage, 63644,
     /*  390400 */     GIR_EraseRootFromParent_Done,
     /*  390401 */   // Label 7018: @390401
     /*  390401 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(390476), // Rule ID 63699 //
     /*  390406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390424 */     // MIs[0] op1
     /*  390424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390432 */     // MIs[0] op2
     /*  390432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390440 */     // MIs[0] op3
     /*  390440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390455 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390474 */     GIR_RootConstrainSelectedInstOperands,
     /*  390475 */     // GIR_Coverage, 63699,
     /*  390475 */     GIR_EraseRootFromParent_Done,
     /*  390476 */   // Label 7019: @390476
     /*  390476 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(390551), // Rule ID 63700 //
     /*  390481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390499 */     // MIs[0] op1
     /*  390499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390507 */     // MIs[0] op2
     /*  390507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390515 */     // MIs[0] op3
     /*  390515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390535 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390537 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390539 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390549 */     GIR_RootConstrainSelectedInstOperands,
     /*  390550 */     // GIR_Coverage, 63700,
     /*  390550 */     GIR_EraseRootFromParent_Done,
     /*  390551 */   // Label 7020: @390551
     /*  390551 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(390626), // Rule ID 63755 //
     /*  390556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390574 */     // MIs[0] op1
     /*  390574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390582 */     // MIs[0] op2
     /*  390582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390590 */     // MIs[0] op3
     /*  390590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390605 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390624 */     GIR_RootConstrainSelectedInstOperands,
     /*  390625 */     // GIR_Coverage, 63755,
     /*  390625 */     GIR_EraseRootFromParent_Done,
     /*  390626 */   // Label 7021: @390626
     /*  390626 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(390701), // Rule ID 63756 //
     /*  390631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390649 */     // MIs[0] op1
     /*  390649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390657 */     // MIs[0] op2
     /*  390657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390665 */     // MIs[0] op3
     /*  390665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  390683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390685 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390687 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390689 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390699 */     GIR_RootConstrainSelectedInstOperands,
     /*  390700 */     // GIR_Coverage, 63756,
     /*  390700 */     GIR_EraseRootFromParent_Done,
     /*  390701 */   // Label 7022: @390701
     /*  390701 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(390776), // Rule ID 63811 //
     /*  390706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390724 */     // MIs[0] op1
     /*  390724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390732 */     // MIs[0] op2
     /*  390732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390740 */     // MIs[0] op3
     /*  390740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390774 */     GIR_RootConstrainSelectedInstOperands,
     /*  390775 */     // GIR_Coverage, 63811,
     /*  390775 */     GIR_EraseRootFromParent_Done,
     /*  390776 */   // Label 7023: @390776
     /*  390776 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(390851), // Rule ID 63812 //
     /*  390781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390799 */     // MIs[0] op1
     /*  390799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390807 */     // MIs[0] op2
     /*  390807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390815 */     // MIs[0] op3
     /*  390815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M2),
     /*  390833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390835 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390837 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390839 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390849 */     GIR_RootConstrainSelectedInstOperands,
     /*  390850 */     // GIR_Coverage, 63812,
     /*  390850 */     GIR_EraseRootFromParent_Done,
     /*  390851 */   // Label 7024: @390851
     /*  390851 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(390926), // Rule ID 63867 //
     /*  390856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390874 */     // MIs[0] op1
     /*  390874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390882 */     // MIs[0] op2
     /*  390882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390890 */     // MIs[0] op3
     /*  390890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390905 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390910 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390912 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390914 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390924 */     GIR_RootConstrainSelectedInstOperands,
     /*  390925 */     // GIR_Coverage, 63867,
     /*  390925 */     GIR_EraseRootFromParent_Done,
     /*  390926 */   // Label 7025: @390926
     /*  390926 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(391001), // Rule ID 63868 //
     /*  390931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390949 */     // MIs[0] op1
     /*  390949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390957 */     // MIs[0] op2
     /*  390957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390965 */     // MIs[0] op3
     /*  390965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M4),
     /*  390983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390985 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390987 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390989 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390999 */     GIR_RootConstrainSelectedInstOperands,
     /*  391000 */     // GIR_Coverage, 63868,
     /*  391000 */     GIR_EraseRootFromParent_Done,
     /*  391001 */   // Label 7026: @391001
     /*  391001 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(391076), // Rule ID 63923 //
     /*  391006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391024 */     // MIs[0] op1
     /*  391024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391032 */     // MIs[0] op2
     /*  391032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391040 */     // MIs[0] op3
     /*  391040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391055 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  391055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  391058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391074 */     GIR_RootConstrainSelectedInstOperands,
     /*  391075 */     // GIR_Coverage, 63923,
     /*  391075 */     GIR_EraseRootFromParent_Done,
     /*  391076 */   // Label 7027: @391076
     /*  391076 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(391151), // Rule ID 63924 //
     /*  391081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  391092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391099 */     // MIs[0] op1
     /*  391099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391107 */     // MIs[0] op2
     /*  391107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391115 */     // MIs[0] op3
     /*  391115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  391130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_I_M8),
     /*  391133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391135 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391137 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391139 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391149 */     GIR_RootConstrainSelectedInstOperands,
     /*  391150 */     // GIR_Coverage, 63924,
     /*  391150 */     GIR_EraseRootFromParent_Done,
     /*  391151 */   // Label 7028: @391151
     /*  391151 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(391225), // Rule ID 62825 //
     /*  391156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391177 */     // MIs[0] op1
     /*  391177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391185 */     // MIs[0] op2
     /*  391185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391204 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  391207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391209 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391211 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391213 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391223 */     GIR_RootConstrainSelectedInstOperands,
     /*  391224 */     // GIR_Coverage, 62825,
     /*  391224 */     GIR_EraseRootFromParent_Done,
     /*  391225 */   // Label 7029: @391225
     /*  391225 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(391299), // Rule ID 62826 //
     /*  391230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391251 */     // MIs[0] op1
     /*  391251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391259 */     // MIs[0] op2
     /*  391259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391278 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF8),
     /*  391281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391283 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391285 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391287 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391297 */     GIR_RootConstrainSelectedInstOperands,
     /*  391298 */     // GIR_Coverage, 62826,
     /*  391298 */     GIR_EraseRootFromParent_Done,
     /*  391299 */   // Label 7030: @391299
     /*  391299 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(391373), // Rule ID 62871 //
     /*  391304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391325 */     // MIs[0] op1
     /*  391325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391333 */     // MIs[0] op2
     /*  391333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391352 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391357 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391359 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391361 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391371 */     GIR_RootConstrainSelectedInstOperands,
     /*  391372 */     // GIR_Coverage, 62871,
     /*  391372 */     GIR_EraseRootFromParent_Done,
     /*  391373 */   // Label 7031: @391373
     /*  391373 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(391447), // Rule ID 62872 //
     /*  391378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391399 */     // MIs[0] op1
     /*  391399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391407 */     // MIs[0] op2
     /*  391407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391431 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391433 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391435 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391445 */     GIR_RootConstrainSelectedInstOperands,
     /*  391446 */     // GIR_Coverage, 62872,
     /*  391446 */     GIR_EraseRootFromParent_Done,
     /*  391447 */   // Label 7032: @391447
     /*  391447 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(391521), // Rule ID 62915 //
     /*  391452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391473 */     // MIs[0] op1
     /*  391473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391481 */     // MIs[0] op2
     /*  391481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391505 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391507 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391509 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391519 */     GIR_RootConstrainSelectedInstOperands,
     /*  391520 */     // GIR_Coverage, 62915,
     /*  391520 */     GIR_EraseRootFromParent_Done,
     /*  391521 */   // Label 7033: @391521
     /*  391521 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(391595), // Rule ID 62916 //
     /*  391526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391547 */     // MIs[0] op1
     /*  391547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391555 */     // MIs[0] op2
     /*  391555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391579 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391581 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391583 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391593 */     GIR_RootConstrainSelectedInstOperands,
     /*  391594 */     // GIR_Coverage, 62916,
     /*  391594 */     GIR_EraseRootFromParent_Done,
     /*  391595 */   // Label 7034: @391595
     /*  391595 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(391669), // Rule ID 62959 //
     /*  391600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391621 */     // MIs[0] op1
     /*  391621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391629 */     // MIs[0] op2
     /*  391629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391653 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391655 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391657 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391667 */     GIR_RootConstrainSelectedInstOperands,
     /*  391668 */     // GIR_Coverage, 62959,
     /*  391668 */     GIR_EraseRootFromParent_Done,
     /*  391669 */   // Label 7035: @391669
     /*  391669 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(391743), // Rule ID 62960 //
     /*  391674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391695 */     // MIs[0] op1
     /*  391695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391703 */     // MIs[0] op2
     /*  391703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391722 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF4),
     /*  391725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391741 */     GIR_RootConstrainSelectedInstOperands,
     /*  391742 */     // GIR_Coverage, 62960,
     /*  391742 */     GIR_EraseRootFromParent_Done,
     /*  391743 */   // Label 7036: @391743
     /*  391743 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(391817), // Rule ID 63015 //
     /*  391748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391769 */     // MIs[0] op1
     /*  391769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391777 */     // MIs[0] op2
     /*  391777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391801 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391803 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391805 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391815 */     GIR_RootConstrainSelectedInstOperands,
     /*  391816 */     // GIR_Coverage, 63015,
     /*  391816 */     GIR_EraseRootFromParent_Done,
     /*  391817 */   // Label 7037: @391817
     /*  391817 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(391891), // Rule ID 63016 //
     /*  391822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391843 */     // MIs[0] op1
     /*  391843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391851 */     // MIs[0] op2
     /*  391851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391875 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391877 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391879 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391889 */     GIR_RootConstrainSelectedInstOperands,
     /*  391890 */     // GIR_Coverage, 63016,
     /*  391890 */     GIR_EraseRootFromParent_Done,
     /*  391891 */   // Label 7038: @391891
     /*  391891 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(391965), // Rule ID 63071 //
     /*  391896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391917 */     // MIs[0] op1
     /*  391917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391925 */     // MIs[0] op2
     /*  391925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  391947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391949 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391951 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391953 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391963 */     GIR_RootConstrainSelectedInstOperands,
     /*  391964 */     // GIR_Coverage, 63071,
     /*  391964 */     GIR_EraseRootFromParent_Done,
     /*  391965 */   // Label 7039: @391965
     /*  391965 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(392039), // Rule ID 63072 //
     /*  391970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391991 */     // MIs[0] op1
     /*  391991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391999 */     // MIs[0] op2
     /*  391999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_MF2),
     /*  392021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392023 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392025 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392027 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392037 */     GIR_RootConstrainSelectedInstOperands,
     /*  392038 */     // GIR_Coverage, 63072,
     /*  392038 */     GIR_EraseRootFromParent_Done,
     /*  392039 */   // Label 7040: @392039
     /*  392039 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(392113), // Rule ID 63127 //
     /*  392044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392065 */     // MIs[0] op1
     /*  392065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392073 */     // MIs[0] op2
     /*  392073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392097 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392099 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392101 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392111 */     GIR_RootConstrainSelectedInstOperands,
     /*  392112 */     // GIR_Coverage, 63127,
     /*  392112 */     GIR_EraseRootFromParent_Done,
     /*  392113 */   // Label 7041: @392113
     /*  392113 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(392187), // Rule ID 63128 //
     /*  392118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392139 */     // MIs[0] op1
     /*  392139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392147 */     // MIs[0] op2
     /*  392147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392171 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392173 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392175 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392185 */     GIR_RootConstrainSelectedInstOperands,
     /*  392186 */     // GIR_Coverage, 63128,
     /*  392186 */     GIR_EraseRootFromParent_Done,
     /*  392187 */   // Label 7042: @392187
     /*  392187 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(392261), // Rule ID 63171 //
     /*  392192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392213 */     // MIs[0] op1
     /*  392213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392221 */     // MIs[0] op2
     /*  392221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392245 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392247 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392249 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392259 */     GIR_RootConstrainSelectedInstOperands,
     /*  392260 */     // GIR_Coverage, 63171,
     /*  392260 */     GIR_EraseRootFromParent_Done,
     /*  392261 */   // Label 7043: @392261
     /*  392261 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(392335), // Rule ID 63172 //
     /*  392266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392287 */     // MIs[0] op1
     /*  392287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392295 */     // MIs[0] op2
     /*  392295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392319 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392321 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392323 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392333 */     GIR_RootConstrainSelectedInstOperands,
     /*  392334 */     // GIR_Coverage, 63172,
     /*  392334 */     GIR_EraseRootFromParent_Done,
     /*  392335 */   // Label 7044: @392335
     /*  392335 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(392409), // Rule ID 63227 //
     /*  392340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392361 */     // MIs[0] op1
     /*  392361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392369 */     // MIs[0] op2
     /*  392369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392393 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392395 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392397 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392407 */     GIR_RootConstrainSelectedInstOperands,
     /*  392408 */     // GIR_Coverage, 63227,
     /*  392408 */     GIR_EraseRootFromParent_Done,
     /*  392409 */   // Label 7045: @392409
     /*  392409 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(392483), // Rule ID 63228 //
     /*  392414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392435 */     // MIs[0] op1
     /*  392435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392443 */     // MIs[0] op2
     /*  392443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392467 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392469 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392471 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392481 */     GIR_RootConstrainSelectedInstOperands,
     /*  392482 */     // GIR_Coverage, 63228,
     /*  392482 */     GIR_EraseRootFromParent_Done,
     /*  392483 */   // Label 7046: @392483
     /*  392483 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(392557), // Rule ID 63283 //
     /*  392488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392509 */     // MIs[0] op1
     /*  392509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392517 */     // MIs[0] op2
     /*  392517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392541 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392543 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392545 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392555 */     GIR_RootConstrainSelectedInstOperands,
     /*  392556 */     // GIR_Coverage, 63283,
     /*  392556 */     GIR_EraseRootFromParent_Done,
     /*  392557 */   // Label 7047: @392557
     /*  392557 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(392631), // Rule ID 63284 //
     /*  392562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392583 */     // MIs[0] op1
     /*  392583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392591 */     // MIs[0] op2
     /*  392591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M1),
     /*  392613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392615 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392617 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392619 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392629 */     GIR_RootConstrainSelectedInstOperands,
     /*  392630 */     // GIR_Coverage, 63284,
     /*  392630 */     GIR_EraseRootFromParent_Done,
     /*  392631 */   // Label 7048: @392631
     /*  392631 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(392705), // Rule ID 63339 //
     /*  392636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392657 */     // MIs[0] op1
     /*  392657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392665 */     // MIs[0] op2
     /*  392665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392689 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392691 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392693 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392703 */     GIR_RootConstrainSelectedInstOperands,
     /*  392704 */     // GIR_Coverage, 63339,
     /*  392704 */     GIR_EraseRootFromParent_Done,
     /*  392705 */   // Label 7049: @392705
     /*  392705 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(392779), // Rule ID 63340 //
     /*  392710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392731 */     // MIs[0] op1
     /*  392731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392739 */     // MIs[0] op2
     /*  392739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  392761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392763 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392765 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392767 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392777 */     GIR_RootConstrainSelectedInstOperands,
     /*  392778 */     // GIR_Coverage, 63340,
     /*  392778 */     GIR_EraseRootFromParent_Done,
     /*  392779 */   // Label 7050: @392779
     /*  392779 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(392853), // Rule ID 63383 //
     /*  392784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392805 */     // MIs[0] op1
     /*  392805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392813 */     // MIs[0] op2
     /*  392813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392832 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392837 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392839 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392841 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392851 */     GIR_RootConstrainSelectedInstOperands,
     /*  392852 */     // GIR_Coverage, 63383,
     /*  392852 */     GIR_EraseRootFromParent_Done,
     /*  392853 */   // Label 7051: @392853
     /*  392853 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(392927), // Rule ID 63384 //
     /*  392858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392879 */     // MIs[0] op1
     /*  392879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392887 */     // MIs[0] op2
     /*  392887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392906 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  392909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392911 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392913 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392915 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392925 */     GIR_RootConstrainSelectedInstOperands,
     /*  392926 */     // GIR_Coverage, 63384,
     /*  392926 */     GIR_EraseRootFromParent_Done,
     /*  392927 */   // Label 7052: @392927
     /*  392927 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(393001), // Rule ID 63427 //
     /*  392932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392953 */     // MIs[0] op1
     /*  392953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392961 */     // MIs[0] op2
     /*  392961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  392983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392985 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392987 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392989 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392999 */     GIR_RootConstrainSelectedInstOperands,
     /*  393000 */     // GIR_Coverage, 63427,
     /*  393000 */     GIR_EraseRootFromParent_Done,
     /*  393001 */   // Label 7053: @393001
     /*  393001 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(393075), // Rule ID 63428 //
     /*  393006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393027 */     // MIs[0] op1
     /*  393027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393035 */     // MIs[0] op2
     /*  393035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393054 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393059 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393061 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393063 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393073 */     GIR_RootConstrainSelectedInstOperands,
     /*  393074 */     // GIR_Coverage, 63428,
     /*  393074 */     GIR_EraseRootFromParent_Done,
     /*  393075 */   // Label 7054: @393075
     /*  393075 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(393149), // Rule ID 63471 //
     /*  393080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393101 */     // MIs[0] op1
     /*  393101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393109 */     // MIs[0] op2
     /*  393109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393133 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393135 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393137 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393147 */     GIR_RootConstrainSelectedInstOperands,
     /*  393148 */     // GIR_Coverage, 63471,
     /*  393148 */     GIR_EraseRootFromParent_Done,
     /*  393149 */   // Label 7055: @393149
     /*  393149 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(393223), // Rule ID 63472 //
     /*  393154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393175 */     // MIs[0] op1
     /*  393175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393183 */     // MIs[0] op2
     /*  393183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393207 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393209 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393211 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393221 */     GIR_RootConstrainSelectedInstOperands,
     /*  393222 */     // GIR_Coverage, 63472,
     /*  393222 */     GIR_EraseRootFromParent_Done,
     /*  393223 */   // Label 7056: @393223
     /*  393223 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(393297), // Rule ID 63527 //
     /*  393228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393249 */     // MIs[0] op1
     /*  393249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393257 */     // MIs[0] op2
     /*  393257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393281 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393283 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393285 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393295 */     GIR_RootConstrainSelectedInstOperands,
     /*  393296 */     // GIR_Coverage, 63527,
     /*  393296 */     GIR_EraseRootFromParent_Done,
     /*  393297 */   // Label 7057: @393297
     /*  393297 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(393371), // Rule ID 63528 //
     /*  393302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393323 */     // MIs[0] op1
     /*  393323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393331 */     // MIs[0] op2
     /*  393331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393355 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393357 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393359 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393369 */     GIR_RootConstrainSelectedInstOperands,
     /*  393370 */     // GIR_Coverage, 63528,
     /*  393370 */     GIR_EraseRootFromParent_Done,
     /*  393371 */   // Label 7058: @393371
     /*  393371 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(393445), // Rule ID 63583 //
     /*  393376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393397 */     // MIs[0] op1
     /*  393397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393405 */     // MIs[0] op2
     /*  393405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393429 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393431 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393433 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393443 */     GIR_RootConstrainSelectedInstOperands,
     /*  393444 */     // GIR_Coverage, 63583,
     /*  393444 */     GIR_EraseRootFromParent_Done,
     /*  393445 */   // Label 7059: @393445
     /*  393445 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(393519), // Rule ID 63584 //
     /*  393450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393471 */     // MIs[0] op1
     /*  393471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393479 */     // MIs[0] op2
     /*  393479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393503 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393505 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393507 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393517 */     GIR_RootConstrainSelectedInstOperands,
     /*  393518 */     // GIR_Coverage, 63584,
     /*  393518 */     GIR_EraseRootFromParent_Done,
     /*  393519 */   // Label 7060: @393519
     /*  393519 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(393593), // Rule ID 63639 //
     /*  393524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393545 */     // MIs[0] op1
     /*  393545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393553 */     // MIs[0] op2
     /*  393553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393577 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393579 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393581 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393591 */     GIR_RootConstrainSelectedInstOperands,
     /*  393592 */     // GIR_Coverage, 63639,
     /*  393592 */     GIR_EraseRootFromParent_Done,
     /*  393593 */   // Label 7061: @393593
     /*  393593 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(393667), // Rule ID 63640 //
     /*  393598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393619 */     // MIs[0] op1
     /*  393619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393627 */     // MIs[0] op2
     /*  393627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  393649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393651 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393653 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393655 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393665 */     GIR_RootConstrainSelectedInstOperands,
     /*  393666 */     // GIR_Coverage, 63640,
     /*  393666 */     GIR_EraseRootFromParent_Done,
     /*  393667 */   // Label 7062: @393667
     /*  393667 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(393741), // Rule ID 63695 //
     /*  393672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393693 */     // MIs[0] op1
     /*  393693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393701 */     // MIs[0] op2
     /*  393701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393720 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393725 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393727 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393729 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393739 */     GIR_RootConstrainSelectedInstOperands,
     /*  393740 */     // GIR_Coverage, 63695,
     /*  393740 */     GIR_EraseRootFromParent_Done,
     /*  393741 */   // Label 7063: @393741
     /*  393741 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(393815), // Rule ID 63696 //
     /*  393746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393767 */     // MIs[0] op1
     /*  393767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393775 */     // MIs[0] op2
     /*  393775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  393797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393799 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393801 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393803 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393813 */     GIR_RootConstrainSelectedInstOperands,
     /*  393814 */     // GIR_Coverage, 63696,
     /*  393814 */     GIR_EraseRootFromParent_Done,
     /*  393815 */   // Label 7064: @393815
     /*  393815 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(393889), // Rule ID 63751 //
     /*  393820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393841 */     // MIs[0] op1
     /*  393841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393849 */     // MIs[0] op2
     /*  393849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393873 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393875 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393877 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393887 */     GIR_RootConstrainSelectedInstOperands,
     /*  393888 */     // GIR_Coverage, 63751,
     /*  393888 */     GIR_EraseRootFromParent_Done,
     /*  393889 */   // Label 7065: @393889
     /*  393889 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(393963), // Rule ID 63752 //
     /*  393894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393915 */     // MIs[0] op1
     /*  393915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393923 */     // MIs[0] op2
     /*  393923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  393945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393947 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393949 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393951 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393961 */     GIR_RootConstrainSelectedInstOperands,
     /*  393962 */     // GIR_Coverage, 63752,
     /*  393962 */     GIR_EraseRootFromParent_Done,
     /*  393963 */   // Label 7066: @393963
     /*  393963 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(394037), // Rule ID 63807 //
     /*  393968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393989 */     // MIs[0] op1
     /*  393989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393997 */     // MIs[0] op2
     /*  393997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394016 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  394019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394021 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394023 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394025 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394035 */     GIR_RootConstrainSelectedInstOperands,
     /*  394036 */     // GIR_Coverage, 63807,
     /*  394036 */     GIR_EraseRootFromParent_Done,
     /*  394037 */   // Label 7067: @394037
     /*  394037 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(394111), // Rule ID 63808 //
     /*  394042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394063 */     // MIs[0] op1
     /*  394063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394071 */     // MIs[0] op2
     /*  394071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M2),
     /*  394093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394095 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394097 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394099 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394109 */     GIR_RootConstrainSelectedInstOperands,
     /*  394110 */     // GIR_Coverage, 63808,
     /*  394110 */     GIR_EraseRootFromParent_Done,
     /*  394111 */   // Label 7068: @394111
     /*  394111 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(394185), // Rule ID 63863 //
     /*  394116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394137 */     // MIs[0] op1
     /*  394137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394145 */     // MIs[0] op2
     /*  394145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  394167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394169 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394171 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394173 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394183 */     GIR_RootConstrainSelectedInstOperands,
     /*  394184 */     // GIR_Coverage, 63863,
     /*  394184 */     GIR_EraseRootFromParent_Done,
     /*  394185 */   // Label 7069: @394185
     /*  394185 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(394259), // Rule ID 63864 //
     /*  394190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394211 */     // MIs[0] op1
     /*  394211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394219 */     // MIs[0] op2
     /*  394219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M4),
     /*  394241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394243 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394245 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394247 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394257 */     GIR_RootConstrainSelectedInstOperands,
     /*  394258 */     // GIR_Coverage, 63864,
     /*  394258 */     GIR_EraseRootFromParent_Done,
     /*  394259 */   // Label 7070: @394259
     /*  394259 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(394333), // Rule ID 63919 //
     /*  394264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394285 */     // MIs[0] op1
     /*  394285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394293 */     // MIs[0] op2
     /*  394293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  394315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394317 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394319 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394321 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394331 */     GIR_RootConstrainSelectedInstOperands,
     /*  394332 */     // GIR_Coverage, 63919,
     /*  394332 */     GIR_EraseRootFromParent_Done,
     /*  394333 */   // Label 7071: @394333
     /*  394333 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(394407), // Rule ID 63920 //
     /*  394338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394359 */     // MIs[0] op1
     /*  394359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394367 */     // MIs[0] op2
     /*  394367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_X_M8),
     /*  394389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394391 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394393 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394395 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394405 */     GIR_RootConstrainSelectedInstOperands,
     /*  394406 */     // GIR_Coverage, 63920,
     /*  394406 */     GIR_EraseRootFromParent_Done,
     /*  394407 */   // Label 7072: @394407
     /*  394407 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(394481), // Rule ID 62849 //
     /*  394412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394433 */     // MIs[0] op1
     /*  394433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394445 */     // MIs[0] op3
     /*  394445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394465 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394467 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394469 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394479 */     GIR_RootConstrainSelectedInstOperands,
     /*  394480 */     // GIR_Coverage, 62849,
     /*  394480 */     GIR_EraseRootFromParent_Done,
     /*  394481 */   // Label 7073: @394481
     /*  394481 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(394555), // Rule ID 62850 //
     /*  394486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394507 */     // MIs[0] op1
     /*  394507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394519 */     // MIs[0] op3
     /*  394519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF8),
     /*  394537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394539 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394541 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394543 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394553 */     GIR_RootConstrainSelectedInstOperands,
     /*  394554 */     // GIR_Coverage, 62850,
     /*  394554 */     GIR_EraseRootFromParent_Done,
     /*  394555 */   // Label 7074: @394555
     /*  394555 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(394629), // Rule ID 62887 //
     /*  394560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394581 */     // MIs[0] op1
     /*  394581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394593 */     // MIs[0] op3
     /*  394593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394608 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394613 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394615 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394617 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394627 */     GIR_RootConstrainSelectedInstOperands,
     /*  394628 */     // GIR_Coverage, 62887,
     /*  394628 */     GIR_EraseRootFromParent_Done,
     /*  394629 */   // Label 7075: @394629
     /*  394629 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(394703), // Rule ID 62888 //
     /*  394634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394655 */     // MIs[0] op1
     /*  394655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394667 */     // MIs[0] op3
     /*  394667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394687 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394689 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394691 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394701 */     GIR_RootConstrainSelectedInstOperands,
     /*  394702 */     // GIR_Coverage, 62888,
     /*  394702 */     GIR_EraseRootFromParent_Done,
     /*  394703 */   // Label 7076: @394703
     /*  394703 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(394777), // Rule ID 62931 //
     /*  394708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394729 */     // MIs[0] op1
     /*  394729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394741 */     // MIs[0] op3
     /*  394741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394756 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394775 */     GIR_RootConstrainSelectedInstOperands,
     /*  394776 */     // GIR_Coverage, 62931,
     /*  394776 */     GIR_EraseRootFromParent_Done,
     /*  394777 */   // Label 7077: @394777
     /*  394777 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(394851), // Rule ID 62932 //
     /*  394782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394803 */     // MIs[0] op1
     /*  394803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394815 */     // MIs[0] op3
     /*  394815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394830 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  394833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394835 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394837 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394839 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394849 */     GIR_RootConstrainSelectedInstOperands,
     /*  394850 */     // GIR_Coverage, 62932,
     /*  394850 */     GIR_EraseRootFromParent_Done,
     /*  394851 */   // Label 7078: @394851
     /*  394851 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(394925), // Rule ID 62975 //
     /*  394856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394877 */     // MIs[0] op1
     /*  394877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394889 */     // MIs[0] op3
     /*  394889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394909 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394911 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394913 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394923 */     GIR_RootConstrainSelectedInstOperands,
     /*  394924 */     // GIR_Coverage, 62975,
     /*  394924 */     GIR_EraseRootFromParent_Done,
     /*  394925 */   // Label 7079: @394925
     /*  394925 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(394999), // Rule ID 62976 //
     /*  394930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394951 */     // MIs[0] op1
     /*  394951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394963 */     // MIs[0] op3
     /*  394963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF4),
     /*  394981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394983 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394985 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394987 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394997 */     GIR_RootConstrainSelectedInstOperands,
     /*  394998 */     // GIR_Coverage, 62976,
     /*  394998 */     GIR_EraseRootFromParent_Done,
     /*  394999 */   // Label 7080: @394999
     /*  394999 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(395073), // Rule ID 63031 //
     /*  395004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  395018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395025 */     // MIs[0] op1
     /*  395025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395037 */     // MIs[0] op3
     /*  395037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395057 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395059 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395061 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395071 */     GIR_RootConstrainSelectedInstOperands,
     /*  395072 */     // GIR_Coverage, 63031,
     /*  395072 */     GIR_EraseRootFromParent_Done,
     /*  395073 */   // Label 7081: @395073
     /*  395073 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(395147), // Rule ID 63032 //
     /*  395078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  395092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395099 */     // MIs[0] op1
     /*  395099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395111 */     // MIs[0] op3
     /*  395111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395131 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395133 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395135 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395145 */     GIR_RootConstrainSelectedInstOperands,
     /*  395146 */     // GIR_Coverage, 63032,
     /*  395146 */     GIR_EraseRootFromParent_Done,
     /*  395147 */   // Label 7082: @395147
     /*  395147 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(395221), // Rule ID 63087 //
     /*  395152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395173 */     // MIs[0] op1
     /*  395173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395185 */     // MIs[0] op3
     /*  395185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395200 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395205 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395207 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395209 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395219 */     GIR_RootConstrainSelectedInstOperands,
     /*  395220 */     // GIR_Coverage, 63087,
     /*  395220 */     GIR_EraseRootFromParent_Done,
     /*  395221 */   // Label 7083: @395221
     /*  395221 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(395295), // Rule ID 63088 //
     /*  395226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  395240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395247 */     // MIs[0] op1
     /*  395247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395259 */     // MIs[0] op3
     /*  395259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_MF2),
     /*  395277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395279 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395281 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395283 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395293 */     GIR_RootConstrainSelectedInstOperands,
     /*  395294 */     // GIR_Coverage, 63088,
     /*  395294 */     GIR_EraseRootFromParent_Done,
     /*  395295 */   // Label 7084: @395295
     /*  395295 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(395369), // Rule ID 63143 //
     /*  395300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  395314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395321 */     // MIs[0] op1
     /*  395321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395333 */     // MIs[0] op3
     /*  395333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395353 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395355 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395357 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395367 */     GIR_RootConstrainSelectedInstOperands,
     /*  395368 */     // GIR_Coverage, 63143,
     /*  395368 */     GIR_EraseRootFromParent_Done,
     /*  395369 */   // Label 7085: @395369
     /*  395369 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(395443), // Rule ID 63144 //
     /*  395374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  395388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395395 */     // MIs[0] op1
     /*  395395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395407 */     // MIs[0] op3
     /*  395407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395427 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395429 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395431 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395441 */     GIR_RootConstrainSelectedInstOperands,
     /*  395442 */     // GIR_Coverage, 63144,
     /*  395442 */     GIR_EraseRootFromParent_Done,
     /*  395443 */   // Label 7086: @395443
     /*  395443 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(395517), // Rule ID 63187 //
     /*  395448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395469 */     // MIs[0] op1
     /*  395469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395481 */     // MIs[0] op3
     /*  395481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395501 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395503 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395505 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395515 */     GIR_RootConstrainSelectedInstOperands,
     /*  395516 */     // GIR_Coverage, 63187,
     /*  395516 */     GIR_EraseRootFromParent_Done,
     /*  395517 */   // Label 7087: @395517
     /*  395517 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(395591), // Rule ID 63188 //
     /*  395522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395543 */     // MIs[0] op1
     /*  395543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395555 */     // MIs[0] op3
     /*  395555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395575 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395577 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395579 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395589 */     GIR_RootConstrainSelectedInstOperands,
     /*  395590 */     // GIR_Coverage, 63188,
     /*  395590 */     GIR_EraseRootFromParent_Done,
     /*  395591 */   // Label 7088: @395591
     /*  395591 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(395665), // Rule ID 63243 //
     /*  395596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395617 */     // MIs[0] op1
     /*  395617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395629 */     // MIs[0] op3
     /*  395629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395649 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395651 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395653 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395663 */     GIR_RootConstrainSelectedInstOperands,
     /*  395664 */     // GIR_Coverage, 63243,
     /*  395664 */     GIR_EraseRootFromParent_Done,
     /*  395665 */   // Label 7089: @395665
     /*  395665 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(395739), // Rule ID 63244 //
     /*  395670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395691 */     // MIs[0] op1
     /*  395691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395703 */     // MIs[0] op3
     /*  395703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395723 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395725 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395727 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395737 */     GIR_RootConstrainSelectedInstOperands,
     /*  395738 */     // GIR_Coverage, 63244,
     /*  395738 */     GIR_EraseRootFromParent_Done,
     /*  395739 */   // Label 7090: @395739
     /*  395739 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(395813), // Rule ID 63299 //
     /*  395744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395765 */     // MIs[0] op1
     /*  395765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395777 */     // MIs[0] op3
     /*  395777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395797 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395799 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395801 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395811 */     GIR_RootConstrainSelectedInstOperands,
     /*  395812 */     // GIR_Coverage, 63299,
     /*  395812 */     GIR_EraseRootFromParent_Done,
     /*  395813 */   // Label 7091: @395813
     /*  395813 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(395887), // Rule ID 63300 //
     /*  395818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395839 */     // MIs[0] op1
     /*  395839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395851 */     // MIs[0] op3
     /*  395851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395866 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M1),
     /*  395869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395871 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395873 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395875 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395885 */     GIR_RootConstrainSelectedInstOperands,
     /*  395886 */     // GIR_Coverage, 63300,
     /*  395886 */     GIR_EraseRootFromParent_Done,
     /*  395887 */   // Label 7092: @395887
     /*  395887 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(395961), // Rule ID 63355 //
     /*  395892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395913 */     // MIs[0] op1
     /*  395913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395925 */     // MIs[0] op3
     /*  395925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  395943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395945 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395947 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395949 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395959 */     GIR_RootConstrainSelectedInstOperands,
     /*  395960 */     // GIR_Coverage, 63355,
     /*  395960 */     GIR_EraseRootFromParent_Done,
     /*  395961 */   // Label 7093: @395961
     /*  395961 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(396035), // Rule ID 63356 //
     /*  395966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395987 */     // MIs[0] op1
     /*  395987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395999 */     // MIs[0] op3
     /*  395999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396019 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396021 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396023 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396033 */     GIR_RootConstrainSelectedInstOperands,
     /*  396034 */     // GIR_Coverage, 63356,
     /*  396034 */     GIR_EraseRootFromParent_Done,
     /*  396035 */   // Label 7094: @396035
     /*  396035 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(396109), // Rule ID 63399 //
     /*  396040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  396054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396061 */     // MIs[0] op1
     /*  396061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396073 */     // MIs[0] op3
     /*  396073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396088 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396093 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396095 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396097 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396107 */     GIR_RootConstrainSelectedInstOperands,
     /*  396108 */     // GIR_Coverage, 63399,
     /*  396108 */     GIR_EraseRootFromParent_Done,
     /*  396109 */   // Label 7095: @396109
     /*  396109 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(396183), // Rule ID 63400 //
     /*  396114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  396128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396135 */     // MIs[0] op1
     /*  396135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396147 */     // MIs[0] op3
     /*  396147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396167 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396169 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396171 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396181 */     GIR_RootConstrainSelectedInstOperands,
     /*  396182 */     // GIR_Coverage, 63400,
     /*  396182 */     GIR_EraseRootFromParent_Done,
     /*  396183 */   // Label 7096: @396183
     /*  396183 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(396257), // Rule ID 63443 //
     /*  396188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  396202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396209 */     // MIs[0] op1
     /*  396209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396221 */     // MIs[0] op3
     /*  396221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396236 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396241 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396243 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396245 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396255 */     GIR_RootConstrainSelectedInstOperands,
     /*  396256 */     // GIR_Coverage, 63443,
     /*  396256 */     GIR_EraseRootFromParent_Done,
     /*  396257 */   // Label 7097: @396257
     /*  396257 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(396331), // Rule ID 63444 //
     /*  396262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  396276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396283 */     // MIs[0] op1
     /*  396283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396295 */     // MIs[0] op3
     /*  396295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396310 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396315 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396317 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396319 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396329 */     GIR_RootConstrainSelectedInstOperands,
     /*  396330 */     // GIR_Coverage, 63444,
     /*  396330 */     GIR_EraseRootFromParent_Done,
     /*  396331 */   // Label 7098: @396331
     /*  396331 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(396405), // Rule ID 63487 //
     /*  396336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  396350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396357 */     // MIs[0] op1
     /*  396357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396369 */     // MIs[0] op3
     /*  396369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396389 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396391 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396393 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396403 */     GIR_RootConstrainSelectedInstOperands,
     /*  396404 */     // GIR_Coverage, 63487,
     /*  396404 */     GIR_EraseRootFromParent_Done,
     /*  396405 */   // Label 7099: @396405
     /*  396405 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(396479), // Rule ID 63488 //
     /*  396410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  396424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396431 */     // MIs[0] op1
     /*  396431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396443 */     // MIs[0] op3
     /*  396443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396463 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396465 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396467 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396477 */     GIR_RootConstrainSelectedInstOperands,
     /*  396478 */     // GIR_Coverage, 63488,
     /*  396478 */     GIR_EraseRootFromParent_Done,
     /*  396479 */   // Label 7100: @396479
     /*  396479 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(396553), // Rule ID 63543 //
     /*  396484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396505 */     // MIs[0] op1
     /*  396505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396517 */     // MIs[0] op3
     /*  396517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396537 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396539 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396541 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396551 */     GIR_RootConstrainSelectedInstOperands,
     /*  396552 */     // GIR_Coverage, 63543,
     /*  396552 */     GIR_EraseRootFromParent_Done,
     /*  396553 */   // Label 7101: @396553
     /*  396553 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(396627), // Rule ID 63544 //
     /*  396558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396579 */     // MIs[0] op1
     /*  396579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396591 */     // MIs[0] op3
     /*  396591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396606 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396611 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396613 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396615 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396625 */     GIR_RootConstrainSelectedInstOperands,
     /*  396626 */     // GIR_Coverage, 63544,
     /*  396626 */     GIR_EraseRootFromParent_Done,
     /*  396627 */   // Label 7102: @396627
     /*  396627 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(396701), // Rule ID 63599 //
     /*  396632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396653 */     // MIs[0] op1
     /*  396653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396665 */     // MIs[0] op3
     /*  396665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396680 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396685 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396687 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396689 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396699 */     GIR_RootConstrainSelectedInstOperands,
     /*  396700 */     // GIR_Coverage, 63599,
     /*  396700 */     GIR_EraseRootFromParent_Done,
     /*  396701 */   // Label 7103: @396701
     /*  396701 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(396775), // Rule ID 63600 //
     /*  396706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396727 */     // MIs[0] op1
     /*  396727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396739 */     // MIs[0] op3
     /*  396739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  396757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396759 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396761 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396763 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396773 */     GIR_RootConstrainSelectedInstOperands,
     /*  396774 */     // GIR_Coverage, 63600,
     /*  396774 */     GIR_EraseRootFromParent_Done,
     /*  396775 */   // Label 7104: @396775
     /*  396775 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(396849), // Rule ID 63655 //
     /*  396780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396801 */     // MIs[0] op1
     /*  396801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396813 */     // MIs[0] op3
     /*  396813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396833 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396835 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396837 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396847 */     GIR_RootConstrainSelectedInstOperands,
     /*  396848 */     // GIR_Coverage, 63655,
     /*  396848 */     GIR_EraseRootFromParent_Done,
     /*  396849 */   // Label 7105: @396849
     /*  396849 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(396923), // Rule ID 63656 //
     /*  396854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396875 */     // MIs[0] op1
     /*  396875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396887 */     // MIs[0] op3
     /*  396887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  396905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396907 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396909 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396911 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396921 */     GIR_RootConstrainSelectedInstOperands,
     /*  396922 */     // GIR_Coverage, 63656,
     /*  396922 */     GIR_EraseRootFromParent_Done,
     /*  396923 */   // Label 7106: @396923
     /*  396923 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(396997), // Rule ID 63711 //
     /*  396928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396949 */     // MIs[0] op1
     /*  396949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396961 */     // MIs[0] op3
     /*  396961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  396979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396981 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396983 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396985 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396995 */     GIR_RootConstrainSelectedInstOperands,
     /*  396996 */     // GIR_Coverage, 63711,
     /*  396996 */     GIR_EraseRootFromParent_Done,
     /*  396997 */   // Label 7107: @396997
     /*  396997 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(397071), // Rule ID 63712 //
     /*  397002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  397016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397023 */     // MIs[0] op1
     /*  397023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397035 */     // MIs[0] op3
     /*  397035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397055 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397057 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397059 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397069 */     GIR_RootConstrainSelectedInstOperands,
     /*  397070 */     // GIR_Coverage, 63712,
     /*  397070 */     GIR_EraseRootFromParent_Done,
     /*  397071 */   // Label 7108: @397071
     /*  397071 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(397145), // Rule ID 63767 //
     /*  397076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  397090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397097 */     // MIs[0] op1
     /*  397097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397109 */     // MIs[0] op3
     /*  397109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397129 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397131 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397133 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397143 */     GIR_RootConstrainSelectedInstOperands,
     /*  397144 */     // GIR_Coverage, 63767,
     /*  397144 */     GIR_EraseRootFromParent_Done,
     /*  397145 */   // Label 7109: @397145
     /*  397145 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(397219), // Rule ID 63768 //
     /*  397150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  397164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397171 */     // MIs[0] op1
     /*  397171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397183 */     // MIs[0] op3
     /*  397183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397203 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397205 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397207 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397217 */     GIR_RootConstrainSelectedInstOperands,
     /*  397218 */     // GIR_Coverage, 63768,
     /*  397218 */     GIR_EraseRootFromParent_Done,
     /*  397219 */   // Label 7110: @397219
     /*  397219 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(397293), // Rule ID 63823 //
     /*  397224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  397238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397245 */     // MIs[0] op1
     /*  397245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397257 */     // MIs[0] op3
     /*  397257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  397275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397277 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397279 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397281 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397291 */     GIR_RootConstrainSelectedInstOperands,
     /*  397292 */     // GIR_Coverage, 63823,
     /*  397292 */     GIR_EraseRootFromParent_Done,
     /*  397293 */   // Label 7111: @397293
     /*  397293 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(397367), // Rule ID 63824 //
     /*  397298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  397312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397319 */     // MIs[0] op1
     /*  397319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397331 */     // MIs[0] op3
     /*  397331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M2),
     /*  397349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397351 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397353 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397355 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397365 */     GIR_RootConstrainSelectedInstOperands,
     /*  397366 */     // GIR_Coverage, 63824,
     /*  397366 */     GIR_EraseRootFromParent_Done,
     /*  397367 */   // Label 7112: @397367
     /*  397367 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(397441), // Rule ID 63879 //
     /*  397372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  397386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397393 */     // MIs[0] op1
     /*  397393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397405 */     // MIs[0] op3
     /*  397405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397425 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397427 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397429 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397439 */     GIR_RootConstrainSelectedInstOperands,
     /*  397440 */     // GIR_Coverage, 63879,
     /*  397440 */     GIR_EraseRootFromParent_Done,
     /*  397441 */   // Label 7113: @397441
     /*  397441 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(397515), // Rule ID 63880 //
     /*  397446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  397460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397467 */     // MIs[0] op1
     /*  397467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397479 */     // MIs[0] op3
     /*  397479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397494 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M4),
     /*  397497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397499 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397501 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397503 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397513 */     GIR_RootConstrainSelectedInstOperands,
     /*  397514 */     // GIR_Coverage, 63880,
     /*  397514 */     GIR_EraseRootFromParent_Done,
     /*  397515 */   // Label 7114: @397515
     /*  397515 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(397589), // Rule ID 63935 //
     /*  397520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397541 */     // MIs[0] op1
     /*  397541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397553 */     // MIs[0] op3
     /*  397553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397573 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397575 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397577 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397587 */     GIR_RootConstrainSelectedInstOperands,
     /*  397588 */     // GIR_Coverage, 63935,
     /*  397588 */     GIR_EraseRootFromParent_Done,
     /*  397589 */   // Label 7115: @397589
     /*  397589 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(397663), // Rule ID 63936 //
     /*  397594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397615 */     // MIs[0] op1
     /*  397615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397627 */     // MIs[0] op3
     /*  397627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IV_M8),
     /*  397645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397647 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397649 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397651 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397661 */     GIR_RootConstrainSelectedInstOperands,
     /*  397662 */     // GIR_Coverage, 63936,
     /*  397662 */     GIR_EraseRootFromParent_Done,
     /*  397663 */   // Label 7116: @397663
     /*  397663 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(397738), // Rule ID 7360 //
     /*  397668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397714 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397736 */     GIR_RootConstrainSelectedInstOperands,
     /*  397737 */     // GIR_Coverage, 7360,
     /*  397737 */     GIR_EraseRootFromParent_Done,
     /*  397738 */   // Label 7117: @397738
     /*  397738 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(397813), // Rule ID 7361 //
     /*  397743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397789 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397811 */     GIR_RootConstrainSelectedInstOperands,
     /*  397812 */     // GIR_Coverage, 7361,
     /*  397812 */     GIR_EraseRootFromParent_Done,
     /*  397813 */   // Label 7118: @397813
     /*  397813 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(397888), // Rule ID 7364 //
     /*  397818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397864 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397886 */     GIR_RootConstrainSelectedInstOperands,
     /*  397887 */     // GIR_Coverage, 7364,
     /*  397887 */     GIR_EraseRootFromParent_Done,
     /*  397888 */   // Label 7119: @397888
     /*  397888 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(397963), // Rule ID 7365 //
     /*  397893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397939 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397961 */     GIR_RootConstrainSelectedInstOperands,
     /*  397962 */     // GIR_Coverage, 7365,
     /*  397962 */     GIR_EraseRootFromParent_Done,
     /*  397963 */   // Label 7120: @397963
     /*  397963 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(398038), // Rule ID 7368 //
     /*  397968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398014 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398036 */     GIR_RootConstrainSelectedInstOperands,
     /*  398037 */     // GIR_Coverage, 7368,
     /*  398037 */     GIR_EraseRootFromParent_Done,
     /*  398038 */   // Label 7121: @398038
     /*  398038 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(398113), // Rule ID 7369 //
     /*  398043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  398057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398089 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398111 */     GIR_RootConstrainSelectedInstOperands,
     /*  398112 */     // GIR_Coverage, 7369,
     /*  398112 */     GIR_EraseRootFromParent_Done,
     /*  398113 */   // Label 7122: @398113
     /*  398113 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(398188), // Rule ID 7372 //
     /*  398118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  398167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398186 */     GIR_RootConstrainSelectedInstOperands,
     /*  398187 */     // GIR_Coverage, 7372,
     /*  398187 */     GIR_EraseRootFromParent_Done,
     /*  398188 */   // Label 7123: @398188
     /*  398188 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(398263), // Rule ID 7373 //
     /*  398193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  398207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  398242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398261 */     GIR_RootConstrainSelectedInstOperands,
     /*  398262 */     // GIR_Coverage, 7373,
     /*  398262 */     GIR_EraseRootFromParent_Done,
     /*  398263 */   // Label 7124: @398263
     /*  398263 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(398338), // Rule ID 7376 //
     /*  398268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  398282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398336 */     GIR_RootConstrainSelectedInstOperands,
     /*  398337 */     // GIR_Coverage, 7376,
     /*  398337 */     GIR_EraseRootFromParent_Done,
     /*  398338 */   // Label 7125: @398338
     /*  398338 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(398413), // Rule ID 7377 //
     /*  398343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  398357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398389 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398411 */     GIR_RootConstrainSelectedInstOperands,
     /*  398412 */     // GIR_Coverage, 7377,
     /*  398412 */     GIR_EraseRootFromParent_Done,
     /*  398413 */   // Label 7126: @398413
     /*  398413 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(398488), // Rule ID 7380 //
     /*  398418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398486 */     GIR_RootConstrainSelectedInstOperands,
     /*  398487 */     // GIR_Coverage, 7380,
     /*  398487 */     GIR_EraseRootFromParent_Done,
     /*  398488 */   // Label 7127: @398488
     /*  398488 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(398563), // Rule ID 7381 //
     /*  398493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398539 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398561 */     GIR_RootConstrainSelectedInstOperands,
     /*  398562 */     // GIR_Coverage, 7381,
     /*  398562 */     GIR_EraseRootFromParent_Done,
     /*  398563 */   // Label 7128: @398563
     /*  398563 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(398638), // Rule ID 7384 //
     /*  398568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398636 */     GIR_RootConstrainSelectedInstOperands,
     /*  398637 */     // GIR_Coverage, 7384,
     /*  398637 */     GIR_EraseRootFromParent_Done,
     /*  398638 */   // Label 7129: @398638
     /*  398638 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(398713), // Rule ID 7385 //
     /*  398643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398689 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398711 */     GIR_RootConstrainSelectedInstOperands,
     /*  398712 */     // GIR_Coverage, 7385,
     /*  398712 */     GIR_EraseRootFromParent_Done,
     /*  398713 */   // Label 7130: @398713
     /*  398713 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(398788), // Rule ID 7388 //
     /*  398718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398786 */     GIR_RootConstrainSelectedInstOperands,
     /*  398787 */     // GIR_Coverage, 7388,
     /*  398787 */     GIR_EraseRootFromParent_Done,
     /*  398788 */   // Label 7131: @398788
     /*  398788 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(398863), // Rule ID 7389 //
     /*  398793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398839 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398861 */     GIR_RootConstrainSelectedInstOperands,
     /*  398862 */     // GIR_Coverage, 7389,
     /*  398862 */     GIR_EraseRootFromParent_Done,
     /*  398863 */   // Label 7132: @398863
     /*  398863 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(398938), // Rule ID 7392 //
     /*  398868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398936 */     GIR_RootConstrainSelectedInstOperands,
     /*  398937 */     // GIR_Coverage, 7392,
     /*  398937 */     GIR_EraseRootFromParent_Done,
     /*  398938 */   // Label 7133: @398938
     /*  398938 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(399013), // Rule ID 7393 //
     /*  398943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399011 */     GIR_RootConstrainSelectedInstOperands,
     /*  399012 */     // GIR_Coverage, 7393,
     /*  399012 */     GIR_EraseRootFromParent_Done,
     /*  399013 */   // Label 7134: @399013
     /*  399013 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(399088), // Rule ID 7396 //
     /*  399018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  399021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  399032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  399064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  399067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399086 */     GIR_RootConstrainSelectedInstOperands,
     /*  399087 */     // GIR_Coverage, 7396,
     /*  399087 */     GIR_EraseRootFromParent_Done,
     /*  399088 */   // Label 7135: @399088
     /*  399088 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(399163), // Rule ID 7397 //
     /*  399093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  399096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  399107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399139 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  399139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  399142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399161 */     GIR_RootConstrainSelectedInstOperands,
     /*  399162 */     // GIR_Coverage, 7397,
     /*  399162 */     GIR_EraseRootFromParent_Done,
     /*  399163 */   // Label 7136: @399163
     /*  399163 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(399238), // Rule ID 7400 //
     /*  399168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  399182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399236 */     GIR_RootConstrainSelectedInstOperands,
     /*  399237 */     // GIR_Coverage, 7400,
     /*  399237 */     GIR_EraseRootFromParent_Done,
     /*  399238 */   // Label 7137: @399238
     /*  399238 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(399313), // Rule ID 7401 //
     /*  399243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  399257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399311 */     GIR_RootConstrainSelectedInstOperands,
     /*  399312 */     // GIR_Coverage, 7401,
     /*  399312 */     GIR_EraseRootFromParent_Done,
     /*  399313 */   // Label 7138: @399313
     /*  399313 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(399388), // Rule ID 7404 //
     /*  399318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  399332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399386 */     GIR_RootConstrainSelectedInstOperands,
     /*  399387 */     // GIR_Coverage, 7404,
     /*  399387 */     GIR_EraseRootFromParent_Done,
     /*  399388 */   // Label 7139: @399388
     /*  399388 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(399463), // Rule ID 7405 //
     /*  399393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  399407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399439 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399461 */     GIR_RootConstrainSelectedInstOperands,
     /*  399462 */     // GIR_Coverage, 7405,
     /*  399462 */     GIR_EraseRootFromParent_Done,
     /*  399463 */   // Label 7140: @399463
     /*  399463 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(399538), // Rule ID 7408 //
     /*  399468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399536 */     GIR_RootConstrainSelectedInstOperands,
     /*  399537 */     // GIR_Coverage, 7408,
     /*  399537 */     GIR_EraseRootFromParent_Done,
     /*  399538 */   // Label 7141: @399538
     /*  399538 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(399613), // Rule ID 7409 //
     /*  399543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399589 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399611 */     GIR_RootConstrainSelectedInstOperands,
     /*  399612 */     // GIR_Coverage, 7409,
     /*  399612 */     GIR_EraseRootFromParent_Done,
     /*  399613 */   // Label 7142: @399613
     /*  399613 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(399688), // Rule ID 7412 //
     /*  399618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399686 */     GIR_RootConstrainSelectedInstOperands,
     /*  399687 */     // GIR_Coverage, 7412,
     /*  399687 */     GIR_EraseRootFromParent_Done,
     /*  399688 */   // Label 7143: @399688
     /*  399688 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(399763), // Rule ID 7413 //
     /*  399693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399761 */     GIR_RootConstrainSelectedInstOperands,
     /*  399762 */     // GIR_Coverage, 7413,
     /*  399762 */     GIR_EraseRootFromParent_Done,
     /*  399763 */   // Label 7144: @399763
     /*  399763 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(399838), // Rule ID 7416 //
     /*  399768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399836 */     GIR_RootConstrainSelectedInstOperands,
     /*  399837 */     // GIR_Coverage, 7416,
     /*  399837 */     GIR_EraseRootFromParent_Done,
     /*  399838 */   // Label 7145: @399838
     /*  399838 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(399913), // Rule ID 7417 //
     /*  399843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399889 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399911 */     GIR_RootConstrainSelectedInstOperands,
     /*  399912 */     // GIR_Coverage, 7417,
     /*  399912 */     GIR_EraseRootFromParent_Done,
     /*  399913 */   // Label 7146: @399913
     /*  399913 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(399988), // Rule ID 7420 //
     /*  399918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399964 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399986 */     GIR_RootConstrainSelectedInstOperands,
     /*  399987 */     // GIR_Coverage, 7420,
     /*  399987 */     GIR_EraseRootFromParent_Done,
     /*  399988 */   // Label 7147: @399988
     /*  399988 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(400063), // Rule ID 7421 //
     /*  399993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  400007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400061 */     GIR_RootConstrainSelectedInstOperands,
     /*  400062 */     // GIR_Coverage, 7421,
     /*  400062 */     GIR_EraseRootFromParent_Done,
     /*  400063 */   // Label 7148: @400063
     /*  400063 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(400138), // Rule ID 7424 //
     /*  400068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400136 */     GIR_RootConstrainSelectedInstOperands,
     /*  400137 */     // GIR_Coverage, 7424,
     /*  400137 */     GIR_EraseRootFromParent_Done,
     /*  400138 */   // Label 7149: @400138
     /*  400138 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(400213), // Rule ID 7425 //
     /*  400143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  400157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400211 */     GIR_RootConstrainSelectedInstOperands,
     /*  400212 */     // GIR_Coverage, 7425,
     /*  400212 */     GIR_EraseRootFromParent_Done,
     /*  400213 */   // Label 7150: @400213
     /*  400213 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(400288), // Rule ID 7428 //
     /*  400218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400286 */     GIR_RootConstrainSelectedInstOperands,
     /*  400287 */     // GIR_Coverage, 7428,
     /*  400287 */     GIR_EraseRootFromParent_Done,
     /*  400288 */   // Label 7151: @400288
     /*  400288 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(400363), // Rule ID 7429 //
     /*  400293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  400307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400339 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400361 */     GIR_RootConstrainSelectedInstOperands,
     /*  400362 */     // GIR_Coverage, 7429,
     /*  400362 */     GIR_EraseRootFromParent_Done,
     /*  400363 */   // Label 7152: @400363
     /*  400363 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(400438), // Rule ID 7432 //
     /*  400368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  400371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400436 */     GIR_RootConstrainSelectedInstOperands,
     /*  400437 */     // GIR_Coverage, 7432,
     /*  400437 */     GIR_EraseRootFromParent_Done,
     /*  400438 */   // Label 7153: @400438
     /*  400438 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(400513), // Rule ID 7433 //
     /*  400443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  400446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  400457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400489 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400511 */     GIR_RootConstrainSelectedInstOperands,
     /*  400512 */     // GIR_Coverage, 7433,
     /*  400512 */     GIR_EraseRootFromParent_Done,
     /*  400513 */   // Label 7154: @400513
     /*  400513 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(400588), // Rule ID 7436 //
     /*  400518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400586 */     GIR_RootConstrainSelectedInstOperands,
     /*  400587 */     // GIR_Coverage, 7436,
     /*  400587 */     GIR_EraseRootFromParent_Done,
     /*  400588 */   // Label 7155: @400588
     /*  400588 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(400663), // Rule ID 7437 //
     /*  400593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400661 */     GIR_RootConstrainSelectedInstOperands,
     /*  400662 */     // GIR_Coverage, 7437,
     /*  400662 */     GIR_EraseRootFromParent_Done,
     /*  400663 */   // Label 7156: @400663
     /*  400663 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(400738), // Rule ID 7440 //
     /*  400668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400736 */     GIR_RootConstrainSelectedInstOperands,
     /*  400737 */     // GIR_Coverage, 7440,
     /*  400737 */     GIR_EraseRootFromParent_Done,
     /*  400738 */   // Label 7157: @400738
     /*  400738 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(400813), // Rule ID 7441 //
     /*  400743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400789 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400811 */     GIR_RootConstrainSelectedInstOperands,
     /*  400812 */     // GIR_Coverage, 7441,
     /*  400812 */     GIR_EraseRootFromParent_Done,
     /*  400813 */   // Label 7158: @400813
     /*  400813 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(400888), // Rule ID 7444 //
     /*  400818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400864 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400886 */     GIR_RootConstrainSelectedInstOperands,
     /*  400887 */     // GIR_Coverage, 7444,
     /*  400887 */     GIR_EraseRootFromParent_Done,
     /*  400888 */   // Label 7159: @400888
     /*  400888 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(400963), // Rule ID 7445 //
     /*  400893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400961 */     GIR_RootConstrainSelectedInstOperands,
     /*  400962 */     // GIR_Coverage, 7445,
     /*  400962 */     GIR_EraseRootFromParent_Done,
     /*  400963 */   // Label 7160: @400963
     /*  400963 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(401040), // Rule ID 2750 //
     /*  400968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401000 */     // MIs[0] Operand 4
     /*  401000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  401021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401038 */     GIR_RootConstrainSelectedInstOperands,
     /*  401039 */     // GIR_Coverage, 2750,
     /*  401039 */     GIR_EraseRootFromParent_Done,
     /*  401040 */   // Label 7161: @401040
     /*  401040 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(401117), // Rule ID 2751 //
     /*  401045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401077 */     // MIs[0] Operand 4
     /*  401077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401095 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  401098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401115 */     GIR_RootConstrainSelectedInstOperands,
     /*  401116 */     // GIR_Coverage, 2751,
     /*  401116 */     GIR_EraseRootFromParent_Done,
     /*  401117 */   // Label 7162: @401117
     /*  401117 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(401194), // Rule ID 20642 //
     /*  401122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401154 */     // MIs[0] Operand 4
     /*  401154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401192 */     GIR_RootConstrainSelectedInstOperands,
     /*  401193 */     // GIR_Coverage, 20642,
     /*  401193 */     GIR_EraseRootFromParent_Done,
     /*  401194 */   // Label 7163: @401194
     /*  401194 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(401271), // Rule ID 20643 //
     /*  401199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401231 */     // MIs[0] Operand 4
     /*  401231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401269 */     GIR_RootConstrainSelectedInstOperands,
     /*  401270 */     // GIR_Coverage, 20643,
     /*  401270 */     GIR_EraseRootFromParent_Done,
     /*  401271 */   // Label 7164: @401271
     /*  401271 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(401348), // Rule ID 20646 //
     /*  401276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401308 */     // MIs[0] Operand 4
     /*  401308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401346 */     GIR_RootConstrainSelectedInstOperands,
     /*  401347 */     // GIR_Coverage, 20646,
     /*  401347 */     GIR_EraseRootFromParent_Done,
     /*  401348 */   // Label 7165: @401348
     /*  401348 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(401425), // Rule ID 20647 //
     /*  401353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401385 */     // MIs[0] Operand 4
     /*  401385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401403 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  401406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401423 */     GIR_RootConstrainSelectedInstOperands,
     /*  401424 */     // GIR_Coverage, 20647,
     /*  401424 */     GIR_EraseRootFromParent_Done,
     /*  401425 */   // Label 7166: @401425
     /*  401425 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(401502), // Rule ID 20650 //
     /*  401430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401462 */     // MIs[0] Operand 4
     /*  401462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401500 */     GIR_RootConstrainSelectedInstOperands,
     /*  401501 */     // GIR_Coverage, 20650,
     /*  401501 */     GIR_EraseRootFromParent_Done,
     /*  401502 */   // Label 7167: @401502
     /*  401502 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(401579), // Rule ID 20651 //
     /*  401507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401539 */     // MIs[0] Operand 4
     /*  401539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401557 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401577 */     GIR_RootConstrainSelectedInstOperands,
     /*  401578 */     // GIR_Coverage, 20651,
     /*  401578 */     GIR_EraseRootFromParent_Done,
     /*  401579 */   // Label 7168: @401579
     /*  401579 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(401656), // Rule ID 20654 //
     /*  401584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401616 */     // MIs[0] Operand 4
     /*  401616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401654 */     GIR_RootConstrainSelectedInstOperands,
     /*  401655 */     // GIR_Coverage, 20654,
     /*  401655 */     GIR_EraseRootFromParent_Done,
     /*  401656 */   // Label 7169: @401656
     /*  401656 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(401733), // Rule ID 20655 //
     /*  401661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401693 */     // MIs[0] Operand 4
     /*  401693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401731 */     GIR_RootConstrainSelectedInstOperands,
     /*  401732 */     // GIR_Coverage, 20655,
     /*  401732 */     GIR_EraseRootFromParent_Done,
     /*  401733 */   // Label 7170: @401733
     /*  401733 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(401810), // Rule ID 20658 //
     /*  401738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401770 */     // MIs[0] Operand 4
     /*  401770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  401788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401808 */     GIR_RootConstrainSelectedInstOperands,
     /*  401809 */     // GIR_Coverage, 20658,
     /*  401809 */     GIR_EraseRootFromParent_Done,
     /*  401810 */   // Label 7171: @401810
     /*  401810 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(401887), // Rule ID 20659 //
     /*  401815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  401818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401847 */     // MIs[0] Operand 4
     /*  401847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  401865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401885 */     GIR_RootConstrainSelectedInstOperands,
     /*  401886 */     // GIR_Coverage, 20659,
     /*  401886 */     GIR_EraseRootFromParent_Done,
     /*  401887 */   // Label 7172: @401887
     /*  401887 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(401964), // Rule ID 20662 //
     /*  401892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401924 */     // MIs[0] Operand 4
     /*  401924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401962 */     GIR_RootConstrainSelectedInstOperands,
     /*  401963 */     // GIR_Coverage, 20662,
     /*  401963 */     GIR_EraseRootFromParent_Done,
     /*  401964 */   // Label 7173: @401964
     /*  401964 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(402041), // Rule ID 20663 //
     /*  401969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402001 */     // MIs[0] Operand 4
     /*  402001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402039 */     GIR_RootConstrainSelectedInstOperands,
     /*  402040 */     // GIR_Coverage, 20663,
     /*  402040 */     GIR_EraseRootFromParent_Done,
     /*  402041 */   // Label 7174: @402041
     /*  402041 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(402118), // Rule ID 20666 //
     /*  402046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  402057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  402060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  402063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402078 */     // MIs[0] Operand 4
     /*  402078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402116 */     GIR_RootConstrainSelectedInstOperands,
     /*  402117 */     // GIR_Coverage, 20666,
     /*  402117 */     GIR_EraseRootFromParent_Done,
     /*  402118 */   // Label 7175: @402118
     /*  402118 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(402195), // Rule ID 20667 //
     /*  402123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  402134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  402137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  402140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402155 */     // MIs[0] Operand 4
     /*  402155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402173 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402193 */     GIR_RootConstrainSelectedInstOperands,
     /*  402194 */     // GIR_Coverage, 20667,
     /*  402194 */     GIR_EraseRootFromParent_Done,
     /*  402195 */   // Label 7176: @402195
     /*  402195 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(402272), // Rule ID 20670 //
     /*  402200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  402211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  402214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  402217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402232 */     // MIs[0] Operand 4
     /*  402232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402270 */     GIR_RootConstrainSelectedInstOperands,
     /*  402271 */     // GIR_Coverage, 20670,
     /*  402271 */     GIR_EraseRootFromParent_Done,
     /*  402272 */   // Label 7177: @402272
     /*  402272 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(402349), // Rule ID 20671 //
     /*  402277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  402288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  402291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  402294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402309 */     // MIs[0] Operand 4
     /*  402309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402327 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402347 */     GIR_RootConstrainSelectedInstOperands,
     /*  402348 */     // GIR_Coverage, 20671,
     /*  402348 */     GIR_EraseRootFromParent_Done,
     /*  402349 */   // Label 7178: @402349
     /*  402349 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(402426), // Rule ID 20674 //
     /*  402354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  402365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  402368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  402371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402386 */     // MIs[0] Operand 4
     /*  402386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402424 */     GIR_RootConstrainSelectedInstOperands,
     /*  402425 */     // GIR_Coverage, 20674,
     /*  402425 */     GIR_EraseRootFromParent_Done,
     /*  402426 */   // Label 7179: @402426
     /*  402426 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(402503), // Rule ID 20675 //
     /*  402431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  402442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  402445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  402448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402463 */     // MIs[0] Operand 4
     /*  402463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402501 */     GIR_RootConstrainSelectedInstOperands,
     /*  402502 */     // GIR_Coverage, 20675,
     /*  402502 */     GIR_EraseRootFromParent_Done,
     /*  402503 */   // Label 7180: @402503
     /*  402503 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(402580), // Rule ID 20678 //
     /*  402508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402540 */     // MIs[0] Operand 4
     /*  402540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402578 */     GIR_RootConstrainSelectedInstOperands,
     /*  402579 */     // GIR_Coverage, 20678,
     /*  402579 */     GIR_EraseRootFromParent_Done,
     /*  402580 */   // Label 7181: @402580
     /*  402580 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(402657), // Rule ID 20679 //
     /*  402585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402617 */     // MIs[0] Operand 4
     /*  402617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402655 */     GIR_RootConstrainSelectedInstOperands,
     /*  402656 */     // GIR_Coverage, 20679,
     /*  402656 */     GIR_EraseRootFromParent_Done,
     /*  402657 */   // Label 7182: @402657
     /*  402657 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(402734), // Rule ID 20682 //
     /*  402662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402694 */     // MIs[0] Operand 4
     /*  402694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402732 */     GIR_RootConstrainSelectedInstOperands,
     /*  402733 */     // GIR_Coverage, 20682,
     /*  402733 */     GIR_EraseRootFromParent_Done,
     /*  402734 */   // Label 7183: @402734
     /*  402734 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(402811), // Rule ID 20683 //
     /*  402739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402771 */     // MIs[0] Operand 4
     /*  402771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402809 */     GIR_RootConstrainSelectedInstOperands,
     /*  402810 */     // GIR_Coverage, 20683,
     /*  402810 */     GIR_EraseRootFromParent_Done,
     /*  402811 */   // Label 7184: @402811
     /*  402811 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(402888), // Rule ID 20686 //
     /*  402816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402848 */     // MIs[0] Operand 4
     /*  402848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402886 */     GIR_RootConstrainSelectedInstOperands,
     /*  402887 */     // GIR_Coverage, 20686,
     /*  402887 */     GIR_EraseRootFromParent_Done,
     /*  402888 */   // Label 7185: @402888
     /*  402888 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(402965), // Rule ID 20687 //
     /*  402893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402925 */     // MIs[0] Operand 4
     /*  402925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402963 */     GIR_RootConstrainSelectedInstOperands,
     /*  402964 */     // GIR_Coverage, 20687,
     /*  402964 */     GIR_EraseRootFromParent_Done,
     /*  402965 */   // Label 7186: @402965
     /*  402965 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(403042), // Rule ID 20690 //
     /*  402970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403002 */     // MIs[0] Operand 4
     /*  403002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  403023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403040 */     GIR_RootConstrainSelectedInstOperands,
     /*  403041 */     // GIR_Coverage, 20690,
     /*  403041 */     GIR_EraseRootFromParent_Done,
     /*  403042 */   // Label 7187: @403042
     /*  403042 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(403119), // Rule ID 20691 //
     /*  403047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  403058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  403061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  403064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403079 */     // MIs[0] Operand 4
     /*  403079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  403100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403117 */     GIR_RootConstrainSelectedInstOperands,
     /*  403118 */     // GIR_Coverage, 20691,
     /*  403118 */     GIR_EraseRootFromParent_Done,
     /*  403119 */   // Label 7188: @403119
     /*  403119 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(403196), // Rule ID 20694 //
     /*  403124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  403127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  403135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  403138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  403141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403156 */     // MIs[0] Operand 4
     /*  403156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  403177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403194 */     GIR_RootConstrainSelectedInstOperands,
     /*  403195 */     // GIR_Coverage, 20694,
     /*  403195 */     GIR_EraseRootFromParent_Done,
     /*  403196 */   // Label 7189: @403196
     /*  403196 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(403273), // Rule ID 20695 //
     /*  403201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  403209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  403212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  403215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  403218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403233 */     // MIs[0] Operand 4
     /*  403233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  403254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403271 */     GIR_RootConstrainSelectedInstOperands,
     /*  403272 */     // GIR_Coverage, 20695,
     /*  403272 */     GIR_EraseRootFromParent_Done,
     /*  403273 */   // Label 7190: @403273
     /*  403273 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(403350), // Rule ID 20698 //
     /*  403278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  403289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  403292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  403295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403310 */     // MIs[0] Operand 4
     /*  403310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  403331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403348 */     GIR_RootConstrainSelectedInstOperands,
     /*  403349 */     // GIR_Coverage, 20698,
     /*  403349 */     GIR_EraseRootFromParent_Done,
     /*  403350 */   // Label 7191: @403350
     /*  403350 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(403427), // Rule ID 20699 //
     /*  403355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  403366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  403369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  403372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403387 */     // MIs[0] Operand 4
     /*  403387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  403408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403425 */     GIR_RootConstrainSelectedInstOperands,
     /*  403426 */     // GIR_Coverage, 20699,
     /*  403426 */     GIR_EraseRootFromParent_Done,
     /*  403427 */   // Label 7192: @403427
     /*  403427 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(403504), // Rule ID 20702 //
     /*  403432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403464 */     // MIs[0] Operand 4
     /*  403464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403502 */     GIR_RootConstrainSelectedInstOperands,
     /*  403503 */     // GIR_Coverage, 20702,
     /*  403503 */     GIR_EraseRootFromParent_Done,
     /*  403504 */   // Label 7193: @403504
     /*  403504 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(403581), // Rule ID 20703 //
     /*  403509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403541 */     // MIs[0] Operand 4
     /*  403541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403579 */     GIR_RootConstrainSelectedInstOperands,
     /*  403580 */     // GIR_Coverage, 20703,
     /*  403580 */     GIR_EraseRootFromParent_Done,
     /*  403581 */   // Label 7194: @403581
     /*  403581 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(403658), // Rule ID 20706 //
     /*  403586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403618 */     // MIs[0] Operand 4
     /*  403618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403656 */     GIR_RootConstrainSelectedInstOperands,
     /*  403657 */     // GIR_Coverage, 20706,
     /*  403657 */     GIR_EraseRootFromParent_Done,
     /*  403658 */   // Label 7195: @403658
     /*  403658 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(403735), // Rule ID 20707 //
     /*  403663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403695 */     // MIs[0] Operand 4
     /*  403695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403713 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403733 */     GIR_RootConstrainSelectedInstOperands,
     /*  403734 */     // GIR_Coverage, 20707,
     /*  403734 */     GIR_EraseRootFromParent_Done,
     /*  403735 */   // Label 7196: @403735
     /*  403735 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(403812), // Rule ID 20710 //
     /*  403740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403772 */     // MIs[0] Operand 4
     /*  403772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403810 */     GIR_RootConstrainSelectedInstOperands,
     /*  403811 */     // GIR_Coverage, 20710,
     /*  403811 */     GIR_EraseRootFromParent_Done,
     /*  403812 */   // Label 7197: @403812
     /*  403812 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(403889), // Rule ID 20711 //
     /*  403817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403849 */     // MIs[0] Operand 4
     /*  403849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403867 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403887 */     GIR_RootConstrainSelectedInstOperands,
     /*  403888 */     // GIR_Coverage, 20711,
     /*  403888 */     GIR_EraseRootFromParent_Done,
     /*  403889 */   // Label 7198: @403889
     /*  403889 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(403966), // Rule ID 20714 //
     /*  403894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403926 */     // MIs[0] Operand 4
     /*  403926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403964 */     GIR_RootConstrainSelectedInstOperands,
     /*  403965 */     // GIR_Coverage, 20714,
     /*  403965 */     GIR_EraseRootFromParent_Done,
     /*  403966 */   // Label 7199: @403966
     /*  403966 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(404043), // Rule ID 20715 //
     /*  403971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404003 */     // MIs[0] Operand 4
     /*  404003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404021 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404041 */     GIR_RootConstrainSelectedInstOperands,
     /*  404042 */     // GIR_Coverage, 20715,
     /*  404042 */     GIR_EraseRootFromParent_Done,
     /*  404043 */   // Label 7200: @404043
     /*  404043 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(404120), // Rule ID 20718 //
     /*  404048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  404059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  404062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  404065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404080 */     // MIs[0] Operand 4
     /*  404080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404118 */     GIR_RootConstrainSelectedInstOperands,
     /*  404119 */     // GIR_Coverage, 20718,
     /*  404119 */     GIR_EraseRootFromParent_Done,
     /*  404120 */   // Label 7201: @404120
     /*  404120 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(404197), // Rule ID 20719 //
     /*  404125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  404136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  404139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  404142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404157 */     // MIs[0] Operand 4
     /*  404157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  404178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404195 */     GIR_RootConstrainSelectedInstOperands,
     /*  404196 */     // GIR_Coverage, 20719,
     /*  404196 */     GIR_EraseRootFromParent_Done,
     /*  404197 */   // Label 7202: @404197
     /*  404197 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(404274), // Rule ID 20722 //
     /*  404202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  404213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  404216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  404219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404234 */     // MIs[0] Operand 4
     /*  404234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404272 */     GIR_RootConstrainSelectedInstOperands,
     /*  404273 */     // GIR_Coverage, 20722,
     /*  404273 */     GIR_EraseRootFromParent_Done,
     /*  404274 */   // Label 7203: @404274
     /*  404274 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(404351), // Rule ID 20723 //
     /*  404279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  404290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  404293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  404296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404311 */     // MIs[0] Operand 4
     /*  404311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404349 */     GIR_RootConstrainSelectedInstOperands,
     /*  404350 */     // GIR_Coverage, 20723,
     /*  404350 */     GIR_EraseRootFromParent_Done,
     /*  404351 */   // Label 7204: @404351
     /*  404351 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(404428), // Rule ID 20726 //
     /*  404356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  404367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  404370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  404373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404388 */     // MIs[0] Operand 4
     /*  404388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404406 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404426 */     GIR_RootConstrainSelectedInstOperands,
     /*  404427 */     // GIR_Coverage, 20726,
     /*  404427 */     GIR_EraseRootFromParent_Done,
     /*  404428 */   // Label 7205: @404428
     /*  404428 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(404505), // Rule ID 20727 //
     /*  404433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  404444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  404447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  404450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404465 */     // MIs[0] Operand 4
     /*  404465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404503 */     GIR_RootConstrainSelectedInstOperands,
     /*  404504 */     // GIR_Coverage, 20727,
     /*  404504 */     GIR_EraseRootFromParent_Done,
     /*  404505 */   // Label 7206: @404505
     /*  404505 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(404582), // Rule ID 20730 //
     /*  404510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404542 */     // MIs[0] Operand 4
     /*  404542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404580 */     GIR_RootConstrainSelectedInstOperands,
     /*  404581 */     // GIR_Coverage, 20730,
     /*  404581 */     GIR_EraseRootFromParent_Done,
     /*  404582 */   // Label 7207: @404582
     /*  404582 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(404659), // Rule ID 20731 //
     /*  404587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404619 */     // MIs[0] Operand 4
     /*  404619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404637 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404657 */     GIR_RootConstrainSelectedInstOperands,
     /*  404658 */     // GIR_Coverage, 20731,
     /*  404658 */     GIR_EraseRootFromParent_Done,
     /*  404659 */   // Label 7208: @404659
     /*  404659 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(404736), // Rule ID 20734 //
     /*  404664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404696 */     // MIs[0] Operand 4
     /*  404696 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404734 */     GIR_RootConstrainSelectedInstOperands,
     /*  404735 */     // GIR_Coverage, 20734,
     /*  404735 */     GIR_EraseRootFromParent_Done,
     /*  404736 */   // Label 7209: @404736
     /*  404736 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(404813), // Rule ID 20735 //
     /*  404741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404773 */     // MIs[0] Operand 4
     /*  404773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404811 */     GIR_RootConstrainSelectedInstOperands,
     /*  404812 */     // GIR_Coverage, 20735,
     /*  404812 */     GIR_EraseRootFromParent_Done,
     /*  404813 */   // Label 7210: @404813
     /*  404813 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(404890), // Rule ID 20738 //
     /*  404818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404850 */     // MIs[0] Operand 4
     /*  404850 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404888 */     GIR_RootConstrainSelectedInstOperands,
     /*  404889 */     // GIR_Coverage, 20738,
     /*  404889 */     GIR_EraseRootFromParent_Done,
     /*  404890 */   // Label 7211: @404890
     /*  404890 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(404967), // Rule ID 20739 //
     /*  404895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404927 */     // MIs[0] Operand 4
     /*  404927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404945 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404965 */     GIR_RootConstrainSelectedInstOperands,
     /*  404966 */     // GIR_Coverage, 20739,
     /*  404966 */     GIR_EraseRootFromParent_Done,
     /*  404967 */   // Label 7212: @404967
     /*  404967 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(405044), // Rule ID 20742 //
     /*  404972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405004 */     // MIs[0] Operand 4
     /*  405004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405042 */     GIR_RootConstrainSelectedInstOperands,
     /*  405043 */     // GIR_Coverage, 20742,
     /*  405043 */     GIR_EraseRootFromParent_Done,
     /*  405044 */   // Label 7213: @405044
     /*  405044 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(405121), // Rule ID 20743 //
     /*  405049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  405066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405081 */     // MIs[0] Operand 4
     /*  405081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405119 */     GIR_RootConstrainSelectedInstOperands,
     /*  405120 */     // GIR_Coverage, 20743,
     /*  405120 */     GIR_EraseRootFromParent_Done,
     /*  405121 */   // Label 7214: @405121
     /*  405121 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(405198), // Rule ID 20746 //
     /*  405126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  405143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405158 */     // MIs[0] Operand 4
     /*  405158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  405179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405196 */     GIR_RootConstrainSelectedInstOperands,
     /*  405197 */     // GIR_Coverage, 20746,
     /*  405197 */     GIR_EraseRootFromParent_Done,
     /*  405198 */   // Label 7215: @405198
     /*  405198 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(405275), // Rule ID 20747 //
     /*  405203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  405220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405235 */     // MIs[0] Operand 4
     /*  405235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  405256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405273 */     GIR_RootConstrainSelectedInstOperands,
     /*  405274 */     // GIR_Coverage, 20747,
     /*  405274 */     GIR_EraseRootFromParent_Done,
     /*  405275 */   // Label 7216: @405275
     /*  405275 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(405352), // Rule ID 20750 //
     /*  405280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  405297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405312 */     // MIs[0] Operand 4
     /*  405312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  405333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405350 */     GIR_RootConstrainSelectedInstOperands,
     /*  405351 */     // GIR_Coverage, 20750,
     /*  405351 */     GIR_EraseRootFromParent_Done,
     /*  405352 */   // Label 7217: @405352
     /*  405352 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(405429), // Rule ID 20751 //
     /*  405357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  405374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405389 */     // MIs[0] Operand 4
     /*  405389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405407 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  405410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405427 */     GIR_RootConstrainSelectedInstOperands,
     /*  405428 */     // GIR_Coverage, 20751,
     /*  405428 */     GIR_EraseRootFromParent_Done,
     /*  405429 */   // Label 7218: @405429
     /*  405429 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(405506), // Rule ID 20754 //
     /*  405434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405466 */     // MIs[0] Operand 4
     /*  405466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405504 */     GIR_RootConstrainSelectedInstOperands,
     /*  405505 */     // GIR_Coverage, 20754,
     /*  405505 */     GIR_EraseRootFromParent_Done,
     /*  405506 */   // Label 7219: @405506
     /*  405506 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(405583), // Rule ID 20755 //
     /*  405511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405543 */     // MIs[0] Operand 4
     /*  405543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405561 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405581 */     GIR_RootConstrainSelectedInstOperands,
     /*  405582 */     // GIR_Coverage, 20755,
     /*  405582 */     GIR_EraseRootFromParent_Done,
     /*  405583 */   // Label 7220: @405583
     /*  405583 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(405660), // Rule ID 21114 //
     /*  405588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405620 */     // MIs[0] Operand 4
     /*  405620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405658 */     GIR_RootConstrainSelectedInstOperands,
     /*  405659 */     // GIR_Coverage, 21114,
     /*  405659 */     GIR_EraseRootFromParent_Done,
     /*  405660 */   // Label 7221: @405660
     /*  405660 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(405737), // Rule ID 21115 //
     /*  405665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405697 */     // MIs[0] Operand 4
     /*  405697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405715 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405735 */     GIR_RootConstrainSelectedInstOperands,
     /*  405736 */     // GIR_Coverage, 21115,
     /*  405736 */     GIR_EraseRootFromParent_Done,
     /*  405737 */   // Label 7222: @405737
     /*  405737 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(405814), // Rule ID 21118 //
     /*  405742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405774 */     // MIs[0] Operand 4
     /*  405774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405812 */     GIR_RootConstrainSelectedInstOperands,
     /*  405813 */     // GIR_Coverage, 21118,
     /*  405813 */     GIR_EraseRootFromParent_Done,
     /*  405814 */   // Label 7223: @405814
     /*  405814 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(405891), // Rule ID 21119 //
     /*  405819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405851 */     // MIs[0] Operand 4
     /*  405851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405869 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405889 */     GIR_RootConstrainSelectedInstOperands,
     /*  405890 */     // GIR_Coverage, 21119,
     /*  405890 */     GIR_EraseRootFromParent_Done,
     /*  405891 */   // Label 7224: @405891
     /*  405891 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(405968), // Rule ID 21122 //
     /*  405896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405928 */     // MIs[0] Operand 4
     /*  405928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405966 */     GIR_RootConstrainSelectedInstOperands,
     /*  405967 */     // GIR_Coverage, 21122,
     /*  405967 */     GIR_EraseRootFromParent_Done,
     /*  405968 */   // Label 7225: @405968
     /*  405968 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(406045), // Rule ID 21123 //
     /*  405973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406005 */     // MIs[0] Operand 4
     /*  406005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406043 */     GIR_RootConstrainSelectedInstOperands,
     /*  406044 */     // GIR_Coverage, 21123,
     /*  406044 */     GIR_EraseRootFromParent_Done,
     /*  406045 */   // Label 7226: @406045
     /*  406045 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(406122), // Rule ID 21126 //
     /*  406050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406082 */     // MIs[0] Operand 4
     /*  406082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406120 */     GIR_RootConstrainSelectedInstOperands,
     /*  406121 */     // GIR_Coverage, 21126,
     /*  406121 */     GIR_EraseRootFromParent_Done,
     /*  406122 */   // Label 7227: @406122
     /*  406122 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(406199), // Rule ID 21127 //
     /*  406127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406159 */     // MIs[0] Operand 4
     /*  406159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406197 */     GIR_RootConstrainSelectedInstOperands,
     /*  406198 */     // GIR_Coverage, 21127,
     /*  406198 */     GIR_EraseRootFromParent_Done,
     /*  406199 */   // Label 7228: @406199
     /*  406199 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(406276), // Rule ID 21130 //
     /*  406204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406236 */     // MIs[0] Operand 4
     /*  406236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406274 */     GIR_RootConstrainSelectedInstOperands,
     /*  406275 */     // GIR_Coverage, 21130,
     /*  406275 */     GIR_EraseRootFromParent_Done,
     /*  406276 */   // Label 7229: @406276
     /*  406276 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(406353), // Rule ID 21131 //
     /*  406281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406313 */     // MIs[0] Operand 4
     /*  406313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406331 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406351 */     GIR_RootConstrainSelectedInstOperands,
     /*  406352 */     // GIR_Coverage, 21131,
     /*  406352 */     GIR_EraseRootFromParent_Done,
     /*  406353 */   // Label 7230: @406353
     /*  406353 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(406430), // Rule ID 21134 //
     /*  406358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406390 */     // MIs[0] Operand 4
     /*  406390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406428 */     GIR_RootConstrainSelectedInstOperands,
     /*  406429 */     // GIR_Coverage, 21134,
     /*  406429 */     GIR_EraseRootFromParent_Done,
     /*  406430 */   // Label 7231: @406430
     /*  406430 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(406507), // Rule ID 21135 //
     /*  406435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406467 */     // MIs[0] Operand 4
     /*  406467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406485 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406505 */     GIR_RootConstrainSelectedInstOperands,
     /*  406506 */     // GIR_Coverage, 21135,
     /*  406506 */     GIR_EraseRootFromParent_Done,
     /*  406507 */   // Label 7232: @406507
     /*  406507 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(406584), // Rule ID 21138 //
     /*  406512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406544 */     // MIs[0] Operand 4
     /*  406544 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406582 */     GIR_RootConstrainSelectedInstOperands,
     /*  406583 */     // GIR_Coverage, 21138,
     /*  406583 */     GIR_EraseRootFromParent_Done,
     /*  406584 */   // Label 7233: @406584
     /*  406584 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(406661), // Rule ID 21139 //
     /*  406589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406621 */     // MIs[0] Operand 4
     /*  406621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406659 */     GIR_RootConstrainSelectedInstOperands,
     /*  406660 */     // GIR_Coverage, 21139,
     /*  406660 */     GIR_EraseRootFromParent_Done,
     /*  406661 */   // Label 7234: @406661
     /*  406661 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(406738), // Rule ID 21142 //
     /*  406666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406698 */     // MIs[0] Operand 4
     /*  406698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406736 */     GIR_RootConstrainSelectedInstOperands,
     /*  406737 */     // GIR_Coverage, 21142,
     /*  406737 */     GIR_EraseRootFromParent_Done,
     /*  406738 */   // Label 7235: @406738
     /*  406738 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(406815), // Rule ID 21143 //
     /*  406743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406775 */     // MIs[0] Operand 4
     /*  406775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406813 */     GIR_RootConstrainSelectedInstOperands,
     /*  406814 */     // GIR_Coverage, 21143,
     /*  406814 */     GIR_EraseRootFromParent_Done,
     /*  406815 */   // Label 7236: @406815
     /*  406815 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(406892), // Rule ID 21146 //
     /*  406820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406852 */     // MIs[0] Operand 4
     /*  406852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406870 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406890 */     GIR_RootConstrainSelectedInstOperands,
     /*  406891 */     // GIR_Coverage, 21146,
     /*  406891 */     GIR_EraseRootFromParent_Done,
     /*  406892 */   // Label 7237: @406892
     /*  406892 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(406969), // Rule ID 21147 //
     /*  406897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406929 */     // MIs[0] Operand 4
     /*  406929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406947 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406967 */     GIR_RootConstrainSelectedInstOperands,
     /*  406968 */     // GIR_Coverage, 21147,
     /*  406968 */     GIR_EraseRootFromParent_Done,
     /*  406969 */   // Label 7238: @406969
     /*  406969 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(407046), // Rule ID 21150 //
     /*  406974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407006 */     // MIs[0] Operand 4
     /*  407006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  407027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407044 */     GIR_RootConstrainSelectedInstOperands,
     /*  407045 */     // GIR_Coverage, 21150,
     /*  407045 */     GIR_EraseRootFromParent_Done,
     /*  407046 */   // Label 7239: @407046
     /*  407046 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(407123), // Rule ID 21151 //
     /*  407051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407083 */     // MIs[0] Operand 4
     /*  407083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  407104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407121 */     GIR_RootConstrainSelectedInstOperands,
     /*  407122 */     // GIR_Coverage, 21151,
     /*  407122 */     GIR_EraseRootFromParent_Done,
     /*  407123 */   // Label 7240: @407123
     /*  407123 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(407200), // Rule ID 21154 //
     /*  407128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407160 */     // MIs[0] Operand 4
     /*  407160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407198 */     GIR_RootConstrainSelectedInstOperands,
     /*  407199 */     // GIR_Coverage, 21154,
     /*  407199 */     GIR_EraseRootFromParent_Done,
     /*  407200 */   // Label 7241: @407200
     /*  407200 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(407277), // Rule ID 21155 //
     /*  407205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407237 */     // MIs[0] Operand 4
     /*  407237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407255 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407275 */     GIR_RootConstrainSelectedInstOperands,
     /*  407276 */     // GIR_Coverage, 21155,
     /*  407276 */     GIR_EraseRootFromParent_Done,
     /*  407277 */   // Label 7242: @407277
     /*  407277 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(407354), // Rule ID 21158 //
     /*  407282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407314 */     // MIs[0] Operand 4
     /*  407314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407352 */     GIR_RootConstrainSelectedInstOperands,
     /*  407353 */     // GIR_Coverage, 21158,
     /*  407353 */     GIR_EraseRootFromParent_Done,
     /*  407354 */   // Label 7243: @407354
     /*  407354 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(407431), // Rule ID 21159 //
     /*  407359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  407370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  407373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407391 */     // MIs[0] Operand 4
     /*  407391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407429 */     GIR_RootConstrainSelectedInstOperands,
     /*  407430 */     // GIR_Coverage, 21159,
     /*  407430 */     GIR_EraseRootFromParent_Done,
     /*  407431 */   // Label 7244: @407431
     /*  407431 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(407508), // Rule ID 21162 //
     /*  407436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407468 */     // MIs[0] Operand 4
     /*  407468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407506 */     GIR_RootConstrainSelectedInstOperands,
     /*  407507 */     // GIR_Coverage, 21162,
     /*  407507 */     GIR_EraseRootFromParent_Done,
     /*  407508 */   // Label 7245: @407508
     /*  407508 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(407585), // Rule ID 21163 //
     /*  407513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407545 */     // MIs[0] Operand 4
     /*  407545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407583 */     GIR_RootConstrainSelectedInstOperands,
     /*  407584 */     // GIR_Coverage, 21163,
     /*  407584 */     GIR_EraseRootFromParent_Done,
     /*  407585 */   // Label 7246: @407585
     /*  407585 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(407662), // Rule ID 21166 //
     /*  407590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407622 */     // MIs[0] Operand 4
     /*  407622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407660 */     GIR_RootConstrainSelectedInstOperands,
     /*  407661 */     // GIR_Coverage, 21166,
     /*  407661 */     GIR_EraseRootFromParent_Done,
     /*  407662 */   // Label 7247: @407662
     /*  407662 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(407739), // Rule ID 21167 //
     /*  407667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407699 */     // MIs[0] Operand 4
     /*  407699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407717 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407737 */     GIR_RootConstrainSelectedInstOperands,
     /*  407738 */     // GIR_Coverage, 21167,
     /*  407738 */     GIR_EraseRootFromParent_Done,
     /*  407739 */   // Label 7248: @407739
     /*  407739 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(407816), // Rule ID 21170 //
     /*  407744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407776 */     // MIs[0] Operand 4
     /*  407776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407814 */     GIR_RootConstrainSelectedInstOperands,
     /*  407815 */     // GIR_Coverage, 21170,
     /*  407815 */     GIR_EraseRootFromParent_Done,
     /*  407816 */   // Label 7249: @407816
     /*  407816 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(407893), // Rule ID 21171 //
     /*  407821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407853 */     // MIs[0] Operand 4
     /*  407853 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407871 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407891 */     GIR_RootConstrainSelectedInstOperands,
     /*  407892 */     // GIR_Coverage, 21171,
     /*  407892 */     GIR_EraseRootFromParent_Done,
     /*  407893 */   // Label 7250: @407893
     /*  407893 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(407970), // Rule ID 21174 //
     /*  407898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407930 */     // MIs[0] Operand 4
     /*  407930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407968 */     GIR_RootConstrainSelectedInstOperands,
     /*  407969 */     // GIR_Coverage, 21174,
     /*  407969 */     GIR_EraseRootFromParent_Done,
     /*  407970 */   // Label 7251: @407970
     /*  407970 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(408047), // Rule ID 21175 //
     /*  407975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408007 */     // MIs[0] Operand 4
     /*  408007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  408028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408045 */     GIR_RootConstrainSelectedInstOperands,
     /*  408046 */     // GIR_Coverage, 21175,
     /*  408046 */     GIR_EraseRootFromParent_Done,
     /*  408047 */   // Label 7252: @408047
     /*  408047 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(408124), // Rule ID 21178 //
     /*  408052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  408055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408084 */     // MIs[0] Operand 4
     /*  408084 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  408105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408122 */     GIR_RootConstrainSelectedInstOperands,
     /*  408123 */     // GIR_Coverage, 21178,
     /*  408123 */     GIR_EraseRootFromParent_Done,
     /*  408124 */   // Label 7253: @408124
     /*  408124 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(408201), // Rule ID 21179 //
     /*  408129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  408132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408161 */     // MIs[0] Operand 4
     /*  408161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408179 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  408182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408199 */     GIR_RootConstrainSelectedInstOperands,
     /*  408200 */     // GIR_Coverage, 21179,
     /*  408200 */     GIR_EraseRootFromParent_Done,
     /*  408201 */   // Label 7254: @408201
     /*  408201 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(408278), // Rule ID 21182 //
     /*  408206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  408209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408238 */     // MIs[0] Operand 4
     /*  408238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  408259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408276 */     GIR_RootConstrainSelectedInstOperands,
     /*  408277 */     // GIR_Coverage, 21182,
     /*  408277 */     GIR_EraseRootFromParent_Done,
     /*  408278 */   // Label 7255: @408278
     /*  408278 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(408355), // Rule ID 21183 //
     /*  408283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  408286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  408291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408315 */     // MIs[0] Operand 4
     /*  408315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408333 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  408336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408353 */     GIR_RootConstrainSelectedInstOperands,
     /*  408354 */     // GIR_Coverage, 21183,
     /*  408354 */     GIR_EraseRootFromParent_Done,
     /*  408355 */   // Label 7256: @408355
     /*  408355 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(408432), // Rule ID 21486 //
     /*  408360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  408371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  408374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408392 */     // MIs[0] Operand 4
     /*  408392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408430 */     GIR_RootConstrainSelectedInstOperands,
     /*  408431 */     // GIR_Coverage, 21486,
     /*  408431 */     GIR_EraseRootFromParent_Done,
     /*  408432 */   // Label 7257: @408432
     /*  408432 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(408509), // Rule ID 21487 //
     /*  408437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  408448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  408451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408469 */     // MIs[0] Operand 4
     /*  408469 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408487 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408507 */     GIR_RootConstrainSelectedInstOperands,
     /*  408508 */     // GIR_Coverage, 21487,
     /*  408508 */     GIR_EraseRootFromParent_Done,
     /*  408509 */   // Label 7258: @408509
     /*  408509 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(408586), // Rule ID 21490 //
     /*  408514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408546 */     // MIs[0] Operand 4
     /*  408546 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408584 */     GIR_RootConstrainSelectedInstOperands,
     /*  408585 */     // GIR_Coverage, 21490,
     /*  408585 */     GIR_EraseRootFromParent_Done,
     /*  408586 */   // Label 7259: @408586
     /*  408586 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(408663), // Rule ID 21491 //
     /*  408591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408623 */     // MIs[0] Operand 4
     /*  408623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408641 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408661 */     GIR_RootConstrainSelectedInstOperands,
     /*  408662 */     // GIR_Coverage, 21491,
     /*  408662 */     GIR_EraseRootFromParent_Done,
     /*  408663 */   // Label 7260: @408663
     /*  408663 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(408740), // Rule ID 21494 //
     /*  408668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408700 */     // MIs[0] Operand 4
     /*  408700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408738 */     GIR_RootConstrainSelectedInstOperands,
     /*  408739 */     // GIR_Coverage, 21494,
     /*  408739 */     GIR_EraseRootFromParent_Done,
     /*  408740 */   // Label 7261: @408740
     /*  408740 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(408817), // Rule ID 21495 //
     /*  408745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408777 */     // MIs[0] Operand 4
     /*  408777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408795 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408815 */     GIR_RootConstrainSelectedInstOperands,
     /*  408816 */     // GIR_Coverage, 21495,
     /*  408816 */     GIR_EraseRootFromParent_Done,
     /*  408817 */   // Label 7262: @408817
     /*  408817 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(408894), // Rule ID 21498 //
     /*  408822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408854 */     // MIs[0] Operand 4
     /*  408854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408892 */     GIR_RootConstrainSelectedInstOperands,
     /*  408893 */     // GIR_Coverage, 21498,
     /*  408893 */     GIR_EraseRootFromParent_Done,
     /*  408894 */   // Label 7263: @408894
     /*  408894 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(408971), // Rule ID 21499 //
     /*  408899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408931 */     // MIs[0] Operand 4
     /*  408931 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408949 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408969 */     GIR_RootConstrainSelectedInstOperands,
     /*  408970 */     // GIR_Coverage, 21499,
     /*  408970 */     GIR_EraseRootFromParent_Done,
     /*  408971 */   // Label 7264: @408971
     /*  408971 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(409048), // Rule ID 21502 //
     /*  408976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409008 */     // MIs[0] Operand 4
     /*  409008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409046 */     GIR_RootConstrainSelectedInstOperands,
     /*  409047 */     // GIR_Coverage, 21502,
     /*  409047 */     GIR_EraseRootFromParent_Done,
     /*  409048 */   // Label 7265: @409048
     /*  409048 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(409125), // Rule ID 21503 //
     /*  409053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  409064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  409067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409085 */     // MIs[0] Operand 4
     /*  409085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409103 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409123 */     GIR_RootConstrainSelectedInstOperands,
     /*  409124 */     // GIR_Coverage, 21503,
     /*  409124 */     GIR_EraseRootFromParent_Done,
     /*  409125 */   // Label 7266: @409125
     /*  409125 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(409202), // Rule ID 21506 //
     /*  409130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  409141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  409144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  409147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409162 */     // MIs[0] Operand 4
     /*  409162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409180 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409200 */     GIR_RootConstrainSelectedInstOperands,
     /*  409201 */     // GIR_Coverage, 21506,
     /*  409201 */     GIR_EraseRootFromParent_Done,
     /*  409202 */   // Label 7267: @409202
     /*  409202 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(409279), // Rule ID 21507 //
     /*  409207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  409218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  409221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  409224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409239 */     // MIs[0] Operand 4
     /*  409239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409257 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409277 */     GIR_RootConstrainSelectedInstOperands,
     /*  409278 */     // GIR_Coverage, 21507,
     /*  409278 */     GIR_EraseRootFromParent_Done,
     /*  409279 */   // Label 7268: @409279
     /*  409279 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(409356), // Rule ID 21510 //
     /*  409284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  409295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  409298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409316 */     // MIs[0] Operand 4
     /*  409316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  409337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409354 */     GIR_RootConstrainSelectedInstOperands,
     /*  409355 */     // GIR_Coverage, 21510,
     /*  409355 */     GIR_EraseRootFromParent_Done,
     /*  409356 */   // Label 7269: @409356
     /*  409356 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(409433), // Rule ID 21511 //
     /*  409361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  409372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  409375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409393 */     // MIs[0] Operand 4
     /*  409393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409411 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  409414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409431 */     GIR_RootConstrainSelectedInstOperands,
     /*  409432 */     // GIR_Coverage, 21511,
     /*  409432 */     GIR_EraseRootFromParent_Done,
     /*  409433 */   // Label 7270: @409433
     /*  409433 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(409510), // Rule ID 21514 //
     /*  409438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409470 */     // MIs[0] Operand 4
     /*  409470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409488 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409508 */     GIR_RootConstrainSelectedInstOperands,
     /*  409509 */     // GIR_Coverage, 21514,
     /*  409509 */     GIR_EraseRootFromParent_Done,
     /*  409510 */   // Label 7271: @409510
     /*  409510 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(409587), // Rule ID 21515 //
     /*  409515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409547 */     // MIs[0] Operand 4
     /*  409547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409565 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409585 */     GIR_RootConstrainSelectedInstOperands,
     /*  409586 */     // GIR_Coverage, 21515,
     /*  409586 */     GIR_EraseRootFromParent_Done,
     /*  409587 */   // Label 7272: @409587
     /*  409587 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(409664), // Rule ID 21518 //
     /*  409592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409624 */     // MIs[0] Operand 4
     /*  409624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409662 */     GIR_RootConstrainSelectedInstOperands,
     /*  409663 */     // GIR_Coverage, 21518,
     /*  409663 */     GIR_EraseRootFromParent_Done,
     /*  409664 */   // Label 7273: @409664
     /*  409664 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(409741), // Rule ID 21519 //
     /*  409669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409701 */     // MIs[0] Operand 4
     /*  409701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409739 */     GIR_RootConstrainSelectedInstOperands,
     /*  409740 */     // GIR_Coverage, 21519,
     /*  409740 */     GIR_EraseRootFromParent_Done,
     /*  409741 */   // Label 7274: @409741
     /*  409741 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(409818), // Rule ID 21522 //
     /*  409746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409778 */     // MIs[0] Operand 4
     /*  409778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409816 */     GIR_RootConstrainSelectedInstOperands,
     /*  409817 */     // GIR_Coverage, 21522,
     /*  409817 */     GIR_EraseRootFromParent_Done,
     /*  409818 */   // Label 7275: @409818
     /*  409818 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(409895), // Rule ID 21523 //
     /*  409823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409855 */     // MIs[0] Operand 4
     /*  409855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409893 */     GIR_RootConstrainSelectedInstOperands,
     /*  409894 */     // GIR_Coverage, 21523,
     /*  409894 */     GIR_EraseRootFromParent_Done,
     /*  409895 */   // Label 7276: @409895
     /*  409895 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(409972), // Rule ID 21526 //
     /*  409900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409932 */     // MIs[0] Operand 4
     /*  409932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409970 */     GIR_RootConstrainSelectedInstOperands,
     /*  409971 */     // GIR_Coverage, 21526,
     /*  409971 */     GIR_EraseRootFromParent_Done,
     /*  409972 */   // Label 7277: @409972
     /*  409972 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(410049), // Rule ID 21527 //
     /*  409977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410009 */     // MIs[0] Operand 4
     /*  410009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410047 */     GIR_RootConstrainSelectedInstOperands,
     /*  410048 */     // GIR_Coverage, 21527,
     /*  410048 */     GIR_EraseRootFromParent_Done,
     /*  410049 */   // Label 7278: @410049
     /*  410049 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(410126), // Rule ID 21530 //
     /*  410054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  410071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410086 */     // MIs[0] Operand 4
     /*  410086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  410107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410124 */     GIR_RootConstrainSelectedInstOperands,
     /*  410125 */     // GIR_Coverage, 21530,
     /*  410125 */     GIR_EraseRootFromParent_Done,
     /*  410126 */   // Label 7279: @410126
     /*  410126 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(410203), // Rule ID 21531 //
     /*  410131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  410148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410163 */     // MIs[0] Operand 4
     /*  410163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  410184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410201 */     GIR_RootConstrainSelectedInstOperands,
     /*  410202 */     // GIR_Coverage, 21531,
     /*  410202 */     GIR_EraseRootFromParent_Done,
     /*  410203 */   // Label 7280: @410203
     /*  410203 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(410280), // Rule ID 21534 //
     /*  410208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  410225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410240 */     // MIs[0] Operand 4
     /*  410240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  410261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410278 */     GIR_RootConstrainSelectedInstOperands,
     /*  410279 */     // GIR_Coverage, 21534,
     /*  410279 */     GIR_EraseRootFromParent_Done,
     /*  410280 */   // Label 7281: @410280
     /*  410280 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(410357), // Rule ID 21535 //
     /*  410285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  410302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410317 */     // MIs[0] Operand 4
     /*  410317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410335 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  410338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410355 */     GIR_RootConstrainSelectedInstOperands,
     /*  410356 */     // GIR_Coverage, 21535,
     /*  410356 */     GIR_EraseRootFromParent_Done,
     /*  410357 */   // Label 7282: @410357
     /*  410357 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(410434), // Rule ID 21538 //
     /*  410362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  410379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410394 */     // MIs[0] Operand 4
     /*  410394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410432 */     GIR_RootConstrainSelectedInstOperands,
     /*  410433 */     // GIR_Coverage, 21538,
     /*  410433 */     GIR_EraseRootFromParent_Done,
     /*  410434 */   // Label 7283: @410434
     /*  410434 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(410511), // Rule ID 21539 //
     /*  410439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  410456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410471 */     // MIs[0] Operand 4
     /*  410471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410509 */     GIR_RootConstrainSelectedInstOperands,
     /*  410510 */     // GIR_Coverage, 21539,
     /*  410510 */     GIR_EraseRootFromParent_Done,
     /*  410511 */   // Label 7284: @410511
     /*  410511 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(410588), // Rule ID 21542 //
     /*  410516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410548 */     // MIs[0] Operand 4
     /*  410548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410586 */     GIR_RootConstrainSelectedInstOperands,
     /*  410587 */     // GIR_Coverage, 21542,
     /*  410587 */     GIR_EraseRootFromParent_Done,
     /*  410588 */   // Label 7285: @410588
     /*  410588 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(410665), // Rule ID 21543 //
     /*  410593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410625 */     // MIs[0] Operand 4
     /*  410625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410663 */     GIR_RootConstrainSelectedInstOperands,
     /*  410664 */     // GIR_Coverage, 21543,
     /*  410664 */     GIR_EraseRootFromParent_Done,
     /*  410665 */   // Label 7286: @410665
     /*  410665 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(410742), // Rule ID 21546 //
     /*  410670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410702 */     // MIs[0] Operand 4
     /*  410702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410720 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410740 */     GIR_RootConstrainSelectedInstOperands,
     /*  410741 */     // GIR_Coverage, 21546,
     /*  410741 */     GIR_EraseRootFromParent_Done,
     /*  410742 */   // Label 7287: @410742
     /*  410742 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(410819), // Rule ID 21547 //
     /*  410747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410779 */     // MIs[0] Operand 4
     /*  410779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410797 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410817 */     GIR_RootConstrainSelectedInstOperands,
     /*  410818 */     // GIR_Coverage, 21547,
     /*  410818 */     GIR_EraseRootFromParent_Done,
     /*  410819 */   // Label 7288: @410819
     /*  410819 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(410896), // Rule ID 21550 //
     /*  410824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410856 */     // MIs[0] Operand 4
     /*  410856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410874 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410894 */     GIR_RootConstrainSelectedInstOperands,
     /*  410895 */     // GIR_Coverage, 21550,
     /*  410895 */     GIR_EraseRootFromParent_Done,
     /*  410896 */   // Label 7289: @410896
     /*  410896 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(410973), // Rule ID 21551 //
     /*  410901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410933 */     // MIs[0] Operand 4
     /*  410933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410951 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410971 */     GIR_RootConstrainSelectedInstOperands,
     /*  410972 */     // GIR_Coverage, 21551,
     /*  410972 */     GIR_EraseRootFromParent_Done,
     /*  410973 */   // Label 7290: @410973
     /*  410973 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(411050), // Rule ID 21554 //
     /*  410978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411010 */     // MIs[0] Operand 4
     /*  411010 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411048 */     GIR_RootConstrainSelectedInstOperands,
     /*  411049 */     // GIR_Coverage, 21554,
     /*  411049 */     GIR_EraseRootFromParent_Done,
     /*  411050 */   // Label 7291: @411050
     /*  411050 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(411127), // Rule ID 21555 //
     /*  411055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  411066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  411069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  411072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411087 */     // MIs[0] Operand 4
     /*  411087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411105 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411125 */     GIR_RootConstrainSelectedInstOperands,
     /*  411126 */     // GIR_Coverage, 21555,
     /*  411126 */     GIR_EraseRootFromParent_Done,
     /*  411127 */   // Label 7292: @411127
     /*  411127 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(411204), // Rule ID 21558 //
     /*  411132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  411143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  411146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  411149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411164 */     // MIs[0] Operand 4
     /*  411164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411182 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411202 */     GIR_RootConstrainSelectedInstOperands,
     /*  411203 */     // GIR_Coverage, 21558,
     /*  411203 */     GIR_EraseRootFromParent_Done,
     /*  411204 */   // Label 7293: @411204
     /*  411204 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(411281), // Rule ID 21559 //
     /*  411209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  411220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  411223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  411226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411241 */     // MIs[0] Operand 4
     /*  411241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411279 */     GIR_RootConstrainSelectedInstOperands,
     /*  411280 */     // GIR_Coverage, 21559,
     /*  411280 */     GIR_EraseRootFromParent_Done,
     /*  411281 */   // Label 7294: @411281
     /*  411281 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(411358), // Rule ID 21562 //
     /*  411286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  411297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  411300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411318 */     // MIs[0] Operand 4
     /*  411318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411356 */     GIR_RootConstrainSelectedInstOperands,
     /*  411357 */     // GIR_Coverage, 21562,
     /*  411357 */     GIR_EraseRootFromParent_Done,
     /*  411358 */   // Label 7295: @411358
     /*  411358 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(411435), // Rule ID 21563 //
     /*  411363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  411374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  411377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411395 */     // MIs[0] Operand 4
     /*  411395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411433 */     GIR_RootConstrainSelectedInstOperands,
     /*  411434 */     // GIR_Coverage, 21563,
     /*  411434 */     GIR_EraseRootFromParent_Done,
     /*  411435 */   // Label 7296: @411435
     /*  411435 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(411512), // Rule ID 21566 //
     /*  411440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411472 */     // MIs[0] Operand 4
     /*  411472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411510 */     GIR_RootConstrainSelectedInstOperands,
     /*  411511 */     // GIR_Coverage, 21566,
     /*  411511 */     GIR_EraseRootFromParent_Done,
     /*  411512 */   // Label 7297: @411512
     /*  411512 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(411589), // Rule ID 21567 //
     /*  411517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411549 */     // MIs[0] Operand 4
     /*  411549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411567 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411587 */     GIR_RootConstrainSelectedInstOperands,
     /*  411588 */     // GIR_Coverage, 21567,
     /*  411588 */     GIR_EraseRootFromParent_Done,
     /*  411589 */   // Label 7298: @411589
     /*  411589 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(411666), // Rule ID 21570 //
     /*  411594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411626 */     // MIs[0] Operand 4
     /*  411626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411644 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411664 */     GIR_RootConstrainSelectedInstOperands,
     /*  411665 */     // GIR_Coverage, 21570,
     /*  411665 */     GIR_EraseRootFromParent_Done,
     /*  411666 */   // Label 7299: @411666
     /*  411666 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(411743), // Rule ID 21571 //
     /*  411671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411703 */     // MIs[0] Operand 4
     /*  411703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411741 */     GIR_RootConstrainSelectedInstOperands,
     /*  411742 */     // GIR_Coverage, 21571,
     /*  411742 */     GIR_EraseRootFromParent_Done,
     /*  411743 */   // Label 7300: @411743
     /*  411743 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(411820), // Rule ID 21574 //
     /*  411748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411780 */     // MIs[0] Operand 4
     /*  411780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411818 */     GIR_RootConstrainSelectedInstOperands,
     /*  411819 */     // GIR_Coverage, 21574,
     /*  411819 */     GIR_EraseRootFromParent_Done,
     /*  411820 */   // Label 7301: @411820
     /*  411820 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(411897), // Rule ID 21575 //
     /*  411825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411857 */     // MIs[0] Operand 4
     /*  411857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411895 */     GIR_RootConstrainSelectedInstOperands,
     /*  411896 */     // GIR_Coverage, 21575,
     /*  411896 */     GIR_EraseRootFromParent_Done,
     /*  411897 */   // Label 7302: @411897
     /*  411897 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(411974), // Rule ID 21578 //
     /*  411902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411934 */     // MIs[0] Operand 4
     /*  411934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411972 */     GIR_RootConstrainSelectedInstOperands,
     /*  411973 */     // GIR_Coverage, 21578,
     /*  411973 */     GIR_EraseRootFromParent_Done,
     /*  411974 */   // Label 7303: @411974
     /*  411974 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(412051), // Rule ID 21579 //
     /*  411979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412011 */     // MIs[0] Operand 4
     /*  412011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412029 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412049 */     GIR_RootConstrainSelectedInstOperands,
     /*  412050 */     // GIR_Coverage, 21579,
     /*  412050 */     GIR_EraseRootFromParent_Done,
     /*  412051 */   // Label 7304: @412051
     /*  412051 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(412128), // Rule ID 21582 //
     /*  412056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  412067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  412070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412088 */     // MIs[0] Operand 4
     /*  412088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412126 */     GIR_RootConstrainSelectedInstOperands,
     /*  412127 */     // GIR_Coverage, 21582,
     /*  412127 */     GIR_EraseRootFromParent_Done,
     /*  412128 */   // Label 7305: @412128
     /*  412128 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(412205), // Rule ID 21583 //
     /*  412133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  412144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  412147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  412150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412165 */     // MIs[0] Operand 4
     /*  412165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412183 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412203 */     GIR_RootConstrainSelectedInstOperands,
     /*  412204 */     // GIR_Coverage, 21583,
     /*  412204 */     GIR_EraseRootFromParent_Done,
     /*  412205 */   // Label 7306: @412205
     /*  412205 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(412282), // Rule ID 21586 //
     /*  412210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  412221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  412224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  412227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412242 */     // MIs[0] Operand 4
     /*  412242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412260 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412280 */     GIR_RootConstrainSelectedInstOperands,
     /*  412281 */     // GIR_Coverage, 21586,
     /*  412281 */     GIR_EraseRootFromParent_Done,
     /*  412282 */   // Label 7307: @412282
     /*  412282 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(412359), // Rule ID 21587 //
     /*  412287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  412298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  412301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  412304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412319 */     // MIs[0] Operand 4
     /*  412319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412337 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412357 */     GIR_RootConstrainSelectedInstOperands,
     /*  412358 */     // GIR_Coverage, 21587,
     /*  412358 */     GIR_EraseRootFromParent_Done,
     /*  412359 */   // Label 7308: @412359
     /*  412359 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(412436), // Rule ID 21590 //
     /*  412364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  412381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412396 */     // MIs[0] Operand 4
     /*  412396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412434 */     GIR_RootConstrainSelectedInstOperands,
     /*  412435 */     // GIR_Coverage, 21590,
     /*  412435 */     GIR_EraseRootFromParent_Done,
     /*  412436 */   // Label 7309: @412436
     /*  412436 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(412513), // Rule ID 21591 //
     /*  412441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  412452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  412455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  412458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412473 */     // MIs[0] Operand 4
     /*  412473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412511 */     GIR_RootConstrainSelectedInstOperands,
     /*  412512 */     // GIR_Coverage, 21591,
     /*  412512 */     GIR_EraseRootFromParent_Done,
     /*  412513 */   // Label 7310: @412513
     /*  412513 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(412590), // Rule ID 21594 //
     /*  412518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412550 */     // MIs[0] Operand 4
     /*  412550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412588 */     GIR_RootConstrainSelectedInstOperands,
     /*  412589 */     // GIR_Coverage, 21594,
     /*  412589 */     GIR_EraseRootFromParent_Done,
     /*  412590 */   // Label 7311: @412590
     /*  412590 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(412667), // Rule ID 21595 //
     /*  412595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412627 */     // MIs[0] Operand 4
     /*  412627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412665 */     GIR_RootConstrainSelectedInstOperands,
     /*  412666 */     // GIR_Coverage, 21595,
     /*  412666 */     GIR_EraseRootFromParent_Done,
     /*  412667 */   // Label 7312: @412667
     /*  412667 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(412744), // Rule ID 21598 //
     /*  412672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412704 */     // MIs[0] Operand 4
     /*  412704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412742 */     GIR_RootConstrainSelectedInstOperands,
     /*  412743 */     // GIR_Coverage, 21598,
     /*  412743 */     GIR_EraseRootFromParent_Done,
     /*  412744 */   // Label 7313: @412744
     /*  412744 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(412821), // Rule ID 21599 //
     /*  412749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412781 */     // MIs[0] Operand 4
     /*  412781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412819 */     GIR_RootConstrainSelectedInstOperands,
     /*  412820 */     // GIR_Coverage, 21599,
     /*  412820 */     GIR_EraseRootFromParent_Done,
     /*  412821 */   // Label 7314: @412821
     /*  412821 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(412898), // Rule ID 21602 //
     /*  412826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412858 */     // MIs[0] Operand 4
     /*  412858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412896 */     GIR_RootConstrainSelectedInstOperands,
     /*  412897 */     // GIR_Coverage, 21602,
     /*  412897 */     GIR_EraseRootFromParent_Done,
     /*  412898 */   // Label 7315: @412898
     /*  412898 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(412975), // Rule ID 21603 //
     /*  412903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412935 */     // MIs[0] Operand 4
     /*  412935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412953 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412973 */     GIR_RootConstrainSelectedInstOperands,
     /*  412974 */     // GIR_Coverage, 21603,
     /*  412974 */     GIR_EraseRootFromParent_Done,
     /*  412975 */   // Label 7316: @412975
     /*  412975 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(413048), // Rule ID 62831 //
     /*  412980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413004 */     // MIs[0] op1
     /*  413004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  413030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413032 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413034 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413036 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413046 */     GIR_RootConstrainSelectedInstOperands,
     /*  413047 */     // GIR_Coverage, 62831,
     /*  413047 */     GIR_EraseRootFromParent_Done,
     /*  413048 */   // Label 7317: @413048
     /*  413048 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(413121), // Rule ID 62832 //
     /*  413053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413077 */     // MIs[0] op1
     /*  413077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413100 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF8),
     /*  413103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413105 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413107 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413109 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413119 */     GIR_RootConstrainSelectedInstOperands,
     /*  413120 */     // GIR_Coverage, 62832,
     /*  413120 */     GIR_EraseRootFromParent_Done,
     /*  413121 */   // Label 7318: @413121
     /*  413121 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(413194), // Rule ID 62855 //
     /*  413126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  413143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413150 */     // MIs[0] op1
     /*  413150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413173 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  413176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413178 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413180 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413182 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413192 */     GIR_RootConstrainSelectedInstOperands,
     /*  413193 */     // GIR_Coverage, 62855,
     /*  413193 */     GIR_EraseRootFromParent_Done,
     /*  413194 */   // Label 7319: @413194
     /*  413194 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(413267), // Rule ID 62856 //
     /*  413199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  413210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  413213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  413216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413223 */     // MIs[0] op1
     /*  413223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF8),
     /*  413249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413265 */     GIR_RootConstrainSelectedInstOperands,
     /*  413266 */     // GIR_Coverage, 62856,
     /*  413266 */     GIR_EraseRootFromParent_Done,
     /*  413267 */   // Label 7320: @413267
     /*  413267 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(413340), // Rule ID 62881 //
     /*  413272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413296 */     // MIs[0] op1
     /*  413296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413319 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413324 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413326 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413328 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413338 */     GIR_RootConstrainSelectedInstOperands,
     /*  413339 */     // GIR_Coverage, 62881,
     /*  413339 */     GIR_EraseRootFromParent_Done,
     /*  413340 */   // Label 7321: @413340
     /*  413340 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(413413), // Rule ID 62882 //
     /*  413345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413369 */     // MIs[0] op1
     /*  413369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413392 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413411 */     GIR_RootConstrainSelectedInstOperands,
     /*  413412 */     // GIR_Coverage, 62882,
     /*  413412 */     GIR_EraseRootFromParent_Done,
     /*  413413 */   // Label 7322: @413413
     /*  413413 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(413486), // Rule ID 62893 //
     /*  413418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413442 */     // MIs[0] op1
     /*  413442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413465 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413484 */     GIR_RootConstrainSelectedInstOperands,
     /*  413485 */     // GIR_Coverage, 62893,
     /*  413485 */     GIR_EraseRootFromParent_Done,
     /*  413486 */   // Label 7323: @413486
     /*  413486 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(413559), // Rule ID 62894 //
     /*  413491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413515 */     // MIs[0] op1
     /*  413515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  413541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413543 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413545 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413547 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413557 */     GIR_RootConstrainSelectedInstOperands,
     /*  413558 */     // GIR_Coverage, 62894,
     /*  413558 */     GIR_EraseRootFromParent_Done,
     /*  413559 */   // Label 7324: @413559
     /*  413559 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(413632), // Rule ID 62925 //
     /*  413564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413588 */     // MIs[0] op1
     /*  413588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413611 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413616 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413618 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413620 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413630 */     GIR_RootConstrainSelectedInstOperands,
     /*  413631 */     // GIR_Coverage, 62925,
     /*  413631 */     GIR_EraseRootFromParent_Done,
     /*  413632 */   // Label 7325: @413632
     /*  413632 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(413705), // Rule ID 62926 //
     /*  413637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413661 */     // MIs[0] op1
     /*  413661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413684 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  413687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413689 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413691 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413693 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413703 */     GIR_RootConstrainSelectedInstOperands,
     /*  413704 */     // GIR_Coverage, 62926,
     /*  413704 */     GIR_EraseRootFromParent_Done,
     /*  413705 */   // Label 7326: @413705
     /*  413705 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(413778), // Rule ID 62937 //
     /*  413710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413734 */     // MIs[0] op1
     /*  413734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413757 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413762 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413764 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413766 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413776 */     GIR_RootConstrainSelectedInstOperands,
     /*  413777 */     // GIR_Coverage, 62937,
     /*  413777 */     GIR_EraseRootFromParent_Done,
     /*  413778 */   // Label 7327: @413778
     /*  413778 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(413851), // Rule ID 62938 //
     /*  413783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413807 */     // MIs[0] op1
     /*  413807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413830 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  413833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413835 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413837 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413839 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413849 */     GIR_RootConstrainSelectedInstOperands,
     /*  413850 */     // GIR_Coverage, 62938,
     /*  413850 */     GIR_EraseRootFromParent_Done,
     /*  413851 */   // Label 7328: @413851
     /*  413851 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(413924), // Rule ID 62969 //
     /*  413856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413880 */     // MIs[0] op1
     /*  413880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413903 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413908 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413910 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413912 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413922 */     GIR_RootConstrainSelectedInstOperands,
     /*  413923 */     // GIR_Coverage, 62969,
     /*  413923 */     GIR_EraseRootFromParent_Done,
     /*  413924 */   // Label 7329: @413924
     /*  413924 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(413997), // Rule ID 62970 //
     /*  413929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413953 */     // MIs[0] op1
     /*  413953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF4),
     /*  413979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413981 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413983 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413985 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413995 */     GIR_RootConstrainSelectedInstOperands,
     /*  413996 */     // GIR_Coverage, 62970,
     /*  413996 */     GIR_EraseRootFromParent_Done,
     /*  413997 */   // Label 7330: @413997
     /*  413997 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(414070), // Rule ID 62981 //
     /*  414002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  414019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414026 */     // MIs[0] op1
     /*  414026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414049 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  414052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414054 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414056 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414058 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414068 */     GIR_RootConstrainSelectedInstOperands,
     /*  414069 */     // GIR_Coverage, 62981,
     /*  414069 */     GIR_EraseRootFromParent_Done,
     /*  414070 */   // Label 7331: @414070
     /*  414070 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(414143), // Rule ID 62982 //
     /*  414075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  414092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414099 */     // MIs[0] op1
     /*  414099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF4),
     /*  414125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414127 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414129 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414131 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414141 */     GIR_RootConstrainSelectedInstOperands,
     /*  414142 */     // GIR_Coverage, 62982,
     /*  414142 */     GIR_EraseRootFromParent_Done,
     /*  414143 */   // Label 7332: @414143
     /*  414143 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(414216), // Rule ID 63005 //
     /*  414148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414172 */     // MIs[0] op1
     /*  414172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  414198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414200 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414202 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414204 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414214 */     GIR_RootConstrainSelectedInstOperands,
     /*  414215 */     // GIR_Coverage, 63005,
     /*  414215 */     GIR_EraseRootFromParent_Done,
     /*  414216 */   // Label 7333: @414216
     /*  414216 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(414289), // Rule ID 63006 //
     /*  414221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414245 */     // MIs[0] op1
     /*  414245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF4),
     /*  414271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414273 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414275 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414277 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414287 */     GIR_RootConstrainSelectedInstOperands,
     /*  414288 */     // GIR_Coverage, 63006,
     /*  414288 */     GIR_EraseRootFromParent_Done,
     /*  414289 */   // Label 7334: @414289
     /*  414289 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(414362), // Rule ID 63025 //
     /*  414294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414318 */     // MIs[0] op1
     /*  414318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414360 */     GIR_RootConstrainSelectedInstOperands,
     /*  414361 */     // GIR_Coverage, 63025,
     /*  414361 */     GIR_EraseRootFromParent_Done,
     /*  414362 */   // Label 7335: @414362
     /*  414362 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(414435), // Rule ID 63026 //
     /*  414367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414391 */     // MIs[0] op1
     /*  414391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414419 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414421 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414423 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414433 */     GIR_RootConstrainSelectedInstOperands,
     /*  414434 */     // GIR_Coverage, 63026,
     /*  414434 */     GIR_EraseRootFromParent_Done,
     /*  414435 */   // Label 7336: @414435
     /*  414435 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(414508), // Rule ID 63037 //
     /*  414440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414464 */     // MIs[0] op1
     /*  414464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414487 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414492 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414494 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414496 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414506 */     GIR_RootConstrainSelectedInstOperands,
     /*  414507 */     // GIR_Coverage, 63037,
     /*  414507 */     GIR_EraseRootFromParent_Done,
     /*  414508 */   // Label 7337: @414508
     /*  414508 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(414581), // Rule ID 63038 //
     /*  414513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414537 */     // MIs[0] op1
     /*  414537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414579 */     GIR_RootConstrainSelectedInstOperands,
     /*  414580 */     // GIR_Coverage, 63038,
     /*  414580 */     GIR_EraseRootFromParent_Done,
     /*  414581 */   // Label 7338: @414581
     /*  414581 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(414654), // Rule ID 63061 //
     /*  414586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414610 */     // MIs[0] op1
     /*  414610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414633 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414652 */     GIR_RootConstrainSelectedInstOperands,
     /*  414653 */     // GIR_Coverage, 63061,
     /*  414653 */     GIR_EraseRootFromParent_Done,
     /*  414654 */   // Label 7339: @414654
     /*  414654 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(414727), // Rule ID 63062 //
     /*  414659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414683 */     // MIs[0] op1
     /*  414683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_MF2),
     /*  414709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414711 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414713 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414715 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414725 */     GIR_RootConstrainSelectedInstOperands,
     /*  414726 */     // GIR_Coverage, 63062,
     /*  414726 */     GIR_EraseRootFromParent_Done,
     /*  414727 */   // Label 7340: @414727
     /*  414727 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(414800), // Rule ID 63081 //
     /*  414732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414756 */     // MIs[0] op1
     /*  414756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414779 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414798 */     GIR_RootConstrainSelectedInstOperands,
     /*  414799 */     // GIR_Coverage, 63081,
     /*  414799 */     GIR_EraseRootFromParent_Done,
     /*  414800 */   // Label 7341: @414800
     /*  414800 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(414873), // Rule ID 63082 //
     /*  414805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414829 */     // MIs[0] op1
     /*  414829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_MF2),
     /*  414855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414857 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414859 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414861 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414871 */     GIR_RootConstrainSelectedInstOperands,
     /*  414872 */     // GIR_Coverage, 63082,
     /*  414872 */     GIR_EraseRootFromParent_Done,
     /*  414873 */   // Label 7342: @414873
     /*  414873 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(414946), // Rule ID 63093 //
     /*  414878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414902 */     // MIs[0] op1
     /*  414902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414925 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  414928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414944 */     GIR_RootConstrainSelectedInstOperands,
     /*  414945 */     // GIR_Coverage, 63093,
     /*  414945 */     GIR_EraseRootFromParent_Done,
     /*  414946 */   // Label 7343: @414946
     /*  414946 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(415019), // Rule ID 63094 //
     /*  414951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414975 */     // MIs[0] op1
     /*  414975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_MF2),
     /*  415001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415003 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415005 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415007 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415017 */     GIR_RootConstrainSelectedInstOperands,
     /*  415018 */     // GIR_Coverage, 63094,
     /*  415018 */     GIR_EraseRootFromParent_Done,
     /*  415019 */   // Label 7344: @415019
     /*  415019 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(415092), // Rule ID 63117 //
     /*  415024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415048 */     // MIs[0] op1
     /*  415048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415071 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  415074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415076 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415078 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415080 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415090 */     GIR_RootConstrainSelectedInstOperands,
     /*  415091 */     // GIR_Coverage, 63117,
     /*  415091 */     GIR_EraseRootFromParent_Done,
     /*  415092 */   // Label 7345: @415092
     /*  415092 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(415165), // Rule ID 63118 //
     /*  415097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415121 */     // MIs[0] op1
     /*  415121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_MF2),
     /*  415147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415149 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415151 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415153 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415163 */     GIR_RootConstrainSelectedInstOperands,
     /*  415164 */     // GIR_Coverage, 63118,
     /*  415164 */     GIR_EraseRootFromParent_Done,
     /*  415165 */   // Label 7346: @415165
     /*  415165 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(415238), // Rule ID 63137 //
     /*  415170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415194 */     // MIs[0] op1
     /*  415194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415217 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415222 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415224 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415226 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415236 */     GIR_RootConstrainSelectedInstOperands,
     /*  415237 */     // GIR_Coverage, 63137,
     /*  415237 */     GIR_EraseRootFromParent_Done,
     /*  415238 */   // Label 7347: @415238
     /*  415238 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(415311), // Rule ID 63138 //
     /*  415243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415267 */     // MIs[0] op1
     /*  415267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  415290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415295 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415297 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415299 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415309 */     GIR_RootConstrainSelectedInstOperands,
     /*  415310 */     // GIR_Coverage, 63138,
     /*  415310 */     GIR_EraseRootFromParent_Done,
     /*  415311 */   // Label 7348: @415311
     /*  415311 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(415384), // Rule ID 63149 //
     /*  415316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  415333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415340 */     // MIs[0] op1
     /*  415340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415363 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415368 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415370 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415372 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415382 */     GIR_RootConstrainSelectedInstOperands,
     /*  415383 */     // GIR_Coverage, 63149,
     /*  415383 */     GIR_EraseRootFromParent_Done,
     /*  415384 */   // Label 7349: @415384
     /*  415384 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(415457), // Rule ID 63150 //
     /*  415389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  415400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  415403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  415406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415413 */     // MIs[0] op1
     /*  415413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  415436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415441 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415443 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415445 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415455 */     GIR_RootConstrainSelectedInstOperands,
     /*  415456 */     // GIR_Coverage, 63150,
     /*  415456 */     GIR_EraseRootFromParent_Done,
     /*  415457 */   // Label 7350: @415457
     /*  415457 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(415530), // Rule ID 63181 //
     /*  415462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415486 */     // MIs[0] op1
     /*  415486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415514 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415516 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415518 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415528 */     GIR_RootConstrainSelectedInstOperands,
     /*  415529 */     // GIR_Coverage, 63181,
     /*  415529 */     GIR_EraseRootFromParent_Done,
     /*  415530 */   // Label 7351: @415530
     /*  415530 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(415603), // Rule ID 63182 //
     /*  415535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415559 */     // MIs[0] op1
     /*  415559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415587 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415589 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415591 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415601 */     GIR_RootConstrainSelectedInstOperands,
     /*  415602 */     // GIR_Coverage, 63182,
     /*  415602 */     GIR_EraseRootFromParent_Done,
     /*  415603 */   // Label 7352: @415603
     /*  415603 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(415676), // Rule ID 63193 //
     /*  415608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415632 */     // MIs[0] op1
     /*  415632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415655 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415674 */     GIR_RootConstrainSelectedInstOperands,
     /*  415675 */     // GIR_Coverage, 63193,
     /*  415675 */     GIR_EraseRootFromParent_Done,
     /*  415676 */   // Label 7353: @415676
     /*  415676 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(415749), // Rule ID 63194 //
     /*  415681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415705 */     // MIs[0] op1
     /*  415705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  415731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415733 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415735 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415737 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415747 */     GIR_RootConstrainSelectedInstOperands,
     /*  415748 */     // GIR_Coverage, 63194,
     /*  415748 */     GIR_EraseRootFromParent_Done,
     /*  415749 */   // Label 7354: @415749
     /*  415749 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(415822), // Rule ID 63217 //
     /*  415754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415778 */     // MIs[0] op1
     /*  415778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415801 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415820 */     GIR_RootConstrainSelectedInstOperands,
     /*  415821 */     // GIR_Coverage, 63217,
     /*  415821 */     GIR_EraseRootFromParent_Done,
     /*  415822 */   // Label 7355: @415822
     /*  415822 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(415895), // Rule ID 63218 //
     /*  415827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415851 */     // MIs[0] op1
     /*  415851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M1),
     /*  415877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415879 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415881 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415883 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415893 */     GIR_RootConstrainSelectedInstOperands,
     /*  415894 */     // GIR_Coverage, 63218,
     /*  415894 */     GIR_EraseRootFromParent_Done,
     /*  415895 */   // Label 7356: @415895
     /*  415895 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(415968), // Rule ID 63237 //
     /*  415900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415924 */     // MIs[0] op1
     /*  415924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415947 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  415950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415952 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415954 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415956 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415966 */     GIR_RootConstrainSelectedInstOperands,
     /*  415967 */     // GIR_Coverage, 63237,
     /*  415967 */     GIR_EraseRootFromParent_Done,
     /*  415968 */   // Label 7357: @415968
     /*  415968 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(416041), // Rule ID 63238 //
     /*  415973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415997 */     // MIs[0] op1
     /*  415997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416025 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416027 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416029 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416039 */     GIR_RootConstrainSelectedInstOperands,
     /*  416040 */     // GIR_Coverage, 63238,
     /*  416040 */     GIR_EraseRootFromParent_Done,
     /*  416041 */   // Label 7358: @416041
     /*  416041 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(416114), // Rule ID 63249 //
     /*  416046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  416063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416070 */     // MIs[0] op1
     /*  416070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  416093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416098 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416100 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416102 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416112 */     GIR_RootConstrainSelectedInstOperands,
     /*  416113 */     // GIR_Coverage, 63249,
     /*  416113 */     GIR_EraseRootFromParent_Done,
     /*  416114 */   // Label 7359: @416114
     /*  416114 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(416187), // Rule ID 63250 //
     /*  416119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  416136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416143 */     // MIs[0] op1
     /*  416143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416171 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416173 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416175 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416185 */     GIR_RootConstrainSelectedInstOperands,
     /*  416186 */     // GIR_Coverage, 63250,
     /*  416186 */     GIR_EraseRootFromParent_Done,
     /*  416187 */   // Label 7360: @416187
     /*  416187 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(416260), // Rule ID 63273 //
     /*  416192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416216 */     // MIs[0] op1
     /*  416216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  416232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416239 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  416239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  416242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416244 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416246 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416248 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416258 */     GIR_RootConstrainSelectedInstOperands,
     /*  416259 */     // GIR_Coverage, 63273,
     /*  416259 */     GIR_EraseRootFromParent_Done,
     /*  416260 */   // Label 7361: @416260
     /*  416260 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(416333), // Rule ID 63274 //
     /*  416265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  416276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  416279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416289 */     // MIs[0] op1
     /*  416289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  416305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  416312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M1),
     /*  416315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416317 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416319 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416321 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416331 */     GIR_RootConstrainSelectedInstOperands,
     /*  416332 */     // GIR_Coverage, 63274,
     /*  416332 */     GIR_EraseRootFromParent_Done,
     /*  416333 */   // Label 7362: @416333
     /*  416333 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(416406), // Rule ID 63293 //
     /*  416338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416362 */     // MIs[0] op1
     /*  416362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416385 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416390 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416392 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416394 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416404 */     GIR_RootConstrainSelectedInstOperands,
     /*  416405 */     // GIR_Coverage, 63293,
     /*  416405 */     GIR_EraseRootFromParent_Done,
     /*  416406 */   // Label 7363: @416406
     /*  416406 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(416479), // Rule ID 63294 //
     /*  416411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416435 */     // MIs[0] op1
     /*  416435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M1),
     /*  416461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416463 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416465 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416467 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416477 */     GIR_RootConstrainSelectedInstOperands,
     /*  416478 */     // GIR_Coverage, 63294,
     /*  416478 */     GIR_EraseRootFromParent_Done,
     /*  416479 */   // Label 7364: @416479
     /*  416479 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(416552), // Rule ID 63305 //
     /*  416484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416508 */     // MIs[0] op1
     /*  416508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416531 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416536 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416538 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416540 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416550 */     GIR_RootConstrainSelectedInstOperands,
     /*  416551 */     // GIR_Coverage, 63305,
     /*  416551 */     GIR_EraseRootFromParent_Done,
     /*  416552 */   // Label 7365: @416552
     /*  416552 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(416625), // Rule ID 63306 //
     /*  416557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416581 */     // MIs[0] op1
     /*  416581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M1),
     /*  416607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416609 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416611 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416613 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416623 */     GIR_RootConstrainSelectedInstOperands,
     /*  416624 */     // GIR_Coverage, 63306,
     /*  416624 */     GIR_EraseRootFromParent_Done,
     /*  416625 */   // Label 7366: @416625
     /*  416625 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(416698), // Rule ID 63329 //
     /*  416630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416654 */     // MIs[0] op1
     /*  416654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416682 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416684 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416686 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416696 */     GIR_RootConstrainSelectedInstOperands,
     /*  416697 */     // GIR_Coverage, 63329,
     /*  416697 */     GIR_EraseRootFromParent_Done,
     /*  416698 */   // Label 7367: @416698
     /*  416698 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(416771), // Rule ID 63330 //
     /*  416703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416727 */     // MIs[0] op1
     /*  416727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M1),
     /*  416753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416755 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416757 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416759 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416769 */     GIR_RootConstrainSelectedInstOperands,
     /*  416770 */     // GIR_Coverage, 63330,
     /*  416770 */     GIR_EraseRootFromParent_Done,
     /*  416771 */   // Label 7368: @416771
     /*  416771 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(416844), // Rule ID 63349 //
     /*  416776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416800 */     // MIs[0] op1
     /*  416800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416828 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416830 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416832 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416842 */     GIR_RootConstrainSelectedInstOperands,
     /*  416843 */     // GIR_Coverage, 63349,
     /*  416843 */     GIR_EraseRootFromParent_Done,
     /*  416844 */   // Label 7369: @416844
     /*  416844 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(416917), // Rule ID 63350 //
     /*  416849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416873 */     // MIs[0] op1
     /*  416873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  416899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416915 */     GIR_RootConstrainSelectedInstOperands,
     /*  416916 */     // GIR_Coverage, 63350,
     /*  416916 */     GIR_EraseRootFromParent_Done,
     /*  416917 */   // Label 7370: @416917
     /*  416917 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(416990), // Rule ID 63361 //
     /*  416922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416946 */     // MIs[0] op1
     /*  416946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416969 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  416972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416988 */     GIR_RootConstrainSelectedInstOperands,
     /*  416989 */     // GIR_Coverage, 63361,
     /*  416989 */     GIR_EraseRootFromParent_Done,
     /*  416990 */   // Label 7371: @416990
     /*  416990 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(417063), // Rule ID 63362 //
     /*  416995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  417006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  417009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  417012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417019 */     // MIs[0] op1
     /*  417019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417061 */     GIR_RootConstrainSelectedInstOperands,
     /*  417062 */     // GIR_Coverage, 63362,
     /*  417062 */     GIR_EraseRootFromParent_Done,
     /*  417063 */   // Label 7372: @417063
     /*  417063 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(417136), // Rule ID 63393 //
     /*  417068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417092 */     // MIs[0] op1
     /*  417092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417115 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417120 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417122 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417124 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417134 */     GIR_RootConstrainSelectedInstOperands,
     /*  417135 */     // GIR_Coverage, 63393,
     /*  417135 */     GIR_EraseRootFromParent_Done,
     /*  417136 */   // Label 7373: @417136
     /*  417136 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(417209), // Rule ID 63394 //
     /*  417141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417165 */     // MIs[0] op1
     /*  417165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  417191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417193 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417195 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417197 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417207 */     GIR_RootConstrainSelectedInstOperands,
     /*  417208 */     // GIR_Coverage, 63394,
     /*  417208 */     GIR_EraseRootFromParent_Done,
     /*  417209 */   // Label 7374: @417209
     /*  417209 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(417282), // Rule ID 63405 //
     /*  417214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  417231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417238 */     // MIs[0] op1
     /*  417238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417261 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417280 */     GIR_RootConstrainSelectedInstOperands,
     /*  417281 */     // GIR_Coverage, 63405,
     /*  417281 */     GIR_EraseRootFromParent_Done,
     /*  417282 */   // Label 7375: @417282
     /*  417282 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(417355), // Rule ID 63406 //
     /*  417287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  417298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  417301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  417304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417311 */     // MIs[0] op1
     /*  417311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  417337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417339 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417341 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417343 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417353 */     GIR_RootConstrainSelectedInstOperands,
     /*  417354 */     // GIR_Coverage, 63406,
     /*  417354 */     GIR_EraseRootFromParent_Done,
     /*  417355 */   // Label 7376: @417355
     /*  417355 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(417428), // Rule ID 63437 //
     /*  417360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417384 */     // MIs[0] op1
     /*  417384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417407 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  417410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417412 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417414 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417416 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417426 */     GIR_RootConstrainSelectedInstOperands,
     /*  417427 */     // GIR_Coverage, 63437,
     /*  417427 */     GIR_EraseRootFromParent_Done,
     /*  417428 */   // Label 7377: @417428
     /*  417428 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(417501), // Rule ID 63438 //
     /*  417433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417457 */     // MIs[0] op1
     /*  417457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  417483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417485 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417487 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417489 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417499 */     GIR_RootConstrainSelectedInstOperands,
     /*  417500 */     // GIR_Coverage, 63438,
     /*  417500 */     GIR_EraseRootFromParent_Done,
     /*  417501 */   // Label 7378: @417501
     /*  417501 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(417574), // Rule ID 63449 //
     /*  417506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417530 */     // MIs[0] op1
     /*  417530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417553 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417558 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417560 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417562 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417572 */     GIR_RootConstrainSelectedInstOperands,
     /*  417573 */     // GIR_Coverage, 63449,
     /*  417573 */     GIR_EraseRootFromParent_Done,
     /*  417574 */   // Label 7379: @417574
     /*  417574 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(417647), // Rule ID 63450 //
     /*  417579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417603 */     // MIs[0] op1
     /*  417603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  417629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417631 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417633 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417635 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417645 */     GIR_RootConstrainSelectedInstOperands,
     /*  417646 */     // GIR_Coverage, 63450,
     /*  417646 */     GIR_EraseRootFromParent_Done,
     /*  417647 */   // Label 7380: @417647
     /*  417647 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(417720), // Rule ID 63481 //
     /*  417652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417676 */     // MIs[0] op1
     /*  417676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417704 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417706 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417708 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417718 */     GIR_RootConstrainSelectedInstOperands,
     /*  417719 */     // GIR_Coverage, 63481,
     /*  417719 */     GIR_EraseRootFromParent_Done,
     /*  417720 */   // Label 7381: @417720
     /*  417720 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(417793), // Rule ID 63482 //
     /*  417725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417749 */     // MIs[0] op1
     /*  417749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  417775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417777 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417779 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417781 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417791 */     GIR_RootConstrainSelectedInstOperands,
     /*  417792 */     // GIR_Coverage, 63482,
     /*  417792 */     GIR_EraseRootFromParent_Done,
     /*  417793 */   // Label 7382: @417793
     /*  417793 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(417866), // Rule ID 63493 //
     /*  417798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417822 */     // MIs[0] op1
     /*  417822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417850 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417852 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417854 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417864 */     GIR_RootConstrainSelectedInstOperands,
     /*  417865 */     // GIR_Coverage, 63493,
     /*  417865 */     GIR_EraseRootFromParent_Done,
     /*  417866 */   // Label 7383: @417866
     /*  417866 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(417939), // Rule ID 63494 //
     /*  417871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417895 */     // MIs[0] op1
     /*  417895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  417921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417923 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417925 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417927 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417937 */     GIR_RootConstrainSelectedInstOperands,
     /*  417938 */     // GIR_Coverage, 63494,
     /*  417938 */     GIR_EraseRootFromParent_Done,
     /*  417939 */   // Label 7384: @417939
     /*  417939 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(418012), // Rule ID 63517 //
     /*  417944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417968 */     // MIs[0] op1
     /*  417968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  417994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417996 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417998 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418000 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418010 */     GIR_RootConstrainSelectedInstOperands,
     /*  418011 */     // GIR_Coverage, 63517,
     /*  418011 */     GIR_EraseRootFromParent_Done,
     /*  418012 */   // Label 7385: @418012
     /*  418012 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(418085), // Rule ID 63518 //
     /*  418017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  418028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  418031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418041 */     // MIs[0] op1
     /*  418041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M2),
     /*  418067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418069 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418071 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418073 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418083 */     GIR_RootConstrainSelectedInstOperands,
     /*  418084 */     // GIR_Coverage, 63518,
     /*  418084 */     GIR_EraseRootFromParent_Done,
     /*  418085 */   // Label 7386: @418085
     /*  418085 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(418158), // Rule ID 63537 //
     /*  418090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418114 */     // MIs[0] op1
     /*  418114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418137 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  418140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418156 */     GIR_RootConstrainSelectedInstOperands,
     /*  418157 */     // GIR_Coverage, 63537,
     /*  418157 */     GIR_EraseRootFromParent_Done,
     /*  418158 */   // Label 7387: @418158
     /*  418158 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(418231), // Rule ID 63538 //
     /*  418163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418187 */     // MIs[0] op1
     /*  418187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  418213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418229 */     GIR_RootConstrainSelectedInstOperands,
     /*  418230 */     // GIR_Coverage, 63538,
     /*  418230 */     GIR_EraseRootFromParent_Done,
     /*  418231 */   // Label 7388: @418231
     /*  418231 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(418304), // Rule ID 63549 //
     /*  418236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  418253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418260 */     // MIs[0] op1
     /*  418260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418283 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  418286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418302 */     GIR_RootConstrainSelectedInstOperands,
     /*  418303 */     // GIR_Coverage, 63549,
     /*  418303 */     GIR_EraseRootFromParent_Done,
     /*  418304 */   // Label 7389: @418304
     /*  418304 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(418377), // Rule ID 63550 //
     /*  418309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  418326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418333 */     // MIs[0] op1
     /*  418333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  418359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418375 */     GIR_RootConstrainSelectedInstOperands,
     /*  418376 */     // GIR_Coverage, 63550,
     /*  418376 */     GIR_EraseRootFromParent_Done,
     /*  418377 */   // Label 7390: @418377
     /*  418377 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(418450), // Rule ID 63573 //
     /*  418382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418406 */     // MIs[0] op1
     /*  418406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418429 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  418432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418434 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418436 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418438 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418448 */     GIR_RootConstrainSelectedInstOperands,
     /*  418449 */     // GIR_Coverage, 63573,
     /*  418449 */     GIR_EraseRootFromParent_Done,
     /*  418450 */   // Label 7391: @418450
     /*  418450 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(418523), // Rule ID 63574 //
     /*  418455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418479 */     // MIs[0] op1
     /*  418479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M4),
     /*  418505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418507 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418509 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418511 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418521 */     GIR_RootConstrainSelectedInstOperands,
     /*  418522 */     // GIR_Coverage, 63574,
     /*  418522 */     GIR_EraseRootFromParent_Done,
     /*  418523 */   // Label 7392: @418523
     /*  418523 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(418596), // Rule ID 63593 //
     /*  418528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418552 */     // MIs[0] op1
     /*  418552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418575 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418580 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418582 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418584 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418594 */     GIR_RootConstrainSelectedInstOperands,
     /*  418595 */     // GIR_Coverage, 63593,
     /*  418595 */     GIR_EraseRootFromParent_Done,
     /*  418596 */   // Label 7393: @418596
     /*  418596 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(418669), // Rule ID 63594 //
     /*  418601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418625 */     // MIs[0] op1
     /*  418625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  418651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418653 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418655 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418657 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418667 */     GIR_RootConstrainSelectedInstOperands,
     /*  418668 */     // GIR_Coverage, 63594,
     /*  418668 */     GIR_EraseRootFromParent_Done,
     /*  418669 */   // Label 7394: @418669
     /*  418669 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(418742), // Rule ID 63605 //
     /*  418674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418698 */     // MIs[0] op1
     /*  418698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418726 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418728 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418730 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418740 */     GIR_RootConstrainSelectedInstOperands,
     /*  418741 */     // GIR_Coverage, 63605,
     /*  418741 */     GIR_EraseRootFromParent_Done,
     /*  418742 */   // Label 7395: @418742
     /*  418742 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(418815), // Rule ID 63606 //
     /*  418747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418771 */     // MIs[0] op1
     /*  418771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  418797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418799 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418801 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418803 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418813 */     GIR_RootConstrainSelectedInstOperands,
     /*  418814 */     // GIR_Coverage, 63606,
     /*  418814 */     GIR_EraseRootFromParent_Done,
     /*  418815 */   // Label 7396: @418815
     /*  418815 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(418888), // Rule ID 63629 //
     /*  418820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418844 */     // MIs[0] op1
     /*  418844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418867 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418872 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418874 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418876 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418886 */     GIR_RootConstrainSelectedInstOperands,
     /*  418887 */     // GIR_Coverage, 63629,
     /*  418887 */     GIR_EraseRootFromParent_Done,
     /*  418888 */   // Label 7397: @418888
     /*  418888 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(418961), // Rule ID 63630 //
     /*  418893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418917 */     // MIs[0] op1
     /*  418917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418940 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16V_M8),
     /*  418943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418945 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418947 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418949 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418959 */     GIR_RootConstrainSelectedInstOperands,
     /*  418960 */     // GIR_Coverage, 63630,
     /*  418960 */     GIR_EraseRootFromParent_Done,
     /*  418961 */   // Label 7398: @418961
     /*  418961 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(419034), // Rule ID 63649 //
     /*  418966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418990 */     // MIs[0] op1
     /*  418990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419032 */     GIR_RootConstrainSelectedInstOperands,
     /*  419033 */     // GIR_Coverage, 63649,
     /*  419033 */     GIR_EraseRootFromParent_Done,
     /*  419034 */   // Label 7399: @419034
     /*  419034 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(419107), // Rule ID 63650 //
     /*  419039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419063 */     // MIs[0] op1
     /*  419063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  419089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419091 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419093 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419095 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419105 */     GIR_RootConstrainSelectedInstOperands,
     /*  419106 */     // GIR_Coverage, 63650,
     /*  419106 */     GIR_EraseRootFromParent_Done,
     /*  419107 */   // Label 7400: @419107
     /*  419107 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(419180), // Rule ID 63661 //
     /*  419112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  419129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419136 */     // MIs[0] op1
     /*  419136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  419162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419164 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419166 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419168 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419178 */     GIR_RootConstrainSelectedInstOperands,
     /*  419179 */     // GIR_Coverage, 63661,
     /*  419179 */     GIR_EraseRootFromParent_Done,
     /*  419180 */   // Label 7401: @419180
     /*  419180 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(419253), // Rule ID 63662 //
     /*  419185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  419202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419209 */     // MIs[0] op1
     /*  419209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  419235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419237 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419239 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419241 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419251 */     GIR_RootConstrainSelectedInstOperands,
     /*  419252 */     // GIR_Coverage, 63662,
     /*  419252 */     GIR_EraseRootFromParent_Done,
     /*  419253 */   // Label 7402: @419253
     /*  419253 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(419326), // Rule ID 63685 //
     /*  419258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419282 */     // MIs[0] op1
     /*  419282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  419308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419324 */     GIR_RootConstrainSelectedInstOperands,
     /*  419325 */     // GIR_Coverage, 63685,
     /*  419325 */     GIR_EraseRootFromParent_Done,
     /*  419326 */   // Label 7403: @419326
     /*  419326 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(419399), // Rule ID 63686 //
     /*  419331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  419342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  419345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419355 */     // MIs[0] op1
     /*  419355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M2),
     /*  419381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419397 */     GIR_RootConstrainSelectedInstOperands,
     /*  419398 */     // GIR_Coverage, 63686,
     /*  419398 */     GIR_EraseRootFromParent_Done,
     /*  419399 */   // Label 7404: @419399
     /*  419399 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(419472), // Rule ID 63705 //
     /*  419404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419428 */     // MIs[0] op1
     /*  419428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419470 */     GIR_RootConstrainSelectedInstOperands,
     /*  419471 */     // GIR_Coverage, 63705,
     /*  419471 */     GIR_EraseRootFromParent_Done,
     /*  419472 */   // Label 7405: @419472
     /*  419472 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(419545), // Rule ID 63706 //
     /*  419477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419501 */     // MIs[0] op1
     /*  419501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  419527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419529 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419531 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419533 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419543 */     GIR_RootConstrainSelectedInstOperands,
     /*  419544 */     // GIR_Coverage, 63706,
     /*  419544 */     GIR_EraseRootFromParent_Done,
     /*  419545 */   // Label 7406: @419545
     /*  419545 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(419618), // Rule ID 63717 //
     /*  419550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419574 */     // MIs[0] op1
     /*  419574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419597 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419616 */     GIR_RootConstrainSelectedInstOperands,
     /*  419617 */     // GIR_Coverage, 63717,
     /*  419617 */     GIR_EraseRootFromParent_Done,
     /*  419618 */   // Label 7407: @419618
     /*  419618 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(419691), // Rule ID 63718 //
     /*  419623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419647 */     // MIs[0] op1
     /*  419647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  419673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419675 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419677 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419679 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419689 */     GIR_RootConstrainSelectedInstOperands,
     /*  419690 */     // GIR_Coverage, 63718,
     /*  419690 */     GIR_EraseRootFromParent_Done,
     /*  419691 */   // Label 7408: @419691
     /*  419691 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(419764), // Rule ID 63741 //
     /*  419696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419720 */     // MIs[0] op1
     /*  419720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419748 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419750 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419752 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419762 */     GIR_RootConstrainSelectedInstOperands,
     /*  419763 */     // GIR_Coverage, 63741,
     /*  419763 */     GIR_EraseRootFromParent_Done,
     /*  419764 */   // Label 7409: @419764
     /*  419764 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(419837), // Rule ID 63742 //
     /*  419769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419793 */     // MIs[0] op1
     /*  419793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M4),
     /*  419819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419821 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419823 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419825 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419835 */     GIR_RootConstrainSelectedInstOperands,
     /*  419836 */     // GIR_Coverage, 63742,
     /*  419836 */     GIR_EraseRootFromParent_Done,
     /*  419837 */   // Label 7410: @419837
     /*  419837 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(419910), // Rule ID 63761 //
     /*  419842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419866 */     // MIs[0] op1
     /*  419866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419889 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419894 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419896 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419898 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419908 */     GIR_RootConstrainSelectedInstOperands,
     /*  419909 */     // GIR_Coverage, 63761,
     /*  419909 */     GIR_EraseRootFromParent_Done,
     /*  419910 */   // Label 7411: @419910
     /*  419910 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(419983), // Rule ID 63762 //
     /*  419915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419939 */     // MIs[0] op1
     /*  419939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  419965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419967 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419969 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419971 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419981 */     GIR_RootConstrainSelectedInstOperands,
     /*  419982 */     // GIR_Coverage, 63762,
     /*  419982 */     GIR_EraseRootFromParent_Done,
     /*  419983 */   // Label 7412: @419983
     /*  419983 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(420056), // Rule ID 63773 //
     /*  419988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  420005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420012 */     // MIs[0] op1
     /*  420012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420035 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  420035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420040 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420042 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420044 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420054 */     GIR_RootConstrainSelectedInstOperands,
     /*  420055 */     // GIR_Coverage, 63773,
     /*  420055 */     GIR_EraseRootFromParent_Done,
     /*  420056 */   // Label 7413: @420056
     /*  420056 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(420129), // Rule ID 63774 //
     /*  420061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  420078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420085 */     // MIs[0] op1
     /*  420085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  420108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  420111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420113 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420115 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420117 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420127 */     GIR_RootConstrainSelectedInstOperands,
     /*  420128 */     // GIR_Coverage, 63774,
     /*  420128 */     GIR_EraseRootFromParent_Done,
     /*  420129 */   // Label 7414: @420129
     /*  420129 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(420202), // Rule ID 63797 //
     /*  420134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420158 */     // MIs[0] op1
     /*  420158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  420174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420181 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  420181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  420184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420200 */     GIR_RootConstrainSelectedInstOperands,
     /*  420201 */     // GIR_Coverage, 63797,
     /*  420201 */     GIR_EraseRootFromParent_Done,
     /*  420202 */   // Label 7415: @420202
     /*  420202 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(420275), // Rule ID 63798 //
     /*  420207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  420218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  420221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420231 */     // MIs[0] op1
     /*  420231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  420247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  420254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32V_M8),
     /*  420257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420259 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420261 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420263 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  420273 */     GIR_RootConstrainSelectedInstOperands,
     /*  420274 */     // GIR_Coverage, 63798,
     /*  420274 */     GIR_EraseRootFromParent_Done,
     /*  420275 */   // Label 7416: @420275
     /*  420275 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(420348), // Rule ID 63817 //
     /*  420280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420304 */     // MIs[0] op1
     /*  420304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  420330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420346 */     GIR_RootConstrainSelectedInstOperands,
     /*  420347 */     // GIR_Coverage, 63817,
     /*  420347 */     GIR_EraseRootFromParent_Done,
     /*  420348 */   // Label 7417: @420348
     /*  420348 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(420421), // Rule ID 63818 //
     /*  420353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420377 */     // MIs[0] op1
     /*  420377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M2),
     /*  420403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420405 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420407 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420409 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420419 */     GIR_RootConstrainSelectedInstOperands,
     /*  420420 */     // GIR_Coverage, 63818,
     /*  420420 */     GIR_EraseRootFromParent_Done,
     /*  420421 */   // Label 7418: @420421
     /*  420421 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(420494), // Rule ID 63829 //
     /*  420426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420450 */     // MIs[0] op1
     /*  420450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420492 */     GIR_RootConstrainSelectedInstOperands,
     /*  420493 */     // GIR_Coverage, 63829,
     /*  420493 */     GIR_EraseRootFromParent_Done,
     /*  420494 */   // Label 7419: @420494
     /*  420494 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(420567), // Rule ID 63830 //
     /*  420499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420523 */     // MIs[0] op1
     /*  420523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M2),
     /*  420549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420551 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420553 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420555 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420565 */     GIR_RootConstrainSelectedInstOperands,
     /*  420566 */     // GIR_Coverage, 63830,
     /*  420566 */     GIR_EraseRootFromParent_Done,
     /*  420567 */   // Label 7420: @420567
     /*  420567 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(420640), // Rule ID 63853 //
     /*  420572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420596 */     // MIs[0] op1
     /*  420596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420638 */     GIR_RootConstrainSelectedInstOperands,
     /*  420639 */     // GIR_Coverage, 63853,
     /*  420639 */     GIR_EraseRootFromParent_Done,
     /*  420640 */   // Label 7421: @420640
     /*  420640 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(420713), // Rule ID 63854 //
     /*  420645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420669 */     // MIs[0] op1
     /*  420669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M2),
     /*  420695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420711 */     GIR_RootConstrainSelectedInstOperands,
     /*  420712 */     // GIR_Coverage, 63854,
     /*  420712 */     GIR_EraseRootFromParent_Done,
     /*  420713 */   // Label 7422: @420713
     /*  420713 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(420786), // Rule ID 63873 //
     /*  420718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420742 */     // MIs[0] op1
     /*  420742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420765 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420770 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420772 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420774 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420784 */     GIR_RootConstrainSelectedInstOperands,
     /*  420785 */     // GIR_Coverage, 63873,
     /*  420785 */     GIR_EraseRootFromParent_Done,
     /*  420786 */   // Label 7423: @420786
     /*  420786 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(420859), // Rule ID 63874 //
     /*  420791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420815 */     // MIs[0] op1
     /*  420815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M4),
     /*  420841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420857 */     GIR_RootConstrainSelectedInstOperands,
     /*  420858 */     // GIR_Coverage, 63874,
     /*  420858 */     GIR_EraseRootFromParent_Done,
     /*  420859 */   // Label 7424: @420859
     /*  420859 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(420932), // Rule ID 63885 //
     /*  420864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420888 */     // MIs[0] op1
     /*  420888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420911 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420930 */     GIR_RootConstrainSelectedInstOperands,
     /*  420931 */     // GIR_Coverage, 63885,
     /*  420931 */     GIR_EraseRootFromParent_Done,
     /*  420932 */   // Label 7425: @420932
     /*  420932 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(421005), // Rule ID 63886 //
     /*  420937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420961 */     // MIs[0] op1
     /*  420961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M4),
     /*  420987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421003 */     GIR_RootConstrainSelectedInstOperands,
     /*  421004 */     // GIR_Coverage, 63886,
     /*  421004 */     GIR_EraseRootFromParent_Done,
     /*  421005 */   // Label 7426: @421005
     /*  421005 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(421078), // Rule ID 63909 //
     /*  421010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421034 */     // MIs[0] op1
     /*  421034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421057 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  421060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421062 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421064 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421066 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421076 */     GIR_RootConstrainSelectedInstOperands,
     /*  421077 */     // GIR_Coverage, 63909,
     /*  421077 */     GIR_EraseRootFromParent_Done,
     /*  421078 */   // Label 7427: @421078
     /*  421078 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(421151), // Rule ID 63910 //
     /*  421083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  421094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  421097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421107 */     // MIs[0] op1
     /*  421107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421130 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M4),
     /*  421133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421135 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421137 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421139 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421149 */     GIR_RootConstrainSelectedInstOperands,
     /*  421150 */     // GIR_Coverage, 63910,
     /*  421150 */     GIR_EraseRootFromParent_Done,
     /*  421151 */   // Label 7428: @421151
     /*  421151 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(421224), // Rule ID 63929 //
     /*  421156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421180 */     // MIs[0] op1
     /*  421180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421203 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  421206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421208 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421210 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421212 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421222 */     GIR_RootConstrainSelectedInstOperands,
     /*  421223 */     // GIR_Coverage, 63929,
     /*  421223 */     GIR_EraseRootFromParent_Done,
     /*  421224 */   // Label 7429: @421224
     /*  421224 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(421297), // Rule ID 63930 //
     /*  421229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421253 */     // MIs[0] op1
     /*  421253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XV_M8),
     /*  421279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421281 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421283 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421285 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421295 */     GIR_RootConstrainSelectedInstOperands,
     /*  421296 */     // GIR_Coverage, 63930,
     /*  421296 */     GIR_EraseRootFromParent_Done,
     /*  421297 */   // Label 7430: @421297
     /*  421297 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(421370), // Rule ID 63941 //
     /*  421302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  421319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421326 */     // MIs[0] op1
     /*  421326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  421352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421354 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421356 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421358 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421368 */     GIR_RootConstrainSelectedInstOperands,
     /*  421369 */     // GIR_Coverage, 63941,
     /*  421369 */     GIR_EraseRootFromParent_Done,
     /*  421370 */   // Label 7431: @421370
     /*  421370 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(421443), // Rule ID 63942 //
     /*  421375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  421392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421399 */     // MIs[0] op1
     /*  421399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421422 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VV_M8),
     /*  421425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421427 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421429 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421431 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421441 */     GIR_RootConstrainSelectedInstOperands,
     /*  421442 */     // GIR_Coverage, 63942,
     /*  421442 */     GIR_EraseRootFromParent_Done,
     /*  421443 */   // Label 7432: @421443
     /*  421443 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(421516), // Rule ID 63965 //
     /*  421448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421472 */     // MIs[0] op1
     /*  421472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421495 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421500 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421502 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421504 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421514 */     GIR_RootConstrainSelectedInstOperands,
     /*  421515 */     // GIR_Coverage, 63965,
     /*  421515 */     GIR_EraseRootFromParent_Done,
     /*  421516 */   // Label 7433: @421516
     /*  421516 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(421589), // Rule ID 63966 //
     /*  421521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421545 */     // MIs[0] op1
     /*  421545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64V_M8),
     /*  421571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421573 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421575 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421577 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421587 */     GIR_RootConstrainSelectedInstOperands,
     /*  421588 */     // GIR_Coverage, 63966,
     /*  421588 */     GIR_EraseRootFromParent_Done,
     /*  421589 */   // Label 7434: @421589
     /*  421589 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(421672), // Rule ID 5338 //
     /*  421594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421637 */     // MIs[1] Operand 1
     /*  421637 */     // No operand predicates
     /*  421637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421650 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421670 */     GIR_RootConstrainSelectedInstOperands,
     /*  421671 */     // GIR_Coverage, 5338,
     /*  421671 */     GIR_EraseRootFromParent_Done,
     /*  421672 */   // Label 7435: @421672
     /*  421672 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(421755), // Rule ID 5339 //
     /*  421677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421720 */     // MIs[1] Operand 1
     /*  421720 */     // No operand predicates
     /*  421720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421733 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421753 */     GIR_RootConstrainSelectedInstOperands,
     /*  421754 */     // GIR_Coverage, 5339,
     /*  421754 */     GIR_EraseRootFromParent_Done,
     /*  421755 */   // Label 7436: @421755
     /*  421755 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(421838), // Rule ID 5340 //
     /*  421760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421803 */     // MIs[1] Operand 1
     /*  421803 */     // No operand predicates
     /*  421803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421836 */     GIR_RootConstrainSelectedInstOperands,
     /*  421837 */     // GIR_Coverage, 5340,
     /*  421837 */     GIR_EraseRootFromParent_Done,
     /*  421838 */   // Label 7437: @421838
     /*  421838 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(421921), // Rule ID 5341 //
     /*  421843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421886 */     // MIs[1] Operand 1
     /*  421886 */     // No operand predicates
     /*  421886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421899 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421919 */     GIR_RootConstrainSelectedInstOperands,
     /*  421920 */     // GIR_Coverage, 5341,
     /*  421920 */     GIR_EraseRootFromParent_Done,
     /*  421921 */   // Label 7438: @421921
     /*  421921 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(422004), // Rule ID 5342 //
     /*  421926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421969 */     // MIs[1] Operand 1
     /*  421969 */     // No operand predicates
     /*  421969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422002 */     GIR_RootConstrainSelectedInstOperands,
     /*  422003 */     // GIR_Coverage, 5342,
     /*  422003 */     GIR_EraseRootFromParent_Done,
     /*  422004 */   // Label 7439: @422004
     /*  422004 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(422087), // Rule ID 5343 //
     /*  422009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  422023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422052 */     // MIs[1] Operand 1
     /*  422052 */     // No operand predicates
     /*  422052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422065 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422085 */     GIR_RootConstrainSelectedInstOperands,
     /*  422086 */     // GIR_Coverage, 5343,
     /*  422086 */     GIR_EraseRootFromParent_Done,
     /*  422087 */   // Label 7440: @422087
     /*  422087 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(422170), // Rule ID 5344 //
     /*  422092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422135 */     // MIs[1] Operand 1
     /*  422135 */     // No operand predicates
     /*  422135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  422151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422168 */     GIR_RootConstrainSelectedInstOperands,
     /*  422169 */     // GIR_Coverage, 5344,
     /*  422169 */     GIR_EraseRootFromParent_Done,
     /*  422170 */   // Label 7441: @422170
     /*  422170 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(422253), // Rule ID 5345 //
     /*  422175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  422189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422218 */     // MIs[1] Operand 1
     /*  422218 */     // No operand predicates
     /*  422218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422231 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  422234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422251 */     GIR_RootConstrainSelectedInstOperands,
     /*  422252 */     // GIR_Coverage, 5345,
     /*  422252 */     GIR_EraseRootFromParent_Done,
     /*  422253 */   // Label 7442: @422253
     /*  422253 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(422336), // Rule ID 5346 //
     /*  422258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422301 */     // MIs[1] Operand 1
     /*  422301 */     // No operand predicates
     /*  422301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422334 */     GIR_RootConstrainSelectedInstOperands,
     /*  422335 */     // GIR_Coverage, 5346,
     /*  422335 */     GIR_EraseRootFromParent_Done,
     /*  422336 */   // Label 7443: @422336
     /*  422336 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(422419), // Rule ID 5347 //
     /*  422341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  422355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422384 */     // MIs[1] Operand 1
     /*  422384 */     // No operand predicates
     /*  422384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422397 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422417 */     GIR_RootConstrainSelectedInstOperands,
     /*  422418 */     // GIR_Coverage, 5347,
     /*  422418 */     GIR_EraseRootFromParent_Done,
     /*  422419 */   // Label 7444: @422419
     /*  422419 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(422502), // Rule ID 5348 //
     /*  422424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422467 */     // MIs[1] Operand 1
     /*  422467 */     // No operand predicates
     /*  422467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422500 */     GIR_RootConstrainSelectedInstOperands,
     /*  422501 */     // GIR_Coverage, 5348,
     /*  422501 */     GIR_EraseRootFromParent_Done,
     /*  422502 */   // Label 7445: @422502
     /*  422502 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(422585), // Rule ID 5349 //
     /*  422507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422550 */     // MIs[1] Operand 1
     /*  422550 */     // No operand predicates
     /*  422550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422583 */     GIR_RootConstrainSelectedInstOperands,
     /*  422584 */     // GIR_Coverage, 5349,
     /*  422584 */     GIR_EraseRootFromParent_Done,
     /*  422585 */   // Label 7446: @422585
     /*  422585 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(422668), // Rule ID 5350 //
     /*  422590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422633 */     // MIs[1] Operand 1
     /*  422633 */     // No operand predicates
     /*  422633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422666 */     GIR_RootConstrainSelectedInstOperands,
     /*  422667 */     // GIR_Coverage, 5350,
     /*  422667 */     GIR_EraseRootFromParent_Done,
     /*  422668 */   // Label 7447: @422668
     /*  422668 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(422751), // Rule ID 5351 //
     /*  422673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422716 */     // MIs[1] Operand 1
     /*  422716 */     // No operand predicates
     /*  422716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422749 */     GIR_RootConstrainSelectedInstOperands,
     /*  422750 */     // GIR_Coverage, 5351,
     /*  422750 */     GIR_EraseRootFromParent_Done,
     /*  422751 */   // Label 7448: @422751
     /*  422751 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(422834), // Rule ID 5352 //
     /*  422756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422799 */     // MIs[1] Operand 1
     /*  422799 */     // No operand predicates
     /*  422799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422832 */     GIR_RootConstrainSelectedInstOperands,
     /*  422833 */     // GIR_Coverage, 5352,
     /*  422833 */     GIR_EraseRootFromParent_Done,
     /*  422834 */   // Label 7449: @422834
     /*  422834 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(422917), // Rule ID 5353 //
     /*  422839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422882 */     // MIs[1] Operand 1
     /*  422882 */     // No operand predicates
     /*  422882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422915 */     GIR_RootConstrainSelectedInstOperands,
     /*  422916 */     // GIR_Coverage, 5353,
     /*  422916 */     GIR_EraseRootFromParent_Done,
     /*  422917 */   // Label 7450: @422917
     /*  422917 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(423000), // Rule ID 5354 //
     /*  422922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422965 */     // MIs[1] Operand 1
     /*  422965 */     // No operand predicates
     /*  422965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422998 */     GIR_RootConstrainSelectedInstOperands,
     /*  422999 */     // GIR_Coverage, 5354,
     /*  422999 */     GIR_EraseRootFromParent_Done,
     /*  423000 */   // Label 7451: @423000
     /*  423000 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(423083), // Rule ID 5355 //
     /*  423005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  423016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  423019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  423025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423048 */     // MIs[1] Operand 1
     /*  423048 */     // No operand predicates
     /*  423048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423061 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423081 */     GIR_RootConstrainSelectedInstOperands,
     /*  423082 */     // GIR_Coverage, 5355,
     /*  423082 */     GIR_EraseRootFromParent_Done,
     /*  423083 */   // Label 7452: @423083
     /*  423083 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(423166), // Rule ID 5356 //
     /*  423088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  423091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  423099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  423102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  423108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423131 */     // MIs[1] Operand 1
     /*  423131 */     // No operand predicates
     /*  423131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423164 */     GIR_RootConstrainSelectedInstOperands,
     /*  423165 */     // GIR_Coverage, 5356,
     /*  423165 */     GIR_EraseRootFromParent_Done,
     /*  423166 */   // Label 7453: @423166
     /*  423166 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(423249), // Rule ID 5357 //
     /*  423171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  423174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  423182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  423185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  423191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423214 */     // MIs[1] Operand 1
     /*  423214 */     // No operand predicates
     /*  423214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  423230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423247 */     GIR_RootConstrainSelectedInstOperands,
     /*  423248 */     // GIR_Coverage, 5357,
     /*  423248 */     GIR_EraseRootFromParent_Done,
     /*  423249 */   // Label 7454: @423249
     /*  423249 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(423332), // Rule ID 5358 //
     /*  423254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  423268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423297 */     // MIs[1] Operand 1
     /*  423297 */     // No operand predicates
     /*  423297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423330 */     GIR_RootConstrainSelectedInstOperands,
     /*  423331 */     // GIR_Coverage, 5358,
     /*  423331 */     GIR_EraseRootFromParent_Done,
     /*  423332 */   // Label 7455: @423332
     /*  423332 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(423415), // Rule ID 5359 //
     /*  423337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  423351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423380 */     // MIs[1] Operand 1
     /*  423380 */     // No operand predicates
     /*  423380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423393 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423413 */     GIR_RootConstrainSelectedInstOperands,
     /*  423414 */     // GIR_Coverage, 5359,
     /*  423414 */     GIR_EraseRootFromParent_Done,
     /*  423415 */   // Label 7456: @423415
     /*  423415 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(423498), // Rule ID 5360 //
     /*  423420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423463 */     // MIs[1] Operand 1
     /*  423463 */     // No operand predicates
     /*  423463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423496 */     GIR_RootConstrainSelectedInstOperands,
     /*  423497 */     // GIR_Coverage, 5360,
     /*  423497 */     GIR_EraseRootFromParent_Done,
     /*  423498 */   // Label 7457: @423498
     /*  423498 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(423581), // Rule ID 5361 //
     /*  423503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423546 */     // MIs[1] Operand 1
     /*  423546 */     // No operand predicates
     /*  423546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423559 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423579 */     GIR_RootConstrainSelectedInstOperands,
     /*  423580 */     // GIR_Coverage, 5361,
     /*  423580 */     GIR_EraseRootFromParent_Done,
     /*  423581 */   // Label 7458: @423581
     /*  423581 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(423664), // Rule ID 5362 //
     /*  423586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423629 */     // MIs[1] Operand 1
     /*  423629 */     // No operand predicates
     /*  423629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423642 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423662 */     GIR_RootConstrainSelectedInstOperands,
     /*  423663 */     // GIR_Coverage, 5362,
     /*  423663 */     GIR_EraseRootFromParent_Done,
     /*  423664 */   // Label 7459: @423664
     /*  423664 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(423747), // Rule ID 5363 //
     /*  423669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423712 */     // MIs[1] Operand 1
     /*  423712 */     // No operand predicates
     /*  423712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423725 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423745 */     GIR_RootConstrainSelectedInstOperands,
     /*  423746 */     // GIR_Coverage, 5363,
     /*  423746 */     GIR_EraseRootFromParent_Done,
     /*  423747 */   // Label 7460: @423747
     /*  423747 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(423830), // Rule ID 5364 //
     /*  423752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423795 */     // MIs[1] Operand 1
     /*  423795 */     // No operand predicates
     /*  423795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423828 */     GIR_RootConstrainSelectedInstOperands,
     /*  423829 */     // GIR_Coverage, 5364,
     /*  423829 */     GIR_EraseRootFromParent_Done,
     /*  423830 */   // Label 7461: @423830
     /*  423830 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(423913), // Rule ID 5365 //
     /*  423835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423878 */     // MIs[1] Operand 1
     /*  423878 */     // No operand predicates
     /*  423878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423891 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423911 */     GIR_RootConstrainSelectedInstOperands,
     /*  423912 */     // GIR_Coverage, 5365,
     /*  423912 */     GIR_EraseRootFromParent_Done,
     /*  423913 */   // Label 7462: @423913
     /*  423913 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(423996), // Rule ID 5366 //
     /*  423918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423961 */     // MIs[1] Operand 1
     /*  423961 */     // No operand predicates
     /*  423961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423994 */     GIR_RootConstrainSelectedInstOperands,
     /*  423995 */     // GIR_Coverage, 5366,
     /*  423995 */     GIR_EraseRootFromParent_Done,
     /*  423996 */   // Label 7463: @423996
     /*  423996 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(424079), // Rule ID 5367 //
     /*  424001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  424015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424044 */     // MIs[1] Operand 1
     /*  424044 */     // No operand predicates
     /*  424044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424057 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  424057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424077 */     GIR_RootConstrainSelectedInstOperands,
     /*  424078 */     // GIR_Coverage, 5367,
     /*  424078 */     GIR_EraseRootFromParent_Done,
     /*  424079 */   // Label 7464: @424079
     /*  424079 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(424162), // Rule ID 5368 //
     /*  424084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  424095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  424098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  424104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424127 */     // MIs[1] Operand 1
     /*  424127 */     // No operand predicates
     /*  424127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424140 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  424140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424160 */     GIR_RootConstrainSelectedInstOperands,
     /*  424161 */     // GIR_Coverage, 5368,
     /*  424161 */     GIR_EraseRootFromParent_Done,
     /*  424162 */   // Label 7465: @424162
     /*  424162 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(424245), // Rule ID 5369 //
     /*  424167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  424178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  424181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  424187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424210 */     // MIs[1] Operand 1
     /*  424210 */     // No operand predicates
     /*  424210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424223 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  424223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  424243 */     GIR_RootConstrainSelectedInstOperands,
     /*  424244 */     // GIR_Coverage, 5369,
     /*  424244 */     GIR_EraseRootFromParent_Done,
     /*  424245 */   // Label 7466: @424245
     /*  424245 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(424328), // Rule ID 5370 //
     /*  424250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424293 */     // MIs[1] Operand 1
     /*  424293 */     // No operand predicates
     /*  424293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424326 */     GIR_RootConstrainSelectedInstOperands,
     /*  424327 */     // GIR_Coverage, 5370,
     /*  424327 */     GIR_EraseRootFromParent_Done,
     /*  424328 */   // Label 7467: @424328
     /*  424328 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(424411), // Rule ID 5371 //
     /*  424333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424376 */     // MIs[1] Operand 1
     /*  424376 */     // No operand predicates
     /*  424376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424389 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424409 */     GIR_RootConstrainSelectedInstOperands,
     /*  424410 */     // GIR_Coverage, 5371,
     /*  424410 */     GIR_EraseRootFromParent_Done,
     /*  424411 */   // Label 7468: @424411
     /*  424411 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(424494), // Rule ID 5372 //
     /*  424416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424459 */     // MIs[1] Operand 1
     /*  424459 */     // No operand predicates
     /*  424459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424492 */     GIR_RootConstrainSelectedInstOperands,
     /*  424493 */     // GIR_Coverage, 5372,
     /*  424493 */     GIR_EraseRootFromParent_Done,
     /*  424494 */   // Label 7469: @424494
     /*  424494 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(424577), // Rule ID 5373 //
     /*  424499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424542 */     // MIs[1] Operand 1
     /*  424542 */     // No operand predicates
     /*  424542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424555 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424575 */     GIR_RootConstrainSelectedInstOperands,
     /*  424576 */     // GIR_Coverage, 5373,
     /*  424576 */     GIR_EraseRootFromParent_Done,
     /*  424577 */   // Label 7470: @424577
     /*  424577 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(424660), // Rule ID 5374 //
     /*  424582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424625 */     // MIs[1] Operand 1
     /*  424625 */     // No operand predicates
     /*  424625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424648 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424658 */     GIR_RootConstrainSelectedInstOperands,
     /*  424659 */     // GIR_Coverage, 5374,
     /*  424659 */     GIR_EraseRootFromParent_Done,
     /*  424660 */   // Label 7471: @424660
     /*  424660 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(424743), // Rule ID 5375 //
     /*  424665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424708 */     // MIs[1] Operand 1
     /*  424708 */     // No operand predicates
     /*  424708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424721 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424741 */     GIR_RootConstrainSelectedInstOperands,
     /*  424742 */     // GIR_Coverage, 5375,
     /*  424742 */     GIR_EraseRootFromParent_Done,
     /*  424743 */   // Label 7472: @424743
     /*  424743 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(424826), // Rule ID 5376 //
     /*  424748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424791 */     // MIs[1] Operand 1
     /*  424791 */     // No operand predicates
     /*  424791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424824 */     GIR_RootConstrainSelectedInstOperands,
     /*  424825 */     // GIR_Coverage, 5376,
     /*  424825 */     GIR_EraseRootFromParent_Done,
     /*  424826 */   // Label 7473: @424826
     /*  424826 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(424909), // Rule ID 5377 //
     /*  424831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424874 */     // MIs[1] Operand 1
     /*  424874 */     // No operand predicates
     /*  424874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424907 */     GIR_RootConstrainSelectedInstOperands,
     /*  424908 */     // GIR_Coverage, 5377,
     /*  424908 */     GIR_EraseRootFromParent_Done,
     /*  424909 */   // Label 7474: @424909
     /*  424909 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(424992), // Rule ID 5378 //
     /*  424914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424957 */     // MIs[1] Operand 1
     /*  424957 */     // No operand predicates
     /*  424957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424990 */     GIR_RootConstrainSelectedInstOperands,
     /*  424991 */     // GIR_Coverage, 5378,
     /*  424991 */     GIR_EraseRootFromParent_Done,
     /*  424992 */   // Label 7475: @424992
     /*  424992 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(425075), // Rule ID 5379 //
     /*  424997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  425000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  425011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425040 */     // MIs[1] Operand 1
     /*  425040 */     // No operand predicates
     /*  425040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425053 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  425053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  425056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425073 */     GIR_RootConstrainSelectedInstOperands,
     /*  425074 */     // GIR_Coverage, 5379,
     /*  425074 */     GIR_EraseRootFromParent_Done,
     /*  425075 */   // Label 7476: @425075
     /*  425075 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(425158), // Rule ID 5380 //
     /*  425080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  425083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  425094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425123 */     // MIs[1] Operand 1
     /*  425123 */     // No operand predicates
     /*  425123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425136 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  425136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  425139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425156 */     GIR_RootConstrainSelectedInstOperands,
     /*  425157 */     // GIR_Coverage, 5380,
     /*  425157 */     GIR_EraseRootFromParent_Done,
     /*  425158 */   // Label 7477: @425158
     /*  425158 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(425241), // Rule ID 5381 //
     /*  425163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  425166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  425177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425206 */     // MIs[1] Operand 1
     /*  425206 */     // No operand predicates
     /*  425206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  425219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  425222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  425239 */     GIR_RootConstrainSelectedInstOperands,
     /*  425240 */     // GIR_Coverage, 5381,
     /*  425240 */     GIR_EraseRootFromParent_Done,
     /*  425241 */   // Label 7478: @425241
     /*  425241 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(425317), // Rule ID 60614 //
     /*  425246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425278 */     // MIs[0] rs2
     /*  425278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425293 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  425296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425315 */     GIR_RootConstrainSelectedInstOperands,
     /*  425316 */     // GIR_Coverage, 60614,
     /*  425316 */     GIR_EraseRootFromParent_Done,
     /*  425317 */   // Label 7479: @425317
     /*  425317 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(425393), // Rule ID 60615 //
     /*  425322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425354 */     // MIs[0] rs2
     /*  425354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  425372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425391 */     GIR_RootConstrainSelectedInstOperands,
     /*  425392 */     // GIR_Coverage, 60615,
     /*  425392 */     GIR_EraseRootFromParent_Done,
     /*  425393 */   // Label 7480: @425393
     /*  425393 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(425469), // Rule ID 62260 //
     /*  425398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425430 */     // MIs[0] rs2
     /*  425430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425467 */     GIR_RootConstrainSelectedInstOperands,
     /*  425468 */     // GIR_Coverage, 62260,
     /*  425468 */     GIR_EraseRootFromParent_Done,
     /*  425469 */   // Label 7481: @425469
     /*  425469 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(425545), // Rule ID 62261 //
     /*  425474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425506 */     // MIs[0] rs2
     /*  425506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425521 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425543 */     GIR_RootConstrainSelectedInstOperands,
     /*  425544 */     // GIR_Coverage, 62261,
     /*  425544 */     GIR_EraseRootFromParent_Done,
     /*  425545 */   // Label 7482: @425545
     /*  425545 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(425621), // Rule ID 62262 //
     /*  425550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425582 */     // MIs[0] rs2
     /*  425582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425619 */     GIR_RootConstrainSelectedInstOperands,
     /*  425620 */     // GIR_Coverage, 62262,
     /*  425620 */     GIR_EraseRootFromParent_Done,
     /*  425621 */   // Label 7483: @425621
     /*  425621 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(425697), // Rule ID 62263 //
     /*  425626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425658 */     // MIs[0] rs2
     /*  425658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425695 */     GIR_RootConstrainSelectedInstOperands,
     /*  425696 */     // GIR_Coverage, 62263,
     /*  425696 */     GIR_EraseRootFromParent_Done,
     /*  425697 */   // Label 7484: @425697
     /*  425697 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(425773), // Rule ID 62264 //
     /*  425702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425734 */     // MIs[0] rs2
     /*  425734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425749 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425771 */     GIR_RootConstrainSelectedInstOperands,
     /*  425772 */     // GIR_Coverage, 62264,
     /*  425772 */     GIR_EraseRootFromParent_Done,
     /*  425773 */   // Label 7485: @425773
     /*  425773 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(425849), // Rule ID 62265 //
     /*  425778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425810 */     // MIs[0] rs2
     /*  425810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425825 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425847 */     GIR_RootConstrainSelectedInstOperands,
     /*  425848 */     // GIR_Coverage, 62265,
     /*  425848 */     GIR_EraseRootFromParent_Done,
     /*  425849 */   // Label 7486: @425849
     /*  425849 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(425925), // Rule ID 62266 //
     /*  425854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425886 */     // MIs[0] rs2
     /*  425886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425923 */     GIR_RootConstrainSelectedInstOperands,
     /*  425924 */     // GIR_Coverage, 62266,
     /*  425924 */     GIR_EraseRootFromParent_Done,
     /*  425925 */   // Label 7487: @425925
     /*  425925 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(426001), // Rule ID 62267 //
     /*  425930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425962 */     // MIs[0] rs2
     /*  425962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425977 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425999 */     GIR_RootConstrainSelectedInstOperands,
     /*  426000 */     // GIR_Coverage, 62267,
     /*  426000 */     GIR_EraseRootFromParent_Done,
     /*  426001 */   // Label 7488: @426001
     /*  426001 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(426077), // Rule ID 62388 //
     /*  426006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426038 */     // MIs[0] rs2
     /*  426038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426053 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  426056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426075 */     GIR_RootConstrainSelectedInstOperands,
     /*  426076 */     // GIR_Coverage, 62388,
     /*  426076 */     GIR_EraseRootFromParent_Done,
     /*  426077 */   // Label 7489: @426077
     /*  426077 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(426153), // Rule ID 62389 //
     /*  426082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426114 */     // MIs[0] rs2
     /*  426114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  426132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426151 */     GIR_RootConstrainSelectedInstOperands,
     /*  426152 */     // GIR_Coverage, 62389,
     /*  426152 */     GIR_EraseRootFromParent_Done,
     /*  426153 */   // Label 7490: @426153
     /*  426153 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(426229), // Rule ID 62390 //
     /*  426158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426190 */     // MIs[0] rs2
     /*  426190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426205 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  426208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426227 */     GIR_RootConstrainSelectedInstOperands,
     /*  426228 */     // GIR_Coverage, 62390,
     /*  426228 */     GIR_EraseRootFromParent_Done,
     /*  426229 */   // Label 7491: @426229
     /*  426229 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(426305), // Rule ID 62391 //
     /*  426234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  426245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  426251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426266 */     // MIs[0] rs2
     /*  426266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426281 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  426284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426303 */     GIR_RootConstrainSelectedInstOperands,
     /*  426304 */     // GIR_Coverage, 62391,
     /*  426304 */     GIR_EraseRootFromParent_Done,
     /*  426305 */   // Label 7492: @426305
     /*  426305 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(426381), // Rule ID 62392 //
     /*  426310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  426321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  426324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  426327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426342 */     // MIs[0] rs2
     /*  426342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  426360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426379 */     GIR_RootConstrainSelectedInstOperands,
     /*  426380 */     // GIR_Coverage, 62392,
     /*  426380 */     GIR_EraseRootFromParent_Done,
     /*  426381 */   // Label 7493: @426381
     /*  426381 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(426457), // Rule ID 62393 //
     /*  426386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  426397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  426400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  426403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426418 */     // MIs[0] rs2
     /*  426418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  426436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426455 */     GIR_RootConstrainSelectedInstOperands,
     /*  426456 */     // GIR_Coverage, 62393,
     /*  426456 */     GIR_EraseRootFromParent_Done,
     /*  426457 */   // Label 7494: @426457
     /*  426457 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(426533), // Rule ID 62394 //
     /*  426462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426494 */     // MIs[0] rs2
     /*  426494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426509 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426531 */     GIR_RootConstrainSelectedInstOperands,
     /*  426532 */     // GIR_Coverage, 62394,
     /*  426532 */     GIR_EraseRootFromParent_Done,
     /*  426533 */   // Label 7495: @426533
     /*  426533 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(426609), // Rule ID 62395 //
     /*  426538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426570 */     // MIs[0] rs2
     /*  426570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426607 */     GIR_RootConstrainSelectedInstOperands,
     /*  426608 */     // GIR_Coverage, 62395,
     /*  426608 */     GIR_EraseRootFromParent_Done,
     /*  426609 */   // Label 7496: @426609
     /*  426609 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(426685), // Rule ID 62396 //
     /*  426614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426646 */     // MIs[0] rs2
     /*  426646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426661 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426683 */     GIR_RootConstrainSelectedInstOperands,
     /*  426684 */     // GIR_Coverage, 62396,
     /*  426684 */     GIR_EraseRootFromParent_Done,
     /*  426685 */   // Label 7497: @426685
     /*  426685 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(426761), // Rule ID 62397 //
     /*  426690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426722 */     // MIs[0] rs2
     /*  426722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426759 */     GIR_RootConstrainSelectedInstOperands,
     /*  426760 */     // GIR_Coverage, 62397,
     /*  426760 */     GIR_EraseRootFromParent_Done,
     /*  426761 */   // Label 7498: @426761
     /*  426761 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(426849), // Rule ID 2800 //
     /*  426766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426813 */     // MIs[1] Operand 1
     /*  426813 */     // No operand predicates
     /*  426813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426822 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426831 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426847 */     GIR_RootConstrainSelectedInstOperands,
     /*  426848 */     // GIR_Coverage, 2800,
     /*  426848 */     GIR_EraseRootFromParent_Done,
     /*  426849 */   // Label 7499: @426849
     /*  426849 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(426937), // Rule ID 2801 //
     /*  426854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426901 */     // MIs[1] Operand 1
     /*  426901 */     // No operand predicates
     /*  426901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426919 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426935 */     GIR_RootConstrainSelectedInstOperands,
     /*  426936 */     // GIR_Coverage, 2801,
     /*  426936 */     GIR_EraseRootFromParent_Done,
     /*  426937 */   // Label 7500: @426937
     /*  426937 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(427025), // Rule ID 2808 //
     /*  426942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426989 */     // MIs[1] Operand 1
     /*  426989 */     // No operand predicates
     /*  426989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426998 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427007 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427023 */     GIR_RootConstrainSelectedInstOperands,
     /*  427024 */     // GIR_Coverage, 2808,
     /*  427024 */     GIR_EraseRootFromParent_Done,
     /*  427025 */   // Label 7501: @427025
     /*  427025 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(427113), // Rule ID 2809 //
     /*  427030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  427041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  427044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  427047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427077 */     // MIs[1] Operand 1
     /*  427077 */     // No operand predicates
     /*  427077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427095 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427111 */     GIR_RootConstrainSelectedInstOperands,
     /*  427112 */     // GIR_Coverage, 2809,
     /*  427112 */     GIR_EraseRootFromParent_Done,
     /*  427113 */   // Label 7502: @427113
     /*  427113 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(427201), // Rule ID 2816 //
     /*  427118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  427129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  427132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  427135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427165 */     // MIs[1] Operand 1
     /*  427165 */     // No operand predicates
     /*  427165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427183 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427199 */     GIR_RootConstrainSelectedInstOperands,
     /*  427200 */     // GIR_Coverage, 2816,
     /*  427200 */     GIR_EraseRootFromParent_Done,
     /*  427201 */   // Label 7503: @427201
     /*  427201 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(427289), // Rule ID 2817 //
     /*  427206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  427217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  427220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  427223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427253 */     // MIs[1] Operand 1
     /*  427253 */     // No operand predicates
     /*  427253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427262 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427271 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427287 */     GIR_RootConstrainSelectedInstOperands,
     /*  427288 */     // GIR_Coverage, 2817,
     /*  427288 */     GIR_EraseRootFromParent_Done,
     /*  427289 */   // Label 7504: @427289
     /*  427289 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(427377), // Rule ID 2824 //
     /*  427294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  427305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  427308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  427311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427341 */     // MIs[1] Operand 1
     /*  427341 */     // No operand predicates
     /*  427341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427350 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427359 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427375 */     GIR_RootConstrainSelectedInstOperands,
     /*  427376 */     // GIR_Coverage, 2824,
     /*  427376 */     GIR_EraseRootFromParent_Done,
     /*  427377 */   // Label 7505: @427377
     /*  427377 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(427465), // Rule ID 2825 //
     /*  427382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  427393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  427396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  427399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427429 */     // MIs[1] Operand 1
     /*  427429 */     // No operand predicates
     /*  427429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  427441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427447 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427463 */     GIR_RootConstrainSelectedInstOperands,
     /*  427464 */     // GIR_Coverage, 2825,
     /*  427464 */     GIR_EraseRootFromParent_Done,
     /*  427465 */   // Label 7506: @427465
     /*  427465 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(427553), // Rule ID 2832 //
     /*  427470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427517 */     // MIs[1] Operand 1
     /*  427517 */     // No operand predicates
     /*  427517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427535 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427551 */     GIR_RootConstrainSelectedInstOperands,
     /*  427552 */     // GIR_Coverage, 2832,
     /*  427552 */     GIR_EraseRootFromParent_Done,
     /*  427553 */   // Label 7507: @427553
     /*  427553 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(427641), // Rule ID 2833 //
     /*  427558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427605 */     // MIs[1] Operand 1
     /*  427605 */     // No operand predicates
     /*  427605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427614 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427623 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427639 */     GIR_RootConstrainSelectedInstOperands,
     /*  427640 */     // GIR_Coverage, 2833,
     /*  427640 */     GIR_EraseRootFromParent_Done,
     /*  427641 */   // Label 7508: @427641
     /*  427641 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(427729), // Rule ID 2840 //
     /*  427646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427693 */     // MIs[1] Operand 1
     /*  427693 */     // No operand predicates
     /*  427693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427711 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427727 */     GIR_RootConstrainSelectedInstOperands,
     /*  427728 */     // GIR_Coverage, 2840,
     /*  427728 */     GIR_EraseRootFromParent_Done,
     /*  427729 */   // Label 7509: @427729
     /*  427729 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(427817), // Rule ID 2841 //
     /*  427734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427781 */     // MIs[1] Operand 1
     /*  427781 */     // No operand predicates
     /*  427781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427799 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427815 */     GIR_RootConstrainSelectedInstOperands,
     /*  427816 */     // GIR_Coverage, 2841,
     /*  427816 */     GIR_EraseRootFromParent_Done,
     /*  427817 */   // Label 7510: @427817
     /*  427817 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(427905), // Rule ID 2848 //
     /*  427822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427869 */     // MIs[1] Operand 1
     /*  427869 */     // No operand predicates
     /*  427869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427878 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427887 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427903 */     GIR_RootConstrainSelectedInstOperands,
     /*  427904 */     // GIR_Coverage, 2848,
     /*  427904 */     GIR_EraseRootFromParent_Done,
     /*  427905 */   // Label 7511: @427905
     /*  427905 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(427993), // Rule ID 2849 //
     /*  427910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427957 */     // MIs[1] Operand 1
     /*  427957 */     // No operand predicates
     /*  427957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427966 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427975 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427991 */     GIR_RootConstrainSelectedInstOperands,
     /*  427992 */     // GIR_Coverage, 2849,
     /*  427992 */     GIR_EraseRootFromParent_Done,
     /*  427993 */   // Label 7512: @427993
     /*  427993 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(428081), // Rule ID 2856 //
     /*  427998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428045 */     // MIs[1] Operand 1
     /*  428045 */     // No operand predicates
     /*  428045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428063 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428079 */     GIR_RootConstrainSelectedInstOperands,
     /*  428080 */     // GIR_Coverage, 2856,
     /*  428080 */     GIR_EraseRootFromParent_Done,
     /*  428081 */   // Label 7513: @428081
     /*  428081 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(428169), // Rule ID 2857 //
     /*  428086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  428097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  428100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  428103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428133 */     // MIs[1] Operand 1
     /*  428133 */     // No operand predicates
     /*  428133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428151 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428167 */     GIR_RootConstrainSelectedInstOperands,
     /*  428168 */     // GIR_Coverage, 2857,
     /*  428168 */     GIR_EraseRootFromParent_Done,
     /*  428169 */   // Label 7514: @428169
     /*  428169 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(428257), // Rule ID 2864 //
     /*  428174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428221 */     // MIs[1] Operand 1
     /*  428221 */     // No operand predicates
     /*  428221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428239 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428255 */     GIR_RootConstrainSelectedInstOperands,
     /*  428256 */     // GIR_Coverage, 2864,
     /*  428256 */     GIR_EraseRootFromParent_Done,
     /*  428257 */   // Label 7515: @428257
     /*  428257 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(428345), // Rule ID 2865 //
     /*  428262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428309 */     // MIs[1] Operand 1
     /*  428309 */     // No operand predicates
     /*  428309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428327 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428343 */     GIR_RootConstrainSelectedInstOperands,
     /*  428344 */     // GIR_Coverage, 2865,
     /*  428344 */     GIR_EraseRootFromParent_Done,
     /*  428345 */   // Label 7516: @428345
     /*  428345 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(428433), // Rule ID 2872 //
     /*  428350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  428361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  428364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428397 */     // MIs[1] Operand 1
     /*  428397 */     // No operand predicates
     /*  428397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  428406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428415 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428431 */     GIR_RootConstrainSelectedInstOperands,
     /*  428432 */     // GIR_Coverage, 2872,
     /*  428432 */     GIR_EraseRootFromParent_Done,
     /*  428433 */   // Label 7517: @428433
     /*  428433 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(428521), // Rule ID 2873 //
     /*  428438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  428449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  428452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  428455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428485 */     // MIs[1] Operand 1
     /*  428485 */     // No operand predicates
     /*  428485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428503 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428519 */     GIR_RootConstrainSelectedInstOperands,
     /*  428520 */     // GIR_Coverage, 2873,
     /*  428520 */     GIR_EraseRootFromParent_Done,
     /*  428521 */   // Label 7518: @428521
     /*  428521 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(428609), // Rule ID 2880 //
     /*  428526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428573 */     // MIs[1] Operand 1
     /*  428573 */     // No operand predicates
     /*  428573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428591 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428607 */     GIR_RootConstrainSelectedInstOperands,
     /*  428608 */     // GIR_Coverage, 2880,
     /*  428608 */     GIR_EraseRootFromParent_Done,
     /*  428609 */   // Label 7519: @428609
     /*  428609 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(428697), // Rule ID 2881 //
     /*  428614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428661 */     // MIs[1] Operand 1
     /*  428661 */     // No operand predicates
     /*  428661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428679 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428695 */     GIR_RootConstrainSelectedInstOperands,
     /*  428696 */     // GIR_Coverage, 2881,
     /*  428696 */     GIR_EraseRootFromParent_Done,
     /*  428697 */   // Label 7520: @428697
     /*  428697 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(428785), // Rule ID 2888 //
     /*  428702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428749 */     // MIs[1] Operand 1
     /*  428749 */     // No operand predicates
     /*  428749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428758 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428767 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428783 */     GIR_RootConstrainSelectedInstOperands,
     /*  428784 */     // GIR_Coverage, 2888,
     /*  428784 */     GIR_EraseRootFromParent_Done,
     /*  428785 */   // Label 7521: @428785
     /*  428785 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(428873), // Rule ID 2889 //
     /*  428790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428837 */     // MIs[1] Operand 1
     /*  428837 */     // No operand predicates
     /*  428837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428855 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428871 */     GIR_RootConstrainSelectedInstOperands,
     /*  428872 */     // GIR_Coverage, 2889,
     /*  428872 */     GIR_EraseRootFromParent_Done,
     /*  428873 */   // Label 7522: @428873
     /*  428873 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(428961), // Rule ID 2896 //
     /*  428878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428925 */     // MIs[1] Operand 1
     /*  428925 */     // No operand predicates
     /*  428925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428943 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428959 */     GIR_RootConstrainSelectedInstOperands,
     /*  428960 */     // GIR_Coverage, 2896,
     /*  428960 */     GIR_EraseRootFromParent_Done,
     /*  428961 */   // Label 7523: @428961
     /*  428961 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(429049), // Rule ID 2897 //
     /*  428966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429013 */     // MIs[1] Operand 1
     /*  429013 */     // No operand predicates
     /*  429013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429022 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  429022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429031 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429047 */     GIR_RootConstrainSelectedInstOperands,
     /*  429048 */     // GIR_Coverage, 2897,
     /*  429048 */     GIR_EraseRootFromParent_Done,
     /*  429049 */   // Label 7524: @429049
     /*  429049 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(429137), // Rule ID 2904 //
     /*  429054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429101 */     // MIs[1] Operand 1
     /*  429101 */     // No operand predicates
     /*  429101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429119 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429135 */     GIR_RootConstrainSelectedInstOperands,
     /*  429136 */     // GIR_Coverage, 2904,
     /*  429136 */     GIR_EraseRootFromParent_Done,
     /*  429137 */   // Label 7525: @429137
     /*  429137 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(429225), // Rule ID 2905 //
     /*  429142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  429153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  429156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  429159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429189 */     // MIs[1] Operand 1
     /*  429189 */     // No operand predicates
     /*  429189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429207 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429223 */     GIR_RootConstrainSelectedInstOperands,
     /*  429224 */     // GIR_Coverage, 2905,
     /*  429224 */     GIR_EraseRootFromParent_Done,
     /*  429225 */   // Label 7526: @429225
     /*  429225 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(429313), // Rule ID 2912 //
     /*  429230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429277 */     // MIs[1] Operand 1
     /*  429277 */     // No operand predicates
     /*  429277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429295 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429311 */     GIR_RootConstrainSelectedInstOperands,
     /*  429312 */     // GIR_Coverage, 2912,
     /*  429312 */     GIR_EraseRootFromParent_Done,
     /*  429313 */   // Label 7527: @429313
     /*  429313 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(429401), // Rule ID 2913 //
     /*  429318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  429329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  429332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  429335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429365 */     // MIs[1] Operand 1
     /*  429365 */     // No operand predicates
     /*  429365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429383 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429399 */     GIR_RootConstrainSelectedInstOperands,
     /*  429400 */     // GIR_Coverage, 2913,
     /*  429400 */     GIR_EraseRootFromParent_Done,
     /*  429401 */   // Label 7528: @429401
     /*  429401 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(429489), // Rule ID 2920 //
     /*  429406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429453 */     // MIs[1] Operand 1
     /*  429453 */     // No operand predicates
     /*  429453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  429462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429471 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429487 */     GIR_RootConstrainSelectedInstOperands,
     /*  429488 */     // GIR_Coverage, 2920,
     /*  429488 */     GIR_EraseRootFromParent_Done,
     /*  429489 */   // Label 7529: @429489
     /*  429489 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(429577), // Rule ID 2921 //
     /*  429494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429541 */     // MIs[1] Operand 1
     /*  429541 */     // No operand predicates
     /*  429541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429559 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429575 */     GIR_RootConstrainSelectedInstOperands,
     /*  429576 */     // GIR_Coverage, 2921,
     /*  429576 */     GIR_EraseRootFromParent_Done,
     /*  429577 */   // Label 7530: @429577
     /*  429577 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(429665), // Rule ID 2928 //
     /*  429582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429629 */     // MIs[1] Operand 1
     /*  429629 */     // No operand predicates
     /*  429629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429647 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429663 */     GIR_RootConstrainSelectedInstOperands,
     /*  429664 */     // GIR_Coverage, 2928,
     /*  429664 */     GIR_EraseRootFromParent_Done,
     /*  429665 */   // Label 7531: @429665
     /*  429665 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(429753), // Rule ID 2929 //
     /*  429670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429717 */     // MIs[1] Operand 1
     /*  429717 */     // No operand predicates
     /*  429717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429735 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429751 */     GIR_RootConstrainSelectedInstOperands,
     /*  429752 */     // GIR_Coverage, 2929,
     /*  429752 */     GIR_EraseRootFromParent_Done,
     /*  429753 */   // Label 7532: @429753
     /*  429753 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(429841), // Rule ID 2936 //
     /*  429758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429805 */     // MIs[1] Operand 1
     /*  429805 */     // No operand predicates
     /*  429805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429823 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429839 */     GIR_RootConstrainSelectedInstOperands,
     /*  429840 */     // GIR_Coverage, 2936,
     /*  429840 */     GIR_EraseRootFromParent_Done,
     /*  429841 */   // Label 7533: @429841
     /*  429841 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(429929), // Rule ID 2937 //
     /*  429846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429893 */     // MIs[1] Operand 1
     /*  429893 */     // No operand predicates
     /*  429893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429911 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429927 */     GIR_RootConstrainSelectedInstOperands,
     /*  429928 */     // GIR_Coverage, 2937,
     /*  429928 */     GIR_EraseRootFromParent_Done,
     /*  429929 */   // Label 7534: @429929
     /*  429929 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(430017), // Rule ID 2944 //
     /*  429934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429981 */     // MIs[1] Operand 1
     /*  429981 */     // No operand predicates
     /*  429981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429999 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430015 */     GIR_RootConstrainSelectedInstOperands,
     /*  430016 */     // GIR_Coverage, 2944,
     /*  430016 */     GIR_EraseRootFromParent_Done,
     /*  430017 */   // Label 7535: @430017
     /*  430017 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(430105), // Rule ID 2945 //
     /*  430022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430069 */     // MIs[1] Operand 1
     /*  430069 */     // No operand predicates
     /*  430069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430087 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430103 */     GIR_RootConstrainSelectedInstOperands,
     /*  430104 */     // GIR_Coverage, 2945,
     /*  430104 */     GIR_EraseRootFromParent_Done,
     /*  430105 */   // Label 7536: @430105
     /*  430105 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(430193), // Rule ID 2952 //
     /*  430110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  430121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  430124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  430127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430157 */     // MIs[1] Operand 1
     /*  430157 */     // No operand predicates
     /*  430157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  430169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430175 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430191 */     GIR_RootConstrainSelectedInstOperands,
     /*  430192 */     // GIR_Coverage, 2952,
     /*  430192 */     GIR_EraseRootFromParent_Done,
     /*  430193 */   // Label 7537: @430193
     /*  430193 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(430281), // Rule ID 2953 //
     /*  430198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  430209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  430212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  430215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  430233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430245 */     // MIs[1] Operand 1
     /*  430245 */     // No operand predicates
     /*  430245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  430257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430263 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430279 */     GIR_RootConstrainSelectedInstOperands,
     /*  430280 */     // GIR_Coverage, 2953,
     /*  430280 */     GIR_EraseRootFromParent_Done,
     /*  430281 */   // Label 7538: @430281
     /*  430281 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(430369), // Rule ID 2960 //
     /*  430286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430333 */     // MIs[1] Operand 1
     /*  430333 */     // No operand predicates
     /*  430333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  430345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430351 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430367 */     GIR_RootConstrainSelectedInstOperands,
     /*  430368 */     // GIR_Coverage, 2960,
     /*  430368 */     GIR_EraseRootFromParent_Done,
     /*  430369 */   // Label 7539: @430369
     /*  430369 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(430457), // Rule ID 2961 //
     /*  430374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  430385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  430388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  430391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  430409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430421 */     // MIs[1] Operand 1
     /*  430421 */     // No operand predicates
     /*  430421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  430433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430439 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430455 */     GIR_RootConstrainSelectedInstOperands,
     /*  430456 */     // GIR_Coverage, 2961,
     /*  430456 */     GIR_EraseRootFromParent_Done,
     /*  430457 */   // Label 7540: @430457
     /*  430457 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(430545), // Rule ID 2968 //
     /*  430462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  430465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430509 */     // MIs[1] Operand 1
     /*  430509 */     // No operand predicates
     /*  430509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430518 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430527 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430543 */     GIR_RootConstrainSelectedInstOperands,
     /*  430544 */     // GIR_Coverage, 2968,
     /*  430544 */     GIR_EraseRootFromParent_Done,
     /*  430545 */   // Label 7541: @430545
     /*  430545 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(430633), // Rule ID 2969 //
     /*  430550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430597 */     // MIs[1] Operand 1
     /*  430597 */     // No operand predicates
     /*  430597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430606 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430615 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430631 */     GIR_RootConstrainSelectedInstOperands,
     /*  430632 */     // GIR_Coverage, 2969,
     /*  430632 */     GIR_EraseRootFromParent_Done,
     /*  430633 */   // Label 7542: @430633
     /*  430633 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(430719), // Rule ID 3152 //
     /*  430638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430685 */     // MIs[1] Operand 1
     /*  430685 */     // No operand predicates
     /*  430685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430694 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430717 */     GIR_RootConstrainSelectedInstOperands,
     /*  430718 */     // GIR_Coverage, 3152,
     /*  430718 */     GIR_EraseRootFromParent_Done,
     /*  430719 */   // Label 7543: @430719
     /*  430719 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(430805), // Rule ID 3153 //
     /*  430724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430771 */     // MIs[1] Operand 1
     /*  430771 */     // No operand predicates
     /*  430771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430803 */     GIR_RootConstrainSelectedInstOperands,
     /*  430804 */     // GIR_Coverage, 3153,
     /*  430804 */     GIR_EraseRootFromParent_Done,
     /*  430805 */   // Label 7544: @430805
     /*  430805 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(430891), // Rule ID 3156 //
     /*  430810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430857 */     // MIs[1] Operand 1
     /*  430857 */     // No operand predicates
     /*  430857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430889 */     GIR_RootConstrainSelectedInstOperands,
     /*  430890 */     // GIR_Coverage, 3156,
     /*  430890 */     GIR_EraseRootFromParent_Done,
     /*  430891 */   // Label 7545: @430891
     /*  430891 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(430977), // Rule ID 3157 //
     /*  430896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430943 */     // MIs[1] Operand 1
     /*  430943 */     // No operand predicates
     /*  430943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430975 */     GIR_RootConstrainSelectedInstOperands,
     /*  430976 */     // GIR_Coverage, 3157,
     /*  430976 */     GIR_EraseRootFromParent_Done,
     /*  430977 */   // Label 7546: @430977
     /*  430977 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(431063), // Rule ID 3160 //
     /*  430982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431029 */     // MIs[1] Operand 1
     /*  431029 */     // No operand predicates
     /*  431029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431061 */     GIR_RootConstrainSelectedInstOperands,
     /*  431062 */     // GIR_Coverage, 3160,
     /*  431062 */     GIR_EraseRootFromParent_Done,
     /*  431063 */   // Label 7547: @431063
     /*  431063 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(431149), // Rule ID 3161 //
     /*  431068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  431079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  431082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  431085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431115 */     // MIs[1] Operand 1
     /*  431115 */     // No operand predicates
     /*  431115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431147 */     GIR_RootConstrainSelectedInstOperands,
     /*  431148 */     // GIR_Coverage, 3161,
     /*  431148 */     GIR_EraseRootFromParent_Done,
     /*  431149 */   // Label 7548: @431149
     /*  431149 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(431235), // Rule ID 3164 //
     /*  431154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  431165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  431168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  431171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431201 */     // MIs[1] Operand 1
     /*  431201 */     // No operand predicates
     /*  431201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  431213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431233 */     GIR_RootConstrainSelectedInstOperands,
     /*  431234 */     // GIR_Coverage, 3164,
     /*  431234 */     GIR_EraseRootFromParent_Done,
     /*  431235 */   // Label 7549: @431235
     /*  431235 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(431321), // Rule ID 3165 //
     /*  431240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  431251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  431254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  431257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431287 */     // MIs[1] Operand 1
     /*  431287 */     // No operand predicates
     /*  431287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  431299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431319 */     GIR_RootConstrainSelectedInstOperands,
     /*  431320 */     // GIR_Coverage, 3165,
     /*  431320 */     GIR_EraseRootFromParent_Done,
     /*  431321 */   // Label 7550: @431321
     /*  431321 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(431407), // Rule ID 3168 //
     /*  431326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  431337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  431340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  431343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431373 */     // MIs[1] Operand 1
     /*  431373 */     // No operand predicates
     /*  431373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431405 */     GIR_RootConstrainSelectedInstOperands,
     /*  431406 */     // GIR_Coverage, 3168,
     /*  431406 */     GIR_EraseRootFromParent_Done,
     /*  431407 */   // Label 7551: @431407
     /*  431407 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(431493), // Rule ID 3169 //
     /*  431412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  431423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  431426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  431429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431459 */     // MIs[1] Operand 1
     /*  431459 */     // No operand predicates
     /*  431459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431491 */     GIR_RootConstrainSelectedInstOperands,
     /*  431492 */     // GIR_Coverage, 3169,
     /*  431492 */     GIR_EraseRootFromParent_Done,
     /*  431493 */   // Label 7552: @431493
     /*  431493 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(431579), // Rule ID 3172 //
     /*  431498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431545 */     // MIs[1] Operand 1
     /*  431545 */     // No operand predicates
     /*  431545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431577 */     GIR_RootConstrainSelectedInstOperands,
     /*  431578 */     // GIR_Coverage, 3172,
     /*  431578 */     GIR_EraseRootFromParent_Done,
     /*  431579 */   // Label 7553: @431579
     /*  431579 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(431665), // Rule ID 3173 //
     /*  431584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431631 */     // MIs[1] Operand 1
     /*  431631 */     // No operand predicates
     /*  431631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431663 */     GIR_RootConstrainSelectedInstOperands,
     /*  431664 */     // GIR_Coverage, 3173,
     /*  431664 */     GIR_EraseRootFromParent_Done,
     /*  431665 */   // Label 7554: @431665
     /*  431665 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(431751), // Rule ID 3176 //
     /*  431670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431717 */     // MIs[1] Operand 1
     /*  431717 */     // No operand predicates
     /*  431717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431749 */     GIR_RootConstrainSelectedInstOperands,
     /*  431750 */     // GIR_Coverage, 3176,
     /*  431750 */     GIR_EraseRootFromParent_Done,
     /*  431751 */   // Label 7555: @431751
     /*  431751 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(431837), // Rule ID 3177 //
     /*  431756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431803 */     // MIs[1] Operand 1
     /*  431803 */     // No operand predicates
     /*  431803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431835 */     GIR_RootConstrainSelectedInstOperands,
     /*  431836 */     // GIR_Coverage, 3177,
     /*  431836 */     GIR_EraseRootFromParent_Done,
     /*  431837 */   // Label 7556: @431837
     /*  431837 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(431923), // Rule ID 3180 //
     /*  431842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431889 */     // MIs[1] Operand 1
     /*  431889 */     // No operand predicates
     /*  431889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431921 */     GIR_RootConstrainSelectedInstOperands,
     /*  431922 */     // GIR_Coverage, 3180,
     /*  431922 */     GIR_EraseRootFromParent_Done,
     /*  431923 */   // Label 7557: @431923
     /*  431923 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(432009), // Rule ID 3181 //
     /*  431928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431975 */     // MIs[1] Operand 1
     /*  431975 */     // No operand predicates
     /*  431975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432007 */     GIR_RootConstrainSelectedInstOperands,
     /*  432008 */     // GIR_Coverage, 3181,
     /*  432008 */     GIR_EraseRootFromParent_Done,
     /*  432009 */   // Label 7558: @432009
     /*  432009 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(432095), // Rule ID 3184 //
     /*  432014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  432031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432061 */     // MIs[1] Operand 1
     /*  432061 */     // No operand predicates
     /*  432061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432093 */     GIR_RootConstrainSelectedInstOperands,
     /*  432094 */     // GIR_Coverage, 3184,
     /*  432094 */     GIR_EraseRootFromParent_Done,
     /*  432095 */   // Label 7559: @432095
     /*  432095 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(432181), // Rule ID 3185 //
     /*  432100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  432111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  432114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  432117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432147 */     // MIs[1] Operand 1
     /*  432147 */     // No operand predicates
     /*  432147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432179 */     GIR_RootConstrainSelectedInstOperands,
     /*  432180 */     // GIR_Coverage, 3185,
     /*  432180 */     GIR_EraseRootFromParent_Done,
     /*  432181 */   // Label 7560: @432181
     /*  432181 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(432267), // Rule ID 3188 //
     /*  432186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  432189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  432197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  432200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  432203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432233 */     // MIs[1] Operand 1
     /*  432233 */     // No operand predicates
     /*  432233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432265 */     GIR_RootConstrainSelectedInstOperands,
     /*  432266 */     // GIR_Coverage, 3188,
     /*  432266 */     GIR_EraseRootFromParent_Done,
     /*  432267 */   // Label 7561: @432267
     /*  432267 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(432353), // Rule ID 3189 //
     /*  432272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  432275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  432283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  432286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  432289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  432307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432319 */     // MIs[1] Operand 1
     /*  432319 */     // No operand predicates
     /*  432319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  432328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  432331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  432348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432351 */     GIR_RootConstrainSelectedInstOperands,
     /*  432352 */     // GIR_Coverage, 3189,
     /*  432352 */     GIR_EraseRootFromParent_Done,
     /*  432353 */   // Label 7562: @432353
     /*  432353 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(432439), // Rule ID 3192 //
     /*  432358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432405 */     // MIs[1] Operand 1
     /*  432405 */     // No operand predicates
     /*  432405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432437 */     GIR_RootConstrainSelectedInstOperands,
     /*  432438 */     // GIR_Coverage, 3192,
     /*  432438 */     GIR_EraseRootFromParent_Done,
     /*  432439 */   // Label 7563: @432439
     /*  432439 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(432525), // Rule ID 3193 //
     /*  432444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432491 */     // MIs[1] Operand 1
     /*  432491 */     // No operand predicates
     /*  432491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432500 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432523 */     GIR_RootConstrainSelectedInstOperands,
     /*  432524 */     // GIR_Coverage, 3193,
     /*  432524 */     GIR_EraseRootFromParent_Done,
     /*  432525 */   // Label 7564: @432525
     /*  432525 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(432611), // Rule ID 3196 //
     /*  432530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432577 */     // MIs[1] Operand 1
     /*  432577 */     // No operand predicates
     /*  432577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432609 */     GIR_RootConstrainSelectedInstOperands,
     /*  432610 */     // GIR_Coverage, 3196,
     /*  432610 */     GIR_EraseRootFromParent_Done,
     /*  432611 */   // Label 7565: @432611
     /*  432611 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(432697), // Rule ID 3197 //
     /*  432616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432663 */     // MIs[1] Operand 1
     /*  432663 */     // No operand predicates
     /*  432663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432695 */     GIR_RootConstrainSelectedInstOperands,
     /*  432696 */     // GIR_Coverage, 3197,
     /*  432696 */     GIR_EraseRootFromParent_Done,
     /*  432697 */   // Label 7566: @432697
     /*  432697 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(432783), // Rule ID 3200 //
     /*  432702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432749 */     // MIs[1] Operand 1
     /*  432749 */     // No operand predicates
     /*  432749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432781 */     GIR_RootConstrainSelectedInstOperands,
     /*  432782 */     // GIR_Coverage, 3200,
     /*  432782 */     GIR_EraseRootFromParent_Done,
     /*  432783 */   // Label 7567: @432783
     /*  432783 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(432869), // Rule ID 3201 //
     /*  432788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432835 */     // MIs[1] Operand 1
     /*  432835 */     // No operand predicates
     /*  432835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432867 */     GIR_RootConstrainSelectedInstOperands,
     /*  432868 */     // GIR_Coverage, 3201,
     /*  432868 */     GIR_EraseRootFromParent_Done,
     /*  432869 */   // Label 7568: @432869
     /*  432869 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(432955), // Rule ID 3204 //
     /*  432874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432921 */     // MIs[1] Operand 1
     /*  432921 */     // No operand predicates
     /*  432921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432953 */     GIR_RootConstrainSelectedInstOperands,
     /*  432954 */     // GIR_Coverage, 3204,
     /*  432954 */     GIR_EraseRootFromParent_Done,
     /*  432955 */   // Label 7569: @432955
     /*  432955 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(433041), // Rule ID 3205 //
     /*  432960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433007 */     // MIs[1] Operand 1
     /*  433007 */     // No operand predicates
     /*  433007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433039 */     GIR_RootConstrainSelectedInstOperands,
     /*  433040 */     // GIR_Coverage, 3205,
     /*  433040 */     GIR_EraseRootFromParent_Done,
     /*  433041 */   // Label 7570: @433041
     /*  433041 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(433127), // Rule ID 3208 //
     /*  433046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  433057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  433060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433093 */     // MIs[1] Operand 1
     /*  433093 */     // No operand predicates
     /*  433093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433125 */     GIR_RootConstrainSelectedInstOperands,
     /*  433126 */     // GIR_Coverage, 3208,
     /*  433126 */     GIR_EraseRootFromParent_Done,
     /*  433127 */   // Label 7571: @433127
     /*  433127 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(433213), // Rule ID 3209 //
     /*  433132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  433143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  433146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  433149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433179 */     // MIs[1] Operand 1
     /*  433179 */     // No operand predicates
     /*  433179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433211 */     GIR_RootConstrainSelectedInstOperands,
     /*  433212 */     // GIR_Coverage, 3209,
     /*  433212 */     GIR_EraseRootFromParent_Done,
     /*  433213 */   // Label 7572: @433213
     /*  433213 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(433299), // Rule ID 3212 //
     /*  433218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  433229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  433232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  433235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433265 */     // MIs[1] Operand 1
     /*  433265 */     // No operand predicates
     /*  433265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  433274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433297 */     GIR_RootConstrainSelectedInstOperands,
     /*  433298 */     // GIR_Coverage, 3212,
     /*  433298 */     GIR_EraseRootFromParent_Done,
     /*  433299 */   // Label 7573: @433299
     /*  433299 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(433385), // Rule ID 3213 //
     /*  433304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  433315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  433318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  433321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433351 */     // MIs[1] Operand 1
     /*  433351 */     // No operand predicates
     /*  433351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  433360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  433380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433383 */     GIR_RootConstrainSelectedInstOperands,
     /*  433384 */     // GIR_Coverage, 3213,
     /*  433384 */     GIR_EraseRootFromParent_Done,
     /*  433385 */   // Label 7574: @433385
     /*  433385 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(433471), // Rule ID 3216 //
     /*  433390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433437 */     // MIs[1] Operand 1
     /*  433437 */     // No operand predicates
     /*  433437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433469 */     GIR_RootConstrainSelectedInstOperands,
     /*  433470 */     // GIR_Coverage, 3216,
     /*  433470 */     GIR_EraseRootFromParent_Done,
     /*  433471 */   // Label 7575: @433471
     /*  433471 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(433557), // Rule ID 3217 //
     /*  433476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433523 */     // MIs[1] Operand 1
     /*  433523 */     // No operand predicates
     /*  433523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433555 */     GIR_RootConstrainSelectedInstOperands,
     /*  433556 */     // GIR_Coverage, 3217,
     /*  433556 */     GIR_EraseRootFromParent_Done,
     /*  433557 */   // Label 7576: @433557
     /*  433557 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(433643), // Rule ID 3220 //
     /*  433562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433609 */     // MIs[1] Operand 1
     /*  433609 */     // No operand predicates
     /*  433609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433641 */     GIR_RootConstrainSelectedInstOperands,
     /*  433642 */     // GIR_Coverage, 3220,
     /*  433642 */     GIR_EraseRootFromParent_Done,
     /*  433643 */   // Label 7577: @433643
     /*  433643 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(433729), // Rule ID 3221 //
     /*  433648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433695 */     // MIs[1] Operand 1
     /*  433695 */     // No operand predicates
     /*  433695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433727 */     GIR_RootConstrainSelectedInstOperands,
     /*  433728 */     // GIR_Coverage, 3221,
     /*  433728 */     GIR_EraseRootFromParent_Done,
     /*  433729 */   // Label 7578: @433729
     /*  433729 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(433815), // Rule ID 3224 //
     /*  433734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433781 */     // MIs[1] Operand 1
     /*  433781 */     // No operand predicates
     /*  433781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433813 */     GIR_RootConstrainSelectedInstOperands,
     /*  433814 */     // GIR_Coverage, 3224,
     /*  433814 */     GIR_EraseRootFromParent_Done,
     /*  433815 */   // Label 7579: @433815
     /*  433815 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(433901), // Rule ID 3225 //
     /*  433820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433867 */     // MIs[1] Operand 1
     /*  433867 */     // No operand predicates
     /*  433867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433899 */     GIR_RootConstrainSelectedInstOperands,
     /*  433900 */     // GIR_Coverage, 3225,
     /*  433900 */     GIR_EraseRootFromParent_Done,
     /*  433901 */   // Label 7580: @433901
     /*  433901 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(433987), // Rule ID 3228 //
     /*  433906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433953 */     // MIs[1] Operand 1
     /*  433953 */     // No operand predicates
     /*  433953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433985 */     GIR_RootConstrainSelectedInstOperands,
     /*  433986 */     // GIR_Coverage, 3228,
     /*  433986 */     GIR_EraseRootFromParent_Done,
     /*  433987 */   // Label 7581: @433987
     /*  433987 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(434073), // Rule ID 3229 //
     /*  433992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  434003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  434006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  434009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  434027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434039 */     // MIs[1] Operand 1
     /*  434039 */     // No operand predicates
     /*  434039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  434051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434071 */     GIR_RootConstrainSelectedInstOperands,
     /*  434072 */     // GIR_Coverage, 3229,
     /*  434072 */     GIR_EraseRootFromParent_Done,
     /*  434073 */   // Label 7582: @434073
     /*  434073 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(434159), // Rule ID 3232 //
     /*  434078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  434081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  434095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434125 */     // MIs[1] Operand 1
     /*  434125 */     // No operand predicates
     /*  434125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  434134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  434137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434157 */     GIR_RootConstrainSelectedInstOperands,
     /*  434158 */     // GIR_Coverage, 3232,
     /*  434158 */     GIR_EraseRootFromParent_Done,
     /*  434159 */   // Label 7583: @434159
     /*  434159 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(434245), // Rule ID 3233 //
     /*  434164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  434167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  434175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  434178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  434181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  434199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434211 */     // MIs[1] Operand 1
     /*  434211 */     // No operand predicates
     /*  434211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  434223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434243 */     GIR_RootConstrainSelectedInstOperands,
     /*  434244 */     // GIR_Coverage, 3233,
     /*  434244 */     GIR_EraseRootFromParent_Done,
     /*  434245 */   // Label 7584: @434245
     /*  434245 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(434331), // Rule ID 3236 //
     /*  434250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  434253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  434261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  434264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  434267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434297 */     // MIs[1] Operand 1
     /*  434297 */     // No operand predicates
     /*  434297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  434306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  434309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434329 */     GIR_RootConstrainSelectedInstOperands,
     /*  434330 */     // GIR_Coverage, 3236,
     /*  434330 */     GIR_EraseRootFromParent_Done,
     /*  434331 */   // Label 7585: @434331
     /*  434331 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(434417), // Rule ID 3237 //
     /*  434336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  434339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  434347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  434350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  434353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  434371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434383 */     // MIs[1] Operand 1
     /*  434383 */     // No operand predicates
     /*  434383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  434392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  434395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434415 */     GIR_RootConstrainSelectedInstOperands,
     /*  434416 */     // GIR_Coverage, 3237,
     /*  434416 */     GIR_EraseRootFromParent_Done,
     /*  434417 */   // Label 7586: @434417
     /*  434417 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(434503), // Rule ID 3504 //
     /*  434422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434469 */     // MIs[1] Operand 1
     /*  434469 */     // No operand predicates
     /*  434469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434501 */     GIR_RootConstrainSelectedInstOperands,
     /*  434502 */     // GIR_Coverage, 3504,
     /*  434502 */     GIR_EraseRootFromParent_Done,
     /*  434503 */   // Label 7587: @434503
     /*  434503 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(434589), // Rule ID 3505 //
     /*  434508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434555 */     // MIs[1] Operand 1
     /*  434555 */     // No operand predicates
     /*  434555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434587 */     GIR_RootConstrainSelectedInstOperands,
     /*  434588 */     // GIR_Coverage, 3505,
     /*  434588 */     GIR_EraseRootFromParent_Done,
     /*  434589 */   // Label 7588: @434589
     /*  434589 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(434675), // Rule ID 3508 //
     /*  434594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434641 */     // MIs[1] Operand 1
     /*  434641 */     // No operand predicates
     /*  434641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434650 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434673 */     GIR_RootConstrainSelectedInstOperands,
     /*  434674 */     // GIR_Coverage, 3508,
     /*  434674 */     GIR_EraseRootFromParent_Done,
     /*  434675 */   // Label 7589: @434675
     /*  434675 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(434761), // Rule ID 3509 //
     /*  434680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434727 */     // MIs[1] Operand 1
     /*  434727 */     // No operand predicates
     /*  434727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434736 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434759 */     GIR_RootConstrainSelectedInstOperands,
     /*  434760 */     // GIR_Coverage, 3509,
     /*  434760 */     GIR_EraseRootFromParent_Done,
     /*  434761 */   // Label 7590: @434761
     /*  434761 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(434847), // Rule ID 3512 //
     /*  434766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434813 */     // MIs[1] Operand 1
     /*  434813 */     // No operand predicates
     /*  434813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434822 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434845 */     GIR_RootConstrainSelectedInstOperands,
     /*  434846 */     // GIR_Coverage, 3512,
     /*  434846 */     GIR_EraseRootFromParent_Done,
     /*  434847 */   // Label 7591: @434847
     /*  434847 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(434933), // Rule ID 3513 //
     /*  434852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434899 */     // MIs[1] Operand 1
     /*  434899 */     // No operand predicates
     /*  434899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434908 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434931 */     GIR_RootConstrainSelectedInstOperands,
     /*  434932 */     // GIR_Coverage, 3513,
     /*  434932 */     GIR_EraseRootFromParent_Done,
     /*  434933 */   // Label 7592: @434933
     /*  434933 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(435019), // Rule ID 3516 //
     /*  434938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434985 */     // MIs[1] Operand 1
     /*  434985 */     // No operand predicates
     /*  434985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435017 */     GIR_RootConstrainSelectedInstOperands,
     /*  435018 */     // GIR_Coverage, 3516,
     /*  435018 */     GIR_EraseRootFromParent_Done,
     /*  435019 */   // Label 7593: @435019
     /*  435019 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(435105), // Rule ID 3517 //
     /*  435024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  435035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  435038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  435041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435071 */     // MIs[1] Operand 1
     /*  435071 */     // No operand predicates
     /*  435071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  435083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435103 */     GIR_RootConstrainSelectedInstOperands,
     /*  435104 */     // GIR_Coverage, 3517,
     /*  435104 */     GIR_EraseRootFromParent_Done,
     /*  435105 */   // Label 7594: @435105
     /*  435105 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(435191), // Rule ID 3520 //
     /*  435110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  435121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  435124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435157 */     // MIs[1] Operand 1
     /*  435157 */     // No operand predicates
     /*  435157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435189 */     GIR_RootConstrainSelectedInstOperands,
     /*  435190 */     // GIR_Coverage, 3520,
     /*  435190 */     GIR_EraseRootFromParent_Done,
     /*  435191 */   // Label 7595: @435191
     /*  435191 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(435277), // Rule ID 3521 //
     /*  435196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  435207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  435210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  435213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435243 */     // MIs[1] Operand 1
     /*  435243 */     // No operand predicates
     /*  435243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435275 */     GIR_RootConstrainSelectedInstOperands,
     /*  435276 */     // GIR_Coverage, 3521,
     /*  435276 */     GIR_EraseRootFromParent_Done,
     /*  435277 */   // Label 7596: @435277
     /*  435277 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(435363), // Rule ID 3524 //
     /*  435282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  435293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  435296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  435299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435329 */     // MIs[1] Operand 1
     /*  435329 */     // No operand predicates
     /*  435329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435361 */     GIR_RootConstrainSelectedInstOperands,
     /*  435362 */     // GIR_Coverage, 3524,
     /*  435362 */     GIR_EraseRootFromParent_Done,
     /*  435363 */   // Label 7597: @435363
     /*  435363 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(435449), // Rule ID 3525 //
     /*  435368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  435379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  435382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  435385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435415 */     // MIs[1] Operand 1
     /*  435415 */     // No operand predicates
     /*  435415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  435427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435447 */     GIR_RootConstrainSelectedInstOperands,
     /*  435448 */     // GIR_Coverage, 3525,
     /*  435448 */     GIR_EraseRootFromParent_Done,
     /*  435449 */   // Label 7598: @435449
     /*  435449 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(435535), // Rule ID 3528 //
     /*  435454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435501 */     // MIs[1] Operand 1
     /*  435501 */     // No operand predicates
     /*  435501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435533 */     GIR_RootConstrainSelectedInstOperands,
     /*  435534 */     // GIR_Coverage, 3528,
     /*  435534 */     GIR_EraseRootFromParent_Done,
     /*  435535 */   // Label 7599: @435535
     /*  435535 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(435621), // Rule ID 3529 //
     /*  435540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435587 */     // MIs[1] Operand 1
     /*  435587 */     // No operand predicates
     /*  435587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435619 */     GIR_RootConstrainSelectedInstOperands,
     /*  435620 */     // GIR_Coverage, 3529,
     /*  435620 */     GIR_EraseRootFromParent_Done,
     /*  435621 */   // Label 7600: @435621
     /*  435621 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(435707), // Rule ID 3532 //
     /*  435626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435673 */     // MIs[1] Operand 1
     /*  435673 */     // No operand predicates
     /*  435673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435705 */     GIR_RootConstrainSelectedInstOperands,
     /*  435706 */     // GIR_Coverage, 3532,
     /*  435706 */     GIR_EraseRootFromParent_Done,
     /*  435707 */   // Label 7601: @435707
     /*  435707 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(435793), // Rule ID 3533 //
     /*  435712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435759 */     // MIs[1] Operand 1
     /*  435759 */     // No operand predicates
     /*  435759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435791 */     GIR_RootConstrainSelectedInstOperands,
     /*  435792 */     // GIR_Coverage, 3533,
     /*  435792 */     GIR_EraseRootFromParent_Done,
     /*  435793 */   // Label 7602: @435793
     /*  435793 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(435879), // Rule ID 3536 //
     /*  435798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435845 */     // MIs[1] Operand 1
     /*  435845 */     // No operand predicates
     /*  435845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435877 */     GIR_RootConstrainSelectedInstOperands,
     /*  435878 */     // GIR_Coverage, 3536,
     /*  435878 */     GIR_EraseRootFromParent_Done,
     /*  435879 */   // Label 7603: @435879
     /*  435879 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(435965), // Rule ID 3537 //
     /*  435884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435931 */     // MIs[1] Operand 1
     /*  435931 */     // No operand predicates
     /*  435931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435963 */     GIR_RootConstrainSelectedInstOperands,
     /*  435964 */     // GIR_Coverage, 3537,
     /*  435964 */     GIR_EraseRootFromParent_Done,
     /*  435965 */   // Label 7604: @435965
     /*  435965 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(436051), // Rule ID 3540 //
     /*  435970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436017 */     // MIs[1] Operand 1
     /*  436017 */     // No operand predicates
     /*  436017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  436026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  436029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436049 */     GIR_RootConstrainSelectedInstOperands,
     /*  436050 */     // GIR_Coverage, 3540,
     /*  436050 */     GIR_EraseRootFromParent_Done,
     /*  436051 */   // Label 7605: @436051
     /*  436051 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(436137), // Rule ID 3541 //
     /*  436056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  436059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  436067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  436070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  436073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  436091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436103 */     // MIs[1] Operand 1
     /*  436103 */     // No operand predicates
     /*  436103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  436112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  436115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436135 */     GIR_RootConstrainSelectedInstOperands,
     /*  436136 */     // GIR_Coverage, 3541,
     /*  436136 */     GIR_EraseRootFromParent_Done,
     /*  436137 */   // Label 7606: @436137
     /*  436137 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(436223), // Rule ID 3544 //
     /*  436142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  436153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  436156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  436159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436189 */     // MIs[1] Operand 1
     /*  436189 */     // No operand predicates
     /*  436189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436221 */     GIR_RootConstrainSelectedInstOperands,
     /*  436222 */     // GIR_Coverage, 3544,
     /*  436222 */     GIR_EraseRootFromParent_Done,
     /*  436223 */   // Label 7607: @436223
     /*  436223 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(436309), // Rule ID 3545 //
     /*  436228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  436239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  436242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  436245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436275 */     // MIs[1] Operand 1
     /*  436275 */     // No operand predicates
     /*  436275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436307 */     GIR_RootConstrainSelectedInstOperands,
     /*  436308 */     // GIR_Coverage, 3545,
     /*  436308 */     GIR_EraseRootFromParent_Done,
     /*  436309 */   // Label 7608: @436309
     /*  436309 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(436395), // Rule ID 3548 //
     /*  436314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436361 */     // MIs[1] Operand 1
     /*  436361 */     // No operand predicates
     /*  436361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436393 */     GIR_RootConstrainSelectedInstOperands,
     /*  436394 */     // GIR_Coverage, 3548,
     /*  436394 */     GIR_EraseRootFromParent_Done,
     /*  436395 */   // Label 7609: @436395
     /*  436395 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(436481), // Rule ID 3549 //
     /*  436400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436447 */     // MIs[1] Operand 1
     /*  436447 */     // No operand predicates
     /*  436447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436456 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436479 */     GIR_RootConstrainSelectedInstOperands,
     /*  436480 */     // GIR_Coverage, 3549,
     /*  436480 */     GIR_EraseRootFromParent_Done,
     /*  436481 */   // Label 7610: @436481
     /*  436481 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(436567), // Rule ID 3552 //
     /*  436486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436533 */     // MIs[1] Operand 1
     /*  436533 */     // No operand predicates
     /*  436533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436565 */     GIR_RootConstrainSelectedInstOperands,
     /*  436566 */     // GIR_Coverage, 3552,
     /*  436566 */     GIR_EraseRootFromParent_Done,
     /*  436567 */   // Label 7611: @436567
     /*  436567 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(436653), // Rule ID 3553 //
     /*  436572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436619 */     // MIs[1] Operand 1
     /*  436619 */     // No operand predicates
     /*  436619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436628 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436651 */     GIR_RootConstrainSelectedInstOperands,
     /*  436652 */     // GIR_Coverage, 3553,
     /*  436652 */     GIR_EraseRootFromParent_Done,
     /*  436653 */   // Label 7612: @436653
     /*  436653 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(436739), // Rule ID 3556 //
     /*  436658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436705 */     // MIs[1] Operand 1
     /*  436705 */     // No operand predicates
     /*  436705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436737 */     GIR_RootConstrainSelectedInstOperands,
     /*  436738 */     // GIR_Coverage, 3556,
     /*  436738 */     GIR_EraseRootFromParent_Done,
     /*  436739 */   // Label 7613: @436739
     /*  436739 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(436825), // Rule ID 3557 //
     /*  436744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436791 */     // MIs[1] Operand 1
     /*  436791 */     // No operand predicates
     /*  436791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436823 */     GIR_RootConstrainSelectedInstOperands,
     /*  436824 */     // GIR_Coverage, 3557,
     /*  436824 */     GIR_EraseRootFromParent_Done,
     /*  436825 */   // Label 7614: @436825
     /*  436825 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(436911), // Rule ID 3560 //
     /*  436830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436877 */     // MIs[1] Operand 1
     /*  436877 */     // No operand predicates
     /*  436877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436909 */     GIR_RootConstrainSelectedInstOperands,
     /*  436910 */     // GIR_Coverage, 3560,
     /*  436910 */     GIR_EraseRootFromParent_Done,
     /*  436911 */   // Label 7615: @436911
     /*  436911 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(436997), // Rule ID 3561 //
     /*  436916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436963 */     // MIs[1] Operand 1
     /*  436963 */     // No operand predicates
     /*  436963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436995 */     GIR_RootConstrainSelectedInstOperands,
     /*  436996 */     // GIR_Coverage, 3561,
     /*  436996 */     GIR_EraseRootFromParent_Done,
     /*  436997 */   // Label 7616: @436997
     /*  436997 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(437083), // Rule ID 3564 //
     /*  437002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  437013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  437016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  437019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437049 */     // MIs[1] Operand 1
     /*  437049 */     // No operand predicates
     /*  437049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  437058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437081 */     GIR_RootConstrainSelectedInstOperands,
     /*  437082 */     // GIR_Coverage, 3564,
     /*  437082 */     GIR_EraseRootFromParent_Done,
     /*  437083 */   // Label 7617: @437083
     /*  437083 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(437169), // Rule ID 3565 //
     /*  437088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  437099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  437102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  437105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437135 */     // MIs[1] Operand 1
     /*  437135 */     // No operand predicates
     /*  437135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437144 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  437144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437167 */     GIR_RootConstrainSelectedInstOperands,
     /*  437168 */     // GIR_Coverage, 3565,
     /*  437168 */     GIR_EraseRootFromParent_Done,
     /*  437169 */   // Label 7618: @437169
     /*  437169 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(437255), // Rule ID 3568 //
     /*  437174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  437185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  437188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  437191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437221 */     // MIs[1] Operand 1
     /*  437221 */     // No operand predicates
     /*  437221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437253 */     GIR_RootConstrainSelectedInstOperands,
     /*  437254 */     // GIR_Coverage, 3568,
     /*  437254 */     GIR_EraseRootFromParent_Done,
     /*  437255 */   // Label 7619: @437255
     /*  437255 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(437341), // Rule ID 3569 //
     /*  437260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  437271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  437274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  437277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437307 */     // MIs[1] Operand 1
     /*  437307 */     // No operand predicates
     /*  437307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437339 */     GIR_RootConstrainSelectedInstOperands,
     /*  437340 */     // GIR_Coverage, 3569,
     /*  437340 */     GIR_EraseRootFromParent_Done,
     /*  437341 */   // Label 7620: @437341
     /*  437341 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(437427), // Rule ID 3572 //
     /*  437346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437393 */     // MIs[1] Operand 1
     /*  437393 */     // No operand predicates
     /*  437393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437425 */     GIR_RootConstrainSelectedInstOperands,
     /*  437426 */     // GIR_Coverage, 3572,
     /*  437426 */     GIR_EraseRootFromParent_Done,
     /*  437427 */   // Label 7621: @437427
     /*  437427 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(437513), // Rule ID 3573 //
     /*  437432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437479 */     // MIs[1] Operand 1
     /*  437479 */     // No operand predicates
     /*  437479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437511 */     GIR_RootConstrainSelectedInstOperands,
     /*  437512 */     // GIR_Coverage, 3573,
     /*  437512 */     GIR_EraseRootFromParent_Done,
     /*  437513 */   // Label 7622: @437513
     /*  437513 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(437599), // Rule ID 3576 //
     /*  437518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437565 */     // MIs[1] Operand 1
     /*  437565 */     // No operand predicates
     /*  437565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437597 */     GIR_RootConstrainSelectedInstOperands,
     /*  437598 */     // GIR_Coverage, 3576,
     /*  437598 */     GIR_EraseRootFromParent_Done,
     /*  437599 */   // Label 7623: @437599
     /*  437599 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(437685), // Rule ID 3577 //
     /*  437604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437651 */     // MIs[1] Operand 1
     /*  437651 */     // No operand predicates
     /*  437651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437683 */     GIR_RootConstrainSelectedInstOperands,
     /*  437684 */     // GIR_Coverage, 3577,
     /*  437684 */     GIR_EraseRootFromParent_Done,
     /*  437685 */   // Label 7624: @437685
     /*  437685 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(437771), // Rule ID 3580 //
     /*  437690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437737 */     // MIs[1] Operand 1
     /*  437737 */     // No operand predicates
     /*  437737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437769 */     GIR_RootConstrainSelectedInstOperands,
     /*  437770 */     // GIR_Coverage, 3580,
     /*  437770 */     GIR_EraseRootFromParent_Done,
     /*  437771 */   // Label 7625: @437771
     /*  437771 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(437857), // Rule ID 3581 //
     /*  437776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437823 */     // MIs[1] Operand 1
     /*  437823 */     // No operand predicates
     /*  437823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437855 */     GIR_RootConstrainSelectedInstOperands,
     /*  437856 */     // GIR_Coverage, 3581,
     /*  437856 */     GIR_EraseRootFromParent_Done,
     /*  437857 */   // Label 7626: @437857
     /*  437857 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(437943), // Rule ID 3584 //
     /*  437862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437909 */     // MIs[1] Operand 1
     /*  437909 */     // No operand predicates
     /*  437909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437941 */     GIR_RootConstrainSelectedInstOperands,
     /*  437942 */     // GIR_Coverage, 3584,
     /*  437942 */     GIR_EraseRootFromParent_Done,
     /*  437943 */   // Label 7627: @437943
     /*  437943 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(438029), // Rule ID 3585 //
     /*  437948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437995 */     // MIs[1] Operand 1
     /*  437995 */     // No operand predicates
     /*  437995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  438004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  438007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438027 */     GIR_RootConstrainSelectedInstOperands,
     /*  438028 */     // GIR_Coverage, 3585,
     /*  438028 */     GIR_EraseRootFromParent_Done,
     /*  438029 */   // Label 7628: @438029
     /*  438029 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(438115), // Rule ID 3588 //
     /*  438034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  438037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  438045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  438048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  438051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438081 */     // MIs[1] Operand 1
     /*  438081 */     // No operand predicates
     /*  438081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  438090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  438093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438113 */     GIR_RootConstrainSelectedInstOperands,
     /*  438114 */     // GIR_Coverage, 3588,
     /*  438114 */     GIR_EraseRootFromParent_Done,
     /*  438115 */   // Label 7629: @438115
     /*  438115 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(438201), // Rule ID 3589 //
     /*  438120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  438123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  438131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  438134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  438137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  438155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438167 */     // MIs[1] Operand 1
     /*  438167 */     // No operand predicates
     /*  438167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  438176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  438179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438199 */     GIR_RootConstrainSelectedInstOperands,
     /*  438200 */     // GIR_Coverage, 3589,
     /*  438200 */     GIR_EraseRootFromParent_Done,
     /*  438201 */   // Label 7630: @438201
     /*  438201 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(438287), // Rule ID 5952 //
     /*  438206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  438217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  438220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  438223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438253 */     // MIs[1] Operand 1
     /*  438253 */     // No operand predicates
     /*  438253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  438265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438285 */     GIR_RootConstrainSelectedInstOperands,
     /*  438286 */     // GIR_Coverage, 5952,
     /*  438286 */     GIR_EraseRootFromParent_Done,
     /*  438287 */   // Label 7631: @438287
     /*  438287 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(438373), // Rule ID 5953 //
     /*  438292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  438303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  438306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  438309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438339 */     // MIs[1] Operand 1
     /*  438339 */     // No operand predicates
     /*  438339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438348 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  438351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438371 */     GIR_RootConstrainSelectedInstOperands,
     /*  438372 */     // GIR_Coverage, 5953,
     /*  438372 */     GIR_EraseRootFromParent_Done,
     /*  438373 */   // Label 7632: @438373
     /*  438373 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(438459), // Rule ID 5956 //
     /*  438378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438425 */     // MIs[1] Operand 1
     /*  438425 */     // No operand predicates
     /*  438425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438457 */     GIR_RootConstrainSelectedInstOperands,
     /*  438458 */     // GIR_Coverage, 5956,
     /*  438458 */     GIR_EraseRootFromParent_Done,
     /*  438459 */   // Label 7633: @438459
     /*  438459 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(438545), // Rule ID 5957 //
     /*  438464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438511 */     // MIs[1] Operand 1
     /*  438511 */     // No operand predicates
     /*  438511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438543 */     GIR_RootConstrainSelectedInstOperands,
     /*  438544 */     // GIR_Coverage, 5957,
     /*  438544 */     GIR_EraseRootFromParent_Done,
     /*  438545 */   // Label 7634: @438545
     /*  438545 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(438631), // Rule ID 5960 //
     /*  438550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438597 */     // MIs[1] Operand 1
     /*  438597 */     // No operand predicates
     /*  438597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438629 */     GIR_RootConstrainSelectedInstOperands,
     /*  438630 */     // GIR_Coverage, 5960,
     /*  438630 */     GIR_EraseRootFromParent_Done,
     /*  438631 */   // Label 7635: @438631
     /*  438631 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(438717), // Rule ID 5961 //
     /*  438636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438683 */     // MIs[1] Operand 1
     /*  438683 */     // No operand predicates
     /*  438683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438692 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438715 */     GIR_RootConstrainSelectedInstOperands,
     /*  438716 */     // GIR_Coverage, 5961,
     /*  438716 */     GIR_EraseRootFromParent_Done,
     /*  438717 */   // Label 7636: @438717
     /*  438717 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(438803), // Rule ID 5964 //
     /*  438722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438769 */     // MIs[1] Operand 1
     /*  438769 */     // No operand predicates
     /*  438769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438778 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438801 */     GIR_RootConstrainSelectedInstOperands,
     /*  438802 */     // GIR_Coverage, 5964,
     /*  438802 */     GIR_EraseRootFromParent_Done,
     /*  438803 */   // Label 7637: @438803
     /*  438803 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(438889), // Rule ID 5965 //
     /*  438808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438855 */     // MIs[1] Operand 1
     /*  438855 */     // No operand predicates
     /*  438855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438864 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438887 */     GIR_RootConstrainSelectedInstOperands,
     /*  438888 */     // GIR_Coverage, 5965,
     /*  438888 */     GIR_EraseRootFromParent_Done,
     /*  438889 */   // Label 7638: @438889
     /*  438889 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(438975), // Rule ID 5968 //
     /*  438894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438941 */     // MIs[1] Operand 1
     /*  438941 */     // No operand predicates
     /*  438941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438973 */     GIR_RootConstrainSelectedInstOperands,
     /*  438974 */     // GIR_Coverage, 5968,
     /*  438974 */     GIR_EraseRootFromParent_Done,
     /*  438975 */   // Label 7639: @438975
     /*  438975 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(439061), // Rule ID 5969 //
     /*  438980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439027 */     // MIs[1] Operand 1
     /*  439027 */     // No operand predicates
     /*  439027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439059 */     GIR_RootConstrainSelectedInstOperands,
     /*  439060 */     // GIR_Coverage, 5969,
     /*  439060 */     GIR_EraseRootFromParent_Done,
     /*  439061 */   // Label 7640: @439061
     /*  439061 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(439147), // Rule ID 5972 //
     /*  439066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  439077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  439080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439113 */     // MIs[1] Operand 1
     /*  439113 */     // No operand predicates
     /*  439113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439145 */     GIR_RootConstrainSelectedInstOperands,
     /*  439146 */     // GIR_Coverage, 5972,
     /*  439146 */     GIR_EraseRootFromParent_Done,
     /*  439147 */   // Label 7641: @439147
     /*  439147 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(439233), // Rule ID 5973 //
     /*  439152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  439163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  439166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  439169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439199 */     // MIs[1] Operand 1
     /*  439199 */     // No operand predicates
     /*  439199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  439211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439231 */     GIR_RootConstrainSelectedInstOperands,
     /*  439232 */     // GIR_Coverage, 5973,
     /*  439232 */     GIR_EraseRootFromParent_Done,
     /*  439233 */   // Label 7642: @439233
     /*  439233 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(439319), // Rule ID 5976 //
     /*  439238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  439249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  439252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  439255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439285 */     // MIs[1] Operand 1
     /*  439285 */     // No operand predicates
     /*  439285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439317 */     GIR_RootConstrainSelectedInstOperands,
     /*  439318 */     // GIR_Coverage, 5976,
     /*  439318 */     GIR_EraseRootFromParent_Done,
     /*  439319 */   // Label 7643: @439319
     /*  439319 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(439405), // Rule ID 5977 //
     /*  439324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  439335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  439338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  439341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439371 */     // MIs[1] Operand 1
     /*  439371 */     // No operand predicates
     /*  439371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439403 */     GIR_RootConstrainSelectedInstOperands,
     /*  439404 */     // GIR_Coverage, 5977,
     /*  439404 */     GIR_EraseRootFromParent_Done,
     /*  439405 */   // Label 7644: @439405
     /*  439405 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(439491), // Rule ID 5980 //
     /*  439410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439457 */     // MIs[1] Operand 1
     /*  439457 */     // No operand predicates
     /*  439457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439489 */     GIR_RootConstrainSelectedInstOperands,
     /*  439490 */     // GIR_Coverage, 5980,
     /*  439490 */     GIR_EraseRootFromParent_Done,
     /*  439491 */   // Label 7645: @439491
     /*  439491 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(439577), // Rule ID 5981 //
     /*  439496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439543 */     // MIs[1] Operand 1
     /*  439543 */     // No operand predicates
     /*  439543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439575 */     GIR_RootConstrainSelectedInstOperands,
     /*  439576 */     // GIR_Coverage, 5981,
     /*  439576 */     GIR_EraseRootFromParent_Done,
     /*  439577 */   // Label 7646: @439577
     /*  439577 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(439663), // Rule ID 5984 //
     /*  439582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439629 */     // MIs[1] Operand 1
     /*  439629 */     // No operand predicates
     /*  439629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439661 */     GIR_RootConstrainSelectedInstOperands,
     /*  439662 */     // GIR_Coverage, 5984,
     /*  439662 */     GIR_EraseRootFromParent_Done,
     /*  439663 */   // Label 7647: @439663
     /*  439663 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(439749), // Rule ID 5985 //
     /*  439668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439715 */     // MIs[1] Operand 1
     /*  439715 */     // No operand predicates
     /*  439715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439747 */     GIR_RootConstrainSelectedInstOperands,
     /*  439748 */     // GIR_Coverage, 5985,
     /*  439748 */     GIR_EraseRootFromParent_Done,
     /*  439749 */   // Label 7648: @439749
     /*  439749 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(439835), // Rule ID 5988 //
     /*  439754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439801 */     // MIs[1] Operand 1
     /*  439801 */     // No operand predicates
     /*  439801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439833 */     GIR_RootConstrainSelectedInstOperands,
     /*  439834 */     // GIR_Coverage, 5988,
     /*  439834 */     GIR_EraseRootFromParent_Done,
     /*  439835 */   // Label 7649: @439835
     /*  439835 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(439921), // Rule ID 5989 //
     /*  439840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439887 */     // MIs[1] Operand 1
     /*  439887 */     // No operand predicates
     /*  439887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439919 */     GIR_RootConstrainSelectedInstOperands,
     /*  439920 */     // GIR_Coverage, 5989,
     /*  439920 */     GIR_EraseRootFromParent_Done,
     /*  439921 */   // Label 7650: @439921
     /*  439921 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(440007), // Rule ID 5992 //
     /*  439926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439973 */     // MIs[1] Operand 1
     /*  439973 */     // No operand predicates
     /*  439973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440005 */     GIR_RootConstrainSelectedInstOperands,
     /*  440006 */     // GIR_Coverage, 5992,
     /*  440006 */     GIR_EraseRootFromParent_Done,
     /*  440007 */   // Label 7651: @440007
     /*  440007 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(440093), // Rule ID 5993 //
     /*  440012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  440023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  440026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  440029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440059 */     // MIs[1] Operand 1
     /*  440059 */     // No operand predicates
     /*  440059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440091 */     GIR_RootConstrainSelectedInstOperands,
     /*  440092 */     // GIR_Coverage, 5993,
     /*  440092 */     GIR_EraseRootFromParent_Done,
     /*  440093 */   // Label 7652: @440093
     /*  440093 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(440179), // Rule ID 5996 //
     /*  440098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  440109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  440112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  440115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440145 */     // MIs[1] Operand 1
     /*  440145 */     // No operand predicates
     /*  440145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  440154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440177 */     GIR_RootConstrainSelectedInstOperands,
     /*  440178 */     // GIR_Coverage, 5996,
     /*  440178 */     GIR_EraseRootFromParent_Done,
     /*  440179 */   // Label 7653: @440179
     /*  440179 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(440265), // Rule ID 5997 //
     /*  440184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  440195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  440198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  440201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440231 */     // MIs[1] Operand 1
     /*  440231 */     // No operand predicates
     /*  440231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440263 */     GIR_RootConstrainSelectedInstOperands,
     /*  440264 */     // GIR_Coverage, 5997,
     /*  440264 */     GIR_EraseRootFromParent_Done,
     /*  440265 */   // Label 7654: @440265
     /*  440265 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(440351), // Rule ID 6000 //
     /*  440270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  440281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  440284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  440287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440317 */     // MIs[1] Operand 1
     /*  440317 */     // No operand predicates
     /*  440317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  440326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440349 */     GIR_RootConstrainSelectedInstOperands,
     /*  440350 */     // GIR_Coverage, 6000,
     /*  440350 */     GIR_EraseRootFromParent_Done,
     /*  440351 */   // Label 7655: @440351
     /*  440351 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(440437), // Rule ID 6001 //
     /*  440356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  440367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  440370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  440373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440403 */     // MIs[1] Operand 1
     /*  440403 */     // No operand predicates
     /*  440403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440412 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440435 */     GIR_RootConstrainSelectedInstOperands,
     /*  440436 */     // GIR_Coverage, 6001,
     /*  440436 */     GIR_EraseRootFromParent_Done,
     /*  440437 */   // Label 7656: @440437
     /*  440437 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(440523), // Rule ID 6004 //
     /*  440442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440489 */     // MIs[1] Operand 1
     /*  440489 */     // No operand predicates
     /*  440489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440521 */     GIR_RootConstrainSelectedInstOperands,
     /*  440522 */     // GIR_Coverage, 6004,
     /*  440522 */     GIR_EraseRootFromParent_Done,
     /*  440523 */   // Label 7657: @440523
     /*  440523 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(440609), // Rule ID 6005 //
     /*  440528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440575 */     // MIs[1] Operand 1
     /*  440575 */     // No operand predicates
     /*  440575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440607 */     GIR_RootConstrainSelectedInstOperands,
     /*  440608 */     // GIR_Coverage, 6005,
     /*  440608 */     GIR_EraseRootFromParent_Done,
     /*  440609 */   // Label 7658: @440609
     /*  440609 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(440695), // Rule ID 6008 //
     /*  440614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440661 */     // MIs[1] Operand 1
     /*  440661 */     // No operand predicates
     /*  440661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440693 */     GIR_RootConstrainSelectedInstOperands,
     /*  440694 */     // GIR_Coverage, 6008,
     /*  440694 */     GIR_EraseRootFromParent_Done,
     /*  440695 */   // Label 7659: @440695
     /*  440695 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(440781), // Rule ID 6009 //
     /*  440700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440747 */     // MIs[1] Operand 1
     /*  440747 */     // No operand predicates
     /*  440747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440779 */     GIR_RootConstrainSelectedInstOperands,
     /*  440780 */     // GIR_Coverage, 6009,
     /*  440780 */     GIR_EraseRootFromParent_Done,
     /*  440781 */   // Label 7660: @440781
     /*  440781 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(440867), // Rule ID 6012 //
     /*  440786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440833 */     // MIs[1] Operand 1
     /*  440833 */     // No operand predicates
     /*  440833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440865 */     GIR_RootConstrainSelectedInstOperands,
     /*  440866 */     // GIR_Coverage, 6012,
     /*  440866 */     GIR_EraseRootFromParent_Done,
     /*  440867 */   // Label 7661: @440867
     /*  440867 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(440953), // Rule ID 6013 //
     /*  440872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440919 */     // MIs[1] Operand 1
     /*  440919 */     // No operand predicates
     /*  440919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440951 */     GIR_RootConstrainSelectedInstOperands,
     /*  440952 */     // GIR_Coverage, 6013,
     /*  440952 */     GIR_EraseRootFromParent_Done,
     /*  440953 */   // Label 7662: @440953
     /*  440953 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(441039), // Rule ID 6016 //
     /*  440958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441005 */     // MIs[1] Operand 1
     /*  441005 */     // No operand predicates
     /*  441005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441037 */     GIR_RootConstrainSelectedInstOperands,
     /*  441038 */     // GIR_Coverage, 6016,
     /*  441038 */     GIR_EraseRootFromParent_Done,
     /*  441039 */   // Label 7663: @441039
     /*  441039 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(441125), // Rule ID 6017 //
     /*  441044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  441055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  441058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  441061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441091 */     // MIs[1] Operand 1
     /*  441091 */     // No operand predicates
     /*  441091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441123 */     GIR_RootConstrainSelectedInstOperands,
     /*  441124 */     // GIR_Coverage, 6017,
     /*  441124 */     GIR_EraseRootFromParent_Done,
     /*  441125 */   // Label 7664: @441125
     /*  441125 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(441211), // Rule ID 6020 //
     /*  441130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441177 */     // MIs[1] Operand 1
     /*  441177 */     // No operand predicates
     /*  441177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441209 */     GIR_RootConstrainSelectedInstOperands,
     /*  441210 */     // GIR_Coverage, 6020,
     /*  441210 */     GIR_EraseRootFromParent_Done,
     /*  441211 */   // Label 7665: @441211
     /*  441211 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(441297), // Rule ID 6021 //
     /*  441216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  441227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  441230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  441233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441263 */     // MIs[1] Operand 1
     /*  441263 */     // No operand predicates
     /*  441263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441295 */     GIR_RootConstrainSelectedInstOperands,
     /*  441296 */     // GIR_Coverage, 6021,
     /*  441296 */     GIR_EraseRootFromParent_Done,
     /*  441297 */   // Label 7666: @441297
     /*  441297 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(441383), // Rule ID 6024 //
     /*  441302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  441313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  441316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441349 */     // MIs[1] Operand 1
     /*  441349 */     // No operand predicates
     /*  441349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441381 */     GIR_RootConstrainSelectedInstOperands,
     /*  441382 */     // GIR_Coverage, 6024,
     /*  441382 */     GIR_EraseRootFromParent_Done,
     /*  441383 */   // Label 7667: @441383
     /*  441383 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(441469), // Rule ID 6025 //
     /*  441388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  441399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  441402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  441405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441435 */     // MIs[1] Operand 1
     /*  441435 */     // No operand predicates
     /*  441435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441467 */     GIR_RootConstrainSelectedInstOperands,
     /*  441468 */     // GIR_Coverage, 6025,
     /*  441468 */     GIR_EraseRootFromParent_Done,
     /*  441469 */   // Label 7668: @441469
     /*  441469 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(441555), // Rule ID 6028 //
     /*  441474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441521 */     // MIs[1] Operand 1
     /*  441521 */     // No operand predicates
     /*  441521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441553 */     GIR_RootConstrainSelectedInstOperands,
     /*  441554 */     // GIR_Coverage, 6028,
     /*  441554 */     GIR_EraseRootFromParent_Done,
     /*  441555 */   // Label 7669: @441555
     /*  441555 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(441641), // Rule ID 6029 //
     /*  441560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441607 */     // MIs[1] Operand 1
     /*  441607 */     // No operand predicates
     /*  441607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441639 */     GIR_RootConstrainSelectedInstOperands,
     /*  441640 */     // GIR_Coverage, 6029,
     /*  441640 */     GIR_EraseRootFromParent_Done,
     /*  441641 */   // Label 7670: @441641
     /*  441641 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(441727), // Rule ID 6032 //
     /*  441646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441693 */     // MIs[1] Operand 1
     /*  441693 */     // No operand predicates
     /*  441693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441725 */     GIR_RootConstrainSelectedInstOperands,
     /*  441726 */     // GIR_Coverage, 6032,
     /*  441726 */     GIR_EraseRootFromParent_Done,
     /*  441727 */   // Label 7671: @441727
     /*  441727 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(441813), // Rule ID 6033 //
     /*  441732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441779 */     // MIs[1] Operand 1
     /*  441779 */     // No operand predicates
     /*  441779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441811 */     GIR_RootConstrainSelectedInstOperands,
     /*  441812 */     // GIR_Coverage, 6033,
     /*  441812 */     GIR_EraseRootFromParent_Done,
     /*  441813 */   // Label 7672: @441813
     /*  441813 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(441899), // Rule ID 6036 //
     /*  441818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441865 */     // MIs[1] Operand 1
     /*  441865 */     // No operand predicates
     /*  441865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441897 */     GIR_RootConstrainSelectedInstOperands,
     /*  441898 */     // GIR_Coverage, 6036,
     /*  441898 */     GIR_EraseRootFromParent_Done,
     /*  441899 */   // Label 7673: @441899
     /*  441899 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(441985), // Rule ID 6037 //
     /*  441904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441951 */     // MIs[1] Operand 1
     /*  441951 */     // No operand predicates
     /*  441951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441983 */     GIR_RootConstrainSelectedInstOperands,
     /*  441984 */     // GIR_Coverage, 6037,
     /*  441984 */     GIR_EraseRootFromParent_Done,
     /*  441985 */   // Label 7674: @441985
     /*  441985 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(442071), // Rule ID 6216 //
     /*  441990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  442001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  442004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  442007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442037 */     // MIs[1] Operand 1
     /*  442037 */     // No operand predicates
     /*  442037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442046 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  442049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442069 */     GIR_RootConstrainSelectedInstOperands,
     /*  442070 */     // GIR_Coverage, 6216,
     /*  442070 */     GIR_EraseRootFromParent_Done,
     /*  442071 */   // Label 7675: @442071
     /*  442071 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(442157), // Rule ID 6217 //
     /*  442076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  442087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  442090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  442093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442123 */     // MIs[1] Operand 1
     /*  442123 */     // No operand predicates
     /*  442123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  442135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442155 */     GIR_RootConstrainSelectedInstOperands,
     /*  442156 */     // GIR_Coverage, 6217,
     /*  442156 */     GIR_EraseRootFromParent_Done,
     /*  442157 */   // Label 7676: @442157
     /*  442157 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(442243), // Rule ID 6220 //
     /*  442162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  442173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  442176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  442179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442209 */     // MIs[1] Operand 1
     /*  442209 */     // No operand predicates
     /*  442209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442241 */     GIR_RootConstrainSelectedInstOperands,
     /*  442242 */     // GIR_Coverage, 6220,
     /*  442242 */     GIR_EraseRootFromParent_Done,
     /*  442243 */   // Label 7677: @442243
     /*  442243 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(442329), // Rule ID 6221 //
     /*  442248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  442259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  442262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  442265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442295 */     // MIs[1] Operand 1
     /*  442295 */     // No operand predicates
     /*  442295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442304 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442327 */     GIR_RootConstrainSelectedInstOperands,
     /*  442328 */     // GIR_Coverage, 6221,
     /*  442328 */     GIR_EraseRootFromParent_Done,
     /*  442329 */   // Label 7678: @442329
     /*  442329 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(442415), // Rule ID 6224 //
     /*  442334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442381 */     // MIs[1] Operand 1
     /*  442381 */     // No operand predicates
     /*  442381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442413 */     GIR_RootConstrainSelectedInstOperands,
     /*  442414 */     // GIR_Coverage, 6224,
     /*  442414 */     GIR_EraseRootFromParent_Done,
     /*  442415 */   // Label 7679: @442415
     /*  442415 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(442501), // Rule ID 6225 //
     /*  442420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442467 */     // MIs[1] Operand 1
     /*  442467 */     // No operand predicates
     /*  442467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442476 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442499 */     GIR_RootConstrainSelectedInstOperands,
     /*  442500 */     // GIR_Coverage, 6225,
     /*  442500 */     GIR_EraseRootFromParent_Done,
     /*  442501 */   // Label 7680: @442501
     /*  442501 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(442587), // Rule ID 6228 //
     /*  442506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442553 */     // MIs[1] Operand 1
     /*  442553 */     // No operand predicates
     /*  442553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442585 */     GIR_RootConstrainSelectedInstOperands,
     /*  442586 */     // GIR_Coverage, 6228,
     /*  442586 */     GIR_EraseRootFromParent_Done,
     /*  442587 */   // Label 7681: @442587
     /*  442587 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(442673), // Rule ID 6229 //
     /*  442592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442639 */     // MIs[1] Operand 1
     /*  442639 */     // No operand predicates
     /*  442639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442671 */     GIR_RootConstrainSelectedInstOperands,
     /*  442672 */     // GIR_Coverage, 6229,
     /*  442672 */     GIR_EraseRootFromParent_Done,
     /*  442673 */   // Label 7682: @442673
     /*  442673 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(442759), // Rule ID 6232 //
     /*  442678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442725 */     // MIs[1] Operand 1
     /*  442725 */     // No operand predicates
     /*  442725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442757 */     GIR_RootConstrainSelectedInstOperands,
     /*  442758 */     // GIR_Coverage, 6232,
     /*  442758 */     GIR_EraseRootFromParent_Done,
     /*  442759 */   // Label 7683: @442759
     /*  442759 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(442845), // Rule ID 6233 //
     /*  442764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442811 */     // MIs[1] Operand 1
     /*  442811 */     // No operand predicates
     /*  442811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442843 */     GIR_RootConstrainSelectedInstOperands,
     /*  442844 */     // GIR_Coverage, 6233,
     /*  442844 */     GIR_EraseRootFromParent_Done,
     /*  442845 */   // Label 7684: @442845
     /*  442845 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(442931), // Rule ID 6236 //
     /*  442850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442897 */     // MIs[1] Operand 1
     /*  442897 */     // No operand predicates
     /*  442897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442929 */     GIR_RootConstrainSelectedInstOperands,
     /*  442930 */     // GIR_Coverage, 6236,
     /*  442930 */     GIR_EraseRootFromParent_Done,
     /*  442931 */   // Label 7685: @442931
     /*  442931 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(443017), // Rule ID 6237 //
     /*  442936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442983 */     // MIs[1] Operand 1
     /*  442983 */     // No operand predicates
     /*  442983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443015 */     GIR_RootConstrainSelectedInstOperands,
     /*  443016 */     // GIR_Coverage, 6237,
     /*  443016 */     GIR_EraseRootFromParent_Done,
     /*  443017 */   // Label 7686: @443017
     /*  443017 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(443103), // Rule ID 6240 //
     /*  443022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  443033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  443036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  443039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443069 */     // MIs[1] Operand 1
     /*  443069 */     // No operand predicates
     /*  443069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443101 */     GIR_RootConstrainSelectedInstOperands,
     /*  443102 */     // GIR_Coverage, 6240,
     /*  443102 */     GIR_EraseRootFromParent_Done,
     /*  443103 */   // Label 7687: @443103
     /*  443103 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(443189), // Rule ID 6241 //
     /*  443108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  443119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  443122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  443125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443155 */     // MIs[1] Operand 1
     /*  443155 */     // No operand predicates
     /*  443155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443187 */     GIR_RootConstrainSelectedInstOperands,
     /*  443188 */     // GIR_Coverage, 6241,
     /*  443188 */     GIR_EraseRootFromParent_Done,
     /*  443189 */   // Label 7688: @443189
     /*  443189 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(443275), // Rule ID 6244 //
     /*  443194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  443211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443241 */     // MIs[1] Operand 1
     /*  443241 */     // No operand predicates
     /*  443241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443273 */     GIR_RootConstrainSelectedInstOperands,
     /*  443274 */     // GIR_Coverage, 6244,
     /*  443274 */     GIR_EraseRootFromParent_Done,
     /*  443275 */   // Label 7689: @443275
     /*  443275 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(443361), // Rule ID 6245 //
     /*  443280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  443291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  443294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  443297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443327 */     // MIs[1] Operand 1
     /*  443327 */     // No operand predicates
     /*  443327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443359 */     GIR_RootConstrainSelectedInstOperands,
     /*  443360 */     // GIR_Coverage, 6245,
     /*  443360 */     GIR_EraseRootFromParent_Done,
     /*  443361 */   // Label 7690: @443361
     /*  443361 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(443447), // Rule ID 6248 //
     /*  443366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443413 */     // MIs[1] Operand 1
     /*  443413 */     // No operand predicates
     /*  443413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443445 */     GIR_RootConstrainSelectedInstOperands,
     /*  443446 */     // GIR_Coverage, 6248,
     /*  443446 */     GIR_EraseRootFromParent_Done,
     /*  443447 */   // Label 7691: @443447
     /*  443447 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(443533), // Rule ID 6249 //
     /*  443452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443499 */     // MIs[1] Operand 1
     /*  443499 */     // No operand predicates
     /*  443499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443531 */     GIR_RootConstrainSelectedInstOperands,
     /*  443532 */     // GIR_Coverage, 6249,
     /*  443532 */     GIR_EraseRootFromParent_Done,
     /*  443533 */   // Label 7692: @443533
     /*  443533 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(443619), // Rule ID 6252 //
     /*  443538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443585 */     // MIs[1] Operand 1
     /*  443585 */     // No operand predicates
     /*  443585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443617 */     GIR_RootConstrainSelectedInstOperands,
     /*  443618 */     // GIR_Coverage, 6252,
     /*  443618 */     GIR_EraseRootFromParent_Done,
     /*  443619 */   // Label 7693: @443619
     /*  443619 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(443705), // Rule ID 6253 //
     /*  443624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443671 */     // MIs[1] Operand 1
     /*  443671 */     // No operand predicates
     /*  443671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443703 */     GIR_RootConstrainSelectedInstOperands,
     /*  443704 */     // GIR_Coverage, 6253,
     /*  443704 */     GIR_EraseRootFromParent_Done,
     /*  443705 */   // Label 7694: @443705
     /*  443705 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(443791), // Rule ID 6256 //
     /*  443710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443757 */     // MIs[1] Operand 1
     /*  443757 */     // No operand predicates
     /*  443757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443789 */     GIR_RootConstrainSelectedInstOperands,
     /*  443790 */     // GIR_Coverage, 6256,
     /*  443790 */     GIR_EraseRootFromParent_Done,
     /*  443791 */   // Label 7695: @443791
     /*  443791 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(443877), // Rule ID 6257 //
     /*  443796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443843 */     // MIs[1] Operand 1
     /*  443843 */     // No operand predicates
     /*  443843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443875 */     GIR_RootConstrainSelectedInstOperands,
     /*  443876 */     // GIR_Coverage, 6257,
     /*  443876 */     GIR_EraseRootFromParent_Done,
     /*  443877 */   // Label 7696: @443877
     /*  443877 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(443963), // Rule ID 6260 //
     /*  443882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443929 */     // MIs[1] Operand 1
     /*  443929 */     // No operand predicates
     /*  443929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443961 */     GIR_RootConstrainSelectedInstOperands,
     /*  443962 */     // GIR_Coverage, 6260,
     /*  443962 */     GIR_EraseRootFromParent_Done,
     /*  443963 */   // Label 7697: @443963
     /*  443963 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(444049), // Rule ID 6261 //
     /*  443968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444015 */     // MIs[1] Operand 1
     /*  444015 */     // No operand predicates
     /*  444015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444047 */     GIR_RootConstrainSelectedInstOperands,
     /*  444048 */     // GIR_Coverage, 6261,
     /*  444048 */     GIR_EraseRootFromParent_Done,
     /*  444049 */   // Label 7698: @444049
     /*  444049 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(444135), // Rule ID 6264 //
     /*  444054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  444065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  444068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  444071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444101 */     // MIs[1] Operand 1
     /*  444101 */     // No operand predicates
     /*  444101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444110 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  444110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444133 */     GIR_RootConstrainSelectedInstOperands,
     /*  444134 */     // GIR_Coverage, 6264,
     /*  444134 */     GIR_EraseRootFromParent_Done,
     /*  444135 */   // Label 7699: @444135
     /*  444135 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(444221), // Rule ID 6265 //
     /*  444140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  444151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  444154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  444157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444187 */     // MIs[1] Operand 1
     /*  444187 */     // No operand predicates
     /*  444187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444219 */     GIR_RootConstrainSelectedInstOperands,
     /*  444220 */     // GIR_Coverage, 6265,
     /*  444220 */     GIR_EraseRootFromParent_Done,
     /*  444221 */   // Label 7700: @444221
     /*  444221 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(444307), // Rule ID 6268 //
     /*  444226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  444237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  444240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  444243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444273 */     // MIs[1] Operand 1
     /*  444273 */     // No operand predicates
     /*  444273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444305 */     GIR_RootConstrainSelectedInstOperands,
     /*  444306 */     // GIR_Coverage, 6268,
     /*  444306 */     GIR_EraseRootFromParent_Done,
     /*  444307 */   // Label 7701: @444307
     /*  444307 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(444393), // Rule ID 6269 //
     /*  444312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  444323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  444326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  444329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444359 */     // MIs[1] Operand 1
     /*  444359 */     // No operand predicates
     /*  444359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444391 */     GIR_RootConstrainSelectedInstOperands,
     /*  444392 */     // GIR_Coverage, 6269,
     /*  444392 */     GIR_EraseRootFromParent_Done,
     /*  444393 */   // Label 7702: @444393
     /*  444393 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(444479), // Rule ID 6272 //
     /*  444398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444445 */     // MIs[1] Operand 1
     /*  444445 */     // No operand predicates
     /*  444445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444477 */     GIR_RootConstrainSelectedInstOperands,
     /*  444478 */     // GIR_Coverage, 6272,
     /*  444478 */     GIR_EraseRootFromParent_Done,
     /*  444479 */   // Label 7703: @444479
     /*  444479 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(444565), // Rule ID 6273 //
     /*  444484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444531 */     // MIs[1] Operand 1
     /*  444531 */     // No operand predicates
     /*  444531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444563 */     GIR_RootConstrainSelectedInstOperands,
     /*  444564 */     // GIR_Coverage, 6273,
     /*  444564 */     GIR_EraseRootFromParent_Done,
     /*  444565 */   // Label 7704: @444565
     /*  444565 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(444651), // Rule ID 6276 //
     /*  444570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444617 */     // MIs[1] Operand 1
     /*  444617 */     // No operand predicates
     /*  444617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444649 */     GIR_RootConstrainSelectedInstOperands,
     /*  444650 */     // GIR_Coverage, 6276,
     /*  444650 */     GIR_EraseRootFromParent_Done,
     /*  444651 */   // Label 7705: @444651
     /*  444651 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(444737), // Rule ID 6277 //
     /*  444656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444703 */     // MIs[1] Operand 1
     /*  444703 */     // No operand predicates
     /*  444703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444735 */     GIR_RootConstrainSelectedInstOperands,
     /*  444736 */     // GIR_Coverage, 6277,
     /*  444736 */     GIR_EraseRootFromParent_Done,
     /*  444737 */   // Label 7706: @444737
     /*  444737 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(444823), // Rule ID 6280 //
     /*  444742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444789 */     // MIs[1] Operand 1
     /*  444789 */     // No operand predicates
     /*  444789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444821 */     GIR_RootConstrainSelectedInstOperands,
     /*  444822 */     // GIR_Coverage, 6280,
     /*  444822 */     GIR_EraseRootFromParent_Done,
     /*  444823 */   // Label 7707: @444823
     /*  444823 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(444909), // Rule ID 6281 //
     /*  444828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444875 */     // MIs[1] Operand 1
     /*  444875 */     // No operand predicates
     /*  444875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444907 */     GIR_RootConstrainSelectedInstOperands,
     /*  444908 */     // GIR_Coverage, 6281,
     /*  444908 */     GIR_EraseRootFromParent_Done,
     /*  444909 */   // Label 7708: @444909
     /*  444909 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(444995), // Rule ID 6284 //
     /*  444914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444961 */     // MIs[1] Operand 1
     /*  444961 */     // No operand predicates
     /*  444961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444993 */     GIR_RootConstrainSelectedInstOperands,
     /*  444994 */     // GIR_Coverage, 6284,
     /*  444994 */     GIR_EraseRootFromParent_Done,
     /*  444995 */   // Label 7709: @444995
     /*  444995 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(445081), // Rule ID 6285 //
     /*  445000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  445011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  445014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  445017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445047 */     // MIs[1] Operand 1
     /*  445047 */     // No operand predicates
     /*  445047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445079 */     GIR_RootConstrainSelectedInstOperands,
     /*  445080 */     // GIR_Coverage, 6285,
     /*  445080 */     GIR_EraseRootFromParent_Done,
     /*  445081 */   // Label 7710: @445081
     /*  445081 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(445167), // Rule ID 6288 //
     /*  445086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  445097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  445100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  445103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445133 */     // MIs[1] Operand 1
     /*  445133 */     // No operand predicates
     /*  445133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  445142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445165 */     GIR_RootConstrainSelectedInstOperands,
     /*  445166 */     // GIR_Coverage, 6288,
     /*  445166 */     GIR_EraseRootFromParent_Done,
     /*  445167 */   // Label 7711: @445167
     /*  445167 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(445253), // Rule ID 6289 //
     /*  445172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  445183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  445186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  445189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445219 */     // MIs[1] Operand 1
     /*  445219 */     // No operand predicates
     /*  445219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445251 */     GIR_RootConstrainSelectedInstOperands,
     /*  445252 */     // GIR_Coverage, 6289,
     /*  445252 */     GIR_EraseRootFromParent_Done,
     /*  445253 */   // Label 7712: @445253
     /*  445253 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(445339), // Rule ID 6292 //
     /*  445258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  445269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  445272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  445275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445305 */     // MIs[1] Operand 1
     /*  445305 */     // No operand predicates
     /*  445305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  445317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445337 */     GIR_RootConstrainSelectedInstOperands,
     /*  445338 */     // GIR_Coverage, 6292,
     /*  445338 */     GIR_EraseRootFromParent_Done,
     /*  445339 */   // Label 7713: @445339
     /*  445339 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(445425), // Rule ID 6293 //
     /*  445344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  445355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  445358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  445361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  445379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445391 */     // MIs[1] Operand 1
     /*  445391 */     // No operand predicates
     /*  445391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  445403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445423 */     GIR_RootConstrainSelectedInstOperands,
     /*  445424 */     // GIR_Coverage, 6293,
     /*  445424 */     GIR_EraseRootFromParent_Done,
     /*  445425 */   // Label 7714: @445425
     /*  445425 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(445511), // Rule ID 6296 //
     /*  445430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445477 */     // MIs[1] Operand 1
     /*  445477 */     // No operand predicates
     /*  445477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445509 */     GIR_RootConstrainSelectedInstOperands,
     /*  445510 */     // GIR_Coverage, 6296,
     /*  445510 */     GIR_EraseRootFromParent_Done,
     /*  445511 */   // Label 7715: @445511
     /*  445511 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(445597), // Rule ID 6297 //
     /*  445516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445563 */     // MIs[1] Operand 1
     /*  445563 */     // No operand predicates
     /*  445563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445595 */     GIR_RootConstrainSelectedInstOperands,
     /*  445596 */     // GIR_Coverage, 6297,
     /*  445596 */     GIR_EraseRootFromParent_Done,
     /*  445597 */   // Label 7716: @445597
     /*  445597 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(445683), // Rule ID 6300 //
     /*  445602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445649 */     // MIs[1] Operand 1
     /*  445649 */     // No operand predicates
     /*  445649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445681 */     GIR_RootConstrainSelectedInstOperands,
     /*  445682 */     // GIR_Coverage, 6300,
     /*  445682 */     GIR_EraseRootFromParent_Done,
     /*  445683 */   // Label 7717: @445683
     /*  445683 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(445769), // Rule ID 6301 //
     /*  445688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445735 */     // MIs[1] Operand 1
     /*  445735 */     // No operand predicates
     /*  445735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445767 */     GIR_RootConstrainSelectedInstOperands,
     /*  445768 */     // GIR_Coverage, 6301,
     /*  445768 */     GIR_EraseRootFromParent_Done,
     /*  445769 */   // Label 7718: @445769
     /*  445769 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(445855), // Rule ID 6480 //
     /*  445774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445821 */     // MIs[1] Operand 1
     /*  445821 */     // No operand predicates
     /*  445821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445853 */     GIR_RootConstrainSelectedInstOperands,
     /*  445854 */     // GIR_Coverage, 6480,
     /*  445854 */     GIR_EraseRootFromParent_Done,
     /*  445855 */   // Label 7719: @445855
     /*  445855 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(445941), // Rule ID 6481 //
     /*  445860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445907 */     // MIs[1] Operand 1
     /*  445907 */     // No operand predicates
     /*  445907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445939 */     GIR_RootConstrainSelectedInstOperands,
     /*  445940 */     // GIR_Coverage, 6481,
     /*  445940 */     GIR_EraseRootFromParent_Done,
     /*  445941 */   // Label 7720: @445941
     /*  445941 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(446027), // Rule ID 6484 //
     /*  445946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445993 */     // MIs[1] Operand 1
     /*  445993 */     // No operand predicates
     /*  445993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446025 */     GIR_RootConstrainSelectedInstOperands,
     /*  446026 */     // GIR_Coverage, 6484,
     /*  446026 */     GIR_EraseRootFromParent_Done,
     /*  446027 */   // Label 7721: @446027
     /*  446027 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(446113), // Rule ID 6485 //
     /*  446032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  446043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  446046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  446049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446079 */     // MIs[1] Operand 1
     /*  446079 */     // No operand predicates
     /*  446079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446088 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446111 */     GIR_RootConstrainSelectedInstOperands,
     /*  446112 */     // GIR_Coverage, 6485,
     /*  446112 */     GIR_EraseRootFromParent_Done,
     /*  446113 */   // Label 7722: @446113
     /*  446113 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(446199), // Rule ID 6488 //
     /*  446118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  446129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  446132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  446135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446165 */     // MIs[1] Operand 1
     /*  446165 */     // No operand predicates
     /*  446165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446197 */     GIR_RootConstrainSelectedInstOperands,
     /*  446198 */     // GIR_Coverage, 6488,
     /*  446198 */     GIR_EraseRootFromParent_Done,
     /*  446199 */   // Label 7723: @446199
     /*  446199 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(446285), // Rule ID 6489 //
     /*  446204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  446215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  446218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  446221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446251 */     // MIs[1] Operand 1
     /*  446251 */     // No operand predicates
     /*  446251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446283 */     GIR_RootConstrainSelectedInstOperands,
     /*  446284 */     // GIR_Coverage, 6489,
     /*  446284 */     GIR_EraseRootFromParent_Done,
     /*  446285 */   // Label 7724: @446285
     /*  446285 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(446371), // Rule ID 6492 //
     /*  446290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  446301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  446304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  446307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446337 */     // MIs[1] Operand 1
     /*  446337 */     // No operand predicates
     /*  446337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446369 */     GIR_RootConstrainSelectedInstOperands,
     /*  446370 */     // GIR_Coverage, 6492,
     /*  446370 */     GIR_EraseRootFromParent_Done,
     /*  446371 */   // Label 7725: @446371
     /*  446371 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(446457), // Rule ID 6493 //
     /*  446376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  446387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  446390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  446393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446423 */     // MIs[1] Operand 1
     /*  446423 */     // No operand predicates
     /*  446423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446432 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  446435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446455 */     GIR_RootConstrainSelectedInstOperands,
     /*  446456 */     // GIR_Coverage, 6493,
     /*  446456 */     GIR_EraseRootFromParent_Done,
     /*  446457 */   // Label 7726: @446457
     /*  446457 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(446543), // Rule ID 6496 //
     /*  446462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446509 */     // MIs[1] Operand 1
     /*  446509 */     // No operand predicates
     /*  446509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446541 */     GIR_RootConstrainSelectedInstOperands,
     /*  446542 */     // GIR_Coverage, 6496,
     /*  446542 */     GIR_EraseRootFromParent_Done,
     /*  446543 */   // Label 7727: @446543
     /*  446543 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(446629), // Rule ID 6497 //
     /*  446548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446595 */     // MIs[1] Operand 1
     /*  446595 */     // No operand predicates
     /*  446595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446627 */     GIR_RootConstrainSelectedInstOperands,
     /*  446628 */     // GIR_Coverage, 6497,
     /*  446628 */     GIR_EraseRootFromParent_Done,
     /*  446629 */   // Label 7728: @446629
     /*  446629 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(446715), // Rule ID 6500 //
     /*  446634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446681 */     // MIs[1] Operand 1
     /*  446681 */     // No operand predicates
     /*  446681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446713 */     GIR_RootConstrainSelectedInstOperands,
     /*  446714 */     // GIR_Coverage, 6500,
     /*  446714 */     GIR_EraseRootFromParent_Done,
     /*  446715 */   // Label 7729: @446715
     /*  446715 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(446801), // Rule ID 6501 //
     /*  446720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446767 */     // MIs[1] Operand 1
     /*  446767 */     // No operand predicates
     /*  446767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446799 */     GIR_RootConstrainSelectedInstOperands,
     /*  446800 */     // GIR_Coverage, 6501,
     /*  446800 */     GIR_EraseRootFromParent_Done,
     /*  446801 */   // Label 7730: @446801
     /*  446801 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(446887), // Rule ID 6504 //
     /*  446806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446853 */     // MIs[1] Operand 1
     /*  446853 */     // No operand predicates
     /*  446853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446885 */     GIR_RootConstrainSelectedInstOperands,
     /*  446886 */     // GIR_Coverage, 6504,
     /*  446886 */     GIR_EraseRootFromParent_Done,
     /*  446887 */   // Label 7731: @446887
     /*  446887 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(446973), // Rule ID 6505 //
     /*  446892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446939 */     // MIs[1] Operand 1
     /*  446939 */     // No operand predicates
     /*  446939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446971 */     GIR_RootConstrainSelectedInstOperands,
     /*  446972 */     // GIR_Coverage, 6505,
     /*  446972 */     GIR_EraseRootFromParent_Done,
     /*  446973 */   // Label 7732: @446973
     /*  446973 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(447059), // Rule ID 6508 //
     /*  446978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447025 */     // MIs[1] Operand 1
     /*  447025 */     // No operand predicates
     /*  447025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447057 */     GIR_RootConstrainSelectedInstOperands,
     /*  447058 */     // GIR_Coverage, 6508,
     /*  447058 */     GIR_EraseRootFromParent_Done,
     /*  447059 */   // Label 7733: @447059
     /*  447059 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(447145), // Rule ID 6509 //
     /*  447064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  447075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  447078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  447081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447111 */     // MIs[1] Operand 1
     /*  447111 */     // No operand predicates
     /*  447111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447143 */     GIR_RootConstrainSelectedInstOperands,
     /*  447144 */     // GIR_Coverage, 6509,
     /*  447144 */     GIR_EraseRootFromParent_Done,
     /*  447145 */   // Label 7734: @447145
     /*  447145 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(447231), // Rule ID 6512 //
     /*  447150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  447161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  447164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  447167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447197 */     // MIs[1] Operand 1
     /*  447197 */     // No operand predicates
     /*  447197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447229 */     GIR_RootConstrainSelectedInstOperands,
     /*  447230 */     // GIR_Coverage, 6512,
     /*  447230 */     GIR_EraseRootFromParent_Done,
     /*  447231 */   // Label 7735: @447231
     /*  447231 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(447317), // Rule ID 6513 //
     /*  447236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  447247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  447250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  447253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447283 */     // MIs[1] Operand 1
     /*  447283 */     // No operand predicates
     /*  447283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447315 */     GIR_RootConstrainSelectedInstOperands,
     /*  447316 */     // GIR_Coverage, 6513,
     /*  447316 */     GIR_EraseRootFromParent_Done,
     /*  447317 */   // Label 7736: @447317
     /*  447317 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(447403), // Rule ID 6516 //
     /*  447322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  447325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447369 */     // MIs[1] Operand 1
     /*  447369 */     // No operand predicates
     /*  447369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  447378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447401 */     GIR_RootConstrainSelectedInstOperands,
     /*  447402 */     // GIR_Coverage, 6516,
     /*  447402 */     GIR_EraseRootFromParent_Done,
     /*  447403 */   // Label 7737: @447403
     /*  447403 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(447489), // Rule ID 6517 //
     /*  447408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  447411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447455 */     // MIs[1] Operand 1
     /*  447455 */     // No operand predicates
     /*  447455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  447464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447487 */     GIR_RootConstrainSelectedInstOperands,
     /*  447488 */     // GIR_Coverage, 6517,
     /*  447488 */     GIR_EraseRootFromParent_Done,
     /*  447489 */   // Label 7738: @447489
     /*  447489 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(447575), // Rule ID 6520 //
     /*  447494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447541 */     // MIs[1] Operand 1
     /*  447541 */     // No operand predicates
     /*  447541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447573 */     GIR_RootConstrainSelectedInstOperands,
     /*  447574 */     // GIR_Coverage, 6520,
     /*  447574 */     GIR_EraseRootFromParent_Done,
     /*  447575 */   // Label 7739: @447575
     /*  447575 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(447661), // Rule ID 6521 //
     /*  447580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447627 */     // MIs[1] Operand 1
     /*  447627 */     // No operand predicates
     /*  447627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447659 */     GIR_RootConstrainSelectedInstOperands,
     /*  447660 */     // GIR_Coverage, 6521,
     /*  447660 */     GIR_EraseRootFromParent_Done,
     /*  447661 */   // Label 7740: @447661
     /*  447661 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(447747), // Rule ID 6524 //
     /*  447666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447713 */     // MIs[1] Operand 1
     /*  447713 */     // No operand predicates
     /*  447713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447722 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447745 */     GIR_RootConstrainSelectedInstOperands,
     /*  447746 */     // GIR_Coverage, 6524,
     /*  447746 */     GIR_EraseRootFromParent_Done,
     /*  447747 */   // Label 7741: @447747
     /*  447747 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(447833), // Rule ID 6525 //
     /*  447752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447799 */     // MIs[1] Operand 1
     /*  447799 */     // No operand predicates
     /*  447799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447831 */     GIR_RootConstrainSelectedInstOperands,
     /*  447832 */     // GIR_Coverage, 6525,
     /*  447832 */     GIR_EraseRootFromParent_Done,
     /*  447833 */   // Label 7742: @447833
     /*  447833 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(447919), // Rule ID 6528 //
     /*  447838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447885 */     // MIs[1] Operand 1
     /*  447885 */     // No operand predicates
     /*  447885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447917 */     GIR_RootConstrainSelectedInstOperands,
     /*  447918 */     // GIR_Coverage, 6528,
     /*  447918 */     GIR_EraseRootFromParent_Done,
     /*  447919 */   // Label 7743: @447919
     /*  447919 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(448005), // Rule ID 6529 //
     /*  447924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447971 */     // MIs[1] Operand 1
     /*  447971 */     // No operand predicates
     /*  447971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448003 */     GIR_RootConstrainSelectedInstOperands,
     /*  448004 */     // GIR_Coverage, 6529,
     /*  448004 */     GIR_EraseRootFromParent_Done,
     /*  448005 */   // Label 7744: @448005
     /*  448005 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(448091), // Rule ID 6532 //
     /*  448010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  448021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  448024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  448027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448057 */     // MIs[1] Operand 1
     /*  448057 */     // No operand predicates
     /*  448057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448089 */     GIR_RootConstrainSelectedInstOperands,
     /*  448090 */     // GIR_Coverage, 6532,
     /*  448090 */     GIR_EraseRootFromParent_Done,
     /*  448091 */   // Label 7745: @448091
     /*  448091 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(448177), // Rule ID 6533 //
     /*  448096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  448107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  448110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  448113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448143 */     // MIs[1] Operand 1
     /*  448143 */     // No operand predicates
     /*  448143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448175 */     GIR_RootConstrainSelectedInstOperands,
     /*  448176 */     // GIR_Coverage, 6533,
     /*  448176 */     GIR_EraseRootFromParent_Done,
     /*  448177 */   // Label 7746: @448177
     /*  448177 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(448263), // Rule ID 6536 //
     /*  448182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  448199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448229 */     // MIs[1] Operand 1
     /*  448229 */     // No operand predicates
     /*  448229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448238 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448261 */     GIR_RootConstrainSelectedInstOperands,
     /*  448262 */     // GIR_Coverage, 6536,
     /*  448262 */     GIR_EraseRootFromParent_Done,
     /*  448263 */   // Label 7747: @448263
     /*  448263 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(448349), // Rule ID 6537 //
     /*  448268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  448279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  448282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  448285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448315 */     // MIs[1] Operand 1
     /*  448315 */     // No operand predicates
     /*  448315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448347 */     GIR_RootConstrainSelectedInstOperands,
     /*  448348 */     // GIR_Coverage, 6537,
     /*  448348 */     GIR_EraseRootFromParent_Done,
     /*  448349 */   // Label 7748: @448349
     /*  448349 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(448435), // Rule ID 6540 //
     /*  448354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448401 */     // MIs[1] Operand 1
     /*  448401 */     // No operand predicates
     /*  448401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448433 */     GIR_RootConstrainSelectedInstOperands,
     /*  448434 */     // GIR_Coverage, 6540,
     /*  448434 */     GIR_EraseRootFromParent_Done,
     /*  448435 */   // Label 7749: @448435
     /*  448435 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(448521), // Rule ID 6541 //
     /*  448440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448487 */     // MIs[1] Operand 1
     /*  448487 */     // No operand predicates
     /*  448487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448496 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448519 */     GIR_RootConstrainSelectedInstOperands,
     /*  448520 */     // GIR_Coverage, 6541,
     /*  448520 */     GIR_EraseRootFromParent_Done,
     /*  448521 */   // Label 7750: @448521
     /*  448521 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(448607), // Rule ID 6544 //
     /*  448526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448573 */     // MIs[1] Operand 1
     /*  448573 */     // No operand predicates
     /*  448573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448605 */     GIR_RootConstrainSelectedInstOperands,
     /*  448606 */     // GIR_Coverage, 6544,
     /*  448606 */     GIR_EraseRootFromParent_Done,
     /*  448607 */   // Label 7751: @448607
     /*  448607 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(448693), // Rule ID 6545 //
     /*  448612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448659 */     // MIs[1] Operand 1
     /*  448659 */     // No operand predicates
     /*  448659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448691 */     GIR_RootConstrainSelectedInstOperands,
     /*  448692 */     // GIR_Coverage, 6545,
     /*  448692 */     GIR_EraseRootFromParent_Done,
     /*  448693 */   // Label 7752: @448693
     /*  448693 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(448779), // Rule ID 6548 //
     /*  448698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448745 */     // MIs[1] Operand 1
     /*  448745 */     // No operand predicates
     /*  448745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448777 */     GIR_RootConstrainSelectedInstOperands,
     /*  448778 */     // GIR_Coverage, 6548,
     /*  448778 */     GIR_EraseRootFromParent_Done,
     /*  448779 */   // Label 7753: @448779
     /*  448779 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(448865), // Rule ID 6549 //
     /*  448784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448831 */     // MIs[1] Operand 1
     /*  448831 */     // No operand predicates
     /*  448831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448863 */     GIR_RootConstrainSelectedInstOperands,
     /*  448864 */     // GIR_Coverage, 6549,
     /*  448864 */     GIR_EraseRootFromParent_Done,
     /*  448865 */   // Label 7754: @448865
     /*  448865 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(448951), // Rule ID 6552 //
     /*  448870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448917 */     // MIs[1] Operand 1
     /*  448917 */     // No operand predicates
     /*  448917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448949 */     GIR_RootConstrainSelectedInstOperands,
     /*  448950 */     // GIR_Coverage, 6552,
     /*  448950 */     GIR_EraseRootFromParent_Done,
     /*  448951 */   // Label 7755: @448951
     /*  448951 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(449037), // Rule ID 6553 //
     /*  448956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449003 */     // MIs[1] Operand 1
     /*  449003 */     // No operand predicates
     /*  449003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449035 */     GIR_RootConstrainSelectedInstOperands,
     /*  449036 */     // GIR_Coverage, 6553,
     /*  449036 */     GIR_EraseRootFromParent_Done,
     /*  449037 */   // Label 7756: @449037
     /*  449037 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(449123), // Rule ID 6556 //
     /*  449042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  449059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449089 */     // MIs[1] Operand 1
     /*  449089 */     // No operand predicates
     /*  449089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  449101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449121 */     GIR_RootConstrainSelectedInstOperands,
     /*  449122 */     // GIR_Coverage, 6556,
     /*  449122 */     GIR_EraseRootFromParent_Done,
     /*  449123 */   // Label 7757: @449123
     /*  449123 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(449209), // Rule ID 6557 //
     /*  449128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  449139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  449142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  449145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  449163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449175 */     // MIs[1] Operand 1
     /*  449175 */     // No operand predicates
     /*  449175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  449187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449207 */     GIR_RootConstrainSelectedInstOperands,
     /*  449208 */     // GIR_Coverage, 6557,
     /*  449208 */     GIR_EraseRootFromParent_Done,
     /*  449209 */   // Label 7758: @449209
     /*  449209 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(449295), // Rule ID 6560 //
     /*  449214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  449231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449261 */     // MIs[1] Operand 1
     /*  449261 */     // No operand predicates
     /*  449261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  449273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449293 */     GIR_RootConstrainSelectedInstOperands,
     /*  449294 */     // GIR_Coverage, 6560,
     /*  449294 */     GIR_EraseRootFromParent_Done,
     /*  449295 */   // Label 7759: @449295
     /*  449295 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(449381), // Rule ID 6561 //
     /*  449300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  449311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  449314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  449317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  449335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449347 */     // MIs[1] Operand 1
     /*  449347 */     // No operand predicates
     /*  449347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  449359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449379 */     GIR_RootConstrainSelectedInstOperands,
     /*  449380 */     // GIR_Coverage, 6561,
     /*  449380 */     GIR_EraseRootFromParent_Done,
     /*  449381 */   // Label 7760: @449381
     /*  449381 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(449467), // Rule ID 6564 //
     /*  449386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  449389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449433 */     // MIs[1] Operand 1
     /*  449433 */     // No operand predicates
     /*  449433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449465 */     GIR_RootConstrainSelectedInstOperands,
     /*  449466 */     // GIR_Coverage, 6564,
     /*  449466 */     GIR_EraseRootFromParent_Done,
     /*  449467 */   // Label 7761: @449467
     /*  449467 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(449553), // Rule ID 6565 //
     /*  449472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449519 */     // MIs[1] Operand 1
     /*  449519 */     // No operand predicates
     /*  449519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449551 */     GIR_RootConstrainSelectedInstOperands,
     /*  449552 */     // GIR_Coverage, 6565,
     /*  449552 */     GIR_EraseRootFromParent_Done,
     /*  449553 */   // Label 7762: @449553
     /*  449553 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(449639), // Rule ID 6744 //
     /*  449558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449605 */     // MIs[1] Operand 1
     /*  449605 */     // No operand predicates
     /*  449605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449637 */     GIR_RootConstrainSelectedInstOperands,
     /*  449638 */     // GIR_Coverage, 6744,
     /*  449638 */     GIR_EraseRootFromParent_Done,
     /*  449639 */   // Label 7763: @449639
     /*  449639 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(449725), // Rule ID 6745 //
     /*  449644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449691 */     // MIs[1] Operand 1
     /*  449691 */     // No operand predicates
     /*  449691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449723 */     GIR_RootConstrainSelectedInstOperands,
     /*  449724 */     // GIR_Coverage, 6745,
     /*  449724 */     GIR_EraseRootFromParent_Done,
     /*  449725 */   // Label 7764: @449725
     /*  449725 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(449811), // Rule ID 6748 //
     /*  449730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449777 */     // MIs[1] Operand 1
     /*  449777 */     // No operand predicates
     /*  449777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449809 */     GIR_RootConstrainSelectedInstOperands,
     /*  449810 */     // GIR_Coverage, 6748,
     /*  449810 */     GIR_EraseRootFromParent_Done,
     /*  449811 */   // Label 7765: @449811
     /*  449811 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(449897), // Rule ID 6749 //
     /*  449816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449863 */     // MIs[1] Operand 1
     /*  449863 */     // No operand predicates
     /*  449863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449872 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449895 */     GIR_RootConstrainSelectedInstOperands,
     /*  449896 */     // GIR_Coverage, 6749,
     /*  449896 */     GIR_EraseRootFromParent_Done,
     /*  449897 */   // Label 7766: @449897
     /*  449897 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(449983), // Rule ID 6752 //
     /*  449902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449949 */     // MIs[1] Operand 1
     /*  449949 */     // No operand predicates
     /*  449949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449981 */     GIR_RootConstrainSelectedInstOperands,
     /*  449982 */     // GIR_Coverage, 6752,
     /*  449982 */     GIR_EraseRootFromParent_Done,
     /*  449983 */   // Label 7767: @449983
     /*  449983 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(450069), // Rule ID 6753 //
     /*  449988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  450002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  450005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450035 */     // MIs[1] Operand 1
     /*  450035 */     // No operand predicates
     /*  450035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450067 */     GIR_RootConstrainSelectedInstOperands,
     /*  450068 */     // GIR_Coverage, 6753,
     /*  450068 */     GIR_EraseRootFromParent_Done,
     /*  450069 */   // Label 7768: @450069
     /*  450069 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(450155), // Rule ID 6756 //
     /*  450074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  450085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  450088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  450091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450121 */     // MIs[1] Operand 1
     /*  450121 */     // No operand predicates
     /*  450121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  450133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450153 */     GIR_RootConstrainSelectedInstOperands,
     /*  450154 */     // GIR_Coverage, 6756,
     /*  450154 */     GIR_EraseRootFromParent_Done,
     /*  450155 */   // Label 7769: @450155
     /*  450155 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(450241), // Rule ID 6757 //
     /*  450160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  450171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  450174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  450177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450207 */     // MIs[1] Operand 1
     /*  450207 */     // No operand predicates
     /*  450207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  450219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450239 */     GIR_RootConstrainSelectedInstOperands,
     /*  450240 */     // GIR_Coverage, 6757,
     /*  450240 */     GIR_EraseRootFromParent_Done,
     /*  450241 */   // Label 7770: @450241
     /*  450241 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(450327), // Rule ID 6760 //
     /*  450246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  450257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  450260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  450263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450293 */     // MIs[1] Operand 1
     /*  450293 */     // No operand predicates
     /*  450293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450325 */     GIR_RootConstrainSelectedInstOperands,
     /*  450326 */     // GIR_Coverage, 6760,
     /*  450326 */     GIR_EraseRootFromParent_Done,
     /*  450327 */   // Label 7771: @450327
     /*  450327 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(450413), // Rule ID 6761 //
     /*  450332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  450343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  450346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  450349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450379 */     // MIs[1] Operand 1
     /*  450379 */     // No operand predicates
     /*  450379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450388 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450411 */     GIR_RootConstrainSelectedInstOperands,
     /*  450412 */     // GIR_Coverage, 6761,
     /*  450412 */     GIR_EraseRootFromParent_Done,
     /*  450413 */   // Label 7772: @450413
     /*  450413 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(450499), // Rule ID 6764 //
     /*  450418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450465 */     // MIs[1] Operand 1
     /*  450465 */     // No operand predicates
     /*  450465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450497 */     GIR_RootConstrainSelectedInstOperands,
     /*  450498 */     // GIR_Coverage, 6764,
     /*  450498 */     GIR_EraseRootFromParent_Done,
     /*  450499 */   // Label 7773: @450499
     /*  450499 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(450585), // Rule ID 6765 //
     /*  450504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450551 */     // MIs[1] Operand 1
     /*  450551 */     // No operand predicates
     /*  450551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450583 */     GIR_RootConstrainSelectedInstOperands,
     /*  450584 */     // GIR_Coverage, 6765,
     /*  450584 */     GIR_EraseRootFromParent_Done,
     /*  450585 */   // Label 7774: @450585
     /*  450585 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(450671), // Rule ID 6768 //
     /*  450590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450637 */     // MIs[1] Operand 1
     /*  450637 */     // No operand predicates
     /*  450637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450669 */     GIR_RootConstrainSelectedInstOperands,
     /*  450670 */     // GIR_Coverage, 6768,
     /*  450670 */     GIR_EraseRootFromParent_Done,
     /*  450671 */   // Label 7775: @450671
     /*  450671 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(450757), // Rule ID 6769 //
     /*  450676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450723 */     // MIs[1] Operand 1
     /*  450723 */     // No operand predicates
     /*  450723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450755 */     GIR_RootConstrainSelectedInstOperands,
     /*  450756 */     // GIR_Coverage, 6769,
     /*  450756 */     GIR_EraseRootFromParent_Done,
     /*  450757 */   // Label 7776: @450757
     /*  450757 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(450843), // Rule ID 6772 //
     /*  450762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450809 */     // MIs[1] Operand 1
     /*  450809 */     // No operand predicates
     /*  450809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450841 */     GIR_RootConstrainSelectedInstOperands,
     /*  450842 */     // GIR_Coverage, 6772,
     /*  450842 */     GIR_EraseRootFromParent_Done,
     /*  450843 */   // Label 7777: @450843
     /*  450843 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(450929), // Rule ID 6773 //
     /*  450848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450895 */     // MIs[1] Operand 1
     /*  450895 */     // No operand predicates
     /*  450895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450927 */     GIR_RootConstrainSelectedInstOperands,
     /*  450928 */     // GIR_Coverage, 6773,
     /*  450928 */     GIR_EraseRootFromParent_Done,
     /*  450929 */   // Label 7778: @450929
     /*  450929 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(451015), // Rule ID 6776 //
     /*  450934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450981 */     // MIs[1] Operand 1
     /*  450981 */     // No operand predicates
     /*  450981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451013 */     GIR_RootConstrainSelectedInstOperands,
     /*  451014 */     // GIR_Coverage, 6776,
     /*  451014 */     GIR_EraseRootFromParent_Done,
     /*  451015 */   // Label 7779: @451015
     /*  451015 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(451101), // Rule ID 6777 //
     /*  451020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  451031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  451034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  451037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451067 */     // MIs[1] Operand 1
     /*  451067 */     // No operand predicates
     /*  451067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451099 */     GIR_RootConstrainSelectedInstOperands,
     /*  451100 */     // GIR_Coverage, 6777,
     /*  451100 */     GIR_EraseRootFromParent_Done,
     /*  451101 */   // Label 7780: @451101
     /*  451101 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(451187), // Rule ID 6780 //
     /*  451106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  451109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  451123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451153 */     // MIs[1] Operand 1
     /*  451153 */     // No operand predicates
     /*  451153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  451162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  451182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451185 */     GIR_RootConstrainSelectedInstOperands,
     /*  451186 */     // GIR_Coverage, 6780,
     /*  451186 */     GIR_EraseRootFromParent_Done,
     /*  451187 */   // Label 7781: @451187
     /*  451187 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(451273), // Rule ID 6781 //
     /*  451192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  451195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  451203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  451206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  451209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  451227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451239 */     // MIs[1] Operand 1
     /*  451239 */     // No operand predicates
     /*  451239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  451248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  451251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  451268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451271 */     GIR_RootConstrainSelectedInstOperands,
     /*  451272 */     // GIR_Coverage, 6781,
     /*  451272 */     GIR_EraseRootFromParent_Done,
     /*  451273 */   // Label 7782: @451273
     /*  451273 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(451359), // Rule ID 6784 //
     /*  451278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  451289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  451292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  451295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451325 */     // MIs[1] Operand 1
     /*  451325 */     // No operand predicates
     /*  451325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451357 */     GIR_RootConstrainSelectedInstOperands,
     /*  451358 */     // GIR_Coverage, 6784,
     /*  451358 */     GIR_EraseRootFromParent_Done,
     /*  451359 */   // Label 7783: @451359
     /*  451359 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(451445), // Rule ID 6785 //
     /*  451364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  451375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  451378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  451381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451411 */     // MIs[1] Operand 1
     /*  451411 */     // No operand predicates
     /*  451411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451443 */     GIR_RootConstrainSelectedInstOperands,
     /*  451444 */     // GIR_Coverage, 6785,
     /*  451444 */     GIR_EraseRootFromParent_Done,
     /*  451445 */   // Label 7784: @451445
     /*  451445 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(451531), // Rule ID 6788 //
     /*  451450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451497 */     // MIs[1] Operand 1
     /*  451497 */     // No operand predicates
     /*  451497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451529 */     GIR_RootConstrainSelectedInstOperands,
     /*  451530 */     // GIR_Coverage, 6788,
     /*  451530 */     GIR_EraseRootFromParent_Done,
     /*  451531 */   // Label 7785: @451531
     /*  451531 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(451617), // Rule ID 6789 //
     /*  451536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451583 */     // MIs[1] Operand 1
     /*  451583 */     // No operand predicates
     /*  451583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451615 */     GIR_RootConstrainSelectedInstOperands,
     /*  451616 */     // GIR_Coverage, 6789,
     /*  451616 */     GIR_EraseRootFromParent_Done,
     /*  451617 */   // Label 7786: @451617
     /*  451617 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(451703), // Rule ID 6792 //
     /*  451622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451669 */     // MIs[1] Operand 1
     /*  451669 */     // No operand predicates
     /*  451669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451701 */     GIR_RootConstrainSelectedInstOperands,
     /*  451702 */     // GIR_Coverage, 6792,
     /*  451702 */     GIR_EraseRootFromParent_Done,
     /*  451703 */   // Label 7787: @451703
     /*  451703 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(451789), // Rule ID 6793 //
     /*  451708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451755 */     // MIs[1] Operand 1
     /*  451755 */     // No operand predicates
     /*  451755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451787 */     GIR_RootConstrainSelectedInstOperands,
     /*  451788 */     // GIR_Coverage, 6793,
     /*  451788 */     GIR_EraseRootFromParent_Done,
     /*  451789 */   // Label 7788: @451789
     /*  451789 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(451875), // Rule ID 6796 //
     /*  451794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451841 */     // MIs[1] Operand 1
     /*  451841 */     // No operand predicates
     /*  451841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451873 */     GIR_RootConstrainSelectedInstOperands,
     /*  451874 */     // GIR_Coverage, 6796,
     /*  451874 */     GIR_EraseRootFromParent_Done,
     /*  451875 */   // Label 7789: @451875
     /*  451875 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(451961), // Rule ID 6797 //
     /*  451880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451927 */     // MIs[1] Operand 1
     /*  451927 */     // No operand predicates
     /*  451927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451959 */     GIR_RootConstrainSelectedInstOperands,
     /*  451960 */     // GIR_Coverage, 6797,
     /*  451960 */     GIR_EraseRootFromParent_Done,
     /*  451961 */   // Label 7790: @451961
     /*  451961 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(452047), // Rule ID 6800 //
     /*  451966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452013 */     // MIs[1] Operand 1
     /*  452013 */     // No operand predicates
     /*  452013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  452022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452045 */     GIR_RootConstrainSelectedInstOperands,
     /*  452046 */     // GIR_Coverage, 6800,
     /*  452046 */     GIR_EraseRootFromParent_Done,
     /*  452047 */   // Label 7791: @452047
     /*  452047 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(452133), // Rule ID 6801 //
     /*  452052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  452063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  452066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  452069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452099 */     // MIs[1] Operand 1
     /*  452099 */     // No operand predicates
     /*  452099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  452108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452131 */     GIR_RootConstrainSelectedInstOperands,
     /*  452132 */     // GIR_Coverage, 6801,
     /*  452132 */     GIR_EraseRootFromParent_Done,
     /*  452133 */   // Label 7792: @452133
     /*  452133 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(452219), // Rule ID 6804 //
     /*  452138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  452149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  452152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  452155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452185 */     // MIs[1] Operand 1
     /*  452185 */     // No operand predicates
     /*  452185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  452194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452217 */     GIR_RootConstrainSelectedInstOperands,
     /*  452218 */     // GIR_Coverage, 6804,
     /*  452218 */     GIR_EraseRootFromParent_Done,
     /*  452219 */   // Label 7793: @452219
     /*  452219 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(452305), // Rule ID 6805 //
     /*  452224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  452235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  452238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  452241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452271 */     // MIs[1] Operand 1
     /*  452271 */     // No operand predicates
     /*  452271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452280 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  452280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452303 */     GIR_RootConstrainSelectedInstOperands,
     /*  452304 */     // GIR_Coverage, 6805,
     /*  452304 */     GIR_EraseRootFromParent_Done,
     /*  452305 */   // Label 7794: @452305
     /*  452305 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(452391), // Rule ID 6808 //
     /*  452310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452357 */     // MIs[1] Operand 1
     /*  452357 */     // No operand predicates
     /*  452357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452389 */     GIR_RootConstrainSelectedInstOperands,
     /*  452390 */     // GIR_Coverage, 6808,
     /*  452390 */     GIR_EraseRootFromParent_Done,
     /*  452391 */   // Label 7795: @452391
     /*  452391 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(452477), // Rule ID 6809 //
     /*  452396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452443 */     // MIs[1] Operand 1
     /*  452443 */     // No operand predicates
     /*  452443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452475 */     GIR_RootConstrainSelectedInstOperands,
     /*  452476 */     // GIR_Coverage, 6809,
     /*  452476 */     GIR_EraseRootFromParent_Done,
     /*  452477 */   // Label 7796: @452477
     /*  452477 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(452563), // Rule ID 6812 //
     /*  452482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452529 */     // MIs[1] Operand 1
     /*  452529 */     // No operand predicates
     /*  452529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452561 */     GIR_RootConstrainSelectedInstOperands,
     /*  452562 */     // GIR_Coverage, 6812,
     /*  452562 */     GIR_EraseRootFromParent_Done,
     /*  452563 */   // Label 7797: @452563
     /*  452563 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(452649), // Rule ID 6813 //
     /*  452568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452615 */     // MIs[1] Operand 1
     /*  452615 */     // No operand predicates
     /*  452615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452647 */     GIR_RootConstrainSelectedInstOperands,
     /*  452648 */     // GIR_Coverage, 6813,
     /*  452648 */     GIR_EraseRootFromParent_Done,
     /*  452649 */   // Label 7798: @452649
     /*  452649 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(452735), // Rule ID 6816 //
     /*  452654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452701 */     // MIs[1] Operand 1
     /*  452701 */     // No operand predicates
     /*  452701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452733 */     GIR_RootConstrainSelectedInstOperands,
     /*  452734 */     // GIR_Coverage, 6816,
     /*  452734 */     GIR_EraseRootFromParent_Done,
     /*  452735 */   // Label 7799: @452735
     /*  452735 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(452821), // Rule ID 6817 //
     /*  452740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452787 */     // MIs[1] Operand 1
     /*  452787 */     // No operand predicates
     /*  452787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452819 */     GIR_RootConstrainSelectedInstOperands,
     /*  452820 */     // GIR_Coverage, 6817,
     /*  452820 */     GIR_EraseRootFromParent_Done,
     /*  452821 */   // Label 7800: @452821
     /*  452821 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(452907), // Rule ID 6820 //
     /*  452826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452873 */     // MIs[1] Operand 1
     /*  452873 */     // No operand predicates
     /*  452873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452905 */     GIR_RootConstrainSelectedInstOperands,
     /*  452906 */     // GIR_Coverage, 6820,
     /*  452906 */     GIR_EraseRootFromParent_Done,
     /*  452907 */   // Label 7801: @452907
     /*  452907 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(452993), // Rule ID 6821 //
     /*  452912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452959 */     // MIs[1] Operand 1
     /*  452959 */     // No operand predicates
     /*  452959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452991 */     GIR_RootConstrainSelectedInstOperands,
     /*  452992 */     // GIR_Coverage, 6821,
     /*  452992 */     GIR_EraseRootFromParent_Done,
     /*  452993 */   // Label 7802: @452993
     /*  452993 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(453079), // Rule ID 6824 //
     /*  452998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  453009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  453012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  453015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453045 */     // MIs[1] Operand 1
     /*  453045 */     // No operand predicates
     /*  453045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  453057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453077 */     GIR_RootConstrainSelectedInstOperands,
     /*  453078 */     // GIR_Coverage, 6824,
     /*  453078 */     GIR_EraseRootFromParent_Done,
     /*  453079 */   // Label 7803: @453079
     /*  453079 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(453165), // Rule ID 6825 //
     /*  453084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  453087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  453095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  453098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  453101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  453119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453131 */     // MIs[1] Operand 1
     /*  453131 */     // No operand predicates
     /*  453131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  453140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  453143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453163 */     GIR_RootConstrainSelectedInstOperands,
     /*  453164 */     // GIR_Coverage, 6825,
     /*  453164 */     GIR_EraseRootFromParent_Done,
     /*  453165 */   // Label 7804: @453165
     /*  453165 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(453251), // Rule ID 6828 //
     /*  453170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  453181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  453184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  453187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453217 */     // MIs[1] Operand 1
     /*  453217 */     // No operand predicates
     /*  453217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  453229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453249 */     GIR_RootConstrainSelectedInstOperands,
     /*  453250 */     // GIR_Coverage, 6828,
     /*  453250 */     GIR_EraseRootFromParent_Done,
     /*  453251 */   // Label 7805: @453251
     /*  453251 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(453337), // Rule ID 6829 //
     /*  453256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  453259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  453267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  453270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  453273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  453291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453303 */     // MIs[1] Operand 1
     /*  453303 */     // No operand predicates
     /*  453303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  453312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  453315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453335 */     GIR_RootConstrainSelectedInstOperands,
     /*  453336 */     // GIR_Coverage, 6829,
     /*  453336 */     GIR_EraseRootFromParent_Done,
     /*  453337 */   // Label 7806: @453337
     /*  453337 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(453423), // Rule ID 7008 //
     /*  453342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453389 */     // MIs[1] Operand 1
     /*  453389 */     // No operand predicates
     /*  453389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453421 */     GIR_RootConstrainSelectedInstOperands,
     /*  453422 */     // GIR_Coverage, 7008,
     /*  453422 */     GIR_EraseRootFromParent_Done,
     /*  453423 */   // Label 7807: @453423
     /*  453423 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(453509), // Rule ID 7009 //
     /*  453428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453475 */     // MIs[1] Operand 1
     /*  453475 */     // No operand predicates
     /*  453475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453507 */     GIR_RootConstrainSelectedInstOperands,
     /*  453508 */     // GIR_Coverage, 7009,
     /*  453508 */     GIR_EraseRootFromParent_Done,
     /*  453509 */   // Label 7808: @453509
     /*  453509 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(453595), // Rule ID 7012 //
     /*  453514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453561 */     // MIs[1] Operand 1
     /*  453561 */     // No operand predicates
     /*  453561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453593 */     GIR_RootConstrainSelectedInstOperands,
     /*  453594 */     // GIR_Coverage, 7012,
     /*  453594 */     GIR_EraseRootFromParent_Done,
     /*  453595 */   // Label 7809: @453595
     /*  453595 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(453681), // Rule ID 7013 //
     /*  453600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453647 */     // MIs[1] Operand 1
     /*  453647 */     // No operand predicates
     /*  453647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453656 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453679 */     GIR_RootConstrainSelectedInstOperands,
     /*  453680 */     // GIR_Coverage, 7013,
     /*  453680 */     GIR_EraseRootFromParent_Done,
     /*  453681 */   // Label 7810: @453681
     /*  453681 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(453767), // Rule ID 7016 //
     /*  453686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453733 */     // MIs[1] Operand 1
     /*  453733 */     // No operand predicates
     /*  453733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453765 */     GIR_RootConstrainSelectedInstOperands,
     /*  453766 */     // GIR_Coverage, 7016,
     /*  453766 */     GIR_EraseRootFromParent_Done,
     /*  453767 */   // Label 7811: @453767
     /*  453767 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(453853), // Rule ID 7017 //
     /*  453772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453819 */     // MIs[1] Operand 1
     /*  453819 */     // No operand predicates
     /*  453819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453851 */     GIR_RootConstrainSelectedInstOperands,
     /*  453852 */     // GIR_Coverage, 7017,
     /*  453852 */     GIR_EraseRootFromParent_Done,
     /*  453853 */   // Label 7812: @453853
     /*  453853 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(453939), // Rule ID 7020 //
     /*  453858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453905 */     // MIs[1] Operand 1
     /*  453905 */     // No operand predicates
     /*  453905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453937 */     GIR_RootConstrainSelectedInstOperands,
     /*  453938 */     // GIR_Coverage, 7020,
     /*  453938 */     GIR_EraseRootFromParent_Done,
     /*  453939 */   // Label 7813: @453939
     /*  453939 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(454025), // Rule ID 7021 //
     /*  453944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453991 */     // MIs[1] Operand 1
     /*  453991 */     // No operand predicates
     /*  453991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  454003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454023 */     GIR_RootConstrainSelectedInstOperands,
     /*  454024 */     // GIR_Coverage, 7021,
     /*  454024 */     GIR_EraseRootFromParent_Done,
     /*  454025 */   // Label 7814: @454025
     /*  454025 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(454111), // Rule ID 7024 //
     /*  454030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  454041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  454044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  454047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454077 */     // MIs[1] Operand 1
     /*  454077 */     // No operand predicates
     /*  454077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454109 */     GIR_RootConstrainSelectedInstOperands,
     /*  454110 */     // GIR_Coverage, 7024,
     /*  454110 */     GIR_EraseRootFromParent_Done,
     /*  454111 */   // Label 7815: @454111
     /*  454111 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(454197), // Rule ID 7025 //
     /*  454116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  454127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  454130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  454133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454163 */     // MIs[1] Operand 1
     /*  454163 */     // No operand predicates
     /*  454163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454195 */     GIR_RootConstrainSelectedInstOperands,
     /*  454196 */     // GIR_Coverage, 7025,
     /*  454196 */     GIR_EraseRootFromParent_Done,
     /*  454197 */   // Label 7816: @454197
     /*  454197 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(454283), // Rule ID 7028 //
     /*  454202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  454213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  454216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  454219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454249 */     // MIs[1] Operand 1
     /*  454249 */     // No operand predicates
     /*  454249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454281 */     GIR_RootConstrainSelectedInstOperands,
     /*  454282 */     // GIR_Coverage, 7028,
     /*  454282 */     GIR_EraseRootFromParent_Done,
     /*  454283 */   // Label 7817: @454283
     /*  454283 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(454369), // Rule ID 7029 //
     /*  454288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  454299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  454302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  454305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454335 */     // MIs[1] Operand 1
     /*  454335 */     // No operand predicates
     /*  454335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  454347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454367 */     GIR_RootConstrainSelectedInstOperands,
     /*  454368 */     // GIR_Coverage, 7029,
     /*  454368 */     GIR_EraseRootFromParent_Done,
     /*  454369 */   // Label 7818: @454369
     /*  454369 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(454455), // Rule ID 7032 //
     /*  454374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454421 */     // MIs[1] Operand 1
     /*  454421 */     // No operand predicates
     /*  454421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454453 */     GIR_RootConstrainSelectedInstOperands,
     /*  454454 */     // GIR_Coverage, 7032,
     /*  454454 */     GIR_EraseRootFromParent_Done,
     /*  454455 */   // Label 7819: @454455
     /*  454455 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(454541), // Rule ID 7033 //
     /*  454460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454507 */     // MIs[1] Operand 1
     /*  454507 */     // No operand predicates
     /*  454507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454539 */     GIR_RootConstrainSelectedInstOperands,
     /*  454540 */     // GIR_Coverage, 7033,
     /*  454540 */     GIR_EraseRootFromParent_Done,
     /*  454541 */   // Label 7820: @454541
     /*  454541 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(454627), // Rule ID 7036 //
     /*  454546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454593 */     // MIs[1] Operand 1
     /*  454593 */     // No operand predicates
     /*  454593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454625 */     GIR_RootConstrainSelectedInstOperands,
     /*  454626 */     // GIR_Coverage, 7036,
     /*  454626 */     GIR_EraseRootFromParent_Done,
     /*  454627 */   // Label 7821: @454627
     /*  454627 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(454713), // Rule ID 7037 //
     /*  454632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454679 */     // MIs[1] Operand 1
     /*  454679 */     // No operand predicates
     /*  454679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454711 */     GIR_RootConstrainSelectedInstOperands,
     /*  454712 */     // GIR_Coverage, 7037,
     /*  454712 */     GIR_EraseRootFromParent_Done,
     /*  454713 */   // Label 7822: @454713
     /*  454713 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(454799), // Rule ID 7040 //
     /*  454718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454765 */     // MIs[1] Operand 1
     /*  454765 */     // No operand predicates
     /*  454765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454797 */     GIR_RootConstrainSelectedInstOperands,
     /*  454798 */     // GIR_Coverage, 7040,
     /*  454798 */     GIR_EraseRootFromParent_Done,
     /*  454799 */   // Label 7823: @454799
     /*  454799 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(454885), // Rule ID 7041 //
     /*  454804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454851 */     // MIs[1] Operand 1
     /*  454851 */     // No operand predicates
     /*  454851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454883 */     GIR_RootConstrainSelectedInstOperands,
     /*  454884 */     // GIR_Coverage, 7041,
     /*  454884 */     GIR_EraseRootFromParent_Done,
     /*  454885 */   // Label 7824: @454885
     /*  454885 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(454971), // Rule ID 7044 //
     /*  454890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454937 */     // MIs[1] Operand 1
     /*  454937 */     // No operand predicates
     /*  454937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454969 */     GIR_RootConstrainSelectedInstOperands,
     /*  454970 */     // GIR_Coverage, 7044,
     /*  454970 */     GIR_EraseRootFromParent_Done,
     /*  454971 */   // Label 7825: @454971
     /*  454971 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(455057), // Rule ID 7045 //
     /*  454976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  455011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455023 */     // MIs[1] Operand 1
     /*  455023 */     // No operand predicates
     /*  455023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  455035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455055 */     GIR_RootConstrainSelectedInstOperands,
     /*  455056 */     // GIR_Coverage, 7045,
     /*  455056 */     GIR_EraseRootFromParent_Done,
     /*  455057 */   // Label 7826: @455057
     /*  455057 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(455143), // Rule ID 7048 //
     /*  455062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  455073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  455076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  455079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455109 */     // MIs[1] Operand 1
     /*  455109 */     // No operand predicates
     /*  455109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455141 */     GIR_RootConstrainSelectedInstOperands,
     /*  455142 */     // GIR_Coverage, 7048,
     /*  455142 */     GIR_EraseRootFromParent_Done,
     /*  455143 */   // Label 7827: @455143
     /*  455143 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(455229), // Rule ID 7049 //
     /*  455148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  455159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  455162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  455165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455195 */     // MIs[1] Operand 1
     /*  455195 */     // No operand predicates
     /*  455195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455227 */     GIR_RootConstrainSelectedInstOperands,
     /*  455228 */     // GIR_Coverage, 7049,
     /*  455228 */     GIR_EraseRootFromParent_Done,
     /*  455229 */   // Label 7828: @455229
     /*  455229 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(455315), // Rule ID 7052 //
     /*  455234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  455245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  455248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  455251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455281 */     // MIs[1] Operand 1
     /*  455281 */     // No operand predicates
     /*  455281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455313 */     GIR_RootConstrainSelectedInstOperands,
     /*  455314 */     // GIR_Coverage, 7052,
     /*  455314 */     GIR_EraseRootFromParent_Done,
     /*  455315 */   // Label 7829: @455315
     /*  455315 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(455401), // Rule ID 7053 //
     /*  455320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  455331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  455334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  455337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455367 */     // MIs[1] Operand 1
     /*  455367 */     // No operand predicates
     /*  455367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455399 */     GIR_RootConstrainSelectedInstOperands,
     /*  455400 */     // GIR_Coverage, 7053,
     /*  455400 */     GIR_EraseRootFromParent_Done,
     /*  455401 */   // Label 7830: @455401
     /*  455401 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(455487), // Rule ID 7056 //
     /*  455406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455453 */     // MIs[1] Operand 1
     /*  455453 */     // No operand predicates
     /*  455453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455485 */     GIR_RootConstrainSelectedInstOperands,
     /*  455486 */     // GIR_Coverage, 7056,
     /*  455486 */     GIR_EraseRootFromParent_Done,
     /*  455487 */   // Label 7831: @455487
     /*  455487 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(455573), // Rule ID 7057 //
     /*  455492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455539 */     // MIs[1] Operand 1
     /*  455539 */     // No operand predicates
     /*  455539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455571 */     GIR_RootConstrainSelectedInstOperands,
     /*  455572 */     // GIR_Coverage, 7057,
     /*  455572 */     GIR_EraseRootFromParent_Done,
     /*  455573 */   // Label 7832: @455573
     /*  455573 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(455659), // Rule ID 7060 //
     /*  455578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455625 */     // MIs[1] Operand 1
     /*  455625 */     // No operand predicates
     /*  455625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455657 */     GIR_RootConstrainSelectedInstOperands,
     /*  455658 */     // GIR_Coverage, 7060,
     /*  455658 */     GIR_EraseRootFromParent_Done,
     /*  455659 */   // Label 7833: @455659
     /*  455659 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(455745), // Rule ID 7061 //
     /*  455664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455711 */     // MIs[1] Operand 1
     /*  455711 */     // No operand predicates
     /*  455711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455743 */     GIR_RootConstrainSelectedInstOperands,
     /*  455744 */     // GIR_Coverage, 7061,
     /*  455744 */     GIR_EraseRootFromParent_Done,
     /*  455745 */   // Label 7834: @455745
     /*  455745 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(455831), // Rule ID 7064 //
     /*  455750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455797 */     // MIs[1] Operand 1
     /*  455797 */     // No operand predicates
     /*  455797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455829 */     GIR_RootConstrainSelectedInstOperands,
     /*  455830 */     // GIR_Coverage, 7064,
     /*  455830 */     GIR_EraseRootFromParent_Done,
     /*  455831 */   // Label 7835: @455831
     /*  455831 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(455917), // Rule ID 7065 //
     /*  455836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455883 */     // MIs[1] Operand 1
     /*  455883 */     // No operand predicates
     /*  455883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455915 */     GIR_RootConstrainSelectedInstOperands,
     /*  455916 */     // GIR_Coverage, 7065,
     /*  455916 */     GIR_EraseRootFromParent_Done,
     /*  455917 */   // Label 7836: @455917
     /*  455917 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(456003), // Rule ID 7068 //
     /*  455922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455969 */     // MIs[1] Operand 1
     /*  455969 */     // No operand predicates
     /*  455969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456001 */     GIR_RootConstrainSelectedInstOperands,
     /*  456002 */     // GIR_Coverage, 7068,
     /*  456002 */     GIR_EraseRootFromParent_Done,
     /*  456003 */   // Label 7837: @456003
     /*  456003 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(456089), // Rule ID 7069 //
     /*  456008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  456019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  456022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  456025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456055 */     // MIs[1] Operand 1
     /*  456055 */     // No operand predicates
     /*  456055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456087 */     GIR_RootConstrainSelectedInstOperands,
     /*  456088 */     // GIR_Coverage, 7069,
     /*  456088 */     GIR_EraseRootFromParent_Done,
     /*  456089 */   // Label 7838: @456089
     /*  456089 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(456175), // Rule ID 7072 //
     /*  456094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  456105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  456108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  456111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456141 */     // MIs[1] Operand 1
     /*  456141 */     // No operand predicates
     /*  456141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456173 */     GIR_RootConstrainSelectedInstOperands,
     /*  456174 */     // GIR_Coverage, 7072,
     /*  456174 */     GIR_EraseRootFromParent_Done,
     /*  456175 */   // Label 7839: @456175
     /*  456175 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(456261), // Rule ID 7073 //
     /*  456180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  456191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  456194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  456197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456227 */     // MIs[1] Operand 1
     /*  456227 */     // No operand predicates
     /*  456227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456259 */     GIR_RootConstrainSelectedInstOperands,
     /*  456260 */     // GIR_Coverage, 7073,
     /*  456260 */     GIR_EraseRootFromParent_Done,
     /*  456261 */   // Label 7840: @456261
     /*  456261 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(456347), // Rule ID 7076 //
     /*  456266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  456277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  456280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  456283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456313 */     // MIs[1] Operand 1
     /*  456313 */     // No operand predicates
     /*  456313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456345 */     GIR_RootConstrainSelectedInstOperands,
     /*  456346 */     // GIR_Coverage, 7076,
     /*  456346 */     GIR_EraseRootFromParent_Done,
     /*  456347 */   // Label 7841: @456347
     /*  456347 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(456433), // Rule ID 7077 //
     /*  456352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  456363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  456366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  456369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456399 */     // MIs[1] Operand 1
     /*  456399 */     // No operand predicates
     /*  456399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456431 */     GIR_RootConstrainSelectedInstOperands,
     /*  456432 */     // GIR_Coverage, 7077,
     /*  456432 */     GIR_EraseRootFromParent_Done,
     /*  456433 */   // Label 7842: @456433
     /*  456433 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(456519), // Rule ID 7080 //
     /*  456438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456485 */     // MIs[1] Operand 1
     /*  456485 */     // No operand predicates
     /*  456485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456517 */     GIR_RootConstrainSelectedInstOperands,
     /*  456518 */     // GIR_Coverage, 7080,
     /*  456518 */     GIR_EraseRootFromParent_Done,
     /*  456519 */   // Label 7843: @456519
     /*  456519 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(456605), // Rule ID 7081 //
     /*  456524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456571 */     // MIs[1] Operand 1
     /*  456571 */     // No operand predicates
     /*  456571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456603 */     GIR_RootConstrainSelectedInstOperands,
     /*  456604 */     // GIR_Coverage, 7081,
     /*  456604 */     GIR_EraseRootFromParent_Done,
     /*  456605 */   // Label 7844: @456605
     /*  456605 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(456691), // Rule ID 7084 //
     /*  456610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456657 */     // MIs[1] Operand 1
     /*  456657 */     // No operand predicates
     /*  456657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456689 */     GIR_RootConstrainSelectedInstOperands,
     /*  456690 */     // GIR_Coverage, 7084,
     /*  456690 */     GIR_EraseRootFromParent_Done,
     /*  456691 */   // Label 7845: @456691
     /*  456691 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(456777), // Rule ID 7085 //
     /*  456696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456743 */     // MIs[1] Operand 1
     /*  456743 */     // No operand predicates
     /*  456743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456775 */     GIR_RootConstrainSelectedInstOperands,
     /*  456776 */     // GIR_Coverage, 7085,
     /*  456776 */     GIR_EraseRootFromParent_Done,
     /*  456777 */   // Label 7846: @456777
     /*  456777 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(456863), // Rule ID 7088 //
     /*  456782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456829 */     // MIs[1] Operand 1
     /*  456829 */     // No operand predicates
     /*  456829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456861 */     GIR_RootConstrainSelectedInstOperands,
     /*  456862 */     // GIR_Coverage, 7088,
     /*  456862 */     GIR_EraseRootFromParent_Done,
     /*  456863 */   // Label 7847: @456863
     /*  456863 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(456949), // Rule ID 7089 //
     /*  456868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456915 */     // MIs[1] Operand 1
     /*  456915 */     // No operand predicates
     /*  456915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456947 */     GIR_RootConstrainSelectedInstOperands,
     /*  456948 */     // GIR_Coverage, 7089,
     /*  456948 */     GIR_EraseRootFromParent_Done,
     /*  456949 */   // Label 7848: @456949
     /*  456949 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(457035), // Rule ID 7092 //
     /*  456954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457001 */     // MIs[1] Operand 1
     /*  457001 */     // No operand predicates
     /*  457001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  457010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  457013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457033 */     GIR_RootConstrainSelectedInstOperands,
     /*  457034 */     // GIR_Coverage, 7092,
     /*  457034 */     GIR_EraseRootFromParent_Done,
     /*  457035 */   // Label 7849: @457035
     /*  457035 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(457121), // Rule ID 7093 //
     /*  457040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  457043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  457051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  457054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  457057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  457075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457087 */     // MIs[1] Operand 1
     /*  457087 */     // No operand predicates
     /*  457087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  457096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  457099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457119 */     GIR_RootConstrainSelectedInstOperands,
     /*  457120 */     // GIR_Coverage, 7093,
     /*  457120 */     GIR_EraseRootFromParent_Done,
     /*  457121 */   // Label 7850: @457121
     /*  457121 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(457207), // Rule ID 7272 //
     /*  457126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  457137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  457140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  457143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457173 */     // MIs[1] Operand 1
     /*  457173 */     // No operand predicates
     /*  457173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  457185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457205 */     GIR_RootConstrainSelectedInstOperands,
     /*  457206 */     // GIR_Coverage, 7272,
     /*  457206 */     GIR_EraseRootFromParent_Done,
     /*  457207 */   // Label 7851: @457207
     /*  457207 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(457293), // Rule ID 7273 //
     /*  457212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  457223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  457226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  457229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457259 */     // MIs[1] Operand 1
     /*  457259 */     // No operand predicates
     /*  457259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457268 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  457271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457291 */     GIR_RootConstrainSelectedInstOperands,
     /*  457292 */     // GIR_Coverage, 7273,
     /*  457292 */     GIR_EraseRootFromParent_Done,
     /*  457293 */   // Label 7852: @457293
     /*  457293 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(457379), // Rule ID 7276 //
     /*  457298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  457309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  457312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  457315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457345 */     // MIs[1] Operand 1
     /*  457345 */     // No operand predicates
     /*  457345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457377 */     GIR_RootConstrainSelectedInstOperands,
     /*  457378 */     // GIR_Coverage, 7276,
     /*  457378 */     GIR_EraseRootFromParent_Done,
     /*  457379 */   // Label 7853: @457379
     /*  457379 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(457465), // Rule ID 7277 //
     /*  457384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  457395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  457398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  457401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457431 */     // MIs[1] Operand 1
     /*  457431 */     // No operand predicates
     /*  457431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457463 */     GIR_RootConstrainSelectedInstOperands,
     /*  457464 */     // GIR_Coverage, 7277,
     /*  457464 */     GIR_EraseRootFromParent_Done,
     /*  457465 */   // Label 7854: @457465
     /*  457465 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(457551), // Rule ID 7280 //
     /*  457470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457517 */     // MIs[1] Operand 1
     /*  457517 */     // No operand predicates
     /*  457517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457549 */     GIR_RootConstrainSelectedInstOperands,
     /*  457550 */     // GIR_Coverage, 7280,
     /*  457550 */     GIR_EraseRootFromParent_Done,
     /*  457551 */   // Label 7855: @457551
     /*  457551 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(457637), // Rule ID 7281 //
     /*  457556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457603 */     // MIs[1] Operand 1
     /*  457603 */     // No operand predicates
     /*  457603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457635 */     GIR_RootConstrainSelectedInstOperands,
     /*  457636 */     // GIR_Coverage, 7281,
     /*  457636 */     GIR_EraseRootFromParent_Done,
     /*  457637 */   // Label 7856: @457637
     /*  457637 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(457723), // Rule ID 7284 //
     /*  457642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457689 */     // MIs[1] Operand 1
     /*  457689 */     // No operand predicates
     /*  457689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457721 */     GIR_RootConstrainSelectedInstOperands,
     /*  457722 */     // GIR_Coverage, 7284,
     /*  457722 */     GIR_EraseRootFromParent_Done,
     /*  457723 */   // Label 7857: @457723
     /*  457723 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(457809), // Rule ID 7285 //
     /*  457728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457775 */     // MIs[1] Operand 1
     /*  457775 */     // No operand predicates
     /*  457775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457807 */     GIR_RootConstrainSelectedInstOperands,
     /*  457808 */     // GIR_Coverage, 7285,
     /*  457808 */     GIR_EraseRootFromParent_Done,
     /*  457809 */   // Label 7858: @457809
     /*  457809 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(457895), // Rule ID 7288 //
     /*  457814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457861 */     // MIs[1] Operand 1
     /*  457861 */     // No operand predicates
     /*  457861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457893 */     GIR_RootConstrainSelectedInstOperands,
     /*  457894 */     // GIR_Coverage, 7288,
     /*  457894 */     GIR_EraseRootFromParent_Done,
     /*  457895 */   // Label 7859: @457895
     /*  457895 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(457981), // Rule ID 7289 //
     /*  457900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457947 */     // MIs[1] Operand 1
     /*  457947 */     // No operand predicates
     /*  457947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457979 */     GIR_RootConstrainSelectedInstOperands,
     /*  457980 */     // GIR_Coverage, 7289,
     /*  457980 */     GIR_EraseRootFromParent_Done,
     /*  457981 */   // Label 7860: @457981
     /*  457981 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(458067), // Rule ID 7292 //
     /*  457986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  458000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  458003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458033 */     // MIs[1] Operand 1
     /*  458033 */     // No operand predicates
     /*  458033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  458045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458065 */     GIR_RootConstrainSelectedInstOperands,
     /*  458066 */     // GIR_Coverage, 7292,
     /*  458066 */     GIR_EraseRootFromParent_Done,
     /*  458067 */   // Label 7861: @458067
     /*  458067 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(458153), // Rule ID 7293 //
     /*  458072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  458083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  458086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  458089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458119 */     // MIs[1] Operand 1
     /*  458119 */     // No operand predicates
     /*  458119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  458131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458151 */     GIR_RootConstrainSelectedInstOperands,
     /*  458152 */     // GIR_Coverage, 7293,
     /*  458152 */     GIR_EraseRootFromParent_Done,
     /*  458153 */   // Label 7862: @458153
     /*  458153 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(458239), // Rule ID 7296 //
     /*  458158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  458169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  458172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  458175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458205 */     // MIs[1] Operand 1
     /*  458205 */     // No operand predicates
     /*  458205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458237 */     GIR_RootConstrainSelectedInstOperands,
     /*  458238 */     // GIR_Coverage, 7296,
     /*  458238 */     GIR_EraseRootFromParent_Done,
     /*  458239 */   // Label 7863: @458239
     /*  458239 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(458325), // Rule ID 7297 //
     /*  458244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  458255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  458258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  458261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458291 */     // MIs[1] Operand 1
     /*  458291 */     // No operand predicates
     /*  458291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458323 */     GIR_RootConstrainSelectedInstOperands,
     /*  458324 */     // GIR_Coverage, 7297,
     /*  458324 */     GIR_EraseRootFromParent_Done,
     /*  458325 */   // Label 7864: @458325
     /*  458325 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(458411), // Rule ID 7300 //
     /*  458330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458377 */     // MIs[1] Operand 1
     /*  458377 */     // No operand predicates
     /*  458377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458409 */     GIR_RootConstrainSelectedInstOperands,
     /*  458410 */     // GIR_Coverage, 7300,
     /*  458410 */     GIR_EraseRootFromParent_Done,
     /*  458411 */   // Label 7865: @458411
     /*  458411 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(458497), // Rule ID 7301 //
     /*  458416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458463 */     // MIs[1] Operand 1
     /*  458463 */     // No operand predicates
     /*  458463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458495 */     GIR_RootConstrainSelectedInstOperands,
     /*  458496 */     // GIR_Coverage, 7301,
     /*  458496 */     GIR_EraseRootFromParent_Done,
     /*  458497 */   // Label 7866: @458497
     /*  458497 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(458583), // Rule ID 7304 //
     /*  458502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458549 */     // MIs[1] Operand 1
     /*  458549 */     // No operand predicates
     /*  458549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458581 */     GIR_RootConstrainSelectedInstOperands,
     /*  458582 */     // GIR_Coverage, 7304,
     /*  458582 */     GIR_EraseRootFromParent_Done,
     /*  458583 */   // Label 7867: @458583
     /*  458583 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(458669), // Rule ID 7305 //
     /*  458588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458635 */     // MIs[1] Operand 1
     /*  458635 */     // No operand predicates
     /*  458635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458667 */     GIR_RootConstrainSelectedInstOperands,
     /*  458668 */     // GIR_Coverage, 7305,
     /*  458668 */     GIR_EraseRootFromParent_Done,
     /*  458669 */   // Label 7868: @458669
     /*  458669 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(458755), // Rule ID 7308 //
     /*  458674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458721 */     // MIs[1] Operand 1
     /*  458721 */     // No operand predicates
     /*  458721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458753 */     GIR_RootConstrainSelectedInstOperands,
     /*  458754 */     // GIR_Coverage, 7308,
     /*  458754 */     GIR_EraseRootFromParent_Done,
     /*  458755 */   // Label 7869: @458755
     /*  458755 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(458841), // Rule ID 7309 //
     /*  458760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458807 */     // MIs[1] Operand 1
     /*  458807 */     // No operand predicates
     /*  458807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458839 */     GIR_RootConstrainSelectedInstOperands,
     /*  458840 */     // GIR_Coverage, 7309,
     /*  458840 */     GIR_EraseRootFromParent_Done,
     /*  458841 */   // Label 7870: @458841
     /*  458841 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(458927), // Rule ID 7312 //
     /*  458846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458893 */     // MIs[1] Operand 1
     /*  458893 */     // No operand predicates
     /*  458893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458925 */     GIR_RootConstrainSelectedInstOperands,
     /*  458926 */     // GIR_Coverage, 7312,
     /*  458926 */     GIR_EraseRootFromParent_Done,
     /*  458927 */   // Label 7871: @458927
     /*  458927 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(459013), // Rule ID 7313 //
     /*  458932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458979 */     // MIs[1] Operand 1
     /*  458979 */     // No operand predicates
     /*  458979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459011 */     GIR_RootConstrainSelectedInstOperands,
     /*  459012 */     // GIR_Coverage, 7313,
     /*  459012 */     GIR_EraseRootFromParent_Done,
     /*  459013 */   // Label 7872: @459013
     /*  459013 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(459099), // Rule ID 7316 //
     /*  459018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  459029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  459032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  459035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459065 */     // MIs[1] Operand 1
     /*  459065 */     // No operand predicates
     /*  459065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459097 */     GIR_RootConstrainSelectedInstOperands,
     /*  459098 */     // GIR_Coverage, 7316,
     /*  459098 */     GIR_EraseRootFromParent_Done,
     /*  459099 */   // Label 7873: @459099
     /*  459099 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(459185), // Rule ID 7317 //
     /*  459104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  459115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  459118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  459121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459151 */     // MIs[1] Operand 1
     /*  459151 */     // No operand predicates
     /*  459151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459183 */     GIR_RootConstrainSelectedInstOperands,
     /*  459184 */     // GIR_Coverage, 7317,
     /*  459184 */     GIR_EraseRootFromParent_Done,
     /*  459185 */   // Label 7874: @459185
     /*  459185 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(459271), // Rule ID 7320 //
     /*  459190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  459201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  459204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  459207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459237 */     // MIs[1] Operand 1
     /*  459237 */     // No operand predicates
     /*  459237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459269 */     GIR_RootConstrainSelectedInstOperands,
     /*  459270 */     // GIR_Coverage, 7320,
     /*  459270 */     GIR_EraseRootFromParent_Done,
     /*  459271 */   // Label 7875: @459271
     /*  459271 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(459357), // Rule ID 7321 //
     /*  459276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  459287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  459290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  459293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459323 */     // MIs[1] Operand 1
     /*  459323 */     // No operand predicates
     /*  459323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  459332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  459352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459355 */     GIR_RootConstrainSelectedInstOperands,
     /*  459356 */     // GIR_Coverage, 7321,
     /*  459356 */     GIR_EraseRootFromParent_Done,
     /*  459357 */   // Label 7876: @459357
     /*  459357 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(459443), // Rule ID 7324 //
     /*  459362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459409 */     // MIs[1] Operand 1
     /*  459409 */     // No operand predicates
     /*  459409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459441 */     GIR_RootConstrainSelectedInstOperands,
     /*  459442 */     // GIR_Coverage, 7324,
     /*  459442 */     GIR_EraseRootFromParent_Done,
     /*  459443 */   // Label 7877: @459443
     /*  459443 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(459529), // Rule ID 7325 //
     /*  459448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459495 */     // MIs[1] Operand 1
     /*  459495 */     // No operand predicates
     /*  459495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459527 */     GIR_RootConstrainSelectedInstOperands,
     /*  459528 */     // GIR_Coverage, 7325,
     /*  459528 */     GIR_EraseRootFromParent_Done,
     /*  459529 */   // Label 7878: @459529
     /*  459529 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(459615), // Rule ID 7328 //
     /*  459534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459581 */     // MIs[1] Operand 1
     /*  459581 */     // No operand predicates
     /*  459581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459613 */     GIR_RootConstrainSelectedInstOperands,
     /*  459614 */     // GIR_Coverage, 7328,
     /*  459614 */     GIR_EraseRootFromParent_Done,
     /*  459615 */   // Label 7879: @459615
     /*  459615 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(459701), // Rule ID 7329 //
     /*  459620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459667 */     // MIs[1] Operand 1
     /*  459667 */     // No operand predicates
     /*  459667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459699 */     GIR_RootConstrainSelectedInstOperands,
     /*  459700 */     // GIR_Coverage, 7329,
     /*  459700 */     GIR_EraseRootFromParent_Done,
     /*  459701 */   // Label 7880: @459701
     /*  459701 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(459787), // Rule ID 7332 //
     /*  459706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459753 */     // MIs[1] Operand 1
     /*  459753 */     // No operand predicates
     /*  459753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459785 */     GIR_RootConstrainSelectedInstOperands,
     /*  459786 */     // GIR_Coverage, 7332,
     /*  459786 */     GIR_EraseRootFromParent_Done,
     /*  459787 */   // Label 7881: @459787
     /*  459787 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(459873), // Rule ID 7333 //
     /*  459792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459839 */     // MIs[1] Operand 1
     /*  459839 */     // No operand predicates
     /*  459839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459848 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459871 */     GIR_RootConstrainSelectedInstOperands,
     /*  459872 */     // GIR_Coverage, 7333,
     /*  459872 */     GIR_EraseRootFromParent_Done,
     /*  459873 */   // Label 7882: @459873
     /*  459873 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(459959), // Rule ID 7336 //
     /*  459878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459925 */     // MIs[1] Operand 1
     /*  459925 */     // No operand predicates
     /*  459925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459957 */     GIR_RootConstrainSelectedInstOperands,
     /*  459958 */     // GIR_Coverage, 7336,
     /*  459958 */     GIR_EraseRootFromParent_Done,
     /*  459959 */   // Label 7883: @459959
     /*  459959 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(460045), // Rule ID 7337 //
     /*  459964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460011 */     // MIs[1] Operand 1
     /*  460011 */     // No operand predicates
     /*  460011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460043 */     GIR_RootConstrainSelectedInstOperands,
     /*  460044 */     // GIR_Coverage, 7337,
     /*  460044 */     GIR_EraseRootFromParent_Done,
     /*  460045 */   // Label 7884: @460045
     /*  460045 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(460131), // Rule ID 7340 //
     /*  460050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  460061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  460064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  460067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460097 */     // MIs[1] Operand 1
     /*  460097 */     // No operand predicates
     /*  460097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  460106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460129 */     GIR_RootConstrainSelectedInstOperands,
     /*  460130 */     // GIR_Coverage, 7340,
     /*  460130 */     GIR_EraseRootFromParent_Done,
     /*  460131 */   // Label 7885: @460131
     /*  460131 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(460217), // Rule ID 7341 //
     /*  460136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  460147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  460150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  460153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460183 */     // MIs[1] Operand 1
     /*  460183 */     // No operand predicates
     /*  460183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460215 */     GIR_RootConstrainSelectedInstOperands,
     /*  460216 */     // GIR_Coverage, 7341,
     /*  460216 */     GIR_EraseRootFromParent_Done,
     /*  460217 */   // Label 7886: @460217
     /*  460217 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(460303), // Rule ID 7344 //
     /*  460222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  460233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  460236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  460239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460269 */     // MIs[1] Operand 1
     /*  460269 */     // No operand predicates
     /*  460269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  460278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460301 */     GIR_RootConstrainSelectedInstOperands,
     /*  460302 */     // GIR_Coverage, 7344,
     /*  460302 */     GIR_EraseRootFromParent_Done,
     /*  460303 */   // Label 7887: @460303
     /*  460303 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(460389), // Rule ID 7345 //
     /*  460308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  460319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  460322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  460325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460355 */     // MIs[1] Operand 1
     /*  460355 */     // No operand predicates
     /*  460355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  460364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  460384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460387 */     GIR_RootConstrainSelectedInstOperands,
     /*  460388 */     // GIR_Coverage, 7345,
     /*  460388 */     GIR_EraseRootFromParent_Done,
     /*  460389 */   // Label 7888: @460389
     /*  460389 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(460475), // Rule ID 7348 //
     /*  460394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460441 */     // MIs[1] Operand 1
     /*  460441 */     // No operand predicates
     /*  460441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460473 */     GIR_RootConstrainSelectedInstOperands,
     /*  460474 */     // GIR_Coverage, 7348,
     /*  460474 */     GIR_EraseRootFromParent_Done,
     /*  460475 */   // Label 7889: @460475
     /*  460475 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(460561), // Rule ID 7349 //
     /*  460480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460527 */     // MIs[1] Operand 1
     /*  460527 */     // No operand predicates
     /*  460527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460559 */     GIR_RootConstrainSelectedInstOperands,
     /*  460560 */     // GIR_Coverage, 7349,
     /*  460560 */     GIR_EraseRootFromParent_Done,
     /*  460561 */   // Label 7890: @460561
     /*  460561 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(460647), // Rule ID 7352 //
     /*  460566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460613 */     // MIs[1] Operand 1
     /*  460613 */     // No operand predicates
     /*  460613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460645 */     GIR_RootConstrainSelectedInstOperands,
     /*  460646 */     // GIR_Coverage, 7352,
     /*  460646 */     GIR_EraseRootFromParent_Done,
     /*  460647 */   // Label 7891: @460647
     /*  460647 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(460733), // Rule ID 7353 //
     /*  460652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460699 */     // MIs[1] Operand 1
     /*  460699 */     // No operand predicates
     /*  460699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460731 */     GIR_RootConstrainSelectedInstOperands,
     /*  460732 */     // GIR_Coverage, 7353,
     /*  460732 */     GIR_EraseRootFromParent_Done,
     /*  460733 */   // Label 7892: @460733
     /*  460733 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(460819), // Rule ID 7356 //
     /*  460738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460785 */     // MIs[1] Operand 1
     /*  460785 */     // No operand predicates
     /*  460785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460817 */     GIR_RootConstrainSelectedInstOperands,
     /*  460818 */     // GIR_Coverage, 7356,
     /*  460818 */     GIR_EraseRootFromParent_Done,
     /*  460819 */   // Label 7893: @460819
     /*  460819 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(460905), // Rule ID 7357 //
     /*  460824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460871 */     // MIs[1] Operand 1
     /*  460871 */     // No operand predicates
     /*  460871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460903 */     GIR_RootConstrainSelectedInstOperands,
     /*  460904 */     // GIR_Coverage, 7357,
     /*  460904 */     GIR_EraseRootFromParent_Done,
     /*  460905 */   // Label 7894: @460905
     /*  460905 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(460991), // Rule ID 7568 //
     /*  460910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460957 */     // MIs[1] Operand 1
     /*  460957 */     // No operand predicates
     /*  460957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460989 */     GIR_RootConstrainSelectedInstOperands,
     /*  460990 */     // GIR_Coverage, 7568,
     /*  460990 */     GIR_EraseRootFromParent_Done,
     /*  460991 */   // Label 7895: @460991
     /*  460991 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(461077), // Rule ID 7569 //
     /*  460996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  461007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  461010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461043 */     // MIs[1] Operand 1
     /*  461043 */     // No operand predicates
     /*  461043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  461055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461075 */     GIR_RootConstrainSelectedInstOperands,
     /*  461076 */     // GIR_Coverage, 7569,
     /*  461076 */     GIR_EraseRootFromParent_Done,
     /*  461077 */   // Label 7896: @461077
     /*  461077 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(461163), // Rule ID 7572 //
     /*  461082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  461093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  461096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461129 */     // MIs[1] Operand 1
     /*  461129 */     // No operand predicates
     /*  461129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461161 */     GIR_RootConstrainSelectedInstOperands,
     /*  461162 */     // GIR_Coverage, 7572,
     /*  461162 */     GIR_EraseRootFromParent_Done,
     /*  461163 */   // Label 7897: @461163
     /*  461163 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(461249), // Rule ID 7573 //
     /*  461168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  461179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  461182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461215 */     // MIs[1] Operand 1
     /*  461215 */     // No operand predicates
     /*  461215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461247 */     GIR_RootConstrainSelectedInstOperands,
     /*  461248 */     // GIR_Coverage, 7573,
     /*  461248 */     GIR_EraseRootFromParent_Done,
     /*  461249 */   // Label 7898: @461249
     /*  461249 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(461335), // Rule ID 7576 //
     /*  461254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  461265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  461268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461301 */     // MIs[1] Operand 1
     /*  461301 */     // No operand predicates
     /*  461301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461333 */     GIR_RootConstrainSelectedInstOperands,
     /*  461334 */     // GIR_Coverage, 7576,
     /*  461334 */     GIR_EraseRootFromParent_Done,
     /*  461335 */   // Label 7899: @461335
     /*  461335 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(461421), // Rule ID 7577 //
     /*  461340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  461351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  461354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461387 */     // MIs[1] Operand 1
     /*  461387 */     // No operand predicates
     /*  461387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461419 */     GIR_RootConstrainSelectedInstOperands,
     /*  461420 */     // GIR_Coverage, 7577,
     /*  461420 */     GIR_EraseRootFromParent_Done,
     /*  461421 */   // Label 7900: @461421
     /*  461421 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(461507), // Rule ID 7580 //
     /*  461426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461473 */     // MIs[1] Operand 1
     /*  461473 */     // No operand predicates
     /*  461473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461505 */     GIR_RootConstrainSelectedInstOperands,
     /*  461506 */     // GIR_Coverage, 7580,
     /*  461506 */     GIR_EraseRootFromParent_Done,
     /*  461507 */   // Label 7901: @461507
     /*  461507 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(461593), // Rule ID 7581 //
     /*  461512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461559 */     // MIs[1] Operand 1
     /*  461559 */     // No operand predicates
     /*  461559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461591 */     GIR_RootConstrainSelectedInstOperands,
     /*  461592 */     // GIR_Coverage, 7581,
     /*  461592 */     GIR_EraseRootFromParent_Done,
     /*  461593 */   // Label 7902: @461593
     /*  461593 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(461679), // Rule ID 7584 //
     /*  461598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461645 */     // MIs[1] Operand 1
     /*  461645 */     // No operand predicates
     /*  461645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461677 */     GIR_RootConstrainSelectedInstOperands,
     /*  461678 */     // GIR_Coverage, 7584,
     /*  461678 */     GIR_EraseRootFromParent_Done,
     /*  461679 */   // Label 7903: @461679
     /*  461679 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(461765), // Rule ID 7585 //
     /*  461684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461731 */     // MIs[1] Operand 1
     /*  461731 */     // No operand predicates
     /*  461731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461763 */     GIR_RootConstrainSelectedInstOperands,
     /*  461764 */     // GIR_Coverage, 7585,
     /*  461764 */     GIR_EraseRootFromParent_Done,
     /*  461765 */   // Label 7904: @461765
     /*  461765 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(461851), // Rule ID 7588 //
     /*  461770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461817 */     // MIs[1] Operand 1
     /*  461817 */     // No operand predicates
     /*  461817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461849 */     GIR_RootConstrainSelectedInstOperands,
     /*  461850 */     // GIR_Coverage, 7588,
     /*  461850 */     GIR_EraseRootFromParent_Done,
     /*  461851 */   // Label 7905: @461851
     /*  461851 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(461937), // Rule ID 7589 //
     /*  461856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461903 */     // MIs[1] Operand 1
     /*  461903 */     // No operand predicates
     /*  461903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461935 */     GIR_RootConstrainSelectedInstOperands,
     /*  461936 */     // GIR_Coverage, 7589,
     /*  461936 */     GIR_EraseRootFromParent_Done,
     /*  461937 */   // Label 7906: @461937
     /*  461937 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(462023), // Rule ID 7592 //
     /*  461942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461989 */     // MIs[1] Operand 1
     /*  461989 */     // No operand predicates
     /*  461989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  462001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462021 */     GIR_RootConstrainSelectedInstOperands,
     /*  462022 */     // GIR_Coverage, 7592,
     /*  462022 */     GIR_EraseRootFromParent_Done,
     /*  462023 */   // Label 7907: @462023
     /*  462023 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(462109), // Rule ID 7593 //
     /*  462028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  462039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  462042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  462045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462075 */     // MIs[1] Operand 1
     /*  462075 */     // No operand predicates
     /*  462075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  462087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462107 */     GIR_RootConstrainSelectedInstOperands,
     /*  462108 */     // GIR_Coverage, 7593,
     /*  462108 */     GIR_EraseRootFromParent_Done,
     /*  462109 */   // Label 7908: @462109
     /*  462109 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(462195), // Rule ID 7596 //
     /*  462114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  462125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  462128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  462131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462161 */     // MIs[1] Operand 1
     /*  462161 */     // No operand predicates
     /*  462161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462193 */     GIR_RootConstrainSelectedInstOperands,
     /*  462194 */     // GIR_Coverage, 7596,
     /*  462194 */     GIR_EraseRootFromParent_Done,
     /*  462195 */   // Label 7909: @462195
     /*  462195 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(462281), // Rule ID 7597 //
     /*  462200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  462211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  462214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  462217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462247 */     // MIs[1] Operand 1
     /*  462247 */     // No operand predicates
     /*  462247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462279 */     GIR_RootConstrainSelectedInstOperands,
     /*  462280 */     // GIR_Coverage, 7597,
     /*  462280 */     GIR_EraseRootFromParent_Done,
     /*  462281 */   // Label 7910: @462281
     /*  462281 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(462367), // Rule ID 7600 //
     /*  462286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  462297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  462300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  462303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462333 */     // MIs[1] Operand 1
     /*  462333 */     // No operand predicates
     /*  462333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462365 */     GIR_RootConstrainSelectedInstOperands,
     /*  462366 */     // GIR_Coverage, 7600,
     /*  462366 */     GIR_EraseRootFromParent_Done,
     /*  462367 */   // Label 7911: @462367
     /*  462367 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(462453), // Rule ID 7601 //
     /*  462372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  462383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  462386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  462389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462419 */     // MIs[1] Operand 1
     /*  462419 */     // No operand predicates
     /*  462419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462428 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462451 */     GIR_RootConstrainSelectedInstOperands,
     /*  462452 */     // GIR_Coverage, 7601,
     /*  462452 */     GIR_EraseRootFromParent_Done,
     /*  462453 */   // Label 7912: @462453
     /*  462453 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(462539), // Rule ID 7604 //
     /*  462458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462505 */     // MIs[1] Operand 1
     /*  462505 */     // No operand predicates
     /*  462505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462537 */     GIR_RootConstrainSelectedInstOperands,
     /*  462538 */     // GIR_Coverage, 7604,
     /*  462538 */     GIR_EraseRootFromParent_Done,
     /*  462539 */   // Label 7913: @462539
     /*  462539 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(462625), // Rule ID 7605 //
     /*  462544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462591 */     // MIs[1] Operand 1
     /*  462591 */     // No operand predicates
     /*  462591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462623 */     GIR_RootConstrainSelectedInstOperands,
     /*  462624 */     // GIR_Coverage, 7605,
     /*  462624 */     GIR_EraseRootFromParent_Done,
     /*  462625 */   // Label 7914: @462625
     /*  462625 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(462711), // Rule ID 7608 //
     /*  462630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462677 */     // MIs[1] Operand 1
     /*  462677 */     // No operand predicates
     /*  462677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462686 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462709 */     GIR_RootConstrainSelectedInstOperands,
     /*  462710 */     // GIR_Coverage, 7608,
     /*  462710 */     GIR_EraseRootFromParent_Done,
     /*  462711 */   // Label 7915: @462711
     /*  462711 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(462797), // Rule ID 7609 //
     /*  462716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462763 */     // MIs[1] Operand 1
     /*  462763 */     // No operand predicates
     /*  462763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462772 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462795 */     GIR_RootConstrainSelectedInstOperands,
     /*  462796 */     // GIR_Coverage, 7609,
     /*  462796 */     GIR_EraseRootFromParent_Done,
     /*  462797 */   // Label 7916: @462797
     /*  462797 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(462883), // Rule ID 7612 //
     /*  462802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462849 */     // MIs[1] Operand 1
     /*  462849 */     // No operand predicates
     /*  462849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462881 */     GIR_RootConstrainSelectedInstOperands,
     /*  462882 */     // GIR_Coverage, 7612,
     /*  462882 */     GIR_EraseRootFromParent_Done,
     /*  462883 */   // Label 7917: @462883
     /*  462883 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(462969), // Rule ID 7613 //
     /*  462888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462935 */     // MIs[1] Operand 1
     /*  462935 */     // No operand predicates
     /*  462935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462967 */     GIR_RootConstrainSelectedInstOperands,
     /*  462968 */     // GIR_Coverage, 7613,
     /*  462968 */     GIR_EraseRootFromParent_Done,
     /*  462969 */   // Label 7918: @462969
     /*  462969 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(463055), // Rule ID 7616 //
     /*  462974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463021 */     // MIs[1] Operand 1
     /*  463021 */     // No operand predicates
     /*  463021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  463033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463053 */     GIR_RootConstrainSelectedInstOperands,
     /*  463054 */     // GIR_Coverage, 7616,
     /*  463054 */     GIR_EraseRootFromParent_Done,
     /*  463055 */   // Label 7919: @463055
     /*  463055 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(463141), // Rule ID 7617 //
     /*  463060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  463071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  463074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463107 */     // MIs[1] Operand 1
     /*  463107 */     // No operand predicates
     /*  463107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  463119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463139 */     GIR_RootConstrainSelectedInstOperands,
     /*  463140 */     // GIR_Coverage, 7617,
     /*  463140 */     GIR_EraseRootFromParent_Done,
     /*  463141 */   // Label 7920: @463141
     /*  463141 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(463227), // Rule ID 7620 //
     /*  463146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  463149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463193 */     // MIs[1] Operand 1
     /*  463193 */     // No operand predicates
     /*  463193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  463205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463225 */     GIR_RootConstrainSelectedInstOperands,
     /*  463226 */     // GIR_Coverage, 7620,
     /*  463226 */     GIR_EraseRootFromParent_Done,
     /*  463227 */   // Label 7921: @463227
     /*  463227 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(463313), // Rule ID 7621 //
     /*  463232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463279 */     // MIs[1] Operand 1
     /*  463279 */     // No operand predicates
     /*  463279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  463291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463311 */     GIR_RootConstrainSelectedInstOperands,
     /*  463312 */     // GIR_Coverage, 7621,
     /*  463312 */     GIR_EraseRootFromParent_Done,
     /*  463313 */   // Label 7922: @463313
     /*  463313 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(463399), // Rule ID 7624 //
     /*  463318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  463321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  463335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463365 */     // MIs[1] Operand 1
     /*  463365 */     // No operand predicates
     /*  463365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  463377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463397 */     GIR_RootConstrainSelectedInstOperands,
     /*  463398 */     // GIR_Coverage, 7624,
     /*  463398 */     GIR_EraseRootFromParent_Done,
     /*  463399 */   // Label 7923: @463399
     /*  463399 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(463485), // Rule ID 7625 //
     /*  463404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  463407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  463412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  463421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463451 */     // MIs[1] Operand 1
     /*  463451 */     // No operand predicates
     /*  463451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  463463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463483 */     GIR_RootConstrainSelectedInstOperands,
     /*  463484 */     // GIR_Coverage, 7625,
     /*  463484 */     GIR_EraseRootFromParent_Done,
     /*  463485 */   // Label 7924: @463485
     /*  463485 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(463571), // Rule ID 7748 //
     /*  463490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463537 */     // MIs[1] Operand 1
     /*  463537 */     // No operand predicates
     /*  463537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463569 */     GIR_RootConstrainSelectedInstOperands,
     /*  463570 */     // GIR_Coverage, 7748,
     /*  463570 */     GIR_EraseRootFromParent_Done,
     /*  463571 */   // Label 7925: @463571
     /*  463571 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(463657), // Rule ID 7749 //
     /*  463576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463623 */     // MIs[1] Operand 1
     /*  463623 */     // No operand predicates
     /*  463623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463655 */     GIR_RootConstrainSelectedInstOperands,
     /*  463656 */     // GIR_Coverage, 7749,
     /*  463656 */     GIR_EraseRootFromParent_Done,
     /*  463657 */   // Label 7926: @463657
     /*  463657 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(463743), // Rule ID 7752 //
     /*  463662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463709 */     // MIs[1] Operand 1
     /*  463709 */     // No operand predicates
     /*  463709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463741 */     GIR_RootConstrainSelectedInstOperands,
     /*  463742 */     // GIR_Coverage, 7752,
     /*  463742 */     GIR_EraseRootFromParent_Done,
     /*  463743 */   // Label 7927: @463743
     /*  463743 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(463829), // Rule ID 7753 //
     /*  463748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463795 */     // MIs[1] Operand 1
     /*  463795 */     // No operand predicates
     /*  463795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463827 */     GIR_RootConstrainSelectedInstOperands,
     /*  463828 */     // GIR_Coverage, 7753,
     /*  463828 */     GIR_EraseRootFromParent_Done,
     /*  463829 */   // Label 7928: @463829
     /*  463829 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(463915), // Rule ID 7756 //
     /*  463834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463881 */     // MIs[1] Operand 1
     /*  463881 */     // No operand predicates
     /*  463881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463913 */     GIR_RootConstrainSelectedInstOperands,
     /*  463914 */     // GIR_Coverage, 7756,
     /*  463914 */     GIR_EraseRootFromParent_Done,
     /*  463915 */   // Label 7929: @463915
     /*  463915 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(464001), // Rule ID 7757 //
     /*  463920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463967 */     // MIs[1] Operand 1
     /*  463967 */     // No operand predicates
     /*  463967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463976 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463999 */     GIR_RootConstrainSelectedInstOperands,
     /*  464000 */     // GIR_Coverage, 7757,
     /*  464000 */     GIR_EraseRootFromParent_Done,
     /*  464001 */   // Label 7930: @464001
     /*  464001 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(464087), // Rule ID 7760 //
     /*  464006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464053 */     // MIs[1] Operand 1
     /*  464053 */     // No operand predicates
     /*  464053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464085 */     GIR_RootConstrainSelectedInstOperands,
     /*  464086 */     // GIR_Coverage, 7760,
     /*  464086 */     GIR_EraseRootFromParent_Done,
     /*  464087 */   // Label 7931: @464087
     /*  464087 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(464173), // Rule ID 7761 //
     /*  464092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464139 */     // MIs[1] Operand 1
     /*  464139 */     // No operand predicates
     /*  464139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464171 */     GIR_RootConstrainSelectedInstOperands,
     /*  464172 */     // GIR_Coverage, 7761,
     /*  464172 */     GIR_EraseRootFromParent_Done,
     /*  464173 */   // Label 7932: @464173
     /*  464173 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(464259), // Rule ID 7764 //
     /*  464178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464225 */     // MIs[1] Operand 1
     /*  464225 */     // No operand predicates
     /*  464225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464257 */     GIR_RootConstrainSelectedInstOperands,
     /*  464258 */     // GIR_Coverage, 7764,
     /*  464258 */     GIR_EraseRootFromParent_Done,
     /*  464259 */   // Label 7933: @464259
     /*  464259 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(464345), // Rule ID 7765 //
     /*  464264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464311 */     // MIs[1] Operand 1
     /*  464311 */     // No operand predicates
     /*  464311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464343 */     GIR_RootConstrainSelectedInstOperands,
     /*  464344 */     // GIR_Coverage, 7765,
     /*  464344 */     GIR_EraseRootFromParent_Done,
     /*  464345 */   // Label 7934: @464345
     /*  464345 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(464431), // Rule ID 7768 //
     /*  464350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  464361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  464364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464397 */     // MIs[1] Operand 1
     /*  464397 */     // No operand predicates
     /*  464397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464406 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464429 */     GIR_RootConstrainSelectedInstOperands,
     /*  464430 */     // GIR_Coverage, 7768,
     /*  464430 */     GIR_EraseRootFromParent_Done,
     /*  464431 */   // Label 7935: @464431
     /*  464431 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(464517), // Rule ID 7769 //
     /*  464436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  464447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  464450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  464453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464483 */     // MIs[1] Operand 1
     /*  464483 */     // No operand predicates
     /*  464483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464515 */     GIR_RootConstrainSelectedInstOperands,
     /*  464516 */     // GIR_Coverage, 7769,
     /*  464516 */     GIR_EraseRootFromParent_Done,
     /*  464517 */   // Label 7936: @464517
     /*  464517 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(464603), // Rule ID 7772 //
     /*  464522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464569 */     // MIs[1] Operand 1
     /*  464569 */     // No operand predicates
     /*  464569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464578 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464601 */     GIR_RootConstrainSelectedInstOperands,
     /*  464602 */     // GIR_Coverage, 7772,
     /*  464602 */     GIR_EraseRootFromParent_Done,
     /*  464603 */   // Label 7937: @464603
     /*  464603 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(464689), // Rule ID 7773 //
     /*  464608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464655 */     // MIs[1] Operand 1
     /*  464655 */     // No operand predicates
     /*  464655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464687 */     GIR_RootConstrainSelectedInstOperands,
     /*  464688 */     // GIR_Coverage, 7773,
     /*  464688 */     GIR_EraseRootFromParent_Done,
     /*  464689 */   // Label 7938: @464689
     /*  464689 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(464775), // Rule ID 7776 //
     /*  464694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464741 */     // MIs[1] Operand 1
     /*  464741 */     // No operand predicates
     /*  464741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464773 */     GIR_RootConstrainSelectedInstOperands,
     /*  464774 */     // GIR_Coverage, 7776,
     /*  464774 */     GIR_EraseRootFromParent_Done,
     /*  464775 */   // Label 7939: @464775
     /*  464775 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(464861), // Rule ID 7777 //
     /*  464780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464827 */     // MIs[1] Operand 1
     /*  464827 */     // No operand predicates
     /*  464827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464859 */     GIR_RootConstrainSelectedInstOperands,
     /*  464860 */     // GIR_Coverage, 7777,
     /*  464860 */     GIR_EraseRootFromParent_Done,
     /*  464861 */   // Label 7940: @464861
     /*  464861 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(464947), // Rule ID 7780 //
     /*  464866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464913 */     // MIs[1] Operand 1
     /*  464913 */     // No operand predicates
     /*  464913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464922 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464945 */     GIR_RootConstrainSelectedInstOperands,
     /*  464946 */     // GIR_Coverage, 7780,
     /*  464946 */     GIR_EraseRootFromParent_Done,
     /*  464947 */   // Label 7941: @464947
     /*  464947 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(465033), // Rule ID 7781 //
     /*  464952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464999 */     // MIs[1] Operand 1
     /*  464999 */     // No operand predicates
     /*  464999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465031 */     GIR_RootConstrainSelectedInstOperands,
     /*  465032 */     // GIR_Coverage, 7781,
     /*  465032 */     GIR_EraseRootFromParent_Done,
     /*  465033 */   // Label 7942: @465033
     /*  465033 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(465119), // Rule ID 7784 //
     /*  465038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465085 */     // MIs[1] Operand 1
     /*  465085 */     // No operand predicates
     /*  465085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465117 */     GIR_RootConstrainSelectedInstOperands,
     /*  465118 */     // GIR_Coverage, 7784,
     /*  465118 */     GIR_EraseRootFromParent_Done,
     /*  465119 */   // Label 7943: @465119
     /*  465119 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(465205), // Rule ID 7785 //
     /*  465124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465171 */     // MIs[1] Operand 1
     /*  465171 */     // No operand predicates
     /*  465171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465203 */     GIR_RootConstrainSelectedInstOperands,
     /*  465204 */     // GIR_Coverage, 7785,
     /*  465204 */     GIR_EraseRootFromParent_Done,
     /*  465205 */   // Label 7944: @465205
     /*  465205 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(465291), // Rule ID 7788 //
     /*  465210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  465221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  465224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465257 */     // MIs[1] Operand 1
     /*  465257 */     // No operand predicates
     /*  465257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465289 */     GIR_RootConstrainSelectedInstOperands,
     /*  465290 */     // GIR_Coverage, 7788,
     /*  465290 */     GIR_EraseRootFromParent_Done,
     /*  465291 */   // Label 7945: @465291
     /*  465291 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(465377), // Rule ID 7789 //
     /*  465296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  465307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  465310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  465313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465343 */     // MIs[1] Operand 1
     /*  465343 */     // No operand predicates
     /*  465343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465375 */     GIR_RootConstrainSelectedInstOperands,
     /*  465376 */     // GIR_Coverage, 7789,
     /*  465376 */     GIR_EraseRootFromParent_Done,
     /*  465377 */   // Label 7946: @465377
     /*  465377 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(465463), // Rule ID 7792 //
     /*  465382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465429 */     // MIs[1] Operand 1
     /*  465429 */     // No operand predicates
     /*  465429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465461 */     GIR_RootConstrainSelectedInstOperands,
     /*  465462 */     // GIR_Coverage, 7792,
     /*  465462 */     GIR_EraseRootFromParent_Done,
     /*  465463 */   // Label 7947: @465463
     /*  465463 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(465549), // Rule ID 7793 //
     /*  465468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465515 */     // MIs[1] Operand 1
     /*  465515 */     // No operand predicates
     /*  465515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465547 */     GIR_RootConstrainSelectedInstOperands,
     /*  465548 */     // GIR_Coverage, 7793,
     /*  465548 */     GIR_EraseRootFromParent_Done,
     /*  465549 */   // Label 7948: @465549
     /*  465549 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(465635), // Rule ID 7796 //
     /*  465554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465601 */     // MIs[1] Operand 1
     /*  465601 */     // No operand predicates
     /*  465601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465633 */     GIR_RootConstrainSelectedInstOperands,
     /*  465634 */     // GIR_Coverage, 7796,
     /*  465634 */     GIR_EraseRootFromParent_Done,
     /*  465635 */   // Label 7949: @465635
     /*  465635 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(465721), // Rule ID 7797 //
     /*  465640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465687 */     // MIs[1] Operand 1
     /*  465687 */     // No operand predicates
     /*  465687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465719 */     GIR_RootConstrainSelectedInstOperands,
     /*  465720 */     // GIR_Coverage, 7797,
     /*  465720 */     GIR_EraseRootFromParent_Done,
     /*  465721 */   // Label 7950: @465721
     /*  465721 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(465807), // Rule ID 7800 //
     /*  465726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465773 */     // MIs[1] Operand 1
     /*  465773 */     // No operand predicates
     /*  465773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465805 */     GIR_RootConstrainSelectedInstOperands,
     /*  465806 */     // GIR_Coverage, 7800,
     /*  465806 */     GIR_EraseRootFromParent_Done,
     /*  465807 */   // Label 7951: @465807
     /*  465807 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(465893), // Rule ID 7801 //
     /*  465812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465859 */     // MIs[1] Operand 1
     /*  465859 */     // No operand predicates
     /*  465859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465891 */     GIR_RootConstrainSelectedInstOperands,
     /*  465892 */     // GIR_Coverage, 7801,
     /*  465892 */     GIR_EraseRootFromParent_Done,
     /*  465893 */   // Label 7952: @465893
     /*  465893 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(465979), // Rule ID 7804 //
     /*  465898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465945 */     // MIs[1] Operand 1
     /*  465945 */     // No operand predicates
     /*  465945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465977 */     GIR_RootConstrainSelectedInstOperands,
     /*  465978 */     // GIR_Coverage, 7804,
     /*  465978 */     GIR_EraseRootFromParent_Done,
     /*  465979 */   // Label 7953: @465979
     /*  465979 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(466065), // Rule ID 7805 //
     /*  465984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466031 */     // MIs[1] Operand 1
     /*  466031 */     // No operand predicates
     /*  466031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  466043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466063 */     GIR_RootConstrainSelectedInstOperands,
     /*  466064 */     // GIR_Coverage, 7805,
     /*  466064 */     GIR_EraseRootFromParent_Done,
     /*  466065 */   // Label 7954: @466065
     /*  466065 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(466154), // Rule ID 14234 //
     /*  466070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  466087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466117 */     // MIs[1] Operand 1
     /*  466117 */     // No operand predicates
     /*  466117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  466129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466152 */     GIR_RootConstrainSelectedInstOperands,
     /*  466153 */     // GIR_Coverage, 14234,
     /*  466153 */     GIR_EraseRootFromParent_Done,
     /*  466154 */   // Label 7955: @466154
     /*  466154 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(466243), // Rule ID 14235 //
     /*  466159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  466176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466206 */     // MIs[1] Operand 1
     /*  466206 */     // No operand predicates
     /*  466206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466215 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  466218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466241 */     GIR_RootConstrainSelectedInstOperands,
     /*  466242 */     // GIR_Coverage, 14235,
     /*  466242 */     GIR_EraseRootFromParent_Done,
     /*  466243 */   // Label 7956: @466243
     /*  466243 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(466332), // Rule ID 14238 //
     /*  466248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  466259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  466262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  466265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466295 */     // MIs[1] Operand 1
     /*  466295 */     // No operand predicates
     /*  466295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466304 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466330 */     GIR_RootConstrainSelectedInstOperands,
     /*  466331 */     // GIR_Coverage, 14238,
     /*  466331 */     GIR_EraseRootFromParent_Done,
     /*  466332 */   // Label 7957: @466332
     /*  466332 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(466421), // Rule ID 14239 //
     /*  466337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  466348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  466351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  466354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466384 */     // MIs[1] Operand 1
     /*  466384 */     // No operand predicates
     /*  466384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466393 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466419 */     GIR_RootConstrainSelectedInstOperands,
     /*  466420 */     // GIR_Coverage, 14239,
     /*  466420 */     GIR_EraseRootFromParent_Done,
     /*  466421 */   // Label 7958: @466421
     /*  466421 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(466510), // Rule ID 14242 //
     /*  466426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466473 */     // MIs[1] Operand 1
     /*  466473 */     // No operand predicates
     /*  466473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466508 */     GIR_RootConstrainSelectedInstOperands,
     /*  466509 */     // GIR_Coverage, 14242,
     /*  466509 */     GIR_EraseRootFromParent_Done,
     /*  466510 */   // Label 7959: @466510
     /*  466510 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(466599), // Rule ID 14243 //
     /*  466515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466562 */     // MIs[1] Operand 1
     /*  466562 */     // No operand predicates
     /*  466562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466597 */     GIR_RootConstrainSelectedInstOperands,
     /*  466598 */     // GIR_Coverage, 14243,
     /*  466598 */     GIR_EraseRootFromParent_Done,
     /*  466599 */   // Label 7960: @466599
     /*  466599 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(466688), // Rule ID 14246 //
     /*  466604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466651 */     // MIs[1] Operand 1
     /*  466651 */     // No operand predicates
     /*  466651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466686 */     GIR_RootConstrainSelectedInstOperands,
     /*  466687 */     // GIR_Coverage, 14246,
     /*  466687 */     GIR_EraseRootFromParent_Done,
     /*  466688 */   // Label 7961: @466688
     /*  466688 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(466777), // Rule ID 14247 //
     /*  466693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466740 */     // MIs[1] Operand 1
     /*  466740 */     // No operand predicates
     /*  466740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466749 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466775 */     GIR_RootConstrainSelectedInstOperands,
     /*  466776 */     // GIR_Coverage, 14247,
     /*  466776 */     GIR_EraseRootFromParent_Done,
     /*  466777 */   // Label 7962: @466777
     /*  466777 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(466866), // Rule ID 14250 //
     /*  466782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466829 */     // MIs[1] Operand 1
     /*  466829 */     // No operand predicates
     /*  466829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466864 */     GIR_RootConstrainSelectedInstOperands,
     /*  466865 */     // GIR_Coverage, 14250,
     /*  466865 */     GIR_EraseRootFromParent_Done,
     /*  466866 */   // Label 7963: @466866
     /*  466866 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(466955), // Rule ID 14251 //
     /*  466871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466918 */     // MIs[1] Operand 1
     /*  466918 */     // No operand predicates
     /*  466918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466953 */     GIR_RootConstrainSelectedInstOperands,
     /*  466954 */     // GIR_Coverage, 14251,
     /*  466954 */     GIR_EraseRootFromParent_Done,
     /*  466955 */   // Label 7964: @466955
     /*  466955 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(467044), // Rule ID 14254 //
     /*  466960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467007 */     // MIs[1] Operand 1
     /*  467007 */     // No operand predicates
     /*  467007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  467019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467042 */     GIR_RootConstrainSelectedInstOperands,
     /*  467043 */     // GIR_Coverage, 14254,
     /*  467043 */     GIR_EraseRootFromParent_Done,
     /*  467044 */   // Label 7965: @467044
     /*  467044 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(467133), // Rule ID 14255 //
     /*  467049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  467060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  467063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  467066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467096 */     // MIs[1] Operand 1
     /*  467096 */     // No operand predicates
     /*  467096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467105 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  467108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467131 */     GIR_RootConstrainSelectedInstOperands,
     /*  467132 */     // GIR_Coverage, 14255,
     /*  467132 */     GIR_EraseRootFromParent_Done,
     /*  467133 */   // Label 7966: @467133
     /*  467133 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(467222), // Rule ID 14258 //
     /*  467138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  467155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467185 */     // MIs[1] Operand 1
     /*  467185 */     // No operand predicates
     /*  467185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467220 */     GIR_RootConstrainSelectedInstOperands,
     /*  467221 */     // GIR_Coverage, 14258,
     /*  467221 */     GIR_EraseRootFromParent_Done,
     /*  467222 */   // Label 7967: @467222
     /*  467222 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(467311), // Rule ID 14259 //
     /*  467227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  467244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467274 */     // MIs[1] Operand 1
     /*  467274 */     // No operand predicates
     /*  467274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467283 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467309 */     GIR_RootConstrainSelectedInstOperands,
     /*  467310 */     // GIR_Coverage, 14259,
     /*  467310 */     GIR_EraseRootFromParent_Done,
     /*  467311 */   // Label 7968: @467311
     /*  467311 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(467400), // Rule ID 14262 //
     /*  467316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  467327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  467330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467363 */     // MIs[1] Operand 1
     /*  467363 */     // No operand predicates
     /*  467363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467398 */     GIR_RootConstrainSelectedInstOperands,
     /*  467399 */     // GIR_Coverage, 14262,
     /*  467399 */     GIR_EraseRootFromParent_Done,
     /*  467400 */   // Label 7969: @467400
     /*  467400 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(467489), // Rule ID 14263 //
     /*  467405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  467416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  467419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467452 */     // MIs[1] Operand 1
     /*  467452 */     // No operand predicates
     /*  467452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467461 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467487 */     GIR_RootConstrainSelectedInstOperands,
     /*  467488 */     // GIR_Coverage, 14263,
     /*  467488 */     GIR_EraseRootFromParent_Done,
     /*  467489 */   // Label 7970: @467489
     /*  467489 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(467578), // Rule ID 14266 //
     /*  467494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467541 */     // MIs[1] Operand 1
     /*  467541 */     // No operand predicates
     /*  467541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467576 */     GIR_RootConstrainSelectedInstOperands,
     /*  467577 */     // GIR_Coverage, 14266,
     /*  467577 */     GIR_EraseRootFromParent_Done,
     /*  467578 */   // Label 7971: @467578
     /*  467578 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(467667), // Rule ID 14267 //
     /*  467583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467630 */     // MIs[1] Operand 1
     /*  467630 */     // No operand predicates
     /*  467630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467665 */     GIR_RootConstrainSelectedInstOperands,
     /*  467666 */     // GIR_Coverage, 14267,
     /*  467666 */     GIR_EraseRootFromParent_Done,
     /*  467667 */   // Label 7972: @467667
     /*  467667 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(467756), // Rule ID 14270 //
     /*  467672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  467675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467719 */     // MIs[1] Operand 1
     /*  467719 */     // No operand predicates
     /*  467719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  467728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467754 */     GIR_RootConstrainSelectedInstOperands,
     /*  467755 */     // GIR_Coverage, 14270,
     /*  467755 */     GIR_EraseRootFromParent_Done,
     /*  467756 */   // Label 7973: @467756
     /*  467756 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(467845), // Rule ID 14271 //
     /*  467761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  467764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467808 */     // MIs[1] Operand 1
     /*  467808 */     // No operand predicates
     /*  467808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467817 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  467817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467843 */     GIR_RootConstrainSelectedInstOperands,
     /*  467844 */     // GIR_Coverage, 14271,
     /*  467844 */     GIR_EraseRootFromParent_Done,
     /*  467845 */   // Label 7974: @467845
     /*  467845 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(467934), // Rule ID 14274 //
     /*  467850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467897 */     // MIs[1] Operand 1
     /*  467897 */     // No operand predicates
     /*  467897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467932 */     GIR_RootConstrainSelectedInstOperands,
     /*  467933 */     // GIR_Coverage, 14274,
     /*  467933 */     GIR_EraseRootFromParent_Done,
     /*  467934 */   // Label 7975: @467934
     /*  467934 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(468023), // Rule ID 14275 //
     /*  467939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467986 */     // MIs[1] Operand 1
     /*  467986 */     // No operand predicates
     /*  467986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468021 */     GIR_RootConstrainSelectedInstOperands,
     /*  468022 */     // GIR_Coverage, 14275,
     /*  468022 */     GIR_EraseRootFromParent_Done,
     /*  468023 */   // Label 7976: @468023
     /*  468023 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(468112), // Rule ID 14278 //
     /*  468028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  468039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  468042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  468045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468075 */     // MIs[1] Operand 1
     /*  468075 */     // No operand predicates
     /*  468075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  468084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468110 */     GIR_RootConstrainSelectedInstOperands,
     /*  468111 */     // GIR_Coverage, 14278,
     /*  468111 */     GIR_EraseRootFromParent_Done,
     /*  468112 */   // Label 7977: @468112
     /*  468112 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(468201), // Rule ID 14279 //
     /*  468117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  468128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  468131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  468134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468164 */     // MIs[1] Operand 1
     /*  468164 */     // No operand predicates
     /*  468164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468173 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  468173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468199 */     GIR_RootConstrainSelectedInstOperands,
     /*  468200 */     // GIR_Coverage, 14279,
     /*  468200 */     GIR_EraseRootFromParent_Done,
     /*  468201 */   // Label 7978: @468201
     /*  468201 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(468290), // Rule ID 14282 //
     /*  468206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  468217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  468220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  468223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468253 */     // MIs[1] Operand 1
     /*  468253 */     // No operand predicates
     /*  468253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468262 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  468262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468288 */     GIR_RootConstrainSelectedInstOperands,
     /*  468289 */     // GIR_Coverage, 14282,
     /*  468289 */     GIR_EraseRootFromParent_Done,
     /*  468290 */   // Label 7979: @468290
     /*  468290 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(468379), // Rule ID 14283 //
     /*  468295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  468306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  468309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  468312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468342 */     // MIs[1] Operand 1
     /*  468342 */     // No operand predicates
     /*  468342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468351 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  468351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  468371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468377 */     GIR_RootConstrainSelectedInstOperands,
     /*  468378 */     // GIR_Coverage, 14283,
     /*  468378 */     GIR_EraseRootFromParent_Done,
     /*  468379 */   // Label 7980: @468379
     /*  468379 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(468468), // Rule ID 14286 //
     /*  468384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468431 */     // MIs[1] Operand 1
     /*  468431 */     // No operand predicates
     /*  468431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468466 */     GIR_RootConstrainSelectedInstOperands,
     /*  468467 */     // GIR_Coverage, 14286,
     /*  468467 */     GIR_EraseRootFromParent_Done,
     /*  468468 */   // Label 7981: @468468
     /*  468468 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(468557), // Rule ID 14287 //
     /*  468473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468520 */     // MIs[1] Operand 1
     /*  468520 */     // No operand predicates
     /*  468520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468555 */     GIR_RootConstrainSelectedInstOperands,
     /*  468556 */     // GIR_Coverage, 14287,
     /*  468556 */     GIR_EraseRootFromParent_Done,
     /*  468557 */   // Label 7982: @468557
     /*  468557 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(468646), // Rule ID 14290 //
     /*  468562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468609 */     // MIs[1] Operand 1
     /*  468609 */     // No operand predicates
     /*  468609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468644 */     GIR_RootConstrainSelectedInstOperands,
     /*  468645 */     // GIR_Coverage, 14290,
     /*  468645 */     GIR_EraseRootFromParent_Done,
     /*  468646 */   // Label 7983: @468646
     /*  468646 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(468735), // Rule ID 14291 //
     /*  468651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468698 */     // MIs[1] Operand 1
     /*  468698 */     // No operand predicates
     /*  468698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468707 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468733 */     GIR_RootConstrainSelectedInstOperands,
     /*  468734 */     // GIR_Coverage, 14291,
     /*  468734 */     GIR_EraseRootFromParent_Done,
     /*  468735 */   // Label 7984: @468735
     /*  468735 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(468824), // Rule ID 14294 //
     /*  468740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468787 */     // MIs[1] Operand 1
     /*  468787 */     // No operand predicates
     /*  468787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468822 */     GIR_RootConstrainSelectedInstOperands,
     /*  468823 */     // GIR_Coverage, 14294,
     /*  468823 */     GIR_EraseRootFromParent_Done,
     /*  468824 */   // Label 7985: @468824
     /*  468824 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(468913), // Rule ID 14295 //
     /*  468829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468876 */     // MIs[1] Operand 1
     /*  468876 */     // No operand predicates
     /*  468876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468885 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468911 */     GIR_RootConstrainSelectedInstOperands,
     /*  468912 */     // GIR_Coverage, 14295,
     /*  468912 */     GIR_EraseRootFromParent_Done,
     /*  468913 */   // Label 7986: @468913
     /*  468913 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(469002), // Rule ID 14298 //
     /*  468918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468965 */     // MIs[1] Operand 1
     /*  468965 */     // No operand predicates
     /*  468965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469000 */     GIR_RootConstrainSelectedInstOperands,
     /*  469001 */     // GIR_Coverage, 14298,
     /*  469001 */     GIR_EraseRootFromParent_Done,
     /*  469002 */   // Label 7987: @469002
     /*  469002 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(469091), // Rule ID 14299 //
     /*  469007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  469024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469054 */     // MIs[1] Operand 1
     /*  469054 */     // No operand predicates
     /*  469054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469089 */     GIR_RootConstrainSelectedInstOperands,
     /*  469090 */     // GIR_Coverage, 14299,
     /*  469090 */     GIR_EraseRootFromParent_Done,
     /*  469091 */   // Label 7988: @469091
     /*  469091 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(469180), // Rule ID 14302 //
     /*  469096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  469113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469143 */     // MIs[1] Operand 1
     /*  469143 */     // No operand predicates
     /*  469143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469178 */     GIR_RootConstrainSelectedInstOperands,
     /*  469179 */     // GIR_Coverage, 14302,
     /*  469179 */     GIR_EraseRootFromParent_Done,
     /*  469180 */   // Label 7989: @469180
     /*  469180 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(469269), // Rule ID 14303 //
     /*  469185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  469202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469232 */     // MIs[1] Operand 1
     /*  469232 */     // No operand predicates
     /*  469232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469241 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469267 */     GIR_RootConstrainSelectedInstOperands,
     /*  469268 */     // GIR_Coverage, 14303,
     /*  469268 */     GIR_EraseRootFromParent_Done,
     /*  469269 */   // Label 7990: @469269
     /*  469269 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(469358), // Rule ID 14306 //
     /*  469274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  469285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  469288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  469291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469321 */     // MIs[1] Operand 1
     /*  469321 */     // No operand predicates
     /*  469321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469356 */     GIR_RootConstrainSelectedInstOperands,
     /*  469357 */     // GIR_Coverage, 14306,
     /*  469357 */     GIR_EraseRootFromParent_Done,
     /*  469358 */   // Label 7991: @469358
     /*  469358 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(469447), // Rule ID 14307 //
     /*  469363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  469374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  469377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  469380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469410 */     // MIs[1] Operand 1
     /*  469410 */     // No operand predicates
     /*  469410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469445 */     GIR_RootConstrainSelectedInstOperands,
     /*  469446 */     // GIR_Coverage, 14307,
     /*  469446 */     GIR_EraseRootFromParent_Done,
     /*  469447 */   // Label 7992: @469447
     /*  469447 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(469536), // Rule ID 14310 //
     /*  469452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469499 */     // MIs[1] Operand 1
     /*  469499 */     // No operand predicates
     /*  469499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469534 */     GIR_RootConstrainSelectedInstOperands,
     /*  469535 */     // GIR_Coverage, 14310,
     /*  469535 */     GIR_EraseRootFromParent_Done,
     /*  469536 */   // Label 7993: @469536
     /*  469536 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(469625), // Rule ID 14311 //
     /*  469541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469588 */     // MIs[1] Operand 1
     /*  469588 */     // No operand predicates
     /*  469588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469597 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469623 */     GIR_RootConstrainSelectedInstOperands,
     /*  469624 */     // GIR_Coverage, 14311,
     /*  469624 */     GIR_EraseRootFromParent_Done,
     /*  469625 */   // Label 7994: @469625
     /*  469625 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(469714), // Rule ID 14314 //
     /*  469630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469677 */     // MIs[1] Operand 1
     /*  469677 */     // No operand predicates
     /*  469677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469686 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469712 */     GIR_RootConstrainSelectedInstOperands,
     /*  469713 */     // GIR_Coverage, 14314,
     /*  469713 */     GIR_EraseRootFromParent_Done,
     /*  469714 */   // Label 7995: @469714
     /*  469714 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(469803), // Rule ID 14315 //
     /*  469719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469766 */     // MIs[1] Operand 1
     /*  469766 */     // No operand predicates
     /*  469766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469775 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469801 */     GIR_RootConstrainSelectedInstOperands,
     /*  469802 */     // GIR_Coverage, 14315,
     /*  469802 */     GIR_EraseRootFromParent_Done,
     /*  469803 */   // Label 7996: @469803
     /*  469803 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(469892), // Rule ID 14318 //
     /*  469808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469855 */     // MIs[1] Operand 1
     /*  469855 */     // No operand predicates
     /*  469855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469864 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469890 */     GIR_RootConstrainSelectedInstOperands,
     /*  469891 */     // GIR_Coverage, 14318,
     /*  469891 */     GIR_EraseRootFromParent_Done,
     /*  469892 */   // Label 7997: @469892
     /*  469892 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(469981), // Rule ID 14319 //
     /*  469897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469944 */     // MIs[1] Operand 1
     /*  469944 */     // No operand predicates
     /*  469944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469953 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469979 */     GIR_RootConstrainSelectedInstOperands,
     /*  469980 */     // GIR_Coverage, 14319,
     /*  469980 */     GIR_EraseRootFromParent_Done,
     /*  469981 */   // Label 7998: @469981
     /*  469981 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(470070), // Rule ID 14498 //
     /*  469986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  470000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  470003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470033 */     // MIs[1] Operand 1
     /*  470033 */     // No operand predicates
     /*  470033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470042 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  470045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470068 */     GIR_RootConstrainSelectedInstOperands,
     /*  470069 */     // GIR_Coverage, 14498,
     /*  470069 */     GIR_EraseRootFromParent_Done,
     /*  470070 */   // Label 7999: @470070
     /*  470070 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(470159), // Rule ID 14499 //
     /*  470075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  470086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  470089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  470092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470122 */     // MIs[1] Operand 1
     /*  470122 */     // No operand predicates
     /*  470122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470131 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  470134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470157 */     GIR_RootConstrainSelectedInstOperands,
     /*  470158 */     // GIR_Coverage, 14499,
     /*  470158 */     GIR_EraseRootFromParent_Done,
     /*  470159 */   // Label 8000: @470159
     /*  470159 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(470248), // Rule ID 14502 //
     /*  470164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  470175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  470178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  470181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470211 */     // MIs[1] Operand 1
     /*  470211 */     // No operand predicates
     /*  470211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470246 */     GIR_RootConstrainSelectedInstOperands,
     /*  470247 */     // GIR_Coverage, 14502,
     /*  470247 */     GIR_EraseRootFromParent_Done,
     /*  470248 */   // Label 8001: @470248
     /*  470248 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(470337), // Rule ID 14503 //
     /*  470253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  470264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  470267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  470270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470300 */     // MIs[1] Operand 1
     /*  470300 */     // No operand predicates
     /*  470300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470335 */     GIR_RootConstrainSelectedInstOperands,
     /*  470336 */     // GIR_Coverage, 14503,
     /*  470336 */     GIR_EraseRootFromParent_Done,
     /*  470337 */   // Label 8002: @470337
     /*  470337 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(470426), // Rule ID 14506 //
     /*  470342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  470353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  470356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  470359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470389 */     // MIs[1] Operand 1
     /*  470389 */     // No operand predicates
     /*  470389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470424 */     GIR_RootConstrainSelectedInstOperands,
     /*  470425 */     // GIR_Coverage, 14506,
     /*  470425 */     GIR_EraseRootFromParent_Done,
     /*  470426 */   // Label 8003: @470426
     /*  470426 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(470515), // Rule ID 14507 //
     /*  470431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  470442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  470445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  470448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470478 */     // MIs[1] Operand 1
     /*  470478 */     // No operand predicates
     /*  470478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470487 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470513 */     GIR_RootConstrainSelectedInstOperands,
     /*  470514 */     // GIR_Coverage, 14507,
     /*  470514 */     GIR_EraseRootFromParent_Done,
     /*  470515 */   // Label 8004: @470515
     /*  470515 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(470604), // Rule ID 14510 //
     /*  470520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470567 */     // MIs[1] Operand 1
     /*  470567 */     // No operand predicates
     /*  470567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470602 */     GIR_RootConstrainSelectedInstOperands,
     /*  470603 */     // GIR_Coverage, 14510,
     /*  470603 */     GIR_EraseRootFromParent_Done,
     /*  470604 */   // Label 8005: @470604
     /*  470604 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(470693), // Rule ID 14511 //
     /*  470609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470656 */     // MIs[1] Operand 1
     /*  470656 */     // No operand predicates
     /*  470656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470665 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470691 */     GIR_RootConstrainSelectedInstOperands,
     /*  470692 */     // GIR_Coverage, 14511,
     /*  470692 */     GIR_EraseRootFromParent_Done,
     /*  470693 */   // Label 8006: @470693
     /*  470693 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(470782), // Rule ID 14514 //
     /*  470698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470745 */     // MIs[1] Operand 1
     /*  470745 */     // No operand predicates
     /*  470745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470754 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470780 */     GIR_RootConstrainSelectedInstOperands,
     /*  470781 */     // GIR_Coverage, 14514,
     /*  470781 */     GIR_EraseRootFromParent_Done,
     /*  470782 */   // Label 8007: @470782
     /*  470782 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(470871), // Rule ID 14515 //
     /*  470787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470834 */     // MIs[1] Operand 1
     /*  470834 */     // No operand predicates
     /*  470834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470869 */     GIR_RootConstrainSelectedInstOperands,
     /*  470870 */     // GIR_Coverage, 14515,
     /*  470870 */     GIR_EraseRootFromParent_Done,
     /*  470871 */   // Label 8008: @470871
     /*  470871 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(470960), // Rule ID 14518 //
     /*  470876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470923 */     // MIs[1] Operand 1
     /*  470923 */     // No operand predicates
     /*  470923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470958 */     GIR_RootConstrainSelectedInstOperands,
     /*  470959 */     // GIR_Coverage, 14518,
     /*  470959 */     GIR_EraseRootFromParent_Done,
     /*  470960 */   // Label 8009: @470960
     /*  470960 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(471049), // Rule ID 14519 //
     /*  470965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471012 */     // MIs[1] Operand 1
     /*  471012 */     // No operand predicates
     /*  471012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  471024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471047 */     GIR_RootConstrainSelectedInstOperands,
     /*  471048 */     // GIR_Coverage, 14519,
     /*  471048 */     GIR_EraseRootFromParent_Done,
     /*  471049 */   // Label 8010: @471049
     /*  471049 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(471138), // Rule ID 14522 //
     /*  471054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  471065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  471068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  471071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471101 */     // MIs[1] Operand 1
     /*  471101 */     // No operand predicates
     /*  471101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471136 */     GIR_RootConstrainSelectedInstOperands,
     /*  471137 */     // GIR_Coverage, 14522,
     /*  471137 */     GIR_EraseRootFromParent_Done,
     /*  471138 */   // Label 8011: @471138
     /*  471138 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(471227), // Rule ID 14523 //
     /*  471143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  471154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  471157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  471160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471190 */     // MIs[1] Operand 1
     /*  471190 */     // No operand predicates
     /*  471190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471225 */     GIR_RootConstrainSelectedInstOperands,
     /*  471226 */     // GIR_Coverage, 14523,
     /*  471226 */     GIR_EraseRootFromParent_Done,
     /*  471227 */   // Label 8012: @471227
     /*  471227 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(471316), // Rule ID 14526 //
     /*  471232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  471243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  471246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  471249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471279 */     // MIs[1] Operand 1
     /*  471279 */     // No operand predicates
     /*  471279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471314 */     GIR_RootConstrainSelectedInstOperands,
     /*  471315 */     // GIR_Coverage, 14526,
     /*  471315 */     GIR_EraseRootFromParent_Done,
     /*  471316 */   // Label 8013: @471316
     /*  471316 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(471405), // Rule ID 14527 //
     /*  471321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  471332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  471335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  471338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471368 */     // MIs[1] Operand 1
     /*  471368 */     // No operand predicates
     /*  471368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471403 */     GIR_RootConstrainSelectedInstOperands,
     /*  471404 */     // GIR_Coverage, 14527,
     /*  471404 */     GIR_EraseRootFromParent_Done,
     /*  471405 */   // Label 8014: @471405
     /*  471405 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(471494), // Rule ID 14530 //
     /*  471410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471457 */     // MIs[1] Operand 1
     /*  471457 */     // No operand predicates
     /*  471457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471492 */     GIR_RootConstrainSelectedInstOperands,
     /*  471493 */     // GIR_Coverage, 14530,
     /*  471493 */     GIR_EraseRootFromParent_Done,
     /*  471494 */   // Label 8015: @471494
     /*  471494 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(471583), // Rule ID 14531 //
     /*  471499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471546 */     // MIs[1] Operand 1
     /*  471546 */     // No operand predicates
     /*  471546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471581 */     GIR_RootConstrainSelectedInstOperands,
     /*  471582 */     // GIR_Coverage, 14531,
     /*  471582 */     GIR_EraseRootFromParent_Done,
     /*  471583 */   // Label 8016: @471583
     /*  471583 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(471672), // Rule ID 14534 //
     /*  471588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471635 */     // MIs[1] Operand 1
     /*  471635 */     // No operand predicates
     /*  471635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471670 */     GIR_RootConstrainSelectedInstOperands,
     /*  471671 */     // GIR_Coverage, 14534,
     /*  471671 */     GIR_EraseRootFromParent_Done,
     /*  471672 */   // Label 8017: @471672
     /*  471672 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(471761), // Rule ID 14535 //
     /*  471677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471724 */     // MIs[1] Operand 1
     /*  471724 */     // No operand predicates
     /*  471724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471733 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471759 */     GIR_RootConstrainSelectedInstOperands,
     /*  471760 */     // GIR_Coverage, 14535,
     /*  471760 */     GIR_EraseRootFromParent_Done,
     /*  471761 */   // Label 8018: @471761
     /*  471761 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(471850), // Rule ID 14538 //
     /*  471766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471813 */     // MIs[1] Operand 1
     /*  471813 */     // No operand predicates
     /*  471813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471822 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471848 */     GIR_RootConstrainSelectedInstOperands,
     /*  471849 */     // GIR_Coverage, 14538,
     /*  471849 */     GIR_EraseRootFromParent_Done,
     /*  471850 */   // Label 8019: @471850
     /*  471850 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(471939), // Rule ID 14539 //
     /*  471855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471902 */     // MIs[1] Operand 1
     /*  471902 */     // No operand predicates
     /*  471902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471911 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471937 */     GIR_RootConstrainSelectedInstOperands,
     /*  471938 */     // GIR_Coverage, 14539,
     /*  471938 */     GIR_EraseRootFromParent_Done,
     /*  471939 */   // Label 8020: @471939
     /*  471939 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(472028), // Rule ID 14542 //
     /*  471944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471991 */     // MIs[1] Operand 1
     /*  471991 */     // No operand predicates
     /*  471991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472026 */     GIR_RootConstrainSelectedInstOperands,
     /*  472027 */     // GIR_Coverage, 14542,
     /*  472027 */     GIR_EraseRootFromParent_Done,
     /*  472028 */   // Label 8021: @472028
     /*  472028 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(472117), // Rule ID 14543 //
     /*  472033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  472044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  472047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  472050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472080 */     // MIs[1] Operand 1
     /*  472080 */     // No operand predicates
     /*  472080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472115 */     GIR_RootConstrainSelectedInstOperands,
     /*  472116 */     // GIR_Coverage, 14543,
     /*  472116 */     GIR_EraseRootFromParent_Done,
     /*  472117 */   // Label 8022: @472117
     /*  472117 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(472206), // Rule ID 14546 //
     /*  472122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  472133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  472136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  472139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472169 */     // MIs[1] Operand 1
     /*  472169 */     // No operand predicates
     /*  472169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472204 */     GIR_RootConstrainSelectedInstOperands,
     /*  472205 */     // GIR_Coverage, 14546,
     /*  472205 */     GIR_EraseRootFromParent_Done,
     /*  472206 */   // Label 8023: @472206
     /*  472206 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(472295), // Rule ID 14547 //
     /*  472211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  472222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  472225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  472228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472258 */     // MIs[1] Operand 1
     /*  472258 */     // No operand predicates
     /*  472258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472267 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  472267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  472287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472293 */     GIR_RootConstrainSelectedInstOperands,
     /*  472294 */     // GIR_Coverage, 14547,
     /*  472294 */     GIR_EraseRootFromParent_Done,
     /*  472295 */   // Label 8024: @472295
     /*  472295 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(472384), // Rule ID 14550 //
     /*  472300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  472317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472347 */     // MIs[1] Operand 1
     /*  472347 */     // No operand predicates
     /*  472347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472382 */     GIR_RootConstrainSelectedInstOperands,
     /*  472383 */     // GIR_Coverage, 14550,
     /*  472383 */     GIR_EraseRootFromParent_Done,
     /*  472384 */   // Label 8025: @472384
     /*  472384 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(472473), // Rule ID 14551 //
     /*  472389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  472400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  472403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  472406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472436 */     // MIs[1] Operand 1
     /*  472436 */     // No operand predicates
     /*  472436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472445 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472471 */     GIR_RootConstrainSelectedInstOperands,
     /*  472472 */     // GIR_Coverage, 14551,
     /*  472472 */     GIR_EraseRootFromParent_Done,
     /*  472473 */   // Label 8026: @472473
     /*  472473 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(472562), // Rule ID 14554 //
     /*  472478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472525 */     // MIs[1] Operand 1
     /*  472525 */     // No operand predicates
     /*  472525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472560 */     GIR_RootConstrainSelectedInstOperands,
     /*  472561 */     // GIR_Coverage, 14554,
     /*  472561 */     GIR_EraseRootFromParent_Done,
     /*  472562 */   // Label 8027: @472562
     /*  472562 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(472651), // Rule ID 14555 //
     /*  472567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472614 */     // MIs[1] Operand 1
     /*  472614 */     // No operand predicates
     /*  472614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472623 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472649 */     GIR_RootConstrainSelectedInstOperands,
     /*  472650 */     // GIR_Coverage, 14555,
     /*  472650 */     GIR_EraseRootFromParent_Done,
     /*  472651 */   // Label 8028: @472651
     /*  472651 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(472740), // Rule ID 14558 //
     /*  472656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472703 */     // MIs[1] Operand 1
     /*  472703 */     // No operand predicates
     /*  472703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472738 */     GIR_RootConstrainSelectedInstOperands,
     /*  472739 */     // GIR_Coverage, 14558,
     /*  472739 */     GIR_EraseRootFromParent_Done,
     /*  472740 */   // Label 8029: @472740
     /*  472740 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(472829), // Rule ID 14559 //
     /*  472745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472792 */     // MIs[1] Operand 1
     /*  472792 */     // No operand predicates
     /*  472792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472801 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472827 */     GIR_RootConstrainSelectedInstOperands,
     /*  472828 */     // GIR_Coverage, 14559,
     /*  472828 */     GIR_EraseRootFromParent_Done,
     /*  472829 */   // Label 8030: @472829
     /*  472829 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(472918), // Rule ID 14562 //
     /*  472834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472881 */     // MIs[1] Operand 1
     /*  472881 */     // No operand predicates
     /*  472881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472916 */     GIR_RootConstrainSelectedInstOperands,
     /*  472917 */     // GIR_Coverage, 14562,
     /*  472917 */     GIR_EraseRootFromParent_Done,
     /*  472918 */   // Label 8031: @472918
     /*  472918 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(473007), // Rule ID 14563 //
     /*  472923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472970 */     // MIs[1] Operand 1
     /*  472970 */     // No operand predicates
     /*  472970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473005 */     GIR_RootConstrainSelectedInstOperands,
     /*  473006 */     // GIR_Coverage, 14563,
     /*  473006 */     GIR_EraseRootFromParent_Done,
     /*  473007 */   // Label 8032: @473007
     /*  473007 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(473096), // Rule ID 14566 //
     /*  473012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  473029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473059 */     // MIs[1] Operand 1
     /*  473059 */     // No operand predicates
     /*  473059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473094 */     GIR_RootConstrainSelectedInstOperands,
     /*  473095 */     // GIR_Coverage, 14566,
     /*  473095 */     GIR_EraseRootFromParent_Done,
     /*  473096 */   // Label 8033: @473096
     /*  473096 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(473185), // Rule ID 14567 //
     /*  473101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  473112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  473115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  473118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473148 */     // MIs[1] Operand 1
     /*  473148 */     // No operand predicates
     /*  473148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473157 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  473157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473183 */     GIR_RootConstrainSelectedInstOperands,
     /*  473184 */     // GIR_Coverage, 14567,
     /*  473184 */     GIR_EraseRootFromParent_Done,
     /*  473185 */   // Label 8034: @473185
     /*  473185 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(473274), // Rule ID 14570 //
     /*  473190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  473207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473237 */     // MIs[1] Operand 1
     /*  473237 */     // No operand predicates
     /*  473237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473272 */     GIR_RootConstrainSelectedInstOperands,
     /*  473273 */     // GIR_Coverage, 14570,
     /*  473273 */     GIR_EraseRootFromParent_Done,
     /*  473274 */   // Label 8035: @473274
     /*  473274 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(473363), // Rule ID 14571 //
     /*  473279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  473290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  473293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  473296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473326 */     // MIs[1] Operand 1
     /*  473326 */     // No operand predicates
     /*  473326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  473335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473361 */     GIR_RootConstrainSelectedInstOperands,
     /*  473362 */     // GIR_Coverage, 14571,
     /*  473362 */     GIR_EraseRootFromParent_Done,
     /*  473363 */   // Label 8036: @473363
     /*  473363 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(473452), // Rule ID 14574 //
     /*  473368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473415 */     // MIs[1] Operand 1
     /*  473415 */     // No operand predicates
     /*  473415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473450 */     GIR_RootConstrainSelectedInstOperands,
     /*  473451 */     // GIR_Coverage, 14574,
     /*  473451 */     GIR_EraseRootFromParent_Done,
     /*  473452 */   // Label 8037: @473452
     /*  473452 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(473541), // Rule ID 14575 //
     /*  473457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473504 */     // MIs[1] Operand 1
     /*  473504 */     // No operand predicates
     /*  473504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473539 */     GIR_RootConstrainSelectedInstOperands,
     /*  473540 */     // GIR_Coverage, 14575,
     /*  473540 */     GIR_EraseRootFromParent_Done,
     /*  473541 */   // Label 8038: @473541
     /*  473541 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(473630), // Rule ID 14578 //
     /*  473546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473593 */     // MIs[1] Operand 1
     /*  473593 */     // No operand predicates
     /*  473593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473628 */     GIR_RootConstrainSelectedInstOperands,
     /*  473629 */     // GIR_Coverage, 14578,
     /*  473629 */     GIR_EraseRootFromParent_Done,
     /*  473630 */   // Label 8039: @473630
     /*  473630 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(473719), // Rule ID 14579 //
     /*  473635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473682 */     // MIs[1] Operand 1
     /*  473682 */     // No operand predicates
     /*  473682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473717 */     GIR_RootConstrainSelectedInstOperands,
     /*  473718 */     // GIR_Coverage, 14579,
     /*  473718 */     GIR_EraseRootFromParent_Done,
     /*  473719 */   // Label 8040: @473719
     /*  473719 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(473808), // Rule ID 14582 //
     /*  473724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473771 */     // MIs[1] Operand 1
     /*  473771 */     // No operand predicates
     /*  473771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473806 */     GIR_RootConstrainSelectedInstOperands,
     /*  473807 */     // GIR_Coverage, 14582,
     /*  473807 */     GIR_EraseRootFromParent_Done,
     /*  473808 */   // Label 8041: @473808
     /*  473808 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(473897), // Rule ID 14583 //
     /*  473813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473860 */     // MIs[1] Operand 1
     /*  473860 */     // No operand predicates
     /*  473860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473895 */     GIR_RootConstrainSelectedInstOperands,
     /*  473896 */     // GIR_Coverage, 14583,
     /*  473896 */     GIR_EraseRootFromParent_Done,
     /*  473897 */   // Label 8042: @473897
     /*  473897 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(473983), // Rule ID 24678 //
     /*  473902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473949 */     // MIs[1] Operand 1
     /*  473949 */     // No operand predicates
     /*  473949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473958 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473981 */     GIR_RootConstrainSelectedInstOperands,
     /*  473982 */     // GIR_Coverage, 24678,
     /*  473982 */     GIR_EraseRootFromParent_Done,
     /*  473983 */   // Label 8043: @473983
     /*  473983 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(474069), // Rule ID 24679 //
     /*  473988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  474002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  474005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474035 */     // MIs[1] Operand 1
     /*  474035 */     // No operand predicates
     /*  474035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  474047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474067 */     GIR_RootConstrainSelectedInstOperands,
     /*  474068 */     // GIR_Coverage, 24679,
     /*  474068 */     GIR_EraseRootFromParent_Done,
     /*  474069 */   // Label 8044: @474069
     /*  474069 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(474155), // Rule ID 24682 //
     /*  474074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  474085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  474088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474121 */     // MIs[1] Operand 1
     /*  474121 */     // No operand predicates
     /*  474121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474153 */     GIR_RootConstrainSelectedInstOperands,
     /*  474154 */     // GIR_Coverage, 24682,
     /*  474154 */     GIR_EraseRootFromParent_Done,
     /*  474155 */   // Label 8045: @474155
     /*  474155 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(474241), // Rule ID 24683 //
     /*  474160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  474171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  474174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  474177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474207 */     // MIs[1] Operand 1
     /*  474207 */     // No operand predicates
     /*  474207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474239 */     GIR_RootConstrainSelectedInstOperands,
     /*  474240 */     // GIR_Coverage, 24683,
     /*  474240 */     GIR_EraseRootFromParent_Done,
     /*  474241 */   // Label 8046: @474241
     /*  474241 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(474327), // Rule ID 24686 //
     /*  474246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  474257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  474260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474293 */     // MIs[1] Operand 1
     /*  474293 */     // No operand predicates
     /*  474293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474325 */     GIR_RootConstrainSelectedInstOperands,
     /*  474326 */     // GIR_Coverage, 24686,
     /*  474326 */     GIR_EraseRootFromParent_Done,
     /*  474327 */   // Label 8047: @474327
     /*  474327 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(474413), // Rule ID 24687 //
     /*  474332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  474343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  474346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  474349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474379 */     // MIs[1] Operand 1
     /*  474379 */     // No operand predicates
     /*  474379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474388 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474411 */     GIR_RootConstrainSelectedInstOperands,
     /*  474412 */     // GIR_Coverage, 24687,
     /*  474412 */     GIR_EraseRootFromParent_Done,
     /*  474413 */   // Label 8048: @474413
     /*  474413 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(474499), // Rule ID 24690 //
     /*  474418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474465 */     // MIs[1] Operand 1
     /*  474465 */     // No operand predicates
     /*  474465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474497 */     GIR_RootConstrainSelectedInstOperands,
     /*  474498 */     // GIR_Coverage, 24690,
     /*  474498 */     GIR_EraseRootFromParent_Done,
     /*  474499 */   // Label 8049: @474499
     /*  474499 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(474585), // Rule ID 24691 //
     /*  474504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474551 */     // MIs[1] Operand 1
     /*  474551 */     // No operand predicates
     /*  474551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474583 */     GIR_RootConstrainSelectedInstOperands,
     /*  474584 */     // GIR_Coverage, 24691,
     /*  474584 */     GIR_EraseRootFromParent_Done,
     /*  474585 */   // Label 8050: @474585
     /*  474585 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(474671), // Rule ID 24694 //
     /*  474590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474637 */     // MIs[1] Operand 1
     /*  474637 */     // No operand predicates
     /*  474637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474669 */     GIR_RootConstrainSelectedInstOperands,
     /*  474670 */     // GIR_Coverage, 24694,
     /*  474670 */     GIR_EraseRootFromParent_Done,
     /*  474671 */   // Label 8051: @474671
     /*  474671 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(474757), // Rule ID 24695 //
     /*  474676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474723 */     // MIs[1] Operand 1
     /*  474723 */     // No operand predicates
     /*  474723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474755 */     GIR_RootConstrainSelectedInstOperands,
     /*  474756 */     // GIR_Coverage, 24695,
     /*  474756 */     GIR_EraseRootFromParent_Done,
     /*  474757 */   // Label 8052: @474757
     /*  474757 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(474843), // Rule ID 24698 //
     /*  474762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474809 */     // MIs[1] Operand 1
     /*  474809 */     // No operand predicates
     /*  474809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474841 */     GIR_RootConstrainSelectedInstOperands,
     /*  474842 */     // GIR_Coverage, 24698,
     /*  474842 */     GIR_EraseRootFromParent_Done,
     /*  474843 */   // Label 8053: @474843
     /*  474843 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(474929), // Rule ID 24699 //
     /*  474848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474895 */     // MIs[1] Operand 1
     /*  474895 */     // No operand predicates
     /*  474895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474927 */     GIR_RootConstrainSelectedInstOperands,
     /*  474928 */     // GIR_Coverage, 24699,
     /*  474928 */     GIR_EraseRootFromParent_Done,
     /*  474929 */   // Label 8054: @474929
     /*  474929 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(475015), // Rule ID 24702 //
     /*  474934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474981 */     // MIs[1] Operand 1
     /*  474981 */     // No operand predicates
     /*  474981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475013 */     GIR_RootConstrainSelectedInstOperands,
     /*  475014 */     // GIR_Coverage, 24702,
     /*  475014 */     GIR_EraseRootFromParent_Done,
     /*  475015 */   // Label 8055: @475015
     /*  475015 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(475101), // Rule ID 24703 //
     /*  475020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  475031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  475034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  475037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475067 */     // MIs[1] Operand 1
     /*  475067 */     // No operand predicates
     /*  475067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475099 */     GIR_RootConstrainSelectedInstOperands,
     /*  475100 */     // GIR_Coverage, 24703,
     /*  475100 */     GIR_EraseRootFromParent_Done,
     /*  475101 */   // Label 8056: @475101
     /*  475101 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(475187), // Rule ID 24706 //
     /*  475106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  475117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  475120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475153 */     // MIs[1] Operand 1
     /*  475153 */     // No operand predicates
     /*  475153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475185 */     GIR_RootConstrainSelectedInstOperands,
     /*  475186 */     // GIR_Coverage, 24706,
     /*  475186 */     GIR_EraseRootFromParent_Done,
     /*  475187 */   // Label 8057: @475187
     /*  475187 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(475273), // Rule ID 24707 //
     /*  475192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  475203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  475206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  475209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475239 */     // MIs[1] Operand 1
     /*  475239 */     // No operand predicates
     /*  475239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475271 */     GIR_RootConstrainSelectedInstOperands,
     /*  475272 */     // GIR_Coverage, 24707,
     /*  475272 */     GIR_EraseRootFromParent_Done,
     /*  475273 */   // Label 8058: @475273
     /*  475273 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(475359), // Rule ID 24710 //
     /*  475278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  475295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475325 */     // MIs[1] Operand 1
     /*  475325 */     // No operand predicates
     /*  475325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  475334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475357 */     GIR_RootConstrainSelectedInstOperands,
     /*  475358 */     // GIR_Coverage, 24710,
     /*  475358 */     GIR_EraseRootFromParent_Done,
     /*  475359 */   // Label 8059: @475359
     /*  475359 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(475445), // Rule ID 24711 //
     /*  475364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  475375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  475378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  475381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475411 */     // MIs[1] Operand 1
     /*  475411 */     // No operand predicates
     /*  475411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  475420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475443 */     GIR_RootConstrainSelectedInstOperands,
     /*  475444 */     // GIR_Coverage, 24711,
     /*  475444 */     GIR_EraseRootFromParent_Done,
     /*  475445 */   // Label 8060: @475445
     /*  475445 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(475531), // Rule ID 24714 //
     /*  475450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  475453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475497 */     // MIs[1] Operand 1
     /*  475497 */     // No operand predicates
     /*  475497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475529 */     GIR_RootConstrainSelectedInstOperands,
     /*  475530 */     // GIR_Coverage, 24714,
     /*  475530 */     GIR_EraseRootFromParent_Done,
     /*  475531 */   // Label 8061: @475531
     /*  475531 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(475617), // Rule ID 24715 //
     /*  475536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475583 */     // MIs[1] Operand 1
     /*  475583 */     // No operand predicates
     /*  475583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475615 */     GIR_RootConstrainSelectedInstOperands,
     /*  475616 */     // GIR_Coverage, 24715,
     /*  475616 */     GIR_EraseRootFromParent_Done,
     /*  475617 */   // Label 8062: @475617
     /*  475617 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(475703), // Rule ID 24718 //
     /*  475622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475669 */     // MIs[1] Operand 1
     /*  475669 */     // No operand predicates
     /*  475669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475701 */     GIR_RootConstrainSelectedInstOperands,
     /*  475702 */     // GIR_Coverage, 24718,
     /*  475702 */     GIR_EraseRootFromParent_Done,
     /*  475703 */   // Label 8063: @475703
     /*  475703 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(475789), // Rule ID 24719 //
     /*  475708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475755 */     // MIs[1] Operand 1
     /*  475755 */     // No operand predicates
     /*  475755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475764 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475787 */     GIR_RootConstrainSelectedInstOperands,
     /*  475788 */     // GIR_Coverage, 24719,
     /*  475788 */     GIR_EraseRootFromParent_Done,
     /*  475789 */   // Label 8064: @475789
     /*  475789 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(475875), // Rule ID 24722 //
     /*  475794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475841 */     // MIs[1] Operand 1
     /*  475841 */     // No operand predicates
     /*  475841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475873 */     GIR_RootConstrainSelectedInstOperands,
     /*  475874 */     // GIR_Coverage, 24722,
     /*  475874 */     GIR_EraseRootFromParent_Done,
     /*  475875 */   // Label 8065: @475875
     /*  475875 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(475961), // Rule ID 24723 //
     /*  475880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475927 */     // MIs[1] Operand 1
     /*  475927 */     // No operand predicates
     /*  475927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475959 */     GIR_RootConstrainSelectedInstOperands,
     /*  475960 */     // GIR_Coverage, 24723,
     /*  475960 */     GIR_EraseRootFromParent_Done,
     /*  475961 */   // Label 8066: @475961
     /*  475961 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(476047), // Rule ID 24726 //
     /*  475966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476013 */     // MIs[1] Operand 1
     /*  476013 */     // No operand predicates
     /*  476013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476022 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  476022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476045 */     GIR_RootConstrainSelectedInstOperands,
     /*  476046 */     // GIR_Coverage, 24726,
     /*  476046 */     GIR_EraseRootFromParent_Done,
     /*  476047 */   // Label 8067: @476047
     /*  476047 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(476133), // Rule ID 24727 //
     /*  476052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  476063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  476066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  476069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476099 */     // MIs[1] Operand 1
     /*  476099 */     // No operand predicates
     /*  476099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476108 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  476108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  476128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476131 */     GIR_RootConstrainSelectedInstOperands,
     /*  476132 */     // GIR_Coverage, 24727,
     /*  476132 */     GIR_EraseRootFromParent_Done,
     /*  476133 */   // Label 8068: @476133
     /*  476133 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(476219), // Rule ID 24730 //
     /*  476138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  476149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  476152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  476155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476185 */     // MIs[1] Operand 1
     /*  476185 */     // No operand predicates
     /*  476185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476217 */     GIR_RootConstrainSelectedInstOperands,
     /*  476218 */     // GIR_Coverage, 24730,
     /*  476218 */     GIR_EraseRootFromParent_Done,
     /*  476219 */   // Label 8069: @476219
     /*  476219 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(476305), // Rule ID 24731 //
     /*  476224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  476235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  476238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  476241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476271 */     // MIs[1] Operand 1
     /*  476271 */     // No operand predicates
     /*  476271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476303 */     GIR_RootConstrainSelectedInstOperands,
     /*  476304 */     // GIR_Coverage, 24731,
     /*  476304 */     GIR_EraseRootFromParent_Done,
     /*  476305 */   // Label 8070: @476305
     /*  476305 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(476391), // Rule ID 24734 //
     /*  476310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  476321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  476324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476357 */     // MIs[1] Operand 1
     /*  476357 */     // No operand predicates
     /*  476357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476389 */     GIR_RootConstrainSelectedInstOperands,
     /*  476390 */     // GIR_Coverage, 24734,
     /*  476390 */     GIR_EraseRootFromParent_Done,
     /*  476391 */   // Label 8071: @476391
     /*  476391 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(476477), // Rule ID 24735 //
     /*  476396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  476407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  476410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  476413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476443 */     // MIs[1] Operand 1
     /*  476443 */     // No operand predicates
     /*  476443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476475 */     GIR_RootConstrainSelectedInstOperands,
     /*  476476 */     // GIR_Coverage, 24735,
     /*  476476 */     GIR_EraseRootFromParent_Done,
     /*  476477 */   // Label 8072: @476477
     /*  476477 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(476563), // Rule ID 24738 //
     /*  476482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476529 */     // MIs[1] Operand 1
     /*  476529 */     // No operand predicates
     /*  476529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476538 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476561 */     GIR_RootConstrainSelectedInstOperands,
     /*  476562 */     // GIR_Coverage, 24738,
     /*  476562 */     GIR_EraseRootFromParent_Done,
     /*  476563 */   // Label 8073: @476563
     /*  476563 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(476649), // Rule ID 24739 //
     /*  476568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476615 */     // MIs[1] Operand 1
     /*  476615 */     // No operand predicates
     /*  476615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476647 */     GIR_RootConstrainSelectedInstOperands,
     /*  476648 */     // GIR_Coverage, 24739,
     /*  476648 */     GIR_EraseRootFromParent_Done,
     /*  476649 */   // Label 8074: @476649
     /*  476649 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(476735), // Rule ID 24742 //
     /*  476654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476701 */     // MIs[1] Operand 1
     /*  476701 */     // No operand predicates
     /*  476701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476733 */     GIR_RootConstrainSelectedInstOperands,
     /*  476734 */     // GIR_Coverage, 24742,
     /*  476734 */     GIR_EraseRootFromParent_Done,
     /*  476735 */   // Label 8075: @476735
     /*  476735 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(476821), // Rule ID 24743 //
     /*  476740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476787 */     // MIs[1] Operand 1
     /*  476787 */     // No operand predicates
     /*  476787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476819 */     GIR_RootConstrainSelectedInstOperands,
     /*  476820 */     // GIR_Coverage, 24743,
     /*  476820 */     GIR_EraseRootFromParent_Done,
     /*  476821 */   // Label 8076: @476821
     /*  476821 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(476907), // Rule ID 24746 //
     /*  476826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476873 */     // MIs[1] Operand 1
     /*  476873 */     // No operand predicates
     /*  476873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476905 */     GIR_RootConstrainSelectedInstOperands,
     /*  476906 */     // GIR_Coverage, 24746,
     /*  476906 */     GIR_EraseRootFromParent_Done,
     /*  476907 */   // Label 8077: @476907
     /*  476907 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(476993), // Rule ID 24747 //
     /*  476912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476959 */     // MIs[1] Operand 1
     /*  476959 */     // No operand predicates
     /*  476959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476991 */     GIR_RootConstrainSelectedInstOperands,
     /*  476992 */     // GIR_Coverage, 24747,
     /*  476992 */     GIR_EraseRootFromParent_Done,
     /*  476993 */   // Label 8078: @476993
     /*  476993 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(477079), // Rule ID 24750 //
     /*  476998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477045 */     // MIs[1] Operand 1
     /*  477045 */     // No operand predicates
     /*  477045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477077 */     GIR_RootConstrainSelectedInstOperands,
     /*  477078 */     // GIR_Coverage, 24750,
     /*  477078 */     GIR_EraseRootFromParent_Done,
     /*  477079 */   // Label 8079: @477079
     /*  477079 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(477165), // Rule ID 24751 //
     /*  477084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477131 */     // MIs[1] Operand 1
     /*  477131 */     // No operand predicates
     /*  477131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477163 */     GIR_RootConstrainSelectedInstOperands,
     /*  477164 */     // GIR_Coverage, 24751,
     /*  477164 */     GIR_EraseRootFromParent_Done,
     /*  477165 */   // Label 8080: @477165
     /*  477165 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(477251), // Rule ID 24754 //
     /*  477170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477217 */     // MIs[1] Operand 1
     /*  477217 */     // No operand predicates
     /*  477217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477249 */     GIR_RootConstrainSelectedInstOperands,
     /*  477250 */     // GIR_Coverage, 24754,
     /*  477250 */     GIR_EraseRootFromParent_Done,
     /*  477251 */   // Label 8081: @477251
     /*  477251 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(477337), // Rule ID 24755 //
     /*  477256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477303 */     // MIs[1] Operand 1
     /*  477303 */     // No operand predicates
     /*  477303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477335 */     GIR_RootConstrainSelectedInstOperands,
     /*  477336 */     // GIR_Coverage, 24755,
     /*  477336 */     GIR_EraseRootFromParent_Done,
     /*  477337 */   // Label 8082: @477337
     /*  477337 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(477423), // Rule ID 24758 //
     /*  477342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477389 */     // MIs[1] Operand 1
     /*  477389 */     // No operand predicates
     /*  477389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477421 */     GIR_RootConstrainSelectedInstOperands,
     /*  477422 */     // GIR_Coverage, 24758,
     /*  477422 */     GIR_EraseRootFromParent_Done,
     /*  477423 */   // Label 8083: @477423
     /*  477423 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(477509), // Rule ID 24759 //
     /*  477428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477475 */     // MIs[1] Operand 1
     /*  477475 */     // No operand predicates
     /*  477475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477507 */     GIR_RootConstrainSelectedInstOperands,
     /*  477508 */     // GIR_Coverage, 24759,
     /*  477508 */     GIR_EraseRootFromParent_Done,
     /*  477509 */   // Label 8084: @477509
     /*  477509 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(477595), // Rule ID 24762 //
     /*  477514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477561 */     // MIs[1] Operand 1
     /*  477561 */     // No operand predicates
     /*  477561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477593 */     GIR_RootConstrainSelectedInstOperands,
     /*  477594 */     // GIR_Coverage, 24762,
     /*  477594 */     GIR_EraseRootFromParent_Done,
     /*  477595 */   // Label 8085: @477595
     /*  477595 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(477681), // Rule ID 24763 //
     /*  477600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477647 */     // MIs[1] Operand 1
     /*  477647 */     // No operand predicates
     /*  477647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477656 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477679 */     GIR_RootConstrainSelectedInstOperands,
     /*  477680 */     // GIR_Coverage, 24763,
     /*  477680 */     GIR_EraseRootFromParent_Done,
     /*  477681 */   // Label 8086: @477681
     /*  477681 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(477767), // Rule ID 24970 //
     /*  477686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477733 */     // MIs[1] Operand 1
     /*  477733 */     // No operand predicates
     /*  477733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477742 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477765 */     GIR_RootConstrainSelectedInstOperands,
     /*  477766 */     // GIR_Coverage, 24970,
     /*  477766 */     GIR_EraseRootFromParent_Done,
     /*  477767 */   // Label 8087: @477767
     /*  477767 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(477853), // Rule ID 24971 //
     /*  477772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477819 */     // MIs[1] Operand 1
     /*  477819 */     // No operand predicates
     /*  477819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477828 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477851 */     GIR_RootConstrainSelectedInstOperands,
     /*  477852 */     // GIR_Coverage, 24971,
     /*  477852 */     GIR_EraseRootFromParent_Done,
     /*  477853 */   // Label 8088: @477853
     /*  477853 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(477939), // Rule ID 24974 //
     /*  477858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477905 */     // MIs[1] Operand 1
     /*  477905 */     // No operand predicates
     /*  477905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477937 */     GIR_RootConstrainSelectedInstOperands,
     /*  477938 */     // GIR_Coverage, 24974,
     /*  477938 */     GIR_EraseRootFromParent_Done,
     /*  477939 */   // Label 8089: @477939
     /*  477939 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(478025), // Rule ID 24975 //
     /*  477944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477991 */     // MIs[1] Operand 1
     /*  477991 */     // No operand predicates
     /*  477991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478000 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478023 */     GIR_RootConstrainSelectedInstOperands,
     /*  478024 */     // GIR_Coverage, 24975,
     /*  478024 */     GIR_EraseRootFromParent_Done,
     /*  478025 */   // Label 8090: @478025
     /*  478025 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(478111), // Rule ID 24978 //
     /*  478030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478077 */     // MIs[1] Operand 1
     /*  478077 */     // No operand predicates
     /*  478077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478086 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478109 */     GIR_RootConstrainSelectedInstOperands,
     /*  478110 */     // GIR_Coverage, 24978,
     /*  478110 */     GIR_EraseRootFromParent_Done,
     /*  478111 */   // Label 8091: @478111
     /*  478111 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(478197), // Rule ID 24979 //
     /*  478116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478163 */     // MIs[1] Operand 1
     /*  478163 */     // No operand predicates
     /*  478163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478172 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478195 */     GIR_RootConstrainSelectedInstOperands,
     /*  478196 */     // GIR_Coverage, 24979,
     /*  478196 */     GIR_EraseRootFromParent_Done,
     /*  478197 */   // Label 8092: @478197
     /*  478197 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(478283), // Rule ID 24982 //
     /*  478202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478249 */     // MIs[1] Operand 1
     /*  478249 */     // No operand predicates
     /*  478249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478281 */     GIR_RootConstrainSelectedInstOperands,
     /*  478282 */     // GIR_Coverage, 24982,
     /*  478282 */     GIR_EraseRootFromParent_Done,
     /*  478283 */   // Label 8093: @478283
     /*  478283 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(478369), // Rule ID 24983 //
     /*  478288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478335 */     // MIs[1] Operand 1
     /*  478335 */     // No operand predicates
     /*  478335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478344 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478367 */     GIR_RootConstrainSelectedInstOperands,
     /*  478368 */     // GIR_Coverage, 24983,
     /*  478368 */     GIR_EraseRootFromParent_Done,
     /*  478369 */   // Label 8094: @478369
     /*  478369 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(478455), // Rule ID 24986 //
     /*  478374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478421 */     // MIs[1] Operand 1
     /*  478421 */     // No operand predicates
     /*  478421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478430 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478453 */     GIR_RootConstrainSelectedInstOperands,
     /*  478454 */     // GIR_Coverage, 24986,
     /*  478454 */     GIR_EraseRootFromParent_Done,
     /*  478455 */   // Label 8095: @478455
     /*  478455 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(478541), // Rule ID 24987 //
     /*  478460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478507 */     // MIs[1] Operand 1
     /*  478507 */     // No operand predicates
     /*  478507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478539 */     GIR_RootConstrainSelectedInstOperands,
     /*  478540 */     // GIR_Coverage, 24987,
     /*  478540 */     GIR_EraseRootFromParent_Done,
     /*  478541 */   // Label 8096: @478541
     /*  478541 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(478627), // Rule ID 24990 //
     /*  478546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  478549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478593 */     // MIs[1] Operand 1
     /*  478593 */     // No operand predicates
     /*  478593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478602 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478625 */     GIR_RootConstrainSelectedInstOperands,
     /*  478626 */     // GIR_Coverage, 24990,
     /*  478626 */     GIR_EraseRootFromParent_Done,
     /*  478627 */   // Label 8097: @478627
     /*  478627 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(478713), // Rule ID 24991 //
     /*  478632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  478635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478679 */     // MIs[1] Operand 1
     /*  478679 */     // No operand predicates
     /*  478679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478688 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478711 */     GIR_RootConstrainSelectedInstOperands,
     /*  478712 */     // GIR_Coverage, 24991,
     /*  478712 */     GIR_EraseRootFromParent_Done,
     /*  478713 */   // Label 8098: @478713
     /*  478713 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(478799), // Rule ID 24994 //
     /*  478718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478765 */     // MIs[1] Operand 1
     /*  478765 */     // No operand predicates
     /*  478765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478774 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478797 */     GIR_RootConstrainSelectedInstOperands,
     /*  478798 */     // GIR_Coverage, 24994,
     /*  478798 */     GIR_EraseRootFromParent_Done,
     /*  478799 */   // Label 8099: @478799
     /*  478799 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(478885), // Rule ID 24995 //
     /*  478804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478851 */     // MIs[1] Operand 1
     /*  478851 */     // No operand predicates
     /*  478851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478883 */     GIR_RootConstrainSelectedInstOperands,
     /*  478884 */     // GIR_Coverage, 24995,
     /*  478884 */     GIR_EraseRootFromParent_Done,
     /*  478885 */   // Label 8100: @478885
     /*  478885 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(478971), // Rule ID 24998 //
     /*  478890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478937 */     // MIs[1] Operand 1
     /*  478937 */     // No operand predicates
     /*  478937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478946 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478969 */     GIR_RootConstrainSelectedInstOperands,
     /*  478970 */     // GIR_Coverage, 24998,
     /*  478970 */     GIR_EraseRootFromParent_Done,
     /*  478971 */   // Label 8101: @478971
     /*  478971 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(479057), // Rule ID 24999 //
     /*  478976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479023 */     // MIs[1] Operand 1
     /*  479023 */     // No operand predicates
     /*  479023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479032 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479055 */     GIR_RootConstrainSelectedInstOperands,
     /*  479056 */     // GIR_Coverage, 24999,
     /*  479056 */     GIR_EraseRootFromParent_Done,
     /*  479057 */   // Label 8102: @479057
     /*  479057 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(479143), // Rule ID 25002 //
     /*  479062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479109 */     // MIs[1] Operand 1
     /*  479109 */     // No operand predicates
     /*  479109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479118 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479141 */     GIR_RootConstrainSelectedInstOperands,
     /*  479142 */     // GIR_Coverage, 25002,
     /*  479142 */     GIR_EraseRootFromParent_Done,
     /*  479143 */   // Label 8103: @479143
     /*  479143 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(479229), // Rule ID 25003 //
     /*  479148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479195 */     // MIs[1] Operand 1
     /*  479195 */     // No operand predicates
     /*  479195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479204 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479227 */     GIR_RootConstrainSelectedInstOperands,
     /*  479228 */     // GIR_Coverage, 25003,
     /*  479228 */     GIR_EraseRootFromParent_Done,
     /*  479229 */   // Label 8104: @479229
     /*  479229 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(479315), // Rule ID 25006 //
     /*  479234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  479245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  479248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  479251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479281 */     // MIs[1] Operand 1
     /*  479281 */     // No operand predicates
     /*  479281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479290 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479313 */     GIR_RootConstrainSelectedInstOperands,
     /*  479314 */     // GIR_Coverage, 25006,
     /*  479314 */     GIR_EraseRootFromParent_Done,
     /*  479315 */   // Label 8105: @479315
     /*  479315 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(479401), // Rule ID 25007 //
     /*  479320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  479331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  479334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  479337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479367 */     // MIs[1] Operand 1
     /*  479367 */     // No operand predicates
     /*  479367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479399 */     GIR_RootConstrainSelectedInstOperands,
     /*  479400 */     // GIR_Coverage, 25007,
     /*  479400 */     GIR_EraseRootFromParent_Done,
     /*  479401 */   // Label 8106: @479401
     /*  479401 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(479487), // Rule ID 25010 //
     /*  479406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479453 */     // MIs[1] Operand 1
     /*  479453 */     // No operand predicates
     /*  479453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479462 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479485 */     GIR_RootConstrainSelectedInstOperands,
     /*  479486 */     // GIR_Coverage, 25010,
     /*  479486 */     GIR_EraseRootFromParent_Done,
     /*  479487 */   // Label 8107: @479487
     /*  479487 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(479573), // Rule ID 25011 //
     /*  479492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479539 */     // MIs[1] Operand 1
     /*  479539 */     // No operand predicates
     /*  479539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479548 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479571 */     GIR_RootConstrainSelectedInstOperands,
     /*  479572 */     // GIR_Coverage, 25011,
     /*  479572 */     GIR_EraseRootFromParent_Done,
     /*  479573 */   // Label 8108: @479573
     /*  479573 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(479659), // Rule ID 25014 //
     /*  479578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479625 */     // MIs[1] Operand 1
     /*  479625 */     // No operand predicates
     /*  479625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479634 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479657 */     GIR_RootConstrainSelectedInstOperands,
     /*  479658 */     // GIR_Coverage, 25014,
     /*  479658 */     GIR_EraseRootFromParent_Done,
     /*  479659 */   // Label 8109: @479659
     /*  479659 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(479745), // Rule ID 25015 //
     /*  479664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479711 */     // MIs[1] Operand 1
     /*  479711 */     // No operand predicates
     /*  479711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479743 */     GIR_RootConstrainSelectedInstOperands,
     /*  479744 */     // GIR_Coverage, 25015,
     /*  479744 */     GIR_EraseRootFromParent_Done,
     /*  479745 */   // Label 8110: @479745
     /*  479745 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(479831), // Rule ID 25018 //
     /*  479750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479797 */     // MIs[1] Operand 1
     /*  479797 */     // No operand predicates
     /*  479797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479829 */     GIR_RootConstrainSelectedInstOperands,
     /*  479830 */     // GIR_Coverage, 25018,
     /*  479830 */     GIR_EraseRootFromParent_Done,
     /*  479831 */   // Label 8111: @479831
     /*  479831 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(479917), // Rule ID 25019 //
     /*  479836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  479839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479883 */     // MIs[1] Operand 1
     /*  479883 */     // No operand predicates
     /*  479883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479892 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479915 */     GIR_RootConstrainSelectedInstOperands,
     /*  479916 */     // GIR_Coverage, 25019,
     /*  479916 */     GIR_EraseRootFromParent_Done,
     /*  479917 */   // Label 8112: @479917
     /*  479917 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(480003), // Rule ID 25022 //
     /*  479922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  479925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479969 */     // MIs[1] Operand 1
     /*  479969 */     // No operand predicates
     /*  479969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479978 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480001 */     GIR_RootConstrainSelectedInstOperands,
     /*  480002 */     // GIR_Coverage, 25022,
     /*  480002 */     GIR_EraseRootFromParent_Done,
     /*  480003 */   // Label 8113: @480003
     /*  480003 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(480089), // Rule ID 25023 //
     /*  480008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480055 */     // MIs[1] Operand 1
     /*  480055 */     // No operand predicates
     /*  480055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480064 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480087 */     GIR_RootConstrainSelectedInstOperands,
     /*  480088 */     // GIR_Coverage, 25023,
     /*  480088 */     GIR_EraseRootFromParent_Done,
     /*  480089 */   // Label 8114: @480089
     /*  480089 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(480175), // Rule ID 25026 //
     /*  480094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480141 */     // MIs[1] Operand 1
     /*  480141 */     // No operand predicates
     /*  480141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480173 */     GIR_RootConstrainSelectedInstOperands,
     /*  480174 */     // GIR_Coverage, 25026,
     /*  480174 */     GIR_EraseRootFromParent_Done,
     /*  480175 */   // Label 8115: @480175
     /*  480175 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(480261), // Rule ID 25027 //
     /*  480180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480227 */     // MIs[1] Operand 1
     /*  480227 */     // No operand predicates
     /*  480227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480259 */     GIR_RootConstrainSelectedInstOperands,
     /*  480260 */     // GIR_Coverage, 25027,
     /*  480260 */     GIR_EraseRootFromParent_Done,
     /*  480261 */   // Label 8116: @480261
     /*  480261 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(480347), // Rule ID 61038 //
     /*  480266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  480277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  480280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  480283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480313 */     // MIs[1] Operand 1
     /*  480313 */     // No operand predicates
     /*  480313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  480325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480345 */     GIR_RootConstrainSelectedInstOperands,
     /*  480346 */     // GIR_Coverage, 61038,
     /*  480346 */     GIR_EraseRootFromParent_Done,
     /*  480347 */   // Label 8117: @480347
     /*  480347 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(480433), // Rule ID 61039 //
     /*  480352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  480363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  480366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  480369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480399 */     // MIs[1] Operand 1
     /*  480399 */     // No operand predicates
     /*  480399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  480411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480431 */     GIR_RootConstrainSelectedInstOperands,
     /*  480432 */     // GIR_Coverage, 61039,
     /*  480432 */     GIR_EraseRootFromParent_Done,
     /*  480433 */   // Label 8118: @480433
     /*  480433 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(480519), // Rule ID 61046 //
     /*  480438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480485 */     // MIs[1] Operand 1
     /*  480485 */     // No operand predicates
     /*  480485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480517 */     GIR_RootConstrainSelectedInstOperands,
     /*  480518 */     // GIR_Coverage, 61046,
     /*  480518 */     GIR_EraseRootFromParent_Done,
     /*  480519 */   // Label 8119: @480519
     /*  480519 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(480605), // Rule ID 61047 //
     /*  480524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480571 */     // MIs[1] Operand 1
     /*  480571 */     // No operand predicates
     /*  480571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480603 */     GIR_RootConstrainSelectedInstOperands,
     /*  480604 */     // GIR_Coverage, 61047,
     /*  480604 */     GIR_EraseRootFromParent_Done,
     /*  480605 */   // Label 8120: @480605
     /*  480605 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(480691), // Rule ID 61054 //
     /*  480610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480657 */     // MIs[1] Operand 1
     /*  480657 */     // No operand predicates
     /*  480657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480689 */     GIR_RootConstrainSelectedInstOperands,
     /*  480690 */     // GIR_Coverage, 61054,
     /*  480690 */     GIR_EraseRootFromParent_Done,
     /*  480691 */   // Label 8121: @480691
     /*  480691 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(480777), // Rule ID 61055 //
     /*  480696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480743 */     // MIs[1] Operand 1
     /*  480743 */     // No operand predicates
     /*  480743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480775 */     GIR_RootConstrainSelectedInstOperands,
     /*  480776 */     // GIR_Coverage, 61055,
     /*  480776 */     GIR_EraseRootFromParent_Done,
     /*  480777 */   // Label 8122: @480777
     /*  480777 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(480863), // Rule ID 61062 //
     /*  480782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480829 */     // MIs[1] Operand 1
     /*  480829 */     // No operand predicates
     /*  480829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480861 */     GIR_RootConstrainSelectedInstOperands,
     /*  480862 */     // GIR_Coverage, 61062,
     /*  480862 */     GIR_EraseRootFromParent_Done,
     /*  480863 */   // Label 8123: @480863
     /*  480863 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(480949), // Rule ID 61063 //
     /*  480868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480915 */     // MIs[1] Operand 1
     /*  480915 */     // No operand predicates
     /*  480915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480947 */     GIR_RootConstrainSelectedInstOperands,
     /*  480948 */     // GIR_Coverage, 61063,
     /*  480948 */     GIR_EraseRootFromParent_Done,
     /*  480949 */   // Label 8124: @480949
     /*  480949 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(481035), // Rule ID 61070 //
     /*  480954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481001 */     // MIs[1] Operand 1
     /*  481001 */     // No operand predicates
     /*  481001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481033 */     GIR_RootConstrainSelectedInstOperands,
     /*  481034 */     // GIR_Coverage, 61070,
     /*  481034 */     GIR_EraseRootFromParent_Done,
     /*  481035 */   // Label 8125: @481035
     /*  481035 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(481121), // Rule ID 61071 //
     /*  481040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  481051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  481054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  481057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481087 */     // MIs[1] Operand 1
     /*  481087 */     // No operand predicates
     /*  481087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481119 */     GIR_RootConstrainSelectedInstOperands,
     /*  481120 */     // GIR_Coverage, 61071,
     /*  481120 */     GIR_EraseRootFromParent_Done,
     /*  481121 */   // Label 8126: @481121
     /*  481121 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(481207), // Rule ID 61078 //
     /*  481126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  481137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  481140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  481143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481173 */     // MIs[1] Operand 1
     /*  481173 */     // No operand predicates
     /*  481173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481205 */     GIR_RootConstrainSelectedInstOperands,
     /*  481206 */     // GIR_Coverage, 61078,
     /*  481206 */     GIR_EraseRootFromParent_Done,
     /*  481207 */   // Label 8127: @481207
     /*  481207 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(481293), // Rule ID 61079 //
     /*  481212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  481223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  481226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  481229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481259 */     // MIs[1] Operand 1
     /*  481259 */     // No operand predicates
     /*  481259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  481268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481291 */     GIR_RootConstrainSelectedInstOperands,
     /*  481292 */     // GIR_Coverage, 61079,
     /*  481292 */     GIR_EraseRootFromParent_Done,
     /*  481293 */   // Label 8128: @481293
     /*  481293 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(481379), // Rule ID 61086 //
     /*  481298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  481315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481345 */     // MIs[1] Operand 1
     /*  481345 */     // No operand predicates
     /*  481345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  481357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481377 */     GIR_RootConstrainSelectedInstOperands,
     /*  481378 */     // GIR_Coverage, 61086,
     /*  481378 */     GIR_EraseRootFromParent_Done,
     /*  481379 */   // Label 8129: @481379
     /*  481379 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(481465), // Rule ID 61087 //
     /*  481384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  481401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481431 */     // MIs[1] Operand 1
     /*  481431 */     // No operand predicates
     /*  481431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  481443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481463 */     GIR_RootConstrainSelectedInstOperands,
     /*  481464 */     // GIR_Coverage, 61087,
     /*  481464 */     GIR_EraseRootFromParent_Done,
     /*  481465 */   // Label 8130: @481465
     /*  481465 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(481551), // Rule ID 61094 //
     /*  481470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481517 */     // MIs[1] Operand 1
     /*  481517 */     // No operand predicates
     /*  481517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481549 */     GIR_RootConstrainSelectedInstOperands,
     /*  481550 */     // GIR_Coverage, 61094,
     /*  481550 */     GIR_EraseRootFromParent_Done,
     /*  481551 */   // Label 8131: @481551
     /*  481551 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(481637), // Rule ID 61095 //
     /*  481556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481603 */     // MIs[1] Operand 1
     /*  481603 */     // No operand predicates
     /*  481603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481635 */     GIR_RootConstrainSelectedInstOperands,
     /*  481636 */     // GIR_Coverage, 61095,
     /*  481636 */     GIR_EraseRootFromParent_Done,
     /*  481637 */   // Label 8132: @481637
     /*  481637 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(481723), // Rule ID 61102 //
     /*  481642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481689 */     // MIs[1] Operand 1
     /*  481689 */     // No operand predicates
     /*  481689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481721 */     GIR_RootConstrainSelectedInstOperands,
     /*  481722 */     // GIR_Coverage, 61102,
     /*  481722 */     GIR_EraseRootFromParent_Done,
     /*  481723 */   // Label 8133: @481723
     /*  481723 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(481809), // Rule ID 61103 //
     /*  481728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481775 */     // MIs[1] Operand 1
     /*  481775 */     // No operand predicates
     /*  481775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481807 */     GIR_RootConstrainSelectedInstOperands,
     /*  481808 */     // GIR_Coverage, 61103,
     /*  481808 */     GIR_EraseRootFromParent_Done,
     /*  481809 */   // Label 8134: @481809
     /*  481809 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(481895), // Rule ID 61110 //
     /*  481814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481861 */     // MIs[1] Operand 1
     /*  481861 */     // No operand predicates
     /*  481861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481893 */     GIR_RootConstrainSelectedInstOperands,
     /*  481894 */     // GIR_Coverage, 61110,
     /*  481894 */     GIR_EraseRootFromParent_Done,
     /*  481895 */   // Label 8135: @481895
     /*  481895 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(481981), // Rule ID 61111 //
     /*  481900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481947 */     // MIs[1] Operand 1
     /*  481947 */     // No operand predicates
     /*  481947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481979 */     GIR_RootConstrainSelectedInstOperands,
     /*  481980 */     // GIR_Coverage, 61111,
     /*  481980 */     GIR_EraseRootFromParent_Done,
     /*  481981 */   // Label 8136: @481981
     /*  481981 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(482067), // Rule ID 61118 //
     /*  481986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482033 */     // MIs[1] Operand 1
     /*  482033 */     // No operand predicates
     /*  482033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482065 */     GIR_RootConstrainSelectedInstOperands,
     /*  482066 */     // GIR_Coverage, 61118,
     /*  482066 */     GIR_EraseRootFromParent_Done,
     /*  482067 */   // Label 8137: @482067
     /*  482067 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(482153), // Rule ID 61119 //
     /*  482072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  482089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482119 */     // MIs[1] Operand 1
     /*  482119 */     // No operand predicates
     /*  482119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482151 */     GIR_RootConstrainSelectedInstOperands,
     /*  482152 */     // GIR_Coverage, 61119,
     /*  482152 */     GIR_EraseRootFromParent_Done,
     /*  482153 */   // Label 8138: @482153
     /*  482153 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(482239), // Rule ID 61126 //
     /*  482158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482205 */     // MIs[1] Operand 1
     /*  482205 */     // No operand predicates
     /*  482205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  482217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482237 */     GIR_RootConstrainSelectedInstOperands,
     /*  482238 */     // GIR_Coverage, 61126,
     /*  482238 */     GIR_EraseRootFromParent_Done,
     /*  482239 */   // Label 8139: @482239
     /*  482239 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(482325), // Rule ID 61127 //
     /*  482244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  482255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  482258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482291 */     // MIs[1] Operand 1
     /*  482291 */     // No operand predicates
     /*  482291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  482303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482323 */     GIR_RootConstrainSelectedInstOperands,
     /*  482324 */     // GIR_Coverage, 61127,
     /*  482324 */     GIR_EraseRootFromParent_Done,
     /*  482325 */   // Label 8140: @482325
     /*  482325 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(482411), // Rule ID 61134 //
     /*  482330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  482347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482377 */     // MIs[1] Operand 1
     /*  482377 */     // No operand predicates
     /*  482377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482409 */     GIR_RootConstrainSelectedInstOperands,
     /*  482410 */     // GIR_Coverage, 61134,
     /*  482410 */     GIR_EraseRootFromParent_Done,
     /*  482411 */   // Label 8141: @482411
     /*  482411 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(482497), // Rule ID 61135 //
     /*  482416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  482433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482463 */     // MIs[1] Operand 1
     /*  482463 */     // No operand predicates
     /*  482463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482495 */     GIR_RootConstrainSelectedInstOperands,
     /*  482496 */     // GIR_Coverage, 61135,
     /*  482496 */     GIR_EraseRootFromParent_Done,
     /*  482497 */   // Label 8142: @482497
     /*  482497 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(482583), // Rule ID 61142 //
     /*  482502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482549 */     // MIs[1] Operand 1
     /*  482549 */     // No operand predicates
     /*  482549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482581 */     GIR_RootConstrainSelectedInstOperands,
     /*  482582 */     // GIR_Coverage, 61142,
     /*  482582 */     GIR_EraseRootFromParent_Done,
     /*  482583 */   // Label 8143: @482583
     /*  482583 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(482669), // Rule ID 61143 //
     /*  482588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482635 */     // MIs[1] Operand 1
     /*  482635 */     // No operand predicates
     /*  482635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482667 */     GIR_RootConstrainSelectedInstOperands,
     /*  482668 */     // GIR_Coverage, 61143,
     /*  482668 */     GIR_EraseRootFromParent_Done,
     /*  482669 */   // Label 8144: @482669
     /*  482669 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(482755), // Rule ID 61150 //
     /*  482674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482721 */     // MIs[1] Operand 1
     /*  482721 */     // No operand predicates
     /*  482721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482753 */     GIR_RootConstrainSelectedInstOperands,
     /*  482754 */     // GIR_Coverage, 61150,
     /*  482754 */     GIR_EraseRootFromParent_Done,
     /*  482755 */   // Label 8145: @482755
     /*  482755 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(482841), // Rule ID 61151 //
     /*  482760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482807 */     // MIs[1] Operand 1
     /*  482807 */     // No operand predicates
     /*  482807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482839 */     GIR_RootConstrainSelectedInstOperands,
     /*  482840 */     // GIR_Coverage, 61151,
     /*  482840 */     GIR_EraseRootFromParent_Done,
     /*  482841 */   // Label 8146: @482841
     /*  482841 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(482927), // Rule ID 62006 //
     /*  482846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482893 */     // MIs[1] Operand 1
     /*  482893 */     // No operand predicates
     /*  482893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482902 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482925 */     GIR_RootConstrainSelectedInstOperands,
     /*  482926 */     // GIR_Coverage, 62006,
     /*  482926 */     GIR_EraseRootFromParent_Done,
     /*  482927 */   // Label 8147: @482927
     /*  482927 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(483013), // Rule ID 62007 //
     /*  482932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482979 */     // MIs[1] Operand 1
     /*  482979 */     // No operand predicates
     /*  482979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482988 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483011 */     GIR_RootConstrainSelectedInstOperands,
     /*  483012 */     // GIR_Coverage, 62007,
     /*  483012 */     GIR_EraseRootFromParent_Done,
     /*  483013 */   // Label 8148: @483013
     /*  483013 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(483099), // Rule ID 62010 //
     /*  483018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  483029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  483032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483065 */     // MIs[1] Operand 1
     /*  483065 */     // No operand predicates
     /*  483065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483097 */     GIR_RootConstrainSelectedInstOperands,
     /*  483098 */     // GIR_Coverage, 62010,
     /*  483098 */     GIR_EraseRootFromParent_Done,
     /*  483099 */   // Label 8149: @483099
     /*  483099 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(483185), // Rule ID 62011 //
     /*  483104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  483115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  483118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483151 */     // MIs[1] Operand 1
     /*  483151 */     // No operand predicates
     /*  483151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483183 */     GIR_RootConstrainSelectedInstOperands,
     /*  483184 */     // GIR_Coverage, 62011,
     /*  483184 */     GIR_EraseRootFromParent_Done,
     /*  483185 */   // Label 8150: @483185
     /*  483185 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(483271), // Rule ID 62014 //
     /*  483190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  483201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  483204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483237 */     // MIs[1] Operand 1
     /*  483237 */     // No operand predicates
     /*  483237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483246 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483269 */     GIR_RootConstrainSelectedInstOperands,
     /*  483270 */     // GIR_Coverage, 62014,
     /*  483270 */     GIR_EraseRootFromParent_Done,
     /*  483271 */   // Label 8151: @483271
     /*  483271 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(483357), // Rule ID 62015 //
     /*  483276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  483287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  483290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  483293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483323 */     // MIs[1] Operand 1
     /*  483323 */     // No operand predicates
     /*  483323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483355 */     GIR_RootConstrainSelectedInstOperands,
     /*  483356 */     // GIR_Coverage, 62015,
     /*  483356 */     GIR_EraseRootFromParent_Done,
     /*  483357 */   // Label 8152: @483357
     /*  483357 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(483443), // Rule ID 62018 //
     /*  483362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  483379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483409 */     // MIs[1] Operand 1
     /*  483409 */     // No operand predicates
     /*  483409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483418 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483441 */     GIR_RootConstrainSelectedInstOperands,
     /*  483442 */     // GIR_Coverage, 62018,
     /*  483442 */     GIR_EraseRootFromParent_Done,
     /*  483443 */   // Label 8153: @483443
     /*  483443 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(483529), // Rule ID 62019 //
     /*  483448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  483465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483495 */     // MIs[1] Operand 1
     /*  483495 */     // No operand predicates
     /*  483495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483504 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483527 */     GIR_RootConstrainSelectedInstOperands,
     /*  483528 */     // GIR_Coverage, 62019,
     /*  483528 */     GIR_EraseRootFromParent_Done,
     /*  483529 */   // Label 8154: @483529
     /*  483529 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(483615), // Rule ID 62022 //
     /*  483534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483581 */     // MIs[1] Operand 1
     /*  483581 */     // No operand predicates
     /*  483581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483613 */     GIR_RootConstrainSelectedInstOperands,
     /*  483614 */     // GIR_Coverage, 62022,
     /*  483614 */     GIR_EraseRootFromParent_Done,
     /*  483615 */   // Label 8155: @483615
     /*  483615 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(483701), // Rule ID 62023 //
     /*  483620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483667 */     // MIs[1] Operand 1
     /*  483667 */     // No operand predicates
     /*  483667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483676 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483699 */     GIR_RootConstrainSelectedInstOperands,
     /*  483700 */     // GIR_Coverage, 62023,
     /*  483700 */     GIR_EraseRootFromParent_Done,
     /*  483701 */   // Label 8156: @483701
     /*  483701 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(483787), // Rule ID 62026 //
     /*  483706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483753 */     // MIs[1] Operand 1
     /*  483753 */     // No operand predicates
     /*  483753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483785 */     GIR_RootConstrainSelectedInstOperands,
     /*  483786 */     // GIR_Coverage, 62026,
     /*  483786 */     GIR_EraseRootFromParent_Done,
     /*  483787 */   // Label 8157: @483787
     /*  483787 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(483873), // Rule ID 62027 //
     /*  483792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483839 */     // MIs[1] Operand 1
     /*  483839 */     // No operand predicates
     /*  483839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483871 */     GIR_RootConstrainSelectedInstOperands,
     /*  483872 */     // GIR_Coverage, 62027,
     /*  483872 */     GIR_EraseRootFromParent_Done,
     /*  483873 */   // Label 8158: @483873
     /*  483873 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(483959), // Rule ID 62030 //
     /*  483878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483925 */     // MIs[1] Operand 1
     /*  483925 */     // No operand predicates
     /*  483925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483957 */     GIR_RootConstrainSelectedInstOperands,
     /*  483958 */     // GIR_Coverage, 62030,
     /*  483958 */     GIR_EraseRootFromParent_Done,
     /*  483959 */   // Label 8159: @483959
     /*  483959 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(484045), // Rule ID 62031 //
     /*  483964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484011 */     // MIs[1] Operand 1
     /*  484011 */     // No operand predicates
     /*  484011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484020 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484043 */     GIR_RootConstrainSelectedInstOperands,
     /*  484044 */     // GIR_Coverage, 62031,
     /*  484044 */     GIR_EraseRootFromParent_Done,
     /*  484045 */   // Label 8160: @484045
     /*  484045 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(484131), // Rule ID 62034 //
     /*  484050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484097 */     // MIs[1] Operand 1
     /*  484097 */     // No operand predicates
     /*  484097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484129 */     GIR_RootConstrainSelectedInstOperands,
     /*  484130 */     // GIR_Coverage, 62034,
     /*  484130 */     GIR_EraseRootFromParent_Done,
     /*  484131 */   // Label 8161: @484131
     /*  484131 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(484217), // Rule ID 62035 //
     /*  484136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  484153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484183 */     // MIs[1] Operand 1
     /*  484183 */     // No operand predicates
     /*  484183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484215 */     GIR_RootConstrainSelectedInstOperands,
     /*  484216 */     // GIR_Coverage, 62035,
     /*  484216 */     GIR_EraseRootFromParent_Done,
     /*  484217 */   // Label 8162: @484217
     /*  484217 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(484303), // Rule ID 62038 //
     /*  484222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  484239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484269 */     // MIs[1] Operand 1
     /*  484269 */     // No operand predicates
     /*  484269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  484278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484301 */     GIR_RootConstrainSelectedInstOperands,
     /*  484302 */     // GIR_Coverage, 62038,
     /*  484302 */     GIR_EraseRootFromParent_Done,
     /*  484303 */   // Label 8163: @484303
     /*  484303 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(484389), // Rule ID 62039 //
     /*  484308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  484325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484355 */     // MIs[1] Operand 1
     /*  484355 */     // No operand predicates
     /*  484355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  484364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484387 */     GIR_RootConstrainSelectedInstOperands,
     /*  484388 */     // GIR_Coverage, 62039,
     /*  484388 */     GIR_EraseRootFromParent_Done,
     /*  484389 */   // Label 8164: @484389
     /*  484389 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(484475), // Rule ID 62042 //
     /*  484394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484441 */     // MIs[1] Operand 1
     /*  484441 */     // No operand predicates
     /*  484441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  484450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484473 */     GIR_RootConstrainSelectedInstOperands,
     /*  484474 */     // GIR_Coverage, 62042,
     /*  484474 */     GIR_EraseRootFromParent_Done,
     /*  484475 */   // Label 8165: @484475
     /*  484475 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(484561), // Rule ID 62043 //
     /*  484480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484527 */     // MIs[1] Operand 1
     /*  484527 */     // No operand predicates
     /*  484527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  484536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484559 */     GIR_RootConstrainSelectedInstOperands,
     /*  484560 */     // GIR_Coverage, 62043,
     /*  484560 */     GIR_EraseRootFromParent_Done,
     /*  484561 */   // Label 8166: @484561
     /*  484561 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(484647), // Rule ID 62046 //
     /*  484566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484613 */     // MIs[1] Operand 1
     /*  484613 */     // No operand predicates
     /*  484613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484645 */     GIR_RootConstrainSelectedInstOperands,
     /*  484646 */     // GIR_Coverage, 62046,
     /*  484646 */     GIR_EraseRootFromParent_Done,
     /*  484647 */   // Label 8167: @484647
     /*  484647 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(484733), // Rule ID 62047 //
     /*  484652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484699 */     // MIs[1] Operand 1
     /*  484699 */     // No operand predicates
     /*  484699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484708 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484731 */     GIR_RootConstrainSelectedInstOperands,
     /*  484732 */     // GIR_Coverage, 62047,
     /*  484732 */     GIR_EraseRootFromParent_Done,
     /*  484733 */   // Label 8168: @484733
     /*  484733 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(484819), // Rule ID 62050 //
     /*  484738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484785 */     // MIs[1] Operand 1
     /*  484785 */     // No operand predicates
     /*  484785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484817 */     GIR_RootConstrainSelectedInstOperands,
     /*  484818 */     // GIR_Coverage, 62050,
     /*  484818 */     GIR_EraseRootFromParent_Done,
     /*  484819 */   // Label 8169: @484819
     /*  484819 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(484905), // Rule ID 62051 //
     /*  484824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484871 */     // MIs[1] Operand 1
     /*  484871 */     // No operand predicates
     /*  484871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484880 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484903 */     GIR_RootConstrainSelectedInstOperands,
     /*  484904 */     // GIR_Coverage, 62051,
     /*  484904 */     GIR_EraseRootFromParent_Done,
     /*  484905 */   // Label 8170: @484905
     /*  484905 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(484991), // Rule ID 62054 //
     /*  484910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484957 */     // MIs[1] Operand 1
     /*  484957 */     // No operand predicates
     /*  484957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484966 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484989 */     GIR_RootConstrainSelectedInstOperands,
     /*  484990 */     // GIR_Coverage, 62054,
     /*  484990 */     GIR_EraseRootFromParent_Done,
     /*  484991 */   // Label 8171: @484991
     /*  484991 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(485077), // Rule ID 62055 //
     /*  484996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  485007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  485010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  485013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485043 */     // MIs[1] Operand 1
     /*  485043 */     // No operand predicates
     /*  485043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  485052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485075 */     GIR_RootConstrainSelectedInstOperands,
     /*  485076 */     // GIR_Coverage, 62055,
     /*  485076 */     GIR_EraseRootFromParent_Done,
     /*  485077 */   // Label 8172: @485077
     /*  485077 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(485163), // Rule ID 62058 //
     /*  485082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  485093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  485096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485129 */     // MIs[1] Operand 1
     /*  485129 */     // No operand predicates
     /*  485129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485161 */     GIR_RootConstrainSelectedInstOperands,
     /*  485162 */     // GIR_Coverage, 62058,
     /*  485162 */     GIR_EraseRootFromParent_Done,
     /*  485163 */   // Label 8173: @485163
     /*  485163 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(485249), // Rule ID 62059 //
     /*  485168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  485179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  485182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485215 */     // MIs[1] Operand 1
     /*  485215 */     // No operand predicates
     /*  485215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485247 */     GIR_RootConstrainSelectedInstOperands,
     /*  485248 */     // GIR_Coverage, 62059,
     /*  485248 */     GIR_EraseRootFromParent_Done,
     /*  485249 */   // Label 8174: @485249
     /*  485249 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(485335), // Rule ID 62062 //
     /*  485254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  485265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  485268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485301 */     // MIs[1] Operand 1
     /*  485301 */     // No operand predicates
     /*  485301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485333 */     GIR_RootConstrainSelectedInstOperands,
     /*  485334 */     // GIR_Coverage, 62062,
     /*  485334 */     GIR_EraseRootFromParent_Done,
     /*  485335 */   // Label 8175: @485335
     /*  485335 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(485421), // Rule ID 62063 //
     /*  485340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  485351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  485354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485387 */     // MIs[1] Operand 1
     /*  485387 */     // No operand predicates
     /*  485387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485419 */     GIR_RootConstrainSelectedInstOperands,
     /*  485420 */     // GIR_Coverage, 62063,
     /*  485420 */     GIR_EraseRootFromParent_Done,
     /*  485421 */   // Label 8176: @485421
     /*  485421 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(485507), // Rule ID 62066 //
     /*  485426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485473 */     // MIs[1] Operand 1
     /*  485473 */     // No operand predicates
     /*  485473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485505 */     GIR_RootConstrainSelectedInstOperands,
     /*  485506 */     // GIR_Coverage, 62066,
     /*  485506 */     GIR_EraseRootFromParent_Done,
     /*  485507 */   // Label 8177: @485507
     /*  485507 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(485593), // Rule ID 62067 //
     /*  485512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485559 */     // MIs[1] Operand 1
     /*  485559 */     // No operand predicates
     /*  485559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485591 */     GIR_RootConstrainSelectedInstOperands,
     /*  485592 */     // GIR_Coverage, 62067,
     /*  485592 */     GIR_EraseRootFromParent_Done,
     /*  485593 */   // Label 8178: @485593
     /*  485593 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(485679), // Rule ID 62070 //
     /*  485598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485645 */     // MIs[1] Operand 1
     /*  485645 */     // No operand predicates
     /*  485645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485677 */     GIR_RootConstrainSelectedInstOperands,
     /*  485678 */     // GIR_Coverage, 62070,
     /*  485678 */     GIR_EraseRootFromParent_Done,
     /*  485679 */   // Label 8179: @485679
     /*  485679 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(485765), // Rule ID 62071 //
     /*  485684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485731 */     // MIs[1] Operand 1
     /*  485731 */     // No operand predicates
     /*  485731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485763 */     GIR_RootConstrainSelectedInstOperands,
     /*  485764 */     // GIR_Coverage, 62071,
     /*  485764 */     GIR_EraseRootFromParent_Done,
     /*  485765 */   // Label 8180: @485765
     /*  485765 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(485851), // Rule ID 62074 //
     /*  485770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485817 */     // MIs[1] Operand 1
     /*  485817 */     // No operand predicates
     /*  485817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485849 */     GIR_RootConstrainSelectedInstOperands,
     /*  485850 */     // GIR_Coverage, 62074,
     /*  485850 */     GIR_EraseRootFromParent_Done,
     /*  485851 */   // Label 8181: @485851
     /*  485851 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(485937), // Rule ID 62075 //
     /*  485856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485903 */     // MIs[1] Operand 1
     /*  485903 */     // No operand predicates
     /*  485903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485912 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485935 */     GIR_RootConstrainSelectedInstOperands,
     /*  485936 */     // GIR_Coverage, 62075,
     /*  485936 */     GIR_EraseRootFromParent_Done,
     /*  485937 */   // Label 8182: @485937
     /*  485937 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(486023), // Rule ID 62078 //
     /*  485942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485989 */     // MIs[1] Operand 1
     /*  485989 */     // No operand predicates
     /*  485989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486021 */     GIR_RootConstrainSelectedInstOperands,
     /*  486022 */     // GIR_Coverage, 62078,
     /*  486022 */     GIR_EraseRootFromParent_Done,
     /*  486023 */   // Label 8183: @486023
     /*  486023 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(486109), // Rule ID 62079 //
     /*  486028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  486039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  486042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  486045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486075 */     // MIs[1] Operand 1
     /*  486075 */     // No operand predicates
     /*  486075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486107 */     GIR_RootConstrainSelectedInstOperands,
     /*  486108 */     // GIR_Coverage, 62079,
     /*  486108 */     GIR_EraseRootFromParent_Done,
     /*  486109 */   // Label 8184: @486109
     /*  486109 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(486195), // Rule ID 62082 //
     /*  486114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  486125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  486128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  486131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486161 */     // MIs[1] Operand 1
     /*  486161 */     // No operand predicates
     /*  486161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  486173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486193 */     GIR_RootConstrainSelectedInstOperands,
     /*  486194 */     // GIR_Coverage, 62082,
     /*  486194 */     GIR_EraseRootFromParent_Done,
     /*  486195 */   // Label 8185: @486195
     /*  486195 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(486281), // Rule ID 62083 //
     /*  486200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  486211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  486214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  486217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486247 */     // MIs[1] Operand 1
     /*  486247 */     // No operand predicates
     /*  486247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  486259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486279 */     GIR_RootConstrainSelectedInstOperands,
     /*  486280 */     // GIR_Coverage, 62083,
     /*  486280 */     GIR_EraseRootFromParent_Done,
     /*  486281 */   // Label 8186: @486281
     /*  486281 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(486367), // Rule ID 62086 //
     /*  486286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  486297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  486300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  486303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486333 */     // MIs[1] Operand 1
     /*  486333 */     // No operand predicates
     /*  486333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  486345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486365 */     GIR_RootConstrainSelectedInstOperands,
     /*  486366 */     // GIR_Coverage, 62086,
     /*  486366 */     GIR_EraseRootFromParent_Done,
     /*  486367 */   // Label 8187: @486367
     /*  486367 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(486453), // Rule ID 62087 //
     /*  486372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  486383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  486386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  486389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486419 */     // MIs[1] Operand 1
     /*  486419 */     // No operand predicates
     /*  486419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  486431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486451 */     GIR_RootConstrainSelectedInstOperands,
     /*  486452 */     // GIR_Coverage, 62087,
     /*  486452 */     GIR_EraseRootFromParent_Done,
     /*  486453 */   // Label 8188: @486453
     /*  486453 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(486539), // Rule ID 62090 //
     /*  486458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486505 */     // MIs[1] Operand 1
     /*  486505 */     // No operand predicates
     /*  486505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486537 */     GIR_RootConstrainSelectedInstOperands,
     /*  486538 */     // GIR_Coverage, 62090,
     /*  486538 */     GIR_EraseRootFromParent_Done,
     /*  486539 */   // Label 8189: @486539
     /*  486539 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(486625), // Rule ID 62091 //
     /*  486544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486591 */     // MIs[1] Operand 1
     /*  486591 */     // No operand predicates
     /*  486591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486600 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486623 */     GIR_RootConstrainSelectedInstOperands,
     /*  486624 */     // GIR_Coverage, 62091,
     /*  486624 */     GIR_EraseRootFromParent_Done,
     /*  486625 */   // Label 8190: @486625
     /*  486625 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(486704), // Rule ID 2756 //
     /*  486630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486702 */     GIR_RootConstrainSelectedInstOperands,
     /*  486703 */     // GIR_Coverage, 2756,
     /*  486703 */     GIR_EraseRootFromParent_Done,
     /*  486704 */   // Label 8191: @486704
     /*  486704 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(486783), // Rule ID 2757 //
     /*  486709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486781 */     GIR_RootConstrainSelectedInstOperands,
     /*  486782 */     // GIR_Coverage, 2757,
     /*  486782 */     GIR_EraseRootFromParent_Done,
     /*  486783 */   // Label 8192: @486783
     /*  486783 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(486862), // Rule ID 4072 //
     /*  486788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486860 */     GIR_RootConstrainSelectedInstOperands,
     /*  486861 */     // GIR_Coverage, 4072,
     /*  486861 */     GIR_EraseRootFromParent_Done,
     /*  486862 */   // Label 8193: @486862
     /*  486862 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(486941), // Rule ID 4073 //
     /*  486867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486939 */     GIR_RootConstrainSelectedInstOperands,
     /*  486940 */     // GIR_Coverage, 4073,
     /*  486940 */     GIR_EraseRootFromParent_Done,
     /*  486941 */   // Label 8194: @486941
     /*  486941 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(487020), // Rule ID 4082 //
     /*  486946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487018 */     GIR_RootConstrainSelectedInstOperands,
     /*  487019 */     // GIR_Coverage, 4082,
     /*  487019 */     GIR_EraseRootFromParent_Done,
     /*  487020 */   // Label 8195: @487020
     /*  487020 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(487099), // Rule ID 4083 //
     /*  487025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  487045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487097 */     GIR_RootConstrainSelectedInstOperands,
     /*  487098 */     // GIR_Coverage, 4083,
     /*  487098 */     GIR_EraseRootFromParent_Done,
     /*  487099 */   // Label 8196: @487099
     /*  487099 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(487178), // Rule ID 4092 //
     /*  487104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  487115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  487118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  487124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487176 */     GIR_RootConstrainSelectedInstOperands,
     /*  487177 */     // GIR_Coverage, 4092,
     /*  487177 */     GIR_EraseRootFromParent_Done,
     /*  487178 */   // Label 8197: @487178
     /*  487178 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(487257), // Rule ID 4093 //
     /*  487183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  487194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  487197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  487200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  487203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487255 */     GIR_RootConstrainSelectedInstOperands,
     /*  487256 */     // GIR_Coverage, 4093,
     /*  487256 */     GIR_EraseRootFromParent_Done,
     /*  487257 */   // Label 8198: @487257
     /*  487257 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(487336), // Rule ID 4102 //
     /*  487262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  487273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  487276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  487282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487334 */     GIR_RootConstrainSelectedInstOperands,
     /*  487335 */     // GIR_Coverage, 4102,
     /*  487335 */     GIR_EraseRootFromParent_Done,
     /*  487336 */   // Label 8199: @487336
     /*  487336 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(487415), // Rule ID 4103 //
     /*  487341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  487352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  487355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  487358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  487361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487413 */     GIR_RootConstrainSelectedInstOperands,
     /*  487414 */     // GIR_Coverage, 4103,
     /*  487414 */     GIR_EraseRootFromParent_Done,
     /*  487415 */   // Label 8200: @487415
     /*  487415 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(487494), // Rule ID 4112 //
     /*  487420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487492 */     GIR_RootConstrainSelectedInstOperands,
     /*  487493 */     // GIR_Coverage, 4112,
     /*  487493 */     GIR_EraseRootFromParent_Done,
     /*  487494 */   // Label 8201: @487494
     /*  487494 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(487573), // Rule ID 4113 //
     /*  487499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487551 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487571 */     GIR_RootConstrainSelectedInstOperands,
     /*  487572 */     // GIR_Coverage, 4113,
     /*  487572 */     GIR_EraseRootFromParent_Done,
     /*  487573 */   // Label 8202: @487573
     /*  487573 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(487652), // Rule ID 4122 //
     /*  487578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487650 */     GIR_RootConstrainSelectedInstOperands,
     /*  487651 */     // GIR_Coverage, 4122,
     /*  487651 */     GIR_EraseRootFromParent_Done,
     /*  487652 */   // Label 8203: @487652
     /*  487652 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(487731), // Rule ID 4123 //
     /*  487657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487729 */     GIR_RootConstrainSelectedInstOperands,
     /*  487730 */     // GIR_Coverage, 4123,
     /*  487730 */     GIR_EraseRootFromParent_Done,
     /*  487731 */   // Label 8204: @487731
     /*  487731 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(487810), // Rule ID 4132 //
     /*  487736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487808 */     GIR_RootConstrainSelectedInstOperands,
     /*  487809 */     // GIR_Coverage, 4132,
     /*  487809 */     GIR_EraseRootFromParent_Done,
     /*  487810 */   // Label 8205: @487810
     /*  487810 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(487889), // Rule ID 4133 //
     /*  487815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487867 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487887 */     GIR_RootConstrainSelectedInstOperands,
     /*  487888 */     // GIR_Coverage, 4133,
     /*  487888 */     GIR_EraseRootFromParent_Done,
     /*  487889 */   // Label 8206: @487889
     /*  487889 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(487968), // Rule ID 4142 //
     /*  487894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487966 */     GIR_RootConstrainSelectedInstOperands,
     /*  487967 */     // GIR_Coverage, 4142,
     /*  487967 */     GIR_EraseRootFromParent_Done,
     /*  487968 */   // Label 8207: @487968
     /*  487968 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(488047), // Rule ID 4143 //
     /*  487973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488045 */     GIR_RootConstrainSelectedInstOperands,
     /*  488046 */     // GIR_Coverage, 4143,
     /*  488046 */     GIR_EraseRootFromParent_Done,
     /*  488047 */   // Label 8208: @488047
     /*  488047 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(488126), // Rule ID 4152 //
     /*  488052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  488063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  488066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  488069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  488072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  488104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488124 */     GIR_RootConstrainSelectedInstOperands,
     /*  488125 */     // GIR_Coverage, 4152,
     /*  488125 */     GIR_EraseRootFromParent_Done,
     /*  488126 */   // Label 8209: @488126
     /*  488126 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(488205), // Rule ID 4153 //
     /*  488131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  488142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  488145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  488148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  488151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488183 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488203 */     GIR_RootConstrainSelectedInstOperands,
     /*  488204 */     // GIR_Coverage, 4153,
     /*  488204 */     GIR_EraseRootFromParent_Done,
     /*  488205 */   // Label 8210: @488205
     /*  488205 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(488284), // Rule ID 4162 //
     /*  488210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  488221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  488224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  488227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  488230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  488262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488282 */     GIR_RootConstrainSelectedInstOperands,
     /*  488283 */     // GIR_Coverage, 4162,
     /*  488283 */     GIR_EraseRootFromParent_Done,
     /*  488284 */   // Label 8211: @488284
     /*  488284 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(488363), // Rule ID 4163 //
     /*  488289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  488300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  488303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  488306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  488309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488341 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  488341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488361 */     GIR_RootConstrainSelectedInstOperands,
     /*  488362 */     // GIR_Coverage, 4163,
     /*  488362 */     GIR_EraseRootFromParent_Done,
     /*  488363 */   // Label 8212: @488363
     /*  488363 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(488442), // Rule ID 4172 //
     /*  488368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  488379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  488382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  488385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488440 */     GIR_RootConstrainSelectedInstOperands,
     /*  488441 */     // GIR_Coverage, 4172,
     /*  488441 */     GIR_EraseRootFromParent_Done,
     /*  488442 */   // Label 8213: @488442
     /*  488442 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(488521), // Rule ID 4173 //
     /*  488447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  488458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  488461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  488464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488519 */     GIR_RootConstrainSelectedInstOperands,
     /*  488520 */     // GIR_Coverage, 4173,
     /*  488520 */     GIR_EraseRootFromParent_Done,
     /*  488521 */   // Label 8214: @488521
     /*  488521 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(488600), // Rule ID 4182 //
     /*  488526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488598 */     GIR_RootConstrainSelectedInstOperands,
     /*  488599 */     // GIR_Coverage, 4182,
     /*  488599 */     GIR_EraseRootFromParent_Done,
     /*  488600 */   // Label 8215: @488600
     /*  488600 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(488679), // Rule ID 4183 //
     /*  488605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488677 */     GIR_RootConstrainSelectedInstOperands,
     /*  488678 */     // GIR_Coverage, 4183,
     /*  488678 */     GIR_EraseRootFromParent_Done,
     /*  488679 */   // Label 8216: @488679
     /*  488679 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(488758), // Rule ID 4192 //
     /*  488684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488756 */     GIR_RootConstrainSelectedInstOperands,
     /*  488757 */     // GIR_Coverage, 4192,
     /*  488757 */     GIR_EraseRootFromParent_Done,
     /*  488758 */   // Label 8217: @488758
     /*  488758 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(488837), // Rule ID 4193 //
     /*  488763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488815 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488835 */     GIR_RootConstrainSelectedInstOperands,
     /*  488836 */     // GIR_Coverage, 4193,
     /*  488836 */     GIR_EraseRootFromParent_Done,
     /*  488837 */   // Label 8218: @488837
     /*  488837 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(488916), // Rule ID 4202 //
     /*  488842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488914 */     GIR_RootConstrainSelectedInstOperands,
     /*  488915 */     // GIR_Coverage, 4202,
     /*  488915 */     GIR_EraseRootFromParent_Done,
     /*  488916 */   // Label 8219: @488916
     /*  488916 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(488995), // Rule ID 4203 //
     /*  488921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488973 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488993 */     GIR_RootConstrainSelectedInstOperands,
     /*  488994 */     // GIR_Coverage, 4203,
     /*  488994 */     GIR_EraseRootFromParent_Done,
     /*  488995 */   // Label 8220: @488995
     /*  488995 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(489074), // Rule ID 4272 //
     /*  489000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  489011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  489014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  489017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  489020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  489055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489072 */     GIR_RootConstrainSelectedInstOperands,
     /*  489073 */     // GIR_Coverage, 4272,
     /*  489073 */     GIR_EraseRootFromParent_Done,
     /*  489074 */   // Label 8221: @489074
     /*  489074 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(489153), // Rule ID 4273 //
     /*  489079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  489090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  489093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  489096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  489099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489131 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  489134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489151 */     GIR_RootConstrainSelectedInstOperands,
     /*  489152 */     // GIR_Coverage, 4273,
     /*  489152 */     GIR_EraseRootFromParent_Done,
     /*  489153 */   // Label 8222: @489153
     /*  489153 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(489232), // Rule ID 4282 //
     /*  489158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  489169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  489172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  489178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489210 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489230 */     GIR_RootConstrainSelectedInstOperands,
     /*  489231 */     // GIR_Coverage, 4282,
     /*  489231 */     GIR_EraseRootFromParent_Done,
     /*  489232 */   // Label 8223: @489232
     /*  489232 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(489311), // Rule ID 4283 //
     /*  489237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  489248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  489251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  489254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  489257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489309 */     GIR_RootConstrainSelectedInstOperands,
     /*  489310 */     // GIR_Coverage, 4283,
     /*  489310 */     GIR_EraseRootFromParent_Done,
     /*  489311 */   // Label 8224: @489311
     /*  489311 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(489390), // Rule ID 4292 //
     /*  489316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  489327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  489330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  489336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489388 */     GIR_RootConstrainSelectedInstOperands,
     /*  489389 */     // GIR_Coverage, 4292,
     /*  489389 */     GIR_EraseRootFromParent_Done,
     /*  489390 */   // Label 8225: @489390
     /*  489390 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(489469), // Rule ID 4293 //
     /*  489395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  489406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  489409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  489412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  489415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489447 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489467 */     GIR_RootConstrainSelectedInstOperands,
     /*  489468 */     // GIR_Coverage, 4293,
     /*  489468 */     GIR_EraseRootFromParent_Done,
     /*  489469 */   // Label 8226: @489469
     /*  489469 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(489548), // Rule ID 4302 //
     /*  489474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489546 */     GIR_RootConstrainSelectedInstOperands,
     /*  489547 */     // GIR_Coverage, 4302,
     /*  489547 */     GIR_EraseRootFromParent_Done,
     /*  489548 */   // Label 8227: @489548
     /*  489548 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(489627), // Rule ID 4303 //
     /*  489553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489625 */     GIR_RootConstrainSelectedInstOperands,
     /*  489626 */     // GIR_Coverage, 4303,
     /*  489626 */     GIR_EraseRootFromParent_Done,
     /*  489627 */   // Label 8228: @489627
     /*  489627 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(489706), // Rule ID 4312 //
     /*  489632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489704 */     GIR_RootConstrainSelectedInstOperands,
     /*  489705 */     // GIR_Coverage, 4312,
     /*  489705 */     GIR_EraseRootFromParent_Done,
     /*  489706 */   // Label 8229: @489706
     /*  489706 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(489785), // Rule ID 4313 //
     /*  489711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489763 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489783 */     GIR_RootConstrainSelectedInstOperands,
     /*  489784 */     // GIR_Coverage, 4313,
     /*  489784 */     GIR_EraseRootFromParent_Done,
     /*  489785 */   // Label 8230: @489785
     /*  489785 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(489864), // Rule ID 4322 //
     /*  489790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489862 */     GIR_RootConstrainSelectedInstOperands,
     /*  489863 */     // GIR_Coverage, 4322,
     /*  489863 */     GIR_EraseRootFromParent_Done,
     /*  489864 */   // Label 8231: @489864
     /*  489864 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(489943), // Rule ID 4323 //
     /*  489869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489941 */     GIR_RootConstrainSelectedInstOperands,
     /*  489942 */     // GIR_Coverage, 4323,
     /*  489942 */     GIR_EraseRootFromParent_Done,
     /*  489943 */   // Label 8232: @489943
     /*  489943 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(490022), // Rule ID 4332 //
     /*  489948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  490003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490020 */     GIR_RootConstrainSelectedInstOperands,
     /*  490021 */     // GIR_Coverage, 4332,
     /*  490021 */     GIR_EraseRootFromParent_Done,
     /*  490022 */   // Label 8233: @490022
     /*  490022 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(490101), // Rule ID 4333 //
     /*  490027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  490038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  490041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  490044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  490047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490079 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  490082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490099 */     GIR_RootConstrainSelectedInstOperands,
     /*  490100 */     // GIR_Coverage, 4333,
     /*  490100 */     GIR_EraseRootFromParent_Done,
     /*  490101 */   // Label 8234: @490101
     /*  490101 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(490180), // Rule ID 4342 //
     /*  490106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  490117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  490120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  490123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  490126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490178 */     GIR_RootConstrainSelectedInstOperands,
     /*  490179 */     // GIR_Coverage, 4342,
     /*  490179 */     GIR_EraseRootFromParent_Done,
     /*  490180 */   // Label 8235: @490180
     /*  490180 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(490259), // Rule ID 4343 //
     /*  490185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  490196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  490199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  490202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  490205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490237 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490257 */     GIR_RootConstrainSelectedInstOperands,
     /*  490258 */     // GIR_Coverage, 4343,
     /*  490258 */     GIR_EraseRootFromParent_Done,
     /*  490259 */   // Label 8236: @490259
     /*  490259 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(490338), // Rule ID 4352 //
     /*  490264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  490275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  490278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  490281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  490284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490336 */     GIR_RootConstrainSelectedInstOperands,
     /*  490337 */     // GIR_Coverage, 4352,
     /*  490337 */     GIR_EraseRootFromParent_Done,
     /*  490338 */   // Label 8237: @490338
     /*  490338 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(490417), // Rule ID 4353 //
     /*  490343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  490354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  490357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  490360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  490363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490415 */     GIR_RootConstrainSelectedInstOperands,
     /*  490416 */     // GIR_Coverage, 4353,
     /*  490416 */     GIR_EraseRootFromParent_Done,
     /*  490417 */   // Label 8238: @490417
     /*  490417 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(490496), // Rule ID 4362 //
     /*  490422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490494 */     GIR_RootConstrainSelectedInstOperands,
     /*  490495 */     // GIR_Coverage, 4362,
     /*  490495 */     GIR_EraseRootFromParent_Done,
     /*  490496 */   // Label 8239: @490496
     /*  490496 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(490575), // Rule ID 4363 //
     /*  490501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490573 */     GIR_RootConstrainSelectedInstOperands,
     /*  490574 */     // GIR_Coverage, 4363,
     /*  490574 */     GIR_EraseRootFromParent_Done,
     /*  490575 */   // Label 8240: @490575
     /*  490575 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(490654), // Rule ID 4372 //
     /*  490580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490652 */     GIR_RootConstrainSelectedInstOperands,
     /*  490653 */     // GIR_Coverage, 4372,
     /*  490653 */     GIR_EraseRootFromParent_Done,
     /*  490654 */   // Label 8241: @490654
     /*  490654 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(490733), // Rule ID 4373 //
     /*  490659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490711 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490731 */     GIR_RootConstrainSelectedInstOperands,
     /*  490732 */     // GIR_Coverage, 4373,
     /*  490732 */     GIR_EraseRootFromParent_Done,
     /*  490733 */   // Label 8242: @490733
     /*  490733 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(490812), // Rule ID 4382 //
     /*  490738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490810 */     GIR_RootConstrainSelectedInstOperands,
     /*  490811 */     // GIR_Coverage, 4382,
     /*  490811 */     GIR_EraseRootFromParent_Done,
     /*  490812 */   // Label 8243: @490812
     /*  490812 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(490891), // Rule ID 4383 //
     /*  490817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490889 */     GIR_RootConstrainSelectedInstOperands,
     /*  490890 */     // GIR_Coverage, 4383,
     /*  490890 */     GIR_EraseRootFromParent_Done,
     /*  490891 */   // Label 8244: @490891
     /*  490891 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(490970), // Rule ID 4392 //
     /*  490896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490968 */     GIR_RootConstrainSelectedInstOperands,
     /*  490969 */     // GIR_Coverage, 4392,
     /*  490969 */     GIR_EraseRootFromParent_Done,
     /*  490970 */   // Label 8245: @490970
     /*  490970 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(491049), // Rule ID 4393 //
     /*  490975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  491030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491047 */     GIR_RootConstrainSelectedInstOperands,
     /*  491048 */     // GIR_Coverage, 4393,
     /*  491048 */     GIR_EraseRootFromParent_Done,
     /*  491049 */   // Label 8246: @491049
     /*  491049 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(491128), // Rule ID 4402 //
     /*  491054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  491065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  491068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  491071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  491074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  491109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491126 */     GIR_RootConstrainSelectedInstOperands,
     /*  491127 */     // GIR_Coverage, 4402,
     /*  491127 */     GIR_EraseRootFromParent_Done,
     /*  491128 */   // Label 8247: @491128
     /*  491128 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(491207), // Rule ID 4403 //
     /*  491133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  491144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  491147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  491150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  491153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491185 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  491188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491205 */     GIR_RootConstrainSelectedInstOperands,
     /*  491206 */     // GIR_Coverage, 4403,
     /*  491206 */     GIR_EraseRootFromParent_Done,
     /*  491207 */   // Label 8248: @491207
     /*  491207 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(491286), // Rule ID 4412 //
     /*  491212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  491223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  491226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  491229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  491232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  491267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491284 */     GIR_RootConstrainSelectedInstOperands,
     /*  491285 */     // GIR_Coverage, 4412,
     /*  491285 */     GIR_EraseRootFromParent_Done,
     /*  491286 */   // Label 8249: @491286
     /*  491286 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(491365), // Rule ID 4413 //
     /*  491291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  491299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  491302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  491305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  491308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  491311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  491346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491363 */     GIR_RootConstrainSelectedInstOperands,
     /*  491364 */     // GIR_Coverage, 4413,
     /*  491364 */     GIR_EraseRootFromParent_Done,
     /*  491365 */   // Label 8250: @491365
     /*  491365 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(491444), // Rule ID 4482 //
     /*  491370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  491381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  491384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491422 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491442 */     GIR_RootConstrainSelectedInstOperands,
     /*  491443 */     // GIR_Coverage, 4482,
     /*  491443 */     GIR_EraseRootFromParent_Done,
     /*  491444 */   // Label 8251: @491444
     /*  491444 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(491523), // Rule ID 4483 //
     /*  491449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  491460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  491463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491501 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491521 */     GIR_RootConstrainSelectedInstOperands,
     /*  491522 */     // GIR_Coverage, 4483,
     /*  491522 */     GIR_EraseRootFromParent_Done,
     /*  491523 */   // Label 8252: @491523
     /*  491523 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(491602), // Rule ID 4492 //
     /*  491528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491600 */     GIR_RootConstrainSelectedInstOperands,
     /*  491601 */     // GIR_Coverage, 4492,
     /*  491601 */     GIR_EraseRootFromParent_Done,
     /*  491602 */   // Label 8253: @491602
     /*  491602 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(491681), // Rule ID 4493 //
     /*  491607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491679 */     GIR_RootConstrainSelectedInstOperands,
     /*  491680 */     // GIR_Coverage, 4493,
     /*  491680 */     GIR_EraseRootFromParent_Done,
     /*  491681 */   // Label 8254: @491681
     /*  491681 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(491760), // Rule ID 4502 //
     /*  491686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491758 */     GIR_RootConstrainSelectedInstOperands,
     /*  491759 */     // GIR_Coverage, 4502,
     /*  491759 */     GIR_EraseRootFromParent_Done,
     /*  491760 */   // Label 8255: @491760
     /*  491760 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(491839), // Rule ID 4503 //
     /*  491765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491817 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491837 */     GIR_RootConstrainSelectedInstOperands,
     /*  491838 */     // GIR_Coverage, 4503,
     /*  491838 */     GIR_EraseRootFromParent_Done,
     /*  491839 */   // Label 8256: @491839
     /*  491839 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(491918), // Rule ID 4512 //
     /*  491844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491916 */     GIR_RootConstrainSelectedInstOperands,
     /*  491917 */     // GIR_Coverage, 4512,
     /*  491917 */     GIR_EraseRootFromParent_Done,
     /*  491918 */   // Label 8257: @491918
     /*  491918 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(491997), // Rule ID 4513 //
     /*  491923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491995 */     GIR_RootConstrainSelectedInstOperands,
     /*  491996 */     // GIR_Coverage, 4513,
     /*  491996 */     GIR_EraseRootFromParent_Done,
     /*  491997 */   // Label 8258: @491997
     /*  491997 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(492076), // Rule ID 4522 //
     /*  492002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  492013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  492016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  492019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  492022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492074 */     GIR_RootConstrainSelectedInstOperands,
     /*  492075 */     // GIR_Coverage, 4522,
     /*  492075 */     GIR_EraseRootFromParent_Done,
     /*  492076 */   // Label 8259: @492076
     /*  492076 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(492155), // Rule ID 4523 //
     /*  492081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  492092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  492095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  492098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  492101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492133 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492153 */     GIR_RootConstrainSelectedInstOperands,
     /*  492154 */     // GIR_Coverage, 4523,
     /*  492154 */     GIR_EraseRootFromParent_Done,
     /*  492155 */   // Label 8260: @492155
     /*  492155 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(492234), // Rule ID 4532 //
     /*  492160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  492171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  492174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  492177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  492180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492232 */     GIR_RootConstrainSelectedInstOperands,
     /*  492233 */     // GIR_Coverage, 4532,
     /*  492233 */     GIR_EraseRootFromParent_Done,
     /*  492234 */   // Label 8261: @492234
     /*  492234 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(492313), // Rule ID 4533 //
     /*  492239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  492250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  492253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  492256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  492259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492291 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492311 */     GIR_RootConstrainSelectedInstOperands,
     /*  492312 */     // GIR_Coverage, 4533,
     /*  492312 */     GIR_EraseRootFromParent_Done,
     /*  492313 */   // Label 8262: @492313
     /*  492313 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(492392), // Rule ID 4542 //
     /*  492318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  492329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  492332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  492335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  492338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  492373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492390 */     GIR_RootConstrainSelectedInstOperands,
     /*  492391 */     // GIR_Coverage, 4542,
     /*  492391 */     GIR_EraseRootFromParent_Done,
     /*  492392 */   // Label 8263: @492392
     /*  492392 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(492471), // Rule ID 4543 //
     /*  492397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  492408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  492411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  492414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  492417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  492452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492469 */     GIR_RootConstrainSelectedInstOperands,
     /*  492470 */     // GIR_Coverage, 4543,
     /*  492470 */     GIR_EraseRootFromParent_Done,
     /*  492471 */   // Label 8264: @492471
     /*  492471 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(492550), // Rule ID 4552 //
     /*  492476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492548 */     GIR_RootConstrainSelectedInstOperands,
     /*  492549 */     // GIR_Coverage, 4552,
     /*  492549 */     GIR_EraseRootFromParent_Done,
     /*  492550 */   // Label 8265: @492550
     /*  492550 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(492629), // Rule ID 4553 //
     /*  492555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492607 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492627 */     GIR_RootConstrainSelectedInstOperands,
     /*  492628 */     // GIR_Coverage, 4553,
     /*  492628 */     GIR_EraseRootFromParent_Done,
     /*  492629 */   // Label 8266: @492629
     /*  492629 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(492708), // Rule ID 4562 //
     /*  492634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492706 */     GIR_RootConstrainSelectedInstOperands,
     /*  492707 */     // GIR_Coverage, 4562,
     /*  492707 */     GIR_EraseRootFromParent_Done,
     /*  492708 */   // Label 8267: @492708
     /*  492708 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(492787), // Rule ID 4563 //
     /*  492713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492785 */     GIR_RootConstrainSelectedInstOperands,
     /*  492786 */     // GIR_Coverage, 4563,
     /*  492786 */     GIR_EraseRootFromParent_Done,
     /*  492787 */   // Label 8268: @492787
     /*  492787 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(492866), // Rule ID 4572 //
     /*  492792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492864 */     GIR_RootConstrainSelectedInstOperands,
     /*  492865 */     // GIR_Coverage, 4572,
     /*  492865 */     GIR_EraseRootFromParent_Done,
     /*  492866 */   // Label 8269: @492866
     /*  492866 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(492945), // Rule ID 4573 //
     /*  492871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492923 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492943 */     GIR_RootConstrainSelectedInstOperands,
     /*  492944 */     // GIR_Coverage, 4573,
     /*  492944 */     GIR_EraseRootFromParent_Done,
     /*  492945 */   // Label 8270: @492945
     /*  492945 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(493024), // Rule ID 4582 //
     /*  492950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493022 */     GIR_RootConstrainSelectedInstOperands,
     /*  493023 */     // GIR_Coverage, 4582,
     /*  493023 */     GIR_EraseRootFromParent_Done,
     /*  493024 */   // Label 8271: @493024
     /*  493024 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(493103), // Rule ID 4583 //
     /*  493029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  493049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493081 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493101 */     GIR_RootConstrainSelectedInstOperands,
     /*  493102 */     // GIR_Coverage, 4583,
     /*  493102 */     GIR_EraseRootFromParent_Done,
     /*  493103 */   // Label 8272: @493103
     /*  493103 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(493182), // Rule ID 4592 //
     /*  493108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  493119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  493122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  493125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  493128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  493163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493180 */     GIR_RootConstrainSelectedInstOperands,
     /*  493181 */     // GIR_Coverage, 4592,
     /*  493181 */     GIR_EraseRootFromParent_Done,
     /*  493182 */   // Label 8273: @493182
     /*  493182 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(493261), // Rule ID 4593 //
     /*  493187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  493198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  493201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  493204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  493207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493239 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  493242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493259 */     GIR_RootConstrainSelectedInstOperands,
     /*  493260 */     // GIR_Coverage, 4593,
     /*  493260 */     GIR_EraseRootFromParent_Done,
     /*  493261 */   // Label 8274: @493261
     /*  493261 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(493340), // Rule ID 4602 //
     /*  493266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  493277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  493280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  493283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  493286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  493321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493338 */     GIR_RootConstrainSelectedInstOperands,
     /*  493339 */     // GIR_Coverage, 4602,
     /*  493339 */     GIR_EraseRootFromParent_Done,
     /*  493340 */   // Label 8275: @493340
     /*  493340 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(493419), // Rule ID 4603 //
     /*  493345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  493356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  493359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  493362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  493365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493397 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  493400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493417 */     GIR_RootConstrainSelectedInstOperands,
     /*  493418 */     // GIR_Coverage, 4603,
     /*  493418 */     GIR_EraseRootFromParent_Done,
     /*  493419 */   // Label 8276: @493419
     /*  493419 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(493498), // Rule ID 4612 //
     /*  493424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493496 */     GIR_RootConstrainSelectedInstOperands,
     /*  493497 */     // GIR_Coverage, 4612,
     /*  493497 */     GIR_EraseRootFromParent_Done,
     /*  493498 */   // Label 8277: @493498
     /*  493498 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(493577), // Rule ID 4613 //
     /*  493503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493555 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493575 */     GIR_RootConstrainSelectedInstOperands,
     /*  493576 */     // GIR_Coverage, 4613,
     /*  493576 */     GIR_EraseRootFromParent_Done,
     /*  493577 */   // Label 8278: @493577
     /*  493577 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(493656), // Rule ID 4622 //
     /*  493582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493654 */     GIR_RootConstrainSelectedInstOperands,
     /*  493655 */     // GIR_Coverage, 4622,
     /*  493655 */     GIR_EraseRootFromParent_Done,
     /*  493656 */   // Label 8279: @493656
     /*  493656 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(493735), // Rule ID 4623 //
     /*  493661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493713 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493733 */     GIR_RootConstrainSelectedInstOperands,
     /*  493734 */     // GIR_Coverage, 4623,
     /*  493734 */     GIR_EraseRootFromParent_Done,
     /*  493735 */   // Label 8280: @493735
     /*  493735 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(493814), // Rule ID 4692 //
     /*  493740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493812 */     GIR_RootConstrainSelectedInstOperands,
     /*  493813 */     // GIR_Coverage, 4692,
     /*  493813 */     GIR_EraseRootFromParent_Done,
     /*  493814 */   // Label 8281: @493814
     /*  493814 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(493893), // Rule ID 4693 //
     /*  493819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493871 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493891 */     GIR_RootConstrainSelectedInstOperands,
     /*  493892 */     // GIR_Coverage, 4693,
     /*  493892 */     GIR_EraseRootFromParent_Done,
     /*  493893 */   // Label 8282: @493893
     /*  493893 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(493972), // Rule ID 4702 //
     /*  493898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493970 */     GIR_RootConstrainSelectedInstOperands,
     /*  493971 */     // GIR_Coverage, 4702,
     /*  493971 */     GIR_EraseRootFromParent_Done,
     /*  493972 */   // Label 8283: @493972
     /*  493972 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(494051), // Rule ID 4703 //
     /*  493977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494029 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494049 */     GIR_RootConstrainSelectedInstOperands,
     /*  494050 */     // GIR_Coverage, 4703,
     /*  494050 */     GIR_EraseRootFromParent_Done,
     /*  494051 */   // Label 8284: @494051
     /*  494051 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(494130), // Rule ID 4712 //
     /*  494056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494128 */     GIR_RootConstrainSelectedInstOperands,
     /*  494129 */     // GIR_Coverage, 4712,
     /*  494129 */     GIR_EraseRootFromParent_Done,
     /*  494130 */   // Label 8285: @494130
     /*  494130 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(494209), // Rule ID 4713 //
     /*  494135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  494146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  494149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  494152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  494155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494187 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494207 */     GIR_RootConstrainSelectedInstOperands,
     /*  494208 */     // GIR_Coverage, 4713,
     /*  494208 */     GIR_EraseRootFromParent_Done,
     /*  494209 */   // Label 8286: @494209
     /*  494209 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(494288), // Rule ID 4722 //
     /*  494214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  494225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  494228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  494231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  494234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494286 */     GIR_RootConstrainSelectedInstOperands,
     /*  494287 */     // GIR_Coverage, 4722,
     /*  494287 */     GIR_EraseRootFromParent_Done,
     /*  494288 */   // Label 8287: @494288
     /*  494288 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(494367), // Rule ID 4723 //
     /*  494293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  494304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  494307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  494310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  494313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494365 */     GIR_RootConstrainSelectedInstOperands,
     /*  494366 */     // GIR_Coverage, 4723,
     /*  494366 */     GIR_EraseRootFromParent_Done,
     /*  494367 */   // Label 8288: @494367
     /*  494367 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(494446), // Rule ID 4732 //
     /*  494372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  494383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  494386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494444 */     GIR_RootConstrainSelectedInstOperands,
     /*  494445 */     // GIR_Coverage, 4732,
     /*  494445 */     GIR_EraseRootFromParent_Done,
     /*  494446 */   // Label 8289: @494446
     /*  494446 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(494525), // Rule ID 4733 //
     /*  494451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  494462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  494465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494503 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494523 */     GIR_RootConstrainSelectedInstOperands,
     /*  494524 */     // GIR_Coverage, 4733,
     /*  494524 */     GIR_EraseRootFromParent_Done,
     /*  494525 */   // Label 8290: @494525
     /*  494525 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(494604), // Rule ID 4742 //
     /*  494530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494602 */     GIR_RootConstrainSelectedInstOperands,
     /*  494603 */     // GIR_Coverage, 4742,
     /*  494603 */     GIR_EraseRootFromParent_Done,
     /*  494604 */   // Label 8291: @494604
     /*  494604 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(494683), // Rule ID 4743 //
     /*  494609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494681 */     GIR_RootConstrainSelectedInstOperands,
     /*  494682 */     // GIR_Coverage, 4743,
     /*  494682 */     GIR_EraseRootFromParent_Done,
     /*  494683 */   // Label 8292: @494683
     /*  494683 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(494762), // Rule ID 4752 //
     /*  494688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494760 */     GIR_RootConstrainSelectedInstOperands,
     /*  494761 */     // GIR_Coverage, 4752,
     /*  494761 */     GIR_EraseRootFromParent_Done,
     /*  494762 */   // Label 8293: @494762
     /*  494762 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(494841), // Rule ID 4753 //
     /*  494767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494839 */     GIR_RootConstrainSelectedInstOperands,
     /*  494840 */     // GIR_Coverage, 4753,
     /*  494840 */     GIR_EraseRootFromParent_Done,
     /*  494841 */   // Label 8294: @494841
     /*  494841 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(494920), // Rule ID 4762 //
     /*  494846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494918 */     GIR_RootConstrainSelectedInstOperands,
     /*  494919 */     // GIR_Coverage, 4762,
     /*  494919 */     GIR_EraseRootFromParent_Done,
     /*  494920 */   // Label 8295: @494920
     /*  494920 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(494999), // Rule ID 4763 //
     /*  494925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494997 */     GIR_RootConstrainSelectedInstOperands,
     /*  494998 */     // GIR_Coverage, 4763,
     /*  494998 */     GIR_EraseRootFromParent_Done,
     /*  494999 */   // Label 8296: @494999
     /*  494999 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(495078), // Rule ID 4772 //
     /*  495004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495076 */     GIR_RootConstrainSelectedInstOperands,
     /*  495077 */     // GIR_Coverage, 4772,
     /*  495077 */     GIR_EraseRootFromParent_Done,
     /*  495078 */   // Label 8297: @495078
     /*  495078 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(495157), // Rule ID 4773 //
     /*  495083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  495094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  495097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  495100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  495103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495155 */     GIR_RootConstrainSelectedInstOperands,
     /*  495156 */     // GIR_Coverage, 4773,
     /*  495156 */     GIR_EraseRootFromParent_Done,
     /*  495157 */   // Label 8298: @495157
     /*  495157 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(495236), // Rule ID 4782 //
     /*  495162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  495173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  495176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  495179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  495182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495234 */     GIR_RootConstrainSelectedInstOperands,
     /*  495235 */     // GIR_Coverage, 4782,
     /*  495235 */     GIR_EraseRootFromParent_Done,
     /*  495236 */   // Label 8299: @495236
     /*  495236 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(495315), // Rule ID 4783 //
     /*  495241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  495252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  495255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  495258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  495261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495313 */     GIR_RootConstrainSelectedInstOperands,
     /*  495314 */     // GIR_Coverage, 4783,
     /*  495314 */     GIR_EraseRootFromParent_Done,
     /*  495315 */   // Label 8300: @495315
     /*  495315 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(495394), // Rule ID 4792 //
     /*  495320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  495331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  495334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  495337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  495340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495392 */     GIR_RootConstrainSelectedInstOperands,
     /*  495393 */     // GIR_Coverage, 4792,
     /*  495393 */     GIR_EraseRootFromParent_Done,
     /*  495394 */   // Label 8301: @495394
     /*  495394 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(495473), // Rule ID 4793 //
     /*  495399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  495410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  495413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  495416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  495419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495451 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495471 */     GIR_RootConstrainSelectedInstOperands,
     /*  495472 */     // GIR_Coverage, 4793,
     /*  495472 */     GIR_EraseRootFromParent_Done,
     /*  495473 */   // Label 8302: @495473
     /*  495473 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(495552), // Rule ID 4802 //
     /*  495478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495550 */     GIR_RootConstrainSelectedInstOperands,
     /*  495551 */     // GIR_Coverage, 4802,
     /*  495551 */     GIR_EraseRootFromParent_Done,
     /*  495552 */   // Label 8303: @495552
     /*  495552 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(495631), // Rule ID 4803 //
     /*  495557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495629 */     GIR_RootConstrainSelectedInstOperands,
     /*  495630 */     // GIR_Coverage, 4803,
     /*  495630 */     GIR_EraseRootFromParent_Done,
     /*  495631 */   // Label 8304: @495631
     /*  495631 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(495710), // Rule ID 4812 //
     /*  495636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495708 */     GIR_RootConstrainSelectedInstOperands,
     /*  495709 */     // GIR_Coverage, 4812,
     /*  495709 */     GIR_EraseRootFromParent_Done,
     /*  495710 */   // Label 8305: @495710
     /*  495710 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(495789), // Rule ID 4813 //
     /*  495715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495787 */     GIR_RootConstrainSelectedInstOperands,
     /*  495788 */     // GIR_Coverage, 4813,
     /*  495788 */     GIR_EraseRootFromParent_Done,
     /*  495789 */   // Label 8306: @495789
     /*  495789 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(495868), // Rule ID 4822 //
     /*  495794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495866 */     GIR_RootConstrainSelectedInstOperands,
     /*  495867 */     // GIR_Coverage, 4822,
     /*  495867 */     GIR_EraseRootFromParent_Done,
     /*  495868 */   // Label 8307: @495868
     /*  495868 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(495947), // Rule ID 4823 //
     /*  495873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495925 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495945 */     GIR_RootConstrainSelectedInstOperands,
     /*  495946 */     // GIR_Coverage, 4823,
     /*  495946 */     GIR_EraseRootFromParent_Done,
     /*  495947 */   // Label 8308: @495947
     /*  495947 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(496026), // Rule ID 4832 //
     /*  495952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  496007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496024 */     GIR_RootConstrainSelectedInstOperands,
     /*  496025 */     // GIR_Coverage, 4832,
     /*  496025 */     GIR_EraseRootFromParent_Done,
     /*  496026 */   // Label 8309: @496026
     /*  496026 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(496105), // Rule ID 4833 //
     /*  496031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  496039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496083 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  496086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496103 */     GIR_RootConstrainSelectedInstOperands,
     /*  496104 */     // GIR_Coverage, 4833,
     /*  496104 */     GIR_EraseRootFromParent_Done,
     /*  496105 */   // Label 8310: @496105
     /*  496105 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(496173), // Rule ID 2716 //
     /*  496110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  496121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  496124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496142 */     // MIs[0] policy
     /*  496142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  496155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496159 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496169 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496171 */     GIR_RootConstrainSelectedInstOperands,
     /*  496172 */     // GIR_Coverage, 2716,
     /*  496172 */     GIR_EraseRootFromParent_Done,
     /*  496173 */   // Label 8311: @496173
     /*  496173 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(496241), // Rule ID 2717 //
     /*  496178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  496189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  496192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496210 */     // MIs[0] policy
     /*  496210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  496223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496227 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496237 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496239 */     GIR_RootConstrainSelectedInstOperands,
     /*  496240 */     // GIR_Coverage, 2717,
     /*  496240 */     GIR_EraseRootFromParent_Done,
     /*  496241 */   // Label 8312: @496241
     /*  496241 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(496309), // Rule ID 23512 //
     /*  496246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  496257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  496260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496278 */     // MIs[0] policy
     /*  496278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496288 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496295 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496305 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496307 */     GIR_RootConstrainSelectedInstOperands,
     /*  496308 */     // GIR_Coverage, 23512,
     /*  496308 */     GIR_EraseRootFromParent_Done,
     /*  496309 */   // Label 8313: @496309
     /*  496309 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(496377), // Rule ID 23513 //
     /*  496314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  496325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  496328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496346 */     // MIs[0] policy
     /*  496346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496356 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496363 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496373 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496375 */     GIR_RootConstrainSelectedInstOperands,
     /*  496376 */     // GIR_Coverage, 23513,
     /*  496376 */     GIR_EraseRootFromParent_Done,
     /*  496377 */   // Label 8314: @496377
     /*  496377 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(496445), // Rule ID 23516 //
     /*  496382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  496393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  496396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496414 */     // MIs[0] policy
     /*  496414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496431 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496441 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496443 */     GIR_RootConstrainSelectedInstOperands,
     /*  496444 */     // GIR_Coverage, 23516,
     /*  496444 */     GIR_EraseRootFromParent_Done,
     /*  496445 */   // Label 8315: @496445
     /*  496445 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(496513), // Rule ID 23517 //
     /*  496450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  496461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  496464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496482 */     // MIs[0] policy
     /*  496482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496499 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496509 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496511 */     GIR_RootConstrainSelectedInstOperands,
     /*  496512 */     // GIR_Coverage, 23517,
     /*  496512 */     GIR_EraseRootFromParent_Done,
     /*  496513 */   // Label 8316: @496513
     /*  496513 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(496581), // Rule ID 23520 //
     /*  496518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496550 */     // MIs[0] policy
     /*  496550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496567 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496577 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496579 */     GIR_RootConstrainSelectedInstOperands,
     /*  496580 */     // GIR_Coverage, 23520,
     /*  496580 */     GIR_EraseRootFromParent_Done,
     /*  496581 */   // Label 8317: @496581
     /*  496581 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(496649), // Rule ID 23521 //
     /*  496586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496618 */     // MIs[0] policy
     /*  496618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496635 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496645 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496647 */     GIR_RootConstrainSelectedInstOperands,
     /*  496648 */     // GIR_Coverage, 23521,
     /*  496648 */     GIR_EraseRootFromParent_Done,
     /*  496649 */   // Label 8318: @496649
     /*  496649 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(496717), // Rule ID 23524 //
     /*  496654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496686 */     // MIs[0] policy
     /*  496686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496703 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496713 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496715 */     GIR_RootConstrainSelectedInstOperands,
     /*  496716 */     // GIR_Coverage, 23524,
     /*  496716 */     GIR_EraseRootFromParent_Done,
     /*  496717 */   // Label 8319: @496717
     /*  496717 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(496785), // Rule ID 23525 //
     /*  496722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496754 */     // MIs[0] policy
     /*  496754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496771 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496781 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496783 */     GIR_RootConstrainSelectedInstOperands,
     /*  496784 */     // GIR_Coverage, 23525,
     /*  496784 */     GIR_EraseRootFromParent_Done,
     /*  496785 */   // Label 8320: @496785
     /*  496785 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(496853), // Rule ID 23528 //
     /*  496790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496822 */     // MIs[0] policy
     /*  496822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496839 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496849 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496851 */     GIR_RootConstrainSelectedInstOperands,
     /*  496852 */     // GIR_Coverage, 23528,
     /*  496852 */     GIR_EraseRootFromParent_Done,
     /*  496853 */   // Label 8321: @496853
     /*  496853 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(496921), // Rule ID 23529 //
     /*  496858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496890 */     // MIs[0] policy
     /*  496890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496907 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496917 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496919 */     GIR_RootConstrainSelectedInstOperands,
     /*  496920 */     // GIR_Coverage, 23529,
     /*  496920 */     GIR_EraseRootFromParent_Done,
     /*  496921 */   // Label 8322: @496921
     /*  496921 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(496989), // Rule ID 23532 //
     /*  496926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496958 */     // MIs[0] policy
     /*  496958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496975 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496985 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496987 */     GIR_RootConstrainSelectedInstOperands,
     /*  496988 */     // GIR_Coverage, 23532,
     /*  496988 */     GIR_EraseRootFromParent_Done,
     /*  496989 */   // Label 8323: @496989
     /*  496989 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(497057), // Rule ID 23533 //
     /*  496994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  497005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  497008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497026 */     // MIs[0] policy
     /*  497026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497043 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497053 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497055 */     GIR_RootConstrainSelectedInstOperands,
     /*  497056 */     // GIR_Coverage, 23533,
     /*  497056 */     GIR_EraseRootFromParent_Done,
     /*  497057 */   // Label 8324: @497057
     /*  497057 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(497125), // Rule ID 23536 //
     /*  497062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497094 */     // MIs[0] policy
     /*  497094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497111 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497121 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497123 */     GIR_RootConstrainSelectedInstOperands,
     /*  497124 */     // GIR_Coverage, 23536,
     /*  497124 */     GIR_EraseRootFromParent_Done,
     /*  497125 */   // Label 8325: @497125
     /*  497125 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(497193), // Rule ID 23537 //
     /*  497130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497162 */     // MIs[0] policy
     /*  497162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497179 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497189 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497191 */     GIR_RootConstrainSelectedInstOperands,
     /*  497192 */     // GIR_Coverage, 23537,
     /*  497192 */     GIR_EraseRootFromParent_Done,
     /*  497193 */   // Label 8326: @497193
     /*  497193 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(497261), // Rule ID 23540 //
     /*  497198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497230 */     // MIs[0] policy
     /*  497230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497247 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497257 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497259 */     GIR_RootConstrainSelectedInstOperands,
     /*  497260 */     // GIR_Coverage, 23540,
     /*  497260 */     GIR_EraseRootFromParent_Done,
     /*  497261 */   // Label 8327: @497261
     /*  497261 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(497329), // Rule ID 23541 //
     /*  497266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  497277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  497280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497298 */     // MIs[0] policy
     /*  497298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497315 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497325 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497327 */     GIR_RootConstrainSelectedInstOperands,
     /*  497328 */     // GIR_Coverage, 23541,
     /*  497328 */     GIR_EraseRootFromParent_Done,
     /*  497329 */   // Label 8328: @497329
     /*  497329 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(497397), // Rule ID 23544 //
     /*  497334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  497337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  497345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  497348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  497351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497366 */     // MIs[0] policy
     /*  497366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497383 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497393 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497395 */     GIR_RootConstrainSelectedInstOperands,
     /*  497396 */     // GIR_Coverage, 23544,
     /*  497396 */     GIR_EraseRootFromParent_Done,
     /*  497397 */   // Label 8329: @497397
     /*  497397 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(497465), // Rule ID 23545 //
     /*  497402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  497405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  497413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  497416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  497419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  497426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497434 */     // MIs[0] policy
     /*  497434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  497447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497451 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497461 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497463 */     GIR_RootConstrainSelectedInstOperands,
     /*  497464 */     // GIR_Coverage, 23545,
     /*  497464 */     GIR_EraseRootFromParent_Done,
     /*  497465 */   // Label 8330: @497465
     /*  497465 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(497533), // Rule ID 23548 //
     /*  497470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497502 */     // MIs[0] policy
     /*  497502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497519 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497529 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497531 */     GIR_RootConstrainSelectedInstOperands,
     /*  497532 */     // GIR_Coverage, 23548,
     /*  497532 */     GIR_EraseRootFromParent_Done,
     /*  497533 */   // Label 8331: @497533
     /*  497533 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(497601), // Rule ID 23549 //
     /*  497538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497570 */     // MIs[0] policy
     /*  497570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497587 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497597 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497599 */     GIR_RootConstrainSelectedInstOperands,
     /*  497600 */     // GIR_Coverage, 23549,
     /*  497600 */     GIR_EraseRootFromParent_Done,
     /*  497601 */   // Label 8332: @497601
     /*  497601 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(497669), // Rule ID 23552 //
     /*  497606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497638 */     // MIs[0] policy
     /*  497638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497648 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497655 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497665 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497667 */     GIR_RootConstrainSelectedInstOperands,
     /*  497668 */     // GIR_Coverage, 23552,
     /*  497668 */     GIR_EraseRootFromParent_Done,
     /*  497669 */   // Label 8333: @497669
     /*  497669 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(497737), // Rule ID 23553 //
     /*  497674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497706 */     // MIs[0] policy
     /*  497706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497723 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497733 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497735 */     GIR_RootConstrainSelectedInstOperands,
     /*  497736 */     // GIR_Coverage, 23553,
     /*  497736 */     GIR_EraseRootFromParent_Done,
     /*  497737 */   // Label 8334: @497737
     /*  497737 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(497805), // Rule ID 23556 //
     /*  497742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497774 */     // MIs[0] policy
     /*  497774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497784 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497791 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497801 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497803 */     GIR_RootConstrainSelectedInstOperands,
     /*  497804 */     // GIR_Coverage, 23556,
     /*  497804 */     GIR_EraseRootFromParent_Done,
     /*  497805 */   // Label 8335: @497805
     /*  497805 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(497873), // Rule ID 23557 //
     /*  497810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497842 */     // MIs[0] policy
     /*  497842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497859 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497869 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497871 */     GIR_RootConstrainSelectedInstOperands,
     /*  497872 */     // GIR_Coverage, 23557,
     /*  497872 */     GIR_EraseRootFromParent_Done,
     /*  497873 */   // Label 8336: @497873
     /*  497873 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(497941), // Rule ID 23560 //
     /*  497878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497910 */     // MIs[0] policy
     /*  497910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497927 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497937 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497939 */     GIR_RootConstrainSelectedInstOperands,
     /*  497940 */     // GIR_Coverage, 23560,
     /*  497940 */     GIR_EraseRootFromParent_Done,
     /*  497941 */   // Label 8337: @497941
     /*  497941 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(498009), // Rule ID 23561 //
     /*  497946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497978 */     // MIs[0] policy
     /*  497978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497995 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498005 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498007 */     GIR_RootConstrainSelectedInstOperands,
     /*  498008 */     // GIR_Coverage, 23561,
     /*  498008 */     GIR_EraseRootFromParent_Done,
     /*  498009 */   // Label 8338: @498009
     /*  498009 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(498077), // Rule ID 23564 //
     /*  498014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  498025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  498028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498046 */     // MIs[0] policy
     /*  498046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498063 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498073 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498075 */     GIR_RootConstrainSelectedInstOperands,
     /*  498076 */     // GIR_Coverage, 23564,
     /*  498076 */     GIR_EraseRootFromParent_Done,
     /*  498077 */   // Label 8339: @498077
     /*  498077 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(498145), // Rule ID 23565 //
     /*  498082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  498093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  498096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498114 */     // MIs[0] policy
     /*  498114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498131 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498141 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498143 */     GIR_RootConstrainSelectedInstOperands,
     /*  498144 */     // GIR_Coverage, 23565,
     /*  498144 */     GIR_EraseRootFromParent_Done,
     /*  498145 */   // Label 8340: @498145
     /*  498145 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(498213), // Rule ID 23568 //
     /*  498150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  498161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  498167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498182 */     // MIs[0] policy
     /*  498182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498192 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498199 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498209 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498211 */     GIR_RootConstrainSelectedInstOperands,
     /*  498212 */     // GIR_Coverage, 23568,
     /*  498212 */     GIR_EraseRootFromParent_Done,
     /*  498213 */   // Label 8341: @498213
     /*  498213 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(498281), // Rule ID 23569 //
     /*  498218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  498229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  498235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498250 */     // MIs[0] policy
     /*  498250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498267 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498277 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498279 */     GIR_RootConstrainSelectedInstOperands,
     /*  498280 */     // GIR_Coverage, 23569,
     /*  498280 */     GIR_EraseRootFromParent_Done,
     /*  498281 */   // Label 8342: @498281
     /*  498281 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(498349), // Rule ID 23572 //
     /*  498286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498318 */     // MIs[0] policy
     /*  498318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498335 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498345 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498347 */     GIR_RootConstrainSelectedInstOperands,
     /*  498348 */     // GIR_Coverage, 23572,
     /*  498348 */     GIR_EraseRootFromParent_Done,
     /*  498349 */   // Label 8343: @498349
     /*  498349 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(498417), // Rule ID 23573 //
     /*  498354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498386 */     // MIs[0] policy
     /*  498386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498403 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498413 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498415 */     GIR_RootConstrainSelectedInstOperands,
     /*  498416 */     // GIR_Coverage, 23573,
     /*  498416 */     GIR_EraseRootFromParent_Done,
     /*  498417 */   // Label 8344: @498417
     /*  498417 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(498485), // Rule ID 23576 //
     /*  498422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498454 */     // MIs[0] policy
     /*  498454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498471 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498481 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498483 */     GIR_RootConstrainSelectedInstOperands,
     /*  498484 */     // GIR_Coverage, 23576,
     /*  498484 */     GIR_EraseRootFromParent_Done,
     /*  498485 */   // Label 8345: @498485
     /*  498485 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(498553), // Rule ID 23577 //
     /*  498490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498522 */     // MIs[0] policy
     /*  498522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498539 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498549 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498551 */     GIR_RootConstrainSelectedInstOperands,
     /*  498552 */     // GIR_Coverage, 23577,
     /*  498552 */     GIR_EraseRootFromParent_Done,
     /*  498553 */   // Label 8346: @498553
     /*  498553 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(498621), // Rule ID 23580 //
     /*  498558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498590 */     // MIs[0] policy
     /*  498590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498607 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498617 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498619 */     GIR_RootConstrainSelectedInstOperands,
     /*  498620 */     // GIR_Coverage, 23580,
     /*  498620 */     GIR_EraseRootFromParent_Done,
     /*  498621 */   // Label 8347: @498621
     /*  498621 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(498689), // Rule ID 23581 //
     /*  498626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498658 */     // MIs[0] policy
     /*  498658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498675 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498685 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498687 */     GIR_RootConstrainSelectedInstOperands,
     /*  498688 */     // GIR_Coverage, 23581,
     /*  498688 */     GIR_EraseRootFromParent_Done,
     /*  498689 */   // Label 8348: @498689
     /*  498689 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(498757), // Rule ID 23584 //
     /*  498694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498726 */     // MIs[0] policy
     /*  498726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498743 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498753 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498755 */     GIR_RootConstrainSelectedInstOperands,
     /*  498756 */     // GIR_Coverage, 23584,
     /*  498756 */     GIR_EraseRootFromParent_Done,
     /*  498757 */   // Label 8349: @498757
     /*  498757 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(498825), // Rule ID 23585 //
     /*  498762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498794 */     // MIs[0] policy
     /*  498794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498811 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498821 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498823 */     GIR_RootConstrainSelectedInstOperands,
     /*  498824 */     // GIR_Coverage, 23585,
     /*  498824 */     GIR_EraseRootFromParent_Done,
     /*  498825 */   // Label 8350: @498825
     /*  498825 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(498893), // Rule ID 23588 //
     /*  498830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498862 */     // MIs[0] policy
     /*  498862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498879 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498889 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498891 */     GIR_RootConstrainSelectedInstOperands,
     /*  498892 */     // GIR_Coverage, 23588,
     /*  498892 */     GIR_EraseRootFromParent_Done,
     /*  498893 */   // Label 8351: @498893
     /*  498893 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(498961), // Rule ID 23589 //
     /*  498898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498930 */     // MIs[0] policy
     /*  498930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498947 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498957 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498959 */     GIR_RootConstrainSelectedInstOperands,
     /*  498960 */     // GIR_Coverage, 23589,
     /*  498960 */     GIR_EraseRootFromParent_Done,
     /*  498961 */   // Label 8352: @498961
     /*  498961 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(499029), // Rule ID 23592 //
     /*  498966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498998 */     // MIs[0] policy
     /*  498998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499008 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  499011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499015 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  499025 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499027 */     GIR_RootConstrainSelectedInstOperands,
     /*  499028 */     // GIR_Coverage, 23592,
     /*  499028 */     GIR_EraseRootFromParent_Done,
     /*  499029 */   // Label 8353: @499029
     /*  499029 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(499097), // Rule ID 23593 //
     /*  499034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  499037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  499051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  499058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499066 */     // MIs[0] policy
     /*  499066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  499079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499083 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  499093 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499095 */     GIR_RootConstrainSelectedInstOperands,
     /*  499096 */     // GIR_Coverage, 23593,
     /*  499096 */     GIR_EraseRootFromParent_Done,
     /*  499097 */   // Label 8354: @499097
     /*  499097 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(499165), // Rule ID 60606 //
     /*  499102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499134 */     // MIs[0] policy
     /*  499134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  499147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499161 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499163 */     GIR_RootConstrainSelectedInstOperands,
     /*  499164 */     // GIR_Coverage, 60606,
     /*  499164 */     GIR_EraseRootFromParent_Done,
     /*  499165 */   // Label 8355: @499165
     /*  499165 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(499233), // Rule ID 60607 //
     /*  499170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499202 */     // MIs[0] policy
     /*  499202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  499215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499229 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499231 */     GIR_RootConstrainSelectedInstOperands,
     /*  499232 */     // GIR_Coverage, 60607,
     /*  499232 */     GIR_EraseRootFromParent_Done,
     /*  499233 */   // Label 8356: @499233
     /*  499233 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(499301), // Rule ID 60608 //
     /*  499238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499270 */     // MIs[0] policy
     /*  499270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  499283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499297 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499299 */     GIR_RootConstrainSelectedInstOperands,
     /*  499300 */     // GIR_Coverage, 60608,
     /*  499300 */     GIR_EraseRootFromParent_Done,
     /*  499301 */   // Label 8357: @499301
     /*  499301 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(499369), // Rule ID 60609 //
     /*  499306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499338 */     // MIs[0] policy
     /*  499338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  499351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499365 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499367 */     GIR_RootConstrainSelectedInstOperands,
     /*  499368 */     // GIR_Coverage, 60609,
     /*  499368 */     GIR_EraseRootFromParent_Done,
     /*  499369 */   // Label 8358: @499369
     /*  499369 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(499437), // Rule ID 62102 //
     /*  499374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499406 */     // MIs[0] policy
     /*  499406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499433 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499435 */     GIR_RootConstrainSelectedInstOperands,
     /*  499436 */     // GIR_Coverage, 62102,
     /*  499436 */     GIR_EraseRootFromParent_Done,
     /*  499437 */   // Label 8359: @499437
     /*  499437 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(499505), // Rule ID 62103 //
     /*  499442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499474 */     // MIs[0] policy
     /*  499474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499501 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499503 */     GIR_RootConstrainSelectedInstOperands,
     /*  499504 */     // GIR_Coverage, 62103,
     /*  499504 */     GIR_EraseRootFromParent_Done,
     /*  499505 */   // Label 8360: @499505
     /*  499505 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(499573), // Rule ID 62104 //
     /*  499510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499542 */     // MIs[0] policy
     /*  499542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499569 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499571 */     GIR_RootConstrainSelectedInstOperands,
     /*  499572 */     // GIR_Coverage, 62104,
     /*  499572 */     GIR_EraseRootFromParent_Done,
     /*  499573 */   // Label 8361: @499573
     /*  499573 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(499641), // Rule ID 62105 //
     /*  499578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499610 */     // MIs[0] policy
     /*  499610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11376:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499637 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499639 */     GIR_RootConstrainSelectedInstOperands,
     /*  499640 */     // GIR_Coverage, 62105,
     /*  499640 */     GIR_EraseRootFromParent_Done,
     /*  499641 */   // Label 8362: @499641
     /*  499641 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(499709), // Rule ID 62106 //
     /*  499646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499678 */     // MIs[0] policy
     /*  499678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499688 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499705 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499707 */     GIR_RootConstrainSelectedInstOperands,
     /*  499708 */     // GIR_Coverage, 62106,
     /*  499708 */     GIR_EraseRootFromParent_Done,
     /*  499709 */   // Label 8363: @499709
     /*  499709 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(499777), // Rule ID 62107 //
     /*  499714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499746 */     // MIs[0] policy
     /*  499746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11376:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499773 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499775 */     GIR_RootConstrainSelectedInstOperands,
     /*  499776 */     // GIR_Coverage, 62107,
     /*  499776 */     GIR_EraseRootFromParent_Done,
     /*  499777 */   // Label 8364: @499777
     /*  499777 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(499845), // Rule ID 62108 //
     /*  499782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499814 */     // MIs[0] policy
     /*  499814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499841 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499843 */     GIR_RootConstrainSelectedInstOperands,
     /*  499844 */     // GIR_Coverage, 62108,
     /*  499844 */     GIR_EraseRootFromParent_Done,
     /*  499845 */   // Label 8365: @499845
     /*  499845 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(499913), // Rule ID 62109 //
     /*  499850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499882 */     // MIs[0] policy
     /*  499882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11376:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499909 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499911 */     GIR_RootConstrainSelectedInstOperands,
     /*  499912 */     // GIR_Coverage, 62109,
     /*  499912 */     GIR_EraseRootFromParent_Done,
     /*  499913 */   // Label 8366: @499913
     /*  499913 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(499981), // Rule ID 62110 //
     /*  499918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499950 */     // MIs[0] policy
     /*  499950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499977 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499979 */     GIR_RootConstrainSelectedInstOperands,
     /*  499980 */     // GIR_Coverage, 62110,
     /*  499980 */     GIR_EraseRootFromParent_Done,
     /*  499981 */   // Label 8367: @499981
     /*  499981 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(500049), // Rule ID 62111 //
     /*  499986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500018 */     // MIs[0] policy
     /*  500018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  500031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500045 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500047 */     GIR_RootConstrainSelectedInstOperands,
     /*  500048 */     // GIR_Coverage, 62111,
     /*  500048 */     GIR_EraseRootFromParent_Done,
     /*  500049 */   // Label 8368: @500049
     /*  500049 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(500117), // Rule ID 62112 //
     /*  500054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500086 */     // MIs[0] policy
     /*  500086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  500099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500113 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500115 */     GIR_RootConstrainSelectedInstOperands,
     /*  500116 */     // GIR_Coverage, 62112,
     /*  500116 */     GIR_EraseRootFromParent_Done,
     /*  500117 */   // Label 8369: @500117
     /*  500117 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(500185), // Rule ID 62113 //
     /*  500122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500154 */     // MIs[0] policy
     /*  500154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  500167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500181 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500183 */     GIR_RootConstrainSelectedInstOperands,
     /*  500184 */     // GIR_Coverage, 62113,
     /*  500184 */     GIR_EraseRootFromParent_Done,
     /*  500185 */   // Label 8370: @500185
     /*  500185 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(500253), // Rule ID 62114 //
     /*  500190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500222 */     // MIs[0] policy
     /*  500222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  500235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500249 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500251 */     GIR_RootConstrainSelectedInstOperands,
     /*  500252 */     // GIR_Coverage, 62114,
     /*  500252 */     GIR_EraseRootFromParent_Done,
     /*  500253 */   // Label 8371: @500253
     /*  500253 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(500321), // Rule ID 62115 //
     /*  500258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500290 */     // MIs[0] policy
     /*  500290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500300 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  500303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500317 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500319 */     GIR_RootConstrainSelectedInstOperands,
     /*  500320 */     // GIR_Coverage, 62115,
     /*  500320 */     GIR_EraseRootFromParent_Done,
     /*  500321 */   // Label 8372: @500321
     /*  500321 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(500389), // Rule ID 62116 //
     /*  500326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500358 */     // MIs[0] policy
     /*  500358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  500371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500385 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500387 */     GIR_RootConstrainSelectedInstOperands,
     /*  500388 */     // GIR_Coverage, 62116,
     /*  500388 */     GIR_EraseRootFromParent_Done,
     /*  500389 */   // Label 8373: @500389
     /*  500389 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(500457), // Rule ID 62117 //
     /*  500394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500426 */     // MIs[0] policy
     /*  500426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  500439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500453 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500455 */     GIR_RootConstrainSelectedInstOperands,
     /*  500456 */     // GIR_Coverage, 62117,
     /*  500456 */     GIR_EraseRootFromParent_Done,
     /*  500457 */   // Label 8374: @500457
     /*  500457 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(500525), // Rule ID 62118 //
     /*  500462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500494 */     // MIs[0] policy
     /*  500494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500504 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500521 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500523 */     GIR_RootConstrainSelectedInstOperands,
     /*  500524 */     // GIR_Coverage, 62118,
     /*  500524 */     GIR_EraseRootFromParent_Done,
     /*  500525 */   // Label 8375: @500525
     /*  500525 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(500593), // Rule ID 62119 //
     /*  500530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500562 */     // MIs[0] policy
     /*  500562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500572 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500589 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500591 */     GIR_RootConstrainSelectedInstOperands,
     /*  500592 */     // GIR_Coverage, 62119,
     /*  500592 */     GIR_EraseRootFromParent_Done,
     /*  500593 */   // Label 8376: @500593
     /*  500593 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(500661), // Rule ID 62120 //
     /*  500598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500630 */     // MIs[0] policy
     /*  500630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500657 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500659 */     GIR_RootConstrainSelectedInstOperands,
     /*  500660 */     // GIR_Coverage, 62120,
     /*  500660 */     GIR_EraseRootFromParent_Done,
     /*  500661 */   // Label 8377: @500661
     /*  500661 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(500729), // Rule ID 62121 //
     /*  500666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500698 */     // MIs[0] policy
     /*  500698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500725 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500727 */     GIR_RootConstrainSelectedInstOperands,
     /*  500728 */     // GIR_Coverage, 62121,
     /*  500728 */     GIR_EraseRootFromParent_Done,
     /*  500729 */   // Label 8378: @500729
     /*  500729 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(500797), // Rule ID 62122 //
     /*  500734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500766 */     // MIs[0] policy
     /*  500766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500793 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500795 */     GIR_RootConstrainSelectedInstOperands,
     /*  500796 */     // GIR_Coverage, 62122,
     /*  500796 */     GIR_EraseRootFromParent_Done,
     /*  500797 */   // Label 8379: @500797
     /*  500797 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(500865), // Rule ID 62123 //
     /*  500802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500834 */     // MIs[0] policy
     /*  500834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500861 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500863 */     GIR_RootConstrainSelectedInstOperands,
     /*  500864 */     // GIR_Coverage, 62123,
     /*  500864 */     GIR_EraseRootFromParent_Done,
     /*  500865 */   // Label 8380: @500865
     /*  500865 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(500933), // Rule ID 62124 //
     /*  500870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500902 */     // MIs[0] policy
     /*  500902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500929 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500931 */     GIR_RootConstrainSelectedInstOperands,
     /*  500932 */     // GIR_Coverage, 62124,
     /*  500932 */     GIR_EraseRootFromParent_Done,
     /*  500933 */   // Label 8381: @500933
     /*  500933 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(501001), // Rule ID 62125 //
     /*  500938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500970 */     // MIs[0] policy
     /*  500970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500997 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500999 */     GIR_RootConstrainSelectedInstOperands,
     /*  501000 */     // GIR_Coverage, 62125,
     /*  501000 */     GIR_EraseRootFromParent_Done,
     /*  501001 */   // Label 8382: @501001
     /*  501001 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(501069), // Rule ID 62126 //
     /*  501006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501038 */     // MIs[0] policy
     /*  501038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  501051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501065 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501067 */     GIR_RootConstrainSelectedInstOperands,
     /*  501068 */     // GIR_Coverage, 62126,
     /*  501068 */     GIR_EraseRootFromParent_Done,
     /*  501069 */   // Label 8383: @501069
     /*  501069 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(501137), // Rule ID 62127 //
     /*  501074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501106 */     // MIs[0] policy
     /*  501106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  501119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501133 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501135 */     GIR_RootConstrainSelectedInstOperands,
     /*  501136 */     // GIR_Coverage, 62127,
     /*  501136 */     GIR_EraseRootFromParent_Done,
     /*  501137 */   // Label 8384: @501137
     /*  501137 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(501205), // Rule ID 62128 //
     /*  501142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501174 */     // MIs[0] policy
     /*  501174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  501187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501201 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501203 */     GIR_RootConstrainSelectedInstOperands,
     /*  501204 */     // GIR_Coverage, 62128,
     /*  501204 */     GIR_EraseRootFromParent_Done,
     /*  501205 */   // Label 8385: @501205
     /*  501205 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(501273), // Rule ID 62129 //
     /*  501210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501242 */     // MIs[0] policy
     /*  501242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  501255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501269 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501271 */     GIR_RootConstrainSelectedInstOperands,
     /*  501272 */     // GIR_Coverage, 62129,
     /*  501272 */     GIR_EraseRootFromParent_Done,
     /*  501273 */   // Label 8386: @501273
     /*  501273 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(501341), // Rule ID 62130 //
     /*  501278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501310 */     // MIs[0] policy
     /*  501310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  501323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501337 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501339 */     GIR_RootConstrainSelectedInstOperands,
     /*  501340 */     // GIR_Coverage, 62130,
     /*  501340 */     GIR_EraseRootFromParent_Done,
     /*  501341 */   // Label 8387: @501341
     /*  501341 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(501409), // Rule ID 62131 //
     /*  501346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501378 */     // MIs[0] policy
     /*  501378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  501391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501405 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501407 */     GIR_RootConstrainSelectedInstOperands,
     /*  501408 */     // GIR_Coverage, 62131,
     /*  501408 */     GIR_EraseRootFromParent_Done,
     /*  501409 */   // Label 8388: @501409
     /*  501409 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(501477), // Rule ID 62132 //
     /*  501414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501446 */     // MIs[0] policy
     /*  501446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501473 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501475 */     GIR_RootConstrainSelectedInstOperands,
     /*  501476 */     // GIR_Coverage, 62132,
     /*  501476 */     GIR_EraseRootFromParent_Done,
     /*  501477 */   // Label 8389: @501477
     /*  501477 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(501545), // Rule ID 62133 //
     /*  501482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501514 */     // MIs[0] policy
     /*  501514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501541 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501543 */     GIR_RootConstrainSelectedInstOperands,
     /*  501544 */     // GIR_Coverage, 62133,
     /*  501544 */     GIR_EraseRootFromParent_Done,
     /*  501545 */   // Label 8390: @501545
     /*  501545 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(501613), // Rule ID 62134 //
     /*  501550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501582 */     // MIs[0] policy
     /*  501582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501609 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501611 */     GIR_RootConstrainSelectedInstOperands,
     /*  501612 */     // GIR_Coverage, 62134,
     /*  501612 */     GIR_EraseRootFromParent_Done,
     /*  501613 */   // Label 8391: @501613
     /*  501613 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(501681), // Rule ID 62135 //
     /*  501618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501650 */     // MIs[0] policy
     /*  501650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501660 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501677 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501679 */     GIR_RootConstrainSelectedInstOperands,
     /*  501680 */     // GIR_Coverage, 62135,
     /*  501680 */     GIR_EraseRootFromParent_Done,
     /*  501681 */   // Label 8392: @501681
     /*  501681 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(501749), // Rule ID 62136 //
     /*  501686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501718 */     // MIs[0] policy
     /*  501718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501745 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501747 */     GIR_RootConstrainSelectedInstOperands,
     /*  501748 */     // GIR_Coverage, 62136,
     /*  501748 */     GIR_EraseRootFromParent_Done,
     /*  501749 */   // Label 8393: @501749
     /*  501749 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(501817), // Rule ID 62137 //
     /*  501754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501786 */     // MIs[0] policy
     /*  501786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501813 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501815 */     GIR_RootConstrainSelectedInstOperands,
     /*  501816 */     // GIR_Coverage, 62137,
     /*  501816 */     GIR_EraseRootFromParent_Done,
     /*  501817 */   // Label 8394: @501817
     /*  501817 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(501885), // Rule ID 62138 //
     /*  501822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501854 */     // MIs[0] policy
     /*  501854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501881 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501883 */     GIR_RootConstrainSelectedInstOperands,
     /*  501884 */     // GIR_Coverage, 62138,
     /*  501884 */     GIR_EraseRootFromParent_Done,
     /*  501885 */   // Label 8395: @501885
     /*  501885 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(501953), // Rule ID 62139 //
     /*  501890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501922 */     // MIs[0] policy
     /*  501922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501949 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501951 */     GIR_RootConstrainSelectedInstOperands,
     /*  501952 */     // GIR_Coverage, 62139,
     /*  501952 */     GIR_EraseRootFromParent_Done,
     /*  501953 */   // Label 8396: @501953
     /*  501953 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(502021), // Rule ID 62140 //
     /*  501958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501990 */     // MIs[0] policy
     /*  501990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  502003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502017 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502019 */     GIR_RootConstrainSelectedInstOperands,
     /*  502020 */     // GIR_Coverage, 62140,
     /*  502020 */     GIR_EraseRootFromParent_Done,
     /*  502021 */   // Label 8397: @502021
     /*  502021 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(502089), // Rule ID 62141 //
     /*  502026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502058 */     // MIs[0] policy
     /*  502058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  502071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502085 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502087 */     GIR_RootConstrainSelectedInstOperands,
     /*  502088 */     // GIR_Coverage, 62141,
     /*  502088 */     GIR_EraseRootFromParent_Done,
     /*  502089 */   // Label 8398: @502089
     /*  502089 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(502157), // Rule ID 62142 //
     /*  502094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502126 */     // MIs[0] policy
     /*  502126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  502139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502153 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502155 */     GIR_RootConstrainSelectedInstOperands,
     /*  502156 */     // GIR_Coverage, 62142,
     /*  502156 */     GIR_EraseRootFromParent_Done,
     /*  502157 */   // Label 8399: @502157
     /*  502157 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(502225), // Rule ID 62143 //
     /*  502162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502194 */     // MIs[0] policy
     /*  502194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  502207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502221 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502223 */     GIR_RootConstrainSelectedInstOperands,
     /*  502224 */     // GIR_Coverage, 62143,
     /*  502224 */     GIR_EraseRootFromParent_Done,
     /*  502225 */   // Label 8400: @502225
     /*  502225 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(502293), // Rule ID 62144 //
     /*  502230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502262 */     // MIs[0] policy
     /*  502262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  502275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502289 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502291 */     GIR_RootConstrainSelectedInstOperands,
     /*  502292 */     // GIR_Coverage, 62144,
     /*  502292 */     GIR_EraseRootFromParent_Done,
     /*  502293 */   // Label 8401: @502293
     /*  502293 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(502361), // Rule ID 62145 //
     /*  502298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502330 */     // MIs[0] policy
     /*  502330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  502343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502357 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502359 */     GIR_RootConstrainSelectedInstOperands,
     /*  502360 */     // GIR_Coverage, 62145,
     /*  502360 */     GIR_EraseRootFromParent_Done,
     /*  502361 */   // Label 8402: @502361
     /*  502361 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(502429), // Rule ID 62146 //
     /*  502366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502398 */     // MIs[0] policy
     /*  502398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502425 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502427 */     GIR_RootConstrainSelectedInstOperands,
     /*  502428 */     // GIR_Coverage, 62146,
     /*  502428 */     GIR_EraseRootFromParent_Done,
     /*  502429 */   // Label 8403: @502429
     /*  502429 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(502497), // Rule ID 62147 //
     /*  502434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502466 */     // MIs[0] policy
     /*  502466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502493 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502495 */     GIR_RootConstrainSelectedInstOperands,
     /*  502496 */     // GIR_Coverage, 62147,
     /*  502496 */     GIR_EraseRootFromParent_Done,
     /*  502497 */   // Label 8404: @502497
     /*  502497 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(502565), // Rule ID 62148 //
     /*  502502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502534 */     // MIs[0] policy
     /*  502534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502561 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502563 */     GIR_RootConstrainSelectedInstOperands,
     /*  502564 */     // GIR_Coverage, 62148,
     /*  502564 */     GIR_EraseRootFromParent_Done,
     /*  502565 */   // Label 8405: @502565
     /*  502565 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(502633), // Rule ID 62149 //
     /*  502570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502602 */     // MIs[0] policy
     /*  502602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502629 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502631 */     GIR_RootConstrainSelectedInstOperands,
     /*  502632 */     // GIR_Coverage, 62149,
     /*  502632 */     GIR_EraseRootFromParent_Done,
     /*  502633 */   // Label 8406: @502633
     /*  502633 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(502701), // Rule ID 62150 //
     /*  502638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502670 */     // MIs[0] policy
     /*  502670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502697 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502699 */     GIR_RootConstrainSelectedInstOperands,
     /*  502700 */     // GIR_Coverage, 62150,
     /*  502700 */     GIR_EraseRootFromParent_Done,
     /*  502701 */   // Label 8407: @502701
     /*  502701 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(502769), // Rule ID 62151 //
     /*  502706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502738 */     // MIs[0] policy
     /*  502738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502765 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502767 */     GIR_RootConstrainSelectedInstOperands,
     /*  502768 */     // GIR_Coverage, 62151,
     /*  502768 */     GIR_EraseRootFromParent_Done,
     /*  502769 */   // Label 8408: @502769
     /*  502769 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(502837), // Rule ID 62152 //
     /*  502774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502806 */     // MIs[0] policy
     /*  502806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502833 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502835 */     GIR_RootConstrainSelectedInstOperands,
     /*  502836 */     // GIR_Coverage, 62152,
     /*  502836 */     GIR_EraseRootFromParent_Done,
     /*  502837 */   // Label 8409: @502837
     /*  502837 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(502905), // Rule ID 62153 //
     /*  502842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502874 */     // MIs[0] policy
     /*  502874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502901 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502903 */     GIR_RootConstrainSelectedInstOperands,
     /*  502904 */     // GIR_Coverage, 62153,
     /*  502904 */     GIR_EraseRootFromParent_Done,
     /*  502905 */   // Label 8410: @502905
     /*  502905 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(502973), // Rule ID 62154 //
     /*  502910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502942 */     // MIs[0] policy
     /*  502942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502969 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502971 */     GIR_RootConstrainSelectedInstOperands,
     /*  502972 */     // GIR_Coverage, 62154,
     /*  502972 */     GIR_EraseRootFromParent_Done,
     /*  502973 */   // Label 8411: @502973
     /*  502973 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(503041), // Rule ID 62155 //
     /*  502978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503010 */     // MIs[0] policy
     /*  503010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  503023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503037 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503039 */     GIR_RootConstrainSelectedInstOperands,
     /*  503040 */     // GIR_Coverage, 62155,
     /*  503040 */     GIR_EraseRootFromParent_Done,
     /*  503041 */   // Label 8412: @503041
     /*  503041 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(503109), // Rule ID 62156 //
     /*  503046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503078 */     // MIs[0] policy
     /*  503078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  503091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503105 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503107 */     GIR_RootConstrainSelectedInstOperands,
     /*  503108 */     // GIR_Coverage, 62156,
     /*  503108 */     GIR_EraseRootFromParent_Done,
     /*  503109 */   // Label 8413: @503109
     /*  503109 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(503177), // Rule ID 62157 //
     /*  503114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503146 */     // MIs[0] policy
     /*  503146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  503159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503173 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503175 */     GIR_RootConstrainSelectedInstOperands,
     /*  503176 */     // GIR_Coverage, 62157,
     /*  503176 */     GIR_EraseRootFromParent_Done,
     /*  503177 */   // Label 8414: @503177
     /*  503177 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(503245), // Rule ID 62158 //
     /*  503182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503214 */     // MIs[0] policy
     /*  503214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  503227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503241 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503243 */     GIR_RootConstrainSelectedInstOperands,
     /*  503244 */     // GIR_Coverage, 62158,
     /*  503244 */     GIR_EraseRootFromParent_Done,
     /*  503245 */   // Label 8415: @503245
     /*  503245 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(503313), // Rule ID 62159 //
     /*  503250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503282 */     // MIs[0] policy
     /*  503282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  503295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503309 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503311 */     GIR_RootConstrainSelectedInstOperands,
     /*  503312 */     // GIR_Coverage, 62159,
     /*  503312 */     GIR_EraseRootFromParent_Done,
     /*  503313 */   // Label 8416: @503313
     /*  503313 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(503381), // Rule ID 62160 //
     /*  503318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503350 */     // MIs[0] policy
     /*  503350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  503363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503377 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503379 */     GIR_RootConstrainSelectedInstOperands,
     /*  503380 */     // GIR_Coverage, 62160,
     /*  503380 */     GIR_EraseRootFromParent_Done,
     /*  503381 */   // Label 8417: @503381
     /*  503381 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(503449), // Rule ID 62161 //
     /*  503386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503418 */     // MIs[0] policy
     /*  503418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  503431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503445 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503447 */     GIR_RootConstrainSelectedInstOperands,
     /*  503448 */     // GIR_Coverage, 62161,
     /*  503448 */     GIR_EraseRootFromParent_Done,
     /*  503449 */   // Label 8418: @503449
     /*  503449 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(503517), // Rule ID 62162 //
     /*  503454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503486 */     // MIs[0] policy
     /*  503486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503513 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503515 */     GIR_RootConstrainSelectedInstOperands,
     /*  503516 */     // GIR_Coverage, 62162,
     /*  503516 */     GIR_EraseRootFromParent_Done,
     /*  503517 */   // Label 8419: @503517
     /*  503517 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(503585), // Rule ID 62163 //
     /*  503522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503554 */     // MIs[0] policy
     /*  503554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503581 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503583 */     GIR_RootConstrainSelectedInstOperands,
     /*  503584 */     // GIR_Coverage, 62163,
     /*  503584 */     GIR_EraseRootFromParent_Done,
     /*  503585 */   // Label 8420: @503585
     /*  503585 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(503653), // Rule ID 62164 //
     /*  503590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503622 */     // MIs[0] policy
     /*  503622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503649 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503651 */     GIR_RootConstrainSelectedInstOperands,
     /*  503652 */     // GIR_Coverage, 62164,
     /*  503652 */     GIR_EraseRootFromParent_Done,
     /*  503653 */   // Label 8421: @503653
     /*  503653 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(503721), // Rule ID 62165 //
     /*  503658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503690 */     // MIs[0] policy
     /*  503690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503717 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503719 */     GIR_RootConstrainSelectedInstOperands,
     /*  503720 */     // GIR_Coverage, 62165,
     /*  503720 */     GIR_EraseRootFromParent_Done,
     /*  503721 */   // Label 8422: @503721
     /*  503721 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(503789), // Rule ID 62166 //
     /*  503726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503758 */     // MIs[0] policy
     /*  503758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503785 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503787 */     GIR_RootConstrainSelectedInstOperands,
     /*  503788 */     // GIR_Coverage, 62166,
     /*  503788 */     GIR_EraseRootFromParent_Done,
     /*  503789 */   // Label 8423: @503789
     /*  503789 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(503857), // Rule ID 62167 //
     /*  503794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503826 */     // MIs[0] policy
     /*  503826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503853 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503855 */     GIR_RootConstrainSelectedInstOperands,
     /*  503856 */     // GIR_Coverage, 62167,
     /*  503856 */     GIR_EraseRootFromParent_Done,
     /*  503857 */   // Label 8424: @503857
     /*  503857 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(503925), // Rule ID 62168 //
     /*  503862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503894 */     // MIs[0] policy
     /*  503894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503921 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503923 */     GIR_RootConstrainSelectedInstOperands,
     /*  503924 */     // GIR_Coverage, 62168,
     /*  503924 */     GIR_EraseRootFromParent_Done,
     /*  503925 */   // Label 8425: @503925
     /*  503925 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(503993), // Rule ID 62169 //
     /*  503930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503962 */     // MIs[0] policy
     /*  503962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503989 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503991 */     GIR_RootConstrainSelectedInstOperands,
     /*  503992 */     // GIR_Coverage, 62169,
     /*  503992 */     GIR_EraseRootFromParent_Done,
     /*  503993 */   // Label 8426: @503993
     /*  503993 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(504061), // Rule ID 62170 //
     /*  503998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504030 */     // MIs[0] policy
     /*  504030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  504043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504057 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504059 */     GIR_RootConstrainSelectedInstOperands,
     /*  504060 */     // GIR_Coverage, 62170,
     /*  504060 */     GIR_EraseRootFromParent_Done,
     /*  504061 */   // Label 8427: @504061
     /*  504061 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(504129), // Rule ID 62171 //
     /*  504066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504098 */     // MIs[0] policy
     /*  504098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  504111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504125 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504127 */     GIR_RootConstrainSelectedInstOperands,
     /*  504128 */     // GIR_Coverage, 62171,
     /*  504128 */     GIR_EraseRootFromParent_Done,
     /*  504129 */   // Label 8428: @504129
     /*  504129 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(504197), // Rule ID 62172 //
     /*  504134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504166 */     // MIs[0] policy
     /*  504166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  504179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504193 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504195 */     GIR_RootConstrainSelectedInstOperands,
     /*  504196 */     // GIR_Coverage, 62172,
     /*  504196 */     GIR_EraseRootFromParent_Done,
     /*  504197 */   // Label 8429: @504197
     /*  504197 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(504265), // Rule ID 62173 //
     /*  504202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504234 */     // MIs[0] policy
     /*  504234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  504247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504261 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504263 */     GIR_RootConstrainSelectedInstOperands,
     /*  504264 */     // GIR_Coverage, 62173,
     /*  504264 */     GIR_EraseRootFromParent_Done,
     /*  504265 */   // Label 8430: @504265
     /*  504265 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(504333), // Rule ID 62174 //
     /*  504270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504302 */     // MIs[0] policy
     /*  504302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  504315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504329 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504331 */     GIR_RootConstrainSelectedInstOperands,
     /*  504332 */     // GIR_Coverage, 62174,
     /*  504332 */     GIR_EraseRootFromParent_Done,
     /*  504333 */   // Label 8431: @504333
     /*  504333 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(504401), // Rule ID 62175 //
     /*  504338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504370 */     // MIs[0] policy
     /*  504370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  504383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504397 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504399 */     GIR_RootConstrainSelectedInstOperands,
     /*  504400 */     // GIR_Coverage, 62175,
     /*  504400 */     GIR_EraseRootFromParent_Done,
     /*  504401 */   // Label 8432: @504401
     /*  504401 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(504469), // Rule ID 62176 //
     /*  504406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504438 */     // MIs[0] policy
     /*  504438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504448 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504465 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504467 */     GIR_RootConstrainSelectedInstOperands,
     /*  504468 */     // GIR_Coverage, 62176,
     /*  504468 */     GIR_EraseRootFromParent_Done,
     /*  504469 */   // Label 8433: @504469
     /*  504469 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(504537), // Rule ID 62177 //
     /*  504474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504506 */     // MIs[0] policy
     /*  504506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504533 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504535 */     GIR_RootConstrainSelectedInstOperands,
     /*  504536 */     // GIR_Coverage, 62177,
     /*  504536 */     GIR_EraseRootFromParent_Done,
     /*  504537 */   // Label 8434: @504537
     /*  504537 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(504605), // Rule ID 62178 //
     /*  504542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504574 */     // MIs[0] policy
     /*  504574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504584 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504601 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504603 */     GIR_RootConstrainSelectedInstOperands,
     /*  504604 */     // GIR_Coverage, 62178,
     /*  504604 */     GIR_EraseRootFromParent_Done,
     /*  504605 */   // Label 8435: @504605
     /*  504605 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(504673), // Rule ID 62179 //
     /*  504610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504642 */     // MIs[0] policy
     /*  504642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504669 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504671 */     GIR_RootConstrainSelectedInstOperands,
     /*  504672 */     // GIR_Coverage, 62179,
     /*  504672 */     GIR_EraseRootFromParent_Done,
     /*  504673 */   // Label 8436: @504673
     /*  504673 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(504741), // Rule ID 62180 //
     /*  504678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504710 */     // MIs[0] policy
     /*  504710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504737 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504739 */     GIR_RootConstrainSelectedInstOperands,
     /*  504740 */     // GIR_Coverage, 62180,
     /*  504740 */     GIR_EraseRootFromParent_Done,
     /*  504741 */   // Label 8437: @504741
     /*  504741 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(504809), // Rule ID 62181 //
     /*  504746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504778 */     // MIs[0] policy
     /*  504778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504805 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504807 */     GIR_RootConstrainSelectedInstOperands,
     /*  504808 */     // GIR_Coverage, 62181,
     /*  504808 */     GIR_EraseRootFromParent_Done,
     /*  504809 */   // Label 8438: @504809
     /*  504809 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(504877), // Rule ID 62182 //
     /*  504814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504846 */     // MIs[0] policy
     /*  504846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504873 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504875 */     GIR_RootConstrainSelectedInstOperands,
     /*  504876 */     // GIR_Coverage, 62182,
     /*  504876 */     GIR_EraseRootFromParent_Done,
     /*  504877 */   // Label 8439: @504877
     /*  504877 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(504945), // Rule ID 62183 //
     /*  504882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504914 */     // MIs[0] policy
     /*  504914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504941 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504943 */     GIR_RootConstrainSelectedInstOperands,
     /*  504944 */     // GIR_Coverage, 62183,
     /*  504944 */     GIR_EraseRootFromParent_Done,
     /*  504945 */   // Label 8440: @504945
     /*  504945 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(505013), // Rule ID 62184 //
     /*  504950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504982 */     // MIs[0] policy
     /*  504982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505009 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505011 */     GIR_RootConstrainSelectedInstOperands,
     /*  505012 */     // GIR_Coverage, 62184,
     /*  505012 */     GIR_EraseRootFromParent_Done,
     /*  505013 */   // Label 8441: @505013
     /*  505013 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(505081), // Rule ID 62185 //
     /*  505018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505050 */     // MIs[0] policy
     /*  505050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  505063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505077 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505079 */     GIR_RootConstrainSelectedInstOperands,
     /*  505080 */     // GIR_Coverage, 62185,
     /*  505080 */     GIR_EraseRootFromParent_Done,
     /*  505081 */   // Label 8442: @505081
     /*  505081 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(505149), // Rule ID 62186 //
     /*  505086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505118 */     // MIs[0] policy
     /*  505118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  505131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505145 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505147 */     GIR_RootConstrainSelectedInstOperands,
     /*  505148 */     // GIR_Coverage, 62186,
     /*  505148 */     GIR_EraseRootFromParent_Done,
     /*  505149 */   // Label 8443: @505149
     /*  505149 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(505217), // Rule ID 62187 //
     /*  505154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505186 */     // MIs[0] policy
     /*  505186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  505199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505213 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505215 */     GIR_RootConstrainSelectedInstOperands,
     /*  505216 */     // GIR_Coverage, 62187,
     /*  505216 */     GIR_EraseRootFromParent_Done,
     /*  505217 */   // Label 8444: @505217
     /*  505217 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(505285), // Rule ID 62188 //
     /*  505222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505254 */     // MIs[0] policy
     /*  505254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  505267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505281 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505283 */     GIR_RootConstrainSelectedInstOperands,
     /*  505284 */     // GIR_Coverage, 62188,
     /*  505284 */     GIR_EraseRootFromParent_Done,
     /*  505285 */   // Label 8445: @505285
     /*  505285 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(505353), // Rule ID 62189 //
     /*  505290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505322 */     // MIs[0] policy
     /*  505322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  505335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505349 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505351 */     GIR_RootConstrainSelectedInstOperands,
     /*  505352 */     // GIR_Coverage, 62189,
     /*  505352 */     GIR_EraseRootFromParent_Done,
     /*  505353 */   // Label 8446: @505353
     /*  505353 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(505421), // Rule ID 62190 //
     /*  505358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505390 */     // MIs[0] policy
     /*  505390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505400 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505417 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505419 */     GIR_RootConstrainSelectedInstOperands,
     /*  505420 */     // GIR_Coverage, 62190,
     /*  505420 */     GIR_EraseRootFromParent_Done,
     /*  505421 */   // Label 8447: @505421
     /*  505421 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(505489), // Rule ID 62191 //
     /*  505426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505458 */     // MIs[0] policy
     /*  505458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505485 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505487 */     GIR_RootConstrainSelectedInstOperands,
     /*  505488 */     // GIR_Coverage, 62191,
     /*  505488 */     GIR_EraseRootFromParent_Done,
     /*  505489 */   // Label 8448: @505489
     /*  505489 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(505557), // Rule ID 62192 //
     /*  505494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505526 */     // MIs[0] policy
     /*  505526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505553 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505555 */     GIR_RootConstrainSelectedInstOperands,
     /*  505556 */     // GIR_Coverage, 62192,
     /*  505556 */     GIR_EraseRootFromParent_Done,
     /*  505557 */   // Label 8449: @505557
     /*  505557 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(505625), // Rule ID 62193 //
     /*  505562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505594 */     // MIs[0] policy
     /*  505594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505621 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505623 */     GIR_RootConstrainSelectedInstOperands,
     /*  505624 */     // GIR_Coverage, 62193,
     /*  505624 */     GIR_EraseRootFromParent_Done,
     /*  505625 */   // Label 8450: @505625
     /*  505625 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(505693), // Rule ID 62194 //
     /*  505630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505662 */     // MIs[0] policy
     /*  505662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505689 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505691 */     GIR_RootConstrainSelectedInstOperands,
     /*  505692 */     // GIR_Coverage, 62194,
     /*  505692 */     GIR_EraseRootFromParent_Done,
     /*  505693 */   // Label 8451: @505693
     /*  505693 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(505761), // Rule ID 62195 //
     /*  505698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505730 */     // MIs[0] policy
     /*  505730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505757 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505759 */     GIR_RootConstrainSelectedInstOperands,
     /*  505760 */     // GIR_Coverage, 62195,
     /*  505760 */     GIR_EraseRootFromParent_Done,
     /*  505761 */   // Label 8452: @505761
     /*  505761 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(505829), // Rule ID 62196 //
     /*  505766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505798 */     // MIs[0] policy
     /*  505798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505825 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505827 */     GIR_RootConstrainSelectedInstOperands,
     /*  505828 */     // GIR_Coverage, 62196,
     /*  505828 */     GIR_EraseRootFromParent_Done,
     /*  505829 */   // Label 8453: @505829
     /*  505829 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(505897), // Rule ID 62197 //
     /*  505834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505866 */     // MIs[0] policy
     /*  505866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505893 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505895 */     GIR_RootConstrainSelectedInstOperands,
     /*  505896 */     // GIR_Coverage, 62197,
     /*  505896 */     GIR_EraseRootFromParent_Done,
     /*  505897 */   // Label 8454: @505897
     /*  505897 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(505965), // Rule ID 62198 //
     /*  505902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505934 */     // MIs[0] policy
     /*  505934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505961 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505963 */     GIR_RootConstrainSelectedInstOperands,
     /*  505964 */     // GIR_Coverage, 62198,
     /*  505964 */     GIR_EraseRootFromParent_Done,
     /*  505965 */   // Label 8455: @505965
     /*  505965 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(506033), // Rule ID 62199 //
     /*  505970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506002 */     // MIs[0] policy
     /*  506002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  506015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506029 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506031 */     GIR_RootConstrainSelectedInstOperands,
     /*  506032 */     // GIR_Coverage, 62199,
     /*  506032 */     GIR_EraseRootFromParent_Done,
     /*  506033 */   // Label 8456: @506033
     /*  506033 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(506101), // Rule ID 62200 //
     /*  506038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506070 */     // MIs[0] policy
     /*  506070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  506083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506097 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506099 */     GIR_RootConstrainSelectedInstOperands,
     /*  506100 */     // GIR_Coverage, 62200,
     /*  506100 */     GIR_EraseRootFromParent_Done,
     /*  506101 */   // Label 8457: @506101
     /*  506101 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(506169), // Rule ID 62201 //
     /*  506106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506138 */     // MIs[0] policy
     /*  506138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  506151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506165 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506167 */     GIR_RootConstrainSelectedInstOperands,
     /*  506168 */     // GIR_Coverage, 62201,
     /*  506168 */     GIR_EraseRootFromParent_Done,
     /*  506169 */   // Label 8458: @506169
     /*  506169 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(506237), // Rule ID 62202 //
     /*  506174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506206 */     // MIs[0] policy
     /*  506206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  506219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506233 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506235 */     GIR_RootConstrainSelectedInstOperands,
     /*  506236 */     // GIR_Coverage, 62202,
     /*  506236 */     GIR_EraseRootFromParent_Done,
     /*  506237 */   // Label 8459: @506237
     /*  506237 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(506305), // Rule ID 62203 //
     /*  506242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506274 */     // MIs[0] policy
     /*  506274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  506287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506301 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506303 */     GIR_RootConstrainSelectedInstOperands,
     /*  506304 */     // GIR_Coverage, 62203,
     /*  506304 */     GIR_EraseRootFromParent_Done,
     /*  506305 */   // Label 8460: @506305
     /*  506305 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(506373), // Rule ID 62204 //
     /*  506310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506342 */     // MIs[0] policy
     /*  506342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  506355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506369 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506371 */     GIR_RootConstrainSelectedInstOperands,
     /*  506372 */     // GIR_Coverage, 62204,
     /*  506372 */     GIR_EraseRootFromParent_Done,
     /*  506373 */   // Label 8461: @506373
     /*  506373 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(506441), // Rule ID 62205 //
     /*  506378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506410 */     // MIs[0] policy
     /*  506410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  506423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506437 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506439 */     GIR_RootConstrainSelectedInstOperands,
     /*  506440 */     // GIR_Coverage, 62205,
     /*  506440 */     GIR_EraseRootFromParent_Done,
     /*  506441 */   // Label 8462: @506441
     /*  506441 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(506509), // Rule ID 62206 //
     /*  506446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506478 */     // MIs[0] policy
     /*  506478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506505 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506507 */     GIR_RootConstrainSelectedInstOperands,
     /*  506508 */     // GIR_Coverage, 62206,
     /*  506508 */     GIR_EraseRootFromParent_Done,
     /*  506509 */   // Label 8463: @506509
     /*  506509 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(506577), // Rule ID 62207 //
     /*  506514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506546 */     // MIs[0] policy
     /*  506546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506573 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506575 */     GIR_RootConstrainSelectedInstOperands,
     /*  506576 */     // GIR_Coverage, 62207,
     /*  506576 */     GIR_EraseRootFromParent_Done,
     /*  506577 */   // Label 8464: @506577
     /*  506577 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(506645), // Rule ID 62208 //
     /*  506582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506614 */     // MIs[0] policy
     /*  506614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506641 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506643 */     GIR_RootConstrainSelectedInstOperands,
     /*  506644 */     // GIR_Coverage, 62208,
     /*  506644 */     GIR_EraseRootFromParent_Done,
     /*  506645 */   // Label 8465: @506645
     /*  506645 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(506713), // Rule ID 62209 //
     /*  506650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506682 */     // MIs[0] policy
     /*  506682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506709 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506711 */     GIR_RootConstrainSelectedInstOperands,
     /*  506712 */     // GIR_Coverage, 62209,
     /*  506712 */     GIR_EraseRootFromParent_Done,
     /*  506713 */   // Label 8466: @506713
     /*  506713 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(506781), // Rule ID 62210 //
     /*  506718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506750 */     // MIs[0] policy
     /*  506750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506777 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506779 */     GIR_RootConstrainSelectedInstOperands,
     /*  506780 */     // GIR_Coverage, 62210,
     /*  506780 */     GIR_EraseRootFromParent_Done,
     /*  506781 */   // Label 8467: @506781
     /*  506781 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(506849), // Rule ID 62211 //
     /*  506786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506818 */     // MIs[0] policy
     /*  506818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506845 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506847 */     GIR_RootConstrainSelectedInstOperands,
     /*  506848 */     // GIR_Coverage, 62211,
     /*  506848 */     GIR_EraseRootFromParent_Done,
     /*  506849 */   // Label 8468: @506849
     /*  506849 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(506917), // Rule ID 62212 //
     /*  506854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506886 */     // MIs[0] policy
     /*  506886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506913 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506915 */     GIR_RootConstrainSelectedInstOperands,
     /*  506916 */     // GIR_Coverage, 62212,
     /*  506916 */     GIR_EraseRootFromParent_Done,
     /*  506917 */   // Label 8469: @506917
     /*  506917 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(506985), // Rule ID 62213 //
     /*  506922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506954 */     // MIs[0] policy
     /*  506954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506981 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506983 */     GIR_RootConstrainSelectedInstOperands,
     /*  506984 */     // GIR_Coverage, 62213,
     /*  506984 */     GIR_EraseRootFromParent_Done,
     /*  506985 */   // Label 8470: @506985
     /*  506985 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(507053), // Rule ID 62214 //
     /*  506990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507022 */     // MIs[0] policy
     /*  507022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  507035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507049 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507051 */     GIR_RootConstrainSelectedInstOperands,
     /*  507052 */     // GIR_Coverage, 62214,
     /*  507052 */     GIR_EraseRootFromParent_Done,
     /*  507053 */   // Label 8471: @507053
     /*  507053 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(507121), // Rule ID 62215 //
     /*  507058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507090 */     // MIs[0] policy
     /*  507090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  507103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507117 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507119 */     GIR_RootConstrainSelectedInstOperands,
     /*  507120 */     // GIR_Coverage, 62215,
     /*  507120 */     GIR_EraseRootFromParent_Done,
     /*  507121 */   // Label 8472: @507121
     /*  507121 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(507189), // Rule ID 62216 //
     /*  507126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507158 */     // MIs[0] policy
     /*  507158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  507171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507185 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507187 */     GIR_RootConstrainSelectedInstOperands,
     /*  507188 */     // GIR_Coverage, 62216,
     /*  507188 */     GIR_EraseRootFromParent_Done,
     /*  507189 */   // Label 8473: @507189
     /*  507189 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(507257), // Rule ID 62217 //
     /*  507194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507226 */     // MIs[0] policy
     /*  507226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507236 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  507239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507253 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507255 */     GIR_RootConstrainSelectedInstOperands,
     /*  507256 */     // GIR_Coverage, 62217,
     /*  507256 */     GIR_EraseRootFromParent_Done,
     /*  507257 */   // Label 8474: @507257
     /*  507257 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(507325), // Rule ID 62218 //
     /*  507262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507294 */     // MIs[0] policy
     /*  507294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  507307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507321 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507323 */     GIR_RootConstrainSelectedInstOperands,
     /*  507324 */     // GIR_Coverage, 62218,
     /*  507324 */     GIR_EraseRootFromParent_Done,
     /*  507325 */   // Label 8475: @507325
     /*  507325 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(507393), // Rule ID 62219 //
     /*  507330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507362 */     // MIs[0] policy
     /*  507362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  507375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507389 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507391 */     GIR_RootConstrainSelectedInstOperands,
     /*  507392 */     // GIR_Coverage, 62219,
     /*  507392 */     GIR_EraseRootFromParent_Done,
     /*  507393 */   // Label 8476: @507393
     /*  507393 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(507461), // Rule ID 62220 //
     /*  507398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507430 */     // MIs[0] policy
     /*  507430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507457 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507459 */     GIR_RootConstrainSelectedInstOperands,
     /*  507460 */     // GIR_Coverage, 62220,
     /*  507460 */     GIR_EraseRootFromParent_Done,
     /*  507461 */   // Label 8477: @507461
     /*  507461 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(507529), // Rule ID 62221 //
     /*  507466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507498 */     // MIs[0] policy
     /*  507498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507525 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507527 */     GIR_RootConstrainSelectedInstOperands,
     /*  507528 */     // GIR_Coverage, 62221,
     /*  507528 */     GIR_EraseRootFromParent_Done,
     /*  507529 */   // Label 8478: @507529
     /*  507529 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(507597), // Rule ID 62222 //
     /*  507534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507566 */     // MIs[0] policy
     /*  507566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507593 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507595 */     GIR_RootConstrainSelectedInstOperands,
     /*  507596 */     // GIR_Coverage, 62222,
     /*  507596 */     GIR_EraseRootFromParent_Done,
     /*  507597 */   // Label 8479: @507597
     /*  507597 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(507665), // Rule ID 62223 //
     /*  507602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507634 */     // MIs[0] policy
     /*  507634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507661 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507663 */     GIR_RootConstrainSelectedInstOperands,
     /*  507664 */     // GIR_Coverage, 62223,
     /*  507664 */     GIR_EraseRootFromParent_Done,
     /*  507665 */   // Label 8480: @507665
     /*  507665 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(507733), // Rule ID 62224 //
     /*  507670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507702 */     // MIs[0] policy
     /*  507702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507729 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507731 */     GIR_RootConstrainSelectedInstOperands,
     /*  507732 */     // GIR_Coverage, 62224,
     /*  507732 */     GIR_EraseRootFromParent_Done,
     /*  507733 */   // Label 8481: @507733
     /*  507733 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(507801), // Rule ID 62225 //
     /*  507738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507770 */     // MIs[0] policy
     /*  507770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507797 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507799 */     GIR_RootConstrainSelectedInstOperands,
     /*  507800 */     // GIR_Coverage, 62225,
     /*  507800 */     GIR_EraseRootFromParent_Done,
     /*  507801 */   // Label 8482: @507801
     /*  507801 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(507869), // Rule ID 62226 //
     /*  507806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507838 */     // MIs[0] policy
     /*  507838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507865 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507867 */     GIR_RootConstrainSelectedInstOperands,
     /*  507868 */     // GIR_Coverage, 62226,
     /*  507868 */     GIR_EraseRootFromParent_Done,
     /*  507869 */   // Label 8483: @507869
     /*  507869 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(507937), // Rule ID 62227 //
     /*  507874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507906 */     // MIs[0] policy
     /*  507906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507933 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507935 */     GIR_RootConstrainSelectedInstOperands,
     /*  507936 */     // GIR_Coverage, 62227,
     /*  507936 */     GIR_EraseRootFromParent_Done,
     /*  507937 */   // Label 8484: @507937
     /*  507937 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(508005), // Rule ID 62228 //
     /*  507942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507974 */     // MIs[0] policy
     /*  507974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508001 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508003 */     GIR_RootConstrainSelectedInstOperands,
     /*  508004 */     // GIR_Coverage, 62228,
     /*  508004 */     GIR_EraseRootFromParent_Done,
     /*  508005 */   // Label 8485: @508005
     /*  508005 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(508073), // Rule ID 62229 //
     /*  508010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508042 */     // MIs[0] policy
     /*  508042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  508055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508069 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508071 */     GIR_RootConstrainSelectedInstOperands,
     /*  508072 */     // GIR_Coverage, 62229,
     /*  508072 */     GIR_EraseRootFromParent_Done,
     /*  508073 */   // Label 8486: @508073
     /*  508073 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(508141), // Rule ID 62230 //
     /*  508078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508110 */     // MIs[0] policy
     /*  508110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  508123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508137 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508139 */     GIR_RootConstrainSelectedInstOperands,
     /*  508140 */     // GIR_Coverage, 62230,
     /*  508140 */     GIR_EraseRootFromParent_Done,
     /*  508141 */   // Label 8487: @508141
     /*  508141 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(508209), // Rule ID 62231 //
     /*  508146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  508154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508178 */     // MIs[0] policy
     /*  508178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  508191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508205 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508207 */     GIR_RootConstrainSelectedInstOperands,
     /*  508208 */     // GIR_Coverage, 62231,
     /*  508208 */     GIR_EraseRootFromParent_Done,
     /*  508209 */   // Label 8488: @508209
     /*  508209 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(508277), // Rule ID 62232 //
     /*  508214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508246 */     // MIs[0] policy
     /*  508246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  508259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508273 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508275 */     GIR_RootConstrainSelectedInstOperands,
     /*  508276 */     // GIR_Coverage, 62232,
     /*  508276 */     GIR_EraseRootFromParent_Done,
     /*  508277 */   // Label 8489: @508277
     /*  508277 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(508345), // Rule ID 62233 //
     /*  508282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508314 */     // MIs[0] policy
     /*  508314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  508327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508341 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508343 */     GIR_RootConstrainSelectedInstOperands,
     /*  508344 */     // GIR_Coverage, 62233,
     /*  508344 */     GIR_EraseRootFromParent_Done,
     /*  508345 */   // Label 8490: @508345
     /*  508345 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(508413), // Rule ID 62234 //
     /*  508350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508382 */     // MIs[0] policy
     /*  508382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  508395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508409 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508411 */     GIR_RootConstrainSelectedInstOperands,
     /*  508412 */     // GIR_Coverage, 62234,
     /*  508412 */     GIR_EraseRootFromParent_Done,
     /*  508413 */   // Label 8491: @508413
     /*  508413 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(508481), // Rule ID 62235 //
     /*  508418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508450 */     // MIs[0] policy
     /*  508450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  508463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508477 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508479 */     GIR_RootConstrainSelectedInstOperands,
     /*  508480 */     // GIR_Coverage, 62235,
     /*  508480 */     GIR_EraseRootFromParent_Done,
     /*  508481 */   // Label 8492: @508481
     /*  508481 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(508549), // Rule ID 62236 //
     /*  508486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508518 */     // MIs[0] policy
     /*  508518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508545 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508547 */     GIR_RootConstrainSelectedInstOperands,
     /*  508548 */     // GIR_Coverage, 62236,
     /*  508548 */     GIR_EraseRootFromParent_Done,
     /*  508549 */   // Label 8493: @508549
     /*  508549 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(508617), // Rule ID 62237 //
     /*  508554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508586 */     // MIs[0] policy
     /*  508586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508613 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508615 */     GIR_RootConstrainSelectedInstOperands,
     /*  508616 */     // GIR_Coverage, 62237,
     /*  508616 */     GIR_EraseRootFromParent_Done,
     /*  508617 */   // Label 8494: @508617
     /*  508617 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(508685), // Rule ID 62238 //
     /*  508622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508654 */     // MIs[0] policy
     /*  508654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508681 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508683 */     GIR_RootConstrainSelectedInstOperands,
     /*  508684 */     // GIR_Coverage, 62238,
     /*  508684 */     GIR_EraseRootFromParent_Done,
     /*  508685 */   // Label 8495: @508685
     /*  508685 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(508753), // Rule ID 62239 //
     /*  508690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508722 */     // MIs[0] policy
     /*  508722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508749 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508751 */     GIR_RootConstrainSelectedInstOperands,
     /*  508752 */     // GIR_Coverage, 62239,
     /*  508752 */     GIR_EraseRootFromParent_Done,
     /*  508753 */   // Label 8496: @508753
     /*  508753 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(508821), // Rule ID 62240 //
     /*  508758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508790 */     // MIs[0] policy
     /*  508790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508817 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508819 */     GIR_RootConstrainSelectedInstOperands,
     /*  508820 */     // GIR_Coverage, 62240,
     /*  508820 */     GIR_EraseRootFromParent_Done,
     /*  508821 */   // Label 8497: @508821
     /*  508821 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(508889), // Rule ID 62241 //
     /*  508826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508858 */     // MIs[0] policy
     /*  508858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508885 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508887 */     GIR_RootConstrainSelectedInstOperands,
     /*  508888 */     // GIR_Coverage, 62241,
     /*  508888 */     GIR_EraseRootFromParent_Done,
     /*  508889 */   // Label 8498: @508889
     /*  508889 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(508957), // Rule ID 62242 //
     /*  508894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508926 */     // MIs[0] policy
     /*  508926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508953 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508955 */     GIR_RootConstrainSelectedInstOperands,
     /*  508956 */     // GIR_Coverage, 62242,
     /*  508956 */     GIR_EraseRootFromParent_Done,
     /*  508957 */   // Label 8499: @508957
     /*  508957 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(509025), // Rule ID 62243 //
     /*  508962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508994 */     // MIs[0] policy
     /*  508994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  509007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509021 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509023 */     GIR_RootConstrainSelectedInstOperands,
     /*  509024 */     // GIR_Coverage, 62243,
     /*  509024 */     GIR_EraseRootFromParent_Done,
     /*  509025 */   // Label 8500: @509025
     /*  509025 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(509093), // Rule ID 62244 //
     /*  509030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509062 */     // MIs[0] policy
     /*  509062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  509075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509089 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509091 */     GIR_RootConstrainSelectedInstOperands,
     /*  509092 */     // GIR_Coverage, 62244,
     /*  509092 */     GIR_EraseRootFromParent_Done,
     /*  509093 */   // Label 8501: @509093
     /*  509093 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(509161), // Rule ID 62245 //
     /*  509098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509130 */     // MIs[0] policy
     /*  509130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  509143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509157 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509159 */     GIR_RootConstrainSelectedInstOperands,
     /*  509160 */     // GIR_Coverage, 62245,
     /*  509160 */     GIR_EraseRootFromParent_Done,
     /*  509161 */   // Label 8502: @509161
     /*  509161 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(509229), // Rule ID 62246 //
     /*  509166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509198 */     // MIs[0] policy
     /*  509198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  509211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509225 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509227 */     GIR_RootConstrainSelectedInstOperands,
     /*  509228 */     // GIR_Coverage, 62246,
     /*  509228 */     GIR_EraseRootFromParent_Done,
     /*  509229 */   // Label 8503: @509229
     /*  509229 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(509297), // Rule ID 62247 //
     /*  509234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509266 */     // MIs[0] policy
     /*  509266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  509279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509293 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509295 */     GIR_RootConstrainSelectedInstOperands,
     /*  509296 */     // GIR_Coverage, 62247,
     /*  509296 */     GIR_EraseRootFromParent_Done,
     /*  509297 */   // Label 8504: @509297
     /*  509297 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(509365), // Rule ID 62248 //
     /*  509302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509334 */     // MIs[0] policy
     /*  509334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  509347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509361 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509363 */     GIR_RootConstrainSelectedInstOperands,
     /*  509364 */     // GIR_Coverage, 62248,
     /*  509364 */     GIR_EraseRootFromParent_Done,
     /*  509365 */   // Label 8505: @509365
     /*  509365 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(509433), // Rule ID 62249 //
     /*  509370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509402 */     // MIs[0] policy
     /*  509402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  509415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509429 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509431 */     GIR_RootConstrainSelectedInstOperands,
     /*  509432 */     // GIR_Coverage, 62249,
     /*  509432 */     GIR_EraseRootFromParent_Done,
     /*  509433 */   // Label 8506: @509433
     /*  509433 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(509501), // Rule ID 62250 //
     /*  509438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509470 */     // MIs[0] policy
     /*  509470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509497 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509499 */     GIR_RootConstrainSelectedInstOperands,
     /*  509500 */     // GIR_Coverage, 62250,
     /*  509500 */     GIR_EraseRootFromParent_Done,
     /*  509501 */   // Label 8507: @509501
     /*  509501 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(509569), // Rule ID 62251 //
     /*  509506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509538 */     // MIs[0] policy
     /*  509538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509565 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509567 */     GIR_RootConstrainSelectedInstOperands,
     /*  509568 */     // GIR_Coverage, 62251,
     /*  509568 */     GIR_EraseRootFromParent_Done,
     /*  509569 */   // Label 8508: @509569
     /*  509569 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(509637), // Rule ID 62252 //
     /*  509574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509606 */     // MIs[0] policy
     /*  509606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509633 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509635 */     GIR_RootConstrainSelectedInstOperands,
     /*  509636 */     // GIR_Coverage, 62252,
     /*  509636 */     GIR_EraseRootFromParent_Done,
     /*  509637 */   // Label 8509: @509637
     /*  509637 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(509705), // Rule ID 62253 //
     /*  509642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509674 */     // MIs[0] policy
     /*  509674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509701 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509703 */     GIR_RootConstrainSelectedInstOperands,
     /*  509704 */     // GIR_Coverage, 62253,
     /*  509704 */     GIR_EraseRootFromParent_Done,
     /*  509705 */   // Label 8510: @509705
     /*  509705 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(509773), // Rule ID 62254 //
     /*  509710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509742 */     // MIs[0] policy
     /*  509742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509769 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509771 */     GIR_RootConstrainSelectedInstOperands,
     /*  509772 */     // GIR_Coverage, 62254,
     /*  509772 */     GIR_EraseRootFromParent_Done,
     /*  509773 */   // Label 8511: @509773
     /*  509773 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(509841), // Rule ID 62255 //
     /*  509778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509810 */     // MIs[0] policy
     /*  509810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509837 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509839 */     GIR_RootConstrainSelectedInstOperands,
     /*  509840 */     // GIR_Coverage, 62255,
     /*  509840 */     GIR_EraseRootFromParent_Done,
     /*  509841 */   // Label 8512: @509841
     /*  509841 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(509909), // Rule ID 62256 //
     /*  509846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509878 */     // MIs[0] policy
     /*  509878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509905 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509907 */     GIR_RootConstrainSelectedInstOperands,
     /*  509908 */     // GIR_Coverage, 62256,
     /*  509908 */     GIR_EraseRootFromParent_Done,
     /*  509909 */   // Label 8513: @509909
     /*  509909 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(509977), // Rule ID 62257 //
     /*  509914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509946 */     // MIs[0] policy
     /*  509946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509973 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509975 */     GIR_RootConstrainSelectedInstOperands,
     /*  509976 */     // GIR_Coverage, 62257,
     /*  509976 */     GIR_EraseRootFromParent_Done,
     /*  509977 */   // Label 8514: @509977
     /*  509977 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(510045), // Rule ID 62258 //
     /*  509982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510014 */     // MIs[0] policy
     /*  510014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  510027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510041 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510043 */     GIR_RootConstrainSelectedInstOperands,
     /*  510044 */     // GIR_Coverage, 62258,
     /*  510044 */     GIR_EraseRootFromParent_Done,
     /*  510045 */   // Label 8515: @510045
     /*  510045 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(510113), // Rule ID 62259 //
     /*  510050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  510058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510082 */     // MIs[0] policy
     /*  510082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  510095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510109 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510111 */     GIR_RootConstrainSelectedInstOperands,
     /*  510112 */     // GIR_Coverage, 62259,
     /*  510112 */     GIR_EraseRootFromParent_Done,
     /*  510113 */   // Label 8516: @510113
     /*  510113 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(510181), // Rule ID 62276 //
     /*  510118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510150 */     // MIs[0] policy
     /*  510150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510160 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  510163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510177 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510179 */     GIR_RootConstrainSelectedInstOperands,
     /*  510180 */     // GIR_Coverage, 62276,
     /*  510180 */     GIR_EraseRootFromParent_Done,
     /*  510181 */   // Label 8517: @510181
     /*  510181 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(510249), // Rule ID 62277 //
     /*  510186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510218 */     // MIs[0] policy
     /*  510218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  510231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510245 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510247 */     GIR_RootConstrainSelectedInstOperands,
     /*  510248 */     // GIR_Coverage, 62277,
     /*  510248 */     GIR_EraseRootFromParent_Done,
     /*  510249 */   // Label 8518: @510249
     /*  510249 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(510317), // Rule ID 62278 //
     /*  510254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510286 */     // MIs[0] policy
     /*  510286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  510299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510313 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510315 */     GIR_RootConstrainSelectedInstOperands,
     /*  510316 */     // GIR_Coverage, 62278,
     /*  510316 */     GIR_EraseRootFromParent_Done,
     /*  510317 */   // Label 8519: @510317
     /*  510317 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(510385), // Rule ID 62279 //
     /*  510322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510354 */     // MIs[0] policy
     /*  510354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  510367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510381 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510383 */     GIR_RootConstrainSelectedInstOperands,
     /*  510384 */     // GIR_Coverage, 62279,
     /*  510384 */     GIR_EraseRootFromParent_Done,
     /*  510385 */   // Label 8520: @510385
     /*  510385 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(510453), // Rule ID 62280 //
     /*  510390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510422 */     // MIs[0] policy
     /*  510422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510449 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510451 */     GIR_RootConstrainSelectedInstOperands,
     /*  510452 */     // GIR_Coverage, 62280,
     /*  510452 */     GIR_EraseRootFromParent_Done,
     /*  510453 */   // Label 8521: @510453
     /*  510453 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(510521), // Rule ID 62281 //
     /*  510458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510490 */     // MIs[0] policy
     /*  510490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510517 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510519 */     GIR_RootConstrainSelectedInstOperands,
     /*  510520 */     // GIR_Coverage, 62281,
     /*  510520 */     GIR_EraseRootFromParent_Done,
     /*  510521 */   // Label 8522: @510521
     /*  510521 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(510589), // Rule ID 62282 //
     /*  510526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510558 */     // MIs[0] policy
     /*  510558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510585 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510587 */     GIR_RootConstrainSelectedInstOperands,
     /*  510588 */     // GIR_Coverage, 62282,
     /*  510588 */     GIR_EraseRootFromParent_Done,
     /*  510589 */   // Label 8523: @510589
     /*  510589 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(510657), // Rule ID 62283 //
     /*  510594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510626 */     // MIs[0] policy
     /*  510626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510653 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510655 */     GIR_RootConstrainSelectedInstOperands,
     /*  510656 */     // GIR_Coverage, 62283,
     /*  510656 */     GIR_EraseRootFromParent_Done,
     /*  510657 */   // Label 8524: @510657
     /*  510657 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(510725), // Rule ID 62284 //
     /*  510662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510694 */     // MIs[0] policy
     /*  510694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510721 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510723 */     GIR_RootConstrainSelectedInstOperands,
     /*  510724 */     // GIR_Coverage, 62284,
     /*  510724 */     GIR_EraseRootFromParent_Done,
     /*  510725 */   // Label 8525: @510725
     /*  510725 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(510793), // Rule ID 62285 //
     /*  510730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510762 */     // MIs[0] policy
     /*  510762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510789 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510791 */     GIR_RootConstrainSelectedInstOperands,
     /*  510792 */     // GIR_Coverage, 62285,
     /*  510792 */     GIR_EraseRootFromParent_Done,
     /*  510793 */   // Label 8526: @510793
     /*  510793 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(510861), // Rule ID 62286 //
     /*  510798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510830 */     // MIs[0] policy
     /*  510830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510857 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510859 */     GIR_RootConstrainSelectedInstOperands,
     /*  510860 */     // GIR_Coverage, 62286,
     /*  510860 */     GIR_EraseRootFromParent_Done,
     /*  510861 */   // Label 8527: @510861
     /*  510861 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(510929), // Rule ID 62287 //
     /*  510866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510898 */     // MIs[0] policy
     /*  510898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510925 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510927 */     GIR_RootConstrainSelectedInstOperands,
     /*  510928 */     // GIR_Coverage, 62287,
     /*  510928 */     GIR_EraseRootFromParent_Done,
     /*  510929 */   // Label 8528: @510929
     /*  510929 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(510997), // Rule ID 62288 //
     /*  510934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510966 */     // MIs[0] policy
     /*  510966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510993 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510995 */     GIR_RootConstrainSelectedInstOperands,
     /*  510996 */     // GIR_Coverage, 62288,
     /*  510996 */     GIR_EraseRootFromParent_Done,
     /*  510997 */   // Label 8529: @510997
     /*  510997 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(511065), // Rule ID 62289 //
     /*  511002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511034 */     // MIs[0] policy
     /*  511034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  511047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511061 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511063 */     GIR_RootConstrainSelectedInstOperands,
     /*  511064 */     // GIR_Coverage, 62289,
     /*  511064 */     GIR_EraseRootFromParent_Done,
     /*  511065 */   // Label 8530: @511065
     /*  511065 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(511133), // Rule ID 62290 //
     /*  511070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511102 */     // MIs[0] policy
     /*  511102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  511115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511129 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511131 */     GIR_RootConstrainSelectedInstOperands,
     /*  511132 */     // GIR_Coverage, 62290,
     /*  511132 */     GIR_EraseRootFromParent_Done,
     /*  511133 */   // Label 8531: @511133
     /*  511133 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(511201), // Rule ID 62291 //
     /*  511138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511170 */     // MIs[0] policy
     /*  511170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511180 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  511183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511197 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511199 */     GIR_RootConstrainSelectedInstOperands,
     /*  511200 */     // GIR_Coverage, 62291,
     /*  511200 */     GIR_EraseRootFromParent_Done,
     /*  511201 */   // Label 8532: @511201
     /*  511201 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(511269), // Rule ID 62292 //
     /*  511206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511238 */     // MIs[0] policy
     /*  511238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  511251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511265 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511267 */     GIR_RootConstrainSelectedInstOperands,
     /*  511268 */     // GIR_Coverage, 62292,
     /*  511268 */     GIR_EraseRootFromParent_Done,
     /*  511269 */   // Label 8533: @511269
     /*  511269 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(511337), // Rule ID 62293 //
     /*  511274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511306 */     // MIs[0] policy
     /*  511306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  511319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511333 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511335 */     GIR_RootConstrainSelectedInstOperands,
     /*  511336 */     // GIR_Coverage, 62293,
     /*  511336 */     GIR_EraseRootFromParent_Done,
     /*  511337 */   // Label 8534: @511337
     /*  511337 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(511405), // Rule ID 62294 //
     /*  511342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511374 */     // MIs[0] policy
     /*  511374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  511387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511401 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511403 */     GIR_RootConstrainSelectedInstOperands,
     /*  511404 */     // GIR_Coverage, 62294,
     /*  511404 */     GIR_EraseRootFromParent_Done,
     /*  511405 */   // Label 8535: @511405
     /*  511405 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(511473), // Rule ID 62295 //
     /*  511410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511442 */     // MIs[0] policy
     /*  511442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  511455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511469 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511471 */     GIR_RootConstrainSelectedInstOperands,
     /*  511472 */     // GIR_Coverage, 62295,
     /*  511472 */     GIR_EraseRootFromParent_Done,
     /*  511473 */   // Label 8536: @511473
     /*  511473 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(511541), // Rule ID 62296 //
     /*  511478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511510 */     // MIs[0] policy
     /*  511510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511537 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511539 */     GIR_RootConstrainSelectedInstOperands,
     /*  511540 */     // GIR_Coverage, 62296,
     /*  511540 */     GIR_EraseRootFromParent_Done,
     /*  511541 */   // Label 8537: @511541
     /*  511541 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(511609), // Rule ID 62297 //
     /*  511546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511578 */     // MIs[0] policy
     /*  511578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511605 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511607 */     GIR_RootConstrainSelectedInstOperands,
     /*  511608 */     // GIR_Coverage, 62297,
     /*  511608 */     GIR_EraseRootFromParent_Done,
     /*  511609 */   // Label 8538: @511609
     /*  511609 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(511677), // Rule ID 62298 //
     /*  511614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511646 */     // MIs[0] policy
     /*  511646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511673 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511675 */     GIR_RootConstrainSelectedInstOperands,
     /*  511676 */     // GIR_Coverage, 62298,
     /*  511676 */     GIR_EraseRootFromParent_Done,
     /*  511677 */   // Label 8539: @511677
     /*  511677 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(511745), // Rule ID 62299 //
     /*  511682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511714 */     // MIs[0] policy
     /*  511714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511741 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511743 */     GIR_RootConstrainSelectedInstOperands,
     /*  511744 */     // GIR_Coverage, 62299,
     /*  511744 */     GIR_EraseRootFromParent_Done,
     /*  511745 */   // Label 8540: @511745
     /*  511745 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(511813), // Rule ID 62300 //
     /*  511750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511782 */     // MIs[0] policy
     /*  511782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511809 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511811 */     GIR_RootConstrainSelectedInstOperands,
     /*  511812 */     // GIR_Coverage, 62300,
     /*  511812 */     GIR_EraseRootFromParent_Done,
     /*  511813 */   // Label 8541: @511813
     /*  511813 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(511881), // Rule ID 62301 //
     /*  511818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511850 */     // MIs[0] policy
     /*  511850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511877 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511879 */     GIR_RootConstrainSelectedInstOperands,
     /*  511880 */     // GIR_Coverage, 62301,
     /*  511880 */     GIR_EraseRootFromParent_Done,
     /*  511881 */   // Label 8542: @511881
     /*  511881 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(511949), // Rule ID 62302 //
     /*  511886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511918 */     // MIs[0] policy
     /*  511918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511928 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511945 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511947 */     GIR_RootConstrainSelectedInstOperands,
     /*  511948 */     // GIR_Coverage, 62302,
     /*  511948 */     GIR_EraseRootFromParent_Done,
     /*  511949 */   // Label 8543: @511949
     /*  511949 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(512017), // Rule ID 62303 //
     /*  511954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511986 */     // MIs[0] policy
     /*  511986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512013 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512015 */     GIR_RootConstrainSelectedInstOperands,
     /*  512016 */     // GIR_Coverage, 62303,
     /*  512016 */     GIR_EraseRootFromParent_Done,
     /*  512017 */   // Label 8544: @512017
     /*  512017 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(512085), // Rule ID 62398 //
     /*  512022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512054 */     // MIs[0] policy
     /*  512054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  512067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512081 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512083 */     GIR_RootConstrainSelectedInstOperands,
     /*  512084 */     // GIR_Coverage, 62398,
     /*  512084 */     GIR_EraseRootFromParent_Done,
     /*  512085 */   // Label 8545: @512085
     /*  512085 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(512153), // Rule ID 62399 //
     /*  512090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512122 */     // MIs[0] policy
     /*  512122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  512135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512149 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512151 */     GIR_RootConstrainSelectedInstOperands,
     /*  512152 */     // GIR_Coverage, 62399,
     /*  512152 */     GIR_EraseRootFromParent_Done,
     /*  512153 */   // Label 8546: @512153
     /*  512153 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(512221), // Rule ID 62400 //
     /*  512158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512190 */     // MIs[0] policy
     /*  512190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  512203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512217 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512219 */     GIR_RootConstrainSelectedInstOperands,
     /*  512220 */     // GIR_Coverage, 62400,
     /*  512220 */     GIR_EraseRootFromParent_Done,
     /*  512221 */   // Label 8547: @512221
     /*  512221 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(512289), // Rule ID 62401 //
     /*  512226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512258 */     // MIs[0] policy
     /*  512258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  512271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512285 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512287 */     GIR_RootConstrainSelectedInstOperands,
     /*  512288 */     // GIR_Coverage, 62401,
     /*  512288 */     GIR_EraseRootFromParent_Done,
     /*  512289 */   // Label 8548: @512289
     /*  512289 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(512357), // Rule ID 62402 //
     /*  512294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512326 */     // MIs[0] policy
     /*  512326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  512339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512353 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512355 */     GIR_RootConstrainSelectedInstOperands,
     /*  512356 */     // GIR_Coverage, 62402,
     /*  512356 */     GIR_EraseRootFromParent_Done,
     /*  512357 */   // Label 8549: @512357
     /*  512357 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(512425), // Rule ID 62403 //
     /*  512362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512394 */     // MIs[0] policy
     /*  512394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  512407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512421 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512423 */     GIR_RootConstrainSelectedInstOperands,
     /*  512424 */     // GIR_Coverage, 62403,
     /*  512424 */     GIR_EraseRootFromParent_Done,
     /*  512425 */   // Label 8550: @512425
     /*  512425 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(512493), // Rule ID 62404 //
     /*  512430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512462 */     // MIs[0] policy
     /*  512462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512489 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512491 */     GIR_RootConstrainSelectedInstOperands,
     /*  512492 */     // GIR_Coverage, 62404,
     /*  512492 */     GIR_EraseRootFromParent_Done,
     /*  512493 */   // Label 8551: @512493
     /*  512493 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(512561), // Rule ID 62405 //
     /*  512498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512530 */     // MIs[0] policy
     /*  512530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512557 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512559 */     GIR_RootConstrainSelectedInstOperands,
     /*  512560 */     // GIR_Coverage, 62405,
     /*  512560 */     GIR_EraseRootFromParent_Done,
     /*  512561 */   // Label 8552: @512561
     /*  512561 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(512629), // Rule ID 62406 //
     /*  512566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512598 */     // MIs[0] policy
     /*  512598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512625 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512627 */     GIR_RootConstrainSelectedInstOperands,
     /*  512628 */     // GIR_Coverage, 62406,
     /*  512628 */     GIR_EraseRootFromParent_Done,
     /*  512629 */   // Label 8553: @512629
     /*  512629 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(512697), // Rule ID 62407 //
     /*  512634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512666 */     // MIs[0] policy
     /*  512666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512693 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512695 */     GIR_RootConstrainSelectedInstOperands,
     /*  512696 */     // GIR_Coverage, 62407,
     /*  512696 */     GIR_EraseRootFromParent_Done,
     /*  512697 */   // Label 8554: @512697
     /*  512697 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(512765), // Rule ID 62408 //
     /*  512702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512734 */     // MIs[0] policy
     /*  512734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512761 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512763 */     GIR_RootConstrainSelectedInstOperands,
     /*  512764 */     // GIR_Coverage, 62408,
     /*  512764 */     GIR_EraseRootFromParent_Done,
     /*  512765 */   // Label 8555: @512765
     /*  512765 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(512833), // Rule ID 62409 //
     /*  512770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512802 */     // MIs[0] policy
     /*  512802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512812 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512829 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512831 */     GIR_RootConstrainSelectedInstOperands,
     /*  512832 */     // GIR_Coverage, 62409,
     /*  512832 */     GIR_EraseRootFromParent_Done,
     /*  512833 */   // Label 8556: @512833
     /*  512833 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(512901), // Rule ID 62410 //
     /*  512838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512870 */     // MIs[0] policy
     /*  512870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512897 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512899 */     GIR_RootConstrainSelectedInstOperands,
     /*  512900 */     // GIR_Coverage, 62410,
     /*  512900 */     GIR_EraseRootFromParent_Done,
     /*  512901 */   // Label 8557: @512901
     /*  512901 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(512969), // Rule ID 62411 //
     /*  512906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512938 */     // MIs[0] policy
     /*  512938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512965 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512967 */     GIR_RootConstrainSelectedInstOperands,
     /*  512968 */     // GIR_Coverage, 62411,
     /*  512968 */     GIR_EraseRootFromParent_Done,
     /*  512969 */   // Label 8558: @512969
     /*  512969 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(513037), // Rule ID 62412 //
     /*  512974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513006 */     // MIs[0] policy
     /*  513006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  513019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513033 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513035 */     GIR_RootConstrainSelectedInstOperands,
     /*  513036 */     // GIR_Coverage, 62412,
     /*  513036 */     GIR_EraseRootFromParent_Done,
     /*  513037 */   // Label 8559: @513037
     /*  513037 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(513105), // Rule ID 62413 //
     /*  513042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513074 */     // MIs[0] policy
     /*  513074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  513087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513101 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513103 */     GIR_RootConstrainSelectedInstOperands,
     /*  513104 */     // GIR_Coverage, 62413,
     /*  513104 */     GIR_EraseRootFromParent_Done,
     /*  513105 */   // Label 8560: @513105
     /*  513105 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(513173), // Rule ID 62414 //
     /*  513110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513142 */     // MIs[0] policy
     /*  513142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  513155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513169 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513171 */     GIR_RootConstrainSelectedInstOperands,
     /*  513172 */     // GIR_Coverage, 62414,
     /*  513172 */     GIR_EraseRootFromParent_Done,
     /*  513173 */   // Label 8561: @513173
     /*  513173 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(513241), // Rule ID 62415 //
     /*  513178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513210 */     // MIs[0] policy
     /*  513210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  513223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513237 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513239 */     GIR_RootConstrainSelectedInstOperands,
     /*  513240 */     // GIR_Coverage, 62415,
     /*  513240 */     GIR_EraseRootFromParent_Done,
     /*  513241 */   // Label 8562: @513241
     /*  513241 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(513309), // Rule ID 62416 //
     /*  513246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513278 */     // MIs[0] policy
     /*  513278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  513291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513305 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513307 */     GIR_RootConstrainSelectedInstOperands,
     /*  513308 */     // GIR_Coverage, 62416,
     /*  513308 */     GIR_EraseRootFromParent_Done,
     /*  513309 */   // Label 8563: @513309
     /*  513309 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(513377), // Rule ID 62417 //
     /*  513314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513346 */     // MIs[0] policy
     /*  513346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  513359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513373 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513375 */     GIR_RootConstrainSelectedInstOperands,
     /*  513376 */     // GIR_Coverage, 62417,
     /*  513376 */     GIR_EraseRootFromParent_Done,
     /*  513377 */   // Label 8564: @513377
     /*  513377 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(513445), // Rule ID 62418 //
     /*  513382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513414 */     // MIs[0] policy
     /*  513414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513441 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513443 */     GIR_RootConstrainSelectedInstOperands,
     /*  513444 */     // GIR_Coverage, 62418,
     /*  513444 */     GIR_EraseRootFromParent_Done,
     /*  513445 */   // Label 8565: @513445
     /*  513445 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(513513), // Rule ID 62419 //
     /*  513450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513482 */     // MIs[0] policy
     /*  513482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513509 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513511 */     GIR_RootConstrainSelectedInstOperands,
     /*  513512 */     // GIR_Coverage, 62419,
     /*  513512 */     GIR_EraseRootFromParent_Done,
     /*  513513 */   // Label 8566: @513513
     /*  513513 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(513581), // Rule ID 62420 //
     /*  513518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513550 */     // MIs[0] policy
     /*  513550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513560 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513577 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513579 */     GIR_RootConstrainSelectedInstOperands,
     /*  513580 */     // GIR_Coverage, 62420,
     /*  513580 */     GIR_EraseRootFromParent_Done,
     /*  513581 */   // Label 8567: @513581
     /*  513581 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(513649), // Rule ID 62421 //
     /*  513586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513618 */     // MIs[0] policy
     /*  513618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513645 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513647 */     GIR_RootConstrainSelectedInstOperands,
     /*  513648 */     // GIR_Coverage, 62421,
     /*  513648 */     GIR_EraseRootFromParent_Done,
     /*  513649 */   // Label 8568: @513649
     /*  513649 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(513717), // Rule ID 62422 //
     /*  513654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513686 */     // MIs[0] policy
     /*  513686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513713 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513715 */     GIR_RootConstrainSelectedInstOperands,
     /*  513716 */     // GIR_Coverage, 62422,
     /*  513716 */     GIR_EraseRootFromParent_Done,
     /*  513717 */   // Label 8569: @513717
     /*  513717 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(513785), // Rule ID 62423 //
     /*  513722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513754 */     // MIs[0] policy
     /*  513754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513781 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513783 */     GIR_RootConstrainSelectedInstOperands,
     /*  513784 */     // GIR_Coverage, 62423,
     /*  513784 */     GIR_EraseRootFromParent_Done,
     /*  513785 */   // Label 8570: @513785
     /*  513785 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(513853), // Rule ID 62424 //
     /*  513790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513822 */     // MIs[0] policy
     /*  513822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513849 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513851 */     GIR_RootConstrainSelectedInstOperands,
     /*  513852 */     // GIR_Coverage, 62424,
     /*  513852 */     GIR_EraseRootFromParent_Done,
     /*  513853 */   // Label 8571: @513853
     /*  513853 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(513921), // Rule ID 62425 //
     /*  513858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513890 */     // MIs[0] policy
     /*  513890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513917 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513919 */     GIR_RootConstrainSelectedInstOperands,
     /*  513920 */     // GIR_Coverage, 62425,
     /*  513920 */     GIR_EraseRootFromParent_Done,
     /*  513921 */   // Label 8572: @513921
     /*  513921 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(513989), // Rule ID 62426 //
     /*  513926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513958 */     // MIs[0] policy
     /*  513958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513985 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513987 */     GIR_RootConstrainSelectedInstOperands,
     /*  513988 */     // GIR_Coverage, 62426,
     /*  513988 */     GIR_EraseRootFromParent_Done,
     /*  513989 */   // Label 8573: @513989
     /*  513989 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(514057), // Rule ID 62427 //
     /*  513994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514026 */     // MIs[0] policy
     /*  514026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  514039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514053 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514055 */     GIR_RootConstrainSelectedInstOperands,
     /*  514056 */     // GIR_Coverage, 62427,
     /*  514056 */     GIR_EraseRootFromParent_Done,
     /*  514057 */   // Label 8574: @514057
     /*  514057 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(514125), // Rule ID 62428 //
     /*  514062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514094 */     // MIs[0] policy
     /*  514094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  514107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514121 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514123 */     GIR_RootConstrainSelectedInstOperands,
     /*  514124 */     // GIR_Coverage, 62428,
     /*  514124 */     GIR_EraseRootFromParent_Done,
     /*  514125 */   // Label 8575: @514125
     /*  514125 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(514193), // Rule ID 62429 //
     /*  514130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514162 */     // MIs[0] policy
     /*  514162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  514175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514189 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514191 */     GIR_RootConstrainSelectedInstOperands,
     /*  514192 */     // GIR_Coverage, 62429,
     /*  514192 */     GIR_EraseRootFromParent_Done,
     /*  514193 */   // Label 8576: @514193
     /*  514193 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(514261), // Rule ID 62430 //
     /*  514198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514230 */     // MIs[0] policy
     /*  514230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  514243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514257 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514259 */     GIR_RootConstrainSelectedInstOperands,
     /*  514260 */     // GIR_Coverage, 62430,
     /*  514260 */     GIR_EraseRootFromParent_Done,
     /*  514261 */   // Label 8577: @514261
     /*  514261 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(514329), // Rule ID 62431 //
     /*  514266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514298 */     // MIs[0] policy
     /*  514298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514308 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  514311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514325 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514327 */     GIR_RootConstrainSelectedInstOperands,
     /*  514328 */     // GIR_Coverage, 62431,
     /*  514328 */     GIR_EraseRootFromParent_Done,
     /*  514329 */   // Label 8578: @514329
     /*  514329 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(514397), // Rule ID 62432 //
     /*  514334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514366 */     // MIs[0] policy
     /*  514366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  514379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514393 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514395 */     GIR_RootConstrainSelectedInstOperands,
     /*  514396 */     // GIR_Coverage, 62432,
     /*  514396 */     GIR_EraseRootFromParent_Done,
     /*  514397 */   // Label 8579: @514397
     /*  514397 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(514465), // Rule ID 62433 //
     /*  514402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514434 */     // MIs[0] policy
     /*  514434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  514447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514461 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514463 */     GIR_RootConstrainSelectedInstOperands,
     /*  514464 */     // GIR_Coverage, 62433,
     /*  514464 */     GIR_EraseRootFromParent_Done,
     /*  514465 */   // Label 8580: @514465
     /*  514465 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(514533), // Rule ID 62434 //
     /*  514470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514502 */     // MIs[0] policy
     /*  514502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514529 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514531 */     GIR_RootConstrainSelectedInstOperands,
     /*  514532 */     // GIR_Coverage, 62434,
     /*  514532 */     GIR_EraseRootFromParent_Done,
     /*  514533 */   // Label 8581: @514533
     /*  514533 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(514601), // Rule ID 62435 //
     /*  514538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514570 */     // MIs[0] policy
     /*  514570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514597 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514599 */     GIR_RootConstrainSelectedInstOperands,
     /*  514600 */     // GIR_Coverage, 62435,
     /*  514600 */     GIR_EraseRootFromParent_Done,
     /*  514601 */   // Label 8582: @514601
     /*  514601 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(514672), // Rule ID 2710 //
     /*  514606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514638 */     // MIs[0] round
     /*  514638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514648 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514657 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514670 */     GIR_RootConstrainSelectedInstOperands,
     /*  514671 */     // GIR_Coverage, 2710,
     /*  514671 */     GIR_EraseRootFromParent_Done,
     /*  514672 */   // Label 8583: @514672
     /*  514672 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(514743), // Rule ID 2711 //
     /*  514677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514709 */     // MIs[0] round
     /*  514709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514719 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514728 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514741 */     GIR_RootConstrainSelectedInstOperands,
     /*  514742 */     // GIR_Coverage, 2711,
     /*  514742 */     GIR_EraseRootFromParent_Done,
     /*  514743 */   // Label 8584: @514743
     /*  514743 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(514814), // Rule ID 2746 //
     /*  514748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  514751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514780 */     // MIs[0] round
     /*  514780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514799 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514812 */     GIR_RootConstrainSelectedInstOperands,
     /*  514813 */     // GIR_Coverage, 2746,
     /*  514813 */     GIR_EraseRootFromParent_Done,
     /*  514814 */   // Label 8585: @514814
     /*  514814 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(514885), // Rule ID 2747 //
     /*  514819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  514822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514851 */     // MIs[0] round
     /*  514851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514870 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514883 */     GIR_RootConstrainSelectedInstOperands,
     /*  514884 */     // GIR_Coverage, 2747,
     /*  514884 */     GIR_EraseRootFromParent_Done,
     /*  514885 */   // Label 8586: @514885
     /*  514885 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(514956), // Rule ID 19004 //
     /*  514890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514922 */     // MIs[0] round
     /*  514922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514932 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514941 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514954 */     GIR_RootConstrainSelectedInstOperands,
     /*  514955 */     // GIR_Coverage, 19004,
     /*  514955 */     GIR_EraseRootFromParent_Done,
     /*  514956 */   // Label 8587: @514956
     /*  514956 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(515027), // Rule ID 19005 //
     /*  514961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514993 */     // MIs[0] round
     /*  514993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515003 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  515006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515012 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515025 */     GIR_RootConstrainSelectedInstOperands,
     /*  515026 */     // GIR_Coverage, 19005,
     /*  515026 */     GIR_EraseRootFromParent_Done,
     /*  515027 */   // Label 8588: @515027
     /*  515027 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(515098), // Rule ID 19008 //
     /*  515032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515064 */     // MIs[0] round
     /*  515064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  515077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515083 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515096 */     GIR_RootConstrainSelectedInstOperands,
     /*  515097 */     // GIR_Coverage, 19008,
     /*  515097 */     GIR_EraseRootFromParent_Done,
     /*  515098 */   // Label 8589: @515098
     /*  515098 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(515169), // Rule ID 19009 //
     /*  515103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515135 */     // MIs[0] round
     /*  515135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515145 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  515148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515154 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515167 */     GIR_RootConstrainSelectedInstOperands,
     /*  515168 */     // GIR_Coverage, 19009,
     /*  515168 */     GIR_EraseRootFromParent_Done,
     /*  515169 */   // Label 8590: @515169
     /*  515169 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(515240), // Rule ID 19012 //
     /*  515174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  515185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515206 */     // MIs[0] round
     /*  515206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515216 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  515219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515225 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515238 */     GIR_RootConstrainSelectedInstOperands,
     /*  515239 */     // GIR_Coverage, 19012,
     /*  515239 */     GIR_EraseRootFromParent_Done,
     /*  515240 */   // Label 8591: @515240
     /*  515240 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(515311), // Rule ID 19013 //
     /*  515245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  515256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  515259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  515262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515277 */     // MIs[0] round
     /*  515277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515287 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11331:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  515290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515296 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515309 */     GIR_RootConstrainSelectedInstOperands,
     /*  515310 */     // GIR_Coverage, 19013,
     /*  515310 */     GIR_EraseRootFromParent_Done,
     /*  515311 */   // Label 8592: @515311
     /*  515311 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(515382), // Rule ID 19016 //
     /*  515316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515348 */     // MIs[0] round
     /*  515348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515358 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  515361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515367 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515380 */     GIR_RootConstrainSelectedInstOperands,
     /*  515381 */     // GIR_Coverage, 19016,
     /*  515381 */     GIR_EraseRootFromParent_Done,
     /*  515382 */   // Label 8593: @515382
     /*  515382 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(515453), // Rule ID 19017 //
     /*  515387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515419 */     // MIs[0] round
     /*  515419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515429 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11331:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  515432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515438 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515451 */     GIR_RootConstrainSelectedInstOperands,
     /*  515452 */     // GIR_Coverage, 19017,
     /*  515452 */     GIR_EraseRootFromParent_Done,
     /*  515453 */   // Label 8594: @515453
     /*  515453 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(515524), // Rule ID 19020 //
     /*  515458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515490 */     // MIs[0] round
     /*  515490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515509 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515522 */     GIR_RootConstrainSelectedInstOperands,
     /*  515523 */     // GIR_Coverage, 19020,
     /*  515523 */     GIR_EraseRootFromParent_Done,
     /*  515524 */   // Label 8595: @515524
     /*  515524 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(515595), // Rule ID 19021 //
     /*  515529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515561 */     // MIs[0] round
     /*  515561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515571 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11331:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515580 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515593 */     GIR_RootConstrainSelectedInstOperands,
     /*  515594 */     // GIR_Coverage, 19021,
     /*  515594 */     GIR_EraseRootFromParent_Done,
     /*  515595 */   // Label 8596: @515595
     /*  515595 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(515666), // Rule ID 19024 //
     /*  515600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515632 */     // MIs[0] round
     /*  515632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515642 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515651 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515664 */     GIR_RootConstrainSelectedInstOperands,
     /*  515665 */     // GIR_Coverage, 19024,
     /*  515665 */     GIR_EraseRootFromParent_Done,
     /*  515666 */   // Label 8597: @515666
     /*  515666 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(515737), // Rule ID 19025 //
     /*  515671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515703 */     // MIs[0] round
     /*  515703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515713 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515722 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515735 */     GIR_RootConstrainSelectedInstOperands,
     /*  515736 */     // GIR_Coverage, 19025,
     /*  515736 */     GIR_EraseRootFromParent_Done,
     /*  515737 */   // Label 8598: @515737
     /*  515737 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(515808), // Rule ID 19028 //
     /*  515742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515774 */     // MIs[0] round
     /*  515774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515784 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515793 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515806 */     GIR_RootConstrainSelectedInstOperands,
     /*  515807 */     // GIR_Coverage, 19028,
     /*  515807 */     GIR_EraseRootFromParent_Done,
     /*  515808 */   // Label 8599: @515808
     /*  515808 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(515879), // Rule ID 19029 //
     /*  515813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515845 */     // MIs[0] round
     /*  515845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515855 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515864 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515877 */     GIR_RootConstrainSelectedInstOperands,
     /*  515878 */     // GIR_Coverage, 19029,
     /*  515878 */     GIR_EraseRootFromParent_Done,
     /*  515879 */   // Label 8600: @515879
     /*  515879 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(515950), // Rule ID 19032 //
     /*  515884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515916 */     // MIs[0] round
     /*  515916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515926 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515935 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515948 */     GIR_RootConstrainSelectedInstOperands,
     /*  515949 */     // GIR_Coverage, 19032,
     /*  515949 */     GIR_EraseRootFromParent_Done,
     /*  515950 */   // Label 8601: @515950
     /*  515950 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(516021), // Rule ID 19033 //
     /*  515955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515987 */     // MIs[0] round
     /*  515987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515997 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  516000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516006 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516019 */     GIR_RootConstrainSelectedInstOperands,
     /*  516020 */     // GIR_Coverage, 19033,
     /*  516020 */     GIR_EraseRootFromParent_Done,
     /*  516021 */   // Label 8602: @516021
     /*  516021 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(516092), // Rule ID 19036 //
     /*  516026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516058 */     // MIs[0] round
     /*  516058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  516071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516077 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516090 */     GIR_RootConstrainSelectedInstOperands,
     /*  516091 */     // GIR_Coverage, 19036,
     /*  516091 */     GIR_EraseRootFromParent_Done,
     /*  516092 */   // Label 8603: @516092
     /*  516092 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(516163), // Rule ID 19037 //
     /*  516097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516129 */     // MIs[0] round
     /*  516129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  516142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516148 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516161 */     GIR_RootConstrainSelectedInstOperands,
     /*  516162 */     // GIR_Coverage, 19037,
     /*  516162 */     GIR_EraseRootFromParent_Done,
     /*  516163 */   // Label 8604: @516163
     /*  516163 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(516234), // Rule ID 19040 //
     /*  516168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516200 */     // MIs[0] round
     /*  516200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  516213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516219 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516232 */     GIR_RootConstrainSelectedInstOperands,
     /*  516233 */     // GIR_Coverage, 19040,
     /*  516233 */     GIR_EraseRootFromParent_Done,
     /*  516234 */   // Label 8605: @516234
     /*  516234 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(516305), // Rule ID 19041 //
     /*  516239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  516256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516271 */     // MIs[0] round
     /*  516271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516281 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  516284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516290 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516303 */     GIR_RootConstrainSelectedInstOperands,
     /*  516304 */     // GIR_Coverage, 19041,
     /*  516304 */     GIR_EraseRootFromParent_Done,
     /*  516305 */   // Label 8606: @516305
     /*  516305 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(516376), // Rule ID 19044 //
     /*  516310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516342 */     // MIs[0] round
     /*  516342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516352 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  516355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516361 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516374 */     GIR_RootConstrainSelectedInstOperands,
     /*  516375 */     // GIR_Coverage, 19044,
     /*  516375 */     GIR_EraseRootFromParent_Done,
     /*  516376 */   // Label 8607: @516376
     /*  516376 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(516447), // Rule ID 19045 //
     /*  516381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516413 */     // MIs[0] round
     /*  516413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516423 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  516426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516432 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516445 */     GIR_RootConstrainSelectedInstOperands,
     /*  516446 */     // GIR_Coverage, 19045,
     /*  516446 */     GIR_EraseRootFromParent_Done,
     /*  516447 */   // Label 8608: @516447
     /*  516447 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(516518), // Rule ID 19048 //
     /*  516452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516484 */     // MIs[0] round
     /*  516484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516494 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516503 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516516 */     GIR_RootConstrainSelectedInstOperands,
     /*  516517 */     // GIR_Coverage, 19048,
     /*  516517 */     GIR_EraseRootFromParent_Done,
     /*  516518 */   // Label 8609: @516518
     /*  516518 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(516589), // Rule ID 19049 //
     /*  516523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516555 */     // MIs[0] round
     /*  516555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516565 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11331:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516574 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516587 */     GIR_RootConstrainSelectedInstOperands,
     /*  516588 */     // GIR_Coverage, 19049,
     /*  516588 */     GIR_EraseRootFromParent_Done,
     /*  516589 */   // Label 8610: @516589
     /*  516589 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(516660), // Rule ID 19052 //
     /*  516594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516626 */     // MIs[0] round
     /*  516626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516636 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516645 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516658 */     GIR_RootConstrainSelectedInstOperands,
     /*  516659 */     // GIR_Coverage, 19052,
     /*  516659 */     GIR_EraseRootFromParent_Done,
     /*  516660 */   // Label 8611: @516660
     /*  516660 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(516731), // Rule ID 19053 //
     /*  516665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516697 */     // MIs[0] round
     /*  516697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516707 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11331:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516716 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516729 */     GIR_RootConstrainSelectedInstOperands,
     /*  516730 */     // GIR_Coverage, 19053,
     /*  516730 */     GIR_EraseRootFromParent_Done,
     /*  516731 */   // Label 8612: @516731
     /*  516731 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(516802), // Rule ID 19056 //
     /*  516736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516768 */     // MIs[0] round
     /*  516768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516778 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516787 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516800 */     GIR_RootConstrainSelectedInstOperands,
     /*  516801 */     // GIR_Coverage, 19056,
     /*  516801 */     GIR_EraseRootFromParent_Done,
     /*  516802 */   // Label 8613: @516802
     /*  516802 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(516873), // Rule ID 19057 //
     /*  516807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516839 */     // MIs[0] round
     /*  516839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516849 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11331:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516858 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516871 */     GIR_RootConstrainSelectedInstOperands,
     /*  516872 */     // GIR_Coverage, 19057,
     /*  516872 */     GIR_EraseRootFromParent_Done,
     /*  516873 */   // Label 8614: @516873
     /*  516873 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(516944), // Rule ID 19116 //
     /*  516878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516910 */     // MIs[0] round
     /*  516910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516920 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516929 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516942 */     GIR_RootConstrainSelectedInstOperands,
     /*  516943 */     // GIR_Coverage, 19116,
     /*  516943 */     GIR_EraseRootFromParent_Done,
     /*  516944 */   // Label 8615: @516944
     /*  516944 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(517015), // Rule ID 19117 //
     /*  516949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516981 */     // MIs[0] round
     /*  516981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516991 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517000 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517013 */     GIR_RootConstrainSelectedInstOperands,
     /*  517014 */     // GIR_Coverage, 19117,
     /*  517014 */     GIR_EraseRootFromParent_Done,
     /*  517015 */   // Label 8616: @517015
     /*  517015 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(517086), // Rule ID 19120 //
     /*  517020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  517031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  517034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  517037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517052 */     // MIs[0] round
     /*  517052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517062 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  517065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517071 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517084 */     GIR_RootConstrainSelectedInstOperands,
     /*  517085 */     // GIR_Coverage, 19120,
     /*  517085 */     GIR_EraseRootFromParent_Done,
     /*  517086 */   // Label 8617: @517086
     /*  517086 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(517157), // Rule ID 19121 //
     /*  517091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  517102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  517105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  517108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517123 */     // MIs[0] round
     /*  517123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517133 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  517136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517142 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517155 */     GIR_RootConstrainSelectedInstOperands,
     /*  517156 */     // GIR_Coverage, 19121,
     /*  517156 */     GIR_EraseRootFromParent_Done,
     /*  517157 */   // Label 8618: @517157
     /*  517157 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(517228), // Rule ID 19124 //
     /*  517162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  517173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  517176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517194 */     // MIs[0] round
     /*  517194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517204 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  517207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517213 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517226 */     GIR_RootConstrainSelectedInstOperands,
     /*  517227 */     // GIR_Coverage, 19124,
     /*  517227 */     GIR_EraseRootFromParent_Done,
     /*  517228 */   // Label 8619: @517228
     /*  517228 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(517299), // Rule ID 19125 //
     /*  517233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  517244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  517247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517265 */     // MIs[0] round
     /*  517265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517275 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  517278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517284 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517297 */     GIR_RootConstrainSelectedInstOperands,
     /*  517298 */     // GIR_Coverage, 19125,
     /*  517298 */     GIR_EraseRootFromParent_Done,
     /*  517299 */   // Label 8620: @517299
     /*  517299 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(517370), // Rule ID 19128 //
     /*  517304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  517315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  517318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  517321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517336 */     // MIs[0] round
     /*  517336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517346 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  517349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517355 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517368 */     GIR_RootConstrainSelectedInstOperands,
     /*  517369 */     // GIR_Coverage, 19128,
     /*  517369 */     GIR_EraseRootFromParent_Done,
     /*  517370 */   // Label 8621: @517370
     /*  517370 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(517441), // Rule ID 19129 //
     /*  517375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  517386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  517389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  517392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517407 */     // MIs[0] round
     /*  517407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517417 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11307:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  517420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517426 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517439 */     GIR_RootConstrainSelectedInstOperands,
     /*  517440 */     // GIR_Coverage, 19129,
     /*  517440 */     GIR_EraseRootFromParent_Done,
     /*  517441 */   // Label 8622: @517441
     /*  517441 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(517512), // Rule ID 19132 //
     /*  517446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517478 */     // MIs[0] round
     /*  517478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517497 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517510 */     GIR_RootConstrainSelectedInstOperands,
     /*  517511 */     // GIR_Coverage, 19132,
     /*  517511 */     GIR_EraseRootFromParent_Done,
     /*  517512 */   // Label 8623: @517512
     /*  517512 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(517583), // Rule ID 19133 //
     /*  517517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517549 */     // MIs[0] round
     /*  517549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517559 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517568 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517581 */     GIR_RootConstrainSelectedInstOperands,
     /*  517582 */     // GIR_Coverage, 19133,
     /*  517582 */     GIR_EraseRootFromParent_Done,
     /*  517583 */   // Label 8624: @517583
     /*  517583 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(517654), // Rule ID 19136 //
     /*  517588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517620 */     // MIs[0] round
     /*  517620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517630 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517639 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517652 */     GIR_RootConstrainSelectedInstOperands,
     /*  517653 */     // GIR_Coverage, 19136,
     /*  517653 */     GIR_EraseRootFromParent_Done,
     /*  517654 */   // Label 8625: @517654
     /*  517654 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(517725), // Rule ID 19137 //
     /*  517659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517691 */     // MIs[0] round
     /*  517691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517701 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517710 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517723 */     GIR_RootConstrainSelectedInstOperands,
     /*  517724 */     // GIR_Coverage, 19137,
     /*  517724 */     GIR_EraseRootFromParent_Done,
     /*  517725 */   // Label 8626: @517725
     /*  517725 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(517796), // Rule ID 19140 //
     /*  517730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517762 */     // MIs[0] round
     /*  517762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517772 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517781 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517794 */     GIR_RootConstrainSelectedInstOperands,
     /*  517795 */     // GIR_Coverage, 19140,
     /*  517795 */     GIR_EraseRootFromParent_Done,
     /*  517796 */   // Label 8627: @517796
     /*  517796 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(517867), // Rule ID 19141 //
     /*  517801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517833 */     // MIs[0] round
     /*  517833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517843 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517852 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517865 */     GIR_RootConstrainSelectedInstOperands,
     /*  517866 */     // GIR_Coverage, 19141,
     /*  517866 */     GIR_EraseRootFromParent_Done,
     /*  517867 */   // Label 8628: @517867
     /*  517867 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(517938), // Rule ID 19144 //
     /*  517872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517904 */     // MIs[0] round
     /*  517904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517914 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517923 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517936 */     GIR_RootConstrainSelectedInstOperands,
     /*  517937 */     // GIR_Coverage, 19144,
     /*  517937 */     GIR_EraseRootFromParent_Done,
     /*  517938 */   // Label 8629: @517938
     /*  517938 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(518009), // Rule ID 19145 //
     /*  517943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517975 */     // MIs[0] round
     /*  517975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517985 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517994 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518007 */     GIR_RootConstrainSelectedInstOperands,
     /*  518008 */     // GIR_Coverage, 19145,
     /*  518008 */     GIR_EraseRootFromParent_Done,
     /*  518009 */   // Label 8630: @518009
     /*  518009 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(518080), // Rule ID 19148 //
     /*  518014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  518025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  518028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  518031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518046 */     // MIs[0] round
     /*  518046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518056 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  518059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518065 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518078 */     GIR_RootConstrainSelectedInstOperands,
     /*  518079 */     // GIR_Coverage, 19148,
     /*  518079 */     GIR_EraseRootFromParent_Done,
     /*  518080 */   // Label 8631: @518080
     /*  518080 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(518151), // Rule ID 19149 //
     /*  518085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  518096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  518099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  518102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518117 */     // MIs[0] round
     /*  518117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518127 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  518130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518136 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518149 */     GIR_RootConstrainSelectedInstOperands,
     /*  518150 */     // GIR_Coverage, 19149,
     /*  518150 */     GIR_EraseRootFromParent_Done,
     /*  518151 */   // Label 8632: @518151
     /*  518151 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(518222), // Rule ID 19152 //
     /*  518156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  518167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  518170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  518173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518188 */     // MIs[0] round
     /*  518188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518198 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  518201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518207 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518220 */     GIR_RootConstrainSelectedInstOperands,
     /*  518221 */     // GIR_Coverage, 19152,
     /*  518221 */     GIR_EraseRootFromParent_Done,
     /*  518222 */   // Label 8633: @518222
     /*  518222 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(518293), // Rule ID 19153 //
     /*  518227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  518238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  518241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  518244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518259 */     // MIs[0] round
     /*  518259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  518272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518278 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518291 */     GIR_RootConstrainSelectedInstOperands,
     /*  518292 */     // GIR_Coverage, 19153,
     /*  518292 */     GIR_EraseRootFromParent_Done,
     /*  518293 */   // Label 8634: @518293
     /*  518293 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(518364), // Rule ID 19156 //
     /*  518298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  518309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  518312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  518315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518330 */     // MIs[0] round
     /*  518330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518340 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  518343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518349 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518362 */     GIR_RootConstrainSelectedInstOperands,
     /*  518363 */     // GIR_Coverage, 19156,
     /*  518363 */     GIR_EraseRootFromParent_Done,
     /*  518364 */   // Label 8635: @518364
     /*  518364 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(518435), // Rule ID 19157 //
     /*  518369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  518380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  518383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  518386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518401 */     // MIs[0] round
     /*  518401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518411 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  518414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518420 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518433 */     GIR_RootConstrainSelectedInstOperands,
     /*  518434 */     // GIR_Coverage, 19157,
     /*  518434 */     GIR_EraseRootFromParent_Done,
     /*  518435 */   // Label 8636: @518435
     /*  518435 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(518506), // Rule ID 19160 //
     /*  518440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518472 */     // MIs[0] round
     /*  518472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518482 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518491 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518504 */     GIR_RootConstrainSelectedInstOperands,
     /*  518505 */     // GIR_Coverage, 19160,
     /*  518505 */     GIR_EraseRootFromParent_Done,
     /*  518506 */   // Label 8637: @518506
     /*  518506 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(518577), // Rule ID 19161 //
     /*  518511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518543 */     // MIs[0] round
     /*  518543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518553 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518562 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518575 */     GIR_RootConstrainSelectedInstOperands,
     /*  518576 */     // GIR_Coverage, 19161,
     /*  518576 */     GIR_EraseRootFromParent_Done,
     /*  518577 */   // Label 8638: @518577
     /*  518577 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(518648), // Rule ID 19164 //
     /*  518582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518614 */     // MIs[0] round
     /*  518614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518624 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518633 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518646 */     GIR_RootConstrainSelectedInstOperands,
     /*  518647 */     // GIR_Coverage, 19164,
     /*  518647 */     GIR_EraseRootFromParent_Done,
     /*  518648 */   // Label 8639: @518648
     /*  518648 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(518719), // Rule ID 19165 //
     /*  518653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518685 */     // MIs[0] round
     /*  518685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518695 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518704 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518717 */     GIR_RootConstrainSelectedInstOperands,
     /*  518718 */     // GIR_Coverage, 19165,
     /*  518718 */     GIR_EraseRootFromParent_Done,
     /*  518719 */   // Label 8640: @518719
     /*  518719 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(518790), // Rule ID 19168 //
     /*  518724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518756 */     // MIs[0] round
     /*  518756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518766 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518775 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518788 */     GIR_RootConstrainSelectedInstOperands,
     /*  518789 */     // GIR_Coverage, 19168,
     /*  518789 */     GIR_EraseRootFromParent_Done,
     /*  518790 */   // Label 8641: @518790
     /*  518790 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(518861), // Rule ID 19169 //
     /*  518795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518827 */     // MIs[0] round
     /*  518827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518837 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518846 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518859 */     GIR_RootConstrainSelectedInstOperands,
     /*  518860 */     // GIR_Coverage, 19169,
     /*  518860 */     GIR_EraseRootFromParent_Done,
     /*  518861 */   // Label 8642: @518861
     /*  518861 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(518932), // Rule ID 19172 //
     /*  518866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518898 */     // MIs[0] round
     /*  518898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518917 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518930 */     GIR_RootConstrainSelectedInstOperands,
     /*  518931 */     // GIR_Coverage, 19172,
     /*  518931 */     GIR_EraseRootFromParent_Done,
     /*  518932 */   // Label 8643: @518932
     /*  518932 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(519003), // Rule ID 19173 //
     /*  518937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518969 */     // MIs[0] round
     /*  518969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518979 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518988 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519001 */     GIR_RootConstrainSelectedInstOperands,
     /*  519002 */     // GIR_Coverage, 19173,
     /*  519002 */     GIR_EraseRootFromParent_Done,
     /*  519003 */   // Label 8644: @519003
     /*  519003 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(519074), // Rule ID 20758 //
     /*  519008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  519019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  519022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  519025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519040 */     // MIs[0] round
     /*  519040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519050 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519059 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519072 */     GIR_RootConstrainSelectedInstOperands,
     /*  519073 */     // GIR_Coverage, 20758,
     /*  519073 */     GIR_EraseRootFromParent_Done,
     /*  519074 */   // Label 8645: @519074
     /*  519074 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(519145), // Rule ID 20759 //
     /*  519079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  519090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  519093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  519096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519111 */     // MIs[0] round
     /*  519111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519121 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519130 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519143 */     GIR_RootConstrainSelectedInstOperands,
     /*  519144 */     // GIR_Coverage, 20759,
     /*  519144 */     GIR_EraseRootFromParent_Done,
     /*  519145 */   // Label 8646: @519145
     /*  519145 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(519216), // Rule ID 20762 //
     /*  519150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  519161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  519164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  519167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519182 */     // MIs[0] round
     /*  519182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519201 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519214 */     GIR_RootConstrainSelectedInstOperands,
     /*  519215 */     // GIR_Coverage, 20762,
     /*  519215 */     GIR_EraseRootFromParent_Done,
     /*  519216 */   // Label 8647: @519216
     /*  519216 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(519287), // Rule ID 20763 //
     /*  519221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  519232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  519235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  519238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519253 */     // MIs[0] round
     /*  519253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  519266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519272 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519285 */     GIR_RootConstrainSelectedInstOperands,
     /*  519286 */     // GIR_Coverage, 20763,
     /*  519286 */     GIR_EraseRootFromParent_Done,
     /*  519287 */   // Label 8648: @519287
     /*  519287 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(519358), // Rule ID 20766 //
     /*  519292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  519303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  519306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  519309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519324 */     // MIs[0] round
     /*  519324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519334 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519343 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519356 */     GIR_RootConstrainSelectedInstOperands,
     /*  519357 */     // GIR_Coverage, 20766,
     /*  519357 */     GIR_EraseRootFromParent_Done,
     /*  519358 */   // Label 8649: @519358
     /*  519358 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(519429), // Rule ID 20767 //
     /*  519363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  519374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  519377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  519380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519395 */     // MIs[0] round
     /*  519395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519405 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519414 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519427 */     GIR_RootConstrainSelectedInstOperands,
     /*  519428 */     // GIR_Coverage, 20767,
     /*  519428 */     GIR_EraseRootFromParent_Done,
     /*  519429 */   // Label 8650: @519429
     /*  519429 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(519500), // Rule ID 20770 //
     /*  519434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519466 */     // MIs[0] round
     /*  519466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519485 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519498 */     GIR_RootConstrainSelectedInstOperands,
     /*  519499 */     // GIR_Coverage, 20770,
     /*  519499 */     GIR_EraseRootFromParent_Done,
     /*  519500 */   // Label 8651: @519500
     /*  519500 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(519571), // Rule ID 20771 //
     /*  519505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519537 */     // MIs[0] round
     /*  519537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519556 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519569 */     GIR_RootConstrainSelectedInstOperands,
     /*  519570 */     // GIR_Coverage, 20771,
     /*  519570 */     GIR_EraseRootFromParent_Done,
     /*  519571 */   // Label 8652: @519571
     /*  519571 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(519642), // Rule ID 20774 //
     /*  519576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519608 */     // MIs[0] round
     /*  519608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519627 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519640 */     GIR_RootConstrainSelectedInstOperands,
     /*  519641 */     // GIR_Coverage, 20774,
     /*  519641 */     GIR_EraseRootFromParent_Done,
     /*  519642 */   // Label 8653: @519642
     /*  519642 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(519713), // Rule ID 20775 //
     /*  519647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519679 */     // MIs[0] round
     /*  519679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519689 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519698 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519711 */     GIR_RootConstrainSelectedInstOperands,
     /*  519712 */     // GIR_Coverage, 20775,
     /*  519712 */     GIR_EraseRootFromParent_Done,
     /*  519713 */   // Label 8654: @519713
     /*  519713 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(519784), // Rule ID 20778 //
     /*  519718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519750 */     // MIs[0] round
     /*  519750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519769 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519782 */     GIR_RootConstrainSelectedInstOperands,
     /*  519783 */     // GIR_Coverage, 20778,
     /*  519783 */     GIR_EraseRootFromParent_Done,
     /*  519784 */   // Label 8655: @519784
     /*  519784 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(519855), // Rule ID 20779 //
     /*  519789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519821 */     // MIs[0] round
     /*  519821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519840 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519853 */     GIR_RootConstrainSelectedInstOperands,
     /*  519854 */     // GIR_Coverage, 20779,
     /*  519854 */     GIR_EraseRootFromParent_Done,
     /*  519855 */   // Label 8656: @519855
     /*  519855 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(519926), // Rule ID 20782 //
     /*  519860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519892 */     // MIs[0] round
     /*  519892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519911 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519924 */     GIR_RootConstrainSelectedInstOperands,
     /*  519925 */     // GIR_Coverage, 20782,
     /*  519925 */     GIR_EraseRootFromParent_Done,
     /*  519926 */   // Label 8657: @519926
     /*  519926 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(519997), // Rule ID 20783 //
     /*  519931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519963 */     // MIs[0] round
     /*  519963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519973 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519982 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519995 */     GIR_RootConstrainSelectedInstOperands,
     /*  519996 */     // GIR_Coverage, 20783,
     /*  519996 */     GIR_EraseRootFromParent_Done,
     /*  519997 */   // Label 8658: @519997
     /*  519997 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(520068), // Rule ID 20786 //
     /*  520002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  520013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  520016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  520019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520034 */     // MIs[0] round
     /*  520034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520053 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520066 */     GIR_RootConstrainSelectedInstOperands,
     /*  520067 */     // GIR_Coverage, 20786,
     /*  520067 */     GIR_EraseRootFromParent_Done,
     /*  520068 */   // Label 8659: @520068
     /*  520068 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(520139), // Rule ID 20787 //
     /*  520073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  520084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  520087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  520090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520105 */     // MIs[0] round
     /*  520105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520115 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520124 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520137 */     GIR_RootConstrainSelectedInstOperands,
     /*  520138 */     // GIR_Coverage, 20787,
     /*  520138 */     GIR_EraseRootFromParent_Done,
     /*  520139 */   // Label 8660: @520139
     /*  520139 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(520210), // Rule ID 20790 //
     /*  520144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  520155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  520158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  520161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520176 */     // MIs[0] round
     /*  520176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520195 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520208 */     GIR_RootConstrainSelectedInstOperands,
     /*  520209 */     // GIR_Coverage, 20790,
     /*  520209 */     GIR_EraseRootFromParent_Done,
     /*  520210 */   // Label 8661: @520210
     /*  520210 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(520281), // Rule ID 20791 //
     /*  520215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  520226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  520229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  520232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520247 */     // MIs[0] round
     /*  520247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520266 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520279 */     GIR_RootConstrainSelectedInstOperands,
     /*  520280 */     // GIR_Coverage, 20791,
     /*  520280 */     GIR_EraseRootFromParent_Done,
     /*  520281 */   // Label 8662: @520281
     /*  520281 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(520352), // Rule ID 20794 //
     /*  520286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  520297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  520300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  520303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520318 */     // MIs[0] round
     /*  520318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520337 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520350 */     GIR_RootConstrainSelectedInstOperands,
     /*  520351 */     // GIR_Coverage, 20794,
     /*  520351 */     GIR_EraseRootFromParent_Done,
     /*  520352 */   // Label 8663: @520352
     /*  520352 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(520423), // Rule ID 20795 //
     /*  520357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  520368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  520371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  520374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520389 */     // MIs[0] round
     /*  520389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520399 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520408 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520421 */     GIR_RootConstrainSelectedInstOperands,
     /*  520422 */     // GIR_Coverage, 20795,
     /*  520422 */     GIR_EraseRootFromParent_Done,
     /*  520423 */   // Label 8664: @520423
     /*  520423 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(520494), // Rule ID 20798 //
     /*  520428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520460 */     // MIs[0] round
     /*  520460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520479 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520492 */     GIR_RootConstrainSelectedInstOperands,
     /*  520493 */     // GIR_Coverage, 20798,
     /*  520493 */     GIR_EraseRootFromParent_Done,
     /*  520494 */   // Label 8665: @520494
     /*  520494 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(520565), // Rule ID 20799 //
     /*  520499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520531 */     // MIs[0] round
     /*  520531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520550 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520563 */     GIR_RootConstrainSelectedInstOperands,
     /*  520564 */     // GIR_Coverage, 20799,
     /*  520564 */     GIR_EraseRootFromParent_Done,
     /*  520565 */   // Label 8666: @520565
     /*  520565 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(520636), // Rule ID 20802 //
     /*  520570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520602 */     // MIs[0] round
     /*  520602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520621 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520634 */     GIR_RootConstrainSelectedInstOperands,
     /*  520635 */     // GIR_Coverage, 20802,
     /*  520635 */     GIR_EraseRootFromParent_Done,
     /*  520636 */   // Label 8667: @520636
     /*  520636 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(520707), // Rule ID 20803 //
     /*  520641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520673 */     // MIs[0] round
     /*  520673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520692 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520705 */     GIR_RootConstrainSelectedInstOperands,
     /*  520706 */     // GIR_Coverage, 20803,
     /*  520706 */     GIR_EraseRootFromParent_Done,
     /*  520707 */   // Label 8668: @520707
     /*  520707 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(520778), // Rule ID 20806 //
     /*  520712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520744 */     // MIs[0] round
     /*  520744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520754 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520763 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520776 */     GIR_RootConstrainSelectedInstOperands,
     /*  520777 */     // GIR_Coverage, 20806,
     /*  520777 */     GIR_EraseRootFromParent_Done,
     /*  520778 */   // Label 8669: @520778
     /*  520778 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(520849), // Rule ID 20807 //
     /*  520783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520815 */     // MIs[0] round
     /*  520815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520825 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520834 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520847 */     GIR_RootConstrainSelectedInstOperands,
     /*  520848 */     // GIR_Coverage, 20807,
     /*  520848 */     GIR_EraseRootFromParent_Done,
     /*  520849 */   // Label 8670: @520849
     /*  520849 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(520920), // Rule ID 20810 //
     /*  520854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520886 */     // MIs[0] round
     /*  520886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520896 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520905 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520918 */     GIR_RootConstrainSelectedInstOperands,
     /*  520919 */     // GIR_Coverage, 20810,
     /*  520919 */     GIR_EraseRootFromParent_Done,
     /*  520920 */   // Label 8671: @520920
     /*  520920 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(520991), // Rule ID 20811 //
     /*  520925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520957 */     // MIs[0] round
     /*  520957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520967 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520976 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520989 */     GIR_RootConstrainSelectedInstOperands,
     /*  520990 */     // GIR_Coverage, 20811,
     /*  520990 */     GIR_EraseRootFromParent_Done,
     /*  520991 */   // Label 8672: @520991
     /*  520991 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(521062), // Rule ID 20814 //
     /*  520996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521028 */     // MIs[0] round
     /*  521028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  521041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521047 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521060 */     GIR_RootConstrainSelectedInstOperands,
     /*  521061 */     // GIR_Coverage, 20814,
     /*  521061 */     GIR_EraseRootFromParent_Done,
     /*  521062 */   // Label 8673: @521062
     /*  521062 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(521133), // Rule ID 20815 //
     /*  521067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  521078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  521081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  521084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521099 */     // MIs[0] round
     /*  521099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  521112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521118 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521131 */     GIR_RootConstrainSelectedInstOperands,
     /*  521132 */     // GIR_Coverage, 20815,
     /*  521132 */     GIR_EraseRootFromParent_Done,
     /*  521133 */   // Label 8674: @521133
     /*  521133 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(521204), // Rule ID 20818 //
     /*  521138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521170 */     // MIs[0] round
     /*  521170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521189 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521202 */     GIR_RootConstrainSelectedInstOperands,
     /*  521203 */     // GIR_Coverage, 20818,
     /*  521203 */     GIR_EraseRootFromParent_Done,
     /*  521204 */   // Label 8675: @521204
     /*  521204 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(521275), // Rule ID 20819 //
     /*  521209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  521220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  521223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  521226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521241 */     // MIs[0] round
     /*  521241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521251 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521260 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521273 */     GIR_RootConstrainSelectedInstOperands,
     /*  521274 */     // GIR_Coverage, 20819,
     /*  521274 */     GIR_EraseRootFromParent_Done,
     /*  521275 */   // Label 8676: @521275
     /*  521275 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(521346), // Rule ID 20822 //
     /*  521280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521312 */     // MIs[0] round
     /*  521312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521331 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521344 */     GIR_RootConstrainSelectedInstOperands,
     /*  521345 */     // GIR_Coverage, 20822,
     /*  521345 */     GIR_EraseRootFromParent_Done,
     /*  521346 */   // Label 8677: @521346
     /*  521346 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(521417), // Rule ID 20823 //
     /*  521351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  521362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  521365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  521368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521383 */     // MIs[0] round
     /*  521383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521393 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  521396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521402 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521415 */     GIR_RootConstrainSelectedInstOperands,
     /*  521416 */     // GIR_Coverage, 20823,
     /*  521416 */     GIR_EraseRootFromParent_Done,
     /*  521417 */   // Label 8678: @521417
     /*  521417 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(521488), // Rule ID 20826 //
     /*  521422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521454 */     // MIs[0] round
     /*  521454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521473 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521486 */     GIR_RootConstrainSelectedInstOperands,
     /*  521487 */     // GIR_Coverage, 20826,
     /*  521487 */     GIR_EraseRootFromParent_Done,
     /*  521488 */   // Label 8679: @521488
     /*  521488 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(521559), // Rule ID 20827 //
     /*  521493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521525 */     // MIs[0] round
     /*  521525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521535 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521544 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521557 */     GIR_RootConstrainSelectedInstOperands,
     /*  521558 */     // GIR_Coverage, 20827,
     /*  521558 */     GIR_EraseRootFromParent_Done,
     /*  521559 */   // Label 8680: @521559
     /*  521559 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(521630), // Rule ID 20830 //
     /*  521564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521596 */     // MIs[0] round
     /*  521596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521606 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521615 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521628 */     GIR_RootConstrainSelectedInstOperands,
     /*  521629 */     // GIR_Coverage, 20830,
     /*  521629 */     GIR_EraseRootFromParent_Done,
     /*  521630 */   // Label 8681: @521630
     /*  521630 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(521701), // Rule ID 20831 //
     /*  521635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521667 */     // MIs[0] round
     /*  521667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521686 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521699 */     GIR_RootConstrainSelectedInstOperands,
     /*  521700 */     // GIR_Coverage, 20831,
     /*  521700 */     GIR_EraseRootFromParent_Done,
     /*  521701 */   // Label 8682: @521701
     /*  521701 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(521772), // Rule ID 20834 //
     /*  521706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521738 */     // MIs[0] round
     /*  521738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521757 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521770 */     GIR_RootConstrainSelectedInstOperands,
     /*  521771 */     // GIR_Coverage, 20834,
     /*  521771 */     GIR_EraseRootFromParent_Done,
     /*  521772 */   // Label 8683: @521772
     /*  521772 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(521843), // Rule ID 20835 //
     /*  521777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521809 */     // MIs[0] round
     /*  521809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521819 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521828 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521841 */     GIR_RootConstrainSelectedInstOperands,
     /*  521842 */     // GIR_Coverage, 20835,
     /*  521842 */     GIR_EraseRootFromParent_Done,
     /*  521843 */   // Label 8684: @521843
     /*  521843 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(521914), // Rule ID 20838 //
     /*  521848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521880 */     // MIs[0] round
     /*  521880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521899 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521912 */     GIR_RootConstrainSelectedInstOperands,
     /*  521913 */     // GIR_Coverage, 20838,
     /*  521913 */     GIR_EraseRootFromParent_Done,
     /*  521914 */   // Label 8685: @521914
     /*  521914 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(521985), // Rule ID 20839 //
     /*  521919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521951 */     // MIs[0] round
     /*  521951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521970 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521983 */     GIR_RootConstrainSelectedInstOperands,
     /*  521984 */     // GIR_Coverage, 20839,
     /*  521984 */     GIR_EraseRootFromParent_Done,
     /*  521985 */   // Label 8686: @521985
     /*  521985 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(522056), // Rule ID 20842 //
     /*  521990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522022 */     // MIs[0] round
     /*  522022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522041 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522054 */     GIR_RootConstrainSelectedInstOperands,
     /*  522055 */     // GIR_Coverage, 20842,
     /*  522055 */     GIR_EraseRootFromParent_Done,
     /*  522056 */   // Label 8687: @522056
     /*  522056 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(522127), // Rule ID 20843 //
     /*  522061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  522072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  522075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  522078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522093 */     // MIs[0] round
     /*  522093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522103 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522112 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522125 */     GIR_RootConstrainSelectedInstOperands,
     /*  522126 */     // GIR_Coverage, 20843,
     /*  522126 */     GIR_EraseRootFromParent_Done,
     /*  522127 */   // Label 8688: @522127
     /*  522127 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(522198), // Rule ID 20846 //
     /*  522132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522164 */     // MIs[0] round
     /*  522164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522183 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522196 */     GIR_RootConstrainSelectedInstOperands,
     /*  522197 */     // GIR_Coverage, 20846,
     /*  522197 */     GIR_EraseRootFromParent_Done,
     /*  522198 */   // Label 8689: @522198
     /*  522198 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(522269), // Rule ID 20847 //
     /*  522203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  522214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  522217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  522220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522235 */     // MIs[0] round
     /*  522235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522254 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522267 */     GIR_RootConstrainSelectedInstOperands,
     /*  522268 */     // GIR_Coverage, 20847,
     /*  522268 */     GIR_EraseRootFromParent_Done,
     /*  522269 */   // Label 8690: @522269
     /*  522269 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(522340), // Rule ID 20850 //
     /*  522274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  522285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  522288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  522291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522306 */     // MIs[0] round
     /*  522306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522325 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522338 */     GIR_RootConstrainSelectedInstOperands,
     /*  522339 */     // GIR_Coverage, 20850,
     /*  522339 */     GIR_EraseRootFromParent_Done,
     /*  522340 */   // Label 8691: @522340
     /*  522340 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(522411), // Rule ID 20851 //
     /*  522345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  522356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  522359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  522362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522377 */     // MIs[0] round
     /*  522377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522396 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522409 */     GIR_RootConstrainSelectedInstOperands,
     /*  522410 */     // GIR_Coverage, 20851,
     /*  522410 */     GIR_EraseRootFromParent_Done,
     /*  522411 */   // Label 8692: @522411
     /*  522411 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(522482), // Rule ID 20854 //
     /*  522416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522448 */     // MIs[0] round
     /*  522448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522467 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522480 */     GIR_RootConstrainSelectedInstOperands,
     /*  522481 */     // GIR_Coverage, 20854,
     /*  522481 */     GIR_EraseRootFromParent_Done,
     /*  522482 */   // Label 8693: @522482
     /*  522482 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(522553), // Rule ID 20855 //
     /*  522487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522519 */     // MIs[0] round
     /*  522519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522538 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522551 */     GIR_RootConstrainSelectedInstOperands,
     /*  522552 */     // GIR_Coverage, 20855,
     /*  522552 */     GIR_EraseRootFromParent_Done,
     /*  522553 */   // Label 8694: @522553
     /*  522553 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(522624), // Rule ID 20858 //
     /*  522558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522590 */     // MIs[0] round
     /*  522590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522609 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522622 */     GIR_RootConstrainSelectedInstOperands,
     /*  522623 */     // GIR_Coverage, 20858,
     /*  522623 */     GIR_EraseRootFromParent_Done,
     /*  522624 */   // Label 8695: @522624
     /*  522624 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(522695), // Rule ID 20859 //
     /*  522629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522661 */     // MIs[0] round
     /*  522661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522680 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522693 */     GIR_RootConstrainSelectedInstOperands,
     /*  522694 */     // GIR_Coverage, 20859,
     /*  522694 */     GIR_EraseRootFromParent_Done,
     /*  522695 */   // Label 8696: @522695
     /*  522695 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(522766), // Rule ID 20862 //
     /*  522700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522732 */     // MIs[0] round
     /*  522732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522751 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522764 */     GIR_RootConstrainSelectedInstOperands,
     /*  522765 */     // GIR_Coverage, 20862,
     /*  522765 */     GIR_EraseRootFromParent_Done,
     /*  522766 */   // Label 8697: @522766
     /*  522766 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(522837), // Rule ID 20863 //
     /*  522771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522803 */     // MIs[0] round
     /*  522803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522822 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522835 */     GIR_RootConstrainSelectedInstOperands,
     /*  522836 */     // GIR_Coverage, 20863,
     /*  522836 */     GIR_EraseRootFromParent_Done,
     /*  522837 */   // Label 8698: @522837
     /*  522837 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(522908), // Rule ID 20866 //
     /*  522842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522874 */     // MIs[0] round
     /*  522874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522893 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522906 */     GIR_RootConstrainSelectedInstOperands,
     /*  522907 */     // GIR_Coverage, 20866,
     /*  522907 */     GIR_EraseRootFromParent_Done,
     /*  522908 */   // Label 8699: @522908
     /*  522908 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(522979), // Rule ID 20867 //
     /*  522913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522945 */     // MIs[0] round
     /*  522945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522955 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522964 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522977 */     GIR_RootConstrainSelectedInstOperands,
     /*  522978 */     // GIR_Coverage, 20867,
     /*  522978 */     GIR_EraseRootFromParent_Done,
     /*  522979 */   // Label 8700: @522979
     /*  522979 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(523050), // Rule ID 20870 //
     /*  522984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523016 */     // MIs[0] round
     /*  523016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  523029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523035 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523048 */     GIR_RootConstrainSelectedInstOperands,
     /*  523049 */     // GIR_Coverage, 20870,
     /*  523049 */     GIR_EraseRootFromParent_Done,
     /*  523050 */   // Label 8701: @523050
     /*  523050 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(523121), // Rule ID 20871 //
     /*  523055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  523063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  523066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  523069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  523072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523087 */     // MIs[0] round
     /*  523087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523097 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  523100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523106 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523119 */     GIR_RootConstrainSelectedInstOperands,
     /*  523120 */     // GIR_Coverage, 20871,
     /*  523120 */     GIR_EraseRootFromParent_Done,
     /*  523121 */   // Label 8702: @523121
     /*  523121 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(523192), // Rule ID 20994 //
     /*  523126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  523137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  523140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  523143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523158 */     // MIs[0] round
     /*  523158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523168 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  523171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523177 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523190 */     GIR_RootConstrainSelectedInstOperands,
     /*  523191 */     // GIR_Coverage, 20994,
     /*  523191 */     GIR_EraseRootFromParent_Done,
     /*  523192 */   // Label 8703: @523192
     /*  523192 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(523263), // Rule ID 20995 //
     /*  523197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  523208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  523211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  523214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523229 */     // MIs[0] round
     /*  523229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523239 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  523242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523248 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523261 */     GIR_RootConstrainSelectedInstOperands,
     /*  523262 */     // GIR_Coverage, 20995,
     /*  523262 */     GIR_EraseRootFromParent_Done,
     /*  523263 */   // Label 8704: @523263
     /*  523263 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(523334), // Rule ID 20998 //
     /*  523268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  523279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  523282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  523285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523300 */     // MIs[0] round
     /*  523300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523310 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  523313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523319 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523332 */     GIR_RootConstrainSelectedInstOperands,
     /*  523333 */     // GIR_Coverage, 20998,
     /*  523333 */     GIR_EraseRootFromParent_Done,
     /*  523334 */   // Label 8705: @523334
     /*  523334 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(523405), // Rule ID 20999 //
     /*  523339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  523350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  523353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  523356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523371 */     // MIs[0] round
     /*  523371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523381 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  523384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523390 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523403 */     GIR_RootConstrainSelectedInstOperands,
     /*  523404 */     // GIR_Coverage, 20999,
     /*  523404 */     GIR_EraseRootFromParent_Done,
     /*  523405 */   // Label 8706: @523405
     /*  523405 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(523476), // Rule ID 21002 //
     /*  523410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523442 */     // MIs[0] round
     /*  523442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523461 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523474 */     GIR_RootConstrainSelectedInstOperands,
     /*  523475 */     // GIR_Coverage, 21002,
     /*  523475 */     GIR_EraseRootFromParent_Done,
     /*  523476 */   // Label 8707: @523476
     /*  523476 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(523547), // Rule ID 21003 //
     /*  523481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523513 */     // MIs[0] round
     /*  523513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523523 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523532 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523545 */     GIR_RootConstrainSelectedInstOperands,
     /*  523546 */     // GIR_Coverage, 21003,
     /*  523546 */     GIR_EraseRootFromParent_Done,
     /*  523547 */   // Label 8708: @523547
     /*  523547 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(523618), // Rule ID 21006 //
     /*  523552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523584 */     // MIs[0] round
     /*  523584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523594 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523603 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523616 */     GIR_RootConstrainSelectedInstOperands,
     /*  523617 */     // GIR_Coverage, 21006,
     /*  523617 */     GIR_EraseRootFromParent_Done,
     /*  523618 */   // Label 8709: @523618
     /*  523618 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(523689), // Rule ID 21007 //
     /*  523623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523655 */     // MIs[0] round
     /*  523655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523665 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523674 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523687 */     GIR_RootConstrainSelectedInstOperands,
     /*  523688 */     // GIR_Coverage, 21007,
     /*  523688 */     GIR_EraseRootFromParent_Done,
     /*  523689 */   // Label 8710: @523689
     /*  523689 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(523760), // Rule ID 21010 //
     /*  523694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523726 */     // MIs[0] round
     /*  523726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523745 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523758 */     GIR_RootConstrainSelectedInstOperands,
     /*  523759 */     // GIR_Coverage, 21010,
     /*  523759 */     GIR_EraseRootFromParent_Done,
     /*  523760 */   // Label 8711: @523760
     /*  523760 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(523831), // Rule ID 21011 //
     /*  523765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523797 */     // MIs[0] round
     /*  523797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523816 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523829 */     GIR_RootConstrainSelectedInstOperands,
     /*  523830 */     // GIR_Coverage, 21011,
     /*  523830 */     GIR_EraseRootFromParent_Done,
     /*  523831 */   // Label 8712: @523831
     /*  523831 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(523902), // Rule ID 21014 //
     /*  523836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523868 */     // MIs[0] round
     /*  523868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523887 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523900 */     GIR_RootConstrainSelectedInstOperands,
     /*  523901 */     // GIR_Coverage, 21014,
     /*  523901 */     GIR_EraseRootFromParent_Done,
     /*  523902 */   // Label 8713: @523902
     /*  523902 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(523973), // Rule ID 21015 //
     /*  523907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523939 */     // MIs[0] round
     /*  523939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523949 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523958 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523971 */     GIR_RootConstrainSelectedInstOperands,
     /*  523972 */     // GIR_Coverage, 21015,
     /*  523972 */     GIR_EraseRootFromParent_Done,
     /*  523973 */   // Label 8714: @523973
     /*  523973 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(524044), // Rule ID 21018 //
     /*  523978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524010 */     // MIs[0] round
     /*  524010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524020 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  524023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524029 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524042 */     GIR_RootConstrainSelectedInstOperands,
     /*  524043 */     // GIR_Coverage, 21018,
     /*  524043 */     GIR_EraseRootFromParent_Done,
     /*  524044 */   // Label 8715: @524044
     /*  524044 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(524115), // Rule ID 21019 //
     /*  524049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  524060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  524063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  524066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524081 */     // MIs[0] round
     /*  524081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  524094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524100 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524113 */     GIR_RootConstrainSelectedInstOperands,
     /*  524114 */     // GIR_Coverage, 21019,
     /*  524114 */     GIR_EraseRootFromParent_Done,
     /*  524115 */   // Label 8716: @524115
     /*  524115 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(524186), // Rule ID 21022 //
     /*  524120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  524131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  524134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  524137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524152 */     // MIs[0] round
     /*  524152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524162 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  524165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524171 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524184 */     GIR_RootConstrainSelectedInstOperands,
     /*  524185 */     // GIR_Coverage, 21022,
     /*  524185 */     GIR_EraseRootFromParent_Done,
     /*  524186 */   // Label 8717: @524186
     /*  524186 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(524257), // Rule ID 21023 //
     /*  524191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  524202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  524205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  524208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524223 */     // MIs[0] round
     /*  524223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524233 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  524236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524242 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524255 */     GIR_RootConstrainSelectedInstOperands,
     /*  524256 */     // GIR_Coverage, 21023,
     /*  524256 */     GIR_EraseRootFromParent_Done,
     /*  524257 */   // Label 8718: @524257
     /*  524257 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(524328), // Rule ID 21026 //
     /*  524262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  524273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  524276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  524279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524294 */     // MIs[0] round
     /*  524294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524304 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  524307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524313 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524326 */     GIR_RootConstrainSelectedInstOperands,
     /*  524327 */     // GIR_Coverage, 21026,
     /*  524327 */     GIR_EraseRootFromParent_Done,
     /*  524328 */   // Label 8719: @524328
     /*  524328 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(524399), // Rule ID 21027 //
     /*  524333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  524344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  524347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  524350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524365 */     // MIs[0] round
     /*  524365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524375 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  524378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524384 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524397 */     GIR_RootConstrainSelectedInstOperands,
     /*  524398 */     // GIR_Coverage, 21027,
     /*  524398 */     GIR_EraseRootFromParent_Done,
     /*  524399 */   // Label 8720: @524399
     /*  524399 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(524470), // Rule ID 21030 //
     /*  524404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524436 */     // MIs[0] round
     /*  524436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524455 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524468 */     GIR_RootConstrainSelectedInstOperands,
     /*  524469 */     // GIR_Coverage, 21030,
     /*  524469 */     GIR_EraseRootFromParent_Done,
     /*  524470 */   // Label 8721: @524470
     /*  524470 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(524541), // Rule ID 21031 //
     /*  524475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524507 */     // MIs[0] round
     /*  524507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524517 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524526 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524539 */     GIR_RootConstrainSelectedInstOperands,
     /*  524540 */     // GIR_Coverage, 21031,
     /*  524540 */     GIR_EraseRootFromParent_Done,
     /*  524541 */   // Label 8722: @524541
     /*  524541 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(524612), // Rule ID 21034 //
     /*  524546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524578 */     // MIs[0] round
     /*  524578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524597 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524610 */     GIR_RootConstrainSelectedInstOperands,
     /*  524611 */     // GIR_Coverage, 21034,
     /*  524611 */     GIR_EraseRootFromParent_Done,
     /*  524612 */   // Label 8723: @524612
     /*  524612 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(524683), // Rule ID 21035 //
     /*  524617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524649 */     // MIs[0] round
     /*  524649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524659 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524668 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524681 */     GIR_RootConstrainSelectedInstOperands,
     /*  524682 */     // GIR_Coverage, 21035,
     /*  524682 */     GIR_EraseRootFromParent_Done,
     /*  524683 */   // Label 8724: @524683
     /*  524683 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(524754), // Rule ID 21038 //
     /*  524688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524720 */     // MIs[0] round
     /*  524720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524739 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524752 */     GIR_RootConstrainSelectedInstOperands,
     /*  524753 */     // GIR_Coverage, 21038,
     /*  524753 */     GIR_EraseRootFromParent_Done,
     /*  524754 */   // Label 8725: @524754
     /*  524754 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(524825), // Rule ID 21039 //
     /*  524759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524791 */     // MIs[0] round
     /*  524791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524801 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524810 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524823 */     GIR_RootConstrainSelectedInstOperands,
     /*  524824 */     // GIR_Coverage, 21039,
     /*  524824 */     GIR_EraseRootFromParent_Done,
     /*  524825 */   // Label 8726: @524825
     /*  524825 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(524896), // Rule ID 21042 //
     /*  524830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524862 */     // MIs[0] round
     /*  524862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524881 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524894 */     GIR_RootConstrainSelectedInstOperands,
     /*  524895 */     // GIR_Coverage, 21042,
     /*  524895 */     GIR_EraseRootFromParent_Done,
     /*  524896 */   // Label 8727: @524896
     /*  524896 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(524967), // Rule ID 21043 //
     /*  524901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524933 */     // MIs[0] round
     /*  524933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524943 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524952 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524965 */     GIR_RootConstrainSelectedInstOperands,
     /*  524966 */     // GIR_Coverage, 21043,
     /*  524966 */     GIR_EraseRootFromParent_Done,
     /*  524967 */   // Label 8728: @524967
     /*  524967 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(525038), // Rule ID 21046 //
     /*  524972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525004 */     // MIs[0] round
     /*  525004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  525017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525023 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525036 */     GIR_RootConstrainSelectedInstOperands,
     /*  525037 */     // GIR_Coverage, 21046,
     /*  525037 */     GIR_EraseRootFromParent_Done,
     /*  525038 */   // Label 8729: @525038
     /*  525038 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(525109), // Rule ID 21047 //
     /*  525043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  525054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  525057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  525060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525075 */     // MIs[0] round
     /*  525075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  525088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525094 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525107 */     GIR_RootConstrainSelectedInstOperands,
     /*  525108 */     // GIR_Coverage, 21047,
     /*  525108 */     GIR_EraseRootFromParent_Done,
     /*  525109 */   // Label 8730: @525109
     /*  525109 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(525180), // Rule ID 21050 //
     /*  525114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  525125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  525128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  525131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525146 */     // MIs[0] round
     /*  525146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  525159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525165 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525178 */     GIR_RootConstrainSelectedInstOperands,
     /*  525179 */     // GIR_Coverage, 21050,
     /*  525179 */     GIR_EraseRootFromParent_Done,
     /*  525180 */   // Label 8731: @525180
     /*  525180 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(525251), // Rule ID 21051 //
     /*  525185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  525193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  525196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  525199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  525202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525217 */     // MIs[0] round
     /*  525217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525227 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  525230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525236 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525249 */     GIR_RootConstrainSelectedInstOperands,
     /*  525250 */     // GIR_Coverage, 21051,
     /*  525250 */     GIR_EraseRootFromParent_Done,
     /*  525251 */   // Label 8732: @525251
     /*  525251 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(525322), // Rule ID 21054 //
     /*  525256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  525267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  525270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  525273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525288 */     // MIs[0] round
     /*  525288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525298 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  525301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525307 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525320 */     GIR_RootConstrainSelectedInstOperands,
     /*  525321 */     // GIR_Coverage, 21054,
     /*  525321 */     GIR_EraseRootFromParent_Done,
     /*  525322 */   // Label 8733: @525322
     /*  525322 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(525393), // Rule ID 21055 //
     /*  525327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  525338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  525341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  525344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525359 */     // MIs[0] round
     /*  525359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525369 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  525372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525378 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525391 */     GIR_RootConstrainSelectedInstOperands,
     /*  525392 */     // GIR_Coverage, 21055,
     /*  525392 */     GIR_EraseRootFromParent_Done,
     /*  525393 */   // Label 8734: @525393
     /*  525393 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(525464), // Rule ID 21058 //
     /*  525398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525430 */     // MIs[0] round
     /*  525430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525440 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525449 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525462 */     GIR_RootConstrainSelectedInstOperands,
     /*  525463 */     // GIR_Coverage, 21058,
     /*  525463 */     GIR_EraseRootFromParent_Done,
     /*  525464 */   // Label 8735: @525464
     /*  525464 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(525535), // Rule ID 21059 //
     /*  525469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525501 */     // MIs[0] round
     /*  525501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525511 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525520 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525533 */     GIR_RootConstrainSelectedInstOperands,
     /*  525534 */     // GIR_Coverage, 21059,
     /*  525534 */     GIR_EraseRootFromParent_Done,
     /*  525535 */   // Label 8736: @525535
     /*  525535 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(525606), // Rule ID 21062 //
     /*  525540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525572 */     // MIs[0] round
     /*  525572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525591 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525604 */     GIR_RootConstrainSelectedInstOperands,
     /*  525605 */     // GIR_Coverage, 21062,
     /*  525605 */     GIR_EraseRootFromParent_Done,
     /*  525606 */   // Label 8737: @525606
     /*  525606 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(525677), // Rule ID 21063 //
     /*  525611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525643 */     // MIs[0] round
     /*  525643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525653 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525662 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525675 */     GIR_RootConstrainSelectedInstOperands,
     /*  525676 */     // GIR_Coverage, 21063,
     /*  525676 */     GIR_EraseRootFromParent_Done,
     /*  525677 */   // Label 8738: @525677
     /*  525677 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(525748), // Rule ID 21066 //
     /*  525682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525714 */     // MIs[0] round
     /*  525714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525733 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525746 */     GIR_RootConstrainSelectedInstOperands,
     /*  525747 */     // GIR_Coverage, 21066,
     /*  525747 */     GIR_EraseRootFromParent_Done,
     /*  525748 */   // Label 8739: @525748
     /*  525748 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(525819), // Rule ID 21067 //
     /*  525753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525785 */     // MIs[0] round
     /*  525785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525795 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525804 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525817 */     GIR_RootConstrainSelectedInstOperands,
     /*  525818 */     // GIR_Coverage, 21067,
     /*  525818 */     GIR_EraseRootFromParent_Done,
     /*  525819 */   // Label 8740: @525819
     /*  525819 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(525890), // Rule ID 21070 //
     /*  525824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525856 */     // MIs[0] round
     /*  525856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525875 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525888 */     GIR_RootConstrainSelectedInstOperands,
     /*  525889 */     // GIR_Coverage, 21070,
     /*  525889 */     GIR_EraseRootFromParent_Done,
     /*  525890 */   // Label 8741: @525890
     /*  525890 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(525961), // Rule ID 21071 //
     /*  525895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525927 */     // MIs[0] round
     /*  525927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525937 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525946 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525959 */     GIR_RootConstrainSelectedInstOperands,
     /*  525960 */     // GIR_Coverage, 21071,
     /*  525960 */     GIR_EraseRootFromParent_Done,
     /*  525961 */   // Label 8742: @525961
     /*  525961 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(526032), // Rule ID 21074 //
     /*  525966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525998 */     // MIs[0] round
     /*  525998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  526011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526017 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526030 */     GIR_RootConstrainSelectedInstOperands,
     /*  526031 */     // GIR_Coverage, 21074,
     /*  526031 */     GIR_EraseRootFromParent_Done,
     /*  526032 */   // Label 8743: @526032
     /*  526032 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(526103), // Rule ID 21075 //
     /*  526037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  526048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  526051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  526054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526069 */     // MIs[0] round
     /*  526069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526079 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  526082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526088 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526101 */     GIR_RootConstrainSelectedInstOperands,
     /*  526102 */     // GIR_Coverage, 21075,
     /*  526102 */     GIR_EraseRootFromParent_Done,
     /*  526103 */   // Label 8744: @526103
     /*  526103 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(526174), // Rule ID 21078 //
     /*  526108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  526119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  526122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526140 */     // MIs[0] round
     /*  526140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526150 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  526153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526159 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526172 */     GIR_RootConstrainSelectedInstOperands,
     /*  526173 */     // GIR_Coverage, 21078,
     /*  526173 */     GIR_EraseRootFromParent_Done,
     /*  526174 */   // Label 8745: @526174
     /*  526174 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(526245), // Rule ID 21079 //
     /*  526179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  526190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  526193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526211 */     // MIs[0] round
     /*  526211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  526224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526230 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526243 */     GIR_RootConstrainSelectedInstOperands,
     /*  526244 */     // GIR_Coverage, 21079,
     /*  526244 */     GIR_EraseRootFromParent_Done,
     /*  526245 */   // Label 8746: @526245
     /*  526245 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(526316), // Rule ID 21082 //
     /*  526250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526282 */     // MIs[0] round
     /*  526282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526292 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  526295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526301 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526314 */     GIR_RootConstrainSelectedInstOperands,
     /*  526315 */     // GIR_Coverage, 21082,
     /*  526315 */     GIR_EraseRootFromParent_Done,
     /*  526316 */   // Label 8747: @526316
     /*  526316 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(526387), // Rule ID 21083 //
     /*  526321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  526332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  526335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526353 */     // MIs[0] round
     /*  526353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526363 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  526366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526372 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526385 */     GIR_RootConstrainSelectedInstOperands,
     /*  526386 */     // GIR_Coverage, 21083,
     /*  526386 */     GIR_EraseRootFromParent_Done,
     /*  526387 */   // Label 8748: @526387
     /*  526387 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(526458), // Rule ID 21086 //
     /*  526392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526424 */     // MIs[0] round
     /*  526424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526443 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526456 */     GIR_RootConstrainSelectedInstOperands,
     /*  526457 */     // GIR_Coverage, 21086,
     /*  526457 */     GIR_EraseRootFromParent_Done,
     /*  526458 */   // Label 8749: @526458
     /*  526458 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(526529), // Rule ID 21087 //
     /*  526463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526495 */     // MIs[0] round
     /*  526495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526514 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526527 */     GIR_RootConstrainSelectedInstOperands,
     /*  526528 */     // GIR_Coverage, 21087,
     /*  526528 */     GIR_EraseRootFromParent_Done,
     /*  526529 */   // Label 8750: @526529
     /*  526529 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(526600), // Rule ID 21090 //
     /*  526534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526566 */     // MIs[0] round
     /*  526566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526585 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526598 */     GIR_RootConstrainSelectedInstOperands,
     /*  526599 */     // GIR_Coverage, 21090,
     /*  526599 */     GIR_EraseRootFromParent_Done,
     /*  526600 */   // Label 8751: @526600
     /*  526600 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(526671), // Rule ID 21091 //
     /*  526605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526637 */     // MIs[0] round
     /*  526637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526656 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526669 */     GIR_RootConstrainSelectedInstOperands,
     /*  526670 */     // GIR_Coverage, 21091,
     /*  526670 */     GIR_EraseRootFromParent_Done,
     /*  526671 */   // Label 8752: @526671
     /*  526671 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(526742), // Rule ID 21094 //
     /*  526676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526708 */     // MIs[0] round
     /*  526708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526727 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526740 */     GIR_RootConstrainSelectedInstOperands,
     /*  526741 */     // GIR_Coverage, 21094,
     /*  526741 */     GIR_EraseRootFromParent_Done,
     /*  526742 */   // Label 8753: @526742
     /*  526742 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(526813), // Rule ID 21095 //
     /*  526747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526779 */     // MIs[0] round
     /*  526779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526789 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526798 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526811 */     GIR_RootConstrainSelectedInstOperands,
     /*  526812 */     // GIR_Coverage, 21095,
     /*  526812 */     GIR_EraseRootFromParent_Done,
     /*  526813 */   // Label 8754: @526813
     /*  526813 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(526884), // Rule ID 21098 //
     /*  526818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526850 */     // MIs[0] round
     /*  526850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526869 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526882 */     GIR_RootConstrainSelectedInstOperands,
     /*  526883 */     // GIR_Coverage, 21098,
     /*  526883 */     GIR_EraseRootFromParent_Done,
     /*  526884 */   // Label 8755: @526884
     /*  526884 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(526955), // Rule ID 21099 //
     /*  526889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526921 */     // MIs[0] round
     /*  526921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526931 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526940 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526953 */     GIR_RootConstrainSelectedInstOperands,
     /*  526954 */     // GIR_Coverage, 21099,
     /*  526954 */     GIR_EraseRootFromParent_Done,
     /*  526955 */   // Label 8756: @526955
     /*  526955 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(527026), // Rule ID 21102 //
     /*  526960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526992 */     // MIs[0] round
     /*  526992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527002 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  527005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527011 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527024 */     GIR_RootConstrainSelectedInstOperands,
     /*  527025 */     // GIR_Coverage, 21102,
     /*  527025 */     GIR_EraseRootFromParent_Done,
     /*  527026 */   // Label 8757: @527026
     /*  527026 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(527097), // Rule ID 21103 //
     /*  527031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  527048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527063 */     // MIs[0] round
     /*  527063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527073 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  527076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527082 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527095 */     GIR_RootConstrainSelectedInstOperands,
     /*  527096 */     // GIR_Coverage, 21103,
     /*  527096 */     GIR_EraseRootFromParent_Done,
     /*  527097 */   // Label 8758: @527097
     /*  527097 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(527168), // Rule ID 21106 //
     /*  527102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  527119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527134 */     // MIs[0] round
     /*  527134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  527147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527153 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527166 */     GIR_RootConstrainSelectedInstOperands,
     /*  527167 */     // GIR_Coverage, 21106,
     /*  527167 */     GIR_EraseRootFromParent_Done,
     /*  527168 */   // Label 8759: @527168
     /*  527168 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(527239), // Rule ID 21107 //
     /*  527173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  527190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527205 */     // MIs[0] round
     /*  527205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527215 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  527218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527224 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527237 */     GIR_RootConstrainSelectedInstOperands,
     /*  527238 */     // GIR_Coverage, 21107,
     /*  527238 */     GIR_EraseRootFromParent_Done,
     /*  527239 */   // Label 8760: @527239
     /*  527239 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(527310), // Rule ID 21110 //
     /*  527244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527276 */     // MIs[0] round
     /*  527276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  527289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527295 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527308 */     GIR_RootConstrainSelectedInstOperands,
     /*  527309 */     // GIR_Coverage, 21110,
     /*  527309 */     GIR_EraseRootFromParent_Done,
     /*  527310 */   // Label 8761: @527310
     /*  527310 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(527381), // Rule ID 21111 //
     /*  527315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  527323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  527332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527347 */     // MIs[0] round
     /*  527347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  527360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527366 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527379 */     GIR_RootConstrainSelectedInstOperands,
     /*  527380 */     // GIR_Coverage, 21111,
     /*  527380 */     GIR_EraseRootFromParent_Done,
     /*  527381 */   // Label 8762: @527381
     /*  527381 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(527452), // Rule ID 21186 //
     /*  527386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527418 */     // MIs[0] round
     /*  527418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527437 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527450 */     GIR_RootConstrainSelectedInstOperands,
     /*  527451 */     // GIR_Coverage, 21186,
     /*  527451 */     GIR_EraseRootFromParent_Done,
     /*  527452 */   // Label 8763: @527452
     /*  527452 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(527523), // Rule ID 21187 //
     /*  527457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527489 */     // MIs[0] round
     /*  527489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527508 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527521 */     GIR_RootConstrainSelectedInstOperands,
     /*  527522 */     // GIR_Coverage, 21187,
     /*  527522 */     GIR_EraseRootFromParent_Done,
     /*  527523 */   // Label 8764: @527523
     /*  527523 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(527594), // Rule ID 21190 //
     /*  527528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527560 */     // MIs[0] round
     /*  527560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527579 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527592 */     GIR_RootConstrainSelectedInstOperands,
     /*  527593 */     // GIR_Coverage, 21190,
     /*  527593 */     GIR_EraseRootFromParent_Done,
     /*  527594 */   // Label 8765: @527594
     /*  527594 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(527665), // Rule ID 21191 //
     /*  527599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527631 */     // MIs[0] round
     /*  527631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527650 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527663 */     GIR_RootConstrainSelectedInstOperands,
     /*  527664 */     // GIR_Coverage, 21191,
     /*  527664 */     GIR_EraseRootFromParent_Done,
     /*  527665 */   // Label 8766: @527665
     /*  527665 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(527736), // Rule ID 21194 //
     /*  527670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527702 */     // MIs[0] round
     /*  527702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527721 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527734 */     GIR_RootConstrainSelectedInstOperands,
     /*  527735 */     // GIR_Coverage, 21194,
     /*  527735 */     GIR_EraseRootFromParent_Done,
     /*  527736 */   // Label 8767: @527736
     /*  527736 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(527807), // Rule ID 21195 //
     /*  527741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527773 */     // MIs[0] round
     /*  527773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527792 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527805 */     GIR_RootConstrainSelectedInstOperands,
     /*  527806 */     // GIR_Coverage, 21195,
     /*  527806 */     GIR_EraseRootFromParent_Done,
     /*  527807 */   // Label 8768: @527807
     /*  527807 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(527878), // Rule ID 21198 //
     /*  527812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527844 */     // MIs[0] round
     /*  527844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527863 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527876 */     GIR_RootConstrainSelectedInstOperands,
     /*  527877 */     // GIR_Coverage, 21198,
     /*  527877 */     GIR_EraseRootFromParent_Done,
     /*  527878 */   // Label 8769: @527878
     /*  527878 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(527949), // Rule ID 21199 //
     /*  527883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527915 */     // MIs[0] round
     /*  527915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527925 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527934 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527947 */     GIR_RootConstrainSelectedInstOperands,
     /*  527948 */     // GIR_Coverage, 21199,
     /*  527948 */     GIR_EraseRootFromParent_Done,
     /*  527949 */   // Label 8770: @527949
     /*  527949 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(528020), // Rule ID 21202 //
     /*  527954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527986 */     // MIs[0] round
     /*  527986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528005 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528018 */     GIR_RootConstrainSelectedInstOperands,
     /*  528019 */     // GIR_Coverage, 21202,
     /*  528019 */     GIR_EraseRootFromParent_Done,
     /*  528020 */   // Label 8771: @528020
     /*  528020 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(528091), // Rule ID 21203 //
     /*  528025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528057 */     // MIs[0] round
     /*  528057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528067 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528076 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528089 */     GIR_RootConstrainSelectedInstOperands,
     /*  528090 */     // GIR_Coverage, 21203,
     /*  528090 */     GIR_EraseRootFromParent_Done,
     /*  528091 */   // Label 8772: @528091
     /*  528091 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(528162), // Rule ID 21206 //
     /*  528096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528128 */     // MIs[0] round
     /*  528128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  528141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528147 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528160 */     GIR_RootConstrainSelectedInstOperands,
     /*  528161 */     // GIR_Coverage, 21206,
     /*  528161 */     GIR_EraseRootFromParent_Done,
     /*  528162 */   // Label 8773: @528162
     /*  528162 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(528233), // Rule ID 21207 //
     /*  528167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528199 */     // MIs[0] round
     /*  528199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  528212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528218 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528231 */     GIR_RootConstrainSelectedInstOperands,
     /*  528232 */     // GIR_Coverage, 21207,
     /*  528232 */     GIR_EraseRootFromParent_Done,
     /*  528233 */   // Label 8774: @528233
     /*  528233 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(528304), // Rule ID 21210 //
     /*  528238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528270 */     // MIs[0] round
     /*  528270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  528283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528289 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528302 */     GIR_RootConstrainSelectedInstOperands,
     /*  528303 */     // GIR_Coverage, 21210,
     /*  528303 */     GIR_EraseRootFromParent_Done,
     /*  528304 */   // Label 8775: @528304
     /*  528304 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(528375), // Rule ID 21211 //
     /*  528309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528341 */     // MIs[0] round
     /*  528341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  528354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528360 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528373 */     GIR_RootConstrainSelectedInstOperands,
     /*  528374 */     // GIR_Coverage, 21211,
     /*  528374 */     GIR_EraseRootFromParent_Done,
     /*  528375 */   // Label 8776: @528375
     /*  528375 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(528446), // Rule ID 21214 //
     /*  528380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528412 */     // MIs[0] round
     /*  528412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528431 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528444 */     GIR_RootConstrainSelectedInstOperands,
     /*  528445 */     // GIR_Coverage, 21214,
     /*  528445 */     GIR_EraseRootFromParent_Done,
     /*  528446 */   // Label 8777: @528446
     /*  528446 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(528517), // Rule ID 21215 //
     /*  528451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528483 */     // MIs[0] round
     /*  528483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528502 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528515 */     GIR_RootConstrainSelectedInstOperands,
     /*  528516 */     // GIR_Coverage, 21215,
     /*  528516 */     GIR_EraseRootFromParent_Done,
     /*  528517 */   // Label 8778: @528517
     /*  528517 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(528588), // Rule ID 21218 //
     /*  528522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528554 */     // MIs[0] round
     /*  528554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528573 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528586 */     GIR_RootConstrainSelectedInstOperands,
     /*  528587 */     // GIR_Coverage, 21218,
     /*  528587 */     GIR_EraseRootFromParent_Done,
     /*  528588 */   // Label 8779: @528588
     /*  528588 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(528659), // Rule ID 21219 //
     /*  528593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528625 */     // MIs[0] round
     /*  528625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528635 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528644 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528657 */     GIR_RootConstrainSelectedInstOperands,
     /*  528658 */     // GIR_Coverage, 21219,
     /*  528658 */     GIR_EraseRootFromParent_Done,
     /*  528659 */   // Label 8780: @528659
     /*  528659 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(528730), // Rule ID 21222 //
     /*  528664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528696 */     // MIs[0] round
     /*  528696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528715 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528728 */     GIR_RootConstrainSelectedInstOperands,
     /*  528729 */     // GIR_Coverage, 21222,
     /*  528729 */     GIR_EraseRootFromParent_Done,
     /*  528730 */   // Label 8781: @528730
     /*  528730 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(528801), // Rule ID 21223 //
     /*  528735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528767 */     // MIs[0] round
     /*  528767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528786 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528799 */     GIR_RootConstrainSelectedInstOperands,
     /*  528800 */     // GIR_Coverage, 21223,
     /*  528800 */     GIR_EraseRootFromParent_Done,
     /*  528801 */   // Label 8782: @528801
     /*  528801 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(528872), // Rule ID 21226 //
     /*  528806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528838 */     // MIs[0] round
     /*  528838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528848 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528857 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528870 */     GIR_RootConstrainSelectedInstOperands,
     /*  528871 */     // GIR_Coverage, 21226,
     /*  528871 */     GIR_EraseRootFromParent_Done,
     /*  528872 */   // Label 8783: @528872
     /*  528872 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(528943), // Rule ID 21227 //
     /*  528877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528909 */     // MIs[0] round
     /*  528909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528928 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528941 */     GIR_RootConstrainSelectedInstOperands,
     /*  528942 */     // GIR_Coverage, 21227,
     /*  528942 */     GIR_EraseRootFromParent_Done,
     /*  528943 */   // Label 8784: @528943
     /*  528943 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(529014), // Rule ID 21230 //
     /*  528948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528980 */     // MIs[0] round
     /*  528980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528999 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529012 */     GIR_RootConstrainSelectedInstOperands,
     /*  529013 */     // GIR_Coverage, 21230,
     /*  529013 */     GIR_EraseRootFromParent_Done,
     /*  529014 */   // Label 8785: @529014
     /*  529014 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(529085), // Rule ID 21231 //
     /*  529019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529051 */     // MIs[0] round
     /*  529051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529070 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529083 */     GIR_RootConstrainSelectedInstOperands,
     /*  529084 */     // GIR_Coverage, 21231,
     /*  529084 */     GIR_EraseRootFromParent_Done,
     /*  529085 */   // Label 8786: @529085
     /*  529085 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(529156), // Rule ID 21234 //
     /*  529090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529122 */     // MIs[0] round
     /*  529122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529141 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529154 */     GIR_RootConstrainSelectedInstOperands,
     /*  529155 */     // GIR_Coverage, 21234,
     /*  529155 */     GIR_EraseRootFromParent_Done,
     /*  529156 */   // Label 8787: @529156
     /*  529156 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(529227), // Rule ID 21235 //
     /*  529161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  529172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  529175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529193 */     // MIs[0] round
     /*  529193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529212 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529225 */     GIR_RootConstrainSelectedInstOperands,
     /*  529226 */     // GIR_Coverage, 21235,
     /*  529226 */     GIR_EraseRootFromParent_Done,
     /*  529227 */   // Label 8788: @529227
     /*  529227 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(529298), // Rule ID 21238 //
     /*  529232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  529246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529264 */     // MIs[0] round
     /*  529264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529283 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529296 */     GIR_RootConstrainSelectedInstOperands,
     /*  529297 */     // GIR_Coverage, 21238,
     /*  529297 */     GIR_EraseRootFromParent_Done,
     /*  529298 */   // Label 8789: @529298
     /*  529298 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(529369), // Rule ID 21239 //
     /*  529303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  529314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  529317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529335 */     // MIs[0] round
     /*  529335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529345 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529354 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529367 */     GIR_RootConstrainSelectedInstOperands,
     /*  529368 */     // GIR_Coverage, 21239,
     /*  529368 */     GIR_EraseRootFromParent_Done,
     /*  529369 */   // Label 8790: @529369
     /*  529369 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(529440), // Rule ID 21242 //
     /*  529374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529406 */     // MIs[0] round
     /*  529406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529425 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529438 */     GIR_RootConstrainSelectedInstOperands,
     /*  529439 */     // GIR_Coverage, 21242,
     /*  529439 */     GIR_EraseRootFromParent_Done,
     /*  529440 */   // Label 8791: @529440
     /*  529440 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(529511), // Rule ID 21243 //
     /*  529445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529477 */     // MIs[0] round
     /*  529477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529487 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529496 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529509 */     GIR_RootConstrainSelectedInstOperands,
     /*  529510 */     // GIR_Coverage, 21243,
     /*  529510 */     GIR_EraseRootFromParent_Done,
     /*  529511 */   // Label 8792: @529511
     /*  529511 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(529582), // Rule ID 21246 //
     /*  529516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529548 */     // MIs[0] round
     /*  529548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529567 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529580 */     GIR_RootConstrainSelectedInstOperands,
     /*  529581 */     // GIR_Coverage, 21246,
     /*  529581 */     GIR_EraseRootFromParent_Done,
     /*  529582 */   // Label 8793: @529582
     /*  529582 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(529653), // Rule ID 21247 //
     /*  529587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529619 */     // MIs[0] round
     /*  529619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529638 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529651 */     GIR_RootConstrainSelectedInstOperands,
     /*  529652 */     // GIR_Coverage, 21247,
     /*  529652 */     GIR_EraseRootFromParent_Done,
     /*  529653 */   // Label 8794: @529653
     /*  529653 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(529724), // Rule ID 21250 //
     /*  529658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529690 */     // MIs[0] round
     /*  529690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529700 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529709 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529722 */     GIR_RootConstrainSelectedInstOperands,
     /*  529723 */     // GIR_Coverage, 21250,
     /*  529723 */     GIR_EraseRootFromParent_Done,
     /*  529724 */   // Label 8795: @529724
     /*  529724 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(529795), // Rule ID 21251 //
     /*  529729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529761 */     // MIs[0] round
     /*  529761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529771 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529780 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529793 */     GIR_RootConstrainSelectedInstOperands,
     /*  529794 */     // GIR_Coverage, 21251,
     /*  529794 */     GIR_EraseRootFromParent_Done,
     /*  529795 */   // Label 8796: @529795
     /*  529795 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(529866), // Rule ID 21254 //
     /*  529800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529832 */     // MIs[0] round
     /*  529832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529842 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529851 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529864 */     GIR_RootConstrainSelectedInstOperands,
     /*  529865 */     // GIR_Coverage, 21254,
     /*  529865 */     GIR_EraseRootFromParent_Done,
     /*  529866 */   // Label 8797: @529866
     /*  529866 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(529937), // Rule ID 21255 //
     /*  529871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529903 */     // MIs[0] round
     /*  529903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529913 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529922 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529935 */     GIR_RootConstrainSelectedInstOperands,
     /*  529936 */     // GIR_Coverage, 21255,
     /*  529936 */     GIR_EraseRootFromParent_Done,
     /*  529937 */   // Label 8798: @529937
     /*  529937 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(530008), // Rule ID 21606 //
     /*  529942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529974 */     // MIs[0] round
     /*  529974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529993 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530006 */     GIR_RootConstrainSelectedInstOperands,
     /*  530007 */     // GIR_Coverage, 21606,
     /*  530007 */     GIR_EraseRootFromParent_Done,
     /*  530008 */   // Label 8799: @530008
     /*  530008 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(530079), // Rule ID 21607 //
     /*  530013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  530024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  530027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530045 */     // MIs[0] round
     /*  530045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530055 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  530058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530064 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530077 */     GIR_RootConstrainSelectedInstOperands,
     /*  530078 */     // GIR_Coverage, 21607,
     /*  530078 */     GIR_EraseRootFromParent_Done,
     /*  530079 */   // Label 8800: @530079
     /*  530079 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(530150), // Rule ID 21610 //
     /*  530084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530116 */     // MIs[0] round
     /*  530116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530135 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530148 */     GIR_RootConstrainSelectedInstOperands,
     /*  530149 */     // GIR_Coverage, 21610,
     /*  530149 */     GIR_EraseRootFromParent_Done,
     /*  530150 */   // Label 8801: @530150
     /*  530150 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(530221), // Rule ID 21611 //
     /*  530155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  530166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  530169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530187 */     // MIs[0] round
     /*  530187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530197 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530206 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530219 */     GIR_RootConstrainSelectedInstOperands,
     /*  530220 */     // GIR_Coverage, 21611,
     /*  530220 */     GIR_EraseRootFromParent_Done,
     /*  530221 */   // Label 8802: @530221
     /*  530221 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(530292), // Rule ID 21614 //
     /*  530226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  530243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530258 */     // MIs[0] round
     /*  530258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530277 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530290 */     GIR_RootConstrainSelectedInstOperands,
     /*  530291 */     // GIR_Coverage, 21614,
     /*  530291 */     GIR_EraseRootFromParent_Done,
     /*  530292 */   // Label 8803: @530292
     /*  530292 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(530363), // Rule ID 21615 //
     /*  530297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  530308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  530311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  530314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530329 */     // MIs[0] round
     /*  530329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530339 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530348 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530361 */     GIR_RootConstrainSelectedInstOperands,
     /*  530362 */     // GIR_Coverage, 21615,
     /*  530362 */     GIR_EraseRootFromParent_Done,
     /*  530363 */   // Label 8804: @530363
     /*  530363 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(530434), // Rule ID 21618 //
     /*  530368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  530379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  530382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  530385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530400 */     // MIs[0] round
     /*  530400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530419 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530432 */     GIR_RootConstrainSelectedInstOperands,
     /*  530433 */     // GIR_Coverage, 21618,
     /*  530433 */     GIR_EraseRootFromParent_Done,
     /*  530434 */   // Label 8805: @530434
     /*  530434 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(530505), // Rule ID 21619 //
     /*  530439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  530450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  530453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  530456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530471 */     // MIs[0] round
     /*  530471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530481 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11293:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530490 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530503 */     GIR_RootConstrainSelectedInstOperands,
     /*  530504 */     // GIR_Coverage, 21619,
     /*  530504 */     GIR_EraseRootFromParent_Done,
     /*  530505 */   // Label 8806: @530505
     /*  530505 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(530576), // Rule ID 21622 //
     /*  530510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530542 */     // MIs[0] round
     /*  530542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530561 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530574 */     GIR_RootConstrainSelectedInstOperands,
     /*  530575 */     // GIR_Coverage, 21622,
     /*  530575 */     GIR_EraseRootFromParent_Done,
     /*  530576 */   // Label 8807: @530576
     /*  530576 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(530647), // Rule ID 21623 //
     /*  530581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530613 */     // MIs[0] round
     /*  530613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530623 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530632 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530645 */     GIR_RootConstrainSelectedInstOperands,
     /*  530646 */     // GIR_Coverage, 21623,
     /*  530646 */     GIR_EraseRootFromParent_Done,
     /*  530647 */   // Label 8808: @530647
     /*  530647 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(530718), // Rule ID 21626 //
     /*  530652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530684 */     // MIs[0] round
     /*  530684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530703 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530716 */     GIR_RootConstrainSelectedInstOperands,
     /*  530717 */     // GIR_Coverage, 21626,
     /*  530717 */     GIR_EraseRootFromParent_Done,
     /*  530718 */   // Label 8809: @530718
     /*  530718 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(530789), // Rule ID 21627 //
     /*  530723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530755 */     // MIs[0] round
     /*  530755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530765 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530774 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530787 */     GIR_RootConstrainSelectedInstOperands,
     /*  530788 */     // GIR_Coverage, 21627,
     /*  530788 */     GIR_EraseRootFromParent_Done,
     /*  530789 */   // Label 8810: @530789
     /*  530789 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(530860), // Rule ID 21630 //
     /*  530794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530826 */     // MIs[0] round
     /*  530826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530845 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530858 */     GIR_RootConstrainSelectedInstOperands,
     /*  530859 */     // GIR_Coverage, 21630,
     /*  530859 */     GIR_EraseRootFromParent_Done,
     /*  530860 */   // Label 8811: @530860
     /*  530860 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(530931), // Rule ID 21631 //
     /*  530865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530897 */     // MIs[0] round
     /*  530897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530907 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530916 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530929 */     GIR_RootConstrainSelectedInstOperands,
     /*  530930 */     // GIR_Coverage, 21631,
     /*  530930 */     GIR_EraseRootFromParent_Done,
     /*  530931 */   // Label 8812: @530931
     /*  530931 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(531002), // Rule ID 21634 //
     /*  530936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530968 */     // MIs[0] round
     /*  530968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530978 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530987 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531000 */     GIR_RootConstrainSelectedInstOperands,
     /*  531001 */     // GIR_Coverage, 21634,
     /*  531001 */     GIR_EraseRootFromParent_Done,
     /*  531002 */   // Label 8813: @531002
     /*  531002 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(531073), // Rule ID 21635 //
     /*  531007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  531018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  531021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531039 */     // MIs[0] round
     /*  531039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531049 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531058 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531071 */     GIR_RootConstrainSelectedInstOperands,
     /*  531072 */     // GIR_Coverage, 21635,
     /*  531072 */     GIR_EraseRootFromParent_Done,
     /*  531073 */   // Label 8814: @531073
     /*  531073 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(531144), // Rule ID 21638 //
     /*  531078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531110 */     // MIs[0] round
     /*  531110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531129 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531142 */     GIR_RootConstrainSelectedInstOperands,
     /*  531143 */     // GIR_Coverage, 21638,
     /*  531143 */     GIR_EraseRootFromParent_Done,
     /*  531144 */   // Label 8815: @531144
     /*  531144 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(531215), // Rule ID 21639 //
     /*  531149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  531160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  531163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531181 */     // MIs[0] round
     /*  531181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531191 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11293:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531200 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531213 */     GIR_RootConstrainSelectedInstOperands,
     /*  531214 */     // GIR_Coverage, 21639,
     /*  531214 */     GIR_EraseRootFromParent_Done,
     /*  531215 */   // Label 8816: @531215
     /*  531215 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(531286), // Rule ID 21642 //
     /*  531220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  531231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  531234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531252 */     // MIs[0] round
     /*  531252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531271 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531284 */     GIR_RootConstrainSelectedInstOperands,
     /*  531285 */     // GIR_Coverage, 21642,
     /*  531285 */     GIR_EraseRootFromParent_Done,
     /*  531286 */   // Label 8817: @531286
     /*  531286 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(531357), // Rule ID 21643 //
     /*  531291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  531302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  531305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531323 */     // MIs[0] round
     /*  531323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531342 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531355 */     GIR_RootConstrainSelectedInstOperands,
     /*  531356 */     // GIR_Coverage, 21643,
     /*  531356 */     GIR_EraseRootFromParent_Done,
     /*  531357 */   // Label 8818: @531357
     /*  531357 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(531428), // Rule ID 21646 //
     /*  531362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  531373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  531376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  531379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531394 */     // MIs[0] round
     /*  531394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531413 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531426 */     GIR_RootConstrainSelectedInstOperands,
     /*  531427 */     // GIR_Coverage, 21646,
     /*  531427 */     GIR_EraseRootFromParent_Done,
     /*  531428 */   // Label 8819: @531428
     /*  531428 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(531499), // Rule ID 21647 //
     /*  531433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  531436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  531444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  531447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  531450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531465 */     // MIs[0] round
     /*  531465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531484 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531497 */     GIR_RootConstrainSelectedInstOperands,
     /*  531498 */     // GIR_Coverage, 21647,
     /*  531498 */     GIR_EraseRootFromParent_Done,
     /*  531499 */   // Label 8820: @531499
     /*  531499 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(531570), // Rule ID 21650 //
     /*  531504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531536 */     // MIs[0] round
     /*  531536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531555 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531568 */     GIR_RootConstrainSelectedInstOperands,
     /*  531569 */     // GIR_Coverage, 21650,
     /*  531569 */     GIR_EraseRootFromParent_Done,
     /*  531570 */   // Label 8821: @531570
     /*  531570 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(531641), // Rule ID 21651 //
     /*  531575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531607 */     // MIs[0] round
     /*  531607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531626 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531639 */     GIR_RootConstrainSelectedInstOperands,
     /*  531640 */     // GIR_Coverage, 21651,
     /*  531640 */     GIR_EraseRootFromParent_Done,
     /*  531641 */   // Label 8822: @531641
     /*  531641 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(531712), // Rule ID 21654 //
     /*  531646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531678 */     // MIs[0] round
     /*  531678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531697 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531710 */     GIR_RootConstrainSelectedInstOperands,
     /*  531711 */     // GIR_Coverage, 21654,
     /*  531711 */     GIR_EraseRootFromParent_Done,
     /*  531712 */   // Label 8823: @531712
     /*  531712 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(531783), // Rule ID 21655 //
     /*  531717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531749 */     // MIs[0] round
     /*  531749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531759 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531768 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531781 */     GIR_RootConstrainSelectedInstOperands,
     /*  531782 */     // GIR_Coverage, 21655,
     /*  531782 */     GIR_EraseRootFromParent_Done,
     /*  531783 */   // Label 8824: @531783
     /*  531783 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(531854), // Rule ID 21658 //
     /*  531788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531820 */     // MIs[0] round
     /*  531820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531839 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531852 */     GIR_RootConstrainSelectedInstOperands,
     /*  531853 */     // GIR_Coverage, 21658,
     /*  531853 */     GIR_EraseRootFromParent_Done,
     /*  531854 */   // Label 8825: @531854
     /*  531854 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(531925), // Rule ID 21659 //
     /*  531859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531891 */     // MIs[0] round
     /*  531891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531910 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531923 */     GIR_RootConstrainSelectedInstOperands,
     /*  531924 */     // GIR_Coverage, 21659,
     /*  531924 */     GIR_EraseRootFromParent_Done,
     /*  531925 */   // Label 8826: @531925
     /*  531925 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(531996), // Rule ID 21662 //
     /*  531930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531962 */     // MIs[0] round
     /*  531962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531981 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531994 */     GIR_RootConstrainSelectedInstOperands,
     /*  531995 */     // GIR_Coverage, 21662,
     /*  531995 */     GIR_EraseRootFromParent_Done,
     /*  531996 */   // Label 8827: @531996
     /*  531996 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(532067), // Rule ID 21663 //
     /*  532001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  532004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  532009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  532018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532033 */     // MIs[0] round
     /*  532033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  532046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532052 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532065 */     GIR_RootConstrainSelectedInstOperands,
     /*  532066 */     // GIR_Coverage, 21663,
     /*  532066 */     GIR_EraseRootFromParent_Done,
     /*  532067 */   // Label 8828: @532067
     /*  532067 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(532138), // Rule ID 21666 //
     /*  532072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  532083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  532086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532104 */     // MIs[0] round
     /*  532104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  532117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532123 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532136 */     GIR_RootConstrainSelectedInstOperands,
     /*  532137 */     // GIR_Coverage, 21666,
     /*  532137 */     GIR_EraseRootFromParent_Done,
     /*  532138 */   // Label 8829: @532138
     /*  532138 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(532209), // Rule ID 21667 //
     /*  532143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  532154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  532157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532175 */     // MIs[0] round
     /*  532175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532185 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  532188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532194 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532207 */     GIR_RootConstrainSelectedInstOperands,
     /*  532208 */     // GIR_Coverage, 21667,
     /*  532208 */     GIR_EraseRootFromParent_Done,
     /*  532209 */   // Label 8830: @532209
     /*  532209 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(532280), // Rule ID 21670 //
     /*  532214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  532225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  532228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532246 */     // MIs[0] round
     /*  532246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532256 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532265 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532278 */     GIR_RootConstrainSelectedInstOperands,
     /*  532279 */     // GIR_Coverage, 21670,
     /*  532279 */     GIR_EraseRootFromParent_Done,
     /*  532280 */   // Label 8831: @532280
     /*  532280 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(532351), // Rule ID 21671 //
     /*  532285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  532296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  532299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532317 */     // MIs[0] round
     /*  532317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532327 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532336 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532349 */     GIR_RootConstrainSelectedInstOperands,
     /*  532350 */     // GIR_Coverage, 21671,
     /*  532350 */     GIR_EraseRootFromParent_Done,
     /*  532351 */   // Label 8832: @532351
     /*  532351 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(532422), // Rule ID 21674 //
     /*  532356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  532367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  532370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532388 */     // MIs[0] round
     /*  532388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532407 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532420 */     GIR_RootConstrainSelectedInstOperands,
     /*  532421 */     // GIR_Coverage, 21674,
     /*  532421 */     GIR_EraseRootFromParent_Done,
     /*  532422 */   // Label 8833: @532422
     /*  532422 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(532493), // Rule ID 21675 //
     /*  532427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  532438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  532441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532459 */     // MIs[0] round
     /*  532459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532478 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532491 */     GIR_RootConstrainSelectedInstOperands,
     /*  532492 */     // GIR_Coverage, 21675,
     /*  532492 */     GIR_EraseRootFromParent_Done,
     /*  532493 */   // Label 8834: @532493
     /*  532493 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(532564), // Rule ID 21678 //
     /*  532498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532530 */     // MIs[0] round
     /*  532530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532549 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532562 */     GIR_RootConstrainSelectedInstOperands,
     /*  532563 */     // GIR_Coverage, 21678,
     /*  532563 */     GIR_EraseRootFromParent_Done,
     /*  532564 */   // Label 8835: @532564
     /*  532564 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(532635), // Rule ID 21679 //
     /*  532569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532601 */     // MIs[0] round
     /*  532601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532611 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11291:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532620 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532633 */     GIR_RootConstrainSelectedInstOperands,
     /*  532634 */     // GIR_Coverage, 21679,
     /*  532634 */     GIR_EraseRootFromParent_Done,
     /*  532635 */   // Label 8836: @532635
     /*  532635 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(532706), // Rule ID 21682 //
     /*  532640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532672 */     // MIs[0] round
     /*  532672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532691 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532704 */     GIR_RootConstrainSelectedInstOperands,
     /*  532705 */     // GIR_Coverage, 21682,
     /*  532705 */     GIR_EraseRootFromParent_Done,
     /*  532706 */   // Label 8837: @532706
     /*  532706 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(532777), // Rule ID 21683 //
     /*  532711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532743 */     // MIs[0] round
     /*  532743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532753 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532762 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532775 */     GIR_RootConstrainSelectedInstOperands,
     /*  532776 */     // GIR_Coverage, 21683,
     /*  532776 */     GIR_EraseRootFromParent_Done,
     /*  532777 */   // Label 8838: @532777
     /*  532777 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(532848), // Rule ID 21686 //
     /*  532782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532814 */     // MIs[0] round
     /*  532814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532833 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532846 */     GIR_RootConstrainSelectedInstOperands,
     /*  532847 */     // GIR_Coverage, 21686,
     /*  532847 */     GIR_EraseRootFromParent_Done,
     /*  532848 */   // Label 8839: @532848
     /*  532848 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(532919), // Rule ID 21687 //
     /*  532853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532885 */     // MIs[0] round
     /*  532885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532895 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532904 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532917 */     GIR_RootConstrainSelectedInstOperands,
     /*  532918 */     // GIR_Coverage, 21687,
     /*  532918 */     GIR_EraseRootFromParent_Done,
     /*  532919 */   // Label 8840: @532919
     /*  532919 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(532990), // Rule ID 21690 //
     /*  532924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532956 */     // MIs[0] round
     /*  532956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532975 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532988 */     GIR_RootConstrainSelectedInstOperands,
     /*  532989 */     // GIR_Coverage, 21690,
     /*  532989 */     GIR_EraseRootFromParent_Done,
     /*  532990 */   // Label 8841: @532990
     /*  532990 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(533061), // Rule ID 21691 //
     /*  532995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533027 */     // MIs[0] round
     /*  533027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533037 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  533040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533046 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533059 */     GIR_RootConstrainSelectedInstOperands,
     /*  533060 */     // GIR_Coverage, 21691,
     /*  533060 */     GIR_EraseRootFromParent_Done,
     /*  533061 */   // Label 8842: @533061
     /*  533061 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(533132), // Rule ID 21694 //
     /*  533066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533098 */     // MIs[0] round
     /*  533098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533117 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533130 */     GIR_RootConstrainSelectedInstOperands,
     /*  533131 */     // GIR_Coverage, 21694,
     /*  533131 */     GIR_EraseRootFromParent_Done,
     /*  533132 */   // Label 8843: @533132
     /*  533132 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(533203), // Rule ID 21695 //
     /*  533137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533169 */     // MIs[0] round
     /*  533169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533179 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533188 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533201 */     GIR_RootConstrainSelectedInstOperands,
     /*  533202 */     // GIR_Coverage, 21695,
     /*  533202 */     GIR_EraseRootFromParent_Done,
     /*  533203 */   // Label 8844: @533203
     /*  533203 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(533274), // Rule ID 21698 //
     /*  533208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533240 */     // MIs[0] round
     /*  533240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533259 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533272 */     GIR_RootConstrainSelectedInstOperands,
     /*  533273 */     // GIR_Coverage, 21698,
     /*  533273 */     GIR_EraseRootFromParent_Done,
     /*  533274 */   // Label 8845: @533274
     /*  533274 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(533345), // Rule ID 21699 //
     /*  533279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533311 */     // MIs[0] round
     /*  533311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11291:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533330 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533343 */     GIR_RootConstrainSelectedInstOperands,
     /*  533344 */     // GIR_Coverage, 21699,
     /*  533344 */     GIR_EraseRootFromParent_Done,
     /*  533345 */   // Label 8846: @533345
     /*  533345 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(533416), // Rule ID 21702 //
     /*  533350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533382 */     // MIs[0] round
     /*  533382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533401 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533414 */     GIR_RootConstrainSelectedInstOperands,
     /*  533415 */     // GIR_Coverage, 21702,
     /*  533415 */     GIR_EraseRootFromParent_Done,
     /*  533416 */   // Label 8847: @533416
     /*  533416 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(533487), // Rule ID 21703 //
     /*  533421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533453 */     // MIs[0] round
     /*  533453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533472 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533485 */     GIR_RootConstrainSelectedInstOperands,
     /*  533486 */     // GIR_Coverage, 21703,
     /*  533486 */     GIR_EraseRootFromParent_Done,
     /*  533487 */   // Label 8848: @533487
     /*  533487 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(533558), // Rule ID 21706 //
     /*  533492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533524 */     // MIs[0] round
     /*  533524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533543 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533556 */     GIR_RootConstrainSelectedInstOperands,
     /*  533557 */     // GIR_Coverage, 21706,
     /*  533557 */     GIR_EraseRootFromParent_Done,
     /*  533558 */   // Label 8849: @533558
     /*  533558 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(533629), // Rule ID 21707 //
     /*  533563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533595 */     // MIs[0] round
     /*  533595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533605 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533614 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533627 */     GIR_RootConstrainSelectedInstOperands,
     /*  533628 */     // GIR_Coverage, 21707,
     /*  533628 */     GIR_EraseRootFromParent_Done,
     /*  533629 */   // Label 8850: @533629
     /*  533629 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(533700), // Rule ID 21710 //
     /*  533634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533666 */     // MIs[0] round
     /*  533666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533685 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533698 */     GIR_RootConstrainSelectedInstOperands,
     /*  533699 */     // GIR_Coverage, 21710,
     /*  533699 */     GIR_EraseRootFromParent_Done,
     /*  533700 */   // Label 8851: @533700
     /*  533700 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(533771), // Rule ID 21711 //
     /*  533705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533737 */     // MIs[0] round
     /*  533737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533747 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533756 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533769 */     GIR_RootConstrainSelectedInstOperands,
     /*  533770 */     // GIR_Coverage, 21711,
     /*  533770 */     GIR_EraseRootFromParent_Done,
     /*  533771 */   // Label 8852: @533771
     /*  533771 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(533842), // Rule ID 21714 //
     /*  533776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533808 */     // MIs[0] round
     /*  533808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533827 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533840 */     GIR_RootConstrainSelectedInstOperands,
     /*  533841 */     // GIR_Coverage, 21714,
     /*  533841 */     GIR_EraseRootFromParent_Done,
     /*  533842 */   // Label 8853: @533842
     /*  533842 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(533913), // Rule ID 21715 //
     /*  533847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533879 */     // MIs[0] round
     /*  533879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533889 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533898 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533911 */     GIR_RootConstrainSelectedInstOperands,
     /*  533912 */     // GIR_Coverage, 21715,
     /*  533912 */     GIR_EraseRootFromParent_Done,
     /*  533913 */   // Label 8854: @533913
     /*  533913 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(533984), // Rule ID 21718 //
     /*  533918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533950 */     // MIs[0] round
     /*  533950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533969 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533982 */     GIR_RootConstrainSelectedInstOperands,
     /*  533983 */     // GIR_Coverage, 21718,
     /*  533983 */     GIR_EraseRootFromParent_Done,
     /*  533984 */   // Label 8855: @533984
     /*  533984 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(534055), // Rule ID 21719 //
     /*  533989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534021 */     // MIs[0] round
     /*  534021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  534034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534040 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534053 */     GIR_RootConstrainSelectedInstOperands,
     /*  534054 */     // GIR_Coverage, 21719,
     /*  534054 */     GIR_EraseRootFromParent_Done,
     /*  534055 */   // Label 8856: @534055
     /*  534055 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(534126), // Rule ID 21722 //
     /*  534060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  534063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  534068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534092 */     // MIs[0] round
     /*  534092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  534105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534111 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534124 */     GIR_RootConstrainSelectedInstOperands,
     /*  534125 */     // GIR_Coverage, 21722,
     /*  534125 */     GIR_EraseRootFromParent_Done,
     /*  534126 */   // Label 8857: @534126
     /*  534126 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(534197), // Rule ID 21723 //
     /*  534131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  534134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  534139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534163 */     // MIs[0] round
     /*  534163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534173 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  534176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534182 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534195 */     GIR_RootConstrainSelectedInstOperands,
     /*  534196 */     // GIR_Coverage, 21723,
     /*  534196 */     GIR_EraseRootFromParent_Done,
     /*  534197 */   // Label 8858: @534197
     /*  534197 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(534268), // Rule ID 21846 //
     /*  534202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534234 */     // MIs[0] round
     /*  534234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534244 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  534247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534253 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534266 */     GIR_RootConstrainSelectedInstOperands,
     /*  534267 */     // GIR_Coverage, 21846,
     /*  534267 */     GIR_EraseRootFromParent_Done,
     /*  534268 */   // Label 8859: @534268
     /*  534268 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(534339), // Rule ID 21847 //
     /*  534273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534305 */     // MIs[0] round
     /*  534305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534315 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  534318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534324 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534337 */     GIR_RootConstrainSelectedInstOperands,
     /*  534338 */     // GIR_Coverage, 21847,
     /*  534338 */     GIR_EraseRootFromParent_Done,
     /*  534339 */   // Label 8860: @534339
     /*  534339 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(534410), // Rule ID 21850 //
     /*  534344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534376 */     // MIs[0] round
     /*  534376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534386 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  534389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534395 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534408 */     GIR_RootConstrainSelectedInstOperands,
     /*  534409 */     // GIR_Coverage, 21850,
     /*  534409 */     GIR_EraseRootFromParent_Done,
     /*  534410 */   // Label 8861: @534410
     /*  534410 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(534481), // Rule ID 21851 //
     /*  534415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534447 */     // MIs[0] round
     /*  534447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534457 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  534460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534466 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534479 */     GIR_RootConstrainSelectedInstOperands,
     /*  534480 */     // GIR_Coverage, 21851,
     /*  534480 */     GIR_EraseRootFromParent_Done,
     /*  534481 */   // Label 8862: @534481
     /*  534481 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(534552), // Rule ID 21854 //
     /*  534486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534518 */     // MIs[0] round
     /*  534518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534528 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534537 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534550 */     GIR_RootConstrainSelectedInstOperands,
     /*  534551 */     // GIR_Coverage, 21854,
     /*  534551 */     GIR_EraseRootFromParent_Done,
     /*  534552 */   // Label 8863: @534552
     /*  534552 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(534623), // Rule ID 21855 //
     /*  534557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534589 */     // MIs[0] round
     /*  534589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534599 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11283:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534608 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534621 */     GIR_RootConstrainSelectedInstOperands,
     /*  534622 */     // GIR_Coverage, 21855,
     /*  534622 */     GIR_EraseRootFromParent_Done,
     /*  534623 */   // Label 8864: @534623
     /*  534623 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(534694), // Rule ID 21858 //
     /*  534628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534660 */     // MIs[0] round
     /*  534660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534679 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534692 */     GIR_RootConstrainSelectedInstOperands,
     /*  534693 */     // GIR_Coverage, 21858,
     /*  534693 */     GIR_EraseRootFromParent_Done,
     /*  534694 */   // Label 8865: @534694
     /*  534694 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(534765), // Rule ID 21859 //
     /*  534699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534731 */     // MIs[0] round
     /*  534731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534741 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534750 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534763 */     GIR_RootConstrainSelectedInstOperands,
     /*  534764 */     // GIR_Coverage, 21859,
     /*  534764 */     GIR_EraseRootFromParent_Done,
     /*  534765 */   // Label 8866: @534765
     /*  534765 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(534836), // Rule ID 21862 //
     /*  534770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534802 */     // MIs[0] round
     /*  534802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534812 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534821 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534834 */     GIR_RootConstrainSelectedInstOperands,
     /*  534835 */     // GIR_Coverage, 21862,
     /*  534835 */     GIR_EraseRootFromParent_Done,
     /*  534836 */   // Label 8867: @534836
     /*  534836 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(534907), // Rule ID 21863 //
     /*  534841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534873 */     // MIs[0] round
     /*  534873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534883 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534892 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534905 */     GIR_RootConstrainSelectedInstOperands,
     /*  534906 */     // GIR_Coverage, 21863,
     /*  534906 */     GIR_EraseRootFromParent_Done,
     /*  534907 */   // Label 8868: @534907
     /*  534907 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(534978), // Rule ID 21866 //
     /*  534912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534944 */     // MIs[0] round
     /*  534944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534954 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534963 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534976 */     GIR_RootConstrainSelectedInstOperands,
     /*  534977 */     // GIR_Coverage, 21866,
     /*  534977 */     GIR_EraseRootFromParent_Done,
     /*  534978 */   // Label 8869: @534978
     /*  534978 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(535049), // Rule ID 21867 //
     /*  534983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535015 */     // MIs[0] round
     /*  535015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535025 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  535028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535034 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535047 */     GIR_RootConstrainSelectedInstOperands,
     /*  535048 */     // GIR_Coverage, 21867,
     /*  535048 */     GIR_EraseRootFromParent_Done,
     /*  535049 */   // Label 8870: @535049
     /*  535049 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(535120), // Rule ID 21870 //
     /*  535054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535086 */     // MIs[0] round
     /*  535086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535096 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  535099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535105 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535118 */     GIR_RootConstrainSelectedInstOperands,
     /*  535119 */     // GIR_Coverage, 21870,
     /*  535119 */     GIR_EraseRootFromParent_Done,
     /*  535120 */   // Label 8871: @535120
     /*  535120 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(535191), // Rule ID 21871 //
     /*  535125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535157 */     // MIs[0] round
     /*  535157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535167 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  535170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535176 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535189 */     GIR_RootConstrainSelectedInstOperands,
     /*  535190 */     // GIR_Coverage, 21871,
     /*  535190 */     GIR_EraseRootFromParent_Done,
     /*  535191 */   // Label 8872: @535191
     /*  535191 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(535262), // Rule ID 21874 //
     /*  535196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535228 */     // MIs[0] round
     /*  535228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535238 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  535241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535247 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535260 */     GIR_RootConstrainSelectedInstOperands,
     /*  535261 */     // GIR_Coverage, 21874,
     /*  535261 */     GIR_EraseRootFromParent_Done,
     /*  535262 */   // Label 8873: @535262
     /*  535262 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(535333), // Rule ID 21875 //
     /*  535267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535299 */     // MIs[0] round
     /*  535299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535309 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  535312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535318 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535331 */     GIR_RootConstrainSelectedInstOperands,
     /*  535332 */     // GIR_Coverage, 21875,
     /*  535332 */     GIR_EraseRootFromParent_Done,
     /*  535333 */   // Label 8874: @535333
     /*  535333 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(535404), // Rule ID 21878 //
     /*  535338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535370 */     // MIs[0] round
     /*  535370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535380 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  535383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535389 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535402 */     GIR_RootConstrainSelectedInstOperands,
     /*  535403 */     // GIR_Coverage, 21878,
     /*  535403 */     GIR_EraseRootFromParent_Done,
     /*  535404 */   // Label 8875: @535404
     /*  535404 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(535475), // Rule ID 21879 //
     /*  535409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  535417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535441 */     // MIs[0] round
     /*  535441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535451 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  535454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535460 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535473 */     GIR_RootConstrainSelectedInstOperands,
     /*  535474 */     // GIR_Coverage, 21879,
     /*  535474 */     GIR_EraseRootFromParent_Done,
     /*  535475 */   // Label 8876: @535475
     /*  535475 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(535546), // Rule ID 21882 //
     /*  535480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535512 */     // MIs[0] round
     /*  535512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535522 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535531 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535544 */     GIR_RootConstrainSelectedInstOperands,
     /*  535545 */     // GIR_Coverage, 21882,
     /*  535545 */     GIR_EraseRootFromParent_Done,
     /*  535546 */   // Label 8877: @535546
     /*  535546 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(535617), // Rule ID 21883 //
     /*  535551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535583 */     // MIs[0] round
     /*  535583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535593 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535602 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535615 */     GIR_RootConstrainSelectedInstOperands,
     /*  535616 */     // GIR_Coverage, 21883,
     /*  535616 */     GIR_EraseRootFromParent_Done,
     /*  535617 */   // Label 8878: @535617
     /*  535617 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(535688), // Rule ID 21886 //
     /*  535622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535654 */     // MIs[0] round
     /*  535654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535673 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535686 */     GIR_RootConstrainSelectedInstOperands,
     /*  535687 */     // GIR_Coverage, 21886,
     /*  535687 */     GIR_EraseRootFromParent_Done,
     /*  535688 */   // Label 8879: @535688
     /*  535688 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(535759), // Rule ID 21887 //
     /*  535693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535725 */     // MIs[0] round
     /*  535725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535735 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535744 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535757 */     GIR_RootConstrainSelectedInstOperands,
     /*  535758 */     // GIR_Coverage, 21887,
     /*  535758 */     GIR_EraseRootFromParent_Done,
     /*  535759 */   // Label 8880: @535759
     /*  535759 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(535830), // Rule ID 21890 //
     /*  535764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535796 */     // MIs[0] round
     /*  535796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535806 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535815 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535828 */     GIR_RootConstrainSelectedInstOperands,
     /*  535829 */     // GIR_Coverage, 21890,
     /*  535829 */     GIR_EraseRootFromParent_Done,
     /*  535830 */   // Label 8881: @535830
     /*  535830 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(535901), // Rule ID 21891 //
     /*  535835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535867 */     // MIs[0] round
     /*  535867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535877 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11281:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535886 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535899 */     GIR_RootConstrainSelectedInstOperands,
     /*  535900 */     // GIR_Coverage, 21891,
     /*  535900 */     GIR_EraseRootFromParent_Done,
     /*  535901 */   // Label 8882: @535901
     /*  535901 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(535972), // Rule ID 21894 //
     /*  535906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535938 */     // MIs[0] round
     /*  535938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535948 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535957 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535970 */     GIR_RootConstrainSelectedInstOperands,
     /*  535971 */     // GIR_Coverage, 21894,
     /*  535971 */     GIR_EraseRootFromParent_Done,
     /*  535972 */   // Label 8883: @535972
     /*  535972 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(536043), // Rule ID 21895 //
     /*  535977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536009 */     // MIs[0] round
     /*  536009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536019 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  536022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536028 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536041 */     GIR_RootConstrainSelectedInstOperands,
     /*  536042 */     // GIR_Coverage, 21895,
     /*  536042 */     GIR_EraseRootFromParent_Done,
     /*  536043 */   // Label 8884: @536043
     /*  536043 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(536114), // Rule ID 21898 //
     /*  536048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536080 */     // MIs[0] round
     /*  536080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  536093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536099 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536112 */     GIR_RootConstrainSelectedInstOperands,
     /*  536113 */     // GIR_Coverage, 21898,
     /*  536113 */     GIR_EraseRootFromParent_Done,
     /*  536114 */   // Label 8885: @536114
     /*  536114 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(536185), // Rule ID 21899 //
     /*  536119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536151 */     // MIs[0] round
     /*  536151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536161 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  536164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536170 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536183 */     GIR_RootConstrainSelectedInstOperands,
     /*  536184 */     // GIR_Coverage, 21899,
     /*  536184 */     GIR_EraseRootFromParent_Done,
     /*  536185 */   // Label 8886: @536185
     /*  536185 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(536256), // Rule ID 21902 //
     /*  536190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  536201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  536204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  536207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536222 */     // MIs[0] round
     /*  536222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536232 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  536235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536241 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536254 */     GIR_RootConstrainSelectedInstOperands,
     /*  536255 */     // GIR_Coverage, 21902,
     /*  536255 */     GIR_EraseRootFromParent_Done,
     /*  536256 */   // Label 8887: @536256
     /*  536256 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(536327), // Rule ID 21903 //
     /*  536261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  536272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  536275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  536278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536293 */     // MIs[0] round
     /*  536293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536303 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  536306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536312 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536325 */     GIR_RootConstrainSelectedInstOperands,
     /*  536326 */     // GIR_Coverage, 21903,
     /*  536326 */     GIR_EraseRootFromParent_Done,
     /*  536327 */   // Label 8888: @536327
     /*  536327 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(536398), // Rule ID 21906 //
     /*  536332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  536343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  536346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536364 */     // MIs[0] round
     /*  536364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  536377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536383 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536396 */     GIR_RootConstrainSelectedInstOperands,
     /*  536397 */     // GIR_Coverage, 21906,
     /*  536397 */     GIR_EraseRootFromParent_Done,
     /*  536398 */   // Label 8889: @536398
     /*  536398 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(536469), // Rule ID 21907 //
     /*  536403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  536414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  536417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536435 */     // MIs[0] round
     /*  536435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536445 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  536448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536454 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536467 */     GIR_RootConstrainSelectedInstOperands,
     /*  536468 */     // GIR_Coverage, 21907,
     /*  536468 */     GIR_EraseRootFromParent_Done,
     /*  536469 */   // Label 8890: @536469
     /*  536469 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(536540), // Rule ID 21910 //
     /*  536474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536506 */     // MIs[0] round
     /*  536506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536525 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536538 */     GIR_RootConstrainSelectedInstOperands,
     /*  536539 */     // GIR_Coverage, 21910,
     /*  536539 */     GIR_EraseRootFromParent_Done,
     /*  536540 */   // Label 8891: @536540
     /*  536540 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(536611), // Rule ID 21911 //
     /*  536545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536577 */     // MIs[0] round
     /*  536577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536587 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536596 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536609 */     GIR_RootConstrainSelectedInstOperands,
     /*  536610 */     // GIR_Coverage, 21911,
     /*  536610 */     GIR_EraseRootFromParent_Done,
     /*  536611 */   // Label 8892: @536611
     /*  536611 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(536682), // Rule ID 21914 //
     /*  536616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536648 */     // MIs[0] round
     /*  536648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536658 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536667 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536680 */     GIR_RootConstrainSelectedInstOperands,
     /*  536681 */     // GIR_Coverage, 21914,
     /*  536681 */     GIR_EraseRootFromParent_Done,
     /*  536682 */   // Label 8893: @536682
     /*  536682 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(536753), // Rule ID 21915 //
     /*  536687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536719 */     // MIs[0] round
     /*  536719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536729 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536738 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536751 */     GIR_RootConstrainSelectedInstOperands,
     /*  536752 */     // GIR_Coverage, 21915,
     /*  536752 */     GIR_EraseRootFromParent_Done,
     /*  536753 */   // Label 8894: @536753
     /*  536753 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(536824), // Rule ID 21918 //
     /*  536758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536790 */     // MIs[0] round
     /*  536790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536809 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536822 */     GIR_RootConstrainSelectedInstOperands,
     /*  536823 */     // GIR_Coverage, 21918,
     /*  536823 */     GIR_EraseRootFromParent_Done,
     /*  536824 */   // Label 8895: @536824
     /*  536824 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(536895), // Rule ID 21919 //
     /*  536829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536861 */     // MIs[0] round
     /*  536861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536871 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536880 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536893 */     GIR_RootConstrainSelectedInstOperands,
     /*  536894 */     // GIR_Coverage, 21919,
     /*  536894 */     GIR_EraseRootFromParent_Done,
     /*  536895 */   // Label 8896: @536895
     /*  536895 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(536966), // Rule ID 21922 //
     /*  536900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536932 */     // MIs[0] round
     /*  536932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536942 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536951 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536964 */     GIR_RootConstrainSelectedInstOperands,
     /*  536965 */     // GIR_Coverage, 21922,
     /*  536965 */     GIR_EraseRootFromParent_Done,
     /*  536966 */   // Label 8897: @536966
     /*  536966 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(537037), // Rule ID 21923 //
     /*  536971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537003 */     // MIs[0] round
     /*  537003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537013 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  537016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537022 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537035 */     GIR_RootConstrainSelectedInstOperands,
     /*  537036 */     // GIR_Coverage, 21923,
     /*  537036 */     GIR_EraseRootFromParent_Done,
     /*  537037 */   // Label 8898: @537037
     /*  537037 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(537108), // Rule ID 21926 //
     /*  537042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537074 */     // MIs[0] round
     /*  537074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  537087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537093 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537106 */     GIR_RootConstrainSelectedInstOperands,
     /*  537107 */     // GIR_Coverage, 21926,
     /*  537107 */     GIR_EraseRootFromParent_Done,
     /*  537108 */   // Label 8899: @537108
     /*  537108 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(537179), // Rule ID 21927 //
     /*  537113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537145 */     // MIs[0] round
     /*  537145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537155 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11279:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  537158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537164 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537177 */     GIR_RootConstrainSelectedInstOperands,
     /*  537178 */     // GIR_Coverage, 21927,
     /*  537178 */     GIR_EraseRootFromParent_Done,
     /*  537179 */   // Label 8900: @537179
     /*  537179 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(537250), // Rule ID 21930 //
     /*  537184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  537201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537216 */     // MIs[0] round
     /*  537216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537226 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  537229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537235 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537248 */     GIR_RootConstrainSelectedInstOperands,
     /*  537249 */     // GIR_Coverage, 21930,
     /*  537249 */     GIR_EraseRootFromParent_Done,
     /*  537250 */   // Label 8901: @537250
     /*  537250 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(537321), // Rule ID 21931 //
     /*  537255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  537272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537287 */     // MIs[0] round
     /*  537287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  537300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537306 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537319 */     GIR_RootConstrainSelectedInstOperands,
     /*  537320 */     // GIR_Coverage, 21931,
     /*  537320 */     GIR_EraseRootFromParent_Done,
     /*  537321 */   // Label 8902: @537321
     /*  537321 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(537392), // Rule ID 21934 //
     /*  537326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  537329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  537343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537358 */     // MIs[0] round
     /*  537358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537368 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  537371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537377 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537390 */     GIR_RootConstrainSelectedInstOperands,
     /*  537391 */     // GIR_Coverage, 21934,
     /*  537391 */     GIR_EraseRootFromParent_Done,
     /*  537392 */   // Label 8903: @537392
     /*  537392 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(537463), // Rule ID 21935 //
     /*  537397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  537400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  537414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537429 */     // MIs[0] round
     /*  537429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537439 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  537442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537448 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537461 */     GIR_RootConstrainSelectedInstOperands,
     /*  537462 */     // GIR_Coverage, 21935,
     /*  537462 */     GIR_EraseRootFromParent_Done,
     /*  537463 */   // Label 8904: @537463
     /*  537463 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(537534), // Rule ID 21938 //
     /*  537468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537500 */     // MIs[0] round
     /*  537500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537510 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537519 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537532 */     GIR_RootConstrainSelectedInstOperands,
     /*  537533 */     // GIR_Coverage, 21938,
     /*  537533 */     GIR_EraseRootFromParent_Done,
     /*  537534 */   // Label 8905: @537534
     /*  537534 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(537605), // Rule ID 21939 //
     /*  537539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537571 */     // MIs[0] round
     /*  537571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537581 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537590 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537603 */     GIR_RootConstrainSelectedInstOperands,
     /*  537604 */     // GIR_Coverage, 21939,
     /*  537604 */     GIR_EraseRootFromParent_Done,
     /*  537605 */   // Label 8906: @537605
     /*  537605 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(537676), // Rule ID 21942 //
     /*  537610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537642 */     // MIs[0] round
     /*  537642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537661 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537674 */     GIR_RootConstrainSelectedInstOperands,
     /*  537675 */     // GIR_Coverage, 21942,
     /*  537675 */     GIR_EraseRootFromParent_Done,
     /*  537676 */   // Label 8907: @537676
     /*  537676 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(537747), // Rule ID 21943 //
     /*  537681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537713 */     // MIs[0] round
     /*  537713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537723 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537732 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537745 */     GIR_RootConstrainSelectedInstOperands,
     /*  537746 */     // GIR_Coverage, 21943,
     /*  537746 */     GIR_EraseRootFromParent_Done,
     /*  537747 */   // Label 8908: @537747
     /*  537747 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(537818), // Rule ID 21946 //
     /*  537752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537784 */     // MIs[0] round
     /*  537784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537794 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537803 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537816 */     GIR_RootConstrainSelectedInstOperands,
     /*  537817 */     // GIR_Coverage, 21946,
     /*  537817 */     GIR_EraseRootFromParent_Done,
     /*  537818 */   // Label 8909: @537818
     /*  537818 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(537889), // Rule ID 21947 //
     /*  537823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537855 */     // MIs[0] round
     /*  537855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537865 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537874 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537887 */     GIR_RootConstrainSelectedInstOperands,
     /*  537888 */     // GIR_Coverage, 21947,
     /*  537888 */     GIR_EraseRootFromParent_Done,
     /*  537889 */   // Label 8910: @537889
     /*  537889 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(537960), // Rule ID 21950 //
     /*  537894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537926 */     // MIs[0] round
     /*  537926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537945 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537958 */     GIR_RootConstrainSelectedInstOperands,
     /*  537959 */     // GIR_Coverage, 21950,
     /*  537959 */     GIR_EraseRootFromParent_Done,
     /*  537960 */   // Label 8911: @537960
     /*  537960 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(538031), // Rule ID 21951 //
     /*  537965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537997 */     // MIs[0] round
     /*  537997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538007 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  538010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538016 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538029 */     GIR_RootConstrainSelectedInstOperands,
     /*  538030 */     // GIR_Coverage, 21951,
     /*  538030 */     GIR_EraseRootFromParent_Done,
     /*  538031 */   // Label 8912: @538031
     /*  538031 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(538102), // Rule ID 2760 //
     /*  538036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  538053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538064 */     // MIs[0] passthru
     /*  538064 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  538083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538100 */     GIR_RootConstrainSelectedInstOperands,
     /*  538101 */     // GIR_Coverage, 2760,
     /*  538101 */     GIR_EraseRootFromParent_Done,
     /*  538102 */   // Label 8913: @538102
     /*  538102 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(538173), // Rule ID 2761 //
     /*  538107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  538124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538135 */     // MIs[0] passthru
     /*  538135 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  538154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538171 */     GIR_RootConstrainSelectedInstOperands,
     /*  538172 */     // GIR_Coverage, 2761,
     /*  538172 */     GIR_EraseRootFromParent_Done,
     /*  538173 */   // Label 8914: @538173
     /*  538173 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(538244), // Rule ID 4076 //
     /*  538178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  538189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  538192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  538195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538206 */     // MIs[0] passthru
     /*  538206 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538242 */     GIR_RootConstrainSelectedInstOperands,
     /*  538243 */     // GIR_Coverage, 4076,
     /*  538243 */     GIR_EraseRootFromParent_Done,
     /*  538244 */   // Label 8915: @538244
     /*  538244 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(538315), // Rule ID 4077 //
     /*  538249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  538260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  538263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  538266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538277 */     // MIs[0] passthru
     /*  538277 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538313 */     GIR_RootConstrainSelectedInstOperands,
     /*  538314 */     // GIR_Coverage, 4077,
     /*  538314 */     GIR_EraseRootFromParent_Done,
     /*  538315 */   // Label 8916: @538315
     /*  538315 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(538386), // Rule ID 4086 //
     /*  538320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  538337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538348 */     // MIs[0] passthru
     /*  538348 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538384 */     GIR_RootConstrainSelectedInstOperands,
     /*  538385 */     // GIR_Coverage, 4086,
     /*  538385 */     GIR_EraseRootFromParent_Done,
     /*  538386 */   // Label 8917: @538386
     /*  538386 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(538457), // Rule ID 4087 //
     /*  538391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  538402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  538405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  538408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538419 */     // MIs[0] passthru
     /*  538419 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538435 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538455 */     GIR_RootConstrainSelectedInstOperands,
     /*  538456 */     // GIR_Coverage, 4087,
     /*  538456 */     GIR_EraseRootFromParent_Done,
     /*  538457 */   // Label 8918: @538457
     /*  538457 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(538528), // Rule ID 4096 //
     /*  538462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538490 */     // MIs[0] passthru
     /*  538490 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538526 */     GIR_RootConstrainSelectedInstOperands,
     /*  538527 */     // GIR_Coverage, 4096,
     /*  538527 */     GIR_EraseRootFromParent_Done,
     /*  538528 */   // Label 8919: @538528
     /*  538528 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(538599), // Rule ID 4097 //
     /*  538533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538561 */     // MIs[0] passthru
     /*  538561 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538597 */     GIR_RootConstrainSelectedInstOperands,
     /*  538598 */     // GIR_Coverage, 4097,
     /*  538598 */     GIR_EraseRootFromParent_Done,
     /*  538599 */   // Label 8920: @538599
     /*  538599 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(538670), // Rule ID 4106 //
     /*  538604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538632 */     // MIs[0] passthru
     /*  538632 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538668 */     GIR_RootConstrainSelectedInstOperands,
     /*  538669 */     // GIR_Coverage, 4106,
     /*  538669 */     GIR_EraseRootFromParent_Done,
     /*  538670 */   // Label 8921: @538670
     /*  538670 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(538741), // Rule ID 4107 //
     /*  538675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538703 */     // MIs[0] passthru
     /*  538703 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538739 */     GIR_RootConstrainSelectedInstOperands,
     /*  538740 */     // GIR_Coverage, 4107,
     /*  538740 */     GIR_EraseRootFromParent_Done,
     /*  538741 */   // Label 8922: @538741
     /*  538741 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(538812), // Rule ID 4116 //
     /*  538746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538774 */     // MIs[0] passthru
     /*  538774 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538790 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538810 */     GIR_RootConstrainSelectedInstOperands,
     /*  538811 */     // GIR_Coverage, 4116,
     /*  538811 */     GIR_EraseRootFromParent_Done,
     /*  538812 */   // Label 8923: @538812
     /*  538812 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(538883), // Rule ID 4117 //
     /*  538817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538845 */     // MIs[0] passthru
     /*  538845 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538881 */     GIR_RootConstrainSelectedInstOperands,
     /*  538882 */     // GIR_Coverage, 4117,
     /*  538882 */     GIR_EraseRootFromParent_Done,
     /*  538883 */   // Label 8924: @538883
     /*  538883 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(538954), // Rule ID 4126 //
     /*  538888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538916 */     // MIs[0] passthru
     /*  538916 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538952 */     GIR_RootConstrainSelectedInstOperands,
     /*  538953 */     // GIR_Coverage, 4126,
     /*  538953 */     GIR_EraseRootFromParent_Done,
     /*  538954 */   // Label 8925: @538954
     /*  538954 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(539025), // Rule ID 4127 //
     /*  538959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538987 */     // MIs[0] passthru
     /*  538987 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539003 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  539006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539023 */     GIR_RootConstrainSelectedInstOperands,
     /*  539024 */     // GIR_Coverage, 4127,
     /*  539024 */     GIR_EraseRootFromParent_Done,
     /*  539025 */   // Label 8926: @539025
     /*  539025 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(539096), // Rule ID 4136 //
     /*  539030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  539047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539058 */     // MIs[0] passthru
     /*  539058 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539094 */     GIR_RootConstrainSelectedInstOperands,
     /*  539095 */     // GIR_Coverage, 4136,
     /*  539095 */     GIR_EraseRootFromParent_Done,
     /*  539096 */   // Label 8927: @539096
     /*  539096 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(539167), // Rule ID 4137 //
     /*  539101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  539118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539129 */     // MIs[0] passthru
     /*  539129 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539165 */     GIR_RootConstrainSelectedInstOperands,
     /*  539166 */     // GIR_Coverage, 4137,
     /*  539166 */     GIR_EraseRootFromParent_Done,
     /*  539167 */   // Label 8928: @539167
     /*  539167 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(539238), // Rule ID 4146 //
     /*  539172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  539189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539200 */     // MIs[0] passthru
     /*  539200 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539236 */     GIR_RootConstrainSelectedInstOperands,
     /*  539237 */     // GIR_Coverage, 4146,
     /*  539237 */     GIR_EraseRootFromParent_Done,
     /*  539238 */   // Label 8929: @539238
     /*  539238 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(539309), // Rule ID 4147 //
     /*  539243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  539260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539271 */     // MIs[0] passthru
     /*  539271 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539307 */     GIR_RootConstrainSelectedInstOperands,
     /*  539308 */     // GIR_Coverage, 4147,
     /*  539308 */     GIR_EraseRootFromParent_Done,
     /*  539309 */   // Label 8930: @539309
     /*  539309 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(539380), // Rule ID 4156 //
     /*  539314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  539331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539342 */     // MIs[0] passthru
     /*  539342 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539378 */     GIR_RootConstrainSelectedInstOperands,
     /*  539379 */     // GIR_Coverage, 4156,
     /*  539379 */     GIR_EraseRootFromParent_Done,
     /*  539380 */   // Label 8931: @539380
     /*  539380 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(539451), // Rule ID 4157 //
     /*  539385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  539396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  539399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  539402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539413 */     // MIs[0] passthru
     /*  539413 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539429 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539449 */     GIR_RootConstrainSelectedInstOperands,
     /*  539450 */     // GIR_Coverage, 4157,
     /*  539450 */     GIR_EraseRootFromParent_Done,
     /*  539451 */   // Label 8932: @539451
     /*  539451 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(539522), // Rule ID 4166 //
     /*  539456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539484 */     // MIs[0] passthru
     /*  539484 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539520 */     GIR_RootConstrainSelectedInstOperands,
     /*  539521 */     // GIR_Coverage, 4166,
     /*  539521 */     GIR_EraseRootFromParent_Done,
     /*  539522 */   // Label 8933: @539522
     /*  539522 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(539593), // Rule ID 4167 //
     /*  539527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539555 */     // MIs[0] passthru
     /*  539555 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539591 */     GIR_RootConstrainSelectedInstOperands,
     /*  539592 */     // GIR_Coverage, 4167,
     /*  539592 */     GIR_EraseRootFromParent_Done,
     /*  539593 */   // Label 8934: @539593
     /*  539593 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(539664), // Rule ID 4176 //
     /*  539598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539626 */     // MIs[0] passthru
     /*  539626 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539662 */     GIR_RootConstrainSelectedInstOperands,
     /*  539663 */     // GIR_Coverage, 4176,
     /*  539663 */     GIR_EraseRootFromParent_Done,
     /*  539664 */   // Label 8935: @539664
     /*  539664 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(539735), // Rule ID 4177 //
     /*  539669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539697 */     // MIs[0] passthru
     /*  539697 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539733 */     GIR_RootConstrainSelectedInstOperands,
     /*  539734 */     // GIR_Coverage, 4177,
     /*  539734 */     GIR_EraseRootFromParent_Done,
     /*  539735 */   // Label 8936: @539735
     /*  539735 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(539806), // Rule ID 4186 //
     /*  539740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539768 */     // MIs[0] passthru
     /*  539768 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539804 */     GIR_RootConstrainSelectedInstOperands,
     /*  539805 */     // GIR_Coverage, 4186,
     /*  539805 */     GIR_EraseRootFromParent_Done,
     /*  539806 */   // Label 8937: @539806
     /*  539806 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(539877), // Rule ID 4187 //
     /*  539811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539839 */     // MIs[0] passthru
     /*  539839 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539855 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539875 */     GIR_RootConstrainSelectedInstOperands,
     /*  539876 */     // GIR_Coverage, 4187,
     /*  539876 */     GIR_EraseRootFromParent_Done,
     /*  539877 */   // Label 8938: @539877
     /*  539877 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(539948), // Rule ID 4196 //
     /*  539882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539910 */     // MIs[0] passthru
     /*  539910 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539946 */     GIR_RootConstrainSelectedInstOperands,
     /*  539947 */     // GIR_Coverage, 4196,
     /*  539947 */     GIR_EraseRootFromParent_Done,
     /*  539948 */   // Label 8939: @539948
     /*  539948 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(540019), // Rule ID 4197 //
     /*  539953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539981 */     // MIs[0] passthru
     /*  539981 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539997 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  540000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540017 */     GIR_RootConstrainSelectedInstOperands,
     /*  540018 */     // GIR_Coverage, 4197,
     /*  540018 */     GIR_EraseRootFromParent_Done,
     /*  540019 */   // Label 8940: @540019
     /*  540019 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(540090), // Rule ID 4206 //
     /*  540024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  540027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  540032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  540041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540052 */     // MIs[0] passthru
     /*  540052 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  540071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540088 */     GIR_RootConstrainSelectedInstOperands,
     /*  540089 */     // GIR_Coverage, 4206,
     /*  540089 */     GIR_EraseRootFromParent_Done,
     /*  540090 */   // Label 8941: @540090
     /*  540090 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(540161), // Rule ID 4207 //
     /*  540095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  540098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  540103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  540106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  540109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  540112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540123 */     // MIs[0] passthru
     /*  540123 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540139 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  540142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540159 */     GIR_RootConstrainSelectedInstOperands,
     /*  540160 */     // GIR_Coverage, 4207,
     /*  540160 */     GIR_EraseRootFromParent_Done,
     /*  540161 */   // Label 8942: @540161
     /*  540161 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(540232), // Rule ID 4276 //
     /*  540166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540194 */     // MIs[0] passthru
     /*  540194 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  540213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540230 */     GIR_RootConstrainSelectedInstOperands,
     /*  540231 */     // GIR_Coverage, 4276,
     /*  540231 */     GIR_EraseRootFromParent_Done,
     /*  540232 */   // Label 8943: @540232
     /*  540232 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(540303), // Rule ID 4277 //
     /*  540237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  540254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540265 */     // MIs[0] passthru
     /*  540265 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  540284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540301 */     GIR_RootConstrainSelectedInstOperands,
     /*  540302 */     // GIR_Coverage, 4277,
     /*  540302 */     GIR_EraseRootFromParent_Done,
     /*  540303 */   // Label 8944: @540303
     /*  540303 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(540374), // Rule ID 4286 //
     /*  540308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540336 */     // MIs[0] passthru
     /*  540336 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540372 */     GIR_RootConstrainSelectedInstOperands,
     /*  540373 */     // GIR_Coverage, 4286,
     /*  540373 */     GIR_EraseRootFromParent_Done,
     /*  540374 */   // Label 8945: @540374
     /*  540374 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(540445), // Rule ID 4287 //
     /*  540379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  540396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540407 */     // MIs[0] passthru
     /*  540407 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540423 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540443 */     GIR_RootConstrainSelectedInstOperands,
     /*  540444 */     // GIR_Coverage, 4287,
     /*  540444 */     GIR_EraseRootFromParent_Done,
     /*  540445 */   // Label 8946: @540445
     /*  540445 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(540516), // Rule ID 4296 //
     /*  540450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540478 */     // MIs[0] passthru
     /*  540478 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540514 */     GIR_RootConstrainSelectedInstOperands,
     /*  540515 */     // GIR_Coverage, 4296,
     /*  540515 */     GIR_EraseRootFromParent_Done,
     /*  540516 */   // Label 8947: @540516
     /*  540516 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(540587), // Rule ID 4297 //
     /*  540521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540549 */     // MIs[0] passthru
     /*  540549 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540585 */     GIR_RootConstrainSelectedInstOperands,
     /*  540586 */     // GIR_Coverage, 4297,
     /*  540586 */     GIR_EraseRootFromParent_Done,
     /*  540587 */   // Label 8948: @540587
     /*  540587 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(540658), // Rule ID 4306 //
     /*  540592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540620 */     // MIs[0] passthru
     /*  540620 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540656 */     GIR_RootConstrainSelectedInstOperands,
     /*  540657 */     // GIR_Coverage, 4306,
     /*  540657 */     GIR_EraseRootFromParent_Done,
     /*  540658 */   // Label 8949: @540658
     /*  540658 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(540729), // Rule ID 4307 //
     /*  540663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540691 */     // MIs[0] passthru
     /*  540691 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540727 */     GIR_RootConstrainSelectedInstOperands,
     /*  540728 */     // GIR_Coverage, 4307,
     /*  540728 */     GIR_EraseRootFromParent_Done,
     /*  540729 */   // Label 8950: @540729
     /*  540729 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(540800), // Rule ID 4316 //
     /*  540734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540762 */     // MIs[0] passthru
     /*  540762 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540798 */     GIR_RootConstrainSelectedInstOperands,
     /*  540799 */     // GIR_Coverage, 4316,
     /*  540799 */     GIR_EraseRootFromParent_Done,
     /*  540800 */   // Label 8951: @540800
     /*  540800 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(540871), // Rule ID 4317 //
     /*  540805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540833 */     // MIs[0] passthru
     /*  540833 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540849 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540869 */     GIR_RootConstrainSelectedInstOperands,
     /*  540870 */     // GIR_Coverage, 4317,
     /*  540870 */     GIR_EraseRootFromParent_Done,
     /*  540871 */   // Label 8952: @540871
     /*  540871 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(540942), // Rule ID 4326 //
     /*  540876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540904 */     // MIs[0] passthru
     /*  540904 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540920 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540940 */     GIR_RootConstrainSelectedInstOperands,
     /*  540941 */     // GIR_Coverage, 4326,
     /*  540941 */     GIR_EraseRootFromParent_Done,
     /*  540942 */   // Label 8953: @540942
     /*  540942 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(541013), // Rule ID 4327 //
     /*  540947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540975 */     // MIs[0] passthru
     /*  540975 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541011 */     GIR_RootConstrainSelectedInstOperands,
     /*  541012 */     // GIR_Coverage, 4327,
     /*  541012 */     GIR_EraseRootFromParent_Done,
     /*  541013 */   // Label 8954: @541013
     /*  541013 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(541084), // Rule ID 4336 //
     /*  541018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  541035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541046 */     // MIs[0] passthru
     /*  541046 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541062 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  541065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541082 */     GIR_RootConstrainSelectedInstOperands,
     /*  541083 */     // GIR_Coverage, 4336,
     /*  541083 */     GIR_EraseRootFromParent_Done,
     /*  541084 */   // Label 8955: @541084
     /*  541084 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(541155), // Rule ID 4337 //
     /*  541089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  541100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  541103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  541106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541117 */     // MIs[0] passthru
     /*  541117 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  541136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541153 */     GIR_RootConstrainSelectedInstOperands,
     /*  541154 */     // GIR_Coverage, 4337,
     /*  541154 */     GIR_EraseRootFromParent_Done,
     /*  541155 */   // Label 8956: @541155
     /*  541155 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(541226), // Rule ID 4346 //
     /*  541160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541188 */     // MIs[0] passthru
     /*  541188 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541224 */     GIR_RootConstrainSelectedInstOperands,
     /*  541225 */     // GIR_Coverage, 4346,
     /*  541225 */     GIR_EraseRootFromParent_Done,
     /*  541226 */   // Label 8957: @541226
     /*  541226 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(541297), // Rule ID 4347 //
     /*  541231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  541242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  541245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  541248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541259 */     // MIs[0] passthru
     /*  541259 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541295 */     GIR_RootConstrainSelectedInstOperands,
     /*  541296 */     // GIR_Coverage, 4347,
     /*  541296 */     GIR_EraseRootFromParent_Done,
     /*  541297 */   // Label 8958: @541297
     /*  541297 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(541368), // Rule ID 4356 //
     /*  541302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  541313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  541316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541330 */     // MIs[0] passthru
     /*  541330 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541366 */     GIR_RootConstrainSelectedInstOperands,
     /*  541367 */     // GIR_Coverage, 4356,
     /*  541367 */     GIR_EraseRootFromParent_Done,
     /*  541368 */   // Label 8959: @541368
     /*  541368 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(541439), // Rule ID 4357 //
     /*  541373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  541384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  541387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  541390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541401 */     // MIs[0] passthru
     /*  541401 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541437 */     GIR_RootConstrainSelectedInstOperands,
     /*  541438 */     // GIR_Coverage, 4357,
     /*  541438 */     GIR_EraseRootFromParent_Done,
     /*  541439 */   // Label 8960: @541439
     /*  541439 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(541510), // Rule ID 4366 //
     /*  541444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541472 */     // MIs[0] passthru
     /*  541472 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541508 */     GIR_RootConstrainSelectedInstOperands,
     /*  541509 */     // GIR_Coverage, 4366,
     /*  541509 */     GIR_EraseRootFromParent_Done,
     /*  541510 */   // Label 8961: @541510
     /*  541510 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(541581), // Rule ID 4367 //
     /*  541515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541543 */     // MIs[0] passthru
     /*  541543 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541579 */     GIR_RootConstrainSelectedInstOperands,
     /*  541580 */     // GIR_Coverage, 4367,
     /*  541580 */     GIR_EraseRootFromParent_Done,
     /*  541581 */   // Label 8962: @541581
     /*  541581 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(541652), // Rule ID 4376 //
     /*  541586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541614 */     // MIs[0] passthru
     /*  541614 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541650 */     GIR_RootConstrainSelectedInstOperands,
     /*  541651 */     // GIR_Coverage, 4376,
     /*  541651 */     GIR_EraseRootFromParent_Done,
     /*  541652 */   // Label 8963: @541652
     /*  541652 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(541723), // Rule ID 4377 //
     /*  541657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541685 */     // MIs[0] passthru
     /*  541685 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541721 */     GIR_RootConstrainSelectedInstOperands,
     /*  541722 */     // GIR_Coverage, 4377,
     /*  541722 */     GIR_EraseRootFromParent_Done,
     /*  541723 */   // Label 8964: @541723
     /*  541723 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(541794), // Rule ID 4386 //
     /*  541728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541756 */     // MIs[0] passthru
     /*  541756 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541792 */     GIR_RootConstrainSelectedInstOperands,
     /*  541793 */     // GIR_Coverage, 4386,
     /*  541793 */     GIR_EraseRootFromParent_Done,
     /*  541794 */   // Label 8965: @541794
     /*  541794 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(541865), // Rule ID 4387 //
     /*  541799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541827 */     // MIs[0] passthru
     /*  541827 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541863 */     GIR_RootConstrainSelectedInstOperands,
     /*  541864 */     // GIR_Coverage, 4387,
     /*  541864 */     GIR_EraseRootFromParent_Done,
     /*  541865 */   // Label 8966: @541865
     /*  541865 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(541936), // Rule ID 4396 //
     /*  541870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541898 */     // MIs[0] passthru
     /*  541898 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541934 */     GIR_RootConstrainSelectedInstOperands,
     /*  541935 */     // GIR_Coverage, 4396,
     /*  541935 */     GIR_EraseRootFromParent_Done,
     /*  541936 */   // Label 8967: @541936
     /*  541936 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(542007), // Rule ID 4397 //
     /*  541941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541969 */     // MIs[0] passthru
     /*  541969 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542005 */     GIR_RootConstrainSelectedInstOperands,
     /*  542006 */     // GIR_Coverage, 4397,
     /*  542006 */     GIR_EraseRootFromParent_Done,
     /*  542007 */   // Label 8968: @542007
     /*  542007 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(542078), // Rule ID 4406 //
     /*  542012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  542023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  542026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542040 */     // MIs[0] passthru
     /*  542040 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  542059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542076 */     GIR_RootConstrainSelectedInstOperands,
     /*  542077 */     // GIR_Coverage, 4406,
     /*  542077 */     GIR_EraseRootFromParent_Done,
     /*  542078 */   // Label 8969: @542078
     /*  542078 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(542149), // Rule ID 4407 //
     /*  542083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  542086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  542094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  542097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  542100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542111 */     // MIs[0] passthru
     /*  542111 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  542130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542147 */     GIR_RootConstrainSelectedInstOperands,
     /*  542148 */     // GIR_Coverage, 4407,
     /*  542148 */     GIR_EraseRootFromParent_Done,
     /*  542149 */   // Label 8970: @542149
     /*  542149 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(542220), // Rule ID 4416 //
     /*  542154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  542165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  542168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  542171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542182 */     // MIs[0] passthru
     /*  542182 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  542201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542218 */     GIR_RootConstrainSelectedInstOperands,
     /*  542219 */     // GIR_Coverage, 4416,
     /*  542219 */     GIR_EraseRootFromParent_Done,
     /*  542220 */   // Label 8971: @542220
     /*  542220 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(542291), // Rule ID 4417 //
     /*  542225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  542228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  542233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  542236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  542239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  542242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542253 */     // MIs[0] passthru
     /*  542253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  542272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542289 */     GIR_RootConstrainSelectedInstOperands,
     /*  542290 */     // GIR_Coverage, 4417,
     /*  542290 */     GIR_EraseRootFromParent_Done,
     /*  542291 */   // Label 8972: @542291
     /*  542291 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(542362), // Rule ID 4486 //
     /*  542296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  542307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  542310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  542313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542324 */     // MIs[0] passthru
     /*  542324 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  542343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542360 */     GIR_RootConstrainSelectedInstOperands,
     /*  542361 */     // GIR_Coverage, 4486,
     /*  542361 */     GIR_EraseRootFromParent_Done,
     /*  542362 */   // Label 8973: @542362
     /*  542362 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(542433), // Rule ID 4487 //
     /*  542367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  542378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  542381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  542384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542395 */     // MIs[0] passthru
     /*  542395 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542411 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  542414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542431 */     GIR_RootConstrainSelectedInstOperands,
     /*  542432 */     // GIR_Coverage, 4487,
     /*  542432 */     GIR_EraseRootFromParent_Done,
     /*  542433 */   // Label 8974: @542433
     /*  542433 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(542504), // Rule ID 4496 //
     /*  542438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542466 */     // MIs[0] passthru
     /*  542466 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542502 */     GIR_RootConstrainSelectedInstOperands,
     /*  542503 */     // GIR_Coverage, 4496,
     /*  542503 */     GIR_EraseRootFromParent_Done,
     /*  542504 */   // Label 8975: @542504
     /*  542504 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(542575), // Rule ID 4497 //
     /*  542509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542537 */     // MIs[0] passthru
     /*  542537 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542553 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542573 */     GIR_RootConstrainSelectedInstOperands,
     /*  542574 */     // GIR_Coverage, 4497,
     /*  542574 */     GIR_EraseRootFromParent_Done,
     /*  542575 */   // Label 8976: @542575
     /*  542575 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(542646), // Rule ID 4506 //
     /*  542580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542608 */     // MIs[0] passthru
     /*  542608 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542644 */     GIR_RootConstrainSelectedInstOperands,
     /*  542645 */     // GIR_Coverage, 4506,
     /*  542645 */     GIR_EraseRootFromParent_Done,
     /*  542646 */   // Label 8977: @542646
     /*  542646 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(542717), // Rule ID 4507 //
     /*  542651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542679 */     // MIs[0] passthru
     /*  542679 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542695 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542715 */     GIR_RootConstrainSelectedInstOperands,
     /*  542716 */     // GIR_Coverage, 4507,
     /*  542716 */     GIR_EraseRootFromParent_Done,
     /*  542717 */   // Label 8978: @542717
     /*  542717 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(542788), // Rule ID 4516 //
     /*  542722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542750 */     // MIs[0] passthru
     /*  542750 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542786 */     GIR_RootConstrainSelectedInstOperands,
     /*  542787 */     // GIR_Coverage, 4516,
     /*  542787 */     GIR_EraseRootFromParent_Done,
     /*  542788 */   // Label 8979: @542788
     /*  542788 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(542859), // Rule ID 4517 //
     /*  542793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542821 */     // MIs[0] passthru
     /*  542821 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542857 */     GIR_RootConstrainSelectedInstOperands,
     /*  542858 */     // GIR_Coverage, 4517,
     /*  542858 */     GIR_EraseRootFromParent_Done,
     /*  542859 */   // Label 8980: @542859
     /*  542859 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(542930), // Rule ID 4526 //
     /*  542864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542892 */     // MIs[0] passthru
     /*  542892 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542928 */     GIR_RootConstrainSelectedInstOperands,
     /*  542929 */     // GIR_Coverage, 4526,
     /*  542929 */     GIR_EraseRootFromParent_Done,
     /*  542930 */   // Label 8981: @542930
     /*  542930 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(543001), // Rule ID 4527 //
     /*  542935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542963 */     // MIs[0] passthru
     /*  542963 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542979 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542999 */     GIR_RootConstrainSelectedInstOperands,
     /*  543000 */     // GIR_Coverage, 4527,
     /*  543000 */     GIR_EraseRootFromParent_Done,
     /*  543001 */   // Label 8982: @543001
     /*  543001 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(543072), // Rule ID 4536 //
     /*  543006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  543017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  543020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  543023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543034 */     // MIs[0] passthru
     /*  543034 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543050 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543070 */     GIR_RootConstrainSelectedInstOperands,
     /*  543071 */     // GIR_Coverage, 4536,
     /*  543071 */     GIR_EraseRootFromParent_Done,
     /*  543072 */   // Label 8983: @543072
     /*  543072 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(543143), // Rule ID 4537 //
     /*  543077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  543088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  543091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  543094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543105 */     // MIs[0] passthru
     /*  543105 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543141 */     GIR_RootConstrainSelectedInstOperands,
     /*  543142 */     // GIR_Coverage, 4537,
     /*  543142 */     GIR_EraseRootFromParent_Done,
     /*  543143 */   // Label 8984: @543143
     /*  543143 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(543214), // Rule ID 4546 //
     /*  543148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  543159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  543162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  543165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543176 */     // MIs[0] passthru
     /*  543176 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  543195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543212 */     GIR_RootConstrainSelectedInstOperands,
     /*  543213 */     // GIR_Coverage, 4546,
     /*  543213 */     GIR_EraseRootFromParent_Done,
     /*  543214 */   // Label 8985: @543214
     /*  543214 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(543285), // Rule ID 4547 //
     /*  543219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  543230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  543233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  543236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543247 */     // MIs[0] passthru
     /*  543247 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  543266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543283 */     GIR_RootConstrainSelectedInstOperands,
     /*  543284 */     // GIR_Coverage, 4547,
     /*  543284 */     GIR_EraseRootFromParent_Done,
     /*  543285 */   // Label 8986: @543285
     /*  543285 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(543356), // Rule ID 4556 //
     /*  543290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  543301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  543304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  543307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543318 */     // MIs[0] passthru
     /*  543318 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543354 */     GIR_RootConstrainSelectedInstOperands,
     /*  543355 */     // GIR_Coverage, 4556,
     /*  543355 */     GIR_EraseRootFromParent_Done,
     /*  543356 */   // Label 8987: @543356
     /*  543356 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(543427), // Rule ID 4557 //
     /*  543361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  543372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  543375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  543378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543389 */     // MIs[0] passthru
     /*  543389 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543405 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543425 */     GIR_RootConstrainSelectedInstOperands,
     /*  543426 */     // GIR_Coverage, 4557,
     /*  543426 */     GIR_EraseRootFromParent_Done,
     /*  543427 */   // Label 8988: @543427
     /*  543427 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(543498), // Rule ID 4566 //
     /*  543432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543460 */     // MIs[0] passthru
     /*  543460 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543496 */     GIR_RootConstrainSelectedInstOperands,
     /*  543497 */     // GIR_Coverage, 4566,
     /*  543497 */     GIR_EraseRootFromParent_Done,
     /*  543498 */   // Label 8989: @543498
     /*  543498 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(543569), // Rule ID 4567 //
     /*  543503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543531 */     // MIs[0] passthru
     /*  543531 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543567 */     GIR_RootConstrainSelectedInstOperands,
     /*  543568 */     // GIR_Coverage, 4567,
     /*  543568 */     GIR_EraseRootFromParent_Done,
     /*  543569 */   // Label 8990: @543569
     /*  543569 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(543640), // Rule ID 4576 //
     /*  543574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543602 */     // MIs[0] passthru
     /*  543602 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543638 */     GIR_RootConstrainSelectedInstOperands,
     /*  543639 */     // GIR_Coverage, 4576,
     /*  543639 */     GIR_EraseRootFromParent_Done,
     /*  543640 */   // Label 8991: @543640
     /*  543640 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(543711), // Rule ID 4577 //
     /*  543645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543673 */     // MIs[0] passthru
     /*  543673 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543709 */     GIR_RootConstrainSelectedInstOperands,
     /*  543710 */     // GIR_Coverage, 4577,
     /*  543710 */     GIR_EraseRootFromParent_Done,
     /*  543711 */   // Label 8992: @543711
     /*  543711 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(543782), // Rule ID 4586 //
     /*  543716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543744 */     // MIs[0] passthru
     /*  543744 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543780 */     GIR_RootConstrainSelectedInstOperands,
     /*  543781 */     // GIR_Coverage, 4586,
     /*  543781 */     GIR_EraseRootFromParent_Done,
     /*  543782 */   // Label 8993: @543782
     /*  543782 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(543853), // Rule ID 4587 //
     /*  543787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543815 */     // MIs[0] passthru
     /*  543815 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543831 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543851 */     GIR_RootConstrainSelectedInstOperands,
     /*  543852 */     // GIR_Coverage, 4587,
     /*  543852 */     GIR_EraseRootFromParent_Done,
     /*  543853 */   // Label 8994: @543853
     /*  543853 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(543924), // Rule ID 4596 //
     /*  543858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543886 */     // MIs[0] passthru
     /*  543886 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543922 */     GIR_RootConstrainSelectedInstOperands,
     /*  543923 */     // GIR_Coverage, 4596,
     /*  543923 */     GIR_EraseRootFromParent_Done,
     /*  543924 */   // Label 8995: @543924
     /*  543924 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(543995), // Rule ID 4597 //
     /*  543929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543957 */     // MIs[0] passthru
     /*  543957 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543973 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543993 */     GIR_RootConstrainSelectedInstOperands,
     /*  543994 */     // GIR_Coverage, 4597,
     /*  543994 */     GIR_EraseRootFromParent_Done,
     /*  543995 */   // Label 8996: @543995
     /*  543995 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(544066), // Rule ID 4606 //
     /*  544000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  544011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  544014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  544017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544028 */     // MIs[0] passthru
     /*  544028 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  544047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544064 */     GIR_RootConstrainSelectedInstOperands,
     /*  544065 */     // GIR_Coverage, 4606,
     /*  544065 */     GIR_EraseRootFromParent_Done,
     /*  544066 */   // Label 8997: @544066
     /*  544066 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(544137), // Rule ID 4607 //
     /*  544071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  544082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  544085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  544088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544099 */     // MIs[0] passthru
     /*  544099 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  544118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544135 */     GIR_RootConstrainSelectedInstOperands,
     /*  544136 */     // GIR_Coverage, 4607,
     /*  544136 */     GIR_EraseRootFromParent_Done,
     /*  544137 */   // Label 8998: @544137
     /*  544137 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(544208), // Rule ID 4616 //
     /*  544142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  544153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  544156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  544159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544170 */     // MIs[0] passthru
     /*  544170 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  544189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544206 */     GIR_RootConstrainSelectedInstOperands,
     /*  544207 */     // GIR_Coverage, 4616,
     /*  544207 */     GIR_EraseRootFromParent_Done,
     /*  544208 */   // Label 8999: @544208
     /*  544208 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(544279), // Rule ID 4617 //
     /*  544213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  544224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  544227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  544230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544241 */     // MIs[0] passthru
     /*  544241 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544257 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  544260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544277 */     GIR_RootConstrainSelectedInstOperands,
     /*  544278 */     // GIR_Coverage, 4617,
     /*  544278 */     GIR_EraseRootFromParent_Done,
     /*  544279 */   // Label 9000: @544279
     /*  544279 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(544350), // Rule ID 4626 //
     /*  544284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  544287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  544295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  544298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  544301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544312 */     // MIs[0] passthru
     /*  544312 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  544328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  544331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544348 */     GIR_RootConstrainSelectedInstOperands,
     /*  544349 */     // GIR_Coverage, 4626,
     /*  544349 */     GIR_EraseRootFromParent_Done,
     /*  544350 */   // Label 9001: @544350
     /*  544350 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(544421), // Rule ID 4627 //
     /*  544355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  544358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  544363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  544366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  544369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  544372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544383 */     // MIs[0] passthru
     /*  544383 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544399 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  544399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  544402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  544416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544419 */     GIR_RootConstrainSelectedInstOperands,
     /*  544420 */     // GIR_Coverage, 4627,
     /*  544420 */     GIR_EraseRootFromParent_Done,
     /*  544421 */   // Label 9002: @544421
     /*  544421 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(544492), // Rule ID 4696 //
     /*  544426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544454 */     // MIs[0] passthru
     /*  544454 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544490 */     GIR_RootConstrainSelectedInstOperands,
     /*  544491 */     // GIR_Coverage, 4696,
     /*  544491 */     GIR_EraseRootFromParent_Done,
     /*  544492 */   // Label 9003: @544492
     /*  544492 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(544563), // Rule ID 4697 //
     /*  544497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544525 */     // MIs[0] passthru
     /*  544525 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544541 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544561 */     GIR_RootConstrainSelectedInstOperands,
     /*  544562 */     // GIR_Coverage, 4697,
     /*  544562 */     GIR_EraseRootFromParent_Done,
     /*  544563 */   // Label 9004: @544563
     /*  544563 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(544634), // Rule ID 4706 //
     /*  544568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544596 */     // MIs[0] passthru
     /*  544596 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544632 */     GIR_RootConstrainSelectedInstOperands,
     /*  544633 */     // GIR_Coverage, 4706,
     /*  544633 */     GIR_EraseRootFromParent_Done,
     /*  544634 */   // Label 9005: @544634
     /*  544634 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(544705), // Rule ID 4707 //
     /*  544639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544667 */     // MIs[0] passthru
     /*  544667 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544683 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544703 */     GIR_RootConstrainSelectedInstOperands,
     /*  544704 */     // GIR_Coverage, 4707,
     /*  544704 */     GIR_EraseRootFromParent_Done,
     /*  544705 */   // Label 9006: @544705
     /*  544705 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(544776), // Rule ID 4716 //
     /*  544710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544738 */     // MIs[0] passthru
     /*  544738 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544774 */     GIR_RootConstrainSelectedInstOperands,
     /*  544775 */     // GIR_Coverage, 4716,
     /*  544775 */     GIR_EraseRootFromParent_Done,
     /*  544776 */   // Label 9007: @544776
     /*  544776 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(544847), // Rule ID 4717 //
     /*  544781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544809 */     // MIs[0] passthru
     /*  544809 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544845 */     GIR_RootConstrainSelectedInstOperands,
     /*  544846 */     // GIR_Coverage, 4717,
     /*  544846 */     GIR_EraseRootFromParent_Done,
     /*  544847 */   // Label 9008: @544847
     /*  544847 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(544918), // Rule ID 4726 //
     /*  544852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544880 */     // MIs[0] passthru
     /*  544880 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544916 */     GIR_RootConstrainSelectedInstOperands,
     /*  544917 */     // GIR_Coverage, 4726,
     /*  544917 */     GIR_EraseRootFromParent_Done,
     /*  544918 */   // Label 9009: @544918
     /*  544918 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(544989), // Rule ID 4727 //
     /*  544923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544951 */     // MIs[0] passthru
     /*  544951 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544987 */     GIR_RootConstrainSelectedInstOperands,
     /*  544988 */     // GIR_Coverage, 4727,
     /*  544988 */     GIR_EraseRootFromParent_Done,
     /*  544989 */   // Label 9010: @544989
     /*  544989 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(545060), // Rule ID 4736 //
     /*  544994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  545011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545022 */     // MIs[0] passthru
     /*  545022 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545058 */     GIR_RootConstrainSelectedInstOperands,
     /*  545059 */     // GIR_Coverage, 4736,
     /*  545059 */     GIR_EraseRootFromParent_Done,
     /*  545060 */   // Label 9011: @545060
     /*  545060 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(545131), // Rule ID 4737 //
     /*  545065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  545076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  545079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  545082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545093 */     // MIs[0] passthru
     /*  545093 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545109 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545129 */     GIR_RootConstrainSelectedInstOperands,
     /*  545130 */     // GIR_Coverage, 4737,
     /*  545130 */     GIR_EraseRootFromParent_Done,
     /*  545131 */   // Label 9012: @545131
     /*  545131 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(545202), // Rule ID 4746 //
     /*  545136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  545147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  545150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  545153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545164 */     // MIs[0] passthru
     /*  545164 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545200 */     GIR_RootConstrainSelectedInstOperands,
     /*  545201 */     // GIR_Coverage, 4746,
     /*  545201 */     GIR_EraseRootFromParent_Done,
     /*  545202 */   // Label 9013: @545202
     /*  545202 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(545273), // Rule ID 4747 //
     /*  545207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  545218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  545221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  545224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545235 */     // MIs[0] passthru
     /*  545235 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545271 */     GIR_RootConstrainSelectedInstOperands,
     /*  545272 */     // GIR_Coverage, 4747,
     /*  545272 */     GIR_EraseRootFromParent_Done,
     /*  545273 */   // Label 9014: @545273
     /*  545273 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(545344), // Rule ID 4756 //
     /*  545278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  545289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  545292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  545295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545306 */     // MIs[0] passthru
     /*  545306 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  545325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545342 */     GIR_RootConstrainSelectedInstOperands,
     /*  545343 */     // GIR_Coverage, 4756,
     /*  545343 */     GIR_EraseRootFromParent_Done,
     /*  545344 */   // Label 9015: @545344
     /*  545344 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(545415), // Rule ID 4757 //
     /*  545349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  545360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  545363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  545366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545377 */     // MIs[0] passthru
     /*  545377 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545393 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  545396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545413 */     GIR_RootConstrainSelectedInstOperands,
     /*  545414 */     // GIR_Coverage, 4757,
     /*  545414 */     GIR_EraseRootFromParent_Done,
     /*  545415 */   // Label 9016: @545415
     /*  545415 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(545486), // Rule ID 4766 //
     /*  545420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545448 */     // MIs[0] passthru
     /*  545448 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545484 */     GIR_RootConstrainSelectedInstOperands,
     /*  545485 */     // GIR_Coverage, 4766,
     /*  545485 */     GIR_EraseRootFromParent_Done,
     /*  545486 */   // Label 9017: @545486
     /*  545486 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(545557), // Rule ID 4767 //
     /*  545491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545519 */     // MIs[0] passthru
     /*  545519 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545535 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545555 */     GIR_RootConstrainSelectedInstOperands,
     /*  545556 */     // GIR_Coverage, 4767,
     /*  545556 */     GIR_EraseRootFromParent_Done,
     /*  545557 */   // Label 9018: @545557
     /*  545557 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(545628), // Rule ID 4776 //
     /*  545562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545590 */     // MIs[0] passthru
     /*  545590 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545626 */     GIR_RootConstrainSelectedInstOperands,
     /*  545627 */     // GIR_Coverage, 4776,
     /*  545627 */     GIR_EraseRootFromParent_Done,
     /*  545628 */   // Label 9019: @545628
     /*  545628 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(545699), // Rule ID 4777 //
     /*  545633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545661 */     // MIs[0] passthru
     /*  545661 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545697 */     GIR_RootConstrainSelectedInstOperands,
     /*  545698 */     // GIR_Coverage, 4777,
     /*  545698 */     GIR_EraseRootFromParent_Done,
     /*  545699 */   // Label 9020: @545699
     /*  545699 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(545770), // Rule ID 4786 //
     /*  545704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545732 */     // MIs[0] passthru
     /*  545732 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545768 */     GIR_RootConstrainSelectedInstOperands,
     /*  545769 */     // GIR_Coverage, 4786,
     /*  545769 */     GIR_EraseRootFromParent_Done,
     /*  545770 */   // Label 9021: @545770
     /*  545770 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(545841), // Rule ID 4787 //
     /*  545775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545803 */     // MIs[0] passthru
     /*  545803 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545839 */     GIR_RootConstrainSelectedInstOperands,
     /*  545840 */     // GIR_Coverage, 4787,
     /*  545840 */     GIR_EraseRootFromParent_Done,
     /*  545841 */   // Label 9022: @545841
     /*  545841 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(545912), // Rule ID 4796 //
     /*  545846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545874 */     // MIs[0] passthru
     /*  545874 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545910 */     GIR_RootConstrainSelectedInstOperands,
     /*  545911 */     // GIR_Coverage, 4796,
     /*  545911 */     GIR_EraseRootFromParent_Done,
     /*  545912 */   // Label 9023: @545912
     /*  545912 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(545983), // Rule ID 4797 //
     /*  545917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545945 */     // MIs[0] passthru
     /*  545945 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545981 */     GIR_RootConstrainSelectedInstOperands,
     /*  545982 */     // GIR_Coverage, 4797,
     /*  545982 */     GIR_EraseRootFromParent_Done,
     /*  545983 */   // Label 9024: @545983
     /*  545983 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(546054), // Rule ID 4806 //
     /*  545988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  546002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  546005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546016 */     // MIs[0] passthru
     /*  546016 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  546035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546052 */     GIR_RootConstrainSelectedInstOperands,
     /*  546053 */     // GIR_Coverage, 4806,
     /*  546053 */     GIR_EraseRootFromParent_Done,
     /*  546054 */   // Label 9025: @546054
     /*  546054 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(546125), // Rule ID 4807 //
     /*  546059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  546070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  546073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  546076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546087 */     // MIs[0] passthru
     /*  546087 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  546106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546123 */     GIR_RootConstrainSelectedInstOperands,
     /*  546124 */     // GIR_Coverage, 4807,
     /*  546124 */     GIR_EraseRootFromParent_Done,
     /*  546125 */   // Label 9026: @546125
     /*  546125 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(546196), // Rule ID 4816 //
     /*  546130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  546147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546158 */     // MIs[0] passthru
     /*  546158 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  546177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546194 */     GIR_RootConstrainSelectedInstOperands,
     /*  546195 */     // GIR_Coverage, 4816,
     /*  546195 */     GIR_EraseRootFromParent_Done,
     /*  546196 */   // Label 9027: @546196
     /*  546196 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(546267), // Rule ID 4817 //
     /*  546201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  546212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  546215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  546218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546229 */     // MIs[0] passthru
     /*  546229 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546245 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  546248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546265 */     GIR_RootConstrainSelectedInstOperands,
     /*  546266 */     // GIR_Coverage, 4817,
     /*  546266 */     GIR_EraseRootFromParent_Done,
     /*  546267 */   // Label 9028: @546267
     /*  546267 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(546338), // Rule ID 4826 //
     /*  546272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  546289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546300 */     // MIs[0] passthru
     /*  546300 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  546319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546336 */     GIR_RootConstrainSelectedInstOperands,
     /*  546337 */     // GIR_Coverage, 4826,
     /*  546337 */     GIR_EraseRootFromParent_Done,
     /*  546338 */   // Label 9029: @546338
     /*  546338 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(546409), // Rule ID 4827 //
     /*  546343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  546354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  546357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  546360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546371 */     // MIs[0] passthru
     /*  546371 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546387 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  546390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546407 */     GIR_RootConstrainSelectedInstOperands,
     /*  546408 */     // GIR_Coverage, 4827,
     /*  546408 */     GIR_EraseRootFromParent_Done,
     /*  546409 */   // Label 9030: @546409
     /*  546409 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(546480), // Rule ID 4836 //
     /*  546414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  546417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546442 */     // MIs[0] passthru
     /*  546442 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546458 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  546458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546478 */     GIR_RootConstrainSelectedInstOperands,
     /*  546479 */     // GIR_Coverage, 4836,
     /*  546479 */     GIR_EraseRootFromParent_Done,
     /*  546480 */   // Label 9031: @546480
     /*  546480 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(546551), // Rule ID 4837 //
     /*  546485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546513 */     // MIs[0] passthru
     /*  546513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546529 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546549 */     GIR_RootConstrainSelectedInstOperands,
     /*  546550 */     // GIR_Coverage, 4837,
     /*  546550 */     GIR_EraseRootFromParent_Done,
     /*  546551 */   // Label 9032: @546551
     /*  546551 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(546623), // Rule ID 2692 //
     /*  546556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546621 */     GIR_RootConstrainSelectedInstOperands,
     /*  546622 */     // GIR_Coverage, 2692,
     /*  546622 */     GIR_EraseRootFromParent_Done,
     /*  546623 */   // Label 9033: @546623
     /*  546623 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(546695), // Rule ID 2693 //
     /*  546628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546674 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546693 */     GIR_RootConstrainSelectedInstOperands,
     /*  546694 */     // GIR_Coverage, 2693,
     /*  546694 */     GIR_EraseRootFromParent_Done,
     /*  546695 */   // Label 9034: @546695
     /*  546695 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(546770), // Rule ID 2696 //
     /*  546700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  546703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  546746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546768 */     GIR_RootConstrainSelectedInstOperands,
     /*  546769 */     // GIR_Coverage, 2696,
     /*  546769 */     GIR_EraseRootFromParent_Done,
     /*  546770 */   // Label 9035: @546770
     /*  546770 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(546845), // Rule ID 2697 //
     /*  546775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  546778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546821 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  546821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546843 */     GIR_RootConstrainSelectedInstOperands,
     /*  546844 */     // GIR_Coverage, 2697,
     /*  546844 */     GIR_EraseRootFromParent_Done,
     /*  546845 */   // Label 9036: @546845
     /*  546845 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(546920), // Rule ID 2724 //
     /*  546850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546918 */     GIR_RootConstrainSelectedInstOperands,
     /*  546919 */     // GIR_Coverage, 2724,
     /*  546919 */     GIR_EraseRootFromParent_Done,
     /*  546920 */   // Label 9037: @546920
     /*  546920 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(546995), // Rule ID 2725 //
     /*  546925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546993 */     GIR_RootConstrainSelectedInstOperands,
     /*  546994 */     // GIR_Coverage, 2725,
     /*  546994 */     GIR_EraseRootFromParent_Done,
     /*  546995 */   // Label 9038: @546995
     /*  546995 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(547067), // Rule ID 2738 //
     /*  547000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  547008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  547011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  547020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  547039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  547046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  547049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  547053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  547057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547065 */     GIR_RootConstrainSelectedInstOperands,
     /*  547066 */     // GIR_Coverage, 2738,
     /*  547066 */     GIR_EraseRootFromParent_Done,
     /*  547067 */   // Label 9039: @547067
     /*  547067 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(547139), // Rule ID 2739 //
     /*  547072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  547080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  547083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  547092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  547111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  547118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  547121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  547125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  547129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547137 */     GIR_RootConstrainSelectedInstOperands,
     /*  547138 */     // GIR_Coverage, 2739,
     /*  547138 */     GIR_EraseRootFromParent_Done,
     /*  547139 */   // Label 9040: @547139
     /*  547139 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(547214), // Rule ID 2758 //
     /*  547144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  547152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  547193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547212 */     GIR_RootConstrainSelectedInstOperands,
     /*  547213 */     // GIR_Coverage, 2758,
     /*  547213 */     GIR_EraseRootFromParent_Done,
     /*  547214 */   // Label 9041: @547214
     /*  547214 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(547289), // Rule ID 2759 //
     /*  547219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  547227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547265 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  547268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547287 */     GIR_RootConstrainSelectedInstOperands,
     /*  547288 */     // GIR_Coverage, 2759,
     /*  547288 */     GIR_EraseRootFromParent_Done,
     /*  547289 */   // Label 9042: @547289
     /*  547289 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(547364), // Rule ID 2784 //
     /*  547294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  547302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  547343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  547347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547362 */     GIR_RootConstrainSelectedInstOperands,
     /*  547363 */     // GIR_Coverage, 2784,
     /*  547363 */     GIR_EraseRootFromParent_Done,
     /*  547364 */   // Label 9043: @547364
     /*  547364 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(547439), // Rule ID 2785 //
     /*  547369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  547377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547415 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  547418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  547422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  547424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547437 */     GIR_RootConstrainSelectedInstOperands,
     /*  547438 */     // GIR_Coverage, 2785,
     /*  547438 */     GIR_EraseRootFromParent_Done,
     /*  547439 */   // Label 9044: @547439
     /*  547439 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(547514), // Rule ID 2796 //
     /*  547444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547512 */     GIR_RootConstrainSelectedInstOperands,
     /*  547513 */     // GIR_Coverage, 2796,
     /*  547513 */     GIR_EraseRootFromParent_Done,
     /*  547514 */   // Label 9045: @547514
     /*  547514 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(547589), // Rule ID 2797 //
     /*  547519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547565 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547587 */     GIR_RootConstrainSelectedInstOperands,
     /*  547588 */     // GIR_Coverage, 2797,
     /*  547588 */     GIR_EraseRootFromParent_Done,
     /*  547589 */   // Label 9046: @547589
     /*  547589 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(547664), // Rule ID 2804 //
     /*  547594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547640 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547662 */     GIR_RootConstrainSelectedInstOperands,
     /*  547663 */     // GIR_Coverage, 2804,
     /*  547663 */     GIR_EraseRootFromParent_Done,
     /*  547664 */   // Label 9047: @547664
     /*  547664 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(547739), // Rule ID 2805 //
     /*  547669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547715 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547737 */     GIR_RootConstrainSelectedInstOperands,
     /*  547738 */     // GIR_Coverage, 2805,
     /*  547738 */     GIR_EraseRootFromParent_Done,
     /*  547739 */   // Label 9048: @547739
     /*  547739 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(547814), // Rule ID 2812 //
     /*  547744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547790 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547812 */     GIR_RootConstrainSelectedInstOperands,
     /*  547813 */     // GIR_Coverage, 2812,
     /*  547813 */     GIR_EraseRootFromParent_Done,
     /*  547814 */   // Label 9049: @547814
     /*  547814 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(547889), // Rule ID 2813 //
     /*  547819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547865 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547887 */     GIR_RootConstrainSelectedInstOperands,
     /*  547888 */     // GIR_Coverage, 2813,
     /*  547888 */     GIR_EraseRootFromParent_Done,
     /*  547889 */   // Label 9050: @547889
     /*  547889 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(547964), // Rule ID 2820 //
     /*  547894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547962 */     GIR_RootConstrainSelectedInstOperands,
     /*  547963 */     // GIR_Coverage, 2820,
     /*  547963 */     GIR_EraseRootFromParent_Done,
     /*  547964 */   // Label 9051: @547964
     /*  547964 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(548039), // Rule ID 2821 //
     /*  547969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  548018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548037 */     GIR_RootConstrainSelectedInstOperands,
     /*  548038 */     // GIR_Coverage, 2821,
     /*  548038 */     GIR_EraseRootFromParent_Done,
     /*  548039 */   // Label 9052: @548039
     /*  548039 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(548114), // Rule ID 2828 //
     /*  548044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  548061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548112 */     GIR_RootConstrainSelectedInstOperands,
     /*  548113 */     // GIR_Coverage, 2828,
     /*  548113 */     GIR_EraseRootFromParent_Done,
     /*  548114 */   // Label 9053: @548114
     /*  548114 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(548189), // Rule ID 2829 //
     /*  548119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  548136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548165 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548187 */     GIR_RootConstrainSelectedInstOperands,
     /*  548188 */     // GIR_Coverage, 2829,
     /*  548188 */     GIR_EraseRootFromParent_Done,
     /*  548189 */   // Label 9054: @548189
     /*  548189 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(548264), // Rule ID 2836 //
     /*  548194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  548211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  548214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548262 */     GIR_RootConstrainSelectedInstOperands,
     /*  548263 */     // GIR_Coverage, 2836,
     /*  548263 */     GIR_EraseRootFromParent_Done,
     /*  548264 */   // Label 9055: @548264
     /*  548264 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(548339), // Rule ID 2837 //
     /*  548269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  548286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  548289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548315 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  548318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548337 */     GIR_RootConstrainSelectedInstOperands,
     /*  548338 */     // GIR_Coverage, 2837,
     /*  548338 */     GIR_EraseRootFromParent_Done,
     /*  548339 */   // Label 9056: @548339
     /*  548339 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(548414), // Rule ID 2844 //
     /*  548344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  548355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  548358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  548361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548412 */     GIR_RootConstrainSelectedInstOperands,
     /*  548413 */     // GIR_Coverage, 2844,
     /*  548413 */     GIR_EraseRootFromParent_Done,
     /*  548414 */   // Label 9057: @548414
     /*  548414 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(548489), // Rule ID 2845 //
     /*  548419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  548430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  548433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  548436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548465 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548487 */     GIR_RootConstrainSelectedInstOperands,
     /*  548488 */     // GIR_Coverage, 2845,
     /*  548488 */     GIR_EraseRootFromParent_Done,
     /*  548489 */   // Label 9058: @548489
     /*  548489 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(548564), // Rule ID 2852 //
     /*  548494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548562 */     GIR_RootConstrainSelectedInstOperands,
     /*  548563 */     // GIR_Coverage, 2852,
     /*  548563 */     GIR_EraseRootFromParent_Done,
     /*  548564 */   // Label 9059: @548564
     /*  548564 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(548639), // Rule ID 2853 //
     /*  548569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548637 */     GIR_RootConstrainSelectedInstOperands,
     /*  548638 */     // GIR_Coverage, 2853,
     /*  548638 */     GIR_EraseRootFromParent_Done,
     /*  548639 */   // Label 9060: @548639
     /*  548639 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(548714), // Rule ID 2860 //
     /*  548644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548712 */     GIR_RootConstrainSelectedInstOperands,
     /*  548713 */     // GIR_Coverage, 2860,
     /*  548713 */     GIR_EraseRootFromParent_Done,
     /*  548714 */   // Label 9061: @548714
     /*  548714 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(548789), // Rule ID 2861 //
     /*  548719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548787 */     GIR_RootConstrainSelectedInstOperands,
     /*  548788 */     // GIR_Coverage, 2861,
     /*  548788 */     GIR_EraseRootFromParent_Done,
     /*  548789 */   // Label 9062: @548789
     /*  548789 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(548864), // Rule ID 2868 //
     /*  548794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  548797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  548840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548862 */     GIR_RootConstrainSelectedInstOperands,
     /*  548863 */     // GIR_Coverage, 2868,
     /*  548863 */     GIR_EraseRootFromParent_Done,
     /*  548864 */   // Label 9063: @548864
     /*  548864 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(548939), // Rule ID 2869 //
     /*  548869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  548872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  548915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548937 */     GIR_RootConstrainSelectedInstOperands,
     /*  548938 */     // GIR_Coverage, 2869,
     /*  548938 */     GIR_EraseRootFromParent_Done,
     /*  548939 */   // Label 9064: @548939
     /*  548939 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(549014), // Rule ID 2876 //
     /*  548944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549012 */     GIR_RootConstrainSelectedInstOperands,
     /*  549013 */     // GIR_Coverage, 2876,
     /*  549013 */     GIR_EraseRootFromParent_Done,
     /*  549014 */   // Label 9065: @549014
     /*  549014 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(549089), // Rule ID 2877 //
     /*  549019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  549030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  549033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  549036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  549039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549065 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549087 */     GIR_RootConstrainSelectedInstOperands,
     /*  549088 */     // GIR_Coverage, 2877,
     /*  549088 */     GIR_EraseRootFromParent_Done,
     /*  549089 */   // Label 9066: @549089
     /*  549089 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(549164), // Rule ID 2884 //
     /*  549094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  549105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  549108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  549111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  549114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549162 */     GIR_RootConstrainSelectedInstOperands,
     /*  549163 */     // GIR_Coverage, 2884,
     /*  549163 */     GIR_EraseRootFromParent_Done,
     /*  549164 */   // Label 9067: @549164
     /*  549164 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(549239), // Rule ID 2885 //
     /*  549169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  549180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  549183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  549186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  549189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549215 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549237 */     GIR_RootConstrainSelectedInstOperands,
     /*  549238 */     // GIR_Coverage, 2885,
     /*  549238 */     GIR_EraseRootFromParent_Done,
     /*  549239 */   // Label 9068: @549239
     /*  549239 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(549314), // Rule ID 2892 //
     /*  549244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  549255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  549258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  549261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  549264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549312 */     GIR_RootConstrainSelectedInstOperands,
     /*  549313 */     // GIR_Coverage, 2892,
     /*  549313 */     GIR_EraseRootFromParent_Done,
     /*  549314 */   // Label 9069: @549314
     /*  549314 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(549389), // Rule ID 2893 //
     /*  549319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  549330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  549333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  549336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  549339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549365 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549387 */     GIR_RootConstrainSelectedInstOperands,
     /*  549388 */     // GIR_Coverage, 2893,
     /*  549388 */     GIR_EraseRootFromParent_Done,
     /*  549389 */   // Label 9070: @549389
     /*  549389 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(549464), // Rule ID 2900 //
     /*  549394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549462 */     GIR_RootConstrainSelectedInstOperands,
     /*  549463 */     // GIR_Coverage, 2900,
     /*  549463 */     GIR_EraseRootFromParent_Done,
     /*  549464 */   // Label 9071: @549464
     /*  549464 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(549539), // Rule ID 2901 //
     /*  549469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549537 */     GIR_RootConstrainSelectedInstOperands,
     /*  549538 */     // GIR_Coverage, 2901,
     /*  549538 */     GIR_EraseRootFromParent_Done,
     /*  549539 */   // Label 9072: @549539
     /*  549539 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(549614), // Rule ID 2908 //
     /*  549544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549612 */     GIR_RootConstrainSelectedInstOperands,
     /*  549613 */     // GIR_Coverage, 2908,
     /*  549613 */     GIR_EraseRootFromParent_Done,
     /*  549614 */   // Label 9073: @549614
     /*  549614 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(549689), // Rule ID 2909 //
     /*  549619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549665 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549687 */     GIR_RootConstrainSelectedInstOperands,
     /*  549688 */     // GIR_Coverage, 2909,
     /*  549688 */     GIR_EraseRootFromParent_Done,
     /*  549689 */   // Label 9074: @549689
     /*  549689 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(549764), // Rule ID 2916 //
     /*  549694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549762 */     GIR_RootConstrainSelectedInstOperands,
     /*  549763 */     // GIR_Coverage, 2916,
     /*  549763 */     GIR_EraseRootFromParent_Done,
     /*  549764 */   // Label 9075: @549764
     /*  549764 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(549839), // Rule ID 2917 //
     /*  549769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549815 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549837 */     GIR_RootConstrainSelectedInstOperands,
     /*  549838 */     // GIR_Coverage, 2917,
     /*  549838 */     GIR_EraseRootFromParent_Done,
     /*  549839 */   // Label 9076: @549839
     /*  549839 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(549914), // Rule ID 2924 //
     /*  549844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549912 */     GIR_RootConstrainSelectedInstOperands,
     /*  549913 */     // GIR_Coverage, 2924,
     /*  549913 */     GIR_EraseRootFromParent_Done,
     /*  549914 */   // Label 9077: @549914
     /*  549914 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(549989), // Rule ID 2925 //
     /*  549919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549987 */     GIR_RootConstrainSelectedInstOperands,
     /*  549988 */     // GIR_Coverage, 2925,
     /*  549988 */     GIR_EraseRootFromParent_Done,
     /*  549989 */   // Label 9078: @549989
     /*  549989 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(550064), // Rule ID 2932 //
     /*  549994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  550005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  550008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  550011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  550014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550062 */     GIR_RootConstrainSelectedInstOperands,
     /*  550063 */     // GIR_Coverage, 2932,
     /*  550063 */     GIR_EraseRootFromParent_Done,
     /*  550064 */   // Label 9079: @550064
     /*  550064 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(550139), // Rule ID 2933 //
     /*  550069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  550080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  550083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  550086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  550089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550115 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550137 */     GIR_RootConstrainSelectedInstOperands,
     /*  550138 */     // GIR_Coverage, 2933,
     /*  550138 */     GIR_EraseRootFromParent_Done,
     /*  550139 */   // Label 9080: @550139
     /*  550139 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(550214), // Rule ID 2940 //
     /*  550144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  550155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  550158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  550161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  550164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550212 */     GIR_RootConstrainSelectedInstOperands,
     /*  550213 */     // GIR_Coverage, 2940,
     /*  550213 */     GIR_EraseRootFromParent_Done,
     /*  550214 */   // Label 9081: @550214
     /*  550214 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(550289), // Rule ID 2941 //
     /*  550219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  550230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  550233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  550236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  550239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550265 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550287 */     GIR_RootConstrainSelectedInstOperands,
     /*  550288 */     // GIR_Coverage, 2941,
     /*  550288 */     GIR_EraseRootFromParent_Done,
     /*  550289 */   // Label 9082: @550289
     /*  550289 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(550364), // Rule ID 2948 //
     /*  550294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  550305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  550308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  550311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  550314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  550343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550362 */     GIR_RootConstrainSelectedInstOperands,
     /*  550363 */     // GIR_Coverage, 2948,
     /*  550363 */     GIR_EraseRootFromParent_Done,
     /*  550364 */   // Label 9083: @550364
     /*  550364 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(550439), // Rule ID 2949 //
     /*  550369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  550380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  550383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  550386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  550389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  550408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  550418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550437 */     GIR_RootConstrainSelectedInstOperands,
     /*  550438 */     // GIR_Coverage, 2949,
     /*  550438 */     GIR_EraseRootFromParent_Done,
     /*  550439 */   // Label 9084: @550439
     /*  550439 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(550514), // Rule ID 2956 //
     /*  550444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550512 */     GIR_RootConstrainSelectedInstOperands,
     /*  550513 */     // GIR_Coverage, 2956,
     /*  550513 */     GIR_EraseRootFromParent_Done,
     /*  550514 */   // Label 9085: @550514
     /*  550514 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(550589), // Rule ID 2957 //
     /*  550519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550587 */     GIR_RootConstrainSelectedInstOperands,
     /*  550588 */     // GIR_Coverage, 2957,
     /*  550588 */     GIR_EraseRootFromParent_Done,
     /*  550589 */   // Label 9086: @550589
     /*  550589 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(550664), // Rule ID 2964 //
     /*  550594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550662 */     GIR_RootConstrainSelectedInstOperands,
     /*  550663 */     // GIR_Coverage, 2964,
     /*  550663 */     GIR_EraseRootFromParent_Done,
     /*  550664 */   // Label 9087: @550664
     /*  550664 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(550739), // Rule ID 2965 //
     /*  550669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550715 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550737 */     GIR_RootConstrainSelectedInstOperands,
     /*  550738 */     // GIR_Coverage, 2965,
     /*  550738 */     GIR_EraseRootFromParent_Done,
     /*  550739 */   // Label 9088: @550739
     /*  550739 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(550814), // Rule ID 2980 //
     /*  550744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550812 */     GIR_RootConstrainSelectedInstOperands,
     /*  550813 */     // GIR_Coverage, 2980,
     /*  550813 */     GIR_EraseRootFromParent_Done,
     /*  550814 */   // Label 9089: @550814
     /*  550814 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(550889), // Rule ID 2981 //
     /*  550819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550865 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550887 */     GIR_RootConstrainSelectedInstOperands,
     /*  550888 */     // GIR_Coverage, 2981,
     /*  550888 */     GIR_EraseRootFromParent_Done,
     /*  550889 */   // Label 9090: @550889
     /*  550889 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(550964), // Rule ID 2984 //
     /*  550894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550962 */     GIR_RootConstrainSelectedInstOperands,
     /*  550963 */     // GIR_Coverage, 2984,
     /*  550963 */     GIR_EraseRootFromParent_Done,
     /*  550964 */   // Label 9091: @550964
     /*  550964 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(551039), // Rule ID 2985 //
     /*  550969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551015 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551037 */     GIR_RootConstrainSelectedInstOperands,
     /*  551038 */     // GIR_Coverage, 2985,
     /*  551038 */     GIR_EraseRootFromParent_Done,
     /*  551039 */   // Label 9092: @551039
     /*  551039 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(551114), // Rule ID 2988 //
     /*  551044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551090 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  551093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551112 */     GIR_RootConstrainSelectedInstOperands,
     /*  551113 */     // GIR_Coverage, 2988,
     /*  551113 */     GIR_EraseRootFromParent_Done,
     /*  551114 */   // Label 9093: @551114
     /*  551114 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(551189), // Rule ID 2989 //
     /*  551119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551165 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  551168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551187 */     GIR_RootConstrainSelectedInstOperands,
     /*  551188 */     // GIR_Coverage, 2989,
     /*  551188 */     GIR_EraseRootFromParent_Done,
     /*  551189 */   // Label 9094: @551189
     /*  551189 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(551264), // Rule ID 2992 //
     /*  551194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551262 */     GIR_RootConstrainSelectedInstOperands,
     /*  551263 */     // GIR_Coverage, 2992,
     /*  551263 */     GIR_EraseRootFromParent_Done,
     /*  551264 */   // Label 9095: @551264
     /*  551264 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(551339), // Rule ID 2993 //
     /*  551269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551337 */     GIR_RootConstrainSelectedInstOperands,
     /*  551338 */     // GIR_Coverage, 2993,
     /*  551338 */     GIR_EraseRootFromParent_Done,
     /*  551339 */   // Label 9096: @551339
     /*  551339 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(551414), // Rule ID 2996 //
     /*  551344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551412 */     GIR_RootConstrainSelectedInstOperands,
     /*  551413 */     // GIR_Coverage, 2996,
     /*  551413 */     GIR_EraseRootFromParent_Done,
     /*  551414 */   // Label 9097: @551414
     /*  551414 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(551489), // Rule ID 2997 //
     /*  551419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551487 */     GIR_RootConstrainSelectedInstOperands,
     /*  551488 */     // GIR_Coverage, 2997,
     /*  551488 */     GIR_EraseRootFromParent_Done,
     /*  551489 */   // Label 9098: @551489
     /*  551489 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(551564), // Rule ID 3000 //
     /*  551494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551562 */     GIR_RootConstrainSelectedInstOperands,
     /*  551563 */     // GIR_Coverage, 3000,
     /*  551563 */     GIR_EraseRootFromParent_Done,
     /*  551564 */   // Label 9099: @551564
     /*  551564 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(551639), // Rule ID 3001 //
     /*  551569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551615 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551637 */     GIR_RootConstrainSelectedInstOperands,
     /*  551638 */     // GIR_Coverage, 3001,
     /*  551638 */     GIR_EraseRootFromParent_Done,
     /*  551639 */   // Label 9100: @551639
     /*  551639 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(551714), // Rule ID 3004 //
     /*  551644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551712 */     GIR_RootConstrainSelectedInstOperands,
     /*  551713 */     // GIR_Coverage, 3004,
     /*  551713 */     GIR_EraseRootFromParent_Done,
     /*  551714 */   // Label 9101: @551714
     /*  551714 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(551789), // Rule ID 3005 //
     /*  551719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551787 */     GIR_RootConstrainSelectedInstOperands,
     /*  551788 */     // GIR_Coverage, 3005,
     /*  551788 */     GIR_EraseRootFromParent_Done,
     /*  551789 */   // Label 9102: @551789
     /*  551789 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(551864), // Rule ID 3008 //
     /*  551794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551862 */     GIR_RootConstrainSelectedInstOperands,
     /*  551863 */     // GIR_Coverage, 3008,
     /*  551863 */     GIR_EraseRootFromParent_Done,
     /*  551864 */   // Label 9103: @551864
     /*  551864 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(551939), // Rule ID 3009 //
     /*  551869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551937 */     GIR_RootConstrainSelectedInstOperands,
     /*  551938 */     // GIR_Coverage, 3009,
     /*  551938 */     GIR_EraseRootFromParent_Done,
     /*  551939 */   // Label 9104: @551939
     /*  551939 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(552014), // Rule ID 3012 //
     /*  551944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  551947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552012 */     GIR_RootConstrainSelectedInstOperands,
     /*  552013 */     // GIR_Coverage, 3012,
     /*  552013 */     GIR_EraseRootFromParent_Done,
     /*  552014 */   // Label 9105: @552014
     /*  552014 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(552089), // Rule ID 3013 //
     /*  552019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  552068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552087 */     GIR_RootConstrainSelectedInstOperands,
     /*  552088 */     // GIR_Coverage, 3013,
     /*  552088 */     GIR_EraseRootFromParent_Done,
     /*  552089 */   // Label 9106: @552089
     /*  552089 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(552164), // Rule ID 3016 //
     /*  552094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552162 */     GIR_RootConstrainSelectedInstOperands,
     /*  552163 */     // GIR_Coverage, 3016,
     /*  552163 */     GIR_EraseRootFromParent_Done,
     /*  552164 */   // Label 9107: @552164
     /*  552164 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(552239), // Rule ID 3017 //
     /*  552169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552237 */     GIR_RootConstrainSelectedInstOperands,
     /*  552238 */     // GIR_Coverage, 3017,
     /*  552238 */     GIR_EraseRootFromParent_Done,
     /*  552239 */   // Label 9108: @552239
     /*  552239 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(552314), // Rule ID 3020 //
     /*  552244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552312 */     GIR_RootConstrainSelectedInstOperands,
     /*  552313 */     // GIR_Coverage, 3020,
     /*  552313 */     GIR_EraseRootFromParent_Done,
     /*  552314 */   // Label 9109: @552314
     /*  552314 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(552389), // Rule ID 3021 //
     /*  552319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552365 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552387 */     GIR_RootConstrainSelectedInstOperands,
     /*  552388 */     // GIR_Coverage, 3021,
     /*  552388 */     GIR_EraseRootFromParent_Done,
     /*  552389 */   // Label 9110: @552389
     /*  552389 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(552464), // Rule ID 3024 //
     /*  552394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552440 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552462 */     GIR_RootConstrainSelectedInstOperands,
     /*  552463 */     // GIR_Coverage, 3024,
     /*  552463 */     GIR_EraseRootFromParent_Done,
     /*  552464 */   // Label 9111: @552464
     /*  552464 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(552539), // Rule ID 3025 //
     /*  552469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552515 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552537 */     GIR_RootConstrainSelectedInstOperands,
     /*  552538 */     // GIR_Coverage, 3025,
     /*  552538 */     GIR_EraseRootFromParent_Done,
     /*  552539 */   // Label 9112: @552539
     /*  552539 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(552614), // Rule ID 3028 //
     /*  552544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552612 */     GIR_RootConstrainSelectedInstOperands,
     /*  552613 */     // GIR_Coverage, 3028,
     /*  552613 */     GIR_EraseRootFromParent_Done,
     /*  552614 */   // Label 9113: @552614
     /*  552614 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(552689), // Rule ID 3029 //
     /*  552619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552665 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552687 */     GIR_RootConstrainSelectedInstOperands,
     /*  552688 */     // GIR_Coverage, 3029,
     /*  552688 */     GIR_EraseRootFromParent_Done,
     /*  552689 */   // Label 9114: @552689
     /*  552689 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(552764), // Rule ID 3032 //
     /*  552694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552740 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552762 */     GIR_RootConstrainSelectedInstOperands,
     /*  552763 */     // GIR_Coverage, 3032,
     /*  552763 */     GIR_EraseRootFromParent_Done,
     /*  552764 */   // Label 9115: @552764
     /*  552764 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(552839), // Rule ID 3033 //
     /*  552769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552837 */     GIR_RootConstrainSelectedInstOperands,
     /*  552838 */     // GIR_Coverage, 3033,
     /*  552838 */     GIR_EraseRootFromParent_Done,
     /*  552839 */   // Label 9116: @552839
     /*  552839 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(552914), // Rule ID 3036 //
     /*  552844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552912 */     GIR_RootConstrainSelectedInstOperands,
     /*  552913 */     // GIR_Coverage, 3036,
     /*  552913 */     GIR_EraseRootFromParent_Done,
     /*  552914 */   // Label 9117: @552914
     /*  552914 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(552989), // Rule ID 3037 //
     /*  552919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552987 */     GIR_RootConstrainSelectedInstOperands,
     /*  552988 */     // GIR_Coverage, 3037,
     /*  552988 */     GIR_EraseRootFromParent_Done,
     /*  552989 */   // Label 9118: @552989
     /*  552989 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(553064), // Rule ID 3040 //
     /*  552994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553062 */     GIR_RootConstrainSelectedInstOperands,
     /*  553063 */     // GIR_Coverage, 3040,
     /*  553063 */     GIR_EraseRootFromParent_Done,
     /*  553064 */   // Label 9119: @553064
     /*  553064 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(553139), // Rule ID 3041 //
     /*  553069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553137 */     GIR_RootConstrainSelectedInstOperands,
     /*  553138 */     // GIR_Coverage, 3041,
     /*  553138 */     GIR_EraseRootFromParent_Done,
     /*  553139 */   // Label 9120: @553139
     /*  553139 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(553214), // Rule ID 3044 //
     /*  553144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553190 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553212 */     GIR_RootConstrainSelectedInstOperands,
     /*  553213 */     // GIR_Coverage, 3044,
     /*  553213 */     GIR_EraseRootFromParent_Done,
     /*  553214 */   // Label 9121: @553214
     /*  553214 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(553289), // Rule ID 3045 //
     /*  553219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553265 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553287 */     GIR_RootConstrainSelectedInstOperands,
     /*  553288 */     // GIR_Coverage, 3045,
     /*  553288 */     GIR_EraseRootFromParent_Done,
     /*  553289 */   // Label 9122: @553289
     /*  553289 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(553364), // Rule ID 3048 //
     /*  553294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553362 */     GIR_RootConstrainSelectedInstOperands,
     /*  553363 */     // GIR_Coverage, 3048,
     /*  553363 */     GIR_EraseRootFromParent_Done,
     /*  553364 */   // Label 9123: @553364
     /*  553364 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(553439), // Rule ID 3049 //
     /*  553369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553415 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553437 */     GIR_RootConstrainSelectedInstOperands,
     /*  553438 */     // GIR_Coverage, 3049,
     /*  553438 */     GIR_EraseRootFromParent_Done,
     /*  553439 */   // Label 9124: @553439
     /*  553439 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(553514), // Rule ID 3052 //
     /*  553444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553512 */     GIR_RootConstrainSelectedInstOperands,
     /*  553513 */     // GIR_Coverage, 3052,
     /*  553513 */     GIR_EraseRootFromParent_Done,
     /*  553514 */   // Label 9125: @553514
     /*  553514 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(553589), // Rule ID 3053 //
     /*  553519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553587 */     GIR_RootConstrainSelectedInstOperands,
     /*  553588 */     // GIR_Coverage, 3053,
     /*  553588 */     GIR_EraseRootFromParent_Done,
     /*  553589 */   // Label 9126: @553589
     /*  553589 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(553664), // Rule ID 3056 //
     /*  553594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553640 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553662 */     GIR_RootConstrainSelectedInstOperands,
     /*  553663 */     // GIR_Coverage, 3056,
     /*  553663 */     GIR_EraseRootFromParent_Done,
     /*  553664 */   // Label 9127: @553664
     /*  553664 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(553739), // Rule ID 3057 //
     /*  553669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553715 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553737 */     GIR_RootConstrainSelectedInstOperands,
     /*  553738 */     // GIR_Coverage, 3057,
     /*  553738 */     GIR_EraseRootFromParent_Done,
     /*  553739 */   // Label 9128: @553739
     /*  553739 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(553814), // Rule ID 3060 //
     /*  553744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553790 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553812 */     GIR_RootConstrainSelectedInstOperands,
     /*  553813 */     // GIR_Coverage, 3060,
     /*  553813 */     GIR_EraseRootFromParent_Done,
     /*  553814 */   // Label 9129: @553814
     /*  553814 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(553889), // Rule ID 3061 //
     /*  553819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553887 */     GIR_RootConstrainSelectedInstOperands,
     /*  553888 */     // GIR_Coverage, 3061,
     /*  553888 */     GIR_EraseRootFromParent_Done,
     /*  553889 */   // Label 9130: @553889
     /*  553889 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(553964), // Rule ID 3064 //
     /*  553894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553940 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553962 */     GIR_RootConstrainSelectedInstOperands,
     /*  553963 */     // GIR_Coverage, 3064,
     /*  553963 */     GIR_EraseRootFromParent_Done,
     /*  553964 */   // Label 9131: @553964
     /*  553964 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(554039), // Rule ID 3065 //
     /*  553969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554015 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  554018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554037 */     GIR_RootConstrainSelectedInstOperands,
     /*  554038 */     // GIR_Coverage, 3065,
     /*  554038 */     GIR_EraseRootFromParent_Done,
     /*  554039 */   // Label 9132: @554039
     /*  554039 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(554114), // Rule ID 3068 //
     /*  554044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554090 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554112 */     GIR_RootConstrainSelectedInstOperands,
     /*  554113 */     // GIR_Coverage, 3068,
     /*  554113 */     GIR_EraseRootFromParent_Done,
     /*  554114 */   // Label 9133: @554114
     /*  554114 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(554189), // Rule ID 3069 //
     /*  554119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554165 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554187 */     GIR_RootConstrainSelectedInstOperands,
     /*  554188 */     // GIR_Coverage, 3069,
     /*  554188 */     GIR_EraseRootFromParent_Done,
     /*  554189 */   // Label 9134: @554189
     /*  554189 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(554264), // Rule ID 3072 //
     /*  554194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554262 */     GIR_RootConstrainSelectedInstOperands,
     /*  554263 */     // GIR_Coverage, 3072,
     /*  554263 */     GIR_EraseRootFromParent_Done,
     /*  554264 */   // Label 9135: @554264
     /*  554264 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(554339), // Rule ID 3073 //
     /*  554269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554315 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554337 */     GIR_RootConstrainSelectedInstOperands,
     /*  554338 */     // GIR_Coverage, 3073,
     /*  554338 */     GIR_EraseRootFromParent_Done,
     /*  554339 */   // Label 9136: @554339
     /*  554339 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(554414), // Rule ID 3076 //
     /*  554344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554412 */     GIR_RootConstrainSelectedInstOperands,
     /*  554413 */     // GIR_Coverage, 3076,
     /*  554413 */     GIR_EraseRootFromParent_Done,
     /*  554414 */   // Label 9137: @554414
     /*  554414 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(554489), // Rule ID 3077 //
     /*  554419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554487 */     GIR_RootConstrainSelectedInstOperands,
     /*  554488 */     // GIR_Coverage, 3077,
     /*  554488 */     GIR_EraseRootFromParent_Done,
     /*  554489 */   // Label 9138: @554489
     /*  554489 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(554564), // Rule ID 3080 //
     /*  554494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554562 */     GIR_RootConstrainSelectedInstOperands,
     /*  554563 */     // GIR_Coverage, 3080,
     /*  554563 */     GIR_EraseRootFromParent_Done,
     /*  554564 */   // Label 9139: @554564
     /*  554564 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(554639), // Rule ID 3081 //
     /*  554569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554637 */     GIR_RootConstrainSelectedInstOperands,
     /*  554638 */     // GIR_Coverage, 3081,
     /*  554638 */     GIR_EraseRootFromParent_Done,
     /*  554639 */   // Label 9140: @554639
     /*  554639 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(554714), // Rule ID 3084 //
     /*  554644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554712 */     GIR_RootConstrainSelectedInstOperands,
     /*  554713 */     // GIR_Coverage, 3084,
     /*  554713 */     GIR_EraseRootFromParent_Done,
     /*  554714 */   // Label 9141: @554714
     /*  554714 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(554789), // Rule ID 3085 //
     /*  554719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554765 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554787 */     GIR_RootConstrainSelectedInstOperands,
     /*  554788 */     // GIR_Coverage, 3085,
     /*  554788 */     GIR_EraseRootFromParent_Done,
     /*  554789 */   // Label 9142: @554789
     /*  554789 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(554864), // Rule ID 3088 //
     /*  554794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554862 */     GIR_RootConstrainSelectedInstOperands,
     /*  554863 */     // GIR_Coverage, 3088,
     /*  554863 */     GIR_EraseRootFromParent_Done,
     /*  554864 */   // Label 9143: @554864
     /*  554864 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(554939), // Rule ID 3089 //
     /*  554869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554915 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11199:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554937 */     GIR_RootConstrainSelectedInstOperands,
     /*  554938 */     // GIR_Coverage, 3089,
     /*  554938 */     GIR_EraseRootFromParent_Done,
     /*  554939 */   // Label 9144: @554939
     /*  554939 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(555014), // Rule ID 3092 //
     /*  554944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554990 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555012 */     GIR_RootConstrainSelectedInstOperands,
     /*  555013 */     // GIR_Coverage, 3092,
     /*  555013 */     GIR_EraseRootFromParent_Done,
     /*  555014 */   // Label 9145: @555014
     /*  555014 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(555089), // Rule ID 3093 //
     /*  555019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555065 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555087 */     GIR_RootConstrainSelectedInstOperands,
     /*  555088 */     // GIR_Coverage, 3093,
     /*  555088 */     GIR_EraseRootFromParent_Done,
     /*  555089 */   // Label 9146: @555089
     /*  555089 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(555164), // Rule ID 3096 //
     /*  555094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555162 */     GIR_RootConstrainSelectedInstOperands,
     /*  555163 */     // GIR_Coverage, 3096,
     /*  555163 */     GIR_EraseRootFromParent_Done,
     /*  555164 */   // Label 9147: @555164
     /*  555164 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(555239), // Rule ID 3097 //
     /*  555169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555215 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555237 */     GIR_RootConstrainSelectedInstOperands,
     /*  555238 */     // GIR_Coverage, 3097,
     /*  555238 */     GIR_EraseRootFromParent_Done,
     /*  555239 */   // Label 9148: @555239
     /*  555239 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(555314), // Rule ID 3100 //
     /*  555244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555312 */     GIR_RootConstrainSelectedInstOperands,
     /*  555313 */     // GIR_Coverage, 3100,
     /*  555313 */     GIR_EraseRootFromParent_Done,
     /*  555314 */   // Label 9149: @555314
     /*  555314 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(555389), // Rule ID 3101 //
     /*  555319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  555368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555387 */     GIR_RootConstrainSelectedInstOperands,
     /*  555388 */     // GIR_Coverage, 3101,
     /*  555388 */     GIR_EraseRootFromParent_Done,
     /*  555389 */   // Label 9150: @555389
     /*  555389 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(555464), // Rule ID 3104 //
     /*  555394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555462 */     GIR_RootConstrainSelectedInstOperands,
     /*  555463 */     // GIR_Coverage, 3104,
     /*  555463 */     GIR_EraseRootFromParent_Done,
     /*  555464 */   // Label 9151: @555464
     /*  555464 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(555539), // Rule ID 3105 //
     /*  555469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555515 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555537 */     GIR_RootConstrainSelectedInstOperands,
     /*  555538 */     // GIR_Coverage, 3105,
     /*  555538 */     GIR_EraseRootFromParent_Done,
     /*  555539 */   // Label 9152: @555539
     /*  555539 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(555614), // Rule ID 3108 //
     /*  555544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555590 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555612 */     GIR_RootConstrainSelectedInstOperands,
     /*  555613 */     // GIR_Coverage, 3108,
     /*  555613 */     GIR_EraseRootFromParent_Done,
     /*  555614 */   // Label 9153: @555614
     /*  555614 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(555689), // Rule ID 3109 //
     /*  555619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555665 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555687 */     GIR_RootConstrainSelectedInstOperands,
     /*  555688 */     // GIR_Coverage, 3109,
     /*  555688 */     GIR_EraseRootFromParent_Done,
     /*  555689 */   // Label 9154: @555689
     /*  555689 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(555764), // Rule ID 3112 //
     /*  555694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555762 */     GIR_RootConstrainSelectedInstOperands,
     /*  555763 */     // GIR_Coverage, 3112,
     /*  555763 */     GIR_EraseRootFromParent_Done,
     /*  555764 */   // Label 9155: @555764
     /*  555764 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(555839), // Rule ID 3113 //
     /*  555769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555815 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555837 */     GIR_RootConstrainSelectedInstOperands,
     /*  555838 */     // GIR_Coverage, 3113,
     /*  555838 */     GIR_EraseRootFromParent_Done,
     /*  555839 */   // Label 9156: @555839
     /*  555839 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(555914), // Rule ID 3116 //
     /*  555844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555912 */     GIR_RootConstrainSelectedInstOperands,
     /*  555913 */     // GIR_Coverage, 3116,
     /*  555913 */     GIR_EraseRootFromParent_Done,
     /*  555914 */   // Label 9157: @555914
     /*  555914 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(555989), // Rule ID 3117 //
     /*  555919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555987 */     GIR_RootConstrainSelectedInstOperands,
     /*  555988 */     // GIR_Coverage, 3117,
     /*  555988 */     GIR_EraseRootFromParent_Done,
     /*  555989 */   // Label 9158: @555989
     /*  555989 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(556064), // Rule ID 3120 //
     /*  555994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556062 */     GIR_RootConstrainSelectedInstOperands,
     /*  556063 */     // GIR_Coverage, 3120,
     /*  556063 */     GIR_EraseRootFromParent_Done,
     /*  556064 */   // Label 9159: @556064
     /*  556064 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(556139), // Rule ID 3121 //
     /*  556069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556115 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556137 */     GIR_RootConstrainSelectedInstOperands,
     /*  556138 */     // GIR_Coverage, 3121,
     /*  556138 */     GIR_EraseRootFromParent_Done,
     /*  556139 */   // Label 9160: @556139
     /*  556139 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(556214), // Rule ID 3124 //
     /*  556144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556212 */     GIR_RootConstrainSelectedInstOperands,
     /*  556213 */     // GIR_Coverage, 3124,
     /*  556213 */     GIR_EraseRootFromParent_Done,
     /*  556214 */   // Label 9161: @556214
     /*  556214 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(556289), // Rule ID 3125 //
     /*  556219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556265 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556287 */     GIR_RootConstrainSelectedInstOperands,
     /*  556288 */     // GIR_Coverage, 3125,
     /*  556288 */     GIR_EraseRootFromParent_Done,
     /*  556289 */   // Label 9162: @556289
     /*  556289 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(556364), // Rule ID 3128 //
     /*  556294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556362 */     GIR_RootConstrainSelectedInstOperands,
     /*  556363 */     // GIR_Coverage, 3128,
     /*  556363 */     GIR_EraseRootFromParent_Done,
     /*  556364 */   // Label 9163: @556364
     /*  556364 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(556439), // Rule ID 3129 //
     /*  556369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556437 */     GIR_RootConstrainSelectedInstOperands,
     /*  556438 */     // GIR_Coverage, 3129,
     /*  556438 */     GIR_EraseRootFromParent_Done,
     /*  556439 */   // Label 9164: @556439
     /*  556439 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(556514), // Rule ID 3132 //
     /*  556444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556512 */     GIR_RootConstrainSelectedInstOperands,
     /*  556513 */     // GIR_Coverage, 3132,
     /*  556513 */     GIR_EraseRootFromParent_Done,
     /*  556514 */   // Label 9165: @556514
     /*  556514 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(556589), // Rule ID 3133 //
     /*  556519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556587 */     GIR_RootConstrainSelectedInstOperands,
     /*  556588 */     // GIR_Coverage, 3133,
     /*  556588 */     GIR_EraseRootFromParent_Done,
     /*  556589 */   // Label 9166: @556589
     /*  556589 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(556664), // Rule ID 3136 //
     /*  556594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556662 */     GIR_RootConstrainSelectedInstOperands,
     /*  556663 */     // GIR_Coverage, 3136,
     /*  556663 */     GIR_EraseRootFromParent_Done,
     /*  556664 */   // Label 9167: @556664
     /*  556664 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(556739), // Rule ID 3137 //
     /*  556669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556737 */     GIR_RootConstrainSelectedInstOperands,
     /*  556738 */     // GIR_Coverage, 3137,
     /*  556738 */     GIR_EraseRootFromParent_Done,
     /*  556739 */   // Label 9168: @556739
     /*  556739 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(556814), // Rule ID 3140 //
     /*  556744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556812 */     GIR_RootConstrainSelectedInstOperands,
     /*  556813 */     // GIR_Coverage, 3140,
     /*  556813 */     GIR_EraseRootFromParent_Done,
     /*  556814 */   // Label 9169: @556814
     /*  556814 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(556889), // Rule ID 3141 //
     /*  556819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556887 */     GIR_RootConstrainSelectedInstOperands,
     /*  556888 */     // GIR_Coverage, 3141,
     /*  556888 */     GIR_EraseRootFromParent_Done,
     /*  556889 */   // Label 9170: @556889
     /*  556889 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(556964), // Rule ID 3144 //
     /*  556894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556962 */     GIR_RootConstrainSelectedInstOperands,
     /*  556963 */     // GIR_Coverage, 3144,
     /*  556963 */     GIR_EraseRootFromParent_Done,
     /*  556964 */   // Label 9171: @556964
     /*  556964 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(557039), // Rule ID 3145 //
     /*  556969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  557018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557037 */     GIR_RootConstrainSelectedInstOperands,
     /*  557038 */     // GIR_Coverage, 3145,
     /*  557038 */     GIR_EraseRootFromParent_Done,
     /*  557039 */   // Label 9172: @557039
     /*  557039 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(557114), // Rule ID 3148 //
     /*  557044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  557047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  557093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557112 */     GIR_RootConstrainSelectedInstOperands,
     /*  557113 */     // GIR_Coverage, 3148,
     /*  557113 */     GIR_EraseRootFromParent_Done,
     /*  557114 */   // Label 9173: @557114
     /*  557114 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(557189), // Rule ID 3149 //
     /*  557119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  557168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557187 */     GIR_RootConstrainSelectedInstOperands,
     /*  557188 */     // GIR_Coverage, 3149,
     /*  557188 */     GIR_EraseRootFromParent_Done,
     /*  557189 */   // Label 9174: @557189
     /*  557189 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(557264), // Rule ID 3240 //
     /*  557194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  557214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  557243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557262 */     GIR_RootConstrainSelectedInstOperands,
     /*  557263 */     // GIR_Coverage, 3240,
     /*  557263 */     GIR_EraseRootFromParent_Done,
     /*  557264 */   // Label 9175: @557264
     /*  557264 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(557339), // Rule ID 3241 //
     /*  557269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  557289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557315 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  557318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557337 */     GIR_RootConstrainSelectedInstOperands,
     /*  557338 */     // GIR_Coverage, 3241,
     /*  557338 */     GIR_EraseRootFromParent_Done,
     /*  557339 */   // Label 9176: @557339
     /*  557339 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(557414), // Rule ID 3244 //
     /*  557344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  557364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557412 */     GIR_RootConstrainSelectedInstOperands,
     /*  557413 */     // GIR_Coverage, 3244,
     /*  557413 */     GIR_EraseRootFromParent_Done,
     /*  557414 */   // Label 9177: @557414
     /*  557414 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(557489), // Rule ID 3245 //
     /*  557419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  557439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557465 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557487 */     GIR_RootConstrainSelectedInstOperands,
     /*  557488 */     // GIR_Coverage, 3245,
     /*  557488 */     GIR_EraseRootFromParent_Done,
     /*  557489 */   // Label 9178: @557489
     /*  557489 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(557564), // Rule ID 3248 //
     /*  557494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557562 */     GIR_RootConstrainSelectedInstOperands,
     /*  557563 */     // GIR_Coverage, 3248,
     /*  557563 */     GIR_EraseRootFromParent_Done,
     /*  557564 */   // Label 9179: @557564
     /*  557564 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(557639), // Rule ID 3249 //
     /*  557569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557615 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557637 */     GIR_RootConstrainSelectedInstOperands,
     /*  557638 */     // GIR_Coverage, 3249,
     /*  557638 */     GIR_EraseRootFromParent_Done,
     /*  557639 */   // Label 9180: @557639
     /*  557639 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(557714), // Rule ID 3252 //
     /*  557644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557712 */     GIR_RootConstrainSelectedInstOperands,
     /*  557713 */     // GIR_Coverage, 3252,
     /*  557713 */     GIR_EraseRootFromParent_Done,
     /*  557714 */   // Label 9181: @557714
     /*  557714 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(557789), // Rule ID 3253 //
     /*  557719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557765 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557787 */     GIR_RootConstrainSelectedInstOperands,
     /*  557788 */     // GIR_Coverage, 3253,
     /*  557788 */     GIR_EraseRootFromParent_Done,
     /*  557789 */   // Label 9182: @557789
     /*  557789 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(557864), // Rule ID 3256 //
     /*  557794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557862 */     GIR_RootConstrainSelectedInstOperands,
     /*  557863 */     // GIR_Coverage, 3256,
     /*  557863 */     GIR_EraseRootFromParent_Done,
     /*  557864 */   // Label 9183: @557864
     /*  557864 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(557939), // Rule ID 3257 //
     /*  557869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557915 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557937 */     GIR_RootConstrainSelectedInstOperands,
     /*  557938 */     // GIR_Coverage, 3257,
     /*  557938 */     GIR_EraseRootFromParent_Done,
     /*  557939 */   // Label 9184: @557939
     /*  557939 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(558014), // Rule ID 3260 //
     /*  557944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558012 */     GIR_RootConstrainSelectedInstOperands,
     /*  558013 */     // GIR_Coverage, 3260,
     /*  558013 */     GIR_EraseRootFromParent_Done,
     /*  558014 */   // Label 9185: @558014
     /*  558014 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(558089), // Rule ID 3261 //
     /*  558019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  558039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558065 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  558068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558087 */     GIR_RootConstrainSelectedInstOperands,
     /*  558088 */     // GIR_Coverage, 3261,
     /*  558088 */     GIR_EraseRootFromParent_Done,
     /*  558089 */   // Label 9186: @558089
     /*  558089 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(558164), // Rule ID 3264 //
     /*  558094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  558114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558162 */     GIR_RootConstrainSelectedInstOperands,
     /*  558163 */     // GIR_Coverage, 3264,
     /*  558163 */     GIR_EraseRootFromParent_Done,
     /*  558164 */   // Label 9187: @558164
     /*  558164 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(558239), // Rule ID 3265 //
     /*  558169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  558189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558237 */     GIR_RootConstrainSelectedInstOperands,
     /*  558238 */     // GIR_Coverage, 3265,
     /*  558238 */     GIR_EraseRootFromParent_Done,
     /*  558239 */   // Label 9188: @558239
     /*  558239 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(558314), // Rule ID 3268 //
     /*  558244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  558264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558312 */     GIR_RootConstrainSelectedInstOperands,
     /*  558313 */     // GIR_Coverage, 3268,
     /*  558313 */     GIR_EraseRootFromParent_Done,
     /*  558314 */   // Label 9189: @558314
     /*  558314 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(558389), // Rule ID 3269 //
     /*  558319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  558339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558387 */     GIR_RootConstrainSelectedInstOperands,
     /*  558388 */     // GIR_Coverage, 3269,
     /*  558388 */     GIR_EraseRootFromParent_Done,
     /*  558389 */   // Label 9190: @558389
     /*  558389 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(558464), // Rule ID 3272 //
     /*  558394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558462 */     GIR_RootConstrainSelectedInstOperands,
     /*  558463 */     // GIR_Coverage, 3272,
     /*  558463 */     GIR_EraseRootFromParent_Done,
     /*  558464 */   // Label 9191: @558464
     /*  558464 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(558539), // Rule ID 3273 //
     /*  558469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558537 */     GIR_RootConstrainSelectedInstOperands,
     /*  558538 */     // GIR_Coverage, 3273,
     /*  558538 */     GIR_EraseRootFromParent_Done,
     /*  558539 */   // Label 9192: @558539
     /*  558539 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(558614), // Rule ID 3276 //
     /*  558544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558612 */     GIR_RootConstrainSelectedInstOperands,
     /*  558613 */     // GIR_Coverage, 3276,
     /*  558613 */     GIR_EraseRootFromParent_Done,
     /*  558614 */   // Label 9193: @558614
     /*  558614 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(558689), // Rule ID 3277 //
     /*  558619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558665 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558687 */     GIR_RootConstrainSelectedInstOperands,
     /*  558688 */     // GIR_Coverage, 3277,
     /*  558688 */     GIR_EraseRootFromParent_Done,
     /*  558689 */   // Label 9194: @558689
     /*  558689 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(558764), // Rule ID 3280 //
     /*  558694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558740 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558762 */     GIR_RootConstrainSelectedInstOperands,
     /*  558763 */     // GIR_Coverage, 3280,
     /*  558763 */     GIR_EraseRootFromParent_Done,
     /*  558764 */   // Label 9195: @558764
     /*  558764 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(558839), // Rule ID 3281 //
     /*  558769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558837 */     GIR_RootConstrainSelectedInstOperands,
     /*  558838 */     // GIR_Coverage, 3281,
     /*  558838 */     GIR_EraseRootFromParent_Done,
     /*  558839 */   // Label 9196: @558839
     /*  558839 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(558914), // Rule ID 3284 //
     /*  558844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558890 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558912 */     GIR_RootConstrainSelectedInstOperands,
     /*  558913 */     // GIR_Coverage, 3284,
     /*  558913 */     GIR_EraseRootFromParent_Done,
     /*  558914 */   // Label 9197: @558914
     /*  558914 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(558989), // Rule ID 3285 //
     /*  558919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558965 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558987 */     GIR_RootConstrainSelectedInstOperands,
     /*  558988 */     // GIR_Coverage, 3285,
     /*  558988 */     GIR_EraseRootFromParent_Done,
     /*  558989 */   // Label 9198: @558989
     /*  558989 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(559064), // Rule ID 3288 //
     /*  558994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  559014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559062 */     GIR_RootConstrainSelectedInstOperands,
     /*  559063 */     // GIR_Coverage, 3288,
     /*  559063 */     GIR_EraseRootFromParent_Done,
     /*  559064 */   // Label 9199: @559064
     /*  559064 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(559139), // Rule ID 3289 //
     /*  559069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  559089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559115 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559137 */     GIR_RootConstrainSelectedInstOperands,
     /*  559138 */     // GIR_Coverage, 3289,
     /*  559138 */     GIR_EraseRootFromParent_Done,
     /*  559139 */   // Label 9200: @559139
     /*  559139 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(559214), // Rule ID 3292 //
     /*  559144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  559164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559212 */     GIR_RootConstrainSelectedInstOperands,
     /*  559213 */     // GIR_Coverage, 3292,
     /*  559213 */     GIR_EraseRootFromParent_Done,
     /*  559214 */   // Label 9201: @559214
     /*  559214 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(559289), // Rule ID 3293 //
     /*  559219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  559239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559287 */     GIR_RootConstrainSelectedInstOperands,
     /*  559288 */     // GIR_Coverage, 3293,
     /*  559288 */     GIR_EraseRootFromParent_Done,
     /*  559289 */   // Label 9202: @559289
     /*  559289 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(559364), // Rule ID 3296 //
     /*  559294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  559314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559362 */     GIR_RootConstrainSelectedInstOperands,
     /*  559363 */     // GIR_Coverage, 3296,
     /*  559363 */     GIR_EraseRootFromParent_Done,
     /*  559364 */   // Label 9203: @559364
     /*  559364 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(559439), // Rule ID 3297 //
     /*  559369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  559389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559437 */     GIR_RootConstrainSelectedInstOperands,
     /*  559438 */     // GIR_Coverage, 3297,
     /*  559438 */     GIR_EraseRootFromParent_Done,
     /*  559439 */   // Label 9204: @559439
     /*  559439 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(559514), // Rule ID 3300 //
     /*  559444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559512 */     GIR_RootConstrainSelectedInstOperands,
     /*  559513 */     // GIR_Coverage, 3300,
     /*  559513 */     GIR_EraseRootFromParent_Done,
     /*  559514 */   // Label 9205: @559514
     /*  559514 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(559589), // Rule ID 3301 //
     /*  559519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559587 */     GIR_RootConstrainSelectedInstOperands,
     /*  559588 */     // GIR_Coverage, 3301,
     /*  559588 */     GIR_EraseRootFromParent_Done,
     /*  559589 */   // Label 9206: @559589
     /*  559589 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(559664), // Rule ID 3304 //
     /*  559594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559662 */     GIR_RootConstrainSelectedInstOperands,
     /*  559663 */     // GIR_Coverage, 3304,
     /*  559663 */     GIR_EraseRootFromParent_Done,
     /*  559664 */   // Label 9207: @559664
     /*  559664 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(559739), // Rule ID 3305 //
     /*  559669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559737 */     GIR_RootConstrainSelectedInstOperands,
     /*  559738 */     // GIR_Coverage, 3305,
     /*  559738 */     GIR_EraseRootFromParent_Done,
     /*  559739 */   // Label 9208: @559739
     /*  559739 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(559814), // Rule ID 3308 //
     /*  559744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559812 */     GIR_RootConstrainSelectedInstOperands,
     /*  559813 */     // GIR_Coverage, 3308,
     /*  559813 */     GIR_EraseRootFromParent_Done,
     /*  559814 */   // Label 9209: @559814
     /*  559814 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(559889), // Rule ID 3309 //
     /*  559819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559865 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559887 */     GIR_RootConstrainSelectedInstOperands,
     /*  559888 */     // GIR_Coverage, 3309,
     /*  559888 */     GIR_EraseRootFromParent_Done,
     /*  559889 */   // Label 9210: @559889
     /*  559889 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(559964), // Rule ID 3312 //
     /*  559894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559962 */     GIR_RootConstrainSelectedInstOperands,
     /*  559963 */     // GIR_Coverage, 3312,
     /*  559963 */     GIR_EraseRootFromParent_Done,
     /*  559964 */   // Label 9211: @559964
     /*  559964 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(560039), // Rule ID 3313 //
     /*  559969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560015 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560037 */     GIR_RootConstrainSelectedInstOperands,
     /*  560038 */     // GIR_Coverage, 3313,
     /*  560038 */     GIR_EraseRootFromParent_Done,
     /*  560039 */   // Label 9212: @560039
     /*  560039 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(560114), // Rule ID 3316 //
     /*  560044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  560064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  560093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560112 */     GIR_RootConstrainSelectedInstOperands,
     /*  560113 */     // GIR_Coverage, 3316,
     /*  560113 */     GIR_EraseRootFromParent_Done,
     /*  560114 */   // Label 9213: @560114
     /*  560114 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(560189), // Rule ID 3317 //
     /*  560119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  560139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  560168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560187 */     GIR_RootConstrainSelectedInstOperands,
     /*  560188 */     // GIR_Coverage, 3317,
     /*  560188 */     GIR_EraseRootFromParent_Done,
     /*  560189 */   // Label 9214: @560189
     /*  560189 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(560264), // Rule ID 3320 //
     /*  560194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  560214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560240 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  560243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560262 */     GIR_RootConstrainSelectedInstOperands,
     /*  560263 */     // GIR_Coverage, 3320,
     /*  560263 */     GIR_EraseRootFromParent_Done,
     /*  560264 */   // Label 9215: @560264
     /*  560264 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(560339), // Rule ID 3321 //
     /*  560269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  560289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560315 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  560318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560337 */     GIR_RootConstrainSelectedInstOperands,
     /*  560338 */     // GIR_Coverage, 3321,
     /*  560338 */     GIR_EraseRootFromParent_Done,
     /*  560339 */   // Label 9216: @560339
     /*  560339 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(560414), // Rule ID 3324 //
     /*  560344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  560364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560412 */     GIR_RootConstrainSelectedInstOperands,
     /*  560413 */     // GIR_Coverage, 3324,
     /*  560413 */     GIR_EraseRootFromParent_Done,
     /*  560414 */   // Label 9217: @560414
     /*  560414 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(560489), // Rule ID 3325 //
     /*  560419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  560439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560465 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560487 */     GIR_RootConstrainSelectedInstOperands,
     /*  560488 */     // GIR_Coverage, 3325,
     /*  560488 */     GIR_EraseRootFromParent_Done,
     /*  560489 */   // Label 9218: @560489
     /*  560489 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(560564), // Rule ID 3328 //
     /*  560494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560562 */     GIR_RootConstrainSelectedInstOperands,
     /*  560563 */     // GIR_Coverage, 3328,
     /*  560563 */     GIR_EraseRootFromParent_Done,
     /*  560564 */   // Label 9219: @560564
     /*  560564 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(560639), // Rule ID 3329 //
     /*  560569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560615 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560637 */     GIR_RootConstrainSelectedInstOperands,
     /*  560638 */     // GIR_Coverage, 3329,
     /*  560638 */     GIR_EraseRootFromParent_Done,
     /*  560639 */   // Label 9220: @560639
     /*  560639 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(560714), // Rule ID 3332 //
     /*  560644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560712 */     GIR_RootConstrainSelectedInstOperands,
     /*  560713 */     // GIR_Coverage, 3332,
     /*  560713 */     GIR_EraseRootFromParent_Done,
     /*  560714 */   // Label 9221: @560714
     /*  560714 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(560789), // Rule ID 3333 //
     /*  560719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560765 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560787 */     GIR_RootConstrainSelectedInstOperands,
     /*  560788 */     // GIR_Coverage, 3333,
     /*  560788 */     GIR_EraseRootFromParent_Done,
     /*  560789 */   // Label 9222: @560789
     /*  560789 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(560864), // Rule ID 3336 //
     /*  560794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560862 */     GIR_RootConstrainSelectedInstOperands,
     /*  560863 */     // GIR_Coverage, 3336,
     /*  560863 */     GIR_EraseRootFromParent_Done,
     /*  560864 */   // Label 9223: @560864
     /*  560864 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(560939), // Rule ID 3337 //
     /*  560869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560915 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560937 */     GIR_RootConstrainSelectedInstOperands,
     /*  560938 */     // GIR_Coverage, 3337,
     /*  560938 */     GIR_EraseRootFromParent_Done,
     /*  560939 */   // Label 9224: @560939
     /*  560939 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(561014), // Rule ID 3340 //
     /*  560944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561012 */     GIR_RootConstrainSelectedInstOperands,
     /*  561013 */     // GIR_Coverage, 3340,
     /*  561013 */     GIR_EraseRootFromParent_Done,
     /*  561014 */   // Label 9225: @561014
     /*  561014 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(561089), // Rule ID 3341 //
     /*  561019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561065 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  561068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561087 */     GIR_RootConstrainSelectedInstOperands,
     /*  561088 */     // GIR_Coverage, 3341,
     /*  561088 */     GIR_EraseRootFromParent_Done,
     /*  561089 */   // Label 9226: @561089
     /*  561089 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(561164), // Rule ID 3344 //
     /*  561094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561162 */     GIR_RootConstrainSelectedInstOperands,
     /*  561163 */     // GIR_Coverage, 3344,
     /*  561163 */     GIR_EraseRootFromParent_Done,
     /*  561164 */   // Label 9227: @561164
     /*  561164 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(561239), // Rule ID 3345 //
     /*  561169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561215 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561237 */     GIR_RootConstrainSelectedInstOperands,
     /*  561238 */     // GIR_Coverage, 3345,
     /*  561238 */     GIR_EraseRootFromParent_Done,
     /*  561239 */   // Label 9228: @561239
     /*  561239 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(561314), // Rule ID 3348 //
     /*  561244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561312 */     GIR_RootConstrainSelectedInstOperands,
     /*  561313 */     // GIR_Coverage, 3348,
     /*  561313 */     GIR_EraseRootFromParent_Done,
     /*  561314 */   // Label 9229: @561314
     /*  561314 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(561389), // Rule ID 3349 //
     /*  561319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561365 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  561368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561387 */     GIR_RootConstrainSelectedInstOperands,
     /*  561388 */     // GIR_Coverage, 3349,
     /*  561388 */     GIR_EraseRootFromParent_Done,
     /*  561389 */   // Label 9230: @561389
     /*  561389 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(561464), // Rule ID 3352 //
     /*  561394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561462 */     GIR_RootConstrainSelectedInstOperands,
     /*  561463 */     // GIR_Coverage, 3352,
     /*  561463 */     GIR_EraseRootFromParent_Done,
     /*  561464 */   // Label 9231: @561464
     /*  561464 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(561539), // Rule ID 3353 //
     /*  561469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561515 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11677:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561537 */     GIR_RootConstrainSelectedInstOperands,
     /*  561538 */     // GIR_Coverage, 3353,
     /*  561538 */     GIR_EraseRootFromParent_Done,
     /*  561539 */   // Label 9232: @561539
     /*  561539 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(561614), // Rule ID 3356 //
     /*  561544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561612 */     GIR_RootConstrainSelectedInstOperands,
     /*  561613 */     // GIR_Coverage, 3356,
     /*  561613 */     GIR_EraseRootFromParent_Done,
     /*  561614 */   // Label 9233: @561614
     /*  561614 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(561689), // Rule ID 3357 //
     /*  561619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561687 */     GIR_RootConstrainSelectedInstOperands,
     /*  561688 */     // GIR_Coverage, 3357,
     /*  561688 */     GIR_EraseRootFromParent_Done,
     /*  561689 */   // Label 9234: @561689
     /*  561689 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(561764), // Rule ID 3360 //
     /*  561694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561762 */     GIR_RootConstrainSelectedInstOperands,
     /*  561763 */     // GIR_Coverage, 3360,
     /*  561763 */     GIR_EraseRootFromParent_Done,
     /*  561764 */   // Label 9235: @561764
     /*  561764 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(561839), // Rule ID 3361 //
     /*  561769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561837 */     GIR_RootConstrainSelectedInstOperands,
     /*  561838 */     // GIR_Coverage, 3361,
     /*  561838 */     GIR_EraseRootFromParent_Done,
     /*  561839 */   // Label 9236: @561839
     /*  561839 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(561914), // Rule ID 3364 //
     /*  561844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561912 */     GIR_RootConstrainSelectedInstOperands,
     /*  561913 */     // GIR_Coverage, 3364,
     /*  561913 */     GIR_EraseRootFromParent_Done,
     /*  561914 */   // Label 9237: @561914
     /*  561914 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(561989), // Rule ID 3365 //
     /*  561919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  561922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  561965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561987 */     GIR_RootConstrainSelectedInstOperands,
     /*  561988 */     // GIR_Coverage, 3365,
     /*  561988 */     GIR_EraseRootFromParent_Done,
     /*  561989 */   // Label 9238: @561989
     /*  561989 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(562064), // Rule ID 3368 //
     /*  561994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562062 */     GIR_RootConstrainSelectedInstOperands,
     /*  562063 */     // GIR_Coverage, 3368,
     /*  562063 */     GIR_EraseRootFromParent_Done,
     /*  562064 */   // Label 9239: @562064
     /*  562064 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(562139), // Rule ID 3369 //
     /*  562069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562115 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562137 */     GIR_RootConstrainSelectedInstOperands,
     /*  562138 */     // GIR_Coverage, 3369,
     /*  562138 */     GIR_EraseRootFromParent_Done,
     /*  562139 */   // Label 9240: @562139
     /*  562139 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(562214), // Rule ID 3372 //
     /*  562144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562190 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562212 */     GIR_RootConstrainSelectedInstOperands,
     /*  562213 */     // GIR_Coverage, 3372,
     /*  562213 */     GIR_EraseRootFromParent_Done,
     /*  562214 */   // Label 9241: @562214
     /*  562214 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(562289), // Rule ID 3373 //
     /*  562219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562265 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562287 */     GIR_RootConstrainSelectedInstOperands,
     /*  562288 */     // GIR_Coverage, 3373,
     /*  562288 */     GIR_EraseRootFromParent_Done,
     /*  562289 */   // Label 9242: @562289
     /*  562289 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(562364), // Rule ID 3376 //
     /*  562294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562340 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562362 */     GIR_RootConstrainSelectedInstOperands,
     /*  562363 */     // GIR_Coverage, 3376,
     /*  562363 */     GIR_EraseRootFromParent_Done,
     /*  562364 */   // Label 9243: @562364
     /*  562364 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(562439), // Rule ID 3377 //
     /*  562369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562415 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562437 */     GIR_RootConstrainSelectedInstOperands,
     /*  562438 */     // GIR_Coverage, 3377,
     /*  562438 */     GIR_EraseRootFromParent_Done,
     /*  562439 */   // Label 9244: @562439
     /*  562439 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(562514), // Rule ID 3380 //
     /*  562444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562512 */     GIR_RootConstrainSelectedInstOperands,
     /*  562513 */     // GIR_Coverage, 3380,
     /*  562513 */     GIR_EraseRootFromParent_Done,
     /*  562514 */   // Label 9245: @562514
     /*  562514 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(562589), // Rule ID 3381 //
     /*  562519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562587 */     GIR_RootConstrainSelectedInstOperands,
     /*  562588 */     // GIR_Coverage, 3381,
     /*  562588 */     GIR_EraseRootFromParent_Done,
     /*  562589 */   // Label 9246: @562589
     /*  562589 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(562664), // Rule ID 3384 //
     /*  562594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562640 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562662 */     GIR_RootConstrainSelectedInstOperands,
     /*  562663 */     // GIR_Coverage, 3384,
     /*  562663 */     GIR_EraseRootFromParent_Done,
     /*  562664 */   // Label 9247: @562664
     /*  562664 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(562739), // Rule ID 3385 //
     /*  562669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562715 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562737 */     GIR_RootConstrainSelectedInstOperands,
     /*  562738 */     // GIR_Coverage, 3385,
     /*  562738 */     GIR_EraseRootFromParent_Done,
     /*  562739 */   // Label 9248: @562739
     /*  562739 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(562814), // Rule ID 3388 //
     /*  562744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562790 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562812 */     GIR_RootConstrainSelectedInstOperands,
     /*  562813 */     // GIR_Coverage, 3388,
     /*  562813 */     GIR_EraseRootFromParent_Done,
     /*  562814 */   // Label 9249: @562814
     /*  562814 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(562889), // Rule ID 3389 //
     /*  562819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562865 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562887 */     GIR_RootConstrainSelectedInstOperands,
     /*  562888 */     // GIR_Coverage, 3389,
     /*  562888 */     GIR_EraseRootFromParent_Done,
     /*  562889 */   // Label 9250: @562889
     /*  562889 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(562964), // Rule ID 3392 //
     /*  562894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562962 */     GIR_RootConstrainSelectedInstOperands,
     /*  562963 */     // GIR_Coverage, 3392,
     /*  562963 */     GIR_EraseRootFromParent_Done,
     /*  562964 */   // Label 9251: @562964
     /*  562964 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(563039), // Rule ID 3393 //
     /*  562969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563037 */     GIR_RootConstrainSelectedInstOperands,
     /*  563038 */     // GIR_Coverage, 3393,
     /*  563038 */     GIR_EraseRootFromParent_Done,
     /*  563039 */   // Label 9252: @563039
     /*  563039 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(563114), // Rule ID 3396 //
     /*  563044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563112 */     GIR_RootConstrainSelectedInstOperands,
     /*  563113 */     // GIR_Coverage, 3396,
     /*  563113 */     GIR_EraseRootFromParent_Done,
     /*  563114 */   // Label 9253: @563114
     /*  563114 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(563189), // Rule ID 3397 //
     /*  563119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563187 */     GIR_RootConstrainSelectedInstOperands,
     /*  563188 */     // GIR_Coverage, 3397,
     /*  563188 */     GIR_EraseRootFromParent_Done,
     /*  563189 */   // Label 9254: @563189
     /*  563189 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(563264), // Rule ID 3400 //
     /*  563194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563262 */     GIR_RootConstrainSelectedInstOperands,
     /*  563263 */     // GIR_Coverage, 3400,
     /*  563263 */     GIR_EraseRootFromParent_Done,
     /*  563264 */   // Label 9255: @563264
     /*  563264 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(563339), // Rule ID 3401 //
     /*  563269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563337 */     GIR_RootConstrainSelectedInstOperands,
     /*  563338 */     // GIR_Coverage, 3401,
     /*  563338 */     GIR_EraseRootFromParent_Done,
     /*  563339 */   // Label 9256: @563339
     /*  563339 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(563414), // Rule ID 3404 //
     /*  563344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563390 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563412 */     GIR_RootConstrainSelectedInstOperands,
     /*  563413 */     // GIR_Coverage, 3404,
     /*  563413 */     GIR_EraseRootFromParent_Done,
     /*  563414 */   // Label 9257: @563414
     /*  563414 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(563489), // Rule ID 3405 //
     /*  563419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563487 */     GIR_RootConstrainSelectedInstOperands,
     /*  563488 */     // GIR_Coverage, 3405,
     /*  563488 */     GIR_EraseRootFromParent_Done,
     /*  563489 */   // Label 9258: @563489
     /*  563489 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(563564), // Rule ID 3408 //
     /*  563494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563562 */     GIR_RootConstrainSelectedInstOperands,
     /*  563563 */     // GIR_Coverage, 3408,
     /*  563563 */     GIR_EraseRootFromParent_Done,
     /*  563564 */   // Label 9259: @563564
     /*  563564 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(563639), // Rule ID 3409 //
     /*  563569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563615 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563637 */     GIR_RootConstrainSelectedInstOperands,
     /*  563638 */     // GIR_Coverage, 3409,
     /*  563638 */     GIR_EraseRootFromParent_Done,
     /*  563639 */   // Label 9260: @563639
     /*  563639 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(563714), // Rule ID 3412 //
     /*  563644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563712 */     GIR_RootConstrainSelectedInstOperands,
     /*  563713 */     // GIR_Coverage, 3412,
     /*  563713 */     GIR_EraseRootFromParent_Done,
     /*  563714 */   // Label 9261: @563714
     /*  563714 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(563789), // Rule ID 3413 //
     /*  563719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563765 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563787 */     GIR_RootConstrainSelectedInstOperands,
     /*  563788 */     // GIR_Coverage, 3413,
     /*  563788 */     GIR_EraseRootFromParent_Done,
     /*  563789 */   // Label 9262: @563789
     /*  563789 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(563864), // Rule ID 3416 //
     /*  563794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563862 */     GIR_RootConstrainSelectedInstOperands,
     /*  563863 */     // GIR_Coverage, 3416,
     /*  563863 */     GIR_EraseRootFromParent_Done,
     /*  563864 */   // Label 9263: @563864
     /*  563864 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(563939), // Rule ID 3417 //
     /*  563869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563915 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563937 */     GIR_RootConstrainSelectedInstOperands,
     /*  563938 */     // GIR_Coverage, 3417,
     /*  563938 */     GIR_EraseRootFromParent_Done,
     /*  563939 */   // Label 9264: @563939
     /*  563939 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(564014), // Rule ID 3420 //
     /*  563944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564012 */     GIR_RootConstrainSelectedInstOperands,
     /*  564013 */     // GIR_Coverage, 3420,
     /*  564013 */     GIR_EraseRootFromParent_Done,
     /*  564014 */   // Label 9265: @564014
     /*  564014 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(564089), // Rule ID 3421 //
     /*  564019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564065 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564087 */     GIR_RootConstrainSelectedInstOperands,
     /*  564088 */     // GIR_Coverage, 3421,
     /*  564088 */     GIR_EraseRootFromParent_Done,
     /*  564089 */   // Label 9266: @564089
     /*  564089 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(564164), // Rule ID 3424 //
     /*  564094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564162 */     GIR_RootConstrainSelectedInstOperands,
     /*  564163 */     // GIR_Coverage, 3424,
     /*  564163 */     GIR_EraseRootFromParent_Done,
     /*  564164 */   // Label 9267: @564164
     /*  564164 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(564239), // Rule ID 3425 //
     /*  564169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564215 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564237 */     GIR_RootConstrainSelectedInstOperands,
     /*  564238 */     // GIR_Coverage, 3425,
     /*  564238 */     GIR_EraseRootFromParent_Done,
     /*  564239 */   // Label 9268: @564239
     /*  564239 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(564314), // Rule ID 3428 //
     /*  564244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564312 */     GIR_RootConstrainSelectedInstOperands,
     /*  564313 */     // GIR_Coverage, 3428,
     /*  564313 */     GIR_EraseRootFromParent_Done,
     /*  564314 */   // Label 9269: @564314
     /*  564314 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(564389), // Rule ID 3429 //
     /*  564319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564365 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  564368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564387 */     GIR_RootConstrainSelectedInstOperands,
     /*  564388 */     // GIR_Coverage, 3429,
     /*  564388 */     GIR_EraseRootFromParent_Done,
     /*  564389 */   // Label 9270: @564389
     /*  564389 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(564464), // Rule ID 3432 //
     /*  564394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564462 */     GIR_RootConstrainSelectedInstOperands,
     /*  564463 */     // GIR_Coverage, 3432,
     /*  564463 */     GIR_EraseRootFromParent_Done,
     /*  564464 */   // Label 9271: @564464
     /*  564464 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(564539), // Rule ID 3433 //
     /*  564469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564515 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564537 */     GIR_RootConstrainSelectedInstOperands,
     /*  564538 */     // GIR_Coverage, 3433,
     /*  564538 */     GIR_EraseRootFromParent_Done,
     /*  564539 */   // Label 9272: @564539
     /*  564539 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(564614), // Rule ID 3436 //
     /*  564544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564612 */     GIR_RootConstrainSelectedInstOperands,
     /*  564613 */     // GIR_Coverage, 3436,
     /*  564613 */     GIR_EraseRootFromParent_Done,
     /*  564614 */   // Label 9273: @564614
     /*  564614 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(564689), // Rule ID 3437 //
     /*  564619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564665 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564687 */     GIR_RootConstrainSelectedInstOperands,
     /*  564688 */     // GIR_Coverage, 3437,
     /*  564688 */     GIR_EraseRootFromParent_Done,
     /*  564689 */   // Label 9274: @564689
     /*  564689 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(564764), // Rule ID 3440 //
     /*  564694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564762 */     GIR_RootConstrainSelectedInstOperands,
     /*  564763 */     // GIR_Coverage, 3440,
     /*  564763 */     GIR_EraseRootFromParent_Done,
     /*  564764 */   // Label 9275: @564764
     /*  564764 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(564839), // Rule ID 3441 //
     /*  564769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564815 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11585:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564837 */     GIR_RootConstrainSelectedInstOperands,
     /*  564838 */     // GIR_Coverage, 3441,
     /*  564838 */     GIR_EraseRootFromParent_Done,
     /*  564839 */   // Label 9276: @564839
     /*  564839 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(564914), // Rule ID 3444 //
     /*  564844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564912 */     GIR_RootConstrainSelectedInstOperands,
     /*  564913 */     // GIR_Coverage, 3444,
     /*  564913 */     GIR_EraseRootFromParent_Done,
     /*  564914 */   // Label 9277: @564914
     /*  564914 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(564989), // Rule ID 3445 //
     /*  564919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564987 */     GIR_RootConstrainSelectedInstOperands,
     /*  564988 */     // GIR_Coverage, 3445,
     /*  564988 */     GIR_EraseRootFromParent_Done,
     /*  564989 */   // Label 9278: @564989
     /*  564989 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(565064), // Rule ID 3448 //
     /*  564994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565062 */     GIR_RootConstrainSelectedInstOperands,
     /*  565063 */     // GIR_Coverage, 3448,
     /*  565063 */     GIR_EraseRootFromParent_Done,
     /*  565064 */   // Label 9279: @565064
     /*  565064 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(565139), // Rule ID 3449 //
     /*  565069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565137 */     GIR_RootConstrainSelectedInstOperands,
     /*  565138 */     // GIR_Coverage, 3449,
     /*  565138 */     GIR_EraseRootFromParent_Done,
     /*  565139 */   // Label 9280: @565139
     /*  565139 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(565214), // Rule ID 3452 //
     /*  565144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565212 */     GIR_RootConstrainSelectedInstOperands,
     /*  565213 */     // GIR_Coverage, 3452,
     /*  565213 */     GIR_EraseRootFromParent_Done,
     /*  565214 */   // Label 9281: @565214
     /*  565214 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(565289), // Rule ID 3453 //
     /*  565219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  565268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565287 */     GIR_RootConstrainSelectedInstOperands,
     /*  565288 */     // GIR_Coverage, 3453,
     /*  565288 */     GIR_EraseRootFromParent_Done,
     /*  565289 */   // Label 9282: @565289
     /*  565289 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(565364), // Rule ID 3456 //
     /*  565294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565362 */     GIR_RootConstrainSelectedInstOperands,
     /*  565363 */     // GIR_Coverage, 3456,
     /*  565363 */     GIR_EraseRootFromParent_Done,
     /*  565364 */   // Label 9283: @565364
     /*  565364 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(565439), // Rule ID 3457 //
     /*  565369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565437 */     GIR_RootConstrainSelectedInstOperands,
     /*  565438 */     // GIR_Coverage, 3457,
     /*  565438 */     GIR_EraseRootFromParent_Done,
     /*  565439 */   // Label 9284: @565439
     /*  565439 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(565514), // Rule ID 3460 //
     /*  565444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565512 */     GIR_RootConstrainSelectedInstOperands,
     /*  565513 */     // GIR_Coverage, 3460,
     /*  565513 */     GIR_EraseRootFromParent_Done,
     /*  565514 */   // Label 9285: @565514
     /*  565514 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(565589), // Rule ID 3461 //
     /*  565519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565565 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565587 */     GIR_RootConstrainSelectedInstOperands,
     /*  565588 */     // GIR_Coverage, 3461,
     /*  565588 */     GIR_EraseRootFromParent_Done,
     /*  565589 */   // Label 9286: @565589
     /*  565589 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(565664), // Rule ID 3464 //
     /*  565594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565662 */     GIR_RootConstrainSelectedInstOperands,
     /*  565663 */     // GIR_Coverage, 3464,
     /*  565663 */     GIR_EraseRootFromParent_Done,
     /*  565664 */   // Label 9287: @565664
     /*  565664 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(565739), // Rule ID 3465 //
     /*  565669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565715 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565737 */     GIR_RootConstrainSelectedInstOperands,
     /*  565738 */     // GIR_Coverage, 3465,
     /*  565738 */     GIR_EraseRootFromParent_Done,
     /*  565739 */   // Label 9288: @565739
     /*  565739 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(565814), // Rule ID 3468 //
     /*  565744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565812 */     GIR_RootConstrainSelectedInstOperands,
     /*  565813 */     // GIR_Coverage, 3468,
     /*  565813 */     GIR_EraseRootFromParent_Done,
     /*  565814 */   // Label 9289: @565814
     /*  565814 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(565889), // Rule ID 3469 //
     /*  565819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565887 */     GIR_RootConstrainSelectedInstOperands,
     /*  565888 */     // GIR_Coverage, 3469,
     /*  565888 */     GIR_EraseRootFromParent_Done,
     /*  565889 */   // Label 9290: @565889
     /*  565889 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(565964), // Rule ID 3472 //
     /*  565894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565940 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565962 */     GIR_RootConstrainSelectedInstOperands,
     /*  565963 */     // GIR_Coverage, 3472,
     /*  565963 */     GIR_EraseRootFromParent_Done,
     /*  565964 */   // Label 9291: @565964
     /*  565964 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(566039), // Rule ID 3473 //
     /*  565969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566015 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566037 */     GIR_RootConstrainSelectedInstOperands,
     /*  566038 */     // GIR_Coverage, 3473,
     /*  566038 */     GIR_EraseRootFromParent_Done,
     /*  566039 */   // Label 9292: @566039
     /*  566039 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(566114), // Rule ID 3476 //
     /*  566044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566112 */     GIR_RootConstrainSelectedInstOperands,
     /*  566113 */     // GIR_Coverage, 3476,
     /*  566113 */     GIR_EraseRootFromParent_Done,
     /*  566114 */   // Label 9293: @566114
     /*  566114 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(566189), // Rule ID 3477 //
     /*  566119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566165 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566187 */     GIR_RootConstrainSelectedInstOperands,
     /*  566188 */     // GIR_Coverage, 3477,
     /*  566188 */     GIR_EraseRootFromParent_Done,
     /*  566189 */   // Label 9294: @566189
     /*  566189 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(566264), // Rule ID 3480 //
     /*  566194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566262 */     GIR_RootConstrainSelectedInstOperands,
     /*  566263 */     // GIR_Coverage, 3480,
     /*  566263 */     GIR_EraseRootFromParent_Done,
     /*  566264 */   // Label 9295: @566264
     /*  566264 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(566339), // Rule ID 3481 //
     /*  566269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566337 */     GIR_RootConstrainSelectedInstOperands,
     /*  566338 */     // GIR_Coverage, 3481,
     /*  566338 */     GIR_EraseRootFromParent_Done,
     /*  566339 */   // Label 9296: @566339
     /*  566339 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(566414), // Rule ID 3484 //
     /*  566344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566412 */     GIR_RootConstrainSelectedInstOperands,
     /*  566413 */     // GIR_Coverage, 3484,
     /*  566413 */     GIR_EraseRootFromParent_Done,
     /*  566414 */   // Label 9297: @566414
     /*  566414 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(566489), // Rule ID 3485 //
     /*  566419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566465 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566487 */     GIR_RootConstrainSelectedInstOperands,
     /*  566488 */     // GIR_Coverage, 3485,
     /*  566488 */     GIR_EraseRootFromParent_Done,
     /*  566489 */   // Label 9298: @566489
     /*  566489 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(566564), // Rule ID 3488 //
     /*  566494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566562 */     GIR_RootConstrainSelectedInstOperands,
     /*  566563 */     // GIR_Coverage, 3488,
     /*  566563 */     GIR_EraseRootFromParent_Done,
     /*  566564 */   // Label 9299: @566564
     /*  566564 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(566639), // Rule ID 3489 //
     /*  566569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566637 */     GIR_RootConstrainSelectedInstOperands,
     /*  566638 */     // GIR_Coverage, 3489,
     /*  566638 */     GIR_EraseRootFromParent_Done,
     /*  566639 */   // Label 9300: @566639
     /*  566639 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(566714), // Rule ID 3492 //
     /*  566644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566712 */     GIR_RootConstrainSelectedInstOperands,
     /*  566713 */     // GIR_Coverage, 3492,
     /*  566713 */     GIR_EraseRootFromParent_Done,
     /*  566714 */   // Label 9301: @566714
     /*  566714 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(566789), // Rule ID 3493 //
     /*  566719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566787 */     GIR_RootConstrainSelectedInstOperands,
     /*  566788 */     // GIR_Coverage, 3493,
     /*  566788 */     GIR_EraseRootFromParent_Done,
     /*  566789 */   // Label 9302: @566789
     /*  566789 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(566864), // Rule ID 3496 //
     /*  566794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566862 */     GIR_RootConstrainSelectedInstOperands,
     /*  566863 */     // GIR_Coverage, 3496,
     /*  566863 */     GIR_EraseRootFromParent_Done,
     /*  566864 */   // Label 9303: @566864
     /*  566864 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(566939), // Rule ID 3497 //
     /*  566869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566915 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566937 */     GIR_RootConstrainSelectedInstOperands,
     /*  566938 */     // GIR_Coverage, 3497,
     /*  566938 */     GIR_EraseRootFromParent_Done,
     /*  566939 */   // Label 9304: @566939
     /*  566939 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(567014), // Rule ID 3500 //
     /*  566944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567012 */     GIR_RootConstrainSelectedInstOperands,
     /*  567013 */     // GIR_Coverage, 3500,
     /*  567013 */     GIR_EraseRootFromParent_Done,
     /*  567014 */   // Label 9305: @567014
     /*  567014 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(567089), // Rule ID 3501 //
     /*  567019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  567022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567065 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  567065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  567068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567087 */     GIR_RootConstrainSelectedInstOperands,
     /*  567088 */     // GIR_Coverage, 3501,
     /*  567088 */     GIR_EraseRootFromParent_Done,
     /*  567089 */   // Label 9306: @567089
     /*  567089 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(567164), // Rule ID 3592 //
     /*  567094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  567114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567140 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  567143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567162 */     GIR_RootConstrainSelectedInstOperands,
     /*  567163 */     // GIR_Coverage, 3592,
     /*  567163 */     GIR_EraseRootFromParent_Done,
     /*  567164 */   // Label 9307: @567164
     /*  567164 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(567239), // Rule ID 3593 //
     /*  567169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  567189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567215 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  567218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567237 */     GIR_RootConstrainSelectedInstOperands,
     /*  567238 */     // GIR_Coverage, 3593,
     /*  567238 */     GIR_EraseRootFromParent_Done,
     /*  567239 */   // Label 9308: @567239
     /*  567239 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(567314), // Rule ID 3596 //
     /*  567244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  567264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567312 */     GIR_RootConstrainSelectedInstOperands,
     /*  567313 */     // GIR_Coverage, 3596,
     /*  567313 */     GIR_EraseRootFromParent_Done,
     /*  567314 */   // Label 9309: @567314
     /*  567314 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(567389), // Rule ID 3597 //
     /*  567319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  567339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567365 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567387 */     GIR_RootConstrainSelectedInstOperands,
     /*  567388 */     // GIR_Coverage, 3597,
     /*  567388 */     GIR_EraseRootFromParent_Done,
     /*  567389 */   // Label 9310: @567389
     /*  567389 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(567464), // Rule ID 3600 //
     /*  567394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567462 */     GIR_RootConstrainSelectedInstOperands,
     /*  567463 */     // GIR_Coverage, 3600,
     /*  567463 */     GIR_EraseRootFromParent_Done,
     /*  567464 */   // Label 9311: @567464
     /*  567464 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(567539), // Rule ID 3601 //
     /*  567469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567537 */     GIR_RootConstrainSelectedInstOperands,
     /*  567538 */     // GIR_Coverage, 3601,
     /*  567538 */     GIR_EraseRootFromParent_Done,
     /*  567539 */   // Label 9312: @567539
     /*  567539 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(567614), // Rule ID 3604 //
     /*  567544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567612 */     GIR_RootConstrainSelectedInstOperands,
     /*  567613 */     // GIR_Coverage, 3604,
     /*  567613 */     GIR_EraseRootFromParent_Done,
     /*  567614 */   // Label 9313: @567614
     /*  567614 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(567689), // Rule ID 3605 //
     /*  567619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567665 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567687 */     GIR_RootConstrainSelectedInstOperands,
     /*  567688 */     // GIR_Coverage, 3605,
     /*  567688 */     GIR_EraseRootFromParent_Done,
     /*  567689 */   // Label 9314: @567689
     /*  567689 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(567764), // Rule ID 3608 //
     /*  567694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567740 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567762 */     GIR_RootConstrainSelectedInstOperands,
     /*  567763 */     // GIR_Coverage, 3608,
     /*  567763 */     GIR_EraseRootFromParent_Done,
     /*  567764 */   // Label 9315: @567764
     /*  567764 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(567839), // Rule ID 3609 //
     /*  567769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567837 */     GIR_RootConstrainSelectedInstOperands,
     /*  567838 */     // GIR_Coverage, 3609,
     /*  567838 */     GIR_EraseRootFromParent_Done,
     /*  567839 */   // Label 9316: @567839
     /*  567839 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(567914), // Rule ID 3612 //
     /*  567844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567912 */     GIR_RootConstrainSelectedInstOperands,
     /*  567913 */     // GIR_Coverage, 3612,
     /*  567913 */     GIR_EraseRootFromParent_Done,
     /*  567914 */   // Label 9317: @567914
     /*  567914 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(567989), // Rule ID 3613 //
     /*  567919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567987 */     GIR_RootConstrainSelectedInstOperands,
     /*  567988 */     // GIR_Coverage, 3613,
     /*  567988 */     GIR_EraseRootFromParent_Done,
     /*  567989 */   // Label 9318: @567989
     /*  567989 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(568064), // Rule ID 3616 //
     /*  567994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  568011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  568014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568040 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  568043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568062 */     GIR_RootConstrainSelectedInstOperands,
     /*  568063 */     // GIR_Coverage, 3616,
     /*  568063 */     GIR_EraseRootFromParent_Done,
     /*  568064 */   // Label 9319: @568064
     /*  568064 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(568139), // Rule ID 3617 //
     /*  568069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  568086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  568089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  568118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568137 */     GIR_RootConstrainSelectedInstOperands,
     /*  568138 */     // GIR_Coverage, 3617,
     /*  568138 */     GIR_EraseRootFromParent_Done,
     /*  568139 */   // Label 9320: @568139
     /*  568139 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(568214), // Rule ID 3620 //
     /*  568144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  568161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  568164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568212 */     GIR_RootConstrainSelectedInstOperands,
     /*  568213 */     // GIR_Coverage, 3620,
     /*  568213 */     GIR_EraseRootFromParent_Done,
     /*  568214 */   // Label 9321: @568214
     /*  568214 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(568289), // Rule ID 3621 //
     /*  568219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  568236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  568239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568287 */     GIR_RootConstrainSelectedInstOperands,
     /*  568288 */     // GIR_Coverage, 3621,
     /*  568288 */     GIR_EraseRootFromParent_Done,
     /*  568289 */   // Label 9322: @568289
     /*  568289 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(568364), // Rule ID 3624 //
     /*  568294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  568308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  568314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568362 */     GIR_RootConstrainSelectedInstOperands,
     /*  568363 */     // GIR_Coverage, 3624,
     /*  568363 */     GIR_EraseRootFromParent_Done,
     /*  568364 */   // Label 9323: @568364
     /*  568364 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(568439), // Rule ID 3625 //
     /*  568369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  568380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  568383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  568389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568437 */     GIR_RootConstrainSelectedInstOperands,
     /*  568438 */     // GIR_Coverage, 3625,
     /*  568438 */     GIR_EraseRootFromParent_Done,
     /*  568439 */   // Label 9324: @568439
     /*  568439 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(568514), // Rule ID 3628 //
     /*  568444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568512 */     GIR_RootConstrainSelectedInstOperands,
     /*  568513 */     // GIR_Coverage, 3628,
     /*  568513 */     GIR_EraseRootFromParent_Done,
     /*  568514 */   // Label 9325: @568514
     /*  568514 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(568589), // Rule ID 3629 //
     /*  568519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568587 */     GIR_RootConstrainSelectedInstOperands,
     /*  568588 */     // GIR_Coverage, 3629,
     /*  568588 */     GIR_EraseRootFromParent_Done,
     /*  568589 */   // Label 9326: @568589
     /*  568589 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(568664), // Rule ID 3632 //
     /*  568594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568662 */     GIR_RootConstrainSelectedInstOperands,
     /*  568663 */     // GIR_Coverage, 3632,
     /*  568663 */     GIR_EraseRootFromParent_Done,
     /*  568664 */   // Label 9327: @568664
     /*  568664 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(568739), // Rule ID 3633 //
     /*  568669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568737 */     GIR_RootConstrainSelectedInstOperands,
     /*  568738 */     // GIR_Coverage, 3633,
     /*  568738 */     GIR_EraseRootFromParent_Done,
     /*  568739 */   // Label 9328: @568739
     /*  568739 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(568814), // Rule ID 3636 //
     /*  568744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568812 */     GIR_RootConstrainSelectedInstOperands,
     /*  568813 */     // GIR_Coverage, 3636,
     /*  568813 */     GIR_EraseRootFromParent_Done,
     /*  568814 */   // Label 9329: @568814
     /*  568814 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(568889), // Rule ID 3637 //
     /*  568819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568887 */     GIR_RootConstrainSelectedInstOperands,
     /*  568888 */     // GIR_Coverage, 3637,
     /*  568888 */     GIR_EraseRootFromParent_Done,
     /*  568889 */   // Label 9330: @568889
     /*  568889 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(568964), // Rule ID 3640 //
     /*  568894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568962 */     GIR_RootConstrainSelectedInstOperands,
     /*  568963 */     // GIR_Coverage, 3640,
     /*  568963 */     GIR_EraseRootFromParent_Done,
     /*  568964 */   // Label 9331: @568964
     /*  568964 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(569039), // Rule ID 3641 //
     /*  568969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  569018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569037 */     GIR_RootConstrainSelectedInstOperands,
     /*  569038 */     // GIR_Coverage, 3641,
     /*  569038 */     GIR_EraseRootFromParent_Done,
     /*  569039 */   // Label 9332: @569039
     /*  569039 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(569114), // Rule ID 3644 //
     /*  569044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  569047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  569055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  569058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  569064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  569093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569112 */     GIR_RootConstrainSelectedInstOperands,
     /*  569113 */     // GIR_Coverage, 3644,
     /*  569113 */     GIR_EraseRootFromParent_Done,
     /*  569114 */   // Label 9333: @569114
     /*  569114 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(569189), // Rule ID 3645 //
     /*  569119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  569122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  569130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  569133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  569139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569165 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  569168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569187 */     GIR_RootConstrainSelectedInstOperands,
     /*  569188 */     // GIR_Coverage, 3645,
     /*  569188 */     GIR_EraseRootFromParent_Done,
     /*  569189 */   // Label 9334: @569189
     /*  569189 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(569264), // Rule ID 3648 //
     /*  569194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  569197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  569205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  569208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  569214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569240 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  569243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569262 */     GIR_RootConstrainSelectedInstOperands,
     /*  569263 */     // GIR_Coverage, 3648,
     /*  569263 */     GIR_EraseRootFromParent_Done,
     /*  569264 */   // Label 9335: @569264
     /*  569264 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(569339), // Rule ID 3649 //
     /*  569269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  569272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  569280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  569283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  569289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  569318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569337 */     GIR_RootConstrainSelectedInstOperands,
     /*  569338 */     // GIR_Coverage, 3649,
     /*  569338 */     GIR_EraseRootFromParent_Done,
     /*  569339 */   // Label 9336: @569339
     /*  569339 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(569414), // Rule ID 3652 //
     /*  569344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569412 */     GIR_RootConstrainSelectedInstOperands,
     /*  569413 */     // GIR_Coverage, 3652,
     /*  569413 */     GIR_EraseRootFromParent_Done,
     /*  569414 */   // Label 9337: @569414
     /*  569414 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(569489), // Rule ID 3653 //
     /*  569419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  569430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  569433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  569436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569487 */     GIR_RootConstrainSelectedInstOperands,
     /*  569488 */     // GIR_Coverage, 3653,
     /*  569488 */     GIR_EraseRootFromParent_Done,
     /*  569489 */   // Label 9338: @569489
     /*  569489 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(569564), // Rule ID 3656 //
     /*  569494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569562 */     GIR_RootConstrainSelectedInstOperands,
     /*  569563 */     // GIR_Coverage, 3656,
     /*  569563 */     GIR_EraseRootFromParent_Done,
     /*  569564 */   // Label 9339: @569564
     /*  569564 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(569639), // Rule ID 3657 //
     /*  569569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569637 */     GIR_RootConstrainSelectedInstOperands,
     /*  569638 */     // GIR_Coverage, 3657,
     /*  569638 */     GIR_EraseRootFromParent_Done,
     /*  569639 */   // Label 9340: @569639
     /*  569639 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(569714), // Rule ID 3660 //
     /*  569644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569712 */     GIR_RootConstrainSelectedInstOperands,
     /*  569713 */     // GIR_Coverage, 3660,
     /*  569713 */     GIR_EraseRootFromParent_Done,
     /*  569714 */   // Label 9341: @569714
     /*  569714 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(569789), // Rule ID 3661 //
     /*  569719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11699:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569787 */     GIR_RootConstrainSelectedInstOperands,
     /*  569788 */     // GIR_Coverage, 3661,
     /*  569788 */     GIR_EraseRootFromParent_Done,
     /*  569789 */   // Label 9342: @569789
     /*  569789 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(569864), // Rule ID 3664 //
     /*  569794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569862 */     GIR_RootConstrainSelectedInstOperands,
     /*  569863 */     // GIR_Coverage, 3664,
     /*  569863 */     GIR_EraseRootFromParent_Done,
     /*  569864 */   // Label 9343: @569864
     /*  569864 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(569939), // Rule ID 3665 //
     /*  569869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569937 */     GIR_RootConstrainSelectedInstOperands,
     /*  569938 */     // GIR_Coverage, 3665,
     /*  569938 */     GIR_EraseRootFromParent_Done,
     /*  569939 */   // Label 9344: @569939
     /*  569939 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(570014), // Rule ID 3668 //
     /*  569944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570012 */     GIR_RootConstrainSelectedInstOperands,
     /*  570013 */     // GIR_Coverage, 3668,
     /*  570013 */     GIR_EraseRootFromParent_Done,
     /*  570014 */   // Label 9345: @570014
     /*  570014 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(570089), // Rule ID 3669 //
     /*  570019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  570030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  570033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  570036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570065 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570087 */     GIR_RootConstrainSelectedInstOperands,
     /*  570088 */     // GIR_Coverage, 3669,
     /*  570088 */     GIR_EraseRootFromParent_Done,
     /*  570089 */   // Label 9346: @570089
     /*  570089 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(570164), // Rule ID 3672 //
     /*  570094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  570105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  570108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570162 */     GIR_RootConstrainSelectedInstOperands,
     /*  570163 */     // GIR_Coverage, 3672,
     /*  570163 */     GIR_EraseRootFromParent_Done,
     /*  570164 */   // Label 9347: @570164
     /*  570164 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(570239), // Rule ID 3673 //
     /*  570169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  570180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  570183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  570186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570215 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570237 */     GIR_RootConstrainSelectedInstOperands,
     /*  570238 */     // GIR_Coverage, 3673,
     /*  570238 */     GIR_EraseRootFromParent_Done,
     /*  570239 */   // Label 9348: @570239
     /*  570239 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(570314), // Rule ID 3676 //
     /*  570244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  570255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  570258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  570261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  570293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570312 */     GIR_RootConstrainSelectedInstOperands,
     /*  570313 */     // GIR_Coverage, 3676,
     /*  570313 */     GIR_EraseRootFromParent_Done,
     /*  570314 */   // Label 9349: @570314
     /*  570314 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(570389), // Rule ID 3677 //
     /*  570319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  570330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  570333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  570336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570365 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  570368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570387 */     GIR_RootConstrainSelectedInstOperands,
     /*  570388 */     // GIR_Coverage, 3677,
     /*  570388 */     GIR_EraseRootFromParent_Done,
     /*  570389 */   // Label 9350: @570389
     /*  570389 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(570464), // Rule ID 3680 //
     /*  570394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570462 */     GIR_RootConstrainSelectedInstOperands,
     /*  570463 */     // GIR_Coverage, 3680,
     /*  570463 */     GIR_EraseRootFromParent_Done,
     /*  570464 */   // Label 9351: @570464
     /*  570464 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(570539), // Rule ID 3681 //
     /*  570469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11699:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570537 */     GIR_RootConstrainSelectedInstOperands,
     /*  570538 */     // GIR_Coverage, 3681,
     /*  570538 */     GIR_EraseRootFromParent_Done,
     /*  570539 */   // Label 9352: @570539
     /*  570539 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(570614), // Rule ID 3684 //
     /*  570544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570612 */     GIR_RootConstrainSelectedInstOperands,
     /*  570613 */     // GIR_Coverage, 3684,
     /*  570613 */     GIR_EraseRootFromParent_Done,
     /*  570614 */   // Label 9353: @570614
     /*  570614 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(570689), // Rule ID 3685 //
     /*  570619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570687 */     GIR_RootConstrainSelectedInstOperands,
     /*  570688 */     // GIR_Coverage, 3685,
     /*  570688 */     GIR_EraseRootFromParent_Done,
     /*  570689 */   // Label 9354: @570689
     /*  570689 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(570764), // Rule ID 3688 //
     /*  570694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570762 */     GIR_RootConstrainSelectedInstOperands,
     /*  570763 */     // GIR_Coverage, 3688,
     /*  570763 */     GIR_EraseRootFromParent_Done,
     /*  570764 */   // Label 9355: @570764
     /*  570764 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(570839), // Rule ID 3689 //
     /*  570769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570815 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570837 */     GIR_RootConstrainSelectedInstOperands,
     /*  570838 */     // GIR_Coverage, 3689,
     /*  570838 */     GIR_EraseRootFromParent_Done,
     /*  570839 */   // Label 9356: @570839
     /*  570839 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(570914), // Rule ID 3692 //
     /*  570844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570912 */     GIR_RootConstrainSelectedInstOperands,
     /*  570913 */     // GIR_Coverage, 3692,
     /*  570913 */     GIR_EraseRootFromParent_Done,
     /*  570914 */   // Label 9357: @570914
     /*  570914 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(570989), // Rule ID 3693 //
     /*  570919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570987 */     GIR_RootConstrainSelectedInstOperands,
     /*  570988 */     // GIR_Coverage, 3693,
     /*  570988 */     GIR_EraseRootFromParent_Done,
     /*  570989 */   // Label 9358: @570989
     /*  570989 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(571064), // Rule ID 3696 //
     /*  570994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  571005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  571008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  571011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  571043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571062 */     GIR_RootConstrainSelectedInstOperands,
     /*  571063 */     // GIR_Coverage, 3696,
     /*  571063 */     GIR_EraseRootFromParent_Done,
     /*  571064 */   // Label 9359: @571064
     /*  571064 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(571139), // Rule ID 3697 //
     /*  571069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  571080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  571083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  571086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11699:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  571118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571137 */     GIR_RootConstrainSelectedInstOperands,
     /*  571138 */     // GIR_Coverage, 3697,
     /*  571138 */     GIR_EraseRootFromParent_Done,
     /*  571139 */   // Label 9360: @571139
     /*  571139 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(571214), // Rule ID 3700 //
     /*  571144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  571155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  571158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  571161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  571193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571212 */     GIR_RootConstrainSelectedInstOperands,
     /*  571213 */     // GIR_Coverage, 3700,
     /*  571213 */     GIR_EraseRootFromParent_Done,
     /*  571214 */   // Label 9361: @571214
     /*  571214 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(571289), // Rule ID 3701 //
     /*  571219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  571230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  571233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  571236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571265 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11699:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  571268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571287 */     GIR_RootConstrainSelectedInstOperands,
     /*  571288 */     // GIR_Coverage, 3701,
     /*  571288 */     GIR_EraseRootFromParent_Done,
     /*  571289 */   // Label 9362: @571289
     /*  571289 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(571364), // Rule ID 3704 //
     /*  571294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  571305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  571308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  571343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571362 */     GIR_RootConstrainSelectedInstOperands,
     /*  571363 */     // GIR_Coverage, 3704,
     /*  571363 */     GIR_EraseRootFromParent_Done,
     /*  571364 */   // Label 9363: @571364
     /*  571364 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(571439), // Rule ID 3705 //
     /*  571369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  571380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  571383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  571386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571415 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11699:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  571418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571437 */     GIR_RootConstrainSelectedInstOperands,
     /*  571438 */     // GIR_Coverage, 3705,
     /*  571438 */     GIR_EraseRootFromParent_Done,
     /*  571439 */   // Label 9364: @571439
     /*  571439 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(571514), // Rule ID 3708 //
     /*  571444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  571447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  571464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571512 */     GIR_RootConstrainSelectedInstOperands,
     /*  571513 */     // GIR_Coverage, 3708,
     /*  571513 */     GIR_EraseRootFromParent_Done,
     /*  571514 */   // Label 9365: @571514
     /*  571514 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(571589), // Rule ID 3709 //
     /*  571519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571565 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11699:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571587 */     GIR_RootConstrainSelectedInstOperands,
     /*  571588 */     // GIR_Coverage, 3709,
     /*  571588 */     GIR_EraseRootFromParent_Done,
     /*  571589 */   // Label 9366: @571589
     /*  571589 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(571664), // Rule ID 3712 //
     /*  571594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571662 */     GIR_RootConstrainSelectedInstOperands,
     /*  571663 */     // GIR_Coverage, 3712,
     /*  571663 */     GIR_EraseRootFromParent_Done,
     /*  571664 */   // Label 9367: @571664
     /*  571664 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(571739), // Rule ID 3713 //
     /*  571669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571715 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571737 */     GIR_RootConstrainSelectedInstOperands,
     /*  571738 */     // GIR_Coverage, 3713,
     /*  571738 */     GIR_EraseRootFromParent_Done,
     /*  571739 */   // Label 9368: @571739
     /*  571739 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(571814), // Rule ID 3716 //
     /*  571744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571812 */     GIR_RootConstrainSelectedInstOperands,
     /*  571813 */     // GIR_Coverage, 3716,
     /*  571813 */     GIR_EraseRootFromParent_Done,
     /*  571814 */   // Label 9369: @571814
     /*  571814 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(571889), // Rule ID 3717 //
     /*  571819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571865 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571887 */     GIR_RootConstrainSelectedInstOperands,
     /*  571888 */     // GIR_Coverage, 3717,
     /*  571888 */     GIR_EraseRootFromParent_Done,
     /*  571889 */   // Label 9370: @571889
     /*  571889 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(571964), // Rule ID 3720 //
     /*  571894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571962 */     GIR_RootConstrainSelectedInstOperands,
     /*  571963 */     // GIR_Coverage, 3720,
     /*  571963 */     GIR_EraseRootFromParent_Done,
     /*  571964 */   // Label 9371: @571964
     /*  571964 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(572039), // Rule ID 3721 //
     /*  571969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572037 */     GIR_RootConstrainSelectedInstOperands,
     /*  572038 */     // GIR_Coverage, 3721,
     /*  572038 */     GIR_EraseRootFromParent_Done,
     /*  572039 */   // Label 9372: @572039
     /*  572039 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(572114), // Rule ID 3724 //
     /*  572044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  572055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  572058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  572061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  572064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572112 */     GIR_RootConstrainSelectedInstOperands,
     /*  572113 */     // GIR_Coverage, 3724,
     /*  572113 */     GIR_EraseRootFromParent_Done,
     /*  572114 */   // Label 9373: @572114
     /*  572114 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(572189), // Rule ID 3725 //
     /*  572119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  572130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  572133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  572136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  572139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572187 */     GIR_RootConstrainSelectedInstOperands,
     /*  572188 */     // GIR_Coverage, 3725,
     /*  572188 */     GIR_EraseRootFromParent_Done,
     /*  572189 */   // Label 9374: @572189
     /*  572189 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(572264), // Rule ID 3728 //
     /*  572194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  572205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  572208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  572211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  572214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572262 */     GIR_RootConstrainSelectedInstOperands,
     /*  572263 */     // GIR_Coverage, 3728,
     /*  572263 */     GIR_EraseRootFromParent_Done,
     /*  572264 */   // Label 9375: @572264
     /*  572264 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(572339), // Rule ID 3729 //
     /*  572269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  572280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  572283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  572286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  572289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572315 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572337 */     GIR_RootConstrainSelectedInstOperands,
     /*  572338 */     // GIR_Coverage, 3729,
     /*  572338 */     GIR_EraseRootFromParent_Done,
     /*  572339 */   // Label 9376: @572339
     /*  572339 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(572414), // Rule ID 3732 //
     /*  572344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  572355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  572358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  572361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  572364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572412 */     GIR_RootConstrainSelectedInstOperands,
     /*  572413 */     // GIR_Coverage, 3732,
     /*  572413 */     GIR_EraseRootFromParent_Done,
     /*  572414 */   // Label 9377: @572414
     /*  572414 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(572489), // Rule ID 3733 //
     /*  572419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  572430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  572433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  572436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  572439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572465 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572487 */     GIR_RootConstrainSelectedInstOperands,
     /*  572488 */     // GIR_Coverage, 3733,
     /*  572488 */     GIR_EraseRootFromParent_Done,
     /*  572489 */   // Label 9378: @572489
     /*  572489 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(572564), // Rule ID 3736 //
     /*  572494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572562 */     GIR_RootConstrainSelectedInstOperands,
     /*  572563 */     // GIR_Coverage, 3736,
     /*  572563 */     GIR_EraseRootFromParent_Done,
     /*  572564 */   // Label 9379: @572564
     /*  572564 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(572639), // Rule ID 3737 //
     /*  572569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572615 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572637 */     GIR_RootConstrainSelectedInstOperands,
     /*  572638 */     // GIR_Coverage, 3737,
     /*  572638 */     GIR_EraseRootFromParent_Done,
     /*  572639 */   // Label 9380: @572639
     /*  572639 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(572714), // Rule ID 3740 //
     /*  572644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572712 */     GIR_RootConstrainSelectedInstOperands,
     /*  572713 */     // GIR_Coverage, 3740,
     /*  572713 */     GIR_EraseRootFromParent_Done,
     /*  572714 */   // Label 9381: @572714
     /*  572714 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(572789), // Rule ID 3741 //
     /*  572719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572787 */     GIR_RootConstrainSelectedInstOperands,
     /*  572788 */     // GIR_Coverage, 3741,
     /*  572788 */     GIR_EraseRootFromParent_Done,
     /*  572789 */   // Label 9382: @572789
     /*  572789 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(572864), // Rule ID 3744 //
     /*  572794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572862 */     GIR_RootConstrainSelectedInstOperands,
     /*  572863 */     // GIR_Coverage, 3744,
     /*  572863 */     GIR_EraseRootFromParent_Done,
     /*  572864 */   // Label 9383: @572864
     /*  572864 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(572939), // Rule ID 3745 //
     /*  572869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572937 */     GIR_RootConstrainSelectedInstOperands,
     /*  572938 */     // GIR_Coverage, 3745,
     /*  572938 */     GIR_EraseRootFromParent_Done,
     /*  572939 */   // Label 9384: @572939
     /*  572939 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(573014), // Rule ID 3748 //
     /*  572944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573012 */     GIR_RootConstrainSelectedInstOperands,
     /*  573013 */     // GIR_Coverage, 3748,
     /*  573013 */     GIR_EraseRootFromParent_Done,
     /*  573014 */   // Label 9385: @573014
     /*  573014 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(573089), // Rule ID 3749 //
     /*  573019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  573030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  573033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  573036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  573039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573065 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573087 */     GIR_RootConstrainSelectedInstOperands,
     /*  573088 */     // GIR_Coverage, 3749,
     /*  573088 */     GIR_EraseRootFromParent_Done,
     /*  573089 */   // Label 9386: @573089
     /*  573089 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(573164), // Rule ID 3752 //
     /*  573094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  573105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  573108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  573111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  573114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573162 */     GIR_RootConstrainSelectedInstOperands,
     /*  573163 */     // GIR_Coverage, 3752,
     /*  573163 */     GIR_EraseRootFromParent_Done,
     /*  573164 */   // Label 9387: @573164
     /*  573164 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(573239), // Rule ID 3753 //
     /*  573169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  573180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  573183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  573186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  573189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573215 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573237 */     GIR_RootConstrainSelectedInstOperands,
     /*  573238 */     // GIR_Coverage, 3753,
     /*  573238 */     GIR_EraseRootFromParent_Done,
     /*  573239 */   // Label 9388: @573239
     /*  573239 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(573314), // Rule ID 3756 //
     /*  573244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  573264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  573293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573312 */     GIR_RootConstrainSelectedInstOperands,
     /*  573313 */     // GIR_Coverage, 3756,
     /*  573313 */     GIR_EraseRootFromParent_Done,
     /*  573314 */   // Label 9389: @573314
     /*  573314 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(573389), // Rule ID 3757 //
     /*  573319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  573330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  573333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  573336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  573339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  573368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573387 */     GIR_RootConstrainSelectedInstOperands,
     /*  573388 */     // GIR_Coverage, 3757,
     /*  573388 */     GIR_EraseRootFromParent_Done,
     /*  573389 */   // Label 9390: @573389
     /*  573389 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(573464), // Rule ID 3760 //
     /*  573394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573462 */     GIR_RootConstrainSelectedInstOperands,
     /*  573463 */     // GIR_Coverage, 3760,
     /*  573463 */     GIR_EraseRootFromParent_Done,
     /*  573464 */   // Label 9391: @573464
     /*  573464 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(573539), // Rule ID 3761 //
     /*  573469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573537 */     GIR_RootConstrainSelectedInstOperands,
     /*  573538 */     // GIR_Coverage, 3761,
     /*  573538 */     GIR_EraseRootFromParent_Done,
     /*  573539 */   // Label 9392: @573539
     /*  573539 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(573614), // Rule ID 3764 //
     /*  573544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573612 */     GIR_RootConstrainSelectedInstOperands,
     /*  573613 */     // GIR_Coverage, 3764,
     /*  573613 */     GIR_EraseRootFromParent_Done,
     /*  573614 */   // Label 9393: @573614
     /*  573614 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(573689), // Rule ID 3765 //
     /*  573619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573665 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573687 */     GIR_RootConstrainSelectedInstOperands,
     /*  573688 */     // GIR_Coverage, 3765,
     /*  573688 */     GIR_EraseRootFromParent_Done,
     /*  573689 */   // Label 9394: @573689
     /*  573689 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(573764), // Rule ID 3768 //
     /*  573694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573740 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573762 */     GIR_RootConstrainSelectedInstOperands,
     /*  573763 */     // GIR_Coverage, 3768,
     /*  573763 */     GIR_EraseRootFromParent_Done,
     /*  573764 */   // Label 9395: @573764
     /*  573764 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(573839), // Rule ID 3769 //
     /*  573769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573837 */     GIR_RootConstrainSelectedInstOperands,
     /*  573838 */     // GIR_Coverage, 3769,
     /*  573838 */     GIR_EraseRootFromParent_Done,
     /*  573839 */   // Label 9396: @573839
     /*  573839 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(573914), // Rule ID 3772 //
     /*  573844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573912 */     GIR_RootConstrainSelectedInstOperands,
     /*  573913 */     // GIR_Coverage, 3772,
     /*  573913 */     GIR_EraseRootFromParent_Done,
     /*  573914 */   // Label 9397: @573914
     /*  573914 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(573989), // Rule ID 3773 //
     /*  573919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573965 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573987 */     GIR_RootConstrainSelectedInstOperands,
     /*  573988 */     // GIR_Coverage, 3773,
     /*  573988 */     GIR_EraseRootFromParent_Done,
     /*  573989 */   // Label 9398: @573989
     /*  573989 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(574064), // Rule ID 3776 //
     /*  573994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  574005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  574008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  574011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574062 */     GIR_RootConstrainSelectedInstOperands,
     /*  574063 */     // GIR_Coverage, 3776,
     /*  574063 */     GIR_EraseRootFromParent_Done,
     /*  574064 */   // Label 9399: @574064
     /*  574064 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(574139), // Rule ID 3777 //
     /*  574069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  574080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  574083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  574086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574115 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574137 */     GIR_RootConstrainSelectedInstOperands,
     /*  574138 */     // GIR_Coverage, 3777,
     /*  574138 */     GIR_EraseRootFromParent_Done,
     /*  574139 */   // Label 9400: @574139
     /*  574139 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(574214), // Rule ID 3780 //
     /*  574144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  574155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  574158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  574161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574212 */     GIR_RootConstrainSelectedInstOperands,
     /*  574213 */     // GIR_Coverage, 3780,
     /*  574213 */     GIR_EraseRootFromParent_Done,
     /*  574214 */   // Label 9401: @574214
     /*  574214 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(574289), // Rule ID 3781 //
     /*  574219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  574230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  574233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  574236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574265 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11727:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574287 */     GIR_RootConstrainSelectedInstOperands,
     /*  574288 */     // GIR_Coverage, 3781,
     /*  574288 */     GIR_EraseRootFromParent_Done,
     /*  574289 */   // Label 9402: @574289
     /*  574289 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(574364), // Rule ID 3784 //
     /*  574294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  574311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574362 */     GIR_RootConstrainSelectedInstOperands,
     /*  574363 */     // GIR_Coverage, 3784,
     /*  574363 */     GIR_EraseRootFromParent_Done,
     /*  574364 */   // Label 9403: @574364
     /*  574364 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(574439), // Rule ID 3785 //
     /*  574369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  574380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  574383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  574386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574415 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574437 */     GIR_RootConstrainSelectedInstOperands,
     /*  574438 */     // GIR_Coverage, 3785,
     /*  574438 */     GIR_EraseRootFromParent_Done,
     /*  574439 */   // Label 9404: @574439
     /*  574439 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(574514), // Rule ID 3788 //
     /*  574444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574512 */     GIR_RootConstrainSelectedInstOperands,
     /*  574513 */     // GIR_Coverage, 3788,
     /*  574513 */     GIR_EraseRootFromParent_Done,
     /*  574514 */   // Label 9405: @574514
     /*  574514 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(574589), // Rule ID 3789 //
     /*  574519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574587 */     GIR_RootConstrainSelectedInstOperands,
     /*  574588 */     // GIR_Coverage, 3789,
     /*  574588 */     GIR_EraseRootFromParent_Done,
     /*  574589 */   // Label 9406: @574589
     /*  574589 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(574664), // Rule ID 3792 //
     /*  574594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574640 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574662 */     GIR_RootConstrainSelectedInstOperands,
     /*  574663 */     // GIR_Coverage, 3792,
     /*  574663 */     GIR_EraseRootFromParent_Done,
     /*  574664 */   // Label 9407: @574664
     /*  574664 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(574739), // Rule ID 3793 //
     /*  574669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574737 */     GIR_RootConstrainSelectedInstOperands,
     /*  574738 */     // GIR_Coverage, 3793,
     /*  574738 */     GIR_EraseRootFromParent_Done,
     /*  574739 */   // Label 9408: @574739
     /*  574739 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(574814), // Rule ID 3796 //
     /*  574744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574812 */     GIR_RootConstrainSelectedInstOperands,
     /*  574813 */     // GIR_Coverage, 3796,
     /*  574813 */     GIR_EraseRootFromParent_Done,
     /*  574814 */   // Label 9409: @574814
     /*  574814 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(574889), // Rule ID 3797 //
     /*  574819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574865 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574887 */     GIR_RootConstrainSelectedInstOperands,
     /*  574888 */     // GIR_Coverage, 3797,
     /*  574888 */     GIR_EraseRootFromParent_Done,
     /*  574889 */   // Label 9410: @574889
     /*  574889 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(574964), // Rule ID 3800 //
     /*  574894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574962 */     GIR_RootConstrainSelectedInstOperands,
     /*  574963 */     // GIR_Coverage, 3800,
     /*  574963 */     GIR_EraseRootFromParent_Done,
     /*  574964 */   // Label 9411: @574964
     /*  574964 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(575039), // Rule ID 3801 //
     /*  574969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11727:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575037 */     GIR_RootConstrainSelectedInstOperands,
     /*  575038 */     // GIR_Coverage, 3801,
     /*  575038 */     GIR_EraseRootFromParent_Done,
     /*  575039 */   // Label 9412: @575039
     /*  575039 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(575114), // Rule ID 3804 //
     /*  575044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  575055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  575058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  575061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575112 */     GIR_RootConstrainSelectedInstOperands,
     /*  575113 */     // GIR_Coverage, 3804,
     /*  575113 */     GIR_EraseRootFromParent_Done,
     /*  575114 */   // Label 9413: @575114
     /*  575114 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(575189), // Rule ID 3805 //
     /*  575119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  575130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  575133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  575136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575187 */     GIR_RootConstrainSelectedInstOperands,
     /*  575188 */     // GIR_Coverage, 3805,
     /*  575188 */     GIR_EraseRootFromParent_Done,
     /*  575189 */   // Label 9414: @575189
     /*  575189 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(575264), // Rule ID 3808 //
     /*  575194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  575211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575262 */     GIR_RootConstrainSelectedInstOperands,
     /*  575263 */     // GIR_Coverage, 3808,
     /*  575263 */     GIR_EraseRootFromParent_Done,
     /*  575264 */   // Label 9415: @575264
     /*  575264 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(575339), // Rule ID 3809 //
     /*  575269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  575280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  575283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  575286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575315 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575337 */     GIR_RootConstrainSelectedInstOperands,
     /*  575338 */     // GIR_Coverage, 3809,
     /*  575338 */     GIR_EraseRootFromParent_Done,
     /*  575339 */   // Label 9416: @575339
     /*  575339 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(575414), // Rule ID 3812 //
     /*  575344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  575361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575412 */     GIR_RootConstrainSelectedInstOperands,
     /*  575413 */     // GIR_Coverage, 3812,
     /*  575413 */     GIR_EraseRootFromParent_Done,
     /*  575414 */   // Label 9417: @575414
     /*  575414 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(575489), // Rule ID 3813 //
     /*  575419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  575430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  575433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  575436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575465 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575487 */     GIR_RootConstrainSelectedInstOperands,
     /*  575488 */     // GIR_Coverage, 3813,
     /*  575488 */     GIR_EraseRootFromParent_Done,
     /*  575489 */   // Label 9418: @575489
     /*  575489 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(575564), // Rule ID 3816 //
     /*  575494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575562 */     GIR_RootConstrainSelectedInstOperands,
     /*  575563 */     // GIR_Coverage, 3816,
     /*  575563 */     GIR_EraseRootFromParent_Done,
     /*  575564 */   // Label 9419: @575564
     /*  575564 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(575639), // Rule ID 3817 //
     /*  575569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11727:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575637 */     GIR_RootConstrainSelectedInstOperands,
     /*  575638 */     // GIR_Coverage, 3817,
     /*  575638 */     GIR_EraseRootFromParent_Done,
     /*  575639 */   // Label 9420: @575639
     /*  575639 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(575714), // Rule ID 3820 //
     /*  575644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575712 */     GIR_RootConstrainSelectedInstOperands,
     /*  575713 */     // GIR_Coverage, 3820,
     /*  575713 */     GIR_EraseRootFromParent_Done,
     /*  575714 */   // Label 9421: @575714
     /*  575714 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(575789), // Rule ID 3821 //
     /*  575719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11727:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575787 */     GIR_RootConstrainSelectedInstOperands,
     /*  575788 */     // GIR_Coverage, 3821,
     /*  575788 */     GIR_EraseRootFromParent_Done,
     /*  575789 */   // Label 9422: @575789
     /*  575789 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(575864), // Rule ID 3824 //
     /*  575794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575862 */     GIR_RootConstrainSelectedInstOperands,
     /*  575863 */     // GIR_Coverage, 3824,
     /*  575863 */     GIR_EraseRootFromParent_Done,
     /*  575864 */   // Label 9423: @575864
     /*  575864 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(575939), // Rule ID 3825 //
     /*  575869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575915 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11727:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575937 */     GIR_RootConstrainSelectedInstOperands,
     /*  575938 */     // GIR_Coverage, 3825,
     /*  575938 */     GIR_EraseRootFromParent_Done,
     /*  575939 */   // Label 9424: @575939
     /*  575939 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(576014), // Rule ID 3828 //
     /*  575944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576012 */     GIR_RootConstrainSelectedInstOperands,
     /*  576013 */     // GIR_Coverage, 3828,
     /*  576013 */     GIR_EraseRootFromParent_Done,
     /*  576014 */   // Label 9425: @576014
     /*  576014 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(576089), // Rule ID 3829 //
     /*  576019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  576030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  576033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  576036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  576039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  576058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576065 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11727:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  576068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576087 */     GIR_RootConstrainSelectedInstOperands,
     /*  576088 */     // GIR_Coverage, 3829,
     /*  576088 */     GIR_EraseRootFromParent_Done,
     /*  576089 */   // Label 9426: @576089
     /*  576089 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(576164), // Rule ID 3832 //
     /*  576094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  576111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  576114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576140 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  576143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576162 */     GIR_RootConstrainSelectedInstOperands,
     /*  576163 */     // GIR_Coverage, 3832,
     /*  576163 */     GIR_EraseRootFromParent_Done,
     /*  576164 */   // Label 9427: @576164
     /*  576164 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(576239), // Rule ID 3833 //
     /*  576169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  576180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  576183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  576186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  576189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576215 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  576218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576237 */     GIR_RootConstrainSelectedInstOperands,
     /*  576238 */     // GIR_Coverage, 3833,
     /*  576238 */     GIR_EraseRootFromParent_Done,
     /*  576239 */   // Label 9428: @576239
     /*  576239 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(576314), // Rule ID 3836 //
     /*  576244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  576261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  576264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576312 */     GIR_RootConstrainSelectedInstOperands,
     /*  576313 */     // GIR_Coverage, 3836,
     /*  576313 */     GIR_EraseRootFromParent_Done,
     /*  576314 */   // Label 9429: @576314
     /*  576314 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(576389), // Rule ID 3837 //
     /*  576319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  576330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  576333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  576336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  576339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576365 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576387 */     GIR_RootConstrainSelectedInstOperands,
     /*  576388 */     // GIR_Coverage, 3837,
     /*  576388 */     GIR_EraseRootFromParent_Done,
     /*  576389 */   // Label 9430: @576389
     /*  576389 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(576464), // Rule ID 3840 //
     /*  576394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576462 */     GIR_RootConstrainSelectedInstOperands,
     /*  576463 */     // GIR_Coverage, 3840,
     /*  576463 */     GIR_EraseRootFromParent_Done,
     /*  576464 */   // Label 9431: @576464
     /*  576464 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(576539), // Rule ID 3841 //
     /*  576469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576515 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576537 */     GIR_RootConstrainSelectedInstOperands,
     /*  576538 */     // GIR_Coverage, 3841,
     /*  576538 */     GIR_EraseRootFromParent_Done,
     /*  576539 */   // Label 9432: @576539
     /*  576539 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(576614), // Rule ID 3844 //
     /*  576544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576612 */     GIR_RootConstrainSelectedInstOperands,
     /*  576613 */     // GIR_Coverage, 3844,
     /*  576613 */     GIR_EraseRootFromParent_Done,
     /*  576614 */   // Label 9433: @576614
     /*  576614 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(576689), // Rule ID 3845 //
     /*  576619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576665 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576687 */     GIR_RootConstrainSelectedInstOperands,
     /*  576688 */     // GIR_Coverage, 3845,
     /*  576688 */     GIR_EraseRootFromParent_Done,
     /*  576689 */   // Label 9434: @576689
     /*  576689 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(576764), // Rule ID 3848 //
     /*  576694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576740 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576762 */     GIR_RootConstrainSelectedInstOperands,
     /*  576763 */     // GIR_Coverage, 3848,
     /*  576763 */     GIR_EraseRootFromParent_Done,
     /*  576764 */   // Label 9435: @576764
     /*  576764 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(576839), // Rule ID 3849 //
     /*  576769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576815 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576837 */     GIR_RootConstrainSelectedInstOperands,
     /*  576838 */     // GIR_Coverage, 3849,
     /*  576838 */     GIR_EraseRootFromParent_Done,
     /*  576839 */   // Label 9436: @576839
     /*  576839 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(576914), // Rule ID 3852 //
     /*  576844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576912 */     GIR_RootConstrainSelectedInstOperands,
     /*  576913 */     // GIR_Coverage, 3852,
     /*  576913 */     GIR_EraseRootFromParent_Done,
     /*  576914 */   // Label 9437: @576914
     /*  576914 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(576989), // Rule ID 3853 //
     /*  576919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576987 */     GIR_RootConstrainSelectedInstOperands,
     /*  576988 */     // GIR_Coverage, 3853,
     /*  576988 */     GIR_EraseRootFromParent_Done,
     /*  576989 */   // Label 9438: @576989
     /*  576989 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(577064), // Rule ID 3856 //
     /*  576994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  577005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  577008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  577011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  577014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577040 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  577043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577062 */     GIR_RootConstrainSelectedInstOperands,
     /*  577063 */     // GIR_Coverage, 3856,
     /*  577063 */     GIR_EraseRootFromParent_Done,
     /*  577064 */   // Label 9439: @577064
     /*  577064 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(577139), // Rule ID 3857 //
     /*  577069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  577080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  577083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  577086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  577089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  577118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577137 */     GIR_RootConstrainSelectedInstOperands,
     /*  577138 */     // GIR_Coverage, 3857,
     /*  577138 */     GIR_EraseRootFromParent_Done,
     /*  577139 */   // Label 9440: @577139
     /*  577139 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(577214), // Rule ID 3860 //
     /*  577144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  577161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  577164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577212 */     GIR_RootConstrainSelectedInstOperands,
     /*  577213 */     // GIR_Coverage, 3860,
     /*  577213 */     GIR_EraseRootFromParent_Done,
     /*  577214 */   // Label 9441: @577214
     /*  577214 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(577289), // Rule ID 3861 //
     /*  577219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  577230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  577233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  577236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  577239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577287 */     GIR_RootConstrainSelectedInstOperands,
     /*  577288 */     // GIR_Coverage, 3861,
     /*  577288 */     GIR_EraseRootFromParent_Done,
     /*  577289 */   // Label 9442: @577289
     /*  577289 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(577364), // Rule ID 3864 //
     /*  577294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  577305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  577308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  577311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  577314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577362 */     GIR_RootConstrainSelectedInstOperands,
     /*  577363 */     // GIR_Coverage, 3864,
     /*  577363 */     GIR_EraseRootFromParent_Done,
     /*  577364 */   // Label 9443: @577364
     /*  577364 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(577439), // Rule ID 3865 //
     /*  577369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  577380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  577383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  577386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  577389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577437 */     GIR_RootConstrainSelectedInstOperands,
     /*  577438 */     // GIR_Coverage, 3865,
     /*  577438 */     GIR_EraseRootFromParent_Done,
     /*  577439 */   // Label 9444: @577439
     /*  577439 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(577514), // Rule ID 3868 //
     /*  577444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577512 */     GIR_RootConstrainSelectedInstOperands,
     /*  577513 */     // GIR_Coverage, 3868,
     /*  577513 */     GIR_EraseRootFromParent_Done,
     /*  577514 */   // Label 9445: @577514
     /*  577514 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(577589), // Rule ID 3869 //
     /*  577519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577587 */     GIR_RootConstrainSelectedInstOperands,
     /*  577588 */     // GIR_Coverage, 3869,
     /*  577588 */     GIR_EraseRootFromParent_Done,
     /*  577589 */   // Label 9446: @577589
     /*  577589 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(577664), // Rule ID 3872 //
     /*  577594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577662 */     GIR_RootConstrainSelectedInstOperands,
     /*  577663 */     // GIR_Coverage, 3872,
     /*  577663 */     GIR_EraseRootFromParent_Done,
     /*  577664 */   // Label 9447: @577664
     /*  577664 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(577739), // Rule ID 3873 //
     /*  577669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577737 */     GIR_RootConstrainSelectedInstOperands,
     /*  577738 */     // GIR_Coverage, 3873,
     /*  577738 */     GIR_EraseRootFromParent_Done,
     /*  577739 */   // Label 9448: @577739
     /*  577739 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(577814), // Rule ID 3876 //
     /*  577744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577812 */     GIR_RootConstrainSelectedInstOperands,
     /*  577813 */     // GIR_Coverage, 3876,
     /*  577813 */     GIR_EraseRootFromParent_Done,
     /*  577814 */   // Label 9449: @577814
     /*  577814 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(577889), // Rule ID 3877 //
     /*  577819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577887 */     GIR_RootConstrainSelectedInstOperands,
     /*  577888 */     // GIR_Coverage, 3877,
     /*  577888 */     GIR_EraseRootFromParent_Done,
     /*  577889 */   // Label 9450: @577889
     /*  577889 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(577964), // Rule ID 3880 //
     /*  577894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577962 */     GIR_RootConstrainSelectedInstOperands,
     /*  577963 */     // GIR_Coverage, 3880,
     /*  577963 */     GIR_EraseRootFromParent_Done,
     /*  577964 */   // Label 9451: @577964
     /*  577964 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(578039), // Rule ID 3881 //
     /*  577969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  578018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578037 */     GIR_RootConstrainSelectedInstOperands,
     /*  578038 */     // GIR_Coverage, 3881,
     /*  578038 */     GIR_EraseRootFromParent_Done,
     /*  578039 */   // Label 9452: @578039
     /*  578039 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(578114), // Rule ID 3884 //
     /*  578044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  578093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578112 */     GIR_RootConstrainSelectedInstOperands,
     /*  578113 */     // GIR_Coverage, 3884,
     /*  578113 */     GIR_EraseRootFromParent_Done,
     /*  578114 */   // Label 9453: @578114
     /*  578114 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(578189), // Rule ID 3885 //
     /*  578119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  578130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  578133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  578136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  578139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578165 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  578168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578187 */     GIR_RootConstrainSelectedInstOperands,
     /*  578188 */     // GIR_Coverage, 3885,
     /*  578188 */     GIR_EraseRootFromParent_Done,
     /*  578189 */   // Label 9454: @578189
     /*  578189 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(578264), // Rule ID 3888 //
     /*  578194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  578205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  578208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578240 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  578243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578262 */     GIR_RootConstrainSelectedInstOperands,
     /*  578263 */     // GIR_Coverage, 3888,
     /*  578263 */     GIR_EraseRootFromParent_Done,
     /*  578264 */   // Label 9455: @578264
     /*  578264 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(578339), // Rule ID 3889 //
     /*  578269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  578280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  578283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  578286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  578289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  578318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578337 */     GIR_RootConstrainSelectedInstOperands,
     /*  578338 */     // GIR_Coverage, 3889,
     /*  578338 */     GIR_EraseRootFromParent_Done,
     /*  578339 */   // Label 9456: @578339
     /*  578339 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(578414), // Rule ID 3892 //
     /*  578344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  578355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  578358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  578361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578412 */     GIR_RootConstrainSelectedInstOperands,
     /*  578413 */     // GIR_Coverage, 3892,
     /*  578413 */     GIR_EraseRootFromParent_Done,
     /*  578414 */   // Label 9457: @578414
     /*  578414 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(578489), // Rule ID 3893 //
     /*  578419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  578430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  578433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  578436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578487 */     GIR_RootConstrainSelectedInstOperands,
     /*  578488 */     // GIR_Coverage, 3893,
     /*  578488 */     GIR_EraseRootFromParent_Done,
     /*  578489 */   // Label 9458: @578489
     /*  578489 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(578564), // Rule ID 3896 //
     /*  578494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578562 */     GIR_RootConstrainSelectedInstOperands,
     /*  578563 */     // GIR_Coverage, 3896,
     /*  578563 */     GIR_EraseRootFromParent_Done,
     /*  578564 */   // Label 9459: @578564
     /*  578564 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(578639), // Rule ID 3897 //
     /*  578569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578637 */     GIR_RootConstrainSelectedInstOperands,
     /*  578638 */     // GIR_Coverage, 3897,
     /*  578638 */     GIR_EraseRootFromParent_Done,
     /*  578639 */   // Label 9460: @578639
     /*  578639 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(578714), // Rule ID 3900 //
     /*  578644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578690 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578712 */     GIR_RootConstrainSelectedInstOperands,
     /*  578713 */     // GIR_Coverage, 3900,
     /*  578713 */     GIR_EraseRootFromParent_Done,
     /*  578714 */   // Label 9461: @578714
     /*  578714 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(578789), // Rule ID 3901 //
     /*  578719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578765 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11695:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578787 */     GIR_RootConstrainSelectedInstOperands,
     /*  578788 */     // GIR_Coverage, 3901,
     /*  578788 */     GIR_EraseRootFromParent_Done,
     /*  578789 */   // Label 9462: @578789
     /*  578789 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(578864), // Rule ID 3904 //
     /*  578794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578862 */     GIR_RootConstrainSelectedInstOperands,
     /*  578863 */     // GIR_Coverage, 3904,
     /*  578863 */     GIR_EraseRootFromParent_Done,
     /*  578864 */   // Label 9463: @578864
     /*  578864 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(578939), // Rule ID 3905 //
     /*  578869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578915 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578937 */     GIR_RootConstrainSelectedInstOperands,
     /*  578938 */     // GIR_Coverage, 3905,
     /*  578938 */     GIR_EraseRootFromParent_Done,
     /*  578939 */   // Label 9464: @578939
     /*  578939 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(579014), // Rule ID 3908 //
     /*  578944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579012 */     GIR_RootConstrainSelectedInstOperands,
     /*  579013 */     // GIR_Coverage, 3908,
     /*  579013 */     GIR_EraseRootFromParent_Done,
     /*  579014 */   // Label 9465: @579014
     /*  579014 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(579089), // Rule ID 3909 //
     /*  579019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  579030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  579033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  579036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579065 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579087 */     GIR_RootConstrainSelectedInstOperands,
     /*  579088 */     // GIR_Coverage, 3909,
     /*  579088 */     GIR_EraseRootFromParent_Done,
     /*  579089 */   // Label 9466: @579089
     /*  579089 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(579164), // Rule ID 3912 //
     /*  579094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  579105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  579108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  579111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579162 */     GIR_RootConstrainSelectedInstOperands,
     /*  579163 */     // GIR_Coverage, 3912,
     /*  579163 */     GIR_EraseRootFromParent_Done,
     /*  579164 */   // Label 9467: @579164
     /*  579164 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(579239), // Rule ID 3913 //
     /*  579169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  579180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  579183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  579186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579215 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579237 */     GIR_RootConstrainSelectedInstOperands,
     /*  579238 */     // GIR_Coverage, 3913,
     /*  579238 */     GIR_EraseRootFromParent_Done,
     /*  579239 */   // Label 9468: @579239
     /*  579239 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(579314), // Rule ID 3916 //
     /*  579244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  579293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579312 */     GIR_RootConstrainSelectedInstOperands,
     /*  579313 */     // GIR_Coverage, 3916,
     /*  579313 */     GIR_EraseRootFromParent_Done,
     /*  579314 */   // Label 9469: @579314
     /*  579314 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(579389), // Rule ID 3917 //
     /*  579319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  579330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  579333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  579336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579365 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  579368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579387 */     GIR_RootConstrainSelectedInstOperands,
     /*  579388 */     // GIR_Coverage, 3917,
     /*  579388 */     GIR_EraseRootFromParent_Done,
     /*  579389 */   // Label 9470: @579389
     /*  579389 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(579464), // Rule ID 3920 //
     /*  579394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579462 */     GIR_RootConstrainSelectedInstOperands,
     /*  579463 */     // GIR_Coverage, 3920,
     /*  579463 */     GIR_EraseRootFromParent_Done,
     /*  579464 */   // Label 9471: @579464
     /*  579464 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(579539), // Rule ID 3921 //
     /*  579469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11695:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579537 */     GIR_RootConstrainSelectedInstOperands,
     /*  579538 */     // GIR_Coverage, 3921,
     /*  579538 */     GIR_EraseRootFromParent_Done,
     /*  579539 */   // Label 9472: @579539
     /*  579539 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(579614), // Rule ID 3924 //
     /*  579544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579612 */     GIR_RootConstrainSelectedInstOperands,
     /*  579613 */     // GIR_Coverage, 3924,
     /*  579613 */     GIR_EraseRootFromParent_Done,
     /*  579614 */   // Label 9473: @579614
     /*  579614 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(579689), // Rule ID 3925 //
     /*  579619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579687 */     GIR_RootConstrainSelectedInstOperands,
     /*  579688 */     // GIR_Coverage, 3925,
     /*  579688 */     GIR_EraseRootFromParent_Done,
     /*  579689 */   // Label 9474: @579689
     /*  579689 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(579764), // Rule ID 3928 //
     /*  579694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579762 */     GIR_RootConstrainSelectedInstOperands,
     /*  579763 */     // GIR_Coverage, 3928,
     /*  579763 */     GIR_EraseRootFromParent_Done,
     /*  579764 */   // Label 9475: @579764
     /*  579764 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(579839), // Rule ID 3929 //
     /*  579769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579815 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579837 */     GIR_RootConstrainSelectedInstOperands,
     /*  579838 */     // GIR_Coverage, 3929,
     /*  579838 */     GIR_EraseRootFromParent_Done,
     /*  579839 */   // Label 9476: @579839
     /*  579839 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(579914), // Rule ID 3932 //
     /*  579844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579912 */     GIR_RootConstrainSelectedInstOperands,
     /*  579913 */     // GIR_Coverage, 3932,
     /*  579913 */     GIR_EraseRootFromParent_Done,
     /*  579914 */   // Label 9477: @579914
     /*  579914 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(579989), // Rule ID 3933 //
     /*  579919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579987 */     GIR_RootConstrainSelectedInstOperands,
     /*  579988 */     // GIR_Coverage, 3933,
     /*  579988 */     GIR_EraseRootFromParent_Done,
     /*  579989 */   // Label 9478: @579989
     /*  579989 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(580064), // Rule ID 3936 //
     /*  579994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  580011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  580043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580062 */     GIR_RootConstrainSelectedInstOperands,
     /*  580063 */     // GIR_Coverage, 3936,
     /*  580063 */     GIR_EraseRootFromParent_Done,
     /*  580064 */   // Label 9479: @580064
     /*  580064 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(580139), // Rule ID 3937 //
     /*  580069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  580080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  580083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  580086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11695:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  580118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580137 */     GIR_RootConstrainSelectedInstOperands,
     /*  580138 */     // GIR_Coverage, 3937,
     /*  580138 */     GIR_EraseRootFromParent_Done,
     /*  580139 */   // Label 9480: @580139
     /*  580139 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(580214), // Rule ID 3940 //
     /*  580144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  580155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  580158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  580193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580212 */     GIR_RootConstrainSelectedInstOperands,
     /*  580213 */     // GIR_Coverage, 3940,
     /*  580213 */     GIR_EraseRootFromParent_Done,
     /*  580214 */   // Label 9481: @580214
     /*  580214 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(580289), // Rule ID 3941 //
     /*  580219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  580230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  580233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  580236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580265 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11695:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  580268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580287 */     GIR_RootConstrainSelectedInstOperands,
     /*  580288 */     // GIR_Coverage, 3941,
     /*  580288 */     GIR_EraseRootFromParent_Done,
     /*  580289 */   // Label 9482: @580289
     /*  580289 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(580364), // Rule ID 3944 //
     /*  580294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  580305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  580308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  580311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  580343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580362 */     GIR_RootConstrainSelectedInstOperands,
     /*  580363 */     // GIR_Coverage, 3944,
     /*  580363 */     GIR_EraseRootFromParent_Done,
     /*  580364 */   // Label 9483: @580364
     /*  580364 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(580439), // Rule ID 3945 //
     /*  580369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  580380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  580383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  580386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580415 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11695:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  580418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580437 */     GIR_RootConstrainSelectedInstOperands,
     /*  580438 */     // GIR_Coverage, 3945,
     /*  580438 */     GIR_EraseRootFromParent_Done,
     /*  580439 */   // Label 9484: @580439
     /*  580439 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(580514), // Rule ID 3948 //
     /*  580444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  580447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  580464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580512 */     GIR_RootConstrainSelectedInstOperands,
     /*  580513 */     // GIR_Coverage, 3948,
     /*  580513 */     GIR_EraseRootFromParent_Done,
     /*  580514 */   // Label 9485: @580514
     /*  580514 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(580589), // Rule ID 3949 //
     /*  580519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580565 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11695:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580587 */     GIR_RootConstrainSelectedInstOperands,
     /*  580588 */     // GIR_Coverage, 3949,
     /*  580588 */     GIR_EraseRootFromParent_Done,
     /*  580589 */   // Label 9486: @580589
     /*  580589 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(580664), // Rule ID 3952 //
     /*  580594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580662 */     GIR_RootConstrainSelectedInstOperands,
     /*  580663 */     // GIR_Coverage, 3952,
     /*  580663 */     GIR_EraseRootFromParent_Done,
     /*  580664 */   // Label 9487: @580664
     /*  580664 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(580739), // Rule ID 3953 //
     /*  580669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580715 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580737 */     GIR_RootConstrainSelectedInstOperands,
     /*  580738 */     // GIR_Coverage, 3953,
     /*  580738 */     GIR_EraseRootFromParent_Done,
     /*  580739 */   // Label 9488: @580739
     /*  580739 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(580814), // Rule ID 3956 //
     /*  580744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580812 */     GIR_RootConstrainSelectedInstOperands,
     /*  580813 */     // GIR_Coverage, 3956,
     /*  580813 */     GIR_EraseRootFromParent_Done,
     /*  580814 */   // Label 9489: @580814
     /*  580814 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(580889), // Rule ID 3957 //
     /*  580819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580865 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580887 */     GIR_RootConstrainSelectedInstOperands,
     /*  580888 */     // GIR_Coverage, 3957,
     /*  580888 */     GIR_EraseRootFromParent_Done,
     /*  580889 */   // Label 9490: @580889
     /*  580889 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(580964), // Rule ID 3960 //
     /*  580894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580962 */     GIR_RootConstrainSelectedInstOperands,
     /*  580963 */     // GIR_Coverage, 3960,
     /*  580963 */     GIR_EraseRootFromParent_Done,
     /*  580964 */   // Label 9491: @580964
     /*  580964 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(581039), // Rule ID 3961 //
     /*  580969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581015 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581037 */     GIR_RootConstrainSelectedInstOperands,
     /*  581038 */     // GIR_Coverage, 3961,
     /*  581038 */     GIR_EraseRootFromParent_Done,
     /*  581039 */   // Label 9492: @581039
     /*  581039 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(581114), // Rule ID 3964 //
     /*  581044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  581061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  581064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581112 */     GIR_RootConstrainSelectedInstOperands,
     /*  581113 */     // GIR_Coverage, 3964,
     /*  581113 */     GIR_EraseRootFromParent_Done,
     /*  581114 */   // Label 9493: @581114
     /*  581114 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(581189), // Rule ID 3965 //
     /*  581119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  581130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  581133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  581136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  581139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581187 */     GIR_RootConstrainSelectedInstOperands,
     /*  581188 */     // GIR_Coverage, 3965,
     /*  581188 */     GIR_EraseRootFromParent_Done,
     /*  581189 */   // Label 9494: @581189
     /*  581189 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(581264), // Rule ID 3968 //
     /*  581194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  581211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  581214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581262 */     GIR_RootConstrainSelectedInstOperands,
     /*  581263 */     // GIR_Coverage, 3968,
     /*  581263 */     GIR_EraseRootFromParent_Done,
     /*  581264 */   // Label 9495: @581264
     /*  581264 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(581339), // Rule ID 3969 //
     /*  581269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  581280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  581283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  581286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  581289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581315 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581337 */     GIR_RootConstrainSelectedInstOperands,
     /*  581338 */     // GIR_Coverage, 3969,
     /*  581338 */     GIR_EraseRootFromParent_Done,
     /*  581339 */   // Label 9496: @581339
     /*  581339 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(581414), // Rule ID 3972 //
     /*  581344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  581361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  581364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581412 */     GIR_RootConstrainSelectedInstOperands,
     /*  581413 */     // GIR_Coverage, 3972,
     /*  581413 */     GIR_EraseRootFromParent_Done,
     /*  581414 */   // Label 9497: @581414
     /*  581414 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(581489), // Rule ID 3973 //
     /*  581419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  581430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  581433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  581436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  581439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581465 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581487 */     GIR_RootConstrainSelectedInstOperands,
     /*  581488 */     // GIR_Coverage, 3973,
     /*  581488 */     GIR_EraseRootFromParent_Done,
     /*  581489 */   // Label 9498: @581489
     /*  581489 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(581564), // Rule ID 3976 //
     /*  581494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581562 */     GIR_RootConstrainSelectedInstOperands,
     /*  581563 */     // GIR_Coverage, 3976,
     /*  581563 */     GIR_EraseRootFromParent_Done,
     /*  581564 */   // Label 9499: @581564
     /*  581564 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(581639), // Rule ID 3977 //
     /*  581569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581615 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581637 */     GIR_RootConstrainSelectedInstOperands,
     /*  581638 */     // GIR_Coverage, 3977,
     /*  581638 */     GIR_EraseRootFromParent_Done,
     /*  581639 */   // Label 9500: @581639
     /*  581639 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(581714), // Rule ID 3980 //
     /*  581644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581712 */     GIR_RootConstrainSelectedInstOperands,
     /*  581713 */     // GIR_Coverage, 3980,
     /*  581713 */     GIR_EraseRootFromParent_Done,
     /*  581714 */   // Label 9501: @581714
     /*  581714 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(581789), // Rule ID 3981 //
     /*  581719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581787 */     GIR_RootConstrainSelectedInstOperands,
     /*  581788 */     // GIR_Coverage, 3981,
     /*  581788 */     GIR_EraseRootFromParent_Done,
     /*  581789 */   // Label 9502: @581789
     /*  581789 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(581864), // Rule ID 3984 //
     /*  581794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581862 */     GIR_RootConstrainSelectedInstOperands,
     /*  581863 */     // GIR_Coverage, 3984,
     /*  581863 */     GIR_EraseRootFromParent_Done,
     /*  581864 */   // Label 9503: @581864
     /*  581864 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(581939), // Rule ID 3985 //
     /*  581869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581937 */     GIR_RootConstrainSelectedInstOperands,
     /*  581938 */     // GIR_Coverage, 3985,
     /*  581938 */     GIR_EraseRootFromParent_Done,
     /*  581939 */   // Label 9504: @581939
     /*  581939 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(582014), // Rule ID 3988 //
     /*  581944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582012 */     GIR_RootConstrainSelectedInstOperands,
     /*  582013 */     // GIR_Coverage, 3988,
     /*  582013 */     GIR_EraseRootFromParent_Done,
     /*  582014 */   // Label 9505: @582014
     /*  582014 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(582089), // Rule ID 3989 //
     /*  582019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  582030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  582033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  582036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  582039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582065 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582087 */     GIR_RootConstrainSelectedInstOperands,
     /*  582088 */     // GIR_Coverage, 3989,
     /*  582088 */     GIR_EraseRootFromParent_Done,
     /*  582089 */   // Label 9506: @582089
     /*  582089 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(582164), // Rule ID 3992 //
     /*  582094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  582105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  582108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  582111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  582114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582162 */     GIR_RootConstrainSelectedInstOperands,
     /*  582163 */     // GIR_Coverage, 3992,
     /*  582163 */     GIR_EraseRootFromParent_Done,
     /*  582164 */   // Label 9507: @582164
     /*  582164 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(582239), // Rule ID 3993 //
     /*  582169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  582180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  582183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  582186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  582189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582215 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582237 */     GIR_RootConstrainSelectedInstOperands,
     /*  582238 */     // GIR_Coverage, 3993,
     /*  582238 */     GIR_EraseRootFromParent_Done,
     /*  582239 */   // Label 9508: @582239
     /*  582239 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(582314), // Rule ID 3996 //
     /*  582244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  582255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  582258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  582261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  582264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  582293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582312 */     GIR_RootConstrainSelectedInstOperands,
     /*  582313 */     // GIR_Coverage, 3996,
     /*  582313 */     GIR_EraseRootFromParent_Done,
     /*  582314 */   // Label 9509: @582314
     /*  582314 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(582389), // Rule ID 3997 //
     /*  582319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  582330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  582333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  582336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  582339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582365 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  582368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582387 */     GIR_RootConstrainSelectedInstOperands,
     /*  582388 */     // GIR_Coverage, 3997,
     /*  582388 */     GIR_EraseRootFromParent_Done,
     /*  582389 */   // Label 9510: @582389
     /*  582389 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(582464), // Rule ID 4000 //
     /*  582394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582462 */     GIR_RootConstrainSelectedInstOperands,
     /*  582463 */     // GIR_Coverage, 4000,
     /*  582463 */     GIR_EraseRootFromParent_Done,
     /*  582464 */   // Label 9511: @582464
     /*  582464 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(582539), // Rule ID 4001 //
     /*  582469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582537 */     GIR_RootConstrainSelectedInstOperands,
     /*  582538 */     // GIR_Coverage, 4001,
     /*  582538 */     GIR_EraseRootFromParent_Done,
     /*  582539 */   // Label 9512: @582539
     /*  582539 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(582614), // Rule ID 4004 //
     /*  582544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582612 */     GIR_RootConstrainSelectedInstOperands,
     /*  582613 */     // GIR_Coverage, 4004,
     /*  582613 */     GIR_EraseRootFromParent_Done,
     /*  582614 */   // Label 9513: @582614
     /*  582614 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(582689), // Rule ID 4005 //
     /*  582619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582665 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582687 */     GIR_RootConstrainSelectedInstOperands,
     /*  582688 */     // GIR_Coverage, 4005,
     /*  582688 */     GIR_EraseRootFromParent_Done,
     /*  582689 */   // Label 9514: @582689
     /*  582689 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(582764), // Rule ID 4008 //
     /*  582694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582740 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582762 */     GIR_RootConstrainSelectedInstOperands,
     /*  582763 */     // GIR_Coverage, 4008,
     /*  582763 */     GIR_EraseRootFromParent_Done,
     /*  582764 */   // Label 9515: @582764
     /*  582764 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(582839), // Rule ID 4009 //
     /*  582769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582837 */     GIR_RootConstrainSelectedInstOperands,
     /*  582838 */     // GIR_Coverage, 4009,
     /*  582838 */     GIR_EraseRootFromParent_Done,
     /*  582839 */   // Label 9516: @582839
     /*  582839 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(582914), // Rule ID 4012 //
     /*  582844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582912 */     GIR_RootConstrainSelectedInstOperands,
     /*  582913 */     // GIR_Coverage, 4012,
     /*  582913 */     GIR_EraseRootFromParent_Done,
     /*  582914 */   // Label 9517: @582914
     /*  582914 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(582989), // Rule ID 4013 //
     /*  582919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582965 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582987 */     GIR_RootConstrainSelectedInstOperands,
     /*  582988 */     // GIR_Coverage, 4013,
     /*  582988 */     GIR_EraseRootFromParent_Done,
     /*  582989 */   // Label 9518: @582989
     /*  582989 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(583064), // Rule ID 4016 //
     /*  582994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  583011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583062 */     GIR_RootConstrainSelectedInstOperands,
     /*  583063 */     // GIR_Coverage, 4016,
     /*  583063 */     GIR_EraseRootFromParent_Done,
     /*  583064 */   // Label 9519: @583064
     /*  583064 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(583139), // Rule ID 4017 //
     /*  583069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  583080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  583083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  583086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583115 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583137 */     GIR_RootConstrainSelectedInstOperands,
     /*  583138 */     // GIR_Coverage, 4017,
     /*  583138 */     GIR_EraseRootFromParent_Done,
     /*  583139 */   // Label 9520: @583139
     /*  583139 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(583214), // Rule ID 4020 //
     /*  583144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  583161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583212 */     GIR_RootConstrainSelectedInstOperands,
     /*  583213 */     // GIR_Coverage, 4020,
     /*  583213 */     GIR_EraseRootFromParent_Done,
     /*  583214 */   // Label 9521: @583214
     /*  583214 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(583289), // Rule ID 4021 //
     /*  583219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  583230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  583233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  583236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583265 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11723:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583287 */     GIR_RootConstrainSelectedInstOperands,
     /*  583288 */     // GIR_Coverage, 4021,
     /*  583288 */     GIR_EraseRootFromParent_Done,
     /*  583289 */   // Label 9522: @583289
     /*  583289 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(583364), // Rule ID 4024 //
     /*  583294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  583305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  583308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583362 */     GIR_RootConstrainSelectedInstOperands,
     /*  583363 */     // GIR_Coverage, 4024,
     /*  583363 */     GIR_EraseRootFromParent_Done,
     /*  583364 */   // Label 9523: @583364
     /*  583364 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(583439), // Rule ID 4025 //
     /*  583369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  583380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  583383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  583386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583415 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583437 */     GIR_RootConstrainSelectedInstOperands,
     /*  583438 */     // GIR_Coverage, 4025,
     /*  583438 */     GIR_EraseRootFromParent_Done,
     /*  583439 */   // Label 9524: @583439
     /*  583439 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(583514), // Rule ID 4028 //
     /*  583444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583512 */     GIR_RootConstrainSelectedInstOperands,
     /*  583513 */     // GIR_Coverage, 4028,
     /*  583513 */     GIR_EraseRootFromParent_Done,
     /*  583514 */   // Label 9525: @583514
     /*  583514 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(583589), // Rule ID 4029 //
     /*  583519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583587 */     GIR_RootConstrainSelectedInstOperands,
     /*  583588 */     // GIR_Coverage, 4029,
     /*  583588 */     GIR_EraseRootFromParent_Done,
     /*  583589 */   // Label 9526: @583589
     /*  583589 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(583664), // Rule ID 4032 //
     /*  583594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583640 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583662 */     GIR_RootConstrainSelectedInstOperands,
     /*  583663 */     // GIR_Coverage, 4032,
     /*  583663 */     GIR_EraseRootFromParent_Done,
     /*  583664 */   // Label 9527: @583664
     /*  583664 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(583739), // Rule ID 4033 //
     /*  583669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583737 */     GIR_RootConstrainSelectedInstOperands,
     /*  583738 */     // GIR_Coverage, 4033,
     /*  583738 */     GIR_EraseRootFromParent_Done,
     /*  583739 */   // Label 9528: @583739
     /*  583739 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(583814), // Rule ID 4036 //
     /*  583744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583812 */     GIR_RootConstrainSelectedInstOperands,
     /*  583813 */     // GIR_Coverage, 4036,
     /*  583813 */     GIR_EraseRootFromParent_Done,
     /*  583814 */   // Label 9529: @583814
     /*  583814 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(583889), // Rule ID 4037 //
     /*  583819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583865 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583887 */     GIR_RootConstrainSelectedInstOperands,
     /*  583888 */     // GIR_Coverage, 4037,
     /*  583888 */     GIR_EraseRootFromParent_Done,
     /*  583889 */   // Label 9530: @583889
     /*  583889 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(583964), // Rule ID 4040 //
     /*  583894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583962 */     GIR_RootConstrainSelectedInstOperands,
     /*  583963 */     // GIR_Coverage, 4040,
     /*  583963 */     GIR_EraseRootFromParent_Done,
     /*  583964 */   // Label 9531: @583964
     /*  583964 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(584039), // Rule ID 4041 //
     /*  583969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11723:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584037 */     GIR_RootConstrainSelectedInstOperands,
     /*  584038 */     // GIR_Coverage, 4041,
     /*  584038 */     GIR_EraseRootFromParent_Done,
     /*  584039 */   // Label 9532: @584039
     /*  584039 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(584114), // Rule ID 4044 //
     /*  584044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584112 */     GIR_RootConstrainSelectedInstOperands,
     /*  584113 */     // GIR_Coverage, 4044,
     /*  584113 */     GIR_EraseRootFromParent_Done,
     /*  584114 */   // Label 9533: @584114
     /*  584114 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(584189), // Rule ID 4045 //
     /*  584119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  584130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  584133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584187 */     GIR_RootConstrainSelectedInstOperands,
     /*  584188 */     // GIR_Coverage, 4045,
     /*  584188 */     GIR_EraseRootFromParent_Done,
     /*  584189 */   // Label 9534: @584189
     /*  584189 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(584264), // Rule ID 4048 //
     /*  584194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  584205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  584208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584262 */     GIR_RootConstrainSelectedInstOperands,
     /*  584263 */     // GIR_Coverage, 4048,
     /*  584263 */     GIR_EraseRootFromParent_Done,
     /*  584264 */   // Label 9535: @584264
     /*  584264 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(584339), // Rule ID 4049 //
     /*  584269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  584280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  584283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584315 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584337 */     GIR_RootConstrainSelectedInstOperands,
     /*  584338 */     // GIR_Coverage, 4049,
     /*  584338 */     GIR_EraseRootFromParent_Done,
     /*  584339 */   // Label 9536: @584339
     /*  584339 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(584414), // Rule ID 4052 //
     /*  584344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  584355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  584358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584412 */     GIR_RootConstrainSelectedInstOperands,
     /*  584413 */     // GIR_Coverage, 4052,
     /*  584413 */     GIR_EraseRootFromParent_Done,
     /*  584414 */   // Label 9537: @584414
     /*  584414 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(584489), // Rule ID 4053 //
     /*  584419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  584430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  584433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584465 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584487 */     GIR_RootConstrainSelectedInstOperands,
     /*  584488 */     // GIR_Coverage, 4053,
     /*  584488 */     GIR_EraseRootFromParent_Done,
     /*  584489 */   // Label 9538: @584489
     /*  584489 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(584564), // Rule ID 4056 //
     /*  584494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584562 */     GIR_RootConstrainSelectedInstOperands,
     /*  584563 */     // GIR_Coverage, 4056,
     /*  584563 */     GIR_EraseRootFromParent_Done,
     /*  584564 */   // Label 9539: @584564
     /*  584564 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(584639), // Rule ID 4057 //
     /*  584569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11723:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584637 */     GIR_RootConstrainSelectedInstOperands,
     /*  584638 */     // GIR_Coverage, 4057,
     /*  584638 */     GIR_EraseRootFromParent_Done,
     /*  584639 */   // Label 9540: @584639
     /*  584639 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(584714), // Rule ID 4060 //
     /*  584644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584712 */     GIR_RootConstrainSelectedInstOperands,
     /*  584713 */     // GIR_Coverage, 4060,
     /*  584713 */     GIR_EraseRootFromParent_Done,
     /*  584714 */   // Label 9541: @584714
     /*  584714 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(584789), // Rule ID 4061 //
     /*  584719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11723:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584787 */     GIR_RootConstrainSelectedInstOperands,
     /*  584788 */     // GIR_Coverage, 4061,
     /*  584788 */     GIR_EraseRootFromParent_Done,
     /*  584789 */   // Label 9542: @584789
     /*  584789 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(584864), // Rule ID 4064 //
     /*  584794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584862 */     GIR_RootConstrainSelectedInstOperands,
     /*  584863 */     // GIR_Coverage, 4064,
     /*  584863 */     GIR_EraseRootFromParent_Done,
     /*  584864 */   // Label 9543: @584864
     /*  584864 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(584939), // Rule ID 4065 //
     /*  584869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584915 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11723:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584937 */     GIR_RootConstrainSelectedInstOperands,
     /*  584938 */     // GIR_Coverage, 4065,
     /*  584938 */     GIR_EraseRootFromParent_Done,
     /*  584939 */   // Label 9544: @584939
     /*  584939 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(585014), // Rule ID 4068 //
     /*  584944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585012 */     GIR_RootConstrainSelectedInstOperands,
     /*  585013 */     // GIR_Coverage, 4068,
     /*  585013 */     GIR_EraseRootFromParent_Done,
     /*  585014 */   // Label 9545: @585014
     /*  585014 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(585089), // Rule ID 4069 //
     /*  585019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  585030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  585033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  585039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  585058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585065 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11723:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  585068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585087 */     GIR_RootConstrainSelectedInstOperands,
     /*  585088 */     // GIR_Coverage, 4069,
     /*  585088 */     GIR_EraseRootFromParent_Done,
     /*  585089 */   // Label 9546: @585089
     /*  585089 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(585164), // Rule ID 4074 //
     /*  585094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  585105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  585108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  585114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585162 */     GIR_RootConstrainSelectedInstOperands,
     /*  585163 */     // GIR_Coverage, 4074,
     /*  585163 */     GIR_EraseRootFromParent_Done,
     /*  585164 */   // Label 9547: @585164
     /*  585164 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(585239), // Rule ID 4075 //
     /*  585169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  585180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  585183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  585189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585215 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585237 */     GIR_RootConstrainSelectedInstOperands,
     /*  585238 */     // GIR_Coverage, 4075,
     /*  585238 */     GIR_EraseRootFromParent_Done,
     /*  585239 */   // Label 9548: @585239
     /*  585239 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(585314), // Rule ID 4084 //
     /*  585244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  585255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  585258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  585264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585312 */     GIR_RootConstrainSelectedInstOperands,
     /*  585313 */     // GIR_Coverage, 4084,
     /*  585313 */     GIR_EraseRootFromParent_Done,
     /*  585314 */   // Label 9549: @585314
     /*  585314 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(585389), // Rule ID 4085 //
     /*  585319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  585330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  585333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  585339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585387 */     GIR_RootConstrainSelectedInstOperands,
     /*  585388 */     // GIR_Coverage, 4085,
     /*  585388 */     GIR_EraseRootFromParent_Done,
     /*  585389 */   // Label 9550: @585389
     /*  585389 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(585464), // Rule ID 4094 //
     /*  585394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585462 */     GIR_RootConstrainSelectedInstOperands,
     /*  585463 */     // GIR_Coverage, 4094,
     /*  585463 */     GIR_EraseRootFromParent_Done,
     /*  585464 */   // Label 9551: @585464
     /*  585464 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(585539), // Rule ID 4095 //
     /*  585469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585537 */     GIR_RootConstrainSelectedInstOperands,
     /*  585538 */     // GIR_Coverage, 4095,
     /*  585538 */     GIR_EraseRootFromParent_Done,
     /*  585539 */   // Label 9552: @585539
     /*  585539 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(585614), // Rule ID 4104 //
     /*  585544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585612 */     GIR_RootConstrainSelectedInstOperands,
     /*  585613 */     // GIR_Coverage, 4104,
     /*  585613 */     GIR_EraseRootFromParent_Done,
     /*  585614 */   // Label 9553: @585614
     /*  585614 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(585689), // Rule ID 4105 //
     /*  585619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585665 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585687 */     GIR_RootConstrainSelectedInstOperands,
     /*  585688 */     // GIR_Coverage, 4105,
     /*  585688 */     GIR_EraseRootFromParent_Done,
     /*  585689 */   // Label 9554: @585689
     /*  585689 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(585764), // Rule ID 4114 //
     /*  585694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585762 */     GIR_RootConstrainSelectedInstOperands,
     /*  585763 */     // GIR_Coverage, 4114,
     /*  585763 */     GIR_EraseRootFromParent_Done,
     /*  585764 */   // Label 9555: @585764
     /*  585764 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(585839), // Rule ID 4115 //
     /*  585769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585815 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585837 */     GIR_RootConstrainSelectedInstOperands,
     /*  585838 */     // GIR_Coverage, 4115,
     /*  585838 */     GIR_EraseRootFromParent_Done,
     /*  585839 */   // Label 9556: @585839
     /*  585839 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(585914), // Rule ID 4124 //
     /*  585844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585912 */     GIR_RootConstrainSelectedInstOperands,
     /*  585913 */     // GIR_Coverage, 4124,
     /*  585913 */     GIR_EraseRootFromParent_Done,
     /*  585914 */   // Label 9557: @585914
     /*  585914 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(585989), // Rule ID 4125 //
     /*  585919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585965 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585987 */     GIR_RootConstrainSelectedInstOperands,
     /*  585988 */     // GIR_Coverage, 4125,
     /*  585988 */     GIR_EraseRootFromParent_Done,
     /*  585989 */   // Label 9558: @585989
     /*  585989 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(586064), // Rule ID 4134 //
     /*  585994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  586008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  586011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  586014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586062 */     GIR_RootConstrainSelectedInstOperands,
     /*  586063 */     // GIR_Coverage, 4134,
     /*  586063 */     GIR_EraseRootFromParent_Done,
     /*  586064 */   // Label 9559: @586064
     /*  586064 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(586139), // Rule ID 4135 //
     /*  586069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  586080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  586083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  586086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  586089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586137 */     GIR_RootConstrainSelectedInstOperands,
     /*  586138 */     // GIR_Coverage, 4135,
     /*  586138 */     GIR_EraseRootFromParent_Done,
     /*  586139 */   // Label 9560: @586139
     /*  586139 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(586214), // Rule ID 4144 //
     /*  586144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  586155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  586158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  586164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586212 */     GIR_RootConstrainSelectedInstOperands,
     /*  586213 */     // GIR_Coverage, 4144,
     /*  586213 */     GIR_EraseRootFromParent_Done,
     /*  586214 */   // Label 9561: @586214
     /*  586214 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(586289), // Rule ID 4145 //
     /*  586219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  586230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  586233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  586239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586287 */     GIR_RootConstrainSelectedInstOperands,
     /*  586288 */     // GIR_Coverage, 4145,
     /*  586288 */     GIR_EraseRootFromParent_Done,
     /*  586289 */   // Label 9562: @586289
     /*  586289 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(586364), // Rule ID 4154 //
     /*  586294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  586305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  586308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  586314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586362 */     GIR_RootConstrainSelectedInstOperands,
     /*  586363 */     // GIR_Coverage, 4154,
     /*  586363 */     GIR_EraseRootFromParent_Done,
     /*  586364 */   // Label 9563: @586364
     /*  586364 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(586439), // Rule ID 4155 //
     /*  586369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  586380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  586383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  586389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586415 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586437 */     GIR_RootConstrainSelectedInstOperands,
     /*  586438 */     // GIR_Coverage, 4155,
     /*  586438 */     GIR_EraseRootFromParent_Done,
     /*  586439 */   // Label 9564: @586439
     /*  586439 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(586514), // Rule ID 4164 //
     /*  586444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586512 */     GIR_RootConstrainSelectedInstOperands,
     /*  586513 */     // GIR_Coverage, 4164,
     /*  586513 */     GIR_EraseRootFromParent_Done,
     /*  586514 */   // Label 9565: @586514
     /*  586514 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(586589), // Rule ID 4165 //
     /*  586519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586565 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586587 */     GIR_RootConstrainSelectedInstOperands,
     /*  586588 */     // GIR_Coverage, 4165,
     /*  586588 */     GIR_EraseRootFromParent_Done,
     /*  586589 */   // Label 9566: @586589
     /*  586589 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(586664), // Rule ID 4174 //
     /*  586594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586662 */     GIR_RootConstrainSelectedInstOperands,
     /*  586663 */     // GIR_Coverage, 4174,
     /*  586663 */     GIR_EraseRootFromParent_Done,
     /*  586664 */   // Label 9567: @586664
     /*  586664 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(586739), // Rule ID 4175 //
     /*  586669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586737 */     GIR_RootConstrainSelectedInstOperands,
     /*  586738 */     // GIR_Coverage, 4175,
     /*  586738 */     GIR_EraseRootFromParent_Done,
     /*  586739 */   // Label 9568: @586739
     /*  586739 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(586814), // Rule ID 4184 //
     /*  586744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586812 */     GIR_RootConstrainSelectedInstOperands,
     /*  586813 */     // GIR_Coverage, 4184,
     /*  586813 */     GIR_EraseRootFromParent_Done,
     /*  586814 */   // Label 9569: @586814
     /*  586814 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(586889), // Rule ID 4185 //
     /*  586819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586887 */     GIR_RootConstrainSelectedInstOperands,
     /*  586888 */     // GIR_Coverage, 4185,
     /*  586888 */     GIR_EraseRootFromParent_Done,
     /*  586889 */   // Label 9570: @586889
     /*  586889 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(586964), // Rule ID 4194 //
     /*  586894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586962 */     GIR_RootConstrainSelectedInstOperands,
     /*  586963 */     // GIR_Coverage, 4194,
     /*  586963 */     GIR_EraseRootFromParent_Done,
     /*  586964 */   // Label 9571: @586964
     /*  586964 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(587039), // Rule ID 4195 //
     /*  586969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  587018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587037 */     GIR_RootConstrainSelectedInstOperands,
     /*  587038 */     // GIR_Coverage, 4195,
     /*  587038 */     GIR_EraseRootFromParent_Done,
     /*  587039 */   // Label 9572: @587039
     /*  587039 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(587114), // Rule ID 4204 //
     /*  587044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  587047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  587055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  587058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  587061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  587064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  587090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  587093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587112 */     GIR_RootConstrainSelectedInstOperands,
     /*  587113 */     // GIR_Coverage, 4204,
     /*  587113 */     GIR_EraseRootFromParent_Done,
     /*  587114 */   // Label 9573: @587114
     /*  587114 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(587189), // Rule ID 4205 //
     /*  587119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  587122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  587130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  587133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  587136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  587139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  587168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587187 */     GIR_RootConstrainSelectedInstOperands,
     /*  587188 */     // GIR_Coverage, 4205,
     /*  587188 */     GIR_EraseRootFromParent_Done,
     /*  587189 */   // Label 9574: @587189
     /*  587189 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(587264), // Rule ID 4212 //
     /*  587194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  587205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  587208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587240 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  587243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587262 */     GIR_RootConstrainSelectedInstOperands,
     /*  587263 */     // GIR_Coverage, 4212,
     /*  587263 */     GIR_EraseRootFromParent_Done,
     /*  587264 */   // Label 9575: @587264
     /*  587264 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(587339), // Rule ID 4213 //
     /*  587269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  587280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  587283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  587318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587337 */     GIR_RootConstrainSelectedInstOperands,
     /*  587338 */     // GIR_Coverage, 4213,
     /*  587338 */     GIR_EraseRootFromParent_Done,
     /*  587339 */   // Label 9576: @587339
     /*  587339 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(587414), // Rule ID 4216 //
     /*  587344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  587355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  587358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587412 */     GIR_RootConstrainSelectedInstOperands,
     /*  587413 */     // GIR_Coverage, 4216,
     /*  587413 */     GIR_EraseRootFromParent_Done,
     /*  587414 */   // Label 9577: @587414
     /*  587414 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(587489), // Rule ID 4217 //
     /*  587419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  587430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  587433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587465 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587487 */     GIR_RootConstrainSelectedInstOperands,
     /*  587488 */     // GIR_Coverage, 4217,
     /*  587488 */     GIR_EraseRootFromParent_Done,
     /*  587489 */   // Label 9578: @587489
     /*  587489 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(587564), // Rule ID 4220 //
     /*  587494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587562 */     GIR_RootConstrainSelectedInstOperands,
     /*  587563 */     // GIR_Coverage, 4220,
     /*  587563 */     GIR_EraseRootFromParent_Done,
     /*  587564 */   // Label 9579: @587564
     /*  587564 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(587639), // Rule ID 4221 //
     /*  587569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11701:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587637 */     GIR_RootConstrainSelectedInstOperands,
     /*  587638 */     // GIR_Coverage, 4221,
     /*  587638 */     GIR_EraseRootFromParent_Done,
     /*  587639 */   // Label 9580: @587639
     /*  587639 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(587714), // Rule ID 4224 //
     /*  587644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587712 */     GIR_RootConstrainSelectedInstOperands,
     /*  587713 */     // GIR_Coverage, 4224,
     /*  587713 */     GIR_EraseRootFromParent_Done,
     /*  587714 */   // Label 9581: @587714
     /*  587714 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(587789), // Rule ID 4225 //
     /*  587719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587787 */     GIR_RootConstrainSelectedInstOperands,
     /*  587788 */     // GIR_Coverage, 4225,
     /*  587788 */     GIR_EraseRootFromParent_Done,
     /*  587789 */   // Label 9582: @587789
     /*  587789 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(587864), // Rule ID 4228 //
     /*  587794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587862 */     GIR_RootConstrainSelectedInstOperands,
     /*  587863 */     // GIR_Coverage, 4228,
     /*  587863 */     GIR_EraseRootFromParent_Done,
     /*  587864 */   // Label 9583: @587864
     /*  587864 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(587939), // Rule ID 4229 //
     /*  587869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587937 */     GIR_RootConstrainSelectedInstOperands,
     /*  587938 */     // GIR_Coverage, 4229,
     /*  587938 */     GIR_EraseRootFromParent_Done,
     /*  587939 */   // Label 9584: @587939
     /*  587939 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(588014), // Rule ID 4232 //
     /*  587944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588012 */     GIR_RootConstrainSelectedInstOperands,
     /*  588013 */     // GIR_Coverage, 4232,
     /*  588013 */     GIR_EraseRootFromParent_Done,
     /*  588014 */   // Label 9585: @588014
     /*  588014 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(588089), // Rule ID 4233 //
     /*  588019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  588030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  588033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  588036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588065 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588087 */     GIR_RootConstrainSelectedInstOperands,
     /*  588088 */     // GIR_Coverage, 4233,
     /*  588088 */     GIR_EraseRootFromParent_Done,
     /*  588089 */   // Label 9586: @588089
     /*  588089 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(588164), // Rule ID 4236 //
     /*  588094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  588105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  588108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  588111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  588143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588162 */     GIR_RootConstrainSelectedInstOperands,
     /*  588163 */     // GIR_Coverage, 4236,
     /*  588163 */     GIR_EraseRootFromParent_Done,
     /*  588164 */   // Label 9587: @588164
     /*  588164 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(588239), // Rule ID 4237 //
     /*  588169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  588180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  588183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  588186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  588218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588237 */     GIR_RootConstrainSelectedInstOperands,
     /*  588238 */     // GIR_Coverage, 4237,
     /*  588238 */     GIR_EraseRootFromParent_Done,
     /*  588239 */   // Label 9588: @588239
     /*  588239 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(588314), // Rule ID 4240 //
     /*  588244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  588255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  588258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588312 */     GIR_RootConstrainSelectedInstOperands,
     /*  588313 */     // GIR_Coverage, 4240,
     /*  588313 */     GIR_EraseRootFromParent_Done,
     /*  588314 */   // Label 9589: @588314
     /*  588314 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(588389), // Rule ID 4241 //
     /*  588319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  588330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  588333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11701:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588387 */     GIR_RootConstrainSelectedInstOperands,
     /*  588388 */     // GIR_Coverage, 4241,
     /*  588388 */     GIR_EraseRootFromParent_Done,
     /*  588389 */   // Label 9590: @588389
     /*  588389 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(588464), // Rule ID 4244 //
     /*  588394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588462 */     GIR_RootConstrainSelectedInstOperands,
     /*  588463 */     // GIR_Coverage, 4244,
     /*  588463 */     GIR_EraseRootFromParent_Done,
     /*  588464 */   // Label 9591: @588464
     /*  588464 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(588539), // Rule ID 4245 //
     /*  588469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588537 */     GIR_RootConstrainSelectedInstOperands,
     /*  588538 */     // GIR_Coverage, 4245,
     /*  588538 */     GIR_EraseRootFromParent_Done,
     /*  588539 */   // Label 9592: @588539
     /*  588539 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(588614), // Rule ID 4248 //
     /*  588544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588612 */     GIR_RootConstrainSelectedInstOperands,
     /*  588613 */     // GIR_Coverage, 4248,
     /*  588613 */     GIR_EraseRootFromParent_Done,
     /*  588614 */   // Label 9593: @588614
     /*  588614 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(588689), // Rule ID 4249 //
     /*  588619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588687 */     GIR_RootConstrainSelectedInstOperands,
     /*  588688 */     // GIR_Coverage, 4249,
     /*  588688 */     GIR_EraseRootFromParent_Done,
     /*  588689 */   // Label 9594: @588689
     /*  588689 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(588764), // Rule ID 4252 //
     /*  588694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588762 */     GIR_RootConstrainSelectedInstOperands,
     /*  588763 */     // GIR_Coverage, 4252,
     /*  588763 */     GIR_EraseRootFromParent_Done,
     /*  588764 */   // Label 9595: @588764
     /*  588764 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(588839), // Rule ID 4253 //
     /*  588769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588815 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588837 */     GIR_RootConstrainSelectedInstOperands,
     /*  588838 */     // GIR_Coverage, 4253,
     /*  588838 */     GIR_EraseRootFromParent_Done,
     /*  588839 */   // Label 9596: @588839
     /*  588839 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(588914), // Rule ID 4256 //
     /*  588844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588912 */     GIR_RootConstrainSelectedInstOperands,
     /*  588913 */     // GIR_Coverage, 4256,
     /*  588913 */     GIR_EraseRootFromParent_Done,
     /*  588914 */   // Label 9597: @588914
     /*  588914 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(588989), // Rule ID 4257 //
     /*  588919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11701:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588987 */     GIR_RootConstrainSelectedInstOperands,
     /*  588988 */     // GIR_Coverage, 4257,
     /*  588988 */     GIR_EraseRootFromParent_Done,
     /*  588989 */   // Label 9598: @588989
     /*  588989 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(589064), // Rule ID 4260 //
     /*  588994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  589005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  589008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  589011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  589043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589062 */     GIR_RootConstrainSelectedInstOperands,
     /*  589063 */     // GIR_Coverage, 4260,
     /*  589063 */     GIR_EraseRootFromParent_Done,
     /*  589064 */   // Label 9599: @589064
     /*  589064 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(589139), // Rule ID 4261 //
     /*  589069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  589080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  589083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  589086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11701:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  589118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589137 */     GIR_RootConstrainSelectedInstOperands,
     /*  589138 */     // GIR_Coverage, 4261,
     /*  589138 */     GIR_EraseRootFromParent_Done,
     /*  589139 */   // Label 9600: @589139
     /*  589139 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(589214), // Rule ID 4264 //
     /*  589144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  589155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  589158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  589161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  589193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589212 */     GIR_RootConstrainSelectedInstOperands,
     /*  589213 */     // GIR_Coverage, 4264,
     /*  589213 */     GIR_EraseRootFromParent_Done,
     /*  589214 */   // Label 9601: @589214
     /*  589214 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(589289), // Rule ID 4265 //
     /*  589219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  589230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  589233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  589236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589265 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11701:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  589268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589287 */     GIR_RootConstrainSelectedInstOperands,
     /*  589288 */     // GIR_Coverage, 4265,
     /*  589288 */     GIR_EraseRootFromParent_Done,
     /*  589289 */   // Label 9602: @589289
     /*  589289 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(589364), // Rule ID 4268 //
     /*  589294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  589305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  589308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  589311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  589314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  589340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  589343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589362 */     GIR_RootConstrainSelectedInstOperands,
     /*  589363 */     // GIR_Coverage, 4268,
     /*  589363 */     GIR_EraseRootFromParent_Done,
     /*  589364 */   // Label 9603: @589364
     /*  589364 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(589439), // Rule ID 4269 //
     /*  589369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  589372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  589380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  589383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  589386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  589389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  589408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11701:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  589415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  589418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  589434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589437 */     GIR_RootConstrainSelectedInstOperands,
     /*  589438 */     // GIR_Coverage, 4269,
     /*  589438 */     GIR_EraseRootFromParent_Done,
     /*  589439 */   // Label 9604: @589439
     /*  589439 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(589514), // Rule ID 4274 //
     /*  589444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589512 */     GIR_RootConstrainSelectedInstOperands,
     /*  589513 */     // GIR_Coverage, 4274,
     /*  589513 */     GIR_EraseRootFromParent_Done,
     /*  589514 */   // Label 9605: @589514
     /*  589514 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(589589), // Rule ID 4275 //
     /*  589519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589565 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589587 */     GIR_RootConstrainSelectedInstOperands,
     /*  589588 */     // GIR_Coverage, 4275,
     /*  589588 */     GIR_EraseRootFromParent_Done,
     /*  589589 */   // Label 9606: @589589
     /*  589589 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(589664), // Rule ID 4284 //
     /*  589594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589662 */     GIR_RootConstrainSelectedInstOperands,
     /*  589663 */     // GIR_Coverage, 4284,
     /*  589663 */     GIR_EraseRootFromParent_Done,
     /*  589664 */   // Label 9607: @589664
     /*  589664 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(589739), // Rule ID 4285 //
     /*  589669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589715 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589737 */     GIR_RootConstrainSelectedInstOperands,
     /*  589738 */     // GIR_Coverage, 4285,
     /*  589738 */     GIR_EraseRootFromParent_Done,
     /*  589739 */   // Label 9608: @589739
     /*  589739 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(589814), // Rule ID 4294 //
     /*  589744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589812 */     GIR_RootConstrainSelectedInstOperands,
     /*  589813 */     // GIR_Coverage, 4294,
     /*  589813 */     GIR_EraseRootFromParent_Done,
     /*  589814 */   // Label 9609: @589814
     /*  589814 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(589889), // Rule ID 4295 //
     /*  589819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589887 */     GIR_RootConstrainSelectedInstOperands,
     /*  589888 */     // GIR_Coverage, 4295,
     /*  589888 */     GIR_EraseRootFromParent_Done,
     /*  589889 */   // Label 9610: @589889
     /*  589889 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(589964), // Rule ID 4304 //
     /*  589894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589962 */     GIR_RootConstrainSelectedInstOperands,
     /*  589963 */     // GIR_Coverage, 4304,
     /*  589963 */     GIR_EraseRootFromParent_Done,
     /*  589964 */   // Label 9611: @589964
     /*  589964 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(590039), // Rule ID 4305 //
     /*  589969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590037 */     GIR_RootConstrainSelectedInstOperands,
     /*  590038 */     // GIR_Coverage, 4305,
     /*  590038 */     GIR_EraseRootFromParent_Done,
     /*  590039 */   // Label 9612: @590039
     /*  590039 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(590114), // Rule ID 4314 //
     /*  590044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  590055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  590058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  590061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590112 */     GIR_RootConstrainSelectedInstOperands,
     /*  590113 */     // GIR_Coverage, 4314,
     /*  590113 */     GIR_EraseRootFromParent_Done,
     /*  590114 */   // Label 9613: @590114
     /*  590114 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(590189), // Rule ID 4315 //
     /*  590119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  590130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  590133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  590136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  590139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590187 */     GIR_RootConstrainSelectedInstOperands,
     /*  590188 */     // GIR_Coverage, 4315,
     /*  590188 */     GIR_EraseRootFromParent_Done,
     /*  590189 */   // Label 9614: @590189
     /*  590189 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(590264), // Rule ID 4324 //
     /*  590194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  590205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  590208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  590211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590262 */     GIR_RootConstrainSelectedInstOperands,
     /*  590263 */     // GIR_Coverage, 4324,
     /*  590263 */     GIR_EraseRootFromParent_Done,
     /*  590264 */   // Label 9615: @590264
     /*  590264 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(590339), // Rule ID 4325 //
     /*  590269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  590280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  590283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  590286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  590289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590337 */     GIR_RootConstrainSelectedInstOperands,
     /*  590338 */     // GIR_Coverage, 4325,
     /*  590338 */     GIR_EraseRootFromParent_Done,
     /*  590339 */   // Label 9616: @590339
     /*  590339 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(590414), // Rule ID 4334 //
     /*  590344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  590355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  590358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  590361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  590364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590412 */     GIR_RootConstrainSelectedInstOperands,
     /*  590413 */     // GIR_Coverage, 4334,
     /*  590413 */     GIR_EraseRootFromParent_Done,
     /*  590414 */   // Label 9617: @590414
     /*  590414 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(590489), // Rule ID 4335 //
     /*  590419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  590430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  590433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  590436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  590439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590487 */     GIR_RootConstrainSelectedInstOperands,
     /*  590488 */     // GIR_Coverage, 4335,
     /*  590488 */     GIR_EraseRootFromParent_Done,
     /*  590489 */   // Label 9618: @590489
     /*  590489 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(590564), // Rule ID 4344 //
     /*  590494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590562 */     GIR_RootConstrainSelectedInstOperands,
     /*  590563 */     // GIR_Coverage, 4344,
     /*  590563 */     GIR_EraseRootFromParent_Done,
     /*  590564 */   // Label 9619: @590564
     /*  590564 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(590639), // Rule ID 4345 //
     /*  590569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590637 */     GIR_RootConstrainSelectedInstOperands,
     /*  590638 */     // GIR_Coverage, 4345,
     /*  590638 */     GIR_EraseRootFromParent_Done,
     /*  590639 */   // Label 9620: @590639
     /*  590639 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(590714), // Rule ID 4354 //
     /*  590644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590712 */     GIR_RootConstrainSelectedInstOperands,
     /*  590713 */     // GIR_Coverage, 4354,
     /*  590713 */     GIR_EraseRootFromParent_Done,
     /*  590714 */   // Label 9621: @590714
     /*  590714 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(590789), // Rule ID 4355 //
     /*  590719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590787 */     GIR_RootConstrainSelectedInstOperands,
     /*  590788 */     // GIR_Coverage, 4355,
     /*  590788 */     GIR_EraseRootFromParent_Done,
     /*  590789 */   // Label 9622: @590789
     /*  590789 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(590864), // Rule ID 4364 //
     /*  590794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590862 */     GIR_RootConstrainSelectedInstOperands,
     /*  590863 */     // GIR_Coverage, 4364,
     /*  590863 */     GIR_EraseRootFromParent_Done,
     /*  590864 */   // Label 9623: @590864
     /*  590864 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(590939), // Rule ID 4365 //
     /*  590869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590937 */     GIR_RootConstrainSelectedInstOperands,
     /*  590938 */     // GIR_Coverage, 4365,
     /*  590938 */     GIR_EraseRootFromParent_Done,
     /*  590939 */   // Label 9624: @590939
     /*  590939 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(591014), // Rule ID 4374 //
     /*  590944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591012 */     GIR_RootConstrainSelectedInstOperands,
     /*  591013 */     // GIR_Coverage, 4374,
     /*  591013 */     GIR_EraseRootFromParent_Done,
     /*  591014 */   // Label 9625: @591014
     /*  591014 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(591089), // Rule ID 4375 //
     /*  591019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  591030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  591033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  591036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  591039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591087 */     GIR_RootConstrainSelectedInstOperands,
     /*  591088 */     // GIR_Coverage, 4375,
     /*  591088 */     GIR_EraseRootFromParent_Done,
     /*  591089 */   // Label 9626: @591089
     /*  591089 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(591164), // Rule ID 4384 //
     /*  591094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  591105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  591108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  591111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  591114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  591143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591162 */     GIR_RootConstrainSelectedInstOperands,
     /*  591163 */     // GIR_Coverage, 4384,
     /*  591163 */     GIR_EraseRootFromParent_Done,
     /*  591164 */   // Label 9627: @591164
     /*  591164 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(591239), // Rule ID 4385 //
     /*  591169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  591180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  591183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  591186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  591189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  591218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591237 */     GIR_RootConstrainSelectedInstOperands,
     /*  591238 */     // GIR_Coverage, 4385,
     /*  591238 */     GIR_EraseRootFromParent_Done,
     /*  591239 */   // Label 9628: @591239
     /*  591239 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(591314), // Rule ID 4394 //
     /*  591244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  591264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  591293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591312 */     GIR_RootConstrainSelectedInstOperands,
     /*  591313 */     // GIR_Coverage, 4394,
     /*  591313 */     GIR_EraseRootFromParent_Done,
     /*  591314 */   // Label 9629: @591314
     /*  591314 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(591389), // Rule ID 4395 //
     /*  591319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  591330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  591333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  591336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  591339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  591368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591387 */     GIR_RootConstrainSelectedInstOperands,
     /*  591388 */     // GIR_Coverage, 4395,
     /*  591388 */     GIR_EraseRootFromParent_Done,
     /*  591389 */   // Label 9630: @591389
     /*  591389 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(591464), // Rule ID 4404 //
     /*  591394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591462 */     GIR_RootConstrainSelectedInstOperands,
     /*  591463 */     // GIR_Coverage, 4404,
     /*  591463 */     GIR_EraseRootFromParent_Done,
     /*  591464 */   // Label 9631: @591464
     /*  591464 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(591539), // Rule ID 4405 //
     /*  591469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591537 */     GIR_RootConstrainSelectedInstOperands,
     /*  591538 */     // GIR_Coverage, 4405,
     /*  591538 */     GIR_EraseRootFromParent_Done,
     /*  591539 */   // Label 9632: @591539
     /*  591539 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(591614), // Rule ID 4414 //
     /*  591544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591612 */     GIR_RootConstrainSelectedInstOperands,
     /*  591613 */     // GIR_Coverage, 4414,
     /*  591613 */     GIR_EraseRootFromParent_Done,
     /*  591614 */   // Label 9633: @591614
     /*  591614 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(591689), // Rule ID 4415 //
     /*  591619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591665 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591687 */     GIR_RootConstrainSelectedInstOperands,
     /*  591688 */     // GIR_Coverage, 4415,
     /*  591688 */     GIR_EraseRootFromParent_Done,
     /*  591689 */   // Label 9634: @591689
     /*  591689 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(591764), // Rule ID 4422 //
     /*  591694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591762 */     GIR_RootConstrainSelectedInstOperands,
     /*  591763 */     // GIR_Coverage, 4422,
     /*  591763 */     GIR_EraseRootFromParent_Done,
     /*  591764 */   // Label 9635: @591764
     /*  591764 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(591839), // Rule ID 4423 //
     /*  591769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591815 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591837 */     GIR_RootConstrainSelectedInstOperands,
     /*  591838 */     // GIR_Coverage, 4423,
     /*  591838 */     GIR_EraseRootFromParent_Done,
     /*  591839 */   // Label 9636: @591839
     /*  591839 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(591914), // Rule ID 4426 //
     /*  591844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591912 */     GIR_RootConstrainSelectedInstOperands,
     /*  591913 */     // GIR_Coverage, 4426,
     /*  591913 */     GIR_EraseRootFromParent_Done,
     /*  591914 */   // Label 9637: @591914
     /*  591914 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(591989), // Rule ID 4427 //
     /*  591919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591965 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591987 */     GIR_RootConstrainSelectedInstOperands,
     /*  591988 */     // GIR_Coverage, 4427,
     /*  591988 */     GIR_EraseRootFromParent_Done,
     /*  591989 */   // Label 9638: @591989
     /*  591989 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(592064), // Rule ID 4430 //
     /*  591994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  592005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  592008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  592011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592062 */     GIR_RootConstrainSelectedInstOperands,
     /*  592063 */     // GIR_Coverage, 4430,
     /*  592063 */     GIR_EraseRootFromParent_Done,
     /*  592064 */   // Label 9639: @592064
     /*  592064 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(592139), // Rule ID 4431 //
     /*  592069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  592080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  592083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  592086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11729:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592137 */     GIR_RootConstrainSelectedInstOperands,
     /*  592138 */     // GIR_Coverage, 4431,
     /*  592138 */     GIR_EraseRootFromParent_Done,
     /*  592139 */   // Label 9640: @592139
     /*  592139 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(592214), // Rule ID 4434 //
     /*  592144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  592155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  592158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  592161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592212 */     GIR_RootConstrainSelectedInstOperands,
     /*  592213 */     // GIR_Coverage, 4434,
     /*  592213 */     GIR_EraseRootFromParent_Done,
     /*  592214 */   // Label 9641: @592214
     /*  592214 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(592289), // Rule ID 4435 //
     /*  592219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  592230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  592233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  592236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592287 */     GIR_RootConstrainSelectedInstOperands,
     /*  592288 */     // GIR_Coverage, 4435,
     /*  592288 */     GIR_EraseRootFromParent_Done,
     /*  592289 */   // Label 9642: @592289
     /*  592289 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(592364), // Rule ID 4438 //
     /*  592294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  592305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  592308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  592311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592362 */     GIR_RootConstrainSelectedInstOperands,
     /*  592363 */     // GIR_Coverage, 4438,
     /*  592363 */     GIR_EraseRootFromParent_Done,
     /*  592364 */   // Label 9643: @592364
     /*  592364 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(592439), // Rule ID 4439 //
     /*  592369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  592380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  592383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  592386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592437 */     GIR_RootConstrainSelectedInstOperands,
     /*  592438 */     // GIR_Coverage, 4439,
     /*  592438 */     GIR_EraseRootFromParent_Done,
     /*  592439 */   // Label 9644: @592439
     /*  592439 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(592514), // Rule ID 4442 //
     /*  592444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592512 */     GIR_RootConstrainSelectedInstOperands,
     /*  592513 */     // GIR_Coverage, 4442,
     /*  592513 */     GIR_EraseRootFromParent_Done,
     /*  592514 */   // Label 9645: @592514
     /*  592514 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(592589), // Rule ID 4443 //
     /*  592519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592587 */     GIR_RootConstrainSelectedInstOperands,
     /*  592588 */     // GIR_Coverage, 4443,
     /*  592588 */     GIR_EraseRootFromParent_Done,
     /*  592589 */   // Label 9646: @592589
     /*  592589 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(592664), // Rule ID 4446 //
     /*  592594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592662 */     GIR_RootConstrainSelectedInstOperands,
     /*  592663 */     // GIR_Coverage, 4446,
     /*  592663 */     GIR_EraseRootFromParent_Done,
     /*  592664 */   // Label 9647: @592664
     /*  592664 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(592739), // Rule ID 4447 //
     /*  592669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592715 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592737 */     GIR_RootConstrainSelectedInstOperands,
     /*  592738 */     // GIR_Coverage, 4447,
     /*  592738 */     GIR_EraseRootFromParent_Done,
     /*  592739 */   // Label 9648: @592739
     /*  592739 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(592814), // Rule ID 4450 //
     /*  592744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592812 */     GIR_RootConstrainSelectedInstOperands,
     /*  592813 */     // GIR_Coverage, 4450,
     /*  592813 */     GIR_EraseRootFromParent_Done,
     /*  592814 */   // Label 9649: @592814
     /*  592814 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(592889), // Rule ID 4451 //
     /*  592819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11729:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592887 */     GIR_RootConstrainSelectedInstOperands,
     /*  592888 */     // GIR_Coverage, 4451,
     /*  592888 */     GIR_EraseRootFromParent_Done,
     /*  592889 */   // Label 9650: @592889
     /*  592889 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(592964), // Rule ID 4454 //
     /*  592894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592962 */     GIR_RootConstrainSelectedInstOperands,
     /*  592963 */     // GIR_Coverage, 4454,
     /*  592963 */     GIR_EraseRootFromParent_Done,
     /*  592964 */   // Label 9651: @592964
     /*  592964 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(593039), // Rule ID 4455 //
     /*  592969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593037 */     GIR_RootConstrainSelectedInstOperands,
     /*  593038 */     // GIR_Coverage, 4455,
     /*  593038 */     GIR_EraseRootFromParent_Done,
     /*  593039 */   // Label 9652: @593039
     /*  593039 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(593114), // Rule ID 4458 //
     /*  593044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  593055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  593058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  593061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593112 */     GIR_RootConstrainSelectedInstOperands,
     /*  593113 */     // GIR_Coverage, 4458,
     /*  593113 */     GIR_EraseRootFromParent_Done,
     /*  593114 */   // Label 9653: @593114
     /*  593114 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(593189), // Rule ID 4459 //
     /*  593119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  593130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  593133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  593136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593187 */     GIR_RootConstrainSelectedInstOperands,
     /*  593188 */     // GIR_Coverage, 4459,
     /*  593188 */     GIR_EraseRootFromParent_Done,
     /*  593189 */   // Label 9654: @593189
     /*  593189 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(593264), // Rule ID 4462 //
     /*  593194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  593205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  593208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  593211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593262 */     GIR_RootConstrainSelectedInstOperands,
     /*  593263 */     // GIR_Coverage, 4462,
     /*  593263 */     GIR_EraseRootFromParent_Done,
     /*  593264 */   // Label 9655: @593264
     /*  593264 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(593339), // Rule ID 4463 //
     /*  593269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  593280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  593283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  593286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593337 */     GIR_RootConstrainSelectedInstOperands,
     /*  593338 */     // GIR_Coverage, 4463,
     /*  593338 */     GIR_EraseRootFromParent_Done,
     /*  593339 */   // Label 9656: @593339
     /*  593339 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(593414), // Rule ID 4466 //
     /*  593344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593412 */     GIR_RootConstrainSelectedInstOperands,
     /*  593413 */     // GIR_Coverage, 4466,
     /*  593413 */     GIR_EraseRootFromParent_Done,
     /*  593414 */   // Label 9657: @593414
     /*  593414 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(593489), // Rule ID 4467 //
     /*  593419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  593430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  593433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  593436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593465 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11729:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593487 */     GIR_RootConstrainSelectedInstOperands,
     /*  593488 */     // GIR_Coverage, 4467,
     /*  593488 */     GIR_EraseRootFromParent_Done,
     /*  593489 */   // Label 9658: @593489
     /*  593489 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(593564), // Rule ID 4470 //
     /*  593494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593562 */     GIR_RootConstrainSelectedInstOperands,
     /*  593563 */     // GIR_Coverage, 4470,
     /*  593563 */     GIR_EraseRootFromParent_Done,
     /*  593564 */   // Label 9659: @593564
     /*  593564 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(593639), // Rule ID 4471 //
     /*  593569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11729:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593637 */     GIR_RootConstrainSelectedInstOperands,
     /*  593638 */     // GIR_Coverage, 4471,
     /*  593638 */     GIR_EraseRootFromParent_Done,
     /*  593639 */   // Label 9660: @593639
     /*  593639 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(593714), // Rule ID 4474 //
     /*  593644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593712 */     GIR_RootConstrainSelectedInstOperands,
     /*  593713 */     // GIR_Coverage, 4474,
     /*  593713 */     GIR_EraseRootFromParent_Done,
     /*  593714 */   // Label 9661: @593714
     /*  593714 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(593789), // Rule ID 4475 //
     /*  593719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593765 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11729:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593787 */     GIR_RootConstrainSelectedInstOperands,
     /*  593788 */     // GIR_Coverage, 4475,
     /*  593788 */     GIR_EraseRootFromParent_Done,
     /*  593789 */   // Label 9662: @593789
     /*  593789 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(593864), // Rule ID 4478 //
     /*  593794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593862 */     GIR_RootConstrainSelectedInstOperands,
     /*  593863 */     // GIR_Coverage, 4478,
     /*  593863 */     GIR_EraseRootFromParent_Done,
     /*  593864 */   // Label 9663: @593864
     /*  593864 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(593939), // Rule ID 4479 //
     /*  593869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593915 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11729:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593937 */     GIR_RootConstrainSelectedInstOperands,
     /*  593938 */     // GIR_Coverage, 4479,
     /*  593938 */     GIR_EraseRootFromParent_Done,
     /*  593939 */   // Label 9664: @593939
     /*  593939 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(594014), // Rule ID 4484 //
     /*  593944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594012 */     GIR_RootConstrainSelectedInstOperands,
     /*  594013 */     // GIR_Coverage, 4484,
     /*  594013 */     GIR_EraseRootFromParent_Done,
     /*  594014 */   // Label 9665: @594014
     /*  594014 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(594089), // Rule ID 4485 //
     /*  594019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  594030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  594033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  594036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  594039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594065 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  594068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594087 */     GIR_RootConstrainSelectedInstOperands,
     /*  594088 */     // GIR_Coverage, 4485,
     /*  594088 */     GIR_EraseRootFromParent_Done,
     /*  594089 */   // Label 9666: @594089
     /*  594089 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(594164), // Rule ID 4494 //
     /*  594094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  594105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  594108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  594111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  594114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594162 */     GIR_RootConstrainSelectedInstOperands,
     /*  594163 */     // GIR_Coverage, 4494,
     /*  594163 */     GIR_EraseRootFromParent_Done,
     /*  594164 */   // Label 9667: @594164
     /*  594164 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(594239), // Rule ID 4495 //
     /*  594169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  594180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  594183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  594186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  594189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594215 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594237 */     GIR_RootConstrainSelectedInstOperands,
     /*  594238 */     // GIR_Coverage, 4495,
     /*  594238 */     GIR_EraseRootFromParent_Done,
     /*  594239 */   // Label 9668: @594239
     /*  594239 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(594314), // Rule ID 4504 //
     /*  594244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  594255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  594258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  594261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  594264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594312 */     GIR_RootConstrainSelectedInstOperands,
     /*  594313 */     // GIR_Coverage, 4504,
     /*  594313 */     GIR_EraseRootFromParent_Done,
     /*  594314 */   // Label 9669: @594314
     /*  594314 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(594389), // Rule ID 4505 //
     /*  594319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  594330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  594333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  594336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  594339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594365 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594387 */     GIR_RootConstrainSelectedInstOperands,
     /*  594388 */     // GIR_Coverage, 4505,
     /*  594388 */     GIR_EraseRootFromParent_Done,
     /*  594389 */   // Label 9670: @594389
     /*  594389 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(594464), // Rule ID 4514 //
     /*  594394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594462 */     GIR_RootConstrainSelectedInstOperands,
     /*  594463 */     // GIR_Coverage, 4514,
     /*  594463 */     GIR_EraseRootFromParent_Done,
     /*  594464 */   // Label 9671: @594464
     /*  594464 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(594539), // Rule ID 4515 //
     /*  594469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594515 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594537 */     GIR_RootConstrainSelectedInstOperands,
     /*  594538 */     // GIR_Coverage, 4515,
     /*  594538 */     GIR_EraseRootFromParent_Done,
     /*  594539 */   // Label 9672: @594539
     /*  594539 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(594614), // Rule ID 4524 //
     /*  594544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594612 */     GIR_RootConstrainSelectedInstOperands,
     /*  594613 */     // GIR_Coverage, 4524,
     /*  594613 */     GIR_EraseRootFromParent_Done,
     /*  594614 */   // Label 9673: @594614
     /*  594614 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(594689), // Rule ID 4525 //
     /*  594619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594665 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594687 */     GIR_RootConstrainSelectedInstOperands,
     /*  594688 */     // GIR_Coverage, 4525,
     /*  594688 */     GIR_EraseRootFromParent_Done,
     /*  594689 */   // Label 9674: @594689
     /*  594689 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(594764), // Rule ID 4534 //
     /*  594694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594762 */     GIR_RootConstrainSelectedInstOperands,
     /*  594763 */     // GIR_Coverage, 4534,
     /*  594763 */     GIR_EraseRootFromParent_Done,
     /*  594764 */   // Label 9675: @594764
     /*  594764 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(594839), // Rule ID 4535 //
     /*  594769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594815 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594837 */     GIR_RootConstrainSelectedInstOperands,
     /*  594838 */     // GIR_Coverage, 4535,
     /*  594838 */     GIR_EraseRootFromParent_Done,
     /*  594839 */   // Label 9676: @594839
     /*  594839 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(594914), // Rule ID 4544 //
     /*  594844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594912 */     GIR_RootConstrainSelectedInstOperands,
     /*  594913 */     // GIR_Coverage, 4544,
     /*  594913 */     GIR_EraseRootFromParent_Done,
     /*  594914 */   // Label 9677: @594914
     /*  594914 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(594989), // Rule ID 4545 //
     /*  594919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594965 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594987 */     GIR_RootConstrainSelectedInstOperands,
     /*  594988 */     // GIR_Coverage, 4545,
     /*  594988 */     GIR_EraseRootFromParent_Done,
     /*  594989 */   // Label 9678: @594989
     /*  594989 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(595064), // Rule ID 4554 //
     /*  594994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  595005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  595008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  595011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  595014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595062 */     GIR_RootConstrainSelectedInstOperands,
     /*  595063 */     // GIR_Coverage, 4554,
     /*  595063 */     GIR_EraseRootFromParent_Done,
     /*  595064 */   // Label 9679: @595064
     /*  595064 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(595139), // Rule ID 4555 //
     /*  595069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  595080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  595083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  595086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  595089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595137 */     GIR_RootConstrainSelectedInstOperands,
     /*  595138 */     // GIR_Coverage, 4555,
     /*  595138 */     GIR_EraseRootFromParent_Done,
     /*  595139 */   // Label 9680: @595139
     /*  595139 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(595214), // Rule ID 4564 //
     /*  595144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  595155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  595158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  595161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  595164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595212 */     GIR_RootConstrainSelectedInstOperands,
     /*  595213 */     // GIR_Coverage, 4564,
     /*  595213 */     GIR_EraseRootFromParent_Done,
     /*  595214 */   // Label 9681: @595214
     /*  595214 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(595289), // Rule ID 4565 //
     /*  595219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  595230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  595233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  595236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  595239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595287 */     GIR_RootConstrainSelectedInstOperands,
     /*  595288 */     // GIR_Coverage, 4565,
     /*  595288 */     GIR_EraseRootFromParent_Done,
     /*  595289 */   // Label 9682: @595289
     /*  595289 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(595364), // Rule ID 4574 //
     /*  595294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  595305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  595308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  595311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  595314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595362 */     GIR_RootConstrainSelectedInstOperands,
     /*  595363 */     // GIR_Coverage, 4574,
     /*  595363 */     GIR_EraseRootFromParent_Done,
     /*  595364 */   // Label 9683: @595364
     /*  595364 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(595439), // Rule ID 4575 //
     /*  595369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  595380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  595383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  595386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  595389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595415 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595437 */     GIR_RootConstrainSelectedInstOperands,
     /*  595438 */     // GIR_Coverage, 4575,
     /*  595438 */     GIR_EraseRootFromParent_Done,
     /*  595439 */   // Label 9684: @595439
     /*  595439 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(595514), // Rule ID 4584 //
     /*  595444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595512 */     GIR_RootConstrainSelectedInstOperands,
     /*  595513 */     // GIR_Coverage, 4584,
     /*  595513 */     GIR_EraseRootFromParent_Done,
     /*  595514 */   // Label 9685: @595514
     /*  595514 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(595589), // Rule ID 4585 //
     /*  595519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595565 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595587 */     GIR_RootConstrainSelectedInstOperands,
     /*  595588 */     // GIR_Coverage, 4585,
     /*  595588 */     GIR_EraseRootFromParent_Done,
     /*  595589 */   // Label 9686: @595589
     /*  595589 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(595664), // Rule ID 4594 //
     /*  595594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595662 */     GIR_RootConstrainSelectedInstOperands,
     /*  595663 */     // GIR_Coverage, 4594,
     /*  595663 */     GIR_EraseRootFromParent_Done,
     /*  595664 */   // Label 9687: @595664
     /*  595664 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(595739), // Rule ID 4595 //
     /*  595669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595737 */     GIR_RootConstrainSelectedInstOperands,
     /*  595738 */     // GIR_Coverage, 4595,
     /*  595738 */     GIR_EraseRootFromParent_Done,
     /*  595739 */   // Label 9688: @595739
     /*  595739 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(595814), // Rule ID 4604 //
     /*  595744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595812 */     GIR_RootConstrainSelectedInstOperands,
     /*  595813 */     // GIR_Coverage, 4604,
     /*  595813 */     GIR_EraseRootFromParent_Done,
     /*  595814 */   // Label 9689: @595814
     /*  595814 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(595889), // Rule ID 4605 //
     /*  595819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595887 */     GIR_RootConstrainSelectedInstOperands,
     /*  595888 */     // GIR_Coverage, 4605,
     /*  595888 */     GIR_EraseRootFromParent_Done,
     /*  595889 */   // Label 9690: @595889
     /*  595889 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(595964), // Rule ID 4614 //
     /*  595894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595962 */     GIR_RootConstrainSelectedInstOperands,
     /*  595963 */     // GIR_Coverage, 4614,
     /*  595963 */     GIR_EraseRootFromParent_Done,
     /*  595964 */   // Label 9691: @595964
     /*  595964 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(596039), // Rule ID 4615 //
     /*  595969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596015 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  596018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596037 */     GIR_RootConstrainSelectedInstOperands,
     /*  596038 */     // GIR_Coverage, 4615,
     /*  596038 */     GIR_EraseRootFromParent_Done,
     /*  596039 */   // Label 9692: @596039
     /*  596039 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(596114), // Rule ID 4624 //
     /*  596044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  596055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  596058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  596061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  596064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  596093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596112 */     GIR_RootConstrainSelectedInstOperands,
     /*  596113 */     // GIR_Coverage, 4624,
     /*  596113 */     GIR_EraseRootFromParent_Done,
     /*  596114 */   // Label 9693: @596114
     /*  596114 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(596189), // Rule ID 4625 //
     /*  596119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  596130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  596133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  596136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  596139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  596168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596187 */     GIR_RootConstrainSelectedInstOperands,
     /*  596188 */     // GIR_Coverage, 4625,
     /*  596188 */     GIR_EraseRootFromParent_Done,
     /*  596189 */   // Label 9694: @596189
     /*  596189 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(596264), // Rule ID 4632 //
     /*  596194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596240 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  596243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596262 */     GIR_RootConstrainSelectedInstOperands,
     /*  596263 */     // GIR_Coverage, 4632,
     /*  596263 */     GIR_EraseRootFromParent_Done,
     /*  596264 */   // Label 9695: @596264
     /*  596264 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(596339), // Rule ID 4633 //
     /*  596269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  596280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  596283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  596286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  596318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596337 */     GIR_RootConstrainSelectedInstOperands,
     /*  596338 */     // GIR_Coverage, 4633,
     /*  596338 */     GIR_EraseRootFromParent_Done,
     /*  596339 */   // Label 9696: @596339
     /*  596339 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(596414), // Rule ID 4636 //
     /*  596344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596412 */     GIR_RootConstrainSelectedInstOperands,
     /*  596413 */     // GIR_Coverage, 4636,
     /*  596413 */     GIR_EraseRootFromParent_Done,
     /*  596414 */   // Label 9697: @596414
     /*  596414 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(596489), // Rule ID 4637 //
     /*  596419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  596430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  596433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  596436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596465 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596487 */     GIR_RootConstrainSelectedInstOperands,
     /*  596488 */     // GIR_Coverage, 4637,
     /*  596488 */     GIR_EraseRootFromParent_Done,
     /*  596489 */   // Label 9698: @596489
     /*  596489 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(596564), // Rule ID 4640 //
     /*  596494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596562 */     GIR_RootConstrainSelectedInstOperands,
     /*  596563 */     // GIR_Coverage, 4640,
     /*  596563 */     GIR_EraseRootFromParent_Done,
     /*  596564 */   // Label 9699: @596564
     /*  596564 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(596639), // Rule ID 4641 //
     /*  596569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11697:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596637 */     GIR_RootConstrainSelectedInstOperands,
     /*  596638 */     // GIR_Coverage, 4641,
     /*  596638 */     GIR_EraseRootFromParent_Done,
     /*  596639 */   // Label 9700: @596639
     /*  596639 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(596714), // Rule ID 4644 //
     /*  596644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596712 */     GIR_RootConstrainSelectedInstOperands,
     /*  596713 */     // GIR_Coverage, 4644,
     /*  596713 */     GIR_EraseRootFromParent_Done,
     /*  596714 */   // Label 9701: @596714
     /*  596714 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(596789), // Rule ID 4645 //
     /*  596719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596787 */     GIR_RootConstrainSelectedInstOperands,
     /*  596788 */     // GIR_Coverage, 4645,
     /*  596788 */     GIR_EraseRootFromParent_Done,
     /*  596789 */   // Label 9702: @596789
     /*  596789 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(596864), // Rule ID 4648 //
     /*  596794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596862 */     GIR_RootConstrainSelectedInstOperands,
     /*  596863 */     // GIR_Coverage, 4648,
     /*  596863 */     GIR_EraseRootFromParent_Done,
     /*  596864 */   // Label 9703: @596864
     /*  596864 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(596939), // Rule ID 4649 //
     /*  596869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596937 */     GIR_RootConstrainSelectedInstOperands,
     /*  596938 */     // GIR_Coverage, 4649,
     /*  596938 */     GIR_EraseRootFromParent_Done,
     /*  596939 */   // Label 9704: @596939
     /*  596939 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(597014), // Rule ID 4652 //
     /*  596944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597012 */     GIR_RootConstrainSelectedInstOperands,
     /*  597013 */     // GIR_Coverage, 4652,
     /*  597013 */     GIR_EraseRootFromParent_Done,
     /*  597014 */   // Label 9705: @597014
     /*  597014 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(597089), // Rule ID 4653 //
     /*  597019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  597030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  597033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  597036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597065 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597087 */     GIR_RootConstrainSelectedInstOperands,
     /*  597088 */     // GIR_Coverage, 4653,
     /*  597088 */     GIR_EraseRootFromParent_Done,
     /*  597089 */   // Label 9706: @597089
     /*  597089 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(597164), // Rule ID 4656 //
     /*  597094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  597105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  597108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  597111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  597143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597162 */     GIR_RootConstrainSelectedInstOperands,
     /*  597163 */     // GIR_Coverage, 4656,
     /*  597163 */     GIR_EraseRootFromParent_Done,
     /*  597164 */   // Label 9707: @597164
     /*  597164 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(597239), // Rule ID 4657 //
     /*  597169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  597180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  597183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  597186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  597218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597237 */     GIR_RootConstrainSelectedInstOperands,
     /*  597238 */     // GIR_Coverage, 4657,
     /*  597238 */     GIR_EraseRootFromParent_Done,
     /*  597239 */   // Label 9708: @597239
     /*  597239 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(597314), // Rule ID 4660 //
     /*  597244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  597255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  597258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  597261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597312 */     GIR_RootConstrainSelectedInstOperands,
     /*  597313 */     // GIR_Coverage, 4660,
     /*  597313 */     GIR_EraseRootFromParent_Done,
     /*  597314 */   // Label 9709: @597314
     /*  597314 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(597389), // Rule ID 4661 //
     /*  597319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  597330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  597333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  597336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11697:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597387 */     GIR_RootConstrainSelectedInstOperands,
     /*  597388 */     // GIR_Coverage, 4661,
     /*  597388 */     GIR_EraseRootFromParent_Done,
     /*  597389 */   // Label 9710: @597389
     /*  597389 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(597464), // Rule ID 4664 //
     /*  597394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597462 */     GIR_RootConstrainSelectedInstOperands,
     /*  597463 */     // GIR_Coverage, 4664,
     /*  597463 */     GIR_EraseRootFromParent_Done,
     /*  597464 */   // Label 9711: @597464
     /*  597464 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(597539), // Rule ID 4665 //
     /*  597469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597537 */     GIR_RootConstrainSelectedInstOperands,
     /*  597538 */     // GIR_Coverage, 4665,
     /*  597538 */     GIR_EraseRootFromParent_Done,
     /*  597539 */   // Label 9712: @597539
     /*  597539 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(597614), // Rule ID 4668 //
     /*  597544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597612 */     GIR_RootConstrainSelectedInstOperands,
     /*  597613 */     // GIR_Coverage, 4668,
     /*  597613 */     GIR_EraseRootFromParent_Done,
     /*  597614 */   // Label 9713: @597614
     /*  597614 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(597689), // Rule ID 4669 //
     /*  597619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597687 */     GIR_RootConstrainSelectedInstOperands,
     /*  597688 */     // GIR_Coverage, 4669,
     /*  597688 */     GIR_EraseRootFromParent_Done,
     /*  597689 */   // Label 9714: @597689
     /*  597689 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(597764), // Rule ID 4672 //
     /*  597694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597762 */     GIR_RootConstrainSelectedInstOperands,
     /*  597763 */     // GIR_Coverage, 4672,
     /*  597763 */     GIR_EraseRootFromParent_Done,
     /*  597764 */   // Label 9715: @597764
     /*  597764 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(597839), // Rule ID 4673 //
     /*  597769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597815 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597837 */     GIR_RootConstrainSelectedInstOperands,
     /*  597838 */     // GIR_Coverage, 4673,
     /*  597838 */     GIR_EraseRootFromParent_Done,
     /*  597839 */   // Label 9716: @597839
     /*  597839 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(597914), // Rule ID 4676 //
     /*  597844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597912 */     GIR_RootConstrainSelectedInstOperands,
     /*  597913 */     // GIR_Coverage, 4676,
     /*  597913 */     GIR_EraseRootFromParent_Done,
     /*  597914 */   // Label 9717: @597914
     /*  597914 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(597989), // Rule ID 4677 //
     /*  597919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11697:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597987 */     GIR_RootConstrainSelectedInstOperands,
     /*  597988 */     // GIR_Coverage, 4677,
     /*  597988 */     GIR_EraseRootFromParent_Done,
     /*  597989 */   // Label 9718: @597989
     /*  597989 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(598064), // Rule ID 4680 //
     /*  597994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  598043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598062 */     GIR_RootConstrainSelectedInstOperands,
     /*  598063 */     // GIR_Coverage, 4680,
     /*  598063 */     GIR_EraseRootFromParent_Done,
     /*  598064 */   // Label 9719: @598064
     /*  598064 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(598139), // Rule ID 4681 //
     /*  598069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  598080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  598083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  598086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11697:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  598118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598137 */     GIR_RootConstrainSelectedInstOperands,
     /*  598138 */     // GIR_Coverage, 4681,
     /*  598138 */     GIR_EraseRootFromParent_Done,
     /*  598139 */   // Label 9720: @598139
     /*  598139 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(598214), // Rule ID 4684 //
     /*  598144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  598193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598212 */     GIR_RootConstrainSelectedInstOperands,
     /*  598213 */     // GIR_Coverage, 4684,
     /*  598213 */     GIR_EraseRootFromParent_Done,
     /*  598214 */   // Label 9721: @598214
     /*  598214 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(598289), // Rule ID 4685 //
     /*  598219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  598230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  598233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  598236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598265 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11697:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  598268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598287 */     GIR_RootConstrainSelectedInstOperands,
     /*  598288 */     // GIR_Coverage, 4685,
     /*  598288 */     GIR_EraseRootFromParent_Done,
     /*  598289 */   // Label 9722: @598289
     /*  598289 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(598364), // Rule ID 4688 //
     /*  598294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  598314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  598340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  598343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598362 */     GIR_RootConstrainSelectedInstOperands,
     /*  598363 */     // GIR_Coverage, 4688,
     /*  598363 */     GIR_EraseRootFromParent_Done,
     /*  598364 */   // Label 9723: @598364
     /*  598364 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(598439), // Rule ID 4689 //
     /*  598369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  598372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  598380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  598383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  598386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  598389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  598408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11697:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  598415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  598418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  598434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598437 */     GIR_RootConstrainSelectedInstOperands,
     /*  598438 */     // GIR_Coverage, 4689,
     /*  598438 */     GIR_EraseRootFromParent_Done,
     /*  598439 */   // Label 9724: @598439
     /*  598439 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(598514), // Rule ID 4694 //
     /*  598444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598512 */     GIR_RootConstrainSelectedInstOperands,
     /*  598513 */     // GIR_Coverage, 4694,
     /*  598513 */     GIR_EraseRootFromParent_Done,
     /*  598514 */   // Label 9725: @598514
     /*  598514 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(598589), // Rule ID 4695 //
     /*  598519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598565 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598587 */     GIR_RootConstrainSelectedInstOperands,
     /*  598588 */     // GIR_Coverage, 4695,
     /*  598588 */     GIR_EraseRootFromParent_Done,
     /*  598589 */   // Label 9726: @598589
     /*  598589 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(598664), // Rule ID 4704 //
     /*  598594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598662 */     GIR_RootConstrainSelectedInstOperands,
     /*  598663 */     // GIR_Coverage, 4704,
     /*  598663 */     GIR_EraseRootFromParent_Done,
     /*  598664 */   // Label 9727: @598664
     /*  598664 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(598739), // Rule ID 4705 //
     /*  598669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598715 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598737 */     GIR_RootConstrainSelectedInstOperands,
     /*  598738 */     // GIR_Coverage, 4705,
     /*  598738 */     GIR_EraseRootFromParent_Done,
     /*  598739 */   // Label 9728: @598739
     /*  598739 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(598814), // Rule ID 4714 //
     /*  598744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598812 */     GIR_RootConstrainSelectedInstOperands,
     /*  598813 */     // GIR_Coverage, 4714,
     /*  598813 */     GIR_EraseRootFromParent_Done,
     /*  598814 */   // Label 9729: @598814
     /*  598814 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(598889), // Rule ID 4715 //
     /*  598819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598887 */     GIR_RootConstrainSelectedInstOperands,
     /*  598888 */     // GIR_Coverage, 4715,
     /*  598888 */     GIR_EraseRootFromParent_Done,
     /*  598889 */   // Label 9730: @598889
     /*  598889 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(598964), // Rule ID 4724 //
     /*  598894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598962 */     GIR_RootConstrainSelectedInstOperands,
     /*  598963 */     // GIR_Coverage, 4724,
     /*  598963 */     GIR_EraseRootFromParent_Done,
     /*  598964 */   // Label 9731: @598964
     /*  598964 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(599039), // Rule ID 4725 //
     /*  598969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599037 */     GIR_RootConstrainSelectedInstOperands,
     /*  599038 */     // GIR_Coverage, 4725,
     /*  599038 */     GIR_EraseRootFromParent_Done,
     /*  599039 */   // Label 9732: @599039
     /*  599039 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(599114), // Rule ID 4734 //
     /*  599044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  599055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  599058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  599061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  599064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599112 */     GIR_RootConstrainSelectedInstOperands,
     /*  599113 */     // GIR_Coverage, 4734,
     /*  599113 */     GIR_EraseRootFromParent_Done,
     /*  599114 */   // Label 9733: @599114
     /*  599114 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(599189), // Rule ID 4735 //
     /*  599119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  599130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  599133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  599136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  599139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599165 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599187 */     GIR_RootConstrainSelectedInstOperands,
     /*  599188 */     // GIR_Coverage, 4735,
     /*  599188 */     GIR_EraseRootFromParent_Done,
     /*  599189 */   // Label 9734: @599189
     /*  599189 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(599264), // Rule ID 4744 //
     /*  599194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  599205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  599208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  599211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  599214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599262 */     GIR_RootConstrainSelectedInstOperands,
     /*  599263 */     // GIR_Coverage, 4744,
     /*  599263 */     GIR_EraseRootFromParent_Done,
     /*  599264 */   // Label 9735: @599264
     /*  599264 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(599339), // Rule ID 4745 //
     /*  599269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  599280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  599283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  599286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  599289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599315 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599337 */     GIR_RootConstrainSelectedInstOperands,
     /*  599338 */     // GIR_Coverage, 4745,
     /*  599338 */     GIR_EraseRootFromParent_Done,
     /*  599339 */   // Label 9736: @599339
     /*  599339 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(599414), // Rule ID 4754 //
     /*  599344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  599364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599412 */     GIR_RootConstrainSelectedInstOperands,
     /*  599413 */     // GIR_Coverage, 4754,
     /*  599413 */     GIR_EraseRootFromParent_Done,
     /*  599414 */   // Label 9737: @599414
     /*  599414 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(599489), // Rule ID 4755 //
     /*  599419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  599430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  599433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  599436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  599439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599465 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599487 */     GIR_RootConstrainSelectedInstOperands,
     /*  599488 */     // GIR_Coverage, 4755,
     /*  599488 */     GIR_EraseRootFromParent_Done,
     /*  599489 */   // Label 9738: @599489
     /*  599489 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(599564), // Rule ID 4764 //
     /*  599494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599562 */     GIR_RootConstrainSelectedInstOperands,
     /*  599563 */     // GIR_Coverage, 4764,
     /*  599563 */     GIR_EraseRootFromParent_Done,
     /*  599564 */   // Label 9739: @599564
     /*  599564 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(599639), // Rule ID 4765 //
     /*  599569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599637 */     GIR_RootConstrainSelectedInstOperands,
     /*  599638 */     // GIR_Coverage, 4765,
     /*  599638 */     GIR_EraseRootFromParent_Done,
     /*  599639 */   // Label 9740: @599639
     /*  599639 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(599714), // Rule ID 4774 //
     /*  599644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599712 */     GIR_RootConstrainSelectedInstOperands,
     /*  599713 */     // GIR_Coverage, 4774,
     /*  599713 */     GIR_EraseRootFromParent_Done,
     /*  599714 */   // Label 9741: @599714
     /*  599714 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(599789), // Rule ID 4775 //
     /*  599719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599787 */     GIR_RootConstrainSelectedInstOperands,
     /*  599788 */     // GIR_Coverage, 4775,
     /*  599788 */     GIR_EraseRootFromParent_Done,
     /*  599789 */   // Label 9742: @599789
     /*  599789 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(599864), // Rule ID 4784 //
     /*  599794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599862 */     GIR_RootConstrainSelectedInstOperands,
     /*  599863 */     // GIR_Coverage, 4784,
     /*  599863 */     GIR_EraseRootFromParent_Done,
     /*  599864 */   // Label 9743: @599864
     /*  599864 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(599939), // Rule ID 4785 //
     /*  599869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599915 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599937 */     GIR_RootConstrainSelectedInstOperands,
     /*  599938 */     // GIR_Coverage, 4785,
     /*  599938 */     GIR_EraseRootFromParent_Done,
     /*  599939 */   // Label 9744: @599939
     /*  599939 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(600014), // Rule ID 4794 //
     /*  599944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600012 */     GIR_RootConstrainSelectedInstOperands,
     /*  600013 */     // GIR_Coverage, 4794,
     /*  600013 */     GIR_EraseRootFromParent_Done,
     /*  600014 */   // Label 9745: @600014
     /*  600014 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(600089), // Rule ID 4795 //
     /*  600019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  600030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  600033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  600036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  600039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600087 */     GIR_RootConstrainSelectedInstOperands,
     /*  600088 */     // GIR_Coverage, 4795,
     /*  600088 */     GIR_EraseRootFromParent_Done,
     /*  600089 */   // Label 9746: @600089
     /*  600089 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(600164), // Rule ID 4804 //
     /*  600094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  600114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  600143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600162 */     GIR_RootConstrainSelectedInstOperands,
     /*  600163 */     // GIR_Coverage, 4804,
     /*  600163 */     GIR_EraseRootFromParent_Done,
     /*  600164 */   // Label 9747: @600164
     /*  600164 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(600239), // Rule ID 4805 //
     /*  600169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  600180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  600183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  600186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  600189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  600218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600237 */     GIR_RootConstrainSelectedInstOperands,
     /*  600238 */     // GIR_Coverage, 4805,
     /*  600238 */     GIR_EraseRootFromParent_Done,
     /*  600239 */   // Label 9748: @600239
     /*  600239 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(600314), // Rule ID 4814 //
     /*  600244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  600255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  600258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  600261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  600264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  600293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600312 */     GIR_RootConstrainSelectedInstOperands,
     /*  600313 */     // GIR_Coverage, 4814,
     /*  600313 */     GIR_EraseRootFromParent_Done,
     /*  600314 */   // Label 9749: @600314
     /*  600314 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(600389), // Rule ID 4815 //
     /*  600319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  600330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  600333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  600336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  600339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  600368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600387 */     GIR_RootConstrainSelectedInstOperands,
     /*  600388 */     // GIR_Coverage, 4815,
     /*  600388 */     GIR_EraseRootFromParent_Done,
     /*  600389 */   // Label 9750: @600389
     /*  600389 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(600464), // Rule ID 4824 //
     /*  600394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600462 */     GIR_RootConstrainSelectedInstOperands,
     /*  600463 */     // GIR_Coverage, 4824,
     /*  600463 */     GIR_EraseRootFromParent_Done,
     /*  600464 */   // Label 9751: @600464
     /*  600464 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(600539), // Rule ID 4825 //
     /*  600469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600537 */     GIR_RootConstrainSelectedInstOperands,
     /*  600538 */     // GIR_Coverage, 4825,
     /*  600538 */     GIR_EraseRootFromParent_Done,
     /*  600539 */   // Label 9752: @600539
     /*  600539 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(600614), // Rule ID 4834 //
     /*  600544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600612 */     GIR_RootConstrainSelectedInstOperands,
     /*  600613 */     // GIR_Coverage, 4834,
     /*  600613 */     GIR_EraseRootFromParent_Done,
     /*  600614 */   // Label 9753: @600614
     /*  600614 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(600689), // Rule ID 4835 //
     /*  600619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600665 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600687 */     GIR_RootConstrainSelectedInstOperands,
     /*  600688 */     // GIR_Coverage, 4835,
     /*  600688 */     GIR_EraseRootFromParent_Done,
     /*  600689 */   // Label 9754: @600689
     /*  600689 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(600764), // Rule ID 4842 //
     /*  600694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600762 */     GIR_RootConstrainSelectedInstOperands,
     /*  600763 */     // GIR_Coverage, 4842,
     /*  600763 */     GIR_EraseRootFromParent_Done,
     /*  600764 */   // Label 9755: @600764
     /*  600764 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(600839), // Rule ID 4843 //
     /*  600769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600815 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600837 */     GIR_RootConstrainSelectedInstOperands,
     /*  600838 */     // GIR_Coverage, 4843,
     /*  600838 */     GIR_EraseRootFromParent_Done,
     /*  600839 */   // Label 9756: @600839
     /*  600839 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(600914), // Rule ID 4846 //
     /*  600844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600912 */     GIR_RootConstrainSelectedInstOperands,
     /*  600913 */     // GIR_Coverage, 4846,
     /*  600913 */     GIR_EraseRootFromParent_Done,
     /*  600914 */   // Label 9757: @600914
     /*  600914 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(600989), // Rule ID 4847 //
     /*  600919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600965 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600987 */     GIR_RootConstrainSelectedInstOperands,
     /*  600988 */     // GIR_Coverage, 4847,
     /*  600988 */     GIR_EraseRootFromParent_Done,
     /*  600989 */   // Label 9758: @600989
     /*  600989 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(601064), // Rule ID 4850 //
     /*  600994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  601005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  601008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  601011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601062 */     GIR_RootConstrainSelectedInstOperands,
     /*  601063 */     // GIR_Coverage, 4850,
     /*  601063 */     GIR_EraseRootFromParent_Done,
     /*  601064 */   // Label 9759: @601064
     /*  601064 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(601139), // Rule ID 4851 //
     /*  601069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  601080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  601083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  601086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11725:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601137 */     GIR_RootConstrainSelectedInstOperands,
     /*  601138 */     // GIR_Coverage, 4851,
     /*  601138 */     GIR_EraseRootFromParent_Done,
     /*  601139 */   // Label 9760: @601139
     /*  601139 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(601214), // Rule ID 4854 //
     /*  601144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  601155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  601158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  601161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601212 */     GIR_RootConstrainSelectedInstOperands,
     /*  601213 */     // GIR_Coverage, 4854,
     /*  601213 */     GIR_EraseRootFromParent_Done,
     /*  601214 */   // Label 9761: @601214
     /*  601214 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(601289), // Rule ID 4855 //
     /*  601219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  601230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  601233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  601236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601287 */     GIR_RootConstrainSelectedInstOperands,
     /*  601288 */     // GIR_Coverage, 4855,
     /*  601288 */     GIR_EraseRootFromParent_Done,
     /*  601289 */   // Label 9762: @601289
     /*  601289 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(601364), // Rule ID 4858 //
     /*  601294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601362 */     GIR_RootConstrainSelectedInstOperands,
     /*  601363 */     // GIR_Coverage, 4858,
     /*  601363 */     GIR_EraseRootFromParent_Done,
     /*  601364 */   // Label 9763: @601364
     /*  601364 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(601439), // Rule ID 4859 //
     /*  601369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  601380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  601383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  601386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601437 */     GIR_RootConstrainSelectedInstOperands,
     /*  601438 */     // GIR_Coverage, 4859,
     /*  601438 */     GIR_EraseRootFromParent_Done,
     /*  601439 */   // Label 9764: @601439
     /*  601439 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(601514), // Rule ID 4862 //
     /*  601444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601512 */     GIR_RootConstrainSelectedInstOperands,
     /*  601513 */     // GIR_Coverage, 4862,
     /*  601513 */     GIR_EraseRootFromParent_Done,
     /*  601514 */   // Label 9765: @601514
     /*  601514 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(601589), // Rule ID 4863 //
     /*  601519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601587 */     GIR_RootConstrainSelectedInstOperands,
     /*  601588 */     // GIR_Coverage, 4863,
     /*  601588 */     GIR_EraseRootFromParent_Done,
     /*  601589 */   // Label 9766: @601589
     /*  601589 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(601664), // Rule ID 4866 //
     /*  601594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601662 */     GIR_RootConstrainSelectedInstOperands,
     /*  601663 */     // GIR_Coverage, 4866,
     /*  601663 */     GIR_EraseRootFromParent_Done,
     /*  601664 */   // Label 9767: @601664
     /*  601664 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(601739), // Rule ID 4867 //
     /*  601669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601715 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601737 */     GIR_RootConstrainSelectedInstOperands,
     /*  601738 */     // GIR_Coverage, 4867,
     /*  601738 */     GIR_EraseRootFromParent_Done,
     /*  601739 */   // Label 9768: @601739
     /*  601739 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(601814), // Rule ID 4870 //
     /*  601744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601812 */     GIR_RootConstrainSelectedInstOperands,
     /*  601813 */     // GIR_Coverage, 4870,
     /*  601813 */     GIR_EraseRootFromParent_Done,
     /*  601814 */   // Label 9769: @601814
     /*  601814 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(601889), // Rule ID 4871 //
     /*  601819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11725:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601887 */     GIR_RootConstrainSelectedInstOperands,
     /*  601888 */     // GIR_Coverage, 4871,
     /*  601888 */     GIR_EraseRootFromParent_Done,
     /*  601889 */   // Label 9770: @601889
     /*  601889 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(601964), // Rule ID 4874 //
     /*  601894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601962 */     GIR_RootConstrainSelectedInstOperands,
     /*  601963 */     // GIR_Coverage, 4874,
     /*  601963 */     GIR_EraseRootFromParent_Done,
     /*  601964 */   // Label 9771: @601964
     /*  601964 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(602039), // Rule ID 4875 //
     /*  601969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602037 */     GIR_RootConstrainSelectedInstOperands,
     /*  602038 */     // GIR_Coverage, 4875,
     /*  602038 */     GIR_EraseRootFromParent_Done,
     /*  602039 */   // Label 9772: @602039
     /*  602039 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(602114), // Rule ID 4878 //
     /*  602044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  602055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  602058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  602061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602112 */     GIR_RootConstrainSelectedInstOperands,
     /*  602113 */     // GIR_Coverage, 4878,
     /*  602113 */     GIR_EraseRootFromParent_Done,
     /*  602114 */   // Label 9773: @602114
     /*  602114 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(602189), // Rule ID 4879 //
     /*  602119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  602130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  602133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  602136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602165 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602187 */     GIR_RootConstrainSelectedInstOperands,
     /*  602188 */     // GIR_Coverage, 4879,
     /*  602188 */     GIR_EraseRootFromParent_Done,
     /*  602189 */   // Label 9774: @602189
     /*  602189 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(602264), // Rule ID 4882 //
     /*  602194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  602205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  602208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  602211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602262 */     GIR_RootConstrainSelectedInstOperands,
     /*  602263 */     // GIR_Coverage, 4882,
     /*  602263 */     GIR_EraseRootFromParent_Done,
     /*  602264 */   // Label 9775: @602264
     /*  602264 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(602339), // Rule ID 4883 //
     /*  602269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  602280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  602283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  602286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602337 */     GIR_RootConstrainSelectedInstOperands,
     /*  602338 */     // GIR_Coverage, 4883,
     /*  602338 */     GIR_EraseRootFromParent_Done,
     /*  602339 */   // Label 9776: @602339
     /*  602339 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(602414), // Rule ID 4886 //
     /*  602344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  602355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  602358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  602361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602412 */     GIR_RootConstrainSelectedInstOperands,
     /*  602413 */     // GIR_Coverage, 4886,
     /*  602413 */     GIR_EraseRootFromParent_Done,
     /*  602414 */   // Label 9777: @602414
     /*  602414 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(602489), // Rule ID 4887 //
     /*  602419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  602430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  602433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  602436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602465 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11725:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602487 */     GIR_RootConstrainSelectedInstOperands,
     /*  602488 */     // GIR_Coverage, 4887,
     /*  602488 */     GIR_EraseRootFromParent_Done,
     /*  602489 */   // Label 9778: @602489
     /*  602489 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(602564), // Rule ID 4890 //
     /*  602494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602562 */     GIR_RootConstrainSelectedInstOperands,
     /*  602563 */     // GIR_Coverage, 4890,
     /*  602563 */     GIR_EraseRootFromParent_Done,
     /*  602564 */   // Label 9779: @602564
     /*  602564 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(602639), // Rule ID 4891 //
     /*  602569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11725:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602637 */     GIR_RootConstrainSelectedInstOperands,
     /*  602638 */     // GIR_Coverage, 4891,
     /*  602638 */     GIR_EraseRootFromParent_Done,
     /*  602639 */   // Label 9780: @602639
     /*  602639 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(602714), // Rule ID 4894 //
     /*  602644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602712 */     GIR_RootConstrainSelectedInstOperands,
     /*  602713 */     // GIR_Coverage, 4894,
     /*  602713 */     GIR_EraseRootFromParent_Done,
     /*  602714 */   // Label 9781: @602714
     /*  602714 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(602789), // Rule ID 4895 //
     /*  602719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602765 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11725:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602787 */     GIR_RootConstrainSelectedInstOperands,
     /*  602788 */     // GIR_Coverage, 4895,
     /*  602788 */     GIR_EraseRootFromParent_Done,
     /*  602789 */   // Label 9782: @602789
     /*  602789 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(602864), // Rule ID 4898 //
     /*  602794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602862 */     GIR_RootConstrainSelectedInstOperands,
     /*  602863 */     // GIR_Coverage, 4898,
     /*  602863 */     GIR_EraseRootFromParent_Done,
     /*  602864 */   // Label 9783: @602864
     /*  602864 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(602939), // Rule ID 4899 //
     /*  602869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602915 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11725:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602937 */     GIR_RootConstrainSelectedInstOperands,
     /*  602938 */     // GIR_Coverage, 4899,
     /*  602938 */     GIR_EraseRootFromParent_Done,
     /*  602939 */   // Label 9784: @602939
     /*  602939 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(603011), // Rule ID 5252 //
     /*  602944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603009 */     GIR_RootConstrainSelectedInstOperands,
     /*  603010 */     // GIR_Coverage, 5252,
     /*  603010 */     GIR_EraseRootFromParent_Done,
     /*  603011 */   // Label 9785: @603011
     /*  603011 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(603083), // Rule ID 5253 //
     /*  603016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  603030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  603033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603081 */     GIR_RootConstrainSelectedInstOperands,
     /*  603082 */     // GIR_Coverage, 5253,
     /*  603082 */     GIR_EraseRootFromParent_Done,
     /*  603083 */   // Label 9786: @603083
     /*  603083 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(603155), // Rule ID 5254 //
     /*  603088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  603102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  603105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603153 */     GIR_RootConstrainSelectedInstOperands,
     /*  603154 */     // GIR_Coverage, 5254,
     /*  603154 */     GIR_EraseRootFromParent_Done,
     /*  603155 */   // Label 9787: @603155
     /*  603155 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(603227), // Rule ID 5255 //
     /*  603160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  603174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  603177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603225 */     GIR_RootConstrainSelectedInstOperands,
     /*  603226 */     // GIR_Coverage, 5255,
     /*  603226 */     GIR_EraseRootFromParent_Done,
     /*  603227 */   // Label 9788: @603227
     /*  603227 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(603299), // Rule ID 5256 //
     /*  603232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  603246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  603249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603278 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603297 */     GIR_RootConstrainSelectedInstOperands,
     /*  603298 */     // GIR_Coverage, 5256,
     /*  603298 */     GIR_EraseRootFromParent_Done,
     /*  603299 */   // Label 9789: @603299
     /*  603299 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(603371), // Rule ID 5257 //
     /*  603304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  603318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  603321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  603353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603369 */     GIR_RootConstrainSelectedInstOperands,
     /*  603370 */     // GIR_Coverage, 5257,
     /*  603370 */     GIR_EraseRootFromParent_Done,
     /*  603371 */   // Label 9790: @603371
     /*  603371 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(603443), // Rule ID 5258 //
     /*  603376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  603390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  603393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603441 */     GIR_RootConstrainSelectedInstOperands,
     /*  603442 */     // GIR_Coverage, 5258,
     /*  603442 */     GIR_EraseRootFromParent_Done,
     /*  603443 */   // Label 9791: @603443
     /*  603443 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(603515), // Rule ID 5259 //
     /*  603448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  603462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  603465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603513 */     GIR_RootConstrainSelectedInstOperands,
     /*  603514 */     // GIR_Coverage, 5259,
     /*  603514 */     GIR_EraseRootFromParent_Done,
     /*  603515 */   // Label 9792: @603515
     /*  603515 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(603587), // Rule ID 5260 //
     /*  603520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603566 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603585 */     GIR_RootConstrainSelectedInstOperands,
     /*  603586 */     // GIR_Coverage, 5260,
     /*  603586 */     GIR_EraseRootFromParent_Done,
     /*  603587 */   // Label 9793: @603587
     /*  603587 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(603659), // Rule ID 5261 //
     /*  603592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603657 */     GIR_RootConstrainSelectedInstOperands,
     /*  603658 */     // GIR_Coverage, 5261,
     /*  603658 */     GIR_EraseRootFromParent_Done,
     /*  603659 */   // Label 9794: @603659
     /*  603659 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(603731), // Rule ID 5262 //
     /*  603664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603729 */     GIR_RootConstrainSelectedInstOperands,
     /*  603730 */     // GIR_Coverage, 5262,
     /*  603730 */     GIR_EraseRootFromParent_Done,
     /*  603731 */   // Label 9795: @603731
     /*  603731 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(603803), // Rule ID 5263 //
     /*  603736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603801 */     GIR_RootConstrainSelectedInstOperands,
     /*  603802 */     // GIR_Coverage, 5263,
     /*  603802 */     GIR_EraseRootFromParent_Done,
     /*  603803 */   // Label 9796: @603803
     /*  603803 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(603875), // Rule ID 5264 //
     /*  603808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603873 */     GIR_RootConstrainSelectedInstOperands,
     /*  603874 */     // GIR_Coverage, 5264,
     /*  603874 */     GIR_EraseRootFromParent_Done,
     /*  603875 */   // Label 9797: @603875
     /*  603875 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(603947), // Rule ID 5265 //
     /*  603880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603945 */     GIR_RootConstrainSelectedInstOperands,
     /*  603946 */     // GIR_Coverage, 5265,
     /*  603946 */     GIR_EraseRootFromParent_Done,
     /*  603947 */   // Label 9798: @603947
     /*  603947 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(604019), // Rule ID 5266 //
     /*  603952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604017 */     GIR_RootConstrainSelectedInstOperands,
     /*  604018 */     // GIR_Coverage, 5266,
     /*  604018 */     GIR_EraseRootFromParent_Done,
     /*  604019 */   // Label 9799: @604019
     /*  604019 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(604091), // Rule ID 5267 //
     /*  604024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  604035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  604038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  604041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  604044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604070 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604089 */     GIR_RootConstrainSelectedInstOperands,
     /*  604090 */     // GIR_Coverage, 5267,
     /*  604090 */     GIR_EraseRootFromParent_Done,
     /*  604091 */   // Label 9800: @604091
     /*  604091 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(604163), // Rule ID 5268 //
     /*  604096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  604099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  604107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  604110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  604113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  604116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  604142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604161 */     GIR_RootConstrainSelectedInstOperands,
     /*  604162 */     // GIR_Coverage, 5268,
     /*  604162 */     GIR_EraseRootFromParent_Done,
     /*  604163 */   // Label 9801: @604163
     /*  604163 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(604235), // Rule ID 5269 //
     /*  604168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  604171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  604179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  604182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  604185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  604188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  604214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  604217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604233 */     GIR_RootConstrainSelectedInstOperands,
     /*  604234 */     // GIR_Coverage, 5269,
     /*  604234 */     GIR_EraseRootFromParent_Done,
     /*  604235 */   // Label 9802: @604235
     /*  604235 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(604307), // Rule ID 5270 //
     /*  604240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  604254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  604257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604305 */     GIR_RootConstrainSelectedInstOperands,
     /*  604306 */     // GIR_Coverage, 5270,
     /*  604306 */     GIR_EraseRootFromParent_Done,
     /*  604307 */   // Label 9803: @604307
     /*  604307 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(604379), // Rule ID 5271 //
     /*  604312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  604326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  604329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604377 */     GIR_RootConstrainSelectedInstOperands,
     /*  604378 */     // GIR_Coverage, 5271,
     /*  604378 */     GIR_EraseRootFromParent_Done,
     /*  604379 */   // Label 9804: @604379
     /*  604379 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(604451), // Rule ID 5272 //
     /*  604384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604430 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604449 */     GIR_RootConstrainSelectedInstOperands,
     /*  604450 */     // GIR_Coverage, 5272,
     /*  604450 */     GIR_EraseRootFromParent_Done,
     /*  604451 */   // Label 9805: @604451
     /*  604451 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(604523), // Rule ID 5273 //
     /*  604456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604521 */     GIR_RootConstrainSelectedInstOperands,
     /*  604522 */     // GIR_Coverage, 5273,
     /*  604522 */     GIR_EraseRootFromParent_Done,
     /*  604523 */   // Label 9806: @604523
     /*  604523 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(604595), // Rule ID 5274 //
     /*  604528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604574 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604593 */     GIR_RootConstrainSelectedInstOperands,
     /*  604594 */     // GIR_Coverage, 5274,
     /*  604594 */     GIR_EraseRootFromParent_Done,
     /*  604595 */   // Label 9807: @604595
     /*  604595 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(604667), // Rule ID 5275 //
     /*  604600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604646 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604665 */     GIR_RootConstrainSelectedInstOperands,
     /*  604666 */     // GIR_Coverage, 5275,
     /*  604666 */     GIR_EraseRootFromParent_Done,
     /*  604667 */   // Label 9808: @604667
     /*  604667 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(604739), // Rule ID 5276 //
     /*  604672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604737 */     GIR_RootConstrainSelectedInstOperands,
     /*  604738 */     // GIR_Coverage, 5276,
     /*  604738 */     GIR_EraseRootFromParent_Done,
     /*  604739 */   // Label 9809: @604739
     /*  604739 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(604811), // Rule ID 5277 //
     /*  604744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604809 */     GIR_RootConstrainSelectedInstOperands,
     /*  604810 */     // GIR_Coverage, 5277,
     /*  604810 */     GIR_EraseRootFromParent_Done,
     /*  604811 */   // Label 9810: @604811
     /*  604811 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(604883), // Rule ID 5278 //
     /*  604816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604881 */     GIR_RootConstrainSelectedInstOperands,
     /*  604882 */     // GIR_Coverage, 5278,
     /*  604882 */     GIR_EraseRootFromParent_Done,
     /*  604883 */   // Label 9811: @604883
     /*  604883 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(604955), // Rule ID 5279 //
     /*  604888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604953 */     GIR_RootConstrainSelectedInstOperands,
     /*  604954 */     // GIR_Coverage, 5279,
     /*  604954 */     GIR_EraseRootFromParent_Done,
     /*  604955 */   // Label 9812: @604955
     /*  604955 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(605027), // Rule ID 5280 //
     /*  604960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605025 */     GIR_RootConstrainSelectedInstOperands,
     /*  605026 */     // GIR_Coverage, 5280,
     /*  605026 */     GIR_EraseRootFromParent_Done,
     /*  605027 */   // Label 9813: @605027
     /*  605027 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(605099), // Rule ID 5281 //
     /*  605032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  605043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  605046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  605049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  605052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605078 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  605078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605097 */     GIR_RootConstrainSelectedInstOperands,
     /*  605098 */     // GIR_Coverage, 5281,
     /*  605098 */     GIR_EraseRootFromParent_Done,
     /*  605099 */   // Label 9814: @605099
     /*  605099 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(605171), // Rule ID 5282 //
     /*  605104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605150 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605169 */     GIR_RootConstrainSelectedInstOperands,
     /*  605170 */     // GIR_Coverage, 5282,
     /*  605170 */     GIR_EraseRootFromParent_Done,
     /*  605171 */   // Label 9815: @605171
     /*  605171 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(605243), // Rule ID 5283 //
     /*  605176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605241 */     GIR_RootConstrainSelectedInstOperands,
     /*  605242 */     // GIR_Coverage, 5283,
     /*  605242 */     GIR_EraseRootFromParent_Done,
     /*  605243 */   // Label 9816: @605243
     /*  605243 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(605315), // Rule ID 5284 //
     /*  605248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605313 */     GIR_RootConstrainSelectedInstOperands,
     /*  605314 */     // GIR_Coverage, 5284,
     /*  605314 */     GIR_EraseRootFromParent_Done,
     /*  605315 */   // Label 9817: @605315
     /*  605315 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(605387), // Rule ID 5285 //
     /*  605320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605385 */     GIR_RootConstrainSelectedInstOperands,
     /*  605386 */     // GIR_Coverage, 5285,
     /*  605386 */     GIR_EraseRootFromParent_Done,
     /*  605387 */   // Label 9818: @605387
     /*  605387 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(605459), // Rule ID 5286 //
     /*  605392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605457 */     GIR_RootConstrainSelectedInstOperands,
     /*  605458 */     // GIR_Coverage, 5286,
     /*  605458 */     GIR_EraseRootFromParent_Done,
     /*  605459 */   // Label 9819: @605459
     /*  605459 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(605531), // Rule ID 5287 //
     /*  605464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605529 */     GIR_RootConstrainSelectedInstOperands,
     /*  605530 */     // GIR_Coverage, 5287,
     /*  605530 */     GIR_EraseRootFromParent_Done,
     /*  605531 */   // Label 9820: @605531
     /*  605531 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(605603), // Rule ID 5288 //
     /*  605536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605601 */     GIR_RootConstrainSelectedInstOperands,
     /*  605602 */     // GIR_Coverage, 5288,
     /*  605602 */     GIR_EraseRootFromParent_Done,
     /*  605603 */   // Label 9821: @605603
     /*  605603 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(605675), // Rule ID 5289 //
     /*  605608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605673 */     GIR_RootConstrainSelectedInstOperands,
     /*  605674 */     // GIR_Coverage, 5289,
     /*  605674 */     GIR_EraseRootFromParent_Done,
     /*  605675 */   // Label 9822: @605675
     /*  605675 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(605747), // Rule ID 5290 //
     /*  605680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605745 */     GIR_RootConstrainSelectedInstOperands,
     /*  605746 */     // GIR_Coverage, 5290,
     /*  605746 */     GIR_EraseRootFromParent_Done,
     /*  605747 */   // Label 9823: @605747
     /*  605747 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(605819), // Rule ID 5291 //
     /*  605752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605817 */     GIR_RootConstrainSelectedInstOperands,
     /*  605818 */     // GIR_Coverage, 5291,
     /*  605818 */     GIR_EraseRootFromParent_Done,
     /*  605819 */   // Label 9824: @605819
     /*  605819 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(605891), // Rule ID 5292 //
     /*  605824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605889 */     GIR_RootConstrainSelectedInstOperands,
     /*  605890 */     // GIR_Coverage, 5292,
     /*  605890 */     GIR_EraseRootFromParent_Done,
     /*  605891 */   // Label 9825: @605891
     /*  605891 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(605963), // Rule ID 5293 //
     /*  605896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605961 */     GIR_RootConstrainSelectedInstOperands,
     /*  605962 */     // GIR_Coverage, 5293,
     /*  605962 */     GIR_EraseRootFromParent_Done,
     /*  605963 */   // Label 9826: @605963
     /*  605963 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(606035), // Rule ID 5294 //
     /*  605968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  606017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606033 */     GIR_RootConstrainSelectedInstOperands,
     /*  606034 */     // GIR_Coverage, 5294,
     /*  606034 */     GIR_EraseRootFromParent_Done,
     /*  606035 */   // Label 9827: @606035
     /*  606035 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(606107), // Rule ID 5295 //
     /*  606040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  606054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606086 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  606089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606105 */     GIR_RootConstrainSelectedInstOperands,
     /*  606106 */     // GIR_Coverage, 5295,
     /*  606106 */     GIR_EraseRootFromParent_Done,
     /*  606107 */   // Label 9828: @606107
     /*  606107 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(606179), // Rule ID 5296 //
     /*  606112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606177 */     GIR_RootConstrainSelectedInstOperands,
     /*  606178 */     // GIR_Coverage, 5296,
     /*  606178 */     GIR_EraseRootFromParent_Done,
     /*  606179 */   // Label 9829: @606179
     /*  606179 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(606251), // Rule ID 5297 //
     /*  606184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606249 */     GIR_RootConstrainSelectedInstOperands,
     /*  606250 */     // GIR_Coverage, 5297,
     /*  606250 */     GIR_EraseRootFromParent_Done,
     /*  606251 */   // Label 9830: @606251
     /*  606251 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(606323), // Rule ID 5298 //
     /*  606256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606321 */     GIR_RootConstrainSelectedInstOperands,
     /*  606322 */     // GIR_Coverage, 5298,
     /*  606322 */     GIR_EraseRootFromParent_Done,
     /*  606323 */   // Label 9831: @606323
     /*  606323 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(606395), // Rule ID 5299 //
     /*  606328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606393 */     GIR_RootConstrainSelectedInstOperands,
     /*  606394 */     // GIR_Coverage, 5299,
     /*  606394 */     GIR_EraseRootFromParent_Done,
     /*  606395 */   // Label 9832: @606395
     /*  606395 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(606467), // Rule ID 5300 //
     /*  606400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606446 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606465 */     GIR_RootConstrainSelectedInstOperands,
     /*  606466 */     // GIR_Coverage, 5300,
     /*  606466 */     GIR_EraseRootFromParent_Done,
     /*  606467 */   // Label 9833: @606467
     /*  606467 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(606539), // Rule ID 5301 //
     /*  606472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606518 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606537 */     GIR_RootConstrainSelectedInstOperands,
     /*  606538 */     // GIR_Coverage, 5301,
     /*  606538 */     GIR_EraseRootFromParent_Done,
     /*  606539 */   // Label 9834: @606539
     /*  606539 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(606611), // Rule ID 5302 //
     /*  606544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606590 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606609 */     GIR_RootConstrainSelectedInstOperands,
     /*  606610 */     // GIR_Coverage, 5302,
     /*  606610 */     GIR_EraseRootFromParent_Done,
     /*  606611 */   // Label 9835: @606611
     /*  606611 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(606683), // Rule ID 5303 //
     /*  606616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606681 */     GIR_RootConstrainSelectedInstOperands,
     /*  606682 */     // GIR_Coverage, 5303,
     /*  606682 */     GIR_EraseRootFromParent_Done,
     /*  606683 */   // Label 9836: @606683
     /*  606683 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(606755), // Rule ID 5304 //
     /*  606688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606753 */     GIR_RootConstrainSelectedInstOperands,
     /*  606754 */     // GIR_Coverage, 5304,
     /*  606754 */     GIR_EraseRootFromParent_Done,
     /*  606755 */   // Label 9837: @606755
     /*  606755 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(606827), // Rule ID 5305 //
     /*  606760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606806 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606825 */     GIR_RootConstrainSelectedInstOperands,
     /*  606826 */     // GIR_Coverage, 5305,
     /*  606826 */     GIR_EraseRootFromParent_Done,
     /*  606827 */   // Label 9838: @606827
     /*  606827 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(606899), // Rule ID 5306 //
     /*  606832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606897 */     GIR_RootConstrainSelectedInstOperands,
     /*  606898 */     // GIR_Coverage, 5306,
     /*  606898 */     GIR_EraseRootFromParent_Done,
     /*  606899 */   // Label 9839: @606899
     /*  606899 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(606971), // Rule ID 5307 //
     /*  606904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606969 */     GIR_RootConstrainSelectedInstOperands,
     /*  606970 */     // GIR_Coverage, 5307,
     /*  606970 */     GIR_EraseRootFromParent_Done,
     /*  606971 */   // Label 9840: @606971
     /*  606971 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(607043), // Rule ID 5308 //
     /*  606976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607041 */     GIR_RootConstrainSelectedInstOperands,
     /*  607042 */     // GIR_Coverage, 5308,
     /*  607042 */     GIR_EraseRootFromParent_Done,
     /*  607043 */   // Label 9841: @607043
     /*  607043 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(607115), // Rule ID 5309 //
     /*  607048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607113 */     GIR_RootConstrainSelectedInstOperands,
     /*  607114 */     // GIR_Coverage, 5309,
     /*  607114 */     GIR_EraseRootFromParent_Done,
     /*  607115 */   // Label 9842: @607115
     /*  607115 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(607187), // Rule ID 5310 //
     /*  607120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607185 */     GIR_RootConstrainSelectedInstOperands,
     /*  607186 */     // GIR_Coverage, 5310,
     /*  607186 */     GIR_EraseRootFromParent_Done,
     /*  607187 */   // Label 9843: @607187
     /*  607187 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(607259), // Rule ID 5311 //
     /*  607192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607257 */     GIR_RootConstrainSelectedInstOperands,
     /*  607258 */     // GIR_Coverage, 5311,
     /*  607258 */     GIR_EraseRootFromParent_Done,
     /*  607259 */   // Label 9844: @607259
     /*  607259 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(607331), // Rule ID 5312 //
     /*  607264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607329 */     GIR_RootConstrainSelectedInstOperands,
     /*  607330 */     // GIR_Coverage, 5312,
     /*  607330 */     GIR_EraseRootFromParent_Done,
     /*  607331 */   // Label 9845: @607331
     /*  607331 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(607403), // Rule ID 5313 //
     /*  607336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  607385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607401 */     GIR_RootConstrainSelectedInstOperands,
     /*  607402 */     // GIR_Coverage, 5313,
     /*  607402 */     GIR_EraseRootFromParent_Done,
     /*  607403 */   // Label 9846: @607403
     /*  607403 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(607475), // Rule ID 5314 //
     /*  607408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607454 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607473 */     GIR_RootConstrainSelectedInstOperands,
     /*  607474 */     // GIR_Coverage, 5314,
     /*  607474 */     GIR_EraseRootFromParent_Done,
     /*  607475 */   // Label 9847: @607475
     /*  607475 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(607547), // Rule ID 5315 //
     /*  607480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607545 */     GIR_RootConstrainSelectedInstOperands,
     /*  607546 */     // GIR_Coverage, 5315,
     /*  607546 */     GIR_EraseRootFromParent_Done,
     /*  607547 */   // Label 9848: @607547
     /*  607547 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(607619), // Rule ID 5316 //
     /*  607552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607617 */     GIR_RootConstrainSelectedInstOperands,
     /*  607618 */     // GIR_Coverage, 5316,
     /*  607618 */     GIR_EraseRootFromParent_Done,
     /*  607619 */   // Label 9849: @607619
     /*  607619 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(607691), // Rule ID 5317 //
     /*  607624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607670 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607689 */     GIR_RootConstrainSelectedInstOperands,
     /*  607690 */     // GIR_Coverage, 5317,
     /*  607690 */     GIR_EraseRootFromParent_Done,
     /*  607691 */   // Label 9850: @607691
     /*  607691 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(607763), // Rule ID 5318 //
     /*  607696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607742 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607761 */     GIR_RootConstrainSelectedInstOperands,
     /*  607762 */     // GIR_Coverage, 5318,
     /*  607762 */     GIR_EraseRootFromParent_Done,
     /*  607763 */   // Label 9851: @607763
     /*  607763 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(607835), // Rule ID 5319 //
     /*  607768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607814 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607833 */     GIR_RootConstrainSelectedInstOperands,
     /*  607834 */     // GIR_Coverage, 5319,
     /*  607834 */     GIR_EraseRootFromParent_Done,
     /*  607835 */   // Label 9852: @607835
     /*  607835 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(607907), // Rule ID 5320 //
     /*  607840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607886 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607905 */     GIR_RootConstrainSelectedInstOperands,
     /*  607906 */     // GIR_Coverage, 5320,
     /*  607906 */     GIR_EraseRootFromParent_Done,
     /*  607907 */   // Label 9853: @607907
     /*  607907 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(607979), // Rule ID 5321 //
     /*  607912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607977 */     GIR_RootConstrainSelectedInstOperands,
     /*  607978 */     // GIR_Coverage, 5321,
     /*  607978 */     GIR_EraseRootFromParent_Done,
     /*  607979 */   // Label 9854: @607979
     /*  607979 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(608051), // Rule ID 5322 //
     /*  607984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608049 */     GIR_RootConstrainSelectedInstOperands,
     /*  608050 */     // GIR_Coverage, 5322,
     /*  608050 */     GIR_EraseRootFromParent_Done,
     /*  608051 */   // Label 9855: @608051
     /*  608051 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(608123), // Rule ID 5323 //
     /*  608056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608121 */     GIR_RootConstrainSelectedInstOperands,
     /*  608122 */     // GIR_Coverage, 5323,
     /*  608122 */     GIR_EraseRootFromParent_Done,
     /*  608123 */   // Label 9856: @608123
     /*  608123 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(608195), // Rule ID 5324 //
     /*  608128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608193 */     GIR_RootConstrainSelectedInstOperands,
     /*  608194 */     // GIR_Coverage, 5324,
     /*  608194 */     GIR_EraseRootFromParent_Done,
     /*  608195 */   // Label 9857: @608195
     /*  608195 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(608267), // Rule ID 5325 //
     /*  608200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608246 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608265 */     GIR_RootConstrainSelectedInstOperands,
     /*  608266 */     // GIR_Coverage, 5325,
     /*  608266 */     GIR_EraseRootFromParent_Done,
     /*  608267 */   // Label 9858: @608267
     /*  608267 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(608339), // Rule ID 5326 //
     /*  608272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608337 */     GIR_RootConstrainSelectedInstOperands,
     /*  608338 */     // GIR_Coverage, 5326,
     /*  608338 */     GIR_EraseRootFromParent_Done,
     /*  608339 */   // Label 9859: @608339
     /*  608339 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(608411), // Rule ID 5327 //
     /*  608344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608409 */     GIR_RootConstrainSelectedInstOperands,
     /*  608410 */     // GIR_Coverage, 5327,
     /*  608410 */     GIR_EraseRootFromParent_Done,
     /*  608411 */   // Label 9860: @608411
     /*  608411 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(608483), // Rule ID 5328 //
     /*  608416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608481 */     GIR_RootConstrainSelectedInstOperands,
     /*  608482 */     // GIR_Coverage, 5328,
     /*  608482 */     GIR_EraseRootFromParent_Done,
     /*  608483 */   // Label 9861: @608483
     /*  608483 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(608555), // Rule ID 5329 //
     /*  608488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608553 */     GIR_RootConstrainSelectedInstOperands,
     /*  608554 */     // GIR_Coverage, 5329,
     /*  608554 */     GIR_EraseRootFromParent_Done,
     /*  608555 */   // Label 9862: @608555
     /*  608555 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(608627), // Rule ID 5330 //
     /*  608560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608625 */     GIR_RootConstrainSelectedInstOperands,
     /*  608626 */     // GIR_Coverage, 5330,
     /*  608626 */     GIR_EraseRootFromParent_Done,
     /*  608627 */   // Label 9863: @608627
     /*  608627 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(608699), // Rule ID 5331 //
     /*  608632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608697 */     GIR_RootConstrainSelectedInstOperands,
     /*  608698 */     // GIR_Coverage, 5331,
     /*  608698 */     GIR_EraseRootFromParent_Done,
     /*  608699 */   // Label 9864: @608699
     /*  608699 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(608771), // Rule ID 5332 //
     /*  608704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608769 */     GIR_RootConstrainSelectedInstOperands,
     /*  608770 */     // GIR_Coverage, 5332,
     /*  608770 */     GIR_EraseRootFromParent_Done,
     /*  608771 */   // Label 9865: @608771
     /*  608771 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(608843), // Rule ID 5333 //
     /*  608776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608841 */     GIR_RootConstrainSelectedInstOperands,
     /*  608842 */     // GIR_Coverage, 5333,
     /*  608842 */     GIR_EraseRootFromParent_Done,
     /*  608843 */   // Label 9866: @608843
     /*  608843 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(608915), // Rule ID 5334 //
     /*  608848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608894 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608913 */     GIR_RootConstrainSelectedInstOperands,
     /*  608914 */     // GIR_Coverage, 5334,
     /*  608914 */     GIR_EraseRootFromParent_Done,
     /*  608915 */   // Label 9867: @608915
     /*  608915 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(608987), // Rule ID 5335 //
     /*  608920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608985 */     GIR_RootConstrainSelectedInstOperands,
     /*  608986 */     // GIR_Coverage, 5335,
     /*  608986 */     GIR_EraseRootFromParent_Done,
     /*  608987 */   // Label 9868: @608987
     /*  608987 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(609059), // Rule ID 5336 //
     /*  608992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609038 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  609041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609057 */     GIR_RootConstrainSelectedInstOperands,
     /*  609058 */     // GIR_Coverage, 5336,
     /*  609058 */     GIR_EraseRootFromParent_Done,
     /*  609059 */   // Label 9869: @609059
     /*  609059 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(609131), // Rule ID 5337 //
     /*  609064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  609113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609129 */     GIR_RootConstrainSelectedInstOperands,
     /*  609130 */     // GIR_Coverage, 5337,
     /*  609130 */     GIR_EraseRootFromParent_Done,
     /*  609131 */   // Label 9870: @609131
     /*  609131 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(609203), // Rule ID 5600 //
     /*  609136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  609153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  609185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609201 */     GIR_RootConstrainSelectedInstOperands,
     /*  609202 */     // GIR_Coverage, 5600,
     /*  609202 */     GIR_EraseRootFromParent_Done,
     /*  609203 */   // Label 9871: @609203
     /*  609203 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(609275), // Rule ID 5601 //
     /*  609208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  609225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  609257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609273 */     GIR_RootConstrainSelectedInstOperands,
     /*  609274 */     // GIR_Coverage, 5601,
     /*  609274 */     GIR_EraseRootFromParent_Done,
     /*  609275 */   // Label 9872: @609275
     /*  609275 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(609347), // Rule ID 5602 //
     /*  609280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  609297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609345 */     GIR_RootConstrainSelectedInstOperands,
     /*  609346 */     // GIR_Coverage, 5602,
     /*  609346 */     GIR_EraseRootFromParent_Done,
     /*  609347 */   // Label 9873: @609347
     /*  609347 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(609419), // Rule ID 5603 //
     /*  609352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  609369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609398 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609417 */     GIR_RootConstrainSelectedInstOperands,
     /*  609418 */     // GIR_Coverage, 5603,
     /*  609418 */     GIR_EraseRootFromParent_Done,
     /*  609419 */   // Label 9874: @609419
     /*  609419 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(609491), // Rule ID 5604 //
     /*  609424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609489 */     GIR_RootConstrainSelectedInstOperands,
     /*  609490 */     // GIR_Coverage, 5604,
     /*  609490 */     GIR_EraseRootFromParent_Done,
     /*  609491 */   // Label 9875: @609491
     /*  609491 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(609563), // Rule ID 5605 //
     /*  609496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609542 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609561 */     GIR_RootConstrainSelectedInstOperands,
     /*  609562 */     // GIR_Coverage, 5605,
     /*  609562 */     GIR_EraseRootFromParent_Done,
     /*  609563 */   // Label 9876: @609563
     /*  609563 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(609635), // Rule ID 5606 //
     /*  609568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609614 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609633 */     GIR_RootConstrainSelectedInstOperands,
     /*  609634 */     // GIR_Coverage, 5606,
     /*  609634 */     GIR_EraseRootFromParent_Done,
     /*  609635 */   // Label 9877: @609635
     /*  609635 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(609707), // Rule ID 5607 //
     /*  609640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609705 */     GIR_RootConstrainSelectedInstOperands,
     /*  609706 */     // GIR_Coverage, 5607,
     /*  609706 */     GIR_EraseRootFromParent_Done,
     /*  609707 */   // Label 9878: @609707
     /*  609707 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(609779), // Rule ID 5608 //
     /*  609712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609777 */     GIR_RootConstrainSelectedInstOperands,
     /*  609778 */     // GIR_Coverage, 5608,
     /*  609778 */     GIR_EraseRootFromParent_Done,
     /*  609779 */   // Label 9879: @609779
     /*  609779 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(609851), // Rule ID 5609 //
     /*  609784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609849 */     GIR_RootConstrainSelectedInstOperands,
     /*  609850 */     // GIR_Coverage, 5609,
     /*  609850 */     GIR_EraseRootFromParent_Done,
     /*  609851 */   // Label 9880: @609851
     /*  609851 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(609923), // Rule ID 5610 //
     /*  609856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609921 */     GIR_RootConstrainSelectedInstOperands,
     /*  609922 */     // GIR_Coverage, 5610,
     /*  609922 */     GIR_EraseRootFromParent_Done,
     /*  609923 */   // Label 9881: @609923
     /*  609923 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(609995), // Rule ID 5611 //
     /*  609928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609993 */     GIR_RootConstrainSelectedInstOperands,
     /*  609994 */     // GIR_Coverage, 5611,
     /*  609994 */     GIR_EraseRootFromParent_Done,
     /*  609995 */   // Label 9882: @609995
     /*  609995 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(610067), // Rule ID 5612 //
     /*  610000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  610017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610065 */     GIR_RootConstrainSelectedInstOperands,
     /*  610066 */     // GIR_Coverage, 5612,
     /*  610066 */     GIR_EraseRootFromParent_Done,
     /*  610067 */   // Label 9883: @610067
     /*  610067 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(610139), // Rule ID 5613 //
     /*  610072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  610089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610137 */     GIR_RootConstrainSelectedInstOperands,
     /*  610138 */     // GIR_Coverage, 5613,
     /*  610138 */     GIR_EraseRootFromParent_Done,
     /*  610139 */   // Label 9884: @610139
     /*  610139 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(610211), // Rule ID 5614 //
     /*  610144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  610161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610209 */     GIR_RootConstrainSelectedInstOperands,
     /*  610210 */     // GIR_Coverage, 5614,
     /*  610210 */     GIR_EraseRootFromParent_Done,
     /*  610211 */   // Label 9885: @610211
     /*  610211 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(610283), // Rule ID 5615 //
     /*  610216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  610233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610281 */     GIR_RootConstrainSelectedInstOperands,
     /*  610282 */     // GIR_Coverage, 5615,
     /*  610282 */     GIR_EraseRootFromParent_Done,
     /*  610283 */   // Label 9886: @610283
     /*  610283 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(610355), // Rule ID 5616 //
     /*  610288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  610305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610353 */     GIR_RootConstrainSelectedInstOperands,
     /*  610354 */     // GIR_Coverage, 5616,
     /*  610354 */     GIR_EraseRootFromParent_Done,
     /*  610355 */   // Label 9887: @610355
     /*  610355 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(610427), // Rule ID 5617 //
     /*  610360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  610377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610425 */     GIR_RootConstrainSelectedInstOperands,
     /*  610426 */     // GIR_Coverage, 5617,
     /*  610426 */     GIR_EraseRootFromParent_Done,
     /*  610427 */   // Label 9888: @610427
     /*  610427 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(610499), // Rule ID 5618 //
     /*  610432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  610435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610497 */     GIR_RootConstrainSelectedInstOperands,
     /*  610498 */     // GIR_Coverage, 5618,
     /*  610498 */     GIR_EraseRootFromParent_Done,
     /*  610499 */   // Label 9889: @610499
     /*  610499 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(610571), // Rule ID 5619 //
     /*  610504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610569 */     GIR_RootConstrainSelectedInstOperands,
     /*  610570 */     // GIR_Coverage, 5619,
     /*  610570 */     GIR_EraseRootFromParent_Done,
     /*  610571 */   // Label 9890: @610571
     /*  610571 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(610643), // Rule ID 5620 //
     /*  610576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610641 */     GIR_RootConstrainSelectedInstOperands,
     /*  610642 */     // GIR_Coverage, 5620,
     /*  610642 */     GIR_EraseRootFromParent_Done,
     /*  610643 */   // Label 9891: @610643
     /*  610643 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(610715), // Rule ID 5621 //
     /*  610648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610694 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610713 */     GIR_RootConstrainSelectedInstOperands,
     /*  610714 */     // GIR_Coverage, 5621,
     /*  610714 */     GIR_EraseRootFromParent_Done,
     /*  610715 */   // Label 9892: @610715
     /*  610715 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(610787), // Rule ID 5622 //
     /*  610720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610766 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610785 */     GIR_RootConstrainSelectedInstOperands,
     /*  610786 */     // GIR_Coverage, 5622,
     /*  610786 */     GIR_EraseRootFromParent_Done,
     /*  610787 */   // Label 9893: @610787
     /*  610787 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(610859), // Rule ID 5623 //
     /*  610792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610838 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610857 */     GIR_RootConstrainSelectedInstOperands,
     /*  610858 */     // GIR_Coverage, 5623,
     /*  610858 */     GIR_EraseRootFromParent_Done,
     /*  610859 */   // Label 9894: @610859
     /*  610859 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(610931), // Rule ID 5624 //
     /*  610864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610910 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610929 */     GIR_RootConstrainSelectedInstOperands,
     /*  610930 */     // GIR_Coverage, 5624,
     /*  610930 */     GIR_EraseRootFromParent_Done,
     /*  610931 */   // Label 9895: @610931
     /*  610931 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(611003), // Rule ID 5625 //
     /*  610936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610982 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611001 */     GIR_RootConstrainSelectedInstOperands,
     /*  611002 */     // GIR_Coverage, 5625,
     /*  611002 */     GIR_EraseRootFromParent_Done,
     /*  611003 */   // Label 9896: @611003
     /*  611003 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(611075), // Rule ID 5626 //
     /*  611008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  611025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611073 */     GIR_RootConstrainSelectedInstOperands,
     /*  611074 */     // GIR_Coverage, 5626,
     /*  611074 */     GIR_EraseRootFromParent_Done,
     /*  611075 */   // Label 9897: @611075
     /*  611075 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(611147), // Rule ID 5627 //
     /*  611080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  611097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611145 */     GIR_RootConstrainSelectedInstOperands,
     /*  611146 */     // GIR_Coverage, 5627,
     /*  611146 */     GIR_EraseRootFromParent_Done,
     /*  611147 */   // Label 9898: @611147
     /*  611147 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(611219), // Rule ID 5628 //
     /*  611152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  611169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611217 */     GIR_RootConstrainSelectedInstOperands,
     /*  611218 */     // GIR_Coverage, 5628,
     /*  611218 */     GIR_EraseRootFromParent_Done,
     /*  611219 */   // Label 9899: @611219
     /*  611219 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(611291), // Rule ID 5629 //
     /*  611224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  611241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611270 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611289 */     GIR_RootConstrainSelectedInstOperands,
     /*  611290 */     // GIR_Coverage, 5629,
     /*  611290 */     GIR_EraseRootFromParent_Done,
     /*  611291 */   // Label 9900: @611291
     /*  611291 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(611363), // Rule ID 5630 //
     /*  611296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  611313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611342 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611361 */     GIR_RootConstrainSelectedInstOperands,
     /*  611362 */     // GIR_Coverage, 5630,
     /*  611362 */     GIR_EraseRootFromParent_Done,
     /*  611363 */   // Label 9901: @611363
     /*  611363 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(611435), // Rule ID 5631 //
     /*  611368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  611385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611414 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611433 */     GIR_RootConstrainSelectedInstOperands,
     /*  611434 */     // GIR_Coverage, 5631,
     /*  611434 */     GIR_EraseRootFromParent_Done,
     /*  611435 */   // Label 9902: @611435
     /*  611435 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(611507), // Rule ID 5632 //
     /*  611440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611486 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611505 */     GIR_RootConstrainSelectedInstOperands,
     /*  611506 */     // GIR_Coverage, 5632,
     /*  611506 */     GIR_EraseRootFromParent_Done,
     /*  611507 */   // Label 9903: @611507
     /*  611507 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(611579), // Rule ID 5633 //
     /*  611512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611577 */     GIR_RootConstrainSelectedInstOperands,
     /*  611578 */     // GIR_Coverage, 5633,
     /*  611578 */     GIR_EraseRootFromParent_Done,
     /*  611579 */   // Label 9904: @611579
     /*  611579 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(611651), // Rule ID 5634 //
     /*  611584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611649 */     GIR_RootConstrainSelectedInstOperands,
     /*  611650 */     // GIR_Coverage, 5634,
     /*  611650 */     GIR_EraseRootFromParent_Done,
     /*  611651 */   // Label 9905: @611651
     /*  611651 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(611723), // Rule ID 5635 //
     /*  611656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611721 */     GIR_RootConstrainSelectedInstOperands,
     /*  611722 */     // GIR_Coverage, 5635,
     /*  611722 */     GIR_EraseRootFromParent_Done,
     /*  611723 */   // Label 9906: @611723
     /*  611723 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(611795), // Rule ID 5636 //
     /*  611728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611793 */     GIR_RootConstrainSelectedInstOperands,
     /*  611794 */     // GIR_Coverage, 5636,
     /*  611794 */     GIR_EraseRootFromParent_Done,
     /*  611795 */   // Label 9907: @611795
     /*  611795 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(611867), // Rule ID 5637 //
     /*  611800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611846 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611865 */     GIR_RootConstrainSelectedInstOperands,
     /*  611866 */     // GIR_Coverage, 5637,
     /*  611866 */     GIR_EraseRootFromParent_Done,
     /*  611867 */   // Label 9908: @611867
     /*  611867 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(611939), // Rule ID 5638 //
     /*  611872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611918 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611937 */     GIR_RootConstrainSelectedInstOperands,
     /*  611938 */     // GIR_Coverage, 5638,
     /*  611938 */     GIR_EraseRootFromParent_Done,
     /*  611939 */   // Label 9909: @611939
     /*  611939 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(612011), // Rule ID 5639 //
     /*  611944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612009 */     GIR_RootConstrainSelectedInstOperands,
     /*  612010 */     // GIR_Coverage, 5639,
     /*  612010 */     GIR_EraseRootFromParent_Done,
     /*  612011 */   // Label 9910: @612011
     /*  612011 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(612083), // Rule ID 5640 //
     /*  612016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  612033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  612065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612081 */     GIR_RootConstrainSelectedInstOperands,
     /*  612082 */     // GIR_Coverage, 5640,
     /*  612082 */     GIR_EraseRootFromParent_Done,
     /*  612083 */   // Label 9911: @612083
     /*  612083 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(612155), // Rule ID 5641 //
     /*  612088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  612105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  612137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612153 */     GIR_RootConstrainSelectedInstOperands,
     /*  612154 */     // GIR_Coverage, 5641,
     /*  612154 */     GIR_EraseRootFromParent_Done,
     /*  612155 */   // Label 9912: @612155
     /*  612155 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(612227), // Rule ID 5642 //
     /*  612160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  612177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  612209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612225 */     GIR_RootConstrainSelectedInstOperands,
     /*  612226 */     // GIR_Coverage, 5642,
     /*  612226 */     GIR_EraseRootFromParent_Done,
     /*  612227 */   // Label 9913: @612227
     /*  612227 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(612299), // Rule ID 5643 //
     /*  612232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  612249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  612281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612297 */     GIR_RootConstrainSelectedInstOperands,
     /*  612298 */     // GIR_Coverage, 5643,
     /*  612298 */     GIR_EraseRootFromParent_Done,
     /*  612299 */   // Label 9914: @612299
     /*  612299 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(612371), // Rule ID 5644 //
     /*  612304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  612353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612369 */     GIR_RootConstrainSelectedInstOperands,
     /*  612370 */     // GIR_Coverage, 5644,
     /*  612370 */     GIR_EraseRootFromParent_Done,
     /*  612371 */   // Label 9915: @612371
     /*  612371 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(612443), // Rule ID 5645 //
     /*  612376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612422 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  612425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612441 */     GIR_RootConstrainSelectedInstOperands,
     /*  612442 */     // GIR_Coverage, 5645,
     /*  612442 */     GIR_EraseRootFromParent_Done,
     /*  612443 */   // Label 9916: @612443
     /*  612443 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(612515), // Rule ID 5646 //
     /*  612448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612513 */     GIR_RootConstrainSelectedInstOperands,
     /*  612514 */     // GIR_Coverage, 5646,
     /*  612514 */     GIR_EraseRootFromParent_Done,
     /*  612515 */   // Label 9917: @612515
     /*  612515 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(612587), // Rule ID 5647 //
     /*  612520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612585 */     GIR_RootConstrainSelectedInstOperands,
     /*  612586 */     // GIR_Coverage, 5647,
     /*  612586 */     GIR_EraseRootFromParent_Done,
     /*  612587 */   // Label 9918: @612587
     /*  612587 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(612659), // Rule ID 5648 //
     /*  612592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612657 */     GIR_RootConstrainSelectedInstOperands,
     /*  612658 */     // GIR_Coverage, 5648,
     /*  612658 */     GIR_EraseRootFromParent_Done,
     /*  612659 */   // Label 9919: @612659
     /*  612659 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(612731), // Rule ID 5649 //
     /*  612664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612729 */     GIR_RootConstrainSelectedInstOperands,
     /*  612730 */     // GIR_Coverage, 5649,
     /*  612730 */     GIR_EraseRootFromParent_Done,
     /*  612731 */   // Label 9920: @612731
     /*  612731 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(612803), // Rule ID 5650 //
     /*  612736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612801 */     GIR_RootConstrainSelectedInstOperands,
     /*  612802 */     // GIR_Coverage, 5650,
     /*  612802 */     GIR_EraseRootFromParent_Done,
     /*  612803 */   // Label 9921: @612803
     /*  612803 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(612875), // Rule ID 5651 //
     /*  612808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612873 */     GIR_RootConstrainSelectedInstOperands,
     /*  612874 */     // GIR_Coverage, 5651,
     /*  612874 */     GIR_EraseRootFromParent_Done,
     /*  612875 */   // Label 9922: @612875
     /*  612875 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(612947), // Rule ID 5652 //
     /*  612880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612945 */     GIR_RootConstrainSelectedInstOperands,
     /*  612946 */     // GIR_Coverage, 5652,
     /*  612946 */     GIR_EraseRootFromParent_Done,
     /*  612947 */   // Label 9923: @612947
     /*  612947 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(613019), // Rule ID 5653 //
     /*  612952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613017 */     GIR_RootConstrainSelectedInstOperands,
     /*  613018 */     // GIR_Coverage, 5653,
     /*  613018 */     GIR_EraseRootFromParent_Done,
     /*  613019 */   // Label 9924: @613019
     /*  613019 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(613091), // Rule ID 5654 //
     /*  613024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613089 */     GIR_RootConstrainSelectedInstOperands,
     /*  613090 */     // GIR_Coverage, 5654,
     /*  613090 */     GIR_EraseRootFromParent_Done,
     /*  613091 */   // Label 9925: @613091
     /*  613091 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(613163), // Rule ID 5655 //
     /*  613096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  613145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613161 */     GIR_RootConstrainSelectedInstOperands,
     /*  613162 */     // GIR_Coverage, 5655,
     /*  613162 */     GIR_EraseRootFromParent_Done,
     /*  613163 */   // Label 9926: @613163
     /*  613163 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(613235), // Rule ID 5656 //
     /*  613168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613214 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613233 */     GIR_RootConstrainSelectedInstOperands,
     /*  613234 */     // GIR_Coverage, 5656,
     /*  613234 */     GIR_EraseRootFromParent_Done,
     /*  613235 */   // Label 9927: @613235
     /*  613235 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(613307), // Rule ID 5657 //
     /*  613240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613286 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613305 */     GIR_RootConstrainSelectedInstOperands,
     /*  613306 */     // GIR_Coverage, 5657,
     /*  613306 */     GIR_EraseRootFromParent_Done,
     /*  613307 */   // Label 9928: @613307
     /*  613307 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(613379), // Rule ID 5658 //
     /*  613312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613377 */     GIR_RootConstrainSelectedInstOperands,
     /*  613378 */     // GIR_Coverage, 5658,
     /*  613378 */     GIR_EraseRootFromParent_Done,
     /*  613379 */   // Label 9929: @613379
     /*  613379 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(613451), // Rule ID 5659 //
     /*  613384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613449 */     GIR_RootConstrainSelectedInstOperands,
     /*  613450 */     // GIR_Coverage, 5659,
     /*  613450 */     GIR_EraseRootFromParent_Done,
     /*  613451 */   // Label 9930: @613451
     /*  613451 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(613523), // Rule ID 5660 //
     /*  613456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613521 */     GIR_RootConstrainSelectedInstOperands,
     /*  613522 */     // GIR_Coverage, 5660,
     /*  613522 */     GIR_EraseRootFromParent_Done,
     /*  613523 */   // Label 9931: @613523
     /*  613523 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(613595), // Rule ID 5661 //
     /*  613528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613593 */     GIR_RootConstrainSelectedInstOperands,
     /*  613594 */     // GIR_Coverage, 5661,
     /*  613594 */     GIR_EraseRootFromParent_Done,
     /*  613595 */   // Label 9932: @613595
     /*  613595 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(613667), // Rule ID 5662 //
     /*  613600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613665 */     GIR_RootConstrainSelectedInstOperands,
     /*  613666 */     // GIR_Coverage, 5662,
     /*  613666 */     GIR_EraseRootFromParent_Done,
     /*  613667 */   // Label 9933: @613667
     /*  613667 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(613739), // Rule ID 5663 //
     /*  613672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613718 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613737 */     GIR_RootConstrainSelectedInstOperands,
     /*  613738 */     // GIR_Coverage, 5663,
     /*  613738 */     GIR_EraseRootFromParent_Done,
     /*  613739 */   // Label 9934: @613739
     /*  613739 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(613811), // Rule ID 5664 //
     /*  613744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613809 */     GIR_RootConstrainSelectedInstOperands,
     /*  613810 */     // GIR_Coverage, 5664,
     /*  613810 */     GIR_EraseRootFromParent_Done,
     /*  613811 */   // Label 9935: @613811
     /*  613811 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(613883), // Rule ID 5665 //
     /*  613816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613881 */     GIR_RootConstrainSelectedInstOperands,
     /*  613882 */     // GIR_Coverage, 5665,
     /*  613882 */     GIR_EraseRootFromParent_Done,
     /*  613883 */   // Label 9936: @613883
     /*  613883 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(613955), // Rule ID 5666 //
     /*  613888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613934 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613953 */     GIR_RootConstrainSelectedInstOperands,
     /*  613954 */     // GIR_Coverage, 5666,
     /*  613954 */     GIR_EraseRootFromParent_Done,
     /*  613955 */   // Label 9937: @613955
     /*  613955 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(614027), // Rule ID 5667 //
     /*  613960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614025 */     GIR_RootConstrainSelectedInstOperands,
     /*  614026 */     // GIR_Coverage, 5667,
     /*  614026 */     GIR_EraseRootFromParent_Done,
     /*  614027 */   // Label 9938: @614027
     /*  614027 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(614099), // Rule ID 5668 //
     /*  614032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614078 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614097 */     GIR_RootConstrainSelectedInstOperands,
     /*  614098 */     // GIR_Coverage, 5668,
     /*  614098 */     GIR_EraseRootFromParent_Done,
     /*  614099 */   // Label 9939: @614099
     /*  614099 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(614171), // Rule ID 5669 //
     /*  614104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614150 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614169 */     GIR_RootConstrainSelectedInstOperands,
     /*  614170 */     // GIR_Coverage, 5669,
     /*  614170 */     GIR_EraseRootFromParent_Done,
     /*  614171 */   // Label 9940: @614171
     /*  614171 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(614243), // Rule ID 5670 //
     /*  614176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614241 */     GIR_RootConstrainSelectedInstOperands,
     /*  614242 */     // GIR_Coverage, 5670,
     /*  614242 */     GIR_EraseRootFromParent_Done,
     /*  614243 */   // Label 9941: @614243
     /*  614243 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(614315), // Rule ID 5671 //
     /*  614248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614313 */     GIR_RootConstrainSelectedInstOperands,
     /*  614314 */     // GIR_Coverage, 5671,
     /*  614314 */     GIR_EraseRootFromParent_Done,
     /*  614315 */   // Label 9942: @614315
     /*  614315 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(614387), // Rule ID 5672 //
     /*  614320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614385 */     GIR_RootConstrainSelectedInstOperands,
     /*  614386 */     // GIR_Coverage, 5672,
     /*  614386 */     GIR_EraseRootFromParent_Done,
     /*  614387 */   // Label 9943: @614387
     /*  614387 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(614459), // Rule ID 5673 //
     /*  614392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614457 */     GIR_RootConstrainSelectedInstOperands,
     /*  614458 */     // GIR_Coverage, 5673,
     /*  614458 */     GIR_EraseRootFromParent_Done,
     /*  614459 */   // Label 9944: @614459
     /*  614459 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(614531), // Rule ID 5674 //
     /*  614464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614529 */     GIR_RootConstrainSelectedInstOperands,
     /*  614530 */     // GIR_Coverage, 5674,
     /*  614530 */     GIR_EraseRootFromParent_Done,
     /*  614531 */   // Label 9945: @614531
     /*  614531 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(614603), // Rule ID 5675 //
     /*  614536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614601 */     GIR_RootConstrainSelectedInstOperands,
     /*  614602 */     // GIR_Coverage, 5675,
     /*  614602 */     GIR_EraseRootFromParent_Done,
     /*  614603 */   // Label 9946: @614603
     /*  614603 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(614675), // Rule ID 5676 //
     /*  614608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614673 */     GIR_RootConstrainSelectedInstOperands,
     /*  614674 */     // GIR_Coverage, 5676,
     /*  614674 */     GIR_EraseRootFromParent_Done,
     /*  614675 */   // Label 9947: @614675
     /*  614675 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(614747), // Rule ID 5677 //
     /*  614680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614745 */     GIR_RootConstrainSelectedInstOperands,
     /*  614746 */     // GIR_Coverage, 5677,
     /*  614746 */     GIR_EraseRootFromParent_Done,
     /*  614747 */   // Label 9948: @614747
     /*  614747 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(614819), // Rule ID 5678 //
     /*  614752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614817 */     GIR_RootConstrainSelectedInstOperands,
     /*  614818 */     // GIR_Coverage, 5678,
     /*  614818 */     GIR_EraseRootFromParent_Done,
     /*  614819 */   // Label 9949: @614819
     /*  614819 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(614891), // Rule ID 5679 //
     /*  614824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614889 */     GIR_RootConstrainSelectedInstOperands,
     /*  614890 */     // GIR_Coverage, 5679,
     /*  614890 */     GIR_EraseRootFromParent_Done,
     /*  614891 */   // Label 9950: @614891
     /*  614891 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(614963), // Rule ID 5680 //
     /*  614896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614961 */     GIR_RootConstrainSelectedInstOperands,
     /*  614962 */     // GIR_Coverage, 5680,
     /*  614962 */     GIR_EraseRootFromParent_Done,
     /*  614963 */   // Label 9951: @614963
     /*  614963 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(615035), // Rule ID 5681 //
     /*  614968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615014 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615033 */     GIR_RootConstrainSelectedInstOperands,
     /*  615034 */     // GIR_Coverage, 5681,
     /*  615034 */     GIR_EraseRootFromParent_Done,
     /*  615035 */   // Label 9952: @615035
     /*  615035 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(615107), // Rule ID 5682 //
     /*  615040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  615089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615105 */     GIR_RootConstrainSelectedInstOperands,
     /*  615106 */     // GIR_Coverage, 5682,
     /*  615106 */     GIR_EraseRootFromParent_Done,
     /*  615107 */   // Label 9953: @615107
     /*  615107 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(615179), // Rule ID 5683 //
     /*  615112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615158 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  615161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615177 */     GIR_RootConstrainSelectedInstOperands,
     /*  615178 */     // GIR_Coverage, 5683,
     /*  615178 */     GIR_EraseRootFromParent_Done,
     /*  615179 */   // Label 9954: @615179
     /*  615179 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(615251), // Rule ID 5684 //
     /*  615184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  615233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615249 */     GIR_RootConstrainSelectedInstOperands,
     /*  615250 */     // GIR_Coverage, 5684,
     /*  615250 */     GIR_EraseRootFromParent_Done,
     /*  615251 */   // Label 9955: @615251
     /*  615251 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(615323), // Rule ID 5685 //
     /*  615256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615302 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  615305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615321 */     GIR_RootConstrainSelectedInstOperands,
     /*  615322 */     // GIR_Coverage, 5685,
     /*  615322 */     GIR_EraseRootFromParent_Done,
     /*  615323 */   // Label 9956: @615323
     /*  615323 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(615395), // Rule ID 5686 //
     /*  615328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615374 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615393 */     GIR_RootConstrainSelectedInstOperands,
     /*  615394 */     // GIR_Coverage, 5686,
     /*  615394 */     GIR_EraseRootFromParent_Done,
     /*  615395 */   // Label 9957: @615395
     /*  615395 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(615467), // Rule ID 5687 //
     /*  615400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  615449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615465 */     GIR_RootConstrainSelectedInstOperands,
     /*  615466 */     // GIR_Coverage, 5687,
     /*  615466 */     GIR_EraseRootFromParent_Done,
     /*  615467 */   // Label 9958: @615467
     /*  615467 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(615542), // Rule ID 5776 //
     /*  615472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615540 */     GIR_RootConstrainSelectedInstOperands,
     /*  615541 */     // GIR_Coverage, 5776,
     /*  615541 */     GIR_EraseRootFromParent_Done,
     /*  615542 */   // Label 9959: @615542
     /*  615542 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(615617), // Rule ID 5777 //
     /*  615547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615615 */     GIR_RootConstrainSelectedInstOperands,
     /*  615616 */     // GIR_Coverage, 5777,
     /*  615616 */     GIR_EraseRootFromParent_Done,
     /*  615617 */   // Label 9960: @615617
     /*  615617 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(615692), // Rule ID 5780 //
     /*  615622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615690 */     GIR_RootConstrainSelectedInstOperands,
     /*  615691 */     // GIR_Coverage, 5780,
     /*  615691 */     GIR_EraseRootFromParent_Done,
     /*  615692 */   // Label 9961: @615692
     /*  615692 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(615767), // Rule ID 5781 //
     /*  615697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615765 */     GIR_RootConstrainSelectedInstOperands,
     /*  615766 */     // GIR_Coverage, 5781,
     /*  615766 */     GIR_EraseRootFromParent_Done,
     /*  615767 */   // Label 9962: @615767
     /*  615767 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(615842), // Rule ID 5784 //
     /*  615772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615840 */     GIR_RootConstrainSelectedInstOperands,
     /*  615841 */     // GIR_Coverage, 5784,
     /*  615841 */     GIR_EraseRootFromParent_Done,
     /*  615842 */   // Label 9963: @615842
     /*  615842 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(615917), // Rule ID 5785 //
     /*  615847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615915 */     GIR_RootConstrainSelectedInstOperands,
     /*  615916 */     // GIR_Coverage, 5785,
     /*  615916 */     GIR_EraseRootFromParent_Done,
     /*  615917 */   // Label 9964: @615917
     /*  615917 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(615992), // Rule ID 5788 //
     /*  615922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615990 */     GIR_RootConstrainSelectedInstOperands,
     /*  615991 */     // GIR_Coverage, 5788,
     /*  615991 */     GIR_EraseRootFromParent_Done,
     /*  615992 */   // Label 9965: @615992
     /*  615992 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(616067), // Rule ID 5789 //
     /*  615997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  616008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  616014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  616017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  616046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616065 */     GIR_RootConstrainSelectedInstOperands,
     /*  616066 */     // GIR_Coverage, 5789,
     /*  616066 */     GIR_EraseRootFromParent_Done,
     /*  616067 */   // Label 9966: @616067
     /*  616067 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(616142), // Rule ID 5792 //
     /*  616072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  616092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616140 */     GIR_RootConstrainSelectedInstOperands,
     /*  616141 */     // GIR_Coverage, 5792,
     /*  616141 */     GIR_EraseRootFromParent_Done,
     /*  616142 */   // Label 9967: @616142
     /*  616142 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(616217), // Rule ID 5793 //
     /*  616147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  616158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  616164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  616167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616215 */     GIR_RootConstrainSelectedInstOperands,
     /*  616216 */     // GIR_Coverage, 5793,
     /*  616216 */     GIR_EraseRootFromParent_Done,
     /*  616217 */   // Label 9968: @616217
     /*  616217 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(616292), // Rule ID 5796 //
     /*  616222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  616242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616290 */     GIR_RootConstrainSelectedInstOperands,
     /*  616291 */     // GIR_Coverage, 5796,
     /*  616291 */     GIR_EraseRootFromParent_Done,
     /*  616292 */   // Label 9969: @616292
     /*  616292 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(616367), // Rule ID 5797 //
     /*  616297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  616308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  616314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  616317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  616346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616365 */     GIR_RootConstrainSelectedInstOperands,
     /*  616366 */     // GIR_Coverage, 5797,
     /*  616366 */     GIR_EraseRootFromParent_Done,
     /*  616367 */   // Label 9970: @616367
     /*  616367 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(616442), // Rule ID 5800 //
     /*  616372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616440 */     GIR_RootConstrainSelectedInstOperands,
     /*  616441 */     // GIR_Coverage, 5800,
     /*  616441 */     GIR_EraseRootFromParent_Done,
     /*  616442 */   // Label 9971: @616442
     /*  616442 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(616517), // Rule ID 5801 //
     /*  616447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  616458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  616464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616493 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616515 */     GIR_RootConstrainSelectedInstOperands,
     /*  616516 */     // GIR_Coverage, 5801,
     /*  616516 */     GIR_EraseRootFromParent_Done,
     /*  616517 */   // Label 9972: @616517
     /*  616517 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(616592), // Rule ID 5804 //
     /*  616522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616590 */     GIR_RootConstrainSelectedInstOperands,
     /*  616591 */     // GIR_Coverage, 5804,
     /*  616591 */     GIR_EraseRootFromParent_Done,
     /*  616592 */   // Label 9973: @616592
     /*  616592 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(616667), // Rule ID 5805 //
     /*  616597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616665 */     GIR_RootConstrainSelectedInstOperands,
     /*  616666 */     // GIR_Coverage, 5805,
     /*  616666 */     GIR_EraseRootFromParent_Done,
     /*  616667 */   // Label 9974: @616667
     /*  616667 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(616742), // Rule ID 5808 //
     /*  616672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616740 */     GIR_RootConstrainSelectedInstOperands,
     /*  616741 */     // GIR_Coverage, 5808,
     /*  616741 */     GIR_EraseRootFromParent_Done,
     /*  616742 */   // Label 9975: @616742
     /*  616742 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(616817), // Rule ID 5809 //
     /*  616747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616815 */     GIR_RootConstrainSelectedInstOperands,
     /*  616816 */     // GIR_Coverage, 5809,
     /*  616816 */     GIR_EraseRootFromParent_Done,
     /*  616817 */   // Label 9976: @616817
     /*  616817 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(616892), // Rule ID 5812 //
     /*  616822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  616868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616890 */     GIR_RootConstrainSelectedInstOperands,
     /*  616891 */     // GIR_Coverage, 5812,
     /*  616891 */     GIR_EraseRootFromParent_Done,
     /*  616892 */   // Label 9977: @616892
     /*  616892 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(616967), // Rule ID 5813 //
     /*  616897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  616900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  616943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616965 */     GIR_RootConstrainSelectedInstOperands,
     /*  616966 */     // GIR_Coverage, 5813,
     /*  616966 */     GIR_EraseRootFromParent_Done,
     /*  616967 */   // Label 9978: @616967
     /*  616967 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(617042), // Rule ID 5816 //
     /*  616972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617040 */     GIR_RootConstrainSelectedInstOperands,
     /*  617041 */     // GIR_Coverage, 5816,
     /*  617041 */     GIR_EraseRootFromParent_Done,
     /*  617042 */   // Label 9979: @617042
     /*  617042 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(617117), // Rule ID 5817 //
     /*  617047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  617058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  617064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  617067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617115 */     GIR_RootConstrainSelectedInstOperands,
     /*  617116 */     // GIR_Coverage, 5817,
     /*  617116 */     GIR_EraseRootFromParent_Done,
     /*  617117 */   // Label 9980: @617117
     /*  617117 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(617192), // Rule ID 5820 //
     /*  617122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  617142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617190 */     GIR_RootConstrainSelectedInstOperands,
     /*  617191 */     // GIR_Coverage, 5820,
     /*  617191 */     GIR_EraseRootFromParent_Done,
     /*  617192 */   // Label 9981: @617192
     /*  617192 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(617267), // Rule ID 5821 //
     /*  617197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  617208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  617214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  617217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617265 */     GIR_RootConstrainSelectedInstOperands,
     /*  617266 */     // GIR_Coverage, 5821,
     /*  617266 */     GIR_EraseRootFromParent_Done,
     /*  617267 */   // Label 9982: @617267
     /*  617267 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(617342), // Rule ID 5824 //
     /*  617272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  617292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617340 */     GIR_RootConstrainSelectedInstOperands,
     /*  617341 */     // GIR_Coverage, 5824,
     /*  617341 */     GIR_EraseRootFromParent_Done,
     /*  617342 */   // Label 9983: @617342
     /*  617342 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(617417), // Rule ID 5825 //
     /*  617347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  617358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  617364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  617367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617415 */     GIR_RootConstrainSelectedInstOperands,
     /*  617416 */     // GIR_Coverage, 5825,
     /*  617416 */     GIR_EraseRootFromParent_Done,
     /*  617417 */   // Label 9984: @617417
     /*  617417 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(617492), // Rule ID 5828 //
     /*  617422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617490 */     GIR_RootConstrainSelectedInstOperands,
     /*  617491 */     // GIR_Coverage, 5828,
     /*  617491 */     GIR_EraseRootFromParent_Done,
     /*  617492 */   // Label 9985: @617492
     /*  617492 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(617567), // Rule ID 5829 //
     /*  617497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617565 */     GIR_RootConstrainSelectedInstOperands,
     /*  617566 */     // GIR_Coverage, 5829,
     /*  617566 */     GIR_EraseRootFromParent_Done,
     /*  617567 */   // Label 9986: @617567
     /*  617567 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(617642), // Rule ID 5832 //
     /*  617572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617640 */     GIR_RootConstrainSelectedInstOperands,
     /*  617641 */     // GIR_Coverage, 5832,
     /*  617641 */     GIR_EraseRootFromParent_Done,
     /*  617642 */   // Label 9987: @617642
     /*  617642 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(617717), // Rule ID 5833 //
     /*  617647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617715 */     GIR_RootConstrainSelectedInstOperands,
     /*  617716 */     // GIR_Coverage, 5833,
     /*  617716 */     GIR_EraseRootFromParent_Done,
     /*  617717 */   // Label 9988: @617717
     /*  617717 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(617792), // Rule ID 5836 //
     /*  617722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617790 */     GIR_RootConstrainSelectedInstOperands,
     /*  617791 */     // GIR_Coverage, 5836,
     /*  617791 */     GIR_EraseRootFromParent_Done,
     /*  617792 */   // Label 9989: @617792
     /*  617792 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(617867), // Rule ID 5837 //
     /*  617797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617865 */     GIR_RootConstrainSelectedInstOperands,
     /*  617866 */     // GIR_Coverage, 5837,
     /*  617866 */     GIR_EraseRootFromParent_Done,
     /*  617867 */   // Label 9990: @617867
     /*  617867 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(617942), // Rule ID 5840 //
     /*  617872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617940 */     GIR_RootConstrainSelectedInstOperands,
     /*  617941 */     // GIR_Coverage, 5840,
     /*  617941 */     GIR_EraseRootFromParent_Done,
     /*  617942 */   // Label 9991: @617942
     /*  617942 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(618017), // Rule ID 5841 //
     /*  617947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618015 */     GIR_RootConstrainSelectedInstOperands,
     /*  618016 */     // GIR_Coverage, 5841,
     /*  618016 */     GIR_EraseRootFromParent_Done,
     /*  618017 */   // Label 9992: @618017
     /*  618017 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(618092), // Rule ID 5844 //
     /*  618022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  618042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618090 */     GIR_RootConstrainSelectedInstOperands,
     /*  618091 */     // GIR_Coverage, 5844,
     /*  618091 */     GIR_EraseRootFromParent_Done,
     /*  618092 */   // Label 9993: @618092
     /*  618092 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(618167), // Rule ID 5845 //
     /*  618097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  618108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  618114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  618117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618165 */     GIR_RootConstrainSelectedInstOperands,
     /*  618166 */     // GIR_Coverage, 5845,
     /*  618166 */     GIR_EraseRootFromParent_Done,
     /*  618167 */   // Label 9994: @618167
     /*  618167 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(618242), // Rule ID 5848 //
     /*  618172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  618192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618240 */     GIR_RootConstrainSelectedInstOperands,
     /*  618241 */     // GIR_Coverage, 5848,
     /*  618241 */     GIR_EraseRootFromParent_Done,
     /*  618242 */   // Label 9995: @618242
     /*  618242 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(618317), // Rule ID 5849 //
     /*  618247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  618258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  618264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  618267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618315 */     GIR_RootConstrainSelectedInstOperands,
     /*  618316 */     // GIR_Coverage, 5849,
     /*  618316 */     GIR_EraseRootFromParent_Done,
     /*  618317 */   // Label 9996: @618317
     /*  618317 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(618392), // Rule ID 5852 //
     /*  618322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  618371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618390 */     GIR_RootConstrainSelectedInstOperands,
     /*  618391 */     // GIR_Coverage, 5852,
     /*  618391 */     GIR_EraseRootFromParent_Done,
     /*  618392 */   // Label 9997: @618392
     /*  618392 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(618467), // Rule ID 5853 //
     /*  618397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  618408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  618414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  618417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  618446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618465 */     GIR_RootConstrainSelectedInstOperands,
     /*  618466 */     // GIR_Coverage, 5853,
     /*  618466 */     GIR_EraseRootFromParent_Done,
     /*  618467 */   // Label 9998: @618467
     /*  618467 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(618542), // Rule ID 5856 //
     /*  618472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618540 */     GIR_RootConstrainSelectedInstOperands,
     /*  618541 */     // GIR_Coverage, 5856,
     /*  618541 */     GIR_EraseRootFromParent_Done,
     /*  618542 */   // Label 9999: @618542
     /*  618542 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(618617), // Rule ID 5857 //
     /*  618547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618615 */     GIR_RootConstrainSelectedInstOperands,
     /*  618616 */     // GIR_Coverage, 5857,
     /*  618616 */     GIR_EraseRootFromParent_Done,
     /*  618617 */   // Label 10000: @618617
     /*  618617 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(618692), // Rule ID 5860 //
     /*  618622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618690 */     GIR_RootConstrainSelectedInstOperands,
     /*  618691 */     // GIR_Coverage, 5860,
     /*  618691 */     GIR_EraseRootFromParent_Done,
     /*  618692 */   // Label 10001: @618692
     /*  618692 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(618767), // Rule ID 5861 //
     /*  618697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618765 */     GIR_RootConstrainSelectedInstOperands,
     /*  618766 */     // GIR_Coverage, 5861,
     /*  618766 */     GIR_EraseRootFromParent_Done,
     /*  618767 */   // Label 10002: @618767
     /*  618767 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(618842), // Rule ID 5864 //
     /*  618772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618840 */     GIR_RootConstrainSelectedInstOperands,
     /*  618841 */     // GIR_Coverage, 5864,
     /*  618841 */     GIR_EraseRootFromParent_Done,
     /*  618842 */   // Label 10003: @618842
     /*  618842 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(618917), // Rule ID 5865 //
     /*  618847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618915 */     GIR_RootConstrainSelectedInstOperands,
     /*  618916 */     // GIR_Coverage, 5865,
     /*  618916 */     GIR_EraseRootFromParent_Done,
     /*  618917 */   // Label 10004: @618917
     /*  618917 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(618992), // Rule ID 5868 //
     /*  618922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618990 */     GIR_RootConstrainSelectedInstOperands,
     /*  618991 */     // GIR_Coverage, 5868,
     /*  618991 */     GIR_EraseRootFromParent_Done,
     /*  618992 */   // Label 10005: @618992
     /*  618992 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(619067), // Rule ID 5869 //
     /*  618997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619065 */     GIR_RootConstrainSelectedInstOperands,
     /*  619066 */     // GIR_Coverage, 5869,
     /*  619066 */     GIR_EraseRootFromParent_Done,
     /*  619067 */   // Label 10006: @619067
     /*  619067 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(619142), // Rule ID 5872 //
     /*  619072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619140 */     GIR_RootConstrainSelectedInstOperands,
     /*  619141 */     // GIR_Coverage, 5872,
     /*  619141 */     GIR_EraseRootFromParent_Done,
     /*  619142 */   // Label 10007: @619142
     /*  619142 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(619217), // Rule ID 5873 //
     /*  619147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619215 */     GIR_RootConstrainSelectedInstOperands,
     /*  619216 */     // GIR_Coverage, 5873,
     /*  619216 */     GIR_EraseRootFromParent_Done,
     /*  619217 */   // Label 10008: @619217
     /*  619217 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(619292), // Rule ID 5876 //
     /*  619222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619290 */     GIR_RootConstrainSelectedInstOperands,
     /*  619291 */     // GIR_Coverage, 5876,
     /*  619291 */     GIR_EraseRootFromParent_Done,
     /*  619292 */   // Label 10009: @619292
     /*  619292 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(619367), // Rule ID 5877 //
     /*  619297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  619346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619365 */     GIR_RootConstrainSelectedInstOperands,
     /*  619366 */     // GIR_Coverage, 5877,
     /*  619366 */     GIR_EraseRootFromParent_Done,
     /*  619367 */   // Label 10010: @619367
     /*  619367 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(619442), // Rule ID 5880 //
     /*  619372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619440 */     GIR_RootConstrainSelectedInstOperands,
     /*  619441 */     // GIR_Coverage, 5880,
     /*  619441 */     GIR_EraseRootFromParent_Done,
     /*  619442 */   // Label 10011: @619442
     /*  619442 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(619517), // Rule ID 5881 //
     /*  619447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619515 */     GIR_RootConstrainSelectedInstOperands,
     /*  619516 */     // GIR_Coverage, 5881,
     /*  619516 */     GIR_EraseRootFromParent_Done,
     /*  619517 */   // Label 10012: @619517
     /*  619517 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(619592), // Rule ID 5884 //
     /*  619522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619590 */     GIR_RootConstrainSelectedInstOperands,
     /*  619591 */     // GIR_Coverage, 5884,
     /*  619591 */     GIR_EraseRootFromParent_Done,
     /*  619592 */   // Label 10013: @619592
     /*  619592 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(619667), // Rule ID 5885 //
     /*  619597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619665 */     GIR_RootConstrainSelectedInstOperands,
     /*  619666 */     // GIR_Coverage, 5885,
     /*  619666 */     GIR_EraseRootFromParent_Done,
     /*  619667 */   // Label 10014: @619667
     /*  619667 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(619742), // Rule ID 5888 //
     /*  619672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619740 */     GIR_RootConstrainSelectedInstOperands,
     /*  619741 */     // GIR_Coverage, 5888,
     /*  619741 */     GIR_EraseRootFromParent_Done,
     /*  619742 */   // Label 10015: @619742
     /*  619742 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(619817), // Rule ID 5889 //
     /*  619747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11212:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619815 */     GIR_RootConstrainSelectedInstOperands,
     /*  619816 */     // GIR_Coverage, 5889,
     /*  619816 */     GIR_EraseRootFromParent_Done,
     /*  619817 */   // Label 10016: @619817
     /*  619817 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(619892), // Rule ID 5892 //
     /*  619822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619890 */     GIR_RootConstrainSelectedInstOperands,
     /*  619891 */     // GIR_Coverage, 5892,
     /*  619891 */     GIR_EraseRootFromParent_Done,
     /*  619892 */   // Label 10017: @619892
     /*  619892 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(619967), // Rule ID 5893 //
     /*  619897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619965 */     GIR_RootConstrainSelectedInstOperands,
     /*  619966 */     // GIR_Coverage, 5893,
     /*  619966 */     GIR_EraseRootFromParent_Done,
     /*  619967 */   // Label 10018: @619967
     /*  619967 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(620042), // Rule ID 5896 //
     /*  619972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620040 */     GIR_RootConstrainSelectedInstOperands,
     /*  620041 */     // GIR_Coverage, 5896,
     /*  620041 */     GIR_EraseRootFromParent_Done,
     /*  620042 */   // Label 10019: @620042
     /*  620042 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(620117), // Rule ID 5897 //
     /*  620047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620115 */     GIR_RootConstrainSelectedInstOperands,
     /*  620116 */     // GIR_Coverage, 5897,
     /*  620116 */     GIR_EraseRootFromParent_Done,
     /*  620117 */   // Label 10020: @620117
     /*  620117 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(620192), // Rule ID 5900 //
     /*  620122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620190 */     GIR_RootConstrainSelectedInstOperands,
     /*  620191 */     // GIR_Coverage, 5900,
     /*  620191 */     GIR_EraseRootFromParent_Done,
     /*  620192 */   // Label 10021: @620192
     /*  620192 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(620267), // Rule ID 5901 //
     /*  620197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  620246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620265 */     GIR_RootConstrainSelectedInstOperands,
     /*  620266 */     // GIR_Coverage, 5901,
     /*  620266 */     GIR_EraseRootFromParent_Done,
     /*  620267 */   // Label 10022: @620267
     /*  620267 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(620342), // Rule ID 5904 //
     /*  620272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620340 */     GIR_RootConstrainSelectedInstOperands,
     /*  620341 */     // GIR_Coverage, 5904,
     /*  620341 */     GIR_EraseRootFromParent_Done,
     /*  620342 */   // Label 10023: @620342
     /*  620342 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(620417), // Rule ID 5905 //
     /*  620347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620415 */     GIR_RootConstrainSelectedInstOperands,
     /*  620416 */     // GIR_Coverage, 5905,
     /*  620416 */     GIR_EraseRootFromParent_Done,
     /*  620417 */   // Label 10024: @620417
     /*  620417 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(620492), // Rule ID 5908 //
     /*  620422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620490 */     GIR_RootConstrainSelectedInstOperands,
     /*  620491 */     // GIR_Coverage, 5908,
     /*  620491 */     GIR_EraseRootFromParent_Done,
     /*  620492 */   // Label 10025: @620492
     /*  620492 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(620567), // Rule ID 5909 //
     /*  620497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620565 */     GIR_RootConstrainSelectedInstOperands,
     /*  620566 */     // GIR_Coverage, 5909,
     /*  620566 */     GIR_EraseRootFromParent_Done,
     /*  620567 */   // Label 10026: @620567
     /*  620567 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(620642), // Rule ID 5912 //
     /*  620572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620640 */     GIR_RootConstrainSelectedInstOperands,
     /*  620641 */     // GIR_Coverage, 5912,
     /*  620641 */     GIR_EraseRootFromParent_Done,
     /*  620642 */   // Label 10027: @620642
     /*  620642 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(620717), // Rule ID 5913 //
     /*  620647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620715 */     GIR_RootConstrainSelectedInstOperands,
     /*  620716 */     // GIR_Coverage, 5913,
     /*  620716 */     GIR_EraseRootFromParent_Done,
     /*  620717 */   // Label 10028: @620717
     /*  620717 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(620792), // Rule ID 5916 //
     /*  620722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620790 */     GIR_RootConstrainSelectedInstOperands,
     /*  620791 */     // GIR_Coverage, 5916,
     /*  620791 */     GIR_EraseRootFromParent_Done,
     /*  620792 */   // Label 10029: @620792
     /*  620792 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(620867), // Rule ID 5917 //
     /*  620797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620865 */     GIR_RootConstrainSelectedInstOperands,
     /*  620866 */     // GIR_Coverage, 5917,
     /*  620866 */     GIR_EraseRootFromParent_Done,
     /*  620867 */   // Label 10030: @620867
     /*  620867 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(620942), // Rule ID 5920 //
     /*  620872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620940 */     GIR_RootConstrainSelectedInstOperands,
     /*  620941 */     // GIR_Coverage, 5920,
     /*  620941 */     GIR_EraseRootFromParent_Done,
     /*  620942 */   // Label 10031: @620942
     /*  620942 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(621017), // Rule ID 5921 //
     /*  620947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621015 */     GIR_RootConstrainSelectedInstOperands,
     /*  621016 */     // GIR_Coverage, 5921,
     /*  621016 */     GIR_EraseRootFromParent_Done,
     /*  621017 */   // Label 10032: @621017
     /*  621017 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(621092), // Rule ID 5924 //
     /*  621022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621090 */     GIR_RootConstrainSelectedInstOperands,
     /*  621091 */     // GIR_Coverage, 5924,
     /*  621091 */     GIR_EraseRootFromParent_Done,
     /*  621092 */   // Label 10033: @621092
     /*  621092 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(621167), // Rule ID 5925 //
     /*  621097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621165 */     GIR_RootConstrainSelectedInstOperands,
     /*  621166 */     // GIR_Coverage, 5925,
     /*  621166 */     GIR_EraseRootFromParent_Done,
     /*  621167 */   // Label 10034: @621167
     /*  621167 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(621242), // Rule ID 5928 //
     /*  621172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621240 */     GIR_RootConstrainSelectedInstOperands,
     /*  621241 */     // GIR_Coverage, 5928,
     /*  621241 */     GIR_EraseRootFromParent_Done,
     /*  621242 */   // Label 10035: @621242
     /*  621242 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(621317), // Rule ID 5929 //
     /*  621247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621315 */     GIR_RootConstrainSelectedInstOperands,
     /*  621316 */     // GIR_Coverage, 5929,
     /*  621316 */     GIR_EraseRootFromParent_Done,
     /*  621317 */   // Label 10036: @621317
     /*  621317 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(621392), // Rule ID 5932 //
     /*  621322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621390 */     GIR_RootConstrainSelectedInstOperands,
     /*  621391 */     // GIR_Coverage, 5932,
     /*  621391 */     GIR_EraseRootFromParent_Done,
     /*  621392 */   // Label 10037: @621392
     /*  621392 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(621467), // Rule ID 5933 //
     /*  621397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621465 */     GIR_RootConstrainSelectedInstOperands,
     /*  621466 */     // GIR_Coverage, 5933,
     /*  621466 */     GIR_EraseRootFromParent_Done,
     /*  621467 */   // Label 10038: @621467
     /*  621467 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(621542), // Rule ID 5936 //
     /*  621472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621540 */     GIR_RootConstrainSelectedInstOperands,
     /*  621541 */     // GIR_Coverage, 5936,
     /*  621541 */     GIR_EraseRootFromParent_Done,
     /*  621542 */   // Label 10039: @621542
     /*  621542 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(621617), // Rule ID 5937 //
     /*  621547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621615 */     GIR_RootConstrainSelectedInstOperands,
     /*  621616 */     // GIR_Coverage, 5937,
     /*  621616 */     GIR_EraseRootFromParent_Done,
     /*  621617 */   // Label 10040: @621617
     /*  621617 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(621692), // Rule ID 5940 //
     /*  621622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621690 */     GIR_RootConstrainSelectedInstOperands,
     /*  621691 */     // GIR_Coverage, 5940,
     /*  621691 */     GIR_EraseRootFromParent_Done,
     /*  621692 */   // Label 10041: @621692
     /*  621692 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(621767), // Rule ID 5941 //
     /*  621697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621765 */     GIR_RootConstrainSelectedInstOperands,
     /*  621766 */     // GIR_Coverage, 5941,
     /*  621766 */     GIR_EraseRootFromParent_Done,
     /*  621767 */   // Label 10042: @621767
     /*  621767 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(621842), // Rule ID 5944 //
     /*  621772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621840 */     GIR_RootConstrainSelectedInstOperands,
     /*  621841 */     // GIR_Coverage, 5944,
     /*  621841 */     GIR_EraseRootFromParent_Done,
     /*  621842 */   // Label 10043: @621842
     /*  621842 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(621917), // Rule ID 5945 //
     /*  621847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621915 */     GIR_RootConstrainSelectedInstOperands,
     /*  621916 */     // GIR_Coverage, 5945,
     /*  621916 */     GIR_EraseRootFromParent_Done,
     /*  621917 */   // Label 10044: @621917
     /*  621917 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(621992), // Rule ID 5948 //
     /*  621922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621990 */     GIR_RootConstrainSelectedInstOperands,
     /*  621991 */     // GIR_Coverage, 5948,
     /*  621991 */     GIR_EraseRootFromParent_Done,
     /*  621992 */   // Label 10045: @621992
     /*  621992 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(622067), // Rule ID 5949 //
     /*  621997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  622000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  622043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  622046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622065 */     GIR_RootConstrainSelectedInstOperands,
     /*  622066 */     // GIR_Coverage, 5949,
     /*  622066 */     GIR_EraseRootFromParent_Done,
     /*  622067 */   // Label 10046: @622067
     /*  622067 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(622142), // Rule ID 6040 //
     /*  622072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  622121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622140 */     GIR_RootConstrainSelectedInstOperands,
     /*  622141 */     // GIR_Coverage, 6040,
     /*  622141 */     GIR_EraseRootFromParent_Done,
     /*  622142 */   // Label 10047: @622142
     /*  622142 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(622217), // Rule ID 6041 //
     /*  622147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  622167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  622196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622215 */     GIR_RootConstrainSelectedInstOperands,
     /*  622216 */     // GIR_Coverage, 6041,
     /*  622216 */     GIR_EraseRootFromParent_Done,
     /*  622217 */   // Label 10048: @622217
     /*  622217 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(622292), // Rule ID 6044 //
     /*  622222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622290 */     GIR_RootConstrainSelectedInstOperands,
     /*  622291 */     // GIR_Coverage, 6044,
     /*  622291 */     GIR_EraseRootFromParent_Done,
     /*  622292 */   // Label 10049: @622292
     /*  622292 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(622367), // Rule ID 6045 //
     /*  622297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  622317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622343 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622365 */     GIR_RootConstrainSelectedInstOperands,
     /*  622366 */     // GIR_Coverage, 6045,
     /*  622366 */     GIR_EraseRootFromParent_Done,
     /*  622367 */   // Label 10050: @622367
     /*  622367 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(622442), // Rule ID 6048 //
     /*  622372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622440 */     GIR_RootConstrainSelectedInstOperands,
     /*  622441 */     // GIR_Coverage, 6048,
     /*  622441 */     GIR_EraseRootFromParent_Done,
     /*  622442 */   // Label 10051: @622442
     /*  622442 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(622517), // Rule ID 6049 //
     /*  622447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622515 */     GIR_RootConstrainSelectedInstOperands,
     /*  622516 */     // GIR_Coverage, 6049,
     /*  622516 */     GIR_EraseRootFromParent_Done,
     /*  622517 */   // Label 10052: @622517
     /*  622517 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(622592), // Rule ID 6052 //
     /*  622522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622590 */     GIR_RootConstrainSelectedInstOperands,
     /*  622591 */     // GIR_Coverage, 6052,
     /*  622591 */     GIR_EraseRootFromParent_Done,
     /*  622592 */   // Label 10053: @622592
     /*  622592 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(622667), // Rule ID 6053 //
     /*  622597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622665 */     GIR_RootConstrainSelectedInstOperands,
     /*  622666 */     // GIR_Coverage, 6053,
     /*  622666 */     GIR_EraseRootFromParent_Done,
     /*  622667 */   // Label 10054: @622667
     /*  622667 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(622742), // Rule ID 6056 //
     /*  622672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622740 */     GIR_RootConstrainSelectedInstOperands,
     /*  622741 */     // GIR_Coverage, 6056,
     /*  622741 */     GIR_EraseRootFromParent_Done,
     /*  622742 */   // Label 10055: @622742
     /*  622742 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(622817), // Rule ID 6057 //
     /*  622747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622815 */     GIR_RootConstrainSelectedInstOperands,
     /*  622816 */     // GIR_Coverage, 6057,
     /*  622816 */     GIR_EraseRootFromParent_Done,
     /*  622817 */   // Label 10056: @622817
     /*  622817 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(622892), // Rule ID 6060 //
     /*  622822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622890 */     GIR_RootConstrainSelectedInstOperands,
     /*  622891 */     // GIR_Coverage, 6060,
     /*  622891 */     GIR_EraseRootFromParent_Done,
     /*  622892 */   // Label 10057: @622892
     /*  622892 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(622967), // Rule ID 6061 //
     /*  622897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622965 */     GIR_RootConstrainSelectedInstOperands,
     /*  622966 */     // GIR_Coverage, 6061,
     /*  622966 */     GIR_EraseRootFromParent_Done,
     /*  622967 */   // Label 10058: @622967
     /*  622967 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(623042), // Rule ID 6064 //
     /*  622972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623040 */     GIR_RootConstrainSelectedInstOperands,
     /*  623041 */     // GIR_Coverage, 6064,
     /*  623041 */     GIR_EraseRootFromParent_Done,
     /*  623042 */   // Label 10059: @623042
     /*  623042 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(623117), // Rule ID 6065 //
     /*  623047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  623067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623093 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623115 */     GIR_RootConstrainSelectedInstOperands,
     /*  623116 */     // GIR_Coverage, 6065,
     /*  623116 */     GIR_EraseRootFromParent_Done,
     /*  623117 */   // Label 10060: @623117
     /*  623117 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(623192), // Rule ID 6068 //
     /*  623122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623190 */     GIR_RootConstrainSelectedInstOperands,
     /*  623191 */     // GIR_Coverage, 6068,
     /*  623191 */     GIR_EraseRootFromParent_Done,
     /*  623192 */   // Label 10061: @623192
     /*  623192 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(623267), // Rule ID 6069 //
     /*  623197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  623217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623265 */     GIR_RootConstrainSelectedInstOperands,
     /*  623266 */     // GIR_Coverage, 6069,
     /*  623266 */     GIR_EraseRootFromParent_Done,
     /*  623267 */   // Label 10062: @623267
     /*  623267 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(623342), // Rule ID 6072 //
     /*  623272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623340 */     GIR_RootConstrainSelectedInstOperands,
     /*  623341 */     // GIR_Coverage, 6072,
     /*  623341 */     GIR_EraseRootFromParent_Done,
     /*  623342 */   // Label 10063: @623342
     /*  623342 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(623417), // Rule ID 6073 //
     /*  623347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  623367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623415 */     GIR_RootConstrainSelectedInstOperands,
     /*  623416 */     // GIR_Coverage, 6073,
     /*  623416 */     GIR_EraseRootFromParent_Done,
     /*  623417 */   // Label 10064: @623417
     /*  623417 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(623492), // Rule ID 6076 //
     /*  623422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623490 */     GIR_RootConstrainSelectedInstOperands,
     /*  623491 */     // GIR_Coverage, 6076,
     /*  623491 */     GIR_EraseRootFromParent_Done,
     /*  623492 */   // Label 10065: @623492
     /*  623492 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(623567), // Rule ID 6077 //
     /*  623497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623565 */     GIR_RootConstrainSelectedInstOperands,
     /*  623566 */     // GIR_Coverage, 6077,
     /*  623566 */     GIR_EraseRootFromParent_Done,
     /*  623567 */   // Label 10066: @623567
     /*  623567 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(623642), // Rule ID 6080 //
     /*  623572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623640 */     GIR_RootConstrainSelectedInstOperands,
     /*  623641 */     // GIR_Coverage, 6080,
     /*  623641 */     GIR_EraseRootFromParent_Done,
     /*  623642 */   // Label 10067: @623642
     /*  623642 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(623717), // Rule ID 6081 //
     /*  623647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623715 */     GIR_RootConstrainSelectedInstOperands,
     /*  623716 */     // GIR_Coverage, 6081,
     /*  623716 */     GIR_EraseRootFromParent_Done,
     /*  623717 */   // Label 10068: @623717
     /*  623717 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(623792), // Rule ID 6084 //
     /*  623722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623768 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623790 */     GIR_RootConstrainSelectedInstOperands,
     /*  623791 */     // GIR_Coverage, 6084,
     /*  623791 */     GIR_EraseRootFromParent_Done,
     /*  623792 */   // Label 10069: @623792
     /*  623792 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(623867), // Rule ID 6085 //
     /*  623797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623843 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623865 */     GIR_RootConstrainSelectedInstOperands,
     /*  623866 */     // GIR_Coverage, 6085,
     /*  623866 */     GIR_EraseRootFromParent_Done,
     /*  623867 */   // Label 10070: @623867
     /*  623867 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(623942), // Rule ID 6088 //
     /*  623872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623940 */     GIR_RootConstrainSelectedInstOperands,
     /*  623941 */     // GIR_Coverage, 6088,
     /*  623941 */     GIR_EraseRootFromParent_Done,
     /*  623942 */   // Label 10071: @623942
     /*  623942 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(624017), // Rule ID 6089 //
     /*  623947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624015 */     GIR_RootConstrainSelectedInstOperands,
     /*  624016 */     // GIR_Coverage, 6089,
     /*  624016 */     GIR_EraseRootFromParent_Done,
     /*  624017 */   // Label 10072: @624017
     /*  624017 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(624092), // Rule ID 6092 //
     /*  624022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  624042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624090 */     GIR_RootConstrainSelectedInstOperands,
     /*  624091 */     // GIR_Coverage, 6092,
     /*  624091 */     GIR_EraseRootFromParent_Done,
     /*  624092 */   // Label 10073: @624092
     /*  624092 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(624167), // Rule ID 6093 //
     /*  624097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  624117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624165 */     GIR_RootConstrainSelectedInstOperands,
     /*  624166 */     // GIR_Coverage, 6093,
     /*  624166 */     GIR_EraseRootFromParent_Done,
     /*  624167 */   // Label 10074: @624167
     /*  624167 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(624242), // Rule ID 6096 //
     /*  624172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624240 */     GIR_RootConstrainSelectedInstOperands,
     /*  624241 */     // GIR_Coverage, 6096,
     /*  624241 */     GIR_EraseRootFromParent_Done,
     /*  624242 */   // Label 10075: @624242
     /*  624242 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(624317), // Rule ID 6097 //
     /*  624247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  624267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624315 */     GIR_RootConstrainSelectedInstOperands,
     /*  624316 */     // GIR_Coverage, 6097,
     /*  624316 */     GIR_EraseRootFromParent_Done,
     /*  624317 */   // Label 10076: @624317
     /*  624317 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(624392), // Rule ID 6100 //
     /*  624322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624390 */     GIR_RootConstrainSelectedInstOperands,
     /*  624391 */     // GIR_Coverage, 6100,
     /*  624391 */     GIR_EraseRootFromParent_Done,
     /*  624392 */   // Label 10077: @624392
     /*  624392 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(624467), // Rule ID 6101 //
     /*  624397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  624417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624465 */     GIR_RootConstrainSelectedInstOperands,
     /*  624466 */     // GIR_Coverage, 6101,
     /*  624466 */     GIR_EraseRootFromParent_Done,
     /*  624467 */   // Label 10078: @624467
     /*  624467 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(624542), // Rule ID 6104 //
     /*  624472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624540 */     GIR_RootConstrainSelectedInstOperands,
     /*  624541 */     // GIR_Coverage, 6104,
     /*  624541 */     GIR_EraseRootFromParent_Done,
     /*  624542 */   // Label 10079: @624542
     /*  624542 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(624617), // Rule ID 6105 //
     /*  624547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624615 */     GIR_RootConstrainSelectedInstOperands,
     /*  624616 */     // GIR_Coverage, 6105,
     /*  624616 */     GIR_EraseRootFromParent_Done,
     /*  624617 */   // Label 10080: @624617
     /*  624617 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(624692), // Rule ID 6108 //
     /*  624622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624690 */     GIR_RootConstrainSelectedInstOperands,
     /*  624691 */     // GIR_Coverage, 6108,
     /*  624691 */     GIR_EraseRootFromParent_Done,
     /*  624692 */   // Label 10081: @624692
     /*  624692 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(624767), // Rule ID 6109 //
     /*  624697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624765 */     GIR_RootConstrainSelectedInstOperands,
     /*  624766 */     // GIR_Coverage, 6109,
     /*  624766 */     GIR_EraseRootFromParent_Done,
     /*  624767 */   // Label 10082: @624767
     /*  624767 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(624842), // Rule ID 6112 //
     /*  624772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624840 */     GIR_RootConstrainSelectedInstOperands,
     /*  624841 */     // GIR_Coverage, 6112,
     /*  624841 */     GIR_EraseRootFromParent_Done,
     /*  624842 */   // Label 10083: @624842
     /*  624842 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(624917), // Rule ID 6113 //
     /*  624847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624915 */     GIR_RootConstrainSelectedInstOperands,
     /*  624916 */     // GIR_Coverage, 6113,
     /*  624916 */     GIR_EraseRootFromParent_Done,
     /*  624917 */   // Label 10084: @624917
     /*  624917 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(624992), // Rule ID 6116 //
     /*  624922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624990 */     GIR_RootConstrainSelectedInstOperands,
     /*  624991 */     // GIR_Coverage, 6116,
     /*  624991 */     GIR_EraseRootFromParent_Done,
     /*  624992 */   // Label 10085: @624992
     /*  624992 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(625067), // Rule ID 6117 //
     /*  624997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  625017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  625046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625065 */     GIR_RootConstrainSelectedInstOperands,
     /*  625066 */     // GIR_Coverage, 6117,
     /*  625066 */     GIR_EraseRootFromParent_Done,
     /*  625067 */   // Label 10086: @625067
     /*  625067 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(625142), // Rule ID 6120 //
     /*  625072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  625121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625140 */     GIR_RootConstrainSelectedInstOperands,
     /*  625141 */     // GIR_Coverage, 6120,
     /*  625141 */     GIR_EraseRootFromParent_Done,
     /*  625142 */   // Label 10087: @625142
     /*  625142 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(625217), // Rule ID 6121 //
     /*  625147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  625167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  625196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625215 */     GIR_RootConstrainSelectedInstOperands,
     /*  625216 */     // GIR_Coverage, 6121,
     /*  625216 */     GIR_EraseRootFromParent_Done,
     /*  625217 */   // Label 10088: @625217
     /*  625217 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(625292), // Rule ID 6124 //
     /*  625222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  625271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625290 */     GIR_RootConstrainSelectedInstOperands,
     /*  625291 */     // GIR_Coverage, 6124,
     /*  625291 */     GIR_EraseRootFromParent_Done,
     /*  625292 */   // Label 10089: @625292
     /*  625292 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(625367), // Rule ID 6125 //
     /*  625297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  625317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  625346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625365 */     GIR_RootConstrainSelectedInstOperands,
     /*  625366 */     // GIR_Coverage, 6125,
     /*  625366 */     GIR_EraseRootFromParent_Done,
     /*  625367 */   // Label 10090: @625367
     /*  625367 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(625442), // Rule ID 6128 //
     /*  625372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625440 */     GIR_RootConstrainSelectedInstOperands,
     /*  625441 */     // GIR_Coverage, 6128,
     /*  625441 */     GIR_EraseRootFromParent_Done,
     /*  625442 */   // Label 10091: @625442
     /*  625442 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(625517), // Rule ID 6129 //
     /*  625447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625493 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625515 */     GIR_RootConstrainSelectedInstOperands,
     /*  625516 */     // GIR_Coverage, 6129,
     /*  625516 */     GIR_EraseRootFromParent_Done,
     /*  625517 */   // Label 10092: @625517
     /*  625517 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(625592), // Rule ID 6132 //
     /*  625522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625568 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625590 */     GIR_RootConstrainSelectedInstOperands,
     /*  625591 */     // GIR_Coverage, 6132,
     /*  625591 */     GIR_EraseRootFromParent_Done,
     /*  625592 */   // Label 10093: @625592
     /*  625592 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(625667), // Rule ID 6133 //
     /*  625597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625665 */     GIR_RootConstrainSelectedInstOperands,
     /*  625666 */     // GIR_Coverage, 6133,
     /*  625666 */     GIR_EraseRootFromParent_Done,
     /*  625667 */   // Label 10094: @625667
     /*  625667 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(625742), // Rule ID 6136 //
     /*  625672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625740 */     GIR_RootConstrainSelectedInstOperands,
     /*  625741 */     // GIR_Coverage, 6136,
     /*  625741 */     GIR_EraseRootFromParent_Done,
     /*  625742 */   // Label 10095: @625742
     /*  625742 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(625817), // Rule ID 6137 //
     /*  625747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625793 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625815 */     GIR_RootConstrainSelectedInstOperands,
     /*  625816 */     // GIR_Coverage, 6137,
     /*  625816 */     GIR_EraseRootFromParent_Done,
     /*  625817 */   // Label 10096: @625817
     /*  625817 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(625892), // Rule ID 6140 //
     /*  625822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625890 */     GIR_RootConstrainSelectedInstOperands,
     /*  625891 */     // GIR_Coverage, 6140,
     /*  625891 */     GIR_EraseRootFromParent_Done,
     /*  625892 */   // Label 10097: @625892
     /*  625892 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(625967), // Rule ID 6141 //
     /*  625897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625965 */     GIR_RootConstrainSelectedInstOperands,
     /*  625966 */     // GIR_Coverage, 6141,
     /*  625966 */     GIR_EraseRootFromParent_Done,
     /*  625967 */   // Label 10098: @625967
     /*  625967 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(626042), // Rule ID 6144 //
     /*  625972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626040 */     GIR_RootConstrainSelectedInstOperands,
     /*  626041 */     // GIR_Coverage, 6144,
     /*  626041 */     GIR_EraseRootFromParent_Done,
     /*  626042 */   // Label 10099: @626042
     /*  626042 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(626117), // Rule ID 6145 //
     /*  626047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626115 */     GIR_RootConstrainSelectedInstOperands,
     /*  626116 */     // GIR_Coverage, 6145,
     /*  626116 */     GIR_EraseRootFromParent_Done,
     /*  626117 */   // Label 10100: @626117
     /*  626117 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(626192), // Rule ID 6148 //
     /*  626122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626190 */     GIR_RootConstrainSelectedInstOperands,
     /*  626191 */     // GIR_Coverage, 6148,
     /*  626191 */     GIR_EraseRootFromParent_Done,
     /*  626192 */   // Label 10101: @626192
     /*  626192 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(626267), // Rule ID 6149 //
     /*  626197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  626246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626265 */     GIR_RootConstrainSelectedInstOperands,
     /*  626266 */     // GIR_Coverage, 6149,
     /*  626266 */     GIR_EraseRootFromParent_Done,
     /*  626267 */   // Label 10102: @626267
     /*  626267 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(626342), // Rule ID 6152 //
     /*  626272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626340 */     GIR_RootConstrainSelectedInstOperands,
     /*  626341 */     // GIR_Coverage, 6152,
     /*  626341 */     GIR_EraseRootFromParent_Done,
     /*  626342 */   // Label 10103: @626342
     /*  626342 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(626417), // Rule ID 6153 //
     /*  626347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626393 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626415 */     GIR_RootConstrainSelectedInstOperands,
     /*  626416 */     // GIR_Coverage, 6153,
     /*  626416 */     GIR_EraseRootFromParent_Done,
     /*  626417 */   // Label 10104: @626417
     /*  626417 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(626492), // Rule ID 6156 //
     /*  626422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626490 */     GIR_RootConstrainSelectedInstOperands,
     /*  626491 */     // GIR_Coverage, 6156,
     /*  626491 */     GIR_EraseRootFromParent_Done,
     /*  626492 */   // Label 10105: @626492
     /*  626492 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(626567), // Rule ID 6157 //
     /*  626497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626543 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626565 */     GIR_RootConstrainSelectedInstOperands,
     /*  626566 */     // GIR_Coverage, 6157,
     /*  626566 */     GIR_EraseRootFromParent_Done,
     /*  626567 */   // Label 10106: @626567
     /*  626567 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(626642), // Rule ID 6160 //
     /*  626572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626640 */     GIR_RootConstrainSelectedInstOperands,
     /*  626641 */     // GIR_Coverage, 6160,
     /*  626641 */     GIR_EraseRootFromParent_Done,
     /*  626642 */   // Label 10107: @626642
     /*  626642 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(626717), // Rule ID 6161 //
     /*  626647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626715 */     GIR_RootConstrainSelectedInstOperands,
     /*  626716 */     // GIR_Coverage, 6161,
     /*  626716 */     GIR_EraseRootFromParent_Done,
     /*  626717 */   // Label 10108: @626717
     /*  626717 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(626792), // Rule ID 6164 //
     /*  626722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626790 */     GIR_RootConstrainSelectedInstOperands,
     /*  626791 */     // GIR_Coverage, 6164,
     /*  626791 */     GIR_EraseRootFromParent_Done,
     /*  626792 */   // Label 10109: @626792
     /*  626792 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(626867), // Rule ID 6165 //
     /*  626797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626865 */     GIR_RootConstrainSelectedInstOperands,
     /*  626866 */     // GIR_Coverage, 6165,
     /*  626866 */     GIR_EraseRootFromParent_Done,
     /*  626867 */   // Label 10110: @626867
     /*  626867 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(626942), // Rule ID 6168 //
     /*  626872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626940 */     GIR_RootConstrainSelectedInstOperands,
     /*  626941 */     // GIR_Coverage, 6168,
     /*  626941 */     GIR_EraseRootFromParent_Done,
     /*  626942 */   // Label 10111: @626942
     /*  626942 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(627017), // Rule ID 6169 //
     /*  626947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627015 */     GIR_RootConstrainSelectedInstOperands,
     /*  627016 */     // GIR_Coverage, 6169,
     /*  627016 */     GIR_EraseRootFromParent_Done,
     /*  627017 */   // Label 10112: @627017
     /*  627017 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(627092), // Rule ID 6172 //
     /*  627022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627090 */     GIR_RootConstrainSelectedInstOperands,
     /*  627091 */     // GIR_Coverage, 6172,
     /*  627091 */     GIR_EraseRootFromParent_Done,
     /*  627092 */   // Label 10113: @627092
     /*  627092 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(627167), // Rule ID 6173 //
     /*  627097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627165 */     GIR_RootConstrainSelectedInstOperands,
     /*  627166 */     // GIR_Coverage, 6173,
     /*  627166 */     GIR_EraseRootFromParent_Done,
     /*  627167 */   // Label 10114: @627167
     /*  627167 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(627242), // Rule ID 6176 //
     /*  627172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627240 */     GIR_RootConstrainSelectedInstOperands,
     /*  627241 */     // GIR_Coverage, 6176,
     /*  627241 */     GIR_EraseRootFromParent_Done,
     /*  627242 */   // Label 10115: @627242
     /*  627242 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(627317), // Rule ID 6177 //
     /*  627247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627315 */     GIR_RootConstrainSelectedInstOperands,
     /*  627316 */     // GIR_Coverage, 6177,
     /*  627316 */     GIR_EraseRootFromParent_Done,
     /*  627317 */   // Label 10116: @627317
     /*  627317 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(627392), // Rule ID 6180 //
     /*  627322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627390 */     GIR_RootConstrainSelectedInstOperands,
     /*  627391 */     // GIR_Coverage, 6180,
     /*  627391 */     GIR_EraseRootFromParent_Done,
     /*  627392 */   // Label 10117: @627392
     /*  627392 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(627467), // Rule ID 6181 //
     /*  627397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627465 */     GIR_RootConstrainSelectedInstOperands,
     /*  627466 */     // GIR_Coverage, 6181,
     /*  627466 */     GIR_EraseRootFromParent_Done,
     /*  627467 */   // Label 10118: @627467
     /*  627467 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(627542), // Rule ID 6184 //
     /*  627472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627540 */     GIR_RootConstrainSelectedInstOperands,
     /*  627541 */     // GIR_Coverage, 6184,
     /*  627541 */     GIR_EraseRootFromParent_Done,
     /*  627542 */   // Label 10119: @627542
     /*  627542 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(627617), // Rule ID 6185 //
     /*  627547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627593 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627615 */     GIR_RootConstrainSelectedInstOperands,
     /*  627616 */     // GIR_Coverage, 6185,
     /*  627616 */     GIR_EraseRootFromParent_Done,
     /*  627617 */   // Label 10120: @627617
     /*  627617 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(627692), // Rule ID 6188 //
     /*  627622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627690 */     GIR_RootConstrainSelectedInstOperands,
     /*  627691 */     // GIR_Coverage, 6188,
     /*  627691 */     GIR_EraseRootFromParent_Done,
     /*  627692 */   // Label 10121: @627692
     /*  627692 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(627767), // Rule ID 6189 //
     /*  627697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627743 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627765 */     GIR_RootConstrainSelectedInstOperands,
     /*  627766 */     // GIR_Coverage, 6189,
     /*  627766 */     GIR_EraseRootFromParent_Done,
     /*  627767 */   // Label 10122: @627767
     /*  627767 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(627842), // Rule ID 6192 //
     /*  627772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627840 */     GIR_RootConstrainSelectedInstOperands,
     /*  627841 */     // GIR_Coverage, 6192,
     /*  627841 */     GIR_EraseRootFromParent_Done,
     /*  627842 */   // Label 10123: @627842
     /*  627842 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(627917), // Rule ID 6193 //
     /*  627847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627915 */     GIR_RootConstrainSelectedInstOperands,
     /*  627916 */     // GIR_Coverage, 6193,
     /*  627916 */     GIR_EraseRootFromParent_Done,
     /*  627917 */   // Label 10124: @627917
     /*  627917 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(627992), // Rule ID 6196 //
     /*  627922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627990 */     GIR_RootConstrainSelectedInstOperands,
     /*  627991 */     // GIR_Coverage, 6196,
     /*  627991 */     GIR_EraseRootFromParent_Done,
     /*  627992 */   // Label 10125: @627992
     /*  627992 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(628067), // Rule ID 6197 //
     /*  627997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628065 */     GIR_RootConstrainSelectedInstOperands,
     /*  628066 */     // GIR_Coverage, 6197,
     /*  628066 */     GIR_EraseRootFromParent_Done,
     /*  628067 */   // Label 10126: @628067
     /*  628067 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(628142), // Rule ID 6200 //
     /*  628072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628140 */     GIR_RootConstrainSelectedInstOperands,
     /*  628141 */     // GIR_Coverage, 6200,
     /*  628141 */     GIR_EraseRootFromParent_Done,
     /*  628142 */   // Label 10127: @628142
     /*  628142 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(628217), // Rule ID 6201 //
     /*  628147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628215 */     GIR_RootConstrainSelectedInstOperands,
     /*  628216 */     // GIR_Coverage, 6201,
     /*  628216 */     GIR_EraseRootFromParent_Done,
     /*  628217 */   // Label 10128: @628217
     /*  628217 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(628292), // Rule ID 6204 //
     /*  628222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  628271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628290 */     GIR_RootConstrainSelectedInstOperands,
     /*  628291 */     // GIR_Coverage, 6204,
     /*  628291 */     GIR_EraseRootFromParent_Done,
     /*  628292 */   // Label 10129: @628292
     /*  628292 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(628367), // Rule ID 6205 //
     /*  628297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  628346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628365 */     GIR_RootConstrainSelectedInstOperands,
     /*  628366 */     // GIR_Coverage, 6205,
     /*  628366 */     GIR_EraseRootFromParent_Done,
     /*  628367 */   // Label 10130: @628367
     /*  628367 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(628442), // Rule ID 6208 //
     /*  628372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628440 */     GIR_RootConstrainSelectedInstOperands,
     /*  628441 */     // GIR_Coverage, 6208,
     /*  628441 */     GIR_EraseRootFromParent_Done,
     /*  628442 */   // Label 10131: @628442
     /*  628442 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(628517), // Rule ID 6209 //
     /*  628447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628515 */     GIR_RootConstrainSelectedInstOperands,
     /*  628516 */     // GIR_Coverage, 6209,
     /*  628516 */     GIR_EraseRootFromParent_Done,
     /*  628517 */   // Label 10132: @628517
     /*  628517 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(628592), // Rule ID 6212 //
     /*  628522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628590 */     GIR_RootConstrainSelectedInstOperands,
     /*  628591 */     // GIR_Coverage, 6212,
     /*  628591 */     GIR_EraseRootFromParent_Done,
     /*  628592 */   // Label 10133: @628592
     /*  628592 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(628667), // Rule ID 6213 //
     /*  628597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628665 */     GIR_RootConstrainSelectedInstOperands,
     /*  628666 */     // GIR_Coverage, 6213,
     /*  628666 */     GIR_EraseRootFromParent_Done,
     /*  628667 */   // Label 10134: @628667
     /*  628667 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(628742), // Rule ID 6304 //
     /*  628672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628740 */     GIR_RootConstrainSelectedInstOperands,
     /*  628741 */     // GIR_Coverage, 6304,
     /*  628741 */     GIR_EraseRootFromParent_Done,
     /*  628742 */   // Label 10135: @628742
     /*  628742 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(628817), // Rule ID 6305 //
     /*  628747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628815 */     GIR_RootConstrainSelectedInstOperands,
     /*  628816 */     // GIR_Coverage, 6305,
     /*  628816 */     GIR_EraseRootFromParent_Done,
     /*  628817 */   // Label 10136: @628817
     /*  628817 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(628892), // Rule ID 6308 //
     /*  628822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628890 */     GIR_RootConstrainSelectedInstOperands,
     /*  628891 */     // GIR_Coverage, 6308,
     /*  628891 */     GIR_EraseRootFromParent_Done,
     /*  628892 */   // Label 10137: @628892
     /*  628892 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(628967), // Rule ID 6309 //
     /*  628897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628943 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628965 */     GIR_RootConstrainSelectedInstOperands,
     /*  628966 */     // GIR_Coverage, 6309,
     /*  628966 */     GIR_EraseRootFromParent_Done,
     /*  628967 */   // Label 10138: @628967
     /*  628967 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(629042), // Rule ID 6312 //
     /*  628972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629040 */     GIR_RootConstrainSelectedInstOperands,
     /*  629041 */     // GIR_Coverage, 6312,
     /*  629041 */     GIR_EraseRootFromParent_Done,
     /*  629042 */   // Label 10139: @629042
     /*  629042 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(629117), // Rule ID 6313 //
     /*  629047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  629067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629093 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629115 */     GIR_RootConstrainSelectedInstOperands,
     /*  629116 */     // GIR_Coverage, 6313,
     /*  629116 */     GIR_EraseRootFromParent_Done,
     /*  629117 */   // Label 10140: @629117
     /*  629117 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(629192), // Rule ID 6316 //
     /*  629122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  629171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629190 */     GIR_RootConstrainSelectedInstOperands,
     /*  629191 */     // GIR_Coverage, 6316,
     /*  629191 */     GIR_EraseRootFromParent_Done,
     /*  629192 */   // Label 10141: @629192
     /*  629192 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(629267), // Rule ID 6317 //
     /*  629197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  629217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  629246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629265 */     GIR_RootConstrainSelectedInstOperands,
     /*  629266 */     // GIR_Coverage, 6317,
     /*  629266 */     GIR_EraseRootFromParent_Done,
     /*  629267 */   // Label 10142: @629267
     /*  629267 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(629342), // Rule ID 6320 //
     /*  629272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629340 */     GIR_RootConstrainSelectedInstOperands,
     /*  629341 */     // GIR_Coverage, 6320,
     /*  629341 */     GIR_EraseRootFromParent_Done,
     /*  629342 */   // Label 10143: @629342
     /*  629342 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(629417), // Rule ID 6321 //
     /*  629347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  629367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629393 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629415 */     GIR_RootConstrainSelectedInstOperands,
     /*  629416 */     // GIR_Coverage, 6321,
     /*  629416 */     GIR_EraseRootFromParent_Done,
     /*  629417 */   // Label 10144: @629417
     /*  629417 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(629492), // Rule ID 6324 //
     /*  629422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629490 */     GIR_RootConstrainSelectedInstOperands,
     /*  629491 */     // GIR_Coverage, 6324,
     /*  629491 */     GIR_EraseRootFromParent_Done,
     /*  629492 */   // Label 10145: @629492
     /*  629492 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(629567), // Rule ID 6325 //
     /*  629497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629565 */     GIR_RootConstrainSelectedInstOperands,
     /*  629566 */     // GIR_Coverage, 6325,
     /*  629566 */     GIR_EraseRootFromParent_Done,
     /*  629567 */   // Label 10146: @629567
     /*  629567 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(629642), // Rule ID 6328 //
     /*  629572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629640 */     GIR_RootConstrainSelectedInstOperands,
     /*  629641 */     // GIR_Coverage, 6328,
     /*  629641 */     GIR_EraseRootFromParent_Done,
     /*  629642 */   // Label 10147: @629642
     /*  629642 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(629717), // Rule ID 6329 //
     /*  629647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629715 */     GIR_RootConstrainSelectedInstOperands,
     /*  629716 */     // GIR_Coverage, 6329,
     /*  629716 */     GIR_EraseRootFromParent_Done,
     /*  629717 */   // Label 10148: @629717
     /*  629717 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(629792), // Rule ID 6332 //
     /*  629722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629790 */     GIR_RootConstrainSelectedInstOperands,
     /*  629791 */     // GIR_Coverage, 6332,
     /*  629791 */     GIR_EraseRootFromParent_Done,
     /*  629792 */   // Label 10149: @629792
     /*  629792 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(629867), // Rule ID 6333 //
     /*  629797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629865 */     GIR_RootConstrainSelectedInstOperands,
     /*  629866 */     // GIR_Coverage, 6333,
     /*  629866 */     GIR_EraseRootFromParent_Done,
     /*  629867 */   // Label 10150: @629867
     /*  629867 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(629942), // Rule ID 6336 //
     /*  629872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629940 */     GIR_RootConstrainSelectedInstOperands,
     /*  629941 */     // GIR_Coverage, 6336,
     /*  629941 */     GIR_EraseRootFromParent_Done,
     /*  629942 */   // Label 10151: @629942
     /*  629942 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(630017), // Rule ID 6337 //
     /*  629947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630015 */     GIR_RootConstrainSelectedInstOperands,
     /*  630016 */     // GIR_Coverage, 6337,
     /*  630016 */     GIR_EraseRootFromParent_Done,
     /*  630017 */   // Label 10152: @630017
     /*  630017 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(630092), // Rule ID 6340 //
     /*  630022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  630042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  630071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630090 */     GIR_RootConstrainSelectedInstOperands,
     /*  630091 */     // GIR_Coverage, 6340,
     /*  630091 */     GIR_EraseRootFromParent_Done,
     /*  630092 */   // Label 10153: @630092
     /*  630092 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(630167), // Rule ID 6341 //
     /*  630097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  630117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  630146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630165 */     GIR_RootConstrainSelectedInstOperands,
     /*  630166 */     // GIR_Coverage, 6341,
     /*  630166 */     GIR_EraseRootFromParent_Done,
     /*  630167 */   // Label 10154: @630167
     /*  630167 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(630242), // Rule ID 6344 //
     /*  630172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630240 */     GIR_RootConstrainSelectedInstOperands,
     /*  630241 */     // GIR_Coverage, 6344,
     /*  630241 */     GIR_EraseRootFromParent_Done,
     /*  630242 */   // Label 10155: @630242
     /*  630242 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(630317), // Rule ID 6345 //
     /*  630247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  630267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630315 */     GIR_RootConstrainSelectedInstOperands,
     /*  630316 */     // GIR_Coverage, 6345,
     /*  630316 */     GIR_EraseRootFromParent_Done,
     /*  630317 */   // Label 10156: @630317
     /*  630317 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(630392), // Rule ID 6348 //
     /*  630322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630390 */     GIR_RootConstrainSelectedInstOperands,
     /*  630391 */     // GIR_Coverage, 6348,
     /*  630391 */     GIR_EraseRootFromParent_Done,
     /*  630392 */   // Label 10157: @630392
     /*  630392 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(630467), // Rule ID 6349 //
     /*  630397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  630417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630443 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630465 */     GIR_RootConstrainSelectedInstOperands,
     /*  630466 */     // GIR_Coverage, 6349,
     /*  630466 */     GIR_EraseRootFromParent_Done,
     /*  630467 */   // Label 10158: @630467
     /*  630467 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(630542), // Rule ID 6352 //
     /*  630472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630540 */     GIR_RootConstrainSelectedInstOperands,
     /*  630541 */     // GIR_Coverage, 6352,
     /*  630541 */     GIR_EraseRootFromParent_Done,
     /*  630542 */   // Label 10159: @630542
     /*  630542 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(630617), // Rule ID 6353 //
     /*  630547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630593 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630615 */     GIR_RootConstrainSelectedInstOperands,
     /*  630616 */     // GIR_Coverage, 6353,
     /*  630616 */     GIR_EraseRootFromParent_Done,
     /*  630617 */   // Label 10160: @630617
     /*  630617 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(630692), // Rule ID 6356 //
     /*  630622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630690 */     GIR_RootConstrainSelectedInstOperands,
     /*  630691 */     // GIR_Coverage, 6356,
     /*  630691 */     GIR_EraseRootFromParent_Done,
     /*  630692 */   // Label 10161: @630692
     /*  630692 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(630767), // Rule ID 6357 //
     /*  630697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630765 */     GIR_RootConstrainSelectedInstOperands,
     /*  630766 */     // GIR_Coverage, 6357,
     /*  630766 */     GIR_EraseRootFromParent_Done,
     /*  630767 */   // Label 10162: @630767
     /*  630767 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(630842), // Rule ID 6360 //
     /*  630772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630840 */     GIR_RootConstrainSelectedInstOperands,
     /*  630841 */     // GIR_Coverage, 6360,
     /*  630841 */     GIR_EraseRootFromParent_Done,
     /*  630842 */   // Label 10163: @630842
     /*  630842 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(630917), // Rule ID 6361 //
     /*  630847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630893 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630915 */     GIR_RootConstrainSelectedInstOperands,
     /*  630916 */     // GIR_Coverage, 6361,
     /*  630916 */     GIR_EraseRootFromParent_Done,
     /*  630917 */   // Label 10164: @630917
     /*  630917 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(630992), // Rule ID 6364 //
     /*  630922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630990 */     GIR_RootConstrainSelectedInstOperands,
     /*  630991 */     // GIR_Coverage, 6364,
     /*  630991 */     GIR_EraseRootFromParent_Done,
     /*  630992 */   // Label 10165: @630992
     /*  630992 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(631067), // Rule ID 6365 //
     /*  630997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  631017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631043 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631065 */     GIR_RootConstrainSelectedInstOperands,
     /*  631066 */     // GIR_Coverage, 6365,
     /*  631066 */     GIR_EraseRootFromParent_Done,
     /*  631067 */   // Label 10166: @631067
     /*  631067 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(631142), // Rule ID 6368 //
     /*  631072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631140 */     GIR_RootConstrainSelectedInstOperands,
     /*  631141 */     // GIR_Coverage, 6368,
     /*  631141 */     GIR_EraseRootFromParent_Done,
     /*  631142 */   // Label 10167: @631142
     /*  631142 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(631217), // Rule ID 6369 //
     /*  631147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  631167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631215 */     GIR_RootConstrainSelectedInstOperands,
     /*  631216 */     // GIR_Coverage, 6369,
     /*  631216 */     GIR_EraseRootFromParent_Done,
     /*  631217 */   // Label 10168: @631217
     /*  631217 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(631292), // Rule ID 6372 //
     /*  631222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631290 */     GIR_RootConstrainSelectedInstOperands,
     /*  631291 */     // GIR_Coverage, 6372,
     /*  631291 */     GIR_EraseRootFromParent_Done,
     /*  631292 */   // Label 10169: @631292
     /*  631292 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(631367), // Rule ID 6373 //
     /*  631297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  631317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631343 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631365 */     GIR_RootConstrainSelectedInstOperands,
     /*  631366 */     // GIR_Coverage, 6373,
     /*  631366 */     GIR_EraseRootFromParent_Done,
     /*  631367 */   // Label 10170: @631367
     /*  631367 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(631442), // Rule ID 6376 //
     /*  631372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631440 */     GIR_RootConstrainSelectedInstOperands,
     /*  631441 */     // GIR_Coverage, 6376,
     /*  631441 */     GIR_EraseRootFromParent_Done,
     /*  631442 */   // Label 10171: @631442
     /*  631442 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(631517), // Rule ID 6377 //
     /*  631447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631493 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631515 */     GIR_RootConstrainSelectedInstOperands,
     /*  631516 */     // GIR_Coverage, 6377,
     /*  631516 */     GIR_EraseRootFromParent_Done,
     /*  631517 */   // Label 10172: @631517
     /*  631517 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(631592), // Rule ID 6380 //
     /*  631522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631590 */     GIR_RootConstrainSelectedInstOperands,
     /*  631591 */     // GIR_Coverage, 6380,
     /*  631591 */     GIR_EraseRootFromParent_Done,
     /*  631592 */   // Label 10173: @631592
     /*  631592 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(631667), // Rule ID 6381 //
     /*  631597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631665 */     GIR_RootConstrainSelectedInstOperands,
     /*  631666 */     // GIR_Coverage, 6381,
     /*  631666 */     GIR_EraseRootFromParent_Done,
     /*  631667 */   // Label 10174: @631667
     /*  631667 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(631742), // Rule ID 6384 //
     /*  631672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631740 */     GIR_RootConstrainSelectedInstOperands,
     /*  631741 */     // GIR_Coverage, 6384,
     /*  631741 */     GIR_EraseRootFromParent_Done,
     /*  631742 */   // Label 10175: @631742
     /*  631742 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(631817), // Rule ID 6385 //
     /*  631747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631815 */     GIR_RootConstrainSelectedInstOperands,
     /*  631816 */     // GIR_Coverage, 6385,
     /*  631816 */     GIR_EraseRootFromParent_Done,
     /*  631817 */   // Label 10176: @631817
     /*  631817 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(631892), // Rule ID 6388 //
     /*  631822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631890 */     GIR_RootConstrainSelectedInstOperands,
     /*  631891 */     // GIR_Coverage, 6388,
     /*  631891 */     GIR_EraseRootFromParent_Done,
     /*  631892 */   // Label 10177: @631892
     /*  631892 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(631967), // Rule ID 6389 //
     /*  631897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631965 */     GIR_RootConstrainSelectedInstOperands,
     /*  631966 */     // GIR_Coverage, 6389,
     /*  631966 */     GIR_EraseRootFromParent_Done,
     /*  631967 */   // Label 10178: @631967
     /*  631967 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(632042), // Rule ID 6392 //
     /*  631972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  632021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632040 */     GIR_RootConstrainSelectedInstOperands,
     /*  632041 */     // GIR_Coverage, 6392,
     /*  632041 */     GIR_EraseRootFromParent_Done,
     /*  632042 */   // Label 10179: @632042
     /*  632042 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(632117), // Rule ID 6393 //
     /*  632047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632093 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  632096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632115 */     GIR_RootConstrainSelectedInstOperands,
     /*  632116 */     // GIR_Coverage, 6393,
     /*  632116 */     GIR_EraseRootFromParent_Done,
     /*  632117 */   // Label 10180: @632117
     /*  632117 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(632192), // Rule ID 6396 //
     /*  632122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632190 */     GIR_RootConstrainSelectedInstOperands,
     /*  632191 */     // GIR_Coverage, 6396,
     /*  632191 */     GIR_EraseRootFromParent_Done,
     /*  632192 */   // Label 10181: @632192
     /*  632192 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(632267), // Rule ID 6397 //
     /*  632197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632265 */     GIR_RootConstrainSelectedInstOperands,
     /*  632266 */     // GIR_Coverage, 6397,
     /*  632266 */     GIR_EraseRootFromParent_Done,
     /*  632267 */   // Label 10182: @632267
     /*  632267 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(632342), // Rule ID 6400 //
     /*  632272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632340 */     GIR_RootConstrainSelectedInstOperands,
     /*  632341 */     // GIR_Coverage, 6400,
     /*  632341 */     GIR_EraseRootFromParent_Done,
     /*  632342 */   // Label 10183: @632342
     /*  632342 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(632417), // Rule ID 6401 //
     /*  632347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632415 */     GIR_RootConstrainSelectedInstOperands,
     /*  632416 */     // GIR_Coverage, 6401,
     /*  632416 */     GIR_EraseRootFromParent_Done,
     /*  632417 */   // Label 10184: @632417
     /*  632417 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(632492), // Rule ID 6404 //
     /*  632422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632490 */     GIR_RootConstrainSelectedInstOperands,
     /*  632491 */     // GIR_Coverage, 6404,
     /*  632491 */     GIR_EraseRootFromParent_Done,
     /*  632492 */   // Label 10185: @632492
     /*  632492 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(632567), // Rule ID 6405 //
     /*  632497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632543 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632565 */     GIR_RootConstrainSelectedInstOperands,
     /*  632566 */     // GIR_Coverage, 6405,
     /*  632566 */     GIR_EraseRootFromParent_Done,
     /*  632567 */   // Label 10186: @632567
     /*  632567 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(632642), // Rule ID 6408 //
     /*  632572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632640 */     GIR_RootConstrainSelectedInstOperands,
     /*  632641 */     // GIR_Coverage, 6408,
     /*  632641 */     GIR_EraseRootFromParent_Done,
     /*  632642 */   // Label 10187: @632642
     /*  632642 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(632717), // Rule ID 6409 //
     /*  632647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632715 */     GIR_RootConstrainSelectedInstOperands,
     /*  632716 */     // GIR_Coverage, 6409,
     /*  632716 */     GIR_EraseRootFromParent_Done,
     /*  632717 */   // Label 10188: @632717
     /*  632717 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(632792), // Rule ID 6412 //
     /*  632722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632790 */     GIR_RootConstrainSelectedInstOperands,
     /*  632791 */     // GIR_Coverage, 6412,
     /*  632791 */     GIR_EraseRootFromParent_Done,
     /*  632792 */   // Label 10189: @632792
     /*  632792 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(632867), // Rule ID 6413 //
     /*  632797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632865 */     GIR_RootConstrainSelectedInstOperands,
     /*  632866 */     // GIR_Coverage, 6413,
     /*  632866 */     GIR_EraseRootFromParent_Done,
     /*  632867 */   // Label 10190: @632867
     /*  632867 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(632942), // Rule ID 6416 //
     /*  632872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632940 */     GIR_RootConstrainSelectedInstOperands,
     /*  632941 */     // GIR_Coverage, 6416,
     /*  632941 */     GIR_EraseRootFromParent_Done,
     /*  632942 */   // Label 10191: @632942
     /*  632942 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(633017), // Rule ID 6417 //
     /*  632947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632993 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11731:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633015 */     GIR_RootConstrainSelectedInstOperands,
     /*  633016 */     // GIR_Coverage, 6417,
     /*  633016 */     GIR_EraseRootFromParent_Done,
     /*  633017 */   // Label 10192: @633017
     /*  633017 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(633092), // Rule ID 6420 //
     /*  633022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633090 */     GIR_RootConstrainSelectedInstOperands,
     /*  633091 */     // GIR_Coverage, 6420,
     /*  633091 */     GIR_EraseRootFromParent_Done,
     /*  633092 */   // Label 10193: @633092
     /*  633092 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(633167), // Rule ID 6421 //
     /*  633097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11731:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633165 */     GIR_RootConstrainSelectedInstOperands,
     /*  633166 */     // GIR_Coverage, 6421,
     /*  633166 */     GIR_EraseRootFromParent_Done,
     /*  633167 */   // Label 10194: @633167
     /*  633167 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(633242), // Rule ID 6424 //
     /*  633172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633240 */     GIR_RootConstrainSelectedInstOperands,
     /*  633241 */     // GIR_Coverage, 6424,
     /*  633241 */     GIR_EraseRootFromParent_Done,
     /*  633242 */   // Label 10195: @633242
     /*  633242 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(633317), // Rule ID 6425 //
     /*  633247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11731:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633315 */     GIR_RootConstrainSelectedInstOperands,
     /*  633316 */     // GIR_Coverage, 6425,
     /*  633316 */     GIR_EraseRootFromParent_Done,
     /*  633317 */   // Label 10196: @633317
     /*  633317 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(633392), // Rule ID 6428 //
     /*  633322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633390 */     GIR_RootConstrainSelectedInstOperands,
     /*  633391 */     // GIR_Coverage, 6428,
     /*  633391 */     GIR_EraseRootFromParent_Done,
     /*  633392 */   // Label 10197: @633392
     /*  633392 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(633467), // Rule ID 6429 //
     /*  633397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11731:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  633446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633465 */     GIR_RootConstrainSelectedInstOperands,
     /*  633466 */     // GIR_Coverage, 6429,
     /*  633466 */     GIR_EraseRootFromParent_Done,
     /*  633467 */   // Label 10198: @633467
     /*  633467 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(633542), // Rule ID 6432 //
     /*  633472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633540 */     GIR_RootConstrainSelectedInstOperands,
     /*  633541 */     // GIR_Coverage, 6432,
     /*  633541 */     GIR_EraseRootFromParent_Done,
     /*  633542 */   // Label 10199: @633542
     /*  633542 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(633617), // Rule ID 6433 //
     /*  633547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633615 */     GIR_RootConstrainSelectedInstOperands,
     /*  633616 */     // GIR_Coverage, 6433,
     /*  633616 */     GIR_EraseRootFromParent_Done,
     /*  633617 */   // Label 10200: @633617
     /*  633617 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(633692), // Rule ID 6436 //
     /*  633622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633690 */     GIR_RootConstrainSelectedInstOperands,
     /*  633691 */     // GIR_Coverage, 6436,
     /*  633691 */     GIR_EraseRootFromParent_Done,
     /*  633692 */   // Label 10201: @633692
     /*  633692 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(633767), // Rule ID 6437 //
     /*  633697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633743 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633765 */     GIR_RootConstrainSelectedInstOperands,
     /*  633766 */     // GIR_Coverage, 6437,
     /*  633766 */     GIR_EraseRootFromParent_Done,
     /*  633767 */   // Label 10202: @633767
     /*  633767 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(633842), // Rule ID 6440 //
     /*  633772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633840 */     GIR_RootConstrainSelectedInstOperands,
     /*  633841 */     // GIR_Coverage, 6440,
     /*  633841 */     GIR_EraseRootFromParent_Done,
     /*  633842 */   // Label 10203: @633842
     /*  633842 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(633917), // Rule ID 6441 //
     /*  633847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633915 */     GIR_RootConstrainSelectedInstOperands,
     /*  633916 */     // GIR_Coverage, 6441,
     /*  633916 */     GIR_EraseRootFromParent_Done,
     /*  633917 */   // Label 10204: @633917
     /*  633917 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(633992), // Rule ID 6444 //
     /*  633922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633990 */     GIR_RootConstrainSelectedInstOperands,
     /*  633991 */     // GIR_Coverage, 6444,
     /*  633991 */     GIR_EraseRootFromParent_Done,
     /*  633992 */   // Label 10205: @633992
     /*  633992 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(634067), // Rule ID 6445 //
     /*  633997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634065 */     GIR_RootConstrainSelectedInstOperands,
     /*  634066 */     // GIR_Coverage, 6445,
     /*  634066 */     GIR_EraseRootFromParent_Done,
     /*  634067 */   // Label 10206: @634067
     /*  634067 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(634142), // Rule ID 6448 //
     /*  634072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634140 */     GIR_RootConstrainSelectedInstOperands,
     /*  634141 */     // GIR_Coverage, 6448,
     /*  634141 */     GIR_EraseRootFromParent_Done,
     /*  634142 */   // Label 10207: @634142
     /*  634142 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(634217), // Rule ID 6449 //
     /*  634147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634215 */     GIR_RootConstrainSelectedInstOperands,
     /*  634216 */     // GIR_Coverage, 6449,
     /*  634216 */     GIR_EraseRootFromParent_Done,
     /*  634217 */   // Label 10208: @634217
     /*  634217 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(634292), // Rule ID 6452 //
     /*  634222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634290 */     GIR_RootConstrainSelectedInstOperands,
     /*  634291 */     // GIR_Coverage, 6452,
     /*  634291 */     GIR_EraseRootFromParent_Done,
     /*  634292 */   // Label 10209: @634292
     /*  634292 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(634367), // Rule ID 6453 //
     /*  634297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634365 */     GIR_RootConstrainSelectedInstOperands,
     /*  634366 */     // GIR_Coverage, 6453,
     /*  634366 */     GIR_EraseRootFromParent_Done,
     /*  634367 */   // Label 10210: @634367
     /*  634367 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(634442), // Rule ID 6456 //
     /*  634372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634440 */     GIR_RootConstrainSelectedInstOperands,
     /*  634441 */     // GIR_Coverage, 6456,
     /*  634441 */     GIR_EraseRootFromParent_Done,
     /*  634442 */   // Label 10211: @634442
     /*  634442 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(634517), // Rule ID 6457 //
     /*  634447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634515 */     GIR_RootConstrainSelectedInstOperands,
     /*  634516 */     // GIR_Coverage, 6457,
     /*  634516 */     GIR_EraseRootFromParent_Done,
     /*  634517 */   // Label 10212: @634517
     /*  634517 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(634592), // Rule ID 6460 //
     /*  634522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634590 */     GIR_RootConstrainSelectedInstOperands,
     /*  634591 */     // GIR_Coverage, 6460,
     /*  634591 */     GIR_EraseRootFromParent_Done,
     /*  634592 */   // Label 10213: @634592
     /*  634592 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(634667), // Rule ID 6461 //
     /*  634597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634665 */     GIR_RootConstrainSelectedInstOperands,
     /*  634666 */     // GIR_Coverage, 6461,
     /*  634666 */     GIR_EraseRootFromParent_Done,
     /*  634667 */   // Label 10214: @634667
     /*  634667 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(634742), // Rule ID 6464 //
     /*  634672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634740 */     GIR_RootConstrainSelectedInstOperands,
     /*  634741 */     // GIR_Coverage, 6464,
     /*  634741 */     GIR_EraseRootFromParent_Done,
     /*  634742 */   // Label 10215: @634742
     /*  634742 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(634817), // Rule ID 6465 //
     /*  634747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634815 */     GIR_RootConstrainSelectedInstOperands,
     /*  634816 */     // GIR_Coverage, 6465,
     /*  634816 */     GIR_EraseRootFromParent_Done,
     /*  634817 */   // Label 10216: @634817
     /*  634817 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(634892), // Rule ID 6468 //
     /*  634822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634890 */     GIR_RootConstrainSelectedInstOperands,
     /*  634891 */     // GIR_Coverage, 6468,
     /*  634891 */     GIR_EraseRootFromParent_Done,
     /*  634892 */   // Label 10217: @634892
     /*  634892 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(634967), // Rule ID 6469 //
     /*  634897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11731:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634965 */     GIR_RootConstrainSelectedInstOperands,
     /*  634966 */     // GIR_Coverage, 6469,
     /*  634966 */     GIR_EraseRootFromParent_Done,
     /*  634967 */   // Label 10218: @634967
     /*  634967 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(635042), // Rule ID 6472 //
     /*  634972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  635021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635040 */     GIR_RootConstrainSelectedInstOperands,
     /*  635041 */     // GIR_Coverage, 6472,
     /*  635041 */     GIR_EraseRootFromParent_Done,
     /*  635042 */   // Label 10219: @635042
     /*  635042 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(635117), // Rule ID 6473 //
     /*  635047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11731:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  635096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635115 */     GIR_RootConstrainSelectedInstOperands,
     /*  635116 */     // GIR_Coverage, 6473,
     /*  635116 */     GIR_EraseRootFromParent_Done,
     /*  635117 */   // Label 10220: @635117
     /*  635117 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(635192), // Rule ID 6476 //
     /*  635122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  635171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635190 */     GIR_RootConstrainSelectedInstOperands,
     /*  635191 */     // GIR_Coverage, 6476,
     /*  635191 */     GIR_EraseRootFromParent_Done,
     /*  635192 */   // Label 10221: @635192
     /*  635192 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(635267), // Rule ID 6477 //
     /*  635197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11731:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  635246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635265 */     GIR_RootConstrainSelectedInstOperands,
     /*  635266 */     // GIR_Coverage, 6477,
     /*  635266 */     GIR_EraseRootFromParent_Done,
     /*  635267 */   // Label 10222: @635267
     /*  635267 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(635342), // Rule ID 6568 //
     /*  635272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  635321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635340 */     GIR_RootConstrainSelectedInstOperands,
     /*  635341 */     // GIR_Coverage, 6568,
     /*  635341 */     GIR_EraseRootFromParent_Done,
     /*  635342 */   // Label 10223: @635342
     /*  635342 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(635417), // Rule ID 6569 //
     /*  635347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  635367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635393 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  635396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635415 */     GIR_RootConstrainSelectedInstOperands,
     /*  635416 */     // GIR_Coverage, 6569,
     /*  635416 */     GIR_EraseRootFromParent_Done,
     /*  635417 */   // Label 10224: @635417
     /*  635417 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(635492), // Rule ID 6572 //
     /*  635422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635490 */     GIR_RootConstrainSelectedInstOperands,
     /*  635491 */     // GIR_Coverage, 6572,
     /*  635491 */     GIR_EraseRootFromParent_Done,
     /*  635492 */   // Label 10225: @635492
     /*  635492 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(635567), // Rule ID 6573 //
     /*  635497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635543 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635565 */     GIR_RootConstrainSelectedInstOperands,
     /*  635566 */     // GIR_Coverage, 6573,
     /*  635566 */     GIR_EraseRootFromParent_Done,
     /*  635567 */   // Label 10226: @635567
     /*  635567 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(635642), // Rule ID 6576 //
     /*  635572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635640 */     GIR_RootConstrainSelectedInstOperands,
     /*  635641 */     // GIR_Coverage, 6576,
     /*  635641 */     GIR_EraseRootFromParent_Done,
     /*  635642 */   // Label 10227: @635642
     /*  635642 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(635717), // Rule ID 6577 //
     /*  635647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635693 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635715 */     GIR_RootConstrainSelectedInstOperands,
     /*  635716 */     // GIR_Coverage, 6577,
     /*  635716 */     GIR_EraseRootFromParent_Done,
     /*  635717 */   // Label 10228: @635717
     /*  635717 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(635792), // Rule ID 6580 //
     /*  635722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635790 */     GIR_RootConstrainSelectedInstOperands,
     /*  635791 */     // GIR_Coverage, 6580,
     /*  635791 */     GIR_EraseRootFromParent_Done,
     /*  635792 */   // Label 10229: @635792
     /*  635792 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(635867), // Rule ID 6581 //
     /*  635797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635865 */     GIR_RootConstrainSelectedInstOperands,
     /*  635866 */     // GIR_Coverage, 6581,
     /*  635866 */     GIR_EraseRootFromParent_Done,
     /*  635867 */   // Label 10230: @635867
     /*  635867 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(635942), // Rule ID 6584 //
     /*  635872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635940 */     GIR_RootConstrainSelectedInstOperands,
     /*  635941 */     // GIR_Coverage, 6584,
     /*  635941 */     GIR_EraseRootFromParent_Done,
     /*  635942 */   // Label 10231: @635942
     /*  635942 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(636017), // Rule ID 6585 //
     /*  635947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636015 */     GIR_RootConstrainSelectedInstOperands,
     /*  636016 */     // GIR_Coverage, 6585,
     /*  636016 */     GIR_EraseRootFromParent_Done,
     /*  636017 */   // Label 10232: @636017
     /*  636017 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(636092), // Rule ID 6588 //
     /*  636022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  636042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  636071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636090 */     GIR_RootConstrainSelectedInstOperands,
     /*  636091 */     // GIR_Coverage, 6588,
     /*  636091 */     GIR_EraseRootFromParent_Done,
     /*  636092 */   // Label 10233: @636092
     /*  636092 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(636167), // Rule ID 6589 //
     /*  636097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  636117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  636146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636165 */     GIR_RootConstrainSelectedInstOperands,
     /*  636166 */     // GIR_Coverage, 6589,
     /*  636166 */     GIR_EraseRootFromParent_Done,
     /*  636167 */   // Label 10234: @636167
     /*  636167 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(636242), // Rule ID 6592 //
     /*  636172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636240 */     GIR_RootConstrainSelectedInstOperands,
     /*  636241 */     // GIR_Coverage, 6592,
     /*  636241 */     GIR_EraseRootFromParent_Done,
     /*  636242 */   // Label 10235: @636242
     /*  636242 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(636317), // Rule ID 6593 //
     /*  636247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  636267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636315 */     GIR_RootConstrainSelectedInstOperands,
     /*  636316 */     // GIR_Coverage, 6593,
     /*  636316 */     GIR_EraseRootFromParent_Done,
     /*  636317 */   // Label 10236: @636317
     /*  636317 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(636392), // Rule ID 6596 //
     /*  636322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636390 */     GIR_RootConstrainSelectedInstOperands,
     /*  636391 */     // GIR_Coverage, 6596,
     /*  636391 */     GIR_EraseRootFromParent_Done,
     /*  636392 */   // Label 10237: @636392
     /*  636392 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(636467), // Rule ID 6597 //
     /*  636397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  636417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636465 */     GIR_RootConstrainSelectedInstOperands,
     /*  636466 */     // GIR_Coverage, 6597,
     /*  636466 */     GIR_EraseRootFromParent_Done,
     /*  636467 */   // Label 10238: @636467
     /*  636467 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(636542), // Rule ID 6600 //
     /*  636472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636540 */     GIR_RootConstrainSelectedInstOperands,
     /*  636541 */     // GIR_Coverage, 6600,
     /*  636541 */     GIR_EraseRootFromParent_Done,
     /*  636542 */   // Label 10239: @636542
     /*  636542 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(636617), // Rule ID 6601 //
     /*  636547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636615 */     GIR_RootConstrainSelectedInstOperands,
     /*  636616 */     // GIR_Coverage, 6601,
     /*  636616 */     GIR_EraseRootFromParent_Done,
     /*  636617 */   // Label 10240: @636617
     /*  636617 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(636692), // Rule ID 6604 //
     /*  636622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636690 */     GIR_RootConstrainSelectedInstOperands,
     /*  636691 */     // GIR_Coverage, 6604,
     /*  636691 */     GIR_EraseRootFromParent_Done,
     /*  636692 */   // Label 10241: @636692
     /*  636692 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(636767), // Rule ID 6605 //
     /*  636697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636765 */     GIR_RootConstrainSelectedInstOperands,
     /*  636766 */     // GIR_Coverage, 6605,
     /*  636766 */     GIR_EraseRootFromParent_Done,
     /*  636767 */   // Label 10242: @636767
     /*  636767 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(636842), // Rule ID 6608 //
     /*  636772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636840 */     GIR_RootConstrainSelectedInstOperands,
     /*  636841 */     // GIR_Coverage, 6608,
     /*  636841 */     GIR_EraseRootFromParent_Done,
     /*  636842 */   // Label 10243: @636842
     /*  636842 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(636917), // Rule ID 6609 //
     /*  636847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636915 */     GIR_RootConstrainSelectedInstOperands,
     /*  636916 */     // GIR_Coverage, 6609,
     /*  636916 */     GIR_EraseRootFromParent_Done,
     /*  636917 */   // Label 10244: @636917
     /*  636917 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(636992), // Rule ID 6612 //
     /*  636922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636990 */     GIR_RootConstrainSelectedInstOperands,
     /*  636991 */     // GIR_Coverage, 6612,
     /*  636991 */     GIR_EraseRootFromParent_Done,
     /*  636992 */   // Label 10245: @636992
     /*  636992 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(637067), // Rule ID 6613 //
     /*  636997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  637017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637043 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637065 */     GIR_RootConstrainSelectedInstOperands,
     /*  637066 */     // GIR_Coverage, 6613,
     /*  637066 */     GIR_EraseRootFromParent_Done,
     /*  637067 */   // Label 10246: @637067
     /*  637067 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(637142), // Rule ID 6616 //
     /*  637072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637140 */     GIR_RootConstrainSelectedInstOperands,
     /*  637141 */     // GIR_Coverage, 6616,
     /*  637141 */     GIR_EraseRootFromParent_Done,
     /*  637142 */   // Label 10247: @637142
     /*  637142 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(637217), // Rule ID 6617 //
     /*  637147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  637167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637193 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637215 */     GIR_RootConstrainSelectedInstOperands,
     /*  637216 */     // GIR_Coverage, 6617,
     /*  637216 */     GIR_EraseRootFromParent_Done,
     /*  637217 */   // Label 10248: @637217
     /*  637217 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(637292), // Rule ID 6620 //
     /*  637222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637290 */     GIR_RootConstrainSelectedInstOperands,
     /*  637291 */     // GIR_Coverage, 6620,
     /*  637291 */     GIR_EraseRootFromParent_Done,
     /*  637292 */   // Label 10249: @637292
     /*  637292 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(637367), // Rule ID 6621 //
     /*  637297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  637317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637365 */     GIR_RootConstrainSelectedInstOperands,
     /*  637366 */     // GIR_Coverage, 6621,
     /*  637366 */     GIR_EraseRootFromParent_Done,
     /*  637367 */   // Label 10250: @637367
     /*  637367 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(637442), // Rule ID 6624 //
     /*  637372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637440 */     GIR_RootConstrainSelectedInstOperands,
     /*  637441 */     // GIR_Coverage, 6624,
     /*  637441 */     GIR_EraseRootFromParent_Done,
     /*  637442 */   // Label 10251: @637442
     /*  637442 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(637517), // Rule ID 6625 //
     /*  637447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637515 */     GIR_RootConstrainSelectedInstOperands,
     /*  637516 */     // GIR_Coverage, 6625,
     /*  637516 */     GIR_EraseRootFromParent_Done,
     /*  637517 */   // Label 10252: @637517
     /*  637517 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(637592), // Rule ID 6628 //
     /*  637522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637590 */     GIR_RootConstrainSelectedInstOperands,
     /*  637591 */     // GIR_Coverage, 6628,
     /*  637591 */     GIR_EraseRootFromParent_Done,
     /*  637592 */   // Label 10253: @637592
     /*  637592 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(637667), // Rule ID 6629 //
     /*  637597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637665 */     GIR_RootConstrainSelectedInstOperands,
     /*  637666 */     // GIR_Coverage, 6629,
     /*  637666 */     GIR_EraseRootFromParent_Done,
     /*  637667 */   // Label 10254: @637667
     /*  637667 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(637742), // Rule ID 6632 //
     /*  637672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637740 */     GIR_RootConstrainSelectedInstOperands,
     /*  637741 */     // GIR_Coverage, 6632,
     /*  637741 */     GIR_EraseRootFromParent_Done,
     /*  637742 */   // Label 10255: @637742
     /*  637742 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(637817), // Rule ID 6633 //
     /*  637747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637815 */     GIR_RootConstrainSelectedInstOperands,
     /*  637816 */     // GIR_Coverage, 6633,
     /*  637816 */     GIR_EraseRootFromParent_Done,
     /*  637817 */   // Label 10256: @637817
     /*  637817 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(637892), // Rule ID 6636 //
     /*  637822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637890 */     GIR_RootConstrainSelectedInstOperands,
     /*  637891 */     // GIR_Coverage, 6636,
     /*  637891 */     GIR_EraseRootFromParent_Done,
     /*  637892 */   // Label 10257: @637892
     /*  637892 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(637967), // Rule ID 6637 //
     /*  637897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637965 */     GIR_RootConstrainSelectedInstOperands,
     /*  637966 */     // GIR_Coverage, 6637,
     /*  637966 */     GIR_EraseRootFromParent_Done,
     /*  637967 */   // Label 10258: @637967
     /*  637967 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(638042), // Rule ID 6640 //
     /*  637972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638040 */     GIR_RootConstrainSelectedInstOperands,
     /*  638041 */     // GIR_Coverage, 6640,
     /*  638041 */     GIR_EraseRootFromParent_Done,
     /*  638042 */   // Label 10259: @638042
     /*  638042 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(638117), // Rule ID 6641 //
     /*  638047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  638067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638115 */     GIR_RootConstrainSelectedInstOperands,
     /*  638116 */     // GIR_Coverage, 6641,
     /*  638116 */     GIR_EraseRootFromParent_Done,
     /*  638117 */   // Label 10260: @638117
     /*  638117 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(638192), // Rule ID 6644 //
     /*  638122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  638171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638190 */     GIR_RootConstrainSelectedInstOperands,
     /*  638191 */     // GIR_Coverage, 6644,
     /*  638191 */     GIR_EraseRootFromParent_Done,
     /*  638192 */   // Label 10261: @638192
     /*  638192 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(638267), // Rule ID 6645 //
     /*  638197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  638217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  638246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638265 */     GIR_RootConstrainSelectedInstOperands,
     /*  638266 */     // GIR_Coverage, 6645,
     /*  638266 */     GIR_EraseRootFromParent_Done,
     /*  638267 */   // Label 10262: @638267
     /*  638267 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(638342), // Rule ID 6648 //
     /*  638272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  638321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638340 */     GIR_RootConstrainSelectedInstOperands,
     /*  638341 */     // GIR_Coverage, 6648,
     /*  638341 */     GIR_EraseRootFromParent_Done,
     /*  638342 */   // Label 10263: @638342
     /*  638342 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(638417), // Rule ID 6649 //
     /*  638347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  638367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  638396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638415 */     GIR_RootConstrainSelectedInstOperands,
     /*  638416 */     // GIR_Coverage, 6649,
     /*  638416 */     GIR_EraseRootFromParent_Done,
     /*  638417 */   // Label 10264: @638417
     /*  638417 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(638492), // Rule ID 6652 //
     /*  638422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638490 */     GIR_RootConstrainSelectedInstOperands,
     /*  638491 */     // GIR_Coverage, 6652,
     /*  638491 */     GIR_EraseRootFromParent_Done,
     /*  638492 */   // Label 10265: @638492
     /*  638492 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(638567), // Rule ID 6653 //
     /*  638497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638565 */     GIR_RootConstrainSelectedInstOperands,
     /*  638566 */     // GIR_Coverage, 6653,
     /*  638566 */     GIR_EraseRootFromParent_Done,
     /*  638567 */   // Label 10266: @638567
     /*  638567 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(638642), // Rule ID 6656 //
     /*  638572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638640 */     GIR_RootConstrainSelectedInstOperands,
     /*  638641 */     // GIR_Coverage, 6656,
     /*  638641 */     GIR_EraseRootFromParent_Done,
     /*  638642 */   // Label 10267: @638642
     /*  638642 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(638717), // Rule ID 6657 //
     /*  638647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638715 */     GIR_RootConstrainSelectedInstOperands,
     /*  638716 */     // GIR_Coverage, 6657,
     /*  638716 */     GIR_EraseRootFromParent_Done,
     /*  638717 */   // Label 10268: @638717
     /*  638717 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(638792), // Rule ID 6660 //
     /*  638722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638790 */     GIR_RootConstrainSelectedInstOperands,
     /*  638791 */     // GIR_Coverage, 6660,
     /*  638791 */     GIR_EraseRootFromParent_Done,
     /*  638792 */   // Label 10269: @638792
     /*  638792 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(638867), // Rule ID 6661 //
     /*  638797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638865 */     GIR_RootConstrainSelectedInstOperands,
     /*  638866 */     // GIR_Coverage, 6661,
     /*  638866 */     GIR_EraseRootFromParent_Done,
     /*  638867 */   // Label 10270: @638867
     /*  638867 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(638942), // Rule ID 6664 //
     /*  638872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638940 */     GIR_RootConstrainSelectedInstOperands,
     /*  638941 */     // GIR_Coverage, 6664,
     /*  638941 */     GIR_EraseRootFromParent_Done,
     /*  638942 */   // Label 10271: @638942
     /*  638942 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(639017), // Rule ID 6665 //
     /*  638947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639015 */     GIR_RootConstrainSelectedInstOperands,
     /*  639016 */     // GIR_Coverage, 6665,
     /*  639016 */     GIR_EraseRootFromParent_Done,
     /*  639017 */   // Label 10272: @639017
     /*  639017 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(639092), // Rule ID 6668 //
     /*  639022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  639071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639090 */     GIR_RootConstrainSelectedInstOperands,
     /*  639091 */     // GIR_Coverage, 6668,
     /*  639091 */     GIR_EraseRootFromParent_Done,
     /*  639092 */   // Label 10273: @639092
     /*  639092 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(639167), // Rule ID 6669 //
     /*  639097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  639146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639165 */     GIR_RootConstrainSelectedInstOperands,
     /*  639166 */     // GIR_Coverage, 6669,
     /*  639166 */     GIR_EraseRootFromParent_Done,
     /*  639167 */   // Label 10274: @639167
     /*  639167 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(639242), // Rule ID 6672 //
     /*  639172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639240 */     GIR_RootConstrainSelectedInstOperands,
     /*  639241 */     // GIR_Coverage, 6672,
     /*  639241 */     GIR_EraseRootFromParent_Done,
     /*  639242 */   // Label 10275: @639242
     /*  639242 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(639317), // Rule ID 6673 //
     /*  639247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639315 */     GIR_RootConstrainSelectedInstOperands,
     /*  639316 */     // GIR_Coverage, 6673,
     /*  639316 */     GIR_EraseRootFromParent_Done,
     /*  639317 */   // Label 10276: @639317
     /*  639317 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(639392), // Rule ID 6676 //
     /*  639322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639390 */     GIR_RootConstrainSelectedInstOperands,
     /*  639391 */     // GIR_Coverage, 6676,
     /*  639391 */     GIR_EraseRootFromParent_Done,
     /*  639392 */   // Label 10277: @639392
     /*  639392 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(639467), // Rule ID 6677 //
     /*  639397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  639446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639465 */     GIR_RootConstrainSelectedInstOperands,
     /*  639466 */     // GIR_Coverage, 6677,
     /*  639466 */     GIR_EraseRootFromParent_Done,
     /*  639467 */   // Label 10278: @639467
     /*  639467 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(639542), // Rule ID 6680 //
     /*  639472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639540 */     GIR_RootConstrainSelectedInstOperands,
     /*  639541 */     // GIR_Coverage, 6680,
     /*  639541 */     GIR_EraseRootFromParent_Done,
     /*  639542 */   // Label 10279: @639542
     /*  639542 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(639617), // Rule ID 6681 //
     /*  639547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11609:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639615 */     GIR_RootConstrainSelectedInstOperands,
     /*  639616 */     // GIR_Coverage, 6681,
     /*  639616 */     GIR_EraseRootFromParent_Done,
     /*  639617 */   // Label 10280: @639617
     /*  639617 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(639692), // Rule ID 6684 //
     /*  639622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639690 */     GIR_RootConstrainSelectedInstOperands,
     /*  639691 */     // GIR_Coverage, 6684,
     /*  639691 */     GIR_EraseRootFromParent_Done,
     /*  639692 */   // Label 10281: @639692
     /*  639692 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(639767), // Rule ID 6685 //
     /*  639697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639765 */     GIR_RootConstrainSelectedInstOperands,
     /*  639766 */     // GIR_Coverage, 6685,
     /*  639766 */     GIR_EraseRootFromParent_Done,
     /*  639767 */   // Label 10282: @639767
     /*  639767 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(639842), // Rule ID 6688 //
     /*  639772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639840 */     GIR_RootConstrainSelectedInstOperands,
     /*  639841 */     // GIR_Coverage, 6688,
     /*  639841 */     GIR_EraseRootFromParent_Done,
     /*  639842 */   // Label 10283: @639842
     /*  639842 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(639917), // Rule ID 6689 //
     /*  639847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639915 */     GIR_RootConstrainSelectedInstOperands,
     /*  639916 */     // GIR_Coverage, 6689,
     /*  639916 */     GIR_EraseRootFromParent_Done,
     /*  639917 */   // Label 10284: @639917
     /*  639917 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(639992), // Rule ID 6692 //
     /*  639922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  639925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  639968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639990 */     GIR_RootConstrainSelectedInstOperands,
     /*  639991 */     // GIR_Coverage, 6692,
     /*  639991 */     GIR_EraseRootFromParent_Done,
     /*  639992 */   // Label 10285: @639992
     /*  639992 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(640067), // Rule ID 6693 //
     /*  639997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  640046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640065 */     GIR_RootConstrainSelectedInstOperands,
     /*  640066 */     // GIR_Coverage, 6693,
     /*  640066 */     GIR_EraseRootFromParent_Done,
     /*  640067 */   // Label 10286: @640067
     /*  640067 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(640142), // Rule ID 6696 //
     /*  640072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640140 */     GIR_RootConstrainSelectedInstOperands,
     /*  640141 */     // GIR_Coverage, 6696,
     /*  640141 */     GIR_EraseRootFromParent_Done,
     /*  640142 */   // Label 10287: @640142
     /*  640142 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(640217), // Rule ID 6697 //
     /*  640147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640215 */     GIR_RootConstrainSelectedInstOperands,
     /*  640216 */     // GIR_Coverage, 6697,
     /*  640216 */     GIR_EraseRootFromParent_Done,
     /*  640217 */   // Label 10288: @640217
     /*  640217 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(640292), // Rule ID 6700 //
     /*  640222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640290 */     GIR_RootConstrainSelectedInstOperands,
     /*  640291 */     // GIR_Coverage, 6700,
     /*  640291 */     GIR_EraseRootFromParent_Done,
     /*  640292 */   // Label 10289: @640292
     /*  640292 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(640367), // Rule ID 6701 //
     /*  640297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640365 */     GIR_RootConstrainSelectedInstOperands,
     /*  640366 */     // GIR_Coverage, 6701,
     /*  640366 */     GIR_EraseRootFromParent_Done,
     /*  640367 */   // Label 10290: @640367
     /*  640367 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(640442), // Rule ID 6704 //
     /*  640372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640440 */     GIR_RootConstrainSelectedInstOperands,
     /*  640441 */     // GIR_Coverage, 6704,
     /*  640441 */     GIR_EraseRootFromParent_Done,
     /*  640442 */   // Label 10291: @640442
     /*  640442 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(640517), // Rule ID 6705 //
     /*  640447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640493 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640515 */     GIR_RootConstrainSelectedInstOperands,
     /*  640516 */     // GIR_Coverage, 6705,
     /*  640516 */     GIR_EraseRootFromParent_Done,
     /*  640517 */   // Label 10292: @640517
     /*  640517 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(640592), // Rule ID 6708 //
     /*  640522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640590 */     GIR_RootConstrainSelectedInstOperands,
     /*  640591 */     // GIR_Coverage, 6708,
     /*  640591 */     GIR_EraseRootFromParent_Done,
     /*  640592 */   // Label 10293: @640592
     /*  640592 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(640667), // Rule ID 6709 //
     /*  640597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640665 */     GIR_RootConstrainSelectedInstOperands,
     /*  640666 */     // GIR_Coverage, 6709,
     /*  640666 */     GIR_EraseRootFromParent_Done,
     /*  640667 */   // Label 10294: @640667
     /*  640667 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(640742), // Rule ID 6712 //
     /*  640672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640740 */     GIR_RootConstrainSelectedInstOperands,
     /*  640741 */     // GIR_Coverage, 6712,
     /*  640741 */     GIR_EraseRootFromParent_Done,
     /*  640742 */   // Label 10295: @640742
     /*  640742 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(640817), // Rule ID 6713 //
     /*  640747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640815 */     GIR_RootConstrainSelectedInstOperands,
     /*  640816 */     // GIR_Coverage, 6713,
     /*  640816 */     GIR_EraseRootFromParent_Done,
     /*  640817 */   // Label 10296: @640817
     /*  640817 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(640892), // Rule ID 6716 //
     /*  640822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640890 */     GIR_RootConstrainSelectedInstOperands,
     /*  640891 */     // GIR_Coverage, 6716,
     /*  640891 */     GIR_EraseRootFromParent_Done,
     /*  640892 */   // Label 10297: @640892
     /*  640892 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(640967), // Rule ID 6717 //
     /*  640897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640965 */     GIR_RootConstrainSelectedInstOperands,
     /*  640966 */     // GIR_Coverage, 6717,
     /*  640966 */     GIR_EraseRootFromParent_Done,
     /*  640967 */   // Label 10298: @640967
     /*  640967 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(641042), // Rule ID 6720 //
     /*  640972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641040 */     GIR_RootConstrainSelectedInstOperands,
     /*  641041 */     // GIR_Coverage, 6720,
     /*  641041 */     GIR_EraseRootFromParent_Done,
     /*  641042 */   // Label 10299: @641042
     /*  641042 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(641117), // Rule ID 6721 //
     /*  641047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641115 */     GIR_RootConstrainSelectedInstOperands,
     /*  641116 */     // GIR_Coverage, 6721,
     /*  641116 */     GIR_EraseRootFromParent_Done,
     /*  641117 */   // Label 10300: @641117
     /*  641117 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(641192), // Rule ID 6724 //
     /*  641122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641190 */     GIR_RootConstrainSelectedInstOperands,
     /*  641191 */     // GIR_Coverage, 6724,
     /*  641191 */     GIR_EraseRootFromParent_Done,
     /*  641192 */   // Label 10301: @641192
     /*  641192 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(641267), // Rule ID 6725 //
     /*  641197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641265 */     GIR_RootConstrainSelectedInstOperands,
     /*  641266 */     // GIR_Coverage, 6725,
     /*  641266 */     GIR_EraseRootFromParent_Done,
     /*  641267 */   // Label 10302: @641267
     /*  641267 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(641342), // Rule ID 6728 //
     /*  641272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641340 */     GIR_RootConstrainSelectedInstOperands,
     /*  641341 */     // GIR_Coverage, 6728,
     /*  641341 */     GIR_EraseRootFromParent_Done,
     /*  641342 */   // Label 10303: @641342
     /*  641342 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(641417), // Rule ID 6729 //
     /*  641347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641415 */     GIR_RootConstrainSelectedInstOperands,
     /*  641416 */     // GIR_Coverage, 6729,
     /*  641416 */     GIR_EraseRootFromParent_Done,
     /*  641417 */   // Label 10304: @641417
     /*  641417 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(641492), // Rule ID 6732 //
     /*  641422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641490 */     GIR_RootConstrainSelectedInstOperands,
     /*  641491 */     // GIR_Coverage, 6732,
     /*  641491 */     GIR_EraseRootFromParent_Done,
     /*  641492 */   // Label 10305: @641492
     /*  641492 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(641567), // Rule ID 6733 //
     /*  641497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641565 */     GIR_RootConstrainSelectedInstOperands,
     /*  641566 */     // GIR_Coverage, 6733,
     /*  641566 */     GIR_EraseRootFromParent_Done,
     /*  641567 */   // Label 10306: @641567
     /*  641567 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(641642), // Rule ID 6736 //
     /*  641572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641640 */     GIR_RootConstrainSelectedInstOperands,
     /*  641641 */     // GIR_Coverage, 6736,
     /*  641641 */     GIR_EraseRootFromParent_Done,
     /*  641642 */   // Label 10307: @641642
     /*  641642 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(641717), // Rule ID 6737 //
     /*  641647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641715 */     GIR_RootConstrainSelectedInstOperands,
     /*  641716 */     // GIR_Coverage, 6737,
     /*  641716 */     GIR_EraseRootFromParent_Done,
     /*  641717 */   // Label 10308: @641717
     /*  641717 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(641792), // Rule ID 6740 //
     /*  641722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641790 */     GIR_RootConstrainSelectedInstOperands,
     /*  641791 */     // GIR_Coverage, 6740,
     /*  641791 */     GIR_EraseRootFromParent_Done,
     /*  641792 */   // Label 10309: @641792
     /*  641792 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(641867), // Rule ID 6741 //
     /*  641797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641865 */     GIR_RootConstrainSelectedInstOperands,
     /*  641866 */     // GIR_Coverage, 6741,
     /*  641866 */     GIR_EraseRootFromParent_Done,
     /*  641867 */   // Label 10310: @641867
     /*  641867 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(641942), // Rule ID 6832 //
     /*  641872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641940 */     GIR_RootConstrainSelectedInstOperands,
     /*  641941 */     // GIR_Coverage, 6832,
     /*  641941 */     GIR_EraseRootFromParent_Done,
     /*  641942 */   // Label 10311: @641942
     /*  641942 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(642017), // Rule ID 6833 //
     /*  641947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642015 */     GIR_RootConstrainSelectedInstOperands,
     /*  642016 */     // GIR_Coverage, 6833,
     /*  642016 */     GIR_EraseRootFromParent_Done,
     /*  642017 */   // Label 10312: @642017
     /*  642017 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(642092), // Rule ID 6836 //
     /*  642022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  642042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642090 */     GIR_RootConstrainSelectedInstOperands,
     /*  642091 */     // GIR_Coverage, 6836,
     /*  642091 */     GIR_EraseRootFromParent_Done,
     /*  642092 */   // Label 10313: @642092
     /*  642092 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(642167), // Rule ID 6837 //
     /*  642097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  642117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642165 */     GIR_RootConstrainSelectedInstOperands,
     /*  642166 */     // GIR_Coverage, 6837,
     /*  642166 */     GIR_EraseRootFromParent_Done,
     /*  642167 */   // Label 10314: @642167
     /*  642167 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(642242), // Rule ID 6840 //
     /*  642172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642240 */     GIR_RootConstrainSelectedInstOperands,
     /*  642241 */     // GIR_Coverage, 6840,
     /*  642241 */     GIR_EraseRootFromParent_Done,
     /*  642242 */   // Label 10315: @642242
     /*  642242 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(642317), // Rule ID 6841 //
     /*  642247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  642267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642315 */     GIR_RootConstrainSelectedInstOperands,
     /*  642316 */     // GIR_Coverage, 6841,
     /*  642316 */     GIR_EraseRootFromParent_Done,
     /*  642317 */   // Label 10316: @642317
     /*  642317 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(642392), // Rule ID 6844 //
     /*  642322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642390 */     GIR_RootConstrainSelectedInstOperands,
     /*  642391 */     // GIR_Coverage, 6844,
     /*  642391 */     GIR_EraseRootFromParent_Done,
     /*  642392 */   // Label 10317: @642392
     /*  642392 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(642467), // Rule ID 6845 //
     /*  642397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  642417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  642446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642465 */     GIR_RootConstrainSelectedInstOperands,
     /*  642466 */     // GIR_Coverage, 6845,
     /*  642466 */     GIR_EraseRootFromParent_Done,
     /*  642467 */   // Label 10318: @642467
     /*  642467 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(642542), // Rule ID 6848 //
     /*  642472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642540 */     GIR_RootConstrainSelectedInstOperands,
     /*  642541 */     // GIR_Coverage, 6848,
     /*  642541 */     GIR_EraseRootFromParent_Done,
     /*  642542 */   // Label 10319: @642542
     /*  642542 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(642617), // Rule ID 6849 //
     /*  642547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642615 */     GIR_RootConstrainSelectedInstOperands,
     /*  642616 */     // GIR_Coverage, 6849,
     /*  642616 */     GIR_EraseRootFromParent_Done,
     /*  642617 */   // Label 10320: @642617
     /*  642617 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(642692), // Rule ID 6852 //
     /*  642622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642690 */     GIR_RootConstrainSelectedInstOperands,
     /*  642691 */     // GIR_Coverage, 6852,
     /*  642691 */     GIR_EraseRootFromParent_Done,
     /*  642692 */   // Label 10321: @642692
     /*  642692 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(642767), // Rule ID 6853 //
     /*  642697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642765 */     GIR_RootConstrainSelectedInstOperands,
     /*  642766 */     // GIR_Coverage, 6853,
     /*  642766 */     GIR_EraseRootFromParent_Done,
     /*  642767 */   // Label 10322: @642767
     /*  642767 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(642842), // Rule ID 6856 //
     /*  642772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642840 */     GIR_RootConstrainSelectedInstOperands,
     /*  642841 */     // GIR_Coverage, 6856,
     /*  642841 */     GIR_EraseRootFromParent_Done,
     /*  642842 */   // Label 10323: @642842
     /*  642842 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(642917), // Rule ID 6857 //
     /*  642847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642915 */     GIR_RootConstrainSelectedInstOperands,
     /*  642916 */     // GIR_Coverage, 6857,
     /*  642916 */     GIR_EraseRootFromParent_Done,
     /*  642917 */   // Label 10324: @642917
     /*  642917 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(642992), // Rule ID 6860 //
     /*  642922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642990 */     GIR_RootConstrainSelectedInstOperands,
     /*  642991 */     // GIR_Coverage, 6860,
     /*  642991 */     GIR_EraseRootFromParent_Done,
     /*  642992 */   // Label 10325: @642992
     /*  642992 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(643067), // Rule ID 6861 //
     /*  642997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  643017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643065 */     GIR_RootConstrainSelectedInstOperands,
     /*  643066 */     // GIR_Coverage, 6861,
     /*  643066 */     GIR_EraseRootFromParent_Done,
     /*  643067 */   // Label 10326: @643067
     /*  643067 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(643142), // Rule ID 6864 //
     /*  643072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643140 */     GIR_RootConstrainSelectedInstOperands,
     /*  643141 */     // GIR_Coverage, 6864,
     /*  643141 */     GIR_EraseRootFromParent_Done,
     /*  643142 */   // Label 10327: @643142
     /*  643142 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(643217), // Rule ID 6865 //
     /*  643147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  643167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643215 */     GIR_RootConstrainSelectedInstOperands,
     /*  643216 */     // GIR_Coverage, 6865,
     /*  643216 */     GIR_EraseRootFromParent_Done,
     /*  643217 */   // Label 10328: @643217
     /*  643217 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(643292), // Rule ID 6868 //
     /*  643222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643290 */     GIR_RootConstrainSelectedInstOperands,
     /*  643291 */     // GIR_Coverage, 6868,
     /*  643291 */     GIR_EraseRootFromParent_Done,
     /*  643292 */   // Label 10329: @643292
     /*  643292 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(643367), // Rule ID 6869 //
     /*  643297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  643317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  643346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643365 */     GIR_RootConstrainSelectedInstOperands,
     /*  643366 */     // GIR_Coverage, 6869,
     /*  643366 */     GIR_EraseRootFromParent_Done,
     /*  643367 */   // Label 10330: @643367
     /*  643367 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(643442), // Rule ID 6872 //
     /*  643372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643440 */     GIR_RootConstrainSelectedInstOperands,
     /*  643441 */     // GIR_Coverage, 6872,
     /*  643441 */     GIR_EraseRootFromParent_Done,
     /*  643442 */   // Label 10331: @643442
     /*  643442 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(643517), // Rule ID 6873 //
     /*  643447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643515 */     GIR_RootConstrainSelectedInstOperands,
     /*  643516 */     // GIR_Coverage, 6873,
     /*  643516 */     GIR_EraseRootFromParent_Done,
     /*  643517 */   // Label 10332: @643517
     /*  643517 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(643592), // Rule ID 6876 //
     /*  643522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643590 */     GIR_RootConstrainSelectedInstOperands,
     /*  643591 */     // GIR_Coverage, 6876,
     /*  643591 */     GIR_EraseRootFromParent_Done,
     /*  643592 */   // Label 10333: @643592
     /*  643592 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(643667), // Rule ID 6877 //
     /*  643597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643665 */     GIR_RootConstrainSelectedInstOperands,
     /*  643666 */     // GIR_Coverage, 6877,
     /*  643666 */     GIR_EraseRootFromParent_Done,
     /*  643667 */   // Label 10334: @643667
     /*  643667 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(643742), // Rule ID 6880 //
     /*  643672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643740 */     GIR_RootConstrainSelectedInstOperands,
     /*  643741 */     // GIR_Coverage, 6880,
     /*  643741 */     GIR_EraseRootFromParent_Done,
     /*  643742 */   // Label 10335: @643742
     /*  643742 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(643817), // Rule ID 6881 //
     /*  643747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643815 */     GIR_RootConstrainSelectedInstOperands,
     /*  643816 */     // GIR_Coverage, 6881,
     /*  643816 */     GIR_EraseRootFromParent_Done,
     /*  643817 */   // Label 10336: @643817
     /*  643817 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(643892), // Rule ID 6884 //
     /*  643822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643890 */     GIR_RootConstrainSelectedInstOperands,
     /*  643891 */     // GIR_Coverage, 6884,
     /*  643891 */     GIR_EraseRootFromParent_Done,
     /*  643892 */   // Label 10337: @643892
     /*  643892 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(643967), // Rule ID 6885 //
     /*  643897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643965 */     GIR_RootConstrainSelectedInstOperands,
     /*  643966 */     // GIR_Coverage, 6885,
     /*  643966 */     GIR_EraseRootFromParent_Done,
     /*  643967 */   // Label 10338: @643967
     /*  643967 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(644042), // Rule ID 6888 //
     /*  643972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644040 */     GIR_RootConstrainSelectedInstOperands,
     /*  644041 */     // GIR_Coverage, 6888,
     /*  644041 */     GIR_EraseRootFromParent_Done,
     /*  644042 */   // Label 10339: @644042
     /*  644042 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(644117), // Rule ID 6889 //
     /*  644047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  644067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644115 */     GIR_RootConstrainSelectedInstOperands,
     /*  644116 */     // GIR_Coverage, 6889,
     /*  644116 */     GIR_EraseRootFromParent_Done,
     /*  644117 */   // Label 10340: @644117
     /*  644117 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(644192), // Rule ID 6892 //
     /*  644122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644190 */     GIR_RootConstrainSelectedInstOperands,
     /*  644191 */     // GIR_Coverage, 6892,
     /*  644191 */     GIR_EraseRootFromParent_Done,
     /*  644192 */   // Label 10341: @644192
     /*  644192 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(644267), // Rule ID 6893 //
     /*  644197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  644217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644265 */     GIR_RootConstrainSelectedInstOperands,
     /*  644266 */     // GIR_Coverage, 6893,
     /*  644266 */     GIR_EraseRootFromParent_Done,
     /*  644267 */   // Label 10342: @644267
     /*  644267 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(644342), // Rule ID 6896 //
     /*  644272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644340 */     GIR_RootConstrainSelectedInstOperands,
     /*  644341 */     // GIR_Coverage, 6896,
     /*  644341 */     GIR_EraseRootFromParent_Done,
     /*  644342 */   // Label 10343: @644342
     /*  644342 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(644417), // Rule ID 6897 //
     /*  644347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  644367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644415 */     GIR_RootConstrainSelectedInstOperands,
     /*  644416 */     // GIR_Coverage, 6897,
     /*  644416 */     GIR_EraseRootFromParent_Done,
     /*  644417 */   // Label 10344: @644417
     /*  644417 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(644492), // Rule ID 6900 //
     /*  644422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644490 */     GIR_RootConstrainSelectedInstOperands,
     /*  644491 */     // GIR_Coverage, 6900,
     /*  644491 */     GIR_EraseRootFromParent_Done,
     /*  644492 */   // Label 10345: @644492
     /*  644492 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(644567), // Rule ID 6901 //
     /*  644497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644565 */     GIR_RootConstrainSelectedInstOperands,
     /*  644566 */     // GIR_Coverage, 6901,
     /*  644566 */     GIR_EraseRootFromParent_Done,
     /*  644567 */   // Label 10346: @644567
     /*  644567 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(644642), // Rule ID 6904 //
     /*  644572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644640 */     GIR_RootConstrainSelectedInstOperands,
     /*  644641 */     // GIR_Coverage, 6904,
     /*  644641 */     GIR_EraseRootFromParent_Done,
     /*  644642 */   // Label 10347: @644642
     /*  644642 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(644717), // Rule ID 6905 //
     /*  644647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644715 */     GIR_RootConstrainSelectedInstOperands,
     /*  644716 */     // GIR_Coverage, 6905,
     /*  644716 */     GIR_EraseRootFromParent_Done,
     /*  644717 */   // Label 10348: @644717
     /*  644717 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(644792), // Rule ID 6908 //
     /*  644722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644790 */     GIR_RootConstrainSelectedInstOperands,
     /*  644791 */     // GIR_Coverage, 6908,
     /*  644791 */     GIR_EraseRootFromParent_Done,
     /*  644792 */   // Label 10349: @644792
     /*  644792 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(644867), // Rule ID 6909 //
     /*  644797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644865 */     GIR_RootConstrainSelectedInstOperands,
     /*  644866 */     // GIR_Coverage, 6909,
     /*  644866 */     GIR_EraseRootFromParent_Done,
     /*  644867 */   // Label 10350: @644867
     /*  644867 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(644942), // Rule ID 6912 //
     /*  644872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644940 */     GIR_RootConstrainSelectedInstOperands,
     /*  644941 */     // GIR_Coverage, 6912,
     /*  644941 */     GIR_EraseRootFromParent_Done,
     /*  644942 */   // Label 10351: @644942
     /*  644942 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(645017), // Rule ID 6913 //
     /*  644947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644993 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645015 */     GIR_RootConstrainSelectedInstOperands,
     /*  645016 */     // GIR_Coverage, 6913,
     /*  645016 */     GIR_EraseRootFromParent_Done,
     /*  645017 */   // Label 10352: @645017
     /*  645017 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(645092), // Rule ID 6916 //
     /*  645022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  645025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  645042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  645071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645090 */     GIR_RootConstrainSelectedInstOperands,
     /*  645091 */     // GIR_Coverage, 6916,
     /*  645091 */     GIR_EraseRootFromParent_Done,
     /*  645092 */   // Label 10353: @645092
     /*  645092 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(645167), // Rule ID 6917 //
     /*  645097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  645117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  645146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645165 */     GIR_RootConstrainSelectedInstOperands,
     /*  645166 */     // GIR_Coverage, 6917,
     /*  645166 */     GIR_EraseRootFromParent_Done,
     /*  645167 */   // Label 10354: @645167
     /*  645167 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(645242), // Rule ID 6920 //
     /*  645172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  645221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645240 */     GIR_RootConstrainSelectedInstOperands,
     /*  645241 */     // GIR_Coverage, 6920,
     /*  645241 */     GIR_EraseRootFromParent_Done,
     /*  645242 */   // Label 10355: @645242
     /*  645242 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(645317), // Rule ID 6921 //
     /*  645247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  645296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645315 */     GIR_RootConstrainSelectedInstOperands,
     /*  645316 */     // GIR_Coverage, 6921,
     /*  645316 */     GIR_EraseRootFromParent_Done,
     /*  645317 */   // Label 10356: @645317
     /*  645317 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(645392), // Rule ID 6924 //
     /*  645322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645390 */     GIR_RootConstrainSelectedInstOperands,
     /*  645391 */     // GIR_Coverage, 6924,
     /*  645391 */     GIR_EraseRootFromParent_Done,
     /*  645392 */   // Label 10357: @645392
     /*  645392 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(645467), // Rule ID 6925 //
     /*  645397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645465 */     GIR_RootConstrainSelectedInstOperands,
     /*  645466 */     // GIR_Coverage, 6925,
     /*  645466 */     GIR_EraseRootFromParent_Done,
     /*  645467 */   // Label 10358: @645467
     /*  645467 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(645542), // Rule ID 6928 //
     /*  645472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645540 */     GIR_RootConstrainSelectedInstOperands,
     /*  645541 */     // GIR_Coverage, 6928,
     /*  645541 */     GIR_EraseRootFromParent_Done,
     /*  645542 */   // Label 10359: @645542
     /*  645542 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(645617), // Rule ID 6929 //
     /*  645547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645615 */     GIR_RootConstrainSelectedInstOperands,
     /*  645616 */     // GIR_Coverage, 6929,
     /*  645616 */     GIR_EraseRootFromParent_Done,
     /*  645617 */   // Label 10360: @645617
     /*  645617 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(645692), // Rule ID 6932 //
     /*  645622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645690 */     GIR_RootConstrainSelectedInstOperands,
     /*  645691 */     // GIR_Coverage, 6932,
     /*  645691 */     GIR_EraseRootFromParent_Done,
     /*  645692 */   // Label 10361: @645692
     /*  645692 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(645767), // Rule ID 6933 //
     /*  645697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645765 */     GIR_RootConstrainSelectedInstOperands,
     /*  645766 */     // GIR_Coverage, 6933,
     /*  645766 */     GIR_EraseRootFromParent_Done,
     /*  645767 */   // Label 10362: @645767
     /*  645767 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(645842), // Rule ID 6936 //
     /*  645772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645840 */     GIR_RootConstrainSelectedInstOperands,
     /*  645841 */     // GIR_Coverage, 6936,
     /*  645841 */     GIR_EraseRootFromParent_Done,
     /*  645842 */   // Label 10363: @645842
     /*  645842 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(645917), // Rule ID 6937 //
     /*  645847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645915 */     GIR_RootConstrainSelectedInstOperands,
     /*  645916 */     // GIR_Coverage, 6937,
     /*  645916 */     GIR_EraseRootFromParent_Done,
     /*  645917 */   // Label 10364: @645917
     /*  645917 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(645992), // Rule ID 6940 //
     /*  645922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645990 */     GIR_RootConstrainSelectedInstOperands,
     /*  645991 */     // GIR_Coverage, 6940,
     /*  645991 */     GIR_EraseRootFromParent_Done,
     /*  645992 */   // Label 10365: @645992
     /*  645992 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(646067), // Rule ID 6941 //
     /*  645997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  646046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646065 */     GIR_RootConstrainSelectedInstOperands,
     /*  646066 */     // GIR_Coverage, 6941,
     /*  646066 */     GIR_EraseRootFromParent_Done,
     /*  646067 */   // Label 10366: @646067
     /*  646067 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(646142), // Rule ID 6944 //
     /*  646072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646140 */     GIR_RootConstrainSelectedInstOperands,
     /*  646141 */     // GIR_Coverage, 6944,
     /*  646141 */     GIR_EraseRootFromParent_Done,
     /*  646142 */   // Label 10367: @646142
     /*  646142 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(646217), // Rule ID 6945 //
     /*  646147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11637:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646215 */     GIR_RootConstrainSelectedInstOperands,
     /*  646216 */     // GIR_Coverage, 6945,
     /*  646216 */     GIR_EraseRootFromParent_Done,
     /*  646217 */   // Label 10368: @646217
     /*  646217 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(646292), // Rule ID 6948 //
     /*  646222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646290 */     GIR_RootConstrainSelectedInstOperands,
     /*  646291 */     // GIR_Coverage, 6948,
     /*  646291 */     GIR_EraseRootFromParent_Done,
     /*  646292 */   // Label 10369: @646292
     /*  646292 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(646367), // Rule ID 6949 //
     /*  646297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11637:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646365 */     GIR_RootConstrainSelectedInstOperands,
     /*  646366 */     // GIR_Coverage, 6949,
     /*  646366 */     GIR_EraseRootFromParent_Done,
     /*  646367 */   // Label 10370: @646367
     /*  646367 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(646442), // Rule ID 6952 //
     /*  646372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646440 */     GIR_RootConstrainSelectedInstOperands,
     /*  646441 */     // GIR_Coverage, 6952,
     /*  646441 */     GIR_EraseRootFromParent_Done,
     /*  646442 */   // Label 10371: @646442
     /*  646442 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(646517), // Rule ID 6953 //
     /*  646447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11637:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646515 */     GIR_RootConstrainSelectedInstOperands,
     /*  646516 */     // GIR_Coverage, 6953,
     /*  646516 */     GIR_EraseRootFromParent_Done,
     /*  646517 */   // Label 10372: @646517
     /*  646517 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(646592), // Rule ID 6956 //
     /*  646522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646590 */     GIR_RootConstrainSelectedInstOperands,
     /*  646591 */     // GIR_Coverage, 6956,
     /*  646591 */     GIR_EraseRootFromParent_Done,
     /*  646592 */   // Label 10373: @646592
     /*  646592 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(646667), // Rule ID 6957 //
     /*  646597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11637:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646665 */     GIR_RootConstrainSelectedInstOperands,
     /*  646666 */     // GIR_Coverage, 6957,
     /*  646666 */     GIR_EraseRootFromParent_Done,
     /*  646667 */   // Label 10374: @646667
     /*  646667 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(646742), // Rule ID 6960 //
     /*  646672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646740 */     GIR_RootConstrainSelectedInstOperands,
     /*  646741 */     // GIR_Coverage, 6960,
     /*  646741 */     GIR_EraseRootFromParent_Done,
     /*  646742 */   // Label 10375: @646742
     /*  646742 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(646817), // Rule ID 6961 //
     /*  646747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646815 */     GIR_RootConstrainSelectedInstOperands,
     /*  646816 */     // GIR_Coverage, 6961,
     /*  646816 */     GIR_EraseRootFromParent_Done,
     /*  646817 */   // Label 10376: @646817
     /*  646817 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(646892), // Rule ID 6964 //
     /*  646822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646890 */     GIR_RootConstrainSelectedInstOperands,
     /*  646891 */     // GIR_Coverage, 6964,
     /*  646891 */     GIR_EraseRootFromParent_Done,
     /*  646892 */   // Label 10377: @646892
     /*  646892 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(646967), // Rule ID 6965 //
     /*  646897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646965 */     GIR_RootConstrainSelectedInstOperands,
     /*  646966 */     // GIR_Coverage, 6965,
     /*  646966 */     GIR_EraseRootFromParent_Done,
     /*  646967 */   // Label 10378: @646967
     /*  646967 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(647042), // Rule ID 6968 //
     /*  646972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647040 */     GIR_RootConstrainSelectedInstOperands,
     /*  647041 */     // GIR_Coverage, 6968,
     /*  647041 */     GIR_EraseRootFromParent_Done,
     /*  647042 */   // Label 10379: @647042
     /*  647042 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(647117), // Rule ID 6969 //
     /*  647047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647093 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647115 */     GIR_RootConstrainSelectedInstOperands,
     /*  647116 */     // GIR_Coverage, 6969,
     /*  647116 */     GIR_EraseRootFromParent_Done,
     /*  647117 */   // Label 10380: @647117
     /*  647117 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(647192), // Rule ID 6972 //
     /*  647122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647190 */     GIR_RootConstrainSelectedInstOperands,
     /*  647191 */     // GIR_Coverage, 6972,
     /*  647191 */     GIR_EraseRootFromParent_Done,
     /*  647192 */   // Label 10381: @647192
     /*  647192 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(647267), // Rule ID 6973 //
     /*  647197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647265 */     GIR_RootConstrainSelectedInstOperands,
     /*  647266 */     // GIR_Coverage, 6973,
     /*  647266 */     GIR_EraseRootFromParent_Done,
     /*  647267 */   // Label 10382: @647267
     /*  647267 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(647342), // Rule ID 6976 //
     /*  647272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647340 */     GIR_RootConstrainSelectedInstOperands,
     /*  647341 */     // GIR_Coverage, 6976,
     /*  647341 */     GIR_EraseRootFromParent_Done,
     /*  647342 */   // Label 10383: @647342
     /*  647342 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(647417), // Rule ID 6977 //
     /*  647347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647415 */     GIR_RootConstrainSelectedInstOperands,
     /*  647416 */     // GIR_Coverage, 6977,
     /*  647416 */     GIR_EraseRootFromParent_Done,
     /*  647417 */   // Label 10384: @647417
     /*  647417 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(647492), // Rule ID 6980 //
     /*  647422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647490 */     GIR_RootConstrainSelectedInstOperands,
     /*  647491 */     // GIR_Coverage, 6980,
     /*  647491 */     GIR_EraseRootFromParent_Done,
     /*  647492 */   // Label 10385: @647492
     /*  647492 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(647567), // Rule ID 6981 //
     /*  647497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647543 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647565 */     GIR_RootConstrainSelectedInstOperands,
     /*  647566 */     // GIR_Coverage, 6981,
     /*  647566 */     GIR_EraseRootFromParent_Done,
     /*  647567 */   // Label 10386: @647567
     /*  647567 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(647642), // Rule ID 6984 //
     /*  647572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647640 */     GIR_RootConstrainSelectedInstOperands,
     /*  647641 */     // GIR_Coverage, 6984,
     /*  647641 */     GIR_EraseRootFromParent_Done,
     /*  647642 */   // Label 10387: @647642
     /*  647642 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(647717), // Rule ID 6985 //
     /*  647647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647715 */     GIR_RootConstrainSelectedInstOperands,
     /*  647716 */     // GIR_Coverage, 6985,
     /*  647716 */     GIR_EraseRootFromParent_Done,
     /*  647717 */   // Label 10388: @647717
     /*  647717 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(647792), // Rule ID 6988 //
     /*  647722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647790 */     GIR_RootConstrainSelectedInstOperands,
     /*  647791 */     // GIR_Coverage, 6988,
     /*  647791 */     GIR_EraseRootFromParent_Done,
     /*  647792 */   // Label 10389: @647792
     /*  647792 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(647867), // Rule ID 6989 //
     /*  647797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647865 */     GIR_RootConstrainSelectedInstOperands,
     /*  647866 */     // GIR_Coverage, 6989,
     /*  647866 */     GIR_EraseRootFromParent_Done,
     /*  647867 */   // Label 10390: @647867
     /*  647867 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(647942), // Rule ID 6992 //
     /*  647872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647940 */     GIR_RootConstrainSelectedInstOperands,
     /*  647941 */     // GIR_Coverage, 6992,
     /*  647941 */     GIR_EraseRootFromParent_Done,
     /*  647942 */   // Label 10391: @647942
     /*  647942 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(648017), // Rule ID 6993 //
     /*  647947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647993 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648015 */     GIR_RootConstrainSelectedInstOperands,
     /*  648016 */     // GIR_Coverage, 6993,
     /*  648016 */     GIR_EraseRootFromParent_Done,
     /*  648017 */   // Label 10392: @648017
     /*  648017 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(648092), // Rule ID 6996 //
     /*  648022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  648071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648090 */     GIR_RootConstrainSelectedInstOperands,
     /*  648091 */     // GIR_Coverage, 6996,
     /*  648091 */     GIR_EraseRootFromParent_Done,
     /*  648092 */   // Label 10393: @648092
     /*  648092 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(648167), // Rule ID 6997 //
     /*  648097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11637:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  648146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648165 */     GIR_RootConstrainSelectedInstOperands,
     /*  648166 */     // GIR_Coverage, 6997,
     /*  648166 */     GIR_EraseRootFromParent_Done,
     /*  648167 */   // Label 10394: @648167
     /*  648167 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(648242), // Rule ID 7000 //
     /*  648172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  648221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648240 */     GIR_RootConstrainSelectedInstOperands,
     /*  648241 */     // GIR_Coverage, 7000,
     /*  648241 */     GIR_EraseRootFromParent_Done,
     /*  648242 */   // Label 10395: @648242
     /*  648242 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(648317), // Rule ID 7001 //
     /*  648247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11637:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  648296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648315 */     GIR_RootConstrainSelectedInstOperands,
     /*  648316 */     // GIR_Coverage, 7001,
     /*  648316 */     GIR_EraseRootFromParent_Done,
     /*  648317 */   // Label 10396: @648317
     /*  648317 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(648392), // Rule ID 7004 //
     /*  648322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  648371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648390 */     GIR_RootConstrainSelectedInstOperands,
     /*  648391 */     // GIR_Coverage, 7004,
     /*  648391 */     GIR_EraseRootFromParent_Done,
     /*  648392 */   // Label 10397: @648392
     /*  648392 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(648467), // Rule ID 7005 //
     /*  648397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11637:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  648446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648465 */     GIR_RootConstrainSelectedInstOperands,
     /*  648466 */     // GIR_Coverage, 7005,
     /*  648466 */     GIR_EraseRootFromParent_Done,
     /*  648467 */   // Label 10398: @648467
     /*  648467 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(648542), // Rule ID 7096 //
     /*  648472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648540 */     GIR_RootConstrainSelectedInstOperands,
     /*  648541 */     // GIR_Coverage, 7096,
     /*  648541 */     GIR_EraseRootFromParent_Done,
     /*  648542 */   // Label 10399: @648542
     /*  648542 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(648617), // Rule ID 7097 //
     /*  648547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648615 */     GIR_RootConstrainSelectedInstOperands,
     /*  648616 */     // GIR_Coverage, 7097,
     /*  648616 */     GIR_EraseRootFromParent_Done,
     /*  648617 */   // Label 10400: @648617
     /*  648617 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(648692), // Rule ID 7100 //
     /*  648622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648690 */     GIR_RootConstrainSelectedInstOperands,
     /*  648691 */     // GIR_Coverage, 7100,
     /*  648691 */     GIR_EraseRootFromParent_Done,
     /*  648692 */   // Label 10401: @648692
     /*  648692 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(648767), // Rule ID 7101 //
     /*  648697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648765 */     GIR_RootConstrainSelectedInstOperands,
     /*  648766 */     // GIR_Coverage, 7101,
     /*  648766 */     GIR_EraseRootFromParent_Done,
     /*  648767 */   // Label 10402: @648767
     /*  648767 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(648842), // Rule ID 7104 //
     /*  648772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648840 */     GIR_RootConstrainSelectedInstOperands,
     /*  648841 */     // GIR_Coverage, 7104,
     /*  648841 */     GIR_EraseRootFromParent_Done,
     /*  648842 */   // Label 10403: @648842
     /*  648842 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(648917), // Rule ID 7105 //
     /*  648847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648915 */     GIR_RootConstrainSelectedInstOperands,
     /*  648916 */     // GIR_Coverage, 7105,
     /*  648916 */     GIR_EraseRootFromParent_Done,
     /*  648917 */   // Label 10404: @648917
     /*  648917 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(648992), // Rule ID 7108 //
     /*  648922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648990 */     GIR_RootConstrainSelectedInstOperands,
     /*  648991 */     // GIR_Coverage, 7108,
     /*  648991 */     GIR_EraseRootFromParent_Done,
     /*  648992 */   // Label 10405: @648992
     /*  648992 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(649067), // Rule ID 7109 //
     /*  648997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  649017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  649046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649065 */     GIR_RootConstrainSelectedInstOperands,
     /*  649066 */     // GIR_Coverage, 7109,
     /*  649066 */     GIR_EraseRootFromParent_Done,
     /*  649067 */   // Label 10406: @649067
     /*  649067 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(649142), // Rule ID 7112 //
     /*  649072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649140 */     GIR_RootConstrainSelectedInstOperands,
     /*  649141 */     // GIR_Coverage, 7112,
     /*  649141 */     GIR_EraseRootFromParent_Done,
     /*  649142 */   // Label 10407: @649142
     /*  649142 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(649217), // Rule ID 7113 //
     /*  649147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  649167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649215 */     GIR_RootConstrainSelectedInstOperands,
     /*  649216 */     // GIR_Coverage, 7113,
     /*  649216 */     GIR_EraseRootFromParent_Done,
     /*  649217 */   // Label 10408: @649217
     /*  649217 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(649292), // Rule ID 7116 //
     /*  649222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  649242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649290 */     GIR_RootConstrainSelectedInstOperands,
     /*  649291 */     // GIR_Coverage, 7116,
     /*  649291 */     GIR_EraseRootFromParent_Done,
     /*  649292 */   // Label 10409: @649292
     /*  649292 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(649367), // Rule ID 7117 //
     /*  649297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  649317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  649346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649365 */     GIR_RootConstrainSelectedInstOperands,
     /*  649366 */     // GIR_Coverage, 7117,
     /*  649366 */     GIR_EraseRootFromParent_Done,
     /*  649367 */   // Label 10410: @649367
     /*  649367 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(649442), // Rule ID 7120 //
     /*  649372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649440 */     GIR_RootConstrainSelectedInstOperands,
     /*  649441 */     // GIR_Coverage, 7120,
     /*  649441 */     GIR_EraseRootFromParent_Done,
     /*  649442 */   // Label 10411: @649442
     /*  649442 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(649517), // Rule ID 7121 //
     /*  649447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649493 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649515 */     GIR_RootConstrainSelectedInstOperands,
     /*  649516 */     // GIR_Coverage, 7121,
     /*  649516 */     GIR_EraseRootFromParent_Done,
     /*  649517 */   // Label 10412: @649517
     /*  649517 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(649592), // Rule ID 7124 //
     /*  649522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649590 */     GIR_RootConstrainSelectedInstOperands,
     /*  649591 */     // GIR_Coverage, 7124,
     /*  649591 */     GIR_EraseRootFromParent_Done,
     /*  649592 */   // Label 10413: @649592
     /*  649592 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(649667), // Rule ID 7125 //
     /*  649597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649665 */     GIR_RootConstrainSelectedInstOperands,
     /*  649666 */     // GIR_Coverage, 7125,
     /*  649666 */     GIR_EraseRootFromParent_Done,
     /*  649667 */   // Label 10414: @649667
     /*  649667 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(649742), // Rule ID 7128 //
     /*  649672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649740 */     GIR_RootConstrainSelectedInstOperands,
     /*  649741 */     // GIR_Coverage, 7128,
     /*  649741 */     GIR_EraseRootFromParent_Done,
     /*  649742 */   // Label 10415: @649742
     /*  649742 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(649817), // Rule ID 7129 //
     /*  649747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649815 */     GIR_RootConstrainSelectedInstOperands,
     /*  649816 */     // GIR_Coverage, 7129,
     /*  649816 */     GIR_EraseRootFromParent_Done,
     /*  649817 */   // Label 10416: @649817
     /*  649817 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(649892), // Rule ID 7132 //
     /*  649822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649890 */     GIR_RootConstrainSelectedInstOperands,
     /*  649891 */     // GIR_Coverage, 7132,
     /*  649891 */     GIR_EraseRootFromParent_Done,
     /*  649892 */   // Label 10417: @649892
     /*  649892 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(649967), // Rule ID 7133 //
     /*  649897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  649943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649965 */     GIR_RootConstrainSelectedInstOperands,
     /*  649966 */     // GIR_Coverage, 7133,
     /*  649966 */     GIR_EraseRootFromParent_Done,
     /*  649967 */   // Label 10418: @649967
     /*  649967 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(650042), // Rule ID 7136 //
     /*  649972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650040 */     GIR_RootConstrainSelectedInstOperands,
     /*  650041 */     // GIR_Coverage, 7136,
     /*  650041 */     GIR_EraseRootFromParent_Done,
     /*  650042 */   // Label 10419: @650042
     /*  650042 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(650117), // Rule ID 7137 //
     /*  650047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  650067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650115 */     GIR_RootConstrainSelectedInstOperands,
     /*  650116 */     // GIR_Coverage, 7137,
     /*  650116 */     GIR_EraseRootFromParent_Done,
     /*  650117 */   // Label 10420: @650117
     /*  650117 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(650192), // Rule ID 7140 //
     /*  650122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  650142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650190 */     GIR_RootConstrainSelectedInstOperands,
     /*  650191 */     // GIR_Coverage, 7140,
     /*  650191 */     GIR_EraseRootFromParent_Done,
     /*  650192 */   // Label 10421: @650192
     /*  650192 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(650267), // Rule ID 7141 //
     /*  650197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  650217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650265 */     GIR_RootConstrainSelectedInstOperands,
     /*  650266 */     // GIR_Coverage, 7141,
     /*  650266 */     GIR_EraseRootFromParent_Done,
     /*  650267 */   // Label 10422: @650267
     /*  650267 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(650342), // Rule ID 7144 //
     /*  650272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  650292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650340 */     GIR_RootConstrainSelectedInstOperands,
     /*  650341 */     // GIR_Coverage, 7144,
     /*  650341 */     GIR_EraseRootFromParent_Done,
     /*  650342 */   // Label 10423: @650342
     /*  650342 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(650417), // Rule ID 7145 //
     /*  650347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  650367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650415 */     GIR_RootConstrainSelectedInstOperands,
     /*  650416 */     // GIR_Coverage, 7145,
     /*  650416 */     GIR_EraseRootFromParent_Done,
     /*  650417 */   // Label 10424: @650417
     /*  650417 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(650492), // Rule ID 7148 //
     /*  650422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650490 */     GIR_RootConstrainSelectedInstOperands,
     /*  650491 */     // GIR_Coverage, 7148,
     /*  650491 */     GIR_EraseRootFromParent_Done,
     /*  650492 */   // Label 10425: @650492
     /*  650492 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(650567), // Rule ID 7149 //
     /*  650497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650565 */     GIR_RootConstrainSelectedInstOperands,
     /*  650566 */     // GIR_Coverage, 7149,
     /*  650566 */     GIR_EraseRootFromParent_Done,
     /*  650567 */   // Label 10426: @650567
     /*  650567 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(650642), // Rule ID 7152 //
     /*  650572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650640 */     GIR_RootConstrainSelectedInstOperands,
     /*  650641 */     // GIR_Coverage, 7152,
     /*  650641 */     GIR_EraseRootFromParent_Done,
     /*  650642 */   // Label 10427: @650642
     /*  650642 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(650717), // Rule ID 7153 //
     /*  650647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650715 */     GIR_RootConstrainSelectedInstOperands,
     /*  650716 */     // GIR_Coverage, 7153,
     /*  650716 */     GIR_EraseRootFromParent_Done,
     /*  650717 */   // Label 10428: @650717
     /*  650717 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(650792), // Rule ID 7156 //
     /*  650722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650790 */     GIR_RootConstrainSelectedInstOperands,
     /*  650791 */     // GIR_Coverage, 7156,
     /*  650791 */     GIR_EraseRootFromParent_Done,
     /*  650792 */   // Label 10429: @650792
     /*  650792 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(650867), // Rule ID 7157 //
     /*  650797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650865 */     GIR_RootConstrainSelectedInstOperands,
     /*  650866 */     // GIR_Coverage, 7157,
     /*  650866 */     GIR_EraseRootFromParent_Done,
     /*  650867 */   // Label 10430: @650867
     /*  650867 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(650942), // Rule ID 7160 //
     /*  650872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650940 */     GIR_RootConstrainSelectedInstOperands,
     /*  650941 */     // GIR_Coverage, 7160,
     /*  650941 */     GIR_EraseRootFromParent_Done,
     /*  650942 */   // Label 10431: @650942
     /*  650942 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(651017), // Rule ID 7161 //
     /*  650947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651015 */     GIR_RootConstrainSelectedInstOperands,
     /*  651016 */     // GIR_Coverage, 7161,
     /*  651016 */     GIR_EraseRootFromParent_Done,
     /*  651017 */   // Label 10432: @651017
     /*  651017 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(651092), // Rule ID 7164 //
     /*  651022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  651042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651090 */     GIR_RootConstrainSelectedInstOperands,
     /*  651091 */     // GIR_Coverage, 7164,
     /*  651091 */     GIR_EraseRootFromParent_Done,
     /*  651092 */   // Label 10433: @651092
     /*  651092 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(651167), // Rule ID 7165 //
     /*  651097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  651117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651165 */     GIR_RootConstrainSelectedInstOperands,
     /*  651166 */     // GIR_Coverage, 7165,
     /*  651166 */     GIR_EraseRootFromParent_Done,
     /*  651167 */   // Label 10434: @651167
     /*  651167 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(651242), // Rule ID 7168 //
     /*  651172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  651192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651240 */     GIR_RootConstrainSelectedInstOperands,
     /*  651241 */     // GIR_Coverage, 7168,
     /*  651241 */     GIR_EraseRootFromParent_Done,
     /*  651242 */   // Label 10435: @651242
     /*  651242 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(651317), // Rule ID 7169 //
     /*  651247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  651267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651315 */     GIR_RootConstrainSelectedInstOperands,
     /*  651316 */     // GIR_Coverage, 7169,
     /*  651316 */     GIR_EraseRootFromParent_Done,
     /*  651317 */   // Label 10436: @651317
     /*  651317 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(651392), // Rule ID 7172 //
     /*  651322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  651342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  651371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651390 */     GIR_RootConstrainSelectedInstOperands,
     /*  651391 */     // GIR_Coverage, 7172,
     /*  651391 */     GIR_EraseRootFromParent_Done,
     /*  651392 */   // Label 10437: @651392
     /*  651392 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(651467), // Rule ID 7173 //
     /*  651397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  651417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  651446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651465 */     GIR_RootConstrainSelectedInstOperands,
     /*  651466 */     // GIR_Coverage, 7173,
     /*  651466 */     GIR_EraseRootFromParent_Done,
     /*  651467 */   // Label 10438: @651467
     /*  651467 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(651542), // Rule ID 7176 //
     /*  651472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651540 */     GIR_RootConstrainSelectedInstOperands,
     /*  651541 */     // GIR_Coverage, 7176,
     /*  651541 */     GIR_EraseRootFromParent_Done,
     /*  651542 */   // Label 10439: @651542
     /*  651542 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(651617), // Rule ID 7177 //
     /*  651547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651615 */     GIR_RootConstrainSelectedInstOperands,
     /*  651616 */     // GIR_Coverage, 7177,
     /*  651616 */     GIR_EraseRootFromParent_Done,
     /*  651617 */   // Label 10440: @651617
     /*  651617 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(651692), // Rule ID 7180 //
     /*  651622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651690 */     GIR_RootConstrainSelectedInstOperands,
     /*  651691 */     // GIR_Coverage, 7180,
     /*  651691 */     GIR_EraseRootFromParent_Done,
     /*  651692 */   // Label 10441: @651692
     /*  651692 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(651767), // Rule ID 7181 //
     /*  651697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651765 */     GIR_RootConstrainSelectedInstOperands,
     /*  651766 */     // GIR_Coverage, 7181,
     /*  651766 */     GIR_EraseRootFromParent_Done,
     /*  651767 */   // Label 10442: @651767
     /*  651767 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(651842), // Rule ID 7184 //
     /*  651772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651840 */     GIR_RootConstrainSelectedInstOperands,
     /*  651841 */     // GIR_Coverage, 7184,
     /*  651841 */     GIR_EraseRootFromParent_Done,
     /*  651842 */   // Label 10443: @651842
     /*  651842 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(651917), // Rule ID 7185 //
     /*  651847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651915 */     GIR_RootConstrainSelectedInstOperands,
     /*  651916 */     // GIR_Coverage, 7185,
     /*  651916 */     GIR_EraseRootFromParent_Done,
     /*  651917 */   // Label 10444: @651917
     /*  651917 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(651992), // Rule ID 7188 //
     /*  651922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651990 */     GIR_RootConstrainSelectedInstOperands,
     /*  651991 */     // GIR_Coverage, 7188,
     /*  651991 */     GIR_EraseRootFromParent_Done,
     /*  651992 */   // Label 10445: @651992
     /*  651992 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(652067), // Rule ID 7189 //
     /*  651997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652065 */     GIR_RootConstrainSelectedInstOperands,
     /*  652066 */     // GIR_Coverage, 7189,
     /*  652066 */     GIR_EraseRootFromParent_Done,
     /*  652067 */   // Label 10446: @652067
     /*  652067 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(652142), // Rule ID 7192 //
     /*  652072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652140 */     GIR_RootConstrainSelectedInstOperands,
     /*  652141 */     // GIR_Coverage, 7192,
     /*  652141 */     GIR_EraseRootFromParent_Done,
     /*  652142 */   // Label 10447: @652142
     /*  652142 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(652217), // Rule ID 7193 //
     /*  652147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652215 */     GIR_RootConstrainSelectedInstOperands,
     /*  652216 */     // GIR_Coverage, 7193,
     /*  652216 */     GIR_EraseRootFromParent_Done,
     /*  652217 */   // Label 10448: @652217
     /*  652217 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(652292), // Rule ID 7196 //
     /*  652222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652290 */     GIR_RootConstrainSelectedInstOperands,
     /*  652291 */     // GIR_Coverage, 7196,
     /*  652291 */     GIR_EraseRootFromParent_Done,
     /*  652292 */   // Label 10449: @652292
     /*  652292 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(652367), // Rule ID 7197 //
     /*  652297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  652346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652365 */     GIR_RootConstrainSelectedInstOperands,
     /*  652366 */     // GIR_Coverage, 7197,
     /*  652366 */     GIR_EraseRootFromParent_Done,
     /*  652367 */   // Label 10450: @652367
     /*  652367 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(652442), // Rule ID 7200 //
     /*  652372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652440 */     GIR_RootConstrainSelectedInstOperands,
     /*  652441 */     // GIR_Coverage, 7200,
     /*  652441 */     GIR_EraseRootFromParent_Done,
     /*  652442 */   // Label 10451: @652442
     /*  652442 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(652517), // Rule ID 7201 //
     /*  652447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652515 */     GIR_RootConstrainSelectedInstOperands,
     /*  652516 */     // GIR_Coverage, 7201,
     /*  652516 */     GIR_EraseRootFromParent_Done,
     /*  652517 */   // Label 10452: @652517
     /*  652517 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(652592), // Rule ID 7204 //
     /*  652522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652590 */     GIR_RootConstrainSelectedInstOperands,
     /*  652591 */     // GIR_Coverage, 7204,
     /*  652591 */     GIR_EraseRootFromParent_Done,
     /*  652592 */   // Label 10453: @652592
     /*  652592 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(652667), // Rule ID 7205 //
     /*  652597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652665 */     GIR_RootConstrainSelectedInstOperands,
     /*  652666 */     // GIR_Coverage, 7205,
     /*  652666 */     GIR_EraseRootFromParent_Done,
     /*  652667 */   // Label 10454: @652667
     /*  652667 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(652742), // Rule ID 7208 //
     /*  652672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652740 */     GIR_RootConstrainSelectedInstOperands,
     /*  652741 */     // GIR_Coverage, 7208,
     /*  652741 */     GIR_EraseRootFromParent_Done,
     /*  652742 */   // Label 10455: @652742
     /*  652742 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(652817), // Rule ID 7209 //
     /*  652747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11635:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652815 */     GIR_RootConstrainSelectedInstOperands,
     /*  652816 */     // GIR_Coverage, 7209,
     /*  652816 */     GIR_EraseRootFromParent_Done,
     /*  652817 */   // Label 10456: @652817
     /*  652817 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(652892), // Rule ID 7212 //
     /*  652822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652890 */     GIR_RootConstrainSelectedInstOperands,
     /*  652891 */     // GIR_Coverage, 7212,
     /*  652891 */     GIR_EraseRootFromParent_Done,
     /*  652892 */   // Label 10457: @652892
     /*  652892 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(652967), // Rule ID 7213 //
     /*  652897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11635:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652965 */     GIR_RootConstrainSelectedInstOperands,
     /*  652966 */     // GIR_Coverage, 7213,
     /*  652966 */     GIR_EraseRootFromParent_Done,
     /*  652967 */   // Label 10458: @652967
     /*  652967 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(653042), // Rule ID 7216 //
     /*  652972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653040 */     GIR_RootConstrainSelectedInstOperands,
     /*  653041 */     // GIR_Coverage, 7216,
     /*  653041 */     GIR_EraseRootFromParent_Done,
     /*  653042 */   // Label 10459: @653042
     /*  653042 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(653117), // Rule ID 7217 //
     /*  653047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11635:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653115 */     GIR_RootConstrainSelectedInstOperands,
     /*  653116 */     // GIR_Coverage, 7217,
     /*  653116 */     GIR_EraseRootFromParent_Done,
     /*  653117 */   // Label 10460: @653117
     /*  653117 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(653192), // Rule ID 7220 //
     /*  653122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653190 */     GIR_RootConstrainSelectedInstOperands,
     /*  653191 */     // GIR_Coverage, 7220,
     /*  653191 */     GIR_EraseRootFromParent_Done,
     /*  653192 */   // Label 10461: @653192
     /*  653192 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(653267), // Rule ID 7221 //
     /*  653197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11635:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  653246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653265 */     GIR_RootConstrainSelectedInstOperands,
     /*  653266 */     // GIR_Coverage, 7221,
     /*  653266 */     GIR_EraseRootFromParent_Done,
     /*  653267 */   // Label 10462: @653267
     /*  653267 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(653342), // Rule ID 7224 //
     /*  653272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653340 */     GIR_RootConstrainSelectedInstOperands,
     /*  653341 */     // GIR_Coverage, 7224,
     /*  653341 */     GIR_EraseRootFromParent_Done,
     /*  653342 */   // Label 10463: @653342
     /*  653342 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(653417), // Rule ID 7225 //
     /*  653347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653415 */     GIR_RootConstrainSelectedInstOperands,
     /*  653416 */     // GIR_Coverage, 7225,
     /*  653416 */     GIR_EraseRootFromParent_Done,
     /*  653417 */   // Label 10464: @653417
     /*  653417 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(653492), // Rule ID 7228 //
     /*  653422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653490 */     GIR_RootConstrainSelectedInstOperands,
     /*  653491 */     // GIR_Coverage, 7228,
     /*  653491 */     GIR_EraseRootFromParent_Done,
     /*  653492 */   // Label 10465: @653492
     /*  653492 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(653567), // Rule ID 7229 //
     /*  653497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653565 */     GIR_RootConstrainSelectedInstOperands,
     /*  653566 */     // GIR_Coverage, 7229,
     /*  653566 */     GIR_EraseRootFromParent_Done,
     /*  653567 */   // Label 10466: @653567
     /*  653567 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(653642), // Rule ID 7232 //
     /*  653572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653640 */     GIR_RootConstrainSelectedInstOperands,
     /*  653641 */     // GIR_Coverage, 7232,
     /*  653641 */     GIR_EraseRootFromParent_Done,
     /*  653642 */   // Label 10467: @653642
     /*  653642 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(653717), // Rule ID 7233 //
     /*  653647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653715 */     GIR_RootConstrainSelectedInstOperands,
     /*  653716 */     // GIR_Coverage, 7233,
     /*  653716 */     GIR_EraseRootFromParent_Done,
     /*  653717 */   // Label 10468: @653717
     /*  653717 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(653792), // Rule ID 7236 //
     /*  653722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653790 */     GIR_RootConstrainSelectedInstOperands,
     /*  653791 */     // GIR_Coverage, 7236,
     /*  653791 */     GIR_EraseRootFromParent_Done,
     /*  653792 */   // Label 10469: @653792
     /*  653792 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(653867), // Rule ID 7237 //
     /*  653797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653865 */     GIR_RootConstrainSelectedInstOperands,
     /*  653866 */     // GIR_Coverage, 7237,
     /*  653866 */     GIR_EraseRootFromParent_Done,
     /*  653867 */   // Label 10470: @653867
     /*  653867 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(653942), // Rule ID 7240 //
     /*  653872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653940 */     GIR_RootConstrainSelectedInstOperands,
     /*  653941 */     // GIR_Coverage, 7240,
     /*  653941 */     GIR_EraseRootFromParent_Done,
     /*  653942 */   // Label 10471: @653942
     /*  653942 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(654017), // Rule ID 7241 //
     /*  653947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654015 */     GIR_RootConstrainSelectedInstOperands,
     /*  654016 */     // GIR_Coverage, 7241,
     /*  654016 */     GIR_EraseRootFromParent_Done,
     /*  654017 */   // Label 10472: @654017
     /*  654017 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(654092), // Rule ID 7244 //
     /*  654022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654090 */     GIR_RootConstrainSelectedInstOperands,
     /*  654091 */     // GIR_Coverage, 7244,
     /*  654091 */     GIR_EraseRootFromParent_Done,
     /*  654092 */   // Label 10473: @654092
     /*  654092 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(654167), // Rule ID 7245 //
     /*  654097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654165 */     GIR_RootConstrainSelectedInstOperands,
     /*  654166 */     // GIR_Coverage, 7245,
     /*  654166 */     GIR_EraseRootFromParent_Done,
     /*  654167 */   // Label 10474: @654167
     /*  654167 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(654242), // Rule ID 7248 //
     /*  654172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654240 */     GIR_RootConstrainSelectedInstOperands,
     /*  654241 */     // GIR_Coverage, 7248,
     /*  654241 */     GIR_EraseRootFromParent_Done,
     /*  654242 */   // Label 10475: @654242
     /*  654242 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(654317), // Rule ID 7249 //
     /*  654247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654315 */     GIR_RootConstrainSelectedInstOperands,
     /*  654316 */     // GIR_Coverage, 7249,
     /*  654316 */     GIR_EraseRootFromParent_Done,
     /*  654317 */   // Label 10476: @654317
     /*  654317 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(654392), // Rule ID 7252 //
     /*  654322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654390 */     GIR_RootConstrainSelectedInstOperands,
     /*  654391 */     // GIR_Coverage, 7252,
     /*  654391 */     GIR_EraseRootFromParent_Done,
     /*  654392 */   // Label 10477: @654392
     /*  654392 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(654467), // Rule ID 7253 //
     /*  654397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654465 */     GIR_RootConstrainSelectedInstOperands,
     /*  654466 */     // GIR_Coverage, 7253,
     /*  654466 */     GIR_EraseRootFromParent_Done,
     /*  654467 */   // Label 10478: @654467
     /*  654467 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(654542), // Rule ID 7256 //
     /*  654472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654540 */     GIR_RootConstrainSelectedInstOperands,
     /*  654541 */     // GIR_Coverage, 7256,
     /*  654541 */     GIR_EraseRootFromParent_Done,
     /*  654542 */   // Label 10479: @654542
     /*  654542 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(654617), // Rule ID 7257 //
     /*  654547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654615 */     GIR_RootConstrainSelectedInstOperands,
     /*  654616 */     // GIR_Coverage, 7257,
     /*  654616 */     GIR_EraseRootFromParent_Done,
     /*  654617 */   // Label 10480: @654617
     /*  654617 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(654692), // Rule ID 7260 //
     /*  654622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654690 */     GIR_RootConstrainSelectedInstOperands,
     /*  654691 */     // GIR_Coverage, 7260,
     /*  654691 */     GIR_EraseRootFromParent_Done,
     /*  654692 */   // Label 10481: @654692
     /*  654692 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(654767), // Rule ID 7261 //
     /*  654697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11635:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654765 */     GIR_RootConstrainSelectedInstOperands,
     /*  654766 */     // GIR_Coverage, 7261,
     /*  654766 */     GIR_EraseRootFromParent_Done,
     /*  654767 */   // Label 10482: @654767
     /*  654767 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(654842), // Rule ID 7264 //
     /*  654772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654840 */     GIR_RootConstrainSelectedInstOperands,
     /*  654841 */     // GIR_Coverage, 7264,
     /*  654841 */     GIR_EraseRootFromParent_Done,
     /*  654842 */   // Label 10483: @654842
     /*  654842 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(654917), // Rule ID 7265 //
     /*  654847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11635:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654915 */     GIR_RootConstrainSelectedInstOperands,
     /*  654916 */     // GIR_Coverage, 7265,
     /*  654916 */     GIR_EraseRootFromParent_Done,
     /*  654917 */   // Label 10484: @654917
     /*  654917 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(654992), // Rule ID 7268 //
     /*  654922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654990 */     GIR_RootConstrainSelectedInstOperands,
     /*  654991 */     // GIR_Coverage, 7268,
     /*  654991 */     GIR_EraseRootFromParent_Done,
     /*  654992 */   // Label 10485: @654992
     /*  654992 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(655067), // Rule ID 7269 //
     /*  654997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  655000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11635:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  655043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  655046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655065 */     GIR_RootConstrainSelectedInstOperands,
     /*  655066 */     // GIR_Coverage, 7269,
     /*  655066 */     GIR_EraseRootFromParent_Done,
     /*  655067 */   // Label 10486: @655067
     /*  655067 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(655142), // Rule ID 7448 //
     /*  655072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  655092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  655121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655140 */     GIR_RootConstrainSelectedInstOperands,
     /*  655141 */     // GIR_Coverage, 7448,
     /*  655141 */     GIR_EraseRootFromParent_Done,
     /*  655142 */   // Label 10487: @655142
     /*  655142 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(655217), // Rule ID 7449 //
     /*  655147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  655167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  655196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655215 */     GIR_RootConstrainSelectedInstOperands,
     /*  655216 */     // GIR_Coverage, 7449,
     /*  655216 */     GIR_EraseRootFromParent_Done,
     /*  655217 */   // Label 10488: @655217
     /*  655217 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(655292), // Rule ID 7452 //
     /*  655222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  655242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655290 */     GIR_RootConstrainSelectedInstOperands,
     /*  655291 */     // GIR_Coverage, 7452,
     /*  655291 */     GIR_EraseRootFromParent_Done,
     /*  655292 */   // Label 10489: @655292
     /*  655292 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(655367), // Rule ID 7453 //
     /*  655297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  655317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655343 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655365 */     GIR_RootConstrainSelectedInstOperands,
     /*  655366 */     // GIR_Coverage, 7453,
     /*  655366 */     GIR_EraseRootFromParent_Done,
     /*  655367 */   // Label 10490: @655367
     /*  655367 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(655442), // Rule ID 7456 //
     /*  655372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  655389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655440 */     GIR_RootConstrainSelectedInstOperands,
     /*  655441 */     // GIR_Coverage, 7456,
     /*  655441 */     GIR_EraseRootFromParent_Done,
     /*  655442 */   // Label 10491: @655442
     /*  655442 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(655517), // Rule ID 7457 //
     /*  655447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  655464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655515 */     GIR_RootConstrainSelectedInstOperands,
     /*  655516 */     // GIR_Coverage, 7457,
     /*  655516 */     GIR_EraseRootFromParent_Done,
     /*  655517 */   // Label 10492: @655517
     /*  655517 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(655592), // Rule ID 7460 //
     /*  655522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655590 */     GIR_RootConstrainSelectedInstOperands,
     /*  655591 */     // GIR_Coverage, 7460,
     /*  655591 */     GIR_EraseRootFromParent_Done,
     /*  655592 */   // Label 10493: @655592
     /*  655592 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(655667), // Rule ID 7461 //
     /*  655597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655643 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655665 */     GIR_RootConstrainSelectedInstOperands,
     /*  655666 */     // GIR_Coverage, 7461,
     /*  655666 */     GIR_EraseRootFromParent_Done,
     /*  655667 */   // Label 10494: @655667
     /*  655667 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(655742), // Rule ID 7464 //
     /*  655672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655740 */     GIR_RootConstrainSelectedInstOperands,
     /*  655741 */     // GIR_Coverage, 7464,
     /*  655741 */     GIR_EraseRootFromParent_Done,
     /*  655742 */   // Label 10495: @655742
     /*  655742 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(655817), // Rule ID 7465 //
     /*  655747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655815 */     GIR_RootConstrainSelectedInstOperands,
     /*  655816 */     // GIR_Coverage, 7465,
     /*  655816 */     GIR_EraseRootFromParent_Done,
     /*  655817 */   // Label 10496: @655817
     /*  655817 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(655892), // Rule ID 7468 //
     /*  655822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655890 */     GIR_RootConstrainSelectedInstOperands,
     /*  655891 */     // GIR_Coverage, 7468,
     /*  655891 */     GIR_EraseRootFromParent_Done,
     /*  655892 */   // Label 10497: @655892
     /*  655892 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(655967), // Rule ID 7469 //
     /*  655897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655965 */     GIR_RootConstrainSelectedInstOperands,
     /*  655966 */     // GIR_Coverage, 7469,
     /*  655966 */     GIR_EraseRootFromParent_Done,
     /*  655967 */   // Label 10498: @655967
     /*  655967 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(656042), // Rule ID 7472 //
     /*  655972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  656021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656040 */     GIR_RootConstrainSelectedInstOperands,
     /*  656041 */     // GIR_Coverage, 7472,
     /*  656041 */     GIR_EraseRootFromParent_Done,
     /*  656042 */   // Label 10499: @656042
     /*  656042 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(656117), // Rule ID 7473 //
     /*  656047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  656058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  656061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  656064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  656067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  656096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656115 */     GIR_RootConstrainSelectedInstOperands,
     /*  656116 */     // GIR_Coverage, 7473,
     /*  656116 */     GIR_EraseRootFromParent_Done,
     /*  656117 */   // Label 10500: @656117
     /*  656117 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(656192), // Rule ID 7476 //
     /*  656122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  656133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  656136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  656142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656190 */     GIR_RootConstrainSelectedInstOperands,
     /*  656191 */     // GIR_Coverage, 7476,
     /*  656191 */     GIR_EraseRootFromParent_Done,
     /*  656192 */   // Label 10501: @656192
     /*  656192 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(656267), // Rule ID 7477 //
     /*  656197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  656208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  656211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  656217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656265 */     GIR_RootConstrainSelectedInstOperands,
     /*  656266 */     // GIR_Coverage, 7477,
     /*  656266 */     GIR_EraseRootFromParent_Done,
     /*  656267 */   // Label 10502: @656267
     /*  656267 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(656342), // Rule ID 7480 //
     /*  656272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  656289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  656292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656340 */     GIR_RootConstrainSelectedInstOperands,
     /*  656341 */     // GIR_Coverage, 7480,
     /*  656341 */     GIR_EraseRootFromParent_Done,
     /*  656342 */   // Label 10503: @656342
     /*  656342 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(656417), // Rule ID 7481 //
     /*  656347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  656364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  656367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656415 */     GIR_RootConstrainSelectedInstOperands,
     /*  656416 */     // GIR_Coverage, 7481,
     /*  656416 */     GIR_EraseRootFromParent_Done,
     /*  656417 */   // Label 10504: @656417
     /*  656417 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(656492), // Rule ID 7484 //
     /*  656422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656490 */     GIR_RootConstrainSelectedInstOperands,
     /*  656491 */     // GIR_Coverage, 7484,
     /*  656491 */     GIR_EraseRootFromParent_Done,
     /*  656492 */   // Label 10505: @656492
     /*  656492 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(656567), // Rule ID 7485 //
     /*  656497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656565 */     GIR_RootConstrainSelectedInstOperands,
     /*  656566 */     // GIR_Coverage, 7485,
     /*  656566 */     GIR_EraseRootFromParent_Done,
     /*  656567 */   // Label 10506: @656567
     /*  656567 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(656642), // Rule ID 7488 //
     /*  656572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656640 */     GIR_RootConstrainSelectedInstOperands,
     /*  656641 */     // GIR_Coverage, 7488,
     /*  656641 */     GIR_EraseRootFromParent_Done,
     /*  656642 */   // Label 10507: @656642
     /*  656642 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(656717), // Rule ID 7489 //
     /*  656647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656715 */     GIR_RootConstrainSelectedInstOperands,
     /*  656716 */     // GIR_Coverage, 7489,
     /*  656716 */     GIR_EraseRootFromParent_Done,
     /*  656717 */   // Label 10508: @656717
     /*  656717 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(656792), // Rule ID 7492 //
     /*  656722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656790 */     GIR_RootConstrainSelectedInstOperands,
     /*  656791 */     // GIR_Coverage, 7492,
     /*  656791 */     GIR_EraseRootFromParent_Done,
     /*  656792 */   // Label 10509: @656792
     /*  656792 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(656867), // Rule ID 7493 //
     /*  656797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656865 */     GIR_RootConstrainSelectedInstOperands,
     /*  656866 */     // GIR_Coverage, 7493,
     /*  656866 */     GIR_EraseRootFromParent_Done,
     /*  656867 */   // Label 10510: @656867
     /*  656867 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(656942), // Rule ID 7496 //
     /*  656872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656940 */     GIR_RootConstrainSelectedInstOperands,
     /*  656941 */     // GIR_Coverage, 7496,
     /*  656941 */     GIR_EraseRootFromParent_Done,
     /*  656942 */   // Label 10511: @656942
     /*  656942 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(657017), // Rule ID 7497 //
     /*  656947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657015 */     GIR_RootConstrainSelectedInstOperands,
     /*  657016 */     // GIR_Coverage, 7497,
     /*  657016 */     GIR_EraseRootFromParent_Done,
     /*  657017 */   // Label 10512: @657017
     /*  657017 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(657092), // Rule ID 7500 //
     /*  657022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  657039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  657042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  657071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657090 */     GIR_RootConstrainSelectedInstOperands,
     /*  657091 */     // GIR_Coverage, 7500,
     /*  657091 */     GIR_EraseRootFromParent_Done,
     /*  657092 */   // Label 10513: @657092
     /*  657092 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(657167), // Rule ID 7501 //
     /*  657097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  657114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  657117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  657146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657165 */     GIR_RootConstrainSelectedInstOperands,
     /*  657166 */     // GIR_Coverage, 7501,
     /*  657166 */     GIR_EraseRootFromParent_Done,
     /*  657167 */   // Label 10514: @657167
     /*  657167 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(657242), // Rule ID 7504 //
     /*  657172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  657175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  657189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  657192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  657221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657240 */     GIR_RootConstrainSelectedInstOperands,
     /*  657241 */     // GIR_Coverage, 7504,
     /*  657241 */     GIR_EraseRootFromParent_Done,
     /*  657242 */   // Label 10515: @657242
     /*  657242 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(657317), // Rule ID 7505 //
     /*  657247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  657250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  657264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  657267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  657296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657315 */     GIR_RootConstrainSelectedInstOperands,
     /*  657316 */     // GIR_Coverage, 7505,
     /*  657316 */     GIR_EraseRootFromParent_Done,
     /*  657317 */   // Label 10516: @657317
     /*  657317 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(657392), // Rule ID 7508 //
     /*  657322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  657333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  657336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  657339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657368 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  657371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657390 */     GIR_RootConstrainSelectedInstOperands,
     /*  657391 */     // GIR_Coverage, 7508,
     /*  657391 */     GIR_EraseRootFromParent_Done,
     /*  657392 */   // Label 10517: @657392
     /*  657392 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(657467), // Rule ID 7509 //
     /*  657397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  657408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  657411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  657414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657443 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  657446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657465 */     GIR_RootConstrainSelectedInstOperands,
     /*  657466 */     // GIR_Coverage, 7509,
     /*  657466 */     GIR_EraseRootFromParent_Done,
     /*  657467 */   // Label 10518: @657467
     /*  657467 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(657542), // Rule ID 7512 //
     /*  657472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657518 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657540 */     GIR_RootConstrainSelectedInstOperands,
     /*  657541 */     // GIR_Coverage, 7512,
     /*  657541 */     GIR_EraseRootFromParent_Done,
     /*  657542 */   // Label 10519: @657542
     /*  657542 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(657617), // Rule ID 7513 //
     /*  657547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657593 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657615 */     GIR_RootConstrainSelectedInstOperands,
     /*  657616 */     // GIR_Coverage, 7513,
     /*  657616 */     GIR_EraseRootFromParent_Done,
     /*  657617 */   // Label 10520: @657617
     /*  657617 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(657692), // Rule ID 7516 //
     /*  657622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657690 */     GIR_RootConstrainSelectedInstOperands,
     /*  657691 */     // GIR_Coverage, 7516,
     /*  657691 */     GIR_EraseRootFromParent_Done,
     /*  657692 */   // Label 10521: @657692
     /*  657692 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(657767), // Rule ID 7517 //
     /*  657697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657743 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657765 */     GIR_RootConstrainSelectedInstOperands,
     /*  657766 */     // GIR_Coverage, 7517,
     /*  657766 */     GIR_EraseRootFromParent_Done,
     /*  657767 */   // Label 10522: @657767
     /*  657767 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(657842), // Rule ID 7520 //
     /*  657772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657840 */     GIR_RootConstrainSelectedInstOperands,
     /*  657841 */     // GIR_Coverage, 7520,
     /*  657841 */     GIR_EraseRootFromParent_Done,
     /*  657842 */   // Label 10523: @657842
     /*  657842 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(657917), // Rule ID 7521 //
     /*  657847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657915 */     GIR_RootConstrainSelectedInstOperands,
     /*  657916 */     // GIR_Coverage, 7521,
     /*  657916 */     GIR_EraseRootFromParent_Done,
     /*  657917 */   // Label 10524: @657917
     /*  657917 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(657992), // Rule ID 7524 //
     /*  657922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657990 */     GIR_RootConstrainSelectedInstOperands,
     /*  657991 */     // GIR_Coverage, 7524,
     /*  657991 */     GIR_EraseRootFromParent_Done,
     /*  657992 */   // Label 10525: @657992
     /*  657992 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(658067), // Rule ID 7525 //
     /*  657997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  658008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  658011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  658014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658065 */     GIR_RootConstrainSelectedInstOperands,
     /*  658066 */     // GIR_Coverage, 7525,
     /*  658066 */     GIR_EraseRootFromParent_Done,
     /*  658067 */   // Label 10526: @658067
     /*  658067 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(658142), // Rule ID 7528 //
     /*  658072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  658083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  658086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  658089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658140 */     GIR_RootConstrainSelectedInstOperands,
     /*  658141 */     // GIR_Coverage, 7528,
     /*  658141 */     GIR_EraseRootFromParent_Done,
     /*  658142 */   // Label 10527: @658142
     /*  658142 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(658217), // Rule ID 7529 //
     /*  658147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  658158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  658161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  658164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658193 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658215 */     GIR_RootConstrainSelectedInstOperands,
     /*  658216 */     // GIR_Coverage, 7529,
     /*  658216 */     GIR_EraseRootFromParent_Done,
     /*  658217 */   // Label 10528: @658217
     /*  658217 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(658292), // Rule ID 7532 //
     /*  658222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  658233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  658236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  658239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  658271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658290 */     GIR_RootConstrainSelectedInstOperands,
     /*  658291 */     // GIR_Coverage, 7532,
     /*  658291 */     GIR_EraseRootFromParent_Done,
     /*  658292 */   // Label 10529: @658292
     /*  658292 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(658367), // Rule ID 7533 //
     /*  658297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  658308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  658311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  658314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  658346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658365 */     GIR_RootConstrainSelectedInstOperands,
     /*  658366 */     // GIR_Coverage, 7533,
     /*  658366 */     GIR_EraseRootFromParent_Done,
     /*  658367 */   // Label 10530: @658367
     /*  658367 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(658442), // Rule ID 7536 //
     /*  658372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  658383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  658386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  658389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658440 */     GIR_RootConstrainSelectedInstOperands,
     /*  658441 */     // GIR_Coverage, 7536,
     /*  658441 */     GIR_EraseRootFromParent_Done,
     /*  658442 */   // Label 10531: @658442
     /*  658442 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(658517), // Rule ID 7537 //
     /*  658447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  658458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  658461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  658464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658515 */     GIR_RootConstrainSelectedInstOperands,
     /*  658516 */     // GIR_Coverage, 7537,
     /*  658516 */     GIR_EraseRootFromParent_Done,
     /*  658517 */   // Label 10532: @658517
     /*  658517 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(658592), // Rule ID 7540 //
     /*  658522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658590 */     GIR_RootConstrainSelectedInstOperands,
     /*  658591 */     // GIR_Coverage, 7540,
     /*  658591 */     GIR_EraseRootFromParent_Done,
     /*  658592 */   // Label 10533: @658592
     /*  658592 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(658667), // Rule ID 7541 //
     /*  658597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658665 */     GIR_RootConstrainSelectedInstOperands,
     /*  658666 */     // GIR_Coverage, 7541,
     /*  658666 */     GIR_EraseRootFromParent_Done,
     /*  658667 */   // Label 10534: @658667
     /*  658667 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(658742), // Rule ID 7544 //
     /*  658672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658740 */     GIR_RootConstrainSelectedInstOperands,
     /*  658741 */     // GIR_Coverage, 7544,
     /*  658741 */     GIR_EraseRootFromParent_Done,
     /*  658742 */   // Label 10535: @658742
     /*  658742 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(658817), // Rule ID 7545 //
     /*  658747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658815 */     GIR_RootConstrainSelectedInstOperands,
     /*  658816 */     // GIR_Coverage, 7545,
     /*  658816 */     GIR_EraseRootFromParent_Done,
     /*  658817 */   // Label 10536: @658817
     /*  658817 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(658892), // Rule ID 7548 //
     /*  658822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658890 */     GIR_RootConstrainSelectedInstOperands,
     /*  658891 */     // GIR_Coverage, 7548,
     /*  658891 */     GIR_EraseRootFromParent_Done,
     /*  658892 */   // Label 10537: @658892
     /*  658892 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(658967), // Rule ID 7549 //
     /*  658897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658965 */     GIR_RootConstrainSelectedInstOperands,
     /*  658966 */     // GIR_Coverage, 7549,
     /*  658966 */     GIR_EraseRootFromParent_Done,
     /*  658967 */   // Label 10538: @658967
     /*  658967 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(659042), // Rule ID 7552 //
     /*  658972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  659021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659040 */     GIR_RootConstrainSelectedInstOperands,
     /*  659041 */     // GIR_Coverage, 7552,
     /*  659041 */     GIR_EraseRootFromParent_Done,
     /*  659042 */   // Label 10539: @659042
     /*  659042 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(659117), // Rule ID 7553 //
     /*  659047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  659058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  659061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  659064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  659096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659115 */     GIR_RootConstrainSelectedInstOperands,
     /*  659116 */     // GIR_Coverage, 7553,
     /*  659116 */     GIR_EraseRootFromParent_Done,
     /*  659117 */   // Label 10540: @659117
     /*  659117 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(659192), // Rule ID 7556 //
     /*  659122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  659133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  659136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  659139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  659171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659190 */     GIR_RootConstrainSelectedInstOperands,
     /*  659191 */     // GIR_Coverage, 7556,
     /*  659191 */     GIR_EraseRootFromParent_Done,
     /*  659192 */   // Label 10541: @659192
     /*  659192 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(659267), // Rule ID 7557 //
     /*  659197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  659208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  659211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  659214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  659246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659265 */     GIR_RootConstrainSelectedInstOperands,
     /*  659266 */     // GIR_Coverage, 7557,
     /*  659266 */     GIR_EraseRootFromParent_Done,
     /*  659267 */   // Label 10542: @659267
     /*  659267 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(659342), // Rule ID 7560 //
     /*  659272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  659283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  659286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  659289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  659321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659340 */     GIR_RootConstrainSelectedInstOperands,
     /*  659341 */     // GIR_Coverage, 7560,
     /*  659341 */     GIR_EraseRootFromParent_Done,
     /*  659342 */   // Label 10543: @659342
     /*  659342 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(659417), // Rule ID 7561 //
     /*  659347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  659358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  659361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  659364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  659396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659415 */     GIR_RootConstrainSelectedInstOperands,
     /*  659416 */     // GIR_Coverage, 7561,
     /*  659416 */     GIR_EraseRootFromParent_Done,
     /*  659417 */   // Label 10544: @659417
     /*  659417 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(659492), // Rule ID 7564 //
     /*  659422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  659425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  659442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659490 */     GIR_RootConstrainSelectedInstOperands,
     /*  659491 */     // GIR_Coverage, 7564,
     /*  659491 */     GIR_EraseRootFromParent_Done,
     /*  659492 */   // Label 10545: @659492
     /*  659492 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(659567), // Rule ID 7565 //
     /*  659497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659565 */     GIR_RootConstrainSelectedInstOperands,
     /*  659566 */     // GIR_Coverage, 7565,
     /*  659566 */     GIR_EraseRootFromParent_Done,
     /*  659567 */   // Label 10546: @659567
     /*  659567 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(659642), // Rule ID 7628 //
     /*  659572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659640 */     GIR_RootConstrainSelectedInstOperands,
     /*  659641 */     // GIR_Coverage, 7628,
     /*  659641 */     GIR_EraseRootFromParent_Done,
     /*  659642 */   // Label 10547: @659642
     /*  659642 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(659717), // Rule ID 7629 //
     /*  659647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659715 */     GIR_RootConstrainSelectedInstOperands,
     /*  659716 */     // GIR_Coverage, 7629,
     /*  659716 */     GIR_EraseRootFromParent_Done,
     /*  659717 */   // Label 10548: @659717
     /*  659717 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(659792), // Rule ID 7632 //
     /*  659722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659790 */     GIR_RootConstrainSelectedInstOperands,
     /*  659791 */     // GIR_Coverage, 7632,
     /*  659791 */     GIR_EraseRootFromParent_Done,
     /*  659792 */   // Label 10549: @659792
     /*  659792 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(659867), // Rule ID 7633 //
     /*  659797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659865 */     GIR_RootConstrainSelectedInstOperands,
     /*  659866 */     // GIR_Coverage, 7633,
     /*  659866 */     GIR_EraseRootFromParent_Done,
     /*  659867 */   // Label 10550: @659867
     /*  659867 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(659942), // Rule ID 7636 //
     /*  659872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659940 */     GIR_RootConstrainSelectedInstOperands,
     /*  659941 */     // GIR_Coverage, 7636,
     /*  659941 */     GIR_EraseRootFromParent_Done,
     /*  659942 */   // Label 10551: @659942
     /*  659942 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(660017), // Rule ID 7637 //
     /*  659947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660015 */     GIR_RootConstrainSelectedInstOperands,
     /*  660016 */     // GIR_Coverage, 7637,
     /*  660016 */     GIR_EraseRootFromParent_Done,
     /*  660017 */   // Label 10552: @660017
     /*  660017 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(660092), // Rule ID 7640 //
     /*  660022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  660033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  660036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  660039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  660042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660090 */     GIR_RootConstrainSelectedInstOperands,
     /*  660091 */     // GIR_Coverage, 7640,
     /*  660091 */     GIR_EraseRootFromParent_Done,
     /*  660092 */   // Label 10553: @660092
     /*  660092 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(660167), // Rule ID 7641 //
     /*  660097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  660108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  660111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  660114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  660117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660143 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660165 */     GIR_RootConstrainSelectedInstOperands,
     /*  660166 */     // GIR_Coverage, 7641,
     /*  660166 */     GIR_EraseRootFromParent_Done,
     /*  660167 */   // Label 10554: @660167
     /*  660167 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(660242), // Rule ID 7644 //
     /*  660172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  660183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  660186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  660189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  660192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660240 */     GIR_RootConstrainSelectedInstOperands,
     /*  660241 */     // GIR_Coverage, 7644,
     /*  660241 */     GIR_EraseRootFromParent_Done,
     /*  660242 */   // Label 10555: @660242
     /*  660242 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(660317), // Rule ID 7645 //
     /*  660247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  660258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  660261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  660264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  660267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660315 */     GIR_RootConstrainSelectedInstOperands,
     /*  660316 */     // GIR_Coverage, 7645,
     /*  660316 */     GIR_EraseRootFromParent_Done,
     /*  660317 */   // Label 10556: @660317
     /*  660317 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(660392), // Rule ID 7648 //
     /*  660322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  660333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  660336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  660339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  660342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660390 */     GIR_RootConstrainSelectedInstOperands,
     /*  660391 */     // GIR_Coverage, 7648,
     /*  660391 */     GIR_EraseRootFromParent_Done,
     /*  660392 */   // Label 10557: @660392
     /*  660392 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(660467), // Rule ID 7649 //
     /*  660397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  660408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  660411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  660414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  660417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660443 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660465 */     GIR_RootConstrainSelectedInstOperands,
     /*  660466 */     // GIR_Coverage, 7649,
     /*  660466 */     GIR_EraseRootFromParent_Done,
     /*  660467 */   // Label 10558: @660467
     /*  660467 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(660542), // Rule ID 7652 //
     /*  660472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660540 */     GIR_RootConstrainSelectedInstOperands,
     /*  660541 */     // GIR_Coverage, 7652,
     /*  660541 */     GIR_EraseRootFromParent_Done,
     /*  660542 */   // Label 10559: @660542
     /*  660542 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(660617), // Rule ID 7653 //
     /*  660547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660615 */     GIR_RootConstrainSelectedInstOperands,
     /*  660616 */     // GIR_Coverage, 7653,
     /*  660616 */     GIR_EraseRootFromParent_Done,
     /*  660617 */   // Label 10560: @660617
     /*  660617 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(660692), // Rule ID 7656 //
     /*  660622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660690 */     GIR_RootConstrainSelectedInstOperands,
     /*  660691 */     // GIR_Coverage, 7656,
     /*  660691 */     GIR_EraseRootFromParent_Done,
     /*  660692 */   // Label 10561: @660692
     /*  660692 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(660767), // Rule ID 7657 //
     /*  660697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660765 */     GIR_RootConstrainSelectedInstOperands,
     /*  660766 */     // GIR_Coverage, 7657,
     /*  660766 */     GIR_EraseRootFromParent_Done,
     /*  660767 */   // Label 10562: @660767
     /*  660767 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(660842), // Rule ID 7660 //
     /*  660772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660840 */     GIR_RootConstrainSelectedInstOperands,
     /*  660841 */     // GIR_Coverage, 7660,
     /*  660841 */     GIR_EraseRootFromParent_Done,
     /*  660842 */   // Label 10563: @660842
     /*  660842 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(660917), // Rule ID 7661 //
     /*  660847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660915 */     GIR_RootConstrainSelectedInstOperands,
     /*  660916 */     // GIR_Coverage, 7661,
     /*  660916 */     GIR_EraseRootFromParent_Done,
     /*  660917 */   // Label 10564: @660917
     /*  660917 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(660992), // Rule ID 7664 //
     /*  660922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660990 */     GIR_RootConstrainSelectedInstOperands,
     /*  660991 */     // GIR_Coverage, 7664,
     /*  660991 */     GIR_EraseRootFromParent_Done,
     /*  660992 */   // Label 10565: @660992
     /*  660992 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(661067), // Rule ID 7665 //
     /*  660997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  661008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  661011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  661014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  661017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661065 */     GIR_RootConstrainSelectedInstOperands,
     /*  661066 */     // GIR_Coverage, 7665,
     /*  661066 */     GIR_EraseRootFromParent_Done,
     /*  661067 */   // Label 10566: @661067
     /*  661067 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(661142), // Rule ID 7668 //
     /*  661072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  661083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  661086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  661089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  661092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661140 */     GIR_RootConstrainSelectedInstOperands,
     /*  661141 */     // GIR_Coverage, 7668,
     /*  661141 */     GIR_EraseRootFromParent_Done,
     /*  661142 */   // Label 10567: @661142
     /*  661142 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(661217), // Rule ID 7669 //
     /*  661147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  661158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  661161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  661164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  661167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661215 */     GIR_RootConstrainSelectedInstOperands,
     /*  661216 */     // GIR_Coverage, 7669,
     /*  661216 */     GIR_EraseRootFromParent_Done,
     /*  661217 */   // Label 10568: @661217
     /*  661217 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(661292), // Rule ID 7672 //
     /*  661222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  661233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  661236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  661239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  661242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  661271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661290 */     GIR_RootConstrainSelectedInstOperands,
     /*  661291 */     // GIR_Coverage, 7672,
     /*  661291 */     GIR_EraseRootFromParent_Done,
     /*  661292 */   // Label 10569: @661292
     /*  661292 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(661367), // Rule ID 7673 //
     /*  661297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  661308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  661311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  661314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  661317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  661346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661365 */     GIR_RootConstrainSelectedInstOperands,
     /*  661366 */     // GIR_Coverage, 7673,
     /*  661366 */     GIR_EraseRootFromParent_Done,
     /*  661367 */   // Label 10570: @661367
     /*  661367 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(661442), // Rule ID 7676 //
     /*  661372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  661383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  661386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  661389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661440 */     GIR_RootConstrainSelectedInstOperands,
     /*  661441 */     // GIR_Coverage, 7676,
     /*  661441 */     GIR_EraseRootFromParent_Done,
     /*  661442 */   // Label 10571: @661442
     /*  661442 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(661517), // Rule ID 7677 //
     /*  661447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  661458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  661461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  661464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661515 */     GIR_RootConstrainSelectedInstOperands,
     /*  661516 */     // GIR_Coverage, 7677,
     /*  661516 */     GIR_EraseRootFromParent_Done,
     /*  661517 */   // Label 10572: @661517
     /*  661517 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(661592), // Rule ID 7680 //
     /*  661522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661590 */     GIR_RootConstrainSelectedInstOperands,
     /*  661591 */     // GIR_Coverage, 7680,
     /*  661591 */     GIR_EraseRootFromParent_Done,
     /*  661592 */   // Label 10573: @661592
     /*  661592 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(661667), // Rule ID 7681 //
     /*  661597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661665 */     GIR_RootConstrainSelectedInstOperands,
     /*  661666 */     // GIR_Coverage, 7681,
     /*  661666 */     GIR_EraseRootFromParent_Done,
     /*  661667 */   // Label 10574: @661667
     /*  661667 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(661742), // Rule ID 7684 //
     /*  661672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661740 */     GIR_RootConstrainSelectedInstOperands,
     /*  661741 */     // GIR_Coverage, 7684,
     /*  661741 */     GIR_EraseRootFromParent_Done,
     /*  661742 */   // Label 10575: @661742
     /*  661742 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(661817), // Rule ID 7685 //
     /*  661747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661815 */     GIR_RootConstrainSelectedInstOperands,
     /*  661816 */     // GIR_Coverage, 7685,
     /*  661816 */     GIR_EraseRootFromParent_Done,
     /*  661817 */   // Label 10576: @661817
     /*  661817 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(661892), // Rule ID 7688 //
     /*  661822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661890 */     GIR_RootConstrainSelectedInstOperands,
     /*  661891 */     // GIR_Coverage, 7688,
     /*  661891 */     GIR_EraseRootFromParent_Done,
     /*  661892 */   // Label 10577: @661892
     /*  661892 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(661967), // Rule ID 7689 //
     /*  661897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661943 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661965 */     GIR_RootConstrainSelectedInstOperands,
     /*  661966 */     // GIR_Coverage, 7689,
     /*  661966 */     GIR_EraseRootFromParent_Done,
     /*  661967 */   // Label 10578: @661967
     /*  661967 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(662042), // Rule ID 7692 //
     /*  661972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662040 */     GIR_RootConstrainSelectedInstOperands,
     /*  662041 */     // GIR_Coverage, 7692,
     /*  662041 */     GIR_EraseRootFromParent_Done,
     /*  662042 */   // Label 10579: @662042
     /*  662042 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(662117), // Rule ID 7693 //
     /*  662047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  662058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  662061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  662064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662115 */     GIR_RootConstrainSelectedInstOperands,
     /*  662116 */     // GIR_Coverage, 7693,
     /*  662116 */     GIR_EraseRootFromParent_Done,
     /*  662117 */   // Label 10580: @662117
     /*  662117 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(662192), // Rule ID 7696 //
     /*  662122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  662139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662190 */     GIR_RootConstrainSelectedInstOperands,
     /*  662191 */     // GIR_Coverage, 7696,
     /*  662191 */     GIR_EraseRootFromParent_Done,
     /*  662192 */   // Label 10581: @662192
     /*  662192 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(662267), // Rule ID 7697 //
     /*  662197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  662208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  662211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  662214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662265 */     GIR_RootConstrainSelectedInstOperands,
     /*  662266 */     // GIR_Coverage, 7697,
     /*  662266 */     GIR_EraseRootFromParent_Done,
     /*  662267 */   // Label 10582: @662267
     /*  662267 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(662342), // Rule ID 7700 //
     /*  662272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  662289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662340 */     GIR_RootConstrainSelectedInstOperands,
     /*  662341 */     // GIR_Coverage, 7700,
     /*  662341 */     GIR_EraseRootFromParent_Done,
     /*  662342 */   // Label 10583: @662342
     /*  662342 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(662417), // Rule ID 7701 //
     /*  662347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  662358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  662361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  662364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662393 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662415 */     GIR_RootConstrainSelectedInstOperands,
     /*  662416 */     // GIR_Coverage, 7701,
     /*  662416 */     GIR_EraseRootFromParent_Done,
     /*  662417 */   // Label 10584: @662417
     /*  662417 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(662492), // Rule ID 7704 //
     /*  662422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662490 */     GIR_RootConstrainSelectedInstOperands,
     /*  662491 */     // GIR_Coverage, 7704,
     /*  662491 */     GIR_EraseRootFromParent_Done,
     /*  662492 */   // Label 10585: @662492
     /*  662492 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(662567), // Rule ID 7705 //
     /*  662497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662565 */     GIR_RootConstrainSelectedInstOperands,
     /*  662566 */     // GIR_Coverage, 7705,
     /*  662566 */     GIR_EraseRootFromParent_Done,
     /*  662567 */   // Label 10586: @662567
     /*  662567 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(662642), // Rule ID 7708 //
     /*  662572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662640 */     GIR_RootConstrainSelectedInstOperands,
     /*  662641 */     // GIR_Coverage, 7708,
     /*  662641 */     GIR_EraseRootFromParent_Done,
     /*  662642 */   // Label 10587: @662642
     /*  662642 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(662717), // Rule ID 7709 //
     /*  662647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662693 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662715 */     GIR_RootConstrainSelectedInstOperands,
     /*  662716 */     // GIR_Coverage, 7709,
     /*  662716 */     GIR_EraseRootFromParent_Done,
     /*  662717 */   // Label 10588: @662717
     /*  662717 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(662792), // Rule ID 7712 //
     /*  662722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662790 */     GIR_RootConstrainSelectedInstOperands,
     /*  662791 */     // GIR_Coverage, 7712,
     /*  662791 */     GIR_EraseRootFromParent_Done,
     /*  662792 */   // Label 10589: @662792
     /*  662792 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(662867), // Rule ID 7713 //
     /*  662797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662865 */     GIR_RootConstrainSelectedInstOperands,
     /*  662866 */     // GIR_Coverage, 7713,
     /*  662866 */     GIR_EraseRootFromParent_Done,
     /*  662867 */   // Label 10590: @662867
     /*  662867 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(662942), // Rule ID 7716 //
     /*  662872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662940 */     GIR_RootConstrainSelectedInstOperands,
     /*  662941 */     // GIR_Coverage, 7716,
     /*  662941 */     GIR_EraseRootFromParent_Done,
     /*  662942 */   // Label 10591: @662942
     /*  662942 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(663017), // Rule ID 7717 //
     /*  662947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663015 */     GIR_RootConstrainSelectedInstOperands,
     /*  663016 */     // GIR_Coverage, 7717,
     /*  663016 */     GIR_EraseRootFromParent_Done,
     /*  663017 */   // Label 10592: @663017
     /*  663017 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(663092), // Rule ID 7720 //
     /*  663022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  663039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663090 */     GIR_RootConstrainSelectedInstOperands,
     /*  663091 */     // GIR_Coverage, 7720,
     /*  663091 */     GIR_EraseRootFromParent_Done,
     /*  663092 */   // Label 10593: @663092
     /*  663092 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(663167), // Rule ID 7721 //
     /*  663097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  663108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  663111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  663114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663165 */     GIR_RootConstrainSelectedInstOperands,
     /*  663166 */     // GIR_Coverage, 7721,
     /*  663166 */     GIR_EraseRootFromParent_Done,
     /*  663167 */   // Label 10594: @663167
     /*  663167 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(663242), // Rule ID 7724 //
     /*  663172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  663183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  663186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  663189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663240 */     GIR_RootConstrainSelectedInstOperands,
     /*  663241 */     // GIR_Coverage, 7724,
     /*  663241 */     GIR_EraseRootFromParent_Done,
     /*  663242 */   // Label 10595: @663242
     /*  663242 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(663317), // Rule ID 7725 //
     /*  663247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  663258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  663261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  663264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663315 */     GIR_RootConstrainSelectedInstOperands,
     /*  663316 */     // GIR_Coverage, 7725,
     /*  663316 */     GIR_EraseRootFromParent_Done,
     /*  663317 */   // Label 10596: @663317
     /*  663317 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(663392), // Rule ID 7728 //
     /*  663322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  663333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  663336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  663339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663390 */     GIR_RootConstrainSelectedInstOperands,
     /*  663391 */     // GIR_Coverage, 7728,
     /*  663391 */     GIR_EraseRootFromParent_Done,
     /*  663392 */   // Label 10597: @663392
     /*  663392 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(663467), // Rule ID 7729 //
     /*  663397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  663408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  663411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  663414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663465 */     GIR_RootConstrainSelectedInstOperands,
     /*  663466 */     // GIR_Coverage, 7729,
     /*  663466 */     GIR_EraseRootFromParent_Done,
     /*  663467 */   // Label 10598: @663467
     /*  663467 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(663542), // Rule ID 7732 //
     /*  663472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663540 */     GIR_RootConstrainSelectedInstOperands,
     /*  663541 */     // GIR_Coverage, 7732,
     /*  663541 */     GIR_EraseRootFromParent_Done,
     /*  663542 */   // Label 10599: @663542
     /*  663542 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(663617), // Rule ID 7733 //
     /*  663547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663615 */     GIR_RootConstrainSelectedInstOperands,
     /*  663616 */     // GIR_Coverage, 7733,
     /*  663616 */     GIR_EraseRootFromParent_Done,
     /*  663617 */   // Label 10600: @663617
     /*  663617 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(663692), // Rule ID 7736 //
     /*  663622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663690 */     GIR_RootConstrainSelectedInstOperands,
     /*  663691 */     // GIR_Coverage, 7736,
     /*  663691 */     GIR_EraseRootFromParent_Done,
     /*  663692 */   // Label 10601: @663692
     /*  663692 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(663767), // Rule ID 7737 //
     /*  663697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663765 */     GIR_RootConstrainSelectedInstOperands,
     /*  663766 */     // GIR_Coverage, 7737,
     /*  663766 */     GIR_EraseRootFromParent_Done,
     /*  663767 */   // Label 10602: @663767
     /*  663767 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(663842), // Rule ID 7740 //
     /*  663772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663840 */     GIR_RootConstrainSelectedInstOperands,
     /*  663841 */     // GIR_Coverage, 7740,
     /*  663841 */     GIR_EraseRootFromParent_Done,
     /*  663842 */   // Label 10603: @663842
     /*  663842 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(663917), // Rule ID 7741 //
     /*  663847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663915 */     GIR_RootConstrainSelectedInstOperands,
     /*  663916 */     // GIR_Coverage, 7741,
     /*  663916 */     GIR_EraseRootFromParent_Done,
     /*  663917 */   // Label 10604: @663917
     /*  663917 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(663992), // Rule ID 7744 //
     /*  663922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663990 */     GIR_RootConstrainSelectedInstOperands,
     /*  663991 */     // GIR_Coverage, 7744,
     /*  663991 */     GIR_EraseRootFromParent_Done,
     /*  663992 */   // Label 10605: @663992
     /*  663992 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(664067), // Rule ID 7745 //
     /*  663997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  664008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  664011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  664014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  664017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  664036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  664046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664065 */     GIR_RootConstrainSelectedInstOperands,
     /*  664066 */     // GIR_Coverage, 7745,
     /*  664066 */     GIR_EraseRootFromParent_Done,
     /*  664067 */   // Label 10606: @664067
     /*  664067 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(664142), // Rule ID 10260 //
     /*  664072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  664083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  664086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  664089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  664092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  664121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664140 */     GIR_RootConstrainSelectedInstOperands,
     /*  664141 */     // GIR_Coverage, 10260,
     /*  664141 */     GIR_EraseRootFromParent_Done,
     /*  664142 */   // Label 10607: @664142
     /*  664142 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(664217), // Rule ID 10261 //
     /*  664147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  664158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  664161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  664164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  664167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  664196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664215 */     GIR_RootConstrainSelectedInstOperands,
     /*  664216 */     // GIR_Coverage, 10261,
     /*  664216 */     GIR_EraseRootFromParent_Done,
     /*  664217 */   // Label 10608: @664217
     /*  664217 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(664292), // Rule ID 10264 //
     /*  664222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  664233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  664236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  664239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  664242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664290 */     GIR_RootConstrainSelectedInstOperands,
     /*  664291 */     // GIR_Coverage, 10264,
     /*  664291 */     GIR_EraseRootFromParent_Done,
     /*  664292 */   // Label 10609: @664292
     /*  664292 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(664367), // Rule ID 10265 //
     /*  664297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  664308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  664311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  664314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  664317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664343 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664365 */     GIR_RootConstrainSelectedInstOperands,
     /*  664366 */     // GIR_Coverage, 10265,
     /*  664366 */     GIR_EraseRootFromParent_Done,
     /*  664367 */   // Label 10610: @664367
     /*  664367 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(664442), // Rule ID 10268 //
     /*  664372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  664383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  664386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  664389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664440 */     GIR_RootConstrainSelectedInstOperands,
     /*  664441 */     // GIR_Coverage, 10268,
     /*  664441 */     GIR_EraseRootFromParent_Done,
     /*  664442 */   // Label 10611: @664442
     /*  664442 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(664517), // Rule ID 10269 //
     /*  664447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  664458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  664461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  664464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664515 */     GIR_RootConstrainSelectedInstOperands,
     /*  664516 */     // GIR_Coverage, 10269,
     /*  664516 */     GIR_EraseRootFromParent_Done,
     /*  664517 */   // Label 10612: @664517
     /*  664517 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(664592), // Rule ID 10272 //
     /*  664522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664590 */     GIR_RootConstrainSelectedInstOperands,
     /*  664591 */     // GIR_Coverage, 10272,
     /*  664591 */     GIR_EraseRootFromParent_Done,
     /*  664592 */   // Label 10613: @664592
     /*  664592 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(664667), // Rule ID 10273 //
     /*  664597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664665 */     GIR_RootConstrainSelectedInstOperands,
     /*  664666 */     // GIR_Coverage, 10273,
     /*  664666 */     GIR_EraseRootFromParent_Done,
     /*  664667 */   // Label 10614: @664667
     /*  664667 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(664742), // Rule ID 10276 //
     /*  664672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664740 */     GIR_RootConstrainSelectedInstOperands,
     /*  664741 */     // GIR_Coverage, 10276,
     /*  664741 */     GIR_EraseRootFromParent_Done,
     /*  664742 */   // Label 10615: @664742
     /*  664742 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(664817), // Rule ID 10277 //
     /*  664747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664815 */     GIR_RootConstrainSelectedInstOperands,
     /*  664816 */     // GIR_Coverage, 10277,
     /*  664816 */     GIR_EraseRootFromParent_Done,
     /*  664817 */   // Label 10616: @664817
     /*  664817 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(664892), // Rule ID 10280 //
     /*  664822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664890 */     GIR_RootConstrainSelectedInstOperands,
     /*  664891 */     // GIR_Coverage, 10280,
     /*  664891 */     GIR_EraseRootFromParent_Done,
     /*  664892 */   // Label 10617: @664892
     /*  664892 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(664967), // Rule ID 10281 //
     /*  664897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664965 */     GIR_RootConstrainSelectedInstOperands,
     /*  664966 */     // GIR_Coverage, 10281,
     /*  664966 */     GIR_EraseRootFromParent_Done,
     /*  664967 */   // Label 10618: @664967
     /*  664967 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(665042), // Rule ID 10284 //
     /*  664972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665040 */     GIR_RootConstrainSelectedInstOperands,
     /*  665041 */     // GIR_Coverage, 10284,
     /*  665041 */     GIR_EraseRootFromParent_Done,
     /*  665042 */   // Label 10619: @665042
     /*  665042 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(665117), // Rule ID 10285 //
     /*  665047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  665064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  665067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665093 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665115 */     GIR_RootConstrainSelectedInstOperands,
     /*  665116 */     // GIR_Coverage, 10285,
     /*  665116 */     GIR_EraseRootFromParent_Done,
     /*  665117 */   // Label 10620: @665117
     /*  665117 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(665192), // Rule ID 10288 //
     /*  665122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  665133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  665136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  665142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665190 */     GIR_RootConstrainSelectedInstOperands,
     /*  665191 */     // GIR_Coverage, 10288,
     /*  665191 */     GIR_EraseRootFromParent_Done,
     /*  665192 */   // Label 10621: @665192
     /*  665192 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(665267), // Rule ID 10289 //
     /*  665197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  665208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  665211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  665217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665265 */     GIR_RootConstrainSelectedInstOperands,
     /*  665266 */     // GIR_Coverage, 10289,
     /*  665266 */     GIR_EraseRootFromParent_Done,
     /*  665267 */   // Label 10622: @665267
     /*  665267 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(665342), // Rule ID 10292 //
     /*  665272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  665283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  665286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  665289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  665292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665340 */     GIR_RootConstrainSelectedInstOperands,
     /*  665341 */     // GIR_Coverage, 10292,
     /*  665341 */     GIR_EraseRootFromParent_Done,
     /*  665342 */   // Label 10623: @665342
     /*  665342 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(665417), // Rule ID 10293 //
     /*  665347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  665358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  665361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  665364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  665367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665415 */     GIR_RootConstrainSelectedInstOperands,
     /*  665416 */     // GIR_Coverage, 10293,
     /*  665416 */     GIR_EraseRootFromParent_Done,
     /*  665417 */   // Label 10624: @665417
     /*  665417 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(665492), // Rule ID 10296 //
     /*  665422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  665425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665490 */     GIR_RootConstrainSelectedInstOperands,
     /*  665491 */     // GIR_Coverage, 10296,
     /*  665491 */     GIR_EraseRootFromParent_Done,
     /*  665492 */   // Label 10625: @665492
     /*  665492 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(665567), // Rule ID 10297 //
     /*  665497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665565 */     GIR_RootConstrainSelectedInstOperands,
     /*  665566 */     // GIR_Coverage, 10297,
     /*  665566 */     GIR_EraseRootFromParent_Done,
     /*  665567 */   // Label 10626: @665567
     /*  665567 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(665642), // Rule ID 10300 //
     /*  665572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665640 */     GIR_RootConstrainSelectedInstOperands,
     /*  665641 */     // GIR_Coverage, 10300,
     /*  665641 */     GIR_EraseRootFromParent_Done,
     /*  665642 */   // Label 10627: @665642
     /*  665642 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(665717), // Rule ID 10301 //
     /*  665647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665715 */     GIR_RootConstrainSelectedInstOperands,
     /*  665716 */     // GIR_Coverage, 10301,
     /*  665716 */     GIR_EraseRootFromParent_Done,
     /*  665717 */   // Label 10628: @665717
     /*  665717 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(665792), // Rule ID 10304 //
     /*  665722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665768 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665790 */     GIR_RootConstrainSelectedInstOperands,
     /*  665791 */     // GIR_Coverage, 10304,
     /*  665791 */     GIR_EraseRootFromParent_Done,
     /*  665792 */   // Label 10629: @665792
     /*  665792 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(665867), // Rule ID 10305 //
     /*  665797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665843 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665865 */     GIR_RootConstrainSelectedInstOperands,
     /*  665866 */     // GIR_Coverage, 10305,
     /*  665866 */     GIR_EraseRootFromParent_Done,
     /*  665867 */   // Label 10630: @665867
     /*  665867 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(665942), // Rule ID 10308 //
     /*  665872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665940 */     GIR_RootConstrainSelectedInstOperands,
     /*  665941 */     // GIR_Coverage, 10308,
     /*  665941 */     GIR_EraseRootFromParent_Done,
     /*  665942 */   // Label 10631: @665942
     /*  665942 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(666017), // Rule ID 10309 //
     /*  665947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666015 */     GIR_RootConstrainSelectedInstOperands,
     /*  666016 */     // GIR_Coverage, 10309,
     /*  666016 */     GIR_EraseRootFromParent_Done,
     /*  666017 */   // Label 10632: @666017
     /*  666017 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(666092), // Rule ID 10312 //
     /*  666022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  666039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  666042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666090 */     GIR_RootConstrainSelectedInstOperands,
     /*  666091 */     // GIR_Coverage, 10312,
     /*  666091 */     GIR_EraseRootFromParent_Done,
     /*  666092 */   // Label 10633: @666092
     /*  666092 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(666167), // Rule ID 10313 //
     /*  666097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  666114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  666117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666165 */     GIR_RootConstrainSelectedInstOperands,
     /*  666166 */     // GIR_Coverage, 10313,
     /*  666166 */     GIR_EraseRootFromParent_Done,
     /*  666167 */   // Label 10634: @666167
     /*  666167 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(666242), // Rule ID 10316 //
     /*  666172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  666189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  666192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666240 */     GIR_RootConstrainSelectedInstOperands,
     /*  666241 */     // GIR_Coverage, 10316,
     /*  666241 */     GIR_EraseRootFromParent_Done,
     /*  666242 */   // Label 10635: @666242
     /*  666242 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(666317), // Rule ID 10317 //
     /*  666247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  666264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  666267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666315 */     GIR_RootConstrainSelectedInstOperands,
     /*  666316 */     // GIR_Coverage, 10317,
     /*  666316 */     GIR_EraseRootFromParent_Done,
     /*  666317 */   // Label 10636: @666317
     /*  666317 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(666392), // Rule ID 10320 //
     /*  666322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  666333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  666336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  666342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666390 */     GIR_RootConstrainSelectedInstOperands,
     /*  666391 */     // GIR_Coverage, 10320,
     /*  666391 */     GIR_EraseRootFromParent_Done,
     /*  666392 */   // Label 10637: @666392
     /*  666392 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(666467), // Rule ID 10321 //
     /*  666397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  666408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  666411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  666417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666465 */     GIR_RootConstrainSelectedInstOperands,
     /*  666466 */     // GIR_Coverage, 10321,
     /*  666466 */     GIR_EraseRootFromParent_Done,
     /*  666467 */   // Label 10638: @666467
     /*  666467 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(666542), // Rule ID 10324 //
     /*  666472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666540 */     GIR_RootConstrainSelectedInstOperands,
     /*  666541 */     // GIR_Coverage, 10324,
     /*  666541 */     GIR_EraseRootFromParent_Done,
     /*  666542 */   // Label 10639: @666542
     /*  666542 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(666617), // Rule ID 10325 //
     /*  666547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666615 */     GIR_RootConstrainSelectedInstOperands,
     /*  666616 */     // GIR_Coverage, 10325,
     /*  666616 */     GIR_EraseRootFromParent_Done,
     /*  666617 */   // Label 10640: @666617
     /*  666617 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(666692), // Rule ID 10328 //
     /*  666622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666690 */     GIR_RootConstrainSelectedInstOperands,
     /*  666691 */     // GIR_Coverage, 10328,
     /*  666691 */     GIR_EraseRootFromParent_Done,
     /*  666692 */   // Label 10641: @666692
     /*  666692 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(666767), // Rule ID 10329 //
     /*  666697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666765 */     GIR_RootConstrainSelectedInstOperands,
     /*  666766 */     // GIR_Coverage, 10329,
     /*  666766 */     GIR_EraseRootFromParent_Done,
     /*  666767 */   // Label 10642: @666767
     /*  666767 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(666842), // Rule ID 10332 //
     /*  666772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666840 */     GIR_RootConstrainSelectedInstOperands,
     /*  666841 */     // GIR_Coverage, 10332,
     /*  666841 */     GIR_EraseRootFromParent_Done,
     /*  666842 */   // Label 10643: @666842
     /*  666842 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(666917), // Rule ID 10333 //
     /*  666847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666915 */     GIR_RootConstrainSelectedInstOperands,
     /*  666916 */     // GIR_Coverage, 10333,
     /*  666916 */     GIR_EraseRootFromParent_Done,
     /*  666917 */   // Label 10644: @666917
     /*  666917 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(666992), // Rule ID 10336 //
     /*  666922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666990 */     GIR_RootConstrainSelectedInstOperands,
     /*  666991 */     // GIR_Coverage, 10336,
     /*  666991 */     GIR_EraseRootFromParent_Done,
     /*  666992 */   // Label 10645: @666992
     /*  666992 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(667067), // Rule ID 10337 //
     /*  666997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  667008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  667011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  667017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  667046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667065 */     GIR_RootConstrainSelectedInstOperands,
     /*  667066 */     // GIR_Coverage, 10337,
     /*  667066 */     GIR_EraseRootFromParent_Done,
     /*  667067 */   // Label 10646: @667067
     /*  667067 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(667142), // Rule ID 10340 //
     /*  667072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  667075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  667083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  667086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  667092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  667118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  667121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667140 */     GIR_RootConstrainSelectedInstOperands,
     /*  667141 */     // GIR_Coverage, 10340,
     /*  667141 */     GIR_EraseRootFromParent_Done,
     /*  667142 */   // Label 10647: @667142
     /*  667142 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(667217), // Rule ID 10341 //
     /*  667147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  667158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  667161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  667167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  667196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667215 */     GIR_RootConstrainSelectedInstOperands,
     /*  667216 */     // GIR_Coverage, 10341,
     /*  667216 */     GIR_EraseRootFromParent_Done,
     /*  667217 */   // Label 10648: @667217
     /*  667217 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(667292), // Rule ID 10344 //
     /*  667222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  667225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  667233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  667236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  667242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  667268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  667271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667290 */     GIR_RootConstrainSelectedInstOperands,
     /*  667291 */     // GIR_Coverage, 10344,
     /*  667291 */     GIR_EraseRootFromParent_Done,
     /*  667292 */   // Label 10649: @667292
     /*  667292 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(667367), // Rule ID 10345 //
     /*  667297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  667308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  667311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  667317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  667346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667365 */     GIR_RootConstrainSelectedInstOperands,
     /*  667366 */     // GIR_Coverage, 10345,
     /*  667366 */     GIR_EraseRootFromParent_Done,
     /*  667367 */   // Label 10650: @667367
     /*  667367 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(667442), // Rule ID 10348 //
     /*  667372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667440 */     GIR_RootConstrainSelectedInstOperands,
     /*  667441 */     // GIR_Coverage, 10348,
     /*  667441 */     GIR_EraseRootFromParent_Done,
     /*  667442 */   // Label 10651: @667442
     /*  667442 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(667517), // Rule ID 10349 //
     /*  667447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667493 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667515 */     GIR_RootConstrainSelectedInstOperands,
     /*  667516 */     // GIR_Coverage, 10349,
     /*  667516 */     GIR_EraseRootFromParent_Done,
     /*  667517 */   // Label 10652: @667517
     /*  667517 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(667592), // Rule ID 10352 //
     /*  667522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667568 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667590 */     GIR_RootConstrainSelectedInstOperands,
     /*  667591 */     // GIR_Coverage, 10352,
     /*  667591 */     GIR_EraseRootFromParent_Done,
     /*  667592 */   // Label 10653: @667592
     /*  667592 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(667667), // Rule ID 10353 //
     /*  667597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667665 */     GIR_RootConstrainSelectedInstOperands,
     /*  667666 */     // GIR_Coverage, 10353,
     /*  667666 */     GIR_EraseRootFromParent_Done,
     /*  667667 */   // Label 10654: @667667
     /*  667667 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(667742), // Rule ID 10356 //
     /*  667672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667740 */     GIR_RootConstrainSelectedInstOperands,
     /*  667741 */     // GIR_Coverage, 10356,
     /*  667741 */     GIR_EraseRootFromParent_Done,
     /*  667742 */   // Label 10655: @667742
     /*  667742 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(667817), // Rule ID 10357 //
     /*  667747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667793 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667815 */     GIR_RootConstrainSelectedInstOperands,
     /*  667816 */     // GIR_Coverage, 10357,
     /*  667816 */     GIR_EraseRootFromParent_Done,
     /*  667817 */   // Label 10656: @667817
     /*  667817 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(667892), // Rule ID 10360 //
     /*  667822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667890 */     GIR_RootConstrainSelectedInstOperands,
     /*  667891 */     // GIR_Coverage, 10360,
     /*  667891 */     GIR_EraseRootFromParent_Done,
     /*  667892 */   // Label 10657: @667892
     /*  667892 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(667967), // Rule ID 10361 //
     /*  667897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667965 */     GIR_RootConstrainSelectedInstOperands,
     /*  667966 */     // GIR_Coverage, 10361,
     /*  667966 */     GIR_EraseRootFromParent_Done,
     /*  667967 */   // Label 10658: @667967
     /*  667967 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(668042), // Rule ID 10364 //
     /*  667972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668040 */     GIR_RootConstrainSelectedInstOperands,
     /*  668041 */     // GIR_Coverage, 10364,
     /*  668041 */     GIR_EraseRootFromParent_Done,
     /*  668042 */   // Label 10659: @668042
     /*  668042 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(668117), // Rule ID 10365 //
     /*  668047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668115 */     GIR_RootConstrainSelectedInstOperands,
     /*  668116 */     // GIR_Coverage, 10365,
     /*  668116 */     GIR_EraseRootFromParent_Done,
     /*  668117 */   // Label 10660: @668117
     /*  668117 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(668192), // Rule ID 10368 //
     /*  668122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668190 */     GIR_RootConstrainSelectedInstOperands,
     /*  668191 */     // GIR_Coverage, 10368,
     /*  668191 */     GIR_EraseRootFromParent_Done,
     /*  668192 */   // Label 10661: @668192
     /*  668192 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(668267), // Rule ID 10369 //
     /*  668197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  668246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668265 */     GIR_RootConstrainSelectedInstOperands,
     /*  668266 */     // GIR_Coverage, 10369,
     /*  668266 */     GIR_EraseRootFromParent_Done,
     /*  668267 */   // Label 10662: @668267
     /*  668267 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(668342), // Rule ID 10372 //
     /*  668272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668340 */     GIR_RootConstrainSelectedInstOperands,
     /*  668341 */     // GIR_Coverage, 10372,
     /*  668341 */     GIR_EraseRootFromParent_Done,
     /*  668342 */   // Label 10663: @668342
     /*  668342 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(668417), // Rule ID 10373 //
     /*  668347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668393 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668415 */     GIR_RootConstrainSelectedInstOperands,
     /*  668416 */     // GIR_Coverage, 10373,
     /*  668416 */     GIR_EraseRootFromParent_Done,
     /*  668417 */   // Label 10664: @668417
     /*  668417 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(668492), // Rule ID 10376 //
     /*  668422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668490 */     GIR_RootConstrainSelectedInstOperands,
     /*  668491 */     // GIR_Coverage, 10376,
     /*  668491 */     GIR_EraseRootFromParent_Done,
     /*  668492 */   // Label 10665: @668492
     /*  668492 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(668567), // Rule ID 10377 //
     /*  668497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668543 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668565 */     GIR_RootConstrainSelectedInstOperands,
     /*  668566 */     // GIR_Coverage, 10377,
     /*  668566 */     GIR_EraseRootFromParent_Done,
     /*  668567 */   // Label 10666: @668567
     /*  668567 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(668642), // Rule ID 10380 //
     /*  668572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668640 */     GIR_RootConstrainSelectedInstOperands,
     /*  668641 */     // GIR_Coverage, 10380,
     /*  668641 */     GIR_EraseRootFromParent_Done,
     /*  668642 */   // Label 10667: @668642
     /*  668642 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(668717), // Rule ID 10381 //
     /*  668647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668715 */     GIR_RootConstrainSelectedInstOperands,
     /*  668716 */     // GIR_Coverage, 10381,
     /*  668716 */     GIR_EraseRootFromParent_Done,
     /*  668717 */   // Label 10668: @668717
     /*  668717 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(668792), // Rule ID 10384 //
     /*  668722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668790 */     GIR_RootConstrainSelectedInstOperands,
     /*  668791 */     // GIR_Coverage, 10384,
     /*  668791 */     GIR_EraseRootFromParent_Done,
     /*  668792 */   // Label 10669: @668792
     /*  668792 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(668867), // Rule ID 10385 //
     /*  668797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668865 */     GIR_RootConstrainSelectedInstOperands,
     /*  668866 */     // GIR_Coverage, 10385,
     /*  668866 */     GIR_EraseRootFromParent_Done,
     /*  668867 */   // Label 10670: @668867
     /*  668867 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(668942), // Rule ID 10388 //
     /*  668872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668940 */     GIR_RootConstrainSelectedInstOperands,
     /*  668941 */     // GIR_Coverage, 10388,
     /*  668941 */     GIR_EraseRootFromParent_Done,
     /*  668942 */   // Label 10671: @668942
     /*  668942 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(669017), // Rule ID 10389 //
     /*  668947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669015 */     GIR_RootConstrainSelectedInstOperands,
     /*  669016 */     // GIR_Coverage, 10389,
     /*  669016 */     GIR_EraseRootFromParent_Done,
     /*  669017 */   // Label 10672: @669017
     /*  669017 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(669092), // Rule ID 10392 //
     /*  669022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669090 */     GIR_RootConstrainSelectedInstOperands,
     /*  669091 */     // GIR_Coverage, 10392,
     /*  669091 */     GIR_EraseRootFromParent_Done,
     /*  669092 */   // Label 10673: @669092
     /*  669092 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(669167), // Rule ID 10393 //
     /*  669097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669165 */     GIR_RootConstrainSelectedInstOperands,
     /*  669166 */     // GIR_Coverage, 10393,
     /*  669166 */     GIR_EraseRootFromParent_Done,
     /*  669167 */   // Label 10674: @669167
     /*  669167 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(669242), // Rule ID 10396 //
     /*  669172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669240 */     GIR_RootConstrainSelectedInstOperands,
     /*  669241 */     // GIR_Coverage, 10396,
     /*  669241 */     GIR_EraseRootFromParent_Done,
     /*  669242 */   // Label 10675: @669242
     /*  669242 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(669317), // Rule ID 10397 //
     /*  669247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669315 */     GIR_RootConstrainSelectedInstOperands,
     /*  669316 */     // GIR_Coverage, 10397,
     /*  669316 */     GIR_EraseRootFromParent_Done,
     /*  669317 */   // Label 10676: @669317
     /*  669317 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(669392), // Rule ID 10400 //
     /*  669322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669390 */     GIR_RootConstrainSelectedInstOperands,
     /*  669391 */     // GIR_Coverage, 10400,
     /*  669391 */     GIR_EraseRootFromParent_Done,
     /*  669392 */   // Label 10677: @669392
     /*  669392 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(669467), // Rule ID 10401 //
     /*  669397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669465 */     GIR_RootConstrainSelectedInstOperands,
     /*  669466 */     // GIR_Coverage, 10401,
     /*  669466 */     GIR_EraseRootFromParent_Done,
     /*  669467 */   // Label 10678: @669467
     /*  669467 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(669542), // Rule ID 10404 //
     /*  669472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669540 */     GIR_RootConstrainSelectedInstOperands,
     /*  669541 */     // GIR_Coverage, 10404,
     /*  669541 */     GIR_EraseRootFromParent_Done,
     /*  669542 */   // Label 10679: @669542
     /*  669542 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(669617), // Rule ID 10405 //
     /*  669547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669593 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669615 */     GIR_RootConstrainSelectedInstOperands,
     /*  669616 */     // GIR_Coverage, 10405,
     /*  669616 */     GIR_EraseRootFromParent_Done,
     /*  669617 */   // Label 10680: @669617
     /*  669617 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(669692), // Rule ID 10408 //
     /*  669622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669690 */     GIR_RootConstrainSelectedInstOperands,
     /*  669691 */     // GIR_Coverage, 10408,
     /*  669691 */     GIR_EraseRootFromParent_Done,
     /*  669692 */   // Label 10681: @669692
     /*  669692 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(669767), // Rule ID 10409 //
     /*  669697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669743 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669765 */     GIR_RootConstrainSelectedInstOperands,
     /*  669766 */     // GIR_Coverage, 10409,
     /*  669766 */     GIR_EraseRootFromParent_Done,
     /*  669767 */   // Label 10682: @669767
     /*  669767 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(669842), // Rule ID 10412 //
     /*  669772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669840 */     GIR_RootConstrainSelectedInstOperands,
     /*  669841 */     // GIR_Coverage, 10412,
     /*  669841 */     GIR_EraseRootFromParent_Done,
     /*  669842 */   // Label 10683: @669842
     /*  669842 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(669917), // Rule ID 10413 //
     /*  669847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669915 */     GIR_RootConstrainSelectedInstOperands,
     /*  669916 */     // GIR_Coverage, 10413,
     /*  669916 */     GIR_EraseRootFromParent_Done,
     /*  669917 */   // Label 10684: @669917
     /*  669917 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(669992), // Rule ID 10416 //
     /*  669922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669990 */     GIR_RootConstrainSelectedInstOperands,
     /*  669991 */     // GIR_Coverage, 10416,
     /*  669991 */     GIR_EraseRootFromParent_Done,
     /*  669992 */   // Label 10685: @669992
     /*  669992 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(670067), // Rule ID 10417 //
     /*  669997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670065 */     GIR_RootConstrainSelectedInstOperands,
     /*  670066 */     // GIR_Coverage, 10417,
     /*  670066 */     GIR_EraseRootFromParent_Done,
     /*  670067 */   // Label 10686: @670067
     /*  670067 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(670142), // Rule ID 10420 //
     /*  670072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670140 */     GIR_RootConstrainSelectedInstOperands,
     /*  670141 */     // GIR_Coverage, 10420,
     /*  670141 */     GIR_EraseRootFromParent_Done,
     /*  670142 */   // Label 10687: @670142
     /*  670142 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(670217), // Rule ID 10421 //
     /*  670147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670215 */     GIR_RootConstrainSelectedInstOperands,
     /*  670216 */     // GIR_Coverage, 10421,
     /*  670216 */     GIR_EraseRootFromParent_Done,
     /*  670217 */   // Label 10688: @670217
     /*  670217 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(670292), // Rule ID 10424 //
     /*  670222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  670271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670290 */     GIR_RootConstrainSelectedInstOperands,
     /*  670291 */     // GIR_Coverage, 10424,
     /*  670291 */     GIR_EraseRootFromParent_Done,
     /*  670292 */   // Label 10689: @670292
     /*  670292 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(670367), // Rule ID 10425 //
     /*  670297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  670346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670365 */     GIR_RootConstrainSelectedInstOperands,
     /*  670366 */     // GIR_Coverage, 10425,
     /*  670366 */     GIR_EraseRootFromParent_Done,
     /*  670367 */   // Label 10690: @670367
     /*  670367 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(670442), // Rule ID 10428 //
     /*  670372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670440 */     GIR_RootConstrainSelectedInstOperands,
     /*  670441 */     // GIR_Coverage, 10428,
     /*  670441 */     GIR_EraseRootFromParent_Done,
     /*  670442 */   // Label 10691: @670442
     /*  670442 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(670517), // Rule ID 10429 //
     /*  670447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670515 */     GIR_RootConstrainSelectedInstOperands,
     /*  670516 */     // GIR_Coverage, 10429,
     /*  670516 */     GIR_EraseRootFromParent_Done,
     /*  670517 */   // Label 10692: @670517
     /*  670517 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(670592), // Rule ID 10432 //
     /*  670522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670590 */     GIR_RootConstrainSelectedInstOperands,
     /*  670591 */     // GIR_Coverage, 10432,
     /*  670591 */     GIR_EraseRootFromParent_Done,
     /*  670592 */   // Label 10693: @670592
     /*  670592 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(670667), // Rule ID 10433 //
     /*  670597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670665 */     GIR_RootConstrainSelectedInstOperands,
     /*  670666 */     // GIR_Coverage, 10433,
     /*  670666 */     GIR_EraseRootFromParent_Done,
     /*  670667 */   // Label 10694: @670667
     /*  670667 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(670742), // Rule ID 10436 //
     /*  670672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670740 */     GIR_RootConstrainSelectedInstOperands,
     /*  670741 */     // GIR_Coverage, 10436,
     /*  670741 */     GIR_EraseRootFromParent_Done,
     /*  670742 */   // Label 10695: @670742
     /*  670742 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(670817), // Rule ID 10437 //
     /*  670747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670815 */     GIR_RootConstrainSelectedInstOperands,
     /*  670816 */     // GIR_Coverage, 10437,
     /*  670816 */     GIR_EraseRootFromParent_Done,
     /*  670817 */   // Label 10696: @670817
     /*  670817 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(670892), // Rule ID 10440 //
     /*  670822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670890 */     GIR_RootConstrainSelectedInstOperands,
     /*  670891 */     // GIR_Coverage, 10440,
     /*  670891 */     GIR_EraseRootFromParent_Done,
     /*  670892 */   // Label 10697: @670892
     /*  670892 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(670967), // Rule ID 10441 //
     /*  670897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670943 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670965 */     GIR_RootConstrainSelectedInstOperands,
     /*  670966 */     // GIR_Coverage, 10441,
     /*  670966 */     GIR_EraseRootFromParent_Done,
     /*  670967 */   // Label 10698: @670967
     /*  670967 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(671042), // Rule ID 10444 //
     /*  670972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671040 */     GIR_RootConstrainSelectedInstOperands,
     /*  671041 */     // GIR_Coverage, 10444,
     /*  671041 */     GIR_EraseRootFromParent_Done,
     /*  671042 */   // Label 10699: @671042
     /*  671042 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(671117), // Rule ID 10445 //
     /*  671047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  671067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671093 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671115 */     GIR_RootConstrainSelectedInstOperands,
     /*  671116 */     // GIR_Coverage, 10445,
     /*  671116 */     GIR_EraseRootFromParent_Done,
     /*  671117 */   // Label 10700: @671117
     /*  671117 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(671192), // Rule ID 10448 //
     /*  671122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  671142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  671171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671190 */     GIR_RootConstrainSelectedInstOperands,
     /*  671191 */     // GIR_Coverage, 10448,
     /*  671191 */     GIR_EraseRootFromParent_Done,
     /*  671192 */   // Label 10701: @671192
     /*  671192 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(671267), // Rule ID 10449 //
     /*  671197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  671217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  671246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671265 */     GIR_RootConstrainSelectedInstOperands,
     /*  671266 */     // GIR_Coverage, 10449,
     /*  671266 */     GIR_EraseRootFromParent_Done,
     /*  671267 */   // Label 10702: @671267
     /*  671267 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(671342), // Rule ID 10452 //
     /*  671272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  671292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671340 */     GIR_RootConstrainSelectedInstOperands,
     /*  671341 */     // GIR_Coverage, 10452,
     /*  671341 */     GIR_EraseRootFromParent_Done,
     /*  671342 */   // Label 10703: @671342
     /*  671342 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(671417), // Rule ID 10453 //
     /*  671347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  671367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671393 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671415 */     GIR_RootConstrainSelectedInstOperands,
     /*  671416 */     // GIR_Coverage, 10453,
     /*  671416 */     GIR_EraseRootFromParent_Done,
     /*  671417 */   // Label 10704: @671417
     /*  671417 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(671492), // Rule ID 10456 //
     /*  671422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671490 */     GIR_RootConstrainSelectedInstOperands,
     /*  671491 */     // GIR_Coverage, 10456,
     /*  671491 */     GIR_EraseRootFromParent_Done,
     /*  671492 */   // Label 10705: @671492
     /*  671492 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(671567), // Rule ID 10457 //
     /*  671497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671565 */     GIR_RootConstrainSelectedInstOperands,
     /*  671566 */     // GIR_Coverage, 10457,
     /*  671566 */     GIR_EraseRootFromParent_Done,
     /*  671567 */   // Label 10706: @671567
     /*  671567 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(671642), // Rule ID 10460 //
     /*  671572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671640 */     GIR_RootConstrainSelectedInstOperands,
     /*  671641 */     // GIR_Coverage, 10460,
     /*  671641 */     GIR_EraseRootFromParent_Done,
     /*  671642 */   // Label 10707: @671642
     /*  671642 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(671717), // Rule ID 10461 //
     /*  671647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671715 */     GIR_RootConstrainSelectedInstOperands,
     /*  671716 */     // GIR_Coverage, 10461,
     /*  671716 */     GIR_EraseRootFromParent_Done,
     /*  671717 */   // Label 10708: @671717
     /*  671717 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(671792), // Rule ID 10464 //
     /*  671722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671790 */     GIR_RootConstrainSelectedInstOperands,
     /*  671791 */     // GIR_Coverage, 10464,
     /*  671791 */     GIR_EraseRootFromParent_Done,
     /*  671792 */   // Label 10709: @671792
     /*  671792 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(671867), // Rule ID 10465 //
     /*  671797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671865 */     GIR_RootConstrainSelectedInstOperands,
     /*  671866 */     // GIR_Coverage, 10465,
     /*  671866 */     GIR_EraseRootFromParent_Done,
     /*  671867 */   // Label 10710: @671867
     /*  671867 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(671942), // Rule ID 10468 //
     /*  671872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671940 */     GIR_RootConstrainSelectedInstOperands,
     /*  671941 */     // GIR_Coverage, 10468,
     /*  671941 */     GIR_EraseRootFromParent_Done,
     /*  671942 */   // Label 10711: @671942
     /*  671942 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(672017), // Rule ID 10469 //
     /*  671947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672015 */     GIR_RootConstrainSelectedInstOperands,
     /*  672016 */     // GIR_Coverage, 10469,
     /*  672016 */     GIR_EraseRootFromParent_Done,
     /*  672017 */   // Label 10712: @672017
     /*  672017 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(672092), // Rule ID 10472 //
     /*  672022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  672042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  672071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672090 */     GIR_RootConstrainSelectedInstOperands,
     /*  672091 */     // GIR_Coverage, 10472,
     /*  672091 */     GIR_EraseRootFromParent_Done,
     /*  672092 */   // Label 10713: @672092
     /*  672092 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(672167), // Rule ID 10473 //
     /*  672097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  672117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  672146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672165 */     GIR_RootConstrainSelectedInstOperands,
     /*  672166 */     // GIR_Coverage, 10473,
     /*  672166 */     GIR_EraseRootFromParent_Done,
     /*  672167 */   // Label 10714: @672167
     /*  672167 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(672242), // Rule ID 10476 //
     /*  672172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  672192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672240 */     GIR_RootConstrainSelectedInstOperands,
     /*  672241 */     // GIR_Coverage, 10476,
     /*  672241 */     GIR_EraseRootFromParent_Done,
     /*  672242 */   // Label 10715: @672242
     /*  672242 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(672317), // Rule ID 10477 //
     /*  672247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  672267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672315 */     GIR_RootConstrainSelectedInstOperands,
     /*  672316 */     // GIR_Coverage, 10477,
     /*  672316 */     GIR_EraseRootFromParent_Done,
     /*  672317 */   // Label 10716: @672317
     /*  672317 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(672392), // Rule ID 10480 //
     /*  672322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  672342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672390 */     GIR_RootConstrainSelectedInstOperands,
     /*  672391 */     // GIR_Coverage, 10480,
     /*  672391 */     GIR_EraseRootFromParent_Done,
     /*  672392 */   // Label 10717: @672392
     /*  672392 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(672467), // Rule ID 10481 //
     /*  672397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  672417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672443 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672465 */     GIR_RootConstrainSelectedInstOperands,
     /*  672466 */     // GIR_Coverage, 10481,
     /*  672466 */     GIR_EraseRootFromParent_Done,
     /*  672467 */   // Label 10718: @672467
     /*  672467 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(672542), // Rule ID 10484 //
     /*  672472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672540 */     GIR_RootConstrainSelectedInstOperands,
     /*  672541 */     // GIR_Coverage, 10484,
     /*  672541 */     GIR_EraseRootFromParent_Done,
     /*  672542 */   // Label 10719: @672542
     /*  672542 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(672617), // Rule ID 10485 //
     /*  672547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672593 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672615 */     GIR_RootConstrainSelectedInstOperands,
     /*  672616 */     // GIR_Coverage, 10485,
     /*  672616 */     GIR_EraseRootFromParent_Done,
     /*  672617 */   // Label 10720: @672617
     /*  672617 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(672692), // Rule ID 10488 //
     /*  672622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672690 */     GIR_RootConstrainSelectedInstOperands,
     /*  672691 */     // GIR_Coverage, 10488,
     /*  672691 */     GIR_EraseRootFromParent_Done,
     /*  672692 */   // Label 10721: @672692
     /*  672692 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(672767), // Rule ID 10489 //
     /*  672697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672765 */     GIR_RootConstrainSelectedInstOperands,
     /*  672766 */     // GIR_Coverage, 10489,
     /*  672766 */     GIR_EraseRootFromParent_Done,
     /*  672767 */   // Label 10722: @672767
     /*  672767 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(672842), // Rule ID 10492 //
     /*  672772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672840 */     GIR_RootConstrainSelectedInstOperands,
     /*  672841 */     // GIR_Coverage, 10492,
     /*  672841 */     GIR_EraseRootFromParent_Done,
     /*  672842 */   // Label 10723: @672842
     /*  672842 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(672917), // Rule ID 10493 //
     /*  672847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672893 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672915 */     GIR_RootConstrainSelectedInstOperands,
     /*  672916 */     // GIR_Coverage, 10493,
     /*  672916 */     GIR_EraseRootFromParent_Done,
     /*  672917 */   // Label 10724: @672917
     /*  672917 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(672992), // Rule ID 10496 //
     /*  672922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672990 */     GIR_RootConstrainSelectedInstOperands,
     /*  672991 */     // GIR_Coverage, 10496,
     /*  672991 */     GIR_EraseRootFromParent_Done,
     /*  672992 */   // Label 10725: @672992
     /*  672992 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(673067), // Rule ID 10497 //
     /*  672997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  673017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673043 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673065 */     GIR_RootConstrainSelectedInstOperands,
     /*  673066 */     // GIR_Coverage, 10497,
     /*  673066 */     GIR_EraseRootFromParent_Done,
     /*  673067 */   // Label 10726: @673067
     /*  673067 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(673142), // Rule ID 10500 //
     /*  673072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  673092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673140 */     GIR_RootConstrainSelectedInstOperands,
     /*  673141 */     // GIR_Coverage, 10500,
     /*  673141 */     GIR_EraseRootFromParent_Done,
     /*  673142 */   // Label 10727: @673142
     /*  673142 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(673217), // Rule ID 10501 //
     /*  673147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  673167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673215 */     GIR_RootConstrainSelectedInstOperands,
     /*  673216 */     // GIR_Coverage, 10501,
     /*  673216 */     GIR_EraseRootFromParent_Done,
     /*  673217 */   // Label 10728: @673217
     /*  673217 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(673292), // Rule ID 10504 //
     /*  673222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  673242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673290 */     GIR_RootConstrainSelectedInstOperands,
     /*  673291 */     // GIR_Coverage, 10504,
     /*  673291 */     GIR_EraseRootFromParent_Done,
     /*  673292 */   // Label 10729: @673292
     /*  673292 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(673367), // Rule ID 10505 //
     /*  673297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  673317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673343 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673365 */     GIR_RootConstrainSelectedInstOperands,
     /*  673366 */     // GIR_Coverage, 10505,
     /*  673366 */     GIR_EraseRootFromParent_Done,
     /*  673367 */   // Label 10730: @673367
     /*  673367 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(673442), // Rule ID 10508 //
     /*  673372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673440 */     GIR_RootConstrainSelectedInstOperands,
     /*  673441 */     // GIR_Coverage, 10508,
     /*  673441 */     GIR_EraseRootFromParent_Done,
     /*  673442 */   // Label 10731: @673442
     /*  673442 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(673517), // Rule ID 10509 //
     /*  673447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673493 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673515 */     GIR_RootConstrainSelectedInstOperands,
     /*  673516 */     // GIR_Coverage, 10509,
     /*  673516 */     GIR_EraseRootFromParent_Done,
     /*  673517 */   // Label 10732: @673517
     /*  673517 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(673592), // Rule ID 10512 //
     /*  673522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673590 */     GIR_RootConstrainSelectedInstOperands,
     /*  673591 */     // GIR_Coverage, 10512,
     /*  673591 */     GIR_EraseRootFromParent_Done,
     /*  673592 */   // Label 10733: @673592
     /*  673592 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(673667), // Rule ID 10513 //
     /*  673597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673665 */     GIR_RootConstrainSelectedInstOperands,
     /*  673666 */     // GIR_Coverage, 10513,
     /*  673666 */     GIR_EraseRootFromParent_Done,
     /*  673667 */   // Label 10734: @673667
     /*  673667 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(673742), // Rule ID 10516 //
     /*  673672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673740 */     GIR_RootConstrainSelectedInstOperands,
     /*  673741 */     // GIR_Coverage, 10516,
     /*  673741 */     GIR_EraseRootFromParent_Done,
     /*  673742 */   // Label 10735: @673742
     /*  673742 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(673817), // Rule ID 10517 //
     /*  673747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673815 */     GIR_RootConstrainSelectedInstOperands,
     /*  673816 */     // GIR_Coverage, 10517,
     /*  673816 */     GIR_EraseRootFromParent_Done,
     /*  673817 */   // Label 10736: @673817
     /*  673817 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(673892), // Rule ID 10520 //
     /*  673822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673890 */     GIR_RootConstrainSelectedInstOperands,
     /*  673891 */     // GIR_Coverage, 10520,
     /*  673891 */     GIR_EraseRootFromParent_Done,
     /*  673892 */   // Label 10737: @673892
     /*  673892 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(673967), // Rule ID 10521 //
     /*  673897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673965 */     GIR_RootConstrainSelectedInstOperands,
     /*  673966 */     // GIR_Coverage, 10521,
     /*  673966 */     GIR_EraseRootFromParent_Done,
     /*  673967 */   // Label 10738: @673967
     /*  673967 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(674042), // Rule ID 10524 //
     /*  673972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  674021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674040 */     GIR_RootConstrainSelectedInstOperands,
     /*  674041 */     // GIR_Coverage, 10524,
     /*  674041 */     GIR_EraseRootFromParent_Done,
     /*  674042 */   // Label 10739: @674042
     /*  674042 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(674117), // Rule ID 10525 //
     /*  674047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674093 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  674096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674115 */     GIR_RootConstrainSelectedInstOperands,
     /*  674116 */     // GIR_Coverage, 10525,
     /*  674116 */     GIR_EraseRootFromParent_Done,
     /*  674117 */   // Label 10740: @674117
     /*  674117 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(674192), // Rule ID 10528 //
     /*  674122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674190 */     GIR_RootConstrainSelectedInstOperands,
     /*  674191 */     // GIR_Coverage, 10528,
     /*  674191 */     GIR_EraseRootFromParent_Done,
     /*  674192 */   // Label 10741: @674192
     /*  674192 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(674267), // Rule ID 10529 //
     /*  674197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674265 */     GIR_RootConstrainSelectedInstOperands,
     /*  674266 */     // GIR_Coverage, 10529,
     /*  674266 */     GIR_EraseRootFromParent_Done,
     /*  674267 */   // Label 10742: @674267
     /*  674267 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(674342), // Rule ID 10532 //
     /*  674272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674340 */     GIR_RootConstrainSelectedInstOperands,
     /*  674341 */     // GIR_Coverage, 10532,
     /*  674341 */     GIR_EraseRootFromParent_Done,
     /*  674342 */   // Label 10743: @674342
     /*  674342 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(674417), // Rule ID 10533 //
     /*  674347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674415 */     GIR_RootConstrainSelectedInstOperands,
     /*  674416 */     // GIR_Coverage, 10533,
     /*  674416 */     GIR_EraseRootFromParent_Done,
     /*  674417 */   // Label 10744: @674417
     /*  674417 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(674492), // Rule ID 10536 //
     /*  674422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674490 */     GIR_RootConstrainSelectedInstOperands,
     /*  674491 */     // GIR_Coverage, 10536,
     /*  674491 */     GIR_EraseRootFromParent_Done,
     /*  674492 */   // Label 10745: @674492
     /*  674492 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(674567), // Rule ID 10537 //
     /*  674497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674543 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674565 */     GIR_RootConstrainSelectedInstOperands,
     /*  674566 */     // GIR_Coverage, 10537,
     /*  674566 */     GIR_EraseRootFromParent_Done,
     /*  674567 */   // Label 10746: @674567
     /*  674567 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(674642), // Rule ID 10540 //
     /*  674572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674640 */     GIR_RootConstrainSelectedInstOperands,
     /*  674641 */     // GIR_Coverage, 10540,
     /*  674641 */     GIR_EraseRootFromParent_Done,
     /*  674642 */   // Label 10747: @674642
     /*  674642 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(674717), // Rule ID 10541 //
     /*  674647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674715 */     GIR_RootConstrainSelectedInstOperands,
     /*  674716 */     // GIR_Coverage, 10541,
     /*  674716 */     GIR_EraseRootFromParent_Done,
     /*  674717 */   // Label 10748: @674717
     /*  674717 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(674792), // Rule ID 10544 //
     /*  674722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674790 */     GIR_RootConstrainSelectedInstOperands,
     /*  674791 */     // GIR_Coverage, 10544,
     /*  674791 */     GIR_EraseRootFromParent_Done,
     /*  674792 */   // Label 10749: @674792
     /*  674792 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(674867), // Rule ID 10545 //
     /*  674797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674865 */     GIR_RootConstrainSelectedInstOperands,
     /*  674866 */     // GIR_Coverage, 10545,
     /*  674866 */     GIR_EraseRootFromParent_Done,
     /*  674867 */   // Label 10750: @674867
     /*  674867 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(674942), // Rule ID 10548 //
     /*  674872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674940 */     GIR_RootConstrainSelectedInstOperands,
     /*  674941 */     // GIR_Coverage, 10548,
     /*  674941 */     GIR_EraseRootFromParent_Done,
     /*  674942 */   // Label 10751: @674942
     /*  674942 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(675017), // Rule ID 10549 //
     /*  674947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674993 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675015 */     GIR_RootConstrainSelectedInstOperands,
     /*  675016 */     // GIR_Coverage, 10549,
     /*  675016 */     GIR_EraseRootFromParent_Done,
     /*  675017 */   // Label 10752: @675017
     /*  675017 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(675092), // Rule ID 10552 //
     /*  675022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675090 */     GIR_RootConstrainSelectedInstOperands,
     /*  675091 */     // GIR_Coverage, 10552,
     /*  675091 */     GIR_EraseRootFromParent_Done,
     /*  675092 */   // Label 10753: @675092
     /*  675092 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(675167), // Rule ID 10553 //
     /*  675097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675165 */     GIR_RootConstrainSelectedInstOperands,
     /*  675166 */     // GIR_Coverage, 10553,
     /*  675166 */     GIR_EraseRootFromParent_Done,
     /*  675167 */   // Label 10754: @675167
     /*  675167 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(675242), // Rule ID 10556 //
     /*  675172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675240 */     GIR_RootConstrainSelectedInstOperands,
     /*  675241 */     // GIR_Coverage, 10556,
     /*  675241 */     GIR_EraseRootFromParent_Done,
     /*  675242 */   // Label 10755: @675242
     /*  675242 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(675317), // Rule ID 10557 //
     /*  675247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675315 */     GIR_RootConstrainSelectedInstOperands,
     /*  675316 */     // GIR_Coverage, 10557,
     /*  675316 */     GIR_EraseRootFromParent_Done,
     /*  675317 */   // Label 10756: @675317
     /*  675317 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(675392), // Rule ID 10560 //
     /*  675322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675390 */     GIR_RootConstrainSelectedInstOperands,
     /*  675391 */     // GIR_Coverage, 10560,
     /*  675391 */     GIR_EraseRootFromParent_Done,
     /*  675392 */   // Label 10757: @675392
     /*  675392 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(675467), // Rule ID 10561 //
     /*  675397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  675446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675465 */     GIR_RootConstrainSelectedInstOperands,
     /*  675466 */     // GIR_Coverage, 10561,
     /*  675466 */     GIR_EraseRootFromParent_Done,
     /*  675467 */   // Label 10758: @675467
     /*  675467 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(675542), // Rule ID 10564 //
     /*  675472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675540 */     GIR_RootConstrainSelectedInstOperands,
     /*  675541 */     // GIR_Coverage, 10564,
     /*  675541 */     GIR_EraseRootFromParent_Done,
     /*  675542 */   // Label 10759: @675542
     /*  675542 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(675617), // Rule ID 10565 //
     /*  675547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675615 */     GIR_RootConstrainSelectedInstOperands,
     /*  675616 */     // GIR_Coverage, 10565,
     /*  675616 */     GIR_EraseRootFromParent_Done,
     /*  675617 */   // Label 10760: @675617
     /*  675617 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(675692), // Rule ID 10568 //
     /*  675622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675690 */     GIR_RootConstrainSelectedInstOperands,
     /*  675691 */     // GIR_Coverage, 10568,
     /*  675691 */     GIR_EraseRootFromParent_Done,
     /*  675692 */   // Label 10761: @675692
     /*  675692 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(675767), // Rule ID 10569 //
     /*  675697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675743 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675765 */     GIR_RootConstrainSelectedInstOperands,
     /*  675766 */     // GIR_Coverage, 10569,
     /*  675766 */     GIR_EraseRootFromParent_Done,
     /*  675767 */   // Label 10762: @675767
     /*  675767 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(675842), // Rule ID 10572 //
     /*  675772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675840 */     GIR_RootConstrainSelectedInstOperands,
     /*  675841 */     // GIR_Coverage, 10572,
     /*  675841 */     GIR_EraseRootFromParent_Done,
     /*  675842 */   // Label 10763: @675842
     /*  675842 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(675917), // Rule ID 10573 //
     /*  675847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675915 */     GIR_RootConstrainSelectedInstOperands,
     /*  675916 */     // GIR_Coverage, 10573,
     /*  675916 */     GIR_EraseRootFromParent_Done,
     /*  675917 */   // Label 10764: @675917
     /*  675917 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(675992), // Rule ID 10576 //
     /*  675922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675990 */     GIR_RootConstrainSelectedInstOperands,
     /*  675991 */     // GIR_Coverage, 10576,
     /*  675991 */     GIR_EraseRootFromParent_Done,
     /*  675992 */   // Label 10765: @675992
     /*  675992 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(676067), // Rule ID 10577 //
     /*  675997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676065 */     GIR_RootConstrainSelectedInstOperands,
     /*  676066 */     // GIR_Coverage, 10577,
     /*  676066 */     GIR_EraseRootFromParent_Done,
     /*  676067 */   // Label 10766: @676067
     /*  676067 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(676142), // Rule ID 10580 //
     /*  676072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676140 */     GIR_RootConstrainSelectedInstOperands,
     /*  676141 */     // GIR_Coverage, 10580,
     /*  676141 */     GIR_EraseRootFromParent_Done,
     /*  676142 */   // Label 10767: @676142
     /*  676142 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(676217), // Rule ID 10581 //
     /*  676147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676215 */     GIR_RootConstrainSelectedInstOperands,
     /*  676216 */     // GIR_Coverage, 10581,
     /*  676216 */     GIR_EraseRootFromParent_Done,
     /*  676217 */   // Label 10768: @676217
     /*  676217 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(676292), // Rule ID 10584 //
     /*  676222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676290 */     GIR_RootConstrainSelectedInstOperands,
     /*  676291 */     // GIR_Coverage, 10584,
     /*  676291 */     GIR_EraseRootFromParent_Done,
     /*  676292 */   // Label 10769: @676292
     /*  676292 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(676367), // Rule ID 10585 //
     /*  676297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676365 */     GIR_RootConstrainSelectedInstOperands,
     /*  676366 */     // GIR_Coverage, 10585,
     /*  676366 */     GIR_EraseRootFromParent_Done,
     /*  676367 */   // Label 10770: @676367
     /*  676367 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(676442), // Rule ID 10588 //
     /*  676372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676440 */     GIR_RootConstrainSelectedInstOperands,
     /*  676441 */     // GIR_Coverage, 10588,
     /*  676441 */     GIR_EraseRootFromParent_Done,
     /*  676442 */   // Label 10771: @676442
     /*  676442 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(676517), // Rule ID 10589 //
     /*  676447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676515 */     GIR_RootConstrainSelectedInstOperands,
     /*  676516 */     // GIR_Coverage, 10589,
     /*  676516 */     GIR_EraseRootFromParent_Done,
     /*  676517 */   // Label 10772: @676517
     /*  676517 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(676592), // Rule ID 10592 //
     /*  676522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676590 */     GIR_RootConstrainSelectedInstOperands,
     /*  676591 */     // GIR_Coverage, 10592,
     /*  676591 */     GIR_EraseRootFromParent_Done,
     /*  676592 */   // Label 10773: @676592
     /*  676592 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(676667), // Rule ID 10593 //
     /*  676597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676665 */     GIR_RootConstrainSelectedInstOperands,
     /*  676666 */     // GIR_Coverage, 10593,
     /*  676666 */     GIR_EraseRootFromParent_Done,
     /*  676667 */   // Label 10774: @676667
     /*  676667 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(676742), // Rule ID 10596 //
     /*  676672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676740 */     GIR_RootConstrainSelectedInstOperands,
     /*  676741 */     // GIR_Coverage, 10596,
     /*  676741 */     GIR_EraseRootFromParent_Done,
     /*  676742 */   // Label 10775: @676742
     /*  676742 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(676817), // Rule ID 10597 //
     /*  676747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676815 */     GIR_RootConstrainSelectedInstOperands,
     /*  676816 */     // GIR_Coverage, 10597,
     /*  676816 */     GIR_EraseRootFromParent_Done,
     /*  676817 */   // Label 10776: @676817
     /*  676817 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(676892), // Rule ID 10600 //
     /*  676822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676890 */     GIR_RootConstrainSelectedInstOperands,
     /*  676891 */     // GIR_Coverage, 10600,
     /*  676891 */     GIR_EraseRootFromParent_Done,
     /*  676892 */   // Label 10777: @676892
     /*  676892 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(676967), // Rule ID 10601 //
     /*  676897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676965 */     GIR_RootConstrainSelectedInstOperands,
     /*  676966 */     // GIR_Coverage, 10601,
     /*  676966 */     GIR_EraseRootFromParent_Done,
     /*  676967 */   // Label 10778: @676967
     /*  676967 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(677042), // Rule ID 10604 //
     /*  676972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  677021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677040 */     GIR_RootConstrainSelectedInstOperands,
     /*  677041 */     // GIR_Coverage, 10604,
     /*  677041 */     GIR_EraseRootFromParent_Done,
     /*  677042 */   // Label 10779: @677042
     /*  677042 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(677117), // Rule ID 10605 //
     /*  677047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  677096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677115 */     GIR_RootConstrainSelectedInstOperands,
     /*  677116 */     // GIR_Coverage, 10605,
     /*  677116 */     GIR_EraseRootFromParent_Done,
     /*  677117 */   // Label 10780: @677117
     /*  677117 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(677192), // Rule ID 10608 //
     /*  677122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  677171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677190 */     GIR_RootConstrainSelectedInstOperands,
     /*  677191 */     // GIR_Coverage, 10608,
     /*  677191 */     GIR_EraseRootFromParent_Done,
     /*  677192 */   // Label 10781: @677192
     /*  677192 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(677267), // Rule ID 10609 //
     /*  677197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  677246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677265 */     GIR_RootConstrainSelectedInstOperands,
     /*  677266 */     // GIR_Coverage, 10609,
     /*  677266 */     GIR_EraseRootFromParent_Done,
     /*  677267 */   // Label 10782: @677267
     /*  677267 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(677342), // Rule ID 10612 //
     /*  677272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  677292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  677321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677340 */     GIR_RootConstrainSelectedInstOperands,
     /*  677341 */     // GIR_Coverage, 10612,
     /*  677341 */     GIR_EraseRootFromParent_Done,
     /*  677342 */   // Label 10783: @677342
     /*  677342 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(677417), // Rule ID 10613 //
     /*  677347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  677367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677393 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  677396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677415 */     GIR_RootConstrainSelectedInstOperands,
     /*  677416 */     // GIR_Coverage, 10613,
     /*  677416 */     GIR_EraseRootFromParent_Done,
     /*  677417 */   // Label 10784: @677417
     /*  677417 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(677492), // Rule ID 10616 //
     /*  677422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677490 */     GIR_RootConstrainSelectedInstOperands,
     /*  677491 */     // GIR_Coverage, 10616,
     /*  677491 */     GIR_EraseRootFromParent_Done,
     /*  677492 */   // Label 10785: @677492
     /*  677492 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(677567), // Rule ID 10617 //
     /*  677497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677543 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677565 */     GIR_RootConstrainSelectedInstOperands,
     /*  677566 */     // GIR_Coverage, 10617,
     /*  677566 */     GIR_EraseRootFromParent_Done,
     /*  677567 */   // Label 10786: @677567
     /*  677567 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(677642), // Rule ID 10620 //
     /*  677572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677640 */     GIR_RootConstrainSelectedInstOperands,
     /*  677641 */     // GIR_Coverage, 10620,
     /*  677641 */     GIR_EraseRootFromParent_Done,
     /*  677642 */   // Label 10787: @677642
     /*  677642 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(677717), // Rule ID 10621 //
     /*  677647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677693 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677715 */     GIR_RootConstrainSelectedInstOperands,
     /*  677716 */     // GIR_Coverage, 10621,
     /*  677716 */     GIR_EraseRootFromParent_Done,
     /*  677717 */   // Label 10788: @677717
     /*  677717 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(677792), // Rule ID 10624 //
     /*  677722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677790 */     GIR_RootConstrainSelectedInstOperands,
     /*  677791 */     // GIR_Coverage, 10624,
     /*  677791 */     GIR_EraseRootFromParent_Done,
     /*  677792 */   // Label 10789: @677792
     /*  677792 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(677867), // Rule ID 10625 //
     /*  677797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677865 */     GIR_RootConstrainSelectedInstOperands,
     /*  677866 */     // GIR_Coverage, 10625,
     /*  677866 */     GIR_EraseRootFromParent_Done,
     /*  677867 */   // Label 10790: @677867
     /*  677867 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(677942), // Rule ID 10628 //
     /*  677872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677940 */     GIR_RootConstrainSelectedInstOperands,
     /*  677941 */     // GIR_Coverage, 10628,
     /*  677941 */     GIR_EraseRootFromParent_Done,
     /*  677942 */   // Label 10791: @677942
     /*  677942 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(678017), // Rule ID 10629 //
     /*  677947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678015 */     GIR_RootConstrainSelectedInstOperands,
     /*  678016 */     // GIR_Coverage, 10629,
     /*  678016 */     GIR_EraseRootFromParent_Done,
     /*  678017 */   // Label 10792: @678017
     /*  678017 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(678092), // Rule ID 10632 //
     /*  678022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  678042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  678071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678090 */     GIR_RootConstrainSelectedInstOperands,
     /*  678091 */     // GIR_Coverage, 10632,
     /*  678091 */     GIR_EraseRootFromParent_Done,
     /*  678092 */   // Label 10793: @678092
     /*  678092 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(678167), // Rule ID 10633 //
     /*  678097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  678117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  678146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678165 */     GIR_RootConstrainSelectedInstOperands,
     /*  678166 */     // GIR_Coverage, 10633,
     /*  678166 */     GIR_EraseRootFromParent_Done,
     /*  678167 */   // Label 10794: @678167
     /*  678167 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(678242), // Rule ID 10636 //
     /*  678172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  678192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678240 */     GIR_RootConstrainSelectedInstOperands,
     /*  678241 */     // GIR_Coverage, 10636,
     /*  678241 */     GIR_EraseRootFromParent_Done,
     /*  678242 */   // Label 10795: @678242
     /*  678242 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(678317), // Rule ID 10637 //
     /*  678247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  678267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678315 */     GIR_RootConstrainSelectedInstOperands,
     /*  678316 */     // GIR_Coverage, 10637,
     /*  678316 */     GIR_EraseRootFromParent_Done,
     /*  678317 */   // Label 10796: @678317
     /*  678317 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(678392), // Rule ID 10640 //
     /*  678322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  678342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678390 */     GIR_RootConstrainSelectedInstOperands,
     /*  678391 */     // GIR_Coverage, 10640,
     /*  678391 */     GIR_EraseRootFromParent_Done,
     /*  678392 */   // Label 10797: @678392
     /*  678392 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(678467), // Rule ID 10641 //
     /*  678397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  678417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678465 */     GIR_RootConstrainSelectedInstOperands,
     /*  678466 */     // GIR_Coverage, 10641,
     /*  678466 */     GIR_EraseRootFromParent_Done,
     /*  678467 */   // Label 10798: @678467
     /*  678467 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(678542), // Rule ID 10644 //
     /*  678472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678540 */     GIR_RootConstrainSelectedInstOperands,
     /*  678541 */     // GIR_Coverage, 10644,
     /*  678541 */     GIR_EraseRootFromParent_Done,
     /*  678542 */   // Label 10799: @678542
     /*  678542 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(678617), // Rule ID 10645 //
     /*  678547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678615 */     GIR_RootConstrainSelectedInstOperands,
     /*  678616 */     // GIR_Coverage, 10645,
     /*  678616 */     GIR_EraseRootFromParent_Done,
     /*  678617 */   // Label 10800: @678617
     /*  678617 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(678692), // Rule ID 10648 //
     /*  678622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678690 */     GIR_RootConstrainSelectedInstOperands,
     /*  678691 */     // GIR_Coverage, 10648,
     /*  678691 */     GIR_EraseRootFromParent_Done,
     /*  678692 */   // Label 10801: @678692
     /*  678692 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(678767), // Rule ID 10649 //
     /*  678697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678765 */     GIR_RootConstrainSelectedInstOperands,
     /*  678766 */     // GIR_Coverage, 10649,
     /*  678766 */     GIR_EraseRootFromParent_Done,
     /*  678767 */   // Label 10802: @678767
     /*  678767 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(678842), // Rule ID 10652 //
     /*  678772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678840 */     GIR_RootConstrainSelectedInstOperands,
     /*  678841 */     // GIR_Coverage, 10652,
     /*  678841 */     GIR_EraseRootFromParent_Done,
     /*  678842 */   // Label 10803: @678842
     /*  678842 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(678917), // Rule ID 10653 //
     /*  678847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678915 */     GIR_RootConstrainSelectedInstOperands,
     /*  678916 */     // GIR_Coverage, 10653,
     /*  678916 */     GIR_EraseRootFromParent_Done,
     /*  678917 */   // Label 10804: @678917
     /*  678917 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(678992), // Rule ID 10656 //
     /*  678922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678990 */     GIR_RootConstrainSelectedInstOperands,
     /*  678991 */     // GIR_Coverage, 10656,
     /*  678991 */     GIR_EraseRootFromParent_Done,
     /*  678992 */   // Label 10805: @678992
     /*  678992 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(679067), // Rule ID 10657 //
     /*  678997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  679017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679043 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679065 */     GIR_RootConstrainSelectedInstOperands,
     /*  679066 */     // GIR_Coverage, 10657,
     /*  679066 */     GIR_EraseRootFromParent_Done,
     /*  679067 */   // Label 10806: @679067
     /*  679067 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(679142), // Rule ID 10660 //
     /*  679072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  679092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679140 */     GIR_RootConstrainSelectedInstOperands,
     /*  679141 */     // GIR_Coverage, 10660,
     /*  679141 */     GIR_EraseRootFromParent_Done,
     /*  679142 */   // Label 10807: @679142
     /*  679142 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(679217), // Rule ID 10661 //
     /*  679147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  679167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679193 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679215 */     GIR_RootConstrainSelectedInstOperands,
     /*  679216 */     // GIR_Coverage, 10661,
     /*  679216 */     GIR_EraseRootFromParent_Done,
     /*  679217 */   // Label 10808: @679217
     /*  679217 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(679292), // Rule ID 10664 //
     /*  679222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  679242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679290 */     GIR_RootConstrainSelectedInstOperands,
     /*  679291 */     // GIR_Coverage, 10664,
     /*  679291 */     GIR_EraseRootFromParent_Done,
     /*  679292 */   // Label 10809: @679292
     /*  679292 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(679367), // Rule ID 10665 //
     /*  679297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  679317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679365 */     GIR_RootConstrainSelectedInstOperands,
     /*  679366 */     // GIR_Coverage, 10665,
     /*  679366 */     GIR_EraseRootFromParent_Done,
     /*  679367 */   // Label 10810: @679367
     /*  679367 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(679442), // Rule ID 10668 //
     /*  679372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679440 */     GIR_RootConstrainSelectedInstOperands,
     /*  679441 */     // GIR_Coverage, 10668,
     /*  679441 */     GIR_EraseRootFromParent_Done,
     /*  679442 */   // Label 10811: @679442
     /*  679442 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(679517), // Rule ID 10669 //
     /*  679447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679515 */     GIR_RootConstrainSelectedInstOperands,
     /*  679516 */     // GIR_Coverage, 10669,
     /*  679516 */     GIR_EraseRootFromParent_Done,
     /*  679517 */   // Label 10812: @679517
     /*  679517 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(679592), // Rule ID 10672 //
     /*  679522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679590 */     GIR_RootConstrainSelectedInstOperands,
     /*  679591 */     // GIR_Coverage, 10672,
     /*  679591 */     GIR_EraseRootFromParent_Done,
     /*  679592 */   // Label 10813: @679592
     /*  679592 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(679667), // Rule ID 10673 //
     /*  679597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679665 */     GIR_RootConstrainSelectedInstOperands,
     /*  679666 */     // GIR_Coverage, 10673,
     /*  679666 */     GIR_EraseRootFromParent_Done,
     /*  679667 */   // Label 10814: @679667
     /*  679667 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(679742), // Rule ID 10676 //
     /*  679672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679740 */     GIR_RootConstrainSelectedInstOperands,
     /*  679741 */     // GIR_Coverage, 10676,
     /*  679741 */     GIR_EraseRootFromParent_Done,
     /*  679742 */   // Label 10815: @679742
     /*  679742 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(679817), // Rule ID 10677 //
     /*  679747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679815 */     GIR_RootConstrainSelectedInstOperands,
     /*  679816 */     // GIR_Coverage, 10677,
     /*  679816 */     GIR_EraseRootFromParent_Done,
     /*  679817 */   // Label 10816: @679817
     /*  679817 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(679892), // Rule ID 10680 //
     /*  679822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679890 */     GIR_RootConstrainSelectedInstOperands,
     /*  679891 */     // GIR_Coverage, 10680,
     /*  679891 */     GIR_EraseRootFromParent_Done,
     /*  679892 */   // Label 10817: @679892
     /*  679892 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(679967), // Rule ID 10681 //
     /*  679897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679965 */     GIR_RootConstrainSelectedInstOperands,
     /*  679966 */     // GIR_Coverage, 10681,
     /*  679966 */     GIR_EraseRootFromParent_Done,
     /*  679967 */   // Label 10818: @679967
     /*  679967 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(680042), // Rule ID 10684 //
     /*  679972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680040 */     GIR_RootConstrainSelectedInstOperands,
     /*  680041 */     // GIR_Coverage, 10684,
     /*  680041 */     GIR_EraseRootFromParent_Done,
     /*  680042 */   // Label 10819: @680042
     /*  680042 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(680117), // Rule ID 10685 //
     /*  680047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  680067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680115 */     GIR_RootConstrainSelectedInstOperands,
     /*  680116 */     // GIR_Coverage, 10685,
     /*  680116 */     GIR_EraseRootFromParent_Done,
     /*  680117 */   // Label 10820: @680117
     /*  680117 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(680192), // Rule ID 10688 //
     /*  680122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  680142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  680171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680190 */     GIR_RootConstrainSelectedInstOperands,
     /*  680191 */     // GIR_Coverage, 10688,
     /*  680191 */     GIR_EraseRootFromParent_Done,
     /*  680192 */   // Label 10821: @680192
     /*  680192 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(680267), // Rule ID 10689 //
     /*  680197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  680217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  680246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680265 */     GIR_RootConstrainSelectedInstOperands,
     /*  680266 */     // GIR_Coverage, 10689,
     /*  680266 */     GIR_EraseRootFromParent_Done,
     /*  680267 */   // Label 10822: @680267
     /*  680267 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(680342), // Rule ID 10692 //
     /*  680272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  680292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  680321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680340 */     GIR_RootConstrainSelectedInstOperands,
     /*  680341 */     // GIR_Coverage, 10692,
     /*  680341 */     GIR_EraseRootFromParent_Done,
     /*  680342 */   // Label 10823: @680342
     /*  680342 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(680417), // Rule ID 10693 //
     /*  680347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  680367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  680396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680415 */     GIR_RootConstrainSelectedInstOperands,
     /*  680416 */     // GIR_Coverage, 10693,
     /*  680416 */     GIR_EraseRootFromParent_Done,
     /*  680417 */   // Label 10824: @680417
     /*  680417 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(680492), // Rule ID 10696 //
     /*  680422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680490 */     GIR_RootConstrainSelectedInstOperands,
     /*  680491 */     // GIR_Coverage, 10696,
     /*  680491 */     GIR_EraseRootFromParent_Done,
     /*  680492 */   // Label 10825: @680492
     /*  680492 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(680567), // Rule ID 10697 //
     /*  680497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680565 */     GIR_RootConstrainSelectedInstOperands,
     /*  680566 */     // GIR_Coverage, 10697,
     /*  680566 */     GIR_EraseRootFromParent_Done,
     /*  680567 */   // Label 10826: @680567
     /*  680567 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(680642), // Rule ID 10700 //
     /*  680572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680640 */     GIR_RootConstrainSelectedInstOperands,
     /*  680641 */     // GIR_Coverage, 10700,
     /*  680641 */     GIR_EraseRootFromParent_Done,
     /*  680642 */   // Label 10827: @680642
     /*  680642 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(680717), // Rule ID 10701 //
     /*  680647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680715 */     GIR_RootConstrainSelectedInstOperands,
     /*  680716 */     // GIR_Coverage, 10701,
     /*  680716 */     GIR_EraseRootFromParent_Done,
     /*  680717 */   // Label 10828: @680717
     /*  680717 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(680792), // Rule ID 10704 //
     /*  680722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680790 */     GIR_RootConstrainSelectedInstOperands,
     /*  680791 */     // GIR_Coverage, 10704,
     /*  680791 */     GIR_EraseRootFromParent_Done,
     /*  680792 */   // Label 10829: @680792
     /*  680792 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(680867), // Rule ID 10705 //
     /*  680797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680865 */     GIR_RootConstrainSelectedInstOperands,
     /*  680866 */     // GIR_Coverage, 10705,
     /*  680866 */     GIR_EraseRootFromParent_Done,
     /*  680867 */   // Label 10830: @680867
     /*  680867 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(680942), // Rule ID 10708 //
     /*  680872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680940 */     GIR_RootConstrainSelectedInstOperands,
     /*  680941 */     // GIR_Coverage, 10708,
     /*  680941 */     GIR_EraseRootFromParent_Done,
     /*  680942 */   // Label 10831: @680942
     /*  680942 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(681017), // Rule ID 10709 //
     /*  680947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681015 */     GIR_RootConstrainSelectedInstOperands,
     /*  681016 */     // GIR_Coverage, 10709,
     /*  681016 */     GIR_EraseRootFromParent_Done,
     /*  681017 */   // Label 10832: @681017
     /*  681017 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(681092), // Rule ID 10712 //
     /*  681022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  681071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681090 */     GIR_RootConstrainSelectedInstOperands,
     /*  681091 */     // GIR_Coverage, 10712,
     /*  681091 */     GIR_EraseRootFromParent_Done,
     /*  681092 */   // Label 10833: @681092
     /*  681092 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(681167), // Rule ID 10713 //
     /*  681097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  681146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681165 */     GIR_RootConstrainSelectedInstOperands,
     /*  681166 */     // GIR_Coverage, 10713,
     /*  681166 */     GIR_EraseRootFromParent_Done,
     /*  681167 */   // Label 10834: @681167
     /*  681167 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(681242), // Rule ID 10716 //
     /*  681172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681240 */     GIR_RootConstrainSelectedInstOperands,
     /*  681241 */     // GIR_Coverage, 10716,
     /*  681241 */     GIR_EraseRootFromParent_Done,
     /*  681242 */   // Label 10835: @681242
     /*  681242 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(681317), // Rule ID 10717 //
     /*  681247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681315 */     GIR_RootConstrainSelectedInstOperands,
     /*  681316 */     // GIR_Coverage, 10717,
     /*  681316 */     GIR_EraseRootFromParent_Done,
     /*  681317 */   // Label 10836: @681317
     /*  681317 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(681392), // Rule ID 10720 //
     /*  681322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681390 */     GIR_RootConstrainSelectedInstOperands,
     /*  681391 */     // GIR_Coverage, 10720,
     /*  681391 */     GIR_EraseRootFromParent_Done,
     /*  681392 */   // Label 10837: @681392
     /*  681392 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(681467), // Rule ID 10721 //
     /*  681397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  681446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681465 */     GIR_RootConstrainSelectedInstOperands,
     /*  681466 */     // GIR_Coverage, 10721,
     /*  681466 */     GIR_EraseRootFromParent_Done,
     /*  681467 */   // Label 10838: @681467
     /*  681467 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(681542), // Rule ID 10724 //
     /*  681472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681540 */     GIR_RootConstrainSelectedInstOperands,
     /*  681541 */     // GIR_Coverage, 10724,
     /*  681541 */     GIR_EraseRootFromParent_Done,
     /*  681542 */   // Label 10839: @681542
     /*  681542 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(681617), // Rule ID 10725 //
     /*  681547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681615 */     GIR_RootConstrainSelectedInstOperands,
     /*  681616 */     // GIR_Coverage, 10725,
     /*  681616 */     GIR_EraseRootFromParent_Done,
     /*  681617 */   // Label 10840: @681617
     /*  681617 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(681692), // Rule ID 10728 //
     /*  681622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681690 */     GIR_RootConstrainSelectedInstOperands,
     /*  681691 */     // GIR_Coverage, 10728,
     /*  681691 */     GIR_EraseRootFromParent_Done,
     /*  681692 */   // Label 10841: @681692
     /*  681692 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(681767), // Rule ID 10729 //
     /*  681697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681765 */     GIR_RootConstrainSelectedInstOperands,
     /*  681766 */     // GIR_Coverage, 10729,
     /*  681766 */     GIR_EraseRootFromParent_Done,
     /*  681767 */   // Label 10842: @681767
     /*  681767 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(681842), // Rule ID 10732 //
     /*  681772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681840 */     GIR_RootConstrainSelectedInstOperands,
     /*  681841 */     // GIR_Coverage, 10732,
     /*  681841 */     GIR_EraseRootFromParent_Done,
     /*  681842 */   // Label 10843: @681842
     /*  681842 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(681917), // Rule ID 10733 //
     /*  681847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681915 */     GIR_RootConstrainSelectedInstOperands,
     /*  681916 */     // GIR_Coverage, 10733,
     /*  681916 */     GIR_EraseRootFromParent_Done,
     /*  681917 */   // Label 10844: @681917
     /*  681917 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(681992), // Rule ID 10736 //
     /*  681922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  681925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  681968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681990 */     GIR_RootConstrainSelectedInstOperands,
     /*  681991 */     // GIR_Coverage, 10736,
     /*  681991 */     GIR_EraseRootFromParent_Done,
     /*  681992 */   // Label 10845: @681992
     /*  681992 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(682067), // Rule ID 10737 //
     /*  681997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  682046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682065 */     GIR_RootConstrainSelectedInstOperands,
     /*  682066 */     // GIR_Coverage, 10737,
     /*  682066 */     GIR_EraseRootFromParent_Done,
     /*  682067 */   // Label 10846: @682067
     /*  682067 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(682142), // Rule ID 10740 //
     /*  682072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682140 */     GIR_RootConstrainSelectedInstOperands,
     /*  682141 */     // GIR_Coverage, 10740,
     /*  682141 */     GIR_EraseRootFromParent_Done,
     /*  682142 */   // Label 10847: @682142
     /*  682142 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(682217), // Rule ID 10741 //
     /*  682147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682215 */     GIR_RootConstrainSelectedInstOperands,
     /*  682216 */     // GIR_Coverage, 10741,
     /*  682216 */     GIR_EraseRootFromParent_Done,
     /*  682217 */   // Label 10848: @682217
     /*  682217 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(682292), // Rule ID 10744 //
     /*  682222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682290 */     GIR_RootConstrainSelectedInstOperands,
     /*  682291 */     // GIR_Coverage, 10744,
     /*  682291 */     GIR_EraseRootFromParent_Done,
     /*  682292 */   // Label 10849: @682292
     /*  682292 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(682367), // Rule ID 10745 //
     /*  682297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682365 */     GIR_RootConstrainSelectedInstOperands,
     /*  682366 */     // GIR_Coverage, 10745,
     /*  682366 */     GIR_EraseRootFromParent_Done,
     /*  682367 */   // Label 10850: @682367
     /*  682367 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(682442), // Rule ID 10748 //
     /*  682372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682440 */     GIR_RootConstrainSelectedInstOperands,
     /*  682441 */     // GIR_Coverage, 10748,
     /*  682441 */     GIR_EraseRootFromParent_Done,
     /*  682442 */   // Label 10851: @682442
     /*  682442 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(682517), // Rule ID 10749 //
     /*  682447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682493 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682515 */     GIR_RootConstrainSelectedInstOperands,
     /*  682516 */     // GIR_Coverage, 10749,
     /*  682516 */     GIR_EraseRootFromParent_Done,
     /*  682517 */   // Label 10852: @682517
     /*  682517 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(682592), // Rule ID 10752 //
     /*  682522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682590 */     GIR_RootConstrainSelectedInstOperands,
     /*  682591 */     // GIR_Coverage, 10752,
     /*  682591 */     GIR_EraseRootFromParent_Done,
     /*  682592 */   // Label 10853: @682592
     /*  682592 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(682667), // Rule ID 10753 //
     /*  682597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682665 */     GIR_RootConstrainSelectedInstOperands,
     /*  682666 */     // GIR_Coverage, 10753,
     /*  682666 */     GIR_EraseRootFromParent_Done,
     /*  682667 */   // Label 10854: @682667
     /*  682667 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(682742), // Rule ID 10756 //
     /*  682672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682740 */     GIR_RootConstrainSelectedInstOperands,
     /*  682741 */     // GIR_Coverage, 10756,
     /*  682741 */     GIR_EraseRootFromParent_Done,
     /*  682742 */   // Label 10855: @682742
     /*  682742 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(682817), // Rule ID 10757 //
     /*  682747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682815 */     GIR_RootConstrainSelectedInstOperands,
     /*  682816 */     // GIR_Coverage, 10757,
     /*  682816 */     GIR_EraseRootFromParent_Done,
     /*  682817 */   // Label 10856: @682817
     /*  682817 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(682892), // Rule ID 10760 //
     /*  682822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682890 */     GIR_RootConstrainSelectedInstOperands,
     /*  682891 */     // GIR_Coverage, 10760,
     /*  682891 */     GIR_EraseRootFromParent_Done,
     /*  682892 */   // Label 10857: @682892
     /*  682892 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(682967), // Rule ID 10761 //
     /*  682897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682965 */     GIR_RootConstrainSelectedInstOperands,
     /*  682966 */     // GIR_Coverage, 10761,
     /*  682966 */     GIR_EraseRootFromParent_Done,
     /*  682967 */   // Label 10858: @682967
     /*  682967 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(683042), // Rule ID 10764 //
     /*  682972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683040 */     GIR_RootConstrainSelectedInstOperands,
     /*  683041 */     // GIR_Coverage, 10764,
     /*  683041 */     GIR_EraseRootFromParent_Done,
     /*  683042 */   // Label 10859: @683042
     /*  683042 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(683117), // Rule ID 10765 //
     /*  683047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683115 */     GIR_RootConstrainSelectedInstOperands,
     /*  683116 */     // GIR_Coverage, 10765,
     /*  683116 */     GIR_EraseRootFromParent_Done,
     /*  683117 */   // Label 10860: @683117
     /*  683117 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(683192), // Rule ID 10768 //
     /*  683122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683190 */     GIR_RootConstrainSelectedInstOperands,
     /*  683191 */     // GIR_Coverage, 10768,
     /*  683191 */     GIR_EraseRootFromParent_Done,
     /*  683192 */   // Label 10861: @683192
     /*  683192 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(683267), // Rule ID 10769 //
     /*  683197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683265 */     GIR_RootConstrainSelectedInstOperands,
     /*  683266 */     // GIR_Coverage, 10769,
     /*  683266 */     GIR_EraseRootFromParent_Done,
     /*  683267 */   // Label 10862: @683267
     /*  683267 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(683342), // Rule ID 10772 //
     /*  683272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683340 */     GIR_RootConstrainSelectedInstOperands,
     /*  683341 */     // GIR_Coverage, 10772,
     /*  683341 */     GIR_EraseRootFromParent_Done,
     /*  683342 */   // Label 10863: @683342
     /*  683342 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(683417), // Rule ID 10773 //
     /*  683347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683415 */     GIR_RootConstrainSelectedInstOperands,
     /*  683416 */     // GIR_Coverage, 10773,
     /*  683416 */     GIR_EraseRootFromParent_Done,
     /*  683417 */   // Label 10864: @683417
     /*  683417 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(683492), // Rule ID 10776 //
     /*  683422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683490 */     GIR_RootConstrainSelectedInstOperands,
     /*  683491 */     // GIR_Coverage, 10776,
     /*  683491 */     GIR_EraseRootFromParent_Done,
     /*  683492 */   // Label 10865: @683492
     /*  683492 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(683567), // Rule ID 10777 //
     /*  683497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683565 */     GIR_RootConstrainSelectedInstOperands,
     /*  683566 */     // GIR_Coverage, 10777,
     /*  683566 */     GIR_EraseRootFromParent_Done,
     /*  683567 */   // Label 10866: @683567
     /*  683567 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(683642), // Rule ID 10780 //
     /*  683572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683640 */     GIR_RootConstrainSelectedInstOperands,
     /*  683641 */     // GIR_Coverage, 10780,
     /*  683641 */     GIR_EraseRootFromParent_Done,
     /*  683642 */   // Label 10867: @683642
     /*  683642 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(683717), // Rule ID 10781 //
     /*  683647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683715 */     GIR_RootConstrainSelectedInstOperands,
     /*  683716 */     // GIR_Coverage, 10781,
     /*  683716 */     GIR_EraseRootFromParent_Done,
     /*  683717 */   // Label 10868: @683717
     /*  683717 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(683792), // Rule ID 10784 //
     /*  683722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683790 */     GIR_RootConstrainSelectedInstOperands,
     /*  683791 */     // GIR_Coverage, 10784,
     /*  683791 */     GIR_EraseRootFromParent_Done,
     /*  683792 */   // Label 10869: @683792
     /*  683792 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(683867), // Rule ID 10785 //
     /*  683797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683865 */     GIR_RootConstrainSelectedInstOperands,
     /*  683866 */     // GIR_Coverage, 10785,
     /*  683866 */     GIR_EraseRootFromParent_Done,
     /*  683867 */   // Label 10870: @683867
     /*  683867 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(683942), // Rule ID 10788 //
     /*  683872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683940 */     GIR_RootConstrainSelectedInstOperands,
     /*  683941 */     // GIR_Coverage, 10788,
     /*  683941 */     GIR_EraseRootFromParent_Done,
     /*  683942 */   // Label 10871: @683942
     /*  683942 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(684017), // Rule ID 10789 //
     /*  683947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684015 */     GIR_RootConstrainSelectedInstOperands,
     /*  684016 */     // GIR_Coverage, 10789,
     /*  684016 */     GIR_EraseRootFromParent_Done,
     /*  684017 */   // Label 10872: @684017
     /*  684017 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(684092), // Rule ID 10792 //
     /*  684022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  684042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684090 */     GIR_RootConstrainSelectedInstOperands,
     /*  684091 */     // GIR_Coverage, 10792,
     /*  684091 */     GIR_EraseRootFromParent_Done,
     /*  684092 */   // Label 10873: @684092
     /*  684092 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(684167), // Rule ID 10793 //
     /*  684097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  684117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684165 */     GIR_RootConstrainSelectedInstOperands,
     /*  684166 */     // GIR_Coverage, 10793,
     /*  684166 */     GIR_EraseRootFromParent_Done,
     /*  684167 */   // Label 10874: @684167
     /*  684167 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(684242), // Rule ID 10796 //
     /*  684172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  684192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684240 */     GIR_RootConstrainSelectedInstOperands,
     /*  684241 */     // GIR_Coverage, 10796,
     /*  684241 */     GIR_EraseRootFromParent_Done,
     /*  684242 */   // Label 10875: @684242
     /*  684242 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(684317), // Rule ID 10797 //
     /*  684247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  684267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684315 */     GIR_RootConstrainSelectedInstOperands,
     /*  684316 */     // GIR_Coverage, 10797,
     /*  684316 */     GIR_EraseRootFromParent_Done,
     /*  684317 */   // Label 10876: @684317
     /*  684317 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(684392), // Rule ID 10800 //
     /*  684322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  684342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684390 */     GIR_RootConstrainSelectedInstOperands,
     /*  684391 */     // GIR_Coverage, 10800,
     /*  684391 */     GIR_EraseRootFromParent_Done,
     /*  684392 */   // Label 10877: @684392
     /*  684392 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(684467), // Rule ID 10801 //
     /*  684397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  684417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  684446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684465 */     GIR_RootConstrainSelectedInstOperands,
     /*  684466 */     // GIR_Coverage, 10801,
     /*  684466 */     GIR_EraseRootFromParent_Done,
     /*  684467 */   // Label 10878: @684467
     /*  684467 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(684542), // Rule ID 10804 //
     /*  684472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684540 */     GIR_RootConstrainSelectedInstOperands,
     /*  684541 */     // GIR_Coverage, 10804,
     /*  684541 */     GIR_EraseRootFromParent_Done,
     /*  684542 */   // Label 10879: @684542
     /*  684542 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(684617), // Rule ID 10805 //
     /*  684547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684615 */     GIR_RootConstrainSelectedInstOperands,
     /*  684616 */     // GIR_Coverage, 10805,
     /*  684616 */     GIR_EraseRootFromParent_Done,
     /*  684617 */   // Label 10880: @684617
     /*  684617 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(684692), // Rule ID 10808 //
     /*  684622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684690 */     GIR_RootConstrainSelectedInstOperands,
     /*  684691 */     // GIR_Coverage, 10808,
     /*  684691 */     GIR_EraseRootFromParent_Done,
     /*  684692 */   // Label 10881: @684692
     /*  684692 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(684767), // Rule ID 10809 //
     /*  684697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684765 */     GIR_RootConstrainSelectedInstOperands,
     /*  684766 */     // GIR_Coverage, 10809,
     /*  684766 */     GIR_EraseRootFromParent_Done,
     /*  684767 */   // Label 10882: @684767
     /*  684767 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(684842), // Rule ID 10812 //
     /*  684772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684840 */     GIR_RootConstrainSelectedInstOperands,
     /*  684841 */     // GIR_Coverage, 10812,
     /*  684841 */     GIR_EraseRootFromParent_Done,
     /*  684842 */   // Label 10883: @684842
     /*  684842 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(684917), // Rule ID 10813 //
     /*  684847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684915 */     GIR_RootConstrainSelectedInstOperands,
     /*  684916 */     // GIR_Coverage, 10813,
     /*  684916 */     GIR_EraseRootFromParent_Done,
     /*  684917 */   // Label 10884: @684917
     /*  684917 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(684992), // Rule ID 10816 //
     /*  684922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684990 */     GIR_RootConstrainSelectedInstOperands,
     /*  684991 */     // GIR_Coverage, 10816,
     /*  684991 */     GIR_EraseRootFromParent_Done,
     /*  684992 */   // Label 10885: @684992
     /*  684992 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(685067), // Rule ID 10817 //
     /*  684997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  685017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685065 */     GIR_RootConstrainSelectedInstOperands,
     /*  685066 */     // GIR_Coverage, 10817,
     /*  685066 */     GIR_EraseRootFromParent_Done,
     /*  685067 */   // Label 10886: @685067
     /*  685067 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(685142), // Rule ID 10820 //
     /*  685072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  685092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685140 */     GIR_RootConstrainSelectedInstOperands,
     /*  685141 */     // GIR_Coverage, 10820,
     /*  685141 */     GIR_EraseRootFromParent_Done,
     /*  685142 */   // Label 10887: @685142
     /*  685142 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(685217), // Rule ID 10821 //
     /*  685147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  685167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685215 */     GIR_RootConstrainSelectedInstOperands,
     /*  685216 */     // GIR_Coverage, 10821,
     /*  685216 */     GIR_EraseRootFromParent_Done,
     /*  685217 */   // Label 10888: @685217
     /*  685217 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(685292), // Rule ID 10824 //
     /*  685222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  685242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685290 */     GIR_RootConstrainSelectedInstOperands,
     /*  685291 */     // GIR_Coverage, 10824,
     /*  685291 */     GIR_EraseRootFromParent_Done,
     /*  685292 */   // Label 10889: @685292
     /*  685292 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(685367), // Rule ID 10825 //
     /*  685297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  685317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  685346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685365 */     GIR_RootConstrainSelectedInstOperands,
     /*  685366 */     // GIR_Coverage, 10825,
     /*  685366 */     GIR_EraseRootFromParent_Done,
     /*  685367 */   // Label 10890: @685367
     /*  685367 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(685442), // Rule ID 10828 //
     /*  685372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685440 */     GIR_RootConstrainSelectedInstOperands,
     /*  685441 */     // GIR_Coverage, 10828,
     /*  685441 */     GIR_EraseRootFromParent_Done,
     /*  685442 */   // Label 10891: @685442
     /*  685442 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(685517), // Rule ID 10829 //
     /*  685447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685515 */     GIR_RootConstrainSelectedInstOperands,
     /*  685516 */     // GIR_Coverage, 10829,
     /*  685516 */     GIR_EraseRootFromParent_Done,
     /*  685517 */   // Label 10892: @685517
     /*  685517 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(685592), // Rule ID 10832 //
     /*  685522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685590 */     GIR_RootConstrainSelectedInstOperands,
     /*  685591 */     // GIR_Coverage, 10832,
     /*  685591 */     GIR_EraseRootFromParent_Done,
     /*  685592 */   // Label 10893: @685592
     /*  685592 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(685667), // Rule ID 10833 //
     /*  685597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685665 */     GIR_RootConstrainSelectedInstOperands,
     /*  685666 */     // GIR_Coverage, 10833,
     /*  685666 */     GIR_EraseRootFromParent_Done,
     /*  685667 */   // Label 10894: @685667
     /*  685667 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(685742), // Rule ID 10836 //
     /*  685672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685740 */     GIR_RootConstrainSelectedInstOperands,
     /*  685741 */     // GIR_Coverage, 10836,
     /*  685741 */     GIR_EraseRootFromParent_Done,
     /*  685742 */   // Label 10895: @685742
     /*  685742 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(685817), // Rule ID 10837 //
     /*  685747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685815 */     GIR_RootConstrainSelectedInstOperands,
     /*  685816 */     // GIR_Coverage, 10837,
     /*  685816 */     GIR_EraseRootFromParent_Done,
     /*  685817 */   // Label 10896: @685817
     /*  685817 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(685892), // Rule ID 10840 //
     /*  685822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685890 */     GIR_RootConstrainSelectedInstOperands,
     /*  685891 */     // GIR_Coverage, 10840,
     /*  685891 */     GIR_EraseRootFromParent_Done,
     /*  685892 */   // Label 10897: @685892
     /*  685892 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(685967), // Rule ID 10841 //
     /*  685897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685965 */     GIR_RootConstrainSelectedInstOperands,
     /*  685966 */     // GIR_Coverage, 10841,
     /*  685966 */     GIR_EraseRootFromParent_Done,
     /*  685967 */   // Label 10898: @685967
     /*  685967 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(686042), // Rule ID 10844 //
     /*  685972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686040 */     GIR_RootConstrainSelectedInstOperands,
     /*  686041 */     // GIR_Coverage, 10844,
     /*  686041 */     GIR_EraseRootFromParent_Done,
     /*  686042 */   // Label 10899: @686042
     /*  686042 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(686117), // Rule ID 10845 //
     /*  686047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  686067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686115 */     GIR_RootConstrainSelectedInstOperands,
     /*  686116 */     // GIR_Coverage, 10845,
     /*  686116 */     GIR_EraseRootFromParent_Done,
     /*  686117 */   // Label 10900: @686117
     /*  686117 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(686192), // Rule ID 10848 //
     /*  686122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  686142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686190 */     GIR_RootConstrainSelectedInstOperands,
     /*  686191 */     // GIR_Coverage, 10848,
     /*  686191 */     GIR_EraseRootFromParent_Done,
     /*  686192 */   // Label 10901: @686192
     /*  686192 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(686267), // Rule ID 10849 //
     /*  686197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  686217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686265 */     GIR_RootConstrainSelectedInstOperands,
     /*  686266 */     // GIR_Coverage, 10849,
     /*  686266 */     GIR_EraseRootFromParent_Done,
     /*  686267 */   // Label 10902: @686267
     /*  686267 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(686342), // Rule ID 10852 //
     /*  686272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  686292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686340 */     GIR_RootConstrainSelectedInstOperands,
     /*  686341 */     // GIR_Coverage, 10852,
     /*  686341 */     GIR_EraseRootFromParent_Done,
     /*  686342 */   // Label 10903: @686342
     /*  686342 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(686417), // Rule ID 10853 //
     /*  686347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  686367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686415 */     GIR_RootConstrainSelectedInstOperands,
     /*  686416 */     // GIR_Coverage, 10853,
     /*  686416 */     GIR_EraseRootFromParent_Done,
     /*  686417 */   // Label 10904: @686417
     /*  686417 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(686492), // Rule ID 10856 //
     /*  686422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686490 */     GIR_RootConstrainSelectedInstOperands,
     /*  686491 */     // GIR_Coverage, 10856,
     /*  686491 */     GIR_EraseRootFromParent_Done,
     /*  686492 */   // Label 10905: @686492
     /*  686492 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(686567), // Rule ID 10857 //
     /*  686497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686565 */     GIR_RootConstrainSelectedInstOperands,
     /*  686566 */     // GIR_Coverage, 10857,
     /*  686566 */     GIR_EraseRootFromParent_Done,
     /*  686567 */   // Label 10906: @686567
     /*  686567 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(686642), // Rule ID 10860 //
     /*  686572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686640 */     GIR_RootConstrainSelectedInstOperands,
     /*  686641 */     // GIR_Coverage, 10860,
     /*  686641 */     GIR_EraseRootFromParent_Done,
     /*  686642 */   // Label 10907: @686642
     /*  686642 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(686717), // Rule ID 10861 //
     /*  686647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686715 */     GIR_RootConstrainSelectedInstOperands,
     /*  686716 */     // GIR_Coverage, 10861,
     /*  686716 */     GIR_EraseRootFromParent_Done,
     /*  686717 */   // Label 10908: @686717
     /*  686717 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(686792), // Rule ID 10864 //
     /*  686722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686790 */     GIR_RootConstrainSelectedInstOperands,
     /*  686791 */     // GIR_Coverage, 10864,
     /*  686791 */     GIR_EraseRootFromParent_Done,
     /*  686792 */   // Label 10909: @686792
     /*  686792 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(686867), // Rule ID 10865 //
     /*  686797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686865 */     GIR_RootConstrainSelectedInstOperands,
     /*  686866 */     // GIR_Coverage, 10865,
     /*  686866 */     GIR_EraseRootFromParent_Done,
     /*  686867 */   // Label 10910: @686867
     /*  686867 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(686942), // Rule ID 10868 //
     /*  686872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686940 */     GIR_RootConstrainSelectedInstOperands,
     /*  686941 */     // GIR_Coverage, 10868,
     /*  686941 */     GIR_EraseRootFromParent_Done,
     /*  686942 */   // Label 10911: @686942
     /*  686942 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(687017), // Rule ID 10869 //
     /*  686947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686993 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687015 */     GIR_RootConstrainSelectedInstOperands,
     /*  687016 */     // GIR_Coverage, 10869,
     /*  687016 */     GIR_EraseRootFromParent_Done,
     /*  687017 */   // Label 10912: @687017
     /*  687017 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(687092), // Rule ID 10872 //
     /*  687022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  687042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  687071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687090 */     GIR_RootConstrainSelectedInstOperands,
     /*  687091 */     // GIR_Coverage, 10872,
     /*  687091 */     GIR_EraseRootFromParent_Done,
     /*  687092 */   // Label 10913: @687092
     /*  687092 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(687167), // Rule ID 10873 //
     /*  687097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  687117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  687146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687165 */     GIR_RootConstrainSelectedInstOperands,
     /*  687166 */     // GIR_Coverage, 10873,
     /*  687166 */     GIR_EraseRootFromParent_Done,
     /*  687167 */   // Label 10914: @687167
     /*  687167 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(687242), // Rule ID 10876 //
     /*  687172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  687221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687240 */     GIR_RootConstrainSelectedInstOperands,
     /*  687241 */     // GIR_Coverage, 10876,
     /*  687241 */     GIR_EraseRootFromParent_Done,
     /*  687242 */   // Label 10915: @687242
     /*  687242 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(687317), // Rule ID 10877 //
     /*  687247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  687296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687315 */     GIR_RootConstrainSelectedInstOperands,
     /*  687316 */     // GIR_Coverage, 10877,
     /*  687316 */     GIR_EraseRootFromParent_Done,
     /*  687317 */   // Label 10916: @687317
     /*  687317 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(687392), // Rule ID 10880 //
     /*  687322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687390 */     GIR_RootConstrainSelectedInstOperands,
     /*  687391 */     // GIR_Coverage, 10880,
     /*  687391 */     GIR_EraseRootFromParent_Done,
     /*  687392 */   // Label 10917: @687392
     /*  687392 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(687467), // Rule ID 10881 //
     /*  687397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687465 */     GIR_RootConstrainSelectedInstOperands,
     /*  687466 */     // GIR_Coverage, 10881,
     /*  687466 */     GIR_EraseRootFromParent_Done,
     /*  687467 */   // Label 10918: @687467
     /*  687467 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(687542), // Rule ID 10884 //
     /*  687472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687540 */     GIR_RootConstrainSelectedInstOperands,
     /*  687541 */     // GIR_Coverage, 10884,
     /*  687541 */     GIR_EraseRootFromParent_Done,
     /*  687542 */   // Label 10919: @687542
     /*  687542 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(687617), // Rule ID 10885 //
     /*  687547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687615 */     GIR_RootConstrainSelectedInstOperands,
     /*  687616 */     // GIR_Coverage, 10885,
     /*  687616 */     GIR_EraseRootFromParent_Done,
     /*  687617 */   // Label 10920: @687617
     /*  687617 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(687692), // Rule ID 10888 //
     /*  687622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687690 */     GIR_RootConstrainSelectedInstOperands,
     /*  687691 */     // GIR_Coverage, 10888,
     /*  687691 */     GIR_EraseRootFromParent_Done,
     /*  687692 */   // Label 10921: @687692
     /*  687692 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(687767), // Rule ID 10889 //
     /*  687697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687765 */     GIR_RootConstrainSelectedInstOperands,
     /*  687766 */     // GIR_Coverage, 10889,
     /*  687766 */     GIR_EraseRootFromParent_Done,
     /*  687767 */   // Label 10922: @687767
     /*  687767 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(687842), // Rule ID 10892 //
     /*  687772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687840 */     GIR_RootConstrainSelectedInstOperands,
     /*  687841 */     // GIR_Coverage, 10892,
     /*  687841 */     GIR_EraseRootFromParent_Done,
     /*  687842 */   // Label 10923: @687842
     /*  687842 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(687917), // Rule ID 10893 //
     /*  687847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687915 */     GIR_RootConstrainSelectedInstOperands,
     /*  687916 */     // GIR_Coverage, 10893,
     /*  687916 */     GIR_EraseRootFromParent_Done,
     /*  687917 */   // Label 10924: @687917
     /*  687917 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(687992), // Rule ID 10896 //
     /*  687922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687990 */     GIR_RootConstrainSelectedInstOperands,
     /*  687991 */     // GIR_Coverage, 10896,
     /*  687991 */     GIR_EraseRootFromParent_Done,
     /*  687992 */   // Label 10925: @687992
     /*  687992 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(688067), // Rule ID 10897 //
     /*  687997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  688046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688065 */     GIR_RootConstrainSelectedInstOperands,
     /*  688066 */     // GIR_Coverage, 10897,
     /*  688066 */     GIR_EraseRootFromParent_Done,
     /*  688067 */   // Label 10926: @688067
     /*  688067 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(688142), // Rule ID 10900 //
     /*  688072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688140 */     GIR_RootConstrainSelectedInstOperands,
     /*  688141 */     // GIR_Coverage, 10900,
     /*  688141 */     GIR_EraseRootFromParent_Done,
     /*  688142 */   // Label 10927: @688142
     /*  688142 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(688217), // Rule ID 10901 //
     /*  688147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688215 */     GIR_RootConstrainSelectedInstOperands,
     /*  688216 */     // GIR_Coverage, 10901,
     /*  688216 */     GIR_EraseRootFromParent_Done,
     /*  688217 */   // Label 10928: @688217
     /*  688217 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(688292), // Rule ID 10904 //
     /*  688222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688290 */     GIR_RootConstrainSelectedInstOperands,
     /*  688291 */     // GIR_Coverage, 10904,
     /*  688291 */     GIR_EraseRootFromParent_Done,
     /*  688292 */   // Label 10929: @688292
     /*  688292 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(688367), // Rule ID 10905 //
     /*  688297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688365 */     GIR_RootConstrainSelectedInstOperands,
     /*  688366 */     // GIR_Coverage, 10905,
     /*  688366 */     GIR_EraseRootFromParent_Done,
     /*  688367 */   // Label 10930: @688367
     /*  688367 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(688442), // Rule ID 10908 //
     /*  688372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688440 */     GIR_RootConstrainSelectedInstOperands,
     /*  688441 */     // GIR_Coverage, 10908,
     /*  688441 */     GIR_EraseRootFromParent_Done,
     /*  688442 */   // Label 10931: @688442
     /*  688442 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(688517), // Rule ID 10909 //
     /*  688447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688515 */     GIR_RootConstrainSelectedInstOperands,
     /*  688516 */     // GIR_Coverage, 10909,
     /*  688516 */     GIR_EraseRootFromParent_Done,
     /*  688517 */   // Label 10932: @688517
     /*  688517 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(688592), // Rule ID 10912 //
     /*  688522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688590 */     GIR_RootConstrainSelectedInstOperands,
     /*  688591 */     // GIR_Coverage, 10912,
     /*  688591 */     GIR_EraseRootFromParent_Done,
     /*  688592 */   // Label 10933: @688592
     /*  688592 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(688667), // Rule ID 10913 //
     /*  688597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688665 */     GIR_RootConstrainSelectedInstOperands,
     /*  688666 */     // GIR_Coverage, 10913,
     /*  688666 */     GIR_EraseRootFromParent_Done,
     /*  688667 */   // Label 10934: @688667
     /*  688667 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(688742), // Rule ID 10916 //
     /*  688672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688740 */     GIR_RootConstrainSelectedInstOperands,
     /*  688741 */     // GIR_Coverage, 10916,
     /*  688741 */     GIR_EraseRootFromParent_Done,
     /*  688742 */   // Label 10935: @688742
     /*  688742 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(688817), // Rule ID 10917 //
     /*  688747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688815 */     GIR_RootConstrainSelectedInstOperands,
     /*  688816 */     // GIR_Coverage, 10917,
     /*  688816 */     GIR_EraseRootFromParent_Done,
     /*  688817 */   // Label 10936: @688817
     /*  688817 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(688892), // Rule ID 10920 //
     /*  688822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688890 */     GIR_RootConstrainSelectedInstOperands,
     /*  688891 */     // GIR_Coverage, 10920,
     /*  688891 */     GIR_EraseRootFromParent_Done,
     /*  688892 */   // Label 10937: @688892
     /*  688892 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(688967), // Rule ID 10921 //
     /*  688897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688965 */     GIR_RootConstrainSelectedInstOperands,
     /*  688966 */     // GIR_Coverage, 10921,
     /*  688966 */     GIR_EraseRootFromParent_Done,
     /*  688967 */   // Label 10938: @688967
     /*  688967 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(689042), // Rule ID 10924 //
     /*  688972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689040 */     GIR_RootConstrainSelectedInstOperands,
     /*  689041 */     // GIR_Coverage, 10924,
     /*  689041 */     GIR_EraseRootFromParent_Done,
     /*  689042 */   // Label 10939: @689042
     /*  689042 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(689117), // Rule ID 10925 //
     /*  689047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689093 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689115 */     GIR_RootConstrainSelectedInstOperands,
     /*  689116 */     // GIR_Coverage, 10925,
     /*  689116 */     GIR_EraseRootFromParent_Done,
     /*  689117 */   // Label 10940: @689117
     /*  689117 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(689192), // Rule ID 10928 //
     /*  689122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689190 */     GIR_RootConstrainSelectedInstOperands,
     /*  689191 */     // GIR_Coverage, 10928,
     /*  689191 */     GIR_EraseRootFromParent_Done,
     /*  689192 */   // Label 10941: @689192
     /*  689192 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(689267), // Rule ID 10929 //
     /*  689197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689265 */     GIR_RootConstrainSelectedInstOperands,
     /*  689266 */     // GIR_Coverage, 10929,
     /*  689266 */     GIR_EraseRootFromParent_Done,
     /*  689267 */   // Label 10942: @689267
     /*  689267 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(689342), // Rule ID 10932 //
     /*  689272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689340 */     GIR_RootConstrainSelectedInstOperands,
     /*  689341 */     // GIR_Coverage, 10932,
     /*  689341 */     GIR_EraseRootFromParent_Done,
     /*  689342 */   // Label 10943: @689342
     /*  689342 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(689417), // Rule ID 10933 //
     /*  689347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689415 */     GIR_RootConstrainSelectedInstOperands,
     /*  689416 */     // GIR_Coverage, 10933,
     /*  689416 */     GIR_EraseRootFromParent_Done,
     /*  689417 */   // Label 10944: @689417
     /*  689417 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(689492), // Rule ID 10936 //
     /*  689422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689490 */     GIR_RootConstrainSelectedInstOperands,
     /*  689491 */     // GIR_Coverage, 10936,
     /*  689491 */     GIR_EraseRootFromParent_Done,
     /*  689492 */   // Label 10945: @689492
     /*  689492 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(689567), // Rule ID 10937 //
     /*  689497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689543 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689565 */     GIR_RootConstrainSelectedInstOperands,
     /*  689566 */     // GIR_Coverage, 10937,
     /*  689566 */     GIR_EraseRootFromParent_Done,
     /*  689567 */   // Label 10946: @689567
     /*  689567 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(689642), // Rule ID 10940 //
     /*  689572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689640 */     GIR_RootConstrainSelectedInstOperands,
     /*  689641 */     // GIR_Coverage, 10940,
     /*  689641 */     GIR_EraseRootFromParent_Done,
     /*  689642 */   // Label 10947: @689642
     /*  689642 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(689717), // Rule ID 10941 //
     /*  689647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689715 */     GIR_RootConstrainSelectedInstOperands,
     /*  689716 */     // GIR_Coverage, 10941,
     /*  689716 */     GIR_EraseRootFromParent_Done,
     /*  689717 */   // Label 10948: @689717
     /*  689717 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(689792), // Rule ID 10944 //
     /*  689722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689790 */     GIR_RootConstrainSelectedInstOperands,
     /*  689791 */     // GIR_Coverage, 10944,
     /*  689791 */     GIR_EraseRootFromParent_Done,
     /*  689792 */   // Label 10949: @689792
     /*  689792 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(689867), // Rule ID 10945 //
     /*  689797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689865 */     GIR_RootConstrainSelectedInstOperands,
     /*  689866 */     // GIR_Coverage, 10945,
     /*  689866 */     GIR_EraseRootFromParent_Done,
     /*  689867 */   // Label 10950: @689867
     /*  689867 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(689942), // Rule ID 10948 //
     /*  689872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689940 */     GIR_RootConstrainSelectedInstOperands,
     /*  689941 */     // GIR_Coverage, 10948,
     /*  689941 */     GIR_EraseRootFromParent_Done,
     /*  689942 */   // Label 10951: @689942
     /*  689942 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(690017), // Rule ID 10949 //
     /*  689947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689993 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690015 */     GIR_RootConstrainSelectedInstOperands,
     /*  690016 */     // GIR_Coverage, 10949,
     /*  690016 */     GIR_EraseRootFromParent_Done,
     /*  690017 */   // Label 10952: @690017
     /*  690017 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(690092), // Rule ID 10952 //
     /*  690022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  690071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690090 */     GIR_RootConstrainSelectedInstOperands,
     /*  690091 */     // GIR_Coverage, 10952,
     /*  690091 */     GIR_EraseRootFromParent_Done,
     /*  690092 */   // Label 10953: @690092
     /*  690092 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(690167), // Rule ID 10953 //
     /*  690097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  690146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690165 */     GIR_RootConstrainSelectedInstOperands,
     /*  690166 */     // GIR_Coverage, 10953,
     /*  690166 */     GIR_EraseRootFromParent_Done,
     /*  690167 */   // Label 10954: @690167
     /*  690167 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(690242), // Rule ID 10956 //
     /*  690172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  690221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690240 */     GIR_RootConstrainSelectedInstOperands,
     /*  690241 */     // GIR_Coverage, 10956,
     /*  690241 */     GIR_EraseRootFromParent_Done,
     /*  690242 */   // Label 10955: @690242
     /*  690242 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(690317), // Rule ID 10957 //
     /*  690247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  690296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690315 */     GIR_RootConstrainSelectedInstOperands,
     /*  690316 */     // GIR_Coverage, 10957,
     /*  690316 */     GIR_EraseRootFromParent_Done,
     /*  690317 */   // Label 10956: @690317
     /*  690317 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(690392), // Rule ID 10960 //
     /*  690322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  690371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690390 */     GIR_RootConstrainSelectedInstOperands,
     /*  690391 */     // GIR_Coverage, 10960,
     /*  690391 */     GIR_EraseRootFromParent_Done,
     /*  690392 */   // Label 10957: @690392
     /*  690392 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(690467), // Rule ID 10961 //
     /*  690397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  690446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690465 */     GIR_RootConstrainSelectedInstOperands,
     /*  690466 */     // GIR_Coverage, 10961,
     /*  690466 */     GIR_EraseRootFromParent_Done,
     /*  690467 */   // Label 10958: @690467
     /*  690467 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(690542), // Rule ID 10964 //
     /*  690472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690540 */     GIR_RootConstrainSelectedInstOperands,
     /*  690541 */     // GIR_Coverage, 10964,
     /*  690541 */     GIR_EraseRootFromParent_Done,
     /*  690542 */   // Label 10959: @690542
     /*  690542 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(690617), // Rule ID 10965 //
     /*  690547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690615 */     GIR_RootConstrainSelectedInstOperands,
     /*  690616 */     // GIR_Coverage, 10965,
     /*  690616 */     GIR_EraseRootFromParent_Done,
     /*  690617 */   // Label 10960: @690617
     /*  690617 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(690692), // Rule ID 10968 //
     /*  690622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690690 */     GIR_RootConstrainSelectedInstOperands,
     /*  690691 */     // GIR_Coverage, 10968,
     /*  690691 */     GIR_EraseRootFromParent_Done,
     /*  690692 */   // Label 10961: @690692
     /*  690692 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(690767), // Rule ID 10969 //
     /*  690697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690765 */     GIR_RootConstrainSelectedInstOperands,
     /*  690766 */     // GIR_Coverage, 10969,
     /*  690766 */     GIR_EraseRootFromParent_Done,
     /*  690767 */   // Label 10962: @690767
     /*  690767 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(690842), // Rule ID 10972 //
     /*  690772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690840 */     GIR_RootConstrainSelectedInstOperands,
     /*  690841 */     // GIR_Coverage, 10972,
     /*  690841 */     GIR_EraseRootFromParent_Done,
     /*  690842 */   // Label 10963: @690842
     /*  690842 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(690917), // Rule ID 10973 //
     /*  690847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690915 */     GIR_RootConstrainSelectedInstOperands,
     /*  690916 */     // GIR_Coverage, 10973,
     /*  690916 */     GIR_EraseRootFromParent_Done,
     /*  690917 */   // Label 10964: @690917
     /*  690917 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(690992), // Rule ID 10976 //
     /*  690922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690990 */     GIR_RootConstrainSelectedInstOperands,
     /*  690991 */     // GIR_Coverage, 10976,
     /*  690991 */     GIR_EraseRootFromParent_Done,
     /*  690992 */   // Label 10965: @690992
     /*  690992 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(691067), // Rule ID 10977 //
     /*  690997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  691017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  691046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691065 */     GIR_RootConstrainSelectedInstOperands,
     /*  691066 */     // GIR_Coverage, 10977,
     /*  691066 */     GIR_EraseRootFromParent_Done,
     /*  691067 */   // Label 10966: @691067
     /*  691067 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(691142), // Rule ID 10980 //
     /*  691072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  691092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691140 */     GIR_RootConstrainSelectedInstOperands,
     /*  691141 */     // GIR_Coverage, 10980,
     /*  691141 */     GIR_EraseRootFromParent_Done,
     /*  691142 */   // Label 10967: @691142
     /*  691142 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(691217), // Rule ID 10981 //
     /*  691147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  691167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691215 */     GIR_RootConstrainSelectedInstOperands,
     /*  691216 */     // GIR_Coverage, 10981,
     /*  691216 */     GIR_EraseRootFromParent_Done,
     /*  691217 */   // Label 10968: @691217
     /*  691217 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(691292), // Rule ID 10984 //
     /*  691222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  691242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691290 */     GIR_RootConstrainSelectedInstOperands,
     /*  691291 */     // GIR_Coverage, 10984,
     /*  691291 */     GIR_EraseRootFromParent_Done,
     /*  691292 */   // Label 10969: @691292
     /*  691292 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(691367), // Rule ID 10985 //
     /*  691297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  691317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  691346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691365 */     GIR_RootConstrainSelectedInstOperands,
     /*  691366 */     // GIR_Coverage, 10985,
     /*  691366 */     GIR_EraseRootFromParent_Done,
     /*  691367 */   // Label 10970: @691367
     /*  691367 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(691442), // Rule ID 10988 //
     /*  691372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691440 */     GIR_RootConstrainSelectedInstOperands,
     /*  691441 */     // GIR_Coverage, 10988,
     /*  691441 */     GIR_EraseRootFromParent_Done,
     /*  691442 */   // Label 10971: @691442
     /*  691442 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(691517), // Rule ID 10989 //
     /*  691447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691493 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691515 */     GIR_RootConstrainSelectedInstOperands,
     /*  691516 */     // GIR_Coverage, 10989,
     /*  691516 */     GIR_EraseRootFromParent_Done,
     /*  691517 */   // Label 10972: @691517
     /*  691517 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(691592), // Rule ID 10992 //
     /*  691522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691590 */     GIR_RootConstrainSelectedInstOperands,
     /*  691591 */     // GIR_Coverage, 10992,
     /*  691591 */     GIR_EraseRootFromParent_Done,
     /*  691592 */   // Label 10973: @691592
     /*  691592 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(691667), // Rule ID 10993 //
     /*  691597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691665 */     GIR_RootConstrainSelectedInstOperands,
     /*  691666 */     // GIR_Coverage, 10993,
     /*  691666 */     GIR_EraseRootFromParent_Done,
     /*  691667 */   // Label 10974: @691667
     /*  691667 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(691742), // Rule ID 10996 //
     /*  691672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691740 */     GIR_RootConstrainSelectedInstOperands,
     /*  691741 */     // GIR_Coverage, 10996,
     /*  691741 */     GIR_EraseRootFromParent_Done,
     /*  691742 */   // Label 10975: @691742
     /*  691742 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(691817), // Rule ID 10997 //
     /*  691747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691815 */     GIR_RootConstrainSelectedInstOperands,
     /*  691816 */     // GIR_Coverage, 10997,
     /*  691816 */     GIR_EraseRootFromParent_Done,
     /*  691817 */   // Label 10976: @691817
     /*  691817 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(691892), // Rule ID 11000 //
     /*  691822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691890 */     GIR_RootConstrainSelectedInstOperands,
     /*  691891 */     // GIR_Coverage, 11000,
     /*  691891 */     GIR_EraseRootFromParent_Done,
     /*  691892 */   // Label 10977: @691892
     /*  691892 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(691967), // Rule ID 11001 //
     /*  691897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691965 */     GIR_RootConstrainSelectedInstOperands,
     /*  691966 */     // GIR_Coverage, 11001,
     /*  691966 */     GIR_EraseRootFromParent_Done,
     /*  691967 */   // Label 10978: @691967
     /*  691967 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(692042), // Rule ID 11004 //
     /*  691972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692040 */     GIR_RootConstrainSelectedInstOperands,
     /*  692041 */     // GIR_Coverage, 11004,
     /*  692041 */     GIR_EraseRootFromParent_Done,
     /*  692042 */   // Label 10979: @692042
     /*  692042 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(692117), // Rule ID 11005 //
     /*  692047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  692067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692115 */     GIR_RootConstrainSelectedInstOperands,
     /*  692116 */     // GIR_Coverage, 11005,
     /*  692116 */     GIR_EraseRootFromParent_Done,
     /*  692117 */   // Label 10980: @692117
     /*  692117 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(692192), // Rule ID 11008 //
     /*  692122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  692142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692190 */     GIR_RootConstrainSelectedInstOperands,
     /*  692191 */     // GIR_Coverage, 11008,
     /*  692191 */     GIR_EraseRootFromParent_Done,
     /*  692192 */   // Label 10981: @692192
     /*  692192 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(692267), // Rule ID 11009 //
     /*  692197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  692217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692265 */     GIR_RootConstrainSelectedInstOperands,
     /*  692266 */     // GIR_Coverage, 11009,
     /*  692266 */     GIR_EraseRootFromParent_Done,
     /*  692267 */   // Label 10982: @692267
     /*  692267 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(692342), // Rule ID 11012 //
     /*  692272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  692292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692340 */     GIR_RootConstrainSelectedInstOperands,
     /*  692341 */     // GIR_Coverage, 11012,
     /*  692341 */     GIR_EraseRootFromParent_Done,
     /*  692342 */   // Label 10983: @692342
     /*  692342 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(692417), // Rule ID 11013 //
     /*  692347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  692367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692415 */     GIR_RootConstrainSelectedInstOperands,
     /*  692416 */     // GIR_Coverage, 11013,
     /*  692416 */     GIR_EraseRootFromParent_Done,
     /*  692417 */   // Label 10984: @692417
     /*  692417 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(692492), // Rule ID 11016 //
     /*  692422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692490 */     GIR_RootConstrainSelectedInstOperands,
     /*  692491 */     // GIR_Coverage, 11016,
     /*  692491 */     GIR_EraseRootFromParent_Done,
     /*  692492 */   // Label 10985: @692492
     /*  692492 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(692567), // Rule ID 11017 //
     /*  692497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692565 */     GIR_RootConstrainSelectedInstOperands,
     /*  692566 */     // GIR_Coverage, 11017,
     /*  692566 */     GIR_EraseRootFromParent_Done,
     /*  692567 */   // Label 10986: @692567
     /*  692567 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(692642), // Rule ID 11020 //
     /*  692572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692640 */     GIR_RootConstrainSelectedInstOperands,
     /*  692641 */     // GIR_Coverage, 11020,
     /*  692641 */     GIR_EraseRootFromParent_Done,
     /*  692642 */   // Label 10987: @692642
     /*  692642 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(692717), // Rule ID 11021 //
     /*  692647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692715 */     GIR_RootConstrainSelectedInstOperands,
     /*  692716 */     // GIR_Coverage, 11021,
     /*  692716 */     GIR_EraseRootFromParent_Done,
     /*  692717 */   // Label 10988: @692717
     /*  692717 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(692792), // Rule ID 11024 //
     /*  692722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692790 */     GIR_RootConstrainSelectedInstOperands,
     /*  692791 */     // GIR_Coverage, 11024,
     /*  692791 */     GIR_EraseRootFromParent_Done,
     /*  692792 */   // Label 10989: @692792
     /*  692792 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(692867), // Rule ID 11025 //
     /*  692797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692865 */     GIR_RootConstrainSelectedInstOperands,
     /*  692866 */     // GIR_Coverage, 11025,
     /*  692866 */     GIR_EraseRootFromParent_Done,
     /*  692867 */   // Label 10990: @692867
     /*  692867 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(692942), // Rule ID 11028 //
     /*  692872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692940 */     GIR_RootConstrainSelectedInstOperands,
     /*  692941 */     // GIR_Coverage, 11028,
     /*  692941 */     GIR_EraseRootFromParent_Done,
     /*  692942 */   // Label 10991: @692942
     /*  692942 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(693017), // Rule ID 11029 //
     /*  692947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693015 */     GIR_RootConstrainSelectedInstOperands,
     /*  693016 */     // GIR_Coverage, 11029,
     /*  693016 */     GIR_EraseRootFromParent_Done,
     /*  693017 */   // Label 10992: @693017
     /*  693017 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(693092), // Rule ID 11032 //
     /*  693022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  693042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693090 */     GIR_RootConstrainSelectedInstOperands,
     /*  693091 */     // GIR_Coverage, 11032,
     /*  693091 */     GIR_EraseRootFromParent_Done,
     /*  693092 */   // Label 10993: @693092
     /*  693092 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(693167), // Rule ID 11033 //
     /*  693097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  693117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693165 */     GIR_RootConstrainSelectedInstOperands,
     /*  693166 */     // GIR_Coverage, 11033,
     /*  693166 */     GIR_EraseRootFromParent_Done,
     /*  693167 */   // Label 10994: @693167
     /*  693167 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(693242), // Rule ID 11036 //
     /*  693172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  693192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693240 */     GIR_RootConstrainSelectedInstOperands,
     /*  693241 */     // GIR_Coverage, 11036,
     /*  693241 */     GIR_EraseRootFromParent_Done,
     /*  693242 */   // Label 10995: @693242
     /*  693242 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(693317), // Rule ID 11037 //
     /*  693247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  693267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693315 */     GIR_RootConstrainSelectedInstOperands,
     /*  693316 */     // GIR_Coverage, 11037,
     /*  693316 */     GIR_EraseRootFromParent_Done,
     /*  693317 */   // Label 10996: @693317
     /*  693317 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(693392), // Rule ID 11040 //
     /*  693322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  693342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  693371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693390 */     GIR_RootConstrainSelectedInstOperands,
     /*  693391 */     // GIR_Coverage, 11040,
     /*  693391 */     GIR_EraseRootFromParent_Done,
     /*  693392 */   // Label 10997: @693392
     /*  693392 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(693467), // Rule ID 11041 //
     /*  693397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  693417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  693446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693465 */     GIR_RootConstrainSelectedInstOperands,
     /*  693466 */     // GIR_Coverage, 11041,
     /*  693466 */     GIR_EraseRootFromParent_Done,
     /*  693467 */   // Label 10998: @693467
     /*  693467 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(693542), // Rule ID 11044 //
     /*  693472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693540 */     GIR_RootConstrainSelectedInstOperands,
     /*  693541 */     // GIR_Coverage, 11044,
     /*  693541 */     GIR_EraseRootFromParent_Done,
     /*  693542 */   // Label 10999: @693542
     /*  693542 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(693617), // Rule ID 11045 //
     /*  693547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693615 */     GIR_RootConstrainSelectedInstOperands,
     /*  693616 */     // GIR_Coverage, 11045,
     /*  693616 */     GIR_EraseRootFromParent_Done,
     /*  693617 */   // Label 11000: @693617
     /*  693617 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(693692), // Rule ID 11048 //
     /*  693622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693690 */     GIR_RootConstrainSelectedInstOperands,
     /*  693691 */     // GIR_Coverage, 11048,
     /*  693691 */     GIR_EraseRootFromParent_Done,
     /*  693692 */   // Label 11001: @693692
     /*  693692 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(693767), // Rule ID 11049 //
     /*  693697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693765 */     GIR_RootConstrainSelectedInstOperands,
     /*  693766 */     // GIR_Coverage, 11049,
     /*  693766 */     GIR_EraseRootFromParent_Done,
     /*  693767 */   // Label 11002: @693767
     /*  693767 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(693842), // Rule ID 11052 //
     /*  693772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693840 */     GIR_RootConstrainSelectedInstOperands,
     /*  693841 */     // GIR_Coverage, 11052,
     /*  693841 */     GIR_EraseRootFromParent_Done,
     /*  693842 */   // Label 11003: @693842
     /*  693842 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(693917), // Rule ID 11053 //
     /*  693847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693915 */     GIR_RootConstrainSelectedInstOperands,
     /*  693916 */     // GIR_Coverage, 11053,
     /*  693916 */     GIR_EraseRootFromParent_Done,
     /*  693917 */   // Label 11004: @693917
     /*  693917 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(693992), // Rule ID 11056 //
     /*  693922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693990 */     GIR_RootConstrainSelectedInstOperands,
     /*  693991 */     // GIR_Coverage, 11056,
     /*  693991 */     GIR_EraseRootFromParent_Done,
     /*  693992 */   // Label 11005: @693992
     /*  693992 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(694067), // Rule ID 11057 //
     /*  693997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694065 */     GIR_RootConstrainSelectedInstOperands,
     /*  694066 */     // GIR_Coverage, 11057,
     /*  694066 */     GIR_EraseRootFromParent_Done,
     /*  694067 */   // Label 11006: @694067
     /*  694067 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(694142), // Rule ID 11060 //
     /*  694072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694140 */     GIR_RootConstrainSelectedInstOperands,
     /*  694141 */     // GIR_Coverage, 11060,
     /*  694141 */     GIR_EraseRootFromParent_Done,
     /*  694142 */   // Label 11007: @694142
     /*  694142 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(694217), // Rule ID 11061 //
     /*  694147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694215 */     GIR_RootConstrainSelectedInstOperands,
     /*  694216 */     // GIR_Coverage, 11061,
     /*  694216 */     GIR_EraseRootFromParent_Done,
     /*  694217 */   // Label 11008: @694217
     /*  694217 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(694292), // Rule ID 11064 //
     /*  694222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694290 */     GIR_RootConstrainSelectedInstOperands,
     /*  694291 */     // GIR_Coverage, 11064,
     /*  694291 */     GIR_EraseRootFromParent_Done,
     /*  694292 */   // Label 11009: @694292
     /*  694292 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(694367), // Rule ID 11065 //
     /*  694297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  694346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694365 */     GIR_RootConstrainSelectedInstOperands,
     /*  694366 */     // GIR_Coverage, 11065,
     /*  694366 */     GIR_EraseRootFromParent_Done,
     /*  694367 */   // Label 11010: @694367
     /*  694367 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(694442), // Rule ID 11068 //
     /*  694372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694440 */     GIR_RootConstrainSelectedInstOperands,
     /*  694441 */     // GIR_Coverage, 11068,
     /*  694441 */     GIR_EraseRootFromParent_Done,
     /*  694442 */   // Label 11011: @694442
     /*  694442 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(694517), // Rule ID 11069 //
     /*  694447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694515 */     GIR_RootConstrainSelectedInstOperands,
     /*  694516 */     // GIR_Coverage, 11069,
     /*  694516 */     GIR_EraseRootFromParent_Done,
     /*  694517 */   // Label 11012: @694517
     /*  694517 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(694592), // Rule ID 11072 //
     /*  694522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694590 */     GIR_RootConstrainSelectedInstOperands,
     /*  694591 */     // GIR_Coverage, 11072,
     /*  694591 */     GIR_EraseRootFromParent_Done,
     /*  694592 */   // Label 11013: @694592
     /*  694592 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(694667), // Rule ID 11073 //
     /*  694597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694665 */     GIR_RootConstrainSelectedInstOperands,
     /*  694666 */     // GIR_Coverage, 11073,
     /*  694666 */     GIR_EraseRootFromParent_Done,
     /*  694667 */   // Label 11014: @694667
     /*  694667 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(694742), // Rule ID 11076 //
     /*  694672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694740 */     GIR_RootConstrainSelectedInstOperands,
     /*  694741 */     // GIR_Coverage, 11076,
     /*  694741 */     GIR_EraseRootFromParent_Done,
     /*  694742 */   // Label 11015: @694742
     /*  694742 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(694817), // Rule ID 11077 //
     /*  694747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694815 */     GIR_RootConstrainSelectedInstOperands,
     /*  694816 */     // GIR_Coverage, 11077,
     /*  694816 */     GIR_EraseRootFromParent_Done,
     /*  694817 */   // Label 11016: @694817
     /*  694817 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(694892), // Rule ID 11080 //
     /*  694822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694890 */     GIR_RootConstrainSelectedInstOperands,
     /*  694891 */     // GIR_Coverage, 11080,
     /*  694891 */     GIR_EraseRootFromParent_Done,
     /*  694892 */   // Label 11017: @694892
     /*  694892 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(694967), // Rule ID 11081 //
     /*  694897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694965 */     GIR_RootConstrainSelectedInstOperands,
     /*  694966 */     // GIR_Coverage, 11081,
     /*  694966 */     GIR_EraseRootFromParent_Done,
     /*  694967 */   // Label 11018: @694967
     /*  694967 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(695042), // Rule ID 11084 //
     /*  694972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695040 */     GIR_RootConstrainSelectedInstOperands,
     /*  695041 */     // GIR_Coverage, 11084,
     /*  695041 */     GIR_EraseRootFromParent_Done,
     /*  695042 */   // Label 11019: @695042
     /*  695042 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(695117), // Rule ID 11085 //
     /*  695047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695115 */     GIR_RootConstrainSelectedInstOperands,
     /*  695116 */     // GIR_Coverage, 11085,
     /*  695116 */     GIR_EraseRootFromParent_Done,
     /*  695117 */   // Label 11020: @695117
     /*  695117 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(695192), // Rule ID 11088 //
     /*  695122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695190 */     GIR_RootConstrainSelectedInstOperands,
     /*  695191 */     // GIR_Coverage, 11088,
     /*  695191 */     GIR_EraseRootFromParent_Done,
     /*  695192 */   // Label 11021: @695192
     /*  695192 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(695267), // Rule ID 11089 //
     /*  695197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  695246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695265 */     GIR_RootConstrainSelectedInstOperands,
     /*  695266 */     // GIR_Coverage, 11089,
     /*  695266 */     GIR_EraseRootFromParent_Done,
     /*  695267 */   // Label 11022: @695267
     /*  695267 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(695342), // Rule ID 11092 //
     /*  695272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695340 */     GIR_RootConstrainSelectedInstOperands,
     /*  695341 */     // GIR_Coverage, 11092,
     /*  695341 */     GIR_EraseRootFromParent_Done,
     /*  695342 */   // Label 11023: @695342
     /*  695342 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(695417), // Rule ID 11093 //
     /*  695347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695415 */     GIR_RootConstrainSelectedInstOperands,
     /*  695416 */     // GIR_Coverage, 11093,
     /*  695416 */     GIR_EraseRootFromParent_Done,
     /*  695417 */   // Label 11024: @695417
     /*  695417 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(695492), // Rule ID 11096 //
     /*  695422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695490 */     GIR_RootConstrainSelectedInstOperands,
     /*  695491 */     // GIR_Coverage, 11096,
     /*  695491 */     GIR_EraseRootFromParent_Done,
     /*  695492 */   // Label 11025: @695492
     /*  695492 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(695567), // Rule ID 11097 //
     /*  695497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695565 */     GIR_RootConstrainSelectedInstOperands,
     /*  695566 */     // GIR_Coverage, 11097,
     /*  695566 */     GIR_EraseRootFromParent_Done,
     /*  695567 */   // Label 11026: @695567
     /*  695567 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(695642), // Rule ID 11100 //
     /*  695572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695640 */     GIR_RootConstrainSelectedInstOperands,
     /*  695641 */     // GIR_Coverage, 11100,
     /*  695641 */     GIR_EraseRootFromParent_Done,
     /*  695642 */   // Label 11027: @695642
     /*  695642 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(695717), // Rule ID 11101 //
     /*  695647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695715 */     GIR_RootConstrainSelectedInstOperands,
     /*  695716 */     // GIR_Coverage, 11101,
     /*  695716 */     GIR_EraseRootFromParent_Done,
     /*  695717 */   // Label 11028: @695717
     /*  695717 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(695792), // Rule ID 11104 //
     /*  695722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695790 */     GIR_RootConstrainSelectedInstOperands,
     /*  695791 */     // GIR_Coverage, 11104,
     /*  695791 */     GIR_EraseRootFromParent_Done,
     /*  695792 */   // Label 11029: @695792
     /*  695792 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(695867), // Rule ID 11105 //
     /*  695797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695865 */     GIR_RootConstrainSelectedInstOperands,
     /*  695866 */     // GIR_Coverage, 11105,
     /*  695866 */     GIR_EraseRootFromParent_Done,
     /*  695867 */   // Label 11030: @695867
     /*  695867 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(695942), // Rule ID 11108 //
     /*  695872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695940 */     GIR_RootConstrainSelectedInstOperands,
     /*  695941 */     // GIR_Coverage, 11108,
     /*  695941 */     GIR_EraseRootFromParent_Done,
     /*  695942 */   // Label 11031: @695942
     /*  695942 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(696017), // Rule ID 11109 //
     /*  695947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696015 */     GIR_RootConstrainSelectedInstOperands,
     /*  696016 */     // GIR_Coverage, 11109,
     /*  696016 */     GIR_EraseRootFromParent_Done,
     /*  696017 */   // Label 11032: @696017
     /*  696017 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(696092), // Rule ID 11112 //
     /*  696022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696090 */     GIR_RootConstrainSelectedInstOperands,
     /*  696091 */     // GIR_Coverage, 11112,
     /*  696091 */     GIR_EraseRootFromParent_Done,
     /*  696092 */   // Label 11033: @696092
     /*  696092 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(696167), // Rule ID 11113 //
     /*  696097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696165 */     GIR_RootConstrainSelectedInstOperands,
     /*  696166 */     // GIR_Coverage, 11113,
     /*  696166 */     GIR_EraseRootFromParent_Done,
     /*  696167 */   // Label 11034: @696167
     /*  696167 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(696242), // Rule ID 11116 //
     /*  696172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696240 */     GIR_RootConstrainSelectedInstOperands,
     /*  696241 */     // GIR_Coverage, 11116,
     /*  696241 */     GIR_EraseRootFromParent_Done,
     /*  696242 */   // Label 11035: @696242
     /*  696242 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(696317), // Rule ID 11117 //
     /*  696247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696315 */     GIR_RootConstrainSelectedInstOperands,
     /*  696316 */     // GIR_Coverage, 11117,
     /*  696316 */     GIR_EraseRootFromParent_Done,
     /*  696317 */   // Label 11036: @696317
     /*  696317 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(696392), // Rule ID 11120 //
     /*  696322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696390 */     GIR_RootConstrainSelectedInstOperands,
     /*  696391 */     // GIR_Coverage, 11120,
     /*  696391 */     GIR_EraseRootFromParent_Done,
     /*  696392 */   // Label 11037: @696392
     /*  696392 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(696467), // Rule ID 11121 //
     /*  696397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696465 */     GIR_RootConstrainSelectedInstOperands,
     /*  696466 */     // GIR_Coverage, 11121,
     /*  696466 */     GIR_EraseRootFromParent_Done,
     /*  696467 */   // Label 11038: @696467
     /*  696467 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(696542), // Rule ID 11124 //
     /*  696472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696540 */     GIR_RootConstrainSelectedInstOperands,
     /*  696541 */     // GIR_Coverage, 11124,
     /*  696541 */     GIR_EraseRootFromParent_Done,
     /*  696542 */   // Label 11039: @696542
     /*  696542 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(696617), // Rule ID 11125 //
     /*  696547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696615 */     GIR_RootConstrainSelectedInstOperands,
     /*  696616 */     // GIR_Coverage, 11125,
     /*  696616 */     GIR_EraseRootFromParent_Done,
     /*  696617 */   // Label 11040: @696617
     /*  696617 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(696692), // Rule ID 11128 //
     /*  696622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696690 */     GIR_RootConstrainSelectedInstOperands,
     /*  696691 */     // GIR_Coverage, 11128,
     /*  696691 */     GIR_EraseRootFromParent_Done,
     /*  696692 */   // Label 11041: @696692
     /*  696692 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(696767), // Rule ID 11129 //
     /*  696697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696765 */     GIR_RootConstrainSelectedInstOperands,
     /*  696766 */     // GIR_Coverage, 11129,
     /*  696766 */     GIR_EraseRootFromParent_Done,
     /*  696767 */   // Label 11042: @696767
     /*  696767 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(696842), // Rule ID 11132 //
     /*  696772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696840 */     GIR_RootConstrainSelectedInstOperands,
     /*  696841 */     // GIR_Coverage, 11132,
     /*  696841 */     GIR_EraseRootFromParent_Done,
     /*  696842 */   // Label 11043: @696842
     /*  696842 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(696917), // Rule ID 11133 //
     /*  696847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696915 */     GIR_RootConstrainSelectedInstOperands,
     /*  696916 */     // GIR_Coverage, 11133,
     /*  696916 */     GIR_EraseRootFromParent_Done,
     /*  696917 */   // Label 11044: @696917
     /*  696917 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(696992), // Rule ID 11136 //
     /*  696922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696990 */     GIR_RootConstrainSelectedInstOperands,
     /*  696991 */     // GIR_Coverage, 11136,
     /*  696991 */     GIR_EraseRootFromParent_Done,
     /*  696992 */   // Label 11045: @696992
     /*  696992 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(697067), // Rule ID 11137 //
     /*  696997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  697000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  697043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  697046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697065 */     GIR_RootConstrainSelectedInstOperands,
     /*  697066 */     // GIR_Coverage, 11137,
     /*  697066 */     GIR_EraseRootFromParent_Done,
     /*  697067 */   // Label 11046: @697067
     /*  697067 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(697142), // Rule ID 11140 //
     /*  697072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  697092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  697121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697140 */     GIR_RootConstrainSelectedInstOperands,
     /*  697141 */     // GIR_Coverage, 11140,
     /*  697141 */     GIR_EraseRootFromParent_Done,
     /*  697142 */   // Label 11047: @697142
     /*  697142 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(697217), // Rule ID 11141 //
     /*  697147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  697167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  697196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697215 */     GIR_RootConstrainSelectedInstOperands,
     /*  697216 */     // GIR_Coverage, 11141,
     /*  697216 */     GIR_EraseRootFromParent_Done,
     /*  697217 */   // Label 11048: @697217
     /*  697217 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(697292), // Rule ID 11144 //
     /*  697222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  697242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697290 */     GIR_RootConstrainSelectedInstOperands,
     /*  697291 */     // GIR_Coverage, 11144,
     /*  697291 */     GIR_EraseRootFromParent_Done,
     /*  697292 */   // Label 11049: @697292
     /*  697292 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(697367), // Rule ID 11145 //
     /*  697297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  697317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697343 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697365 */     GIR_RootConstrainSelectedInstOperands,
     /*  697366 */     // GIR_Coverage, 11145,
     /*  697366 */     GIR_EraseRootFromParent_Done,
     /*  697367 */   // Label 11050: @697367
     /*  697367 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(697442), // Rule ID 11148 //
     /*  697372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697440 */     GIR_RootConstrainSelectedInstOperands,
     /*  697441 */     // GIR_Coverage, 11148,
     /*  697441 */     GIR_EraseRootFromParent_Done,
     /*  697442 */   // Label 11051: @697442
     /*  697442 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(697517), // Rule ID 11149 //
     /*  697447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697515 */     GIR_RootConstrainSelectedInstOperands,
     /*  697516 */     // GIR_Coverage, 11149,
     /*  697516 */     GIR_EraseRootFromParent_Done,
     /*  697517 */   // Label 11052: @697517
     /*  697517 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(697592), // Rule ID 11152 //
     /*  697522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697590 */     GIR_RootConstrainSelectedInstOperands,
     /*  697591 */     // GIR_Coverage, 11152,
     /*  697591 */     GIR_EraseRootFromParent_Done,
     /*  697592 */   // Label 11053: @697592
     /*  697592 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(697667), // Rule ID 11153 //
     /*  697597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697665 */     GIR_RootConstrainSelectedInstOperands,
     /*  697666 */     // GIR_Coverage, 11153,
     /*  697666 */     GIR_EraseRootFromParent_Done,
     /*  697667 */   // Label 11054: @697667
     /*  697667 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(697742), // Rule ID 11156 //
     /*  697672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697740 */     GIR_RootConstrainSelectedInstOperands,
     /*  697741 */     // GIR_Coverage, 11156,
     /*  697741 */     GIR_EraseRootFromParent_Done,
     /*  697742 */   // Label 11055: @697742
     /*  697742 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(697817), // Rule ID 11157 //
     /*  697747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697815 */     GIR_RootConstrainSelectedInstOperands,
     /*  697816 */     // GIR_Coverage, 11157,
     /*  697816 */     GIR_EraseRootFromParent_Done,
     /*  697817 */   // Label 11056: @697817
     /*  697817 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(697892), // Rule ID 11160 //
     /*  697822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697890 */     GIR_RootConstrainSelectedInstOperands,
     /*  697891 */     // GIR_Coverage, 11160,
     /*  697891 */     GIR_EraseRootFromParent_Done,
     /*  697892 */   // Label 11057: @697892
     /*  697892 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(697967), // Rule ID 11161 //
     /*  697897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697965 */     GIR_RootConstrainSelectedInstOperands,
     /*  697966 */     // GIR_Coverage, 11161,
     /*  697966 */     GIR_EraseRootFromParent_Done,
     /*  697967 */   // Label 11058: @697967
     /*  697967 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(698042), // Rule ID 11164 //
     /*  697972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698040 */     GIR_RootConstrainSelectedInstOperands,
     /*  698041 */     // GIR_Coverage, 11164,
     /*  698041 */     GIR_EraseRootFromParent_Done,
     /*  698042 */   // Label 11059: @698042
     /*  698042 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(698117), // Rule ID 11165 //
     /*  698047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  698067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698093 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698115 */     GIR_RootConstrainSelectedInstOperands,
     /*  698116 */     // GIR_Coverage, 11165,
     /*  698116 */     GIR_EraseRootFromParent_Done,
     /*  698117 */   // Label 11060: @698117
     /*  698117 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(698192), // Rule ID 11168 //
     /*  698122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698190 */     GIR_RootConstrainSelectedInstOperands,
     /*  698191 */     // GIR_Coverage, 11168,
     /*  698191 */     GIR_EraseRootFromParent_Done,
     /*  698192 */   // Label 11061: @698192
     /*  698192 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(698267), // Rule ID 11169 //
     /*  698197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  698217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698265 */     GIR_RootConstrainSelectedInstOperands,
     /*  698266 */     // GIR_Coverage, 11169,
     /*  698266 */     GIR_EraseRootFromParent_Done,
     /*  698267 */   // Label 11062: @698267
     /*  698267 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(698342), // Rule ID 11172 //
     /*  698272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  698292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698340 */     GIR_RootConstrainSelectedInstOperands,
     /*  698341 */     // GIR_Coverage, 11172,
     /*  698341 */     GIR_EraseRootFromParent_Done,
     /*  698342 */   // Label 11063: @698342
     /*  698342 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(698417), // Rule ID 11173 //
     /*  698347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  698367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  698396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698415 */     GIR_RootConstrainSelectedInstOperands,
     /*  698416 */     // GIR_Coverage, 11173,
     /*  698416 */     GIR_EraseRootFromParent_Done,
     /*  698417 */   // Label 11064: @698417
     /*  698417 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(698492), // Rule ID 11176 //
     /*  698422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698490 */     GIR_RootConstrainSelectedInstOperands,
     /*  698491 */     // GIR_Coverage, 11176,
     /*  698491 */     GIR_EraseRootFromParent_Done,
     /*  698492 */   // Label 11065: @698492
     /*  698492 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(698567), // Rule ID 11177 //
     /*  698497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698565 */     GIR_RootConstrainSelectedInstOperands,
     /*  698566 */     // GIR_Coverage, 11177,
     /*  698566 */     GIR_EraseRootFromParent_Done,
     /*  698567 */   // Label 11066: @698567
     /*  698567 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(698642), // Rule ID 11180 //
     /*  698572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698640 */     GIR_RootConstrainSelectedInstOperands,
     /*  698641 */     // GIR_Coverage, 11180,
     /*  698641 */     GIR_EraseRootFromParent_Done,
     /*  698642 */   // Label 11067: @698642
     /*  698642 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(698717), // Rule ID 11181 //
     /*  698647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698693 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698715 */     GIR_RootConstrainSelectedInstOperands,
     /*  698716 */     // GIR_Coverage, 11181,
     /*  698716 */     GIR_EraseRootFromParent_Done,
     /*  698717 */   // Label 11068: @698717
     /*  698717 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(698792), // Rule ID 11184 //
     /*  698722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698790 */     GIR_RootConstrainSelectedInstOperands,
     /*  698791 */     // GIR_Coverage, 11184,
     /*  698791 */     GIR_EraseRootFromParent_Done,
     /*  698792 */   // Label 11069: @698792
     /*  698792 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(698867), // Rule ID 11185 //
     /*  698797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698843 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698865 */     GIR_RootConstrainSelectedInstOperands,
     /*  698866 */     // GIR_Coverage, 11185,
     /*  698866 */     GIR_EraseRootFromParent_Done,
     /*  698867 */   // Label 11070: @698867
     /*  698867 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(698942), // Rule ID 11188 //
     /*  698872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698940 */     GIR_RootConstrainSelectedInstOperands,
     /*  698941 */     // GIR_Coverage, 11188,
     /*  698941 */     GIR_EraseRootFromParent_Done,
     /*  698942 */   // Label 11071: @698942
     /*  698942 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(699017), // Rule ID 11189 //
     /*  698947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699015 */     GIR_RootConstrainSelectedInstOperands,
     /*  699016 */     // GIR_Coverage, 11189,
     /*  699016 */     GIR_EraseRootFromParent_Done,
     /*  699017 */   // Label 11072: @699017
     /*  699017 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(699092), // Rule ID 11192 //
     /*  699022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699090 */     GIR_RootConstrainSelectedInstOperands,
     /*  699091 */     // GIR_Coverage, 11192,
     /*  699091 */     GIR_EraseRootFromParent_Done,
     /*  699092 */   // Label 11073: @699092
     /*  699092 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(699167), // Rule ID 11193 //
     /*  699097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  699117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699143 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699165 */     GIR_RootConstrainSelectedInstOperands,
     /*  699166 */     // GIR_Coverage, 11193,
     /*  699166 */     GIR_EraseRootFromParent_Done,
     /*  699167 */   // Label 11074: @699167
     /*  699167 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(699242), // Rule ID 11196 //
     /*  699172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699240 */     GIR_RootConstrainSelectedInstOperands,
     /*  699241 */     // GIR_Coverage, 11196,
     /*  699241 */     GIR_EraseRootFromParent_Done,
     /*  699242 */   // Label 11075: @699242
     /*  699242 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(699317), // Rule ID 11197 //
     /*  699247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  699267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699293 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699315 */     GIR_RootConstrainSelectedInstOperands,
     /*  699316 */     // GIR_Coverage, 11197,
     /*  699316 */     GIR_EraseRootFromParent_Done,
     /*  699317 */   // Label 11076: @699317
     /*  699317 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(699392), // Rule ID 11200 //
     /*  699322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  699371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699390 */     GIR_RootConstrainSelectedInstOperands,
     /*  699391 */     // GIR_Coverage, 11200,
     /*  699391 */     GIR_EraseRootFromParent_Done,
     /*  699392 */   // Label 11077: @699392
     /*  699392 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(699467), // Rule ID 11201 //
     /*  699397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  699417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  699446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699465 */     GIR_RootConstrainSelectedInstOperands,
     /*  699466 */     // GIR_Coverage, 11201,
     /*  699466 */     GIR_EraseRootFromParent_Done,
     /*  699467 */   // Label 11078: @699467
     /*  699467 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(699542), // Rule ID 11204 //
     /*  699472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699540 */     GIR_RootConstrainSelectedInstOperands,
     /*  699541 */     // GIR_Coverage, 11204,
     /*  699541 */     GIR_EraseRootFromParent_Done,
     /*  699542 */   // Label 11079: @699542
     /*  699542 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(699617), // Rule ID 11205 //
     /*  699547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699615 */     GIR_RootConstrainSelectedInstOperands,
     /*  699616 */     // GIR_Coverage, 11205,
     /*  699616 */     GIR_EraseRootFromParent_Done,
     /*  699617 */   // Label 11080: @699617
     /*  699617 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(699692), // Rule ID 11208 //
     /*  699622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699690 */     GIR_RootConstrainSelectedInstOperands,
     /*  699691 */     // GIR_Coverage, 11208,
     /*  699691 */     GIR_EraseRootFromParent_Done,
     /*  699692 */   // Label 11081: @699692
     /*  699692 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(699767), // Rule ID 11209 //
     /*  699697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699743 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699765 */     GIR_RootConstrainSelectedInstOperands,
     /*  699766 */     // GIR_Coverage, 11209,
     /*  699766 */     GIR_EraseRootFromParent_Done,
     /*  699767 */   // Label 11082: @699767
     /*  699767 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(699842), // Rule ID 11212 //
     /*  699772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699840 */     GIR_RootConstrainSelectedInstOperands,
     /*  699841 */     // GIR_Coverage, 11212,
     /*  699841 */     GIR_EraseRootFromParent_Done,
     /*  699842 */   // Label 11083: @699842
     /*  699842 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(699917), // Rule ID 11213 //
     /*  699847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699915 */     GIR_RootConstrainSelectedInstOperands,
     /*  699916 */     // GIR_Coverage, 11213,
     /*  699916 */     GIR_EraseRootFromParent_Done,
     /*  699917 */   // Label 11084: @699917
     /*  699917 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(699992), // Rule ID 11216 //
     /*  699922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699990 */     GIR_RootConstrainSelectedInstOperands,
     /*  699991 */     // GIR_Coverage, 11216,
     /*  699991 */     GIR_EraseRootFromParent_Done,
     /*  699992 */   // Label 11085: @699992
     /*  699992 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(700067), // Rule ID 11217 //
     /*  699997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700065 */     GIR_RootConstrainSelectedInstOperands,
     /*  700066 */     // GIR_Coverage, 11217,
     /*  700066 */     GIR_EraseRootFromParent_Done,
     /*  700067 */   // Label 11086: @700067
     /*  700067 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(700142), // Rule ID 11220 //
     /*  700072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700140 */     GIR_RootConstrainSelectedInstOperands,
     /*  700141 */     // GIR_Coverage, 11220,
     /*  700141 */     GIR_EraseRootFromParent_Done,
     /*  700142 */   // Label 11087: @700142
     /*  700142 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(700217), // Rule ID 11221 //
     /*  700147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700215 */     GIR_RootConstrainSelectedInstOperands,
     /*  700216 */     // GIR_Coverage, 11221,
     /*  700216 */     GIR_EraseRootFromParent_Done,
     /*  700217 */   // Label 11088: @700217
     /*  700217 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(700292), // Rule ID 11224 //
     /*  700222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700290 */     GIR_RootConstrainSelectedInstOperands,
     /*  700291 */     // GIR_Coverage, 11224,
     /*  700291 */     GIR_EraseRootFromParent_Done,
     /*  700292 */   // Label 11089: @700292
     /*  700292 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(700367), // Rule ID 11225 //
     /*  700297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  700346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700365 */     GIR_RootConstrainSelectedInstOperands,
     /*  700366 */     // GIR_Coverage, 11225,
     /*  700366 */     GIR_EraseRootFromParent_Done,
     /*  700367 */   // Label 11090: @700367
     /*  700367 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(700442), // Rule ID 11228 //
     /*  700372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700440 */     GIR_RootConstrainSelectedInstOperands,
     /*  700441 */     // GIR_Coverage, 11228,
     /*  700441 */     GIR_EraseRootFromParent_Done,
     /*  700442 */   // Label 11091: @700442
     /*  700442 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(700517), // Rule ID 11229 //
     /*  700447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  700458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  700461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  700464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700515 */     GIR_RootConstrainSelectedInstOperands,
     /*  700516 */     // GIR_Coverage, 11229,
     /*  700516 */     GIR_EraseRootFromParent_Done,
     /*  700517 */   // Label 11092: @700517
     /*  700517 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(700592), // Rule ID 11232 //
     /*  700522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700590 */     GIR_RootConstrainSelectedInstOperands,
     /*  700591 */     // GIR_Coverage, 11232,
     /*  700591 */     GIR_EraseRootFromParent_Done,
     /*  700592 */   // Label 11093: @700592
     /*  700592 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(700667), // Rule ID 11233 //
     /*  700597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700665 */     GIR_RootConstrainSelectedInstOperands,
     /*  700666 */     // GIR_Coverage, 11233,
     /*  700666 */     GIR_EraseRootFromParent_Done,
     /*  700667 */   // Label 11094: @700667
     /*  700667 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(700742), // Rule ID 11236 //
     /*  700672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700740 */     GIR_RootConstrainSelectedInstOperands,
     /*  700741 */     // GIR_Coverage, 11236,
     /*  700741 */     GIR_EraseRootFromParent_Done,
     /*  700742 */   // Label 11095: @700742
     /*  700742 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(700817), // Rule ID 11237 //
     /*  700747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700815 */     GIR_RootConstrainSelectedInstOperands,
     /*  700816 */     // GIR_Coverage, 11237,
     /*  700816 */     GIR_EraseRootFromParent_Done,
     /*  700817 */   // Label 11096: @700817
     /*  700817 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(700892), // Rule ID 11240 //
     /*  700822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700890 */     GIR_RootConstrainSelectedInstOperands,
     /*  700891 */     // GIR_Coverage, 11240,
     /*  700891 */     GIR_EraseRootFromParent_Done,
     /*  700892 */   // Label 11097: @700892
     /*  700892 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(700967), // Rule ID 11241 //
     /*  700897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700965 */     GIR_RootConstrainSelectedInstOperands,
     /*  700966 */     // GIR_Coverage, 11241,
     /*  700966 */     GIR_EraseRootFromParent_Done,
     /*  700967 */   // Label 11098: @700967
     /*  700967 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(701042), // Rule ID 11244 //
     /*  700972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  701021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701040 */     GIR_RootConstrainSelectedInstOperands,
     /*  701041 */     // GIR_Coverage, 11244,
     /*  701041 */     GIR_EraseRootFromParent_Done,
     /*  701042 */   // Label 11099: @701042
     /*  701042 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(701117), // Rule ID 11245 //
     /*  701047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  701096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701115 */     GIR_RootConstrainSelectedInstOperands,
     /*  701116 */     // GIR_Coverage, 11245,
     /*  701116 */     GIR_EraseRootFromParent_Done,
     /*  701117 */   // Label 11100: @701117
     /*  701117 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(701192), // Rule ID 11248 //
     /*  701122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701190 */     GIR_RootConstrainSelectedInstOperands,
     /*  701191 */     // GIR_Coverage, 11248,
     /*  701191 */     GIR_EraseRootFromParent_Done,
     /*  701192 */   // Label 11101: @701192
     /*  701192 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(701267), // Rule ID 11249 //
     /*  701197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701243 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701265 */     GIR_RootConstrainSelectedInstOperands,
     /*  701266 */     // GIR_Coverage, 11249,
     /*  701266 */     GIR_EraseRootFromParent_Done,
     /*  701267 */   // Label 11102: @701267
     /*  701267 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(701342), // Rule ID 11252 //
     /*  701272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701340 */     GIR_RootConstrainSelectedInstOperands,
     /*  701341 */     // GIR_Coverage, 11252,
     /*  701341 */     GIR_EraseRootFromParent_Done,
     /*  701342 */   // Label 11103: @701342
     /*  701342 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(701417), // Rule ID 11253 //
     /*  701347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701393 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701415 */     GIR_RootConstrainSelectedInstOperands,
     /*  701416 */     // GIR_Coverage, 11253,
     /*  701416 */     GIR_EraseRootFromParent_Done,
     /*  701417 */   // Label 11104: @701417
     /*  701417 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(701492), // Rule ID 11256 //
     /*  701422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701490 */     GIR_RootConstrainSelectedInstOperands,
     /*  701491 */     // GIR_Coverage, 11256,
     /*  701491 */     GIR_EraseRootFromParent_Done,
     /*  701492 */   // Label 11105: @701492
     /*  701492 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(701567), // Rule ID 11257 //
     /*  701497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701543 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701565 */     GIR_RootConstrainSelectedInstOperands,
     /*  701566 */     // GIR_Coverage, 11257,
     /*  701566 */     GIR_EraseRootFromParent_Done,
     /*  701567 */   // Label 11106: @701567
     /*  701567 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(701642), // Rule ID 11260 //
     /*  701572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701640 */     GIR_RootConstrainSelectedInstOperands,
     /*  701641 */     // GIR_Coverage, 11260,
     /*  701641 */     GIR_EraseRootFromParent_Done,
     /*  701642 */   // Label 11107: @701642
     /*  701642 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(701717), // Rule ID 11261 //
     /*  701647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701693 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701715 */     GIR_RootConstrainSelectedInstOperands,
     /*  701716 */     // GIR_Coverage, 11261,
     /*  701716 */     GIR_EraseRootFromParent_Done,
     /*  701717 */   // Label 11108: @701717
     /*  701717 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(701792), // Rule ID 11264 //
     /*  701722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701768 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701790 */     GIR_RootConstrainSelectedInstOperands,
     /*  701791 */     // GIR_Coverage, 11264,
     /*  701791 */     GIR_EraseRootFromParent_Done,
     /*  701792 */   // Label 11109: @701792
     /*  701792 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(701867), // Rule ID 11265 //
     /*  701797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701843 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701865 */     GIR_RootConstrainSelectedInstOperands,
     /*  701866 */     // GIR_Coverage, 11265,
     /*  701866 */     GIR_EraseRootFromParent_Done,
     /*  701867 */   // Label 11110: @701867
     /*  701867 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(701942), // Rule ID 11268 //
     /*  701872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701940 */     GIR_RootConstrainSelectedInstOperands,
     /*  701941 */     // GIR_Coverage, 11268,
     /*  701941 */     GIR_EraseRootFromParent_Done,
     /*  701942 */   // Label 11111: @701942
     /*  701942 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(702017), // Rule ID 11269 //
     /*  701947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701993 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702015 */     GIR_RootConstrainSelectedInstOperands,
     /*  702016 */     // GIR_Coverage, 11269,
     /*  702016 */     GIR_EraseRootFromParent_Done,
     /*  702017 */   // Label 11112: @702017
     /*  702017 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(702092), // Rule ID 11272 //
     /*  702022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  702071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702090 */     GIR_RootConstrainSelectedInstOperands,
     /*  702091 */     // GIR_Coverage, 11272,
     /*  702091 */     GIR_EraseRootFromParent_Done,
     /*  702092 */   // Label 11113: @702092
     /*  702092 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(702167), // Rule ID 11273 //
     /*  702097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  702146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702165 */     GIR_RootConstrainSelectedInstOperands,
     /*  702166 */     // GIR_Coverage, 11273,
     /*  702166 */     GIR_EraseRootFromParent_Done,
     /*  702167 */   // Label 11114: @702167
     /*  702167 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(702242), // Rule ID 11276 //
     /*  702172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  702221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702240 */     GIR_RootConstrainSelectedInstOperands,
     /*  702241 */     // GIR_Coverage, 11276,
     /*  702241 */     GIR_EraseRootFromParent_Done,
     /*  702242 */   // Label 11115: @702242
     /*  702242 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(702317), // Rule ID 11277 //
     /*  702247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  702296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702315 */     GIR_RootConstrainSelectedInstOperands,
     /*  702316 */     // GIR_Coverage, 11277,
     /*  702316 */     GIR_EraseRootFromParent_Done,
     /*  702317 */   // Label 11116: @702317
     /*  702317 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(702392), // Rule ID 11280 //
     /*  702322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  702342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  702371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702390 */     GIR_RootConstrainSelectedInstOperands,
     /*  702391 */     // GIR_Coverage, 11280,
     /*  702391 */     GIR_EraseRootFromParent_Done,
     /*  702392 */   // Label 11117: @702392
     /*  702392 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(702467), // Rule ID 11281 //
     /*  702397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  702408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  702411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  702414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  702417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  702436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  702446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702465 */     GIR_RootConstrainSelectedInstOperands,
     /*  702466 */     // GIR_Coverage, 11281,
     /*  702466 */     GIR_EraseRootFromParent_Done,
     /*  702467 */   // Label 11118: @702467
     /*  702467 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(702542), // Rule ID 11284 //
     /*  702472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702540 */     GIR_RootConstrainSelectedInstOperands,
     /*  702541 */     // GIR_Coverage, 11284,
     /*  702541 */     GIR_EraseRootFromParent_Done,
     /*  702542 */   // Label 11119: @702542
     /*  702542 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(702617), // Rule ID 11285 //
     /*  702547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702615 */     GIR_RootConstrainSelectedInstOperands,
     /*  702616 */     // GIR_Coverage, 11285,
     /*  702616 */     GIR_EraseRootFromParent_Done,
     /*  702617 */   // Label 11120: @702617
     /*  702617 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(702692), // Rule ID 11288 //
     /*  702622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702690 */     GIR_RootConstrainSelectedInstOperands,
     /*  702691 */     // GIR_Coverage, 11288,
     /*  702691 */     GIR_EraseRootFromParent_Done,
     /*  702692 */   // Label 11121: @702692
     /*  702692 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(702767), // Rule ID 11289 //
     /*  702697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702765 */     GIR_RootConstrainSelectedInstOperands,
     /*  702766 */     // GIR_Coverage, 11289,
     /*  702766 */     GIR_EraseRootFromParent_Done,
     /*  702767 */   // Label 11122: @702767
     /*  702767 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(702842), // Rule ID 11292 //
     /*  702772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702840 */     GIR_RootConstrainSelectedInstOperands,
     /*  702841 */     // GIR_Coverage, 11292,
     /*  702841 */     GIR_EraseRootFromParent_Done,
     /*  702842 */   // Label 11123: @702842
     /*  702842 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(702917), // Rule ID 11293 //
     /*  702847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702915 */     GIR_RootConstrainSelectedInstOperands,
     /*  702916 */     // GIR_Coverage, 11293,
     /*  702916 */     GIR_EraseRootFromParent_Done,
     /*  702917 */   // Label 11124: @702917
     /*  702917 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(702992), // Rule ID 11296 //
     /*  702922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702990 */     GIR_RootConstrainSelectedInstOperands,
     /*  702991 */     // GIR_Coverage, 11296,
     /*  702991 */     GIR_EraseRootFromParent_Done,
     /*  702992 */   // Label 11125: @702992
     /*  702992 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(703067), // Rule ID 11297 //
     /*  702997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  703017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  703046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703065 */     GIR_RootConstrainSelectedInstOperands,
     /*  703066 */     // GIR_Coverage, 11297,
     /*  703066 */     GIR_EraseRootFromParent_Done,
     /*  703067 */   // Label 11126: @703067
     /*  703067 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(703142), // Rule ID 11300 //
     /*  703072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703140 */     GIR_RootConstrainSelectedInstOperands,
     /*  703141 */     // GIR_Coverage, 11300,
     /*  703141 */     GIR_EraseRootFromParent_Done,
     /*  703142 */   // Label 11127: @703142
     /*  703142 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(703217), // Rule ID 11301 //
     /*  703147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  703167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703215 */     GIR_RootConstrainSelectedInstOperands,
     /*  703216 */     // GIR_Coverage, 11301,
     /*  703216 */     GIR_EraseRootFromParent_Done,
     /*  703217 */   // Label 11128: @703217
     /*  703217 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(703292), // Rule ID 11304 //
     /*  703222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703290 */     GIR_RootConstrainSelectedInstOperands,
     /*  703291 */     // GIR_Coverage, 11304,
     /*  703291 */     GIR_EraseRootFromParent_Done,
     /*  703292 */   // Label 11129: @703292
     /*  703292 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(703367), // Rule ID 11305 //
     /*  703297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  703317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  703346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703365 */     GIR_RootConstrainSelectedInstOperands,
     /*  703366 */     // GIR_Coverage, 11305,
     /*  703366 */     GIR_EraseRootFromParent_Done,
     /*  703367 */   // Label 11130: @703367
     /*  703367 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(703442), // Rule ID 11308 //
     /*  703372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  703383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  703386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  703389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703440 */     GIR_RootConstrainSelectedInstOperands,
     /*  703441 */     // GIR_Coverage, 11308,
     /*  703441 */     GIR_EraseRootFromParent_Done,
     /*  703442 */   // Label 11131: @703442
     /*  703442 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(703517), // Rule ID 11309 //
     /*  703447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  703458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  703461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  703464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703493 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703515 */     GIR_RootConstrainSelectedInstOperands,
     /*  703516 */     // GIR_Coverage, 11309,
     /*  703516 */     GIR_EraseRootFromParent_Done,
     /*  703517 */   // Label 11132: @703517
     /*  703517 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(703592), // Rule ID 11312 //
     /*  703522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703590 */     GIR_RootConstrainSelectedInstOperands,
     /*  703591 */     // GIR_Coverage, 11312,
     /*  703591 */     GIR_EraseRootFromParent_Done,
     /*  703592 */   // Label 11133: @703592
     /*  703592 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(703667), // Rule ID 11313 //
     /*  703597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703665 */     GIR_RootConstrainSelectedInstOperands,
     /*  703666 */     // GIR_Coverage, 11313,
     /*  703666 */     GIR_EraseRootFromParent_Done,
     /*  703667 */   // Label 11134: @703667
     /*  703667 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(703742), // Rule ID 11316 //
     /*  703672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703740 */     GIR_RootConstrainSelectedInstOperands,
     /*  703741 */     // GIR_Coverage, 11316,
     /*  703741 */     GIR_EraseRootFromParent_Done,
     /*  703742 */   // Label 11135: @703742
     /*  703742 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(703817), // Rule ID 11317 //
     /*  703747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703815 */     GIR_RootConstrainSelectedInstOperands,
     /*  703816 */     // GIR_Coverage, 11317,
     /*  703816 */     GIR_EraseRootFromParent_Done,
     /*  703817 */   // Label 11136: @703817
     /*  703817 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(703892), // Rule ID 11320 //
     /*  703822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703868 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703890 */     GIR_RootConstrainSelectedInstOperands,
     /*  703891 */     // GIR_Coverage, 11320,
     /*  703891 */     GIR_EraseRootFromParent_Done,
     /*  703892 */   // Label 11137: @703892
     /*  703892 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(703967), // Rule ID 11321 //
     /*  703897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703943 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703965 */     GIR_RootConstrainSelectedInstOperands,
     /*  703966 */     // GIR_Coverage, 11321,
     /*  703966 */     GIR_EraseRootFromParent_Done,
     /*  703967 */   // Label 11138: @703967
     /*  703967 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(704042), // Rule ID 11324 //
     /*  703972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704040 */     GIR_RootConstrainSelectedInstOperands,
     /*  704041 */     // GIR_Coverage, 11324,
     /*  704041 */     GIR_EraseRootFromParent_Done,
     /*  704042 */   // Label 11139: @704042
     /*  704042 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(704117), // Rule ID 11325 //
     /*  704047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  704067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704093 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704115 */     GIR_RootConstrainSelectedInstOperands,
     /*  704116 */     // GIR_Coverage, 11325,
     /*  704116 */     GIR_EraseRootFromParent_Done,
     /*  704117 */   // Label 11140: @704117
     /*  704117 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(704192), // Rule ID 11328 //
     /*  704122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  704142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704168 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704190 */     GIR_RootConstrainSelectedInstOperands,
     /*  704191 */     // GIR_Coverage, 11328,
     /*  704191 */     GIR_EraseRootFromParent_Done,
     /*  704192 */   // Label 11141: @704192
     /*  704192 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(704267), // Rule ID 11329 //
     /*  704197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  704217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704243 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704265 */     GIR_RootConstrainSelectedInstOperands,
     /*  704266 */     // GIR_Coverage, 11329,
     /*  704266 */     GIR_EraseRootFromParent_Done,
     /*  704267 */   // Label 11142: @704267
     /*  704267 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(704342), // Rule ID 11332 //
     /*  704272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  704292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704340 */     GIR_RootConstrainSelectedInstOperands,
     /*  704341 */     // GIR_Coverage, 11332,
     /*  704341 */     GIR_EraseRootFromParent_Done,
     /*  704342 */   // Label 11143: @704342
     /*  704342 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(704417), // Rule ID 11333 //
     /*  704347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  704367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704415 */     GIR_RootConstrainSelectedInstOperands,
     /*  704416 */     // GIR_Coverage, 11333,
     /*  704416 */     GIR_EraseRootFromParent_Done,
     /*  704417 */   // Label 11144: @704417
     /*  704417 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(704492), // Rule ID 11336 //
     /*  704422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704490 */     GIR_RootConstrainSelectedInstOperands,
     /*  704491 */     // GIR_Coverage, 11336,
     /*  704491 */     GIR_EraseRootFromParent_Done,
     /*  704492 */   // Label 11145: @704492
     /*  704492 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(704567), // Rule ID 11337 //
     /*  704497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704543 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704565 */     GIR_RootConstrainSelectedInstOperands,
     /*  704566 */     // GIR_Coverage, 11337,
     /*  704566 */     GIR_EraseRootFromParent_Done,
     /*  704567 */   // Label 11146: @704567
     /*  704567 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(704642), // Rule ID 11340 //
     /*  704572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704640 */     GIR_RootConstrainSelectedInstOperands,
     /*  704641 */     // GIR_Coverage, 11340,
     /*  704641 */     GIR_EraseRootFromParent_Done,
     /*  704642 */   // Label 11147: @704642
     /*  704642 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(704717), // Rule ID 11341 //
     /*  704647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704715 */     GIR_RootConstrainSelectedInstOperands,
     /*  704716 */     // GIR_Coverage, 11341,
     /*  704716 */     GIR_EraseRootFromParent_Done,
     /*  704717 */   // Label 11148: @704717
     /*  704717 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(704792), // Rule ID 11344 //
     /*  704722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704790 */     GIR_RootConstrainSelectedInstOperands,
     /*  704791 */     // GIR_Coverage, 11344,
     /*  704791 */     GIR_EraseRootFromParent_Done,
     /*  704792 */   // Label 11149: @704792
     /*  704792 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(704867), // Rule ID 11345 //
     /*  704797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704865 */     GIR_RootConstrainSelectedInstOperands,
     /*  704866 */     // GIR_Coverage, 11345,
     /*  704866 */     GIR_EraseRootFromParent_Done,
     /*  704867 */   // Label 11150: @704867
     /*  704867 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(704942), // Rule ID 11348 //
     /*  704872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704940 */     GIR_RootConstrainSelectedInstOperands,
     /*  704941 */     // GIR_Coverage, 11348,
     /*  704941 */     GIR_EraseRootFromParent_Done,
     /*  704942 */   // Label 11151: @704942
     /*  704942 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(705017), // Rule ID 11349 //
     /*  704947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705015 */     GIR_RootConstrainSelectedInstOperands,
     /*  705016 */     // GIR_Coverage, 11349,
     /*  705016 */     GIR_EraseRootFromParent_Done,
     /*  705017 */   // Label 11152: @705017
     /*  705017 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(705092), // Rule ID 11352 //
     /*  705022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  705042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  705071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705090 */     GIR_RootConstrainSelectedInstOperands,
     /*  705091 */     // GIR_Coverage, 11352,
     /*  705091 */     GIR_EraseRootFromParent_Done,
     /*  705092 */   // Label 11153: @705092
     /*  705092 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(705167), // Rule ID 11353 //
     /*  705097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  705117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  705146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705165 */     GIR_RootConstrainSelectedInstOperands,
     /*  705166 */     // GIR_Coverage, 11353,
     /*  705166 */     GIR_EraseRootFromParent_Done,
     /*  705167 */   // Label 11154: @705167
     /*  705167 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(705242), // Rule ID 11356 //
     /*  705172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  705221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705240 */     GIR_RootConstrainSelectedInstOperands,
     /*  705241 */     // GIR_Coverage, 11356,
     /*  705241 */     GIR_EraseRootFromParent_Done,
     /*  705242 */   // Label 11155: @705242
     /*  705242 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(705317), // Rule ID 11357 //
     /*  705247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  705296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705315 */     GIR_RootConstrainSelectedInstOperands,
     /*  705316 */     // GIR_Coverage, 11357,
     /*  705316 */     GIR_EraseRootFromParent_Done,
     /*  705317 */   // Label 11156: @705317
     /*  705317 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(705392), // Rule ID 11360 //
     /*  705322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  705333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  705336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  705339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705390 */     GIR_RootConstrainSelectedInstOperands,
     /*  705391 */     // GIR_Coverage, 11360,
     /*  705391 */     GIR_EraseRootFromParent_Done,
     /*  705392 */   // Label 11157: @705392
     /*  705392 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(705467), // Rule ID 11361 //
     /*  705397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  705408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  705411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  705414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705465 */     GIR_RootConstrainSelectedInstOperands,
     /*  705466 */     // GIR_Coverage, 11361,
     /*  705466 */     GIR_EraseRootFromParent_Done,
     /*  705467 */   // Label 11158: @705467
     /*  705467 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(705542), // Rule ID 11364 //
     /*  705472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705540 */     GIR_RootConstrainSelectedInstOperands,
     /*  705541 */     // GIR_Coverage, 11364,
     /*  705541 */     GIR_EraseRootFromParent_Done,
     /*  705542 */   // Label 11159: @705542
     /*  705542 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(705617), // Rule ID 11365 //
     /*  705547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705615 */     GIR_RootConstrainSelectedInstOperands,
     /*  705616 */     // GIR_Coverage, 11365,
     /*  705616 */     GIR_EraseRootFromParent_Done,
     /*  705617 */   // Label 11160: @705617
     /*  705617 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(705692), // Rule ID 11368 //
     /*  705622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705690 */     GIR_RootConstrainSelectedInstOperands,
     /*  705691 */     // GIR_Coverage, 11368,
     /*  705691 */     GIR_EraseRootFromParent_Done,
     /*  705692 */   // Label 11161: @705692
     /*  705692 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(705767), // Rule ID 11369 //
     /*  705697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705765 */     GIR_RootConstrainSelectedInstOperands,
     /*  705766 */     // GIR_Coverage, 11369,
     /*  705766 */     GIR_EraseRootFromParent_Done,
     /*  705767 */   // Label 11162: @705767
     /*  705767 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(705842), // Rule ID 11372 //
     /*  705772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705840 */     GIR_RootConstrainSelectedInstOperands,
     /*  705841 */     // GIR_Coverage, 11372,
     /*  705841 */     GIR_EraseRootFromParent_Done,
     /*  705842 */   // Label 11163: @705842
     /*  705842 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(705917), // Rule ID 11373 //
     /*  705847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705915 */     GIR_RootConstrainSelectedInstOperands,
     /*  705916 */     // GIR_Coverage, 11373,
     /*  705916 */     GIR_EraseRootFromParent_Done,
     /*  705917 */   // Label 11164: @705917
     /*  705917 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(705992), // Rule ID 11376 //
     /*  705922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705990 */     GIR_RootConstrainSelectedInstOperands,
     /*  705991 */     // GIR_Coverage, 11376,
     /*  705991 */     GIR_EraseRootFromParent_Done,
     /*  705992 */   // Label 11165: @705992
     /*  705992 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(706067), // Rule ID 11377 //
     /*  705997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  706046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706065 */     GIR_RootConstrainSelectedInstOperands,
     /*  706066 */     // GIR_Coverage, 11377,
     /*  706066 */     GIR_EraseRootFromParent_Done,
     /*  706067 */   // Label 11166: @706067
     /*  706067 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(706142), // Rule ID 11380 //
     /*  706072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706140 */     GIR_RootConstrainSelectedInstOperands,
     /*  706141 */     // GIR_Coverage, 11380,
     /*  706141 */     GIR_EraseRootFromParent_Done,
     /*  706142 */   // Label 11167: @706142
     /*  706142 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(706217), // Rule ID 11381 //
     /*  706147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706215 */     GIR_RootConstrainSelectedInstOperands,
     /*  706216 */     // GIR_Coverage, 11381,
     /*  706216 */     GIR_EraseRootFromParent_Done,
     /*  706217 */   // Label 11168: @706217
     /*  706217 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(706292), // Rule ID 11384 //
     /*  706222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706290 */     GIR_RootConstrainSelectedInstOperands,
     /*  706291 */     // GIR_Coverage, 11384,
     /*  706291 */     GIR_EraseRootFromParent_Done,
     /*  706292 */   // Label 11169: @706292
     /*  706292 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(706367), // Rule ID 11385 //
     /*  706297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706365 */     GIR_RootConstrainSelectedInstOperands,
     /*  706366 */     // GIR_Coverage, 11385,
     /*  706366 */     GIR_EraseRootFromParent_Done,
     /*  706367 */   // Label 11170: @706367
     /*  706367 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(706442), // Rule ID 11388 //
     /*  706372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  706383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  706386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  706389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706440 */     GIR_RootConstrainSelectedInstOperands,
     /*  706441 */     // GIR_Coverage, 11388,
     /*  706441 */     GIR_EraseRootFromParent_Done,
     /*  706442 */   // Label 11171: @706442
     /*  706442 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(706517), // Rule ID 11389 //
     /*  706447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  706458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  706461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  706464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706515 */     GIR_RootConstrainSelectedInstOperands,
     /*  706516 */     // GIR_Coverage, 11389,
     /*  706516 */     GIR_EraseRootFromParent_Done,
     /*  706517 */   // Label 11172: @706517
     /*  706517 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(706592), // Rule ID 11392 //
     /*  706522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706590 */     GIR_RootConstrainSelectedInstOperands,
     /*  706591 */     // GIR_Coverage, 11392,
     /*  706591 */     GIR_EraseRootFromParent_Done,
     /*  706592 */   // Label 11173: @706592
     /*  706592 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(706667), // Rule ID 11393 //
     /*  706597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706643 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706665 */     GIR_RootConstrainSelectedInstOperands,
     /*  706666 */     // GIR_Coverage, 11393,
     /*  706666 */     GIR_EraseRootFromParent_Done,
     /*  706667 */   // Label 11174: @706667
     /*  706667 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(706742), // Rule ID 11396 //
     /*  706672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706718 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706740 */     GIR_RootConstrainSelectedInstOperands,
     /*  706741 */     // GIR_Coverage, 11396,
     /*  706741 */     GIR_EraseRootFromParent_Done,
     /*  706742 */   // Label 11175: @706742
     /*  706742 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(706817), // Rule ID 11397 //
     /*  706747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706793 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706815 */     GIR_RootConstrainSelectedInstOperands,
     /*  706816 */     // GIR_Coverage, 11397,
     /*  706816 */     GIR_EraseRootFromParent_Done,
     /*  706817 */   // Label 11176: @706817
     /*  706817 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(706892), // Rule ID 11400 //
     /*  706822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706868 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706890 */     GIR_RootConstrainSelectedInstOperands,
     /*  706891 */     // GIR_Coverage, 11400,
     /*  706891 */     GIR_EraseRootFromParent_Done,
     /*  706892 */   // Label 11177: @706892
     /*  706892 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(706967), // Rule ID 11401 //
     /*  706897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706943 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706965 */     GIR_RootConstrainSelectedInstOperands,
     /*  706966 */     // GIR_Coverage, 11401,
     /*  706966 */     GIR_EraseRootFromParent_Done,
     /*  706967 */   // Label 11178: @706967
     /*  706967 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(707042), // Rule ID 11404 //
     /*  706972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707040 */     GIR_RootConstrainSelectedInstOperands,
     /*  707041 */     // GIR_Coverage, 11404,
     /*  707041 */     GIR_EraseRootFromParent_Done,
     /*  707042 */   // Label 11179: @707042
     /*  707042 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(707117), // Rule ID 11405 //
     /*  707047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707115 */     GIR_RootConstrainSelectedInstOperands,
     /*  707116 */     // GIR_Coverage, 11405,
     /*  707116 */     GIR_EraseRootFromParent_Done,
     /*  707117 */   // Label 11180: @707117
     /*  707117 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(707192), // Rule ID 11408 //
     /*  707122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707190 */     GIR_RootConstrainSelectedInstOperands,
     /*  707191 */     // GIR_Coverage, 11408,
     /*  707191 */     GIR_EraseRootFromParent_Done,
     /*  707192 */   // Label 11181: @707192
     /*  707192 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(707267), // Rule ID 11409 //
     /*  707197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707265 */     GIR_RootConstrainSelectedInstOperands,
     /*  707266 */     // GIR_Coverage, 11409,
     /*  707266 */     GIR_EraseRootFromParent_Done,
     /*  707267 */   // Label 11182: @707267
     /*  707267 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(707342), // Rule ID 11412 //
     /*  707272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707340 */     GIR_RootConstrainSelectedInstOperands,
     /*  707341 */     // GIR_Coverage, 11412,
     /*  707341 */     GIR_EraseRootFromParent_Done,
     /*  707342 */   // Label 11183: @707342
     /*  707342 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(707417), // Rule ID 11413 //
     /*  707347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707393 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707415 */     GIR_RootConstrainSelectedInstOperands,
     /*  707416 */     // GIR_Coverage, 11413,
     /*  707416 */     GIR_EraseRootFromParent_Done,
     /*  707417 */   // Label 11184: @707417
     /*  707417 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(707492), // Rule ID 11416 //
     /*  707422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707490 */     GIR_RootConstrainSelectedInstOperands,
     /*  707491 */     // GIR_Coverage, 11416,
     /*  707491 */     GIR_EraseRootFromParent_Done,
     /*  707492 */   // Label 11185: @707492
     /*  707492 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(707567), // Rule ID 11417 //
     /*  707497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707565 */     GIR_RootConstrainSelectedInstOperands,
     /*  707566 */     // GIR_Coverage, 11417,
     /*  707566 */     GIR_EraseRootFromParent_Done,
     /*  707567 */   // Label 11186: @707567
     /*  707567 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(707642), // Rule ID 11420 //
     /*  707572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707640 */     GIR_RootConstrainSelectedInstOperands,
     /*  707641 */     // GIR_Coverage, 11420,
     /*  707641 */     GIR_EraseRootFromParent_Done,
     /*  707642 */   // Label 11187: @707642
     /*  707642 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(707717), // Rule ID 11421 //
     /*  707647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707693 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707715 */     GIR_RootConstrainSelectedInstOperands,
     /*  707716 */     // GIR_Coverage, 11421,
     /*  707716 */     GIR_EraseRootFromParent_Done,
     /*  707717 */   // Label 11188: @707717
     /*  707717 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(707792), // Rule ID 11424 //
     /*  707722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707790 */     GIR_RootConstrainSelectedInstOperands,
     /*  707791 */     // GIR_Coverage, 11424,
     /*  707791 */     GIR_EraseRootFromParent_Done,
     /*  707792 */   // Label 11189: @707792
     /*  707792 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(707867), // Rule ID 11425 //
     /*  707797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707865 */     GIR_RootConstrainSelectedInstOperands,
     /*  707866 */     // GIR_Coverage, 11425,
     /*  707866 */     GIR_EraseRootFromParent_Done,
     /*  707867 */   // Label 11190: @707867
     /*  707867 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(707942), // Rule ID 11428 //
     /*  707872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707940 */     GIR_RootConstrainSelectedInstOperands,
     /*  707941 */     // GIR_Coverage, 11428,
     /*  707941 */     GIR_EraseRootFromParent_Done,
     /*  707942 */   // Label 11191: @707942
     /*  707942 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(708017), // Rule ID 11429 //
     /*  707947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708015 */     GIR_RootConstrainSelectedInstOperands,
     /*  708016 */     // GIR_Coverage, 11429,
     /*  708016 */     GIR_EraseRootFromParent_Done,
     /*  708017 */   // Label 11192: @708017
     /*  708017 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(708092), // Rule ID 11432 //
     /*  708022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  708042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708090 */     GIR_RootConstrainSelectedInstOperands,
     /*  708091 */     // GIR_Coverage, 11432,
     /*  708091 */     GIR_EraseRootFromParent_Done,
     /*  708092 */   // Label 11193: @708092
     /*  708092 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(708167), // Rule ID 11433 //
     /*  708097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  708117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708165 */     GIR_RootConstrainSelectedInstOperands,
     /*  708166 */     // GIR_Coverage, 11433,
     /*  708166 */     GIR_EraseRootFromParent_Done,
     /*  708167 */   // Label 11194: @708167
     /*  708167 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(708242), // Rule ID 11436 //
     /*  708172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  708192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708240 */     GIR_RootConstrainSelectedInstOperands,
     /*  708241 */     // GIR_Coverage, 11436,
     /*  708241 */     GIR_EraseRootFromParent_Done,
     /*  708242 */   // Label 11195: @708242
     /*  708242 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(708317), // Rule ID 11437 //
     /*  708247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  708267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708315 */     GIR_RootConstrainSelectedInstOperands,
     /*  708316 */     // GIR_Coverage, 11437,
     /*  708316 */     GIR_EraseRootFromParent_Done,
     /*  708317 */   // Label 11196: @708317
     /*  708317 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(708392), // Rule ID 11440 //
     /*  708322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  708333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  708336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  708339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  708342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708390 */     GIR_RootConstrainSelectedInstOperands,
     /*  708391 */     // GIR_Coverage, 11440,
     /*  708391 */     GIR_EraseRootFromParent_Done,
     /*  708392 */   // Label 11197: @708392
     /*  708392 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(708467), // Rule ID 11441 //
     /*  708397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  708408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  708411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  708414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  708417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  708446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708465 */     GIR_RootConstrainSelectedInstOperands,
     /*  708466 */     // GIR_Coverage, 11441,
     /*  708466 */     GIR_EraseRootFromParent_Done,
     /*  708467 */   // Label 11198: @708467
     /*  708467 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(708542), // Rule ID 11444 //
     /*  708472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708540 */     GIR_RootConstrainSelectedInstOperands,
     /*  708541 */     // GIR_Coverage, 11444,
     /*  708541 */     GIR_EraseRootFromParent_Done,
     /*  708542 */   // Label 11199: @708542
     /*  708542 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(708617), // Rule ID 11445 //
     /*  708547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708615 */     GIR_RootConstrainSelectedInstOperands,
     /*  708616 */     // GIR_Coverage, 11445,
     /*  708616 */     GIR_EraseRootFromParent_Done,
     /*  708617 */   // Label 11200: @708617
     /*  708617 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(708692), // Rule ID 11448 //
     /*  708622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708690 */     GIR_RootConstrainSelectedInstOperands,
     /*  708691 */     // GIR_Coverage, 11448,
     /*  708691 */     GIR_EraseRootFromParent_Done,
     /*  708692 */   // Label 11201: @708692
     /*  708692 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(708767), // Rule ID 11449 //
     /*  708697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708765 */     GIR_RootConstrainSelectedInstOperands,
     /*  708766 */     // GIR_Coverage, 11449,
     /*  708766 */     GIR_EraseRootFromParent_Done,
     /*  708767 */   // Label 11202: @708767
     /*  708767 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(708842), // Rule ID 11452 //
     /*  708772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708840 */     GIR_RootConstrainSelectedInstOperands,
     /*  708841 */     // GIR_Coverage, 11452,
     /*  708841 */     GIR_EraseRootFromParent_Done,
     /*  708842 */   // Label 11203: @708842
     /*  708842 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(708917), // Rule ID 11453 //
     /*  708847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708915 */     GIR_RootConstrainSelectedInstOperands,
     /*  708916 */     // GIR_Coverage, 11453,
     /*  708916 */     GIR_EraseRootFromParent_Done,
     /*  708917 */   // Label 11204: @708917
     /*  708917 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(708992), // Rule ID 11456 //
     /*  708922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708990 */     GIR_RootConstrainSelectedInstOperands,
     /*  708991 */     // GIR_Coverage, 11456,
     /*  708991 */     GIR_EraseRootFromParent_Done,
     /*  708992 */   // Label 11205: @708992
     /*  708992 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(709067), // Rule ID 11457 //
     /*  708997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  709017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709065 */     GIR_RootConstrainSelectedInstOperands,
     /*  709066 */     // GIR_Coverage, 11457,
     /*  709066 */     GIR_EraseRootFromParent_Done,
     /*  709067 */   // Label 11206: @709067
     /*  709067 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(709142), // Rule ID 11460 //
     /*  709072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  709092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709140 */     GIR_RootConstrainSelectedInstOperands,
     /*  709141 */     // GIR_Coverage, 11460,
     /*  709141 */     GIR_EraseRootFromParent_Done,
     /*  709142 */   // Label 11207: @709142
     /*  709142 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(709217), // Rule ID 11461 //
     /*  709147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  709167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  709196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709215 */     GIR_RootConstrainSelectedInstOperands,
     /*  709216 */     // GIR_Coverage, 11461,
     /*  709216 */     GIR_EraseRootFromParent_Done,
     /*  709217 */   // Label 11208: @709217
     /*  709217 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(709292), // Rule ID 11464 //
     /*  709222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  709242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709290 */     GIR_RootConstrainSelectedInstOperands,
     /*  709291 */     // GIR_Coverage, 11464,
     /*  709291 */     GIR_EraseRootFromParent_Done,
     /*  709292 */   // Label 11209: @709292
     /*  709292 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(709367), // Rule ID 11465 //
     /*  709297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  709317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709365 */     GIR_RootConstrainSelectedInstOperands,
     /*  709366 */     // GIR_Coverage, 11465,
     /*  709366 */     GIR_EraseRootFromParent_Done,
     /*  709367 */   // Label 11210: @709367
     /*  709367 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(709442), // Rule ID 11468 //
     /*  709372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  709383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  709386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  709389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709440 */     GIR_RootConstrainSelectedInstOperands,
     /*  709441 */     // GIR_Coverage, 11468,
     /*  709441 */     GIR_EraseRootFromParent_Done,
     /*  709442 */   // Label 11211: @709442
     /*  709442 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(709517), // Rule ID 11469 //
     /*  709447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  709458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  709461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  709464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709493 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709515 */     GIR_RootConstrainSelectedInstOperands,
     /*  709516 */     // GIR_Coverage, 11469,
     /*  709516 */     GIR_EraseRootFromParent_Done,
     /*  709517 */   // Label 11212: @709517
     /*  709517 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(709592), // Rule ID 11472 //
     /*  709522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709568 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709590 */     GIR_RootConstrainSelectedInstOperands,
     /*  709591 */     // GIR_Coverage, 11472,
     /*  709591 */     GIR_EraseRootFromParent_Done,
     /*  709592 */   // Label 11213: @709592
     /*  709592 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(709667), // Rule ID 11473 //
     /*  709597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709643 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709665 */     GIR_RootConstrainSelectedInstOperands,
     /*  709666 */     // GIR_Coverage, 11473,
     /*  709666 */     GIR_EraseRootFromParent_Done,
     /*  709667 */   // Label 11214: @709667
     /*  709667 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(709742), // Rule ID 11476 //
     /*  709672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709740 */     GIR_RootConstrainSelectedInstOperands,
     /*  709741 */     // GIR_Coverage, 11476,
     /*  709741 */     GIR_EraseRootFromParent_Done,
     /*  709742 */   // Label 11215: @709742
     /*  709742 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(709817), // Rule ID 11477 //
     /*  709747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709815 */     GIR_RootConstrainSelectedInstOperands,
     /*  709816 */     // GIR_Coverage, 11477,
     /*  709816 */     GIR_EraseRootFromParent_Done,
     /*  709817 */   // Label 11216: @709817
     /*  709817 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(709892), // Rule ID 11480 //
     /*  709822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709890 */     GIR_RootConstrainSelectedInstOperands,
     /*  709891 */     // GIR_Coverage, 11480,
     /*  709891 */     GIR_EraseRootFromParent_Done,
     /*  709892 */   // Label 11217: @709892
     /*  709892 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(709967), // Rule ID 11481 //
     /*  709897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709965 */     GIR_RootConstrainSelectedInstOperands,
     /*  709966 */     // GIR_Coverage, 11481,
     /*  709966 */     GIR_EraseRootFromParent_Done,
     /*  709967 */   // Label 11218: @709967
     /*  709967 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(710042), // Rule ID 11484 //
     /*  709972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710040 */     GIR_RootConstrainSelectedInstOperands,
     /*  710041 */     // GIR_Coverage, 11484,
     /*  710041 */     GIR_EraseRootFromParent_Done,
     /*  710042 */   // Label 11219: @710042
     /*  710042 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(710117), // Rule ID 11485 //
     /*  710047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  710067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710115 */     GIR_RootConstrainSelectedInstOperands,
     /*  710116 */     // GIR_Coverage, 11485,
     /*  710116 */     GIR_EraseRootFromParent_Done,
     /*  710117 */   // Label 11220: @710117
     /*  710117 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(710192), // Rule ID 11488 //
     /*  710122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  710142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  710171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710190 */     GIR_RootConstrainSelectedInstOperands,
     /*  710191 */     // GIR_Coverage, 11488,
     /*  710191 */     GIR_EraseRootFromParent_Done,
     /*  710192 */   // Label 11221: @710192
     /*  710192 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(710267), // Rule ID 11489 //
     /*  710197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  710217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  710246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710265 */     GIR_RootConstrainSelectedInstOperands,
     /*  710266 */     // GIR_Coverage, 11489,
     /*  710266 */     GIR_EraseRootFromParent_Done,
     /*  710267 */   // Label 11222: @710267
     /*  710267 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(710342), // Rule ID 11492 //
     /*  710272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  710292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  710321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710340 */     GIR_RootConstrainSelectedInstOperands,
     /*  710341 */     // GIR_Coverage, 11492,
     /*  710341 */     GIR_EraseRootFromParent_Done,
     /*  710342 */   // Label 11223: @710342
     /*  710342 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(710417), // Rule ID 11493 //
     /*  710347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  710367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710393 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  710396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710415 */     GIR_RootConstrainSelectedInstOperands,
     /*  710416 */     // GIR_Coverage, 11493,
     /*  710416 */     GIR_EraseRootFromParent_Done,
     /*  710417 */   // Label 11224: @710417
     /*  710417 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(710492), // Rule ID 11496 //
     /*  710422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710490 */     GIR_RootConstrainSelectedInstOperands,
     /*  710491 */     // GIR_Coverage, 11496,
     /*  710491 */     GIR_EraseRootFromParent_Done,
     /*  710492 */   // Label 11225: @710492
     /*  710492 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(710567), // Rule ID 11497 //
     /*  710497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710543 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710565 */     GIR_RootConstrainSelectedInstOperands,
     /*  710566 */     // GIR_Coverage, 11497,
     /*  710566 */     GIR_EraseRootFromParent_Done,
     /*  710567 */   // Label 11226: @710567
     /*  710567 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(710642), // Rule ID 11500 //
     /*  710572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710640 */     GIR_RootConstrainSelectedInstOperands,
     /*  710641 */     // GIR_Coverage, 11500,
     /*  710641 */     GIR_EraseRootFromParent_Done,
     /*  710642 */   // Label 11227: @710642
     /*  710642 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(710717), // Rule ID 11501 //
     /*  710647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710715 */     GIR_RootConstrainSelectedInstOperands,
     /*  710716 */     // GIR_Coverage, 11501,
     /*  710716 */     GIR_EraseRootFromParent_Done,
     /*  710717 */   // Label 11228: @710717
     /*  710717 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(710792), // Rule ID 11504 //
     /*  710722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710790 */     GIR_RootConstrainSelectedInstOperands,
     /*  710791 */     // GIR_Coverage, 11504,
     /*  710791 */     GIR_EraseRootFromParent_Done,
     /*  710792 */   // Label 11229: @710792
     /*  710792 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(710867), // Rule ID 11505 //
     /*  710797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710865 */     GIR_RootConstrainSelectedInstOperands,
     /*  710866 */     // GIR_Coverage, 11505,
     /*  710866 */     GIR_EraseRootFromParent_Done,
     /*  710867 */   // Label 11230: @710867
     /*  710867 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(710942), // Rule ID 11508 //
     /*  710872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710940 */     GIR_RootConstrainSelectedInstOperands,
     /*  710941 */     // GIR_Coverage, 11508,
     /*  710941 */     GIR_EraseRootFromParent_Done,
     /*  710942 */   // Label 11231: @710942
     /*  710942 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(711017), // Rule ID 11509 //
     /*  710947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711015 */     GIR_RootConstrainSelectedInstOperands,
     /*  711016 */     // GIR_Coverage, 11509,
     /*  711016 */     GIR_EraseRootFromParent_Done,
     /*  711017 */   // Label 11232: @711017
     /*  711017 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(711092), // Rule ID 11512 //
     /*  711022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  711071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711090 */     GIR_RootConstrainSelectedInstOperands,
     /*  711091 */     // GIR_Coverage, 11512,
     /*  711091 */     GIR_EraseRootFromParent_Done,
     /*  711092 */   // Label 11233: @711092
     /*  711092 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(711167), // Rule ID 11513 //
     /*  711097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  711146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711165 */     GIR_RootConstrainSelectedInstOperands,
     /*  711166 */     // GIR_Coverage, 11513,
     /*  711166 */     GIR_EraseRootFromParent_Done,
     /*  711167 */   // Label 11234: @711167
     /*  711167 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(711242), // Rule ID 11516 //
     /*  711172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711240 */     GIR_RootConstrainSelectedInstOperands,
     /*  711241 */     // GIR_Coverage, 11516,
     /*  711241 */     GIR_EraseRootFromParent_Done,
     /*  711242 */   // Label 11235: @711242
     /*  711242 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(711317), // Rule ID 11517 //
     /*  711247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711315 */     GIR_RootConstrainSelectedInstOperands,
     /*  711316 */     // GIR_Coverage, 11517,
     /*  711316 */     GIR_EraseRootFromParent_Done,
     /*  711317 */   // Label 11236: @711317
     /*  711317 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(711392), // Rule ID 11520 //
     /*  711322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  711333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  711336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  711339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711390 */     GIR_RootConstrainSelectedInstOperands,
     /*  711391 */     // GIR_Coverage, 11520,
     /*  711391 */     GIR_EraseRootFromParent_Done,
     /*  711392 */   // Label 11237: @711392
     /*  711392 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(711467), // Rule ID 11521 //
     /*  711397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  711408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  711411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  711414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  711446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711465 */     GIR_RootConstrainSelectedInstOperands,
     /*  711466 */     // GIR_Coverage, 11521,
     /*  711466 */     GIR_EraseRootFromParent_Done,
     /*  711467 */   // Label 11238: @711467
     /*  711467 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(711542), // Rule ID 11524 //
     /*  711472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711540 */     GIR_RootConstrainSelectedInstOperands,
     /*  711541 */     // GIR_Coverage, 11524,
     /*  711541 */     GIR_EraseRootFromParent_Done,
     /*  711542 */   // Label 11239: @711542
     /*  711542 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(711617), // Rule ID 11525 //
     /*  711547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711615 */     GIR_RootConstrainSelectedInstOperands,
     /*  711616 */     // GIR_Coverage, 11525,
     /*  711616 */     GIR_EraseRootFromParent_Done,
     /*  711617 */   // Label 11240: @711617
     /*  711617 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(711692), // Rule ID 11528 //
     /*  711622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711690 */     GIR_RootConstrainSelectedInstOperands,
     /*  711691 */     // GIR_Coverage, 11528,
     /*  711691 */     GIR_EraseRootFromParent_Done,
     /*  711692 */   // Label 11241: @711692
     /*  711692 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(711767), // Rule ID 11529 //
     /*  711697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711765 */     GIR_RootConstrainSelectedInstOperands,
     /*  711766 */     // GIR_Coverage, 11529,
     /*  711766 */     GIR_EraseRootFromParent_Done,
     /*  711767 */   // Label 11242: @711767
     /*  711767 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(711842), // Rule ID 11532 //
     /*  711772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711840 */     GIR_RootConstrainSelectedInstOperands,
     /*  711841 */     // GIR_Coverage, 11532,
     /*  711841 */     GIR_EraseRootFromParent_Done,
     /*  711842 */   // Label 11243: @711842
     /*  711842 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(711917), // Rule ID 11533 //
     /*  711847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711915 */     GIR_RootConstrainSelectedInstOperands,
     /*  711916 */     // GIR_Coverage, 11533,
     /*  711916 */     GIR_EraseRootFromParent_Done,
     /*  711917 */   // Label 11244: @711917
     /*  711917 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(711992), // Rule ID 11536 //
     /*  711922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711990 */     GIR_RootConstrainSelectedInstOperands,
     /*  711991 */     // GIR_Coverage, 11536,
     /*  711991 */     GIR_EraseRootFromParent_Done,
     /*  711992 */   // Label 11245: @711992
     /*  711992 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(712067), // Rule ID 11537 //
     /*  711997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712065 */     GIR_RootConstrainSelectedInstOperands,
     /*  712066 */     // GIR_Coverage, 11537,
     /*  712066 */     GIR_EraseRootFromParent_Done,
     /*  712067 */   // Label 11246: @712067
     /*  712067 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(712142), // Rule ID 11540 //
     /*  712072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712140 */     GIR_RootConstrainSelectedInstOperands,
     /*  712141 */     // GIR_Coverage, 11540,
     /*  712141 */     GIR_EraseRootFromParent_Done,
     /*  712142 */   // Label 11247: @712142
     /*  712142 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(712217), // Rule ID 11541 //
     /*  712147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712193 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712215 */     GIR_RootConstrainSelectedInstOperands,
     /*  712216 */     // GIR_Coverage, 11541,
     /*  712216 */     GIR_EraseRootFromParent_Done,
     /*  712217 */   // Label 11248: @712217
     /*  712217 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(712292), // Rule ID 11544 //
     /*  712222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712268 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712290 */     GIR_RootConstrainSelectedInstOperands,
     /*  712291 */     // GIR_Coverage, 11544,
     /*  712291 */     GIR_EraseRootFromParent_Done,
     /*  712292 */   // Label 11249: @712292
     /*  712292 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(712367), // Rule ID 11545 //
     /*  712297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712343 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712365 */     GIR_RootConstrainSelectedInstOperands,
     /*  712366 */     // GIR_Coverage, 11545,
     /*  712366 */     GIR_EraseRootFromParent_Done,
     /*  712367 */   // Label 11250: @712367
     /*  712367 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(712442), // Rule ID 11548 //
     /*  712372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  712383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  712386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  712389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712440 */     GIR_RootConstrainSelectedInstOperands,
     /*  712441 */     // GIR_Coverage, 11548,
     /*  712441 */     GIR_EraseRootFromParent_Done,
     /*  712442 */   // Label 11251: @712442
     /*  712442 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(712517), // Rule ID 11549 //
     /*  712447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  712458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  712461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  712464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712493 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712515 */     GIR_RootConstrainSelectedInstOperands,
     /*  712516 */     // GIR_Coverage, 11549,
     /*  712516 */     GIR_EraseRootFromParent_Done,
     /*  712517 */   // Label 11252: @712517
     /*  712517 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(712592), // Rule ID 11552 //
     /*  712522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712590 */     GIR_RootConstrainSelectedInstOperands,
     /*  712591 */     // GIR_Coverage, 11552,
     /*  712591 */     GIR_EraseRootFromParent_Done,
     /*  712592 */   // Label 11253: @712592
     /*  712592 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(712667), // Rule ID 11553 //
     /*  712597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712643 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712665 */     GIR_RootConstrainSelectedInstOperands,
     /*  712666 */     // GIR_Coverage, 11553,
     /*  712666 */     GIR_EraseRootFromParent_Done,
     /*  712667 */   // Label 11254: @712667
     /*  712667 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(712742), // Rule ID 11556 //
     /*  712672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712740 */     GIR_RootConstrainSelectedInstOperands,
     /*  712741 */     // GIR_Coverage, 11556,
     /*  712741 */     GIR_EraseRootFromParent_Done,
     /*  712742 */   // Label 11255: @712742
     /*  712742 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(712817), // Rule ID 11557 //
     /*  712747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712793 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712815 */     GIR_RootConstrainSelectedInstOperands,
     /*  712816 */     // GIR_Coverage, 11557,
     /*  712816 */     GIR_EraseRootFromParent_Done,
     /*  712817 */   // Label 11256: @712817
     /*  712817 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(712892), // Rule ID 11560 //
     /*  712822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712890 */     GIR_RootConstrainSelectedInstOperands,
     /*  712891 */     // GIR_Coverage, 11560,
     /*  712891 */     GIR_EraseRootFromParent_Done,
     /*  712892 */   // Label 11257: @712892
     /*  712892 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(712967), // Rule ID 11561 //
     /*  712897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712965 */     GIR_RootConstrainSelectedInstOperands,
     /*  712966 */     // GIR_Coverage, 11561,
     /*  712966 */     GIR_EraseRootFromParent_Done,
     /*  712967 */   // Label 11258: @712967
     /*  712967 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(713042), // Rule ID 11564 //
     /*  712972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  713021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713040 */     GIR_RootConstrainSelectedInstOperands,
     /*  713041 */     // GIR_Coverage, 11564,
     /*  713041 */     GIR_EraseRootFromParent_Done,
     /*  713042 */   // Label 11259: @713042
     /*  713042 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(713117), // Rule ID 11565 //
     /*  713047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713093 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  713096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713115 */     GIR_RootConstrainSelectedInstOperands,
     /*  713116 */     // GIR_Coverage, 11565,
     /*  713116 */     GIR_EraseRootFromParent_Done,
     /*  713117 */   // Label 11260: @713117
     /*  713117 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(713192), // Rule ID 11568 //
     /*  713122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  713171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713190 */     GIR_RootConstrainSelectedInstOperands,
     /*  713191 */     // GIR_Coverage, 11568,
     /*  713191 */     GIR_EraseRootFromParent_Done,
     /*  713192 */   // Label 11261: @713192
     /*  713192 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(713267), // Rule ID 11569 //
     /*  713197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713243 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  713246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713265 */     GIR_RootConstrainSelectedInstOperands,
     /*  713266 */     // GIR_Coverage, 11569,
     /*  713266 */     GIR_EraseRootFromParent_Done,
     /*  713267 */   // Label 11262: @713267
     /*  713267 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(713342), // Rule ID 11572 //
     /*  713272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  713321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713340 */     GIR_RootConstrainSelectedInstOperands,
     /*  713341 */     // GIR_Coverage, 11572,
     /*  713341 */     GIR_EraseRootFromParent_Done,
     /*  713342 */   // Label 11263: @713342
     /*  713342 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(713417), // Rule ID 11573 //
     /*  713347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  713396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713415 */     GIR_RootConstrainSelectedInstOperands,
     /*  713416 */     // GIR_Coverage, 11573,
     /*  713416 */     GIR_EraseRootFromParent_Done,
     /*  713417 */   // Label 11264: @713417
     /*  713417 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(713492), // Rule ID 11576 //
     /*  713422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713490 */     GIR_RootConstrainSelectedInstOperands,
     /*  713491 */     // GIR_Coverage, 11576,
     /*  713491 */     GIR_EraseRootFromParent_Done,
     /*  713492 */   // Label 11265: @713492
     /*  713492 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(713567), // Rule ID 11577 //
     /*  713497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713565 */     GIR_RootConstrainSelectedInstOperands,
     /*  713566 */     // GIR_Coverage, 11577,
     /*  713566 */     GIR_EraseRootFromParent_Done,
     /*  713567 */   // Label 11266: @713567
     /*  713567 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(713642), // Rule ID 11580 //
     /*  713572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713640 */     GIR_RootConstrainSelectedInstOperands,
     /*  713641 */     // GIR_Coverage, 11580,
     /*  713641 */     GIR_EraseRootFromParent_Done,
     /*  713642 */   // Label 11267: @713642
     /*  713642 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(713717), // Rule ID 11581 //
     /*  713647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713715 */     GIR_RootConstrainSelectedInstOperands,
     /*  713716 */     // GIR_Coverage, 11581,
     /*  713716 */     GIR_EraseRootFromParent_Done,
     /*  713717 */   // Label 11268: @713717
     /*  713717 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(713792), // Rule ID 11584 //
     /*  713722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713790 */     GIR_RootConstrainSelectedInstOperands,
     /*  713791 */     // GIR_Coverage, 11584,
     /*  713791 */     GIR_EraseRootFromParent_Done,
     /*  713792 */   // Label 11269: @713792
     /*  713792 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(713867), // Rule ID 11585 //
     /*  713797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713865 */     GIR_RootConstrainSelectedInstOperands,
     /*  713866 */     // GIR_Coverage, 11585,
     /*  713866 */     GIR_EraseRootFromParent_Done,
     /*  713867 */   // Label 11270: @713867
     /*  713867 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(713942), // Rule ID 11588 //
     /*  713872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713940 */     GIR_RootConstrainSelectedInstOperands,
     /*  713941 */     // GIR_Coverage, 11588,
     /*  713941 */     GIR_EraseRootFromParent_Done,
     /*  713942 */   // Label 11271: @713942
     /*  713942 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(714017), // Rule ID 11589 //
     /*  713947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714015 */     GIR_RootConstrainSelectedInstOperands,
     /*  714016 */     // GIR_Coverage, 11589,
     /*  714016 */     GIR_EraseRootFromParent_Done,
     /*  714017 */   // Label 11272: @714017
     /*  714017 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(714092), // Rule ID 11592 //
     /*  714022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  714071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714090 */     GIR_RootConstrainSelectedInstOperands,
     /*  714091 */     // GIR_Coverage, 11592,
     /*  714091 */     GIR_EraseRootFromParent_Done,
     /*  714092 */   // Label 11273: @714092
     /*  714092 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(714167), // Rule ID 11593 //
     /*  714097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  714146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714165 */     GIR_RootConstrainSelectedInstOperands,
     /*  714166 */     // GIR_Coverage, 11593,
     /*  714166 */     GIR_EraseRootFromParent_Done,
     /*  714167 */   // Label 11274: @714167
     /*  714167 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(714242), // Rule ID 11596 //
     /*  714172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  714221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714240 */     GIR_RootConstrainSelectedInstOperands,
     /*  714241 */     // GIR_Coverage, 11596,
     /*  714241 */     GIR_EraseRootFromParent_Done,
     /*  714242 */   // Label 11275: @714242
     /*  714242 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(714317), // Rule ID 11597 //
     /*  714247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  714296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714315 */     GIR_RootConstrainSelectedInstOperands,
     /*  714316 */     // GIR_Coverage, 11597,
     /*  714316 */     GIR_EraseRootFromParent_Done,
     /*  714317 */   // Label 11276: @714317
     /*  714317 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(714392), // Rule ID 11600 //
     /*  714322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  714371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714390 */     GIR_RootConstrainSelectedInstOperands,
     /*  714391 */     // GIR_Coverage, 11600,
     /*  714391 */     GIR_EraseRootFromParent_Done,
     /*  714392 */   // Label 11277: @714392
     /*  714392 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(714467), // Rule ID 11601 //
     /*  714397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  714405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  714446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714465 */     GIR_RootConstrainSelectedInstOperands,
     /*  714466 */     // GIR_Coverage, 11601,
     /*  714466 */     GIR_EraseRootFromParent_Done,
     /*  714467 */   // Label 11278: @714467
     /*  714467 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(714542), // Rule ID 11604 //
     /*  714472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714540 */     GIR_RootConstrainSelectedInstOperands,
     /*  714541 */     // GIR_Coverage, 11604,
     /*  714541 */     GIR_EraseRootFromParent_Done,
     /*  714542 */   // Label 11279: @714542
     /*  714542 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(714617), // Rule ID 11605 //
     /*  714547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714593 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714615 */     GIR_RootConstrainSelectedInstOperands,
     /*  714616 */     // GIR_Coverage, 11605,
     /*  714616 */     GIR_EraseRootFromParent_Done,
     /*  714617 */   // Label 11280: @714617
     /*  714617 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(714692), // Rule ID 11608 //
     /*  714622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714690 */     GIR_RootConstrainSelectedInstOperands,
     /*  714691 */     // GIR_Coverage, 11608,
     /*  714691 */     GIR_EraseRootFromParent_Done,
     /*  714692 */   // Label 11281: @714692
     /*  714692 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(714767), // Rule ID 11609 //
     /*  714697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714765 */     GIR_RootConstrainSelectedInstOperands,
     /*  714766 */     // GIR_Coverage, 11609,
     /*  714766 */     GIR_EraseRootFromParent_Done,
     /*  714767 */   // Label 11282: @714767
     /*  714767 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(714842), // Rule ID 11612 //
     /*  714772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714840 */     GIR_RootConstrainSelectedInstOperands,
     /*  714841 */     // GIR_Coverage, 11612,
     /*  714841 */     GIR_EraseRootFromParent_Done,
     /*  714842 */   // Label 11283: @714842
     /*  714842 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(714917), // Rule ID 11613 //
     /*  714847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714915 */     GIR_RootConstrainSelectedInstOperands,
     /*  714916 */     // GIR_Coverage, 11613,
     /*  714916 */     GIR_EraseRootFromParent_Done,
     /*  714917 */   // Label 11284: @714917
     /*  714917 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(714992), // Rule ID 11616 //
     /*  714922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714990 */     GIR_RootConstrainSelectedInstOperands,
     /*  714991 */     // GIR_Coverage, 11616,
     /*  714991 */     GIR_EraseRootFromParent_Done,
     /*  714992 */   // Label 11285: @714992
     /*  714992 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(715067), // Rule ID 11617 //
     /*  714997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  715046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715065 */     GIR_RootConstrainSelectedInstOperands,
     /*  715066 */     // GIR_Coverage, 11617,
     /*  715066 */     GIR_EraseRootFromParent_Done,
     /*  715067 */   // Label 11286: @715067
     /*  715067 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(715142), // Rule ID 11620 //
     /*  715072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  715121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715140 */     GIR_RootConstrainSelectedInstOperands,
     /*  715141 */     // GIR_Coverage, 11620,
     /*  715141 */     GIR_EraseRootFromParent_Done,
     /*  715142 */   // Label 11287: @715142
     /*  715142 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(715217), // Rule ID 11621 //
     /*  715147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715193 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  715196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715215 */     GIR_RootConstrainSelectedInstOperands,
     /*  715216 */     // GIR_Coverage, 11621,
     /*  715216 */     GIR_EraseRootFromParent_Done,
     /*  715217 */   // Label 11288: @715217
     /*  715217 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(715292), // Rule ID 11624 //
     /*  715222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  715271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715290 */     GIR_RootConstrainSelectedInstOperands,
     /*  715291 */     // GIR_Coverage, 11624,
     /*  715291 */     GIR_EraseRootFromParent_Done,
     /*  715292 */   // Label 11289: @715292
     /*  715292 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(715367), // Rule ID 11625 //
     /*  715297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  715346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715365 */     GIR_RootConstrainSelectedInstOperands,
     /*  715366 */     // GIR_Coverage, 11625,
     /*  715366 */     GIR_EraseRootFromParent_Done,
     /*  715367 */   // Label 11290: @715367
     /*  715367 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(715442), // Rule ID 11628 //
     /*  715372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715440 */     GIR_RootConstrainSelectedInstOperands,
     /*  715441 */     // GIR_Coverage, 11628,
     /*  715441 */     GIR_EraseRootFromParent_Done,
     /*  715442 */   // Label 11291: @715442
     /*  715442 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(715517), // Rule ID 11629 //
     /*  715447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715515 */     GIR_RootConstrainSelectedInstOperands,
     /*  715516 */     // GIR_Coverage, 11629,
     /*  715516 */     GIR_EraseRootFromParent_Done,
     /*  715517 */   // Label 11292: @715517
     /*  715517 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(715592), // Rule ID 11632 //
     /*  715522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715590 */     GIR_RootConstrainSelectedInstOperands,
     /*  715591 */     // GIR_Coverage, 11632,
     /*  715591 */     GIR_EraseRootFromParent_Done,
     /*  715592 */   // Label 11293: @715592
     /*  715592 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(715667), // Rule ID 11633 //
     /*  715597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715665 */     GIR_RootConstrainSelectedInstOperands,
     /*  715666 */     // GIR_Coverage, 11633,
     /*  715666 */     GIR_EraseRootFromParent_Done,
     /*  715667 */   // Label 11294: @715667
     /*  715667 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(715742), // Rule ID 11636 //
     /*  715672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715740 */     GIR_RootConstrainSelectedInstOperands,
     /*  715741 */     // GIR_Coverage, 11636,
     /*  715741 */     GIR_EraseRootFromParent_Done,
     /*  715742 */   // Label 11295: @715742
     /*  715742 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(715817), // Rule ID 11637 //
     /*  715747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715793 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715815 */     GIR_RootConstrainSelectedInstOperands,
     /*  715816 */     // GIR_Coverage, 11637,
     /*  715816 */     GIR_EraseRootFromParent_Done,
     /*  715817 */   // Label 11296: @715817
     /*  715817 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(715892), // Rule ID 11640 //
     /*  715822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715890 */     GIR_RootConstrainSelectedInstOperands,
     /*  715891 */     // GIR_Coverage, 11640,
     /*  715891 */     GIR_EraseRootFromParent_Done,
     /*  715892 */   // Label 11297: @715892
     /*  715892 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(715967), // Rule ID 11641 //
     /*  715897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715965 */     GIR_RootConstrainSelectedInstOperands,
     /*  715966 */     // GIR_Coverage, 11641,
     /*  715966 */     GIR_EraseRootFromParent_Done,
     /*  715967 */   // Label 11298: @715967
     /*  715967 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(716042), // Rule ID 11644 //
     /*  715972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  716021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716040 */     GIR_RootConstrainSelectedInstOperands,
     /*  716041 */     // GIR_Coverage, 11644,
     /*  716041 */     GIR_EraseRootFromParent_Done,
     /*  716042 */   // Label 11299: @716042
     /*  716042 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(716117), // Rule ID 11645 //
     /*  716047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  716067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  716096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716115 */     GIR_RootConstrainSelectedInstOperands,
     /*  716116 */     // GIR_Coverage, 11645,
     /*  716116 */     GIR_EraseRootFromParent_Done,
     /*  716117 */   // Label 11300: @716117
     /*  716117 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(716192), // Rule ID 11648 //
     /*  716122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  716142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  716171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716190 */     GIR_RootConstrainSelectedInstOperands,
     /*  716191 */     // GIR_Coverage, 11648,
     /*  716191 */     GIR_EraseRootFromParent_Done,
     /*  716192 */   // Label 11301: @716192
     /*  716192 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(716267), // Rule ID 11649 //
     /*  716197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  716217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  716246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716265 */     GIR_RootConstrainSelectedInstOperands,
     /*  716266 */     // GIR_Coverage, 11649,
     /*  716266 */     GIR_EraseRootFromParent_Done,
     /*  716267 */   // Label 11302: @716267
     /*  716267 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(716342), // Rule ID 11652 //
     /*  716272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716318 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  716321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716340 */     GIR_RootConstrainSelectedInstOperands,
     /*  716341 */     // GIR_Coverage, 11652,
     /*  716341 */     GIR_EraseRootFromParent_Done,
     /*  716342 */   // Label 11303: @716342
     /*  716342 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(716417), // Rule ID 11653 //
     /*  716347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716393 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  716396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716415 */     GIR_RootConstrainSelectedInstOperands,
     /*  716416 */     // GIR_Coverage, 11653,
     /*  716416 */     GIR_EraseRootFromParent_Done,
     /*  716417 */   // Label 11304: @716417
     /*  716417 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(716492), // Rule ID 11656 //
     /*  716422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716490 */     GIR_RootConstrainSelectedInstOperands,
     /*  716491 */     // GIR_Coverage, 11656,
     /*  716491 */     GIR_EraseRootFromParent_Done,
     /*  716492 */   // Label 11305: @716492
     /*  716492 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(716567), // Rule ID 11657 //
     /*  716497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716565 */     GIR_RootConstrainSelectedInstOperands,
     /*  716566 */     // GIR_Coverage, 11657,
     /*  716566 */     GIR_EraseRootFromParent_Done,
     /*  716567 */   // Label 11306: @716567
     /*  716567 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(716642), // Rule ID 11660 //
     /*  716572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716640 */     GIR_RootConstrainSelectedInstOperands,
     /*  716641 */     // GIR_Coverage, 11660,
     /*  716641 */     GIR_EraseRootFromParent_Done,
     /*  716642 */   // Label 11307: @716642
     /*  716642 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(716717), // Rule ID 11661 //
     /*  716647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716715 */     GIR_RootConstrainSelectedInstOperands,
     /*  716716 */     // GIR_Coverage, 11661,
     /*  716716 */     GIR_EraseRootFromParent_Done,
     /*  716717 */   // Label 11308: @716717
     /*  716717 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(716792), // Rule ID 11664 //
     /*  716722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716790 */     GIR_RootConstrainSelectedInstOperands,
     /*  716791 */     // GIR_Coverage, 11664,
     /*  716791 */     GIR_EraseRootFromParent_Done,
     /*  716792 */   // Label 11309: @716792
     /*  716792 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(716867), // Rule ID 11665 //
     /*  716797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716865 */     GIR_RootConstrainSelectedInstOperands,
     /*  716866 */     // GIR_Coverage, 11665,
     /*  716866 */     GIR_EraseRootFromParent_Done,
     /*  716867 */   // Label 11310: @716867
     /*  716867 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(716942), // Rule ID 11668 //
     /*  716872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716940 */     GIR_RootConstrainSelectedInstOperands,
     /*  716941 */     // GIR_Coverage, 11668,
     /*  716941 */     GIR_EraseRootFromParent_Done,
     /*  716942 */   // Label 11311: @716942
     /*  716942 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(717017), // Rule ID 11669 //
     /*  716947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717015 */     GIR_RootConstrainSelectedInstOperands,
     /*  717016 */     // GIR_Coverage, 11669,
     /*  717016 */     GIR_EraseRootFromParent_Done,
     /*  717017 */   // Label 11312: @717017
     /*  717017 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(717092), // Rule ID 11672 //
     /*  717022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  717033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  717036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  717039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  717042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  717071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717090 */     GIR_RootConstrainSelectedInstOperands,
     /*  717091 */     // GIR_Coverage, 11672,
     /*  717091 */     GIR_EraseRootFromParent_Done,
     /*  717092 */   // Label 11313: @717092
     /*  717092 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(717167), // Rule ID 11673 //
     /*  717097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  717108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  717111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  717114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  717117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  717146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717165 */     GIR_RootConstrainSelectedInstOperands,
     /*  717166 */     // GIR_Coverage, 11673,
     /*  717166 */     GIR_EraseRootFromParent_Done,
     /*  717167 */   // Label 11314: @717167
     /*  717167 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(717242), // Rule ID 11676 //
     /*  717172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  717183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  717186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  717189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  717192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  717221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717240 */     GIR_RootConstrainSelectedInstOperands,
     /*  717241 */     // GIR_Coverage, 11676,
     /*  717241 */     GIR_EraseRootFromParent_Done,
     /*  717242 */   // Label 11315: @717242
     /*  717242 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(717317), // Rule ID 11677 //
     /*  717247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  717258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  717261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  717264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  717267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  717296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717315 */     GIR_RootConstrainSelectedInstOperands,
     /*  717316 */     // GIR_Coverage, 11677,
     /*  717316 */     GIR_EraseRootFromParent_Done,
     /*  717317 */   // Label 11316: @717317
     /*  717317 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(717392), // Rule ID 11680 //
     /*  717322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  717333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  717336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  717339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  717342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  717371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717390 */     GIR_RootConstrainSelectedInstOperands,
     /*  717391 */     // GIR_Coverage, 11680,
     /*  717391 */     GIR_EraseRootFromParent_Done,
     /*  717392 */   // Label 11317: @717392
     /*  717392 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(717467), // Rule ID 11681 //
     /*  717397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  717408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  717411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  717414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  717417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  717446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717465 */     GIR_RootConstrainSelectedInstOperands,
     /*  717466 */     // GIR_Coverage, 11681,
     /*  717466 */     GIR_EraseRootFromParent_Done,
     /*  717467 */   // Label 11318: @717467
     /*  717467 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(717542), // Rule ID 11684 //
     /*  717472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717540 */     GIR_RootConstrainSelectedInstOperands,
     /*  717541 */     // GIR_Coverage, 11684,
     /*  717541 */     GIR_EraseRootFromParent_Done,
     /*  717542 */   // Label 11319: @717542
     /*  717542 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(717617), // Rule ID 11685 //
     /*  717547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717615 */     GIR_RootConstrainSelectedInstOperands,
     /*  717616 */     // GIR_Coverage, 11685,
     /*  717616 */     GIR_EraseRootFromParent_Done,
     /*  717617 */   // Label 11320: @717617
     /*  717617 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(717692), // Rule ID 11688 //
     /*  717622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717690 */     GIR_RootConstrainSelectedInstOperands,
     /*  717691 */     // GIR_Coverage, 11688,
     /*  717691 */     GIR_EraseRootFromParent_Done,
     /*  717692 */   // Label 11321: @717692
     /*  717692 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(717767), // Rule ID 11689 //
     /*  717697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717765 */     GIR_RootConstrainSelectedInstOperands,
     /*  717766 */     // GIR_Coverage, 11689,
     /*  717766 */     GIR_EraseRootFromParent_Done,
     /*  717767 */   // Label 11322: @717767
     /*  717767 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(717842), // Rule ID 11692 //
     /*  717772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717840 */     GIR_RootConstrainSelectedInstOperands,
     /*  717841 */     // GIR_Coverage, 11692,
     /*  717841 */     GIR_EraseRootFromParent_Done,
     /*  717842 */   // Label 11323: @717842
     /*  717842 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(717917), // Rule ID 11693 //
     /*  717847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717915 */     GIR_RootConstrainSelectedInstOperands,
     /*  717916 */     // GIR_Coverage, 11693,
     /*  717916 */     GIR_EraseRootFromParent_Done,
     /*  717917 */   // Label 11324: @717917
     /*  717917 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(717992), // Rule ID 11696 //
     /*  717922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717990 */     GIR_RootConstrainSelectedInstOperands,
     /*  717991 */     // GIR_Coverage, 11696,
     /*  717991 */     GIR_EraseRootFromParent_Done,
     /*  717992 */   // Label 11325: @717992
     /*  717992 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(718067), // Rule ID 11697 //
     /*  717997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  718008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  718011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  718014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  718017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  718046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718065 */     GIR_RootConstrainSelectedInstOperands,
     /*  718066 */     // GIR_Coverage, 11697,
     /*  718066 */     GIR_EraseRootFromParent_Done,
     /*  718067 */   // Label 11326: @718067
     /*  718067 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(718142), // Rule ID 11700 //
     /*  718072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  718083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  718086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  718089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  718092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  718121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718140 */     GIR_RootConstrainSelectedInstOperands,
     /*  718141 */     // GIR_Coverage, 11700,
     /*  718141 */     GIR_EraseRootFromParent_Done,
     /*  718142 */   // Label 11327: @718142
     /*  718142 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(718217), // Rule ID 11701 //
     /*  718147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  718158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  718161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  718164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  718167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  718196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718215 */     GIR_RootConstrainSelectedInstOperands,
     /*  718216 */     // GIR_Coverage, 11701,
     /*  718216 */     GIR_EraseRootFromParent_Done,
     /*  718217 */   // Label 11328: @718217
     /*  718217 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(718292), // Rule ID 11704 //
     /*  718222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  718271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718290 */     GIR_RootConstrainSelectedInstOperands,
     /*  718291 */     // GIR_Coverage, 11704,
     /*  718291 */     GIR_EraseRootFromParent_Done,
     /*  718292 */   // Label 11329: @718292
     /*  718292 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(718367), // Rule ID 11705 //
     /*  718297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  718317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  718346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718365 */     GIR_RootConstrainSelectedInstOperands,
     /*  718366 */     // GIR_Coverage, 11705,
     /*  718366 */     GIR_EraseRootFromParent_Done,
     /*  718367 */   // Label 11330: @718367
     /*  718367 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(718442), // Rule ID 11708 //
     /*  718372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  718383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  718386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  718389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718440 */     GIR_RootConstrainSelectedInstOperands,
     /*  718441 */     // GIR_Coverage, 11708,
     /*  718441 */     GIR_EraseRootFromParent_Done,
     /*  718442 */   // Label 11331: @718442
     /*  718442 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(718517), // Rule ID 11709 //
     /*  718447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  718458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  718461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  718464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718515 */     GIR_RootConstrainSelectedInstOperands,
     /*  718516 */     // GIR_Coverage, 11709,
     /*  718516 */     GIR_EraseRootFromParent_Done,
     /*  718517 */   // Label 11332: @718517
     /*  718517 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(718592), // Rule ID 11712 //
     /*  718522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718590 */     GIR_RootConstrainSelectedInstOperands,
     /*  718591 */     // GIR_Coverage, 11712,
     /*  718591 */     GIR_EraseRootFromParent_Done,
     /*  718592 */   // Label 11333: @718592
     /*  718592 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(718667), // Rule ID 11713 //
     /*  718597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718665 */     GIR_RootConstrainSelectedInstOperands,
     /*  718666 */     // GIR_Coverage, 11713,
     /*  718666 */     GIR_EraseRootFromParent_Done,
     /*  718667 */   // Label 11334: @718667
     /*  718667 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(718742), // Rule ID 11716 //
     /*  718672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718740 */     GIR_RootConstrainSelectedInstOperands,
     /*  718741 */     // GIR_Coverage, 11716,
     /*  718741 */     GIR_EraseRootFromParent_Done,
     /*  718742 */   // Label 11335: @718742
     /*  718742 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(718817), // Rule ID 11717 //
     /*  718747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718815 */     GIR_RootConstrainSelectedInstOperands,
     /*  718816 */     // GIR_Coverage, 11717,
     /*  718816 */     GIR_EraseRootFromParent_Done,
     /*  718817 */   // Label 11336: @718817
     /*  718817 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(718892), // Rule ID 11720 //
     /*  718822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718890 */     GIR_RootConstrainSelectedInstOperands,
     /*  718891 */     // GIR_Coverage, 11720,
     /*  718891 */     GIR_EraseRootFromParent_Done,
     /*  718892 */   // Label 11337: @718892
     /*  718892 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(718967), // Rule ID 11721 //
     /*  718897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718965 */     GIR_RootConstrainSelectedInstOperands,
     /*  718966 */     // GIR_Coverage, 11721,
     /*  718966 */     GIR_EraseRootFromParent_Done,
     /*  718967 */   // Label 11338: @718967
     /*  718967 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(719042), // Rule ID 11724 //
     /*  718972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  719021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719040 */     GIR_RootConstrainSelectedInstOperands,
     /*  719041 */     // GIR_Coverage, 11724,
     /*  719041 */     GIR_EraseRootFromParent_Done,
     /*  719042 */   // Label 11339: @719042
     /*  719042 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(719117), // Rule ID 11725 //
     /*  719047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  719058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  719061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  719064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  719067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  719096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719115 */     GIR_RootConstrainSelectedInstOperands,
     /*  719116 */     // GIR_Coverage, 11725,
     /*  719116 */     GIR_EraseRootFromParent_Done,
     /*  719117 */   // Label 11340: @719117
     /*  719117 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(719192), // Rule ID 11728 //
     /*  719122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  719133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  719136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  719139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  719142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  719171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719190 */     GIR_RootConstrainSelectedInstOperands,
     /*  719191 */     // GIR_Coverage, 11728,
     /*  719191 */     GIR_EraseRootFromParent_Done,
     /*  719192 */   // Label 11341: @719192
     /*  719192 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(719267), // Rule ID 11729 //
     /*  719197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  719208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  719211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  719214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  719217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  719246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719265 */     GIR_RootConstrainSelectedInstOperands,
     /*  719266 */     // GIR_Coverage, 11729,
     /*  719266 */     GIR_EraseRootFromParent_Done,
     /*  719267 */   // Label 11342: @719267
     /*  719267 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(719342), // Rule ID 11732 //
     /*  719272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  719283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  719286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  719289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  719292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  719321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719340 */     GIR_RootConstrainSelectedInstOperands,
     /*  719341 */     // GIR_Coverage, 11732,
     /*  719341 */     GIR_EraseRootFromParent_Done,
     /*  719342 */   // Label 11343: @719342
     /*  719342 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(719417), // Rule ID 11733 //
     /*  719347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  719358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  719361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  719364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  719367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  719396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719415 */     GIR_RootConstrainSelectedInstOperands,
     /*  719416 */     // GIR_Coverage, 11733,
     /*  719416 */     GIR_EraseRootFromParent_Done,
     /*  719417 */   // Label 11344: @719417
     /*  719417 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(719492), // Rule ID 11736 //
     /*  719422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719490 */     GIR_RootConstrainSelectedInstOperands,
     /*  719491 */     // GIR_Coverage, 11736,
     /*  719491 */     GIR_EraseRootFromParent_Done,
     /*  719492 */   // Label 11345: @719492
     /*  719492 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(719567), // Rule ID 11737 //
     /*  719497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719565 */     GIR_RootConstrainSelectedInstOperands,
     /*  719566 */     // GIR_Coverage, 11737,
     /*  719566 */     GIR_EraseRootFromParent_Done,
     /*  719567 */   // Label 11346: @719567
     /*  719567 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(719642), // Rule ID 11740 //
     /*  719572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719640 */     GIR_RootConstrainSelectedInstOperands,
     /*  719641 */     // GIR_Coverage, 11740,
     /*  719641 */     GIR_EraseRootFromParent_Done,
     /*  719642 */   // Label 11347: @719642
     /*  719642 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(719717), // Rule ID 11741 //
     /*  719647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719715 */     GIR_RootConstrainSelectedInstOperands,
     /*  719716 */     // GIR_Coverage, 11741,
     /*  719716 */     GIR_EraseRootFromParent_Done,
     /*  719717 */   // Label 11348: @719717
     /*  719717 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(719792), // Rule ID 11744 //
     /*  719722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719790 */     GIR_RootConstrainSelectedInstOperands,
     /*  719791 */     // GIR_Coverage, 11744,
     /*  719791 */     GIR_EraseRootFromParent_Done,
     /*  719792 */   // Label 11349: @719792
     /*  719792 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(719867), // Rule ID 11745 //
     /*  719797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719865 */     GIR_RootConstrainSelectedInstOperands,
     /*  719866 */     // GIR_Coverage, 11745,
     /*  719866 */     GIR_EraseRootFromParent_Done,
     /*  719867 */   // Label 11350: @719867
     /*  719867 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(719942), // Rule ID 11748 //
     /*  719872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719940 */     GIR_RootConstrainSelectedInstOperands,
     /*  719941 */     // GIR_Coverage, 11748,
     /*  719941 */     GIR_EraseRootFromParent_Done,
     /*  719942 */   // Label 11351: @719942
     /*  719942 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(720017), // Rule ID 11749 //
     /*  719947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719993 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720015 */     GIR_RootConstrainSelectedInstOperands,
     /*  720016 */     // GIR_Coverage, 11749,
     /*  720016 */     GIR_EraseRootFromParent_Done,
     /*  720017 */   // Label 11352: @720017
     /*  720017 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(720092), // Rule ID 11752 //
     /*  720022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  720025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  720042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  720068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  720071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720090 */     GIR_RootConstrainSelectedInstOperands,
     /*  720091 */     // GIR_Coverage, 11752,
     /*  720091 */     GIR_EraseRootFromParent_Done,
     /*  720092 */   // Label 11353: @720092
     /*  720092 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(720167), // Rule ID 11753 //
     /*  720097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  720100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  720117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  720146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720165 */     GIR_RootConstrainSelectedInstOperands,
     /*  720166 */     // GIR_Coverage, 11753,
     /*  720166 */     GIR_EraseRootFromParent_Done,
     /*  720167 */   // Label 11354: @720167
     /*  720167 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(720242), // Rule ID 11756 //
     /*  720172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  720221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720240 */     GIR_RootConstrainSelectedInstOperands,
     /*  720241 */     // GIR_Coverage, 11756,
     /*  720241 */     GIR_EraseRootFromParent_Done,
     /*  720242 */   // Label 11355: @720242
     /*  720242 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(720317), // Rule ID 11757 //
     /*  720247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  720296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720315 */     GIR_RootConstrainSelectedInstOperands,
     /*  720316 */     // GIR_Coverage, 11757,
     /*  720316 */     GIR_EraseRootFromParent_Done,
     /*  720317 */   // Label 11356: @720317
     /*  720317 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(720392), // Rule ID 11760 //
     /*  720322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  720371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720390 */     GIR_RootConstrainSelectedInstOperands,
     /*  720391 */     // GIR_Coverage, 11760,
     /*  720391 */     GIR_EraseRootFromParent_Done,
     /*  720392 */   // Label 11357: @720392
     /*  720392 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(720467), // Rule ID 11761 //
     /*  720397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  720446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720465 */     GIR_RootConstrainSelectedInstOperands,
     /*  720466 */     // GIR_Coverage, 11761,
     /*  720466 */     GIR_EraseRootFromParent_Done,
     /*  720467 */   // Label 11358: @720467
     /*  720467 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(720542), // Rule ID 11764 //
     /*  720472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720540 */     GIR_RootConstrainSelectedInstOperands,
     /*  720541 */     // GIR_Coverage, 11764,
     /*  720541 */     GIR_EraseRootFromParent_Done,
     /*  720542 */   // Label 11359: @720542
     /*  720542 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(720617), // Rule ID 11765 //
     /*  720547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720615 */     GIR_RootConstrainSelectedInstOperands,
     /*  720616 */     // GIR_Coverage, 11765,
     /*  720616 */     GIR_EraseRootFromParent_Done,
     /*  720617 */   // Label 11360: @720617
     /*  720617 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(720692), // Rule ID 11768 //
     /*  720622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720690 */     GIR_RootConstrainSelectedInstOperands,
     /*  720691 */     // GIR_Coverage, 11768,
     /*  720691 */     GIR_EraseRootFromParent_Done,
     /*  720692 */   // Label 11361: @720692
     /*  720692 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(720767), // Rule ID 11769 //
     /*  720697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720765 */     GIR_RootConstrainSelectedInstOperands,
     /*  720766 */     // GIR_Coverage, 11769,
     /*  720766 */     GIR_EraseRootFromParent_Done,
     /*  720767 */   // Label 11362: @720767
     /*  720767 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(720842), // Rule ID 11772 //
     /*  720772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720840 */     GIR_RootConstrainSelectedInstOperands,
     /*  720841 */     // GIR_Coverage, 11772,
     /*  720841 */     GIR_EraseRootFromParent_Done,
     /*  720842 */   // Label 11363: @720842
     /*  720842 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(720917), // Rule ID 11773 //
     /*  720847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720915 */     GIR_RootConstrainSelectedInstOperands,
     /*  720916 */     // GIR_Coverage, 11773,
     /*  720916 */     GIR_EraseRootFromParent_Done,
     /*  720917 */   // Label 11364: @720917
     /*  720917 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(720992), // Rule ID 11776 //
     /*  720922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720990 */     GIR_RootConstrainSelectedInstOperands,
     /*  720991 */     // GIR_Coverage, 11776,
     /*  720991 */     GIR_EraseRootFromParent_Done,
     /*  720992 */   // Label 11365: @720992
     /*  720992 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(721067), // Rule ID 11777 //
     /*  720997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  721046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721065 */     GIR_RootConstrainSelectedInstOperands,
     /*  721066 */     // GIR_Coverage, 11777,
     /*  721066 */     GIR_EraseRootFromParent_Done,
     /*  721067 */   // Label 11366: @721067
     /*  721067 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(721142), // Rule ID 11780 //
     /*  721072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  721121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721140 */     GIR_RootConstrainSelectedInstOperands,
     /*  721141 */     // GIR_Coverage, 11780,
     /*  721141 */     GIR_EraseRootFromParent_Done,
     /*  721142 */   // Label 11367: @721142
     /*  721142 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(721217), // Rule ID 11781 //
     /*  721147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11239:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  721196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721215 */     GIR_RootConstrainSelectedInstOperands,
     /*  721216 */     // GIR_Coverage, 11781,
     /*  721216 */     GIR_EraseRootFromParent_Done,
     /*  721217 */   // Label 11368: @721217
     /*  721217 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(721292), // Rule ID 11784 //
     /*  721222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  721271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721290 */     GIR_RootConstrainSelectedInstOperands,
     /*  721291 */     // GIR_Coverage, 11784,
     /*  721291 */     GIR_EraseRootFromParent_Done,
     /*  721292 */   // Label 11369: @721292
     /*  721292 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(721367), // Rule ID 11785 //
     /*  721297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11239:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  721346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721365 */     GIR_RootConstrainSelectedInstOperands,
     /*  721366 */     // GIR_Coverage, 11785,
     /*  721366 */     GIR_EraseRootFromParent_Done,
     /*  721367 */   // Label 11370: @721367
     /*  721367 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(721442), // Rule ID 11788 //
     /*  721372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721440 */     GIR_RootConstrainSelectedInstOperands,
     /*  721441 */     // GIR_Coverage, 11788,
     /*  721441 */     GIR_EraseRootFromParent_Done,
     /*  721442 */   // Label 11371: @721442
     /*  721442 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(721517), // Rule ID 11789 //
     /*  721447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721515 */     GIR_RootConstrainSelectedInstOperands,
     /*  721516 */     // GIR_Coverage, 11789,
     /*  721516 */     GIR_EraseRootFromParent_Done,
     /*  721517 */   // Label 11372: @721517
     /*  721517 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(721592), // Rule ID 11792 //
     /*  721522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721590 */     GIR_RootConstrainSelectedInstOperands,
     /*  721591 */     // GIR_Coverage, 11792,
     /*  721591 */     GIR_EraseRootFromParent_Done,
     /*  721592 */   // Label 11373: @721592
     /*  721592 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(721667), // Rule ID 11793 //
     /*  721597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721665 */     GIR_RootConstrainSelectedInstOperands,
     /*  721666 */     // GIR_Coverage, 11793,
     /*  721666 */     GIR_EraseRootFromParent_Done,
     /*  721667 */   // Label 11374: @721667
     /*  721667 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(721742), // Rule ID 11796 //
     /*  721672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721740 */     GIR_RootConstrainSelectedInstOperands,
     /*  721741 */     // GIR_Coverage, 11796,
     /*  721741 */     GIR_EraseRootFromParent_Done,
     /*  721742 */   // Label 11375: @721742
     /*  721742 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(721817), // Rule ID 11797 //
     /*  721747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721815 */     GIR_RootConstrainSelectedInstOperands,
     /*  721816 */     // GIR_Coverage, 11797,
     /*  721816 */     GIR_EraseRootFromParent_Done,
     /*  721817 */   // Label 11376: @721817
     /*  721817 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(721892), // Rule ID 11800 //
     /*  721822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721890 */     GIR_RootConstrainSelectedInstOperands,
     /*  721891 */     // GIR_Coverage, 11800,
     /*  721891 */     GIR_EraseRootFromParent_Done,
     /*  721892 */   // Label 11377: @721892
     /*  721892 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(721967), // Rule ID 11801 //
     /*  721897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721965 */     GIR_RootConstrainSelectedInstOperands,
     /*  721966 */     // GIR_Coverage, 11801,
     /*  721966 */     GIR_EraseRootFromParent_Done,
     /*  721967 */   // Label 11378: @721967
     /*  721967 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(722042), // Rule ID 11804 //
     /*  721972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  722021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722040 */     GIR_RootConstrainSelectedInstOperands,
     /*  722041 */     // GIR_Coverage, 11804,
     /*  722041 */     GIR_EraseRootFromParent_Done,
     /*  722042 */   // Label 11379: @722042
     /*  722042 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(722117), // Rule ID 11805 //
     /*  722047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722093 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  722096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722115 */     GIR_RootConstrainSelectedInstOperands,
     /*  722116 */     // GIR_Coverage, 11805,
     /*  722116 */     GIR_EraseRootFromParent_Done,
     /*  722117 */   // Label 11380: @722117
     /*  722117 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(722192), // Rule ID 11808 //
     /*  722122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  722171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722190 */     GIR_RootConstrainSelectedInstOperands,
     /*  722191 */     // GIR_Coverage, 11808,
     /*  722191 */     GIR_EraseRootFromParent_Done,
     /*  722192 */   // Label 11381: @722192
     /*  722192 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(722267), // Rule ID 11809 //
     /*  722197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  722246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722265 */     GIR_RootConstrainSelectedInstOperands,
     /*  722266 */     // GIR_Coverage, 11809,
     /*  722266 */     GIR_EraseRootFromParent_Done,
     /*  722267 */   // Label 11382: @722267
     /*  722267 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(722342), // Rule ID 11812 //
     /*  722272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  722321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722340 */     GIR_RootConstrainSelectedInstOperands,
     /*  722341 */     // GIR_Coverage, 11812,
     /*  722341 */     GIR_EraseRootFromParent_Done,
     /*  722342 */   // Label 11383: @722342
     /*  722342 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(722417), // Rule ID 11813 //
     /*  722347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  722396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722415 */     GIR_RootConstrainSelectedInstOperands,
     /*  722416 */     // GIR_Coverage, 11813,
     /*  722416 */     GIR_EraseRootFromParent_Done,
     /*  722417 */   // Label 11384: @722417
     /*  722417 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(722492), // Rule ID 11816 //
     /*  722422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722490 */     GIR_RootConstrainSelectedInstOperands,
     /*  722491 */     // GIR_Coverage, 11816,
     /*  722491 */     GIR_EraseRootFromParent_Done,
     /*  722492 */   // Label 11385: @722492
     /*  722492 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(722567), // Rule ID 11817 //
     /*  722497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722543 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722565 */     GIR_RootConstrainSelectedInstOperands,
     /*  722566 */     // GIR_Coverage, 11817,
     /*  722566 */     GIR_EraseRootFromParent_Done,
     /*  722567 */   // Label 11386: @722567
     /*  722567 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(722642), // Rule ID 11820 //
     /*  722572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722640 */     GIR_RootConstrainSelectedInstOperands,
     /*  722641 */     // GIR_Coverage, 11820,
     /*  722641 */     GIR_EraseRootFromParent_Done,
     /*  722642 */   // Label 11387: @722642
     /*  722642 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(722717), // Rule ID 11821 //
     /*  722647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722715 */     GIR_RootConstrainSelectedInstOperands,
     /*  722716 */     // GIR_Coverage, 11821,
     /*  722716 */     GIR_EraseRootFromParent_Done,
     /*  722717 */   // Label 11388: @722717
     /*  722717 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(722792), // Rule ID 11824 //
     /*  722722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722790 */     GIR_RootConstrainSelectedInstOperands,
     /*  722791 */     // GIR_Coverage, 11824,
     /*  722791 */     GIR_EraseRootFromParent_Done,
     /*  722792 */   // Label 11389: @722792
     /*  722792 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(722867), // Rule ID 11825 //
     /*  722797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722865 */     GIR_RootConstrainSelectedInstOperands,
     /*  722866 */     // GIR_Coverage, 11825,
     /*  722866 */     GIR_EraseRootFromParent_Done,
     /*  722867 */   // Label 11390: @722867
     /*  722867 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(722942), // Rule ID 11828 //
     /*  722872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722940 */     GIR_RootConstrainSelectedInstOperands,
     /*  722941 */     // GIR_Coverage, 11828,
     /*  722941 */     GIR_EraseRootFromParent_Done,
     /*  722942 */   // Label 11391: @722942
     /*  722942 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(723017), // Rule ID 11829 //
     /*  722947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722993 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723015 */     GIR_RootConstrainSelectedInstOperands,
     /*  723016 */     // GIR_Coverage, 11829,
     /*  723016 */     GIR_EraseRootFromParent_Done,
     /*  723017 */   // Label 11392: @723017
     /*  723017 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(723092), // Rule ID 11832 //
     /*  723022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  723071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723090 */     GIR_RootConstrainSelectedInstOperands,
     /*  723091 */     // GIR_Coverage, 11832,
     /*  723091 */     GIR_EraseRootFromParent_Done,
     /*  723092 */   // Label 11393: @723092
     /*  723092 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(723167), // Rule ID 11833 //
     /*  723097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  723146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723165 */     GIR_RootConstrainSelectedInstOperands,
     /*  723166 */     // GIR_Coverage, 11833,
     /*  723166 */     GIR_EraseRootFromParent_Done,
     /*  723167 */   // Label 11394: @723167
     /*  723167 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(723242), // Rule ID 11836 //
     /*  723172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  723221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723240 */     GIR_RootConstrainSelectedInstOperands,
     /*  723241 */     // GIR_Coverage, 11836,
     /*  723241 */     GIR_EraseRootFromParent_Done,
     /*  723242 */   // Label 11395: @723242
     /*  723242 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(723317), // Rule ID 11837 //
     /*  723247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  723296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723315 */     GIR_RootConstrainSelectedInstOperands,
     /*  723316 */     // GIR_Coverage, 11837,
     /*  723316 */     GIR_EraseRootFromParent_Done,
     /*  723317 */   // Label 11396: @723317
     /*  723317 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(723392), // Rule ID 11840 //
     /*  723322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  723371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723390 */     GIR_RootConstrainSelectedInstOperands,
     /*  723391 */     // GIR_Coverage, 11840,
     /*  723391 */     GIR_EraseRootFromParent_Done,
     /*  723392 */   // Label 11397: @723392
     /*  723392 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(723467), // Rule ID 11841 //
     /*  723397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  723446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723465 */     GIR_RootConstrainSelectedInstOperands,
     /*  723466 */     // GIR_Coverage, 11841,
     /*  723466 */     GIR_EraseRootFromParent_Done,
     /*  723467 */   // Label 11398: @723467
     /*  723467 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(723542), // Rule ID 11844 //
     /*  723472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723540 */     GIR_RootConstrainSelectedInstOperands,
     /*  723541 */     // GIR_Coverage, 11844,
     /*  723541 */     GIR_EraseRootFromParent_Done,
     /*  723542 */   // Label 11399: @723542
     /*  723542 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(723617), // Rule ID 11845 //
     /*  723547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723615 */     GIR_RootConstrainSelectedInstOperands,
     /*  723616 */     // GIR_Coverage, 11845,
     /*  723616 */     GIR_EraseRootFromParent_Done,
     /*  723617 */   // Label 11400: @723617
     /*  723617 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(723692), // Rule ID 11848 //
     /*  723622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723690 */     GIR_RootConstrainSelectedInstOperands,
     /*  723691 */     // GIR_Coverage, 11848,
     /*  723691 */     GIR_EraseRootFromParent_Done,
     /*  723692 */   // Label 11401: @723692
     /*  723692 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(723767), // Rule ID 11849 //
     /*  723697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723765 */     GIR_RootConstrainSelectedInstOperands,
     /*  723766 */     // GIR_Coverage, 11849,
     /*  723766 */     GIR_EraseRootFromParent_Done,
     /*  723767 */   // Label 11402: @723767
     /*  723767 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(723842), // Rule ID 11852 //
     /*  723772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723840 */     GIR_RootConstrainSelectedInstOperands,
     /*  723841 */     // GIR_Coverage, 11852,
     /*  723841 */     GIR_EraseRootFromParent_Done,
     /*  723842 */   // Label 11403: @723842
     /*  723842 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(723917), // Rule ID 11853 //
     /*  723847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723893 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723915 */     GIR_RootConstrainSelectedInstOperands,
     /*  723916 */     // GIR_Coverage, 11853,
     /*  723916 */     GIR_EraseRootFromParent_Done,
     /*  723917 */   // Label 11404: @723917
     /*  723917 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(723992), // Rule ID 11856 //
     /*  723922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723990 */     GIR_RootConstrainSelectedInstOperands,
     /*  723991 */     // GIR_Coverage, 11856,
     /*  723991 */     GIR_EraseRootFromParent_Done,
     /*  723992 */   // Label 11405: @723992
     /*  723992 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(724067), // Rule ID 11857 //
     /*  723997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  724017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  724046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724065 */     GIR_RootConstrainSelectedInstOperands,
     /*  724066 */     // GIR_Coverage, 11857,
     /*  724066 */     GIR_EraseRootFromParent_Done,
     /*  724067 */   // Label 11406: @724067
     /*  724067 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(724142), // Rule ID 11860 //
     /*  724072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  724092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  724121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724140 */     GIR_RootConstrainSelectedInstOperands,
     /*  724141 */     // GIR_Coverage, 11860,
     /*  724141 */     GIR_EraseRootFromParent_Done,
     /*  724142 */   // Label 11407: @724142
     /*  724142 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(724217), // Rule ID 11861 //
     /*  724147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  724167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  724196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724215 */     GIR_RootConstrainSelectedInstOperands,
     /*  724216 */     // GIR_Coverage, 11861,
     /*  724216 */     GIR_EraseRootFromParent_Done,
     /*  724217 */   // Label 11408: @724217
     /*  724217 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(724292), // Rule ID 11864 //
     /*  724222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  724242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  724271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724290 */     GIR_RootConstrainSelectedInstOperands,
     /*  724291 */     // GIR_Coverage, 11864,
     /*  724291 */     GIR_EraseRootFromParent_Done,
     /*  724292 */   // Label 11409: @724292
     /*  724292 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(724367), // Rule ID 11865 //
     /*  724297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  724317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  724346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724365 */     GIR_RootConstrainSelectedInstOperands,
     /*  724366 */     // GIR_Coverage, 11865,
     /*  724366 */     GIR_EraseRootFromParent_Done,
     /*  724367 */   // Label 11410: @724367
     /*  724367 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(724442), // Rule ID 11868 //
     /*  724372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724440 */     GIR_RootConstrainSelectedInstOperands,
     /*  724441 */     // GIR_Coverage, 11868,
     /*  724441 */     GIR_EraseRootFromParent_Done,
     /*  724442 */   // Label 11411: @724442
     /*  724442 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(724517), // Rule ID 11869 //
     /*  724447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724493 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724515 */     GIR_RootConstrainSelectedInstOperands,
     /*  724516 */     // GIR_Coverage, 11869,
     /*  724516 */     GIR_EraseRootFromParent_Done,
     /*  724517 */   // Label 11412: @724517
     /*  724517 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(724592), // Rule ID 11872 //
     /*  724522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724590 */     GIR_RootConstrainSelectedInstOperands,
     /*  724591 */     // GIR_Coverage, 11872,
     /*  724591 */     GIR_EraseRootFromParent_Done,
     /*  724592 */   // Label 11413: @724592
     /*  724592 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(724667), // Rule ID 11873 //
     /*  724597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724665 */     GIR_RootConstrainSelectedInstOperands,
     /*  724666 */     // GIR_Coverage, 11873,
     /*  724666 */     GIR_EraseRootFromParent_Done,
     /*  724667 */   // Label 11414: @724667
     /*  724667 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(724742), // Rule ID 11876 //
     /*  724672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724740 */     GIR_RootConstrainSelectedInstOperands,
     /*  724741 */     // GIR_Coverage, 11876,
     /*  724741 */     GIR_EraseRootFromParent_Done,
     /*  724742 */   // Label 11415: @724742
     /*  724742 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(724817), // Rule ID 11877 //
     /*  724747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724793 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724815 */     GIR_RootConstrainSelectedInstOperands,
     /*  724816 */     // GIR_Coverage, 11877,
     /*  724816 */     GIR_EraseRootFromParent_Done,
     /*  724817 */   // Label 11416: @724817
     /*  724817 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(724892), // Rule ID 11880 //
     /*  724822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724890 */     GIR_RootConstrainSelectedInstOperands,
     /*  724891 */     // GIR_Coverage, 11880,
     /*  724891 */     GIR_EraseRootFromParent_Done,
     /*  724892 */   // Label 11417: @724892
     /*  724892 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(724967), // Rule ID 11881 //
     /*  724897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724965 */     GIR_RootConstrainSelectedInstOperands,
     /*  724966 */     // GIR_Coverage, 11881,
     /*  724966 */     GIR_EraseRootFromParent_Done,
     /*  724967 */   // Label 11418: @724967
     /*  724967 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(725042), // Rule ID 11884 //
     /*  724972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  725021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725040 */     GIR_RootConstrainSelectedInstOperands,
     /*  725041 */     // GIR_Coverage, 11884,
     /*  725041 */     GIR_EraseRootFromParent_Done,
     /*  725042 */   // Label 11419: @725042
     /*  725042 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(725117), // Rule ID 11885 //
     /*  725047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  725067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  725096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725115 */     GIR_RootConstrainSelectedInstOperands,
     /*  725116 */     // GIR_Coverage, 11885,
     /*  725116 */     GIR_EraseRootFromParent_Done,
     /*  725117 */   // Label 11420: @725117
     /*  725117 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(725192), // Rule ID 11888 //
     /*  725122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  725142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  725171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725190 */     GIR_RootConstrainSelectedInstOperands,
     /*  725191 */     // GIR_Coverage, 11888,
     /*  725191 */     GIR_EraseRootFromParent_Done,
     /*  725192 */   // Label 11421: @725192
     /*  725192 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(725267), // Rule ID 11889 //
     /*  725197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  725217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  725246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725265 */     GIR_RootConstrainSelectedInstOperands,
     /*  725266 */     // GIR_Coverage, 11889,
     /*  725266 */     GIR_EraseRootFromParent_Done,
     /*  725267 */   // Label 11422: @725267
     /*  725267 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(725342), // Rule ID 11892 //
     /*  725272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  725292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  725321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725340 */     GIR_RootConstrainSelectedInstOperands,
     /*  725341 */     // GIR_Coverage, 11892,
     /*  725341 */     GIR_EraseRootFromParent_Done,
     /*  725342 */   // Label 11423: @725342
     /*  725342 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(725417), // Rule ID 11893 //
     /*  725347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  725367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  725396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725415 */     GIR_RootConstrainSelectedInstOperands,
     /*  725416 */     // GIR_Coverage, 11893,
     /*  725416 */     GIR_EraseRootFromParent_Done,
     /*  725417 */   // Label 11424: @725417
     /*  725417 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(725492), // Rule ID 11896 //
     /*  725422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725490 */     GIR_RootConstrainSelectedInstOperands,
     /*  725491 */     // GIR_Coverage, 11896,
     /*  725491 */     GIR_EraseRootFromParent_Done,
     /*  725492 */   // Label 11425: @725492
     /*  725492 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(725567), // Rule ID 11897 //
     /*  725497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725565 */     GIR_RootConstrainSelectedInstOperands,
     /*  725566 */     // GIR_Coverage, 11897,
     /*  725566 */     GIR_EraseRootFromParent_Done,
     /*  725567 */   // Label 11426: @725567
     /*  725567 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(725642), // Rule ID 11900 //
     /*  725572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725640 */     GIR_RootConstrainSelectedInstOperands,
     /*  725641 */     // GIR_Coverage, 11900,
     /*  725641 */     GIR_EraseRootFromParent_Done,
     /*  725642 */   // Label 11427: @725642
     /*  725642 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(725717), // Rule ID 11901 //
     /*  725647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725715 */     GIR_RootConstrainSelectedInstOperands,
     /*  725716 */     // GIR_Coverage, 11901,
     /*  725716 */     GIR_EraseRootFromParent_Done,
     /*  725717 */   // Label 11428: @725717
     /*  725717 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(725792), // Rule ID 11904 //
     /*  725722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725790 */     GIR_RootConstrainSelectedInstOperands,
     /*  725791 */     // GIR_Coverage, 11904,
     /*  725791 */     GIR_EraseRootFromParent_Done,
     /*  725792 */   // Label 11429: @725792
     /*  725792 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(725867), // Rule ID 11905 //
     /*  725797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725865 */     GIR_RootConstrainSelectedInstOperands,
     /*  725866 */     // GIR_Coverage, 11905,
     /*  725866 */     GIR_EraseRootFromParent_Done,
     /*  725867 */   // Label 11430: @725867
     /*  725867 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(725942), // Rule ID 11908 //
     /*  725872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725940 */     GIR_RootConstrainSelectedInstOperands,
     /*  725941 */     // GIR_Coverage, 11908,
     /*  725941 */     GIR_EraseRootFromParent_Done,
     /*  725942 */   // Label 11431: @725942
     /*  725942 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(726017), // Rule ID 11909 //
     /*  725947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725993 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726015 */     GIR_RootConstrainSelectedInstOperands,
     /*  726016 */     // GIR_Coverage, 11909,
     /*  726016 */     GIR_EraseRootFromParent_Done,
     /*  726017 */   // Label 11432: @726017
     /*  726017 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(726092), // Rule ID 11912 //
     /*  726022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  726042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  726071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726090 */     GIR_RootConstrainSelectedInstOperands,
     /*  726091 */     // GIR_Coverage, 11912,
     /*  726091 */     GIR_EraseRootFromParent_Done,
     /*  726092 */   // Label 11433: @726092
     /*  726092 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(726167), // Rule ID 11913 //
     /*  726097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  726117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  726146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726165 */     GIR_RootConstrainSelectedInstOperands,
     /*  726166 */     // GIR_Coverage, 11913,
     /*  726166 */     GIR_EraseRootFromParent_Done,
     /*  726167 */   // Label 11434: @726167
     /*  726167 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(726242), // Rule ID 11916 //
     /*  726172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  726192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  726221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726240 */     GIR_RootConstrainSelectedInstOperands,
     /*  726241 */     // GIR_Coverage, 11916,
     /*  726241 */     GIR_EraseRootFromParent_Done,
     /*  726242 */   // Label 11435: @726242
     /*  726242 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(726317), // Rule ID 11917 //
     /*  726247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  726267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  726296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726315 */     GIR_RootConstrainSelectedInstOperands,
     /*  726316 */     // GIR_Coverage, 11917,
     /*  726316 */     GIR_EraseRootFromParent_Done,
     /*  726317 */   // Label 11436: @726317
     /*  726317 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(726392), // Rule ID 11920 //
     /*  726322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  726342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  726371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726390 */     GIR_RootConstrainSelectedInstOperands,
     /*  726391 */     // GIR_Coverage, 11920,
     /*  726391 */     GIR_EraseRootFromParent_Done,
     /*  726392 */   // Label 11437: @726392
     /*  726392 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(726467), // Rule ID 11921 //
     /*  726397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  726417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  726446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726465 */     GIR_RootConstrainSelectedInstOperands,
     /*  726466 */     // GIR_Coverage, 11921,
     /*  726466 */     GIR_EraseRootFromParent_Done,
     /*  726467 */   // Label 11438: @726467
     /*  726467 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(726542), // Rule ID 11924 //
     /*  726472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726540 */     GIR_RootConstrainSelectedInstOperands,
     /*  726541 */     // GIR_Coverage, 11924,
     /*  726541 */     GIR_EraseRootFromParent_Done,
     /*  726542 */   // Label 11439: @726542
     /*  726542 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(726617), // Rule ID 11925 //
     /*  726547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726615 */     GIR_RootConstrainSelectedInstOperands,
     /*  726616 */     // GIR_Coverage, 11925,
     /*  726616 */     GIR_EraseRootFromParent_Done,
     /*  726617 */   // Label 11440: @726617
     /*  726617 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(726692), // Rule ID 11928 //
     /*  726622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726690 */     GIR_RootConstrainSelectedInstOperands,
     /*  726691 */     // GIR_Coverage, 11928,
     /*  726691 */     GIR_EraseRootFromParent_Done,
     /*  726692 */   // Label 11441: @726692
     /*  726692 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(726767), // Rule ID 11929 //
     /*  726697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726765 */     GIR_RootConstrainSelectedInstOperands,
     /*  726766 */     // GIR_Coverage, 11929,
     /*  726766 */     GIR_EraseRootFromParent_Done,
     /*  726767 */   // Label 11442: @726767
     /*  726767 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(726842), // Rule ID 11932 //
     /*  726772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726840 */     GIR_RootConstrainSelectedInstOperands,
     /*  726841 */     // GIR_Coverage, 11932,
     /*  726841 */     GIR_EraseRootFromParent_Done,
     /*  726842 */   // Label 11443: @726842
     /*  726842 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(726917), // Rule ID 11933 //
     /*  726847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726915 */     GIR_RootConstrainSelectedInstOperands,
     /*  726916 */     // GIR_Coverage, 11933,
     /*  726916 */     GIR_EraseRootFromParent_Done,
     /*  726917 */   // Label 11444: @726917
     /*  726917 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(726992), // Rule ID 11936 //
     /*  726922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726990 */     GIR_RootConstrainSelectedInstOperands,
     /*  726991 */     // GIR_Coverage, 11936,
     /*  726991 */     GIR_EraseRootFromParent_Done,
     /*  726992 */   // Label 11445: @726992
     /*  726992 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(727067), // Rule ID 11937 //
     /*  726997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727043 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  727046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727065 */     GIR_RootConstrainSelectedInstOperands,
     /*  727066 */     // GIR_Coverage, 11937,
     /*  727066 */     GIR_EraseRootFromParent_Done,
     /*  727067 */   // Label 11446: @727067
     /*  727067 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(727142), // Rule ID 11940 //
     /*  727072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  727121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727140 */     GIR_RootConstrainSelectedInstOperands,
     /*  727141 */     // GIR_Coverage, 11940,
     /*  727141 */     GIR_EraseRootFromParent_Done,
     /*  727142 */   // Label 11447: @727142
     /*  727142 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(727217), // Rule ID 11941 //
     /*  727147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727193 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  727196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727215 */     GIR_RootConstrainSelectedInstOperands,
     /*  727216 */     // GIR_Coverage, 11941,
     /*  727216 */     GIR_EraseRootFromParent_Done,
     /*  727217 */   // Label 11448: @727217
     /*  727217 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(727292), // Rule ID 11944 //
     /*  727222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  727271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727290 */     GIR_RootConstrainSelectedInstOperands,
     /*  727291 */     // GIR_Coverage, 11944,
     /*  727291 */     GIR_EraseRootFromParent_Done,
     /*  727292 */   // Label 11449: @727292
     /*  727292 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(727367), // Rule ID 11945 //
     /*  727297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  727346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727365 */     GIR_RootConstrainSelectedInstOperands,
     /*  727366 */     // GIR_Coverage, 11945,
     /*  727366 */     GIR_EraseRootFromParent_Done,
     /*  727367 */   // Label 11450: @727367
     /*  727367 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(727442), // Rule ID 11948 //
     /*  727372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727440 */     GIR_RootConstrainSelectedInstOperands,
     /*  727441 */     // GIR_Coverage, 11948,
     /*  727441 */     GIR_EraseRootFromParent_Done,
     /*  727442 */   // Label 11451: @727442
     /*  727442 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(727517), // Rule ID 11949 //
     /*  727447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727515 */     GIR_RootConstrainSelectedInstOperands,
     /*  727516 */     // GIR_Coverage, 11949,
     /*  727516 */     GIR_EraseRootFromParent_Done,
     /*  727517 */   // Label 11452: @727517
     /*  727517 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(727592), // Rule ID 11952 //
     /*  727522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727590 */     GIR_RootConstrainSelectedInstOperands,
     /*  727591 */     // GIR_Coverage, 11952,
     /*  727591 */     GIR_EraseRootFromParent_Done,
     /*  727592 */   // Label 11453: @727592
     /*  727592 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(727667), // Rule ID 11953 //
     /*  727597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727665 */     GIR_RootConstrainSelectedInstOperands,
     /*  727666 */     // GIR_Coverage, 11953,
     /*  727666 */     GIR_EraseRootFromParent_Done,
     /*  727667 */   // Label 11454: @727667
     /*  727667 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(727742), // Rule ID 11956 //
     /*  727672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727740 */     GIR_RootConstrainSelectedInstOperands,
     /*  727741 */     // GIR_Coverage, 11956,
     /*  727741 */     GIR_EraseRootFromParent_Done,
     /*  727742 */   // Label 11455: @727742
     /*  727742 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(727817), // Rule ID 11957 //
     /*  727747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727815 */     GIR_RootConstrainSelectedInstOperands,
     /*  727816 */     // GIR_Coverage, 11957,
     /*  727816 */     GIR_EraseRootFromParent_Done,
     /*  727817 */   // Label 11456: @727817
     /*  727817 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(727892), // Rule ID 11960 //
     /*  727822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727890 */     GIR_RootConstrainSelectedInstOperands,
     /*  727891 */     // GIR_Coverage, 11960,
     /*  727891 */     GIR_EraseRootFromParent_Done,
     /*  727892 */   // Label 11457: @727892
     /*  727892 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(727967), // Rule ID 11961 //
     /*  727897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727965 */     GIR_RootConstrainSelectedInstOperands,
     /*  727966 */     // GIR_Coverage, 11961,
     /*  727966 */     GIR_EraseRootFromParent_Done,
     /*  727967 */   // Label 11458: @727967
     /*  727967 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(728042), // Rule ID 11964 //
     /*  727972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  728021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728040 */     GIR_RootConstrainSelectedInstOperands,
     /*  728041 */     // GIR_Coverage, 11964,
     /*  728041 */     GIR_EraseRootFromParent_Done,
     /*  728042 */   // Label 11459: @728042
     /*  728042 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(728117), // Rule ID 11965 //
     /*  728047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728093 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  728096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728115 */     GIR_RootConstrainSelectedInstOperands,
     /*  728116 */     // GIR_Coverage, 11965,
     /*  728116 */     GIR_EraseRootFromParent_Done,
     /*  728117 */   // Label 11460: @728117
     /*  728117 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(728192), // Rule ID 11968 //
     /*  728122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  728171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728190 */     GIR_RootConstrainSelectedInstOperands,
     /*  728191 */     // GIR_Coverage, 11968,
     /*  728191 */     GIR_EraseRootFromParent_Done,
     /*  728192 */   // Label 11461: @728192
     /*  728192 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(728267), // Rule ID 11969 //
     /*  728197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  728246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728265 */     GIR_RootConstrainSelectedInstOperands,
     /*  728266 */     // GIR_Coverage, 11969,
     /*  728266 */     GIR_EraseRootFromParent_Done,
     /*  728267 */   // Label 11462: @728267
     /*  728267 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(728342), // Rule ID 11972 //
     /*  728272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  728321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728340 */     GIR_RootConstrainSelectedInstOperands,
     /*  728341 */     // GIR_Coverage, 11972,
     /*  728341 */     GIR_EraseRootFromParent_Done,
     /*  728342 */   // Label 11463: @728342
     /*  728342 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(728417), // Rule ID 11973 //
     /*  728347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  728396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728415 */     GIR_RootConstrainSelectedInstOperands,
     /*  728416 */     // GIR_Coverage, 11973,
     /*  728416 */     GIR_EraseRootFromParent_Done,
     /*  728417 */   // Label 11464: @728417
     /*  728417 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(728492), // Rule ID 11976 //
     /*  728422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728490 */     GIR_RootConstrainSelectedInstOperands,
     /*  728491 */     // GIR_Coverage, 11976,
     /*  728491 */     GIR_EraseRootFromParent_Done,
     /*  728492 */   // Label 11465: @728492
     /*  728492 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(728567), // Rule ID 11977 //
     /*  728497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728543 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728565 */     GIR_RootConstrainSelectedInstOperands,
     /*  728566 */     // GIR_Coverage, 11977,
     /*  728566 */     GIR_EraseRootFromParent_Done,
     /*  728567 */   // Label 11466: @728567
     /*  728567 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(728642), // Rule ID 11980 //
     /*  728572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728640 */     GIR_RootConstrainSelectedInstOperands,
     /*  728641 */     // GIR_Coverage, 11980,
     /*  728641 */     GIR_EraseRootFromParent_Done,
     /*  728642 */   // Label 11467: @728642
     /*  728642 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(728717), // Rule ID 11981 //
     /*  728647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728715 */     GIR_RootConstrainSelectedInstOperands,
     /*  728716 */     // GIR_Coverage, 11981,
     /*  728716 */     GIR_EraseRootFromParent_Done,
     /*  728717 */   // Label 11468: @728717
     /*  728717 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(728792), // Rule ID 11984 //
     /*  728722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728790 */     GIR_RootConstrainSelectedInstOperands,
     /*  728791 */     // GIR_Coverage, 11984,
     /*  728791 */     GIR_EraseRootFromParent_Done,
     /*  728792 */   // Label 11469: @728792
     /*  728792 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(728867), // Rule ID 11985 //
     /*  728797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728865 */     GIR_RootConstrainSelectedInstOperands,
     /*  728866 */     // GIR_Coverage, 11985,
     /*  728866 */     GIR_EraseRootFromParent_Done,
     /*  728867 */   // Label 11470: @728867
     /*  728867 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(728942), // Rule ID 11988 //
     /*  728872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728940 */     GIR_RootConstrainSelectedInstOperands,
     /*  728941 */     // GIR_Coverage, 11988,
     /*  728941 */     GIR_EraseRootFromParent_Done,
     /*  728942 */   // Label 11471: @728942
     /*  728942 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(729017), // Rule ID 11989 //
     /*  728947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729015 */     GIR_RootConstrainSelectedInstOperands,
     /*  729016 */     // GIR_Coverage, 11989,
     /*  729016 */     GIR_EraseRootFromParent_Done,
     /*  729017 */   // Label 11472: @729017
     /*  729017 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(729092), // Rule ID 11992 //
     /*  729022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  729071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729090 */     GIR_RootConstrainSelectedInstOperands,
     /*  729091 */     // GIR_Coverage, 11992,
     /*  729091 */     GIR_EraseRootFromParent_Done,
     /*  729092 */   // Label 11473: @729092
     /*  729092 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(729167), // Rule ID 11993 //
     /*  729097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  729146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729165 */     GIR_RootConstrainSelectedInstOperands,
     /*  729166 */     // GIR_Coverage, 11993,
     /*  729166 */     GIR_EraseRootFromParent_Done,
     /*  729167 */   // Label 11474: @729167
     /*  729167 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(729242), // Rule ID 11996 //
     /*  729172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  729221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729240 */     GIR_RootConstrainSelectedInstOperands,
     /*  729241 */     // GIR_Coverage, 11996,
     /*  729241 */     GIR_EraseRootFromParent_Done,
     /*  729242 */   // Label 11475: @729242
     /*  729242 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(729317), // Rule ID 11997 //
     /*  729247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  729296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729315 */     GIR_RootConstrainSelectedInstOperands,
     /*  729316 */     // GIR_Coverage, 11997,
     /*  729316 */     GIR_EraseRootFromParent_Done,
     /*  729317 */   // Label 11476: @729317
     /*  729317 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(729392), // Rule ID 12000 //
     /*  729322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  729371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729390 */     GIR_RootConstrainSelectedInstOperands,
     /*  729391 */     // GIR_Coverage, 12000,
     /*  729391 */     GIR_EraseRootFromParent_Done,
     /*  729392 */   // Label 11477: @729392
     /*  729392 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(729467), // Rule ID 12001 //
     /*  729397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  729446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729465 */     GIR_RootConstrainSelectedInstOperands,
     /*  729466 */     // GIR_Coverage, 12001,
     /*  729466 */     GIR_EraseRootFromParent_Done,
     /*  729467 */   // Label 11478: @729467
     /*  729467 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(729542), // Rule ID 12004 //
     /*  729472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729540 */     GIR_RootConstrainSelectedInstOperands,
     /*  729541 */     // GIR_Coverage, 12004,
     /*  729541 */     GIR_EraseRootFromParent_Done,
     /*  729542 */   // Label 11479: @729542
     /*  729542 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(729617), // Rule ID 12005 //
     /*  729547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729615 */     GIR_RootConstrainSelectedInstOperands,
     /*  729616 */     // GIR_Coverage, 12005,
     /*  729616 */     GIR_EraseRootFromParent_Done,
     /*  729617 */   // Label 11480: @729617
     /*  729617 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(729692), // Rule ID 12008 //
     /*  729622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729690 */     GIR_RootConstrainSelectedInstOperands,
     /*  729691 */     // GIR_Coverage, 12008,
     /*  729691 */     GIR_EraseRootFromParent_Done,
     /*  729692 */   // Label 11481: @729692
     /*  729692 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(729767), // Rule ID 12009 //
     /*  729697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729765 */     GIR_RootConstrainSelectedInstOperands,
     /*  729766 */     // GIR_Coverage, 12009,
     /*  729766 */     GIR_EraseRootFromParent_Done,
     /*  729767 */   // Label 11482: @729767
     /*  729767 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(729842), // Rule ID 12012 //
     /*  729772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729840 */     GIR_RootConstrainSelectedInstOperands,
     /*  729841 */     // GIR_Coverage, 12012,
     /*  729841 */     GIR_EraseRootFromParent_Done,
     /*  729842 */   // Label 11483: @729842
     /*  729842 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(729917), // Rule ID 12013 //
     /*  729847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729915 */     GIR_RootConstrainSelectedInstOperands,
     /*  729916 */     // GIR_Coverage, 12013,
     /*  729916 */     GIR_EraseRootFromParent_Done,
     /*  729917 */   // Label 11484: @729917
     /*  729917 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(729992), // Rule ID 12016 //
     /*  729922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729990 */     GIR_RootConstrainSelectedInstOperands,
     /*  729991 */     // GIR_Coverage, 12016,
     /*  729991 */     GIR_EraseRootFromParent_Done,
     /*  729992 */   // Label 11485: @729992
     /*  729992 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(730067), // Rule ID 12017 //
     /*  729997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  730000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  730043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  730046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730065 */     GIR_RootConstrainSelectedInstOperands,
     /*  730066 */     // GIR_Coverage, 12017,
     /*  730066 */     GIR_EraseRootFromParent_Done,
     /*  730067 */   // Label 11486: @730067
     /*  730067 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(730142), // Rule ID 12020 //
     /*  730072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  730092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  730121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730140 */     GIR_RootConstrainSelectedInstOperands,
     /*  730141 */     // GIR_Coverage, 12020,
     /*  730141 */     GIR_EraseRootFromParent_Done,
     /*  730142 */   // Label 11487: @730142
     /*  730142 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(730217), // Rule ID 12021 //
     /*  730147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  730167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  730196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730215 */     GIR_RootConstrainSelectedInstOperands,
     /*  730216 */     // GIR_Coverage, 12021,
     /*  730216 */     GIR_EraseRootFromParent_Done,
     /*  730217 */   // Label 11488: @730217
     /*  730217 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(730292), // Rule ID 12024 //
     /*  730222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  730242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  730271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730290 */     GIR_RootConstrainSelectedInstOperands,
     /*  730291 */     // GIR_Coverage, 12024,
     /*  730291 */     GIR_EraseRootFromParent_Done,
     /*  730292 */   // Label 11489: @730292
     /*  730292 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(730367), // Rule ID 12025 //
     /*  730297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  730317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730343 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  730346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730365 */     GIR_RootConstrainSelectedInstOperands,
     /*  730366 */     // GIR_Coverage, 12025,
     /*  730366 */     GIR_EraseRootFromParent_Done,
     /*  730367 */   // Label 11490: @730367
     /*  730367 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(730442), // Rule ID 12028 //
     /*  730372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730440 */     GIR_RootConstrainSelectedInstOperands,
     /*  730441 */     // GIR_Coverage, 12028,
     /*  730441 */     GIR_EraseRootFromParent_Done,
     /*  730442 */   // Label 11491: @730442
     /*  730442 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(730517), // Rule ID 12029 //
     /*  730447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730493 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730515 */     GIR_RootConstrainSelectedInstOperands,
     /*  730516 */     // GIR_Coverage, 12029,
     /*  730516 */     GIR_EraseRootFromParent_Done,
     /*  730517 */   // Label 11492: @730517
     /*  730517 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(730592), // Rule ID 12032 //
     /*  730522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730590 */     GIR_RootConstrainSelectedInstOperands,
     /*  730591 */     // GIR_Coverage, 12032,
     /*  730591 */     GIR_EraseRootFromParent_Done,
     /*  730592 */   // Label 11493: @730592
     /*  730592 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(730667), // Rule ID 12033 //
     /*  730597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730665 */     GIR_RootConstrainSelectedInstOperands,
     /*  730666 */     // GIR_Coverage, 12033,
     /*  730666 */     GIR_EraseRootFromParent_Done,
     /*  730667 */   // Label 11494: @730667
     /*  730667 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(730742), // Rule ID 12036 //
     /*  730672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730740 */     GIR_RootConstrainSelectedInstOperands,
     /*  730741 */     // GIR_Coverage, 12036,
     /*  730741 */     GIR_EraseRootFromParent_Done,
     /*  730742 */   // Label 11495: @730742
     /*  730742 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(730817), // Rule ID 12037 //
     /*  730747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730815 */     GIR_RootConstrainSelectedInstOperands,
     /*  730816 */     // GIR_Coverage, 12037,
     /*  730816 */     GIR_EraseRootFromParent_Done,
     /*  730817 */   // Label 11496: @730817
     /*  730817 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(730892), // Rule ID 12040 //
     /*  730822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730890 */     GIR_RootConstrainSelectedInstOperands,
     /*  730891 */     // GIR_Coverage, 12040,
     /*  730891 */     GIR_EraseRootFromParent_Done,
     /*  730892 */   // Label 11497: @730892
     /*  730892 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(730967), // Rule ID 12041 //
     /*  730897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730965 */     GIR_RootConstrainSelectedInstOperands,
     /*  730966 */     // GIR_Coverage, 12041,
     /*  730966 */     GIR_EraseRootFromParent_Done,
     /*  730967 */   // Label 11498: @730967
     /*  730967 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(731042), // Rule ID 12044 //
     /*  730972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  731021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731040 */     GIR_RootConstrainSelectedInstOperands,
     /*  731041 */     // GIR_Coverage, 12044,
     /*  731041 */     GIR_EraseRootFromParent_Done,
     /*  731042 */   // Label 11499: @731042
     /*  731042 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(731117), // Rule ID 12045 //
     /*  731047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  731067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731093 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  731096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731115 */     GIR_RootConstrainSelectedInstOperands,
     /*  731116 */     // GIR_Coverage, 12045,
     /*  731116 */     GIR_EraseRootFromParent_Done,
     /*  731117 */   // Label 11500: @731117
     /*  731117 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(731192), // Rule ID 12048 //
     /*  731122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  731142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  731171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731190 */     GIR_RootConstrainSelectedInstOperands,
     /*  731191 */     // GIR_Coverage, 12048,
     /*  731191 */     GIR_EraseRootFromParent_Done,
     /*  731192 */   // Label 11501: @731192
     /*  731192 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(731267), // Rule ID 12049 //
     /*  731197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  731217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  731246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731265 */     GIR_RootConstrainSelectedInstOperands,
     /*  731266 */     // GIR_Coverage, 12049,
     /*  731266 */     GIR_EraseRootFromParent_Done,
     /*  731267 */   // Label 11502: @731267
     /*  731267 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(731342), // Rule ID 12052 //
     /*  731272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  731292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  731321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731340 */     GIR_RootConstrainSelectedInstOperands,
     /*  731341 */     // GIR_Coverage, 12052,
     /*  731341 */     GIR_EraseRootFromParent_Done,
     /*  731342 */   // Label 11503: @731342
     /*  731342 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(731417), // Rule ID 12053 //
     /*  731347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  731367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  731396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731415 */     GIR_RootConstrainSelectedInstOperands,
     /*  731416 */     // GIR_Coverage, 12053,
     /*  731416 */     GIR_EraseRootFromParent_Done,
     /*  731417 */   // Label 11504: @731417
     /*  731417 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(731492), // Rule ID 12056 //
     /*  731422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731490 */     GIR_RootConstrainSelectedInstOperands,
     /*  731491 */     // GIR_Coverage, 12056,
     /*  731491 */     GIR_EraseRootFromParent_Done,
     /*  731492 */   // Label 11505: @731492
     /*  731492 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(731567), // Rule ID 12057 //
     /*  731497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731565 */     GIR_RootConstrainSelectedInstOperands,
     /*  731566 */     // GIR_Coverage, 12057,
     /*  731566 */     GIR_EraseRootFromParent_Done,
     /*  731567 */   // Label 11506: @731567
     /*  731567 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(731642), // Rule ID 12060 //
     /*  731572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731640 */     GIR_RootConstrainSelectedInstOperands,
     /*  731641 */     // GIR_Coverage, 12060,
     /*  731641 */     GIR_EraseRootFromParent_Done,
     /*  731642 */   // Label 11507: @731642
     /*  731642 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(731717), // Rule ID 12061 //
     /*  731647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731715 */     GIR_RootConstrainSelectedInstOperands,
     /*  731716 */     // GIR_Coverage, 12061,
     /*  731716 */     GIR_EraseRootFromParent_Done,
     /*  731717 */   // Label 11508: @731717
     /*  731717 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(731792), // Rule ID 12064 //
     /*  731722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731768 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731790 */     GIR_RootConstrainSelectedInstOperands,
     /*  731791 */     // GIR_Coverage, 12064,
     /*  731791 */     GIR_EraseRootFromParent_Done,
     /*  731792 */   // Label 11509: @731792
     /*  731792 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(731867), // Rule ID 12065 //
     /*  731797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731843 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731865 */     GIR_RootConstrainSelectedInstOperands,
     /*  731866 */     // GIR_Coverage, 12065,
     /*  731866 */     GIR_EraseRootFromParent_Done,
     /*  731867 */   // Label 11510: @731867
     /*  731867 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(731942), // Rule ID 12068 //
     /*  731872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731940 */     GIR_RootConstrainSelectedInstOperands,
     /*  731941 */     // GIR_Coverage, 12068,
     /*  731941 */     GIR_EraseRootFromParent_Done,
     /*  731942 */   // Label 11511: @731942
     /*  731942 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(732017), // Rule ID 12069 //
     /*  731947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731993 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732015 */     GIR_RootConstrainSelectedInstOperands,
     /*  732016 */     // GIR_Coverage, 12069,
     /*  732016 */     GIR_EraseRootFromParent_Done,
     /*  732017 */   // Label 11512: @732017
     /*  732017 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(732092), // Rule ID 12072 //
     /*  732022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  732042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  732071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732090 */     GIR_RootConstrainSelectedInstOperands,
     /*  732091 */     // GIR_Coverage, 12072,
     /*  732091 */     GIR_EraseRootFromParent_Done,
     /*  732092 */   // Label 11513: @732092
     /*  732092 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(732167), // Rule ID 12073 //
     /*  732097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  732117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  732146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732165 */     GIR_RootConstrainSelectedInstOperands,
     /*  732166 */     // GIR_Coverage, 12073,
     /*  732166 */     GIR_EraseRootFromParent_Done,
     /*  732167 */   // Label 11514: @732167
     /*  732167 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(732242), // Rule ID 12076 //
     /*  732172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  732192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  732221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732240 */     GIR_RootConstrainSelectedInstOperands,
     /*  732241 */     // GIR_Coverage, 12076,
     /*  732241 */     GIR_EraseRootFromParent_Done,
     /*  732242 */   // Label 11515: @732242
     /*  732242 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(732317), // Rule ID 12077 //
     /*  732247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  732267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  732296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732315 */     GIR_RootConstrainSelectedInstOperands,
     /*  732316 */     // GIR_Coverage, 12077,
     /*  732316 */     GIR_EraseRootFromParent_Done,
     /*  732317 */   // Label 11516: @732317
     /*  732317 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(732392), // Rule ID 12080 //
     /*  732322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  732342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  732371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732390 */     GIR_RootConstrainSelectedInstOperands,
     /*  732391 */     // GIR_Coverage, 12080,
     /*  732391 */     GIR_EraseRootFromParent_Done,
     /*  732392 */   // Label 11517: @732392
     /*  732392 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(732467), // Rule ID 12081 //
     /*  732397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  732417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  732446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732465 */     GIR_RootConstrainSelectedInstOperands,
     /*  732466 */     // GIR_Coverage, 12081,
     /*  732466 */     GIR_EraseRootFromParent_Done,
     /*  732467 */   // Label 11518: @732467
     /*  732467 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(732542), // Rule ID 12084 //
     /*  732472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732540 */     GIR_RootConstrainSelectedInstOperands,
     /*  732541 */     // GIR_Coverage, 12084,
     /*  732541 */     GIR_EraseRootFromParent_Done,
     /*  732542 */   // Label 11519: @732542
     /*  732542 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(732617), // Rule ID 12085 //
     /*  732547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732615 */     GIR_RootConstrainSelectedInstOperands,
     /*  732616 */     // GIR_Coverage, 12085,
     /*  732616 */     GIR_EraseRootFromParent_Done,
     /*  732617 */   // Label 11520: @732617
     /*  732617 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(732692), // Rule ID 12088 //
     /*  732622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732690 */     GIR_RootConstrainSelectedInstOperands,
     /*  732691 */     // GIR_Coverage, 12088,
     /*  732691 */     GIR_EraseRootFromParent_Done,
     /*  732692 */   // Label 11521: @732692
     /*  732692 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(732767), // Rule ID 12089 //
     /*  732697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732765 */     GIR_RootConstrainSelectedInstOperands,
     /*  732766 */     // GIR_Coverage, 12089,
     /*  732766 */     GIR_EraseRootFromParent_Done,
     /*  732767 */   // Label 11522: @732767
     /*  732767 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(732842), // Rule ID 12092 //
     /*  732772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732840 */     GIR_RootConstrainSelectedInstOperands,
     /*  732841 */     // GIR_Coverage, 12092,
     /*  732841 */     GIR_EraseRootFromParent_Done,
     /*  732842 */   // Label 11523: @732842
     /*  732842 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(732917), // Rule ID 12093 //
     /*  732847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732915 */     GIR_RootConstrainSelectedInstOperands,
     /*  732916 */     // GIR_Coverage, 12093,
     /*  732916 */     GIR_EraseRootFromParent_Done,
     /*  732917 */   // Label 11524: @732917
     /*  732917 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(732992), // Rule ID 12096 //
     /*  732922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732990 */     GIR_RootConstrainSelectedInstOperands,
     /*  732991 */     // GIR_Coverage, 12096,
     /*  732991 */     GIR_EraseRootFromParent_Done,
     /*  732992 */   // Label 11525: @732992
     /*  732992 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(733067), // Rule ID 12097 //
     /*  732997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  733017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  733046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733065 */     GIR_RootConstrainSelectedInstOperands,
     /*  733066 */     // GIR_Coverage, 12097,
     /*  733066 */     GIR_EraseRootFromParent_Done,
     /*  733067 */   // Label 11526: @733067
     /*  733067 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(733142), // Rule ID 12100 //
     /*  733072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  733092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  733121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733140 */     GIR_RootConstrainSelectedInstOperands,
     /*  733141 */     // GIR_Coverage, 12100,
     /*  733141 */     GIR_EraseRootFromParent_Done,
     /*  733142 */   // Label 11527: @733142
     /*  733142 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(733217), // Rule ID 12101 //
     /*  733147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  733167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  733196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733215 */     GIR_RootConstrainSelectedInstOperands,
     /*  733216 */     // GIR_Coverage, 12101,
     /*  733216 */     GIR_EraseRootFromParent_Done,
     /*  733217 */   // Label 11528: @733217
     /*  733217 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(733292), // Rule ID 12104 //
     /*  733222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  733242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  733271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733290 */     GIR_RootConstrainSelectedInstOperands,
     /*  733291 */     // GIR_Coverage, 12104,
     /*  733291 */     GIR_EraseRootFromParent_Done,
     /*  733292 */   // Label 11529: @733292
     /*  733292 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(733367), // Rule ID 12105 //
     /*  733297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  733317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733343 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  733346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733365 */     GIR_RootConstrainSelectedInstOperands,
     /*  733366 */     // GIR_Coverage, 12105,
     /*  733366 */     GIR_EraseRootFromParent_Done,
     /*  733367 */   // Label 11530: @733367
     /*  733367 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(733442), // Rule ID 12108 //
     /*  733372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733440 */     GIR_RootConstrainSelectedInstOperands,
     /*  733441 */     // GIR_Coverage, 12108,
     /*  733441 */     GIR_EraseRootFromParent_Done,
     /*  733442 */   // Label 11531: @733442
     /*  733442 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(733517), // Rule ID 12109 //
     /*  733447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733493 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733515 */     GIR_RootConstrainSelectedInstOperands,
     /*  733516 */     // GIR_Coverage, 12109,
     /*  733516 */     GIR_EraseRootFromParent_Done,
     /*  733517 */   // Label 11532: @733517
     /*  733517 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(733592), // Rule ID 12112 //
     /*  733522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733568 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733590 */     GIR_RootConstrainSelectedInstOperands,
     /*  733591 */     // GIR_Coverage, 12112,
     /*  733591 */     GIR_EraseRootFromParent_Done,
     /*  733592 */   // Label 11533: @733592
     /*  733592 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(733667), // Rule ID 12113 //
     /*  733597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733665 */     GIR_RootConstrainSelectedInstOperands,
     /*  733666 */     // GIR_Coverage, 12113,
     /*  733666 */     GIR_EraseRootFromParent_Done,
     /*  733667 */   // Label 11534: @733667
     /*  733667 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(733742), // Rule ID 12116 //
     /*  733672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733740 */     GIR_RootConstrainSelectedInstOperands,
     /*  733741 */     // GIR_Coverage, 12116,
     /*  733741 */     GIR_EraseRootFromParent_Done,
     /*  733742 */   // Label 11535: @733742
     /*  733742 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(733817), // Rule ID 12117 //
     /*  733747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733793 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733815 */     GIR_RootConstrainSelectedInstOperands,
     /*  733816 */     // GIR_Coverage, 12117,
     /*  733816 */     GIR_EraseRootFromParent_Done,
     /*  733817 */   // Label 11536: @733817
     /*  733817 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(733892), // Rule ID 12120 //
     /*  733822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733890 */     GIR_RootConstrainSelectedInstOperands,
     /*  733891 */     // GIR_Coverage, 12120,
     /*  733891 */     GIR_EraseRootFromParent_Done,
     /*  733892 */   // Label 11537: @733892
     /*  733892 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(733967), // Rule ID 12121 //
     /*  733897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733965 */     GIR_RootConstrainSelectedInstOperands,
     /*  733966 */     // GIR_Coverage, 12121,
     /*  733966 */     GIR_EraseRootFromParent_Done,
     /*  733967 */   // Label 11538: @733967
     /*  733967 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(734042), // Rule ID 12124 //
     /*  733972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  734021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734040 */     GIR_RootConstrainSelectedInstOperands,
     /*  734041 */     // GIR_Coverage, 12124,
     /*  734041 */     GIR_EraseRootFromParent_Done,
     /*  734042 */   // Label 11539: @734042
     /*  734042 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(734117), // Rule ID 12125 //
     /*  734047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  734096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734115 */     GIR_RootConstrainSelectedInstOperands,
     /*  734116 */     // GIR_Coverage, 12125,
     /*  734116 */     GIR_EraseRootFromParent_Done,
     /*  734117 */   // Label 11540: @734117
     /*  734117 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(734192), // Rule ID 12128 //
     /*  734122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  734171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734190 */     GIR_RootConstrainSelectedInstOperands,
     /*  734191 */     // GIR_Coverage, 12128,
     /*  734191 */     GIR_EraseRootFromParent_Done,
     /*  734192 */   // Label 11541: @734192
     /*  734192 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(734267), // Rule ID 12129 //
     /*  734197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  734246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734265 */     GIR_RootConstrainSelectedInstOperands,
     /*  734266 */     // GIR_Coverage, 12129,
     /*  734266 */     GIR_EraseRootFromParent_Done,
     /*  734267 */   // Label 11542: @734267
     /*  734267 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(734342), // Rule ID 12132 //
     /*  734272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734318 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  734321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734340 */     GIR_RootConstrainSelectedInstOperands,
     /*  734341 */     // GIR_Coverage, 12132,
     /*  734341 */     GIR_EraseRootFromParent_Done,
     /*  734342 */   // Label 11543: @734342
     /*  734342 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(734417), // Rule ID 12133 //
     /*  734347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734393 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11571:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  734396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734415 */     GIR_RootConstrainSelectedInstOperands,
     /*  734416 */     // GIR_Coverage, 12133,
     /*  734416 */     GIR_EraseRootFromParent_Done,
     /*  734417 */   // Label 11544: @734417
     /*  734417 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(734492), // Rule ID 12136 //
     /*  734422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734490 */     GIR_RootConstrainSelectedInstOperands,
     /*  734491 */     // GIR_Coverage, 12136,
     /*  734491 */     GIR_EraseRootFromParent_Done,
     /*  734492 */   // Label 11545: @734492
     /*  734492 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(734567), // Rule ID 12137 //
     /*  734497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734543 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734565 */     GIR_RootConstrainSelectedInstOperands,
     /*  734566 */     // GIR_Coverage, 12137,
     /*  734566 */     GIR_EraseRootFromParent_Done,
     /*  734567 */   // Label 11546: @734567
     /*  734567 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(734642), // Rule ID 12140 //
     /*  734572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734640 */     GIR_RootConstrainSelectedInstOperands,
     /*  734641 */     // GIR_Coverage, 12140,
     /*  734641 */     GIR_EraseRootFromParent_Done,
     /*  734642 */   // Label 11547: @734642
     /*  734642 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(734717), // Rule ID 12141 //
     /*  734647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734715 */     GIR_RootConstrainSelectedInstOperands,
     /*  734716 */     // GIR_Coverage, 12141,
     /*  734716 */     GIR_EraseRootFromParent_Done,
     /*  734717 */   // Label 11548: @734717
     /*  734717 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(734792), // Rule ID 12144 //
     /*  734722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734790 */     GIR_RootConstrainSelectedInstOperands,
     /*  734791 */     // GIR_Coverage, 12144,
     /*  734791 */     GIR_EraseRootFromParent_Done,
     /*  734792 */   // Label 11549: @734792
     /*  734792 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(734867), // Rule ID 12145 //
     /*  734797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734865 */     GIR_RootConstrainSelectedInstOperands,
     /*  734866 */     // GIR_Coverage, 12145,
     /*  734866 */     GIR_EraseRootFromParent_Done,
     /*  734867 */   // Label 11550: @734867
     /*  734867 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(734942), // Rule ID 12148 //
     /*  734872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734940 */     GIR_RootConstrainSelectedInstOperands,
     /*  734941 */     // GIR_Coverage, 12148,
     /*  734941 */     GIR_EraseRootFromParent_Done,
     /*  734942 */   // Label 11551: @734942
     /*  734942 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(735017), // Rule ID 12149 //
     /*  734947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735015 */     GIR_RootConstrainSelectedInstOperands,
     /*  735016 */     // GIR_Coverage, 12149,
     /*  735016 */     GIR_EraseRootFromParent_Done,
     /*  735017 */   // Label 11552: @735017
     /*  735017 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(735092), // Rule ID 12152 //
     /*  735022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  735071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735090 */     GIR_RootConstrainSelectedInstOperands,
     /*  735091 */     // GIR_Coverage, 12152,
     /*  735091 */     GIR_EraseRootFromParent_Done,
     /*  735092 */   // Label 11553: @735092
     /*  735092 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(735167), // Rule ID 12153 //
     /*  735097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  735146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735165 */     GIR_RootConstrainSelectedInstOperands,
     /*  735166 */     // GIR_Coverage, 12153,
     /*  735166 */     GIR_EraseRootFromParent_Done,
     /*  735167 */   // Label 11554: @735167
     /*  735167 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(735242), // Rule ID 12156 //
     /*  735172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  735221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735240 */     GIR_RootConstrainSelectedInstOperands,
     /*  735241 */     // GIR_Coverage, 12156,
     /*  735241 */     GIR_EraseRootFromParent_Done,
     /*  735242 */   // Label 11555: @735242
     /*  735242 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(735317), // Rule ID 12157 //
     /*  735247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  735296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735315 */     GIR_RootConstrainSelectedInstOperands,
     /*  735316 */     // GIR_Coverage, 12157,
     /*  735316 */     GIR_EraseRootFromParent_Done,
     /*  735317 */   // Label 11556: @735317
     /*  735317 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(735392), // Rule ID 12160 //
     /*  735322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  735371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735390 */     GIR_RootConstrainSelectedInstOperands,
     /*  735391 */     // GIR_Coverage, 12160,
     /*  735391 */     GIR_EraseRootFromParent_Done,
     /*  735392 */   // Label 11557: @735392
     /*  735392 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(735467), // Rule ID 12161 //
     /*  735397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  735446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735465 */     GIR_RootConstrainSelectedInstOperands,
     /*  735466 */     // GIR_Coverage, 12161,
     /*  735466 */     GIR_EraseRootFromParent_Done,
     /*  735467 */   // Label 11558: @735467
     /*  735467 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(735542), // Rule ID 12164 //
     /*  735472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735540 */     GIR_RootConstrainSelectedInstOperands,
     /*  735541 */     // GIR_Coverage, 12164,
     /*  735541 */     GIR_EraseRootFromParent_Done,
     /*  735542 */   // Label 11559: @735542
     /*  735542 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(735617), // Rule ID 12165 //
     /*  735547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735593 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735615 */     GIR_RootConstrainSelectedInstOperands,
     /*  735616 */     // GIR_Coverage, 12165,
     /*  735616 */     GIR_EraseRootFromParent_Done,
     /*  735617 */   // Label 11560: @735617
     /*  735617 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(735692), // Rule ID 12168 //
     /*  735622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735690 */     GIR_RootConstrainSelectedInstOperands,
     /*  735691 */     // GIR_Coverage, 12168,
     /*  735691 */     GIR_EraseRootFromParent_Done,
     /*  735692 */   // Label 11561: @735692
     /*  735692 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(735767), // Rule ID 12169 //
     /*  735697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735743 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735765 */     GIR_RootConstrainSelectedInstOperands,
     /*  735766 */     // GIR_Coverage, 12169,
     /*  735766 */     GIR_EraseRootFromParent_Done,
     /*  735767 */   // Label 11562: @735767
     /*  735767 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(735842), // Rule ID 12172 //
     /*  735772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735840 */     GIR_RootConstrainSelectedInstOperands,
     /*  735841 */     // GIR_Coverage, 12172,
     /*  735841 */     GIR_EraseRootFromParent_Done,
     /*  735842 */   // Label 11563: @735842
     /*  735842 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(735917), // Rule ID 12173 //
     /*  735847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735915 */     GIR_RootConstrainSelectedInstOperands,
     /*  735916 */     // GIR_Coverage, 12173,
     /*  735916 */     GIR_EraseRootFromParent_Done,
     /*  735917 */   // Label 11564: @735917
     /*  735917 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(735992), // Rule ID 12176 //
     /*  735922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735990 */     GIR_RootConstrainSelectedInstOperands,
     /*  735991 */     // GIR_Coverage, 12176,
     /*  735991 */     GIR_EraseRootFromParent_Done,
     /*  735992 */   // Label 11565: @735992
     /*  735992 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(736067), // Rule ID 12177 //
     /*  735997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  736046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736065 */     GIR_RootConstrainSelectedInstOperands,
     /*  736066 */     // GIR_Coverage, 12177,
     /*  736066 */     GIR_EraseRootFromParent_Done,
     /*  736067 */   // Label 11566: @736067
     /*  736067 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(736142), // Rule ID 12180 //
     /*  736072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  736121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736140 */     GIR_RootConstrainSelectedInstOperands,
     /*  736141 */     // GIR_Coverage, 12180,
     /*  736141 */     GIR_EraseRootFromParent_Done,
     /*  736142 */   // Label 11567: @736142
     /*  736142 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(736217), // Rule ID 12181 //
     /*  736147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  736196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736215 */     GIR_RootConstrainSelectedInstOperands,
     /*  736216 */     // GIR_Coverage, 12181,
     /*  736216 */     GIR_EraseRootFromParent_Done,
     /*  736217 */   // Label 11568: @736217
     /*  736217 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(736292), // Rule ID 12184 //
     /*  736222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  736271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736290 */     GIR_RootConstrainSelectedInstOperands,
     /*  736291 */     // GIR_Coverage, 12184,
     /*  736291 */     GIR_EraseRootFromParent_Done,
     /*  736292 */   // Label 11569: @736292
     /*  736292 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(736367), // Rule ID 12185 //
     /*  736297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  736346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736365 */     GIR_RootConstrainSelectedInstOperands,
     /*  736366 */     // GIR_Coverage, 12185,
     /*  736366 */     GIR_EraseRootFromParent_Done,
     /*  736367 */   // Label 11570: @736367
     /*  736367 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(736442), // Rule ID 12188 //
     /*  736372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736440 */     GIR_RootConstrainSelectedInstOperands,
     /*  736441 */     // GIR_Coverage, 12188,
     /*  736441 */     GIR_EraseRootFromParent_Done,
     /*  736442 */   // Label 11571: @736442
     /*  736442 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(736517), // Rule ID 12189 //
     /*  736447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736493 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736515 */     GIR_RootConstrainSelectedInstOperands,
     /*  736516 */     // GIR_Coverage, 12189,
     /*  736516 */     GIR_EraseRootFromParent_Done,
     /*  736517 */   // Label 11572: @736517
     /*  736517 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(736592), // Rule ID 12192 //
     /*  736522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736590 */     GIR_RootConstrainSelectedInstOperands,
     /*  736591 */     // GIR_Coverage, 12192,
     /*  736591 */     GIR_EraseRootFromParent_Done,
     /*  736592 */   // Label 11573: @736592
     /*  736592 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(736667), // Rule ID 12193 //
     /*  736597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736643 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736665 */     GIR_RootConstrainSelectedInstOperands,
     /*  736666 */     // GIR_Coverage, 12193,
     /*  736666 */     GIR_EraseRootFromParent_Done,
     /*  736667 */   // Label 11574: @736667
     /*  736667 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(736742), // Rule ID 12196 //
     /*  736672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736740 */     GIR_RootConstrainSelectedInstOperands,
     /*  736741 */     // GIR_Coverage, 12196,
     /*  736741 */     GIR_EraseRootFromParent_Done,
     /*  736742 */   // Label 11575: @736742
     /*  736742 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(736817), // Rule ID 12197 //
     /*  736747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736815 */     GIR_RootConstrainSelectedInstOperands,
     /*  736816 */     // GIR_Coverage, 12197,
     /*  736816 */     GIR_EraseRootFromParent_Done,
     /*  736817 */   // Label 11576: @736817
     /*  736817 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(736892), // Rule ID 12200 //
     /*  736822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736890 */     GIR_RootConstrainSelectedInstOperands,
     /*  736891 */     // GIR_Coverage, 12200,
     /*  736891 */     GIR_EraseRootFromParent_Done,
     /*  736892 */   // Label 11577: @736892
     /*  736892 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(736967), // Rule ID 12201 //
     /*  736897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736943 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736965 */     GIR_RootConstrainSelectedInstOperands,
     /*  736966 */     // GIR_Coverage, 12201,
     /*  736966 */     GIR_EraseRootFromParent_Done,
     /*  736967 */   // Label 11578: @736967
     /*  736967 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(737042), // Rule ID 12204 //
     /*  736972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  737021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737040 */     GIR_RootConstrainSelectedInstOperands,
     /*  737041 */     // GIR_Coverage, 12204,
     /*  737041 */     GIR_EraseRootFromParent_Done,
     /*  737042 */   // Label 11579: @737042
     /*  737042 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(737117), // Rule ID 12205 //
     /*  737047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  737067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737093 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  737096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737115 */     GIR_RootConstrainSelectedInstOperands,
     /*  737116 */     // GIR_Coverage, 12205,
     /*  737116 */     GIR_EraseRootFromParent_Done,
     /*  737117 */   // Label 11580: @737117
     /*  737117 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(737192), // Rule ID 12208 //
     /*  737122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  737142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  737171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737190 */     GIR_RootConstrainSelectedInstOperands,
     /*  737191 */     // GIR_Coverage, 12208,
     /*  737191 */     GIR_EraseRootFromParent_Done,
     /*  737192 */   // Label 11581: @737192
     /*  737192 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(737267), // Rule ID 12209 //
     /*  737197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  737217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737243 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  737246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737265 */     GIR_RootConstrainSelectedInstOperands,
     /*  737266 */     // GIR_Coverage, 12209,
     /*  737266 */     GIR_EraseRootFromParent_Done,
     /*  737267 */   // Label 11582: @737267
     /*  737267 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(737342), // Rule ID 12212 //
     /*  737272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  737292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  737321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737340 */     GIR_RootConstrainSelectedInstOperands,
     /*  737341 */     // GIR_Coverage, 12212,
     /*  737341 */     GIR_EraseRootFromParent_Done,
     /*  737342 */   // Label 11583: @737342
     /*  737342 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(737417), // Rule ID 12213 //
     /*  737347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  737367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737393 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  737396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737415 */     GIR_RootConstrainSelectedInstOperands,
     /*  737416 */     // GIR_Coverage, 12213,
     /*  737416 */     GIR_EraseRootFromParent_Done,
     /*  737417 */   // Label 11584: @737417
     /*  737417 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(737492), // Rule ID 12216 //
     /*  737422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737490 */     GIR_RootConstrainSelectedInstOperands,
     /*  737491 */     // GIR_Coverage, 12216,
     /*  737491 */     GIR_EraseRootFromParent_Done,
     /*  737492 */   // Label 11585: @737492
     /*  737492 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(737567), // Rule ID 12217 //
     /*  737497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737565 */     GIR_RootConstrainSelectedInstOperands,
     /*  737566 */     // GIR_Coverage, 12217,
     /*  737566 */     GIR_EraseRootFromParent_Done,
     /*  737567 */   // Label 11586: @737567
     /*  737567 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(737642), // Rule ID 12220 //
     /*  737572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737640 */     GIR_RootConstrainSelectedInstOperands,
     /*  737641 */     // GIR_Coverage, 12220,
     /*  737641 */     GIR_EraseRootFromParent_Done,
     /*  737642 */   // Label 11587: @737642
     /*  737642 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(737717), // Rule ID 12221 //
     /*  737647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737715 */     GIR_RootConstrainSelectedInstOperands,
     /*  737716 */     // GIR_Coverage, 12221,
     /*  737716 */     GIR_EraseRootFromParent_Done,
     /*  737717 */   // Label 11588: @737717
     /*  737717 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(737792), // Rule ID 12224 //
     /*  737722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737790 */     GIR_RootConstrainSelectedInstOperands,
     /*  737791 */     // GIR_Coverage, 12224,
     /*  737791 */     GIR_EraseRootFromParent_Done,
     /*  737792 */   // Label 11589: @737792
     /*  737792 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(737867), // Rule ID 12225 //
     /*  737797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737865 */     GIR_RootConstrainSelectedInstOperands,
     /*  737866 */     // GIR_Coverage, 12225,
     /*  737866 */     GIR_EraseRootFromParent_Done,
     /*  737867 */   // Label 11590: @737867
     /*  737867 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(737942), // Rule ID 12228 //
     /*  737872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737940 */     GIR_RootConstrainSelectedInstOperands,
     /*  737941 */     // GIR_Coverage, 12228,
     /*  737941 */     GIR_EraseRootFromParent_Done,
     /*  737942 */   // Label 11591: @737942
     /*  737942 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(738017), // Rule ID 12229 //
     /*  737947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738015 */     GIR_RootConstrainSelectedInstOperands,
     /*  738016 */     // GIR_Coverage, 12229,
     /*  738016 */     GIR_EraseRootFromParent_Done,
     /*  738017 */   // Label 11592: @738017
     /*  738017 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(738092), // Rule ID 12232 //
     /*  738022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  738071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738090 */     GIR_RootConstrainSelectedInstOperands,
     /*  738091 */     // GIR_Coverage, 12232,
     /*  738091 */     GIR_EraseRootFromParent_Done,
     /*  738092 */   // Label 11593: @738092
     /*  738092 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(738167), // Rule ID 12233 //
     /*  738097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  738117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  738146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738165 */     GIR_RootConstrainSelectedInstOperands,
     /*  738166 */     // GIR_Coverage, 12233,
     /*  738166 */     GIR_EraseRootFromParent_Done,
     /*  738167 */   // Label 11594: @738167
     /*  738167 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(738242), // Rule ID 12236 //
     /*  738172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  738192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  738221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738240 */     GIR_RootConstrainSelectedInstOperands,
     /*  738241 */     // GIR_Coverage, 12236,
     /*  738241 */     GIR_EraseRootFromParent_Done,
     /*  738242 */   // Label 11595: @738242
     /*  738242 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(738317), // Rule ID 12237 //
     /*  738247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  738267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  738296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738315 */     GIR_RootConstrainSelectedInstOperands,
     /*  738316 */     // GIR_Coverage, 12237,
     /*  738316 */     GIR_EraseRootFromParent_Done,
     /*  738317 */   // Label 11596: @738317
     /*  738317 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(738392), // Rule ID 12240 //
     /*  738322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  738342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  738371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738390 */     GIR_RootConstrainSelectedInstOperands,
     /*  738391 */     // GIR_Coverage, 12240,
     /*  738391 */     GIR_EraseRootFromParent_Done,
     /*  738392 */   // Label 11597: @738392
     /*  738392 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(738467), // Rule ID 12241 //
     /*  738397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  738417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738443 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  738446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738465 */     GIR_RootConstrainSelectedInstOperands,
     /*  738466 */     // GIR_Coverage, 12241,
     /*  738466 */     GIR_EraseRootFromParent_Done,
     /*  738467 */   // Label 11598: @738467
     /*  738467 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(738542), // Rule ID 12244 //
     /*  738472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738540 */     GIR_RootConstrainSelectedInstOperands,
     /*  738541 */     // GIR_Coverage, 12244,
     /*  738541 */     GIR_EraseRootFromParent_Done,
     /*  738542 */   // Label 11599: @738542
     /*  738542 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(738617), // Rule ID 12245 //
     /*  738547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738593 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738615 */     GIR_RootConstrainSelectedInstOperands,
     /*  738616 */     // GIR_Coverage, 12245,
     /*  738616 */     GIR_EraseRootFromParent_Done,
     /*  738617 */   // Label 11600: @738617
     /*  738617 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(738692), // Rule ID 12248 //
     /*  738622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738690 */     GIR_RootConstrainSelectedInstOperands,
     /*  738691 */     // GIR_Coverage, 12248,
     /*  738691 */     GIR_EraseRootFromParent_Done,
     /*  738692 */   // Label 11601: @738692
     /*  738692 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(738767), // Rule ID 12249 //
     /*  738697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738765 */     GIR_RootConstrainSelectedInstOperands,
     /*  738766 */     // GIR_Coverage, 12249,
     /*  738766 */     GIR_EraseRootFromParent_Done,
     /*  738767 */   // Label 11602: @738767
     /*  738767 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(738842), // Rule ID 12252 //
     /*  738772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738840 */     GIR_RootConstrainSelectedInstOperands,
     /*  738841 */     // GIR_Coverage, 12252,
     /*  738841 */     GIR_EraseRootFromParent_Done,
     /*  738842 */   // Label 11603: @738842
     /*  738842 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(738917), // Rule ID 12253 //
     /*  738847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738893 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738915 */     GIR_RootConstrainSelectedInstOperands,
     /*  738916 */     // GIR_Coverage, 12253,
     /*  738916 */     GIR_EraseRootFromParent_Done,
     /*  738917 */   // Label 11604: @738917
     /*  738917 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(738992), // Rule ID 12256 //
     /*  738922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738990 */     GIR_RootConstrainSelectedInstOperands,
     /*  738991 */     // GIR_Coverage, 12256,
     /*  738991 */     GIR_EraseRootFromParent_Done,
     /*  738992 */   // Label 11605: @738992
     /*  738992 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(739067), // Rule ID 12257 //
     /*  738997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  739017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739043 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  739046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739065 */     GIR_RootConstrainSelectedInstOperands,
     /*  739066 */     // GIR_Coverage, 12257,
     /*  739066 */     GIR_EraseRootFromParent_Done,
     /*  739067 */   // Label 11606: @739067
     /*  739067 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(739142), // Rule ID 12260 //
     /*  739072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  739092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  739121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739140 */     GIR_RootConstrainSelectedInstOperands,
     /*  739141 */     // GIR_Coverage, 12260,
     /*  739141 */     GIR_EraseRootFromParent_Done,
     /*  739142 */   // Label 11607: @739142
     /*  739142 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(739217), // Rule ID 12261 //
     /*  739147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  739167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  739196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739215 */     GIR_RootConstrainSelectedInstOperands,
     /*  739216 */     // GIR_Coverage, 12261,
     /*  739216 */     GIR_EraseRootFromParent_Done,
     /*  739217 */   // Label 11608: @739217
     /*  739217 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(739292), // Rule ID 12264 //
     /*  739222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  739242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  739271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739290 */     GIR_RootConstrainSelectedInstOperands,
     /*  739291 */     // GIR_Coverage, 12264,
     /*  739291 */     GIR_EraseRootFromParent_Done,
     /*  739292 */   // Label 11609: @739292
     /*  739292 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(739367), // Rule ID 12265 //
     /*  739297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  739317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739343 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  739346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739365 */     GIR_RootConstrainSelectedInstOperands,
     /*  739366 */     // GIR_Coverage, 12265,
     /*  739366 */     GIR_EraseRootFromParent_Done,
     /*  739367 */   // Label 11610: @739367
     /*  739367 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(739442), // Rule ID 12268 //
     /*  739372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739440 */     GIR_RootConstrainSelectedInstOperands,
     /*  739441 */     // GIR_Coverage, 12268,
     /*  739441 */     GIR_EraseRootFromParent_Done,
     /*  739442 */   // Label 11611: @739442
     /*  739442 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(739517), // Rule ID 12269 //
     /*  739447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739493 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739515 */     GIR_RootConstrainSelectedInstOperands,
     /*  739516 */     // GIR_Coverage, 12269,
     /*  739516 */     GIR_EraseRootFromParent_Done,
     /*  739517 */   // Label 11612: @739517
     /*  739517 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(739592), // Rule ID 12272 //
     /*  739522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739590 */     GIR_RootConstrainSelectedInstOperands,
     /*  739591 */     // GIR_Coverage, 12272,
     /*  739591 */     GIR_EraseRootFromParent_Done,
     /*  739592 */   // Label 11613: @739592
     /*  739592 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(739667), // Rule ID 12273 //
     /*  739597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739665 */     GIR_RootConstrainSelectedInstOperands,
     /*  739666 */     // GIR_Coverage, 12273,
     /*  739666 */     GIR_EraseRootFromParent_Done,
     /*  739667 */   // Label 11614: @739667
     /*  739667 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(739742), // Rule ID 12276 //
     /*  739672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739740 */     GIR_RootConstrainSelectedInstOperands,
     /*  739741 */     // GIR_Coverage, 12276,
     /*  739741 */     GIR_EraseRootFromParent_Done,
     /*  739742 */   // Label 11615: @739742
     /*  739742 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(739817), // Rule ID 12277 //
     /*  739747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739815 */     GIR_RootConstrainSelectedInstOperands,
     /*  739816 */     // GIR_Coverage, 12277,
     /*  739816 */     GIR_EraseRootFromParent_Done,
     /*  739817 */   // Label 11616: @739817
     /*  739817 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(739892), // Rule ID 12280 //
     /*  739822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739890 */     GIR_RootConstrainSelectedInstOperands,
     /*  739891 */     // GIR_Coverage, 12280,
     /*  739891 */     GIR_EraseRootFromParent_Done,
     /*  739892 */   // Label 11617: @739892
     /*  739892 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(739967), // Rule ID 12281 //
     /*  739897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739965 */     GIR_RootConstrainSelectedInstOperands,
     /*  739966 */     // GIR_Coverage, 12281,
     /*  739966 */     GIR_EraseRootFromParent_Done,
     /*  739967 */   // Label 11618: @739967
     /*  739967 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(740042), // Rule ID 12284 //
     /*  739972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  740021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740040 */     GIR_RootConstrainSelectedInstOperands,
     /*  740041 */     // GIR_Coverage, 12284,
     /*  740041 */     GIR_EraseRootFromParent_Done,
     /*  740042 */   // Label 11619: @740042
     /*  740042 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(740117), // Rule ID 12285 //
     /*  740047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740093 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  740096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740115 */     GIR_RootConstrainSelectedInstOperands,
     /*  740116 */     // GIR_Coverage, 12285,
     /*  740116 */     GIR_EraseRootFromParent_Done,
     /*  740117 */   // Label 11620: @740117
     /*  740117 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(740192), // Rule ID 12288 //
     /*  740122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  740171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740190 */     GIR_RootConstrainSelectedInstOperands,
     /*  740191 */     // GIR_Coverage, 12288,
     /*  740191 */     GIR_EraseRootFromParent_Done,
     /*  740192 */   // Label 11621: @740192
     /*  740192 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(740267), // Rule ID 12289 //
     /*  740197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  740246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740265 */     GIR_RootConstrainSelectedInstOperands,
     /*  740266 */     // GIR_Coverage, 12289,
     /*  740266 */     GIR_EraseRootFromParent_Done,
     /*  740267 */   // Label 11622: @740267
     /*  740267 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(740342), // Rule ID 12292 //
     /*  740272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  740321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740340 */     GIR_RootConstrainSelectedInstOperands,
     /*  740341 */     // GIR_Coverage, 12292,
     /*  740341 */     GIR_EraseRootFromParent_Done,
     /*  740342 */   // Label 11623: @740342
     /*  740342 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(740417), // Rule ID 12293 //
     /*  740347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  740396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740415 */     GIR_RootConstrainSelectedInstOperands,
     /*  740416 */     // GIR_Coverage, 12293,
     /*  740416 */     GIR_EraseRootFromParent_Done,
     /*  740417 */   // Label 11624: @740417
     /*  740417 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(740492), // Rule ID 12296 //
     /*  740422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740490 */     GIR_RootConstrainSelectedInstOperands,
     /*  740491 */     // GIR_Coverage, 12296,
     /*  740491 */     GIR_EraseRootFromParent_Done,
     /*  740492 */   // Label 11625: @740492
     /*  740492 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(740567), // Rule ID 12297 //
     /*  740497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740543 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740565 */     GIR_RootConstrainSelectedInstOperands,
     /*  740566 */     // GIR_Coverage, 12297,
     /*  740566 */     GIR_EraseRootFromParent_Done,
     /*  740567 */   // Label 11626: @740567
     /*  740567 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(740642), // Rule ID 12300 //
     /*  740572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740640 */     GIR_RootConstrainSelectedInstOperands,
     /*  740641 */     // GIR_Coverage, 12300,
     /*  740641 */     GIR_EraseRootFromParent_Done,
     /*  740642 */   // Label 11627: @740642
     /*  740642 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(740717), // Rule ID 12301 //
     /*  740647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740715 */     GIR_RootConstrainSelectedInstOperands,
     /*  740716 */     // GIR_Coverage, 12301,
     /*  740716 */     GIR_EraseRootFromParent_Done,
     /*  740717 */   // Label 11628: @740717
     /*  740717 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(740792), // Rule ID 12304 //
     /*  740722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740790 */     GIR_RootConstrainSelectedInstOperands,
     /*  740791 */     // GIR_Coverage, 12304,
     /*  740791 */     GIR_EraseRootFromParent_Done,
     /*  740792 */   // Label 11629: @740792
     /*  740792 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(740867), // Rule ID 12305 //
     /*  740797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740865 */     GIR_RootConstrainSelectedInstOperands,
     /*  740866 */     // GIR_Coverage, 12305,
     /*  740866 */     GIR_EraseRootFromParent_Done,
     /*  740867 */   // Label 11630: @740867
     /*  740867 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(740942), // Rule ID 12308 //
     /*  740872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740940 */     GIR_RootConstrainSelectedInstOperands,
     /*  740941 */     // GIR_Coverage, 12308,
     /*  740941 */     GIR_EraseRootFromParent_Done,
     /*  740942 */   // Label 11631: @740942
     /*  740942 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(741017), // Rule ID 12309 //
     /*  740947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740993 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11569:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741015 */     GIR_RootConstrainSelectedInstOperands,
     /*  741016 */     // GIR_Coverage, 12309,
     /*  741016 */     GIR_EraseRootFromParent_Done,
     /*  741017 */   // Label 11632: @741017
     /*  741017 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(741092), // Rule ID 12312 //
     /*  741022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  741071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741090 */     GIR_RootConstrainSelectedInstOperands,
     /*  741091 */     // GIR_Coverage, 12312,
     /*  741091 */     GIR_EraseRootFromParent_Done,
     /*  741092 */   // Label 11633: @741092
     /*  741092 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(741167), // Rule ID 12313 //
     /*  741097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11569:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  741146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741165 */     GIR_RootConstrainSelectedInstOperands,
     /*  741166 */     // GIR_Coverage, 12313,
     /*  741166 */     GIR_EraseRootFromParent_Done,
     /*  741167 */   // Label 11634: @741167
     /*  741167 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(741242), // Rule ID 12316 //
     /*  741172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  741221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741240 */     GIR_RootConstrainSelectedInstOperands,
     /*  741241 */     // GIR_Coverage, 12316,
     /*  741241 */     GIR_EraseRootFromParent_Done,
     /*  741242 */   // Label 11635: @741242
     /*  741242 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(741317), // Rule ID 12317 //
     /*  741247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11569:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  741296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741315 */     GIR_RootConstrainSelectedInstOperands,
     /*  741316 */     // GIR_Coverage, 12317,
     /*  741316 */     GIR_EraseRootFromParent_Done,
     /*  741317 */   // Label 11636: @741317
     /*  741317 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(741392), // Rule ID 12320 //
     /*  741322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  741325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  741368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  741371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741390 */     GIR_RootConstrainSelectedInstOperands,
     /*  741391 */     // GIR_Coverage, 12320,
     /*  741391 */     GIR_EraseRootFromParent_Done,
     /*  741392 */   // Label 11637: @741392
     /*  741392 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(741467), // Rule ID 12321 //
     /*  741397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  741400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11569:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  741443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  741446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741465 */     GIR_RootConstrainSelectedInstOperands,
     /*  741466 */     // GIR_Coverage, 12321,
     /*  741466 */     GIR_EraseRootFromParent_Done,
     /*  741467 */   // Label 11638: @741467
     /*  741467 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(741542), // Rule ID 12324 //
     /*  741472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741540 */     GIR_RootConstrainSelectedInstOperands,
     /*  741541 */     // GIR_Coverage, 12324,
     /*  741541 */     GIR_EraseRootFromParent_Done,
     /*  741542 */   // Label 11639: @741542
     /*  741542 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(741617), // Rule ID 12325 //
     /*  741547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741615 */     GIR_RootConstrainSelectedInstOperands,
     /*  741616 */     // GIR_Coverage, 12325,
     /*  741616 */     GIR_EraseRootFromParent_Done,
     /*  741617 */   // Label 11640: @741617
     /*  741617 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(741692), // Rule ID 12328 //
     /*  741622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741690 */     GIR_RootConstrainSelectedInstOperands,
     /*  741691 */     // GIR_Coverage, 12328,
     /*  741691 */     GIR_EraseRootFromParent_Done,
     /*  741692 */   // Label 11641: @741692
     /*  741692 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(741767), // Rule ID 12329 //
     /*  741697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741743 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741765 */     GIR_RootConstrainSelectedInstOperands,
     /*  741766 */     // GIR_Coverage, 12329,
     /*  741766 */     GIR_EraseRootFromParent_Done,
     /*  741767 */   // Label 11642: @741767
     /*  741767 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(741842), // Rule ID 12332 //
     /*  741772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741840 */     GIR_RootConstrainSelectedInstOperands,
     /*  741841 */     // GIR_Coverage, 12332,
     /*  741841 */     GIR_EraseRootFromParent_Done,
     /*  741842 */   // Label 11643: @741842
     /*  741842 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(741917), // Rule ID 12333 //
     /*  741847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741915 */     GIR_RootConstrainSelectedInstOperands,
     /*  741916 */     // GIR_Coverage, 12333,
     /*  741916 */     GIR_EraseRootFromParent_Done,
     /*  741917 */   // Label 11644: @741917
     /*  741917 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(741992), // Rule ID 12336 //
     /*  741922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741990 */     GIR_RootConstrainSelectedInstOperands,
     /*  741991 */     // GIR_Coverage, 12336,
     /*  741991 */     GIR_EraseRootFromParent_Done,
     /*  741992 */   // Label 11645: @741992
     /*  741992 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(742067), // Rule ID 12337 //
     /*  741997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  742046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742065 */     GIR_RootConstrainSelectedInstOperands,
     /*  742066 */     // GIR_Coverage, 12337,
     /*  742066 */     GIR_EraseRootFromParent_Done,
     /*  742067 */   // Label 11646: @742067
     /*  742067 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(742142), // Rule ID 12340 //
     /*  742072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  742121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742140 */     GIR_RootConstrainSelectedInstOperands,
     /*  742141 */     // GIR_Coverage, 12340,
     /*  742141 */     GIR_EraseRootFromParent_Done,
     /*  742142 */   // Label 11647: @742142
     /*  742142 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(742217), // Rule ID 12341 //
     /*  742147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  742196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742215 */     GIR_RootConstrainSelectedInstOperands,
     /*  742216 */     // GIR_Coverage, 12341,
     /*  742216 */     GIR_EraseRootFromParent_Done,
     /*  742217 */   // Label 11648: @742217
     /*  742217 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(742292), // Rule ID 12344 //
     /*  742222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  742271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742290 */     GIR_RootConstrainSelectedInstOperands,
     /*  742291 */     // GIR_Coverage, 12344,
     /*  742291 */     GIR_EraseRootFromParent_Done,
     /*  742292 */   // Label 11649: @742292
     /*  742292 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(742367), // Rule ID 12345 //
     /*  742297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  742346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742365 */     GIR_RootConstrainSelectedInstOperands,
     /*  742366 */     // GIR_Coverage, 12345,
     /*  742366 */     GIR_EraseRootFromParent_Done,
     /*  742367 */   // Label 11650: @742367
     /*  742367 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(742442), // Rule ID 12348 //
     /*  742372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742440 */     GIR_RootConstrainSelectedInstOperands,
     /*  742441 */     // GIR_Coverage, 12348,
     /*  742441 */     GIR_EraseRootFromParent_Done,
     /*  742442 */   // Label 11651: @742442
     /*  742442 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(742517), // Rule ID 12349 //
     /*  742447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742515 */     GIR_RootConstrainSelectedInstOperands,
     /*  742516 */     // GIR_Coverage, 12349,
     /*  742516 */     GIR_EraseRootFromParent_Done,
     /*  742517 */   // Label 11652: @742517
     /*  742517 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(742592), // Rule ID 12352 //
     /*  742522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742590 */     GIR_RootConstrainSelectedInstOperands,
     /*  742591 */     // GIR_Coverage, 12352,
     /*  742591 */     GIR_EraseRootFromParent_Done,
     /*  742592 */   // Label 11653: @742592
     /*  742592 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(742667), // Rule ID 12353 //
     /*  742597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742665 */     GIR_RootConstrainSelectedInstOperands,
     /*  742666 */     // GIR_Coverage, 12353,
     /*  742666 */     GIR_EraseRootFromParent_Done,
     /*  742667 */   // Label 11654: @742667
     /*  742667 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(742742), // Rule ID 12356 //
     /*  742672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742740 */     GIR_RootConstrainSelectedInstOperands,
     /*  742741 */     // GIR_Coverage, 12356,
     /*  742741 */     GIR_EraseRootFromParent_Done,
     /*  742742 */   // Label 11655: @742742
     /*  742742 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(742817), // Rule ID 12357 //
     /*  742747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742815 */     GIR_RootConstrainSelectedInstOperands,
     /*  742816 */     // GIR_Coverage, 12357,
     /*  742816 */     GIR_EraseRootFromParent_Done,
     /*  742817 */   // Label 11656: @742817
     /*  742817 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(742892), // Rule ID 12360 //
     /*  742822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742890 */     GIR_RootConstrainSelectedInstOperands,
     /*  742891 */     // GIR_Coverage, 12360,
     /*  742891 */     GIR_EraseRootFromParent_Done,
     /*  742892 */   // Label 11657: @742892
     /*  742892 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(742967), // Rule ID 12361 //
     /*  742897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11569:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742965 */     GIR_RootConstrainSelectedInstOperands,
     /*  742966 */     // GIR_Coverage, 12361,
     /*  742966 */     GIR_EraseRootFromParent_Done,
     /*  742967 */   // Label 11658: @742967
     /*  742967 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(743042), // Rule ID 12364 //
     /*  742972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  743021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743040 */     GIR_RootConstrainSelectedInstOperands,
     /*  743041 */     // GIR_Coverage, 12364,
     /*  743041 */     GIR_EraseRootFromParent_Done,
     /*  743042 */   // Label 11659: @743042
     /*  743042 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(743117), // Rule ID 12365 //
     /*  743047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11569:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  743096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743115 */     GIR_RootConstrainSelectedInstOperands,
     /*  743116 */     // GIR_Coverage, 12365,
     /*  743116 */     GIR_EraseRootFromParent_Done,
     /*  743117 */   // Label 11660: @743117
     /*  743117 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(743192), // Rule ID 12368 //
     /*  743122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  743171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743190 */     GIR_RootConstrainSelectedInstOperands,
     /*  743191 */     // GIR_Coverage, 12368,
     /*  743191 */     GIR_EraseRootFromParent_Done,
     /*  743192 */   // Label 11661: @743192
     /*  743192 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(743267), // Rule ID 12369 //
     /*  743197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11569:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  743246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743265 */     GIR_RootConstrainSelectedInstOperands,
     /*  743266 */     // GIR_Coverage, 12369,
     /*  743266 */     GIR_EraseRootFromParent_Done,
     /*  743267 */   // Label 11662: @743267
     /*  743267 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(743342), // Rule ID 12372 //
     /*  743272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  743292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  743321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743340 */     GIR_RootConstrainSelectedInstOperands,
     /*  743341 */     // GIR_Coverage, 12372,
     /*  743341 */     GIR_EraseRootFromParent_Done,
     /*  743342 */   // Label 11663: @743342
     /*  743342 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(743417), // Rule ID 12373 //
     /*  743347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  743367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  743396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743415 */     GIR_RootConstrainSelectedInstOperands,
     /*  743416 */     // GIR_Coverage, 12373,
     /*  743416 */     GIR_EraseRootFromParent_Done,
     /*  743417 */   // Label 11664: @743417
     /*  743417 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(743492), // Rule ID 12376 //
     /*  743422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743490 */     GIR_RootConstrainSelectedInstOperands,
     /*  743491 */     // GIR_Coverage, 12376,
     /*  743491 */     GIR_EraseRootFromParent_Done,
     /*  743492 */   // Label 11665: @743492
     /*  743492 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(743567), // Rule ID 12377 //
     /*  743497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743543 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743565 */     GIR_RootConstrainSelectedInstOperands,
     /*  743566 */     // GIR_Coverage, 12377,
     /*  743566 */     GIR_EraseRootFromParent_Done,
     /*  743567 */   // Label 11666: @743567
     /*  743567 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(743642), // Rule ID 12380 //
     /*  743572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743640 */     GIR_RootConstrainSelectedInstOperands,
     /*  743641 */     // GIR_Coverage, 12380,
     /*  743641 */     GIR_EraseRootFromParent_Done,
     /*  743642 */   // Label 11667: @743642
     /*  743642 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(743717), // Rule ID 12381 //
     /*  743647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743715 */     GIR_RootConstrainSelectedInstOperands,
     /*  743716 */     // GIR_Coverage, 12381,
     /*  743716 */     GIR_EraseRootFromParent_Done,
     /*  743717 */   // Label 11668: @743717
     /*  743717 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(743792), // Rule ID 12384 //
     /*  743722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743790 */     GIR_RootConstrainSelectedInstOperands,
     /*  743791 */     // GIR_Coverage, 12384,
     /*  743791 */     GIR_EraseRootFromParent_Done,
     /*  743792 */   // Label 11669: @743792
     /*  743792 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(743867), // Rule ID 12385 //
     /*  743797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743865 */     GIR_RootConstrainSelectedInstOperands,
     /*  743866 */     // GIR_Coverage, 12385,
     /*  743866 */     GIR_EraseRootFromParent_Done,
     /*  743867 */   // Label 11670: @743867
     /*  743867 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(743942), // Rule ID 12388 //
     /*  743872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743940 */     GIR_RootConstrainSelectedInstOperands,
     /*  743941 */     // GIR_Coverage, 12388,
     /*  743941 */     GIR_EraseRootFromParent_Done,
     /*  743942 */   // Label 11671: @743942
     /*  743942 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(744017), // Rule ID 12389 //
     /*  743947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744015 */     GIR_RootConstrainSelectedInstOperands,
     /*  744016 */     // GIR_Coverage, 12389,
     /*  744016 */     GIR_EraseRootFromParent_Done,
     /*  744017 */   // Label 11672: @744017
     /*  744017 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(744092), // Rule ID 12392 //
     /*  744022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  744033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  744036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  744039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  744042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744090 */     GIR_RootConstrainSelectedInstOperands,
     /*  744091 */     // GIR_Coverage, 12392,
     /*  744091 */     GIR_EraseRootFromParent_Done,
     /*  744092 */   // Label 11673: @744092
     /*  744092 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(744167), // Rule ID 12393 //
     /*  744097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  744108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  744111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  744114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  744117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744165 */     GIR_RootConstrainSelectedInstOperands,
     /*  744166 */     // GIR_Coverage, 12393,
     /*  744166 */     GIR_EraseRootFromParent_Done,
     /*  744167 */   // Label 11674: @744167
     /*  744167 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(744242), // Rule ID 12396 //
     /*  744172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  744189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  744192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  744221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744240 */     GIR_RootConstrainSelectedInstOperands,
     /*  744241 */     // GIR_Coverage, 12396,
     /*  744241 */     GIR_EraseRootFromParent_Done,
     /*  744242 */   // Label 11675: @744242
     /*  744242 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(744317), // Rule ID 12397 //
     /*  744247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  744264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  744267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744293 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  744296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744315 */     GIR_RootConstrainSelectedInstOperands,
     /*  744316 */     // GIR_Coverage, 12397,
     /*  744316 */     GIR_EraseRootFromParent_Done,
     /*  744317 */   // Label 11676: @744317
     /*  744317 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(744392), // Rule ID 12400 //
     /*  744322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  744342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744390 */     GIR_RootConstrainSelectedInstOperands,
     /*  744391 */     // GIR_Coverage, 12400,
     /*  744391 */     GIR_EraseRootFromParent_Done,
     /*  744392 */   // Label 11677: @744392
     /*  744392 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(744467), // Rule ID 12401 //
     /*  744397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  744417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744443 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744465 */     GIR_RootConstrainSelectedInstOperands,
     /*  744466 */     // GIR_Coverage, 12401,
     /*  744466 */     GIR_EraseRootFromParent_Done,
     /*  744467 */   // Label 11678: @744467
     /*  744467 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(744542), // Rule ID 12404 //
     /*  744472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744540 */     GIR_RootConstrainSelectedInstOperands,
     /*  744541 */     // GIR_Coverage, 12404,
     /*  744541 */     GIR_EraseRootFromParent_Done,
     /*  744542 */   // Label 11679: @744542
     /*  744542 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(744617), // Rule ID 12405 //
     /*  744547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744615 */     GIR_RootConstrainSelectedInstOperands,
     /*  744616 */     // GIR_Coverage, 12405,
     /*  744616 */     GIR_EraseRootFromParent_Done,
     /*  744617 */   // Label 11680: @744617
     /*  744617 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(744692), // Rule ID 12408 //
     /*  744622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744690 */     GIR_RootConstrainSelectedInstOperands,
     /*  744691 */     // GIR_Coverage, 12408,
     /*  744691 */     GIR_EraseRootFromParent_Done,
     /*  744692 */   // Label 11681: @744692
     /*  744692 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(744767), // Rule ID 12409 //
     /*  744697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744765 */     GIR_RootConstrainSelectedInstOperands,
     /*  744766 */     // GIR_Coverage, 12409,
     /*  744766 */     GIR_EraseRootFromParent_Done,
     /*  744767 */   // Label 11682: @744767
     /*  744767 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(744842), // Rule ID 12412 //
     /*  744772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744840 */     GIR_RootConstrainSelectedInstOperands,
     /*  744841 */     // GIR_Coverage, 12412,
     /*  744841 */     GIR_EraseRootFromParent_Done,
     /*  744842 */   // Label 11683: @744842
     /*  744842 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(744917), // Rule ID 12413 //
     /*  744847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744915 */     GIR_RootConstrainSelectedInstOperands,
     /*  744916 */     // GIR_Coverage, 12413,
     /*  744916 */     GIR_EraseRootFromParent_Done,
     /*  744917 */   // Label 11684: @744917
     /*  744917 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(744992), // Rule ID 12416 //
     /*  744922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744990 */     GIR_RootConstrainSelectedInstOperands,
     /*  744991 */     // GIR_Coverage, 12416,
     /*  744991 */     GIR_EraseRootFromParent_Done,
     /*  744992 */   // Label 11685: @744992
     /*  744992 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(745067), // Rule ID 12417 //
     /*  744997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  745008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  745011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  745014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  745017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  745046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745065 */     GIR_RootConstrainSelectedInstOperands,
     /*  745066 */     // GIR_Coverage, 12417,
     /*  745066 */     GIR_EraseRootFromParent_Done,
     /*  745067 */   // Label 11686: @745067
     /*  745067 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(745142), // Rule ID 12420 //
     /*  745072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  745083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  745086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  745089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  745121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745140 */     GIR_RootConstrainSelectedInstOperands,
     /*  745141 */     // GIR_Coverage, 12420,
     /*  745141 */     GIR_EraseRootFromParent_Done,
     /*  745142 */   // Label 11687: @745142
     /*  745142 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(745217), // Rule ID 12421 //
     /*  745147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  745158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  745161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  745164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  745167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  745196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745215 */     GIR_RootConstrainSelectedInstOperands,
     /*  745216 */     // GIR_Coverage, 12421,
     /*  745216 */     GIR_EraseRootFromParent_Done,
     /*  745217 */   // Label 11688: @745217
     /*  745217 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(745292), // Rule ID 12424 //
     /*  745222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  745233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  745236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  745242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  745271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745290 */     GIR_RootConstrainSelectedInstOperands,
     /*  745291 */     // GIR_Coverage, 12424,
     /*  745291 */     GIR_EraseRootFromParent_Done,
     /*  745292 */   // Label 11689: @745292
     /*  745292 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(745367), // Rule ID 12425 //
     /*  745297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  745308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  745311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  745317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745343 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  745346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745365 */     GIR_RootConstrainSelectedInstOperands,
     /*  745366 */     // GIR_Coverage, 12425,
     /*  745366 */     GIR_EraseRootFromParent_Done,
     /*  745367 */   // Label 11690: @745367
     /*  745367 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(745442), // Rule ID 12428 //
     /*  745372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  745375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  745383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  745386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745440 */     GIR_RootConstrainSelectedInstOperands,
     /*  745441 */     // GIR_Coverage, 12428,
     /*  745441 */     GIR_EraseRootFromParent_Done,
     /*  745442 */   // Label 11691: @745442
     /*  745442 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(745517), // Rule ID 12429 //
     /*  745447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  745450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  745458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  745461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745493 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745515 */     GIR_RootConstrainSelectedInstOperands,
     /*  745516 */     // GIR_Coverage, 12429,
     /*  745516 */     GIR_EraseRootFromParent_Done,
     /*  745517 */   // Label 11692: @745517
     /*  745517 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(745592), // Rule ID 12432 //
     /*  745522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745590 */     GIR_RootConstrainSelectedInstOperands,
     /*  745591 */     // GIR_Coverage, 12432,
     /*  745591 */     GIR_EraseRootFromParent_Done,
     /*  745592 */   // Label 11693: @745592
     /*  745592 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(745667), // Rule ID 12433 //
     /*  745597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745665 */     GIR_RootConstrainSelectedInstOperands,
     /*  745666 */     // GIR_Coverage, 12433,
     /*  745666 */     GIR_EraseRootFromParent_Done,
     /*  745667 */   // Label 11694: @745667
     /*  745667 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(745742), // Rule ID 12436 //
     /*  745672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745740 */     GIR_RootConstrainSelectedInstOperands,
     /*  745741 */     // GIR_Coverage, 12436,
     /*  745741 */     GIR_EraseRootFromParent_Done,
     /*  745742 */   // Label 11695: @745742
     /*  745742 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(745817), // Rule ID 12437 //
     /*  745747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745815 */     GIR_RootConstrainSelectedInstOperands,
     /*  745816 */     // GIR_Coverage, 12437,
     /*  745816 */     GIR_EraseRootFromParent_Done,
     /*  745817 */   // Label 11696: @745817
     /*  745817 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(745892), // Rule ID 12440 //
     /*  745822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745890 */     GIR_RootConstrainSelectedInstOperands,
     /*  745891 */     // GIR_Coverage, 12440,
     /*  745891 */     GIR_EraseRootFromParent_Done,
     /*  745892 */   // Label 11697: @745892
     /*  745892 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(745967), // Rule ID 12441 //
     /*  745897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11711:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745965 */     GIR_RootConstrainSelectedInstOperands,
     /*  745966 */     // GIR_Coverage, 12441,
     /*  745966 */     GIR_EraseRootFromParent_Done,
     /*  745967 */   // Label 11698: @745967
     /*  745967 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(746042), // Rule ID 12444 //
     /*  745972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746040 */     GIR_RootConstrainSelectedInstOperands,
     /*  746041 */     // GIR_Coverage, 12444,
     /*  746041 */     GIR_EraseRootFromParent_Done,
     /*  746042 */   // Label 11699: @746042
     /*  746042 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(746117), // Rule ID 12445 //
     /*  746047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  746058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  746061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  746064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746115 */     GIR_RootConstrainSelectedInstOperands,
     /*  746116 */     // GIR_Coverage, 12445,
     /*  746116 */     GIR_EraseRootFromParent_Done,
     /*  746117 */   // Label 11700: @746117
     /*  746117 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(746192), // Rule ID 12448 //
     /*  746122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  746133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  746136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  746139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746190 */     GIR_RootConstrainSelectedInstOperands,
     /*  746191 */     // GIR_Coverage, 12448,
     /*  746191 */     GIR_EraseRootFromParent_Done,
     /*  746192 */   // Label 11701: @746192
     /*  746192 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(746267), // Rule ID 12449 //
     /*  746197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  746208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  746211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  746214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746265 */     GIR_RootConstrainSelectedInstOperands,
     /*  746266 */     // GIR_Coverage, 12449,
     /*  746266 */     GIR_EraseRootFromParent_Done,
     /*  746267 */   // Label 11702: @746267
     /*  746267 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(746342), // Rule ID 12452 //
     /*  746272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  746283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  746286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  746289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746340 */     GIR_RootConstrainSelectedInstOperands,
     /*  746341 */     // GIR_Coverage, 12452,
     /*  746341 */     GIR_EraseRootFromParent_Done,
     /*  746342 */   // Label 11703: @746342
     /*  746342 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(746417), // Rule ID 12453 //
     /*  746347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  746358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  746361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  746364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746393 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746415 */     GIR_RootConstrainSelectedInstOperands,
     /*  746416 */     // GIR_Coverage, 12453,
     /*  746416 */     GIR_EraseRootFromParent_Done,
     /*  746417 */   // Label 11704: @746417
     /*  746417 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(746492), // Rule ID 12456 //
     /*  746422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746490 */     GIR_RootConstrainSelectedInstOperands,
     /*  746491 */     // GIR_Coverage, 12456,
     /*  746491 */     GIR_EraseRootFromParent_Done,
     /*  746492 */   // Label 11705: @746492
     /*  746492 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(746567), // Rule ID 12457 //
     /*  746497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746565 */     GIR_RootConstrainSelectedInstOperands,
     /*  746566 */     // GIR_Coverage, 12457,
     /*  746566 */     GIR_EraseRootFromParent_Done,
     /*  746567 */   // Label 11706: @746567
     /*  746567 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(746642), // Rule ID 12460 //
     /*  746572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746640 */     GIR_RootConstrainSelectedInstOperands,
     /*  746641 */     // GIR_Coverage, 12460,
     /*  746641 */     GIR_EraseRootFromParent_Done,
     /*  746642 */   // Label 11707: @746642
     /*  746642 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(746717), // Rule ID 12461 //
     /*  746647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11711:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746715 */     GIR_RootConstrainSelectedInstOperands,
     /*  746716 */     // GIR_Coverage, 12461,
     /*  746716 */     GIR_EraseRootFromParent_Done,
     /*  746717 */   // Label 11708: @746717
     /*  746717 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(746792), // Rule ID 12464 //
     /*  746722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746790 */     GIR_RootConstrainSelectedInstOperands,
     /*  746791 */     // GIR_Coverage, 12464,
     /*  746791 */     GIR_EraseRootFromParent_Done,
     /*  746792 */   // Label 11709: @746792
     /*  746792 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(746867), // Rule ID 12465 //
     /*  746797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746865 */     GIR_RootConstrainSelectedInstOperands,
     /*  746866 */     // GIR_Coverage, 12465,
     /*  746866 */     GIR_EraseRootFromParent_Done,
     /*  746867 */   // Label 11710: @746867
     /*  746867 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(746942), // Rule ID 12468 //
     /*  746872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746940 */     GIR_RootConstrainSelectedInstOperands,
     /*  746941 */     // GIR_Coverage, 12468,
     /*  746941 */     GIR_EraseRootFromParent_Done,
     /*  746942 */   // Label 11711: @746942
     /*  746942 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(747017), // Rule ID 12469 //
     /*  746947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747015 */     GIR_RootConstrainSelectedInstOperands,
     /*  747016 */     // GIR_Coverage, 12469,
     /*  747016 */     GIR_EraseRootFromParent_Done,
     /*  747017 */   // Label 11712: @747017
     /*  747017 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(747092), // Rule ID 12472 //
     /*  747022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  747033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  747036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  747039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747090 */     GIR_RootConstrainSelectedInstOperands,
     /*  747091 */     // GIR_Coverage, 12472,
     /*  747091 */     GIR_EraseRootFromParent_Done,
     /*  747092 */   // Label 11713: @747092
     /*  747092 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(747167), // Rule ID 12473 //
     /*  747097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  747108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  747111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  747114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747165 */     GIR_RootConstrainSelectedInstOperands,
     /*  747166 */     // GIR_Coverage, 12473,
     /*  747166 */     GIR_EraseRootFromParent_Done,
     /*  747167 */   // Label 11714: @747167
     /*  747167 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(747242), // Rule ID 12476 //
     /*  747172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  747189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  747221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747240 */     GIR_RootConstrainSelectedInstOperands,
     /*  747241 */     // GIR_Coverage, 12476,
     /*  747241 */     GIR_EraseRootFromParent_Done,
     /*  747242 */   // Label 11715: @747242
     /*  747242 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(747317), // Rule ID 12477 //
     /*  747247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  747258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  747261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  747264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11711:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  747296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747315 */     GIR_RootConstrainSelectedInstOperands,
     /*  747316 */     // GIR_Coverage, 12477,
     /*  747316 */     GIR_EraseRootFromParent_Done,
     /*  747317 */   // Label 11716: @747317
     /*  747317 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(747392), // Rule ID 12480 //
     /*  747322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  747333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  747336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  747339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  747371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747390 */     GIR_RootConstrainSelectedInstOperands,
     /*  747391 */     // GIR_Coverage, 12480,
     /*  747391 */     GIR_EraseRootFromParent_Done,
     /*  747392 */   // Label 11717: @747392
     /*  747392 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(747467), // Rule ID 12481 //
     /*  747397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  747408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  747411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  747414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11711:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  747446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747465 */     GIR_RootConstrainSelectedInstOperands,
     /*  747466 */     // GIR_Coverage, 12481,
     /*  747466 */     GIR_EraseRootFromParent_Done,
     /*  747467 */   // Label 11718: @747467
     /*  747467 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(747542), // Rule ID 12484 //
     /*  747472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747540 */     GIR_RootConstrainSelectedInstOperands,
     /*  747541 */     // GIR_Coverage, 12484,
     /*  747541 */     GIR_EraseRootFromParent_Done,
     /*  747542 */   // Label 11719: @747542
     /*  747542 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(747617), // Rule ID 12485 //
     /*  747547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11711:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747615 */     GIR_RootConstrainSelectedInstOperands,
     /*  747616 */     // GIR_Coverage, 12485,
     /*  747616 */     GIR_EraseRootFromParent_Done,
     /*  747617 */   // Label 11720: @747617
     /*  747617 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(747692), // Rule ID 12488 //
     /*  747622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747690 */     GIR_RootConstrainSelectedInstOperands,
     /*  747691 */     // GIR_Coverage, 12488,
     /*  747691 */     GIR_EraseRootFromParent_Done,
     /*  747692 */   // Label 11721: @747692
     /*  747692 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(747767), // Rule ID 12489 //
     /*  747697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11711:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747765 */     GIR_RootConstrainSelectedInstOperands,
     /*  747766 */     // GIR_Coverage, 12489,
     /*  747766 */     GIR_EraseRootFromParent_Done,
     /*  747767 */   // Label 11722: @747767
     /*  747767 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(747842), // Rule ID 12492 //
     /*  747772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747840 */     GIR_RootConstrainSelectedInstOperands,
     /*  747841 */     // GIR_Coverage, 12492,
     /*  747841 */     GIR_EraseRootFromParent_Done,
     /*  747842 */   // Label 11723: @747842
     /*  747842 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(747917), // Rule ID 12493 //
     /*  747847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747893 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747915 */     GIR_RootConstrainSelectedInstOperands,
     /*  747916 */     // GIR_Coverage, 12493,
     /*  747916 */     GIR_EraseRootFromParent_Done,
     /*  747917 */   // Label 11724: @747917
     /*  747917 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(747992), // Rule ID 12496 //
     /*  747922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747990 */     GIR_RootConstrainSelectedInstOperands,
     /*  747991 */     // GIR_Coverage, 12496,
     /*  747991 */     GIR_EraseRootFromParent_Done,
     /*  747992 */   // Label 11725: @747992
     /*  747992 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(748067), // Rule ID 12497 //
     /*  747997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  748008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  748011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  748014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  748017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748043 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748065 */     GIR_RootConstrainSelectedInstOperands,
     /*  748066 */     // GIR_Coverage, 12497,
     /*  748066 */     GIR_EraseRootFromParent_Done,
     /*  748067 */   // Label 11726: @748067
     /*  748067 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(748142), // Rule ID 12500 //
     /*  748072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  748083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  748086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  748089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  748092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748140 */     GIR_RootConstrainSelectedInstOperands,
     /*  748141 */     // GIR_Coverage, 12500,
     /*  748141 */     GIR_EraseRootFromParent_Done,
     /*  748142 */   // Label 11727: @748142
     /*  748142 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(748217), // Rule ID 12501 //
     /*  748147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  748158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  748161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  748164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  748167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748193 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748215 */     GIR_RootConstrainSelectedInstOperands,
     /*  748216 */     // GIR_Coverage, 12501,
     /*  748216 */     GIR_EraseRootFromParent_Done,
     /*  748217 */   // Label 11728: @748217
     /*  748217 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(748292), // Rule ID 12504 //
     /*  748222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  748233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  748236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  748239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  748242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748290 */     GIR_RootConstrainSelectedInstOperands,
     /*  748291 */     // GIR_Coverage, 12504,
     /*  748291 */     GIR_EraseRootFromParent_Done,
     /*  748292 */   // Label 11729: @748292
     /*  748292 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(748367), // Rule ID 12505 //
     /*  748297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  748308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  748311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  748314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  748317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748365 */     GIR_RootConstrainSelectedInstOperands,
     /*  748366 */     // GIR_Coverage, 12505,
     /*  748366 */     GIR_EraseRootFromParent_Done,
     /*  748367 */   // Label 11730: @748367
     /*  748367 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(748442), // Rule ID 12508 //
     /*  748372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  748383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  748386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  748389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748440 */     GIR_RootConstrainSelectedInstOperands,
     /*  748441 */     // GIR_Coverage, 12508,
     /*  748441 */     GIR_EraseRootFromParent_Done,
     /*  748442 */   // Label 11731: @748442
     /*  748442 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(748517), // Rule ID 12509 //
     /*  748447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  748458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  748461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  748464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748515 */     GIR_RootConstrainSelectedInstOperands,
     /*  748516 */     // GIR_Coverage, 12509,
     /*  748516 */     GIR_EraseRootFromParent_Done,
     /*  748517 */   // Label 11732: @748517
     /*  748517 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(748592), // Rule ID 12512 //
     /*  748522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748590 */     GIR_RootConstrainSelectedInstOperands,
     /*  748591 */     // GIR_Coverage, 12512,
     /*  748591 */     GIR_EraseRootFromParent_Done,
     /*  748592 */   // Label 11733: @748592
     /*  748592 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(748667), // Rule ID 12513 //
     /*  748597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748665 */     GIR_RootConstrainSelectedInstOperands,
     /*  748666 */     // GIR_Coverage, 12513,
     /*  748666 */     GIR_EraseRootFromParent_Done,
     /*  748667 */   // Label 11734: @748667
     /*  748667 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(748742), // Rule ID 12516 //
     /*  748672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748740 */     GIR_RootConstrainSelectedInstOperands,
     /*  748741 */     // GIR_Coverage, 12516,
     /*  748741 */     GIR_EraseRootFromParent_Done,
     /*  748742 */   // Label 11735: @748742
     /*  748742 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(748817), // Rule ID 12517 //
     /*  748747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748793 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748815 */     GIR_RootConstrainSelectedInstOperands,
     /*  748816 */     // GIR_Coverage, 12517,
     /*  748816 */     GIR_EraseRootFromParent_Done,
     /*  748817 */   // Label 11736: @748817
     /*  748817 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(748892), // Rule ID 12520 //
     /*  748822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748890 */     GIR_RootConstrainSelectedInstOperands,
     /*  748891 */     // GIR_Coverage, 12520,
     /*  748891 */     GIR_EraseRootFromParent_Done,
     /*  748892 */   // Label 11737: @748892
     /*  748892 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(748967), // Rule ID 12521 //
     /*  748897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748965 */     GIR_RootConstrainSelectedInstOperands,
     /*  748966 */     // GIR_Coverage, 12521,
     /*  748966 */     GIR_EraseRootFromParent_Done,
     /*  748967 */   // Label 11738: @748967
     /*  748967 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(749042), // Rule ID 12524 //
     /*  748972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749040 */     GIR_RootConstrainSelectedInstOperands,
     /*  749041 */     // GIR_Coverage, 12524,
     /*  749041 */     GIR_EraseRootFromParent_Done,
     /*  749042 */   // Label 11739: @749042
     /*  749042 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(749117), // Rule ID 12525 //
     /*  749047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  749058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  749061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  749064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  749067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749115 */     GIR_RootConstrainSelectedInstOperands,
     /*  749116 */     // GIR_Coverage, 12525,
     /*  749116 */     GIR_EraseRootFromParent_Done,
     /*  749117 */   // Label 11740: @749117
     /*  749117 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(749192), // Rule ID 12528 //
     /*  749122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  749133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  749136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  749139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  749142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749190 */     GIR_RootConstrainSelectedInstOperands,
     /*  749191 */     // GIR_Coverage, 12528,
     /*  749191 */     GIR_EraseRootFromParent_Done,
     /*  749192 */   // Label 11741: @749192
     /*  749192 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(749267), // Rule ID 12529 //
     /*  749197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  749208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  749211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  749214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  749217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749265 */     GIR_RootConstrainSelectedInstOperands,
     /*  749266 */     // GIR_Coverage, 12529,
     /*  749266 */     GIR_EraseRootFromParent_Done,
     /*  749267 */   // Label 11742: @749267
     /*  749267 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(749342), // Rule ID 12532 //
     /*  749272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  749283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  749286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  749289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  749292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749340 */     GIR_RootConstrainSelectedInstOperands,
     /*  749341 */     // GIR_Coverage, 12532,
     /*  749341 */     GIR_EraseRootFromParent_Done,
     /*  749342 */   // Label 11743: @749342
     /*  749342 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(749417), // Rule ID 12533 //
     /*  749347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  749358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  749361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  749364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  749367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749415 */     GIR_RootConstrainSelectedInstOperands,
     /*  749416 */     // GIR_Coverage, 12533,
     /*  749416 */     GIR_EraseRootFromParent_Done,
     /*  749417 */   // Label 11744: @749417
     /*  749417 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(749492), // Rule ID 12536 //
     /*  749422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749490 */     GIR_RootConstrainSelectedInstOperands,
     /*  749491 */     // GIR_Coverage, 12536,
     /*  749491 */     GIR_EraseRootFromParent_Done,
     /*  749492 */   // Label 11745: @749492
     /*  749492 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(749567), // Rule ID 12537 //
     /*  749497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749565 */     GIR_RootConstrainSelectedInstOperands,
     /*  749566 */     // GIR_Coverage, 12537,
     /*  749566 */     GIR_EraseRootFromParent_Done,
     /*  749567 */   // Label 11746: @749567
     /*  749567 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(749642), // Rule ID 12540 //
     /*  749572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749640 */     GIR_RootConstrainSelectedInstOperands,
     /*  749641 */     // GIR_Coverage, 12540,
     /*  749641 */     GIR_EraseRootFromParent_Done,
     /*  749642 */   // Label 11747: @749642
     /*  749642 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(749717), // Rule ID 12541 //
     /*  749647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749715 */     GIR_RootConstrainSelectedInstOperands,
     /*  749716 */     // GIR_Coverage, 12541,
     /*  749716 */     GIR_EraseRootFromParent_Done,
     /*  749717 */   // Label 11748: @749717
     /*  749717 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(749792), // Rule ID 12544 //
     /*  749722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749790 */     GIR_RootConstrainSelectedInstOperands,
     /*  749791 */     // GIR_Coverage, 12544,
     /*  749791 */     GIR_EraseRootFromParent_Done,
     /*  749792 */   // Label 11749: @749792
     /*  749792 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(749867), // Rule ID 12545 //
     /*  749797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749843 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749865 */     GIR_RootConstrainSelectedInstOperands,
     /*  749866 */     // GIR_Coverage, 12545,
     /*  749866 */     GIR_EraseRootFromParent_Done,
     /*  749867 */   // Label 11750: @749867
     /*  749867 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(749942), // Rule ID 12548 //
     /*  749872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749918 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749940 */     GIR_RootConstrainSelectedInstOperands,
     /*  749941 */     // GIR_Coverage, 12548,
     /*  749941 */     GIR_EraseRootFromParent_Done,
     /*  749942 */   // Label 11751: @749942
     /*  749942 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(750017), // Rule ID 12549 //
     /*  749947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749993 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750015 */     GIR_RootConstrainSelectedInstOperands,
     /*  750016 */     // GIR_Coverage, 12549,
     /*  750016 */     GIR_EraseRootFromParent_Done,
     /*  750017 */   // Label 11752: @750017
     /*  750017 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(750092), // Rule ID 12552 //
     /*  750022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  750033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  750036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  750039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  750071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750090 */     GIR_RootConstrainSelectedInstOperands,
     /*  750091 */     // GIR_Coverage, 12552,
     /*  750091 */     GIR_EraseRootFromParent_Done,
     /*  750092 */   // Label 11753: @750092
     /*  750092 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(750167), // Rule ID 12553 //
     /*  750097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  750108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  750111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  750114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  750146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750165 */     GIR_RootConstrainSelectedInstOperands,
     /*  750166 */     // GIR_Coverage, 12553,
     /*  750166 */     GIR_EraseRootFromParent_Done,
     /*  750167 */   // Label 11754: @750167
     /*  750167 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(750242), // Rule ID 12556 //
     /*  750172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  750183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  750186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  750189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750240 */     GIR_RootConstrainSelectedInstOperands,
     /*  750241 */     // GIR_Coverage, 12556,
     /*  750241 */     GIR_EraseRootFromParent_Done,
     /*  750242 */   // Label 11755: @750242
     /*  750242 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(750317), // Rule ID 12557 //
     /*  750247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  750258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  750261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  750264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750315 */     GIR_RootConstrainSelectedInstOperands,
     /*  750316 */     // GIR_Coverage, 12557,
     /*  750316 */     GIR_EraseRootFromParent_Done,
     /*  750317 */   // Label 11756: @750317
     /*  750317 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(750392), // Rule ID 12560 //
     /*  750322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  750333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  750336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  750339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750390 */     GIR_RootConstrainSelectedInstOperands,
     /*  750391 */     // GIR_Coverage, 12560,
     /*  750391 */     GIR_EraseRootFromParent_Done,
     /*  750392 */   // Label 11757: @750392
     /*  750392 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(750467), // Rule ID 12561 //
     /*  750397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  750408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  750411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  750414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11715:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750465 */     GIR_RootConstrainSelectedInstOperands,
     /*  750466 */     // GIR_Coverage, 12561,
     /*  750466 */     GIR_EraseRootFromParent_Done,
     /*  750467 */   // Label 11758: @750467
     /*  750467 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(750542), // Rule ID 12564 //
     /*  750472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750540 */     GIR_RootConstrainSelectedInstOperands,
     /*  750541 */     // GIR_Coverage, 12564,
     /*  750541 */     GIR_EraseRootFromParent_Done,
     /*  750542 */   // Label 11759: @750542
     /*  750542 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(750617), // Rule ID 12565 //
     /*  750547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750615 */     GIR_RootConstrainSelectedInstOperands,
     /*  750616 */     // GIR_Coverage, 12565,
     /*  750616 */     GIR_EraseRootFromParent_Done,
     /*  750617 */   // Label 11760: @750617
     /*  750617 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(750692), // Rule ID 12568 //
     /*  750622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750668 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750690 */     GIR_RootConstrainSelectedInstOperands,
     /*  750691 */     // GIR_Coverage, 12568,
     /*  750691 */     GIR_EraseRootFromParent_Done,
     /*  750692 */   // Label 11761: @750692
     /*  750692 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(750767), // Rule ID 12569 //
     /*  750697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750743 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750765 */     GIR_RootConstrainSelectedInstOperands,
     /*  750766 */     // GIR_Coverage, 12569,
     /*  750766 */     GIR_EraseRootFromParent_Done,
     /*  750767 */   // Label 11762: @750767
     /*  750767 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(750842), // Rule ID 12572 //
     /*  750772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750818 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750840 */     GIR_RootConstrainSelectedInstOperands,
     /*  750841 */     // GIR_Coverage, 12572,
     /*  750841 */     GIR_EraseRootFromParent_Done,
     /*  750842 */   // Label 11763: @750842
     /*  750842 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(750917), // Rule ID 12573 //
     /*  750847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750893 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750915 */     GIR_RootConstrainSelectedInstOperands,
     /*  750916 */     // GIR_Coverage, 12573,
     /*  750916 */     GIR_EraseRootFromParent_Done,
     /*  750917 */   // Label 11764: @750917
     /*  750917 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(750992), // Rule ID 12576 //
     /*  750922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750990 */     GIR_RootConstrainSelectedInstOperands,
     /*  750991 */     // GIR_Coverage, 12576,
     /*  750991 */     GIR_EraseRootFromParent_Done,
     /*  750992 */   // Label 11765: @750992
     /*  750992 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(751067), // Rule ID 12577 //
     /*  750997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  751008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  751011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  751014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  751046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751065 */     GIR_RootConstrainSelectedInstOperands,
     /*  751066 */     // GIR_Coverage, 12577,
     /*  751066 */     GIR_EraseRootFromParent_Done,
     /*  751067 */   // Label 11766: @751067
     /*  751067 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(751142), // Rule ID 12580 //
     /*  751072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  751083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  751086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751140 */     GIR_RootConstrainSelectedInstOperands,
     /*  751141 */     // GIR_Coverage, 12580,
     /*  751141 */     GIR_EraseRootFromParent_Done,
     /*  751142 */   // Label 11767: @751142
     /*  751142 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(751217), // Rule ID 12581 //
     /*  751147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  751158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  751161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  751164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11715:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751215 */     GIR_RootConstrainSelectedInstOperands,
     /*  751216 */     // GIR_Coverage, 12581,
     /*  751216 */     GIR_EraseRootFromParent_Done,
     /*  751217 */   // Label 11768: @751217
     /*  751217 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(751292), // Rule ID 12584 //
     /*  751222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  751233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  751236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  751239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751290 */     GIR_RootConstrainSelectedInstOperands,
     /*  751291 */     // GIR_Coverage, 12584,
     /*  751291 */     GIR_EraseRootFromParent_Done,
     /*  751292 */   // Label 11769: @751292
     /*  751292 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(751367), // Rule ID 12585 //
     /*  751297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  751308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  751311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  751314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751365 */     GIR_RootConstrainSelectedInstOperands,
     /*  751366 */     // GIR_Coverage, 12585,
     /*  751366 */     GIR_EraseRootFromParent_Done,
     /*  751367 */   // Label 11770: @751367
     /*  751367 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(751442), // Rule ID 12588 //
     /*  751372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  751383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  751386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  751389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751440 */     GIR_RootConstrainSelectedInstOperands,
     /*  751441 */     // GIR_Coverage, 12588,
     /*  751441 */     GIR_EraseRootFromParent_Done,
     /*  751442 */   // Label 11771: @751442
     /*  751442 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(751517), // Rule ID 12589 //
     /*  751447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  751458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  751461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  751464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751515 */     GIR_RootConstrainSelectedInstOperands,
     /*  751516 */     // GIR_Coverage, 12589,
     /*  751516 */     GIR_EraseRootFromParent_Done,
     /*  751517 */   // Label 11772: @751517
     /*  751517 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(751592), // Rule ID 12592 //
     /*  751522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751590 */     GIR_RootConstrainSelectedInstOperands,
     /*  751591 */     // GIR_Coverage, 12592,
     /*  751591 */     GIR_EraseRootFromParent_Done,
     /*  751592 */   // Label 11773: @751592
     /*  751592 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(751667), // Rule ID 12593 //
     /*  751597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751665 */     GIR_RootConstrainSelectedInstOperands,
     /*  751666 */     // GIR_Coverage, 12593,
     /*  751666 */     GIR_EraseRootFromParent_Done,
     /*  751667 */   // Label 11774: @751667
     /*  751667 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(751742), // Rule ID 12596 //
     /*  751672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751740 */     GIR_RootConstrainSelectedInstOperands,
     /*  751741 */     // GIR_Coverage, 12596,
     /*  751741 */     GIR_EraseRootFromParent_Done,
     /*  751742 */   // Label 11775: @751742
     /*  751742 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(751817), // Rule ID 12597 //
     /*  751747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751793 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11715:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751815 */     GIR_RootConstrainSelectedInstOperands,
     /*  751816 */     // GIR_Coverage, 12597,
     /*  751816 */     GIR_EraseRootFromParent_Done,
     /*  751817 */   // Label 11776: @751817
     /*  751817 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(751892), // Rule ID 12600 //
     /*  751822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751890 */     GIR_RootConstrainSelectedInstOperands,
     /*  751891 */     // GIR_Coverage, 12600,
     /*  751891 */     GIR_EraseRootFromParent_Done,
     /*  751892 */   // Label 11777: @751892
     /*  751892 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(751967), // Rule ID 12601 //
     /*  751897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11715:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751965 */     GIR_RootConstrainSelectedInstOperands,
     /*  751966 */     // GIR_Coverage, 12601,
     /*  751966 */     GIR_EraseRootFromParent_Done,
     /*  751967 */   // Label 11778: @751967
     /*  751967 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(752042), // Rule ID 12604 //
     /*  751972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  752021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752040 */     GIR_RootConstrainSelectedInstOperands,
     /*  752041 */     // GIR_Coverage, 12604,
     /*  752041 */     GIR_EraseRootFromParent_Done,
     /*  752042 */   // Label 11779: @752042
     /*  752042 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(752117), // Rule ID 12605 //
     /*  752047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  752058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  752061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  752064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11715:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  752096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752115 */     GIR_RootConstrainSelectedInstOperands,
     /*  752116 */     // GIR_Coverage, 12605,
     /*  752116 */     GIR_EraseRootFromParent_Done,
     /*  752117 */   // Label 11780: @752117
     /*  752117 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(752192), // Rule ID 12608 //
     /*  752122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  752133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  752136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  752139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  752142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  752171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752190 */     GIR_RootConstrainSelectedInstOperands,
     /*  752191 */     // GIR_Coverage, 12608,
     /*  752191 */     GIR_EraseRootFromParent_Done,
     /*  752192 */   // Label 11781: @752192
     /*  752192 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(752267), // Rule ID 12609 //
     /*  752197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  752208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  752211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  752214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  752217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  752236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11715:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  752246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752265 */     GIR_RootConstrainSelectedInstOperands,
     /*  752266 */     // GIR_Coverage, 12609,
     /*  752266 */     GIR_EraseRootFromParent_Done,
     /*  752267 */   // Label 11782: @752267
     /*  752267 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(752342), // Rule ID 12612 //
     /*  752272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  752283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  752286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  752289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  752292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  752321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752340 */     GIR_RootConstrainSelectedInstOperands,
     /*  752341 */     // GIR_Coverage, 12612,
     /*  752341 */     GIR_EraseRootFromParent_Done,
     /*  752342 */   // Label 11783: @752342
     /*  752342 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(752417), // Rule ID 12613 //
     /*  752347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  752358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  752361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  752364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  752367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  752396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752415 */     GIR_RootConstrainSelectedInstOperands,
     /*  752416 */     // GIR_Coverage, 12613,
     /*  752416 */     GIR_EraseRootFromParent_Done,
     /*  752417 */   // Label 11784: @752417
     /*  752417 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(752492), // Rule ID 12616 //
     /*  752422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752490 */     GIR_RootConstrainSelectedInstOperands,
     /*  752491 */     // GIR_Coverage, 12616,
     /*  752491 */     GIR_EraseRootFromParent_Done,
     /*  752492 */   // Label 11785: @752492
     /*  752492 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(752567), // Rule ID 12617 //
     /*  752497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752543 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752565 */     GIR_RootConstrainSelectedInstOperands,
     /*  752566 */     // GIR_Coverage, 12617,
     /*  752566 */     GIR_EraseRootFromParent_Done,
     /*  752567 */   // Label 11786: @752567
     /*  752567 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(752642), // Rule ID 12620 //
     /*  752572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752640 */     GIR_RootConstrainSelectedInstOperands,
     /*  752641 */     // GIR_Coverage, 12620,
     /*  752641 */     GIR_EraseRootFromParent_Done,
     /*  752642 */   // Label 11787: @752642
     /*  752642 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(752717), // Rule ID 12621 //
     /*  752647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752715 */     GIR_RootConstrainSelectedInstOperands,
     /*  752716 */     // GIR_Coverage, 12621,
     /*  752716 */     GIR_EraseRootFromParent_Done,
     /*  752717 */   // Label 11788: @752717
     /*  752717 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(752792), // Rule ID 12624 //
     /*  752722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752790 */     GIR_RootConstrainSelectedInstOperands,
     /*  752791 */     // GIR_Coverage, 12624,
     /*  752791 */     GIR_EraseRootFromParent_Done,
     /*  752792 */   // Label 11789: @752792
     /*  752792 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(752867), // Rule ID 12625 //
     /*  752797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752865 */     GIR_RootConstrainSelectedInstOperands,
     /*  752866 */     // GIR_Coverage, 12625,
     /*  752866 */     GIR_EraseRootFromParent_Done,
     /*  752867 */   // Label 11790: @752867
     /*  752867 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(752942), // Rule ID 12628 //
     /*  752872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752940 */     GIR_RootConstrainSelectedInstOperands,
     /*  752941 */     // GIR_Coverage, 12628,
     /*  752941 */     GIR_EraseRootFromParent_Done,
     /*  752942 */   // Label 11791: @752942
     /*  752942 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(753017), // Rule ID 12629 //
     /*  752947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753015 */     GIR_RootConstrainSelectedInstOperands,
     /*  753016 */     // GIR_Coverage, 12629,
     /*  753016 */     GIR_EraseRootFromParent_Done,
     /*  753017 */   // Label 11792: @753017
     /*  753017 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(753092), // Rule ID 12632 //
     /*  753022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  753039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  753042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753090 */     GIR_RootConstrainSelectedInstOperands,
     /*  753091 */     // GIR_Coverage, 12632,
     /*  753091 */     GIR_EraseRootFromParent_Done,
     /*  753092 */   // Label 11793: @753092
     /*  753092 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(753167), // Rule ID 12633 //
     /*  753097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  753108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  753111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  753114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  753117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753143 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753165 */     GIR_RootConstrainSelectedInstOperands,
     /*  753166 */     // GIR_Coverage, 12633,
     /*  753166 */     GIR_EraseRootFromParent_Done,
     /*  753167 */   // Label 11794: @753167
     /*  753167 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(753242), // Rule ID 12636 //
     /*  753172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  753183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  753186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  753189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  753192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  753221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753240 */     GIR_RootConstrainSelectedInstOperands,
     /*  753241 */     // GIR_Coverage, 12636,
     /*  753241 */     GIR_EraseRootFromParent_Done,
     /*  753242 */   // Label 11795: @753242
     /*  753242 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(753317), // Rule ID 12637 //
     /*  753247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  753258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  753261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  753264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  753267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753293 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  753296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753315 */     GIR_RootConstrainSelectedInstOperands,
     /*  753316 */     // GIR_Coverage, 12637,
     /*  753316 */     GIR_EraseRootFromParent_Done,
     /*  753317 */   // Label 11796: @753317
     /*  753317 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(753392), // Rule ID 12640 //
     /*  753322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  753333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  753336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  753339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  753342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753390 */     GIR_RootConstrainSelectedInstOperands,
     /*  753391 */     // GIR_Coverage, 12640,
     /*  753391 */     GIR_EraseRootFromParent_Done,
     /*  753392 */   // Label 11797: @753392
     /*  753392 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(753467), // Rule ID 12641 //
     /*  753397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  753408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  753411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  753414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  753417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753443 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753465 */     GIR_RootConstrainSelectedInstOperands,
     /*  753466 */     // GIR_Coverage, 12641,
     /*  753466 */     GIR_EraseRootFromParent_Done,
     /*  753467 */   // Label 11798: @753467
     /*  753467 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(753542), // Rule ID 12644 //
     /*  753472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753540 */     GIR_RootConstrainSelectedInstOperands,
     /*  753541 */     // GIR_Coverage, 12644,
     /*  753541 */     GIR_EraseRootFromParent_Done,
     /*  753542 */   // Label 11799: @753542
     /*  753542 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(753617), // Rule ID 12645 //
     /*  753547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753615 */     GIR_RootConstrainSelectedInstOperands,
     /*  753616 */     // GIR_Coverage, 12645,
     /*  753616 */     GIR_EraseRootFromParent_Done,
     /*  753617 */   // Label 11800: @753617
     /*  753617 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(753692), // Rule ID 12648 //
     /*  753622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753690 */     GIR_RootConstrainSelectedInstOperands,
     /*  753691 */     // GIR_Coverage, 12648,
     /*  753691 */     GIR_EraseRootFromParent_Done,
     /*  753692 */   // Label 11801: @753692
     /*  753692 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(753767), // Rule ID 12649 //
     /*  753697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753765 */     GIR_RootConstrainSelectedInstOperands,
     /*  753766 */     // GIR_Coverage, 12649,
     /*  753766 */     GIR_EraseRootFromParent_Done,
     /*  753767 */   // Label 11802: @753767
     /*  753767 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(753842), // Rule ID 12652 //
     /*  753772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753840 */     GIR_RootConstrainSelectedInstOperands,
     /*  753841 */     // GIR_Coverage, 12652,
     /*  753841 */     GIR_EraseRootFromParent_Done,
     /*  753842 */   // Label 11803: @753842
     /*  753842 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(753917), // Rule ID 12653 //
     /*  753847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753893 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753915 */     GIR_RootConstrainSelectedInstOperands,
     /*  753916 */     // GIR_Coverage, 12653,
     /*  753916 */     GIR_EraseRootFromParent_Done,
     /*  753917 */   // Label 11804: @753917
     /*  753917 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(753992), // Rule ID 12656 //
     /*  753922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753990 */     GIR_RootConstrainSelectedInstOperands,
     /*  753991 */     // GIR_Coverage, 12656,
     /*  753991 */     GIR_EraseRootFromParent_Done,
     /*  753992 */   // Label 11805: @753992
     /*  753992 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(754067), // Rule ID 12657 //
     /*  753997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  754008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  754011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  754014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  754017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  754046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754065 */     GIR_RootConstrainSelectedInstOperands,
     /*  754066 */     // GIR_Coverage, 12657,
     /*  754066 */     GIR_EraseRootFromParent_Done,
     /*  754067 */   // Label 11806: @754067
     /*  754067 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(754142), // Rule ID 12660 //
     /*  754072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  754083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  754086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  754089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  754092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  754121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754140 */     GIR_RootConstrainSelectedInstOperands,
     /*  754141 */     // GIR_Coverage, 12660,
     /*  754141 */     GIR_EraseRootFromParent_Done,
     /*  754142 */   // Label 11807: @754142
     /*  754142 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(754217), // Rule ID 12661 //
     /*  754147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  754158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  754161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  754164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  754167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  754196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754215 */     GIR_RootConstrainSelectedInstOperands,
     /*  754216 */     // GIR_Coverage, 12661,
     /*  754216 */     GIR_EraseRootFromParent_Done,
     /*  754217 */   // Label 11808: @754217
     /*  754217 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(754292), // Rule ID 12664 //
     /*  754222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  754239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  754242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  754271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754290 */     GIR_RootConstrainSelectedInstOperands,
     /*  754291 */     // GIR_Coverage, 12664,
     /*  754291 */     GIR_EraseRootFromParent_Done,
     /*  754292 */   // Label 11809: @754292
     /*  754292 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(754367), // Rule ID 12665 //
     /*  754297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  754308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  754311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  754314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  754317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754343 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  754346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754365 */     GIR_RootConstrainSelectedInstOperands,
     /*  754366 */     // GIR_Coverage, 12665,
     /*  754366 */     GIR_EraseRootFromParent_Done,
     /*  754367 */   // Label 11810: @754367
     /*  754367 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(754442), // Rule ID 12668 //
     /*  754372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  754375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  754389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  754418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754440 */     GIR_RootConstrainSelectedInstOperands,
     /*  754441 */     // GIR_Coverage, 12668,
     /*  754441 */     GIR_EraseRootFromParent_Done,
     /*  754442 */   // Label 11811: @754442
     /*  754442 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(754517), // Rule ID 12669 //
     /*  754447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  754450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  754458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  754461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  754464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754493 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754515 */     GIR_RootConstrainSelectedInstOperands,
     /*  754516 */     // GIR_Coverage, 12669,
     /*  754516 */     GIR_EraseRootFromParent_Done,
     /*  754517 */   // Label 11812: @754517
     /*  754517 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(754592), // Rule ID 12672 //
     /*  754522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754590 */     GIR_RootConstrainSelectedInstOperands,
     /*  754591 */     // GIR_Coverage, 12672,
     /*  754591 */     GIR_EraseRootFromParent_Done,
     /*  754592 */   // Label 11813: @754592
     /*  754592 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(754667), // Rule ID 12673 //
     /*  754597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754665 */     GIR_RootConstrainSelectedInstOperands,
     /*  754666 */     // GIR_Coverage, 12673,
     /*  754666 */     GIR_EraseRootFromParent_Done,
     /*  754667 */   // Label 11814: @754667
     /*  754667 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(754742), // Rule ID 12676 //
     /*  754672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754740 */     GIR_RootConstrainSelectedInstOperands,
     /*  754741 */     // GIR_Coverage, 12676,
     /*  754741 */     GIR_EraseRootFromParent_Done,
     /*  754742 */   // Label 11815: @754742
     /*  754742 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(754817), // Rule ID 12677 //
     /*  754747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754815 */     GIR_RootConstrainSelectedInstOperands,
     /*  754816 */     // GIR_Coverage, 12677,
     /*  754816 */     GIR_EraseRootFromParent_Done,
     /*  754817 */   // Label 11816: @754817
     /*  754817 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(754892), // Rule ID 12680 //
     /*  754822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754890 */     GIR_RootConstrainSelectedInstOperands,
     /*  754891 */     // GIR_Coverage, 12680,
     /*  754891 */     GIR_EraseRootFromParent_Done,
     /*  754892 */   // Label 11817: @754892
     /*  754892 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(754967), // Rule ID 12681 //
     /*  754897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11713:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754965 */     GIR_RootConstrainSelectedInstOperands,
     /*  754966 */     // GIR_Coverage, 12681,
     /*  754966 */     GIR_EraseRootFromParent_Done,
     /*  754967 */   // Label 11818: @754967
     /*  754967 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(755042), // Rule ID 12684 //
     /*  754972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755040 */     GIR_RootConstrainSelectedInstOperands,
     /*  755041 */     // GIR_Coverage, 12684,
     /*  755041 */     GIR_EraseRootFromParent_Done,
     /*  755042 */   // Label 11819: @755042
     /*  755042 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(755117), // Rule ID 12685 //
     /*  755047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  755058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  755061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  755064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755115 */     GIR_RootConstrainSelectedInstOperands,
     /*  755116 */     // GIR_Coverage, 12685,
     /*  755116 */     GIR_EraseRootFromParent_Done,
     /*  755117 */   // Label 11820: @755117
     /*  755117 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(755192), // Rule ID 12688 //
     /*  755122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  755133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  755136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755190 */     GIR_RootConstrainSelectedInstOperands,
     /*  755191 */     // GIR_Coverage, 12688,
     /*  755191 */     GIR_EraseRootFromParent_Done,
     /*  755192 */   // Label 11821: @755192
     /*  755192 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(755267), // Rule ID 12689 //
     /*  755197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  755208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  755211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  755214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755265 */     GIR_RootConstrainSelectedInstOperands,
     /*  755266 */     // GIR_Coverage, 12689,
     /*  755266 */     GIR_EraseRootFromParent_Done,
     /*  755267 */   // Label 11822: @755267
     /*  755267 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(755342), // Rule ID 12692 //
     /*  755272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  755283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  755286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  755289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755340 */     GIR_RootConstrainSelectedInstOperands,
     /*  755341 */     // GIR_Coverage, 12692,
     /*  755341 */     GIR_EraseRootFromParent_Done,
     /*  755342 */   // Label 11823: @755342
     /*  755342 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(755417), // Rule ID 12693 //
     /*  755347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  755358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  755361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  755364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755393 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755415 */     GIR_RootConstrainSelectedInstOperands,
     /*  755416 */     // GIR_Coverage, 12693,
     /*  755416 */     GIR_EraseRootFromParent_Done,
     /*  755417 */   // Label 11824: @755417
     /*  755417 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(755492), // Rule ID 12696 //
     /*  755422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755490 */     GIR_RootConstrainSelectedInstOperands,
     /*  755491 */     // GIR_Coverage, 12696,
     /*  755491 */     GIR_EraseRootFromParent_Done,
     /*  755492 */   // Label 11825: @755492
     /*  755492 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(755567), // Rule ID 12697 //
     /*  755497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755543 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755565 */     GIR_RootConstrainSelectedInstOperands,
     /*  755566 */     // GIR_Coverage, 12697,
     /*  755566 */     GIR_EraseRootFromParent_Done,
     /*  755567 */   // Label 11826: @755567
     /*  755567 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(755642), // Rule ID 12700 //
     /*  755572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755640 */     GIR_RootConstrainSelectedInstOperands,
     /*  755641 */     // GIR_Coverage, 12700,
     /*  755641 */     GIR_EraseRootFromParent_Done,
     /*  755642 */   // Label 11827: @755642
     /*  755642 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(755717), // Rule ID 12701 //
     /*  755647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11713:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755715 */     GIR_RootConstrainSelectedInstOperands,
     /*  755716 */     // GIR_Coverage, 12701,
     /*  755716 */     GIR_EraseRootFromParent_Done,
     /*  755717 */   // Label 11828: @755717
     /*  755717 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(755792), // Rule ID 12704 //
     /*  755722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755790 */     GIR_RootConstrainSelectedInstOperands,
     /*  755791 */     // GIR_Coverage, 12704,
     /*  755791 */     GIR_EraseRootFromParent_Done,
     /*  755792 */   // Label 11829: @755792
     /*  755792 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(755867), // Rule ID 12705 //
     /*  755797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755865 */     GIR_RootConstrainSelectedInstOperands,
     /*  755866 */     // GIR_Coverage, 12705,
     /*  755866 */     GIR_EraseRootFromParent_Done,
     /*  755867 */   // Label 11830: @755867
     /*  755867 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(755942), // Rule ID 12708 //
     /*  755872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755940 */     GIR_RootConstrainSelectedInstOperands,
     /*  755941 */     // GIR_Coverage, 12708,
     /*  755941 */     GIR_EraseRootFromParent_Done,
     /*  755942 */   // Label 11831: @755942
     /*  755942 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(756017), // Rule ID 12709 //
     /*  755947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756015 */     GIR_RootConstrainSelectedInstOperands,
     /*  756016 */     // GIR_Coverage, 12709,
     /*  756016 */     GIR_EraseRootFromParent_Done,
     /*  756017 */   // Label 11832: @756017
     /*  756017 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(756092), // Rule ID 12712 //
     /*  756022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  756033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  756036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756090 */     GIR_RootConstrainSelectedInstOperands,
     /*  756091 */     // GIR_Coverage, 12712,
     /*  756091 */     GIR_EraseRootFromParent_Done,
     /*  756092 */   // Label 11833: @756092
     /*  756092 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(756167), // Rule ID 12713 //
     /*  756097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  756108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  756111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  756114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756165 */     GIR_RootConstrainSelectedInstOperands,
     /*  756166 */     // GIR_Coverage, 12713,
     /*  756166 */     GIR_EraseRootFromParent_Done,
     /*  756167 */   // Label 11834: @756167
     /*  756167 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(756242), // Rule ID 12716 //
     /*  756172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  756183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  756186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  756221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756240 */     GIR_RootConstrainSelectedInstOperands,
     /*  756241 */     // GIR_Coverage, 12716,
     /*  756241 */     GIR_EraseRootFromParent_Done,
     /*  756242 */   // Label 11835: @756242
     /*  756242 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(756317), // Rule ID 12717 //
     /*  756247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  756258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  756261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11713:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  756296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756315 */     GIR_RootConstrainSelectedInstOperands,
     /*  756316 */     // GIR_Coverage, 12717,
     /*  756316 */     GIR_EraseRootFromParent_Done,
     /*  756317 */   // Label 11836: @756317
     /*  756317 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(756392), // Rule ID 12720 //
     /*  756322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  756333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  756336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  756339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  756371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756390 */     GIR_RootConstrainSelectedInstOperands,
     /*  756391 */     // GIR_Coverage, 12720,
     /*  756391 */     GIR_EraseRootFromParent_Done,
     /*  756392 */   // Label 11837: @756392
     /*  756392 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(756467), // Rule ID 12721 //
     /*  756397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  756408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  756411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  756414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11713:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  756446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756465 */     GIR_RootConstrainSelectedInstOperands,
     /*  756466 */     // GIR_Coverage, 12721,
     /*  756466 */     GIR_EraseRootFromParent_Done,
     /*  756467 */   // Label 11838: @756467
     /*  756467 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(756542), // Rule ID 12724 //
     /*  756472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756540 */     GIR_RootConstrainSelectedInstOperands,
     /*  756541 */     // GIR_Coverage, 12724,
     /*  756541 */     GIR_EraseRootFromParent_Done,
     /*  756542 */   // Label 11839: @756542
     /*  756542 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(756617), // Rule ID 12725 //
     /*  756547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756593 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11713:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756615 */     GIR_RootConstrainSelectedInstOperands,
     /*  756616 */     // GIR_Coverage, 12725,
     /*  756616 */     GIR_EraseRootFromParent_Done,
     /*  756617 */   // Label 11840: @756617
     /*  756617 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(756692), // Rule ID 12728 //
     /*  756622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756690 */     GIR_RootConstrainSelectedInstOperands,
     /*  756691 */     // GIR_Coverage, 12728,
     /*  756691 */     GIR_EraseRootFromParent_Done,
     /*  756692 */   // Label 11841: @756692
     /*  756692 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(756767), // Rule ID 12729 //
     /*  756697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756743 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11713:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756765 */     GIR_RootConstrainSelectedInstOperands,
     /*  756766 */     // GIR_Coverage, 12729,
     /*  756766 */     GIR_EraseRootFromParent_Done,
     /*  756767 */   // Label 11842: @756767
     /*  756767 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(756845), // Rule ID 14058 //
     /*  756772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756843 */     GIR_RootConstrainSelectedInstOperands,
     /*  756844 */     // GIR_Coverage, 14058,
     /*  756844 */     GIR_EraseRootFromParent_Done,
     /*  756845 */   // Label 11843: @756845
     /*  756845 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(756923), // Rule ID 14059 //
     /*  756850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756921 */     GIR_RootConstrainSelectedInstOperands,
     /*  756922 */     // GIR_Coverage, 14059,
     /*  756922 */     GIR_EraseRootFromParent_Done,
     /*  756923 */   // Label 11844: @756923
     /*  756923 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(757001), // Rule ID 14062 //
     /*  756928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756974 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756999 */     GIR_RootConstrainSelectedInstOperands,
     /*  757000 */     // GIR_Coverage, 14062,
     /*  757000 */     GIR_EraseRootFromParent_Done,
     /*  757001 */   // Label 11845: @757001
     /*  757001 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(757079), // Rule ID 14063 //
     /*  757006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  757017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  757020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  757023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  757026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757052 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757077 */     GIR_RootConstrainSelectedInstOperands,
     /*  757078 */     // GIR_Coverage, 14063,
     /*  757078 */     GIR_EraseRootFromParent_Done,
     /*  757079 */   // Label 11846: @757079
     /*  757079 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(757157), // Rule ID 14066 //
     /*  757084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  757095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  757098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  757101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  757104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757155 */     GIR_RootConstrainSelectedInstOperands,
     /*  757156 */     // GIR_Coverage, 14066,
     /*  757156 */     GIR_EraseRootFromParent_Done,
     /*  757157 */   // Label 11847: @757157
     /*  757157 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(757235), // Rule ID 14067 //
     /*  757162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  757173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  757176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  757179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  757182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757233 */     GIR_RootConstrainSelectedInstOperands,
     /*  757234 */     // GIR_Coverage, 14067,
     /*  757234 */     GIR_EraseRootFromParent_Done,
     /*  757235 */   // Label 11848: @757235
     /*  757235 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(757313), // Rule ID 14070 //
     /*  757240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  757260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757311 */     GIR_RootConstrainSelectedInstOperands,
     /*  757312 */     // GIR_Coverage, 14070,
     /*  757312 */     GIR_EraseRootFromParent_Done,
     /*  757313 */   // Label 11849: @757313
     /*  757313 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(757391), // Rule ID 14071 //
     /*  757318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  757335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  757338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  757367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757389 */     GIR_RootConstrainSelectedInstOperands,
     /*  757390 */     // GIR_Coverage, 14071,
     /*  757390 */     GIR_EraseRootFromParent_Done,
     /*  757391 */   // Label 11850: @757391
     /*  757391 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(757469), // Rule ID 14074 //
     /*  757396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757442 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757467 */     GIR_RootConstrainSelectedInstOperands,
     /*  757468 */     // GIR_Coverage, 14074,
     /*  757468 */     GIR_EraseRootFromParent_Done,
     /*  757469 */   // Label 11851: @757469
     /*  757469 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(757547), // Rule ID 14075 //
     /*  757474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757545 */     GIR_RootConstrainSelectedInstOperands,
     /*  757546 */     // GIR_Coverage, 14075,
     /*  757546 */     GIR_EraseRootFromParent_Done,
     /*  757547 */   // Label 11852: @757547
     /*  757547 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(757625), // Rule ID 14078 //
     /*  757552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757623 */     GIR_RootConstrainSelectedInstOperands,
     /*  757624 */     // GIR_Coverage, 14078,
     /*  757624 */     GIR_EraseRootFromParent_Done,
     /*  757625 */   // Label 11853: @757625
     /*  757625 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(757703), // Rule ID 14079 //
     /*  757630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757676 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757701 */     GIR_RootConstrainSelectedInstOperands,
     /*  757702 */     // GIR_Coverage, 14079,
     /*  757702 */     GIR_EraseRootFromParent_Done,
     /*  757703 */   // Label 11854: @757703
     /*  757703 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(757781), // Rule ID 14082 //
     /*  757708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757779 */     GIR_RootConstrainSelectedInstOperands,
     /*  757780 */     // GIR_Coverage, 14082,
     /*  757780 */     GIR_EraseRootFromParent_Done,
     /*  757781 */   // Label 11855: @757781
     /*  757781 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(757859), // Rule ID 14083 //
     /*  757786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757857 */     GIR_RootConstrainSelectedInstOperands,
     /*  757858 */     // GIR_Coverage, 14083,
     /*  757858 */     GIR_EraseRootFromParent_Done,
     /*  757859 */   // Label 11856: @757859
     /*  757859 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(757937), // Rule ID 14086 //
     /*  757864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757935 */     GIR_RootConstrainSelectedInstOperands,
     /*  757936 */     // GIR_Coverage, 14086,
     /*  757936 */     GIR_EraseRootFromParent_Done,
     /*  757937 */   // Label 11857: @757937
     /*  757937 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(758015), // Rule ID 14087 //
     /*  757942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758013 */     GIR_RootConstrainSelectedInstOperands,
     /*  758014 */     // GIR_Coverage, 14087,
     /*  758014 */     GIR_EraseRootFromParent_Done,
     /*  758015 */   // Label 11858: @758015
     /*  758015 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(758093), // Rule ID 14090 //
     /*  758020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  758040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758091 */     GIR_RootConstrainSelectedInstOperands,
     /*  758092 */     // GIR_Coverage, 14090,
     /*  758092 */     GIR_EraseRootFromParent_Done,
     /*  758093 */   // Label 11859: @758093
     /*  758093 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(758171), // Rule ID 14091 //
     /*  758098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  758115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  758118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758169 */     GIR_RootConstrainSelectedInstOperands,
     /*  758170 */     // GIR_Coverage, 14091,
     /*  758170 */     GIR_EraseRootFromParent_Done,
     /*  758171 */   // Label 11860: @758171
     /*  758171 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(758249), // Rule ID 14094 //
     /*  758176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  758179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  758196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  758222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758247 */     GIR_RootConstrainSelectedInstOperands,
     /*  758248 */     // GIR_Coverage, 14094,
     /*  758248 */     GIR_EraseRootFromParent_Done,
     /*  758249 */   // Label 11861: @758249
     /*  758249 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(758327), // Rule ID 14095 //
     /*  758254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  758257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  758265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  758268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  758271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  758274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  758300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  758303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758325 */     GIR_RootConstrainSelectedInstOperands,
     /*  758326 */     // GIR_Coverage, 14095,
     /*  758326 */     GIR_EraseRootFromParent_Done,
     /*  758327 */   // Label 11862: @758327
     /*  758327 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(758405), // Rule ID 14098 //
     /*  758332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  758343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  758346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  758352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758378 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758403 */     GIR_RootConstrainSelectedInstOperands,
     /*  758404 */     // GIR_Coverage, 14098,
     /*  758404 */     GIR_EraseRootFromParent_Done,
     /*  758405 */   // Label 11863: @758405
     /*  758405 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(758483), // Rule ID 14099 //
     /*  758410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  758421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  758424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  758430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758481 */     GIR_RootConstrainSelectedInstOperands,
     /*  758482 */     // GIR_Coverage, 14099,
     /*  758482 */     GIR_EraseRootFromParent_Done,
     /*  758483 */   // Label 11864: @758483
     /*  758483 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(758561), // Rule ID 14102 //
     /*  758488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758534 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758559 */     GIR_RootConstrainSelectedInstOperands,
     /*  758560 */     // GIR_Coverage, 14102,
     /*  758560 */     GIR_EraseRootFromParent_Done,
     /*  758561 */   // Label 11865: @758561
     /*  758561 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(758639), // Rule ID 14103 //
     /*  758566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758637 */     GIR_RootConstrainSelectedInstOperands,
     /*  758638 */     // GIR_Coverage, 14103,
     /*  758638 */     GIR_EraseRootFromParent_Done,
     /*  758639 */   // Label 11866: @758639
     /*  758639 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(758717), // Rule ID 14106 //
     /*  758644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758715 */     GIR_RootConstrainSelectedInstOperands,
     /*  758716 */     // GIR_Coverage, 14106,
     /*  758716 */     GIR_EraseRootFromParent_Done,
     /*  758717 */   // Label 11867: @758717
     /*  758717 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(758795), // Rule ID 14107 //
     /*  758722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758793 */     GIR_RootConstrainSelectedInstOperands,
     /*  758794 */     // GIR_Coverage, 14107,
     /*  758794 */     GIR_EraseRootFromParent_Done,
     /*  758795 */   // Label 11868: @758795
     /*  758795 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(758873), // Rule ID 14110 //
     /*  758800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758871 */     GIR_RootConstrainSelectedInstOperands,
     /*  758872 */     // GIR_Coverage, 14110,
     /*  758872 */     GIR_EraseRootFromParent_Done,
     /*  758873 */   // Label 11869: @758873
     /*  758873 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(758951), // Rule ID 14111 //
     /*  758878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758949 */     GIR_RootConstrainSelectedInstOperands,
     /*  758950 */     // GIR_Coverage, 14111,
     /*  758950 */     GIR_EraseRootFromParent_Done,
     /*  758951 */   // Label 11870: @758951
     /*  758951 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(759029), // Rule ID 14114 //
     /*  758956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759027 */     GIR_RootConstrainSelectedInstOperands,
     /*  759028 */     // GIR_Coverage, 14114,
     /*  759028 */     GIR_EraseRootFromParent_Done,
     /*  759029 */   // Label 11871: @759029
     /*  759029 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(759107), // Rule ID 14115 //
     /*  759034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  759045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  759048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  759054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759105 */     GIR_RootConstrainSelectedInstOperands,
     /*  759106 */     // GIR_Coverage, 14115,
     /*  759106 */     GIR_EraseRootFromParent_Done,
     /*  759107 */   // Label 11872: @759107
     /*  759107 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(759185), // Rule ID 14118 //
     /*  759112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  759123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  759126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  759129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  759132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759183 */     GIR_RootConstrainSelectedInstOperands,
     /*  759184 */     // GIR_Coverage, 14118,
     /*  759184 */     GIR_EraseRootFromParent_Done,
     /*  759185 */   // Label 11873: @759185
     /*  759185 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(759263), // Rule ID 14119 //
     /*  759190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  759201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  759204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  759207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  759210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759261 */     GIR_RootConstrainSelectedInstOperands,
     /*  759262 */     // GIR_Coverage, 14119,
     /*  759262 */     GIR_EraseRootFromParent_Done,
     /*  759263 */   // Label 11874: @759263
     /*  759263 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(759341), // Rule ID 14122 //
     /*  759268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  759288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759339 */     GIR_RootConstrainSelectedInstOperands,
     /*  759340 */     // GIR_Coverage, 14122,
     /*  759340 */     GIR_EraseRootFromParent_Done,
     /*  759341 */   // Label 11875: @759341
     /*  759341 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(759419), // Rule ID 14123 //
     /*  759346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  759366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759417 */     GIR_RootConstrainSelectedInstOperands,
     /*  759418 */     // GIR_Coverage, 14123,
     /*  759418 */     GIR_EraseRootFromParent_Done,
     /*  759419 */   // Label 11876: @759419
     /*  759419 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(759497), // Rule ID 14126 //
     /*  759424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759495 */     GIR_RootConstrainSelectedInstOperands,
     /*  759496 */     // GIR_Coverage, 14126,
     /*  759496 */     GIR_EraseRootFromParent_Done,
     /*  759497 */   // Label 11877: @759497
     /*  759497 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(759575), // Rule ID 14127 //
     /*  759502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759573 */     GIR_RootConstrainSelectedInstOperands,
     /*  759574 */     // GIR_Coverage, 14127,
     /*  759574 */     GIR_EraseRootFromParent_Done,
     /*  759575 */   // Label 11878: @759575
     /*  759575 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(759653), // Rule ID 14130 //
     /*  759580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759651 */     GIR_RootConstrainSelectedInstOperands,
     /*  759652 */     // GIR_Coverage, 14130,
     /*  759652 */     GIR_EraseRootFromParent_Done,
     /*  759653 */   // Label 11879: @759653
     /*  759653 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(759731), // Rule ID 14131 //
     /*  759658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759729 */     GIR_RootConstrainSelectedInstOperands,
     /*  759730 */     // GIR_Coverage, 14131,
     /*  759730 */     GIR_EraseRootFromParent_Done,
     /*  759731 */   // Label 11880: @759731
     /*  759731 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(759809), // Rule ID 14134 //
     /*  759736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759807 */     GIR_RootConstrainSelectedInstOperands,
     /*  759808 */     // GIR_Coverage, 14134,
     /*  759808 */     GIR_EraseRootFromParent_Done,
     /*  759809 */   // Label 11881: @759809
     /*  759809 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(759887), // Rule ID 14135 //
     /*  759814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759885 */     GIR_RootConstrainSelectedInstOperands,
     /*  759886 */     // GIR_Coverage, 14135,
     /*  759886 */     GIR_EraseRootFromParent_Done,
     /*  759887 */   // Label 11882: @759887
     /*  759887 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(759965), // Rule ID 14138 //
     /*  759892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759963 */     GIR_RootConstrainSelectedInstOperands,
     /*  759964 */     // GIR_Coverage, 14138,
     /*  759964 */     GIR_EraseRootFromParent_Done,
     /*  759965 */   // Label 11883: @759965
     /*  759965 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(760043), // Rule ID 14139 //
     /*  759970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  760019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760041 */     GIR_RootConstrainSelectedInstOperands,
     /*  760042 */     // GIR_Coverage, 14139,
     /*  760042 */     GIR_EraseRootFromParent_Done,
     /*  760043 */   // Label 11884: @760043
     /*  760043 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(760121), // Rule ID 14142 //
     /*  760048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  760051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  760065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  760068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  760094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  760097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760119 */     GIR_RootConstrainSelectedInstOperands,
     /*  760120 */     // GIR_Coverage, 14142,
     /*  760120 */     GIR_EraseRootFromParent_Done,
     /*  760121 */   // Label 11885: @760121
     /*  760121 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(760199), // Rule ID 14143 //
     /*  760126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  760129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  760143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  760146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  760175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760197 */     GIR_RootConstrainSelectedInstOperands,
     /*  760198 */     // GIR_Coverage, 14143,
     /*  760198 */     GIR_EraseRootFromParent_Done,
     /*  760199 */   // Label 11886: @760199
     /*  760199 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(760277), // Rule ID 14146 //
     /*  760204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  760253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760275 */     GIR_RootConstrainSelectedInstOperands,
     /*  760276 */     // GIR_Coverage, 14146,
     /*  760276 */     GIR_EraseRootFromParent_Done,
     /*  760277 */   // Label 11887: @760277
     /*  760277 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(760355), // Rule ID 14147 //
     /*  760282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760328 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  760331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760353 */     GIR_RootConstrainSelectedInstOperands,
     /*  760354 */     // GIR_Coverage, 14147,
     /*  760354 */     GIR_EraseRootFromParent_Done,
     /*  760355 */   // Label 11888: @760355
     /*  760355 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(760433), // Rule ID 14150 //
     /*  760360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760406 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760431 */     GIR_RootConstrainSelectedInstOperands,
     /*  760432 */     // GIR_Coverage, 14150,
     /*  760432 */     GIR_EraseRootFromParent_Done,
     /*  760433 */   // Label 11889: @760433
     /*  760433 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(760511), // Rule ID 14151 //
     /*  760438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760509 */     GIR_RootConstrainSelectedInstOperands,
     /*  760510 */     // GIR_Coverage, 14151,
     /*  760510 */     GIR_EraseRootFromParent_Done,
     /*  760511 */   // Label 11890: @760511
     /*  760511 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(760589), // Rule ID 14154 //
     /*  760516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760562 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760587 */     GIR_RootConstrainSelectedInstOperands,
     /*  760588 */     // GIR_Coverage, 14154,
     /*  760588 */     GIR_EraseRootFromParent_Done,
     /*  760589 */   // Label 11891: @760589
     /*  760589 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(760667), // Rule ID 14155 //
     /*  760594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760665 */     GIR_RootConstrainSelectedInstOperands,
     /*  760666 */     // GIR_Coverage, 14155,
     /*  760666 */     GIR_EraseRootFromParent_Done,
     /*  760667 */   // Label 11892: @760667
     /*  760667 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(760745), // Rule ID 14158 //
     /*  760672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760743 */     GIR_RootConstrainSelectedInstOperands,
     /*  760744 */     // GIR_Coverage, 14158,
     /*  760744 */     GIR_EraseRootFromParent_Done,
     /*  760745 */   // Label 11893: @760745
     /*  760745 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(760823), // Rule ID 14159 //
     /*  760750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760821 */     GIR_RootConstrainSelectedInstOperands,
     /*  760822 */     // GIR_Coverage, 14159,
     /*  760822 */     GIR_EraseRootFromParent_Done,
     /*  760823 */   // Label 11894: @760823
     /*  760823 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(760901), // Rule ID 14162 //
     /*  760828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760899 */     GIR_RootConstrainSelectedInstOperands,
     /*  760900 */     // GIR_Coverage, 14162,
     /*  760900 */     GIR_EraseRootFromParent_Done,
     /*  760901 */   // Label 11895: @760901
     /*  760901 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(760979), // Rule ID 14163 //
     /*  760906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760977 */     GIR_RootConstrainSelectedInstOperands,
     /*  760978 */     // GIR_Coverage, 14163,
     /*  760978 */     GIR_EraseRootFromParent_Done,
     /*  760979 */   // Label 11896: @760979
     /*  760979 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(761057), // Rule ID 14166 //
     /*  760984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  761033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761055 */     GIR_RootConstrainSelectedInstOperands,
     /*  761056 */     // GIR_Coverage, 14166,
     /*  761056 */     GIR_EraseRootFromParent_Done,
     /*  761057 */   // Label 11897: @761057
     /*  761057 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(761135), // Rule ID 14167 //
     /*  761062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  761073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  761076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  761111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761133 */     GIR_RootConstrainSelectedInstOperands,
     /*  761134 */     // GIR_Coverage, 14167,
     /*  761134 */     GIR_EraseRootFromParent_Done,
     /*  761135 */   // Label 11898: @761135
     /*  761135 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(761213), // Rule ID 14170 //
     /*  761140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761186 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761211 */     GIR_RootConstrainSelectedInstOperands,
     /*  761212 */     // GIR_Coverage, 14170,
     /*  761212 */     GIR_EraseRootFromParent_Done,
     /*  761213 */   // Label 11899: @761213
     /*  761213 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(761291), // Rule ID 14171 //
     /*  761218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11589:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761289 */     GIR_RootConstrainSelectedInstOperands,
     /*  761290 */     // GIR_Coverage, 14171,
     /*  761290 */     GIR_EraseRootFromParent_Done,
     /*  761291 */   // Label 11900: @761291
     /*  761291 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(761369), // Rule ID 14174 //
     /*  761296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761367 */     GIR_RootConstrainSelectedInstOperands,
     /*  761368 */     // GIR_Coverage, 14174,
     /*  761368 */     GIR_EraseRootFromParent_Done,
     /*  761369 */   // Label 11901: @761369
     /*  761369 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(761447), // Rule ID 14175 //
     /*  761374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761445 */     GIR_RootConstrainSelectedInstOperands,
     /*  761446 */     // GIR_Coverage, 14175,
     /*  761446 */     GIR_EraseRootFromParent_Done,
     /*  761447 */   // Label 11902: @761447
     /*  761447 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(761525), // Rule ID 14178 //
     /*  761452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761523 */     GIR_RootConstrainSelectedInstOperands,
     /*  761524 */     // GIR_Coverage, 14178,
     /*  761524 */     GIR_EraseRootFromParent_Done,
     /*  761525 */   // Label 11903: @761525
     /*  761525 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(761603), // Rule ID 14179 //
     /*  761530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761601 */     GIR_RootConstrainSelectedInstOperands,
     /*  761602 */     // GIR_Coverage, 14179,
     /*  761602 */     GIR_EraseRootFromParent_Done,
     /*  761603 */   // Label 11904: @761603
     /*  761603 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(761681), // Rule ID 14182 //
     /*  761608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761679 */     GIR_RootConstrainSelectedInstOperands,
     /*  761680 */     // GIR_Coverage, 14182,
     /*  761680 */     GIR_EraseRootFromParent_Done,
     /*  761681 */   // Label 11905: @761681
     /*  761681 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(761759), // Rule ID 14183 //
     /*  761686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761757 */     GIR_RootConstrainSelectedInstOperands,
     /*  761758 */     // GIR_Coverage, 14183,
     /*  761758 */     GIR_EraseRootFromParent_Done,
     /*  761759 */   // Label 11906: @761759
     /*  761759 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(761837), // Rule ID 14186 //
     /*  761764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761835 */     GIR_RootConstrainSelectedInstOperands,
     /*  761836 */     // GIR_Coverage, 14186,
     /*  761836 */     GIR_EraseRootFromParent_Done,
     /*  761837 */   // Label 11907: @761837
     /*  761837 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(761915), // Rule ID 14187 //
     /*  761842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761913 */     GIR_RootConstrainSelectedInstOperands,
     /*  761914 */     // GIR_Coverage, 14187,
     /*  761914 */     GIR_EraseRootFromParent_Done,
     /*  761915 */   // Label 11908: @761915
     /*  761915 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(761993), // Rule ID 14190 //
     /*  761920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761966 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761991 */     GIR_RootConstrainSelectedInstOperands,
     /*  761992 */     // GIR_Coverage, 14190,
     /*  761992 */     GIR_EraseRootFromParent_Done,
     /*  761993 */   // Label 11909: @761993
     /*  761993 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(762071), // Rule ID 14191 //
     /*  761998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  762009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  762012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  762015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762069 */     GIR_RootConstrainSelectedInstOperands,
     /*  762070 */     // GIR_Coverage, 14191,
     /*  762070 */     GIR_EraseRootFromParent_Done,
     /*  762071 */   // Label 11910: @762071
     /*  762071 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(762149), // Rule ID 14194 //
     /*  762076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762147 */     GIR_RootConstrainSelectedInstOperands,
     /*  762148 */     // GIR_Coverage, 14194,
     /*  762148 */     GIR_EraseRootFromParent_Done,
     /*  762149 */   // Label 11911: @762149
     /*  762149 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(762227), // Rule ID 14195 //
     /*  762154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762200 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762225 */     GIR_RootConstrainSelectedInstOperands,
     /*  762226 */     // GIR_Coverage, 14195,
     /*  762226 */     GIR_EraseRootFromParent_Done,
     /*  762227 */   // Label 11912: @762227
     /*  762227 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(762305), // Rule ID 14198 //
     /*  762232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762303 */     GIR_RootConstrainSelectedInstOperands,
     /*  762304 */     // GIR_Coverage, 14198,
     /*  762304 */     GIR_EraseRootFromParent_Done,
     /*  762305 */   // Label 11913: @762305
     /*  762305 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(762383), // Rule ID 14199 //
     /*  762310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762381 */     GIR_RootConstrainSelectedInstOperands,
     /*  762382 */     // GIR_Coverage, 14199,
     /*  762382 */     GIR_EraseRootFromParent_Done,
     /*  762383 */   // Label 11914: @762383
     /*  762383 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(762461), // Rule ID 14202 //
     /*  762388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762459 */     GIR_RootConstrainSelectedInstOperands,
     /*  762460 */     // GIR_Coverage, 14202,
     /*  762460 */     GIR_EraseRootFromParent_Done,
     /*  762461 */   // Label 11915: @762461
     /*  762461 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(762539), // Rule ID 14203 //
     /*  762466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762512 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762537 */     GIR_RootConstrainSelectedInstOperands,
     /*  762538 */     // GIR_Coverage, 14203,
     /*  762538 */     GIR_EraseRootFromParent_Done,
     /*  762539 */   // Label 11916: @762539
     /*  762539 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(762617), // Rule ID 14206 //
     /*  762544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762615 */     GIR_RootConstrainSelectedInstOperands,
     /*  762616 */     // GIR_Coverage, 14206,
     /*  762616 */     GIR_EraseRootFromParent_Done,
     /*  762617 */   // Label 11917: @762617
     /*  762617 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(762695), // Rule ID 14207 //
     /*  762622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762693 */     GIR_RootConstrainSelectedInstOperands,
     /*  762694 */     // GIR_Coverage, 14207,
     /*  762694 */     GIR_EraseRootFromParent_Done,
     /*  762695 */   // Label 11918: @762695
     /*  762695 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(762773), // Rule ID 14210 //
     /*  762700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762771 */     GIR_RootConstrainSelectedInstOperands,
     /*  762772 */     // GIR_Coverage, 14210,
     /*  762772 */     GIR_EraseRootFromParent_Done,
     /*  762773 */   // Label 11919: @762773
     /*  762773 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(762851), // Rule ID 14211 //
     /*  762778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762849 */     GIR_RootConstrainSelectedInstOperands,
     /*  762850 */     // GIR_Coverage, 14211,
     /*  762850 */     GIR_EraseRootFromParent_Done,
     /*  762851 */   // Label 11920: @762851
     /*  762851 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(762929), // Rule ID 14214 //
     /*  762856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762927 */     GIR_RootConstrainSelectedInstOperands,
     /*  762928 */     // GIR_Coverage, 14214,
     /*  762928 */     GIR_EraseRootFromParent_Done,
     /*  762929 */   // Label 11921: @762929
     /*  762929 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(763007), // Rule ID 14215 //
     /*  762934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763005 */     GIR_RootConstrainSelectedInstOperands,
     /*  763006 */     // GIR_Coverage, 14215,
     /*  763006 */     GIR_EraseRootFromParent_Done,
     /*  763007 */   // Label 11922: @763007
     /*  763007 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(763085), // Rule ID 14218 //
     /*  763012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763083 */     GIR_RootConstrainSelectedInstOperands,
     /*  763084 */     // GIR_Coverage, 14218,
     /*  763084 */     GIR_EraseRootFromParent_Done,
     /*  763085 */   // Label 11923: @763085
     /*  763085 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(763163), // Rule ID 14219 //
     /*  763090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763161 */     GIR_RootConstrainSelectedInstOperands,
     /*  763162 */     // GIR_Coverage, 14219,
     /*  763162 */     GIR_EraseRootFromParent_Done,
     /*  763163 */   // Label 11924: @763163
     /*  763163 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(763241), // Rule ID 14222 //
     /*  763168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  763217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763239 */     GIR_RootConstrainSelectedInstOperands,
     /*  763240 */     // GIR_Coverage, 14222,
     /*  763240 */     GIR_EraseRootFromParent_Done,
     /*  763241 */   // Label 11925: @763241
     /*  763241 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(763319), // Rule ID 14223 //
     /*  763246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  763295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763317 */     GIR_RootConstrainSelectedInstOperands,
     /*  763318 */     // GIR_Coverage, 14223,
     /*  763318 */     GIR_EraseRootFromParent_Done,
     /*  763319 */   // Label 11926: @763319
     /*  763319 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(763397), // Rule ID 14226 //
     /*  763324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  763373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763395 */     GIR_RootConstrainSelectedInstOperands,
     /*  763396 */     // GIR_Coverage, 14226,
     /*  763396 */     GIR_EraseRootFromParent_Done,
     /*  763397 */   // Label 11927: @763397
     /*  763397 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(763475), // Rule ID 14227 //
     /*  763402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  763451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763473 */     GIR_RootConstrainSelectedInstOperands,
     /*  763474 */     // GIR_Coverage, 14227,
     /*  763474 */     GIR_EraseRootFromParent_Done,
     /*  763475 */   // Label 11928: @763475
     /*  763475 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(763553), // Rule ID 14230 //
     /*  763480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763551 */     GIR_RootConstrainSelectedInstOperands,
     /*  763552 */     // GIR_Coverage, 14230,
     /*  763552 */     GIR_EraseRootFromParent_Done,
     /*  763553 */   // Label 11929: @763553
     /*  763553 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(763631), // Rule ID 14231 //
     /*  763558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763629 */     GIR_RootConstrainSelectedInstOperands,
     /*  763630 */     // GIR_Coverage, 14231,
     /*  763630 */     GIR_EraseRootFromParent_Done,
     /*  763631 */   // Label 11930: @763631
     /*  763631 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(763709), // Rule ID 14322 //
     /*  763636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763707 */     GIR_RootConstrainSelectedInstOperands,
     /*  763708 */     // GIR_Coverage, 14322,
     /*  763708 */     GIR_EraseRootFromParent_Done,
     /*  763709 */   // Label 11931: @763709
     /*  763709 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(763787), // Rule ID 14323 //
     /*  763714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763785 */     GIR_RootConstrainSelectedInstOperands,
     /*  763786 */     // GIR_Coverage, 14323,
     /*  763786 */     GIR_EraseRootFromParent_Done,
     /*  763787 */   // Label 11932: @763787
     /*  763787 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(763865), // Rule ID 14326 //
     /*  763792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763863 */     GIR_RootConstrainSelectedInstOperands,
     /*  763864 */     // GIR_Coverage, 14326,
     /*  763864 */     GIR_EraseRootFromParent_Done,
     /*  763865 */   // Label 11933: @763865
     /*  763865 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(763943), // Rule ID 14327 //
     /*  763870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763941 */     GIR_RootConstrainSelectedInstOperands,
     /*  763942 */     // GIR_Coverage, 14327,
     /*  763942 */     GIR_EraseRootFromParent_Done,
     /*  763943 */   // Label 11934: @763943
     /*  763943 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(764021), // Rule ID 14330 //
     /*  763948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763994 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764019 */     GIR_RootConstrainSelectedInstOperands,
     /*  764020 */     // GIR_Coverage, 14330,
     /*  764020 */     GIR_EraseRootFromParent_Done,
     /*  764021 */   // Label 11935: @764021
     /*  764021 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(764099), // Rule ID 14331 //
     /*  764026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  764037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  764040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  764043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  764046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764072 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764097 */     GIR_RootConstrainSelectedInstOperands,
     /*  764098 */     // GIR_Coverage, 14331,
     /*  764098 */     GIR_EraseRootFromParent_Done,
     /*  764099 */   // Label 11936: @764099
     /*  764099 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(764177), // Rule ID 14334 //
     /*  764104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  764124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764150 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  764153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764175 */     GIR_RootConstrainSelectedInstOperands,
     /*  764176 */     // GIR_Coverage, 14334,
     /*  764176 */     GIR_EraseRootFromParent_Done,
     /*  764177 */   // Label 11937: @764177
     /*  764177 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(764255), // Rule ID 14335 //
     /*  764182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  764202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  764231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764253 */     GIR_RootConstrainSelectedInstOperands,
     /*  764254 */     // GIR_Coverage, 14335,
     /*  764254 */     GIR_EraseRootFromParent_Done,
     /*  764255 */   // Label 11938: @764255
     /*  764255 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(764333), // Rule ID 14338 //
     /*  764260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  764280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764331 */     GIR_RootConstrainSelectedInstOperands,
     /*  764332 */     // GIR_Coverage, 14338,
     /*  764332 */     GIR_EraseRootFromParent_Done,
     /*  764333 */   // Label 11939: @764333
     /*  764333 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(764411), // Rule ID 14339 //
     /*  764338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  764358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764409 */     GIR_RootConstrainSelectedInstOperands,
     /*  764410 */     // GIR_Coverage, 14339,
     /*  764410 */     GIR_EraseRootFromParent_Done,
     /*  764411 */   // Label 11940: @764411
     /*  764411 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(764489), // Rule ID 14342 //
     /*  764416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764487 */     GIR_RootConstrainSelectedInstOperands,
     /*  764488 */     // GIR_Coverage, 14342,
     /*  764488 */     GIR_EraseRootFromParent_Done,
     /*  764489 */   // Label 11941: @764489
     /*  764489 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(764567), // Rule ID 14343 //
     /*  764494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764540 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764565 */     GIR_RootConstrainSelectedInstOperands,
     /*  764566 */     // GIR_Coverage, 14343,
     /*  764566 */     GIR_EraseRootFromParent_Done,
     /*  764567 */   // Label 11942: @764567
     /*  764567 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(764645), // Rule ID 14346 //
     /*  764572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764643 */     GIR_RootConstrainSelectedInstOperands,
     /*  764644 */     // GIR_Coverage, 14346,
     /*  764644 */     GIR_EraseRootFromParent_Done,
     /*  764645 */   // Label 11943: @764645
     /*  764645 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(764723), // Rule ID 14347 //
     /*  764650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764721 */     GIR_RootConstrainSelectedInstOperands,
     /*  764722 */     // GIR_Coverage, 14347,
     /*  764722 */     GIR_EraseRootFromParent_Done,
     /*  764723 */   // Label 11944: @764723
     /*  764723 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(764801), // Rule ID 14350 //
     /*  764728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764799 */     GIR_RootConstrainSelectedInstOperands,
     /*  764800 */     // GIR_Coverage, 14350,
     /*  764800 */     GIR_EraseRootFromParent_Done,
     /*  764801 */   // Label 11945: @764801
     /*  764801 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(764879), // Rule ID 14351 //
     /*  764806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764877 */     GIR_RootConstrainSelectedInstOperands,
     /*  764878 */     // GIR_Coverage, 14351,
     /*  764878 */     GIR_EraseRootFromParent_Done,
     /*  764879 */   // Label 11946: @764879
     /*  764879 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(764957), // Rule ID 14354 //
     /*  764884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764955 */     GIR_RootConstrainSelectedInstOperands,
     /*  764956 */     // GIR_Coverage, 14354,
     /*  764956 */     GIR_EraseRootFromParent_Done,
     /*  764957 */   // Label 11947: @764957
     /*  764957 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(765035), // Rule ID 14355 //
     /*  764962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765033 */     GIR_RootConstrainSelectedInstOperands,
     /*  765034 */     // GIR_Coverage, 14355,
     /*  765034 */     GIR_EraseRootFromParent_Done,
     /*  765035 */   // Label 11948: @765035
     /*  765035 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(765113), // Rule ID 14358 //
     /*  765040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  765060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765111 */     GIR_RootConstrainSelectedInstOperands,
     /*  765112 */     // GIR_Coverage, 14358,
     /*  765112 */     GIR_EraseRootFromParent_Done,
     /*  765113 */   // Label 11949: @765113
     /*  765113 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(765191), // Rule ID 14359 //
     /*  765118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  765138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  765167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765189 */     GIR_RootConstrainSelectedInstOperands,
     /*  765190 */     // GIR_Coverage, 14359,
     /*  765190 */     GIR_EraseRootFromParent_Done,
     /*  765191 */   // Label 11950: @765191
     /*  765191 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(765269), // Rule ID 14362 //
     /*  765196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  765216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765267 */     GIR_RootConstrainSelectedInstOperands,
     /*  765268 */     // GIR_Coverage, 14362,
     /*  765268 */     GIR_EraseRootFromParent_Done,
     /*  765269 */   // Label 11951: @765269
     /*  765269 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(765347), // Rule ID 14363 //
     /*  765274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  765294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765345 */     GIR_RootConstrainSelectedInstOperands,
     /*  765346 */     // GIR_Coverage, 14363,
     /*  765346 */     GIR_EraseRootFromParent_Done,
     /*  765347 */   // Label 11952: @765347
     /*  765347 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(765425), // Rule ID 14366 //
     /*  765352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  765372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765398 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765423 */     GIR_RootConstrainSelectedInstOperands,
     /*  765424 */     // GIR_Coverage, 14366,
     /*  765424 */     GIR_EraseRootFromParent_Done,
     /*  765425 */   // Label 11953: @765425
     /*  765425 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(765503), // Rule ID 14367 //
     /*  765430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  765450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765501 */     GIR_RootConstrainSelectedInstOperands,
     /*  765502 */     // GIR_Coverage, 14367,
     /*  765502 */     GIR_EraseRootFromParent_Done,
     /*  765503 */   // Label 11954: @765503
     /*  765503 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(765581), // Rule ID 14370 //
     /*  765508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765579 */     GIR_RootConstrainSelectedInstOperands,
     /*  765580 */     // GIR_Coverage, 14370,
     /*  765580 */     GIR_EraseRootFromParent_Done,
     /*  765581 */   // Label 11955: @765581
     /*  765581 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(765659), // Rule ID 14371 //
     /*  765586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765632 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765657 */     GIR_RootConstrainSelectedInstOperands,
     /*  765658 */     // GIR_Coverage, 14371,
     /*  765658 */     GIR_EraseRootFromParent_Done,
     /*  765659 */   // Label 11956: @765659
     /*  765659 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(765737), // Rule ID 14374 //
     /*  765664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765735 */     GIR_RootConstrainSelectedInstOperands,
     /*  765736 */     // GIR_Coverage, 14374,
     /*  765736 */     GIR_EraseRootFromParent_Done,
     /*  765737 */   // Label 11957: @765737
     /*  765737 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(765815), // Rule ID 14375 //
     /*  765742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765813 */     GIR_RootConstrainSelectedInstOperands,
     /*  765814 */     // GIR_Coverage, 14375,
     /*  765814 */     GIR_EraseRootFromParent_Done,
     /*  765815 */   // Label 11958: @765815
     /*  765815 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(765893), // Rule ID 14378 //
     /*  765820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765891 */     GIR_RootConstrainSelectedInstOperands,
     /*  765892 */     // GIR_Coverage, 14378,
     /*  765892 */     GIR_EraseRootFromParent_Done,
     /*  765893 */   // Label 11959: @765893
     /*  765893 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(765971), // Rule ID 14379 //
     /*  765898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765969 */     GIR_RootConstrainSelectedInstOperands,
     /*  765970 */     // GIR_Coverage, 14379,
     /*  765970 */     GIR_EraseRootFromParent_Done,
     /*  765971 */   // Label 11960: @765971
     /*  765971 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(766049), // Rule ID 14382 //
     /*  765976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766047 */     GIR_RootConstrainSelectedInstOperands,
     /*  766048 */     // GIR_Coverage, 14382,
     /*  766048 */     GIR_EraseRootFromParent_Done,
     /*  766049 */   // Label 11961: @766049
     /*  766049 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(766127), // Rule ID 14383 //
     /*  766054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  766065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  766068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  766071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  766074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766125 */     GIR_RootConstrainSelectedInstOperands,
     /*  766126 */     // GIR_Coverage, 14383,
     /*  766126 */     GIR_EraseRootFromParent_Done,
     /*  766127 */   // Label 11962: @766127
     /*  766127 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(766205), // Rule ID 14386 //
     /*  766132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  766152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766203 */     GIR_RootConstrainSelectedInstOperands,
     /*  766204 */     // GIR_Coverage, 14386,
     /*  766204 */     GIR_EraseRootFromParent_Done,
     /*  766205 */   // Label 11963: @766205
     /*  766205 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(766283), // Rule ID 14387 //
     /*  766210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  766230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766281 */     GIR_RootConstrainSelectedInstOperands,
     /*  766282 */     // GIR_Coverage, 14387,
     /*  766282 */     GIR_EraseRootFromParent_Done,
     /*  766283 */   // Label 11964: @766283
     /*  766283 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(766361), // Rule ID 14390 //
     /*  766288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  766308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766359 */     GIR_RootConstrainSelectedInstOperands,
     /*  766360 */     // GIR_Coverage, 14390,
     /*  766360 */     GIR_EraseRootFromParent_Done,
     /*  766361 */   // Label 11965: @766361
     /*  766361 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(766439), // Rule ID 14391 //
     /*  766366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  766386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766437 */     GIR_RootConstrainSelectedInstOperands,
     /*  766438 */     // GIR_Coverage, 14391,
     /*  766438 */     GIR_EraseRootFromParent_Done,
     /*  766439 */   // Label 11966: @766439
     /*  766439 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(766517), // Rule ID 14394 //
     /*  766444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766515 */     GIR_RootConstrainSelectedInstOperands,
     /*  766516 */     // GIR_Coverage, 14394,
     /*  766516 */     GIR_EraseRootFromParent_Done,
     /*  766517 */   // Label 11967: @766517
     /*  766517 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(766595), // Rule ID 14395 //
     /*  766522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766593 */     GIR_RootConstrainSelectedInstOperands,
     /*  766594 */     // GIR_Coverage, 14395,
     /*  766594 */     GIR_EraseRootFromParent_Done,
     /*  766595 */   // Label 11968: @766595
     /*  766595 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(766673), // Rule ID 14398 //
     /*  766600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766671 */     GIR_RootConstrainSelectedInstOperands,
     /*  766672 */     // GIR_Coverage, 14398,
     /*  766672 */     GIR_EraseRootFromParent_Done,
     /*  766673 */   // Label 11969: @766673
     /*  766673 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(766751), // Rule ID 14399 //
     /*  766678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766749 */     GIR_RootConstrainSelectedInstOperands,
     /*  766750 */     // GIR_Coverage, 14399,
     /*  766750 */     GIR_EraseRootFromParent_Done,
     /*  766751 */   // Label 11970: @766751
     /*  766751 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(766829), // Rule ID 14402 //
     /*  766756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766827 */     GIR_RootConstrainSelectedInstOperands,
     /*  766828 */     // GIR_Coverage, 14402,
     /*  766828 */     GIR_EraseRootFromParent_Done,
     /*  766829 */   // Label 11971: @766829
     /*  766829 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(766907), // Rule ID 14403 //
     /*  766834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766905 */     GIR_RootConstrainSelectedInstOperands,
     /*  766906 */     // GIR_Coverage, 14403,
     /*  766906 */     GIR_EraseRootFromParent_Done,
     /*  766907 */   // Label 11972: @766907
     /*  766907 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(766985), // Rule ID 14406 //
     /*  766912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766983 */     GIR_RootConstrainSelectedInstOperands,
     /*  766984 */     // GIR_Coverage, 14406,
     /*  766984 */     GIR_EraseRootFromParent_Done,
     /*  766985 */   // Label 11973: @766985
     /*  766985 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(767063), // Rule ID 14407 //
     /*  766990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  767001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  767004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  767007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  767010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  767036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  767039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767061 */     GIR_RootConstrainSelectedInstOperands,
     /*  767062 */     // GIR_Coverage, 14407,
     /*  767062 */     GIR_EraseRootFromParent_Done,
     /*  767063 */   // Label 11974: @767063
     /*  767063 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(767141), // Rule ID 14410 //
     /*  767068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  767117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767139 */     GIR_RootConstrainSelectedInstOperands,
     /*  767140 */     // GIR_Coverage, 14410,
     /*  767140 */     GIR_EraseRootFromParent_Done,
     /*  767141 */   // Label 11975: @767141
     /*  767141 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(767219), // Rule ID 14411 //
     /*  767146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  767195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767217 */     GIR_RootConstrainSelectedInstOperands,
     /*  767218 */     // GIR_Coverage, 14411,
     /*  767218 */     GIR_EraseRootFromParent_Done,
     /*  767219 */   // Label 11976: @767219
     /*  767219 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(767297), // Rule ID 14414 //
     /*  767224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767295 */     GIR_RootConstrainSelectedInstOperands,
     /*  767296 */     // GIR_Coverage, 14414,
     /*  767296 */     GIR_EraseRootFromParent_Done,
     /*  767297 */   // Label 11977: @767297
     /*  767297 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(767375), // Rule ID 14415 //
     /*  767302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767373 */     GIR_RootConstrainSelectedInstOperands,
     /*  767374 */     // GIR_Coverage, 14415,
     /*  767374 */     GIR_EraseRootFromParent_Done,
     /*  767375 */   // Label 11978: @767375
     /*  767375 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(767453), // Rule ID 14418 //
     /*  767380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767451 */     GIR_RootConstrainSelectedInstOperands,
     /*  767452 */     // GIR_Coverage, 14418,
     /*  767452 */     GIR_EraseRootFromParent_Done,
     /*  767453 */   // Label 11979: @767453
     /*  767453 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(767531), // Rule ID 14419 //
     /*  767458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767529 */     GIR_RootConstrainSelectedInstOperands,
     /*  767530 */     // GIR_Coverage, 14419,
     /*  767530 */     GIR_EraseRootFromParent_Done,
     /*  767531 */   // Label 11980: @767531
     /*  767531 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(767609), // Rule ID 14422 //
     /*  767536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767582 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767607 */     GIR_RootConstrainSelectedInstOperands,
     /*  767608 */     // GIR_Coverage, 14422,
     /*  767608 */     GIR_EraseRootFromParent_Done,
     /*  767609 */   // Label 11981: @767609
     /*  767609 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(767687), // Rule ID 14423 //
     /*  767614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767685 */     GIR_RootConstrainSelectedInstOperands,
     /*  767686 */     // GIR_Coverage, 14423,
     /*  767686 */     GIR_EraseRootFromParent_Done,
     /*  767687 */   // Label 11982: @767687
     /*  767687 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(767765), // Rule ID 14426 //
     /*  767692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767763 */     GIR_RootConstrainSelectedInstOperands,
     /*  767764 */     // GIR_Coverage, 14426,
     /*  767764 */     GIR_EraseRootFromParent_Done,
     /*  767765 */   // Label 11983: @767765
     /*  767765 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(767843), // Rule ID 14427 //
     /*  767770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767841 */     GIR_RootConstrainSelectedInstOperands,
     /*  767842 */     // GIR_Coverage, 14427,
     /*  767842 */     GIR_EraseRootFromParent_Done,
     /*  767843 */   // Label 11984: @767843
     /*  767843 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(767921), // Rule ID 14430 //
     /*  767848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767919 */     GIR_RootConstrainSelectedInstOperands,
     /*  767920 */     // GIR_Coverage, 14430,
     /*  767920 */     GIR_EraseRootFromParent_Done,
     /*  767921 */   // Label 11985: @767921
     /*  767921 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(767999), // Rule ID 14431 //
     /*  767926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767997 */     GIR_RootConstrainSelectedInstOperands,
     /*  767998 */     // GIR_Coverage, 14431,
     /*  767998 */     GIR_EraseRootFromParent_Done,
     /*  767999 */   // Label 11986: @767999
     /*  767999 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(768077), // Rule ID 14434 //
     /*  768004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768075 */     GIR_RootConstrainSelectedInstOperands,
     /*  768076 */     // GIR_Coverage, 14434,
     /*  768076 */     GIR_EraseRootFromParent_Done,
     /*  768077 */   // Label 11987: @768077
     /*  768077 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(768155), // Rule ID 14435 //
     /*  768082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11587:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768153 */     GIR_RootConstrainSelectedInstOperands,
     /*  768154 */     // GIR_Coverage, 14435,
     /*  768154 */     GIR_EraseRootFromParent_Done,
     /*  768155 */   // Label 11988: @768155
     /*  768155 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(768233), // Rule ID 14438 //
     /*  768160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768231 */     GIR_RootConstrainSelectedInstOperands,
     /*  768232 */     // GIR_Coverage, 14438,
     /*  768232 */     GIR_EraseRootFromParent_Done,
     /*  768233 */   // Label 11989: @768233
     /*  768233 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(768311), // Rule ID 14439 //
     /*  768238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768309 */     GIR_RootConstrainSelectedInstOperands,
     /*  768310 */     // GIR_Coverage, 14439,
     /*  768310 */     GIR_EraseRootFromParent_Done,
     /*  768311 */   // Label 11990: @768311
     /*  768311 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(768389), // Rule ID 14442 //
     /*  768316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768387 */     GIR_RootConstrainSelectedInstOperands,
     /*  768388 */     // GIR_Coverage, 14442,
     /*  768388 */     GIR_EraseRootFromParent_Done,
     /*  768389 */   // Label 11991: @768389
     /*  768389 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(768467), // Rule ID 14443 //
     /*  768394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768465 */     GIR_RootConstrainSelectedInstOperands,
     /*  768466 */     // GIR_Coverage, 14443,
     /*  768466 */     GIR_EraseRootFromParent_Done,
     /*  768467 */   // Label 11992: @768467
     /*  768467 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(768545), // Rule ID 14446 //
     /*  768472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768543 */     GIR_RootConstrainSelectedInstOperands,
     /*  768544 */     // GIR_Coverage, 14446,
     /*  768544 */     GIR_EraseRootFromParent_Done,
     /*  768545 */   // Label 11993: @768545
     /*  768545 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(768623), // Rule ID 14447 //
     /*  768550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768621 */     GIR_RootConstrainSelectedInstOperands,
     /*  768622 */     // GIR_Coverage, 14447,
     /*  768622 */     GIR_EraseRootFromParent_Done,
     /*  768623 */   // Label 11994: @768623
     /*  768623 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(768701), // Rule ID 14450 //
     /*  768628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768699 */     GIR_RootConstrainSelectedInstOperands,
     /*  768700 */     // GIR_Coverage, 14450,
     /*  768700 */     GIR_EraseRootFromParent_Done,
     /*  768701 */   // Label 11995: @768701
     /*  768701 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(768779), // Rule ID 14451 //
     /*  768706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768777 */     GIR_RootConstrainSelectedInstOperands,
     /*  768778 */     // GIR_Coverage, 14451,
     /*  768778 */     GIR_EraseRootFromParent_Done,
     /*  768779 */   // Label 11996: @768779
     /*  768779 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(768857), // Rule ID 14454 //
     /*  768784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768855 */     GIR_RootConstrainSelectedInstOperands,
     /*  768856 */     // GIR_Coverage, 14454,
     /*  768856 */     GIR_EraseRootFromParent_Done,
     /*  768857 */   // Label 11997: @768857
     /*  768857 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(768935), // Rule ID 14455 //
     /*  768862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768933 */     GIR_RootConstrainSelectedInstOperands,
     /*  768934 */     // GIR_Coverage, 14455,
     /*  768934 */     GIR_EraseRootFromParent_Done,
     /*  768935 */   // Label 11998: @768935
     /*  768935 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(769013), // Rule ID 14458 //
     /*  768940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769011 */     GIR_RootConstrainSelectedInstOperands,
     /*  769012 */     // GIR_Coverage, 14458,
     /*  769012 */     GIR_EraseRootFromParent_Done,
     /*  769013 */   // Label 11999: @769013
     /*  769013 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(769091), // Rule ID 14459 //
     /*  769018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  769029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  769032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  769035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769089 */     GIR_RootConstrainSelectedInstOperands,
     /*  769090 */     // GIR_Coverage, 14459,
     /*  769090 */     GIR_EraseRootFromParent_Done,
     /*  769091 */   // Label 12000: @769091
     /*  769091 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(769169), // Rule ID 14462 //
     /*  769096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769167 */     GIR_RootConstrainSelectedInstOperands,
     /*  769168 */     // GIR_Coverage, 14462,
     /*  769168 */     GIR_EraseRootFromParent_Done,
     /*  769169 */   // Label 12001: @769169
     /*  769169 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(769247), // Rule ID 14463 //
     /*  769174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769245 */     GIR_RootConstrainSelectedInstOperands,
     /*  769246 */     // GIR_Coverage, 14463,
     /*  769246 */     GIR_EraseRootFromParent_Done,
     /*  769247 */   // Label 12002: @769247
     /*  769247 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(769325), // Rule ID 14466 //
     /*  769252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769298 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769323 */     GIR_RootConstrainSelectedInstOperands,
     /*  769324 */     // GIR_Coverage, 14466,
     /*  769324 */     GIR_EraseRootFromParent_Done,
     /*  769325 */   // Label 12003: @769325
     /*  769325 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(769403), // Rule ID 14467 //
     /*  769330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769401 */     GIR_RootConstrainSelectedInstOperands,
     /*  769402 */     // GIR_Coverage, 14467,
     /*  769402 */     GIR_EraseRootFromParent_Done,
     /*  769403 */   // Label 12004: @769403
     /*  769403 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(769481), // Rule ID 14470 //
     /*  769408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769479 */     GIR_RootConstrainSelectedInstOperands,
     /*  769480 */     // GIR_Coverage, 14470,
     /*  769480 */     GIR_EraseRootFromParent_Done,
     /*  769481 */   // Label 12005: @769481
     /*  769481 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(769559), // Rule ID 14471 //
     /*  769486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769557 */     GIR_RootConstrainSelectedInstOperands,
     /*  769558 */     // GIR_Coverage, 14471,
     /*  769558 */     GIR_EraseRootFromParent_Done,
     /*  769559 */   // Label 12006: @769559
     /*  769559 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(769637), // Rule ID 14474 //
     /*  769564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769635 */     GIR_RootConstrainSelectedInstOperands,
     /*  769636 */     // GIR_Coverage, 14474,
     /*  769636 */     GIR_EraseRootFromParent_Done,
     /*  769637 */   // Label 12007: @769637
     /*  769637 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(769715), // Rule ID 14475 //
     /*  769642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769713 */     GIR_RootConstrainSelectedInstOperands,
     /*  769714 */     // GIR_Coverage, 14475,
     /*  769714 */     GIR_EraseRootFromParent_Done,
     /*  769715 */   // Label 12008: @769715
     /*  769715 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(769793), // Rule ID 14478 //
     /*  769720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769791 */     GIR_RootConstrainSelectedInstOperands,
     /*  769792 */     // GIR_Coverage, 14478,
     /*  769792 */     GIR_EraseRootFromParent_Done,
     /*  769793 */   // Label 12009: @769793
     /*  769793 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(769871), // Rule ID 14479 //
     /*  769798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769869 */     GIR_RootConstrainSelectedInstOperands,
     /*  769870 */     // GIR_Coverage, 14479,
     /*  769870 */     GIR_EraseRootFromParent_Done,
     /*  769871 */   // Label 12010: @769871
     /*  769871 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(769949), // Rule ID 14482 //
     /*  769876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769922 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769947 */     GIR_RootConstrainSelectedInstOperands,
     /*  769948 */     // GIR_Coverage, 14482,
     /*  769948 */     GIR_EraseRootFromParent_Done,
     /*  769949 */   // Label 12011: @769949
     /*  769949 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(770027), // Rule ID 14483 //
     /*  769954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770025 */     GIR_RootConstrainSelectedInstOperands,
     /*  770026 */     // GIR_Coverage, 14483,
     /*  770026 */     GIR_EraseRootFromParent_Done,
     /*  770027 */   // Label 12012: @770027
     /*  770027 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(770105), // Rule ID 14486 //
     /*  770032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  770081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770103 */     GIR_RootConstrainSelectedInstOperands,
     /*  770104 */     // GIR_Coverage, 14486,
     /*  770104 */     GIR_EraseRootFromParent_Done,
     /*  770105 */   // Label 12013: @770105
     /*  770105 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(770183), // Rule ID 14487 //
     /*  770110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  770159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770181 */     GIR_RootConstrainSelectedInstOperands,
     /*  770182 */     // GIR_Coverage, 14487,
     /*  770182 */     GIR_EraseRootFromParent_Done,
     /*  770183 */   // Label 12014: @770183
     /*  770183 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(770261), // Rule ID 14490 //
     /*  770188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  770237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770259 */     GIR_RootConstrainSelectedInstOperands,
     /*  770260 */     // GIR_Coverage, 14490,
     /*  770260 */     GIR_EraseRootFromParent_Done,
     /*  770261 */   // Label 12015: @770261
     /*  770261 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(770339), // Rule ID 14491 //
     /*  770266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  770315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770337 */     GIR_RootConstrainSelectedInstOperands,
     /*  770338 */     // GIR_Coverage, 14491,
     /*  770338 */     GIR_EraseRootFromParent_Done,
     /*  770339 */   // Label 12016: @770339
     /*  770339 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(770417), // Rule ID 14494 //
     /*  770344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770390 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770415 */     GIR_RootConstrainSelectedInstOperands,
     /*  770416 */     // GIR_Coverage, 14494,
     /*  770416 */     GIR_EraseRootFromParent_Done,
     /*  770417 */   // Label 12017: @770417
     /*  770417 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(770495), // Rule ID 14495 //
     /*  770422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770493 */     GIR_RootConstrainSelectedInstOperands,
     /*  770494 */     // GIR_Coverage, 14495,
     /*  770494 */     GIR_EraseRootFromParent_Done,
     /*  770495 */   // Label 12018: @770495
     /*  770495 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(770573), // Rule ID 14586 //
     /*  770500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770571 */     GIR_RootConstrainSelectedInstOperands,
     /*  770572 */     // GIR_Coverage, 14586,
     /*  770572 */     GIR_EraseRootFromParent_Done,
     /*  770573 */   // Label 12019: @770573
     /*  770573 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(770651), // Rule ID 14587 //
     /*  770578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770649 */     GIR_RootConstrainSelectedInstOperands,
     /*  770650 */     // GIR_Coverage, 14587,
     /*  770650 */     GIR_EraseRootFromParent_Done,
     /*  770651 */   // Label 12020: @770651
     /*  770651 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(770729), // Rule ID 14590 //
     /*  770656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770727 */     GIR_RootConstrainSelectedInstOperands,
     /*  770728 */     // GIR_Coverage, 14590,
     /*  770728 */     GIR_EraseRootFromParent_Done,
     /*  770729 */   // Label 12021: @770729
     /*  770729 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(770807), // Rule ID 14591 //
     /*  770734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770780 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770805 */     GIR_RootConstrainSelectedInstOperands,
     /*  770806 */     // GIR_Coverage, 14591,
     /*  770806 */     GIR_EraseRootFromParent_Done,
     /*  770807 */   // Label 12022: @770807
     /*  770807 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(770885), // Rule ID 14594 //
     /*  770812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770858 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770883 */     GIR_RootConstrainSelectedInstOperands,
     /*  770884 */     // GIR_Coverage, 14594,
     /*  770884 */     GIR_EraseRootFromParent_Done,
     /*  770885 */   // Label 12023: @770885
     /*  770885 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(770963), // Rule ID 14595 //
     /*  770890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770961 */     GIR_RootConstrainSelectedInstOperands,
     /*  770962 */     // GIR_Coverage, 14595,
     /*  770962 */     GIR_EraseRootFromParent_Done,
     /*  770963 */   // Label 12024: @770963
     /*  770963 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(771041), // Rule ID 14598 //
     /*  770968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  771017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771039 */     GIR_RootConstrainSelectedInstOperands,
     /*  771040 */     // GIR_Coverage, 14598,
     /*  771040 */     GIR_EraseRootFromParent_Done,
     /*  771041 */   // Label 12025: @771041
     /*  771041 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(771119), // Rule ID 14599 //
     /*  771046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  771057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  771060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  771063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  771066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  771095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771117 */     GIR_RootConstrainSelectedInstOperands,
     /*  771118 */     // GIR_Coverage, 14599,
     /*  771118 */     GIR_EraseRootFromParent_Done,
     /*  771119 */   // Label 12026: @771119
     /*  771119 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(771197), // Rule ID 14602 //
     /*  771124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771170 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771195 */     GIR_RootConstrainSelectedInstOperands,
     /*  771196 */     // GIR_Coverage, 14602,
     /*  771196 */     GIR_EraseRootFromParent_Done,
     /*  771197 */   // Label 12027: @771197
     /*  771197 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(771275), // Rule ID 14603 //
     /*  771202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  771222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771273 */     GIR_RootConstrainSelectedInstOperands,
     /*  771274 */     // GIR_Coverage, 14603,
     /*  771274 */     GIR_EraseRootFromParent_Done,
     /*  771275 */   // Label 12028: @771275
     /*  771275 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(771353), // Rule ID 14606 //
     /*  771280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771351 */     GIR_RootConstrainSelectedInstOperands,
     /*  771352 */     // GIR_Coverage, 14606,
     /*  771352 */     GIR_EraseRootFromParent_Done,
     /*  771353 */   // Label 12029: @771353
     /*  771353 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(771431), // Rule ID 14607 //
     /*  771358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  771378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  771407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771429 */     GIR_RootConstrainSelectedInstOperands,
     /*  771430 */     // GIR_Coverage, 14607,
     /*  771430 */     GIR_EraseRootFromParent_Done,
     /*  771431 */   // Label 12030: @771431
     /*  771431 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(771509), // Rule ID 14610 //
     /*  771436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771507 */     GIR_RootConstrainSelectedInstOperands,
     /*  771508 */     // GIR_Coverage, 14610,
     /*  771508 */     GIR_EraseRootFromParent_Done,
     /*  771509 */   // Label 12031: @771509
     /*  771509 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(771587), // Rule ID 14611 //
     /*  771514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771585 */     GIR_RootConstrainSelectedInstOperands,
     /*  771586 */     // GIR_Coverage, 14611,
     /*  771586 */     GIR_EraseRootFromParent_Done,
     /*  771587 */   // Label 12032: @771587
     /*  771587 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(771665), // Rule ID 14614 //
     /*  771592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771663 */     GIR_RootConstrainSelectedInstOperands,
     /*  771664 */     // GIR_Coverage, 14614,
     /*  771664 */     GIR_EraseRootFromParent_Done,
     /*  771665 */   // Label 12033: @771665
     /*  771665 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(771743), // Rule ID 14615 //
     /*  771670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771741 */     GIR_RootConstrainSelectedInstOperands,
     /*  771742 */     // GIR_Coverage, 14615,
     /*  771742 */     GIR_EraseRootFromParent_Done,
     /*  771743 */   // Label 12034: @771743
     /*  771743 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(771821), // Rule ID 14618 //
     /*  771748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771819 */     GIR_RootConstrainSelectedInstOperands,
     /*  771820 */     // GIR_Coverage, 14618,
     /*  771820 */     GIR_EraseRootFromParent_Done,
     /*  771821 */   // Label 12035: @771821
     /*  771821 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(771899), // Rule ID 14619 //
     /*  771826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771897 */     GIR_RootConstrainSelectedInstOperands,
     /*  771898 */     // GIR_Coverage, 14619,
     /*  771898 */     GIR_EraseRootFromParent_Done,
     /*  771899 */   // Label 12036: @771899
     /*  771899 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(771977), // Rule ID 14622 //
     /*  771904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771975 */     GIR_RootConstrainSelectedInstOperands,
     /*  771976 */     // GIR_Coverage, 14622,
     /*  771976 */     GIR_EraseRootFromParent_Done,
     /*  771977 */   // Label 12037: @771977
     /*  771977 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(772055), // Rule ID 14623 //
     /*  771982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  772002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  772031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772053 */     GIR_RootConstrainSelectedInstOperands,
     /*  772054 */     // GIR_Coverage, 14623,
     /*  772054 */     GIR_EraseRootFromParent_Done,
     /*  772055 */   // Label 12038: @772055
     /*  772055 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(772133), // Rule ID 14626 //
     /*  772060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  772080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772131 */     GIR_RootConstrainSelectedInstOperands,
     /*  772132 */     // GIR_Coverage, 14626,
     /*  772132 */     GIR_EraseRootFromParent_Done,
     /*  772133 */   // Label 12039: @772133
     /*  772133 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(772211), // Rule ID 14627 //
     /*  772138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  772158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772209 */     GIR_RootConstrainSelectedInstOperands,
     /*  772210 */     // GIR_Coverage, 14627,
     /*  772210 */     GIR_EraseRootFromParent_Done,
     /*  772211 */   // Label 12040: @772211
     /*  772211 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(772289), // Rule ID 14630 //
     /*  772216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  772236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772262 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772287 */     GIR_RootConstrainSelectedInstOperands,
     /*  772288 */     // GIR_Coverage, 14630,
     /*  772288 */     GIR_EraseRootFromParent_Done,
     /*  772289 */   // Label 12041: @772289
     /*  772289 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(772367), // Rule ID 14631 //
     /*  772294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  772314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772365 */     GIR_RootConstrainSelectedInstOperands,
     /*  772366 */     // GIR_Coverage, 14631,
     /*  772366 */     GIR_EraseRootFromParent_Done,
     /*  772367 */   // Label 12042: @772367
     /*  772367 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(772445), // Rule ID 14634 //
     /*  772372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772443 */     GIR_RootConstrainSelectedInstOperands,
     /*  772444 */     // GIR_Coverage, 14634,
     /*  772444 */     GIR_EraseRootFromParent_Done,
     /*  772445 */   // Label 12043: @772445
     /*  772445 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(772523), // Rule ID 14635 //
     /*  772450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772521 */     GIR_RootConstrainSelectedInstOperands,
     /*  772522 */     // GIR_Coverage, 14635,
     /*  772522 */     GIR_EraseRootFromParent_Done,
     /*  772523 */   // Label 12044: @772523
     /*  772523 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(772601), // Rule ID 14638 //
     /*  772528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772599 */     GIR_RootConstrainSelectedInstOperands,
     /*  772600 */     // GIR_Coverage, 14638,
     /*  772600 */     GIR_EraseRootFromParent_Done,
     /*  772601 */   // Label 12045: @772601
     /*  772601 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(772679), // Rule ID 14639 //
     /*  772606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772677 */     GIR_RootConstrainSelectedInstOperands,
     /*  772678 */     // GIR_Coverage, 14639,
     /*  772678 */     GIR_EraseRootFromParent_Done,
     /*  772679 */   // Label 12046: @772679
     /*  772679 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(772757), // Rule ID 14642 //
     /*  772684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772755 */     GIR_RootConstrainSelectedInstOperands,
     /*  772756 */     // GIR_Coverage, 14642,
     /*  772756 */     GIR_EraseRootFromParent_Done,
     /*  772757 */   // Label 12047: @772757
     /*  772757 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(772835), // Rule ID 14643 //
     /*  772762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772808 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772833 */     GIR_RootConstrainSelectedInstOperands,
     /*  772834 */     // GIR_Coverage, 14643,
     /*  772834 */     GIR_EraseRootFromParent_Done,
     /*  772835 */   // Label 12048: @772835
     /*  772835 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(772913), // Rule ID 14646 //
     /*  772840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772911 */     GIR_RootConstrainSelectedInstOperands,
     /*  772912 */     // GIR_Coverage, 14646,
     /*  772912 */     GIR_EraseRootFromParent_Done,
     /*  772913 */   // Label 12049: @772913
     /*  772913 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(772991), // Rule ID 14647 //
     /*  772918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772964 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772989 */     GIR_RootConstrainSelectedInstOperands,
     /*  772990 */     // GIR_Coverage, 14647,
     /*  772990 */     GIR_EraseRootFromParent_Done,
     /*  772991 */   // Label 12050: @772991
     /*  772991 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(773069), // Rule ID 14650 //
     /*  772996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  773016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773067 */     GIR_RootConstrainSelectedInstOperands,
     /*  773068 */     // GIR_Coverage, 14650,
     /*  773068 */     GIR_EraseRootFromParent_Done,
     /*  773069 */   // Label 12051: @773069
     /*  773069 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(773147), // Rule ID 14651 //
     /*  773074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  773094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773145 */     GIR_RootConstrainSelectedInstOperands,
     /*  773146 */     // GIR_Coverage, 14651,
     /*  773146 */     GIR_EraseRootFromParent_Done,
     /*  773147 */   // Label 12052: @773147
     /*  773147 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(773225), // Rule ID 14654 //
     /*  773152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  773172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773223 */     GIR_RootConstrainSelectedInstOperands,
     /*  773224 */     // GIR_Coverage, 14654,
     /*  773224 */     GIR_EraseRootFromParent_Done,
     /*  773225 */   // Label 12053: @773225
     /*  773225 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(773303), // Rule ID 14655 //
     /*  773230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  773250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773301 */     GIR_RootConstrainSelectedInstOperands,
     /*  773302 */     // GIR_Coverage, 14655,
     /*  773302 */     GIR_EraseRootFromParent_Done,
     /*  773303 */   // Label 12054: @773303
     /*  773303 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(773381), // Rule ID 14658 //
     /*  773308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  773328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773354 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773379 */     GIR_RootConstrainSelectedInstOperands,
     /*  773380 */     // GIR_Coverage, 14658,
     /*  773380 */     GIR_EraseRootFromParent_Done,
     /*  773381 */   // Label 12055: @773381
     /*  773381 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(773459), // Rule ID 14659 //
     /*  773386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  773406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773457 */     GIR_RootConstrainSelectedInstOperands,
     /*  773458 */     // GIR_Coverage, 14659,
     /*  773458 */     GIR_EraseRootFromParent_Done,
     /*  773459 */   // Label 12056: @773459
     /*  773459 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(773537), // Rule ID 14662 //
     /*  773464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773535 */     GIR_RootConstrainSelectedInstOperands,
     /*  773536 */     // GIR_Coverage, 14662,
     /*  773536 */     GIR_EraseRootFromParent_Done,
     /*  773537 */   // Label 12057: @773537
     /*  773537 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(773615), // Rule ID 14663 //
     /*  773542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773613 */     GIR_RootConstrainSelectedInstOperands,
     /*  773614 */     // GIR_Coverage, 14663,
     /*  773614 */     GIR_EraseRootFromParent_Done,
     /*  773615 */   // Label 12058: @773615
     /*  773615 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(773693), // Rule ID 14666 //
     /*  773620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773691 */     GIR_RootConstrainSelectedInstOperands,
     /*  773692 */     // GIR_Coverage, 14666,
     /*  773692 */     GIR_EraseRootFromParent_Done,
     /*  773693 */   // Label 12059: @773693
     /*  773693 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(773771), // Rule ID 14667 //
     /*  773698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773769 */     GIR_RootConstrainSelectedInstOperands,
     /*  773770 */     // GIR_Coverage, 14667,
     /*  773770 */     GIR_EraseRootFromParent_Done,
     /*  773771 */   // Label 12060: @773771
     /*  773771 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(773849), // Rule ID 14670 //
     /*  773776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773822 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773847 */     GIR_RootConstrainSelectedInstOperands,
     /*  773848 */     // GIR_Coverage, 14670,
     /*  773848 */     GIR_EraseRootFromParent_Done,
     /*  773849 */   // Label 12061: @773849
     /*  773849 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(773927), // Rule ID 14671 //
     /*  773854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773900 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773925 */     GIR_RootConstrainSelectedInstOperands,
     /*  773926 */     // GIR_Coverage, 14671,
     /*  773926 */     GIR_EraseRootFromParent_Done,
     /*  773927 */   // Label 12062: @773927
     /*  773927 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(774005), // Rule ID 14674 //
     /*  773932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774003 */     GIR_RootConstrainSelectedInstOperands,
     /*  774004 */     // GIR_Coverage, 14674,
     /*  774004 */     GIR_EraseRootFromParent_Done,
     /*  774005 */   // Label 12063: @774005
     /*  774005 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(774083), // Rule ID 14675 //
     /*  774010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  774021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  774024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  774027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  774059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774081 */     GIR_RootConstrainSelectedInstOperands,
     /*  774082 */     // GIR_Coverage, 14675,
     /*  774082 */     GIR_EraseRootFromParent_Done,
     /*  774083 */   // Label 12064: @774083
     /*  774083 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(774161), // Rule ID 14678 //
     /*  774088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774159 */     GIR_RootConstrainSelectedInstOperands,
     /*  774160 */     // GIR_Coverage, 14678,
     /*  774160 */     GIR_EraseRootFromParent_Done,
     /*  774161 */   // Label 12065: @774161
     /*  774161 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(774239), // Rule ID 14679 //
     /*  774166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774212 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774237 */     GIR_RootConstrainSelectedInstOperands,
     /*  774238 */     // GIR_Coverage, 14679,
     /*  774238 */     GIR_EraseRootFromParent_Done,
     /*  774239 */   // Label 12066: @774239
     /*  774239 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(774317), // Rule ID 14682 //
     /*  774244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774290 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774315 */     GIR_RootConstrainSelectedInstOperands,
     /*  774316 */     // GIR_Coverage, 14682,
     /*  774316 */     GIR_EraseRootFromParent_Done,
     /*  774317 */   // Label 12067: @774317
     /*  774317 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(774395), // Rule ID 14683 //
     /*  774322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774368 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774393 */     GIR_RootConstrainSelectedInstOperands,
     /*  774394 */     // GIR_Coverage, 14683,
     /*  774394 */     GIR_EraseRootFromParent_Done,
     /*  774395 */   // Label 12068: @774395
     /*  774395 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(774473), // Rule ID 14686 //
     /*  774400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774471 */     GIR_RootConstrainSelectedInstOperands,
     /*  774472 */     // GIR_Coverage, 14686,
     /*  774472 */     GIR_EraseRootFromParent_Done,
     /*  774473 */   // Label 12069: @774473
     /*  774473 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(774551), // Rule ID 14687 //
     /*  774478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774549 */     GIR_RootConstrainSelectedInstOperands,
     /*  774550 */     // GIR_Coverage, 14687,
     /*  774550 */     GIR_EraseRootFromParent_Done,
     /*  774551 */   // Label 12070: @774551
     /*  774551 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(774629), // Rule ID 14690 //
     /*  774556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774627 */     GIR_RootConstrainSelectedInstOperands,
     /*  774628 */     // GIR_Coverage, 14690,
     /*  774628 */     GIR_EraseRootFromParent_Done,
     /*  774629 */   // Label 12071: @774629
     /*  774629 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(774707), // Rule ID 14691 //
     /*  774634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774705 */     GIR_RootConstrainSelectedInstOperands,
     /*  774706 */     // GIR_Coverage, 14691,
     /*  774706 */     GIR_EraseRootFromParent_Done,
     /*  774707 */   // Label 12072: @774707
     /*  774707 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(774785), // Rule ID 14694 //
     /*  774712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774783 */     GIR_RootConstrainSelectedInstOperands,
     /*  774784 */     // GIR_Coverage, 14694,
     /*  774784 */     GIR_EraseRootFromParent_Done,
     /*  774785 */   // Label 12073: @774785
     /*  774785 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(774863), // Rule ID 14695 //
     /*  774790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774861 */     GIR_RootConstrainSelectedInstOperands,
     /*  774862 */     // GIR_Coverage, 14695,
     /*  774862 */     GIR_EraseRootFromParent_Done,
     /*  774863 */   // Label 12074: @774863
     /*  774863 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(774941), // Rule ID 14698 //
     /*  774868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774939 */     GIR_RootConstrainSelectedInstOperands,
     /*  774940 */     // GIR_Coverage, 14698,
     /*  774940 */     GIR_EraseRootFromParent_Done,
     /*  774941 */   // Label 12075: @774941
     /*  774941 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(775019), // Rule ID 14699 //
     /*  774946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775017 */     GIR_RootConstrainSelectedInstOperands,
     /*  775018 */     // GIR_Coverage, 14699,
     /*  775018 */     GIR_EraseRootFromParent_Done,
     /*  775019 */   // Label 12076: @775019
     /*  775019 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(775097), // Rule ID 14702 //
     /*  775024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775095 */     GIR_RootConstrainSelectedInstOperands,
     /*  775096 */     // GIR_Coverage, 14702,
     /*  775096 */     GIR_EraseRootFromParent_Done,
     /*  775097 */   // Label 12077: @775097
     /*  775097 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(775175), // Rule ID 14703 //
     /*  775102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775173 */     GIR_RootConstrainSelectedInstOperands,
     /*  775174 */     // GIR_Coverage, 14703,
     /*  775174 */     GIR_EraseRootFromParent_Done,
     /*  775175 */   // Label 12078: @775175
     /*  775175 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(775253), // Rule ID 14706 //
     /*  775180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775251 */     GIR_RootConstrainSelectedInstOperands,
     /*  775252 */     // GIR_Coverage, 14706,
     /*  775252 */     GIR_EraseRootFromParent_Done,
     /*  775253 */   // Label 12079: @775253
     /*  775253 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(775331), // Rule ID 14707 //
     /*  775258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775329 */     GIR_RootConstrainSelectedInstOperands,
     /*  775330 */     // GIR_Coverage, 14707,
     /*  775330 */     GIR_EraseRootFromParent_Done,
     /*  775331 */   // Label 12080: @775331
     /*  775331 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(775409), // Rule ID 14710 //
     /*  775336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  775339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  775382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775407 */     GIR_RootConstrainSelectedInstOperands,
     /*  775408 */     // GIR_Coverage, 14710,
     /*  775408 */     GIR_EraseRootFromParent_Done,
     /*  775409 */   // Label 12081: @775409
     /*  775409 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(775487), // Rule ID 14711 //
     /*  775414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  775417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775460 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  775460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  775463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775485 */     GIR_RootConstrainSelectedInstOperands,
     /*  775486 */     // GIR_Coverage, 14711,
     /*  775486 */     GIR_EraseRootFromParent_Done,
     /*  775487 */   // Label 12082: @775487
     /*  775487 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(775565), // Rule ID 14714 //
     /*  775492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775563 */     GIR_RootConstrainSelectedInstOperands,
     /*  775564 */     // GIR_Coverage, 14714,
     /*  775564 */     GIR_EraseRootFromParent_Done,
     /*  775565 */   // Label 12083: @775565
     /*  775565 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(775643), // Rule ID 14715 //
     /*  775570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775641 */     GIR_RootConstrainSelectedInstOperands,
     /*  775642 */     // GIR_Coverage, 14715,
     /*  775642 */     GIR_EraseRootFromParent_Done,
     /*  775643 */   // Label 12084: @775643
     /*  775643 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(775721), // Rule ID 14718 //
     /*  775648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775719 */     GIR_RootConstrainSelectedInstOperands,
     /*  775720 */     // GIR_Coverage, 14718,
     /*  775720 */     GIR_EraseRootFromParent_Done,
     /*  775721 */   // Label 12085: @775721
     /*  775721 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(775799), // Rule ID 14719 //
     /*  775726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775772 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775797 */     GIR_RootConstrainSelectedInstOperands,
     /*  775798 */     // GIR_Coverage, 14719,
     /*  775798 */     GIR_EraseRootFromParent_Done,
     /*  775799 */   // Label 12086: @775799
     /*  775799 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(775877), // Rule ID 14722 //
     /*  775804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775875 */     GIR_RootConstrainSelectedInstOperands,
     /*  775876 */     // GIR_Coverage, 14722,
     /*  775876 */     GIR_EraseRootFromParent_Done,
     /*  775877 */   // Label 12087: @775877
     /*  775877 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(775955), // Rule ID 14723 //
     /*  775882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775953 */     GIR_RootConstrainSelectedInstOperands,
     /*  775954 */     // GIR_Coverage, 14723,
     /*  775954 */     GIR_EraseRootFromParent_Done,
     /*  775955 */   // Label 12088: @775955
     /*  775955 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(776033), // Rule ID 14726 //
     /*  775960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776031 */     GIR_RootConstrainSelectedInstOperands,
     /*  776032 */     // GIR_Coverage, 14726,
     /*  776032 */     GIR_EraseRootFromParent_Done,
     /*  776033 */   // Label 12089: @776033
     /*  776033 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(776111), // Rule ID 14727 //
     /*  776038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  776049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  776052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  776055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776109 */     GIR_RootConstrainSelectedInstOperands,
     /*  776110 */     // GIR_Coverage, 14727,
     /*  776110 */     GIR_EraseRootFromParent_Done,
     /*  776111 */   // Label 12090: @776111
     /*  776111 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(776189), // Rule ID 14730 //
     /*  776116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776162 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776187 */     GIR_RootConstrainSelectedInstOperands,
     /*  776188 */     // GIR_Coverage, 14730,
     /*  776188 */     GIR_EraseRootFromParent_Done,
     /*  776189 */   // Label 12091: @776189
     /*  776189 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(776267), // Rule ID 14731 //
     /*  776194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776265 */     GIR_RootConstrainSelectedInstOperands,
     /*  776266 */     // GIR_Coverage, 14731,
     /*  776266 */     GIR_EraseRootFromParent_Done,
     /*  776267 */   // Label 12092: @776267
     /*  776267 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(776345), // Rule ID 14734 //
     /*  776272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776343 */     GIR_RootConstrainSelectedInstOperands,
     /*  776344 */     // GIR_Coverage, 14734,
     /*  776344 */     GIR_EraseRootFromParent_Done,
     /*  776345 */   // Label 12093: @776345
     /*  776345 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(776423), // Rule ID 14735 //
     /*  776350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776421 */     GIR_RootConstrainSelectedInstOperands,
     /*  776422 */     // GIR_Coverage, 14735,
     /*  776422 */     GIR_EraseRootFromParent_Done,
     /*  776423 */   // Label 12094: @776423
     /*  776423 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(776501), // Rule ID 14738 //
     /*  776428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776499 */     GIR_RootConstrainSelectedInstOperands,
     /*  776500 */     // GIR_Coverage, 14738,
     /*  776500 */     GIR_EraseRootFromParent_Done,
     /*  776501 */   // Label 12095: @776501
     /*  776501 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(776579), // Rule ID 14739 //
     /*  776506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776577 */     GIR_RootConstrainSelectedInstOperands,
     /*  776578 */     // GIR_Coverage, 14739,
     /*  776578 */     GIR_EraseRootFromParent_Done,
     /*  776579 */   // Label 12096: @776579
     /*  776579 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(776657), // Rule ID 14742 //
     /*  776584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776655 */     GIR_RootConstrainSelectedInstOperands,
     /*  776656 */     // GIR_Coverage, 14742,
     /*  776656 */     GIR_EraseRootFromParent_Done,
     /*  776657 */   // Label 12097: @776657
     /*  776657 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(776735), // Rule ID 14743 //
     /*  776662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776733 */     GIR_RootConstrainSelectedInstOperands,
     /*  776734 */     // GIR_Coverage, 14743,
     /*  776734 */     GIR_EraseRootFromParent_Done,
     /*  776735 */   // Label 12098: @776735
     /*  776735 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(776813), // Rule ID 14746 //
     /*  776740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776811 */     GIR_RootConstrainSelectedInstOperands,
     /*  776812 */     // GIR_Coverage, 14746,
     /*  776812 */     GIR_EraseRootFromParent_Done,
     /*  776813 */   // Label 12099: @776813
     /*  776813 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(776891), // Rule ID 14747 //
     /*  776818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776889 */     GIR_RootConstrainSelectedInstOperands,
     /*  776890 */     // GIR_Coverage, 14747,
     /*  776890 */     GIR_EraseRootFromParent_Done,
     /*  776891 */   // Label 12100: @776891
     /*  776891 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(776969), // Rule ID 14750 //
     /*  776896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776967 */     GIR_RootConstrainSelectedInstOperands,
     /*  776968 */     // GIR_Coverage, 14750,
     /*  776968 */     GIR_EraseRootFromParent_Done,
     /*  776969 */   // Label 12101: @776969
     /*  776969 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(777047), // Rule ID 14751 //
     /*  776974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  777023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777045 */     GIR_RootConstrainSelectedInstOperands,
     /*  777046 */     // GIR_Coverage, 14751,
     /*  777046 */     GIR_EraseRootFromParent_Done,
     /*  777047 */   // Label 12102: @777047
     /*  777047 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(777125), // Rule ID 14754 //
     /*  777052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  777101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777123 */     GIR_RootConstrainSelectedInstOperands,
     /*  777124 */     // GIR_Coverage, 14754,
     /*  777124 */     GIR_EraseRootFromParent_Done,
     /*  777125 */   // Label 12103: @777125
     /*  777125 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(777203), // Rule ID 14755 //
     /*  777130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  777179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777201 */     GIR_RootConstrainSelectedInstOperands,
     /*  777202 */     // GIR_Coverage, 14755,
     /*  777202 */     GIR_EraseRootFromParent_Done,
     /*  777203 */   // Label 12104: @777203
     /*  777203 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(777281), // Rule ID 14758 //
     /*  777208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777254 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  777257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777279 */     GIR_RootConstrainSelectedInstOperands,
     /*  777280 */     // GIR_Coverage, 14758,
     /*  777280 */     GIR_EraseRootFromParent_Done,
     /*  777281 */   // Label 12105: @777281
     /*  777281 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(777359), // Rule ID 14759 //
     /*  777286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777332 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  777335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777357 */     GIR_RootConstrainSelectedInstOperands,
     /*  777358 */     // GIR_Coverage, 14759,
     /*  777358 */     GIR_EraseRootFromParent_Done,
     /*  777359 */   // Label 12106: @777359
     /*  777359 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(777437), // Rule ID 14762 //
     /*  777364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  777384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777435 */     GIR_RootConstrainSelectedInstOperands,
     /*  777436 */     // GIR_Coverage, 14762,
     /*  777436 */     GIR_EraseRootFromParent_Done,
     /*  777437 */   // Label 12107: @777437
     /*  777437 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(777515), // Rule ID 14763 //
     /*  777442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  777462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777513 */     GIR_RootConstrainSelectedInstOperands,
     /*  777514 */     // GIR_Coverage, 14763,
     /*  777514 */     GIR_EraseRootFromParent_Done,
     /*  777515 */   // Label 12108: @777515
     /*  777515 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(777593), // Rule ID 14766 //
     /*  777520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777566 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777591 */     GIR_RootConstrainSelectedInstOperands,
     /*  777592 */     // GIR_Coverage, 14766,
     /*  777592 */     GIR_EraseRootFromParent_Done,
     /*  777593 */   // Label 12109: @777593
     /*  777593 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(777671), // Rule ID 14767 //
     /*  777598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777644 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777669 */     GIR_RootConstrainSelectedInstOperands,
     /*  777670 */     // GIR_Coverage, 14767,
     /*  777670 */     GIR_EraseRootFromParent_Done,
     /*  777671 */   // Label 12110: @777671
     /*  777671 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(777749), // Rule ID 14770 //
     /*  777676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777747 */     GIR_RootConstrainSelectedInstOperands,
     /*  777748 */     // GIR_Coverage, 14770,
     /*  777748 */     GIR_EraseRootFromParent_Done,
     /*  777749 */   // Label 12111: @777749
     /*  777749 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(777827), // Rule ID 14771 //
     /*  777754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777800 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777825 */     GIR_RootConstrainSelectedInstOperands,
     /*  777826 */     // GIR_Coverage, 14771,
     /*  777826 */     GIR_EraseRootFromParent_Done,
     /*  777827 */   // Label 12112: @777827
     /*  777827 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(777905), // Rule ID 14774 //
     /*  777832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777878 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777903 */     GIR_RootConstrainSelectedInstOperands,
     /*  777904 */     // GIR_Coverage, 14774,
     /*  777904 */     GIR_EraseRootFromParent_Done,
     /*  777905 */   // Label 12113: @777905
     /*  777905 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(777983), // Rule ID 14775 //
     /*  777910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777981 */     GIR_RootConstrainSelectedInstOperands,
     /*  777982 */     // GIR_Coverage, 14775,
     /*  777982 */     GIR_EraseRootFromParent_Done,
     /*  777983 */   // Label 12114: @777983
     /*  777983 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(778061), // Rule ID 14778 //
     /*  777988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778059 */     GIR_RootConstrainSelectedInstOperands,
     /*  778060 */     // GIR_Coverage, 14778,
     /*  778060 */     GIR_EraseRootFromParent_Done,
     /*  778061 */   // Label 12115: @778061
     /*  778061 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(778139), // Rule ID 14779 //
     /*  778066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  778077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  778086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778137 */     GIR_RootConstrainSelectedInstOperands,
     /*  778138 */     // GIR_Coverage, 14779,
     /*  778138 */     GIR_EraseRootFromParent_Done,
     /*  778139 */   // Label 12116: @778139
     /*  778139 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(778217), // Rule ID 14782 //
     /*  778144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  778164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778215 */     GIR_RootConstrainSelectedInstOperands,
     /*  778216 */     // GIR_Coverage, 14782,
     /*  778216 */     GIR_EraseRootFromParent_Done,
     /*  778217 */   // Label 12117: @778217
     /*  778217 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(778295), // Rule ID 14783 //
     /*  778222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  778242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  778271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778293 */     GIR_RootConstrainSelectedInstOperands,
     /*  778294 */     // GIR_Coverage, 14783,
     /*  778294 */     GIR_EraseRootFromParent_Done,
     /*  778295 */   // Label 12118: @778295
     /*  778295 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(778373), // Rule ID 14786 //
     /*  778300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  778320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778371 */     GIR_RootConstrainSelectedInstOperands,
     /*  778372 */     // GIR_Coverage, 14786,
     /*  778372 */     GIR_EraseRootFromParent_Done,
     /*  778373 */   // Label 12119: @778373
     /*  778373 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(778451), // Rule ID 14787 //
     /*  778378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  778398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778449 */     GIR_RootConstrainSelectedInstOperands,
     /*  778450 */     // GIR_Coverage, 14787,
     /*  778450 */     GIR_EraseRootFromParent_Done,
     /*  778451 */   // Label 12120: @778451
     /*  778451 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(778529), // Rule ID 14790 //
     /*  778456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778527 */     GIR_RootConstrainSelectedInstOperands,
     /*  778528 */     // GIR_Coverage, 14790,
     /*  778528 */     GIR_EraseRootFromParent_Done,
     /*  778529 */   // Label 12121: @778529
     /*  778529 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(778607), // Rule ID 14791 //
     /*  778534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778605 */     GIR_RootConstrainSelectedInstOperands,
     /*  778606 */     // GIR_Coverage, 14791,
     /*  778606 */     GIR_EraseRootFromParent_Done,
     /*  778607 */   // Label 12122: @778607
     /*  778607 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(778685), // Rule ID 14794 //
     /*  778612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778683 */     GIR_RootConstrainSelectedInstOperands,
     /*  778684 */     // GIR_Coverage, 14794,
     /*  778684 */     GIR_EraseRootFromParent_Done,
     /*  778685 */   // Label 12123: @778685
     /*  778685 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(778763), // Rule ID 14795 //
     /*  778690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778761 */     GIR_RootConstrainSelectedInstOperands,
     /*  778762 */     // GIR_Coverage, 14795,
     /*  778762 */     GIR_EraseRootFromParent_Done,
     /*  778763 */   // Label 12124: @778763
     /*  778763 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(778841), // Rule ID 14798 //
     /*  778768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778839 */     GIR_RootConstrainSelectedInstOperands,
     /*  778840 */     // GIR_Coverage, 14798,
     /*  778840 */     GIR_EraseRootFromParent_Done,
     /*  778841 */   // Label 12125: @778841
     /*  778841 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(778919), // Rule ID 14799 //
     /*  778846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778917 */     GIR_RootConstrainSelectedInstOperands,
     /*  778918 */     // GIR_Coverage, 14799,
     /*  778918 */     GIR_EraseRootFromParent_Done,
     /*  778919 */   // Label 12126: @778919
     /*  778919 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(778997), // Rule ID 14802 //
     /*  778924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778995 */     GIR_RootConstrainSelectedInstOperands,
     /*  778996 */     // GIR_Coverage, 14802,
     /*  778996 */     GIR_EraseRootFromParent_Done,
     /*  778997 */   // Label 12127: @778997
     /*  778997 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(779075), // Rule ID 14803 //
     /*  779002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  779013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  779016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  779019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  779022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779073 */     GIR_RootConstrainSelectedInstOperands,
     /*  779074 */     // GIR_Coverage, 14803,
     /*  779074 */     GIR_EraseRootFromParent_Done,
     /*  779075 */   // Label 12128: @779075
     /*  779075 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(779153), // Rule ID 14806 //
     /*  779080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  779100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779151 */     GIR_RootConstrainSelectedInstOperands,
     /*  779152 */     // GIR_Coverage, 14806,
     /*  779152 */     GIR_EraseRootFromParent_Done,
     /*  779153 */   // Label 12129: @779153
     /*  779153 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(779231), // Rule ID 14807 //
     /*  779158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  779178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779229 */     GIR_RootConstrainSelectedInstOperands,
     /*  779230 */     // GIR_Coverage, 14807,
     /*  779230 */     GIR_EraseRootFromParent_Done,
     /*  779231 */   // Label 12130: @779231
     /*  779231 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(779309), // Rule ID 14810 //
     /*  779236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  779256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779307 */     GIR_RootConstrainSelectedInstOperands,
     /*  779308 */     // GIR_Coverage, 14810,
     /*  779308 */     GIR_EraseRootFromParent_Done,
     /*  779309 */   // Label 12131: @779309
     /*  779309 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(779387), // Rule ID 14811 //
     /*  779314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  779334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779385 */     GIR_RootConstrainSelectedInstOperands,
     /*  779386 */     // GIR_Coverage, 14811,
     /*  779386 */     GIR_EraseRootFromParent_Done,
     /*  779387 */   // Label 12132: @779387
     /*  779387 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(779465), // Rule ID 14814 //
     /*  779392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779463 */     GIR_RootConstrainSelectedInstOperands,
     /*  779464 */     // GIR_Coverage, 14814,
     /*  779464 */     GIR_EraseRootFromParent_Done,
     /*  779465 */   // Label 12133: @779465
     /*  779465 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(779543), // Rule ID 14815 //
     /*  779470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779541 */     GIR_RootConstrainSelectedInstOperands,
     /*  779542 */     // GIR_Coverage, 14815,
     /*  779542 */     GIR_EraseRootFromParent_Done,
     /*  779543 */   // Label 12134: @779543
     /*  779543 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(779621), // Rule ID 14818 //
     /*  779548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779594 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779619 */     GIR_RootConstrainSelectedInstOperands,
     /*  779620 */     // GIR_Coverage, 14818,
     /*  779620 */     GIR_EraseRootFromParent_Done,
     /*  779621 */   // Label 12135: @779621
     /*  779621 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(779699), // Rule ID 14819 //
     /*  779626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779697 */     GIR_RootConstrainSelectedInstOperands,
     /*  779698 */     // GIR_Coverage, 14819,
     /*  779698 */     GIR_EraseRootFromParent_Done,
     /*  779699 */   // Label 12136: @779699
     /*  779699 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(779777), // Rule ID 14822 //
     /*  779704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779775 */     GIR_RootConstrainSelectedInstOperands,
     /*  779776 */     // GIR_Coverage, 14822,
     /*  779776 */     GIR_EraseRootFromParent_Done,
     /*  779777 */   // Label 12137: @779777
     /*  779777 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(779855), // Rule ID 14823 //
     /*  779782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779853 */     GIR_RootConstrainSelectedInstOperands,
     /*  779854 */     // GIR_Coverage, 14823,
     /*  779854 */     GIR_EraseRootFromParent_Done,
     /*  779855 */   // Label 12138: @779855
     /*  779855 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(779933), // Rule ID 14826 //
     /*  779860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779931 */     GIR_RootConstrainSelectedInstOperands,
     /*  779932 */     // GIR_Coverage, 14826,
     /*  779932 */     GIR_EraseRootFromParent_Done,
     /*  779933 */   // Label 12139: @779933
     /*  779933 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(780011), // Rule ID 14827 //
     /*  779938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780009 */     GIR_RootConstrainSelectedInstOperands,
     /*  780010 */     // GIR_Coverage, 14827,
     /*  780010 */     GIR_EraseRootFromParent_Done,
     /*  780011 */   // Label 12140: @780011
     /*  780011 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(780089), // Rule ID 14830 //
     /*  780016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  780036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780087 */     GIR_RootConstrainSelectedInstOperands,
     /*  780088 */     // GIR_Coverage, 14830,
     /*  780088 */     GIR_EraseRootFromParent_Done,
     /*  780089 */   // Label 12141: @780089
     /*  780089 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(780167), // Rule ID 14831 //
     /*  780094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  780114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780165 */     GIR_RootConstrainSelectedInstOperands,
     /*  780166 */     // GIR_Coverage, 14831,
     /*  780166 */     GIR_EraseRootFromParent_Done,
     /*  780167 */   // Label 12142: @780167
     /*  780167 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(780245), // Rule ID 14834 //
     /*  780172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  780192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780243 */     GIR_RootConstrainSelectedInstOperands,
     /*  780244 */     // GIR_Coverage, 14834,
     /*  780244 */     GIR_EraseRootFromParent_Done,
     /*  780245 */   // Label 12143: @780245
     /*  780245 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(780323), // Rule ID 14835 //
     /*  780250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  780270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780321 */     GIR_RootConstrainSelectedInstOperands,
     /*  780322 */     // GIR_Coverage, 14835,
     /*  780322 */     GIR_EraseRootFromParent_Done,
     /*  780323 */   // Label 12144: @780323
     /*  780323 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(780401), // Rule ID 14838 //
     /*  780328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  780348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  780377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780399 */     GIR_RootConstrainSelectedInstOperands,
     /*  780400 */     // GIR_Coverage, 14838,
     /*  780400 */     GIR_EraseRootFromParent_Done,
     /*  780401 */   // Label 12145: @780401
     /*  780401 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(780479), // Rule ID 14839 //
     /*  780406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  780426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  780455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780477 */     GIR_RootConstrainSelectedInstOperands,
     /*  780478 */     // GIR_Coverage, 14839,
     /*  780478 */     GIR_EraseRootFromParent_Done,
     /*  780479 */   // Label 12146: @780479
     /*  780479 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(780557), // Rule ID 14842 //
     /*  780484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780555 */     GIR_RootConstrainSelectedInstOperands,
     /*  780556 */     // GIR_Coverage, 14842,
     /*  780556 */     GIR_EraseRootFromParent_Done,
     /*  780557 */   // Label 12147: @780557
     /*  780557 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(780635), // Rule ID 14843 //
     /*  780562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780633 */     GIR_RootConstrainSelectedInstOperands,
     /*  780634 */     // GIR_Coverage, 14843,
     /*  780634 */     GIR_EraseRootFromParent_Done,
     /*  780635 */   // Label 12148: @780635
     /*  780635 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(780713), // Rule ID 14846 //
     /*  780640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780686 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780711 */     GIR_RootConstrainSelectedInstOperands,
     /*  780712 */     // GIR_Coverage, 14846,
     /*  780712 */     GIR_EraseRootFromParent_Done,
     /*  780713 */   // Label 12149: @780713
     /*  780713 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(780791), // Rule ID 14847 //
     /*  780718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780789 */     GIR_RootConstrainSelectedInstOperands,
     /*  780790 */     // GIR_Coverage, 14847,
     /*  780790 */     GIR_EraseRootFromParent_Done,
     /*  780791 */   // Label 12150: @780791
     /*  780791 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(780869), // Rule ID 14850 //
     /*  780796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780867 */     GIR_RootConstrainSelectedInstOperands,
     /*  780868 */     // GIR_Coverage, 14850,
     /*  780868 */     GIR_EraseRootFromParent_Done,
     /*  780869 */   // Label 12151: @780869
     /*  780869 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(780947), // Rule ID 14851 //
     /*  780874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780945 */     GIR_RootConstrainSelectedInstOperands,
     /*  780946 */     // GIR_Coverage, 14851,
     /*  780946 */     GIR_EraseRootFromParent_Done,
     /*  780947 */   // Label 12152: @780947
     /*  780947 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(781025), // Rule ID 14854 //
     /*  780952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780998 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781023 */     GIR_RootConstrainSelectedInstOperands,
     /*  781024 */     // GIR_Coverage, 14854,
     /*  781024 */     GIR_EraseRootFromParent_Done,
     /*  781025 */   // Label 12153: @781025
     /*  781025 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(781103), // Rule ID 14855 //
     /*  781030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  781041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  781044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  781047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781101 */     GIR_RootConstrainSelectedInstOperands,
     /*  781102 */     // GIR_Coverage, 14855,
     /*  781102 */     GIR_EraseRootFromParent_Done,
     /*  781103 */   // Label 12154: @781103
     /*  781103 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(781181), // Rule ID 14858 //
     /*  781108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781154 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781179 */     GIR_RootConstrainSelectedInstOperands,
     /*  781180 */     // GIR_Coverage, 14858,
     /*  781180 */     GIR_EraseRootFromParent_Done,
     /*  781181 */   // Label 12155: @781181
     /*  781181 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(781259), // Rule ID 14859 //
     /*  781186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781257 */     GIR_RootConstrainSelectedInstOperands,
     /*  781258 */     // GIR_Coverage, 14859,
     /*  781258 */     GIR_EraseRootFromParent_Done,
     /*  781259 */   // Label 12156: @781259
     /*  781259 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(781337), // Rule ID 14862 //
     /*  781264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781335 */     GIR_RootConstrainSelectedInstOperands,
     /*  781336 */     // GIR_Coverage, 14862,
     /*  781336 */     GIR_EraseRootFromParent_Done,
     /*  781337 */   // Label 12157: @781337
     /*  781337 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(781415), // Rule ID 14863 //
     /*  781342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  781391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781413 */     GIR_RootConstrainSelectedInstOperands,
     /*  781414 */     // GIR_Coverage, 14863,
     /*  781414 */     GIR_EraseRootFromParent_Done,
     /*  781415 */   // Label 12158: @781415
     /*  781415 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(781493), // Rule ID 14866 //
     /*  781420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781491 */     GIR_RootConstrainSelectedInstOperands,
     /*  781492 */     // GIR_Coverage, 14866,
     /*  781492 */     GIR_EraseRootFromParent_Done,
     /*  781493 */   // Label 12159: @781493
     /*  781493 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(781571), // Rule ID 14867 //
     /*  781498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781569 */     GIR_RootConstrainSelectedInstOperands,
     /*  781570 */     // GIR_Coverage, 14867,
     /*  781570 */     GIR_EraseRootFromParent_Done,
     /*  781571 */   // Label 12160: @781571
     /*  781571 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(781649), // Rule ID 14870 //
     /*  781576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781647 */     GIR_RootConstrainSelectedInstOperands,
     /*  781648 */     // GIR_Coverage, 14870,
     /*  781648 */     GIR_EraseRootFromParent_Done,
     /*  781649 */   // Label 12161: @781649
     /*  781649 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(781727), // Rule ID 14871 //
     /*  781654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781725 */     GIR_RootConstrainSelectedInstOperands,
     /*  781726 */     // GIR_Coverage, 14871,
     /*  781726 */     GIR_EraseRootFromParent_Done,
     /*  781727 */   // Label 12162: @781727
     /*  781727 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(781805), // Rule ID 14874 //
     /*  781732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781803 */     GIR_RootConstrainSelectedInstOperands,
     /*  781804 */     // GIR_Coverage, 14874,
     /*  781804 */     GIR_EraseRootFromParent_Done,
     /*  781805 */   // Label 12163: @781805
     /*  781805 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(781883), // Rule ID 14875 //
     /*  781810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11673:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781881 */     GIR_RootConstrainSelectedInstOperands,
     /*  781882 */     // GIR_Coverage, 14875,
     /*  781882 */     GIR_EraseRootFromParent_Done,
     /*  781883 */   // Label 12164: @781883
     /*  781883 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(781961), // Rule ID 14878 //
     /*  781888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781959 */     GIR_RootConstrainSelectedInstOperands,
     /*  781960 */     // GIR_Coverage, 14878,
     /*  781960 */     GIR_EraseRootFromParent_Done,
     /*  781961 */   // Label 12165: @781961
     /*  781961 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(782039), // Rule ID 14879 //
     /*  781966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782037 */     GIR_RootConstrainSelectedInstOperands,
     /*  782038 */     // GIR_Coverage, 14879,
     /*  782038 */     GIR_EraseRootFromParent_Done,
     /*  782039 */   // Label 12166: @782039
     /*  782039 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(782117), // Rule ID 14882 //
     /*  782044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782115 */     GIR_RootConstrainSelectedInstOperands,
     /*  782116 */     // GIR_Coverage, 14882,
     /*  782116 */     GIR_EraseRootFromParent_Done,
     /*  782117 */   // Label 12167: @782117
     /*  782117 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(782195), // Rule ID 14883 //
     /*  782122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782193 */     GIR_RootConstrainSelectedInstOperands,
     /*  782194 */     // GIR_Coverage, 14883,
     /*  782194 */     GIR_EraseRootFromParent_Done,
     /*  782195 */   // Label 12168: @782195
     /*  782195 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(782273), // Rule ID 14886 //
     /*  782200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782271 */     GIR_RootConstrainSelectedInstOperands,
     /*  782272 */     // GIR_Coverage, 14886,
     /*  782272 */     GIR_EraseRootFromParent_Done,
     /*  782273 */   // Label 12169: @782273
     /*  782273 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(782351), // Rule ID 14887 //
     /*  782278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  782281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  782324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  782327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782349 */     GIR_RootConstrainSelectedInstOperands,
     /*  782350 */     // GIR_Coverage, 14887,
     /*  782350 */     GIR_EraseRootFromParent_Done,
     /*  782351 */   // Label 12170: @782351
     /*  782351 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(782429), // Rule ID 14890 //
     /*  782356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782427 */     GIR_RootConstrainSelectedInstOperands,
     /*  782428 */     // GIR_Coverage, 14890,
     /*  782428 */     GIR_EraseRootFromParent_Done,
     /*  782429 */   // Label 12171: @782429
     /*  782429 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(782507), // Rule ID 14891 //
     /*  782434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782505 */     GIR_RootConstrainSelectedInstOperands,
     /*  782506 */     // GIR_Coverage, 14891,
     /*  782506 */     GIR_EraseRootFromParent_Done,
     /*  782507 */   // Label 12172: @782507
     /*  782507 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(782585), // Rule ID 14894 //
     /*  782512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782583 */     GIR_RootConstrainSelectedInstOperands,
     /*  782584 */     // GIR_Coverage, 14894,
     /*  782584 */     GIR_EraseRootFromParent_Done,
     /*  782585 */   // Label 12173: @782585
     /*  782585 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(782663), // Rule ID 14895 //
     /*  782590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782661 */     GIR_RootConstrainSelectedInstOperands,
     /*  782662 */     // GIR_Coverage, 14895,
     /*  782662 */     GIR_EraseRootFromParent_Done,
     /*  782663 */   // Label 12174: @782663
     /*  782663 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(782741), // Rule ID 14898 //
     /*  782668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782739 */     GIR_RootConstrainSelectedInstOperands,
     /*  782740 */     // GIR_Coverage, 14898,
     /*  782740 */     GIR_EraseRootFromParent_Done,
     /*  782741 */   // Label 12175: @782741
     /*  782741 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(782819), // Rule ID 14899 //
     /*  782746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782817 */     GIR_RootConstrainSelectedInstOperands,
     /*  782818 */     // GIR_Coverage, 14899,
     /*  782818 */     GIR_EraseRootFromParent_Done,
     /*  782819 */   // Label 12176: @782819
     /*  782819 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(782897), // Rule ID 14902 //
     /*  782824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782895 */     GIR_RootConstrainSelectedInstOperands,
     /*  782896 */     // GIR_Coverage, 14902,
     /*  782896 */     GIR_EraseRootFromParent_Done,
     /*  782897 */   // Label 12177: @782897
     /*  782897 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(782975), // Rule ID 14903 //
     /*  782902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782948 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782973 */     GIR_RootConstrainSelectedInstOperands,
     /*  782974 */     // GIR_Coverage, 14903,
     /*  782974 */     GIR_EraseRootFromParent_Done,
     /*  782975 */   // Label 12178: @782975
     /*  782975 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(783053), // Rule ID 14906 //
     /*  782980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783051 */     GIR_RootConstrainSelectedInstOperands,
     /*  783052 */     // GIR_Coverage, 14906,
     /*  783052 */     GIR_EraseRootFromParent_Done,
     /*  783053 */   // Label 12179: @783053
     /*  783053 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(783131), // Rule ID 14907 //
     /*  783058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783129 */     GIR_RootConstrainSelectedInstOperands,
     /*  783130 */     // GIR_Coverage, 14907,
     /*  783130 */     GIR_EraseRootFromParent_Done,
     /*  783131 */   // Label 12180: @783131
     /*  783131 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(783209), // Rule ID 14910 //
     /*  783136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783207 */     GIR_RootConstrainSelectedInstOperands,
     /*  783208 */     // GIR_Coverage, 14910,
     /*  783208 */     GIR_EraseRootFromParent_Done,
     /*  783209 */   // Label 12181: @783209
     /*  783209 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(783287), // Rule ID 14911 //
     /*  783214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783285 */     GIR_RootConstrainSelectedInstOperands,
     /*  783286 */     // GIR_Coverage, 14911,
     /*  783286 */     GIR_EraseRootFromParent_Done,
     /*  783287 */   // Label 12182: @783287
     /*  783287 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(783365), // Rule ID 14914 //
     /*  783292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783363 */     GIR_RootConstrainSelectedInstOperands,
     /*  783364 */     // GIR_Coverage, 14914,
     /*  783364 */     GIR_EraseRootFromParent_Done,
     /*  783365 */   // Label 12183: @783365
     /*  783365 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(783443), // Rule ID 14915 //
     /*  783370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783441 */     GIR_RootConstrainSelectedInstOperands,
     /*  783442 */     // GIR_Coverage, 14915,
     /*  783442 */     GIR_EraseRootFromParent_Done,
     /*  783443 */   // Label 12184: @783443
     /*  783443 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(783521), // Rule ID 14918 //
     /*  783448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783519 */     GIR_RootConstrainSelectedInstOperands,
     /*  783520 */     // GIR_Coverage, 14918,
     /*  783520 */     GIR_EraseRootFromParent_Done,
     /*  783521 */   // Label 12185: @783521
     /*  783521 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(783599), // Rule ID 14919 //
     /*  783526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783597 */     GIR_RootConstrainSelectedInstOperands,
     /*  783598 */     // GIR_Coverage, 14919,
     /*  783598 */     GIR_EraseRootFromParent_Done,
     /*  783599 */   // Label 12186: @783599
     /*  783599 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(783677), // Rule ID 14922 //
     /*  783604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783675 */     GIR_RootConstrainSelectedInstOperands,
     /*  783676 */     // GIR_Coverage, 14922,
     /*  783676 */     GIR_EraseRootFromParent_Done,
     /*  783677 */   // Label 12187: @783677
     /*  783677 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(783755), // Rule ID 14923 //
     /*  783682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783753 */     GIR_RootConstrainSelectedInstOperands,
     /*  783754 */     // GIR_Coverage, 14923,
     /*  783754 */     GIR_EraseRootFromParent_Done,
     /*  783755 */   // Label 12188: @783755
     /*  783755 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(783833), // Rule ID 14926 //
     /*  783760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783831 */     GIR_RootConstrainSelectedInstOperands,
     /*  783832 */     // GIR_Coverage, 14926,
     /*  783832 */     GIR_EraseRootFromParent_Done,
     /*  783833 */   // Label 12189: @783833
     /*  783833 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(783911), // Rule ID 14927 //
     /*  783838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783909 */     GIR_RootConstrainSelectedInstOperands,
     /*  783910 */     // GIR_Coverage, 14927,
     /*  783910 */     GIR_EraseRootFromParent_Done,
     /*  783911 */   // Label 12190: @783911
     /*  783911 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(783989), // Rule ID 14930 //
     /*  783916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783987 */     GIR_RootConstrainSelectedInstOperands,
     /*  783988 */     // GIR_Coverage, 14930,
     /*  783988 */     GIR_EraseRootFromParent_Done,
     /*  783989 */   // Label 12191: @783989
     /*  783989 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(784067), // Rule ID 14931 //
     /*  783994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  784005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  784008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  784011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784040 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  784043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784065 */     GIR_RootConstrainSelectedInstOperands,
     /*  784066 */     // GIR_Coverage, 14931,
     /*  784066 */     GIR_EraseRootFromParent_Done,
     /*  784067 */   // Label 12192: @784067
     /*  784067 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(784145), // Rule ID 14934 //
     /*  784072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  784075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  784121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784143 */     GIR_RootConstrainSelectedInstOperands,
     /*  784144 */     // GIR_Coverage, 14934,
     /*  784144 */     GIR_EraseRootFromParent_Done,
     /*  784145 */   // Label 12193: @784145
     /*  784145 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(784223), // Rule ID 14935 //
     /*  784150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  784153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  784199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784221 */     GIR_RootConstrainSelectedInstOperands,
     /*  784222 */     // GIR_Coverage, 14935,
     /*  784222 */     GIR_EraseRootFromParent_Done,
     /*  784223 */   // Label 12194: @784223
     /*  784223 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(784298), // Rule ID 19176 //
     /*  784228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784274 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  784277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784296 */     GIR_RootConstrainSelectedInstOperands,
     /*  784297 */     // GIR_Coverage, 19176,
     /*  784297 */     GIR_EraseRootFromParent_Done,
     /*  784298 */   // Label 12195: @784298
     /*  784298 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(784373), // Rule ID 19177 //
     /*  784303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  784323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784349 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  784352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784371 */     GIR_RootConstrainSelectedInstOperands,
     /*  784372 */     // GIR_Coverage, 19177,
     /*  784372 */     GIR_EraseRootFromParent_Done,
     /*  784373 */   // Label 12196: @784373
     /*  784373 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(784448), // Rule ID 19180 //
     /*  784378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784446 */     GIR_RootConstrainSelectedInstOperands,
     /*  784447 */     // GIR_Coverage, 19180,
     /*  784447 */     GIR_EraseRootFromParent_Done,
     /*  784448 */   // Label 12197: @784448
     /*  784448 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(784523), // Rule ID 19181 //
     /*  784453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784499 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784521 */     GIR_RootConstrainSelectedInstOperands,
     /*  784522 */     // GIR_Coverage, 19181,
     /*  784522 */     GIR_EraseRootFromParent_Done,
     /*  784523 */   // Label 12198: @784523
     /*  784523 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(784598), // Rule ID 19184 //
     /*  784528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784596 */     GIR_RootConstrainSelectedInstOperands,
     /*  784597 */     // GIR_Coverage, 19184,
     /*  784597 */     GIR_EraseRootFromParent_Done,
     /*  784598 */   // Label 12199: @784598
     /*  784598 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(784673), // Rule ID 19185 //
     /*  784603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784649 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784671 */     GIR_RootConstrainSelectedInstOperands,
     /*  784672 */     // GIR_Coverage, 19185,
     /*  784672 */     GIR_EraseRootFromParent_Done,
     /*  784673 */   // Label 12200: @784673
     /*  784673 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(784748), // Rule ID 19188 //
     /*  784678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784746 */     GIR_RootConstrainSelectedInstOperands,
     /*  784747 */     // GIR_Coverage, 19188,
     /*  784747 */     GIR_EraseRootFromParent_Done,
     /*  784748 */   // Label 12201: @784748
     /*  784748 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(784823), // Rule ID 19189 //
     /*  784753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784821 */     GIR_RootConstrainSelectedInstOperands,
     /*  784822 */     // GIR_Coverage, 19189,
     /*  784822 */     GIR_EraseRootFromParent_Done,
     /*  784823 */   // Label 12202: @784823
     /*  784823 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(784898), // Rule ID 19192 //
     /*  784828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784896 */     GIR_RootConstrainSelectedInstOperands,
     /*  784897 */     // GIR_Coverage, 19192,
     /*  784897 */     GIR_EraseRootFromParent_Done,
     /*  784898 */   // Label 12203: @784898
     /*  784898 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(784973), // Rule ID 19193 //
     /*  784903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784949 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784971 */     GIR_RootConstrainSelectedInstOperands,
     /*  784972 */     // GIR_Coverage, 19193,
     /*  784972 */     GIR_EraseRootFromParent_Done,
     /*  784973 */   // Label 12204: @784973
     /*  784973 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(785048), // Rule ID 19196 //
     /*  784978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  784981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  785027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785046 */     GIR_RootConstrainSelectedInstOperands,
     /*  785047 */     // GIR_Coverage, 19196,
     /*  785047 */     GIR_EraseRootFromParent_Done,
     /*  785048 */   // Label 12205: @785048
     /*  785048 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(785123), // Rule ID 19197 //
     /*  785053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  785073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  785102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785121 */     GIR_RootConstrainSelectedInstOperands,
     /*  785122 */     // GIR_Coverage, 19197,
     /*  785122 */     GIR_EraseRootFromParent_Done,
     /*  785123 */   // Label 12206: @785123
     /*  785123 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(785198), // Rule ID 19200 //
     /*  785128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  785139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  785142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  785177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785196 */     GIR_RootConstrainSelectedInstOperands,
     /*  785197 */     // GIR_Coverage, 19200,
     /*  785197 */     GIR_EraseRootFromParent_Done,
     /*  785198 */   // Label 12207: @785198
     /*  785198 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(785273), // Rule ID 19201 //
     /*  785203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  785214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  785217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  785220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  785223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  785252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785271 */     GIR_RootConstrainSelectedInstOperands,
     /*  785272 */     // GIR_Coverage, 19201,
     /*  785272 */     GIR_EraseRootFromParent_Done,
     /*  785273 */   // Label 12208: @785273
     /*  785273 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(785348), // Rule ID 19204 //
     /*  785278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  785289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  785292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  785327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785346 */     GIR_RootConstrainSelectedInstOperands,
     /*  785347 */     // GIR_Coverage, 19204,
     /*  785347 */     GIR_EraseRootFromParent_Done,
     /*  785348 */   // Label 12209: @785348
     /*  785348 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(785423), // Rule ID 19205 //
     /*  785353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  785364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  785367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  785370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  785373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785399 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  785402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785421 */     GIR_RootConstrainSelectedInstOperands,
     /*  785422 */     // GIR_Coverage, 19205,
     /*  785422 */     GIR_EraseRootFromParent_Done,
     /*  785423 */   // Label 12210: @785423
     /*  785423 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(785498), // Rule ID 19208 //
     /*  785428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785474 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785496 */     GIR_RootConstrainSelectedInstOperands,
     /*  785497 */     // GIR_Coverage, 19208,
     /*  785497 */     GIR_EraseRootFromParent_Done,
     /*  785498 */   // Label 12211: @785498
     /*  785498 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(785573), // Rule ID 19209 //
     /*  785503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785549 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785571 */     GIR_RootConstrainSelectedInstOperands,
     /*  785572 */     // GIR_Coverage, 19209,
     /*  785572 */     GIR_EraseRootFromParent_Done,
     /*  785573 */   // Label 12212: @785573
     /*  785573 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(785648), // Rule ID 19212 //
     /*  785578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785646 */     GIR_RootConstrainSelectedInstOperands,
     /*  785647 */     // GIR_Coverage, 19212,
     /*  785647 */     GIR_EraseRootFromParent_Done,
     /*  785648 */   // Label 12213: @785648
     /*  785648 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(785723), // Rule ID 19213 //
     /*  785653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785721 */     GIR_RootConstrainSelectedInstOperands,
     /*  785722 */     // GIR_Coverage, 19213,
     /*  785722 */     GIR_EraseRootFromParent_Done,
     /*  785723 */   // Label 12214: @785723
     /*  785723 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(785798), // Rule ID 19216 //
     /*  785728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785796 */     GIR_RootConstrainSelectedInstOperands,
     /*  785797 */     // GIR_Coverage, 19216,
     /*  785797 */     GIR_EraseRootFromParent_Done,
     /*  785798 */   // Label 12215: @785798
     /*  785798 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(785873), // Rule ID 19217 //
     /*  785803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785849 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785871 */     GIR_RootConstrainSelectedInstOperands,
     /*  785872 */     // GIR_Coverage, 19217,
     /*  785872 */     GIR_EraseRootFromParent_Done,
     /*  785873 */   // Label 12216: @785873
     /*  785873 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(785948), // Rule ID 19220 //
     /*  785878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785946 */     GIR_RootConstrainSelectedInstOperands,
     /*  785947 */     // GIR_Coverage, 19220,
     /*  785947 */     GIR_EraseRootFromParent_Done,
     /*  785948 */   // Label 12217: @785948
     /*  785948 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(786023), // Rule ID 19221 //
     /*  785953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785999 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  786002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786021 */     GIR_RootConstrainSelectedInstOperands,
     /*  786022 */     // GIR_Coverage, 19221,
     /*  786022 */     GIR_EraseRootFromParent_Done,
     /*  786023 */   // Label 12218: @786023
     /*  786023 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(786098), // Rule ID 19224 //
     /*  786028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  786039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  786042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  786045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  786048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  786077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786096 */     GIR_RootConstrainSelectedInstOperands,
     /*  786097 */     // GIR_Coverage, 19224,
     /*  786097 */     GIR_EraseRootFromParent_Done,
     /*  786098 */   // Label 12219: @786098
     /*  786098 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(786173), // Rule ID 19225 //
     /*  786103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  786114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  786117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  786120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  786123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  786152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786171 */     GIR_RootConstrainSelectedInstOperands,
     /*  786172 */     // GIR_Coverage, 19225,
     /*  786172 */     GIR_EraseRootFromParent_Done,
     /*  786173 */   // Label 12220: @786173
     /*  786173 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(786248), // Rule ID 19228 //
     /*  786178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  786189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  786192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  786195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  786198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  786227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786246 */     GIR_RootConstrainSelectedInstOperands,
     /*  786247 */     // GIR_Coverage, 19228,
     /*  786247 */     GIR_EraseRootFromParent_Done,
     /*  786248 */   // Label 12221: @786248
     /*  786248 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(786323), // Rule ID 19229 //
     /*  786253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  786264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  786267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  786270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  786273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  786302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786321 */     GIR_RootConstrainSelectedInstOperands,
     /*  786322 */     // GIR_Coverage, 19229,
     /*  786322 */     GIR_EraseRootFromParent_Done,
     /*  786323 */   // Label 12222: @786323
     /*  786323 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(786398), // Rule ID 19232 //
     /*  786328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  786345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  786348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  786377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786396 */     GIR_RootConstrainSelectedInstOperands,
     /*  786397 */     // GIR_Coverage, 19232,
     /*  786397 */     GIR_EraseRootFromParent_Done,
     /*  786398 */   // Label 12223: @786398
     /*  786398 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(786473), // Rule ID 19233 //
     /*  786403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  786414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  786417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  786420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  786423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786449 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  786452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786471 */     GIR_RootConstrainSelectedInstOperands,
     /*  786472 */     // GIR_Coverage, 19233,
     /*  786472 */     GIR_EraseRootFromParent_Done,
     /*  786473 */   // Label 12224: @786473
     /*  786473 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(786548), // Rule ID 19236 //
     /*  786478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786546 */     GIR_RootConstrainSelectedInstOperands,
     /*  786547 */     // GIR_Coverage, 19236,
     /*  786547 */     GIR_EraseRootFromParent_Done,
     /*  786548 */   // Label 12225: @786548
     /*  786548 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(786623), // Rule ID 19237 //
     /*  786553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786599 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786621 */     GIR_RootConstrainSelectedInstOperands,
     /*  786622 */     // GIR_Coverage, 19237,
     /*  786622 */     GIR_EraseRootFromParent_Done,
     /*  786623 */   // Label 12226: @786623
     /*  786623 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(786698), // Rule ID 19240 //
     /*  786628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786696 */     GIR_RootConstrainSelectedInstOperands,
     /*  786697 */     // GIR_Coverage, 19240,
     /*  786697 */     GIR_EraseRootFromParent_Done,
     /*  786698 */   // Label 12227: @786698
     /*  786698 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(786773), // Rule ID 19241 //
     /*  786703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786749 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786771 */     GIR_RootConstrainSelectedInstOperands,
     /*  786772 */     // GIR_Coverage, 19241,
     /*  786772 */     GIR_EraseRootFromParent_Done,
     /*  786773 */   // Label 12228: @786773
     /*  786773 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(786848), // Rule ID 19244 //
     /*  786778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786846 */     GIR_RootConstrainSelectedInstOperands,
     /*  786847 */     // GIR_Coverage, 19244,
     /*  786847 */     GIR_EraseRootFromParent_Done,
     /*  786848 */   // Label 12229: @786848
     /*  786848 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(786923), // Rule ID 19245 //
     /*  786853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786921 */     GIR_RootConstrainSelectedInstOperands,
     /*  786922 */     // GIR_Coverage, 19245,
     /*  786922 */     GIR_EraseRootFromParent_Done,
     /*  786923 */   // Label 12230: @786923
     /*  786923 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(786998), // Rule ID 19248 //
     /*  786928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786996 */     GIR_RootConstrainSelectedInstOperands,
     /*  786997 */     // GIR_Coverage, 19248,
     /*  786997 */     GIR_EraseRootFromParent_Done,
     /*  786998 */   // Label 12231: @786998
     /*  786998 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(787073), // Rule ID 19249 //
     /*  787003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  787014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  787017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  787020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787049 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  787052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787071 */     GIR_RootConstrainSelectedInstOperands,
     /*  787072 */     // GIR_Coverage, 19249,
     /*  787072 */     GIR_EraseRootFromParent_Done,
     /*  787073 */   // Label 12232: @787073
     /*  787073 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(787148), // Rule ID 19252 //
     /*  787078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  787095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  787127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787146 */     GIR_RootConstrainSelectedInstOperands,
     /*  787147 */     // GIR_Coverage, 19252,
     /*  787147 */     GIR_EraseRootFromParent_Done,
     /*  787148 */   // Label 12233: @787148
     /*  787148 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(787223), // Rule ID 19253 //
     /*  787153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  787164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  787167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  787170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787199 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  787202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787221 */     GIR_RootConstrainSelectedInstOperands,
     /*  787222 */     // GIR_Coverage, 19253,
     /*  787222 */     GIR_EraseRootFromParent_Done,
     /*  787223 */   // Label 12234: @787223
     /*  787223 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(787298), // Rule ID 19256 //
     /*  787228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  787245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  787277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787296 */     GIR_RootConstrainSelectedInstOperands,
     /*  787297 */     // GIR_Coverage, 19256,
     /*  787297 */     GIR_EraseRootFromParent_Done,
     /*  787298 */   // Label 12235: @787298
     /*  787298 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(787373), // Rule ID 19257 //
     /*  787303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  787314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  787317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  787320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787349 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  787352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787371 */     GIR_RootConstrainSelectedInstOperands,
     /*  787372 */     // GIR_Coverage, 19257,
     /*  787372 */     GIR_EraseRootFromParent_Done,
     /*  787373 */   // Label 12236: @787373
     /*  787373 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(787448), // Rule ID 19260 //
     /*  787378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  787389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787446 */     GIR_RootConstrainSelectedInstOperands,
     /*  787447 */     // GIR_Coverage, 19260,
     /*  787447 */     GIR_EraseRootFromParent_Done,
     /*  787448 */   // Label 12237: @787448
     /*  787448 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(787523), // Rule ID 19261 //
     /*  787453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  787464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787521 */     GIR_RootConstrainSelectedInstOperands,
     /*  787522 */     // GIR_Coverage, 19261,
     /*  787522 */     GIR_EraseRootFromParent_Done,
     /*  787523 */   // Label 12238: @787523
     /*  787523 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(787598), // Rule ID 19264 //
     /*  787528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787596 */     GIR_RootConstrainSelectedInstOperands,
     /*  787597 */     // GIR_Coverage, 19264,
     /*  787597 */     GIR_EraseRootFromParent_Done,
     /*  787598 */   // Label 12239: @787598
     /*  787598 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(787673), // Rule ID 19265 //
     /*  787603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787649 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787671 */     GIR_RootConstrainSelectedInstOperands,
     /*  787672 */     // GIR_Coverage, 19265,
     /*  787672 */     GIR_EraseRootFromParent_Done,
     /*  787673 */   // Label 12240: @787673
     /*  787673 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(787748), // Rule ID 19268 //
     /*  787678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787724 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787746 */     GIR_RootConstrainSelectedInstOperands,
     /*  787747 */     // GIR_Coverage, 19268,
     /*  787747 */     GIR_EraseRootFromParent_Done,
     /*  787748 */   // Label 12241: @787748
     /*  787748 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(787823), // Rule ID 19269 //
     /*  787753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787799 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787821 */     GIR_RootConstrainSelectedInstOperands,
     /*  787822 */     // GIR_Coverage, 19269,
     /*  787822 */     GIR_EraseRootFromParent_Done,
     /*  787823 */   // Label 12242: @787823
     /*  787823 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(787898), // Rule ID 19272 //
     /*  787828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787896 */     GIR_RootConstrainSelectedInstOperands,
     /*  787897 */     // GIR_Coverage, 19272,
     /*  787897 */     GIR_EraseRootFromParent_Done,
     /*  787898 */   // Label 12243: @787898
     /*  787898 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(787973), // Rule ID 19273 //
     /*  787903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787971 */     GIR_RootConstrainSelectedInstOperands,
     /*  787972 */     // GIR_Coverage, 19273,
     /*  787972 */     GIR_EraseRootFromParent_Done,
     /*  787973 */   // Label 12244: @787973
     /*  787973 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(788048), // Rule ID 19276 //
     /*  787978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  788027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788046 */     GIR_RootConstrainSelectedInstOperands,
     /*  788047 */     // GIR_Coverage, 19276,
     /*  788047 */     GIR_EraseRootFromParent_Done,
     /*  788048 */   // Label 12245: @788048
     /*  788048 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(788123), // Rule ID 19277 //
     /*  788053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  788064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  788067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  788070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  788102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788121 */     GIR_RootConstrainSelectedInstOperands,
     /*  788122 */     // GIR_Coverage, 19277,
     /*  788122 */     GIR_EraseRootFromParent_Done,
     /*  788123 */   // Label 12246: @788123
     /*  788123 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(788198), // Rule ID 19280 //
     /*  788128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  788139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  788142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  788145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  788177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788196 */     GIR_RootConstrainSelectedInstOperands,
     /*  788197 */     // GIR_Coverage, 19280,
     /*  788197 */     GIR_EraseRootFromParent_Done,
     /*  788198 */   // Label 12247: @788198
     /*  788198 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(788273), // Rule ID 19281 //
     /*  788203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  788214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  788217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  788220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  788223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  788242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788249 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  788252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788271 */     GIR_RootConstrainSelectedInstOperands,
     /*  788272 */     // GIR_Coverage, 19281,
     /*  788272 */     GIR_EraseRootFromParent_Done,
     /*  788273 */   // Label 12248: @788273
     /*  788273 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(788348), // Rule ID 19284 //
     /*  788278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  788327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788346 */     GIR_RootConstrainSelectedInstOperands,
     /*  788347 */     // GIR_Coverage, 19284,
     /*  788347 */     GIR_EraseRootFromParent_Done,
     /*  788348 */   // Label 12249: @788348
     /*  788348 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(788423), // Rule ID 19285 //
     /*  788353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  788364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  788367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  788370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  788402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788421 */     GIR_RootConstrainSelectedInstOperands,
     /*  788422 */     // GIR_Coverage, 19285,
     /*  788422 */     GIR_EraseRootFromParent_Done,
     /*  788423 */   // Label 12250: @788423
     /*  788423 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(788498), // Rule ID 19288 //
     /*  788428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788496 */     GIR_RootConstrainSelectedInstOperands,
     /*  788497 */     // GIR_Coverage, 19288,
     /*  788497 */     GIR_EraseRootFromParent_Done,
     /*  788498 */   // Label 12251: @788498
     /*  788498 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(788573), // Rule ID 19289 //
     /*  788503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788571 */     GIR_RootConstrainSelectedInstOperands,
     /*  788572 */     // GIR_Coverage, 19289,
     /*  788572 */     GIR_EraseRootFromParent_Done,
     /*  788573 */   // Label 12252: @788573
     /*  788573 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(788648), // Rule ID 19292 //
     /*  788578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788646 */     GIR_RootConstrainSelectedInstOperands,
     /*  788647 */     // GIR_Coverage, 19292,
     /*  788647 */     GIR_EraseRootFromParent_Done,
     /*  788648 */   // Label 12253: @788648
     /*  788648 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(788723), // Rule ID 19293 //
     /*  788653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788721 */     GIR_RootConstrainSelectedInstOperands,
     /*  788722 */     // GIR_Coverage, 19293,
     /*  788722 */     GIR_EraseRootFromParent_Done,
     /*  788723 */   // Label 12254: @788723
     /*  788723 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(788798), // Rule ID 19296 //
     /*  788728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788796 */     GIR_RootConstrainSelectedInstOperands,
     /*  788797 */     // GIR_Coverage, 19296,
     /*  788797 */     GIR_EraseRootFromParent_Done,
     /*  788798 */   // Label 12255: @788798
     /*  788798 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(788873), // Rule ID 19297 //
     /*  788803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788849 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788871 */     GIR_RootConstrainSelectedInstOperands,
     /*  788872 */     // GIR_Coverage, 19297,
     /*  788872 */     GIR_EraseRootFromParent_Done,
     /*  788873 */   // Label 12256: @788873
     /*  788873 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(788948), // Rule ID 19300 //
     /*  788878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788924 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788946 */     GIR_RootConstrainSelectedInstOperands,
     /*  788947 */     // GIR_Coverage, 19300,
     /*  788947 */     GIR_EraseRootFromParent_Done,
     /*  788948 */   // Label 12257: @788948
     /*  788948 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(789023), // Rule ID 19301 //
     /*  788953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  789002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789021 */     GIR_RootConstrainSelectedInstOperands,
     /*  789022 */     // GIR_Coverage, 19301,
     /*  789022 */     GIR_EraseRootFromParent_Done,
     /*  789023 */   // Label 12258: @789023
     /*  789023 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(789098), // Rule ID 19304 //
     /*  789028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  789039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  789042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  789045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  789048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  789077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789096 */     GIR_RootConstrainSelectedInstOperands,
     /*  789097 */     // GIR_Coverage, 19304,
     /*  789097 */     GIR_EraseRootFromParent_Done,
     /*  789098 */   // Label 12259: @789098
     /*  789098 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(789173), // Rule ID 19305 //
     /*  789103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  789114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  789117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  789120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  789123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  789152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789171 */     GIR_RootConstrainSelectedInstOperands,
     /*  789172 */     // GIR_Coverage, 19305,
     /*  789172 */     GIR_EraseRootFromParent_Done,
     /*  789173 */   // Label 12260: @789173
     /*  789173 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(789248), // Rule ID 19308 //
     /*  789178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  789189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  789192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  789195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  789198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  789227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789246 */     GIR_RootConstrainSelectedInstOperands,
     /*  789247 */     // GIR_Coverage, 19308,
     /*  789247 */     GIR_EraseRootFromParent_Done,
     /*  789248 */   // Label 12261: @789248
     /*  789248 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(789323), // Rule ID 19309 //
     /*  789253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  789264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  789267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  789270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  789273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  789302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789321 */     GIR_RootConstrainSelectedInstOperands,
     /*  789322 */     // GIR_Coverage, 19309,
     /*  789322 */     GIR_EraseRootFromParent_Done,
     /*  789323 */   // Label 12262: @789323
     /*  789323 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(789398), // Rule ID 19312 //
     /*  789328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  789339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  789342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  789345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  789348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  789377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789396 */     GIR_RootConstrainSelectedInstOperands,
     /*  789397 */     // GIR_Coverage, 19312,
     /*  789397 */     GIR_EraseRootFromParent_Done,
     /*  789398 */   // Label 12263: @789398
     /*  789398 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(789473), // Rule ID 19313 //
     /*  789403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  789414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  789417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  789420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  789423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  789452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789471 */     GIR_RootConstrainSelectedInstOperands,
     /*  789472 */     // GIR_Coverage, 19313,
     /*  789472 */     GIR_EraseRootFromParent_Done,
     /*  789473 */   // Label 12264: @789473
     /*  789473 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(789548), // Rule ID 19316 //
     /*  789478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789546 */     GIR_RootConstrainSelectedInstOperands,
     /*  789547 */     // GIR_Coverage, 19316,
     /*  789547 */     GIR_EraseRootFromParent_Done,
     /*  789548 */   // Label 12265: @789548
     /*  789548 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(789623), // Rule ID 19317 //
     /*  789553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789621 */     GIR_RootConstrainSelectedInstOperands,
     /*  789622 */     // GIR_Coverage, 19317,
     /*  789622 */     GIR_EraseRootFromParent_Done,
     /*  789623 */   // Label 12266: @789623
     /*  789623 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(789698), // Rule ID 19320 //
     /*  789628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789696 */     GIR_RootConstrainSelectedInstOperands,
     /*  789697 */     // GIR_Coverage, 19320,
     /*  789697 */     GIR_EraseRootFromParent_Done,
     /*  789698 */   // Label 12267: @789698
     /*  789698 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(789773), // Rule ID 19321 //
     /*  789703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789771 */     GIR_RootConstrainSelectedInstOperands,
     /*  789772 */     // GIR_Coverage, 19321,
     /*  789772 */     GIR_EraseRootFromParent_Done,
     /*  789773 */   // Label 12268: @789773
     /*  789773 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(789848), // Rule ID 19324 //
     /*  789778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789846 */     GIR_RootConstrainSelectedInstOperands,
     /*  789847 */     // GIR_Coverage, 19324,
     /*  789847 */     GIR_EraseRootFromParent_Done,
     /*  789848 */   // Label 12269: @789848
     /*  789848 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(789923), // Rule ID 19325 //
     /*  789853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789921 */     GIR_RootConstrainSelectedInstOperands,
     /*  789922 */     // GIR_Coverage, 19325,
     /*  789922 */     GIR_EraseRootFromParent_Done,
     /*  789923 */   // Label 12270: @789923
     /*  789923 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(789998), // Rule ID 19328 //
     /*  789928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789996 */     GIR_RootConstrainSelectedInstOperands,
     /*  789997 */     // GIR_Coverage, 19328,
     /*  789997 */     GIR_EraseRootFromParent_Done,
     /*  789998 */   // Label 12271: @789998
     /*  789998 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(790073), // Rule ID 19329 //
     /*  790003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  790014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  790017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  790020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  790023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790049 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  790052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790071 */     GIR_RootConstrainSelectedInstOperands,
     /*  790072 */     // GIR_Coverage, 19329,
     /*  790072 */     GIR_EraseRootFromParent_Done,
     /*  790073 */   // Label 12272: @790073
     /*  790073 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(790148), // Rule ID 19332 //
     /*  790078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  790089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  790092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  790095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  790098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  790127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790146 */     GIR_RootConstrainSelectedInstOperands,
     /*  790147 */     // GIR_Coverage, 19332,
     /*  790147 */     GIR_EraseRootFromParent_Done,
     /*  790148 */   // Label 12273: @790148
     /*  790148 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(790223), // Rule ID 19333 //
     /*  790153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  790164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  790167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  790170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  790173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790199 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  790202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790221 */     GIR_RootConstrainSelectedInstOperands,
     /*  790222 */     // GIR_Coverage, 19333,
     /*  790222 */     GIR_EraseRootFromParent_Done,
     /*  790223 */   // Label 12274: @790223
     /*  790223 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(790298), // Rule ID 19336 //
     /*  790228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  790239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  790242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  790245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  790248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  790277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790296 */     GIR_RootConstrainSelectedInstOperands,
     /*  790297 */     // GIR_Coverage, 19336,
     /*  790297 */     GIR_EraseRootFromParent_Done,
     /*  790298 */   // Label 12275: @790298
     /*  790298 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(790373), // Rule ID 19337 //
     /*  790303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  790314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  790317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  790320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  790323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  790352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790371 */     GIR_RootConstrainSelectedInstOperands,
     /*  790372 */     // GIR_Coverage, 19337,
     /*  790372 */     GIR_EraseRootFromParent_Done,
     /*  790373 */   // Label 12276: @790373
     /*  790373 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(790448), // Rule ID 19340 //
     /*  790378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  790389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790446 */     GIR_RootConstrainSelectedInstOperands,
     /*  790447 */     // GIR_Coverage, 19340,
     /*  790447 */     GIR_EraseRootFromParent_Done,
     /*  790448 */   // Label 12277: @790448
     /*  790448 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(790523), // Rule ID 19341 //
     /*  790453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  790464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790499 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790521 */     GIR_RootConstrainSelectedInstOperands,
     /*  790522 */     // GIR_Coverage, 19341,
     /*  790522 */     GIR_EraseRootFromParent_Done,
     /*  790523 */   // Label 12278: @790523
     /*  790523 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(790598), // Rule ID 19344 //
     /*  790528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790596 */     GIR_RootConstrainSelectedInstOperands,
     /*  790597 */     // GIR_Coverage, 19344,
     /*  790597 */     GIR_EraseRootFromParent_Done,
     /*  790598 */   // Label 12279: @790598
     /*  790598 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(790673), // Rule ID 19345 //
     /*  790603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790649 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790671 */     GIR_RootConstrainSelectedInstOperands,
     /*  790672 */     // GIR_Coverage, 19345,
     /*  790672 */     GIR_EraseRootFromParent_Done,
     /*  790673 */   // Label 12280: @790673
     /*  790673 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(790748), // Rule ID 19348 //
     /*  790678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790746 */     GIR_RootConstrainSelectedInstOperands,
     /*  790747 */     // GIR_Coverage, 19348,
     /*  790747 */     GIR_EraseRootFromParent_Done,
     /*  790748 */   // Label 12281: @790748
     /*  790748 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(790823), // Rule ID 19349 //
     /*  790753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790799 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790821 */     GIR_RootConstrainSelectedInstOperands,
     /*  790822 */     // GIR_Coverage, 19349,
     /*  790822 */     GIR_EraseRootFromParent_Done,
     /*  790823 */   // Label 12282: @790823
     /*  790823 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(790898), // Rule ID 19352 //
     /*  790828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790874 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790896 */     GIR_RootConstrainSelectedInstOperands,
     /*  790897 */     // GIR_Coverage, 19352,
     /*  790897 */     GIR_EraseRootFromParent_Done,
     /*  790898 */   // Label 12283: @790898
     /*  790898 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(790973), // Rule ID 19353 //
     /*  790903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790971 */     GIR_RootConstrainSelectedInstOperands,
     /*  790972 */     // GIR_Coverage, 19353,
     /*  790972 */     GIR_EraseRootFromParent_Done,
     /*  790973 */   // Label 12284: @790973
     /*  790973 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(791048), // Rule ID 19356 //
     /*  790978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791024 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  791027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791046 */     GIR_RootConstrainSelectedInstOperands,
     /*  791047 */     // GIR_Coverage, 19356,
     /*  791047 */     GIR_EraseRootFromParent_Done,
     /*  791048 */   // Label 12285: @791048
     /*  791048 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(791123), // Rule ID 19357 //
     /*  791053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  791064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  791067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  791070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791099 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  791102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791121 */     GIR_RootConstrainSelectedInstOperands,
     /*  791122 */     // GIR_Coverage, 19357,
     /*  791122 */     GIR_EraseRootFromParent_Done,
     /*  791123 */   // Label 12286: @791123
     /*  791123 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(791198), // Rule ID 19360 //
     /*  791128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  791177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791196 */     GIR_RootConstrainSelectedInstOperands,
     /*  791197 */     // GIR_Coverage, 19360,
     /*  791197 */     GIR_EraseRootFromParent_Done,
     /*  791198 */   // Label 12287: @791198
     /*  791198 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(791273), // Rule ID 19361 //
     /*  791203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  791214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  791217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  791220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791249 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  791252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791271 */     GIR_RootConstrainSelectedInstOperands,
     /*  791272 */     // GIR_Coverage, 19361,
     /*  791272 */     GIR_EraseRootFromParent_Done,
     /*  791273 */   // Label 12288: @791273
     /*  791273 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(791348), // Rule ID 19364 //
     /*  791278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  791327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791346 */     GIR_RootConstrainSelectedInstOperands,
     /*  791347 */     // GIR_Coverage, 19364,
     /*  791347 */     GIR_EraseRootFromParent_Done,
     /*  791348 */   // Label 12289: @791348
     /*  791348 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(791423), // Rule ID 19365 //
     /*  791353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  791364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  791367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  791370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791399 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  791402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791421 */     GIR_RootConstrainSelectedInstOperands,
     /*  791422 */     // GIR_Coverage, 19365,
     /*  791422 */     GIR_EraseRootFromParent_Done,
     /*  791423 */   // Label 12290: @791423
     /*  791423 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(791498), // Rule ID 19368 //
     /*  791428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791474 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791496 */     GIR_RootConstrainSelectedInstOperands,
     /*  791497 */     // GIR_Coverage, 19368,
     /*  791497 */     GIR_EraseRootFromParent_Done,
     /*  791498 */   // Label 12291: @791498
     /*  791498 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(791573), // Rule ID 19369 //
     /*  791503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791571 */     GIR_RootConstrainSelectedInstOperands,
     /*  791572 */     // GIR_Coverage, 19369,
     /*  791572 */     GIR_EraseRootFromParent_Done,
     /*  791573 */   // Label 12292: @791573
     /*  791573 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(791648), // Rule ID 19372 //
     /*  791578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791646 */     GIR_RootConstrainSelectedInstOperands,
     /*  791647 */     // GIR_Coverage, 19372,
     /*  791647 */     GIR_EraseRootFromParent_Done,
     /*  791648 */   // Label 12293: @791648
     /*  791648 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(791723), // Rule ID 19373 //
     /*  791653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791721 */     GIR_RootConstrainSelectedInstOperands,
     /*  791722 */     // GIR_Coverage, 19373,
     /*  791722 */     GIR_EraseRootFromParent_Done,
     /*  791723 */   // Label 12294: @791723
     /*  791723 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(791798), // Rule ID 19376 //
     /*  791728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791796 */     GIR_RootConstrainSelectedInstOperands,
     /*  791797 */     // GIR_Coverage, 19376,
     /*  791797 */     GIR_EraseRootFromParent_Done,
     /*  791798 */   // Label 12295: @791798
     /*  791798 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(791873), // Rule ID 19377 //
     /*  791803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791871 */     GIR_RootConstrainSelectedInstOperands,
     /*  791872 */     // GIR_Coverage, 19377,
     /*  791872 */     GIR_EraseRootFromParent_Done,
     /*  791873 */   // Label 12296: @791873
     /*  791873 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(791948), // Rule ID 19380 //
     /*  791878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791924 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791946 */     GIR_RootConstrainSelectedInstOperands,
     /*  791947 */     // GIR_Coverage, 19380,
     /*  791947 */     GIR_EraseRootFromParent_Done,
     /*  791948 */   // Label 12297: @791948
     /*  791948 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(792023), // Rule ID 19381 //
     /*  791953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791999 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  792002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792021 */     GIR_RootConstrainSelectedInstOperands,
     /*  792022 */     // GIR_Coverage, 19381,
     /*  792022 */     GIR_EraseRootFromParent_Done,
     /*  792023 */   // Label 12298: @792023
     /*  792023 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(792098), // Rule ID 19384 //
     /*  792028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  792039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  792042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  792045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792074 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  792077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792096 */     GIR_RootConstrainSelectedInstOperands,
     /*  792097 */     // GIR_Coverage, 19384,
     /*  792097 */     GIR_EraseRootFromParent_Done,
     /*  792098 */   // Label 12299: @792098
     /*  792098 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(792173), // Rule ID 19385 //
     /*  792103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  792114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  792117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  792120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792149 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  792152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792171 */     GIR_RootConstrainSelectedInstOperands,
     /*  792172 */     // GIR_Coverage, 19385,
     /*  792172 */     GIR_EraseRootFromParent_Done,
     /*  792173 */   // Label 12300: @792173
     /*  792173 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(792248), // Rule ID 19388 //
     /*  792178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  792189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  792192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  792195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  792227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792246 */     GIR_RootConstrainSelectedInstOperands,
     /*  792247 */     // GIR_Coverage, 19388,
     /*  792247 */     GIR_EraseRootFromParent_Done,
     /*  792248 */   // Label 12301: @792248
     /*  792248 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(792323), // Rule ID 19389 //
     /*  792253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  792264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  792267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  792270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  792273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  792292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792299 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  792302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792321 */     GIR_RootConstrainSelectedInstOperands,
     /*  792322 */     // GIR_Coverage, 19389,
     /*  792322 */     GIR_EraseRootFromParent_Done,
     /*  792323 */   // Label 12302: @792323
     /*  792323 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(792398), // Rule ID 19392 //
     /*  792328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  792339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  792342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  792345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  792377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792396 */     GIR_RootConstrainSelectedInstOperands,
     /*  792397 */     // GIR_Coverage, 19392,
     /*  792397 */     GIR_EraseRootFromParent_Done,
     /*  792398 */   // Label 12303: @792398
     /*  792398 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(792473), // Rule ID 19393 //
     /*  792403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  792414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  792417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  792420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  792452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792471 */     GIR_RootConstrainSelectedInstOperands,
     /*  792472 */     // GIR_Coverage, 19393,
     /*  792472 */     GIR_EraseRootFromParent_Done,
     /*  792473 */   // Label 12304: @792473
     /*  792473 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(792548), // Rule ID 19396 //
     /*  792478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792524 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792546 */     GIR_RootConstrainSelectedInstOperands,
     /*  792547 */     // GIR_Coverage, 19396,
     /*  792547 */     GIR_EraseRootFromParent_Done,
     /*  792548 */   // Label 12305: @792548
     /*  792548 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(792623), // Rule ID 19397 //
     /*  792553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792599 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792621 */     GIR_RootConstrainSelectedInstOperands,
     /*  792622 */     // GIR_Coverage, 19397,
     /*  792622 */     GIR_EraseRootFromParent_Done,
     /*  792623 */   // Label 12306: @792623
     /*  792623 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(792698), // Rule ID 19400 //
     /*  792628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792674 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792696 */     GIR_RootConstrainSelectedInstOperands,
     /*  792697 */     // GIR_Coverage, 19400,
     /*  792697 */     GIR_EraseRootFromParent_Done,
     /*  792698 */   // Label 12307: @792698
     /*  792698 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(792773), // Rule ID 19401 //
     /*  792703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792749 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792771 */     GIR_RootConstrainSelectedInstOperands,
     /*  792772 */     // GIR_Coverage, 19401,
     /*  792772 */     GIR_EraseRootFromParent_Done,
     /*  792773 */   // Label 12308: @792773
     /*  792773 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(792848), // Rule ID 19404 //
     /*  792778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792846 */     GIR_RootConstrainSelectedInstOperands,
     /*  792847 */     // GIR_Coverage, 19404,
     /*  792847 */     GIR_EraseRootFromParent_Done,
     /*  792848 */   // Label 12309: @792848
     /*  792848 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(792923), // Rule ID 19405 //
     /*  792853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792921 */     GIR_RootConstrainSelectedInstOperands,
     /*  792922 */     // GIR_Coverage, 19405,
     /*  792922 */     GIR_EraseRootFromParent_Done,
     /*  792923 */   // Label 12310: @792923
     /*  792923 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(792998), // Rule ID 19408 //
     /*  792928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792996 */     GIR_RootConstrainSelectedInstOperands,
     /*  792997 */     // GIR_Coverage, 19408,
     /*  792997 */     GIR_EraseRootFromParent_Done,
     /*  792998 */   // Label 12311: @792998
     /*  792998 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(793073), // Rule ID 19409 //
     /*  793003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  793014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  793017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  793020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793049 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  793052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793071 */     GIR_RootConstrainSelectedInstOperands,
     /*  793072 */     // GIR_Coverage, 19409,
     /*  793072 */     GIR_EraseRootFromParent_Done,
     /*  793073 */   // Label 12312: @793073
     /*  793073 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(793148), // Rule ID 19412 //
     /*  793078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  793089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  793092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  793095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  793127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793146 */     GIR_RootConstrainSelectedInstOperands,
     /*  793147 */     // GIR_Coverage, 19412,
     /*  793147 */     GIR_EraseRootFromParent_Done,
     /*  793148 */   // Label 12313: @793148
     /*  793148 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(793223), // Rule ID 19413 //
     /*  793153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  793164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  793167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  793170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  793173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  793192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793199 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  793202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793221 */     GIR_RootConstrainSelectedInstOperands,
     /*  793222 */     // GIR_Coverage, 19413,
     /*  793222 */     GIR_EraseRootFromParent_Done,
     /*  793223 */   // Label 12314: @793223
     /*  793223 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(793298), // Rule ID 19416 //
     /*  793228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  793239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  793242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  793245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  793248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793274 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  793277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793296 */     GIR_RootConstrainSelectedInstOperands,
     /*  793297 */     // GIR_Coverage, 19416,
     /*  793297 */     GIR_EraseRootFromParent_Done,
     /*  793298 */   // Label 12315: @793298
     /*  793298 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(793373), // Rule ID 19417 //
     /*  793303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  793314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  793317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  793320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  793323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793349 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  793352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793371 */     GIR_RootConstrainSelectedInstOperands,
     /*  793372 */     // GIR_Coverage, 19417,
     /*  793372 */     GIR_EraseRootFromParent_Done,
     /*  793373 */   // Label 12316: @793373
     /*  793373 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(793448), // Rule ID 19420 //
     /*  793378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  793389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793446 */     GIR_RootConstrainSelectedInstOperands,
     /*  793447 */     // GIR_Coverage, 19420,
     /*  793447 */     GIR_EraseRootFromParent_Done,
     /*  793448 */   // Label 12317: @793448
     /*  793448 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(793523), // Rule ID 19421 //
     /*  793453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  793464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793499 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793521 */     GIR_RootConstrainSelectedInstOperands,
     /*  793522 */     // GIR_Coverage, 19421,
     /*  793522 */     GIR_EraseRootFromParent_Done,
     /*  793523 */   // Label 12318: @793523
     /*  793523 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(793598), // Rule ID 19424 //
     /*  793528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793596 */     GIR_RootConstrainSelectedInstOperands,
     /*  793597 */     // GIR_Coverage, 19424,
     /*  793597 */     GIR_EraseRootFromParent_Done,
     /*  793598 */   // Label 12319: @793598
     /*  793598 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(793673), // Rule ID 19425 //
     /*  793603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793649 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793671 */     GIR_RootConstrainSelectedInstOperands,
     /*  793672 */     // GIR_Coverage, 19425,
     /*  793672 */     GIR_EraseRootFromParent_Done,
     /*  793673 */   // Label 12320: @793673
     /*  793673 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(793748), // Rule ID 19428 //
     /*  793678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793746 */     GIR_RootConstrainSelectedInstOperands,
     /*  793747 */     // GIR_Coverage, 19428,
     /*  793747 */     GIR_EraseRootFromParent_Done,
     /*  793748 */   // Label 12321: @793748
     /*  793748 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(793823), // Rule ID 19429 //
     /*  793753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793821 */     GIR_RootConstrainSelectedInstOperands,
     /*  793822 */     // GIR_Coverage, 19429,
     /*  793822 */     GIR_EraseRootFromParent_Done,
     /*  793823 */   // Label 12322: @793823
     /*  793823 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(793898), // Rule ID 19432 //
     /*  793828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793896 */     GIR_RootConstrainSelectedInstOperands,
     /*  793897 */     // GIR_Coverage, 19432,
     /*  793897 */     GIR_EraseRootFromParent_Done,
     /*  793898 */   // Label 12323: @793898
     /*  793898 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(793973), // Rule ID 19433 //
     /*  793903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793949 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793971 */     GIR_RootConstrainSelectedInstOperands,
     /*  793972 */     // GIR_Coverage, 19433,
     /*  793972 */     GIR_EraseRootFromParent_Done,
     /*  793973 */   // Label 12324: @793973
     /*  793973 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(794048), // Rule ID 19436 //
     /*  793978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  794027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794046 */     GIR_RootConstrainSelectedInstOperands,
     /*  794047 */     // GIR_Coverage, 19436,
     /*  794047 */     GIR_EraseRootFromParent_Done,
     /*  794048 */   // Label 12325: @794048
     /*  794048 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(794123), // Rule ID 19437 //
     /*  794053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  794064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  794067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  794070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  794073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  794102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794121 */     GIR_RootConstrainSelectedInstOperands,
     /*  794122 */     // GIR_Coverage, 19437,
     /*  794122 */     GIR_EraseRootFromParent_Done,
     /*  794123 */   // Label 12326: @794123
     /*  794123 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(794198), // Rule ID 19440 //
     /*  794128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  794139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  794142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  794145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  794148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  794177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794196 */     GIR_RootConstrainSelectedInstOperands,
     /*  794197 */     // GIR_Coverage, 19440,
     /*  794197 */     GIR_EraseRootFromParent_Done,
     /*  794198 */   // Label 12327: @794198
     /*  794198 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(794273), // Rule ID 19441 //
     /*  794203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  794214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  794217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  794220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  794223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  794252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794271 */     GIR_RootConstrainSelectedInstOperands,
     /*  794272 */     // GIR_Coverage, 19441,
     /*  794272 */     GIR_EraseRootFromParent_Done,
     /*  794273 */   // Label 12328: @794273
     /*  794273 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(794348), // Rule ID 19444 //
     /*  794278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  794289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  794292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  794295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  794298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  794327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794346 */     GIR_RootConstrainSelectedInstOperands,
     /*  794347 */     // GIR_Coverage, 19444,
     /*  794347 */     GIR_EraseRootFromParent_Done,
     /*  794348 */   // Label 12329: @794348
     /*  794348 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(794423), // Rule ID 19445 //
     /*  794353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  794364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  794367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  794370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  794373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794399 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  794402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794421 */     GIR_RootConstrainSelectedInstOperands,
     /*  794422 */     // GIR_Coverage, 19445,
     /*  794422 */     GIR_EraseRootFromParent_Done,
     /*  794423 */   // Label 12330: @794423
     /*  794423 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(794498), // Rule ID 19448 //
     /*  794428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794474 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794496 */     GIR_RootConstrainSelectedInstOperands,
     /*  794497 */     // GIR_Coverage, 19448,
     /*  794497 */     GIR_EraseRootFromParent_Done,
     /*  794498 */   // Label 12331: @794498
     /*  794498 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(794573), // Rule ID 19449 //
     /*  794503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794549 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794571 */     GIR_RootConstrainSelectedInstOperands,
     /*  794572 */     // GIR_Coverage, 19449,
     /*  794572 */     GIR_EraseRootFromParent_Done,
     /*  794573 */   // Label 12332: @794573
     /*  794573 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(794648), // Rule ID 19452 //
     /*  794578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794646 */     GIR_RootConstrainSelectedInstOperands,
     /*  794647 */     // GIR_Coverage, 19452,
     /*  794647 */     GIR_EraseRootFromParent_Done,
     /*  794648 */   // Label 12333: @794648
     /*  794648 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(794723), // Rule ID 19453 //
     /*  794653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794721 */     GIR_RootConstrainSelectedInstOperands,
     /*  794722 */     // GIR_Coverage, 19453,
     /*  794722 */     GIR_EraseRootFromParent_Done,
     /*  794723 */   // Label 12334: @794723
     /*  794723 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(794798), // Rule ID 19456 //
     /*  794728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794796 */     GIR_RootConstrainSelectedInstOperands,
     /*  794797 */     // GIR_Coverage, 19456,
     /*  794797 */     GIR_EraseRootFromParent_Done,
     /*  794798 */   // Label 12335: @794798
     /*  794798 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(794873), // Rule ID 19457 //
     /*  794803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794849 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794871 */     GIR_RootConstrainSelectedInstOperands,
     /*  794872 */     // GIR_Coverage, 19457,
     /*  794872 */     GIR_EraseRootFromParent_Done,
     /*  794873 */   // Label 12336: @794873
     /*  794873 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(794948), // Rule ID 19460 //
     /*  794878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794946 */     GIR_RootConstrainSelectedInstOperands,
     /*  794947 */     // GIR_Coverage, 19460,
     /*  794947 */     GIR_EraseRootFromParent_Done,
     /*  794948 */   // Label 12337: @794948
     /*  794948 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(795023), // Rule ID 19461 //
     /*  794953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794999 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  795002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795021 */     GIR_RootConstrainSelectedInstOperands,
     /*  795022 */     // GIR_Coverage, 19461,
     /*  795022 */     GIR_EraseRootFromParent_Done,
     /*  795023 */   // Label 12338: @795023
     /*  795023 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(795098), // Rule ID 19464 //
     /*  795028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  795039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  795042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  795045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  795048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  795077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795096 */     GIR_RootConstrainSelectedInstOperands,
     /*  795097 */     // GIR_Coverage, 19464,
     /*  795097 */     GIR_EraseRootFromParent_Done,
     /*  795098 */   // Label 12339: @795098
     /*  795098 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(795173), // Rule ID 19465 //
     /*  795103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  795114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  795117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  795120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  795123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  795152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795171 */     GIR_RootConstrainSelectedInstOperands,
     /*  795172 */     // GIR_Coverage, 19465,
     /*  795172 */     GIR_EraseRootFromParent_Done,
     /*  795173 */   // Label 12340: @795173
     /*  795173 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(795248), // Rule ID 19468 //
     /*  795178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  795189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  795192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  795195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  795198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  795227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795246 */     GIR_RootConstrainSelectedInstOperands,
     /*  795247 */     // GIR_Coverage, 19468,
     /*  795247 */     GIR_EraseRootFromParent_Done,
     /*  795248 */   // Label 12341: @795248
     /*  795248 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(795323), // Rule ID 19469 //
     /*  795253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  795264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  795267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  795270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  795273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  795302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795321 */     GIR_RootConstrainSelectedInstOperands,
     /*  795322 */     // GIR_Coverage, 19469,
     /*  795322 */     GIR_EraseRootFromParent_Done,
     /*  795323 */   // Label 12342: @795323
     /*  795323 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(795398), // Rule ID 19472 //
     /*  795328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  795339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  795342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  795345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  795348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  795377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795396 */     GIR_RootConstrainSelectedInstOperands,
     /*  795397 */     // GIR_Coverage, 19472,
     /*  795397 */     GIR_EraseRootFromParent_Done,
     /*  795398 */   // Label 12343: @795398
     /*  795398 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(795473), // Rule ID 19473 //
     /*  795403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  795414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  795417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  795420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  795423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795449 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  795452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795471 */     GIR_RootConstrainSelectedInstOperands,
     /*  795472 */     // GIR_Coverage, 19473,
     /*  795472 */     GIR_EraseRootFromParent_Done,
     /*  795473 */   // Label 12344: @795473
     /*  795473 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(795548), // Rule ID 19476 //
     /*  795478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795546 */     GIR_RootConstrainSelectedInstOperands,
     /*  795547 */     // GIR_Coverage, 19476,
     /*  795547 */     GIR_EraseRootFromParent_Done,
     /*  795548 */   // Label 12345: @795548
     /*  795548 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(795623), // Rule ID 19477 //
     /*  795553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795599 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795621 */     GIR_RootConstrainSelectedInstOperands,
     /*  795622 */     // GIR_Coverage, 19477,
     /*  795622 */     GIR_EraseRootFromParent_Done,
     /*  795623 */   // Label 12346: @795623
     /*  795623 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(795698), // Rule ID 19480 //
     /*  795628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795696 */     GIR_RootConstrainSelectedInstOperands,
     /*  795697 */     // GIR_Coverage, 19480,
     /*  795697 */     GIR_EraseRootFromParent_Done,
     /*  795698 */   // Label 12347: @795698
     /*  795698 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(795773), // Rule ID 19481 //
     /*  795703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795749 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795771 */     GIR_RootConstrainSelectedInstOperands,
     /*  795772 */     // GIR_Coverage, 19481,
     /*  795772 */     GIR_EraseRootFromParent_Done,
     /*  795773 */   // Label 12348: @795773
     /*  795773 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(795848), // Rule ID 19484 //
     /*  795778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795846 */     GIR_RootConstrainSelectedInstOperands,
     /*  795847 */     // GIR_Coverage, 19484,
     /*  795847 */     GIR_EraseRootFromParent_Done,
     /*  795848 */   // Label 12349: @795848
     /*  795848 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(795923), // Rule ID 19485 //
     /*  795853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795921 */     GIR_RootConstrainSelectedInstOperands,
     /*  795922 */     // GIR_Coverage, 19485,
     /*  795922 */     GIR_EraseRootFromParent_Done,
     /*  795923 */   // Label 12350: @795923
     /*  795923 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(795998), // Rule ID 19488 //
     /*  795928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795996 */     GIR_RootConstrainSelectedInstOperands,
     /*  795997 */     // GIR_Coverage, 19488,
     /*  795997 */     GIR_EraseRootFromParent_Done,
     /*  795998 */   // Label 12351: @795998
     /*  795998 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(796073), // Rule ID 19489 //
     /*  796003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  796014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  796017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  796020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796049 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  796052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796071 */     GIR_RootConstrainSelectedInstOperands,
     /*  796072 */     // GIR_Coverage, 19489,
     /*  796072 */     GIR_EraseRootFromParent_Done,
     /*  796073 */   // Label 12352: @796073
     /*  796073 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(796148), // Rule ID 19492 //
     /*  796078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  796089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  796092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  796095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  796127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796146 */     GIR_RootConstrainSelectedInstOperands,
     /*  796147 */     // GIR_Coverage, 19492,
     /*  796147 */     GIR_EraseRootFromParent_Done,
     /*  796148 */   // Label 12353: @796148
     /*  796148 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(796223), // Rule ID 19493 //
     /*  796153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  796164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  796167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  796170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796199 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  796202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796221 */     GIR_RootConstrainSelectedInstOperands,
     /*  796222 */     // GIR_Coverage, 19493,
     /*  796222 */     GIR_EraseRootFromParent_Done,
     /*  796223 */   // Label 12354: @796223
     /*  796223 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(796298), // Rule ID 19496 //
     /*  796228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  796239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  796242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  796245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  796277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796296 */     GIR_RootConstrainSelectedInstOperands,
     /*  796297 */     // GIR_Coverage, 19496,
     /*  796297 */     GIR_EraseRootFromParent_Done,
     /*  796298 */   // Label 12355: @796298
     /*  796298 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(796373), // Rule ID 19497 //
     /*  796303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  796314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  796317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  796320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796349 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  796352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796371 */     GIR_RootConstrainSelectedInstOperands,
     /*  796372 */     // GIR_Coverage, 19497,
     /*  796372 */     GIR_EraseRootFromParent_Done,
     /*  796373 */   // Label 12356: @796373
     /*  796373 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(796448), // Rule ID 19500 //
     /*  796378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796446 */     GIR_RootConstrainSelectedInstOperands,
     /*  796447 */     // GIR_Coverage, 19500,
     /*  796447 */     GIR_EraseRootFromParent_Done,
     /*  796448 */   // Label 12357: @796448
     /*  796448 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(796523), // Rule ID 19501 //
     /*  796453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  796464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796521 */     GIR_RootConstrainSelectedInstOperands,
     /*  796522 */     // GIR_Coverage, 19501,
     /*  796522 */     GIR_EraseRootFromParent_Done,
     /*  796523 */   // Label 12358: @796523
     /*  796523 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(796598), // Rule ID 19504 //
     /*  796528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796596 */     GIR_RootConstrainSelectedInstOperands,
     /*  796597 */     // GIR_Coverage, 19504,
     /*  796597 */     GIR_EraseRootFromParent_Done,
     /*  796598 */   // Label 12359: @796598
     /*  796598 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(796673), // Rule ID 19505 //
     /*  796603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796649 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796671 */     GIR_RootConstrainSelectedInstOperands,
     /*  796672 */     // GIR_Coverage, 19505,
     /*  796672 */     GIR_EraseRootFromParent_Done,
     /*  796673 */   // Label 12360: @796673
     /*  796673 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(796748), // Rule ID 19508 //
     /*  796678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796724 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796746 */     GIR_RootConstrainSelectedInstOperands,
     /*  796747 */     // GIR_Coverage, 19508,
     /*  796747 */     GIR_EraseRootFromParent_Done,
     /*  796748 */   // Label 12361: @796748
     /*  796748 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(796823), // Rule ID 19509 //
     /*  796753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796799 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796821 */     GIR_RootConstrainSelectedInstOperands,
     /*  796822 */     // GIR_Coverage, 19509,
     /*  796822 */     GIR_EraseRootFromParent_Done,
     /*  796823 */   // Label 12362: @796823
     /*  796823 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(796898), // Rule ID 19512 //
     /*  796828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796896 */     GIR_RootConstrainSelectedInstOperands,
     /*  796897 */     // GIR_Coverage, 19512,
     /*  796897 */     GIR_EraseRootFromParent_Done,
     /*  796898 */   // Label 12363: @796898
     /*  796898 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(796973), // Rule ID 19513 //
     /*  796903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796971 */     GIR_RootConstrainSelectedInstOperands,
     /*  796972 */     // GIR_Coverage, 19513,
     /*  796972 */     GIR_EraseRootFromParent_Done,
     /*  796973 */   // Label 12364: @796973
     /*  796973 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(797048), // Rule ID 19516 //
     /*  796978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  797027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797046 */     GIR_RootConstrainSelectedInstOperands,
     /*  797047 */     // GIR_Coverage, 19516,
     /*  797047 */     GIR_EraseRootFromParent_Done,
     /*  797048 */   // Label 12365: @797048
     /*  797048 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(797123), // Rule ID 19517 //
     /*  797053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  797064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  797067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  797070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  797102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797121 */     GIR_RootConstrainSelectedInstOperands,
     /*  797122 */     // GIR_Coverage, 19517,
     /*  797122 */     GIR_EraseRootFromParent_Done,
     /*  797123 */   // Label 12366: @797123
     /*  797123 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(797198), // Rule ID 19520 //
     /*  797128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  797139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  797142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  797145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  797177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797196 */     GIR_RootConstrainSelectedInstOperands,
     /*  797197 */     // GIR_Coverage, 19520,
     /*  797197 */     GIR_EraseRootFromParent_Done,
     /*  797198 */   // Label 12367: @797198
     /*  797198 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(797273), // Rule ID 19521 //
     /*  797203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  797214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  797217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  797220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  797223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  797242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797249 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  797252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797271 */     GIR_RootConstrainSelectedInstOperands,
     /*  797272 */     // GIR_Coverage, 19521,
     /*  797272 */     GIR_EraseRootFromParent_Done,
     /*  797273 */   // Label 12368: @797273
     /*  797273 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(797348), // Rule ID 19524 //
     /*  797278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  797327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797346 */     GIR_RootConstrainSelectedInstOperands,
     /*  797347 */     // GIR_Coverage, 19524,
     /*  797347 */     GIR_EraseRootFromParent_Done,
     /*  797348 */   // Label 12369: @797348
     /*  797348 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(797423), // Rule ID 19525 //
     /*  797353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  797364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  797367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  797370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  797402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797421 */     GIR_RootConstrainSelectedInstOperands,
     /*  797422 */     // GIR_Coverage, 19525,
     /*  797422 */     GIR_EraseRootFromParent_Done,
     /*  797423 */   // Label 12370: @797423
     /*  797423 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(797498), // Rule ID 19528 //
     /*  797428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797496 */     GIR_RootConstrainSelectedInstOperands,
     /*  797497 */     // GIR_Coverage, 19528,
     /*  797497 */     GIR_EraseRootFromParent_Done,
     /*  797498 */   // Label 12371: @797498
     /*  797498 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(797573), // Rule ID 19529 //
     /*  797503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797571 */     GIR_RootConstrainSelectedInstOperands,
     /*  797572 */     // GIR_Coverage, 19529,
     /*  797572 */     GIR_EraseRootFromParent_Done,
     /*  797573 */   // Label 12372: @797573
     /*  797573 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(797648), // Rule ID 19532 //
     /*  797578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797646 */     GIR_RootConstrainSelectedInstOperands,
     /*  797647 */     // GIR_Coverage, 19532,
     /*  797647 */     GIR_EraseRootFromParent_Done,
     /*  797648 */   // Label 12373: @797648
     /*  797648 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(797723), // Rule ID 19533 //
     /*  797653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797721 */     GIR_RootConstrainSelectedInstOperands,
     /*  797722 */     // GIR_Coverage, 19533,
     /*  797722 */     GIR_EraseRootFromParent_Done,
     /*  797723 */   // Label 12374: @797723
     /*  797723 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(797798), // Rule ID 19536 //
     /*  797728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797796 */     GIR_RootConstrainSelectedInstOperands,
     /*  797797 */     // GIR_Coverage, 19536,
     /*  797797 */     GIR_EraseRootFromParent_Done,
     /*  797798 */   // Label 12375: @797798
     /*  797798 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(797873), // Rule ID 19537 //
     /*  797803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797849 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797871 */     GIR_RootConstrainSelectedInstOperands,
     /*  797872 */     // GIR_Coverage, 19537,
     /*  797872 */     GIR_EraseRootFromParent_Done,
     /*  797873 */   // Label 12376: @797873
     /*  797873 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(797948), // Rule ID 19540 //
     /*  797878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797924 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797946 */     GIR_RootConstrainSelectedInstOperands,
     /*  797947 */     // GIR_Coverage, 19540,
     /*  797947 */     GIR_EraseRootFromParent_Done,
     /*  797948 */   // Label 12377: @797948
     /*  797948 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(798023), // Rule ID 19541 //
     /*  797953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  798002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798021 */     GIR_RootConstrainSelectedInstOperands,
     /*  798022 */     // GIR_Coverage, 19541,
     /*  798022 */     GIR_EraseRootFromParent_Done,
     /*  798023 */   // Label 12378: @798023
     /*  798023 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(798098), // Rule ID 19544 //
     /*  798028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  798077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798096 */     GIR_RootConstrainSelectedInstOperands,
     /*  798097 */     // GIR_Coverage, 19544,
     /*  798097 */     GIR_EraseRootFromParent_Done,
     /*  798098 */   // Label 12379: @798098
     /*  798098 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(798173), // Rule ID 19545 //
     /*  798103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  798114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  798117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  798120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  798123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  798152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798171 */     GIR_RootConstrainSelectedInstOperands,
     /*  798172 */     // GIR_Coverage, 19545,
     /*  798172 */     GIR_EraseRootFromParent_Done,
     /*  798173 */   // Label 12380: @798173
     /*  798173 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(798248), // Rule ID 19548 //
     /*  798178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  798227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798246 */     GIR_RootConstrainSelectedInstOperands,
     /*  798247 */     // GIR_Coverage, 19548,
     /*  798247 */     GIR_EraseRootFromParent_Done,
     /*  798248 */   // Label 12381: @798248
     /*  798248 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(798323), // Rule ID 19549 //
     /*  798253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  798264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  798267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  798270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  798273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  798302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798321 */     GIR_RootConstrainSelectedInstOperands,
     /*  798322 */     // GIR_Coverage, 19549,
     /*  798322 */     GIR_EraseRootFromParent_Done,
     /*  798323 */   // Label 12382: @798323
     /*  798323 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(798398), // Rule ID 19552 //
     /*  798328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  798377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798396 */     GIR_RootConstrainSelectedInstOperands,
     /*  798397 */     // GIR_Coverage, 19552,
     /*  798397 */     GIR_EraseRootFromParent_Done,
     /*  798398 */   // Label 12383: @798398
     /*  798398 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(798473), // Rule ID 19553 //
     /*  798403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  798414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  798417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  798420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  798423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  798452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798471 */     GIR_RootConstrainSelectedInstOperands,
     /*  798472 */     // GIR_Coverage, 19553,
     /*  798472 */     GIR_EraseRootFromParent_Done,
     /*  798473 */   // Label 12384: @798473
     /*  798473 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(798548), // Rule ID 19556 //
     /*  798478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798546 */     GIR_RootConstrainSelectedInstOperands,
     /*  798547 */     // GIR_Coverage, 19556,
     /*  798547 */     GIR_EraseRootFromParent_Done,
     /*  798548 */   // Label 12385: @798548
     /*  798548 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(798623), // Rule ID 19557 //
     /*  798553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798621 */     GIR_RootConstrainSelectedInstOperands,
     /*  798622 */     // GIR_Coverage, 19557,
     /*  798622 */     GIR_EraseRootFromParent_Done,
     /*  798623 */   // Label 12386: @798623
     /*  798623 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(798698), // Rule ID 19560 //
     /*  798628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798696 */     GIR_RootConstrainSelectedInstOperands,
     /*  798697 */     // GIR_Coverage, 19560,
     /*  798697 */     GIR_EraseRootFromParent_Done,
     /*  798698 */   // Label 12387: @798698
     /*  798698 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(798773), // Rule ID 19561 //
     /*  798703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798771 */     GIR_RootConstrainSelectedInstOperands,
     /*  798772 */     // GIR_Coverage, 19561,
     /*  798772 */     GIR_EraseRootFromParent_Done,
     /*  798773 */   // Label 12388: @798773
     /*  798773 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(798848), // Rule ID 19564 //
     /*  798778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798846 */     GIR_RootConstrainSelectedInstOperands,
     /*  798847 */     // GIR_Coverage, 19564,
     /*  798847 */     GIR_EraseRootFromParent_Done,
     /*  798848 */   // Label 12389: @798848
     /*  798848 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(798923), // Rule ID 19565 //
     /*  798853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798921 */     GIR_RootConstrainSelectedInstOperands,
     /*  798922 */     // GIR_Coverage, 19565,
     /*  798922 */     GIR_EraseRootFromParent_Done,
     /*  798923 */   // Label 12390: @798923
     /*  798923 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(798998), // Rule ID 19568 //
     /*  798928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798996 */     GIR_RootConstrainSelectedInstOperands,
     /*  798997 */     // GIR_Coverage, 19568,
     /*  798997 */     GIR_EraseRootFromParent_Done,
     /*  798998 */   // Label 12391: @798998
     /*  798998 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(799073), // Rule ID 19569 //
     /*  799003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  799014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  799017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  799020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  799023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799049 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  799052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799071 */     GIR_RootConstrainSelectedInstOperands,
     /*  799072 */     // GIR_Coverage, 19569,
     /*  799072 */     GIR_EraseRootFromParent_Done,
     /*  799073 */   // Label 12392: @799073
     /*  799073 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(799148), // Rule ID 19572 //
     /*  799078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  799127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799146 */     GIR_RootConstrainSelectedInstOperands,
     /*  799147 */     // GIR_Coverage, 19572,
     /*  799147 */     GIR_EraseRootFromParent_Done,
     /*  799148 */   // Label 12393: @799148
     /*  799148 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(799223), // Rule ID 19573 //
     /*  799153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  799164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  799167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  799170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  799173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799199 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  799202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799221 */     GIR_RootConstrainSelectedInstOperands,
     /*  799222 */     // GIR_Coverage, 19573,
     /*  799222 */     GIR_EraseRootFromParent_Done,
     /*  799223 */   // Label 12394: @799223
     /*  799223 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(799298), // Rule ID 19576 //
     /*  799228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  799239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  799242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  799245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  799248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  799277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799296 */     GIR_RootConstrainSelectedInstOperands,
     /*  799297 */     // GIR_Coverage, 19576,
     /*  799297 */     GIR_EraseRootFromParent_Done,
     /*  799298 */   // Label 12395: @799298
     /*  799298 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(799373), // Rule ID 19577 //
     /*  799303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  799314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  799317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  799320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  799323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  799352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799371 */     GIR_RootConstrainSelectedInstOperands,
     /*  799372 */     // GIR_Coverage, 19577,
     /*  799372 */     GIR_EraseRootFromParent_Done,
     /*  799373 */   // Label 12396: @799373
     /*  799373 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(799448), // Rule ID 19580 //
     /*  799378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  799389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799446 */     GIR_RootConstrainSelectedInstOperands,
     /*  799447 */     // GIR_Coverage, 19580,
     /*  799447 */     GIR_EraseRootFromParent_Done,
     /*  799448 */   // Label 12397: @799448
     /*  799448 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(799523), // Rule ID 19581 //
     /*  799453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  799464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799499 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799521 */     GIR_RootConstrainSelectedInstOperands,
     /*  799522 */     // GIR_Coverage, 19581,
     /*  799522 */     GIR_EraseRootFromParent_Done,
     /*  799523 */   // Label 12398: @799523
     /*  799523 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(799598), // Rule ID 19584 //
     /*  799528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799596 */     GIR_RootConstrainSelectedInstOperands,
     /*  799597 */     // GIR_Coverage, 19584,
     /*  799597 */     GIR_EraseRootFromParent_Done,
     /*  799598 */   // Label 12399: @799598
     /*  799598 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(799673), // Rule ID 19585 //
     /*  799603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799649 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799671 */     GIR_RootConstrainSelectedInstOperands,
     /*  799672 */     // GIR_Coverage, 19585,
     /*  799672 */     GIR_EraseRootFromParent_Done,
     /*  799673 */   // Label 12400: @799673
     /*  799673 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(799748), // Rule ID 19588 //
     /*  799678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799746 */     GIR_RootConstrainSelectedInstOperands,
     /*  799747 */     // GIR_Coverage, 19588,
     /*  799747 */     GIR_EraseRootFromParent_Done,
     /*  799748 */   // Label 12401: @799748
     /*  799748 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(799823), // Rule ID 19589 //
     /*  799753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799799 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799821 */     GIR_RootConstrainSelectedInstOperands,
     /*  799822 */     // GIR_Coverage, 19589,
     /*  799822 */     GIR_EraseRootFromParent_Done,
     /*  799823 */   // Label 12402: @799823
     /*  799823 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(799898), // Rule ID 19592 //
     /*  799828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799874 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799896 */     GIR_RootConstrainSelectedInstOperands,
     /*  799897 */     // GIR_Coverage, 19592,
     /*  799897 */     GIR_EraseRootFromParent_Done,
     /*  799898 */   // Label 12403: @799898
     /*  799898 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(799973), // Rule ID 19593 //
     /*  799903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799971 */     GIR_RootConstrainSelectedInstOperands,
     /*  799972 */     // GIR_Coverage, 19593,
     /*  799972 */     GIR_EraseRootFromParent_Done,
     /*  799973 */   // Label 12404: @799973
     /*  799973 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(800048), // Rule ID 19596 //
     /*  799978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800024 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  800027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800046 */     GIR_RootConstrainSelectedInstOperands,
     /*  800047 */     // GIR_Coverage, 19596,
     /*  800047 */     GIR_EraseRootFromParent_Done,
     /*  800048 */   // Label 12405: @800048
     /*  800048 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(800123), // Rule ID 19597 //
     /*  800053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  800064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  800067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  800070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800099 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  800102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800121 */     GIR_RootConstrainSelectedInstOperands,
     /*  800122 */     // GIR_Coverage, 19597,
     /*  800122 */     GIR_EraseRootFromParent_Done,
     /*  800123 */   // Label 12406: @800123
     /*  800123 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(800198), // Rule ID 19600 //
     /*  800128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  800139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  800142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  800145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  800177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800196 */     GIR_RootConstrainSelectedInstOperands,
     /*  800197 */     // GIR_Coverage, 19600,
     /*  800197 */     GIR_EraseRootFromParent_Done,
     /*  800198 */   // Label 12407: @800198
     /*  800198 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(800273), // Rule ID 19601 //
     /*  800203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  800214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  800217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  800220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800249 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  800252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800271 */     GIR_RootConstrainSelectedInstOperands,
     /*  800272 */     // GIR_Coverage, 19601,
     /*  800272 */     GIR_EraseRootFromParent_Done,
     /*  800273 */   // Label 12408: @800273
     /*  800273 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(800348), // Rule ID 19604 //
     /*  800278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  800289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  800292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  800295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  800327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800346 */     GIR_RootConstrainSelectedInstOperands,
     /*  800347 */     // GIR_Coverage, 19604,
     /*  800347 */     GIR_EraseRootFromParent_Done,
     /*  800348 */   // Label 12409: @800348
     /*  800348 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(800423), // Rule ID 19605 //
     /*  800353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  800364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  800367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  800370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800399 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  800402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800421 */     GIR_RootConstrainSelectedInstOperands,
     /*  800422 */     // GIR_Coverage, 19605,
     /*  800422 */     GIR_EraseRootFromParent_Done,
     /*  800423 */   // Label 12410: @800423
     /*  800423 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(800498), // Rule ID 19608 //
     /*  800428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800474 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800496 */     GIR_RootConstrainSelectedInstOperands,
     /*  800497 */     // GIR_Coverage, 19608,
     /*  800497 */     GIR_EraseRootFromParent_Done,
     /*  800498 */   // Label 12411: @800498
     /*  800498 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(800573), // Rule ID 19609 //
     /*  800503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800571 */     GIR_RootConstrainSelectedInstOperands,
     /*  800572 */     // GIR_Coverage, 19609,
     /*  800572 */     GIR_EraseRootFromParent_Done,
     /*  800573 */   // Label 12412: @800573
     /*  800573 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(800648), // Rule ID 19612 //
     /*  800578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800646 */     GIR_RootConstrainSelectedInstOperands,
     /*  800647 */     // GIR_Coverage, 19612,
     /*  800647 */     GIR_EraseRootFromParent_Done,
     /*  800648 */   // Label 12413: @800648
     /*  800648 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(800723), // Rule ID 19613 //
     /*  800653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800721 */     GIR_RootConstrainSelectedInstOperands,
     /*  800722 */     // GIR_Coverage, 19613,
     /*  800722 */     GIR_EraseRootFromParent_Done,
     /*  800723 */   // Label 12414: @800723
     /*  800723 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(800798), // Rule ID 19616 //
     /*  800728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800796 */     GIR_RootConstrainSelectedInstOperands,
     /*  800797 */     // GIR_Coverage, 19616,
     /*  800797 */     GIR_EraseRootFromParent_Done,
     /*  800798 */   // Label 12415: @800798
     /*  800798 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(800873), // Rule ID 19617 //
     /*  800803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800871 */     GIR_RootConstrainSelectedInstOperands,
     /*  800872 */     // GIR_Coverage, 19617,
     /*  800872 */     GIR_EraseRootFromParent_Done,
     /*  800873 */   // Label 12416: @800873
     /*  800873 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(800948), // Rule ID 19620 //
     /*  800878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800924 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800946 */     GIR_RootConstrainSelectedInstOperands,
     /*  800947 */     // GIR_Coverage, 19620,
     /*  800947 */     GIR_EraseRootFromParent_Done,
     /*  800948 */   // Label 12417: @800948
     /*  800948 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(801023), // Rule ID 19621 //
     /*  800953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800999 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  801002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801021 */     GIR_RootConstrainSelectedInstOperands,
     /*  801022 */     // GIR_Coverage, 19621,
     /*  801022 */     GIR_EraseRootFromParent_Done,
     /*  801023 */   // Label 12418: @801023
     /*  801023 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(801098), // Rule ID 19624 //
     /*  801028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  801039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  801042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  801045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801074 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  801077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801096 */     GIR_RootConstrainSelectedInstOperands,
     /*  801097 */     // GIR_Coverage, 19624,
     /*  801097 */     GIR_EraseRootFromParent_Done,
     /*  801098 */   // Label 12419: @801098
     /*  801098 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(801173), // Rule ID 19625 //
     /*  801103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  801114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  801117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  801120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801149 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  801152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801171 */     GIR_RootConstrainSelectedInstOperands,
     /*  801172 */     // GIR_Coverage, 19625,
     /*  801172 */     GIR_EraseRootFromParent_Done,
     /*  801173 */   // Label 12420: @801173
     /*  801173 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(801248), // Rule ID 19628 //
     /*  801178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  801189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  801192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  801195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  801227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801246 */     GIR_RootConstrainSelectedInstOperands,
     /*  801247 */     // GIR_Coverage, 19628,
     /*  801247 */     GIR_EraseRootFromParent_Done,
     /*  801248 */   // Label 12421: @801248
     /*  801248 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(801323), // Rule ID 19629 //
     /*  801253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  801264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  801267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  801270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  801273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  801292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801299 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  801302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801321 */     GIR_RootConstrainSelectedInstOperands,
     /*  801322 */     // GIR_Coverage, 19629,
     /*  801322 */     GIR_EraseRootFromParent_Done,
     /*  801323 */   // Label 12422: @801323
     /*  801323 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(801398), // Rule ID 19632 //
     /*  801328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  801339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  801342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  801345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  801377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801396 */     GIR_RootConstrainSelectedInstOperands,
     /*  801397 */     // GIR_Coverage, 19632,
     /*  801397 */     GIR_EraseRootFromParent_Done,
     /*  801398 */   // Label 12423: @801398
     /*  801398 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(801473), // Rule ID 19633 //
     /*  801403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  801414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  801417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  801420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  801452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801471 */     GIR_RootConstrainSelectedInstOperands,
     /*  801472 */     // GIR_Coverage, 19633,
     /*  801472 */     GIR_EraseRootFromParent_Done,
     /*  801473 */   // Label 12424: @801473
     /*  801473 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(801548), // Rule ID 19636 //
     /*  801478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801524 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801546 */     GIR_RootConstrainSelectedInstOperands,
     /*  801547 */     // GIR_Coverage, 19636,
     /*  801547 */     GIR_EraseRootFromParent_Done,
     /*  801548 */   // Label 12425: @801548
     /*  801548 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(801623), // Rule ID 19637 //
     /*  801553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801599 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801621 */     GIR_RootConstrainSelectedInstOperands,
     /*  801622 */     // GIR_Coverage, 19637,
     /*  801622 */     GIR_EraseRootFromParent_Done,
     /*  801623 */   // Label 12426: @801623
     /*  801623 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(801698), // Rule ID 19640 //
     /*  801628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801674 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801696 */     GIR_RootConstrainSelectedInstOperands,
     /*  801697 */     // GIR_Coverage, 19640,
     /*  801697 */     GIR_EraseRootFromParent_Done,
     /*  801698 */   // Label 12427: @801698
     /*  801698 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(801773), // Rule ID 19641 //
     /*  801703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801749 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801771 */     GIR_RootConstrainSelectedInstOperands,
     /*  801772 */     // GIR_Coverage, 19641,
     /*  801772 */     GIR_EraseRootFromParent_Done,
     /*  801773 */   // Label 12428: @801773
     /*  801773 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(801848), // Rule ID 19644 //
     /*  801778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801846 */     GIR_RootConstrainSelectedInstOperands,
     /*  801847 */     // GIR_Coverage, 19644,
     /*  801847 */     GIR_EraseRootFromParent_Done,
     /*  801848 */   // Label 12429: @801848
     /*  801848 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(801923), // Rule ID 19645 //
     /*  801853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801921 */     GIR_RootConstrainSelectedInstOperands,
     /*  801922 */     // GIR_Coverage, 19645,
     /*  801922 */     GIR_EraseRootFromParent_Done,
     /*  801923 */   // Label 12430: @801923
     /*  801923 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(801998), // Rule ID 19648 //
     /*  801928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801996 */     GIR_RootConstrainSelectedInstOperands,
     /*  801997 */     // GIR_Coverage, 19648,
     /*  801997 */     GIR_EraseRootFromParent_Done,
     /*  801998 */   // Label 12431: @801998
     /*  801998 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(802073), // Rule ID 19649 //
     /*  802003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  802014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  802017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  802020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802049 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  802052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802071 */     GIR_RootConstrainSelectedInstOperands,
     /*  802072 */     // GIR_Coverage, 19649,
     /*  802072 */     GIR_EraseRootFromParent_Done,
     /*  802073 */   // Label 12432: @802073
     /*  802073 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(802148), // Rule ID 19652 //
     /*  802078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  802089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  802092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  802095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  802127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802146 */     GIR_RootConstrainSelectedInstOperands,
     /*  802147 */     // GIR_Coverage, 19652,
     /*  802147 */     GIR_EraseRootFromParent_Done,
     /*  802148 */   // Label 12433: @802148
     /*  802148 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(802223), // Rule ID 19653 //
     /*  802153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  802164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  802167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  802170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  802173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  802192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802199 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  802202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802221 */     GIR_RootConstrainSelectedInstOperands,
     /*  802222 */     // GIR_Coverage, 19653,
     /*  802222 */     GIR_EraseRootFromParent_Done,
     /*  802223 */   // Label 12434: @802223
     /*  802223 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(802298), // Rule ID 19656 //
     /*  802228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  802239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  802242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  802245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  802248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802274 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  802277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802296 */     GIR_RootConstrainSelectedInstOperands,
     /*  802297 */     // GIR_Coverage, 19656,
     /*  802297 */     GIR_EraseRootFromParent_Done,
     /*  802298 */   // Label 12435: @802298
     /*  802298 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(802373), // Rule ID 19657 //
     /*  802303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  802314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  802317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  802320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  802323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802349 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  802352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802371 */     GIR_RootConstrainSelectedInstOperands,
     /*  802372 */     // GIR_Coverage, 19657,
     /*  802372 */     GIR_EraseRootFromParent_Done,
     /*  802373 */   // Label 12436: @802373
     /*  802373 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(802448), // Rule ID 19660 //
     /*  802378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  802389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802446 */     GIR_RootConstrainSelectedInstOperands,
     /*  802447 */     // GIR_Coverage, 19660,
     /*  802447 */     GIR_EraseRootFromParent_Done,
     /*  802448 */   // Label 12437: @802448
     /*  802448 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(802523), // Rule ID 19661 //
     /*  802453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  802464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802499 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802521 */     GIR_RootConstrainSelectedInstOperands,
     /*  802522 */     // GIR_Coverage, 19661,
     /*  802522 */     GIR_EraseRootFromParent_Done,
     /*  802523 */   // Label 12438: @802523
     /*  802523 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(802598), // Rule ID 19664 //
     /*  802528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802596 */     GIR_RootConstrainSelectedInstOperands,
     /*  802597 */     // GIR_Coverage, 19664,
     /*  802597 */     GIR_EraseRootFromParent_Done,
     /*  802598 */   // Label 12439: @802598
     /*  802598 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(802673), // Rule ID 19665 //
     /*  802603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802649 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802671 */     GIR_RootConstrainSelectedInstOperands,
     /*  802672 */     // GIR_Coverage, 19665,
     /*  802672 */     GIR_EraseRootFromParent_Done,
     /*  802673 */   // Label 12440: @802673
     /*  802673 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(802748), // Rule ID 19668 //
     /*  802678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802746 */     GIR_RootConstrainSelectedInstOperands,
     /*  802747 */     // GIR_Coverage, 19668,
     /*  802747 */     GIR_EraseRootFromParent_Done,
     /*  802748 */   // Label 12441: @802748
     /*  802748 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(802823), // Rule ID 19669 //
     /*  802753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802821 */     GIR_RootConstrainSelectedInstOperands,
     /*  802822 */     // GIR_Coverage, 19669,
     /*  802822 */     GIR_EraseRootFromParent_Done,
     /*  802823 */   // Label 12442: @802823
     /*  802823 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(802898), // Rule ID 19672 //
     /*  802828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802896 */     GIR_RootConstrainSelectedInstOperands,
     /*  802897 */     // GIR_Coverage, 19672,
     /*  802897 */     GIR_EraseRootFromParent_Done,
     /*  802898 */   // Label 12443: @802898
     /*  802898 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(802973), // Rule ID 19673 //
     /*  802903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802949 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802971 */     GIR_RootConstrainSelectedInstOperands,
     /*  802972 */     // GIR_Coverage, 19673,
     /*  802972 */     GIR_EraseRootFromParent_Done,
     /*  802973 */   // Label 12444: @802973
     /*  802973 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(803048), // Rule ID 19676 //
     /*  802978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  803027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803046 */     GIR_RootConstrainSelectedInstOperands,
     /*  803047 */     // GIR_Coverage, 19676,
     /*  803047 */     GIR_EraseRootFromParent_Done,
     /*  803048 */   // Label 12445: @803048
     /*  803048 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(803123), // Rule ID 19677 //
     /*  803053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  803064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  803067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  803070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  803073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  803102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803121 */     GIR_RootConstrainSelectedInstOperands,
     /*  803122 */     // GIR_Coverage, 19677,
     /*  803122 */     GIR_EraseRootFromParent_Done,
     /*  803123 */   // Label 12446: @803123
     /*  803123 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(803198), // Rule ID 19680 //
     /*  803128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  803139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  803142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  803145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  803148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  803177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803196 */     GIR_RootConstrainSelectedInstOperands,
     /*  803197 */     // GIR_Coverage, 19680,
     /*  803197 */     GIR_EraseRootFromParent_Done,
     /*  803198 */   // Label 12447: @803198
     /*  803198 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(803273), // Rule ID 19681 //
     /*  803203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  803214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  803217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  803220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  803223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  803252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803271 */     GIR_RootConstrainSelectedInstOperands,
     /*  803272 */     // GIR_Coverage, 19681,
     /*  803272 */     GIR_EraseRootFromParent_Done,
     /*  803273 */   // Label 12448: @803273
     /*  803273 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(803348), // Rule ID 19684 //
     /*  803278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  803289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  803292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  803295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  803298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  803327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803346 */     GIR_RootConstrainSelectedInstOperands,
     /*  803347 */     // GIR_Coverage, 19684,
     /*  803347 */     GIR_EraseRootFromParent_Done,
     /*  803348 */   // Label 12449: @803348
     /*  803348 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(803423), // Rule ID 19685 //
     /*  803353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  803364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  803367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  803370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  803373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803399 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  803402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803421 */     GIR_RootConstrainSelectedInstOperands,
     /*  803422 */     // GIR_Coverage, 19685,
     /*  803422 */     GIR_EraseRootFromParent_Done,
     /*  803423 */   // Label 12450: @803423
     /*  803423 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(803498), // Rule ID 19688 //
     /*  803428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803474 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803496 */     GIR_RootConstrainSelectedInstOperands,
     /*  803497 */     // GIR_Coverage, 19688,
     /*  803497 */     GIR_EraseRootFromParent_Done,
     /*  803498 */   // Label 12451: @803498
     /*  803498 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(803573), // Rule ID 19689 //
     /*  803503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803549 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803571 */     GIR_RootConstrainSelectedInstOperands,
     /*  803572 */     // GIR_Coverage, 19689,
     /*  803572 */     GIR_EraseRootFromParent_Done,
     /*  803573 */   // Label 12452: @803573
     /*  803573 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(803648), // Rule ID 19692 //
     /*  803578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803646 */     GIR_RootConstrainSelectedInstOperands,
     /*  803647 */     // GIR_Coverage, 19692,
     /*  803647 */     GIR_EraseRootFromParent_Done,
     /*  803648 */   // Label 12453: @803648
     /*  803648 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(803723), // Rule ID 19693 //
     /*  803653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803721 */     GIR_RootConstrainSelectedInstOperands,
     /*  803722 */     // GIR_Coverage, 19693,
     /*  803722 */     GIR_EraseRootFromParent_Done,
     /*  803723 */   // Label 12454: @803723
     /*  803723 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(803798), // Rule ID 19696 //
     /*  803728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803796 */     GIR_RootConstrainSelectedInstOperands,
     /*  803797 */     // GIR_Coverage, 19696,
     /*  803797 */     GIR_EraseRootFromParent_Done,
     /*  803798 */   // Label 12455: @803798
     /*  803798 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(803873), // Rule ID 19697 //
     /*  803803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803849 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803871 */     GIR_RootConstrainSelectedInstOperands,
     /*  803872 */     // GIR_Coverage, 19697,
     /*  803872 */     GIR_EraseRootFromParent_Done,
     /*  803873 */   // Label 12456: @803873
     /*  803873 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(803948), // Rule ID 19700 //
     /*  803878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803946 */     GIR_RootConstrainSelectedInstOperands,
     /*  803947 */     // GIR_Coverage, 19700,
     /*  803947 */     GIR_EraseRootFromParent_Done,
     /*  803948 */   // Label 12457: @803948
     /*  803948 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(804023), // Rule ID 19701 //
     /*  803953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803999 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  804002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804021 */     GIR_RootConstrainSelectedInstOperands,
     /*  804022 */     // GIR_Coverage, 19701,
     /*  804022 */     GIR_EraseRootFromParent_Done,
     /*  804023 */   // Label 12458: @804023
     /*  804023 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(804098), // Rule ID 19704 //
     /*  804028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  804039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  804042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  804045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  804048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  804077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804096 */     GIR_RootConstrainSelectedInstOperands,
     /*  804097 */     // GIR_Coverage, 19704,
     /*  804097 */     GIR_EraseRootFromParent_Done,
     /*  804098 */   // Label 12459: @804098
     /*  804098 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(804173), // Rule ID 19705 //
     /*  804103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  804114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  804117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  804120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  804123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  804152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804171 */     GIR_RootConstrainSelectedInstOperands,
     /*  804172 */     // GIR_Coverage, 19705,
     /*  804172 */     GIR_EraseRootFromParent_Done,
     /*  804173 */   // Label 12460: @804173
     /*  804173 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(804248), // Rule ID 19708 //
     /*  804178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  804189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  804192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  804195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  804198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  804227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804246 */     GIR_RootConstrainSelectedInstOperands,
     /*  804247 */     // GIR_Coverage, 19708,
     /*  804247 */     GIR_EraseRootFromParent_Done,
     /*  804248 */   // Label 12461: @804248
     /*  804248 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(804323), // Rule ID 19709 //
     /*  804253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  804264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  804267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  804270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  804273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  804302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804321 */     GIR_RootConstrainSelectedInstOperands,
     /*  804322 */     // GIR_Coverage, 19709,
     /*  804322 */     GIR_EraseRootFromParent_Done,
     /*  804323 */   // Label 12462: @804323
     /*  804323 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(804398), // Rule ID 19712 //
     /*  804328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  804339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  804342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  804345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  804348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  804377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804396 */     GIR_RootConstrainSelectedInstOperands,
     /*  804397 */     // GIR_Coverage, 19712,
     /*  804397 */     GIR_EraseRootFromParent_Done,
     /*  804398 */   // Label 12463: @804398
     /*  804398 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(804473), // Rule ID 19713 //
     /*  804403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  804414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  804417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  804420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  804423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804449 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  804452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804471 */     GIR_RootConstrainSelectedInstOperands,
     /*  804472 */     // GIR_Coverage, 19713,
     /*  804472 */     GIR_EraseRootFromParent_Done,
     /*  804473 */   // Label 12464: @804473
     /*  804473 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(804548), // Rule ID 19716 //
     /*  804478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804546 */     GIR_RootConstrainSelectedInstOperands,
     /*  804547 */     // GIR_Coverage, 19716,
     /*  804547 */     GIR_EraseRootFromParent_Done,
     /*  804548 */   // Label 12465: @804548
     /*  804548 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(804623), // Rule ID 19717 //
     /*  804553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804599 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804621 */     GIR_RootConstrainSelectedInstOperands,
     /*  804622 */     // GIR_Coverage, 19717,
     /*  804622 */     GIR_EraseRootFromParent_Done,
     /*  804623 */   // Label 12466: @804623
     /*  804623 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(804698), // Rule ID 19720 //
     /*  804628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804696 */     GIR_RootConstrainSelectedInstOperands,
     /*  804697 */     // GIR_Coverage, 19720,
     /*  804697 */     GIR_EraseRootFromParent_Done,
     /*  804698 */   // Label 12467: @804698
     /*  804698 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(804773), // Rule ID 19721 //
     /*  804703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804749 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804771 */     GIR_RootConstrainSelectedInstOperands,
     /*  804772 */     // GIR_Coverage, 19721,
     /*  804772 */     GIR_EraseRootFromParent_Done,
     /*  804773 */   // Label 12468: @804773
     /*  804773 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(804848), // Rule ID 19724 //
     /*  804778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804846 */     GIR_RootConstrainSelectedInstOperands,
     /*  804847 */     // GIR_Coverage, 19724,
     /*  804847 */     GIR_EraseRootFromParent_Done,
     /*  804848 */   // Label 12469: @804848
     /*  804848 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(804923), // Rule ID 19725 //
     /*  804853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804921 */     GIR_RootConstrainSelectedInstOperands,
     /*  804922 */     // GIR_Coverage, 19725,
     /*  804922 */     GIR_EraseRootFromParent_Done,
     /*  804923 */   // Label 12470: @804923
     /*  804923 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(804998), // Rule ID 19728 //
     /*  804928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804996 */     GIR_RootConstrainSelectedInstOperands,
     /*  804997 */     // GIR_Coverage, 19728,
     /*  804997 */     GIR_EraseRootFromParent_Done,
     /*  804998 */   // Label 12471: @804998
     /*  804998 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(805073), // Rule ID 19729 //
     /*  805003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  805014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  805017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  805020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805049 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11325:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  805052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805071 */     GIR_RootConstrainSelectedInstOperands,
     /*  805072 */     // GIR_Coverage, 19729,
     /*  805072 */     GIR_EraseRootFromParent_Done,
     /*  805073 */   // Label 12472: @805073
     /*  805073 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(805148), // Rule ID 19732 //
     /*  805078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  805127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805146 */     GIR_RootConstrainSelectedInstOperands,
     /*  805147 */     // GIR_Coverage, 19732,
     /*  805147 */     GIR_EraseRootFromParent_Done,
     /*  805148 */   // Label 12473: @805148
     /*  805148 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(805223), // Rule ID 19733 //
     /*  805153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  805164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  805167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  805170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805199 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11325:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  805202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805221 */     GIR_RootConstrainSelectedInstOperands,
     /*  805222 */     // GIR_Coverage, 19733,
     /*  805222 */     GIR_EraseRootFromParent_Done,
     /*  805223 */   // Label 12474: @805223
     /*  805223 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(805298), // Rule ID 19736 //
     /*  805228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  805277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805296 */     GIR_RootConstrainSelectedInstOperands,
     /*  805297 */     // GIR_Coverage, 19736,
     /*  805297 */     GIR_EraseRootFromParent_Done,
     /*  805298 */   // Label 12475: @805298
     /*  805298 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(805373), // Rule ID 19737 //
     /*  805303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  805314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  805317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  805320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805349 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11325:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  805352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805371 */     GIR_RootConstrainSelectedInstOperands,
     /*  805372 */     // GIR_Coverage, 19737,
     /*  805372 */     GIR_EraseRootFromParent_Done,
     /*  805373 */   // Label 12476: @805373
     /*  805373 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(805448), // Rule ID 19740 //
     /*  805378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  805389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805446 */     GIR_RootConstrainSelectedInstOperands,
     /*  805447 */     // GIR_Coverage, 19740,
     /*  805447 */     GIR_EraseRootFromParent_Done,
     /*  805448 */   // Label 12477: @805448
     /*  805448 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(805523), // Rule ID 19741 //
     /*  805453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  805464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805521 */     GIR_RootConstrainSelectedInstOperands,
     /*  805522 */     // GIR_Coverage, 19741,
     /*  805522 */     GIR_EraseRootFromParent_Done,
     /*  805523 */   // Label 12478: @805523
     /*  805523 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(805598), // Rule ID 19744 //
     /*  805528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805596 */     GIR_RootConstrainSelectedInstOperands,
     /*  805597 */     // GIR_Coverage, 19744,
     /*  805597 */     GIR_EraseRootFromParent_Done,
     /*  805598 */   // Label 12479: @805598
     /*  805598 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(805673), // Rule ID 19745 //
     /*  805603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805649 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805671 */     GIR_RootConstrainSelectedInstOperands,
     /*  805672 */     // GIR_Coverage, 19745,
     /*  805672 */     GIR_EraseRootFromParent_Done,
     /*  805673 */   // Label 12480: @805673
     /*  805673 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(805748), // Rule ID 19748 //
     /*  805678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805724 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805746 */     GIR_RootConstrainSelectedInstOperands,
     /*  805747 */     // GIR_Coverage, 19748,
     /*  805747 */     GIR_EraseRootFromParent_Done,
     /*  805748 */   // Label 12481: @805748
     /*  805748 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(805823), // Rule ID 19749 //
     /*  805753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805799 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805821 */     GIR_RootConstrainSelectedInstOperands,
     /*  805822 */     // GIR_Coverage, 19749,
     /*  805822 */     GIR_EraseRootFromParent_Done,
     /*  805823 */   // Label 12482: @805823
     /*  805823 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(805898), // Rule ID 19752 //
     /*  805828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805896 */     GIR_RootConstrainSelectedInstOperands,
     /*  805897 */     // GIR_Coverage, 19752,
     /*  805897 */     GIR_EraseRootFromParent_Done,
     /*  805898 */   // Label 12483: @805898
     /*  805898 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(805973), // Rule ID 19753 //
     /*  805903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805971 */     GIR_RootConstrainSelectedInstOperands,
     /*  805972 */     // GIR_Coverage, 19753,
     /*  805972 */     GIR_EraseRootFromParent_Done,
     /*  805973 */   // Label 12484: @805973
     /*  805973 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(806048), // Rule ID 19756 //
     /*  805978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  806027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806046 */     GIR_RootConstrainSelectedInstOperands,
     /*  806047 */     // GIR_Coverage, 19756,
     /*  806047 */     GIR_EraseRootFromParent_Done,
     /*  806048 */   // Label 12485: @806048
     /*  806048 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(806123), // Rule ID 19757 //
     /*  806053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  806064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  806067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  806070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  806102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806121 */     GIR_RootConstrainSelectedInstOperands,
     /*  806122 */     // GIR_Coverage, 19757,
     /*  806122 */     GIR_EraseRootFromParent_Done,
     /*  806123 */   // Label 12486: @806123
     /*  806123 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(806198), // Rule ID 19760 //
     /*  806128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  806177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806196 */     GIR_RootConstrainSelectedInstOperands,
     /*  806197 */     // GIR_Coverage, 19760,
     /*  806197 */     GIR_EraseRootFromParent_Done,
     /*  806198 */   // Label 12487: @806198
     /*  806198 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(806273), // Rule ID 19761 //
     /*  806203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  806214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  806217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  806220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  806223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  806242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806249 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  806252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806271 */     GIR_RootConstrainSelectedInstOperands,
     /*  806272 */     // GIR_Coverage, 19761,
     /*  806272 */     GIR_EraseRootFromParent_Done,
     /*  806273 */   // Label 12488: @806273
     /*  806273 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(806348), // Rule ID 19764 //
     /*  806278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  806327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806346 */     GIR_RootConstrainSelectedInstOperands,
     /*  806347 */     // GIR_Coverage, 19764,
     /*  806347 */     GIR_EraseRootFromParent_Done,
     /*  806348 */   // Label 12489: @806348
     /*  806348 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(806423), // Rule ID 19765 //
     /*  806353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  806364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  806367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  806370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11325:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  806402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806421 */     GIR_RootConstrainSelectedInstOperands,
     /*  806422 */     // GIR_Coverage, 19765,
     /*  806422 */     GIR_EraseRootFromParent_Done,
     /*  806423 */   // Label 12490: @806423
     /*  806423 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(806498), // Rule ID 19768 //
     /*  806428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806496 */     GIR_RootConstrainSelectedInstOperands,
     /*  806497 */     // GIR_Coverage, 19768,
     /*  806497 */     GIR_EraseRootFromParent_Done,
     /*  806498 */   // Label 12491: @806498
     /*  806498 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(806573), // Rule ID 19769 //
     /*  806503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11325:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806571 */     GIR_RootConstrainSelectedInstOperands,
     /*  806572 */     // GIR_Coverage, 19769,
     /*  806572 */     GIR_EraseRootFromParent_Done,
     /*  806573 */   // Label 12492: @806573
     /*  806573 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(806648), // Rule ID 19772 //
     /*  806578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806646 */     GIR_RootConstrainSelectedInstOperands,
     /*  806647 */     // GIR_Coverage, 19772,
     /*  806647 */     GIR_EraseRootFromParent_Done,
     /*  806648 */   // Label 12493: @806648
     /*  806648 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(806723), // Rule ID 19773 //
     /*  806653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11325:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806721 */     GIR_RootConstrainSelectedInstOperands,
     /*  806722 */     // GIR_Coverage, 19773,
     /*  806722 */     GIR_EraseRootFromParent_Done,
     /*  806723 */   // Label 12494: @806723
     /*  806723 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(806798), // Rule ID 21990 //
     /*  806728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806796 */     GIR_RootConstrainSelectedInstOperands,
     /*  806797 */     // GIR_Coverage, 21990,
     /*  806797 */     GIR_EraseRootFromParent_Done,
     /*  806798 */   // Label 12495: @806798
     /*  806798 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(806873), // Rule ID 21991 //
     /*  806803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806849 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806871 */     GIR_RootConstrainSelectedInstOperands,
     /*  806872 */     // GIR_Coverage, 21991,
     /*  806872 */     GIR_EraseRootFromParent_Done,
     /*  806873 */   // Label 12496: @806873
     /*  806873 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(806948), // Rule ID 21994 //
     /*  806878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806946 */     GIR_RootConstrainSelectedInstOperands,
     /*  806947 */     // GIR_Coverage, 21994,
     /*  806947 */     GIR_EraseRootFromParent_Done,
     /*  806948 */   // Label 12497: @806948
     /*  806948 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(807023), // Rule ID 21995 //
     /*  806953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  807002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807021 */     GIR_RootConstrainSelectedInstOperands,
     /*  807022 */     // GIR_Coverage, 21995,
     /*  807022 */     GIR_EraseRootFromParent_Done,
     /*  807023 */   // Label 12498: @807023
     /*  807023 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(807098), // Rule ID 21998 //
     /*  807028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  807077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807096 */     GIR_RootConstrainSelectedInstOperands,
     /*  807097 */     // GIR_Coverage, 21998,
     /*  807097 */     GIR_EraseRootFromParent_Done,
     /*  807098 */   // Label 12499: @807098
     /*  807098 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(807173), // Rule ID 21999 //
     /*  807103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  807152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807171 */     GIR_RootConstrainSelectedInstOperands,
     /*  807172 */     // GIR_Coverage, 21999,
     /*  807172 */     GIR_EraseRootFromParent_Done,
     /*  807173 */   // Label 12500: @807173
     /*  807173 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(807248), // Rule ID 22002 //
     /*  807178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  807195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  807227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807246 */     GIR_RootConstrainSelectedInstOperands,
     /*  807247 */     // GIR_Coverage, 22002,
     /*  807247 */     GIR_EraseRootFromParent_Done,
     /*  807248 */   // Label 12501: @807248
     /*  807248 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(807323), // Rule ID 22003 //
     /*  807253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  807270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  807302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807321 */     GIR_RootConstrainSelectedInstOperands,
     /*  807322 */     // GIR_Coverage, 22003,
     /*  807322 */     GIR_EraseRootFromParent_Done,
     /*  807323 */   // Label 12502: @807323
     /*  807323 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(807398), // Rule ID 22006 //
     /*  807328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  807345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  807377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807396 */     GIR_RootConstrainSelectedInstOperands,
     /*  807397 */     // GIR_Coverage, 22006,
     /*  807397 */     GIR_EraseRootFromParent_Done,
     /*  807398 */   // Label 12503: @807398
     /*  807398 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(807473), // Rule ID 22007 //
     /*  807403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  807420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  807452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807471 */     GIR_RootConstrainSelectedInstOperands,
     /*  807472 */     // GIR_Coverage, 22007,
     /*  807472 */     GIR_EraseRootFromParent_Done,
     /*  807473 */   // Label 12504: @807473
     /*  807473 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(807548), // Rule ID 22010 //
     /*  807478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807546 */     GIR_RootConstrainSelectedInstOperands,
     /*  807547 */     // GIR_Coverage, 22010,
     /*  807547 */     GIR_EraseRootFromParent_Done,
     /*  807548 */   // Label 12505: @807548
     /*  807548 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(807623), // Rule ID 22011 //
     /*  807553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807621 */     GIR_RootConstrainSelectedInstOperands,
     /*  807622 */     // GIR_Coverage, 22011,
     /*  807622 */     GIR_EraseRootFromParent_Done,
     /*  807623 */   // Label 12506: @807623
     /*  807623 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(807698), // Rule ID 22014 //
     /*  807628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807696 */     GIR_RootConstrainSelectedInstOperands,
     /*  807697 */     // GIR_Coverage, 22014,
     /*  807697 */     GIR_EraseRootFromParent_Done,
     /*  807698 */   // Label 12507: @807698
     /*  807698 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(807773), // Rule ID 22015 //
     /*  807703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807771 */     GIR_RootConstrainSelectedInstOperands,
     /*  807772 */     // GIR_Coverage, 22015,
     /*  807772 */     GIR_EraseRootFromParent_Done,
     /*  807773 */   // Label 12508: @807773
     /*  807773 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(807848), // Rule ID 22018 //
     /*  807778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807846 */     GIR_RootConstrainSelectedInstOperands,
     /*  807847 */     // GIR_Coverage, 22018,
     /*  807847 */     GIR_EraseRootFromParent_Done,
     /*  807848 */   // Label 12509: @807848
     /*  807848 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(807923), // Rule ID 22019 //
     /*  807853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807921 */     GIR_RootConstrainSelectedInstOperands,
     /*  807922 */     // GIR_Coverage, 22019,
     /*  807922 */     GIR_EraseRootFromParent_Done,
     /*  807923 */   // Label 12510: @807923
     /*  807923 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(807998), // Rule ID 22022 //
     /*  807928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  807931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807996 */     GIR_RootConstrainSelectedInstOperands,
     /*  807997 */     // GIR_Coverage, 22022,
     /*  807997 */     GIR_EraseRootFromParent_Done,
     /*  807998 */   // Label 12511: @807998
     /*  807998 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(808073), // Rule ID 22023 //
     /*  808003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  808006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  808052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808071 */     GIR_RootConstrainSelectedInstOperands,
     /*  808072 */     // GIR_Coverage, 22023,
     /*  808072 */     GIR_EraseRootFromParent_Done,
     /*  808073 */   // Label 12512: @808073
     /*  808073 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(808148), // Rule ID 22026 //
     /*  808078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  808127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808146 */     GIR_RootConstrainSelectedInstOperands,
     /*  808147 */     // GIR_Coverage, 22026,
     /*  808147 */     GIR_EraseRootFromParent_Done,
     /*  808148 */   // Label 12513: @808148
     /*  808148 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(808223), // Rule ID 22027 //
     /*  808153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  808170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  808202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808221 */     GIR_RootConstrainSelectedInstOperands,
     /*  808222 */     // GIR_Coverage, 22027,
     /*  808222 */     GIR_EraseRootFromParent_Done,
     /*  808223 */   // Label 12514: @808223
     /*  808223 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(808298), // Rule ID 22030 //
     /*  808228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  808245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  808277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808296 */     GIR_RootConstrainSelectedInstOperands,
     /*  808297 */     // GIR_Coverage, 22030,
     /*  808297 */     GIR_EraseRootFromParent_Done,
     /*  808298 */   // Label 12515: @808298
     /*  808298 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(808373), // Rule ID 22031 //
     /*  808303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  808320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808349 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  808352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808371 */     GIR_RootConstrainSelectedInstOperands,
     /*  808372 */     // GIR_Coverage, 22031,
     /*  808372 */     GIR_EraseRootFromParent_Done,
     /*  808373 */   // Label 12516: @808373
     /*  808373 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(808448), // Rule ID 22034 //
     /*  808378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808446 */     GIR_RootConstrainSelectedInstOperands,
     /*  808447 */     // GIR_Coverage, 22034,
     /*  808447 */     GIR_EraseRootFromParent_Done,
     /*  808448 */   // Label 12517: @808448
     /*  808448 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(808523), // Rule ID 22035 //
     /*  808453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11565:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808521 */     GIR_RootConstrainSelectedInstOperands,
     /*  808522 */     // GIR_Coverage, 22035,
     /*  808522 */     GIR_EraseRootFromParent_Done,
     /*  808523 */   // Label 12518: @808523
     /*  808523 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(808598), // Rule ID 22038 //
     /*  808528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808596 */     GIR_RootConstrainSelectedInstOperands,
     /*  808597 */     // GIR_Coverage, 22038,
     /*  808597 */     GIR_EraseRootFromParent_Done,
     /*  808598 */   // Label 12519: @808598
     /*  808598 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(808673), // Rule ID 22039 //
     /*  808603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808671 */     GIR_RootConstrainSelectedInstOperands,
     /*  808672 */     // GIR_Coverage, 22039,
     /*  808672 */     GIR_EraseRootFromParent_Done,
     /*  808673 */   // Label 12520: @808673
     /*  808673 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(808748), // Rule ID 22042 //
     /*  808678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808746 */     GIR_RootConstrainSelectedInstOperands,
     /*  808747 */     // GIR_Coverage, 22042,
     /*  808747 */     GIR_EraseRootFromParent_Done,
     /*  808748 */   // Label 12521: @808748
     /*  808748 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(808823), // Rule ID 22043 //
     /*  808753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808821 */     GIR_RootConstrainSelectedInstOperands,
     /*  808822 */     // GIR_Coverage, 22043,
     /*  808822 */     GIR_EraseRootFromParent_Done,
     /*  808823 */   // Label 12522: @808823
     /*  808823 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(808898), // Rule ID 22046 //
     /*  808828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808896 */     GIR_RootConstrainSelectedInstOperands,
     /*  808897 */     // GIR_Coverage, 22046,
     /*  808897 */     GIR_EraseRootFromParent_Done,
     /*  808898 */   // Label 12523: @808898
     /*  808898 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(808973), // Rule ID 22047 //
     /*  808903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11565:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808971 */     GIR_RootConstrainSelectedInstOperands,
     /*  808972 */     // GIR_Coverage, 22047,
     /*  808972 */     GIR_EraseRootFromParent_Done,
     /*  808973 */   // Label 12524: @808973
     /*  808973 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(809048), // Rule ID 22050 //
     /*  808978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  809027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809046 */     GIR_RootConstrainSelectedInstOperands,
     /*  809047 */     // GIR_Coverage, 22050,
     /*  809047 */     GIR_EraseRootFromParent_Done,
     /*  809048 */   // Label 12525: @809048
     /*  809048 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(809123), // Rule ID 22051 //
     /*  809053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  809102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809121 */     GIR_RootConstrainSelectedInstOperands,
     /*  809122 */     // GIR_Coverage, 22051,
     /*  809122 */     GIR_EraseRootFromParent_Done,
     /*  809123 */   // Label 12526: @809123
     /*  809123 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(809198), // Rule ID 22054 //
     /*  809128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  809177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809196 */     GIR_RootConstrainSelectedInstOperands,
     /*  809197 */     // GIR_Coverage, 22054,
     /*  809197 */     GIR_EraseRootFromParent_Done,
     /*  809198 */   // Label 12527: @809198
     /*  809198 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(809273), // Rule ID 22055 //
     /*  809203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  809252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809271 */     GIR_RootConstrainSelectedInstOperands,
     /*  809272 */     // GIR_Coverage, 22055,
     /*  809272 */     GIR_EraseRootFromParent_Done,
     /*  809273 */   // Label 12528: @809273
     /*  809273 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(809348), // Rule ID 22058 //
     /*  809278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  809327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809346 */     GIR_RootConstrainSelectedInstOperands,
     /*  809347 */     // GIR_Coverage, 22058,
     /*  809347 */     GIR_EraseRootFromParent_Done,
     /*  809348 */   // Label 12529: @809348
     /*  809348 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(809423), // Rule ID 22059 //
     /*  809353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11565:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  809402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809421 */     GIR_RootConstrainSelectedInstOperands,
     /*  809422 */     // GIR_Coverage, 22059,
     /*  809422 */     GIR_EraseRootFromParent_Done,
     /*  809423 */   // Label 12530: @809423
     /*  809423 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(809498), // Rule ID 22062 //
     /*  809428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809496 */     GIR_RootConstrainSelectedInstOperands,
     /*  809497 */     // GIR_Coverage, 22062,
     /*  809497 */     GIR_EraseRootFromParent_Done,
     /*  809498 */   // Label 12531: @809498
     /*  809498 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(809573), // Rule ID 22063 //
     /*  809503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809571 */     GIR_RootConstrainSelectedInstOperands,
     /*  809572 */     // GIR_Coverage, 22063,
     /*  809572 */     GIR_EraseRootFromParent_Done,
     /*  809573 */   // Label 12532: @809573
     /*  809573 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(809648), // Rule ID 22066 //
     /*  809578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809646 */     GIR_RootConstrainSelectedInstOperands,
     /*  809647 */     // GIR_Coverage, 22066,
     /*  809647 */     GIR_EraseRootFromParent_Done,
     /*  809648 */   // Label 12533: @809648
     /*  809648 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(809723), // Rule ID 22067 //
     /*  809653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809721 */     GIR_RootConstrainSelectedInstOperands,
     /*  809722 */     // GIR_Coverage, 22067,
     /*  809722 */     GIR_EraseRootFromParent_Done,
     /*  809723 */   // Label 12534: @809723
     /*  809723 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(809798), // Rule ID 22070 //
     /*  809728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809796 */     GIR_RootConstrainSelectedInstOperands,
     /*  809797 */     // GIR_Coverage, 22070,
     /*  809797 */     GIR_EraseRootFromParent_Done,
     /*  809798 */   // Label 12535: @809798
     /*  809798 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(809873), // Rule ID 22071 //
     /*  809803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11565:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809871 */     GIR_RootConstrainSelectedInstOperands,
     /*  809872 */     // GIR_Coverage, 22071,
     /*  809872 */     GIR_EraseRootFromParent_Done,
     /*  809873 */   // Label 12536: @809873
     /*  809873 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(809948), // Rule ID 22074 //
     /*  809878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809946 */     GIR_RootConstrainSelectedInstOperands,
     /*  809947 */     // GIR_Coverage, 22074,
     /*  809947 */     GIR_EraseRootFromParent_Done,
     /*  809948 */   // Label 12537: @809948
     /*  809948 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(810023), // Rule ID 22075 //
     /*  809953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  810002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810021 */     GIR_RootConstrainSelectedInstOperands,
     /*  810022 */     // GIR_Coverage, 22075,
     /*  810022 */     GIR_EraseRootFromParent_Done,
     /*  810023 */   // Label 12538: @810023
     /*  810023 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(810098), // Rule ID 22078 //
     /*  810028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  810077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810096 */     GIR_RootConstrainSelectedInstOperands,
     /*  810097 */     // GIR_Coverage, 22078,
     /*  810097 */     GIR_EraseRootFromParent_Done,
     /*  810098 */   // Label 12539: @810098
     /*  810098 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(810173), // Rule ID 22079 //
     /*  810103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810149 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  810152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810171 */     GIR_RootConstrainSelectedInstOperands,
     /*  810172 */     // GIR_Coverage, 22079,
     /*  810172 */     GIR_EraseRootFromParent_Done,
     /*  810173 */   // Label 12540: @810173
     /*  810173 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(810248), // Rule ID 22082 //
     /*  810178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  810227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810246 */     GIR_RootConstrainSelectedInstOperands,
     /*  810247 */     // GIR_Coverage, 22082,
     /*  810247 */     GIR_EraseRootFromParent_Done,
     /*  810248 */   // Label 12541: @810248
     /*  810248 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(810323), // Rule ID 22083 //
     /*  810253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  810302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810321 */     GIR_RootConstrainSelectedInstOperands,
     /*  810322 */     // GIR_Coverage, 22083,
     /*  810322 */     GIR_EraseRootFromParent_Done,
     /*  810323 */   // Label 12542: @810323
     /*  810323 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(810398), // Rule ID 22086 //
     /*  810328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  810377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810396 */     GIR_RootConstrainSelectedInstOperands,
     /*  810397 */     // GIR_Coverage, 22086,
     /*  810397 */     GIR_EraseRootFromParent_Done,
     /*  810398 */   // Label 12543: @810398
     /*  810398 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(810473), // Rule ID 22087 //
     /*  810403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  810452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810471 */     GIR_RootConstrainSelectedInstOperands,
     /*  810472 */     // GIR_Coverage, 22087,
     /*  810472 */     GIR_EraseRootFromParent_Done,
     /*  810473 */   // Label 12544: @810473
     /*  810473 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(810548), // Rule ID 22090 //
     /*  810478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810546 */     GIR_RootConstrainSelectedInstOperands,
     /*  810547 */     // GIR_Coverage, 22090,
     /*  810547 */     GIR_EraseRootFromParent_Done,
     /*  810548 */   // Label 12545: @810548
     /*  810548 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(810623), // Rule ID 22091 //
     /*  810553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810621 */     GIR_RootConstrainSelectedInstOperands,
     /*  810622 */     // GIR_Coverage, 22091,
     /*  810622 */     GIR_EraseRootFromParent_Done,
     /*  810623 */   // Label 12546: @810623
     /*  810623 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(810698), // Rule ID 22094 //
     /*  810628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810696 */     GIR_RootConstrainSelectedInstOperands,
     /*  810697 */     // GIR_Coverage, 22094,
     /*  810697 */     GIR_EraseRootFromParent_Done,
     /*  810698 */   // Label 12547: @810698
     /*  810698 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(810773), // Rule ID 22095 //
     /*  810703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810749 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810771 */     GIR_RootConstrainSelectedInstOperands,
     /*  810772 */     // GIR_Coverage, 22095,
     /*  810772 */     GIR_EraseRootFromParent_Done,
     /*  810773 */   // Label 12548: @810773
     /*  810773 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(810848), // Rule ID 22098 //
     /*  810778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810846 */     GIR_RootConstrainSelectedInstOperands,
     /*  810847 */     // GIR_Coverage, 22098,
     /*  810847 */     GIR_EraseRootFromParent_Done,
     /*  810848 */   // Label 12549: @810848
     /*  810848 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(810923), // Rule ID 22099 //
     /*  810853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810899 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810921 */     GIR_RootConstrainSelectedInstOperands,
     /*  810922 */     // GIR_Coverage, 22099,
     /*  810922 */     GIR_EraseRootFromParent_Done,
     /*  810923 */   // Label 12550: @810923
     /*  810923 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(810998), // Rule ID 22102 //
     /*  810928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810996 */     GIR_RootConstrainSelectedInstOperands,
     /*  810997 */     // GIR_Coverage, 22102,
     /*  810997 */     GIR_EraseRootFromParent_Done,
     /*  810998 */   // Label 12551: @810998
     /*  810998 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(811073), // Rule ID 22103 //
     /*  811003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  811052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811071 */     GIR_RootConstrainSelectedInstOperands,
     /*  811072 */     // GIR_Coverage, 22103,
     /*  811072 */     GIR_EraseRootFromParent_Done,
     /*  811073 */   // Label 12552: @811073
     /*  811073 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(811148), // Rule ID 22106 //
     /*  811078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  811127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811146 */     GIR_RootConstrainSelectedInstOperands,
     /*  811147 */     // GIR_Coverage, 22106,
     /*  811147 */     GIR_EraseRootFromParent_Done,
     /*  811148 */   // Label 12553: @811148
     /*  811148 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(811223), // Rule ID 22107 //
     /*  811153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  811202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811221 */     GIR_RootConstrainSelectedInstOperands,
     /*  811222 */     // GIR_Coverage, 22107,
     /*  811222 */     GIR_EraseRootFromParent_Done,
     /*  811223 */   // Label 12554: @811223
     /*  811223 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(811298), // Rule ID 22110 //
     /*  811228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  811277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811296 */     GIR_RootConstrainSelectedInstOperands,
     /*  811297 */     // GIR_Coverage, 22110,
     /*  811297 */     GIR_EraseRootFromParent_Done,
     /*  811298 */   // Label 12555: @811298
     /*  811298 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(811373), // Rule ID 22111 //
     /*  811303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  811349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  811352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811371 */     GIR_RootConstrainSelectedInstOperands,
     /*  811372 */     // GIR_Coverage, 22111,
     /*  811372 */     GIR_EraseRootFromParent_Done,
     /*  811373 */   // Label 12556: @811373
     /*  811373 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(811448), // Rule ID 22114 //
     /*  811378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811446 */     GIR_RootConstrainSelectedInstOperands,
     /*  811447 */     // GIR_Coverage, 22114,
     /*  811447 */     GIR_EraseRootFromParent_Done,
     /*  811448 */   // Label 12557: @811448
     /*  811448 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(811523), // Rule ID 22115 //
     /*  811453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811521 */     GIR_RootConstrainSelectedInstOperands,
     /*  811522 */     // GIR_Coverage, 22115,
     /*  811522 */     GIR_EraseRootFromParent_Done,
     /*  811523 */   // Label 12558: @811523
     /*  811523 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(811598), // Rule ID 22118 //
     /*  811528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811574 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811596 */     GIR_RootConstrainSelectedInstOperands,
     /*  811597 */     // GIR_Coverage, 22118,
     /*  811597 */     GIR_EraseRootFromParent_Done,
     /*  811598 */   // Label 12559: @811598
     /*  811598 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(811673), // Rule ID 22119 //
     /*  811603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811649 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811671 */     GIR_RootConstrainSelectedInstOperands,
     /*  811672 */     // GIR_Coverage, 22119,
     /*  811672 */     GIR_EraseRootFromParent_Done,
     /*  811673 */   // Label 12560: @811673
     /*  811673 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(811748), // Rule ID 22122 //
     /*  811678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811746 */     GIR_RootConstrainSelectedInstOperands,
     /*  811747 */     // GIR_Coverage, 22122,
     /*  811747 */     GIR_EraseRootFromParent_Done,
     /*  811748 */   // Label 12561: @811748
     /*  811748 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(811823), // Rule ID 22123 //
     /*  811753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811821 */     GIR_RootConstrainSelectedInstOperands,
     /*  811822 */     // GIR_Coverage, 22123,
     /*  811822 */     GIR_EraseRootFromParent_Done,
     /*  811823 */   // Label 12562: @811823
     /*  811823 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(811898), // Rule ID 22126 //
     /*  811828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811896 */     GIR_RootConstrainSelectedInstOperands,
     /*  811897 */     // GIR_Coverage, 22126,
     /*  811897 */     GIR_EraseRootFromParent_Done,
     /*  811898 */   // Label 12563: @811898
     /*  811898 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(811973), // Rule ID 22127 //
     /*  811903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811971 */     GIR_RootConstrainSelectedInstOperands,
     /*  811972 */     // GIR_Coverage, 22127,
     /*  811972 */     GIR_EraseRootFromParent_Done,
     /*  811973 */   // Label 12564: @811973
     /*  811973 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(812048), // Rule ID 22130 //
     /*  811978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  812027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812046 */     GIR_RootConstrainSelectedInstOperands,
     /*  812047 */     // GIR_Coverage, 22130,
     /*  812047 */     GIR_EraseRootFromParent_Done,
     /*  812048 */   // Label 12565: @812048
     /*  812048 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(812123), // Rule ID 22131 //
     /*  812053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812099 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  812102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812121 */     GIR_RootConstrainSelectedInstOperands,
     /*  812122 */     // GIR_Coverage, 22131,
     /*  812122 */     GIR_EraseRootFromParent_Done,
     /*  812123 */   // Label 12566: @812123
     /*  812123 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(812198), // Rule ID 22134 //
     /*  812128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  812177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812196 */     GIR_RootConstrainSelectedInstOperands,
     /*  812197 */     // GIR_Coverage, 22134,
     /*  812197 */     GIR_EraseRootFromParent_Done,
     /*  812198 */   // Label 12567: @812198
     /*  812198 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(812273), // Rule ID 22135 //
     /*  812203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  812252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812271 */     GIR_RootConstrainSelectedInstOperands,
     /*  812272 */     // GIR_Coverage, 22135,
     /*  812272 */     GIR_EraseRootFromParent_Done,
     /*  812273 */   // Label 12568: @812273
     /*  812273 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(812348), // Rule ID 22138 //
     /*  812278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  812327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812346 */     GIR_RootConstrainSelectedInstOperands,
     /*  812347 */     // GIR_Coverage, 22138,
     /*  812347 */     GIR_EraseRootFromParent_Done,
     /*  812348 */   // Label 12569: @812348
     /*  812348 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(812423), // Rule ID 22139 //
     /*  812353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  812402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812421 */     GIR_RootConstrainSelectedInstOperands,
     /*  812422 */     // GIR_Coverage, 22139,
     /*  812422 */     GIR_EraseRootFromParent_Done,
     /*  812423 */   // Label 12570: @812423
     /*  812423 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(812498), // Rule ID 22142 //
     /*  812428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812496 */     GIR_RootConstrainSelectedInstOperands,
     /*  812497 */     // GIR_Coverage, 22142,
     /*  812497 */     GIR_EraseRootFromParent_Done,
     /*  812498 */   // Label 12571: @812498
     /*  812498 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(812573), // Rule ID 22143 //
     /*  812503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812571 */     GIR_RootConstrainSelectedInstOperands,
     /*  812572 */     // GIR_Coverage, 22143,
     /*  812572 */     GIR_EraseRootFromParent_Done,
     /*  812573 */   // Label 12572: @812573
     /*  812573 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(812648), // Rule ID 22146 //
     /*  812578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812646 */     GIR_RootConstrainSelectedInstOperands,
     /*  812647 */     // GIR_Coverage, 22146,
     /*  812647 */     GIR_EraseRootFromParent_Done,
     /*  812648 */   // Label 12573: @812648
     /*  812648 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(812723), // Rule ID 22147 //
     /*  812653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812721 */     GIR_RootConstrainSelectedInstOperands,
     /*  812722 */     // GIR_Coverage, 22147,
     /*  812722 */     GIR_EraseRootFromParent_Done,
     /*  812723 */   // Label 12574: @812723
     /*  812723 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(812798), // Rule ID 22150 //
     /*  812728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812796 */     GIR_RootConstrainSelectedInstOperands,
     /*  812797 */     // GIR_Coverage, 22150,
     /*  812797 */     GIR_EraseRootFromParent_Done,
     /*  812798 */   // Label 12575: @812798
     /*  812798 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(812873), // Rule ID 22151 //
     /*  812803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812871 */     GIR_RootConstrainSelectedInstOperands,
     /*  812872 */     // GIR_Coverage, 22151,
     /*  812872 */     GIR_EraseRootFromParent_Done,
     /*  812873 */   // Label 12576: @812873
     /*  812873 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(812948), // Rule ID 22154 //
     /*  812878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812946 */     GIR_RootConstrainSelectedInstOperands,
     /*  812947 */     // GIR_Coverage, 22154,
     /*  812947 */     GIR_EraseRootFromParent_Done,
     /*  812948 */   // Label 12577: @812948
     /*  812948 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(813023), // Rule ID 22155 //
     /*  812953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  813002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813021 */     GIR_RootConstrainSelectedInstOperands,
     /*  813022 */     // GIR_Coverage, 22155,
     /*  813022 */     GIR_EraseRootFromParent_Done,
     /*  813023 */   // Label 12578: @813023
     /*  813023 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(813098), // Rule ID 22158 //
     /*  813028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  813031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  813077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813096 */     GIR_RootConstrainSelectedInstOperands,
     /*  813097 */     // GIR_Coverage, 22158,
     /*  813097 */     GIR_EraseRootFromParent_Done,
     /*  813098 */   // Label 12579: @813098
     /*  813098 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(813173), // Rule ID 22159 //
     /*  813103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  813152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813171 */     GIR_RootConstrainSelectedInstOperands,
     /*  813172 */     // GIR_Coverage, 22159,
     /*  813172 */     GIR_EraseRootFromParent_Done,
     /*  813173 */   // Label 12580: @813173
     /*  813173 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(813248), // Rule ID 22162 //
     /*  813178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  813227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813246 */     GIR_RootConstrainSelectedInstOperands,
     /*  813247 */     // GIR_Coverage, 22162,
     /*  813247 */     GIR_EraseRootFromParent_Done,
     /*  813248 */   // Label 12581: @813248
     /*  813248 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(813323), // Rule ID 22163 //
     /*  813253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  813302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813321 */     GIR_RootConstrainSelectedInstOperands,
     /*  813322 */     // GIR_Coverage, 22163,
     /*  813322 */     GIR_EraseRootFromParent_Done,
     /*  813323 */   // Label 12582: @813323
     /*  813323 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(813398), // Rule ID 22166 //
     /*  813328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  813377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813396 */     GIR_RootConstrainSelectedInstOperands,
     /*  813397 */     // GIR_Coverage, 22166,
     /*  813397 */     GIR_EraseRootFromParent_Done,
     /*  813398 */   // Label 12583: @813398
     /*  813398 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(813473), // Rule ID 22167 //
     /*  813403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  813452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813471 */     GIR_RootConstrainSelectedInstOperands,
     /*  813472 */     // GIR_Coverage, 22167,
     /*  813472 */     GIR_EraseRootFromParent_Done,
     /*  813473 */   // Label 12584: @813473
     /*  813473 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(813548), // Rule ID 22170 //
     /*  813478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813546 */     GIR_RootConstrainSelectedInstOperands,
     /*  813547 */     // GIR_Coverage, 22170,
     /*  813547 */     GIR_EraseRootFromParent_Done,
     /*  813548 */   // Label 12585: @813548
     /*  813548 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(813623), // Rule ID 22171 //
     /*  813553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813621 */     GIR_RootConstrainSelectedInstOperands,
     /*  813622 */     // GIR_Coverage, 22171,
     /*  813622 */     GIR_EraseRootFromParent_Done,
     /*  813623 */   // Label 12586: @813623
     /*  813623 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(813698), // Rule ID 22174 //
     /*  813628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813696 */     GIR_RootConstrainSelectedInstOperands,
     /*  813697 */     // GIR_Coverage, 22174,
     /*  813697 */     GIR_EraseRootFromParent_Done,
     /*  813698 */   // Label 12587: @813698
     /*  813698 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(813773), // Rule ID 22175 //
     /*  813703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813771 */     GIR_RootConstrainSelectedInstOperands,
     /*  813772 */     // GIR_Coverage, 22175,
     /*  813772 */     GIR_EraseRootFromParent_Done,
     /*  813773 */   // Label 12588: @813773
     /*  813773 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(813848), // Rule ID 22178 //
     /*  813778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813846 */     GIR_RootConstrainSelectedInstOperands,
     /*  813847 */     // GIR_Coverage, 22178,
     /*  813847 */     GIR_EraseRootFromParent_Done,
     /*  813848 */   // Label 12589: @813848
     /*  813848 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(813923), // Rule ID 22179 //
     /*  813853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813921 */     GIR_RootConstrainSelectedInstOperands,
     /*  813922 */     // GIR_Coverage, 22179,
     /*  813922 */     GIR_EraseRootFromParent_Done,
     /*  813923 */   // Label 12590: @813923
     /*  813923 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(813998), // Rule ID 22182 //
     /*  813928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813996 */     GIR_RootConstrainSelectedInstOperands,
     /*  813997 */     // GIR_Coverage, 22182,
     /*  813997 */     GIR_EraseRootFromParent_Done,
     /*  813998 */   // Label 12591: @813998
     /*  813998 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(814073), // Rule ID 22183 //
     /*  814003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  814052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814071 */     GIR_RootConstrainSelectedInstOperands,
     /*  814072 */     // GIR_Coverage, 22183,
     /*  814072 */     GIR_EraseRootFromParent_Done,
     /*  814073 */   // Label 12592: @814073
     /*  814073 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(814148), // Rule ID 22186 //
     /*  814078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  814127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814146 */     GIR_RootConstrainSelectedInstOperands,
     /*  814147 */     // GIR_Coverage, 22186,
     /*  814147 */     GIR_EraseRootFromParent_Done,
     /*  814148 */   // Label 12593: @814148
     /*  814148 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(814223), // Rule ID 22187 //
     /*  814153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  814202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814221 */     GIR_RootConstrainSelectedInstOperands,
     /*  814222 */     // GIR_Coverage, 22187,
     /*  814222 */     GIR_EraseRootFromParent_Done,
     /*  814223 */   // Label 12594: @814223
     /*  814223 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(814298), // Rule ID 22190 //
     /*  814228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  814277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814296 */     GIR_RootConstrainSelectedInstOperands,
     /*  814297 */     // GIR_Coverage, 22190,
     /*  814297 */     GIR_EraseRootFromParent_Done,
     /*  814298 */   // Label 12595: @814298
     /*  814298 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(814373), // Rule ID 22191 //
     /*  814303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814349 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  814352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814371 */     GIR_RootConstrainSelectedInstOperands,
     /*  814372 */     // GIR_Coverage, 22191,
     /*  814372 */     GIR_EraseRootFromParent_Done,
     /*  814373 */   // Label 12596: @814373
     /*  814373 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(814448), // Rule ID 22194 //
     /*  814378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814446 */     GIR_RootConstrainSelectedInstOperands,
     /*  814447 */     // GIR_Coverage, 22194,
     /*  814447 */     GIR_EraseRootFromParent_Done,
     /*  814448 */   // Label 12597: @814448
     /*  814448 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(814523), // Rule ID 22195 //
     /*  814453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814521 */     GIR_RootConstrainSelectedInstOperands,
     /*  814522 */     // GIR_Coverage, 22195,
     /*  814522 */     GIR_EraseRootFromParent_Done,
     /*  814523 */   // Label 12598: @814523
     /*  814523 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(814598), // Rule ID 22198 //
     /*  814528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814596 */     GIR_RootConstrainSelectedInstOperands,
     /*  814597 */     // GIR_Coverage, 22198,
     /*  814597 */     GIR_EraseRootFromParent_Done,
     /*  814598 */   // Label 12599: @814598
     /*  814598 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(814673), // Rule ID 22199 //
     /*  814603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814671 */     GIR_RootConstrainSelectedInstOperands,
     /*  814672 */     // GIR_Coverage, 22199,
     /*  814672 */     GIR_EraseRootFromParent_Done,
     /*  814673 */   // Label 12600: @814673
     /*  814673 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(814748), // Rule ID 22202 //
     /*  814678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814746 */     GIR_RootConstrainSelectedInstOperands,
     /*  814747 */     // GIR_Coverage, 22202,
     /*  814747 */     GIR_EraseRootFromParent_Done,
     /*  814748 */   // Label 12601: @814748
     /*  814748 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(814823), // Rule ID 22203 //
     /*  814753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814821 */     GIR_RootConstrainSelectedInstOperands,
     /*  814822 */     // GIR_Coverage, 22203,
     /*  814822 */     GIR_EraseRootFromParent_Done,
     /*  814823 */   // Label 12602: @814823
     /*  814823 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(814898), // Rule ID 22206 //
     /*  814828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814896 */     GIR_RootConstrainSelectedInstOperands,
     /*  814897 */     // GIR_Coverage, 22206,
     /*  814897 */     GIR_EraseRootFromParent_Done,
     /*  814898 */   // Label 12603: @814898
     /*  814898 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(814973), // Rule ID 22207 //
     /*  814903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814949 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814971 */     GIR_RootConstrainSelectedInstOperands,
     /*  814972 */     // GIR_Coverage, 22207,
     /*  814972 */     GIR_EraseRootFromParent_Done,
     /*  814973 */   // Label 12604: @814973
     /*  814973 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(815048), // Rule ID 22210 //
     /*  814978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  815027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815046 */     GIR_RootConstrainSelectedInstOperands,
     /*  815047 */     // GIR_Coverage, 22210,
     /*  815047 */     GIR_EraseRootFromParent_Done,
     /*  815048 */   // Label 12605: @815048
     /*  815048 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(815123), // Rule ID 22211 //
     /*  815053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11563:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  815102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815121 */     GIR_RootConstrainSelectedInstOperands,
     /*  815122 */     // GIR_Coverage, 22211,
     /*  815122 */     GIR_EraseRootFromParent_Done,
     /*  815123 */   // Label 12606: @815123
     /*  815123 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(815198), // Rule ID 22214 //
     /*  815128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  815177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815196 */     GIR_RootConstrainSelectedInstOperands,
     /*  815197 */     // GIR_Coverage, 22214,
     /*  815197 */     GIR_EraseRootFromParent_Done,
     /*  815198 */   // Label 12607: @815198
     /*  815198 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(815273), // Rule ID 22215 //
     /*  815203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  815252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815271 */     GIR_RootConstrainSelectedInstOperands,
     /*  815272 */     // GIR_Coverage, 22215,
     /*  815272 */     GIR_EraseRootFromParent_Done,
     /*  815273 */   // Label 12608: @815273
     /*  815273 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(815348), // Rule ID 22218 //
     /*  815278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  815327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815346 */     GIR_RootConstrainSelectedInstOperands,
     /*  815347 */     // GIR_Coverage, 22218,
     /*  815347 */     GIR_EraseRootFromParent_Done,
     /*  815348 */   // Label 12609: @815348
     /*  815348 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(815423), // Rule ID 22219 //
     /*  815353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  815402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815421 */     GIR_RootConstrainSelectedInstOperands,
     /*  815422 */     // GIR_Coverage, 22219,
     /*  815422 */     GIR_EraseRootFromParent_Done,
     /*  815423 */   // Label 12610: @815423
     /*  815423 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(815498), // Rule ID 22222 //
     /*  815428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815496 */     GIR_RootConstrainSelectedInstOperands,
     /*  815497 */     // GIR_Coverage, 22222,
     /*  815497 */     GIR_EraseRootFromParent_Done,
     /*  815498 */   // Label 12611: @815498
     /*  815498 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(815573), // Rule ID 22223 //
     /*  815503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11563:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815571 */     GIR_RootConstrainSelectedInstOperands,
     /*  815572 */     // GIR_Coverage, 22223,
     /*  815572 */     GIR_EraseRootFromParent_Done,
     /*  815573 */   // Label 12612: @815573
     /*  815573 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(815648), // Rule ID 22226 //
     /*  815578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815646 */     GIR_RootConstrainSelectedInstOperands,
     /*  815647 */     // GIR_Coverage, 22226,
     /*  815647 */     GIR_EraseRootFromParent_Done,
     /*  815648 */   // Label 12613: @815648
     /*  815648 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(815723), // Rule ID 22227 //
     /*  815653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815721 */     GIR_RootConstrainSelectedInstOperands,
     /*  815722 */     // GIR_Coverage, 22227,
     /*  815722 */     GIR_EraseRootFromParent_Done,
     /*  815723 */   // Label 12614: @815723
     /*  815723 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(815798), // Rule ID 22230 //
     /*  815728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815796 */     GIR_RootConstrainSelectedInstOperands,
     /*  815797 */     // GIR_Coverage, 22230,
     /*  815797 */     GIR_EraseRootFromParent_Done,
     /*  815798 */   // Label 12615: @815798
     /*  815798 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(815873), // Rule ID 22231 //
     /*  815803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815871 */     GIR_RootConstrainSelectedInstOperands,
     /*  815872 */     // GIR_Coverage, 22231,
     /*  815872 */     GIR_EraseRootFromParent_Done,
     /*  815873 */   // Label 12616: @815873
     /*  815873 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(815948), // Rule ID 22234 //
     /*  815878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815946 */     GIR_RootConstrainSelectedInstOperands,
     /*  815947 */     // GIR_Coverage, 22234,
     /*  815947 */     GIR_EraseRootFromParent_Done,
     /*  815948 */   // Label 12617: @815948
     /*  815948 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(816023), // Rule ID 22235 //
     /*  815953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11563:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  816002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816021 */     GIR_RootConstrainSelectedInstOperands,
     /*  816022 */     // GIR_Coverage, 22235,
     /*  816022 */     GIR_EraseRootFromParent_Done,
     /*  816023 */   // Label 12618: @816023
     /*  816023 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(816098), // Rule ID 22238 //
     /*  816028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  816077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816096 */     GIR_RootConstrainSelectedInstOperands,
     /*  816097 */     // GIR_Coverage, 22238,
     /*  816097 */     GIR_EraseRootFromParent_Done,
     /*  816098 */   // Label 12619: @816098
     /*  816098 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(816173), // Rule ID 22239 //
     /*  816103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  816152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816171 */     GIR_RootConstrainSelectedInstOperands,
     /*  816172 */     // GIR_Coverage, 22239,
     /*  816172 */     GIR_EraseRootFromParent_Done,
     /*  816173 */   // Label 12620: @816173
     /*  816173 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(816248), // Rule ID 22242 //
     /*  816178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  816227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816246 */     GIR_RootConstrainSelectedInstOperands,
     /*  816247 */     // GIR_Coverage, 22242,
     /*  816247 */     GIR_EraseRootFromParent_Done,
     /*  816248 */   // Label 12621: @816248
     /*  816248 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(816323), // Rule ID 22243 //
     /*  816253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  816302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816321 */     GIR_RootConstrainSelectedInstOperands,
     /*  816322 */     // GIR_Coverage, 22243,
     /*  816322 */     GIR_EraseRootFromParent_Done,
     /*  816323 */   // Label 12622: @816323
     /*  816323 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(816398), // Rule ID 22246 //
     /*  816328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  816377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816396 */     GIR_RootConstrainSelectedInstOperands,
     /*  816397 */     // GIR_Coverage, 22246,
     /*  816397 */     GIR_EraseRootFromParent_Done,
     /*  816398 */   // Label 12623: @816398
     /*  816398 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(816473), // Rule ID 22247 //
     /*  816403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11563:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  816452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816471 */     GIR_RootConstrainSelectedInstOperands,
     /*  816472 */     // GIR_Coverage, 22247,
     /*  816472 */     GIR_EraseRootFromParent_Done,
     /*  816473 */   // Label 12624: @816473
     /*  816473 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(816548), // Rule ID 22250 //
     /*  816478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816546 */     GIR_RootConstrainSelectedInstOperands,
     /*  816547 */     // GIR_Coverage, 22250,
     /*  816547 */     GIR_EraseRootFromParent_Done,
     /*  816548 */   // Label 12625: @816548
     /*  816548 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(816623), // Rule ID 22251 //
     /*  816553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816621 */     GIR_RootConstrainSelectedInstOperands,
     /*  816622 */     // GIR_Coverage, 22251,
     /*  816622 */     GIR_EraseRootFromParent_Done,
     /*  816623 */   // Label 12626: @816623
     /*  816623 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(816698), // Rule ID 22254 //
     /*  816628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816674 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816696 */     GIR_RootConstrainSelectedInstOperands,
     /*  816697 */     // GIR_Coverage, 22254,
     /*  816697 */     GIR_EraseRootFromParent_Done,
     /*  816698 */   // Label 12627: @816698
     /*  816698 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(816773), // Rule ID 22255 //
     /*  816703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816749 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816771 */     GIR_RootConstrainSelectedInstOperands,
     /*  816772 */     // GIR_Coverage, 22255,
     /*  816772 */     GIR_EraseRootFromParent_Done,
     /*  816773 */   // Label 12628: @816773
     /*  816773 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(816848), // Rule ID 22258 //
     /*  816778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816846 */     GIR_RootConstrainSelectedInstOperands,
     /*  816847 */     // GIR_Coverage, 22258,
     /*  816847 */     GIR_EraseRootFromParent_Done,
     /*  816848 */   // Label 12629: @816848
     /*  816848 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(816923), // Rule ID 22259 //
     /*  816853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816899 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816921 */     GIR_RootConstrainSelectedInstOperands,
     /*  816922 */     // GIR_Coverage, 22259,
     /*  816922 */     GIR_EraseRootFromParent_Done,
     /*  816923 */   // Label 12630: @816923
     /*  816923 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(816998), // Rule ID 22262 //
     /*  816928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816996 */     GIR_RootConstrainSelectedInstOperands,
     /*  816997 */     // GIR_Coverage, 22262,
     /*  816997 */     GIR_EraseRootFromParent_Done,
     /*  816998 */   // Label 12631: @816998
     /*  816998 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(817073), // Rule ID 22263 //
     /*  817003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  817052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817071 */     GIR_RootConstrainSelectedInstOperands,
     /*  817072 */     // GIR_Coverage, 22263,
     /*  817072 */     GIR_EraseRootFromParent_Done,
     /*  817073 */   // Label 12632: @817073
     /*  817073 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(817148), // Rule ID 22266 //
     /*  817078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  817127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817146 */     GIR_RootConstrainSelectedInstOperands,
     /*  817147 */     // GIR_Coverage, 22266,
     /*  817147 */     GIR_EraseRootFromParent_Done,
     /*  817148 */   // Label 12633: @817148
     /*  817148 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(817223), // Rule ID 22267 //
     /*  817153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817199 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  817202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817221 */     GIR_RootConstrainSelectedInstOperands,
     /*  817222 */     // GIR_Coverage, 22267,
     /*  817222 */     GIR_EraseRootFromParent_Done,
     /*  817223 */   // Label 12634: @817223
     /*  817223 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(817298), // Rule ID 22270 //
     /*  817228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  817277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817296 */     GIR_RootConstrainSelectedInstOperands,
     /*  817297 */     // GIR_Coverage, 22270,
     /*  817297 */     GIR_EraseRootFromParent_Done,
     /*  817298 */   // Label 12635: @817298
     /*  817298 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(817373), // Rule ID 22271 //
     /*  817303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817349 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  817352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817371 */     GIR_RootConstrainSelectedInstOperands,
     /*  817372 */     // GIR_Coverage, 22271,
     /*  817372 */     GIR_EraseRootFromParent_Done,
     /*  817373 */   // Label 12636: @817373
     /*  817373 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(817448), // Rule ID 22274 //
     /*  817378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817446 */     GIR_RootConstrainSelectedInstOperands,
     /*  817447 */     // GIR_Coverage, 22274,
     /*  817447 */     GIR_EraseRootFromParent_Done,
     /*  817448 */   // Label 12637: @817448
     /*  817448 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(817523), // Rule ID 22275 //
     /*  817453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817521 */     GIR_RootConstrainSelectedInstOperands,
     /*  817522 */     // GIR_Coverage, 22275,
     /*  817522 */     GIR_EraseRootFromParent_Done,
     /*  817523 */   // Label 12638: @817523
     /*  817523 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(817598), // Rule ID 22278 //
     /*  817528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817596 */     GIR_RootConstrainSelectedInstOperands,
     /*  817597 */     // GIR_Coverage, 22278,
     /*  817597 */     GIR_EraseRootFromParent_Done,
     /*  817598 */   // Label 12639: @817598
     /*  817598 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(817673), // Rule ID 22279 //
     /*  817603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817671 */     GIR_RootConstrainSelectedInstOperands,
     /*  817672 */     // GIR_Coverage, 22279,
     /*  817672 */     GIR_EraseRootFromParent_Done,
     /*  817673 */   // Label 12640: @817673
     /*  817673 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(817748), // Rule ID 22282 //
     /*  817678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817746 */     GIR_RootConstrainSelectedInstOperands,
     /*  817747 */     // GIR_Coverage, 22282,
     /*  817747 */     GIR_EraseRootFromParent_Done,
     /*  817748 */   // Label 12641: @817748
     /*  817748 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(817823), // Rule ID 22283 //
     /*  817753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817821 */     GIR_RootConstrainSelectedInstOperands,
     /*  817822 */     // GIR_Coverage, 22283,
     /*  817822 */     GIR_EraseRootFromParent_Done,
     /*  817823 */   // Label 12642: @817823
     /*  817823 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(817898), // Rule ID 22286 //
     /*  817828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817896 */     GIR_RootConstrainSelectedInstOperands,
     /*  817897 */     // GIR_Coverage, 22286,
     /*  817897 */     GIR_EraseRootFromParent_Done,
     /*  817898 */   // Label 12643: @817898
     /*  817898 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(817973), // Rule ID 22287 //
     /*  817903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  817949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817971 */     GIR_RootConstrainSelectedInstOperands,
     /*  817972 */     // GIR_Coverage, 22287,
     /*  817972 */     GIR_EraseRootFromParent_Done,
     /*  817973 */   // Label 12644: @817973
     /*  817973 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(818048), // Rule ID 22290 //
     /*  817978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  818027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818046 */     GIR_RootConstrainSelectedInstOperands,
     /*  818047 */     // GIR_Coverage, 22290,
     /*  818047 */     GIR_EraseRootFromParent_Done,
     /*  818048 */   // Label 12645: @818048
     /*  818048 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(818123), // Rule ID 22291 //
     /*  818053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  818102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818121 */     GIR_RootConstrainSelectedInstOperands,
     /*  818122 */     // GIR_Coverage, 22291,
     /*  818122 */     GIR_EraseRootFromParent_Done,
     /*  818123 */   // Label 12646: @818123
     /*  818123 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(818198), // Rule ID 22294 //
     /*  818128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  818177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818196 */     GIR_RootConstrainSelectedInstOperands,
     /*  818197 */     // GIR_Coverage, 22294,
     /*  818197 */     GIR_EraseRootFromParent_Done,
     /*  818198 */   // Label 12647: @818198
     /*  818198 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(818273), // Rule ID 22295 //
     /*  818203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818249 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  818252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818271 */     GIR_RootConstrainSelectedInstOperands,
     /*  818272 */     // GIR_Coverage, 22295,
     /*  818272 */     GIR_EraseRootFromParent_Done,
     /*  818273 */   // Label 12648: @818273
     /*  818273 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(818348), // Rule ID 22298 //
     /*  818278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  818327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818346 */     GIR_RootConstrainSelectedInstOperands,
     /*  818347 */     // GIR_Coverage, 22298,
     /*  818347 */     GIR_EraseRootFromParent_Done,
     /*  818348 */   // Label 12649: @818348
     /*  818348 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(818423), // Rule ID 22299 //
     /*  818353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11567:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  818402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818421 */     GIR_RootConstrainSelectedInstOperands,
     /*  818422 */     // GIR_Coverage, 22299,
     /*  818422 */     GIR_EraseRootFromParent_Done,
     /*  818423 */   // Label 12650: @818423
     /*  818423 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(818498), // Rule ID 22302 //
     /*  818428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818496 */     GIR_RootConstrainSelectedInstOperands,
     /*  818497 */     // GIR_Coverage, 22302,
     /*  818497 */     GIR_EraseRootFromParent_Done,
     /*  818498 */   // Label 12651: @818498
     /*  818498 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(818573), // Rule ID 22303 //
     /*  818503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818571 */     GIR_RootConstrainSelectedInstOperands,
     /*  818572 */     // GIR_Coverage, 22303,
     /*  818572 */     GIR_EraseRootFromParent_Done,
     /*  818573 */   // Label 12652: @818573
     /*  818573 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(818648), // Rule ID 22306 //
     /*  818578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818646 */     GIR_RootConstrainSelectedInstOperands,
     /*  818647 */     // GIR_Coverage, 22306,
     /*  818647 */     GIR_EraseRootFromParent_Done,
     /*  818648 */   // Label 12653: @818648
     /*  818648 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(818723), // Rule ID 22307 //
     /*  818653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818721 */     GIR_RootConstrainSelectedInstOperands,
     /*  818722 */     // GIR_Coverage, 22307,
     /*  818722 */     GIR_EraseRootFromParent_Done,
     /*  818723 */   // Label 12654: @818723
     /*  818723 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(818798), // Rule ID 22310 //
     /*  818728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818796 */     GIR_RootConstrainSelectedInstOperands,
     /*  818797 */     // GIR_Coverage, 22310,
     /*  818797 */     GIR_EraseRootFromParent_Done,
     /*  818798 */   // Label 12655: @818798
     /*  818798 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(818873), // Rule ID 22311 //
     /*  818803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11567:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818871 */     GIR_RootConstrainSelectedInstOperands,
     /*  818872 */     // GIR_Coverage, 22311,
     /*  818872 */     GIR_EraseRootFromParent_Done,
     /*  818873 */   // Label 12656: @818873
     /*  818873 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(818948), // Rule ID 22314 //
     /*  818878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818946 */     GIR_RootConstrainSelectedInstOperands,
     /*  818947 */     // GIR_Coverage, 22314,
     /*  818947 */     GIR_EraseRootFromParent_Done,
     /*  818948 */   // Label 12657: @818948
     /*  818948 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(819023), // Rule ID 22315 //
     /*  818953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  819002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819021 */     GIR_RootConstrainSelectedInstOperands,
     /*  819022 */     // GIR_Coverage, 22315,
     /*  819022 */     GIR_EraseRootFromParent_Done,
     /*  819023 */   // Label 12658: @819023
     /*  819023 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(819098), // Rule ID 22318 //
     /*  819028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  819077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819096 */     GIR_RootConstrainSelectedInstOperands,
     /*  819097 */     // GIR_Coverage, 22318,
     /*  819097 */     GIR_EraseRootFromParent_Done,
     /*  819098 */   // Label 12659: @819098
     /*  819098 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(819173), // Rule ID 22319 //
     /*  819103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819149 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  819152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819171 */     GIR_RootConstrainSelectedInstOperands,
     /*  819172 */     // GIR_Coverage, 22319,
     /*  819172 */     GIR_EraseRootFromParent_Done,
     /*  819173 */   // Label 12660: @819173
     /*  819173 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(819248), // Rule ID 22322 //
     /*  819178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  819227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819246 */     GIR_RootConstrainSelectedInstOperands,
     /*  819247 */     // GIR_Coverage, 22322,
     /*  819247 */     GIR_EraseRootFromParent_Done,
     /*  819248 */   // Label 12661: @819248
     /*  819248 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(819323), // Rule ID 22323 //
     /*  819253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11567:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  819302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819321 */     GIR_RootConstrainSelectedInstOperands,
     /*  819322 */     // GIR_Coverage, 22323,
     /*  819322 */     GIR_EraseRootFromParent_Done,
     /*  819323 */   // Label 12662: @819323
     /*  819323 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(819398), // Rule ID 22326 //
     /*  819328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  819377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819396 */     GIR_RootConstrainSelectedInstOperands,
     /*  819397 */     // GIR_Coverage, 22326,
     /*  819397 */     GIR_EraseRootFromParent_Done,
     /*  819398 */   // Label 12663: @819398
     /*  819398 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(819473), // Rule ID 22327 //
     /*  819403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  819452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819471 */     GIR_RootConstrainSelectedInstOperands,
     /*  819472 */     // GIR_Coverage, 22327,
     /*  819472 */     GIR_EraseRootFromParent_Done,
     /*  819473 */   // Label 12664: @819473
     /*  819473 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(819548), // Rule ID 22330 //
     /*  819478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819546 */     GIR_RootConstrainSelectedInstOperands,
     /*  819547 */     // GIR_Coverage, 22330,
     /*  819547 */     GIR_EraseRootFromParent_Done,
     /*  819548 */   // Label 12665: @819548
     /*  819548 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(819623), // Rule ID 22331 //
     /*  819553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819599 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819621 */     GIR_RootConstrainSelectedInstOperands,
     /*  819622 */     // GIR_Coverage, 22331,
     /*  819622 */     GIR_EraseRootFromParent_Done,
     /*  819623 */   // Label 12666: @819623
     /*  819623 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(819698), // Rule ID 22334 //
     /*  819628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819696 */     GIR_RootConstrainSelectedInstOperands,
     /*  819697 */     // GIR_Coverage, 22334,
     /*  819697 */     GIR_EraseRootFromParent_Done,
     /*  819698 */   // Label 12667: @819698
     /*  819698 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(819773), // Rule ID 22335 //
     /*  819703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11567:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819771 */     GIR_RootConstrainSelectedInstOperands,
     /*  819772 */     // GIR_Coverage, 22335,
     /*  819772 */     GIR_EraseRootFromParent_Done,
     /*  819773 */   // Label 12668: @819773
     /*  819773 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(819848), // Rule ID 22338 //
     /*  819778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819846 */     GIR_RootConstrainSelectedInstOperands,
     /*  819847 */     // GIR_Coverage, 22338,
     /*  819847 */     GIR_EraseRootFromParent_Done,
     /*  819848 */   // Label 12669: @819848
     /*  819848 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(819923), // Rule ID 22339 //
     /*  819853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819899 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819921 */     GIR_RootConstrainSelectedInstOperands,
     /*  819922 */     // GIR_Coverage, 22339,
     /*  819922 */     GIR_EraseRootFromParent_Done,
     /*  819923 */   // Label 12670: @819923
     /*  819923 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(819998), // Rule ID 22342 //
     /*  819928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819996 */     GIR_RootConstrainSelectedInstOperands,
     /*  819997 */     // GIR_Coverage, 22342,
     /*  819997 */     GIR_EraseRootFromParent_Done,
     /*  819998 */   // Label 12671: @819998
     /*  819998 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(820073), // Rule ID 22343 //
     /*  820003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820049 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  820052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820071 */     GIR_RootConstrainSelectedInstOperands,
     /*  820072 */     // GIR_Coverage, 22343,
     /*  820072 */     GIR_EraseRootFromParent_Done,
     /*  820073 */   // Label 12672: @820073
     /*  820073 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(820148), // Rule ID 22346 //
     /*  820078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  820127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820146 */     GIR_RootConstrainSelectedInstOperands,
     /*  820147 */     // GIR_Coverage, 22346,
     /*  820147 */     GIR_EraseRootFromParent_Done,
     /*  820148 */   // Label 12673: @820148
     /*  820148 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(820223), // Rule ID 22347 //
     /*  820153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  820202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820221 */     GIR_RootConstrainSelectedInstOperands,
     /*  820222 */     // GIR_Coverage, 22347,
     /*  820222 */     GIR_EraseRootFromParent_Done,
     /*  820223 */   // Label 12674: @820223
     /*  820223 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(820298), // Rule ID 22350 //
     /*  820228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  820277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820296 */     GIR_RootConstrainSelectedInstOperands,
     /*  820297 */     // GIR_Coverage, 22350,
     /*  820297 */     GIR_EraseRootFromParent_Done,
     /*  820298 */   // Label 12675: @820298
     /*  820298 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(820373), // Rule ID 22351 //
     /*  820303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820349 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  820352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820371 */     GIR_RootConstrainSelectedInstOperands,
     /*  820372 */     // GIR_Coverage, 22351,
     /*  820372 */     GIR_EraseRootFromParent_Done,
     /*  820373 */   // Label 12676: @820373
     /*  820373 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(820448), // Rule ID 22354 //
     /*  820378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820446 */     GIR_RootConstrainSelectedInstOperands,
     /*  820447 */     // GIR_Coverage, 22354,
     /*  820447 */     GIR_EraseRootFromParent_Done,
     /*  820448 */   // Label 12677: @820448
     /*  820448 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(820523), // Rule ID 22355 //
     /*  820453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820521 */     GIR_RootConstrainSelectedInstOperands,
     /*  820522 */     // GIR_Coverage, 22355,
     /*  820522 */     GIR_EraseRootFromParent_Done,
     /*  820523 */   // Label 12678: @820523
     /*  820523 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(820598), // Rule ID 22358 //
     /*  820528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820596 */     GIR_RootConstrainSelectedInstOperands,
     /*  820597 */     // GIR_Coverage, 22358,
     /*  820597 */     GIR_EraseRootFromParent_Done,
     /*  820598 */   // Label 12679: @820598
     /*  820598 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(820673), // Rule ID 22359 //
     /*  820603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820671 */     GIR_RootConstrainSelectedInstOperands,
     /*  820672 */     // GIR_Coverage, 22359,
     /*  820672 */     GIR_EraseRootFromParent_Done,
     /*  820673 */   // Label 12680: @820673
     /*  820673 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(820748), // Rule ID 22362 //
     /*  820678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820746 */     GIR_RootConstrainSelectedInstOperands,
     /*  820747 */     // GIR_Coverage, 22362,
     /*  820747 */     GIR_EraseRootFromParent_Done,
     /*  820748 */   // Label 12681: @820748
     /*  820748 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(820823), // Rule ID 22363 //
     /*  820753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820821 */     GIR_RootConstrainSelectedInstOperands,
     /*  820822 */     // GIR_Coverage, 22363,
     /*  820822 */     GIR_EraseRootFromParent_Done,
     /*  820823 */   // Label 12682: @820823
     /*  820823 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(820898), // Rule ID 22366 //
     /*  820828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820896 */     GIR_RootConstrainSelectedInstOperands,
     /*  820897 */     // GIR_Coverage, 22366,
     /*  820897 */     GIR_EraseRootFromParent_Done,
     /*  820898 */   // Label 12683: @820898
     /*  820898 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(820973), // Rule ID 22367 //
     /*  820903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820971 */     GIR_RootConstrainSelectedInstOperands,
     /*  820972 */     // GIR_Coverage, 22367,
     /*  820972 */     GIR_EraseRootFromParent_Done,
     /*  820973 */   // Label 12684: @820973
     /*  820973 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(821048), // Rule ID 22370 //
     /*  820978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  821027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821046 */     GIR_RootConstrainSelectedInstOperands,
     /*  821047 */     // GIR_Coverage, 22370,
     /*  821047 */     GIR_EraseRootFromParent_Done,
     /*  821048 */   // Label 12685: @821048
     /*  821048 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(821123), // Rule ID 22371 //
     /*  821053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  821102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821121 */     GIR_RootConstrainSelectedInstOperands,
     /*  821122 */     // GIR_Coverage, 22371,
     /*  821122 */     GIR_EraseRootFromParent_Done,
     /*  821123 */   // Label 12686: @821123
     /*  821123 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(821198), // Rule ID 22374 //
     /*  821128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  821177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821196 */     GIR_RootConstrainSelectedInstOperands,
     /*  821197 */     // GIR_Coverage, 22374,
     /*  821197 */     GIR_EraseRootFromParent_Done,
     /*  821198 */   // Label 12687: @821198
     /*  821198 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(821273), // Rule ID 22375 //
     /*  821203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  821252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821271 */     GIR_RootConstrainSelectedInstOperands,
     /*  821272 */     // GIR_Coverage, 22375,
     /*  821272 */     GIR_EraseRootFromParent_Done,
     /*  821273 */   // Label 12688: @821273
     /*  821273 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(821348), // Rule ID 22378 //
     /*  821278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  821327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821346 */     GIR_RootConstrainSelectedInstOperands,
     /*  821347 */     // GIR_Coverage, 22378,
     /*  821347 */     GIR_EraseRootFromParent_Done,
     /*  821348 */   // Label 12689: @821348
     /*  821348 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(821423), // Rule ID 22379 //
     /*  821353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  821402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821421 */     GIR_RootConstrainSelectedInstOperands,
     /*  821422 */     // GIR_Coverage, 22379,
     /*  821422 */     GIR_EraseRootFromParent_Done,
     /*  821423 */   // Label 12690: @821423
     /*  821423 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(821498), // Rule ID 22382 //
     /*  821428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821496 */     GIR_RootConstrainSelectedInstOperands,
     /*  821497 */     // GIR_Coverage, 22382,
     /*  821497 */     GIR_EraseRootFromParent_Done,
     /*  821498 */   // Label 12691: @821498
     /*  821498 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(821573), // Rule ID 22383 //
     /*  821503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821549 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821571 */     GIR_RootConstrainSelectedInstOperands,
     /*  821572 */     // GIR_Coverage, 22383,
     /*  821572 */     GIR_EraseRootFromParent_Done,
     /*  821573 */   // Label 12692: @821573
     /*  821573 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(821648), // Rule ID 22386 //
     /*  821578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821646 */     GIR_RootConstrainSelectedInstOperands,
     /*  821647 */     // GIR_Coverage, 22386,
     /*  821647 */     GIR_EraseRootFromParent_Done,
     /*  821648 */   // Label 12693: @821648
     /*  821648 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(821723), // Rule ID 22387 //
     /*  821653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821721 */     GIR_RootConstrainSelectedInstOperands,
     /*  821722 */     // GIR_Coverage, 22387,
     /*  821722 */     GIR_EraseRootFromParent_Done,
     /*  821723 */   // Label 12694: @821723
     /*  821723 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(821798), // Rule ID 22390 //
     /*  821728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821796 */     GIR_RootConstrainSelectedInstOperands,
     /*  821797 */     // GIR_Coverage, 22390,
     /*  821797 */     GIR_EraseRootFromParent_Done,
     /*  821798 */   // Label 12695: @821798
     /*  821798 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(821873), // Rule ID 22391 //
     /*  821803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821871 */     GIR_RootConstrainSelectedInstOperands,
     /*  821872 */     // GIR_Coverage, 22391,
     /*  821872 */     GIR_EraseRootFromParent_Done,
     /*  821873 */   // Label 12696: @821873
     /*  821873 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(821948), // Rule ID 22394 //
     /*  821878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821946 */     GIR_RootConstrainSelectedInstOperands,
     /*  821947 */     // GIR_Coverage, 22394,
     /*  821947 */     GIR_EraseRootFromParent_Done,
     /*  821948 */   // Label 12697: @821948
     /*  821948 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(822023), // Rule ID 22395 //
     /*  821953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821999 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  822002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822021 */     GIR_RootConstrainSelectedInstOperands,
     /*  822022 */     // GIR_Coverage, 22395,
     /*  822022 */     GIR_EraseRootFromParent_Done,
     /*  822023 */   // Label 12698: @822023
     /*  822023 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(822098), // Rule ID 22398 //
     /*  822028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  822077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822096 */     GIR_RootConstrainSelectedInstOperands,
     /*  822097 */     // GIR_Coverage, 22398,
     /*  822097 */     GIR_EraseRootFromParent_Done,
     /*  822098 */   // Label 12699: @822098
     /*  822098 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(822173), // Rule ID 22399 //
     /*  822103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  822152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822171 */     GIR_RootConstrainSelectedInstOperands,
     /*  822172 */     // GIR_Coverage, 22399,
     /*  822172 */     GIR_EraseRootFromParent_Done,
     /*  822173 */   // Label 12700: @822173
     /*  822173 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(822248), // Rule ID 22402 //
     /*  822178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  822227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822246 */     GIR_RootConstrainSelectedInstOperands,
     /*  822247 */     // GIR_Coverage, 22402,
     /*  822247 */     GIR_EraseRootFromParent_Done,
     /*  822248 */   // Label 12701: @822248
     /*  822248 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(822323), // Rule ID 22403 //
     /*  822253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  822302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822321 */     GIR_RootConstrainSelectedInstOperands,
     /*  822322 */     // GIR_Coverage, 22403,
     /*  822322 */     GIR_EraseRootFromParent_Done,
     /*  822323 */   // Label 12702: @822323
     /*  822323 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(822398), // Rule ID 22406 //
     /*  822328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  822377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822396 */     GIR_RootConstrainSelectedInstOperands,
     /*  822397 */     // GIR_Coverage, 22406,
     /*  822397 */     GIR_EraseRootFromParent_Done,
     /*  822398 */   // Label 12703: @822398
     /*  822398 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(822473), // Rule ID 22407 //
     /*  822403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  822452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822471 */     GIR_RootConstrainSelectedInstOperands,
     /*  822472 */     // GIR_Coverage, 22407,
     /*  822472 */     GIR_EraseRootFromParent_Done,
     /*  822473 */   // Label 12704: @822473
     /*  822473 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(822548), // Rule ID 22410 //
     /*  822478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822546 */     GIR_RootConstrainSelectedInstOperands,
     /*  822547 */     // GIR_Coverage, 22410,
     /*  822547 */     GIR_EraseRootFromParent_Done,
     /*  822548 */   // Label 12705: @822548
     /*  822548 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(822623), // Rule ID 22411 //
     /*  822553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822621 */     GIR_RootConstrainSelectedInstOperands,
     /*  822622 */     // GIR_Coverage, 22411,
     /*  822622 */     GIR_EraseRootFromParent_Done,
     /*  822623 */   // Label 12706: @822623
     /*  822623 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(822698), // Rule ID 22414 //
     /*  822628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822696 */     GIR_RootConstrainSelectedInstOperands,
     /*  822697 */     // GIR_Coverage, 22414,
     /*  822697 */     GIR_EraseRootFromParent_Done,
     /*  822698 */   // Label 12707: @822698
     /*  822698 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(822773), // Rule ID 22415 //
     /*  822703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822771 */     GIR_RootConstrainSelectedInstOperands,
     /*  822772 */     // GIR_Coverage, 22415,
     /*  822772 */     GIR_EraseRootFromParent_Done,
     /*  822773 */   // Label 12708: @822773
     /*  822773 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(822848), // Rule ID 22418 //
     /*  822778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822846 */     GIR_RootConstrainSelectedInstOperands,
     /*  822847 */     // GIR_Coverage, 22418,
     /*  822847 */     GIR_EraseRootFromParent_Done,
     /*  822848 */   // Label 12709: @822848
     /*  822848 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(822923), // Rule ID 22419 //
     /*  822853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822921 */     GIR_RootConstrainSelectedInstOperands,
     /*  822922 */     // GIR_Coverage, 22419,
     /*  822922 */     GIR_EraseRootFromParent_Done,
     /*  822923 */   // Label 12710: @822923
     /*  822923 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(822998), // Rule ID 22422 //
     /*  822928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822996 */     GIR_RootConstrainSelectedInstOperands,
     /*  822997 */     // GIR_Coverage, 22422,
     /*  822997 */     GIR_EraseRootFromParent_Done,
     /*  822998 */   // Label 12711: @822998
     /*  822998 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(823073), // Rule ID 22423 //
     /*  823003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  823049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  823052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823071 */     GIR_RootConstrainSelectedInstOperands,
     /*  823072 */     // GIR_Coverage, 22423,
     /*  823072 */     GIR_EraseRootFromParent_Done,
     /*  823073 */   // Label 12712: @823073
     /*  823073 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(823148), // Rule ID 22426 //
     /*  823078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  823127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823146 */     GIR_RootConstrainSelectedInstOperands,
     /*  823147 */     // GIR_Coverage, 22426,
     /*  823147 */     GIR_EraseRootFromParent_Done,
     /*  823148 */   // Label 12713: @823148
     /*  823148 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(823223), // Rule ID 22427 //
     /*  823153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  823202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823221 */     GIR_RootConstrainSelectedInstOperands,
     /*  823222 */     // GIR_Coverage, 22427,
     /*  823222 */     GIR_EraseRootFromParent_Done,
     /*  823223 */   // Label 12714: @823223
     /*  823223 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(823298), // Rule ID 22430 //
     /*  823228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  823277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823296 */     GIR_RootConstrainSelectedInstOperands,
     /*  823297 */     // GIR_Coverage, 22430,
     /*  823297 */     GIR_EraseRootFromParent_Done,
     /*  823298 */   // Label 12715: @823298
     /*  823298 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(823373), // Rule ID 22431 //
     /*  823303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823349 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  823352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823371 */     GIR_RootConstrainSelectedInstOperands,
     /*  823372 */     // GIR_Coverage, 22431,
     /*  823372 */     GIR_EraseRootFromParent_Done,
     /*  823373 */   // Label 12716: @823373
     /*  823373 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(823448), // Rule ID 22434 //
     /*  823378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823446 */     GIR_RootConstrainSelectedInstOperands,
     /*  823447 */     // GIR_Coverage, 22434,
     /*  823447 */     GIR_EraseRootFromParent_Done,
     /*  823448 */   // Label 12717: @823448
     /*  823448 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(823523), // Rule ID 22435 //
     /*  823453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823521 */     GIR_RootConstrainSelectedInstOperands,
     /*  823522 */     // GIR_Coverage, 22435,
     /*  823522 */     GIR_EraseRootFromParent_Done,
     /*  823523 */   // Label 12718: @823523
     /*  823523 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(823598), // Rule ID 22438 //
     /*  823528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823596 */     GIR_RootConstrainSelectedInstOperands,
     /*  823597 */     // GIR_Coverage, 22438,
     /*  823597 */     GIR_EraseRootFromParent_Done,
     /*  823598 */   // Label 12719: @823598
     /*  823598 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(823673), // Rule ID 22439 //
     /*  823603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823671 */     GIR_RootConstrainSelectedInstOperands,
     /*  823672 */     // GIR_Coverage, 22439,
     /*  823672 */     GIR_EraseRootFromParent_Done,
     /*  823673 */   // Label 12720: @823673
     /*  823673 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(823748), // Rule ID 22442 //
     /*  823678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823746 */     GIR_RootConstrainSelectedInstOperands,
     /*  823747 */     // GIR_Coverage, 22442,
     /*  823747 */     GIR_EraseRootFromParent_Done,
     /*  823748 */   // Label 12721: @823748
     /*  823748 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(823823), // Rule ID 22443 //
     /*  823753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823821 */     GIR_RootConstrainSelectedInstOperands,
     /*  823822 */     // GIR_Coverage, 22443,
     /*  823822 */     GIR_EraseRootFromParent_Done,
     /*  823823 */   // Label 12722: @823823
     /*  823823 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(823898), // Rule ID 22446 //
     /*  823828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823896 */     GIR_RootConstrainSelectedInstOperands,
     /*  823897 */     // GIR_Coverage, 22446,
     /*  823897 */     GIR_EraseRootFromParent_Done,
     /*  823898 */   // Label 12723: @823898
     /*  823898 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(823973), // Rule ID 22447 //
     /*  823903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823949 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823971 */     GIR_RootConstrainSelectedInstOperands,
     /*  823972 */     // GIR_Coverage, 22447,
     /*  823972 */     GIR_EraseRootFromParent_Done,
     /*  823973 */   // Label 12724: @823973
     /*  823973 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(824048), // Rule ID 22450 //
     /*  823978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  824027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824046 */     GIR_RootConstrainSelectedInstOperands,
     /*  824047 */     // GIR_Coverage, 22450,
     /*  824047 */     GIR_EraseRootFromParent_Done,
     /*  824048 */   // Label 12725: @824048
     /*  824048 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(824123), // Rule ID 22451 //
     /*  824053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  824102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824121 */     GIR_RootConstrainSelectedInstOperands,
     /*  824122 */     // GIR_Coverage, 22451,
     /*  824122 */     GIR_EraseRootFromParent_Done,
     /*  824123 */   // Label 12726: @824123
     /*  824123 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(824198), // Rule ID 22454 //
     /*  824128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  824177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824196 */     GIR_RootConstrainSelectedInstOperands,
     /*  824197 */     // GIR_Coverage, 22454,
     /*  824197 */     GIR_EraseRootFromParent_Done,
     /*  824198 */   // Label 12727: @824198
     /*  824198 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(824273), // Rule ID 22455 //
     /*  824203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  824252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824271 */     GIR_RootConstrainSelectedInstOperands,
     /*  824272 */     // GIR_Coverage, 22455,
     /*  824272 */     GIR_EraseRootFromParent_Done,
     /*  824273 */   // Label 12728: @824273
     /*  824273 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(824348), // Rule ID 22458 //
     /*  824278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  824327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824346 */     GIR_RootConstrainSelectedInstOperands,
     /*  824347 */     // GIR_Coverage, 22458,
     /*  824347 */     GIR_EraseRootFromParent_Done,
     /*  824348 */   // Label 12729: @824348
     /*  824348 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(824423), // Rule ID 22459 //
     /*  824353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  824402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824421 */     GIR_RootConstrainSelectedInstOperands,
     /*  824422 */     // GIR_Coverage, 22459,
     /*  824422 */     GIR_EraseRootFromParent_Done,
     /*  824423 */   // Label 12730: @824423
     /*  824423 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(824498), // Rule ID 22462 //
     /*  824428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824496 */     GIR_RootConstrainSelectedInstOperands,
     /*  824497 */     // GIR_Coverage, 22462,
     /*  824497 */     GIR_EraseRootFromParent_Done,
     /*  824498 */   // Label 12731: @824498
     /*  824498 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(824573), // Rule ID 22463 //
     /*  824503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824571 */     GIR_RootConstrainSelectedInstOperands,
     /*  824572 */     // GIR_Coverage, 22463,
     /*  824572 */     GIR_EraseRootFromParent_Done,
     /*  824573 */   // Label 12732: @824573
     /*  824573 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(824648), // Rule ID 22466 //
     /*  824578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824646 */     GIR_RootConstrainSelectedInstOperands,
     /*  824647 */     // GIR_Coverage, 22466,
     /*  824647 */     GIR_EraseRootFromParent_Done,
     /*  824648 */   // Label 12733: @824648
     /*  824648 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(824723), // Rule ID 22467 //
     /*  824653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824721 */     GIR_RootConstrainSelectedInstOperands,
     /*  824722 */     // GIR_Coverage, 22467,
     /*  824722 */     GIR_EraseRootFromParent_Done,
     /*  824723 */   // Label 12734: @824723
     /*  824723 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(824798), // Rule ID 22470 //
     /*  824728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824774 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824796 */     GIR_RootConstrainSelectedInstOperands,
     /*  824797 */     // GIR_Coverage, 22470,
     /*  824797 */     GIR_EraseRootFromParent_Done,
     /*  824798 */   // Label 12735: @824798
     /*  824798 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(824873), // Rule ID 22471 //
     /*  824803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824849 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824871 */     GIR_RootConstrainSelectedInstOperands,
     /*  824872 */     // GIR_Coverage, 22471,
     /*  824872 */     GIR_EraseRootFromParent_Done,
     /*  824873 */   // Label 12736: @824873
     /*  824873 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(824948), // Rule ID 22474 //
     /*  824878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824946 */     GIR_RootConstrainSelectedInstOperands,
     /*  824947 */     // GIR_Coverage, 22474,
     /*  824947 */     GIR_EraseRootFromParent_Done,
     /*  824948 */   // Label 12737: @824948
     /*  824948 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(825023), // Rule ID 22475 //
     /*  824953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  825002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825021 */     GIR_RootConstrainSelectedInstOperands,
     /*  825022 */     // GIR_Coverage, 22475,
     /*  825022 */     GIR_EraseRootFromParent_Done,
     /*  825023 */   // Label 12738: @825023
     /*  825023 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(825098), // Rule ID 22478 //
     /*  825028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  825077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825096 */     GIR_RootConstrainSelectedInstOperands,
     /*  825097 */     // GIR_Coverage, 22478,
     /*  825097 */     GIR_EraseRootFromParent_Done,
     /*  825098 */   // Label 12739: @825098
     /*  825098 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(825173), // Rule ID 22479 //
     /*  825103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  825152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825171 */     GIR_RootConstrainSelectedInstOperands,
     /*  825172 */     // GIR_Coverage, 22479,
     /*  825172 */     GIR_EraseRootFromParent_Done,
     /*  825173 */   // Label 12740: @825173
     /*  825173 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(825248), // Rule ID 22482 //
     /*  825178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  825227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825246 */     GIR_RootConstrainSelectedInstOperands,
     /*  825247 */     // GIR_Coverage, 22482,
     /*  825247 */     GIR_EraseRootFromParent_Done,
     /*  825248 */   // Label 12741: @825248
     /*  825248 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(825323), // Rule ID 22483 //
     /*  825253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  825302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825321 */     GIR_RootConstrainSelectedInstOperands,
     /*  825322 */     // GIR_Coverage, 22483,
     /*  825322 */     GIR_EraseRootFromParent_Done,
     /*  825323 */   // Label 12742: @825323
     /*  825323 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(825398), // Rule ID 22486 //
     /*  825328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  825377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825396 */     GIR_RootConstrainSelectedInstOperands,
     /*  825397 */     // GIR_Coverage, 22486,
     /*  825397 */     GIR_EraseRootFromParent_Done,
     /*  825398 */   // Label 12743: @825398
     /*  825398 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(825473), // Rule ID 22487 //
     /*  825403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  825452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825471 */     GIR_RootConstrainSelectedInstOperands,
     /*  825472 */     // GIR_Coverage, 22487,
     /*  825472 */     GIR_EraseRootFromParent_Done,
     /*  825473 */   // Label 12744: @825473
     /*  825473 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(825548), // Rule ID 22490 //
     /*  825478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825546 */     GIR_RootConstrainSelectedInstOperands,
     /*  825547 */     // GIR_Coverage, 22490,
     /*  825547 */     GIR_EraseRootFromParent_Done,
     /*  825548 */   // Label 12745: @825548
     /*  825548 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(825623), // Rule ID 22491 //
     /*  825553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825621 */     GIR_RootConstrainSelectedInstOperands,
     /*  825622 */     // GIR_Coverage, 22491,
     /*  825622 */     GIR_EraseRootFromParent_Done,
     /*  825623 */   // Label 12746: @825623
     /*  825623 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(825698), // Rule ID 22494 //
     /*  825628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825696 */     GIR_RootConstrainSelectedInstOperands,
     /*  825697 */     // GIR_Coverage, 22494,
     /*  825697 */     GIR_EraseRootFromParent_Done,
     /*  825698 */   // Label 12747: @825698
     /*  825698 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(825773), // Rule ID 22495 //
     /*  825703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825749 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825771 */     GIR_RootConstrainSelectedInstOperands,
     /*  825772 */     // GIR_Coverage, 22495,
     /*  825772 */     GIR_EraseRootFromParent_Done,
     /*  825773 */   // Label 12748: @825773
     /*  825773 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(825848), // Rule ID 22498 //
     /*  825778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825846 */     GIR_RootConstrainSelectedInstOperands,
     /*  825847 */     // GIR_Coverage, 22498,
     /*  825847 */     GIR_EraseRootFromParent_Done,
     /*  825848 */   // Label 12749: @825848
     /*  825848 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(825923), // Rule ID 22499 //
     /*  825853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825921 */     GIR_RootConstrainSelectedInstOperands,
     /*  825922 */     // GIR_Coverage, 22499,
     /*  825922 */     GIR_EraseRootFromParent_Done,
     /*  825923 */   // Label 12750: @825923
     /*  825923 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(825998), // Rule ID 22502 //
     /*  825928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825996 */     GIR_RootConstrainSelectedInstOperands,
     /*  825997 */     // GIR_Coverage, 22502,
     /*  825997 */     GIR_EraseRootFromParent_Done,
     /*  825998 */   // Label 12751: @825998
     /*  825998 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(826073), // Rule ID 22503 //
     /*  826003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  826052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826071 */     GIR_RootConstrainSelectedInstOperands,
     /*  826072 */     // GIR_Coverage, 22503,
     /*  826072 */     GIR_EraseRootFromParent_Done,
     /*  826073 */   // Label 12752: @826073
     /*  826073 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(826148), // Rule ID 22506 //
     /*  826078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  826127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826146 */     GIR_RootConstrainSelectedInstOperands,
     /*  826147 */     // GIR_Coverage, 22506,
     /*  826147 */     GIR_EraseRootFromParent_Done,
     /*  826148 */   // Label 12753: @826148
     /*  826148 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(826223), // Rule ID 22507 //
     /*  826153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826199 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  826202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826221 */     GIR_RootConstrainSelectedInstOperands,
     /*  826222 */     // GIR_Coverage, 22507,
     /*  826222 */     GIR_EraseRootFromParent_Done,
     /*  826223 */   // Label 12754: @826223
     /*  826223 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(826298), // Rule ID 22510 //
     /*  826228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  826277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826296 */     GIR_RootConstrainSelectedInstOperands,
     /*  826297 */     // GIR_Coverage, 22510,
     /*  826297 */     GIR_EraseRootFromParent_Done,
     /*  826298 */   // Label 12755: @826298
     /*  826298 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(826373), // Rule ID 22511 //
     /*  826303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  826352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826371 */     GIR_RootConstrainSelectedInstOperands,
     /*  826372 */     // GIR_Coverage, 22511,
     /*  826372 */     GIR_EraseRootFromParent_Done,
     /*  826373 */   // Label 12756: @826373
     /*  826373 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(826448), // Rule ID 22514 //
     /*  826378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826446 */     GIR_RootConstrainSelectedInstOperands,
     /*  826447 */     // GIR_Coverage, 22514,
     /*  826447 */     GIR_EraseRootFromParent_Done,
     /*  826448 */   // Label 12757: @826448
     /*  826448 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(826523), // Rule ID 22515 //
     /*  826453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826521 */     GIR_RootConstrainSelectedInstOperands,
     /*  826522 */     // GIR_Coverage, 22515,
     /*  826522 */     GIR_EraseRootFromParent_Done,
     /*  826523 */   // Label 12758: @826523
     /*  826523 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(826598), // Rule ID 22518 //
     /*  826528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826574 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826596 */     GIR_RootConstrainSelectedInstOperands,
     /*  826597 */     // GIR_Coverage, 22518,
     /*  826597 */     GIR_EraseRootFromParent_Done,
     /*  826598 */   // Label 12759: @826598
     /*  826598 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(826673), // Rule ID 22519 //
     /*  826603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826649 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826671 */     GIR_RootConstrainSelectedInstOperands,
     /*  826672 */     // GIR_Coverage, 22519,
     /*  826672 */     GIR_EraseRootFromParent_Done,
     /*  826673 */   // Label 12760: @826673
     /*  826673 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(826748), // Rule ID 22522 //
     /*  826678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826746 */     GIR_RootConstrainSelectedInstOperands,
     /*  826747 */     // GIR_Coverage, 22522,
     /*  826747 */     GIR_EraseRootFromParent_Done,
     /*  826748 */   // Label 12761: @826748
     /*  826748 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(826823), // Rule ID 22523 //
     /*  826753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826821 */     GIR_RootConstrainSelectedInstOperands,
     /*  826822 */     // GIR_Coverage, 22523,
     /*  826822 */     GIR_EraseRootFromParent_Done,
     /*  826823 */   // Label 12762: @826823
     /*  826823 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(826898), // Rule ID 22526 //
     /*  826828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826896 */     GIR_RootConstrainSelectedInstOperands,
     /*  826897 */     // GIR_Coverage, 22526,
     /*  826897 */     GIR_EraseRootFromParent_Done,
     /*  826898 */   // Label 12763: @826898
     /*  826898 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(826973), // Rule ID 22527 //
     /*  826903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826971 */     GIR_RootConstrainSelectedInstOperands,
     /*  826972 */     // GIR_Coverage, 22527,
     /*  826972 */     GIR_EraseRootFromParent_Done,
     /*  826973 */   // Label 12764: @826973
     /*  826973 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(827048), // Rule ID 22530 //
     /*  826978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  827027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827046 */     GIR_RootConstrainSelectedInstOperands,
     /*  827047 */     // GIR_Coverage, 22530,
     /*  827047 */     GIR_EraseRootFromParent_Done,
     /*  827048 */   // Label 12765: @827048
     /*  827048 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(827123), // Rule ID 22531 //
     /*  827053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827099 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  827102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827121 */     GIR_RootConstrainSelectedInstOperands,
     /*  827122 */     // GIR_Coverage, 22531,
     /*  827122 */     GIR_EraseRootFromParent_Done,
     /*  827123 */   // Label 12766: @827123
     /*  827123 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(827198), // Rule ID 22534 //
     /*  827128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  827177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827196 */     GIR_RootConstrainSelectedInstOperands,
     /*  827197 */     // GIR_Coverage, 22534,
     /*  827197 */     GIR_EraseRootFromParent_Done,
     /*  827198 */   // Label 12767: @827198
     /*  827198 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(827273), // Rule ID 22535 //
     /*  827203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  827252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827271 */     GIR_RootConstrainSelectedInstOperands,
     /*  827272 */     // GIR_Coverage, 22535,
     /*  827272 */     GIR_EraseRootFromParent_Done,
     /*  827273 */   // Label 12768: @827273
     /*  827273 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(827348), // Rule ID 22538 //
     /*  827278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  827327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827346 */     GIR_RootConstrainSelectedInstOperands,
     /*  827347 */     // GIR_Coverage, 22538,
     /*  827347 */     GIR_EraseRootFromParent_Done,
     /*  827348 */   // Label 12769: @827348
     /*  827348 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(827423), // Rule ID 22539 //
     /*  827353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  827402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827421 */     GIR_RootConstrainSelectedInstOperands,
     /*  827422 */     // GIR_Coverage, 22539,
     /*  827422 */     GIR_EraseRootFromParent_Done,
     /*  827423 */   // Label 12770: @827423
     /*  827423 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(827498), // Rule ID 22542 //
     /*  827428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827496 */     GIR_RootConstrainSelectedInstOperands,
     /*  827497 */     // GIR_Coverage, 22542,
     /*  827497 */     GIR_EraseRootFromParent_Done,
     /*  827498 */   // Label 12771: @827498
     /*  827498 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(827573), // Rule ID 22543 //
     /*  827503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827571 */     GIR_RootConstrainSelectedInstOperands,
     /*  827572 */     // GIR_Coverage, 22543,
     /*  827572 */     GIR_EraseRootFromParent_Done,
     /*  827573 */   // Label 12772: @827573
     /*  827573 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(827648), // Rule ID 22546 //
     /*  827578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827646 */     GIR_RootConstrainSelectedInstOperands,
     /*  827647 */     // GIR_Coverage, 22546,
     /*  827647 */     GIR_EraseRootFromParent_Done,
     /*  827648 */   // Label 12773: @827648
     /*  827648 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(827723), // Rule ID 22547 //
     /*  827653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827721 */     GIR_RootConstrainSelectedInstOperands,
     /*  827722 */     // GIR_Coverage, 22547,
     /*  827722 */     GIR_EraseRootFromParent_Done,
     /*  827723 */   // Label 12774: @827723
     /*  827723 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(827798), // Rule ID 22550 //
     /*  827728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827796 */     GIR_RootConstrainSelectedInstOperands,
     /*  827797 */     // GIR_Coverage, 22550,
     /*  827797 */     GIR_EraseRootFromParent_Done,
     /*  827798 */   // Label 12775: @827798
     /*  827798 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(827873), // Rule ID 22551 //
     /*  827803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827871 */     GIR_RootConstrainSelectedInstOperands,
     /*  827872 */     // GIR_Coverage, 22551,
     /*  827872 */     GIR_EraseRootFromParent_Done,
     /*  827873 */   // Label 12776: @827873
     /*  827873 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(827948), // Rule ID 22554 //
     /*  827878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827946 */     GIR_RootConstrainSelectedInstOperands,
     /*  827947 */     // GIR_Coverage, 22554,
     /*  827947 */     GIR_EraseRootFromParent_Done,
     /*  827948 */   // Label 12777: @827948
     /*  827948 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(828023), // Rule ID 22555 //
     /*  827953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  828002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828021 */     GIR_RootConstrainSelectedInstOperands,
     /*  828022 */     // GIR_Coverage, 22555,
     /*  828022 */     GIR_EraseRootFromParent_Done,
     /*  828023 */   // Label 12778: @828023
     /*  828023 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(828098), // Rule ID 22558 //
     /*  828028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  828077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828096 */     GIR_RootConstrainSelectedInstOperands,
     /*  828097 */     // GIR_Coverage, 22558,
     /*  828097 */     GIR_EraseRootFromParent_Done,
     /*  828098 */   // Label 12779: @828098
     /*  828098 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(828173), // Rule ID 22559 //
     /*  828103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828149 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  828152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828171 */     GIR_RootConstrainSelectedInstOperands,
     /*  828172 */     // GIR_Coverage, 22559,
     /*  828172 */     GIR_EraseRootFromParent_Done,
     /*  828173 */   // Label 12780: @828173
     /*  828173 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(828248), // Rule ID 22562 //
     /*  828178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  828227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828246 */     GIR_RootConstrainSelectedInstOperands,
     /*  828247 */     // GIR_Coverage, 22562,
     /*  828247 */     GIR_EraseRootFromParent_Done,
     /*  828248 */   // Label 12781: @828248
     /*  828248 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(828323), // Rule ID 22563 //
     /*  828253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  828302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828321 */     GIR_RootConstrainSelectedInstOperands,
     /*  828322 */     // GIR_Coverage, 22563,
     /*  828322 */     GIR_EraseRootFromParent_Done,
     /*  828323 */   // Label 12782: @828323
     /*  828323 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(828398), // Rule ID 22566 //
     /*  828328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  828377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828396 */     GIR_RootConstrainSelectedInstOperands,
     /*  828397 */     // GIR_Coverage, 22566,
     /*  828397 */     GIR_EraseRootFromParent_Done,
     /*  828398 */   // Label 12783: @828398
     /*  828398 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(828473), // Rule ID 22567 //
     /*  828403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  828452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828471 */     GIR_RootConstrainSelectedInstOperands,
     /*  828472 */     // GIR_Coverage, 22567,
     /*  828472 */     GIR_EraseRootFromParent_Done,
     /*  828473 */   // Label 12784: @828473
     /*  828473 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(828548), // Rule ID 22570 //
     /*  828478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828546 */     GIR_RootConstrainSelectedInstOperands,
     /*  828547 */     // GIR_Coverage, 22570,
     /*  828547 */     GIR_EraseRootFromParent_Done,
     /*  828548 */   // Label 12785: @828548
     /*  828548 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(828623), // Rule ID 22571 //
     /*  828553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828621 */     GIR_RootConstrainSelectedInstOperands,
     /*  828622 */     // GIR_Coverage, 22571,
     /*  828622 */     GIR_EraseRootFromParent_Done,
     /*  828623 */   // Label 12786: @828623
     /*  828623 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(828698), // Rule ID 22574 //
     /*  828628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828696 */     GIR_RootConstrainSelectedInstOperands,
     /*  828697 */     // GIR_Coverage, 22574,
     /*  828697 */     GIR_EraseRootFromParent_Done,
     /*  828698 */   // Label 12787: @828698
     /*  828698 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(828773), // Rule ID 22575 //
     /*  828703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828771 */     GIR_RootConstrainSelectedInstOperands,
     /*  828772 */     // GIR_Coverage, 22575,
     /*  828772 */     GIR_EraseRootFromParent_Done,
     /*  828773 */   // Label 12788: @828773
     /*  828773 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(828848), // Rule ID 22578 //
     /*  828778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828846 */     GIR_RootConstrainSelectedInstOperands,
     /*  828847 */     // GIR_Coverage, 22578,
     /*  828847 */     GIR_EraseRootFromParent_Done,
     /*  828848 */   // Label 12789: @828848
     /*  828848 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(828923), // Rule ID 22579 //
     /*  828853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828921 */     GIR_RootConstrainSelectedInstOperands,
     /*  828922 */     // GIR_Coverage, 22579,
     /*  828922 */     GIR_EraseRootFromParent_Done,
     /*  828923 */   // Label 12790: @828923
     /*  828923 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(828998), // Rule ID 22582 //
     /*  828928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828996 */     GIR_RootConstrainSelectedInstOperands,
     /*  828997 */     // GIR_Coverage, 22582,
     /*  828997 */     GIR_EraseRootFromParent_Done,
     /*  828998 */   // Label 12791: @828998
     /*  828998 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(829073), // Rule ID 22583 //
     /*  829003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  829052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829071 */     GIR_RootConstrainSelectedInstOperands,
     /*  829072 */     // GIR_Coverage, 22583,
     /*  829072 */     GIR_EraseRootFromParent_Done,
     /*  829073 */   // Label 12792: @829073
     /*  829073 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(829148), // Rule ID 22586 //
     /*  829078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  829127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829146 */     GIR_RootConstrainSelectedInstOperands,
     /*  829147 */     // GIR_Coverage, 22586,
     /*  829147 */     GIR_EraseRootFromParent_Done,
     /*  829148 */   // Label 12793: @829148
     /*  829148 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(829223), // Rule ID 22587 //
     /*  829153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  829202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829221 */     GIR_RootConstrainSelectedInstOperands,
     /*  829222 */     // GIR_Coverage, 22587,
     /*  829222 */     GIR_EraseRootFromParent_Done,
     /*  829223 */   // Label 12794: @829223
     /*  829223 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(829298), // Rule ID 22590 //
     /*  829228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  829277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829296 */     GIR_RootConstrainSelectedInstOperands,
     /*  829297 */     // GIR_Coverage, 22590,
     /*  829297 */     GIR_EraseRootFromParent_Done,
     /*  829298 */   // Label 12795: @829298
     /*  829298 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(829373), // Rule ID 22591 //
     /*  829303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  829352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829371 */     GIR_RootConstrainSelectedInstOperands,
     /*  829372 */     // GIR_Coverage, 22591,
     /*  829372 */     GIR_EraseRootFromParent_Done,
     /*  829373 */   // Label 12796: @829373
     /*  829373 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(829448), // Rule ID 22594 //
     /*  829378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829446 */     GIR_RootConstrainSelectedInstOperands,
     /*  829447 */     // GIR_Coverage, 22594,
     /*  829447 */     GIR_EraseRootFromParent_Done,
     /*  829448 */   // Label 12797: @829448
     /*  829448 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(829523), // Rule ID 22595 //
     /*  829453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829521 */     GIR_RootConstrainSelectedInstOperands,
     /*  829522 */     // GIR_Coverage, 22595,
     /*  829522 */     GIR_EraseRootFromParent_Done,
     /*  829523 */   // Label 12798: @829523
     /*  829523 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(829598), // Rule ID 22598 //
     /*  829528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829596 */     GIR_RootConstrainSelectedInstOperands,
     /*  829597 */     // GIR_Coverage, 22598,
     /*  829597 */     GIR_EraseRootFromParent_Done,
     /*  829598 */   // Label 12799: @829598
     /*  829598 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(829673), // Rule ID 22599 //
     /*  829603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829671 */     GIR_RootConstrainSelectedInstOperands,
     /*  829672 */     // GIR_Coverage, 22599,
     /*  829672 */     GIR_EraseRootFromParent_Done,
     /*  829673 */   // Label 12800: @829673
     /*  829673 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(829748), // Rule ID 22602 //
     /*  829678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829746 */     GIR_RootConstrainSelectedInstOperands,
     /*  829747 */     // GIR_Coverage, 22602,
     /*  829747 */     GIR_EraseRootFromParent_Done,
     /*  829748 */   // Label 12801: @829748
     /*  829748 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(829823), // Rule ID 22603 //
     /*  829753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829821 */     GIR_RootConstrainSelectedInstOperands,
     /*  829822 */     // GIR_Coverage, 22603,
     /*  829822 */     GIR_EraseRootFromParent_Done,
     /*  829823 */   // Label 12802: @829823
     /*  829823 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(829898), // Rule ID 22606 //
     /*  829828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829896 */     GIR_RootConstrainSelectedInstOperands,
     /*  829897 */     // GIR_Coverage, 22606,
     /*  829897 */     GIR_EraseRootFromParent_Done,
     /*  829898 */   // Label 12803: @829898
     /*  829898 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(829973), // Rule ID 22607 //
     /*  829903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829949 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829971 */     GIR_RootConstrainSelectedInstOperands,
     /*  829972 */     // GIR_Coverage, 22607,
     /*  829972 */     GIR_EraseRootFromParent_Done,
     /*  829973 */   // Label 12804: @829973
     /*  829973 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(830048), // Rule ID 22610 //
     /*  829978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  830027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830046 */     GIR_RootConstrainSelectedInstOperands,
     /*  830047 */     // GIR_Coverage, 22610,
     /*  830047 */     GIR_EraseRootFromParent_Done,
     /*  830048 */   // Label 12805: @830048
     /*  830048 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(830123), // Rule ID 22611 //
     /*  830053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  830102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830121 */     GIR_RootConstrainSelectedInstOperands,
     /*  830122 */     // GIR_Coverage, 22611,
     /*  830122 */     GIR_EraseRootFromParent_Done,
     /*  830123 */   // Label 12806: @830123
     /*  830123 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(830198), // Rule ID 22614 //
     /*  830128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  830177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830196 */     GIR_RootConstrainSelectedInstOperands,
     /*  830197 */     // GIR_Coverage, 22614,
     /*  830197 */     GIR_EraseRootFromParent_Done,
     /*  830198 */   // Label 12807: @830198
     /*  830198 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(830273), // Rule ID 22615 //
     /*  830203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  830252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830271 */     GIR_RootConstrainSelectedInstOperands,
     /*  830272 */     // GIR_Coverage, 22615,
     /*  830272 */     GIR_EraseRootFromParent_Done,
     /*  830273 */   // Label 12808: @830273
     /*  830273 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(830348), // Rule ID 22618 //
     /*  830278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  830327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830346 */     GIR_RootConstrainSelectedInstOperands,
     /*  830347 */     // GIR_Coverage, 22618,
     /*  830347 */     GIR_EraseRootFromParent_Done,
     /*  830348 */   // Label 12809: @830348
     /*  830348 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(830423), // Rule ID 22619 //
     /*  830353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  830402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830421 */     GIR_RootConstrainSelectedInstOperands,
     /*  830422 */     // GIR_Coverage, 22619,
     /*  830422 */     GIR_EraseRootFromParent_Done,
     /*  830423 */   // Label 12810: @830423
     /*  830423 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(830498), // Rule ID 22622 //
     /*  830428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830496 */     GIR_RootConstrainSelectedInstOperands,
     /*  830497 */     // GIR_Coverage, 22622,
     /*  830497 */     GIR_EraseRootFromParent_Done,
     /*  830498 */   // Label 12811: @830498
     /*  830498 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(830573), // Rule ID 22623 //
     /*  830503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830571 */     GIR_RootConstrainSelectedInstOperands,
     /*  830572 */     // GIR_Coverage, 22623,
     /*  830572 */     GIR_EraseRootFromParent_Done,
     /*  830573 */   // Label 12812: @830573
     /*  830573 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(830648), // Rule ID 22626 //
     /*  830578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830646 */     GIR_RootConstrainSelectedInstOperands,
     /*  830647 */     // GIR_Coverage, 22626,
     /*  830647 */     GIR_EraseRootFromParent_Done,
     /*  830648 */   // Label 12813: @830648
     /*  830648 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(830723), // Rule ID 22627 //
     /*  830653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830721 */     GIR_RootConstrainSelectedInstOperands,
     /*  830722 */     // GIR_Coverage, 22627,
     /*  830722 */     GIR_EraseRootFromParent_Done,
     /*  830723 */   // Label 12814: @830723
     /*  830723 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(830798), // Rule ID 22630 //
     /*  830728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830796 */     GIR_RootConstrainSelectedInstOperands,
     /*  830797 */     // GIR_Coverage, 22630,
     /*  830797 */     GIR_EraseRootFromParent_Done,
     /*  830798 */   // Label 12815: @830798
     /*  830798 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(830873), // Rule ID 22631 //
     /*  830803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830871 */     GIR_RootConstrainSelectedInstOperands,
     /*  830872 */     // GIR_Coverage, 22631,
     /*  830872 */     GIR_EraseRootFromParent_Done,
     /*  830873 */   // Label 12816: @830873
     /*  830873 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(830948), // Rule ID 22634 //
     /*  830878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830946 */     GIR_RootConstrainSelectedInstOperands,
     /*  830947 */     // GIR_Coverage, 22634,
     /*  830947 */     GIR_EraseRootFromParent_Done,
     /*  830948 */   // Label 12817: @830948
     /*  830948 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(831023), // Rule ID 22635 //
     /*  830953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  831002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831021 */     GIR_RootConstrainSelectedInstOperands,
     /*  831022 */     // GIR_Coverage, 22635,
     /*  831022 */     GIR_EraseRootFromParent_Done,
     /*  831023 */   // Label 12818: @831023
     /*  831023 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(831098), // Rule ID 22638 //
     /*  831028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  831077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831096 */     GIR_RootConstrainSelectedInstOperands,
     /*  831097 */     // GIR_Coverage, 22638,
     /*  831097 */     GIR_EraseRootFromParent_Done,
     /*  831098 */   // Label 12819: @831098
     /*  831098 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(831173), // Rule ID 22639 //
     /*  831103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  831152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831171 */     GIR_RootConstrainSelectedInstOperands,
     /*  831172 */     // GIR_Coverage, 22639,
     /*  831172 */     GIR_EraseRootFromParent_Done,
     /*  831173 */   // Label 12820: @831173
     /*  831173 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(831248), // Rule ID 22642 //
     /*  831178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  831227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831246 */     GIR_RootConstrainSelectedInstOperands,
     /*  831247 */     // GIR_Coverage, 22642,
     /*  831247 */     GIR_EraseRootFromParent_Done,
     /*  831248 */   // Label 12821: @831248
     /*  831248 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(831323), // Rule ID 22643 //
     /*  831253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  831302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831321 */     GIR_RootConstrainSelectedInstOperands,
     /*  831322 */     // GIR_Coverage, 22643,
     /*  831322 */     GIR_EraseRootFromParent_Done,
     /*  831323 */   // Label 12822: @831323
     /*  831323 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(831398), // Rule ID 22646 //
     /*  831328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  831377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831396 */     GIR_RootConstrainSelectedInstOperands,
     /*  831397 */     // GIR_Coverage, 22646,
     /*  831397 */     GIR_EraseRootFromParent_Done,
     /*  831398 */   // Label 12823: @831398
     /*  831398 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(831473), // Rule ID 22647 //
     /*  831403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  831452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831471 */     GIR_RootConstrainSelectedInstOperands,
     /*  831472 */     // GIR_Coverage, 22647,
     /*  831472 */     GIR_EraseRootFromParent_Done,
     /*  831473 */   // Label 12824: @831473
     /*  831473 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(831548), // Rule ID 22650 //
     /*  831478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831546 */     GIR_RootConstrainSelectedInstOperands,
     /*  831547 */     // GIR_Coverage, 22650,
     /*  831547 */     GIR_EraseRootFromParent_Done,
     /*  831548 */   // Label 12825: @831548
     /*  831548 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(831623), // Rule ID 22651 //
     /*  831553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11555:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831621 */     GIR_RootConstrainSelectedInstOperands,
     /*  831622 */     // GIR_Coverage, 22651,
     /*  831622 */     GIR_EraseRootFromParent_Done,
     /*  831623 */   // Label 12826: @831623
     /*  831623 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(831698), // Rule ID 22654 //
     /*  831628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831696 */     GIR_RootConstrainSelectedInstOperands,
     /*  831697 */     // GIR_Coverage, 22654,
     /*  831697 */     GIR_EraseRootFromParent_Done,
     /*  831698 */   // Label 12827: @831698
     /*  831698 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(831773), // Rule ID 22655 //
     /*  831703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831771 */     GIR_RootConstrainSelectedInstOperands,
     /*  831772 */     // GIR_Coverage, 22655,
     /*  831772 */     GIR_EraseRootFromParent_Done,
     /*  831773 */   // Label 12828: @831773
     /*  831773 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(831848), // Rule ID 22658 //
     /*  831778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831846 */     GIR_RootConstrainSelectedInstOperands,
     /*  831847 */     // GIR_Coverage, 22658,
     /*  831847 */     GIR_EraseRootFromParent_Done,
     /*  831848 */   // Label 12829: @831848
     /*  831848 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(831923), // Rule ID 22659 //
     /*  831853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831921 */     GIR_RootConstrainSelectedInstOperands,
     /*  831922 */     // GIR_Coverage, 22659,
     /*  831922 */     GIR_EraseRootFromParent_Done,
     /*  831923 */   // Label 12830: @831923
     /*  831923 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(831998), // Rule ID 22662 //
     /*  831928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831996 */     GIR_RootConstrainSelectedInstOperands,
     /*  831997 */     // GIR_Coverage, 22662,
     /*  831997 */     GIR_EraseRootFromParent_Done,
     /*  831998 */   // Label 12831: @831998
     /*  831998 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(832073), // Rule ID 22663 //
     /*  832003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11555:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  832052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832071 */     GIR_RootConstrainSelectedInstOperands,
     /*  832072 */     // GIR_Coverage, 22663,
     /*  832072 */     GIR_EraseRootFromParent_Done,
     /*  832073 */   // Label 12832: @832073
     /*  832073 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(832148), // Rule ID 22666 //
     /*  832078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  832127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832146 */     GIR_RootConstrainSelectedInstOperands,
     /*  832147 */     // GIR_Coverage, 22666,
     /*  832147 */     GIR_EraseRootFromParent_Done,
     /*  832148 */   // Label 12833: @832148
     /*  832148 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(832223), // Rule ID 22667 //
     /*  832153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  832202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832221 */     GIR_RootConstrainSelectedInstOperands,
     /*  832222 */     // GIR_Coverage, 22667,
     /*  832222 */     GIR_EraseRootFromParent_Done,
     /*  832223 */   // Label 12834: @832223
     /*  832223 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(832298), // Rule ID 22670 //
     /*  832228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  832277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832296 */     GIR_RootConstrainSelectedInstOperands,
     /*  832297 */     // GIR_Coverage, 22670,
     /*  832297 */     GIR_EraseRootFromParent_Done,
     /*  832298 */   // Label 12835: @832298
     /*  832298 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(832373), // Rule ID 22671 //
     /*  832303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832349 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  832352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832371 */     GIR_RootConstrainSelectedInstOperands,
     /*  832372 */     // GIR_Coverage, 22671,
     /*  832372 */     GIR_EraseRootFromParent_Done,
     /*  832373 */   // Label 12836: @832373
     /*  832373 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(832448), // Rule ID 22674 //
     /*  832378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832446 */     GIR_RootConstrainSelectedInstOperands,
     /*  832447 */     // GIR_Coverage, 22674,
     /*  832447 */     GIR_EraseRootFromParent_Done,
     /*  832448 */   // Label 12837: @832448
     /*  832448 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(832523), // Rule ID 22675 //
     /*  832453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11555:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832521 */     GIR_RootConstrainSelectedInstOperands,
     /*  832522 */     // GIR_Coverage, 22675,
     /*  832522 */     GIR_EraseRootFromParent_Done,
     /*  832523 */   // Label 12838: @832523
     /*  832523 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(832598), // Rule ID 22678 //
     /*  832528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832596 */     GIR_RootConstrainSelectedInstOperands,
     /*  832597 */     // GIR_Coverage, 22678,
     /*  832597 */     GIR_EraseRootFromParent_Done,
     /*  832598 */   // Label 12839: @832598
     /*  832598 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(832673), // Rule ID 22679 //
     /*  832603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832671 */     GIR_RootConstrainSelectedInstOperands,
     /*  832672 */     // GIR_Coverage, 22679,
     /*  832672 */     GIR_EraseRootFromParent_Done,
     /*  832673 */   // Label 12840: @832673
     /*  832673 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(832748), // Rule ID 22682 //
     /*  832678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832746 */     GIR_RootConstrainSelectedInstOperands,
     /*  832747 */     // GIR_Coverage, 22682,
     /*  832747 */     GIR_EraseRootFromParent_Done,
     /*  832748 */   // Label 12841: @832748
     /*  832748 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(832823), // Rule ID 22683 //
     /*  832753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832799 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832821 */     GIR_RootConstrainSelectedInstOperands,
     /*  832822 */     // GIR_Coverage, 22683,
     /*  832822 */     GIR_EraseRootFromParent_Done,
     /*  832823 */   // Label 12842: @832823
     /*  832823 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(832898), // Rule ID 22686 //
     /*  832828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832896 */     GIR_RootConstrainSelectedInstOperands,
     /*  832897 */     // GIR_Coverage, 22686,
     /*  832897 */     GIR_EraseRootFromParent_Done,
     /*  832898 */   // Label 12843: @832898
     /*  832898 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(832973), // Rule ID 22687 //
     /*  832903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11555:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832971 */     GIR_RootConstrainSelectedInstOperands,
     /*  832972 */     // GIR_Coverage, 22687,
     /*  832972 */     GIR_EraseRootFromParent_Done,
     /*  832973 */   // Label 12844: @832973
     /*  832973 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(833048), // Rule ID 22690 //
     /*  832978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  833027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833046 */     GIR_RootConstrainSelectedInstOperands,
     /*  833047 */     // GIR_Coverage, 22690,
     /*  833047 */     GIR_EraseRootFromParent_Done,
     /*  833048 */   // Label 12845: @833048
     /*  833048 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(833123), // Rule ID 22691 //
     /*  833053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833099 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  833102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833121 */     GIR_RootConstrainSelectedInstOperands,
     /*  833122 */     // GIR_Coverage, 22691,
     /*  833122 */     GIR_EraseRootFromParent_Done,
     /*  833123 */   // Label 12846: @833123
     /*  833123 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(833198), // Rule ID 22694 //
     /*  833128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  833177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833196 */     GIR_RootConstrainSelectedInstOperands,
     /*  833197 */     // GIR_Coverage, 22694,
     /*  833197 */     GIR_EraseRootFromParent_Done,
     /*  833198 */   // Label 12847: @833198
     /*  833198 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(833273), // Rule ID 22695 //
     /*  833203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833249 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  833252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833271 */     GIR_RootConstrainSelectedInstOperands,
     /*  833272 */     // GIR_Coverage, 22695,
     /*  833272 */     GIR_EraseRootFromParent_Done,
     /*  833273 */   // Label 12848: @833273
     /*  833273 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(833348), // Rule ID 22698 //
     /*  833278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  833327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833346 */     GIR_RootConstrainSelectedInstOperands,
     /*  833347 */     // GIR_Coverage, 22698,
     /*  833347 */     GIR_EraseRootFromParent_Done,
     /*  833348 */   // Label 12849: @833348
     /*  833348 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(833423), // Rule ID 22699 //
     /*  833353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  833402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833421 */     GIR_RootConstrainSelectedInstOperands,
     /*  833422 */     // GIR_Coverage, 22699,
     /*  833422 */     GIR_EraseRootFromParent_Done,
     /*  833423 */   // Label 12850: @833423
     /*  833423 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(833498), // Rule ID 22702 //
     /*  833428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833496 */     GIR_RootConstrainSelectedInstOperands,
     /*  833497 */     // GIR_Coverage, 22702,
     /*  833497 */     GIR_EraseRootFromParent_Done,
     /*  833498 */   // Label 12851: @833498
     /*  833498 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(833573), // Rule ID 22703 //
     /*  833503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833571 */     GIR_RootConstrainSelectedInstOperands,
     /*  833572 */     // GIR_Coverage, 22703,
     /*  833572 */     GIR_EraseRootFromParent_Done,
     /*  833573 */   // Label 12852: @833573
     /*  833573 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(833648), // Rule ID 22706 //
     /*  833578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833646 */     GIR_RootConstrainSelectedInstOperands,
     /*  833647 */     // GIR_Coverage, 22706,
     /*  833647 */     GIR_EraseRootFromParent_Done,
     /*  833648 */   // Label 12853: @833648
     /*  833648 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(833723), // Rule ID 22707 //
     /*  833653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833699 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833721 */     GIR_RootConstrainSelectedInstOperands,
     /*  833722 */     // GIR_Coverage, 22707,
     /*  833722 */     GIR_EraseRootFromParent_Done,
     /*  833723 */   // Label 12854: @833723
     /*  833723 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(833798), // Rule ID 22710 //
     /*  833728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833796 */     GIR_RootConstrainSelectedInstOperands,
     /*  833797 */     // GIR_Coverage, 22710,
     /*  833797 */     GIR_EraseRootFromParent_Done,
     /*  833798 */   // Label 12855: @833798
     /*  833798 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(833873), // Rule ID 22711 //
     /*  833803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833871 */     GIR_RootConstrainSelectedInstOperands,
     /*  833872 */     // GIR_Coverage, 22711,
     /*  833872 */     GIR_EraseRootFromParent_Done,
     /*  833873 */   // Label 12856: @833873
     /*  833873 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(833948), // Rule ID 22714 //
     /*  833878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833946 */     GIR_RootConstrainSelectedInstOperands,
     /*  833947 */     // GIR_Coverage, 22714,
     /*  833947 */     GIR_EraseRootFromParent_Done,
     /*  833948 */   // Label 12857: @833948
     /*  833948 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(834023), // Rule ID 22715 //
     /*  833953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833999 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  834002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834021 */     GIR_RootConstrainSelectedInstOperands,
     /*  834022 */     // GIR_Coverage, 22715,
     /*  834022 */     GIR_EraseRootFromParent_Done,
     /*  834023 */   // Label 12858: @834023
     /*  834023 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(834098), // Rule ID 22718 //
     /*  834028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  834077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834096 */     GIR_RootConstrainSelectedInstOperands,
     /*  834097 */     // GIR_Coverage, 22718,
     /*  834097 */     GIR_EraseRootFromParent_Done,
     /*  834098 */   // Label 12859: @834098
     /*  834098 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(834173), // Rule ID 22719 //
     /*  834103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834149 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  834152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834171 */     GIR_RootConstrainSelectedInstOperands,
     /*  834172 */     // GIR_Coverage, 22719,
     /*  834172 */     GIR_EraseRootFromParent_Done,
     /*  834173 */   // Label 12860: @834173
     /*  834173 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(834248), // Rule ID 22722 //
     /*  834178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  834227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834246 */     GIR_RootConstrainSelectedInstOperands,
     /*  834247 */     // GIR_Coverage, 22722,
     /*  834247 */     GIR_EraseRootFromParent_Done,
     /*  834248 */   // Label 12861: @834248
     /*  834248 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(834323), // Rule ID 22723 //
     /*  834253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  834302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834321 */     GIR_RootConstrainSelectedInstOperands,
     /*  834322 */     // GIR_Coverage, 22723,
     /*  834322 */     GIR_EraseRootFromParent_Done,
     /*  834323 */   // Label 12862: @834323
     /*  834323 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(834398), // Rule ID 22726 //
     /*  834328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  834377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834396 */     GIR_RootConstrainSelectedInstOperands,
     /*  834397 */     // GIR_Coverage, 22726,
     /*  834397 */     GIR_EraseRootFromParent_Done,
     /*  834398 */   // Label 12863: @834398
     /*  834398 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(834473), // Rule ID 22727 //
     /*  834403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  834452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834471 */     GIR_RootConstrainSelectedInstOperands,
     /*  834472 */     // GIR_Coverage, 22727,
     /*  834472 */     GIR_EraseRootFromParent_Done,
     /*  834473 */   // Label 12864: @834473
     /*  834473 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(834548), // Rule ID 22730 //
     /*  834478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834546 */     GIR_RootConstrainSelectedInstOperands,
     /*  834547 */     // GIR_Coverage, 22730,
     /*  834547 */     GIR_EraseRootFromParent_Done,
     /*  834548 */   // Label 12865: @834548
     /*  834548 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(834623), // Rule ID 22731 //
     /*  834553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834621 */     GIR_RootConstrainSelectedInstOperands,
     /*  834622 */     // GIR_Coverage, 22731,
     /*  834622 */     GIR_EraseRootFromParent_Done,
     /*  834623 */   // Label 12866: @834623
     /*  834623 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(834698), // Rule ID 22734 //
     /*  834628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834696 */     GIR_RootConstrainSelectedInstOperands,
     /*  834697 */     // GIR_Coverage, 22734,
     /*  834697 */     GIR_EraseRootFromParent_Done,
     /*  834698 */   // Label 12867: @834698
     /*  834698 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(834773), // Rule ID 22735 //
     /*  834703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11719:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834771 */     GIR_RootConstrainSelectedInstOperands,
     /*  834772 */     // GIR_Coverage, 22735,
     /*  834772 */     GIR_EraseRootFromParent_Done,
     /*  834773 */   // Label 12868: @834773
     /*  834773 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(834848), // Rule ID 22738 //
     /*  834778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834846 */     GIR_RootConstrainSelectedInstOperands,
     /*  834847 */     // GIR_Coverage, 22738,
     /*  834847 */     GIR_EraseRootFromParent_Done,
     /*  834848 */   // Label 12869: @834848
     /*  834848 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(834923), // Rule ID 22739 //
     /*  834853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834921 */     GIR_RootConstrainSelectedInstOperands,
     /*  834922 */     // GIR_Coverage, 22739,
     /*  834922 */     GIR_EraseRootFromParent_Done,
     /*  834923 */   // Label 12870: @834923
     /*  834923 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(834998), // Rule ID 22742 //
     /*  834928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834996 */     GIR_RootConstrainSelectedInstOperands,
     /*  834997 */     // GIR_Coverage, 22742,
     /*  834997 */     GIR_EraseRootFromParent_Done,
     /*  834998 */   // Label 12871: @834998
     /*  834998 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(835073), // Rule ID 22743 //
     /*  835003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  835052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835071 */     GIR_RootConstrainSelectedInstOperands,
     /*  835072 */     // GIR_Coverage, 22743,
     /*  835072 */     GIR_EraseRootFromParent_Done,
     /*  835073 */   // Label 12872: @835073
     /*  835073 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(835148), // Rule ID 22746 //
     /*  835078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  835127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835146 */     GIR_RootConstrainSelectedInstOperands,
     /*  835147 */     // GIR_Coverage, 22746,
     /*  835147 */     GIR_EraseRootFromParent_Done,
     /*  835148 */   // Label 12873: @835148
     /*  835148 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(835223), // Rule ID 22747 //
     /*  835153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11719:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  835202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835221 */     GIR_RootConstrainSelectedInstOperands,
     /*  835222 */     // GIR_Coverage, 22747,
     /*  835222 */     GIR_EraseRootFromParent_Done,
     /*  835223 */   // Label 12874: @835223
     /*  835223 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(835298), // Rule ID 22750 //
     /*  835228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  835277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835296 */     GIR_RootConstrainSelectedInstOperands,
     /*  835297 */     // GIR_Coverage, 22750,
     /*  835297 */     GIR_EraseRootFromParent_Done,
     /*  835298 */   // Label 12875: @835298
     /*  835298 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(835373), // Rule ID 22751 //
     /*  835303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  835352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835371 */     GIR_RootConstrainSelectedInstOperands,
     /*  835372 */     // GIR_Coverage, 22751,
     /*  835372 */     GIR_EraseRootFromParent_Done,
     /*  835373 */   // Label 12876: @835373
     /*  835373 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(835448), // Rule ID 22754 //
     /*  835378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835446 */     GIR_RootConstrainSelectedInstOperands,
     /*  835447 */     // GIR_Coverage, 22754,
     /*  835447 */     GIR_EraseRootFromParent_Done,
     /*  835448 */   // Label 12877: @835448
     /*  835448 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(835523), // Rule ID 22755 //
     /*  835453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835521 */     GIR_RootConstrainSelectedInstOperands,
     /*  835522 */     // GIR_Coverage, 22755,
     /*  835522 */     GIR_EraseRootFromParent_Done,
     /*  835523 */   // Label 12878: @835523
     /*  835523 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(835598), // Rule ID 22758 //
     /*  835528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835596 */     GIR_RootConstrainSelectedInstOperands,
     /*  835597 */     // GIR_Coverage, 22758,
     /*  835597 */     GIR_EraseRootFromParent_Done,
     /*  835598 */   // Label 12879: @835598
     /*  835598 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(835673), // Rule ID 22759 //
     /*  835603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11719:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835671 */     GIR_RootConstrainSelectedInstOperands,
     /*  835672 */     // GIR_Coverage, 22759,
     /*  835672 */     GIR_EraseRootFromParent_Done,
     /*  835673 */   // Label 12880: @835673
     /*  835673 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(835748), // Rule ID 22762 //
     /*  835678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835746 */     GIR_RootConstrainSelectedInstOperands,
     /*  835747 */     // GIR_Coverage, 22762,
     /*  835747 */     GIR_EraseRootFromParent_Done,
     /*  835748 */   // Label 12881: @835748
     /*  835748 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(835823), // Rule ID 22763 //
     /*  835753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835821 */     GIR_RootConstrainSelectedInstOperands,
     /*  835822 */     // GIR_Coverage, 22763,
     /*  835822 */     GIR_EraseRootFromParent_Done,
     /*  835823 */   // Label 12882: @835823
     /*  835823 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(835898), // Rule ID 22766 //
     /*  835828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835896 */     GIR_RootConstrainSelectedInstOperands,
     /*  835897 */     // GIR_Coverage, 22766,
     /*  835897 */     GIR_EraseRootFromParent_Done,
     /*  835898 */   // Label 12883: @835898
     /*  835898 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(835973), // Rule ID 22767 //
     /*  835903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835971 */     GIR_RootConstrainSelectedInstOperands,
     /*  835972 */     // GIR_Coverage, 22767,
     /*  835972 */     GIR_EraseRootFromParent_Done,
     /*  835973 */   // Label 12884: @835973
     /*  835973 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(836048), // Rule ID 22770 //
     /*  835978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  836027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836046 */     GIR_RootConstrainSelectedInstOperands,
     /*  836047 */     // GIR_Coverage, 22770,
     /*  836047 */     GIR_EraseRootFromParent_Done,
     /*  836048 */   // Label 12885: @836048
     /*  836048 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(836123), // Rule ID 22771 //
     /*  836053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836099 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  836102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836121 */     GIR_RootConstrainSelectedInstOperands,
     /*  836122 */     // GIR_Coverage, 22771,
     /*  836122 */     GIR_EraseRootFromParent_Done,
     /*  836123 */   // Label 12886: @836123
     /*  836123 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(836198), // Rule ID 22774 //
     /*  836128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  836177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836196 */     GIR_RootConstrainSelectedInstOperands,
     /*  836197 */     // GIR_Coverage, 22774,
     /*  836197 */     GIR_EraseRootFromParent_Done,
     /*  836198 */   // Label 12887: @836198
     /*  836198 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(836273), // Rule ID 22775 //
     /*  836203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836249 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  836252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836271 */     GIR_RootConstrainSelectedInstOperands,
     /*  836272 */     // GIR_Coverage, 22775,
     /*  836272 */     GIR_EraseRootFromParent_Done,
     /*  836273 */   // Label 12888: @836273
     /*  836273 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(836348), // Rule ID 22778 //
     /*  836278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  836327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836346 */     GIR_RootConstrainSelectedInstOperands,
     /*  836347 */     // GIR_Coverage, 22778,
     /*  836347 */     GIR_EraseRootFromParent_Done,
     /*  836348 */   // Label 12889: @836348
     /*  836348 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(836423), // Rule ID 22779 //
     /*  836353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  836402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836421 */     GIR_RootConstrainSelectedInstOperands,
     /*  836422 */     // GIR_Coverage, 22779,
     /*  836422 */     GIR_EraseRootFromParent_Done,
     /*  836423 */   // Label 12890: @836423
     /*  836423 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(836498), // Rule ID 22782 //
     /*  836428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836496 */     GIR_RootConstrainSelectedInstOperands,
     /*  836497 */     // GIR_Coverage, 22782,
     /*  836497 */     GIR_EraseRootFromParent_Done,
     /*  836498 */   // Label 12891: @836498
     /*  836498 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(836573), // Rule ID 22783 //
     /*  836503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836571 */     GIR_RootConstrainSelectedInstOperands,
     /*  836572 */     // GIR_Coverage, 22783,
     /*  836572 */     GIR_EraseRootFromParent_Done,
     /*  836573 */   // Label 12892: @836573
     /*  836573 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(836648), // Rule ID 22786 //
     /*  836578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836646 */     GIR_RootConstrainSelectedInstOperands,
     /*  836647 */     // GIR_Coverage, 22786,
     /*  836647 */     GIR_EraseRootFromParent_Done,
     /*  836648 */   // Label 12893: @836648
     /*  836648 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(836723), // Rule ID 22787 //
     /*  836653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836721 */     GIR_RootConstrainSelectedInstOperands,
     /*  836722 */     // GIR_Coverage, 22787,
     /*  836722 */     GIR_EraseRootFromParent_Done,
     /*  836723 */   // Label 12894: @836723
     /*  836723 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(836798), // Rule ID 22790 //
     /*  836728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836796 */     GIR_RootConstrainSelectedInstOperands,
     /*  836797 */     // GIR_Coverage, 22790,
     /*  836797 */     GIR_EraseRootFromParent_Done,
     /*  836798 */   // Label 12895: @836798
     /*  836798 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(836873), // Rule ID 22791 //
     /*  836803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836849 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836871 */     GIR_RootConstrainSelectedInstOperands,
     /*  836872 */     // GIR_Coverage, 22791,
     /*  836872 */     GIR_EraseRootFromParent_Done,
     /*  836873 */   // Label 12896: @836873
     /*  836873 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(836948), // Rule ID 22794 //
     /*  836878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836946 */     GIR_RootConstrainSelectedInstOperands,
     /*  836947 */     // GIR_Coverage, 22794,
     /*  836947 */     GIR_EraseRootFromParent_Done,
     /*  836948 */   // Label 12897: @836948
     /*  836948 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(837023), // Rule ID 22795 //
     /*  836953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  837002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837021 */     GIR_RootConstrainSelectedInstOperands,
     /*  837022 */     // GIR_Coverage, 22795,
     /*  837022 */     GIR_EraseRootFromParent_Done,
     /*  837023 */   // Label 12898: @837023
     /*  837023 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(837098), // Rule ID 22798 //
     /*  837028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  837077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837096 */     GIR_RootConstrainSelectedInstOperands,
     /*  837097 */     // GIR_Coverage, 22798,
     /*  837097 */     GIR_EraseRootFromParent_Done,
     /*  837098 */   // Label 12899: @837098
     /*  837098 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(837173), // Rule ID 22799 //
     /*  837103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  837152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837171 */     GIR_RootConstrainSelectedInstOperands,
     /*  837172 */     // GIR_Coverage, 22799,
     /*  837172 */     GIR_EraseRootFromParent_Done,
     /*  837173 */   // Label 12900: @837173
     /*  837173 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(837248), // Rule ID 22802 //
     /*  837178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  837227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837246 */     GIR_RootConstrainSelectedInstOperands,
     /*  837247 */     // GIR_Coverage, 22802,
     /*  837247 */     GIR_EraseRootFromParent_Done,
     /*  837248 */   // Label 12901: @837248
     /*  837248 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(837323), // Rule ID 22803 //
     /*  837253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  837302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837321 */     GIR_RootConstrainSelectedInstOperands,
     /*  837322 */     // GIR_Coverage, 22803,
     /*  837322 */     GIR_EraseRootFromParent_Done,
     /*  837323 */   // Label 12902: @837323
     /*  837323 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(837398), // Rule ID 22806 //
     /*  837328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  837345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  837377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837396 */     GIR_RootConstrainSelectedInstOperands,
     /*  837397 */     // GIR_Coverage, 22806,
     /*  837397 */     GIR_EraseRootFromParent_Done,
     /*  837398 */   // Label 12903: @837398
     /*  837398 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(837473), // Rule ID 22807 //
     /*  837403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  837420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11717:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  837452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837471 */     GIR_RootConstrainSelectedInstOperands,
     /*  837472 */     // GIR_Coverage, 22807,
     /*  837472 */     GIR_EraseRootFromParent_Done,
     /*  837473 */   // Label 12904: @837473
     /*  837473 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(837548), // Rule ID 22810 //
     /*  837478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837546 */     GIR_RootConstrainSelectedInstOperands,
     /*  837547 */     // GIR_Coverage, 22810,
     /*  837547 */     GIR_EraseRootFromParent_Done,
     /*  837548 */   // Label 12905: @837548
     /*  837548 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(837623), // Rule ID 22811 //
     /*  837553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837621 */     GIR_RootConstrainSelectedInstOperands,
     /*  837622 */     // GIR_Coverage, 22811,
     /*  837622 */     GIR_EraseRootFromParent_Done,
     /*  837623 */   // Label 12906: @837623
     /*  837623 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(837698), // Rule ID 22814 //
     /*  837628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837696 */     GIR_RootConstrainSelectedInstOperands,
     /*  837697 */     // GIR_Coverage, 22814,
     /*  837697 */     GIR_EraseRootFromParent_Done,
     /*  837698 */   // Label 12907: @837698
     /*  837698 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(837773), // Rule ID 22815 //
     /*  837703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837749 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837771 */     GIR_RootConstrainSelectedInstOperands,
     /*  837772 */     // GIR_Coverage, 22815,
     /*  837772 */     GIR_EraseRootFromParent_Done,
     /*  837773 */   // Label 12908: @837773
     /*  837773 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(837848), // Rule ID 22818 //
     /*  837778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837846 */     GIR_RootConstrainSelectedInstOperands,
     /*  837847 */     // GIR_Coverage, 22818,
     /*  837847 */     GIR_EraseRootFromParent_Done,
     /*  837848 */   // Label 12909: @837848
     /*  837848 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(837923), // Rule ID 22819 //
     /*  837853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11717:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837921 */     GIR_RootConstrainSelectedInstOperands,
     /*  837922 */     // GIR_Coverage, 22819,
     /*  837922 */     GIR_EraseRootFromParent_Done,
     /*  837923 */   // Label 12910: @837923
     /*  837923 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(837998), // Rule ID 22822 //
     /*  837928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837996 */     GIR_RootConstrainSelectedInstOperands,
     /*  837997 */     // GIR_Coverage, 22822,
     /*  837997 */     GIR_EraseRootFromParent_Done,
     /*  837998 */   // Label 12911: @837998
     /*  837998 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(838073), // Rule ID 22823 //
     /*  838003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  838052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838071 */     GIR_RootConstrainSelectedInstOperands,
     /*  838072 */     // GIR_Coverage, 22823,
     /*  838072 */     GIR_EraseRootFromParent_Done,
     /*  838073 */   // Label 12912: @838073
     /*  838073 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(838148), // Rule ID 22826 //
     /*  838078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  838127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838146 */     GIR_RootConstrainSelectedInstOperands,
     /*  838147 */     // GIR_Coverage, 22826,
     /*  838147 */     GIR_EraseRootFromParent_Done,
     /*  838148 */   // Label 12913: @838148
     /*  838148 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(838223), // Rule ID 22827 //
     /*  838153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838199 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  838202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838221 */     GIR_RootConstrainSelectedInstOperands,
     /*  838222 */     // GIR_Coverage, 22827,
     /*  838222 */     GIR_EraseRootFromParent_Done,
     /*  838223 */   // Label 12914: @838223
     /*  838223 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(838298), // Rule ID 22830 //
     /*  838228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  838277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838296 */     GIR_RootConstrainSelectedInstOperands,
     /*  838297 */     // GIR_Coverage, 22830,
     /*  838297 */     GIR_EraseRootFromParent_Done,
     /*  838298 */   // Label 12915: @838298
     /*  838298 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(838373), // Rule ID 22831 //
     /*  838303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  838311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11717:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  838352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838371 */     GIR_RootConstrainSelectedInstOperands,
     /*  838372 */     // GIR_Coverage, 22831,
     /*  838372 */     GIR_EraseRootFromParent_Done,
     /*  838373 */   // Label 12916: @838373
     /*  838373 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(838448), // Rule ID 22950 //
     /*  838378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838424 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838446 */     GIR_RootConstrainSelectedInstOperands,
     /*  838447 */     // GIR_Coverage, 22950,
     /*  838447 */     GIR_EraseRootFromParent_Done,
     /*  838448 */   // Label 12917: @838448
     /*  838448 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(838523), // Rule ID 22951 //
     /*  838453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838499 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838521 */     GIR_RootConstrainSelectedInstOperands,
     /*  838522 */     // GIR_Coverage, 22951,
     /*  838522 */     GIR_EraseRootFromParent_Done,
     /*  838523 */   // Label 12918: @838523
     /*  838523 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(838598), // Rule ID 22954 //
     /*  838528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838596 */     GIR_RootConstrainSelectedInstOperands,
     /*  838597 */     // GIR_Coverage, 22954,
     /*  838597 */     GIR_EraseRootFromParent_Done,
     /*  838598 */   // Label 12919: @838598
     /*  838598 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(838673), // Rule ID 22955 //
     /*  838603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838649 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838671 */     GIR_RootConstrainSelectedInstOperands,
     /*  838672 */     // GIR_Coverage, 22955,
     /*  838672 */     GIR_EraseRootFromParent_Done,
     /*  838673 */   // Label 12920: @838673
     /*  838673 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(838748), // Rule ID 22958 //
     /*  838678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838746 */     GIR_RootConstrainSelectedInstOperands,
     /*  838747 */     // GIR_Coverage, 22958,
     /*  838747 */     GIR_EraseRootFromParent_Done,
     /*  838748 */   // Label 12921: @838748
     /*  838748 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(838823), // Rule ID 22959 //
     /*  838753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838799 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838821 */     GIR_RootConstrainSelectedInstOperands,
     /*  838822 */     // GIR_Coverage, 22959,
     /*  838822 */     GIR_EraseRootFromParent_Done,
     /*  838823 */   // Label 12922: @838823
     /*  838823 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(838898), // Rule ID 22962 //
     /*  838828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838874 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838896 */     GIR_RootConstrainSelectedInstOperands,
     /*  838897 */     // GIR_Coverage, 22962,
     /*  838897 */     GIR_EraseRootFromParent_Done,
     /*  838898 */   // Label 12923: @838898
     /*  838898 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(838973), // Rule ID 22963 //
     /*  838903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838949 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838971 */     GIR_RootConstrainSelectedInstOperands,
     /*  838972 */     // GIR_Coverage, 22963,
     /*  838972 */     GIR_EraseRootFromParent_Done,
     /*  838973 */   // Label 12924: @838973
     /*  838973 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(839048), // Rule ID 22966 //
     /*  838978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  839027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839046 */     GIR_RootConstrainSelectedInstOperands,
     /*  839047 */     // GIR_Coverage, 22966,
     /*  839047 */     GIR_EraseRootFromParent_Done,
     /*  839048 */   // Label 12925: @839048
     /*  839048 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(839123), // Rule ID 22967 //
     /*  839053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  839070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  839102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839121 */     GIR_RootConstrainSelectedInstOperands,
     /*  839122 */     // GIR_Coverage, 22967,
     /*  839122 */     GIR_EraseRootFromParent_Done,
     /*  839123 */   // Label 12926: @839123
     /*  839123 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(839198), // Rule ID 22970 //
     /*  839128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  839145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839174 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  839177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839196 */     GIR_RootConstrainSelectedInstOperands,
     /*  839197 */     // GIR_Coverage, 22970,
     /*  839197 */     GIR_EraseRootFromParent_Done,
     /*  839198 */   // Label 12927: @839198
     /*  839198 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(839273), // Rule ID 22971 //
     /*  839203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  839220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839249 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  839252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839271 */     GIR_RootConstrainSelectedInstOperands,
     /*  839272 */     // GIR_Coverage, 22971,
     /*  839272 */     GIR_EraseRootFromParent_Done,
     /*  839273 */   // Label 12928: @839273
     /*  839273 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(839348), // Rule ID 22974 //
     /*  839278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  839295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  839327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839346 */     GIR_RootConstrainSelectedInstOperands,
     /*  839347 */     // GIR_Coverage, 22974,
     /*  839347 */     GIR_EraseRootFromParent_Done,
     /*  839348 */   // Label 12929: @839348
     /*  839348 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(839423), // Rule ID 22975 //
     /*  839353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  839370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839399 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  839402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839421 */     GIR_RootConstrainSelectedInstOperands,
     /*  839422 */     // GIR_Coverage, 22975,
     /*  839422 */     GIR_EraseRootFromParent_Done,
     /*  839423 */   // Label 12930: @839423
     /*  839423 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(839498), // Rule ID 22978 //
     /*  839428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839474 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839496 */     GIR_RootConstrainSelectedInstOperands,
     /*  839497 */     // GIR_Coverage, 22978,
     /*  839497 */     GIR_EraseRootFromParent_Done,
     /*  839498 */   // Label 12931: @839498
     /*  839498 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(839573), // Rule ID 22979 //
     /*  839503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839571 */     GIR_RootConstrainSelectedInstOperands,
     /*  839572 */     // GIR_Coverage, 22979,
     /*  839572 */     GIR_EraseRootFromParent_Done,
     /*  839573 */   // Label 12932: @839573
     /*  839573 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(839648), // Rule ID 22982 //
     /*  839578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839624 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839646 */     GIR_RootConstrainSelectedInstOperands,
     /*  839647 */     // GIR_Coverage, 22982,
     /*  839647 */     GIR_EraseRootFromParent_Done,
     /*  839648 */   // Label 12933: @839648
     /*  839648 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(839723), // Rule ID 22983 //
     /*  839653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839699 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11311:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839721 */     GIR_RootConstrainSelectedInstOperands,
     /*  839722 */     // GIR_Coverage, 22983,
     /*  839722 */     GIR_EraseRootFromParent_Done,
     /*  839723 */   // Label 12934: @839723
     /*  839723 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(839798), // Rule ID 22986 //
     /*  839728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839774 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839796 */     GIR_RootConstrainSelectedInstOperands,
     /*  839797 */     // GIR_Coverage, 22986,
     /*  839797 */     GIR_EraseRootFromParent_Done,
     /*  839798 */   // Label 12935: @839798
     /*  839798 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(839873), // Rule ID 22987 //
     /*  839803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839849 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839871 */     GIR_RootConstrainSelectedInstOperands,
     /*  839872 */     // GIR_Coverage, 22987,
     /*  839872 */     GIR_EraseRootFromParent_Done,
     /*  839873 */   // Label 12936: @839873
     /*  839873 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(839948), // Rule ID 22990 //
     /*  839878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839946 */     GIR_RootConstrainSelectedInstOperands,
     /*  839947 */     // GIR_Coverage, 22990,
     /*  839947 */     GIR_EraseRootFromParent_Done,
     /*  839948 */   // Label 12937: @839948
     /*  839948 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(840023), // Rule ID 22991 //
     /*  839953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839999 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  840002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840021 */     GIR_RootConstrainSelectedInstOperands,
     /*  840022 */     // GIR_Coverage, 22991,
     /*  840022 */     GIR_EraseRootFromParent_Done,
     /*  840023 */   // Label 12938: @840023
     /*  840023 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(840098), // Rule ID 22994 //
     /*  840028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  840045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840074 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  840077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840096 */     GIR_RootConstrainSelectedInstOperands,
     /*  840097 */     // GIR_Coverage, 22994,
     /*  840097 */     GIR_EraseRootFromParent_Done,
     /*  840098 */   // Label 12939: @840098
     /*  840098 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(840173), // Rule ID 22995 //
     /*  840103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  840120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  840152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840171 */     GIR_RootConstrainSelectedInstOperands,
     /*  840172 */     // GIR_Coverage, 22995,
     /*  840172 */     GIR_EraseRootFromParent_Done,
     /*  840173 */   // Label 12940: @840173
     /*  840173 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(840248), // Rule ID 22998 //
     /*  840178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  840195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840224 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  840227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840246 */     GIR_RootConstrainSelectedInstOperands,
     /*  840247 */     // GIR_Coverage, 22998,
     /*  840247 */     GIR_EraseRootFromParent_Done,
     /*  840248 */   // Label 12941: @840248
     /*  840248 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(840323), // Rule ID 22999 //
     /*  840253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  840270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840299 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  840302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840321 */     GIR_RootConstrainSelectedInstOperands,
     /*  840322 */     // GIR_Coverage, 22999,
     /*  840322 */     GIR_EraseRootFromParent_Done,
     /*  840323 */   // Label 12942: @840323
     /*  840323 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(840398), // Rule ID 23002 //
     /*  840328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  840377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840396 */     GIR_RootConstrainSelectedInstOperands,
     /*  840397 */     // GIR_Coverage, 23002,
     /*  840397 */     GIR_EraseRootFromParent_Done,
     /*  840398 */   // Label 12943: @840398
     /*  840398 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(840473), // Rule ID 23003 //
     /*  840403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  840420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840449 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  840452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840471 */     GIR_RootConstrainSelectedInstOperands,
     /*  840472 */     // GIR_Coverage, 23003,
     /*  840472 */     GIR_EraseRootFromParent_Done,
     /*  840473 */   // Label 12944: @840473
     /*  840473 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(840548), // Rule ID 23006 //
     /*  840478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840546 */     GIR_RootConstrainSelectedInstOperands,
     /*  840547 */     // GIR_Coverage, 23006,
     /*  840547 */     GIR_EraseRootFromParent_Done,
     /*  840548 */   // Label 12945: @840548
     /*  840548 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(840623), // Rule ID 23007 //
     /*  840553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840621 */     GIR_RootConstrainSelectedInstOperands,
     /*  840622 */     // GIR_Coverage, 23007,
     /*  840622 */     GIR_EraseRootFromParent_Done,
     /*  840623 */   // Label 12946: @840623
     /*  840623 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(840698), // Rule ID 23010 //
     /*  840628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840674 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840696 */     GIR_RootConstrainSelectedInstOperands,
     /*  840697 */     // GIR_Coverage, 23010,
     /*  840697 */     GIR_EraseRootFromParent_Done,
     /*  840698 */   // Label 12947: @840698
     /*  840698 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(840773), // Rule ID 23011 //
     /*  840703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840749 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840771 */     GIR_RootConstrainSelectedInstOperands,
     /*  840772 */     // GIR_Coverage, 23011,
     /*  840772 */     GIR_EraseRootFromParent_Done,
     /*  840773 */   // Label 12948: @840773
     /*  840773 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(840848), // Rule ID 23014 //
     /*  840778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840846 */     GIR_RootConstrainSelectedInstOperands,
     /*  840847 */     // GIR_Coverage, 23014,
     /*  840847 */     GIR_EraseRootFromParent_Done,
     /*  840848 */   // Label 12949: @840848
     /*  840848 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(840923), // Rule ID 23015 //
     /*  840853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840921 */     GIR_RootConstrainSelectedInstOperands,
     /*  840922 */     // GIR_Coverage, 23015,
     /*  840922 */     GIR_EraseRootFromParent_Done,
     /*  840923 */   // Label 12950: @840923
     /*  840923 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(840998), // Rule ID 23018 //
     /*  840928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840996 */     GIR_RootConstrainSelectedInstOperands,
     /*  840997 */     // GIR_Coverage, 23018,
     /*  840997 */     GIR_EraseRootFromParent_Done,
     /*  840998 */   // Label 12951: @840998
     /*  840998 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(841073), // Rule ID 23019 //
     /*  841003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  841020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841049 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  841052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841071 */     GIR_RootConstrainSelectedInstOperands,
     /*  841072 */     // GIR_Coverage, 23019,
     /*  841072 */     GIR_EraseRootFromParent_Done,
     /*  841073 */   // Label 12952: @841073
     /*  841073 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(841148), // Rule ID 23022 //
     /*  841078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  841095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  841127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841146 */     GIR_RootConstrainSelectedInstOperands,
     /*  841147 */     // GIR_Coverage, 23022,
     /*  841147 */     GIR_EraseRootFromParent_Done,
     /*  841148 */   // Label 12953: @841148
     /*  841148 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(841223), // Rule ID 23023 //
     /*  841153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  841170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841199 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  841202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841221 */     GIR_RootConstrainSelectedInstOperands,
     /*  841222 */     // GIR_Coverage, 23023,
     /*  841222 */     GIR_EraseRootFromParent_Done,
     /*  841223 */   // Label 12954: @841223
     /*  841223 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(841298), // Rule ID 23026 //
     /*  841228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841274 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  841277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841296 */     GIR_RootConstrainSelectedInstOperands,
     /*  841297 */     // GIR_Coverage, 23026,
     /*  841297 */     GIR_EraseRootFromParent_Done,
     /*  841298 */   // Label 12955: @841298
     /*  841298 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(841373), // Rule ID 23027 //
     /*  841303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  841320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841349 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  841352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841371 */     GIR_RootConstrainSelectedInstOperands,
     /*  841372 */     // GIR_Coverage, 23027,
     /*  841372 */     GIR_EraseRootFromParent_Done,
     /*  841373 */   // Label 12956: @841373
     /*  841373 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(841448), // Rule ID 23030 //
     /*  841378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  841424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841446 */     GIR_RootConstrainSelectedInstOperands,
     /*  841447 */     // GIR_Coverage, 23030,
     /*  841447 */     GIR_EraseRootFromParent_Done,
     /*  841448 */   // Label 12957: @841448
     /*  841448 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(841523), // Rule ID 23031 //
     /*  841453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841521 */     GIR_RootConstrainSelectedInstOperands,
     /*  841522 */     // GIR_Coverage, 23031,
     /*  841522 */     GIR_EraseRootFromParent_Done,
     /*  841523 */   // Label 12958: @841523
     /*  841523 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(841598), // Rule ID 23034 //
     /*  841528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841574 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841596 */     GIR_RootConstrainSelectedInstOperands,
     /*  841597 */     // GIR_Coverage, 23034,
     /*  841597 */     GIR_EraseRootFromParent_Done,
     /*  841598 */   // Label 12959: @841598
     /*  841598 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(841673), // Rule ID 23035 //
     /*  841603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841649 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841671 */     GIR_RootConstrainSelectedInstOperands,
     /*  841672 */     // GIR_Coverage, 23035,
     /*  841672 */     GIR_EraseRootFromParent_Done,
     /*  841673 */   // Label 12960: @841673
     /*  841673 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(841748), // Rule ID 23038 //
     /*  841678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841746 */     GIR_RootConstrainSelectedInstOperands,
     /*  841747 */     // GIR_Coverage, 23038,
     /*  841747 */     GIR_EraseRootFromParent_Done,
     /*  841748 */   // Label 12961: @841748
     /*  841748 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(841823), // Rule ID 23039 //
     /*  841753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841821 */     GIR_RootConstrainSelectedInstOperands,
     /*  841822 */     // GIR_Coverage, 23039,
     /*  841822 */     GIR_EraseRootFromParent_Done,
     /*  841823 */   // Label 12962: @841823
     /*  841823 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(841898), // Rule ID 23042 //
     /*  841828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841874 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841896 */     GIR_RootConstrainSelectedInstOperands,
     /*  841897 */     // GIR_Coverage, 23042,
     /*  841897 */     GIR_EraseRootFromParent_Done,
     /*  841898 */   // Label 12963: @841898
     /*  841898 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(841973), // Rule ID 23043 //
     /*  841903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841949 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11309:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841971 */     GIR_RootConstrainSelectedInstOperands,
     /*  841972 */     // GIR_Coverage, 23043,
     /*  841972 */     GIR_EraseRootFromParent_Done,
     /*  841973 */   // Label 12964: @841973
     /*  841973 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(842048), // Rule ID 23046 //
     /*  841978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  842027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842046 */     GIR_RootConstrainSelectedInstOperands,
     /*  842047 */     // GIR_Coverage, 23046,
     /*  842047 */     GIR_EraseRootFromParent_Done,
     /*  842048 */   // Label 12965: @842048
     /*  842048 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(842123), // Rule ID 23047 //
     /*  842053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  842070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842099 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  842102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842121 */     GIR_RootConstrainSelectedInstOperands,
     /*  842122 */     // GIR_Coverage, 23047,
     /*  842122 */     GIR_EraseRootFromParent_Done,
     /*  842123 */   // Label 12966: @842123
     /*  842123 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(842198), // Rule ID 23050 //
     /*  842128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  842177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842196 */     GIR_RootConstrainSelectedInstOperands,
     /*  842197 */     // GIR_Coverage, 23050,
     /*  842197 */     GIR_EraseRootFromParent_Done,
     /*  842198 */   // Label 12967: @842198
     /*  842198 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(842273), // Rule ID 23051 //
     /*  842203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  842220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842249 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  842252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842271 */     GIR_RootConstrainSelectedInstOperands,
     /*  842272 */     // GIR_Coverage, 23051,
     /*  842272 */     GIR_EraseRootFromParent_Done,
     /*  842273 */   // Label 12968: @842273
     /*  842273 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(842348), // Rule ID 23054 //
     /*  842278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  842327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842346 */     GIR_RootConstrainSelectedInstOperands,
     /*  842347 */     // GIR_Coverage, 23054,
     /*  842347 */     GIR_EraseRootFromParent_Done,
     /*  842348 */   // Label 12969: @842348
     /*  842348 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(842423), // Rule ID 23055 //
     /*  842353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  842370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842399 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  842402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842421 */     GIR_RootConstrainSelectedInstOperands,
     /*  842422 */     // GIR_Coverage, 23055,
     /*  842422 */     GIR_EraseRootFromParent_Done,
     /*  842423 */   // Label 12970: @842423
     /*  842423 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(842498), // Rule ID 23058 //
     /*  842428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842474 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842496 */     GIR_RootConstrainSelectedInstOperands,
     /*  842497 */     // GIR_Coverage, 23058,
     /*  842497 */     GIR_EraseRootFromParent_Done,
     /*  842498 */   // Label 12971: @842498
     /*  842498 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(842573), // Rule ID 23059 //
     /*  842503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842549 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842571 */     GIR_RootConstrainSelectedInstOperands,
     /*  842572 */     // GIR_Coverage, 23059,
     /*  842572 */     GIR_EraseRootFromParent_Done,
     /*  842573 */   // Label 12972: @842573
     /*  842573 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(842648), // Rule ID 23062 //
     /*  842578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842646 */     GIR_RootConstrainSelectedInstOperands,
     /*  842647 */     // GIR_Coverage, 23062,
     /*  842647 */     GIR_EraseRootFromParent_Done,
     /*  842648 */   // Label 12973: @842648
     /*  842648 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(842723), // Rule ID 23063 //
     /*  842653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842699 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842721 */     GIR_RootConstrainSelectedInstOperands,
     /*  842722 */     // GIR_Coverage, 23063,
     /*  842722 */     GIR_EraseRootFromParent_Done,
     /*  842723 */   // Label 12974: @842723
     /*  842723 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(842798), // Rule ID 23066 //
     /*  842728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842796 */     GIR_RootConstrainSelectedInstOperands,
     /*  842797 */     // GIR_Coverage, 23066,
     /*  842797 */     GIR_EraseRootFromParent_Done,
     /*  842798 */   // Label 12975: @842798
     /*  842798 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(842873), // Rule ID 23067 //
     /*  842803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842871 */     GIR_RootConstrainSelectedInstOperands,
     /*  842872 */     // GIR_Coverage, 23067,
     /*  842872 */     GIR_EraseRootFromParent_Done,
     /*  842873 */   // Label 12976: @842873
     /*  842873 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(842948), // Rule ID 23348 //
     /*  842878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842946 */     GIR_RootConstrainSelectedInstOperands,
     /*  842947 */     // GIR_Coverage, 23348,
     /*  842947 */     GIR_EraseRootFromParent_Done,
     /*  842948 */   // Label 12977: @842948
     /*  842948 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(843023), // Rule ID 23349 //
     /*  842953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842999 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  843002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843021 */     GIR_RootConstrainSelectedInstOperands,
     /*  843022 */     // GIR_Coverage, 23349,
     /*  843022 */     GIR_EraseRootFromParent_Done,
     /*  843023 */   // Label 12978: @843023
     /*  843023 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(843098), // Rule ID 23352 //
     /*  843028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843074 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  843077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843096 */     GIR_RootConstrainSelectedInstOperands,
     /*  843097 */     // GIR_Coverage, 23352,
     /*  843097 */     GIR_EraseRootFromParent_Done,
     /*  843098 */   // Label 12979: @843098
     /*  843098 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(843173), // Rule ID 23353 //
     /*  843103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843149 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  843152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843171 */     GIR_RootConstrainSelectedInstOperands,
     /*  843172 */     // GIR_Coverage, 23353,
     /*  843172 */     GIR_EraseRootFromParent_Done,
     /*  843173 */   // Label 12980: @843173
     /*  843173 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(843248), // Rule ID 23356 //
     /*  843178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  843227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843246 */     GIR_RootConstrainSelectedInstOperands,
     /*  843247 */     // GIR_Coverage, 23356,
     /*  843247 */     GIR_EraseRootFromParent_Done,
     /*  843248 */   // Label 12981: @843248
     /*  843248 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(843323), // Rule ID 23357 //
     /*  843253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  843302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843321 */     GIR_RootConstrainSelectedInstOperands,
     /*  843322 */     // GIR_Coverage, 23357,
     /*  843322 */     GIR_EraseRootFromParent_Done,
     /*  843323 */   // Label 12982: @843323
     /*  843323 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(843398), // Rule ID 23360 //
     /*  843328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  843377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843396 */     GIR_RootConstrainSelectedInstOperands,
     /*  843397 */     // GIR_Coverage, 23360,
     /*  843397 */     GIR_EraseRootFromParent_Done,
     /*  843398 */   // Label 12983: @843398
     /*  843398 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(843473), // Rule ID 23361 //
     /*  843403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  843452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843471 */     GIR_RootConstrainSelectedInstOperands,
     /*  843472 */     // GIR_Coverage, 23361,
     /*  843472 */     GIR_EraseRootFromParent_Done,
     /*  843473 */   // Label 12984: @843473
     /*  843473 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(843548), // Rule ID 23364 //
     /*  843478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843524 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843546 */     GIR_RootConstrainSelectedInstOperands,
     /*  843547 */     // GIR_Coverage, 23364,
     /*  843547 */     GIR_EraseRootFromParent_Done,
     /*  843548 */   // Label 12985: @843548
     /*  843548 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(843623), // Rule ID 23365 //
     /*  843553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843599 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843621 */     GIR_RootConstrainSelectedInstOperands,
     /*  843622 */     // GIR_Coverage, 23365,
     /*  843622 */     GIR_EraseRootFromParent_Done,
     /*  843623 */   // Label 12986: @843623
     /*  843623 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(843698), // Rule ID 23368 //
     /*  843628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843674 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843696 */     GIR_RootConstrainSelectedInstOperands,
     /*  843697 */     // GIR_Coverage, 23368,
     /*  843697 */     GIR_EraseRootFromParent_Done,
     /*  843698 */   // Label 12987: @843698
     /*  843698 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(843773), // Rule ID 23369 //
     /*  843703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843749 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11499:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843771 */     GIR_RootConstrainSelectedInstOperands,
     /*  843772 */     // GIR_Coverage, 23369,
     /*  843772 */     GIR_EraseRootFromParent_Done,
     /*  843773 */   // Label 12988: @843773
     /*  843773 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(843848), // Rule ID 23372 //
     /*  843778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843846 */     GIR_RootConstrainSelectedInstOperands,
     /*  843847 */     // GIR_Coverage, 23372,
     /*  843847 */     GIR_EraseRootFromParent_Done,
     /*  843848 */   // Label 12989: @843848
     /*  843848 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(843923), // Rule ID 23373 //
     /*  843853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843899 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843921 */     GIR_RootConstrainSelectedInstOperands,
     /*  843922 */     // GIR_Coverage, 23373,
     /*  843922 */     GIR_EraseRootFromParent_Done,
     /*  843923 */   // Label 12990: @843923
     /*  843923 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(843998), // Rule ID 23376 //
     /*  843928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843996 */     GIR_RootConstrainSelectedInstOperands,
     /*  843997 */     // GIR_Coverage, 23376,
     /*  843997 */     GIR_EraseRootFromParent_Done,
     /*  843998 */   // Label 12991: @843998
     /*  843998 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(844073), // Rule ID 23377 //
     /*  844003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  844052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844071 */     GIR_RootConstrainSelectedInstOperands,
     /*  844072 */     // GIR_Coverage, 23377,
     /*  844072 */     GIR_EraseRootFromParent_Done,
     /*  844073 */   // Label 12992: @844073
     /*  844073 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(844148), // Rule ID 23380 //
     /*  844078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  844127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844146 */     GIR_RootConstrainSelectedInstOperands,
     /*  844147 */     // GIR_Coverage, 23380,
     /*  844147 */     GIR_EraseRootFromParent_Done,
     /*  844148 */   // Label 12993: @844148
     /*  844148 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(844223), // Rule ID 23381 //
     /*  844153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844199 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  844202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844221 */     GIR_RootConstrainSelectedInstOperands,
     /*  844222 */     // GIR_Coverage, 23381,
     /*  844222 */     GIR_EraseRootFromParent_Done,
     /*  844223 */   // Label 12994: @844223
     /*  844223 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(844298), // Rule ID 23384 //
     /*  844228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  844277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844296 */     GIR_RootConstrainSelectedInstOperands,
     /*  844297 */     // GIR_Coverage, 23384,
     /*  844297 */     GIR_EraseRootFromParent_Done,
     /*  844298 */   // Label 12995: @844298
     /*  844298 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(844373), // Rule ID 23385 //
     /*  844303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844349 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  844352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844371 */     GIR_RootConstrainSelectedInstOperands,
     /*  844372 */     // GIR_Coverage, 23385,
     /*  844372 */     GIR_EraseRootFromParent_Done,
     /*  844373 */   // Label 12996: @844373
     /*  844373 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(844448), // Rule ID 23388 //
     /*  844378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844446 */     GIR_RootConstrainSelectedInstOperands,
     /*  844447 */     // GIR_Coverage, 23388,
     /*  844447 */     GIR_EraseRootFromParent_Done,
     /*  844448 */   // Label 12997: @844448
     /*  844448 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(844523), // Rule ID 23389 //
     /*  844453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844499 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844521 */     GIR_RootConstrainSelectedInstOperands,
     /*  844522 */     // GIR_Coverage, 23389,
     /*  844522 */     GIR_EraseRootFromParent_Done,
     /*  844523 */   // Label 12998: @844523
     /*  844523 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(844598), // Rule ID 23392 //
     /*  844528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844574 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844596 */     GIR_RootConstrainSelectedInstOperands,
     /*  844597 */     // GIR_Coverage, 23392,
     /*  844597 */     GIR_EraseRootFromParent_Done,
     /*  844598 */   // Label 12999: @844598
     /*  844598 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(844673), // Rule ID 23393 //
     /*  844603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844649 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844671 */     GIR_RootConstrainSelectedInstOperands,
     /*  844672 */     // GIR_Coverage, 23393,
     /*  844672 */     GIR_EraseRootFromParent_Done,
     /*  844673 */   // Label 13000: @844673
     /*  844673 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(844748), // Rule ID 23396 //
     /*  844678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844724 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844746 */     GIR_RootConstrainSelectedInstOperands,
     /*  844747 */     // GIR_Coverage, 23396,
     /*  844747 */     GIR_EraseRootFromParent_Done,
     /*  844748 */   // Label 13001: @844748
     /*  844748 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(844823), // Rule ID 23397 //
     /*  844753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844799 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11512:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844821 */     GIR_RootConstrainSelectedInstOperands,
     /*  844822 */     // GIR_Coverage, 23397,
     /*  844822 */     GIR_EraseRootFromParent_Done,
     /*  844823 */   // Label 13002: @844823
     /*  844823 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(844898), // Rule ID 23400 //
     /*  844828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844896 */     GIR_RootConstrainSelectedInstOperands,
     /*  844897 */     // GIR_Coverage, 23400,
     /*  844897 */     GIR_EraseRootFromParent_Done,
     /*  844898 */   // Label 13003: @844898
     /*  844898 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(844973), // Rule ID 23401 //
     /*  844903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844949 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844971 */     GIR_RootConstrainSelectedInstOperands,
     /*  844972 */     // GIR_Coverage, 23401,
     /*  844972 */     GIR_EraseRootFromParent_Done,
     /*  844973 */   // Label 13004: @844973
     /*  844973 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(845048), // Rule ID 23404 //
     /*  844978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  845027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845046 */     GIR_RootConstrainSelectedInstOperands,
     /*  845047 */     // GIR_Coverage, 23404,
     /*  845047 */     GIR_EraseRootFromParent_Done,
     /*  845048 */   // Label 13005: @845048
     /*  845048 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(845123), // Rule ID 23405 //
     /*  845053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  845064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  845067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  845070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  845073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  845102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845121 */     GIR_RootConstrainSelectedInstOperands,
     /*  845122 */     // GIR_Coverage, 23405,
     /*  845122 */     GIR_EraseRootFromParent_Done,
     /*  845123 */   // Label 13006: @845123
     /*  845123 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(845198), // Rule ID 23408 //
     /*  845128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  845139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  845142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  845145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  845148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845174 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  845177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845196 */     GIR_RootConstrainSelectedInstOperands,
     /*  845197 */     // GIR_Coverage, 23408,
     /*  845197 */     GIR_EraseRootFromParent_Done,
     /*  845198 */   // Label 13007: @845198
     /*  845198 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(845273), // Rule ID 23409 //
     /*  845203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  845214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  845217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  845220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  845223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845249 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  845252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845271 */     GIR_RootConstrainSelectedInstOperands,
     /*  845272 */     // GIR_Coverage, 23409,
     /*  845272 */     GIR_EraseRootFromParent_Done,
     /*  845273 */   // Label 13008: @845273
     /*  845273 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(845348), // Rule ID 23412 //
     /*  845278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  845289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  845292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  845295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  845298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  845327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845346 */     GIR_RootConstrainSelectedInstOperands,
     /*  845347 */     // GIR_Coverage, 23412,
     /*  845347 */     GIR_EraseRootFromParent_Done,
     /*  845348 */   // Label 13009: @845348
     /*  845348 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(845423), // Rule ID 23413 //
     /*  845353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  845364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  845367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  845370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  845373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845399 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  845402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845421 */     GIR_RootConstrainSelectedInstOperands,
     /*  845422 */     // GIR_Coverage, 23413,
     /*  845422 */     GIR_EraseRootFromParent_Done,
     /*  845423 */   // Label 13010: @845423
     /*  845423 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(845498), // Rule ID 23416 //
     /*  845428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845496 */     GIR_RootConstrainSelectedInstOperands,
     /*  845497 */     // GIR_Coverage, 23416,
     /*  845497 */     GIR_EraseRootFromParent_Done,
     /*  845498 */   // Label 13011: @845498
     /*  845498 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(845573), // Rule ID 23417 //
     /*  845503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845571 */     GIR_RootConstrainSelectedInstOperands,
     /*  845572 */     // GIR_Coverage, 23417,
     /*  845572 */     GIR_EraseRootFromParent_Done,
     /*  845573 */   // Label 13012: @845573
     /*  845573 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(845648), // Rule ID 23420 //
     /*  845578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845646 */     GIR_RootConstrainSelectedInstOperands,
     /*  845647 */     // GIR_Coverage, 23420,
     /*  845647 */     GIR_EraseRootFromParent_Done,
     /*  845648 */   // Label 13013: @845648
     /*  845648 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(845723), // Rule ID 23421 //
     /*  845653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845699 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845721 */     GIR_RootConstrainSelectedInstOperands,
     /*  845722 */     // GIR_Coverage, 23421,
     /*  845722 */     GIR_EraseRootFromParent_Done,
     /*  845723 */   // Label 13014: @845723
     /*  845723 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(845798), // Rule ID 23424 //
     /*  845728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845774 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845796 */     GIR_RootConstrainSelectedInstOperands,
     /*  845797 */     // GIR_Coverage, 23424,
     /*  845797 */     GIR_EraseRootFromParent_Done,
     /*  845798 */   // Label 13015: @845798
     /*  845798 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(845873), // Rule ID 23425 //
     /*  845803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845849 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11524:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845871 */     GIR_RootConstrainSelectedInstOperands,
     /*  845872 */     // GIR_Coverage, 23425,
     /*  845872 */     GIR_EraseRootFromParent_Done,
     /*  845873 */   // Label 13016: @845873
     /*  845873 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(845948), // Rule ID 23966 //
     /*  845878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845946 */     GIR_RootConstrainSelectedInstOperands,
     /*  845947 */     // GIR_Coverage, 23966,
     /*  845947 */     GIR_EraseRootFromParent_Done,
     /*  845948 */   // Label 13017: @845948
     /*  845948 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(846023), // Rule ID 23967 //
     /*  845953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845999 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  846002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846021 */     GIR_RootConstrainSelectedInstOperands,
     /*  846022 */     // GIR_Coverage, 23967,
     /*  846022 */     GIR_EraseRootFromParent_Done,
     /*  846023 */   // Label 13018: @846023
     /*  846023 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(846098), // Rule ID 23970 //
     /*  846028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  846039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  846042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  846045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846096 */     GIR_RootConstrainSelectedInstOperands,
     /*  846097 */     // GIR_Coverage, 23970,
     /*  846097 */     GIR_EraseRootFromParent_Done,
     /*  846098 */   // Label 13019: @846098
     /*  846098 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(846173), // Rule ID 23971 //
     /*  846103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  846114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  846117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  846120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846149 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846171 */     GIR_RootConstrainSelectedInstOperands,
     /*  846172 */     // GIR_Coverage, 23971,
     /*  846172 */     GIR_EraseRootFromParent_Done,
     /*  846173 */   // Label 13020: @846173
     /*  846173 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(846248), // Rule ID 23974 //
     /*  846178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  846189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  846192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  846195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846246 */     GIR_RootConstrainSelectedInstOperands,
     /*  846247 */     // GIR_Coverage, 23974,
     /*  846247 */     GIR_EraseRootFromParent_Done,
     /*  846248 */   // Label 13021: @846248
     /*  846248 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(846323), // Rule ID 23975 //
     /*  846253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  846264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  846267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  846270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846299 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846321 */     GIR_RootConstrainSelectedInstOperands,
     /*  846322 */     // GIR_Coverage, 23975,
     /*  846322 */     GIR_EraseRootFromParent_Done,
     /*  846323 */   // Label 13022: @846323
     /*  846323 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(846398), // Rule ID 23978 //
     /*  846328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  846339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  846342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  846345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846396 */     GIR_RootConstrainSelectedInstOperands,
     /*  846397 */     // GIR_Coverage, 23978,
     /*  846397 */     GIR_EraseRootFromParent_Done,
     /*  846398 */   // Label 13023: @846398
     /*  846398 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(846473), // Rule ID 23979 //
     /*  846403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  846414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  846417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  846420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846449 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  846452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846471 */     GIR_RootConstrainSelectedInstOperands,
     /*  846472 */     // GIR_Coverage, 23979,
     /*  846472 */     GIR_EraseRootFromParent_Done,
     /*  846473 */   // Label 13024: @846473
     /*  846473 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(846548), // Rule ID 23982 //
     /*  846478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846546 */     GIR_RootConstrainSelectedInstOperands,
     /*  846547 */     // GIR_Coverage, 23982,
     /*  846547 */     GIR_EraseRootFromParent_Done,
     /*  846548 */   // Label 13025: @846548
     /*  846548 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(846623), // Rule ID 23983 //
     /*  846553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846599 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846621 */     GIR_RootConstrainSelectedInstOperands,
     /*  846622 */     // GIR_Coverage, 23983,
     /*  846622 */     GIR_EraseRootFromParent_Done,
     /*  846623 */   // Label 13026: @846623
     /*  846623 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(846698), // Rule ID 23986 //
     /*  846628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846696 */     GIR_RootConstrainSelectedInstOperands,
     /*  846697 */     // GIR_Coverage, 23986,
     /*  846697 */     GIR_EraseRootFromParent_Done,
     /*  846698 */   // Label 13027: @846698
     /*  846698 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(846773), // Rule ID 23987 //
     /*  846703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846771 */     GIR_RootConstrainSelectedInstOperands,
     /*  846772 */     // GIR_Coverage, 23987,
     /*  846772 */     GIR_EraseRootFromParent_Done,
     /*  846773 */   // Label 13028: @846773
     /*  846773 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(846848), // Rule ID 23990 //
     /*  846778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846846 */     GIR_RootConstrainSelectedInstOperands,
     /*  846847 */     // GIR_Coverage, 23990,
     /*  846847 */     GIR_EraseRootFromParent_Done,
     /*  846848 */   // Label 13029: @846848
     /*  846848 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(846923), // Rule ID 23991 //
     /*  846853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846899 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11603:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846921 */     GIR_RootConstrainSelectedInstOperands,
     /*  846922 */     // GIR_Coverage, 23991,
     /*  846922 */     GIR_EraseRootFromParent_Done,
     /*  846923 */   // Label 13030: @846923
     /*  846923 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(846998), // Rule ID 23994 //
     /*  846928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846996 */     GIR_RootConstrainSelectedInstOperands,
     /*  846997 */     // GIR_Coverage, 23994,
     /*  846997 */     GIR_EraseRootFromParent_Done,
     /*  846998 */   // Label 13031: @846998
     /*  846998 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(847073), // Rule ID 23995 //
     /*  847003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  847014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  847017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  847020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847071 */     GIR_RootConstrainSelectedInstOperands,
     /*  847072 */     // GIR_Coverage, 23995,
     /*  847072 */     GIR_EraseRootFromParent_Done,
     /*  847073 */   // Label 13032: @847073
     /*  847073 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(847148), // Rule ID 23998 //
     /*  847078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847146 */     GIR_RootConstrainSelectedInstOperands,
     /*  847147 */     // GIR_Coverage, 23998,
     /*  847147 */     GIR_EraseRootFromParent_Done,
     /*  847148 */   // Label 13033: @847148
     /*  847148 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(847223), // Rule ID 23999 //
     /*  847153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  847164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  847167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  847170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847221 */     GIR_RootConstrainSelectedInstOperands,
     /*  847222 */     // GIR_Coverage, 23999,
     /*  847222 */     GIR_EraseRootFromParent_Done,
     /*  847223 */   // Label 13034: @847223
     /*  847223 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(847298), // Rule ID 24002 //
     /*  847228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  847231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  847239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  847274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847296 */     GIR_RootConstrainSelectedInstOperands,
     /*  847297 */     // GIR_Coverage, 24002,
     /*  847297 */     GIR_EraseRootFromParent_Done,
     /*  847298 */   // Label 13035: @847298
     /*  847298 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(847373), // Rule ID 24003 //
     /*  847303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  847306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  847314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  847317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  847320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847349 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  847349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  847352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847371 */     GIR_RootConstrainSelectedInstOperands,
     /*  847372 */     // GIR_Coverage, 24003,
     /*  847372 */     GIR_EraseRootFromParent_Done,
     /*  847373 */   // Label 13036: @847373
     /*  847373 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(847448), // Rule ID 24006 //
     /*  847378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  847389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847446 */     GIR_RootConstrainSelectedInstOperands,
     /*  847447 */     // GIR_Coverage, 24006,
     /*  847447 */     GIR_EraseRootFromParent_Done,
     /*  847448 */   // Label 13037: @847448
     /*  847448 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(847523), // Rule ID 24007 //
     /*  847453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  847464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847499 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847521 */     GIR_RootConstrainSelectedInstOperands,
     /*  847522 */     // GIR_Coverage, 24007,
     /*  847522 */     GIR_EraseRootFromParent_Done,
     /*  847523 */   // Label 13038: @847523
     /*  847523 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(847598), // Rule ID 24010 //
     /*  847528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847596 */     GIR_RootConstrainSelectedInstOperands,
     /*  847597 */     // GIR_Coverage, 24010,
     /*  847597 */     GIR_EraseRootFromParent_Done,
     /*  847598 */   // Label 13039: @847598
     /*  847598 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(847673), // Rule ID 24011 //
     /*  847603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847649 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847671 */     GIR_RootConstrainSelectedInstOperands,
     /*  847672 */     // GIR_Coverage, 24011,
     /*  847672 */     GIR_EraseRootFromParent_Done,
     /*  847673 */   // Label 13040: @847673
     /*  847673 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(847748), // Rule ID 24014 //
     /*  847678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847724 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847746 */     GIR_RootConstrainSelectedInstOperands,
     /*  847747 */     // GIR_Coverage, 24014,
     /*  847747 */     GIR_EraseRootFromParent_Done,
     /*  847748 */   // Label 13041: @847748
     /*  847748 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(847823), // Rule ID 24015 //
     /*  847753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847799 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847821 */     GIR_RootConstrainSelectedInstOperands,
     /*  847822 */     // GIR_Coverage, 24015,
     /*  847822 */     GIR_EraseRootFromParent_Done,
     /*  847823 */   // Label 13042: @847823
     /*  847823 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(847898), // Rule ID 24018 //
     /*  847828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847896 */     GIR_RootConstrainSelectedInstOperands,
     /*  847897 */     // GIR_Coverage, 24018,
     /*  847897 */     GIR_EraseRootFromParent_Done,
     /*  847898 */   // Label 13043: @847898
     /*  847898 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(847973), // Rule ID 24019 //
     /*  847903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847971 */     GIR_RootConstrainSelectedInstOperands,
     /*  847972 */     // GIR_Coverage, 24019,
     /*  847972 */     GIR_EraseRootFromParent_Done,
     /*  847973 */   // Label 13044: @847973
     /*  847973 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(848048), // Rule ID 24022 //
     /*  847978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848046 */     GIR_RootConstrainSelectedInstOperands,
     /*  848047 */     // GIR_Coverage, 24022,
     /*  848047 */     GIR_EraseRootFromParent_Done,
     /*  848048 */   // Label 13045: @848048
     /*  848048 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(848123), // Rule ID 24023 //
     /*  848053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  848064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  848067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  848070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848121 */     GIR_RootConstrainSelectedInstOperands,
     /*  848122 */     // GIR_Coverage, 24023,
     /*  848122 */     GIR_EraseRootFromParent_Done,
     /*  848123 */   // Label 13046: @848123
     /*  848123 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(848198), // Rule ID 24026 //
     /*  848128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  848139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  848142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  848145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848196 */     GIR_RootConstrainSelectedInstOperands,
     /*  848197 */     // GIR_Coverage, 24026,
     /*  848197 */     GIR_EraseRootFromParent_Done,
     /*  848198 */   // Label 13047: @848198
     /*  848198 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(848273), // Rule ID 24027 //
     /*  848203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  848214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  848217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  848220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848271 */     GIR_RootConstrainSelectedInstOperands,
     /*  848272 */     // GIR_Coverage, 24027,
     /*  848272 */     GIR_EraseRootFromParent_Done,
     /*  848273 */   // Label 13048: @848273
     /*  848273 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(848348), // Rule ID 24030 //
     /*  848278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848346 */     GIR_RootConstrainSelectedInstOperands,
     /*  848347 */     // GIR_Coverage, 24030,
     /*  848347 */     GIR_EraseRootFromParent_Done,
     /*  848348 */   // Label 13049: @848348
     /*  848348 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(848423), // Rule ID 24031 //
     /*  848353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  848364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  848367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  848370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848421 */     GIR_RootConstrainSelectedInstOperands,
     /*  848422 */     // GIR_Coverage, 24031,
     /*  848422 */     GIR_EraseRootFromParent_Done,
     /*  848423 */   // Label 13050: @848423
     /*  848423 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(848498), // Rule ID 24034 //
     /*  848428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848496 */     GIR_RootConstrainSelectedInstOperands,
     /*  848497 */     // GIR_Coverage, 24034,
     /*  848497 */     GIR_EraseRootFromParent_Done,
     /*  848498 */   // Label 13051: @848498
     /*  848498 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(848573), // Rule ID 24035 //
     /*  848503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848549 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848571 */     GIR_RootConstrainSelectedInstOperands,
     /*  848572 */     // GIR_Coverage, 24035,
     /*  848572 */     GIR_EraseRootFromParent_Done,
     /*  848573 */   // Label 13052: @848573
     /*  848573 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(848648), // Rule ID 24038 //
     /*  848578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848646 */     GIR_RootConstrainSelectedInstOperands,
     /*  848647 */     // GIR_Coverage, 24038,
     /*  848647 */     GIR_EraseRootFromParent_Done,
     /*  848648 */   // Label 13053: @848648
     /*  848648 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(848723), // Rule ID 24039 //
     /*  848653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848699 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848721 */     GIR_RootConstrainSelectedInstOperands,
     /*  848722 */     // GIR_Coverage, 24039,
     /*  848722 */     GIR_EraseRootFromParent_Done,
     /*  848723 */   // Label 13054: @848723
     /*  848723 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(848798), // Rule ID 24042 //
     /*  848728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848796 */     GIR_RootConstrainSelectedInstOperands,
     /*  848797 */     // GIR_Coverage, 24042,
     /*  848797 */     GIR_EraseRootFromParent_Done,
     /*  848798 */   // Label 13055: @848798
     /*  848798 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(848873), // Rule ID 24043 //
     /*  848803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848871 */     GIR_RootConstrainSelectedInstOperands,
     /*  848872 */     // GIR_Coverage, 24043,
     /*  848872 */     GIR_EraseRootFromParent_Done,
     /*  848873 */   // Label 13056: @848873
     /*  848873 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(848948), // Rule ID 24046 //
     /*  848878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848946 */     GIR_RootConstrainSelectedInstOperands,
     /*  848947 */     // GIR_Coverage, 24046,
     /*  848947 */     GIR_EraseRootFromParent_Done,
     /*  848948 */   // Label 13057: @848948
     /*  848948 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(849023), // Rule ID 24047 //
     /*  848953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848999 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  849002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849021 */     GIR_RootConstrainSelectedInstOperands,
     /*  849022 */     // GIR_Coverage, 24047,
     /*  849022 */     GIR_EraseRootFromParent_Done,
     /*  849023 */   // Label 13058: @849023
     /*  849023 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(849098), // Rule ID 24050 //
     /*  849028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  849031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849074 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  849074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  849077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849096 */     GIR_RootConstrainSelectedInstOperands,
     /*  849097 */     // GIR_Coverage, 24050,
     /*  849097 */     GIR_EraseRootFromParent_Done,
     /*  849098 */   // Label 13059: @849098
     /*  849098 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(849173), // Rule ID 24051 //
     /*  849103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  849106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  849114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  849117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  849120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  849138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849149 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  849149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  849152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849171 */     GIR_RootConstrainSelectedInstOperands,
     /*  849172 */     // GIR_Coverage, 24051,
     /*  849172 */     GIR_EraseRootFromParent_Done,
     /*  849173 */   // Label 13060: @849173
     /*  849173 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(849248), // Rule ID 24054 //
     /*  849178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  849227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849246 */     GIR_RootConstrainSelectedInstOperands,
     /*  849247 */     // GIR_Coverage, 24054,
     /*  849247 */     GIR_EraseRootFromParent_Done,
     /*  849248 */   // Label 13061: @849248
     /*  849248 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(849323), // Rule ID 24055 //
     /*  849253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849299 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  849302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849321 */     GIR_RootConstrainSelectedInstOperands,
     /*  849322 */     // GIR_Coverage, 24055,
     /*  849322 */     GIR_EraseRootFromParent_Done,
     /*  849323 */   // Label 13062: @849323
     /*  849323 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(849398), // Rule ID 24058 //
     /*  849328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849374 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849396 */     GIR_RootConstrainSelectedInstOperands,
     /*  849397 */     // GIR_Coverage, 24058,
     /*  849397 */     GIR_EraseRootFromParent_Done,
     /*  849398 */   // Label 13063: @849398
     /*  849398 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(849473), // Rule ID 24059 //
     /*  849403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849449 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849471 */     GIR_RootConstrainSelectedInstOperands,
     /*  849472 */     // GIR_Coverage, 24059,
     /*  849472 */     GIR_EraseRootFromParent_Done,
     /*  849473 */   // Label 13064: @849473
     /*  849473 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(849548), // Rule ID 24062 //
     /*  849478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849524 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849546 */     GIR_RootConstrainSelectedInstOperands,
     /*  849547 */     // GIR_Coverage, 24062,
     /*  849547 */     GIR_EraseRootFromParent_Done,
     /*  849548 */   // Label 13065: @849548
     /*  849548 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(849623), // Rule ID 24063 //
     /*  849553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849599 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849621 */     GIR_RootConstrainSelectedInstOperands,
     /*  849622 */     // GIR_Coverage, 24063,
     /*  849622 */     GIR_EraseRootFromParent_Done,
     /*  849623 */   // Label 13066: @849623
     /*  849623 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(849698), // Rule ID 24066 //
     /*  849628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849696 */     GIR_RootConstrainSelectedInstOperands,
     /*  849697 */     // GIR_Coverage, 24066,
     /*  849697 */     GIR_EraseRootFromParent_Done,
     /*  849698 */   // Label 13067: @849698
     /*  849698 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(849773), // Rule ID 24067 //
     /*  849703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849749 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849771 */     GIR_RootConstrainSelectedInstOperands,
     /*  849772 */     // GIR_Coverage, 24067,
     /*  849772 */     GIR_EraseRootFromParent_Done,
     /*  849773 */   // Label 13068: @849773
     /*  849773 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(849848), // Rule ID 24070 //
     /*  849778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849846 */     GIR_RootConstrainSelectedInstOperands,
     /*  849847 */     // GIR_Coverage, 24070,
     /*  849847 */     GIR_EraseRootFromParent_Done,
     /*  849848 */   // Label 13069: @849848
     /*  849848 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(849923), // Rule ID 24071 //
     /*  849853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849921 */     GIR_RootConstrainSelectedInstOperands,
     /*  849922 */     // GIR_Coverage, 24071,
     /*  849922 */     GIR_EraseRootFromParent_Done,
     /*  849923 */   // Label 13070: @849923
     /*  849923 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(849998), // Rule ID 24074 //
     /*  849928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849996 */     GIR_RootConstrainSelectedInstOperands,
     /*  849997 */     // GIR_Coverage, 24074,
     /*  849997 */     GIR_EraseRootFromParent_Done,
     /*  849998 */   // Label 13071: @849998
     /*  849998 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(850073), // Rule ID 24075 //
     /*  850003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850049 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  850052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850071 */     GIR_RootConstrainSelectedInstOperands,
     /*  850072 */     // GIR_Coverage, 24075,
     /*  850072 */     GIR_EraseRootFromParent_Done,
     /*  850073 */   // Label 13072: @850073
     /*  850073 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(850148), // Rule ID 24078 //
     /*  850078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850146 */     GIR_RootConstrainSelectedInstOperands,
     /*  850147 */     // GIR_Coverage, 24078,
     /*  850147 */     GIR_EraseRootFromParent_Done,
     /*  850148 */   // Label 13073: @850148
     /*  850148 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(850223), // Rule ID 24079 //
     /*  850153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850199 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850221 */     GIR_RootConstrainSelectedInstOperands,
     /*  850222 */     // GIR_Coverage, 24079,
     /*  850222 */     GIR_EraseRootFromParent_Done,
     /*  850223 */   // Label 13074: @850223
     /*  850223 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(850298), // Rule ID 24082 //
     /*  850228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850296 */     GIR_RootConstrainSelectedInstOperands,
     /*  850297 */     // GIR_Coverage, 24082,
     /*  850297 */     GIR_EraseRootFromParent_Done,
     /*  850298 */   // Label 13075: @850298
     /*  850298 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(850373), // Rule ID 24083 //
     /*  850303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850349 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850371 */     GIR_RootConstrainSelectedInstOperands,
     /*  850372 */     // GIR_Coverage, 24083,
     /*  850372 */     GIR_EraseRootFromParent_Done,
     /*  850373 */   // Label 13076: @850373
     /*  850373 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(850448), // Rule ID 24086 //
     /*  850378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850446 */     GIR_RootConstrainSelectedInstOperands,
     /*  850447 */     // GIR_Coverage, 24086,
     /*  850447 */     GIR_EraseRootFromParent_Done,
     /*  850448 */   // Label 13077: @850448
     /*  850448 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(850523), // Rule ID 24087 //
     /*  850453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850521 */     GIR_RootConstrainSelectedInstOperands,
     /*  850522 */     // GIR_Coverage, 24087,
     /*  850522 */     GIR_EraseRootFromParent_Done,
     /*  850523 */   // Label 13078: @850523
     /*  850523 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(850598), // Rule ID 24090 //
     /*  850528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850596 */     GIR_RootConstrainSelectedInstOperands,
     /*  850597 */     // GIR_Coverage, 24090,
     /*  850597 */     GIR_EraseRootFromParent_Done,
     /*  850598 */   // Label 13079: @850598
     /*  850598 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(850673), // Rule ID 24091 //
     /*  850603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850671 */     GIR_RootConstrainSelectedInstOperands,
     /*  850672 */     // GIR_Coverage, 24091,
     /*  850672 */     GIR_EraseRootFromParent_Done,
     /*  850673 */   // Label 13080: @850673
     /*  850673 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(850748), // Rule ID 24094 //
     /*  850678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850746 */     GIR_RootConstrainSelectedInstOperands,
     /*  850747 */     // GIR_Coverage, 24094,
     /*  850747 */     GIR_EraseRootFromParent_Done,
     /*  850748 */   // Label 13081: @850748
     /*  850748 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(850823), // Rule ID 24095 //
     /*  850753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850821 */     GIR_RootConstrainSelectedInstOperands,
     /*  850822 */     // GIR_Coverage, 24095,
     /*  850822 */     GIR_EraseRootFromParent_Done,
     /*  850823 */   // Label 13082: @850823
     /*  850823 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(850898), // Rule ID 24098 //
     /*  850828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850874 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850896 */     GIR_RootConstrainSelectedInstOperands,
     /*  850897 */     // GIR_Coverage, 24098,
     /*  850897 */     GIR_EraseRootFromParent_Done,
     /*  850898 */   // Label 13083: @850898
     /*  850898 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(850973), // Rule ID 24099 //
     /*  850903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850949 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850971 */     GIR_RootConstrainSelectedInstOperands,
     /*  850972 */     // GIR_Coverage, 24099,
     /*  850972 */     GIR_EraseRootFromParent_Done,
     /*  850973 */   // Label 13084: @850973
     /*  850973 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(851048), // Rule ID 24102 //
     /*  850978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  851024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851046 */     GIR_RootConstrainSelectedInstOperands,
     /*  851047 */     // GIR_Coverage, 24102,
     /*  851047 */     GIR_EraseRootFromParent_Done,
     /*  851048 */   // Label 13085: @851048
     /*  851048 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(851123), // Rule ID 24103 //
     /*  851053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851121 */     GIR_RootConstrainSelectedInstOperands,
     /*  851122 */     // GIR_Coverage, 24103,
     /*  851122 */     GIR_EraseRootFromParent_Done,
     /*  851123 */   // Label 13086: @851123
     /*  851123 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(851198), // Rule ID 24106 //
     /*  851128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851196 */     GIR_RootConstrainSelectedInstOperands,
     /*  851197 */     // GIR_Coverage, 24106,
     /*  851197 */     GIR_EraseRootFromParent_Done,
     /*  851198 */   // Label 13087: @851198
     /*  851198 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(851273), // Rule ID 24107 //
     /*  851203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851271 */     GIR_RootConstrainSelectedInstOperands,
     /*  851272 */     // GIR_Coverage, 24107,
     /*  851272 */     GIR_EraseRootFromParent_Done,
     /*  851273 */   // Label 13088: @851273
     /*  851273 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(851348), // Rule ID 24110 //
     /*  851278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851346 */     GIR_RootConstrainSelectedInstOperands,
     /*  851347 */     // GIR_Coverage, 24110,
     /*  851347 */     GIR_EraseRootFromParent_Done,
     /*  851348 */   // Label 13089: @851348
     /*  851348 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(851423), // Rule ID 24111 //
     /*  851353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851399 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851421 */     GIR_RootConstrainSelectedInstOperands,
     /*  851422 */     // GIR_Coverage, 24111,
     /*  851422 */     GIR_EraseRootFromParent_Done,
     /*  851423 */   // Label 13090: @851423
     /*  851423 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(851498), // Rule ID 24114 //
     /*  851428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851496 */     GIR_RootConstrainSelectedInstOperands,
     /*  851497 */     // GIR_Coverage, 24114,
     /*  851497 */     GIR_EraseRootFromParent_Done,
     /*  851498 */   // Label 13091: @851498
     /*  851498 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(851573), // Rule ID 24115 //
     /*  851503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851549 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851571 */     GIR_RootConstrainSelectedInstOperands,
     /*  851572 */     // GIR_Coverage, 24115,
     /*  851572 */     GIR_EraseRootFromParent_Done,
     /*  851573 */   // Label 13092: @851573
     /*  851573 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(851648), // Rule ID 24118 //
     /*  851578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851646 */     GIR_RootConstrainSelectedInstOperands,
     /*  851647 */     // GIR_Coverage, 24118,
     /*  851647 */     GIR_EraseRootFromParent_Done,
     /*  851648 */   // Label 13093: @851648
     /*  851648 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(851723), // Rule ID 24119 //
     /*  851653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851721 */     GIR_RootConstrainSelectedInstOperands,
     /*  851722 */     // GIR_Coverage, 24119,
     /*  851722 */     GIR_EraseRootFromParent_Done,
     /*  851723 */   // Label 13094: @851723
     /*  851723 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(851798), // Rule ID 24122 //
     /*  851728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851796 */     GIR_RootConstrainSelectedInstOperands,
     /*  851797 */     // GIR_Coverage, 24122,
     /*  851797 */     GIR_EraseRootFromParent_Done,
     /*  851798 */   // Label 13095: @851798
     /*  851798 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(851873), // Rule ID 24123 //
     /*  851803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851871 */     GIR_RootConstrainSelectedInstOperands,
     /*  851872 */     // GIR_Coverage, 24123,
     /*  851872 */     GIR_EraseRootFromParent_Done,
     /*  851873 */   // Label 13096: @851873
     /*  851873 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(851948), // Rule ID 24126 //
     /*  851878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851946 */     GIR_RootConstrainSelectedInstOperands,
     /*  851947 */     // GIR_Coverage, 24126,
     /*  851947 */     GIR_EraseRootFromParent_Done,
     /*  851948 */   // Label 13097: @851948
     /*  851948 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(852023), // Rule ID 24127 //
     /*  851953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851999 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852021 */     GIR_RootConstrainSelectedInstOperands,
     /*  852022 */     // GIR_Coverage, 24127,
     /*  852022 */     GIR_EraseRootFromParent_Done,
     /*  852023 */   // Label 13098: @852023
     /*  852023 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(852098), // Rule ID 24130 //
     /*  852028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  852077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852096 */     GIR_RootConstrainSelectedInstOperands,
     /*  852097 */     // GIR_Coverage, 24130,
     /*  852097 */     GIR_EraseRootFromParent_Done,
     /*  852098 */   // Label 13099: @852098
     /*  852098 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(852173), // Rule ID 24131 //
     /*  852103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  852152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852171 */     GIR_RootConstrainSelectedInstOperands,
     /*  852172 */     // GIR_Coverage, 24131,
     /*  852172 */     GIR_EraseRootFromParent_Done,
     /*  852173 */   // Label 13100: @852173
     /*  852173 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(852248), // Rule ID 24134 //
     /*  852178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  852227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852246 */     GIR_RootConstrainSelectedInstOperands,
     /*  852247 */     // GIR_Coverage, 24134,
     /*  852247 */     GIR_EraseRootFromParent_Done,
     /*  852248 */   // Label 13101: @852248
     /*  852248 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(852323), // Rule ID 24135 //
     /*  852253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  852302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852321 */     GIR_RootConstrainSelectedInstOperands,
     /*  852322 */     // GIR_Coverage, 24135,
     /*  852322 */     GIR_EraseRootFromParent_Done,
     /*  852323 */   // Label 13102: @852323
     /*  852323 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(852398), // Rule ID 24138 //
     /*  852328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852396 */     GIR_RootConstrainSelectedInstOperands,
     /*  852397 */     // GIR_Coverage, 24138,
     /*  852397 */     GIR_EraseRootFromParent_Done,
     /*  852398 */   // Label 13103: @852398
     /*  852398 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(852473), // Rule ID 24139 //
     /*  852403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852449 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  852452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852471 */     GIR_RootConstrainSelectedInstOperands,
     /*  852472 */     // GIR_Coverage, 24139,
     /*  852472 */     GIR_EraseRootFromParent_Done,
     /*  852473 */   // Label 13104: @852473
     /*  852473 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(852548), // Rule ID 24382 //
     /*  852478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852546 */     GIR_RootConstrainSelectedInstOperands,
     /*  852547 */     // GIR_Coverage, 24382,
     /*  852547 */     GIR_EraseRootFromParent_Done,
     /*  852548 */   // Label 13105: @852548
     /*  852548 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(852623), // Rule ID 24383 //
     /*  852553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852599 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852621 */     GIR_RootConstrainSelectedInstOperands,
     /*  852622 */     // GIR_Coverage, 24383,
     /*  852622 */     GIR_EraseRootFromParent_Done,
     /*  852623 */   // Label 13106: @852623
     /*  852623 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(852698), // Rule ID 24386 //
     /*  852628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852696 */     GIR_RootConstrainSelectedInstOperands,
     /*  852697 */     // GIR_Coverage, 24386,
     /*  852697 */     GIR_EraseRootFromParent_Done,
     /*  852698 */   // Label 13107: @852698
     /*  852698 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(852773), // Rule ID 24387 //
     /*  852703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852749 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852771 */     GIR_RootConstrainSelectedInstOperands,
     /*  852772 */     // GIR_Coverage, 24387,
     /*  852772 */     GIR_EraseRootFromParent_Done,
     /*  852773 */   // Label 13108: @852773
     /*  852773 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(852848), // Rule ID 24390 //
     /*  852778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852846 */     GIR_RootConstrainSelectedInstOperands,
     /*  852847 */     // GIR_Coverage, 24390,
     /*  852847 */     GIR_EraseRootFromParent_Done,
     /*  852848 */   // Label 13109: @852848
     /*  852848 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(852923), // Rule ID 24391 //
     /*  852853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852899 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852921 */     GIR_RootConstrainSelectedInstOperands,
     /*  852922 */     // GIR_Coverage, 24391,
     /*  852922 */     GIR_EraseRootFromParent_Done,
     /*  852923 */   // Label 13110: @852923
     /*  852923 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(852998), // Rule ID 24394 //
     /*  852928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852996 */     GIR_RootConstrainSelectedInstOperands,
     /*  852997 */     // GIR_Coverage, 24394,
     /*  852997 */     GIR_EraseRootFromParent_Done,
     /*  852998 */   // Label 13111: @852998
     /*  852998 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(853073), // Rule ID 24395 //
     /*  853003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853049 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11329:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  853052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853071 */     GIR_RootConstrainSelectedInstOperands,
     /*  853072 */     // GIR_Coverage, 24395,
     /*  853072 */     GIR_EraseRootFromParent_Done,
     /*  853073 */   // Label 13112: @853073
     /*  853073 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(853148), // Rule ID 24398 //
     /*  853078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  853127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853146 */     GIR_RootConstrainSelectedInstOperands,
     /*  853147 */     // GIR_Coverage, 24398,
     /*  853147 */     GIR_EraseRootFromParent_Done,
     /*  853148 */   // Label 13113: @853148
     /*  853148 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(853223), // Rule ID 24399 //
     /*  853153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853199 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11329:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  853202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853221 */     GIR_RootConstrainSelectedInstOperands,
     /*  853222 */     // GIR_Coverage, 24399,
     /*  853222 */     GIR_EraseRootFromParent_Done,
     /*  853223 */   // Label 13114: @853223
     /*  853223 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(853298), // Rule ID 24402 //
     /*  853228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  853277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853296 */     GIR_RootConstrainSelectedInstOperands,
     /*  853297 */     // GIR_Coverage, 24402,
     /*  853297 */     GIR_EraseRootFromParent_Done,
     /*  853298 */   // Label 13115: @853298
     /*  853298 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(853373), // Rule ID 24403 //
     /*  853303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853349 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11329:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  853352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853371 */     GIR_RootConstrainSelectedInstOperands,
     /*  853372 */     // GIR_Coverage, 24403,
     /*  853372 */     GIR_EraseRootFromParent_Done,
     /*  853373 */   // Label 13116: @853373
     /*  853373 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(853448), // Rule ID 24406 //
     /*  853378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  853389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853446 */     GIR_RootConstrainSelectedInstOperands,
     /*  853447 */     // GIR_Coverage, 24406,
     /*  853447 */     GIR_EraseRootFromParent_Done,
     /*  853448 */   // Label 13117: @853448
     /*  853448 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(853523), // Rule ID 24407 //
     /*  853453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  853464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853499 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853521 */     GIR_RootConstrainSelectedInstOperands,
     /*  853522 */     // GIR_Coverage, 24407,
     /*  853522 */     GIR_EraseRootFromParent_Done,
     /*  853523 */   // Label 13118: @853523
     /*  853523 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(853598), // Rule ID 24410 //
     /*  853528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853596 */     GIR_RootConstrainSelectedInstOperands,
     /*  853597 */     // GIR_Coverage, 24410,
     /*  853597 */     GIR_EraseRootFromParent_Done,
     /*  853598 */   // Label 13119: @853598
     /*  853598 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(853673), // Rule ID 24411 //
     /*  853603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853649 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853671 */     GIR_RootConstrainSelectedInstOperands,
     /*  853672 */     // GIR_Coverage, 24411,
     /*  853672 */     GIR_EraseRootFromParent_Done,
     /*  853673 */   // Label 13120: @853673
     /*  853673 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(853748), // Rule ID 24414 //
     /*  853678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853724 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853746 */     GIR_RootConstrainSelectedInstOperands,
     /*  853747 */     // GIR_Coverage, 24414,
     /*  853747 */     GIR_EraseRootFromParent_Done,
     /*  853748 */   // Label 13121: @853748
     /*  853748 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(853823), // Rule ID 24415 //
     /*  853753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853799 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853821 */     GIR_RootConstrainSelectedInstOperands,
     /*  853822 */     // GIR_Coverage, 24415,
     /*  853822 */     GIR_EraseRootFromParent_Done,
     /*  853823 */   // Label 13122: @853823
     /*  853823 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(853898), // Rule ID 24418 //
     /*  853828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853896 */     GIR_RootConstrainSelectedInstOperands,
     /*  853897 */     // GIR_Coverage, 24418,
     /*  853897 */     GIR_EraseRootFromParent_Done,
     /*  853898 */   // Label 13123: @853898
     /*  853898 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(853973), // Rule ID 24419 //
     /*  853903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853971 */     GIR_RootConstrainSelectedInstOperands,
     /*  853972 */     // GIR_Coverage, 24419,
     /*  853972 */     GIR_EraseRootFromParent_Done,
     /*  853973 */   // Label 13124: @853973
     /*  853973 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(854048), // Rule ID 24422 //
     /*  853978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  854027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854046 */     GIR_RootConstrainSelectedInstOperands,
     /*  854047 */     // GIR_Coverage, 24422,
     /*  854047 */     GIR_EraseRootFromParent_Done,
     /*  854048 */   // Label 13125: @854048
     /*  854048 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(854123), // Rule ID 24423 //
     /*  854053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  854064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  854067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  854070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854099 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  854102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854121 */     GIR_RootConstrainSelectedInstOperands,
     /*  854122 */     // GIR_Coverage, 24423,
     /*  854122 */     GIR_EraseRootFromParent_Done,
     /*  854123 */   // Label 13126: @854123
     /*  854123 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(854198), // Rule ID 24426 //
     /*  854128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  854139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  854142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  854145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  854177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854196 */     GIR_RootConstrainSelectedInstOperands,
     /*  854197 */     // GIR_Coverage, 24426,
     /*  854197 */     GIR_EraseRootFromParent_Done,
     /*  854198 */   // Label 13127: @854198
     /*  854198 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(854273), // Rule ID 24427 //
     /*  854203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  854214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  854217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  854220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854249 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  854252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854271 */     GIR_RootConstrainSelectedInstOperands,
     /*  854272 */     // GIR_Coverage, 24427,
     /*  854272 */     GIR_EraseRootFromParent_Done,
     /*  854273 */   // Label 13128: @854273
     /*  854273 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(854348), // Rule ID 24430 //
     /*  854278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  854289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  854292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  854295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  854327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854346 */     GIR_RootConstrainSelectedInstOperands,
     /*  854347 */     // GIR_Coverage, 24430,
     /*  854347 */     GIR_EraseRootFromParent_Done,
     /*  854348 */   // Label 13129: @854348
     /*  854348 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(854423), // Rule ID 24431 //
     /*  854353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  854364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  854367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  854370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11329:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  854402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854421 */     GIR_RootConstrainSelectedInstOperands,
     /*  854422 */     // GIR_Coverage, 24431,
     /*  854422 */     GIR_EraseRootFromParent_Done,
     /*  854423 */   // Label 13130: @854423
     /*  854423 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(854498), // Rule ID 24434 //
     /*  854428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854496 */     GIR_RootConstrainSelectedInstOperands,
     /*  854497 */     // GIR_Coverage, 24434,
     /*  854497 */     GIR_EraseRootFromParent_Done,
     /*  854498 */   // Label 13131: @854498
     /*  854498 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(854573), // Rule ID 24435 //
     /*  854503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854549 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11329:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854571 */     GIR_RootConstrainSelectedInstOperands,
     /*  854572 */     // GIR_Coverage, 24435,
     /*  854572 */     GIR_EraseRootFromParent_Done,
     /*  854573 */   // Label 13132: @854573
     /*  854573 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(854648), // Rule ID 24438 //
     /*  854578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854646 */     GIR_RootConstrainSelectedInstOperands,
     /*  854647 */     // GIR_Coverage, 24438,
     /*  854647 */     GIR_EraseRootFromParent_Done,
     /*  854648 */   // Label 13133: @854648
     /*  854648 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(854723), // Rule ID 24439 //
     /*  854653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854699 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11329:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854721 */     GIR_RootConstrainSelectedInstOperands,
     /*  854722 */     // GIR_Coverage, 24439,
     /*  854722 */     GIR_EraseRootFromParent_Done,
     /*  854723 */   // Label 13134: @854723
     /*  854723 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(854798), // Rule ID 24442 //
     /*  854728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854796 */     GIR_RootConstrainSelectedInstOperands,
     /*  854797 */     // GIR_Coverage, 24442,
     /*  854797 */     GIR_EraseRootFromParent_Done,
     /*  854798 */   // Label 13135: @854798
     /*  854798 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(854873), // Rule ID 24443 //
     /*  854803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854849 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854871 */     GIR_RootConstrainSelectedInstOperands,
     /*  854872 */     // GIR_Coverage, 24443,
     /*  854872 */     GIR_EraseRootFromParent_Done,
     /*  854873 */   // Label 13136: @854873
     /*  854873 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(854948), // Rule ID 24446 //
     /*  854878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854924 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854946 */     GIR_RootConstrainSelectedInstOperands,
     /*  854947 */     // GIR_Coverage, 24446,
     /*  854947 */     GIR_EraseRootFromParent_Done,
     /*  854948 */   // Label 13137: @854948
     /*  854948 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(855023), // Rule ID 24447 //
     /*  854953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  855002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855021 */     GIR_RootConstrainSelectedInstOperands,
     /*  855022 */     // GIR_Coverage, 24447,
     /*  855022 */     GIR_EraseRootFromParent_Done,
     /*  855023 */   // Label 13138: @855023
     /*  855023 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(855098), // Rule ID 24450 //
     /*  855028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  855039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  855042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  855045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  855077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855096 */     GIR_RootConstrainSelectedInstOperands,
     /*  855097 */     // GIR_Coverage, 24450,
     /*  855097 */     GIR_EraseRootFromParent_Done,
     /*  855098 */   // Label 13139: @855098
     /*  855098 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(855173), // Rule ID 24451 //
     /*  855103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  855114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  855117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  855120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  855152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855171 */     GIR_RootConstrainSelectedInstOperands,
     /*  855172 */     // GIR_Coverage, 24451,
     /*  855172 */     GIR_EraseRootFromParent_Done,
     /*  855173 */   // Label 13140: @855173
     /*  855173 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(855248), // Rule ID 24454 //
     /*  855178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  855189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  855192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  855195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  855227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855246 */     GIR_RootConstrainSelectedInstOperands,
     /*  855247 */     // GIR_Coverage, 24454,
     /*  855247 */     GIR_EraseRootFromParent_Done,
     /*  855248 */   // Label 13141: @855248
     /*  855248 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(855323), // Rule ID 24455 //
     /*  855253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  855264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  855267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  855270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11327:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  855302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855321 */     GIR_RootConstrainSelectedInstOperands,
     /*  855322 */     // GIR_Coverage, 24455,
     /*  855322 */     GIR_EraseRootFromParent_Done,
     /*  855323 */   // Label 13142: @855323
     /*  855323 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(855398), // Rule ID 24458 //
     /*  855328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  855339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  855342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  855345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  855377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855396 */     GIR_RootConstrainSelectedInstOperands,
     /*  855397 */     // GIR_Coverage, 24458,
     /*  855397 */     GIR_EraseRootFromParent_Done,
     /*  855398 */   // Label 13143: @855398
     /*  855398 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(855473), // Rule ID 24459 //
     /*  855403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  855414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  855417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  855420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11327:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  855452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855471 */     GIR_RootConstrainSelectedInstOperands,
     /*  855472 */     // GIR_Coverage, 24459,
     /*  855472 */     GIR_EraseRootFromParent_Done,
     /*  855473 */   // Label 13144: @855473
     /*  855473 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(855548), // Rule ID 24462 //
     /*  855478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855546 */     GIR_RootConstrainSelectedInstOperands,
     /*  855547 */     // GIR_Coverage, 24462,
     /*  855547 */     GIR_EraseRootFromParent_Done,
     /*  855548 */   // Label 13145: @855548
     /*  855548 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(855623), // Rule ID 24463 //
     /*  855553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11327:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855621 */     GIR_RootConstrainSelectedInstOperands,
     /*  855622 */     // GIR_Coverage, 24463,
     /*  855622 */     GIR_EraseRootFromParent_Done,
     /*  855623 */   // Label 13146: @855623
     /*  855623 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(855698), // Rule ID 24466 //
     /*  855628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855696 */     GIR_RootConstrainSelectedInstOperands,
     /*  855697 */     // GIR_Coverage, 24466,
     /*  855697 */     GIR_EraseRootFromParent_Done,
     /*  855698 */   // Label 13147: @855698
     /*  855698 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(855773), // Rule ID 24467 //
     /*  855703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855771 */     GIR_RootConstrainSelectedInstOperands,
     /*  855772 */     // GIR_Coverage, 24467,
     /*  855772 */     GIR_EraseRootFromParent_Done,
     /*  855773 */   // Label 13148: @855773
     /*  855773 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(855848), // Rule ID 24470 //
     /*  855778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855846 */     GIR_RootConstrainSelectedInstOperands,
     /*  855847 */     // GIR_Coverage, 24470,
     /*  855847 */     GIR_EraseRootFromParent_Done,
     /*  855848 */   // Label 13149: @855848
     /*  855848 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(855923), // Rule ID 24471 //
     /*  855853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855921 */     GIR_RootConstrainSelectedInstOperands,
     /*  855922 */     // GIR_Coverage, 24471,
     /*  855922 */     GIR_EraseRootFromParent_Done,
     /*  855923 */   // Label 13150: @855923
     /*  855923 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(855998), // Rule ID 24474 //
     /*  855928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855996 */     GIR_RootConstrainSelectedInstOperands,
     /*  855997 */     // GIR_Coverage, 24474,
     /*  855997 */     GIR_EraseRootFromParent_Done,
     /*  855998 */   // Label 13151: @855998
     /*  855998 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(856073), // Rule ID 24475 //
     /*  856003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  856014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  856017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  856020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856049 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  856052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856071 */     GIR_RootConstrainSelectedInstOperands,
     /*  856072 */     // GIR_Coverage, 24475,
     /*  856072 */     GIR_EraseRootFromParent_Done,
     /*  856073 */   // Label 13152: @856073
     /*  856073 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(856148), // Rule ID 24478 //
     /*  856078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  856092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  856127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856146 */     GIR_RootConstrainSelectedInstOperands,
     /*  856147 */     // GIR_Coverage, 24478,
     /*  856147 */     GIR_EraseRootFromParent_Done,
     /*  856148 */   // Label 13153: @856148
     /*  856148 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(856223), // Rule ID 24479 //
     /*  856153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  856164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  856167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  856170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856199 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  856202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856221 */     GIR_RootConstrainSelectedInstOperands,
     /*  856222 */     // GIR_Coverage, 24479,
     /*  856222 */     GIR_EraseRootFromParent_Done,
     /*  856223 */   // Label 13154: @856223
     /*  856223 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(856298), // Rule ID 24482 //
     /*  856228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  856242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  856277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856296 */     GIR_RootConstrainSelectedInstOperands,
     /*  856297 */     // GIR_Coverage, 24482,
     /*  856297 */     GIR_EraseRootFromParent_Done,
     /*  856298 */   // Label 13155: @856298
     /*  856298 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(856373), // Rule ID 24483 //
     /*  856303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  856314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  856317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  856320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  856352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856371 */     GIR_RootConstrainSelectedInstOperands,
     /*  856372 */     // GIR_Coverage, 24483,
     /*  856372 */     GIR_EraseRootFromParent_Done,
     /*  856373 */   // Label 13156: @856373
     /*  856373 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(856448), // Rule ID 24486 //
     /*  856378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856446 */     GIR_RootConstrainSelectedInstOperands,
     /*  856447 */     // GIR_Coverage, 24486,
     /*  856447 */     GIR_EraseRootFromParent_Done,
     /*  856448 */   // Label 13157: @856448
     /*  856448 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(856523), // Rule ID 24487 //
     /*  856453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  856464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856499 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856521 */     GIR_RootConstrainSelectedInstOperands,
     /*  856522 */     // GIR_Coverage, 24487,
     /*  856522 */     GIR_EraseRootFromParent_Done,
     /*  856523 */   // Label 13158: @856523
     /*  856523 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(856598), // Rule ID 24490 //
     /*  856528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856596 */     GIR_RootConstrainSelectedInstOperands,
     /*  856597 */     // GIR_Coverage, 24490,
     /*  856597 */     GIR_EraseRootFromParent_Done,
     /*  856598 */   // Label 13159: @856598
     /*  856598 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(856673), // Rule ID 24491 //
     /*  856603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856649 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11327:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856671 */     GIR_RootConstrainSelectedInstOperands,
     /*  856672 */     // GIR_Coverage, 24491,
     /*  856672 */     GIR_EraseRootFromParent_Done,
     /*  856673 */   // Label 13160: @856673
     /*  856673 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(856748), // Rule ID 24494 //
     /*  856678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856746 */     GIR_RootConstrainSelectedInstOperands,
     /*  856747 */     // GIR_Coverage, 24494,
     /*  856747 */     GIR_EraseRootFromParent_Done,
     /*  856748 */   // Label 13161: @856748
     /*  856748 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(856823), // Rule ID 24495 //
     /*  856753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856799 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11327:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856821 */     GIR_RootConstrainSelectedInstOperands,
     /*  856822 */     // GIR_Coverage, 24495,
     /*  856822 */     GIR_EraseRootFromParent_Done,
     /*  856823 */   // Label 13162: @856823
     /*  856823 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(856898), // Rule ID 24498 //
     /*  856828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856874 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856896 */     GIR_RootConstrainSelectedInstOperands,
     /*  856897 */     // GIR_Coverage, 24498,
     /*  856897 */     GIR_EraseRootFromParent_Done,
     /*  856898 */   // Label 13163: @856898
     /*  856898 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(856973), // Rule ID 24499 //
     /*  856903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11327:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856971 */     GIR_RootConstrainSelectedInstOperands,
     /*  856972 */     // GIR_Coverage, 24499,
     /*  856972 */     GIR_EraseRootFromParent_Done,
     /*  856973 */   // Label 13164: @856973
     /*  856973 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(857048), // Rule ID 24502 //
     /*  856978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  857027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857046 */     GIR_RootConstrainSelectedInstOperands,
     /*  857047 */     // GIR_Coverage, 24502,
     /*  857047 */     GIR_EraseRootFromParent_Done,
     /*  857048 */   // Label 13165: @857048
     /*  857048 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(857123), // Rule ID 24503 //
     /*  857053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  857064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  857067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  857070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  857073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  857102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857121 */     GIR_RootConstrainSelectedInstOperands,
     /*  857122 */     // GIR_Coverage, 24503,
     /*  857122 */     GIR_EraseRootFromParent_Done,
     /*  857123 */   // Label 13166: @857123
     /*  857123 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(857198), // Rule ID 24506 //
     /*  857128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  857139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  857142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  857145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  857148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  857177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857196 */     GIR_RootConstrainSelectedInstOperands,
     /*  857197 */     // GIR_Coverage, 24506,
     /*  857197 */     GIR_EraseRootFromParent_Done,
     /*  857198 */   // Label 13167: @857198
     /*  857198 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(857273), // Rule ID 24507 //
     /*  857203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  857214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  857217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  857220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  857223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857249 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  857252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857271 */     GIR_RootConstrainSelectedInstOperands,
     /*  857272 */     // GIR_Coverage, 24507,
     /*  857272 */     GIR_EraseRootFromParent_Done,
     /*  857273 */   // Label 13168: @857273
     /*  857273 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(857348), // Rule ID 24510 //
     /*  857278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  857289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  857292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  857295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  857298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857324 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  857327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857346 */     GIR_RootConstrainSelectedInstOperands,
     /*  857347 */     // GIR_Coverage, 24510,
     /*  857347 */     GIR_EraseRootFromParent_Done,
     /*  857348 */   // Label 13169: @857348
     /*  857348 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(857423), // Rule ID 24511 //
     /*  857353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  857364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  857367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  857370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  857373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857399 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  857402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857421 */     GIR_RootConstrainSelectedInstOperands,
     /*  857422 */     // GIR_Coverage, 24511,
     /*  857422 */     GIR_EraseRootFromParent_Done,
     /*  857423 */   // Label 13170: @857423
     /*  857423 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(857498), // Rule ID 24514 //
     /*  857428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857496 */     GIR_RootConstrainSelectedInstOperands,
     /*  857497 */     // GIR_Coverage, 24514,
     /*  857497 */     GIR_EraseRootFromParent_Done,
     /*  857498 */   // Label 13171: @857498
     /*  857498 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(857573), // Rule ID 24515 //
     /*  857503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857571 */     GIR_RootConstrainSelectedInstOperands,
     /*  857572 */     // GIR_Coverage, 24515,
     /*  857572 */     GIR_EraseRootFromParent_Done,
     /*  857573 */   // Label 13172: @857573
     /*  857573 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(857648), // Rule ID 24518 //
     /*  857578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857646 */     GIR_RootConstrainSelectedInstOperands,
     /*  857647 */     // GIR_Coverage, 24518,
     /*  857647 */     GIR_EraseRootFromParent_Done,
     /*  857648 */   // Label 13173: @857648
     /*  857648 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(857723), // Rule ID 24519 //
     /*  857653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857699 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857721 */     GIR_RootConstrainSelectedInstOperands,
     /*  857722 */     // GIR_Coverage, 24519,
     /*  857722 */     GIR_EraseRootFromParent_Done,
     /*  857723 */   // Label 13174: @857723
     /*  857723 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(857798), // Rule ID 24522 //
     /*  857728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857796 */     GIR_RootConstrainSelectedInstOperands,
     /*  857797 */     // GIR_Coverage, 24522,
     /*  857797 */     GIR_EraseRootFromParent_Done,
     /*  857798 */   // Label 13175: @857798
     /*  857798 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(857873), // Rule ID 24523 //
     /*  857803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857849 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857871 */     GIR_RootConstrainSelectedInstOperands,
     /*  857872 */     // GIR_Coverage, 24523,
     /*  857872 */     GIR_EraseRootFromParent_Done,
     /*  857873 */   // Label 13176: @857873
     /*  857873 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(857948), // Rule ID 24526 //
     /*  857878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857946 */     GIR_RootConstrainSelectedInstOperands,
     /*  857947 */     // GIR_Coverage, 24526,
     /*  857947 */     GIR_EraseRootFromParent_Done,
     /*  857948 */   // Label 13177: @857948
     /*  857948 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(858023), // Rule ID 24527 //
     /*  857953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11575:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  858002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858021 */     GIR_RootConstrainSelectedInstOperands,
     /*  858022 */     // GIR_Coverage, 24527,
     /*  858022 */     GIR_EraseRootFromParent_Done,
     /*  858023 */   // Label 13178: @858023
     /*  858023 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(858098), // Rule ID 24530 //
     /*  858028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  858048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  858077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858096 */     GIR_RootConstrainSelectedInstOperands,
     /*  858097 */     // GIR_Coverage, 24530,
     /*  858097 */     GIR_EraseRootFromParent_Done,
     /*  858098 */   // Label 13179: @858098
     /*  858098 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(858173), // Rule ID 24531 //
     /*  858103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  858123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  858152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858171 */     GIR_RootConstrainSelectedInstOperands,
     /*  858172 */     // GIR_Coverage, 24531,
     /*  858172 */     GIR_EraseRootFromParent_Done,
     /*  858173 */   // Label 13180: @858173
     /*  858173 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(858248), // Rule ID 24534 //
     /*  858178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  858198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  858227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858246 */     GIR_RootConstrainSelectedInstOperands,
     /*  858247 */     // GIR_Coverage, 24534,
     /*  858247 */     GIR_EraseRootFromParent_Done,
     /*  858248 */   // Label 13181: @858248
     /*  858248 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(858323), // Rule ID 24535 //
     /*  858253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  858273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  858302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858321 */     GIR_RootConstrainSelectedInstOperands,
     /*  858322 */     // GIR_Coverage, 24535,
     /*  858322 */     GIR_EraseRootFromParent_Done,
     /*  858323 */   // Label 13182: @858323
     /*  858323 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(858398), // Rule ID 24538 //
     /*  858328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  858331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  858348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  858377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858396 */     GIR_RootConstrainSelectedInstOperands,
     /*  858397 */     // GIR_Coverage, 24538,
     /*  858397 */     GIR_EraseRootFromParent_Done,
     /*  858398 */   // Label 13183: @858398
     /*  858398 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(858473), // Rule ID 24539 //
     /*  858403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  858406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  858423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  858452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858471 */     GIR_RootConstrainSelectedInstOperands,
     /*  858472 */     // GIR_Coverage, 24539,
     /*  858472 */     GIR_EraseRootFromParent_Done,
     /*  858473 */   // Label 13184: @858473
     /*  858473 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(858548), // Rule ID 24542 //
     /*  858478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858546 */     GIR_RootConstrainSelectedInstOperands,
     /*  858547 */     // GIR_Coverage, 24542,
     /*  858547 */     GIR_EraseRootFromParent_Done,
     /*  858548 */   // Label 13185: @858548
     /*  858548 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(858623), // Rule ID 24543 //
     /*  858553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858599 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858621 */     GIR_RootConstrainSelectedInstOperands,
     /*  858622 */     // GIR_Coverage, 24543,
     /*  858622 */     GIR_EraseRootFromParent_Done,
     /*  858623 */   // Label 13186: @858623
     /*  858623 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(858698), // Rule ID 24546 //
     /*  858628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858696 */     GIR_RootConstrainSelectedInstOperands,
     /*  858697 */     // GIR_Coverage, 24546,
     /*  858697 */     GIR_EraseRootFromParent_Done,
     /*  858698 */   // Label 13187: @858698
     /*  858698 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(858773), // Rule ID 24547 //
     /*  858703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858749 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858771 */     GIR_RootConstrainSelectedInstOperands,
     /*  858772 */     // GIR_Coverage, 24547,
     /*  858772 */     GIR_EraseRootFromParent_Done,
     /*  858773 */   // Label 13188: @858773
     /*  858773 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(858848), // Rule ID 24550 //
     /*  858778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858846 */     GIR_RootConstrainSelectedInstOperands,
     /*  858847 */     // GIR_Coverage, 24550,
     /*  858847 */     GIR_EraseRootFromParent_Done,
     /*  858848 */   // Label 13189: @858848
     /*  858848 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(858923), // Rule ID 24551 //
     /*  858853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858899 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858921 */     GIR_RootConstrainSelectedInstOperands,
     /*  858922 */     // GIR_Coverage, 24551,
     /*  858922 */     GIR_EraseRootFromParent_Done,
     /*  858923 */   // Label 13190: @858923
     /*  858923 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(858998), // Rule ID 24554 //
     /*  858928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858996 */     GIR_RootConstrainSelectedInstOperands,
     /*  858997 */     // GIR_Coverage, 24554,
     /*  858997 */     GIR_EraseRootFromParent_Done,
     /*  858998 */   // Label 13191: @858998
     /*  858998 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(859073), // Rule ID 24555 //
     /*  859003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  859023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  859052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859071 */     GIR_RootConstrainSelectedInstOperands,
     /*  859072 */     // GIR_Coverage, 24555,
     /*  859072 */     GIR_EraseRootFromParent_Done,
     /*  859073 */   // Label 13192: @859073
     /*  859073 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(859148), // Rule ID 24558 //
     /*  859078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  859098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  859127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859146 */     GIR_RootConstrainSelectedInstOperands,
     /*  859147 */     // GIR_Coverage, 24558,
     /*  859147 */     GIR_EraseRootFromParent_Done,
     /*  859148 */   // Label 13193: @859148
     /*  859148 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(859223), // Rule ID 24559 //
     /*  859153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  859173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  859202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859221 */     GIR_RootConstrainSelectedInstOperands,
     /*  859222 */     // GIR_Coverage, 24559,
     /*  859222 */     GIR_EraseRootFromParent_Done,
     /*  859223 */   // Label 13194: @859223
     /*  859223 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(859298), // Rule ID 24562 //
     /*  859228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  859248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  859277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859296 */     GIR_RootConstrainSelectedInstOperands,
     /*  859297 */     // GIR_Coverage, 24562,
     /*  859297 */     GIR_EraseRootFromParent_Done,
     /*  859298 */   // Label 13195: @859298
     /*  859298 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(859373), // Rule ID 24563 //
     /*  859303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  859323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  859352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859371 */     GIR_RootConstrainSelectedInstOperands,
     /*  859372 */     // GIR_Coverage, 24563,
     /*  859372 */     GIR_EraseRootFromParent_Done,
     /*  859373 */   // Label 13196: @859373
     /*  859373 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(859448), // Rule ID 24566 //
     /*  859378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859446 */     GIR_RootConstrainSelectedInstOperands,
     /*  859447 */     // GIR_Coverage, 24566,
     /*  859447 */     GIR_EraseRootFromParent_Done,
     /*  859448 */   // Label 13197: @859448
     /*  859448 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(859523), // Rule ID 24567 //
     /*  859453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859521 */     GIR_RootConstrainSelectedInstOperands,
     /*  859522 */     // GIR_Coverage, 24567,
     /*  859522 */     GIR_EraseRootFromParent_Done,
     /*  859523 */   // Label 13198: @859523
     /*  859523 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(859598), // Rule ID 24570 //
     /*  859528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859596 */     GIR_RootConstrainSelectedInstOperands,
     /*  859597 */     // GIR_Coverage, 24570,
     /*  859597 */     GIR_EraseRootFromParent_Done,
     /*  859598 */   // Label 13199: @859598
     /*  859598 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(859673), // Rule ID 24571 //
     /*  859603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859649 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859671 */     GIR_RootConstrainSelectedInstOperands,
     /*  859672 */     // GIR_Coverage, 24571,
     /*  859672 */     GIR_EraseRootFromParent_Done,
     /*  859673 */   // Label 13200: @859673
     /*  859673 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(859748), // Rule ID 24574 //
     /*  859678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859746 */     GIR_RootConstrainSelectedInstOperands,
     /*  859747 */     // GIR_Coverage, 24574,
     /*  859747 */     GIR_EraseRootFromParent_Done,
     /*  859748 */   // Label 13201: @859748
     /*  859748 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(859823), // Rule ID 24575 //
     /*  859753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859821 */     GIR_RootConstrainSelectedInstOperands,
     /*  859822 */     // GIR_Coverage, 24575,
     /*  859822 */     GIR_EraseRootFromParent_Done,
     /*  859823 */   // Label 13202: @859823
     /*  859823 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(859898), // Rule ID 24578 //
     /*  859828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859896 */     GIR_RootConstrainSelectedInstOperands,
     /*  859897 */     // GIR_Coverage, 24578,
     /*  859897 */     GIR_EraseRootFromParent_Done,
     /*  859898 */   // Label 13203: @859898
     /*  859898 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(859973), // Rule ID 24579 //
     /*  859903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859971 */     GIR_RootConstrainSelectedInstOperands,
     /*  859972 */     // GIR_Coverage, 24579,
     /*  859972 */     GIR_EraseRootFromParent_Done,
     /*  859973 */   // Label 13204: @859973
     /*  859973 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(860048), // Rule ID 24582 //
     /*  859978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  860027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860046 */     GIR_RootConstrainSelectedInstOperands,
     /*  860047 */     // GIR_Coverage, 24582,
     /*  860047 */     GIR_EraseRootFromParent_Done,
     /*  860048 */   // Label 13205: @860048
     /*  860048 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(860123), // Rule ID 24583 //
     /*  860053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  860056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  860073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860099 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  860102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860121 */     GIR_RootConstrainSelectedInstOperands,
     /*  860122 */     // GIR_Coverage, 24583,
     /*  860122 */     GIR_EraseRootFromParent_Done,
     /*  860123 */   // Label 13206: @860123
     /*  860123 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(860198), // Rule ID 24586 //
     /*  860128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  860131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  860148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  860177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860196 */     GIR_RootConstrainSelectedInstOperands,
     /*  860197 */     // GIR_Coverage, 24586,
     /*  860197 */     GIR_EraseRootFromParent_Done,
     /*  860198 */   // Label 13207: @860198
     /*  860198 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(860273), // Rule ID 24587 //
     /*  860203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  860206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  860223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860249 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  860252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860271 */     GIR_RootConstrainSelectedInstOperands,
     /*  860272 */     // GIR_Coverage, 24587,
     /*  860272 */     GIR_EraseRootFromParent_Done,
     /*  860273 */   // Label 13208: @860273
     /*  860273 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(860348), // Rule ID 24590 //
     /*  860278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860324 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  860327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860346 */     GIR_RootConstrainSelectedInstOperands,
     /*  860347 */     // GIR_Coverage, 24590,
     /*  860347 */     GIR_EraseRootFromParent_Done,
     /*  860348 */   // Label 13209: @860348
     /*  860348 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(860423), // Rule ID 24591 //
     /*  860353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860399 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  860402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860421 */     GIR_RootConstrainSelectedInstOperands,
     /*  860422 */     // GIR_Coverage, 24591,
     /*  860422 */     GIR_EraseRootFromParent_Done,
     /*  860423 */   // Label 13210: @860423
     /*  860423 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(860498), // Rule ID 24594 //
     /*  860428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860474 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860496 */     GIR_RootConstrainSelectedInstOperands,
     /*  860497 */     // GIR_Coverage, 24594,
     /*  860497 */     GIR_EraseRootFromParent_Done,
     /*  860498 */   // Label 13211: @860498
     /*  860498 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(860573), // Rule ID 24595 //
     /*  860503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860549 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860571 */     GIR_RootConstrainSelectedInstOperands,
     /*  860572 */     // GIR_Coverage, 24595,
     /*  860572 */     GIR_EraseRootFromParent_Done,
     /*  860573 */   // Label 13212: @860573
     /*  860573 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(860648), // Rule ID 24598 //
     /*  860578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860646 */     GIR_RootConstrainSelectedInstOperands,
     /*  860647 */     // GIR_Coverage, 24598,
     /*  860647 */     GIR_EraseRootFromParent_Done,
     /*  860648 */   // Label 13213: @860648
     /*  860648 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(860723), // Rule ID 24599 //
     /*  860653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860699 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860721 */     GIR_RootConstrainSelectedInstOperands,
     /*  860722 */     // GIR_Coverage, 24599,
     /*  860722 */     GIR_EraseRootFromParent_Done,
     /*  860723 */   // Label 13214: @860723
     /*  860723 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(860798), // Rule ID 24602 //
     /*  860728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860796 */     GIR_RootConstrainSelectedInstOperands,
     /*  860797 */     // GIR_Coverage, 24602,
     /*  860797 */     GIR_EraseRootFromParent_Done,
     /*  860798 */   // Label 13215: @860798
     /*  860798 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(860873), // Rule ID 24603 //
     /*  860803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860871 */     GIR_RootConstrainSelectedInstOperands,
     /*  860872 */     // GIR_Coverage, 24603,
     /*  860872 */     GIR_EraseRootFromParent_Done,
     /*  860873 */   // Label 13216: @860873
     /*  860873 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(860948), // Rule ID 24606 //
     /*  860878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860946 */     GIR_RootConstrainSelectedInstOperands,
     /*  860947 */     // GIR_Coverage, 24606,
     /*  860947 */     GIR_EraseRootFromParent_Done,
     /*  860948 */   // Label 13217: @860948
     /*  860948 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(861023), // Rule ID 24607 //
     /*  860953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860999 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861021 */     GIR_RootConstrainSelectedInstOperands,
     /*  861022 */     // GIR_Coverage, 24607,
     /*  861022 */     GIR_EraseRootFromParent_Done,
     /*  861023 */   // Label 13218: @861023
     /*  861023 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(861098), // Rule ID 24610 //
     /*  861028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861096 */     GIR_RootConstrainSelectedInstOperands,
     /*  861097 */     // GIR_Coverage, 24610,
     /*  861097 */     GIR_EraseRootFromParent_Done,
     /*  861098 */   // Label 13219: @861098
     /*  861098 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(861173), // Rule ID 24611 //
     /*  861103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  861152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861171 */     GIR_RootConstrainSelectedInstOperands,
     /*  861172 */     // GIR_Coverage, 24611,
     /*  861172 */     GIR_EraseRootFromParent_Done,
     /*  861173 */   // Label 13220: @861173
     /*  861173 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(861248), // Rule ID 24614 //
     /*  861178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861246 */     GIR_RootConstrainSelectedInstOperands,
     /*  861247 */     // GIR_Coverage, 24614,
     /*  861247 */     GIR_EraseRootFromParent_Done,
     /*  861248 */   // Label 13221: @861248
     /*  861248 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(861323), // Rule ID 24615 //
     /*  861253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11577:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861321 */     GIR_RootConstrainSelectedInstOperands,
     /*  861322 */     // GIR_Coverage, 24615,
     /*  861322 */     GIR_EraseRootFromParent_Done,
     /*  861323 */   // Label 13222: @861323
     /*  861323 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(861398), // Rule ID 24618 //
     /*  861328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861396 */     GIR_RootConstrainSelectedInstOperands,
     /*  861397 */     // GIR_Coverage, 24618,
     /*  861397 */     GIR_EraseRootFromParent_Done,
     /*  861398 */   // Label 13223: @861398
     /*  861398 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(861473), // Rule ID 24619 //
     /*  861403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861471 */     GIR_RootConstrainSelectedInstOperands,
     /*  861472 */     // GIR_Coverage, 24619,
     /*  861472 */     GIR_EraseRootFromParent_Done,
     /*  861473 */   // Label 13224: @861473
     /*  861473 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(861548), // Rule ID 24622 //
     /*  861478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861546 */     GIR_RootConstrainSelectedInstOperands,
     /*  861547 */     // GIR_Coverage, 24622,
     /*  861547 */     GIR_EraseRootFromParent_Done,
     /*  861548 */   // Label 13225: @861548
     /*  861548 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(861623), // Rule ID 24623 //
     /*  861553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861621 */     GIR_RootConstrainSelectedInstOperands,
     /*  861622 */     // GIR_Coverage, 24623,
     /*  861622 */     GIR_EraseRootFromParent_Done,
     /*  861623 */   // Label 13226: @861623
     /*  861623 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(861698), // Rule ID 24626 //
     /*  861628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861696 */     GIR_RootConstrainSelectedInstOperands,
     /*  861697 */     // GIR_Coverage, 24626,
     /*  861697 */     GIR_EraseRootFromParent_Done,
     /*  861698 */   // Label 13227: @861698
     /*  861698 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(861773), // Rule ID 24627 //
     /*  861703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861771 */     GIR_RootConstrainSelectedInstOperands,
     /*  861772 */     // GIR_Coverage, 24627,
     /*  861772 */     GIR_EraseRootFromParent_Done,
     /*  861773 */   // Label 13228: @861773
     /*  861773 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(861848), // Rule ID 24630 //
     /*  861778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861824 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861846 */     GIR_RootConstrainSelectedInstOperands,
     /*  861847 */     // GIR_Coverage, 24630,
     /*  861847 */     GIR_EraseRootFromParent_Done,
     /*  861848 */   // Label 13229: @861848
     /*  861848 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(861923), // Rule ID 24631 //
     /*  861853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861899 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861921 */     GIR_RootConstrainSelectedInstOperands,
     /*  861922 */     // GIR_Coverage, 24631,
     /*  861922 */     GIR_EraseRootFromParent_Done,
     /*  861923 */   // Label 13230: @861923
     /*  861923 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(861998), // Rule ID 24634 //
     /*  861928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861974 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861996 */     GIR_RootConstrainSelectedInstOperands,
     /*  861997 */     // GIR_Coverage, 24634,
     /*  861997 */     GIR_EraseRootFromParent_Done,
     /*  861998 */   // Label 13231: @861998
     /*  861998 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(862073), // Rule ID 24635 //
     /*  862003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862049 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862071 */     GIR_RootConstrainSelectedInstOperands,
     /*  862072 */     // GIR_Coverage, 24635,
     /*  862072 */     GIR_EraseRootFromParent_Done,
     /*  862073 */   // Label 13232: @862073
     /*  862073 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(862148), // Rule ID 24638 //
     /*  862078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862124 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862146 */     GIR_RootConstrainSelectedInstOperands,
     /*  862147 */     // GIR_Coverage, 24638,
     /*  862147 */     GIR_EraseRootFromParent_Done,
     /*  862148 */   // Label 13233: @862148
     /*  862148 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(862223), // Rule ID 24639 //
     /*  862153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862199 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862221 */     GIR_RootConstrainSelectedInstOperands,
     /*  862222 */     // GIR_Coverage, 24639,
     /*  862222 */     GIR_EraseRootFromParent_Done,
     /*  862223 */   // Label 13234: @862223
     /*  862223 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(862298), // Rule ID 24642 //
     /*  862228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862296 */     GIR_RootConstrainSelectedInstOperands,
     /*  862297 */     // GIR_Coverage, 24642,
     /*  862297 */     GIR_EraseRootFromParent_Done,
     /*  862298 */   // Label 13235: @862298
     /*  862298 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(862373), // Rule ID 24643 //
     /*  862303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862371 */     GIR_RootConstrainSelectedInstOperands,
     /*  862372 */     // GIR_Coverage, 24643,
     /*  862372 */     GIR_EraseRootFromParent_Done,
     /*  862373 */   // Label 13236: @862373
     /*  862373 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(862448), // Rule ID 24646 //
     /*  862378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862446 */     GIR_RootConstrainSelectedInstOperands,
     /*  862447 */     // GIR_Coverage, 24646,
     /*  862447 */     GIR_EraseRootFromParent_Done,
     /*  862448 */   // Label 13237: @862448
     /*  862448 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(862523), // Rule ID 24647 //
     /*  862453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862499 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862521 */     GIR_RootConstrainSelectedInstOperands,
     /*  862522 */     // GIR_Coverage, 24647,
     /*  862522 */     GIR_EraseRootFromParent_Done,
     /*  862523 */   // Label 13238: @862523
     /*  862523 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(862598), // Rule ID 24650 //
     /*  862528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862596 */     GIR_RootConstrainSelectedInstOperands,
     /*  862597 */     // GIR_Coverage, 24650,
     /*  862597 */     GIR_EraseRootFromParent_Done,
     /*  862598 */   // Label 13239: @862598
     /*  862598 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(862673), // Rule ID 24651 //
     /*  862603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862649 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862671 */     GIR_RootConstrainSelectedInstOperands,
     /*  862672 */     // GIR_Coverage, 24651,
     /*  862672 */     GIR_EraseRootFromParent_Done,
     /*  862673 */   // Label 13240: @862673
     /*  862673 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(862748), // Rule ID 24654 //
     /*  862678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862746 */     GIR_RootConstrainSelectedInstOperands,
     /*  862747 */     // GIR_Coverage, 24654,
     /*  862747 */     GIR_EraseRootFromParent_Done,
     /*  862748 */   // Label 13241: @862748
     /*  862748 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(862823), // Rule ID 24655 //
     /*  862753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862821 */     GIR_RootConstrainSelectedInstOperands,
     /*  862822 */     // GIR_Coverage, 24655,
     /*  862822 */     GIR_EraseRootFromParent_Done,
     /*  862823 */   // Label 13242: @862823
     /*  862823 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(862898), // Rule ID 24658 //
     /*  862828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862896 */     GIR_RootConstrainSelectedInstOperands,
     /*  862897 */     // GIR_Coverage, 24658,
     /*  862897 */     GIR_EraseRootFromParent_Done,
     /*  862898 */   // Label 13243: @862898
     /*  862898 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(862973), // Rule ID 24659 //
     /*  862903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862971 */     GIR_RootConstrainSelectedInstOperands,
     /*  862972 */     // GIR_Coverage, 24659,
     /*  862972 */     GIR_EraseRootFromParent_Done,
     /*  862973 */   // Label 13244: @862973
     /*  862973 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(863048), // Rule ID 24662 //
     /*  862978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863046 */     GIR_RootConstrainSelectedInstOperands,
     /*  863047 */     // GIR_Coverage, 24662,
     /*  863047 */     GIR_EraseRootFromParent_Done,
     /*  863048 */   // Label 13245: @863048
     /*  863048 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(863123), // Rule ID 24663 //
     /*  863053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863121 */     GIR_RootConstrainSelectedInstOperands,
     /*  863122 */     // GIR_Coverage, 24663,
     /*  863122 */     GIR_EraseRootFromParent_Done,
     /*  863123 */   // Label 13246: @863123
     /*  863123 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(863198), // Rule ID 24666 //
     /*  863128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  863177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863196 */     GIR_RootConstrainSelectedInstOperands,
     /*  863197 */     // GIR_Coverage, 24666,
     /*  863197 */     GIR_EraseRootFromParent_Done,
     /*  863198 */   // Label 13247: @863198
     /*  863198 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(863273), // Rule ID 24667 //
     /*  863203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  863252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863271 */     GIR_RootConstrainSelectedInstOperands,
     /*  863272 */     // GIR_Coverage, 24667,
     /*  863272 */     GIR_EraseRootFromParent_Done,
     /*  863273 */   // Label 13248: @863273
     /*  863273 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(863348), // Rule ID 24670 //
     /*  863278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  863327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863346 */     GIR_RootConstrainSelectedInstOperands,
     /*  863347 */     // GIR_Coverage, 24670,
     /*  863347 */     GIR_EraseRootFromParent_Done,
     /*  863348 */   // Label 13249: @863348
     /*  863348 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(863423), // Rule ID 24671 //
     /*  863353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863399 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  863402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863421 */     GIR_RootConstrainSelectedInstOperands,
     /*  863422 */     // GIR_Coverage, 24671,
     /*  863422 */     GIR_EraseRootFromParent_Done,
     /*  863423 */   // Label 13250: @863423
     /*  863423 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(863498), // Rule ID 24674 //
     /*  863428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863496 */     GIR_RootConstrainSelectedInstOperands,
     /*  863497 */     // GIR_Coverage, 24674,
     /*  863497 */     GIR_EraseRootFromParent_Done,
     /*  863498 */   // Label 13251: @863498
     /*  863498 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(863573), // Rule ID 24675 //
     /*  863503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863549 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863571 */     GIR_RootConstrainSelectedInstOperands,
     /*  863572 */     // GIR_Coverage, 24675,
     /*  863572 */     GIR_EraseRootFromParent_Done,
     /*  863573 */   // Label 13252: @863573
     /*  863573 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(863648), // Rule ID 24766 //
     /*  863578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863646 */     GIR_RootConstrainSelectedInstOperands,
     /*  863647 */     // GIR_Coverage, 24766,
     /*  863647 */     GIR_EraseRootFromParent_Done,
     /*  863648 */   // Label 13253: @863648
     /*  863648 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(863723), // Rule ID 24767 //
     /*  863653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863699 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863721 */     GIR_RootConstrainSelectedInstOperands,
     /*  863722 */     // GIR_Coverage, 24767,
     /*  863722 */     GIR_EraseRootFromParent_Done,
     /*  863723 */   // Label 13254: @863723
     /*  863723 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(863798), // Rule ID 24770 //
     /*  863728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863796 */     GIR_RootConstrainSelectedInstOperands,
     /*  863797 */     // GIR_Coverage, 24770,
     /*  863797 */     GIR_EraseRootFromParent_Done,
     /*  863798 */   // Label 13255: @863798
     /*  863798 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(863873), // Rule ID 24771 //
     /*  863803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863849 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863871 */     GIR_RootConstrainSelectedInstOperands,
     /*  863872 */     // GIR_Coverage, 24771,
     /*  863872 */     GIR_EraseRootFromParent_Done,
     /*  863873 */   // Label 13256: @863873
     /*  863873 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(863948), // Rule ID 24774 //
     /*  863878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863946 */     GIR_RootConstrainSelectedInstOperands,
     /*  863947 */     // GIR_Coverage, 24774,
     /*  863947 */     GIR_EraseRootFromParent_Done,
     /*  863948 */   // Label 13257: @863948
     /*  863948 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(864023), // Rule ID 24775 //
     /*  863953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863999 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  864002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864021 */     GIR_RootConstrainSelectedInstOperands,
     /*  864022 */     // GIR_Coverage, 24775,
     /*  864022 */     GIR_EraseRootFromParent_Done,
     /*  864023 */   // Label 13258: @864023
     /*  864023 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(864098), // Rule ID 24778 //
     /*  864028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  864077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864096 */     GIR_RootConstrainSelectedInstOperands,
     /*  864097 */     // GIR_Coverage, 24778,
     /*  864097 */     GIR_EraseRootFromParent_Done,
     /*  864098 */   // Label 13259: @864098
     /*  864098 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(864173), // Rule ID 24779 //
     /*  864103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864149 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  864152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864171 */     GIR_RootConstrainSelectedInstOperands,
     /*  864172 */     // GIR_Coverage, 24779,
     /*  864172 */     GIR_EraseRootFromParent_Done,
     /*  864173 */   // Label 13260: @864173
     /*  864173 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(864248), // Rule ID 24782 //
     /*  864178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  864227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864246 */     GIR_RootConstrainSelectedInstOperands,
     /*  864247 */     // GIR_Coverage, 24782,
     /*  864247 */     GIR_EraseRootFromParent_Done,
     /*  864248 */   // Label 13261: @864248
     /*  864248 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(864323), // Rule ID 24783 //
     /*  864253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864299 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  864302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864321 */     GIR_RootConstrainSelectedInstOperands,
     /*  864322 */     // GIR_Coverage, 24783,
     /*  864322 */     GIR_EraseRootFromParent_Done,
     /*  864323 */   // Label 13262: @864323
     /*  864323 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(864398), // Rule ID 24786 //
     /*  864328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  864377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864396 */     GIR_RootConstrainSelectedInstOperands,
     /*  864397 */     // GIR_Coverage, 24786,
     /*  864397 */     GIR_EraseRootFromParent_Done,
     /*  864398 */   // Label 13263: @864398
     /*  864398 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(864473), // Rule ID 24787 //
     /*  864403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  864452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864471 */     GIR_RootConstrainSelectedInstOperands,
     /*  864472 */     // GIR_Coverage, 24787,
     /*  864472 */     GIR_EraseRootFromParent_Done,
     /*  864473 */   // Label 13264: @864473
     /*  864473 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(864548), // Rule ID 24790 //
     /*  864478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864546 */     GIR_RootConstrainSelectedInstOperands,
     /*  864547 */     // GIR_Coverage, 24790,
     /*  864547 */     GIR_EraseRootFromParent_Done,
     /*  864548 */   // Label 13265: @864548
     /*  864548 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(864623), // Rule ID 24791 //
     /*  864553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864621 */     GIR_RootConstrainSelectedInstOperands,
     /*  864622 */     // GIR_Coverage, 24791,
     /*  864622 */     GIR_EraseRootFromParent_Done,
     /*  864623 */   // Label 13266: @864623
     /*  864623 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(864698), // Rule ID 24794 //
     /*  864628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864696 */     GIR_RootConstrainSelectedInstOperands,
     /*  864697 */     // GIR_Coverage, 24794,
     /*  864697 */     GIR_EraseRootFromParent_Done,
     /*  864698 */   // Label 13267: @864698
     /*  864698 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(864773), // Rule ID 24795 //
     /*  864703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864771 */     GIR_RootConstrainSelectedInstOperands,
     /*  864772 */     // GIR_Coverage, 24795,
     /*  864772 */     GIR_EraseRootFromParent_Done,
     /*  864773 */   // Label 13268: @864773
     /*  864773 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(864848), // Rule ID 24798 //
     /*  864778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864846 */     GIR_RootConstrainSelectedInstOperands,
     /*  864847 */     // GIR_Coverage, 24798,
     /*  864847 */     GIR_EraseRootFromParent_Done,
     /*  864848 */   // Label 13269: @864848
     /*  864848 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(864923), // Rule ID 24799 //
     /*  864853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864921 */     GIR_RootConstrainSelectedInstOperands,
     /*  864922 */     // GIR_Coverage, 24799,
     /*  864922 */     GIR_EraseRootFromParent_Done,
     /*  864923 */   // Label 13270: @864923
     /*  864923 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(864998), // Rule ID 24802 //
     /*  864928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  864931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  864974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864996 */     GIR_RootConstrainSelectedInstOperands,
     /*  864997 */     // GIR_Coverage, 24802,
     /*  864997 */     GIR_EraseRootFromParent_Done,
     /*  864998 */   // Label 13271: @864998
     /*  864998 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(865073), // Rule ID 24803 //
     /*  865003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  865023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  865052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865071 */     GIR_RootConstrainSelectedInstOperands,
     /*  865072 */     // GIR_Coverage, 24803,
     /*  865072 */     GIR_EraseRootFromParent_Done,
     /*  865073 */   // Label 13272: @865073
     /*  865073 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(865148), // Rule ID 24806 //
     /*  865078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  865127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865146 */     GIR_RootConstrainSelectedInstOperands,
     /*  865147 */     // GIR_Coverage, 24806,
     /*  865147 */     GIR_EraseRootFromParent_Done,
     /*  865148 */   // Label 13273: @865148
     /*  865148 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(865223), // Rule ID 24807 //
     /*  865153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865199 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  865202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865221 */     GIR_RootConstrainSelectedInstOperands,
     /*  865222 */     // GIR_Coverage, 24807,
     /*  865222 */     GIR_EraseRootFromParent_Done,
     /*  865223 */   // Label 13274: @865223
     /*  865223 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(865298), // Rule ID 24810 //
     /*  865228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  865277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865296 */     GIR_RootConstrainSelectedInstOperands,
     /*  865297 */     // GIR_Coverage, 24810,
     /*  865297 */     GIR_EraseRootFromParent_Done,
     /*  865298 */   // Label 13275: @865298
     /*  865298 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(865373), // Rule ID 24811 //
     /*  865303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865349 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  865352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865371 */     GIR_RootConstrainSelectedInstOperands,
     /*  865372 */     // GIR_Coverage, 24811,
     /*  865372 */     GIR_EraseRootFromParent_Done,
     /*  865373 */   // Label 13276: @865373
     /*  865373 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(865448), // Rule ID 24814 //
     /*  865378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865446 */     GIR_RootConstrainSelectedInstOperands,
     /*  865447 */     // GIR_Coverage, 24814,
     /*  865447 */     GIR_EraseRootFromParent_Done,
     /*  865448 */   // Label 13277: @865448
     /*  865448 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(865523), // Rule ID 24815 //
     /*  865453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865521 */     GIR_RootConstrainSelectedInstOperands,
     /*  865522 */     // GIR_Coverage, 24815,
     /*  865522 */     GIR_EraseRootFromParent_Done,
     /*  865523 */   // Label 13278: @865523
     /*  865523 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(865598), // Rule ID 24818 //
     /*  865528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865596 */     GIR_RootConstrainSelectedInstOperands,
     /*  865597 */     // GIR_Coverage, 24818,
     /*  865597 */     GIR_EraseRootFromParent_Done,
     /*  865598 */   // Label 13279: @865598
     /*  865598 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(865673), // Rule ID 24819 //
     /*  865603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865649 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865671 */     GIR_RootConstrainSelectedInstOperands,
     /*  865672 */     // GIR_Coverage, 24819,
     /*  865672 */     GIR_EraseRootFromParent_Done,
     /*  865673 */   // Label 13280: @865673
     /*  865673 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(865748), // Rule ID 24822 //
     /*  865678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865746 */     GIR_RootConstrainSelectedInstOperands,
     /*  865747 */     // GIR_Coverage, 24822,
     /*  865747 */     GIR_EraseRootFromParent_Done,
     /*  865748 */   // Label 13281: @865748
     /*  865748 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(865823), // Rule ID 24823 //
     /*  865753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865821 */     GIR_RootConstrainSelectedInstOperands,
     /*  865822 */     // GIR_Coverage, 24823,
     /*  865822 */     GIR_EraseRootFromParent_Done,
     /*  865823 */   // Label 13282: @865823
     /*  865823 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(865898), // Rule ID 24826 //
     /*  865828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865896 */     GIR_RootConstrainSelectedInstOperands,
     /*  865897 */     // GIR_Coverage, 24826,
     /*  865897 */     GIR_EraseRootFromParent_Done,
     /*  865898 */   // Label 13283: @865898
     /*  865898 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(865973), // Rule ID 24827 //
     /*  865903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865971 */     GIR_RootConstrainSelectedInstOperands,
     /*  865972 */     // GIR_Coverage, 24827,
     /*  865972 */     GIR_EraseRootFromParent_Done,
     /*  865973 */   // Label 13284: @865973
     /*  865973 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(866048), // Rule ID 24830 //
     /*  865978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  866027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866046 */     GIR_RootConstrainSelectedInstOperands,
     /*  866047 */     // GIR_Coverage, 24830,
     /*  866047 */     GIR_EraseRootFromParent_Done,
     /*  866048 */   // Label 13285: @866048
     /*  866048 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(866123), // Rule ID 24831 //
     /*  866053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  866102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866121 */     GIR_RootConstrainSelectedInstOperands,
     /*  866122 */     // GIR_Coverage, 24831,
     /*  866122 */     GIR_EraseRootFromParent_Done,
     /*  866123 */   // Label 13286: @866123
     /*  866123 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(866198), // Rule ID 24834 //
     /*  866128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  866148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  866177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866196 */     GIR_RootConstrainSelectedInstOperands,
     /*  866197 */     // GIR_Coverage, 24834,
     /*  866197 */     GIR_EraseRootFromParent_Done,
     /*  866198 */   // Label 13287: @866198
     /*  866198 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(866273), // Rule ID 24835 //
     /*  866203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  866223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  866252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866271 */     GIR_RootConstrainSelectedInstOperands,
     /*  866272 */     // GIR_Coverage, 24835,
     /*  866272 */     GIR_EraseRootFromParent_Done,
     /*  866273 */   // Label 13288: @866273
     /*  866273 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(866348), // Rule ID 24838 //
     /*  866278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  866327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866346 */     GIR_RootConstrainSelectedInstOperands,
     /*  866347 */     // GIR_Coverage, 24838,
     /*  866347 */     GIR_EraseRootFromParent_Done,
     /*  866348 */   // Label 13289: @866348
     /*  866348 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(866423), // Rule ID 24839 //
     /*  866353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  866402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866421 */     GIR_RootConstrainSelectedInstOperands,
     /*  866422 */     // GIR_Coverage, 24839,
     /*  866422 */     GIR_EraseRootFromParent_Done,
     /*  866423 */   // Label 13290: @866423
     /*  866423 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(866498), // Rule ID 24842 //
     /*  866428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866496 */     GIR_RootConstrainSelectedInstOperands,
     /*  866497 */     // GIR_Coverage, 24842,
     /*  866497 */     GIR_EraseRootFromParent_Done,
     /*  866498 */   // Label 13291: @866498
     /*  866498 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(866573), // Rule ID 24843 //
     /*  866503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866549 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866571 */     GIR_RootConstrainSelectedInstOperands,
     /*  866572 */     // GIR_Coverage, 24843,
     /*  866572 */     GIR_EraseRootFromParent_Done,
     /*  866573 */   // Label 13292: @866573
     /*  866573 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(866648), // Rule ID 24846 //
     /*  866578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866646 */     GIR_RootConstrainSelectedInstOperands,
     /*  866647 */     // GIR_Coverage, 24846,
     /*  866647 */     GIR_EraseRootFromParent_Done,
     /*  866648 */   // Label 13293: @866648
     /*  866648 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(866723), // Rule ID 24847 //
     /*  866653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866721 */     GIR_RootConstrainSelectedInstOperands,
     /*  866722 */     // GIR_Coverage, 24847,
     /*  866722 */     GIR_EraseRootFromParent_Done,
     /*  866723 */   // Label 13294: @866723
     /*  866723 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(866798), // Rule ID 24850 //
     /*  866728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866774 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866796 */     GIR_RootConstrainSelectedInstOperands,
     /*  866797 */     // GIR_Coverage, 24850,
     /*  866797 */     GIR_EraseRootFromParent_Done,
     /*  866798 */   // Label 13295: @866798
     /*  866798 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(866873), // Rule ID 24851 //
     /*  866803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866849 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866871 */     GIR_RootConstrainSelectedInstOperands,
     /*  866872 */     // GIR_Coverage, 24851,
     /*  866872 */     GIR_EraseRootFromParent_Done,
     /*  866873 */   // Label 13296: @866873
     /*  866873 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(866948), // Rule ID 24854 //
     /*  866878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866924 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866946 */     GIR_RootConstrainSelectedInstOperands,
     /*  866947 */     // GIR_Coverage, 24854,
     /*  866947 */     GIR_EraseRootFromParent_Done,
     /*  866948 */   // Label 13297: @866948
     /*  866948 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(867023), // Rule ID 24855 //
     /*  866953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  867002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867021 */     GIR_RootConstrainSelectedInstOperands,
     /*  867022 */     // GIR_Coverage, 24855,
     /*  867022 */     GIR_EraseRootFromParent_Done,
     /*  867023 */   // Label 13298: @867023
     /*  867023 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(867098), // Rule ID 24858 //
     /*  867028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  867048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  867077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867096 */     GIR_RootConstrainSelectedInstOperands,
     /*  867097 */     // GIR_Coverage, 24858,
     /*  867097 */     GIR_EraseRootFromParent_Done,
     /*  867098 */   // Label 13299: @867098
     /*  867098 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(867173), // Rule ID 24859 //
     /*  867103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  867123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867149 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  867152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867171 */     GIR_RootConstrainSelectedInstOperands,
     /*  867172 */     // GIR_Coverage, 24859,
     /*  867172 */     GIR_EraseRootFromParent_Done,
     /*  867173 */   // Label 13300: @867173
     /*  867173 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(867248), // Rule ID 24862 //
     /*  867178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  867189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  867192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  867195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  867227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867246 */     GIR_RootConstrainSelectedInstOperands,
     /*  867247 */     // GIR_Coverage, 24862,
     /*  867247 */     GIR_EraseRootFromParent_Done,
     /*  867248 */   // Label 13301: @867248
     /*  867248 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(867323), // Rule ID 24863 //
     /*  867253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  867264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  867267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  867270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867299 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  867302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867321 */     GIR_RootConstrainSelectedInstOperands,
     /*  867322 */     // GIR_Coverage, 24863,
     /*  867322 */     GIR_EraseRootFromParent_Done,
     /*  867323 */   // Label 13302: @867323
     /*  867323 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(867398), // Rule ID 24866 //
     /*  867328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  867348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  867377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867396 */     GIR_RootConstrainSelectedInstOperands,
     /*  867397 */     // GIR_Coverage, 24866,
     /*  867397 */     GIR_EraseRootFromParent_Done,
     /*  867398 */   // Label 13303: @867398
     /*  867398 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(867473), // Rule ID 24867 //
     /*  867403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  867423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  867452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867471 */     GIR_RootConstrainSelectedInstOperands,
     /*  867472 */     // GIR_Coverage, 24867,
     /*  867472 */     GIR_EraseRootFromParent_Done,
     /*  867473 */   // Label 13304: @867473
     /*  867473 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(867548), // Rule ID 24870 //
     /*  867478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  867481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867546 */     GIR_RootConstrainSelectedInstOperands,
     /*  867547 */     // GIR_Coverage, 24870,
     /*  867547 */     GIR_EraseRootFromParent_Done,
     /*  867548 */   // Label 13305: @867548
     /*  867548 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(867623), // Rule ID 24871 //
     /*  867553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  867556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867621 */     GIR_RootConstrainSelectedInstOperands,
     /*  867622 */     // GIR_Coverage, 24871,
     /*  867622 */     GIR_EraseRootFromParent_Done,
     /*  867623 */   // Label 13306: @867623
     /*  867623 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(867698), // Rule ID 24874 //
     /*  867628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867696 */     GIR_RootConstrainSelectedInstOperands,
     /*  867697 */     // GIR_Coverage, 24874,
     /*  867697 */     GIR_EraseRootFromParent_Done,
     /*  867698 */   // Label 13307: @867698
     /*  867698 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(867773), // Rule ID 24875 //
     /*  867703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867771 */     GIR_RootConstrainSelectedInstOperands,
     /*  867772 */     // GIR_Coverage, 24875,
     /*  867772 */     GIR_EraseRootFromParent_Done,
     /*  867773 */   // Label 13308: @867773
     /*  867773 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(867848), // Rule ID 24878 //
     /*  867778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867846 */     GIR_RootConstrainSelectedInstOperands,
     /*  867847 */     // GIR_Coverage, 24878,
     /*  867847 */     GIR_EraseRootFromParent_Done,
     /*  867848 */   // Label 13309: @867848
     /*  867848 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(867923), // Rule ID 24879 //
     /*  867853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867899 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867921 */     GIR_RootConstrainSelectedInstOperands,
     /*  867922 */     // GIR_Coverage, 24879,
     /*  867922 */     GIR_EraseRootFromParent_Done,
     /*  867923 */   // Label 13310: @867923
     /*  867923 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(867998), // Rule ID 24882 //
     /*  867928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867996 */     GIR_RootConstrainSelectedInstOperands,
     /*  867997 */     // GIR_Coverage, 24882,
     /*  867997 */     GIR_EraseRootFromParent_Done,
     /*  867998 */   // Label 13311: @867998
     /*  867998 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(868073), // Rule ID 24883 //
     /*  868003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  868014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  868017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  868020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868049 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  868052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868071 */     GIR_RootConstrainSelectedInstOperands,
     /*  868072 */     // GIR_Coverage, 24883,
     /*  868072 */     GIR_EraseRootFromParent_Done,
     /*  868073 */   // Label 13312: @868073
     /*  868073 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(868148), // Rule ID 24886 //
     /*  868078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  868098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  868127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868146 */     GIR_RootConstrainSelectedInstOperands,
     /*  868147 */     // GIR_Coverage, 24886,
     /*  868147 */     GIR_EraseRootFromParent_Done,
     /*  868148 */   // Label 13313: @868148
     /*  868148 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(868223), // Rule ID 24887 //
     /*  868153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  868164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  868167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  868170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  868173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868199 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  868202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868221 */     GIR_RootConstrainSelectedInstOperands,
     /*  868222 */     // GIR_Coverage, 24887,
     /*  868222 */     GIR_EraseRootFromParent_Done,
     /*  868223 */   // Label 13314: @868223
     /*  868223 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(868298), // Rule ID 24890 //
     /*  868228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  868248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868274 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  868277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868296 */     GIR_RootConstrainSelectedInstOperands,
     /*  868297 */     // GIR_Coverage, 24890,
     /*  868297 */     GIR_EraseRootFromParent_Done,
     /*  868298 */   // Label 13315: @868298
     /*  868298 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(868373), // Rule ID 24891 //
     /*  868303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  868314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  868317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  868320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  868323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  868352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868371 */     GIR_RootConstrainSelectedInstOperands,
     /*  868372 */     // GIR_Coverage, 24891,
     /*  868372 */     GIR_EraseRootFromParent_Done,
     /*  868373 */   // Label 13316: @868373
     /*  868373 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(868448), // Rule ID 24894 //
     /*  868378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868446 */     GIR_RootConstrainSelectedInstOperands,
     /*  868447 */     // GIR_Coverage, 24894,
     /*  868447 */     GIR_EraseRootFromParent_Done,
     /*  868448 */   // Label 13317: @868448
     /*  868448 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(868523), // Rule ID 24895 //
     /*  868453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  868464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868499 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868521 */     GIR_RootConstrainSelectedInstOperands,
     /*  868522 */     // GIR_Coverage, 24895,
     /*  868522 */     GIR_EraseRootFromParent_Done,
     /*  868523 */   // Label 13318: @868523
     /*  868523 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(868598), // Rule ID 24898 //
     /*  868528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868574 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868596 */     GIR_RootConstrainSelectedInstOperands,
     /*  868597 */     // GIR_Coverage, 24898,
     /*  868597 */     GIR_EraseRootFromParent_Done,
     /*  868598 */   // Label 13319: @868598
     /*  868598 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(868673), // Rule ID 24899 //
     /*  868603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868649 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868671 */     GIR_RootConstrainSelectedInstOperands,
     /*  868672 */     // GIR_Coverage, 24899,
     /*  868672 */     GIR_EraseRootFromParent_Done,
     /*  868673 */   // Label 13320: @868673
     /*  868673 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(868748), // Rule ID 24902 //
     /*  868678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868746 */     GIR_RootConstrainSelectedInstOperands,
     /*  868747 */     // GIR_Coverage, 24902,
     /*  868747 */     GIR_EraseRootFromParent_Done,
     /*  868748 */   // Label 13321: @868748
     /*  868748 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(868823), // Rule ID 24903 //
     /*  868753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868799 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868821 */     GIR_RootConstrainSelectedInstOperands,
     /*  868822 */     // GIR_Coverage, 24903,
     /*  868822 */     GIR_EraseRootFromParent_Done,
     /*  868823 */   // Label 13322: @868823
     /*  868823 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(868898), // Rule ID 24906 //
     /*  868828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  868831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868874 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868896 */     GIR_RootConstrainSelectedInstOperands,
     /*  868897 */     // GIR_Coverage, 24906,
     /*  868897 */     GIR_EraseRootFromParent_Done,
     /*  868898 */   // Label 13323: @868898
     /*  868898 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(868973), // Rule ID 24907 //
     /*  868903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  868906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868949 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868971 */     GIR_RootConstrainSelectedInstOperands,
     /*  868972 */     // GIR_Coverage, 24907,
     /*  868972 */     GIR_EraseRootFromParent_Done,
     /*  868973 */   // Label 13324: @868973
     /*  868973 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(869048), // Rule ID 24910 //
     /*  868978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869024 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869046 */     GIR_RootConstrainSelectedInstOperands,
     /*  869047 */     // GIR_Coverage, 24910,
     /*  869047 */     GIR_EraseRootFromParent_Done,
     /*  869048 */   // Label 13325: @869048
     /*  869048 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(869123), // Rule ID 24911 //
     /*  869053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  869064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  869067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869099 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869121 */     GIR_RootConstrainSelectedInstOperands,
     /*  869122 */     // GIR_Coverage, 24911,
     /*  869122 */     GIR_EraseRootFromParent_Done,
     /*  869123 */   // Label 13326: @869123
     /*  869123 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(869198), // Rule ID 24914 //
     /*  869128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869196 */     GIR_RootConstrainSelectedInstOperands,
     /*  869197 */     // GIR_Coverage, 24914,
     /*  869197 */     GIR_EraseRootFromParent_Done,
     /*  869198 */   // Label 13327: @869198
     /*  869198 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(869273), // Rule ID 24915 //
     /*  869203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869249 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869271 */     GIR_RootConstrainSelectedInstOperands,
     /*  869272 */     // GIR_Coverage, 24915,
     /*  869272 */     GIR_EraseRootFromParent_Done,
     /*  869273 */   // Label 13328: @869273
     /*  869273 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(869348), // Rule ID 24918 //
     /*  869278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  869289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  869292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  869295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869346 */     GIR_RootConstrainSelectedInstOperands,
     /*  869347 */     // GIR_Coverage, 24918,
     /*  869347 */     GIR_EraseRootFromParent_Done,
     /*  869348 */   // Label 13329: @869348
     /*  869348 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(869423), // Rule ID 24919 //
     /*  869353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  869364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  869367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  869370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869399 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869421 */     GIR_RootConstrainSelectedInstOperands,
     /*  869422 */     // GIR_Coverage, 24919,
     /*  869422 */     GIR_EraseRootFromParent_Done,
     /*  869423 */   // Label 13330: @869423
     /*  869423 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(869498), // Rule ID 24922 //
     /*  869428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869474 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869496 */     GIR_RootConstrainSelectedInstOperands,
     /*  869497 */     // GIR_Coverage, 24922,
     /*  869497 */     GIR_EraseRootFromParent_Done,
     /*  869498 */   // Label 13331: @869498
     /*  869498 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(869573), // Rule ID 24923 //
     /*  869503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869571 */     GIR_RootConstrainSelectedInstOperands,
     /*  869572 */     // GIR_Coverage, 24923,
     /*  869572 */     GIR_EraseRootFromParent_Done,
     /*  869573 */   // Label 13332: @869573
     /*  869573 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(869648), // Rule ID 24926 //
     /*  869578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869646 */     GIR_RootConstrainSelectedInstOperands,
     /*  869647 */     // GIR_Coverage, 24926,
     /*  869647 */     GIR_EraseRootFromParent_Done,
     /*  869648 */   // Label 13333: @869648
     /*  869648 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(869723), // Rule ID 24927 //
     /*  869653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869721 */     GIR_RootConstrainSelectedInstOperands,
     /*  869722 */     // GIR_Coverage, 24927,
     /*  869722 */     GIR_EraseRootFromParent_Done,
     /*  869723 */   // Label 13334: @869723
     /*  869723 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(869798), // Rule ID 24930 //
     /*  869728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  869731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869796 */     GIR_RootConstrainSelectedInstOperands,
     /*  869797 */     // GIR_Coverage, 24930,
     /*  869797 */     GIR_EraseRootFromParent_Done,
     /*  869798 */   // Label 13335: @869798
     /*  869798 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(869873), // Rule ID 24931 //
     /*  869803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  869806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869871 */     GIR_RootConstrainSelectedInstOperands,
     /*  869872 */     // GIR_Coverage, 24931,
     /*  869872 */     GIR_EraseRootFromParent_Done,
     /*  869873 */   // Label 13336: @869873
     /*  869873 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(869948), // Rule ID 24934 //
     /*  869878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869924 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869946 */     GIR_RootConstrainSelectedInstOperands,
     /*  869947 */     // GIR_Coverage, 24934,
     /*  869947 */     GIR_EraseRootFromParent_Done,
     /*  869948 */   // Label 13337: @869948
     /*  869948 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(870023), // Rule ID 24935 //
     /*  869953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869999 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870021 */     GIR_RootConstrainSelectedInstOperands,
     /*  870022 */     // GIR_Coverage, 24935,
     /*  870022 */     GIR_EraseRootFromParent_Done,
     /*  870023 */   // Label 13338: @870023
     /*  870023 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(870098), // Rule ID 24938 //
     /*  870028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  870039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  870042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  870045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870074 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870096 */     GIR_RootConstrainSelectedInstOperands,
     /*  870097 */     // GIR_Coverage, 24938,
     /*  870097 */     GIR_EraseRootFromParent_Done,
     /*  870098 */   // Label 13339: @870098
     /*  870098 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(870173), // Rule ID 24939 //
     /*  870103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  870114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  870117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  870120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870149 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870171 */     GIR_RootConstrainSelectedInstOperands,
     /*  870172 */     // GIR_Coverage, 24939,
     /*  870172 */     GIR_EraseRootFromParent_Done,
     /*  870173 */   // Label 13340: @870173
     /*  870173 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(870248), // Rule ID 24942 //
     /*  870178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870246 */     GIR_RootConstrainSelectedInstOperands,
     /*  870247 */     // GIR_Coverage, 24942,
     /*  870247 */     GIR_EraseRootFromParent_Done,
     /*  870248 */   // Label 13341: @870248
     /*  870248 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(870323), // Rule ID 24943 //
     /*  870253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870299 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870321 */     GIR_RootConstrainSelectedInstOperands,
     /*  870322 */     // GIR_Coverage, 24943,
     /*  870322 */     GIR_EraseRootFromParent_Done,
     /*  870323 */   // Label 13342: @870323
     /*  870323 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(870398), // Rule ID 24946 //
     /*  870328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870396 */     GIR_RootConstrainSelectedInstOperands,
     /*  870397 */     // GIR_Coverage, 24946,
     /*  870397 */     GIR_EraseRootFromParent_Done,
     /*  870398 */   // Label 13343: @870398
     /*  870398 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(870473), // Rule ID 24947 //
     /*  870403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870471 */     GIR_RootConstrainSelectedInstOperands,
     /*  870472 */     // GIR_Coverage, 24947,
     /*  870472 */     GIR_EraseRootFromParent_Done,
     /*  870473 */   // Label 13344: @870473
     /*  870473 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(870548), // Rule ID 24950 //
     /*  870478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870524 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870546 */     GIR_RootConstrainSelectedInstOperands,
     /*  870547 */     // GIR_Coverage, 24950,
     /*  870547 */     GIR_EraseRootFromParent_Done,
     /*  870548 */   // Label 13345: @870548
     /*  870548 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(870623), // Rule ID 24951 //
     /*  870553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870599 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870621 */     GIR_RootConstrainSelectedInstOperands,
     /*  870622 */     // GIR_Coverage, 24951,
     /*  870622 */     GIR_EraseRootFromParent_Done,
     /*  870623 */   // Label 13346: @870623
     /*  870623 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(870698), // Rule ID 24954 //
     /*  870628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  870631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870674 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870696 */     GIR_RootConstrainSelectedInstOperands,
     /*  870697 */     // GIR_Coverage, 24954,
     /*  870697 */     GIR_EraseRootFromParent_Done,
     /*  870698 */   // Label 13347: @870698
     /*  870698 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(870773), // Rule ID 24955 //
     /*  870703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  870706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870749 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870771 */     GIR_RootConstrainSelectedInstOperands,
     /*  870772 */     // GIR_Coverage, 24955,
     /*  870772 */     GIR_EraseRootFromParent_Done,
     /*  870773 */   // Label 13348: @870773
     /*  870773 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(870848), // Rule ID 24958 //
     /*  870778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870846 */     GIR_RootConstrainSelectedInstOperands,
     /*  870847 */     // GIR_Coverage, 24958,
     /*  870847 */     GIR_EraseRootFromParent_Done,
     /*  870848 */   // Label 13349: @870848
     /*  870848 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(870923), // Rule ID 24959 //
     /*  870853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  870856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870921 */     GIR_RootConstrainSelectedInstOperands,
     /*  870922 */     // GIR_Coverage, 24959,
     /*  870922 */     GIR_EraseRootFromParent_Done,
     /*  870923 */   // Label 13350: @870923
     /*  870923 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(870998), // Rule ID 24962 //
     /*  870928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  870931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870996 */     GIR_RootConstrainSelectedInstOperands,
     /*  870997 */     // GIR_Coverage, 24962,
     /*  870997 */     GIR_EraseRootFromParent_Done,
     /*  870998 */   // Label 13351: @870998
     /*  870998 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(871073), // Rule ID 24963 //
     /*  871003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  871006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871049 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  871052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871071 */     GIR_RootConstrainSelectedInstOperands,
     /*  871072 */     // GIR_Coverage, 24963,
     /*  871072 */     GIR_EraseRootFromParent_Done,
     /*  871073 */   // Label 13352: @871073
     /*  871073 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(871148), // Rule ID 24966 //
     /*  871078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  871081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  871127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871146 */     GIR_RootConstrainSelectedInstOperands,
     /*  871147 */     // GIR_Coverage, 24966,
     /*  871147 */     GIR_EraseRootFromParent_Done,
     /*  871148 */   // Label 13353: @871148
     /*  871148 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(871223), // Rule ID 24967 //
     /*  871153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  871156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871199 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  871202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871221 */     GIR_RootConstrainSelectedInstOperands,
     /*  871222 */     // GIR_Coverage, 24967,
     /*  871222 */     GIR_EraseRootFromParent_Done,
     /*  871223 */   // Label 13354: @871223
     /*  871223 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(871298), // Rule ID 25030 //
     /*  871228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  871239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  871242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  871245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871274 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  871277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871296 */     GIR_RootConstrainSelectedInstOperands,
     /*  871297 */     // GIR_Coverage, 25030,
     /*  871297 */     GIR_EraseRootFromParent_Done,
     /*  871298 */   // Label 13355: @871298
     /*  871298 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(871373), // Rule ID 25031 //
     /*  871303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  871314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  871317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  871320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871349 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  871352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871371 */     GIR_RootConstrainSelectedInstOperands,
     /*  871372 */     // GIR_Coverage, 25031,
     /*  871372 */     GIR_EraseRootFromParent_Done,
     /*  871373 */   // Label 13356: @871373
     /*  871373 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(871448), // Rule ID 25034 //
     /*  871378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  871389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871446 */     GIR_RootConstrainSelectedInstOperands,
     /*  871447 */     // GIR_Coverage, 25034,
     /*  871447 */     GIR_EraseRootFromParent_Done,
     /*  871448 */   // Label 13357: @871448
     /*  871448 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(871523), // Rule ID 25035 //
     /*  871453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  871464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871499 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871521 */     GIR_RootConstrainSelectedInstOperands,
     /*  871522 */     // GIR_Coverage, 25035,
     /*  871522 */     GIR_EraseRootFromParent_Done,
     /*  871523 */   // Label 13358: @871523
     /*  871523 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(871598), // Rule ID 25038 //
     /*  871528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871596 */     GIR_RootConstrainSelectedInstOperands,
     /*  871597 */     // GIR_Coverage, 25038,
     /*  871597 */     GIR_EraseRootFromParent_Done,
     /*  871598 */   // Label 13359: @871598
     /*  871598 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(871673), // Rule ID 25039 //
     /*  871603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871649 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871671 */     GIR_RootConstrainSelectedInstOperands,
     /*  871672 */     // GIR_Coverage, 25039,
     /*  871672 */     GIR_EraseRootFromParent_Done,
     /*  871673 */   // Label 13360: @871673
     /*  871673 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(871748), // Rule ID 25042 //
     /*  871678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871746 */     GIR_RootConstrainSelectedInstOperands,
     /*  871747 */     // GIR_Coverage, 25042,
     /*  871747 */     GIR_EraseRootFromParent_Done,
     /*  871748 */   // Label 13361: @871748
     /*  871748 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(871823), // Rule ID 25043 //
     /*  871753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871799 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871821 */     GIR_RootConstrainSelectedInstOperands,
     /*  871822 */     // GIR_Coverage, 25043,
     /*  871822 */     GIR_EraseRootFromParent_Done,
     /*  871823 */   // Label 13362: @871823
     /*  871823 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(871898), // Rule ID 25046 //
     /*  871828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  871831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871896 */     GIR_RootConstrainSelectedInstOperands,
     /*  871897 */     // GIR_Coverage, 25046,
     /*  871897 */     GIR_EraseRootFromParent_Done,
     /*  871898 */   // Label 13363: @871898
     /*  871898 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(871973), // Rule ID 25047 //
     /*  871903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  871906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871949 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871971 */     GIR_RootConstrainSelectedInstOperands,
     /*  871972 */     // GIR_Coverage, 25047,
     /*  871972 */     GIR_EraseRootFromParent_Done,
     /*  871973 */   // Label 13364: @871973
     /*  871973 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(872048), // Rule ID 25050 //
     /*  871978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  871981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  872027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872046 */     GIR_RootConstrainSelectedInstOperands,
     /*  872047 */     // GIR_Coverage, 25050,
     /*  872047 */     GIR_EraseRootFromParent_Done,
     /*  872048 */   // Label 13365: @872048
     /*  872048 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(872123), // Rule ID 25051 //
     /*  872053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  872056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  872064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  872067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  872070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872099 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  872102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872121 */     GIR_RootConstrainSelectedInstOperands,
     /*  872122 */     // GIR_Coverage, 25051,
     /*  872122 */     GIR_EraseRootFromParent_Done,
     /*  872123 */   // Label 13366: @872123
     /*  872123 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(872198), // Rule ID 25054 //
     /*  872128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  872139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  872142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  872145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  872177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872196 */     GIR_RootConstrainSelectedInstOperands,
     /*  872197 */     // GIR_Coverage, 25054,
     /*  872197 */     GIR_EraseRootFromParent_Done,
     /*  872198 */   // Label 13367: @872198
     /*  872198 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(872273), // Rule ID 25055 //
     /*  872203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  872214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  872217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  872220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  872252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872271 */     GIR_RootConstrainSelectedInstOperands,
     /*  872272 */     // GIR_Coverage, 25055,
     /*  872272 */     GIR_EraseRootFromParent_Done,
     /*  872273 */   // Label 13368: @872273
     /*  872273 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(872348), // Rule ID 25058 //
     /*  872278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  872289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  872292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  872295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872324 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  872327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872346 */     GIR_RootConstrainSelectedInstOperands,
     /*  872347 */     // GIR_Coverage, 25058,
     /*  872347 */     GIR_EraseRootFromParent_Done,
     /*  872348 */   // Label 13369: @872348
     /*  872348 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(872423), // Rule ID 25059 //
     /*  872353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  872364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  872367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  872370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872399 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  872402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872421 */     GIR_RootConstrainSelectedInstOperands,
     /*  872422 */     // GIR_Coverage, 25059,
     /*  872422 */     GIR_EraseRootFromParent_Done,
     /*  872423 */   // Label 13370: @872423
     /*  872423 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(872498), // Rule ID 25062 //
     /*  872428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872474 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872496 */     GIR_RootConstrainSelectedInstOperands,
     /*  872497 */     // GIR_Coverage, 25062,
     /*  872497 */     GIR_EraseRootFromParent_Done,
     /*  872498 */   // Label 13371: @872498
     /*  872498 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(872573), // Rule ID 25063 //
     /*  872503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872549 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872571 */     GIR_RootConstrainSelectedInstOperands,
     /*  872572 */     // GIR_Coverage, 25063,
     /*  872572 */     GIR_EraseRootFromParent_Done,
     /*  872573 */   // Label 13372: @872573
     /*  872573 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(872648), // Rule ID 25066 //
     /*  872578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872646 */     GIR_RootConstrainSelectedInstOperands,
     /*  872647 */     // GIR_Coverage, 25066,
     /*  872647 */     GIR_EraseRootFromParent_Done,
     /*  872648 */   // Label 13373: @872648
     /*  872648 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(872723), // Rule ID 25067 //
     /*  872653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872721 */     GIR_RootConstrainSelectedInstOperands,
     /*  872722 */     // GIR_Coverage, 25067,
     /*  872722 */     GIR_EraseRootFromParent_Done,
     /*  872723 */   // Label 13374: @872723
     /*  872723 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(872798), // Rule ID 25070 //
     /*  872728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872796 */     GIR_RootConstrainSelectedInstOperands,
     /*  872797 */     // GIR_Coverage, 25070,
     /*  872797 */     GIR_EraseRootFromParent_Done,
     /*  872798 */   // Label 13375: @872798
     /*  872798 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(872873), // Rule ID 25071 //
     /*  872803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872849 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872871 */     GIR_RootConstrainSelectedInstOperands,
     /*  872872 */     // GIR_Coverage, 25071,
     /*  872872 */     GIR_EraseRootFromParent_Done,
     /*  872873 */   // Label 13376: @872873
     /*  872873 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(872948), // Rule ID 25074 //
     /*  872878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872946 */     GIR_RootConstrainSelectedInstOperands,
     /*  872947 */     // GIR_Coverage, 25074,
     /*  872947 */     GIR_EraseRootFromParent_Done,
     /*  872948 */   // Label 13377: @872948
     /*  872948 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(873023), // Rule ID 25075 //
     /*  872953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872999 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  873002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873021 */     GIR_RootConstrainSelectedInstOperands,
     /*  873022 */     // GIR_Coverage, 25075,
     /*  873022 */     GIR_EraseRootFromParent_Done,
     /*  873023 */   // Label 13378: @873023
     /*  873023 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(873098), // Rule ID 25078 //
     /*  873028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  873039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  873042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  873045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  873077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873096 */     GIR_RootConstrainSelectedInstOperands,
     /*  873097 */     // GIR_Coverage, 25078,
     /*  873097 */     GIR_EraseRootFromParent_Done,
     /*  873098 */   // Label 13379: @873098
     /*  873098 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(873173), // Rule ID 25079 //
     /*  873103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  873114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  873117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  873120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  873152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873171 */     GIR_RootConstrainSelectedInstOperands,
     /*  873172 */     // GIR_Coverage, 25079,
     /*  873172 */     GIR_EraseRootFromParent_Done,
     /*  873173 */   // Label 13380: @873173
     /*  873173 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(873248), // Rule ID 25082 //
     /*  873178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  873189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  873192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  873227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873246 */     GIR_RootConstrainSelectedInstOperands,
     /*  873247 */     // GIR_Coverage, 25082,
     /*  873247 */     GIR_EraseRootFromParent_Done,
     /*  873248 */   // Label 13381: @873248
     /*  873248 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(873323), // Rule ID 25083 //
     /*  873253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  873264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  873267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  873270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  873302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873321 */     GIR_RootConstrainSelectedInstOperands,
     /*  873322 */     // GIR_Coverage, 25083,
     /*  873322 */     GIR_EraseRootFromParent_Done,
     /*  873323 */   // Label 13382: @873323
     /*  873323 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(873398), // Rule ID 25086 //
     /*  873328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  873331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  873339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  873342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  873374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  873377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873396 */     GIR_RootConstrainSelectedInstOperands,
     /*  873397 */     // GIR_Coverage, 25086,
     /*  873397 */     GIR_EraseRootFromParent_Done,
     /*  873398 */   // Label 13383: @873398
     /*  873398 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(873473), // Rule ID 25087 //
     /*  873403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  873406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  873411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  873414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  873417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  873420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873449 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  873449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  873452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873471 */     GIR_RootConstrainSelectedInstOperands,
     /*  873472 */     // GIR_Coverage, 25087,
     /*  873472 */     GIR_EraseRootFromParent_Done,
     /*  873473 */   // Label 13384: @873473
     /*  873473 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(873545), // Rule ID 25090 //
     /*  873478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873524 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873543 */     GIR_RootConstrainSelectedInstOperands,
     /*  873544 */     // GIR_Coverage, 25090,
     /*  873544 */     GIR_EraseRootFromParent_Done,
     /*  873545 */   // Label 13385: @873545
     /*  873545 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(873617), // Rule ID 25091 //
     /*  873550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873615 */     GIR_RootConstrainSelectedInstOperands,
     /*  873616 */     // GIR_Coverage, 25091,
     /*  873616 */     GIR_EraseRootFromParent_Done,
     /*  873617 */   // Label 13386: @873617
     /*  873617 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(873689), // Rule ID 25092 //
     /*  873622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873687 */     GIR_RootConstrainSelectedInstOperands,
     /*  873688 */     // GIR_Coverage, 25092,
     /*  873688 */     GIR_EraseRootFromParent_Done,
     /*  873689 */   // Label 13387: @873689
     /*  873689 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(873761), // Rule ID 25093 //
     /*  873694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873740 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873759 */     GIR_RootConstrainSelectedInstOperands,
     /*  873760 */     // GIR_Coverage, 25093,
     /*  873760 */     GIR_EraseRootFromParent_Done,
     /*  873761 */   // Label 13388: @873761
     /*  873761 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(873833), // Rule ID 25094 //
     /*  873766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873831 */     GIR_RootConstrainSelectedInstOperands,
     /*  873832 */     // GIR_Coverage, 25094,
     /*  873832 */     GIR_EraseRootFromParent_Done,
     /*  873833 */   // Label 13389: @873833
     /*  873833 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(873905), // Rule ID 25095 //
     /*  873838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873903 */     GIR_RootConstrainSelectedInstOperands,
     /*  873904 */     // GIR_Coverage, 25095,
     /*  873904 */     GIR_EraseRootFromParent_Done,
     /*  873905 */   // Label 13390: @873905
     /*  873905 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(873977), // Rule ID 25096 //
     /*  873910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873975 */     GIR_RootConstrainSelectedInstOperands,
     /*  873976 */     // GIR_Coverage, 25096,
     /*  873976 */     GIR_EraseRootFromParent_Done,
     /*  873977 */   // Label 13391: @873977
     /*  873977 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(874049), // Rule ID 25097 //
     /*  873982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  874031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874047 */     GIR_RootConstrainSelectedInstOperands,
     /*  874048 */     // GIR_Coverage, 25097,
     /*  874048 */     GIR_EraseRootFromParent_Done,
     /*  874049 */   // Label 13392: @874049
     /*  874049 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(874121), // Rule ID 25098 //
     /*  874054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  874103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874119 */     GIR_RootConstrainSelectedInstOperands,
     /*  874120 */     // GIR_Coverage, 25098,
     /*  874120 */     GIR_EraseRootFromParent_Done,
     /*  874121 */   // Label 13393: @874121
     /*  874121 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(874193), // Rule ID 25099 //
     /*  874126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  874175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874191 */     GIR_RootConstrainSelectedInstOperands,
     /*  874192 */     // GIR_Coverage, 25099,
     /*  874192 */     GIR_EraseRootFromParent_Done,
     /*  874193 */   // Label 13394: @874193
     /*  874193 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(874265), // Rule ID 25100 //
     /*  874198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  874209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  874212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  874247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874263 */     GIR_RootConstrainSelectedInstOperands,
     /*  874264 */     // GIR_Coverage, 25100,
     /*  874264 */     GIR_EraseRootFromParent_Done,
     /*  874265 */   // Label 13395: @874265
     /*  874265 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(874337), // Rule ID 25101 //
     /*  874270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  874281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  874284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  874287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11230:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  874319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874335 */     GIR_RootConstrainSelectedInstOperands,
     /*  874336 */     // GIR_Coverage, 25101,
     /*  874336 */     GIR_EraseRootFromParent_Done,
     /*  874337 */   // Label 13396: @874337
     /*  874337 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(874409), // Rule ID 25102 //
     /*  874342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874388 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  874391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874407 */     GIR_RootConstrainSelectedInstOperands,
     /*  874408 */     // GIR_Coverage, 25102,
     /*  874408 */     GIR_EraseRootFromParent_Done,
     /*  874409 */   // Label 13397: @874409
     /*  874409 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(874481), // Rule ID 25103 //
     /*  874414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  874463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874479 */     GIR_RootConstrainSelectedInstOperands,
     /*  874480 */     // GIR_Coverage, 25103,
     /*  874480 */     GIR_EraseRootFromParent_Done,
     /*  874481 */   // Label 13398: @874481
     /*  874481 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(874553), // Rule ID 25104 //
     /*  874486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874551 */     GIR_RootConstrainSelectedInstOperands,
     /*  874552 */     // GIR_Coverage, 25104,
     /*  874552 */     GIR_EraseRootFromParent_Done,
     /*  874553 */   // Label 13399: @874553
     /*  874553 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(874625), // Rule ID 25105 //
     /*  874558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874623 */     GIR_RootConstrainSelectedInstOperands,
     /*  874624 */     // GIR_Coverage, 25105,
     /*  874624 */     GIR_EraseRootFromParent_Done,
     /*  874625 */   // Label 13400: @874625
     /*  874625 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(874697), // Rule ID 25106 //
     /*  874630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  874633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  874676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874695 */     GIR_RootConstrainSelectedInstOperands,
     /*  874696 */     // GIR_Coverage, 25106,
     /*  874696 */     GIR_EraseRootFromParent_Done,
     /*  874697 */   // Label 13401: @874697
     /*  874697 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(874769), // Rule ID 25107 //
     /*  874702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  874705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  874748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874767 */     GIR_RootConstrainSelectedInstOperands,
     /*  874768 */     // GIR_Coverage, 25107,
     /*  874768 */     GIR_EraseRootFromParent_Done,
     /*  874769 */   // Label 13402: @874769
     /*  874769 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(874841), // Rule ID 25108 //
     /*  874774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874839 */     GIR_RootConstrainSelectedInstOperands,
     /*  874840 */     // GIR_Coverage, 25108,
     /*  874840 */     GIR_EraseRootFromParent_Done,
     /*  874841 */   // Label 13403: @874841
     /*  874841 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(874913), // Rule ID 25109 //
     /*  874846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874911 */     GIR_RootConstrainSelectedInstOperands,
     /*  874912 */     // GIR_Coverage, 25109,
     /*  874912 */     GIR_EraseRootFromParent_Done,
     /*  874913 */   // Label 13404: @874913
     /*  874913 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(874985), // Rule ID 25110 //
     /*  874918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874983 */     GIR_RootConstrainSelectedInstOperands,
     /*  874984 */     // GIR_Coverage, 25110,
     /*  874984 */     GIR_EraseRootFromParent_Done,
     /*  874985 */   // Label 13405: @874985
     /*  874985 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(875057), // Rule ID 25111 //
     /*  874990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  875001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  875004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  875007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  875036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  875039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875055 */     GIR_RootConstrainSelectedInstOperands,
     /*  875056 */     // GIR_Coverage, 25111,
     /*  875056 */     GIR_EraseRootFromParent_Done,
     /*  875057 */   // Label 13406: @875057
     /*  875057 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(875129), // Rule ID 25112 //
     /*  875062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  875073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  875076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  875082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875108 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  875108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  875111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875127 */     GIR_RootConstrainSelectedInstOperands,
     /*  875128 */     // GIR_Coverage, 25112,
     /*  875128 */     GIR_EraseRootFromParent_Done,
     /*  875129 */   // Label 13407: @875129
     /*  875129 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(875201), // Rule ID 25113 //
     /*  875134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  875145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  875148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  875151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  875154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875180 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  875180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  875183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  875199 */     GIR_RootConstrainSelectedInstOperands,
     /*  875200 */     // GIR_Coverage, 25113,
     /*  875200 */     GIR_EraseRootFromParent_Done,
     /*  875201 */   // Label 13408: @875201
     /*  875201 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(875273), // Rule ID 25114 //
     /*  875206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  875255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875271 */     GIR_RootConstrainSelectedInstOperands,
     /*  875272 */     // GIR_Coverage, 25114,
     /*  875272 */     GIR_EraseRootFromParent_Done,
     /*  875273 */   // Label 13409: @875273
     /*  875273 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(875345), // Rule ID 25115 //
     /*  875278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  875327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875343 */     GIR_RootConstrainSelectedInstOperands,
     /*  875344 */     // GIR_Coverage, 25115,
     /*  875344 */     GIR_EraseRootFromParent_Done,
     /*  875345 */   // Label 13410: @875345
     /*  875345 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(875417), // Rule ID 25116 //
     /*  875350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875415 */     GIR_RootConstrainSelectedInstOperands,
     /*  875416 */     // GIR_Coverage, 25116,
     /*  875416 */     GIR_EraseRootFromParent_Done,
     /*  875417 */   // Label 13411: @875417
     /*  875417 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(875489), // Rule ID 25117 //
     /*  875422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875487 */     GIR_RootConstrainSelectedInstOperands,
     /*  875488 */     // GIR_Coverage, 25117,
     /*  875488 */     GIR_EraseRootFromParent_Done,
     /*  875489 */   // Label 13412: @875489
     /*  875489 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(875561), // Rule ID 25118 //
     /*  875494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875559 */     GIR_RootConstrainSelectedInstOperands,
     /*  875560 */     // GIR_Coverage, 25118,
     /*  875560 */     GIR_EraseRootFromParent_Done,
     /*  875561 */   // Label 13413: @875561
     /*  875561 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(875633), // Rule ID 25119 //
     /*  875566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875631 */     GIR_RootConstrainSelectedInstOperands,
     /*  875632 */     // GIR_Coverage, 25119,
     /*  875632 */     GIR_EraseRootFromParent_Done,
     /*  875633 */   // Label 13414: @875633
     /*  875633 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(875705), // Rule ID 25120 //
     /*  875638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875703 */     GIR_RootConstrainSelectedInstOperands,
     /*  875704 */     // GIR_Coverage, 25120,
     /*  875704 */     GIR_EraseRootFromParent_Done,
     /*  875705 */   // Label 13415: @875705
     /*  875705 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(875777), // Rule ID 25121 //
     /*  875710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875775 */     GIR_RootConstrainSelectedInstOperands,
     /*  875776 */     // GIR_Coverage, 25121,
     /*  875776 */     GIR_EraseRootFromParent_Done,
     /*  875777 */   // Label 13416: @875777
     /*  875777 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(875849), // Rule ID 25122 //
     /*  875782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875847 */     GIR_RootConstrainSelectedInstOperands,
     /*  875848 */     // GIR_Coverage, 25122,
     /*  875848 */     GIR_EraseRootFromParent_Done,
     /*  875849 */   // Label 13417: @875849
     /*  875849 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(875921), // Rule ID 25123 //
     /*  875854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875919 */     GIR_RootConstrainSelectedInstOperands,
     /*  875920 */     // GIR_Coverage, 25123,
     /*  875920 */     GIR_EraseRootFromParent_Done,
     /*  875921 */   // Label 13418: @875921
     /*  875921 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(875993), // Rule ID 25124 //
     /*  875926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875991 */     GIR_RootConstrainSelectedInstOperands,
     /*  875992 */     // GIR_Coverage, 25124,
     /*  875992 */     GIR_EraseRootFromParent_Done,
     /*  875993 */   // Label 13419: @875993
     /*  875993 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(876065), // Rule ID 25125 //
     /*  875998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  876018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  876047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876063 */     GIR_RootConstrainSelectedInstOperands,
     /*  876064 */     // GIR_Coverage, 25125,
     /*  876064 */     GIR_EraseRootFromParent_Done,
     /*  876065 */   // Label 13420: @876065
     /*  876065 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(876137), // Rule ID 25126 //
     /*  876070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876135 */     GIR_RootConstrainSelectedInstOperands,
     /*  876136 */     // GIR_Coverage, 25126,
     /*  876136 */     GIR_EraseRootFromParent_Done,
     /*  876137 */   // Label 13421: @876137
     /*  876137 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(876209), // Rule ID 25127 //
     /*  876142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876207 */     GIR_RootConstrainSelectedInstOperands,
     /*  876208 */     // GIR_Coverage, 25127,
     /*  876208 */     GIR_EraseRootFromParent_Done,
     /*  876209 */   // Label 13422: @876209
     /*  876209 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(876281), // Rule ID 25128 //
     /*  876214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876279 */     GIR_RootConstrainSelectedInstOperands,
     /*  876280 */     // GIR_Coverage, 25128,
     /*  876280 */     GIR_EraseRootFromParent_Done,
     /*  876281 */   // Label 13423: @876281
     /*  876281 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(876353), // Rule ID 25129 //
     /*  876286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876351 */     GIR_RootConstrainSelectedInstOperands,
     /*  876352 */     // GIR_Coverage, 25129,
     /*  876352 */     GIR_EraseRootFromParent_Done,
     /*  876353 */   // Label 13424: @876353
     /*  876353 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(876425), // Rule ID 25130 //
     /*  876358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  876361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876423 */     GIR_RootConstrainSelectedInstOperands,
     /*  876424 */     // GIR_Coverage, 25130,
     /*  876424 */     GIR_EraseRootFromParent_Done,
     /*  876425 */   // Label 13425: @876425
     /*  876425 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(876497), // Rule ID 25131 //
     /*  876430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  876433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876495 */     GIR_RootConstrainSelectedInstOperands,
     /*  876496 */     // GIR_Coverage, 25131,
     /*  876496 */     GIR_EraseRootFromParent_Done,
     /*  876497 */   // Label 13426: @876497
     /*  876497 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(876569), // Rule ID 25132 //
     /*  876502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876548 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876567 */     GIR_RootConstrainSelectedInstOperands,
     /*  876568 */     // GIR_Coverage, 25132,
     /*  876568 */     GIR_EraseRootFromParent_Done,
     /*  876569 */   // Label 13427: @876569
     /*  876569 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(876641), // Rule ID 25133 //
     /*  876574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876620 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876639 */     GIR_RootConstrainSelectedInstOperands,
     /*  876640 */     // GIR_Coverage, 25133,
     /*  876640 */     GIR_EraseRootFromParent_Done,
     /*  876641 */   // Label 13428: @876641
     /*  876641 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(876713), // Rule ID 25134 //
     /*  876646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876711 */     GIR_RootConstrainSelectedInstOperands,
     /*  876712 */     // GIR_Coverage, 25134,
     /*  876712 */     GIR_EraseRootFromParent_Done,
     /*  876713 */   // Label 13429: @876713
     /*  876713 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(876785), // Rule ID 25135 //
     /*  876718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876783 */     GIR_RootConstrainSelectedInstOperands,
     /*  876784 */     // GIR_Coverage, 25135,
     /*  876784 */     GIR_EraseRootFromParent_Done,
     /*  876785 */   // Label 13430: @876785
     /*  876785 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(876857), // Rule ID 25136 //
     /*  876790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876855 */     GIR_RootConstrainSelectedInstOperands,
     /*  876856 */     // GIR_Coverage, 25136,
     /*  876856 */     GIR_EraseRootFromParent_Done,
     /*  876857 */   // Label 13431: @876857
     /*  876857 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(876929), // Rule ID 25137 //
     /*  876862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876908 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876927 */     GIR_RootConstrainSelectedInstOperands,
     /*  876928 */     // GIR_Coverage, 25137,
     /*  876928 */     GIR_EraseRootFromParent_Done,
     /*  876929 */   // Label 13432: @876929
     /*  876929 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(877001), // Rule ID 25138 //
     /*  876934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876980 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876999 */     GIR_RootConstrainSelectedInstOperands,
     /*  877000 */     // GIR_Coverage, 25138,
     /*  877000 */     GIR_EraseRootFromParent_Done,
     /*  877001 */   // Label 13433: @877001
     /*  877001 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(877073), // Rule ID 25139 //
     /*  877006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877071 */     GIR_RootConstrainSelectedInstOperands,
     /*  877072 */     // GIR_Coverage, 25139,
     /*  877072 */     GIR_EraseRootFromParent_Done,
     /*  877073 */   // Label 13434: @877073
     /*  877073 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(877145), // Rule ID 25140 //
     /*  877078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877143 */     GIR_RootConstrainSelectedInstOperands,
     /*  877144 */     // GIR_Coverage, 25140,
     /*  877144 */     GIR_EraseRootFromParent_Done,
     /*  877145 */   // Label 13435: @877145
     /*  877145 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(877217), // Rule ID 25141 //
     /*  877150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877196 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877215 */     GIR_RootConstrainSelectedInstOperands,
     /*  877216 */     // GIR_Coverage, 25141,
     /*  877216 */     GIR_EraseRootFromParent_Done,
     /*  877217 */   // Label 13436: @877217
     /*  877217 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(877289), // Rule ID 25142 //
     /*  877222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  877225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  877233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  877236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  877239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  877271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877287 */     GIR_RootConstrainSelectedInstOperands,
     /*  877288 */     // GIR_Coverage, 25142,
     /*  877288 */     GIR_EraseRootFromParent_Done,
     /*  877289 */   // Label 13437: @877289
     /*  877289 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(877361), // Rule ID 25143 //
     /*  877294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  877297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  877305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  877308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  877311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877340 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  877340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  877343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877359 */     GIR_RootConstrainSelectedInstOperands,
     /*  877360 */     // GIR_Coverage, 25143,
     /*  877360 */     GIR_EraseRootFromParent_Done,
     /*  877361 */   // Label 13438: @877361
     /*  877361 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(877433), // Rule ID 25144 //
     /*  877366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877431 */     GIR_RootConstrainSelectedInstOperands,
     /*  877432 */     // GIR_Coverage, 25144,
     /*  877432 */     GIR_EraseRootFromParent_Done,
     /*  877433 */   // Label 13439: @877433
     /*  877433 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(877505), // Rule ID 25145 //
     /*  877438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877484 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877503 */     GIR_RootConstrainSelectedInstOperands,
     /*  877504 */     // GIR_Coverage, 25145,
     /*  877504 */     GIR_EraseRootFromParent_Done,
     /*  877505 */   // Label 13440: @877505
     /*  877505 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(877577), // Rule ID 25146 //
     /*  877510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877556 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877575 */     GIR_RootConstrainSelectedInstOperands,
     /*  877576 */     // GIR_Coverage, 25146,
     /*  877576 */     GIR_EraseRootFromParent_Done,
     /*  877577 */   // Label 13441: @877577
     /*  877577 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(877649), // Rule ID 25147 //
     /*  877582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877628 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877647 */     GIR_RootConstrainSelectedInstOperands,
     /*  877648 */     // GIR_Coverage, 25147,
     /*  877648 */     GIR_EraseRootFromParent_Done,
     /*  877649 */   // Label 13442: @877649
     /*  877649 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(877721), // Rule ID 25148 //
     /*  877654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877700 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877719 */     GIR_RootConstrainSelectedInstOperands,
     /*  877720 */     // GIR_Coverage, 25148,
     /*  877720 */     GIR_EraseRootFromParent_Done,
     /*  877721 */   // Label 13443: @877721
     /*  877721 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(877793), // Rule ID 25149 //
     /*  877726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877772 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877791 */     GIR_RootConstrainSelectedInstOperands,
     /*  877792 */     // GIR_Coverage, 25149,
     /*  877792 */     GIR_EraseRootFromParent_Done,
     /*  877793 */   // Label 13444: @877793
     /*  877793 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(877865), // Rule ID 25150 //
     /*  877798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877863 */     GIR_RootConstrainSelectedInstOperands,
     /*  877864 */     // GIR_Coverage, 25150,
     /*  877864 */     GIR_EraseRootFromParent_Done,
     /*  877865 */   // Label 13445: @877865
     /*  877865 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(877937), // Rule ID 25151 //
     /*  877870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877916 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877935 */     GIR_RootConstrainSelectedInstOperands,
     /*  877936 */     // GIR_Coverage, 25151,
     /*  877936 */     GIR_EraseRootFromParent_Done,
     /*  877937 */   // Label 13446: @877937
     /*  877937 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(878009), // Rule ID 25152 //
     /*  877942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878007 */     GIR_RootConstrainSelectedInstOperands,
     /*  878008 */     // GIR_Coverage, 25152,
     /*  878008 */     GIR_EraseRootFromParent_Done,
     /*  878009 */   // Label 13447: @878009
     /*  878009 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(878081), // Rule ID 25153 //
     /*  878014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  878025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  878028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  878031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878060 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  878060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  878063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878079 */     GIR_RootConstrainSelectedInstOperands,
     /*  878080 */     // GIR_Coverage, 25153,
     /*  878080 */     GIR_EraseRootFromParent_Done,
     /*  878081 */   // Label 13448: @878081
     /*  878081 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(878153), // Rule ID 25154 //
     /*  878086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  878097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  878100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  878103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878132 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  878132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  878135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878151 */     GIR_RootConstrainSelectedInstOperands,
     /*  878152 */     // GIR_Coverage, 25154,
     /*  878152 */     GIR_EraseRootFromParent_Done,
     /*  878153 */   // Label 13449: @878153
     /*  878153 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(878225), // Rule ID 25155 //
     /*  878158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  878169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  878172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  878175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878204 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  878204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  878207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878223 */     GIR_RootConstrainSelectedInstOperands,
     /*  878224 */     // GIR_Coverage, 25155,
     /*  878224 */     GIR_EraseRootFromParent_Done,
     /*  878225 */   // Label 13450: @878225
     /*  878225 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(878297), // Rule ID 25156 //
     /*  878230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  878241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  878244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  878247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  878250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  878279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878295 */     GIR_RootConstrainSelectedInstOperands,
     /*  878296 */     // GIR_Coverage, 25156,
     /*  878296 */     GIR_EraseRootFromParent_Done,
     /*  878297 */   // Label 13451: @878297
     /*  878297 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(878369), // Rule ID 25157 //
     /*  878302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  878313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  878316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  878319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  878322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878348 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  878351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878367 */     GIR_RootConstrainSelectedInstOperands,
     /*  878368 */     // GIR_Coverage, 25157,
     /*  878368 */     GIR_EraseRootFromParent_Done,
     /*  878369 */   // Label 13452: @878369
     /*  878369 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(878441), // Rule ID 25158 //
     /*  878374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  878385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  878388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  878391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878420 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878439 */     GIR_RootConstrainSelectedInstOperands,
     /*  878440 */     // GIR_Coverage, 25158,
     /*  878440 */     GIR_EraseRootFromParent_Done,
     /*  878441 */   // Label 13453: @878441
     /*  878441 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(878513), // Rule ID 25159 //
     /*  878446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  878457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  878460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  878463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878492 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878511 */     GIR_RootConstrainSelectedInstOperands,
     /*  878512 */     // GIR_Coverage, 25159,
     /*  878512 */     GIR_EraseRootFromParent_Done,
     /*  878513 */   // Label 13454: @878513
     /*  878513 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(878585), // Rule ID 25160 //
     /*  878518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878564 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878583 */     GIR_RootConstrainSelectedInstOperands,
     /*  878584 */     // GIR_Coverage, 25160,
     /*  878584 */     GIR_EraseRootFromParent_Done,
     /*  878585 */   // Label 13455: @878585
     /*  878585 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(878657), // Rule ID 25161 //
     /*  878590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878636 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878655 */     GIR_RootConstrainSelectedInstOperands,
     /*  878656 */     // GIR_Coverage, 25161,
     /*  878656 */     GIR_EraseRootFromParent_Done,
     /*  878657 */   // Label 13456: @878657
     /*  878657 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(878732), // Rule ID 60616 //
     /*  878662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  878665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  878708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878730 */     GIR_RootConstrainSelectedInstOperands,
     /*  878731 */     // GIR_Coverage, 60616,
     /*  878731 */     GIR_EraseRootFromParent_Done,
     /*  878732 */   // Label 13457: @878732
     /*  878732 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(878807), // Rule ID 60617 //
     /*  878737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  878740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878783 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  878783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878805 */     GIR_RootConstrainSelectedInstOperands,
     /*  878806 */     // GIR_Coverage, 60617,
     /*  878806 */     GIR_EraseRootFromParent_Done,
     /*  878807 */   // Label 13458: @878807
     /*  878807 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(878882), // Rule ID 60974 //
     /*  878812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878880 */     GIR_RootConstrainSelectedInstOperands,
     /*  878881 */     // GIR_Coverage, 60974,
     /*  878881 */     GIR_EraseRootFromParent_Done,
     /*  878882 */   // Label 13459: @878882
     /*  878882 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(878957), // Rule ID 60975 //
     /*  878887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878933 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878955 */     GIR_RootConstrainSelectedInstOperands,
     /*  878956 */     // GIR_Coverage, 60975,
     /*  878956 */     GIR_EraseRootFromParent_Done,
     /*  878957 */   // Label 13460: @878957
     /*  878957 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(879032), // Rule ID 60978 //
     /*  878962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879030 */     GIR_RootConstrainSelectedInstOperands,
     /*  879031 */     // GIR_Coverage, 60978,
     /*  879031 */     GIR_EraseRootFromParent_Done,
     /*  879032 */   // Label 13461: @879032
     /*  879032 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(879107), // Rule ID 60979 //
     /*  879037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  879048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  879051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  879054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  879057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879083 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879105 */     GIR_RootConstrainSelectedInstOperands,
     /*  879106 */     // GIR_Coverage, 60979,
     /*  879106 */     GIR_EraseRootFromParent_Done,
     /*  879107 */   // Label 13462: @879107
     /*  879107 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(879182), // Rule ID 60982 //
     /*  879112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  879123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  879126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  879129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  879132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879180 */     GIR_RootConstrainSelectedInstOperands,
     /*  879181 */     // GIR_Coverage, 60982,
     /*  879181 */     GIR_EraseRootFromParent_Done,
     /*  879182 */   // Label 13463: @879182
     /*  879182 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(879257), // Rule ID 60983 //
     /*  879187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  879198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  879201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  879204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  879207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879233 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879255 */     GIR_RootConstrainSelectedInstOperands,
     /*  879256 */     // GIR_Coverage, 60983,
     /*  879256 */     GIR_EraseRootFromParent_Done,
     /*  879257 */   // Label 13464: @879257
     /*  879257 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(879332), // Rule ID 60986 //
     /*  879262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  879273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  879276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  879279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  879282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879330 */     GIR_RootConstrainSelectedInstOperands,
     /*  879331 */     // GIR_Coverage, 60986,
     /*  879331 */     GIR_EraseRootFromParent_Done,
     /*  879332 */   // Label 13465: @879332
     /*  879332 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(879407), // Rule ID 60987 //
     /*  879337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  879348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  879351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  879354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  879357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879405 */     GIR_RootConstrainSelectedInstOperands,
     /*  879406 */     // GIR_Coverage, 60987,
     /*  879406 */     GIR_EraseRootFromParent_Done,
     /*  879407 */   // Label 13466: @879407
     /*  879407 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(879482), // Rule ID 60990 //
     /*  879412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879480 */     GIR_RootConstrainSelectedInstOperands,
     /*  879481 */     // GIR_Coverage, 60990,
     /*  879481 */     GIR_EraseRootFromParent_Done,
     /*  879482 */   // Label 13467: @879482
     /*  879482 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(879557), // Rule ID 60991 //
     /*  879487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879555 */     GIR_RootConstrainSelectedInstOperands,
     /*  879556 */     // GIR_Coverage, 60991,
     /*  879556 */     GIR_EraseRootFromParent_Done,
     /*  879557 */   // Label 13468: @879557
     /*  879557 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(879632), // Rule ID 60994 //
     /*  879562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879630 */     GIR_RootConstrainSelectedInstOperands,
     /*  879631 */     // GIR_Coverage, 60994,
     /*  879631 */     GIR_EraseRootFromParent_Done,
     /*  879632 */   // Label 13469: @879632
     /*  879632 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(879707), // Rule ID 60995 //
     /*  879637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879683 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879705 */     GIR_RootConstrainSelectedInstOperands,
     /*  879706 */     // GIR_Coverage, 60995,
     /*  879706 */     GIR_EraseRootFromParent_Done,
     /*  879707 */   // Label 13470: @879707
     /*  879707 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(879782), // Rule ID 60998 //
     /*  879712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879780 */     GIR_RootConstrainSelectedInstOperands,
     /*  879781 */     // GIR_Coverage, 60998,
     /*  879781 */     GIR_EraseRootFromParent_Done,
     /*  879782 */   // Label 13471: @879782
     /*  879782 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(879857), // Rule ID 60999 //
     /*  879787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879855 */     GIR_RootConstrainSelectedInstOperands,
     /*  879856 */     // GIR_Coverage, 60999,
     /*  879856 */     GIR_EraseRootFromParent_Done,
     /*  879857 */   // Label 13472: @879857
     /*  879857 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(879932), // Rule ID 61002 //
     /*  879862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879930 */     GIR_RootConstrainSelectedInstOperands,
     /*  879931 */     // GIR_Coverage, 61002,
     /*  879931 */     GIR_EraseRootFromParent_Done,
     /*  879932 */   // Label 13473: @879932
     /*  879932 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(880007), // Rule ID 61003 //
     /*  879937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880005 */     GIR_RootConstrainSelectedInstOperands,
     /*  880006 */     // GIR_Coverage, 61003,
     /*  880006 */     GIR_EraseRootFromParent_Done,
     /*  880007 */   // Label 13474: @880007
     /*  880007 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(880082), // Rule ID 61006 //
     /*  880012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  880029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  880032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880080 */     GIR_RootConstrainSelectedInstOperands,
     /*  880081 */     // GIR_Coverage, 61006,
     /*  880081 */     GIR_EraseRootFromParent_Done,
     /*  880082 */   // Label 13475: @880082
     /*  880082 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(880157), // Rule ID 61007 //
     /*  880087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  880104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  880107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880155 */     GIR_RootConstrainSelectedInstOperands,
     /*  880156 */     // GIR_Coverage, 61007,
     /*  880156 */     GIR_EraseRootFromParent_Done,
     /*  880157 */   // Label 13476: @880157
     /*  880157 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(880232), // Rule ID 61010 //
     /*  880162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  880182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880230 */     GIR_RootConstrainSelectedInstOperands,
     /*  880231 */     // GIR_Coverage, 61010,
     /*  880231 */     GIR_EraseRootFromParent_Done,
     /*  880232 */   // Label 13477: @880232
     /*  880232 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(880307), // Rule ID 61011 //
     /*  880237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  880254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  880257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880305 */     GIR_RootConstrainSelectedInstOperands,
     /*  880306 */     // GIR_Coverage, 61011,
     /*  880306 */     GIR_EraseRootFromParent_Done,
     /*  880307 */   // Label 13478: @880307
     /*  880307 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(880382), // Rule ID 61014 //
     /*  880312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  880332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  880358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880380 */     GIR_RootConstrainSelectedInstOperands,
     /*  880381 */     // GIR_Coverage, 61014,
     /*  880381 */     GIR_EraseRootFromParent_Done,
     /*  880382 */   // Label 13479: @880382
     /*  880382 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(880457), // Rule ID 61015 //
     /*  880387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  880404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  880407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880433 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  880433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  880452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880455 */     GIR_RootConstrainSelectedInstOperands,
     /*  880456 */     // GIR_Coverage, 61015,
     /*  880456 */     GIR_EraseRootFromParent_Done,
     /*  880457 */   // Label 13480: @880457
     /*  880457 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(880532), // Rule ID 61018 //
     /*  880462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880530 */     GIR_RootConstrainSelectedInstOperands,
     /*  880531 */     // GIR_Coverage, 61018,
     /*  880531 */     GIR_EraseRootFromParent_Done,
     /*  880532 */   // Label 13481: @880532
     /*  880532 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(880607), // Rule ID 61019 //
     /*  880537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880605 */     GIR_RootConstrainSelectedInstOperands,
     /*  880606 */     // GIR_Coverage, 61019,
     /*  880606 */     GIR_EraseRootFromParent_Done,
     /*  880607 */   // Label 13482: @880607
     /*  880607 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(880682), // Rule ID 61022 //
     /*  880612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880680 */     GIR_RootConstrainSelectedInstOperands,
     /*  880681 */     // GIR_Coverage, 61022,
     /*  880681 */     GIR_EraseRootFromParent_Done,
     /*  880682 */   // Label 13483: @880682
     /*  880682 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(880757), // Rule ID 61023 //
     /*  880687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880733 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880755 */     GIR_RootConstrainSelectedInstOperands,
     /*  880756 */     // GIR_Coverage, 61023,
     /*  880756 */     GIR_EraseRootFromParent_Done,
     /*  880757 */   // Label 13484: @880757
     /*  880757 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(880832), // Rule ID 61026 //
     /*  880762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880830 */     GIR_RootConstrainSelectedInstOperands,
     /*  880831 */     // GIR_Coverage, 61026,
     /*  880831 */     GIR_EraseRootFromParent_Done,
     /*  880832 */   // Label 13485: @880832
     /*  880832 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(880907), // Rule ID 61027 //
     /*  880837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880905 */     GIR_RootConstrainSelectedInstOperands,
     /*  880906 */     // GIR_Coverage, 61027,
     /*  880906 */     GIR_EraseRootFromParent_Done,
     /*  880907 */   // Label 13486: @880907
     /*  880907 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(880982), // Rule ID 61030 //
     /*  880912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880980 */     GIR_RootConstrainSelectedInstOperands,
     /*  880981 */     // GIR_Coverage, 61030,
     /*  880981 */     GIR_EraseRootFromParent_Done,
     /*  880982 */   // Label 13487: @880982
     /*  880982 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(881057), // Rule ID 61031 //
     /*  880987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  881004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  881007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  881033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  881036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881055 */     GIR_RootConstrainSelectedInstOperands,
     /*  881056 */     // GIR_Coverage, 61031,
     /*  881056 */     GIR_EraseRootFromParent_Done,
     /*  881057 */   // Label 13488: @881057
     /*  881057 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(881132), // Rule ID 61034 //
     /*  881062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  881111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881130 */     GIR_RootConstrainSelectedInstOperands,
     /*  881131 */     // GIR_Coverage, 61034,
     /*  881131 */     GIR_EraseRootFromParent_Done,
     /*  881132 */   // Label 13489: @881132
     /*  881132 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(881207), // Rule ID 61035 //
     /*  881137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  881154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881183 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  881186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881205 */     GIR_RootConstrainSelectedInstOperands,
     /*  881206 */     // GIR_Coverage, 61035,
     /*  881206 */     GIR_EraseRootFromParent_Done,
     /*  881207 */   // Label 13490: @881207
     /*  881207 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(881282), // Rule ID 61042 //
     /*  881212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  881229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881280 */     GIR_RootConstrainSelectedInstOperands,
     /*  881281 */     // GIR_Coverage, 61042,
     /*  881281 */     GIR_EraseRootFromParent_Done,
     /*  881282 */   // Label 13491: @881282
     /*  881282 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(881357), // Rule ID 61043 //
     /*  881287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  881304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881333 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881355 */     GIR_RootConstrainSelectedInstOperands,
     /*  881356 */     // GIR_Coverage, 61043,
     /*  881356 */     GIR_EraseRootFromParent_Done,
     /*  881357 */   // Label 13492: @881357
     /*  881357 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(881432), // Rule ID 61050 //
     /*  881362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  881379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881430 */     GIR_RootConstrainSelectedInstOperands,
     /*  881431 */     // GIR_Coverage, 61050,
     /*  881431 */     GIR_EraseRootFromParent_Done,
     /*  881432 */   // Label 13493: @881432
     /*  881432 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(881507), // Rule ID 61051 //
     /*  881437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  881454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11721:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881505 */     GIR_RootConstrainSelectedInstOperands,
     /*  881506 */     // GIR_Coverage, 61051,
     /*  881506 */     GIR_EraseRootFromParent_Done,
     /*  881507 */   // Label 13494: @881507
     /*  881507 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(881582), // Rule ID 61058 //
     /*  881512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881580 */     GIR_RootConstrainSelectedInstOperands,
     /*  881581 */     // GIR_Coverage, 61058,
     /*  881581 */     GIR_EraseRootFromParent_Done,
     /*  881582 */   // Label 13495: @881582
     /*  881582 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(881657), // Rule ID 61059 //
     /*  881587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881655 */     GIR_RootConstrainSelectedInstOperands,
     /*  881656 */     // GIR_Coverage, 61059,
     /*  881656 */     GIR_EraseRootFromParent_Done,
     /*  881657 */   // Label 13496: @881657
     /*  881657 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(881732), // Rule ID 61066 //
     /*  881662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881730 */     GIR_RootConstrainSelectedInstOperands,
     /*  881731 */     // GIR_Coverage, 61066,
     /*  881731 */     GIR_EraseRootFromParent_Done,
     /*  881732 */   // Label 13497: @881732
     /*  881732 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(881807), // Rule ID 61067 //
     /*  881737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881805 */     GIR_RootConstrainSelectedInstOperands,
     /*  881806 */     // GIR_Coverage, 61067,
     /*  881806 */     GIR_EraseRootFromParent_Done,
     /*  881807 */   // Label 13498: @881807
     /*  881807 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(881882), // Rule ID 61074 //
     /*  881812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881880 */     GIR_RootConstrainSelectedInstOperands,
     /*  881881 */     // GIR_Coverage, 61074,
     /*  881881 */     GIR_EraseRootFromParent_Done,
     /*  881882 */   // Label 13499: @881882
     /*  881882 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(881957), // Rule ID 61075 //
     /*  881887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881933 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881955 */     GIR_RootConstrainSelectedInstOperands,
     /*  881956 */     // GIR_Coverage, 61075,
     /*  881956 */     GIR_EraseRootFromParent_Done,
     /*  881957 */   // Label 13500: @881957
     /*  881957 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(882032), // Rule ID 61082 //
     /*  881962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  882011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882030 */     GIR_RootConstrainSelectedInstOperands,
     /*  882031 */     // GIR_Coverage, 61082,
     /*  882031 */     GIR_EraseRootFromParent_Done,
     /*  882032 */   // Label 13501: @882032
     /*  882032 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(882107), // Rule ID 61083 //
     /*  882037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  882054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  882086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882105 */     GIR_RootConstrainSelectedInstOperands,
     /*  882106 */     // GIR_Coverage, 61083,
     /*  882106 */     GIR_EraseRootFromParent_Done,
     /*  882107 */   // Label 13502: @882107
     /*  882107 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(882182), // Rule ID 61090 //
     /*  882112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  882123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  882126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882180 */     GIR_RootConstrainSelectedInstOperands,
     /*  882181 */     // GIR_Coverage, 61090,
     /*  882181 */     GIR_EraseRootFromParent_Done,
     /*  882182 */   // Label 13503: @882182
     /*  882182 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(882257), // Rule ID 61091 //
     /*  882187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  882198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  882201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  882204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11721:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882255 */     GIR_RootConstrainSelectedInstOperands,
     /*  882256 */     // GIR_Coverage, 61091,
     /*  882256 */     GIR_EraseRootFromParent_Done,
     /*  882257 */   // Label 13504: @882257
     /*  882257 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(882332), // Rule ID 61098 //
     /*  882262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  882273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  882276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  882279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882330 */     GIR_RootConstrainSelectedInstOperands,
     /*  882331 */     // GIR_Coverage, 61098,
     /*  882331 */     GIR_EraseRootFromParent_Done,
     /*  882332 */   // Label 13505: @882332
     /*  882332 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(882407), // Rule ID 61099 //
     /*  882337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  882348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  882351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  882354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882405 */     GIR_RootConstrainSelectedInstOperands,
     /*  882406 */     // GIR_Coverage, 61099,
     /*  882406 */     GIR_EraseRootFromParent_Done,
     /*  882407 */   // Label 13506: @882407
     /*  882407 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(882482), // Rule ID 61106 //
     /*  882412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882480 */     GIR_RootConstrainSelectedInstOperands,
     /*  882481 */     // GIR_Coverage, 61106,
     /*  882481 */     GIR_EraseRootFromParent_Done,
     /*  882482 */   // Label 13507: @882482
     /*  882482 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(882557), // Rule ID 61107 //
     /*  882487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882533 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882555 */     GIR_RootConstrainSelectedInstOperands,
     /*  882556 */     // GIR_Coverage, 61107,
     /*  882556 */     GIR_EraseRootFromParent_Done,
     /*  882557 */   // Label 13508: @882557
     /*  882557 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(882632), // Rule ID 61114 //
     /*  882562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882630 */     GIR_RootConstrainSelectedInstOperands,
     /*  882631 */     // GIR_Coverage, 61114,
     /*  882631 */     GIR_EraseRootFromParent_Done,
     /*  882632 */   // Label 13509: @882632
     /*  882632 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(882707), // Rule ID 61115 //
     /*  882637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882683 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882705 */     GIR_RootConstrainSelectedInstOperands,
     /*  882706 */     // GIR_Coverage, 61115,
     /*  882706 */     GIR_EraseRootFromParent_Done,
     /*  882707 */   // Label 13510: @882707
     /*  882707 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(882782), // Rule ID 61122 //
     /*  882712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882780 */     GIR_RootConstrainSelectedInstOperands,
     /*  882781 */     // GIR_Coverage, 61122,
     /*  882781 */     GIR_EraseRootFromParent_Done,
     /*  882782 */   // Label 13511: @882782
     /*  882782 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(882857), // Rule ID 61123 //
     /*  882787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882833 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11721:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882855 */     GIR_RootConstrainSelectedInstOperands,
     /*  882856 */     // GIR_Coverage, 61123,
     /*  882856 */     GIR_EraseRootFromParent_Done,
     /*  882857 */   // Label 13512: @882857
     /*  882857 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(882932), // Rule ID 61130 //
     /*  882862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882930 */     GIR_RootConstrainSelectedInstOperands,
     /*  882931 */     // GIR_Coverage, 61130,
     /*  882931 */     GIR_EraseRootFromParent_Done,
     /*  882932 */   // Label 13513: @882932
     /*  882932 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(883007), // Rule ID 61131 //
     /*  882937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11721:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883005 */     GIR_RootConstrainSelectedInstOperands,
     /*  883006 */     // GIR_Coverage, 61131,
     /*  883006 */     GIR_EraseRootFromParent_Done,
     /*  883007 */   // Label 13514: @883007
     /*  883007 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(883082), // Rule ID 61138 //
     /*  883012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  883029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  883061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883080 */     GIR_RootConstrainSelectedInstOperands,
     /*  883081 */     // GIR_Coverage, 61138,
     /*  883081 */     GIR_EraseRootFromParent_Done,
     /*  883082 */   // Label 13515: @883082
     /*  883082 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(883157), // Rule ID 61139 //
     /*  883087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  883104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11721:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  883136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883155 */     GIR_RootConstrainSelectedInstOperands,
     /*  883156 */     // GIR_Coverage, 61139,
     /*  883156 */     GIR_EraseRootFromParent_Done,
     /*  883157 */   // Label 13516: @883157
     /*  883157 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(883232), // Rule ID 61146 //
     /*  883162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  883179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  883211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883230 */     GIR_RootConstrainSelectedInstOperands,
     /*  883231 */     // GIR_Coverage, 61146,
     /*  883231 */     GIR_EraseRootFromParent_Done,
     /*  883232 */   // Label 13517: @883232
     /*  883232 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(883307), // Rule ID 61147 //
     /*  883237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  883254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11721:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  883286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883305 */     GIR_RootConstrainSelectedInstOperands,
     /*  883306 */     // GIR_Coverage, 61147,
     /*  883306 */     GIR_EraseRootFromParent_Done,
     /*  883307 */   // Label 13518: @883307
     /*  883307 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(883382), // Rule ID 61154 //
     /*  883312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  883361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883380 */     GIR_RootConstrainSelectedInstOperands,
     /*  883381 */     // GIR_Coverage, 61154,
     /*  883381 */     GIR_EraseRootFromParent_Done,
     /*  883382 */   // Label 13519: @883382
     /*  883382 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(883457), // Rule ID 61155 //
     /*  883387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883433 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  883436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883455 */     GIR_RootConstrainSelectedInstOperands,
     /*  883456 */     // GIR_Coverage, 61155,
     /*  883456 */     GIR_EraseRootFromParent_Done,
     /*  883457 */   // Label 13520: @883457
     /*  883457 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(883532), // Rule ID 61158 //
     /*  883462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883530 */     GIR_RootConstrainSelectedInstOperands,
     /*  883531 */     // GIR_Coverage, 61158,
     /*  883531 */     GIR_EraseRootFromParent_Done,
     /*  883532 */   // Label 13521: @883532
     /*  883532 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(883607), // Rule ID 61159 //
     /*  883537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883605 */     GIR_RootConstrainSelectedInstOperands,
     /*  883606 */     // GIR_Coverage, 61159,
     /*  883606 */     GIR_EraseRootFromParent_Done,
     /*  883607 */   // Label 13522: @883607
     /*  883607 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(883682), // Rule ID 61162 //
     /*  883612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883680 */     GIR_RootConstrainSelectedInstOperands,
     /*  883681 */     // GIR_Coverage, 61162,
     /*  883681 */     GIR_EraseRootFromParent_Done,
     /*  883682 */   // Label 13523: @883682
     /*  883682 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(883757), // Rule ID 61163 //
     /*  883687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883733 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883755 */     GIR_RootConstrainSelectedInstOperands,
     /*  883756 */     // GIR_Coverage, 61163,
     /*  883756 */     GIR_EraseRootFromParent_Done,
     /*  883757 */   // Label 13524: @883757
     /*  883757 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(883832), // Rule ID 61166 //
     /*  883762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883830 */     GIR_RootConstrainSelectedInstOperands,
     /*  883831 */     // GIR_Coverage, 61166,
     /*  883831 */     GIR_EraseRootFromParent_Done,
     /*  883832 */   // Label 13525: @883832
     /*  883832 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(883907), // Rule ID 61167 //
     /*  883837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883905 */     GIR_RootConstrainSelectedInstOperands,
     /*  883906 */     // GIR_Coverage, 61167,
     /*  883906 */     GIR_EraseRootFromParent_Done,
     /*  883907 */   // Label 13526: @883907
     /*  883907 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(883982), // Rule ID 61170 //
     /*  883912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883980 */     GIR_RootConstrainSelectedInstOperands,
     /*  883981 */     // GIR_Coverage, 61170,
     /*  883981 */     GIR_EraseRootFromParent_Done,
     /*  883982 */   // Label 13527: @883982
     /*  883982 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(884057), // Rule ID 61171 //
     /*  883987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  884036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884055 */     GIR_RootConstrainSelectedInstOperands,
     /*  884056 */     // GIR_Coverage, 61171,
     /*  884056 */     GIR_EraseRootFromParent_Done,
     /*  884057 */   // Label 13528: @884057
     /*  884057 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(884132), // Rule ID 61174 //
     /*  884062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  884111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884130 */     GIR_RootConstrainSelectedInstOperands,
     /*  884131 */     // GIR_Coverage, 61174,
     /*  884131 */     GIR_EraseRootFromParent_Done,
     /*  884132 */   // Label 13529: @884132
     /*  884132 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(884207), // Rule ID 61175 //
     /*  884137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  884186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884205 */     GIR_RootConstrainSelectedInstOperands,
     /*  884206 */     // GIR_Coverage, 61175,
     /*  884206 */     GIR_EraseRootFromParent_Done,
     /*  884207 */   // Label 13530: @884207
     /*  884207 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(884282), // Rule ID 61178 //
     /*  884212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  884261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884280 */     GIR_RootConstrainSelectedInstOperands,
     /*  884281 */     // GIR_Coverage, 61178,
     /*  884281 */     GIR_EraseRootFromParent_Done,
     /*  884282 */   // Label 13531: @884282
     /*  884282 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(884357), // Rule ID 61179 //
     /*  884287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  884336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884355 */     GIR_RootConstrainSelectedInstOperands,
     /*  884356 */     // GIR_Coverage, 61179,
     /*  884356 */     GIR_EraseRootFromParent_Done,
     /*  884357 */   // Label 13532: @884357
     /*  884357 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(884432), // Rule ID 61182 //
     /*  884362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884430 */     GIR_RootConstrainSelectedInstOperands,
     /*  884431 */     // GIR_Coverage, 61182,
     /*  884431 */     GIR_EraseRootFromParent_Done,
     /*  884432 */   // Label 13533: @884432
     /*  884432 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(884507), // Rule ID 61183 //
     /*  884437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  884445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884483 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884505 */     GIR_RootConstrainSelectedInstOperands,
     /*  884506 */     // GIR_Coverage, 61183,
     /*  884506 */     GIR_EraseRootFromParent_Done,
     /*  884507 */   // Label 13534: @884507
     /*  884507 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(884582), // Rule ID 61186 //
     /*  884512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884580 */     GIR_RootConstrainSelectedInstOperands,
     /*  884581 */     // GIR_Coverage, 61186,
     /*  884581 */     GIR_EraseRootFromParent_Done,
     /*  884582 */   // Label 13535: @884582
     /*  884582 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(884657), // Rule ID 61187 //
     /*  884587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884633 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884655 */     GIR_RootConstrainSelectedInstOperands,
     /*  884656 */     // GIR_Coverage, 61187,
     /*  884656 */     GIR_EraseRootFromParent_Done,
     /*  884657 */   // Label 13536: @884657
     /*  884657 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(884732), // Rule ID 61190 //
     /*  884662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884730 */     GIR_RootConstrainSelectedInstOperands,
     /*  884731 */     // GIR_Coverage, 61190,
     /*  884731 */     GIR_EraseRootFromParent_Done,
     /*  884732 */   // Label 13537: @884732
     /*  884732 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(884807), // Rule ID 61191 //
     /*  884737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884783 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884805 */     GIR_RootConstrainSelectedInstOperands,
     /*  884806 */     // GIR_Coverage, 61191,
     /*  884806 */     GIR_EraseRootFromParent_Done,
     /*  884807 */   // Label 13538: @884807
     /*  884807 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(884882), // Rule ID 61194 //
     /*  884812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884880 */     GIR_RootConstrainSelectedInstOperands,
     /*  884881 */     // GIR_Coverage, 61194,
     /*  884881 */     GIR_EraseRootFromParent_Done,
     /*  884882 */   // Label 13539: @884882
     /*  884882 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(884957), // Rule ID 61195 //
     /*  884887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884955 */     GIR_RootConstrainSelectedInstOperands,
     /*  884956 */     // GIR_Coverage, 61195,
     /*  884956 */     GIR_EraseRootFromParent_Done,
     /*  884957 */   // Label 13540: @884957
     /*  884957 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(885032), // Rule ID 61198 //
     /*  884962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885008 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  885011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885030 */     GIR_RootConstrainSelectedInstOperands,
     /*  885031 */     // GIR_Coverage, 61198,
     /*  885031 */     GIR_EraseRootFromParent_Done,
     /*  885032 */   // Label 13541: @885032
     /*  885032 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(885107), // Rule ID 61199 //
     /*  885037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  885057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885083 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  885086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885105 */     GIR_RootConstrainSelectedInstOperands,
     /*  885106 */     // GIR_Coverage, 61199,
     /*  885106 */     GIR_EraseRootFromParent_Done,
     /*  885107 */   // Label 13542: @885107
     /*  885107 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(885182), // Rule ID 61202 //
     /*  885112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  885123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  885126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  885129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  885161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885180 */     GIR_RootConstrainSelectedInstOperands,
     /*  885181 */     // GIR_Coverage, 61202,
     /*  885181 */     GIR_EraseRootFromParent_Done,
     /*  885182 */   // Label 13543: @885182
     /*  885182 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(885257), // Rule ID 61203 //
     /*  885187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  885198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  885201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  885204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885233 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  885236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885255 */     GIR_RootConstrainSelectedInstOperands,
     /*  885256 */     // GIR_Coverage, 61203,
     /*  885256 */     GIR_EraseRootFromParent_Done,
     /*  885257 */   // Label 13544: @885257
     /*  885257 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(885332), // Rule ID 61206 //
     /*  885262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  885273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  885276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  885311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885330 */     GIR_RootConstrainSelectedInstOperands,
     /*  885331 */     // GIR_Coverage, 61206,
     /*  885331 */     GIR_EraseRootFromParent_Done,
     /*  885332 */   // Label 13545: @885332
     /*  885332 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(885407), // Rule ID 61207 //
     /*  885337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  885348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  885351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  885354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  885386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885405 */     GIR_RootConstrainSelectedInstOperands,
     /*  885406 */     // GIR_Coverage, 61207,
     /*  885406 */     GIR_EraseRootFromParent_Done,
     /*  885407 */   // Label 13546: @885407
     /*  885407 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(885482), // Rule ID 61210 //
     /*  885412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885458 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885480 */     GIR_RootConstrainSelectedInstOperands,
     /*  885481 */     // GIR_Coverage, 61210,
     /*  885481 */     GIR_EraseRootFromParent_Done,
     /*  885482 */   // Label 13547: @885482
     /*  885482 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(885557), // Rule ID 61211 //
     /*  885487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885533 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885555 */     GIR_RootConstrainSelectedInstOperands,
     /*  885556 */     // GIR_Coverage, 61211,
     /*  885556 */     GIR_EraseRootFromParent_Done,
     /*  885557 */   // Label 13548: @885557
     /*  885557 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(885632), // Rule ID 61214 //
     /*  885562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885630 */     GIR_RootConstrainSelectedInstOperands,
     /*  885631 */     // GIR_Coverage, 61214,
     /*  885631 */     GIR_EraseRootFromParent_Done,
     /*  885632 */   // Label 13549: @885632
     /*  885632 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(885707), // Rule ID 61215 //
     /*  885637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885683 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885705 */     GIR_RootConstrainSelectedInstOperands,
     /*  885706 */     // GIR_Coverage, 61215,
     /*  885706 */     GIR_EraseRootFromParent_Done,
     /*  885707 */   // Label 13550: @885707
     /*  885707 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(885782), // Rule ID 61218 //
     /*  885712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885780 */     GIR_RootConstrainSelectedInstOperands,
     /*  885781 */     // GIR_Coverage, 61218,
     /*  885781 */     GIR_EraseRootFromParent_Done,
     /*  885782 */   // Label 13551: @885782
     /*  885782 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(885857), // Rule ID 61219 //
     /*  885787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885833 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885855 */     GIR_RootConstrainSelectedInstOperands,
     /*  885856 */     // GIR_Coverage, 61219,
     /*  885856 */     GIR_EraseRootFromParent_Done,
     /*  885857 */   // Label 13552: @885857
     /*  885857 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(885932), // Rule ID 61222 //
     /*  885862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885930 */     GIR_RootConstrainSelectedInstOperands,
     /*  885931 */     // GIR_Coverage, 61222,
     /*  885931 */     GIR_EraseRootFromParent_Done,
     /*  885932 */   // Label 13553: @885932
     /*  885932 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(886007), // Rule ID 61223 //
     /*  885937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886005 */     GIR_RootConstrainSelectedInstOperands,
     /*  886006 */     // GIR_Coverage, 61223,
     /*  886006 */     GIR_EraseRootFromParent_Done,
     /*  886007 */   // Label 13554: @886007
     /*  886007 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(886082), // Rule ID 61226 //
     /*  886012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  886023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  886026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  886032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886058 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886080 */     GIR_RootConstrainSelectedInstOperands,
     /*  886081 */     // GIR_Coverage, 61226,
     /*  886081 */     GIR_EraseRootFromParent_Done,
     /*  886082 */   // Label 13555: @886082
     /*  886082 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(886157), // Rule ID 61227 //
     /*  886087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  886098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  886101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  886104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  886107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886133 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886155 */     GIR_RootConstrainSelectedInstOperands,
     /*  886156 */     // GIR_Coverage, 61227,
     /*  886156 */     GIR_EraseRootFromParent_Done,
     /*  886157 */   // Label 13556: @886157
     /*  886157 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(886232), // Rule ID 61230 //
     /*  886162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  886173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  886176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  886182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  886211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886230 */     GIR_RootConstrainSelectedInstOperands,
     /*  886231 */     // GIR_Coverage, 61230,
     /*  886231 */     GIR_EraseRootFromParent_Done,
     /*  886232 */   // Label 13557: @886232
     /*  886232 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(886307), // Rule ID 61231 //
     /*  886237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  886248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  886251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  886254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  886257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886283 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  886286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886305 */     GIR_RootConstrainSelectedInstOperands,
     /*  886306 */     // GIR_Coverage, 61231,
     /*  886306 */     GIR_EraseRootFromParent_Done,
     /*  886307 */   // Label 13558: @886307
     /*  886307 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(886382), // Rule ID 61234 //
     /*  886312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  886323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  886326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  886332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886380 */     GIR_RootConstrainSelectedInstOperands,
     /*  886381 */     // GIR_Coverage, 61234,
     /*  886381 */     GIR_EraseRootFromParent_Done,
     /*  886382 */   // Label 13559: @886382
     /*  886382 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(886457), // Rule ID 61235 //
     /*  886387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  886398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  886401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  886404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  886407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886433 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886455 */     GIR_RootConstrainSelectedInstOperands,
     /*  886456 */     // GIR_Coverage, 61235,
     /*  886456 */     GIR_EraseRootFromParent_Done,
     /*  886457 */   // Label 13560: @886457
     /*  886457 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(886532), // Rule ID 61238 //
     /*  886462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886530 */     GIR_RootConstrainSelectedInstOperands,
     /*  886531 */     // GIR_Coverage, 61238,
     /*  886531 */     GIR_EraseRootFromParent_Done,
     /*  886532 */   // Label 13561: @886532
     /*  886532 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(886607), // Rule ID 61239 //
     /*  886537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886605 */     GIR_RootConstrainSelectedInstOperands,
     /*  886606 */     // GIR_Coverage, 61239,
     /*  886606 */     GIR_EraseRootFromParent_Done,
     /*  886607 */   // Label 13562: @886607
     /*  886607 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(886682), // Rule ID 61242 //
     /*  886612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886680 */     GIR_RootConstrainSelectedInstOperands,
     /*  886681 */     // GIR_Coverage, 61242,
     /*  886681 */     GIR_EraseRootFromParent_Done,
     /*  886682 */   // Label 13563: @886682
     /*  886682 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(886757), // Rule ID 61243 //
     /*  886687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886755 */     GIR_RootConstrainSelectedInstOperands,
     /*  886756 */     // GIR_Coverage, 61243,
     /*  886756 */     GIR_EraseRootFromParent_Done,
     /*  886757 */   // Label 13564: @886757
     /*  886757 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(886832), // Rule ID 61246 //
     /*  886762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886830 */     GIR_RootConstrainSelectedInstOperands,
     /*  886831 */     // GIR_Coverage, 61246,
     /*  886831 */     GIR_EraseRootFromParent_Done,
     /*  886832 */   // Label 13565: @886832
     /*  886832 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(886907), // Rule ID 61247 //
     /*  886837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886905 */     GIR_RootConstrainSelectedInstOperands,
     /*  886906 */     // GIR_Coverage, 61247,
     /*  886906 */     GIR_EraseRootFromParent_Done,
     /*  886907 */   // Label 13566: @886907
     /*  886907 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(886982), // Rule ID 61250 //
     /*  886912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886980 */     GIR_RootConstrainSelectedInstOperands,
     /*  886981 */     // GIR_Coverage, 61250,
     /*  886981 */     GIR_EraseRootFromParent_Done,
     /*  886982 */   // Label 13567: @886982
     /*  886982 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(887057), // Rule ID 61251 //
     /*  886987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  887001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  887004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  887007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887055 */     GIR_RootConstrainSelectedInstOperands,
     /*  887056 */     // GIR_Coverage, 61251,
     /*  887056 */     GIR_EraseRootFromParent_Done,
     /*  887057 */   // Label 13568: @887057
     /*  887057 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(887132), // Rule ID 61254 //
     /*  887062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887130 */     GIR_RootConstrainSelectedInstOperands,
     /*  887131 */     // GIR_Coverage, 61254,
     /*  887131 */     GIR_EraseRootFromParent_Done,
     /*  887132 */   // Label 13569: @887132
     /*  887132 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(887207), // Rule ID 61255 //
     /*  887137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  887186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887205 */     GIR_RootConstrainSelectedInstOperands,
     /*  887206 */     // GIR_Coverage, 61255,
     /*  887206 */     GIR_EraseRootFromParent_Done,
     /*  887207 */   // Label 13570: @887207
     /*  887207 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(887282), // Rule ID 61258 //
     /*  887212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  887223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  887226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  887229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  887232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887280 */     GIR_RootConstrainSelectedInstOperands,
     /*  887281 */     // GIR_Coverage, 61258,
     /*  887281 */     GIR_EraseRootFromParent_Done,
     /*  887282 */   // Label 13571: @887282
     /*  887282 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(887357), // Rule ID 61259 //
     /*  887287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  887298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  887301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  887304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  887307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887333 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887355 */     GIR_RootConstrainSelectedInstOperands,
     /*  887356 */     // GIR_Coverage, 61259,
     /*  887356 */     GIR_EraseRootFromParent_Done,
     /*  887357 */   // Label 13572: @887357
     /*  887357 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(887432), // Rule ID 61262 //
     /*  887362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  887373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  887376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  887379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  887382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887430 */     GIR_RootConstrainSelectedInstOperands,
     /*  887431 */     // GIR_Coverage, 61262,
     /*  887431 */     GIR_EraseRootFromParent_Done,
     /*  887432 */   // Label 13573: @887432
     /*  887432 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(887507), // Rule ID 61263 //
     /*  887437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  887448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  887451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  887454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  887457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887483 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887505 */     GIR_RootConstrainSelectedInstOperands,
     /*  887506 */     // GIR_Coverage, 61263,
     /*  887506 */     GIR_EraseRootFromParent_Done,
     /*  887507 */   // Label 13574: @887507
     /*  887507 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(887582), // Rule ID 61266 //
     /*  887512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887580 */     GIR_RootConstrainSelectedInstOperands,
     /*  887581 */     // GIR_Coverage, 61266,
     /*  887581 */     GIR_EraseRootFromParent_Done,
     /*  887582 */   // Label 13575: @887582
     /*  887582 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(887657), // Rule ID 61267 //
     /*  887587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887633 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887655 */     GIR_RootConstrainSelectedInstOperands,
     /*  887656 */     // GIR_Coverage, 61267,
     /*  887656 */     GIR_EraseRootFromParent_Done,
     /*  887657 */   // Label 13576: @887657
     /*  887657 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(887732), // Rule ID 61270 //
     /*  887662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887730 */     GIR_RootConstrainSelectedInstOperands,
     /*  887731 */     // GIR_Coverage, 61270,
     /*  887731 */     GIR_EraseRootFromParent_Done,
     /*  887732 */   // Label 13577: @887732
     /*  887732 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(887807), // Rule ID 61271 //
     /*  887737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887805 */     GIR_RootConstrainSelectedInstOperands,
     /*  887806 */     // GIR_Coverage, 61271,
     /*  887806 */     GIR_EraseRootFromParent_Done,
     /*  887807 */   // Label 13578: @887807
     /*  887807 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(887882), // Rule ID 61274 //
     /*  887812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887880 */     GIR_RootConstrainSelectedInstOperands,
     /*  887881 */     // GIR_Coverage, 61274,
     /*  887881 */     GIR_EraseRootFromParent_Done,
     /*  887882 */   // Label 13579: @887882
     /*  887882 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(887957), // Rule ID 61275 //
     /*  887887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887955 */     GIR_RootConstrainSelectedInstOperands,
     /*  887956 */     // GIR_Coverage, 61275,
     /*  887956 */     GIR_EraseRootFromParent_Done,
     /*  887957 */   // Label 13580: @887957
     /*  887957 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(888032), // Rule ID 61278 //
     /*  887962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  888008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888030 */     GIR_RootConstrainSelectedInstOperands,
     /*  888031 */     // GIR_Coverage, 61278,
     /*  888031 */     GIR_EraseRootFromParent_Done,
     /*  888032 */   // Label 13581: @888032
     /*  888032 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(888107), // Rule ID 61279 //
     /*  888037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  888048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  888051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  888054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  888057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888083 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  888083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888105 */     GIR_RootConstrainSelectedInstOperands,
     /*  888106 */     // GIR_Coverage, 61279,
     /*  888106 */     GIR_EraseRootFromParent_Done,
     /*  888107 */   // Label 13582: @888107
     /*  888107 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(888182), // Rule ID 61282 //
     /*  888112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  888123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  888126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  888129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  888132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888180 */     GIR_RootConstrainSelectedInstOperands,
     /*  888181 */     // GIR_Coverage, 61282,
     /*  888181 */     GIR_EraseRootFromParent_Done,
     /*  888182 */   // Label 13583: @888182
     /*  888182 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(888257), // Rule ID 61283 //
     /*  888187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  888198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  888201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  888204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  888207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888255 */     GIR_RootConstrainSelectedInstOperands,
     /*  888256 */     // GIR_Coverage, 61283,
     /*  888256 */     GIR_EraseRootFromParent_Done,
     /*  888257 */   // Label 13584: @888257
     /*  888257 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(888332), // Rule ID 61286 //
     /*  888262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  888273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  888276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  888279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  888282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888330 */     GIR_RootConstrainSelectedInstOperands,
     /*  888331 */     // GIR_Coverage, 61286,
     /*  888331 */     GIR_EraseRootFromParent_Done,
     /*  888332 */   // Label 13585: @888332
     /*  888332 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(888407), // Rule ID 61287 //
     /*  888337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  888348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  888351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  888354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  888357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888405 */     GIR_RootConstrainSelectedInstOperands,
     /*  888406 */     // GIR_Coverage, 61287,
     /*  888406 */     GIR_EraseRootFromParent_Done,
     /*  888407 */   // Label 13586: @888407
     /*  888407 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(888482), // Rule ID 61290 //
     /*  888412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888480 */     GIR_RootConstrainSelectedInstOperands,
     /*  888481 */     // GIR_Coverage, 61290,
     /*  888481 */     GIR_EraseRootFromParent_Done,
     /*  888482 */   // Label 13587: @888482
     /*  888482 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(888557), // Rule ID 61291 //
     /*  888487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888533 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888555 */     GIR_RootConstrainSelectedInstOperands,
     /*  888556 */     // GIR_Coverage, 61291,
     /*  888556 */     GIR_EraseRootFromParent_Done,
     /*  888557 */   // Label 13588: @888557
     /*  888557 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(888632), // Rule ID 61294 //
     /*  888562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888630 */     GIR_RootConstrainSelectedInstOperands,
     /*  888631 */     // GIR_Coverage, 61294,
     /*  888631 */     GIR_EraseRootFromParent_Done,
     /*  888632 */   // Label 13589: @888632
     /*  888632 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(888707), // Rule ID 61295 //
     /*  888637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888705 */     GIR_RootConstrainSelectedInstOperands,
     /*  888706 */     // GIR_Coverage, 61295,
     /*  888706 */     GIR_EraseRootFromParent_Done,
     /*  888707 */   // Label 13590: @888707
     /*  888707 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(888782), // Rule ID 61298 //
     /*  888712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888780 */     GIR_RootConstrainSelectedInstOperands,
     /*  888781 */     // GIR_Coverage, 61298,
     /*  888781 */     GIR_EraseRootFromParent_Done,
     /*  888782 */   // Label 13591: @888782
     /*  888782 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(888857), // Rule ID 61299 //
     /*  888787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888833 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888855 */     GIR_RootConstrainSelectedInstOperands,
     /*  888856 */     // GIR_Coverage, 61299,
     /*  888856 */     GIR_EraseRootFromParent_Done,
     /*  888857 */   // Label 13592: @888857
     /*  888857 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(888932), // Rule ID 61302 //
     /*  888862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888930 */     GIR_RootConstrainSelectedInstOperands,
     /*  888931 */     // GIR_Coverage, 61302,
     /*  888931 */     GIR_EraseRootFromParent_Done,
     /*  888932 */   // Label 13593: @888932
     /*  888932 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(889007), // Rule ID 61303 //
     /*  888937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889005 */     GIR_RootConstrainSelectedInstOperands,
     /*  889006 */     // GIR_Coverage, 61303,
     /*  889006 */     GIR_EraseRootFromParent_Done,
     /*  889007 */   // Label 13594: @889007
     /*  889007 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(889082), // Rule ID 61306 //
     /*  889012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  889061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889080 */     GIR_RootConstrainSelectedInstOperands,
     /*  889081 */     // GIR_Coverage, 61306,
     /*  889081 */     GIR_EraseRootFromParent_Done,
     /*  889082 */   // Label 13595: @889082
     /*  889082 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(889157), // Rule ID 61307 //
     /*  889087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889133 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  889136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889155 */     GIR_RootConstrainSelectedInstOperands,
     /*  889156 */     // GIR_Coverage, 61307,
     /*  889156 */     GIR_EraseRootFromParent_Done,
     /*  889157 */   // Label 13596: @889157
     /*  889157 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(889232), // Rule ID 61310 //
     /*  889162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889208 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889230 */     GIR_RootConstrainSelectedInstOperands,
     /*  889231 */     // GIR_Coverage, 61310,
     /*  889231 */     GIR_EraseRootFromParent_Done,
     /*  889232 */   // Label 13597: @889232
     /*  889232 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(889307), // Rule ID 61311 //
     /*  889237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889283 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889305 */     GIR_RootConstrainSelectedInstOperands,
     /*  889306 */     // GIR_Coverage, 61311,
     /*  889306 */     GIR_EraseRootFromParent_Done,
     /*  889307 */   // Label 13598: @889307
     /*  889307 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(889382), // Rule ID 61314 //
     /*  889312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889358 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889380 */     GIR_RootConstrainSelectedInstOperands,
     /*  889381 */     // GIR_Coverage, 61314,
     /*  889381 */     GIR_EraseRootFromParent_Done,
     /*  889382 */   // Label 13599: @889382
     /*  889382 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(889457), // Rule ID 61315 //
     /*  889387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889433 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889455 */     GIR_RootConstrainSelectedInstOperands,
     /*  889456 */     // GIR_Coverage, 61315,
     /*  889456 */     GIR_EraseRootFromParent_Done,
     /*  889457 */   // Label 13600: @889457
     /*  889457 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(889532), // Rule ID 61318 //
     /*  889462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889508 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889530 */     GIR_RootConstrainSelectedInstOperands,
     /*  889531 */     // GIR_Coverage, 61318,
     /*  889531 */     GIR_EraseRootFromParent_Done,
     /*  889532 */   // Label 13601: @889532
     /*  889532 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(889607), // Rule ID 61319 //
     /*  889537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889583 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889605 */     GIR_RootConstrainSelectedInstOperands,
     /*  889606 */     // GIR_Coverage, 61319,
     /*  889606 */     GIR_EraseRootFromParent_Done,
     /*  889607 */   // Label 13602: @889607
     /*  889607 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(889682), // Rule ID 61322 //
     /*  889612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889680 */     GIR_RootConstrainSelectedInstOperands,
     /*  889681 */     // GIR_Coverage, 61322,
     /*  889681 */     GIR_EraseRootFromParent_Done,
     /*  889682 */   // Label 13603: @889682
     /*  889682 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(889757), // Rule ID 61323 //
     /*  889687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889755 */     GIR_RootConstrainSelectedInstOperands,
     /*  889756 */     // GIR_Coverage, 61323,
     /*  889756 */     GIR_EraseRootFromParent_Done,
     /*  889757 */   // Label 13604: @889757
     /*  889757 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(889832), // Rule ID 61326 //
     /*  889762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889830 */     GIR_RootConstrainSelectedInstOperands,
     /*  889831 */     // GIR_Coverage, 61326,
     /*  889831 */     GIR_EraseRootFromParent_Done,
     /*  889832 */   // Label 13605: @889832
     /*  889832 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(889907), // Rule ID 61327 //
     /*  889837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889883 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889905 */     GIR_RootConstrainSelectedInstOperands,
     /*  889906 */     // GIR_Coverage, 61327,
     /*  889906 */     GIR_EraseRootFromParent_Done,
     /*  889907 */   // Label 13606: @889907
     /*  889907 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(889982), // Rule ID 61330 //
     /*  889912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889980 */     GIR_RootConstrainSelectedInstOperands,
     /*  889981 */     // GIR_Coverage, 61330,
     /*  889981 */     GIR_EraseRootFromParent_Done,
     /*  889982 */   // Label 13607: @889982
     /*  889982 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(890057), // Rule ID 61331 //
     /*  889987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11214:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890055 */     GIR_RootConstrainSelectedInstOperands,
     /*  890056 */     // GIR_Coverage, 61331,
     /*  890056 */     GIR_EraseRootFromParent_Done,
     /*  890057 */   // Label 13608: @890057
     /*  890057 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(890132), // Rule ID 61334 //
     /*  890062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890130 */     GIR_RootConstrainSelectedInstOperands,
     /*  890131 */     // GIR_Coverage, 61334,
     /*  890131 */     GIR_EraseRootFromParent_Done,
     /*  890132 */   // Label 13609: @890132
     /*  890132 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(890207), // Rule ID 61335 //
     /*  890137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890183 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890205 */     GIR_RootConstrainSelectedInstOperands,
     /*  890206 */     // GIR_Coverage, 61335,
     /*  890206 */     GIR_EraseRootFromParent_Done,
     /*  890207 */   // Label 13610: @890207
     /*  890207 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(890282), // Rule ID 61338 //
     /*  890212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890280 */     GIR_RootConstrainSelectedInstOperands,
     /*  890281 */     // GIR_Coverage, 61338,
     /*  890281 */     GIR_EraseRootFromParent_Done,
     /*  890282 */   // Label 13611: @890282
     /*  890282 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(890357), // Rule ID 61339 //
     /*  890287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890355 */     GIR_RootConstrainSelectedInstOperands,
     /*  890356 */     // GIR_Coverage, 61339,
     /*  890356 */     GIR_EraseRootFromParent_Done,
     /*  890357 */   // Label 13612: @890357
     /*  890357 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(890432), // Rule ID 61342 //
     /*  890362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  890408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890430 */     GIR_RootConstrainSelectedInstOperands,
     /*  890431 */     // GIR_Coverage, 61342,
     /*  890431 */     GIR_EraseRootFromParent_Done,
     /*  890432 */   // Label 13613: @890432
     /*  890432 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(890507), // Rule ID 61343 //
     /*  890437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890483 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890505 */     GIR_RootConstrainSelectedInstOperands,
     /*  890506 */     // GIR_Coverage, 61343,
     /*  890506 */     GIR_EraseRootFromParent_Done,
     /*  890507 */   // Label 13614: @890507
     /*  890507 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(890582), // Rule ID 61346 //
     /*  890512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890580 */     GIR_RootConstrainSelectedInstOperands,
     /*  890581 */     // GIR_Coverage, 61346,
     /*  890581 */     GIR_EraseRootFromParent_Done,
     /*  890582 */   // Label 13615: @890582
     /*  890582 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(890657), // Rule ID 61347 //
     /*  890587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890633 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890655 */     GIR_RootConstrainSelectedInstOperands,
     /*  890656 */     // GIR_Coverage, 61347,
     /*  890656 */     GIR_EraseRootFromParent_Done,
     /*  890657 */   // Label 13616: @890657
     /*  890657 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(890732), // Rule ID 61350 //
     /*  890662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890730 */     GIR_RootConstrainSelectedInstOperands,
     /*  890731 */     // GIR_Coverage, 61350,
     /*  890731 */     GIR_EraseRootFromParent_Done,
     /*  890732 */   // Label 13617: @890732
     /*  890732 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(890807), // Rule ID 61351 //
     /*  890737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890783 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890805 */     GIR_RootConstrainSelectedInstOperands,
     /*  890806 */     // GIR_Coverage, 61351,
     /*  890806 */     GIR_EraseRootFromParent_Done,
     /*  890807 */   // Label 13618: @890807
     /*  890807 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(890882), // Rule ID 61354 //
     /*  890812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890880 */     GIR_RootConstrainSelectedInstOperands,
     /*  890881 */     // GIR_Coverage, 61354,
     /*  890881 */     GIR_EraseRootFromParent_Done,
     /*  890882 */   // Label 13619: @890882
     /*  890882 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(890957), // Rule ID 61355 //
     /*  890887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890933 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890955 */     GIR_RootConstrainSelectedInstOperands,
     /*  890956 */     // GIR_Coverage, 61355,
     /*  890956 */     GIR_EraseRootFromParent_Done,
     /*  890957 */   // Label 13620: @890957
     /*  890957 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(891032), // Rule ID 61358 //
     /*  890962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891030 */     GIR_RootConstrainSelectedInstOperands,
     /*  891031 */     // GIR_Coverage, 61358,
     /*  891031 */     GIR_EraseRootFromParent_Done,
     /*  891032 */   // Label 13621: @891032
     /*  891032 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(891107), // Rule ID 61359 //
     /*  891037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891083 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891105 */     GIR_RootConstrainSelectedInstOperands,
     /*  891106 */     // GIR_Coverage, 61359,
     /*  891106 */     GIR_EraseRootFromParent_Done,
     /*  891107 */   // Label 13622: @891107
     /*  891107 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(891182), // Rule ID 61362 //
     /*  891112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891180 */     GIR_RootConstrainSelectedInstOperands,
     /*  891181 */     // GIR_Coverage, 61362,
     /*  891181 */     GIR_EraseRootFromParent_Done,
     /*  891182 */   // Label 13623: @891182
     /*  891182 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(891257), // Rule ID 61363 //
     /*  891187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891233 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891255 */     GIR_RootConstrainSelectedInstOperands,
     /*  891256 */     // GIR_Coverage, 61363,
     /*  891256 */     GIR_EraseRootFromParent_Done,
     /*  891257 */   // Label 13624: @891257
     /*  891257 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(891332), // Rule ID 61366 //
     /*  891262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891330 */     GIR_RootConstrainSelectedInstOperands,
     /*  891331 */     // GIR_Coverage, 61366,
     /*  891331 */     GIR_EraseRootFromParent_Done,
     /*  891332 */   // Label 13625: @891332
     /*  891332 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(891407), // Rule ID 61367 //
     /*  891337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891383 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891405 */     GIR_RootConstrainSelectedInstOperands,
     /*  891406 */     // GIR_Coverage, 61367,
     /*  891406 */     GIR_EraseRootFromParent_Done,
     /*  891407 */   // Label 13626: @891407
     /*  891407 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(891482), // Rule ID 61370 //
     /*  891412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891480 */     GIR_RootConstrainSelectedInstOperands,
     /*  891481 */     // GIR_Coverage, 61370,
     /*  891481 */     GIR_EraseRootFromParent_Done,
     /*  891482 */   // Label 13627: @891482
     /*  891482 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(891557), // Rule ID 61371 //
     /*  891487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891555 */     GIR_RootConstrainSelectedInstOperands,
     /*  891556 */     // GIR_Coverage, 61371,
     /*  891556 */     GIR_EraseRootFromParent_Done,
     /*  891557 */   // Label 13628: @891557
     /*  891557 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(891632), // Rule ID 61374 //
     /*  891562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891630 */     GIR_RootConstrainSelectedInstOperands,
     /*  891631 */     // GIR_Coverage, 61374,
     /*  891631 */     GIR_EraseRootFromParent_Done,
     /*  891632 */   // Label 13629: @891632
     /*  891632 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(891707), // Rule ID 61375 //
     /*  891637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891683 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891705 */     GIR_RootConstrainSelectedInstOperands,
     /*  891706 */     // GIR_Coverage, 61375,
     /*  891706 */     GIR_EraseRootFromParent_Done,
     /*  891707 */   // Label 13630: @891707
     /*  891707 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(891782), // Rule ID 61378 //
     /*  891712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891780 */     GIR_RootConstrainSelectedInstOperands,
     /*  891781 */     // GIR_Coverage, 61378,
     /*  891781 */     GIR_EraseRootFromParent_Done,
     /*  891782 */   // Label 13631: @891782
     /*  891782 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(891857), // Rule ID 61379 //
     /*  891787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891833 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891855 */     GIR_RootConstrainSelectedInstOperands,
     /*  891856 */     // GIR_Coverage, 61379,
     /*  891856 */     GIR_EraseRootFromParent_Done,
     /*  891857 */   // Label 13632: @891857
     /*  891857 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(891932), // Rule ID 61382 //
     /*  891862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891930 */     GIR_RootConstrainSelectedInstOperands,
     /*  891931 */     // GIR_Coverage, 61382,
     /*  891931 */     GIR_EraseRootFromParent_Done,
     /*  891932 */   // Label 13633: @891932
     /*  891932 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(892007), // Rule ID 61383 //
     /*  891937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892005 */     GIR_RootConstrainSelectedInstOperands,
     /*  892006 */     // GIR_Coverage, 61383,
     /*  892006 */     GIR_EraseRootFromParent_Done,
     /*  892007 */   // Label 13634: @892007
     /*  892007 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(892082), // Rule ID 61386 //
     /*  892012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  892061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892080 */     GIR_RootConstrainSelectedInstOperands,
     /*  892081 */     // GIR_Coverage, 61386,
     /*  892081 */     GIR_EraseRootFromParent_Done,
     /*  892082 */   // Label 13635: @892082
     /*  892082 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(892157), // Rule ID 61387 //
     /*  892087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  892136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892155 */     GIR_RootConstrainSelectedInstOperands,
     /*  892156 */     // GIR_Coverage, 61387,
     /*  892156 */     GIR_EraseRootFromParent_Done,
     /*  892157 */   // Label 13636: @892157
     /*  892157 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(892232), // Rule ID 61390 //
     /*  892162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  892211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892230 */     GIR_RootConstrainSelectedInstOperands,
     /*  892231 */     // GIR_Coverage, 61390,
     /*  892231 */     GIR_EraseRootFromParent_Done,
     /*  892232 */   // Label 13637: @892232
     /*  892232 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(892307), // Rule ID 61391 //
     /*  892237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  892286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892305 */     GIR_RootConstrainSelectedInstOperands,
     /*  892306 */     // GIR_Coverage, 61391,
     /*  892306 */     GIR_EraseRootFromParent_Done,
     /*  892307 */   // Label 13638: @892307
     /*  892307 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(892382), // Rule ID 61570 //
     /*  892312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  892332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  892361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892380 */     GIR_RootConstrainSelectedInstOperands,
     /*  892381 */     // GIR_Coverage, 61570,
     /*  892381 */     GIR_EraseRootFromParent_Done,
     /*  892382 */   // Label 13639: @892382
     /*  892382 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(892457), // Rule ID 61571 //
     /*  892387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  892407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892433 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  892436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892455 */     GIR_RootConstrainSelectedInstOperands,
     /*  892456 */     // GIR_Coverage, 61571,
     /*  892456 */     GIR_EraseRootFromParent_Done,
     /*  892457 */   // Label 13640: @892457
     /*  892457 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(892532), // Rule ID 61574 //
     /*  892462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892530 */     GIR_RootConstrainSelectedInstOperands,
     /*  892531 */     // GIR_Coverage, 61574,
     /*  892531 */     GIR_EraseRootFromParent_Done,
     /*  892532 */   // Label 13641: @892532
     /*  892532 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(892607), // Rule ID 61575 //
     /*  892537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892583 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892605 */     GIR_RootConstrainSelectedInstOperands,
     /*  892606 */     // GIR_Coverage, 61575,
     /*  892606 */     GIR_EraseRootFromParent_Done,
     /*  892607 */   // Label 13642: @892607
     /*  892607 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(892682), // Rule ID 61578 //
     /*  892612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892680 */     GIR_RootConstrainSelectedInstOperands,
     /*  892681 */     // GIR_Coverage, 61578,
     /*  892681 */     GIR_EraseRootFromParent_Done,
     /*  892682 */   // Label 13643: @892682
     /*  892682 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(892757), // Rule ID 61579 //
     /*  892687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892733 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892755 */     GIR_RootConstrainSelectedInstOperands,
     /*  892756 */     // GIR_Coverage, 61579,
     /*  892756 */     GIR_EraseRootFromParent_Done,
     /*  892757 */   // Label 13644: @892757
     /*  892757 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(892832), // Rule ID 61582 //
     /*  892762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892830 */     GIR_RootConstrainSelectedInstOperands,
     /*  892831 */     // GIR_Coverage, 61582,
     /*  892831 */     GIR_EraseRootFromParent_Done,
     /*  892832 */   // Label 13645: @892832
     /*  892832 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(892907), // Rule ID 61583 //
     /*  892837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892883 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892905 */     GIR_RootConstrainSelectedInstOperands,
     /*  892906 */     // GIR_Coverage, 61583,
     /*  892906 */     GIR_EraseRootFromParent_Done,
     /*  892907 */   // Label 13646: @892907
     /*  892907 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(892982), // Rule ID 61586 //
     /*  892912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892980 */     GIR_RootConstrainSelectedInstOperands,
     /*  892981 */     // GIR_Coverage, 61586,
     /*  892981 */     GIR_EraseRootFromParent_Done,
     /*  892982 */   // Label 13647: @892982
     /*  892982 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(893057), // Rule ID 61587 //
     /*  892987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  893007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893033 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893055 */     GIR_RootConstrainSelectedInstOperands,
     /*  893056 */     // GIR_Coverage, 61587,
     /*  893056 */     GIR_EraseRootFromParent_Done,
     /*  893057 */   // Label 13648: @893057
     /*  893057 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(893132), // Rule ID 61590 //
     /*  893062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  893082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893130 */     GIR_RootConstrainSelectedInstOperands,
     /*  893131 */     // GIR_Coverage, 61590,
     /*  893131 */     GIR_EraseRootFromParent_Done,
     /*  893132 */   // Label 13649: @893132
     /*  893132 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(893207), // Rule ID 61591 //
     /*  893137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  893157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  893186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893205 */     GIR_RootConstrainSelectedInstOperands,
     /*  893206 */     // GIR_Coverage, 61591,
     /*  893206 */     GIR_EraseRootFromParent_Done,
     /*  893207 */   // Label 13650: @893207
     /*  893207 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(893282), // Rule ID 61594 //
     /*  893212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  893232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893280 */     GIR_RootConstrainSelectedInstOperands,
     /*  893281 */     // GIR_Coverage, 61594,
     /*  893281 */     GIR_EraseRootFromParent_Done,
     /*  893282 */   // Label 13651: @893282
     /*  893282 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(893357), // Rule ID 61595 //
     /*  893287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  893307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893355 */     GIR_RootConstrainSelectedInstOperands,
     /*  893356 */     // GIR_Coverage, 61595,
     /*  893356 */     GIR_EraseRootFromParent_Done,
     /*  893357 */   // Label 13652: @893357
     /*  893357 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(893432), // Rule ID 61598 //
     /*  893362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  893382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893430 */     GIR_RootConstrainSelectedInstOperands,
     /*  893431 */     // GIR_Coverage, 61598,
     /*  893431 */     GIR_EraseRootFromParent_Done,
     /*  893432 */   // Label 13653: @893432
     /*  893432 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(893507), // Rule ID 61599 //
     /*  893437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  893457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893505 */     GIR_RootConstrainSelectedInstOperands,
     /*  893506 */     // GIR_Coverage, 61599,
     /*  893506 */     GIR_EraseRootFromParent_Done,
     /*  893507 */   // Label 13654: @893507
     /*  893507 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(893582), // Rule ID 61602 //
     /*  893512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893580 */     GIR_RootConstrainSelectedInstOperands,
     /*  893581 */     // GIR_Coverage, 61602,
     /*  893581 */     GIR_EraseRootFromParent_Done,
     /*  893582 */   // Label 13655: @893582
     /*  893582 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(893657), // Rule ID 61603 //
     /*  893587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893655 */     GIR_RootConstrainSelectedInstOperands,
     /*  893656 */     // GIR_Coverage, 61603,
     /*  893656 */     GIR_EraseRootFromParent_Done,
     /*  893657 */   // Label 13656: @893657
     /*  893657 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(893732), // Rule ID 61606 //
     /*  893662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893730 */     GIR_RootConstrainSelectedInstOperands,
     /*  893731 */     // GIR_Coverage, 61606,
     /*  893731 */     GIR_EraseRootFromParent_Done,
     /*  893732 */   // Label 13657: @893732
     /*  893732 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(893807), // Rule ID 61607 //
     /*  893737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893805 */     GIR_RootConstrainSelectedInstOperands,
     /*  893806 */     // GIR_Coverage, 61607,
     /*  893806 */     GIR_EraseRootFromParent_Done,
     /*  893807 */   // Label 13658: @893807
     /*  893807 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(893882), // Rule ID 61610 //
     /*  893812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893880 */     GIR_RootConstrainSelectedInstOperands,
     /*  893881 */     // GIR_Coverage, 61610,
     /*  893881 */     GIR_EraseRootFromParent_Done,
     /*  893882 */   // Label 13659: @893882
     /*  893882 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(893957), // Rule ID 61611 //
     /*  893887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893933 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893955 */     GIR_RootConstrainSelectedInstOperands,
     /*  893956 */     // GIR_Coverage, 61611,
     /*  893956 */     GIR_EraseRootFromParent_Done,
     /*  893957 */   // Label 13660: @893957
     /*  893957 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(894032), // Rule ID 61614 //
     /*  893962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894030 */     GIR_RootConstrainSelectedInstOperands,
     /*  894031 */     // GIR_Coverage, 61614,
     /*  894031 */     GIR_EraseRootFromParent_Done,
     /*  894032 */   // Label 13661: @894032
     /*  894032 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(894107), // Rule ID 61615 //
     /*  894037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  894057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894083 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894105 */     GIR_RootConstrainSelectedInstOperands,
     /*  894106 */     // GIR_Coverage, 61615,
     /*  894106 */     GIR_EraseRootFromParent_Done,
     /*  894107 */   // Label 13662: @894107
     /*  894107 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(894182), // Rule ID 61618 //
     /*  894112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  894132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894180 */     GIR_RootConstrainSelectedInstOperands,
     /*  894181 */     // GIR_Coverage, 61618,
     /*  894181 */     GIR_EraseRootFromParent_Done,
     /*  894182 */   // Label 13663: @894182
     /*  894182 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(894257), // Rule ID 61619 //
     /*  894187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  894207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894233 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894255 */     GIR_RootConstrainSelectedInstOperands,
     /*  894256 */     // GIR_Coverage, 61619,
     /*  894256 */     GIR_EraseRootFromParent_Done,
     /*  894257 */   // Label 13664: @894257
     /*  894257 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(894332), // Rule ID 61622 //
     /*  894262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  894282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894330 */     GIR_RootConstrainSelectedInstOperands,
     /*  894331 */     // GIR_Coverage, 61622,
     /*  894331 */     GIR_EraseRootFromParent_Done,
     /*  894332 */   // Label 13665: @894332
     /*  894332 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(894407), // Rule ID 61623 //
     /*  894337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  894357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894405 */     GIR_RootConstrainSelectedInstOperands,
     /*  894406 */     // GIR_Coverage, 61623,
     /*  894406 */     GIR_EraseRootFromParent_Done,
     /*  894407 */   // Label 13666: @894407
     /*  894407 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(894482), // Rule ID 61626 //
     /*  894412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894480 */     GIR_RootConstrainSelectedInstOperands,
     /*  894481 */     // GIR_Coverage, 61626,
     /*  894481 */     GIR_EraseRootFromParent_Done,
     /*  894482 */   // Label 13667: @894482
     /*  894482 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(894557), // Rule ID 61627 //
     /*  894487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894555 */     GIR_RootConstrainSelectedInstOperands,
     /*  894556 */     // GIR_Coverage, 61627,
     /*  894556 */     GIR_EraseRootFromParent_Done,
     /*  894557 */   // Label 13668: @894557
     /*  894557 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(894632), // Rule ID 61630 //
     /*  894562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894630 */     GIR_RootConstrainSelectedInstOperands,
     /*  894631 */     // GIR_Coverage, 61630,
     /*  894631 */     GIR_EraseRootFromParent_Done,
     /*  894632 */   // Label 13669: @894632
     /*  894632 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(894707), // Rule ID 61631 //
     /*  894637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894683 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894705 */     GIR_RootConstrainSelectedInstOperands,
     /*  894706 */     // GIR_Coverage, 61631,
     /*  894706 */     GIR_EraseRootFromParent_Done,
     /*  894707 */   // Label 13670: @894707
     /*  894707 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(894782), // Rule ID 61634 //
     /*  894712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894780 */     GIR_RootConstrainSelectedInstOperands,
     /*  894781 */     // GIR_Coverage, 61634,
     /*  894781 */     GIR_EraseRootFromParent_Done,
     /*  894782 */   // Label 13671: @894782
     /*  894782 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(894857), // Rule ID 61635 //
     /*  894787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894855 */     GIR_RootConstrainSelectedInstOperands,
     /*  894856 */     // GIR_Coverage, 61635,
     /*  894856 */     GIR_EraseRootFromParent_Done,
     /*  894857 */   // Label 13672: @894857
     /*  894857 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(894932), // Rule ID 61638 //
     /*  894862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894930 */     GIR_RootConstrainSelectedInstOperands,
     /*  894931 */     // GIR_Coverage, 61638,
     /*  894931 */     GIR_EraseRootFromParent_Done,
     /*  894932 */   // Label 13673: @894932
     /*  894932 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(895007), // Rule ID 61639 //
     /*  894937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894983 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895005 */     GIR_RootConstrainSelectedInstOperands,
     /*  895006 */     // GIR_Coverage, 61639,
     /*  895006 */     GIR_EraseRootFromParent_Done,
     /*  895007 */   // Label 13674: @895007
     /*  895007 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(895082), // Rule ID 61642 //
     /*  895012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  895032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895080 */     GIR_RootConstrainSelectedInstOperands,
     /*  895081 */     // GIR_Coverage, 61642,
     /*  895081 */     GIR_EraseRootFromParent_Done,
     /*  895082 */   // Label 13675: @895082
     /*  895082 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(895157), // Rule ID 61643 //
     /*  895087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  895107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895133 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895155 */     GIR_RootConstrainSelectedInstOperands,
     /*  895156 */     // GIR_Coverage, 61643,
     /*  895156 */     GIR_EraseRootFromParent_Done,
     /*  895157 */   // Label 13676: @895157
     /*  895157 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(895232), // Rule ID 61646 //
     /*  895162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  895182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  895211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895230 */     GIR_RootConstrainSelectedInstOperands,
     /*  895231 */     // GIR_Coverage, 61646,
     /*  895231 */     GIR_EraseRootFromParent_Done,
     /*  895232 */   // Label 13677: @895232
     /*  895232 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(895307), // Rule ID 61647 //
     /*  895237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  895257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  895286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895305 */     GIR_RootConstrainSelectedInstOperands,
     /*  895306 */     // GIR_Coverage, 61647,
     /*  895306 */     GIR_EraseRootFromParent_Done,
     /*  895307 */   // Label 13678: @895307
     /*  895307 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(895382), // Rule ID 61650 //
     /*  895312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  895332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  895361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895380 */     GIR_RootConstrainSelectedInstOperands,
     /*  895381 */     // GIR_Coverage, 61650,
     /*  895381 */     GIR_EraseRootFromParent_Done,
     /*  895382 */   // Label 13679: @895382
     /*  895382 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(895457), // Rule ID 61651 //
     /*  895387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  895407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895433 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  895436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895455 */     GIR_RootConstrainSelectedInstOperands,
     /*  895456 */     // GIR_Coverage, 61651,
     /*  895456 */     GIR_EraseRootFromParent_Done,
     /*  895457 */   // Label 13680: @895457
     /*  895457 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(895532), // Rule ID 61654 //
     /*  895462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895530 */     GIR_RootConstrainSelectedInstOperands,
     /*  895531 */     // GIR_Coverage, 61654,
     /*  895531 */     GIR_EraseRootFromParent_Done,
     /*  895532 */   // Label 13681: @895532
     /*  895532 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(895607), // Rule ID 61655 //
     /*  895537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895583 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895605 */     GIR_RootConstrainSelectedInstOperands,
     /*  895606 */     // GIR_Coverage, 61655,
     /*  895606 */     GIR_EraseRootFromParent_Done,
     /*  895607 */   // Label 13682: @895607
     /*  895607 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(895682), // Rule ID 61658 //
     /*  895612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895658 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895680 */     GIR_RootConstrainSelectedInstOperands,
     /*  895681 */     // GIR_Coverage, 61658,
     /*  895681 */     GIR_EraseRootFromParent_Done,
     /*  895682 */   // Label 13683: @895682
     /*  895682 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(895757), // Rule ID 61659 //
     /*  895687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895733 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895755 */     GIR_RootConstrainSelectedInstOperands,
     /*  895756 */     // GIR_Coverage, 61659,
     /*  895756 */     GIR_EraseRootFromParent_Done,
     /*  895757 */   // Label 13684: @895757
     /*  895757 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(895832), // Rule ID 61662 //
     /*  895762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895808 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895830 */     GIR_RootConstrainSelectedInstOperands,
     /*  895831 */     // GIR_Coverage, 61662,
     /*  895831 */     GIR_EraseRootFromParent_Done,
     /*  895832 */   // Label 13685: @895832
     /*  895832 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(895907), // Rule ID 61663 //
     /*  895837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895883 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895905 */     GIR_RootConstrainSelectedInstOperands,
     /*  895906 */     // GIR_Coverage, 61663,
     /*  895906 */     GIR_EraseRootFromParent_Done,
     /*  895907 */   // Label 13686: @895907
     /*  895907 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(895982), // Rule ID 61666 //
     /*  895912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895980 */     GIR_RootConstrainSelectedInstOperands,
     /*  895981 */     // GIR_Coverage, 61666,
     /*  895981 */     GIR_EraseRootFromParent_Done,
     /*  895982 */   // Label 13687: @895982
     /*  895982 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(896057), // Rule ID 61667 //
     /*  895987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896033 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896055 */     GIR_RootConstrainSelectedInstOperands,
     /*  896056 */     // GIR_Coverage, 61667,
     /*  896056 */     GIR_EraseRootFromParent_Done,
     /*  896057 */   // Label 13688: @896057
     /*  896057 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(896132), // Rule ID 61670 //
     /*  896062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  896111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896130 */     GIR_RootConstrainSelectedInstOperands,
     /*  896131 */     // GIR_Coverage, 61670,
     /*  896131 */     GIR_EraseRootFromParent_Done,
     /*  896132 */   // Label 13689: @896132
     /*  896132 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(896207), // Rule ID 61671 //
     /*  896137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896183 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  896186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896205 */     GIR_RootConstrainSelectedInstOperands,
     /*  896206 */     // GIR_Coverage, 61671,
     /*  896206 */     GIR_EraseRootFromParent_Done,
     /*  896207 */   // Label 13690: @896207
     /*  896207 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(896282), // Rule ID 61674 //
     /*  896212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896280 */     GIR_RootConstrainSelectedInstOperands,
     /*  896281 */     // GIR_Coverage, 61674,
     /*  896281 */     GIR_EraseRootFromParent_Done,
     /*  896282 */   // Label 13691: @896282
     /*  896282 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(896357), // Rule ID 61675 //
     /*  896287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896333 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896355 */     GIR_RootConstrainSelectedInstOperands,
     /*  896356 */     // GIR_Coverage, 61675,
     /*  896356 */     GIR_EraseRootFromParent_Done,
     /*  896357 */   // Label 13692: @896357
     /*  896357 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(896432), // Rule ID 61678 //
     /*  896362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896430 */     GIR_RootConstrainSelectedInstOperands,
     /*  896431 */     // GIR_Coverage, 61678,
     /*  896431 */     GIR_EraseRootFromParent_Done,
     /*  896432 */   // Label 13693: @896432
     /*  896432 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(896507), // Rule ID 61679 //
     /*  896437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896483 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896505 */     GIR_RootConstrainSelectedInstOperands,
     /*  896506 */     // GIR_Coverage, 61679,
     /*  896506 */     GIR_EraseRootFromParent_Done,
     /*  896507 */   // Label 13694: @896507
     /*  896507 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(896582), // Rule ID 61682 //
     /*  896512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896580 */     GIR_RootConstrainSelectedInstOperands,
     /*  896581 */     // GIR_Coverage, 61682,
     /*  896581 */     GIR_EraseRootFromParent_Done,
     /*  896582 */   // Label 13695: @896582
     /*  896582 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(896657), // Rule ID 61683 //
     /*  896587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896655 */     GIR_RootConstrainSelectedInstOperands,
     /*  896656 */     // GIR_Coverage, 61683,
     /*  896656 */     GIR_EraseRootFromParent_Done,
     /*  896657 */   // Label 13696: @896657
     /*  896657 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(896732), // Rule ID 61686 //
     /*  896662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896730 */     GIR_RootConstrainSelectedInstOperands,
     /*  896731 */     // GIR_Coverage, 61686,
     /*  896731 */     GIR_EraseRootFromParent_Done,
     /*  896732 */   // Label 13697: @896732
     /*  896732 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(896807), // Rule ID 61687 //
     /*  896737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896805 */     GIR_RootConstrainSelectedInstOperands,
     /*  896806 */     // GIR_Coverage, 61687,
     /*  896806 */     GIR_EraseRootFromParent_Done,
     /*  896807 */   // Label 13698: @896807
     /*  896807 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(896882), // Rule ID 61690 //
     /*  896812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896880 */     GIR_RootConstrainSelectedInstOperands,
     /*  896881 */     // GIR_Coverage, 61690,
     /*  896881 */     GIR_EraseRootFromParent_Done,
     /*  896882 */   // Label 13699: @896882
     /*  896882 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(896957), // Rule ID 61691 //
     /*  896887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896955 */     GIR_RootConstrainSelectedInstOperands,
     /*  896956 */     // GIR_Coverage, 61691,
     /*  896956 */     GIR_EraseRootFromParent_Done,
     /*  896957 */   // Label 13700: @896957
     /*  896957 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(897032), // Rule ID 61694 //
     /*  896962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  897011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897030 */     GIR_RootConstrainSelectedInstOperands,
     /*  897031 */     // GIR_Coverage, 61694,
     /*  897031 */     GIR_EraseRootFromParent_Done,
     /*  897032 */   // Label 13701: @897032
     /*  897032 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(897107), // Rule ID 61695 //
     /*  897037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  897086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897105 */     GIR_RootConstrainSelectedInstOperands,
     /*  897106 */     // GIR_Coverage, 61695,
     /*  897106 */     GIR_EraseRootFromParent_Done,
     /*  897107 */   // Label 13702: @897107
     /*  897107 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(897182), // Rule ID 61698 //
     /*  897112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897180 */     GIR_RootConstrainSelectedInstOperands,
     /*  897181 */     // GIR_Coverage, 61698,
     /*  897181 */     GIR_EraseRootFromParent_Done,
     /*  897182 */   // Label 13703: @897182
     /*  897182 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(897257), // Rule ID 61699 //
     /*  897187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897233 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897255 */     GIR_RootConstrainSelectedInstOperands,
     /*  897256 */     // GIR_Coverage, 61699,
     /*  897256 */     GIR_EraseRootFromParent_Done,
     /*  897257 */   // Label 13704: @897257
     /*  897257 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(897332), // Rule ID 61702 //
     /*  897262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897308 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897330 */     GIR_RootConstrainSelectedInstOperands,
     /*  897331 */     // GIR_Coverage, 61702,
     /*  897331 */     GIR_EraseRootFromParent_Done,
     /*  897332 */   // Label 13705: @897332
     /*  897332 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(897407), // Rule ID 61703 //
     /*  897337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897383 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897405 */     GIR_RootConstrainSelectedInstOperands,
     /*  897406 */     // GIR_Coverage, 61703,
     /*  897406 */     GIR_EraseRootFromParent_Done,
     /*  897407 */   // Label 13706: @897407
     /*  897407 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(897482), // Rule ID 61706 //
     /*  897412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897458 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897480 */     GIR_RootConstrainSelectedInstOperands,
     /*  897481 */     // GIR_Coverage, 61706,
     /*  897481 */     GIR_EraseRootFromParent_Done,
     /*  897482 */   // Label 13707: @897482
     /*  897482 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(897557), // Rule ID 61707 //
     /*  897487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897533 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897555 */     GIR_RootConstrainSelectedInstOperands,
     /*  897556 */     // GIR_Coverage, 61707,
     /*  897556 */     GIR_EraseRootFromParent_Done,
     /*  897557 */   // Label 13708: @897557
     /*  897557 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(897632), // Rule ID 61710 //
     /*  897562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897630 */     GIR_RootConstrainSelectedInstOperands,
     /*  897631 */     // GIR_Coverage, 61710,
     /*  897631 */     GIR_EraseRootFromParent_Done,
     /*  897632 */   // Label 13709: @897632
     /*  897632 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(897707), // Rule ID 61711 //
     /*  897637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897683 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897705 */     GIR_RootConstrainSelectedInstOperands,
     /*  897706 */     // GIR_Coverage, 61711,
     /*  897706 */     GIR_EraseRootFromParent_Done,
     /*  897707 */   // Label 13710: @897707
     /*  897707 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(897782), // Rule ID 61714 //
     /*  897712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897758 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897780 */     GIR_RootConstrainSelectedInstOperands,
     /*  897781 */     // GIR_Coverage, 61714,
     /*  897781 */     GIR_EraseRootFromParent_Done,
     /*  897782 */   // Label 13711: @897782
     /*  897782 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(897857), // Rule ID 61715 //
     /*  897787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897833 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897855 */     GIR_RootConstrainSelectedInstOperands,
     /*  897856 */     // GIR_Coverage, 61715,
     /*  897856 */     GIR_EraseRootFromParent_Done,
     /*  897857 */   // Label 13712: @897857
     /*  897857 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(897932), // Rule ID 61718 //
     /*  897862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897930 */     GIR_RootConstrainSelectedInstOperands,
     /*  897931 */     // GIR_Coverage, 61718,
     /*  897931 */     GIR_EraseRootFromParent_Done,
     /*  897932 */   // Label 13713: @897932
     /*  897932 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(898007), // Rule ID 61719 //
     /*  897937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897983 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898005 */     GIR_RootConstrainSelectedInstOperands,
     /*  898006 */     // GIR_Coverage, 61719,
     /*  898006 */     GIR_EraseRootFromParent_Done,
     /*  898007 */   // Label 13714: @898007
     /*  898007 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(898082), // Rule ID 61722 //
     /*  898012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898080 */     GIR_RootConstrainSelectedInstOperands,
     /*  898081 */     // GIR_Coverage, 61722,
     /*  898081 */     GIR_EraseRootFromParent_Done,
     /*  898082 */   // Label 13715: @898082
     /*  898082 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(898157), // Rule ID 61723 //
     /*  898087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898155 */     GIR_RootConstrainSelectedInstOperands,
     /*  898156 */     // GIR_Coverage, 61723,
     /*  898156 */     GIR_EraseRootFromParent_Done,
     /*  898157 */   // Label 13716: @898157
     /*  898157 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(898232), // Rule ID 61726 //
     /*  898162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898230 */     GIR_RootConstrainSelectedInstOperands,
     /*  898231 */     // GIR_Coverage, 61726,
     /*  898231 */     GIR_EraseRootFromParent_Done,
     /*  898232 */   // Label 13717: @898232
     /*  898232 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(898307), // Rule ID 61727 //
     /*  898237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898305 */     GIR_RootConstrainSelectedInstOperands,
     /*  898306 */     // GIR_Coverage, 61727,
     /*  898306 */     GIR_EraseRootFromParent_Done,
     /*  898307 */   // Label 13718: @898307
     /*  898307 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(898382), // Rule ID 61730 //
     /*  898312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898380 */     GIR_RootConstrainSelectedInstOperands,
     /*  898381 */     // GIR_Coverage, 61730,
     /*  898381 */     GIR_EraseRootFromParent_Done,
     /*  898382 */   // Label 13719: @898382
     /*  898382 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(898457), // Rule ID 61731 //
     /*  898387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898433 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898455 */     GIR_RootConstrainSelectedInstOperands,
     /*  898456 */     // GIR_Coverage, 61731,
     /*  898456 */     GIR_EraseRootFromParent_Done,
     /*  898457 */   // Label 13720: @898457
     /*  898457 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(898532), // Rule ID 61734 //
     /*  898462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898530 */     GIR_RootConstrainSelectedInstOperands,
     /*  898531 */     // GIR_Coverage, 61734,
     /*  898531 */     GIR_EraseRootFromParent_Done,
     /*  898532 */   // Label 13721: @898532
     /*  898532 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(898607), // Rule ID 61735 //
     /*  898537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898605 */     GIR_RootConstrainSelectedInstOperands,
     /*  898606 */     // GIR_Coverage, 61735,
     /*  898606 */     GIR_EraseRootFromParent_Done,
     /*  898607 */   // Label 13722: @898607
     /*  898607 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(898682), // Rule ID 61738 //
     /*  898612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898680 */     GIR_RootConstrainSelectedInstOperands,
     /*  898681 */     // GIR_Coverage, 61738,
     /*  898681 */     GIR_EraseRootFromParent_Done,
     /*  898682 */   // Label 13723: @898682
     /*  898682 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(898757), // Rule ID 61739 //
     /*  898687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898733 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898755 */     GIR_RootConstrainSelectedInstOperands,
     /*  898756 */     // GIR_Coverage, 61739,
     /*  898756 */     GIR_EraseRootFromParent_Done,
     /*  898757 */   // Label 13724: @898757
     /*  898757 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(898832), // Rule ID 61742 //
     /*  898762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898830 */     GIR_RootConstrainSelectedInstOperands,
     /*  898831 */     // GIR_Coverage, 61742,
     /*  898831 */     GIR_EraseRootFromParent_Done,
     /*  898832 */   // Label 13725: @898832
     /*  898832 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(898907), // Rule ID 61743 //
     /*  898837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898905 */     GIR_RootConstrainSelectedInstOperands,
     /*  898906 */     // GIR_Coverage, 61743,
     /*  898906 */     GIR_EraseRootFromParent_Done,
     /*  898907 */   // Label 13726: @898907
     /*  898907 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(898982), // Rule ID 61830 //
     /*  898912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898958 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898980 */     GIR_RootConstrainSelectedInstOperands,
     /*  898981 */     // GIR_Coverage, 61830,
     /*  898981 */     GIR_EraseRootFromParent_Done,
     /*  898982 */   // Label 13727: @898982
     /*  898982 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(899057), // Rule ID 61831 //
     /*  898987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  899007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899033 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  899036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899055 */     GIR_RootConstrainSelectedInstOperands,
     /*  899056 */     // GIR_Coverage, 61831,
     /*  899056 */     GIR_EraseRootFromParent_Done,
     /*  899057 */   // Label 13728: @899057
     /*  899057 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(899132), // Rule ID 61834 //
     /*  899062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  899082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899108 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899130 */     GIR_RootConstrainSelectedInstOperands,
     /*  899131 */     // GIR_Coverage, 61834,
     /*  899131 */     GIR_EraseRootFromParent_Done,
     /*  899132 */   // Label 13729: @899132
     /*  899132 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(899207), // Rule ID 61835 //
     /*  899137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  899157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899183 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899205 */     GIR_RootConstrainSelectedInstOperands,
     /*  899206 */     // GIR_Coverage, 61835,
     /*  899206 */     GIR_EraseRootFromParent_Done,
     /*  899207 */   // Label 13730: @899207
     /*  899207 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(899282), // Rule ID 61838 //
     /*  899212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  899232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899280 */     GIR_RootConstrainSelectedInstOperands,
     /*  899281 */     // GIR_Coverage, 61838,
     /*  899281 */     GIR_EraseRootFromParent_Done,
     /*  899282 */   // Label 13731: @899282
     /*  899282 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(899357), // Rule ID 61839 //
     /*  899287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  899307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899333 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899355 */     GIR_RootConstrainSelectedInstOperands,
     /*  899356 */     // GIR_Coverage, 61839,
     /*  899356 */     GIR_EraseRootFromParent_Done,
     /*  899357 */   // Label 13732: @899357
     /*  899357 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(899432), // Rule ID 61842 //
     /*  899362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899430 */     GIR_RootConstrainSelectedInstOperands,
     /*  899431 */     // GIR_Coverage, 61842,
     /*  899431 */     GIR_EraseRootFromParent_Done,
     /*  899432 */   // Label 13733: @899432
     /*  899432 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(899507), // Rule ID 61843 //
     /*  899437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  899457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899483 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899505 */     GIR_RootConstrainSelectedInstOperands,
     /*  899506 */     // GIR_Coverage, 61843,
     /*  899506 */     GIR_EraseRootFromParent_Done,
     /*  899507 */   // Label 13734: @899507
     /*  899507 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(899582), // Rule ID 61846 //
     /*  899512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899580 */     GIR_RootConstrainSelectedInstOperands,
     /*  899581 */     // GIR_Coverage, 61846,
     /*  899581 */     GIR_EraseRootFromParent_Done,
     /*  899582 */   // Label 13735: @899582
     /*  899582 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(899657), // Rule ID 61847 //
     /*  899587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899633 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899655 */     GIR_RootConstrainSelectedInstOperands,
     /*  899656 */     // GIR_Coverage, 61847,
     /*  899656 */     GIR_EraseRootFromParent_Done,
     /*  899657 */   // Label 13736: @899657
     /*  899657 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(899732), // Rule ID 61850 //
     /*  899662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899730 */     GIR_RootConstrainSelectedInstOperands,
     /*  899731 */     // GIR_Coverage, 61850,
     /*  899731 */     GIR_EraseRootFromParent_Done,
     /*  899732 */   // Label 13737: @899732
     /*  899732 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(899807), // Rule ID 61851 //
     /*  899737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899783 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899805 */     GIR_RootConstrainSelectedInstOperands,
     /*  899806 */     // GIR_Coverage, 61851,
     /*  899806 */     GIR_EraseRootFromParent_Done,
     /*  899807 */   // Label 13738: @899807
     /*  899807 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(899882), // Rule ID 61854 //
     /*  899812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899880 */     GIR_RootConstrainSelectedInstOperands,
     /*  899881 */     // GIR_Coverage, 61854,
     /*  899881 */     GIR_EraseRootFromParent_Done,
     /*  899882 */   // Label 13739: @899882
     /*  899882 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(899957), // Rule ID 61855 //
     /*  899887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899933 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899955 */     GIR_RootConstrainSelectedInstOperands,
     /*  899956 */     // GIR_Coverage, 61855,
     /*  899956 */     GIR_EraseRootFromParent_Done,
     /*  899957 */   // Label 13740: @899957
     /*  899957 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(900032), // Rule ID 61858 //
     /*  899962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900030 */     GIR_RootConstrainSelectedInstOperands,
     /*  900031 */     // GIR_Coverage, 61858,
     /*  900031 */     GIR_EraseRootFromParent_Done,
     /*  900032 */   // Label 13741: @900032
     /*  900032 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(900107), // Rule ID 61859 //
     /*  900037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  900057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900105 */     GIR_RootConstrainSelectedInstOperands,
     /*  900106 */     // GIR_Coverage, 61859,
     /*  900106 */     GIR_EraseRootFromParent_Done,
     /*  900107 */   // Label 13742: @900107
     /*  900107 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(900182), // Rule ID 61862 //
     /*  900112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900180 */     GIR_RootConstrainSelectedInstOperands,
     /*  900181 */     // GIR_Coverage, 61862,
     /*  900181 */     GIR_EraseRootFromParent_Done,
     /*  900182 */   // Label 13743: @900182
     /*  900182 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(900257), // Rule ID 61863 //
     /*  900187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  900207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900255 */     GIR_RootConstrainSelectedInstOperands,
     /*  900256 */     // GIR_Coverage, 61863,
     /*  900256 */     GIR_EraseRootFromParent_Done,
     /*  900257 */   // Label 13744: @900257
     /*  900257 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(900332), // Rule ID 61866 //
     /*  900262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  900282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900330 */     GIR_RootConstrainSelectedInstOperands,
     /*  900331 */     // GIR_Coverage, 61866,
     /*  900331 */     GIR_EraseRootFromParent_Done,
     /*  900332 */   // Label 13745: @900332
     /*  900332 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(900407), // Rule ID 61867 //
     /*  900337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  900357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  900383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  900386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900405 */     GIR_RootConstrainSelectedInstOperands,
     /*  900406 */     // GIR_Coverage, 61867,
     /*  900406 */     GIR_EraseRootFromParent_Done,
     /*  900407 */   // Label 13746: @900407
     /*  900407 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(900482), // Rule ID 61870 //
     /*  900412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900480 */     GIR_RootConstrainSelectedInstOperands,
     /*  900481 */     // GIR_Coverage, 61870,
     /*  900481 */     GIR_EraseRootFromParent_Done,
     /*  900482 */   // Label 13747: @900482
     /*  900482 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(900557), // Rule ID 61871 //
     /*  900487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900555 */     GIR_RootConstrainSelectedInstOperands,
     /*  900556 */     // GIR_Coverage, 61871,
     /*  900556 */     GIR_EraseRootFromParent_Done,
     /*  900557 */   // Label 13748: @900557
     /*  900557 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(900632), // Rule ID 61874 //
     /*  900562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900608 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900630 */     GIR_RootConstrainSelectedInstOperands,
     /*  900631 */     // GIR_Coverage, 61874,
     /*  900631 */     GIR_EraseRootFromParent_Done,
     /*  900632 */   // Label 13749: @900632
     /*  900632 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(900707), // Rule ID 61875 //
     /*  900637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900683 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900705 */     GIR_RootConstrainSelectedInstOperands,
     /*  900706 */     // GIR_Coverage, 61875,
     /*  900706 */     GIR_EraseRootFromParent_Done,
     /*  900707 */   // Label 13750: @900707
     /*  900707 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(900782), // Rule ID 61878 //
     /*  900712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900780 */     GIR_RootConstrainSelectedInstOperands,
     /*  900781 */     // GIR_Coverage, 61878,
     /*  900781 */     GIR_EraseRootFromParent_Done,
     /*  900782 */   // Label 13751: @900782
     /*  900782 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(900857), // Rule ID 61879 //
     /*  900787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900833 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900855 */     GIR_RootConstrainSelectedInstOperands,
     /*  900856 */     // GIR_Coverage, 61879,
     /*  900856 */     GIR_EraseRootFromParent_Done,
     /*  900857 */   // Label 13752: @900857
     /*  900857 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(900932), // Rule ID 61882 //
     /*  900862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900930 */     GIR_RootConstrainSelectedInstOperands,
     /*  900931 */     // GIR_Coverage, 61882,
     /*  900931 */     GIR_EraseRootFromParent_Done,
     /*  900932 */   // Label 13753: @900932
     /*  900932 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(901007), // Rule ID 61883 //
     /*  900937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901005 */     GIR_RootConstrainSelectedInstOperands,
     /*  901006 */     // GIR_Coverage, 61883,
     /*  901006 */     GIR_EraseRootFromParent_Done,
     /*  901007 */   // Label 13754: @901007
     /*  901007 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(901082), // Rule ID 61886 //
     /*  901012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  901032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901080 */     GIR_RootConstrainSelectedInstOperands,
     /*  901081 */     // GIR_Coverage, 61886,
     /*  901081 */     GIR_EraseRootFromParent_Done,
     /*  901082 */   // Label 13755: @901082
     /*  901082 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(901157), // Rule ID 61887 //
     /*  901087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  901107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901133 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901155 */     GIR_RootConstrainSelectedInstOperands,
     /*  901156 */     // GIR_Coverage, 61887,
     /*  901156 */     GIR_EraseRootFromParent_Done,
     /*  901157 */   // Label 13756: @901157
     /*  901157 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(901232), // Rule ID 61890 //
     /*  901162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  901182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901208 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901230 */     GIR_RootConstrainSelectedInstOperands,
     /*  901231 */     // GIR_Coverage, 61890,
     /*  901231 */     GIR_EraseRootFromParent_Done,
     /*  901232 */   // Label 13757: @901232
     /*  901232 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(901307), // Rule ID 61891 //
     /*  901237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  901257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901283 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901305 */     GIR_RootConstrainSelectedInstOperands,
     /*  901306 */     // GIR_Coverage, 61891,
     /*  901306 */     GIR_EraseRootFromParent_Done,
     /*  901307 */   // Label 13758: @901307
     /*  901307 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(901382), // Rule ID 61894 //
     /*  901312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  901332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901380 */     GIR_RootConstrainSelectedInstOperands,
     /*  901381 */     // GIR_Coverage, 61894,
     /*  901381 */     GIR_EraseRootFromParent_Done,
     /*  901382 */   // Label 13759: @901382
     /*  901382 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(901457), // Rule ID 61895 //
     /*  901387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  901407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901455 */     GIR_RootConstrainSelectedInstOperands,
     /*  901456 */     // GIR_Coverage, 61895,
     /*  901456 */     GIR_EraseRootFromParent_Done,
     /*  901457 */   // Label 13760: @901457
     /*  901457 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(901532), // Rule ID 61898 //
     /*  901462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901530 */     GIR_RootConstrainSelectedInstOperands,
     /*  901531 */     // GIR_Coverage, 61898,
     /*  901531 */     GIR_EraseRootFromParent_Done,
     /*  901532 */   // Label 13761: @901532
     /*  901532 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(901607), // Rule ID 61899 //
     /*  901537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901605 */     GIR_RootConstrainSelectedInstOperands,
     /*  901606 */     // GIR_Coverage, 61899,
     /*  901606 */     GIR_EraseRootFromParent_Done,
     /*  901607 */   // Label 13762: @901607
     /*  901607 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(901682), // Rule ID 61902 //
     /*  901612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901680 */     GIR_RootConstrainSelectedInstOperands,
     /*  901681 */     // GIR_Coverage, 61902,
     /*  901681 */     GIR_EraseRootFromParent_Done,
     /*  901682 */   // Label 13763: @901682
     /*  901682 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(901757), // Rule ID 61903 //
     /*  901687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901733 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901755 */     GIR_RootConstrainSelectedInstOperands,
     /*  901756 */     // GIR_Coverage, 61903,
     /*  901756 */     GIR_EraseRootFromParent_Done,
     /*  901757 */   // Label 13764: @901757
     /*  901757 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(901832), // Rule ID 61906 //
     /*  901762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901830 */     GIR_RootConstrainSelectedInstOperands,
     /*  901831 */     // GIR_Coverage, 61906,
     /*  901831 */     GIR_EraseRootFromParent_Done,
     /*  901832 */   // Label 13765: @901832
     /*  901832 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(901907), // Rule ID 61907 //
     /*  901837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901905 */     GIR_RootConstrainSelectedInstOperands,
     /*  901906 */     // GIR_Coverage, 61907,
     /*  901906 */     GIR_EraseRootFromParent_Done,
     /*  901907 */   // Label 13766: @901907
     /*  901907 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(901982), // Rule ID 61910 //
     /*  901912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901980 */     GIR_RootConstrainSelectedInstOperands,
     /*  901981 */     // GIR_Coverage, 61910,
     /*  901981 */     GIR_EraseRootFromParent_Done,
     /*  901982 */   // Label 13767: @901982
     /*  901982 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(902057), // Rule ID 61911 //
     /*  901987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  902007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902033 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  902036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902055 */     GIR_RootConstrainSelectedInstOperands,
     /*  902056 */     // GIR_Coverage, 61911,
     /*  902056 */     GIR_EraseRootFromParent_Done,
     /*  902057 */   // Label 13768: @902057
     /*  902057 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(902132), // Rule ID 61914 //
     /*  902062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  902082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  902111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902130 */     GIR_RootConstrainSelectedInstOperands,
     /*  902131 */     // GIR_Coverage, 61914,
     /*  902131 */     GIR_EraseRootFromParent_Done,
     /*  902132 */   // Label 13769: @902132
     /*  902132 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(902207), // Rule ID 61915 //
     /*  902137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  902157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902183 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  902186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902205 */     GIR_RootConstrainSelectedInstOperands,
     /*  902206 */     // GIR_Coverage, 61915,
     /*  902206 */     GIR_EraseRootFromParent_Done,
     /*  902207 */   // Label 13770: @902207
     /*  902207 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(902282), // Rule ID 61918 //
     /*  902212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902258 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  902261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902280 */     GIR_RootConstrainSelectedInstOperands,
     /*  902281 */     // GIR_Coverage, 61918,
     /*  902281 */     GIR_EraseRootFromParent_Done,
     /*  902282 */   // Label 13771: @902282
     /*  902282 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(902357), // Rule ID 61919 //
     /*  902287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902333 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  902336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902355 */     GIR_RootConstrainSelectedInstOperands,
     /*  902356 */     // GIR_Coverage, 61919,
     /*  902356 */     GIR_EraseRootFromParent_Done,
     /*  902357 */   // Label 13772: @902357
     /*  902357 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(902432), // Rule ID 61922 //
     /*  902362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902408 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902430 */     GIR_RootConstrainSelectedInstOperands,
     /*  902431 */     // GIR_Coverage, 61922,
     /*  902431 */     GIR_EraseRootFromParent_Done,
     /*  902432 */   // Label 13773: @902432
     /*  902432 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(902507), // Rule ID 61923 //
     /*  902437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902483 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902505 */     GIR_RootConstrainSelectedInstOperands,
     /*  902506 */     // GIR_Coverage, 61923,
     /*  902506 */     GIR_EraseRootFromParent_Done,
     /*  902507 */   // Label 13774: @902507
     /*  902507 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(902582), // Rule ID 61926 //
     /*  902512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902558 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902580 */     GIR_RootConstrainSelectedInstOperands,
     /*  902581 */     // GIR_Coverage, 61926,
     /*  902581 */     GIR_EraseRootFromParent_Done,
     /*  902582 */   // Label 13775: @902582
     /*  902582 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(902657), // Rule ID 61927 //
     /*  902587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902633 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902655 */     GIR_RootConstrainSelectedInstOperands,
     /*  902656 */     // GIR_Coverage, 61927,
     /*  902656 */     GIR_EraseRootFromParent_Done,
     /*  902657 */   // Label 13776: @902657
     /*  902657 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(902732), // Rule ID 61930 //
     /*  902662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902730 */     GIR_RootConstrainSelectedInstOperands,
     /*  902731 */     // GIR_Coverage, 61930,
     /*  902731 */     GIR_EraseRootFromParent_Done,
     /*  902732 */   // Label 13777: @902732
     /*  902732 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(902807), // Rule ID 61931 //
     /*  902737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902805 */     GIR_RootConstrainSelectedInstOperands,
     /*  902806 */     // GIR_Coverage, 61931,
     /*  902806 */     GIR_EraseRootFromParent_Done,
     /*  902807 */   // Label 13778: @902807
     /*  902807 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(902882), // Rule ID 61934 //
     /*  902812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902880 */     GIR_RootConstrainSelectedInstOperands,
     /*  902881 */     // GIR_Coverage, 61934,
     /*  902881 */     GIR_EraseRootFromParent_Done,
     /*  902882 */   // Label 13779: @902882
     /*  902882 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(902957), // Rule ID 61935 //
     /*  902887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902933 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902955 */     GIR_RootConstrainSelectedInstOperands,
     /*  902956 */     // GIR_Coverage, 61935,
     /*  902956 */     GIR_EraseRootFromParent_Done,
     /*  902957 */   // Label 13780: @902957
     /*  902957 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(903032), // Rule ID 61938 //
     /*  902962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  903011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903030 */     GIR_RootConstrainSelectedInstOperands,
     /*  903031 */     // GIR_Coverage, 61938,
     /*  903031 */     GIR_EraseRootFromParent_Done,
     /*  903032 */   // Label 13781: @903032
     /*  903032 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(903107), // Rule ID 61939 //
     /*  903037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  903086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903105 */     GIR_RootConstrainSelectedInstOperands,
     /*  903106 */     // GIR_Coverage, 61939,
     /*  903106 */     GIR_EraseRootFromParent_Done,
     /*  903107 */   // Label 13782: @903107
     /*  903107 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(903182), // Rule ID 61942 //
     /*  903112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903180 */     GIR_RootConstrainSelectedInstOperands,
     /*  903181 */     // GIR_Coverage, 61942,
     /*  903181 */     GIR_EraseRootFromParent_Done,
     /*  903182 */   // Label 13783: @903182
     /*  903182 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(903257), // Rule ID 61943 //
     /*  903187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903233 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11583:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903255 */     GIR_RootConstrainSelectedInstOperands,
     /*  903256 */     // GIR_Coverage, 61943,
     /*  903256 */     GIR_EraseRootFromParent_Done,
     /*  903257 */   // Label 13784: @903257
     /*  903257 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(903332), // Rule ID 61946 //
     /*  903262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903330 */     GIR_RootConstrainSelectedInstOperands,
     /*  903331 */     // GIR_Coverage, 61946,
     /*  903331 */     GIR_EraseRootFromParent_Done,
     /*  903332 */   // Label 13785: @903332
     /*  903332 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(903407), // Rule ID 61947 //
     /*  903337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903383 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903405 */     GIR_RootConstrainSelectedInstOperands,
     /*  903406 */     // GIR_Coverage, 61947,
     /*  903406 */     GIR_EraseRootFromParent_Done,
     /*  903407 */   // Label 13786: @903407
     /*  903407 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(903482), // Rule ID 61950 //
     /*  903412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903480 */     GIR_RootConstrainSelectedInstOperands,
     /*  903481 */     // GIR_Coverage, 61950,
     /*  903481 */     GIR_EraseRootFromParent_Done,
     /*  903482 */   // Label 13787: @903482
     /*  903482 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(903557), // Rule ID 61951 //
     /*  903487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903555 */     GIR_RootConstrainSelectedInstOperands,
     /*  903556 */     // GIR_Coverage, 61951,
     /*  903556 */     GIR_EraseRootFromParent_Done,
     /*  903557 */   // Label 13788: @903557
     /*  903557 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(903632), // Rule ID 61954 //
     /*  903562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903630 */     GIR_RootConstrainSelectedInstOperands,
     /*  903631 */     // GIR_Coverage, 61954,
     /*  903631 */     GIR_EraseRootFromParent_Done,
     /*  903632 */   // Label 13789: @903632
     /*  903632 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(903707), // Rule ID 61955 //
     /*  903637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903705 */     GIR_RootConstrainSelectedInstOperands,
     /*  903706 */     // GIR_Coverage, 61955,
     /*  903706 */     GIR_EraseRootFromParent_Done,
     /*  903707 */   // Label 13790: @903707
     /*  903707 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(903782), // Rule ID 61958 //
     /*  903712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903780 */     GIR_RootConstrainSelectedInstOperands,
     /*  903781 */     // GIR_Coverage, 61958,
     /*  903781 */     GIR_EraseRootFromParent_Done,
     /*  903782 */   // Label 13791: @903782
     /*  903782 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(903857), // Rule ID 61959 //
     /*  903787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903855 */     GIR_RootConstrainSelectedInstOperands,
     /*  903856 */     // GIR_Coverage, 61959,
     /*  903856 */     GIR_EraseRootFromParent_Done,
     /*  903857 */   // Label 13792: @903857
     /*  903857 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(903932), // Rule ID 61962 //
     /*  903862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903930 */     GIR_RootConstrainSelectedInstOperands,
     /*  903931 */     // GIR_Coverage, 61962,
     /*  903931 */     GIR_EraseRootFromParent_Done,
     /*  903932 */   // Label 13793: @903932
     /*  903932 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(904007), // Rule ID 61963 //
     /*  903937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903983 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904005 */     GIR_RootConstrainSelectedInstOperands,
     /*  904006 */     // GIR_Coverage, 61963,
     /*  904006 */     GIR_EraseRootFromParent_Done,
     /*  904007 */   // Label 13794: @904007
     /*  904007 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(904082), // Rule ID 61966 //
     /*  904012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904058 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  904058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904080 */     GIR_RootConstrainSelectedInstOperands,
     /*  904081 */     // GIR_Coverage, 61966,
     /*  904081 */     GIR_EraseRootFromParent_Done,
     /*  904082 */   // Label 13795: @904082
     /*  904082 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(904157), // Rule ID 61967 //
     /*  904087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904133 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904155 */     GIR_RootConstrainSelectedInstOperands,
     /*  904156 */     // GIR_Coverage, 61967,
     /*  904156 */     GIR_EraseRootFromParent_Done,
     /*  904157 */   // Label 13796: @904157
     /*  904157 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(904232), // Rule ID 61970 //
     /*  904162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904230 */     GIR_RootConstrainSelectedInstOperands,
     /*  904231 */     // GIR_Coverage, 61970,
     /*  904231 */     GIR_EraseRootFromParent_Done,
     /*  904232 */   // Label 13797: @904232
     /*  904232 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(904307), // Rule ID 61971 //
     /*  904237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904305 */     GIR_RootConstrainSelectedInstOperands,
     /*  904306 */     // GIR_Coverage, 61971,
     /*  904306 */     GIR_EraseRootFromParent_Done,
     /*  904307 */   // Label 13798: @904307
     /*  904307 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(904382), // Rule ID 61974 //
     /*  904312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904380 */     GIR_RootConstrainSelectedInstOperands,
     /*  904381 */     // GIR_Coverage, 61974,
     /*  904381 */     GIR_EraseRootFromParent_Done,
     /*  904382 */   // Label 13799: @904382
     /*  904382 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(904457), // Rule ID 61975 //
     /*  904387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904433 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904455 */     GIR_RootConstrainSelectedInstOperands,
     /*  904456 */     // GIR_Coverage, 61975,
     /*  904456 */     GIR_EraseRootFromParent_Done,
     /*  904457 */   // Label 13800: @904457
     /*  904457 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(904532), // Rule ID 61978 //
     /*  904462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904508 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904530 */     GIR_RootConstrainSelectedInstOperands,
     /*  904531 */     // GIR_Coverage, 61978,
     /*  904531 */     GIR_EraseRootFromParent_Done,
     /*  904532 */   // Label 13801: @904532
     /*  904532 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(904607), // Rule ID 61979 //
     /*  904537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904583 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904605 */     GIR_RootConstrainSelectedInstOperands,
     /*  904606 */     // GIR_Coverage, 61979,
     /*  904606 */     GIR_EraseRootFromParent_Done,
     /*  904607 */   // Label 13802: @904607
     /*  904607 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(904682), // Rule ID 61982 //
     /*  904612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904680 */     GIR_RootConstrainSelectedInstOperands,
     /*  904681 */     // GIR_Coverage, 61982,
     /*  904681 */     GIR_EraseRootFromParent_Done,
     /*  904682 */   // Label 13803: @904682
     /*  904682 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(904757), // Rule ID 61983 //
     /*  904687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904755 */     GIR_RootConstrainSelectedInstOperands,
     /*  904756 */     // GIR_Coverage, 61983,
     /*  904756 */     GIR_EraseRootFromParent_Done,
     /*  904757 */   // Label 13804: @904757
     /*  904757 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(904832), // Rule ID 61986 //
     /*  904762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904808 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904830 */     GIR_RootConstrainSelectedInstOperands,
     /*  904831 */     // GIR_Coverage, 61986,
     /*  904831 */     GIR_EraseRootFromParent_Done,
     /*  904832 */   // Label 13805: @904832
     /*  904832 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(904907), // Rule ID 61987 //
     /*  904837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904883 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904905 */     GIR_RootConstrainSelectedInstOperands,
     /*  904906 */     // GIR_Coverage, 61987,
     /*  904906 */     GIR_EraseRootFromParent_Done,
     /*  904907 */   // Label 13806: @904907
     /*  904907 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(904982), // Rule ID 61990 //
     /*  904912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904980 */     GIR_RootConstrainSelectedInstOperands,
     /*  904981 */     // GIR_Coverage, 61990,
     /*  904981 */     GIR_EraseRootFromParent_Done,
     /*  904982 */   // Label 13807: @904982
     /*  904982 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(905057), // Rule ID 61991 //
     /*  904987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905055 */     GIR_RootConstrainSelectedInstOperands,
     /*  905056 */     // GIR_Coverage, 61991,
     /*  905056 */     GIR_EraseRootFromParent_Done,
     /*  905057 */   // Label 13808: @905057
     /*  905057 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(905132), // Rule ID 61994 //
     /*  905062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  905111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905130 */     GIR_RootConstrainSelectedInstOperands,
     /*  905131 */     // GIR_Coverage, 61994,
     /*  905131 */     GIR_EraseRootFromParent_Done,
     /*  905132 */   // Label 13809: @905132
     /*  905132 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(905207), // Rule ID 61995 //
     /*  905137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  905186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905205 */     GIR_RootConstrainSelectedInstOperands,
     /*  905206 */     // GIR_Coverage, 61995,
     /*  905206 */     GIR_EraseRootFromParent_Done,
     /*  905207 */   // Label 13810: @905207
     /*  905207 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(905282), // Rule ID 61998 //
     /*  905212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  905261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905280 */     GIR_RootConstrainSelectedInstOperands,
     /*  905281 */     // GIR_Coverage, 61998,
     /*  905281 */     GIR_EraseRootFromParent_Done,
     /*  905282 */   // Label 13811: @905282
     /*  905282 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(905357), // Rule ID 61999 //
     /*  905287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  905336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905355 */     GIR_RootConstrainSelectedInstOperands,
     /*  905356 */     // GIR_Coverage, 61999,
     /*  905356 */     GIR_EraseRootFromParent_Done,
     /*  905357 */   // Label 13812: @905357
     /*  905357 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(905432), // Rule ID 62002 //
     /*  905362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905430 */     GIR_RootConstrainSelectedInstOperands,
     /*  905431 */     // GIR_Coverage, 62002,
     /*  905431 */     GIR_EraseRootFromParent_Done,
     /*  905432 */   // Label 13813: @905432
     /*  905432 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(905507), // Rule ID 62003 //
     /*  905437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905483 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905505 */     GIR_RootConstrainSelectedInstOperands,
     /*  905506 */     // GIR_Coverage, 62003,
     /*  905506 */     GIR_EraseRootFromParent_Done,
     /*  905507 */   // Label 13814: @905507
     /*  905507 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(905582), // Rule ID 62446 //
     /*  905512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905580 */     GIR_RootConstrainSelectedInstOperands,
     /*  905581 */     // GIR_Coverage, 62446,
     /*  905581 */     GIR_EraseRootFromParent_Done,
     /*  905582 */   // Label 13815: @905582
     /*  905582 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(905657), // Rule ID 62447 //
     /*  905587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905655 */     GIR_RootConstrainSelectedInstOperands,
     /*  905656 */     // GIR_Coverage, 62447,
     /*  905656 */     GIR_EraseRootFromParent_Done,
     /*  905657 */   // Label 13816: @905657
     /*  905657 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(905732), // Rule ID 62448 //
     /*  905662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905730 */     GIR_RootConstrainSelectedInstOperands,
     /*  905731 */     // GIR_Coverage, 62448,
     /*  905731 */     GIR_EraseRootFromParent_Done,
     /*  905732 */   // Label 13817: @905732
     /*  905732 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(905807), // Rule ID 62449 //
     /*  905737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905805 */     GIR_RootConstrainSelectedInstOperands,
     /*  905806 */     // GIR_Coverage, 62449,
     /*  905806 */     GIR_EraseRootFromParent_Done,
     /*  905807 */   // Label 13818: @905807
     /*  905807 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(905882), // Rule ID 62450 //
     /*  905812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905880 */     GIR_RootConstrainSelectedInstOperands,
     /*  905881 */     // GIR_Coverage, 62450,
     /*  905881 */     GIR_EraseRootFromParent_Done,
     /*  905882 */   // Label 13819: @905882
     /*  905882 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(905957), // Rule ID 62451 //
     /*  905887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905955 */     GIR_RootConstrainSelectedInstOperands,
     /*  905956 */     // GIR_Coverage, 62451,
     /*  905956 */     GIR_EraseRootFromParent_Done,
     /*  905957 */   // Label 13820: @905957
     /*  905957 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(906032), // Rule ID 62452 //
     /*  905962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  906011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906030 */     GIR_RootConstrainSelectedInstOperands,
     /*  906031 */     // GIR_Coverage, 62452,
     /*  906031 */     GIR_EraseRootFromParent_Done,
     /*  906032 */   // Label 13821: @906032
     /*  906032 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(906107), // Rule ID 62453 //
     /*  906037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  906040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  906045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  906048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  906051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  906054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  906057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  906076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906083 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  906086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906105 */     GIR_RootConstrainSelectedInstOperands,
     /*  906106 */     // GIR_Coverage, 62453,
     /*  906106 */     GIR_EraseRootFromParent_Done,
     /*  906107 */   // Label 13822: @906107
     /*  906107 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(906171), // Rule ID 64522 //
     /*  906112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  906120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906148 */     // MIs[0] imm5
     /*  906148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906156 */     // (intrinsic_wo_chain:{ *:[i32] } 11047:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  906159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906167 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906169 */     GIR_RootConstrainSelectedInstOperands,
     /*  906170 */     // GIR_Coverage, 64522,
     /*  906170 */     GIR_EraseRootFromParent_Done,
     /*  906171 */   // Label 13823: @906171
     /*  906171 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(906235), // Rule ID 64523 //
     /*  906176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  906184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906212 */     // MIs[0] imm5
     /*  906212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906220 */     // (intrinsic_wo_chain:{ *:[i32] } 11043:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  906223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906231 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906233 */     GIR_RootConstrainSelectedInstOperands,
     /*  906234 */     // GIR_Coverage, 64523,
     /*  906234 */     GIR_EraseRootFromParent_Done,
     /*  906235 */   // Label 13824: @906235
     /*  906235 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(906299), // Rule ID 64524 //
     /*  906240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  906248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906276 */     // MIs[0] imm5
     /*  906276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906284 */     // (intrinsic_wo_chain:{ *:[i32] } 11045:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  906287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906295 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906297 */     GIR_RootConstrainSelectedInstOperands,
     /*  906298 */     // GIR_Coverage, 64524,
     /*  906298 */     GIR_EraseRootFromParent_Done,
     /*  906299 */   // Label 13825: @906299
     /*  906299 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(906363), // Rule ID 64525 //
     /*  906304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  906312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906340 */     // MIs[0] imm5
     /*  906340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906348 */     // (intrinsic_wo_chain:{ *:[i32] } 11041:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  906351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906359 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906361 */     GIR_RootConstrainSelectedInstOperands,
     /*  906362 */     // GIR_Coverage, 64525,
     /*  906362 */     GIR_EraseRootFromParent_Done,
     /*  906363 */   // Label 13826: @906363
     /*  906363 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(906427), // Rule ID 64526 //
     /*  906368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  906376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906404 */     // MIs[0] imm5
     /*  906404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906412 */     // (intrinsic_wo_chain:{ *:[i32] } 11048:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  906415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906423 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906425 */     GIR_RootConstrainSelectedInstOperands,
     /*  906426 */     // GIR_Coverage, 64526,
     /*  906426 */     GIR_EraseRootFromParent_Done,
     /*  906427 */   // Label 13827: @906427
     /*  906427 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(906491), // Rule ID 64527 //
     /*  906432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  906440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906468 */     // MIs[0] imm5
     /*  906468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906476 */     // (intrinsic_wo_chain:{ *:[i32] } 11044:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  906479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906487 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906489 */     GIR_RootConstrainSelectedInstOperands,
     /*  906490 */     // GIR_Coverage, 64527,
     /*  906490 */     GIR_EraseRootFromParent_Done,
     /*  906491 */   // Label 13828: @906491
     /*  906491 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(906555), // Rule ID 64528 //
     /*  906496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  906504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906532 */     // MIs[0] imm5
     /*  906532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906540 */     // (intrinsic_wo_chain:{ *:[i32] } 11046:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  906543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906551 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906553 */     GIR_RootConstrainSelectedInstOperands,
     /*  906554 */     // GIR_Coverage, 64528,
     /*  906554 */     GIR_EraseRootFromParent_Done,
     /*  906555 */   // Label 13829: @906555
     /*  906555 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(906619), // Rule ID 64529 //
     /*  906560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  906568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906596 */     // MIs[0] imm5
     /*  906596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906604 */     // (intrinsic_wo_chain:{ *:[i32] } 11042:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  906607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906615 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906617 */     GIR_RootConstrainSelectedInstOperands,
     /*  906618 */     // GIR_Coverage, 64529,
     /*  906618 */     GIR_EraseRootFromParent_Done,
     /*  906619 */   // Label 13830: @906619
     /*  906619 */   GIM_Reject,
     /*  906620 */ // Label 6984: @906620
     /*  906620 */ GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(1402171),
     /*  906625 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  906628 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(906711), // Rule ID 62861 //
     /*  906633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906657 */     // MIs[0] op1
     /*  906657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906673 */     // MIs[0] op4
     /*  906673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906688 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906699 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906709 */     GIR_RootConstrainSelectedInstOperands,
     /*  906710 */     // GIR_Coverage, 62861,
     /*  906710 */     GIR_EraseRootFromParent_Done,
     /*  906711 */   // Label 13832: @906711
     /*  906711 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(906794), // Rule ID 62862 //
     /*  906716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906740 */     // MIs[0] op1
     /*  906740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906756 */     // MIs[0] op4
     /*  906756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF8),
     /*  906774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906782 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906792 */     GIR_RootConstrainSelectedInstOperands,
     /*  906793 */     // GIR_Coverage, 62862,
     /*  906793 */     GIR_EraseRootFromParent_Done,
     /*  906794 */   // Label 13833: @906794
     /*  906794 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(906877), // Rule ID 62905 //
     /*  906799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906823 */     // MIs[0] op1
     /*  906823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906839 */     // MIs[0] op4
     /*  906839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906859 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906861 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906863 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906865 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906875 */     GIR_RootConstrainSelectedInstOperands,
     /*  906876 */     // GIR_Coverage, 62905,
     /*  906876 */     GIR_EraseRootFromParent_Done,
     /*  906877 */   // Label 13834: @906877
     /*  906877 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(906960), // Rule ID 62906 //
     /*  906882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906906 */     // MIs[0] op1
     /*  906906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906922 */     // MIs[0] op4
     /*  906922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906937 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  906940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906942 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906944 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906946 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906948 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906958 */     GIR_RootConstrainSelectedInstOperands,
     /*  906959 */     // GIR_Coverage, 62906,
     /*  906959 */     GIR_EraseRootFromParent_Done,
     /*  906960 */   // Label 13835: @906960
     /*  906960 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(907043), // Rule ID 62949 //
     /*  906965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906989 */     // MIs[0] op1
     /*  906989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907005 */     // MIs[0] op4
     /*  907005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907025 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907027 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907029 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907031 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907041 */     GIR_RootConstrainSelectedInstOperands,
     /*  907042 */     // GIR_Coverage, 62949,
     /*  907042 */     GIR_EraseRootFromParent_Done,
     /*  907043 */   // Label 13836: @907043
     /*  907043 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(907126), // Rule ID 62950 //
     /*  907048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  907059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  907062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  907065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907072 */     // MIs[0] op1
     /*  907072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907088 */     // MIs[0] op4
     /*  907088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907103 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907114 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907124 */     GIR_RootConstrainSelectedInstOperands,
     /*  907125 */     // GIR_Coverage, 62950,
     /*  907125 */     GIR_EraseRootFromParent_Done,
     /*  907126 */   // Label 13837: @907126
     /*  907126 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(907209), // Rule ID 62993 //
     /*  907131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  907142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  907148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907155 */     // MIs[0] op1
     /*  907155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907171 */     // MIs[0] op4
     /*  907171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  907189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907191 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907193 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907195 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907197 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907207 */     GIR_RootConstrainSelectedInstOperands,
     /*  907208 */     // GIR_Coverage, 62993,
     /*  907208 */     GIR_EraseRootFromParent_Done,
     /*  907209 */   // Label 13838: @907209
     /*  907209 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(907292), // Rule ID 62994 //
     /*  907214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  907225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  907228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  907231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907238 */     // MIs[0] op1
     /*  907238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907254 */     // MIs[0] op4
     /*  907254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF4),
     /*  907272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907280 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907290 */     GIR_RootConstrainSelectedInstOperands,
     /*  907291 */     // GIR_Coverage, 62994,
     /*  907291 */     GIR_EraseRootFromParent_Done,
     /*  907292 */   // Label 13839: @907292
     /*  907292 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(907375), // Rule ID 63049 //
     /*  907297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  907308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  907314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907321 */     // MIs[0] op1
     /*  907321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907337 */     // MIs[0] op4
     /*  907337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907357 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907359 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907361 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907363 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907373 */     GIR_RootConstrainSelectedInstOperands,
     /*  907374 */     // GIR_Coverage, 63049,
     /*  907374 */     GIR_EraseRootFromParent_Done,
     /*  907375 */   // Label 13840: @907375
     /*  907375 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(907458), // Rule ID 63050 //
     /*  907380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  907391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  907394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  907397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907404 */     // MIs[0] op1
     /*  907404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907420 */     // MIs[0] op4
     /*  907420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907435 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907456 */     GIR_RootConstrainSelectedInstOperands,
     /*  907457 */     // GIR_Coverage, 63050,
     /*  907457 */     GIR_EraseRootFromParent_Done,
     /*  907458 */   // Label 13841: @907458
     /*  907458 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(907541), // Rule ID 63105 //
     /*  907463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907487 */     // MIs[0] op1
     /*  907487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907503 */     // MIs[0] op4
     /*  907503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907523 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907525 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907527 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907529 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907539 */     GIR_RootConstrainSelectedInstOperands,
     /*  907540 */     // GIR_Coverage, 63105,
     /*  907540 */     GIR_EraseRootFromParent_Done,
     /*  907541 */   // Label 13842: @907541
     /*  907541 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(907624), // Rule ID 63106 //
     /*  907546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907570 */     // MIs[0] op1
     /*  907570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907586 */     // MIs[0] op4
     /*  907586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_MF2),
     /*  907604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907612 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907622 */     GIR_RootConstrainSelectedInstOperands,
     /*  907623 */     // GIR_Coverage, 63106,
     /*  907623 */     GIR_EraseRootFromParent_Done,
     /*  907624 */   // Label 13843: @907624
     /*  907624 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(907707), // Rule ID 63161 //
     /*  907629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907653 */     // MIs[0] op1
     /*  907653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907669 */     // MIs[0] op4
     /*  907669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907689 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907691 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907693 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907695 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907705 */     GIR_RootConstrainSelectedInstOperands,
     /*  907706 */     // GIR_Coverage, 63161,
     /*  907706 */     GIR_EraseRootFromParent_Done,
     /*  907707 */   // Label 13844: @907707
     /*  907707 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(907790), // Rule ID 63162 //
     /*  907712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907736 */     // MIs[0] op1
     /*  907736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907752 */     // MIs[0] op4
     /*  907752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907767 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907788 */     GIR_RootConstrainSelectedInstOperands,
     /*  907789 */     // GIR_Coverage, 63162,
     /*  907789 */     GIR_EraseRootFromParent_Done,
     /*  907790 */   // Label 13845: @907790
     /*  907790 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(907873), // Rule ID 63205 //
     /*  907795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907819 */     // MIs[0] op1
     /*  907819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907835 */     // MIs[0] op4
     /*  907835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907855 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907857 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907859 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907861 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907871 */     GIR_RootConstrainSelectedInstOperands,
     /*  907872 */     // GIR_Coverage, 63205,
     /*  907872 */     GIR_EraseRootFromParent_Done,
     /*  907873 */   // Label 13846: @907873
     /*  907873 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(907956), // Rule ID 63206 //
     /*  907878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907902 */     // MIs[0] op1
     /*  907902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907918 */     // MIs[0] op4
     /*  907918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  907936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907944 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907954 */     GIR_RootConstrainSelectedInstOperands,
     /*  907955 */     // GIR_Coverage, 63206,
     /*  907955 */     GIR_EraseRootFromParent_Done,
     /*  907956 */   // Label 13847: @907956
     /*  907956 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(908039), // Rule ID 63261 //
     /*  907961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907985 */     // MIs[0] op1
     /*  907985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908001 */     // MIs[0] op4
     /*  908001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908021 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908023 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908025 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908027 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908037 */     GIR_RootConstrainSelectedInstOperands,
     /*  908038 */     // GIR_Coverage, 63261,
     /*  908038 */     GIR_EraseRootFromParent_Done,
     /*  908039 */   // Label 13848: @908039
     /*  908039 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(908122), // Rule ID 63262 //
     /*  908044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908068 */     // MIs[0] op1
     /*  908068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908084 */     // MIs[0] op4
     /*  908084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908110 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908120 */     GIR_RootConstrainSelectedInstOperands,
     /*  908121 */     // GIR_Coverage, 63262,
     /*  908121 */     GIR_EraseRootFromParent_Done,
     /*  908122 */   // Label 13849: @908122
     /*  908122 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(908205), // Rule ID 63317 //
     /*  908127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  908138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  908141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  908144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908151 */     // MIs[0] op1
     /*  908151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908167 */     // MIs[0] op4
     /*  908167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  908182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908187 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908189 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908191 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908193 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908203 */     GIR_RootConstrainSelectedInstOperands,
     /*  908204 */     // GIR_Coverage, 63317,
     /*  908204 */     GIR_EraseRootFromParent_Done,
     /*  908205 */   // Label 13850: @908205
     /*  908205 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(908288), // Rule ID 63318 //
     /*  908210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  908221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  908224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  908227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908234 */     // MIs[0] op1
     /*  908234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908250 */     // MIs[0] op4
     /*  908250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  908265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M1),
     /*  908268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908270 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908272 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908274 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908276 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908286 */     GIR_RootConstrainSelectedInstOperands,
     /*  908287 */     // GIR_Coverage, 63318,
     /*  908287 */     GIR_EraseRootFromParent_Done,
     /*  908288 */   // Label 13851: @908288
     /*  908288 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(908371), // Rule ID 63373 //
     /*  908293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  908304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  908307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  908310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908317 */     // MIs[0] op1
     /*  908317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908333 */     // MIs[0] op4
     /*  908333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908353 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908355 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908357 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908359 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908369 */     GIR_RootConstrainSelectedInstOperands,
     /*  908370 */     // GIR_Coverage, 63373,
     /*  908370 */     GIR_EraseRootFromParent_Done,
     /*  908371 */   // Label 13852: @908371
     /*  908371 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(908454), // Rule ID 63374 //
     /*  908376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  908387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  908390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  908393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908400 */     // MIs[0] op1
     /*  908400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908416 */     // MIs[0] op4
     /*  908416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908442 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908452 */     GIR_RootConstrainSelectedInstOperands,
     /*  908453 */     // GIR_Coverage, 63374,
     /*  908453 */     GIR_EraseRootFromParent_Done,
     /*  908454 */   // Label 13853: @908454
     /*  908454 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(908537), // Rule ID 63417 //
     /*  908459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908483 */     // MIs[0] op1
     /*  908483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908499 */     // MIs[0] op4
     /*  908499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908519 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908521 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908523 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908525 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908535 */     GIR_RootConstrainSelectedInstOperands,
     /*  908536 */     // GIR_Coverage, 63417,
     /*  908536 */     GIR_EraseRootFromParent_Done,
     /*  908537 */   // Label 13854: @908537
     /*  908537 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(908620), // Rule ID 63418 //
     /*  908542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908566 */     // MIs[0] op1
     /*  908566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908582 */     // MIs[0] op4
     /*  908582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908597 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  908600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908608 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908618 */     GIR_RootConstrainSelectedInstOperands,
     /*  908619 */     // GIR_Coverage, 63418,
     /*  908619 */     GIR_EraseRootFromParent_Done,
     /*  908620 */   // Label 13855: @908620
     /*  908620 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(908703), // Rule ID 63461 //
     /*  908625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908649 */     // MIs[0] op1
     /*  908649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908665 */     // MIs[0] op4
     /*  908665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908680 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908685 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908687 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908689 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908691 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908701 */     GIR_RootConstrainSelectedInstOperands,
     /*  908702 */     // GIR_Coverage, 63461,
     /*  908702 */     GIR_EraseRootFromParent_Done,
     /*  908703 */   // Label 13856: @908703
     /*  908703 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(908786), // Rule ID 63462 //
     /*  908708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908732 */     // MIs[0] op1
     /*  908732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908748 */     // MIs[0] op4
     /*  908748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908763 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  908766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908784 */     GIR_RootConstrainSelectedInstOperands,
     /*  908785 */     // GIR_Coverage, 63462,
     /*  908785 */     GIR_EraseRootFromParent_Done,
     /*  908786 */   // Label 13857: @908786
     /*  908786 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(908869), // Rule ID 63505 //
     /*  908791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908815 */     // MIs[0] op1
     /*  908815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908831 */     // MIs[0] op4
     /*  908831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908857 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908867 */     GIR_RootConstrainSelectedInstOperands,
     /*  908868 */     // GIR_Coverage, 63505,
     /*  908868 */     GIR_EraseRootFromParent_Done,
     /*  908869 */   // Label 13858: @908869
     /*  908869 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(908952), // Rule ID 63506 //
     /*  908874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908898 */     // MIs[0] op1
     /*  908898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908914 */     // MIs[0] op4
     /*  908914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  908932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908934 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908936 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908938 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908940 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908950 */     GIR_RootConstrainSelectedInstOperands,
     /*  908951 */     // GIR_Coverage, 63506,
     /*  908951 */     GIR_EraseRootFromParent_Done,
     /*  908952 */   // Label 13859: @908952
     /*  908952 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(909035), // Rule ID 63561 //
     /*  908957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908981 */     // MIs[0] op1
     /*  908981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908997 */     // MIs[0] op4
     /*  908997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  909012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909017 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909019 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909021 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909023 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909033 */     GIR_RootConstrainSelectedInstOperands,
     /*  909034 */     // GIR_Coverage, 63561,
     /*  909034 */     GIR_EraseRootFromParent_Done,
     /*  909035 */   // Label 13860: @909035
     /*  909035 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(909118), // Rule ID 63562 //
     /*  909040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  909051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  909054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  909057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909064 */     // MIs[0] op1
     /*  909064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909080 */     // MIs[0] op4
     /*  909080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909095 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  909095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909116 */     GIR_RootConstrainSelectedInstOperands,
     /*  909117 */     // GIR_Coverage, 63562,
     /*  909117 */     GIR_EraseRootFromParent_Done,
     /*  909118 */   // Label 13861: @909118
     /*  909118 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(909201), // Rule ID 63617 //
     /*  909123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  909134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  909137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  909140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909147 */     // MIs[0] op1
     /*  909147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909163 */     // MIs[0] op4
     /*  909163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  909178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909183 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909185 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909187 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909189 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909199 */     GIR_RootConstrainSelectedInstOperands,
     /*  909200 */     // GIR_Coverage, 63617,
     /*  909200 */     GIR_EraseRootFromParent_Done,
     /*  909201 */   // Label 13862: @909201
     /*  909201 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(909284), // Rule ID 63618 //
     /*  909206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  909217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  909220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  909223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909230 */     // MIs[0] op1
     /*  909230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909246 */     // MIs[0] op4
     /*  909246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  909261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909272 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  909282 */     GIR_RootConstrainSelectedInstOperands,
     /*  909283 */     // GIR_Coverage, 63618,
     /*  909283 */     GIR_EraseRootFromParent_Done,
     /*  909284 */   // Label 13863: @909284
     /*  909284 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(909367), // Rule ID 63673 //
     /*  909289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909313 */     // MIs[0] op1
     /*  909313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909329 */     // MIs[0] op4
     /*  909329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909349 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909351 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909353 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909355 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909365 */     GIR_RootConstrainSelectedInstOperands,
     /*  909366 */     // GIR_Coverage, 63673,
     /*  909366 */     GIR_EraseRootFromParent_Done,
     /*  909367 */   // Label 13864: @909367
     /*  909367 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(909450), // Rule ID 63674 //
     /*  909372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909396 */     // MIs[0] op1
     /*  909396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909412 */     // MIs[0] op4
     /*  909412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909438 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909448 */     GIR_RootConstrainSelectedInstOperands,
     /*  909449 */     // GIR_Coverage, 63674,
     /*  909449 */     GIR_EraseRootFromParent_Done,
     /*  909450 */   // Label 13865: @909450
     /*  909450 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(909533), // Rule ID 63729 //
     /*  909455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909479 */     // MIs[0] op1
     /*  909479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909495 */     // MIs[0] op4
     /*  909495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909521 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909531 */     GIR_RootConstrainSelectedInstOperands,
     /*  909532 */     // GIR_Coverage, 63729,
     /*  909532 */     GIR_EraseRootFromParent_Done,
     /*  909533 */   // Label 13866: @909533
     /*  909533 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(909616), // Rule ID 63730 //
     /*  909538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909562 */     // MIs[0] op1
     /*  909562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909578 */     // MIs[0] op4
     /*  909578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909593 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  909596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909598 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909600 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909602 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909604 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909614 */     GIR_RootConstrainSelectedInstOperands,
     /*  909615 */     // GIR_Coverage, 63730,
     /*  909615 */     GIR_EraseRootFromParent_Done,
     /*  909616 */   // Label 13867: @909616
     /*  909616 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(909699), // Rule ID 63785 //
     /*  909621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909645 */     // MIs[0] op1
     /*  909645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909661 */     // MIs[0] op4
     /*  909661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909681 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909683 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909685 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909687 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909697 */     GIR_RootConstrainSelectedInstOperands,
     /*  909698 */     // GIR_Coverage, 63785,
     /*  909698 */     GIR_EraseRootFromParent_Done,
     /*  909699 */   // Label 13868: @909699
     /*  909699 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(909782), // Rule ID 63786 //
     /*  909704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909728 */     // MIs[0] op1
     /*  909728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909744 */     // MIs[0] op4
     /*  909744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909759 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  909762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909764 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909766 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909768 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909770 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909780 */     GIR_RootConstrainSelectedInstOperands,
     /*  909781 */     // GIR_Coverage, 63786,
     /*  909781 */     GIR_EraseRootFromParent_Done,
     /*  909782 */   // Label 13869: @909782
     /*  909782 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(909865), // Rule ID 63841 //
     /*  909787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909811 */     // MIs[0] op1
     /*  909811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909827 */     // MIs[0] op4
     /*  909827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909847 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909849 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909851 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909853 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909863 */     GIR_RootConstrainSelectedInstOperands,
     /*  909864 */     // GIR_Coverage, 63841,
     /*  909864 */     GIR_EraseRootFromParent_Done,
     /*  909865 */   // Label 13870: @909865
     /*  909865 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(909948), // Rule ID 63842 //
     /*  909870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909894 */     // MIs[0] op1
     /*  909894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909910 */     // MIs[0] op4
     /*  909910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M2),
     /*  909928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909936 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909946 */     GIR_RootConstrainSelectedInstOperands,
     /*  909947 */     // GIR_Coverage, 63842,
     /*  909947 */     GIR_EraseRootFromParent_Done,
     /*  909948 */   // Label 13871: @909948
     /*  909948 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(910031), // Rule ID 63897 //
     /*  909953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909977 */     // MIs[0] op1
     /*  909977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909993 */     // MIs[0] op4
     /*  909993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  910008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  910011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910019 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910029 */     GIR_RootConstrainSelectedInstOperands,
     /*  910030 */     // GIR_Coverage, 63897,
     /*  910030 */     GIR_EraseRootFromParent_Done,
     /*  910031 */   // Label 13872: @910031
     /*  910031 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(910114), // Rule ID 63898 //
     /*  910036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  910047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  910050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  910053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910060 */     // MIs[0] op1
     /*  910060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910076 */     // MIs[0] op4
     /*  910076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910091 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  910091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M4),
     /*  910094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910112 */     GIR_RootConstrainSelectedInstOperands,
     /*  910113 */     // GIR_Coverage, 63898,
     /*  910113 */     GIR_EraseRootFromParent_Done,
     /*  910114 */   // Label 13873: @910114
     /*  910114 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(910197), // Rule ID 63953 //
     /*  910119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  910133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  910136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910143 */     // MIs[0] op1
     /*  910143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910159 */     // MIs[0] op4
     /*  910159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  910174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  910177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910185 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910195 */     GIR_RootConstrainSelectedInstOperands,
     /*  910196 */     // GIR_Coverage, 63953,
     /*  910196 */     GIR_EraseRootFromParent_Done,
     /*  910197 */   // Label 13874: @910197
     /*  910197 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(910280), // Rule ID 63954 //
     /*  910202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  910213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  910216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  910219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910226 */     // MIs[0] op1
     /*  910226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910242 */     // MIs[0] op4
     /*  910242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910257 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  910257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVV_M8),
     /*  910260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910262 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910264 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910266 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910268 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  910278 */     GIR_RootConstrainSelectedInstOperands,
     /*  910279 */     // GIR_Coverage, 63954,
     /*  910279 */     GIR_EraseRootFromParent_Done,
     /*  910280 */   // Label 13875: @910280
     /*  910280 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(910363), // Rule ID 63983 //
     /*  910285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910309 */     // MIs[0] op1
     /*  910309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910325 */     // MIs[0] op4
     /*  910325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  910343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910351 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910361 */     GIR_RootConstrainSelectedInstOperands,
     /*  910362 */     // GIR_Coverage, 63983,
     /*  910362 */     GIR_EraseRootFromParent_Done,
     /*  910363 */   // Label 13876: @910363
     /*  910363 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(910446), // Rule ID 63984 //
     /*  910368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910392 */     // MIs[0] op1
     /*  910392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910408 */     // MIs[0] op4
     /*  910408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910423 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF8),
     /*  910426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910444 */     GIR_RootConstrainSelectedInstOperands,
     /*  910445 */     // GIR_Coverage, 63984,
     /*  910445 */     GIR_EraseRootFromParent_Done,
     /*  910446 */   // Label 13877: @910446
     /*  910446 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(910529), // Rule ID 64001 //
     /*  910451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910475 */     // MIs[0] op1
     /*  910475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910491 */     // MIs[0] op4
     /*  910491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910517 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910527 */     GIR_RootConstrainSelectedInstOperands,
     /*  910528 */     // GIR_Coverage, 64001,
     /*  910528 */     GIR_EraseRootFromParent_Done,
     /*  910529 */   // Label 13878: @910529
     /*  910529 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(910612), // Rule ID 64002 //
     /*  910534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910558 */     // MIs[0] op1
     /*  910558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910574 */     // MIs[0] op4
     /*  910574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910589 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  910592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910600 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910610 */     GIR_RootConstrainSelectedInstOperands,
     /*  910611 */     // GIR_Coverage, 64002,
     /*  910611 */     GIR_EraseRootFromParent_Done,
     /*  910612 */   // Label 13879: @910612
     /*  910612 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(910695), // Rule ID 64019 //
     /*  910617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910641 */     // MIs[0] op1
     /*  910641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910657 */     // MIs[0] op4
     /*  910657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910683 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910693 */     GIR_RootConstrainSelectedInstOperands,
     /*  910694 */     // GIR_Coverage, 64019,
     /*  910694 */     GIR_EraseRootFromParent_Done,
     /*  910695 */   // Label 13880: @910695
     /*  910695 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(910778), // Rule ID 64020 //
     /*  910700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910724 */     // MIs[0] op1
     /*  910724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910740 */     // MIs[0] op4
     /*  910740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  910758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910766 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910776 */     GIR_RootConstrainSelectedInstOperands,
     /*  910777 */     // GIR_Coverage, 64020,
     /*  910777 */     GIR_EraseRootFromParent_Done,
     /*  910778 */   // Label 13881: @910778
     /*  910778 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(910861), // Rule ID 64037 //
     /*  910783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910807 */     // MIs[0] op1
     /*  910807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910823 */     // MIs[0] op4
     /*  910823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910849 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910859 */     GIR_RootConstrainSelectedInstOperands,
     /*  910860 */     // GIR_Coverage, 64037,
     /*  910860 */     GIR_EraseRootFromParent_Done,
     /*  910861 */   // Label 13882: @910861
     /*  910861 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(910944), // Rule ID 64038 //
     /*  910866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910890 */     // MIs[0] op1
     /*  910890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910906 */     // MIs[0] op4
     /*  910906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  910924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910926 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910928 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910930 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910932 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910942 */     GIR_RootConstrainSelectedInstOperands,
     /*  910943 */     // GIR_Coverage, 64038,
     /*  910943 */     GIR_EraseRootFromParent_Done,
     /*  910944 */   // Label 13883: @910944
     /*  910944 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(911027), // Rule ID 64055 //
     /*  910949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910973 */     // MIs[0] op1
     /*  910973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910989 */     // MIs[0] op4
     /*  910989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911015 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911025 */     GIR_RootConstrainSelectedInstOperands,
     /*  911026 */     // GIR_Coverage, 64055,
     /*  911026 */     GIR_EraseRootFromParent_Done,
     /*  911027 */   // Label 13884: @911027
     /*  911027 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(911110), // Rule ID 64056 //
     /*  911032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  911043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  911046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911056 */     // MIs[0] op1
     /*  911056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911072 */     // MIs[0] op4
     /*  911072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911092 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911094 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911096 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911098 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911108 */     GIR_RootConstrainSelectedInstOperands,
     /*  911109 */     // GIR_Coverage, 64056,
     /*  911109 */     GIR_EraseRootFromParent_Done,
     /*  911110 */   // Label 13885: @911110
     /*  911110 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(911193), // Rule ID 64073 //
     /*  911115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  911126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  911129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911139 */     // MIs[0] op1
     /*  911139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911155 */     // MIs[0] op4
     /*  911155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911175 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911177 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911179 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911181 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911191 */     GIR_RootConstrainSelectedInstOperands,
     /*  911192 */     // GIR_Coverage, 64073,
     /*  911192 */     GIR_EraseRootFromParent_Done,
     /*  911193 */   // Label 13886: @911193
     /*  911193 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(911276), // Rule ID 64074 //
     /*  911198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  911209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  911212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911222 */     // MIs[0] op1
     /*  911222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911238 */     // MIs[0] op4
     /*  911238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911253 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  911256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911258 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911260 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911262 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911264 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911274 */     GIR_RootConstrainSelectedInstOperands,
     /*  911275 */     // GIR_Coverage, 64074,
     /*  911275 */     GIR_EraseRootFromParent_Done,
     /*  911276 */   // Label 13887: @911276
     /*  911276 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(911359), // Rule ID 64091 //
     /*  911281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  911298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911305 */     // MIs[0] op1
     /*  911305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911321 */     // MIs[0] op4
     /*  911321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  911339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911341 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911343 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911345 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911347 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911357 */     GIR_RootConstrainSelectedInstOperands,
     /*  911358 */     // GIR_Coverage, 64091,
     /*  911358 */     GIR_EraseRootFromParent_Done,
     /*  911359 */   // Label 13888: @911359
     /*  911359 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(911442), // Rule ID 64092 //
     /*  911364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  911381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911388 */     // MIs[0] op1
     /*  911388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911404 */     // MIs[0] op4
     /*  911404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF4),
     /*  911422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911430 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911440 */     GIR_RootConstrainSelectedInstOperands,
     /*  911441 */     // GIR_Coverage, 64092,
     /*  911441 */     GIR_EraseRootFromParent_Done,
     /*  911442 */   // Label 13889: @911442
     /*  911442 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(911525), // Rule ID 64115 //
     /*  911447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911471 */     // MIs[0] op1
     /*  911471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911487 */     // MIs[0] op4
     /*  911487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911507 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911509 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911511 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911513 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911523 */     GIR_RootConstrainSelectedInstOperands,
     /*  911524 */     // GIR_Coverage, 64115,
     /*  911524 */     GIR_EraseRootFromParent_Done,
     /*  911525 */   // Label 13890: @911525
     /*  911525 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(911608), // Rule ID 64116 //
     /*  911530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911554 */     // MIs[0] op1
     /*  911554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911570 */     // MIs[0] op4
     /*  911570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911585 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  911588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911590 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911592 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911594 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911596 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911606 */     GIR_RootConstrainSelectedInstOperands,
     /*  911607 */     // GIR_Coverage, 64116,
     /*  911607 */     GIR_EraseRootFromParent_Done,
     /*  911608 */   // Label 13891: @911608
     /*  911608 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(911691), // Rule ID 64139 //
     /*  911613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911637 */     // MIs[0] op1
     /*  911637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911653 */     // MIs[0] op4
     /*  911653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911673 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911675 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911677 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911679 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911689 */     GIR_RootConstrainSelectedInstOperands,
     /*  911690 */     // GIR_Coverage, 64139,
     /*  911690 */     GIR_EraseRootFromParent_Done,
     /*  911691 */   // Label 13892: @911691
     /*  911691 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(911774), // Rule ID 64140 //
     /*  911696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911720 */     // MIs[0] op1
     /*  911720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911736 */     // MIs[0] op4
     /*  911736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  911754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911762 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911772 */     GIR_RootConstrainSelectedInstOperands,
     /*  911773 */     // GIR_Coverage, 64140,
     /*  911773 */     GIR_EraseRootFromParent_Done,
     /*  911774 */   // Label 13893: @911774
     /*  911774 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(911857), // Rule ID 64163 //
     /*  911779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911803 */     // MIs[0] op1
     /*  911803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911819 */     // MIs[0] op4
     /*  911819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911839 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911841 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911843 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911845 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911855 */     GIR_RootConstrainSelectedInstOperands,
     /*  911856 */     // GIR_Coverage, 64163,
     /*  911856 */     GIR_EraseRootFromParent_Done,
     /*  911857 */   // Label 13894: @911857
     /*  911857 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(911940), // Rule ID 64164 //
     /*  911862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911886 */     // MIs[0] op1
     /*  911886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911902 */     // MIs[0] op4
     /*  911902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911917 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  911920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911922 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911924 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911926 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911928 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911938 */     GIR_RootConstrainSelectedInstOperands,
     /*  911939 */     // GIR_Coverage, 64164,
     /*  911939 */     GIR_EraseRootFromParent_Done,
     /*  911940 */   // Label 13895: @911940
     /*  911940 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(912023), // Rule ID 64187 //
     /*  911945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911969 */     // MIs[0] op1
     /*  911969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911985 */     // MIs[0] op4
     /*  911985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912005 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912007 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912009 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912011 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912021 */     GIR_RootConstrainSelectedInstOperands,
     /*  912022 */     // GIR_Coverage, 64187,
     /*  912022 */     GIR_EraseRootFromParent_Done,
     /*  912023 */   // Label 13896: @912023
     /*  912023 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(912106), // Rule ID 64188 //
     /*  912028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912052 */     // MIs[0] op1
     /*  912052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912068 */     // MIs[0] op4
     /*  912068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912083 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912094 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912104 */     GIR_RootConstrainSelectedInstOperands,
     /*  912105 */     // GIR_Coverage, 64188,
     /*  912105 */     GIR_EraseRootFromParent_Done,
     /*  912106 */   // Label 13897: @912106
     /*  912106 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(912189), // Rule ID 64211 //
     /*  912111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  912122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  912125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  912128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912135 */     // MIs[0] op1
     /*  912135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912151 */     // MIs[0] op4
     /*  912151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  912169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912171 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912173 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912175 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912177 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912187 */     GIR_RootConstrainSelectedInstOperands,
     /*  912188 */     // GIR_Coverage, 64211,
     /*  912188 */     GIR_EraseRootFromParent_Done,
     /*  912189 */   // Label 13898: @912189
     /*  912189 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(912272), // Rule ID 64212 //
     /*  912194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  912205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  912208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  912211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912218 */     // MIs[0] op1
     /*  912218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912234 */     // MIs[0] op4
     /*  912234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_MF2),
     /*  912252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912254 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912256 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912258 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912260 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912270 */     GIR_RootConstrainSelectedInstOperands,
     /*  912271 */     // GIR_Coverage, 64212,
     /*  912271 */     GIR_EraseRootFromParent_Done,
     /*  912272 */   // Label 13899: @912272
     /*  912272 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(912355), // Rule ID 64235 //
     /*  912277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  912288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  912291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  912294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912301 */     // MIs[0] op1
     /*  912301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912317 */     // MIs[0] op4
     /*  912317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  912335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912337 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912339 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912341 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912343 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912353 */     GIR_RootConstrainSelectedInstOperands,
     /*  912354 */     // GIR_Coverage, 64235,
     /*  912354 */     GIR_EraseRootFromParent_Done,
     /*  912355 */   // Label 13900: @912355
     /*  912355 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(912438), // Rule ID 64236 //
     /*  912360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  912371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  912374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  912377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912384 */     // MIs[0] op1
     /*  912384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912400 */     // MIs[0] op4
     /*  912400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M1),
     /*  912418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912426 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912436 */     GIR_RootConstrainSelectedInstOperands,
     /*  912437 */     // GIR_Coverage, 64236,
     /*  912437 */     GIR_EraseRootFromParent_Done,
     /*  912438 */   // Label 13901: @912438
     /*  912438 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(912521), // Rule ID 64259 //
     /*  912443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912467 */     // MIs[0] op1
     /*  912467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912483 */     // MIs[0] op4
     /*  912483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912503 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912505 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912507 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912509 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912519 */     GIR_RootConstrainSelectedInstOperands,
     /*  912520 */     // GIR_Coverage, 64259,
     /*  912520 */     GIR_EraseRootFromParent_Done,
     /*  912521 */   // Label 13902: @912521
     /*  912521 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(912604), // Rule ID 64260 //
     /*  912526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912550 */     // MIs[0] op1
     /*  912550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912566 */     // MIs[0] op4
     /*  912566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M2),
     /*  912584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912592 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912602 */     GIR_RootConstrainSelectedInstOperands,
     /*  912603 */     // GIR_Coverage, 64260,
     /*  912603 */     GIR_EraseRootFromParent_Done,
     /*  912604 */   // Label 13903: @912604
     /*  912604 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(912687), // Rule ID 64283 //
     /*  912609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912633 */     // MIs[0] op1
     /*  912633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912649 */     // MIs[0] op4
     /*  912649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912669 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912671 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912673 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912675 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912685 */     GIR_RootConstrainSelectedInstOperands,
     /*  912686 */     // GIR_Coverage, 64283,
     /*  912686 */     GIR_EraseRootFromParent_Done,
     /*  912687 */   // Label 13904: @912687
     /*  912687 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(912770), // Rule ID 64284 //
     /*  912692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912716 */     // MIs[0] op1
     /*  912716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912732 */     // MIs[0] op4
     /*  912732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912747 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_IVW_M4),
     /*  912750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912758 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912768 */     GIR_RootConstrainSelectedInstOperands,
     /*  912769 */     // GIR_Coverage, 64284,
     /*  912769 */     GIR_EraseRootFromParent_Done,
     /*  912770 */   // Label 13905: @912770
     /*  912770 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(912848), // Rule ID 60612 //
     /*  912775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912807 */     // MIs[0] rs2
     /*  912807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912815 */     // MIs[0] policy
     /*  912815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912825 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912846 */     GIR_RootConstrainSelectedInstOperands,
     /*  912847 */     // GIR_Coverage, 60612,
     /*  912847 */     GIR_EraseRootFromParent_Done,
     /*  912848 */   // Label 13906: @912848
     /*  912848 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(912926), // Rule ID 60613 //
     /*  912853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912885 */     // MIs[0] rs2
     /*  912885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912893 */     // MIs[0] policy
     /*  912893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912903 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912924 */     GIR_RootConstrainSelectedInstOperands,
     /*  912925 */     // GIR_Coverage, 60613,
     /*  912925 */     GIR_EraseRootFromParent_Done,
     /*  912926 */   // Label 13907: @912926
     /*  912926 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(913004), // Rule ID 62268 //
     /*  912931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912963 */     // MIs[0] rs2
     /*  912963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912971 */     // MIs[0] policy
     /*  912971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912981 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913002 */     GIR_RootConstrainSelectedInstOperands,
     /*  913003 */     // GIR_Coverage, 62268,
     /*  913003 */     GIR_EraseRootFromParent_Done,
     /*  913004 */   // Label 13908: @913004
     /*  913004 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(913082), // Rule ID 62269 //
     /*  913009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913041 */     // MIs[0] rs2
     /*  913041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913049 */     // MIs[0] policy
     /*  913049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  913062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913080 */     GIR_RootConstrainSelectedInstOperands,
     /*  913081 */     // GIR_Coverage, 62269,
     /*  913081 */     GIR_EraseRootFromParent_Done,
     /*  913082 */   // Label 13909: @913082
     /*  913082 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(913160), // Rule ID 62270 //
     /*  913087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913119 */     // MIs[0] rs2
     /*  913119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913127 */     // MIs[0] policy
     /*  913127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  913140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913158 */     GIR_RootConstrainSelectedInstOperands,
     /*  913159 */     // GIR_Coverage, 62270,
     /*  913159 */     GIR_EraseRootFromParent_Done,
     /*  913160 */   // Label 13910: @913160
     /*  913160 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(913238), // Rule ID 62271 //
     /*  913165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913197 */     // MIs[0] rs2
     /*  913197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913205 */     // MIs[0] policy
     /*  913205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913215 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  913218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913236 */     GIR_RootConstrainSelectedInstOperands,
     /*  913237 */     // GIR_Coverage, 62271,
     /*  913237 */     GIR_EraseRootFromParent_Done,
     /*  913238 */   // Label 13911: @913238
     /*  913238 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(913316), // Rule ID 62272 //
     /*  913243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913275 */     // MIs[0] rs2
     /*  913275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913283 */     // MIs[0] policy
     /*  913283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  913296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913314 */     GIR_RootConstrainSelectedInstOperands,
     /*  913315 */     // GIR_Coverage, 62272,
     /*  913315 */     GIR_EraseRootFromParent_Done,
     /*  913316 */   // Label 13912: @913316
     /*  913316 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(913394), // Rule ID 62273 //
     /*  913321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913353 */     // MIs[0] rs2
     /*  913353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913361 */     // MIs[0] policy
     /*  913361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  913374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913392 */     GIR_RootConstrainSelectedInstOperands,
     /*  913393 */     // GIR_Coverage, 62273,
     /*  913393 */     GIR_EraseRootFromParent_Done,
     /*  913394 */   // Label 13913: @913394
     /*  913394 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(913472), // Rule ID 62274 //
     /*  913399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  913402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913431 */     // MIs[0] rs2
     /*  913431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913439 */     // MIs[0] policy
     /*  913439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913449 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913470 */     GIR_RootConstrainSelectedInstOperands,
     /*  913471 */     // GIR_Coverage, 62274,
     /*  913471 */     GIR_EraseRootFromParent_Done,
     /*  913472 */   // Label 13914: @913472
     /*  913472 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(913550), // Rule ID 62275 //
     /*  913477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913509 */     // MIs[0] rs2
     /*  913509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913517 */     // MIs[0] policy
     /*  913517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913548 */     GIR_RootConstrainSelectedInstOperands,
     /*  913549 */     // GIR_Coverage, 62275,
     /*  913549 */     GIR_EraseRootFromParent_Done,
     /*  913550 */   // Label 13915: @913550
     /*  913550 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(913628), // Rule ID 62436 //
     /*  913555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913587 */     // MIs[0] rs2
     /*  913587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913595 */     // MIs[0] policy
     /*  913595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913605 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913626 */     GIR_RootConstrainSelectedInstOperands,
     /*  913627 */     // GIR_Coverage, 62436,
     /*  913627 */     GIR_EraseRootFromParent_Done,
     /*  913628 */   // Label 13916: @913628
     /*  913628 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(913706), // Rule ID 62437 //
     /*  913633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913665 */     // MIs[0] rs2
     /*  913665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913673 */     // MIs[0] policy
     /*  913673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913704 */     GIR_RootConstrainSelectedInstOperands,
     /*  913705 */     // GIR_Coverage, 62437,
     /*  913705 */     GIR_EraseRootFromParent_Done,
     /*  913706 */   // Label 13917: @913706
     /*  913706 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(913784), // Rule ID 62438 //
     /*  913711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913743 */     // MIs[0] rs2
     /*  913743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913751 */     // MIs[0] policy
     /*  913751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913761 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913782 */     GIR_RootConstrainSelectedInstOperands,
     /*  913783 */     // GIR_Coverage, 62438,
     /*  913783 */     GIR_EraseRootFromParent_Done,
     /*  913784 */   // Label 13918: @913784
     /*  913784 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(913862), // Rule ID 62439 //
     /*  913789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913821 */     // MIs[0] rs2
     /*  913821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913829 */     // MIs[0] policy
     /*  913829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913839 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913860 */     GIR_RootConstrainSelectedInstOperands,
     /*  913861 */     // GIR_Coverage, 62439,
     /*  913861 */     GIR_EraseRootFromParent_Done,
     /*  913862 */   // Label 13919: @913862
     /*  913862 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(913940), // Rule ID 62440 //
     /*  913867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913899 */     // MIs[0] rs2
     /*  913899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913907 */     // MIs[0] policy
     /*  913907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913938 */     GIR_RootConstrainSelectedInstOperands,
     /*  913939 */     // GIR_Coverage, 62440,
     /*  913939 */     GIR_EraseRootFromParent_Done,
     /*  913940 */   // Label 13920: @913940
     /*  913940 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(914018), // Rule ID 62441 //
     /*  913945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913977 */     // MIs[0] rs2
     /*  913977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913985 */     // MIs[0] policy
     /*  913985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914016 */     GIR_RootConstrainSelectedInstOperands,
     /*  914017 */     // GIR_Coverage, 62441,
     /*  914017 */     GIR_EraseRootFromParent_Done,
     /*  914018 */   // Label 13921: @914018
     /*  914018 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(914096), // Rule ID 62442 //
     /*  914023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  914026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  914034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  914037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  914040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914055 */     // MIs[0] rs2
     /*  914055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914063 */     // MIs[0] policy
     /*  914063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914073 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  914076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914094 */     GIR_RootConstrainSelectedInstOperands,
     /*  914095 */     // GIR_Coverage, 62442,
     /*  914095 */     GIR_EraseRootFromParent_Done,
     /*  914096 */   // Label 13922: @914096
     /*  914096 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(914174), // Rule ID 62443 //
     /*  914101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  914104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  914112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  914115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  914118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914133 */     // MIs[0] rs2
     /*  914133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914141 */     // MIs[0] policy
     /*  914141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914151 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  914154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914172 */     GIR_RootConstrainSelectedInstOperands,
     /*  914173 */     // GIR_Coverage, 62443,
     /*  914173 */     GIR_EraseRootFromParent_Done,
     /*  914174 */   // Label 13923: @914174
     /*  914174 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(914252), // Rule ID 62444 //
     /*  914179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  914182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  914190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  914193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  914196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914211 */     // MIs[0] rs2
     /*  914211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914219 */     // MIs[0] policy
     /*  914219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914229 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  914232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914250 */     GIR_RootConstrainSelectedInstOperands,
     /*  914251 */     // GIR_Coverage, 62444,
     /*  914251 */     GIR_EraseRootFromParent_Done,
     /*  914252 */   // Label 13924: @914252
     /*  914252 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(914330), // Rule ID 62445 //
     /*  914257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  914260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  914265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  914268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  914271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  914274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914289 */     // MIs[0] rs2
     /*  914289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  914292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  914297 */     // MIs[0] policy
     /*  914297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914307 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  914310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  914312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  914318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914328 */     GIR_RootConstrainSelectedInstOperands,
     /*  914329 */     // GIR_Coverage, 62445,
     /*  914329 */     GIR_EraseRootFromParent_Done,
     /*  914330 */   // Label 13925: @914330
     /*  914330 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(914418), // Rule ID 23702 //
     /*  914335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  914346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  914349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  914352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914382 */     // MIs[1] Operand 1
     /*  914382 */     // No operand predicates
     /*  914382 */     // MIs[0] policy
     /*  914382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914416 */     GIR_RootConstrainSelectedInstOperands,
     /*  914417 */     // GIR_Coverage, 23702,
     /*  914417 */     GIR_EraseRootFromParent_Done,
     /*  914418 */   // Label 13926: @914418
     /*  914418 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(914506), // Rule ID 23703 //
     /*  914423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  914434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  914437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  914440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914470 */     // MIs[1] Operand 1
     /*  914470 */     // No operand predicates
     /*  914470 */     // MIs[0] policy
     /*  914470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914482 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914504 */     GIR_RootConstrainSelectedInstOperands,
     /*  914505 */     // GIR_Coverage, 23703,
     /*  914505 */     GIR_EraseRootFromParent_Done,
     /*  914506 */   // Label 13927: @914506
     /*  914506 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(914594), // Rule ID 23706 //
     /*  914511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914558 */     // MIs[1] Operand 1
     /*  914558 */     // No operand predicates
     /*  914558 */     // MIs[0] policy
     /*  914558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914592 */     GIR_RootConstrainSelectedInstOperands,
     /*  914593 */     // GIR_Coverage, 23706,
     /*  914593 */     GIR_EraseRootFromParent_Done,
     /*  914594 */   // Label 13928: @914594
     /*  914594 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(914682), // Rule ID 23707 //
     /*  914599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914646 */     // MIs[1] Operand 1
     /*  914646 */     // No operand predicates
     /*  914646 */     // MIs[0] policy
     /*  914646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914658 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914680 */     GIR_RootConstrainSelectedInstOperands,
     /*  914681 */     // GIR_Coverage, 23707,
     /*  914681 */     GIR_EraseRootFromParent_Done,
     /*  914682 */   // Label 13929: @914682
     /*  914682 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(914770), // Rule ID 23710 //
     /*  914687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914734 */     // MIs[1] Operand 1
     /*  914734 */     // No operand predicates
     /*  914734 */     // MIs[0] policy
     /*  914734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914768 */     GIR_RootConstrainSelectedInstOperands,
     /*  914769 */     // GIR_Coverage, 23710,
     /*  914769 */     GIR_EraseRootFromParent_Done,
     /*  914770 */   // Label 13930: @914770
     /*  914770 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(914858), // Rule ID 23711 //
     /*  914775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914822 */     // MIs[1] Operand 1
     /*  914822 */     // No operand predicates
     /*  914822 */     // MIs[0] policy
     /*  914822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914856 */     GIR_RootConstrainSelectedInstOperands,
     /*  914857 */     // GIR_Coverage, 23711,
     /*  914857 */     GIR_EraseRootFromParent_Done,
     /*  914858 */   // Label 13931: @914858
     /*  914858 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(914946), // Rule ID 23714 //
     /*  914863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914910 */     // MIs[1] Operand 1
     /*  914910 */     // No operand predicates
     /*  914910 */     // MIs[0] policy
     /*  914910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914944 */     GIR_RootConstrainSelectedInstOperands,
     /*  914945 */     // GIR_Coverage, 23714,
     /*  914945 */     GIR_EraseRootFromParent_Done,
     /*  914946 */   // Label 13932: @914946
     /*  914946 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(915034), // Rule ID 23715 //
     /*  914951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914998 */     // MIs[1] Operand 1
     /*  914998 */     // No operand predicates
     /*  914998 */     // MIs[0] policy
     /*  914998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  915013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915032 */     GIR_RootConstrainSelectedInstOperands,
     /*  915033 */     // GIR_Coverage, 23715,
     /*  915033 */     GIR_EraseRootFromParent_Done,
     /*  915034 */   // Label 13933: @915034
     /*  915034 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(915122), // Rule ID 23718 //
     /*  915039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  915050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  915053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  915056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915086 */     // MIs[1] Operand 1
     /*  915086 */     // No operand predicates
     /*  915086 */     // MIs[0] policy
     /*  915086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915120 */     GIR_RootConstrainSelectedInstOperands,
     /*  915121 */     // GIR_Coverage, 23718,
     /*  915121 */     GIR_EraseRootFromParent_Done,
     /*  915122 */   // Label 13934: @915122
     /*  915122 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(915210), // Rule ID 23719 //
     /*  915127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  915138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  915141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  915144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915174 */     // MIs[1] Operand 1
     /*  915174 */     // No operand predicates
     /*  915174 */     // MIs[0] policy
     /*  915174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915186 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915208 */     GIR_RootConstrainSelectedInstOperands,
     /*  915209 */     // GIR_Coverage, 23719,
     /*  915209 */     GIR_EraseRootFromParent_Done,
     /*  915210 */   // Label 13935: @915210
     /*  915210 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(915298), // Rule ID 23722 //
     /*  915215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  915226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  915229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  915232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915262 */     // MIs[1] Operand 1
     /*  915262 */     // No operand predicates
     /*  915262 */     // MIs[0] policy
     /*  915262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915296 */     GIR_RootConstrainSelectedInstOperands,
     /*  915297 */     // GIR_Coverage, 23722,
     /*  915297 */     GIR_EraseRootFromParent_Done,
     /*  915298 */   // Label 13936: @915298
     /*  915298 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(915386), // Rule ID 23723 //
     /*  915303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  915314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  915317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  915320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915350 */     // MIs[1] Operand 1
     /*  915350 */     // No operand predicates
     /*  915350 */     // MIs[0] policy
     /*  915350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  915365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915384 */     GIR_RootConstrainSelectedInstOperands,
     /*  915385 */     // GIR_Coverage, 23723,
     /*  915385 */     GIR_EraseRootFromParent_Done,
     /*  915386 */   // Label 13937: @915386
     /*  915386 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(915474), // Rule ID 23726 //
     /*  915391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915438 */     // MIs[1] Operand 1
     /*  915438 */     // No operand predicates
     /*  915438 */     // MIs[0] policy
     /*  915438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915472 */     GIR_RootConstrainSelectedInstOperands,
     /*  915473 */     // GIR_Coverage, 23726,
     /*  915473 */     GIR_EraseRootFromParent_Done,
     /*  915474 */   // Label 13938: @915474
     /*  915474 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(915562), // Rule ID 23727 //
     /*  915479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915526 */     // MIs[1] Operand 1
     /*  915526 */     // No operand predicates
     /*  915526 */     // MIs[0] policy
     /*  915526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915560 */     GIR_RootConstrainSelectedInstOperands,
     /*  915561 */     // GIR_Coverage, 23727,
     /*  915561 */     GIR_EraseRootFromParent_Done,
     /*  915562 */   // Label 13939: @915562
     /*  915562 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(915650), // Rule ID 23730 //
     /*  915567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915614 */     // MIs[1] Operand 1
     /*  915614 */     // No operand predicates
     /*  915614 */     // MIs[0] policy
     /*  915614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915648 */     GIR_RootConstrainSelectedInstOperands,
     /*  915649 */     // GIR_Coverage, 23730,
     /*  915649 */     GIR_EraseRootFromParent_Done,
     /*  915650 */   // Label 13940: @915650
     /*  915650 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(915738), // Rule ID 23731 //
     /*  915655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915702 */     // MIs[1] Operand 1
     /*  915702 */     // No operand predicates
     /*  915702 */     // MIs[0] policy
     /*  915702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915736 */     GIR_RootConstrainSelectedInstOperands,
     /*  915737 */     // GIR_Coverage, 23731,
     /*  915737 */     GIR_EraseRootFromParent_Done,
     /*  915738 */   // Label 13941: @915738
     /*  915738 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(915826), // Rule ID 23734 //
     /*  915743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915790 */     // MIs[1] Operand 1
     /*  915790 */     // No operand predicates
     /*  915790 */     // MIs[0] policy
     /*  915790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915824 */     GIR_RootConstrainSelectedInstOperands,
     /*  915825 */     // GIR_Coverage, 23734,
     /*  915825 */     GIR_EraseRootFromParent_Done,
     /*  915826 */   // Label 13942: @915826
     /*  915826 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(915914), // Rule ID 23735 //
     /*  915831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915878 */     // MIs[1] Operand 1
     /*  915878 */     // No operand predicates
     /*  915878 */     // MIs[0] policy
     /*  915878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915912 */     GIR_RootConstrainSelectedInstOperands,
     /*  915913 */     // GIR_Coverage, 23735,
     /*  915913 */     GIR_EraseRootFromParent_Done,
     /*  915914 */   // Label 13943: @915914
     /*  915914 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(916002), // Rule ID 23738 //
     /*  915919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  915922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915966 */     // MIs[1] Operand 1
     /*  915966 */     // No operand predicates
     /*  915966 */     // MIs[0] policy
     /*  915966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916000 */     GIR_RootConstrainSelectedInstOperands,
     /*  916001 */     // GIR_Coverage, 23738,
     /*  916001 */     GIR_EraseRootFromParent_Done,
     /*  916002 */   // Label 13944: @916002
     /*  916002 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(916090), // Rule ID 23739 //
     /*  916007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  916018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  916021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  916024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916054 */     // MIs[1] Operand 1
     /*  916054 */     // No operand predicates
     /*  916054 */     // MIs[0] policy
     /*  916054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  916069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916088 */     GIR_RootConstrainSelectedInstOperands,
     /*  916089 */     // GIR_Coverage, 23739,
     /*  916089 */     GIR_EraseRootFromParent_Done,
     /*  916090 */   // Label 13945: @916090
     /*  916090 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(916178), // Rule ID 23742 //
     /*  916095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  916106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  916109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  916112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916142 */     // MIs[1] Operand 1
     /*  916142 */     // No operand predicates
     /*  916142 */     // MIs[0] policy
     /*  916142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916176 */     GIR_RootConstrainSelectedInstOperands,
     /*  916177 */     // GIR_Coverage, 23742,
     /*  916177 */     GIR_EraseRootFromParent_Done,
     /*  916178 */   // Label 13946: @916178
     /*  916178 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(916266), // Rule ID 23743 //
     /*  916183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  916194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  916197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  916200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916230 */     // MIs[1] Operand 1
     /*  916230 */     // No operand predicates
     /*  916230 */     // MIs[0] policy
     /*  916230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916264 */     GIR_RootConstrainSelectedInstOperands,
     /*  916265 */     // GIR_Coverage, 23743,
     /*  916265 */     GIR_EraseRootFromParent_Done,
     /*  916266 */   // Label 13947: @916266
     /*  916266 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(916354), // Rule ID 23746 //
     /*  916271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  916282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  916285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  916288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916318 */     // MIs[1] Operand 1
     /*  916318 */     // No operand predicates
     /*  916318 */     // MIs[0] policy
     /*  916318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916352 */     GIR_RootConstrainSelectedInstOperands,
     /*  916353 */     // GIR_Coverage, 23746,
     /*  916353 */     GIR_EraseRootFromParent_Done,
     /*  916354 */   // Label 13948: @916354
     /*  916354 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(916442), // Rule ID 23747 //
     /*  916359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  916370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  916373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  916376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916406 */     // MIs[1] Operand 1
     /*  916406 */     // No operand predicates
     /*  916406 */     // MIs[0] policy
     /*  916406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916440 */     GIR_RootConstrainSelectedInstOperands,
     /*  916441 */     // GIR_Coverage, 23747,
     /*  916441 */     GIR_EraseRootFromParent_Done,
     /*  916442 */   // Label 13949: @916442
     /*  916442 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(916530), // Rule ID 23750 //
     /*  916447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916494 */     // MIs[1] Operand 1
     /*  916494 */     // No operand predicates
     /*  916494 */     // MIs[0] policy
     /*  916494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916528 */     GIR_RootConstrainSelectedInstOperands,
     /*  916529 */     // GIR_Coverage, 23750,
     /*  916529 */     GIR_EraseRootFromParent_Done,
     /*  916530 */   // Label 13950: @916530
     /*  916530 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(916618), // Rule ID 23751 //
     /*  916535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916582 */     // MIs[1] Operand 1
     /*  916582 */     // No operand predicates
     /*  916582 */     // MIs[0] policy
     /*  916582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916594 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916616 */     GIR_RootConstrainSelectedInstOperands,
     /*  916617 */     // GIR_Coverage, 23751,
     /*  916617 */     GIR_EraseRootFromParent_Done,
     /*  916618 */   // Label 13951: @916618
     /*  916618 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(916706), // Rule ID 23754 //
     /*  916623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916670 */     // MIs[1] Operand 1
     /*  916670 */     // No operand predicates
     /*  916670 */     // MIs[0] policy
     /*  916670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916704 */     GIR_RootConstrainSelectedInstOperands,
     /*  916705 */     // GIR_Coverage, 23754,
     /*  916705 */     GIR_EraseRootFromParent_Done,
     /*  916706 */   // Label 13952: @916706
     /*  916706 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(916794), // Rule ID 23755 //
     /*  916711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916758 */     // MIs[1] Operand 1
     /*  916758 */     // No operand predicates
     /*  916758 */     // MIs[0] policy
     /*  916758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916792 */     GIR_RootConstrainSelectedInstOperands,
     /*  916793 */     // GIR_Coverage, 23755,
     /*  916793 */     GIR_EraseRootFromParent_Done,
     /*  916794 */   // Label 13953: @916794
     /*  916794 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(916882), // Rule ID 23758 //
     /*  916799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916846 */     // MIs[1] Operand 1
     /*  916846 */     // No operand predicates
     /*  916846 */     // MIs[0] policy
     /*  916846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916880 */     GIR_RootConstrainSelectedInstOperands,
     /*  916881 */     // GIR_Coverage, 23758,
     /*  916881 */     GIR_EraseRootFromParent_Done,
     /*  916882 */   // Label 13954: @916882
     /*  916882 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(916970), // Rule ID 23759 //
     /*  916887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916934 */     // MIs[1] Operand 1
     /*  916934 */     // No operand predicates
     /*  916934 */     // MIs[0] policy
     /*  916934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916968 */     GIR_RootConstrainSelectedInstOperands,
     /*  916969 */     // GIR_Coverage, 23759,
     /*  916969 */     GIR_EraseRootFromParent_Done,
     /*  916970 */   // Label 13955: @916970
     /*  916970 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(917058), // Rule ID 23762 //
     /*  916975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917022 */     // MIs[1] Operand 1
     /*  917022 */     // No operand predicates
     /*  917022 */     // MIs[0] policy
     /*  917022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917034 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917056 */     GIR_RootConstrainSelectedInstOperands,
     /*  917057 */     // GIR_Coverage, 23762,
     /*  917057 */     GIR_EraseRootFromParent_Done,
     /*  917058 */   // Label 13956: @917058
     /*  917058 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(917146), // Rule ID 23763 //
     /*  917063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  917074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  917077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  917080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917110 */     // MIs[1] Operand 1
     /*  917110 */     // No operand predicates
     /*  917110 */     // MIs[0] policy
     /*  917110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917122 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917144 */     GIR_RootConstrainSelectedInstOperands,
     /*  917145 */     // GIR_Coverage, 23763,
     /*  917145 */     GIR_EraseRootFromParent_Done,
     /*  917146 */   // Label 13957: @917146
     /*  917146 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(917234), // Rule ID 23766 //
     /*  917151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917198 */     // MIs[1] Operand 1
     /*  917198 */     // No operand predicates
     /*  917198 */     // MIs[0] policy
     /*  917198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917232 */     GIR_RootConstrainSelectedInstOperands,
     /*  917233 */     // GIR_Coverage, 23766,
     /*  917233 */     GIR_EraseRootFromParent_Done,
     /*  917234 */   // Label 13958: @917234
     /*  917234 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(917322), // Rule ID 23767 //
     /*  917239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917286 */     // MIs[1] Operand 1
     /*  917286 */     // No operand predicates
     /*  917286 */     // MIs[0] policy
     /*  917286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917320 */     GIR_RootConstrainSelectedInstOperands,
     /*  917321 */     // GIR_Coverage, 23767,
     /*  917321 */     GIR_EraseRootFromParent_Done,
     /*  917322 */   // Label 13959: @917322
     /*  917322 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(917410), // Rule ID 23770 //
     /*  917327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917374 */     // MIs[1] Operand 1
     /*  917374 */     // No operand predicates
     /*  917374 */     // MIs[0] policy
     /*  917374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917408 */     GIR_RootConstrainSelectedInstOperands,
     /*  917409 */     // GIR_Coverage, 23770,
     /*  917409 */     GIR_EraseRootFromParent_Done,
     /*  917410 */   // Label 13960: @917410
     /*  917410 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(917498), // Rule ID 23771 //
     /*  917415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917462 */     // MIs[1] Operand 1
     /*  917462 */     // No operand predicates
     /*  917462 */     // MIs[0] policy
     /*  917462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917496 */     GIR_RootConstrainSelectedInstOperands,
     /*  917497 */     // GIR_Coverage, 23771,
     /*  917497 */     GIR_EraseRootFromParent_Done,
     /*  917498 */   // Label 13961: @917498
     /*  917498 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(917586), // Rule ID 23774 //
     /*  917503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917550 */     // MIs[1] Operand 1
     /*  917550 */     // No operand predicates
     /*  917550 */     // MIs[0] policy
     /*  917550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917584 */     GIR_RootConstrainSelectedInstOperands,
     /*  917585 */     // GIR_Coverage, 23774,
     /*  917585 */     GIR_EraseRootFromParent_Done,
     /*  917586 */   // Label 13962: @917586
     /*  917586 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(917674), // Rule ID 23775 //
     /*  917591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917638 */     // MIs[1] Operand 1
     /*  917638 */     // No operand predicates
     /*  917638 */     // MIs[0] policy
     /*  917638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917672 */     GIR_RootConstrainSelectedInstOperands,
     /*  917673 */     // GIR_Coverage, 23775,
     /*  917673 */     GIR_EraseRootFromParent_Done,
     /*  917674 */   // Label 13963: @917674
     /*  917674 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(917762), // Rule ID 23778 //
     /*  917679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917726 */     // MIs[1] Operand 1
     /*  917726 */     // No operand predicates
     /*  917726 */     // MIs[0] policy
     /*  917726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917760 */     GIR_RootConstrainSelectedInstOperands,
     /*  917761 */     // GIR_Coverage, 23778,
     /*  917761 */     GIR_EraseRootFromParent_Done,
     /*  917762 */   // Label 13964: @917762
     /*  917762 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(917850), // Rule ID 23779 //
     /*  917767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917814 */     // MIs[1] Operand 1
     /*  917814 */     // No operand predicates
     /*  917814 */     // MIs[0] policy
     /*  917814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917848 */     GIR_RootConstrainSelectedInstOperands,
     /*  917849 */     // GIR_Coverage, 23779,
     /*  917849 */     GIR_EraseRootFromParent_Done,
     /*  917850 */   // Label 13965: @917850
     /*  917850 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(917938), // Rule ID 23782 //
     /*  917855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917902 */     // MIs[1] Operand 1
     /*  917902 */     // No operand predicates
     /*  917902 */     // MIs[0] policy
     /*  917902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917914 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917936 */     GIR_RootConstrainSelectedInstOperands,
     /*  917937 */     // GIR_Coverage, 23782,
     /*  917937 */     GIR_EraseRootFromParent_Done,
     /*  917938 */   // Label 13966: @917938
     /*  917938 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(918026), // Rule ID 23783 //
     /*  917943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917990 */     // MIs[1] Operand 1
     /*  917990 */     // No operand predicates
     /*  917990 */     // MIs[0] policy
     /*  917990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  918005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918024 */     GIR_RootConstrainSelectedInstOperands,
     /*  918025 */     // GIR_Coverage, 23783,
     /*  918025 */     GIR_EraseRootFromParent_Done,
     /*  918026 */   // Label 13967: @918026
     /*  918026 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(918114), // Rule ID 23786 //
     /*  918031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  918034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  918042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  918045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  918048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918078 */     // MIs[1] Operand 1
     /*  918078 */     // No operand predicates
     /*  918078 */     // MIs[0] policy
     /*  918078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  918093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918112 */     GIR_RootConstrainSelectedInstOperands,
     /*  918113 */     // GIR_Coverage, 23786,
     /*  918113 */     GIR_EraseRootFromParent_Done,
     /*  918114 */   // Label 13968: @918114
     /*  918114 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(918202), // Rule ID 23787 //
     /*  918119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  918122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  918130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  918133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  918136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  918154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918166 */     // MIs[1] Operand 1
     /*  918166 */     // No operand predicates
     /*  918166 */     // MIs[0] policy
     /*  918166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918178 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  918181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918200 */     GIR_RootConstrainSelectedInstOperands,
     /*  918201 */     // GIR_Coverage, 23787,
     /*  918201 */     GIR_EraseRootFromParent_Done,
     /*  918202 */   // Label 13969: @918202
     /*  918202 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(918290), // Rule ID 23878 //
     /*  918207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  918218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  918221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  918224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918254 */     // MIs[1] Operand 1
     /*  918254 */     // No operand predicates
     /*  918254 */     // MIs[0] policy
     /*  918254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  918269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918288 */     GIR_RootConstrainSelectedInstOperands,
     /*  918289 */     // GIR_Coverage, 23878,
     /*  918289 */     GIR_EraseRootFromParent_Done,
     /*  918290 */   // Label 13970: @918290
     /*  918290 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(918378), // Rule ID 23879 //
     /*  918295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  918306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  918309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  918312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918342 */     // MIs[1] Operand 1
     /*  918342 */     // No operand predicates
     /*  918342 */     // MIs[0] policy
     /*  918342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  918357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918376 */     GIR_RootConstrainSelectedInstOperands,
     /*  918377 */     // GIR_Coverage, 23879,
     /*  918377 */     GIR_EraseRootFromParent_Done,
     /*  918378 */   // Label 13971: @918378
     /*  918378 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(918466), // Rule ID 23882 //
     /*  918383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918430 */     // MIs[1] Operand 1
     /*  918430 */     // No operand predicates
     /*  918430 */     // MIs[0] policy
     /*  918430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918464 */     GIR_RootConstrainSelectedInstOperands,
     /*  918465 */     // GIR_Coverage, 23882,
     /*  918465 */     GIR_EraseRootFromParent_Done,
     /*  918466 */   // Label 13972: @918466
     /*  918466 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(918554), // Rule ID 23883 //
     /*  918471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918518 */     // MIs[1] Operand 1
     /*  918518 */     // No operand predicates
     /*  918518 */     // MIs[0] policy
     /*  918518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918530 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918552 */     GIR_RootConstrainSelectedInstOperands,
     /*  918553 */     // GIR_Coverage, 23883,
     /*  918553 */     GIR_EraseRootFromParent_Done,
     /*  918554 */   // Label 13973: @918554
     /*  918554 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(918642), // Rule ID 23886 //
     /*  918559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918606 */     // MIs[1] Operand 1
     /*  918606 */     // No operand predicates
     /*  918606 */     // MIs[0] policy
     /*  918606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918640 */     GIR_RootConstrainSelectedInstOperands,
     /*  918641 */     // GIR_Coverage, 23886,
     /*  918641 */     GIR_EraseRootFromParent_Done,
     /*  918642 */   // Label 13974: @918642
     /*  918642 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(918730), // Rule ID 23887 //
     /*  918647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918694 */     // MIs[1] Operand 1
     /*  918694 */     // No operand predicates
     /*  918694 */     // MIs[0] policy
     /*  918694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918728 */     GIR_RootConstrainSelectedInstOperands,
     /*  918729 */     // GIR_Coverage, 23887,
     /*  918729 */     GIR_EraseRootFromParent_Done,
     /*  918730 */   // Label 13975: @918730
     /*  918730 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(918818), // Rule ID 23890 //
     /*  918735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918782 */     // MIs[1] Operand 1
     /*  918782 */     // No operand predicates
     /*  918782 */     // MIs[0] policy
     /*  918782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918816 */     GIR_RootConstrainSelectedInstOperands,
     /*  918817 */     // GIR_Coverage, 23890,
     /*  918817 */     GIR_EraseRootFromParent_Done,
     /*  918818 */   // Label 13976: @918818
     /*  918818 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(918906), // Rule ID 23891 //
     /*  918823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918870 */     // MIs[1] Operand 1
     /*  918870 */     // No operand predicates
     /*  918870 */     // MIs[0] policy
     /*  918870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918904 */     GIR_RootConstrainSelectedInstOperands,
     /*  918905 */     // GIR_Coverage, 23891,
     /*  918905 */     GIR_EraseRootFromParent_Done,
     /*  918906 */   // Label 13977: @918906
     /*  918906 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(918994), // Rule ID 23894 //
     /*  918911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918958 */     // MIs[1] Operand 1
     /*  918958 */     // No operand predicates
     /*  918958 */     // MIs[0] policy
     /*  918958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918992 */     GIR_RootConstrainSelectedInstOperands,
     /*  918993 */     // GIR_Coverage, 23894,
     /*  918993 */     GIR_EraseRootFromParent_Done,
     /*  918994 */   // Label 13978: @918994
     /*  918994 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(919082), // Rule ID 23895 //
     /*  918999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  919010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  919013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  919016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919046 */     // MIs[1] Operand 1
     /*  919046 */     // No operand predicates
     /*  919046 */     // MIs[0] policy
     /*  919046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919080 */     GIR_RootConstrainSelectedInstOperands,
     /*  919081 */     // GIR_Coverage, 23895,
     /*  919081 */     GIR_EraseRootFromParent_Done,
     /*  919082 */   // Label 13979: @919082
     /*  919082 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(919170), // Rule ID 23898 //
     /*  919087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  919098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  919101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  919104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919134 */     // MIs[1] Operand 1
     /*  919134 */     // No operand predicates
     /*  919134 */     // MIs[0] policy
     /*  919134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919168 */     GIR_RootConstrainSelectedInstOperands,
     /*  919169 */     // GIR_Coverage, 23898,
     /*  919169 */     GIR_EraseRootFromParent_Done,
     /*  919170 */   // Label 13980: @919170
     /*  919170 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(919258), // Rule ID 23899 //
     /*  919175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  919186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  919189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  919192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919222 */     // MIs[1] Operand 1
     /*  919222 */     // No operand predicates
     /*  919222 */     // MIs[0] policy
     /*  919222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  919237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919256 */     GIR_RootConstrainSelectedInstOperands,
     /*  919257 */     // GIR_Coverage, 23899,
     /*  919257 */     GIR_EraseRootFromParent_Done,
     /*  919258 */   // Label 13981: @919258
     /*  919258 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(919346), // Rule ID 23902 //
     /*  919263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  919274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  919277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  919280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919310 */     // MIs[1] Operand 1
     /*  919310 */     // No operand predicates
     /*  919310 */     // MIs[0] policy
     /*  919310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919322 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919344 */     GIR_RootConstrainSelectedInstOperands,
     /*  919345 */     // GIR_Coverage, 23902,
     /*  919345 */     GIR_EraseRootFromParent_Done,
     /*  919346 */   // Label 13982: @919346
     /*  919346 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(919434), // Rule ID 23903 //
     /*  919351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  919362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  919365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  919368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919398 */     // MIs[1] Operand 1
     /*  919398 */     // No operand predicates
     /*  919398 */     // MIs[0] policy
     /*  919398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919410 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919432 */     GIR_RootConstrainSelectedInstOperands,
     /*  919433 */     // GIR_Coverage, 23903,
     /*  919433 */     GIR_EraseRootFromParent_Done,
     /*  919434 */   // Label 13983: @919434
     /*  919434 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(919522), // Rule ID 23906 //
     /*  919439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919486 */     // MIs[1] Operand 1
     /*  919486 */     // No operand predicates
     /*  919486 */     // MIs[0] policy
     /*  919486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919520 */     GIR_RootConstrainSelectedInstOperands,
     /*  919521 */     // GIR_Coverage, 23906,
     /*  919521 */     GIR_EraseRootFromParent_Done,
     /*  919522 */   // Label 13984: @919522
     /*  919522 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(919610), // Rule ID 23907 //
     /*  919527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919574 */     // MIs[1] Operand 1
     /*  919574 */     // No operand predicates
     /*  919574 */     // MIs[0] policy
     /*  919574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919586 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919608 */     GIR_RootConstrainSelectedInstOperands,
     /*  919609 */     // GIR_Coverage, 23907,
     /*  919609 */     GIR_EraseRootFromParent_Done,
     /*  919610 */   // Label 13985: @919610
     /*  919610 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(919698), // Rule ID 23910 //
     /*  919615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919662 */     // MIs[1] Operand 1
     /*  919662 */     // No operand predicates
     /*  919662 */     // MIs[0] policy
     /*  919662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919696 */     GIR_RootConstrainSelectedInstOperands,
     /*  919697 */     // GIR_Coverage, 23910,
     /*  919697 */     GIR_EraseRootFromParent_Done,
     /*  919698 */   // Label 13986: @919698
     /*  919698 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(919786), // Rule ID 23911 //
     /*  919703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919750 */     // MIs[1] Operand 1
     /*  919750 */     // No operand predicates
     /*  919750 */     // MIs[0] policy
     /*  919750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919784 */     GIR_RootConstrainSelectedInstOperands,
     /*  919785 */     // GIR_Coverage, 23911,
     /*  919785 */     GIR_EraseRootFromParent_Done,
     /*  919786 */   // Label 13987: @919786
     /*  919786 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(919874), // Rule ID 23914 //
     /*  919791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919838 */     // MIs[1] Operand 1
     /*  919838 */     // No operand predicates
     /*  919838 */     // MIs[0] policy
     /*  919838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919872 */     GIR_RootConstrainSelectedInstOperands,
     /*  919873 */     // GIR_Coverage, 23914,
     /*  919873 */     GIR_EraseRootFromParent_Done,
     /*  919874 */   // Label 13988: @919874
     /*  919874 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(919962), // Rule ID 23915 //
     /*  919879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919926 */     // MIs[1] Operand 1
     /*  919926 */     // No operand predicates
     /*  919926 */     // MIs[0] policy
     /*  919926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919960 */     GIR_RootConstrainSelectedInstOperands,
     /*  919961 */     // GIR_Coverage, 23915,
     /*  919961 */     GIR_EraseRootFromParent_Done,
     /*  919962 */   // Label 13989: @919962
     /*  919962 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(920050), // Rule ID 23918 //
     /*  919967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920014 */     // MIs[1] Operand 1
     /*  920014 */     // No operand predicates
     /*  920014 */     // MIs[0] policy
     /*  920014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920048 */     GIR_RootConstrainSelectedInstOperands,
     /*  920049 */     // GIR_Coverage, 23918,
     /*  920049 */     GIR_EraseRootFromParent_Done,
     /*  920050 */   // Label 13990: @920050
     /*  920050 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(920138), // Rule ID 23919 //
     /*  920055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  920066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  920069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  920072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920102 */     // MIs[1] Operand 1
     /*  920102 */     // No operand predicates
     /*  920102 */     // MIs[0] policy
     /*  920102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920136 */     GIR_RootConstrainSelectedInstOperands,
     /*  920137 */     // GIR_Coverage, 23919,
     /*  920137 */     GIR_EraseRootFromParent_Done,
     /*  920138 */   // Label 13991: @920138
     /*  920138 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(920226), // Rule ID 23922 //
     /*  920143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  920154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  920157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  920160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920190 */     // MIs[1] Operand 1
     /*  920190 */     // No operand predicates
     /*  920190 */     // MIs[0] policy
     /*  920190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920224 */     GIR_RootConstrainSelectedInstOperands,
     /*  920225 */     // GIR_Coverage, 23922,
     /*  920225 */     GIR_EraseRootFromParent_Done,
     /*  920226 */   // Label 13992: @920226
     /*  920226 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(920314), // Rule ID 23923 //
     /*  920231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  920242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  920245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  920248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920278 */     // MIs[1] Operand 1
     /*  920278 */     // No operand predicates
     /*  920278 */     // MIs[0] policy
     /*  920278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920312 */     GIR_RootConstrainSelectedInstOperands,
     /*  920313 */     // GIR_Coverage, 23923,
     /*  920313 */     GIR_EraseRootFromParent_Done,
     /*  920314 */   // Label 13993: @920314
     /*  920314 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(920402), // Rule ID 23926 //
     /*  920319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  920330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  920333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  920336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920366 */     // MIs[1] Operand 1
     /*  920366 */     // No operand predicates
     /*  920366 */     // MIs[0] policy
     /*  920366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920400 */     GIR_RootConstrainSelectedInstOperands,
     /*  920401 */     // GIR_Coverage, 23926,
     /*  920401 */     GIR_EraseRootFromParent_Done,
     /*  920402 */   // Label 13994: @920402
     /*  920402 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(920490), // Rule ID 23927 //
     /*  920407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  920418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  920421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  920424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920454 */     // MIs[1] Operand 1
     /*  920454 */     // No operand predicates
     /*  920454 */     // MIs[0] policy
     /*  920454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920488 */     GIR_RootConstrainSelectedInstOperands,
     /*  920489 */     // GIR_Coverage, 23927,
     /*  920489 */     GIR_EraseRootFromParent_Done,
     /*  920490 */   // Label 13995: @920490
     /*  920490 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(920578), // Rule ID 23930 //
     /*  920495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920542 */     // MIs[1] Operand 1
     /*  920542 */     // No operand predicates
     /*  920542 */     // MIs[0] policy
     /*  920542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920576 */     GIR_RootConstrainSelectedInstOperands,
     /*  920577 */     // GIR_Coverage, 23930,
     /*  920577 */     GIR_EraseRootFromParent_Done,
     /*  920578 */   // Label 13996: @920578
     /*  920578 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(920666), // Rule ID 23931 //
     /*  920583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920630 */     // MIs[1] Operand 1
     /*  920630 */     // No operand predicates
     /*  920630 */     // MIs[0] policy
     /*  920630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920664 */     GIR_RootConstrainSelectedInstOperands,
     /*  920665 */     // GIR_Coverage, 23931,
     /*  920665 */     GIR_EraseRootFromParent_Done,
     /*  920666 */   // Label 13997: @920666
     /*  920666 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(920754), // Rule ID 23934 //
     /*  920671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920718 */     // MIs[1] Operand 1
     /*  920718 */     // No operand predicates
     /*  920718 */     // MIs[0] policy
     /*  920718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920752 */     GIR_RootConstrainSelectedInstOperands,
     /*  920753 */     // GIR_Coverage, 23934,
     /*  920753 */     GIR_EraseRootFromParent_Done,
     /*  920754 */   // Label 13998: @920754
     /*  920754 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(920842), // Rule ID 23935 //
     /*  920759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920806 */     // MIs[1] Operand 1
     /*  920806 */     // No operand predicates
     /*  920806 */     // MIs[0] policy
     /*  920806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920840 */     GIR_RootConstrainSelectedInstOperands,
     /*  920841 */     // GIR_Coverage, 23935,
     /*  920841 */     GIR_EraseRootFromParent_Done,
     /*  920842 */   // Label 13999: @920842
     /*  920842 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(920930), // Rule ID 23938 //
     /*  920847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920894 */     // MIs[1] Operand 1
     /*  920894 */     // No operand predicates
     /*  920894 */     // MIs[0] policy
     /*  920894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920928 */     GIR_RootConstrainSelectedInstOperands,
     /*  920929 */     // GIR_Coverage, 23938,
     /*  920929 */     GIR_EraseRootFromParent_Done,
     /*  920930 */   // Label 14000: @920930
     /*  920930 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(921018), // Rule ID 23939 //
     /*  920935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920982 */     // MIs[1] Operand 1
     /*  920982 */     // No operand predicates
     /*  920982 */     // MIs[0] policy
     /*  920982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921016 */     GIR_RootConstrainSelectedInstOperands,
     /*  921017 */     // GIR_Coverage, 23939,
     /*  921017 */     GIR_EraseRootFromParent_Done,
     /*  921018 */   // Label 14001: @921018
     /*  921018 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(921106), // Rule ID 23942 //
     /*  921023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  921034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  921037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  921040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921070 */     // MIs[1] Operand 1
     /*  921070 */     // No operand predicates
     /*  921070 */     // MIs[0] policy
     /*  921070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921104 */     GIR_RootConstrainSelectedInstOperands,
     /*  921105 */     // GIR_Coverage, 23942,
     /*  921105 */     GIR_EraseRootFromParent_Done,
     /*  921106 */   // Label 14002: @921106
     /*  921106 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(921194), // Rule ID 23943 //
     /*  921111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  921122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  921125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  921128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921158 */     // MIs[1] Operand 1
     /*  921158 */     // No operand predicates
     /*  921158 */     // MIs[0] policy
     /*  921158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921192 */     GIR_RootConstrainSelectedInstOperands,
     /*  921193 */     // GIR_Coverage, 23943,
     /*  921193 */     GIR_EraseRootFromParent_Done,
     /*  921194 */   // Label 14003: @921194
     /*  921194 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(921282), // Rule ID 23946 //
     /*  921199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  921210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  921213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  921216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921246 */     // MIs[1] Operand 1
     /*  921246 */     // No operand predicates
     /*  921246 */     // MIs[0] policy
     /*  921246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921280 */     GIR_RootConstrainSelectedInstOperands,
     /*  921281 */     // GIR_Coverage, 23946,
     /*  921281 */     GIR_EraseRootFromParent_Done,
     /*  921282 */   // Label 14004: @921282
     /*  921282 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(921370), // Rule ID 23947 //
     /*  921287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  921298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  921301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  921304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921334 */     // MIs[1] Operand 1
     /*  921334 */     // No operand predicates
     /*  921334 */     // MIs[0] policy
     /*  921334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921368 */     GIR_RootConstrainSelectedInstOperands,
     /*  921369 */     // GIR_Coverage, 23947,
     /*  921369 */     GIR_EraseRootFromParent_Done,
     /*  921370 */   // Label 14005: @921370
     /*  921370 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(921458), // Rule ID 23950 //
     /*  921375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921422 */     // MIs[1] Operand 1
     /*  921422 */     // No operand predicates
     /*  921422 */     // MIs[0] policy
     /*  921422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921456 */     GIR_RootConstrainSelectedInstOperands,
     /*  921457 */     // GIR_Coverage, 23950,
     /*  921457 */     GIR_EraseRootFromParent_Done,
     /*  921458 */   // Label 14006: @921458
     /*  921458 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(921546), // Rule ID 23951 //
     /*  921463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921510 */     // MIs[1] Operand 1
     /*  921510 */     // No operand predicates
     /*  921510 */     // MIs[0] policy
     /*  921510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921522 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921544 */     GIR_RootConstrainSelectedInstOperands,
     /*  921545 */     // GIR_Coverage, 23951,
     /*  921545 */     GIR_EraseRootFromParent_Done,
     /*  921546 */   // Label 14007: @921546
     /*  921546 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(921634), // Rule ID 23954 //
     /*  921551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921598 */     // MIs[1] Operand 1
     /*  921598 */     // No operand predicates
     /*  921598 */     // MIs[0] policy
     /*  921598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921632 */     GIR_RootConstrainSelectedInstOperands,
     /*  921633 */     // GIR_Coverage, 23954,
     /*  921633 */     GIR_EraseRootFromParent_Done,
     /*  921634 */   // Label 14008: @921634
     /*  921634 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(921722), // Rule ID 23955 //
     /*  921639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921686 */     // MIs[1] Operand 1
     /*  921686 */     // No operand predicates
     /*  921686 */     // MIs[0] policy
     /*  921686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921720 */     GIR_RootConstrainSelectedInstOperands,
     /*  921721 */     // GIR_Coverage, 23955,
     /*  921721 */     GIR_EraseRootFromParent_Done,
     /*  921722 */   // Label 14009: @921722
     /*  921722 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(921810), // Rule ID 23958 //
     /*  921727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921774 */     // MIs[1] Operand 1
     /*  921774 */     // No operand predicates
     /*  921774 */     // MIs[0] policy
     /*  921774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921786 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921808 */     GIR_RootConstrainSelectedInstOperands,
     /*  921809 */     // GIR_Coverage, 23958,
     /*  921809 */     GIR_EraseRootFromParent_Done,
     /*  921810 */   // Label 14010: @921810
     /*  921810 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(921898), // Rule ID 23959 //
     /*  921815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921862 */     // MIs[1] Operand 1
     /*  921862 */     // No operand predicates
     /*  921862 */     // MIs[0] policy
     /*  921862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921896 */     GIR_RootConstrainSelectedInstOperands,
     /*  921897 */     // GIR_Coverage, 23959,
     /*  921897 */     GIR_EraseRootFromParent_Done,
     /*  921898 */   // Label 14011: @921898
     /*  921898 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(921986), // Rule ID 23962 //
     /*  921903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921950 */     // MIs[1] Operand 1
     /*  921950 */     // No operand predicates
     /*  921950 */     // MIs[0] policy
     /*  921950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921984 */     GIR_RootConstrainSelectedInstOperands,
     /*  921985 */     // GIR_Coverage, 23962,
     /*  921985 */     GIR_EraseRootFromParent_Done,
     /*  921986 */   // Label 14012: @921986
     /*  921986 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(922074), // Rule ID 23963 //
     /*  921991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  922002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  922005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  922008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922038 */     // MIs[1] Operand 1
     /*  922038 */     // No operand predicates
     /*  922038 */     // MIs[0] policy
     /*  922038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922050 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  922053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922072 */     GIR_RootConstrainSelectedInstOperands,
     /*  922073 */     // GIR_Coverage, 23963,
     /*  922073 */     GIR_EraseRootFromParent_Done,
     /*  922074 */   // Label 14013: @922074
     /*  922074 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(922162), // Rule ID 24202 //
     /*  922079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922126 */     // MIs[1] Operand 1
     /*  922126 */     // No operand predicates
     /*  922126 */     // MIs[0] policy
     /*  922126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922138 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  922141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922160 */     GIR_RootConstrainSelectedInstOperands,
     /*  922161 */     // GIR_Coverage, 24202,
     /*  922161 */     GIR_EraseRootFromParent_Done,
     /*  922162 */   // Label 14014: @922162
     /*  922162 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(922250), // Rule ID 24203 //
     /*  922167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922214 */     // MIs[1] Operand 1
     /*  922214 */     // No operand predicates
     /*  922214 */     // MIs[0] policy
     /*  922214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922226 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  922229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922248 */     GIR_RootConstrainSelectedInstOperands,
     /*  922249 */     // GIR_Coverage, 24203,
     /*  922249 */     GIR_EraseRootFromParent_Done,
     /*  922250 */   // Label 14015: @922250
     /*  922250 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(922338), // Rule ID 24206 //
     /*  922255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922302 */     // MIs[1] Operand 1
     /*  922302 */     // No operand predicates
     /*  922302 */     // MIs[0] policy
     /*  922302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922314 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922336 */     GIR_RootConstrainSelectedInstOperands,
     /*  922337 */     // GIR_Coverage, 24206,
     /*  922337 */     GIR_EraseRootFromParent_Done,
     /*  922338 */   // Label 14016: @922338
     /*  922338 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(922426), // Rule ID 24207 //
     /*  922343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922390 */     // MIs[1] Operand 1
     /*  922390 */     // No operand predicates
     /*  922390 */     // MIs[0] policy
     /*  922390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922402 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922424 */     GIR_RootConstrainSelectedInstOperands,
     /*  922425 */     // GIR_Coverage, 24207,
     /*  922425 */     GIR_EraseRootFromParent_Done,
     /*  922426 */   // Label 14017: @922426
     /*  922426 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(922514), // Rule ID 24210 //
     /*  922431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922478 */     // MIs[1] Operand 1
     /*  922478 */     // No operand predicates
     /*  922478 */     // MIs[0] policy
     /*  922478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922512 */     GIR_RootConstrainSelectedInstOperands,
     /*  922513 */     // GIR_Coverage, 24210,
     /*  922513 */     GIR_EraseRootFromParent_Done,
     /*  922514 */   // Label 14018: @922514
     /*  922514 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(922602), // Rule ID 24211 //
     /*  922519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922566 */     // MIs[1] Operand 1
     /*  922566 */     // No operand predicates
     /*  922566 */     // MIs[0] policy
     /*  922566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922578 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922600 */     GIR_RootConstrainSelectedInstOperands,
     /*  922601 */     // GIR_Coverage, 24211,
     /*  922601 */     GIR_EraseRootFromParent_Done,
     /*  922602 */   // Label 14019: @922602
     /*  922602 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(922690), // Rule ID 24214 //
     /*  922607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922654 */     // MIs[1] Operand 1
     /*  922654 */     // No operand predicates
     /*  922654 */     // MIs[0] policy
     /*  922654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922666 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922688 */     GIR_RootConstrainSelectedInstOperands,
     /*  922689 */     // GIR_Coverage, 24214,
     /*  922689 */     GIR_EraseRootFromParent_Done,
     /*  922690 */   // Label 14020: @922690
     /*  922690 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(922778), // Rule ID 24215 //
     /*  922695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922742 */     // MIs[1] Operand 1
     /*  922742 */     // No operand predicates
     /*  922742 */     // MIs[0] policy
     /*  922742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922754 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922776 */     GIR_RootConstrainSelectedInstOperands,
     /*  922777 */     // GIR_Coverage, 24215,
     /*  922777 */     GIR_EraseRootFromParent_Done,
     /*  922778 */   // Label 14021: @922778
     /*  922778 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(922866), // Rule ID 24218 //
     /*  922783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922830 */     // MIs[1] Operand 1
     /*  922830 */     // No operand predicates
     /*  922830 */     // MIs[0] policy
     /*  922830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922842 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922864 */     GIR_RootConstrainSelectedInstOperands,
     /*  922865 */     // GIR_Coverage, 24218,
     /*  922865 */     GIR_EraseRootFromParent_Done,
     /*  922866 */   // Label 14022: @922866
     /*  922866 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(922954), // Rule ID 24219 //
     /*  922871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922918 */     // MIs[1] Operand 1
     /*  922918 */     // No operand predicates
     /*  922918 */     // MIs[0] policy
     /*  922918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922952 */     GIR_RootConstrainSelectedInstOperands,
     /*  922953 */     // GIR_Coverage, 24219,
     /*  922953 */     GIR_EraseRootFromParent_Done,
     /*  922954 */   // Label 14023: @922954
     /*  922954 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(923042), // Rule ID 24222 //
     /*  922959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  922962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923006 */     // MIs[1] Operand 1
     /*  923006 */     // No operand predicates
     /*  923006 */     // MIs[0] policy
     /*  923006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923018 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  923021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923040 */     GIR_RootConstrainSelectedInstOperands,
     /*  923041 */     // GIR_Coverage, 24222,
     /*  923041 */     GIR_EraseRootFromParent_Done,
     /*  923042 */   // Label 14024: @923042
     /*  923042 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(923130), // Rule ID 24223 //
     /*  923047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923094 */     // MIs[1] Operand 1
     /*  923094 */     // No operand predicates
     /*  923094 */     // MIs[0] policy
     /*  923094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923106 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  923109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923128 */     GIR_RootConstrainSelectedInstOperands,
     /*  923129 */     // GIR_Coverage, 24223,
     /*  923129 */     GIR_EraseRootFromParent_Done,
     /*  923130 */   // Label 14025: @923130
     /*  923130 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(923218), // Rule ID 24226 //
     /*  923135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923182 */     // MIs[1] Operand 1
     /*  923182 */     // No operand predicates
     /*  923182 */     // MIs[0] policy
     /*  923182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923216 */     GIR_RootConstrainSelectedInstOperands,
     /*  923217 */     // GIR_Coverage, 24226,
     /*  923217 */     GIR_EraseRootFromParent_Done,
     /*  923218 */   // Label 14026: @923218
     /*  923218 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(923306), // Rule ID 24227 //
     /*  923223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923270 */     // MIs[1] Operand 1
     /*  923270 */     // No operand predicates
     /*  923270 */     // MIs[0] policy
     /*  923270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923282 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923304 */     GIR_RootConstrainSelectedInstOperands,
     /*  923305 */     // GIR_Coverage, 24227,
     /*  923305 */     GIR_EraseRootFromParent_Done,
     /*  923306 */   // Label 14027: @923306
     /*  923306 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(923394), // Rule ID 24230 //
     /*  923311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  923322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  923325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  923328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923358 */     // MIs[1] Operand 1
     /*  923358 */     // No operand predicates
     /*  923358 */     // MIs[0] policy
     /*  923358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923392 */     GIR_RootConstrainSelectedInstOperands,
     /*  923393 */     // GIR_Coverage, 24230,
     /*  923393 */     GIR_EraseRootFromParent_Done,
     /*  923394 */   // Label 14028: @923394
     /*  923394 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(923482), // Rule ID 24231 //
     /*  923399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  923410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  923413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  923416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923446 */     // MIs[1] Operand 1
     /*  923446 */     // No operand predicates
     /*  923446 */     // MIs[0] policy
     /*  923446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923458 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923480 */     GIR_RootConstrainSelectedInstOperands,
     /*  923481 */     // GIR_Coverage, 24231,
     /*  923481 */     GIR_EraseRootFromParent_Done,
     /*  923482 */   // Label 14029: @923482
     /*  923482 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(923570), // Rule ID 24234 //
     /*  923487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923534 */     // MIs[1] Operand 1
     /*  923534 */     // No operand predicates
     /*  923534 */     // MIs[0] policy
     /*  923534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923546 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923568 */     GIR_RootConstrainSelectedInstOperands,
     /*  923569 */     // GIR_Coverage, 24234,
     /*  923569 */     GIR_EraseRootFromParent_Done,
     /*  923570 */   // Label 14030: @923570
     /*  923570 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(923658), // Rule ID 24235 //
     /*  923575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923622 */     // MIs[1] Operand 1
     /*  923622 */     // No operand predicates
     /*  923622 */     // MIs[0] policy
     /*  923622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923634 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923656 */     GIR_RootConstrainSelectedInstOperands,
     /*  923657 */     // GIR_Coverage, 24235,
     /*  923657 */     GIR_EraseRootFromParent_Done,
     /*  923658 */   // Label 14031: @923658
     /*  923658 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(923746), // Rule ID 24238 //
     /*  923663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923710 */     // MIs[1] Operand 1
     /*  923710 */     // No operand predicates
     /*  923710 */     // MIs[0] policy
     /*  923710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923744 */     GIR_RootConstrainSelectedInstOperands,
     /*  923745 */     // GIR_Coverage, 24238,
     /*  923745 */     GIR_EraseRootFromParent_Done,
     /*  923746 */   // Label 14032: @923746
     /*  923746 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(923834), // Rule ID 24239 //
     /*  923751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923798 */     // MIs[1] Operand 1
     /*  923798 */     // No operand predicates
     /*  923798 */     // MIs[0] policy
     /*  923798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923832 */     GIR_RootConstrainSelectedInstOperands,
     /*  923833 */     // GIR_Coverage, 24239,
     /*  923833 */     GIR_EraseRootFromParent_Done,
     /*  923834 */   // Label 14033: @923834
     /*  923834 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(923922), // Rule ID 24242 //
     /*  923839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923886 */     // MIs[1] Operand 1
     /*  923886 */     // No operand predicates
     /*  923886 */     // MIs[0] policy
     /*  923886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923898 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923920 */     GIR_RootConstrainSelectedInstOperands,
     /*  923921 */     // GIR_Coverage, 24242,
     /*  923921 */     GIR_EraseRootFromParent_Done,
     /*  923922 */   // Label 14034: @923922
     /*  923922 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(924010), // Rule ID 24243 //
     /*  923927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923974 */     // MIs[1] Operand 1
     /*  923974 */     // No operand predicates
     /*  923974 */     // MIs[0] policy
     /*  923974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923986 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924008 */     GIR_RootConstrainSelectedInstOperands,
     /*  924009 */     // GIR_Coverage, 24243,
     /*  924009 */     GIR_EraseRootFromParent_Done,
     /*  924010 */   // Label 14035: @924010
     /*  924010 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(924098), // Rule ID 24246 //
     /*  924015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924062 */     // MIs[1] Operand 1
     /*  924062 */     // No operand predicates
     /*  924062 */     // MIs[0] policy
     /*  924062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924074 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924096 */     GIR_RootConstrainSelectedInstOperands,
     /*  924097 */     // GIR_Coverage, 24246,
     /*  924097 */     GIR_EraseRootFromParent_Done,
     /*  924098 */   // Label 14036: @924098
     /*  924098 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(924186), // Rule ID 24247 //
     /*  924103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924150 */     // MIs[1] Operand 1
     /*  924150 */     // No operand predicates
     /*  924150 */     // MIs[0] policy
     /*  924150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924162 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924184 */     GIR_RootConstrainSelectedInstOperands,
     /*  924185 */     // GIR_Coverage, 24247,
     /*  924185 */     GIR_EraseRootFromParent_Done,
     /*  924186 */   // Label 14037: @924186
     /*  924186 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(924274), // Rule ID 24250 //
     /*  924191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924238 */     // MIs[1] Operand 1
     /*  924238 */     // No operand predicates
     /*  924238 */     // MIs[0] policy
     /*  924238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  924253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924272 */     GIR_RootConstrainSelectedInstOperands,
     /*  924273 */     // GIR_Coverage, 24250,
     /*  924273 */     GIR_EraseRootFromParent_Done,
     /*  924274 */   // Label 14038: @924274
     /*  924274 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(924362), // Rule ID 24251 //
     /*  924279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924326 */     // MIs[1] Operand 1
     /*  924326 */     // No operand predicates
     /*  924326 */     // MIs[0] policy
     /*  924326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924338 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  924341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924360 */     GIR_RootConstrainSelectedInstOperands,
     /*  924361 */     // GIR_Coverage, 24251,
     /*  924361 */     GIR_EraseRootFromParent_Done,
     /*  924362 */   // Label 14039: @924362
     /*  924362 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(924450), // Rule ID 24254 //
     /*  924367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924414 */     // MIs[1] Operand 1
     /*  924414 */     // No operand predicates
     /*  924414 */     // MIs[0] policy
     /*  924414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924426 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924448 */     GIR_RootConstrainSelectedInstOperands,
     /*  924449 */     // GIR_Coverage, 24254,
     /*  924449 */     GIR_EraseRootFromParent_Done,
     /*  924450 */   // Label 14040: @924450
     /*  924450 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(924538), // Rule ID 24255 //
     /*  924455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924502 */     // MIs[1] Operand 1
     /*  924502 */     // No operand predicates
     /*  924502 */     // MIs[0] policy
     /*  924502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924514 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924536 */     GIR_RootConstrainSelectedInstOperands,
     /*  924537 */     // GIR_Coverage, 24255,
     /*  924537 */     GIR_EraseRootFromParent_Done,
     /*  924538 */   // Label 14041: @924538
     /*  924538 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(924626), // Rule ID 24258 //
     /*  924543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924590 */     // MIs[1] Operand 1
     /*  924590 */     // No operand predicates
     /*  924590 */     // MIs[0] policy
     /*  924590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924602 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924624 */     GIR_RootConstrainSelectedInstOperands,
     /*  924625 */     // GIR_Coverage, 24258,
     /*  924625 */     GIR_EraseRootFromParent_Done,
     /*  924626 */   // Label 14042: @924626
     /*  924626 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(924714), // Rule ID 24259 //
     /*  924631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  924634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924678 */     // MIs[1] Operand 1
     /*  924678 */     // No operand predicates
     /*  924678 */     // MIs[0] policy
     /*  924678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924690 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924712 */     GIR_RootConstrainSelectedInstOperands,
     /*  924713 */     // GIR_Coverage, 24259,
     /*  924713 */     GIR_EraseRootFromParent_Done,
     /*  924714 */   // Label 14043: @924714
     /*  924714 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(924802), // Rule ID 24322 //
     /*  924719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924766 */     // MIs[1] Operand 1
     /*  924766 */     // No operand predicates
     /*  924766 */     // MIs[0] policy
     /*  924766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924778 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924800 */     GIR_RootConstrainSelectedInstOperands,
     /*  924801 */     // GIR_Coverage, 24322,
     /*  924801 */     GIR_EraseRootFromParent_Done,
     /*  924802 */   // Label 14044: @924802
     /*  924802 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(924890), // Rule ID 24323 //
     /*  924807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924854 */     // MIs[1] Operand 1
     /*  924854 */     // No operand predicates
     /*  924854 */     // MIs[0] policy
     /*  924854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924866 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924888 */     GIR_RootConstrainSelectedInstOperands,
     /*  924889 */     // GIR_Coverage, 24323,
     /*  924889 */     GIR_EraseRootFromParent_Done,
     /*  924890 */   // Label 14045: @924890
     /*  924890 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(924978), // Rule ID 24326 //
     /*  924895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924942 */     // MIs[1] Operand 1
     /*  924942 */     // No operand predicates
     /*  924942 */     // MIs[0] policy
     /*  924942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924954 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924976 */     GIR_RootConstrainSelectedInstOperands,
     /*  924977 */     // GIR_Coverage, 24326,
     /*  924977 */     GIR_EraseRootFromParent_Done,
     /*  924978 */   // Label 14046: @924978
     /*  924978 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(925066), // Rule ID 24327 //
     /*  924983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925030 */     // MIs[1] Operand 1
     /*  925030 */     // No operand predicates
     /*  925030 */     // MIs[0] policy
     /*  925030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925064 */     GIR_RootConstrainSelectedInstOperands,
     /*  925065 */     // GIR_Coverage, 24327,
     /*  925065 */     GIR_EraseRootFromParent_Done,
     /*  925066 */   // Label 14047: @925066
     /*  925066 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(925154), // Rule ID 24330 //
     /*  925071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925118 */     // MIs[1] Operand 1
     /*  925118 */     // No operand predicates
     /*  925118 */     // MIs[0] policy
     /*  925118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925130 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925152 */     GIR_RootConstrainSelectedInstOperands,
     /*  925153 */     // GIR_Coverage, 24330,
     /*  925153 */     GIR_EraseRootFromParent_Done,
     /*  925154 */   // Label 14048: @925154
     /*  925154 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(925242), // Rule ID 24331 //
     /*  925159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925206 */     // MIs[1] Operand 1
     /*  925206 */     // No operand predicates
     /*  925206 */     // MIs[0] policy
     /*  925206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925218 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  925221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925240 */     GIR_RootConstrainSelectedInstOperands,
     /*  925241 */     // GIR_Coverage, 24331,
     /*  925241 */     GIR_EraseRootFromParent_Done,
     /*  925242 */   // Label 14049: @925242
     /*  925242 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(925330), // Rule ID 24334 //
     /*  925247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  925264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925294 */     // MIs[1] Operand 1
     /*  925294 */     // No operand predicates
     /*  925294 */     // MIs[0] policy
     /*  925294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925306 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925328 */     GIR_RootConstrainSelectedInstOperands,
     /*  925329 */     // GIR_Coverage, 24334,
     /*  925329 */     GIR_EraseRootFromParent_Done,
     /*  925330 */   // Label 14050: @925330
     /*  925330 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(925418), // Rule ID 24335 //
     /*  925335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  925352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925382 */     // MIs[1] Operand 1
     /*  925382 */     // No operand predicates
     /*  925382 */     // MIs[0] policy
     /*  925382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925394 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925416 */     GIR_RootConstrainSelectedInstOperands,
     /*  925417 */     // GIR_Coverage, 24335,
     /*  925417 */     GIR_EraseRootFromParent_Done,
     /*  925418 */   // Label 14051: @925418
     /*  925418 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(925506), // Rule ID 24338 //
     /*  925423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925470 */     // MIs[1] Operand 1
     /*  925470 */     // No operand predicates
     /*  925470 */     // MIs[0] policy
     /*  925470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925482 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925504 */     GIR_RootConstrainSelectedInstOperands,
     /*  925505 */     // GIR_Coverage, 24338,
     /*  925505 */     GIR_EraseRootFromParent_Done,
     /*  925506 */   // Label 14052: @925506
     /*  925506 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(925594), // Rule ID 24339 //
     /*  925511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925558 */     // MIs[1] Operand 1
     /*  925558 */     // No operand predicates
     /*  925558 */     // MIs[0] policy
     /*  925558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925592 */     GIR_RootConstrainSelectedInstOperands,
     /*  925593 */     // GIR_Coverage, 24339,
     /*  925593 */     GIR_EraseRootFromParent_Done,
     /*  925594 */   // Label 14053: @925594
     /*  925594 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(925682), // Rule ID 24342 //
     /*  925599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925646 */     // MIs[1] Operand 1
     /*  925646 */     // No operand predicates
     /*  925646 */     // MIs[0] policy
     /*  925646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925658 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925680 */     GIR_RootConstrainSelectedInstOperands,
     /*  925681 */     // GIR_Coverage, 24342,
     /*  925681 */     GIR_EraseRootFromParent_Done,
     /*  925682 */   // Label 14054: @925682
     /*  925682 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(925770), // Rule ID 24343 //
     /*  925687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925734 */     // MIs[1] Operand 1
     /*  925734 */     // No operand predicates
     /*  925734 */     // MIs[0] policy
     /*  925734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925746 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925768 */     GIR_RootConstrainSelectedInstOperands,
     /*  925769 */     // GIR_Coverage, 24343,
     /*  925769 */     GIR_EraseRootFromParent_Done,
     /*  925770 */   // Label 14055: @925770
     /*  925770 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(925858), // Rule ID 24346 //
     /*  925775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925822 */     // MIs[1] Operand 1
     /*  925822 */     // No operand predicates
     /*  925822 */     // MIs[0] policy
     /*  925822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925834 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925856 */     GIR_RootConstrainSelectedInstOperands,
     /*  925857 */     // GIR_Coverage, 24346,
     /*  925857 */     GIR_EraseRootFromParent_Done,
     /*  925858 */   // Label 14056: @925858
     /*  925858 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(925946), // Rule ID 24347 //
     /*  925863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  925866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925910 */     // MIs[1] Operand 1
     /*  925910 */     // No operand predicates
     /*  925910 */     // MIs[0] policy
     /*  925910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925922 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925944 */     GIR_RootConstrainSelectedInstOperands,
     /*  925945 */     // GIR_Coverage, 24347,
     /*  925945 */     GIR_EraseRootFromParent_Done,
     /*  925946 */   // Label 14057: @925946
     /*  925946 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(926034), // Rule ID 24350 //
     /*  925951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  925954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925998 */     // MIs[1] Operand 1
     /*  925998 */     // No operand predicates
     /*  925998 */     // MIs[0] policy
     /*  925998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926010 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926032 */     GIR_RootConstrainSelectedInstOperands,
     /*  926033 */     // GIR_Coverage, 24350,
     /*  926033 */     GIR_EraseRootFromParent_Done,
     /*  926034 */   // Label 14058: @926034
     /*  926034 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(926122), // Rule ID 24351 //
     /*  926039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926086 */     // MIs[1] Operand 1
     /*  926086 */     // No operand predicates
     /*  926086 */     // MIs[0] policy
     /*  926086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926098 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926120 */     GIR_RootConstrainSelectedInstOperands,
     /*  926121 */     // GIR_Coverage, 24351,
     /*  926121 */     GIR_EraseRootFromParent_Done,
     /*  926122 */   // Label 14059: @926122
     /*  926122 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(926210), // Rule ID 24354 //
     /*  926127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926174 */     // MIs[1] Operand 1
     /*  926174 */     // No operand predicates
     /*  926174 */     // MIs[0] policy
     /*  926174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926186 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926208 */     GIR_RootConstrainSelectedInstOperands,
     /*  926209 */     // GIR_Coverage, 24354,
     /*  926209 */     GIR_EraseRootFromParent_Done,
     /*  926210 */   // Label 14060: @926210
     /*  926210 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(926298), // Rule ID 24355 //
     /*  926215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926262 */     // MIs[1] Operand 1
     /*  926262 */     // No operand predicates
     /*  926262 */     // MIs[0] policy
     /*  926262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926274 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926296 */     GIR_RootConstrainSelectedInstOperands,
     /*  926297 */     // GIR_Coverage, 24355,
     /*  926297 */     GIR_EraseRootFromParent_Done,
     /*  926298 */   // Label 14061: @926298
     /*  926298 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(926386), // Rule ID 24358 //
     /*  926303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926350 */     // MIs[1] Operand 1
     /*  926350 */     // No operand predicates
     /*  926350 */     // MIs[0] policy
     /*  926350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926362 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926384 */     GIR_RootConstrainSelectedInstOperands,
     /*  926385 */     // GIR_Coverage, 24358,
     /*  926385 */     GIR_EraseRootFromParent_Done,
     /*  926386 */   // Label 14062: @926386
     /*  926386 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(926474), // Rule ID 24359 //
     /*  926391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  926402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  926405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  926408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926438 */     // MIs[1] Operand 1
     /*  926438 */     // No operand predicates
     /*  926438 */     // MIs[0] policy
     /*  926438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926472 */     GIR_RootConstrainSelectedInstOperands,
     /*  926473 */     // GIR_Coverage, 24359,
     /*  926473 */     GIR_EraseRootFromParent_Done,
     /*  926474 */   // Label 14063: @926474
     /*  926474 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(926562), // Rule ID 24362 //
     /*  926479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926526 */     // MIs[1] Operand 1
     /*  926526 */     // No operand predicates
     /*  926526 */     // MIs[0] policy
     /*  926526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926538 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926560 */     GIR_RootConstrainSelectedInstOperands,
     /*  926561 */     // GIR_Coverage, 24362,
     /*  926561 */     GIR_EraseRootFromParent_Done,
     /*  926562 */   // Label 14064: @926562
     /*  926562 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(926650), // Rule ID 24363 //
     /*  926567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926614 */     // MIs[1] Operand 1
     /*  926614 */     // No operand predicates
     /*  926614 */     // MIs[0] policy
     /*  926614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926626 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926648 */     GIR_RootConstrainSelectedInstOperands,
     /*  926649 */     // GIR_Coverage, 24363,
     /*  926649 */     GIR_EraseRootFromParent_Done,
     /*  926650 */   // Label 14065: @926650
     /*  926650 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(926738), // Rule ID 24366 //
     /*  926655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926702 */     // MIs[1] Operand 1
     /*  926702 */     // No operand predicates
     /*  926702 */     // MIs[0] policy
     /*  926702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926714 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926736 */     GIR_RootConstrainSelectedInstOperands,
     /*  926737 */     // GIR_Coverage, 24366,
     /*  926737 */     GIR_EraseRootFromParent_Done,
     /*  926738 */   // Label 14066: @926738
     /*  926738 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(926826), // Rule ID 24367 //
     /*  926743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926790 */     // MIs[1] Operand 1
     /*  926790 */     // No operand predicates
     /*  926790 */     // MIs[0] policy
     /*  926790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926824 */     GIR_RootConstrainSelectedInstOperands,
     /*  926825 */     // GIR_Coverage, 24367,
     /*  926825 */     GIR_EraseRootFromParent_Done,
     /*  926826 */   // Label 14067: @926826
     /*  926826 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(926914), // Rule ID 24370 //
     /*  926831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  926834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926878 */     // MIs[1] Operand 1
     /*  926878 */     // No operand predicates
     /*  926878 */     // MIs[0] policy
     /*  926878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926912 */     GIR_RootConstrainSelectedInstOperands,
     /*  926913 */     // GIR_Coverage, 24370,
     /*  926913 */     GIR_EraseRootFromParent_Done,
     /*  926914 */   // Label 14068: @926914
     /*  926914 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(927002), // Rule ID 24371 //
     /*  926919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  926922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926966 */     // MIs[1] Operand 1
     /*  926966 */     // No operand predicates
     /*  926966 */     // MIs[0] policy
     /*  926966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926978 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927000 */     GIR_RootConstrainSelectedInstOperands,
     /*  927001 */     // GIR_Coverage, 24371,
     /*  927001 */     GIR_EraseRootFromParent_Done,
     /*  927002 */   // Label 14069: @927002
     /*  927002 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(927090), // Rule ID 24374 //
     /*  927007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  927010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927054 */     // MIs[1] Operand 1
     /*  927054 */     // No operand predicates
     /*  927054 */     // MIs[0] policy
     /*  927054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927066 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  927069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927088 */     GIR_RootConstrainSelectedInstOperands,
     /*  927089 */     // GIR_Coverage, 24374,
     /*  927089 */     GIR_EraseRootFromParent_Done,
     /*  927090 */   // Label 14070: @927090
     /*  927090 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(927178), // Rule ID 24375 //
     /*  927095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  927098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927142 */     // MIs[1] Operand 1
     /*  927142 */     // No operand predicates
     /*  927142 */     // MIs[0] policy
     /*  927142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927154 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  927157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927176 */     GIR_RootConstrainSelectedInstOperands,
     /*  927177 */     // GIR_Coverage, 24375,
     /*  927177 */     GIR_EraseRootFromParent_Done,
     /*  927178 */   // Label 14071: @927178
     /*  927178 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(927266), // Rule ID 24378 //
     /*  927183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  927186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927230 */     // MIs[1] Operand 1
     /*  927230 */     // No operand predicates
     /*  927230 */     // MIs[0] policy
     /*  927230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927242 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  927245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927264 */     GIR_RootConstrainSelectedInstOperands,
     /*  927265 */     // GIR_Coverage, 24378,
     /*  927265 */     GIR_EraseRootFromParent_Done,
     /*  927266 */   // Label 14072: @927266
     /*  927266 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(927354), // Rule ID 24379 //
     /*  927271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  927274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  927279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927318 */     // MIs[1] Operand 1
     /*  927318 */     // No operand predicates
     /*  927318 */     // MIs[0] policy
     /*  927318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927330 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  927333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927352 */     GIR_RootConstrainSelectedInstOperands,
     /*  927353 */     // GIR_Coverage, 24379,
     /*  927353 */     GIR_EraseRootFromParent_Done,
     /*  927354 */   // Label 14073: @927354
     /*  927354 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(927445), // Rule ID 15990 //
     /*  927359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927406 */     // MIs[1] Operand 1
     /*  927406 */     // No operand predicates
     /*  927406 */     // MIs[0] round
     /*  927406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927443 */     GIR_RootConstrainSelectedInstOperands,
     /*  927444 */     // GIR_Coverage, 15990,
     /*  927444 */     GIR_EraseRootFromParent_Done,
     /*  927445 */   // Label 14074: @927445
     /*  927445 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(927536), // Rule ID 15991 //
     /*  927450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  927461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  927464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927497 */     // MIs[1] Operand 1
     /*  927497 */     // No operand predicates
     /*  927497 */     // MIs[0] round
     /*  927497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927509 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927534 */     GIR_RootConstrainSelectedInstOperands,
     /*  927535 */     // GIR_Coverage, 15991,
     /*  927535 */     GIR_EraseRootFromParent_Done,
     /*  927536 */   // Label 14075: @927536
     /*  927536 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(927627), // Rule ID 15994 //
     /*  927541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927588 */     // MIs[1] Operand 1
     /*  927588 */     // No operand predicates
     /*  927588 */     // MIs[0] round
     /*  927588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927612 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927625 */     GIR_RootConstrainSelectedInstOperands,
     /*  927626 */     // GIR_Coverage, 15994,
     /*  927626 */     GIR_EraseRootFromParent_Done,
     /*  927627 */   // Label 14076: @927627
     /*  927627 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(927718), // Rule ID 15995 //
     /*  927632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927679 */     // MIs[1] Operand 1
     /*  927679 */     // No operand predicates
     /*  927679 */     // MIs[0] round
     /*  927679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927691 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927716 */     GIR_RootConstrainSelectedInstOperands,
     /*  927717 */     // GIR_Coverage, 15995,
     /*  927717 */     GIR_EraseRootFromParent_Done,
     /*  927718 */   // Label 14077: @927718
     /*  927718 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(927809), // Rule ID 15998 //
     /*  927723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927770 */     // MIs[1] Operand 1
     /*  927770 */     // No operand predicates
     /*  927770 */     // MIs[0] round
     /*  927770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927794 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927807 */     GIR_RootConstrainSelectedInstOperands,
     /*  927808 */     // GIR_Coverage, 15998,
     /*  927808 */     GIR_EraseRootFromParent_Done,
     /*  927809 */   // Label 14078: @927809
     /*  927809 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(927900), // Rule ID 15999 //
     /*  927814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927861 */     // MIs[1] Operand 1
     /*  927861 */     // No operand predicates
     /*  927861 */     // MIs[0] round
     /*  927861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927873 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927898 */     GIR_RootConstrainSelectedInstOperands,
     /*  927899 */     // GIR_Coverage, 15999,
     /*  927899 */     GIR_EraseRootFromParent_Done,
     /*  927900 */   // Label 14079: @927900
     /*  927900 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(927991), // Rule ID 16002 //
     /*  927905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927952 */     // MIs[1] Operand 1
     /*  927952 */     // No operand predicates
     /*  927952 */     // MIs[0] round
     /*  927952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927989 */     GIR_RootConstrainSelectedInstOperands,
     /*  927990 */     // GIR_Coverage, 16002,
     /*  927990 */     GIR_EraseRootFromParent_Done,
     /*  927991 */   // Label 14080: @927991
     /*  927991 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(928082), // Rule ID 16003 //
     /*  927996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928043 */     // MIs[1] Operand 1
     /*  928043 */     // No operand predicates
     /*  928043 */     // MIs[0] round
     /*  928043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928055 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  928058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928080 */     GIR_RootConstrainSelectedInstOperands,
     /*  928081 */     // GIR_Coverage, 16003,
     /*  928081 */     GIR_EraseRootFromParent_Done,
     /*  928082 */   // Label 14081: @928082
     /*  928082 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(928173), // Rule ID 16006 //
     /*  928087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928134 */     // MIs[1] Operand 1
     /*  928134 */     // No operand predicates
     /*  928134 */     // MIs[0] round
     /*  928134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928158 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928171 */     GIR_RootConstrainSelectedInstOperands,
     /*  928172 */     // GIR_Coverage, 16006,
     /*  928172 */     GIR_EraseRootFromParent_Done,
     /*  928173 */   // Label 14082: @928173
     /*  928173 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(928264), // Rule ID 16007 //
     /*  928178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928225 */     // MIs[1] Operand 1
     /*  928225 */     // No operand predicates
     /*  928225 */     // MIs[0] round
     /*  928225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928237 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928262 */     GIR_RootConstrainSelectedInstOperands,
     /*  928263 */     // GIR_Coverage, 16007,
     /*  928263 */     GIR_EraseRootFromParent_Done,
     /*  928264 */   // Label 14083: @928264
     /*  928264 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(928355), // Rule ID 16010 //
     /*  928269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928316 */     // MIs[1] Operand 1
     /*  928316 */     // No operand predicates
     /*  928316 */     // MIs[0] round
     /*  928316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928340 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928353 */     GIR_RootConstrainSelectedInstOperands,
     /*  928354 */     // GIR_Coverage, 16010,
     /*  928354 */     GIR_EraseRootFromParent_Done,
     /*  928355 */   // Label 14084: @928355
     /*  928355 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(928446), // Rule ID 16011 //
     /*  928360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928407 */     // MIs[1] Operand 1
     /*  928407 */     // No operand predicates
     /*  928407 */     // MIs[0] round
     /*  928407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  928422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928444 */     GIR_RootConstrainSelectedInstOperands,
     /*  928445 */     // GIR_Coverage, 16011,
     /*  928445 */     GIR_EraseRootFromParent_Done,
     /*  928446 */   // Label 14085: @928446
     /*  928446 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(928537), // Rule ID 16014 //
     /*  928451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928498 */     // MIs[1] Operand 1
     /*  928498 */     // No operand predicates
     /*  928498 */     // MIs[0] round
     /*  928498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928522 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928535 */     GIR_RootConstrainSelectedInstOperands,
     /*  928536 */     // GIR_Coverage, 16014,
     /*  928536 */     GIR_EraseRootFromParent_Done,
     /*  928537 */   // Label 14086: @928537
     /*  928537 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(928628), // Rule ID 16015 //
     /*  928542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928589 */     // MIs[1] Operand 1
     /*  928589 */     // No operand predicates
     /*  928589 */     // MIs[0] round
     /*  928589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928601 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928626 */     GIR_RootConstrainSelectedInstOperands,
     /*  928627 */     // GIR_Coverage, 16015,
     /*  928627 */     GIR_EraseRootFromParent_Done,
     /*  928628 */   // Label 14087: @928628
     /*  928628 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(928719), // Rule ID 16018 //
     /*  928633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928680 */     // MIs[1] Operand 1
     /*  928680 */     // No operand predicates
     /*  928680 */     // MIs[0] round
     /*  928680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928717 */     GIR_RootConstrainSelectedInstOperands,
     /*  928718 */     // GIR_Coverage, 16018,
     /*  928718 */     GIR_EraseRootFromParent_Done,
     /*  928719 */   // Label 14088: @928719
     /*  928719 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(928810), // Rule ID 16019 //
     /*  928724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928771 */     // MIs[1] Operand 1
     /*  928771 */     // No operand predicates
     /*  928771 */     // MIs[0] round
     /*  928771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928808 */     GIR_RootConstrainSelectedInstOperands,
     /*  928809 */     // GIR_Coverage, 16019,
     /*  928809 */     GIR_EraseRootFromParent_Done,
     /*  928810 */   // Label 14089: @928810
     /*  928810 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(928901), // Rule ID 16022 //
     /*  928815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928862 */     // MIs[1] Operand 1
     /*  928862 */     // No operand predicates
     /*  928862 */     // MIs[0] round
     /*  928862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928899 */     GIR_RootConstrainSelectedInstOperands,
     /*  928900 */     // GIR_Coverage, 16022,
     /*  928900 */     GIR_EraseRootFromParent_Done,
     /*  928901 */   // Label 14090: @928901
     /*  928901 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(928992), // Rule ID 16023 //
     /*  928906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928953 */     // MIs[1] Operand 1
     /*  928953 */     // No operand predicates
     /*  928953 */     // MIs[0] round
     /*  928953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928990 */     GIR_RootConstrainSelectedInstOperands,
     /*  928991 */     // GIR_Coverage, 16023,
     /*  928991 */     GIR_EraseRootFromParent_Done,
     /*  928992 */   // Label 14091: @928992
     /*  928992 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(929083), // Rule ID 16026 //
     /*  928997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  929000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929044 */     // MIs[1] Operand 1
     /*  929044 */     // No operand predicates
     /*  929044 */     // MIs[0] round
     /*  929044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  929056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  929059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929081 */     GIR_RootConstrainSelectedInstOperands,
     /*  929082 */     // GIR_Coverage, 16026,
     /*  929082 */     GIR_EraseRootFromParent_Done,
     /*  929083 */   // Label 14092: @929083
     /*  929083 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(929174), // Rule ID 16027 //
     /*  929088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  929091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929135 */     // MIs[1] Operand 1
     /*  929135 */     // No operand predicates
     /*  929135 */     // MIs[0] round
     /*  929135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929147 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  929147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  929150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929172 */     GIR_RootConstrainSelectedInstOperands,
     /*  929173 */     // GIR_Coverage, 16027,
     /*  929173 */     GIR_EraseRootFromParent_Done,
     /*  929174 */   // Label 14093: @929174
     /*  929174 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(929265), // Rule ID 16030 //
     /*  929179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  929190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  929193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  929196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929226 */     // MIs[1] Operand 1
     /*  929226 */     // No operand predicates
     /*  929226 */     // MIs[0] round
     /*  929226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929238 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929263 */     GIR_RootConstrainSelectedInstOperands,
     /*  929264 */     // GIR_Coverage, 16030,
     /*  929264 */     GIR_EraseRootFromParent_Done,
     /*  929265 */   // Label 14094: @929265
     /*  929265 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(929356), // Rule ID 16031 //
     /*  929270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  929281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  929284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  929287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929317 */     // MIs[1] Operand 1
     /*  929317 */     // No operand predicates
     /*  929317 */     // MIs[0] round
     /*  929317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929354 */     GIR_RootConstrainSelectedInstOperands,
     /*  929355 */     // GIR_Coverage, 16031,
     /*  929355 */     GIR_EraseRootFromParent_Done,
     /*  929356 */   // Label 14095: @929356
     /*  929356 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(929447), // Rule ID 16034 //
     /*  929361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  929372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929408 */     // MIs[1] Operand 1
     /*  929408 */     // No operand predicates
     /*  929408 */     // MIs[0] round
     /*  929408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929445 */     GIR_RootConstrainSelectedInstOperands,
     /*  929446 */     // GIR_Coverage, 16034,
     /*  929446 */     GIR_EraseRootFromParent_Done,
     /*  929447 */   // Label 14096: @929447
     /*  929447 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(929538), // Rule ID 16035 //
     /*  929452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  929463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929499 */     // MIs[1] Operand 1
     /*  929499 */     // No operand predicates
     /*  929499 */     // MIs[0] round
     /*  929499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929511 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929536 */     GIR_RootConstrainSelectedInstOperands,
     /*  929537 */     // GIR_Coverage, 16035,
     /*  929537 */     GIR_EraseRootFromParent_Done,
     /*  929538 */   // Label 14097: @929538
     /*  929538 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(929629), // Rule ID 16038 //
     /*  929543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929590 */     // MIs[1] Operand 1
     /*  929590 */     // No operand predicates
     /*  929590 */     // MIs[0] round
     /*  929590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929627 */     GIR_RootConstrainSelectedInstOperands,
     /*  929628 */     // GIR_Coverage, 16038,
     /*  929628 */     GIR_EraseRootFromParent_Done,
     /*  929629 */   // Label 14098: @929629
     /*  929629 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(929720), // Rule ID 16039 //
     /*  929634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929681 */     // MIs[1] Operand 1
     /*  929681 */     // No operand predicates
     /*  929681 */     // MIs[0] round
     /*  929681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929693 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929718 */     GIR_RootConstrainSelectedInstOperands,
     /*  929719 */     // GIR_Coverage, 16039,
     /*  929719 */     GIR_EraseRootFromParent_Done,
     /*  929720 */   // Label 14099: @929720
     /*  929720 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(929811), // Rule ID 16042 //
     /*  929725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929772 */     // MIs[1] Operand 1
     /*  929772 */     // No operand predicates
     /*  929772 */     // MIs[0] round
     /*  929772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929809 */     GIR_RootConstrainSelectedInstOperands,
     /*  929810 */     // GIR_Coverage, 16042,
     /*  929810 */     GIR_EraseRootFromParent_Done,
     /*  929811 */   // Label 14100: @929811
     /*  929811 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(929902), // Rule ID 16043 //
     /*  929816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929863 */     // MIs[1] Operand 1
     /*  929863 */     // No operand predicates
     /*  929863 */     // MIs[0] round
     /*  929863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929900 */     GIR_RootConstrainSelectedInstOperands,
     /*  929901 */     // GIR_Coverage, 16043,
     /*  929901 */     GIR_EraseRootFromParent_Done,
     /*  929902 */   // Label 14101: @929902
     /*  929902 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(929993), // Rule ID 16046 //
     /*  929907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929954 */     // MIs[1] Operand 1
     /*  929954 */     // No operand predicates
     /*  929954 */     // MIs[0] round
     /*  929954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929991 */     GIR_RootConstrainSelectedInstOperands,
     /*  929992 */     // GIR_Coverage, 16046,
     /*  929992 */     GIR_EraseRootFromParent_Done,
     /*  929993 */   // Label 14102: @929993
     /*  929993 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(930084), // Rule ID 16047 //
     /*  929998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  930009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  930012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  930015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930045 */     // MIs[1] Operand 1
     /*  930045 */     // No operand predicates
     /*  930045 */     // MIs[0] round
     /*  930045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930057 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  930057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930082 */     GIR_RootConstrainSelectedInstOperands,
     /*  930083 */     // GIR_Coverage, 16047,
     /*  930083 */     GIR_EraseRootFromParent_Done,
     /*  930084 */   // Label 14103: @930084
     /*  930084 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(930175), // Rule ID 16050 //
     /*  930089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  930100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  930103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  930106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930136 */     // MIs[1] Operand 1
     /*  930136 */     // No operand predicates
     /*  930136 */     // MIs[0] round
     /*  930136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  930148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930173 */     GIR_RootConstrainSelectedInstOperands,
     /*  930174 */     // GIR_Coverage, 16050,
     /*  930174 */     GIR_EraseRootFromParent_Done,
     /*  930175 */   // Label 14104: @930175
     /*  930175 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(930266), // Rule ID 16051 //
     /*  930180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  930191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  930194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  930197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930227 */     // MIs[1] Operand 1
     /*  930227 */     // No operand predicates
     /*  930227 */     // MIs[0] round
     /*  930227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930239 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  930239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  930261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930264 */     GIR_RootConstrainSelectedInstOperands,
     /*  930265 */     // GIR_Coverage, 16051,
     /*  930265 */     GIR_EraseRootFromParent_Done,
     /*  930266 */   // Label 14105: @930266
     /*  930266 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(930357), // Rule ID 16054 //
     /*  930271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  930282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  930285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  930288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930318 */     // MIs[1] Operand 1
     /*  930318 */     // No operand predicates
     /*  930318 */     // MIs[0] round
     /*  930318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930342 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930355 */     GIR_RootConstrainSelectedInstOperands,
     /*  930356 */     // GIR_Coverage, 16054,
     /*  930356 */     GIR_EraseRootFromParent_Done,
     /*  930357 */   // Label 14106: @930357
     /*  930357 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(930448), // Rule ID 16055 //
     /*  930362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  930373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  930376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  930379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930409 */     // MIs[1] Operand 1
     /*  930409 */     // No operand predicates
     /*  930409 */     // MIs[0] round
     /*  930409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930446 */     GIR_RootConstrainSelectedInstOperands,
     /*  930447 */     // GIR_Coverage, 16055,
     /*  930447 */     GIR_EraseRootFromParent_Done,
     /*  930448 */   // Label 14107: @930448
     /*  930448 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(930539), // Rule ID 16058 //
     /*  930453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930500 */     // MIs[1] Operand 1
     /*  930500 */     // No operand predicates
     /*  930500 */     // MIs[0] round
     /*  930500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930524 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930537 */     GIR_RootConstrainSelectedInstOperands,
     /*  930538 */     // GIR_Coverage, 16058,
     /*  930538 */     GIR_EraseRootFromParent_Done,
     /*  930539 */   // Label 14108: @930539
     /*  930539 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(930630), // Rule ID 16059 //
     /*  930544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930591 */     // MIs[1] Operand 1
     /*  930591 */     // No operand predicates
     /*  930591 */     // MIs[0] round
     /*  930591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930628 */     GIR_RootConstrainSelectedInstOperands,
     /*  930629 */     // GIR_Coverage, 16059,
     /*  930629 */     GIR_EraseRootFromParent_Done,
     /*  930630 */   // Label 14109: @930630
     /*  930630 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(930721), // Rule ID 16062 //
     /*  930635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930682 */     // MIs[1] Operand 1
     /*  930682 */     // No operand predicates
     /*  930682 */     // MIs[0] round
     /*  930682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930719 */     GIR_RootConstrainSelectedInstOperands,
     /*  930720 */     // GIR_Coverage, 16062,
     /*  930720 */     GIR_EraseRootFromParent_Done,
     /*  930721 */   // Label 14110: @930721
     /*  930721 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(930812), // Rule ID 16063 //
     /*  930726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930773 */     // MIs[1] Operand 1
     /*  930773 */     // No operand predicates
     /*  930773 */     // MIs[0] round
     /*  930773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930785 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930810 */     GIR_RootConstrainSelectedInstOperands,
     /*  930811 */     // GIR_Coverage, 16063,
     /*  930811 */     GIR_EraseRootFromParent_Done,
     /*  930812 */   // Label 14111: @930812
     /*  930812 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(930903), // Rule ID 16066 //
     /*  930817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930864 */     // MIs[1] Operand 1
     /*  930864 */     // No operand predicates
     /*  930864 */     // MIs[0] round
     /*  930864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930888 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930901 */     GIR_RootConstrainSelectedInstOperands,
     /*  930902 */     // GIR_Coverage, 16066,
     /*  930902 */     GIR_EraseRootFromParent_Done,
     /*  930903 */   // Label 14112: @930903
     /*  930903 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(930994), // Rule ID 16067 //
     /*  930908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930955 */     // MIs[1] Operand 1
     /*  930955 */     // No operand predicates
     /*  930955 */     // MIs[0] round
     /*  930955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930967 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930992 */     GIR_RootConstrainSelectedInstOperands,
     /*  930993 */     // GIR_Coverage, 16067,
     /*  930993 */     GIR_EraseRootFromParent_Done,
     /*  930994 */   // Label 14113: @930994
     /*  930994 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(931085), // Rule ID 16070 //
     /*  930999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  931002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  931010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  931013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  931016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931046 */     // MIs[1] Operand 1
     /*  931046 */     // No operand predicates
     /*  931046 */     // MIs[0] round
     /*  931046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  931058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  931061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931083 */     GIR_RootConstrainSelectedInstOperands,
     /*  931084 */     // GIR_Coverage, 16070,
     /*  931084 */     GIR_EraseRootFromParent_Done,
     /*  931085 */   // Label 14114: @931085
     /*  931085 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(931176), // Rule ID 16071 //
     /*  931090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  931093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  931101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  931104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  931107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  931125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931137 */     // MIs[1] Operand 1
     /*  931137 */     // No operand predicates
     /*  931137 */     // MIs[0] round
     /*  931137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  931149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  931152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931174 */     GIR_RootConstrainSelectedInstOperands,
     /*  931175 */     // GIR_Coverage, 16071,
     /*  931175 */     GIR_EraseRootFromParent_Done,
     /*  931176 */   // Label 14115: @931176
     /*  931176 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(931267), // Rule ID 16074 //
     /*  931181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  931184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  931192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  931195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  931198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931228 */     // MIs[1] Operand 1
     /*  931228 */     // No operand predicates
     /*  931228 */     // MIs[0] round
     /*  931228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931240 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  931240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  931243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931265 */     GIR_RootConstrainSelectedInstOperands,
     /*  931266 */     // GIR_Coverage, 16074,
     /*  931266 */     GIR_EraseRootFromParent_Done,
     /*  931267 */   // Label 14116: @931267
     /*  931267 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(931358), // Rule ID 16075 //
     /*  931272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  931275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  931283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  931286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  931289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  931307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931319 */     // MIs[1] Operand 1
     /*  931319 */     // No operand predicates
     /*  931319 */     // MIs[0] round
     /*  931319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  931331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  931334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  931353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931356 */     GIR_RootConstrainSelectedInstOperands,
     /*  931357 */     // GIR_Coverage, 16075,
     /*  931357 */     GIR_EraseRootFromParent_Done,
     /*  931358 */   // Label 14117: @931358
     /*  931358 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(931449), // Rule ID 16254 //
     /*  931363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  931374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931410 */     // MIs[1] Operand 1
     /*  931410 */     // No operand predicates
     /*  931410 */     // MIs[0] round
     /*  931410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931447 */     GIR_RootConstrainSelectedInstOperands,
     /*  931448 */     // GIR_Coverage, 16254,
     /*  931448 */     GIR_EraseRootFromParent_Done,
     /*  931449 */   // Label 14118: @931449
     /*  931449 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(931540), // Rule ID 16255 //
     /*  931454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  931465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931501 */     // MIs[1] Operand 1
     /*  931501 */     // No operand predicates
     /*  931501 */     // MIs[0] round
     /*  931501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931513 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931538 */     GIR_RootConstrainSelectedInstOperands,
     /*  931539 */     // GIR_Coverage, 16255,
     /*  931539 */     GIR_EraseRootFromParent_Done,
     /*  931540 */   // Label 14119: @931540
     /*  931540 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(931631), // Rule ID 16258 //
     /*  931545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931592 */     // MIs[1] Operand 1
     /*  931592 */     // No operand predicates
     /*  931592 */     // MIs[0] round
     /*  931592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931629 */     GIR_RootConstrainSelectedInstOperands,
     /*  931630 */     // GIR_Coverage, 16258,
     /*  931630 */     GIR_EraseRootFromParent_Done,
     /*  931631 */   // Label 14120: @931631
     /*  931631 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(931722), // Rule ID 16259 //
     /*  931636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931683 */     // MIs[1] Operand 1
     /*  931683 */     // No operand predicates
     /*  931683 */     // MIs[0] round
     /*  931683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931695 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931720 */     GIR_RootConstrainSelectedInstOperands,
     /*  931721 */     // GIR_Coverage, 16259,
     /*  931721 */     GIR_EraseRootFromParent_Done,
     /*  931722 */   // Label 14121: @931722
     /*  931722 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(931813), // Rule ID 16262 //
     /*  931727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931774 */     // MIs[1] Operand 1
     /*  931774 */     // No operand predicates
     /*  931774 */     // MIs[0] round
     /*  931774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931811 */     GIR_RootConstrainSelectedInstOperands,
     /*  931812 */     // GIR_Coverage, 16262,
     /*  931812 */     GIR_EraseRootFromParent_Done,
     /*  931813 */   // Label 14122: @931813
     /*  931813 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(931904), // Rule ID 16263 //
     /*  931818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931865 */     // MIs[1] Operand 1
     /*  931865 */     // No operand predicates
     /*  931865 */     // MIs[0] round
     /*  931865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931877 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931902 */     GIR_RootConstrainSelectedInstOperands,
     /*  931903 */     // GIR_Coverage, 16263,
     /*  931903 */     GIR_EraseRootFromParent_Done,
     /*  931904 */   // Label 14123: @931904
     /*  931904 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(931995), // Rule ID 16266 //
     /*  931909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931956 */     // MIs[1] Operand 1
     /*  931956 */     // No operand predicates
     /*  931956 */     // MIs[0] round
     /*  931956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931993 */     GIR_RootConstrainSelectedInstOperands,
     /*  931994 */     // GIR_Coverage, 16266,
     /*  931994 */     GIR_EraseRootFromParent_Done,
     /*  931995 */   // Label 14124: @931995
     /*  931995 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(932086), // Rule ID 16267 //
     /*  932000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  932011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  932014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  932017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932047 */     // MIs[1] Operand 1
     /*  932047 */     // No operand predicates
     /*  932047 */     // MIs[0] round
     /*  932047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  932062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932084 */     GIR_RootConstrainSelectedInstOperands,
     /*  932085 */     // GIR_Coverage, 16267,
     /*  932085 */     GIR_EraseRootFromParent_Done,
     /*  932086 */   // Label 14125: @932086
     /*  932086 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(932177), // Rule ID 16270 //
     /*  932091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  932102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  932105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  932108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932138 */     // MIs[1] Operand 1
     /*  932138 */     // No operand predicates
     /*  932138 */     // MIs[0] round
     /*  932138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932162 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932175 */     GIR_RootConstrainSelectedInstOperands,
     /*  932176 */     // GIR_Coverage, 16270,
     /*  932176 */     GIR_EraseRootFromParent_Done,
     /*  932177 */   // Label 14126: @932177
     /*  932177 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(932268), // Rule ID 16271 //
     /*  932182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  932193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  932196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  932199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932229 */     // MIs[1] Operand 1
     /*  932229 */     // No operand predicates
     /*  932229 */     // MIs[0] round
     /*  932229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932266 */     GIR_RootConstrainSelectedInstOperands,
     /*  932267 */     // GIR_Coverage, 16271,
     /*  932267 */     GIR_EraseRootFromParent_Done,
     /*  932268 */   // Label 14127: @932268
     /*  932268 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(932359), // Rule ID 16274 //
     /*  932273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  932284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  932287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  932290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932320 */     // MIs[1] Operand 1
     /*  932320 */     // No operand predicates
     /*  932320 */     // MIs[0] round
     /*  932320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932344 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932357 */     GIR_RootConstrainSelectedInstOperands,
     /*  932358 */     // GIR_Coverage, 16274,
     /*  932358 */     GIR_EraseRootFromParent_Done,
     /*  932359 */   // Label 14128: @932359
     /*  932359 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(932450), // Rule ID 16275 //
     /*  932364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  932375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  932378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  932381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932411 */     // MIs[1] Operand 1
     /*  932411 */     // No operand predicates
     /*  932411 */     // MIs[0] round
     /*  932411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932423 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  932426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932448 */     GIR_RootConstrainSelectedInstOperands,
     /*  932449 */     // GIR_Coverage, 16275,
     /*  932449 */     GIR_EraseRootFromParent_Done,
     /*  932450 */   // Label 14129: @932450
     /*  932450 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(932541), // Rule ID 16278 //
     /*  932455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932502 */     // MIs[1] Operand 1
     /*  932502 */     // No operand predicates
     /*  932502 */     // MIs[0] round
     /*  932502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932526 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932539 */     GIR_RootConstrainSelectedInstOperands,
     /*  932540 */     // GIR_Coverage, 16278,
     /*  932540 */     GIR_EraseRootFromParent_Done,
     /*  932541 */   // Label 14130: @932541
     /*  932541 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(932632), // Rule ID 16279 //
     /*  932546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932593 */     // MIs[1] Operand 1
     /*  932593 */     // No operand predicates
     /*  932593 */     // MIs[0] round
     /*  932593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932605 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932630 */     GIR_RootConstrainSelectedInstOperands,
     /*  932631 */     // GIR_Coverage, 16279,
     /*  932631 */     GIR_EraseRootFromParent_Done,
     /*  932632 */   // Label 14131: @932632
     /*  932632 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(932723), // Rule ID 16282 //
     /*  932637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932684 */     // MIs[1] Operand 1
     /*  932684 */     // No operand predicates
     /*  932684 */     // MIs[0] round
     /*  932684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932708 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932721 */     GIR_RootConstrainSelectedInstOperands,
     /*  932722 */     // GIR_Coverage, 16282,
     /*  932722 */     GIR_EraseRootFromParent_Done,
     /*  932723 */   // Label 14132: @932723
     /*  932723 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(932814), // Rule ID 16283 //
     /*  932728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932775 */     // MIs[1] Operand 1
     /*  932775 */     // No operand predicates
     /*  932775 */     // MIs[0] round
     /*  932775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932787 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932812 */     GIR_RootConstrainSelectedInstOperands,
     /*  932813 */     // GIR_Coverage, 16283,
     /*  932813 */     GIR_EraseRootFromParent_Done,
     /*  932814 */   // Label 14133: @932814
     /*  932814 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(932905), // Rule ID 16286 //
     /*  932819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932866 */     // MIs[1] Operand 1
     /*  932866 */     // No operand predicates
     /*  932866 */     // MIs[0] round
     /*  932866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932903 */     GIR_RootConstrainSelectedInstOperands,
     /*  932904 */     // GIR_Coverage, 16286,
     /*  932904 */     GIR_EraseRootFromParent_Done,
     /*  932905 */   // Label 14134: @932905
     /*  932905 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(932996), // Rule ID 16287 //
     /*  932910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932957 */     // MIs[1] Operand 1
     /*  932957 */     // No operand predicates
     /*  932957 */     // MIs[0] round
     /*  932957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932969 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932994 */     GIR_RootConstrainSelectedInstOperands,
     /*  932995 */     // GIR_Coverage, 16287,
     /*  932995 */     GIR_EraseRootFromParent_Done,
     /*  932996 */   // Label 14135: @932996
     /*  932996 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(933087), // Rule ID 16290 //
     /*  933001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  933012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  933015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  933018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933048 */     // MIs[1] Operand 1
     /*  933048 */     // No operand predicates
     /*  933048 */     // MIs[0] round
     /*  933048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933060 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  933060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  933063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933085 */     GIR_RootConstrainSelectedInstOperands,
     /*  933086 */     // GIR_Coverage, 16290,
     /*  933086 */     GIR_EraseRootFromParent_Done,
     /*  933087 */   // Label 14136: @933087
     /*  933087 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(933178), // Rule ID 16291 //
     /*  933092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  933103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  933106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  933109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  933127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933139 */     // MIs[1] Operand 1
     /*  933139 */     // No operand predicates
     /*  933139 */     // MIs[0] round
     /*  933139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933151 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  933151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  933154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933176 */     GIR_RootConstrainSelectedInstOperands,
     /*  933177 */     // GIR_Coverage, 16291,
     /*  933177 */     GIR_EraseRootFromParent_Done,
     /*  933178 */   // Label 14137: @933178
     /*  933178 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(933269), // Rule ID 16294 //
     /*  933183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  933194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  933197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  933200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933230 */     // MIs[1] Operand 1
     /*  933230 */     // No operand predicates
     /*  933230 */     // MIs[0] round
     /*  933230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933267 */     GIR_RootConstrainSelectedInstOperands,
     /*  933268 */     // GIR_Coverage, 16294,
     /*  933268 */     GIR_EraseRootFromParent_Done,
     /*  933269 */   // Label 14138: @933269
     /*  933269 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(933360), // Rule ID 16295 //
     /*  933274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  933285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  933288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  933291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933321 */     // MIs[1] Operand 1
     /*  933321 */     // No operand predicates
     /*  933321 */     // MIs[0] round
     /*  933321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933333 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933358 */     GIR_RootConstrainSelectedInstOperands,
     /*  933359 */     // GIR_Coverage, 16295,
     /*  933359 */     GIR_EraseRootFromParent_Done,
     /*  933360 */   // Label 14139: @933360
     /*  933360 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(933451), // Rule ID 16298 //
     /*  933365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933412 */     // MIs[1] Operand 1
     /*  933412 */     // No operand predicates
     /*  933412 */     // MIs[0] round
     /*  933412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933424 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933449 */     GIR_RootConstrainSelectedInstOperands,
     /*  933450 */     // GIR_Coverage, 16298,
     /*  933450 */     GIR_EraseRootFromParent_Done,
     /*  933451 */   // Label 14140: @933451
     /*  933451 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(933542), // Rule ID 16299 //
     /*  933456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933503 */     // MIs[1] Operand 1
     /*  933503 */     // No operand predicates
     /*  933503 */     // MIs[0] round
     /*  933503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933515 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933540 */     GIR_RootConstrainSelectedInstOperands,
     /*  933541 */     // GIR_Coverage, 16299,
     /*  933541 */     GIR_EraseRootFromParent_Done,
     /*  933542 */   // Label 14141: @933542
     /*  933542 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(933633), // Rule ID 16302 //
     /*  933547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933594 */     // MIs[1] Operand 1
     /*  933594 */     // No operand predicates
     /*  933594 */     // MIs[0] round
     /*  933594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933606 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933631 */     GIR_RootConstrainSelectedInstOperands,
     /*  933632 */     // GIR_Coverage, 16302,
     /*  933632 */     GIR_EraseRootFromParent_Done,
     /*  933633 */   // Label 14142: @933633
     /*  933633 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(933724), // Rule ID 16303 //
     /*  933638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933685 */     // MIs[1] Operand 1
     /*  933685 */     // No operand predicates
     /*  933685 */     // MIs[0] round
     /*  933685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933697 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933722 */     GIR_RootConstrainSelectedInstOperands,
     /*  933723 */     // GIR_Coverage, 16303,
     /*  933723 */     GIR_EraseRootFromParent_Done,
     /*  933724 */   // Label 14143: @933724
     /*  933724 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(933815), // Rule ID 16306 //
     /*  933729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933776 */     // MIs[1] Operand 1
     /*  933776 */     // No operand predicates
     /*  933776 */     // MIs[0] round
     /*  933776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933813 */     GIR_RootConstrainSelectedInstOperands,
     /*  933814 */     // GIR_Coverage, 16306,
     /*  933814 */     GIR_EraseRootFromParent_Done,
     /*  933815 */   // Label 14144: @933815
     /*  933815 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(933906), // Rule ID 16307 //
     /*  933820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933867 */     // MIs[1] Operand 1
     /*  933867 */     // No operand predicates
     /*  933867 */     // MIs[0] round
     /*  933867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933904 */     GIR_RootConstrainSelectedInstOperands,
     /*  933905 */     // GIR_Coverage, 16307,
     /*  933905 */     GIR_EraseRootFromParent_Done,
     /*  933906 */   // Label 14145: @933906
     /*  933906 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(933997), // Rule ID 16310 //
     /*  933911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933958 */     // MIs[1] Operand 1
     /*  933958 */     // No operand predicates
     /*  933958 */     // MIs[0] round
     /*  933958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933995 */     GIR_RootConstrainSelectedInstOperands,
     /*  933996 */     // GIR_Coverage, 16310,
     /*  933996 */     GIR_EraseRootFromParent_Done,
     /*  933997 */   // Label 14146: @933997
     /*  933997 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(934088), // Rule ID 16311 //
     /*  934002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  934013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  934016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  934019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934049 */     // MIs[1] Operand 1
     /*  934049 */     // No operand predicates
     /*  934049 */     // MIs[0] round
     /*  934049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934061 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  934061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934086 */     GIR_RootConstrainSelectedInstOperands,
     /*  934087 */     // GIR_Coverage, 16311,
     /*  934087 */     GIR_EraseRootFromParent_Done,
     /*  934088 */   // Label 14147: @934088
     /*  934088 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(934179), // Rule ID 16314 //
     /*  934093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  934104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  934107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  934110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934140 */     // MIs[1] Operand 1
     /*  934140 */     // No operand predicates
     /*  934140 */     // MIs[0] round
     /*  934140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  934152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934177 */     GIR_RootConstrainSelectedInstOperands,
     /*  934178 */     // GIR_Coverage, 16314,
     /*  934178 */     GIR_EraseRootFromParent_Done,
     /*  934179 */   // Label 14148: @934179
     /*  934179 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(934270), // Rule ID 16315 //
     /*  934184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  934195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  934198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  934201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934231 */     // MIs[1] Operand 1
     /*  934231 */     // No operand predicates
     /*  934231 */     // MIs[0] round
     /*  934231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  934243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  934265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934268 */     GIR_RootConstrainSelectedInstOperands,
     /*  934269 */     // GIR_Coverage, 16315,
     /*  934269 */     GIR_EraseRootFromParent_Done,
     /*  934270 */   // Label 14149: @934270
     /*  934270 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(934361), // Rule ID 16318 //
     /*  934275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  934286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  934289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  934292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934322 */     // MIs[1] Operand 1
     /*  934322 */     // No operand predicates
     /*  934322 */     // MIs[0] round
     /*  934322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934346 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934359 */     GIR_RootConstrainSelectedInstOperands,
     /*  934360 */     // GIR_Coverage, 16318,
     /*  934360 */     GIR_EraseRootFromParent_Done,
     /*  934361 */   // Label 14150: @934361
     /*  934361 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(934452), // Rule ID 16319 //
     /*  934366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  934377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  934380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  934383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934413 */     // MIs[1] Operand 1
     /*  934413 */     // No operand predicates
     /*  934413 */     // MIs[0] round
     /*  934413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934450 */     GIR_RootConstrainSelectedInstOperands,
     /*  934451 */     // GIR_Coverage, 16319,
     /*  934451 */     GIR_EraseRootFromParent_Done,
     /*  934452 */   // Label 14151: @934452
     /*  934452 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(934543), // Rule ID 16322 //
     /*  934457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934504 */     // MIs[1] Operand 1
     /*  934504 */     // No operand predicates
     /*  934504 */     // MIs[0] round
     /*  934504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934541 */     GIR_RootConstrainSelectedInstOperands,
     /*  934542 */     // GIR_Coverage, 16322,
     /*  934542 */     GIR_EraseRootFromParent_Done,
     /*  934543 */   // Label 14152: @934543
     /*  934543 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(934634), // Rule ID 16323 //
     /*  934548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934595 */     // MIs[1] Operand 1
     /*  934595 */     // No operand predicates
     /*  934595 */     // MIs[0] round
     /*  934595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934607 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934632 */     GIR_RootConstrainSelectedInstOperands,
     /*  934633 */     // GIR_Coverage, 16323,
     /*  934633 */     GIR_EraseRootFromParent_Done,
     /*  934634 */   // Label 14153: @934634
     /*  934634 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(934725), // Rule ID 16326 //
     /*  934639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934686 */     // MIs[1] Operand 1
     /*  934686 */     // No operand predicates
     /*  934686 */     // MIs[0] round
     /*  934686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934723 */     GIR_RootConstrainSelectedInstOperands,
     /*  934724 */     // GIR_Coverage, 16326,
     /*  934724 */     GIR_EraseRootFromParent_Done,
     /*  934725 */   // Label 14154: @934725
     /*  934725 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(934816), // Rule ID 16327 //
     /*  934730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934777 */     // MIs[1] Operand 1
     /*  934777 */     // No operand predicates
     /*  934777 */     // MIs[0] round
     /*  934777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934814 */     GIR_RootConstrainSelectedInstOperands,
     /*  934815 */     // GIR_Coverage, 16327,
     /*  934815 */     GIR_EraseRootFromParent_Done,
     /*  934816 */   // Label 14155: @934816
     /*  934816 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(934907), // Rule ID 16330 //
     /*  934821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934868 */     // MIs[1] Operand 1
     /*  934868 */     // No operand predicates
     /*  934868 */     // MIs[0] round
     /*  934868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934905 */     GIR_RootConstrainSelectedInstOperands,
     /*  934906 */     // GIR_Coverage, 16330,
     /*  934906 */     GIR_EraseRootFromParent_Done,
     /*  934907 */   // Label 14156: @934907
     /*  934907 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(934998), // Rule ID 16331 //
     /*  934912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934959 */     // MIs[1] Operand 1
     /*  934959 */     // No operand predicates
     /*  934959 */     // MIs[0] round
     /*  934959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934996 */     GIR_RootConstrainSelectedInstOperands,
     /*  934997 */     // GIR_Coverage, 16331,
     /*  934997 */     GIR_EraseRootFromParent_Done,
     /*  934998 */   // Label 14157: @934998
     /*  934998 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(935089), // Rule ID 16334 //
     /*  935003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  935006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  935014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  935017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  935020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935050 */     // MIs[1] Operand 1
     /*  935050 */     // No operand predicates
     /*  935050 */     // MIs[0] round
     /*  935050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  935062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  935065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935087 */     GIR_RootConstrainSelectedInstOperands,
     /*  935088 */     // GIR_Coverage, 16334,
     /*  935088 */     GIR_EraseRootFromParent_Done,
     /*  935089 */   // Label 14158: @935089
     /*  935089 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(935180), // Rule ID 16335 //
     /*  935094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  935097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  935105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  935108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  935111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935141 */     // MIs[1] Operand 1
     /*  935141 */     // No operand predicates
     /*  935141 */     // MIs[0] round
     /*  935141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  935153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  935156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935178 */     GIR_RootConstrainSelectedInstOperands,
     /*  935179 */     // GIR_Coverage, 16335,
     /*  935179 */     GIR_EraseRootFromParent_Done,
     /*  935180 */   // Label 14159: @935180
     /*  935180 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(935271), // Rule ID 16338 //
     /*  935185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  935188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  935196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  935199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  935202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935232 */     // MIs[1] Operand 1
     /*  935232 */     // No operand predicates
     /*  935232 */     // MIs[0] round
     /*  935232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  935244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  935247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935269 */     GIR_RootConstrainSelectedInstOperands,
     /*  935270 */     // GIR_Coverage, 16338,
     /*  935270 */     GIR_EraseRootFromParent_Done,
     /*  935271 */   // Label 14160: @935271
     /*  935271 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(935362), // Rule ID 16339 //
     /*  935276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  935279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  935287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  935290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  935293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935323 */     // MIs[1] Operand 1
     /*  935323 */     // No operand predicates
     /*  935323 */     // MIs[0] round
     /*  935323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935335 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  935335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  935338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  935357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935360 */     GIR_RootConstrainSelectedInstOperands,
     /*  935361 */     // GIR_Coverage, 16339,
     /*  935361 */     GIR_EraseRootFromParent_Done,
     /*  935362 */   // Label 14161: @935362
     /*  935362 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(935456), // Rule ID 16462 //
     /*  935367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935414 */     // MIs[1] Operand 1
     /*  935414 */     // No operand predicates
     /*  935414 */     // MIs[0] round
     /*  935414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935454 */     GIR_RootConstrainSelectedInstOperands,
     /*  935455 */     // GIR_Coverage, 16462,
     /*  935455 */     GIR_EraseRootFromParent_Done,
     /*  935456 */   // Label 14162: @935456
     /*  935456 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(935550), // Rule ID 16463 //
     /*  935461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935508 */     // MIs[1] Operand 1
     /*  935508 */     // No operand predicates
     /*  935508 */     // MIs[0] round
     /*  935508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935548 */     GIR_RootConstrainSelectedInstOperands,
     /*  935549 */     // GIR_Coverage, 16463,
     /*  935549 */     GIR_EraseRootFromParent_Done,
     /*  935550 */   // Label 14163: @935550
     /*  935550 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(935644), // Rule ID 16466 //
     /*  935555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935602 */     // MIs[1] Operand 1
     /*  935602 */     // No operand predicates
     /*  935602 */     // MIs[0] round
     /*  935602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935642 */     GIR_RootConstrainSelectedInstOperands,
     /*  935643 */     // GIR_Coverage, 16466,
     /*  935643 */     GIR_EraseRootFromParent_Done,
     /*  935644 */   // Label 14164: @935644
     /*  935644 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(935738), // Rule ID 16467 //
     /*  935649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935696 */     // MIs[1] Operand 1
     /*  935696 */     // No operand predicates
     /*  935696 */     // MIs[0] round
     /*  935696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935736 */     GIR_RootConstrainSelectedInstOperands,
     /*  935737 */     // GIR_Coverage, 16467,
     /*  935737 */     GIR_EraseRootFromParent_Done,
     /*  935738 */   // Label 14165: @935738
     /*  935738 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(935832), // Rule ID 16470 //
     /*  935743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935790 */     // MIs[1] Operand 1
     /*  935790 */     // No operand predicates
     /*  935790 */     // MIs[0] round
     /*  935790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935830 */     GIR_RootConstrainSelectedInstOperands,
     /*  935831 */     // GIR_Coverage, 16470,
     /*  935831 */     GIR_EraseRootFromParent_Done,
     /*  935832 */   // Label 14166: @935832
     /*  935832 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(935926), // Rule ID 16471 //
     /*  935837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935884 */     // MIs[1] Operand 1
     /*  935884 */     // No operand predicates
     /*  935884 */     // MIs[0] round
     /*  935884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935924 */     GIR_RootConstrainSelectedInstOperands,
     /*  935925 */     // GIR_Coverage, 16471,
     /*  935925 */     GIR_EraseRootFromParent_Done,
     /*  935926 */   // Label 14167: @935926
     /*  935926 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(936020), // Rule ID 16474 //
     /*  935931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935978 */     // MIs[1] Operand 1
     /*  935978 */     // No operand predicates
     /*  935978 */     // MIs[0] round
     /*  935978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936018 */     GIR_RootConstrainSelectedInstOperands,
     /*  936019 */     // GIR_Coverage, 16474,
     /*  936019 */     GIR_EraseRootFromParent_Done,
     /*  936020 */   // Label 14168: @936020
     /*  936020 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(936114), // Rule ID 16475 //
     /*  936025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  936036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  936039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  936042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936072 */     // MIs[1] Operand 1
     /*  936072 */     // No operand predicates
     /*  936072 */     // MIs[0] round
     /*  936072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936112 */     GIR_RootConstrainSelectedInstOperands,
     /*  936113 */     // GIR_Coverage, 16475,
     /*  936113 */     GIR_EraseRootFromParent_Done,
     /*  936114 */   // Label 14169: @936114
     /*  936114 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(936208), // Rule ID 16478 //
     /*  936119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  936136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936166 */     // MIs[1] Operand 1
     /*  936166 */     // No operand predicates
     /*  936166 */     // MIs[0] round
     /*  936166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936206 */     GIR_RootConstrainSelectedInstOperands,
     /*  936207 */     // GIR_Coverage, 16478,
     /*  936207 */     GIR_EraseRootFromParent_Done,
     /*  936208 */   // Label 14170: @936208
     /*  936208 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(936302), // Rule ID 16479 //
     /*  936213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  936230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936260 */     // MIs[1] Operand 1
     /*  936260 */     // No operand predicates
     /*  936260 */     // MIs[0] round
     /*  936260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936272 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936300 */     GIR_RootConstrainSelectedInstOperands,
     /*  936301 */     // GIR_Coverage, 16479,
     /*  936301 */     GIR_EraseRootFromParent_Done,
     /*  936302 */   // Label 14171: @936302
     /*  936302 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(936396), // Rule ID 16482 //
     /*  936307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  936324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936354 */     // MIs[1] Operand 1
     /*  936354 */     // No operand predicates
     /*  936354 */     // MIs[0] round
     /*  936354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936366 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936394 */     GIR_RootConstrainSelectedInstOperands,
     /*  936395 */     // GIR_Coverage, 16482,
     /*  936395 */     GIR_EraseRootFromParent_Done,
     /*  936396 */   // Label 14172: @936396
     /*  936396 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(936490), // Rule ID 16483 //
     /*  936401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  936418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936448 */     // MIs[1] Operand 1
     /*  936448 */     // No operand predicates
     /*  936448 */     // MIs[0] round
     /*  936448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936460 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936488 */     GIR_RootConstrainSelectedInstOperands,
     /*  936489 */     // GIR_Coverage, 16483,
     /*  936489 */     GIR_EraseRootFromParent_Done,
     /*  936490 */   // Label 14173: @936490
     /*  936490 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(936584), // Rule ID 16486 //
     /*  936495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936542 */     // MIs[1] Operand 1
     /*  936542 */     // No operand predicates
     /*  936542 */     // MIs[0] round
     /*  936542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936554 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936582 */     GIR_RootConstrainSelectedInstOperands,
     /*  936583 */     // GIR_Coverage, 16486,
     /*  936583 */     GIR_EraseRootFromParent_Done,
     /*  936584 */   // Label 14174: @936584
     /*  936584 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(936678), // Rule ID 16487 //
     /*  936589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936636 */     // MIs[1] Operand 1
     /*  936636 */     // No operand predicates
     /*  936636 */     // MIs[0] round
     /*  936636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936660 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936676 */     GIR_RootConstrainSelectedInstOperands,
     /*  936677 */     // GIR_Coverage, 16487,
     /*  936677 */     GIR_EraseRootFromParent_Done,
     /*  936678 */   // Label 14175: @936678
     /*  936678 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(936772), // Rule ID 16490 //
     /*  936683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936730 */     // MIs[1] Operand 1
     /*  936730 */     // No operand predicates
     /*  936730 */     // MIs[0] round
     /*  936730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936742 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936770 */     GIR_RootConstrainSelectedInstOperands,
     /*  936771 */     // GIR_Coverage, 16490,
     /*  936771 */     GIR_EraseRootFromParent_Done,
     /*  936772 */   // Label 14176: @936772
     /*  936772 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(936866), // Rule ID 16491 //
     /*  936777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936824 */     // MIs[1] Operand 1
     /*  936824 */     // No operand predicates
     /*  936824 */     // MIs[0] round
     /*  936824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936848 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936864 */     GIR_RootConstrainSelectedInstOperands,
     /*  936865 */     // GIR_Coverage, 16491,
     /*  936865 */     GIR_EraseRootFromParent_Done,
     /*  936866 */   // Label 14177: @936866
     /*  936866 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(936960), // Rule ID 16494 //
     /*  936871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936918 */     // MIs[1] Operand 1
     /*  936918 */     // No operand predicates
     /*  936918 */     // MIs[0] round
     /*  936918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936958 */     GIR_RootConstrainSelectedInstOperands,
     /*  936959 */     // GIR_Coverage, 16494,
     /*  936959 */     GIR_EraseRootFromParent_Done,
     /*  936960 */   // Label 14178: @936960
     /*  936960 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(937054), // Rule ID 16495 //
     /*  936965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937012 */     // MIs[1] Operand 1
     /*  937012 */     // No operand predicates
     /*  937012 */     // MIs[0] round
     /*  937012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937036 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937052 */     GIR_RootConstrainSelectedInstOperands,
     /*  937053 */     // GIR_Coverage, 16495,
     /*  937053 */     GIR_EraseRootFromParent_Done,
     /*  937054 */   // Label 14179: @937054
     /*  937054 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(937148), // Rule ID 16498 //
     /*  937059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937106 */     // MIs[1] Operand 1
     /*  937106 */     // No operand predicates
     /*  937106 */     // MIs[0] round
     /*  937106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937146 */     GIR_RootConstrainSelectedInstOperands,
     /*  937147 */     // GIR_Coverage, 16498,
     /*  937147 */     GIR_EraseRootFromParent_Done,
     /*  937148 */   // Label 14180: @937148
     /*  937148 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(937242), // Rule ID 16499 //
     /*  937153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937200 */     // MIs[1] Operand 1
     /*  937200 */     // No operand predicates
     /*  937200 */     // MIs[0] round
     /*  937200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937240 */     GIR_RootConstrainSelectedInstOperands,
     /*  937241 */     // GIR_Coverage, 16499,
     /*  937241 */     GIR_EraseRootFromParent_Done,
     /*  937242 */   // Label 14181: @937242
     /*  937242 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(937336), // Rule ID 16502 //
     /*  937247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  937264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937294 */     // MIs[1] Operand 1
     /*  937294 */     // No operand predicates
     /*  937294 */     // MIs[0] round
     /*  937294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937334 */     GIR_RootConstrainSelectedInstOperands,
     /*  937335 */     // GIR_Coverage, 16502,
     /*  937335 */     GIR_EraseRootFromParent_Done,
     /*  937336 */   // Label 14182: @937336
     /*  937336 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(937430), // Rule ID 16503 //
     /*  937341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  937358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937388 */     // MIs[1] Operand 1
     /*  937388 */     // No operand predicates
     /*  937388 */     // MIs[0] round
     /*  937388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937428 */     GIR_RootConstrainSelectedInstOperands,
     /*  937429 */     // GIR_Coverage, 16503,
     /*  937429 */     GIR_EraseRootFromParent_Done,
     /*  937430 */   // Label 14183: @937430
     /*  937430 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(937524), // Rule ID 16506 //
     /*  937435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937482 */     // MIs[1] Operand 1
     /*  937482 */     // No operand predicates
     /*  937482 */     // MIs[0] round
     /*  937482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937506 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937522 */     GIR_RootConstrainSelectedInstOperands,
     /*  937523 */     // GIR_Coverage, 16506,
     /*  937523 */     GIR_EraseRootFromParent_Done,
     /*  937524 */   // Label 14184: @937524
     /*  937524 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(937618), // Rule ID 16507 //
     /*  937529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937576 */     // MIs[1] Operand 1
     /*  937576 */     // No operand predicates
     /*  937576 */     // MIs[0] round
     /*  937576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937616 */     GIR_RootConstrainSelectedInstOperands,
     /*  937617 */     // GIR_Coverage, 16507,
     /*  937617 */     GIR_EraseRootFromParent_Done,
     /*  937618 */   // Label 14185: @937618
     /*  937618 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(937712), // Rule ID 16510 //
     /*  937623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937670 */     // MIs[1] Operand 1
     /*  937670 */     // No operand predicates
     /*  937670 */     // MIs[0] round
     /*  937670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937710 */     GIR_RootConstrainSelectedInstOperands,
     /*  937711 */     // GIR_Coverage, 16510,
     /*  937711 */     GIR_EraseRootFromParent_Done,
     /*  937712 */   // Label 14186: @937712
     /*  937712 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(937806), // Rule ID 16511 //
     /*  937717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937764 */     // MIs[1] Operand 1
     /*  937764 */     // No operand predicates
     /*  937764 */     // MIs[0] round
     /*  937764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937804 */     GIR_RootConstrainSelectedInstOperands,
     /*  937805 */     // GIR_Coverage, 16511,
     /*  937805 */     GIR_EraseRootFromParent_Done,
     /*  937806 */   // Label 14187: @937806
     /*  937806 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(937900), // Rule ID 16514 //
     /*  937811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937858 */     // MIs[1] Operand 1
     /*  937858 */     // No operand predicates
     /*  937858 */     // MIs[0] round
     /*  937858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937882 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937898 */     GIR_RootConstrainSelectedInstOperands,
     /*  937899 */     // GIR_Coverage, 16514,
     /*  937899 */     GIR_EraseRootFromParent_Done,
     /*  937900 */   // Label 14188: @937900
     /*  937900 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(937994), // Rule ID 16515 //
     /*  937905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937952 */     // MIs[1] Operand 1
     /*  937952 */     // No operand predicates
     /*  937952 */     // MIs[0] round
     /*  937952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937992 */     GIR_RootConstrainSelectedInstOperands,
     /*  937993 */     // GIR_Coverage, 16515,
     /*  937993 */     GIR_EraseRootFromParent_Done,
     /*  937994 */   // Label 14189: @937994
     /*  937994 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(938088), // Rule ID 16518 //
     /*  937999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  938002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938046 */     // MIs[1] Operand 1
     /*  938046 */     // No operand predicates
     /*  938046 */     // MIs[0] round
     /*  938046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  938058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  938061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938086 */     GIR_RootConstrainSelectedInstOperands,
     /*  938087 */     // GIR_Coverage, 16518,
     /*  938087 */     GIR_EraseRootFromParent_Done,
     /*  938088 */   // Label 14190: @938088
     /*  938088 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(938182), // Rule ID 16519 //
     /*  938093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  938096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  938104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  938107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938140 */     // MIs[1] Operand 1
     /*  938140 */     // No operand predicates
     /*  938140 */     // MIs[0] round
     /*  938140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  938152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  938155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938180 */     GIR_RootConstrainSelectedInstOperands,
     /*  938181 */     // GIR_Coverage, 16519,
     /*  938181 */     GIR_EraseRootFromParent_Done,
     /*  938182 */   // Label 14191: @938182
     /*  938182 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(938276), // Rule ID 16642 //
     /*  938187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938234 */     // MIs[1] Operand 1
     /*  938234 */     // No operand predicates
     /*  938234 */     // MIs[0] round
     /*  938234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  938249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938274 */     GIR_RootConstrainSelectedInstOperands,
     /*  938275 */     // GIR_Coverage, 16642,
     /*  938275 */     GIR_EraseRootFromParent_Done,
     /*  938276 */   // Label 14192: @938276
     /*  938276 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(938370), // Rule ID 16643 //
     /*  938281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938328 */     // MIs[1] Operand 1
     /*  938328 */     // No operand predicates
     /*  938328 */     // MIs[0] round
     /*  938328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938340 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  938343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938352 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938368 */     GIR_RootConstrainSelectedInstOperands,
     /*  938369 */     // GIR_Coverage, 16643,
     /*  938369 */     GIR_EraseRootFromParent_Done,
     /*  938370 */   // Label 14193: @938370
     /*  938370 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(938464), // Rule ID 16646 //
     /*  938375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938422 */     // MIs[1] Operand 1
     /*  938422 */     // No operand predicates
     /*  938422 */     // MIs[0] round
     /*  938422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938462 */     GIR_RootConstrainSelectedInstOperands,
     /*  938463 */     // GIR_Coverage, 16646,
     /*  938463 */     GIR_EraseRootFromParent_Done,
     /*  938464 */   // Label 14194: @938464
     /*  938464 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(938558), // Rule ID 16647 //
     /*  938469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938516 */     // MIs[1] Operand 1
     /*  938516 */     // No operand predicates
     /*  938516 */     // MIs[0] round
     /*  938516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938556 */     GIR_RootConstrainSelectedInstOperands,
     /*  938557 */     // GIR_Coverage, 16647,
     /*  938557 */     GIR_EraseRootFromParent_Done,
     /*  938558 */   // Label 14195: @938558
     /*  938558 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(938652), // Rule ID 16650 //
     /*  938563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938610 */     // MIs[1] Operand 1
     /*  938610 */     // No operand predicates
     /*  938610 */     // MIs[0] round
     /*  938610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938622 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938650 */     GIR_RootConstrainSelectedInstOperands,
     /*  938651 */     // GIR_Coverage, 16650,
     /*  938651 */     GIR_EraseRootFromParent_Done,
     /*  938652 */   // Label 14196: @938652
     /*  938652 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(938746), // Rule ID 16651 //
     /*  938657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938704 */     // MIs[1] Operand 1
     /*  938704 */     // No operand predicates
     /*  938704 */     // MIs[0] round
     /*  938704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938716 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938744 */     GIR_RootConstrainSelectedInstOperands,
     /*  938745 */     // GIR_Coverage, 16651,
     /*  938745 */     GIR_EraseRootFromParent_Done,
     /*  938746 */   // Label 14197: @938746
     /*  938746 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(938840), // Rule ID 16654 //
     /*  938751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938798 */     // MIs[1] Operand 1
     /*  938798 */     // No operand predicates
     /*  938798 */     // MIs[0] round
     /*  938798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938810 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938838 */     GIR_RootConstrainSelectedInstOperands,
     /*  938839 */     // GIR_Coverage, 16654,
     /*  938839 */     GIR_EraseRootFromParent_Done,
     /*  938840 */   // Label 14198: @938840
     /*  938840 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(938934), // Rule ID 16655 //
     /*  938845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938892 */     // MIs[1] Operand 1
     /*  938892 */     // No operand predicates
     /*  938892 */     // MIs[0] round
     /*  938892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938932 */     GIR_RootConstrainSelectedInstOperands,
     /*  938933 */     // GIR_Coverage, 16655,
     /*  938933 */     GIR_EraseRootFromParent_Done,
     /*  938934 */   // Label 14199: @938934
     /*  938934 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(939028), // Rule ID 16658 //
     /*  938939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938986 */     // MIs[1] Operand 1
     /*  938986 */     // No operand predicates
     /*  938986 */     // MIs[0] round
     /*  938986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939010 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939026 */     GIR_RootConstrainSelectedInstOperands,
     /*  939027 */     // GIR_Coverage, 16658,
     /*  939027 */     GIR_EraseRootFromParent_Done,
     /*  939028 */   // Label 14200: @939028
     /*  939028 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(939122), // Rule ID 16659 //
     /*  939033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939080 */     // MIs[1] Operand 1
     /*  939080 */     // No operand predicates
     /*  939080 */     // MIs[0] round
     /*  939080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939092 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939120 */     GIR_RootConstrainSelectedInstOperands,
     /*  939121 */     // GIR_Coverage, 16659,
     /*  939121 */     GIR_EraseRootFromParent_Done,
     /*  939122 */   // Label 14201: @939122
     /*  939122 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(939216), // Rule ID 16662 //
     /*  939127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939174 */     // MIs[1] Operand 1
     /*  939174 */     // No operand predicates
     /*  939174 */     // MIs[0] round
     /*  939174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939198 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939214 */     GIR_RootConstrainSelectedInstOperands,
     /*  939215 */     // GIR_Coverage, 16662,
     /*  939215 */     GIR_EraseRootFromParent_Done,
     /*  939216 */   // Label 14202: @939216
     /*  939216 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(939310), // Rule ID 16663 //
     /*  939221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939268 */     // MIs[1] Operand 1
     /*  939268 */     // No operand predicates
     /*  939268 */     // MIs[0] round
     /*  939268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939280 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939292 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939308 */     GIR_RootConstrainSelectedInstOperands,
     /*  939309 */     // GIR_Coverage, 16663,
     /*  939309 */     GIR_EraseRootFromParent_Done,
     /*  939310 */   // Label 14203: @939310
     /*  939310 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(939404), // Rule ID 16666 //
     /*  939315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939362 */     // MIs[1] Operand 1
     /*  939362 */     // No operand predicates
     /*  939362 */     // MIs[0] round
     /*  939362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939402 */     GIR_RootConstrainSelectedInstOperands,
     /*  939403 */     // GIR_Coverage, 16666,
     /*  939403 */     GIR_EraseRootFromParent_Done,
     /*  939404 */   // Label 14204: @939404
     /*  939404 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(939498), // Rule ID 16667 //
     /*  939409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939456 */     // MIs[1] Operand 1
     /*  939456 */     // No operand predicates
     /*  939456 */     // MIs[0] round
     /*  939456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939496 */     GIR_RootConstrainSelectedInstOperands,
     /*  939497 */     // GIR_Coverage, 16667,
     /*  939497 */     GIR_EraseRootFromParent_Done,
     /*  939498 */   // Label 14205: @939498
     /*  939498 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(939592), // Rule ID 16670 //
     /*  939503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939550 */     // MIs[1] Operand 1
     /*  939550 */     // No operand predicates
     /*  939550 */     // MIs[0] round
     /*  939550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939590 */     GIR_RootConstrainSelectedInstOperands,
     /*  939591 */     // GIR_Coverage, 16670,
     /*  939591 */     GIR_EraseRootFromParent_Done,
     /*  939592 */   // Label 14206: @939592
     /*  939592 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(939686), // Rule ID 16671 //
     /*  939597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939644 */     // MIs[1] Operand 1
     /*  939644 */     // No operand predicates
     /*  939644 */     // MIs[0] round
     /*  939644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939668 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939684 */     GIR_RootConstrainSelectedInstOperands,
     /*  939685 */     // GIR_Coverage, 16671,
     /*  939685 */     GIR_EraseRootFromParent_Done,
     /*  939686 */   // Label 14207: @939686
     /*  939686 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(939780), // Rule ID 16674 //
     /*  939691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939738 */     // MIs[1] Operand 1
     /*  939738 */     // No operand predicates
     /*  939738 */     // MIs[0] round
     /*  939738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939778 */     GIR_RootConstrainSelectedInstOperands,
     /*  939779 */     // GIR_Coverage, 16674,
     /*  939779 */     GIR_EraseRootFromParent_Done,
     /*  939780 */   // Label 14208: @939780
     /*  939780 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(939874), // Rule ID 16675 //
     /*  939785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939832 */     // MIs[1] Operand 1
     /*  939832 */     // No operand predicates
     /*  939832 */     // MIs[0] round
     /*  939832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939856 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939872 */     GIR_RootConstrainSelectedInstOperands,
     /*  939873 */     // GIR_Coverage, 16675,
     /*  939873 */     GIR_EraseRootFromParent_Done,
     /*  939874 */   // Label 14209: @939874
     /*  939874 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(939968), // Rule ID 16678 //
     /*  939879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939926 */     // MIs[1] Operand 1
     /*  939926 */     // No operand predicates
     /*  939926 */     // MIs[0] round
     /*  939926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939966 */     GIR_RootConstrainSelectedInstOperands,
     /*  939967 */     // GIR_Coverage, 16678,
     /*  939967 */     GIR_EraseRootFromParent_Done,
     /*  939968 */   // Label 14210: @939968
     /*  939968 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(940062), // Rule ID 16679 //
     /*  939973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940020 */     // MIs[1] Operand 1
     /*  940020 */     // No operand predicates
     /*  940020 */     // MIs[0] round
     /*  940020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940044 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940060 */     GIR_RootConstrainSelectedInstOperands,
     /*  940061 */     // GIR_Coverage, 16679,
     /*  940061 */     GIR_EraseRootFromParent_Done,
     /*  940062 */   // Label 14211: @940062
     /*  940062 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(940156), // Rule ID 16682 //
     /*  940067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940114 */     // MIs[1] Operand 1
     /*  940114 */     // No operand predicates
     /*  940114 */     // MIs[0] round
     /*  940114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940138 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940154 */     GIR_RootConstrainSelectedInstOperands,
     /*  940155 */     // GIR_Coverage, 16682,
     /*  940155 */     GIR_EraseRootFromParent_Done,
     /*  940156 */   // Label 14212: @940156
     /*  940156 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(940250), // Rule ID 16683 //
     /*  940161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940208 */     // MIs[1] Operand 1
     /*  940208 */     // No operand predicates
     /*  940208 */     // MIs[0] round
     /*  940208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940248 */     GIR_RootConstrainSelectedInstOperands,
     /*  940249 */     // GIR_Coverage, 16683,
     /*  940249 */     GIR_EraseRootFromParent_Done,
     /*  940250 */   // Label 14213: @940250
     /*  940250 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(940344), // Rule ID 16686 //
     /*  940255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940302 */     // MIs[1] Operand 1
     /*  940302 */     // No operand predicates
     /*  940302 */     // MIs[0] round
     /*  940302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  940317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940326 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940342 */     GIR_RootConstrainSelectedInstOperands,
     /*  940343 */     // GIR_Coverage, 16686,
     /*  940343 */     GIR_EraseRootFromParent_Done,
     /*  940344 */   // Label 14214: @940344
     /*  940344 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(940438), // Rule ID 16687 //
     /*  940349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940396 */     // MIs[1] Operand 1
     /*  940396 */     // No operand predicates
     /*  940396 */     // MIs[0] round
     /*  940396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  940411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940436 */     GIR_RootConstrainSelectedInstOperands,
     /*  940437 */     // GIR_Coverage, 16687,
     /*  940437 */     GIR_EraseRootFromParent_Done,
     /*  940438 */   // Label 14215: @940438
     /*  940438 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(940532), // Rule ID 16690 //
     /*  940443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940490 */     // MIs[1] Operand 1
     /*  940490 */     // No operand predicates
     /*  940490 */     // MIs[0] round
     /*  940490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940514 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940530 */     GIR_RootConstrainSelectedInstOperands,
     /*  940531 */     // GIR_Coverage, 16690,
     /*  940531 */     GIR_EraseRootFromParent_Done,
     /*  940532 */   // Label 14216: @940532
     /*  940532 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(940626), // Rule ID 16691 //
     /*  940537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940584 */     // MIs[1] Operand 1
     /*  940584 */     // No operand predicates
     /*  940584 */     // MIs[0] round
     /*  940584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940624 */     GIR_RootConstrainSelectedInstOperands,
     /*  940625 */     // GIR_Coverage, 16691,
     /*  940625 */     GIR_EraseRootFromParent_Done,
     /*  940626 */   // Label 14217: @940626
     /*  940626 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(940720), // Rule ID 16694 //
     /*  940631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940678 */     // MIs[1] Operand 1
     /*  940678 */     // No operand predicates
     /*  940678 */     // MIs[0] round
     /*  940678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940702 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940718 */     GIR_RootConstrainSelectedInstOperands,
     /*  940719 */     // GIR_Coverage, 16694,
     /*  940719 */     GIR_EraseRootFromParent_Done,
     /*  940720 */   // Label 14218: @940720
     /*  940720 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(940814), // Rule ID 16695 //
     /*  940725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940772 */     // MIs[1] Operand 1
     /*  940772 */     // No operand predicates
     /*  940772 */     // MIs[0] round
     /*  940772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940812 */     GIR_RootConstrainSelectedInstOperands,
     /*  940813 */     // GIR_Coverage, 16695,
     /*  940813 */     GIR_EraseRootFromParent_Done,
     /*  940814 */   // Label 14219: @940814
     /*  940814 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(940908), // Rule ID 16698 //
     /*  940819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940866 */     // MIs[1] Operand 1
     /*  940866 */     // No operand predicates
     /*  940866 */     // MIs[0] round
     /*  940866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940890 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940906 */     GIR_RootConstrainSelectedInstOperands,
     /*  940907 */     // GIR_Coverage, 16698,
     /*  940907 */     GIR_EraseRootFromParent_Done,
     /*  940908 */   // Label 14220: @940908
     /*  940908 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(941002), // Rule ID 16699 //
     /*  940913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940960 */     // MIs[1] Operand 1
     /*  940960 */     // No operand predicates
     /*  940960 */     // MIs[0] round
     /*  940960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940984 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941000 */     GIR_RootConstrainSelectedInstOperands,
     /*  941001 */     // GIR_Coverage, 16699,
     /*  941001 */     GIR_EraseRootFromParent_Done,
     /*  941002 */   // Label 14221: @941002
     /*  941002 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(941086), // Rule ID 2766 //
     /*  941007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941050 */     // MIs[0] round
     /*  941050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941062 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  941065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941084 */     GIR_RootConstrainSelectedInstOperands,
     /*  941085 */     // GIR_Coverage, 2766,
     /*  941085 */     GIR_EraseRootFromParent_Done,
     /*  941086 */   // Label 14222: @941086
     /*  941086 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(941170), // Rule ID 2767 //
     /*  941091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941134 */     // MIs[0] round
     /*  941134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  941149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941168 */     GIR_RootConstrainSelectedInstOperands,
     /*  941169 */     // GIR_Coverage, 2767,
     /*  941169 */     GIR_EraseRootFromParent_Done,
     /*  941170 */   // Label 14223: @941170
     /*  941170 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(941254), // Rule ID 17146 //
     /*  941175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941218 */     // MIs[0] round
     /*  941218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941230 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  941233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941252 */     GIR_RootConstrainSelectedInstOperands,
     /*  941253 */     // GIR_Coverage, 17146,
     /*  941253 */     GIR_EraseRootFromParent_Done,
     /*  941254 */   // Label 14224: @941254
     /*  941254 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(941338), // Rule ID 17147 //
     /*  941259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941302 */     // MIs[0] round
     /*  941302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941314 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  941317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941336 */     GIR_RootConstrainSelectedInstOperands,
     /*  941337 */     // GIR_Coverage, 17147,
     /*  941337 */     GIR_EraseRootFromParent_Done,
     /*  941338 */   // Label 14225: @941338
     /*  941338 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(941422), // Rule ID 17156 //
     /*  941343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941386 */     // MIs[0] round
     /*  941386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941420 */     GIR_RootConstrainSelectedInstOperands,
     /*  941421 */     // GIR_Coverage, 17156,
     /*  941421 */     GIR_EraseRootFromParent_Done,
     /*  941422 */   // Label 14226: @941422
     /*  941422 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(941506), // Rule ID 17157 //
     /*  941427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941470 */     // MIs[0] round
     /*  941470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941504 */     GIR_RootConstrainSelectedInstOperands,
     /*  941505 */     // GIR_Coverage, 17157,
     /*  941505 */     GIR_EraseRootFromParent_Done,
     /*  941506 */   // Label 14227: @941506
     /*  941506 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(941590), // Rule ID 17166 //
     /*  941511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941554 */     // MIs[0] round
     /*  941554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941566 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941588 */     GIR_RootConstrainSelectedInstOperands,
     /*  941589 */     // GIR_Coverage, 17166,
     /*  941589 */     GIR_EraseRootFromParent_Done,
     /*  941590 */   // Label 14228: @941590
     /*  941590 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(941674), // Rule ID 17167 //
     /*  941595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941638 */     // MIs[0] round
     /*  941638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941650 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941672 */     GIR_RootConstrainSelectedInstOperands,
     /*  941673 */     // GIR_Coverage, 17167,
     /*  941673 */     GIR_EraseRootFromParent_Done,
     /*  941674 */   // Label 14229: @941674
     /*  941674 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(941758), // Rule ID 17176 //
     /*  941679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941722 */     // MIs[0] round
     /*  941722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941756 */     GIR_RootConstrainSelectedInstOperands,
     /*  941757 */     // GIR_Coverage, 17176,
     /*  941757 */     GIR_EraseRootFromParent_Done,
     /*  941758 */   // Label 14230: @941758
     /*  941758 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(941842), // Rule ID 17177 //
     /*  941763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941806 */     // MIs[0] round
     /*  941806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941818 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941840 */     GIR_RootConstrainSelectedInstOperands,
     /*  941841 */     // GIR_Coverage, 17177,
     /*  941841 */     GIR_EraseRootFromParent_Done,
     /*  941842 */   // Label 14231: @941842
     /*  941842 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(941926), // Rule ID 17186 //
     /*  941847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941890 */     // MIs[0] round
     /*  941890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941924 */     GIR_RootConstrainSelectedInstOperands,
     /*  941925 */     // GIR_Coverage, 17186,
     /*  941925 */     GIR_EraseRootFromParent_Done,
     /*  941926 */   // Label 14232: @941926
     /*  941926 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(942010), // Rule ID 17187 //
     /*  941931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941974 */     // MIs[0] round
     /*  941974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941986 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942008 */     GIR_RootConstrainSelectedInstOperands,
     /*  942009 */     // GIR_Coverage, 17187,
     /*  942009 */     GIR_EraseRootFromParent_Done,
     /*  942010 */   // Label 14233: @942010
     /*  942010 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(942094), // Rule ID 17196 //
     /*  942015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942058 */     // MIs[0] round
     /*  942058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942070 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  942073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942092 */     GIR_RootConstrainSelectedInstOperands,
     /*  942093 */     // GIR_Coverage, 17196,
     /*  942093 */     GIR_EraseRootFromParent_Done,
     /*  942094 */   // Label 14234: @942094
     /*  942094 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(942178), // Rule ID 17197 //
     /*  942099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942142 */     // MIs[0] round
     /*  942142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  942157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942176 */     GIR_RootConstrainSelectedInstOperands,
     /*  942177 */     // GIR_Coverage, 17197,
     /*  942177 */     GIR_EraseRootFromParent_Done,
     /*  942178 */   // Label 14235: @942178
     /*  942178 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(942262), // Rule ID 17206 //
     /*  942183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942226 */     // MIs[0] round
     /*  942226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942238 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  942241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942260 */     GIR_RootConstrainSelectedInstOperands,
     /*  942261 */     // GIR_Coverage, 17206,
     /*  942261 */     GIR_EraseRootFromParent_Done,
     /*  942262 */   // Label 14236: @942262
     /*  942262 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(942346), // Rule ID 17207 //
     /*  942267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942310 */     // MIs[0] round
     /*  942310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942322 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  942325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942344 */     GIR_RootConstrainSelectedInstOperands,
     /*  942345 */     // GIR_Coverage, 17207,
     /*  942345 */     GIR_EraseRootFromParent_Done,
     /*  942346 */   // Label 14237: @942346
     /*  942346 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(942430), // Rule ID 17216 //
     /*  942351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942394 */     // MIs[0] round
     /*  942394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942406 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942428 */     GIR_RootConstrainSelectedInstOperands,
     /*  942429 */     // GIR_Coverage, 17216,
     /*  942429 */     GIR_EraseRootFromParent_Done,
     /*  942430 */   // Label 14238: @942430
     /*  942430 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(942514), // Rule ID 17217 //
     /*  942435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  942443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942478 */     // MIs[0] round
     /*  942478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942490 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942512 */     GIR_RootConstrainSelectedInstOperands,
     /*  942513 */     // GIR_Coverage, 17217,
     /*  942513 */     GIR_EraseRootFromParent_Done,
     /*  942514 */   // Label 14239: @942514
     /*  942514 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(942598), // Rule ID 17262 //
     /*  942519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942562 */     // MIs[0] round
     /*  942562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942596 */     GIR_RootConstrainSelectedInstOperands,
     /*  942597 */     // GIR_Coverage, 17262,
     /*  942597 */     GIR_EraseRootFromParent_Done,
     /*  942598 */   // Label 14240: @942598
     /*  942598 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(942682), // Rule ID 17263 //
     /*  942603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942646 */     // MIs[0] round
     /*  942646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942658 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942680 */     GIR_RootConstrainSelectedInstOperands,
     /*  942681 */     // GIR_Coverage, 17263,
     /*  942681 */     GIR_EraseRootFromParent_Done,
     /*  942682 */   // Label 14241: @942682
     /*  942682 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(942766), // Rule ID 17272 //
     /*  942687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942730 */     // MIs[0] round
     /*  942730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942764 */     GIR_RootConstrainSelectedInstOperands,
     /*  942765 */     // GIR_Coverage, 17272,
     /*  942765 */     GIR_EraseRootFromParent_Done,
     /*  942766 */   // Label 14242: @942766
     /*  942766 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(942850), // Rule ID 17273 //
     /*  942771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942814 */     // MIs[0] round
     /*  942814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942826 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942848 */     GIR_RootConstrainSelectedInstOperands,
     /*  942849 */     // GIR_Coverage, 17273,
     /*  942849 */     GIR_EraseRootFromParent_Done,
     /*  942850 */   // Label 14243: @942850
     /*  942850 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(942934), // Rule ID 17282 //
     /*  942855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942898 */     // MIs[0] round
     /*  942898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942932 */     GIR_RootConstrainSelectedInstOperands,
     /*  942933 */     // GIR_Coverage, 17282,
     /*  942933 */     GIR_EraseRootFromParent_Done,
     /*  942934 */   // Label 14244: @942934
     /*  942934 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(943018), // Rule ID 17283 //
     /*  942939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942982 */     // MIs[0] round
     /*  942982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943016 */     GIR_RootConstrainSelectedInstOperands,
     /*  943017 */     // GIR_Coverage, 17283,
     /*  943017 */     GIR_EraseRootFromParent_Done,
     /*  943018 */   // Label 14245: @943018
     /*  943018 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(943102), // Rule ID 17292 //
     /*  943023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  943026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943066 */     // MIs[0] round
     /*  943066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943078 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  943078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  943081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943100 */     GIR_RootConstrainSelectedInstOperands,
     /*  943101 */     // GIR_Coverage, 17292,
     /*  943101 */     GIR_EraseRootFromParent_Done,
     /*  943102 */   // Label 14246: @943102
     /*  943102 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(943186), // Rule ID 17293 //
     /*  943107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  943110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  943118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  943121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  943127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943150 */     // MIs[0] round
     /*  943150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943162 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  943162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  943165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943184 */     GIR_RootConstrainSelectedInstOperands,
     /*  943185 */     // GIR_Coverage, 17293,
     /*  943185 */     GIR_EraseRootFromParent_Done,
     /*  943186 */   // Label 14247: @943186
     /*  943186 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(943270), // Rule ID 17302 //
     /*  943191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  943194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943234 */     // MIs[0] round
     /*  943234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943246 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  943246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  943249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943268 */     GIR_RootConstrainSelectedInstOperands,
     /*  943269 */     // GIR_Coverage, 17302,
     /*  943269 */     GIR_EraseRootFromParent_Done,
     /*  943270 */   // Label 14248: @943270
     /*  943270 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(943354), // Rule ID 17303 //
     /*  943275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  943278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  943286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  943289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  943295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943318 */     // MIs[0] round
     /*  943318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943330 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  943330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  943333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943352 */     GIR_RootConstrainSelectedInstOperands,
     /*  943353 */     // GIR_Coverage, 17303,
     /*  943353 */     GIR_EraseRootFromParent_Done,
     /*  943354 */   // Label 14249: @943354
     /*  943354 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(943438), // Rule ID 17312 //
     /*  943359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943402 */     // MIs[0] round
     /*  943402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943414 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943436 */     GIR_RootConstrainSelectedInstOperands,
     /*  943437 */     // GIR_Coverage, 17312,
     /*  943437 */     GIR_EraseRootFromParent_Done,
     /*  943438 */   // Label 14250: @943438
     /*  943438 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(943522), // Rule ID 17313 //
     /*  943443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  943454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  943457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  943463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943486 */     // MIs[0] round
     /*  943486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943498 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943520 */     GIR_RootConstrainSelectedInstOperands,
     /*  943521 */     // GIR_Coverage, 17313,
     /*  943521 */     GIR_EraseRootFromParent_Done,
     /*  943522 */   // Label 14251: @943522
     /*  943522 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(943606), // Rule ID 17322 //
     /*  943527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943570 */     // MIs[0] round
     /*  943570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943604 */     GIR_RootConstrainSelectedInstOperands,
     /*  943605 */     // GIR_Coverage, 17322,
     /*  943605 */     GIR_EraseRootFromParent_Done,
     /*  943606 */   // Label 14252: @943606
     /*  943606 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(943690), // Rule ID 17323 //
     /*  943611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943654 */     // MIs[0] round
     /*  943654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943688 */     GIR_RootConstrainSelectedInstOperands,
     /*  943689 */     // GIR_Coverage, 17323,
     /*  943689 */     GIR_EraseRootFromParent_Done,
     /*  943690 */   // Label 14253: @943690
     /*  943690 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(943774), // Rule ID 17332 //
     /*  943695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943738 */     // MIs[0] round
     /*  943738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943772 */     GIR_RootConstrainSelectedInstOperands,
     /*  943773 */     // GIR_Coverage, 17332,
     /*  943773 */     GIR_EraseRootFromParent_Done,
     /*  943774 */   // Label 14254: @943774
     /*  943774 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(943858), // Rule ID 17333 //
     /*  943779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943822 */     // MIs[0] round
     /*  943822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943856 */     GIR_RootConstrainSelectedInstOperands,
     /*  943857 */     // GIR_Coverage, 17333,
     /*  943857 */     GIR_EraseRootFromParent_Done,
     /*  943858 */   // Label 14255: @943858
     /*  943858 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(943942), // Rule ID 17342 //
     /*  943863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943906 */     // MIs[0] round
     /*  943906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943940 */     GIR_RootConstrainSelectedInstOperands,
     /*  943941 */     // GIR_Coverage, 17342,
     /*  943941 */     GIR_EraseRootFromParent_Done,
     /*  943942 */   // Label 14256: @943942
     /*  943942 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(944026), // Rule ID 17343 //
     /*  943947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943990 */     // MIs[0] round
     /*  943990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  944002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  944005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944024 */     GIR_RootConstrainSelectedInstOperands,
     /*  944025 */     // GIR_Coverage, 17343,
     /*  944025 */     GIR_EraseRootFromParent_Done,
     /*  944026 */   // Label 14257: @944026
     /*  944026 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(944108), // Rule ID 62837 //
     /*  944031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944058 */     // MIs[0] op1
     /*  944058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944085 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  944088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944090 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944092 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944094 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944096 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944106 */     GIR_RootConstrainSelectedInstOperands,
     /*  944107 */     // GIR_Coverage, 62837,
     /*  944107 */     GIR_EraseRootFromParent_Done,
     /*  944108 */   // Label 14258: @944108
     /*  944108 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(944190), // Rule ID 62838 //
     /*  944113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944140 */     // MIs[0] op1
     /*  944140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF8),
     /*  944170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944172 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944174 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944176 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944178 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944188 */     GIR_RootConstrainSelectedInstOperands,
     /*  944189 */     // GIR_Coverage, 62838,
     /*  944189 */     GIR_EraseRootFromParent_Done,
     /*  944190 */   // Label 14259: @944190
     /*  944190 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(944272), // Rule ID 62867 //
     /*  944195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  944215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944222 */     // MIs[0] op1
     /*  944222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944249 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  944252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944254 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944256 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944258 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944260 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944270 */     GIR_RootConstrainSelectedInstOperands,
     /*  944271 */     // GIR_Coverage, 62867,
     /*  944271 */     GIR_EraseRootFromParent_Done,
     /*  944272 */   // Label 14260: @944272
     /*  944272 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(944354), // Rule ID 62868 //
     /*  944277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  944288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  944291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  944294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  944297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944304 */     // MIs[0] op1
     /*  944304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944331 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF8),
     /*  944334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944336 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944338 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944340 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944342 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944352 */     GIR_RootConstrainSelectedInstOperands,
     /*  944353 */     // GIR_Coverage, 62868,
     /*  944353 */     GIR_EraseRootFromParent_Done,
     /*  944354 */   // Label 14261: @944354
     /*  944354 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(944436), // Rule ID 62899 //
     /*  944359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944386 */     // MIs[0] op1
     /*  944386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944413 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944424 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944434 */     GIR_RootConstrainSelectedInstOperands,
     /*  944435 */     // GIR_Coverage, 62899,
     /*  944435 */     GIR_EraseRootFromParent_Done,
     /*  944436 */   // Label 14262: @944436
     /*  944436 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(944518), // Rule ID 62900 //
     /*  944441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944468 */     // MIs[0] op1
     /*  944468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944495 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  944498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944500 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944502 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944504 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944506 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944516 */     GIR_RootConstrainSelectedInstOperands,
     /*  944517 */     // GIR_Coverage, 62900,
     /*  944517 */     GIR_EraseRootFromParent_Done,
     /*  944518 */   // Label 14263: @944518
     /*  944518 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(944600), // Rule ID 62911 //
     /*  944523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944550 */     // MIs[0] op1
     /*  944550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944582 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944584 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944586 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944588 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944598 */     GIR_RootConstrainSelectedInstOperands,
     /*  944599 */     // GIR_Coverage, 62911,
     /*  944599 */     GIR_EraseRootFromParent_Done,
     /*  944600 */   // Label 14264: @944600
     /*  944600 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(944682), // Rule ID 62912 //
     /*  944605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944632 */     // MIs[0] op1
     /*  944632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944659 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  944662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944664 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944666 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944668 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944670 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944680 */     GIR_RootConstrainSelectedInstOperands,
     /*  944681 */     // GIR_Coverage, 62912,
     /*  944681 */     GIR_EraseRootFromParent_Done,
     /*  944682 */   // Label 14265: @944682
     /*  944682 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(944764), // Rule ID 62943 //
     /*  944687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944714 */     // MIs[0] op1
     /*  944714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944717 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944741 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944746 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944748 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944750 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944752 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944762 */     GIR_RootConstrainSelectedInstOperands,
     /*  944763 */     // GIR_Coverage, 62943,
     /*  944763 */     GIR_EraseRootFromParent_Done,
     /*  944764 */   // Label 14266: @944764
     /*  944764 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(944846), // Rule ID 62944 //
     /*  944769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944796 */     // MIs[0] op1
     /*  944796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944823 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  944826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944828 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944830 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944832 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944834 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944844 */     GIR_RootConstrainSelectedInstOperands,
     /*  944845 */     // GIR_Coverage, 62944,
     /*  944845 */     GIR_EraseRootFromParent_Done,
     /*  944846 */   // Label 14267: @944846
     /*  944846 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(944928), // Rule ID 62955 //
     /*  944851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944878 */     // MIs[0] op1
     /*  944878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944905 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944910 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944912 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944914 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944916 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944926 */     GIR_RootConstrainSelectedInstOperands,
     /*  944927 */     // GIR_Coverage, 62955,
     /*  944927 */     GIR_EraseRootFromParent_Done,
     /*  944928 */   // Label 14268: @944928
     /*  944928 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(945010), // Rule ID 62956 //
     /*  944933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944960 */     // MIs[0] op1
     /*  944960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944987 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  944990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944992 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944994 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944996 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944998 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945008 */     GIR_RootConstrainSelectedInstOperands,
     /*  945009 */     // GIR_Coverage, 62956,
     /*  945009 */     GIR_EraseRootFromParent_Done,
     /*  945010 */   // Label 14269: @945010
     /*  945010 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(945092), // Rule ID 62987 //
     /*  945015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945042 */     // MIs[0] op1
     /*  945042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  945072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945074 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945076 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945078 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945080 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945090 */     GIR_RootConstrainSelectedInstOperands,
     /*  945091 */     // GIR_Coverage, 62987,
     /*  945091 */     GIR_EraseRootFromParent_Done,
     /*  945092 */   // Label 14270: @945092
     /*  945092 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(945174), // Rule ID 62988 //
     /*  945097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945124 */     // MIs[0] op1
     /*  945124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945151 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF4),
     /*  945154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945156 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945158 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945160 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945162 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945172 */     GIR_RootConstrainSelectedInstOperands,
     /*  945173 */     // GIR_Coverage, 62988,
     /*  945173 */     GIR_EraseRootFromParent_Done,
     /*  945174 */   // Label 14271: @945174
     /*  945174 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(945256), // Rule ID 62999 //
     /*  945179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  945199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945206 */     // MIs[0] op1
     /*  945206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945233 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  945236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945238 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945240 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945242 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945244 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945254 */     GIR_RootConstrainSelectedInstOperands,
     /*  945255 */     // GIR_Coverage, 62999,
     /*  945255 */     GIR_EraseRootFromParent_Done,
     /*  945256 */   // Label 14272: @945256
     /*  945256 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(945338), // Rule ID 63000 //
     /*  945261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  945281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945288 */     // MIs[0] op1
     /*  945288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945315 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF4),
     /*  945318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945320 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945322 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945324 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945326 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945336 */     GIR_RootConstrainSelectedInstOperands,
     /*  945337 */     // GIR_Coverage, 63000,
     /*  945337 */     GIR_EraseRootFromParent_Done,
     /*  945338 */   // Label 14273: @945338
     /*  945338 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(945420), // Rule ID 63011 //
     /*  945343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945370 */     // MIs[0] op1
     /*  945370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945397 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  945400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945402 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945404 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945406 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945408 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945418 */     GIR_RootConstrainSelectedInstOperands,
     /*  945419 */     // GIR_Coverage, 63011,
     /*  945419 */     GIR_EraseRootFromParent_Done,
     /*  945420 */   // Label 14274: @945420
     /*  945420 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(945502), // Rule ID 63012 //
     /*  945425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  945436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  945439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945452 */     // MIs[0] op1
     /*  945452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945479 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF4),
     /*  945482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945484 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945486 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945488 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945490 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945500 */     GIR_RootConstrainSelectedInstOperands,
     /*  945501 */     // GIR_Coverage, 63012,
     /*  945501 */     GIR_EraseRootFromParent_Done,
     /*  945502 */   // Label 14275: @945502
     /*  945502 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(945584), // Rule ID 63043 //
     /*  945507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945534 */     // MIs[0] op1
     /*  945534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945561 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945566 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945568 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945570 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945572 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945582 */     GIR_RootConstrainSelectedInstOperands,
     /*  945583 */     // GIR_Coverage, 63043,
     /*  945583 */     GIR_EraseRootFromParent_Done,
     /*  945584 */   // Label 14276: @945584
     /*  945584 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(945666), // Rule ID 63044 //
     /*  945589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945616 */     // MIs[0] op1
     /*  945616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945643 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  945646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945648 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945650 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945652 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945654 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945664 */     GIR_RootConstrainSelectedInstOperands,
     /*  945665 */     // GIR_Coverage, 63044,
     /*  945665 */     GIR_EraseRootFromParent_Done,
     /*  945666 */   // Label 14277: @945666
     /*  945666 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(945748), // Rule ID 63055 //
     /*  945671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945698 */     // MIs[0] op1
     /*  945698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945730 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945732 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945734 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945736 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945746 */     GIR_RootConstrainSelectedInstOperands,
     /*  945747 */     // GIR_Coverage, 63055,
     /*  945747 */     GIR_EraseRootFromParent_Done,
     /*  945748 */   // Label 14278: @945748
     /*  945748 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(945830), // Rule ID 63056 //
     /*  945753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945780 */     // MIs[0] op1
     /*  945780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945807 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  945810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945812 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945814 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945816 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945818 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945828 */     GIR_RootConstrainSelectedInstOperands,
     /*  945829 */     // GIR_Coverage, 63056,
     /*  945829 */     GIR_EraseRootFromParent_Done,
     /*  945830 */   // Label 14279: @945830
     /*  945830 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(945912), // Rule ID 63067 //
     /*  945835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945862 */     // MIs[0] op1
     /*  945862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945889 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945894 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945896 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945898 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945900 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945910 */     GIR_RootConstrainSelectedInstOperands,
     /*  945911 */     // GIR_Coverage, 63067,
     /*  945911 */     GIR_EraseRootFromParent_Done,
     /*  945912 */   // Label 14280: @945912
     /*  945912 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(945994), // Rule ID 63068 //
     /*  945917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945944 */     // MIs[0] op1
     /*  945944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_MF2),
     /*  945974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945982 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945992 */     GIR_RootConstrainSelectedInstOperands,
     /*  945993 */     // GIR_Coverage, 63068,
     /*  945993 */     GIR_EraseRootFromParent_Done,
     /*  945994 */   // Label 14281: @945994
     /*  945994 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(946076), // Rule ID 63099 //
     /*  945999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946026 */     // MIs[0] op1
     /*  946026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946053 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  946056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946058 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946060 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946062 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946064 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946074 */     GIR_RootConstrainSelectedInstOperands,
     /*  946075 */     // GIR_Coverage, 63099,
     /*  946075 */     GIR_EraseRootFromParent_Done,
     /*  946076 */   // Label 14282: @946076
     /*  946076 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(946158), // Rule ID 63100 //
     /*  946081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946108 */     // MIs[0] op1
     /*  946108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946135 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_MF2),
     /*  946138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946140 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946142 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946144 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946146 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946156 */     GIR_RootConstrainSelectedInstOperands,
     /*  946157 */     // GIR_Coverage, 63100,
     /*  946157 */     GIR_EraseRootFromParent_Done,
     /*  946158 */   // Label 14283: @946158
     /*  946158 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(946240), // Rule ID 63111 //
     /*  946163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  946183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946190 */     // MIs[0] op1
     /*  946190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946217 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  946220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946222 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946224 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946226 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946228 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946238 */     GIR_RootConstrainSelectedInstOperands,
     /*  946239 */     // GIR_Coverage, 63111,
     /*  946239 */     GIR_EraseRootFromParent_Done,
     /*  946240 */   // Label 14284: @946240
     /*  946240 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(946322), // Rule ID 63112 //
     /*  946245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  946265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946272 */     // MIs[0] op1
     /*  946272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946299 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_MF2),
     /*  946302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946304 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946306 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946308 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946310 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946320 */     GIR_RootConstrainSelectedInstOperands,
     /*  946321 */     // GIR_Coverage, 63112,
     /*  946321 */     GIR_EraseRootFromParent_Done,
     /*  946322 */   // Label 14285: @946322
     /*  946322 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(946404), // Rule ID 63123 //
     /*  946327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946354 */     // MIs[0] op1
     /*  946354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946381 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  946384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946386 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946388 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946390 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946392 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946402 */     GIR_RootConstrainSelectedInstOperands,
     /*  946403 */     // GIR_Coverage, 63123,
     /*  946403 */     GIR_EraseRootFromParent_Done,
     /*  946404 */   // Label 14286: @946404
     /*  946404 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(946486), // Rule ID 63124 //
     /*  946409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  946420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  946423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946436 */     // MIs[0] op1
     /*  946436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946463 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_MF2),
     /*  946466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946474 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946484 */     GIR_RootConstrainSelectedInstOperands,
     /*  946485 */     // GIR_Coverage, 63124,
     /*  946485 */     GIR_EraseRootFromParent_Done,
     /*  946486 */   // Label 14287: @946486
     /*  946486 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(946568), // Rule ID 63155 //
     /*  946491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946518 */     // MIs[0] op1
     /*  946518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946550 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946552 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946554 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946556 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946566 */     GIR_RootConstrainSelectedInstOperands,
     /*  946567 */     // GIR_Coverage, 63155,
     /*  946567 */     GIR_EraseRootFromParent_Done,
     /*  946568 */   // Label 14288: @946568
     /*  946568 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(946650), // Rule ID 63156 //
     /*  946573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946600 */     // MIs[0] op1
     /*  946600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946648 */     GIR_RootConstrainSelectedInstOperands,
     /*  946649 */     // GIR_Coverage, 63156,
     /*  946649 */     GIR_EraseRootFromParent_Done,
     /*  946650 */   // Label 14289: @946650
     /*  946650 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(946732), // Rule ID 63167 //
     /*  946655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946682 */     // MIs[0] op1
     /*  946682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946709 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946714 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946716 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946718 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946720 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946730 */     GIR_RootConstrainSelectedInstOperands,
     /*  946731 */     // GIR_Coverage, 63167,
     /*  946731 */     GIR_EraseRootFromParent_Done,
     /*  946732 */   // Label 14290: @946732
     /*  946732 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(946814), // Rule ID 63168 //
     /*  946737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946764 */     // MIs[0] op1
     /*  946764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946791 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  946794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946796 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946798 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946800 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946802 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946812 */     GIR_RootConstrainSelectedInstOperands,
     /*  946813 */     // GIR_Coverage, 63168,
     /*  946813 */     GIR_EraseRootFromParent_Done,
     /*  946814 */   // Label 14291: @946814
     /*  946814 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(946896), // Rule ID 63199 //
     /*  946819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946846 */     // MIs[0] op1
     /*  946846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946873 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946884 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946894 */     GIR_RootConstrainSelectedInstOperands,
     /*  946895 */     // GIR_Coverage, 63199,
     /*  946895 */     GIR_EraseRootFromParent_Done,
     /*  946896 */   // Label 14292: @946896
     /*  946896 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(946978), // Rule ID 63200 //
     /*  946901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946928 */     // MIs[0] op1
     /*  946928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  946958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946966 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946976 */     GIR_RootConstrainSelectedInstOperands,
     /*  946977 */     // GIR_Coverage, 63200,
     /*  946977 */     GIR_EraseRootFromParent_Done,
     /*  946978 */   // Label 14293: @946978
     /*  946978 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(947060), // Rule ID 63211 //
     /*  946983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  947003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947010 */     // MIs[0] op1
     /*  947010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947037 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  947037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947042 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947044 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947046 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947048 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947058 */     GIR_RootConstrainSelectedInstOperands,
     /*  947059 */     // GIR_Coverage, 63211,
     /*  947059 */     GIR_EraseRootFromParent_Done,
     /*  947060 */   // Label 14294: @947060
     /*  947060 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(947142), // Rule ID 63212 //
     /*  947065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  947085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947092 */     // MIs[0] op1
     /*  947092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947119 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  947119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947130 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947140 */     GIR_RootConstrainSelectedInstOperands,
     /*  947141 */     // GIR_Coverage, 63212,
     /*  947141 */     GIR_EraseRootFromParent_Done,
     /*  947142 */   // Label 14295: @947142
     /*  947142 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(947224), // Rule ID 63223 //
     /*  947147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  947167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947174 */     // MIs[0] op1
     /*  947174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  947194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  947201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  947204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947212 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947222 */     GIR_RootConstrainSelectedInstOperands,
     /*  947223 */     // GIR_Coverage, 63223,
     /*  947223 */     GIR_EraseRootFromParent_Done,
     /*  947224 */   // Label 14296: @947224
     /*  947224 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(947306), // Rule ID 63224 //
     /*  947229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  947240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  947243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  947246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  947249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947256 */     // MIs[0] op1
     /*  947256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  947276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  947283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M1),
     /*  947286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947294 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  947304 */     GIR_RootConstrainSelectedInstOperands,
     /*  947305 */     // GIR_Coverage, 63224,
     /*  947305 */     GIR_EraseRootFromParent_Done,
     /*  947306 */   // Label 14297: @947306
     /*  947306 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(947388), // Rule ID 63255 //
     /*  947311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947338 */     // MIs[0] op1
     /*  947338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947370 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947372 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947374 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947376 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947386 */     GIR_RootConstrainSelectedInstOperands,
     /*  947387 */     // GIR_Coverage, 63255,
     /*  947387 */     GIR_EraseRootFromParent_Done,
     /*  947388 */   // Label 14298: @947388
     /*  947388 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(947470), // Rule ID 63256 //
     /*  947393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947420 */     // MIs[0] op1
     /*  947420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947447 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947452 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947454 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947456 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947458 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947468 */     GIR_RootConstrainSelectedInstOperands,
     /*  947469 */     // GIR_Coverage, 63256,
     /*  947469 */     GIR_EraseRootFromParent_Done,
     /*  947470 */   // Label 14299: @947470
     /*  947470 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(947552), // Rule ID 63267 //
     /*  947475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947502 */     // MIs[0] op1
     /*  947502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947529 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947534 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947536 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947538 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947540 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947550 */     GIR_RootConstrainSelectedInstOperands,
     /*  947551 */     // GIR_Coverage, 63267,
     /*  947551 */     GIR_EraseRootFromParent_Done,
     /*  947552 */   // Label 14300: @947552
     /*  947552 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(947634), // Rule ID 63268 //
     /*  947557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947584 */     // MIs[0] op1
     /*  947584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  947614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947616 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947618 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947620 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947622 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947632 */     GIR_RootConstrainSelectedInstOperands,
     /*  947633 */     // GIR_Coverage, 63268,
     /*  947633 */     GIR_EraseRootFromParent_Done,
     /*  947634 */   // Label 14301: @947634
     /*  947634 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(947716), // Rule ID 63279 //
     /*  947639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947666 */     // MIs[0] op1
     /*  947666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947693 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947698 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947700 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947702 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947704 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947714 */     GIR_RootConstrainSelectedInstOperands,
     /*  947715 */     // GIR_Coverage, 63279,
     /*  947715 */     GIR_EraseRootFromParent_Done,
     /*  947716 */   // Label 14302: @947716
     /*  947716 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(947798), // Rule ID 63280 //
     /*  947721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947748 */     // MIs[0] op1
     /*  947748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M1),
     /*  947778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947780 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947782 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947784 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947786 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947796 */     GIR_RootConstrainSelectedInstOperands,
     /*  947797 */     // GIR_Coverage, 63280,
     /*  947797 */     GIR_EraseRootFromParent_Done,
     /*  947798 */   // Label 14303: @947798
     /*  947798 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(947880), // Rule ID 63311 //
     /*  947803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947830 */     // MIs[0] op1
     /*  947830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947862 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947864 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947866 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947868 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947878 */     GIR_RootConstrainSelectedInstOperands,
     /*  947879 */     // GIR_Coverage, 63311,
     /*  947879 */     GIR_EraseRootFromParent_Done,
     /*  947880 */   // Label 14304: @947880
     /*  947880 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(947962), // Rule ID 63312 //
     /*  947885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947912 */     // MIs[0] op1
     /*  947912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M1),
     /*  947942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947944 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947946 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947948 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947950 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947960 */     GIR_RootConstrainSelectedInstOperands,
     /*  947961 */     // GIR_Coverage, 63312,
     /*  947961 */     GIR_EraseRootFromParent_Done,
     /*  947962 */   // Label 14305: @947962
     /*  947962 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(948044), // Rule ID 63323 //
     /*  947967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947994 */     // MIs[0] op1
     /*  947994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  948021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  948024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948032 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948042 */     GIR_RootConstrainSelectedInstOperands,
     /*  948043 */     // GIR_Coverage, 63323,
     /*  948043 */     GIR_EraseRootFromParent_Done,
     /*  948044 */   // Label 14306: @948044
     /*  948044 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(948126), // Rule ID 63324 //
     /*  948049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  948069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948076 */     // MIs[0] op1
     /*  948076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  948103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M1),
     /*  948106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948114 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948124 */     GIR_RootConstrainSelectedInstOperands,
     /*  948125 */     // GIR_Coverage, 63324,
     /*  948125 */     GIR_EraseRootFromParent_Done,
     /*  948126 */   // Label 14307: @948126
     /*  948126 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(948208), // Rule ID 63335 //
     /*  948131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948158 */     // MIs[0] op1
     /*  948158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  948178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948185 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  948185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  948188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948190 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948192 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948194 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948196 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948206 */     GIR_RootConstrainSelectedInstOperands,
     /*  948207 */     // GIR_Coverage, 63335,
     /*  948207 */     GIR_EraseRootFromParent_Done,
     /*  948208 */   // Label 14308: @948208
     /*  948208 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(948290), // Rule ID 63336 //
     /*  948213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  948224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  948227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  948230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948240 */     // MIs[0] op1
     /*  948240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  948260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948267 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  948267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M1),
     /*  948270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948278 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  948288 */     GIR_RootConstrainSelectedInstOperands,
     /*  948289 */     // GIR_Coverage, 63336,
     /*  948289 */     GIR_EraseRootFromParent_Done,
     /*  948290 */   // Label 14309: @948290
     /*  948290 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(948372), // Rule ID 63367 //
     /*  948295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948322 */     // MIs[0] op1
     /*  948322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948349 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948354 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948356 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948358 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948360 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948370 */     GIR_RootConstrainSelectedInstOperands,
     /*  948371 */     // GIR_Coverage, 63367,
     /*  948371 */     GIR_EraseRootFromParent_Done,
     /*  948372 */   // Label 14310: @948372
     /*  948372 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(948454), // Rule ID 63368 //
     /*  948377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948404 */     // MIs[0] op1
     /*  948404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  948434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948442 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948452 */     GIR_RootConstrainSelectedInstOperands,
     /*  948453 */     // GIR_Coverage, 63368,
     /*  948453 */     GIR_EraseRootFromParent_Done,
     /*  948454 */   // Label 14311: @948454
     /*  948454 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(948536), // Rule ID 63379 //
     /*  948459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948486 */     // MIs[0] op1
     /*  948486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948518 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948520 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948522 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948524 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948534 */     GIR_RootConstrainSelectedInstOperands,
     /*  948535 */     // GIR_Coverage, 63379,
     /*  948535 */     GIR_EraseRootFromParent_Done,
     /*  948536 */   // Label 14312: @948536
     /*  948536 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(948618), // Rule ID 63380 //
     /*  948541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948568 */     // MIs[0] op1
     /*  948568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948595 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  948598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948606 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948616 */     GIR_RootConstrainSelectedInstOperands,
     /*  948617 */     // GIR_Coverage, 63380,
     /*  948617 */     GIR_EraseRootFromParent_Done,
     /*  948618 */   // Label 14313: @948618
     /*  948618 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(948700), // Rule ID 63411 //
     /*  948623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948650 */     // MIs[0] op1
     /*  948650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948677 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948682 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948684 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948686 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948688 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948698 */     GIR_RootConstrainSelectedInstOperands,
     /*  948699 */     // GIR_Coverage, 63411,
     /*  948699 */     GIR_EraseRootFromParent_Done,
     /*  948700 */   // Label 14314: @948700
     /*  948700 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(948782), // Rule ID 63412 //
     /*  948705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948732 */     // MIs[0] op1
     /*  948732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  948762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948764 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948766 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948768 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948770 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948780 */     GIR_RootConstrainSelectedInstOperands,
     /*  948781 */     // GIR_Coverage, 63412,
     /*  948781 */     GIR_EraseRootFromParent_Done,
     /*  948782 */   // Label 14315: @948782
     /*  948782 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(948864), // Rule ID 63423 //
     /*  948787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948814 */     // MIs[0] op1
     /*  948814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948841 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948846 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948848 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948850 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948852 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948862 */     GIR_RootConstrainSelectedInstOperands,
     /*  948863 */     // GIR_Coverage, 63423,
     /*  948863 */     GIR_EraseRootFromParent_Done,
     /*  948864 */   // Label 14316: @948864
     /*  948864 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(948946), // Rule ID 63424 //
     /*  948869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948896 */     // MIs[0] op1
     /*  948896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948923 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  948926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948928 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948930 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948932 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948934 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948944 */     GIR_RootConstrainSelectedInstOperands,
     /*  948945 */     // GIR_Coverage, 63424,
     /*  948945 */     GIR_EraseRootFromParent_Done,
     /*  948946 */   // Label 14317: @948946
     /*  948946 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(949028), // Rule ID 63455 //
     /*  948951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948978 */     // MIs[0] op1
     /*  948978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949005 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949010 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949012 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949014 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949016 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949026 */     GIR_RootConstrainSelectedInstOperands,
     /*  949027 */     // GIR_Coverage, 63455,
     /*  949027 */     GIR_EraseRootFromParent_Done,
     /*  949028 */   // Label 14318: @949028
     /*  949028 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(949110), // Rule ID 63456 //
     /*  949033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949060 */     // MIs[0] op1
     /*  949060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949087 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  949087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  949090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949092 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949094 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949096 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949098 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949108 */     GIR_RootConstrainSelectedInstOperands,
     /*  949109 */     // GIR_Coverage, 63456,
     /*  949109 */     GIR_EraseRootFromParent_Done,
     /*  949110 */   // Label 14319: @949110
     /*  949110 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(949192), // Rule ID 63467 //
     /*  949115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  949135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949142 */     // MIs[0] op1
     /*  949142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949169 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  949172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949174 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949176 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949178 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949180 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949190 */     GIR_RootConstrainSelectedInstOperands,
     /*  949191 */     // GIR_Coverage, 63467,
     /*  949191 */     GIR_EraseRootFromParent_Done,
     /*  949192 */   // Label 14320: @949192
     /*  949192 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(949274), // Rule ID 63468 //
     /*  949197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  949208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  949211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  949214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  949217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949224 */     // MIs[0] op1
     /*  949224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949251 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  949251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  949254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949256 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949258 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949260 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949262 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949272 */     GIR_RootConstrainSelectedInstOperands,
     /*  949273 */     // GIR_Coverage, 63468,
     /*  949273 */     GIR_EraseRootFromParent_Done,
     /*  949274 */   // Label 14321: @949274
     /*  949274 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(949356), // Rule ID 63499 //
     /*  949279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949306 */     // MIs[0] op1
     /*  949306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  949336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949338 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949340 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949342 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949344 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949354 */     GIR_RootConstrainSelectedInstOperands,
     /*  949355 */     // GIR_Coverage, 63499,
     /*  949355 */     GIR_EraseRootFromParent_Done,
     /*  949356 */   // Label 14322: @949356
     /*  949356 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(949438), // Rule ID 63500 //
     /*  949361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949388 */     // MIs[0] op1
     /*  949388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949415 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  949418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949426 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949436 */     GIR_RootConstrainSelectedInstOperands,
     /*  949437 */     // GIR_Coverage, 63500,
     /*  949437 */     GIR_EraseRootFromParent_Done,
     /*  949438 */   // Label 14323: @949438
     /*  949438 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(949520), // Rule ID 63511 //
     /*  949443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949470 */     // MIs[0] op1
     /*  949470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949497 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949502 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949504 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949506 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949508 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949518 */     GIR_RootConstrainSelectedInstOperands,
     /*  949519 */     // GIR_Coverage, 63511,
     /*  949519 */     GIR_EraseRootFromParent_Done,
     /*  949520 */   // Label 14324: @949520
     /*  949520 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(949602), // Rule ID 63512 //
     /*  949525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949552 */     // MIs[0] op1
     /*  949552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  949582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949584 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949586 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949588 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949590 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949600 */     GIR_RootConstrainSelectedInstOperands,
     /*  949601 */     // GIR_Coverage, 63512,
     /*  949601 */     GIR_EraseRootFromParent_Done,
     /*  949602 */   // Label 14325: @949602
     /*  949602 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(949684), // Rule ID 63523 //
     /*  949607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949634 */     // MIs[0] op1
     /*  949634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949672 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949682 */     GIR_RootConstrainSelectedInstOperands,
     /*  949683 */     // GIR_Coverage, 63523,
     /*  949683 */     GIR_EraseRootFromParent_Done,
     /*  949684 */   // Label 14326: @949684
     /*  949684 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(949766), // Rule ID 63524 //
     /*  949689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949716 */     // MIs[0] op1
     /*  949716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M2),
     /*  949746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949748 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949750 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949752 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949754 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949764 */     GIR_RootConstrainSelectedInstOperands,
     /*  949765 */     // GIR_Coverage, 63524,
     /*  949765 */     GIR_EraseRootFromParent_Done,
     /*  949766 */   // Label 14327: @949766
     /*  949766 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(949848), // Rule ID 63555 //
     /*  949771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949798 */     // MIs[0] op1
     /*  949798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949825 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949836 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949846 */     GIR_RootConstrainSelectedInstOperands,
     /*  949847 */     // GIR_Coverage, 63555,
     /*  949847 */     GIR_EraseRootFromParent_Done,
     /*  949848 */   // Label 14328: @949848
     /*  949848 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(949930), // Rule ID 63556 //
     /*  949853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949880 */     // MIs[0] op1
     /*  949880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949907 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  949910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949912 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949914 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949916 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949918 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949928 */     GIR_RootConstrainSelectedInstOperands,
     /*  949929 */     // GIR_Coverage, 63556,
     /*  949929 */     GIR_EraseRootFromParent_Done,
     /*  949930 */   // Label 14329: @949930
     /*  949930 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(950012), // Rule ID 63567 //
     /*  949935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949962 */     // MIs[0] op1
     /*  949962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  949992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950000 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950010 */     GIR_RootConstrainSelectedInstOperands,
     /*  950011 */     // GIR_Coverage, 63567,
     /*  950011 */     GIR_EraseRootFromParent_Done,
     /*  950012 */   // Label 14330: @950012
     /*  950012 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(950094), // Rule ID 63568 //
     /*  950017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  950037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950044 */     // MIs[0] op1
     /*  950044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  950074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950076 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950078 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950080 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950082 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950092 */     GIR_RootConstrainSelectedInstOperands,
     /*  950093 */     // GIR_Coverage, 63568,
     /*  950093 */     GIR_EraseRootFromParent_Done,
     /*  950094 */   // Label 14331: @950094
     /*  950094 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(950176), // Rule ID 63579 //
     /*  950099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950126 */     // MIs[0] op1
     /*  950126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950153 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  950156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950158 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950160 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950162 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950164 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950174 */     GIR_RootConstrainSelectedInstOperands,
     /*  950175 */     // GIR_Coverage, 63579,
     /*  950175 */     GIR_EraseRootFromParent_Done,
     /*  950176 */   // Label 14332: @950176
     /*  950176 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(950258), // Rule ID 63580 //
     /*  950181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  950192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  950195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  950198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950208 */     // MIs[0] op1
     /*  950208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950235 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M4),
     /*  950238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950240 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950242 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950244 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950246 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950256 */     GIR_RootConstrainSelectedInstOperands,
     /*  950257 */     // GIR_Coverage, 63580,
     /*  950257 */     GIR_EraseRootFromParent_Done,
     /*  950258 */   // Label 14333: @950258
     /*  950258 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(950340), // Rule ID 63611 //
     /*  950263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950290 */     // MIs[0] op1
     /*  950290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950317 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  950320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950322 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950324 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950326 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950328 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950338 */     GIR_RootConstrainSelectedInstOperands,
     /*  950339 */     // GIR_Coverage, 63611,
     /*  950339 */     GIR_EraseRootFromParent_Done,
     /*  950340 */   // Label 14334: @950340
     /*  950340 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(950422), // Rule ID 63612 //
     /*  950345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950372 */     // MIs[0] op1
     /*  950372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950399 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  950402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950404 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950406 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950408 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950410 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950420 */     GIR_RootConstrainSelectedInstOperands,
     /*  950421 */     // GIR_Coverage, 63612,
     /*  950421 */     GIR_EraseRootFromParent_Done,
     /*  950422 */   // Label 14335: @950422
     /*  950422 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(950504), // Rule ID 63623 //
     /*  950427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950454 */     // MIs[0] op1
     /*  950454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950481 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950502 */     GIR_RootConstrainSelectedInstOperands,
     /*  950503 */     // GIR_Coverage, 63623,
     /*  950503 */     GIR_EraseRootFromParent_Done,
     /*  950504 */   // Label 14336: @950504
     /*  950504 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(950586), // Rule ID 63624 //
     /*  950509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950536 */     // MIs[0] op1
     /*  950536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950563 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  950566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950574 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950584 */     GIR_RootConstrainSelectedInstOperands,
     /*  950585 */     // GIR_Coverage, 63624,
     /*  950585 */     GIR_EraseRootFromParent_Done,
     /*  950586 */   // Label 14337: @950586
     /*  950586 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(950668), // Rule ID 63635 //
     /*  950591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950618 */     // MIs[0] op1
     /*  950618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950650 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950652 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950654 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950656 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950666 */     GIR_RootConstrainSelectedInstOperands,
     /*  950667 */     // GIR_Coverage, 63635,
     /*  950667 */     GIR_EraseRootFromParent_Done,
     /*  950668 */   // Label 14338: @950668
     /*  950668 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(950750), // Rule ID 63636 //
     /*  950673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950700 */     // MIs[0] op1
     /*  950700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950727 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VV_M8),
     /*  950730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950738 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950748 */     GIR_RootConstrainSelectedInstOperands,
     /*  950749 */     // GIR_Coverage, 63636,
     /*  950749 */     GIR_EraseRootFromParent_Done,
     /*  950750 */   // Label 14339: @950750
     /*  950750 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(950832), // Rule ID 63667 //
     /*  950755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950782 */     // MIs[0] op1
     /*  950782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950830 */     GIR_RootConstrainSelectedInstOperands,
     /*  950831 */     // GIR_Coverage, 63667,
     /*  950831 */     GIR_EraseRootFromParent_Done,
     /*  950832 */   // Label 14340: @950832
     /*  950832 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(950914), // Rule ID 63668 //
     /*  950837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950864 */     // MIs[0] op1
     /*  950864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950891 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  950894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950896 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950898 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950900 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950902 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950912 */     GIR_RootConstrainSelectedInstOperands,
     /*  950913 */     // GIR_Coverage, 63668,
     /*  950913 */     GIR_EraseRootFromParent_Done,
     /*  950914 */   // Label 14341: @950914
     /*  950914 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(950996), // Rule ID 63679 //
     /*  950919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950946 */     // MIs[0] op1
     /*  950946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  950976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950984 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950994 */     GIR_RootConstrainSelectedInstOperands,
     /*  950995 */     // GIR_Coverage, 63679,
     /*  950995 */     GIR_EraseRootFromParent_Done,
     /*  950996 */   // Label 14342: @950996
     /*  950996 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(951078), // Rule ID 63680 //
     /*  951001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  951021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951028 */     // MIs[0] op1
     /*  951028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  951058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951066 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951076 */     GIR_RootConstrainSelectedInstOperands,
     /*  951077 */     // GIR_Coverage, 63680,
     /*  951077 */     GIR_EraseRootFromParent_Done,
     /*  951078 */   // Label 14343: @951078
     /*  951078 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(951160), // Rule ID 63691 //
     /*  951083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951110 */     // MIs[0] op1
     /*  951110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  951140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951148 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951158 */     GIR_RootConstrainSelectedInstOperands,
     /*  951159 */     // GIR_Coverage, 63691,
     /*  951159 */     GIR_EraseRootFromParent_Done,
     /*  951160 */   // Label 14344: @951160
     /*  951160 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(951242), // Rule ID 63692 //
     /*  951165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  951176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  951179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  951182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951192 */     // MIs[0] op1
     /*  951192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M2),
     /*  951222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951224 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951226 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951228 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951230 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951240 */     GIR_RootConstrainSelectedInstOperands,
     /*  951241 */     // GIR_Coverage, 63692,
     /*  951241 */     GIR_EraseRootFromParent_Done,
     /*  951242 */   // Label 14345: @951242
     /*  951242 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(951324), // Rule ID 63723 //
     /*  951247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951274 */     // MIs[0] op1
     /*  951274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  951304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951312 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951322 */     GIR_RootConstrainSelectedInstOperands,
     /*  951323 */     // GIR_Coverage, 63723,
     /*  951323 */     GIR_EraseRootFromParent_Done,
     /*  951324 */   // Label 14346: @951324
     /*  951324 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(951406), // Rule ID 63724 //
     /*  951329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951356 */     // MIs[0] op1
     /*  951356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  951386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951388 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951390 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951392 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951394 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951404 */     GIR_RootConstrainSelectedInstOperands,
     /*  951405 */     // GIR_Coverage, 63724,
     /*  951405 */     GIR_EraseRootFromParent_Done,
     /*  951406 */   // Label 14347: @951406
     /*  951406 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(951488), // Rule ID 63735 //
     /*  951411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951438 */     // MIs[0] op1
     /*  951438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951465 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951476 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951486 */     GIR_RootConstrainSelectedInstOperands,
     /*  951487 */     // GIR_Coverage, 63735,
     /*  951487 */     GIR_EraseRootFromParent_Done,
     /*  951488 */   // Label 14348: @951488
     /*  951488 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(951570), // Rule ID 63736 //
     /*  951493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951520 */     // MIs[0] op1
     /*  951520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951547 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  951550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951552 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951554 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951556 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951558 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951568 */     GIR_RootConstrainSelectedInstOperands,
     /*  951569 */     // GIR_Coverage, 63736,
     /*  951569 */     GIR_EraseRootFromParent_Done,
     /*  951570 */   // Label 14349: @951570
     /*  951570 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(951652), // Rule ID 63747 //
     /*  951575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951602 */     // MIs[0] op1
     /*  951602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951634 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951636 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951638 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951640 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951650 */     GIR_RootConstrainSelectedInstOperands,
     /*  951651 */     // GIR_Coverage, 63747,
     /*  951651 */     GIR_EraseRootFromParent_Done,
     /*  951652 */   // Label 14350: @951652
     /*  951652 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(951734), // Rule ID 63748 //
     /*  951657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951684 */     // MIs[0] op1
     /*  951684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M4),
     /*  951714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951716 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951718 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951720 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951722 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951732 */     GIR_RootConstrainSelectedInstOperands,
     /*  951733 */     // GIR_Coverage, 63748,
     /*  951733 */     GIR_EraseRootFromParent_Done,
     /*  951734 */   // Label 14351: @951734
     /*  951734 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(951816), // Rule ID 63779 //
     /*  951739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951766 */     // MIs[0] op1
     /*  951766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951814 */     GIR_RootConstrainSelectedInstOperands,
     /*  951815 */     // GIR_Coverage, 63779,
     /*  951815 */     GIR_EraseRootFromParent_Done,
     /*  951816 */   // Label 14352: @951816
     /*  951816 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(951898), // Rule ID 63780 //
     /*  951821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951848 */     // MIs[0] op1
     /*  951848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  951878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951880 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951882 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951884 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951886 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951896 */     GIR_RootConstrainSelectedInstOperands,
     /*  951897 */     // GIR_Coverage, 63780,
     /*  951897 */     GIR_EraseRootFromParent_Done,
     /*  951898 */   // Label 14353: @951898
     /*  951898 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(951980), // Rule ID 63791 //
     /*  951903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951930 */     // MIs[0] op1
     /*  951930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951957 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  951960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951962 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951964 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951966 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951968 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951978 */     GIR_RootConstrainSelectedInstOperands,
     /*  951979 */     // GIR_Coverage, 63791,
     /*  951979 */     GIR_EraseRootFromParent_Done,
     /*  951980 */   // Label 14354: @951980
     /*  951980 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(952062), // Rule ID 63792 //
     /*  951985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  952005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952012 */     // MIs[0] op1
     /*  952012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  952039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  952042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952044 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952046 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952048 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952050 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952060 */     GIR_RootConstrainSelectedInstOperands,
     /*  952061 */     // GIR_Coverage, 63792,
     /*  952061 */     GIR_EraseRootFromParent_Done,
     /*  952062 */   // Label 14355: @952062
     /*  952062 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(952144), // Rule ID 63803 //
     /*  952067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  952081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952094 */     // MIs[0] op1
     /*  952094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  952114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  952121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  952124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952132 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952142 */     GIR_RootConstrainSelectedInstOperands,
     /*  952143 */     // GIR_Coverage, 63803,
     /*  952143 */     GIR_EraseRootFromParent_Done,
     /*  952144 */   // Label 14356: @952144
     /*  952144 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(952226), // Rule ID 63804 //
     /*  952149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  952160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  952163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  952166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952176 */     // MIs[0] op1
     /*  952176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  952196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952203 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  952203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VV_M8),
     /*  952206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952208 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952210 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952212 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952214 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  952224 */     GIR_RootConstrainSelectedInstOperands,
     /*  952225 */     // GIR_Coverage, 63804,
     /*  952225 */     GIR_EraseRootFromParent_Done,
     /*  952226 */   // Label 14357: @952226
     /*  952226 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(952308), // Rule ID 63835 //
     /*  952231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952258 */     // MIs[0] op1
     /*  952258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  952288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952290 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952292 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952294 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952296 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952306 */     GIR_RootConstrainSelectedInstOperands,
     /*  952307 */     // GIR_Coverage, 63835,
     /*  952307 */     GIR_EraseRootFromParent_Done,
     /*  952308 */   // Label 14358: @952308
     /*  952308 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(952390), // Rule ID 63836 //
     /*  952313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952340 */     // MIs[0] op1
     /*  952340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M2),
     /*  952370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952372 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952374 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952376 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952378 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952388 */     GIR_RootConstrainSelectedInstOperands,
     /*  952389 */     // GIR_Coverage, 63836,
     /*  952389 */     GIR_EraseRootFromParent_Done,
     /*  952390 */   // Label 14359: @952390
     /*  952390 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(952472), // Rule ID 63847 //
     /*  952395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952422 */     // MIs[0] op1
     /*  952422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  952452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952460 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952470 */     GIR_RootConstrainSelectedInstOperands,
     /*  952471 */     // GIR_Coverage, 63847,
     /*  952471 */     GIR_EraseRootFromParent_Done,
     /*  952472 */   // Label 14360: @952472
     /*  952472 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(952554), // Rule ID 63848 //
     /*  952477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952504 */     // MIs[0] op1
     /*  952504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M2),
     /*  952534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952536 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952538 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952540 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952542 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952552 */     GIR_RootConstrainSelectedInstOperands,
     /*  952553 */     // GIR_Coverage, 63848,
     /*  952553 */     GIR_EraseRootFromParent_Done,
     /*  952554 */   // Label 14361: @952554
     /*  952554 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(952636), // Rule ID 63859 //
     /*  952559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952586 */     // MIs[0] op1
     /*  952586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952618 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952620 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952622 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952624 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952634 */     GIR_RootConstrainSelectedInstOperands,
     /*  952635 */     // GIR_Coverage, 63859,
     /*  952635 */     GIR_EraseRootFromParent_Done,
     /*  952636 */   // Label 14362: @952636
     /*  952636 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(952718), // Rule ID 63860 //
     /*  952641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952668 */     // MIs[0] op1
     /*  952668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M2),
     /*  952698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952700 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952702 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952704 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952706 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952716 */     GIR_RootConstrainSelectedInstOperands,
     /*  952717 */     // GIR_Coverage, 63860,
     /*  952717 */     GIR_EraseRootFromParent_Done,
     /*  952718 */   // Label 14363: @952718
     /*  952718 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(952800), // Rule ID 63891 //
     /*  952723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952750 */     // MIs[0] op1
     /*  952750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952777 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952782 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952784 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952786 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952788 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952798 */     GIR_RootConstrainSelectedInstOperands,
     /*  952799 */     // GIR_Coverage, 63891,
     /*  952799 */     GIR_EraseRootFromParent_Done,
     /*  952800 */   // Label 14364: @952800
     /*  952800 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(952882), // Rule ID 63892 //
     /*  952805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952832 */     // MIs[0] op1
     /*  952832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M4),
     /*  952862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952864 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952866 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952868 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952870 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952880 */     GIR_RootConstrainSelectedInstOperands,
     /*  952881 */     // GIR_Coverage, 63892,
     /*  952881 */     GIR_EraseRootFromParent_Done,
     /*  952882 */   // Label 14365: @952882
     /*  952882 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(952964), // Rule ID 63903 //
     /*  952887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952914 */     // MIs[0] op1
     /*  952914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  952944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952946 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952948 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952950 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952952 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952962 */     GIR_RootConstrainSelectedInstOperands,
     /*  952963 */     // GIR_Coverage, 63903,
     /*  952963 */     GIR_EraseRootFromParent_Done,
     /*  952964 */   // Label 14366: @952964
     /*  952964 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(953046), // Rule ID 63904 //
     /*  952969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952996 */     // MIs[0] op1
     /*  952996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M4),
     /*  953026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953028 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953030 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953032 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953034 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953044 */     GIR_RootConstrainSelectedInstOperands,
     /*  953045 */     // GIR_Coverage, 63904,
     /*  953045 */     GIR_EraseRootFromParent_Done,
     /*  953046 */   // Label 14367: @953046
     /*  953046 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(953128), // Rule ID 63915 //
     /*  953051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  953065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  953068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953078 */     // MIs[0] op1
     /*  953078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953105 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  953108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953110 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953112 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953114 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953116 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953126 */     GIR_RootConstrainSelectedInstOperands,
     /*  953127 */     // GIR_Coverage, 63915,
     /*  953127 */     GIR_EraseRootFromParent_Done,
     /*  953128 */   // Label 14368: @953128
     /*  953128 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(953210), // Rule ID 63916 //
     /*  953133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  953144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  953147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  953150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953160 */     // MIs[0] op1
     /*  953160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953187 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M4),
     /*  953190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953192 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953194 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953196 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953198 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953208 */     GIR_RootConstrainSelectedInstOperands,
     /*  953209 */     // GIR_Coverage, 63916,
     /*  953209 */     GIR_EraseRootFromParent_Done,
     /*  953210 */   // Label 14369: @953210
     /*  953210 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(953292), // Rule ID 63947 //
     /*  953215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953242 */     // MIs[0] op1
     /*  953242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  953272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953280 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953290 */     GIR_RootConstrainSelectedInstOperands,
     /*  953291 */     // GIR_Coverage, 63947,
     /*  953291 */     GIR_EraseRootFromParent_Done,
     /*  953292 */   // Label 14370: @953292
     /*  953292 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(953374), // Rule ID 63948 //
     /*  953297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953324 */     // MIs[0] op1
     /*  953324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVV_M8),
     /*  953354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953356 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953358 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953360 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953362 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953372 */     GIR_RootConstrainSelectedInstOperands,
     /*  953373 */     // GIR_Coverage, 63948,
     /*  953373 */     GIR_EraseRootFromParent_Done,
     /*  953374 */   // Label 14371: @953374
     /*  953374 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(953456), // Rule ID 63959 //
     /*  953379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953406 */     // MIs[0] op1
     /*  953406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953433 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  953436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953444 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953454 */     GIR_RootConstrainSelectedInstOperands,
     /*  953455 */     // GIR_Coverage, 63959,
     /*  953455 */     GIR_EraseRootFromParent_Done,
     /*  953456 */   // Label 14372: @953456
     /*  953456 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(953538), // Rule ID 63960 //
     /*  953461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953488 */     // MIs[0] op1
     /*  953488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953515 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVV_M8),
     /*  953518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953526 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953536 */     GIR_RootConstrainSelectedInstOperands,
     /*  953537 */     // GIR_Coverage, 63960,
     /*  953537 */     GIR_EraseRootFromParent_Done,
     /*  953538 */   // Label 14373: @953538
     /*  953538 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(953620), // Rule ID 63971 //
     /*  953543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953570 */     // MIs[0] op1
     /*  953570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953597 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953608 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953618 */     GIR_RootConstrainSelectedInstOperands,
     /*  953619 */     // GIR_Coverage, 63971,
     /*  953619 */     GIR_EraseRootFromParent_Done,
     /*  953620 */   // Label 14374: @953620
     /*  953620 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(953702), // Rule ID 63972 //
     /*  953625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953652 */     // MIs[0] op1
     /*  953652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953679 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR64VV_M8),
     /*  953682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953684 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953686 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953688 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953690 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953700 */     GIR_RootConstrainSelectedInstOperands,
     /*  953701 */     // GIR_Coverage, 63972,
     /*  953701 */     GIR_EraseRootFromParent_Done,
     /*  953702 */   // Label 14375: @953702
     /*  953702 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(953784), // Rule ID 63977 //
     /*  953707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953734 */     // MIs[0] op1
     /*  953734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953766 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953768 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953770 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953772 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953782 */     GIR_RootConstrainSelectedInstOperands,
     /*  953783 */     // GIR_Coverage, 63977,
     /*  953783 */     GIR_EraseRootFromParent_Done,
     /*  953784 */   // Label 14376: @953784
     /*  953784 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(953866), // Rule ID 63978 //
     /*  953789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953816 */     // MIs[0] op1
     /*  953816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF8),
     /*  953846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953848 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953850 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953852 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953854 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953864 */     GIR_RootConstrainSelectedInstOperands,
     /*  953865 */     // GIR_Coverage, 63978,
     /*  953865 */     GIR_EraseRootFromParent_Done,
     /*  953866 */   // Label 14377: @953866
     /*  953866 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(953948), // Rule ID 63989 //
     /*  953871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953898 */     // MIs[0] op1
     /*  953898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953925 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  953928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953936 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953946 */     GIR_RootConstrainSelectedInstOperands,
     /*  953947 */     // GIR_Coverage, 63989,
     /*  953947 */     GIR_EraseRootFromParent_Done,
     /*  953948 */   // Label 14378: @953948
     /*  953948 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(954030), // Rule ID 63990 //
     /*  953953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953980 */     // MIs[0] op1
     /*  953980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954007 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF8),
     /*  954010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954012 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954014 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954016 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954018 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954028 */     GIR_RootConstrainSelectedInstOperands,
     /*  954029 */     // GIR_Coverage, 63990,
     /*  954029 */     GIR_EraseRootFromParent_Done,
     /*  954030 */   // Label 14379: @954030
     /*  954030 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(954112), // Rule ID 63995 //
     /*  954035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954062 */     // MIs[0] op1
     /*  954062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954089 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  954092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954094 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954096 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954098 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954100 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954110 */     GIR_RootConstrainSelectedInstOperands,
     /*  954111 */     // GIR_Coverage, 63995,
     /*  954111 */     GIR_EraseRootFromParent_Done,
     /*  954112 */   // Label 14380: @954112
     /*  954112 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(954194), // Rule ID 63996 //
     /*  954117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954144 */     // MIs[0] op1
     /*  954144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  954174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954176 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954178 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954180 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954182 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954192 */     GIR_RootConstrainSelectedInstOperands,
     /*  954193 */     // GIR_Coverage, 63996,
     /*  954193 */     GIR_EraseRootFromParent_Done,
     /*  954194 */   // Label 14381: @954194
     /*  954194 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(954276), // Rule ID 64007 //
     /*  954199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  954219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954226 */     // MIs[0] op1
     /*  954226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  954256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954258 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954260 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954262 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954264 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954274 */     GIR_RootConstrainSelectedInstOperands,
     /*  954275 */     // GIR_Coverage, 64007,
     /*  954275 */     GIR_EraseRootFromParent_Done,
     /*  954276 */   // Label 14382: @954276
     /*  954276 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(954358), // Rule ID 64008 //
     /*  954281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  954292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  954295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  954298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  954301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954308 */     // MIs[0] op1
     /*  954308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954335 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  954338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954340 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954342 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954344 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954346 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954356 */     GIR_RootConstrainSelectedInstOperands,
     /*  954357 */     // GIR_Coverage, 64008,
     /*  954357 */     GIR_EraseRootFromParent_Done,
     /*  954358 */   // Label 14383: @954358
     /*  954358 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(954440), // Rule ID 64013 //
     /*  954363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954390 */     // MIs[0] op1
     /*  954390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954417 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  954420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954422 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954424 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954426 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954428 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954438 */     GIR_RootConstrainSelectedInstOperands,
     /*  954439 */     // GIR_Coverage, 64013,
     /*  954439 */     GIR_EraseRootFromParent_Done,
     /*  954440 */   // Label 14384: @954440
     /*  954440 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(954522), // Rule ID 64014 //
     /*  954445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954472 */     // MIs[0] op1
     /*  954472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  954502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954504 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954506 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954508 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954510 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954520 */     GIR_RootConstrainSelectedInstOperands,
     /*  954521 */     // GIR_Coverage, 64014,
     /*  954521 */     GIR_EraseRootFromParent_Done,
     /*  954522 */   // Label 14385: @954522
     /*  954522 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(954604), // Rule ID 64025 //
     /*  954527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954554 */     // MIs[0] op1
     /*  954554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954581 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954592 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954602 */     GIR_RootConstrainSelectedInstOperands,
     /*  954603 */     // GIR_Coverage, 64025,
     /*  954603 */     GIR_EraseRootFromParent_Done,
     /*  954604 */   // Label 14386: @954604
     /*  954604 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(954686), // Rule ID 64026 //
     /*  954609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954636 */     // MIs[0] op1
     /*  954636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954663 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  954666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954668 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954670 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954672 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954674 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954684 */     GIR_RootConstrainSelectedInstOperands,
     /*  954685 */     // GIR_Coverage, 64026,
     /*  954685 */     GIR_EraseRootFromParent_Done,
     /*  954686 */   // Label 14387: @954686
     /*  954686 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(954768), // Rule ID 64031 //
     /*  954691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954718 */     // MIs[0] op1
     /*  954718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954745 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954750 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954752 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954754 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954756 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954766 */     GIR_RootConstrainSelectedInstOperands,
     /*  954767 */     // GIR_Coverage, 64031,
     /*  954767 */     GIR_EraseRootFromParent_Done,
     /*  954768 */   // Label 14388: @954768
     /*  954768 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(954850), // Rule ID 64032 //
     /*  954773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954800 */     // MIs[0] op1
     /*  954800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  954830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954832 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954834 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954836 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954838 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954848 */     GIR_RootConstrainSelectedInstOperands,
     /*  954849 */     // GIR_Coverage, 64032,
     /*  954849 */     GIR_EraseRootFromParent_Done,
     /*  954850 */   // Label 14389: @954850
     /*  954850 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(954932), // Rule ID 64043 //
     /*  954855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954882 */     // MIs[0] op1
     /*  954882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  954912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954920 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954930 */     GIR_RootConstrainSelectedInstOperands,
     /*  954931 */     // GIR_Coverage, 64043,
     /*  954931 */     GIR_EraseRootFromParent_Done,
     /*  954932 */   // Label 14390: @954932
     /*  954932 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(955014), // Rule ID 64044 //
     /*  954937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954964 */     // MIs[0] op1
     /*  954964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  954994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954996 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954998 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955000 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955002 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955012 */     GIR_RootConstrainSelectedInstOperands,
     /*  955013 */     // GIR_Coverage, 64044,
     /*  955013 */     GIR_EraseRootFromParent_Done,
     /*  955014 */   // Label 14391: @955014
     /*  955014 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(955096), // Rule ID 64049 //
     /*  955019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955046 */     // MIs[0] op1
     /*  955046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955073 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  955076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955078 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955080 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955082 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955084 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955094 */     GIR_RootConstrainSelectedInstOperands,
     /*  955095 */     // GIR_Coverage, 64049,
     /*  955095 */     GIR_EraseRootFromParent_Done,
     /*  955096 */   // Label 14392: @955096
     /*  955096 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(955178), // Rule ID 64050 //
     /*  955101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955128 */     // MIs[0] op1
     /*  955128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955155 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  955158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955160 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955162 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955164 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955166 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955176 */     GIR_RootConstrainSelectedInstOperands,
     /*  955177 */     // GIR_Coverage, 64050,
     /*  955177 */     GIR_EraseRootFromParent_Done,
     /*  955178 */   // Label 14393: @955178
     /*  955178 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(955260), // Rule ID 64061 //
     /*  955183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  955203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955210 */     // MIs[0] op1
     /*  955210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  955240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955242 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955244 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955246 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955248 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955258 */     GIR_RootConstrainSelectedInstOperands,
     /*  955259 */     // GIR_Coverage, 64061,
     /*  955259 */     GIR_EraseRootFromParent_Done,
     /*  955260 */   // Label 14394: @955260
     /*  955260 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(955342), // Rule ID 64062 //
     /*  955265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  955276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  955279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  955282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  955285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955292 */     // MIs[0] op1
     /*  955292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955319 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  955322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955324 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955326 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955328 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955330 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955340 */     GIR_RootConstrainSelectedInstOperands,
     /*  955341 */     // GIR_Coverage, 64062,
     /*  955341 */     GIR_EraseRootFromParent_Done,
     /*  955342 */   // Label 14395: @955342
     /*  955342 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(955424), // Rule ID 64067 //
     /*  955347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955374 */     // MIs[0] op1
     /*  955374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  955404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955406 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955408 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955410 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955412 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955422 */     GIR_RootConstrainSelectedInstOperands,
     /*  955423 */     // GIR_Coverage, 64067,
     /*  955423 */     GIR_EraseRootFromParent_Done,
     /*  955424 */   // Label 14396: @955424
     /*  955424 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(955506), // Rule ID 64068 //
     /*  955429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955456 */     // MIs[0] op1
     /*  955456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955483 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  955486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955494 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955504 */     GIR_RootConstrainSelectedInstOperands,
     /*  955505 */     // GIR_Coverage, 64068,
     /*  955505 */     GIR_EraseRootFromParent_Done,
     /*  955506 */   // Label 14397: @955506
     /*  955506 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(955588), // Rule ID 64079 //
     /*  955511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955538 */     // MIs[0] op1
     /*  955538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955570 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955572 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955574 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955576 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955586 */     GIR_RootConstrainSelectedInstOperands,
     /*  955587 */     // GIR_Coverage, 64079,
     /*  955587 */     GIR_EraseRootFromParent_Done,
     /*  955588 */   // Label 14398: @955588
     /*  955588 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(955670), // Rule ID 64080 //
     /*  955593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955620 */     // MIs[0] op1
     /*  955620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955647 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  955650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955668 */     GIR_RootConstrainSelectedInstOperands,
     /*  955669 */     // GIR_Coverage, 64080,
     /*  955669 */     GIR_EraseRootFromParent_Done,
     /*  955670 */   // Label 14399: @955670
     /*  955670 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(955752), // Rule ID 64085 //
     /*  955675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955702 */     // MIs[0] op1
     /*  955702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955729 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955734 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955736 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955738 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955740 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955750 */     GIR_RootConstrainSelectedInstOperands,
     /*  955751 */     // GIR_Coverage, 64085,
     /*  955751 */     GIR_EraseRootFromParent_Done,
     /*  955752 */   // Label 14400: @955752
     /*  955752 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(955834), // Rule ID 64086 //
     /*  955757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955784 */     // MIs[0] op1
     /*  955784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF4),
     /*  955814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955816 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955818 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955820 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955822 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955832 */     GIR_RootConstrainSelectedInstOperands,
     /*  955833 */     // GIR_Coverage, 64086,
     /*  955833 */     GIR_EraseRootFromParent_Done,
     /*  955834 */   // Label 14401: @955834
     /*  955834 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(955916), // Rule ID 64097 //
     /*  955839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955866 */     // MIs[0] op1
     /*  955866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955893 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955898 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955900 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955902 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955904 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955914 */     GIR_RootConstrainSelectedInstOperands,
     /*  955915 */     // GIR_Coverage, 64097,
     /*  955915 */     GIR_EraseRootFromParent_Done,
     /*  955916 */   // Label 14402: @955916
     /*  955916 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(955998), // Rule ID 64098 //
     /*  955921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955948 */     // MIs[0] op1
     /*  955948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955975 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF4),
     /*  955978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955996 */     GIR_RootConstrainSelectedInstOperands,
     /*  955997 */     // GIR_Coverage, 64098,
     /*  955997 */     GIR_EraseRootFromParent_Done,
     /*  955998 */   // Label 14403: @955998
     /*  955998 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(956080), // Rule ID 64103 //
     /*  956003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  956014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  956017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  956020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956030 */     // MIs[0] op1
     /*  956030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956057 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  956060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956062 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956064 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956066 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956068 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956078 */     GIR_RootConstrainSelectedInstOperands,
     /*  956079 */     // GIR_Coverage, 64103,
     /*  956079 */     GIR_EraseRootFromParent_Done,
     /*  956080 */   // Label 14404: @956080
     /*  956080 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(956162), // Rule ID 64104 //
     /*  956085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  956096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  956099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  956102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956112 */     // MIs[0] op1
     /*  956112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956139 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF4),
     /*  956142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956150 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956160 */     GIR_RootConstrainSelectedInstOperands,
     /*  956161 */     // GIR_Coverage, 64104,
     /*  956161 */     GIR_EraseRootFromParent_Done,
     /*  956162 */   // Label 14405: @956162
     /*  956162 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(956244), // Rule ID 64109 //
     /*  956167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956194 */     // MIs[0] op1
     /*  956194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956221 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  956224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956226 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956228 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956230 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956232 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956242 */     GIR_RootConstrainSelectedInstOperands,
     /*  956243 */     // GIR_Coverage, 64109,
     /*  956243 */     GIR_EraseRootFromParent_Done,
     /*  956244 */   // Label 14406: @956244
     /*  956244 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(956326), // Rule ID 64110 //
     /*  956249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956276 */     // MIs[0] op1
     /*  956276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  956306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956314 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956324 */     GIR_RootConstrainSelectedInstOperands,
     /*  956325 */     // GIR_Coverage, 64110,
     /*  956325 */     GIR_EraseRootFromParent_Done,
     /*  956326 */   // Label 14407: @956326
     /*  956326 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(956408), // Rule ID 64121 //
     /*  956331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  956351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956358 */     // MIs[0] op1
     /*  956358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956385 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  956388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956390 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956392 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956394 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956396 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956406 */     GIR_RootConstrainSelectedInstOperands,
     /*  956407 */     // GIR_Coverage, 64121,
     /*  956407 */     GIR_EraseRootFromParent_Done,
     /*  956408 */   // Label 14408: @956408
     /*  956408 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(956490), // Rule ID 64122 //
     /*  956413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  956433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956440 */     // MIs[0] op1
     /*  956440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956467 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  956470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956472 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956474 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956476 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956478 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956488 */     GIR_RootConstrainSelectedInstOperands,
     /*  956489 */     // GIR_Coverage, 64122,
     /*  956489 */     GIR_EraseRootFromParent_Done,
     /*  956490 */   // Label 14409: @956490
     /*  956490 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(956572), // Rule ID 64127 //
     /*  956495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956522 */     // MIs[0] op1
     /*  956522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956554 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956556 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956558 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956560 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956570 */     GIR_RootConstrainSelectedInstOperands,
     /*  956571 */     // GIR_Coverage, 64127,
     /*  956571 */     GIR_EraseRootFromParent_Done,
     /*  956572 */   // Label 14410: @956572
     /*  956572 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(956654), // Rule ID 64128 //
     /*  956577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956604 */     // MIs[0] op1
     /*  956604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956631 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_MF2),
     /*  956634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956652 */     GIR_RootConstrainSelectedInstOperands,
     /*  956653 */     // GIR_Coverage, 64128,
     /*  956653 */     GIR_EraseRootFromParent_Done,
     /*  956654 */   // Label 14411: @956654
     /*  956654 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(956736), // Rule ID 64133 //
     /*  956659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956686 */     // MIs[0] op1
     /*  956686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956724 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956734 */     GIR_RootConstrainSelectedInstOperands,
     /*  956735 */     // GIR_Coverage, 64133,
     /*  956735 */     GIR_EraseRootFromParent_Done,
     /*  956736 */   // Label 14412: @956736
     /*  956736 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(956818), // Rule ID 64134 //
     /*  956741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956768 */     // MIs[0] op1
     /*  956768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  956798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956816 */     GIR_RootConstrainSelectedInstOperands,
     /*  956817 */     // GIR_Coverage, 64134,
     /*  956817 */     GIR_EraseRootFromParent_Done,
     /*  956818 */   // Label 14413: @956818
     /*  956818 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(956900), // Rule ID 64145 //
     /*  956823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956850 */     // MIs[0] op1
     /*  956850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956882 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956884 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956886 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956888 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956898 */     GIR_RootConstrainSelectedInstOperands,
     /*  956899 */     // GIR_Coverage, 64145,
     /*  956899 */     GIR_EraseRootFromParent_Done,
     /*  956900 */   // Label 14414: @956900
     /*  956900 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(956982), // Rule ID 64146 //
     /*  956905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956932 */     // MIs[0] op1
     /*  956932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  956962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956980 */     GIR_RootConstrainSelectedInstOperands,
     /*  956981 */     // GIR_Coverage, 64146,
     /*  956981 */     GIR_EraseRootFromParent_Done,
     /*  956982 */   // Label 14415: @956982
     /*  956982 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(957064), // Rule ID 64151 //
     /*  956987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  957001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  957004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957014 */     // MIs[0] op1
     /*  957014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  957044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957046 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957048 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957050 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957052 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957062 */     GIR_RootConstrainSelectedInstOperands,
     /*  957063 */     // GIR_Coverage, 64151,
     /*  957063 */     GIR_EraseRootFromParent_Done,
     /*  957064 */   // Label 14416: @957064
     /*  957064 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(957146), // Rule ID 64152 //
     /*  957069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  957080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  957083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  957086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957096 */     // MIs[0] op1
     /*  957096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M1),
     /*  957126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957134 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957144 */     GIR_RootConstrainSelectedInstOperands,
     /*  957145 */     // GIR_Coverage, 64152,
     /*  957145 */     GIR_EraseRootFromParent_Done,
     /*  957146 */   // Label 14417: @957146
     /*  957146 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(957228), // Rule ID 64157 //
     /*  957151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957178 */     // MIs[0] op1
     /*  957178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957205 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  957208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957216 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957226 */     GIR_RootConstrainSelectedInstOperands,
     /*  957227 */     // GIR_Coverage, 64157,
     /*  957227 */     GIR_EraseRootFromParent_Done,
     /*  957228 */   // Label 14418: @957228
     /*  957228 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(957310), // Rule ID 64158 //
     /*  957233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957260 */     // MIs[0] op1
     /*  957260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957287 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  957290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957298 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957308 */     GIR_RootConstrainSelectedInstOperands,
     /*  957309 */     // GIR_Coverage, 64158,
     /*  957309 */     GIR_EraseRootFromParent_Done,
     /*  957310 */   // Label 14419: @957310
     /*  957310 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(957392), // Rule ID 64169 //
     /*  957315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  957335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957342 */     // MIs[0] op1
     /*  957342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  957372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957380 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957390 */     GIR_RootConstrainSelectedInstOperands,
     /*  957391 */     // GIR_Coverage, 64169,
     /*  957391 */     GIR_EraseRootFromParent_Done,
     /*  957392 */   // Label 14420: @957392
     /*  957392 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(957474), // Rule ID 64170 //
     /*  957397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  957417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957424 */     // MIs[0] op1
     /*  957424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  957454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957462 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957472 */     GIR_RootConstrainSelectedInstOperands,
     /*  957473 */     // GIR_Coverage, 64170,
     /*  957473 */     GIR_EraseRootFromParent_Done,
     /*  957474 */   // Label 14421: @957474
     /*  957474 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(957556), // Rule ID 64175 //
     /*  957479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957506 */     // MIs[0] op1
     /*  957506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957533 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957544 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957554 */     GIR_RootConstrainSelectedInstOperands,
     /*  957555 */     // GIR_Coverage, 64175,
     /*  957555 */     GIR_EraseRootFromParent_Done,
     /*  957556 */   // Label 14422: @957556
     /*  957556 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(957638), // Rule ID 64176 //
     /*  957561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957588 */     // MIs[0] op1
     /*  957588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957615 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M2),
     /*  957618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957620 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957622 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957624 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957626 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957636 */     GIR_RootConstrainSelectedInstOperands,
     /*  957637 */     // GIR_Coverage, 64176,
     /*  957637 */     GIR_EraseRootFromParent_Done,
     /*  957638 */   // Label 14423: @957638
     /*  957638 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(957720), // Rule ID 64181 //
     /*  957643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957670 */     // MIs[0] op1
     /*  957670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957697 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957708 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957718 */     GIR_RootConstrainSelectedInstOperands,
     /*  957719 */     // GIR_Coverage, 64181,
     /*  957719 */     GIR_EraseRootFromParent_Done,
     /*  957720 */   // Label 14424: @957720
     /*  957720 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(957802), // Rule ID 64182 //
     /*  957725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957752 */     // MIs[0] op1
     /*  957752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957779 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  957782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957790 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957800 */     GIR_RootConstrainSelectedInstOperands,
     /*  957801 */     // GIR_Coverage, 64182,
     /*  957801 */     GIR_EraseRootFromParent_Done,
     /*  957802 */   // Label 14425: @957802
     /*  957802 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(957884), // Rule ID 64193 //
     /*  957807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957834 */     // MIs[0] op1
     /*  957834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957872 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957882 */     GIR_RootConstrainSelectedInstOperands,
     /*  957883 */     // GIR_Coverage, 64193,
     /*  957883 */     GIR_EraseRootFromParent_Done,
     /*  957884 */   // Label 14426: @957884
     /*  957884 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(957966), // Rule ID 64194 //
     /*  957889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957916 */     // MIs[0] op1
     /*  957916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  957946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957948 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957950 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957952 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957954 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957964 */     GIR_RootConstrainSelectedInstOperands,
     /*  957965 */     // GIR_Coverage, 64194,
     /*  957965 */     GIR_EraseRootFromParent_Done,
     /*  957966 */   // Label 14427: @957966
     /*  957966 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(958048), // Rule ID 64199 //
     /*  957971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957998 */     // MIs[0] op1
     /*  957998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  958018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  958025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  958028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958030 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958032 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958034 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958036 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958046 */     GIR_RootConstrainSelectedInstOperands,
     /*  958047 */     // GIR_Coverage, 64199,
     /*  958047 */     GIR_EraseRootFromParent_Done,
     /*  958048 */   // Label 14428: @958048
     /*  958048 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(958130), // Rule ID 64200 //
     /*  958053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  958064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  958067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  958070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  958073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958080 */     // MIs[0] op1
     /*  958080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  958100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  958107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR16VW_M4),
     /*  958110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958112 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958114 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958116 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958118 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  958128 */     GIR_RootConstrainSelectedInstOperands,
     /*  958129 */     // GIR_Coverage, 64200,
     /*  958129 */     GIR_EraseRootFromParent_Done,
     /*  958130 */   // Label 14429: @958130
     /*  958130 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(958212), // Rule ID 64205 //
     /*  958135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958162 */     // MIs[0] op1
     /*  958162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  958192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958200 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958210 */     GIR_RootConstrainSelectedInstOperands,
     /*  958211 */     // GIR_Coverage, 64205,
     /*  958211 */     GIR_EraseRootFromParent_Done,
     /*  958212 */   // Label 14430: @958212
     /*  958212 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(958294), // Rule ID 64206 //
     /*  958217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958244 */     // MIs[0] op1
     /*  958244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_MF2),
     /*  958274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958282 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958292 */     GIR_RootConstrainSelectedInstOperands,
     /*  958293 */     // GIR_Coverage, 64206,
     /*  958293 */     GIR_EraseRootFromParent_Done,
     /*  958294 */   // Label 14431: @958294
     /*  958294 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(958376), // Rule ID 64217 //
     /*  958299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  958319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958326 */     // MIs[0] op1
     /*  958326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958353 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  958356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958358 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958360 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958362 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958364 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958374 */     GIR_RootConstrainSelectedInstOperands,
     /*  958375 */     // GIR_Coverage, 64217,
     /*  958375 */     GIR_EraseRootFromParent_Done,
     /*  958376 */   // Label 14432: @958376
     /*  958376 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(958458), // Rule ID 64218 //
     /*  958381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  958401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958408 */     // MIs[0] op1
     /*  958408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958435 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_MF2),
     /*  958438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958456 */     GIR_RootConstrainSelectedInstOperands,
     /*  958457 */     // GIR_Coverage, 64218,
     /*  958457 */     GIR_EraseRootFromParent_Done,
     /*  958458 */   // Label 14433: @958458
     /*  958458 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(958540), // Rule ID 64223 //
     /*  958463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958490 */     // MIs[0] op1
     /*  958490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958522 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958524 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958526 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958528 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958538 */     GIR_RootConstrainSelectedInstOperands,
     /*  958539 */     // GIR_Coverage, 64223,
     /*  958539 */     GIR_EraseRootFromParent_Done,
     /*  958540 */   // Label 14434: @958540
     /*  958540 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(958622), // Rule ID 64224 //
     /*  958545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958572 */     // MIs[0] op1
     /*  958572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958599 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_MF2),
     /*  958602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958610 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958620 */     GIR_RootConstrainSelectedInstOperands,
     /*  958621 */     // GIR_Coverage, 64224,
     /*  958621 */     GIR_EraseRootFromParent_Done,
     /*  958622 */   // Label 14435: @958622
     /*  958622 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(958704), // Rule ID 64229 //
     /*  958627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958654 */     // MIs[0] op1
     /*  958654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958692 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958702 */     GIR_RootConstrainSelectedInstOperands,
     /*  958703 */     // GIR_Coverage, 64229,
     /*  958703 */     GIR_EraseRootFromParent_Done,
     /*  958704 */   // Label 14436: @958704
     /*  958704 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(958786), // Rule ID 64230 //
     /*  958709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958736 */     // MIs[0] op1
     /*  958736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M1),
     /*  958766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958784 */     GIR_RootConstrainSelectedInstOperands,
     /*  958785 */     // GIR_Coverage, 64230,
     /*  958785 */     GIR_EraseRootFromParent_Done,
     /*  958786 */   // Label 14437: @958786
     /*  958786 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(958868), // Rule ID 64241 //
     /*  958791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958818 */     // MIs[0] op1
     /*  958818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958845 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958850 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958852 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958854 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958856 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958866 */     GIR_RootConstrainSelectedInstOperands,
     /*  958867 */     // GIR_Coverage, 64241,
     /*  958867 */     GIR_EraseRootFromParent_Done,
     /*  958868 */   // Label 14438: @958868
     /*  958868 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(958950), // Rule ID 64242 //
     /*  958873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958900 */     // MIs[0] op1
     /*  958900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M1),
     /*  958930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958932 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958934 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958936 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958938 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958948 */     GIR_RootConstrainSelectedInstOperands,
     /*  958949 */     // GIR_Coverage, 64242,
     /*  958949 */     GIR_EraseRootFromParent_Done,
     /*  958950 */   // Label 14439: @958950
     /*  958950 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(959032), // Rule ID 64247 //
     /*  958955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958982 */     // MIs[0] op1
     /*  958982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  959012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959014 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959016 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959018 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959020 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959030 */     GIR_RootConstrainSelectedInstOperands,
     /*  959031 */     // GIR_Coverage, 64247,
     /*  959031 */     GIR_EraseRootFromParent_Done,
     /*  959032 */   // Label 14440: @959032
     /*  959032 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(959114), // Rule ID 64248 //
     /*  959037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  959048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  959051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  959054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959064 */     // MIs[0] op1
     /*  959064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959091 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M1),
     /*  959094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959112 */     GIR_RootConstrainSelectedInstOperands,
     /*  959113 */     // GIR_Coverage, 64248,
     /*  959113 */     GIR_EraseRootFromParent_Done,
     /*  959114 */   // Label 14441: @959114
     /*  959114 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(959196), // Rule ID 64253 //
     /*  959119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959146 */     // MIs[0] op1
     /*  959146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959173 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  959176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959178 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959180 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959182 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959184 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959194 */     GIR_RootConstrainSelectedInstOperands,
     /*  959195 */     // GIR_Coverage, 64253,
     /*  959195 */     GIR_EraseRootFromParent_Done,
     /*  959196 */   // Label 14442: @959196
     /*  959196 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(959278), // Rule ID 64254 //
     /*  959201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959228 */     // MIs[0] op1
     /*  959228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959255 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M2),
     /*  959258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959266 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959276 */     GIR_RootConstrainSelectedInstOperands,
     /*  959277 */     // GIR_Coverage, 64254,
     /*  959277 */     GIR_EraseRootFromParent_Done,
     /*  959278 */   // Label 14443: @959278
     /*  959278 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(959360), // Rule ID 64265 //
     /*  959283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  959303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959310 */     // MIs[0] op1
     /*  959310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959337 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  959340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959342 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959344 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959346 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959348 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959358 */     GIR_RootConstrainSelectedInstOperands,
     /*  959359 */     // GIR_Coverage, 64265,
     /*  959359 */     GIR_EraseRootFromParent_Done,
     /*  959360 */   // Label 14444: @959360
     /*  959360 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(959442), // Rule ID 64266 //
     /*  959365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  959385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959392 */     // MIs[0] op1
     /*  959392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959419 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M2),
     /*  959422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959430 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959440 */     GIR_RootConstrainSelectedInstOperands,
     /*  959441 */     // GIR_Coverage, 64266,
     /*  959441 */     GIR_EraseRootFromParent_Done,
     /*  959442 */   // Label 14445: @959442
     /*  959442 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(959524), // Rule ID 64271 //
     /*  959447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959474 */     // MIs[0] op1
     /*  959474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959501 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959506 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959508 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959510 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959512 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959522 */     GIR_RootConstrainSelectedInstOperands,
     /*  959523 */     // GIR_Coverage, 64271,
     /*  959523 */     GIR_EraseRootFromParent_Done,
     /*  959524 */   // Label 14446: @959524
     /*  959524 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(959606), // Rule ID 64272 //
     /*  959529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959556 */     // MIs[0] op1
     /*  959556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959583 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M2),
     /*  959586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959594 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959604 */     GIR_RootConstrainSelectedInstOperands,
     /*  959605 */     // GIR_Coverage, 64272,
     /*  959605 */     GIR_EraseRootFromParent_Done,
     /*  959606 */   // Label 14447: @959606
     /*  959606 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(959688), // Rule ID 64277 //
     /*  959611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959638 */     // MIs[0] op1
     /*  959638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959665 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959670 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959672 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959674 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959676 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959686 */     GIR_RootConstrainSelectedInstOperands,
     /*  959687 */     // GIR_Coverage, 64277,
     /*  959687 */     GIR_EraseRootFromParent_Done,
     /*  959688 */   // Label 14448: @959688
     /*  959688 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(959770), // Rule ID 64278 //
     /*  959693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959720 */     // MIs[0] op1
     /*  959720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959747 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_XVW_M4),
     /*  959750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959758 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959768 */     GIR_RootConstrainSelectedInstOperands,
     /*  959769 */     // GIR_Coverage, 64278,
     /*  959769 */     GIR_EraseRootFromParent_Done,
     /*  959770 */   // Label 14449: @959770
     /*  959770 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(959852), // Rule ID 64289 //
     /*  959775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959802 */     // MIs[0] op1
     /*  959802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959829 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959840 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959850 */     GIR_RootConstrainSelectedInstOperands,
     /*  959851 */     // GIR_Coverage, 64289,
     /*  959851 */     GIR_EraseRootFromParent_Done,
     /*  959852 */   // Label 14450: @959852
     /*  959852 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(959934), // Rule ID 64290 //
     /*  959857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959884 */     // MIs[0] op1
     /*  959884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959911 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_VVW_M4),
     /*  959914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959922 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959932 */     GIR_RootConstrainSelectedInstOperands,
     /*  959933 */     // GIR_Coverage, 64290,
     /*  959933 */     GIR_EraseRootFromParent_Done,
     /*  959934 */   // Label 14451: @959934
     /*  959934 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(960016), // Rule ID 64295 //
     /*  959939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959966 */     // MIs[0] op1
     /*  959966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959993 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  959996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959998 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960000 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960002 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960004 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960014 */     GIR_RootConstrainSelectedInstOperands,
     /*  960015 */     // GIR_Coverage, 64295,
     /*  960015 */     GIR_EraseRootFromParent_Done,
     /*  960016 */   // Label 14452: @960016
     /*  960016 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(960098), // Rule ID 64296 //
     /*  960021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  960032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  960035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  960038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960048 */     // MIs[0] op1
     /*  960048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  960060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  960068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960075 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VC_V_FPR32VW_M4),
     /*  960078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960080 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960082 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960084 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960086 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960096 */     GIR_RootConstrainSelectedInstOperands,
     /*  960097 */     // GIR_Coverage, 64296,
     /*  960097 */     GIR_EraseRootFromParent_Done,
     /*  960098 */   // Label 14453: @960098
     /*  960098 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(960190), // Rule ID 5208 //
     /*  960103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  960114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  960117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  960120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960153 */     // MIs[1] Operand 1
     /*  960153 */     // No operand predicates
     /*  960153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  960169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960188 */     GIR_RootConstrainSelectedInstOperands,
     /*  960189 */     // GIR_Coverage, 5208,
     /*  960189 */     GIR_EraseRootFromParent_Done,
     /*  960190 */   // Label 14454: @960190
     /*  960190 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(960282), // Rule ID 5209 //
     /*  960195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  960206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  960209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  960212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960245 */     // MIs[1] Operand 1
     /*  960245 */     // No operand predicates
     /*  960245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960258 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  960261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960280 */     GIR_RootConstrainSelectedInstOperands,
     /*  960281 */     // GIR_Coverage, 5209,
     /*  960281 */     GIR_EraseRootFromParent_Done,
     /*  960282 */   // Label 14455: @960282
     /*  960282 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(960374), // Rule ID 5210 //
     /*  960287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  960298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  960301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  960304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960337 */     // MIs[1] Operand 1
     /*  960337 */     // No operand predicates
     /*  960337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960350 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960372 */     GIR_RootConstrainSelectedInstOperands,
     /*  960373 */     // GIR_Coverage, 5210,
     /*  960373 */     GIR_EraseRootFromParent_Done,
     /*  960374 */   // Label 14456: @960374
     /*  960374 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(960466), // Rule ID 5211 //
     /*  960379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  960390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  960393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  960396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960429 */     // MIs[1] Operand 1
     /*  960429 */     // No operand predicates
     /*  960429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960464 */     GIR_RootConstrainSelectedInstOperands,
     /*  960465 */     // GIR_Coverage, 5211,
     /*  960465 */     GIR_EraseRootFromParent_Done,
     /*  960466 */   // Label 14457: @960466
     /*  960466 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(960558), // Rule ID 5212 //
     /*  960471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960521 */     // MIs[1] Operand 1
     /*  960521 */     // No operand predicates
     /*  960521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960556 */     GIR_RootConstrainSelectedInstOperands,
     /*  960557 */     // GIR_Coverage, 5212,
     /*  960557 */     GIR_EraseRootFromParent_Done,
     /*  960558 */   // Label 14458: @960558
     /*  960558 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(960650), // Rule ID 5213 //
     /*  960563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960613 */     // MIs[1] Operand 1
     /*  960613 */     // No operand predicates
     /*  960613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960648 */     GIR_RootConstrainSelectedInstOperands,
     /*  960649 */     // GIR_Coverage, 5213,
     /*  960649 */     GIR_EraseRootFromParent_Done,
     /*  960650 */   // Label 14459: @960650
     /*  960650 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(960742), // Rule ID 5214 //
     /*  960655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960705 */     // MIs[1] Operand 1
     /*  960705 */     // No operand predicates
     /*  960705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960740 */     GIR_RootConstrainSelectedInstOperands,
     /*  960741 */     // GIR_Coverage, 5214,
     /*  960741 */     GIR_EraseRootFromParent_Done,
     /*  960742 */   // Label 14460: @960742
     /*  960742 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(960834), // Rule ID 5215 //
     /*  960747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960797 */     // MIs[1] Operand 1
     /*  960797 */     // No operand predicates
     /*  960797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960832 */     GIR_RootConstrainSelectedInstOperands,
     /*  960833 */     // GIR_Coverage, 5215,
     /*  960833 */     GIR_EraseRootFromParent_Done,
     /*  960834 */   // Label 14461: @960834
     /*  960834 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(960926), // Rule ID 5216 //
     /*  960839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960889 */     // MIs[1] Operand 1
     /*  960889 */     // No operand predicates
     /*  960889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960924 */     GIR_RootConstrainSelectedInstOperands,
     /*  960925 */     // GIR_Coverage, 5216,
     /*  960925 */     GIR_EraseRootFromParent_Done,
     /*  960926 */   // Label 14462: @960926
     /*  960926 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(961018), // Rule ID 5217 //
     /*  960931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960981 */     // MIs[1] Operand 1
     /*  960981 */     // No operand predicates
     /*  960981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960994 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961016 */     GIR_RootConstrainSelectedInstOperands,
     /*  961017 */     // GIR_Coverage, 5217,
     /*  961017 */     GIR_EraseRootFromParent_Done,
     /*  961018 */   // Label 14463: @961018
     /*  961018 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(961110), // Rule ID 5218 //
     /*  961023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  961034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  961037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  961040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961073 */     // MIs[1] Operand 1
     /*  961073 */     // No operand predicates
     /*  961073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  961089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961108 */     GIR_RootConstrainSelectedInstOperands,
     /*  961109 */     // GIR_Coverage, 5218,
     /*  961109 */     GIR_EraseRootFromParent_Done,
     /*  961110 */   // Label 14464: @961110
     /*  961110 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(961202), // Rule ID 5219 //
     /*  961115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  961126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  961129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  961132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961165 */     // MIs[1] Operand 1
     /*  961165 */     // No operand predicates
     /*  961165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  961181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961200 */     GIR_RootConstrainSelectedInstOperands,
     /*  961201 */     // GIR_Coverage, 5219,
     /*  961201 */     GIR_EraseRootFromParent_Done,
     /*  961202 */   // Label 14465: @961202
     /*  961202 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(961294), // Rule ID 5220 //
     /*  961207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  961218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  961221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  961224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961257 */     // MIs[1] Operand 1
     /*  961257 */     // No operand predicates
     /*  961257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961292 */     GIR_RootConstrainSelectedInstOperands,
     /*  961293 */     // GIR_Coverage, 5220,
     /*  961293 */     GIR_EraseRootFromParent_Done,
     /*  961294 */   // Label 14466: @961294
     /*  961294 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(961386), // Rule ID 5221 //
     /*  961299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  961310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  961313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  961316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961349 */     // MIs[1] Operand 1
     /*  961349 */     // No operand predicates
     /*  961349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961384 */     GIR_RootConstrainSelectedInstOperands,
     /*  961385 */     // GIR_Coverage, 5221,
     /*  961385 */     GIR_EraseRootFromParent_Done,
     /*  961386 */   // Label 14467: @961386
     /*  961386 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(961478), // Rule ID 5222 //
     /*  961391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961441 */     // MIs[1] Operand 1
     /*  961441 */     // No operand predicates
     /*  961441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961476 */     GIR_RootConstrainSelectedInstOperands,
     /*  961477 */     // GIR_Coverage, 5222,
     /*  961477 */     GIR_EraseRootFromParent_Done,
     /*  961478 */   // Label 14468: @961478
     /*  961478 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(961570), // Rule ID 5223 //
     /*  961483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961533 */     // MIs[1] Operand 1
     /*  961533 */     // No operand predicates
     /*  961533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961568 */     GIR_RootConstrainSelectedInstOperands,
     /*  961569 */     // GIR_Coverage, 5223,
     /*  961569 */     GIR_EraseRootFromParent_Done,
     /*  961570 */   // Label 14469: @961570
     /*  961570 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(961662), // Rule ID 5224 //
     /*  961575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961625 */     // MIs[1] Operand 1
     /*  961625 */     // No operand predicates
     /*  961625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961660 */     GIR_RootConstrainSelectedInstOperands,
     /*  961661 */     // GIR_Coverage, 5224,
     /*  961661 */     GIR_EraseRootFromParent_Done,
     /*  961662 */   // Label 14470: @961662
     /*  961662 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(961754), // Rule ID 5225 //
     /*  961667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961717 */     // MIs[1] Operand 1
     /*  961717 */     // No operand predicates
     /*  961717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961752 */     GIR_RootConstrainSelectedInstOperands,
     /*  961753 */     // GIR_Coverage, 5225,
     /*  961753 */     GIR_EraseRootFromParent_Done,
     /*  961754 */   // Label 14471: @961754
     /*  961754 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(961846), // Rule ID 5226 //
     /*  961759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  961762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961809 */     // MIs[1] Operand 1
     /*  961809 */     // No operand predicates
     /*  961809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  961822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961844 */     GIR_RootConstrainSelectedInstOperands,
     /*  961845 */     // GIR_Coverage, 5226,
     /*  961845 */     GIR_EraseRootFromParent_Done,
     /*  961846 */   // Label 14472: @961846
     /*  961846 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(961938), // Rule ID 5227 //
     /*  961851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  961854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961901 */     // MIs[1] Operand 1
     /*  961901 */     // No operand predicates
     /*  961901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  961914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961936 */     GIR_RootConstrainSelectedInstOperands,
     /*  961937 */     // GIR_Coverage, 5227,
     /*  961937 */     GIR_EraseRootFromParent_Done,
     /*  961938 */   // Label 14473: @961938
     /*  961938 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(962030), // Rule ID 5228 //
     /*  961943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961993 */     // MIs[1] Operand 1
     /*  961993 */     // No operand predicates
     /*  961993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962028 */     GIR_RootConstrainSelectedInstOperands,
     /*  962029 */     // GIR_Coverage, 5228,
     /*  962029 */     GIR_EraseRootFromParent_Done,
     /*  962030 */   // Label 14474: @962030
     /*  962030 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(962122), // Rule ID 5229 //
     /*  962035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  962046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  962049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  962052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962085 */     // MIs[1] Operand 1
     /*  962085 */     // No operand predicates
     /*  962085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962120 */     GIR_RootConstrainSelectedInstOperands,
     /*  962121 */     // GIR_Coverage, 5229,
     /*  962121 */     GIR_EraseRootFromParent_Done,
     /*  962122 */   // Label 14475: @962122
     /*  962122 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(962214), // Rule ID 5230 //
     /*  962127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  962138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  962141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  962144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962177 */     // MIs[1] Operand 1
     /*  962177 */     // No operand predicates
     /*  962177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962190 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962212 */     GIR_RootConstrainSelectedInstOperands,
     /*  962213 */     // GIR_Coverage, 5230,
     /*  962213 */     GIR_EraseRootFromParent_Done,
     /*  962214 */   // Label 14476: @962214
     /*  962214 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(962306), // Rule ID 5231 //
     /*  962219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  962230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  962233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  962236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962269 */     // MIs[1] Operand 1
     /*  962269 */     // No operand predicates
     /*  962269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962304 */     GIR_RootConstrainSelectedInstOperands,
     /*  962305 */     // GIR_Coverage, 5231,
     /*  962305 */     GIR_EraseRootFromParent_Done,
     /*  962306 */   // Label 14477: @962306
     /*  962306 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(962398), // Rule ID 5232 //
     /*  962311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  962322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  962325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  962328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  962334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962361 */     // MIs[1] Operand 1
     /*  962361 */     // No operand predicates
     /*  962361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962374 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  962374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962396 */     GIR_RootConstrainSelectedInstOperands,
     /*  962397 */     // GIR_Coverage, 5232,
     /*  962397 */     GIR_EraseRootFromParent_Done,
     /*  962398 */   // Label 14478: @962398
     /*  962398 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(962490), // Rule ID 5233 //
     /*  962403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  962414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  962417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  962420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  962426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962453 */     // MIs[1] Operand 1
     /*  962453 */     // No operand predicates
     /*  962453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962488 */     GIR_RootConstrainSelectedInstOperands,
     /*  962489 */     // GIR_Coverage, 5233,
     /*  962489 */     GIR_EraseRootFromParent_Done,
     /*  962490 */   // Label 14479: @962490
     /*  962490 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(962582), // Rule ID 5234 //
     /*  962495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962545 */     // MIs[1] Operand 1
     /*  962545 */     // No operand predicates
     /*  962545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962580 */     GIR_RootConstrainSelectedInstOperands,
     /*  962581 */     // GIR_Coverage, 5234,
     /*  962581 */     GIR_EraseRootFromParent_Done,
     /*  962582 */   // Label 14480: @962582
     /*  962582 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(962674), // Rule ID 5235 //
     /*  962587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962637 */     // MIs[1] Operand 1
     /*  962637 */     // No operand predicates
     /*  962637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962672 */     GIR_RootConstrainSelectedInstOperands,
     /*  962673 */     // GIR_Coverage, 5235,
     /*  962673 */     GIR_EraseRootFromParent_Done,
     /*  962674 */   // Label 14481: @962674
     /*  962674 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(962766), // Rule ID 5236 //
     /*  962679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962729 */     // MIs[1] Operand 1
     /*  962729 */     // No operand predicates
     /*  962729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962764 */     GIR_RootConstrainSelectedInstOperands,
     /*  962765 */     // GIR_Coverage, 5236,
     /*  962765 */     GIR_EraseRootFromParent_Done,
     /*  962766 */   // Label 14482: @962766
     /*  962766 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(962858), // Rule ID 5237 //
     /*  962771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962821 */     // MIs[1] Operand 1
     /*  962821 */     // No operand predicates
     /*  962821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962856 */     GIR_RootConstrainSelectedInstOperands,
     /*  962857 */     // GIR_Coverage, 5237,
     /*  962857 */     GIR_EraseRootFromParent_Done,
     /*  962858 */   // Label 14483: @962858
     /*  962858 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(962950), // Rule ID 5238 //
     /*  962863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962913 */     // MIs[1] Operand 1
     /*  962913 */     // No operand predicates
     /*  962913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962926 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962948 */     GIR_RootConstrainSelectedInstOperands,
     /*  962949 */     // GIR_Coverage, 5238,
     /*  962949 */     GIR_EraseRootFromParent_Done,
     /*  962950 */   // Label 14484: @962950
     /*  962950 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(963042), // Rule ID 5239 //
     /*  962955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963005 */     // MIs[1] Operand 1
     /*  963005 */     // No operand predicates
     /*  963005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  963018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963040 */     GIR_RootConstrainSelectedInstOperands,
     /*  963041 */     // GIR_Coverage, 5239,
     /*  963041 */     GIR_EraseRootFromParent_Done,
     /*  963042 */   // Label 14485: @963042
     /*  963042 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(963134), // Rule ID 5240 //
     /*  963047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  963058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  963061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963097 */     // MIs[1] Operand 1
     /*  963097 */     // No operand predicates
     /*  963097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963132 */     GIR_RootConstrainSelectedInstOperands,
     /*  963133 */     // GIR_Coverage, 5240,
     /*  963133 */     GIR_EraseRootFromParent_Done,
     /*  963134 */   // Label 14486: @963134
     /*  963134 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(963226), // Rule ID 5241 //
     /*  963139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  963150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  963153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  963156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963189 */     // MIs[1] Operand 1
     /*  963189 */     // No operand predicates
     /*  963189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963224 */     GIR_RootConstrainSelectedInstOperands,
     /*  963225 */     // GIR_Coverage, 5241,
     /*  963225 */     GIR_EraseRootFromParent_Done,
     /*  963226 */   // Label 14487: @963226
     /*  963226 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(963318), // Rule ID 5242 //
     /*  963231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  963242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  963245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963281 */     // MIs[1] Operand 1
     /*  963281 */     // No operand predicates
     /*  963281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963316 */     GIR_RootConstrainSelectedInstOperands,
     /*  963317 */     // GIR_Coverage, 5242,
     /*  963317 */     GIR_EraseRootFromParent_Done,
     /*  963318 */   // Label 14488: @963318
     /*  963318 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(963410), // Rule ID 5243 //
     /*  963323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  963334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  963337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  963340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963373 */     // MIs[1] Operand 1
     /*  963373 */     // No operand predicates
     /*  963373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963408 */     GIR_RootConstrainSelectedInstOperands,
     /*  963409 */     // GIR_Coverage, 5243,
     /*  963409 */     GIR_EraseRootFromParent_Done,
     /*  963410 */   // Label 14489: @963410
     /*  963410 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(963502), // Rule ID 5244 //
     /*  963415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963465 */     // MIs[1] Operand 1
     /*  963465 */     // No operand predicates
     /*  963465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963500 */     GIR_RootConstrainSelectedInstOperands,
     /*  963501 */     // GIR_Coverage, 5244,
     /*  963501 */     GIR_EraseRootFromParent_Done,
     /*  963502 */   // Label 14490: @963502
     /*  963502 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(963594), // Rule ID 5245 //
     /*  963507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963557 */     // MIs[1] Operand 1
     /*  963557 */     // No operand predicates
     /*  963557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963592 */     GIR_RootConstrainSelectedInstOperands,
     /*  963593 */     // GIR_Coverage, 5245,
     /*  963593 */     GIR_EraseRootFromParent_Done,
     /*  963594 */   // Label 14491: @963594
     /*  963594 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(963686), // Rule ID 5246 //
     /*  963599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963649 */     // MIs[1] Operand 1
     /*  963649 */     // No operand predicates
     /*  963649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963684 */     GIR_RootConstrainSelectedInstOperands,
     /*  963685 */     // GIR_Coverage, 5246,
     /*  963685 */     GIR_EraseRootFromParent_Done,
     /*  963686 */   // Label 14492: @963686
     /*  963686 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(963778), // Rule ID 5247 //
     /*  963691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963741 */     // MIs[1] Operand 1
     /*  963741 */     // No operand predicates
     /*  963741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963776 */     GIR_RootConstrainSelectedInstOperands,
     /*  963777 */     // GIR_Coverage, 5247,
     /*  963777 */     GIR_EraseRootFromParent_Done,
     /*  963778 */   // Label 14493: @963778
     /*  963778 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(963870), // Rule ID 5248 //
     /*  963783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963833 */     // MIs[1] Operand 1
     /*  963833 */     // No operand predicates
     /*  963833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963868 */     GIR_RootConstrainSelectedInstOperands,
     /*  963869 */     // GIR_Coverage, 5248,
     /*  963869 */     GIR_EraseRootFromParent_Done,
     /*  963870 */   // Label 14494: @963870
     /*  963870 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(963962), // Rule ID 5249 //
     /*  963875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963925 */     // MIs[1] Operand 1
     /*  963925 */     // No operand predicates
     /*  963925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963960 */     GIR_RootConstrainSelectedInstOperands,
     /*  963961 */     // GIR_Coverage, 5249,
     /*  963961 */     GIR_EraseRootFromParent_Done,
     /*  963962 */   // Label 14495: @963962
     /*  963962 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(964054), // Rule ID 5250 //
     /*  963967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964017 */     // MIs[1] Operand 1
     /*  964017 */     // No operand predicates
     /*  964017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  964030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  964033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  964052 */     GIR_RootConstrainSelectedInstOperands,
     /*  964053 */     // GIR_Coverage, 5250,
     /*  964053 */     GIR_EraseRootFromParent_Done,
     /*  964054 */   // Label 14496: @964054
     /*  964054 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(964146), // Rule ID 5251 //
     /*  964059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  964062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  964070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  964073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  964076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  964089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  964097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964109 */     // MIs[1] Operand 1
     /*  964109 */     // No operand predicates
     /*  964109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  964122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  964125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  964144 */     GIR_RootConstrainSelectedInstOperands,
     /*  964145 */     // GIR_Coverage, 5251,
     /*  964145 */     GIR_EraseRootFromParent_Done,
     /*  964146 */   // Label 14497: @964146
     /*  964146 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(964241), // Rule ID 7982 //
     /*  964151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  964168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964201 */     // MIs[1] Operand 1
     /*  964201 */     // No operand predicates
     /*  964201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  964217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964239 */     GIR_RootConstrainSelectedInstOperands,
     /*  964240 */     // GIR_Coverage, 7982,
     /*  964240 */     GIR_EraseRootFromParent_Done,
     /*  964241 */   // Label 14498: @964241
     /*  964241 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(964336), // Rule ID 7983 //
     /*  964246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  964263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964296 */     // MIs[1] Operand 1
     /*  964296 */     // No operand predicates
     /*  964296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964309 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  964312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964334 */     GIR_RootConstrainSelectedInstOperands,
     /*  964335 */     // GIR_Coverage, 7983,
     /*  964335 */     GIR_EraseRootFromParent_Done,
     /*  964336 */   // Label 14499: @964336
     /*  964336 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(964431), // Rule ID 7986 //
     /*  964341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  964358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964391 */     // MIs[1] Operand 1
     /*  964391 */     // No operand predicates
     /*  964391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964429 */     GIR_RootConstrainSelectedInstOperands,
     /*  964430 */     // GIR_Coverage, 7986,
     /*  964430 */     GIR_EraseRootFromParent_Done,
     /*  964431 */   // Label 14500: @964431
     /*  964431 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(964526), // Rule ID 7987 //
     /*  964436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  964453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964486 */     // MIs[1] Operand 1
     /*  964486 */     // No operand predicates
     /*  964486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964499 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964524 */     GIR_RootConstrainSelectedInstOperands,
     /*  964525 */     // GIR_Coverage, 7987,
     /*  964525 */     GIR_EraseRootFromParent_Done,
     /*  964526 */   // Label 14501: @964526
     /*  964526 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(964621), // Rule ID 7990 //
     /*  964531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964581 */     // MIs[1] Operand 1
     /*  964581 */     // No operand predicates
     /*  964581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964619 */     GIR_RootConstrainSelectedInstOperands,
     /*  964620 */     // GIR_Coverage, 7990,
     /*  964620 */     GIR_EraseRootFromParent_Done,
     /*  964621 */   // Label 14502: @964621
     /*  964621 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(964716), // Rule ID 7991 //
     /*  964626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964676 */     // MIs[1] Operand 1
     /*  964676 */     // No operand predicates
     /*  964676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964714 */     GIR_RootConstrainSelectedInstOperands,
     /*  964715 */     // GIR_Coverage, 7991,
     /*  964715 */     GIR_EraseRootFromParent_Done,
     /*  964716 */   // Label 14503: @964716
     /*  964716 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(964811), // Rule ID 7994 //
     /*  964721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964771 */     // MIs[1] Operand 1
     /*  964771 */     // No operand predicates
     /*  964771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964809 */     GIR_RootConstrainSelectedInstOperands,
     /*  964810 */     // GIR_Coverage, 7994,
     /*  964810 */     GIR_EraseRootFromParent_Done,
     /*  964811 */   // Label 14504: @964811
     /*  964811 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(964906), // Rule ID 7995 //
     /*  964816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964866 */     // MIs[1] Operand 1
     /*  964866 */     // No operand predicates
     /*  964866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964879 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964904 */     GIR_RootConstrainSelectedInstOperands,
     /*  964905 */     // GIR_Coverage, 7995,
     /*  964905 */     GIR_EraseRootFromParent_Done,
     /*  964906 */   // Label 14505: @964906
     /*  964906 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(965001), // Rule ID 7998 //
     /*  964911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964961 */     // MIs[1] Operand 1
     /*  964961 */     // No operand predicates
     /*  964961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964999 */     GIR_RootConstrainSelectedInstOperands,
     /*  965000 */     // GIR_Coverage, 7998,
     /*  965000 */     GIR_EraseRootFromParent_Done,
     /*  965001 */   // Label 14506: @965001
     /*  965001 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(965096), // Rule ID 7999 //
     /*  965006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  965023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965056 */     // MIs[1] Operand 1
     /*  965056 */     // No operand predicates
     /*  965056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965069 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965094 */     GIR_RootConstrainSelectedInstOperands,
     /*  965095 */     // GIR_Coverage, 7999,
     /*  965095 */     GIR_EraseRootFromParent_Done,
     /*  965096 */   // Label 14507: @965096
     /*  965096 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(965191), // Rule ID 8002 //
     /*  965101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  965118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965151 */     // MIs[1] Operand 1
     /*  965151 */     // No operand predicates
     /*  965151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965189 */     GIR_RootConstrainSelectedInstOperands,
     /*  965190 */     // GIR_Coverage, 8002,
     /*  965190 */     GIR_EraseRootFromParent_Done,
     /*  965191 */   // Label 14508: @965191
     /*  965191 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(965286), // Rule ID 8003 //
     /*  965196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  965213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965246 */     // MIs[1] Operand 1
     /*  965246 */     // No operand predicates
     /*  965246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965259 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  965262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965284 */     GIR_RootConstrainSelectedInstOperands,
     /*  965285 */     // GIR_Coverage, 8003,
     /*  965285 */     GIR_EraseRootFromParent_Done,
     /*  965286 */   // Label 14509: @965286
     /*  965286 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(965381), // Rule ID 8006 //
     /*  965291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965341 */     // MIs[1] Operand 1
     /*  965341 */     // No operand predicates
     /*  965341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965379 */     GIR_RootConstrainSelectedInstOperands,
     /*  965380 */     // GIR_Coverage, 8006,
     /*  965380 */     GIR_EraseRootFromParent_Done,
     /*  965381 */   // Label 14510: @965381
     /*  965381 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(965476), // Rule ID 8007 //
     /*  965386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  965403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965436 */     // MIs[1] Operand 1
     /*  965436 */     // No operand predicates
     /*  965436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965449 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965474 */     GIR_RootConstrainSelectedInstOperands,
     /*  965475 */     // GIR_Coverage, 8007,
     /*  965475 */     GIR_EraseRootFromParent_Done,
     /*  965476 */   // Label 14511: @965476
     /*  965476 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(965571), // Rule ID 8010 //
     /*  965481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965531 */     // MIs[1] Operand 1
     /*  965531 */     // No operand predicates
     /*  965531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965569 */     GIR_RootConstrainSelectedInstOperands,
     /*  965570 */     // GIR_Coverage, 8010,
     /*  965570 */     GIR_EraseRootFromParent_Done,
     /*  965571 */   // Label 14512: @965571
     /*  965571 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(965666), // Rule ID 8011 //
     /*  965576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965626 */     // MIs[1] Operand 1
     /*  965626 */     // No operand predicates
     /*  965626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965639 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965664 */     GIR_RootConstrainSelectedInstOperands,
     /*  965665 */     // GIR_Coverage, 8011,
     /*  965665 */     GIR_EraseRootFromParent_Done,
     /*  965666 */   // Label 14513: @965666
     /*  965666 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(965761), // Rule ID 8014 //
     /*  965671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965721 */     // MIs[1] Operand 1
     /*  965721 */     // No operand predicates
     /*  965721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965734 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965759 */     GIR_RootConstrainSelectedInstOperands,
     /*  965760 */     // GIR_Coverage, 8014,
     /*  965760 */     GIR_EraseRootFromParent_Done,
     /*  965761 */   // Label 14514: @965761
     /*  965761 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(965856), // Rule ID 8015 //
     /*  965766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965816 */     // MIs[1] Operand 1
     /*  965816 */     // No operand predicates
     /*  965816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965829 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965854 */     GIR_RootConstrainSelectedInstOperands,
     /*  965855 */     // GIR_Coverage, 8015,
     /*  965855 */     GIR_EraseRootFromParent_Done,
     /*  965856 */   // Label 14515: @965856
     /*  965856 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(965951), // Rule ID 8018 //
     /*  965861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965911 */     // MIs[1] Operand 1
     /*  965911 */     // No operand predicates
     /*  965911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  965924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965949 */     GIR_RootConstrainSelectedInstOperands,
     /*  965950 */     // GIR_Coverage, 8018,
     /*  965950 */     GIR_EraseRootFromParent_Done,
     /*  965951 */   // Label 14516: @965951
     /*  965951 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(966046), // Rule ID 8019 //
     /*  965956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966006 */     // MIs[1] Operand 1
     /*  966006 */     // No operand predicates
     /*  966006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966019 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  966019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  966022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  966041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966044 */     GIR_RootConstrainSelectedInstOperands,
     /*  966045 */     // GIR_Coverage, 8019,
     /*  966045 */     GIR_EraseRootFromParent_Done,
     /*  966046 */   // Label 14517: @966046
     /*  966046 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(966141), // Rule ID 8022 //
     /*  966051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  966068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966101 */     // MIs[1] Operand 1
     /*  966101 */     // No operand predicates
     /*  966101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966139 */     GIR_RootConstrainSelectedInstOperands,
     /*  966140 */     // GIR_Coverage, 8022,
     /*  966140 */     GIR_EraseRootFromParent_Done,
     /*  966141 */   // Label 14518: @966141
     /*  966141 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(966236), // Rule ID 8023 //
     /*  966146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  966163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966196 */     // MIs[1] Operand 1
     /*  966196 */     // No operand predicates
     /*  966196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966209 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966234 */     GIR_RootConstrainSelectedInstOperands,
     /*  966235 */     // GIR_Coverage, 8023,
     /*  966235 */     GIR_EraseRootFromParent_Done,
     /*  966236 */   // Label 14519: @966236
     /*  966236 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(966331), // Rule ID 8026 //
     /*  966241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966291 */     // MIs[1] Operand 1
     /*  966291 */     // No operand predicates
     /*  966291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966304 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966329 */     GIR_RootConstrainSelectedInstOperands,
     /*  966330 */     // GIR_Coverage, 8026,
     /*  966330 */     GIR_EraseRootFromParent_Done,
     /*  966331 */   // Label 14520: @966331
     /*  966331 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(966426), // Rule ID 8027 //
     /*  966336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  966353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966386 */     // MIs[1] Operand 1
     /*  966386 */     // No operand predicates
     /*  966386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966399 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966424 */     GIR_RootConstrainSelectedInstOperands,
     /*  966425 */     // GIR_Coverage, 8027,
     /*  966425 */     GIR_EraseRootFromParent_Done,
     /*  966426 */   // Label 14521: @966426
     /*  966426 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(966521), // Rule ID 8030 //
     /*  966431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966481 */     // MIs[1] Operand 1
     /*  966481 */     // No operand predicates
     /*  966481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966494 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966519 */     GIR_RootConstrainSelectedInstOperands,
     /*  966520 */     // GIR_Coverage, 8030,
     /*  966520 */     GIR_EraseRootFromParent_Done,
     /*  966521 */   // Label 14522: @966521
     /*  966521 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(966616), // Rule ID 8031 //
     /*  966526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966576 */     // MIs[1] Operand 1
     /*  966576 */     // No operand predicates
     /*  966576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966589 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966614 */     GIR_RootConstrainSelectedInstOperands,
     /*  966615 */     // GIR_Coverage, 8031,
     /*  966615 */     GIR_EraseRootFromParent_Done,
     /*  966616 */   // Label 14523: @966616
     /*  966616 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(966711), // Rule ID 8034 //
     /*  966621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966671 */     // MIs[1] Operand 1
     /*  966671 */     // No operand predicates
     /*  966671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966709 */     GIR_RootConstrainSelectedInstOperands,
     /*  966710 */     // GIR_Coverage, 8034,
     /*  966710 */     GIR_EraseRootFromParent_Done,
     /*  966711 */   // Label 14524: @966711
     /*  966711 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(966806), // Rule ID 8035 //
     /*  966716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966766 */     // MIs[1] Operand 1
     /*  966766 */     // No operand predicates
     /*  966766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966804 */     GIR_RootConstrainSelectedInstOperands,
     /*  966805 */     // GIR_Coverage, 8035,
     /*  966805 */     GIR_EraseRootFromParent_Done,
     /*  966806 */   // Label 14525: @966806
     /*  966806 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(966901), // Rule ID 8038 //
     /*  966811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966861 */     // MIs[1] Operand 1
     /*  966861 */     // No operand predicates
     /*  966861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966899 */     GIR_RootConstrainSelectedInstOperands,
     /*  966900 */     // GIR_Coverage, 8038,
     /*  966900 */     GIR_EraseRootFromParent_Done,
     /*  966901 */   // Label 14526: @966901
     /*  966901 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(966996), // Rule ID 8039 //
     /*  966906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966956 */     // MIs[1] Operand 1
     /*  966956 */     // No operand predicates
     /*  966956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966994 */     GIR_RootConstrainSelectedInstOperands,
     /*  966995 */     // GIR_Coverage, 8039,
     /*  966995 */     GIR_EraseRootFromParent_Done,
     /*  966996 */   // Label 14527: @966996
     /*  966996 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(967091), // Rule ID 8042 //
     /*  967001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  967012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  967015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  967018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  967024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967051 */     // MIs[1] Operand 1
     /*  967051 */     // No operand predicates
     /*  967051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967064 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  967064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  967086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967089 */     GIR_RootConstrainSelectedInstOperands,
     /*  967090 */     // GIR_Coverage, 8042,
     /*  967090 */     GIR_EraseRootFromParent_Done,
     /*  967091 */   // Label 14528: @967091
     /*  967091 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(967186), // Rule ID 8043 //
     /*  967096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  967107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  967110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  967113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  967119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967146 */     // MIs[1] Operand 1
     /*  967146 */     // No operand predicates
     /*  967146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967159 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  967159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  967181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967184 */     GIR_RootConstrainSelectedInstOperands,
     /*  967185 */     // GIR_Coverage, 8043,
     /*  967185 */     GIR_EraseRootFromParent_Done,
     /*  967186 */   // Label 14529: @967186
     /*  967186 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(967281), // Rule ID 8046 //
     /*  967191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967241 */     // MIs[1] Operand 1
     /*  967241 */     // No operand predicates
     /*  967241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967279 */     GIR_RootConstrainSelectedInstOperands,
     /*  967280 */     // GIR_Coverage, 8046,
     /*  967280 */     GIR_EraseRootFromParent_Done,
     /*  967281 */   // Label 14530: @967281
     /*  967281 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(967376), // Rule ID 8047 //
     /*  967286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  967303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967336 */     // MIs[1] Operand 1
     /*  967336 */     // No operand predicates
     /*  967336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967349 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967374 */     GIR_RootConstrainSelectedInstOperands,
     /*  967375 */     // GIR_Coverage, 8047,
     /*  967375 */     GIR_EraseRootFromParent_Done,
     /*  967376 */   // Label 14531: @967376
     /*  967376 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(967471), // Rule ID 8050 //
     /*  967381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967431 */     // MIs[1] Operand 1
     /*  967431 */     // No operand predicates
     /*  967431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967469 */     GIR_RootConstrainSelectedInstOperands,
     /*  967470 */     // GIR_Coverage, 8050,
     /*  967470 */     GIR_EraseRootFromParent_Done,
     /*  967471 */   // Label 14532: @967471
     /*  967471 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(967566), // Rule ID 8051 //
     /*  967476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967526 */     // MIs[1] Operand 1
     /*  967526 */     // No operand predicates
     /*  967526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967539 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967564 */     GIR_RootConstrainSelectedInstOperands,
     /*  967565 */     // GIR_Coverage, 8051,
     /*  967565 */     GIR_EraseRootFromParent_Done,
     /*  967566 */   // Label 14533: @967566
     /*  967566 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(967661), // Rule ID 8054 //
     /*  967571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967621 */     // MIs[1] Operand 1
     /*  967621 */     // No operand predicates
     /*  967621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967659 */     GIR_RootConstrainSelectedInstOperands,
     /*  967660 */     // GIR_Coverage, 8054,
     /*  967660 */     GIR_EraseRootFromParent_Done,
     /*  967661 */   // Label 14534: @967661
     /*  967661 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(967756), // Rule ID 8055 //
     /*  967666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967716 */     // MIs[1] Operand 1
     /*  967716 */     // No operand predicates
     /*  967716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967754 */     GIR_RootConstrainSelectedInstOperands,
     /*  967755 */     // GIR_Coverage, 8055,
     /*  967755 */     GIR_EraseRootFromParent_Done,
     /*  967756 */   // Label 14535: @967756
     /*  967756 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(967851), // Rule ID 8058 //
     /*  967761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967811 */     // MIs[1] Operand 1
     /*  967811 */     // No operand predicates
     /*  967811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967849 */     GIR_RootConstrainSelectedInstOperands,
     /*  967850 */     // GIR_Coverage, 8058,
     /*  967850 */     GIR_EraseRootFromParent_Done,
     /*  967851 */   // Label 14536: @967851
     /*  967851 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(967946), // Rule ID 8059 //
     /*  967856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967906 */     // MIs[1] Operand 1
     /*  967906 */     // No operand predicates
     /*  967906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967919 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967944 */     GIR_RootConstrainSelectedInstOperands,
     /*  967945 */     // GIR_Coverage, 8059,
     /*  967945 */     GIR_EraseRootFromParent_Done,
     /*  967946 */   // Label 14537: @967946
     /*  967946 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(968041), // Rule ID 8062 //
     /*  967951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968001 */     // MIs[1] Operand 1
     /*  968001 */     // No operand predicates
     /*  968001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  968014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  968017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968039 */     GIR_RootConstrainSelectedInstOperands,
     /*  968040 */     // GIR_Coverage, 8062,
     /*  968040 */     GIR_EraseRootFromParent_Done,
     /*  968041 */   // Label 14538: @968041
     /*  968041 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(968136), // Rule ID 8063 //
     /*  968046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  968049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  968063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  968084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968096 */     // MIs[1] Operand 1
     /*  968096 */     // No operand predicates
     /*  968096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  968109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  968112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968134 */     GIR_RootConstrainSelectedInstOperands,
     /*  968135 */     // GIR_Coverage, 8063,
     /*  968135 */     GIR_EraseRootFromParent_Done,
     /*  968136 */   // Label 14539: @968136
     /*  968136 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(968231), // Rule ID 8066 //
     /*  968141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  968144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  968158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968191 */     // MIs[1] Operand 1
     /*  968191 */     // No operand predicates
     /*  968191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  968204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  968207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968229 */     GIR_RootConstrainSelectedInstOperands,
     /*  968230 */     // GIR_Coverage, 8066,
     /*  968230 */     GIR_EraseRootFromParent_Done,
     /*  968231 */   // Label 14540: @968231
     /*  968231 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(968326), // Rule ID 8067 //
     /*  968236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  968239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  968253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  968274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968286 */     // MIs[1] Operand 1
     /*  968286 */     // No operand predicates
     /*  968286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  968299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  968302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  968321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968324 */     GIR_RootConstrainSelectedInstOperands,
     /*  968325 */     // GIR_Coverage, 8067,
     /*  968325 */     GIR_EraseRootFromParent_Done,
     /*  968326 */   // Label 14541: @968326
     /*  968326 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(968421), // Rule ID 8246 //
     /*  968331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  968348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968381 */     // MIs[1] Operand 1
     /*  968381 */     // No operand predicates
     /*  968381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968419 */     GIR_RootConstrainSelectedInstOperands,
     /*  968420 */     // GIR_Coverage, 8246,
     /*  968420 */     GIR_EraseRootFromParent_Done,
     /*  968421 */   // Label 14542: @968421
     /*  968421 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(968516), // Rule ID 8247 //
     /*  968426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  968443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968476 */     // MIs[1] Operand 1
     /*  968476 */     // No operand predicates
     /*  968476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968489 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968514 */     GIR_RootConstrainSelectedInstOperands,
     /*  968515 */     // GIR_Coverage, 8247,
     /*  968515 */     GIR_EraseRootFromParent_Done,
     /*  968516 */   // Label 14543: @968516
     /*  968516 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(968611), // Rule ID 8250 //
     /*  968521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968571 */     // MIs[1] Operand 1
     /*  968571 */     // No operand predicates
     /*  968571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968609 */     GIR_RootConstrainSelectedInstOperands,
     /*  968610 */     // GIR_Coverage, 8250,
     /*  968610 */     GIR_EraseRootFromParent_Done,
     /*  968611 */   // Label 14544: @968611
     /*  968611 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(968706), // Rule ID 8251 //
     /*  968616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968666 */     // MIs[1] Operand 1
     /*  968666 */     // No operand predicates
     /*  968666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968679 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968704 */     GIR_RootConstrainSelectedInstOperands,
     /*  968705 */     // GIR_Coverage, 8251,
     /*  968705 */     GIR_EraseRootFromParent_Done,
     /*  968706 */   // Label 14545: @968706
     /*  968706 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(968801), // Rule ID 8254 //
     /*  968711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968761 */     // MIs[1] Operand 1
     /*  968761 */     // No operand predicates
     /*  968761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968799 */     GIR_RootConstrainSelectedInstOperands,
     /*  968800 */     // GIR_Coverage, 8254,
     /*  968800 */     GIR_EraseRootFromParent_Done,
     /*  968801 */   // Label 14546: @968801
     /*  968801 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(968896), // Rule ID 8255 //
     /*  968806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968856 */     // MIs[1] Operand 1
     /*  968856 */     // No operand predicates
     /*  968856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968894 */     GIR_RootConstrainSelectedInstOperands,
     /*  968895 */     // GIR_Coverage, 8255,
     /*  968895 */     GIR_EraseRootFromParent_Done,
     /*  968896 */   // Label 14547: @968896
     /*  968896 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(968991), // Rule ID 8258 //
     /*  968901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968951 */     // MIs[1] Operand 1
     /*  968951 */     // No operand predicates
     /*  968951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968989 */     GIR_RootConstrainSelectedInstOperands,
     /*  968990 */     // GIR_Coverage, 8258,
     /*  968990 */     GIR_EraseRootFromParent_Done,
     /*  968991 */   // Label 14548: @968991
     /*  968991 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(969086), // Rule ID 8259 //
     /*  968996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  969013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969046 */     // MIs[1] Operand 1
     /*  969046 */     // No operand predicates
     /*  969046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969059 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  969062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969084 */     GIR_RootConstrainSelectedInstOperands,
     /*  969085 */     // GIR_Coverage, 8259,
     /*  969085 */     GIR_EraseRootFromParent_Done,
     /*  969086 */   // Label 14549: @969086
     /*  969086 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(969181), // Rule ID 8262 //
     /*  969091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  969108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969141 */     // MIs[1] Operand 1
     /*  969141 */     // No operand predicates
     /*  969141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969179 */     GIR_RootConstrainSelectedInstOperands,
     /*  969180 */     // GIR_Coverage, 8262,
     /*  969180 */     GIR_EraseRootFromParent_Done,
     /*  969181 */   // Label 14550: @969181
     /*  969181 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(969276), // Rule ID 8263 //
     /*  969186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  969203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969236 */     // MIs[1] Operand 1
     /*  969236 */     // No operand predicates
     /*  969236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969249 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969274 */     GIR_RootConstrainSelectedInstOperands,
     /*  969275 */     // GIR_Coverage, 8263,
     /*  969275 */     GIR_EraseRootFromParent_Done,
     /*  969276 */   // Label 14551: @969276
     /*  969276 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(969371), // Rule ID 8266 //
     /*  969281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969331 */     // MIs[1] Operand 1
     /*  969331 */     // No operand predicates
     /*  969331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969369 */     GIR_RootConstrainSelectedInstOperands,
     /*  969370 */     // GIR_Coverage, 8266,
     /*  969370 */     GIR_EraseRootFromParent_Done,
     /*  969371 */   // Label 14552: @969371
     /*  969371 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(969466), // Rule ID 8267 //
     /*  969376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  969393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969426 */     // MIs[1] Operand 1
     /*  969426 */     // No operand predicates
     /*  969426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969439 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  969442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969464 */     GIR_RootConstrainSelectedInstOperands,
     /*  969465 */     // GIR_Coverage, 8267,
     /*  969465 */     GIR_EraseRootFromParent_Done,
     /*  969466 */   // Label 14553: @969466
     /*  969466 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(969561), // Rule ID 8270 //
     /*  969471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969521 */     // MIs[1] Operand 1
     /*  969521 */     // No operand predicates
     /*  969521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969559 */     GIR_RootConstrainSelectedInstOperands,
     /*  969560 */     // GIR_Coverage, 8270,
     /*  969560 */     GIR_EraseRootFromParent_Done,
     /*  969561 */   // Label 14554: @969561
     /*  969561 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(969656), // Rule ID 8271 //
     /*  969566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969616 */     // MIs[1] Operand 1
     /*  969616 */     // No operand predicates
     /*  969616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969629 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969654 */     GIR_RootConstrainSelectedInstOperands,
     /*  969655 */     // GIR_Coverage, 8271,
     /*  969655 */     GIR_EraseRootFromParent_Done,
     /*  969656 */   // Label 14555: @969656
     /*  969656 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(969751), // Rule ID 8274 //
     /*  969661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969711 */     // MIs[1] Operand 1
     /*  969711 */     // No operand predicates
     /*  969711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969749 */     GIR_RootConstrainSelectedInstOperands,
     /*  969750 */     // GIR_Coverage, 8274,
     /*  969750 */     GIR_EraseRootFromParent_Done,
     /*  969751 */   // Label 14556: @969751
     /*  969751 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(969846), // Rule ID 8275 //
     /*  969756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969806 */     // MIs[1] Operand 1
     /*  969806 */     // No operand predicates
     /*  969806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969844 */     GIR_RootConstrainSelectedInstOperands,
     /*  969845 */     // GIR_Coverage, 8275,
     /*  969845 */     GIR_EraseRootFromParent_Done,
     /*  969846 */   // Label 14557: @969846
     /*  969846 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(969941), // Rule ID 8278 //
     /*  969851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969901 */     // MIs[1] Operand 1
     /*  969901 */     // No operand predicates
     /*  969901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969939 */     GIR_RootConstrainSelectedInstOperands,
     /*  969940 */     // GIR_Coverage, 8278,
     /*  969940 */     GIR_EraseRootFromParent_Done,
     /*  969941 */   // Label 14558: @969941
     /*  969941 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(970036), // Rule ID 8279 //
     /*  969946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969996 */     // MIs[1] Operand 1
     /*  969996 */     // No operand predicates
     /*  969996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970009 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970034 */     GIR_RootConstrainSelectedInstOperands,
     /*  970035 */     // GIR_Coverage, 8279,
     /*  970035 */     GIR_EraseRootFromParent_Done,
     /*  970036 */   // Label 14559: @970036
     /*  970036 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(970131), // Rule ID 8282 //
     /*  970041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  970044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  970052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  970055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  970058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  970064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970091 */     // MIs[1] Operand 1
     /*  970091 */     // No operand predicates
     /*  970091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970104 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  970104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  970126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970129 */     GIR_RootConstrainSelectedInstOperands,
     /*  970130 */     // GIR_Coverage, 8282,
     /*  970130 */     GIR_EraseRootFromParent_Done,
     /*  970131 */   // Label 14560: @970131
     /*  970131 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(970226), // Rule ID 8283 //
     /*  970136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  970139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  970147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  970150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  970153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  970159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970186 */     // MIs[1] Operand 1
     /*  970186 */     // No operand predicates
     /*  970186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  970199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  970202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  970221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970224 */     GIR_RootConstrainSelectedInstOperands,
     /*  970225 */     // GIR_Coverage, 8283,
     /*  970225 */     GIR_EraseRootFromParent_Done,
     /*  970226 */   // Label 14561: @970226
     /*  970226 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(970321), // Rule ID 8286 //
     /*  970231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  970248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970281 */     // MIs[1] Operand 1
     /*  970281 */     // No operand predicates
     /*  970281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970319 */     GIR_RootConstrainSelectedInstOperands,
     /*  970320 */     // GIR_Coverage, 8286,
     /*  970320 */     GIR_EraseRootFromParent_Done,
     /*  970321 */   // Label 14562: @970321
     /*  970321 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(970416), // Rule ID 8287 //
     /*  970326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  970343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970376 */     // MIs[1] Operand 1
     /*  970376 */     // No operand predicates
     /*  970376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970389 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970414 */     GIR_RootConstrainSelectedInstOperands,
     /*  970415 */     // GIR_Coverage, 8287,
     /*  970415 */     GIR_EraseRootFromParent_Done,
     /*  970416 */   // Label 14563: @970416
     /*  970416 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(970511), // Rule ID 8290 //
     /*  970421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970471 */     // MIs[1] Operand 1
     /*  970471 */     // No operand predicates
     /*  970471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970509 */     GIR_RootConstrainSelectedInstOperands,
     /*  970510 */     // GIR_Coverage, 8290,
     /*  970510 */     GIR_EraseRootFromParent_Done,
     /*  970511 */   // Label 14564: @970511
     /*  970511 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(970606), // Rule ID 8291 //
     /*  970516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970566 */     // MIs[1] Operand 1
     /*  970566 */     // No operand predicates
     /*  970566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970579 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970604 */     GIR_RootConstrainSelectedInstOperands,
     /*  970605 */     // GIR_Coverage, 8291,
     /*  970605 */     GIR_EraseRootFromParent_Done,
     /*  970606 */   // Label 14565: @970606
     /*  970606 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(970701), // Rule ID 8294 //
     /*  970611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970661 */     // MIs[1] Operand 1
     /*  970661 */     // No operand predicates
     /*  970661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970674 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970699 */     GIR_RootConstrainSelectedInstOperands,
     /*  970700 */     // GIR_Coverage, 8294,
     /*  970700 */     GIR_EraseRootFromParent_Done,
     /*  970701 */   // Label 14566: @970701
     /*  970701 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(970796), // Rule ID 8295 //
     /*  970706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970756 */     // MIs[1] Operand 1
     /*  970756 */     // No operand predicates
     /*  970756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970769 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970794 */     GIR_RootConstrainSelectedInstOperands,
     /*  970795 */     // GIR_Coverage, 8295,
     /*  970795 */     GIR_EraseRootFromParent_Done,
     /*  970796 */   // Label 14567: @970796
     /*  970796 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(970891), // Rule ID 8298 //
     /*  970801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970851 */     // MIs[1] Operand 1
     /*  970851 */     // No operand predicates
     /*  970851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970889 */     GIR_RootConstrainSelectedInstOperands,
     /*  970890 */     // GIR_Coverage, 8298,
     /*  970890 */     GIR_EraseRootFromParent_Done,
     /*  970891 */   // Label 14568: @970891
     /*  970891 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(970986), // Rule ID 8299 //
     /*  970896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970946 */     // MIs[1] Operand 1
     /*  970946 */     // No operand predicates
     /*  970946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970984 */     GIR_RootConstrainSelectedInstOperands,
     /*  970985 */     // GIR_Coverage, 8299,
     /*  970985 */     GIR_EraseRootFromParent_Done,
     /*  970986 */   // Label 14569: @970986
     /*  970986 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(971081), // Rule ID 8302 //
     /*  970991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971041 */     // MIs[1] Operand 1
     /*  971041 */     // No operand predicates
     /*  971041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971054 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  971054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971079 */     GIR_RootConstrainSelectedInstOperands,
     /*  971080 */     // GIR_Coverage, 8302,
     /*  971080 */     GIR_EraseRootFromParent_Done,
     /*  971081 */   // Label 14570: @971081
     /*  971081 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(971176), // Rule ID 8303 //
     /*  971086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  971103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971136 */     // MIs[1] Operand 1
     /*  971136 */     // No operand predicates
     /*  971136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971149 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  971149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971174 */     GIR_RootConstrainSelectedInstOperands,
     /*  971175 */     // GIR_Coverage, 8303,
     /*  971175 */     GIR_EraseRootFromParent_Done,
     /*  971176 */   // Label 14571: @971176
     /*  971176 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(971271), // Rule ID 8306 //
     /*  971181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  971192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  971195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  971198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  971204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971231 */     // MIs[1] Operand 1
     /*  971231 */     // No operand predicates
     /*  971231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971244 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  971244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971269 */     GIR_RootConstrainSelectedInstOperands,
     /*  971270 */     // GIR_Coverage, 8306,
     /*  971270 */     GIR_EraseRootFromParent_Done,
     /*  971271 */   // Label 14572: @971271
     /*  971271 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(971366), // Rule ID 8307 //
     /*  971276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  971287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  971290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  971293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  971299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971326 */     // MIs[1] Operand 1
     /*  971326 */     // No operand predicates
     /*  971326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971339 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  971339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  971361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971364 */     GIR_RootConstrainSelectedInstOperands,
     /*  971365 */     // GIR_Coverage, 8307,
     /*  971365 */     GIR_EraseRootFromParent_Done,
     /*  971366 */   // Label 14573: @971366
     /*  971366 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(971461), // Rule ID 8310 //
     /*  971371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971421 */     // MIs[1] Operand 1
     /*  971421 */     // No operand predicates
     /*  971421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971459 */     GIR_RootConstrainSelectedInstOperands,
     /*  971460 */     // GIR_Coverage, 8310,
     /*  971460 */     GIR_EraseRootFromParent_Done,
     /*  971461 */   // Label 14574: @971461
     /*  971461 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(971556), // Rule ID 8311 //
     /*  971466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971516 */     // MIs[1] Operand 1
     /*  971516 */     // No operand predicates
     /*  971516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971529 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971554 */     GIR_RootConstrainSelectedInstOperands,
     /*  971555 */     // GIR_Coverage, 8311,
     /*  971555 */     GIR_EraseRootFromParent_Done,
     /*  971556 */   // Label 14575: @971556
     /*  971556 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(971651), // Rule ID 8314 //
     /*  971561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971611 */     // MIs[1] Operand 1
     /*  971611 */     // No operand predicates
     /*  971611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971624 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971649 */     GIR_RootConstrainSelectedInstOperands,
     /*  971650 */     // GIR_Coverage, 8314,
     /*  971650 */     GIR_EraseRootFromParent_Done,
     /*  971651 */   // Label 14576: @971651
     /*  971651 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(971746), // Rule ID 8315 //
     /*  971656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971706 */     // MIs[1] Operand 1
     /*  971706 */     // No operand predicates
     /*  971706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971719 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971744 */     GIR_RootConstrainSelectedInstOperands,
     /*  971745 */     // GIR_Coverage, 8315,
     /*  971745 */     GIR_EraseRootFromParent_Done,
     /*  971746 */   // Label 14577: @971746
     /*  971746 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(971841), // Rule ID 8318 //
     /*  971751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971801 */     // MIs[1] Operand 1
     /*  971801 */     // No operand predicates
     /*  971801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971814 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971839 */     GIR_RootConstrainSelectedInstOperands,
     /*  971840 */     // GIR_Coverage, 8318,
     /*  971840 */     GIR_EraseRootFromParent_Done,
     /*  971841 */   // Label 14578: @971841
     /*  971841 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(971936), // Rule ID 8319 //
     /*  971846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971896 */     // MIs[1] Operand 1
     /*  971896 */     // No operand predicates
     /*  971896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971909 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971934 */     GIR_RootConstrainSelectedInstOperands,
     /*  971935 */     // GIR_Coverage, 8319,
     /*  971935 */     GIR_EraseRootFromParent_Done,
     /*  971936 */   // Label 14579: @971936
     /*  971936 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(972031), // Rule ID 8322 //
     /*  971941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971991 */     // MIs[1] Operand 1
     /*  971991 */     // No operand predicates
     /*  971991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  972007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972029 */     GIR_RootConstrainSelectedInstOperands,
     /*  972030 */     // GIR_Coverage, 8322,
     /*  972030 */     GIR_EraseRootFromParent_Done,
     /*  972031 */   // Label 14580: @972031
     /*  972031 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(972126), // Rule ID 8323 //
     /*  972036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  972053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  972074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972086 */     // MIs[1] Operand 1
     /*  972086 */     // No operand predicates
     /*  972086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  972102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972124 */     GIR_RootConstrainSelectedInstOperands,
     /*  972125 */     // GIR_Coverage, 8323,
     /*  972125 */     GIR_EraseRootFromParent_Done,
     /*  972126 */   // Label 14581: @972126
     /*  972126 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(972221), // Rule ID 8326 //
     /*  972131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  972134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  972148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972181 */     // MIs[1] Operand 1
     /*  972181 */     // No operand predicates
     /*  972181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  972197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972219 */     GIR_RootConstrainSelectedInstOperands,
     /*  972220 */     // GIR_Coverage, 8326,
     /*  972220 */     GIR_EraseRootFromParent_Done,
     /*  972221 */   // Label 14582: @972221
     /*  972221 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(972316), // Rule ID 8327 //
     /*  972226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  972243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  972264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972276 */     // MIs[1] Operand 1
     /*  972276 */     // No operand predicates
     /*  972276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972289 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  972292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972314 */     GIR_RootConstrainSelectedInstOperands,
     /*  972315 */     // GIR_Coverage, 8327,
     /*  972315 */     GIR_EraseRootFromParent_Done,
     /*  972316 */   // Label 14583: @972316
     /*  972316 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(972411), // Rule ID 8330 //
     /*  972321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  972324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  972338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972371 */     // MIs[1] Operand 1
     /*  972371 */     // No operand predicates
     /*  972371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  972384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972409 */     GIR_RootConstrainSelectedInstOperands,
     /*  972410 */     // GIR_Coverage, 8330,
     /*  972410 */     GIR_EraseRootFromParent_Done,
     /*  972411 */   // Label 14584: @972411
     /*  972411 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(972506), // Rule ID 8331 //
     /*  972416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  972419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  972433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  972454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972466 */     // MIs[1] Operand 1
     /*  972466 */     // No operand predicates
     /*  972466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972479 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972504 */     GIR_RootConstrainSelectedInstOperands,
     /*  972505 */     // GIR_Coverage, 8331,
     /*  972505 */     GIR_EraseRootFromParent_Done,
     /*  972506 */   // Label 14585: @972506
     /*  972506 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(972601), // Rule ID 8862 //
     /*  972511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972561 */     // MIs[1] Operand 1
     /*  972561 */     // No operand predicates
     /*  972561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972599 */     GIR_RootConstrainSelectedInstOperands,
     /*  972600 */     // GIR_Coverage, 8862,
     /*  972600 */     GIR_EraseRootFromParent_Done,
     /*  972601 */   // Label 14586: @972601
     /*  972601 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(972696), // Rule ID 8863 //
     /*  972606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972656 */     // MIs[1] Operand 1
     /*  972656 */     // No operand predicates
     /*  972656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972669 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972694 */     GIR_RootConstrainSelectedInstOperands,
     /*  972695 */     // GIR_Coverage, 8863,
     /*  972695 */     GIR_EraseRootFromParent_Done,
     /*  972696 */   // Label 14587: @972696
     /*  972696 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(972791), // Rule ID 8866 //
     /*  972701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972751 */     // MIs[1] Operand 1
     /*  972751 */     // No operand predicates
     /*  972751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972789 */     GIR_RootConstrainSelectedInstOperands,
     /*  972790 */     // GIR_Coverage, 8866,
     /*  972790 */     GIR_EraseRootFromParent_Done,
     /*  972791 */   // Label 14588: @972791
     /*  972791 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(972886), // Rule ID 8867 //
     /*  972796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972846 */     // MIs[1] Operand 1
     /*  972846 */     // No operand predicates
     /*  972846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972859 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972884 */     GIR_RootConstrainSelectedInstOperands,
     /*  972885 */     // GIR_Coverage, 8867,
     /*  972885 */     GIR_EraseRootFromParent_Done,
     /*  972886 */   // Label 14589: @972886
     /*  972886 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(972981), // Rule ID 8870 //
     /*  972891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972941 */     // MIs[1] Operand 1
     /*  972941 */     // No operand predicates
     /*  972941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972979 */     GIR_RootConstrainSelectedInstOperands,
     /*  972980 */     // GIR_Coverage, 8870,
     /*  972980 */     GIR_EraseRootFromParent_Done,
     /*  972981 */   // Label 14590: @972981
     /*  972981 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(973076), // Rule ID 8871 //
     /*  972986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  973003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973036 */     // MIs[1] Operand 1
     /*  973036 */     // No operand predicates
     /*  973036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973049 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973074 */     GIR_RootConstrainSelectedInstOperands,
     /*  973075 */     // GIR_Coverage, 8871,
     /*  973075 */     GIR_EraseRootFromParent_Done,
     /*  973076 */   // Label 14591: @973076
     /*  973076 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(973171), // Rule ID 8874 //
     /*  973081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973131 */     // MIs[1] Operand 1
     /*  973131 */     // No operand predicates
     /*  973131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  973147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973169 */     GIR_RootConstrainSelectedInstOperands,
     /*  973170 */     // GIR_Coverage, 8874,
     /*  973170 */     GIR_EraseRootFromParent_Done,
     /*  973171 */   // Label 14592: @973171
     /*  973171 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(973266), // Rule ID 8875 //
     /*  973176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  973193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973226 */     // MIs[1] Operand 1
     /*  973226 */     // No operand predicates
     /*  973226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973239 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  973242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973264 */     GIR_RootConstrainSelectedInstOperands,
     /*  973265 */     // GIR_Coverage, 8875,
     /*  973265 */     GIR_EraseRootFromParent_Done,
     /*  973266 */   // Label 14593: @973266
     /*  973266 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(973361), // Rule ID 8878 //
     /*  973271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973321 */     // MIs[1] Operand 1
     /*  973321 */     // No operand predicates
     /*  973321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973359 */     GIR_RootConstrainSelectedInstOperands,
     /*  973360 */     // GIR_Coverage, 8878,
     /*  973360 */     GIR_EraseRootFromParent_Done,
     /*  973361 */   // Label 14594: @973361
     /*  973361 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(973456), // Rule ID 8879 //
     /*  973366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  973383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973416 */     // MIs[1] Operand 1
     /*  973416 */     // No operand predicates
     /*  973416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973429 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973454 */     GIR_RootConstrainSelectedInstOperands,
     /*  973455 */     // GIR_Coverage, 8879,
     /*  973455 */     GIR_EraseRootFromParent_Done,
     /*  973456 */   // Label 14595: @973456
     /*  973456 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(973551), // Rule ID 8882 //
     /*  973461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973511 */     // MIs[1] Operand 1
     /*  973511 */     // No operand predicates
     /*  973511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973524 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973549 */     GIR_RootConstrainSelectedInstOperands,
     /*  973550 */     // GIR_Coverage, 8882,
     /*  973550 */     GIR_EraseRootFromParent_Done,
     /*  973551 */   // Label 14596: @973551
     /*  973551 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(973646), // Rule ID 8883 //
     /*  973556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973606 */     // MIs[1] Operand 1
     /*  973606 */     // No operand predicates
     /*  973606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973619 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973644 */     GIR_RootConstrainSelectedInstOperands,
     /*  973645 */     // GIR_Coverage, 8883,
     /*  973645 */     GIR_EraseRootFromParent_Done,
     /*  973646 */   // Label 14597: @973646
     /*  973646 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(973741), // Rule ID 8886 //
     /*  973651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973701 */     // MIs[1] Operand 1
     /*  973701 */     // No operand predicates
     /*  973701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973739 */     GIR_RootConstrainSelectedInstOperands,
     /*  973740 */     // GIR_Coverage, 8886,
     /*  973740 */     GIR_EraseRootFromParent_Done,
     /*  973741 */   // Label 14598: @973741
     /*  973741 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(973836), // Rule ID 8887 //
     /*  973746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973796 */     // MIs[1] Operand 1
     /*  973796 */     // No operand predicates
     /*  973796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973809 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973834 */     GIR_RootConstrainSelectedInstOperands,
     /*  973835 */     // GIR_Coverage, 8887,
     /*  973835 */     GIR_EraseRootFromParent_Done,
     /*  973836 */   // Label 14599: @973836
     /*  973836 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(973931), // Rule ID 8890 //
     /*  973841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973891 */     // MIs[1] Operand 1
     /*  973891 */     // No operand predicates
     /*  973891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973929 */     GIR_RootConstrainSelectedInstOperands,
     /*  973930 */     // GIR_Coverage, 8890,
     /*  973930 */     GIR_EraseRootFromParent_Done,
     /*  973931 */   // Label 14600: @973931
     /*  973931 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(974026), // Rule ID 8891 //
     /*  973936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973986 */     // MIs[1] Operand 1
     /*  973986 */     // No operand predicates
     /*  973986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973999 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974024 */     GIR_RootConstrainSelectedInstOperands,
     /*  974025 */     // GIR_Coverage, 8891,
     /*  974025 */     GIR_EraseRootFromParent_Done,
     /*  974026 */   // Label 14601: @974026
     /*  974026 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(974121), // Rule ID 8894 //
     /*  974031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  974042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  974045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  974054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974081 */     // MIs[1] Operand 1
     /*  974081 */     // No operand predicates
     /*  974081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974119 */     GIR_RootConstrainSelectedInstOperands,
     /*  974120 */     // GIR_Coverage, 8894,
     /*  974120 */     GIR_EraseRootFromParent_Done,
     /*  974121 */   // Label 14602: @974121
     /*  974121 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(974216), // Rule ID 8895 //
     /*  974126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  974137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  974140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  974143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  974149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974176 */     // MIs[1] Operand 1
     /*  974176 */     // No operand predicates
     /*  974176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974214 */     GIR_RootConstrainSelectedInstOperands,
     /*  974215 */     // GIR_Coverage, 8895,
     /*  974215 */     GIR_EraseRootFromParent_Done,
     /*  974216 */   // Label 14603: @974216
     /*  974216 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(974311), // Rule ID 8898 //
     /*  974221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  974224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  974232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  974235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  974238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  974244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974271 */     // MIs[1] Operand 1
     /*  974271 */     // No operand predicates
     /*  974271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974284 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  974284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  974306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974309 */     GIR_RootConstrainSelectedInstOperands,
     /*  974310 */     // GIR_Coverage, 8898,
     /*  974310 */     GIR_EraseRootFromParent_Done,
     /*  974311 */   // Label 14604: @974311
     /*  974311 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(974406), // Rule ID 8899 //
     /*  974316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  974319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  974327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  974330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  974333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  974339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974366 */     // MIs[1] Operand 1
     /*  974366 */     // No operand predicates
     /*  974366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974379 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  974379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  974382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  974401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974404 */     GIR_RootConstrainSelectedInstOperands,
     /*  974405 */     // GIR_Coverage, 8899,
     /*  974405 */     GIR_EraseRootFromParent_Done,
     /*  974406 */   // Label 14605: @974406
     /*  974406 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(974501), // Rule ID 8902 //
     /*  974411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974461 */     // MIs[1] Operand 1
     /*  974461 */     // No operand predicates
     /*  974461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974499 */     GIR_RootConstrainSelectedInstOperands,
     /*  974500 */     // GIR_Coverage, 8902,
     /*  974500 */     GIR_EraseRootFromParent_Done,
     /*  974501 */   // Label 14606: @974501
     /*  974501 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(974596), // Rule ID 8903 //
     /*  974506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974556 */     // MIs[1] Operand 1
     /*  974556 */     // No operand predicates
     /*  974556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974594 */     GIR_RootConstrainSelectedInstOperands,
     /*  974595 */     // GIR_Coverage, 8903,
     /*  974595 */     GIR_EraseRootFromParent_Done,
     /*  974596 */   // Label 14607: @974596
     /*  974596 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(974691), // Rule ID 8906 //
     /*  974601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974651 */     // MIs[1] Operand 1
     /*  974651 */     // No operand predicates
     /*  974651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974689 */     GIR_RootConstrainSelectedInstOperands,
     /*  974690 */     // GIR_Coverage, 8906,
     /*  974690 */     GIR_EraseRootFromParent_Done,
     /*  974691 */   // Label 14608: @974691
     /*  974691 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(974786), // Rule ID 8907 //
     /*  974696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974746 */     // MIs[1] Operand 1
     /*  974746 */     // No operand predicates
     /*  974746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974759 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974784 */     GIR_RootConstrainSelectedInstOperands,
     /*  974785 */     // GIR_Coverage, 8907,
     /*  974785 */     GIR_EraseRootFromParent_Done,
     /*  974786 */   // Label 14609: @974786
     /*  974786 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(974881), // Rule ID 8910 //
     /*  974791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974841 */     // MIs[1] Operand 1
     /*  974841 */     // No operand predicates
     /*  974841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974854 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974879 */     GIR_RootConstrainSelectedInstOperands,
     /*  974880 */     // GIR_Coverage, 8910,
     /*  974880 */     GIR_EraseRootFromParent_Done,
     /*  974881 */   // Label 14610: @974881
     /*  974881 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(974976), // Rule ID 8911 //
     /*  974886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974936 */     // MIs[1] Operand 1
     /*  974936 */     // No operand predicates
     /*  974936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974949 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974974 */     GIR_RootConstrainSelectedInstOperands,
     /*  974975 */     // GIR_Coverage, 8911,
     /*  974975 */     GIR_EraseRootFromParent_Done,
     /*  974976 */   // Label 14611: @974976
     /*  974976 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(975071), // Rule ID 8914 //
     /*  974981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975031 */     // MIs[1] Operand 1
     /*  975031 */     // No operand predicates
     /*  975031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975069 */     GIR_RootConstrainSelectedInstOperands,
     /*  975070 */     // GIR_Coverage, 8914,
     /*  975070 */     GIR_EraseRootFromParent_Done,
     /*  975071 */   // Label 14612: @975071
     /*  975071 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(975166), // Rule ID 8915 //
     /*  975076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  975093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975126 */     // MIs[1] Operand 1
     /*  975126 */     // No operand predicates
     /*  975126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975164 */     GIR_RootConstrainSelectedInstOperands,
     /*  975165 */     // GIR_Coverage, 8915,
     /*  975165 */     GIR_EraseRootFromParent_Done,
     /*  975166 */   // Label 14613: @975166
     /*  975166 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(975261), // Rule ID 8918 //
     /*  975171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  975188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975221 */     // MIs[1] Operand 1
     /*  975221 */     // No operand predicates
     /*  975221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975259 */     GIR_RootConstrainSelectedInstOperands,
     /*  975260 */     // GIR_Coverage, 8918,
     /*  975260 */     GIR_EraseRootFromParent_Done,
     /*  975261 */   // Label 14614: @975261
     /*  975261 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(975356), // Rule ID 8919 //
     /*  975266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  975283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975316 */     // MIs[1] Operand 1
     /*  975316 */     // No operand predicates
     /*  975316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975329 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975354 */     GIR_RootConstrainSelectedInstOperands,
     /*  975355 */     // GIR_Coverage, 8919,
     /*  975355 */     GIR_EraseRootFromParent_Done,
     /*  975356 */   // Label 14615: @975356
     /*  975356 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(975451), // Rule ID 8922 //
     /*  975361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975411 */     // MIs[1] Operand 1
     /*  975411 */     // No operand predicates
     /*  975411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975424 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  975424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975449 */     GIR_RootConstrainSelectedInstOperands,
     /*  975450 */     // GIR_Coverage, 8922,
     /*  975450 */     GIR_EraseRootFromParent_Done,
     /*  975451 */   // Label 14616: @975451
     /*  975451 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(975546), // Rule ID 8923 //
     /*  975456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975506 */     // MIs[1] Operand 1
     /*  975506 */     // No operand predicates
     /*  975506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975519 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975544 */     GIR_RootConstrainSelectedInstOperands,
     /*  975545 */     // GIR_Coverage, 8923,
     /*  975545 */     GIR_EraseRootFromParent_Done,
     /*  975546 */   // Label 14617: @975546
     /*  975546 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(975641), // Rule ID 8926 //
     /*  975551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975601 */     // MIs[1] Operand 1
     /*  975601 */     // No operand predicates
     /*  975601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975639 */     GIR_RootConstrainSelectedInstOperands,
     /*  975640 */     // GIR_Coverage, 8926,
     /*  975640 */     GIR_EraseRootFromParent_Done,
     /*  975641 */   // Label 14618: @975641
     /*  975641 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(975736), // Rule ID 8927 //
     /*  975646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975696 */     // MIs[1] Operand 1
     /*  975696 */     // No operand predicates
     /*  975696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975709 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975734 */     GIR_RootConstrainSelectedInstOperands,
     /*  975735 */     // GIR_Coverage, 8927,
     /*  975735 */     GIR_EraseRootFromParent_Done,
     /*  975736 */   // Label 14619: @975736
     /*  975736 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(975831), // Rule ID 8930 //
     /*  975741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975791 */     // MIs[1] Operand 1
     /*  975791 */     // No operand predicates
     /*  975791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975829 */     GIR_RootConstrainSelectedInstOperands,
     /*  975830 */     // GIR_Coverage, 8930,
     /*  975830 */     GIR_EraseRootFromParent_Done,
     /*  975831 */   // Label 14620: @975831
     /*  975831 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(975926), // Rule ID 8931 //
     /*  975836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975886 */     // MIs[1] Operand 1
     /*  975886 */     // No operand predicates
     /*  975886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975924 */     GIR_RootConstrainSelectedInstOperands,
     /*  975925 */     // GIR_Coverage, 8931,
     /*  975925 */     GIR_EraseRootFromParent_Done,
     /*  975926 */   // Label 14621: @975926
     /*  975926 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(976021), // Rule ID 8934 //
     /*  975931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975981 */     // MIs[1] Operand 1
     /*  975981 */     // No operand predicates
     /*  975981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976019 */     GIR_RootConstrainSelectedInstOperands,
     /*  976020 */     // GIR_Coverage, 8934,
     /*  976020 */     GIR_EraseRootFromParent_Done,
     /*  976021 */   // Label 14622: @976021
     /*  976021 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(976116), // Rule ID 8935 //
     /*  976026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  976037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  976040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  976043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  976049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976076 */     // MIs[1] Operand 1
     /*  976076 */     // No operand predicates
     /*  976076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976089 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  976089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976114 */     GIR_RootConstrainSelectedInstOperands,
     /*  976115 */     // GIR_Coverage, 8935,
     /*  976115 */     GIR_EraseRootFromParent_Done,
     /*  976116 */   // Label 14623: @976116
     /*  976116 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(976211), // Rule ID 8938 //
     /*  976121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976171 */     // MIs[1] Operand 1
     /*  976171 */     // No operand predicates
     /*  976171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  976187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976209 */     GIR_RootConstrainSelectedInstOperands,
     /*  976210 */     // GIR_Coverage, 8938,
     /*  976210 */     GIR_EraseRootFromParent_Done,
     /*  976211 */   // Label 14624: @976211
     /*  976211 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(976306), // Rule ID 8939 //
     /*  976216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  976233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  976254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976266 */     // MIs[1] Operand 1
     /*  976266 */     // No operand predicates
     /*  976266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  976282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976304 */     GIR_RootConstrainSelectedInstOperands,
     /*  976305 */     // GIR_Coverage, 8939,
     /*  976305 */     GIR_EraseRootFromParent_Done,
     /*  976306 */   // Label 14625: @976306
     /*  976306 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(976401), // Rule ID 8942 //
     /*  976311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  976328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976361 */     // MIs[1] Operand 1
     /*  976361 */     // No operand predicates
     /*  976361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976399 */     GIR_RootConstrainSelectedInstOperands,
     /*  976400 */     // GIR_Coverage, 8942,
     /*  976400 */     GIR_EraseRootFromParent_Done,
     /*  976401 */   // Label 14626: @976401
     /*  976401 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(976496), // Rule ID 8943 //
     /*  976406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  976423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  976444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976456 */     // MIs[1] Operand 1
     /*  976456 */     // No operand predicates
     /*  976456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976494 */     GIR_RootConstrainSelectedInstOperands,
     /*  976495 */     // GIR_Coverage, 8943,
     /*  976495 */     GIR_EraseRootFromParent_Done,
     /*  976496 */   // Label 14627: @976496
     /*  976496 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(976591), // Rule ID 8946 //
     /*  976501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976551 */     // MIs[1] Operand 1
     /*  976551 */     // No operand predicates
     /*  976551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976564 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976589 */     GIR_RootConstrainSelectedInstOperands,
     /*  976590 */     // GIR_Coverage, 8946,
     /*  976590 */     GIR_EraseRootFromParent_Done,
     /*  976591 */   // Label 14628: @976591
     /*  976591 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(976686), // Rule ID 8947 //
     /*  976596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976646 */     // MIs[1] Operand 1
     /*  976646 */     // No operand predicates
     /*  976646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976659 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976684 */     GIR_RootConstrainSelectedInstOperands,
     /*  976685 */     // GIR_Coverage, 8947,
     /*  976685 */     GIR_EraseRootFromParent_Done,
     /*  976686 */   // Label 14629: @976686
     /*  976686 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(976781), // Rule ID 9126 //
     /*  976691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976741 */     // MIs[1] Operand 1
     /*  976741 */     // No operand predicates
     /*  976741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976754 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976779 */     GIR_RootConstrainSelectedInstOperands,
     /*  976780 */     // GIR_Coverage, 9126,
     /*  976780 */     GIR_EraseRootFromParent_Done,
     /*  976781 */   // Label 14630: @976781
     /*  976781 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(976876), // Rule ID 9127 //
     /*  976786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976836 */     // MIs[1] Operand 1
     /*  976836 */     // No operand predicates
     /*  976836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976849 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976874 */     GIR_RootConstrainSelectedInstOperands,
     /*  976875 */     // GIR_Coverage, 9127,
     /*  976875 */     GIR_EraseRootFromParent_Done,
     /*  976876 */   // Label 14631: @976876
     /*  976876 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(976971), // Rule ID 9130 //
     /*  976881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976931 */     // MIs[1] Operand 1
     /*  976931 */     // No operand predicates
     /*  976931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976969 */     GIR_RootConstrainSelectedInstOperands,
     /*  976970 */     // GIR_Coverage, 9130,
     /*  976970 */     GIR_EraseRootFromParent_Done,
     /*  976971 */   // Label 14632: @976971
     /*  976971 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(977066), // Rule ID 9131 //
     /*  976976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977026 */     // MIs[1] Operand 1
     /*  977026 */     // No operand predicates
     /*  977026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977064 */     GIR_RootConstrainSelectedInstOperands,
     /*  977065 */     // GIR_Coverage, 9131,
     /*  977065 */     GIR_EraseRootFromParent_Done,
     /*  977066 */   // Label 14633: @977066
     /*  977066 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(977161), // Rule ID 9134 //
     /*  977071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  977088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977121 */     // MIs[1] Operand 1
     /*  977121 */     // No operand predicates
     /*  977121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977159 */     GIR_RootConstrainSelectedInstOperands,
     /*  977160 */     // GIR_Coverage, 9134,
     /*  977160 */     GIR_EraseRootFromParent_Done,
     /*  977161 */   // Label 14634: @977161
     /*  977161 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(977256), // Rule ID 9135 //
     /*  977166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  977183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977216 */     // MIs[1] Operand 1
     /*  977216 */     // No operand predicates
     /*  977216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977229 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977254 */     GIR_RootConstrainSelectedInstOperands,
     /*  977255 */     // GIR_Coverage, 9135,
     /*  977255 */     GIR_EraseRootFromParent_Done,
     /*  977256 */   // Label 14635: @977256
     /*  977256 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(977351), // Rule ID 9138 //
     /*  977261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  977278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977311 */     // MIs[1] Operand 1
     /*  977311 */     // No operand predicates
     /*  977311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977349 */     GIR_RootConstrainSelectedInstOperands,
     /*  977350 */     // GIR_Coverage, 9138,
     /*  977350 */     GIR_EraseRootFromParent_Done,
     /*  977351 */   // Label 14636: @977351
     /*  977351 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(977446), // Rule ID 9139 //
     /*  977356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  977373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977406 */     // MIs[1] Operand 1
     /*  977406 */     // No operand predicates
     /*  977406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977419 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  977422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977444 */     GIR_RootConstrainSelectedInstOperands,
     /*  977445 */     // GIR_Coverage, 9139,
     /*  977445 */     GIR_EraseRootFromParent_Done,
     /*  977446 */   // Label 14637: @977446
     /*  977446 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(977541), // Rule ID 9142 //
     /*  977451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977501 */     // MIs[1] Operand 1
     /*  977501 */     // No operand predicates
     /*  977501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977539 */     GIR_RootConstrainSelectedInstOperands,
     /*  977540 */     // GIR_Coverage, 9142,
     /*  977540 */     GIR_EraseRootFromParent_Done,
     /*  977541 */   // Label 14638: @977541
     /*  977541 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(977636), // Rule ID 9143 //
     /*  977546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977596 */     // MIs[1] Operand 1
     /*  977596 */     // No operand predicates
     /*  977596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977609 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977634 */     GIR_RootConstrainSelectedInstOperands,
     /*  977635 */     // GIR_Coverage, 9143,
     /*  977635 */     GIR_EraseRootFromParent_Done,
     /*  977636 */   // Label 14639: @977636
     /*  977636 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(977731), // Rule ID 9146 //
     /*  977641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977691 */     // MIs[1] Operand 1
     /*  977691 */     // No operand predicates
     /*  977691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977729 */     GIR_RootConstrainSelectedInstOperands,
     /*  977730 */     // GIR_Coverage, 9146,
     /*  977730 */     GIR_EraseRootFromParent_Done,
     /*  977731 */   // Label 14640: @977731
     /*  977731 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(977826), // Rule ID 9147 //
     /*  977736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977786 */     // MIs[1] Operand 1
     /*  977786 */     // No operand predicates
     /*  977786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977799 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977824 */     GIR_RootConstrainSelectedInstOperands,
     /*  977825 */     // GIR_Coverage, 9147,
     /*  977825 */     GIR_EraseRootFromParent_Done,
     /*  977826 */   // Label 14641: @977826
     /*  977826 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(977921), // Rule ID 9150 //
     /*  977831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977881 */     // MIs[1] Operand 1
     /*  977881 */     // No operand predicates
     /*  977881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977919 */     GIR_RootConstrainSelectedInstOperands,
     /*  977920 */     // GIR_Coverage, 9150,
     /*  977920 */     GIR_EraseRootFromParent_Done,
     /*  977921 */   // Label 14642: @977921
     /*  977921 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(978016), // Rule ID 9151 //
     /*  977926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977976 */     // MIs[1] Operand 1
     /*  977976 */     // No operand predicates
     /*  977976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978014 */     GIR_RootConstrainSelectedInstOperands,
     /*  978015 */     // GIR_Coverage, 9151,
     /*  978015 */     GIR_EraseRootFromParent_Done,
     /*  978016 */   // Label 14643: @978016
     /*  978016 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(978111), // Rule ID 9154 //
     /*  978021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  978038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978071 */     // MIs[1] Operand 1
     /*  978071 */     // No operand predicates
     /*  978071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978109 */     GIR_RootConstrainSelectedInstOperands,
     /*  978110 */     // GIR_Coverage, 9154,
     /*  978110 */     GIR_EraseRootFromParent_Done,
     /*  978111 */   // Label 14644: @978111
     /*  978111 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(978206), // Rule ID 9155 //
     /*  978116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  978133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978166 */     // MIs[1] Operand 1
     /*  978166 */     // No operand predicates
     /*  978166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978204 */     GIR_RootConstrainSelectedInstOperands,
     /*  978205 */     // GIR_Coverage, 9155,
     /*  978205 */     GIR_EraseRootFromParent_Done,
     /*  978206 */   // Label 14645: @978206
     /*  978206 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(978301), // Rule ID 9158 //
     /*  978211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  978222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  978225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  978228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  978234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978261 */     // MIs[1] Operand 1
     /*  978261 */     // No operand predicates
     /*  978261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  978274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978299 */     GIR_RootConstrainSelectedInstOperands,
     /*  978300 */     // GIR_Coverage, 9158,
     /*  978300 */     GIR_EraseRootFromParent_Done,
     /*  978301 */   // Label 14646: @978301
     /*  978301 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(978396), // Rule ID 9159 //
     /*  978306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  978317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  978320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  978323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  978329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978356 */     // MIs[1] Operand 1
     /*  978356 */     // No operand predicates
     /*  978356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  978369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978394 */     GIR_RootConstrainSelectedInstOperands,
     /*  978395 */     // GIR_Coverage, 9159,
     /*  978395 */     GIR_EraseRootFromParent_Done,
     /*  978396 */   // Label 14647: @978396
     /*  978396 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(978491), // Rule ID 9162 //
     /*  978401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  978404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978451 */     // MIs[1] Operand 1
     /*  978451 */     // No operand predicates
     /*  978451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  978464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978489 */     GIR_RootConstrainSelectedInstOperands,
     /*  978490 */     // GIR_Coverage, 9162,
     /*  978490 */     GIR_EraseRootFromParent_Done,
     /*  978491 */   // Label 14648: @978491
     /*  978491 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(978586), // Rule ID 9163 //
     /*  978496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  978499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978546 */     // MIs[1] Operand 1
     /*  978546 */     // No operand predicates
     /*  978546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  978559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978584 */     GIR_RootConstrainSelectedInstOperands,
     /*  978585 */     // GIR_Coverage, 9163,
     /*  978585 */     GIR_EraseRootFromParent_Done,
     /*  978586 */   // Label 14649: @978586
     /*  978586 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(978681), // Rule ID 9166 //
     /*  978591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978641 */     // MIs[1] Operand 1
     /*  978641 */     // No operand predicates
     /*  978641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978654 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978679 */     GIR_RootConstrainSelectedInstOperands,
     /*  978680 */     // GIR_Coverage, 9166,
     /*  978680 */     GIR_EraseRootFromParent_Done,
     /*  978681 */   // Label 14650: @978681
     /*  978681 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(978776), // Rule ID 9167 //
     /*  978686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978736 */     // MIs[1] Operand 1
     /*  978736 */     // No operand predicates
     /*  978736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978774 */     GIR_RootConstrainSelectedInstOperands,
     /*  978775 */     // GIR_Coverage, 9167,
     /*  978775 */     GIR_EraseRootFromParent_Done,
     /*  978776 */   // Label 14651: @978776
     /*  978776 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(978871), // Rule ID 9170 //
     /*  978781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978831 */     // MIs[1] Operand 1
     /*  978831 */     // No operand predicates
     /*  978831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978844 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978869 */     GIR_RootConstrainSelectedInstOperands,
     /*  978870 */     // GIR_Coverage, 9170,
     /*  978870 */     GIR_EraseRootFromParent_Done,
     /*  978871 */   // Label 14652: @978871
     /*  978871 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(978966), // Rule ID 9171 //
     /*  978876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978926 */     // MIs[1] Operand 1
     /*  978926 */     // No operand predicates
     /*  978926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978939 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978964 */     GIR_RootConstrainSelectedInstOperands,
     /*  978965 */     // GIR_Coverage, 9171,
     /*  978965 */     GIR_EraseRootFromParent_Done,
     /*  978966 */   // Label 14653: @978966
     /*  978966 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(979061), // Rule ID 9174 //
     /*  978971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979021 */     // MIs[1] Operand 1
     /*  979021 */     // No operand predicates
     /*  979021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979034 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  979034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979059 */     GIR_RootConstrainSelectedInstOperands,
     /*  979060 */     // GIR_Coverage, 9174,
     /*  979060 */     GIR_EraseRootFromParent_Done,
     /*  979061 */   // Label 14654: @979061
     /*  979061 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(979156), // Rule ID 9175 //
     /*  979066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  979077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  979080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  979083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  979089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979116 */     // MIs[1] Operand 1
     /*  979116 */     // No operand predicates
     /*  979116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979129 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  979129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979154 */     GIR_RootConstrainSelectedInstOperands,
     /*  979155 */     // GIR_Coverage, 9175,
     /*  979155 */     GIR_EraseRootFromParent_Done,
     /*  979156 */   // Label 14655: @979156
     /*  979156 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(979251), // Rule ID 9178 //
     /*  979161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  979178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979211 */     // MIs[1] Operand 1
     /*  979211 */     // No operand predicates
     /*  979211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979249 */     GIR_RootConstrainSelectedInstOperands,
     /*  979250 */     // GIR_Coverage, 9178,
     /*  979250 */     GIR_EraseRootFromParent_Done,
     /*  979251 */   // Label 14656: @979251
     /*  979251 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(979346), // Rule ID 9179 //
     /*  979256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  979273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979306 */     // MIs[1] Operand 1
     /*  979306 */     // No operand predicates
     /*  979306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979319 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979344 */     GIR_RootConstrainSelectedInstOperands,
     /*  979345 */     // GIR_Coverage, 9179,
     /*  979345 */     GIR_EraseRootFromParent_Done,
     /*  979346 */   // Label 14657: @979346
     /*  979346 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(979441), // Rule ID 9182 //
     /*  979351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  979368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979401 */     // MIs[1] Operand 1
     /*  979401 */     // No operand predicates
     /*  979401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979439 */     GIR_RootConstrainSelectedInstOperands,
     /*  979440 */     // GIR_Coverage, 9182,
     /*  979440 */     GIR_EraseRootFromParent_Done,
     /*  979441 */   // Label 14658: @979441
     /*  979441 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(979536), // Rule ID 9183 //
     /*  979446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  979463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979496 */     // MIs[1] Operand 1
     /*  979496 */     // No operand predicates
     /*  979496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979509 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979534 */     GIR_RootConstrainSelectedInstOperands,
     /*  979535 */     // GIR_Coverage, 9183,
     /*  979535 */     GIR_EraseRootFromParent_Done,
     /*  979536 */   // Label 14659: @979536
     /*  979536 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(979631), // Rule ID 9186 //
     /*  979541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979591 */     // MIs[1] Operand 1
     /*  979591 */     // No operand predicates
     /*  979591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979604 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979629 */     GIR_RootConstrainSelectedInstOperands,
     /*  979630 */     // GIR_Coverage, 9186,
     /*  979630 */     GIR_EraseRootFromParent_Done,
     /*  979631 */   // Label 14660: @979631
     /*  979631 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(979726), // Rule ID 9187 //
     /*  979636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979686 */     // MIs[1] Operand 1
     /*  979686 */     // No operand predicates
     /*  979686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979699 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979724 */     GIR_RootConstrainSelectedInstOperands,
     /*  979725 */     // GIR_Coverage, 9187,
     /*  979725 */     GIR_EraseRootFromParent_Done,
     /*  979726 */   // Label 14661: @979726
     /*  979726 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(979821), // Rule ID 9190 //
     /*  979731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979781 */     // MIs[1] Operand 1
     /*  979781 */     // No operand predicates
     /*  979781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979794 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979819 */     GIR_RootConstrainSelectedInstOperands,
     /*  979820 */     // GIR_Coverage, 9190,
     /*  979820 */     GIR_EraseRootFromParent_Done,
     /*  979821 */   // Label 14662: @979821
     /*  979821 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(979916), // Rule ID 9191 //
     /*  979826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979876 */     // MIs[1] Operand 1
     /*  979876 */     // No operand predicates
     /*  979876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979889 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979914 */     GIR_RootConstrainSelectedInstOperands,
     /*  979915 */     // GIR_Coverage, 9191,
     /*  979915 */     GIR_EraseRootFromParent_Done,
     /*  979916 */   // Label 14663: @979916
     /*  979916 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(980011), // Rule ID 9194 //
     /*  979921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979971 */     // MIs[1] Operand 1
     /*  979971 */     // No operand predicates
     /*  979971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980009 */     GIR_RootConstrainSelectedInstOperands,
     /*  980010 */     // GIR_Coverage, 9194,
     /*  980010 */     GIR_EraseRootFromParent_Done,
     /*  980011 */   // Label 14664: @980011
     /*  980011 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(980106), // Rule ID 9195 //
     /*  980016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  980033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980066 */     // MIs[1] Operand 1
     /*  980066 */     // No operand predicates
     /*  980066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980079 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  980079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980104 */     GIR_RootConstrainSelectedInstOperands,
     /*  980105 */     // GIR_Coverage, 9195,
     /*  980105 */     GIR_EraseRootFromParent_Done,
     /*  980106 */   // Label 14665: @980106
     /*  980106 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(980201), // Rule ID 9198 //
     /*  980111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  980122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  980125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  980128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  980134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980161 */     // MIs[1] Operand 1
     /*  980161 */     // No operand predicates
     /*  980161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980174 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  980174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980199 */     GIR_RootConstrainSelectedInstOperands,
     /*  980200 */     // GIR_Coverage, 9198,
     /*  980200 */     GIR_EraseRootFromParent_Done,
     /*  980201 */   // Label 14666: @980201
     /*  980201 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(980296), // Rule ID 9199 //
     /*  980206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  980217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  980220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  980223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  980229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980256 */     // MIs[1] Operand 1
     /*  980256 */     // No operand predicates
     /*  980256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980269 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  980269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980294 */     GIR_RootConstrainSelectedInstOperands,
     /*  980295 */     // GIR_Coverage, 9199,
     /*  980295 */     GIR_EraseRootFromParent_Done,
     /*  980296 */   // Label 14667: @980296
     /*  980296 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(980391), // Rule ID 9202 //
     /*  980301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  980318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980351 */     // MIs[1] Operand 1
     /*  980351 */     // No operand predicates
     /*  980351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  980367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980389 */     GIR_RootConstrainSelectedInstOperands,
     /*  980390 */     // GIR_Coverage, 9202,
     /*  980390 */     GIR_EraseRootFromParent_Done,
     /*  980391 */   // Label 14668: @980391
     /*  980391 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(980486), // Rule ID 9203 //
     /*  980396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  980413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  980434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980446 */     // MIs[1] Operand 1
     /*  980446 */     // No operand predicates
     /*  980446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980459 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  980462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980484 */     GIR_RootConstrainSelectedInstOperands,
     /*  980485 */     // GIR_Coverage, 9203,
     /*  980485 */     GIR_EraseRootFromParent_Done,
     /*  980486 */   // Label 14669: @980486
     /*  980486 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(980581), // Rule ID 9206 //
     /*  980491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980541 */     // MIs[1] Operand 1
     /*  980541 */     // No operand predicates
     /*  980541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980554 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980579 */     GIR_RootConstrainSelectedInstOperands,
     /*  980580 */     // GIR_Coverage, 9206,
     /*  980580 */     GIR_EraseRootFromParent_Done,
     /*  980581 */   // Label 14670: @980581
     /*  980581 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(980676), // Rule ID 9207 //
     /*  980586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980636 */     // MIs[1] Operand 1
     /*  980636 */     // No operand predicates
     /*  980636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980649 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980674 */     GIR_RootConstrainSelectedInstOperands,
     /*  980675 */     // GIR_Coverage, 9207,
     /*  980675 */     GIR_EraseRootFromParent_Done,
     /*  980676 */   // Label 14671: @980676
     /*  980676 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(980771), // Rule ID 9210 //
     /*  980681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980731 */     // MIs[1] Operand 1
     /*  980731 */     // No operand predicates
     /*  980731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980769 */     GIR_RootConstrainSelectedInstOperands,
     /*  980770 */     // GIR_Coverage, 9210,
     /*  980770 */     GIR_EraseRootFromParent_Done,
     /*  980771 */   // Label 14672: @980771
     /*  980771 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(980866), // Rule ID 9211 //
     /*  980776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980826 */     // MIs[1] Operand 1
     /*  980826 */     // No operand predicates
     /*  980826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980839 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980864 */     GIR_RootConstrainSelectedInstOperands,
     /*  980865 */     // GIR_Coverage, 9211,
     /*  980865 */     GIR_EraseRootFromParent_Done,
     /*  980866 */   // Label 14673: @980866
     /*  980866 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(980961), // Rule ID 9302 //
     /*  980871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980921 */     // MIs[1] Operand 1
     /*  980921 */     // No operand predicates
     /*  980921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980934 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980959 */     GIR_RootConstrainSelectedInstOperands,
     /*  980960 */     // GIR_Coverage, 9302,
     /*  980960 */     GIR_EraseRootFromParent_Done,
     /*  980961 */   // Label 14674: @980961
     /*  980961 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(981056), // Rule ID 9303 //
     /*  980966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981016 */     // MIs[1] Operand 1
     /*  981016 */     // No operand predicates
     /*  981016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981029 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  981032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981054 */     GIR_RootConstrainSelectedInstOperands,
     /*  981055 */     // GIR_Coverage, 9303,
     /*  981055 */     GIR_EraseRootFromParent_Done,
     /*  981056 */   // Label 14675: @981056
     /*  981056 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(981151), // Rule ID 9306 //
     /*  981061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  981078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981111 */     // MIs[1] Operand 1
     /*  981111 */     // No operand predicates
     /*  981111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981149 */     GIR_RootConstrainSelectedInstOperands,
     /*  981150 */     // GIR_Coverage, 9306,
     /*  981150 */     GIR_EraseRootFromParent_Done,
     /*  981151 */   // Label 14676: @981151
     /*  981151 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(981246), // Rule ID 9307 //
     /*  981156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  981173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981206 */     // MIs[1] Operand 1
     /*  981206 */     // No operand predicates
     /*  981206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981244 */     GIR_RootConstrainSelectedInstOperands,
     /*  981245 */     // GIR_Coverage, 9307,
     /*  981245 */     GIR_EraseRootFromParent_Done,
     /*  981246 */   // Label 14677: @981246
     /*  981246 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(981341), // Rule ID 9310 //
     /*  981251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  981268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981301 */     // MIs[1] Operand 1
     /*  981301 */     // No operand predicates
     /*  981301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981314 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981339 */     GIR_RootConstrainSelectedInstOperands,
     /*  981340 */     // GIR_Coverage, 9310,
     /*  981340 */     GIR_EraseRootFromParent_Done,
     /*  981341 */   // Label 14678: @981341
     /*  981341 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(981436), // Rule ID 9311 //
     /*  981346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  981363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981396 */     // MIs[1] Operand 1
     /*  981396 */     // No operand predicates
     /*  981396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981409 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981434 */     GIR_RootConstrainSelectedInstOperands,
     /*  981435 */     // GIR_Coverage, 9311,
     /*  981435 */     GIR_EraseRootFromParent_Done,
     /*  981436 */   // Label 14679: @981436
     /*  981436 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(981531), // Rule ID 9314 //
     /*  981441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981491 */     // MIs[1] Operand 1
     /*  981491 */     // No operand predicates
     /*  981491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981529 */     GIR_RootConstrainSelectedInstOperands,
     /*  981530 */     // GIR_Coverage, 9314,
     /*  981530 */     GIR_EraseRootFromParent_Done,
     /*  981531 */   // Label 14680: @981531
     /*  981531 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(981626), // Rule ID 9315 //
     /*  981536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981586 */     // MIs[1] Operand 1
     /*  981586 */     // No operand predicates
     /*  981586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981599 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981624 */     GIR_RootConstrainSelectedInstOperands,
     /*  981625 */     // GIR_Coverage, 9315,
     /*  981625 */     GIR_EraseRootFromParent_Done,
     /*  981626 */   // Label 14681: @981626
     /*  981626 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(981721), // Rule ID 9318 //
     /*  981631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981681 */     // MIs[1] Operand 1
     /*  981681 */     // No operand predicates
     /*  981681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981719 */     GIR_RootConstrainSelectedInstOperands,
     /*  981720 */     // GIR_Coverage, 9318,
     /*  981720 */     GIR_EraseRootFromParent_Done,
     /*  981721 */   // Label 14682: @981721
     /*  981721 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(981816), // Rule ID 9319 //
     /*  981726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981776 */     // MIs[1] Operand 1
     /*  981776 */     // No operand predicates
     /*  981776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981789 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981814 */     GIR_RootConstrainSelectedInstOperands,
     /*  981815 */     // GIR_Coverage, 9319,
     /*  981815 */     GIR_EraseRootFromParent_Done,
     /*  981816 */   // Label 14683: @981816
     /*  981816 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(981911), // Rule ID 9322 //
     /*  981821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981871 */     // MIs[1] Operand 1
     /*  981871 */     // No operand predicates
     /*  981871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981909 */     GIR_RootConstrainSelectedInstOperands,
     /*  981910 */     // GIR_Coverage, 9322,
     /*  981910 */     GIR_EraseRootFromParent_Done,
     /*  981911 */   // Label 14684: @981911
     /*  981911 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(982006), // Rule ID 9323 //
     /*  981916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981966 */     // MIs[1] Operand 1
     /*  981966 */     // No operand predicates
     /*  981966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981979 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982004 */     GIR_RootConstrainSelectedInstOperands,
     /*  982005 */     // GIR_Coverage, 9323,
     /*  982005 */     GIR_EraseRootFromParent_Done,
     /*  982006 */   // Label 14685: @982006
     /*  982006 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(982101), // Rule ID 9326 //
     /*  982011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  982028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982061 */     // MIs[1] Operand 1
     /*  982061 */     // No operand predicates
     /*  982061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982074 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982099 */     GIR_RootConstrainSelectedInstOperands,
     /*  982100 */     // GIR_Coverage, 9326,
     /*  982100 */     GIR_EraseRootFromParent_Done,
     /*  982101 */   // Label 14686: @982101
     /*  982101 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(982196), // Rule ID 9327 //
     /*  982106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  982123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982156 */     // MIs[1] Operand 1
     /*  982156 */     // No operand predicates
     /*  982156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982194 */     GIR_RootConstrainSelectedInstOperands,
     /*  982195 */     // GIR_Coverage, 9327,
     /*  982195 */     GIR_EraseRootFromParent_Done,
     /*  982196 */   // Label 14687: @982196
     /*  982196 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(982291), // Rule ID 9330 //
     /*  982201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  982212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  982215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  982218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  982224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982251 */     // MIs[1] Operand 1
     /*  982251 */     // No operand predicates
     /*  982251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982289 */     GIR_RootConstrainSelectedInstOperands,
     /*  982290 */     // GIR_Coverage, 9330,
     /*  982290 */     GIR_EraseRootFromParent_Done,
     /*  982291 */   // Label 14688: @982291
     /*  982291 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(982386), // Rule ID 9331 //
     /*  982296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  982307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  982310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  982313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  982319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982346 */     // MIs[1] Operand 1
     /*  982346 */     // No operand predicates
     /*  982346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982384 */     GIR_RootConstrainSelectedInstOperands,
     /*  982385 */     // GIR_Coverage, 9331,
     /*  982385 */     GIR_EraseRootFromParent_Done,
     /*  982386 */   // Label 14689: @982386
     /*  982386 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(982481), // Rule ID 9334 //
     /*  982391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982441 */     // MIs[1] Operand 1
     /*  982441 */     // No operand predicates
     /*  982441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  982454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982479 */     GIR_RootConstrainSelectedInstOperands,
     /*  982480 */     // GIR_Coverage, 9334,
     /*  982480 */     GIR_EraseRootFromParent_Done,
     /*  982481 */   // Label 14690: @982481
     /*  982481 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(982576), // Rule ID 9335 //
     /*  982486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982536 */     // MIs[1] Operand 1
     /*  982536 */     // No operand predicates
     /*  982536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  982549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982574 */     GIR_RootConstrainSelectedInstOperands,
     /*  982575 */     // GIR_Coverage, 9335,
     /*  982575 */     GIR_EraseRootFromParent_Done,
     /*  982576 */   // Label 14691: @982576
     /*  982576 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(982671), // Rule ID 9338 //
     /*  982581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  982584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982631 */     // MIs[1] Operand 1
     /*  982631 */     // No operand predicates
     /*  982631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  982644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982669 */     GIR_RootConstrainSelectedInstOperands,
     /*  982670 */     // GIR_Coverage, 9338,
     /*  982670 */     GIR_EraseRootFromParent_Done,
     /*  982671 */   // Label 14692: @982671
     /*  982671 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(982766), // Rule ID 9339 //
     /*  982676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  982679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982726 */     // MIs[1] Operand 1
     /*  982726 */     // No operand predicates
     /*  982726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982739 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  982739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982764 */     GIR_RootConstrainSelectedInstOperands,
     /*  982765 */     // GIR_Coverage, 9339,
     /*  982765 */     GIR_EraseRootFromParent_Done,
     /*  982766 */   // Label 14693: @982766
     /*  982766 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(982861), // Rule ID 9342 //
     /*  982771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982821 */     // MIs[1] Operand 1
     /*  982821 */     // No operand predicates
     /*  982821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982859 */     GIR_RootConstrainSelectedInstOperands,
     /*  982860 */     // GIR_Coverage, 9342,
     /*  982860 */     GIR_EraseRootFromParent_Done,
     /*  982861 */   // Label 14694: @982861
     /*  982861 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(982956), // Rule ID 9343 //
     /*  982866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982916 */     // MIs[1] Operand 1
     /*  982916 */     // No operand predicates
     /*  982916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982929 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982954 */     GIR_RootConstrainSelectedInstOperands,
     /*  982955 */     // GIR_Coverage, 9343,
     /*  982955 */     GIR_EraseRootFromParent_Done,
     /*  982956 */   // Label 14695: @982956
     /*  982956 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(983051), // Rule ID 9346 //
     /*  982961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983011 */     // MIs[1] Operand 1
     /*  983011 */     // No operand predicates
     /*  983011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983024 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  983024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983049 */     GIR_RootConstrainSelectedInstOperands,
     /*  983050 */     // GIR_Coverage, 9346,
     /*  983050 */     GIR_EraseRootFromParent_Done,
     /*  983051 */   // Label 14696: @983051
     /*  983051 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(983146), // Rule ID 9347 //
     /*  983056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  983073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983106 */     // MIs[1] Operand 1
     /*  983106 */     // No operand predicates
     /*  983106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983119 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  983119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983144 */     GIR_RootConstrainSelectedInstOperands,
     /*  983145 */     // GIR_Coverage, 9347,
     /*  983145 */     GIR_EraseRootFromParent_Done,
     /*  983146 */   // Label 14697: @983146
     /*  983146 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(983241), // Rule ID 9350 //
     /*  983151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  983162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  983165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  983168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  983174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983201 */     // MIs[1] Operand 1
     /*  983201 */     // No operand predicates
     /*  983201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983214 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  983214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983239 */     GIR_RootConstrainSelectedInstOperands,
     /*  983240 */     // GIR_Coverage, 9350,
     /*  983240 */     GIR_EraseRootFromParent_Done,
     /*  983241 */   // Label 14698: @983241
     /*  983241 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(983336), // Rule ID 9351 //
     /*  983246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  983257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  983260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  983263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  983269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983296 */     // MIs[1] Operand 1
     /*  983296 */     // No operand predicates
     /*  983296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983309 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  983309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  983331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983334 */     GIR_RootConstrainSelectedInstOperands,
     /*  983335 */     // GIR_Coverage, 9351,
     /*  983335 */     GIR_EraseRootFromParent_Done,
     /*  983336 */   // Label 14699: @983336
     /*  983336 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(983431), // Rule ID 9354 //
     /*  983341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  983358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983391 */     // MIs[1] Operand 1
     /*  983391 */     // No operand predicates
     /*  983391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983404 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983429 */     GIR_RootConstrainSelectedInstOperands,
     /*  983430 */     // GIR_Coverage, 9354,
     /*  983430 */     GIR_EraseRootFromParent_Done,
     /*  983431 */   // Label 14700: @983431
     /*  983431 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(983526), // Rule ID 9355 //
     /*  983436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  983453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983486 */     // MIs[1] Operand 1
     /*  983486 */     // No operand predicates
     /*  983486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983524 */     GIR_RootConstrainSelectedInstOperands,
     /*  983525 */     // GIR_Coverage, 9355,
     /*  983525 */     GIR_EraseRootFromParent_Done,
     /*  983526 */   // Label 14701: @983526
     /*  983526 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(983621), // Rule ID 9358 //
     /*  983531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983581 */     // MIs[1] Operand 1
     /*  983581 */     // No operand predicates
     /*  983581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983619 */     GIR_RootConstrainSelectedInstOperands,
     /*  983620 */     // GIR_Coverage, 9358,
     /*  983620 */     GIR_EraseRootFromParent_Done,
     /*  983621 */   // Label 14702: @983621
     /*  983621 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(983716), // Rule ID 9359 //
     /*  983626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983676 */     // MIs[1] Operand 1
     /*  983676 */     // No operand predicates
     /*  983676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983689 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983714 */     GIR_RootConstrainSelectedInstOperands,
     /*  983715 */     // GIR_Coverage, 9359,
     /*  983715 */     GIR_EraseRootFromParent_Done,
     /*  983716 */   // Label 14703: @983716
     /*  983716 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(983811), // Rule ID 9362 //
     /*  983721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983771 */     // MIs[1] Operand 1
     /*  983771 */     // No operand predicates
     /*  983771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983784 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983809 */     GIR_RootConstrainSelectedInstOperands,
     /*  983810 */     // GIR_Coverage, 9362,
     /*  983810 */     GIR_EraseRootFromParent_Done,
     /*  983811 */   // Label 14704: @983811
     /*  983811 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(983906), // Rule ID 9363 //
     /*  983816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983866 */     // MIs[1] Operand 1
     /*  983866 */     // No operand predicates
     /*  983866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983879 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983904 */     GIR_RootConstrainSelectedInstOperands,
     /*  983905 */     // GIR_Coverage, 9363,
     /*  983905 */     GIR_EraseRootFromParent_Done,
     /*  983906 */   // Label 14705: @983906
     /*  983906 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(984001), // Rule ID 9366 //
     /*  983911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983961 */     // MIs[1] Operand 1
     /*  983961 */     // No operand predicates
     /*  983961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983974 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983999 */     GIR_RootConstrainSelectedInstOperands,
     /*  984000 */     // GIR_Coverage, 9366,
     /*  984000 */     GIR_EraseRootFromParent_Done,
     /*  984001 */   // Label 14706: @984001
     /*  984001 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(984096), // Rule ID 9367 //
     /*  984006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  984023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984056 */     // MIs[1] Operand 1
     /*  984056 */     // No operand predicates
     /*  984056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984069 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984094 */     GIR_RootConstrainSelectedInstOperands,
     /*  984095 */     // GIR_Coverage, 9367,
     /*  984095 */     GIR_EraseRootFromParent_Done,
     /*  984096 */   // Label 14707: @984096
     /*  984096 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(984191), // Rule ID 9370 //
     /*  984101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  984118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984151 */     // MIs[1] Operand 1
     /*  984151 */     // No operand predicates
     /*  984151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  984164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984189 */     GIR_RootConstrainSelectedInstOperands,
     /*  984190 */     // GIR_Coverage, 9370,
     /*  984190 */     GIR_EraseRootFromParent_Done,
     /*  984191 */   // Label 14708: @984191
     /*  984191 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(984286), // Rule ID 9371 //
     /*  984196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  984213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984246 */     // MIs[1] Operand 1
     /*  984246 */     // No operand predicates
     /*  984246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984284 */     GIR_RootConstrainSelectedInstOperands,
     /*  984285 */     // GIR_Coverage, 9371,
     /*  984285 */     GIR_EraseRootFromParent_Done,
     /*  984286 */   // Label 14709: @984286
     /*  984286 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(984381), // Rule ID 9374 //
     /*  984291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  984302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  984305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  984308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  984314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984341 */     // MIs[1] Operand 1
     /*  984341 */     // No operand predicates
     /*  984341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984354 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  984354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984379 */     GIR_RootConstrainSelectedInstOperands,
     /*  984380 */     // GIR_Coverage, 9374,
     /*  984380 */     GIR_EraseRootFromParent_Done,
     /*  984381 */   // Label 14710: @984381
     /*  984381 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(984476), // Rule ID 9375 //
     /*  984386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  984397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  984400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  984403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  984409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984436 */     // MIs[1] Operand 1
     /*  984436 */     // No operand predicates
     /*  984436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  984449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984474 */     GIR_RootConstrainSelectedInstOperands,
     /*  984475 */     // GIR_Coverage, 9375,
     /*  984475 */     GIR_EraseRootFromParent_Done,
     /*  984476 */   // Label 14711: @984476
     /*  984476 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(984571), // Rule ID 9378 //
     /*  984481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984531 */     // MIs[1] Operand 1
     /*  984531 */     // No operand predicates
     /*  984531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984569 */     GIR_RootConstrainSelectedInstOperands,
     /*  984570 */     // GIR_Coverage, 9378,
     /*  984570 */     GIR_EraseRootFromParent_Done,
     /*  984571 */   // Label 14712: @984571
     /*  984571 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(984666), // Rule ID 9379 //
     /*  984576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984626 */     // MIs[1] Operand 1
     /*  984626 */     // No operand predicates
     /*  984626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984639 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984664 */     GIR_RootConstrainSelectedInstOperands,
     /*  984665 */     // GIR_Coverage, 9379,
     /*  984665 */     GIR_EraseRootFromParent_Done,
     /*  984666 */   // Label 14713: @984666
     /*  984666 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(984761), // Rule ID 9382 //
     /*  984671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984721 */     // MIs[1] Operand 1
     /*  984721 */     // No operand predicates
     /*  984721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984759 */     GIR_RootConstrainSelectedInstOperands,
     /*  984760 */     // GIR_Coverage, 9382,
     /*  984760 */     GIR_EraseRootFromParent_Done,
     /*  984761 */   // Label 14714: @984761
     /*  984761 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(984856), // Rule ID 9383 //
     /*  984766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984816 */     // MIs[1] Operand 1
     /*  984816 */     // No operand predicates
     /*  984816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984829 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984854 */     GIR_RootConstrainSelectedInstOperands,
     /*  984855 */     // GIR_Coverage, 9383,
     /*  984855 */     GIR_EraseRootFromParent_Done,
     /*  984856 */   // Label 14715: @984856
     /*  984856 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(984951), // Rule ID 9386 //
     /*  984861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984911 */     // MIs[1] Operand 1
     /*  984911 */     // No operand predicates
     /*  984911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984924 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984949 */     GIR_RootConstrainSelectedInstOperands,
     /*  984950 */     // GIR_Coverage, 9386,
     /*  984950 */     GIR_EraseRootFromParent_Done,
     /*  984951 */   // Label 14716: @984951
     /*  984951 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(985046), // Rule ID 9387 //
     /*  984956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985006 */     // MIs[1] Operand 1
     /*  985006 */     // No operand predicates
     /*  985006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985019 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  985019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  985022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985044 */     GIR_RootConstrainSelectedInstOperands,
     /*  985045 */     // GIR_Coverage, 9387,
     /*  985045 */     GIR_EraseRootFromParent_Done,
     /*  985046 */   // Label 14717: @985046
     /*  985046 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(985141), // Rule ID 9478 //
     /*  985051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  985068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985101 */     // MIs[1] Operand 1
     /*  985101 */     // No operand predicates
     /*  985101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  985117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985139 */     GIR_RootConstrainSelectedInstOperands,
     /*  985140 */     // GIR_Coverage, 9478,
     /*  985140 */     GIR_EraseRootFromParent_Done,
     /*  985141 */   // Label 14718: @985141
     /*  985141 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(985236), // Rule ID 9479 //
     /*  985146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  985163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985196 */     // MIs[1] Operand 1
     /*  985196 */     // No operand predicates
     /*  985196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985209 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  985212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985234 */     GIR_RootConstrainSelectedInstOperands,
     /*  985235 */     // GIR_Coverage, 9479,
     /*  985235 */     GIR_EraseRootFromParent_Done,
     /*  985236 */   // Label 14719: @985236
     /*  985236 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(985331), // Rule ID 9482 //
     /*  985241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  985258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985291 */     // MIs[1] Operand 1
     /*  985291 */     // No operand predicates
     /*  985291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985329 */     GIR_RootConstrainSelectedInstOperands,
     /*  985330 */     // GIR_Coverage, 9482,
     /*  985330 */     GIR_EraseRootFromParent_Done,
     /*  985331 */   // Label 14720: @985331
     /*  985331 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(985426), // Rule ID 9483 //
     /*  985336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  985353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985386 */     // MIs[1] Operand 1
     /*  985386 */     // No operand predicates
     /*  985386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985424 */     GIR_RootConstrainSelectedInstOperands,
     /*  985425 */     // GIR_Coverage, 9483,
     /*  985425 */     GIR_EraseRootFromParent_Done,
     /*  985426 */   // Label 14721: @985426
     /*  985426 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(985521), // Rule ID 9486 //
     /*  985431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985481 */     // MIs[1] Operand 1
     /*  985481 */     // No operand predicates
     /*  985481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985519 */     GIR_RootConstrainSelectedInstOperands,
     /*  985520 */     // GIR_Coverage, 9486,
     /*  985520 */     GIR_EraseRootFromParent_Done,
     /*  985521 */   // Label 14722: @985521
     /*  985521 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(985616), // Rule ID 9487 //
     /*  985526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985576 */     // MIs[1] Operand 1
     /*  985576 */     // No operand predicates
     /*  985576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985589 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985614 */     GIR_RootConstrainSelectedInstOperands,
     /*  985615 */     // GIR_Coverage, 9487,
     /*  985615 */     GIR_EraseRootFromParent_Done,
     /*  985616 */   // Label 14723: @985616
     /*  985616 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(985711), // Rule ID 9490 //
     /*  985621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985671 */     // MIs[1] Operand 1
     /*  985671 */     // No operand predicates
     /*  985671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985684 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985709 */     GIR_RootConstrainSelectedInstOperands,
     /*  985710 */     // GIR_Coverage, 9490,
     /*  985710 */     GIR_EraseRootFromParent_Done,
     /*  985711 */   // Label 14724: @985711
     /*  985711 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(985806), // Rule ID 9491 //
     /*  985716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985766 */     // MIs[1] Operand 1
     /*  985766 */     // No operand predicates
     /*  985766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985779 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985804 */     GIR_RootConstrainSelectedInstOperands,
     /*  985805 */     // GIR_Coverage, 9491,
     /*  985805 */     GIR_EraseRootFromParent_Done,
     /*  985806 */   // Label 14725: @985806
     /*  985806 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(985901), // Rule ID 9494 //
     /*  985811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985861 */     // MIs[1] Operand 1
     /*  985861 */     // No operand predicates
     /*  985861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985899 */     GIR_RootConstrainSelectedInstOperands,
     /*  985900 */     // GIR_Coverage, 9494,
     /*  985900 */     GIR_EraseRootFromParent_Done,
     /*  985901 */   // Label 14726: @985901
     /*  985901 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(985996), // Rule ID 9495 //
     /*  985906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985956 */     // MIs[1] Operand 1
     /*  985956 */     // No operand predicates
     /*  985956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985969 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985994 */     GIR_RootConstrainSelectedInstOperands,
     /*  985995 */     // GIR_Coverage, 9495,
     /*  985995 */     GIR_EraseRootFromParent_Done,
     /*  985996 */   // Label 14727: @985996
     /*  985996 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(986091), // Rule ID 9498 //
     /*  986001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  986018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986051 */     // MIs[1] Operand 1
     /*  986051 */     // No operand predicates
     /*  986051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  986067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986089 */     GIR_RootConstrainSelectedInstOperands,
     /*  986090 */     // GIR_Coverage, 9498,
     /*  986090 */     GIR_EraseRootFromParent_Done,
     /*  986091 */   // Label 14728: @986091
     /*  986091 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(986186), // Rule ID 9499 //
     /*  986096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  986113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986146 */     // MIs[1] Operand 1
     /*  986146 */     // No operand predicates
     /*  986146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986159 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  986162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986184 */     GIR_RootConstrainSelectedInstOperands,
     /*  986185 */     // GIR_Coverage, 9499,
     /*  986185 */     GIR_EraseRootFromParent_Done,
     /*  986186 */   // Label 14729: @986186
     /*  986186 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(986281), // Rule ID 9502 //
     /*  986191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  986208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986241 */     // MIs[1] Operand 1
     /*  986241 */     // No operand predicates
     /*  986241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986279 */     GIR_RootConstrainSelectedInstOperands,
     /*  986280 */     // GIR_Coverage, 9502,
     /*  986280 */     GIR_EraseRootFromParent_Done,
     /*  986281 */   // Label 14730: @986281
     /*  986281 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(986376), // Rule ID 9503 //
     /*  986286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  986303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986336 */     // MIs[1] Operand 1
     /*  986336 */     // No operand predicates
     /*  986336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986349 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986374 */     GIR_RootConstrainSelectedInstOperands,
     /*  986375 */     // GIR_Coverage, 9503,
     /*  986375 */     GIR_EraseRootFromParent_Done,
     /*  986376 */   // Label 14731: @986376
     /*  986376 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(986471), // Rule ID 9506 //
     /*  986381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986431 */     // MIs[1] Operand 1
     /*  986431 */     // No operand predicates
     /*  986431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986469 */     GIR_RootConstrainSelectedInstOperands,
     /*  986470 */     // GIR_Coverage, 9506,
     /*  986470 */     GIR_EraseRootFromParent_Done,
     /*  986471 */   // Label 14732: @986471
     /*  986471 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(986566), // Rule ID 9507 //
     /*  986476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986526 */     // MIs[1] Operand 1
     /*  986526 */     // No operand predicates
     /*  986526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986539 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986564 */     GIR_RootConstrainSelectedInstOperands,
     /*  986565 */     // GIR_Coverage, 9507,
     /*  986565 */     GIR_EraseRootFromParent_Done,
     /*  986566 */   // Label 14733: @986566
     /*  986566 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(986661), // Rule ID 9510 //
     /*  986571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986621 */     // MIs[1] Operand 1
     /*  986621 */     // No operand predicates
     /*  986621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986659 */     GIR_RootConstrainSelectedInstOperands,
     /*  986660 */     // GIR_Coverage, 9510,
     /*  986660 */     GIR_EraseRootFromParent_Done,
     /*  986661 */   // Label 14734: @986661
     /*  986661 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(986756), // Rule ID 9511 //
     /*  986666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986716 */     // MIs[1] Operand 1
     /*  986716 */     // No operand predicates
     /*  986716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986729 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986754 */     GIR_RootConstrainSelectedInstOperands,
     /*  986755 */     // GIR_Coverage, 9511,
     /*  986755 */     GIR_EraseRootFromParent_Done,
     /*  986756 */   // Label 14735: @986756
     /*  986756 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(986851), // Rule ID 9514 //
     /*  986761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986811 */     // MIs[1] Operand 1
     /*  986811 */     // No operand predicates
     /*  986811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986849 */     GIR_RootConstrainSelectedInstOperands,
     /*  986850 */     // GIR_Coverage, 9514,
     /*  986850 */     GIR_EraseRootFromParent_Done,
     /*  986851 */   // Label 14736: @986851
     /*  986851 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(986946), // Rule ID 9515 //
     /*  986856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986906 */     // MIs[1] Operand 1
     /*  986906 */     // No operand predicates
     /*  986906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986919 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986944 */     GIR_RootConstrainSelectedInstOperands,
     /*  986945 */     // GIR_Coverage, 9515,
     /*  986945 */     GIR_EraseRootFromParent_Done,
     /*  986946 */   // Label 14737: @986946
     /*  986946 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(987041), // Rule ID 9518 //
     /*  986951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987001 */     // MIs[1] Operand 1
     /*  987001 */     // No operand predicates
     /*  987001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987014 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987039 */     GIR_RootConstrainSelectedInstOperands,
     /*  987040 */     // GIR_Coverage, 9518,
     /*  987040 */     GIR_EraseRootFromParent_Done,
     /*  987041 */   // Label 14738: @987041
     /*  987041 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(987136), // Rule ID 9519 //
     /*  987046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  987063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987096 */     // MIs[1] Operand 1
     /*  987096 */     // No operand predicates
     /*  987096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987134 */     GIR_RootConstrainSelectedInstOperands,
     /*  987135 */     // GIR_Coverage, 9519,
     /*  987135 */     GIR_EraseRootFromParent_Done,
     /*  987136 */   // Label 14739: @987136
     /*  987136 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(987231), // Rule ID 9522 //
     /*  987141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  987158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987191 */     // MIs[1] Operand 1
     /*  987191 */     // No operand predicates
     /*  987191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987204 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987229 */     GIR_RootConstrainSelectedInstOperands,
     /*  987230 */     // GIR_Coverage, 9522,
     /*  987230 */     GIR_EraseRootFromParent_Done,
     /*  987231 */   // Label 14740: @987231
     /*  987231 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(987326), // Rule ID 9523 //
     /*  987236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  987253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987286 */     // MIs[1] Operand 1
     /*  987286 */     // No operand predicates
     /*  987286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987299 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987324 */     GIR_RootConstrainSelectedInstOperands,
     /*  987325 */     // GIR_Coverage, 9523,
     /*  987325 */     GIR_EraseRootFromParent_Done,
     /*  987326 */   // Label 14741: @987326
     /*  987326 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(987421), // Rule ID 9526 //
     /*  987331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  987342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  987345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  987348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  987354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987381 */     // MIs[1] Operand 1
     /*  987381 */     // No operand predicates
     /*  987381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987394 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  987394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987419 */     GIR_RootConstrainSelectedInstOperands,
     /*  987420 */     // GIR_Coverage, 9526,
     /*  987420 */     GIR_EraseRootFromParent_Done,
     /*  987421 */   // Label 14742: @987421
     /*  987421 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(987516), // Rule ID 9527 //
     /*  987426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  987437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  987440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  987443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  987449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987476 */     // MIs[1] Operand 1
     /*  987476 */     // No operand predicates
     /*  987476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987489 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987514 */     GIR_RootConstrainSelectedInstOperands,
     /*  987515 */     // GIR_Coverage, 9527,
     /*  987515 */     GIR_EraseRootFromParent_Done,
     /*  987516 */   // Label 14743: @987516
     /*  987516 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(987611), // Rule ID 9530 //
     /*  987521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987571 */     // MIs[1] Operand 1
     /*  987571 */     // No operand predicates
     /*  987571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987609 */     GIR_RootConstrainSelectedInstOperands,
     /*  987610 */     // GIR_Coverage, 9530,
     /*  987610 */     GIR_EraseRootFromParent_Done,
     /*  987611 */   // Label 14744: @987611
     /*  987611 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(987706), // Rule ID 9531 //
     /*  987616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987666 */     // MIs[1] Operand 1
     /*  987666 */     // No operand predicates
     /*  987666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987679 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987704 */     GIR_RootConstrainSelectedInstOperands,
     /*  987705 */     // GIR_Coverage, 9531,
     /*  987705 */     GIR_EraseRootFromParent_Done,
     /*  987706 */   // Label 14745: @987706
     /*  987706 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(987801), // Rule ID 9534 //
     /*  987711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987761 */     // MIs[1] Operand 1
     /*  987761 */     // No operand predicates
     /*  987761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987799 */     GIR_RootConstrainSelectedInstOperands,
     /*  987800 */     // GIR_Coverage, 9534,
     /*  987800 */     GIR_EraseRootFromParent_Done,
     /*  987801 */   // Label 14746: @987801
     /*  987801 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(987896), // Rule ID 9535 //
     /*  987806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987856 */     // MIs[1] Operand 1
     /*  987856 */     // No operand predicates
     /*  987856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987894 */     GIR_RootConstrainSelectedInstOperands,
     /*  987895 */     // GIR_Coverage, 9535,
     /*  987895 */     GIR_EraseRootFromParent_Done,
     /*  987896 */   // Label 14747: @987896
     /*  987896 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(987991), // Rule ID 9538 //
     /*  987901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987951 */     // MIs[1] Operand 1
     /*  987951 */     // No operand predicates
     /*  987951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987964 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987989 */     GIR_RootConstrainSelectedInstOperands,
     /*  987990 */     // GIR_Coverage, 9538,
     /*  987990 */     GIR_EraseRootFromParent_Done,
     /*  987991 */   // Label 14748: @987991
     /*  987991 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(988086), // Rule ID 9539 //
     /*  987996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  988007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  988010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  988013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  988019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988046 */     // MIs[1] Operand 1
     /*  988046 */     // No operand predicates
     /*  988046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988059 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  988059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988084 */     GIR_RootConstrainSelectedInstOperands,
     /*  988085 */     // GIR_Coverage, 9539,
     /*  988085 */     GIR_EraseRootFromParent_Done,
     /*  988086 */   // Label 14749: @988086
     /*  988086 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(988181), // Rule ID 9542 //
     /*  988091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988141 */     // MIs[1] Operand 1
     /*  988141 */     // No operand predicates
     /*  988141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988179 */     GIR_RootConstrainSelectedInstOperands,
     /*  988180 */     // GIR_Coverage, 9542,
     /*  988180 */     GIR_EraseRootFromParent_Done,
     /*  988181 */   // Label 14750: @988181
     /*  988181 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(988276), // Rule ID 9543 //
     /*  988186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  988203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988236 */     // MIs[1] Operand 1
     /*  988236 */     // No operand predicates
     /*  988236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988249 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988274 */     GIR_RootConstrainSelectedInstOperands,
     /*  988275 */     // GIR_Coverage, 9543,
     /*  988275 */     GIR_EraseRootFromParent_Done,
     /*  988276 */   // Label 14751: @988276
     /*  988276 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(988371), // Rule ID 9546 //
     /*  988281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988331 */     // MIs[1] Operand 1
     /*  988331 */     // No operand predicates
     /*  988331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988369 */     GIR_RootConstrainSelectedInstOperands,
     /*  988370 */     // GIR_Coverage, 9546,
     /*  988370 */     GIR_EraseRootFromParent_Done,
     /*  988371 */   // Label 14752: @988371
     /*  988371 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(988466), // Rule ID 9547 //
     /*  988376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  988393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988426 */     // MIs[1] Operand 1
     /*  988426 */     // No operand predicates
     /*  988426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988464 */     GIR_RootConstrainSelectedInstOperands,
     /*  988465 */     // GIR_Coverage, 9547,
     /*  988465 */     GIR_EraseRootFromParent_Done,
     /*  988466 */   // Label 14753: @988466
     /*  988466 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(988561), // Rule ID 9550 //
     /*  988471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988521 */     // MIs[1] Operand 1
     /*  988521 */     // No operand predicates
     /*  988521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988534 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988559 */     GIR_RootConstrainSelectedInstOperands,
     /*  988560 */     // GIR_Coverage, 9550,
     /*  988560 */     GIR_EraseRootFromParent_Done,
     /*  988561 */   // Label 14754: @988561
     /*  988561 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(988656), // Rule ID 9551 //
     /*  988566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988616 */     // MIs[1] Operand 1
     /*  988616 */     // No operand predicates
     /*  988616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988629 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988654 */     GIR_RootConstrainSelectedInstOperands,
     /*  988655 */     // GIR_Coverage, 9551,
     /*  988655 */     GIR_EraseRootFromParent_Done,
     /*  988656 */   // Label 14755: @988656
     /*  988656 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(988751), // Rule ID 9554 //
     /*  988661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988711 */     // MIs[1] Operand 1
     /*  988711 */     // No operand predicates
     /*  988711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988749 */     GIR_RootConstrainSelectedInstOperands,
     /*  988750 */     // GIR_Coverage, 9554,
     /*  988750 */     GIR_EraseRootFromParent_Done,
     /*  988751 */   // Label 14756: @988751
     /*  988751 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(988846), // Rule ID 9555 //
     /*  988756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988806 */     // MIs[1] Operand 1
     /*  988806 */     // No operand predicates
     /*  988806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988844 */     GIR_RootConstrainSelectedInstOperands,
     /*  988845 */     // GIR_Coverage, 9555,
     /*  988845 */     GIR_EraseRootFromParent_Done,
     /*  988846 */   // Label 14757: @988846
     /*  988846 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(988941), // Rule ID 9558 //
     /*  988851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988901 */     // MIs[1] Operand 1
     /*  988901 */     // No operand predicates
     /*  988901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988939 */     GIR_RootConstrainSelectedInstOperands,
     /*  988940 */     // GIR_Coverage, 9558,
     /*  988940 */     GIR_EraseRootFromParent_Done,
     /*  988941 */   // Label 14758: @988941
     /*  988941 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(989036), // Rule ID 9559 //
     /*  988946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988996 */     // MIs[1] Operand 1
     /*  988996 */     // No operand predicates
     /*  988996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989009 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  989009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  989012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989034 */     GIR_RootConstrainSelectedInstOperands,
     /*  989035 */     // GIR_Coverage, 9559,
     /*  989035 */     GIR_EraseRootFromParent_Done,
     /*  989036 */   // Label 14759: @989036
     /*  989036 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(989131), // Rule ID 9562 //
     /*  989041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  989044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989091 */     // MIs[1] Operand 1
     /*  989091 */     // No operand predicates
     /*  989091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  989104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  989107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989129 */     GIR_RootConstrainSelectedInstOperands,
     /*  989130 */     // GIR_Coverage, 9562,
     /*  989130 */     GIR_EraseRootFromParent_Done,
     /*  989131 */   // Label 14760: @989131
     /*  989131 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(989226), // Rule ID 9563 //
     /*  989136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  989139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  989153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  989174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989186 */     // MIs[1] Operand 1
     /*  989186 */     // No operand predicates
     /*  989186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989199 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  989199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  989202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989224 */     GIR_RootConstrainSelectedInstOperands,
     /*  989225 */     // GIR_Coverage, 9563,
     /*  989225 */     GIR_EraseRootFromParent_Done,
     /*  989226 */   // Label 14761: @989226
     /*  989226 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(989318), // Rule ID 13940 //
     /*  989231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  989242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  989245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  989248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989281 */     // MIs[1] Operand 1
     /*  989281 */     // No operand predicates
     /*  989281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  989297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989316 */     GIR_RootConstrainSelectedInstOperands,
     /*  989317 */     // GIR_Coverage, 13940,
     /*  989317 */     GIR_EraseRootFromParent_Done,
     /*  989318 */   // Label 14762: @989318
     /*  989318 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(989410), // Rule ID 13941 //
     /*  989323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  989334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  989337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  989340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989373 */     // MIs[1] Operand 1
     /*  989373 */     // No operand predicates
     /*  989373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  989389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989408 */     GIR_RootConstrainSelectedInstOperands,
     /*  989409 */     // GIR_Coverage, 13941,
     /*  989409 */     GIR_EraseRootFromParent_Done,
     /*  989410 */   // Label 14763: @989410
     /*  989410 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(989502), // Rule ID 13942 //
     /*  989415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989465 */     // MIs[1] Operand 1
     /*  989465 */     // No operand predicates
     /*  989465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989500 */     GIR_RootConstrainSelectedInstOperands,
     /*  989501 */     // GIR_Coverage, 13942,
     /*  989501 */     GIR_EraseRootFromParent_Done,
     /*  989502 */   // Label 14764: @989502
     /*  989502 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(989594), // Rule ID 13943 //
     /*  989507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989557 */     // MIs[1] Operand 1
     /*  989557 */     // No operand predicates
     /*  989557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989592 */     GIR_RootConstrainSelectedInstOperands,
     /*  989593 */     // GIR_Coverage, 13943,
     /*  989593 */     GIR_EraseRootFromParent_Done,
     /*  989594 */   // Label 14765: @989594
     /*  989594 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(989686), // Rule ID 13944 //
     /*  989599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989649 */     // MIs[1] Operand 1
     /*  989649 */     // No operand predicates
     /*  989649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989662 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989684 */     GIR_RootConstrainSelectedInstOperands,
     /*  989685 */     // GIR_Coverage, 13944,
     /*  989685 */     GIR_EraseRootFromParent_Done,
     /*  989686 */   // Label 14766: @989686
     /*  989686 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(989778), // Rule ID 13945 //
     /*  989691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989741 */     // MIs[1] Operand 1
     /*  989741 */     // No operand predicates
     /*  989741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989776 */     GIR_RootConstrainSelectedInstOperands,
     /*  989777 */     // GIR_Coverage, 13945,
     /*  989777 */     GIR_EraseRootFromParent_Done,
     /*  989778 */   // Label 14767: @989778
     /*  989778 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(989870), // Rule ID 13946 //
     /*  989783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989833 */     // MIs[1] Operand 1
     /*  989833 */     // No operand predicates
     /*  989833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989868 */     GIR_RootConstrainSelectedInstOperands,
     /*  989869 */     // GIR_Coverage, 13946,
     /*  989869 */     GIR_EraseRootFromParent_Done,
     /*  989870 */   // Label 14768: @989870
     /*  989870 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(989962), // Rule ID 13947 //
     /*  989875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989925 */     // MIs[1] Operand 1
     /*  989925 */     // No operand predicates
     /*  989925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989960 */     GIR_RootConstrainSelectedInstOperands,
     /*  989961 */     // GIR_Coverage, 13947,
     /*  989961 */     GIR_EraseRootFromParent_Done,
     /*  989962 */   // Label 14769: @989962
     /*  989962 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(990054), // Rule ID 13948 //
     /*  989967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990017 */     // MIs[1] Operand 1
     /*  990017 */     // No operand predicates
     /*  990017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990052 */     GIR_RootConstrainSelectedInstOperands,
     /*  990053 */     // GIR_Coverage, 13948,
     /*  990053 */     GIR_EraseRootFromParent_Done,
     /*  990054 */   // Label 14770: @990054
     /*  990054 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(990146), // Rule ID 13949 //
     /*  990059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  990070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  990073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  990076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990109 */     // MIs[1] Operand 1
     /*  990109 */     // No operand predicates
     /*  990109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990122 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990144 */     GIR_RootConstrainSelectedInstOperands,
     /*  990145 */     // GIR_Coverage, 13949,
     /*  990145 */     GIR_EraseRootFromParent_Done,
     /*  990146 */   // Label 14771: @990146
     /*  990146 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(990238), // Rule ID 13950 //
     /*  990151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  990162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  990165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  990168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990201 */     // MIs[1] Operand 1
     /*  990201 */     // No operand predicates
     /*  990201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990236 */     GIR_RootConstrainSelectedInstOperands,
     /*  990237 */     // GIR_Coverage, 13950,
     /*  990237 */     GIR_EraseRootFromParent_Done,
     /*  990238 */   // Label 14772: @990238
     /*  990238 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(990330), // Rule ID 13951 //
     /*  990243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  990254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  990257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  990260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990293 */     // MIs[1] Operand 1
     /*  990293 */     // No operand predicates
     /*  990293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  990309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990328 */     GIR_RootConstrainSelectedInstOperands,
     /*  990329 */     // GIR_Coverage, 13951,
     /*  990329 */     GIR_EraseRootFromParent_Done,
     /*  990330 */   // Label 14773: @990330
     /*  990330 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(990422), // Rule ID 13952 //
     /*  990335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  990346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  990349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  990352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990385 */     // MIs[1] Operand 1
     /*  990385 */     // No operand predicates
     /*  990385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990420 */     GIR_RootConstrainSelectedInstOperands,
     /*  990421 */     // GIR_Coverage, 13952,
     /*  990421 */     GIR_EraseRootFromParent_Done,
     /*  990422 */   // Label 14774: @990422
     /*  990422 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(990514), // Rule ID 13953 //
     /*  990427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  990438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  990441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  990444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990477 */     // MIs[1] Operand 1
     /*  990477 */     // No operand predicates
     /*  990477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990512 */     GIR_RootConstrainSelectedInstOperands,
     /*  990513 */     // GIR_Coverage, 13953,
     /*  990513 */     GIR_EraseRootFromParent_Done,
     /*  990514 */   // Label 14775: @990514
     /*  990514 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(990606), // Rule ID 13954 //
     /*  990519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990569 */     // MIs[1] Operand 1
     /*  990569 */     // No operand predicates
     /*  990569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990604 */     GIR_RootConstrainSelectedInstOperands,
     /*  990605 */     // GIR_Coverage, 13954,
     /*  990605 */     GIR_EraseRootFromParent_Done,
     /*  990606 */   // Label 14776: @990606
     /*  990606 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(990698), // Rule ID 13955 //
     /*  990611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990661 */     // MIs[1] Operand 1
     /*  990661 */     // No operand predicates
     /*  990661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990696 */     GIR_RootConstrainSelectedInstOperands,
     /*  990697 */     // GIR_Coverage, 13955,
     /*  990697 */     GIR_EraseRootFromParent_Done,
     /*  990698 */   // Label 14777: @990698
     /*  990698 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(990790), // Rule ID 13956 //
     /*  990703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990753 */     // MIs[1] Operand 1
     /*  990753 */     // No operand predicates
     /*  990753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990788 */     GIR_RootConstrainSelectedInstOperands,
     /*  990789 */     // GIR_Coverage, 13956,
     /*  990789 */     GIR_EraseRootFromParent_Done,
     /*  990790 */   // Label 14778: @990790
     /*  990790 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(990882), // Rule ID 13957 //
     /*  990795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990845 */     // MIs[1] Operand 1
     /*  990845 */     // No operand predicates
     /*  990845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990880 */     GIR_RootConstrainSelectedInstOperands,
     /*  990881 */     // GIR_Coverage, 13957,
     /*  990881 */     GIR_EraseRootFromParent_Done,
     /*  990882 */   // Label 14779: @990882
     /*  990882 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(990974), // Rule ID 13958 //
     /*  990887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990937 */     // MIs[1] Operand 1
     /*  990937 */     // No operand predicates
     /*  990937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  990950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990972 */     GIR_RootConstrainSelectedInstOperands,
     /*  990973 */     // GIR_Coverage, 13958,
     /*  990973 */     GIR_EraseRootFromParent_Done,
     /*  990974 */   // Label 14780: @990974
     /*  990974 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(991066), // Rule ID 13959 //
     /*  990979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  991002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  991009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991029 */     // MIs[1] Operand 1
     /*  991029 */     // No operand predicates
     /*  991029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  991042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  991045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991064 */     GIR_RootConstrainSelectedInstOperands,
     /*  991065 */     // GIR_Coverage, 13959,
     /*  991065 */     GIR_EraseRootFromParent_Done,
     /*  991066 */   // Label 14781: @991066
     /*  991066 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(991158), // Rule ID 13960 //
     /*  991071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  991082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  991085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  991088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991121 */     // MIs[1] Operand 1
     /*  991121 */     // No operand predicates
     /*  991121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991156 */     GIR_RootConstrainSelectedInstOperands,
     /*  991157 */     // GIR_Coverage, 13960,
     /*  991157 */     GIR_EraseRootFromParent_Done,
     /*  991158 */   // Label 14782: @991158
     /*  991158 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(991250), // Rule ID 13961 //
     /*  991163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  991174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  991177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  991180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991213 */     // MIs[1] Operand 1
     /*  991213 */     // No operand predicates
     /*  991213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991248 */     GIR_RootConstrainSelectedInstOperands,
     /*  991249 */     // GIR_Coverage, 13961,
     /*  991249 */     GIR_EraseRootFromParent_Done,
     /*  991250 */   // Label 14783: @991250
     /*  991250 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(991342), // Rule ID 13962 //
     /*  991255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  991266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  991269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  991272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991305 */     // MIs[1] Operand 1
     /*  991305 */     // No operand predicates
     /*  991305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991340 */     GIR_RootConstrainSelectedInstOperands,
     /*  991341 */     // GIR_Coverage, 13962,
     /*  991341 */     GIR_EraseRootFromParent_Done,
     /*  991342 */   // Label 14784: @991342
     /*  991342 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(991434), // Rule ID 13963 //
     /*  991347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  991358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  991361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  991364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991397 */     // MIs[1] Operand 1
     /*  991397 */     // No operand predicates
     /*  991397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991432 */     GIR_RootConstrainSelectedInstOperands,
     /*  991433 */     // GIR_Coverage, 13963,
     /*  991433 */     GIR_EraseRootFromParent_Done,
     /*  991434 */   // Label 14785: @991434
     /*  991434 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(991526), // Rule ID 13964 //
     /*  991439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991489 */     // MIs[1] Operand 1
     /*  991489 */     // No operand predicates
     /*  991489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991502 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991524 */     GIR_RootConstrainSelectedInstOperands,
     /*  991525 */     // GIR_Coverage, 13964,
     /*  991525 */     GIR_EraseRootFromParent_Done,
     /*  991526 */   // Label 14786: @991526
     /*  991526 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(991618), // Rule ID 13965 //
     /*  991531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991581 */     // MIs[1] Operand 1
     /*  991581 */     // No operand predicates
     /*  991581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991594 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991616 */     GIR_RootConstrainSelectedInstOperands,
     /*  991617 */     // GIR_Coverage, 13965,
     /*  991617 */     GIR_EraseRootFromParent_Done,
     /*  991618 */   // Label 14787: @991618
     /*  991618 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(991710), // Rule ID 13966 //
     /*  991623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991673 */     // MIs[1] Operand 1
     /*  991673 */     // No operand predicates
     /*  991673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991708 */     GIR_RootConstrainSelectedInstOperands,
     /*  991709 */     // GIR_Coverage, 13966,
     /*  991709 */     GIR_EraseRootFromParent_Done,
     /*  991710 */   // Label 14788: @991710
     /*  991710 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(991802), // Rule ID 13967 //
     /*  991715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991765 */     // MIs[1] Operand 1
     /*  991765 */     // No operand predicates
     /*  991765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991800 */     GIR_RootConstrainSelectedInstOperands,
     /*  991801 */     // GIR_Coverage, 13967,
     /*  991801 */     GIR_EraseRootFromParent_Done,
     /*  991802 */   // Label 14789: @991802
     /*  991802 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(991894), // Rule ID 13968 //
     /*  991807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991857 */     // MIs[1] Operand 1
     /*  991857 */     // No operand predicates
     /*  991857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991892 */     GIR_RootConstrainSelectedInstOperands,
     /*  991893 */     // GIR_Coverage, 13968,
     /*  991893 */     GIR_EraseRootFromParent_Done,
     /*  991894 */   // Label 14790: @991894
     /*  991894 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(991986), // Rule ID 13969 //
     /*  991899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991949 */     // MIs[1] Operand 1
     /*  991949 */     // No operand predicates
     /*  991949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991962 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991984 */     GIR_RootConstrainSelectedInstOperands,
     /*  991985 */     // GIR_Coverage, 13969,
     /*  991985 */     GIR_EraseRootFromParent_Done,
     /*  991986 */   // Label 14791: @991986
     /*  991986 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(992078), // Rule ID 13970 //
     /*  991991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  992002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  992005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  992008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  992014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992041 */     // MIs[1] Operand 1
     /*  992041 */     // No operand predicates
     /*  992041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992054 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  992054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992076 */     GIR_RootConstrainSelectedInstOperands,
     /*  992077 */     // GIR_Coverage, 13970,
     /*  992077 */     GIR_EraseRootFromParent_Done,
     /*  992078 */   // Label 14792: @992078
     /*  992078 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(992170), // Rule ID 13971 //
     /*  992083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  992094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  992097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  992100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  992106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992133 */     // MIs[1] Operand 1
     /*  992133 */     // No operand predicates
     /*  992133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  992146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992168 */     GIR_RootConstrainSelectedInstOperands,
     /*  992169 */     // GIR_Coverage, 13971,
     /*  992169 */     GIR_EraseRootFromParent_Done,
     /*  992170 */   // Label 14793: @992170
     /*  992170 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(992262), // Rule ID 13972 //
     /*  992175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  992192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992225 */     // MIs[1] Operand 1
     /*  992225 */     // No operand predicates
     /*  992225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992260 */     GIR_RootConstrainSelectedInstOperands,
     /*  992261 */     // GIR_Coverage, 13972,
     /*  992261 */     GIR_EraseRootFromParent_Done,
     /*  992262 */   // Label 14794: @992262
     /*  992262 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(992354), // Rule ID 13973 //
     /*  992267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  992284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992317 */     // MIs[1] Operand 1
     /*  992317 */     // No operand predicates
     /*  992317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992352 */     GIR_RootConstrainSelectedInstOperands,
     /*  992353 */     // GIR_Coverage, 13973,
     /*  992353 */     GIR_EraseRootFromParent_Done,
     /*  992354 */   // Label 14795: @992354
     /*  992354 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(992446), // Rule ID 13974 //
     /*  992359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992409 */     // MIs[1] Operand 1
     /*  992409 */     // No operand predicates
     /*  992409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992444 */     GIR_RootConstrainSelectedInstOperands,
     /*  992445 */     // GIR_Coverage, 13974,
     /*  992445 */     GIR_EraseRootFromParent_Done,
     /*  992446 */   // Label 14796: @992446
     /*  992446 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(992538), // Rule ID 13975 //
     /*  992451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992501 */     // MIs[1] Operand 1
     /*  992501 */     // No operand predicates
     /*  992501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992536 */     GIR_RootConstrainSelectedInstOperands,
     /*  992537 */     // GIR_Coverage, 13975,
     /*  992537 */     GIR_EraseRootFromParent_Done,
     /*  992538 */   // Label 14797: @992538
     /*  992538 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(992630), // Rule ID 13976 //
     /*  992543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992593 */     // MIs[1] Operand 1
     /*  992593 */     // No operand predicates
     /*  992593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992628 */     GIR_RootConstrainSelectedInstOperands,
     /*  992629 */     // GIR_Coverage, 13976,
     /*  992629 */     GIR_EraseRootFromParent_Done,
     /*  992630 */   // Label 14798: @992630
     /*  992630 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(992722), // Rule ID 13977 //
     /*  992635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992685 */     // MIs[1] Operand 1
     /*  992685 */     // No operand predicates
     /*  992685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992720 */     GIR_RootConstrainSelectedInstOperands,
     /*  992721 */     // GIR_Coverage, 13977,
     /*  992721 */     GIR_EraseRootFromParent_Done,
     /*  992722 */   // Label 14799: @992722
     /*  992722 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(992814), // Rule ID 13978 //
     /*  992727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992777 */     // MIs[1] Operand 1
     /*  992777 */     // No operand predicates
     /*  992777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992812 */     GIR_RootConstrainSelectedInstOperands,
     /*  992813 */     // GIR_Coverage, 13978,
     /*  992813 */     GIR_EraseRootFromParent_Done,
     /*  992814 */   // Label 14800: @992814
     /*  992814 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(992906), // Rule ID 13979 //
     /*  992819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992869 */     // MIs[1] Operand 1
     /*  992869 */     // No operand predicates
     /*  992869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992904 */     GIR_RootConstrainSelectedInstOperands,
     /*  992905 */     // GIR_Coverage, 13979,
     /*  992905 */     GIR_EraseRootFromParent_Done,
     /*  992906 */   // Label 14801: @992906
     /*  992906 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(992998), // Rule ID 13980 //
     /*  992911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992961 */     // MIs[1] Operand 1
     /*  992961 */     // No operand predicates
     /*  992961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992996 */     GIR_RootConstrainSelectedInstOperands,
     /*  992997 */     // GIR_Coverage, 13980,
     /*  992997 */     GIR_EraseRootFromParent_Done,
     /*  992998 */   // Label 14802: @992998
     /*  992998 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(993090), // Rule ID 13981 //
     /*  993003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  993006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  993020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  993033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993053 */     // MIs[1] Operand 1
     /*  993053 */     // No operand predicates
     /*  993053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  993066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  993069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993088 */     GIR_RootConstrainSelectedInstOperands,
     /*  993089 */     // GIR_Coverage, 13981,
     /*  993089 */     GIR_EraseRootFromParent_Done,
     /*  993090 */   // Label 14803: @993090
     /*  993090 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(993182), // Rule ID 13982 //
     /*  993095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  993098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  993112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993145 */     // MIs[1] Operand 1
     /*  993145 */     // No operand predicates
     /*  993145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  993158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  993161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993180 */     GIR_RootConstrainSelectedInstOperands,
     /*  993181 */     // GIR_Coverage, 13982,
     /*  993181 */     GIR_EraseRootFromParent_Done,
     /*  993182 */   // Label 14804: @993182
     /*  993182 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(993274), // Rule ID 13983 //
     /*  993187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  993190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  993204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  993217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993237 */     // MIs[1] Operand 1
     /*  993237 */     // No operand predicates
     /*  993237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  993250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  993253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  993272 */     GIR_RootConstrainSelectedInstOperands,
     /*  993273 */     // GIR_Coverage, 13983,
     /*  993273 */     GIR_EraseRootFromParent_Done,
     /*  993274 */   // Label 14805: @993274
     /*  993274 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(993350), // Rule ID 2770 //
     /*  993279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993307 */     // MIs[0] passthru
     /*  993307 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993316 */     // MIs[0] round
     /*  993316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  993329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993348 */     GIR_RootConstrainSelectedInstOperands,
     /*  993349 */     // GIR_Coverage, 2770,
     /*  993349 */     GIR_EraseRootFromParent_Done,
     /*  993350 */   // Label 14806: @993350
     /*  993350 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(993426), // Rule ID 2771 //
     /*  993355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993383 */     // MIs[0] passthru
     /*  993383 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993392 */     // MIs[0] round
     /*  993392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993402 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  993405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993424 */     GIR_RootConstrainSelectedInstOperands,
     /*  993425 */     // GIR_Coverage, 2771,
     /*  993425 */     GIR_EraseRootFromParent_Done,
     /*  993426 */   // Label 14807: @993426
     /*  993426 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(993502), // Rule ID 17150 //
     /*  993431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993459 */     // MIs[0] passthru
     /*  993459 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993468 */     // MIs[0] round
     /*  993468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993478 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993500 */     GIR_RootConstrainSelectedInstOperands,
     /*  993501 */     // GIR_Coverage, 17150,
     /*  993501 */     GIR_EraseRootFromParent_Done,
     /*  993502 */   // Label 14808: @993502
     /*  993502 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(993578), // Rule ID 17151 //
     /*  993507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993535 */     // MIs[0] passthru
     /*  993535 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993544 */     // MIs[0] round
     /*  993544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993576 */     GIR_RootConstrainSelectedInstOperands,
     /*  993577 */     // GIR_Coverage, 17151,
     /*  993577 */     GIR_EraseRootFromParent_Done,
     /*  993578 */   // Label 14809: @993578
     /*  993578 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(993654), // Rule ID 17160 //
     /*  993583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993611 */     // MIs[0] passthru
     /*  993611 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993620 */     // MIs[0] round
     /*  993620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993652 */     GIR_RootConstrainSelectedInstOperands,
     /*  993653 */     // GIR_Coverage, 17160,
     /*  993653 */     GIR_EraseRootFromParent_Done,
     /*  993654 */   // Label 14810: @993654
     /*  993654 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(993730), // Rule ID 17161 //
     /*  993659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993687 */     // MIs[0] passthru
     /*  993687 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993696 */     // MIs[0] round
     /*  993696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993728 */     GIR_RootConstrainSelectedInstOperands,
     /*  993729 */     // GIR_Coverage, 17161,
     /*  993729 */     GIR_EraseRootFromParent_Done,
     /*  993730 */   // Label 14811: @993730
     /*  993730 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(993806), // Rule ID 17170 //
     /*  993735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993763 */     // MIs[0] passthru
     /*  993763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993772 */     // MIs[0] round
     /*  993772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993782 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993804 */     GIR_RootConstrainSelectedInstOperands,
     /*  993805 */     // GIR_Coverage, 17170,
     /*  993805 */     GIR_EraseRootFromParent_Done,
     /*  993806 */   // Label 14812: @993806
     /*  993806 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(993882), // Rule ID 17171 //
     /*  993811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993839 */     // MIs[0] passthru
     /*  993839 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993848 */     // MIs[0] round
     /*  993848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993858 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993880 */     GIR_RootConstrainSelectedInstOperands,
     /*  993881 */     // GIR_Coverage, 17171,
     /*  993881 */     GIR_EraseRootFromParent_Done,
     /*  993882 */   // Label 14813: @993882
     /*  993882 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(993958), // Rule ID 17180 //
     /*  993887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993915 */     // MIs[0] passthru
     /*  993915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993924 */     // MIs[0] round
     /*  993924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993956 */     GIR_RootConstrainSelectedInstOperands,
     /*  993957 */     // GIR_Coverage, 17180,
     /*  993957 */     GIR_EraseRootFromParent_Done,
     /*  993958 */   // Label 14814: @993958
     /*  993958 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(994034), // Rule ID 17181 //
     /*  993963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993991 */     // MIs[0] passthru
     /*  993991 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994000 */     // MIs[0] round
     /*  994000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994010 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  994013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994032 */     GIR_RootConstrainSelectedInstOperands,
     /*  994033 */     // GIR_Coverage, 17181,
     /*  994033 */     GIR_EraseRootFromParent_Done,
     /*  994034 */   // Label 14815: @994034
     /*  994034 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(994110), // Rule ID 17190 //
     /*  994039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994067 */     // MIs[0] passthru
     /*  994067 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994076 */     // MIs[0] round
     /*  994076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  994089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994108 */     GIR_RootConstrainSelectedInstOperands,
     /*  994109 */     // GIR_Coverage, 17190,
     /*  994109 */     GIR_EraseRootFromParent_Done,
     /*  994110 */   // Label 14816: @994110
     /*  994110 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(994186), // Rule ID 17191 //
     /*  994115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994143 */     // MIs[0] passthru
     /*  994143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994152 */     // MIs[0] round
     /*  994152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994162 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  994165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994184 */     GIR_RootConstrainSelectedInstOperands,
     /*  994185 */     // GIR_Coverage, 17191,
     /*  994185 */     GIR_EraseRootFromParent_Done,
     /*  994186 */   // Label 14817: @994186
     /*  994186 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(994262), // Rule ID 17200 //
     /*  994191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994219 */     // MIs[0] passthru
     /*  994219 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994228 */     // MIs[0] round
     /*  994228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  994241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994260 */     GIR_RootConstrainSelectedInstOperands,
     /*  994261 */     // GIR_Coverage, 17200,
     /*  994261 */     GIR_EraseRootFromParent_Done,
     /*  994262 */   // Label 14818: @994262
     /*  994262 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(994338), // Rule ID 17201 //
     /*  994267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994295 */     // MIs[0] passthru
     /*  994295 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994304 */     // MIs[0] round
     /*  994304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  994317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994336 */     GIR_RootConstrainSelectedInstOperands,
     /*  994337 */     // GIR_Coverage, 17201,
     /*  994337 */     GIR_EraseRootFromParent_Done,
     /*  994338 */   // Label 14819: @994338
     /*  994338 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(994414), // Rule ID 17210 //
     /*  994343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994371 */     // MIs[0] passthru
     /*  994371 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994380 */     // MIs[0] round
     /*  994380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994390 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994412 */     GIR_RootConstrainSelectedInstOperands,
     /*  994413 */     // GIR_Coverage, 17210,
     /*  994413 */     GIR_EraseRootFromParent_Done,
     /*  994414 */   // Label 14820: @994414
     /*  994414 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(994490), // Rule ID 17211 //
     /*  994419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994447 */     // MIs[0] passthru
     /*  994447 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994456 */     // MIs[0] round
     /*  994456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994466 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994488 */     GIR_RootConstrainSelectedInstOperands,
     /*  994489 */     // GIR_Coverage, 17211,
     /*  994489 */     GIR_EraseRootFromParent_Done,
     /*  994490 */   // Label 14821: @994490
     /*  994490 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(994566), // Rule ID 17220 //
     /*  994495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994523 */     // MIs[0] passthru
     /*  994523 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994532 */     // MIs[0] round
     /*  994532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994542 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994564 */     GIR_RootConstrainSelectedInstOperands,
     /*  994565 */     // GIR_Coverage, 17220,
     /*  994565 */     GIR_EraseRootFromParent_Done,
     /*  994566 */   // Label 14822: @994566
     /*  994566 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(994642), // Rule ID 17221 //
     /*  994571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994599 */     // MIs[0] passthru
     /*  994599 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994608 */     // MIs[0] round
     /*  994608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994618 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994640 */     GIR_RootConstrainSelectedInstOperands,
     /*  994641 */     // GIR_Coverage, 17221,
     /*  994641 */     GIR_EraseRootFromParent_Done,
     /*  994642 */   // Label 14823: @994642
     /*  994642 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(994718), // Rule ID 17266 //
     /*  994647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994675 */     // MIs[0] passthru
     /*  994675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994684 */     // MIs[0] round
     /*  994684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994716 */     GIR_RootConstrainSelectedInstOperands,
     /*  994717 */     // GIR_Coverage, 17266,
     /*  994717 */     GIR_EraseRootFromParent_Done,
     /*  994718 */   // Label 14824: @994718
     /*  994718 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(994794), // Rule ID 17267 //
     /*  994723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994751 */     // MIs[0] passthru
     /*  994751 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994760 */     // MIs[0] round
     /*  994760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994770 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994792 */     GIR_RootConstrainSelectedInstOperands,
     /*  994793 */     // GIR_Coverage, 17267,
     /*  994793 */     GIR_EraseRootFromParent_Done,
     /*  994794 */   // Label 14825: @994794
     /*  994794 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(994870), // Rule ID 17276 //
     /*  994799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994827 */     // MIs[0] passthru
     /*  994827 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994836 */     // MIs[0] round
     /*  994836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994846 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994868 */     GIR_RootConstrainSelectedInstOperands,
     /*  994869 */     // GIR_Coverage, 17276,
     /*  994869 */     GIR_EraseRootFromParent_Done,
     /*  994870 */   // Label 14826: @994870
     /*  994870 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(994946), // Rule ID 17277 //
     /*  994875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994903 */     // MIs[0] passthru
     /*  994903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994912 */     // MIs[0] round
     /*  994912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994922 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994944 */     GIR_RootConstrainSelectedInstOperands,
     /*  994945 */     // GIR_Coverage, 17277,
     /*  994945 */     GIR_EraseRootFromParent_Done,
     /*  994946 */   // Label 14827: @994946
     /*  994946 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(995022), // Rule ID 17286 //
     /*  994951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994979 */     // MIs[0] passthru
     /*  994979 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994988 */     // MIs[0] round
     /*  994988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994998 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  995001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995020 */     GIR_RootConstrainSelectedInstOperands,
     /*  995021 */     // GIR_Coverage, 17286,
     /*  995021 */     GIR_EraseRootFromParent_Done,
     /*  995022 */   // Label 14828: @995022
     /*  995022 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(995098), // Rule ID 17287 //
     /*  995027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  995044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995055 */     // MIs[0] passthru
     /*  995055 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995064 */     // MIs[0] round
     /*  995064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995074 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  995077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995096 */     GIR_RootConstrainSelectedInstOperands,
     /*  995097 */     // GIR_Coverage, 17287,
     /*  995097 */     GIR_EraseRootFromParent_Done,
     /*  995098 */   // Label 14829: @995098
     /*  995098 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(995174), // Rule ID 17296 //
     /*  995103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  995106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  995120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995131 */     // MIs[0] passthru
     /*  995131 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995140 */     // MIs[0] round
     /*  995140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  995150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  995153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995172 */     GIR_RootConstrainSelectedInstOperands,
     /*  995173 */     // GIR_Coverage, 17296,
     /*  995173 */     GIR_EraseRootFromParent_Done,
     /*  995174 */   // Label 14830: @995174
     /*  995174 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(995250), // Rule ID 17297 //
     /*  995179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  995196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995207 */     // MIs[0] passthru
     /*  995207 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995216 */     // MIs[0] round
     /*  995216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995226 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  995229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995248 */     GIR_RootConstrainSelectedInstOperands,
     /*  995249 */     // GIR_Coverage, 17297,
     /*  995249 */     GIR_EraseRootFromParent_Done,
     /*  995250 */   // Label 14831: @995250
     /*  995250 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(995326), // Rule ID 17306 //
     /*  995255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  995258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  995272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995283 */     // MIs[0] passthru
     /*  995283 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995292 */     // MIs[0] round
     /*  995292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  995302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  995305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995324 */     GIR_RootConstrainSelectedInstOperands,
     /*  995325 */     // GIR_Coverage, 17306,
     /*  995325 */     GIR_EraseRootFromParent_Done,
     /*  995326 */   // Label 14832: @995326
     /*  995326 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(995402), // Rule ID 17307 //
     /*  995331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  995334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  995348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995359 */     // MIs[0] passthru
     /*  995359 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995368 */     // MIs[0] round
     /*  995368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995378 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  995378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  995381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995400 */     GIR_RootConstrainSelectedInstOperands,
     /*  995401 */     // GIR_Coverage, 17307,
     /*  995401 */     GIR_EraseRootFromParent_Done,
     /*  995402 */   // Label 14833: @995402
     /*  995402 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(995478), // Rule ID 17316 //
     /*  995407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995435 */     // MIs[0] passthru
     /*  995435 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995444 */     // MIs[0] round
     /*  995444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995454 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995476 */     GIR_RootConstrainSelectedInstOperands,
     /*  995477 */     // GIR_Coverage, 17316,
     /*  995477 */     GIR_EraseRootFromParent_Done,
     /*  995478 */   // Label 14834: @995478
     /*  995478 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(995554), // Rule ID 17317 //
     /*  995483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995511 */     // MIs[0] passthru
     /*  995511 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995520 */     // MIs[0] round
     /*  995520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995552 */     GIR_RootConstrainSelectedInstOperands,
     /*  995553 */     // GIR_Coverage, 17317,
     /*  995553 */     GIR_EraseRootFromParent_Done,
     /*  995554 */   // Label 14835: @995554
     /*  995554 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(995630), // Rule ID 17326 //
     /*  995559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995587 */     // MIs[0] passthru
     /*  995587 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995596 */     // MIs[0] round
     /*  995596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995628 */     GIR_RootConstrainSelectedInstOperands,
     /*  995629 */     // GIR_Coverage, 17326,
     /*  995629 */     GIR_EraseRootFromParent_Done,
     /*  995630 */   // Label 14836: @995630
     /*  995630 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(995706), // Rule ID 17327 //
     /*  995635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995663 */     // MIs[0] passthru
     /*  995663 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995672 */     // MIs[0] round
     /*  995672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995682 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995704 */     GIR_RootConstrainSelectedInstOperands,
     /*  995705 */     // GIR_Coverage, 17327,
     /*  995705 */     GIR_EraseRootFromParent_Done,
     /*  995706 */   // Label 14837: @995706
     /*  995706 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(995782), // Rule ID 17336 //
     /*  995711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995739 */     // MIs[0] passthru
     /*  995739 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995748 */     // MIs[0] round
     /*  995748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995780 */     GIR_RootConstrainSelectedInstOperands,
     /*  995781 */     // GIR_Coverage, 17336,
     /*  995781 */     GIR_EraseRootFromParent_Done,
     /*  995782 */   // Label 14838: @995782
     /*  995782 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(995858), // Rule ID 17337 //
     /*  995787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995815 */     // MIs[0] passthru
     /*  995815 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995824 */     // MIs[0] round
     /*  995824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995834 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995856 */     GIR_RootConstrainSelectedInstOperands,
     /*  995857 */     // GIR_Coverage, 17337,
     /*  995857 */     GIR_EraseRootFromParent_Done,
     /*  995858 */   // Label 14839: @995858
     /*  995858 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(995934), // Rule ID 17346 //
     /*  995863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995891 */     // MIs[0] passthru
     /*  995891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995900 */     // MIs[0] round
     /*  995900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995910 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995932 */     GIR_RootConstrainSelectedInstOperands,
     /*  995933 */     // GIR_Coverage, 17346,
     /*  995933 */     GIR_EraseRootFromParent_Done,
     /*  995934 */   // Label 14840: @995934
     /*  995934 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(996010), // Rule ID 17347 //
     /*  995939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995967 */     // MIs[0] passthru
     /*  995967 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995976 */     // MIs[0] round
     /*  995976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995986 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996008 */     GIR_RootConstrainSelectedInstOperands,
     /*  996009 */     // GIR_Coverage, 17347,
     /*  996009 */     GIR_EraseRootFromParent_Done,
     /*  996010 */   // Label 14841: @996010
     /*  996010 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(996087), // Rule ID 2700 //
     /*  996015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  996023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  996032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996054 */     // MIs[0] policy
     /*  996054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  996067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996085 */     GIR_RootConstrainSelectedInstOperands,
     /*  996086 */     // GIR_Coverage, 2700,
     /*  996086 */     GIR_EraseRootFromParent_Done,
     /*  996087 */   // Label 14842: @996087
     /*  996087 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(996164), // Rule ID 2701 //
     /*  996092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  996100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  996109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996131 */     // MIs[0] policy
     /*  996131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996141 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  996144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996162 */     GIR_RootConstrainSelectedInstOperands,
     /*  996163 */     // GIR_Coverage, 2701,
     /*  996163 */     GIR_EraseRootFromParent_Done,
     /*  996164 */   // Label 14843: @996164
     /*  996164 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(996241), // Rule ID 2704 //
     /*  996169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996208 */     // MIs[0] policy
     /*  996208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  996221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996239 */     GIR_RootConstrainSelectedInstOperands,
     /*  996240 */     // GIR_Coverage, 2704,
     /*  996240 */     GIR_EraseRootFromParent_Done,
     /*  996241 */   // Label 14844: @996241
     /*  996241 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(996318), // Rule ID 2705 //
     /*  996246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996285 */     // MIs[0] policy
     /*  996285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  996298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996316 */     GIR_RootConstrainSelectedInstOperands,
     /*  996317 */     // GIR_Coverage, 2705,
     /*  996317 */     GIR_EraseRootFromParent_Done,
     /*  996318 */   // Label 14845: @996318
     /*  996318 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(996395), // Rule ID 2708 //
     /*  996323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  996326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  996331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996362 */     // MIs[0] policy
     /*  996362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996372 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  996375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996393 */     GIR_RootConstrainSelectedInstOperands,
     /*  996394 */     // GIR_Coverage, 2708,
     /*  996394 */     GIR_EraseRootFromParent_Done,
     /*  996395 */   // Label 14846: @996395
     /*  996395 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(996472), // Rule ID 2709 //
     /*  996400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  996403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  996408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996439 */     // MIs[0] policy
     /*  996439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996449 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  996452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996470 */     GIR_RootConstrainSelectedInstOperands,
     /*  996471 */     // GIR_Coverage, 2709,
     /*  996471 */     GIR_EraseRootFromParent_Done,
     /*  996472 */   // Label 14847: @996472
     /*  996472 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(996549), // Rule ID 2744 //
     /*  996477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  996480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996516 */     // MIs[0] policy
     /*  996516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996547 */     GIR_RootConstrainSelectedInstOperands,
     /*  996548 */     // GIR_Coverage, 2744,
     /*  996548 */     GIR_EraseRootFromParent_Done,
     /*  996549 */   // Label 14848: @996549
     /*  996549 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(996626), // Rule ID 2745 //
     /*  996554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  996557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996593 */     // MIs[0] policy
     /*  996593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996624 */     GIR_RootConstrainSelectedInstOperands,
     /*  996625 */     // GIR_Coverage, 2745,
     /*  996625 */     GIR_EraseRootFromParent_Done,
     /*  996626 */   // Label 14849: @996626
     /*  996626 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(996703), // Rule ID 2776 //
     /*  996631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996670 */     // MIs[0] policy
     /*  996670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996701 */     GIR_RootConstrainSelectedInstOperands,
     /*  996702 */     // GIR_Coverage, 2776,
     /*  996702 */     GIR_EraseRootFromParent_Done,
     /*  996703 */   // Label 14850: @996703
     /*  996703 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(996780), // Rule ID 2777 //
     /*  996708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996747 */     // MIs[0] policy
     /*  996747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996757 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996778 */     GIR_RootConstrainSelectedInstOperands,
     /*  996779 */     // GIR_Coverage, 2777,
     /*  996779 */     GIR_EraseRootFromParent_Done,
     /*  996780 */   // Label 14851: @996780
     /*  996780 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(996857), // Rule ID 4904 //
     /*  996785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996824 */     // MIs[0] policy
     /*  996824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996855 */     GIR_RootConstrainSelectedInstOperands,
     /*  996856 */     // GIR_Coverage, 4904,
     /*  996856 */     GIR_EraseRootFromParent_Done,
     /*  996857 */   // Label 14852: @996857
     /*  996857 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(996934), // Rule ID 4905 //
     /*  996862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996901 */     // MIs[0] policy
     /*  996901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996911 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996932 */     GIR_RootConstrainSelectedInstOperands,
     /*  996933 */     // GIR_Coverage, 4905,
     /*  996933 */     GIR_EraseRootFromParent_Done,
     /*  996934 */   // Label 14853: @996934
     /*  996934 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(997011), // Rule ID 4908 //
     /*  996939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996978 */     // MIs[0] policy
     /*  996978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997009 */     GIR_RootConstrainSelectedInstOperands,
     /*  997010 */     // GIR_Coverage, 4908,
     /*  997010 */     GIR_EraseRootFromParent_Done,
     /*  997011 */   // Label 14854: @997011
     /*  997011 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(997088), // Rule ID 4909 //
     /*  997016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  997027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  997030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  997033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997055 */     // MIs[0] policy
     /*  997055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997065 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11734:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997086 */     GIR_RootConstrainSelectedInstOperands,
     /*  997087 */     // GIR_Coverage, 4909,
     /*  997087 */     GIR_EraseRootFromParent_Done,
     /*  997088 */   // Label 14855: @997088
     /*  997088 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(997165), // Rule ID 4912 //
     /*  997093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  997110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997132 */     // MIs[0] policy
     /*  997132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997163 */     GIR_RootConstrainSelectedInstOperands,
     /*  997164 */     // GIR_Coverage, 4912,
     /*  997164 */     GIR_EraseRootFromParent_Done,
     /*  997165 */   // Label 14856: @997165
     /*  997165 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(997242), // Rule ID 4913 //
     /*  997170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  997181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  997184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  997187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997209 */     // MIs[0] policy
     /*  997209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997240 */     GIR_RootConstrainSelectedInstOperands,
     /*  997241 */     // GIR_Coverage, 4913,
     /*  997241 */     GIR_EraseRootFromParent_Done,
     /*  997242 */   // Label 14857: @997242
     /*  997242 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(997319), // Rule ID 4916 //
     /*  997247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  997264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997286 */     // MIs[0] policy
     /*  997286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997317 */     GIR_RootConstrainSelectedInstOperands,
     /*  997318 */     // GIR_Coverage, 4916,
     /*  997318 */     GIR_EraseRootFromParent_Done,
     /*  997319 */   // Label 14858: @997319
     /*  997319 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(997396), // Rule ID 4917 //
     /*  997324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  997335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  997338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  997341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997363 */     // MIs[0] policy
     /*  997363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997373 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997394 */     GIR_RootConstrainSelectedInstOperands,
     /*  997395 */     // GIR_Coverage, 4917,
     /*  997395 */     GIR_EraseRootFromParent_Done,
     /*  997396 */   // Label 14859: @997396
     /*  997396 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(997473), // Rule ID 4920 //
     /*  997401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997440 */     // MIs[0] policy
     /*  997440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997471 */     GIR_RootConstrainSelectedInstOperands,
     /*  997472 */     // GIR_Coverage, 4920,
     /*  997472 */     GIR_EraseRootFromParent_Done,
     /*  997473 */   // Label 14860: @997473
     /*  997473 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(997550), // Rule ID 4921 //
     /*  997478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997517 */     // MIs[0] policy
     /*  997517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997527 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997548 */     GIR_RootConstrainSelectedInstOperands,
     /*  997549 */     // GIR_Coverage, 4921,
     /*  997549 */     GIR_EraseRootFromParent_Done,
     /*  997550 */   // Label 14861: @997550
     /*  997550 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(997627), // Rule ID 4924 //
     /*  997555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997594 */     // MIs[0] policy
     /*  997594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997625 */     GIR_RootConstrainSelectedInstOperands,
     /*  997626 */     // GIR_Coverage, 4924,
     /*  997626 */     GIR_EraseRootFromParent_Done,
     /*  997627 */   // Label 14862: @997627
     /*  997627 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(997704), // Rule ID 4925 //
     /*  997632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997671 */     // MIs[0] policy
     /*  997671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997702 */     GIR_RootConstrainSelectedInstOperands,
     /*  997703 */     // GIR_Coverage, 4925,
     /*  997703 */     GIR_EraseRootFromParent_Done,
     /*  997704 */   // Label 14863: @997704
     /*  997704 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(997781), // Rule ID 4928 //
     /*  997709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997748 */     // MIs[0] policy
     /*  997748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997779 */     GIR_RootConstrainSelectedInstOperands,
     /*  997780 */     // GIR_Coverage, 4928,
     /*  997780 */     GIR_EraseRootFromParent_Done,
     /*  997781 */   // Label 14864: @997781
     /*  997781 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(997858), // Rule ID 4929 //
     /*  997786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997825 */     // MIs[0] policy
     /*  997825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997835 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997856 */     GIR_RootConstrainSelectedInstOperands,
     /*  997857 */     // GIR_Coverage, 4929,
     /*  997857 */     GIR_EraseRootFromParent_Done,
     /*  997858 */   // Label 14865: @997858
     /*  997858 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(997935), // Rule ID 4932 //
     /*  997863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997902 */     // MIs[0] policy
     /*  997902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997933 */     GIR_RootConstrainSelectedInstOperands,
     /*  997934 */     // GIR_Coverage, 4932,
     /*  997934 */     GIR_EraseRootFromParent_Done,
     /*  997935 */   // Label 14866: @997935
     /*  997935 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(998012), // Rule ID 4933 //
     /*  997940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997979 */     // MIs[0] policy
     /*  997979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998010 */     GIR_RootConstrainSelectedInstOperands,
     /*  998011 */     // GIR_Coverage, 4933,
     /*  998011 */     GIR_EraseRootFromParent_Done,
     /*  998012 */   // Label 14867: @998012
     /*  998012 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(998089), // Rule ID 4936 //
     /*  998017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  998034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998056 */     // MIs[0] policy
     /*  998056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998087 */     GIR_RootConstrainSelectedInstOperands,
     /*  998088 */     // GIR_Coverage, 4936,
     /*  998088 */     GIR_EraseRootFromParent_Done,
     /*  998089 */   // Label 14868: @998089
     /*  998089 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(998166), // Rule ID 4937 //
     /*  998094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  998111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998133 */     // MIs[0] policy
     /*  998133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998143 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998164 */     GIR_RootConstrainSelectedInstOperands,
     /*  998165 */     // GIR_Coverage, 4937,
     /*  998165 */     GIR_EraseRootFromParent_Done,
     /*  998166 */   // Label 14869: @998166
     /*  998166 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(998243), // Rule ID 4940 //
     /*  998171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  998188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998210 */     // MIs[0] policy
     /*  998210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998220 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998241 */     GIR_RootConstrainSelectedInstOperands,
     /*  998242 */     // GIR_Coverage, 4940,
     /*  998242 */     GIR_EraseRootFromParent_Done,
     /*  998243 */   // Label 14870: @998243
     /*  998243 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(998320), // Rule ID 4941 //
     /*  998248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  998265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998287 */     // MIs[0] policy
     /*  998287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998297 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998318 */     GIR_RootConstrainSelectedInstOperands,
     /*  998319 */     // GIR_Coverage, 4941,
     /*  998319 */     GIR_EraseRootFromParent_Done,
     /*  998320 */   // Label 14871: @998320
     /*  998320 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(998397), // Rule ID 4944 //
     /*  998325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  998342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998364 */     // MIs[0] policy
     /*  998364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  998377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998395 */     GIR_RootConstrainSelectedInstOperands,
     /*  998396 */     // GIR_Coverage, 4944,
     /*  998396 */     GIR_EraseRootFromParent_Done,
     /*  998397 */   // Label 14872: @998397
     /*  998397 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(998474), // Rule ID 4945 //
     /*  998402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  998419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998441 */     // MIs[0] policy
     /*  998441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998451 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  998454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998472 */     GIR_RootConstrainSelectedInstOperands,
     /*  998473 */     // GIR_Coverage, 4945,
     /*  998473 */     GIR_EraseRootFromParent_Done,
     /*  998474 */   // Label 14873: @998474
     /*  998474 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(998551), // Rule ID 4948 //
     /*  998479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998518 */     // MIs[0] policy
     /*  998518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998549 */     GIR_RootConstrainSelectedInstOperands,
     /*  998550 */     // GIR_Coverage, 4948,
     /*  998550 */     GIR_EraseRootFromParent_Done,
     /*  998551 */   // Label 14874: @998551
     /*  998551 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(998628), // Rule ID 4949 //
     /*  998556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998595 */     // MIs[0] policy
     /*  998595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998626 */     GIR_RootConstrainSelectedInstOperands,
     /*  998627 */     // GIR_Coverage, 4949,
     /*  998627 */     GIR_EraseRootFromParent_Done,
     /*  998628 */   // Label 14875: @998628
     /*  998628 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(998705), // Rule ID 4952 //
     /*  998633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998672 */     // MIs[0] policy
     /*  998672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998703 */     GIR_RootConstrainSelectedInstOperands,
     /*  998704 */     // GIR_Coverage, 4952,
     /*  998704 */     GIR_EraseRootFromParent_Done,
     /*  998705 */   // Label 14876: @998705
     /*  998705 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(998782), // Rule ID 4953 //
     /*  998710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998749 */     // MIs[0] policy
     /*  998749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998780 */     GIR_RootConstrainSelectedInstOperands,
     /*  998781 */     // GIR_Coverage, 4953,
     /*  998781 */     GIR_EraseRootFromParent_Done,
     /*  998782 */   // Label 14877: @998782
     /*  998782 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(998859), // Rule ID 4956 //
     /*  998787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998826 */     // MIs[0] policy
     /*  998826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998857 */     GIR_RootConstrainSelectedInstOperands,
     /*  998858 */     // GIR_Coverage, 4956,
     /*  998858 */     GIR_EraseRootFromParent_Done,
     /*  998859 */   // Label 14878: @998859
     /*  998859 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(998936), // Rule ID 4957 //
     /*  998864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998903 */     // MIs[0] policy
     /*  998903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998913 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998934 */     GIR_RootConstrainSelectedInstOperands,
     /*  998935 */     // GIR_Coverage, 4957,
     /*  998935 */     GIR_EraseRootFromParent_Done,
     /*  998936 */   // Label 14879: @998936
     /*  998936 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(999013), // Rule ID 4960 //
     /*  998941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998980 */     // MIs[0] policy
     /*  998980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999011 */     GIR_RootConstrainSelectedInstOperands,
     /*  999012 */     // GIR_Coverage, 4960,
     /*  999012 */     GIR_EraseRootFromParent_Done,
     /*  999013 */   // Label 14880: @999013
     /*  999013 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(999090), // Rule ID 4961 //
     /*  999018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  999029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  999032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999057 */     // MIs[0] policy
     /*  999057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999067 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  999070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999088 */     GIR_RootConstrainSelectedInstOperands,
     /*  999089 */     // GIR_Coverage, 4961,
     /*  999089 */     GIR_EraseRootFromParent_Done,
     /*  999090 */   // Label 14881: @999090
     /*  999090 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(999167), // Rule ID 4964 //
     /*  999095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  999106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  999109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999134 */     // MIs[0] policy
     /*  999134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999165 */     GIR_RootConstrainSelectedInstOperands,
     /*  999166 */     // GIR_Coverage, 4964,
     /*  999166 */     GIR_EraseRootFromParent_Done,
     /*  999167 */   // Label 14882: @999167
     /*  999167 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(999244), // Rule ID 4965 //
     /*  999172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  999183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  999186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999211 */     // MIs[0] policy
     /*  999211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999221 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11734:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999242 */     GIR_RootConstrainSelectedInstOperands,
     /*  999243 */     // GIR_Coverage, 4965,
     /*  999243 */     GIR_EraseRootFromParent_Done,
     /*  999244 */   // Label 14883: @999244
     /*  999244 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(999321), // Rule ID 4968 //
     /*  999249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  999260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  999263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999288 */     // MIs[0] policy
     /*  999288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999319 */     GIR_RootConstrainSelectedInstOperands,
     /*  999320 */     // GIR_Coverage, 4968,
     /*  999320 */     GIR_EraseRootFromParent_Done,
     /*  999321 */   // Label 14884: @999321
     /*  999321 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(999398), // Rule ID 4969 //
     /*  999326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  999337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  999340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999365 */     // MIs[0] policy
     /*  999365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999396 */     GIR_RootConstrainSelectedInstOperands,
     /*  999397 */     // GIR_Coverage, 4969,
     /*  999397 */     GIR_EraseRootFromParent_Done,
     /*  999398 */   // Label 14885: @999398
     /*  999398 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(999475), // Rule ID 4972 //
     /*  999403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999442 */     // MIs[0] policy
     /*  999442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999473 */     GIR_RootConstrainSelectedInstOperands,
     /*  999474 */     // GIR_Coverage, 4972,
     /*  999474 */     GIR_EraseRootFromParent_Done,
     /*  999475 */   // Label 14886: @999475
     /*  999475 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(999552), // Rule ID 4973 //
     /*  999480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999519 */     // MIs[0] policy
     /*  999519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999550 */     GIR_RootConstrainSelectedInstOperands,
     /*  999551 */     // GIR_Coverage, 4973,
     /*  999551 */     GIR_EraseRootFromParent_Done,
     /*  999552 */   // Label 14887: @999552
     /*  999552 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(999629), // Rule ID 4976 //
     /*  999557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999596 */     // MIs[0] policy
     /*  999596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999627 */     GIR_RootConstrainSelectedInstOperands,
     /*  999628 */     // GIR_Coverage, 4976,
     /*  999628 */     GIR_EraseRootFromParent_Done,
     /*  999629 */   // Label 14888: @999629
     /*  999629 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(999706), // Rule ID 4977 //
     /*  999634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999673 */     // MIs[0] policy
     /*  999673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999683 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999704 */     GIR_RootConstrainSelectedInstOperands,
     /*  999705 */     // GIR_Coverage, 4977,
     /*  999705 */     GIR_EraseRootFromParent_Done,
     /*  999706 */   // Label 14889: @999706
     /*  999706 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(999783), // Rule ID 4980 //
     /*  999711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999750 */     // MIs[0] policy
     /*  999750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999781 */     GIR_RootConstrainSelectedInstOperands,
     /*  999782 */     // GIR_Coverage, 4980,
     /*  999782 */     GIR_EraseRootFromParent_Done,
     /*  999783 */   // Label 14890: @999783
     /*  999783 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(999860), // Rule ID 4981 //
     /*  999788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999827 */     // MIs[0] policy
     /*  999827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999837 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999858 */     GIR_RootConstrainSelectedInstOperands,
     /*  999859 */     // GIR_Coverage, 4981,
     /*  999859 */     GIR_EraseRootFromParent_Done,
     /*  999860 */   // Label 14891: @999860
     /*  999860 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(999937), // Rule ID 4984 //
     /*  999865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999904 */     // MIs[0] policy
     /*  999904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999935 */     GIR_RootConstrainSelectedInstOperands,
     /*  999936 */     // GIR_Coverage, 4984,
     /*  999936 */     GIR_EraseRootFromParent_Done,
     /*  999937 */   // Label 14892: @999937
     /*  999937 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1000014), // Rule ID 4985 //
     /*  999942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999981 */     // MIs[0] policy
     /*  999981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000013 */     // GIR_Coverage, 4985,
     /* 1000013 */     GIR_EraseRootFromParent_Done,
     /* 1000014 */   // Label 14893: @1000014
     /* 1000014 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1000091), // Rule ID 4988 //
     /* 1000019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1000036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000058 */     // MIs[0] policy
     /* 1000058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1000071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000090 */     // GIR_Coverage, 4988,
     /* 1000090 */     GIR_EraseRootFromParent_Done,
     /* 1000091 */   // Label 14894: @1000091
     /* 1000091 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1000168), // Rule ID 4989 //
     /* 1000096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1000113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000135 */     // MIs[0] policy
     /* 1000135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000145 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1000148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000167 */     // GIR_Coverage, 4989,
     /* 1000167 */     GIR_EraseRootFromParent_Done,
     /* 1000168 */   // Label 14895: @1000168
     /* 1000168 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1000245), // Rule ID 4992 //
     /* 1000173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000212 */     // MIs[0] policy
     /* 1000212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000222 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1000225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000244 */     // GIR_Coverage, 4992,
     /* 1000244 */     GIR_EraseRootFromParent_Done,
     /* 1000245 */   // Label 14896: @1000245
     /* 1000245 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1000322), // Rule ID 4993 //
     /* 1000250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1000267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000289 */     // MIs[0] policy
     /* 1000289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1000302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000321 */     // GIR_Coverage, 4993,
     /* 1000321 */     GIR_EraseRootFromParent_Done,
     /* 1000322 */   // Label 14897: @1000322
     /* 1000322 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1000399), // Rule ID 4996 //
     /* 1000327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000366 */     // MIs[0] policy
     /* 1000366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1000379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000398 */     // GIR_Coverage, 4996,
     /* 1000398 */     GIR_EraseRootFromParent_Done,
     /* 1000399 */   // Label 14898: @1000399
     /* 1000399 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1000476), // Rule ID 4997 //
     /* 1000404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1000415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1000418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000443 */     // MIs[0] policy
     /* 1000443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000453 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11734:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1000456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000475 */     // GIR_Coverage, 4997,
     /* 1000475 */     GIR_EraseRootFromParent_Done,
     /* 1000476 */   // Label 14899: @1000476
     /* 1000476 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1000553), // Rule ID 5000 //
     /* 1000481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000520 */     // MIs[0] policy
     /* 1000520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000552 */     // GIR_Coverage, 5000,
     /* 1000552 */     GIR_EraseRootFromParent_Done,
     /* 1000553 */   // Label 14900: @1000553
     /* 1000553 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1000630), // Rule ID 5001 //
     /* 1000558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000597 */     // MIs[0] policy
     /* 1000597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000607 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11734:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000629 */     // GIR_Coverage, 5001,
     /* 1000629 */     GIR_EraseRootFromParent_Done,
     /* 1000630 */   // Label 14901: @1000630
     /* 1000630 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1000707), // Rule ID 5004 //
     /* 1000635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000674 */     // MIs[0] policy
     /* 1000674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000706 */     // GIR_Coverage, 5004,
     /* 1000706 */     GIR_EraseRootFromParent_Done,
     /* 1000707 */   // Label 14902: @1000707
     /* 1000707 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1000784), // Rule ID 5005 //
     /* 1000712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000751 */     // MIs[0] policy
     /* 1000751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000761 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11734:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000783 */     // GIR_Coverage, 5005,
     /* 1000783 */     GIR_EraseRootFromParent_Done,
     /* 1000784 */   // Label 14903: @1000784
     /* 1000784 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1000861), // Rule ID 5008 //
     /* 1000789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000828 */     // MIs[0] policy
     /* 1000828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000838 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000860 */     // GIR_Coverage, 5008,
     /* 1000860 */     GIR_EraseRootFromParent_Done,
     /* 1000861 */   // Label 14904: @1000861
     /* 1000861 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1000938), // Rule ID 5009 //
     /* 1000866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000905 */     // MIs[0] policy
     /* 1000905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000915 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11734:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000937 */     // GIR_Coverage, 5009,
     /* 1000937 */     GIR_EraseRootFromParent_Done,
     /* 1000938 */   // Label 14905: @1000938
     /* 1000938 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1001015), // Rule ID 5012 //
     /* 1000943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000982 */     // MIs[0] policy
     /* 1000982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001014 */     // GIR_Coverage, 5012,
     /* 1001014 */     GIR_EraseRootFromParent_Done,
     /* 1001015 */   // Label 14906: @1001015
     /* 1001015 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1001092), // Rule ID 5013 //
     /* 1001020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1001031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1001034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1001037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001059 */     // MIs[0] policy
     /* 1001059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1001072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001091 */     // GIR_Coverage, 5013,
     /* 1001091 */     GIR_EraseRootFromParent_Done,
     /* 1001092 */   // Label 14907: @1001092
     /* 1001092 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1001169), // Rule ID 5016 //
     /* 1001097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1001108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1001111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1001114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001136 */     // MIs[0] policy
     /* 1001136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001168 */     // GIR_Coverage, 5016,
     /* 1001168 */     GIR_EraseRootFromParent_Done,
     /* 1001169 */   // Label 14908: @1001169
     /* 1001169 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1001246), // Rule ID 5017 //
     /* 1001174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1001185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1001188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1001191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001213 */     // MIs[0] policy
     /* 1001213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001223 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001245 */     // GIR_Coverage, 5017,
     /* 1001245 */     GIR_EraseRootFromParent_Done,
     /* 1001246 */   // Label 14909: @1001246
     /* 1001246 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1001323), // Rule ID 5020 //
     /* 1001251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1001262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1001265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1001268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001290 */     // MIs[0] policy
     /* 1001290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001322 */     // GIR_Coverage, 5020,
     /* 1001322 */     GIR_EraseRootFromParent_Done,
     /* 1001323 */   // Label 14910: @1001323
     /* 1001323 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1001400), // Rule ID 5021 //
     /* 1001328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1001339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1001342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1001345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001367 */     // MIs[0] policy
     /* 1001367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001399 */     // GIR_Coverage, 5021,
     /* 1001399 */     GIR_EraseRootFromParent_Done,
     /* 1001400 */   // Label 14911: @1001400
     /* 1001400 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1001477), // Rule ID 5024 //
     /* 1001405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001444 */     // MIs[0] policy
     /* 1001444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001476 */     // GIR_Coverage, 5024,
     /* 1001476 */     GIR_EraseRootFromParent_Done,
     /* 1001477 */   // Label 14912: @1001477
     /* 1001477 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1001554), // Rule ID 5025 //
     /* 1001482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001521 */     // MIs[0] policy
     /* 1001521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001531 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001553 */     // GIR_Coverage, 5025,
     /* 1001553 */     GIR_EraseRootFromParent_Done,
     /* 1001554 */   // Label 14913: @1001554
     /* 1001554 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1001631), // Rule ID 5028 //
     /* 1001559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001598 */     // MIs[0] policy
     /* 1001598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001608 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001630 */     // GIR_Coverage, 5028,
     /* 1001630 */     GIR_EraseRootFromParent_Done,
     /* 1001631 */   // Label 14914: @1001631
     /* 1001631 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1001708), // Rule ID 5029 //
     /* 1001636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001675 */     // MIs[0] policy
     /* 1001675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001685 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001707 */     // GIR_Coverage, 5029,
     /* 1001707 */     GIR_EraseRootFromParent_Done,
     /* 1001708 */   // Label 14915: @1001708
     /* 1001708 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1001785), // Rule ID 5032 //
     /* 1001713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001752 */     // MIs[0] policy
     /* 1001752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001784 */     // GIR_Coverage, 5032,
     /* 1001784 */     GIR_EraseRootFromParent_Done,
     /* 1001785 */   // Label 14916: @1001785
     /* 1001785 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1001862), // Rule ID 5033 //
     /* 1001790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001829 */     // MIs[0] policy
     /* 1001829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001839 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001861 */     // GIR_Coverage, 5033,
     /* 1001861 */     GIR_EraseRootFromParent_Done,
     /* 1001862 */   // Label 14917: @1001862
     /* 1001862 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1001939), // Rule ID 5036 //
     /* 1001867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001906 */     // MIs[0] policy
     /* 1001906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001938 */     // GIR_Coverage, 5036,
     /* 1001938 */     GIR_EraseRootFromParent_Done,
     /* 1001939 */   // Label 14918: @1001939
     /* 1001939 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1002016), // Rule ID 5037 //
     /* 1001944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001983 */     // MIs[0] policy
     /* 1001983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002015 */     // GIR_Coverage, 5037,
     /* 1002015 */     GIR_EraseRootFromParent_Done,
     /* 1002016 */   // Label 14919: @1002016
     /* 1002016 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1002093), // Rule ID 5040 //
     /* 1002021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002060 */     // MIs[0] policy
     /* 1002060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002092 */     // GIR_Coverage, 5040,
     /* 1002092 */     GIR_EraseRootFromParent_Done,
     /* 1002093 */   // Label 14920: @1002093
     /* 1002093 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1002170), // Rule ID 5041 //
     /* 1002098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1002115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002137 */     // MIs[0] policy
     /* 1002137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002147 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002169 */     // GIR_Coverage, 5041,
     /* 1002169 */     GIR_EraseRootFromParent_Done,
     /* 1002170 */   // Label 14921: @1002170
     /* 1002170 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1002247), // Rule ID 5044 //
     /* 1002175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1002192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002214 */     // MIs[0] policy
     /* 1002214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002246 */     // GIR_Coverage, 5044,
     /* 1002246 */     GIR_EraseRootFromParent_Done,
     /* 1002247 */   // Label 14922: @1002247
     /* 1002247 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1002324), // Rule ID 5045 //
     /* 1002252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1002269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002291 */     // MIs[0] policy
     /* 1002291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002323 */     // GIR_Coverage, 5045,
     /* 1002323 */     GIR_EraseRootFromParent_Done,
     /* 1002324 */   // Label 14923: @1002324
     /* 1002324 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1002401), // Rule ID 5048 //
     /* 1002329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1002346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002368 */     // MIs[0] policy
     /* 1002368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002400 */     // GIR_Coverage, 5048,
     /* 1002400 */     GIR_EraseRootFromParent_Done,
     /* 1002401 */   // Label 14924: @1002401
     /* 1002401 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1002478), // Rule ID 5049 //
     /* 1002406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1002423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002445 */     // MIs[0] policy
     /* 1002445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002455 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002477 */     // GIR_Coverage, 5049,
     /* 1002477 */     GIR_EraseRootFromParent_Done,
     /* 1002478 */   // Label 14925: @1002478
     /* 1002478 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1002555), // Rule ID 5052 //
     /* 1002483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002522 */     // MIs[0] policy
     /* 1002522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002554 */     // GIR_Coverage, 5052,
     /* 1002554 */     GIR_EraseRootFromParent_Done,
     /* 1002555 */   // Label 14926: @1002555
     /* 1002555 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1002632), // Rule ID 5053 //
     /* 1002560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002599 */     // MIs[0] policy
     /* 1002599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002609 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002631 */     // GIR_Coverage, 5053,
     /* 1002631 */     GIR_EraseRootFromParent_Done,
     /* 1002632 */   // Label 14927: @1002632
     /* 1002632 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1002709), // Rule ID 5056 //
     /* 1002637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002676 */     // MIs[0] policy
     /* 1002676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002708 */     // GIR_Coverage, 5056,
     /* 1002708 */     GIR_EraseRootFromParent_Done,
     /* 1002709 */   // Label 14928: @1002709
     /* 1002709 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1002786), // Rule ID 5057 //
     /* 1002714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002753 */     // MIs[0] policy
     /* 1002753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002763 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002785 */     // GIR_Coverage, 5057,
     /* 1002785 */     GIR_EraseRootFromParent_Done,
     /* 1002786 */   // Label 14929: @1002786
     /* 1002786 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1002863), // Rule ID 5060 //
     /* 1002791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002830 */     // MIs[0] policy
     /* 1002830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002862 */     // GIR_Coverage, 5060,
     /* 1002862 */     GIR_EraseRootFromParent_Done,
     /* 1002863 */   // Label 14930: @1002863
     /* 1002863 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1002940), // Rule ID 5061 //
     /* 1002868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002907 */     // MIs[0] policy
     /* 1002907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002917 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002939 */     // GIR_Coverage, 5061,
     /* 1002939 */     GIR_EraseRootFromParent_Done,
     /* 1002940 */   // Label 14931: @1002940
     /* 1002940 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1003017), // Rule ID 5064 //
     /* 1002945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002984 */     // MIs[0] policy
     /* 1002984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003016 */     // GIR_Coverage, 5064,
     /* 1003016 */     GIR_EraseRootFromParent_Done,
     /* 1003017 */   // Label 14932: @1003017
     /* 1003017 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1003094), // Rule ID 5065 //
     /* 1003022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1003039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003061 */     // MIs[0] policy
     /* 1003061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1003074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003093 */     // GIR_Coverage, 5065,
     /* 1003093 */     GIR_EraseRootFromParent_Done,
     /* 1003094 */   // Label 14933: @1003094
     /* 1003094 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1003171), // Rule ID 5068 //
     /* 1003099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1003116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003138 */     // MIs[0] policy
     /* 1003138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1003151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003170 */     // GIR_Coverage, 5068,
     /* 1003170 */     GIR_EraseRootFromParent_Done,
     /* 1003171 */   // Label 14934: @1003171
     /* 1003171 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1003248), // Rule ID 5069 //
     /* 1003176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1003193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003215 */     // MIs[0] policy
     /* 1003215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003225 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1003228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003247 */     // GIR_Coverage, 5069,
     /* 1003247 */     GIR_EraseRootFromParent_Done,
     /* 1003248 */   // Label 14935: @1003248
     /* 1003248 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1003325), // Rule ID 5072 //
     /* 1003253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1003264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1003267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003292 */     // MIs[0] policy
     /* 1003292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1003305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003324 */     // GIR_Coverage, 5072,
     /* 1003324 */     GIR_EraseRootFromParent_Done,
     /* 1003325 */   // Label 14936: @1003325
     /* 1003325 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1003402), // Rule ID 5073 //
     /* 1003330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1003341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1003344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003369 */     // MIs[0] policy
     /* 1003369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1003382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003401 */     // GIR_Coverage, 5073,
     /* 1003401 */     GIR_EraseRootFromParent_Done,
     /* 1003402 */   // Label 14937: @1003402
     /* 1003402 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1003479), // Rule ID 5076 //
     /* 1003407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003446 */     // MIs[0] policy
     /* 1003446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003478 */     // GIR_Coverage, 5076,
     /* 1003478 */     GIR_EraseRootFromParent_Done,
     /* 1003479 */   // Label 14938: @1003479
     /* 1003479 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1003556), // Rule ID 5077 //
     /* 1003484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003523 */     // MIs[0] policy
     /* 1003523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003555 */     // GIR_Coverage, 5077,
     /* 1003555 */     GIR_EraseRootFromParent_Done,
     /* 1003556 */   // Label 14939: @1003556
     /* 1003556 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1003633), // Rule ID 5080 //
     /* 1003561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003600 */     // MIs[0] policy
     /* 1003600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003632 */     // GIR_Coverage, 5080,
     /* 1003632 */     GIR_EraseRootFromParent_Done,
     /* 1003633 */   // Label 14940: @1003633
     /* 1003633 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1003710), // Rule ID 5081 //
     /* 1003638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003677 */     // MIs[0] policy
     /* 1003677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003687 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003709 */     // GIR_Coverage, 5081,
     /* 1003709 */     GIR_EraseRootFromParent_Done,
     /* 1003710 */   // Label 14941: @1003710
     /* 1003710 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1003787), // Rule ID 5084 //
     /* 1003715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003754 */     // MIs[0] policy
     /* 1003754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003786 */     // GIR_Coverage, 5084,
     /* 1003786 */     GIR_EraseRootFromParent_Done,
     /* 1003787 */   // Label 14942: @1003787
     /* 1003787 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1003864), // Rule ID 5085 //
     /* 1003792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003831 */     // MIs[0] policy
     /* 1003831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003841 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003863 */     // GIR_Coverage, 5085,
     /* 1003863 */     GIR_EraseRootFromParent_Done,
     /* 1003864 */   // Label 14943: @1003864
     /* 1003864 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1003941), // Rule ID 5088 //
     /* 1003869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003908 */     // MIs[0] policy
     /* 1003908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003940 */     // GIR_Coverage, 5088,
     /* 1003940 */     GIR_EraseRootFromParent_Done,
     /* 1003941 */   // Label 14944: @1003941
     /* 1003941 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1004018), // Rule ID 5089 //
     /* 1003946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003985 */     // MIs[0] policy
     /* 1003985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003995 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004017 */     // GIR_Coverage, 5089,
     /* 1004017 */     GIR_EraseRootFromParent_Done,
     /* 1004018 */   // Label 14945: @1004018
     /* 1004018 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1004095), // Rule ID 5092 //
     /* 1004023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004062 */     // MIs[0] policy
     /* 1004062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1004075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004094 */     // GIR_Coverage, 5092,
     /* 1004094 */     GIR_EraseRootFromParent_Done,
     /* 1004095 */   // Label 14946: @1004095
     /* 1004095 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1004172), // Rule ID 5093 //
     /* 1004100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004139 */     // MIs[0] policy
     /* 1004139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1004152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004171 */     // GIR_Coverage, 5093,
     /* 1004171 */     GIR_EraseRootFromParent_Done,
     /* 1004172 */   // Label 14947: @1004172
     /* 1004172 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1004249), // Rule ID 5096 //
     /* 1004177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004216 */     // MIs[0] policy
     /* 1004216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1004229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004248 */     // GIR_Coverage, 5096,
     /* 1004248 */     GIR_EraseRootFromParent_Done,
     /* 1004249 */   // Label 14948: @1004249
     /* 1004249 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1004326), // Rule ID 5097 //
     /* 1004254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004293 */     // MIs[0] policy
     /* 1004293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1004306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004325 */     // GIR_Coverage, 5097,
     /* 1004325 */     GIR_EraseRootFromParent_Done,
     /* 1004326 */   // Label 14949: @1004326
     /* 1004326 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1004403), // Rule ID 5100 //
     /* 1004331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1004348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004370 */     // MIs[0] policy
     /* 1004370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1004383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004402 */     // GIR_Coverage, 5100,
     /* 1004402 */     GIR_EraseRootFromParent_Done,
     /* 1004403 */   // Label 14950: @1004403
     /* 1004403 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1004480), // Rule ID 5101 //
     /* 1004408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1004425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004447 */     // MIs[0] policy
     /* 1004447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004457 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1004460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004479 */     // GIR_Coverage, 5101,
     /* 1004479 */     GIR_EraseRootFromParent_Done,
     /* 1004480 */   // Label 14951: @1004480
     /* 1004480 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1004557), // Rule ID 5104 //
     /* 1004485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004524 */     // MIs[0] policy
     /* 1004524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004556 */     // GIR_Coverage, 5104,
     /* 1004556 */     GIR_EraseRootFromParent_Done,
     /* 1004557 */   // Label 14952: @1004557
     /* 1004557 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1004634), // Rule ID 5105 //
     /* 1004562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004601 */     // MIs[0] policy
     /* 1004601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004611 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004633 */     // GIR_Coverage, 5105,
     /* 1004633 */     GIR_EraseRootFromParent_Done,
     /* 1004634 */   // Label 14953: @1004634
     /* 1004634 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1004711), // Rule ID 5108 //
     /* 1004639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004678 */     // MIs[0] policy
     /* 1004678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004710 */     // GIR_Coverage, 5108,
     /* 1004710 */     GIR_EraseRootFromParent_Done,
     /* 1004711 */   // Label 14954: @1004711
     /* 1004711 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1004788), // Rule ID 5109 //
     /* 1004716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004755 */     // MIs[0] policy
     /* 1004755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004765 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004787 */     // GIR_Coverage, 5109,
     /* 1004787 */     GIR_EraseRootFromParent_Done,
     /* 1004788 */   // Label 14955: @1004788
     /* 1004788 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1004865), // Rule ID 5112 //
     /* 1004793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004832 */     // MIs[0] policy
     /* 1004832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004864 */     // GIR_Coverage, 5112,
     /* 1004864 */     GIR_EraseRootFromParent_Done,
     /* 1004865 */   // Label 14956: @1004865
     /* 1004865 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1004942), // Rule ID 5113 //
     /* 1004870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004909 */     // MIs[0] policy
     /* 1004909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004941 */     // GIR_Coverage, 5113,
     /* 1004941 */     GIR_EraseRootFromParent_Done,
     /* 1004942 */   // Label 14957: @1004942
     /* 1004942 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1005019), // Rule ID 5116 //
     /* 1004947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004986 */     // MIs[0] policy
     /* 1004986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005018 */     // GIR_Coverage, 5116,
     /* 1005018 */     GIR_EraseRootFromParent_Done,
     /* 1005019 */   // Label 14958: @1005019
     /* 1005019 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1005096), // Rule ID 5117 //
     /* 1005024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1005027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1005035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1005038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005063 */     // MIs[0] policy
     /* 1005063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005073 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1005076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005095 */     // GIR_Coverage, 5117,
     /* 1005095 */     GIR_EraseRootFromParent_Done,
     /* 1005096 */   // Label 14959: @1005096
     /* 1005096 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1005173), // Rule ID 5120 //
     /* 1005101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1005104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005140 */     // MIs[0] policy
     /* 1005140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1005153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005172 */     // GIR_Coverage, 5120,
     /* 1005172 */     GIR_EraseRootFromParent_Done,
     /* 1005173 */   // Label 14960: @1005173
     /* 1005173 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1005250), // Rule ID 5121 //
     /* 1005178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1005181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1005189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1005192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005217 */     // MIs[0] policy
     /* 1005217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005227 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1005230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005249 */     // GIR_Coverage, 5121,
     /* 1005249 */     GIR_EraseRootFromParent_Done,
     /* 1005250 */   // Label 14961: @1005250
     /* 1005250 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1005327), // Rule ID 12732 //
     /* 1005255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1005275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005294 */     // MIs[0] policy
     /* 1005294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005304 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005326 */     // GIR_Coverage, 12732,
     /* 1005326 */     GIR_EraseRootFromParent_Done,
     /* 1005327 */   // Label 14962: @1005327
     /* 1005327 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1005404), // Rule ID 12733 //
     /* 1005332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1005343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1005346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1005349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1005352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005371 */     // MIs[0] policy
     /* 1005371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005381 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005403 */     // GIR_Coverage, 12733,
     /* 1005403 */     GIR_EraseRootFromParent_Done,
     /* 1005404 */   // Label 14963: @1005404
     /* 1005404 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1005481), // Rule ID 12736 //
     /* 1005409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005448 */     // MIs[0] policy
     /* 1005448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005480 */     // GIR_Coverage, 12736,
     /* 1005480 */     GIR_EraseRootFromParent_Done,
     /* 1005481 */   // Label 14964: @1005481
     /* 1005481 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1005558), // Rule ID 12737 //
     /* 1005486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005525 */     // MIs[0] policy
     /* 1005525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005535 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005557 */     // GIR_Coverage, 12737,
     /* 1005557 */     GIR_EraseRootFromParent_Done,
     /* 1005558 */   // Label 14965: @1005558
     /* 1005558 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1005635), // Rule ID 12740 //
     /* 1005563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005602 */     // MIs[0] policy
     /* 1005602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005612 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005634 */     // GIR_Coverage, 12740,
     /* 1005634 */     GIR_EraseRootFromParent_Done,
     /* 1005635 */   // Label 14966: @1005635
     /* 1005635 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1005712), // Rule ID 12741 //
     /* 1005640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005679 */     // MIs[0] policy
     /* 1005679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005689 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005711 */     // GIR_Coverage, 12741,
     /* 1005711 */     GIR_EraseRootFromParent_Done,
     /* 1005712 */   // Label 14967: @1005712
     /* 1005712 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1005789), // Rule ID 12744 //
     /* 1005717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005756 */     // MIs[0] policy
     /* 1005756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005766 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005788 */     // GIR_Coverage, 12744,
     /* 1005788 */     GIR_EraseRootFromParent_Done,
     /* 1005789 */   // Label 14968: @1005789
     /* 1005789 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1005866), // Rule ID 12745 //
     /* 1005794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005833 */     // MIs[0] policy
     /* 1005833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005865 */     // GIR_Coverage, 12745,
     /* 1005865 */     GIR_EraseRootFromParent_Done,
     /* 1005866 */   // Label 14969: @1005866
     /* 1005866 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1005943), // Rule ID 12748 //
     /* 1005871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005910 */     // MIs[0] policy
     /* 1005910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005942 */     // GIR_Coverage, 12748,
     /* 1005942 */     GIR_EraseRootFromParent_Done,
     /* 1005943 */   // Label 14970: @1005943
     /* 1005943 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1006020), // Rule ID 12749 //
     /* 1005948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005987 */     // MIs[0] policy
     /* 1005987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005997 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1006000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006019 */     // GIR_Coverage, 12749,
     /* 1006019 */     GIR_EraseRootFromParent_Done,
     /* 1006020 */   // Label 14971: @1006020
     /* 1006020 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1006097), // Rule ID 12752 //
     /* 1006025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1006045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006064 */     // MIs[0] policy
     /* 1006064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006096 */     // GIR_Coverage, 12752,
     /* 1006096 */     GIR_EraseRootFromParent_Done,
     /* 1006097 */   // Label 14972: @1006097
     /* 1006097 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1006174), // Rule ID 12753 //
     /* 1006102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1006113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1006116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1006119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1006122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006141 */     // MIs[0] policy
     /* 1006141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006151 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006173 */     // GIR_Coverage, 12753,
     /* 1006173 */     GIR_EraseRootFromParent_Done,
     /* 1006174 */   // Label 14973: @1006174
     /* 1006174 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1006251), // Rule ID 12756 //
     /* 1006179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1006199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006218 */     // MIs[0] policy
     /* 1006218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006250 */     // GIR_Coverage, 12756,
     /* 1006250 */     GIR_EraseRootFromParent_Done,
     /* 1006251 */   // Label 14974: @1006251
     /* 1006251 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1006328), // Rule ID 12757 //
     /* 1006256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1006267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1006270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1006273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1006276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006295 */     // MIs[0] policy
     /* 1006295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006305 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006327 */     // GIR_Coverage, 12757,
     /* 1006327 */     GIR_EraseRootFromParent_Done,
     /* 1006328 */   // Label 14975: @1006328
     /* 1006328 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1006405), // Rule ID 12760 //
     /* 1006333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1006353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006372 */     // MIs[0] policy
     /* 1006372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006404 */     // GIR_Coverage, 12760,
     /* 1006404 */     GIR_EraseRootFromParent_Done,
     /* 1006405 */   // Label 14976: @1006405
     /* 1006405 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1006482), // Rule ID 12761 //
     /* 1006410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1006430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006449 */     // MIs[0] policy
     /* 1006449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006459 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006481 */     // GIR_Coverage, 12761,
     /* 1006481 */     GIR_EraseRootFromParent_Done,
     /* 1006482 */   // Label 14977: @1006482
     /* 1006482 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1006559), // Rule ID 12764 //
     /* 1006487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1006490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006526 */     // MIs[0] policy
     /* 1006526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006558 */     // GIR_Coverage, 12764,
     /* 1006558 */     GIR_EraseRootFromParent_Done,
     /* 1006559 */   // Label 14978: @1006559
     /* 1006559 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1006636), // Rule ID 12765 //
     /* 1006564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1006567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006603 */     // MIs[0] policy
     /* 1006603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006613 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006635 */     // GIR_Coverage, 12765,
     /* 1006635 */     GIR_EraseRootFromParent_Done,
     /* 1006636 */   // Label 14979: @1006636
     /* 1006636 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1006713), // Rule ID 12768 //
     /* 1006641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006680 */     // MIs[0] policy
     /* 1006680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006712 */     // GIR_Coverage, 12768,
     /* 1006712 */     GIR_EraseRootFromParent_Done,
     /* 1006713 */   // Label 14980: @1006713
     /* 1006713 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1006790), // Rule ID 12769 //
     /* 1006718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006757 */     // MIs[0] policy
     /* 1006757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006767 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006789 */     // GIR_Coverage, 12769,
     /* 1006789 */     GIR_EraseRootFromParent_Done,
     /* 1006790 */   // Label 14981: @1006790
     /* 1006790 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1006867), // Rule ID 12772 //
     /* 1006795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006834 */     // MIs[0] policy
     /* 1006834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006844 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006866 */     // GIR_Coverage, 12772,
     /* 1006866 */     GIR_EraseRootFromParent_Done,
     /* 1006867 */   // Label 14982: @1006867
     /* 1006867 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1006944), // Rule ID 12773 //
     /* 1006872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006911 */     // MIs[0] policy
     /* 1006911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006943 */     // GIR_Coverage, 12773,
     /* 1006943 */     GIR_EraseRootFromParent_Done,
     /* 1006944 */   // Label 14983: @1006944
     /* 1006944 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1007021), // Rule ID 12776 //
     /* 1006949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006988 */     // MIs[0] policy
     /* 1006988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006998 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007020 */     // GIR_Coverage, 12776,
     /* 1007020 */     GIR_EraseRootFromParent_Done,
     /* 1007021 */   // Label 14984: @1007021
     /* 1007021 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1007098), // Rule ID 12777 //
     /* 1007026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1007037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1007040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1007043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1007046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007065 */     // MIs[0] policy
     /* 1007065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007075 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007097 */     // GIR_Coverage, 12777,
     /* 1007097 */     GIR_EraseRootFromParent_Done,
     /* 1007098 */   // Label 14985: @1007098
     /* 1007098 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1007175), // Rule ID 12780 //
     /* 1007103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1007123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007142 */     // MIs[0] policy
     /* 1007142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007174 */     // GIR_Coverage, 12780,
     /* 1007174 */     GIR_EraseRootFromParent_Done,
     /* 1007175 */   // Label 14986: @1007175
     /* 1007175 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1007252), // Rule ID 12781 //
     /* 1007180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1007191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1007194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1007200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007219 */     // MIs[0] policy
     /* 1007219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007251 */     // GIR_Coverage, 12781,
     /* 1007251 */     GIR_EraseRootFromParent_Done,
     /* 1007252 */   // Label 14987: @1007252
     /* 1007252 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1007329), // Rule ID 12784 //
     /* 1007257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1007277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007296 */     // MIs[0] policy
     /* 1007296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007328 */     // GIR_Coverage, 12784,
     /* 1007328 */     GIR_EraseRootFromParent_Done,
     /* 1007329 */   // Label 14988: @1007329
     /* 1007329 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1007406), // Rule ID 12785 //
     /* 1007334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1007345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1007348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1007351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1007354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007373 */     // MIs[0] policy
     /* 1007373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007383 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007405 */     // GIR_Coverage, 12785,
     /* 1007405 */     GIR_EraseRootFromParent_Done,
     /* 1007406 */   // Label 14989: @1007406
     /* 1007406 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1007483), // Rule ID 12788 //
     /* 1007411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007450 */     // MIs[0] policy
     /* 1007450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007460 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007482 */     // GIR_Coverage, 12788,
     /* 1007482 */     GIR_EraseRootFromParent_Done,
     /* 1007483 */   // Label 14990: @1007483
     /* 1007483 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1007560), // Rule ID 12789 //
     /* 1007488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007527 */     // MIs[0] policy
     /* 1007527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007537 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007559 */     // GIR_Coverage, 12789,
     /* 1007559 */     GIR_EraseRootFromParent_Done,
     /* 1007560 */   // Label 14991: @1007560
     /* 1007560 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1007637), // Rule ID 12792 //
     /* 1007565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007604 */     // MIs[0] policy
     /* 1007604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007636 */     // GIR_Coverage, 12792,
     /* 1007636 */     GIR_EraseRootFromParent_Done,
     /* 1007637 */   // Label 14992: @1007637
     /* 1007637 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1007714), // Rule ID 12793 //
     /* 1007642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007681 */     // MIs[0] policy
     /* 1007681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007713 */     // GIR_Coverage, 12793,
     /* 1007713 */     GIR_EraseRootFromParent_Done,
     /* 1007714 */   // Label 14993: @1007714
     /* 1007714 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1007791), // Rule ID 12796 //
     /* 1007719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007758 */     // MIs[0] policy
     /* 1007758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007790 */     // GIR_Coverage, 12796,
     /* 1007790 */     GIR_EraseRootFromParent_Done,
     /* 1007791 */   // Label 14994: @1007791
     /* 1007791 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1007868), // Rule ID 12797 //
     /* 1007796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007835 */     // MIs[0] policy
     /* 1007835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007845 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007867 */     // GIR_Coverage, 12797,
     /* 1007867 */     GIR_EraseRootFromParent_Done,
     /* 1007868 */   // Label 14995: @1007868
     /* 1007868 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1007945), // Rule ID 12800 //
     /* 1007873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007912 */     // MIs[0] policy
     /* 1007912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007922 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007944 */     // GIR_Coverage, 12800,
     /* 1007944 */     GIR_EraseRootFromParent_Done,
     /* 1007945 */   // Label 14996: @1007945
     /* 1007945 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1008022), // Rule ID 12801 //
     /* 1007950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007989 */     // MIs[0] policy
     /* 1007989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007999 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008021 */     // GIR_Coverage, 12801,
     /* 1008021 */     GIR_EraseRootFromParent_Done,
     /* 1008022 */   // Label 14997: @1008022
     /* 1008022 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1008099), // Rule ID 12804 //
     /* 1008027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1008047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008066 */     // MIs[0] policy
     /* 1008066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1008079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008098 */     // GIR_Coverage, 12804,
     /* 1008098 */     GIR_EraseRootFromParent_Done,
     /* 1008099 */   // Label 14998: @1008099
     /* 1008099 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1008176), // Rule ID 12805 //
     /* 1008104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1008121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1008124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008143 */     // MIs[0] policy
     /* 1008143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1008156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008175 */     // GIR_Coverage, 12805,
     /* 1008175 */     GIR_EraseRootFromParent_Done,
     /* 1008176 */   // Label 14999: @1008176
     /* 1008176 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1008253), // Rule ID 12808 //
     /* 1008181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1008201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008220 */     // MIs[0] policy
     /* 1008220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008230 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1008233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008252 */     // GIR_Coverage, 12808,
     /* 1008252 */     GIR_EraseRootFromParent_Done,
     /* 1008253 */   // Label 15000: @1008253
     /* 1008253 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1008330), // Rule ID 12809 //
     /* 1008258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1008275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1008278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008297 */     // MIs[0] policy
     /* 1008297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008307 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1008310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008329 */     // GIR_Coverage, 12809,
     /* 1008329 */     GIR_EraseRootFromParent_Done,
     /* 1008330 */   // Label 15001: @1008330
     /* 1008330 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1008407), // Rule ID 12812 //
     /* 1008335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1008355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008374 */     // MIs[0] policy
     /* 1008374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008406 */     // GIR_Coverage, 12812,
     /* 1008406 */     GIR_EraseRootFromParent_Done,
     /* 1008407 */   // Label 15002: @1008407
     /* 1008407 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1008484), // Rule ID 12813 //
     /* 1008412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1008429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1008432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008451 */     // MIs[0] policy
     /* 1008451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1008464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008483 */     // GIR_Coverage, 12813,
     /* 1008483 */     GIR_EraseRootFromParent_Done,
     /* 1008484 */   // Label 15003: @1008484
     /* 1008484 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1008561), // Rule ID 12816 //
     /* 1008489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008528 */     // MIs[0] policy
     /* 1008528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008560 */     // GIR_Coverage, 12816,
     /* 1008560 */     GIR_EraseRootFromParent_Done,
     /* 1008561 */   // Label 15004: @1008561
     /* 1008561 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1008638), // Rule ID 12817 //
     /* 1008566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008605 */     // MIs[0] policy
     /* 1008605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008615 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008637 */     // GIR_Coverage, 12817,
     /* 1008637 */     GIR_EraseRootFromParent_Done,
     /* 1008638 */   // Label 15005: @1008638
     /* 1008638 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1008715), // Rule ID 12820 //
     /* 1008643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008682 */     // MIs[0] policy
     /* 1008682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008692 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008714 */     // GIR_Coverage, 12820,
     /* 1008714 */     GIR_EraseRootFromParent_Done,
     /* 1008715 */   // Label 15006: @1008715
     /* 1008715 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1008792), // Rule ID 12821 //
     /* 1008720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008759 */     // MIs[0] policy
     /* 1008759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008791 */     // GIR_Coverage, 12821,
     /* 1008791 */     GIR_EraseRootFromParent_Done,
     /* 1008792 */   // Label 15007: @1008792
     /* 1008792 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1008869), // Rule ID 12824 //
     /* 1008797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008836 */     // MIs[0] policy
     /* 1008836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008846 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008868 */     // GIR_Coverage, 12824,
     /* 1008868 */     GIR_EraseRootFromParent_Done,
     /* 1008869 */   // Label 15008: @1008869
     /* 1008869 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1008946), // Rule ID 12825 //
     /* 1008874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008913 */     // MIs[0] policy
     /* 1008913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008923 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008945 */     // GIR_Coverage, 12825,
     /* 1008945 */     GIR_EraseRootFromParent_Done,
     /* 1008946 */   // Label 15009: @1008946
     /* 1008946 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1009023), // Rule ID 12828 //
     /* 1008951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008990 */     // MIs[0] policy
     /* 1008990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1009003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009022 */     // GIR_Coverage, 12828,
     /* 1009022 */     GIR_EraseRootFromParent_Done,
     /* 1009023 */   // Label 15010: @1009023
     /* 1009023 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1009100), // Rule ID 12829 //
     /* 1009028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1009048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009067 */     // MIs[0] policy
     /* 1009067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1009080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009099 */     // GIR_Coverage, 12829,
     /* 1009099 */     GIR_EraseRootFromParent_Done,
     /* 1009100 */   // Label 15011: @1009100
     /* 1009100 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1009177), // Rule ID 12832 //
     /* 1009105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009144 */     // MIs[0] policy
     /* 1009144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009176 */     // GIR_Coverage, 12832,
     /* 1009176 */     GIR_EraseRootFromParent_Done,
     /* 1009177 */   // Label 15012: @1009177
     /* 1009177 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1009254), // Rule ID 12833 //
     /* 1009182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009221 */     // MIs[0] policy
     /* 1009221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009231 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009253 */     // GIR_Coverage, 12833,
     /* 1009253 */     GIR_EraseRootFromParent_Done,
     /* 1009254 */   // Label 15013: @1009254
     /* 1009254 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1009331), // Rule ID 12836 //
     /* 1009259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009298 */     // MIs[0] policy
     /* 1009298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009330 */     // GIR_Coverage, 12836,
     /* 1009330 */     GIR_EraseRootFromParent_Done,
     /* 1009331 */   // Label 15014: @1009331
     /* 1009331 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1009408), // Rule ID 12837 //
     /* 1009336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009375 */     // MIs[0] policy
     /* 1009375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009385 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1009388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009407 */     // GIR_Coverage, 12837,
     /* 1009407 */     GIR_EraseRootFromParent_Done,
     /* 1009408 */   // Label 15015: @1009408
     /* 1009408 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1009485), // Rule ID 12840 //
     /* 1009413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009452 */     // MIs[0] policy
     /* 1009452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009484 */     // GIR_Coverage, 12840,
     /* 1009484 */     GIR_EraseRootFromParent_Done,
     /* 1009485 */   // Label 15016: @1009485
     /* 1009485 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1009562), // Rule ID 12841 //
     /* 1009490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009529 */     // MIs[0] policy
     /* 1009529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009539 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009561 */     // GIR_Coverage, 12841,
     /* 1009561 */     GIR_EraseRootFromParent_Done,
     /* 1009562 */   // Label 15017: @1009562
     /* 1009562 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1009639), // Rule ID 12844 //
     /* 1009567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009606 */     // MIs[0] policy
     /* 1009606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009638 */     // GIR_Coverage, 12844,
     /* 1009638 */     GIR_EraseRootFromParent_Done,
     /* 1009639 */   // Label 15018: @1009639
     /* 1009639 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1009716), // Rule ID 12845 //
     /* 1009644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009683 */     // MIs[0] policy
     /* 1009683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009715 */     // GIR_Coverage, 12845,
     /* 1009715 */     GIR_EraseRootFromParent_Done,
     /* 1009716 */   // Label 15019: @1009716
     /* 1009716 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1009793), // Rule ID 12848 //
     /* 1009721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009760 */     // MIs[0] policy
     /* 1009760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009792 */     // GIR_Coverage, 12848,
     /* 1009792 */     GIR_EraseRootFromParent_Done,
     /* 1009793 */   // Label 15020: @1009793
     /* 1009793 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1009870), // Rule ID 12849 //
     /* 1009798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009837 */     // MIs[0] policy
     /* 1009837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009847 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009869 */     // GIR_Coverage, 12849,
     /* 1009869 */     GIR_EraseRootFromParent_Done,
     /* 1009870 */   // Label 15021: @1009870
     /* 1009870 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1009947), // Rule ID 12852 //
     /* 1009875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009914 */     // MIs[0] policy
     /* 1009914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009946 */     // GIR_Coverage, 12852,
     /* 1009946 */     GIR_EraseRootFromParent_Done,
     /* 1009947 */   // Label 15022: @1009947
     /* 1009947 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1010024), // Rule ID 12853 //
     /* 1009952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009991 */     // MIs[0] policy
     /* 1009991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010001 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1010004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010023 */     // GIR_Coverage, 12853,
     /* 1010023 */     GIR_EraseRootFromParent_Done,
     /* 1010024 */   // Label 15023: @1010024
     /* 1010024 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1010101), // Rule ID 12856 //
     /* 1010029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010068 */     // MIs[0] policy
     /* 1010068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010078 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010100 */     // GIR_Coverage, 12856,
     /* 1010100 */     GIR_EraseRootFromParent_Done,
     /* 1010101 */   // Label 15024: @1010101
     /* 1010101 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1010178), // Rule ID 12857 //
     /* 1010106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010145 */     // MIs[0] policy
     /* 1010145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010177 */     // GIR_Coverage, 12857,
     /* 1010177 */     GIR_EraseRootFromParent_Done,
     /* 1010178 */   // Label 15025: @1010178
     /* 1010178 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1010255), // Rule ID 12860 //
     /* 1010183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010222 */     // MIs[0] policy
     /* 1010222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010254 */     // GIR_Coverage, 12860,
     /* 1010254 */     GIR_EraseRootFromParent_Done,
     /* 1010255 */   // Label 15026: @1010255
     /* 1010255 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1010332), // Rule ID 12861 //
     /* 1010260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010299 */     // MIs[0] policy
     /* 1010299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010309 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010331 */     // GIR_Coverage, 12861,
     /* 1010331 */     GIR_EraseRootFromParent_Done,
     /* 1010332 */   // Label 15027: @1010332
     /* 1010332 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1010409), // Rule ID 12864 //
     /* 1010337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010376 */     // MIs[0] policy
     /* 1010376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010408 */     // GIR_Coverage, 12864,
     /* 1010408 */     GIR_EraseRootFromParent_Done,
     /* 1010409 */   // Label 15028: @1010409
     /* 1010409 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1010486), // Rule ID 12865 //
     /* 1010414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010453 */     // MIs[0] policy
     /* 1010453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010463 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010485 */     // GIR_Coverage, 12865,
     /* 1010485 */     GIR_EraseRootFromParent_Done,
     /* 1010486 */   // Label 15029: @1010486
     /* 1010486 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1010563), // Rule ID 12868 //
     /* 1010491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010530 */     // MIs[0] policy
     /* 1010530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010562 */     // GIR_Coverage, 12868,
     /* 1010562 */     GIR_EraseRootFromParent_Done,
     /* 1010563 */   // Label 15030: @1010563
     /* 1010563 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1010640), // Rule ID 12869 //
     /* 1010568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010607 */     // MIs[0] policy
     /* 1010607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010639 */     // GIR_Coverage, 12869,
     /* 1010639 */     GIR_EraseRootFromParent_Done,
     /* 1010640 */   // Label 15031: @1010640
     /* 1010640 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1010717), // Rule ID 12872 //
     /* 1010645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010684 */     // MIs[0] policy
     /* 1010684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010716 */     // GIR_Coverage, 12872,
     /* 1010716 */     GIR_EraseRootFromParent_Done,
     /* 1010717 */   // Label 15032: @1010717
     /* 1010717 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1010794), // Rule ID 12873 //
     /* 1010722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010761 */     // MIs[0] policy
     /* 1010761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010793 */     // GIR_Coverage, 12873,
     /* 1010793 */     GIR_EraseRootFromParent_Done,
     /* 1010794 */   // Label 15033: @1010794
     /* 1010794 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1010871), // Rule ID 12876 //
     /* 1010799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010838 */     // MIs[0] policy
     /* 1010838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010848 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010870 */     // GIR_Coverage, 12876,
     /* 1010870 */     GIR_EraseRootFromParent_Done,
     /* 1010871 */   // Label 15034: @1010871
     /* 1010871 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1010948), // Rule ID 12877 //
     /* 1010876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010915 */     // MIs[0] policy
     /* 1010915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010925 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010947 */     // GIR_Coverage, 12877,
     /* 1010947 */     GIR_EraseRootFromParent_Done,
     /* 1010948 */   // Label 15035: @1010948
     /* 1010948 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1011025), // Rule ID 12880 //
     /* 1010953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010992 */     // MIs[0] policy
     /* 1010992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011024 */     // GIR_Coverage, 12880,
     /* 1011024 */     GIR_EraseRootFromParent_Done,
     /* 1011025 */   // Label 15036: @1011025
     /* 1011025 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1011102), // Rule ID 12881 //
     /* 1011030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1011050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011069 */     // MIs[0] policy
     /* 1011069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011101 */     // GIR_Coverage, 12881,
     /* 1011101 */     GIR_EraseRootFromParent_Done,
     /* 1011102 */   // Label 15037: @1011102
     /* 1011102 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1011179), // Rule ID 12884 //
     /* 1011107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011146 */     // MIs[0] policy
     /* 1011146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011156 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011178 */     // GIR_Coverage, 12884,
     /* 1011178 */     GIR_EraseRootFromParent_Done,
     /* 1011179 */   // Label 15038: @1011179
     /* 1011179 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1011256), // Rule ID 12885 //
     /* 1011184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011223 */     // MIs[0] policy
     /* 1011223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011233 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011255 */     // GIR_Coverage, 12885,
     /* 1011255 */     GIR_EraseRootFromParent_Done,
     /* 1011256 */   // Label 15039: @1011256
     /* 1011256 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1011333), // Rule ID 12888 //
     /* 1011261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011300 */     // MIs[0] policy
     /* 1011300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011332 */     // GIR_Coverage, 12888,
     /* 1011332 */     GIR_EraseRootFromParent_Done,
     /* 1011333 */   // Label 15040: @1011333
     /* 1011333 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1011410), // Rule ID 12889 //
     /* 1011338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011377 */     // MIs[0] policy
     /* 1011377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011387 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011409 */     // GIR_Coverage, 12889,
     /* 1011409 */     GIR_EraseRootFromParent_Done,
     /* 1011410 */   // Label 15041: @1011410
     /* 1011410 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1011487), // Rule ID 12892 //
     /* 1011415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011454 */     // MIs[0] policy
     /* 1011454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011486 */     // GIR_Coverage, 12892,
     /* 1011486 */     GIR_EraseRootFromParent_Done,
     /* 1011487 */   // Label 15042: @1011487
     /* 1011487 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1011564), // Rule ID 12893 //
     /* 1011492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011531 */     // MIs[0] policy
     /* 1011531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011563 */     // GIR_Coverage, 12893,
     /* 1011563 */     GIR_EraseRootFromParent_Done,
     /* 1011564 */   // Label 15043: @1011564
     /* 1011564 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1011641), // Rule ID 12896 //
     /* 1011569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011608 */     // MIs[0] policy
     /* 1011608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011640 */     // GIR_Coverage, 12896,
     /* 1011640 */     GIR_EraseRootFromParent_Done,
     /* 1011641 */   // Label 15044: @1011641
     /* 1011641 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1011718), // Rule ID 12897 //
     /* 1011646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011685 */     // MIs[0] policy
     /* 1011685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011695 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011717 */     // GIR_Coverage, 12897,
     /* 1011717 */     GIR_EraseRootFromParent_Done,
     /* 1011718 */   // Label 15045: @1011718
     /* 1011718 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1011795), // Rule ID 12900 //
     /* 1011723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011762 */     // MIs[0] policy
     /* 1011762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011794 */     // GIR_Coverage, 12900,
     /* 1011794 */     GIR_EraseRootFromParent_Done,
     /* 1011795 */   // Label 15046: @1011795
     /* 1011795 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1011872), // Rule ID 12901 //
     /* 1011800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011839 */     // MIs[0] policy
     /* 1011839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011849 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011871 */     // GIR_Coverage, 12901,
     /* 1011871 */     GIR_EraseRootFromParent_Done,
     /* 1011872 */   // Label 15047: @1011872
     /* 1011872 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1011949), // Rule ID 12904 //
     /* 1011877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011916 */     // MIs[0] policy
     /* 1011916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011926 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011948 */     // GIR_Coverage, 12904,
     /* 1011948 */     GIR_EraseRootFromParent_Done,
     /* 1011949 */   // Label 15048: @1011949
     /* 1011949 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1012026), // Rule ID 12905 //
     /* 1011954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011993 */     // MIs[0] policy
     /* 1011993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012003 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1012006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012025 */     // GIR_Coverage, 12905,
     /* 1012025 */     GIR_EraseRootFromParent_Done,
     /* 1012026 */   // Label 15049: @1012026
     /* 1012026 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1012103), // Rule ID 12908 //
     /* 1012031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1012048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012070 */     // MIs[0] policy
     /* 1012070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012102 */     // GIR_Coverage, 12908,
     /* 1012102 */     GIR_EraseRootFromParent_Done,
     /* 1012103 */   // Label 15050: @1012103
     /* 1012103 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1012180), // Rule ID 12909 //
     /* 1012108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1012125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012147 */     // MIs[0] policy
     /* 1012147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012157 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012179 */     // GIR_Coverage, 12909,
     /* 1012179 */     GIR_EraseRootFromParent_Done,
     /* 1012180 */   // Label 15051: @1012180
     /* 1012180 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1012257), // Rule ID 12912 //
     /* 1012185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1012202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012224 */     // MIs[0] policy
     /* 1012224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012256 */     // GIR_Coverage, 12912,
     /* 1012256 */     GIR_EraseRootFromParent_Done,
     /* 1012257 */   // Label 15052: @1012257
     /* 1012257 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1012334), // Rule ID 12913 //
     /* 1012262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1012279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012301 */     // MIs[0] policy
     /* 1012301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012311 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012333 */     // GIR_Coverage, 12913,
     /* 1012333 */     GIR_EraseRootFromParent_Done,
     /* 1012334 */   // Label 15053: @1012334
     /* 1012334 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1012411), // Rule ID 12916 //
     /* 1012339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1012356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012378 */     // MIs[0] policy
     /* 1012378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012410 */     // GIR_Coverage, 12916,
     /* 1012410 */     GIR_EraseRootFromParent_Done,
     /* 1012411 */   // Label 15054: @1012411
     /* 1012411 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1012488), // Rule ID 12917 //
     /* 1012416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1012433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012455 */     // MIs[0] policy
     /* 1012455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012487 */     // GIR_Coverage, 12917,
     /* 1012487 */     GIR_EraseRootFromParent_Done,
     /* 1012488 */   // Label 15055: @1012488
     /* 1012488 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1012565), // Rule ID 12920 //
     /* 1012493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012532 */     // MIs[0] policy
     /* 1012532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012564 */     // GIR_Coverage, 12920,
     /* 1012564 */     GIR_EraseRootFromParent_Done,
     /* 1012565 */   // Label 15056: @1012565
     /* 1012565 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1012642), // Rule ID 12921 //
     /* 1012570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012609 */     // MIs[0] policy
     /* 1012609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012641 */     // GIR_Coverage, 12921,
     /* 1012641 */     GIR_EraseRootFromParent_Done,
     /* 1012642 */   // Label 15057: @1012642
     /* 1012642 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1012719), // Rule ID 12924 //
     /* 1012647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012686 */     // MIs[0] policy
     /* 1012686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012718 */     // GIR_Coverage, 12924,
     /* 1012718 */     GIR_EraseRootFromParent_Done,
     /* 1012719 */   // Label 15058: @1012719
     /* 1012719 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1012796), // Rule ID 12925 //
     /* 1012724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012763 */     // MIs[0] policy
     /* 1012763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012773 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012795 */     // GIR_Coverage, 12925,
     /* 1012795 */     GIR_EraseRootFromParent_Done,
     /* 1012796 */   // Label 15059: @1012796
     /* 1012796 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1012873), // Rule ID 12928 //
     /* 1012801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012840 */     // MIs[0] policy
     /* 1012840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012872 */     // GIR_Coverage, 12928,
     /* 1012872 */     GIR_EraseRootFromParent_Done,
     /* 1012873 */   // Label 15060: @1012873
     /* 1012873 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1012950), // Rule ID 12929 //
     /* 1012878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012917 */     // MIs[0] policy
     /* 1012917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012949 */     // GIR_Coverage, 12929,
     /* 1012949 */     GIR_EraseRootFromParent_Done,
     /* 1012950 */   // Label 15061: @1012950
     /* 1012950 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1013027), // Rule ID 12932 //
     /* 1012955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012994 */     // MIs[0] policy
     /* 1012994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013026 */     // GIR_Coverage, 12932,
     /* 1013026 */     GIR_EraseRootFromParent_Done,
     /* 1013027 */   // Label 15062: @1013027
     /* 1013027 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1013104), // Rule ID 12933 //
     /* 1013032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1013043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1013046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1013049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1013052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013071 */     // MIs[0] policy
     /* 1013071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013103 */     // GIR_Coverage, 12933,
     /* 1013103 */     GIR_EraseRootFromParent_Done,
     /* 1013104 */   // Label 15063: @1013104
     /* 1013104 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1013181), // Rule ID 12936 //
     /* 1013109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013148 */     // MIs[0] policy
     /* 1013148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013180 */     // GIR_Coverage, 12936,
     /* 1013180 */     GIR_EraseRootFromParent_Done,
     /* 1013181 */   // Label 15064: @1013181
     /* 1013181 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1013258), // Rule ID 12937 //
     /* 1013186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1013203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013225 */     // MIs[0] policy
     /* 1013225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013235 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013257 */     // GIR_Coverage, 12937,
     /* 1013257 */     GIR_EraseRootFromParent_Done,
     /* 1013258 */   // Label 15065: @1013258
     /* 1013258 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1013335), // Rule ID 12940 //
     /* 1013263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1013280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013302 */     // MIs[0] policy
     /* 1013302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013334 */     // GIR_Coverage, 12940,
     /* 1013334 */     GIR_EraseRootFromParent_Done,
     /* 1013335 */   // Label 15066: @1013335
     /* 1013335 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1013412), // Rule ID 12941 //
     /* 1013340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1013343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1013357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013379 */     // MIs[0] policy
     /* 1013379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013389 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1013392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013411 */     // GIR_Coverage, 12941,
     /* 1013411 */     GIR_EraseRootFromParent_Done,
     /* 1013412 */   // Label 15067: @1013412
     /* 1013412 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1013489), // Rule ID 12944 //
     /* 1013417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013456 */     // MIs[0] policy
     /* 1013456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013488 */     // GIR_Coverage, 12944,
     /* 1013488 */     GIR_EraseRootFromParent_Done,
     /* 1013489 */   // Label 15068: @1013489
     /* 1013489 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1013566), // Rule ID 12945 //
     /* 1013494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013533 */     // MIs[0] policy
     /* 1013533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013565 */     // GIR_Coverage, 12945,
     /* 1013565 */     GIR_EraseRootFromParent_Done,
     /* 1013566 */   // Label 15069: @1013566
     /* 1013566 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1013643), // Rule ID 12948 //
     /* 1013571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013610 */     // MIs[0] policy
     /* 1013610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013642 */     // GIR_Coverage, 12948,
     /* 1013642 */     GIR_EraseRootFromParent_Done,
     /* 1013643 */   // Label 15070: @1013643
     /* 1013643 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1013720), // Rule ID 12949 //
     /* 1013648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013687 */     // MIs[0] policy
     /* 1013687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013697 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013719 */     // GIR_Coverage, 12949,
     /* 1013719 */     GIR_EraseRootFromParent_Done,
     /* 1013720 */   // Label 15071: @1013720
     /* 1013720 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1013797), // Rule ID 12952 //
     /* 1013725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013764 */     // MIs[0] policy
     /* 1013764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013774 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013796 */     // GIR_Coverage, 12952,
     /* 1013796 */     GIR_EraseRootFromParent_Done,
     /* 1013797 */   // Label 15072: @1013797
     /* 1013797 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1013874), // Rule ID 12953 //
     /* 1013802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013841 */     // MIs[0] policy
     /* 1013841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013851 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013873 */     // GIR_Coverage, 12953,
     /* 1013873 */     GIR_EraseRootFromParent_Done,
     /* 1013874 */   // Label 15073: @1013874
     /* 1013874 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1013951), // Rule ID 12956 //
     /* 1013879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013918 */     // MIs[0] policy
     /* 1013918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013950 */     // GIR_Coverage, 12956,
     /* 1013950 */     GIR_EraseRootFromParent_Done,
     /* 1013951 */   // Label 15074: @1013951
     /* 1013951 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1014028), // Rule ID 12957 //
     /* 1013956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013995 */     // MIs[0] policy
     /* 1013995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014027 */     // GIR_Coverage, 12957,
     /* 1014027 */     GIR_EraseRootFromParent_Done,
     /* 1014028 */   // Label 15075: @1014028
     /* 1014028 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1014105), // Rule ID 12960 //
     /* 1014033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1014050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014072 */     // MIs[0] policy
     /* 1014072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014104 */     // GIR_Coverage, 12960,
     /* 1014104 */     GIR_EraseRootFromParent_Done,
     /* 1014105 */   // Label 15076: @1014105
     /* 1014105 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1014182), // Rule ID 12961 //
     /* 1014110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1014127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014149 */     // MIs[0] policy
     /* 1014149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014181 */     // GIR_Coverage, 12961,
     /* 1014181 */     GIR_EraseRootFromParent_Done,
     /* 1014182 */   // Label 15077: @1014182
     /* 1014182 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1014259), // Rule ID 12964 //
     /* 1014187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1014204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014226 */     // MIs[0] policy
     /* 1014226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014258 */     // GIR_Coverage, 12964,
     /* 1014258 */     GIR_EraseRootFromParent_Done,
     /* 1014259 */   // Label 15078: @1014259
     /* 1014259 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1014336), // Rule ID 12965 //
     /* 1014264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1014281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014303 */     // MIs[0] policy
     /* 1014303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014313 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014335 */     // GIR_Coverage, 12965,
     /* 1014335 */     GIR_EraseRootFromParent_Done,
     /* 1014336 */   // Label 15079: @1014336
     /* 1014336 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1014413), // Rule ID 12968 //
     /* 1014341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014380 */     // MIs[0] policy
     /* 1014380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014412 */     // GIR_Coverage, 12968,
     /* 1014412 */     GIR_EraseRootFromParent_Done,
     /* 1014413 */   // Label 15080: @1014413
     /* 1014413 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1014490), // Rule ID 12969 //
     /* 1014418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1014435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014457 */     // MIs[0] policy
     /* 1014457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014489 */     // GIR_Coverage, 12969,
     /* 1014489 */     GIR_EraseRootFromParent_Done,
     /* 1014490 */   // Label 15081: @1014490
     /* 1014490 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1014567), // Rule ID 12972 //
     /* 1014495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014534 */     // MIs[0] policy
     /* 1014534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014566 */     // GIR_Coverage, 12972,
     /* 1014566 */     GIR_EraseRootFromParent_Done,
     /* 1014567 */   // Label 15082: @1014567
     /* 1014567 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1014644), // Rule ID 12973 //
     /* 1014572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014611 */     // MIs[0] policy
     /* 1014611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014643 */     // GIR_Coverage, 12973,
     /* 1014643 */     GIR_EraseRootFromParent_Done,
     /* 1014644 */   // Label 15083: @1014644
     /* 1014644 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1014721), // Rule ID 12976 //
     /* 1014649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014688 */     // MIs[0] policy
     /* 1014688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014720 */     // GIR_Coverage, 12976,
     /* 1014720 */     GIR_EraseRootFromParent_Done,
     /* 1014721 */   // Label 15084: @1014721
     /* 1014721 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1014798), // Rule ID 12977 //
     /* 1014726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014765 */     // MIs[0] policy
     /* 1014765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014775 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014797 */     // GIR_Coverage, 12977,
     /* 1014797 */     GIR_EraseRootFromParent_Done,
     /* 1014798 */   // Label 15085: @1014798
     /* 1014798 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1014875), // Rule ID 12980 //
     /* 1014803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014842 */     // MIs[0] policy
     /* 1014842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014874 */     // GIR_Coverage, 12980,
     /* 1014874 */     GIR_EraseRootFromParent_Done,
     /* 1014875 */   // Label 15086: @1014875
     /* 1014875 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1014952), // Rule ID 12981 //
     /* 1014880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014919 */     // MIs[0] policy
     /* 1014919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014951 */     // GIR_Coverage, 12981,
     /* 1014951 */     GIR_EraseRootFromParent_Done,
     /* 1014952 */   // Label 15087: @1014952
     /* 1014952 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1015029), // Rule ID 12984 //
     /* 1014957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014996 */     // MIs[0] policy
     /* 1014996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1015009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015028 */     // GIR_Coverage, 12984,
     /* 1015028 */     GIR_EraseRootFromParent_Done,
     /* 1015029 */   // Label 15088: @1015029
     /* 1015029 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1015106), // Rule ID 12985 //
     /* 1015034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1015045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1015048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1015051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1015054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015073 */     // MIs[0] policy
     /* 1015073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015083 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1015086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015105 */     // GIR_Coverage, 12985,
     /* 1015105 */     GIR_EraseRootFromParent_Done,
     /* 1015106 */   // Label 15089: @1015106
     /* 1015106 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1015183), // Rule ID 12988 //
     /* 1015111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1015114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1015128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015150 */     // MIs[0] policy
     /* 1015150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015160 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1015163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015182 */     // GIR_Coverage, 12988,
     /* 1015182 */     GIR_EraseRootFromParent_Done,
     /* 1015183 */   // Label 15090: @1015183
     /* 1015183 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1015260), // Rule ID 12989 //
     /* 1015188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1015205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015227 */     // MIs[0] policy
     /* 1015227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015237 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1015240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015259 */     // GIR_Coverage, 12989,
     /* 1015259 */     GIR_EraseRootFromParent_Done,
     /* 1015260 */   // Label 15091: @1015260
     /* 1015260 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1015337), // Rule ID 12992 //
     /* 1015265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015304 */     // MIs[0] policy
     /* 1015304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015314 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1015317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015336 */     // GIR_Coverage, 12992,
     /* 1015336 */     GIR_EraseRootFromParent_Done,
     /* 1015337 */   // Label 15092: @1015337
     /* 1015337 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1015414), // Rule ID 12993 //
     /* 1015342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015381 */     // MIs[0] policy
     /* 1015381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015391 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1015394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015413 */     // GIR_Coverage, 12993,
     /* 1015413 */     GIR_EraseRootFromParent_Done,
     /* 1015414 */   // Label 15093: @1015414
     /* 1015414 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1015491), // Rule ID 12996 //
     /* 1015419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015458 */     // MIs[0] policy
     /* 1015458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015490 */     // GIR_Coverage, 12996,
     /* 1015490 */     GIR_EraseRootFromParent_Done,
     /* 1015491 */   // Label 15094: @1015491
     /* 1015491 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1015568), // Rule ID 12997 //
     /* 1015496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015535 */     // MIs[0] policy
     /* 1015535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015545 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015567 */     // GIR_Coverage, 12997,
     /* 1015567 */     GIR_EraseRootFromParent_Done,
     /* 1015568 */   // Label 15095: @1015568
     /* 1015568 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1015645), // Rule ID 13000 //
     /* 1015573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015612 */     // MIs[0] policy
     /* 1015612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015622 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015644 */     // GIR_Coverage, 13000,
     /* 1015644 */     GIR_EraseRootFromParent_Done,
     /* 1015645 */   // Label 15096: @1015645
     /* 1015645 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1015722), // Rule ID 13001 //
     /* 1015650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015689 */     // MIs[0] policy
     /* 1015689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015699 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015721 */     // GIR_Coverage, 13001,
     /* 1015721 */     GIR_EraseRootFromParent_Done,
     /* 1015722 */   // Label 15097: @1015722
     /* 1015722 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1015799), // Rule ID 13004 //
     /* 1015727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015766 */     // MIs[0] policy
     /* 1015766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015798 */     // GIR_Coverage, 13004,
     /* 1015798 */     GIR_EraseRootFromParent_Done,
     /* 1015799 */   // Label 15098: @1015799
     /* 1015799 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1015876), // Rule ID 13005 //
     /* 1015804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015843 */     // MIs[0] policy
     /* 1015843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015853 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015875 */     // GIR_Coverage, 13005,
     /* 1015875 */     GIR_EraseRootFromParent_Done,
     /* 1015876 */   // Label 15099: @1015876
     /* 1015876 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1015953), // Rule ID 13008 //
     /* 1015881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015920 */     // MIs[0] policy
     /* 1015920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015952 */     // GIR_Coverage, 13008,
     /* 1015952 */     GIR_EraseRootFromParent_Done,
     /* 1015953 */   // Label 15100: @1015953
     /* 1015953 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1016030), // Rule ID 13009 //
     /* 1015958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015997 */     // MIs[0] policy
     /* 1015997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016007 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016029 */     // GIR_Coverage, 13009,
     /* 1016029 */     GIR_EraseRootFromParent_Done,
     /* 1016030 */   // Label 15101: @1016030
     /* 1016030 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1016107), // Rule ID 13012 //
     /* 1016035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016074 */     // MIs[0] policy
     /* 1016074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016106 */     // GIR_Coverage, 13012,
     /* 1016106 */     GIR_EraseRootFromParent_Done,
     /* 1016107 */   // Label 15102: @1016107
     /* 1016107 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1016184), // Rule ID 13013 //
     /* 1016112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016151 */     // MIs[0] policy
     /* 1016151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1016164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016183 */     // GIR_Coverage, 13013,
     /* 1016183 */     GIR_EraseRootFromParent_Done,
     /* 1016184 */   // Label 15103: @1016184
     /* 1016184 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1016261), // Rule ID 13016 //
     /* 1016189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016228 */     // MIs[0] policy
     /* 1016228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016260 */     // GIR_Coverage, 13016,
     /* 1016260 */     GIR_EraseRootFromParent_Done,
     /* 1016261 */   // Label 15104: @1016261
     /* 1016261 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1016338), // Rule ID 13017 //
     /* 1016266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016305 */     // MIs[0] policy
     /* 1016305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016337 */     // GIR_Coverage, 13017,
     /* 1016337 */     GIR_EraseRootFromParent_Done,
     /* 1016338 */   // Label 15105: @1016338
     /* 1016338 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1016415), // Rule ID 13020 //
     /* 1016343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016382 */     // MIs[0] policy
     /* 1016382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016414 */     // GIR_Coverage, 13020,
     /* 1016414 */     GIR_EraseRootFromParent_Done,
     /* 1016415 */   // Label 15106: @1016415
     /* 1016415 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1016492), // Rule ID 13021 //
     /* 1016420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016459 */     // MIs[0] policy
     /* 1016459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016491 */     // GIR_Coverage, 13021,
     /* 1016491 */     GIR_EraseRootFromParent_Done,
     /* 1016492 */   // Label 15107: @1016492
     /* 1016492 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1016569), // Rule ID 13024 //
     /* 1016497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016536 */     // MIs[0] policy
     /* 1016536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016568 */     // GIR_Coverage, 13024,
     /* 1016568 */     GIR_EraseRootFromParent_Done,
     /* 1016569 */   // Label 15108: @1016569
     /* 1016569 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1016646), // Rule ID 13025 //
     /* 1016574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016613 */     // MIs[0] policy
     /* 1016613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016623 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016645 */     // GIR_Coverage, 13025,
     /* 1016645 */     GIR_EraseRootFromParent_Done,
     /* 1016646 */   // Label 15109: @1016646
     /* 1016646 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1016723), // Rule ID 13028 //
     /* 1016651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016690 */     // MIs[0] policy
     /* 1016690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016722 */     // GIR_Coverage, 13028,
     /* 1016722 */     GIR_EraseRootFromParent_Done,
     /* 1016723 */   // Label 15110: @1016723
     /* 1016723 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1016800), // Rule ID 13029 //
     /* 1016728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016767 */     // MIs[0] policy
     /* 1016767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016799 */     // GIR_Coverage, 13029,
     /* 1016799 */     GIR_EraseRootFromParent_Done,
     /* 1016800 */   // Label 15111: @1016800
     /* 1016800 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1016877), // Rule ID 13032 //
     /* 1016805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016844 */     // MIs[0] policy
     /* 1016844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016876 */     // GIR_Coverage, 13032,
     /* 1016876 */     GIR_EraseRootFromParent_Done,
     /* 1016877 */   // Label 15112: @1016877
     /* 1016877 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1016954), // Rule ID 13033 //
     /* 1016882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016921 */     // MIs[0] policy
     /* 1016921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016931 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016953 */     // GIR_Coverage, 13033,
     /* 1016953 */     GIR_EraseRootFromParent_Done,
     /* 1016954 */   // Label 15113: @1016954
     /* 1016954 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1017031), // Rule ID 13036 //
     /* 1016959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016998 */     // MIs[0] policy
     /* 1016998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017030 */     // GIR_Coverage, 13036,
     /* 1017030 */     GIR_EraseRootFromParent_Done,
     /* 1017031 */   // Label 15114: @1017031
     /* 1017031 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1017108), // Rule ID 13037 //
     /* 1017036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1017047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1017050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1017056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017075 */     // MIs[0] policy
     /* 1017075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017085 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017107 */     // GIR_Coverage, 13037,
     /* 1017107 */     GIR_EraseRootFromParent_Done,
     /* 1017108 */   // Label 15115: @1017108
     /* 1017108 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1017185), // Rule ID 13040 //
     /* 1017113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017152 */     // MIs[0] policy
     /* 1017152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017184 */     // GIR_Coverage, 13040,
     /* 1017184 */     GIR_EraseRootFromParent_Done,
     /* 1017185 */   // Label 15116: @1017185
     /* 1017185 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1017262), // Rule ID 13041 //
     /* 1017190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017229 */     // MIs[0] policy
     /* 1017229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017261 */     // GIR_Coverage, 13041,
     /* 1017261 */     GIR_EraseRootFromParent_Done,
     /* 1017262 */   // Label 15117: @1017262
     /* 1017262 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1017339), // Rule ID 13044 //
     /* 1017267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017306 */     // MIs[0] policy
     /* 1017306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017338 */     // GIR_Coverage, 13044,
     /* 1017338 */     GIR_EraseRootFromParent_Done,
     /* 1017339 */   // Label 15118: @1017339
     /* 1017339 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1017416), // Rule ID 13045 //
     /* 1017344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017383 */     // MIs[0] policy
     /* 1017383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017415 */     // GIR_Coverage, 13045,
     /* 1017415 */     GIR_EraseRootFromParent_Done,
     /* 1017416 */   // Label 15119: @1017416
     /* 1017416 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1017493), // Rule ID 13048 //
     /* 1017421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017460 */     // MIs[0] policy
     /* 1017460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017492 */     // GIR_Coverage, 13048,
     /* 1017492 */     GIR_EraseRootFromParent_Done,
     /* 1017493 */   // Label 15120: @1017493
     /* 1017493 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1017570), // Rule ID 13049 //
     /* 1017498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017537 */     // MIs[0] policy
     /* 1017537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017547 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017569 */     // GIR_Coverage, 13049,
     /* 1017569 */     GIR_EraseRootFromParent_Done,
     /* 1017570 */   // Label 15121: @1017570
     /* 1017570 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1017647), // Rule ID 13052 //
     /* 1017575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017614 */     // MIs[0] policy
     /* 1017614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017646 */     // GIR_Coverage, 13052,
     /* 1017646 */     GIR_EraseRootFromParent_Done,
     /* 1017647 */   // Label 15122: @1017647
     /* 1017647 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1017724), // Rule ID 13053 //
     /* 1017652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017691 */     // MIs[0] policy
     /* 1017691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017701 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017723 */     // GIR_Coverage, 13053,
     /* 1017723 */     GIR_EraseRootFromParent_Done,
     /* 1017724 */   // Label 15123: @1017724
     /* 1017724 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1017801), // Rule ID 13056 //
     /* 1017729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017768 */     // MIs[0] policy
     /* 1017768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017800 */     // GIR_Coverage, 13056,
     /* 1017800 */     GIR_EraseRootFromParent_Done,
     /* 1017801 */   // Label 15124: @1017801
     /* 1017801 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1017878), // Rule ID 13057 //
     /* 1017806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017845 */     // MIs[0] policy
     /* 1017845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017855 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017877 */     // GIR_Coverage, 13057,
     /* 1017877 */     GIR_EraseRootFromParent_Done,
     /* 1017878 */   // Label 15125: @1017878
     /* 1017878 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1017955), // Rule ID 13060 //
     /* 1017883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017922 */     // MIs[0] policy
     /* 1017922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017954 */     // GIR_Coverage, 13060,
     /* 1017954 */     GIR_EraseRootFromParent_Done,
     /* 1017955 */   // Label 15126: @1017955
     /* 1017955 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1018032), // Rule ID 13061 //
     /* 1017960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017999 */     // MIs[0] policy
     /* 1017999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018031 */     // GIR_Coverage, 13061,
     /* 1018031 */     GIR_EraseRootFromParent_Done,
     /* 1018032 */   // Label 15127: @1018032
     /* 1018032 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1018109), // Rule ID 13064 //
     /* 1018037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018076 */     // MIs[0] policy
     /* 1018076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018108 */     // GIR_Coverage, 13064,
     /* 1018108 */     GIR_EraseRootFromParent_Done,
     /* 1018109 */   // Label 15128: @1018109
     /* 1018109 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1018186), // Rule ID 13065 //
     /* 1018114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018153 */     // MIs[0] policy
     /* 1018153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018185 */     // GIR_Coverage, 13065,
     /* 1018185 */     GIR_EraseRootFromParent_Done,
     /* 1018186 */   // Label 15129: @1018186
     /* 1018186 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1018263), // Rule ID 13068 //
     /* 1018191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018230 */     // MIs[0] policy
     /* 1018230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1018243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018262 */     // GIR_Coverage, 13068,
     /* 1018262 */     GIR_EraseRootFromParent_Done,
     /* 1018263 */   // Label 15130: @1018263
     /* 1018263 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1018340), // Rule ID 13069 //
     /* 1018268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018307 */     // MIs[0] policy
     /* 1018307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1018320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018339 */     // GIR_Coverage, 13069,
     /* 1018339 */     GIR_EraseRootFromParent_Done,
     /* 1018340 */   // Label 15131: @1018340
     /* 1018340 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1018417), // Rule ID 13072 //
     /* 1018345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018384 */     // MIs[0] policy
     /* 1018384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018416 */     // GIR_Coverage, 13072,
     /* 1018416 */     GIR_EraseRootFromParent_Done,
     /* 1018417 */   // Label 15132: @1018417
     /* 1018417 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1018494), // Rule ID 13073 //
     /* 1018422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018461 */     // MIs[0] policy
     /* 1018461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018493 */     // GIR_Coverage, 13073,
     /* 1018493 */     GIR_EraseRootFromParent_Done,
     /* 1018494 */   // Label 15133: @1018494
     /* 1018494 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1018571), // Rule ID 13076 //
     /* 1018499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018538 */     // MIs[0] policy
     /* 1018538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018548 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018570 */     // GIR_Coverage, 13076,
     /* 1018570 */     GIR_EraseRootFromParent_Done,
     /* 1018571 */   // Label 15134: @1018571
     /* 1018571 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1018648), // Rule ID 13077 //
     /* 1018576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018615 */     // MIs[0] policy
     /* 1018615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018625 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018647 */     // GIR_Coverage, 13077,
     /* 1018647 */     GIR_EraseRootFromParent_Done,
     /* 1018648 */   // Label 15135: @1018648
     /* 1018648 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1018725), // Rule ID 13080 //
     /* 1018653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018692 */     // MIs[0] policy
     /* 1018692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018724 */     // GIR_Coverage, 13080,
     /* 1018724 */     GIR_EraseRootFromParent_Done,
     /* 1018725 */   // Label 15136: @1018725
     /* 1018725 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1018802), // Rule ID 13081 //
     /* 1018730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018769 */     // MIs[0] policy
     /* 1018769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018779 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018801 */     // GIR_Coverage, 13081,
     /* 1018801 */     GIR_EraseRootFromParent_Done,
     /* 1018802 */   // Label 15137: @1018802
     /* 1018802 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1018879), // Rule ID 13084 //
     /* 1018807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018846 */     // MIs[0] policy
     /* 1018846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018878 */     // GIR_Coverage, 13084,
     /* 1018878 */     GIR_EraseRootFromParent_Done,
     /* 1018879 */   // Label 15138: @1018879
     /* 1018879 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1018956), // Rule ID 13085 //
     /* 1018884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018923 */     // MIs[0] policy
     /* 1018923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018933 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018955 */     // GIR_Coverage, 13085,
     /* 1018955 */     GIR_EraseRootFromParent_Done,
     /* 1018956 */   // Label 15139: @1018956
     /* 1018956 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1019033), // Rule ID 13088 //
     /* 1018961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019000 */     // MIs[0] policy
     /* 1019000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019032 */     // GIR_Coverage, 13088,
     /* 1019032 */     GIR_EraseRootFromParent_Done,
     /* 1019033 */   // Label 15140: @1019033
     /* 1019033 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1019110), // Rule ID 13089 //
     /* 1019038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1019049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1019052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1019055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019077 */     // MIs[0] policy
     /* 1019077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019087 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019109 */     // GIR_Coverage, 13089,
     /* 1019109 */     GIR_EraseRootFromParent_Done,
     /* 1019110 */   // Label 15141: @1019110
     /* 1019110 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1019187), // Rule ID 13092 //
     /* 1019115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1019132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019154 */     // MIs[0] policy
     /* 1019154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1019167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019186 */     // GIR_Coverage, 13092,
     /* 1019186 */     GIR_EraseRootFromParent_Done,
     /* 1019187 */   // Label 15142: @1019187
     /* 1019187 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1019264), // Rule ID 13093 //
     /* 1019192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1019209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019231 */     // MIs[0] policy
     /* 1019231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1019244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019263 */     // GIR_Coverage, 13093,
     /* 1019263 */     GIR_EraseRootFromParent_Done,
     /* 1019264 */   // Label 15143: @1019264
     /* 1019264 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1019341), // Rule ID 13096 //
     /* 1019269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1019286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019308 */     // MIs[0] policy
     /* 1019308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019340 */     // GIR_Coverage, 13096,
     /* 1019340 */     GIR_EraseRootFromParent_Done,
     /* 1019341 */   // Label 15144: @1019341
     /* 1019341 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1019418), // Rule ID 13097 //
     /* 1019346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1019363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019385 */     // MIs[0] policy
     /* 1019385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019395 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019417 */     // GIR_Coverage, 13097,
     /* 1019417 */     GIR_EraseRootFromParent_Done,
     /* 1019418 */   // Label 15145: @1019418
     /* 1019418 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1019495), // Rule ID 13100 //
     /* 1019423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019462 */     // MIs[0] policy
     /* 1019462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019494 */     // GIR_Coverage, 13100,
     /* 1019494 */     GIR_EraseRootFromParent_Done,
     /* 1019495 */   // Label 15146: @1019495
     /* 1019495 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1019572), // Rule ID 13101 //
     /* 1019500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019539 */     // MIs[0] policy
     /* 1019539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019549 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019571 */     // GIR_Coverage, 13101,
     /* 1019571 */     GIR_EraseRootFromParent_Done,
     /* 1019572 */   // Label 15147: @1019572
     /* 1019572 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1019649), // Rule ID 13104 //
     /* 1019577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019616 */     // MIs[0] policy
     /* 1019616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019648 */     // GIR_Coverage, 13104,
     /* 1019648 */     GIR_EraseRootFromParent_Done,
     /* 1019649 */   // Label 15148: @1019649
     /* 1019649 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1019726), // Rule ID 13105 //
     /* 1019654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019693 */     // MIs[0] policy
     /* 1019693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019703 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019725 */     // GIR_Coverage, 13105,
     /* 1019725 */     GIR_EraseRootFromParent_Done,
     /* 1019726 */   // Label 15149: @1019726
     /* 1019726 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1019803), // Rule ID 13108 //
     /* 1019731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019770 */     // MIs[0] policy
     /* 1019770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019802 */     // GIR_Coverage, 13108,
     /* 1019802 */     GIR_EraseRootFromParent_Done,
     /* 1019803 */   // Label 15150: @1019803
     /* 1019803 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1019880), // Rule ID 13109 //
     /* 1019808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019847 */     // MIs[0] policy
     /* 1019847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019879 */     // GIR_Coverage, 13109,
     /* 1019879 */     GIR_EraseRootFromParent_Done,
     /* 1019880 */   // Label 15151: @1019880
     /* 1019880 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1019957), // Rule ID 13112 //
     /* 1019885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019924 */     // MIs[0] policy
     /* 1019924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019956 */     // GIR_Coverage, 13112,
     /* 1019956 */     GIR_EraseRootFromParent_Done,
     /* 1019957 */   // Label 15152: @1019957
     /* 1019957 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1020034), // Rule ID 13113 //
     /* 1019962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020001 */     // MIs[0] policy
     /* 1020001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020011 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020033 */     // GIR_Coverage, 13113,
     /* 1020033 */     GIR_EraseRootFromParent_Done,
     /* 1020034 */   // Label 15153: @1020034
     /* 1020034 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1020111), // Rule ID 13116 //
     /* 1020039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1020056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020078 */     // MIs[0] policy
     /* 1020078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020110 */     // GIR_Coverage, 13116,
     /* 1020110 */     GIR_EraseRootFromParent_Done,
     /* 1020111 */   // Label 15154: @1020111
     /* 1020111 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1020188), // Rule ID 13117 //
     /* 1020116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1020133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020155 */     // MIs[0] policy
     /* 1020155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020165 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1020168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020187 */     // GIR_Coverage, 13117,
     /* 1020187 */     GIR_EraseRootFromParent_Done,
     /* 1020188 */   // Label 15155: @1020188
     /* 1020188 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1020265), // Rule ID 13120 //
     /* 1020193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1020210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020232 */     // MIs[0] policy
     /* 1020232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020264 */     // GIR_Coverage, 13120,
     /* 1020264 */     GIR_EraseRootFromParent_Done,
     /* 1020265 */   // Label 15156: @1020265
     /* 1020265 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1020342), // Rule ID 13121 //
     /* 1020270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1020287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020309 */     // MIs[0] policy
     /* 1020309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020341 */     // GIR_Coverage, 13121,
     /* 1020341 */     GIR_EraseRootFromParent_Done,
     /* 1020342 */   // Label 15157: @1020342
     /* 1020342 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1020419), // Rule ID 13124 //
     /* 1020347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1020364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020386 */     // MIs[0] policy
     /* 1020386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020418 */     // GIR_Coverage, 13124,
     /* 1020418 */     GIR_EraseRootFromParent_Done,
     /* 1020419 */   // Label 15158: @1020419
     /* 1020419 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1020496), // Rule ID 13125 //
     /* 1020424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1020441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020463 */     // MIs[0] policy
     /* 1020463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020495 */     // GIR_Coverage, 13125,
     /* 1020495 */     GIR_EraseRootFromParent_Done,
     /* 1020496 */   // Label 15159: @1020496
     /* 1020496 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1020573), // Rule ID 13128 //
     /* 1020501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020540 */     // MIs[0] policy
     /* 1020540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020572 */     // GIR_Coverage, 13128,
     /* 1020572 */     GIR_EraseRootFromParent_Done,
     /* 1020573 */   // Label 15160: @1020573
     /* 1020573 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1020650), // Rule ID 13129 //
     /* 1020578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020617 */     // MIs[0] policy
     /* 1020617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020627 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020649 */     // GIR_Coverage, 13129,
     /* 1020649 */     GIR_EraseRootFromParent_Done,
     /* 1020650 */   // Label 15161: @1020650
     /* 1020650 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1020727), // Rule ID 13132 //
     /* 1020655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020694 */     // MIs[0] policy
     /* 1020694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020726 */     // GIR_Coverage, 13132,
     /* 1020726 */     GIR_EraseRootFromParent_Done,
     /* 1020727 */   // Label 15162: @1020727
     /* 1020727 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1020804), // Rule ID 13133 //
     /* 1020732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020771 */     // MIs[0] policy
     /* 1020771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020803 */     // GIR_Coverage, 13133,
     /* 1020803 */     GIR_EraseRootFromParent_Done,
     /* 1020804 */   // Label 15163: @1020804
     /* 1020804 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1020881), // Rule ID 13136 //
     /* 1020809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020848 */     // MIs[0] policy
     /* 1020848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020880 */     // GIR_Coverage, 13136,
     /* 1020880 */     GIR_EraseRootFromParent_Done,
     /* 1020881 */   // Label 15164: @1020881
     /* 1020881 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1020958), // Rule ID 13137 //
     /* 1020886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020925 */     // MIs[0] policy
     /* 1020925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020935 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020957 */     // GIR_Coverage, 13137,
     /* 1020957 */     GIR_EraseRootFromParent_Done,
     /* 1020958 */   // Label 15165: @1020958
     /* 1020958 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1021035), // Rule ID 13140 //
     /* 1020963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021002 */     // MIs[0] policy
     /* 1021002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021012 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021034 */     // GIR_Coverage, 13140,
     /* 1021034 */     GIR_EraseRootFromParent_Done,
     /* 1021035 */   // Label 15166: @1021035
     /* 1021035 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1021112), // Rule ID 13141 //
     /* 1021040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1021051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1021054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1021057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1021060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021079 */     // MIs[0] policy
     /* 1021079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021089 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021111 */     // GIR_Coverage, 13141,
     /* 1021111 */     GIR_EraseRootFromParent_Done,
     /* 1021112 */   // Label 15167: @1021112
     /* 1021112 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1021189), // Rule ID 13144 //
     /* 1021117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1021134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021156 */     // MIs[0] policy
     /* 1021156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021188 */     // GIR_Coverage, 13144,
     /* 1021188 */     GIR_EraseRootFromParent_Done,
     /* 1021189 */   // Label 15168: @1021189
     /* 1021189 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1021266), // Rule ID 13145 //
     /* 1021194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1021211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021233 */     // MIs[0] policy
     /* 1021233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021265 */     // GIR_Coverage, 13145,
     /* 1021265 */     GIR_EraseRootFromParent_Done,
     /* 1021266 */   // Label 15169: @1021266
     /* 1021266 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1021343), // Rule ID 13148 //
     /* 1021271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1021288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021310 */     // MIs[0] policy
     /* 1021310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021342 */     // GIR_Coverage, 13148,
     /* 1021342 */     GIR_EraseRootFromParent_Done,
     /* 1021343 */   // Label 15170: @1021343
     /* 1021343 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1021420), // Rule ID 13149 //
     /* 1021348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1021365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021387 */     // MIs[0] policy
     /* 1021387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021397 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021419 */     // GIR_Coverage, 13149,
     /* 1021419 */     GIR_EraseRootFromParent_Done,
     /* 1021420 */   // Label 15171: @1021420
     /* 1021420 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1021497), // Rule ID 13152 //
     /* 1021425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021464 */     // MIs[0] policy
     /* 1021464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021496 */     // GIR_Coverage, 13152,
     /* 1021496 */     GIR_EraseRootFromParent_Done,
     /* 1021497 */   // Label 15172: @1021497
     /* 1021497 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1021574), // Rule ID 13153 //
     /* 1021502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021541 */     // MIs[0] policy
     /* 1021541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021551 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021573 */     // GIR_Coverage, 13153,
     /* 1021573 */     GIR_EraseRootFromParent_Done,
     /* 1021574 */   // Label 15173: @1021574
     /* 1021574 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1021651), // Rule ID 13156 //
     /* 1021579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021618 */     // MIs[0] policy
     /* 1021618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021650 */     // GIR_Coverage, 13156,
     /* 1021650 */     GIR_EraseRootFromParent_Done,
     /* 1021651 */   // Label 15174: @1021651
     /* 1021651 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1021728), // Rule ID 13157 //
     /* 1021656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021695 */     // MIs[0] policy
     /* 1021695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021727 */     // GIR_Coverage, 13157,
     /* 1021727 */     GIR_EraseRootFromParent_Done,
     /* 1021728 */   // Label 15175: @1021728
     /* 1021728 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1021805), // Rule ID 13160 //
     /* 1021733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021772 */     // MIs[0] policy
     /* 1021772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021804 */     // GIR_Coverage, 13160,
     /* 1021804 */     GIR_EraseRootFromParent_Done,
     /* 1021805 */   // Label 15176: @1021805
     /* 1021805 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1021882), // Rule ID 13161 //
     /* 1021810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021849 */     // MIs[0] policy
     /* 1021849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021881 */     // GIR_Coverage, 13161,
     /* 1021881 */     GIR_EraseRootFromParent_Done,
     /* 1021882 */   // Label 15177: @1021882
     /* 1021882 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1021959), // Rule ID 13164 //
     /* 1021887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021926 */     // MIs[0] policy
     /* 1021926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021958 */     // GIR_Coverage, 13164,
     /* 1021958 */     GIR_EraseRootFromParent_Done,
     /* 1021959 */   // Label 15178: @1021959
     /* 1021959 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1022036), // Rule ID 13165 //
     /* 1021964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022003 */     // MIs[0] policy
     /* 1022003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022013 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1022016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022035 */     // GIR_Coverage, 13165,
     /* 1022035 */     GIR_EraseRootFromParent_Done,
     /* 1022036 */   // Label 15179: @1022036
     /* 1022036 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1022113), // Rule ID 13168 //
     /* 1022041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022080 */     // MIs[0] policy
     /* 1022080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1022093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022112 */     // GIR_Coverage, 13168,
     /* 1022112 */     GIR_EraseRootFromParent_Done,
     /* 1022113 */   // Label 15180: @1022113
     /* 1022113 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1022190), // Rule ID 13169 //
     /* 1022118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022157 */     // MIs[0] policy
     /* 1022157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1022170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022189 */     // GIR_Coverage, 13169,
     /* 1022189 */     GIR_EraseRootFromParent_Done,
     /* 1022190 */   // Label 15181: @1022190
     /* 1022190 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1022267), // Rule ID 13172 //
     /* 1022195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022234 */     // MIs[0] policy
     /* 1022234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022244 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022266 */     // GIR_Coverage, 13172,
     /* 1022266 */     GIR_EraseRootFromParent_Done,
     /* 1022267 */   // Label 15182: @1022267
     /* 1022267 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1022344), // Rule ID 13173 //
     /* 1022272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022311 */     // MIs[0] policy
     /* 1022311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022343 */     // GIR_Coverage, 13173,
     /* 1022343 */     GIR_EraseRootFromParent_Done,
     /* 1022344 */   // Label 15183: @1022344
     /* 1022344 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1022421), // Rule ID 13176 //
     /* 1022349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022388 */     // MIs[0] policy
     /* 1022388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022420 */     // GIR_Coverage, 13176,
     /* 1022420 */     GIR_EraseRootFromParent_Done,
     /* 1022421 */   // Label 15184: @1022421
     /* 1022421 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1022498), // Rule ID 13177 //
     /* 1022426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022465 */     // MIs[0] policy
     /* 1022465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022475 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022497 */     // GIR_Coverage, 13177,
     /* 1022497 */     GIR_EraseRootFromParent_Done,
     /* 1022498 */   // Label 15185: @1022498
     /* 1022498 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1022575), // Rule ID 13180 //
     /* 1022503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022542 */     // MIs[0] policy
     /* 1022542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022574 */     // GIR_Coverage, 13180,
     /* 1022574 */     GIR_EraseRootFromParent_Done,
     /* 1022575 */   // Label 15186: @1022575
     /* 1022575 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1022652), // Rule ID 13181 //
     /* 1022580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022619 */     // MIs[0] policy
     /* 1022619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022629 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022651 */     // GIR_Coverage, 13181,
     /* 1022651 */     GIR_EraseRootFromParent_Done,
     /* 1022652 */   // Label 15187: @1022652
     /* 1022652 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1022729), // Rule ID 13184 //
     /* 1022657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022696 */     // MIs[0] policy
     /* 1022696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022728 */     // GIR_Coverage, 13184,
     /* 1022728 */     GIR_EraseRootFromParent_Done,
     /* 1022729 */   // Label 15188: @1022729
     /* 1022729 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1022806), // Rule ID 13185 //
     /* 1022734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022773 */     // MIs[0] policy
     /* 1022773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022783 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022805 */     // GIR_Coverage, 13185,
     /* 1022805 */     GIR_EraseRootFromParent_Done,
     /* 1022806 */   // Label 15189: @1022806
     /* 1022806 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1022883), // Rule ID 13188 //
     /* 1022811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022850 */     // MIs[0] policy
     /* 1022850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022882 */     // GIR_Coverage, 13188,
     /* 1022882 */     GIR_EraseRootFromParent_Done,
     /* 1022883 */   // Label 15190: @1022883
     /* 1022883 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1022960), // Rule ID 13189 //
     /* 1022888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022927 */     // MIs[0] policy
     /* 1022927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022959 */     // GIR_Coverage, 13189,
     /* 1022959 */     GIR_EraseRootFromParent_Done,
     /* 1022960 */   // Label 15191: @1022960
     /* 1022960 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1023037), // Rule ID 13192 //
     /* 1022965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023004 */     // MIs[0] policy
     /* 1023004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023014 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023036 */     // GIR_Coverage, 13192,
     /* 1023036 */     GIR_EraseRootFromParent_Done,
     /* 1023037 */   // Label 15192: @1023037
     /* 1023037 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1023114), // Rule ID 13193 //
     /* 1023042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1023053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1023056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023081 */     // MIs[0] policy
     /* 1023081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023091 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023113 */     // GIR_Coverage, 13193,
     /* 1023113 */     GIR_EraseRootFromParent_Done,
     /* 1023114 */   // Label 15193: @1023114
     /* 1023114 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1023191), // Rule ID 13196 //
     /* 1023119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023158 */     // MIs[0] policy
     /* 1023158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023190 */     // GIR_Coverage, 13196,
     /* 1023190 */     GIR_EraseRootFromParent_Done,
     /* 1023191 */   // Label 15194: @1023191
     /* 1023191 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1023268), // Rule ID 13197 //
     /* 1023196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023235 */     // MIs[0] policy
     /* 1023235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023267 */     // GIR_Coverage, 13197,
     /* 1023267 */     GIR_EraseRootFromParent_Done,
     /* 1023268 */   // Label 15195: @1023268
     /* 1023268 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1023345), // Rule ID 13200 //
     /* 1023273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023312 */     // MIs[0] policy
     /* 1023312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023344 */     // GIR_Coverage, 13200,
     /* 1023344 */     GIR_EraseRootFromParent_Done,
     /* 1023345 */   // Label 15196: @1023345
     /* 1023345 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1023422), // Rule ID 13201 //
     /* 1023350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023389 */     // MIs[0] policy
     /* 1023389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023421 */     // GIR_Coverage, 13201,
     /* 1023421 */     GIR_EraseRootFromParent_Done,
     /* 1023422 */   // Label 15197: @1023422
     /* 1023422 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1023499), // Rule ID 13204 //
     /* 1023427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1023430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023466 */     // MIs[0] policy
     /* 1023466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023498 */     // GIR_Coverage, 13204,
     /* 1023498 */     GIR_EraseRootFromParent_Done,
     /* 1023499 */   // Label 15198: @1023499
     /* 1023499 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1023576), // Rule ID 13205 //
     /* 1023504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023543 */     // MIs[0] policy
     /* 1023543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023575 */     // GIR_Coverage, 13205,
     /* 1023575 */     GIR_EraseRootFromParent_Done,
     /* 1023576 */   // Label 15199: @1023576
     /* 1023576 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1023653), // Rule ID 13208 //
     /* 1023581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023620 */     // MIs[0] policy
     /* 1023620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023652 */     // GIR_Coverage, 13208,
     /* 1023652 */     GIR_EraseRootFromParent_Done,
     /* 1023653 */   // Label 15200: @1023653
     /* 1023653 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1023730), // Rule ID 13209 //
     /* 1023658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023697 */     // MIs[0] policy
     /* 1023697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023729 */     // GIR_Coverage, 13209,
     /* 1023729 */     GIR_EraseRootFromParent_Done,
     /* 1023730 */   // Label 15201: @1023730
     /* 1023730 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1023807), // Rule ID 13212 //
     /* 1023735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023774 */     // MIs[0] policy
     /* 1023774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023806 */     // GIR_Coverage, 13212,
     /* 1023806 */     GIR_EraseRootFromParent_Done,
     /* 1023807 */   // Label 15202: @1023807
     /* 1023807 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1023884), // Rule ID 13213 //
     /* 1023812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023851 */     // MIs[0] policy
     /* 1023851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023861 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023883 */     // GIR_Coverage, 13213,
     /* 1023883 */     GIR_EraseRootFromParent_Done,
     /* 1023884 */   // Label 15203: @1023884
     /* 1023884 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1023961), // Rule ID 13216 //
     /* 1023889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023928 */     // MIs[0] policy
     /* 1023928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023938 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023960 */     // GIR_Coverage, 13216,
     /* 1023960 */     GIR_EraseRootFromParent_Done,
     /* 1023961 */   // Label 15204: @1023961
     /* 1023961 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1024038), // Rule ID 13217 //
     /* 1023966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024005 */     // MIs[0] policy
     /* 1024005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024015 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024037 */     // GIR_Coverage, 13217,
     /* 1024037 */     GIR_EraseRootFromParent_Done,
     /* 1024038 */   // Label 15205: @1024038
     /* 1024038 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1024115), // Rule ID 13220 //
     /* 1024043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024082 */     // MIs[0] policy
     /* 1024082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024114 */     // GIR_Coverage, 13220,
     /* 1024114 */     GIR_EraseRootFromParent_Done,
     /* 1024115 */   // Label 15206: @1024115
     /* 1024115 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1024192), // Rule ID 13221 //
     /* 1024120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024159 */     // MIs[0] policy
     /* 1024159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024191 */     // GIR_Coverage, 13221,
     /* 1024191 */     GIR_EraseRootFromParent_Done,
     /* 1024192 */   // Label 15207: @1024192
     /* 1024192 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1024269), // Rule ID 13224 //
     /* 1024197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024236 */     // MIs[0] policy
     /* 1024236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024268 */     // GIR_Coverage, 13224,
     /* 1024268 */     GIR_EraseRootFromParent_Done,
     /* 1024269 */   // Label 15208: @1024269
     /* 1024269 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1024346), // Rule ID 13225 //
     /* 1024274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024313 */     // MIs[0] policy
     /* 1024313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024323 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024345 */     // GIR_Coverage, 13225,
     /* 1024345 */     GIR_EraseRootFromParent_Done,
     /* 1024346 */   // Label 15209: @1024346
     /* 1024346 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1024423), // Rule ID 13228 //
     /* 1024351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024390 */     // MIs[0] policy
     /* 1024390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024422 */     // GIR_Coverage, 13228,
     /* 1024422 */     GIR_EraseRootFromParent_Done,
     /* 1024423 */   // Label 15210: @1024423
     /* 1024423 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1024500), // Rule ID 13229 //
     /* 1024428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024467 */     // MIs[0] policy
     /* 1024467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024477 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024499 */     // GIR_Coverage, 13229,
     /* 1024499 */     GIR_EraseRootFromParent_Done,
     /* 1024500 */   // Label 15211: @1024500
     /* 1024500 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1024577), // Rule ID 13232 //
     /* 1024505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024544 */     // MIs[0] policy
     /* 1024544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024576 */     // GIR_Coverage, 13232,
     /* 1024576 */     GIR_EraseRootFromParent_Done,
     /* 1024577 */   // Label 15212: @1024577
     /* 1024577 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1024654), // Rule ID 13233 //
     /* 1024582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024621 */     // MIs[0] policy
     /* 1024621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024653 */     // GIR_Coverage, 13233,
     /* 1024653 */     GIR_EraseRootFromParent_Done,
     /* 1024654 */   // Label 15213: @1024654
     /* 1024654 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1024731), // Rule ID 13236 //
     /* 1024659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024698 */     // MIs[0] policy
     /* 1024698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024730 */     // GIR_Coverage, 13236,
     /* 1024730 */     GIR_EraseRootFromParent_Done,
     /* 1024731 */   // Label 15214: @1024731
     /* 1024731 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1024808), // Rule ID 13237 //
     /* 1024736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024775 */     // MIs[0] policy
     /* 1024775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024785 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024807 */     // GIR_Coverage, 13237,
     /* 1024807 */     GIR_EraseRootFromParent_Done,
     /* 1024808 */   // Label 15215: @1024808
     /* 1024808 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1024885), // Rule ID 13240 //
     /* 1024813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024852 */     // MIs[0] policy
     /* 1024852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024862 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024884 */     // GIR_Coverage, 13240,
     /* 1024884 */     GIR_EraseRootFromParent_Done,
     /* 1024885 */   // Label 15216: @1024885
     /* 1024885 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1024962), // Rule ID 13241 //
     /* 1024890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024929 */     // MIs[0] policy
     /* 1024929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024961 */     // GIR_Coverage, 13241,
     /* 1024961 */     GIR_EraseRootFromParent_Done,
     /* 1024962 */   // Label 15217: @1024962
     /* 1024962 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1025039), // Rule ID 13244 //
     /* 1024967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025006 */     // MIs[0] policy
     /* 1025006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025016 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1025019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025038 */     // GIR_Coverage, 13244,
     /* 1025038 */     GIR_EraseRootFromParent_Done,
     /* 1025039 */   // Label 15218: @1025039
     /* 1025039 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1025116), // Rule ID 13245 //
     /* 1025044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1025055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1025058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1025064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025083 */     // MIs[0] policy
     /* 1025083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1025096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025115 */     // GIR_Coverage, 13245,
     /* 1025115 */     GIR_EraseRootFromParent_Done,
     /* 1025116 */   // Label 15219: @1025116
     /* 1025116 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1025193), // Rule ID 13248 //
     /* 1025121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025160 */     // MIs[0] policy
     /* 1025160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025170 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1025173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025192 */     // GIR_Coverage, 13248,
     /* 1025192 */     GIR_EraseRootFromParent_Done,
     /* 1025193 */   // Label 15220: @1025193
     /* 1025193 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1025270), // Rule ID 13249 //
     /* 1025198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025237 */     // MIs[0] policy
     /* 1025237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025247 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1025250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025269 */     // GIR_Coverage, 13249,
     /* 1025269 */     GIR_EraseRootFromParent_Done,
     /* 1025270 */   // Label 15221: @1025270
     /* 1025270 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1025347), // Rule ID 13252 //
     /* 1025275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025314 */     // MIs[0] policy
     /* 1025314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1025327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025346 */     // GIR_Coverage, 13252,
     /* 1025346 */     GIR_EraseRootFromParent_Done,
     /* 1025347 */   // Label 15222: @1025347
     /* 1025347 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1025424), // Rule ID 13253 //
     /* 1025352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025391 */     // MIs[0] policy
     /* 1025391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025401 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1025404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025423 */     // GIR_Coverage, 13253,
     /* 1025423 */     GIR_EraseRootFromParent_Done,
     /* 1025424 */   // Label 15223: @1025424
     /* 1025424 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1025501), // Rule ID 13256 //
     /* 1025429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025468 */     // MIs[0] policy
     /* 1025468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025500 */     // GIR_Coverage, 13256,
     /* 1025500 */     GIR_EraseRootFromParent_Done,
     /* 1025501 */   // Label 15224: @1025501
     /* 1025501 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1025578), // Rule ID 13257 //
     /* 1025506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025545 */     // MIs[0] policy
     /* 1025545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025555 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025577 */     // GIR_Coverage, 13257,
     /* 1025577 */     GIR_EraseRootFromParent_Done,
     /* 1025578 */   // Label 15225: @1025578
     /* 1025578 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1025655), // Rule ID 13260 //
     /* 1025583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025622 */     // MIs[0] policy
     /* 1025622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025654 */     // GIR_Coverage, 13260,
     /* 1025654 */     GIR_EraseRootFromParent_Done,
     /* 1025655 */   // Label 15226: @1025655
     /* 1025655 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1025732), // Rule ID 13261 //
     /* 1025660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025699 */     // MIs[0] policy
     /* 1025699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025731 */     // GIR_Coverage, 13261,
     /* 1025731 */     GIR_EraseRootFromParent_Done,
     /* 1025732 */   // Label 15227: @1025732
     /* 1025732 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1025809), // Rule ID 13264 //
     /* 1025737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025776 */     // MIs[0] policy
     /* 1025776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025808 */     // GIR_Coverage, 13264,
     /* 1025808 */     GIR_EraseRootFromParent_Done,
     /* 1025809 */   // Label 15228: @1025809
     /* 1025809 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1025886), // Rule ID 13265 //
     /* 1025814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025853 */     // MIs[0] policy
     /* 1025853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025863 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025885 */     // GIR_Coverage, 13265,
     /* 1025885 */     GIR_EraseRootFromParent_Done,
     /* 1025886 */   // Label 15229: @1025886
     /* 1025886 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1025963), // Rule ID 13268 //
     /* 1025891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025930 */     // MIs[0] policy
     /* 1025930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025962 */     // GIR_Coverage, 13268,
     /* 1025962 */     GIR_EraseRootFromParent_Done,
     /* 1025963 */   // Label 15230: @1025963
     /* 1025963 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1026040), // Rule ID 13269 //
     /* 1025968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026007 */     // MIs[0] policy
     /* 1026007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026017 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1026020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026039 */     // GIR_Coverage, 13269,
     /* 1026039 */     GIR_EraseRootFromParent_Done,
     /* 1026040 */   // Label 15231: @1026040
     /* 1026040 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1026117), // Rule ID 13272 //
     /* 1026045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1026062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026084 */     // MIs[0] policy
     /* 1026084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026116 */     // GIR_Coverage, 13272,
     /* 1026116 */     GIR_EraseRootFromParent_Done,
     /* 1026117 */   // Label 15232: @1026117
     /* 1026117 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1026194), // Rule ID 13273 //
     /* 1026122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1026139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026161 */     // MIs[0] policy
     /* 1026161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026193 */     // GIR_Coverage, 13273,
     /* 1026193 */     GIR_EraseRootFromParent_Done,
     /* 1026194 */   // Label 15233: @1026194
     /* 1026194 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1026271), // Rule ID 13276 //
     /* 1026199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1026216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026238 */     // MIs[0] policy
     /* 1026238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026270 */     // GIR_Coverage, 13276,
     /* 1026270 */     GIR_EraseRootFromParent_Done,
     /* 1026271 */   // Label 15234: @1026271
     /* 1026271 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1026348), // Rule ID 13277 //
     /* 1026276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1026293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026315 */     // MIs[0] policy
     /* 1026315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026325 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1026328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026347 */     // GIR_Coverage, 13277,
     /* 1026347 */     GIR_EraseRootFromParent_Done,
     /* 1026348 */   // Label 15235: @1026348
     /* 1026348 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1026425), // Rule ID 13280 //
     /* 1026353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026392 */     // MIs[0] policy
     /* 1026392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026424 */     // GIR_Coverage, 13280,
     /* 1026424 */     GIR_EraseRootFromParent_Done,
     /* 1026425 */   // Label 15236: @1026425
     /* 1026425 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1026502), // Rule ID 13281 //
     /* 1026430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1026447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026469 */     // MIs[0] policy
     /* 1026469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026479 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026501 */     // GIR_Coverage, 13281,
     /* 1026501 */     GIR_EraseRootFromParent_Done,
     /* 1026502 */   // Label 15237: @1026502
     /* 1026502 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1026579), // Rule ID 13284 //
     /* 1026507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026546 */     // MIs[0] policy
     /* 1026546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026578 */     // GIR_Coverage, 13284,
     /* 1026578 */     GIR_EraseRootFromParent_Done,
     /* 1026579 */   // Label 15238: @1026579
     /* 1026579 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1026656), // Rule ID 13285 //
     /* 1026584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026623 */     // MIs[0] policy
     /* 1026623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026655 */     // GIR_Coverage, 13285,
     /* 1026655 */     GIR_EraseRootFromParent_Done,
     /* 1026656 */   // Label 15239: @1026656
     /* 1026656 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1026733), // Rule ID 13288 //
     /* 1026661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026700 */     // MIs[0] policy
     /* 1026700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026732 */     // GIR_Coverage, 13288,
     /* 1026732 */     GIR_EraseRootFromParent_Done,
     /* 1026733 */   // Label 15240: @1026733
     /* 1026733 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1026810), // Rule ID 13289 //
     /* 1026738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026777 */     // MIs[0] policy
     /* 1026777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026809 */     // GIR_Coverage, 13289,
     /* 1026809 */     GIR_EraseRootFromParent_Done,
     /* 1026810 */   // Label 15241: @1026810
     /* 1026810 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1026887), // Rule ID 13292 //
     /* 1026815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026854 */     // MIs[0] policy
     /* 1026854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026886 */     // GIR_Coverage, 13292,
     /* 1026886 */     GIR_EraseRootFromParent_Done,
     /* 1026887 */   // Label 15242: @1026887
     /* 1026887 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1026964), // Rule ID 13293 //
     /* 1026892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026931 */     // MIs[0] policy
     /* 1026931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026941 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026963 */     // GIR_Coverage, 13293,
     /* 1026963 */     GIR_EraseRootFromParent_Done,
     /* 1026964 */   // Label 15243: @1026964
     /* 1026964 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1027041), // Rule ID 13296 //
     /* 1026969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027008 */     // MIs[0] policy
     /* 1027008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027040 */     // GIR_Coverage, 13296,
     /* 1027040 */     GIR_EraseRootFromParent_Done,
     /* 1027041 */   // Label 15244: @1027041
     /* 1027041 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1027118), // Rule ID 13297 //
     /* 1027046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1027057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1027060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1027063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027085 */     // MIs[0] policy
     /* 1027085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027095 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027117 */     // GIR_Coverage, 13297,
     /* 1027117 */     GIR_EraseRootFromParent_Done,
     /* 1027118 */   // Label 15245: @1027118
     /* 1027118 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1027195), // Rule ID 13300 //
     /* 1027123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1027140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027162 */     // MIs[0] policy
     /* 1027162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027194 */     // GIR_Coverage, 13300,
     /* 1027194 */     GIR_EraseRootFromParent_Done,
     /* 1027195 */   // Label 15246: @1027195
     /* 1027195 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1027272), // Rule ID 13301 //
     /* 1027200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1027217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027239 */     // MIs[0] policy
     /* 1027239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027249 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027271 */     // GIR_Coverage, 13301,
     /* 1027271 */     GIR_EraseRootFromParent_Done,
     /* 1027272 */   // Label 15247: @1027272
     /* 1027272 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1027349), // Rule ID 13304 //
     /* 1027277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1027294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027316 */     // MIs[0] policy
     /* 1027316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027348 */     // GIR_Coverage, 13304,
     /* 1027348 */     GIR_EraseRootFromParent_Done,
     /* 1027349 */   // Label 15248: @1027349
     /* 1027349 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1027426), // Rule ID 13305 //
     /* 1027354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1027371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027393 */     // MIs[0] policy
     /* 1027393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027403 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027425 */     // GIR_Coverage, 13305,
     /* 1027425 */     GIR_EraseRootFromParent_Done,
     /* 1027426 */   // Label 15249: @1027426
     /* 1027426 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1027503), // Rule ID 13308 //
     /* 1027431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027470 */     // MIs[0] policy
     /* 1027470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027502 */     // GIR_Coverage, 13308,
     /* 1027502 */     GIR_EraseRootFromParent_Done,
     /* 1027503 */   // Label 15250: @1027503
     /* 1027503 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1027580), // Rule ID 13309 //
     /* 1027508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027547 */     // MIs[0] policy
     /* 1027547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027557 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027579 */     // GIR_Coverage, 13309,
     /* 1027579 */     GIR_EraseRootFromParent_Done,
     /* 1027580 */   // Label 15251: @1027580
     /* 1027580 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1027657), // Rule ID 13312 //
     /* 1027585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027624 */     // MIs[0] policy
     /* 1027624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027656 */     // GIR_Coverage, 13312,
     /* 1027656 */     GIR_EraseRootFromParent_Done,
     /* 1027657 */   // Label 15252: @1027657
     /* 1027657 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1027734), // Rule ID 13313 //
     /* 1027662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027701 */     // MIs[0] policy
     /* 1027701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027733 */     // GIR_Coverage, 13313,
     /* 1027733 */     GIR_EraseRootFromParent_Done,
     /* 1027734 */   // Label 15253: @1027734
     /* 1027734 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1027811), // Rule ID 13316 //
     /* 1027739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027778 */     // MIs[0] policy
     /* 1027778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027810 */     // GIR_Coverage, 13316,
     /* 1027810 */     GIR_EraseRootFromParent_Done,
     /* 1027811 */   // Label 15254: @1027811
     /* 1027811 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1027888), // Rule ID 13317 //
     /* 1027816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027855 */     // MIs[0] policy
     /* 1027855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027865 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027887 */     // GIR_Coverage, 13317,
     /* 1027887 */     GIR_EraseRootFromParent_Done,
     /* 1027888 */   // Label 15255: @1027888
     /* 1027888 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1027965), // Rule ID 13320 //
     /* 1027893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027932 */     // MIs[0] policy
     /* 1027932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027964 */     // GIR_Coverage, 13320,
     /* 1027964 */     GIR_EraseRootFromParent_Done,
     /* 1027965 */   // Label 15256: @1027965
     /* 1027965 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1028042), // Rule ID 13321 //
     /* 1027970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028009 */     // MIs[0] policy
     /* 1028009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028041 */     // GIR_Coverage, 13321,
     /* 1028041 */     GIR_EraseRootFromParent_Done,
     /* 1028042 */   // Label 15257: @1028042
     /* 1028042 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1028119), // Rule ID 13324 //
     /* 1028047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1028064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028086 */     // MIs[0] policy
     /* 1028086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028118 */     // GIR_Coverage, 13324,
     /* 1028118 */     GIR_EraseRootFromParent_Done,
     /* 1028119 */   // Label 15258: @1028119
     /* 1028119 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1028196), // Rule ID 13325 //
     /* 1028124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1028141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028163 */     // MIs[0] policy
     /* 1028163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028173 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028195 */     // GIR_Coverage, 13325,
     /* 1028195 */     GIR_EraseRootFromParent_Done,
     /* 1028196 */   // Label 15259: @1028196
     /* 1028196 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1028273), // Rule ID 13328 //
     /* 1028201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1028218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028240 */     // MIs[0] policy
     /* 1028240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028272 */     // GIR_Coverage, 13328,
     /* 1028272 */     GIR_EraseRootFromParent_Done,
     /* 1028273 */   // Label 15260: @1028273
     /* 1028273 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1028350), // Rule ID 13329 //
     /* 1028278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1028295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028317 */     // MIs[0] policy
     /* 1028317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028349 */     // GIR_Coverage, 13329,
     /* 1028349 */     GIR_EraseRootFromParent_Done,
     /* 1028350 */   // Label 15261: @1028350
     /* 1028350 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1028427), // Rule ID 13332 //
     /* 1028355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1028372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028394 */     // MIs[0] policy
     /* 1028394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028404 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028426 */     // GIR_Coverage, 13332,
     /* 1028426 */     GIR_EraseRootFromParent_Done,
     /* 1028427 */   // Label 15262: @1028427
     /* 1028427 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1028504), // Rule ID 13333 //
     /* 1028432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1028449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028471 */     // MIs[0] policy
     /* 1028471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028503 */     // GIR_Coverage, 13333,
     /* 1028503 */     GIR_EraseRootFromParent_Done,
     /* 1028504 */   // Label 15263: @1028504
     /* 1028504 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1028581), // Rule ID 13336 //
     /* 1028509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028548 */     // MIs[0] policy
     /* 1028548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028580 */     // GIR_Coverage, 13336,
     /* 1028580 */     GIR_EraseRootFromParent_Done,
     /* 1028581 */   // Label 15264: @1028581
     /* 1028581 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1028658), // Rule ID 13337 //
     /* 1028586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028625 */     // MIs[0] policy
     /* 1028625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028635 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028657 */     // GIR_Coverage, 13337,
     /* 1028657 */     GIR_EraseRootFromParent_Done,
     /* 1028658 */   // Label 15265: @1028658
     /* 1028658 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1028735), // Rule ID 13340 //
     /* 1028663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028702 */     // MIs[0] policy
     /* 1028702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028734 */     // GIR_Coverage, 13340,
     /* 1028734 */     GIR_EraseRootFromParent_Done,
     /* 1028735 */   // Label 15266: @1028735
     /* 1028735 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1028812), // Rule ID 13341 //
     /* 1028740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028779 */     // MIs[0] policy
     /* 1028779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028789 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028811 */     // GIR_Coverage, 13341,
     /* 1028811 */     GIR_EraseRootFromParent_Done,
     /* 1028812 */   // Label 15267: @1028812
     /* 1028812 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1028889), // Rule ID 13344 //
     /* 1028817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028856 */     // MIs[0] policy
     /* 1028856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028888 */     // GIR_Coverage, 13344,
     /* 1028888 */     GIR_EraseRootFromParent_Done,
     /* 1028889 */   // Label 15268: @1028889
     /* 1028889 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1028966), // Rule ID 13345 //
     /* 1028894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028933 */     // MIs[0] policy
     /* 1028933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028943 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028965 */     // GIR_Coverage, 13345,
     /* 1028965 */     GIR_EraseRootFromParent_Done,
     /* 1028966 */   // Label 15269: @1028966
     /* 1028966 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1029043), // Rule ID 13348 //
     /* 1028971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029010 */     // MIs[0] policy
     /* 1029010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029042 */     // GIR_Coverage, 13348,
     /* 1029042 */     GIR_EraseRootFromParent_Done,
     /* 1029043 */   // Label 15270: @1029043
     /* 1029043 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1029120), // Rule ID 13349 //
     /* 1029048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1029059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1029062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1029068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029087 */     // MIs[0] policy
     /* 1029087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029097 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029119 */     // GIR_Coverage, 13349,
     /* 1029119 */     GIR_EraseRootFromParent_Done,
     /* 1029120 */   // Label 15271: @1029120
     /* 1029120 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1029197), // Rule ID 13352 //
     /* 1029125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029164 */     // MIs[0] policy
     /* 1029164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029196 */     // GIR_Coverage, 13352,
     /* 1029196 */     GIR_EraseRootFromParent_Done,
     /* 1029197 */   // Label 15272: @1029197
     /* 1029197 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1029274), // Rule ID 13353 //
     /* 1029202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029241 */     // MIs[0] policy
     /* 1029241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029251 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029273 */     // GIR_Coverage, 13353,
     /* 1029273 */     GIR_EraseRootFromParent_Done,
     /* 1029274 */   // Label 15273: @1029274
     /* 1029274 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1029351), // Rule ID 13356 //
     /* 1029279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029318 */     // MIs[0] policy
     /* 1029318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029350 */     // GIR_Coverage, 13356,
     /* 1029350 */     GIR_EraseRootFromParent_Done,
     /* 1029351 */   // Label 15274: @1029351
     /* 1029351 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1029428), // Rule ID 13357 //
     /* 1029356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029395 */     // MIs[0] policy
     /* 1029395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1029408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029427 */     // GIR_Coverage, 13357,
     /* 1029427 */     GIR_EraseRootFromParent_Done,
     /* 1029428 */   // Label 15275: @1029428
     /* 1029428 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1029505), // Rule ID 13360 //
     /* 1029433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029472 */     // MIs[0] policy
     /* 1029472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029504 */     // GIR_Coverage, 13360,
     /* 1029504 */     GIR_EraseRootFromParent_Done,
     /* 1029505 */   // Label 15276: @1029505
     /* 1029505 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1029582), // Rule ID 13361 //
     /* 1029510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029549 */     // MIs[0] policy
     /* 1029549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029581 */     // GIR_Coverage, 13361,
     /* 1029581 */     GIR_EraseRootFromParent_Done,
     /* 1029582 */   // Label 15277: @1029582
     /* 1029582 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1029659), // Rule ID 13364 //
     /* 1029587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029626 */     // MIs[0] policy
     /* 1029626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029658 */     // GIR_Coverage, 13364,
     /* 1029658 */     GIR_EraseRootFromParent_Done,
     /* 1029659 */   // Label 15278: @1029659
     /* 1029659 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1029736), // Rule ID 13365 //
     /* 1029664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029703 */     // MIs[0] policy
     /* 1029703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029713 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029735 */     // GIR_Coverage, 13365,
     /* 1029735 */     GIR_EraseRootFromParent_Done,
     /* 1029736 */   // Label 15279: @1029736
     /* 1029736 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1029813), // Rule ID 13368 //
     /* 1029741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029780 */     // MIs[0] policy
     /* 1029780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029812 */     // GIR_Coverage, 13368,
     /* 1029812 */     GIR_EraseRootFromParent_Done,
     /* 1029813 */   // Label 15280: @1029813
     /* 1029813 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1029890), // Rule ID 13369 //
     /* 1029818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029857 */     // MIs[0] policy
     /* 1029857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029867 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11543:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029889 */     // GIR_Coverage, 13369,
     /* 1029889 */     GIR_EraseRootFromParent_Done,
     /* 1029890 */   // Label 15281: @1029890
     /* 1029890 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1029967), // Rule ID 13372 //
     /* 1029895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029934 */     // MIs[0] policy
     /* 1029934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029966 */     // GIR_Coverage, 13372,
     /* 1029966 */     GIR_EraseRootFromParent_Done,
     /* 1029967 */   // Label 15282: @1029967
     /* 1029967 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1030044), // Rule ID 13373 //
     /* 1029972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030011 */     // MIs[0] policy
     /* 1030011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11543:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030043 */     // GIR_Coverage, 13373,
     /* 1030043 */     GIR_EraseRootFromParent_Done,
     /* 1030044 */   // Label 15283: @1030044
     /* 1030044 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1030121), // Rule ID 13376 //
     /* 1030049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030088 */     // MIs[0] policy
     /* 1030088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030120 */     // GIR_Coverage, 13376,
     /* 1030120 */     GIR_EraseRootFromParent_Done,
     /* 1030121 */   // Label 15284: @1030121
     /* 1030121 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1030198), // Rule ID 13377 //
     /* 1030126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030165 */     // MIs[0] policy
     /* 1030165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030175 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030197 */     // GIR_Coverage, 13377,
     /* 1030197 */     GIR_EraseRootFromParent_Done,
     /* 1030198 */   // Label 15285: @1030198
     /* 1030198 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1030275), // Rule ID 13380 //
     /* 1030203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030242 */     // MIs[0] policy
     /* 1030242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030274 */     // GIR_Coverage, 13380,
     /* 1030274 */     GIR_EraseRootFromParent_Done,
     /* 1030275 */   // Label 15286: @1030275
     /* 1030275 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1030352), // Rule ID 13381 //
     /* 1030280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1030283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030319 */     // MIs[0] policy
     /* 1030319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030329 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1030332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030351 */     // GIR_Coverage, 13381,
     /* 1030351 */     GIR_EraseRootFromParent_Done,
     /* 1030352 */   // Label 15287: @1030352
     /* 1030352 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1030429), // Rule ID 13384 //
     /* 1030357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030396 */     // MIs[0] policy
     /* 1030396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030428 */     // GIR_Coverage, 13384,
     /* 1030428 */     GIR_EraseRootFromParent_Done,
     /* 1030429 */   // Label 15288: @1030429
     /* 1030429 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1030506), // Rule ID 13385 //
     /* 1030434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030473 */     // MIs[0] policy
     /* 1030473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030483 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030505 */     // GIR_Coverage, 13385,
     /* 1030505 */     GIR_EraseRootFromParent_Done,
     /* 1030506 */   // Label 15289: @1030506
     /* 1030506 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1030583), // Rule ID 13388 //
     /* 1030511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030550 */     // MIs[0] policy
     /* 1030550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030560 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030582 */     // GIR_Coverage, 13388,
     /* 1030582 */     GIR_EraseRootFromParent_Done,
     /* 1030583 */   // Label 15290: @1030583
     /* 1030583 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1030660), // Rule ID 13389 //
     /* 1030588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030627 */     // MIs[0] policy
     /* 1030627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030637 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030659 */     // GIR_Coverage, 13389,
     /* 1030659 */     GIR_EraseRootFromParent_Done,
     /* 1030660 */   // Label 15291: @1030660
     /* 1030660 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1030737), // Rule ID 13392 //
     /* 1030665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030704 */     // MIs[0] policy
     /* 1030704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030736 */     // GIR_Coverage, 13392,
     /* 1030736 */     GIR_EraseRootFromParent_Done,
     /* 1030737 */   // Label 15292: @1030737
     /* 1030737 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1030814), // Rule ID 13393 //
     /* 1030742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030781 */     // MIs[0] policy
     /* 1030781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030791 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030813 */     // GIR_Coverage, 13393,
     /* 1030813 */     GIR_EraseRootFromParent_Done,
     /* 1030814 */   // Label 15293: @1030814
     /* 1030814 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1030891), // Rule ID 13396 //
     /* 1030819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030858 */     // MIs[0] policy
     /* 1030858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030890 */     // GIR_Coverage, 13396,
     /* 1030890 */     GIR_EraseRootFromParent_Done,
     /* 1030891 */   // Label 15294: @1030891
     /* 1030891 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1030968), // Rule ID 13397 //
     /* 1030896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030935 */     // MIs[0] policy
     /* 1030935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030967 */     // GIR_Coverage, 13397,
     /* 1030967 */     GIR_EraseRootFromParent_Done,
     /* 1030968 */   // Label 15295: @1030968
     /* 1030968 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1031045), // Rule ID 13400 //
     /* 1030973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031012 */     // MIs[0] policy
     /* 1031012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031044 */     // GIR_Coverage, 13400,
     /* 1031044 */     GIR_EraseRootFromParent_Done,
     /* 1031045 */   // Label 15296: @1031045
     /* 1031045 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1031122), // Rule ID 13401 //
     /* 1031050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1031070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031089 */     // MIs[0] policy
     /* 1031089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031121 */     // GIR_Coverage, 13401,
     /* 1031121 */     GIR_EraseRootFromParent_Done,
     /* 1031122 */   // Label 15297: @1031122
     /* 1031122 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1031199), // Rule ID 13404 //
     /* 1031127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031166 */     // MIs[0] policy
     /* 1031166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031198 */     // GIR_Coverage, 13404,
     /* 1031198 */     GIR_EraseRootFromParent_Done,
     /* 1031199 */   // Label 15298: @1031199
     /* 1031199 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1031276), // Rule ID 13405 //
     /* 1031204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031243 */     // MIs[0] policy
     /* 1031243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031253 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031275 */     // GIR_Coverage, 13405,
     /* 1031275 */     GIR_EraseRootFromParent_Done,
     /* 1031276 */   // Label 15299: @1031276
     /* 1031276 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1031353), // Rule ID 13408 //
     /* 1031281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031320 */     // MIs[0] policy
     /* 1031320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031352 */     // GIR_Coverage, 13408,
     /* 1031352 */     GIR_EraseRootFromParent_Done,
     /* 1031353 */   // Label 15300: @1031353
     /* 1031353 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1031430), // Rule ID 13409 //
     /* 1031358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031397 */     // MIs[0] policy
     /* 1031397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031429 */     // GIR_Coverage, 13409,
     /* 1031429 */     GIR_EraseRootFromParent_Done,
     /* 1031430 */   // Label 15301: @1031430
     /* 1031430 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1031507), // Rule ID 13412 //
     /* 1031435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031474 */     // MIs[0] policy
     /* 1031474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031506 */     // GIR_Coverage, 13412,
     /* 1031506 */     GIR_EraseRootFromParent_Done,
     /* 1031507 */   // Label 15302: @1031507
     /* 1031507 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1031584), // Rule ID 13413 //
     /* 1031512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031551 */     // MIs[0] policy
     /* 1031551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031583 */     // GIR_Coverage, 13413,
     /* 1031583 */     GIR_EraseRootFromParent_Done,
     /* 1031584 */   // Label 15303: @1031584
     /* 1031584 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1031661), // Rule ID 13416 //
     /* 1031589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031628 */     // MIs[0] policy
     /* 1031628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031660 */     // GIR_Coverage, 13416,
     /* 1031660 */     GIR_EraseRootFromParent_Done,
     /* 1031661 */   // Label 15304: @1031661
     /* 1031661 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1031738), // Rule ID 13417 //
     /* 1031666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031705 */     // MIs[0] policy
     /* 1031705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031737 */     // GIR_Coverage, 13417,
     /* 1031737 */     GIR_EraseRootFromParent_Done,
     /* 1031738 */   // Label 15305: @1031738
     /* 1031738 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1031815), // Rule ID 13420 //
     /* 1031743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031782 */     // MIs[0] policy
     /* 1031782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031814 */     // GIR_Coverage, 13420,
     /* 1031814 */     GIR_EraseRootFromParent_Done,
     /* 1031815 */   // Label 15306: @1031815
     /* 1031815 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1031892), // Rule ID 13421 //
     /* 1031820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031859 */     // MIs[0] policy
     /* 1031859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031891 */     // GIR_Coverage, 13421,
     /* 1031891 */     GIR_EraseRootFromParent_Done,
     /* 1031892 */   // Label 15307: @1031892
     /* 1031892 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1031969), // Rule ID 13424 //
     /* 1031897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031936 */     // MIs[0] policy
     /* 1031936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031968 */     // GIR_Coverage, 13424,
     /* 1031968 */     GIR_EraseRootFromParent_Done,
     /* 1031969 */   // Label 15308: @1031969
     /* 1031969 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1032046), // Rule ID 13425 //
     /* 1031974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032013 */     // MIs[0] policy
     /* 1032013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1032026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032045 */     // GIR_Coverage, 13425,
     /* 1032045 */     GIR_EraseRootFromParent_Done,
     /* 1032046 */   // Label 15309: @1032046
     /* 1032046 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1032123), // Rule ID 13428 //
     /* 1032051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1032054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032090 */     // MIs[0] policy
     /* 1032090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1032103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032122 */     // GIR_Coverage, 13428,
     /* 1032122 */     GIR_EraseRootFromParent_Done,
     /* 1032123 */   // Label 15310: @1032123
     /* 1032123 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1032200), // Rule ID 13429 //
     /* 1032128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1032131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032167 */     // MIs[0] policy
     /* 1032167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1032180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032199 */     // GIR_Coverage, 13429,
     /* 1032199 */     GIR_EraseRootFromParent_Done,
     /* 1032200 */   // Label 15311: @1032200
     /* 1032200 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1032277), // Rule ID 13432 //
     /* 1032205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1032222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032244 */     // MIs[0] policy
     /* 1032244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032254 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1032257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032276 */     // GIR_Coverage, 13432,
     /* 1032276 */     GIR_EraseRootFromParent_Done,
     /* 1032277 */   // Label 15312: @1032277
     /* 1032277 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1032354), // Rule ID 13433 //
     /* 1032282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1032299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032321 */     // MIs[0] policy
     /* 1032321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032331 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1032334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032353 */     // GIR_Coverage, 13433,
     /* 1032353 */     GIR_EraseRootFromParent_Done,
     /* 1032354 */   // Label 15313: @1032354
     /* 1032354 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1032431), // Rule ID 13436 //
     /* 1032359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1032376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032398 */     // MIs[0] policy
     /* 1032398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032430 */     // GIR_Coverage, 13436,
     /* 1032430 */     GIR_EraseRootFromParent_Done,
     /* 1032431 */   // Label 15314: @1032431
     /* 1032431 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1032508), // Rule ID 13437 //
     /* 1032436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1032453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032475 */     // MIs[0] policy
     /* 1032475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032507 */     // GIR_Coverage, 13437,
     /* 1032507 */     GIR_EraseRootFromParent_Done,
     /* 1032508 */   // Label 15315: @1032508
     /* 1032508 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1032585), // Rule ID 13440 //
     /* 1032513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032552 */     // MIs[0] policy
     /* 1032552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032584 */     // GIR_Coverage, 13440,
     /* 1032584 */     GIR_EraseRootFromParent_Done,
     /* 1032585 */   // Label 15316: @1032585
     /* 1032585 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1032662), // Rule ID 13441 //
     /* 1032590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032629 */     // MIs[0] policy
     /* 1032629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032639 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032661 */     // GIR_Coverage, 13441,
     /* 1032661 */     GIR_EraseRootFromParent_Done,
     /* 1032662 */   // Label 15317: @1032662
     /* 1032662 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1032739), // Rule ID 13444 //
     /* 1032667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032706 */     // MIs[0] policy
     /* 1032706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032738 */     // GIR_Coverage, 13444,
     /* 1032738 */     GIR_EraseRootFromParent_Done,
     /* 1032739 */   // Label 15318: @1032739
     /* 1032739 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1032816), // Rule ID 13445 //
     /* 1032744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032783 */     // MIs[0] policy
     /* 1032783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032815 */     // GIR_Coverage, 13445,
     /* 1032815 */     GIR_EraseRootFromParent_Done,
     /* 1032816 */   // Label 15319: @1032816
     /* 1032816 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1032893), // Rule ID 13448 //
     /* 1032821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032860 */     // MIs[0] policy
     /* 1032860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032892 */     // GIR_Coverage, 13448,
     /* 1032892 */     GIR_EraseRootFromParent_Done,
     /* 1032893 */   // Label 15320: @1032893
     /* 1032893 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1032970), // Rule ID 13449 //
     /* 1032898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032937 */     // MIs[0] policy
     /* 1032937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032947 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032969 */     // GIR_Coverage, 13449,
     /* 1032969 */     GIR_EraseRootFromParent_Done,
     /* 1032970 */   // Label 15321: @1032970
     /* 1032970 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1033047), // Rule ID 13452 //
     /* 1032975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033014 */     // MIs[0] policy
     /* 1033014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033046 */     // GIR_Coverage, 13452,
     /* 1033046 */     GIR_EraseRootFromParent_Done,
     /* 1033047 */   // Label 15322: @1033047
     /* 1033047 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1033124), // Rule ID 13453 //
     /* 1033052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1033063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1033066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1033069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033091 */     // MIs[0] policy
     /* 1033091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033101 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033123 */     // GIR_Coverage, 13453,
     /* 1033123 */     GIR_EraseRootFromParent_Done,
     /* 1033124 */   // Label 15323: @1033124
     /* 1033124 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1033201), // Rule ID 13456 //
     /* 1033129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1033146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1033149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033168 */     // MIs[0] policy
     /* 1033168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1033181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033200 */     // GIR_Coverage, 13456,
     /* 1033200 */     GIR_EraseRootFromParent_Done,
     /* 1033201 */   // Label 15324: @1033201
     /* 1033201 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1033278), // Rule ID 13457 //
     /* 1033206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1033223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1033226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033245 */     // MIs[0] policy
     /* 1033245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033255 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1033258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033277 */     // GIR_Coverage, 13457,
     /* 1033277 */     GIR_EraseRootFromParent_Done,
     /* 1033278 */   // Label 15325: @1033278
     /* 1033278 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1033355), // Rule ID 13460 //
     /* 1033283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1033300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1033303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033322 */     // MIs[0] policy
     /* 1033322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033354 */     // GIR_Coverage, 13460,
     /* 1033354 */     GIR_EraseRootFromParent_Done,
     /* 1033355 */   // Label 15326: @1033355
     /* 1033355 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1033432), // Rule ID 13461 //
     /* 1033360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1033377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1033380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033399 */     // MIs[0] policy
     /* 1033399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033409 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033431 */     // GIR_Coverage, 13461,
     /* 1033431 */     GIR_EraseRootFromParent_Done,
     /* 1033432 */   // Label 15327: @1033432
     /* 1033432 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1033509), // Rule ID 13464 //
     /* 1033437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033476 */     // MIs[0] policy
     /* 1033476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033508 */     // GIR_Coverage, 13464,
     /* 1033508 */     GIR_EraseRootFromParent_Done,
     /* 1033509 */   // Label 15328: @1033509
     /* 1033509 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1033586), // Rule ID 13465 //
     /* 1033514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033553 */     // MIs[0] policy
     /* 1033553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033585 */     // GIR_Coverage, 13465,
     /* 1033585 */     GIR_EraseRootFromParent_Done,
     /* 1033586 */   // Label 15329: @1033586
     /* 1033586 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1033663), // Rule ID 13468 //
     /* 1033591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033630 */     // MIs[0] policy
     /* 1033630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033662 */     // GIR_Coverage, 13468,
     /* 1033662 */     GIR_EraseRootFromParent_Done,
     /* 1033663 */   // Label 15330: @1033663
     /* 1033663 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1033740), // Rule ID 13469 //
     /* 1033668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033707 */     // MIs[0] policy
     /* 1033707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033739 */     // GIR_Coverage, 13469,
     /* 1033739 */     GIR_EraseRootFromParent_Done,
     /* 1033740 */   // Label 15331: @1033740
     /* 1033740 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1033817), // Rule ID 13472 //
     /* 1033745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033784 */     // MIs[0] policy
     /* 1033784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033816 */     // GIR_Coverage, 13472,
     /* 1033816 */     GIR_EraseRootFromParent_Done,
     /* 1033817 */   // Label 15332: @1033817
     /* 1033817 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1033894), // Rule ID 13473 //
     /* 1033822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033861 */     // MIs[0] policy
     /* 1033861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033893 */     // GIR_Coverage, 13473,
     /* 1033893 */     GIR_EraseRootFromParent_Done,
     /* 1033894 */   // Label 15333: @1033894
     /* 1033894 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1033971), // Rule ID 13476 //
     /* 1033899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033938 */     // MIs[0] policy
     /* 1033938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033970 */     // GIR_Coverage, 13476,
     /* 1033970 */     GIR_EraseRootFromParent_Done,
     /* 1033971 */   // Label 15334: @1033971
     /* 1033971 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1034048), // Rule ID 13477 //
     /* 1033976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034015 */     // MIs[0] policy
     /* 1034015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1034028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034047 */     // GIR_Coverage, 13477,
     /* 1034047 */     GIR_EraseRootFromParent_Done,
     /* 1034048 */   // Label 15335: @1034048
     /* 1034048 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1034125), // Rule ID 13480 //
     /* 1034053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1034064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1034067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1034073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034092 */     // MIs[0] policy
     /* 1034092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1034105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034124 */     // GIR_Coverage, 13480,
     /* 1034124 */     GIR_EraseRootFromParent_Done,
     /* 1034125 */   // Label 15336: @1034125
     /* 1034125 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1034202), // Rule ID 13481 //
     /* 1034130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1034141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1034144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1034147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1034150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034169 */     // MIs[0] policy
     /* 1034169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1034182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034201 */     // GIR_Coverage, 13481,
     /* 1034201 */     GIR_EraseRootFromParent_Done,
     /* 1034202 */   // Label 15337: @1034202
     /* 1034202 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1034279), // Rule ID 13484 //
     /* 1034207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1034218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1034221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1034224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034246 */     // MIs[0] policy
     /* 1034246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1034259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034278 */     // GIR_Coverage, 13484,
     /* 1034278 */     GIR_EraseRootFromParent_Done,
     /* 1034279 */   // Label 15338: @1034279
     /* 1034279 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1034356), // Rule ID 13485 //
     /* 1034284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1034295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1034298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1034301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034323 */     // MIs[0] policy
     /* 1034323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1034336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034355 */     // GIR_Coverage, 13485,
     /* 1034355 */     GIR_EraseRootFromParent_Done,
     /* 1034356 */   // Label 15339: @1034356
     /* 1034356 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1034433), // Rule ID 13488 //
     /* 1034361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1034364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1034372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1034375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1034378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034400 */     // MIs[0] policy
     /* 1034400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034432 */     // GIR_Coverage, 13488,
     /* 1034432 */     GIR_EraseRootFromParent_Done,
     /* 1034433 */   // Label 15340: @1034433
     /* 1034433 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1034510), // Rule ID 13489 //
     /* 1034438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1034441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1034449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1034452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1034455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034477 */     // MIs[0] policy
     /* 1034477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034487 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034509 */     // GIR_Coverage, 13489,
     /* 1034509 */     GIR_EraseRootFromParent_Done,
     /* 1034510 */   // Label 15341: @1034510
     /* 1034510 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1034587), // Rule ID 13492 //
     /* 1034515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034554 */     // MIs[0] policy
     /* 1034554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034586 */     // GIR_Coverage, 13492,
     /* 1034586 */     GIR_EraseRootFromParent_Done,
     /* 1034587 */   // Label 15342: @1034587
     /* 1034587 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1034664), // Rule ID 13493 //
     /* 1034592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034631 */     // MIs[0] policy
     /* 1034631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034641 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034663 */     // GIR_Coverage, 13493,
     /* 1034663 */     GIR_EraseRootFromParent_Done,
     /* 1034664 */   // Label 15343: @1034664
     /* 1034664 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1034741), // Rule ID 13496 //
     /* 1034669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034708 */     // MIs[0] policy
     /* 1034708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034740 */     // GIR_Coverage, 13496,
     /* 1034740 */     GIR_EraseRootFromParent_Done,
     /* 1034741 */   // Label 15344: @1034741
     /* 1034741 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1034818), // Rule ID 13497 //
     /* 1034746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034785 */     // MIs[0] policy
     /* 1034785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034795 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034817 */     // GIR_Coverage, 13497,
     /* 1034817 */     GIR_EraseRootFromParent_Done,
     /* 1034818 */   // Label 15345: @1034818
     /* 1034818 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1034895), // Rule ID 13500 //
     /* 1034823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034862 */     // MIs[0] policy
     /* 1034862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034894 */     // GIR_Coverage, 13500,
     /* 1034894 */     GIR_EraseRootFromParent_Done,
     /* 1034895 */   // Label 15346: @1034895
     /* 1034895 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1034972), // Rule ID 13501 //
     /* 1034900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034939 */     // MIs[0] policy
     /* 1034939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034949 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11707:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034971 */     // GIR_Coverage, 13501,
     /* 1034971 */     GIR_EraseRootFromParent_Done,
     /* 1034972 */   // Label 15347: @1034972
     /* 1034972 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1035049), // Rule ID 13504 //
     /* 1034977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035016 */     // MIs[0] policy
     /* 1035016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035048 */     // GIR_Coverage, 13504,
     /* 1035048 */     GIR_EraseRootFromParent_Done,
     /* 1035049 */   // Label 15348: @1035049
     /* 1035049 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1035126), // Rule ID 13505 //
     /* 1035054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1035065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1035068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1035074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035093 */     // MIs[0] policy
     /* 1035093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035125 */     // GIR_Coverage, 13505,
     /* 1035125 */     GIR_EraseRootFromParent_Done,
     /* 1035126 */   // Label 15349: @1035126
     /* 1035126 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1035203), // Rule ID 13508 //
     /* 1035131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1035151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035170 */     // MIs[0] policy
     /* 1035170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035202 */     // GIR_Coverage, 13508,
     /* 1035202 */     GIR_EraseRootFromParent_Done,
     /* 1035203 */   // Label 15350: @1035203
     /* 1035203 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1035280), // Rule ID 13509 //
     /* 1035208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1035219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1035222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1035228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035247 */     // MIs[0] policy
     /* 1035247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035257 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035279 */     // GIR_Coverage, 13509,
     /* 1035279 */     GIR_EraseRootFromParent_Done,
     /* 1035280 */   // Label 15351: @1035280
     /* 1035280 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1035357), // Rule ID 13512 //
     /* 1035285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1035296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1035299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1035305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035324 */     // MIs[0] policy
     /* 1035324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035356 */     // GIR_Coverage, 13512,
     /* 1035356 */     GIR_EraseRootFromParent_Done,
     /* 1035357 */   // Label 15352: @1035357
     /* 1035357 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1035434), // Rule ID 13513 //
     /* 1035362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1035373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1035376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1035382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035401 */     // MIs[0] policy
     /* 1035401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035411 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035433 */     // GIR_Coverage, 13513,
     /* 1035433 */     GIR_EraseRootFromParent_Done,
     /* 1035434 */   // Label 15353: @1035434
     /* 1035434 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1035511), // Rule ID 13516 //
     /* 1035439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035478 */     // MIs[0] policy
     /* 1035478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035488 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035510 */     // GIR_Coverage, 13516,
     /* 1035510 */     GIR_EraseRootFromParent_Done,
     /* 1035511 */   // Label 15354: @1035511
     /* 1035511 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1035588), // Rule ID 13517 //
     /* 1035516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035555 */     // MIs[0] policy
     /* 1035555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035565 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035587 */     // GIR_Coverage, 13517,
     /* 1035587 */     GIR_EraseRootFromParent_Done,
     /* 1035588 */   // Label 15355: @1035588
     /* 1035588 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1035665), // Rule ID 13520 //
     /* 1035593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035632 */     // MIs[0] policy
     /* 1035632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035664 */     // GIR_Coverage, 13520,
     /* 1035664 */     GIR_EraseRootFromParent_Done,
     /* 1035665 */   // Label 15356: @1035665
     /* 1035665 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1035742), // Rule ID 13521 //
     /* 1035670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035709 */     // MIs[0] policy
     /* 1035709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11707:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035741 */     // GIR_Coverage, 13521,
     /* 1035741 */     GIR_EraseRootFromParent_Done,
     /* 1035742 */   // Label 15357: @1035742
     /* 1035742 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1035819), // Rule ID 13524 //
     /* 1035747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035786 */     // MIs[0] policy
     /* 1035786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035818 */     // GIR_Coverage, 13524,
     /* 1035818 */     GIR_EraseRootFromParent_Done,
     /* 1035819 */   // Label 15358: @1035819
     /* 1035819 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1035896), // Rule ID 13525 //
     /* 1035824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035863 */     // MIs[0] policy
     /* 1035863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035895 */     // GIR_Coverage, 13525,
     /* 1035895 */     GIR_EraseRootFromParent_Done,
     /* 1035896 */   // Label 15359: @1035896
     /* 1035896 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1035973), // Rule ID 13528 //
     /* 1035901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035940 */     // MIs[0] policy
     /* 1035940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035972 */     // GIR_Coverage, 13528,
     /* 1035972 */     GIR_EraseRootFromParent_Done,
     /* 1035973 */   // Label 15360: @1035973
     /* 1035973 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1036050), // Rule ID 13529 //
     /* 1035978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036017 */     // MIs[0] policy
     /* 1036017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036049 */     // GIR_Coverage, 13529,
     /* 1036049 */     GIR_EraseRootFromParent_Done,
     /* 1036050 */   // Label 15361: @1036050
     /* 1036050 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1036127), // Rule ID 13532 //
     /* 1036055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1036075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036094 */     // MIs[0] policy
     /* 1036094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036126 */     // GIR_Coverage, 13532,
     /* 1036126 */     GIR_EraseRootFromParent_Done,
     /* 1036127 */   // Label 15362: @1036127
     /* 1036127 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1036204), // Rule ID 13533 //
     /* 1036132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1036143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1036146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1036152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036171 */     // MIs[0] policy
     /* 1036171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036181 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036203 */     // GIR_Coverage, 13533,
     /* 1036203 */     GIR_EraseRootFromParent_Done,
     /* 1036204 */   // Label 15363: @1036204
     /* 1036204 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1036281), // Rule ID 13536 //
     /* 1036209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1036220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1036223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1036229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036248 */     // MIs[0] policy
     /* 1036248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1036261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036280 */     // GIR_Coverage, 13536,
     /* 1036280 */     GIR_EraseRootFromParent_Done,
     /* 1036281 */   // Label 15364: @1036281
     /* 1036281 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1036358), // Rule ID 13537 //
     /* 1036286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1036297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1036300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1036306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036325 */     // MIs[0] policy
     /* 1036325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036335 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11707:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1036338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036357 */     // GIR_Coverage, 13537,
     /* 1036357 */     GIR_EraseRootFromParent_Done,
     /* 1036358 */   // Label 15365: @1036358
     /* 1036358 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1036435), // Rule ID 13540 //
     /* 1036363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1036383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036402 */     // MIs[0] policy
     /* 1036402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036434 */     // GIR_Coverage, 13540,
     /* 1036434 */     GIR_EraseRootFromParent_Done,
     /* 1036435 */   // Label 15366: @1036435
     /* 1036435 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1036512), // Rule ID 13541 //
     /* 1036440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1036451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1036454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1036460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036479 */     // MIs[0] policy
     /* 1036479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11707:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036511 */     // GIR_Coverage, 13541,
     /* 1036511 */     GIR_EraseRootFromParent_Done,
     /* 1036512 */   // Label 15367: @1036512
     /* 1036512 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1036589), // Rule ID 13544 //
     /* 1036517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036556 */     // MIs[0] policy
     /* 1036556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036588 */     // GIR_Coverage, 13544,
     /* 1036588 */     GIR_EraseRootFromParent_Done,
     /* 1036589 */   // Label 15368: @1036589
     /* 1036589 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1036666), // Rule ID 13545 //
     /* 1036594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036633 */     // MIs[0] policy
     /* 1036633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11707:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036665 */     // GIR_Coverage, 13545,
     /* 1036665 */     GIR_EraseRootFromParent_Done,
     /* 1036666 */   // Label 15369: @1036666
     /* 1036666 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1036743), // Rule ID 13548 //
     /* 1036671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036710 */     // MIs[0] policy
     /* 1036710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036742 */     // GIR_Coverage, 13548,
     /* 1036742 */     GIR_EraseRootFromParent_Done,
     /* 1036743 */   // Label 15370: @1036743
     /* 1036743 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1036820), // Rule ID 13549 //
     /* 1036748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036787 */     // MIs[0] policy
     /* 1036787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036797 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11707:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036819 */     // GIR_Coverage, 13549,
     /* 1036819 */     GIR_EraseRootFromParent_Done,
     /* 1036820 */   // Label 15371: @1036820
     /* 1036820 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1036897), // Rule ID 13552 //
     /* 1036825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036864 */     // MIs[0] policy
     /* 1036864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036896 */     // GIR_Coverage, 13552,
     /* 1036896 */     GIR_EraseRootFromParent_Done,
     /* 1036897 */   // Label 15372: @1036897
     /* 1036897 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1036974), // Rule ID 13553 //
     /* 1036902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036941 */     // MIs[0] policy
     /* 1036941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036973 */     // GIR_Coverage, 13553,
     /* 1036973 */     GIR_EraseRootFromParent_Done,
     /* 1036974 */   // Label 15373: @1036974
     /* 1036974 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1037051), // Rule ID 13556 //
     /* 1036979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037018 */     // MIs[0] policy
     /* 1037018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037050 */     // GIR_Coverage, 13556,
     /* 1037050 */     GIR_EraseRootFromParent_Done,
     /* 1037051 */   // Label 15374: @1037051
     /* 1037051 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1037128), // Rule ID 13557 //
     /* 1037056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1037067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1037070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1037073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1037076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037095 */     // MIs[0] policy
     /* 1037095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037105 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037127 */     // GIR_Coverage, 13557,
     /* 1037127 */     GIR_EraseRootFromParent_Done,
     /* 1037128 */   // Label 15375: @1037128
     /* 1037128 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1037205), // Rule ID 13560 //
     /* 1037133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1037144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1037147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037172 */     // MIs[0] policy
     /* 1037172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037204 */     // GIR_Coverage, 13560,
     /* 1037204 */     GIR_EraseRootFromParent_Done,
     /* 1037205 */   // Label 15376: @1037205
     /* 1037205 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1037282), // Rule ID 13561 //
     /* 1037210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1037221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1037224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1037227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1037230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037249 */     // MIs[0] policy
     /* 1037249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037259 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037281 */     // GIR_Coverage, 13561,
     /* 1037281 */     GIR_EraseRootFromParent_Done,
     /* 1037282 */   // Label 15377: @1037282
     /* 1037282 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1037359), // Rule ID 13564 //
     /* 1037287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1037298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1037301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1037304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1037307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037326 */     // MIs[0] policy
     /* 1037326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037358 */     // GIR_Coverage, 13564,
     /* 1037358 */     GIR_EraseRootFromParent_Done,
     /* 1037359 */   // Label 15378: @1037359
     /* 1037359 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1037436), // Rule ID 13565 //
     /* 1037364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1037375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1037378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1037381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1037384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037403 */     // MIs[0] policy
     /* 1037403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037435 */     // GIR_Coverage, 13565,
     /* 1037435 */     GIR_EraseRootFromParent_Done,
     /* 1037436 */   // Label 15379: @1037436
     /* 1037436 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1037513), // Rule ID 13568 //
     /* 1037441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037480 */     // MIs[0] policy
     /* 1037480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037512 */     // GIR_Coverage, 13568,
     /* 1037512 */     GIR_EraseRootFromParent_Done,
     /* 1037513 */   // Label 15380: @1037513
     /* 1037513 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1037590), // Rule ID 13569 //
     /* 1037518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037557 */     // MIs[0] policy
     /* 1037557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037567 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037589 */     // GIR_Coverage, 13569,
     /* 1037589 */     GIR_EraseRootFromParent_Done,
     /* 1037590 */   // Label 15381: @1037590
     /* 1037590 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1037667), // Rule ID 13572 //
     /* 1037595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037634 */     // MIs[0] policy
     /* 1037634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037666 */     // GIR_Coverage, 13572,
     /* 1037666 */     GIR_EraseRootFromParent_Done,
     /* 1037667 */   // Label 15382: @1037667
     /* 1037667 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1037744), // Rule ID 13573 //
     /* 1037672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037711 */     // MIs[0] policy
     /* 1037711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037743 */     // GIR_Coverage, 13573,
     /* 1037743 */     GIR_EraseRootFromParent_Done,
     /* 1037744 */   // Label 15383: @1037744
     /* 1037744 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1037821), // Rule ID 13576 //
     /* 1037749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037788 */     // MIs[0] policy
     /* 1037788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037820 */     // GIR_Coverage, 13576,
     /* 1037820 */     GIR_EraseRootFromParent_Done,
     /* 1037821 */   // Label 15384: @1037821
     /* 1037821 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1037898), // Rule ID 13577 //
     /* 1037826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037865 */     // MIs[0] policy
     /* 1037865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037875 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037897 */     // GIR_Coverage, 13577,
     /* 1037897 */     GIR_EraseRootFromParent_Done,
     /* 1037898 */   // Label 15385: @1037898
     /* 1037898 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1037975), // Rule ID 13580 //
     /* 1037903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037942 */     // MIs[0] policy
     /* 1037942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037974 */     // GIR_Coverage, 13580,
     /* 1037974 */     GIR_EraseRootFromParent_Done,
     /* 1037975 */   // Label 15386: @1037975
     /* 1037975 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1038052), // Rule ID 13581 //
     /* 1037980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1038000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038019 */     // MIs[0] policy
     /* 1038019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038029 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038051 */     // GIR_Coverage, 13581,
     /* 1038051 */     GIR_EraseRootFromParent_Done,
     /* 1038052 */   // Label 15387: @1038052
     /* 1038052 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1038129), // Rule ID 13584 //
     /* 1038057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1038068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1038071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038096 */     // MIs[0] policy
     /* 1038096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038128 */     // GIR_Coverage, 13584,
     /* 1038128 */     GIR_EraseRootFromParent_Done,
     /* 1038129 */   // Label 15388: @1038129
     /* 1038129 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1038206), // Rule ID 13585 //
     /* 1038134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1038145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1038148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1038151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1038154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038173 */     // MIs[0] policy
     /* 1038173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038205 */     // GIR_Coverage, 13585,
     /* 1038205 */     GIR_EraseRootFromParent_Done,
     /* 1038206 */   // Label 15389: @1038206
     /* 1038206 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1038283), // Rule ID 13588 //
     /* 1038211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1038222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1038225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1038228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1038231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038250 */     // MIs[0] policy
     /* 1038250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038282 */     // GIR_Coverage, 13588,
     /* 1038282 */     GIR_EraseRootFromParent_Done,
     /* 1038283 */   // Label 15390: @1038283
     /* 1038283 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1038360), // Rule ID 13589 //
     /* 1038288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1038299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1038302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1038305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1038308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038327 */     // MIs[0] policy
     /* 1038327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038337 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038359 */     // GIR_Coverage, 13589,
     /* 1038359 */     GIR_EraseRootFromParent_Done,
     /* 1038360 */   // Label 15391: @1038360
     /* 1038360 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1038437), // Rule ID 13592 //
     /* 1038365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1038376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1038379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1038382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1038385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038404 */     // MIs[0] policy
     /* 1038404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038436 */     // GIR_Coverage, 13592,
     /* 1038436 */     GIR_EraseRootFromParent_Done,
     /* 1038437 */   // Label 15392: @1038437
     /* 1038437 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1038514), // Rule ID 13593 //
     /* 1038442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1038453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1038456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1038459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1038462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038481 */     // MIs[0] policy
     /* 1038481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038513 */     // GIR_Coverage, 13593,
     /* 1038513 */     GIR_EraseRootFromParent_Done,
     /* 1038514 */   // Label 15393: @1038514
     /* 1038514 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1038591), // Rule ID 13596 //
     /* 1038519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038558 */     // MIs[0] policy
     /* 1038558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038590 */     // GIR_Coverage, 13596,
     /* 1038590 */     GIR_EraseRootFromParent_Done,
     /* 1038591 */   // Label 15394: @1038591
     /* 1038591 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1038668), // Rule ID 13597 //
     /* 1038596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038635 */     // MIs[0] policy
     /* 1038635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038645 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038667 */     // GIR_Coverage, 13597,
     /* 1038667 */     GIR_EraseRootFromParent_Done,
     /* 1038668 */   // Label 15395: @1038668
     /* 1038668 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1038745), // Rule ID 13600 //
     /* 1038673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038712 */     // MIs[0] policy
     /* 1038712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038744 */     // GIR_Coverage, 13600,
     /* 1038744 */     GIR_EraseRootFromParent_Done,
     /* 1038745 */   // Label 15396: @1038745
     /* 1038745 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1038822), // Rule ID 13601 //
     /* 1038750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038789 */     // MIs[0] policy
     /* 1038789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038821 */     // GIR_Coverage, 13601,
     /* 1038821 */     GIR_EraseRootFromParent_Done,
     /* 1038822 */   // Label 15397: @1038822
     /* 1038822 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1038899), // Rule ID 13604 //
     /* 1038827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038866 */     // MIs[0] policy
     /* 1038866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038898 */     // GIR_Coverage, 13604,
     /* 1038898 */     GIR_EraseRootFromParent_Done,
     /* 1038899 */   // Label 15398: @1038899
     /* 1038899 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1038976), // Rule ID 13605 //
     /* 1038904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038943 */     // MIs[0] policy
     /* 1038943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038975 */     // GIR_Coverage, 13605,
     /* 1038975 */     GIR_EraseRootFromParent_Done,
     /* 1038976 */   // Label 15399: @1038976
     /* 1038976 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1039053), // Rule ID 13608 //
     /* 1038981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039020 */     // MIs[0] policy
     /* 1039020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1039033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039052 */     // GIR_Coverage, 13608,
     /* 1039052 */     GIR_EraseRootFromParent_Done,
     /* 1039053 */   // Label 15400: @1039053
     /* 1039053 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1039130), // Rule ID 13609 //
     /* 1039058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1039069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1039072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1039075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1039078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039097 */     // MIs[0] policy
     /* 1039097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039107 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1039110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039129 */     // GIR_Coverage, 13609,
     /* 1039129 */     GIR_EraseRootFromParent_Done,
     /* 1039130 */   // Label 15401: @1039130
     /* 1039130 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1039207), // Rule ID 13612 //
     /* 1039135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1039146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1039149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1039155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039174 */     // MIs[0] policy
     /* 1039174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1039187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039206 */     // GIR_Coverage, 13612,
     /* 1039206 */     GIR_EraseRootFromParent_Done,
     /* 1039207 */   // Label 15402: @1039207
     /* 1039207 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1039284), // Rule ID 13613 //
     /* 1039212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1039223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1039226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1039232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039251 */     // MIs[0] policy
     /* 1039251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039261 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1039264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039283 */     // GIR_Coverage, 13613,
     /* 1039283 */     GIR_EraseRootFromParent_Done,
     /* 1039284 */   // Label 15403: @1039284
     /* 1039284 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1039361), // Rule ID 13616 //
     /* 1039289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1039300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1039303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1039309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039328 */     // MIs[0] policy
     /* 1039328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039338 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039360 */     // GIR_Coverage, 13616,
     /* 1039360 */     GIR_EraseRootFromParent_Done,
     /* 1039361 */   // Label 15404: @1039361
     /* 1039361 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1039438), // Rule ID 13617 //
     /* 1039366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1039377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1039380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1039386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039405 */     // MIs[0] policy
     /* 1039405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039415 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039437 */     // GIR_Coverage, 13617,
     /* 1039437 */     GIR_EraseRootFromParent_Done,
     /* 1039438 */   // Label 15405: @1039438
     /* 1039438 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1039515), // Rule ID 13620 //
     /* 1039443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039482 */     // MIs[0] policy
     /* 1039482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039514 */     // GIR_Coverage, 13620,
     /* 1039514 */     GIR_EraseRootFromParent_Done,
     /* 1039515 */   // Label 15406: @1039515
     /* 1039515 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1039592), // Rule ID 13621 //
     /* 1039520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039559 */     // MIs[0] policy
     /* 1039559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11703:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039591 */     // GIR_Coverage, 13621,
     /* 1039591 */     GIR_EraseRootFromParent_Done,
     /* 1039592 */   // Label 15407: @1039592
     /* 1039592 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1039669), // Rule ID 13624 //
     /* 1039597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039636 */     // MIs[0] policy
     /* 1039636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039668 */     // GIR_Coverage, 13624,
     /* 1039668 */     GIR_EraseRootFromParent_Done,
     /* 1039669 */   // Label 15408: @1039669
     /* 1039669 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1039746), // Rule ID 13625 //
     /* 1039674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039713 */     // MIs[0] policy
     /* 1039713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039745 */     // GIR_Coverage, 13625,
     /* 1039745 */     GIR_EraseRootFromParent_Done,
     /* 1039746 */   // Label 15409: @1039746
     /* 1039746 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1039823), // Rule ID 13628 //
     /* 1039751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039790 */     // MIs[0] policy
     /* 1039790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039822 */     // GIR_Coverage, 13628,
     /* 1039822 */     GIR_EraseRootFromParent_Done,
     /* 1039823 */   // Label 15410: @1039823
     /* 1039823 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1039900), // Rule ID 13629 //
     /* 1039828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039867 */     // MIs[0] policy
     /* 1039867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039877 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039899 */     // GIR_Coverage, 13629,
     /* 1039899 */     GIR_EraseRootFromParent_Done,
     /* 1039900 */   // Label 15411: @1039900
     /* 1039900 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1039977), // Rule ID 13632 //
     /* 1039905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039944 */     // MIs[0] policy
     /* 1039944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039954 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039976 */     // GIR_Coverage, 13632,
     /* 1039976 */     GIR_EraseRootFromParent_Done,
     /* 1039977 */   // Label 15412: @1039977
     /* 1039977 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1040054), // Rule ID 13633 //
     /* 1039982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1040002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040021 */     // MIs[0] policy
     /* 1040021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040031 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040053 */     // GIR_Coverage, 13633,
     /* 1040053 */     GIR_EraseRootFromParent_Done,
     /* 1040054 */   // Label 15413: @1040054
     /* 1040054 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1040131), // Rule ID 13636 //
     /* 1040059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1040070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1040073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1040079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040098 */     // MIs[0] policy
     /* 1040098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1040111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040130 */     // GIR_Coverage, 13636,
     /* 1040130 */     GIR_EraseRootFromParent_Done,
     /* 1040131 */   // Label 15414: @1040131
     /* 1040131 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1040208), // Rule ID 13637 //
     /* 1040136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1040147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1040150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1040156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040175 */     // MIs[0] policy
     /* 1040175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040185 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1040188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040207 */     // GIR_Coverage, 13637,
     /* 1040207 */     GIR_EraseRootFromParent_Done,
     /* 1040208 */   // Label 15415: @1040208
     /* 1040208 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1040285), // Rule ID 13640 //
     /* 1040213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1040224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1040227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1040233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040252 */     // MIs[0] policy
     /* 1040252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040284 */     // GIR_Coverage, 13640,
     /* 1040284 */     GIR_EraseRootFromParent_Done,
     /* 1040285 */   // Label 15416: @1040285
     /* 1040285 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1040362), // Rule ID 13641 //
     /* 1040290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1040301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1040304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1040310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040329 */     // MIs[0] policy
     /* 1040329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11703:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040361 */     // GIR_Coverage, 13641,
     /* 1040361 */     GIR_EraseRootFromParent_Done,
     /* 1040362 */   // Label 15417: @1040362
     /* 1040362 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1040439), // Rule ID 13644 //
     /* 1040367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1040378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1040381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1040387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040406 */     // MIs[0] policy
     /* 1040406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040438 */     // GIR_Coverage, 13644,
     /* 1040438 */     GIR_EraseRootFromParent_Done,
     /* 1040439 */   // Label 15418: @1040439
     /* 1040439 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1040516), // Rule ID 13645 //
     /* 1040444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1040455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1040458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1040464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040483 */     // MIs[0] policy
     /* 1040483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040515 */     // GIR_Coverage, 13645,
     /* 1040515 */     GIR_EraseRootFromParent_Done,
     /* 1040516 */   // Label 15419: @1040516
     /* 1040516 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1040593), // Rule ID 13648 //
     /* 1040521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040560 */     // MIs[0] policy
     /* 1040560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040592 */     // GIR_Coverage, 13648,
     /* 1040592 */     GIR_EraseRootFromParent_Done,
     /* 1040593 */   // Label 15420: @1040593
     /* 1040593 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1040670), // Rule ID 13649 //
     /* 1040598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040637 */     // MIs[0] policy
     /* 1040637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040647 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040669 */     // GIR_Coverage, 13649,
     /* 1040669 */     GIR_EraseRootFromParent_Done,
     /* 1040670 */   // Label 15421: @1040670
     /* 1040670 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1040747), // Rule ID 13652 //
     /* 1040675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040714 */     // MIs[0] policy
     /* 1040714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040746 */     // GIR_Coverage, 13652,
     /* 1040746 */     GIR_EraseRootFromParent_Done,
     /* 1040747 */   // Label 15422: @1040747
     /* 1040747 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1040824), // Rule ID 13653 //
     /* 1040752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040791 */     // MIs[0] policy
     /* 1040791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040823 */     // GIR_Coverage, 13653,
     /* 1040823 */     GIR_EraseRootFromParent_Done,
     /* 1040824 */   // Label 15423: @1040824
     /* 1040824 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1040901), // Rule ID 13656 //
     /* 1040829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040868 */     // MIs[0] policy
     /* 1040868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040900 */     // GIR_Coverage, 13656,
     /* 1040900 */     GIR_EraseRootFromParent_Done,
     /* 1040901 */   // Label 15424: @1040901
     /* 1040901 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1040978), // Rule ID 13657 //
     /* 1040906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040945 */     // MIs[0] policy
     /* 1040945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040955 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11703:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040977 */     // GIR_Coverage, 13657,
     /* 1040977 */     GIR_EraseRootFromParent_Done,
     /* 1040978 */   // Label 15425: @1040978
     /* 1040978 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1041055), // Rule ID 13660 //
     /* 1040983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1041003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041022 */     // MIs[0] policy
     /* 1041022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1041035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041054 */     // GIR_Coverage, 13660,
     /* 1041054 */     GIR_EraseRootFromParent_Done,
     /* 1041055 */   // Label 15426: @1041055
     /* 1041055 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1041132), // Rule ID 13661 //
     /* 1041060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1041071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1041074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1041080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041099 */     // MIs[0] policy
     /* 1041099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11703:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1041112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041131 */     // GIR_Coverage, 13661,
     /* 1041131 */     GIR_EraseRootFromParent_Done,
     /* 1041132 */   // Label 15427: @1041132
     /* 1041132 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1041209), // Rule ID 13664 //
     /* 1041137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1041148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1041151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1041157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041176 */     // MIs[0] policy
     /* 1041176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1041189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041208 */     // GIR_Coverage, 13664,
     /* 1041208 */     GIR_EraseRootFromParent_Done,
     /* 1041209 */   // Label 15428: @1041209
     /* 1041209 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1041286), // Rule ID 13665 //
     /* 1041214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1041225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1041228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1041234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041253 */     // MIs[0] policy
     /* 1041253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041263 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11703:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1041266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041285 */     // GIR_Coverage, 13665,
     /* 1041285 */     GIR_EraseRootFromParent_Done,
     /* 1041286 */   // Label 15429: @1041286
     /* 1041286 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1041363), // Rule ID 13668 //
     /* 1041291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1041302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1041305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1041308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1041311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041330 */     // MIs[0] policy
     /* 1041330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1041343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041362 */     // GIR_Coverage, 13668,
     /* 1041362 */     GIR_EraseRootFromParent_Done,
     /* 1041363 */   // Label 15430: @1041363
     /* 1041363 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1041440), // Rule ID 13669 //
     /* 1041368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1041379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1041382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1041385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1041388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1041403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041407 */     // MIs[0] policy
     /* 1041407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11703:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1041420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041439 */     // GIR_Coverage, 13669,
     /* 1041439 */     GIR_EraseRootFromParent_Done,
     /* 1041440 */   // Label 15431: @1041440
     /* 1041440 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1041517), // Rule ID 13672 //
     /* 1041445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041484 */     // MIs[0] policy
     /* 1041484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041516 */     // GIR_Coverage, 13672,
     /* 1041516 */     GIR_EraseRootFromParent_Done,
     /* 1041517 */   // Label 15432: @1041517
     /* 1041517 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1041594), // Rule ID 13673 //
     /* 1041522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041561 */     // MIs[0] policy
     /* 1041561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041571 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041593 */     // GIR_Coverage, 13673,
     /* 1041593 */     GIR_EraseRootFromParent_Done,
     /* 1041594 */   // Label 15433: @1041594
     /* 1041594 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1041671), // Rule ID 13676 //
     /* 1041599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041638 */     // MIs[0] policy
     /* 1041638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041670 */     // GIR_Coverage, 13676,
     /* 1041670 */     GIR_EraseRootFromParent_Done,
     /* 1041671 */   // Label 15434: @1041671
     /* 1041671 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1041748), // Rule ID 13677 //
     /* 1041676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041715 */     // MIs[0] policy
     /* 1041715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041747 */     // GIR_Coverage, 13677,
     /* 1041747 */     GIR_EraseRootFromParent_Done,
     /* 1041748 */   // Label 15435: @1041748
     /* 1041748 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1041825), // Rule ID 13680 //
     /* 1041753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041792 */     // MIs[0] policy
     /* 1041792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041824 */     // GIR_Coverage, 13680,
     /* 1041824 */     GIR_EraseRootFromParent_Done,
     /* 1041825 */   // Label 15436: @1041825
     /* 1041825 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1041902), // Rule ID 13681 //
     /* 1041830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041869 */     // MIs[0] policy
     /* 1041869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041879 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041901 */     // GIR_Coverage, 13681,
     /* 1041901 */     GIR_EraseRootFromParent_Done,
     /* 1041902 */   // Label 15437: @1041902
     /* 1041902 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1041979), // Rule ID 13684 //
     /* 1041907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041946 */     // MIs[0] policy
     /* 1041946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041978 */     // GIR_Coverage, 13684,
     /* 1041978 */     GIR_EraseRootFromParent_Done,
     /* 1041979 */   // Label 15438: @1041979
     /* 1041979 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1042056), // Rule ID 13685 //
     /* 1041984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1042001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1042004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042023 */     // MIs[0] policy
     /* 1042023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042055 */     // GIR_Coverage, 13685,
     /* 1042055 */     GIR_EraseRootFromParent_Done,
     /* 1042056 */   // Label 15439: @1042056
     /* 1042056 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1042133), // Rule ID 13688 //
     /* 1042061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1042081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042100 */     // MIs[0] policy
     /* 1042100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042132 */     // GIR_Coverage, 13688,
     /* 1042132 */     GIR_EraseRootFromParent_Done,
     /* 1042133 */   // Label 15440: @1042133
     /* 1042133 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1042210), // Rule ID 13689 //
     /* 1042138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1042149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1042152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1042155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1042158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042177 */     // MIs[0] policy
     /* 1042177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042187 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042209 */     // GIR_Coverage, 13689,
     /* 1042209 */     GIR_EraseRootFromParent_Done,
     /* 1042210 */   // Label 15441: @1042210
     /* 1042210 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1042287), // Rule ID 13692 //
     /* 1042215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1042226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1042229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1042235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042254 */     // MIs[0] policy
     /* 1042254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042286 */     // GIR_Coverage, 13692,
     /* 1042286 */     GIR_EraseRootFromParent_Done,
     /* 1042287 */   // Label 15442: @1042287
     /* 1042287 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1042364), // Rule ID 13693 //
     /* 1042292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1042303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1042306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1042309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1042312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042331 */     // MIs[0] policy
     /* 1042331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042341 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042363 */     // GIR_Coverage, 13693,
     /* 1042363 */     GIR_EraseRootFromParent_Done,
     /* 1042364 */   // Label 15443: @1042364
     /* 1042364 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1042441), // Rule ID 13696 //
     /* 1042369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1042380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1042383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1042386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042408 */     // MIs[0] policy
     /* 1042408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042440 */     // GIR_Coverage, 13696,
     /* 1042440 */     GIR_EraseRootFromParent_Done,
     /* 1042441 */   // Label 15444: @1042441
     /* 1042441 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1042518), // Rule ID 13697 //
     /* 1042446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1042457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1042460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1042463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042485 */     // MIs[0] policy
     /* 1042485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042495 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042517 */     // GIR_Coverage, 13697,
     /* 1042517 */     GIR_EraseRootFromParent_Done,
     /* 1042518 */   // Label 15445: @1042518
     /* 1042518 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1042595), // Rule ID 13700 //
     /* 1042523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042562 */     // MIs[0] policy
     /* 1042562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042594 */     // GIR_Coverage, 13700,
     /* 1042594 */     GIR_EraseRootFromParent_Done,
     /* 1042595 */   // Label 15446: @1042595
     /* 1042595 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1042672), // Rule ID 13701 //
     /* 1042600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042639 */     // MIs[0] policy
     /* 1042639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042671 */     // GIR_Coverage, 13701,
     /* 1042671 */     GIR_EraseRootFromParent_Done,
     /* 1042672 */   // Label 15447: @1042672
     /* 1042672 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1042749), // Rule ID 13704 //
     /* 1042677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042716 */     // MIs[0] policy
     /* 1042716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042748 */     // GIR_Coverage, 13704,
     /* 1042748 */     GIR_EraseRootFromParent_Done,
     /* 1042749 */   // Label 15448: @1042749
     /* 1042749 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1042826), // Rule ID 13705 //
     /* 1042754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042793 */     // MIs[0] policy
     /* 1042793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042825 */     // GIR_Coverage, 13705,
     /* 1042825 */     GIR_EraseRootFromParent_Done,
     /* 1042826 */   // Label 15449: @1042826
     /* 1042826 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1042903), // Rule ID 13708 //
     /* 1042831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042870 */     // MIs[0] policy
     /* 1042870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042902 */     // GIR_Coverage, 13708,
     /* 1042902 */     GIR_EraseRootFromParent_Done,
     /* 1042903 */   // Label 15450: @1042903
     /* 1042903 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1042980), // Rule ID 13709 //
     /* 1042908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042947 */     // MIs[0] policy
     /* 1042947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042979 */     // GIR_Coverage, 13709,
     /* 1042979 */     GIR_EraseRootFromParent_Done,
     /* 1042980 */   // Label 15451: @1042980
     /* 1042980 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1043057), // Rule ID 13712 //
     /* 1042985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1043002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1043005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043024 */     // MIs[0] policy
     /* 1043024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043056 */     // GIR_Coverage, 13712,
     /* 1043056 */     GIR_EraseRootFromParent_Done,
     /* 1043057 */   // Label 15452: @1043057
     /* 1043057 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1043134), // Rule ID 13713 //
     /* 1043062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1043073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1043076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1043079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1043082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043101 */     // MIs[0] policy
     /* 1043101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043133 */     // GIR_Coverage, 13713,
     /* 1043133 */     GIR_EraseRootFromParent_Done,
     /* 1043134 */   // Label 15453: @1043134
     /* 1043134 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1043211), // Rule ID 13716 //
     /* 1043139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1043150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1043153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1043156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1043159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043178 */     // MIs[0] policy
     /* 1043178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1043191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043210 */     // GIR_Coverage, 13716,
     /* 1043210 */     GIR_EraseRootFromParent_Done,
     /* 1043211 */   // Label 15454: @1043211
     /* 1043211 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1043288), // Rule ID 13717 //
     /* 1043216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1043227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1043230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1043233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1043236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043255 */     // MIs[0] policy
     /* 1043255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1043268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043287 */     // GIR_Coverage, 13717,
     /* 1043287 */     GIR_EraseRootFromParent_Done,
     /* 1043288 */   // Label 15455: @1043288
     /* 1043288 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1043365), // Rule ID 13720 //
     /* 1043293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1043310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1043313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043332 */     // MIs[0] policy
     /* 1043332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1043345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043364 */     // GIR_Coverage, 13720,
     /* 1043364 */     GIR_EraseRootFromParent_Done,
     /* 1043365 */   // Label 15456: @1043365
     /* 1043365 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1043442), // Rule ID 13721 //
     /* 1043370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1043381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1043384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1043387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1043390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043409 */     // MIs[0] policy
     /* 1043409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043419 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1043422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043441 */     // GIR_Coverage, 13721,
     /* 1043441 */     GIR_EraseRootFromParent_Done,
     /* 1043442 */   // Label 15457: @1043442
     /* 1043442 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1043519), // Rule ID 13724 //
     /* 1043447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043486 */     // MIs[0] policy
     /* 1043486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043518 */     // GIR_Coverage, 13724,
     /* 1043518 */     GIR_EraseRootFromParent_Done,
     /* 1043519 */   // Label 15458: @1043519
     /* 1043519 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1043596), // Rule ID 13725 //
     /* 1043524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043563 */     // MIs[0] policy
     /* 1043563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043573 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043595 */     // GIR_Coverage, 13725,
     /* 1043595 */     GIR_EraseRootFromParent_Done,
     /* 1043596 */   // Label 15459: @1043596
     /* 1043596 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1043673), // Rule ID 13728 //
     /* 1043601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043640 */     // MIs[0] policy
     /* 1043640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043672 */     // GIR_Coverage, 13728,
     /* 1043672 */     GIR_EraseRootFromParent_Done,
     /* 1043673 */   // Label 15460: @1043673
     /* 1043673 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1043750), // Rule ID 13729 //
     /* 1043678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043717 */     // MIs[0] policy
     /* 1043717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043727 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043749 */     // GIR_Coverage, 13729,
     /* 1043749 */     GIR_EraseRootFromParent_Done,
     /* 1043750 */   // Label 15461: @1043750
     /* 1043750 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1043827), // Rule ID 13732 //
     /* 1043755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043794 */     // MIs[0] policy
     /* 1043794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043826 */     // GIR_Coverage, 13732,
     /* 1043826 */     GIR_EraseRootFromParent_Done,
     /* 1043827 */   // Label 15462: @1043827
     /* 1043827 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1043904), // Rule ID 13733 //
     /* 1043832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043871 */     // MIs[0] policy
     /* 1043871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043881 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043903 */     // GIR_Coverage, 13733,
     /* 1043903 */     GIR_EraseRootFromParent_Done,
     /* 1043904 */   // Label 15463: @1043904
     /* 1043904 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1043981), // Rule ID 13736 //
     /* 1043909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043948 */     // MIs[0] policy
     /* 1043948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043980 */     // GIR_Coverage, 13736,
     /* 1043980 */     GIR_EraseRootFromParent_Done,
     /* 1043981 */   // Label 15464: @1043981
     /* 1043981 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1044058), // Rule ID 13737 //
     /* 1043986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044025 */     // MIs[0] policy
     /* 1044025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044035 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044057 */     // GIR_Coverage, 13737,
     /* 1044057 */     GIR_EraseRootFromParent_Done,
     /* 1044058 */   // Label 15465: @1044058
     /* 1044058 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1044135), // Rule ID 13740 //
     /* 1044063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1044074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1044077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044102 */     // MIs[0] policy
     /* 1044102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044134 */     // GIR_Coverage, 13740,
     /* 1044134 */     GIR_EraseRootFromParent_Done,
     /* 1044135 */   // Label 15466: @1044135
     /* 1044135 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1044212), // Rule ID 13741 //
     /* 1044140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1044151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1044154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1044160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044179 */     // MIs[0] policy
     /* 1044179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11705:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044211 */     // GIR_Coverage, 13741,
     /* 1044211 */     GIR_EraseRootFromParent_Done,
     /* 1044212 */   // Label 15467: @1044212
     /* 1044212 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1044289), // Rule ID 13744 //
     /* 1044217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1044228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1044231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1044237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044256 */     // MIs[0] policy
     /* 1044256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044288 */     // GIR_Coverage, 13744,
     /* 1044288 */     GIR_EraseRootFromParent_Done,
     /* 1044289 */   // Label 15468: @1044289
     /* 1044289 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1044366), // Rule ID 13745 //
     /* 1044294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1044305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1044308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1044314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044333 */     // MIs[0] policy
     /* 1044333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044365 */     // GIR_Coverage, 13745,
     /* 1044365 */     GIR_EraseRootFromParent_Done,
     /* 1044366 */   // Label 15469: @1044366
     /* 1044366 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1044443), // Rule ID 13748 //
     /* 1044371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1044382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1044385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044410 */     // MIs[0] policy
     /* 1044410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044420 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044442 */     // GIR_Coverage, 13748,
     /* 1044442 */     GIR_EraseRootFromParent_Done,
     /* 1044443 */   // Label 15470: @1044443
     /* 1044443 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1044520), // Rule ID 13749 //
     /* 1044448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1044459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1044462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044487 */     // MIs[0] policy
     /* 1044487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044497 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044519 */     // GIR_Coverage, 13749,
     /* 1044519 */     GIR_EraseRootFromParent_Done,
     /* 1044520 */   // Label 15471: @1044520
     /* 1044520 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1044597), // Rule ID 13752 //
     /* 1044525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044564 */     // MIs[0] policy
     /* 1044564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044596 */     // GIR_Coverage, 13752,
     /* 1044596 */     GIR_EraseRootFromParent_Done,
     /* 1044597 */   // Label 15472: @1044597
     /* 1044597 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1044674), // Rule ID 13753 //
     /* 1044602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044641 */     // MIs[0] policy
     /* 1044641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044651 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044673 */     // GIR_Coverage, 13753,
     /* 1044673 */     GIR_EraseRootFromParent_Done,
     /* 1044674 */   // Label 15473: @1044674
     /* 1044674 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1044751), // Rule ID 13756 //
     /* 1044679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044718 */     // MIs[0] policy
     /* 1044718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044750 */     // GIR_Coverage, 13756,
     /* 1044750 */     GIR_EraseRootFromParent_Done,
     /* 1044751 */   // Label 15474: @1044751
     /* 1044751 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1044828), // Rule ID 13757 //
     /* 1044756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044795 */     // MIs[0] policy
     /* 1044795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044805 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044827 */     // GIR_Coverage, 13757,
     /* 1044827 */     GIR_EraseRootFromParent_Done,
     /* 1044828 */   // Label 15475: @1044828
     /* 1044828 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1044905), // Rule ID 13760 //
     /* 1044833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044872 */     // MIs[0] policy
     /* 1044872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044904 */     // GIR_Coverage, 13760,
     /* 1044904 */     GIR_EraseRootFromParent_Done,
     /* 1044905 */   // Label 15476: @1044905
     /* 1044905 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1044982), // Rule ID 13761 //
     /* 1044910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044949 */     // MIs[0] policy
     /* 1044949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11705:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044981 */     // GIR_Coverage, 13761,
     /* 1044981 */     GIR_EraseRootFromParent_Done,
     /* 1044982 */   // Label 15477: @1044982
     /* 1044982 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1045059), // Rule ID 13764 //
     /* 1044987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1045001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045026 */     // MIs[0] policy
     /* 1045026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045058 */     // GIR_Coverage, 13764,
     /* 1045058 */     GIR_EraseRootFromParent_Done,
     /* 1045059 */   // Label 15478: @1045059
     /* 1045059 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1045136), // Rule ID 13765 //
     /* 1045064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1045075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1045078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1045084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045103 */     // MIs[0] policy
     /* 1045103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045135 */     // GIR_Coverage, 13765,
     /* 1045135 */     GIR_EraseRootFromParent_Done,
     /* 1045136 */   // Label 15479: @1045136
     /* 1045136 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1045213), // Rule ID 13768 //
     /* 1045141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1045152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1045155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1045161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045180 */     // MIs[0] policy
     /* 1045180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045190 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045212 */     // GIR_Coverage, 13768,
     /* 1045212 */     GIR_EraseRootFromParent_Done,
     /* 1045213 */   // Label 15480: @1045213
     /* 1045213 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1045290), // Rule ID 13769 //
     /* 1045218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1045229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1045232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1045238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045257 */     // MIs[0] policy
     /* 1045257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045267 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045289 */     // GIR_Coverage, 13769,
     /* 1045289 */     GIR_EraseRootFromParent_Done,
     /* 1045290 */   // Label 15481: @1045290
     /* 1045290 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1045367), // Rule ID 13772 //
     /* 1045295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1045306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1045309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1045315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045334 */     // MIs[0] policy
     /* 1045334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045366 */     // GIR_Coverage, 13772,
     /* 1045366 */     GIR_EraseRootFromParent_Done,
     /* 1045367 */   // Label 15482: @1045367
     /* 1045367 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1045444), // Rule ID 13773 //
     /* 1045372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1045383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1045386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1045392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045411 */     // MIs[0] policy
     /* 1045411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045421 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045443 */     // GIR_Coverage, 13773,
     /* 1045443 */     GIR_EraseRootFromParent_Done,
     /* 1045444 */   // Label 15483: @1045444
     /* 1045444 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1045521), // Rule ID 13776 //
     /* 1045449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045488 */     // MIs[0] policy
     /* 1045488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045520 */     // GIR_Coverage, 13776,
     /* 1045520 */     GIR_EraseRootFromParent_Done,
     /* 1045521 */   // Label 15484: @1045521
     /* 1045521 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1045598), // Rule ID 13777 //
     /* 1045526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045565 */     // MIs[0] policy
     /* 1045565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045575 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11705:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045597 */     // GIR_Coverage, 13777,
     /* 1045597 */     GIR_EraseRootFromParent_Done,
     /* 1045598 */   // Label 15485: @1045598
     /* 1045598 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1045675), // Rule ID 13780 //
     /* 1045603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045642 */     // MIs[0] policy
     /* 1045642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045674 */     // GIR_Coverage, 13780,
     /* 1045674 */     GIR_EraseRootFromParent_Done,
     /* 1045675 */   // Label 15486: @1045675
     /* 1045675 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1045752), // Rule ID 13781 //
     /* 1045680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045719 */     // MIs[0] policy
     /* 1045719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11705:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045751 */     // GIR_Coverage, 13781,
     /* 1045751 */     GIR_EraseRootFromParent_Done,
     /* 1045752 */   // Label 15487: @1045752
     /* 1045752 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1045829), // Rule ID 13784 //
     /* 1045757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045796 */     // MIs[0] policy
     /* 1045796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045828 */     // GIR_Coverage, 13784,
     /* 1045828 */     GIR_EraseRootFromParent_Done,
     /* 1045829 */   // Label 15488: @1045829
     /* 1045829 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1045906), // Rule ID 13785 //
     /* 1045834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045873 */     // MIs[0] policy
     /* 1045873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11705:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045905 */     // GIR_Coverage, 13785,
     /* 1045905 */     GIR_EraseRootFromParent_Done,
     /* 1045906 */   // Label 15489: @1045906
     /* 1045906 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1045983), // Rule ID 13788 //
     /* 1045911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045950 */     // MIs[0] policy
     /* 1045950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045982 */     // GIR_Coverage, 13788,
     /* 1045982 */     GIR_EraseRootFromParent_Done,
     /* 1045983 */   // Label 15490: @1045983
     /* 1045983 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1046060), // Rule ID 13789 //
     /* 1045988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1046002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046027 */     // MIs[0] policy
     /* 1046027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11705:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1046040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046059 */     // GIR_Coverage, 13789,
     /* 1046059 */     GIR_EraseRootFromParent_Done,
     /* 1046060 */   // Label 15491: @1046060
     /* 1046060 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1046137), // Rule ID 13792 //
     /* 1046065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1046076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1046079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1046085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046104 */     // MIs[0] policy
     /* 1046104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1046117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046136 */     // GIR_Coverage, 13792,
     /* 1046136 */     GIR_EraseRootFromParent_Done,
     /* 1046137 */   // Label 15492: @1046137
     /* 1046137 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1046214), // Rule ID 13793 //
     /* 1046142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1046153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1046156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1046162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046181 */     // MIs[0] policy
     /* 1046181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1046194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046213 */     // GIR_Coverage, 13793,
     /* 1046213 */     GIR_EraseRootFromParent_Done,
     /* 1046214 */   // Label 15493: @1046214
     /* 1046214 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1046291), // Rule ID 13796 //
     /* 1046219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1046230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1046233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1046239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046258 */     // MIs[0] policy
     /* 1046258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046290 */     // GIR_Coverage, 13796,
     /* 1046290 */     GIR_EraseRootFromParent_Done,
     /* 1046291 */   // Label 15494: @1046291
     /* 1046291 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1046368), // Rule ID 13797 //
     /* 1046296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1046307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1046310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1046316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046335 */     // MIs[0] policy
     /* 1046335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046345 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046367 */     // GIR_Coverage, 13797,
     /* 1046367 */     GIR_EraseRootFromParent_Done,
     /* 1046368 */   // Label 15495: @1046368
     /* 1046368 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1046445), // Rule ID 13800 //
     /* 1046373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1046384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1046387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046412 */     // MIs[0] policy
     /* 1046412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046444 */     // GIR_Coverage, 13800,
     /* 1046444 */     GIR_EraseRootFromParent_Done,
     /* 1046445 */   // Label 15496: @1046445
     /* 1046445 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1046522), // Rule ID 13801 //
     /* 1046450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1046461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1046464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046489 */     // MIs[0] policy
     /* 1046489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11709:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046521 */     // GIR_Coverage, 13801,
     /* 1046521 */     GIR_EraseRootFromParent_Done,
     /* 1046522 */   // Label 15497: @1046522
     /* 1046522 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1046599), // Rule ID 13804 //
     /* 1046527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046566 */     // MIs[0] policy
     /* 1046566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046598 */     // GIR_Coverage, 13804,
     /* 1046598 */     GIR_EraseRootFromParent_Done,
     /* 1046599 */   // Label 15498: @1046599
     /* 1046599 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1046676), // Rule ID 13805 //
     /* 1046604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046643 */     // MIs[0] policy
     /* 1046643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046653 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046675 */     // GIR_Coverage, 13805,
     /* 1046675 */     GIR_EraseRootFromParent_Done,
     /* 1046676 */   // Label 15499: @1046676
     /* 1046676 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1046753), // Rule ID 13808 //
     /* 1046681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046720 */     // MIs[0] policy
     /* 1046720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046752 */     // GIR_Coverage, 13808,
     /* 1046752 */     GIR_EraseRootFromParent_Done,
     /* 1046753 */   // Label 15500: @1046753
     /* 1046753 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1046830), // Rule ID 13809 //
     /* 1046758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046797 */     // MIs[0] policy
     /* 1046797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046807 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046829 */     // GIR_Coverage, 13809,
     /* 1046829 */     GIR_EraseRootFromParent_Done,
     /* 1046830 */   // Label 15501: @1046830
     /* 1046830 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1046907), // Rule ID 13812 //
     /* 1046835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046874 */     // MIs[0] policy
     /* 1046874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046906 */     // GIR_Coverage, 13812,
     /* 1046906 */     GIR_EraseRootFromParent_Done,
     /* 1046907 */   // Label 15502: @1046907
     /* 1046907 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1046984), // Rule ID 13813 //
     /* 1046912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046951 */     // MIs[0] policy
     /* 1046951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046983 */     // GIR_Coverage, 13813,
     /* 1046983 */     GIR_EraseRootFromParent_Done,
     /* 1046984 */   // Label 15503: @1046984
     /* 1046984 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1047061), // Rule ID 13816 //
     /* 1046989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1047009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047028 */     // MIs[0] policy
     /* 1047028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1047041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047060 */     // GIR_Coverage, 13816,
     /* 1047060 */     GIR_EraseRootFromParent_Done,
     /* 1047061 */   // Label 15504: @1047061
     /* 1047061 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1047138), // Rule ID 13817 //
     /* 1047066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1047086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047105 */     // MIs[0] policy
     /* 1047105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047115 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1047118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047137 */     // GIR_Coverage, 13817,
     /* 1047137 */     GIR_EraseRootFromParent_Done,
     /* 1047138 */   // Label 15505: @1047138
     /* 1047138 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1047215), // Rule ID 13820 //
     /* 1047143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1047163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047182 */     // MIs[0] policy
     /* 1047182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047214 */     // GIR_Coverage, 13820,
     /* 1047214 */     GIR_EraseRootFromParent_Done,
     /* 1047215 */   // Label 15506: @1047215
     /* 1047215 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1047292), // Rule ID 13821 //
     /* 1047220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1047240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047259 */     // MIs[0] policy
     /* 1047259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047269 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11709:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047291 */     // GIR_Coverage, 13821,
     /* 1047291 */     GIR_EraseRootFromParent_Done,
     /* 1047292 */   // Label 15507: @1047292
     /* 1047292 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1047369), // Rule ID 13824 //
     /* 1047297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1047308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1047311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1047317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047336 */     // MIs[0] policy
     /* 1047336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047368 */     // GIR_Coverage, 13824,
     /* 1047368 */     GIR_EraseRootFromParent_Done,
     /* 1047369 */   // Label 15508: @1047369
     /* 1047369 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1047446), // Rule ID 13825 //
     /* 1047374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1047385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1047388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1047394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047413 */     // MIs[0] policy
     /* 1047413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047445 */     // GIR_Coverage, 13825,
     /* 1047445 */     GIR_EraseRootFromParent_Done,
     /* 1047446 */   // Label 15509: @1047446
     /* 1047446 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1047523), // Rule ID 13828 //
     /* 1047451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047490 */     // MIs[0] policy
     /* 1047490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047522 */     // GIR_Coverage, 13828,
     /* 1047522 */     GIR_EraseRootFromParent_Done,
     /* 1047523 */   // Label 15510: @1047523
     /* 1047523 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1047600), // Rule ID 13829 //
     /* 1047528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047567 */     // MIs[0] policy
     /* 1047567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047599 */     // GIR_Coverage, 13829,
     /* 1047599 */     GIR_EraseRootFromParent_Done,
     /* 1047600 */   // Label 15511: @1047600
     /* 1047600 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1047677), // Rule ID 13832 //
     /* 1047605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047644 */     // MIs[0] policy
     /* 1047644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047676 */     // GIR_Coverage, 13832,
     /* 1047676 */     GIR_EraseRootFromParent_Done,
     /* 1047677 */   // Label 15512: @1047677
     /* 1047677 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1047754), // Rule ID 13833 //
     /* 1047682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047721 */     // MIs[0] policy
     /* 1047721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047731 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047753 */     // GIR_Coverage, 13833,
     /* 1047753 */     GIR_EraseRootFromParent_Done,
     /* 1047754 */   // Label 15513: @1047754
     /* 1047754 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1047831), // Rule ID 13836 //
     /* 1047759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047798 */     // MIs[0] policy
     /* 1047798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047830 */     // GIR_Coverage, 13836,
     /* 1047830 */     GIR_EraseRootFromParent_Done,
     /* 1047831 */   // Label 15514: @1047831
     /* 1047831 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1047908), // Rule ID 13837 //
     /* 1047836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047875 */     // MIs[0] policy
     /* 1047875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047885 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11709:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047907 */     // GIR_Coverage, 13837,
     /* 1047907 */     GIR_EraseRootFromParent_Done,
     /* 1047908 */   // Label 15515: @1047908
     /* 1047908 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1047985), // Rule ID 13840 //
     /* 1047913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047952 */     // MIs[0] policy
     /* 1047952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047984 */     // GIR_Coverage, 13840,
     /* 1047984 */     GIR_EraseRootFromParent_Done,
     /* 1047985 */   // Label 15516: @1047985
     /* 1047985 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1048062), // Rule ID 13841 //
     /* 1047990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1048001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1048004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1048010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048029 */     // MIs[0] policy
     /* 1048029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11709:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1048042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048061 */     // GIR_Coverage, 13841,
     /* 1048061 */     GIR_EraseRootFromParent_Done,
     /* 1048062 */   // Label 15517: @1048062
     /* 1048062 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1048139), // Rule ID 13844 //
     /* 1048067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1048078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1048081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1048087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048106 */     // MIs[0] policy
     /* 1048106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1048119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048138 */     // GIR_Coverage, 13844,
     /* 1048138 */     GIR_EraseRootFromParent_Done,
     /* 1048139 */   // Label 15518: @1048139
     /* 1048139 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1048216), // Rule ID 13845 //
     /* 1048144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1048155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1048158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1048164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048183 */     // MIs[0] policy
     /* 1048183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11709:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1048196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048215 */     // GIR_Coverage, 13845,
     /* 1048215 */     GIR_EraseRootFromParent_Done,
     /* 1048216 */   // Label 15519: @1048216
     /* 1048216 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1048293), // Rule ID 13848 //
     /* 1048221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1048232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1048235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1048241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048260 */     // MIs[0] policy
     /* 1048260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1048273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048292 */     // GIR_Coverage, 13848,
     /* 1048292 */     GIR_EraseRootFromParent_Done,
     /* 1048293 */   // Label 15520: @1048293
     /* 1048293 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1048370), // Rule ID 13849 //
     /* 1048298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1048306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1048309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1048312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1048318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048337 */     // MIs[0] policy
     /* 1048337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11709:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1048350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048369 */     // GIR_Coverage, 13849,
     /* 1048369 */     GIR_EraseRootFromParent_Done,
     /* 1048370 */   // Label 15521: @1048370
     /* 1048370 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1048447), // Rule ID 19062 //
     /* 1048375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048414 */     // MIs[0] policy
     /* 1048414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048446 */     // GIR_Coverage, 19062,
     /* 1048446 */     GIR_EraseRootFromParent_Done,
     /* 1048447 */   // Label 15522: @1048447
     /* 1048447 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1048524), // Rule ID 19063 //
     /* 1048452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1048463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048491 */     // MIs[0] policy
     /* 1048491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048501 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048523 */     // GIR_Coverage, 19063,
     /* 1048523 */     GIR_EraseRootFromParent_Done,
     /* 1048524 */   // Label 15523: @1048524
     /* 1048524 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1048601), // Rule ID 19066 //
     /* 1048529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048568 */     // MIs[0] policy
     /* 1048568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048578 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048600 */     // GIR_Coverage, 19066,
     /* 1048600 */     GIR_EraseRootFromParent_Done,
     /* 1048601 */   // Label 15524: @1048601
     /* 1048601 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1048678), // Rule ID 19067 //
     /* 1048606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048645 */     // MIs[0] policy
     /* 1048645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048655 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048677 */     // GIR_Coverage, 19067,
     /* 1048677 */     GIR_EraseRootFromParent_Done,
     /* 1048678 */   // Label 15525: @1048678
     /* 1048678 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1048755), // Rule ID 19070 //
     /* 1048683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048722 */     // MIs[0] policy
     /* 1048722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048754 */     // GIR_Coverage, 19070,
     /* 1048754 */     GIR_EraseRootFromParent_Done,
     /* 1048755 */   // Label 15526: @1048755
     /* 1048755 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1048832), // Rule ID 19071 //
     /* 1048760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048799 */     // MIs[0] policy
     /* 1048799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048809 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11318:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048831 */     // GIR_Coverage, 19071,
     /* 1048831 */     GIR_EraseRootFromParent_Done,
     /* 1048832 */   // Label 15527: @1048832
     /* 1048832 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1048909), // Rule ID 19074 //
     /* 1048837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048876 */     // MIs[0] policy
     /* 1048876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048886 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048908 */     // GIR_Coverage, 19074,
     /* 1048908 */     GIR_EraseRootFromParent_Done,
     /* 1048909 */   // Label 15528: @1048909
     /* 1048909 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1048986), // Rule ID 19075 //
     /* 1048914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048953 */     // MIs[0] policy
     /* 1048953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048963 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048985 */     // GIR_Coverage, 19075,
     /* 1048985 */     GIR_EraseRootFromParent_Done,
     /* 1048986 */   // Label 15529: @1048986
     /* 1048986 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1049063), // Rule ID 19078 //
     /* 1048991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1048994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049030 */     // MIs[0] policy
     /* 1049030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049040 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1049043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049062 */     // GIR_Coverage, 19078,
     /* 1049062 */     GIR_EraseRootFromParent_Done,
     /* 1049063 */   // Label 15530: @1049063
     /* 1049063 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1049140), // Rule ID 19079 //
     /* 1049068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1049079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1049082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1049085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049107 */     // MIs[0] policy
     /* 1049107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049117 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1049120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049139 */     // GIR_Coverage, 19079,
     /* 1049139 */     GIR_EraseRootFromParent_Done,
     /* 1049140 */   // Label 15531: @1049140
     /* 1049140 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1049217), // Rule ID 19082 //
     /* 1049145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049184 */     // MIs[0] policy
     /* 1049184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1049197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049216 */     // GIR_Coverage, 19082,
     /* 1049216 */     GIR_EraseRootFromParent_Done,
     /* 1049217 */   // Label 15532: @1049217
     /* 1049217 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1049294), // Rule ID 19083 //
     /* 1049222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1049239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049261 */     // MIs[0] policy
     /* 1049261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049271 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1049274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049293 */     // GIR_Coverage, 19083,
     /* 1049293 */     GIR_EraseRootFromParent_Done,
     /* 1049294 */   // Label 15533: @1049294
     /* 1049294 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1049371), // Rule ID 19086 //
     /* 1049299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1049313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1049316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049338 */     // MIs[0] policy
     /* 1049338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049348 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1049351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049370 */     // GIR_Coverage, 19086,
     /* 1049370 */     GIR_EraseRootFromParent_Done,
     /* 1049371 */   // Label 15534: @1049371
     /* 1049371 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1049448), // Rule ID 19087 //
     /* 1049376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1049387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1049390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1049393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049415 */     // MIs[0] policy
     /* 1049415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1049428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049447 */     // GIR_Coverage, 19087,
     /* 1049447 */     GIR_EraseRootFromParent_Done,
     /* 1049448 */   // Label 15535: @1049448
     /* 1049448 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1049525), // Rule ID 19090 //
     /* 1049453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1049456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049492 */     // MIs[0] policy
     /* 1049492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049502 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049524 */     // GIR_Coverage, 19090,
     /* 1049524 */     GIR_EraseRootFromParent_Done,
     /* 1049525 */   // Label 15536: @1049525
     /* 1049525 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1049602), // Rule ID 19091 //
     /* 1049530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049569 */     // MIs[0] policy
     /* 1049569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049579 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049601 */     // GIR_Coverage, 19091,
     /* 1049601 */     GIR_EraseRootFromParent_Done,
     /* 1049602 */   // Label 15537: @1049602
     /* 1049602 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1049679), // Rule ID 19094 //
     /* 1049607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049646 */     // MIs[0] policy
     /* 1049646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049656 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049678 */     // GIR_Coverage, 19094,
     /* 1049678 */     GIR_EraseRootFromParent_Done,
     /* 1049679 */   // Label 15538: @1049679
     /* 1049679 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1049756), // Rule ID 19095 //
     /* 1049684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049723 */     // MIs[0] policy
     /* 1049723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049755 */     // GIR_Coverage, 19095,
     /* 1049755 */     GIR_EraseRootFromParent_Done,
     /* 1049756 */   // Label 15539: @1049756
     /* 1049756 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1049833), // Rule ID 19098 //
     /* 1049761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049800 */     // MIs[0] policy
     /* 1049800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049810 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049832 */     // GIR_Coverage, 19098,
     /* 1049832 */     GIR_EraseRootFromParent_Done,
     /* 1049833 */   // Label 15540: @1049833
     /* 1049833 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1049910), // Rule ID 19099 //
     /* 1049838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049877 */     // MIs[0] policy
     /* 1049877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049887 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049909 */     // GIR_Coverage, 19099,
     /* 1049909 */     GIR_EraseRootFromParent_Done,
     /* 1049910 */   // Label 15541: @1049910
     /* 1049910 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1049987), // Rule ID 19102 //
     /* 1049915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049954 */     // MIs[0] policy
     /* 1049954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049964 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049986 */     // GIR_Coverage, 19102,
     /* 1049986 */     GIR_EraseRootFromParent_Done,
     /* 1049987 */   // Label 15542: @1049987
     /* 1049987 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1050064), // Rule ID 19103 //
     /* 1049992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1050009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1050012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050031 */     // MIs[0] policy
     /* 1050031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050041 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1050044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050063 */     // GIR_Coverage, 19103,
     /* 1050063 */     GIR_EraseRootFromParent_Done,
     /* 1050064 */   // Label 15543: @1050064
     /* 1050064 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1050141), // Rule ID 19106 //
     /* 1050069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050108 */     // MIs[0] policy
     /* 1050108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050118 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1050121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050140 */     // GIR_Coverage, 19106,
     /* 1050140 */     GIR_EraseRootFromParent_Done,
     /* 1050141 */   // Label 15544: @1050141
     /* 1050141 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1050218), // Rule ID 19107 //
     /* 1050146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1050157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1050160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1050163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050185 */     // MIs[0] policy
     /* 1050185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1050198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050217 */     // GIR_Coverage, 19107,
     /* 1050217 */     GIR_EraseRootFromParent_Done,
     /* 1050218 */   // Label 15545: @1050218
     /* 1050218 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1050295), // Rule ID 19110 //
     /* 1050223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050262 */     // MIs[0] policy
     /* 1050262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050272 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1050275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050294 */     // GIR_Coverage, 19110,
     /* 1050294 */     GIR_EraseRootFromParent_Done,
     /* 1050295 */   // Label 15546: @1050295
     /* 1050295 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1050372), // Rule ID 19111 //
     /* 1050300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1050311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1050314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1050317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050339 */     // MIs[0] policy
     /* 1050339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050349 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1050352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050371 */     // GIR_Coverage, 19111,
     /* 1050371 */     GIR_EraseRootFromParent_Done,
     /* 1050372 */   // Label 15547: @1050372
     /* 1050372 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1050449), // Rule ID 19114 //
     /* 1050377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1050380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1050388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050416 */     // MIs[0] policy
     /* 1050416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050448 */     // GIR_Coverage, 19114,
     /* 1050448 */     GIR_EraseRootFromParent_Done,
     /* 1050449 */   // Label 15548: @1050449
     /* 1050449 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1050526), // Rule ID 19115 //
     /* 1050454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1050457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1050462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1050465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050493 */     // MIs[0] policy
     /* 1050493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050503 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050525 */     // GIR_Coverage, 19115,
     /* 1050525 */     GIR_EraseRootFromParent_Done,
     /* 1050526 */   // Label 15549: @1050526
     /* 1050526 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1050603), // Rule ID 20498 //
     /* 1050531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050570 */     // MIs[0] policy
     /* 1050570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050602 */     // GIR_Coverage, 20498,
     /* 1050602 */     GIR_EraseRootFromParent_Done,
     /* 1050603 */   // Label 15550: @1050603
     /* 1050603 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1050680), // Rule ID 20499 //
     /* 1050608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050647 */     // MIs[0] policy
     /* 1050647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050657 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050679 */     // GIR_Coverage, 20499,
     /* 1050679 */     GIR_EraseRootFromParent_Done,
     /* 1050680 */   // Label 15551: @1050680
     /* 1050680 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1050757), // Rule ID 20502 //
     /* 1050685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050724 */     // MIs[0] policy
     /* 1050724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050756 */     // GIR_Coverage, 20502,
     /* 1050756 */     GIR_EraseRootFromParent_Done,
     /* 1050757 */   // Label 15552: @1050757
     /* 1050757 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1050834), // Rule ID 20503 //
     /* 1050762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050801 */     // MIs[0] policy
     /* 1050801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050833 */     // GIR_Coverage, 20503,
     /* 1050833 */     GIR_EraseRootFromParent_Done,
     /* 1050834 */   // Label 15553: @1050834
     /* 1050834 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1050911), // Rule ID 20506 //
     /* 1050839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050878 */     // MIs[0] policy
     /* 1050878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050910 */     // GIR_Coverage, 20506,
     /* 1050910 */     GIR_EraseRootFromParent_Done,
     /* 1050911 */   // Label 15554: @1050911
     /* 1050911 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1050988), // Rule ID 20507 //
     /* 1050916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050955 */     // MIs[0] policy
     /* 1050955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050987 */     // GIR_Coverage, 20507,
     /* 1050987 */     GIR_EraseRootFromParent_Done,
     /* 1050988 */   // Label 15555: @1050988
     /* 1050988 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1051065), // Rule ID 20510 //
     /* 1050993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1051004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1051007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1051010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051032 */     // MIs[0] policy
     /* 1051032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051064 */     // GIR_Coverage, 20510,
     /* 1051064 */     GIR_EraseRootFromParent_Done,
     /* 1051065 */   // Label 15556: @1051065
     /* 1051065 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1051142), // Rule ID 20511 //
     /* 1051070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1051081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1051084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1051087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051109 */     // MIs[0] policy
     /* 1051109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051141 */     // GIR_Coverage, 20511,
     /* 1051141 */     GIR_EraseRootFromParent_Done,
     /* 1051142 */   // Label 15557: @1051142
     /* 1051142 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1051219), // Rule ID 20514 //
     /* 1051147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1051164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051186 */     // MIs[0] policy
     /* 1051186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051218 */     // GIR_Coverage, 20514,
     /* 1051218 */     GIR_EraseRootFromParent_Done,
     /* 1051219 */   // Label 15558: @1051219
     /* 1051219 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1051296), // Rule ID 20515 //
     /* 1051224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1051241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051263 */     // MIs[0] policy
     /* 1051263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1051276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051295 */     // GIR_Coverage, 20515,
     /* 1051295 */     GIR_EraseRootFromParent_Done,
     /* 1051296 */   // Label 15559: @1051296
     /* 1051296 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1051373), // Rule ID 20518 //
     /* 1051301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1051312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1051315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1051318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051340 */     // MIs[0] policy
     /* 1051340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051372 */     // GIR_Coverage, 20518,
     /* 1051372 */     GIR_EraseRootFromParent_Done,
     /* 1051373 */   // Label 15560: @1051373
     /* 1051373 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1051450), // Rule ID 20519 //
     /* 1051378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1051389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1051392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1051395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051417 */     // MIs[0] policy
     /* 1051417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051449 */     // GIR_Coverage, 20519,
     /* 1051449 */     GIR_EraseRootFromParent_Done,
     /* 1051450 */   // Label 15561: @1051450
     /* 1051450 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1051527), // Rule ID 20522 //
     /* 1051455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051494 */     // MIs[0] policy
     /* 1051494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051526 */     // GIR_Coverage, 20522,
     /* 1051526 */     GIR_EraseRootFromParent_Done,
     /* 1051527 */   // Label 15562: @1051527
     /* 1051527 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1051604), // Rule ID 20523 //
     /* 1051532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051571 */     // MIs[0] policy
     /* 1051571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051581 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051603 */     // GIR_Coverage, 20523,
     /* 1051603 */     GIR_EraseRootFromParent_Done,
     /* 1051604 */   // Label 15563: @1051604
     /* 1051604 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1051681), // Rule ID 20526 //
     /* 1051609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051648 */     // MIs[0] policy
     /* 1051648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051680 */     // GIR_Coverage, 20526,
     /* 1051680 */     GIR_EraseRootFromParent_Done,
     /* 1051681 */   // Label 15564: @1051681
     /* 1051681 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1051758), // Rule ID 20527 //
     /* 1051686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051725 */     // MIs[0] policy
     /* 1051725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051735 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051757 */     // GIR_Coverage, 20527,
     /* 1051757 */     GIR_EraseRootFromParent_Done,
     /* 1051758 */   // Label 15565: @1051758
     /* 1051758 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1051835), // Rule ID 20530 //
     /* 1051763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051802 */     // MIs[0] policy
     /* 1051802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051834 */     // GIR_Coverage, 20530,
     /* 1051834 */     GIR_EraseRootFromParent_Done,
     /* 1051835 */   // Label 15566: @1051835
     /* 1051835 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1051912), // Rule ID 20531 //
     /* 1051840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051879 */     // MIs[0] policy
     /* 1051879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051911 */     // GIR_Coverage, 20531,
     /* 1051911 */     GIR_EraseRootFromParent_Done,
     /* 1051912 */   // Label 15567: @1051912
     /* 1051912 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1051989), // Rule ID 20534 //
     /* 1051917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051956 */     // MIs[0] policy
     /* 1051956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051988 */     // GIR_Coverage, 20534,
     /* 1051988 */     GIR_EraseRootFromParent_Done,
     /* 1051989 */   // Label 15568: @1051989
     /* 1051989 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1052066), // Rule ID 20535 //
     /* 1051994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1052005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1052008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1052011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052033 */     // MIs[0] policy
     /* 1052033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052065 */     // GIR_Coverage, 20535,
     /* 1052065 */     GIR_EraseRootFromParent_Done,
     /* 1052066 */   // Label 15569: @1052066
     /* 1052066 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1052143), // Rule ID 20538 //
     /* 1052071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1052082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1052085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1052088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052110 */     // MIs[0] policy
     /* 1052110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052142 */     // GIR_Coverage, 20538,
     /* 1052142 */     GIR_EraseRootFromParent_Done,
     /* 1052143 */   // Label 15570: @1052143
     /* 1052143 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1052220), // Rule ID 20539 //
     /* 1052148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1052159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1052162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1052165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052187 */     // MIs[0] policy
     /* 1052187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052197 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052219 */     // GIR_Coverage, 20539,
     /* 1052219 */     GIR_EraseRootFromParent_Done,
     /* 1052220 */   // Label 15571: @1052220
     /* 1052220 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1052297), // Rule ID 20542 //
     /* 1052225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1052236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1052239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1052242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052264 */     // MIs[0] policy
     /* 1052264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1052277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052296 */     // GIR_Coverage, 20542,
     /* 1052296 */     GIR_EraseRootFromParent_Done,
     /* 1052297 */   // Label 15572: @1052297
     /* 1052297 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1052374), // Rule ID 20543 //
     /* 1052302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1052313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1052316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1052319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052341 */     // MIs[0] policy
     /* 1052341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1052354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052373 */     // GIR_Coverage, 20543,
     /* 1052373 */     GIR_EraseRootFromParent_Done,
     /* 1052374 */   // Label 15573: @1052374
     /* 1052374 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1052451), // Rule ID 20546 //
     /* 1052379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052418 */     // MIs[0] policy
     /* 1052418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052450 */     // GIR_Coverage, 20546,
     /* 1052450 */     GIR_EraseRootFromParent_Done,
     /* 1052451 */   // Label 15574: @1052451
     /* 1052451 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1052528), // Rule ID 20547 //
     /* 1052456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052495 */     // MIs[0] policy
     /* 1052495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052527 */     // GIR_Coverage, 20547,
     /* 1052527 */     GIR_EraseRootFromParent_Done,
     /* 1052528 */   // Label 15575: @1052528
     /* 1052528 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1052605), // Rule ID 20550 //
     /* 1052533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052572 */     // MIs[0] policy
     /* 1052572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052604 */     // GIR_Coverage, 20550,
     /* 1052604 */     GIR_EraseRootFromParent_Done,
     /* 1052605 */   // Label 15576: @1052605
     /* 1052605 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1052682), // Rule ID 20551 //
     /* 1052610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052649 */     // MIs[0] policy
     /* 1052649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052659 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052681 */     // GIR_Coverage, 20551,
     /* 1052681 */     GIR_EraseRootFromParent_Done,
     /* 1052682 */   // Label 15577: @1052682
     /* 1052682 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1052759), // Rule ID 20876 //
     /* 1052687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052726 */     // MIs[0] policy
     /* 1052726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052758 */     // GIR_Coverage, 20876,
     /* 1052758 */     GIR_EraseRootFromParent_Done,
     /* 1052759 */   // Label 15578: @1052759
     /* 1052759 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1052836), // Rule ID 20877 //
     /* 1052764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052803 */     // MIs[0] policy
     /* 1052803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052813 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052835 */     // GIR_Coverage, 20877,
     /* 1052835 */     GIR_EraseRootFromParent_Done,
     /* 1052836 */   // Label 15579: @1052836
     /* 1052836 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1052913), // Rule ID 20880 //
     /* 1052841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052880 */     // MIs[0] policy
     /* 1052880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052912 */     // GIR_Coverage, 20880,
     /* 1052912 */     GIR_EraseRootFromParent_Done,
     /* 1052913 */   // Label 15580: @1052913
     /* 1052913 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1052990), // Rule ID 20881 //
     /* 1052918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052957 */     // MIs[0] policy
     /* 1052957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052989 */     // GIR_Coverage, 20881,
     /* 1052989 */     GIR_EraseRootFromParent_Done,
     /* 1052990 */   // Label 15581: @1052990
     /* 1052990 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1053067), // Rule ID 20884 //
     /* 1052995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1053006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1053009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1053012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053034 */     // MIs[0] policy
     /* 1053034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1053047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053066 */     // GIR_Coverage, 20884,
     /* 1053066 */     GIR_EraseRootFromParent_Done,
     /* 1053067 */   // Label 15582: @1053067
     /* 1053067 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1053144), // Rule ID 20885 //
     /* 1053072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1053083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1053086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1053089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053111 */     // MIs[0] policy
     /* 1053111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1053124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053143 */     // GIR_Coverage, 20885,
     /* 1053143 */     GIR_EraseRootFromParent_Done,
     /* 1053144 */   // Label 15583: @1053144
     /* 1053144 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1053221), // Rule ID 20888 //
     /* 1053149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1053160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1053163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1053166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053188 */     // MIs[0] policy
     /* 1053188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053220 */     // GIR_Coverage, 20888,
     /* 1053220 */     GIR_EraseRootFromParent_Done,
     /* 1053221 */   // Label 15584: @1053221
     /* 1053221 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1053298), // Rule ID 20889 //
     /* 1053226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1053237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1053240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1053243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053265 */     // MIs[0] policy
     /* 1053265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053297 */     // GIR_Coverage, 20889,
     /* 1053297 */     GIR_EraseRootFromParent_Done,
     /* 1053298 */   // Label 15585: @1053298
     /* 1053298 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1053375), // Rule ID 20892 //
     /* 1053303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1053314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1053317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1053320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053342 */     // MIs[0] policy
     /* 1053342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053374 */     // GIR_Coverage, 20892,
     /* 1053374 */     GIR_EraseRootFromParent_Done,
     /* 1053375 */   // Label 15586: @1053375
     /* 1053375 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1053452), // Rule ID 20893 //
     /* 1053380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1053391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1053394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1053397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053419 */     // MIs[0] policy
     /* 1053419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053429 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053451 */     // GIR_Coverage, 20893,
     /* 1053451 */     GIR_EraseRootFromParent_Done,
     /* 1053452 */   // Label 15587: @1053452
     /* 1053452 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1053529), // Rule ID 20896 //
     /* 1053457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053496 */     // MIs[0] policy
     /* 1053496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053528 */     // GIR_Coverage, 20896,
     /* 1053528 */     GIR_EraseRootFromParent_Done,
     /* 1053529 */   // Label 15588: @1053529
     /* 1053529 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1053606), // Rule ID 20897 //
     /* 1053534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053573 */     // MIs[0] policy
     /* 1053573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053605 */     // GIR_Coverage, 20897,
     /* 1053605 */     GIR_EraseRootFromParent_Done,
     /* 1053606 */   // Label 15589: @1053606
     /* 1053606 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1053683), // Rule ID 20900 //
     /* 1053611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053650 */     // MIs[0] policy
     /* 1053650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053682 */     // GIR_Coverage, 20900,
     /* 1053682 */     GIR_EraseRootFromParent_Done,
     /* 1053683 */   // Label 15590: @1053683
     /* 1053683 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1053760), // Rule ID 20901 //
     /* 1053688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053727 */     // MIs[0] policy
     /* 1053727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053737 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053759 */     // GIR_Coverage, 20901,
     /* 1053759 */     GIR_EraseRootFromParent_Done,
     /* 1053760 */   // Label 15591: @1053760
     /* 1053760 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1053837), // Rule ID 20904 //
     /* 1053765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053804 */     // MIs[0] policy
     /* 1053804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053836 */     // GIR_Coverage, 20904,
     /* 1053836 */     GIR_EraseRootFromParent_Done,
     /* 1053837 */   // Label 15592: @1053837
     /* 1053837 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1053914), // Rule ID 20905 //
     /* 1053842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053881 */     // MIs[0] policy
     /* 1053881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053891 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053913 */     // GIR_Coverage, 20905,
     /* 1053913 */     GIR_EraseRootFromParent_Done,
     /* 1053914 */   // Label 15593: @1053914
     /* 1053914 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1053991), // Rule ID 20908 //
     /* 1053919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053958 */     // MIs[0] policy
     /* 1053958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053990 */     // GIR_Coverage, 20908,
     /* 1053990 */     GIR_EraseRootFromParent_Done,
     /* 1053991 */   // Label 15594: @1053991
     /* 1053991 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1054068), // Rule ID 20909 //
     /* 1053996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1054007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1054010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1054013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1054016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054035 */     // MIs[0] policy
     /* 1054035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054045 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054067 */     // GIR_Coverage, 20909,
     /* 1054067 */     GIR_EraseRootFromParent_Done,
     /* 1054068 */   // Label 15595: @1054068
     /* 1054068 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1054145), // Rule ID 20912 //
     /* 1054073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1054084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1054087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1054090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054112 */     // MIs[0] policy
     /* 1054112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054144 */     // GIR_Coverage, 20912,
     /* 1054144 */     GIR_EraseRootFromParent_Done,
     /* 1054145 */   // Label 15596: @1054145
     /* 1054145 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1054222), // Rule ID 20913 //
     /* 1054150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1054161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1054164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1054167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054189 */     // MIs[0] policy
     /* 1054189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054221 */     // GIR_Coverage, 20913,
     /* 1054221 */     GIR_EraseRootFromParent_Done,
     /* 1054222 */   // Label 15597: @1054222
     /* 1054222 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1054299), // Rule ID 20916 //
     /* 1054227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1054238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1054241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1054244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054266 */     // MIs[0] policy
     /* 1054266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054276 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054298 */     // GIR_Coverage, 20916,
     /* 1054298 */     GIR_EraseRootFromParent_Done,
     /* 1054299 */   // Label 15598: @1054299
     /* 1054299 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1054376), // Rule ID 20917 //
     /* 1054304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1054315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1054318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1054321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054343 */     // MIs[0] policy
     /* 1054343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054375 */     // GIR_Coverage, 20917,
     /* 1054375 */     GIR_EraseRootFromParent_Done,
     /* 1054376 */   // Label 15599: @1054376
     /* 1054376 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1054453), // Rule ID 20920 //
     /* 1054381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054420 */     // MIs[0] policy
     /* 1054420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054452 */     // GIR_Coverage, 20920,
     /* 1054452 */     GIR_EraseRootFromParent_Done,
     /* 1054453 */   // Label 15600: @1054453
     /* 1054453 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1054530), // Rule ID 20921 //
     /* 1054458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054497 */     // MIs[0] policy
     /* 1054497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054529 */     // GIR_Coverage, 20921,
     /* 1054529 */     GIR_EraseRootFromParent_Done,
     /* 1054530 */   // Label 15601: @1054530
     /* 1054530 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1054607), // Rule ID 20924 //
     /* 1054535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054574 */     // MIs[0] policy
     /* 1054574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054606 */     // GIR_Coverage, 20924,
     /* 1054606 */     GIR_EraseRootFromParent_Done,
     /* 1054607 */   // Label 15602: @1054607
     /* 1054607 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1054684), // Rule ID 20925 //
     /* 1054612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054651 */     // MIs[0] policy
     /* 1054651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054683 */     // GIR_Coverage, 20925,
     /* 1054683 */     GIR_EraseRootFromParent_Done,
     /* 1054684 */   // Label 15603: @1054684
     /* 1054684 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1054761), // Rule ID 20928 //
     /* 1054689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054728 */     // MIs[0] policy
     /* 1054728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054738 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054760 */     // GIR_Coverage, 20928,
     /* 1054760 */     GIR_EraseRootFromParent_Done,
     /* 1054761 */   // Label 15604: @1054761
     /* 1054761 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1054838), // Rule ID 20929 //
     /* 1054766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054805 */     // MIs[0] policy
     /* 1054805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054815 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054837 */     // GIR_Coverage, 20929,
     /* 1054837 */     GIR_EraseRootFromParent_Done,
     /* 1054838 */   // Label 15605: @1054838
     /* 1054838 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1054915), // Rule ID 20932 //
     /* 1054843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054882 */     // MIs[0] policy
     /* 1054882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054914 */     // GIR_Coverage, 20932,
     /* 1054914 */     GIR_EraseRootFromParent_Done,
     /* 1054915 */   // Label 15606: @1054915
     /* 1054915 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1054992), // Rule ID 20933 //
     /* 1054920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054959 */     // MIs[0] policy
     /* 1054959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054969 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054991 */     // GIR_Coverage, 20933,
     /* 1054991 */     GIR_EraseRootFromParent_Done,
     /* 1054992 */   // Label 15607: @1054992
     /* 1054992 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1055069), // Rule ID 20936 //
     /* 1054997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055036 */     // MIs[0] policy
     /* 1055036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1055049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055068 */     // GIR_Coverage, 20936,
     /* 1055068 */     GIR_EraseRootFromParent_Done,
     /* 1055069 */   // Label 15608: @1055069
     /* 1055069 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1055146), // Rule ID 20937 //
     /* 1055074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1055085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1055088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1055091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055113 */     // MIs[0] policy
     /* 1055113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055123 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1055126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055145 */     // GIR_Coverage, 20937,
     /* 1055145 */     GIR_EraseRootFromParent_Done,
     /* 1055146 */   // Label 15609: @1055146
     /* 1055146 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1055223), // Rule ID 20940 //
     /* 1055151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055190 */     // MIs[0] policy
     /* 1055190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055222 */     // GIR_Coverage, 20940,
     /* 1055222 */     GIR_EraseRootFromParent_Done,
     /* 1055223 */   // Label 15610: @1055223
     /* 1055223 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1055300), // Rule ID 20941 //
     /* 1055228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1055239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1055242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1055245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055267 */     // MIs[0] policy
     /* 1055267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055277 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055299 */     // GIR_Coverage, 20941,
     /* 1055299 */     GIR_EraseRootFromParent_Done,
     /* 1055300 */   // Label 15611: @1055300
     /* 1055300 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1055377), // Rule ID 20944 //
     /* 1055305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055344 */     // MIs[0] policy
     /* 1055344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055376 */     // GIR_Coverage, 20944,
     /* 1055376 */     GIR_EraseRootFromParent_Done,
     /* 1055377 */   // Label 15612: @1055377
     /* 1055377 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1055454), // Rule ID 20945 //
     /* 1055382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1055393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1055396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1055399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055421 */     // MIs[0] policy
     /* 1055421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1055434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055453 */     // GIR_Coverage, 20945,
     /* 1055453 */     GIR_EraseRootFromParent_Done,
     /* 1055454 */   // Label 15613: @1055454
     /* 1055454 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1055531), // Rule ID 20948 //
     /* 1055459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055498 */     // MIs[0] policy
     /* 1055498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055530 */     // GIR_Coverage, 20948,
     /* 1055530 */     GIR_EraseRootFromParent_Done,
     /* 1055531 */   // Label 15614: @1055531
     /* 1055531 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1055608), // Rule ID 20949 //
     /* 1055536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055575 */     // MIs[0] policy
     /* 1055575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055585 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055607 */     // GIR_Coverage, 20949,
     /* 1055607 */     GIR_EraseRootFromParent_Done,
     /* 1055608 */   // Label 15615: @1055608
     /* 1055608 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1055685), // Rule ID 20952 //
     /* 1055613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055652 */     // MIs[0] policy
     /* 1055652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055684 */     // GIR_Coverage, 20952,
     /* 1055684 */     GIR_EraseRootFromParent_Done,
     /* 1055685 */   // Label 15616: @1055685
     /* 1055685 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1055762), // Rule ID 20953 //
     /* 1055690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055729 */     // MIs[0] policy
     /* 1055729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055761 */     // GIR_Coverage, 20953,
     /* 1055761 */     GIR_EraseRootFromParent_Done,
     /* 1055762 */   // Label 15617: @1055762
     /* 1055762 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1055839), // Rule ID 20956 //
     /* 1055767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055806 */     // MIs[0] policy
     /* 1055806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055838 */     // GIR_Coverage, 20956,
     /* 1055838 */     GIR_EraseRootFromParent_Done,
     /* 1055839 */   // Label 15618: @1055839
     /* 1055839 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1055916), // Rule ID 20957 //
     /* 1055844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055883 */     // MIs[0] policy
     /* 1055883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055893 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055915 */     // GIR_Coverage, 20957,
     /* 1055915 */     GIR_EraseRootFromParent_Done,
     /* 1055916 */   // Label 15619: @1055916
     /* 1055916 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1055993), // Rule ID 20960 //
     /* 1055921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055960 */     // MIs[0] policy
     /* 1055960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055992 */     // GIR_Coverage, 20960,
     /* 1055992 */     GIR_EraseRootFromParent_Done,
     /* 1055993 */   // Label 15620: @1055993
     /* 1055993 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1056070), // Rule ID 20961 //
     /* 1055998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1056009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1056012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056037 */     // MIs[0] policy
     /* 1056037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056047 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056069 */     // GIR_Coverage, 20961,
     /* 1056069 */     GIR_EraseRootFromParent_Done,
     /* 1056070 */   // Label 15621: @1056070
     /* 1056070 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1056147), // Rule ID 20964 //
     /* 1056075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1056086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1056089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056114 */     // MIs[0] policy
     /* 1056114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056146 */     // GIR_Coverage, 20964,
     /* 1056146 */     GIR_EraseRootFromParent_Done,
     /* 1056147 */   // Label 15622: @1056147
     /* 1056147 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1056224), // Rule ID 20965 //
     /* 1056152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1056163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1056166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056191 */     // MIs[0] policy
     /* 1056191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056201 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056223 */     // GIR_Coverage, 20965,
     /* 1056223 */     GIR_EraseRootFromParent_Done,
     /* 1056224 */   // Label 15623: @1056224
     /* 1056224 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1056301), // Rule ID 20968 //
     /* 1056229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1056240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1056243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1056246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1056249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056268 */     // MIs[0] policy
     /* 1056268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056278 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056300 */     // GIR_Coverage, 20968,
     /* 1056300 */     GIR_EraseRootFromParent_Done,
     /* 1056301 */   // Label 15624: @1056301
     /* 1056301 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1056378), // Rule ID 20969 //
     /* 1056306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1056317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1056320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1056323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1056326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056345 */     // MIs[0] policy
     /* 1056345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056355 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056377 */     // GIR_Coverage, 20969,
     /* 1056377 */     GIR_EraseRootFromParent_Done,
     /* 1056378 */   // Label 15625: @1056378
     /* 1056378 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1056455), // Rule ID 20972 //
     /* 1056383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056422 */     // MIs[0] policy
     /* 1056422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056454 */     // GIR_Coverage, 20972,
     /* 1056454 */     GIR_EraseRootFromParent_Done,
     /* 1056455 */   // Label 15626: @1056455
     /* 1056455 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1056532), // Rule ID 20973 //
     /* 1056460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056499 */     // MIs[0] policy
     /* 1056499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056531 */     // GIR_Coverage, 20973,
     /* 1056531 */     GIR_EraseRootFromParent_Done,
     /* 1056532 */   // Label 15627: @1056532
     /* 1056532 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1056609), // Rule ID 20976 //
     /* 1056537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056576 */     // MIs[0] policy
     /* 1056576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056608 */     // GIR_Coverage, 20976,
     /* 1056608 */     GIR_EraseRootFromParent_Done,
     /* 1056609 */   // Label 15628: @1056609
     /* 1056609 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1056686), // Rule ID 20977 //
     /* 1056614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056653 */     // MIs[0] policy
     /* 1056653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056663 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056685 */     // GIR_Coverage, 20977,
     /* 1056685 */     GIR_EraseRootFromParent_Done,
     /* 1056686 */   // Label 15629: @1056686
     /* 1056686 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1056763), // Rule ID 20980 //
     /* 1056691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056730 */     // MIs[0] policy
     /* 1056730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056762 */     // GIR_Coverage, 20980,
     /* 1056762 */     GIR_EraseRootFromParent_Done,
     /* 1056763 */   // Label 15630: @1056763
     /* 1056763 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1056840), // Rule ID 20981 //
     /* 1056768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056807 */     // MIs[0] policy
     /* 1056807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056817 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056839 */     // GIR_Coverage, 20981,
     /* 1056839 */     GIR_EraseRootFromParent_Done,
     /* 1056840 */   // Label 15631: @1056840
     /* 1056840 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1056917), // Rule ID 20984 //
     /* 1056845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056884 */     // MIs[0] policy
     /* 1056884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056916 */     // GIR_Coverage, 20984,
     /* 1056916 */     GIR_EraseRootFromParent_Done,
     /* 1056917 */   // Label 15632: @1056917
     /* 1056917 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1056994), // Rule ID 20985 //
     /* 1056922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056961 */     // MIs[0] policy
     /* 1056961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056993 */     // GIR_Coverage, 20985,
     /* 1056993 */     GIR_EraseRootFromParent_Done,
     /* 1056994 */   // Label 15633: @1056994
     /* 1056994 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1057071), // Rule ID 20988 //
     /* 1056999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1057016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057038 */     // MIs[0] policy
     /* 1057038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1057051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057070 */     // GIR_Coverage, 20988,
     /* 1057070 */     GIR_EraseRootFromParent_Done,
     /* 1057071 */   // Label 15634: @1057071
     /* 1057071 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1057148), // Rule ID 20989 //
     /* 1057076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1057093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057115 */     // MIs[0] policy
     /* 1057115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057125 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1057128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057147 */     // GIR_Coverage, 20989,
     /* 1057147 */     GIR_EraseRootFromParent_Done,
     /* 1057148 */   // Label 15635: @1057148
     /* 1057148 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1057225), // Rule ID 20992 //
     /* 1057153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1057170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057192 */     // MIs[0] policy
     /* 1057192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1057205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057224 */     // GIR_Coverage, 20992,
     /* 1057224 */     GIR_EraseRootFromParent_Done,
     /* 1057225 */   // Label 15636: @1057225
     /* 1057225 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1057302), // Rule ID 20993 //
     /* 1057230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1057238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1057247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057269 */     // MIs[0] policy
     /* 1057269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057279 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1057282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057301 */     // GIR_Coverage, 20993,
     /* 1057301 */     GIR_EraseRootFromParent_Done,
     /* 1057302 */   // Label 15637: @1057302
     /* 1057302 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1057379), // Rule ID 21260 //
     /* 1057307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057346 */     // MIs[0] policy
     /* 1057346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1057359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057378 */     // GIR_Coverage, 21260,
     /* 1057378 */     GIR_EraseRootFromParent_Done,
     /* 1057379 */   // Label 15638: @1057379
     /* 1057379 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1057456), // Rule ID 21261 //
     /* 1057384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057423 */     // MIs[0] policy
     /* 1057423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1057436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057455 */     // GIR_Coverage, 21261,
     /* 1057455 */     GIR_EraseRootFromParent_Done,
     /* 1057456 */   // Label 15639: @1057456
     /* 1057456 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1057533), // Rule ID 21264 //
     /* 1057461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057500 */     // MIs[0] policy
     /* 1057500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057532 */     // GIR_Coverage, 21264,
     /* 1057532 */     GIR_EraseRootFromParent_Done,
     /* 1057533 */   // Label 15640: @1057533
     /* 1057533 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1057610), // Rule ID 21265 //
     /* 1057538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057577 */     // MIs[0] policy
     /* 1057577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057587 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057609 */     // GIR_Coverage, 21265,
     /* 1057609 */     GIR_EraseRootFromParent_Done,
     /* 1057610 */   // Label 15641: @1057610
     /* 1057610 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1057687), // Rule ID 21268 //
     /* 1057615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057654 */     // MIs[0] policy
     /* 1057654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057686 */     // GIR_Coverage, 21268,
     /* 1057686 */     GIR_EraseRootFromParent_Done,
     /* 1057687 */   // Label 15642: @1057687
     /* 1057687 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1057764), // Rule ID 21269 //
     /* 1057692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057731 */     // MIs[0] policy
     /* 1057731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057763 */     // GIR_Coverage, 21269,
     /* 1057763 */     GIR_EraseRootFromParent_Done,
     /* 1057764 */   // Label 15643: @1057764
     /* 1057764 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1057841), // Rule ID 21272 //
     /* 1057769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057808 */     // MIs[0] policy
     /* 1057808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057840 */     // GIR_Coverage, 21272,
     /* 1057840 */     GIR_EraseRootFromParent_Done,
     /* 1057841 */   // Label 15644: @1057841
     /* 1057841 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1057918), // Rule ID 21273 //
     /* 1057846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057885 */     // MIs[0] policy
     /* 1057885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057895 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057917 */     // GIR_Coverage, 21273,
     /* 1057917 */     GIR_EraseRootFromParent_Done,
     /* 1057918 */   // Label 15645: @1057918
     /* 1057918 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1057995), // Rule ID 21276 //
     /* 1057923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057962 */     // MIs[0] policy
     /* 1057962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057994 */     // GIR_Coverage, 21276,
     /* 1057994 */     GIR_EraseRootFromParent_Done,
     /* 1057995 */   // Label 15646: @1057995
     /* 1057995 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1058072), // Rule ID 21277 //
     /* 1058000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058039 */     // MIs[0] policy
     /* 1058039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058049 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058071 */     // GIR_Coverage, 21277,
     /* 1058071 */     GIR_EraseRootFromParent_Done,
     /* 1058072 */   // Label 15647: @1058072
     /* 1058072 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1058149), // Rule ID 21280 //
     /* 1058077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058116 */     // MIs[0] policy
     /* 1058116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1058129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058148 */     // GIR_Coverage, 21280,
     /* 1058148 */     GIR_EraseRootFromParent_Done,
     /* 1058149 */   // Label 15648: @1058149
     /* 1058149 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1058226), // Rule ID 21281 //
     /* 1058154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058193 */     // MIs[0] policy
     /* 1058193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058203 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1058206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058225 */     // GIR_Coverage, 21281,
     /* 1058225 */     GIR_EraseRootFromParent_Done,
     /* 1058226 */   // Label 15649: @1058226
     /* 1058226 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1058303), // Rule ID 21284 //
     /* 1058231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058270 */     // MIs[0] policy
     /* 1058270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1058283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058302 */     // GIR_Coverage, 21284,
     /* 1058302 */     GIR_EraseRootFromParent_Done,
     /* 1058303 */   // Label 15650: @1058303
     /* 1058303 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1058380), // Rule ID 21285 //
     /* 1058308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058347 */     // MIs[0] policy
     /* 1058347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058357 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1058360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058379 */     // GIR_Coverage, 21285,
     /* 1058379 */     GIR_EraseRootFromParent_Done,
     /* 1058380 */   // Label 15651: @1058380
     /* 1058380 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1058457), // Rule ID 21288 //
     /* 1058385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058424 */     // MIs[0] policy
     /* 1058424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058456 */     // GIR_Coverage, 21288,
     /* 1058456 */     GIR_EraseRootFromParent_Done,
     /* 1058457 */   // Label 15652: @1058457
     /* 1058457 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1058534), // Rule ID 21289 //
     /* 1058462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058501 */     // MIs[0] policy
     /* 1058501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058533 */     // GIR_Coverage, 21289,
     /* 1058533 */     GIR_EraseRootFromParent_Done,
     /* 1058534 */   // Label 15653: @1058534
     /* 1058534 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1058611), // Rule ID 21292 //
     /* 1058539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058578 */     // MIs[0] policy
     /* 1058578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058610 */     // GIR_Coverage, 21292,
     /* 1058610 */     GIR_EraseRootFromParent_Done,
     /* 1058611 */   // Label 15654: @1058611
     /* 1058611 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1058688), // Rule ID 21293 //
     /* 1058616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058655 */     // MIs[0] policy
     /* 1058655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058665 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058687 */     // GIR_Coverage, 21293,
     /* 1058687 */     GIR_EraseRootFromParent_Done,
     /* 1058688 */   // Label 15655: @1058688
     /* 1058688 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1058765), // Rule ID 21296 //
     /* 1058693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058732 */     // MIs[0] policy
     /* 1058732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058764 */     // GIR_Coverage, 21296,
     /* 1058764 */     GIR_EraseRootFromParent_Done,
     /* 1058765 */   // Label 15656: @1058765
     /* 1058765 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1058842), // Rule ID 21297 //
     /* 1058770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058809 */     // MIs[0] policy
     /* 1058809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058841 */     // GIR_Coverage, 21297,
     /* 1058841 */     GIR_EraseRootFromParent_Done,
     /* 1058842 */   // Label 15657: @1058842
     /* 1058842 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1058919), // Rule ID 21300 //
     /* 1058847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058886 */     // MIs[0] policy
     /* 1058886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058918 */     // GIR_Coverage, 21300,
     /* 1058918 */     GIR_EraseRootFromParent_Done,
     /* 1058919 */   // Label 15658: @1058919
     /* 1058919 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1058996), // Rule ID 21301 //
     /* 1058924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058963 */     // MIs[0] policy
     /* 1058963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058973 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058995 */     // GIR_Coverage, 21301,
     /* 1058995 */     GIR_EraseRootFromParent_Done,
     /* 1058996 */   // Label 15659: @1058996
     /* 1058996 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1059073), // Rule ID 21304 //
     /* 1059001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059040 */     // MIs[0] policy
     /* 1059040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059072 */     // GIR_Coverage, 21304,
     /* 1059072 */     GIR_EraseRootFromParent_Done,
     /* 1059073 */   // Label 15660: @1059073
     /* 1059073 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1059150), // Rule ID 21305 //
     /* 1059078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1059095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059117 */     // MIs[0] policy
     /* 1059117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059149 */     // GIR_Coverage, 21305,
     /* 1059149 */     GIR_EraseRootFromParent_Done,
     /* 1059150 */   // Label 15661: @1059150
     /* 1059150 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1059227), // Rule ID 21308 //
     /* 1059155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059194 */     // MIs[0] policy
     /* 1059194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059226 */     // GIR_Coverage, 21308,
     /* 1059226 */     GIR_EraseRootFromParent_Done,
     /* 1059227 */   // Label 15662: @1059227
     /* 1059227 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1059304), // Rule ID 21309 //
     /* 1059232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059271 */     // MIs[0] policy
     /* 1059271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059281 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059303 */     // GIR_Coverage, 21309,
     /* 1059303 */     GIR_EraseRootFromParent_Done,
     /* 1059304 */   // Label 15663: @1059304
     /* 1059304 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1059381), // Rule ID 21312 //
     /* 1059309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1059320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1059323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059348 */     // MIs[0] policy
     /* 1059348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059380 */     // GIR_Coverage, 21312,
     /* 1059380 */     GIR_EraseRootFromParent_Done,
     /* 1059381 */   // Label 15664: @1059381
     /* 1059381 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1059458), // Rule ID 21313 //
     /* 1059386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1059397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1059400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059425 */     // MIs[0] policy
     /* 1059425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059435 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059457 */     // GIR_Coverage, 21313,
     /* 1059457 */     GIR_EraseRootFromParent_Done,
     /* 1059458 */   // Label 15665: @1059458
     /* 1059458 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1059535), // Rule ID 21316 //
     /* 1059463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059502 */     // MIs[0] policy
     /* 1059502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059534 */     // GIR_Coverage, 21316,
     /* 1059534 */     GIR_EraseRootFromParent_Done,
     /* 1059535 */   // Label 15666: @1059535
     /* 1059535 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1059612), // Rule ID 21317 //
     /* 1059540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059579 */     // MIs[0] policy
     /* 1059579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059611 */     // GIR_Coverage, 21317,
     /* 1059611 */     GIR_EraseRootFromParent_Done,
     /* 1059612 */   // Label 15667: @1059612
     /* 1059612 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1059689), // Rule ID 21320 //
     /* 1059617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059656 */     // MIs[0] policy
     /* 1059656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059688 */     // GIR_Coverage, 21320,
     /* 1059688 */     GIR_EraseRootFromParent_Done,
     /* 1059689 */   // Label 15668: @1059689
     /* 1059689 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1059766), // Rule ID 21321 //
     /* 1059694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059733 */     // MIs[0] policy
     /* 1059733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059765 */     // GIR_Coverage, 21321,
     /* 1059765 */     GIR_EraseRootFromParent_Done,
     /* 1059766 */   // Label 15669: @1059766
     /* 1059766 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1059843), // Rule ID 21324 //
     /* 1059771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059810 */     // MIs[0] policy
     /* 1059810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059842 */     // GIR_Coverage, 21324,
     /* 1059842 */     GIR_EraseRootFromParent_Done,
     /* 1059843 */   // Label 15670: @1059843
     /* 1059843 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1059920), // Rule ID 21325 //
     /* 1059848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059887 */     // MIs[0] policy
     /* 1059887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059897 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059919 */     // GIR_Coverage, 21325,
     /* 1059919 */     GIR_EraseRootFromParent_Done,
     /* 1059920 */   // Label 15671: @1059920
     /* 1059920 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1059997), // Rule ID 21328 //
     /* 1059925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059964 */     // MIs[0] policy
     /* 1059964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059996 */     // GIR_Coverage, 21328,
     /* 1059996 */     GIR_EraseRootFromParent_Done,
     /* 1059997 */   // Label 15672: @1059997
     /* 1059997 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1060074), // Rule ID 21329 //
     /* 1060002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1060005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1060010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060041 */     // MIs[0] policy
     /* 1060041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060051 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1060054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060073 */     // GIR_Coverage, 21329,
     /* 1060073 */     GIR_EraseRootFromParent_Done,
     /* 1060074 */   // Label 15673: @1060074
     /* 1060074 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1060151), // Rule ID 21332 //
     /* 1060079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1060090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1060093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1060096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060118 */     // MIs[0] policy
     /* 1060118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060128 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1060131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060150 */     // GIR_Coverage, 21332,
     /* 1060150 */     GIR_EraseRootFromParent_Done,
     /* 1060151 */   // Label 15674: @1060151
     /* 1060151 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1060228), // Rule ID 21333 //
     /* 1060156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1060167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1060170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1060173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060195 */     // MIs[0] policy
     /* 1060195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060205 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1060208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060227 */     // GIR_Coverage, 21333,
     /* 1060227 */     GIR_EraseRootFromParent_Done,
     /* 1060228 */   // Label 15675: @1060228
     /* 1060228 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1060305), // Rule ID 21336 //
     /* 1060233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1060244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1060247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1060250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060272 */     // MIs[0] policy
     /* 1060272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060282 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1060285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060304 */     // GIR_Coverage, 21336,
     /* 1060304 */     GIR_EraseRootFromParent_Done,
     /* 1060305 */   // Label 15676: @1060305
     /* 1060305 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1060382), // Rule ID 21337 //
     /* 1060310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1060321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1060324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1060327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060349 */     // MIs[0] policy
     /* 1060349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060359 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1060362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060381 */     // GIR_Coverage, 21337,
     /* 1060381 */     GIR_EraseRootFromParent_Done,
     /* 1060382 */   // Label 15677: @1060382
     /* 1060382 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1060459), // Rule ID 21340 //
     /* 1060387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060426 */     // MIs[0] policy
     /* 1060426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060436 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060458 */     // GIR_Coverage, 21340,
     /* 1060458 */     GIR_EraseRootFromParent_Done,
     /* 1060459 */   // Label 15678: @1060459
     /* 1060459 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1060536), // Rule ID 21341 //
     /* 1060464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060503 */     // MIs[0] policy
     /* 1060503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060513 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060535 */     // GIR_Coverage, 21341,
     /* 1060535 */     GIR_EraseRootFromParent_Done,
     /* 1060536 */   // Label 15679: @1060536
     /* 1060536 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1060613), // Rule ID 21344 //
     /* 1060541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060580 */     // MIs[0] policy
     /* 1060580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060612 */     // GIR_Coverage, 21344,
     /* 1060612 */     GIR_EraseRootFromParent_Done,
     /* 1060613 */   // Label 15680: @1060613
     /* 1060613 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1060690), // Rule ID 21345 //
     /* 1060618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060657 */     // MIs[0] policy
     /* 1060657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060667 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060689 */     // GIR_Coverage, 21345,
     /* 1060689 */     GIR_EraseRootFromParent_Done,
     /* 1060690 */   // Label 15681: @1060690
     /* 1060690 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1060767), // Rule ID 21348 //
     /* 1060695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060734 */     // MIs[0] policy
     /* 1060734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060766 */     // GIR_Coverage, 21348,
     /* 1060766 */     GIR_EraseRootFromParent_Done,
     /* 1060767 */   // Label 15682: @1060767
     /* 1060767 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1060844), // Rule ID 21349 //
     /* 1060772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060811 */     // MIs[0] policy
     /* 1060811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060821 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060843 */     // GIR_Coverage, 21349,
     /* 1060843 */     GIR_EraseRootFromParent_Done,
     /* 1060844 */   // Label 15683: @1060844
     /* 1060844 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1060921), // Rule ID 21352 //
     /* 1060849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060888 */     // MIs[0] policy
     /* 1060888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060898 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060920 */     // GIR_Coverage, 21352,
     /* 1060920 */     GIR_EraseRootFromParent_Done,
     /* 1060921 */   // Label 15684: @1060921
     /* 1060921 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1060998), // Rule ID 21353 //
     /* 1060926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060965 */     // MIs[0] policy
     /* 1060965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060975 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060997 */     // GIR_Coverage, 21353,
     /* 1060997 */     GIR_EraseRootFromParent_Done,
     /* 1060998 */   // Label 15685: @1060998
     /* 1060998 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1061075), // Rule ID 21356 //
     /* 1061003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1061014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1061017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061042 */     // MIs[0] policy
     /* 1061042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061052 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1061055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061074 */     // GIR_Coverage, 21356,
     /* 1061074 */     GIR_EraseRootFromParent_Done,
     /* 1061075 */   // Label 15686: @1061075
     /* 1061075 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1061152), // Rule ID 21357 //
     /* 1061080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1061091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1061094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1061097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061119 */     // MIs[0] policy
     /* 1061119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061129 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1061132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061151 */     // GIR_Coverage, 21357,
     /* 1061151 */     GIR_EraseRootFromParent_Done,
     /* 1061152 */   // Label 15687: @1061152
     /* 1061152 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1061229), // Rule ID 21360 //
     /* 1061157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1061168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1061171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061196 */     // MIs[0] policy
     /* 1061196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061206 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1061209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061228 */     // GIR_Coverage, 21360,
     /* 1061228 */     GIR_EraseRootFromParent_Done,
     /* 1061229 */   // Label 15688: @1061229
     /* 1061229 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1061306), // Rule ID 21361 //
     /* 1061234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1061245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1061248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1061251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061273 */     // MIs[0] policy
     /* 1061273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061283 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1061286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061305 */     // GIR_Coverage, 21361,
     /* 1061305 */     GIR_EraseRootFromParent_Done,
     /* 1061306 */   // Label 15689: @1061306
     /* 1061306 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1061383), // Rule ID 21364 //
     /* 1061311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061350 */     // MIs[0] policy
     /* 1061350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061360 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1061363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061382 */     // GIR_Coverage, 21364,
     /* 1061382 */     GIR_EraseRootFromParent_Done,
     /* 1061383 */   // Label 15690: @1061383
     /* 1061383 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1061460), // Rule ID 21365 //
     /* 1061388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061427 */     // MIs[0] policy
     /* 1061427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1061440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061459 */     // GIR_Coverage, 21365,
     /* 1061459 */     GIR_EraseRootFromParent_Done,
     /* 1061460 */   // Label 15691: @1061460
     /* 1061460 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1061537), // Rule ID 21368 //
     /* 1061465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061504 */     // MIs[0] policy
     /* 1061504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061514 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061536 */     // GIR_Coverage, 21368,
     /* 1061536 */     GIR_EraseRootFromParent_Done,
     /* 1061537 */   // Label 15692: @1061537
     /* 1061537 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1061614), // Rule ID 21369 //
     /* 1061542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061581 */     // MIs[0] policy
     /* 1061581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061591 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061613 */     // GIR_Coverage, 21369,
     /* 1061613 */     GIR_EraseRootFromParent_Done,
     /* 1061614 */   // Label 15693: @1061614
     /* 1061614 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1061691), // Rule ID 21372 //
     /* 1061619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061658 */     // MIs[0] policy
     /* 1061658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061668 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061690 */     // GIR_Coverage, 21372,
     /* 1061690 */     GIR_EraseRootFromParent_Done,
     /* 1061691 */   // Label 15694: @1061691
     /* 1061691 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1061768), // Rule ID 21373 //
     /* 1061696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061735 */     // MIs[0] policy
     /* 1061735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061745 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061767 */     // GIR_Coverage, 21373,
     /* 1061767 */     GIR_EraseRootFromParent_Done,
     /* 1061768 */   // Label 15695: @1061768
     /* 1061768 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1061845), // Rule ID 21376 //
     /* 1061773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061812 */     // MIs[0] policy
     /* 1061812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061844 */     // GIR_Coverage, 21376,
     /* 1061844 */     GIR_EraseRootFromParent_Done,
     /* 1061845 */   // Label 15696: @1061845
     /* 1061845 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1061922), // Rule ID 21377 //
     /* 1061850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061889 */     // MIs[0] policy
     /* 1061889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061899 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061921 */     // GIR_Coverage, 21377,
     /* 1061921 */     GIR_EraseRootFromParent_Done,
     /* 1061922 */   // Label 15697: @1061922
     /* 1061922 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1061999), // Rule ID 21380 //
     /* 1061927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061966 */     // MIs[0] policy
     /* 1061966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061976 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061998 */     // GIR_Coverage, 21380,
     /* 1061998 */     GIR_EraseRootFromParent_Done,
     /* 1061999 */   // Label 15698: @1061999
     /* 1061999 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1062076), // Rule ID 21381 //
     /* 1062004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1062015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1062018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1062021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062043 */     // MIs[0] policy
     /* 1062043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062053 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11344:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1062056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062075 */     // GIR_Coverage, 21381,
     /* 1062075 */     GIR_EraseRootFromParent_Done,
     /* 1062076 */   // Label 15699: @1062076
     /* 1062076 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1062153), // Rule ID 21384 //
     /* 1062081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1062084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1062092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1062095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1062098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062120 */     // MIs[0] policy
     /* 1062120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1062133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062152 */     // GIR_Coverage, 21384,
     /* 1062152 */     GIR_EraseRootFromParent_Done,
     /* 1062153 */   // Label 15700: @1062153
     /* 1062153 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1062230), // Rule ID 21385 //
     /* 1062158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1062169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1062172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1062175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062197 */     // MIs[0] policy
     /* 1062197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062207 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11344:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1062210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062229 */     // GIR_Coverage, 21385,
     /* 1062229 */     GIR_EraseRootFromParent_Done,
     /* 1062230 */   // Label 15701: @1062230
     /* 1062230 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1062307), // Rule ID 21388 //
     /* 1062235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1062238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062274 */     // MIs[0] policy
     /* 1062274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1062287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062306 */     // GIR_Coverage, 21388,
     /* 1062306 */     GIR_EraseRootFromParent_Done,
     /* 1062307 */   // Label 15702: @1062307
     /* 1062307 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1062384), // Rule ID 21389 //
     /* 1062312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1062315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1062320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062351 */     // MIs[0] policy
     /* 1062351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062361 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11344:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1062364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062383 */     // GIR_Coverage, 21389,
     /* 1062383 */     GIR_EraseRootFromParent_Done,
     /* 1062384 */   // Label 15703: @1062384
     /* 1062384 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1062461), // Rule ID 21392 //
     /* 1062389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062428 */     // MIs[0] policy
     /* 1062428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062438 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062460 */     // GIR_Coverage, 21392,
     /* 1062460 */     GIR_EraseRootFromParent_Done,
     /* 1062461 */   // Label 15704: @1062461
     /* 1062461 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1062538), // Rule ID 21393 //
     /* 1062466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062505 */     // MIs[0] policy
     /* 1062505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062515 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062537 */     // GIR_Coverage, 21393,
     /* 1062537 */     GIR_EraseRootFromParent_Done,
     /* 1062538 */   // Label 15705: @1062538
     /* 1062538 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1062615), // Rule ID 21396 //
     /* 1062543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062582 */     // MIs[0] policy
     /* 1062582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062614 */     // GIR_Coverage, 21396,
     /* 1062614 */     GIR_EraseRootFromParent_Done,
     /* 1062615 */   // Label 15706: @1062615
     /* 1062615 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1062692), // Rule ID 21397 //
     /* 1062620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062659 */     // MIs[0] policy
     /* 1062659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062669 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062691 */     // GIR_Coverage, 21397,
     /* 1062691 */     GIR_EraseRootFromParent_Done,
     /* 1062692 */   // Label 15707: @1062692
     /* 1062692 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1062769), // Rule ID 21400 //
     /* 1062697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062736 */     // MIs[0] policy
     /* 1062736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062768 */     // GIR_Coverage, 21400,
     /* 1062768 */     GIR_EraseRootFromParent_Done,
     /* 1062769 */   // Label 15708: @1062769
     /* 1062769 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1062846), // Rule ID 21401 //
     /* 1062774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062813 */     // MIs[0] policy
     /* 1062813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062823 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062845 */     // GIR_Coverage, 21401,
     /* 1062845 */     GIR_EraseRootFromParent_Done,
     /* 1062846 */   // Label 15709: @1062846
     /* 1062846 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1062923), // Rule ID 21404 //
     /* 1062851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062890 */     // MIs[0] policy
     /* 1062890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062922 */     // GIR_Coverage, 21404,
     /* 1062922 */     GIR_EraseRootFromParent_Done,
     /* 1062923 */   // Label 15710: @1062923
     /* 1062923 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1063000), // Rule ID 21405 //
     /* 1062928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062967 */     // MIs[0] policy
     /* 1062967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062977 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062999 */     // GIR_Coverage, 21405,
     /* 1062999 */     GIR_EraseRootFromParent_Done,
     /* 1063000 */   // Label 15711: @1063000
     /* 1063000 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1063077), // Rule ID 21408 //
     /* 1063005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1063022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063044 */     // MIs[0] policy
     /* 1063044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063054 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1063057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063076 */     // GIR_Coverage, 21408,
     /* 1063076 */     GIR_EraseRootFromParent_Done,
     /* 1063077 */   // Label 15712: @1063077
     /* 1063077 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1063154), // Rule ID 21409 //
     /* 1063082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1063093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1063096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1063099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063121 */     // MIs[0] policy
     /* 1063121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063131 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1063134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063153 */     // GIR_Coverage, 21409,
     /* 1063153 */     GIR_EraseRootFromParent_Done,
     /* 1063154 */   // Label 15713: @1063154
     /* 1063154 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1063231), // Rule ID 21412 //
     /* 1063159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1063176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1063179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063198 */     // MIs[0] policy
     /* 1063198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063208 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1063211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063230 */     // GIR_Coverage, 21412,
     /* 1063230 */     GIR_EraseRootFromParent_Done,
     /* 1063231 */   // Label 15714: @1063231
     /* 1063231 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1063308), // Rule ID 21413 //
     /* 1063236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1063247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1063250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1063253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1063256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063275 */     // MIs[0] policy
     /* 1063275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063285 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1063288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063307 */     // GIR_Coverage, 21413,
     /* 1063307 */     GIR_EraseRootFromParent_Done,
     /* 1063308 */   // Label 15715: @1063308
     /* 1063308 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1063385), // Rule ID 21416 //
     /* 1063313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063352 */     // MIs[0] policy
     /* 1063352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063362 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1063365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063384 */     // GIR_Coverage, 21416,
     /* 1063384 */     GIR_EraseRootFromParent_Done,
     /* 1063385 */   // Label 15716: @1063385
     /* 1063385 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1063462), // Rule ID 21417 //
     /* 1063390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063429 */     // MIs[0] policy
     /* 1063429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063439 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1063442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063461 */     // GIR_Coverage, 21417,
     /* 1063461 */     GIR_EraseRootFromParent_Done,
     /* 1063462 */   // Label 15717: @1063462
     /* 1063462 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1063539), // Rule ID 21420 //
     /* 1063467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063506 */     // MIs[0] policy
     /* 1063506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063538 */     // GIR_Coverage, 21420,
     /* 1063538 */     GIR_EraseRootFromParent_Done,
     /* 1063539 */   // Label 15718: @1063539
     /* 1063539 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1063616), // Rule ID 21421 //
     /* 1063544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063583 */     // MIs[0] policy
     /* 1063583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063593 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063615 */     // GIR_Coverage, 21421,
     /* 1063615 */     GIR_EraseRootFromParent_Done,
     /* 1063616 */   // Label 15719: @1063616
     /* 1063616 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1063693), // Rule ID 21424 //
     /* 1063621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063660 */     // MIs[0] policy
     /* 1063660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063692 */     // GIR_Coverage, 21424,
     /* 1063692 */     GIR_EraseRootFromParent_Done,
     /* 1063693 */   // Label 15720: @1063693
     /* 1063693 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1063770), // Rule ID 21425 //
     /* 1063698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063737 */     // MIs[0] policy
     /* 1063737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063747 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063769 */     // GIR_Coverage, 21425,
     /* 1063769 */     GIR_EraseRootFromParent_Done,
     /* 1063770 */   // Label 15721: @1063770
     /* 1063770 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1063847), // Rule ID 21428 //
     /* 1063775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063814 */     // MIs[0] policy
     /* 1063814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063824 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063846 */     // GIR_Coverage, 21428,
     /* 1063846 */     GIR_EraseRootFromParent_Done,
     /* 1063847 */   // Label 15722: @1063847
     /* 1063847 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1063924), // Rule ID 21429 //
     /* 1063852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063891 */     // MIs[0] policy
     /* 1063891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063901 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063923 */     // GIR_Coverage, 21429,
     /* 1063923 */     GIR_EraseRootFromParent_Done,
     /* 1063924 */   // Label 15723: @1063924
     /* 1063924 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1064001), // Rule ID 21432 //
     /* 1063929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063968 */     // MIs[0] policy
     /* 1063968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063978 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064000 */     // GIR_Coverage, 21432,
     /* 1064000 */     GIR_EraseRootFromParent_Done,
     /* 1064001 */   // Label 15724: @1064001
     /* 1064001 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1064078), // Rule ID 21433 //
     /* 1064006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064045 */     // MIs[0] policy
     /* 1064045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064055 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1064058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064077 */     // GIR_Coverage, 21433,
     /* 1064077 */     GIR_EraseRootFromParent_Done,
     /* 1064078 */   // Label 15725: @1064078
     /* 1064078 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1064155), // Rule ID 21436 //
     /* 1064083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064122 */     // MIs[0] policy
     /* 1064122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1064135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064154 */     // GIR_Coverage, 21436,
     /* 1064154 */     GIR_EraseRootFromParent_Done,
     /* 1064155 */   // Label 15726: @1064155
     /* 1064155 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1064232), // Rule ID 21437 //
     /* 1064160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064199 */     // MIs[0] policy
     /* 1064199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064209 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1064212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064231 */     // GIR_Coverage, 21437,
     /* 1064231 */     GIR_EraseRootFromParent_Done,
     /* 1064232 */   // Label 15727: @1064232
     /* 1064232 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1064309), // Rule ID 21440 //
     /* 1064237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064276 */     // MIs[0] policy
     /* 1064276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064286 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1064289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064308 */     // GIR_Coverage, 21440,
     /* 1064308 */     GIR_EraseRootFromParent_Done,
     /* 1064309 */   // Label 15728: @1064309
     /* 1064309 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1064386), // Rule ID 21441 //
     /* 1064314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064353 */     // MIs[0] policy
     /* 1064353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064363 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1064366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064385 */     // GIR_Coverage, 21441,
     /* 1064385 */     GIR_EraseRootFromParent_Done,
     /* 1064386 */   // Label 15729: @1064386
     /* 1064386 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1064463), // Rule ID 21444 //
     /* 1064391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064430 */     // MIs[0] policy
     /* 1064430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064462 */     // GIR_Coverage, 21444,
     /* 1064462 */     GIR_EraseRootFromParent_Done,
     /* 1064463 */   // Label 15730: @1064463
     /* 1064463 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1064540), // Rule ID 21445 //
     /* 1064468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064507 */     // MIs[0] policy
     /* 1064507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064517 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064539 */     // GIR_Coverage, 21445,
     /* 1064539 */     GIR_EraseRootFromParent_Done,
     /* 1064540 */   // Label 15731: @1064540
     /* 1064540 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1064617), // Rule ID 21448 //
     /* 1064545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064584 */     // MIs[0] policy
     /* 1064584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064594 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064616 */     // GIR_Coverage, 21448,
     /* 1064616 */     GIR_EraseRootFromParent_Done,
     /* 1064617 */   // Label 15732: @1064617
     /* 1064617 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1064694), // Rule ID 21449 //
     /* 1064622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064661 */     // MIs[0] policy
     /* 1064661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064671 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064693 */     // GIR_Coverage, 21449,
     /* 1064693 */     GIR_EraseRootFromParent_Done,
     /* 1064694 */   // Label 15733: @1064694
     /* 1064694 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1064771), // Rule ID 21452 //
     /* 1064699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064738 */     // MIs[0] policy
     /* 1064738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064748 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064770 */     // GIR_Coverage, 21452,
     /* 1064770 */     GIR_EraseRootFromParent_Done,
     /* 1064771 */   // Label 15734: @1064771
     /* 1064771 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1064848), // Rule ID 21453 //
     /* 1064776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064815 */     // MIs[0] policy
     /* 1064815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064825 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064847 */     // GIR_Coverage, 21453,
     /* 1064847 */     GIR_EraseRootFromParent_Done,
     /* 1064848 */   // Label 15735: @1064848
     /* 1064848 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1064925), // Rule ID 21456 //
     /* 1064853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064892 */     // MIs[0] policy
     /* 1064892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064902 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064924 */     // GIR_Coverage, 21456,
     /* 1064924 */     GIR_EraseRootFromParent_Done,
     /* 1064925 */   // Label 15736: @1064925
     /* 1064925 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1065002), // Rule ID 21457 //
     /* 1064930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064969 */     // MIs[0] policy
     /* 1064969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064979 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065001 */     // GIR_Coverage, 21457,
     /* 1065001 */     GIR_EraseRootFromParent_Done,
     /* 1065002 */   // Label 15737: @1065002
     /* 1065002 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1065079), // Rule ID 21460 //
     /* 1065007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1065018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1065021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065046 */     // MIs[0] policy
     /* 1065046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1065059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065078 */     // GIR_Coverage, 21460,
     /* 1065078 */     GIR_EraseRootFromParent_Done,
     /* 1065079 */   // Label 15738: @1065079
     /* 1065079 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1065156), // Rule ID 21461 //
     /* 1065084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1065095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1065098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065123 */     // MIs[0] policy
     /* 1065123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1065136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065155 */     // GIR_Coverage, 21461,
     /* 1065155 */     GIR_EraseRootFromParent_Done,
     /* 1065156 */   // Label 15739: @1065156
     /* 1065156 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1065233), // Rule ID 21464 //
     /* 1065161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1065172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1065175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065200 */     // MIs[0] policy
     /* 1065200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1065213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065232 */     // GIR_Coverage, 21464,
     /* 1065232 */     GIR_EraseRootFromParent_Done,
     /* 1065233 */   // Label 15740: @1065233
     /* 1065233 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1065310), // Rule ID 21465 //
     /* 1065238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1065249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1065252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065277 */     // MIs[0] policy
     /* 1065277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065287 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1065290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065309 */     // GIR_Coverage, 21465,
     /* 1065309 */     GIR_EraseRootFromParent_Done,
     /* 1065310 */   // Label 15741: @1065310
     /* 1065310 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1065387), // Rule ID 21468 //
     /* 1065315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1065318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065354 */     // MIs[0] policy
     /* 1065354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065364 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1065367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065386 */     // GIR_Coverage, 21468,
     /* 1065386 */     GIR_EraseRootFromParent_Done,
     /* 1065387 */   // Label 15742: @1065387
     /* 1065387 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1065464), // Rule ID 21469 //
     /* 1065392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1065395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065431 */     // MIs[0] policy
     /* 1065431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065441 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1065444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065463 */     // GIR_Coverage, 21469,
     /* 1065463 */     GIR_EraseRootFromParent_Done,
     /* 1065464 */   // Label 15743: @1065464
     /* 1065464 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1065541), // Rule ID 21472 //
     /* 1065469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065508 */     // MIs[0] policy
     /* 1065508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065518 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065540 */     // GIR_Coverage, 21472,
     /* 1065540 */     GIR_EraseRootFromParent_Done,
     /* 1065541 */   // Label 15744: @1065541
     /* 1065541 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1065618), // Rule ID 21473 //
     /* 1065546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065585 */     // MIs[0] policy
     /* 1065585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065595 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065617 */     // GIR_Coverage, 21473,
     /* 1065617 */     GIR_EraseRootFromParent_Done,
     /* 1065618 */   // Label 15745: @1065618
     /* 1065618 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1065695), // Rule ID 21476 //
     /* 1065623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065662 */     // MIs[0] policy
     /* 1065662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065672 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065694 */     // GIR_Coverage, 21476,
     /* 1065694 */     GIR_EraseRootFromParent_Done,
     /* 1065695 */   // Label 15746: @1065695
     /* 1065695 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1065772), // Rule ID 21477 //
     /* 1065700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065739 */     // MIs[0] policy
     /* 1065739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065749 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065771 */     // GIR_Coverage, 21477,
     /* 1065771 */     GIR_EraseRootFromParent_Done,
     /* 1065772 */   // Label 15747: @1065772
     /* 1065772 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1065849), // Rule ID 21480 //
     /* 1065777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065816 */     // MIs[0] policy
     /* 1065816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065826 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065848 */     // GIR_Coverage, 21480,
     /* 1065848 */     GIR_EraseRootFromParent_Done,
     /* 1065849 */   // Label 15748: @1065849
     /* 1065849 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1065926), // Rule ID 21481 //
     /* 1065854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065893 */     // MIs[0] policy
     /* 1065893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065903 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065925 */     // GIR_Coverage, 21481,
     /* 1065925 */     GIR_EraseRootFromParent_Done,
     /* 1065926 */   // Label 15749: @1065926
     /* 1065926 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1066003), // Rule ID 21484 //
     /* 1065931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065970 */     // MIs[0] policy
     /* 1065970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065980 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066002 */     // GIR_Coverage, 21484,
     /* 1066002 */     GIR_EraseRootFromParent_Done,
     /* 1066003 */   // Label 15750: @1066003
     /* 1066003 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1066080), // Rule ID 21485 //
     /* 1066008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1066011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1066016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1066019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1066022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1066025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066047 */     // MIs[0] policy
     /* 1066047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066057 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1066060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066079 */     // GIR_Coverage, 21485,
     /* 1066079 */     GIR_EraseRootFromParent_Done,
     /* 1066080 */   // Label 15751: @1066080
     /* 1066080 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1066157), // Rule ID 21728 //
     /* 1066085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1066096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1066099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066124 */     // MIs[0] policy
     /* 1066124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066134 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1066137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066156 */     // GIR_Coverage, 21728,
     /* 1066156 */     GIR_EraseRootFromParent_Done,
     /* 1066157 */   // Label 15752: @1066157
     /* 1066157 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1066234), // Rule ID 21729 //
     /* 1066162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1066173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1066176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066201 */     // MIs[0] policy
     /* 1066201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1066214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066233 */     // GIR_Coverage, 21729,
     /* 1066233 */     GIR_EraseRootFromParent_Done,
     /* 1066234 */   // Label 15753: @1066234
     /* 1066234 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1066311), // Rule ID 21732 //
     /* 1066239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1066250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1066253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066278 */     // MIs[0] policy
     /* 1066278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066288 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066310 */     // GIR_Coverage, 21732,
     /* 1066310 */     GIR_EraseRootFromParent_Done,
     /* 1066311 */   // Label 15754: @1066311
     /* 1066311 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1066388), // Rule ID 21733 //
     /* 1066316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1066327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1066330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066355 */     // MIs[0] policy
     /* 1066355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066365 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066387 */     // GIR_Coverage, 21733,
     /* 1066387 */     GIR_EraseRootFromParent_Done,
     /* 1066388 */   // Label 15755: @1066388
     /* 1066388 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1066465), // Rule ID 21736 //
     /* 1066393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066432 */     // MIs[0] policy
     /* 1066432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066442 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066464 */     // GIR_Coverage, 21736,
     /* 1066464 */     GIR_EraseRootFromParent_Done,
     /* 1066465 */   // Label 15756: @1066465
     /* 1066465 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1066542), // Rule ID 21737 //
     /* 1066470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066509 */     // MIs[0] policy
     /* 1066509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066541 */     // GIR_Coverage, 21737,
     /* 1066541 */     GIR_EraseRootFromParent_Done,
     /* 1066542 */   // Label 15757: @1066542
     /* 1066542 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1066619), // Rule ID 21740 //
     /* 1066547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066586 */     // MIs[0] policy
     /* 1066586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066618 */     // GIR_Coverage, 21740,
     /* 1066618 */     GIR_EraseRootFromParent_Done,
     /* 1066619 */   // Label 15758: @1066619
     /* 1066619 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1066696), // Rule ID 21741 //
     /* 1066624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066663 */     // MIs[0] policy
     /* 1066663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066673 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11290:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066695 */     // GIR_Coverage, 21741,
     /* 1066695 */     GIR_EraseRootFromParent_Done,
     /* 1066696 */   // Label 15759: @1066696
     /* 1066696 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1066773), // Rule ID 21744 //
     /* 1066701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066740 */     // MIs[0] policy
     /* 1066740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066772 */     // GIR_Coverage, 21744,
     /* 1066772 */     GIR_EraseRootFromParent_Done,
     /* 1066773 */   // Label 15760: @1066773
     /* 1066773 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1066850), // Rule ID 21745 //
     /* 1066778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066817 */     // MIs[0] policy
     /* 1066817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066849 */     // GIR_Coverage, 21745,
     /* 1066849 */     GIR_EraseRootFromParent_Done,
     /* 1066850 */   // Label 15761: @1066850
     /* 1066850 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1066927), // Rule ID 21748 //
     /* 1066855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066894 */     // MIs[0] policy
     /* 1066894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066904 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066926 */     // GIR_Coverage, 21748,
     /* 1066926 */     GIR_EraseRootFromParent_Done,
     /* 1066927 */   // Label 15762: @1066927
     /* 1066927 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1067004), // Rule ID 21749 //
     /* 1066932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066971 */     // MIs[0] policy
     /* 1066971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066981 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067003 */     // GIR_Coverage, 21749,
     /* 1067003 */     GIR_EraseRootFromParent_Done,
     /* 1067004 */   // Label 15763: @1067004
     /* 1067004 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1067081), // Rule ID 21752 //
     /* 1067009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1067020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1067023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067048 */     // MIs[0] policy
     /* 1067048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1067061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067080 */     // GIR_Coverage, 21752,
     /* 1067080 */     GIR_EraseRootFromParent_Done,
     /* 1067081 */   // Label 15764: @1067081
     /* 1067081 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1067158), // Rule ID 21753 //
     /* 1067086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1067097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1067100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067125 */     // MIs[0] policy
     /* 1067125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067135 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1067138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067157 */     // GIR_Coverage, 21753,
     /* 1067157 */     GIR_EraseRootFromParent_Done,
     /* 1067158 */   // Label 15765: @1067158
     /* 1067158 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1067235), // Rule ID 21756 //
     /* 1067163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1067174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1067177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067202 */     // MIs[0] policy
     /* 1067202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067234 */     // GIR_Coverage, 21756,
     /* 1067234 */     GIR_EraseRootFromParent_Done,
     /* 1067235 */   // Label 15766: @1067235
     /* 1067235 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1067312), // Rule ID 21757 //
     /* 1067240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1067251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1067254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067279 */     // MIs[0] policy
     /* 1067279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067311 */     // GIR_Coverage, 21757,
     /* 1067311 */     GIR_EraseRootFromParent_Done,
     /* 1067312 */   // Label 15767: @1067312
     /* 1067312 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1067389), // Rule ID 21760 //
     /* 1067317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1067328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1067331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067356 */     // MIs[0] policy
     /* 1067356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067388 */     // GIR_Coverage, 21760,
     /* 1067388 */     GIR_EraseRootFromParent_Done,
     /* 1067389 */   // Label 15768: @1067389
     /* 1067389 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1067466), // Rule ID 21761 //
     /* 1067394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1067405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1067408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067433 */     // MIs[0] policy
     /* 1067433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11290:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067465 */     // GIR_Coverage, 21761,
     /* 1067465 */     GIR_EraseRootFromParent_Done,
     /* 1067466 */   // Label 15769: @1067466
     /* 1067466 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1067543), // Rule ID 21764 //
     /* 1067471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067510 */     // MIs[0] policy
     /* 1067510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067542 */     // GIR_Coverage, 21764,
     /* 1067542 */     GIR_EraseRootFromParent_Done,
     /* 1067543 */   // Label 15770: @1067543
     /* 1067543 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1067620), // Rule ID 21765 //
     /* 1067548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067587 */     // MIs[0] policy
     /* 1067587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067619 */     // GIR_Coverage, 21765,
     /* 1067619 */     GIR_EraseRootFromParent_Done,
     /* 1067620 */   // Label 15771: @1067620
     /* 1067620 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1067697), // Rule ID 21768 //
     /* 1067625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067664 */     // MIs[0] policy
     /* 1067664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067696 */     // GIR_Coverage, 21768,
     /* 1067696 */     GIR_EraseRootFromParent_Done,
     /* 1067697 */   // Label 15772: @1067697
     /* 1067697 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1067774), // Rule ID 21769 //
     /* 1067702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067741 */     // MIs[0] policy
     /* 1067741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067751 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067773 */     // GIR_Coverage, 21769,
     /* 1067773 */     GIR_EraseRootFromParent_Done,
     /* 1067774 */   // Label 15773: @1067774
     /* 1067774 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1067851), // Rule ID 21772 //
     /* 1067779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067818 */     // MIs[0] policy
     /* 1067818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067850 */     // GIR_Coverage, 21772,
     /* 1067850 */     GIR_EraseRootFromParent_Done,
     /* 1067851 */   // Label 15774: @1067851
     /* 1067851 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1067928), // Rule ID 21773 //
     /* 1067856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067895 */     // MIs[0] policy
     /* 1067895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067905 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067927 */     // GIR_Coverage, 21773,
     /* 1067927 */     GIR_EraseRootFromParent_Done,
     /* 1067928 */   // Label 15775: @1067928
     /* 1067928 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1068005), // Rule ID 21776 //
     /* 1067933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067972 */     // MIs[0] policy
     /* 1067972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068004 */     // GIR_Coverage, 21776,
     /* 1068004 */     GIR_EraseRootFromParent_Done,
     /* 1068005 */   // Label 15776: @1068005
     /* 1068005 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1068082), // Rule ID 21777 //
     /* 1068010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1068027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068049 */     // MIs[0] policy
     /* 1068049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1068062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068081 */     // GIR_Coverage, 21777,
     /* 1068081 */     GIR_EraseRootFromParent_Done,
     /* 1068082 */   // Label 15777: @1068082
     /* 1068082 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1068159), // Rule ID 21780 //
     /* 1068087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1068090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068126 */     // MIs[0] policy
     /* 1068126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1068139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068158 */     // GIR_Coverage, 21780,
     /* 1068158 */     GIR_EraseRootFromParent_Done,
     /* 1068159 */   // Label 15778: @1068159
     /* 1068159 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1068236), // Rule ID 21781 //
     /* 1068164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1068181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068203 */     // MIs[0] policy
     /* 1068203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1068216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068235 */     // GIR_Coverage, 21781,
     /* 1068235 */     GIR_EraseRootFromParent_Done,
     /* 1068236 */   // Label 15779: @1068236
     /* 1068236 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1068313), // Rule ID 21784 //
     /* 1068241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1068244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068280 */     // MIs[0] policy
     /* 1068280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1068293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068312 */     // GIR_Coverage, 21784,
     /* 1068312 */     GIR_EraseRootFromParent_Done,
     /* 1068313 */   // Label 15780: @1068313
     /* 1068313 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1068390), // Rule ID 21785 //
     /* 1068318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1068326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1068335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068357 */     // MIs[0] policy
     /* 1068357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068367 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1068370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068389 */     // GIR_Coverage, 21785,
     /* 1068389 */     GIR_EraseRootFromParent_Done,
     /* 1068390 */   // Label 15781: @1068390
     /* 1068390 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1068467), // Rule ID 21788 //
     /* 1068395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068434 */     // MIs[0] policy
     /* 1068434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068466 */     // GIR_Coverage, 21788,
     /* 1068466 */     GIR_EraseRootFromParent_Done,
     /* 1068467 */   // Label 15782: @1068467
     /* 1068467 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1068544), // Rule ID 21789 //
     /* 1068472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068511 */     // MIs[0] policy
     /* 1068511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068521 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068543 */     // GIR_Coverage, 21789,
     /* 1068543 */     GIR_EraseRootFromParent_Done,
     /* 1068544 */   // Label 15783: @1068544
     /* 1068544 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1068621), // Rule ID 21792 //
     /* 1068549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068588 */     // MIs[0] policy
     /* 1068588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068598 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068620 */     // GIR_Coverage, 21792,
     /* 1068620 */     GIR_EraseRootFromParent_Done,
     /* 1068621 */   // Label 15784: @1068621
     /* 1068621 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1068698), // Rule ID 21793 //
     /* 1068626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068665 */     // MIs[0] policy
     /* 1068665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068675 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068697 */     // GIR_Coverage, 21793,
     /* 1068697 */     GIR_EraseRootFromParent_Done,
     /* 1068698 */   // Label 15785: @1068698
     /* 1068698 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1068775), // Rule ID 21796 //
     /* 1068703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068742 */     // MIs[0] policy
     /* 1068742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068774 */     // GIR_Coverage, 21796,
     /* 1068774 */     GIR_EraseRootFromParent_Done,
     /* 1068775 */   // Label 15786: @1068775
     /* 1068775 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1068852), // Rule ID 21797 //
     /* 1068780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068819 */     // MIs[0] policy
     /* 1068819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068829 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068851 */     // GIR_Coverage, 21797,
     /* 1068851 */     GIR_EraseRootFromParent_Done,
     /* 1068852 */   // Label 15787: @1068852
     /* 1068852 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1068929), // Rule ID 21800 //
     /* 1068857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068896 */     // MIs[0] policy
     /* 1068896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068928 */     // GIR_Coverage, 21800,
     /* 1068928 */     GIR_EraseRootFromParent_Done,
     /* 1068929 */   // Label 15788: @1068929
     /* 1068929 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1069006), // Rule ID 21801 //
     /* 1068934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068973 */     // MIs[0] policy
     /* 1068973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11288:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069005 */     // GIR_Coverage, 21801,
     /* 1069005 */     GIR_EraseRootFromParent_Done,
     /* 1069006 */   // Label 15789: @1069006
     /* 1069006 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1069083), // Rule ID 21804 //
     /* 1069011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1069022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1069025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1069028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069050 */     // MIs[0] policy
     /* 1069050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069082 */     // GIR_Coverage, 21804,
     /* 1069082 */     GIR_EraseRootFromParent_Done,
     /* 1069083 */   // Label 15790: @1069083
     /* 1069083 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1069160), // Rule ID 21805 //
     /* 1069088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1069099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1069102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1069105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069127 */     // MIs[0] policy
     /* 1069127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069137 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069159 */     // GIR_Coverage, 21805,
     /* 1069159 */     GIR_EraseRootFromParent_Done,
     /* 1069160 */   // Label 15791: @1069160
     /* 1069160 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1069237), // Rule ID 21808 //
     /* 1069165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1069176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1069179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1069182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1069185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069204 */     // MIs[0] policy
     /* 1069204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069236 */     // GIR_Coverage, 21808,
     /* 1069236 */     GIR_EraseRootFromParent_Done,
     /* 1069237 */   // Label 15792: @1069237
     /* 1069237 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1069314), // Rule ID 21809 //
     /* 1069242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1069253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1069256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1069259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1069262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069281 */     // MIs[0] policy
     /* 1069281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069291 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069313 */     // GIR_Coverage, 21809,
     /* 1069313 */     GIR_EraseRootFromParent_Done,
     /* 1069314 */   // Label 15793: @1069314
     /* 1069314 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1069391), // Rule ID 21812 //
     /* 1069319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069358 */     // MIs[0] policy
     /* 1069358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1069371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069390 */     // GIR_Coverage, 21812,
     /* 1069390 */     GIR_EraseRootFromParent_Done,
     /* 1069391 */   // Label 15794: @1069391
     /* 1069391 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1069468), // Rule ID 21813 //
     /* 1069396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069435 */     // MIs[0] policy
     /* 1069435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069445 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1069448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069467 */     // GIR_Coverage, 21813,
     /* 1069467 */     GIR_EraseRootFromParent_Done,
     /* 1069468 */   // Label 15795: @1069468
     /* 1069468 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1069545), // Rule ID 21816 //
     /* 1069473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069512 */     // MIs[0] policy
     /* 1069512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069522 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069544 */     // GIR_Coverage, 21816,
     /* 1069544 */     GIR_EraseRootFromParent_Done,
     /* 1069545 */   // Label 15796: @1069545
     /* 1069545 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1069622), // Rule ID 21817 //
     /* 1069550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069589 */     // MIs[0] policy
     /* 1069589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069599 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069621 */     // GIR_Coverage, 21817,
     /* 1069621 */     GIR_EraseRootFromParent_Done,
     /* 1069622 */   // Label 15797: @1069622
     /* 1069622 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1069699), // Rule ID 21820 //
     /* 1069627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069666 */     // MIs[0] policy
     /* 1069666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069698 */     // GIR_Coverage, 21820,
     /* 1069698 */     GIR_EraseRootFromParent_Done,
     /* 1069699 */   // Label 15798: @1069699
     /* 1069699 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1069776), // Rule ID 21821 //
     /* 1069704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069743 */     // MIs[0] policy
     /* 1069743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069753 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069775 */     // GIR_Coverage, 21821,
     /* 1069775 */     GIR_EraseRootFromParent_Done,
     /* 1069776 */   // Label 15799: @1069776
     /* 1069776 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1069853), // Rule ID 21824 //
     /* 1069781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069820 */     // MIs[0] policy
     /* 1069820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069852 */     // GIR_Coverage, 21824,
     /* 1069852 */     GIR_EraseRootFromParent_Done,
     /* 1069853 */   // Label 15800: @1069853
     /* 1069853 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1069930), // Rule ID 21825 //
     /* 1069858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069897 */     // MIs[0] policy
     /* 1069897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069929 */     // GIR_Coverage, 21825,
     /* 1069929 */     GIR_EraseRootFromParent_Done,
     /* 1069930 */   // Label 15801: @1069930
     /* 1069930 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1070007), // Rule ID 21828 //
     /* 1069935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069974 */     // MIs[0] policy
     /* 1069974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070006 */     // GIR_Coverage, 21828,
     /* 1070006 */     GIR_EraseRootFromParent_Done,
     /* 1070007 */   // Label 15802: @1070007
     /* 1070007 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1070084), // Rule ID 21829 //
     /* 1070012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070051 */     // MIs[0] policy
     /* 1070051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070061 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070083 */     // GIR_Coverage, 21829,
     /* 1070083 */     GIR_EraseRootFromParent_Done,
     /* 1070084 */   // Label 15803: @1070084
     /* 1070084 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1070161), // Rule ID 21832 //
     /* 1070089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070128 */     // MIs[0] policy
     /* 1070128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070138 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1070141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070160 */     // GIR_Coverage, 21832,
     /* 1070160 */     GIR_EraseRootFromParent_Done,
     /* 1070161 */   // Label 15804: @1070161
     /* 1070161 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1070238), // Rule ID 21833 //
     /* 1070166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070205 */     // MIs[0] policy
     /* 1070205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1070218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070237 */     // GIR_Coverage, 21833,
     /* 1070237 */     GIR_EraseRootFromParent_Done,
     /* 1070238 */   // Label 15805: @1070238
     /* 1070238 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1070315), // Rule ID 21836 //
     /* 1070243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070282 */     // MIs[0] policy
     /* 1070282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1070295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070314 */     // GIR_Coverage, 21836,
     /* 1070314 */     GIR_EraseRootFromParent_Done,
     /* 1070315 */   // Label 15806: @1070315
     /* 1070315 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1070392), // Rule ID 21837 //
     /* 1070320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070359 */     // MIs[0] policy
     /* 1070359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070369 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1070372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070391 */     // GIR_Coverage, 21837,
     /* 1070391 */     GIR_EraseRootFromParent_Done,
     /* 1070392 */   // Label 15807: @1070392
     /* 1070392 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1070469), // Rule ID 21840 //
     /* 1070397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070436 */     // MIs[0] policy
     /* 1070436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070468 */     // GIR_Coverage, 21840,
     /* 1070468 */     GIR_EraseRootFromParent_Done,
     /* 1070469 */   // Label 15808: @1070469
     /* 1070469 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1070546), // Rule ID 21841 //
     /* 1070474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070513 */     // MIs[0] policy
     /* 1070513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070545 */     // GIR_Coverage, 21841,
     /* 1070545 */     GIR_EraseRootFromParent_Done,
     /* 1070546 */   // Label 15809: @1070546
     /* 1070546 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1070623), // Rule ID 21844 //
     /* 1070551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070590 */     // MIs[0] policy
     /* 1070590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070622 */     // GIR_Coverage, 21844,
     /* 1070622 */     GIR_EraseRootFromParent_Done,
     /* 1070623 */   // Label 15810: @1070623
     /* 1070623 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1070700), // Rule ID 21845 //
     /* 1070628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070667 */     // MIs[0] policy
     /* 1070667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070699 */     // GIR_Coverage, 21845,
     /* 1070699 */     GIR_EraseRootFromParent_Done,
     /* 1070700 */   // Label 15811: @1070700
     /* 1070700 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1070777), // Rule ID 21956 //
     /* 1070705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070744 */     // MIs[0] policy
     /* 1070744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070776 */     // GIR_Coverage, 21956,
     /* 1070776 */     GIR_EraseRootFromParent_Done,
     /* 1070777 */   // Label 15812: @1070777
     /* 1070777 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1070854), // Rule ID 21957 //
     /* 1070782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070821 */     // MIs[0] policy
     /* 1070821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070831 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070853 */     // GIR_Coverage, 21957,
     /* 1070853 */     GIR_EraseRootFromParent_Done,
     /* 1070854 */   // Label 15813: @1070854
     /* 1070854 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1070931), // Rule ID 21960 //
     /* 1070859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070898 */     // MIs[0] policy
     /* 1070898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070908 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070930 */     // GIR_Coverage, 21960,
     /* 1070930 */     GIR_EraseRootFromParent_Done,
     /* 1070931 */   // Label 15814: @1070931
     /* 1070931 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1071008), // Rule ID 21961 //
     /* 1070936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070975 */     // MIs[0] policy
     /* 1070975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070985 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071007 */     // GIR_Coverage, 21961,
     /* 1071007 */     GIR_EraseRootFromParent_Done,
     /* 1071008 */   // Label 15815: @1071008
     /* 1071008 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1071085), // Rule ID 21964 //
     /* 1071013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1071024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1071027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071052 */     // MIs[0] policy
     /* 1071052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071062 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1071065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071084 */     // GIR_Coverage, 21964,
     /* 1071084 */     GIR_EraseRootFromParent_Done,
     /* 1071085 */   // Label 15816: @1071085
     /* 1071085 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1071162), // Rule ID 21965 //
     /* 1071090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1071101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1071104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1071107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071129 */     // MIs[0] policy
     /* 1071129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071139 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1071142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071161 */     // GIR_Coverage, 21965,
     /* 1071161 */     GIR_EraseRootFromParent_Done,
     /* 1071162 */   // Label 15817: @1071162
     /* 1071162 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1071239), // Rule ID 21968 //
     /* 1071167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071206 */     // MIs[0] policy
     /* 1071206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071216 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1071219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071238 */     // GIR_Coverage, 21968,
     /* 1071238 */     GIR_EraseRootFromParent_Done,
     /* 1071239 */   // Label 15818: @1071239
     /* 1071239 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1071316), // Rule ID 21969 //
     /* 1071244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1071255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1071258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1071261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071283 */     // MIs[0] policy
     /* 1071283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071293 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1071296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071315 */     // GIR_Coverage, 21969,
     /* 1071315 */     GIR_EraseRootFromParent_Done,
     /* 1071316 */   // Label 15819: @1071316
     /* 1071316 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1071393), // Rule ID 21972 //
     /* 1071321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1071324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071360 */     // MIs[0] policy
     /* 1071360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1071373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071392 */     // GIR_Coverage, 21972,
     /* 1071392 */     GIR_EraseRootFromParent_Done,
     /* 1071393 */   // Label 15820: @1071393
     /* 1071393 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1071470), // Rule ID 21973 //
     /* 1071398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1071401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071437 */     // MIs[0] policy
     /* 1071437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071447 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1071450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071469 */     // GIR_Coverage, 21973,
     /* 1071469 */     GIR_EraseRootFromParent_Done,
     /* 1071470 */   // Label 15821: @1071470
     /* 1071470 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1071547), // Rule ID 21976 //
     /* 1071475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071514 */     // MIs[0] policy
     /* 1071514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071546 */     // GIR_Coverage, 21976,
     /* 1071546 */     GIR_EraseRootFromParent_Done,
     /* 1071547 */   // Label 15822: @1071547
     /* 1071547 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1071624), // Rule ID 21977 //
     /* 1071552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071591 */     // MIs[0] policy
     /* 1071591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071601 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071623 */     // GIR_Coverage, 21977,
     /* 1071623 */     GIR_EraseRootFromParent_Done,
     /* 1071624 */   // Label 15823: @1071624
     /* 1071624 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1071701), // Rule ID 21980 //
     /* 1071629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071668 */     // MIs[0] policy
     /* 1071668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071678 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071700 */     // GIR_Coverage, 21980,
     /* 1071700 */     GIR_EraseRootFromParent_Done,
     /* 1071701 */   // Label 15824: @1071701
     /* 1071701 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1071778), // Rule ID 21981 //
     /* 1071706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071745 */     // MIs[0] policy
     /* 1071745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071755 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071777 */     // GIR_Coverage, 21981,
     /* 1071777 */     GIR_EraseRootFromParent_Done,
     /* 1071778 */   // Label 15825: @1071778
     /* 1071778 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1071855), // Rule ID 21984 //
     /* 1071783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071822 */     // MIs[0] policy
     /* 1071822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071832 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071854 */     // GIR_Coverage, 21984,
     /* 1071854 */     GIR_EraseRootFromParent_Done,
     /* 1071855 */   // Label 15826: @1071855
     /* 1071855 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1071932), // Rule ID 21985 //
     /* 1071860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071899 */     // MIs[0] policy
     /* 1071899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071909 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071931 */     // GIR_Coverage, 21985,
     /* 1071931 */     GIR_EraseRootFromParent_Done,
     /* 1071932 */   // Label 15827: @1071932
     /* 1071932 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1072009), // Rule ID 21988 //
     /* 1071937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071976 */     // MIs[0] policy
     /* 1071976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071986 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072008 */     // GIR_Coverage, 21988,
     /* 1072008 */     GIR_EraseRootFromParent_Done,
     /* 1072009 */   // Label 15828: @1072009
     /* 1072009 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1072086), // Rule ID 21989 //
     /* 1072014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1072017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1072022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1072025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1072028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1072031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072053 */     // MIs[0] policy
     /* 1072053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072063 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1072066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072085 */     // GIR_Coverage, 21989,
     /* 1072085 */     GIR_EraseRootFromParent_Done,
     /* 1072086 */   // Label 15829: @1072086
     /* 1072086 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1072163), // Rule ID 23428 //
     /* 1072091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072130 */     // MIs[0] policy
     /* 1072130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072140 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072162 */     // GIR_Coverage, 23428,
     /* 1072162 */     GIR_EraseRootFromParent_Done,
     /* 1072163 */   // Label 15830: @1072163
     /* 1072163 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1072240), // Rule ID 23429 //
     /* 1072168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072207 */     // MIs[0] policy
     /* 1072207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072217 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072239 */     // GIR_Coverage, 23429,
     /* 1072239 */     GIR_EraseRootFromParent_Done,
     /* 1072240 */   // Label 15831: @1072240
     /* 1072240 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1072317), // Rule ID 23432 //
     /* 1072245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072284 */     // MIs[0] policy
     /* 1072284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072316 */     // GIR_Coverage, 23432,
     /* 1072316 */     GIR_EraseRootFromParent_Done,
     /* 1072317 */   // Label 15832: @1072317
     /* 1072317 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1072394), // Rule ID 23433 //
     /* 1072322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072361 */     // MIs[0] policy
     /* 1072361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072393 */     // GIR_Coverage, 23433,
     /* 1072393 */     GIR_EraseRootFromParent_Done,
     /* 1072394 */   // Label 15833: @1072394
     /* 1072394 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1072471), // Rule ID 23436 //
     /* 1072399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072438 */     // MIs[0] policy
     /* 1072438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072470 */     // GIR_Coverage, 23436,
     /* 1072470 */     GIR_EraseRootFromParent_Done,
     /* 1072471 */   // Label 15834: @1072471
     /* 1072471 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1072548), // Rule ID 23437 //
     /* 1072476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072515 */     // MIs[0] policy
     /* 1072515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072525 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072547 */     // GIR_Coverage, 23437,
     /* 1072547 */     GIR_EraseRootFromParent_Done,
     /* 1072548 */   // Label 15835: @1072548
     /* 1072548 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1072625), // Rule ID 23440 //
     /* 1072553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072592 */     // MIs[0] policy
     /* 1072592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072624 */     // GIR_Coverage, 23440,
     /* 1072624 */     GIR_EraseRootFromParent_Done,
     /* 1072625 */   // Label 15836: @1072625
     /* 1072625 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1072702), // Rule ID 23441 //
     /* 1072630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072669 */     // MIs[0] policy
     /* 1072669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072679 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072701 */     // GIR_Coverage, 23441,
     /* 1072701 */     GIR_EraseRootFromParent_Done,
     /* 1072702 */   // Label 15837: @1072702
     /* 1072702 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1072779), // Rule ID 23444 //
     /* 1072707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072746 */     // MIs[0] policy
     /* 1072746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072778 */     // GIR_Coverage, 23444,
     /* 1072778 */     GIR_EraseRootFromParent_Done,
     /* 1072779 */   // Label 15838: @1072779
     /* 1072779 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1072856), // Rule ID 23445 //
     /* 1072784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072823 */     // MIs[0] policy
     /* 1072823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072855 */     // GIR_Coverage, 23445,
     /* 1072855 */     GIR_EraseRootFromParent_Done,
     /* 1072856 */   // Label 15839: @1072856
     /* 1072856 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1072933), // Rule ID 23448 //
     /* 1072861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072900 */     // MIs[0] policy
     /* 1072900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072910 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072932 */     // GIR_Coverage, 23448,
     /* 1072932 */     GIR_EraseRootFromParent_Done,
     /* 1072933 */   // Label 15840: @1072933
     /* 1072933 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1073010), // Rule ID 23449 //
     /* 1072938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072977 */     // MIs[0] policy
     /* 1072977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072987 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073009 */     // GIR_Coverage, 23449,
     /* 1073009 */     GIR_EraseRootFromParent_Done,
     /* 1073010 */   // Label 15841: @1073010
     /* 1073010 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1073087), // Rule ID 23452 //
     /* 1073015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073054 */     // MIs[0] policy
     /* 1073054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073086 */     // GIR_Coverage, 23452,
     /* 1073086 */     GIR_EraseRootFromParent_Done,
     /* 1073087 */   // Label 15842: @1073087
     /* 1073087 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1073164), // Rule ID 23453 //
     /* 1073092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073131 */     // MIs[0] policy
     /* 1073131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073163 */     // GIR_Coverage, 23453,
     /* 1073163 */     GIR_EraseRootFromParent_Done,
     /* 1073164 */   // Label 15843: @1073164
     /* 1073164 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1073241), // Rule ID 23456 //
     /* 1073169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073208 */     // MIs[0] policy
     /* 1073208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073240 */     // GIR_Coverage, 23456,
     /* 1073240 */     GIR_EraseRootFromParent_Done,
     /* 1073241 */   // Label 15844: @1073241
     /* 1073241 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1073318), // Rule ID 23457 //
     /* 1073246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073285 */     // MIs[0] policy
     /* 1073285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073317 */     // GIR_Coverage, 23457,
     /* 1073317 */     GIR_EraseRootFromParent_Done,
     /* 1073318 */   // Label 15845: @1073318
     /* 1073318 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1073395), // Rule ID 23460 //
     /* 1073323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1073326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1073334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1073337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1073340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073362 */     // MIs[0] policy
     /* 1073362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073394 */     // GIR_Coverage, 23460,
     /* 1073394 */     GIR_EraseRootFromParent_Done,
     /* 1073395 */   // Label 15846: @1073395
     /* 1073395 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1073472), // Rule ID 23461 //
     /* 1073400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1073403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1073411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1073414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1073417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073439 */     // MIs[0] policy
     /* 1073439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1073452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073471 */     // GIR_Coverage, 23461,
     /* 1073471 */     GIR_EraseRootFromParent_Done,
     /* 1073472 */   // Label 15847: @1073472
     /* 1073472 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1073549), // Rule ID 23464 //
     /* 1073477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073516 */     // MIs[0] policy
     /* 1073516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073548 */     // GIR_Coverage, 23464,
     /* 1073548 */     GIR_EraseRootFromParent_Done,
     /* 1073549 */   // Label 15848: @1073549
     /* 1073549 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1073626), // Rule ID 23465 //
     /* 1073554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073593 */     // MIs[0] policy
     /* 1073593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073625 */     // GIR_Coverage, 23465,
     /* 1073625 */     GIR_EraseRootFromParent_Done,
     /* 1073626 */   // Label 15849: @1073626
     /* 1073626 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1073703), // Rule ID 23468 //
     /* 1073631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073670 */     // MIs[0] policy
     /* 1073670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073702 */     // GIR_Coverage, 23468,
     /* 1073702 */     GIR_EraseRootFromParent_Done,
     /* 1073703 */   // Label 15850: @1073703
     /* 1073703 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1073780), // Rule ID 23469 //
     /* 1073708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073747 */     // MIs[0] policy
     /* 1073747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073757 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073779 */     // GIR_Coverage, 23469,
     /* 1073779 */     GIR_EraseRootFromParent_Done,
     /* 1073780 */   // Label 15851: @1073780
     /* 1073780 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1073857), // Rule ID 23472 //
     /* 1073785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073824 */     // MIs[0] policy
     /* 1073824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073856 */     // GIR_Coverage, 23472,
     /* 1073856 */     GIR_EraseRootFromParent_Done,
     /* 1073857 */   // Label 15852: @1073857
     /* 1073857 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1073934), // Rule ID 23473 //
     /* 1073862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073901 */     // MIs[0] policy
     /* 1073901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073911 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073933 */     // GIR_Coverage, 23473,
     /* 1073933 */     GIR_EraseRootFromParent_Done,
     /* 1073934 */   // Label 15853: @1073934
     /* 1073934 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1074011), // Rule ID 23476 //
     /* 1073939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073978 */     // MIs[0] policy
     /* 1073978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074010 */     // GIR_Coverage, 23476,
     /* 1074010 */     GIR_EraseRootFromParent_Done,
     /* 1074011 */   // Label 15854: @1074011
     /* 1074011 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1074088), // Rule ID 23477 //
     /* 1074016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074055 */     // MIs[0] policy
     /* 1074055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074087 */     // GIR_Coverage, 23477,
     /* 1074087 */     GIR_EraseRootFromParent_Done,
     /* 1074088 */   // Label 15855: @1074088
     /* 1074088 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1074165), // Rule ID 23480 //
     /* 1074093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074132 */     // MIs[0] policy
     /* 1074132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074164 */     // GIR_Coverage, 23480,
     /* 1074164 */     GIR_EraseRootFromParent_Done,
     /* 1074165 */   // Label 15856: @1074165
     /* 1074165 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1074242), // Rule ID 23481 //
     /* 1074170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074209 */     // MIs[0] policy
     /* 1074209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074241 */     // GIR_Coverage, 23481,
     /* 1074241 */     GIR_EraseRootFromParent_Done,
     /* 1074242 */   // Label 15857: @1074242
     /* 1074242 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1074319), // Rule ID 23484 //
     /* 1074247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1074258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1074261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1074264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1074267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074286 */     // MIs[0] policy
     /* 1074286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074318 */     // GIR_Coverage, 23484,
     /* 1074318 */     GIR_EraseRootFromParent_Done,
     /* 1074319 */   // Label 15858: @1074319
     /* 1074319 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1074396), // Rule ID 23485 //
     /* 1074324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1074335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1074338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1074341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1074344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074363 */     // MIs[0] policy
     /* 1074363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074373 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074395 */     // GIR_Coverage, 23485,
     /* 1074395 */     GIR_EraseRootFromParent_Done,
     /* 1074396 */   // Label 15859: @1074396
     /* 1074396 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1074473), // Rule ID 23488 //
     /* 1074401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074440 */     // MIs[0] policy
     /* 1074440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074472 */     // GIR_Coverage, 23488,
     /* 1074472 */     GIR_EraseRootFromParent_Done,
     /* 1074473 */   // Label 15860: @1074473
     /* 1074473 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1074550), // Rule ID 23489 //
     /* 1074478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074517 */     // MIs[0] policy
     /* 1074517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074549 */     // GIR_Coverage, 23489,
     /* 1074549 */     GIR_EraseRootFromParent_Done,
     /* 1074550 */   // Label 15861: @1074550
     /* 1074550 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1074627), // Rule ID 23492 //
     /* 1074555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074594 */     // MIs[0] policy
     /* 1074594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074604 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074626 */     // GIR_Coverage, 23492,
     /* 1074626 */     GIR_EraseRootFromParent_Done,
     /* 1074627 */   // Label 15862: @1074627
     /* 1074627 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1074704), // Rule ID 23493 //
     /* 1074632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074671 */     // MIs[0] policy
     /* 1074671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074681 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074703 */     // GIR_Coverage, 23493,
     /* 1074703 */     GIR_EraseRootFromParent_Done,
     /* 1074704 */   // Label 15863: @1074704
     /* 1074704 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1074781), // Rule ID 23496 //
     /* 1074709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074748 */     // MIs[0] policy
     /* 1074748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074780 */     // GIR_Coverage, 23496,
     /* 1074780 */     GIR_EraseRootFromParent_Done,
     /* 1074781 */   // Label 15864: @1074781
     /* 1074781 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1074858), // Rule ID 23497 //
     /* 1074786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074825 */     // MIs[0] policy
     /* 1074825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074835 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074857 */     // GIR_Coverage, 23497,
     /* 1074857 */     GIR_EraseRootFromParent_Done,
     /* 1074858 */   // Label 15865: @1074858
     /* 1074858 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1074935), // Rule ID 23500 //
     /* 1074863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074902 */     // MIs[0] policy
     /* 1074902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074934 */     // GIR_Coverage, 23500,
     /* 1074934 */     GIR_EraseRootFromParent_Done,
     /* 1074935 */   // Label 15866: @1074935
     /* 1074935 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1075012), // Rule ID 23501 //
     /* 1074940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074979 */     // MIs[0] policy
     /* 1074979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075011 */     // GIR_Coverage, 23501,
     /* 1075011 */     GIR_EraseRootFromParent_Done,
     /* 1075012 */   // Label 15867: @1075012
     /* 1075012 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1075089), // Rule ID 23504 //
     /* 1075017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075056 */     // MIs[0] policy
     /* 1075056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1075069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075088 */     // GIR_Coverage, 23504,
     /* 1075088 */     GIR_EraseRootFromParent_Done,
     /* 1075089 */   // Label 15868: @1075089
     /* 1075089 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1075166), // Rule ID 23505 //
     /* 1075094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1075105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1075108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075133 */     // MIs[0] policy
     /* 1075133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1075146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075165 */     // GIR_Coverage, 23505,
     /* 1075165 */     GIR_EraseRootFromParent_Done,
     /* 1075166 */   // Label 15869: @1075166
     /* 1075166 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1075243), // Rule ID 23508 //
     /* 1075171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1075182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1075185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1075188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1075198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075210 */     // MIs[0] policy
     /* 1075210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1075223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075242 */     // GIR_Coverage, 23508,
     /* 1075242 */     GIR_EraseRootFromParent_Done,
     /* 1075243 */   // Label 15870: @1075243
     /* 1075243 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1075320), // Rule ID 23509 //
     /* 1075248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1075259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1075262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1075265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1075275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075287 */     // MIs[0] policy
     /* 1075287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075297 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1075300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075319 */     // GIR_Coverage, 23509,
     /* 1075319 */     GIR_EraseRootFromParent_Done,
     /* 1075320 */   // Label 15871: @1075320
     /* 1075320 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1075397), // Rule ID 23614 //
     /* 1075325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1075336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1075339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1075342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075364 */     // MIs[0] policy
     /* 1075364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1075377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075396 */     // GIR_Coverage, 23614,
     /* 1075396 */     GIR_EraseRootFromParent_Done,
     /* 1075397 */   // Label 15872: @1075397
     /* 1075397 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1075474), // Rule ID 23615 //
     /* 1075402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1075413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1075416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1075419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075441 */     // MIs[0] policy
     /* 1075441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075451 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1075454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075473 */     // GIR_Coverage, 23615,
     /* 1075473 */     GIR_EraseRootFromParent_Done,
     /* 1075474 */   // Label 15873: @1075474
     /* 1075474 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1075551), // Rule ID 23618 //
     /* 1075479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075518 */     // MIs[0] policy
     /* 1075518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075550 */     // GIR_Coverage, 23618,
     /* 1075550 */     GIR_EraseRootFromParent_Done,
     /* 1075551 */   // Label 15874: @1075551
     /* 1075551 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1075628), // Rule ID 23619 //
     /* 1075556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075595 */     // MIs[0] policy
     /* 1075595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075605 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075627 */     // GIR_Coverage, 23619,
     /* 1075627 */     GIR_EraseRootFromParent_Done,
     /* 1075628 */   // Label 15875: @1075628
     /* 1075628 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1075705), // Rule ID 23622 //
     /* 1075633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075672 */     // MIs[0] policy
     /* 1075672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075682 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075704 */     // GIR_Coverage, 23622,
     /* 1075704 */     GIR_EraseRootFromParent_Done,
     /* 1075705 */   // Label 15876: @1075705
     /* 1075705 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1075782), // Rule ID 23623 //
     /* 1075710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075749 */     // MIs[0] policy
     /* 1075749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075781 */     // GIR_Coverage, 23623,
     /* 1075781 */     GIR_EraseRootFromParent_Done,
     /* 1075782 */   // Label 15877: @1075782
     /* 1075782 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1075859), // Rule ID 23626 //
     /* 1075787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075826 */     // MIs[0] policy
     /* 1075826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075858 */     // GIR_Coverage, 23626,
     /* 1075858 */     GIR_EraseRootFromParent_Done,
     /* 1075859 */   // Label 15878: @1075859
     /* 1075859 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1075936), // Rule ID 23627 //
     /* 1075864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075903 */     // MIs[0] policy
     /* 1075903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075913 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075935 */     // GIR_Coverage, 23627,
     /* 1075935 */     GIR_EraseRootFromParent_Done,
     /* 1075936 */   // Label 15879: @1075936
     /* 1075936 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1076013), // Rule ID 23630 //
     /* 1075941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075980 */     // MIs[0] policy
     /* 1075980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076012 */     // GIR_Coverage, 23630,
     /* 1076012 */     GIR_EraseRootFromParent_Done,
     /* 1076013 */   // Label 15880: @1076013
     /* 1076013 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1076090), // Rule ID 23631 //
     /* 1076018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1076035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076057 */     // MIs[0] policy
     /* 1076057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076067 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076089 */     // GIR_Coverage, 23631,
     /* 1076089 */     GIR_EraseRootFromParent_Done,
     /* 1076090 */   // Label 15881: @1076090
     /* 1076090 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1076167), // Rule ID 23634 //
     /* 1076095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076134 */     // MIs[0] policy
     /* 1076134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076166 */     // GIR_Coverage, 23634,
     /* 1076166 */     GIR_EraseRootFromParent_Done,
     /* 1076167 */   // Label 15882: @1076167
     /* 1076167 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1076244), // Rule ID 23635 //
     /* 1076172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1076189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076211 */     // MIs[0] policy
     /* 1076211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1076224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076243 */     // GIR_Coverage, 23635,
     /* 1076243 */     GIR_EraseRootFromParent_Done,
     /* 1076244 */   // Label 15883: @1076244
     /* 1076244 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1076321), // Rule ID 23638 //
     /* 1076249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1076266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076288 */     // MIs[0] policy
     /* 1076288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076320 */     // GIR_Coverage, 23638,
     /* 1076320 */     GIR_EraseRootFromParent_Done,
     /* 1076321 */   // Label 15884: @1076321
     /* 1076321 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1076398), // Rule ID 23639 //
     /* 1076326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1076343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076365 */     // MIs[0] policy
     /* 1076365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076375 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076397 */     // GIR_Coverage, 23639,
     /* 1076397 */     GIR_EraseRootFromParent_Done,
     /* 1076398 */   // Label 15885: @1076398
     /* 1076398 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1076475), // Rule ID 23642 //
     /* 1076403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076442 */     // MIs[0] policy
     /* 1076442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076474 */     // GIR_Coverage, 23642,
     /* 1076474 */     GIR_EraseRootFromParent_Done,
     /* 1076475 */   // Label 15886: @1076475
     /* 1076475 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1076552), // Rule ID 23643 //
     /* 1076480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076519 */     // MIs[0] policy
     /* 1076519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076529 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076551 */     // GIR_Coverage, 23643,
     /* 1076551 */     GIR_EraseRootFromParent_Done,
     /* 1076552 */   // Label 15887: @1076552
     /* 1076552 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1076629), // Rule ID 23646 //
     /* 1076557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076596 */     // MIs[0] policy
     /* 1076596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076606 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076628 */     // GIR_Coverage, 23646,
     /* 1076628 */     GIR_EraseRootFromParent_Done,
     /* 1076629 */   // Label 15888: @1076629
     /* 1076629 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1076706), // Rule ID 23647 //
     /* 1076634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076673 */     // MIs[0] policy
     /* 1076673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076683 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076705 */     // GIR_Coverage, 23647,
     /* 1076705 */     GIR_EraseRootFromParent_Done,
     /* 1076706 */   // Label 15889: @1076706
     /* 1076706 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1076783), // Rule ID 23650 //
     /* 1076711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076750 */     // MIs[0] policy
     /* 1076750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076782 */     // GIR_Coverage, 23650,
     /* 1076782 */     GIR_EraseRootFromParent_Done,
     /* 1076783 */   // Label 15890: @1076783
     /* 1076783 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1076860), // Rule ID 23651 //
     /* 1076788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076827 */     // MIs[0] policy
     /* 1076827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076837 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076859 */     // GIR_Coverage, 23651,
     /* 1076859 */     GIR_EraseRootFromParent_Done,
     /* 1076860 */   // Label 15891: @1076860
     /* 1076860 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1076937), // Rule ID 23654 //
     /* 1076865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076904 */     // MIs[0] policy
     /* 1076904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076936 */     // GIR_Coverage, 23654,
     /* 1076936 */     GIR_EraseRootFromParent_Done,
     /* 1076937 */   // Label 15892: @1076937
     /* 1076937 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1077014), // Rule ID 23655 //
     /* 1076942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076981 */     // MIs[0] policy
     /* 1076981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077013 */     // GIR_Coverage, 23655,
     /* 1077013 */     GIR_EraseRootFromParent_Done,
     /* 1077014 */   // Label 15893: @1077014
     /* 1077014 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1077091), // Rule ID 23658 //
     /* 1077019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077058 */     // MIs[0] policy
     /* 1077058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077090 */     // GIR_Coverage, 23658,
     /* 1077090 */     GIR_EraseRootFromParent_Done,
     /* 1077091 */   // Label 15894: @1077091
     /* 1077091 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1077168), // Rule ID 23659 //
     /* 1077096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1077113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077135 */     // MIs[0] policy
     /* 1077135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077145 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077167 */     // GIR_Coverage, 23659,
     /* 1077167 */     GIR_EraseRootFromParent_Done,
     /* 1077168 */   // Label 15895: @1077168
     /* 1077168 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1077245), // Rule ID 23662 //
     /* 1077173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1077190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077212 */     // MIs[0] policy
     /* 1077212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077222 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077244 */     // GIR_Coverage, 23662,
     /* 1077244 */     GIR_EraseRootFromParent_Done,
     /* 1077245 */   // Label 15896: @1077245
     /* 1077245 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1077322), // Rule ID 23663 //
     /* 1077250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1077267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077289 */     // MIs[0] policy
     /* 1077289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077299 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077321 */     // GIR_Coverage, 23663,
     /* 1077321 */     GIR_EraseRootFromParent_Done,
     /* 1077322 */   // Label 15897: @1077322
     /* 1077322 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1077399), // Rule ID 23666 //
     /* 1077327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1077344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077366 */     // MIs[0] policy
     /* 1077366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077398 */     // GIR_Coverage, 23666,
     /* 1077398 */     GIR_EraseRootFromParent_Done,
     /* 1077399 */   // Label 15898: @1077399
     /* 1077399 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1077476), // Rule ID 23667 //
     /* 1077404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1077421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077443 */     // MIs[0] policy
     /* 1077443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077475 */     // GIR_Coverage, 23667,
     /* 1077475 */     GIR_EraseRootFromParent_Done,
     /* 1077476 */   // Label 15899: @1077476
     /* 1077476 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1077553), // Rule ID 23670 //
     /* 1077481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077520 */     // MIs[0] policy
     /* 1077520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077552 */     // GIR_Coverage, 23670,
     /* 1077552 */     GIR_EraseRootFromParent_Done,
     /* 1077553 */   // Label 15900: @1077553
     /* 1077553 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1077630), // Rule ID 23671 //
     /* 1077558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077597 */     // MIs[0] policy
     /* 1077597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077607 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077629 */     // GIR_Coverage, 23671,
     /* 1077629 */     GIR_EraseRootFromParent_Done,
     /* 1077630 */   // Label 15901: @1077630
     /* 1077630 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1077707), // Rule ID 23674 //
     /* 1077635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077674 */     // MIs[0] policy
     /* 1077674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077706 */     // GIR_Coverage, 23674,
     /* 1077706 */     GIR_EraseRootFromParent_Done,
     /* 1077707 */   // Label 15902: @1077707
     /* 1077707 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1077784), // Rule ID 23675 //
     /* 1077712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077751 */     // MIs[0] policy
     /* 1077751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077783 */     // GIR_Coverage, 23675,
     /* 1077783 */     GIR_EraseRootFromParent_Done,
     /* 1077784 */   // Label 15903: @1077784
     /* 1077784 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1077861), // Rule ID 23678 //
     /* 1077789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077828 */     // MIs[0] policy
     /* 1077828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077860 */     // GIR_Coverage, 23678,
     /* 1077860 */     GIR_EraseRootFromParent_Done,
     /* 1077861 */   // Label 15904: @1077861
     /* 1077861 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1077938), // Rule ID 23679 //
     /* 1077866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077905 */     // MIs[0] policy
     /* 1077905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077937 */     // GIR_Coverage, 23679,
     /* 1077937 */     GIR_EraseRootFromParent_Done,
     /* 1077938 */   // Label 15905: @1077938
     /* 1077938 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1078015), // Rule ID 23682 //
     /* 1077943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077982 */     // MIs[0] policy
     /* 1077982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078014 */     // GIR_Coverage, 23682,
     /* 1078014 */     GIR_EraseRootFromParent_Done,
     /* 1078015 */   // Label 15906: @1078015
     /* 1078015 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1078092), // Rule ID 23683 //
     /* 1078020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1078037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078059 */     // MIs[0] policy
     /* 1078059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078091 */     // GIR_Coverage, 23683,
     /* 1078091 */     GIR_EraseRootFromParent_Done,
     /* 1078092 */   // Label 15907: @1078092
     /* 1078092 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1078169), // Rule ID 23686 //
     /* 1078097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1078114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078136 */     // MIs[0] policy
     /* 1078136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078168 */     // GIR_Coverage, 23686,
     /* 1078168 */     GIR_EraseRootFromParent_Done,
     /* 1078169 */   // Label 15908: @1078169
     /* 1078169 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1078246), // Rule ID 23687 //
     /* 1078174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1078191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078213 */     // MIs[0] policy
     /* 1078213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078223 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078245 */     // GIR_Coverage, 23687,
     /* 1078245 */     GIR_EraseRootFromParent_Done,
     /* 1078246 */   // Label 15909: @1078246
     /* 1078246 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1078323), // Rule ID 23690 //
     /* 1078251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1078268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078290 */     // MIs[0] policy
     /* 1078290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1078303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078322 */     // GIR_Coverage, 23690,
     /* 1078322 */     GIR_EraseRootFromParent_Done,
     /* 1078323 */   // Label 15910: @1078323
     /* 1078323 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1078400), // Rule ID 23691 //
     /* 1078328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1078345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078367 */     // MIs[0] policy
     /* 1078367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1078380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078399 */     // GIR_Coverage, 23691,
     /* 1078399 */     GIR_EraseRootFromParent_Done,
     /* 1078400 */   // Label 15911: @1078400
     /* 1078400 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1078477), // Rule ID 23694 //
     /* 1078405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078444 */     // MIs[0] policy
     /* 1078444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078476 */     // GIR_Coverage, 23694,
     /* 1078476 */     GIR_EraseRootFromParent_Done,
     /* 1078477 */   // Label 15912: @1078477
     /* 1078477 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1078554), // Rule ID 23695 //
     /* 1078482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078521 */     // MIs[0] policy
     /* 1078521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078553 */     // GIR_Coverage, 23695,
     /* 1078553 */     GIR_EraseRootFromParent_Done,
     /* 1078554 */   // Label 15913: @1078554
     /* 1078554 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1078631), // Rule ID 23698 //
     /* 1078559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078598 */     // MIs[0] policy
     /* 1078598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078630 */     // GIR_Coverage, 23698,
     /* 1078630 */     GIR_EraseRootFromParent_Done,
     /* 1078631 */   // Label 15914: @1078631
     /* 1078631 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1078708), // Rule ID 23699 //
     /* 1078636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078675 */     // MIs[0] policy
     /* 1078675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078685 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078707 */     // GIR_Coverage, 23699,
     /* 1078707 */     GIR_EraseRootFromParent_Done,
     /* 1078708 */   // Label 15915: @1078708
     /* 1078708 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1078785), // Rule ID 23790 //
     /* 1078713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078752 */     // MIs[0] policy
     /* 1078752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078784 */     // GIR_Coverage, 23790,
     /* 1078784 */     GIR_EraseRootFromParent_Done,
     /* 1078785 */   // Label 15916: @1078785
     /* 1078785 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1078862), // Rule ID 23791 //
     /* 1078790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078829 */     // MIs[0] policy
     /* 1078829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078839 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078861 */     // GIR_Coverage, 23791,
     /* 1078861 */     GIR_EraseRootFromParent_Done,
     /* 1078862 */   // Label 15917: @1078862
     /* 1078862 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1078939), // Rule ID 23794 //
     /* 1078867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078906 */     // MIs[0] policy
     /* 1078906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078938 */     // GIR_Coverage, 23794,
     /* 1078938 */     GIR_EraseRootFromParent_Done,
     /* 1078939 */   // Label 15918: @1078939
     /* 1078939 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1079016), // Rule ID 23795 //
     /* 1078944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078983 */     // MIs[0] policy
     /* 1078983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078993 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079015 */     // GIR_Coverage, 23795,
     /* 1079015 */     GIR_EraseRootFromParent_Done,
     /* 1079016 */   // Label 15919: @1079016
     /* 1079016 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1079093), // Rule ID 23798 //
     /* 1079021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079060 */     // MIs[0] policy
     /* 1079060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079092 */     // GIR_Coverage, 23798,
     /* 1079092 */     GIR_EraseRootFromParent_Done,
     /* 1079093 */   // Label 15920: @1079093
     /* 1079093 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1079170), // Rule ID 23799 //
     /* 1079098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079137 */     // MIs[0] policy
     /* 1079137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079147 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079169 */     // GIR_Coverage, 23799,
     /* 1079169 */     GIR_EraseRootFromParent_Done,
     /* 1079170 */   // Label 15921: @1079170
     /* 1079170 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1079247), // Rule ID 23802 //
     /* 1079175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079214 */     // MIs[0] policy
     /* 1079214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1079227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079246 */     // GIR_Coverage, 23802,
     /* 1079246 */     GIR_EraseRootFromParent_Done,
     /* 1079247 */   // Label 15922: @1079247
     /* 1079247 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1079324), // Rule ID 23803 //
     /* 1079252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079291 */     // MIs[0] policy
     /* 1079291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079301 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1079304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079323 */     // GIR_Coverage, 23803,
     /* 1079323 */     GIR_EraseRootFromParent_Done,
     /* 1079324 */   // Label 15923: @1079324
     /* 1079324 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1079401), // Rule ID 23806 //
     /* 1079329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079368 */     // MIs[0] policy
     /* 1079368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079400 */     // GIR_Coverage, 23806,
     /* 1079400 */     GIR_EraseRootFromParent_Done,
     /* 1079401 */   // Label 15924: @1079401
     /* 1079401 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1079478), // Rule ID 23807 //
     /* 1079406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079445 */     // MIs[0] policy
     /* 1079445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079455 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079477 */     // GIR_Coverage, 23807,
     /* 1079477 */     GIR_EraseRootFromParent_Done,
     /* 1079478 */   // Label 15925: @1079478
     /* 1079478 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1079555), // Rule ID 23810 //
     /* 1079483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079522 */     // MIs[0] policy
     /* 1079522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079554 */     // GIR_Coverage, 23810,
     /* 1079554 */     GIR_EraseRootFromParent_Done,
     /* 1079555 */   // Label 15926: @1079555
     /* 1079555 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1079632), // Rule ID 23811 //
     /* 1079560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079599 */     // MIs[0] policy
     /* 1079599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079631 */     // GIR_Coverage, 23811,
     /* 1079631 */     GIR_EraseRootFromParent_Done,
     /* 1079632 */   // Label 15927: @1079632
     /* 1079632 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1079709), // Rule ID 23814 //
     /* 1079637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079676 */     // MIs[0] policy
     /* 1079676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079708 */     // GIR_Coverage, 23814,
     /* 1079708 */     GIR_EraseRootFromParent_Done,
     /* 1079709 */   // Label 15928: @1079709
     /* 1079709 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1079786), // Rule ID 23815 //
     /* 1079714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079753 */     // MIs[0] policy
     /* 1079753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079763 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11605:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079785 */     // GIR_Coverage, 23815,
     /* 1079785 */     GIR_EraseRootFromParent_Done,
     /* 1079786 */   // Label 15929: @1079786
     /* 1079786 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1079863), // Rule ID 23818 //
     /* 1079791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079830 */     // MIs[0] policy
     /* 1079830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079862 */     // GIR_Coverage, 23818,
     /* 1079862 */     GIR_EraseRootFromParent_Done,
     /* 1079863 */   // Label 15930: @1079863
     /* 1079863 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1079940), // Rule ID 23819 //
     /* 1079868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079907 */     // MIs[0] policy
     /* 1079907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079917 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079939 */     // GIR_Coverage, 23819,
     /* 1079939 */     GIR_EraseRootFromParent_Done,
     /* 1079940 */   // Label 15931: @1079940
     /* 1079940 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1080017), // Rule ID 23822 //
     /* 1079945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079984 */     // MIs[0] policy
     /* 1079984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080016 */     // GIR_Coverage, 23822,
     /* 1080016 */     GIR_EraseRootFromParent_Done,
     /* 1080017 */   // Label 15932: @1080017
     /* 1080017 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1080094), // Rule ID 23823 //
     /* 1080022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1080033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1080036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080061 */     // MIs[0] policy
     /* 1080061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080093 */     // GIR_Coverage, 23823,
     /* 1080093 */     GIR_EraseRootFromParent_Done,
     /* 1080094 */   // Label 15933: @1080094
     /* 1080094 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1080171), // Rule ID 23826 //
     /* 1080099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080138 */     // MIs[0] policy
     /* 1080138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080170 */     // GIR_Coverage, 23826,
     /* 1080170 */     GIR_EraseRootFromParent_Done,
     /* 1080171 */   // Label 15934: @1080171
     /* 1080171 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1080248), // Rule ID 23827 //
     /* 1080176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080215 */     // MIs[0] policy
     /* 1080215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080225 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1080228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080247 */     // GIR_Coverage, 23827,
     /* 1080247 */     GIR_EraseRootFromParent_Done,
     /* 1080248 */   // Label 15935: @1080248
     /* 1080248 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1080325), // Rule ID 23830 //
     /* 1080253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080292 */     // MIs[0] policy
     /* 1080292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080302 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080324 */     // GIR_Coverage, 23830,
     /* 1080324 */     GIR_EraseRootFromParent_Done,
     /* 1080325 */   // Label 15936: @1080325
     /* 1080325 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1080402), // Rule ID 23831 //
     /* 1080330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080369 */     // MIs[0] policy
     /* 1080369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080379 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080401 */     // GIR_Coverage, 23831,
     /* 1080401 */     GIR_EraseRootFromParent_Done,
     /* 1080402 */   // Label 15937: @1080402
     /* 1080402 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1080479), // Rule ID 23834 //
     /* 1080407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080446 */     // MIs[0] policy
     /* 1080446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080456 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080478 */     // GIR_Coverage, 23834,
     /* 1080478 */     GIR_EraseRootFromParent_Done,
     /* 1080479 */   // Label 15938: @1080479
     /* 1080479 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1080556), // Rule ID 23835 //
     /* 1080484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080523 */     // MIs[0] policy
     /* 1080523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080533 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080555 */     // GIR_Coverage, 23835,
     /* 1080555 */     GIR_EraseRootFromParent_Done,
     /* 1080556 */   // Label 15939: @1080556
     /* 1080556 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1080633), // Rule ID 23838 //
     /* 1080561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080600 */     // MIs[0] policy
     /* 1080600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080632 */     // GIR_Coverage, 23838,
     /* 1080632 */     GIR_EraseRootFromParent_Done,
     /* 1080633 */   // Label 15940: @1080633
     /* 1080633 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1080710), // Rule ID 23839 //
     /* 1080638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080677 */     // MIs[0] policy
     /* 1080677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080687 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080709 */     // GIR_Coverage, 23839,
     /* 1080709 */     GIR_EraseRootFromParent_Done,
     /* 1080710 */   // Label 15941: @1080710
     /* 1080710 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1080787), // Rule ID 23842 //
     /* 1080715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080754 */     // MIs[0] policy
     /* 1080754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080786 */     // GIR_Coverage, 23842,
     /* 1080786 */     GIR_EraseRootFromParent_Done,
     /* 1080787 */   // Label 15942: @1080787
     /* 1080787 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1080864), // Rule ID 23843 //
     /* 1080792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080831 */     // MIs[0] policy
     /* 1080831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080863 */     // GIR_Coverage, 23843,
     /* 1080863 */     GIR_EraseRootFromParent_Done,
     /* 1080864 */   // Label 15943: @1080864
     /* 1080864 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1080941), // Rule ID 23846 //
     /* 1080869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080908 */     // MIs[0] policy
     /* 1080908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080940 */     // GIR_Coverage, 23846,
     /* 1080940 */     GIR_EraseRootFromParent_Done,
     /* 1080941 */   // Label 15944: @1080941
     /* 1080941 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1081018), // Rule ID 23847 //
     /* 1080946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080985 */     // MIs[0] policy
     /* 1080985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080995 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081017 */     // GIR_Coverage, 23847,
     /* 1081017 */     GIR_EraseRootFromParent_Done,
     /* 1081018 */   // Label 15945: @1081018
     /* 1081018 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1081095), // Rule ID 23850 //
     /* 1081023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081062 */     // MIs[0] policy
     /* 1081062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081094 */     // GIR_Coverage, 23850,
     /* 1081094 */     GIR_EraseRootFromParent_Done,
     /* 1081095 */   // Label 15946: @1081095
     /* 1081095 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1081172), // Rule ID 23851 //
     /* 1081100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081139 */     // MIs[0] policy
     /* 1081139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081149 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081171 */     // GIR_Coverage, 23851,
     /* 1081171 */     GIR_EraseRootFromParent_Done,
     /* 1081172 */   // Label 15947: @1081172
     /* 1081172 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1081249), // Rule ID 23854 //
     /* 1081177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081216 */     // MIs[0] policy
     /* 1081216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081248 */     // GIR_Coverage, 23854,
     /* 1081248 */     GIR_EraseRootFromParent_Done,
     /* 1081249 */   // Label 15948: @1081249
     /* 1081249 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1081326), // Rule ID 23855 //
     /* 1081254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081293 */     // MIs[0] policy
     /* 1081293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081325 */     // GIR_Coverage, 23855,
     /* 1081325 */     GIR_EraseRootFromParent_Done,
     /* 1081326 */   // Label 15949: @1081326
     /* 1081326 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1081403), // Rule ID 23858 //
     /* 1081331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081370 */     // MIs[0] policy
     /* 1081370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081402 */     // GIR_Coverage, 23858,
     /* 1081402 */     GIR_EraseRootFromParent_Done,
     /* 1081403 */   // Label 15950: @1081403
     /* 1081403 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1081480), // Rule ID 23859 //
     /* 1081408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081447 */     // MIs[0] policy
     /* 1081447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081457 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081479 */     // GIR_Coverage, 23859,
     /* 1081479 */     GIR_EraseRootFromParent_Done,
     /* 1081480 */   // Label 15951: @1081480
     /* 1081480 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1081557), // Rule ID 23862 //
     /* 1081485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081524 */     // MIs[0] policy
     /* 1081524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081556 */     // GIR_Coverage, 23862,
     /* 1081556 */     GIR_EraseRootFromParent_Done,
     /* 1081557 */   // Label 15952: @1081557
     /* 1081557 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1081634), // Rule ID 23863 //
     /* 1081562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081601 */     // MIs[0] policy
     /* 1081601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081611 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081633 */     // GIR_Coverage, 23863,
     /* 1081633 */     GIR_EraseRootFromParent_Done,
     /* 1081634 */   // Label 15953: @1081634
     /* 1081634 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1081711), // Rule ID 23866 //
     /* 1081639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081678 */     // MIs[0] policy
     /* 1081678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081710 */     // GIR_Coverage, 23866,
     /* 1081710 */     GIR_EraseRootFromParent_Done,
     /* 1081711 */   // Label 15954: @1081711
     /* 1081711 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1081788), // Rule ID 23867 //
     /* 1081716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081755 */     // MIs[0] policy
     /* 1081755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081787 */     // GIR_Coverage, 23867,
     /* 1081787 */     GIR_EraseRootFromParent_Done,
     /* 1081788 */   // Label 15955: @1081788
     /* 1081788 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1081865), // Rule ID 23870 //
     /* 1081793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081832 */     // MIs[0] policy
     /* 1081832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081864 */     // GIR_Coverage, 23870,
     /* 1081864 */     GIR_EraseRootFromParent_Done,
     /* 1081865 */   // Label 15956: @1081865
     /* 1081865 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1081942), // Rule ID 23871 //
     /* 1081870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081909 */     // MIs[0] policy
     /* 1081909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081941 */     // GIR_Coverage, 23871,
     /* 1081941 */     GIR_EraseRootFromParent_Done,
     /* 1081942 */   // Label 15957: @1081942
     /* 1081942 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1082019), // Rule ID 23874 //
     /* 1081947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081986 */     // MIs[0] policy
     /* 1081986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082018 */     // GIR_Coverage, 23874,
     /* 1082018 */     GIR_EraseRootFromParent_Done,
     /* 1082019 */   // Label 15958: @1082019
     /* 1082019 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1082096), // Rule ID 23875 //
     /* 1082024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1082035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1082038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1082041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082063 */     // MIs[0] policy
     /* 1082063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082073 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1082076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082095 */     // GIR_Coverage, 23875,
     /* 1082095 */     GIR_EraseRootFromParent_Done,
     /* 1082096 */   // Label 15959: @1082096
     /* 1082096 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1082173), // Rule ID 24142 //
     /* 1082101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082140 */     // MIs[0] policy
     /* 1082140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082150 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1082153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082172 */     // GIR_Coverage, 24142,
     /* 1082172 */     GIR_EraseRootFromParent_Done,
     /* 1082173 */   // Label 15960: @1082173
     /* 1082173 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1082250), // Rule ID 24143 //
     /* 1082178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082217 */     // MIs[0] policy
     /* 1082217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1082230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082249 */     // GIR_Coverage, 24143,
     /* 1082249 */     GIR_EraseRootFromParent_Done,
     /* 1082250 */   // Label 15961: @1082250
     /* 1082250 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1082327), // Rule ID 24146 //
     /* 1082255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082294 */     // MIs[0] policy
     /* 1082294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082304 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082326 */     // GIR_Coverage, 24146,
     /* 1082326 */     GIR_EraseRootFromParent_Done,
     /* 1082327 */   // Label 15962: @1082327
     /* 1082327 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1082404), // Rule ID 24147 //
     /* 1082332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082371 */     // MIs[0] policy
     /* 1082371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082381 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082403 */     // GIR_Coverage, 24147,
     /* 1082403 */     GIR_EraseRootFromParent_Done,
     /* 1082404 */   // Label 15963: @1082404
     /* 1082404 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1082481), // Rule ID 24150 //
     /* 1082409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082448 */     // MIs[0] policy
     /* 1082448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082458 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082480 */     // GIR_Coverage, 24150,
     /* 1082480 */     GIR_EraseRootFromParent_Done,
     /* 1082481 */   // Label 15964: @1082481
     /* 1082481 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1082558), // Rule ID 24151 //
     /* 1082486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082525 */     // MIs[0] policy
     /* 1082525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082535 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082557 */     // GIR_Coverage, 24151,
     /* 1082557 */     GIR_EraseRootFromParent_Done,
     /* 1082558 */   // Label 15965: @1082558
     /* 1082558 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1082635), // Rule ID 24154 //
     /* 1082563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082602 */     // MIs[0] policy
     /* 1082602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082612 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082634 */     // GIR_Coverage, 24154,
     /* 1082634 */     GIR_EraseRootFromParent_Done,
     /* 1082635 */   // Label 15966: @1082635
     /* 1082635 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1082712), // Rule ID 24155 //
     /* 1082640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082679 */     // MIs[0] policy
     /* 1082679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082689 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082711 */     // GIR_Coverage, 24155,
     /* 1082711 */     GIR_EraseRootFromParent_Done,
     /* 1082712 */   // Label 15967: @1082712
     /* 1082712 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1082789), // Rule ID 24158 //
     /* 1082717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082756 */     // MIs[0] policy
     /* 1082756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082788 */     // GIR_Coverage, 24158,
     /* 1082788 */     GIR_EraseRootFromParent_Done,
     /* 1082789 */   // Label 15968: @1082789
     /* 1082789 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1082866), // Rule ID 24159 //
     /* 1082794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082833 */     // MIs[0] policy
     /* 1082833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082843 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082865 */     // GIR_Coverage, 24159,
     /* 1082865 */     GIR_EraseRootFromParent_Done,
     /* 1082866 */   // Label 15969: @1082866
     /* 1082866 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1082943), // Rule ID 24162 //
     /* 1082871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1082874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082910 */     // MIs[0] policy
     /* 1082910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082920 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082942 */     // GIR_Coverage, 24162,
     /* 1082942 */     GIR_EraseRootFromParent_Done,
     /* 1082943 */   // Label 15970: @1082943
     /* 1082943 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1083020), // Rule ID 24163 //
     /* 1082948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082987 */     // MIs[0] policy
     /* 1082987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082997 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1083000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083019 */     // GIR_Coverage, 24163,
     /* 1083019 */     GIR_EraseRootFromParent_Done,
     /* 1083020 */   // Label 15971: @1083020
     /* 1083020 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1083097), // Rule ID 24166 //
     /* 1083025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1083042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083064 */     // MIs[0] policy
     /* 1083064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083074 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083096 */     // GIR_Coverage, 24166,
     /* 1083096 */     GIR_EraseRootFromParent_Done,
     /* 1083097 */   // Label 15972: @1083097
     /* 1083097 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1083174), // Rule ID 24167 //
     /* 1083102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1083113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1083116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1083119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083141 */     // MIs[0] policy
     /* 1083141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083151 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083173 */     // GIR_Coverage, 24167,
     /* 1083173 */     GIR_EraseRootFromParent_Done,
     /* 1083174 */   // Label 15973: @1083174
     /* 1083174 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1083251), // Rule ID 24170 //
     /* 1083179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1083196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083218 */     // MIs[0] policy
     /* 1083218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083228 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083250 */     // GIR_Coverage, 24170,
     /* 1083250 */     GIR_EraseRootFromParent_Done,
     /* 1083251 */   // Label 15974: @1083251
     /* 1083251 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1083328), // Rule ID 24171 //
     /* 1083256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1083267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1083270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1083273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083295 */     // MIs[0] policy
     /* 1083295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083305 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083327 */     // GIR_Coverage, 24171,
     /* 1083327 */     GIR_EraseRootFromParent_Done,
     /* 1083328 */   // Label 15975: @1083328
     /* 1083328 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1083405), // Rule ID 24174 //
     /* 1083333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1083344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1083347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1083350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083372 */     // MIs[0] policy
     /* 1083372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083382 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083404 */     // GIR_Coverage, 24174,
     /* 1083404 */     GIR_EraseRootFromParent_Done,
     /* 1083405 */   // Label 15976: @1083405
     /* 1083405 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1083482), // Rule ID 24175 //
     /* 1083410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1083421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1083424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1083427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083449 */     // MIs[0] policy
     /* 1083449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083459 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083481 */     // GIR_Coverage, 24175,
     /* 1083481 */     GIR_EraseRootFromParent_Done,
     /* 1083482 */   // Label 15977: @1083482
     /* 1083482 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1083559), // Rule ID 24178 //
     /* 1083487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083526 */     // MIs[0] policy
     /* 1083526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083558 */     // GIR_Coverage, 24178,
     /* 1083558 */     GIR_EraseRootFromParent_Done,
     /* 1083559 */   // Label 15978: @1083559
     /* 1083559 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1083636), // Rule ID 24179 //
     /* 1083564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083603 */     // MIs[0] policy
     /* 1083603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083635 */     // GIR_Coverage, 24179,
     /* 1083635 */     GIR_EraseRootFromParent_Done,
     /* 1083636 */   // Label 15979: @1083636
     /* 1083636 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1083713), // Rule ID 24182 //
     /* 1083641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083680 */     // MIs[0] policy
     /* 1083680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083712 */     // GIR_Coverage, 24182,
     /* 1083712 */     GIR_EraseRootFromParent_Done,
     /* 1083713 */   // Label 15980: @1083713
     /* 1083713 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1083790), // Rule ID 24183 //
     /* 1083718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083757 */     // MIs[0] policy
     /* 1083757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083767 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083789 */     // GIR_Coverage, 24183,
     /* 1083789 */     GIR_EraseRootFromParent_Done,
     /* 1083790 */   // Label 15981: @1083790
     /* 1083790 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1083867), // Rule ID 24186 //
     /* 1083795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083834 */     // MIs[0] policy
     /* 1083834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083866 */     // GIR_Coverage, 24186,
     /* 1083866 */     GIR_EraseRootFromParent_Done,
     /* 1083867 */   // Label 15982: @1083867
     /* 1083867 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1083944), // Rule ID 24187 //
     /* 1083872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083911 */     // MIs[0] policy
     /* 1083911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083921 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083943 */     // GIR_Coverage, 24187,
     /* 1083943 */     GIR_EraseRootFromParent_Done,
     /* 1083944 */   // Label 15983: @1083944
     /* 1083944 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1084021), // Rule ID 24190 //
     /* 1083949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083988 */     // MIs[0] policy
     /* 1083988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1084001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084020 */     // GIR_Coverage, 24190,
     /* 1084020 */     GIR_EraseRootFromParent_Done,
     /* 1084021 */   // Label 15984: @1084021
     /* 1084021 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1084098), // Rule ID 24191 //
     /* 1084026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1084037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1084040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1084043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084065 */     // MIs[0] policy
     /* 1084065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084075 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1084078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084097 */     // GIR_Coverage, 24191,
     /* 1084097 */     GIR_EraseRootFromParent_Done,
     /* 1084098 */   // Label 15985: @1084098
     /* 1084098 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1084175), // Rule ID 24194 //
     /* 1084103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1084106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1084114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1084117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084142 */     // MIs[0] policy
     /* 1084142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084152 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1084155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084174 */     // GIR_Coverage, 24194,
     /* 1084174 */     GIR_EraseRootFromParent_Done,
     /* 1084175 */   // Label 15986: @1084175
     /* 1084175 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1084252), // Rule ID 24195 //
     /* 1084180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1084191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1084194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1084197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084219 */     // MIs[0] policy
     /* 1084219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084229 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1084232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084251 */     // GIR_Coverage, 24195,
     /* 1084251 */     GIR_EraseRootFromParent_Done,
     /* 1084252 */   // Label 15987: @1084252
     /* 1084252 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1084329), // Rule ID 24198 //
     /* 1084257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1084260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1084268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1084271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084296 */     // MIs[0] policy
     /* 1084296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084306 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1084309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084328 */     // GIR_Coverage, 24198,
     /* 1084328 */     GIR_EraseRootFromParent_Done,
     /* 1084329 */   // Label 15988: @1084329
     /* 1084329 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1084406), // Rule ID 24199 //
     /* 1084334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1084337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1084342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1084345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1084348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1084351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084373 */     // MIs[0] policy
     /* 1084373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084383 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1084386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084405 */     // GIR_Coverage, 24199,
     /* 1084405 */     GIR_EraseRootFromParent_Done,
     /* 1084406 */   // Label 15989: @1084406
     /* 1084406 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1084483), // Rule ID 24262 //
     /* 1084411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084450 */     // MIs[0] policy
     /* 1084450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084460 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084482 */     // GIR_Coverage, 24262,
     /* 1084482 */     GIR_EraseRootFromParent_Done,
     /* 1084483 */   // Label 15990: @1084483
     /* 1084483 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1084560), // Rule ID 24263 //
     /* 1084488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084527 */     // MIs[0] policy
     /* 1084527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084537 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084559 */     // GIR_Coverage, 24263,
     /* 1084559 */     GIR_EraseRootFromParent_Done,
     /* 1084560 */   // Label 15991: @1084560
     /* 1084560 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1084637), // Rule ID 24266 //
     /* 1084565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084604 */     // MIs[0] policy
     /* 1084604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084614 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084636 */     // GIR_Coverage, 24266,
     /* 1084636 */     GIR_EraseRootFromParent_Done,
     /* 1084637 */   // Label 15992: @1084637
     /* 1084637 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1084714), // Rule ID 24267 //
     /* 1084642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084681 */     // MIs[0] policy
     /* 1084681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084691 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084713 */     // GIR_Coverage, 24267,
     /* 1084713 */     GIR_EraseRootFromParent_Done,
     /* 1084714 */   // Label 15993: @1084714
     /* 1084714 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1084791), // Rule ID 24270 //
     /* 1084719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084758 */     // MIs[0] policy
     /* 1084758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084790 */     // GIR_Coverage, 24270,
     /* 1084790 */     GIR_EraseRootFromParent_Done,
     /* 1084791 */   // Label 15994: @1084791
     /* 1084791 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1084868), // Rule ID 24271 //
     /* 1084796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084835 */     // MIs[0] policy
     /* 1084835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084845 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084867 */     // GIR_Coverage, 24271,
     /* 1084867 */     GIR_EraseRootFromParent_Done,
     /* 1084868 */   // Label 15995: @1084868
     /* 1084868 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1084945), // Rule ID 24274 //
     /* 1084873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084912 */     // MIs[0] policy
     /* 1084912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084944 */     // GIR_Coverage, 24274,
     /* 1084944 */     GIR_EraseRootFromParent_Done,
     /* 1084945 */   // Label 15996: @1084945
     /* 1084945 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1085022), // Rule ID 24275 //
     /* 1084950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084989 */     // MIs[0] policy
     /* 1084989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084999 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085021 */     // GIR_Coverage, 24275,
     /* 1085021 */     GIR_EraseRootFromParent_Done,
     /* 1085022 */   // Label 15997: @1085022
     /* 1085022 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1085099), // Rule ID 24278 //
     /* 1085027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1085038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1085041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085066 */     // MIs[0] policy
     /* 1085066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085098 */     // GIR_Coverage, 24278,
     /* 1085098 */     GIR_EraseRootFromParent_Done,
     /* 1085099 */   // Label 15998: @1085099
     /* 1085099 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1085176), // Rule ID 24279 //
     /* 1085104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1085115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1085118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1085121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085143 */     // MIs[0] policy
     /* 1085143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085153 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085175 */     // GIR_Coverage, 24279,
     /* 1085175 */     GIR_EraseRootFromParent_Done,
     /* 1085176 */   // Label 15999: @1085176
     /* 1085176 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1085253), // Rule ID 24282 //
     /* 1085181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1085192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1085195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1085198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085220 */     // MIs[0] policy
     /* 1085220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085230 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085252 */     // GIR_Coverage, 24282,
     /* 1085252 */     GIR_EraseRootFromParent_Done,
     /* 1085253 */   // Label 16000: @1085253
     /* 1085253 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1085330), // Rule ID 24283 //
     /* 1085258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1085269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1085272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1085275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085297 */     // MIs[0] policy
     /* 1085297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085307 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1085310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085329 */     // GIR_Coverage, 24283,
     /* 1085329 */     GIR_EraseRootFromParent_Done,
     /* 1085330 */   // Label 16001: @1085330
     /* 1085330 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1085407), // Rule ID 24286 //
     /* 1085335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1085346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1085349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085374 */     // MIs[0] policy
     /* 1085374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085384 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085406 */     // GIR_Coverage, 24286,
     /* 1085406 */     GIR_EraseRootFromParent_Done,
     /* 1085407 */   // Label 16002: @1085407
     /* 1085407 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1085484), // Rule ID 24287 //
     /* 1085412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1085423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1085426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1085429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085451 */     // MIs[0] policy
     /* 1085451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085461 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085483 */     // GIR_Coverage, 24287,
     /* 1085483 */     GIR_EraseRootFromParent_Done,
     /* 1085484 */   // Label 16003: @1085484
     /* 1085484 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1085561), // Rule ID 24290 //
     /* 1085489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085528 */     // MIs[0] policy
     /* 1085528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085560 */     // GIR_Coverage, 24290,
     /* 1085560 */     GIR_EraseRootFromParent_Done,
     /* 1085561 */   // Label 16004: @1085561
     /* 1085561 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1085638), // Rule ID 24291 //
     /* 1085566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085605 */     // MIs[0] policy
     /* 1085605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085615 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085637 */     // GIR_Coverage, 24291,
     /* 1085637 */     GIR_EraseRootFromParent_Done,
     /* 1085638 */   // Label 16005: @1085638
     /* 1085638 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1085715), // Rule ID 24294 //
     /* 1085643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085682 */     // MIs[0] policy
     /* 1085682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085692 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085714 */     // GIR_Coverage, 24294,
     /* 1085714 */     GIR_EraseRootFromParent_Done,
     /* 1085715 */   // Label 16006: @1085715
     /* 1085715 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1085792), // Rule ID 24295 //
     /* 1085720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085759 */     // MIs[0] policy
     /* 1085759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085769 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085791 */     // GIR_Coverage, 24295,
     /* 1085791 */     GIR_EraseRootFromParent_Done,
     /* 1085792 */   // Label 16007: @1085792
     /* 1085792 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1085869), // Rule ID 24298 //
     /* 1085797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085836 */     // MIs[0] policy
     /* 1085836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085846 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085868 */     // GIR_Coverage, 24298,
     /* 1085868 */     GIR_EraseRootFromParent_Done,
     /* 1085869 */   // Label 16008: @1085869
     /* 1085869 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1085946), // Rule ID 24299 //
     /* 1085874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1085877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085913 */     // MIs[0] policy
     /* 1085913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085923 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085945 */     // GIR_Coverage, 24299,
     /* 1085945 */     GIR_EraseRootFromParent_Done,
     /* 1085946 */   // Label 16009: @1085946
     /* 1085946 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1086023), // Rule ID 24302 //
     /* 1085951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1085954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085990 */     // MIs[0] policy
     /* 1085990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086000 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086022 */     // GIR_Coverage, 24302,
     /* 1086022 */     GIR_EraseRootFromParent_Done,
     /* 1086023 */   // Label 16010: @1086023
     /* 1086023 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1086100), // Rule ID 24303 //
     /* 1086028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1086039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1086042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1086045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086067 */     // MIs[0] policy
     /* 1086067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086077 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086099 */     // GIR_Coverage, 24303,
     /* 1086099 */     GIR_EraseRootFromParent_Done,
     /* 1086100 */   // Label 16011: @1086100
     /* 1086100 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1086177), // Rule ID 24306 //
     /* 1086105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1086108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1086116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1086119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086144 */     // MIs[0] policy
     /* 1086144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086154 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086176 */     // GIR_Coverage, 24306,
     /* 1086176 */     GIR_EraseRootFromParent_Done,
     /* 1086177 */   // Label 16012: @1086177
     /* 1086177 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1086254), // Rule ID 24307 //
     /* 1086182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1086185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1086193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1086196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1086199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086221 */     // MIs[0] policy
     /* 1086221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086231 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086253 */     // GIR_Coverage, 24307,
     /* 1086253 */     GIR_EraseRootFromParent_Done,
     /* 1086254 */   // Label 16013: @1086254
     /* 1086254 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1086331), // Rule ID 24310 //
     /* 1086259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1086270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1086273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086298 */     // MIs[0] policy
     /* 1086298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086308 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1086311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086330 */     // GIR_Coverage, 24310,
     /* 1086330 */     GIR_EraseRootFromParent_Done,
     /* 1086331 */   // Label 16014: @1086331
     /* 1086331 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1086408), // Rule ID 24311 //
     /* 1086336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1086347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1086350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1086353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086375 */     // MIs[0] policy
     /* 1086375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086385 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1086388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086407 */     // GIR_Coverage, 24311,
     /* 1086407 */     GIR_EraseRootFromParent_Done,
     /* 1086408 */   // Label 16015: @1086408
     /* 1086408 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1086485), // Rule ID 24314 //
     /* 1086413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086452 */     // MIs[0] policy
     /* 1086452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086462 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086484 */     // GIR_Coverage, 24314,
     /* 1086484 */     GIR_EraseRootFromParent_Done,
     /* 1086485 */   // Label 16016: @1086485
     /* 1086485 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1086562), // Rule ID 24315 //
     /* 1086490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086529 */     // MIs[0] policy
     /* 1086529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086539 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086561 */     // GIR_Coverage, 24315,
     /* 1086561 */     GIR_EraseRootFromParent_Done,
     /* 1086562 */   // Label 16017: @1086562
     /* 1086562 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1086639), // Rule ID 24318 //
     /* 1086567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1086570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086606 */     // MIs[0] policy
     /* 1086606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086616 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086638 */     // GIR_Coverage, 24318,
     /* 1086638 */     GIR_EraseRootFromParent_Done,
     /* 1086639 */   // Label 16018: @1086639
     /* 1086639 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1086716), // Rule ID 24319 //
     /* 1086644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1086647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086683 */     // MIs[0] policy
     /* 1086683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086693 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086715 */     // GIR_Coverage, 24319,
     /* 1086715 */     GIR_EraseRootFromParent_Done,
     /* 1086716 */   // Label 16019: @1086716
     /* 1086716 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1086793), // Rule ID 60610 //
     /* 1086721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1086724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086760 */     // MIs[0] policy
     /* 1086760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086792 */     // GIR_Coverage, 60610,
     /* 1086792 */     GIR_EraseRootFromParent_Done,
     /* 1086793 */   // Label 16020: @1086793
     /* 1086793 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1086870), // Rule ID 60611 //
     /* 1086798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1086801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086837 */     // MIs[0] policy
     /* 1086837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086847 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086869 */     // GIR_Coverage, 60611,
     /* 1086869 */     GIR_EraseRootFromParent_Done,
     /* 1086870 */   // Label 16021: @1086870
     /* 1086870 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1086947), // Rule ID 60624 //
     /* 1086875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086914 */     // MIs[0] policy
     /* 1086914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086946 */     // GIR_Coverage, 60624,
     /* 1086946 */     GIR_EraseRootFromParent_Done,
     /* 1086947 */   // Label 16022: @1086947
     /* 1086947 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1087024), // Rule ID 60625 //
     /* 1086952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086991 */     // MIs[0] policy
     /* 1086991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087001 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1087004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087023 */     // GIR_Coverage, 60625,
     /* 1087023 */     GIR_EraseRootFromParent_Done,
     /* 1087024 */   // Label 16023: @1087024
     /* 1087024 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1087101), // Rule ID 60628 //
     /* 1087029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1087046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087068 */     // MIs[0] policy
     /* 1087068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087078 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087100 */     // GIR_Coverage, 60628,
     /* 1087100 */     GIR_EraseRootFromParent_Done,
     /* 1087101 */   // Label 16024: @1087101
     /* 1087101 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1087178), // Rule ID 60629 //
     /* 1087106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1087117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1087120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1087123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087145 */     // MIs[0] policy
     /* 1087145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087155 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087177 */     // GIR_Coverage, 60629,
     /* 1087177 */     GIR_EraseRootFromParent_Done,
     /* 1087178 */   // Label 16025: @1087178
     /* 1087178 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1087255), // Rule ID 60632 //
     /* 1087183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1087200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087222 */     // MIs[0] policy
     /* 1087222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087254 */     // GIR_Coverage, 60632,
     /* 1087254 */     GIR_EraseRootFromParent_Done,
     /* 1087255 */   // Label 16026: @1087255
     /* 1087255 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1087332), // Rule ID 60633 //
     /* 1087260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1087271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1087274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1087277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087299 */     // MIs[0] policy
     /* 1087299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087309 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087331 */     // GIR_Coverage, 60633,
     /* 1087331 */     GIR_EraseRootFromParent_Done,
     /* 1087332 */   // Label 16027: @1087332
     /* 1087332 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1087409), // Rule ID 60636 //
     /* 1087337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087376 */     // MIs[0] policy
     /* 1087376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087408 */     // GIR_Coverage, 60636,
     /* 1087408 */     GIR_EraseRootFromParent_Done,
     /* 1087409 */   // Label 16028: @1087409
     /* 1087409 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1087486), // Rule ID 60637 //
     /* 1087414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087453 */     // MIs[0] policy
     /* 1087453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087463 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087485 */     // GIR_Coverage, 60637,
     /* 1087485 */     GIR_EraseRootFromParent_Done,
     /* 1087486 */   // Label 16029: @1087486
     /* 1087486 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1087563), // Rule ID 60640 //
     /* 1087491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087530 */     // MIs[0] policy
     /* 1087530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087562 */     // GIR_Coverage, 60640,
     /* 1087562 */     GIR_EraseRootFromParent_Done,
     /* 1087563 */   // Label 16030: @1087563
     /* 1087563 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1087640), // Rule ID 60641 //
     /* 1087568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087607 */     // MIs[0] policy
     /* 1087607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087617 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087639 */     // GIR_Coverage, 60641,
     /* 1087639 */     GIR_EraseRootFromParent_Done,
     /* 1087640 */   // Label 16031: @1087640
     /* 1087640 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1087717), // Rule ID 60644 //
     /* 1087645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087684 */     // MIs[0] policy
     /* 1087684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087716 */     // GIR_Coverage, 60644,
     /* 1087716 */     GIR_EraseRootFromParent_Done,
     /* 1087717 */   // Label 16032: @1087717
     /* 1087717 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1087794), // Rule ID 60645 //
     /* 1087722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087761 */     // MIs[0] policy
     /* 1087761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087793 */     // GIR_Coverage, 60645,
     /* 1087793 */     GIR_EraseRootFromParent_Done,
     /* 1087794 */   // Label 16033: @1087794
     /* 1087794 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1087871), // Rule ID 60648 //
     /* 1087799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087838 */     // MIs[0] policy
     /* 1087838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087870 */     // GIR_Coverage, 60648,
     /* 1087870 */     GIR_EraseRootFromParent_Done,
     /* 1087871 */   // Label 16034: @1087871
     /* 1087871 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1087948), // Rule ID 60649 //
     /* 1087876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087915 */     // MIs[0] policy
     /* 1087915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11221:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087947 */     // GIR_Coverage, 60649,
     /* 1087947 */     GIR_EraseRootFromParent_Done,
     /* 1087948 */   // Label 16035: @1087948
     /* 1087948 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1088025), // Rule ID 60652 //
     /* 1087953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087992 */     // MIs[0] policy
     /* 1087992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088024 */     // GIR_Coverage, 60652,
     /* 1088024 */     GIR_EraseRootFromParent_Done,
     /* 1088025 */   // Label 16036: @1088025
     /* 1088025 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1088102), // Rule ID 60653 //
     /* 1088030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088069 */     // MIs[0] policy
     /* 1088069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088079 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11221:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088101 */     // GIR_Coverage, 60653,
     /* 1088101 */     GIR_EraseRootFromParent_Done,
     /* 1088102 */   // Label 16037: @1088102
     /* 1088102 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1088179), // Rule ID 60656 //
     /* 1088107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088146 */     // MIs[0] policy
     /* 1088146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088178 */     // GIR_Coverage, 60656,
     /* 1088178 */     GIR_EraseRootFromParent_Done,
     /* 1088179 */   // Label 16038: @1088179
     /* 1088179 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1088256), // Rule ID 60657 //
     /* 1088184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088223 */     // MIs[0] policy
     /* 1088223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088255 */     // GIR_Coverage, 60657,
     /* 1088255 */     GIR_EraseRootFromParent_Done,
     /* 1088256 */   // Label 16039: @1088256
     /* 1088256 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1088333), // Rule ID 60660 //
     /* 1088261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1088281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088300 */     // MIs[0] policy
     /* 1088300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088332 */     // GIR_Coverage, 60660,
     /* 1088332 */     GIR_EraseRootFromParent_Done,
     /* 1088333 */   // Label 16040: @1088333
     /* 1088333 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1088410), // Rule ID 60661 //
     /* 1088338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1088358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1088365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088377 */     // MIs[0] policy
     /* 1088377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088387 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1088390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088409 */     // GIR_Coverage, 60661,
     /* 1088409 */     GIR_EraseRootFromParent_Done,
     /* 1088410 */   // Label 16041: @1088410
     /* 1088410 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1088487), // Rule ID 60664 //
     /* 1088415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088454 */     // MIs[0] policy
     /* 1088454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088486 */     // GIR_Coverage, 60664,
     /* 1088486 */     GIR_EraseRootFromParent_Done,
     /* 1088487 */   // Label 16042: @1088487
     /* 1088487 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1088564), // Rule ID 60665 //
     /* 1088492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088531 */     // MIs[0] policy
     /* 1088531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088563 */     // GIR_Coverage, 60665,
     /* 1088563 */     GIR_EraseRootFromParent_Done,
     /* 1088564 */   // Label 16043: @1088564
     /* 1088564 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1088641), // Rule ID 60668 //
     /* 1088569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088608 */     // MIs[0] policy
     /* 1088608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088640 */     // GIR_Coverage, 60668,
     /* 1088640 */     GIR_EraseRootFromParent_Done,
     /* 1088641 */   // Label 16044: @1088641
     /* 1088641 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1088718), // Rule ID 60669 //
     /* 1088646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088685 */     // MIs[0] policy
     /* 1088685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088695 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088717 */     // GIR_Coverage, 60669,
     /* 1088717 */     GIR_EraseRootFromParent_Done,
     /* 1088718 */   // Label 16045: @1088718
     /* 1088718 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1088795), // Rule ID 60672 //
     /* 1088723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088762 */     // MIs[0] policy
     /* 1088762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088794 */     // GIR_Coverage, 60672,
     /* 1088794 */     GIR_EraseRootFromParent_Done,
     /* 1088795 */   // Label 16046: @1088795
     /* 1088795 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1088872), // Rule ID 60673 //
     /* 1088800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088839 */     // MIs[0] policy
     /* 1088839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088849 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088871 */     // GIR_Coverage, 60673,
     /* 1088871 */     GIR_EraseRootFromParent_Done,
     /* 1088872 */   // Label 16047: @1088872
     /* 1088872 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1088949), // Rule ID 60676 //
     /* 1088877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088916 */     // MIs[0] policy
     /* 1088916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088948 */     // GIR_Coverage, 60676,
     /* 1088948 */     GIR_EraseRootFromParent_Done,
     /* 1088949 */   // Label 16048: @1088949
     /* 1088949 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1089026), // Rule ID 60677 //
     /* 1088954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088993 */     // MIs[0] policy
     /* 1088993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089025 */     // GIR_Coverage, 60677,
     /* 1089025 */     GIR_EraseRootFromParent_Done,
     /* 1089026 */   // Label 16049: @1089026
     /* 1089026 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1089103), // Rule ID 60680 //
     /* 1089031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1089042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1089045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1089048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089070 */     // MIs[0] policy
     /* 1089070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089102 */     // GIR_Coverage, 60680,
     /* 1089102 */     GIR_EraseRootFromParent_Done,
     /* 1089103 */   // Label 16050: @1089103
     /* 1089103 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1089180), // Rule ID 60681 //
     /* 1089108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1089119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1089122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1089125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089147 */     // MIs[0] policy
     /* 1089147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089157 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089179 */     // GIR_Coverage, 60681,
     /* 1089179 */     GIR_EraseRootFromParent_Done,
     /* 1089180 */   // Label 16051: @1089180
     /* 1089180 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1089257), // Rule ID 60684 //
     /* 1089185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1089205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089224 */     // MIs[0] policy
     /* 1089224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089256 */     // GIR_Coverage, 60684,
     /* 1089256 */     GIR_EraseRootFromParent_Done,
     /* 1089257 */   // Label 16052: @1089257
     /* 1089257 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1089334), // Rule ID 60685 //
     /* 1089262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1089282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089301 */     // MIs[0] policy
     /* 1089301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089311 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089333 */     // GIR_Coverage, 60685,
     /* 1089333 */     GIR_EraseRootFromParent_Done,
     /* 1089334 */   // Label 16053: @1089334
     /* 1089334 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1089411), // Rule ID 60688 //
     /* 1089339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089378 */     // MIs[0] policy
     /* 1089378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089410 */     // GIR_Coverage, 60688,
     /* 1089410 */     GIR_EraseRootFromParent_Done,
     /* 1089411 */   // Label 16054: @1089411
     /* 1089411 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1089488), // Rule ID 60689 //
     /* 1089416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089455 */     // MIs[0] policy
     /* 1089455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089487 */     // GIR_Coverage, 60689,
     /* 1089487 */     GIR_EraseRootFromParent_Done,
     /* 1089488 */   // Label 16055: @1089488
     /* 1089488 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1089565), // Rule ID 60692 //
     /* 1089493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089532 */     // MIs[0] policy
     /* 1089532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089542 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089564 */     // GIR_Coverage, 60692,
     /* 1089564 */     GIR_EraseRootFromParent_Done,
     /* 1089565 */   // Label 16056: @1089565
     /* 1089565 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1089642), // Rule ID 60693 //
     /* 1089570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089609 */     // MIs[0] policy
     /* 1089609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089641 */     // GIR_Coverage, 60693,
     /* 1089641 */     GIR_EraseRootFromParent_Done,
     /* 1089642 */   // Label 16057: @1089642
     /* 1089642 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1089719), // Rule ID 60696 //
     /* 1089647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089686 */     // MIs[0] policy
     /* 1089686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089718 */     // GIR_Coverage, 60696,
     /* 1089718 */     GIR_EraseRootFromParent_Done,
     /* 1089719 */   // Label 16058: @1089719
     /* 1089719 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1089796), // Rule ID 60697 //
     /* 1089724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089763 */     // MIs[0] policy
     /* 1089763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089773 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089795 */     // GIR_Coverage, 60697,
     /* 1089795 */     GIR_EraseRootFromParent_Done,
     /* 1089796 */   // Label 16059: @1089796
     /* 1089796 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1089873), // Rule ID 60700 //
     /* 1089801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089840 */     // MIs[0] policy
     /* 1089840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089872 */     // GIR_Coverage, 60700,
     /* 1089872 */     GIR_EraseRootFromParent_Done,
     /* 1089873 */   // Label 16060: @1089873
     /* 1089873 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1089950), // Rule ID 60701 //
     /* 1089878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089917 */     // MIs[0] policy
     /* 1089917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089949 */     // GIR_Coverage, 60701,
     /* 1089949 */     GIR_EraseRootFromParent_Done,
     /* 1089950 */   // Label 16061: @1089950
     /* 1089950 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1090027), // Rule ID 60704 //
     /* 1089955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089994 */     // MIs[0] policy
     /* 1089994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1090007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090026 */     // GIR_Coverage, 60704,
     /* 1090026 */     GIR_EraseRootFromParent_Done,
     /* 1090027 */   // Label 16062: @1090027
     /* 1090027 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1090104), // Rule ID 60705 //
     /* 1090032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1090043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1090046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1090049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1090059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1090067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090071 */     // MIs[0] policy
     /* 1090071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1090084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090103 */     // GIR_Coverage, 60705,
     /* 1090103 */     GIR_EraseRootFromParent_Done,
     /* 1090104 */   // Label 16063: @1090104
     /* 1090104 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1090181), // Rule ID 60708 //
     /* 1090109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1090136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090148 */     // MIs[0] policy
     /* 1090148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1090161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090180 */     // GIR_Coverage, 60708,
     /* 1090180 */     GIR_EraseRootFromParent_Done,
     /* 1090181 */   // Label 16064: @1090181
     /* 1090181 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1090258), // Rule ID 60709 //
     /* 1090186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1090213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090225 */     // MIs[0] policy
     /* 1090225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090235 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1090238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090257 */     // GIR_Coverage, 60709,
     /* 1090257 */     GIR_EraseRootFromParent_Done,
     /* 1090258 */   // Label 16065: @1090258
     /* 1090258 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1090335), // Rule ID 60712 //
     /* 1090263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090302 */     // MIs[0] policy
     /* 1090302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090312 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1090315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090334 */     // GIR_Coverage, 60712,
     /* 1090334 */     GIR_EraseRootFromParent_Done,
     /* 1090335 */   // Label 16066: @1090335
     /* 1090335 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1090412), // Rule ID 60713 //
     /* 1090340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090379 */     // MIs[0] policy
     /* 1090379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090389 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1090392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090411 */     // GIR_Coverage, 60713,
     /* 1090411 */     GIR_EraseRootFromParent_Done,
     /* 1090412 */   // Label 16067: @1090412
     /* 1090412 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1090489), // Rule ID 60716 //
     /* 1090417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090456 */     // MIs[0] policy
     /* 1090456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090488 */     // GIR_Coverage, 60716,
     /* 1090488 */     GIR_EraseRootFromParent_Done,
     /* 1090489 */   // Label 16068: @1090489
     /* 1090489 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1090566), // Rule ID 60717 //
     /* 1090494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090533 */     // MIs[0] policy
     /* 1090533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090543 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090565 */     // GIR_Coverage, 60717,
     /* 1090565 */     GIR_EraseRootFromParent_Done,
     /* 1090566 */   // Label 16069: @1090566
     /* 1090566 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1090643), // Rule ID 60720 //
     /* 1090571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090610 */     // MIs[0] policy
     /* 1090610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090642 */     // GIR_Coverage, 60720,
     /* 1090642 */     GIR_EraseRootFromParent_Done,
     /* 1090643 */   // Label 16070: @1090643
     /* 1090643 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1090720), // Rule ID 60721 //
     /* 1090648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090687 */     // MIs[0] policy
     /* 1090687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090697 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090719 */     // GIR_Coverage, 60721,
     /* 1090719 */     GIR_EraseRootFromParent_Done,
     /* 1090720 */   // Label 16071: @1090720
     /* 1090720 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1090797), // Rule ID 60724 //
     /* 1090725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090764 */     // MIs[0] policy
     /* 1090764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090796 */     // GIR_Coverage, 60724,
     /* 1090796 */     GIR_EraseRootFromParent_Done,
     /* 1090797 */   // Label 16072: @1090797
     /* 1090797 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1090874), // Rule ID 60725 //
     /* 1090802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090841 */     // MIs[0] policy
     /* 1090841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090851 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090873 */     // GIR_Coverage, 60725,
     /* 1090873 */     GIR_EraseRootFromParent_Done,
     /* 1090874 */   // Label 16073: @1090874
     /* 1090874 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1090951), // Rule ID 60728 //
     /* 1090879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090918 */     // MIs[0] policy
     /* 1090918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090950 */     // GIR_Coverage, 60728,
     /* 1090950 */     GIR_EraseRootFromParent_Done,
     /* 1090951 */   // Label 16074: @1090951
     /* 1090951 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1091028), // Rule ID 60729 //
     /* 1090956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090995 */     // MIs[0] policy
     /* 1090995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091005 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091027 */     // GIR_Coverage, 60729,
     /* 1091027 */     GIR_EraseRootFromParent_Done,
     /* 1091028 */   // Label 16075: @1091028
     /* 1091028 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1091105), // Rule ID 60732 //
     /* 1091033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091072 */     // MIs[0] policy
     /* 1091072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091104 */     // GIR_Coverage, 60732,
     /* 1091104 */     GIR_EraseRootFromParent_Done,
     /* 1091105 */   // Label 16076: @1091105
     /* 1091105 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1091182), // Rule ID 60733 //
     /* 1091110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091149 */     // MIs[0] policy
     /* 1091149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091159 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1091162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091181 */     // GIR_Coverage, 60733,
     /* 1091181 */     GIR_EraseRootFromParent_Done,
     /* 1091182 */   // Label 16077: @1091182
     /* 1091182 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1091259), // Rule ID 60736 //
     /* 1091187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091226 */     // MIs[0] policy
     /* 1091226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091258 */     // GIR_Coverage, 60736,
     /* 1091258 */     GIR_EraseRootFromParent_Done,
     /* 1091259 */   // Label 16078: @1091259
     /* 1091259 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1091336), // Rule ID 60737 //
     /* 1091264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091303 */     // MIs[0] policy
     /* 1091303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091313 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11229:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091335 */     // GIR_Coverage, 60737,
     /* 1091335 */     GIR_EraseRootFromParent_Done,
     /* 1091336 */   // Label 16079: @1091336
     /* 1091336 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1091413), // Rule ID 60740 //
     /* 1091341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091380 */     // MIs[0] policy
     /* 1091380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091412 */     // GIR_Coverage, 60740,
     /* 1091412 */     GIR_EraseRootFromParent_Done,
     /* 1091413 */   // Label 16080: @1091413
     /* 1091413 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1091490), // Rule ID 60741 //
     /* 1091418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091457 */     // MIs[0] policy
     /* 1091457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091467 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091489 */     // GIR_Coverage, 60741,
     /* 1091489 */     GIR_EraseRootFromParent_Done,
     /* 1091490 */   // Label 16081: @1091490
     /* 1091490 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1091567), // Rule ID 60744 //
     /* 1091495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091534 */     // MIs[0] policy
     /* 1091534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091566 */     // GIR_Coverage, 60744,
     /* 1091566 */     GIR_EraseRootFromParent_Done,
     /* 1091567 */   // Label 16082: @1091567
     /* 1091567 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1091644), // Rule ID 60745 //
     /* 1091572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091611 */     // MIs[0] policy
     /* 1091611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091621 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091643 */     // GIR_Coverage, 60745,
     /* 1091643 */     GIR_EraseRootFromParent_Done,
     /* 1091644 */   // Label 16083: @1091644
     /* 1091644 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1091721), // Rule ID 60748 //
     /* 1091649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091688 */     // MIs[0] policy
     /* 1091688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091698 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091720 */     // GIR_Coverage, 60748,
     /* 1091720 */     GIR_EraseRootFromParent_Done,
     /* 1091721 */   // Label 16084: @1091721
     /* 1091721 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1091798), // Rule ID 60749 //
     /* 1091726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091765 */     // MIs[0] policy
     /* 1091765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091797 */     // GIR_Coverage, 60749,
     /* 1091797 */     GIR_EraseRootFromParent_Done,
     /* 1091798 */   // Label 16085: @1091798
     /* 1091798 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1091875), // Rule ID 60752 //
     /* 1091803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091842 */     // MIs[0] policy
     /* 1091842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091874 */     // GIR_Coverage, 60752,
     /* 1091874 */     GIR_EraseRootFromParent_Done,
     /* 1091875 */   // Label 16086: @1091875
     /* 1091875 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1091952), // Rule ID 60753 //
     /* 1091880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091919 */     // MIs[0] policy
     /* 1091919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091951 */     // GIR_Coverage, 60753,
     /* 1091951 */     GIR_EraseRootFromParent_Done,
     /* 1091952 */   // Label 16087: @1091952
     /* 1091952 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1092029), // Rule ID 60756 //
     /* 1091957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091996 */     // MIs[0] policy
     /* 1091996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092028 */     // GIR_Coverage, 60756,
     /* 1092028 */     GIR_EraseRootFromParent_Done,
     /* 1092029 */   // Label 16088: @1092029
     /* 1092029 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1092106), // Rule ID 60757 //
     /* 1092034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1092045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1092048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1092051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092073 */     // MIs[0] policy
     /* 1092073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092083 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092105 */     // GIR_Coverage, 60757,
     /* 1092105 */     GIR_EraseRootFromParent_Done,
     /* 1092106 */   // Label 16089: @1092106
     /* 1092106 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1092183), // Rule ID 60760 //
     /* 1092111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092150 */     // MIs[0] policy
     /* 1092150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092160 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092182 */     // GIR_Coverage, 60760,
     /* 1092182 */     GIR_EraseRootFromParent_Done,
     /* 1092183 */   // Label 16090: @1092183
     /* 1092183 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1092260), // Rule ID 60761 //
     /* 1092188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092227 */     // MIs[0] policy
     /* 1092227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092237 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092259 */     // GIR_Coverage, 60761,
     /* 1092259 */     GIR_EraseRootFromParent_Done,
     /* 1092260 */   // Label 16091: @1092260
     /* 1092260 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1092337), // Rule ID 60764 //
     /* 1092265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092304 */     // MIs[0] policy
     /* 1092304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092336 */     // GIR_Coverage, 60764,
     /* 1092336 */     GIR_EraseRootFromParent_Done,
     /* 1092337 */   // Label 16092: @1092337
     /* 1092337 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1092414), // Rule ID 60765 //
     /* 1092342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092381 */     // MIs[0] policy
     /* 1092381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092413 */     // GIR_Coverage, 60765,
     /* 1092413 */     GIR_EraseRootFromParent_Done,
     /* 1092414 */   // Label 16093: @1092414
     /* 1092414 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1092491), // Rule ID 60768 //
     /* 1092419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092458 */     // MIs[0] policy
     /* 1092458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092490 */     // GIR_Coverage, 60768,
     /* 1092490 */     GIR_EraseRootFromParent_Done,
     /* 1092491 */   // Label 16094: @1092491
     /* 1092491 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1092568), // Rule ID 60769 //
     /* 1092496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092535 */     // MIs[0] policy
     /* 1092535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092545 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092567 */     // GIR_Coverage, 60769,
     /* 1092567 */     GIR_EraseRootFromParent_Done,
     /* 1092568 */   // Label 16095: @1092568
     /* 1092568 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1092645), // Rule ID 60772 //
     /* 1092573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092612 */     // MIs[0] policy
     /* 1092612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092644 */     // GIR_Coverage, 60772,
     /* 1092644 */     GIR_EraseRootFromParent_Done,
     /* 1092645 */   // Label 16096: @1092645
     /* 1092645 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1092722), // Rule ID 60773 //
     /* 1092650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092689 */     // MIs[0] policy
     /* 1092689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092699 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092721 */     // GIR_Coverage, 60773,
     /* 1092721 */     GIR_EraseRootFromParent_Done,
     /* 1092722 */   // Label 16097: @1092722
     /* 1092722 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1092799), // Rule ID 60776 //
     /* 1092727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092766 */     // MIs[0] policy
     /* 1092766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092798 */     // GIR_Coverage, 60776,
     /* 1092798 */     GIR_EraseRootFromParent_Done,
     /* 1092799 */   // Label 16098: @1092799
     /* 1092799 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1092876), // Rule ID 60777 //
     /* 1092804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092843 */     // MIs[0] policy
     /* 1092843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092875 */     // GIR_Coverage, 60777,
     /* 1092875 */     GIR_EraseRootFromParent_Done,
     /* 1092876 */   // Label 16099: @1092876
     /* 1092876 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1092953), // Rule ID 60780 //
     /* 1092881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092920 */     // MIs[0] policy
     /* 1092920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092952 */     // GIR_Coverage, 60780,
     /* 1092952 */     GIR_EraseRootFromParent_Done,
     /* 1092953 */   // Label 16100: @1092953
     /* 1092953 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1093030), // Rule ID 60781 //
     /* 1092958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092997 */     // MIs[0] policy
     /* 1092997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093007 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093029 */     // GIR_Coverage, 60781,
     /* 1093029 */     GIR_EraseRootFromParent_Done,
     /* 1093030 */   // Label 16101: @1093030
     /* 1093030 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1093107), // Rule ID 60784 //
     /* 1093035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093074 */     // MIs[0] policy
     /* 1093074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093106 */     // GIR_Coverage, 60784,
     /* 1093106 */     GIR_EraseRootFromParent_Done,
     /* 1093107 */   // Label 16102: @1093107
     /* 1093107 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1093184), // Rule ID 60785 //
     /* 1093112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093151 */     // MIs[0] policy
     /* 1093151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093161 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093183 */     // GIR_Coverage, 60785,
     /* 1093183 */     GIR_EraseRootFromParent_Done,
     /* 1093184 */   // Label 16103: @1093184
     /* 1093184 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1093261), // Rule ID 60788 //
     /* 1093189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093228 */     // MIs[0] policy
     /* 1093228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1093241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093260 */     // GIR_Coverage, 60788,
     /* 1093260 */     GIR_EraseRootFromParent_Done,
     /* 1093261 */   // Label 16104: @1093261
     /* 1093261 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1093338), // Rule ID 60789 //
     /* 1093266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093305 */     // MIs[0] policy
     /* 1093305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1093318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093337 */     // GIR_Coverage, 60789,
     /* 1093337 */     GIR_EraseRootFromParent_Done,
     /* 1093338 */   // Label 16105: @1093338
     /* 1093338 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1093415), // Rule ID 60792 //
     /* 1093343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093382 */     // MIs[0] policy
     /* 1093382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093414 */     // GIR_Coverage, 60792,
     /* 1093414 */     GIR_EraseRootFromParent_Done,
     /* 1093415 */   // Label 16106: @1093415
     /* 1093415 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1093492), // Rule ID 60793 //
     /* 1093420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093459 */     // MIs[0] policy
     /* 1093459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093469 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093491 */     // GIR_Coverage, 60793,
     /* 1093491 */     GIR_EraseRootFromParent_Done,
     /* 1093492 */   // Label 16107: @1093492
     /* 1093492 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1093569), // Rule ID 60796 //
     /* 1093497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093536 */     // MIs[0] policy
     /* 1093536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093568 */     // GIR_Coverage, 60796,
     /* 1093568 */     GIR_EraseRootFromParent_Done,
     /* 1093569 */   // Label 16108: @1093569
     /* 1093569 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1093646), // Rule ID 60797 //
     /* 1093574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093613 */     // MIs[0] policy
     /* 1093613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093623 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093645 */     // GIR_Coverage, 60797,
     /* 1093645 */     GIR_EraseRootFromParent_Done,
     /* 1093646 */   // Label 16109: @1093646
     /* 1093646 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1093723), // Rule ID 60800 //
     /* 1093651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093690 */     // MIs[0] policy
     /* 1093690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093722 */     // GIR_Coverage, 60800,
     /* 1093722 */     GIR_EraseRootFromParent_Done,
     /* 1093723 */   // Label 16110: @1093723
     /* 1093723 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1093800), // Rule ID 60801 //
     /* 1093728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093767 */     // MIs[0] policy
     /* 1093767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093777 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093799 */     // GIR_Coverage, 60801,
     /* 1093799 */     GIR_EraseRootFromParent_Done,
     /* 1093800 */   // Label 16111: @1093800
     /* 1093800 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1093877), // Rule ID 60804 //
     /* 1093805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093844 */     // MIs[0] policy
     /* 1093844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093876 */     // GIR_Coverage, 60804,
     /* 1093876 */     GIR_EraseRootFromParent_Done,
     /* 1093877 */   // Label 16112: @1093877
     /* 1093877 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1093954), // Rule ID 60805 //
     /* 1093882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093921 */     // MIs[0] policy
     /* 1093921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093931 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093953 */     // GIR_Coverage, 60805,
     /* 1093953 */     GIR_EraseRootFromParent_Done,
     /* 1093954 */   // Label 16113: @1093954
     /* 1093954 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1094031), // Rule ID 60808 //
     /* 1093959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093998 */     // MIs[0] policy
     /* 1093998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094008 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094030 */     // GIR_Coverage, 60808,
     /* 1094030 */     GIR_EraseRootFromParent_Done,
     /* 1094031 */   // Label 16114: @1094031
     /* 1094031 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1094108), // Rule ID 60809 //
     /* 1094036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1094047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1094050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1094053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094075 */     // MIs[0] policy
     /* 1094075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094085 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094107 */     // GIR_Coverage, 60809,
     /* 1094107 */     GIR_EraseRootFromParent_Done,
     /* 1094108 */   // Label 16115: @1094108
     /* 1094108 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1094185), // Rule ID 60812 //
     /* 1094113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094152 */     // MIs[0] policy
     /* 1094152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1094165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094184 */     // GIR_Coverage, 60812,
     /* 1094184 */     GIR_EraseRootFromParent_Done,
     /* 1094185 */   // Label 16116: @1094185
     /* 1094185 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1094262), // Rule ID 60813 //
     /* 1094190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094229 */     // MIs[0] policy
     /* 1094229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1094242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094261 */     // GIR_Coverage, 60813,
     /* 1094261 */     GIR_EraseRootFromParent_Done,
     /* 1094262 */   // Label 16117: @1094262
     /* 1094262 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1094339), // Rule ID 60816 //
     /* 1094267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094306 */     // MIs[0] policy
     /* 1094306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094338 */     // GIR_Coverage, 60816,
     /* 1094338 */     GIR_EraseRootFromParent_Done,
     /* 1094339 */   // Label 16118: @1094339
     /* 1094339 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1094416), // Rule ID 60817 //
     /* 1094344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094383 */     // MIs[0] policy
     /* 1094383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094393 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094415 */     // GIR_Coverage, 60817,
     /* 1094415 */     GIR_EraseRootFromParent_Done,
     /* 1094416 */   // Label 16119: @1094416
     /* 1094416 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1094493), // Rule ID 60820 //
     /* 1094421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094460 */     // MIs[0] policy
     /* 1094460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094492 */     // GIR_Coverage, 60820,
     /* 1094492 */     GIR_EraseRootFromParent_Done,
     /* 1094493 */   // Label 16120: @1094493
     /* 1094493 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1094570), // Rule ID 60821 //
     /* 1094498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094537 */     // MIs[0] policy
     /* 1094537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094547 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094569 */     // GIR_Coverage, 60821,
     /* 1094569 */     GIR_EraseRootFromParent_Done,
     /* 1094570 */   // Label 16121: @1094570
     /* 1094570 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1094647), // Rule ID 60824 //
     /* 1094575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094614 */     // MIs[0] policy
     /* 1094614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094646 */     // GIR_Coverage, 60824,
     /* 1094646 */     GIR_EraseRootFromParent_Done,
     /* 1094647 */   // Label 16122: @1094647
     /* 1094647 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1094724), // Rule ID 60825 //
     /* 1094652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094691 */     // MIs[0] policy
     /* 1094691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094701 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094723 */     // GIR_Coverage, 60825,
     /* 1094723 */     GIR_EraseRootFromParent_Done,
     /* 1094724 */   // Label 16123: @1094724
     /* 1094724 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1094801), // Rule ID 60828 //
     /* 1094729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094768 */     // MIs[0] policy
     /* 1094768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094800 */     // GIR_Coverage, 60828,
     /* 1094800 */     GIR_EraseRootFromParent_Done,
     /* 1094801 */   // Label 16124: @1094801
     /* 1094801 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1094878), // Rule ID 60829 //
     /* 1094806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094845 */     // MIs[0] policy
     /* 1094845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094855 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094877 */     // GIR_Coverage, 60829,
     /* 1094877 */     GIR_EraseRootFromParent_Done,
     /* 1094878 */   // Label 16125: @1094878
     /* 1094878 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1094955), // Rule ID 60832 //
     /* 1094883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094922 */     // MIs[0] policy
     /* 1094922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094954 */     // GIR_Coverage, 60832,
     /* 1094954 */     GIR_EraseRootFromParent_Done,
     /* 1094955 */   // Label 16126: @1094955
     /* 1094955 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1095032), // Rule ID 60833 //
     /* 1094960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094999 */     // MIs[0] policy
     /* 1094999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095031 */     // GIR_Coverage, 60833,
     /* 1095031 */     GIR_EraseRootFromParent_Done,
     /* 1095032 */   // Label 16127: @1095032
     /* 1095032 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1095109), // Rule ID 60836 //
     /* 1095037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095076 */     // MIs[0] policy
     /* 1095076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095108 */     // GIR_Coverage, 60836,
     /* 1095108 */     GIR_EraseRootFromParent_Done,
     /* 1095109 */   // Label 16128: @1095109
     /* 1095109 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1095186), // Rule ID 60837 //
     /* 1095114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095153 */     // MIs[0] policy
     /* 1095153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095163 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1095166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095185 */     // GIR_Coverage, 60837,
     /* 1095185 */     GIR_EraseRootFromParent_Done,
     /* 1095186 */   // Label 16129: @1095186
     /* 1095186 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1095263), // Rule ID 60840 //
     /* 1095191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095230 */     // MIs[0] policy
     /* 1095230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095262 */     // GIR_Coverage, 60840,
     /* 1095262 */     GIR_EraseRootFromParent_Done,
     /* 1095263 */   // Label 16130: @1095263
     /* 1095263 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1095340), // Rule ID 60841 //
     /* 1095268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095307 */     // MIs[0] policy
     /* 1095307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095317 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095339 */     // GIR_Coverage, 60841,
     /* 1095339 */     GIR_EraseRootFromParent_Done,
     /* 1095340 */   // Label 16131: @1095340
     /* 1095340 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1095417), // Rule ID 60844 //
     /* 1095345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095384 */     // MIs[0] policy
     /* 1095384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095416 */     // GIR_Coverage, 60844,
     /* 1095416 */     GIR_EraseRootFromParent_Done,
     /* 1095417 */   // Label 16132: @1095417
     /* 1095417 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1095494), // Rule ID 60845 //
     /* 1095422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095461 */     // MIs[0] policy
     /* 1095461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095493 */     // GIR_Coverage, 60845,
     /* 1095493 */     GIR_EraseRootFromParent_Done,
     /* 1095494 */   // Label 16133: @1095494
     /* 1095494 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1095571), // Rule ID 60848 //
     /* 1095499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095538 */     // MIs[0] policy
     /* 1095538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095570 */     // GIR_Coverage, 60848,
     /* 1095570 */     GIR_EraseRootFromParent_Done,
     /* 1095571 */   // Label 16134: @1095571
     /* 1095571 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1095648), // Rule ID 60849 //
     /* 1095576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095615 */     // MIs[0] policy
     /* 1095615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095625 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095647 */     // GIR_Coverage, 60849,
     /* 1095647 */     GIR_EraseRootFromParent_Done,
     /* 1095648 */   // Label 16135: @1095648
     /* 1095648 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1095725), // Rule ID 60852 //
     /* 1095653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095692 */     // MIs[0] policy
     /* 1095692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095724 */     // GIR_Coverage, 60852,
     /* 1095724 */     GIR_EraseRootFromParent_Done,
     /* 1095725 */   // Label 16136: @1095725
     /* 1095725 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1095802), // Rule ID 60853 //
     /* 1095730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095769 */     // MIs[0] policy
     /* 1095769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095779 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095801 */     // GIR_Coverage, 60853,
     /* 1095801 */     GIR_EraseRootFromParent_Done,
     /* 1095802 */   // Label 16137: @1095802
     /* 1095802 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1095879), // Rule ID 60856 //
     /* 1095807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095846 */     // MIs[0] policy
     /* 1095846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095856 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095878 */     // GIR_Coverage, 60856,
     /* 1095878 */     GIR_EraseRootFromParent_Done,
     /* 1095879 */   // Label 16138: @1095879
     /* 1095879 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1095956), // Rule ID 60857 //
     /* 1095884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095923 */     // MIs[0] policy
     /* 1095923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095955 */     // GIR_Coverage, 60857,
     /* 1095955 */     GIR_EraseRootFromParent_Done,
     /* 1095956 */   // Label 16139: @1095956
     /* 1095956 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1096033), // Rule ID 60860 //
     /* 1095961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096000 */     // MIs[0] policy
     /* 1096000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096010 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096032 */     // GIR_Coverage, 60860,
     /* 1096032 */     GIR_EraseRootFromParent_Done,
     /* 1096033 */   // Label 16140: @1096033
     /* 1096033 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1096110), // Rule ID 60861 //
     /* 1096038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1096049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1096052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1096055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1096058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096077 */     // MIs[0] policy
     /* 1096077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096087 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096109 */     // GIR_Coverage, 60861,
     /* 1096109 */     GIR_EraseRootFromParent_Done,
     /* 1096110 */   // Label 16141: @1096110
     /* 1096110 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1096187), // Rule ID 60864 //
     /* 1096115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096154 */     // MIs[0] policy
     /* 1096154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096186 */     // GIR_Coverage, 60864,
     /* 1096186 */     GIR_EraseRootFromParent_Done,
     /* 1096187 */   // Label 16142: @1096187
     /* 1096187 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1096264), // Rule ID 60865 //
     /* 1096192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096231 */     // MIs[0] policy
     /* 1096231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096263 */     // GIR_Coverage, 60865,
     /* 1096263 */     GIR_EraseRootFromParent_Done,
     /* 1096264 */   // Label 16143: @1096264
     /* 1096264 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1096341), // Rule ID 60868 //
     /* 1096269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096308 */     // MIs[0] policy
     /* 1096308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096340 */     // GIR_Coverage, 60868,
     /* 1096340 */     GIR_EraseRootFromParent_Done,
     /* 1096341 */   // Label 16144: @1096341
     /* 1096341 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1096418), // Rule ID 60869 //
     /* 1096346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096385 */     // MIs[0] policy
     /* 1096385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096417 */     // GIR_Coverage, 60869,
     /* 1096417 */     GIR_EraseRootFromParent_Done,
     /* 1096418 */   // Label 16145: @1096418
     /* 1096418 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1096495), // Rule ID 60872 //
     /* 1096423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096462 */     // MIs[0] policy
     /* 1096462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096494 */     // GIR_Coverage, 60872,
     /* 1096494 */     GIR_EraseRootFromParent_Done,
     /* 1096495 */   // Label 16146: @1096495
     /* 1096495 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1096572), // Rule ID 60873 //
     /* 1096500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096539 */     // MIs[0] policy
     /* 1096539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096549 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096571 */     // GIR_Coverage, 60873,
     /* 1096571 */     GIR_EraseRootFromParent_Done,
     /* 1096572 */   // Label 16147: @1096572
     /* 1096572 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1096649), // Rule ID 60876 //
     /* 1096577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096616 */     // MIs[0] policy
     /* 1096616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096626 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096648 */     // GIR_Coverage, 60876,
     /* 1096648 */     GIR_EraseRootFromParent_Done,
     /* 1096649 */   // Label 16148: @1096649
     /* 1096649 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1096726), // Rule ID 60877 //
     /* 1096654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096693 */     // MIs[0] policy
     /* 1096693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096725 */     // GIR_Coverage, 60877,
     /* 1096725 */     GIR_EraseRootFromParent_Done,
     /* 1096726 */   // Label 16149: @1096726
     /* 1096726 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1096803), // Rule ID 60880 //
     /* 1096731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096770 */     // MIs[0] policy
     /* 1096770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096802 */     // GIR_Coverage, 60880,
     /* 1096802 */     GIR_EraseRootFromParent_Done,
     /* 1096803 */   // Label 16150: @1096803
     /* 1096803 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1096880), // Rule ID 60881 //
     /* 1096808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096847 */     // MIs[0] policy
     /* 1096847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096857 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096879 */     // GIR_Coverage, 60881,
     /* 1096879 */     GIR_EraseRootFromParent_Done,
     /* 1096880 */   // Label 16151: @1096880
     /* 1096880 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1096957), // Rule ID 60884 //
     /* 1096885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096924 */     // MIs[0] policy
     /* 1096924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096956 */     // GIR_Coverage, 60884,
     /* 1096956 */     GIR_EraseRootFromParent_Done,
     /* 1096957 */   // Label 16152: @1096957
     /* 1096957 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1097034), // Rule ID 60885 //
     /* 1096962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097001 */     // MIs[0] policy
     /* 1097001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097011 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1097014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097033 */     // GIR_Coverage, 60885,
     /* 1097033 */     GIR_EraseRootFromParent_Done,
     /* 1097034 */   // Label 16153: @1097034
     /* 1097034 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1097111), // Rule ID 60888 //
     /* 1097039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097078 */     // MIs[0] policy
     /* 1097078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1097091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097110 */     // GIR_Coverage, 60888,
     /* 1097110 */     GIR_EraseRootFromParent_Done,
     /* 1097111 */   // Label 16154: @1097111
     /* 1097111 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1097188), // Rule ID 60889 //
     /* 1097116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097155 */     // MIs[0] policy
     /* 1097155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097165 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1097168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097187 */     // GIR_Coverage, 60889,
     /* 1097187 */     GIR_EraseRootFromParent_Done,
     /* 1097188 */   // Label 16155: @1097188
     /* 1097188 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1097265), // Rule ID 60892 //
     /* 1097193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097232 */     // MIs[0] policy
     /* 1097232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097264 */     // GIR_Coverage, 60892,
     /* 1097264 */     GIR_EraseRootFromParent_Done,
     /* 1097265 */   // Label 16156: @1097265
     /* 1097265 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1097342), // Rule ID 60893 //
     /* 1097270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097309 */     // MIs[0] policy
     /* 1097309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097319 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097341 */     // GIR_Coverage, 60893,
     /* 1097341 */     GIR_EraseRootFromParent_Done,
     /* 1097342 */   // Label 16157: @1097342
     /* 1097342 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1097419), // Rule ID 60896 //
     /* 1097347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097386 */     // MIs[0] policy
     /* 1097386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097418 */     // GIR_Coverage, 60896,
     /* 1097418 */     GIR_EraseRootFromParent_Done,
     /* 1097419 */   // Label 16158: @1097419
     /* 1097419 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1097496), // Rule ID 60897 //
     /* 1097424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097463 */     // MIs[0] policy
     /* 1097463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097473 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097495 */     // GIR_Coverage, 60897,
     /* 1097495 */     GIR_EraseRootFromParent_Done,
     /* 1097496 */   // Label 16159: @1097496
     /* 1097496 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1097573), // Rule ID 60900 //
     /* 1097501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097540 */     // MIs[0] policy
     /* 1097540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097572 */     // GIR_Coverage, 60900,
     /* 1097572 */     GIR_EraseRootFromParent_Done,
     /* 1097573 */   // Label 16160: @1097573
     /* 1097573 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1097650), // Rule ID 60901 //
     /* 1097578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097617 */     // MIs[0] policy
     /* 1097617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097627 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097649 */     // GIR_Coverage, 60901,
     /* 1097649 */     GIR_EraseRootFromParent_Done,
     /* 1097650 */   // Label 16161: @1097650
     /* 1097650 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1097727), // Rule ID 60904 //
     /* 1097655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097694 */     // MIs[0] policy
     /* 1097694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097726 */     // GIR_Coverage, 60904,
     /* 1097726 */     GIR_EraseRootFromParent_Done,
     /* 1097727 */   // Label 16162: @1097727
     /* 1097727 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1097804), // Rule ID 60905 //
     /* 1097732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097771 */     // MIs[0] policy
     /* 1097771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097781 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097803 */     // GIR_Coverage, 60905,
     /* 1097803 */     GIR_EraseRootFromParent_Done,
     /* 1097804 */   // Label 16163: @1097804
     /* 1097804 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1097881), // Rule ID 60908 //
     /* 1097809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097848 */     // MIs[0] policy
     /* 1097848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097880 */     // GIR_Coverage, 60908,
     /* 1097880 */     GIR_EraseRootFromParent_Done,
     /* 1097881 */   // Label 16164: @1097881
     /* 1097881 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1097958), // Rule ID 60909 //
     /* 1097886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097925 */     // MIs[0] policy
     /* 1097925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097935 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097957 */     // GIR_Coverage, 60909,
     /* 1097957 */     GIR_EraseRootFromParent_Done,
     /* 1097958 */   // Label 16165: @1097958
     /* 1097958 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1098035), // Rule ID 60912 //
     /* 1097963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098002 */     // MIs[0] policy
     /* 1098002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098012 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098034 */     // GIR_Coverage, 60912,
     /* 1098034 */     GIR_EraseRootFromParent_Done,
     /* 1098035 */   // Label 16166: @1098035
     /* 1098035 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1098112), // Rule ID 60913 //
     /* 1098040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1098051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1098054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1098057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098079 */     // MIs[0] policy
     /* 1098079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098089 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098111 */     // GIR_Coverage, 60913,
     /* 1098111 */     GIR_EraseRootFromParent_Done,
     /* 1098112 */   // Label 16167: @1098112
     /* 1098112 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1098189), // Rule ID 60916 //
     /* 1098117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098156 */     // MIs[0] policy
     /* 1098156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098188 */     // GIR_Coverage, 60916,
     /* 1098188 */     GIR_EraseRootFromParent_Done,
     /* 1098189 */   // Label 16168: @1098189
     /* 1098189 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1098266), // Rule ID 60917 //
     /* 1098194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098233 */     // MIs[0] policy
     /* 1098233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098265 */     // GIR_Coverage, 60917,
     /* 1098265 */     GIR_EraseRootFromParent_Done,
     /* 1098266 */   // Label 16169: @1098266
     /* 1098266 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1098343), // Rule ID 60920 //
     /* 1098271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098310 */     // MIs[0] policy
     /* 1098310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098342 */     // GIR_Coverage, 60920,
     /* 1098342 */     GIR_EraseRootFromParent_Done,
     /* 1098343 */   // Label 16170: @1098343
     /* 1098343 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1098420), // Rule ID 60921 //
     /* 1098348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098387 */     // MIs[0] policy
     /* 1098387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098397 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098419 */     // GIR_Coverage, 60921,
     /* 1098419 */     GIR_EraseRootFromParent_Done,
     /* 1098420 */   // Label 16171: @1098420
     /* 1098420 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1098497), // Rule ID 60924 //
     /* 1098425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098464 */     // MIs[0] policy
     /* 1098464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098496 */     // GIR_Coverage, 60924,
     /* 1098496 */     GIR_EraseRootFromParent_Done,
     /* 1098497 */   // Label 16172: @1098497
     /* 1098497 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1098574), // Rule ID 60925 //
     /* 1098502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098541 */     // MIs[0] policy
     /* 1098541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098573 */     // GIR_Coverage, 60925,
     /* 1098573 */     GIR_EraseRootFromParent_Done,
     /* 1098574 */   // Label 16173: @1098574
     /* 1098574 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1098651), // Rule ID 60928 //
     /* 1098579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098618 */     // MIs[0] policy
     /* 1098618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098650 */     // GIR_Coverage, 60928,
     /* 1098650 */     GIR_EraseRootFromParent_Done,
     /* 1098651 */   // Label 16174: @1098651
     /* 1098651 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1098728), // Rule ID 60929 //
     /* 1098656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098695 */     // MIs[0] policy
     /* 1098695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098705 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098727 */     // GIR_Coverage, 60929,
     /* 1098727 */     GIR_EraseRootFromParent_Done,
     /* 1098728 */   // Label 16175: @1098728
     /* 1098728 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1098805), // Rule ID 60932 //
     /* 1098733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098772 */     // MIs[0] policy
     /* 1098772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098804 */     // GIR_Coverage, 60932,
     /* 1098804 */     GIR_EraseRootFromParent_Done,
     /* 1098805 */   // Label 16176: @1098805
     /* 1098805 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1098882), // Rule ID 60933 //
     /* 1098810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098849 */     // MIs[0] policy
     /* 1098849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098859 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098881 */     // GIR_Coverage, 60933,
     /* 1098881 */     GIR_EraseRootFromParent_Done,
     /* 1098882 */   // Label 16177: @1098882
     /* 1098882 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1098959), // Rule ID 60936 //
     /* 1098887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098926 */     // MIs[0] policy
     /* 1098926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098958 */     // GIR_Coverage, 60936,
     /* 1098958 */     GIR_EraseRootFromParent_Done,
     /* 1098959 */   // Label 16178: @1098959
     /* 1098959 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1099036), // Rule ID 60937 //
     /* 1098964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099003 */     // MIs[0] policy
     /* 1099003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099013 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099035 */     // GIR_Coverage, 60937,
     /* 1099035 */     GIR_EraseRootFromParent_Done,
     /* 1099036 */   // Label 16179: @1099036
     /* 1099036 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1099113), // Rule ID 60940 //
     /* 1099041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099080 */     // MIs[0] policy
     /* 1099080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099112 */     // GIR_Coverage, 60940,
     /* 1099112 */     GIR_EraseRootFromParent_Done,
     /* 1099113 */   // Label 16180: @1099113
     /* 1099113 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1099190), // Rule ID 60941 //
     /* 1099118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099157 */     // MIs[0] policy
     /* 1099157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099189 */     // GIR_Coverage, 60941,
     /* 1099189 */     GIR_EraseRootFromParent_Done,
     /* 1099190 */   // Label 16181: @1099190
     /* 1099190 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1099267), // Rule ID 60944 //
     /* 1099195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099234 */     // MIs[0] policy
     /* 1099234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099266 */     // GIR_Coverage, 60944,
     /* 1099266 */     GIR_EraseRootFromParent_Done,
     /* 1099267 */   // Label 16182: @1099267
     /* 1099267 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1099344), // Rule ID 60945 //
     /* 1099272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099311 */     // MIs[0] policy
     /* 1099311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099343 */     // GIR_Coverage, 60945,
     /* 1099343 */     GIR_EraseRootFromParent_Done,
     /* 1099344 */   // Label 16183: @1099344
     /* 1099344 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1099421), // Rule ID 60948 //
     /* 1099349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099388 */     // MIs[0] policy
     /* 1099388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099420 */     // GIR_Coverage, 60948,
     /* 1099420 */     GIR_EraseRootFromParent_Done,
     /* 1099421 */   // Label 16184: @1099421
     /* 1099421 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1099498), // Rule ID 60949 //
     /* 1099426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099465 */     // MIs[0] policy
     /* 1099465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099475 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099497 */     // GIR_Coverage, 60949,
     /* 1099497 */     GIR_EraseRootFromParent_Done,
     /* 1099498 */   // Label 16185: @1099498
     /* 1099498 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1099575), // Rule ID 60952 //
     /* 1099503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099542 */     // MIs[0] policy
     /* 1099542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099574 */     // GIR_Coverage, 60952,
     /* 1099574 */     GIR_EraseRootFromParent_Done,
     /* 1099575 */   // Label 16186: @1099575
     /* 1099575 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1099652), // Rule ID 60953 //
     /* 1099580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099619 */     // MIs[0] policy
     /* 1099619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099651 */     // GIR_Coverage, 60953,
     /* 1099651 */     GIR_EraseRootFromParent_Done,
     /* 1099652 */   // Label 16187: @1099652
     /* 1099652 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1099729), // Rule ID 60956 //
     /* 1099657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099696 */     // MIs[0] policy
     /* 1099696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099728 */     // GIR_Coverage, 60956,
     /* 1099728 */     GIR_EraseRootFromParent_Done,
     /* 1099729 */   // Label 16188: @1099729
     /* 1099729 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1099806), // Rule ID 60957 //
     /* 1099734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099773 */     // MIs[0] policy
     /* 1099773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099783 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099805 */     // GIR_Coverage, 60957,
     /* 1099805 */     GIR_EraseRootFromParent_Done,
     /* 1099806 */   // Label 16189: @1099806
     /* 1099806 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1099883), // Rule ID 60960 //
     /* 1099811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099850 */     // MIs[0] policy
     /* 1099850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099882 */     // GIR_Coverage, 60960,
     /* 1099882 */     GIR_EraseRootFromParent_Done,
     /* 1099883 */   // Label 16190: @1099883
     /* 1099883 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1099960), // Rule ID 60961 //
     /* 1099888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099927 */     // MIs[0] policy
     /* 1099927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099937 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099959 */     // GIR_Coverage, 60961,
     /* 1099959 */     GIR_EraseRootFromParent_Done,
     /* 1099960 */   // Label 16191: @1099960
     /* 1099960 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1100037), // Rule ID 60964 //
     /* 1099965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100004 */     // MIs[0] policy
     /* 1100004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1100017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100036 */     // GIR_Coverage, 60964,
     /* 1100036 */     GIR_EraseRootFromParent_Done,
     /* 1100037 */   // Label 16192: @1100037
     /* 1100037 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1100114), // Rule ID 60965 //
     /* 1100042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1100053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1100056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1100059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1100069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100081 */     // MIs[0] policy
     /* 1100081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100091 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1100094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100113 */     // GIR_Coverage, 60965,
     /* 1100113 */     GIR_EraseRootFromParent_Done,
     /* 1100114 */   // Label 16193: @1100114
     /* 1100114 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1100191), // Rule ID 60968 //
     /* 1100119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100158 */     // MIs[0] policy
     /* 1100158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1100171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100190 */     // GIR_Coverage, 60968,
     /* 1100190 */     GIR_EraseRootFromParent_Done,
     /* 1100191 */   // Label 16194: @1100191
     /* 1100191 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1100268), // Rule ID 60969 //
     /* 1100196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100235 */     // MIs[0] policy
     /* 1100235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100245 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1100248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100267 */     // GIR_Coverage, 60969,
     /* 1100267 */     GIR_EraseRootFromParent_Done,
     /* 1100268 */   // Label 16195: @1100268
     /* 1100268 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1100345), // Rule ID 60972 //
     /* 1100273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100312 */     // MIs[0] policy
     /* 1100312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100322 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1100325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100344 */     // GIR_Coverage, 60972,
     /* 1100344 */     GIR_EraseRootFromParent_Done,
     /* 1100345 */   // Label 16196: @1100345
     /* 1100345 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1100422), // Rule ID 60973 //
     /* 1100350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100389 */     // MIs[0] policy
     /* 1100389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100399 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1100402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100421 */     // GIR_Coverage, 60973,
     /* 1100421 */     GIR_EraseRootFromParent_Done,
     /* 1100422 */   // Label 16197: @1100422
     /* 1100422 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1100499), // Rule ID 61396 //
     /* 1100427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100466 */     // MIs[0] policy
     /* 1100466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100498 */     // GIR_Coverage, 61396,
     /* 1100498 */     GIR_EraseRootFromParent_Done,
     /* 1100499 */   // Label 16198: @1100499
     /* 1100499 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1100576), // Rule ID 61397 //
     /* 1100504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100543 */     // MIs[0] policy
     /* 1100543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100553 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100575 */     // GIR_Coverage, 61397,
     /* 1100575 */     GIR_EraseRootFromParent_Done,
     /* 1100576 */   // Label 16199: @1100576
     /* 1100576 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1100653), // Rule ID 61400 //
     /* 1100581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100620 */     // MIs[0] policy
     /* 1100620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100652 */     // GIR_Coverage, 61400,
     /* 1100652 */     GIR_EraseRootFromParent_Done,
     /* 1100653 */   // Label 16200: @1100653
     /* 1100653 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1100730), // Rule ID 61401 //
     /* 1100658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100697 */     // MIs[0] policy
     /* 1100697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100729 */     // GIR_Coverage, 61401,
     /* 1100729 */     GIR_EraseRootFromParent_Done,
     /* 1100730 */   // Label 16201: @1100730
     /* 1100730 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1100807), // Rule ID 61404 //
     /* 1100735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100774 */     // MIs[0] policy
     /* 1100774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100806 */     // GIR_Coverage, 61404,
     /* 1100806 */     GIR_EraseRootFromParent_Done,
     /* 1100807 */   // Label 16202: @1100807
     /* 1100807 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1100884), // Rule ID 61405 //
     /* 1100812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100851 */     // MIs[0] policy
     /* 1100851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100861 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100883 */     // GIR_Coverage, 61405,
     /* 1100883 */     GIR_EraseRootFromParent_Done,
     /* 1100884 */   // Label 16203: @1100884
     /* 1100884 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1100961), // Rule ID 61408 //
     /* 1100889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100928 */     // MIs[0] policy
     /* 1100928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100960 */     // GIR_Coverage, 61408,
     /* 1100960 */     GIR_EraseRootFromParent_Done,
     /* 1100961 */   // Label 16204: @1100961
     /* 1100961 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1101038), // Rule ID 61409 //
     /* 1100966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101005 */     // MIs[0] policy
     /* 1101005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1101018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101037 */     // GIR_Coverage, 61409,
     /* 1101037 */     GIR_EraseRootFromParent_Done,
     /* 1101038 */   // Label 16205: @1101038
     /* 1101038 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1101115), // Rule ID 61412 //
     /* 1101043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101082 */     // MIs[0] policy
     /* 1101082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101114 */     // GIR_Coverage, 61412,
     /* 1101114 */     GIR_EraseRootFromParent_Done,
     /* 1101115 */   // Label 16206: @1101115
     /* 1101115 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1101192), // Rule ID 61413 //
     /* 1101120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101159 */     // MIs[0] policy
     /* 1101159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101169 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101191 */     // GIR_Coverage, 61413,
     /* 1101191 */     GIR_EraseRootFromParent_Done,
     /* 1101192 */   // Label 16207: @1101192
     /* 1101192 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1101269), // Rule ID 61416 //
     /* 1101197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101236 */     // MIs[0] policy
     /* 1101236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101268 */     // GIR_Coverage, 61416,
     /* 1101268 */     GIR_EraseRootFromParent_Done,
     /* 1101269 */   // Label 16208: @1101269
     /* 1101269 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1101346), // Rule ID 61417 //
     /* 1101274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101313 */     // MIs[0] policy
     /* 1101313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1101326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101345 */     // GIR_Coverage, 61417,
     /* 1101345 */     GIR_EraseRootFromParent_Done,
     /* 1101346 */   // Label 16209: @1101346
     /* 1101346 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1101423), // Rule ID 61420 //
     /* 1101351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101390 */     // MIs[0] policy
     /* 1101390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101422 */     // GIR_Coverage, 61420,
     /* 1101422 */     GIR_EraseRootFromParent_Done,
     /* 1101423 */   // Label 16210: @1101423
     /* 1101423 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1101500), // Rule ID 61421 //
     /* 1101428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101467 */     // MIs[0] policy
     /* 1101467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11223:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101499 */     // GIR_Coverage, 61421,
     /* 1101499 */     GIR_EraseRootFromParent_Done,
     /* 1101500 */   // Label 16211: @1101500
     /* 1101500 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1101577), // Rule ID 61424 //
     /* 1101505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101544 */     // MIs[0] policy
     /* 1101544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101576 */     // GIR_Coverage, 61424,
     /* 1101576 */     GIR_EraseRootFromParent_Done,
     /* 1101577 */   // Label 16212: @1101577
     /* 1101577 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1101654), // Rule ID 61425 //
     /* 1101582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101621 */     // MIs[0] policy
     /* 1101621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101631 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101653 */     // GIR_Coverage, 61425,
     /* 1101653 */     GIR_EraseRootFromParent_Done,
     /* 1101654 */   // Label 16213: @1101654
     /* 1101654 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1101731), // Rule ID 61428 //
     /* 1101659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101698 */     // MIs[0] policy
     /* 1101698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101730 */     // GIR_Coverage, 61428,
     /* 1101730 */     GIR_EraseRootFromParent_Done,
     /* 1101731 */   // Label 16214: @1101731
     /* 1101731 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1101808), // Rule ID 61429 //
     /* 1101736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101775 */     // MIs[0] policy
     /* 1101775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101785 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101807 */     // GIR_Coverage, 61429,
     /* 1101807 */     GIR_EraseRootFromParent_Done,
     /* 1101808 */   // Label 16215: @1101808
     /* 1101808 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1101885), // Rule ID 61432 //
     /* 1101813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101852 */     // MIs[0] policy
     /* 1101852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101884 */     // GIR_Coverage, 61432,
     /* 1101884 */     GIR_EraseRootFromParent_Done,
     /* 1101885 */   // Label 16216: @1101885
     /* 1101885 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1101962), // Rule ID 61433 //
     /* 1101890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101929 */     // MIs[0] policy
     /* 1101929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101939 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101961 */     // GIR_Coverage, 61433,
     /* 1101961 */     GIR_EraseRootFromParent_Done,
     /* 1101962 */   // Label 16217: @1101962
     /* 1101962 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1102039), // Rule ID 61436 //
     /* 1101967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102006 */     // MIs[0] policy
     /* 1102006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102038 */     // GIR_Coverage, 61436,
     /* 1102038 */     GIR_EraseRootFromParent_Done,
     /* 1102039 */   // Label 16218: @1102039
     /* 1102039 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1102116), // Rule ID 61437 //
     /* 1102044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1102055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1102058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1102061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102083 */     // MIs[0] policy
     /* 1102083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102115 */     // GIR_Coverage, 61437,
     /* 1102115 */     GIR_EraseRootFromParent_Done,
     /* 1102116 */   // Label 16219: @1102116
     /* 1102116 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1102193), // Rule ID 61440 //
     /* 1102121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102160 */     // MIs[0] policy
     /* 1102160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102192 */     // GIR_Coverage, 61440,
     /* 1102192 */     GIR_EraseRootFromParent_Done,
     /* 1102193 */   // Label 16220: @1102193
     /* 1102193 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1102270), // Rule ID 61441 //
     /* 1102198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102237 */     // MIs[0] policy
     /* 1102237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102247 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102269 */     // GIR_Coverage, 61441,
     /* 1102269 */     GIR_EraseRootFromParent_Done,
     /* 1102270 */   // Label 16221: @1102270
     /* 1102270 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1102347), // Rule ID 61444 //
     /* 1102275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102314 */     // MIs[0] policy
     /* 1102314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102324 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102346 */     // GIR_Coverage, 61444,
     /* 1102346 */     GIR_EraseRootFromParent_Done,
     /* 1102347 */   // Label 16222: @1102347
     /* 1102347 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1102424), // Rule ID 61445 //
     /* 1102352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102391 */     // MIs[0] policy
     /* 1102391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102423 */     // GIR_Coverage, 61445,
     /* 1102423 */     GIR_EraseRootFromParent_Done,
     /* 1102424 */   // Label 16223: @1102424
     /* 1102424 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1102501), // Rule ID 61448 //
     /* 1102429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102468 */     // MIs[0] policy
     /* 1102468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102500 */     // GIR_Coverage, 61448,
     /* 1102500 */     GIR_EraseRootFromParent_Done,
     /* 1102501 */   // Label 16224: @1102501
     /* 1102501 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1102578), // Rule ID 61449 //
     /* 1102506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102545 */     // MIs[0] policy
     /* 1102545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102555 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102577 */     // GIR_Coverage, 61449,
     /* 1102577 */     GIR_EraseRootFromParent_Done,
     /* 1102578 */   // Label 16225: @1102578
     /* 1102578 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1102655), // Rule ID 61452 //
     /* 1102583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102622 */     // MIs[0] policy
     /* 1102622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102654 */     // GIR_Coverage, 61452,
     /* 1102654 */     GIR_EraseRootFromParent_Done,
     /* 1102655 */   // Label 16226: @1102655
     /* 1102655 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1102732), // Rule ID 61453 //
     /* 1102660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102699 */     // MIs[0] policy
     /* 1102699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102709 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102731 */     // GIR_Coverage, 61453,
     /* 1102731 */     GIR_EraseRootFromParent_Done,
     /* 1102732 */   // Label 16227: @1102732
     /* 1102732 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1102809), // Rule ID 61456 //
     /* 1102737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102776 */     // MIs[0] policy
     /* 1102776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102808 */     // GIR_Coverage, 61456,
     /* 1102808 */     GIR_EraseRootFromParent_Done,
     /* 1102809 */   // Label 16228: @1102809
     /* 1102809 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1102886), // Rule ID 61457 //
     /* 1102814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102853 */     // MIs[0] policy
     /* 1102853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102863 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102885 */     // GIR_Coverage, 61457,
     /* 1102885 */     GIR_EraseRootFromParent_Done,
     /* 1102886 */   // Label 16229: @1102886
     /* 1102886 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1102963), // Rule ID 61460 //
     /* 1102891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102930 */     // MIs[0] policy
     /* 1102930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102962 */     // GIR_Coverage, 61460,
     /* 1102962 */     GIR_EraseRootFromParent_Done,
     /* 1102963 */   // Label 16230: @1102963
     /* 1102963 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1103040), // Rule ID 61461 //
     /* 1102968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103007 */     // MIs[0] policy
     /* 1103007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103039 */     // GIR_Coverage, 61461,
     /* 1103039 */     GIR_EraseRootFromParent_Done,
     /* 1103040 */   // Label 16231: @1103040
     /* 1103040 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1103117), // Rule ID 61464 //
     /* 1103045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103084 */     // MIs[0] policy
     /* 1103084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103116 */     // GIR_Coverage, 61464,
     /* 1103116 */     GIR_EraseRootFromParent_Done,
     /* 1103117 */   // Label 16232: @1103117
     /* 1103117 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1103194), // Rule ID 61465 //
     /* 1103122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103161 */     // MIs[0] policy
     /* 1103161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103171 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103193 */     // GIR_Coverage, 61465,
     /* 1103193 */     GIR_EraseRootFromParent_Done,
     /* 1103194 */   // Label 16233: @1103194
     /* 1103194 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1103271), // Rule ID 61468 //
     /* 1103199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103238 */     // MIs[0] policy
     /* 1103238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103270 */     // GIR_Coverage, 61468,
     /* 1103270 */     GIR_EraseRootFromParent_Done,
     /* 1103271 */   // Label 16234: @1103271
     /* 1103271 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1103348), // Rule ID 61469 //
     /* 1103276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103315 */     // MIs[0] policy
     /* 1103315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103347 */     // GIR_Coverage, 61469,
     /* 1103347 */     GIR_EraseRootFromParent_Done,
     /* 1103348 */   // Label 16235: @1103348
     /* 1103348 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1103425), // Rule ID 61472 //
     /* 1103353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103392 */     // MIs[0] policy
     /* 1103392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103424 */     // GIR_Coverage, 61472,
     /* 1103424 */     GIR_EraseRootFromParent_Done,
     /* 1103425 */   // Label 16236: @1103425
     /* 1103425 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1103502), // Rule ID 61473 //
     /* 1103430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103469 */     // MIs[0] policy
     /* 1103469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103488 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103501 */     // GIR_Coverage, 61473,
     /* 1103501 */     GIR_EraseRootFromParent_Done,
     /* 1103502 */   // Label 16237: @1103502
     /* 1103502 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1103579), // Rule ID 61476 //
     /* 1103507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103546 */     // MIs[0] policy
     /* 1103546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103578 */     // GIR_Coverage, 61476,
     /* 1103578 */     GIR_EraseRootFromParent_Done,
     /* 1103579 */   // Label 16238: @1103579
     /* 1103579 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1103656), // Rule ID 61477 //
     /* 1103584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103623 */     // MIs[0] policy
     /* 1103623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103633 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103655 */     // GIR_Coverage, 61477,
     /* 1103655 */     GIR_EraseRootFromParent_Done,
     /* 1103656 */   // Label 16239: @1103656
     /* 1103656 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1103733), // Rule ID 61480 //
     /* 1103661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103700 */     // MIs[0] policy
     /* 1103700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103732 */     // GIR_Coverage, 61480,
     /* 1103732 */     GIR_EraseRootFromParent_Done,
     /* 1103733 */   // Label 16240: @1103733
     /* 1103733 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1103810), // Rule ID 61481 //
     /* 1103738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103777 */     // MIs[0] policy
     /* 1103777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103787 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103809 */     // GIR_Coverage, 61481,
     /* 1103809 */     GIR_EraseRootFromParent_Done,
     /* 1103810 */   // Label 16241: @1103810
     /* 1103810 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1103887), // Rule ID 61484 //
     /* 1103815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103854 */     // MIs[0] policy
     /* 1103854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103886 */     // GIR_Coverage, 61484,
     /* 1103886 */     GIR_EraseRootFromParent_Done,
     /* 1103887 */   // Label 16242: @1103887
     /* 1103887 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1103964), // Rule ID 61485 //
     /* 1103892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103931 */     // MIs[0] policy
     /* 1103931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103941 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103963 */     // GIR_Coverage, 61485,
     /* 1103963 */     GIR_EraseRootFromParent_Done,
     /* 1103964 */   // Label 16243: @1103964
     /* 1103964 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1104041), // Rule ID 61488 //
     /* 1103969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104008 */     // MIs[0] policy
     /* 1104008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104040 */     // GIR_Coverage, 61488,
     /* 1104040 */     GIR_EraseRootFromParent_Done,
     /* 1104041 */   // Label 16244: @1104041
     /* 1104041 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1104118), // Rule ID 61489 //
     /* 1104046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1104057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1104060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1104063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104085 */     // MIs[0] policy
     /* 1104085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104095 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104117 */     // GIR_Coverage, 61489,
     /* 1104117 */     GIR_EraseRootFromParent_Done,
     /* 1104118 */   // Label 16245: @1104118
     /* 1104118 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1104195), // Rule ID 61492 //
     /* 1104123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104162 */     // MIs[0] policy
     /* 1104162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104172 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104194 */     // GIR_Coverage, 61492,
     /* 1104194 */     GIR_EraseRootFromParent_Done,
     /* 1104195 */   // Label 16246: @1104195
     /* 1104195 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1104272), // Rule ID 61493 //
     /* 1104200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104239 */     // MIs[0] policy
     /* 1104239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104249 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104271 */     // GIR_Coverage, 61493,
     /* 1104271 */     GIR_EraseRootFromParent_Done,
     /* 1104272 */   // Label 16247: @1104272
     /* 1104272 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1104349), // Rule ID 61496 //
     /* 1104277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104316 */     // MIs[0] policy
     /* 1104316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104348 */     // GIR_Coverage, 61496,
     /* 1104348 */     GIR_EraseRootFromParent_Done,
     /* 1104349 */   // Label 16248: @1104349
     /* 1104349 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1104426), // Rule ID 61497 //
     /* 1104354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104393 */     // MIs[0] policy
     /* 1104393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104403 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1104406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104425 */     // GIR_Coverage, 61497,
     /* 1104425 */     GIR_EraseRootFromParent_Done,
     /* 1104426 */   // Label 16249: @1104426
     /* 1104426 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1104503), // Rule ID 61500 //
     /* 1104431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104470 */     // MIs[0] policy
     /* 1104470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104480 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104502 */     // GIR_Coverage, 61500,
     /* 1104502 */     GIR_EraseRootFromParent_Done,
     /* 1104503 */   // Label 16250: @1104503
     /* 1104503 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1104580), // Rule ID 61501 //
     /* 1104508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104547 */     // MIs[0] policy
     /* 1104547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104557 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104579 */     // GIR_Coverage, 61501,
     /* 1104579 */     GIR_EraseRootFromParent_Done,
     /* 1104580 */   // Label 16251: @1104580
     /* 1104580 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1104657), // Rule ID 61504 //
     /* 1104585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104624 */     // MIs[0] policy
     /* 1104624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104656 */     // GIR_Coverage, 61504,
     /* 1104656 */     GIR_EraseRootFromParent_Done,
     /* 1104657 */   // Label 16252: @1104657
     /* 1104657 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1104734), // Rule ID 61505 //
     /* 1104662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104701 */     // MIs[0] policy
     /* 1104701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104711 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104720 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104733 */     // GIR_Coverage, 61505,
     /* 1104733 */     GIR_EraseRootFromParent_Done,
     /* 1104734 */   // Label 16253: @1104734
     /* 1104734 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1104811), // Rule ID 61508 //
     /* 1104739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104778 */     // MIs[0] policy
     /* 1104778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104810 */     // GIR_Coverage, 61508,
     /* 1104810 */     GIR_EraseRootFromParent_Done,
     /* 1104811 */   // Label 16254: @1104811
     /* 1104811 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1104888), // Rule ID 61509 //
     /* 1104816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104855 */     // MIs[0] policy
     /* 1104855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11574:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104887 */     // GIR_Coverage, 61509,
     /* 1104887 */     GIR_EraseRootFromParent_Done,
     /* 1104888 */   // Label 16255: @1104888
     /* 1104888 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1104965), // Rule ID 61512 //
     /* 1104893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104932 */     // MIs[0] policy
     /* 1104932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104964 */     // GIR_Coverage, 61512,
     /* 1104964 */     GIR_EraseRootFromParent_Done,
     /* 1104965 */   // Label 16256: @1104965
     /* 1104965 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1105042), // Rule ID 61513 //
     /* 1104970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105009 */     // MIs[0] policy
     /* 1105009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105019 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105041 */     // GIR_Coverage, 61513,
     /* 1105041 */     GIR_EraseRootFromParent_Done,
     /* 1105042 */   // Label 16257: @1105042
     /* 1105042 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1105119), // Rule ID 61516 //
     /* 1105047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105086 */     // MIs[0] policy
     /* 1105086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105118 */     // GIR_Coverage, 61516,
     /* 1105118 */     GIR_EraseRootFromParent_Done,
     /* 1105119 */   // Label 16258: @1105119
     /* 1105119 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1105196), // Rule ID 61517 //
     /* 1105124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105163 */     // MIs[0] policy
     /* 1105163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105195 */     // GIR_Coverage, 61517,
     /* 1105195 */     GIR_EraseRootFromParent_Done,
     /* 1105196 */   // Label 16259: @1105196
     /* 1105196 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1105273), // Rule ID 61520 //
     /* 1105201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105240 */     // MIs[0] policy
     /* 1105240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105272 */     // GIR_Coverage, 61520,
     /* 1105272 */     GIR_EraseRootFromParent_Done,
     /* 1105273 */   // Label 16260: @1105273
     /* 1105273 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1105350), // Rule ID 61521 //
     /* 1105278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105317 */     // MIs[0] policy
     /* 1105317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1105330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105349 */     // GIR_Coverage, 61521,
     /* 1105349 */     GIR_EraseRootFromParent_Done,
     /* 1105350 */   // Label 16261: @1105350
     /* 1105350 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1105427), // Rule ID 61524 //
     /* 1105355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105394 */     // MIs[0] policy
     /* 1105394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105426 */     // GIR_Coverage, 61524,
     /* 1105426 */     GIR_EraseRootFromParent_Done,
     /* 1105427 */   // Label 16262: @1105427
     /* 1105427 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1105504), // Rule ID 61525 //
     /* 1105432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105471 */     // MIs[0] policy
     /* 1105471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105503 */     // GIR_Coverage, 61525,
     /* 1105503 */     GIR_EraseRootFromParent_Done,
     /* 1105504 */   // Label 16263: @1105504
     /* 1105504 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1105581), // Rule ID 61528 //
     /* 1105509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105548 */     // MIs[0] policy
     /* 1105548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105580 */     // GIR_Coverage, 61528,
     /* 1105580 */     GIR_EraseRootFromParent_Done,
     /* 1105581 */   // Label 16264: @1105581
     /* 1105581 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1105658), // Rule ID 61529 //
     /* 1105586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105625 */     // MIs[0] policy
     /* 1105625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105635 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105657 */     // GIR_Coverage, 61529,
     /* 1105657 */     GIR_EraseRootFromParent_Done,
     /* 1105658 */   // Label 16265: @1105658
     /* 1105658 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1105735), // Rule ID 61532 //
     /* 1105663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105702 */     // MIs[0] policy
     /* 1105702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105712 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105734 */     // GIR_Coverage, 61532,
     /* 1105734 */     GIR_EraseRootFromParent_Done,
     /* 1105735 */   // Label 16266: @1105735
     /* 1105735 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1105812), // Rule ID 61533 //
     /* 1105740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105779 */     // MIs[0] policy
     /* 1105779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105811 */     // GIR_Coverage, 61533,
     /* 1105811 */     GIR_EraseRootFromParent_Done,
     /* 1105812 */   // Label 16267: @1105812
     /* 1105812 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1105889), // Rule ID 61536 //
     /* 1105817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105856 */     // MIs[0] policy
     /* 1105856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105888 */     // GIR_Coverage, 61536,
     /* 1105888 */     GIR_EraseRootFromParent_Done,
     /* 1105889 */   // Label 16268: @1105889
     /* 1105889 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1105966), // Rule ID 61537 //
     /* 1105894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105933 */     // MIs[0] policy
     /* 1105933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105965 */     // GIR_Coverage, 61537,
     /* 1105965 */     GIR_EraseRootFromParent_Done,
     /* 1105966 */   // Label 16269: @1105966
     /* 1105966 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1106043), // Rule ID 61540 //
     /* 1105971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106010 */     // MIs[0] policy
     /* 1106010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106042 */     // GIR_Coverage, 61540,
     /* 1106042 */     GIR_EraseRootFromParent_Done,
     /* 1106043 */   // Label 16270: @1106043
     /* 1106043 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1106120), // Rule ID 61541 //
     /* 1106048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1106059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1106062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106087 */     // MIs[0] policy
     /* 1106087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106097 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106119 */     // GIR_Coverage, 61541,
     /* 1106119 */     GIR_EraseRootFromParent_Done,
     /* 1106120 */   // Label 16271: @1106120
     /* 1106120 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1106197), // Rule ID 61544 //
     /* 1106125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106164 */     // MIs[0] policy
     /* 1106164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106196 */     // GIR_Coverage, 61544,
     /* 1106196 */     GIR_EraseRootFromParent_Done,
     /* 1106197 */   // Label 16272: @1106197
     /* 1106197 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1106274), // Rule ID 61545 //
     /* 1106202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106241 */     // MIs[0] policy
     /* 1106241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106251 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106273 */     // GIR_Coverage, 61545,
     /* 1106273 */     GIR_EraseRootFromParent_Done,
     /* 1106274 */   // Label 16273: @1106274
     /* 1106274 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1106351), // Rule ID 61548 //
     /* 1106279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106318 */     // MIs[0] policy
     /* 1106318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106350 */     // GIR_Coverage, 61548,
     /* 1106350 */     GIR_EraseRootFromParent_Done,
     /* 1106351 */   // Label 16274: @1106351
     /* 1106351 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1106428), // Rule ID 61549 //
     /* 1106356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106395 */     // MIs[0] policy
     /* 1106395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106427 */     // GIR_Coverage, 61549,
     /* 1106427 */     GIR_EraseRootFromParent_Done,
     /* 1106428 */   // Label 16275: @1106428
     /* 1106428 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1106505), // Rule ID 61552 //
     /* 1106433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106472 */     // MIs[0] policy
     /* 1106472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106504 */     // GIR_Coverage, 61552,
     /* 1106504 */     GIR_EraseRootFromParent_Done,
     /* 1106505 */   // Label 16276: @1106505
     /* 1106505 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1106582), // Rule ID 61553 //
     /* 1106510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106549 */     // MIs[0] policy
     /* 1106549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106581 */     // GIR_Coverage, 61553,
     /* 1106581 */     GIR_EraseRootFromParent_Done,
     /* 1106582 */   // Label 16277: @1106582
     /* 1106582 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1106659), // Rule ID 61556 //
     /* 1106587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106626 */     // MIs[0] policy
     /* 1106626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106658 */     // GIR_Coverage, 61556,
     /* 1106658 */     GIR_EraseRootFromParent_Done,
     /* 1106659 */   // Label 16278: @1106659
     /* 1106659 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1106736), // Rule ID 61557 //
     /* 1106664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106703 */     // MIs[0] policy
     /* 1106703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106713 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106735 */     // GIR_Coverage, 61557,
     /* 1106735 */     GIR_EraseRootFromParent_Done,
     /* 1106736 */   // Label 16279: @1106736
     /* 1106736 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1106813), // Rule ID 61560 //
     /* 1106741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106780 */     // MIs[0] policy
     /* 1106780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106812 */     // GIR_Coverage, 61560,
     /* 1106812 */     GIR_EraseRootFromParent_Done,
     /* 1106813 */   // Label 16280: @1106813
     /* 1106813 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1106890), // Rule ID 61561 //
     /* 1106818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106857 */     // MIs[0] policy
     /* 1106857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106889 */     // GIR_Coverage, 61561,
     /* 1106889 */     GIR_EraseRootFromParent_Done,
     /* 1106890 */   // Label 16281: @1106890
     /* 1106890 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1106967), // Rule ID 61564 //
     /* 1106895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106934 */     // MIs[0] policy
     /* 1106934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106966 */     // GIR_Coverage, 61564,
     /* 1106966 */     GIR_EraseRootFromParent_Done,
     /* 1106967 */   // Label 16282: @1106967
     /* 1106967 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1107044), // Rule ID 61565 //
     /* 1106972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107011 */     // MIs[0] policy
     /* 1107011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1107024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107043 */     // GIR_Coverage, 61565,
     /* 1107043 */     GIR_EraseRootFromParent_Done,
     /* 1107044 */   // Label 16283: @1107044
     /* 1107044 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1107121), // Rule ID 61568 //
     /* 1107049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107088 */     // MIs[0] policy
     /* 1107088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1107101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107120 */     // GIR_Coverage, 61568,
     /* 1107120 */     GIR_EraseRootFromParent_Done,
     /* 1107121 */   // Label 16284: @1107121
     /* 1107121 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1107198), // Rule ID 61569 //
     /* 1107126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107165 */     // MIs[0] policy
     /* 1107165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107175 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1107178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107197 */     // GIR_Coverage, 61569,
     /* 1107197 */     GIR_EraseRootFromParent_Done,
     /* 1107198 */   // Label 16285: @1107198
     /* 1107198 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1107275), // Rule ID 62094 //
     /* 1107203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107242 */     // MIs[0] policy
     /* 1107242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1107255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107274 */     // GIR_Coverage, 62094,
     /* 1107274 */     GIR_EraseRootFromParent_Done,
     /* 1107275 */   // Label 16286: @1107275
     /* 1107275 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1107352), // Rule ID 62095 //
     /* 1107280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107319 */     // MIs[0] policy
     /* 1107319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107329 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1107332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107351 */     // GIR_Coverage, 62095,
     /* 1107351 */     GIR_EraseRootFromParent_Done,
     /* 1107352 */   // Label 16287: @1107352
     /* 1107352 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1107429), // Rule ID 62096 //
     /* 1107357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107396 */     // MIs[0] policy
     /* 1107396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107428 */     // GIR_Coverage, 62096,
     /* 1107428 */     GIR_EraseRootFromParent_Done,
     /* 1107429 */   // Label 16288: @1107429
     /* 1107429 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1107506), // Rule ID 62097 //
     /* 1107434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107473 */     // MIs[0] policy
     /* 1107473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107505 */     // GIR_Coverage, 62097,
     /* 1107505 */     GIR_EraseRootFromParent_Done,
     /* 1107506 */   // Label 16289: @1107506
     /* 1107506 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1107583), // Rule ID 62098 //
     /* 1107511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107550 */     // MIs[0] policy
     /* 1107550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107560 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107582 */     // GIR_Coverage, 62098,
     /* 1107582 */     GIR_EraseRootFromParent_Done,
     /* 1107583 */   // Label 16290: @1107583
     /* 1107583 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1107660), // Rule ID 62099 //
     /* 1107588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107627 */     // MIs[0] policy
     /* 1107627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107637 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107659 */     // GIR_Coverage, 62099,
     /* 1107659 */     GIR_EraseRootFromParent_Done,
     /* 1107660 */   // Label 16291: @1107660
     /* 1107660 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1107737), // Rule ID 62100 //
     /* 1107665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107704 */     // MIs[0] policy
     /* 1107704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107736 */     // GIR_Coverage, 62100,
     /* 1107736 */     GIR_EraseRootFromParent_Done,
     /* 1107737 */   // Label 16292: @1107737
     /* 1107737 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1107814), // Rule ID 62101 //
     /* 1107742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107781 */     // MIs[0] policy
     /* 1107781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107791 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107813 */     // GIR_Coverage, 62101,
     /* 1107813 */     GIR_EraseRootFromParent_Done,
     /* 1107814 */   // Label 16293: @1107814
     /* 1107814 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1107891), // Rule ID 62304 //
     /* 1107819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107858 */     // MIs[0] policy
     /* 1107858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107868 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107890 */     // GIR_Coverage, 62304,
     /* 1107890 */     GIR_EraseRootFromParent_Done,
     /* 1107891 */   // Label 16294: @1107891
     /* 1107891 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1107968), // Rule ID 62305 //
     /* 1107896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107935 */     // MIs[0] policy
     /* 1107935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107945 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107967 */     // GIR_Coverage, 62305,
     /* 1107967 */     GIR_EraseRootFromParent_Done,
     /* 1107968 */   // Label 16295: @1107968
     /* 1107968 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1108045), // Rule ID 62306 //
     /* 1107973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108012 */     // MIs[0] policy
     /* 1108012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108044 */     // GIR_Coverage, 62306,
     /* 1108044 */     GIR_EraseRootFromParent_Done,
     /* 1108045 */   // Label 16296: @1108045
     /* 1108045 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1108122), // Rule ID 62307 //
     /* 1108050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108089 */     // MIs[0] policy
     /* 1108089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108121 */     // GIR_Coverage, 62307,
     /* 1108121 */     GIR_EraseRootFromParent_Done,
     /* 1108122 */   // Label 16297: @1108122
     /* 1108122 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1108199), // Rule ID 62308 //
     /* 1108127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108166 */     // MIs[0] policy
     /* 1108166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108198 */     // GIR_Coverage, 62308,
     /* 1108198 */     GIR_EraseRootFromParent_Done,
     /* 1108199 */   // Label 16298: @1108199
     /* 1108199 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1108276), // Rule ID 62309 //
     /* 1108204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108243 */     // MIs[0] policy
     /* 1108243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108275 */     // GIR_Coverage, 62309,
     /* 1108275 */     GIR_EraseRootFromParent_Done,
     /* 1108276 */   // Label 16299: @1108276
     /* 1108276 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1108353), // Rule ID 62310 //
     /* 1108281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108320 */     // MIs[0] policy
     /* 1108320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108352 */     // GIR_Coverage, 62310,
     /* 1108352 */     GIR_EraseRootFromParent_Done,
     /* 1108353 */   // Label 16300: @1108353
     /* 1108353 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1108430), // Rule ID 62311 //
     /* 1108358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108397 */     // MIs[0] policy
     /* 1108397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108407 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108429 */     // GIR_Coverage, 62311,
     /* 1108429 */     GIR_EraseRootFromParent_Done,
     /* 1108430 */   // Label 16301: @1108430
     /* 1108430 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1108507), // Rule ID 62312 //
     /* 1108435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108474 */     // MIs[0] policy
     /* 1108474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108484 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108506 */     // GIR_Coverage, 62312,
     /* 1108506 */     GIR_EraseRootFromParent_Done,
     /* 1108507 */   // Label 16302: @1108507
     /* 1108507 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1108584), // Rule ID 62313 //
     /* 1108512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108551 */     // MIs[0] policy
     /* 1108551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108561 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108583 */     // GIR_Coverage, 62313,
     /* 1108583 */     GIR_EraseRootFromParent_Done,
     /* 1108584 */   // Label 16303: @1108584
     /* 1108584 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1108661), // Rule ID 62314 //
     /* 1108589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108628 */     // MIs[0] policy
     /* 1108628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108660 */     // GIR_Coverage, 62314,
     /* 1108660 */     GIR_EraseRootFromParent_Done,
     /* 1108661 */   // Label 16304: @1108661
     /* 1108661 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1108738), // Rule ID 62315 //
     /* 1108666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108705 */     // MIs[0] policy
     /* 1108705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108715 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108737 */     // GIR_Coverage, 62315,
     /* 1108737 */     GIR_EraseRootFromParent_Done,
     /* 1108738 */   // Label 16305: @1108738
     /* 1108738 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1108815), // Rule ID 62316 //
     /* 1108743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108782 */     // MIs[0] policy
     /* 1108782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108814 */     // GIR_Coverage, 62316,
     /* 1108814 */     GIR_EraseRootFromParent_Done,
     /* 1108815 */   // Label 16306: @1108815
     /* 1108815 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1108892), // Rule ID 62317 //
     /* 1108820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108859 */     // MIs[0] policy
     /* 1108859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108869 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108891 */     // GIR_Coverage, 62317,
     /* 1108891 */     GIR_EraseRootFromParent_Done,
     /* 1108892 */   // Label 16307: @1108892
     /* 1108892 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1108969), // Rule ID 62318 //
     /* 1108897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108936 */     // MIs[0] policy
     /* 1108936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108968 */     // GIR_Coverage, 62318,
     /* 1108968 */     GIR_EraseRootFromParent_Done,
     /* 1108969 */   // Label 16308: @1108969
     /* 1108969 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1109046), // Rule ID 62319 //
     /* 1108974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109013 */     // MIs[0] policy
     /* 1109013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1109026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109045 */     // GIR_Coverage, 62319,
     /* 1109045 */     GIR_EraseRootFromParent_Done,
     /* 1109046 */   // Label 16309: @1109046
     /* 1109046 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1109123), // Rule ID 62320 //
     /* 1109051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109090 */     // MIs[0] policy
     /* 1109090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109122 */     // GIR_Coverage, 62320,
     /* 1109122 */     GIR_EraseRootFromParent_Done,
     /* 1109123 */   // Label 16310: @1109123
     /* 1109123 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1109200), // Rule ID 62321 //
     /* 1109128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109167 */     // MIs[0] policy
     /* 1109167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109199 */     // GIR_Coverage, 62321,
     /* 1109199 */     GIR_EraseRootFromParent_Done,
     /* 1109200 */   // Label 16311: @1109200
     /* 1109200 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1109277), // Rule ID 62322 //
     /* 1109205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109244 */     // MIs[0] policy
     /* 1109244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1109257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109276 */     // GIR_Coverage, 62322,
     /* 1109276 */     GIR_EraseRootFromParent_Done,
     /* 1109277 */   // Label 16312: @1109277
     /* 1109277 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1109354), // Rule ID 62323 //
     /* 1109282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1109290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109321 */     // MIs[0] policy
     /* 1109321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109331 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1109334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109353 */     // GIR_Coverage, 62323,
     /* 1109353 */     GIR_EraseRootFromParent_Done,
     /* 1109354 */   // Label 16313: @1109354
     /* 1109354 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1109431), // Rule ID 62324 //
     /* 1109359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109398 */     // MIs[0] policy
     /* 1109398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109430 */     // GIR_Coverage, 62324,
     /* 1109430 */     GIR_EraseRootFromParent_Done,
     /* 1109431 */   // Label 16314: @1109431
     /* 1109431 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1109508), // Rule ID 62325 //
     /* 1109436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109475 */     // MIs[0] policy
     /* 1109475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109485 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109507 */     // GIR_Coverage, 62325,
     /* 1109507 */     GIR_EraseRootFromParent_Done,
     /* 1109508 */   // Label 16315: @1109508
     /* 1109508 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1109585), // Rule ID 62326 //
     /* 1109513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109552 */     // MIs[0] policy
     /* 1109552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109562 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109584 */     // GIR_Coverage, 62326,
     /* 1109584 */     GIR_EraseRootFromParent_Done,
     /* 1109585 */   // Label 16316: @1109585
     /* 1109585 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1109662), // Rule ID 62327 //
     /* 1109590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109629 */     // MIs[0] policy
     /* 1109629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109661 */     // GIR_Coverage, 62327,
     /* 1109661 */     GIR_EraseRootFromParent_Done,
     /* 1109662 */   // Label 16317: @1109662
     /* 1109662 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1109739), // Rule ID 62328 //
     /* 1109667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109706 */     // MIs[0] policy
     /* 1109706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109738 */     // GIR_Coverage, 62328,
     /* 1109738 */     GIR_EraseRootFromParent_Done,
     /* 1109739 */   // Label 16318: @1109739
     /* 1109739 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1109816), // Rule ID 62329 //
     /* 1109744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109783 */     // MIs[0] policy
     /* 1109783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109815 */     // GIR_Coverage, 62329,
     /* 1109815 */     GIR_EraseRootFromParent_Done,
     /* 1109816 */   // Label 16319: @1109816
     /* 1109816 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1109893), // Rule ID 62330 //
     /* 1109821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109860 */     // MIs[0] policy
     /* 1109860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109892 */     // GIR_Coverage, 62330,
     /* 1109892 */     GIR_EraseRootFromParent_Done,
     /* 1109893 */   // Label 16320: @1109893
     /* 1109893 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1109970), // Rule ID 62331 //
     /* 1109898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109937 */     // MIs[0] policy
     /* 1109937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109947 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109969 */     // GIR_Coverage, 62331,
     /* 1109969 */     GIR_EraseRootFromParent_Done,
     /* 1109970 */   // Label 16321: @1109970
     /* 1109970 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1110047), // Rule ID 62332 //
     /* 1109975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110014 */     // MIs[0] policy
     /* 1110014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1110027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110046 */     // GIR_Coverage, 62332,
     /* 1110046 */     GIR_EraseRootFromParent_Done,
     /* 1110047 */   // Label 16322: @1110047
     /* 1110047 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1110124), // Rule ID 62333 //
     /* 1110052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1110055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1110060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110091 */     // MIs[0] policy
     /* 1110091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110101 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1110104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110123 */     // GIR_Coverage, 62333,
     /* 1110123 */     GIR_EraseRootFromParent_Done,
     /* 1110124 */   // Label 16323: @1110124
     /* 1110124 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1110201), // Rule ID 62334 //
     /* 1110129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110168 */     // MIs[0] policy
     /* 1110168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110200 */     // GIR_Coverage, 62334,
     /* 1110200 */     GIR_EraseRootFromParent_Done,
     /* 1110201 */   // Label 16324: @1110201
     /* 1110201 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1110278), // Rule ID 62335 //
     /* 1110206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110245 */     // MIs[0] policy
     /* 1110245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110255 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110277 */     // GIR_Coverage, 62335,
     /* 1110277 */     GIR_EraseRootFromParent_Done,
     /* 1110278 */   // Label 16325: @1110278
     /* 1110278 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1110355), // Rule ID 62336 //
     /* 1110283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110322 */     // MIs[0] policy
     /* 1110322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110354 */     // GIR_Coverage, 62336,
     /* 1110354 */     GIR_EraseRootFromParent_Done,
     /* 1110355 */   // Label 16326: @1110355
     /* 1110355 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1110432), // Rule ID 62337 //
     /* 1110360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110399 */     // MIs[0] policy
     /* 1110399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110409 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110431 */     // GIR_Coverage, 62337,
     /* 1110431 */     GIR_EraseRootFromParent_Done,
     /* 1110432 */   // Label 16327: @1110432
     /* 1110432 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1110509), // Rule ID 62338 //
     /* 1110437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110476 */     // MIs[0] policy
     /* 1110476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110508 */     // GIR_Coverage, 62338,
     /* 1110508 */     GIR_EraseRootFromParent_Done,
     /* 1110509 */   // Label 16328: @1110509
     /* 1110509 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1110586), // Rule ID 62339 //
     /* 1110514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110553 */     // MIs[0] policy
     /* 1110553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110563 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110585 */     // GIR_Coverage, 62339,
     /* 1110585 */     GIR_EraseRootFromParent_Done,
     /* 1110586 */   // Label 16329: @1110586
     /* 1110586 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1110663), // Rule ID 62340 //
     /* 1110591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110630 */     // MIs[0] policy
     /* 1110630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110662 */     // GIR_Coverage, 62340,
     /* 1110662 */     GIR_EraseRootFromParent_Done,
     /* 1110663 */   // Label 16330: @1110663
     /* 1110663 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1110740), // Rule ID 62341 //
     /* 1110668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110707 */     // MIs[0] policy
     /* 1110707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110739 */     // GIR_Coverage, 62341,
     /* 1110739 */     GIR_EraseRootFromParent_Done,
     /* 1110740 */   // Label 16331: @1110740
     /* 1110740 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1110817), // Rule ID 62342 //
     /* 1110745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110784 */     // MIs[0] policy
     /* 1110784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110816 */     // GIR_Coverage, 62342,
     /* 1110816 */     GIR_EraseRootFromParent_Done,
     /* 1110817 */   // Label 16332: @1110817
     /* 1110817 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1110894), // Rule ID 62343 //
     /* 1110822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110861 */     // MIs[0] policy
     /* 1110861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110893 */     // GIR_Coverage, 62343,
     /* 1110893 */     GIR_EraseRootFromParent_Done,
     /* 1110894 */   // Label 16333: @1110894
     /* 1110894 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1110971), // Rule ID 62344 //
     /* 1110899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110938 */     // MIs[0] policy
     /* 1110938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110970 */     // GIR_Coverage, 62344,
     /* 1110970 */     GIR_EraseRootFromParent_Done,
     /* 1110971 */   // Label 16334: @1110971
     /* 1110971 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1111048), // Rule ID 62345 //
     /* 1110976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111015 */     // MIs[0] policy
     /* 1111015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111047 */     // GIR_Coverage, 62345,
     /* 1111047 */     GIR_EraseRootFromParent_Done,
     /* 1111048 */   // Label 16335: @1111048
     /* 1111048 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1111125), // Rule ID 62346 //
     /* 1111053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111092 */     // MIs[0] policy
     /* 1111092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111124 */     // GIR_Coverage, 62346,
     /* 1111124 */     GIR_EraseRootFromParent_Done,
     /* 1111125 */   // Label 16336: @1111125
     /* 1111125 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1111202), // Rule ID 62347 //
     /* 1111130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111169 */     // MIs[0] policy
     /* 1111169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111201 */     // GIR_Coverage, 62347,
     /* 1111201 */     GIR_EraseRootFromParent_Done,
     /* 1111202 */   // Label 16337: @1111202
     /* 1111202 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1111279), // Rule ID 62348 //
     /* 1111207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111246 */     // MIs[0] policy
     /* 1111246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111278 */     // GIR_Coverage, 62348,
     /* 1111278 */     GIR_EraseRootFromParent_Done,
     /* 1111279 */   // Label 16338: @1111279
     /* 1111279 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1111356), // Rule ID 62349 //
     /* 1111284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111323 */     // MIs[0] policy
     /* 1111323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111355 */     // GIR_Coverage, 62349,
     /* 1111355 */     GIR_EraseRootFromParent_Done,
     /* 1111356 */   // Label 16339: @1111356
     /* 1111356 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1111433), // Rule ID 62350 //
     /* 1111361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111400 */     // MIs[0] policy
     /* 1111400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111432 */     // GIR_Coverage, 62350,
     /* 1111432 */     GIR_EraseRootFromParent_Done,
     /* 1111433 */   // Label 16340: @1111433
     /* 1111433 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1111510), // Rule ID 62351 //
     /* 1111438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111477 */     // MIs[0] policy
     /* 1111477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111487 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111509 */     // GIR_Coverage, 62351,
     /* 1111509 */     GIR_EraseRootFromParent_Done,
     /* 1111510 */   // Label 16341: @1111510
     /* 1111510 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1111587), // Rule ID 62352 //
     /* 1111515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111554 */     // MIs[0] policy
     /* 1111554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111586 */     // GIR_Coverage, 62352,
     /* 1111586 */     GIR_EraseRootFromParent_Done,
     /* 1111587 */   // Label 16342: @1111587
     /* 1111587 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1111664), // Rule ID 62353 //
     /* 1111592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111631 */     // MIs[0] policy
     /* 1111631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111663 */     // GIR_Coverage, 62353,
     /* 1111663 */     GIR_EraseRootFromParent_Done,
     /* 1111664 */   // Label 16343: @1111664
     /* 1111664 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1111741), // Rule ID 62354 //
     /* 1111669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111708 */     // MIs[0] policy
     /* 1111708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111740 */     // GIR_Coverage, 62354,
     /* 1111740 */     GIR_EraseRootFromParent_Done,
     /* 1111741 */   // Label 16344: @1111741
     /* 1111741 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1111818), // Rule ID 62355 //
     /* 1111746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111785 */     // MIs[0] policy
     /* 1111785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111817 */     // GIR_Coverage, 62355,
     /* 1111817 */     GIR_EraseRootFromParent_Done,
     /* 1111818 */   // Label 16345: @1111818
     /* 1111818 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1111895), // Rule ID 62356 //
     /* 1111823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111862 */     // MIs[0] policy
     /* 1111862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111894 */     // GIR_Coverage, 62356,
     /* 1111894 */     GIR_EraseRootFromParent_Done,
     /* 1111895 */   // Label 16346: @1111895
     /* 1111895 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1111972), // Rule ID 62357 //
     /* 1111900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111939 */     // MIs[0] policy
     /* 1111939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111949 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111971 */     // GIR_Coverage, 62357,
     /* 1111971 */     GIR_EraseRootFromParent_Done,
     /* 1111972 */   // Label 16347: @1111972
     /* 1111972 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1112049), // Rule ID 62358 //
     /* 1111977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112016 */     // MIs[0] policy
     /* 1112016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112048 */     // GIR_Coverage, 62358,
     /* 1112048 */     GIR_EraseRootFromParent_Done,
     /* 1112049 */   // Label 16348: @1112049
     /* 1112049 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1112126), // Rule ID 62359 //
     /* 1112054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112093 */     // MIs[0] policy
     /* 1112093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112103 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112125 */     // GIR_Coverage, 62359,
     /* 1112125 */     GIR_EraseRootFromParent_Done,
     /* 1112126 */   // Label 16349: @1112126
     /* 1112126 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1112203), // Rule ID 62360 //
     /* 1112131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112170 */     // MIs[0] policy
     /* 1112170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112180 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112202 */     // GIR_Coverage, 62360,
     /* 1112202 */     GIR_EraseRootFromParent_Done,
     /* 1112203 */   // Label 16350: @1112203
     /* 1112203 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1112280), // Rule ID 62361 //
     /* 1112208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112247 */     // MIs[0] policy
     /* 1112247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112257 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112279 */     // GIR_Coverage, 62361,
     /* 1112279 */     GIR_EraseRootFromParent_Done,
     /* 1112280 */   // Label 16351: @1112280
     /* 1112280 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1112357), // Rule ID 62362 //
     /* 1112285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112324 */     // MIs[0] policy
     /* 1112324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112356 */     // GIR_Coverage, 62362,
     /* 1112356 */     GIR_EraseRootFromParent_Done,
     /* 1112357 */   // Label 16352: @1112357
     /* 1112357 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1112434), // Rule ID 62363 //
     /* 1112362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112401 */     // MIs[0] policy
     /* 1112401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112411 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112433 */     // GIR_Coverage, 62363,
     /* 1112433 */     GIR_EraseRootFromParent_Done,
     /* 1112434 */   // Label 16353: @1112434
     /* 1112434 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1112511), // Rule ID 62364 //
     /* 1112439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112478 */     // MIs[0] policy
     /* 1112478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112510 */     // GIR_Coverage, 62364,
     /* 1112510 */     GIR_EraseRootFromParent_Done,
     /* 1112511 */   // Label 16354: @1112511
     /* 1112511 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1112588), // Rule ID 62365 //
     /* 1112516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112555 */     // MIs[0] policy
     /* 1112555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112587 */     // GIR_Coverage, 62365,
     /* 1112587 */     GIR_EraseRootFromParent_Done,
     /* 1112588 */   // Label 16355: @1112588
     /* 1112588 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1112665), // Rule ID 62366 //
     /* 1112593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112632 */     // MIs[0] policy
     /* 1112632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112664 */     // GIR_Coverage, 62366,
     /* 1112664 */     GIR_EraseRootFromParent_Done,
     /* 1112665 */   // Label 16356: @1112665
     /* 1112665 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1112742), // Rule ID 62367 //
     /* 1112670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112709 */     // MIs[0] policy
     /* 1112709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112741 */     // GIR_Coverage, 62367,
     /* 1112741 */     GIR_EraseRootFromParent_Done,
     /* 1112742 */   // Label 16357: @1112742
     /* 1112742 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1112819), // Rule ID 62368 //
     /* 1112747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112786 */     // MIs[0] policy
     /* 1112786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112818 */     // GIR_Coverage, 62368,
     /* 1112818 */     GIR_EraseRootFromParent_Done,
     /* 1112819 */   // Label 16358: @1112819
     /* 1112819 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1112896), // Rule ID 62369 //
     /* 1112824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112863 */     // MIs[0] policy
     /* 1112863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112873 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112895 */     // GIR_Coverage, 62369,
     /* 1112895 */     GIR_EraseRootFromParent_Done,
     /* 1112896 */   // Label 16359: @1112896
     /* 1112896 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1112973), // Rule ID 62370 //
     /* 1112901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112940 */     // MIs[0] policy
     /* 1112940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112972 */     // GIR_Coverage, 62370,
     /* 1112972 */     GIR_EraseRootFromParent_Done,
     /* 1112973 */   // Label 16360: @1112973
     /* 1112973 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1113050), // Rule ID 62371 //
     /* 1112978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113017 */     // MIs[0] policy
     /* 1113017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1113030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113049 */     // GIR_Coverage, 62371,
     /* 1113049 */     GIR_EraseRootFromParent_Done,
     /* 1113050 */   // Label 16361: @1113050
     /* 1113050 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1113127), // Rule ID 62372 //
     /* 1113055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113094 */     // MIs[0] policy
     /* 1113094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113126 */     // GIR_Coverage, 62372,
     /* 1113126 */     GIR_EraseRootFromParent_Done,
     /* 1113127 */   // Label 16362: @1113127
     /* 1113127 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1113204), // Rule ID 62373 //
     /* 1113132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113171 */     // MIs[0] policy
     /* 1113171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113203 */     // GIR_Coverage, 62373,
     /* 1113203 */     GIR_EraseRootFromParent_Done,
     /* 1113204 */   // Label 16363: @1113204
     /* 1113204 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1113281), // Rule ID 62374 //
     /* 1113209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113248 */     // MIs[0] policy
     /* 1113248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1113261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113280 */     // GIR_Coverage, 62374,
     /* 1113280 */     GIR_EraseRootFromParent_Done,
     /* 1113281 */   // Label 16364: @1113281
     /* 1113281 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1113358), // Rule ID 62375 //
     /* 1113286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113325 */     // MIs[0] policy
     /* 1113325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113335 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1113338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113357 */     // GIR_Coverage, 62375,
     /* 1113357 */     GIR_EraseRootFromParent_Done,
     /* 1113358 */   // Label 16365: @1113358
     /* 1113358 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1113435), // Rule ID 62376 //
     /* 1113363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113402 */     // MIs[0] policy
     /* 1113402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113434 */     // GIR_Coverage, 62376,
     /* 1113434 */     GIR_EraseRootFromParent_Done,
     /* 1113435 */   // Label 16366: @1113435
     /* 1113435 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1113512), // Rule ID 62377 //
     /* 1113440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113479 */     // MIs[0] policy
     /* 1113479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113511 */     // GIR_Coverage, 62377,
     /* 1113511 */     GIR_EraseRootFromParent_Done,
     /* 1113512 */   // Label 16367: @1113512
     /* 1113512 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1113589), // Rule ID 62378 //
     /* 1113517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113556 */     // MIs[0] policy
     /* 1113556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113588 */     // GIR_Coverage, 62378,
     /* 1113588 */     GIR_EraseRootFromParent_Done,
     /* 1113589 */   // Label 16368: @1113589
     /* 1113589 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1113666), // Rule ID 62379 //
     /* 1113594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113633 */     // MIs[0] policy
     /* 1113633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113665 */     // GIR_Coverage, 62379,
     /* 1113665 */     GIR_EraseRootFromParent_Done,
     /* 1113666 */   // Label 16369: @1113666
     /* 1113666 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1113743), // Rule ID 62380 //
     /* 1113671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113710 */     // MIs[0] policy
     /* 1113710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113742 */     // GIR_Coverage, 62380,
     /* 1113742 */     GIR_EraseRootFromParent_Done,
     /* 1113743 */   // Label 16370: @1113743
     /* 1113743 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1113820), // Rule ID 62381 //
     /* 1113748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113787 */     // MIs[0] policy
     /* 1113787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113819 */     // GIR_Coverage, 62381,
     /* 1113819 */     GIR_EraseRootFromParent_Done,
     /* 1113820 */   // Label 16371: @1113820
     /* 1113820 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1113897), // Rule ID 62382 //
     /* 1113825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113864 */     // MIs[0] policy
     /* 1113864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113896 */     // GIR_Coverage, 62382,
     /* 1113896 */     GIR_EraseRootFromParent_Done,
     /* 1113897 */   // Label 16372: @1113897
     /* 1113897 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1113974), // Rule ID 62383 //
     /* 1113902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113941 */     // MIs[0] policy
     /* 1113941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113973 */     // GIR_Coverage, 62383,
     /* 1113973 */     GIR_EraseRootFromParent_Done,
     /* 1113974 */   // Label 16373: @1113974
     /* 1113974 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1114051), // Rule ID 62384 //
     /* 1113979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114018 */     // MIs[0] policy
     /* 1114018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1114031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114050 */     // GIR_Coverage, 62384,
     /* 1114050 */     GIR_EraseRootFromParent_Done,
     /* 1114051 */   // Label 16374: @1114051
     /* 1114051 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1114128), // Rule ID 62385 //
     /* 1114056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114095 */     // MIs[0] policy
     /* 1114095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114105 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1114108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114127 */     // GIR_Coverage, 62385,
     /* 1114127 */     GIR_EraseRootFromParent_Done,
     /* 1114128 */   // Label 16375: @1114128
     /* 1114128 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1114205), // Rule ID 62386 //
     /* 1114133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114172 */     // MIs[0] policy
     /* 1114172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1114185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114204 */     // GIR_Coverage, 62386,
     /* 1114204 */     GIR_EraseRootFromParent_Done,
     /* 1114205 */   // Label 16376: @1114205
     /* 1114205 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1114282), // Rule ID 62387 //
     /* 1114210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1114218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114249 */     // MIs[0] policy
     /* 1114249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114259 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1114262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114281 */     // GIR_Coverage, 62387,
     /* 1114281 */     GIR_EraseRootFromParent_Done,
     /* 1114282 */   // Label 16377: @1114282
     /* 1114282 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1114359), // Rule ID 62608 //
     /* 1114287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114326 */     // MIs[0] policy
     /* 1114326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1114339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114358 */     // GIR_Coverage, 62608,
     /* 1114358 */     GIR_EraseRootFromParent_Done,
     /* 1114359 */   // Label 16378: @1114359
     /* 1114359 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1114436), // Rule ID 62609 //
     /* 1114364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114403 */     // MIs[0] policy
     /* 1114403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114413 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2),
     /* 1114416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114435 */     // GIR_Coverage, 62609,
     /* 1114435 */     GIR_EraseRootFromParent_Done,
     /* 1114436 */   // Label 16379: @1114436
     /* 1114436 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1114513), // Rule ID 62612 //
     /* 1114441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114480 */     // MIs[0] policy
     /* 1114480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114512 */     // GIR_Coverage, 62612,
     /* 1114512 */     GIR_EraseRootFromParent_Done,
     /* 1114513 */   // Label 16380: @1114513
     /* 1114513 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1114590), // Rule ID 62613 //
     /* 1114518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114557 */     // MIs[0] policy
     /* 1114557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114567 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1),
     /* 1114570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114589 */     // GIR_Coverage, 62613,
     /* 1114589 */     GIR_EraseRootFromParent_Done,
     /* 1114590 */   // Label 16381: @1114590
     /* 1114590 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1114667), // Rule ID 62616 //
     /* 1114595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114634 */     // MIs[0] policy
     /* 1114634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114666 */     // GIR_Coverage, 62616,
     /* 1114666 */     GIR_EraseRootFromParent_Done,
     /* 1114667 */   // Label 16382: @1114667
     /* 1114667 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1114744), // Rule ID 62617 //
     /* 1114672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114711 */     // MIs[0] policy
     /* 1114711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2),
     /* 1114724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114743 */     // GIR_Coverage, 62617,
     /* 1114743 */     GIR_EraseRootFromParent_Done,
     /* 1114744 */   // Label 16383: @1114744
     /* 1114744 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1114821), // Rule ID 62620 //
     /* 1114749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114788 */     // MIs[0] policy
     /* 1114788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114820 */     // GIR_Coverage, 62620,
     /* 1114820 */     GIR_EraseRootFromParent_Done,
     /* 1114821 */   // Label 16384: @1114821
     /* 1114821 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1114898), // Rule ID 62621 //
     /* 1114826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114865 */     // MIs[0] policy
     /* 1114865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114875 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4),
     /* 1114878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114897 */     // GIR_Coverage, 62621,
     /* 1114897 */     GIR_EraseRootFromParent_Done,
     /* 1114898 */   // Label 16385: @1114898
     /* 1114898 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1114975), // Rule ID 62624 //
     /* 1114903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114942 */     // MIs[0] policy
     /* 1114942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1114955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114974 */     // GIR_Coverage, 62624,
     /* 1114974 */     GIR_EraseRootFromParent_Done,
     /* 1114975 */   // Label 16386: @1114975
     /* 1114975 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1115052), // Rule ID 62625 //
     /* 1114980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115019 */     // MIs[0] policy
     /* 1115019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115029 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8),
     /* 1115032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115051 */     // GIR_Coverage, 62625,
     /* 1115051 */     GIR_EraseRootFromParent_Done,
     /* 1115052 */   // Label 16387: @1115052
     /* 1115052 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1115129), // Rule ID 62628 //
     /* 1115057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115096 */     // MIs[0] policy
     /* 1115096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1115109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115128 */     // GIR_Coverage, 62628,
     /* 1115128 */     GIR_EraseRootFromParent_Done,
     /* 1115129 */   // Label 16388: @1115129
     /* 1115129 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1115206), // Rule ID 62629 //
     /* 1115134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115173 */     // MIs[0] policy
     /* 1115173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2),
     /* 1115186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115205 */     // GIR_Coverage, 62629,
     /* 1115205 */     GIR_EraseRootFromParent_Done,
     /* 1115206 */   // Label 16389: @1115206
     /* 1115206 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1115283), // Rule ID 62632 //
     /* 1115211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115250 */     // MIs[0] policy
     /* 1115250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1115263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115282 */     // GIR_Coverage, 62632,
     /* 1115282 */     GIR_EraseRootFromParent_Done,
     /* 1115283 */   // Label 16390: @1115283
     /* 1115283 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1115360), // Rule ID 62633 //
     /* 1115288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115327 */     // MIs[0] policy
     /* 1115327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1),
     /* 1115340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115359 */     // GIR_Coverage, 62633,
     /* 1115359 */     GIR_EraseRootFromParent_Done,
     /* 1115360 */   // Label 16391: @1115360
     /* 1115360 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1115437), // Rule ID 62636 //
     /* 1115365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115404 */     // MIs[0] policy
     /* 1115404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1115417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115436 */     // GIR_Coverage, 62636,
     /* 1115436 */     GIR_EraseRootFromParent_Done,
     /* 1115437 */   // Label 16392: @1115437
     /* 1115437 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1115514), // Rule ID 62637 //
     /* 1115442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115481 */     // MIs[0] policy
     /* 1115481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2),
     /* 1115494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115513 */     // GIR_Coverage, 62637,
     /* 1115513 */     GIR_EraseRootFromParent_Done,
     /* 1115514 */   // Label 16393: @1115514
     /* 1115514 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1115591), // Rule ID 62640 //
     /* 1115519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115558 */     // MIs[0] policy
     /* 1115558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115590 */     // GIR_Coverage, 62640,
     /* 1115590 */     GIR_EraseRootFromParent_Done,
     /* 1115591 */   // Label 16394: @1115591
     /* 1115591 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1115668), // Rule ID 62641 //
     /* 1115596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115635 */     // MIs[0] policy
     /* 1115635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4),
     /* 1115648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115667 */     // GIR_Coverage, 62641,
     /* 1115667 */     GIR_EraseRootFromParent_Done,
     /* 1115668 */   // Label 16395: @1115668
     /* 1115668 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1115745), // Rule ID 62644 //
     /* 1115673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115712 */     // MIs[0] policy
     /* 1115712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115744 */     // GIR_Coverage, 62644,
     /* 1115744 */     GIR_EraseRootFromParent_Done,
     /* 1115745 */   // Label 16396: @1115745
     /* 1115745 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1115822), // Rule ID 62645 //
     /* 1115750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115789 */     // MIs[0] policy
     /* 1115789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8),
     /* 1115802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115821 */     // GIR_Coverage, 62645,
     /* 1115821 */     GIR_EraseRootFromParent_Done,
     /* 1115822 */   // Label 16397: @1115822
     /* 1115822 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1115899), // Rule ID 62648 //
     /* 1115827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115866 */     // MIs[0] policy
     /* 1115866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115898 */     // GIR_Coverage, 62648,
     /* 1115898 */     GIR_EraseRootFromParent_Done,
     /* 1115899 */   // Label 16398: @1115899
     /* 1115899 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1115976), // Rule ID 62649 //
     /* 1115904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115943 */     // MIs[0] policy
     /* 1115943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2),
     /* 1115956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115975 */     // GIR_Coverage, 62649,
     /* 1115975 */     GIR_EraseRootFromParent_Done,
     /* 1115976 */   // Label 16399: @1115976
     /* 1115976 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1116053), // Rule ID 62652 //
     /* 1115981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116020 */     // MIs[0] policy
     /* 1116020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1116033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116052 */     // GIR_Coverage, 62652,
     /* 1116052 */     GIR_EraseRootFromParent_Done,
     /* 1116053 */   // Label 16400: @1116053
     /* 1116053 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1116130), // Rule ID 62653 //
     /* 1116058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1116075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116097 */     // MIs[0] policy
     /* 1116097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1),
     /* 1116110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116129 */     // GIR_Coverage, 62653,
     /* 1116129 */     GIR_EraseRootFromParent_Done,
     /* 1116130 */   // Label 16401: @1116130
     /* 1116130 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1116207), // Rule ID 62656 //
     /* 1116135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116174 */     // MIs[0] policy
     /* 1116174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1116187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116206 */     // GIR_Coverage, 62656,
     /* 1116206 */     GIR_EraseRootFromParent_Done,
     /* 1116207 */   // Label 16402: @1116207
     /* 1116207 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1116284), // Rule ID 62657 //
     /* 1116212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116251 */     // MIs[0] policy
     /* 1116251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2),
     /* 1116264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116283 */     // GIR_Coverage, 62657,
     /* 1116283 */     GIR_EraseRootFromParent_Done,
     /* 1116284 */   // Label 16403: @1116284
     /* 1116284 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1116361), // Rule ID 62660 //
     /* 1116289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116328 */     // MIs[0] policy
     /* 1116328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1116341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116360 */     // GIR_Coverage, 62660,
     /* 1116360 */     GIR_EraseRootFromParent_Done,
     /* 1116361 */   // Label 16404: @1116361
     /* 1116361 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1116438), // Rule ID 62661 //
     /* 1116366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116405 */     // MIs[0] policy
     /* 1116405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116415 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4),
     /* 1116418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116437 */     // GIR_Coverage, 62661,
     /* 1116437 */     GIR_EraseRootFromParent_Done,
     /* 1116438 */   // Label 16405: @1116438
     /* 1116438 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1116515), // Rule ID 62664 //
     /* 1116443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116482 */     // MIs[0] policy
     /* 1116482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116514 */     // GIR_Coverage, 62664,
     /* 1116514 */     GIR_EraseRootFromParent_Done,
     /* 1116515 */   // Label 16406: @1116515
     /* 1116515 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1116592), // Rule ID 62665 //
     /* 1116520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116559 */     // MIs[0] policy
     /* 1116559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8),
     /* 1116572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116591 */     // GIR_Coverage, 62665,
     /* 1116591 */     GIR_EraseRootFromParent_Done,
     /* 1116592 */   // Label 16407: @1116592
     /* 1116592 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1116669), // Rule ID 62668 //
     /* 1116597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116636 */     // MIs[0] policy
     /* 1116636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116668 */     // GIR_Coverage, 62668,
     /* 1116668 */     GIR_EraseRootFromParent_Done,
     /* 1116669 */   // Label 16408: @1116669
     /* 1116669 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1116746), // Rule ID 62669 //
     /* 1116674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116713 */     // MIs[0] policy
     /* 1116713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116723 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2),
     /* 1116726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116745 */     // GIR_Coverage, 62669,
     /* 1116745 */     GIR_EraseRootFromParent_Done,
     /* 1116746 */   // Label 16409: @1116746
     /* 1116746 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1116823), // Rule ID 62672 //
     /* 1116751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116790 */     // MIs[0] policy
     /* 1116790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116822 */     // GIR_Coverage, 62672,
     /* 1116822 */     GIR_EraseRootFromParent_Done,
     /* 1116823 */   // Label 16410: @1116823
     /* 1116823 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1116900), // Rule ID 62673 //
     /* 1116828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116867 */     // MIs[0] policy
     /* 1116867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1),
     /* 1116880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116899 */     // GIR_Coverage, 62673,
     /* 1116899 */     GIR_EraseRootFromParent_Done,
     /* 1116900 */   // Label 16411: @1116900
     /* 1116900 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1116977), // Rule ID 62676 //
     /* 1116905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116944 */     // MIs[0] policy
     /* 1116944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1116957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116976 */     // GIR_Coverage, 62676,
     /* 1116976 */     GIR_EraseRootFromParent_Done,
     /* 1116977 */   // Label 16412: @1116977
     /* 1116977 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1117054), // Rule ID 62677 //
     /* 1116982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117021 */     // MIs[0] policy
     /* 1117021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2),
     /* 1117034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117053 */     // GIR_Coverage, 62677,
     /* 1117053 */     GIR_EraseRootFromParent_Done,
     /* 1117054 */   // Label 16413: @1117054
     /* 1117054 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1117131), // Rule ID 62680 //
     /* 1117059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117098 */     // MIs[0] policy
     /* 1117098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1117111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117130 */     // GIR_Coverage, 62680,
     /* 1117130 */     GIR_EraseRootFromParent_Done,
     /* 1117131 */   // Label 16414: @1117131
     /* 1117131 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1117208), // Rule ID 62681 //
     /* 1117136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117175 */     // MIs[0] policy
     /* 1117175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4),
     /* 1117188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117207 */     // GIR_Coverage, 62681,
     /* 1117207 */     GIR_EraseRootFromParent_Done,
     /* 1117208 */   // Label 16415: @1117208
     /* 1117208 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1117285), // Rule ID 62684 //
     /* 1117213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117252 */     // MIs[0] policy
     /* 1117252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1117265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117284 */     // GIR_Coverage, 62684,
     /* 1117284 */     GIR_EraseRootFromParent_Done,
     /* 1117285 */   // Label 16416: @1117285
     /* 1117285 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1117362), // Rule ID 62685 //
     /* 1117290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1117298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117329 */     // MIs[0] policy
     /* 1117329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8),
     /* 1117342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117361 */     // GIR_Coverage, 62685,
     /* 1117361 */     GIR_EraseRootFromParent_Done,
     /* 1117362 */   // Label 16417: @1117362
     /* 1117362 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1117439), // Rule ID 62688 //
     /* 1117367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117406 */     // MIs[0] policy
     /* 1117406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1117419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117438 */     // GIR_Coverage, 62688,
     /* 1117438 */     GIR_EraseRootFromParent_Done,
     /* 1117439 */   // Label 16418: @1117439
     /* 1117439 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1117516), // Rule ID 62689 //
     /* 1117444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117483 */     // MIs[0] policy
     /* 1117483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2),
     /* 1117496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117515 */     // GIR_Coverage, 62689,
     /* 1117515 */     GIR_EraseRootFromParent_Done,
     /* 1117516 */   // Label 16419: @1117516
     /* 1117516 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1117593), // Rule ID 62692 //
     /* 1117521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117560 */     // MIs[0] policy
     /* 1117560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117592 */     // GIR_Coverage, 62692,
     /* 1117592 */     GIR_EraseRootFromParent_Done,
     /* 1117593 */   // Label 16420: @1117593
     /* 1117593 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1117670), // Rule ID 62693 //
     /* 1117598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117637 */     // MIs[0] policy
     /* 1117637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1),
     /* 1117650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117669 */     // GIR_Coverage, 62693,
     /* 1117669 */     GIR_EraseRootFromParent_Done,
     /* 1117670 */   // Label 16421: @1117670
     /* 1117670 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1117747), // Rule ID 62696 //
     /* 1117675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117714 */     // MIs[0] policy
     /* 1117714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117746 */     // GIR_Coverage, 62696,
     /* 1117746 */     GIR_EraseRootFromParent_Done,
     /* 1117747 */   // Label 16422: @1117747
     /* 1117747 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1117824), // Rule ID 62697 //
     /* 1117752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117791 */     // MIs[0] policy
     /* 1117791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2),
     /* 1117804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117823 */     // GIR_Coverage, 62697,
     /* 1117823 */     GIR_EraseRootFromParent_Done,
     /* 1117824 */   // Label 16423: @1117824
     /* 1117824 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1117901), // Rule ID 62700 //
     /* 1117829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117868 */     // MIs[0] policy
     /* 1117868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117900 */     // GIR_Coverage, 62700,
     /* 1117900 */     GIR_EraseRootFromParent_Done,
     /* 1117901 */   // Label 16424: @1117901
     /* 1117901 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1117978), // Rule ID 62701 //
     /* 1117906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117945 */     // MIs[0] policy
     /* 1117945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4),
     /* 1117958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117977 */     // GIR_Coverage, 62701,
     /* 1117977 */     GIR_EraseRootFromParent_Done,
     /* 1117978 */   // Label 16425: @1117978
     /* 1117978 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1118055), // Rule ID 62704 //
     /* 1117983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118022 */     // MIs[0] policy
     /* 1118022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1118035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118054 */     // GIR_Coverage, 62704,
     /* 1118054 */     GIR_EraseRootFromParent_Done,
     /* 1118055 */   // Label 16426: @1118055
     /* 1118055 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1118132), // Rule ID 62705 //
     /* 1118060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118099 */     // MIs[0] policy
     /* 1118099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8),
     /* 1118112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118131 */     // GIR_Coverage, 62705,
     /* 1118131 */     GIR_EraseRootFromParent_Done,
     /* 1118132 */   // Label 16427: @1118132
     /* 1118132 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1118209), // Rule ID 62708 //
     /* 1118137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118176 */     // MIs[0] policy
     /* 1118176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1118189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118208 */     // GIR_Coverage, 62708,
     /* 1118208 */     GIR_EraseRootFromParent_Done,
     /* 1118209 */   // Label 16428: @1118209
     /* 1118209 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1118286), // Rule ID 62709 //
     /* 1118214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118253 */     // MIs[0] policy
     /* 1118253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2),
     /* 1118266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118285 */     // GIR_Coverage, 62709,
     /* 1118285 */     GIR_EraseRootFromParent_Done,
     /* 1118286 */   // Label 16429: @1118286
     /* 1118286 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1118363), // Rule ID 62712 //
     /* 1118291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118330 */     // MIs[0] policy
     /* 1118330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1118343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118362 */     // GIR_Coverage, 62712,
     /* 1118362 */     GIR_EraseRootFromParent_Done,
     /* 1118363 */   // Label 16430: @1118363
     /* 1118363 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1118440), // Rule ID 62713 //
     /* 1118368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118407 */     // MIs[0] policy
     /* 1118407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118417 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1),
     /* 1118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118439 */     // GIR_Coverage, 62713,
     /* 1118439 */     GIR_EraseRootFromParent_Done,
     /* 1118440 */   // Label 16431: @1118440
     /* 1118440 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1118517), // Rule ID 62716 //
     /* 1118445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118484 */     // MIs[0] policy
     /* 1118484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118516 */     // GIR_Coverage, 62716,
     /* 1118516 */     GIR_EraseRootFromParent_Done,
     /* 1118517 */   // Label 16432: @1118517
     /* 1118517 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1118594), // Rule ID 62717 //
     /* 1118522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118561 */     // MIs[0] policy
     /* 1118561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2),
     /* 1118574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118593 */     // GIR_Coverage, 62717,
     /* 1118593 */     GIR_EraseRootFromParent_Done,
     /* 1118594 */   // Label 16433: @1118594
     /* 1118594 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1118671), // Rule ID 62720 //
     /* 1118599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118638 */     // MIs[0] policy
     /* 1118638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118670 */     // GIR_Coverage, 62720,
     /* 1118670 */     GIR_EraseRootFromParent_Done,
     /* 1118671 */   // Label 16434: @1118671
     /* 1118671 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1118748), // Rule ID 62721 //
     /* 1118676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118715 */     // MIs[0] policy
     /* 1118715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118725 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4),
     /* 1118728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118747 */     // GIR_Coverage, 62721,
     /* 1118747 */     GIR_EraseRootFromParent_Done,
     /* 1118748 */   // Label 16435: @1118748
     /* 1118748 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1118825), // Rule ID 62724 //
     /* 1118753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118792 */     // MIs[0] policy
     /* 1118792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118824 */     // GIR_Coverage, 62724,
     /* 1118824 */     GIR_EraseRootFromParent_Done,
     /* 1118825 */   // Label 16436: @1118825
     /* 1118825 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1118902), // Rule ID 62725 //
     /* 1118830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118869 */     // MIs[0] policy
     /* 1118869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118879 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8),
     /* 1118882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118901 */     // GIR_Coverage, 62725,
     /* 1118901 */     GIR_EraseRootFromParent_Done,
     /* 1118902 */   // Label 16437: @1118902
     /* 1118902 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1118979), // Rule ID 62728 //
     /* 1118907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118946 */     // MIs[0] policy
     /* 1118946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118956 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1118959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118978 */     // GIR_Coverage, 62728,
     /* 1118978 */     GIR_EraseRootFromParent_Done,
     /* 1118979 */   // Label 16438: @1118979
     /* 1118979 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1119056), // Rule ID 62729 //
     /* 1118984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119023 */     // MIs[0] policy
     /* 1119023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119033 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2),
     /* 1119036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119055 */     // GIR_Coverage, 62729,
     /* 1119055 */     GIR_EraseRootFromParent_Done,
     /* 1119056 */   // Label 16439: @1119056
     /* 1119056 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1119133), // Rule ID 62732 //
     /* 1119061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119100 */     // MIs[0] policy
     /* 1119100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1119113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119132 */     // GIR_Coverage, 62732,
     /* 1119132 */     GIR_EraseRootFromParent_Done,
     /* 1119133 */   // Label 16440: @1119133
     /* 1119133 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1119210), // Rule ID 62733 //
     /* 1119138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119177 */     // MIs[0] policy
     /* 1119177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119187 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1),
     /* 1119190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119209 */     // GIR_Coverage, 62733,
     /* 1119209 */     GIR_EraseRootFromParent_Done,
     /* 1119210 */   // Label 16441: @1119210
     /* 1119210 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1119287), // Rule ID 62736 //
     /* 1119215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119254 */     // MIs[0] policy
     /* 1119254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1119267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119286 */     // GIR_Coverage, 62736,
     /* 1119286 */     GIR_EraseRootFromParent_Done,
     /* 1119287 */   // Label 16442: @1119287
     /* 1119287 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1119364), // Rule ID 62737 //
     /* 1119292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119331 */     // MIs[0] policy
     /* 1119331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2),
     /* 1119344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119363 */     // GIR_Coverage, 62737,
     /* 1119363 */     GIR_EraseRootFromParent_Done,
     /* 1119364 */   // Label 16443: @1119364
     /* 1119364 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1119441), // Rule ID 62740 //
     /* 1119369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119408 */     // MIs[0] policy
     /* 1119408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1119421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119440 */     // GIR_Coverage, 62740,
     /* 1119440 */     GIR_EraseRootFromParent_Done,
     /* 1119441 */   // Label 16444: @1119441
     /* 1119441 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1119518), // Rule ID 62741 //
     /* 1119446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119485 */     // MIs[0] policy
     /* 1119485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119495 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4),
     /* 1119498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119517 */     // GIR_Coverage, 62741,
     /* 1119517 */     GIR_EraseRootFromParent_Done,
     /* 1119518 */   // Label 16445: @1119518
     /* 1119518 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1119595), // Rule ID 62744 //
     /* 1119523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119562 */     // MIs[0] policy
     /* 1119562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119572 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119594 */     // GIR_Coverage, 62744,
     /* 1119594 */     GIR_EraseRootFromParent_Done,
     /* 1119595 */   // Label 16446: @1119595
     /* 1119595 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1119672), // Rule ID 62745 //
     /* 1119600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119639 */     // MIs[0] policy
     /* 1119639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119649 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8),
     /* 1119652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119671 */     // GIR_Coverage, 62745,
     /* 1119671 */     GIR_EraseRootFromParent_Done,
     /* 1119672 */   // Label 16447: @1119672
     /* 1119672 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1119749), // Rule ID 62839 //
     /* 1119677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119716 */     // MIs[0] policy
     /* 1119716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119748 */     // GIR_Coverage, 62839,
     /* 1119748 */     GIR_EraseRootFromParent_Done,
     /* 1119749 */   // Label 16448: @1119749
     /* 1119749 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1119826), // Rule ID 62840 //
     /* 1119754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119793 */     // MIs[0] policy
     /* 1119793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M1),
     /* 1119806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119825 */     // GIR_Coverage, 62840,
     /* 1119825 */     GIR_EraseRootFromParent_Done,
     /* 1119826 */   // Label 16449: @1119826
     /* 1119826 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1119903), // Rule ID 64297 //
     /* 1119831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119870 */     // MIs[0] policy
     /* 1119870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119902 */     // GIR_Coverage, 64297,
     /* 1119902 */     GIR_EraseRootFromParent_Done,
     /* 1119903 */   // Label 16450: @1119903
     /* 1119903 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1119980), // Rule ID 64298 //
     /* 1119908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119947 */     // MIs[0] policy
     /* 1119947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M2),
     /* 1119960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119979 */     // GIR_Coverage, 64298,
     /* 1119979 */     GIR_EraseRootFromParent_Done,
     /* 1119980 */   // Label 16451: @1119980
     /* 1119980 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1120057), // Rule ID 64299 //
     /* 1119985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120024 */     // MIs[0] policy
     /* 1120024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1120037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120056 */     // GIR_Coverage, 64299,
     /* 1120056 */     GIR_EraseRootFromParent_Done,
     /* 1120057 */   // Label 16452: @1120057
     /* 1120057 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1120134), // Rule ID 64300 //
     /* 1120062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120101 */     // MIs[0] policy
     /* 1120101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M4),
     /* 1120114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120133 */     // GIR_Coverage, 64300,
     /* 1120133 */     GIR_EraseRootFromParent_Done,
     /* 1120134 */   // Label 16453: @1120134
     /* 1120134 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1120211), // Rule ID 64301 //
     /* 1120139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120178 */     // MIs[0] policy
     /* 1120178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1120191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120210 */     // GIR_Coverage, 64301,
     /* 1120210 */     GIR_EraseRootFromParent_Done,
     /* 1120211 */   // Label 16454: @1120211
     /* 1120211 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1120288), // Rule ID 64302 //
     /* 1120216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1120224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120255 */     // MIs[0] policy
     /* 1120255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120265 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_2x8x2_M8),
     /* 1120268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120287 */     // GIR_Coverage, 64302,
     /* 1120287 */     GIR_EraseRootFromParent_Done,
     /* 1120288 */   // Label 16455: @1120288
     /* 1120288 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1120365), // Rule ID 64303 //
     /* 1120293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120332 */     // MIs[0] policy
     /* 1120332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1120345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120364 */     // GIR_Coverage, 64303,
     /* 1120364 */     GIR_EraseRootFromParent_Done,
     /* 1120365 */   // Label 16456: @1120365
     /* 1120365 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1120442), // Rule ID 64304 //
     /* 1120370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120409 */     // MIs[0] policy
     /* 1120409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M1),
     /* 1120422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120441 */     // GIR_Coverage, 64304,
     /* 1120441 */     GIR_EraseRootFromParent_Done,
     /* 1120442 */   // Label 16457: @1120442
     /* 1120442 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1120519), // Rule ID 64305 //
     /* 1120447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120486 */     // MIs[0] policy
     /* 1120486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120518 */     // GIR_Coverage, 64305,
     /* 1120518 */     GIR_EraseRootFromParent_Done,
     /* 1120519 */   // Label 16458: @1120519
     /* 1120519 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1120596), // Rule ID 64306 //
     /* 1120524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120563 */     // MIs[0] policy
     /* 1120563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M2),
     /* 1120576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120595 */     // GIR_Coverage, 64306,
     /* 1120595 */     GIR_EraseRootFromParent_Done,
     /* 1120596 */   // Label 16459: @1120596
     /* 1120596 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1120673), // Rule ID 64307 //
     /* 1120601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120640 */     // MIs[0] policy
     /* 1120640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120672 */     // GIR_Coverage, 64307,
     /* 1120672 */     GIR_EraseRootFromParent_Done,
     /* 1120673 */   // Label 16460: @1120673
     /* 1120673 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1120750), // Rule ID 64308 //
     /* 1120678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120717 */     // MIs[0] policy
     /* 1120717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120727 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M4),
     /* 1120730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120749 */     // GIR_Coverage, 64308,
     /* 1120749 */     GIR_EraseRootFromParent_Done,
     /* 1120750 */   // Label 16461: @1120750
     /* 1120750 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1120827), // Rule ID 64309 //
     /* 1120755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120794 */     // MIs[0] policy
     /* 1120794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120826 */     // GIR_Coverage, 64309,
     /* 1120826 */     GIR_EraseRootFromParent_Done,
     /* 1120827 */   // Label 16462: @1120827
     /* 1120827 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1120904), // Rule ID 64310 //
     /* 1120832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120871 */     // MIs[0] policy
     /* 1120871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_2x8x2_M8),
     /* 1120884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120903 */     // GIR_Coverage, 64310,
     /* 1120903 */     GIR_EraseRootFromParent_Done,
     /* 1120904 */   // Label 16463: @1120904
     /* 1120904 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1120981), // Rule ID 64311 //
     /* 1120909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120948 */     // MIs[0] policy
     /* 1120948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1120961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120980 */     // GIR_Coverage, 64311,
     /* 1120980 */     GIR_EraseRootFromParent_Done,
     /* 1120981 */   // Label 16464: @1120981
     /* 1120981 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1121058), // Rule ID 64312 //
     /* 1120986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121025 */     // MIs[0] policy
     /* 1121025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M1),
     /* 1121038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121057 */     // GIR_Coverage, 64312,
     /* 1121057 */     GIR_EraseRootFromParent_Done,
     /* 1121058 */   // Label 16465: @1121058
     /* 1121058 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1121135), // Rule ID 64313 //
     /* 1121063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121102 */     // MIs[0] policy
     /* 1121102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1121115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121134 */     // GIR_Coverage, 64313,
     /* 1121134 */     GIR_EraseRootFromParent_Done,
     /* 1121135 */   // Label 16466: @1121135
     /* 1121135 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1121212), // Rule ID 64314 //
     /* 1121140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121179 */     // MIs[0] policy
     /* 1121179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121189 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M2),
     /* 1121192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121211 */     // GIR_Coverage, 64314,
     /* 1121211 */     GIR_EraseRootFromParent_Done,
     /* 1121212 */   // Label 16467: @1121212
     /* 1121212 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1121289), // Rule ID 64315 //
     /* 1121217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121256 */     // MIs[0] policy
     /* 1121256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1121269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121288 */     // GIR_Coverage, 64315,
     /* 1121288 */     GIR_EraseRootFromParent_Done,
     /* 1121289 */   // Label 16468: @1121289
     /* 1121289 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1121366), // Rule ID 64316 //
     /* 1121294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121333 */     // MIs[0] policy
     /* 1121333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121343 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M4),
     /* 1121346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121365 */     // GIR_Coverage, 64316,
     /* 1121365 */     GIR_EraseRootFromParent_Done,
     /* 1121366 */   // Label 16469: @1121366
     /* 1121366 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1121443), // Rule ID 64317 //
     /* 1121371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121410 */     // MIs[0] policy
     /* 1121410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1121423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121442 */     // GIR_Coverage, 64317,
     /* 1121442 */     GIR_EraseRootFromParent_Done,
     /* 1121443 */   // Label 16470: @1121443
     /* 1121443 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1121520), // Rule ID 64318 //
     /* 1121448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1121456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121487 */     // MIs[0] policy
     /* 1121487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121497 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_2x8x2_M8),
     /* 1121500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121519 */     // GIR_Coverage, 64318,
     /* 1121519 */     GIR_EraseRootFromParent_Done,
     /* 1121520 */   // Label 16471: @1121520
     /* 1121520 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1121597), // Rule ID 64319 //
     /* 1121525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121564 */     // MIs[0] policy
     /* 1121564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121596 */     // GIR_Coverage, 64319,
     /* 1121596 */     GIR_EraseRootFromParent_Done,
     /* 1121597 */   // Label 16472: @1121597
     /* 1121597 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1121674), // Rule ID 64320 //
     /* 1121602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121641 */     // MIs[0] policy
     /* 1121641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121651 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M1),
     /* 1121654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121673 */     // GIR_Coverage, 64320,
     /* 1121673 */     GIR_EraseRootFromParent_Done,
     /* 1121674 */   // Label 16473: @1121674
     /* 1121674 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1121751), // Rule ID 64321 //
     /* 1121679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121718 */     // MIs[0] policy
     /* 1121718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121750 */     // GIR_Coverage, 64321,
     /* 1121750 */     GIR_EraseRootFromParent_Done,
     /* 1121751 */   // Label 16474: @1121751
     /* 1121751 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1121828), // Rule ID 64322 //
     /* 1121756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121795 */     // MIs[0] policy
     /* 1121795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M2),
     /* 1121808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121827 */     // GIR_Coverage, 64322,
     /* 1121827 */     GIR_EraseRootFromParent_Done,
     /* 1121828 */   // Label 16475: @1121828
     /* 1121828 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1121905), // Rule ID 64323 //
     /* 1121833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121872 */     // MIs[0] policy
     /* 1121872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121904 */     // GIR_Coverage, 64323,
     /* 1121904 */     GIR_EraseRootFromParent_Done,
     /* 1121905 */   // Label 16476: @1121905
     /* 1121905 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1121982), // Rule ID 64324 //
     /* 1121910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121949 */     // MIs[0] policy
     /* 1121949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121959 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M4),
     /* 1121962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121981 */     // GIR_Coverage, 64324,
     /* 1121981 */     GIR_EraseRootFromParent_Done,
     /* 1121982 */   // Label 16477: @1121982
     /* 1121982 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1122059), // Rule ID 64325 //
     /* 1121987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122026 */     // MIs[0] policy
     /* 1122026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1122039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122058 */     // GIR_Coverage, 64325,
     /* 1122058 */     GIR_EraseRootFromParent_Done,
     /* 1122059 */   // Label 16478: @1122059
     /* 1122059 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1122136), // Rule ID 64326 //
     /* 1122064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1122067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1122072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122103 */     // MIs[0] policy
     /* 1122103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122113 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_2x8x2_M8),
     /* 1122116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122135 */     // GIR_Coverage, 64326,
     /* 1122135 */     GIR_EraseRootFromParent_Done,
     /* 1122136 */   // Label 16479: @1122136
     /* 1122136 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1122213), // Rule ID 64327 //
     /* 1122141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122180 */     // MIs[0] policy
     /* 1122180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1122193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122212 */     // GIR_Coverage, 64327,
     /* 1122212 */     GIR_EraseRootFromParent_Done,
     /* 1122213 */   // Label 16480: @1122213
     /* 1122213 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1122290), // Rule ID 64328 //
     /* 1122218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122257 */     // MIs[0] policy
     /* 1122257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122267 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_MF2),
     /* 1122270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122289 */     // GIR_Coverage, 64328,
     /* 1122289 */     GIR_EraseRootFromParent_Done,
     /* 1122290 */   // Label 16481: @1122290
     /* 1122290 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1122367), // Rule ID 64329 //
     /* 1122295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122334 */     // MIs[0] policy
     /* 1122334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1122347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122366 */     // GIR_Coverage, 64329,
     /* 1122366 */     GIR_EraseRootFromParent_Done,
     /* 1122367 */   // Label 16482: @1122367
     /* 1122367 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1122444), // Rule ID 64330 //
     /* 1122372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122411 */     // MIs[0] policy
     /* 1122411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M1),
     /* 1122424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122443 */     // GIR_Coverage, 64330,
     /* 1122443 */     GIR_EraseRootFromParent_Done,
     /* 1122444 */   // Label 16483: @1122444
     /* 1122444 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1122521), // Rule ID 64331 //
     /* 1122449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122488 */     // MIs[0] policy
     /* 1122488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122520 */     // GIR_Coverage, 64331,
     /* 1122520 */     GIR_EraseRootFromParent_Done,
     /* 1122521 */   // Label 16484: @1122521
     /* 1122521 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1122598), // Rule ID 64332 //
     /* 1122526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122565 */     // MIs[0] policy
     /* 1122565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M2),
     /* 1122578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122597 */     // GIR_Coverage, 64332,
     /* 1122597 */     GIR_EraseRootFromParent_Done,
     /* 1122598 */   // Label 16485: @1122598
     /* 1122598 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1122675), // Rule ID 64333 //
     /* 1122603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122642 */     // MIs[0] policy
     /* 1122642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122674 */     // GIR_Coverage, 64333,
     /* 1122674 */     GIR_EraseRootFromParent_Done,
     /* 1122675 */   // Label 16486: @1122675
     /* 1122675 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1122752), // Rule ID 64334 //
     /* 1122680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122719 */     // MIs[0] policy
     /* 1122719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCU_4x8x4_M4),
     /* 1122732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122751 */     // GIR_Coverage, 64334,
     /* 1122751 */     GIR_EraseRootFromParent_Done,
     /* 1122752 */   // Label 16487: @1122752
     /* 1122752 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1122829), // Rule ID 64335 //
     /* 1122757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122796 */     // MIs[0] policy
     /* 1122796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122828 */     // GIR_Coverage, 64335,
     /* 1122828 */     GIR_EraseRootFromParent_Done,
     /* 1122829 */   // Label 16488: @1122829
     /* 1122829 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1122906), // Rule ID 64336 //
     /* 1122834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122873 */     // MIs[0] policy
     /* 1122873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_MF2),
     /* 1122886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122905 */     // GIR_Coverage, 64336,
     /* 1122905 */     GIR_EraseRootFromParent_Done,
     /* 1122906 */   // Label 16489: @1122906
     /* 1122906 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1122983), // Rule ID 64337 //
     /* 1122911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122950 */     // MIs[0] policy
     /* 1122950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1122963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122982 */     // GIR_Coverage, 64337,
     /* 1122982 */     GIR_EraseRootFromParent_Done,
     /* 1122983 */   // Label 16490: @1122983
     /* 1122983 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1123060), // Rule ID 64338 //
     /* 1122988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123027 */     // MIs[0] policy
     /* 1123027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M1),
     /* 1123040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123059 */     // GIR_Coverage, 64338,
     /* 1123059 */     GIR_EraseRootFromParent_Done,
     /* 1123060 */   // Label 16491: @1123060
     /* 1123060 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1123137), // Rule ID 64339 //
     /* 1123065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123104 */     // MIs[0] policy
     /* 1123104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1123117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123136 */     // GIR_Coverage, 64339,
     /* 1123136 */     GIR_EraseRootFromParent_Done,
     /* 1123137 */   // Label 16492: @1123137
     /* 1123137 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1123214), // Rule ID 64340 //
     /* 1123142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123181 */     // MIs[0] policy
     /* 1123181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M2),
     /* 1123194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123213 */     // GIR_Coverage, 64340,
     /* 1123213 */     GIR_EraseRootFromParent_Done,
     /* 1123214 */   // Label 16493: @1123214
     /* 1123214 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1123291), // Rule ID 64341 //
     /* 1123219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123258 */     // MIs[0] policy
     /* 1123258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1123271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123290 */     // GIR_Coverage, 64341,
     /* 1123290 */     GIR_EraseRootFromParent_Done,
     /* 1123291 */   // Label 16494: @1123291
     /* 1123291 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1123368), // Rule ID 64342 //
     /* 1123296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1123304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123335 */     // MIs[0] policy
     /* 1123335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123345 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACC_4x8x4_M4),
     /* 1123348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123367 */     // GIR_Coverage, 64342,
     /* 1123367 */     GIR_EraseRootFromParent_Done,
     /* 1123368 */   // Label 16495: @1123368
     /* 1123368 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1123445), // Rule ID 64343 //
     /* 1123373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123412 */     // MIs[0] policy
     /* 1123412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1123425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123444 */     // GIR_Coverage, 64343,
     /* 1123444 */     GIR_EraseRootFromParent_Done,
     /* 1123445 */   // Label 16496: @1123445
     /* 1123445 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1123522), // Rule ID 64344 //
     /* 1123450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123489 */     // MIs[0] policy
     /* 1123489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_MF2),
     /* 1123502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123521 */     // GIR_Coverage, 64344,
     /* 1123521 */     GIR_EraseRootFromParent_Done,
     /* 1123522 */   // Label 16497: @1123522
     /* 1123522 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1123599), // Rule ID 64345 //
     /* 1123527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123566 */     // MIs[0] policy
     /* 1123566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123598 */     // GIR_Coverage, 64345,
     /* 1123598 */     GIR_EraseRootFromParent_Done,
     /* 1123599 */   // Label 16498: @1123599
     /* 1123599 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1123676), // Rule ID 64346 //
     /* 1123604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123643 */     // MIs[0] policy
     /* 1123643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123653 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M1),
     /* 1123656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123675 */     // GIR_Coverage, 64346,
     /* 1123675 */     GIR_EraseRootFromParent_Done,
     /* 1123676 */   // Label 16499: @1123676
     /* 1123676 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1123753), // Rule ID 64347 //
     /* 1123681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123720 */     // MIs[0] policy
     /* 1123720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123730 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123752 */     // GIR_Coverage, 64347,
     /* 1123752 */     GIR_EraseRootFromParent_Done,
     /* 1123753 */   // Label 16500: @1123753
     /* 1123753 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1123830), // Rule ID 64348 //
     /* 1123758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123797 */     // MIs[0] policy
     /* 1123797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123807 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M2),
     /* 1123810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123829 */     // GIR_Coverage, 64348,
     /* 1123829 */     GIR_EraseRootFromParent_Done,
     /* 1123830 */   // Label 16501: @1123830
     /* 1123830 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1123907), // Rule ID 64349 //
     /* 1123835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123874 */     // MIs[0] policy
     /* 1123874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123906 */     // GIR_Coverage, 64349,
     /* 1123906 */     GIR_EraseRootFromParent_Done,
     /* 1123907 */   // Label 16502: @1123907
     /* 1123907 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1123984), // Rule ID 64350 //
     /* 1123912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123951 */     // MIs[0] policy
     /* 1123951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123961 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCUS_4x8x4_M4),
     /* 1123964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123983 */     // GIR_Coverage, 64350,
     /* 1123983 */     GIR_EraseRootFromParent_Done,
     /* 1123984 */   // Label 16503: @1123984
     /* 1123984 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1124061), // Rule ID 64351 //
     /* 1123989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124028 */     // MIs[0] policy
     /* 1124028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1124041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124060 */     // GIR_Coverage, 64351,
     /* 1124060 */     GIR_EraseRootFromParent_Done,
     /* 1124061 */   // Label 16504: @1124061
     /* 1124061 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1124138), // Rule ID 64352 //
     /* 1124066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124105 */     // MIs[0] policy
     /* 1124105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124115 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_MF2),
     /* 1124118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124137 */     // GIR_Coverage, 64352,
     /* 1124137 */     GIR_EraseRootFromParent_Done,
     /* 1124138 */   // Label 16505: @1124138
     /* 1124138 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1124215), // Rule ID 64353 //
     /* 1124143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124182 */     // MIs[0] policy
     /* 1124182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1124195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124214 */     // GIR_Coverage, 64353,
     /* 1124214 */     GIR_EraseRootFromParent_Done,
     /* 1124215 */   // Label 16506: @1124215
     /* 1124215 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1124292), // Rule ID 64354 //
     /* 1124220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124259 */     // MIs[0] policy
     /* 1124259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M1),
     /* 1124272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124291 */     // GIR_Coverage, 64354,
     /* 1124291 */     GIR_EraseRootFromParent_Done,
     /* 1124292 */   // Label 16507: @1124292
     /* 1124292 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1124369), // Rule ID 64355 //
     /* 1124297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124336 */     // MIs[0] policy
     /* 1124336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1124349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124368 */     // GIR_Coverage, 64355,
     /* 1124368 */     GIR_EraseRootFromParent_Done,
     /* 1124369 */   // Label 16508: @1124369
     /* 1124369 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1124446), // Rule ID 64356 //
     /* 1124374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124413 */     // MIs[0] policy
     /* 1124413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124423 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M2),
     /* 1124426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124445 */     // GIR_Coverage, 64356,
     /* 1124445 */     GIR_EraseRootFromParent_Done,
     /* 1124446 */   // Label 16509: @1124446
     /* 1124446 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1124523), // Rule ID 64357 //
     /* 1124451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1124454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124490 */     // MIs[0] policy
     /* 1124490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124522 */     // GIR_Coverage, 64357,
     /* 1124522 */     GIR_EraseRootFromParent_Done,
     /* 1124523 */   // Label 16510: @1124523
     /* 1124523 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1124600), // Rule ID 64358 //
     /* 1124528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124567 */     // MIs[0] policy
     /* 1124567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124577 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VQMACCSU_4x8x4_M4),
     /* 1124580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124599 */     // GIR_Coverage, 64358,
     /* 1124599 */     GIR_EraseRootFromParent_Done,
     /* 1124600 */   // Label 16511: @1124600
     /* 1124600 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1124677), // Rule ID 65232 //
     /* 1124605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124644 */     // MIs[0] policy
     /* 1124644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124676 */     // GIR_Coverage, 65232,
     /* 1124676 */     GIR_EraseRootFromParent_Done,
     /* 1124677 */   // Label 16512: @1124677
     /* 1124677 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1124754), // Rule ID 65233 //
     /* 1124682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124721 */     // MIs[0] policy
     /* 1124721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124731 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124753 */     // GIR_Coverage, 65233,
     /* 1124753 */     GIR_EraseRootFromParent_Done,
     /* 1124754 */   // Label 16513: @1124754
     /* 1124754 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1124831), // Rule ID 65236 //
     /* 1124759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124798 */     // MIs[0] policy
     /* 1124798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124830 */     // GIR_Coverage, 65236,
     /* 1124830 */     GIR_EraseRootFromParent_Done,
     /* 1124831 */   // Label 16514: @1124831
     /* 1124831 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1124908), // Rule ID 65237 //
     /* 1124836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124875 */     // MIs[0] policy
     /* 1124875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124885 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124907 */     // GIR_Coverage, 65237,
     /* 1124907 */     GIR_EraseRootFromParent_Done,
     /* 1124908 */   // Label 16515: @1124908
     /* 1124908 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1124985), // Rule ID 65240 //
     /* 1124913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124952 */     // MIs[0] policy
     /* 1124952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124984 */     // GIR_Coverage, 65240,
     /* 1124984 */     GIR_EraseRootFromParent_Done,
     /* 1124985 */   // Label 16516: @1124985
     /* 1124985 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1125062), // Rule ID 65241 //
     /* 1124990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125029 */     // MIs[0] policy
     /* 1125029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125061 */     // GIR_Coverage, 65241,
     /* 1125061 */     GIR_EraseRootFromParent_Done,
     /* 1125062 */   // Label 16517: @1125062
     /* 1125062 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1125139), // Rule ID 65244 //
     /* 1125067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125106 */     // MIs[0] policy
     /* 1125106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125138 */     // GIR_Coverage, 65244,
     /* 1125138 */     GIR_EraseRootFromParent_Done,
     /* 1125139 */   // Label 16518: @1125139
     /* 1125139 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1125216), // Rule ID 65245 //
     /* 1125144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125183 */     // MIs[0] policy
     /* 1125183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125215 */     // GIR_Coverage, 65245,
     /* 1125215 */     GIR_EraseRootFromParent_Done,
     /* 1125216 */   // Label 16519: @1125216
     /* 1125216 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1125293), // Rule ID 65248 //
     /* 1125221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125260 */     // MIs[0] policy
     /* 1125260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125292 */     // GIR_Coverage, 65248,
     /* 1125292 */     GIR_EraseRootFromParent_Done,
     /* 1125293 */   // Label 16520: @1125293
     /* 1125293 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1125370), // Rule ID 65249 //
     /* 1125298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125337 */     // MIs[0] policy
     /* 1125337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125347 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125369 */     // GIR_Coverage, 65249,
     /* 1125369 */     GIR_EraseRootFromParent_Done,
     /* 1125370 */   // Label 16521: @1125370
     /* 1125370 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1125447), // Rule ID 65252 //
     /* 1125375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125414 */     // MIs[0] policy
     /* 1125414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125446 */     // GIR_Coverage, 65252,
     /* 1125446 */     GIR_EraseRootFromParent_Done,
     /* 1125447 */   // Label 16522: @1125447
     /* 1125447 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1125524), // Rule ID 65253 //
     /* 1125452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125491 */     // MIs[0] policy
     /* 1125491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125501 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125523 */     // GIR_Coverage, 65253,
     /* 1125523 */     GIR_EraseRootFromParent_Done,
     /* 1125524 */   // Label 16523: @1125524
     /* 1125524 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1125601), // Rule ID 65256 //
     /* 1125529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125568 */     // MIs[0] policy
     /* 1125568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125600 */     // GIR_Coverage, 65256,
     /* 1125600 */     GIR_EraseRootFromParent_Done,
     /* 1125601 */   // Label 16524: @1125601
     /* 1125601 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1125678), // Rule ID 65257 //
     /* 1125606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125645 */     // MIs[0] policy
     /* 1125645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125677 */     // GIR_Coverage, 65257,
     /* 1125677 */     GIR_EraseRootFromParent_Done,
     /* 1125678 */   // Label 16525: @1125678
     /* 1125678 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1125755), // Rule ID 65260 //
     /* 1125683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125722 */     // MIs[0] policy
     /* 1125722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125754 */     // GIR_Coverage, 65260,
     /* 1125754 */     GIR_EraseRootFromParent_Done,
     /* 1125755 */   // Label 16526: @1125755
     /* 1125755 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1125832), // Rule ID 65261 //
     /* 1125760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125799 */     // MIs[0] policy
     /* 1125799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125809 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125831 */     // GIR_Coverage, 65261,
     /* 1125831 */     GIR_EraseRootFromParent_Done,
     /* 1125832 */   // Label 16527: @1125832
     /* 1125832 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1125909), // Rule ID 65264 //
     /* 1125837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125876 */     // MIs[0] policy
     /* 1125876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125908 */     // GIR_Coverage, 65264,
     /* 1125908 */     GIR_EraseRootFromParent_Done,
     /* 1125909 */   // Label 16528: @1125909
     /* 1125909 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1125986), // Rule ID 65265 //
     /* 1125914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125953 */     // MIs[0] policy
     /* 1125953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125963 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125985 */     // GIR_Coverage, 65265,
     /* 1125985 */     GIR_EraseRootFromParent_Done,
     /* 1125986 */   // Label 16529: @1125986
     /* 1125986 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1126063), // Rule ID 65268 //
     /* 1125991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126030 */     // MIs[0] policy
     /* 1126030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126040 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1126043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126062 */     // GIR_Coverage, 65268,
     /* 1126062 */     GIR_EraseRootFromParent_Done,
     /* 1126063 */   // Label 16530: @1126063
     /* 1126063 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1126140), // Rule ID 65269 //
     /* 1126068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126107 */     // MIs[0] policy
     /* 1126107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126117 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1126120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126139 */     // GIR_Coverage, 65269,
     /* 1126139 */     GIR_EraseRootFromParent_Done,
     /* 1126140 */   // Label 16531: @1126140
     /* 1126140 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1126217), // Rule ID 65272 //
     /* 1126145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126184 */     // MIs[0] policy
     /* 1126184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126216 */     // GIR_Coverage, 65272,
     /* 1126216 */     GIR_EraseRootFromParent_Done,
     /* 1126217 */   // Label 16532: @1126217
     /* 1126217 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1126294), // Rule ID 65273 //
     /* 1126222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126261 */     // MIs[0] policy
     /* 1126261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126293 */     // GIR_Coverage, 65273,
     /* 1126293 */     GIR_EraseRootFromParent_Done,
     /* 1126294 */   // Label 16533: @1126294
     /* 1126294 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1126371), // Rule ID 65276 //
     /* 1126299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1126316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126338 */     // MIs[0] policy
     /* 1126338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126370 */     // GIR_Coverage, 65276,
     /* 1126370 */     GIR_EraseRootFromParent_Done,
     /* 1126371 */   // Label 16534: @1126371
     /* 1126371 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1126448), // Rule ID 65277 //
     /* 1126376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1126393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126415 */     // MIs[0] policy
     /* 1126415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126447 */     // GIR_Coverage, 65277,
     /* 1126447 */     GIR_EraseRootFromParent_Done,
     /* 1126448 */   // Label 16535: @1126448
     /* 1126448 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1126525), // Rule ID 65280 //
     /* 1126453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126492 */     // MIs[0] policy
     /* 1126492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126524 */     // GIR_Coverage, 65280,
     /* 1126524 */     GIR_EraseRootFromParent_Done,
     /* 1126525 */   // Label 16536: @1126525
     /* 1126525 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1126602), // Rule ID 65281 //
     /* 1126530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126569 */     // MIs[0] policy
     /* 1126569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126579 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126601 */     // GIR_Coverage, 65281,
     /* 1126601 */     GIR_EraseRootFromParent_Done,
     /* 1126602 */   // Label 16537: @1126602
     /* 1126602 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1126679), // Rule ID 65284 //
     /* 1126607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126646 */     // MIs[0] policy
     /* 1126646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126678 */     // GIR_Coverage, 65284,
     /* 1126678 */     GIR_EraseRootFromParent_Done,
     /* 1126679 */   // Label 16538: @1126679
     /* 1126679 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1126756), // Rule ID 65285 //
     /* 1126684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126723 */     // MIs[0] policy
     /* 1126723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126733 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126755 */     // GIR_Coverage, 65285,
     /* 1126755 */     GIR_EraseRootFromParent_Done,
     /* 1126756 */   // Label 16539: @1126756
     /* 1126756 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1126833), // Rule ID 65288 //
     /* 1126761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126800 */     // MIs[0] policy
     /* 1126800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126832 */     // GIR_Coverage, 65288,
     /* 1126832 */     GIR_EraseRootFromParent_Done,
     /* 1126833 */   // Label 16540: @1126833
     /* 1126833 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1126910), // Rule ID 65289 //
     /* 1126838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126877 */     // MIs[0] policy
     /* 1126877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126887 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126909 */     // GIR_Coverage, 65289,
     /* 1126909 */     GIR_EraseRootFromParent_Done,
     /* 1126910 */   // Label 16541: @1126910
     /* 1126910 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1126987), // Rule ID 65292 //
     /* 1126915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126954 */     // MIs[0] policy
     /* 1126954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126986 */     // GIR_Coverage, 65292,
     /* 1126986 */     GIR_EraseRootFromParent_Done,
     /* 1126987 */   // Label 16542: @1126987
     /* 1126987 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1127064), // Rule ID 65293 //
     /* 1126992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127031 */     // MIs[0] policy
     /* 1127031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1127044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127063 */     // GIR_Coverage, 65293,
     /* 1127063 */     GIR_EraseRootFromParent_Done,
     /* 1127064 */   // Label 16543: @1127064
     /* 1127064 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1127141), // Rule ID 65296 //
     /* 1127069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1127089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127108 */     // MIs[0] policy
     /* 1127108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1127121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127140 */     // GIR_Coverage, 65296,
     /* 1127140 */     GIR_EraseRootFromParent_Done,
     /* 1127141 */   // Label 16544: @1127141
     /* 1127141 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1127218), // Rule ID 65297 //
     /* 1127146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1127163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1127166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127185 */     // MIs[0] policy
     /* 1127185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127195 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1127198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127217 */     // GIR_Coverage, 65297,
     /* 1127217 */     GIR_EraseRootFromParent_Done,
     /* 1127218 */   // Label 16545: @1127218
     /* 1127218 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1127295), // Rule ID 65300 //
     /* 1127223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1127240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1127243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127262 */     // MIs[0] policy
     /* 1127262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1127275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127294 */     // GIR_Coverage, 65300,
     /* 1127294 */     GIR_EraseRootFromParent_Done,
     /* 1127295 */   // Label 16546: @1127295
     /* 1127295 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1127372), // Rule ID 65301 //
     /* 1127300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1127308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1127317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1127320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127339 */     // MIs[0] policy
     /* 1127339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1127352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127371 */     // GIR_Coverage, 65301,
     /* 1127371 */     GIR_EraseRootFromParent_Done,
     /* 1127372 */   // Label 16547: @1127372
     /* 1127372 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1127449), // Rule ID 65304 //
     /* 1127377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127416 */     // MIs[0] policy
     /* 1127416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127448 */     // GIR_Coverage, 65304,
     /* 1127448 */     GIR_EraseRootFromParent_Done,
     /* 1127449 */   // Label 16548: @1127449
     /* 1127449 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1127526), // Rule ID 65305 //
     /* 1127454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1127465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127493 */     // MIs[0] policy
     /* 1127493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127503 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127525 */     // GIR_Coverage, 65305,
     /* 1127525 */     GIR_EraseRootFromParent_Done,
     /* 1127526 */   // Label 16549: @1127526
     /* 1127526 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1127603), // Rule ID 65308 //
     /* 1127531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127570 */     // MIs[0] policy
     /* 1127570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127602 */     // GIR_Coverage, 65308,
     /* 1127602 */     GIR_EraseRootFromParent_Done,
     /* 1127603 */   // Label 16550: @1127603
     /* 1127603 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1127680), // Rule ID 65309 //
     /* 1127608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127647 */     // MIs[0] policy
     /* 1127647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127657 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127679 */     // GIR_Coverage, 65309,
     /* 1127679 */     GIR_EraseRootFromParent_Done,
     /* 1127680 */   // Label 16551: @1127680
     /* 1127680 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1127757), // Rule ID 65312 //
     /* 1127685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127724 */     // MIs[0] policy
     /* 1127724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127756 */     // GIR_Coverage, 65312,
     /* 1127756 */     GIR_EraseRootFromParent_Done,
     /* 1127757 */   // Label 16552: @1127757
     /* 1127757 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1127834), // Rule ID 65313 //
     /* 1127762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127801 */     // MIs[0] policy
     /* 1127801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127833 */     // GIR_Coverage, 65313,
     /* 1127833 */     GIR_EraseRootFromParent_Done,
     /* 1127834 */   // Label 16553: @1127834
     /* 1127834 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1127911), // Rule ID 65316 //
     /* 1127839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127878 */     // MIs[0] policy
     /* 1127878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127910 */     // GIR_Coverage, 65316,
     /* 1127910 */     GIR_EraseRootFromParent_Done,
     /* 1127911 */   // Label 16554: @1127911
     /* 1127911 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1127988), // Rule ID 65317 //
     /* 1127916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127955 */     // MIs[0] policy
     /* 1127955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127965 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127987 */     // GIR_Coverage, 65317,
     /* 1127987 */     GIR_EraseRootFromParent_Done,
     /* 1127988 */   // Label 16555: @1127988
     /* 1127988 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1128065), // Rule ID 65320 //
     /* 1127993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128032 */     // MIs[0] policy
     /* 1128032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128064 */     // GIR_Coverage, 65320,
     /* 1128064 */     GIR_EraseRootFromParent_Done,
     /* 1128065 */   // Label 16556: @1128065
     /* 1128065 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1128142), // Rule ID 65321 //
     /* 1128070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1128081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1128084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1128087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1128090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128109 */     // MIs[0] policy
     /* 1128109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128119 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128141 */     // GIR_Coverage, 65321,
     /* 1128141 */     GIR_EraseRootFromParent_Done,
     /* 1128142 */   // Label 16557: @1128142
     /* 1128142 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1128219), // Rule ID 65324 //
     /* 1128147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128186 */     // MIs[0] policy
     /* 1128186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1128199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128218 */     // GIR_Coverage, 65324,
     /* 1128218 */     GIR_EraseRootFromParent_Done,
     /* 1128219 */   // Label 16558: @1128219
     /* 1128219 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1128296), // Rule ID 65325 //
     /* 1128224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128263 */     // MIs[0] policy
     /* 1128263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128273 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1128276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128295 */     // GIR_Coverage, 65325,
     /* 1128295 */     GIR_EraseRootFromParent_Done,
     /* 1128296 */   // Label 16559: @1128296
     /* 1128296 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1128373), // Rule ID 65328 //
     /* 1128301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1128321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128340 */     // MIs[0] policy
     /* 1128340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1128353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128372 */     // GIR_Coverage, 65328,
     /* 1128372 */     GIR_EraseRootFromParent_Done,
     /* 1128373 */   // Label 16560: @1128373
     /* 1128373 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1128450), // Rule ID 65329 //
     /* 1128378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1128389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1128392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1128395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1128398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1128417 */     // MIs[0] policy
     /* 1128417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1128430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128449 */     // GIR_Coverage, 65329,
     /* 1128449 */     GIR_EraseRootFromParent_Done,
     /* 1128450 */   // Label 16561: @1128450
     /* 1128450 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1128527), // Rule ID 65332 //
     /* 1128455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128494 */     // MIs[0] policy
     /* 1128494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128526 */     // GIR_Coverage, 65332,
     /* 1128526 */     GIR_EraseRootFromParent_Done,
     /* 1128527 */   // Label 16562: @1128527
     /* 1128527 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1128604), // Rule ID 65333 //
     /* 1128532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128571 */     // MIs[0] policy
     /* 1128571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128603 */     // GIR_Coverage, 65333,
     /* 1128603 */     GIR_EraseRootFromParent_Done,
     /* 1128604 */   // Label 16563: @1128604
     /* 1128604 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1128681), // Rule ID 65336 //
     /* 1128609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128648 */     // MIs[0] policy
     /* 1128648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128680 */     // GIR_Coverage, 65336,
     /* 1128680 */     GIR_EraseRootFromParent_Done,
     /* 1128681 */   // Label 16564: @1128681
     /* 1128681 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1128758), // Rule ID 65337 //
     /* 1128686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128725 */     // MIs[0] policy
     /* 1128725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128735 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128757 */     // GIR_Coverage, 65337,
     /* 1128757 */     GIR_EraseRootFromParent_Done,
     /* 1128758 */   // Label 16565: @1128758
     /* 1128758 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1128838), // Rule ID 2728 //
     /* 1128763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128802 */     // MIs[0] round
     /* 1128802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128837 */     // GIR_Coverage, 2728,
     /* 1128837 */     GIR_EraseRootFromParent_Done,
     /* 1128838 */   // Label 16566: @1128838
     /* 1128838 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1128918), // Rule ID 2729 //
     /* 1128843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128882 */     // MIs[0] round
     /* 1128882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128917 */     // GIR_Coverage, 2729,
     /* 1128917 */     GIR_EraseRootFromParent_Done,
     /* 1128918 */   // Label 16567: @1128918
     /* 1128918 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1128998), // Rule ID 2768 //
     /* 1128923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1128926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128962 */     // MIs[0] round
     /* 1128962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128972 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128997 */     // GIR_Coverage, 2768,
     /* 1128997 */     GIR_EraseRootFromParent_Done,
     /* 1128998 */   // Label 16568: @1128998
     /* 1128998 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1129078), // Rule ID 2769 //
     /* 1129003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1129006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1129011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129042 */     // MIs[0] round
     /* 1129042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129052 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1129055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129077 */     // GIR_Coverage, 2769,
     /* 1129077 */     GIR_EraseRootFromParent_Done,
     /* 1129078 */   // Label 16569: @1129078
     /* 1129078 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1129158), // Rule ID 2788 //
     /* 1129083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1129086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129122 */     // MIs[0] round
     /* 1129122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1129135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129157 */     // GIR_Coverage, 2788,
     /* 1129157 */     GIR_EraseRootFromParent_Done,
     /* 1129158 */   // Label 16570: @1129158
     /* 1129158 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1129238), // Rule ID 2789 //
     /* 1129163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1129166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1129171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129202 */     // MIs[0] round
     /* 1129202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129212 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1129215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1129219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129237 */     // GIR_Coverage, 2789,
     /* 1129237 */     GIR_EraseRootFromParent_Done,
     /* 1129238 */   // Label 16571: @1129238
     /* 1129238 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1129318), // Rule ID 14938 //
     /* 1129243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1129254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1129257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1129260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1129263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129282 */     // MIs[0] round
     /* 1129282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129317 */     // GIR_Coverage, 14938,
     /* 1129317 */     GIR_EraseRootFromParent_Done,
     /* 1129318 */   // Label 16572: @1129318
     /* 1129318 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1129398), // Rule ID 14939 //
     /* 1129323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1129334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1129337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1129340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1129343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129362 */     // MIs[0] round
     /* 1129362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129397 */     // GIR_Coverage, 14939,
     /* 1129397 */     GIR_EraseRootFromParent_Done,
     /* 1129398 */   // Label 16573: @1129398
     /* 1129398 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1129478), // Rule ID 14942 //
     /* 1129403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129442 */     // MIs[0] round
     /* 1129442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129477 */     // GIR_Coverage, 14942,
     /* 1129477 */     GIR_EraseRootFromParent_Done,
     /* 1129478 */   // Label 16574: @1129478
     /* 1129478 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1129558), // Rule ID 14943 //
     /* 1129483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129522 */     // MIs[0] round
     /* 1129522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129557 */     // GIR_Coverage, 14943,
     /* 1129557 */     GIR_EraseRootFromParent_Done,
     /* 1129558 */   // Label 16575: @1129558
     /* 1129558 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1129638), // Rule ID 14946 //
     /* 1129563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129602 */     // MIs[0] round
     /* 1129602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129612 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129637 */     // GIR_Coverage, 14946,
     /* 1129637 */     GIR_EraseRootFromParent_Done,
     /* 1129638 */   // Label 16576: @1129638
     /* 1129638 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1129718), // Rule ID 14947 //
     /* 1129643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129682 */     // MIs[0] round
     /* 1129682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129717 */     // GIR_Coverage, 14947,
     /* 1129717 */     GIR_EraseRootFromParent_Done,
     /* 1129718 */   // Label 16577: @1129718
     /* 1129718 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1129798), // Rule ID 14950 //
     /* 1129723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129762 */     // MIs[0] round
     /* 1129762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129797 */     // GIR_Coverage, 14950,
     /* 1129797 */     GIR_EraseRootFromParent_Done,
     /* 1129798 */   // Label 16578: @1129798
     /* 1129798 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1129878), // Rule ID 14951 //
     /* 1129803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129842 */     // MIs[0] round
     /* 1129842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129877 */     // GIR_Coverage, 14951,
     /* 1129877 */     GIR_EraseRootFromParent_Done,
     /* 1129878 */   // Label 16579: @1129878
     /* 1129878 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1129958), // Rule ID 14954 //
     /* 1129883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129922 */     // MIs[0] round
     /* 1129922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129957 */     // GIR_Coverage, 14954,
     /* 1129957 */     GIR_EraseRootFromParent_Done,
     /* 1129958 */   // Label 16580: @1129958
     /* 1129958 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1130038), // Rule ID 14955 //
     /* 1129963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130002 */     // MIs[0] round
     /* 1130002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1130015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130037 */     // GIR_Coverage, 14955,
     /* 1130037 */     GIR_EraseRootFromParent_Done,
     /* 1130038 */   // Label 16581: @1130038
     /* 1130038 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1130118), // Rule ID 14958 //
     /* 1130043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1130054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1130057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1130060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1130063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130082 */     // MIs[0] round
     /* 1130082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130117 */     // GIR_Coverage, 14958,
     /* 1130117 */     GIR_EraseRootFromParent_Done,
     /* 1130118 */   // Label 16582: @1130118
     /* 1130118 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1130198), // Rule ID 14959 //
     /* 1130123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1130134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1130137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1130140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1130143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130162 */     // MIs[0] round
     /* 1130162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130197 */     // GIR_Coverage, 14959,
     /* 1130197 */     GIR_EraseRootFromParent_Done,
     /* 1130198 */   // Label 16583: @1130198
     /* 1130198 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1130278), // Rule ID 14962 //
     /* 1130203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130242 */     // MIs[0] round
     /* 1130242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130277 */     // GIR_Coverage, 14962,
     /* 1130277 */     GIR_EraseRootFromParent_Done,
     /* 1130278 */   // Label 16584: @1130278
     /* 1130278 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1130358), // Rule ID 14963 //
     /* 1130283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1130294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1130297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1130300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1130303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130322 */     // MIs[0] round
     /* 1130322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130357 */     // GIR_Coverage, 14963,
     /* 1130357 */     GIR_EraseRootFromParent_Done,
     /* 1130358 */   // Label 16585: @1130358
     /* 1130358 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1130438), // Rule ID 14966 //
     /* 1130363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130402 */     // MIs[0] round
     /* 1130402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130437 */     // GIR_Coverage, 14966,
     /* 1130437 */     GIR_EraseRootFromParent_Done,
     /* 1130438 */   // Label 16586: @1130438
     /* 1130438 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1130518), // Rule ID 14967 //
     /* 1130443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1130454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1130457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1130460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1130463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130482 */     // MIs[0] round
     /* 1130482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130517 */     // GIR_Coverage, 14967,
     /* 1130517 */     GIR_EraseRootFromParent_Done,
     /* 1130518 */   // Label 16587: @1130518
     /* 1130518 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1130598), // Rule ID 14970 //
     /* 1130523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130562 */     // MIs[0] round
     /* 1130562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130597 */     // GIR_Coverage, 14970,
     /* 1130597 */     GIR_EraseRootFromParent_Done,
     /* 1130598 */   // Label 16588: @1130598
     /* 1130598 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1130678), // Rule ID 14971 //
     /* 1130603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130642 */     // MIs[0] round
     /* 1130642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130677 */     // GIR_Coverage, 14971,
     /* 1130677 */     GIR_EraseRootFromParent_Done,
     /* 1130678 */   // Label 16589: @1130678
     /* 1130678 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1130758), // Rule ID 14974 //
     /* 1130683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130722 */     // MIs[0] round
     /* 1130722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130757 */     // GIR_Coverage, 14974,
     /* 1130757 */     GIR_EraseRootFromParent_Done,
     /* 1130758 */   // Label 16590: @1130758
     /* 1130758 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1130838), // Rule ID 14975 //
     /* 1130763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130802 */     // MIs[0] round
     /* 1130802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130837 */     // GIR_Coverage, 14975,
     /* 1130837 */     GIR_EraseRootFromParent_Done,
     /* 1130838 */   // Label 16591: @1130838
     /* 1130838 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1130918), // Rule ID 14978 //
     /* 1130843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130882 */     // MIs[0] round
     /* 1130882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130917 */     // GIR_Coverage, 14978,
     /* 1130917 */     GIR_EraseRootFromParent_Done,
     /* 1130918 */   // Label 16592: @1130918
     /* 1130918 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1130998), // Rule ID 14979 //
     /* 1130923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130962 */     // MIs[0] round
     /* 1130962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130997 */     // GIR_Coverage, 14979,
     /* 1130997 */     GIR_EraseRootFromParent_Done,
     /* 1130998 */   // Label 16593: @1130998
     /* 1130998 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1131078), // Rule ID 14982 //
     /* 1131003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1131014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1131017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131042 */     // MIs[0] round
     /* 1131042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131077 */     // GIR_Coverage, 14982,
     /* 1131077 */     GIR_EraseRootFromParent_Done,
     /* 1131078 */   // Label 16594: @1131078
     /* 1131078 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1131158), // Rule ID 14983 //
     /* 1131083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1131094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1131097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1131100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1131103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131122 */     // MIs[0] round
     /* 1131122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131132 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131157 */     // GIR_Coverage, 14983,
     /* 1131157 */     GIR_EraseRootFromParent_Done,
     /* 1131158 */   // Label 16595: @1131158
     /* 1131158 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1131238), // Rule ID 14986 //
     /* 1131163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1131174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1131177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131202 */     // MIs[0] round
     /* 1131202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131237 */     // GIR_Coverage, 14986,
     /* 1131237 */     GIR_EraseRootFromParent_Done,
     /* 1131238 */   // Label 16596: @1131238
     /* 1131238 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1131318), // Rule ID 14987 //
     /* 1131243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1131254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1131257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1131260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1131263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131282 */     // MIs[0] round
     /* 1131282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131317 */     // GIR_Coverage, 14987,
     /* 1131317 */     GIR_EraseRootFromParent_Done,
     /* 1131318 */   // Label 16597: @1131318
     /* 1131318 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1131398), // Rule ID 14990 //
     /* 1131323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1131334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1131337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131362 */     // MIs[0] round
     /* 1131362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131372 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131397 */     // GIR_Coverage, 14990,
     /* 1131397 */     GIR_EraseRootFromParent_Done,
     /* 1131398 */   // Label 16598: @1131398
     /* 1131398 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1131478), // Rule ID 14991 //
     /* 1131403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1131414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1131417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1131420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1131423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131442 */     // MIs[0] round
     /* 1131442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131477 */     // GIR_Coverage, 14991,
     /* 1131477 */     GIR_EraseRootFromParent_Done,
     /* 1131478 */   // Label 16599: @1131478
     /* 1131478 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1131558), // Rule ID 14994 //
     /* 1131483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131522 */     // MIs[0] round
     /* 1131522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131557 */     // GIR_Coverage, 14994,
     /* 1131557 */     GIR_EraseRootFromParent_Done,
     /* 1131558 */   // Label 16600: @1131558
     /* 1131558 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1131638), // Rule ID 14995 //
     /* 1131563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131602 */     // MIs[0] round
     /* 1131602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131637 */     // GIR_Coverage, 14995,
     /* 1131637 */     GIR_EraseRootFromParent_Done,
     /* 1131638 */   // Label 16601: @1131638
     /* 1131638 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1131718), // Rule ID 14998 //
     /* 1131643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131682 */     // MIs[0] round
     /* 1131682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131717 */     // GIR_Coverage, 14998,
     /* 1131717 */     GIR_EraseRootFromParent_Done,
     /* 1131718 */   // Label 16602: @1131718
     /* 1131718 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1131798), // Rule ID 14999 //
     /* 1131723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131762 */     // MIs[0] round
     /* 1131762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131797 */     // GIR_Coverage, 14999,
     /* 1131797 */     GIR_EraseRootFromParent_Done,
     /* 1131798 */   // Label 16603: @1131798
     /* 1131798 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1131878), // Rule ID 15002 //
     /* 1131803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131842 */     // MIs[0] round
     /* 1131842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131877 */     // GIR_Coverage, 15002,
     /* 1131877 */     GIR_EraseRootFromParent_Done,
     /* 1131878 */   // Label 16604: @1131878
     /* 1131878 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1131958), // Rule ID 15003 //
     /* 1131883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131922 */     // MIs[0] round
     /* 1131922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131957 */     // GIR_Coverage, 15003,
     /* 1131957 */     GIR_EraseRootFromParent_Done,
     /* 1131958 */   // Label 16605: @1131958
     /* 1131958 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1132038), // Rule ID 15006 //
     /* 1131963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132002 */     // MIs[0] round
     /* 1132002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132037 */     // GIR_Coverage, 15006,
     /* 1132037 */     GIR_EraseRootFromParent_Done,
     /* 1132038 */   // Label 16606: @1132038
     /* 1132038 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1132118), // Rule ID 15007 //
     /* 1132043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1132054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1132057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1132060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1132063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132082 */     // MIs[0] round
     /* 1132082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132117 */     // GIR_Coverage, 15007,
     /* 1132117 */     GIR_EraseRootFromParent_Done,
     /* 1132118 */   // Label 16607: @1132118
     /* 1132118 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1132198), // Rule ID 15010 //
     /* 1132123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1132134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1132137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1132140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1132143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132162 */     // MIs[0] round
     /* 1132162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1132175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132197 */     // GIR_Coverage, 15010,
     /* 1132197 */     GIR_EraseRootFromParent_Done,
     /* 1132198 */   // Label 16608: @1132198
     /* 1132198 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1132278), // Rule ID 15011 //
     /* 1132203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1132214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1132217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1132220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1132223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132242 */     // MIs[0] round
     /* 1132242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1132255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132277 */     // GIR_Coverage, 15011,
     /* 1132277 */     GIR_EraseRootFromParent_Done,
     /* 1132278 */   // Label 16609: @1132278
     /* 1132278 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1132358), // Rule ID 15014 //
     /* 1132283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1132294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1132297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1132303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132322 */     // MIs[0] round
     /* 1132322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1132335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132357 */     // GIR_Coverage, 15014,
     /* 1132357 */     GIR_EraseRootFromParent_Done,
     /* 1132358 */   // Label 16610: @1132358
     /* 1132358 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1132438), // Rule ID 15015 //
     /* 1132363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1132374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1132377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1132380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1132383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132402 */     // MIs[0] round
     /* 1132402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1132415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132437 */     // GIR_Coverage, 15015,
     /* 1132437 */     GIR_EraseRootFromParent_Done,
     /* 1132438 */   // Label 16611: @1132438
     /* 1132438 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1132518), // Rule ID 15018 //
     /* 1132443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132482 */     // MIs[0] round
     /* 1132482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132517 */     // GIR_Coverage, 15018,
     /* 1132517 */     GIR_EraseRootFromParent_Done,
     /* 1132518 */   // Label 16612: @1132518
     /* 1132518 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1132598), // Rule ID 15019 //
     /* 1132523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132562 */     // MIs[0] round
     /* 1132562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132597 */     // GIR_Coverage, 15019,
     /* 1132597 */     GIR_EraseRootFromParent_Done,
     /* 1132598 */   // Label 16613: @1132598
     /* 1132598 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1132678), // Rule ID 15022 //
     /* 1132603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132642 */     // MIs[0] round
     /* 1132642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132677 */     // GIR_Coverage, 15022,
     /* 1132677 */     GIR_EraseRootFromParent_Done,
     /* 1132678 */   // Label 16614: @1132678
     /* 1132678 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1132758), // Rule ID 15023 //
     /* 1132683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132722 */     // MIs[0] round
     /* 1132722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132757 */     // GIR_Coverage, 15023,
     /* 1132757 */     GIR_EraseRootFromParent_Done,
     /* 1132758 */   // Label 16615: @1132758
     /* 1132758 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1132838), // Rule ID 15026 //
     /* 1132763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132802 */     // MIs[0] round
     /* 1132802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132837 */     // GIR_Coverage, 15026,
     /* 1132837 */     GIR_EraseRootFromParent_Done,
     /* 1132838 */   // Label 16616: @1132838
     /* 1132838 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1132918), // Rule ID 15027 //
     /* 1132843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132882 */     // MIs[0] round
     /* 1132882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132892 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132917 */     // GIR_Coverage, 15027,
     /* 1132917 */     GIR_EraseRootFromParent_Done,
     /* 1132918 */   // Label 16617: @1132918
     /* 1132918 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1132998), // Rule ID 15030 //
     /* 1132923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132962 */     // MIs[0] round
     /* 1132962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132972 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132997 */     // GIR_Coverage, 15030,
     /* 1132997 */     GIR_EraseRootFromParent_Done,
     /* 1132998 */   // Label 16618: @1132998
     /* 1132998 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1133078), // Rule ID 15031 //
     /* 1133003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1133014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1133017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1133020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133042 */     // MIs[0] round
     /* 1133042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133077 */     // GIR_Coverage, 15031,
     /* 1133077 */     GIR_EraseRootFromParent_Done,
     /* 1133078 */   // Label 16619: @1133078
     /* 1133078 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1133158), // Rule ID 15034 //
     /* 1133083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1133094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1133097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1133100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133122 */     // MIs[0] round
     /* 1133122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1133135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133157 */     // GIR_Coverage, 15034,
     /* 1133157 */     GIR_EraseRootFromParent_Done,
     /* 1133158 */   // Label 16620: @1133158
     /* 1133158 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1133238), // Rule ID 15035 //
     /* 1133163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1133174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1133177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1133180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133202 */     // MIs[0] round
     /* 1133202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1133215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133237 */     // GIR_Coverage, 15035,
     /* 1133237 */     GIR_EraseRootFromParent_Done,
     /* 1133238 */   // Label 16621: @1133238
     /* 1133238 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1133318), // Rule ID 15038 //
     /* 1133243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133282 */     // MIs[0] round
     /* 1133282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133317 */     // GIR_Coverage, 15038,
     /* 1133317 */     GIR_EraseRootFromParent_Done,
     /* 1133318 */   // Label 16622: @1133318
     /* 1133318 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1133398), // Rule ID 15039 //
     /* 1133323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1133334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1133337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1133340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133362 */     // MIs[0] round
     /* 1133362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133397 */     // GIR_Coverage, 15039,
     /* 1133397 */     GIR_EraseRootFromParent_Done,
     /* 1133398 */   // Label 16623: @1133398
     /* 1133398 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1133478), // Rule ID 15042 //
     /* 1133403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133442 */     // MIs[0] round
     /* 1133442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133477 */     // GIR_Coverage, 15042,
     /* 1133477 */     GIR_EraseRootFromParent_Done,
     /* 1133478 */   // Label 16624: @1133478
     /* 1133478 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1133558), // Rule ID 15043 //
     /* 1133483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133522 */     // MIs[0] round
     /* 1133522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133557 */     // GIR_Coverage, 15043,
     /* 1133557 */     GIR_EraseRootFromParent_Done,
     /* 1133558 */   // Label 16625: @1133558
     /* 1133558 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1133638), // Rule ID 15046 //
     /* 1133563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133602 */     // MIs[0] round
     /* 1133602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133637 */     // GIR_Coverage, 15046,
     /* 1133637 */     GIR_EraseRootFromParent_Done,
     /* 1133638 */   // Label 16626: @1133638
     /* 1133638 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1133718), // Rule ID 15047 //
     /* 1133643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133682 */     // MIs[0] round
     /* 1133682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11196:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133717 */     // GIR_Coverage, 15047,
     /* 1133717 */     GIR_EraseRootFromParent_Done,
     /* 1133718 */   // Label 16627: @1133718
     /* 1133718 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1133798), // Rule ID 15050 //
     /* 1133723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133762 */     // MIs[0] round
     /* 1133762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133797 */     // GIR_Coverage, 15050,
     /* 1133797 */     GIR_EraseRootFromParent_Done,
     /* 1133798 */   // Label 16628: @1133798
     /* 1133798 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1133878), // Rule ID 15051 //
     /* 1133803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133842 */     // MIs[0] round
     /* 1133842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133877 */     // GIR_Coverage, 15051,
     /* 1133877 */     GIR_EraseRootFromParent_Done,
     /* 1133878 */   // Label 16629: @1133878
     /* 1133878 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1133958), // Rule ID 15054 //
     /* 1133883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133922 */     // MIs[0] round
     /* 1133922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133957 */     // GIR_Coverage, 15054,
     /* 1133957 */     GIR_EraseRootFromParent_Done,
     /* 1133958 */   // Label 16630: @1133958
     /* 1133958 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1134038), // Rule ID 15055 //
     /* 1133963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134002 */     // MIs[0] round
     /* 1134002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134037 */     // GIR_Coverage, 15055,
     /* 1134037 */     GIR_EraseRootFromParent_Done,
     /* 1134038 */   // Label 16631: @1134038
     /* 1134038 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1134118), // Rule ID 15058 //
     /* 1134043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1134060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134082 */     // MIs[0] round
     /* 1134082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134117 */     // GIR_Coverage, 15058,
     /* 1134117 */     GIR_EraseRootFromParent_Done,
     /* 1134118 */   // Label 16632: @1134118
     /* 1134118 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1134198), // Rule ID 15059 //
     /* 1134123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1134134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1134137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1134140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134162 */     // MIs[0] round
     /* 1134162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1134175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134197 */     // GIR_Coverage, 15059,
     /* 1134197 */     GIR_EraseRootFromParent_Done,
     /* 1134198 */   // Label 16633: @1134198
     /* 1134198 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1134278), // Rule ID 15062 //
     /* 1134203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134242 */     // MIs[0] round
     /* 1134242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134277 */     // GIR_Coverage, 15062,
     /* 1134277 */     GIR_EraseRootFromParent_Done,
     /* 1134278 */   // Label 16634: @1134278
     /* 1134278 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1134358), // Rule ID 15063 //
     /* 1134283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1134294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1134297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1134300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134322 */     // MIs[0] round
     /* 1134322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134357 */     // GIR_Coverage, 15063,
     /* 1134357 */     GIR_EraseRootFromParent_Done,
     /* 1134358 */   // Label 16635: @1134358
     /* 1134358 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1134438), // Rule ID 15066 //
     /* 1134363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134402 */     // MIs[0] round
     /* 1134402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134412 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134437 */     // GIR_Coverage, 15066,
     /* 1134437 */     GIR_EraseRootFromParent_Done,
     /* 1134438 */   // Label 16636: @1134438
     /* 1134438 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1134518), // Rule ID 15067 //
     /* 1134443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1134454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1134457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1134460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134482 */     // MIs[0] round
     /* 1134482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134517 */     // GIR_Coverage, 15067,
     /* 1134517 */     GIR_EraseRootFromParent_Done,
     /* 1134518 */   // Label 16637: @1134518
     /* 1134518 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1134598), // Rule ID 15070 //
     /* 1134523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134562 */     // MIs[0] round
     /* 1134562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134572 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134597 */     // GIR_Coverage, 15070,
     /* 1134597 */     GIR_EraseRootFromParent_Done,
     /* 1134598 */   // Label 16638: @1134598
     /* 1134598 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1134678), // Rule ID 15071 //
     /* 1134603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134642 */     // MIs[0] round
     /* 1134642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134677 */     // GIR_Coverage, 15071,
     /* 1134677 */     GIR_EraseRootFromParent_Done,
     /* 1134678 */   // Label 16639: @1134678
     /* 1134678 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1134758), // Rule ID 15074 //
     /* 1134683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134722 */     // MIs[0] round
     /* 1134722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134757 */     // GIR_Coverage, 15074,
     /* 1134757 */     GIR_EraseRootFromParent_Done,
     /* 1134758 */   // Label 16640: @1134758
     /* 1134758 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1134838), // Rule ID 15075 //
     /* 1134763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134802 */     // MIs[0] round
     /* 1134802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134837 */     // GIR_Coverage, 15075,
     /* 1134837 */     GIR_EraseRootFromParent_Done,
     /* 1134838 */   // Label 16641: @1134838
     /* 1134838 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1134918), // Rule ID 15078 //
     /* 1134843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134882 */     // MIs[0] round
     /* 1134882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134917 */     // GIR_Coverage, 15078,
     /* 1134917 */     GIR_EraseRootFromParent_Done,
     /* 1134918 */   // Label 16642: @1134918
     /* 1134918 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1134998), // Rule ID 15079 //
     /* 1134923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134962 */     // MIs[0] round
     /* 1134962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134997 */     // GIR_Coverage, 15079,
     /* 1134997 */     GIR_EraseRootFromParent_Done,
     /* 1134998 */   // Label 16643: @1134998
     /* 1134998 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1135078), // Rule ID 15082 //
     /* 1135003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1135014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1135017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135042 */     // MIs[0] round
     /* 1135042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135052 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135077 */     // GIR_Coverage, 15082,
     /* 1135077 */     GIR_EraseRootFromParent_Done,
     /* 1135078 */   // Label 16644: @1135078
     /* 1135078 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1135158), // Rule ID 15083 //
     /* 1135083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1135094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1135097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1135100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135122 */     // MIs[0] round
     /* 1135122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135157 */     // GIR_Coverage, 15083,
     /* 1135157 */     GIR_EraseRootFromParent_Done,
     /* 1135158 */   // Label 16645: @1135158
     /* 1135158 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1135238), // Rule ID 15086 //
     /* 1135163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135202 */     // MIs[0] round
     /* 1135202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135237 */     // GIR_Coverage, 15086,
     /* 1135237 */     GIR_EraseRootFromParent_Done,
     /* 1135238 */   // Label 16646: @1135238
     /* 1135238 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1135318), // Rule ID 15087 //
     /* 1135243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1135254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1135257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1135260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135282 */     // MIs[0] round
     /* 1135282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135317 */     // GIR_Coverage, 15087,
     /* 1135317 */     GIR_EraseRootFromParent_Done,
     /* 1135318 */   // Label 16647: @1135318
     /* 1135318 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1135398), // Rule ID 15090 //
     /* 1135323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135362 */     // MIs[0] round
     /* 1135362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135397 */     // GIR_Coverage, 15090,
     /* 1135397 */     GIR_EraseRootFromParent_Done,
     /* 1135398 */   // Label 16648: @1135398
     /* 1135398 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1135478), // Rule ID 15091 //
     /* 1135403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1135414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1135417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1135420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135442 */     // MIs[0] round
     /* 1135442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135477 */     // GIR_Coverage, 15091,
     /* 1135477 */     GIR_EraseRootFromParent_Done,
     /* 1135478 */   // Label 16649: @1135478
     /* 1135478 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1135558), // Rule ID 15094 //
     /* 1135483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135522 */     // MIs[0] round
     /* 1135522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135557 */     // GIR_Coverage, 15094,
     /* 1135557 */     GIR_EraseRootFromParent_Done,
     /* 1135558 */   // Label 16650: @1135558
     /* 1135558 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1135638), // Rule ID 15095 //
     /* 1135563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135602 */     // MIs[0] round
     /* 1135602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135637 */     // GIR_Coverage, 15095,
     /* 1135637 */     GIR_EraseRootFromParent_Done,
     /* 1135638 */   // Label 16651: @1135638
     /* 1135638 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1135718), // Rule ID 15098 //
     /* 1135643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135682 */     // MIs[0] round
     /* 1135682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135717 */     // GIR_Coverage, 15098,
     /* 1135717 */     GIR_EraseRootFromParent_Done,
     /* 1135718 */   // Label 16652: @1135718
     /* 1135718 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1135798), // Rule ID 15099 //
     /* 1135723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135762 */     // MIs[0] round
     /* 1135762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135797 */     // GIR_Coverage, 15099,
     /* 1135797 */     GIR_EraseRootFromParent_Done,
     /* 1135798 */   // Label 16653: @1135798
     /* 1135798 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1135878), // Rule ID 15102 //
     /* 1135803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135842 */     // MIs[0] round
     /* 1135842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135877 */     // GIR_Coverage, 15102,
     /* 1135877 */     GIR_EraseRootFromParent_Done,
     /* 1135878 */   // Label 16654: @1135878
     /* 1135878 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1135958), // Rule ID 15103 //
     /* 1135883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135922 */     // MIs[0] round
     /* 1135922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135957 */     // GIR_Coverage, 15103,
     /* 1135957 */     GIR_EraseRootFromParent_Done,
     /* 1135958 */   // Label 16655: @1135958
     /* 1135958 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1136038), // Rule ID 15106 //
     /* 1135963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136002 */     // MIs[0] round
     /* 1136002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1136015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136037 */     // GIR_Coverage, 15106,
     /* 1136037 */     GIR_EraseRootFromParent_Done,
     /* 1136038 */   // Label 16656: @1136038
     /* 1136038 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1136118), // Rule ID 15107 //
     /* 1136043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1136046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1136051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1136054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1136057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1136060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136082 */     // MIs[0] round
     /* 1136082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136092 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1136095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136117 */     // GIR_Coverage, 15107,
     /* 1136117 */     GIR_EraseRootFromParent_Done,
     /* 1136118 */   // Label 16657: @1136118
     /* 1136118 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1136198), // Rule ID 15110 //
     /* 1136123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1136140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1136143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136162 */     // MIs[0] round
     /* 1136162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136172 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1136175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136197 */     // GIR_Coverage, 15110,
     /* 1136197 */     GIR_EraseRootFromParent_Done,
     /* 1136198 */   // Label 16658: @1136198
     /* 1136198 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1136278), // Rule ID 15111 //
     /* 1136203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1136214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1136217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1136220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1136223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136242 */     // MIs[0] round
     /* 1136242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1136255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136277 */     // GIR_Coverage, 15111,
     /* 1136277 */     GIR_EraseRootFromParent_Done,
     /* 1136278 */   // Label 16659: @1136278
     /* 1136278 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1136358), // Rule ID 15114 //
     /* 1136283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1136303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136322 */     // MIs[0] round
     /* 1136322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136357 */     // GIR_Coverage, 15114,
     /* 1136357 */     GIR_EraseRootFromParent_Done,
     /* 1136358 */   // Label 16660: @1136358
     /* 1136358 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1136438), // Rule ID 15115 //
     /* 1136363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1136374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1136377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1136380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1136383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136402 */     // MIs[0] round
     /* 1136402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136437 */     // GIR_Coverage, 15115,
     /* 1136437 */     GIR_EraseRootFromParent_Done,
     /* 1136438 */   // Label 16661: @1136438
     /* 1136438 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1136518), // Rule ID 15118 //
     /* 1136443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136482 */     // MIs[0] round
     /* 1136482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136517 */     // GIR_Coverage, 15118,
     /* 1136517 */     GIR_EraseRootFromParent_Done,
     /* 1136518 */   // Label 16662: @1136518
     /* 1136518 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1136598), // Rule ID 15119 //
     /* 1136523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136562 */     // MIs[0] round
     /* 1136562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136572 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136597 */     // GIR_Coverage, 15119,
     /* 1136597 */     GIR_EraseRootFromParent_Done,
     /* 1136598 */   // Label 16663: @1136598
     /* 1136598 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1136678), // Rule ID 15122 //
     /* 1136603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136642 */     // MIs[0] round
     /* 1136642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136677 */     // GIR_Coverage, 15122,
     /* 1136677 */     GIR_EraseRootFromParent_Done,
     /* 1136678 */   // Label 16664: @1136678
     /* 1136678 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1136758), // Rule ID 15123 //
     /* 1136683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136722 */     // MIs[0] round
     /* 1136722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136757 */     // GIR_Coverage, 15123,
     /* 1136757 */     GIR_EraseRootFromParent_Done,
     /* 1136758 */   // Label 16665: @1136758
     /* 1136758 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1136838), // Rule ID 15126 //
     /* 1136763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136802 */     // MIs[0] round
     /* 1136802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136812 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136837 */     // GIR_Coverage, 15126,
     /* 1136837 */     GIR_EraseRootFromParent_Done,
     /* 1136838 */   // Label 16666: @1136838
     /* 1136838 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1136918), // Rule ID 15127 //
     /* 1136843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136882 */     // MIs[0] round
     /* 1136882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136892 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136917 */     // GIR_Coverage, 15127,
     /* 1136917 */     GIR_EraseRootFromParent_Done,
     /* 1136918 */   // Label 16667: @1136918
     /* 1136918 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1136998), // Rule ID 15130 //
     /* 1136923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136962 */     // MIs[0] round
     /* 1136962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136997 */     // GIR_Coverage, 15130,
     /* 1136997 */     GIR_EraseRootFromParent_Done,
     /* 1136998 */   // Label 16668: @1136998
     /* 1136998 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1137078), // Rule ID 15131 //
     /* 1137003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1137014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1137017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1137020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1137023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137042 */     // MIs[0] round
     /* 1137042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1137055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137077 */     // GIR_Coverage, 15131,
     /* 1137077 */     GIR_EraseRootFromParent_Done,
     /* 1137078 */   // Label 16669: @1137078
     /* 1137078 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1137158), // Rule ID 15134 //
     /* 1137083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1137100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1137103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137122 */     // MIs[0] round
     /* 1137122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137157 */     // GIR_Coverage, 15134,
     /* 1137157 */     GIR_EraseRootFromParent_Done,
     /* 1137158 */   // Label 16670: @1137158
     /* 1137158 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1137238), // Rule ID 15135 //
     /* 1137163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1137174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1137177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1137180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1137183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137202 */     // MIs[0] round
     /* 1137202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137237 */     // GIR_Coverage, 15135,
     /* 1137237 */     GIR_EraseRootFromParent_Done,
     /* 1137238 */   // Label 16671: @1137238
     /* 1137238 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1137318), // Rule ID 15138 //
     /* 1137243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1137263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137282 */     // MIs[0] round
     /* 1137282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137317 */     // GIR_Coverage, 15138,
     /* 1137317 */     GIR_EraseRootFromParent_Done,
     /* 1137318 */   // Label 16672: @1137318
     /* 1137318 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1137398), // Rule ID 15139 //
     /* 1137323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1137334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1137337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1137340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1137343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137362 */     // MIs[0] round
     /* 1137362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137397 */     // GIR_Coverage, 15139,
     /* 1137397 */     GIR_EraseRootFromParent_Done,
     /* 1137398 */   // Label 16673: @1137398
     /* 1137398 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1137478), // Rule ID 15142 //
     /* 1137403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137442 */     // MIs[0] round
     /* 1137442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137477 */     // GIR_Coverage, 15142,
     /* 1137477 */     GIR_EraseRootFromParent_Done,
     /* 1137478 */   // Label 16674: @1137478
     /* 1137478 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1137558), // Rule ID 15143 //
     /* 1137483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137522 */     // MIs[0] round
     /* 1137522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137557 */     // GIR_Coverage, 15143,
     /* 1137557 */     GIR_EraseRootFromParent_Done,
     /* 1137558 */   // Label 16675: @1137558
     /* 1137558 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1137638), // Rule ID 15146 //
     /* 1137563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137602 */     // MIs[0] round
     /* 1137602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137637 */     // GIR_Coverage, 15146,
     /* 1137637 */     GIR_EraseRootFromParent_Done,
     /* 1137638 */   // Label 16676: @1137638
     /* 1137638 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1137718), // Rule ID 15147 //
     /* 1137643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137682 */     // MIs[0] round
     /* 1137682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137717 */     // GIR_Coverage, 15147,
     /* 1137717 */     GIR_EraseRootFromParent_Done,
     /* 1137718 */   // Label 16677: @1137718
     /* 1137718 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1137798), // Rule ID 15150 //
     /* 1137723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137762 */     // MIs[0] round
     /* 1137762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137797 */     // GIR_Coverage, 15150,
     /* 1137797 */     GIR_EraseRootFromParent_Done,
     /* 1137798 */   // Label 16678: @1137798
     /* 1137798 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1137878), // Rule ID 15151 //
     /* 1137803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137842 */     // MIs[0] round
     /* 1137842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137877 */     // GIR_Coverage, 15151,
     /* 1137877 */     GIR_EraseRootFromParent_Done,
     /* 1137878 */   // Label 16679: @1137878
     /* 1137878 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1137958), // Rule ID 15154 //
     /* 1137883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137922 */     // MIs[0] round
     /* 1137922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137932 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137957 */     // GIR_Coverage, 15154,
     /* 1137957 */     GIR_EraseRootFromParent_Done,
     /* 1137958 */   // Label 16680: @1137958
     /* 1137958 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1138038), // Rule ID 15155 //
     /* 1137963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138002 */     // MIs[0] round
     /* 1138002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138012 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138037 */     // GIR_Coverage, 15155,
     /* 1138037 */     GIR_EraseRootFromParent_Done,
     /* 1138038 */   // Label 16681: @1138038
     /* 1138038 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1138118), // Rule ID 15158 //
     /* 1138043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1138054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1138057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1138060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1138063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138082 */     // MIs[0] round
     /* 1138082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138117 */     // GIR_Coverage, 15158,
     /* 1138117 */     GIR_EraseRootFromParent_Done,
     /* 1138118 */   // Label 16682: @1138118
     /* 1138118 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1138198), // Rule ID 15159 //
     /* 1138123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1138134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1138137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1138140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1138143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138162 */     // MIs[0] round
     /* 1138162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138197 */     // GIR_Coverage, 15159,
     /* 1138197 */     GIR_EraseRootFromParent_Done,
     /* 1138198 */   // Label 16683: @1138198
     /* 1138198 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1138278), // Rule ID 15162 //
     /* 1138203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1138223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138242 */     // MIs[0] round
     /* 1138242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138277 */     // GIR_Coverage, 15162,
     /* 1138277 */     GIR_EraseRootFromParent_Done,
     /* 1138278 */   // Label 16684: @1138278
     /* 1138278 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1138358), // Rule ID 15163 //
     /* 1138283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1138294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1138297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1138300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1138303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138322 */     // MIs[0] round
     /* 1138322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138357 */     // GIR_Coverage, 15163,
     /* 1138357 */     GIR_EraseRootFromParent_Done,
     /* 1138358 */   // Label 16685: @1138358
     /* 1138358 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1138438), // Rule ID 15166 //
     /* 1138363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1138383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138402 */     // MIs[0] round
     /* 1138402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138437 */     // GIR_Coverage, 15166,
     /* 1138437 */     GIR_EraseRootFromParent_Done,
     /* 1138438 */   // Label 16686: @1138438
     /* 1138438 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1138518), // Rule ID 15167 //
     /* 1138443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1138454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1138457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1138460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1138463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138482 */     // MIs[0] round
     /* 1138482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138517 */     // GIR_Coverage, 15167,
     /* 1138517 */     GIR_EraseRootFromParent_Done,
     /* 1138518 */   // Label 16687: @1138518
     /* 1138518 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1138598), // Rule ID 15170 //
     /* 1138523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138562 */     // MIs[0] round
     /* 1138562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138597 */     // GIR_Coverage, 15170,
     /* 1138597 */     GIR_EraseRootFromParent_Done,
     /* 1138598 */   // Label 16688: @1138598
     /* 1138598 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1138678), // Rule ID 15171 //
     /* 1138603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138642 */     // MIs[0] round
     /* 1138642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138677 */     // GIR_Coverage, 15171,
     /* 1138677 */     GIR_EraseRootFromParent_Done,
     /* 1138678 */   // Label 16689: @1138678
     /* 1138678 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1138758), // Rule ID 15174 //
     /* 1138683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138722 */     // MIs[0] round
     /* 1138722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138757 */     // GIR_Coverage, 15174,
     /* 1138757 */     GIR_EraseRootFromParent_Done,
     /* 1138758 */   // Label 16690: @1138758
     /* 1138758 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1138838), // Rule ID 15175 //
     /* 1138763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138802 */     // MIs[0] round
     /* 1138802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138837 */     // GIR_Coverage, 15175,
     /* 1138837 */     GIR_EraseRootFromParent_Done,
     /* 1138838 */   // Label 16691: @1138838
     /* 1138838 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1138918), // Rule ID 15178 //
     /* 1138843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138882 */     // MIs[0] round
     /* 1138882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138917 */     // GIR_Coverage, 15178,
     /* 1138917 */     GIR_EraseRootFromParent_Done,
     /* 1138918 */   // Label 16692: @1138918
     /* 1138918 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1138998), // Rule ID 15179 //
     /* 1138923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138962 */     // MIs[0] round
     /* 1138962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138997 */     // GIR_Coverage, 15179,
     /* 1138997 */     GIR_EraseRootFromParent_Done,
     /* 1138998 */   // Label 16693: @1138998
     /* 1138998 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1139078), // Rule ID 15182 //
     /* 1139003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1139014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1139017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1139020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1139023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139042 */     // MIs[0] round
     /* 1139042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139077 */     // GIR_Coverage, 15182,
     /* 1139077 */     GIR_EraseRootFromParent_Done,
     /* 1139078 */   // Label 16694: @1139078
     /* 1139078 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1139158), // Rule ID 15183 //
     /* 1139083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1139094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1139097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1139100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1139103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139122 */     // MIs[0] round
     /* 1139122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139132 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139157 */     // GIR_Coverage, 15183,
     /* 1139157 */     GIR_EraseRootFromParent_Done,
     /* 1139158 */   // Label 16695: @1139158
     /* 1139158 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1139238), // Rule ID 15186 //
     /* 1139163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1139183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139202 */     // MIs[0] round
     /* 1139202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1139215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139237 */     // GIR_Coverage, 15186,
     /* 1139237 */     GIR_EraseRootFromParent_Done,
     /* 1139238 */   // Label 16696: @1139238
     /* 1139238 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1139318), // Rule ID 15187 //
     /* 1139243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1139254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1139257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1139260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1139263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139282 */     // MIs[0] round
     /* 1139282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1139295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139317 */     // GIR_Coverage, 15187,
     /* 1139317 */     GIR_EraseRootFromParent_Done,
     /* 1139318 */   // Label 16697: @1139318
     /* 1139318 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1139398), // Rule ID 15190 //
     /* 1139323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1139343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139362 */     // MIs[0] round
     /* 1139362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1139375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139397 */     // GIR_Coverage, 15190,
     /* 1139397 */     GIR_EraseRootFromParent_Done,
     /* 1139398 */   // Label 16698: @1139398
     /* 1139398 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1139478), // Rule ID 15191 //
     /* 1139403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1139414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1139417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1139420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1139423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139442 */     // MIs[0] round
     /* 1139442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1139455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139477 */     // GIR_Coverage, 15191,
     /* 1139477 */     GIR_EraseRootFromParent_Done,
     /* 1139478 */   // Label 16699: @1139478
     /* 1139478 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1139558), // Rule ID 15194 //
     /* 1139483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139522 */     // MIs[0] round
     /* 1139522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139532 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139557 */     // GIR_Coverage, 15194,
     /* 1139557 */     GIR_EraseRootFromParent_Done,
     /* 1139558 */   // Label 16700: @1139558
     /* 1139558 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1139638), // Rule ID 15195 //
     /* 1139563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139602 */     // MIs[0] round
     /* 1139602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139637 */     // GIR_Coverage, 15195,
     /* 1139637 */     GIR_EraseRootFromParent_Done,
     /* 1139638 */   // Label 16701: @1139638
     /* 1139638 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1139718), // Rule ID 15198 //
     /* 1139643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139682 */     // MIs[0] round
     /* 1139682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139692 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139717 */     // GIR_Coverage, 15198,
     /* 1139717 */     GIR_EraseRootFromParent_Done,
     /* 1139718 */   // Label 16702: @1139718
     /* 1139718 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1139798), // Rule ID 15199 //
     /* 1139723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139762 */     // MIs[0] round
     /* 1139762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139797 */     // GIR_Coverage, 15199,
     /* 1139797 */     GIR_EraseRootFromParent_Done,
     /* 1139798 */   // Label 16703: @1139798
     /* 1139798 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1139878), // Rule ID 15202 //
     /* 1139803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139842 */     // MIs[0] round
     /* 1139842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139877 */     // GIR_Coverage, 15202,
     /* 1139877 */     GIR_EraseRootFromParent_Done,
     /* 1139878 */   // Label 16704: @1139878
     /* 1139878 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1139958), // Rule ID 15203 //
     /* 1139883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139922 */     // MIs[0] round
     /* 1139922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139932 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139957 */     // GIR_Coverage, 15203,
     /* 1139957 */     GIR_EraseRootFromParent_Done,
     /* 1139958 */   // Label 16705: @1139958
     /* 1139958 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1140038), // Rule ID 15206 //
     /* 1139963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140002 */     // MIs[0] round
     /* 1140002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140012 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140037 */     // GIR_Coverage, 15206,
     /* 1140037 */     GIR_EraseRootFromParent_Done,
     /* 1140038 */   // Label 16706: @1140038
     /* 1140038 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1140118), // Rule ID 15207 //
     /* 1140043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1140054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1140057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1140060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140082 */     // MIs[0] round
     /* 1140082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140092 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140117 */     // GIR_Coverage, 15207,
     /* 1140117 */     GIR_EraseRootFromParent_Done,
     /* 1140118 */   // Label 16707: @1140118
     /* 1140118 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1140198), // Rule ID 15210 //
     /* 1140123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1140134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1140137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1140140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140162 */     // MIs[0] round
     /* 1140162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1140175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140197 */     // GIR_Coverage, 15210,
     /* 1140197 */     GIR_EraseRootFromParent_Done,
     /* 1140198 */   // Label 16708: @1140198
     /* 1140198 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1140278), // Rule ID 15211 //
     /* 1140203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1140214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1140217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1140220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140242 */     // MIs[0] round
     /* 1140242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1140255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140277 */     // GIR_Coverage, 15211,
     /* 1140277 */     GIR_EraseRootFromParent_Done,
     /* 1140278 */   // Label 16709: @1140278
     /* 1140278 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1140358), // Rule ID 15214 //
     /* 1140283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140322 */     // MIs[0] round
     /* 1140322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140357 */     // GIR_Coverage, 15214,
     /* 1140357 */     GIR_EraseRootFromParent_Done,
     /* 1140358 */   // Label 16710: @1140358
     /* 1140358 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1140438), // Rule ID 15215 //
     /* 1140363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1140374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1140377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1140380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140402 */     // MIs[0] round
     /* 1140402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140437 */     // GIR_Coverage, 15215,
     /* 1140437 */     GIR_EraseRootFromParent_Done,
     /* 1140438 */   // Label 16711: @1140438
     /* 1140438 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1140518), // Rule ID 15218 //
     /* 1140443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140482 */     // MIs[0] round
     /* 1140482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140517 */     // GIR_Coverage, 15218,
     /* 1140517 */     GIR_EraseRootFromParent_Done,
     /* 1140518 */   // Label 16712: @1140518
     /* 1140518 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1140598), // Rule ID 15219 //
     /* 1140523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140562 */     // MIs[0] round
     /* 1140562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140597 */     // GIR_Coverage, 15219,
     /* 1140597 */     GIR_EraseRootFromParent_Done,
     /* 1140598 */   // Label 16713: @1140598
     /* 1140598 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1140678), // Rule ID 15222 //
     /* 1140603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140642 */     // MIs[0] round
     /* 1140642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140677 */     // GIR_Coverage, 15222,
     /* 1140677 */     GIR_EraseRootFromParent_Done,
     /* 1140678 */   // Label 16714: @1140678
     /* 1140678 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1140758), // Rule ID 15223 //
     /* 1140683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140722 */     // MIs[0] round
     /* 1140722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11218:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140757 */     // GIR_Coverage, 15223,
     /* 1140757 */     GIR_EraseRootFromParent_Done,
     /* 1140758 */   // Label 16715: @1140758
     /* 1140758 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1140838), // Rule ID 15226 //
     /* 1140763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140802 */     // MIs[0] round
     /* 1140802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140837 */     // GIR_Coverage, 15226,
     /* 1140837 */     GIR_EraseRootFromParent_Done,
     /* 1140838 */   // Label 16716: @1140838
     /* 1140838 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1140918), // Rule ID 15227 //
     /* 1140843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140882 */     // MIs[0] round
     /* 1140882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140917 */     // GIR_Coverage, 15227,
     /* 1140917 */     GIR_EraseRootFromParent_Done,
     /* 1140918 */   // Label 16717: @1140918
     /* 1140918 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1140998), // Rule ID 15230 //
     /* 1140923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140962 */     // MIs[0] round
     /* 1140962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140997 */     // GIR_Coverage, 15230,
     /* 1140997 */     GIR_EraseRootFromParent_Done,
     /* 1140998 */   // Label 16718: @1140998
     /* 1140998 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1141078), // Rule ID 15231 //
     /* 1141003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1141014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1141017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1141020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141042 */     // MIs[0] round
     /* 1141042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141077 */     // GIR_Coverage, 15231,
     /* 1141077 */     GIR_EraseRootFromParent_Done,
     /* 1141078 */   // Label 16719: @1141078
     /* 1141078 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1141158), // Rule ID 15234 //
     /* 1141083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1141094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1141097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1141100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141122 */     // MIs[0] round
     /* 1141122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141157 */     // GIR_Coverage, 15234,
     /* 1141157 */     GIR_EraseRootFromParent_Done,
     /* 1141158 */   // Label 16720: @1141158
     /* 1141158 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1141238), // Rule ID 15235 //
     /* 1141163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1141174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1141177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1141180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141202 */     // MIs[0] round
     /* 1141202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1141215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141237 */     // GIR_Coverage, 15235,
     /* 1141237 */     GIR_EraseRootFromParent_Done,
     /* 1141238 */   // Label 16721: @1141238
     /* 1141238 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1141318), // Rule ID 15238 //
     /* 1141243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141282 */     // MIs[0] round
     /* 1141282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141317 */     // GIR_Coverage, 15238,
     /* 1141317 */     GIR_EraseRootFromParent_Done,
     /* 1141318 */   // Label 16722: @1141318
     /* 1141318 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1141398), // Rule ID 15239 //
     /* 1141323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1141334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1141337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1141340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141362 */     // MIs[0] round
     /* 1141362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141372 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141397 */     // GIR_Coverage, 15239,
     /* 1141397 */     GIR_EraseRootFromParent_Done,
     /* 1141398 */   // Label 16723: @1141398
     /* 1141398 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1141478), // Rule ID 15242 //
     /* 1141403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141442 */     // MIs[0] round
     /* 1141442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141452 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141477 */     // GIR_Coverage, 15242,
     /* 1141477 */     GIR_EraseRootFromParent_Done,
     /* 1141478 */   // Label 16724: @1141478
     /* 1141478 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1141558), // Rule ID 15243 //
     /* 1141483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141522 */     // MIs[0] round
     /* 1141522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141557 */     // GIR_Coverage, 15243,
     /* 1141557 */     GIR_EraseRootFromParent_Done,
     /* 1141558 */   // Label 16725: @1141558
     /* 1141558 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1141638), // Rule ID 15246 //
     /* 1141563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141602 */     // MIs[0] round
     /* 1141602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141612 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141637 */     // GIR_Coverage, 15246,
     /* 1141637 */     GIR_EraseRootFromParent_Done,
     /* 1141638 */   // Label 16726: @1141638
     /* 1141638 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1141718), // Rule ID 15247 //
     /* 1141643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141682 */     // MIs[0] round
     /* 1141682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141692 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141717 */     // GIR_Coverage, 15247,
     /* 1141717 */     GIR_EraseRootFromParent_Done,
     /* 1141718 */   // Label 16727: @1141718
     /* 1141718 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1141798), // Rule ID 15250 //
     /* 1141723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141762 */     // MIs[0] round
     /* 1141762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141797 */     // GIR_Coverage, 15250,
     /* 1141797 */     GIR_EraseRootFromParent_Done,
     /* 1141798 */   // Label 16728: @1141798
     /* 1141798 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1141878), // Rule ID 15251 //
     /* 1141803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141842 */     // MIs[0] round
     /* 1141842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141877 */     // GIR_Coverage, 15251,
     /* 1141877 */     GIR_EraseRootFromParent_Done,
     /* 1141878 */   // Label 16729: @1141878
     /* 1141878 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1141958), // Rule ID 15254 //
     /* 1141883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141922 */     // MIs[0] round
     /* 1141922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141957 */     // GIR_Coverage, 15254,
     /* 1141957 */     GIR_EraseRootFromParent_Done,
     /* 1141958 */   // Label 16730: @1141958
     /* 1141958 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1142038), // Rule ID 15255 //
     /* 1141963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142002 */     // MIs[0] round
     /* 1142002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142037 */     // GIR_Coverage, 15255,
     /* 1142037 */     GIR_EraseRootFromParent_Done,
     /* 1142038 */   // Label 16731: @1142038
     /* 1142038 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1142118), // Rule ID 15258 //
     /* 1142043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1142054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1142057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1142060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142082 */     // MIs[0] round
     /* 1142082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142117 */     // GIR_Coverage, 15258,
     /* 1142117 */     GIR_EraseRootFromParent_Done,
     /* 1142118 */   // Label 16732: @1142118
     /* 1142118 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1142198), // Rule ID 15259 //
     /* 1142123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1142134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1142137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1142140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142162 */     // MIs[0] round
     /* 1142162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142197 */     // GIR_Coverage, 15259,
     /* 1142197 */     GIR_EraseRootFromParent_Done,
     /* 1142198 */   // Label 16733: @1142198
     /* 1142198 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1142278), // Rule ID 15262 //
     /* 1142203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142242 */     // MIs[0] round
     /* 1142242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142277 */     // GIR_Coverage, 15262,
     /* 1142277 */     GIR_EraseRootFromParent_Done,
     /* 1142278 */   // Label 16734: @1142278
     /* 1142278 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1142358), // Rule ID 15263 //
     /* 1142283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1142294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1142297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1142300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142322 */     // MIs[0] round
     /* 1142322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142357 */     // GIR_Coverage, 15263,
     /* 1142357 */     GIR_EraseRootFromParent_Done,
     /* 1142358 */   // Label 16735: @1142358
     /* 1142358 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1142438), // Rule ID 15266 //
     /* 1142363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142402 */     // MIs[0] round
     /* 1142402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142437 */     // GIR_Coverage, 15266,
     /* 1142437 */     GIR_EraseRootFromParent_Done,
     /* 1142438 */   // Label 16736: @1142438
     /* 1142438 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1142518), // Rule ID 15267 //
     /* 1142443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1142454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1142457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1142460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142482 */     // MIs[0] round
     /* 1142482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142517 */     // GIR_Coverage, 15267,
     /* 1142517 */     GIR_EraseRootFromParent_Done,
     /* 1142518 */   // Label 16737: @1142518
     /* 1142518 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1142598), // Rule ID 15270 //
     /* 1142523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142562 */     // MIs[0] round
     /* 1142562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142572 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142597 */     // GIR_Coverage, 15270,
     /* 1142597 */     GIR_EraseRootFromParent_Done,
     /* 1142598 */   // Label 16738: @1142598
     /* 1142598 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1142678), // Rule ID 15271 //
     /* 1142603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142642 */     // MIs[0] round
     /* 1142642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142677 */     // GIR_Coverage, 15271,
     /* 1142677 */     GIR_EraseRootFromParent_Done,
     /* 1142678 */   // Label 16739: @1142678
     /* 1142678 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1142758), // Rule ID 15274 //
     /* 1142683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142722 */     // MIs[0] round
     /* 1142722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142732 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142757 */     // GIR_Coverage, 15274,
     /* 1142757 */     GIR_EraseRootFromParent_Done,
     /* 1142758 */   // Label 16740: @1142758
     /* 1142758 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1142838), // Rule ID 15275 //
     /* 1142763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142802 */     // MIs[0] round
     /* 1142802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142837 */     // GIR_Coverage, 15275,
     /* 1142837 */     GIR_EraseRootFromParent_Done,
     /* 1142838 */   // Label 16741: @1142838
     /* 1142838 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1142918), // Rule ID 15278 //
     /* 1142843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142882 */     // MIs[0] round
     /* 1142882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142917 */     // GIR_Coverage, 15278,
     /* 1142917 */     GIR_EraseRootFromParent_Done,
     /* 1142918 */   // Label 16742: @1142918
     /* 1142918 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1142998), // Rule ID 15279 //
     /* 1142923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142962 */     // MIs[0] round
     /* 1142962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142997 */     // GIR_Coverage, 15279,
     /* 1142997 */     GIR_EraseRootFromParent_Done,
     /* 1142998 */   // Label 16743: @1142998
     /* 1142998 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1143078), // Rule ID 15282 //
     /* 1143003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1143006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1143014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1143017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1143020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143042 */     // MIs[0] round
     /* 1143042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1143055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143077 */     // GIR_Coverage, 15282,
     /* 1143077 */     GIR_EraseRootFromParent_Done,
     /* 1143078 */   // Label 16744: @1143078
     /* 1143078 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1143158), // Rule ID 15283 //
     /* 1143083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1143086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1143091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1143094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1143097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1143100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143122 */     // MIs[0] round
     /* 1143122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1143135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143157 */     // GIR_Coverage, 15283,
     /* 1143157 */     GIR_EraseRootFromParent_Done,
     /* 1143158 */   // Label 16745: @1143158
     /* 1143158 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1143238), // Rule ID 15286 //
     /* 1143163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1143183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143202 */     // MIs[0] round
     /* 1143202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1143215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143237 */     // GIR_Coverage, 15286,
     /* 1143237 */     GIR_EraseRootFromParent_Done,
     /* 1143238 */   // Label 16746: @1143238
     /* 1143238 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1143318), // Rule ID 15287 //
     /* 1143243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1143254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1143257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1143260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1143263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143282 */     // MIs[0] round
     /* 1143282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1143295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143317 */     // GIR_Coverage, 15287,
     /* 1143317 */     GIR_EraseRootFromParent_Done,
     /* 1143318 */   // Label 16747: @1143318
     /* 1143318 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1143398), // Rule ID 15290 //
     /* 1143323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1143343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143362 */     // MIs[0] round
     /* 1143362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143397 */     // GIR_Coverage, 15290,
     /* 1143397 */     GIR_EraseRootFromParent_Done,
     /* 1143398 */   // Label 16748: @1143398
     /* 1143398 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1143478), // Rule ID 15291 //
     /* 1143403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1143414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1143417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1143420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1143423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143442 */     // MIs[0] round
     /* 1143442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143477 */     // GIR_Coverage, 15291,
     /* 1143477 */     GIR_EraseRootFromParent_Done,
     /* 1143478 */   // Label 16749: @1143478
     /* 1143478 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1143558), // Rule ID 15294 //
     /* 1143483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143522 */     // MIs[0] round
     /* 1143522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143557 */     // GIR_Coverage, 15294,
     /* 1143557 */     GIR_EraseRootFromParent_Done,
     /* 1143558 */   // Label 16750: @1143558
     /* 1143558 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1143638), // Rule ID 15295 //
     /* 1143563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143602 */     // MIs[0] round
     /* 1143602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143637 */     // GIR_Coverage, 15295,
     /* 1143637 */     GIR_EraseRootFromParent_Done,
     /* 1143638 */   // Label 16751: @1143638
     /* 1143638 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1143718), // Rule ID 15298 //
     /* 1143643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143682 */     // MIs[0] round
     /* 1143682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143717 */     // GIR_Coverage, 15298,
     /* 1143717 */     GIR_EraseRootFromParent_Done,
     /* 1143718 */   // Label 16752: @1143718
     /* 1143718 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1143798), // Rule ID 15299 //
     /* 1143723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143762 */     // MIs[0] round
     /* 1143762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143772 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143797 */     // GIR_Coverage, 15299,
     /* 1143797 */     GIR_EraseRootFromParent_Done,
     /* 1143798 */   // Label 16753: @1143798
     /* 1143798 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1143878), // Rule ID 15302 //
     /* 1143803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143842 */     // MIs[0] round
     /* 1143842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143877 */     // GIR_Coverage, 15302,
     /* 1143877 */     GIR_EraseRootFromParent_Done,
     /* 1143878 */   // Label 16754: @1143878
     /* 1143878 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1143958), // Rule ID 15303 //
     /* 1143883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143922 */     // MIs[0] round
     /* 1143922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143957 */     // GIR_Coverage, 15303,
     /* 1143957 */     GIR_EraseRootFromParent_Done,
     /* 1143958 */   // Label 16755: @1143958
     /* 1143958 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1144038), // Rule ID 15306 //
     /* 1143963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144002 */     // MIs[0] round
     /* 1144002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1144015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144037 */     // GIR_Coverage, 15306,
     /* 1144037 */     GIR_EraseRootFromParent_Done,
     /* 1144038 */   // Label 16756: @1144038
     /* 1144038 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1144118), // Rule ID 15307 //
     /* 1144043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1144054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1144057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1144060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1144063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144082 */     // MIs[0] round
     /* 1144082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1144095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144117 */     // GIR_Coverage, 15307,
     /* 1144117 */     GIR_EraseRootFromParent_Done,
     /* 1144118 */   // Label 16757: @1144118
     /* 1144118 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1144198), // Rule ID 15310 //
     /* 1144123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1144134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1144137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1144140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1144143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144162 */     // MIs[0] round
     /* 1144162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144197 */     // GIR_Coverage, 15310,
     /* 1144197 */     GIR_EraseRootFromParent_Done,
     /* 1144198 */   // Label 16758: @1144198
     /* 1144198 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1144278), // Rule ID 15311 //
     /* 1144203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1144214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1144217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1144220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1144223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144242 */     // MIs[0] round
     /* 1144242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144277 */     // GIR_Coverage, 15311,
     /* 1144277 */     GIR_EraseRootFromParent_Done,
     /* 1144278 */   // Label 16759: @1144278
     /* 1144278 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1144358), // Rule ID 15314 //
     /* 1144283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1144303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144322 */     // MIs[0] round
     /* 1144322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144357 */     // GIR_Coverage, 15314,
     /* 1144357 */     GIR_EraseRootFromParent_Done,
     /* 1144358 */   // Label 16760: @1144358
     /* 1144358 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1144438), // Rule ID 15315 //
     /* 1144363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1144374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1144377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1144380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1144383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144402 */     // MIs[0] round
     /* 1144402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144437 */     // GIR_Coverage, 15315,
     /* 1144437 */     GIR_EraseRootFromParent_Done,
     /* 1144438 */   // Label 16761: @1144438
     /* 1144438 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1144518), // Rule ID 15318 //
     /* 1144443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144482 */     // MIs[0] round
     /* 1144482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144517 */     // GIR_Coverage, 15318,
     /* 1144517 */     GIR_EraseRootFromParent_Done,
     /* 1144518 */   // Label 16762: @1144518
     /* 1144518 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1144598), // Rule ID 15319 //
     /* 1144523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144562 */     // MIs[0] round
     /* 1144562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144597 */     // GIR_Coverage, 15319,
     /* 1144597 */     GIR_EraseRootFromParent_Done,
     /* 1144598 */   // Label 16763: @1144598
     /* 1144598 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1144678), // Rule ID 15322 //
     /* 1144603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144642 */     // MIs[0] round
     /* 1144642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144677 */     // GIR_Coverage, 15322,
     /* 1144677 */     GIR_EraseRootFromParent_Done,
     /* 1144678 */   // Label 16764: @1144678
     /* 1144678 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1144758), // Rule ID 15323 //
     /* 1144683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144722 */     // MIs[0] round
     /* 1144722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144757 */     // GIR_Coverage, 15323,
     /* 1144757 */     GIR_EraseRootFromParent_Done,
     /* 1144758 */   // Label 16765: @1144758
     /* 1144758 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1144838), // Rule ID 15326 //
     /* 1144763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144802 */     // MIs[0] round
     /* 1144802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144837 */     // GIR_Coverage, 15326,
     /* 1144837 */     GIR_EraseRootFromParent_Done,
     /* 1144838 */   // Label 16766: @1144838
     /* 1144838 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1144918), // Rule ID 15327 //
     /* 1144843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144882 */     // MIs[0] round
     /* 1144882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144917 */     // GIR_Coverage, 15327,
     /* 1144917 */     GIR_EraseRootFromParent_Done,
     /* 1144918 */   // Label 16767: @1144918
     /* 1144918 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1144998), // Rule ID 15330 //
     /* 1144923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144962 */     // MIs[0] round
     /* 1144962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144997 */     // GIR_Coverage, 15330,
     /* 1144997 */     GIR_EraseRootFromParent_Done,
     /* 1144998 */   // Label 16768: @1144998
     /* 1144998 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1145078), // Rule ID 15331 //
     /* 1145003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1145014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1145017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1145020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1145023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145042 */     // MIs[0] round
     /* 1145042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145077 */     // GIR_Coverage, 15331,
     /* 1145077 */     GIR_EraseRootFromParent_Done,
     /* 1145078 */   // Label 16769: @1145078
     /* 1145078 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1145158), // Rule ID 15334 //
     /* 1145083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1145094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1145097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1145100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1145103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145122 */     // MIs[0] round
     /* 1145122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145132 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145157 */     // GIR_Coverage, 15334,
     /* 1145157 */     GIR_EraseRootFromParent_Done,
     /* 1145158 */   // Label 16770: @1145158
     /* 1145158 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1145238), // Rule ID 15335 //
     /* 1145163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1145174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1145177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1145180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1145183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145202 */     // MIs[0] round
     /* 1145202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145237 */     // GIR_Coverage, 15335,
     /* 1145237 */     GIR_EraseRootFromParent_Done,
     /* 1145238 */   // Label 16771: @1145238
     /* 1145238 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1145318), // Rule ID 15338 //
     /* 1145243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1145263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145282 */     // MIs[0] round
     /* 1145282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145317 */     // GIR_Coverage, 15338,
     /* 1145317 */     GIR_EraseRootFromParent_Done,
     /* 1145318 */   // Label 16772: @1145318
     /* 1145318 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1145398), // Rule ID 15339 //
     /* 1145323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1145334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1145337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1145340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1145343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145362 */     // MIs[0] round
     /* 1145362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145372 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145397 */     // GIR_Coverage, 15339,
     /* 1145397 */     GIR_EraseRootFromParent_Done,
     /* 1145398 */   // Label 16773: @1145398
     /* 1145398 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1145478), // Rule ID 15342 //
     /* 1145403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145442 */     // MIs[0] round
     /* 1145442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145477 */     // GIR_Coverage, 15342,
     /* 1145477 */     GIR_EraseRootFromParent_Done,
     /* 1145478 */   // Label 16774: @1145478
     /* 1145478 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1145558), // Rule ID 15343 //
     /* 1145483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145522 */     // MIs[0] round
     /* 1145522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145557 */     // GIR_Coverage, 15343,
     /* 1145557 */     GIR_EraseRootFromParent_Done,
     /* 1145558 */   // Label 16775: @1145558
     /* 1145558 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1145638), // Rule ID 15346 //
     /* 1145563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145602 */     // MIs[0] round
     /* 1145602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145637 */     // GIR_Coverage, 15346,
     /* 1145637 */     GIR_EraseRootFromParent_Done,
     /* 1145638 */   // Label 16776: @1145638
     /* 1145638 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1145718), // Rule ID 15347 //
     /* 1145643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145682 */     // MIs[0] round
     /* 1145682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145717 */     // GIR_Coverage, 15347,
     /* 1145717 */     GIR_EraseRootFromParent_Done,
     /* 1145718 */   // Label 16777: @1145718
     /* 1145718 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1145798), // Rule ID 15350 //
     /* 1145723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145762 */     // MIs[0] round
     /* 1145762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145797 */     // GIR_Coverage, 15350,
     /* 1145797 */     GIR_EraseRootFromParent_Done,
     /* 1145798 */   // Label 16778: @1145798
     /* 1145798 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1145878), // Rule ID 15351 //
     /* 1145803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145842 */     // MIs[0] round
     /* 1145842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145877 */     // GIR_Coverage, 15351,
     /* 1145877 */     GIR_EraseRootFromParent_Done,
     /* 1145878 */   // Label 16779: @1145878
     /* 1145878 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1145958), // Rule ID 15354 //
     /* 1145883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145922 */     // MIs[0] round
     /* 1145922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145932 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145957 */     // GIR_Coverage, 15354,
     /* 1145957 */     GIR_EraseRootFromParent_Done,
     /* 1145958 */   // Label 16780: @1145958
     /* 1145958 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1146038), // Rule ID 15355 //
     /* 1145963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146002 */     // MIs[0] round
     /* 1146002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146037 */     // GIR_Coverage, 15355,
     /* 1146037 */     GIR_EraseRootFromParent_Done,
     /* 1146038 */   // Label 16781: @1146038
     /* 1146038 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1146118), // Rule ID 15358 //
     /* 1146043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1146054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1146057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1146060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1146063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146082 */     // MIs[0] round
     /* 1146082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146117 */     // GIR_Coverage, 15358,
     /* 1146117 */     GIR_EraseRootFromParent_Done,
     /* 1146118 */   // Label 16782: @1146118
     /* 1146118 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1146198), // Rule ID 15359 //
     /* 1146123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1146134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1146137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1146140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1146143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146162 */     // MIs[0] round
     /* 1146162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146197 */     // GIR_Coverage, 15359,
     /* 1146197 */     GIR_EraseRootFromParent_Done,
     /* 1146198 */   // Label 16783: @1146198
     /* 1146198 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1146278), // Rule ID 15362 //
     /* 1146203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1146223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146242 */     // MIs[0] round
     /* 1146242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1146255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146277 */     // GIR_Coverage, 15362,
     /* 1146277 */     GIR_EraseRootFromParent_Done,
     /* 1146278 */   // Label 16784: @1146278
     /* 1146278 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1146358), // Rule ID 15363 //
     /* 1146283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1146294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1146297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1146300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1146303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146322 */     // MIs[0] round
     /* 1146322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1146335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146357 */     // GIR_Coverage, 15363,
     /* 1146357 */     GIR_EraseRootFromParent_Done,
     /* 1146358 */   // Label 16785: @1146358
     /* 1146358 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1146438), // Rule ID 15366 //
     /* 1146363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1146383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146402 */     // MIs[0] round
     /* 1146402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146437 */     // GIR_Coverage, 15366,
     /* 1146437 */     GIR_EraseRootFromParent_Done,
     /* 1146438 */   // Label 16786: @1146438
     /* 1146438 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1146518), // Rule ID 15367 //
     /* 1146443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1146454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1146457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1146460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1146463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146482 */     // MIs[0] round
     /* 1146482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146517 */     // GIR_Coverage, 15367,
     /* 1146517 */     GIR_EraseRootFromParent_Done,
     /* 1146518 */   // Label 16787: @1146518
     /* 1146518 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1146598), // Rule ID 15370 //
     /* 1146523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146562 */     // MIs[0] round
     /* 1146562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146597 */     // GIR_Coverage, 15370,
     /* 1146597 */     GIR_EraseRootFromParent_Done,
     /* 1146598 */   // Label 16788: @1146598
     /* 1146598 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1146678), // Rule ID 15371 //
     /* 1146603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146642 */     // MIs[0] round
     /* 1146642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146677 */     // GIR_Coverage, 15371,
     /* 1146677 */     GIR_EraseRootFromParent_Done,
     /* 1146678 */   // Label 16789: @1146678
     /* 1146678 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1146758), // Rule ID 15374 //
     /* 1146683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146722 */     // MIs[0] round
     /* 1146722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146757 */     // GIR_Coverage, 15374,
     /* 1146757 */     GIR_EraseRootFromParent_Done,
     /* 1146758 */   // Label 16790: @1146758
     /* 1146758 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1146838), // Rule ID 15375 //
     /* 1146763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146802 */     // MIs[0] round
     /* 1146802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146837 */     // GIR_Coverage, 15375,
     /* 1146837 */     GIR_EraseRootFromParent_Done,
     /* 1146838 */   // Label 16791: @1146838
     /* 1146838 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1146918), // Rule ID 15378 //
     /* 1146843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146882 */     // MIs[0] round
     /* 1146882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146892 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146917 */     // GIR_Coverage, 15378,
     /* 1146917 */     GIR_EraseRootFromParent_Done,
     /* 1146918 */   // Label 16792: @1146918
     /* 1146918 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1146998), // Rule ID 15379 //
     /* 1146923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146962 */     // MIs[0] round
     /* 1146962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146972 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146997 */     // GIR_Coverage, 15379,
     /* 1146997 */     GIR_EraseRootFromParent_Done,
     /* 1146998 */   // Label 16793: @1146998
     /* 1146998 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1147078), // Rule ID 15382 //
     /* 1147003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1147014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1147017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1147020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147042 */     // MIs[0] round
     /* 1147042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147077 */     // GIR_Coverage, 15382,
     /* 1147077 */     GIR_EraseRootFromParent_Done,
     /* 1147078 */   // Label 16794: @1147078
     /* 1147078 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1147158), // Rule ID 15383 //
     /* 1147083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1147094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1147097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1147100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147122 */     // MIs[0] round
     /* 1147122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147157 */     // GIR_Coverage, 15383,
     /* 1147157 */     GIR_EraseRootFromParent_Done,
     /* 1147158 */   // Label 16795: @1147158
     /* 1147158 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1147238), // Rule ID 15386 //
     /* 1147163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147202 */     // MIs[0] round
     /* 1147202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1147215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147237 */     // GIR_Coverage, 15386,
     /* 1147237 */     GIR_EraseRootFromParent_Done,
     /* 1147238 */   // Label 16796: @1147238
     /* 1147238 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1147318), // Rule ID 15387 //
     /* 1147243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1147254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1147257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1147260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147282 */     // MIs[0] round
     /* 1147282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1147295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147317 */     // GIR_Coverage, 15387,
     /* 1147317 */     GIR_EraseRootFromParent_Done,
     /* 1147318 */   // Label 16797: @1147318
     /* 1147318 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1147398), // Rule ID 15390 //
     /* 1147323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147362 */     // MIs[0] round
     /* 1147362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147397 */     // GIR_Coverage, 15390,
     /* 1147397 */     GIR_EraseRootFromParent_Done,
     /* 1147398 */   // Label 16798: @1147398
     /* 1147398 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1147478), // Rule ID 15391 //
     /* 1147403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1147414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1147417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1147420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147442 */     // MIs[0] round
     /* 1147442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147477 */     // GIR_Coverage, 15391,
     /* 1147477 */     GIR_EraseRootFromParent_Done,
     /* 1147478 */   // Label 16799: @1147478
     /* 1147478 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1147558), // Rule ID 15394 //
     /* 1147483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147522 */     // MIs[0] round
     /* 1147522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147557 */     // GIR_Coverage, 15394,
     /* 1147557 */     GIR_EraseRootFromParent_Done,
     /* 1147558 */   // Label 16800: @1147558
     /* 1147558 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1147638), // Rule ID 15395 //
     /* 1147563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147602 */     // MIs[0] round
     /* 1147602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147637 */     // GIR_Coverage, 15395,
     /* 1147637 */     GIR_EraseRootFromParent_Done,
     /* 1147638 */   // Label 16801: @1147638
     /* 1147638 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1147718), // Rule ID 15398 //
     /* 1147643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147682 */     // MIs[0] round
     /* 1147682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147717 */     // GIR_Coverage, 15398,
     /* 1147717 */     GIR_EraseRootFromParent_Done,
     /* 1147718 */   // Label 16802: @1147718
     /* 1147718 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1147798), // Rule ID 15399 //
     /* 1147723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147762 */     // MIs[0] round
     /* 1147762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11216:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147797 */     // GIR_Coverage, 15399,
     /* 1147797 */     GIR_EraseRootFromParent_Done,
     /* 1147798 */   // Label 16803: @1147798
     /* 1147798 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1147878), // Rule ID 15402 //
     /* 1147803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147842 */     // MIs[0] round
     /* 1147842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147877 */     // GIR_Coverage, 15402,
     /* 1147877 */     GIR_EraseRootFromParent_Done,
     /* 1147878 */   // Label 16804: @1147878
     /* 1147878 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1147958), // Rule ID 15403 //
     /* 1147883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147922 */     // MIs[0] round
     /* 1147922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147957 */     // GIR_Coverage, 15403,
     /* 1147957 */     GIR_EraseRootFromParent_Done,
     /* 1147958 */   // Label 16805: @1147958
     /* 1147958 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1148038), // Rule ID 15406 //
     /* 1147963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148002 */     // MIs[0] round
     /* 1148002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148037 */     // GIR_Coverage, 15406,
     /* 1148037 */     GIR_EraseRootFromParent_Done,
     /* 1148038 */   // Label 16806: @1148038
     /* 1148038 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1148118), // Rule ID 15407 //
     /* 1148043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1148054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1148057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1148060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148082 */     // MIs[0] round
     /* 1148082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148117 */     // GIR_Coverage, 15407,
     /* 1148117 */     GIR_EraseRootFromParent_Done,
     /* 1148118 */   // Label 16807: @1148118
     /* 1148118 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1148198), // Rule ID 15410 //
     /* 1148123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1148134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1148137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1148140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148162 */     // MIs[0] round
     /* 1148162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148197 */     // GIR_Coverage, 15410,
     /* 1148197 */     GIR_EraseRootFromParent_Done,
     /* 1148198 */   // Label 16808: @1148198
     /* 1148198 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1148278), // Rule ID 15411 //
     /* 1148203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1148214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1148217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1148220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148242 */     // MIs[0] round
     /* 1148242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1148255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148277 */     // GIR_Coverage, 15411,
     /* 1148277 */     GIR_EraseRootFromParent_Done,
     /* 1148278 */   // Label 16809: @1148278
     /* 1148278 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1148358), // Rule ID 15414 //
     /* 1148283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148322 */     // MIs[0] round
     /* 1148322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148357 */     // GIR_Coverage, 15414,
     /* 1148357 */     GIR_EraseRootFromParent_Done,
     /* 1148358 */   // Label 16810: @1148358
     /* 1148358 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1148438), // Rule ID 15415 //
     /* 1148363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1148374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1148377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1148380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148402 */     // MIs[0] round
     /* 1148402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148437 */     // GIR_Coverage, 15415,
     /* 1148437 */     GIR_EraseRootFromParent_Done,
     /* 1148438 */   // Label 16811: @1148438
     /* 1148438 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1148518), // Rule ID 15418 //
     /* 1148443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148482 */     // MIs[0] round
     /* 1148482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148517 */     // GIR_Coverage, 15418,
     /* 1148517 */     GIR_EraseRootFromParent_Done,
     /* 1148518 */   // Label 16812: @1148518
     /* 1148518 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1148598), // Rule ID 15419 //
     /* 1148523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148562 */     // MIs[0] round
     /* 1148562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148572 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148597 */     // GIR_Coverage, 15419,
     /* 1148597 */     GIR_EraseRootFromParent_Done,
     /* 1148598 */   // Label 16813: @1148598
     /* 1148598 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1148678), // Rule ID 15422 //
     /* 1148603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148642 */     // MIs[0] round
     /* 1148642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148677 */     // GIR_Coverage, 15422,
     /* 1148677 */     GIR_EraseRootFromParent_Done,
     /* 1148678 */   // Label 16814: @1148678
     /* 1148678 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1148758), // Rule ID 15423 //
     /* 1148683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148722 */     // MIs[0] round
     /* 1148722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148732 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148757 */     // GIR_Coverage, 15423,
     /* 1148757 */     GIR_EraseRootFromParent_Done,
     /* 1148758 */   // Label 16815: @1148758
     /* 1148758 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1148838), // Rule ID 15426 //
     /* 1148763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148802 */     // MIs[0] round
     /* 1148802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148837 */     // GIR_Coverage, 15426,
     /* 1148837 */     GIR_EraseRootFromParent_Done,
     /* 1148838 */   // Label 16816: @1148838
     /* 1148838 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1148918), // Rule ID 15427 //
     /* 1148843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148882 */     // MIs[0] round
     /* 1148882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148917 */     // GIR_Coverage, 15427,
     /* 1148917 */     GIR_EraseRootFromParent_Done,
     /* 1148918 */   // Label 16817: @1148918
     /* 1148918 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1148998), // Rule ID 15430 //
     /* 1148923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148962 */     // MIs[0] round
     /* 1148962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148997 */     // GIR_Coverage, 15430,
     /* 1148997 */     GIR_EraseRootFromParent_Done,
     /* 1148998 */   // Label 16818: @1148998
     /* 1148998 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1149078), // Rule ID 15431 //
     /* 1149003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1149014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1149017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1149020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149042 */     // MIs[0] round
     /* 1149042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149077 */     // GIR_Coverage, 15431,
     /* 1149077 */     GIR_EraseRootFromParent_Done,
     /* 1149078 */   // Label 16819: @1149078
     /* 1149078 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1149158), // Rule ID 15434 //
     /* 1149083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1149094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1149097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1149100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149122 */     // MIs[0] round
     /* 1149122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149157 */     // GIR_Coverage, 15434,
     /* 1149157 */     GIR_EraseRootFromParent_Done,
     /* 1149158 */   // Label 16820: @1149158
     /* 1149158 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1149238), // Rule ID 15435 //
     /* 1149163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1149174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1149177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1149180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149202 */     // MIs[0] round
     /* 1149202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149237 */     // GIR_Coverage, 15435,
     /* 1149237 */     GIR_EraseRootFromParent_Done,
     /* 1149238 */   // Label 16821: @1149238
     /* 1149238 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1149318), // Rule ID 15438 //
     /* 1149243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149282 */     // MIs[0] round
     /* 1149282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149317 */     // GIR_Coverage, 15438,
     /* 1149317 */     GIR_EraseRootFromParent_Done,
     /* 1149318 */   // Label 16822: @1149318
     /* 1149318 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1149398), // Rule ID 15439 //
     /* 1149323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1149334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1149337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1149340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149362 */     // MIs[0] round
     /* 1149362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149397 */     // GIR_Coverage, 15439,
     /* 1149397 */     GIR_EraseRootFromParent_Done,
     /* 1149398 */   // Label 16823: @1149398
     /* 1149398 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1149478), // Rule ID 15442 //
     /* 1149403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149442 */     // MIs[0] round
     /* 1149442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149477 */     // GIR_Coverage, 15442,
     /* 1149477 */     GIR_EraseRootFromParent_Done,
     /* 1149478 */   // Label 16824: @1149478
     /* 1149478 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1149558), // Rule ID 15443 //
     /* 1149483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149522 */     // MIs[0] round
     /* 1149522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149557 */     // GIR_Coverage, 15443,
     /* 1149557 */     GIR_EraseRootFromParent_Done,
     /* 1149558 */   // Label 16825: @1149558
     /* 1149558 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1149638), // Rule ID 15446 //
     /* 1149563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149602 */     // MIs[0] round
     /* 1149602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149637 */     // GIR_Coverage, 15446,
     /* 1149637 */     GIR_EraseRootFromParent_Done,
     /* 1149638 */   // Label 16826: @1149638
     /* 1149638 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1149718), // Rule ID 15447 //
     /* 1149643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149682 */     // MIs[0] round
     /* 1149682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149717 */     // GIR_Coverage, 15447,
     /* 1149717 */     GIR_EraseRootFromParent_Done,
     /* 1149718 */   // Label 16827: @1149718
     /* 1149718 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1149798), // Rule ID 15450 //
     /* 1149723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149762 */     // MIs[0] round
     /* 1149762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149797 */     // GIR_Coverage, 15450,
     /* 1149797 */     GIR_EraseRootFromParent_Done,
     /* 1149798 */   // Label 16828: @1149798
     /* 1149798 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1149878), // Rule ID 15451 //
     /* 1149803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149842 */     // MIs[0] round
     /* 1149842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149877 */     // GIR_Coverage, 15451,
     /* 1149877 */     GIR_EraseRootFromParent_Done,
     /* 1149878 */   // Label 16829: @1149878
     /* 1149878 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1149958), // Rule ID 15454 //
     /* 1149883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149922 */     // MIs[0] round
     /* 1149922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149957 */     // GIR_Coverage, 15454,
     /* 1149957 */     GIR_EraseRootFromParent_Done,
     /* 1149958 */   // Label 16830: @1149958
     /* 1149958 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1150038), // Rule ID 15455 //
     /* 1149963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150002 */     // MIs[0] round
     /* 1150002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1150015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150037 */     // GIR_Coverage, 15455,
     /* 1150037 */     GIR_EraseRootFromParent_Done,
     /* 1150038 */   // Label 16831: @1150038
     /* 1150038 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1150118), // Rule ID 15458 //
     /* 1150043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1150046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1150054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1150057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1150060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150082 */     // MIs[0] round
     /* 1150082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150092 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1150095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150117 */     // GIR_Coverage, 15458,
     /* 1150117 */     GIR_EraseRootFromParent_Done,
     /* 1150118 */   // Label 16832: @1150118
     /* 1150118 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1150198), // Rule ID 15459 //
     /* 1150123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1150126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1150131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1150134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1150137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1150140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150162 */     // MIs[0] round
     /* 1150162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1150175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150197 */     // GIR_Coverage, 15459,
     /* 1150197 */     GIR_EraseRootFromParent_Done,
     /* 1150198 */   // Label 16833: @1150198
     /* 1150198 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1150278), // Rule ID 15462 //
     /* 1150203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1150223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150242 */     // MIs[0] round
     /* 1150242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1150255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150277 */     // GIR_Coverage, 15462,
     /* 1150277 */     GIR_EraseRootFromParent_Done,
     /* 1150278 */   // Label 16834: @1150278
     /* 1150278 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1150358), // Rule ID 15463 //
     /* 1150283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1150294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1150297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1150300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1150303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150322 */     // MIs[0] round
     /* 1150322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150332 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1150335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150357 */     // GIR_Coverage, 15463,
     /* 1150357 */     GIR_EraseRootFromParent_Done,
     /* 1150358 */   // Label 16835: @1150358
     /* 1150358 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1150438), // Rule ID 15466 //
     /* 1150363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1150383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150402 */     // MIs[0] round
     /* 1150402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150437 */     // GIR_Coverage, 15466,
     /* 1150437 */     GIR_EraseRootFromParent_Done,
     /* 1150438 */   // Label 16836: @1150438
     /* 1150438 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1150518), // Rule ID 15467 //
     /* 1150443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1150454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1150457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1150460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1150463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150482 */     // MIs[0] round
     /* 1150482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150517 */     // GIR_Coverage, 15467,
     /* 1150517 */     GIR_EraseRootFromParent_Done,
     /* 1150518 */   // Label 16837: @1150518
     /* 1150518 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1150598), // Rule ID 15470 //
     /* 1150523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150562 */     // MIs[0] round
     /* 1150562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150572 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150597 */     // GIR_Coverage, 15470,
     /* 1150597 */     GIR_EraseRootFromParent_Done,
     /* 1150598 */   // Label 16838: @1150598
     /* 1150598 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1150678), // Rule ID 15471 //
     /* 1150603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150642 */     // MIs[0] round
     /* 1150642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150677 */     // GIR_Coverage, 15471,
     /* 1150677 */     GIR_EraseRootFromParent_Done,
     /* 1150678 */   // Label 16839: @1150678
     /* 1150678 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1150758), // Rule ID 15474 //
     /* 1150683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150722 */     // MIs[0] round
     /* 1150722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150757 */     // GIR_Coverage, 15474,
     /* 1150757 */     GIR_EraseRootFromParent_Done,
     /* 1150758 */   // Label 16840: @1150758
     /* 1150758 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1150838), // Rule ID 15475 //
     /* 1150763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150802 */     // MIs[0] round
     /* 1150802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150837 */     // GIR_Coverage, 15475,
     /* 1150837 */     GIR_EraseRootFromParent_Done,
     /* 1150838 */   // Label 16841: @1150838
     /* 1150838 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1150918), // Rule ID 15478 //
     /* 1150843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150882 */     // MIs[0] round
     /* 1150882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150892 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150917 */     // GIR_Coverage, 15478,
     /* 1150917 */     GIR_EraseRootFromParent_Done,
     /* 1150918 */   // Label 16842: @1150918
     /* 1150918 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1150998), // Rule ID 15479 //
     /* 1150923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150962 */     // MIs[0] round
     /* 1150962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150972 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150997 */     // GIR_Coverage, 15479,
     /* 1150997 */     GIR_EraseRootFromParent_Done,
     /* 1150998 */   // Label 16843: @1150998
     /* 1150998 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1151078), // Rule ID 15482 //
     /* 1151003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1151014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1151017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1151020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1151023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151042 */     // MIs[0] round
     /* 1151042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1151055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151077 */     // GIR_Coverage, 15482,
     /* 1151077 */     GIR_EraseRootFromParent_Done,
     /* 1151078 */   // Label 16844: @1151078
     /* 1151078 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1151158), // Rule ID 15483 //
     /* 1151083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1151094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1151097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1151100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1151103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151122 */     // MIs[0] round
     /* 1151122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1151135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151157 */     // GIR_Coverage, 15483,
     /* 1151157 */     GIR_EraseRootFromParent_Done,
     /* 1151158 */   // Label 16845: @1151158
     /* 1151158 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1151238), // Rule ID 15486 //
     /* 1151163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1151183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151202 */     // MIs[0] round
     /* 1151202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151237 */     // GIR_Coverage, 15486,
     /* 1151237 */     GIR_EraseRootFromParent_Done,
     /* 1151238 */   // Label 16846: @1151238
     /* 1151238 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1151318), // Rule ID 15487 //
     /* 1151243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1151254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1151257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1151260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1151263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151282 */     // MIs[0] round
     /* 1151282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151317 */     // GIR_Coverage, 15487,
     /* 1151317 */     GIR_EraseRootFromParent_Done,
     /* 1151318 */   // Label 16847: @1151318
     /* 1151318 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1151398), // Rule ID 15490 //
     /* 1151323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1151343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151362 */     // MIs[0] round
     /* 1151362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151397 */     // GIR_Coverage, 15490,
     /* 1151397 */     GIR_EraseRootFromParent_Done,
     /* 1151398 */   // Label 16848: @1151398
     /* 1151398 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1151478), // Rule ID 15491 //
     /* 1151403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1151414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1151417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1151420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1151423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151442 */     // MIs[0] round
     /* 1151442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151477 */     // GIR_Coverage, 15491,
     /* 1151477 */     GIR_EraseRootFromParent_Done,
     /* 1151478 */   // Label 16849: @1151478
     /* 1151478 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1151558), // Rule ID 15494 //
     /* 1151483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151522 */     // MIs[0] round
     /* 1151522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151557 */     // GIR_Coverage, 15494,
     /* 1151557 */     GIR_EraseRootFromParent_Done,
     /* 1151558 */   // Label 16850: @1151558
     /* 1151558 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1151638), // Rule ID 15495 //
     /* 1151563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151602 */     // MIs[0] round
     /* 1151602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151637 */     // GIR_Coverage, 15495,
     /* 1151637 */     GIR_EraseRootFromParent_Done,
     /* 1151638 */   // Label 16851: @1151638
     /* 1151638 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1151718), // Rule ID 15498 //
     /* 1151643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151682 */     // MIs[0] round
     /* 1151682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151717 */     // GIR_Coverage, 15498,
     /* 1151717 */     GIR_EraseRootFromParent_Done,
     /* 1151718 */   // Label 16852: @1151718
     /* 1151718 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1151798), // Rule ID 15499 //
     /* 1151723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151762 */     // MIs[0] round
     /* 1151762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151797 */     // GIR_Coverage, 15499,
     /* 1151797 */     GIR_EraseRootFromParent_Done,
     /* 1151798 */   // Label 16853: @1151798
     /* 1151798 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1151878), // Rule ID 15502 //
     /* 1151803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151842 */     // MIs[0] round
     /* 1151842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151877 */     // GIR_Coverage, 15502,
     /* 1151877 */     GIR_EraseRootFromParent_Done,
     /* 1151878 */   // Label 16854: @1151878
     /* 1151878 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1151958), // Rule ID 15503 //
     /* 1151883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151922 */     // MIs[0] round
     /* 1151922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151957 */     // GIR_Coverage, 15503,
     /* 1151957 */     GIR_EraseRootFromParent_Done,
     /* 1151958 */   // Label 16855: @1151958
     /* 1151958 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1152038), // Rule ID 15506 //
     /* 1151963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152002 */     // MIs[0] round
     /* 1152002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152012 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152037 */     // GIR_Coverage, 15506,
     /* 1152037 */     GIR_EraseRootFromParent_Done,
     /* 1152038 */   // Label 16856: @1152038
     /* 1152038 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1152118), // Rule ID 15507 //
     /* 1152043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1152054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1152057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1152060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1152063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152082 */     // MIs[0] round
     /* 1152082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152117 */     // GIR_Coverage, 15507,
     /* 1152117 */     GIR_EraseRootFromParent_Done,
     /* 1152118 */   // Label 16857: @1152118
     /* 1152118 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1152198), // Rule ID 15510 //
     /* 1152123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1152134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1152137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1152140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1152143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152162 */     // MIs[0] round
     /* 1152162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152197 */     // GIR_Coverage, 15510,
     /* 1152197 */     GIR_EraseRootFromParent_Done,
     /* 1152198 */   // Label 16858: @1152198
     /* 1152198 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1152278), // Rule ID 15511 //
     /* 1152203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1152214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1152217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1152220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1152223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152242 */     // MIs[0] round
     /* 1152242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152277 */     // GIR_Coverage, 15511,
     /* 1152277 */     GIR_EraseRootFromParent_Done,
     /* 1152278 */   // Label 16859: @1152278
     /* 1152278 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1152358), // Rule ID 15514 //
     /* 1152283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1152303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152322 */     // MIs[0] round
     /* 1152322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152357 */     // GIR_Coverage, 15514,
     /* 1152357 */     GIR_EraseRootFromParent_Done,
     /* 1152358 */   // Label 16860: @1152358
     /* 1152358 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1152438), // Rule ID 15515 //
     /* 1152363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1152374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1152377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1152380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1152383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152402 */     // MIs[0] round
     /* 1152402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152437 */     // GIR_Coverage, 15515,
     /* 1152437 */     GIR_EraseRootFromParent_Done,
     /* 1152438 */   // Label 16861: @1152438
     /* 1152438 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1152518), // Rule ID 15518 //
     /* 1152443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152482 */     // MIs[0] round
     /* 1152482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152517 */     // GIR_Coverage, 15518,
     /* 1152517 */     GIR_EraseRootFromParent_Done,
     /* 1152518 */   // Label 16862: @1152518
     /* 1152518 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1152598), // Rule ID 15519 //
     /* 1152523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152562 */     // MIs[0] round
     /* 1152562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152597 */     // GIR_Coverage, 15519,
     /* 1152597 */     GIR_EraseRootFromParent_Done,
     /* 1152598 */   // Label 16863: @1152598
     /* 1152598 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1152678), // Rule ID 15522 //
     /* 1152603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152642 */     // MIs[0] round
     /* 1152642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152677 */     // GIR_Coverage, 15522,
     /* 1152677 */     GIR_EraseRootFromParent_Done,
     /* 1152678 */   // Label 16864: @1152678
     /* 1152678 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1152758), // Rule ID 15523 //
     /* 1152683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152722 */     // MIs[0] round
     /* 1152722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152757 */     // GIR_Coverage, 15523,
     /* 1152757 */     GIR_EraseRootFromParent_Done,
     /* 1152758 */   // Label 16865: @1152758
     /* 1152758 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1152838), // Rule ID 15526 //
     /* 1152763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152802 */     // MIs[0] round
     /* 1152802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152837 */     // GIR_Coverage, 15526,
     /* 1152837 */     GIR_EraseRootFromParent_Done,
     /* 1152838 */   // Label 16866: @1152838
     /* 1152838 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1152918), // Rule ID 15527 //
     /* 1152843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152882 */     // MIs[0] round
     /* 1152882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152917 */     // GIR_Coverage, 15527,
     /* 1152917 */     GIR_EraseRootFromParent_Done,
     /* 1152918 */   // Label 16867: @1152918
     /* 1152918 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1152998), // Rule ID 15530 //
     /* 1152923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152962 */     // MIs[0] round
     /* 1152962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152997 */     // GIR_Coverage, 15530,
     /* 1152997 */     GIR_EraseRootFromParent_Done,
     /* 1152998 */   // Label 16868: @1152998
     /* 1152998 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1153078), // Rule ID 15531 //
     /* 1153003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1153014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1153017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1153020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1153023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153042 */     // MIs[0] round
     /* 1153042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153077 */     // GIR_Coverage, 15531,
     /* 1153077 */     GIR_EraseRootFromParent_Done,
     /* 1153078 */   // Label 16869: @1153078
     /* 1153078 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1153158), // Rule ID 15534 //
     /* 1153083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1153094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1153097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1153100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1153103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153122 */     // MIs[0] round
     /* 1153122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153132 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153157 */     // GIR_Coverage, 15534,
     /* 1153157 */     GIR_EraseRootFromParent_Done,
     /* 1153158 */   // Label 16870: @1153158
     /* 1153158 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1153238), // Rule ID 15535 //
     /* 1153163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1153174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1153177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1153180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1153183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153202 */     // MIs[0] round
     /* 1153202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153212 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153237 */     // GIR_Coverage, 15535,
     /* 1153237 */     GIR_EraseRootFromParent_Done,
     /* 1153238 */   // Label 16871: @1153238
     /* 1153238 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1153318), // Rule ID 15538 //
     /* 1153243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1153263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153282 */     // MIs[0] round
     /* 1153282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1153295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153317 */     // GIR_Coverage, 15538,
     /* 1153317 */     GIR_EraseRootFromParent_Done,
     /* 1153318 */   // Label 16872: @1153318
     /* 1153318 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1153398), // Rule ID 15539 //
     /* 1153323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1153334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1153337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1153340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1153343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153362 */     // MIs[0] round
     /* 1153362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1153375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153397 */     // GIR_Coverage, 15539,
     /* 1153397 */     GIR_EraseRootFromParent_Done,
     /* 1153398 */   // Label 16873: @1153398
     /* 1153398 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1153478), // Rule ID 15542 //
     /* 1153403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153442 */     // MIs[0] round
     /* 1153442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153477 */     // GIR_Coverage, 15542,
     /* 1153477 */     GIR_EraseRootFromParent_Done,
     /* 1153478 */   // Label 16874: @1153478
     /* 1153478 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1153558), // Rule ID 15543 //
     /* 1153483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153522 */     // MIs[0] round
     /* 1153522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153532 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153557 */     // GIR_Coverage, 15543,
     /* 1153557 */     GIR_EraseRootFromParent_Done,
     /* 1153558 */   // Label 16875: @1153558
     /* 1153558 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1153638), // Rule ID 15546 //
     /* 1153563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153602 */     // MIs[0] round
     /* 1153602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153637 */     // GIR_Coverage, 15546,
     /* 1153637 */     GIR_EraseRootFromParent_Done,
     /* 1153638 */   // Label 16876: @1153638
     /* 1153638 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1153718), // Rule ID 15547 //
     /* 1153643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153682 */     // MIs[0] round
     /* 1153682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153717 */     // GIR_Coverage, 15547,
     /* 1153717 */     GIR_EraseRootFromParent_Done,
     /* 1153718 */   // Label 16877: @1153718
     /* 1153718 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1153798), // Rule ID 15550 //
     /* 1153723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153762 */     // MIs[0] round
     /* 1153762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153797 */     // GIR_Coverage, 15550,
     /* 1153797 */     GIR_EraseRootFromParent_Done,
     /* 1153798 */   // Label 16878: @1153798
     /* 1153798 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1153878), // Rule ID 15551 //
     /* 1153803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153842 */     // MIs[0] round
     /* 1153842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153852 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153877 */     // GIR_Coverage, 15551,
     /* 1153877 */     GIR_EraseRootFromParent_Done,
     /* 1153878 */   // Label 16879: @1153878
     /* 1153878 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1153958), // Rule ID 15554 //
     /* 1153883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153922 */     // MIs[0] round
     /* 1153922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153932 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153957 */     // GIR_Coverage, 15554,
     /* 1153957 */     GIR_EraseRootFromParent_Done,
     /* 1153958 */   // Label 16880: @1153958
     /* 1153958 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1154038), // Rule ID 15555 //
     /* 1153963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154002 */     // MIs[0] round
     /* 1154002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154037 */     // GIR_Coverage, 15555,
     /* 1154037 */     GIR_EraseRootFromParent_Done,
     /* 1154038 */   // Label 16881: @1154038
     /* 1154038 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1154118), // Rule ID 15558 //
     /* 1154043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1154054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1154057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1154060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154082 */     // MIs[0] round
     /* 1154082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154092 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154117 */     // GIR_Coverage, 15558,
     /* 1154117 */     GIR_EraseRootFromParent_Done,
     /* 1154118 */   // Label 16882: @1154118
     /* 1154118 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1154198), // Rule ID 15559 //
     /* 1154123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1154134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1154137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1154140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154162 */     // MIs[0] round
     /* 1154162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154172 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154197 */     // GIR_Coverage, 15559,
     /* 1154197 */     GIR_EraseRootFromParent_Done,
     /* 1154198 */   // Label 16883: @1154198
     /* 1154198 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1154278), // Rule ID 15562 //
     /* 1154203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154242 */     // MIs[0] round
     /* 1154242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154277 */     // GIR_Coverage, 15562,
     /* 1154277 */     GIR_EraseRootFromParent_Done,
     /* 1154278 */   // Label 16884: @1154278
     /* 1154278 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1154358), // Rule ID 15563 //
     /* 1154283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1154294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1154297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1154300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154322 */     // MIs[0] round
     /* 1154322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154332 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1154335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154357 */     // GIR_Coverage, 15563,
     /* 1154357 */     GIR_EraseRootFromParent_Done,
     /* 1154358 */   // Label 16885: @1154358
     /* 1154358 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1154438), // Rule ID 15566 //
     /* 1154363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154402 */     // MIs[0] round
     /* 1154402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154437 */     // GIR_Coverage, 15566,
     /* 1154437 */     GIR_EraseRootFromParent_Done,
     /* 1154438 */   // Label 16886: @1154438
     /* 1154438 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1154518), // Rule ID 15567 //
     /* 1154443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1154454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1154457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1154460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154482 */     // MIs[0] round
     /* 1154482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154517 */     // GIR_Coverage, 15567,
     /* 1154517 */     GIR_EraseRootFromParent_Done,
     /* 1154518 */   // Label 16887: @1154518
     /* 1154518 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1154598), // Rule ID 15570 //
     /* 1154523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154562 */     // MIs[0] round
     /* 1154562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154597 */     // GIR_Coverage, 15570,
     /* 1154597 */     GIR_EraseRootFromParent_Done,
     /* 1154598 */   // Label 16888: @1154598
     /* 1154598 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1154678), // Rule ID 15571 //
     /* 1154603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154642 */     // MIs[0] round
     /* 1154642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154677 */     // GIR_Coverage, 15571,
     /* 1154677 */     GIR_EraseRootFromParent_Done,
     /* 1154678 */   // Label 16889: @1154678
     /* 1154678 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1154758), // Rule ID 15574 //
     /* 1154683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154722 */     // MIs[0] round
     /* 1154722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154757 */     // GIR_Coverage, 15574,
     /* 1154757 */     GIR_EraseRootFromParent_Done,
     /* 1154758 */   // Label 16890: @1154758
     /* 1154758 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1154838), // Rule ID 15575 //
     /* 1154763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154802 */     // MIs[0] round
     /* 1154802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11194:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154837 */     // GIR_Coverage, 15575,
     /* 1154837 */     GIR_EraseRootFromParent_Done,
     /* 1154838 */   // Label 16891: @1154838
     /* 1154838 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1154918), // Rule ID 15578 //
     /* 1154843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154882 */     // MIs[0] round
     /* 1154882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154917 */     // GIR_Coverage, 15578,
     /* 1154917 */     GIR_EraseRootFromParent_Done,
     /* 1154918 */   // Label 16892: @1154918
     /* 1154918 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1154998), // Rule ID 15579 //
     /* 1154923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154962 */     // MIs[0] round
     /* 1154962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154997 */     // GIR_Coverage, 15579,
     /* 1154997 */     GIR_EraseRootFromParent_Done,
     /* 1154998 */   // Label 16893: @1154998
     /* 1154998 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1155078), // Rule ID 15582 //
     /* 1155003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1155014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1155017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1155020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155042 */     // MIs[0] round
     /* 1155042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155077 */     // GIR_Coverage, 15582,
     /* 1155077 */     GIR_EraseRootFromParent_Done,
     /* 1155078 */   // Label 16894: @1155078
     /* 1155078 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1155158), // Rule ID 15583 //
     /* 1155083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1155094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1155097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1155100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155122 */     // MIs[0] round
     /* 1155122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155157 */     // GIR_Coverage, 15583,
     /* 1155157 */     GIR_EraseRootFromParent_Done,
     /* 1155158 */   // Label 16895: @1155158
     /* 1155158 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1155238), // Rule ID 15586 //
     /* 1155163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155202 */     // MIs[0] round
     /* 1155202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155237 */     // GIR_Coverage, 15586,
     /* 1155237 */     GIR_EraseRootFromParent_Done,
     /* 1155238 */   // Label 16896: @1155238
     /* 1155238 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1155318), // Rule ID 15587 //
     /* 1155243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1155246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1155254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1155257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1155260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155282 */     // MIs[0] round
     /* 1155282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1155295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1155313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155317 */     // GIR_Coverage, 15587,
     /* 1155317 */     GIR_EraseRootFromParent_Done,
     /* 1155318 */   // Label 16897: @1155318
     /* 1155318 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1155398), // Rule ID 15590 //
     /* 1155323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155362 */     // MIs[0] round
     /* 1155362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155372 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155397 */     // GIR_Coverage, 15590,
     /* 1155397 */     GIR_EraseRootFromParent_Done,
     /* 1155398 */   // Label 16898: @1155398
     /* 1155398 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1155478), // Rule ID 15591 //
     /* 1155403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1155414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1155417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1155420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155442 */     // MIs[0] round
     /* 1155442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155477 */     // GIR_Coverage, 15591,
     /* 1155477 */     GIR_EraseRootFromParent_Done,
     /* 1155478 */   // Label 16899: @1155478
     /* 1155478 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1155558), // Rule ID 15594 //
     /* 1155483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155522 */     // MIs[0] round
     /* 1155522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155557 */     // GIR_Coverage, 15594,
     /* 1155557 */     GIR_EraseRootFromParent_Done,
     /* 1155558 */   // Label 16900: @1155558
     /* 1155558 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1155638), // Rule ID 15595 //
     /* 1155563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155602 */     // MIs[0] round
     /* 1155602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155637 */     // GIR_Coverage, 15595,
     /* 1155637 */     GIR_EraseRootFromParent_Done,
     /* 1155638 */   // Label 16901: @1155638
     /* 1155638 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1155718), // Rule ID 15598 //
     /* 1155643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155682 */     // MIs[0] round
     /* 1155682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155692 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155717 */     // GIR_Coverage, 15598,
     /* 1155717 */     GIR_EraseRootFromParent_Done,
     /* 1155718 */   // Label 16902: @1155718
     /* 1155718 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1155798), // Rule ID 15599 //
     /* 1155723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155762 */     // MIs[0] round
     /* 1155762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155797 */     // GIR_Coverage, 15599,
     /* 1155797 */     GIR_EraseRootFromParent_Done,
     /* 1155798 */   // Label 16903: @1155798
     /* 1155798 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1155878), // Rule ID 15602 //
     /* 1155803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155842 */     // MIs[0] round
     /* 1155842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155877 */     // GIR_Coverage, 15602,
     /* 1155877 */     GIR_EraseRootFromParent_Done,
     /* 1155878 */   // Label 16904: @1155878
     /* 1155878 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1155958), // Rule ID 15603 //
     /* 1155883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155922 */     // MIs[0] round
     /* 1155922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155957 */     // GIR_Coverage, 15603,
     /* 1155957 */     GIR_EraseRootFromParent_Done,
     /* 1155958 */   // Label 16905: @1155958
     /* 1155958 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1156038), // Rule ID 15606 //
     /* 1155963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156002 */     // MIs[0] round
     /* 1156002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156037 */     // GIR_Coverage, 15606,
     /* 1156037 */     GIR_EraseRootFromParent_Done,
     /* 1156038 */   // Label 16906: @1156038
     /* 1156038 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1156118), // Rule ID 15607 //
     /* 1156043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1156054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1156057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1156060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156082 */     // MIs[0] round
     /* 1156082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156092 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156117 */     // GIR_Coverage, 15607,
     /* 1156117 */     GIR_EraseRootFromParent_Done,
     /* 1156118 */   // Label 16907: @1156118
     /* 1156118 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1156198), // Rule ID 15610 //
     /* 1156123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1156134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1156137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1156140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156162 */     // MIs[0] round
     /* 1156162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156197 */     // GIR_Coverage, 15610,
     /* 1156197 */     GIR_EraseRootFromParent_Done,
     /* 1156198 */   // Label 16908: @1156198
     /* 1156198 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1156278), // Rule ID 15611 //
     /* 1156203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1156214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1156217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1156220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156242 */     // MIs[0] round
     /* 1156242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156277 */     // GIR_Coverage, 15611,
     /* 1156277 */     GIR_EraseRootFromParent_Done,
     /* 1156278 */   // Label 16909: @1156278
     /* 1156278 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1156358), // Rule ID 15614 //
     /* 1156283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156322 */     // MIs[0] round
     /* 1156322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156357 */     // GIR_Coverage, 15614,
     /* 1156357 */     GIR_EraseRootFromParent_Done,
     /* 1156358 */   // Label 16910: @1156358
     /* 1156358 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1156438), // Rule ID 15615 //
     /* 1156363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1156374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1156377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1156380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156402 */     // MIs[0] round
     /* 1156402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156437 */     // GIR_Coverage, 15615,
     /* 1156437 */     GIR_EraseRootFromParent_Done,
     /* 1156438 */   // Label 16911: @1156438
     /* 1156438 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1156518), // Rule ID 15618 //
     /* 1156443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156482 */     // MIs[0] round
     /* 1156482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156517 */     // GIR_Coverage, 15618,
     /* 1156517 */     GIR_EraseRootFromParent_Done,
     /* 1156518 */   // Label 16912: @1156518
     /* 1156518 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1156598), // Rule ID 15619 //
     /* 1156523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156562 */     // MIs[0] round
     /* 1156562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156597 */     // GIR_Coverage, 15619,
     /* 1156597 */     GIR_EraseRootFromParent_Done,
     /* 1156598 */   // Label 16913: @1156598
     /* 1156598 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1156678), // Rule ID 15622 //
     /* 1156603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156642 */     // MIs[0] round
     /* 1156642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156677 */     // GIR_Coverage, 15622,
     /* 1156677 */     GIR_EraseRootFromParent_Done,
     /* 1156678 */   // Label 16914: @1156678
     /* 1156678 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1156758), // Rule ID 15623 //
     /* 1156683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156722 */     // MIs[0] round
     /* 1156722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156757 */     // GIR_Coverage, 15623,
     /* 1156757 */     GIR_EraseRootFromParent_Done,
     /* 1156758 */   // Label 16915: @1156758
     /* 1156758 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1156838), // Rule ID 15626 //
     /* 1156763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156802 */     // MIs[0] round
     /* 1156802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156837 */     // GIR_Coverage, 15626,
     /* 1156837 */     GIR_EraseRootFromParent_Done,
     /* 1156838 */   // Label 16916: @1156838
     /* 1156838 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1156918), // Rule ID 15627 //
     /* 1156843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156882 */     // MIs[0] round
     /* 1156882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156917 */     // GIR_Coverage, 15627,
     /* 1156917 */     GIR_EraseRootFromParent_Done,
     /* 1156918 */   // Label 16917: @1156918
     /* 1156918 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1156998), // Rule ID 15630 //
     /* 1156923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156962 */     // MIs[0] round
     /* 1156962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156997 */     // GIR_Coverage, 15630,
     /* 1156997 */     GIR_EraseRootFromParent_Done,
     /* 1156998 */   // Label 16918: @1156998
     /* 1156998 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1157078), // Rule ID 15631 //
     /* 1157003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1157014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1157017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1157020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157042 */     // MIs[0] round
     /* 1157042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1157055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157077 */     // GIR_Coverage, 15631,
     /* 1157077 */     GIR_EraseRootFromParent_Done,
     /* 1157078 */   // Label 16919: @1157078
     /* 1157078 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1157158), // Rule ID 15634 //
     /* 1157083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1157086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1157094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1157097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1157100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157122 */     // MIs[0] round
     /* 1157122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1157135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157157 */     // GIR_Coverage, 15634,
     /* 1157157 */     GIR_EraseRootFromParent_Done,
     /* 1157158 */   // Label 16920: @1157158
     /* 1157158 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1157238), // Rule ID 15635 //
     /* 1157163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1157166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1157171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1157174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1157177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1157180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157202 */     // MIs[0] round
     /* 1157202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1157215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1157233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157237 */     // GIR_Coverage, 15635,
     /* 1157237 */     GIR_EraseRootFromParent_Done,
     /* 1157238 */   // Label 16921: @1157238
     /* 1157238 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1157321), // Rule ID 15638 //
     /* 1157243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1157263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157282 */     // MIs[0] round
     /* 1157282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1157295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157320 */     // GIR_Coverage, 15638,
     /* 1157320 */     GIR_EraseRootFromParent_Done,
     /* 1157321 */   // Label 16922: @1157321
     /* 1157321 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1157404), // Rule ID 15639 //
     /* 1157326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1157337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1157340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1157343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1157346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157365 */     // MIs[0] round
     /* 1157365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157375 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1157378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157386 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157403 */     // GIR_Coverage, 15639,
     /* 1157403 */     GIR_EraseRootFromParent_Done,
     /* 1157404 */   // Label 16923: @1157404
     /* 1157404 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1157487), // Rule ID 15642 //
     /* 1157409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157448 */     // MIs[0] round
     /* 1157448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157458 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157486 */     // GIR_Coverage, 15642,
     /* 1157486 */     GIR_EraseRootFromParent_Done,
     /* 1157487 */   // Label 16924: @1157487
     /* 1157487 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1157570), // Rule ID 15643 //
     /* 1157492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157531 */     // MIs[0] round
     /* 1157531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157541 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157569 */     // GIR_Coverage, 15643,
     /* 1157569 */     GIR_EraseRootFromParent_Done,
     /* 1157570 */   // Label 16925: @1157570
     /* 1157570 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1157653), // Rule ID 15646 //
     /* 1157575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157614 */     // MIs[0] round
     /* 1157614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157652 */     // GIR_Coverage, 15646,
     /* 1157652 */     GIR_EraseRootFromParent_Done,
     /* 1157653 */   // Label 16926: @1157653
     /* 1157653 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1157736), // Rule ID 15647 //
     /* 1157658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157697 */     // MIs[0] round
     /* 1157697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157707 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157735 */     // GIR_Coverage, 15647,
     /* 1157735 */     GIR_EraseRootFromParent_Done,
     /* 1157736 */   // Label 16927: @1157736
     /* 1157736 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1157819), // Rule ID 15650 //
     /* 1157741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157780 */     // MIs[0] round
     /* 1157780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157818 */     // GIR_Coverage, 15650,
     /* 1157818 */     GIR_EraseRootFromParent_Done,
     /* 1157819 */   // Label 16928: @1157819
     /* 1157819 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1157902), // Rule ID 15651 //
     /* 1157824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157863 */     // MIs[0] round
     /* 1157863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157873 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157901 */     // GIR_Coverage, 15651,
     /* 1157901 */     GIR_EraseRootFromParent_Done,
     /* 1157902 */   // Label 16929: @1157902
     /* 1157902 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1157985), // Rule ID 15654 //
     /* 1157907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157946 */     // MIs[0] round
     /* 1157946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157984 */     // GIR_Coverage, 15654,
     /* 1157984 */     GIR_EraseRootFromParent_Done,
     /* 1157985 */   // Label 16930: @1157985
     /* 1157985 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1158068), // Rule ID 15655 //
     /* 1157990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1158001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1158004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1158007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1158010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158029 */     // MIs[0] round
     /* 1158029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158050 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158067 */     // GIR_Coverage, 15655,
     /* 1158067 */     GIR_EraseRootFromParent_Done,
     /* 1158068 */   // Label 16931: @1158068
     /* 1158068 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1158151), // Rule ID 15658 //
     /* 1158073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1158084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1158087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1158090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1158093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158112 */     // MIs[0] round
     /* 1158112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158150 */     // GIR_Coverage, 15658,
     /* 1158150 */     GIR_EraseRootFromParent_Done,
     /* 1158151 */   // Label 16932: @1158151
     /* 1158151 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1158234), // Rule ID 15659 //
     /* 1158156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1158167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1158170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1158173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1158176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158195 */     // MIs[0] round
     /* 1158195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158205 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1158208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158216 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158233 */     // GIR_Coverage, 15659,
     /* 1158233 */     GIR_EraseRootFromParent_Done,
     /* 1158234 */   // Label 16933: @1158234
     /* 1158234 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1158317), // Rule ID 15662 //
     /* 1158239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1158259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158278 */     // MIs[0] round
     /* 1158278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158316 */     // GIR_Coverage, 15662,
     /* 1158316 */     GIR_EraseRootFromParent_Done,
     /* 1158317 */   // Label 16934: @1158317
     /* 1158317 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1158400), // Rule ID 15663 //
     /* 1158322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1158333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1158336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1158339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1158342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158361 */     // MIs[0] round
     /* 1158361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158382 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158399 */     // GIR_Coverage, 15663,
     /* 1158399 */     GIR_EraseRootFromParent_Done,
     /* 1158400 */   // Label 16935: @1158400
     /* 1158400 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1158483), // Rule ID 15666 //
     /* 1158405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158444 */     // MIs[0] round
     /* 1158444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158482 */     // GIR_Coverage, 15666,
     /* 1158482 */     GIR_EraseRootFromParent_Done,
     /* 1158483 */   // Label 16936: @1158483
     /* 1158483 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1158566), // Rule ID 15667 //
     /* 1158488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158527 */     // MIs[0] round
     /* 1158527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158537 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158565 */     // GIR_Coverage, 15667,
     /* 1158565 */     GIR_EraseRootFromParent_Done,
     /* 1158566 */   // Label 16937: @1158566
     /* 1158566 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1158649), // Rule ID 15670 //
     /* 1158571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158610 */     // MIs[0] round
     /* 1158610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158648 */     // GIR_Coverage, 15670,
     /* 1158648 */     GIR_EraseRootFromParent_Done,
     /* 1158649 */   // Label 16938: @1158649
     /* 1158649 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1158732), // Rule ID 15671 //
     /* 1158654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158693 */     // MIs[0] round
     /* 1158693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158703 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158714 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158731 */     // GIR_Coverage, 15671,
     /* 1158731 */     GIR_EraseRootFromParent_Done,
     /* 1158732 */   // Label 16939: @1158732
     /* 1158732 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1158815), // Rule ID 15674 //
     /* 1158737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158776 */     // MIs[0] round
     /* 1158776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158814 */     // GIR_Coverage, 15674,
     /* 1158814 */     GIR_EraseRootFromParent_Done,
     /* 1158815 */   // Label 16940: @1158815
     /* 1158815 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1158898), // Rule ID 15675 //
     /* 1158820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158859 */     // MIs[0] round
     /* 1158859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158880 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158897 */     // GIR_Coverage, 15675,
     /* 1158897 */     GIR_EraseRootFromParent_Done,
     /* 1158898 */   // Label 16941: @1158898
     /* 1158898 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1158981), // Rule ID 15678 //
     /* 1158903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158942 */     // MIs[0] round
     /* 1158942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158980 */     // GIR_Coverage, 15678,
     /* 1158980 */     GIR_EraseRootFromParent_Done,
     /* 1158981 */   // Label 16942: @1158981
     /* 1158981 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1159064), // Rule ID 15679 //
     /* 1158986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1159000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1159003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1159006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159025 */     // MIs[0] round
     /* 1159025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159035 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159063 */     // GIR_Coverage, 15679,
     /* 1159063 */     GIR_EraseRootFromParent_Done,
     /* 1159064 */   // Label 16943: @1159064
     /* 1159064 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1159147), // Rule ID 15682 //
     /* 1159069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1159089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159108 */     // MIs[0] round
     /* 1159108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159146 */     // GIR_Coverage, 15682,
     /* 1159146 */     GIR_EraseRootFromParent_Done,
     /* 1159147 */   // Label 16944: @1159147
     /* 1159147 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1159230), // Rule ID 15683 //
     /* 1159152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1159163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1159166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1159169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1159172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159191 */     // MIs[0] round
     /* 1159191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159201 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159212 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159229 */     // GIR_Coverage, 15683,
     /* 1159229 */     GIR_EraseRootFromParent_Done,
     /* 1159230 */   // Label 16945: @1159230
     /* 1159230 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1159313), // Rule ID 15686 //
     /* 1159235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1159255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159274 */     // MIs[0] round
     /* 1159274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159312 */     // GIR_Coverage, 15686,
     /* 1159312 */     GIR_EraseRootFromParent_Done,
     /* 1159313 */   // Label 16946: @1159313
     /* 1159313 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1159396), // Rule ID 15687 //
     /* 1159318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1159329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1159332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1159335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1159338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159357 */     // MIs[0] round
     /* 1159357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159395 */     // GIR_Coverage, 15687,
     /* 1159395 */     GIR_EraseRootFromParent_Done,
     /* 1159396 */   // Label 16947: @1159396
     /* 1159396 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1159479), // Rule ID 15690 //
     /* 1159401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159440 */     // MIs[0] round
     /* 1159440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159478 */     // GIR_Coverage, 15690,
     /* 1159478 */     GIR_EraseRootFromParent_Done,
     /* 1159479 */   // Label 16948: @1159479
     /* 1159479 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1159562), // Rule ID 15691 //
     /* 1159484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159523 */     // MIs[0] round
     /* 1159523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159544 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159561 */     // GIR_Coverage, 15691,
     /* 1159561 */     GIR_EraseRootFromParent_Done,
     /* 1159562 */   // Label 16949: @1159562
     /* 1159562 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1159645), // Rule ID 15694 //
     /* 1159567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159606 */     // MIs[0] round
     /* 1159606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159644 */     // GIR_Coverage, 15694,
     /* 1159644 */     GIR_EraseRootFromParent_Done,
     /* 1159645 */   // Label 16950: @1159645
     /* 1159645 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1159728), // Rule ID 15695 //
     /* 1159650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159689 */     // MIs[0] round
     /* 1159689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159699 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159710 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159727 */     // GIR_Coverage, 15695,
     /* 1159727 */     GIR_EraseRootFromParent_Done,
     /* 1159728 */   // Label 16951: @1159728
     /* 1159728 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1159811), // Rule ID 15698 //
     /* 1159733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159772 */     // MIs[0] round
     /* 1159772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159810 */     // GIR_Coverage, 15698,
     /* 1159810 */     GIR_EraseRootFromParent_Done,
     /* 1159811 */   // Label 16952: @1159811
     /* 1159811 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1159894), // Rule ID 15699 //
     /* 1159816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159855 */     // MIs[0] round
     /* 1159855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159876 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159893 */     // GIR_Coverage, 15699,
     /* 1159893 */     GIR_EraseRootFromParent_Done,
     /* 1159894 */   // Label 16953: @1159894
     /* 1159894 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1159977), // Rule ID 15702 //
     /* 1159899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159938 */     // MIs[0] round
     /* 1159938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159976 */     // GIR_Coverage, 15702,
     /* 1159976 */     GIR_EraseRootFromParent_Done,
     /* 1159977 */   // Label 16954: @1159977
     /* 1159977 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1160060), // Rule ID 15703 //
     /* 1159982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1160002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1160021 */     // MIs[0] round
     /* 1160021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160031 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1160034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160042 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160059 */     // GIR_Coverage, 15703,
     /* 1160059 */     GIR_EraseRootFromParent_Done,
     /* 1160060 */   // Label 16955: @1160060
     /* 1160060 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1160143), // Rule ID 15706 //
     /* 1160065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1160076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1160079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1160082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1160085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160104 */     // MIs[0] round
     /* 1160104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1160117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160142 */     // GIR_Coverage, 15706,
     /* 1160142 */     GIR_EraseRootFromParent_Done,
     /* 1160143 */   // Label 16956: @1160143
     /* 1160143 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1160226), // Rule ID 15707 //
     /* 1160148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1160159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1160162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1160165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1160168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1160187 */     // MIs[0] round
     /* 1160187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160197 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1160200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160208 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160225 */     // GIR_Coverage, 15707,
     /* 1160225 */     GIR_EraseRootFromParent_Done,
     /* 1160226 */   // Label 16957: @1160226
     /* 1160226 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1160309), // Rule ID 15710 //
     /* 1160231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160270 */     // MIs[0] round
     /* 1160270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1160283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160308 */     // GIR_Coverage, 15710,
     /* 1160308 */     GIR_EraseRootFromParent_Done,
     /* 1160309 */   // Label 16958: @1160309
     /* 1160309 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1160392), // Rule ID 15711 //
     /* 1160314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1160325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1160328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1160331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160353 */     // MIs[0] round
     /* 1160353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160363 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1160366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160374 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160391 */     // GIR_Coverage, 15711,
     /* 1160391 */     GIR_EraseRootFromParent_Done,
     /* 1160392 */   // Label 16959: @1160392
     /* 1160392 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1160475), // Rule ID 15714 //
     /* 1160397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160436 */     // MIs[0] round
     /* 1160436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160474 */     // GIR_Coverage, 15714,
     /* 1160474 */     GIR_EraseRootFromParent_Done,
     /* 1160475 */   // Label 16960: @1160475
     /* 1160475 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1160558), // Rule ID 15715 //
     /* 1160480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160519 */     // MIs[0] round
     /* 1160519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160529 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160557 */     // GIR_Coverage, 15715,
     /* 1160557 */     GIR_EraseRootFromParent_Done,
     /* 1160558 */   // Label 16961: @1160558
     /* 1160558 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1160641), // Rule ID 15718 //
     /* 1160563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160602 */     // MIs[0] round
     /* 1160602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160640 */     // GIR_Coverage, 15718,
     /* 1160640 */     GIR_EraseRootFromParent_Done,
     /* 1160641 */   // Label 16962: @1160641
     /* 1160641 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1160724), // Rule ID 15719 //
     /* 1160646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160685 */     // MIs[0] round
     /* 1160685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160695 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160706 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160723 */     // GIR_Coverage, 15719,
     /* 1160723 */     GIR_EraseRootFromParent_Done,
     /* 1160724 */   // Label 16963: @1160724
     /* 1160724 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1160807), // Rule ID 15722 //
     /* 1160729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160768 */     // MIs[0] round
     /* 1160768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160778 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160806 */     // GIR_Coverage, 15722,
     /* 1160806 */     GIR_EraseRootFromParent_Done,
     /* 1160807 */   // Label 16964: @1160807
     /* 1160807 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1160890), // Rule ID 15723 //
     /* 1160812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160851 */     // MIs[0] round
     /* 1160851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160872 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160889 */     // GIR_Coverage, 15723,
     /* 1160889 */     GIR_EraseRootFromParent_Done,
     /* 1160890 */   // Label 16965: @1160890
     /* 1160890 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1160973), // Rule ID 15726 //
     /* 1160895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160934 */     // MIs[0] round
     /* 1160934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160944 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160972 */     // GIR_Coverage, 15726,
     /* 1160972 */     GIR_EraseRootFromParent_Done,
     /* 1160973 */   // Label 16966: @1160973
     /* 1160973 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1161056), // Rule ID 15727 //
     /* 1160978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161017 */     // MIs[0] round
     /* 1161017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161055 */     // GIR_Coverage, 15727,
     /* 1161055 */     GIR_EraseRootFromParent_Done,
     /* 1161056 */   // Label 16967: @1161056
     /* 1161056 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1161139), // Rule ID 15730 //
     /* 1161061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161100 */     // MIs[0] round
     /* 1161100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161138 */     // GIR_Coverage, 15730,
     /* 1161138 */     GIR_EraseRootFromParent_Done,
     /* 1161139 */   // Label 16968: @1161139
     /* 1161139 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1161222), // Rule ID 15731 //
     /* 1161144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1161155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1161158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1161161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161183 */     // MIs[0] round
     /* 1161183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161193 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1161196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161204 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161221 */     // GIR_Coverage, 15731,
     /* 1161221 */     GIR_EraseRootFromParent_Done,
     /* 1161222 */   // Label 16969: @1161222
     /* 1161222 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1161305), // Rule ID 15734 //
     /* 1161227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161266 */     // MIs[0] round
     /* 1161266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161304 */     // GIR_Coverage, 15734,
     /* 1161304 */     GIR_EraseRootFromParent_Done,
     /* 1161305 */   // Label 16970: @1161305
     /* 1161305 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1161388), // Rule ID 15735 //
     /* 1161310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1161321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1161324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1161327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161349 */     // MIs[0] round
     /* 1161349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161370 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161387 */     // GIR_Coverage, 15735,
     /* 1161387 */     GIR_EraseRootFromParent_Done,
     /* 1161388 */   // Label 16971: @1161388
     /* 1161388 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1161471), // Rule ID 15738 //
     /* 1161393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161432 */     // MIs[0] round
     /* 1161432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161442 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161470 */     // GIR_Coverage, 15738,
     /* 1161470 */     GIR_EraseRootFromParent_Done,
     /* 1161471 */   // Label 16972: @1161471
     /* 1161471 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1161554), // Rule ID 15739 //
     /* 1161476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161515 */     // MIs[0] round
     /* 1161515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161553 */     // GIR_Coverage, 15739,
     /* 1161553 */     GIR_EraseRootFromParent_Done,
     /* 1161554 */   // Label 16973: @1161554
     /* 1161554 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1161637), // Rule ID 15742 //
     /* 1161559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161598 */     // MIs[0] round
     /* 1161598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161636 */     // GIR_Coverage, 15742,
     /* 1161636 */     GIR_EraseRootFromParent_Done,
     /* 1161637 */   // Label 16974: @1161637
     /* 1161637 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1161720), // Rule ID 15743 //
     /* 1161642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161681 */     // MIs[0] round
     /* 1161681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161702 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161719 */     // GIR_Coverage, 15743,
     /* 1161719 */     GIR_EraseRootFromParent_Done,
     /* 1161720 */   // Label 16975: @1161720
     /* 1161720 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1161803), // Rule ID 15746 //
     /* 1161725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161764 */     // MIs[0] round
     /* 1161764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161802 */     // GIR_Coverage, 15746,
     /* 1161802 */     GIR_EraseRootFromParent_Done,
     /* 1161803 */   // Label 16976: @1161803
     /* 1161803 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1161886), // Rule ID 15747 //
     /* 1161808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161847 */     // MIs[0] round
     /* 1161847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161857 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161868 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161885 */     // GIR_Coverage, 15747,
     /* 1161885 */     GIR_EraseRootFromParent_Done,
     /* 1161886 */   // Label 16977: @1161886
     /* 1161886 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1161969), // Rule ID 15750 //
     /* 1161891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161930 */     // MIs[0] round
     /* 1161930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161940 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161968 */     // GIR_Coverage, 15750,
     /* 1161968 */     GIR_EraseRootFromParent_Done,
     /* 1161969 */   // Label 16978: @1161969
     /* 1161969 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1162052), // Rule ID 15751 //
     /* 1161974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162013 */     // MIs[0] round
     /* 1162013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162023 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162034 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162051 */     // GIR_Coverage, 15751,
     /* 1162051 */     GIR_EraseRootFromParent_Done,
     /* 1162052 */   // Label 16979: @1162052
     /* 1162052 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1162135), // Rule ID 15754 //
     /* 1162057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162096 */     // MIs[0] round
     /* 1162096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162106 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162134 */     // GIR_Coverage, 15754,
     /* 1162134 */     GIR_EraseRootFromParent_Done,
     /* 1162135 */   // Label 16980: @1162135
     /* 1162135 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1162218), // Rule ID 15755 //
     /* 1162140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1162151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1162154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1162157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162179 */     // MIs[0] round
     /* 1162179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162189 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1162210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162217 */     // GIR_Coverage, 15755,
     /* 1162217 */     GIR_EraseRootFromParent_Done,
     /* 1162218 */   // Label 16981: @1162218
     /* 1162218 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1162301), // Rule ID 15758 //
     /* 1162223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162262 */     // MIs[0] round
     /* 1162262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162300 */     // GIR_Coverage, 15758,
     /* 1162300 */     GIR_EraseRootFromParent_Done,
     /* 1162301 */   // Label 16982: @1162301
     /* 1162301 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1162384), // Rule ID 15759 //
     /* 1162306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1162317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1162320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1162323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162345 */     // MIs[0] round
     /* 1162345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162383 */     // GIR_Coverage, 15759,
     /* 1162383 */     GIR_EraseRootFromParent_Done,
     /* 1162384 */   // Label 16983: @1162384
     /* 1162384 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1162467), // Rule ID 15762 //
     /* 1162389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162428 */     // MIs[0] round
     /* 1162428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162438 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162466 */     // GIR_Coverage, 15762,
     /* 1162466 */     GIR_EraseRootFromParent_Done,
     /* 1162467 */   // Label 16984: @1162467
     /* 1162467 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1162550), // Rule ID 15763 //
     /* 1162472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162511 */     // MIs[0] round
     /* 1162511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162521 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162549 */     // GIR_Coverage, 15763,
     /* 1162549 */     GIR_EraseRootFromParent_Done,
     /* 1162550 */   // Label 16985: @1162550
     /* 1162550 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1162633), // Rule ID 15766 //
     /* 1162555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162594 */     // MIs[0] round
     /* 1162594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162632 */     // GIR_Coverage, 15766,
     /* 1162632 */     GIR_EraseRootFromParent_Done,
     /* 1162633 */   // Label 16986: @1162633
     /* 1162633 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1162716), // Rule ID 15767 //
     /* 1162638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162677 */     // MIs[0] round
     /* 1162677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162687 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162698 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162715 */     // GIR_Coverage, 15767,
     /* 1162715 */     GIR_EraseRootFromParent_Done,
     /* 1162716 */   // Label 16987: @1162716
     /* 1162716 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1162799), // Rule ID 15770 //
     /* 1162721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162760 */     // MIs[0] round
     /* 1162760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162798 */     // GIR_Coverage, 15770,
     /* 1162798 */     GIR_EraseRootFromParent_Done,
     /* 1162799 */   // Label 16988: @1162799
     /* 1162799 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1162882), // Rule ID 15771 //
     /* 1162804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162843 */     // MIs[0] round
     /* 1162843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162864 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162881 */     // GIR_Coverage, 15771,
     /* 1162881 */     GIR_EraseRootFromParent_Done,
     /* 1162882 */   // Label 16989: @1162882
     /* 1162882 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1162965), // Rule ID 15774 //
     /* 1162887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162926 */     // MIs[0] round
     /* 1162926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162964 */     // GIR_Coverage, 15774,
     /* 1162964 */     GIR_EraseRootFromParent_Done,
     /* 1162965 */   // Label 16990: @1162965
     /* 1162965 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1163048), // Rule ID 15775 //
     /* 1162970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163009 */     // MIs[0] round
     /* 1163009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163030 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163047 */     // GIR_Coverage, 15775,
     /* 1163047 */     GIR_EraseRootFromParent_Done,
     /* 1163048 */   // Label 16991: @1163048
     /* 1163048 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1163131), // Rule ID 15778 //
     /* 1163053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163092 */     // MIs[0] round
     /* 1163092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163130 */     // GIR_Coverage, 15778,
     /* 1163130 */     GIR_EraseRootFromParent_Done,
     /* 1163131 */   // Label 16992: @1163131
     /* 1163131 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1163214), // Rule ID 15779 //
     /* 1163136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1163147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1163150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1163153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163175 */     // MIs[0] round
     /* 1163175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163185 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163196 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163213 */     // GIR_Coverage, 15779,
     /* 1163213 */     GIR_EraseRootFromParent_Done,
     /* 1163214 */   // Label 16993: @1163214
     /* 1163214 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1163297), // Rule ID 15782 //
     /* 1163219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1163239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163258 */     // MIs[0] round
     /* 1163258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1163271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163296 */     // GIR_Coverage, 15782,
     /* 1163296 */     GIR_EraseRootFromParent_Done,
     /* 1163297 */   // Label 16994: @1163297
     /* 1163297 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1163380), // Rule ID 15783 //
     /* 1163302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1163322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163341 */     // MIs[0] round
     /* 1163341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1163354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163362 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163379 */     // GIR_Coverage, 15783,
     /* 1163379 */     GIR_EraseRootFromParent_Done,
     /* 1163380 */   // Label 16995: @1163380
     /* 1163380 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1163463), // Rule ID 15786 //
     /* 1163385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163424 */     // MIs[0] round
     /* 1163424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163462 */     // GIR_Coverage, 15786,
     /* 1163462 */     GIR_EraseRootFromParent_Done,
     /* 1163463 */   // Label 16996: @1163463
     /* 1163463 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1163546), // Rule ID 15787 //
     /* 1163468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163507 */     // MIs[0] round
     /* 1163507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163528 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163545 */     // GIR_Coverage, 15787,
     /* 1163545 */     GIR_EraseRootFromParent_Done,
     /* 1163546 */   // Label 16997: @1163546
     /* 1163546 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1163629), // Rule ID 15790 //
     /* 1163551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163590 */     // MIs[0] round
     /* 1163590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163628 */     // GIR_Coverage, 15790,
     /* 1163628 */     GIR_EraseRootFromParent_Done,
     /* 1163629 */   // Label 16998: @1163629
     /* 1163629 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1163712), // Rule ID 15791 //
     /* 1163634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163673 */     // MIs[0] round
     /* 1163673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163683 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163711 */     // GIR_Coverage, 15791,
     /* 1163711 */     GIR_EraseRootFromParent_Done,
     /* 1163712 */   // Label 16999: @1163712
     /* 1163712 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1163795), // Rule ID 15794 //
     /* 1163717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163756 */     // MIs[0] round
     /* 1163756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163794 */     // GIR_Coverage, 15794,
     /* 1163794 */     GIR_EraseRootFromParent_Done,
     /* 1163795 */   // Label 17000: @1163795
     /* 1163795 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1163878), // Rule ID 15795 //
     /* 1163800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163839 */     // MIs[0] round
     /* 1163839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163849 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163860 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163877 */     // GIR_Coverage, 15795,
     /* 1163877 */     GIR_EraseRootFromParent_Done,
     /* 1163878 */   // Label 17001: @1163878
     /* 1163878 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1163961), // Rule ID 15798 //
     /* 1163883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163922 */     // MIs[0] round
     /* 1163922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163960 */     // GIR_Coverage, 15798,
     /* 1163960 */     GIR_EraseRootFromParent_Done,
     /* 1163961 */   // Label 17002: @1163961
     /* 1163961 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1164044), // Rule ID 15799 //
     /* 1163966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164005 */     // MIs[0] round
     /* 1164005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164015 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1164018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164026 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164043 */     // GIR_Coverage, 15799,
     /* 1164043 */     GIR_EraseRootFromParent_Done,
     /* 1164044 */   // Label 17003: @1164044
     /* 1164044 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1164127), // Rule ID 15802 //
     /* 1164049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1164060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1164063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1164066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164088 */     // MIs[0] round
     /* 1164088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1164101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164126 */     // GIR_Coverage, 15802,
     /* 1164126 */     GIR_EraseRootFromParent_Done,
     /* 1164127 */   // Label 17004: @1164127
     /* 1164127 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1164210), // Rule ID 15803 //
     /* 1164132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1164143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1164146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1164149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164171 */     // MIs[0] round
     /* 1164171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1164184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164192 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164209 */     // GIR_Coverage, 15803,
     /* 1164209 */     GIR_EraseRootFromParent_Done,
     /* 1164210 */   // Label 17005: @1164210
     /* 1164210 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1164293), // Rule ID 15806 //
     /* 1164215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1164226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1164229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1164232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164254 */     // MIs[0] round
     /* 1164254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1164267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164292 */     // GIR_Coverage, 15806,
     /* 1164292 */     GIR_EraseRootFromParent_Done,
     /* 1164293 */   // Label 17006: @1164293
     /* 1164293 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1164376), // Rule ID 15807 //
     /* 1164298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1164309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1164312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1164315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164337 */     // MIs[0] round
     /* 1164337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164347 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1164350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164358 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164375 */     // GIR_Coverage, 15807,
     /* 1164375 */     GIR_EraseRootFromParent_Done,
     /* 1164376 */   // Label 17007: @1164376
     /* 1164376 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1164459), // Rule ID 15810 //
     /* 1164381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1164384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164420 */     // MIs[0] round
     /* 1164420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164458 */     // GIR_Coverage, 15810,
     /* 1164458 */     GIR_EraseRootFromParent_Done,
     /* 1164459 */   // Label 17008: @1164459
     /* 1164459 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1164542), // Rule ID 15811 //
     /* 1164464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164503 */     // MIs[0] round
     /* 1164503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164513 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164524 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164541 */     // GIR_Coverage, 15811,
     /* 1164541 */     GIR_EraseRootFromParent_Done,
     /* 1164542 */   // Label 17009: @1164542
     /* 1164542 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1164622), // Rule ID 15814 //
     /* 1164547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164586 */     // MIs[0] round
     /* 1164586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164621 */     // GIR_Coverage, 15814,
     /* 1164621 */     GIR_EraseRootFromParent_Done,
     /* 1164622 */   // Label 17010: @1164622
     /* 1164622 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1164702), // Rule ID 15815 //
     /* 1164627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164666 */     // MIs[0] round
     /* 1164666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164701 */     // GIR_Coverage, 15815,
     /* 1164701 */     GIR_EraseRootFromParent_Done,
     /* 1164702 */   // Label 17011: @1164702
     /* 1164702 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1164782), // Rule ID 15818 //
     /* 1164707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164746 */     // MIs[0] round
     /* 1164746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164756 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164781 */     // GIR_Coverage, 15818,
     /* 1164781 */     GIR_EraseRootFromParent_Done,
     /* 1164782 */   // Label 17012: @1164782
     /* 1164782 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1164862), // Rule ID 15819 //
     /* 1164787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164826 */     // MIs[0] round
     /* 1164826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164861 */     // GIR_Coverage, 15819,
     /* 1164861 */     GIR_EraseRootFromParent_Done,
     /* 1164862 */   // Label 17013: @1164862
     /* 1164862 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1164942), // Rule ID 15822 //
     /* 1164867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164906 */     // MIs[0] round
     /* 1164906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164941 */     // GIR_Coverage, 15822,
     /* 1164941 */     GIR_EraseRootFromParent_Done,
     /* 1164942 */   // Label 17014: @1164942
     /* 1164942 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1165022), // Rule ID 15823 //
     /* 1164947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164986 */     // MIs[0] round
     /* 1164986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165021 */     // GIR_Coverage, 15823,
     /* 1165021 */     GIR_EraseRootFromParent_Done,
     /* 1165022 */   // Label 17015: @1165022
     /* 1165022 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1165102), // Rule ID 15826 //
     /* 1165027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1165038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1165041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1165044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1165047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165066 */     // MIs[0] round
     /* 1165066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1165079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165101 */     // GIR_Coverage, 15826,
     /* 1165101 */     GIR_EraseRootFromParent_Done,
     /* 1165102 */   // Label 17016: @1165102
     /* 1165102 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1165182), // Rule ID 15827 //
     /* 1165107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1165118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1165121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1165124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1165127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165146 */     // MIs[0] round
     /* 1165146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1165159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165181 */     // GIR_Coverage, 15827,
     /* 1165181 */     GIR_EraseRootFromParent_Done,
     /* 1165182 */   // Label 17017: @1165182
     /* 1165182 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1165262), // Rule ID 15830 //
     /* 1165187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1165198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1165201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1165204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1165207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165226 */     // MIs[0] round
     /* 1165226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165261 */     // GIR_Coverage, 15830,
     /* 1165261 */     GIR_EraseRootFromParent_Done,
     /* 1165262 */   // Label 17018: @1165262
     /* 1165262 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1165342), // Rule ID 15831 //
     /* 1165267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1165278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1165281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1165284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1165287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165306 */     // MIs[0] round
     /* 1165306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165341 */     // GIR_Coverage, 15831,
     /* 1165341 */     GIR_EraseRootFromParent_Done,
     /* 1165342 */   // Label 17019: @1165342
     /* 1165342 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1165422), // Rule ID 15834 //
     /* 1165347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1165358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1165361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1165364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1165367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165386 */     // MIs[0] round
     /* 1165386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165421 */     // GIR_Coverage, 15834,
     /* 1165421 */     GIR_EraseRootFromParent_Done,
     /* 1165422 */   // Label 17020: @1165422
     /* 1165422 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1165502), // Rule ID 15835 //
     /* 1165427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1165438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1165441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1165444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1165447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165466 */     // MIs[0] round
     /* 1165466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165501 */     // GIR_Coverage, 15835,
     /* 1165501 */     GIR_EraseRootFromParent_Done,
     /* 1165502 */   // Label 17021: @1165502
     /* 1165502 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1165582), // Rule ID 15838 //
     /* 1165507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165546 */     // MIs[0] round
     /* 1165546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165581 */     // GIR_Coverage, 15838,
     /* 1165581 */     GIR_EraseRootFromParent_Done,
     /* 1165582 */   // Label 17022: @1165582
     /* 1165582 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1165662), // Rule ID 15839 //
     /* 1165587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165626 */     // MIs[0] round
     /* 1165626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165636 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165661 */     // GIR_Coverage, 15839,
     /* 1165661 */     GIR_EraseRootFromParent_Done,
     /* 1165662 */   // Label 17023: @1165662
     /* 1165662 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1165742), // Rule ID 15842 //
     /* 1165667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165706 */     // MIs[0] round
     /* 1165706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165741 */     // GIR_Coverage, 15842,
     /* 1165741 */     GIR_EraseRootFromParent_Done,
     /* 1165742 */   // Label 17024: @1165742
     /* 1165742 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1165822), // Rule ID 15843 //
     /* 1165747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165786 */     // MIs[0] round
     /* 1165786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165821 */     // GIR_Coverage, 15843,
     /* 1165821 */     GIR_EraseRootFromParent_Done,
     /* 1165822 */   // Label 17025: @1165822
     /* 1165822 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1165902), // Rule ID 15846 //
     /* 1165827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165866 */     // MIs[0] round
     /* 1165866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165901 */     // GIR_Coverage, 15846,
     /* 1165901 */     GIR_EraseRootFromParent_Done,
     /* 1165902 */   // Label 17026: @1165902
     /* 1165902 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1165982), // Rule ID 15847 //
     /* 1165907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165946 */     // MIs[0] round
     /* 1165946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165981 */     // GIR_Coverage, 15847,
     /* 1165981 */     GIR_EraseRootFromParent_Done,
     /* 1165982 */   // Label 17027: @1165982
     /* 1165982 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1166062), // Rule ID 15850 //
     /* 1165987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166026 */     // MIs[0] round
     /* 1166026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1166039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166061 */     // GIR_Coverage, 15850,
     /* 1166061 */     GIR_EraseRootFromParent_Done,
     /* 1166062 */   // Label 17028: @1166062
     /* 1166062 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1166142), // Rule ID 15851 //
     /* 1166067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1166078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1166081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1166084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1166087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166106 */     // MIs[0] round
     /* 1166106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1166119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166141 */     // GIR_Coverage, 15851,
     /* 1166141 */     GIR_EraseRootFromParent_Done,
     /* 1166142 */   // Label 17029: @1166142
     /* 1166142 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1166222), // Rule ID 15854 //
     /* 1166147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1166158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1166161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1166164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1166167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166186 */     // MIs[0] round
     /* 1166186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166221 */     // GIR_Coverage, 15854,
     /* 1166221 */     GIR_EraseRootFromParent_Done,
     /* 1166222 */   // Label 17030: @1166222
     /* 1166222 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1166302), // Rule ID 15855 //
     /* 1166227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1166238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1166241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1166244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1166247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166266 */     // MIs[0] round
     /* 1166266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166301 */     // GIR_Coverage, 15855,
     /* 1166301 */     GIR_EraseRootFromParent_Done,
     /* 1166302 */   // Label 17031: @1166302
     /* 1166302 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1166382), // Rule ID 15858 //
     /* 1166307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1166318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1166321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1166324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1166327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166346 */     // MIs[0] round
     /* 1166346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166381 */     // GIR_Coverage, 15858,
     /* 1166381 */     GIR_EraseRootFromParent_Done,
     /* 1166382 */   // Label 17032: @1166382
     /* 1166382 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1166462), // Rule ID 15859 //
     /* 1166387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1166398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1166401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1166404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1166407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166426 */     // MIs[0] round
     /* 1166426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166461 */     // GIR_Coverage, 15859,
     /* 1166461 */     GIR_EraseRootFromParent_Done,
     /* 1166462 */   // Label 17033: @1166462
     /* 1166462 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1166542), // Rule ID 15862 //
     /* 1166467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166506 */     // MIs[0] round
     /* 1166506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166516 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166541 */     // GIR_Coverage, 15862,
     /* 1166541 */     GIR_EraseRootFromParent_Done,
     /* 1166542 */   // Label 17034: @1166542
     /* 1166542 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1166622), // Rule ID 15863 //
     /* 1166547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166586 */     // MIs[0] round
     /* 1166586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166621 */     // GIR_Coverage, 15863,
     /* 1166621 */     GIR_EraseRootFromParent_Done,
     /* 1166622 */   // Label 17035: @1166622
     /* 1166622 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1166702), // Rule ID 15866 //
     /* 1166627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166666 */     // MIs[0] round
     /* 1166666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166701 */     // GIR_Coverage, 15866,
     /* 1166701 */     GIR_EraseRootFromParent_Done,
     /* 1166702 */   // Label 17036: @1166702
     /* 1166702 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1166782), // Rule ID 15867 //
     /* 1166707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166746 */     // MIs[0] round
     /* 1166746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166781 */     // GIR_Coverage, 15867,
     /* 1166781 */     GIR_EraseRootFromParent_Done,
     /* 1166782 */   // Label 17037: @1166782
     /* 1166782 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1166862), // Rule ID 15870 //
     /* 1166787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166826 */     // MIs[0] round
     /* 1166826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166861 */     // GIR_Coverage, 15870,
     /* 1166861 */     GIR_EraseRootFromParent_Done,
     /* 1166862 */   // Label 17038: @1166862
     /* 1166862 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1166942), // Rule ID 15871 //
     /* 1166867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166906 */     // MIs[0] round
     /* 1166906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166941 */     // GIR_Coverage, 15871,
     /* 1166941 */     GIR_EraseRootFromParent_Done,
     /* 1166942 */   // Label 17039: @1166942
     /* 1166942 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1167022), // Rule ID 15874 //
     /* 1166947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166986 */     // MIs[0] round
     /* 1166986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167021 */     // GIR_Coverage, 15874,
     /* 1167021 */     GIR_EraseRootFromParent_Done,
     /* 1167022 */   // Label 17040: @1167022
     /* 1167022 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1167102), // Rule ID 15875 //
     /* 1167027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1167038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1167041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1167044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1167047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167066 */     // MIs[0] round
     /* 1167066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167101 */     // GIR_Coverage, 15875,
     /* 1167101 */     GIR_EraseRootFromParent_Done,
     /* 1167102 */   // Label 17041: @1167102
     /* 1167102 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1167182), // Rule ID 15878 //
     /* 1167107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1167118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1167121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1167124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1167127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167146 */     // MIs[0] round
     /* 1167146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167181 */     // GIR_Coverage, 15878,
     /* 1167181 */     GIR_EraseRootFromParent_Done,
     /* 1167182 */   // Label 17042: @1167182
     /* 1167182 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1167262), // Rule ID 15879 //
     /* 1167187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1167198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1167201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1167204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1167207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167226 */     // MIs[0] round
     /* 1167226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167261 */     // GIR_Coverage, 15879,
     /* 1167261 */     GIR_EraseRootFromParent_Done,
     /* 1167262 */   // Label 17043: @1167262
     /* 1167262 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1167342), // Rule ID 15882 //
     /* 1167267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1167278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1167281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1167284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1167287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167306 */     // MIs[0] round
     /* 1167306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167341 */     // GIR_Coverage, 15882,
     /* 1167341 */     GIR_EraseRootFromParent_Done,
     /* 1167342 */   // Label 17044: @1167342
     /* 1167342 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1167422), // Rule ID 15883 //
     /* 1167347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1167358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1167361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1167364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1167367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167386 */     // MIs[0] round
     /* 1167386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167421 */     // GIR_Coverage, 15883,
     /* 1167421 */     GIR_EraseRootFromParent_Done,
     /* 1167422 */   // Label 17045: @1167422
     /* 1167422 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1167502), // Rule ID 15886 //
     /* 1167427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167466 */     // MIs[0] round
     /* 1167466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167501 */     // GIR_Coverage, 15886,
     /* 1167501 */     GIR_EraseRootFromParent_Done,
     /* 1167502 */   // Label 17046: @1167502
     /* 1167502 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1167582), // Rule ID 15887 //
     /* 1167507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167546 */     // MIs[0] round
     /* 1167546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167581 */     // GIR_Coverage, 15887,
     /* 1167581 */     GIR_EraseRootFromParent_Done,
     /* 1167582 */   // Label 17047: @1167582
     /* 1167582 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1167662), // Rule ID 15890 //
     /* 1167587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167626 */     // MIs[0] round
     /* 1167626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167661 */     // GIR_Coverage, 15890,
     /* 1167661 */     GIR_EraseRootFromParent_Done,
     /* 1167662 */   // Label 17048: @1167662
     /* 1167662 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1167742), // Rule ID 15891 //
     /* 1167667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167706 */     // MIs[0] round
     /* 1167706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167741 */     // GIR_Coverage, 15891,
     /* 1167741 */     GIR_EraseRootFromParent_Done,
     /* 1167742 */   // Label 17049: @1167742
     /* 1167742 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1167822), // Rule ID 15894 //
     /* 1167747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167786 */     // MIs[0] round
     /* 1167786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167821 */     // GIR_Coverage, 15894,
     /* 1167821 */     GIR_EraseRootFromParent_Done,
     /* 1167822 */   // Label 17050: @1167822
     /* 1167822 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1167902), // Rule ID 15895 //
     /* 1167827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167866 */     // MIs[0] round
     /* 1167866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167901 */     // GIR_Coverage, 15895,
     /* 1167901 */     GIR_EraseRootFromParent_Done,
     /* 1167902 */   // Label 17051: @1167902
     /* 1167902 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1167982), // Rule ID 15898 //
     /* 1167907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167946 */     // MIs[0] round
     /* 1167946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167981 */     // GIR_Coverage, 15898,
     /* 1167981 */     GIR_EraseRootFromParent_Done,
     /* 1167982 */   // Label 17052: @1167982
     /* 1167982 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1168062), // Rule ID 15899 //
     /* 1167987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1168001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1168004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1168007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168026 */     // MIs[0] round
     /* 1168026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1168039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168061 */     // GIR_Coverage, 15899,
     /* 1168061 */     GIR_EraseRootFromParent_Done,
     /* 1168062 */   // Label 17053: @1168062
     /* 1168062 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1168142), // Rule ID 15902 //
     /* 1168067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1168078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1168081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1168084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168106 */     // MIs[0] round
     /* 1168106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1168119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168141 */     // GIR_Coverage, 15902,
     /* 1168141 */     GIR_EraseRootFromParent_Done,
     /* 1168142 */   // Label 17054: @1168142
     /* 1168142 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1168222), // Rule ID 15903 //
     /* 1168147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1168158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1168161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1168164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168186 */     // MIs[0] round
     /* 1168186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1168199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168221 */     // GIR_Coverage, 15903,
     /* 1168221 */     GIR_EraseRootFromParent_Done,
     /* 1168222 */   // Label 17055: @1168222
     /* 1168222 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1168302), // Rule ID 15906 //
     /* 1168227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168266 */     // MIs[0] round
     /* 1168266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168301 */     // GIR_Coverage, 15906,
     /* 1168301 */     GIR_EraseRootFromParent_Done,
     /* 1168302 */   // Label 17056: @1168302
     /* 1168302 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1168382), // Rule ID 15907 //
     /* 1168307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1168318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1168321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1168324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168346 */     // MIs[0] round
     /* 1168346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168356 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168381 */     // GIR_Coverage, 15907,
     /* 1168381 */     GIR_EraseRootFromParent_Done,
     /* 1168382 */   // Label 17057: @1168382
     /* 1168382 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1168462), // Rule ID 15910 //
     /* 1168387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168426 */     // MIs[0] round
     /* 1168426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168461 */     // GIR_Coverage, 15910,
     /* 1168461 */     GIR_EraseRootFromParent_Done,
     /* 1168462 */   // Label 17058: @1168462
     /* 1168462 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1168542), // Rule ID 15911 //
     /* 1168467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168506 */     // MIs[0] round
     /* 1168506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168516 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168541 */     // GIR_Coverage, 15911,
     /* 1168541 */     GIR_EraseRootFromParent_Done,
     /* 1168542 */   // Label 17059: @1168542
     /* 1168542 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1168622), // Rule ID 15914 //
     /* 1168547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168586 */     // MIs[0] round
     /* 1168586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168621 */     // GIR_Coverage, 15914,
     /* 1168621 */     GIR_EraseRootFromParent_Done,
     /* 1168622 */   // Label 17060: @1168622
     /* 1168622 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1168702), // Rule ID 15915 //
     /* 1168627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168666 */     // MIs[0] round
     /* 1168666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168701 */     // GIR_Coverage, 15915,
     /* 1168701 */     GIR_EraseRootFromParent_Done,
     /* 1168702 */   // Label 17061: @1168702
     /* 1168702 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1168782), // Rule ID 15918 //
     /* 1168707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168746 */     // MIs[0] round
     /* 1168746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168781 */     // GIR_Coverage, 15918,
     /* 1168781 */     GIR_EraseRootFromParent_Done,
     /* 1168782 */   // Label 17062: @1168782
     /* 1168782 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1168862), // Rule ID 15919 //
     /* 1168787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168826 */     // MIs[0] round
     /* 1168826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168861 */     // GIR_Coverage, 15919,
     /* 1168861 */     GIR_EraseRootFromParent_Done,
     /* 1168862 */   // Label 17063: @1168862
     /* 1168862 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1168942), // Rule ID 15922 //
     /* 1168867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168906 */     // MIs[0] round
     /* 1168906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168941 */     // GIR_Coverage, 15922,
     /* 1168941 */     GIR_EraseRootFromParent_Done,
     /* 1168942 */   // Label 17064: @1168942
     /* 1168942 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1169022), // Rule ID 15923 //
     /* 1168947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168986 */     // MIs[0] round
     /* 1168986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169021 */     // GIR_Coverage, 15923,
     /* 1169021 */     GIR_EraseRootFromParent_Done,
     /* 1169022 */   // Label 17065: @1169022
     /* 1169022 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1169102), // Rule ID 15926 //
     /* 1169027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1169038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1169041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1169044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169066 */     // MIs[0] round
     /* 1169066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169101 */     // GIR_Coverage, 15926,
     /* 1169101 */     GIR_EraseRootFromParent_Done,
     /* 1169102 */   // Label 17066: @1169102
     /* 1169102 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1169182), // Rule ID 15927 //
     /* 1169107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1169118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1169121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1169124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169146 */     // MIs[0] round
     /* 1169146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11657:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169181 */     // GIR_Coverage, 15927,
     /* 1169181 */     GIR_EraseRootFromParent_Done,
     /* 1169182 */   // Label 17067: @1169182
     /* 1169182 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1169262), // Rule ID 15930 //
     /* 1169187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169226 */     // MIs[0] round
     /* 1169226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169261 */     // GIR_Coverage, 15930,
     /* 1169261 */     GIR_EraseRootFromParent_Done,
     /* 1169262 */   // Label 17068: @1169262
     /* 1169262 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1169342), // Rule ID 15931 //
     /* 1169267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1169278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1169281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1169284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169306 */     // MIs[0] round
     /* 1169306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169341 */     // GIR_Coverage, 15931,
     /* 1169341 */     GIR_EraseRootFromParent_Done,
     /* 1169342 */   // Label 17069: @1169342
     /* 1169342 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1169422), // Rule ID 15934 //
     /* 1169347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169386 */     // MIs[0] round
     /* 1169386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169421 */     // GIR_Coverage, 15934,
     /* 1169421 */     GIR_EraseRootFromParent_Done,
     /* 1169422 */   // Label 17070: @1169422
     /* 1169422 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1169502), // Rule ID 15935 //
     /* 1169427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1169438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1169441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1169444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169466 */     // MIs[0] round
     /* 1169466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169501 */     // GIR_Coverage, 15935,
     /* 1169501 */     GIR_EraseRootFromParent_Done,
     /* 1169502 */   // Label 17071: @1169502
     /* 1169502 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1169582), // Rule ID 15938 //
     /* 1169507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169546 */     // MIs[0] round
     /* 1169546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169581 */     // GIR_Coverage, 15938,
     /* 1169581 */     GIR_EraseRootFromParent_Done,
     /* 1169582 */   // Label 17072: @1169582
     /* 1169582 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1169662), // Rule ID 15939 //
     /* 1169587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169626 */     // MIs[0] round
     /* 1169626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169661 */     // GIR_Coverage, 15939,
     /* 1169661 */     GIR_EraseRootFromParent_Done,
     /* 1169662 */   // Label 17073: @1169662
     /* 1169662 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1169742), // Rule ID 15942 //
     /* 1169667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169706 */     // MIs[0] round
     /* 1169706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169741 */     // GIR_Coverage, 15942,
     /* 1169741 */     GIR_EraseRootFromParent_Done,
     /* 1169742 */   // Label 17074: @1169742
     /* 1169742 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1169822), // Rule ID 15943 //
     /* 1169747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169786 */     // MIs[0] round
     /* 1169786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169821 */     // GIR_Coverage, 15943,
     /* 1169821 */     GIR_EraseRootFromParent_Done,
     /* 1169822 */   // Label 17075: @1169822
     /* 1169822 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1169902), // Rule ID 15946 //
     /* 1169827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169866 */     // MIs[0] round
     /* 1169866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169901 */     // GIR_Coverage, 15946,
     /* 1169901 */     GIR_EraseRootFromParent_Done,
     /* 1169902 */   // Label 17076: @1169902
     /* 1169902 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1169982), // Rule ID 15947 //
     /* 1169907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169946 */     // MIs[0] round
     /* 1169946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169981 */     // GIR_Coverage, 15947,
     /* 1169981 */     GIR_EraseRootFromParent_Done,
     /* 1169982 */   // Label 17077: @1169982
     /* 1169982 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1170062), // Rule ID 15950 //
     /* 1169987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1170001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1170004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170026 */     // MIs[0] round
     /* 1170026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170061 */     // GIR_Coverage, 15950,
     /* 1170061 */     GIR_EraseRootFromParent_Done,
     /* 1170062 */   // Label 17078: @1170062
     /* 1170062 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1170142), // Rule ID 15951 //
     /* 1170067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1170078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1170081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1170084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170106 */     // MIs[0] round
     /* 1170106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170141 */     // GIR_Coverage, 15951,
     /* 1170141 */     GIR_EraseRootFromParent_Done,
     /* 1170142 */   // Label 17079: @1170142
     /* 1170142 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1170222), // Rule ID 15954 //
     /* 1170147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170186 */     // MIs[0] round
     /* 1170186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170221 */     // GIR_Coverage, 15954,
     /* 1170221 */     GIR_EraseRootFromParent_Done,
     /* 1170222 */   // Label 17080: @1170222
     /* 1170222 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1170302), // Rule ID 15955 //
     /* 1170227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1170238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1170241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1170244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170266 */     // MIs[0] round
     /* 1170266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170301 */     // GIR_Coverage, 15955,
     /* 1170301 */     GIR_EraseRootFromParent_Done,
     /* 1170302 */   // Label 17081: @1170302
     /* 1170302 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1170382), // Rule ID 15958 //
     /* 1170307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170346 */     // MIs[0] round
     /* 1170346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170381 */     // GIR_Coverage, 15958,
     /* 1170381 */     GIR_EraseRootFromParent_Done,
     /* 1170382 */   // Label 17082: @1170382
     /* 1170382 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1170462), // Rule ID 15959 //
     /* 1170387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1170398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1170401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1170404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170426 */     // MIs[0] round
     /* 1170426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170461 */     // GIR_Coverage, 15959,
     /* 1170461 */     GIR_EraseRootFromParent_Done,
     /* 1170462 */   // Label 17083: @1170462
     /* 1170462 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1170542), // Rule ID 15962 //
     /* 1170467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170506 */     // MIs[0] round
     /* 1170506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170541 */     // GIR_Coverage, 15962,
     /* 1170541 */     GIR_EraseRootFromParent_Done,
     /* 1170542 */   // Label 17084: @1170542
     /* 1170542 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1170622), // Rule ID 15963 //
     /* 1170547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170586 */     // MIs[0] round
     /* 1170586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170621 */     // GIR_Coverage, 15963,
     /* 1170621 */     GIR_EraseRootFromParent_Done,
     /* 1170622 */   // Label 17085: @1170622
     /* 1170622 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1170702), // Rule ID 15966 //
     /* 1170627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170666 */     // MIs[0] round
     /* 1170666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170701 */     // GIR_Coverage, 15966,
     /* 1170701 */     GIR_EraseRootFromParent_Done,
     /* 1170702 */   // Label 17086: @1170702
     /* 1170702 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1170782), // Rule ID 15967 //
     /* 1170707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170746 */     // MIs[0] round
     /* 1170746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170781 */     // GIR_Coverage, 15967,
     /* 1170781 */     GIR_EraseRootFromParent_Done,
     /* 1170782 */   // Label 17087: @1170782
     /* 1170782 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1170862), // Rule ID 15970 //
     /* 1170787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170826 */     // MIs[0] round
     /* 1170826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170861 */     // GIR_Coverage, 15970,
     /* 1170861 */     GIR_EraseRootFromParent_Done,
     /* 1170862 */   // Label 17088: @1170862
     /* 1170862 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1170942), // Rule ID 15971 //
     /* 1170867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170906 */     // MIs[0] round
     /* 1170906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170941 */     // GIR_Coverage, 15971,
     /* 1170941 */     GIR_EraseRootFromParent_Done,
     /* 1170942 */   // Label 17089: @1170942
     /* 1170942 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1171022), // Rule ID 15974 //
     /* 1170947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170986 */     // MIs[0] round
     /* 1170986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171021 */     // GIR_Coverage, 15974,
     /* 1171021 */     GIR_EraseRootFromParent_Done,
     /* 1171022 */   // Label 17090: @1171022
     /* 1171022 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1171102), // Rule ID 15975 //
     /* 1171027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1171038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1171041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1171044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171066 */     // MIs[0] round
     /* 1171066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171101 */     // GIR_Coverage, 15975,
     /* 1171101 */     GIR_EraseRootFromParent_Done,
     /* 1171102 */   // Label 17091: @1171102
     /* 1171102 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1171182), // Rule ID 15978 //
     /* 1171107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1171118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1171121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1171124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171146 */     // MIs[0] round
     /* 1171146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1171159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171181 */     // GIR_Coverage, 15978,
     /* 1171181 */     GIR_EraseRootFromParent_Done,
     /* 1171182 */   // Label 17092: @1171182
     /* 1171182 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1171262), // Rule ID 15979 //
     /* 1171187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1171198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1171201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1171204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171226 */     // MIs[0] round
     /* 1171226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1171239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171261 */     // GIR_Coverage, 15979,
     /* 1171261 */     GIR_EraseRootFromParent_Done,
     /* 1171262 */   // Label 17093: @1171262
     /* 1171262 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1171342), // Rule ID 15982 //
     /* 1171267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171306 */     // MIs[0] round
     /* 1171306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1171319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171341 */     // GIR_Coverage, 15982,
     /* 1171341 */     GIR_EraseRootFromParent_Done,
     /* 1171342 */   // Label 17094: @1171342
     /* 1171342 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1171422), // Rule ID 15983 //
     /* 1171347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1171358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1171361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1171364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171386 */     // MIs[0] round
     /* 1171386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1171399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171421 */     // GIR_Coverage, 15983,
     /* 1171421 */     GIR_EraseRootFromParent_Done,
     /* 1171422 */   // Label 17095: @1171422
     /* 1171422 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1171502), // Rule ID 15986 //
     /* 1171427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171466 */     // MIs[0] round
     /* 1171466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171501 */     // GIR_Coverage, 15986,
     /* 1171501 */     GIR_EraseRootFromParent_Done,
     /* 1171502 */   // Label 17096: @1171502
     /* 1171502 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1171582), // Rule ID 15987 //
     /* 1171507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171546 */     // MIs[0] round
     /* 1171546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171581 */     // GIR_Coverage, 15987,
     /* 1171581 */     GIR_EraseRootFromParent_Done,
     /* 1171582 */   // Label 17097: @1171582
     /* 1171582 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1171662), // Rule ID 16078 //
     /* 1171587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171626 */     // MIs[0] round
     /* 1171626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171661 */     // GIR_Coverage, 16078,
     /* 1171661 */     GIR_EraseRootFromParent_Done,
     /* 1171662 */   // Label 17098: @1171662
     /* 1171662 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1171742), // Rule ID 16079 //
     /* 1171667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171706 */     // MIs[0] round
     /* 1171706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171716 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171741 */     // GIR_Coverage, 16079,
     /* 1171741 */     GIR_EraseRootFromParent_Done,
     /* 1171742 */   // Label 17099: @1171742
     /* 1171742 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1171822), // Rule ID 16082 //
     /* 1171747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171786 */     // MIs[0] round
     /* 1171786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171796 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171821 */     // GIR_Coverage, 16082,
     /* 1171821 */     GIR_EraseRootFromParent_Done,
     /* 1171822 */   // Label 17100: @1171822
     /* 1171822 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1171902), // Rule ID 16083 //
     /* 1171827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171866 */     // MIs[0] round
     /* 1171866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171876 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171901 */     // GIR_Coverage, 16083,
     /* 1171901 */     GIR_EraseRootFromParent_Done,
     /* 1171902 */   // Label 17101: @1171902
     /* 1171902 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1171982), // Rule ID 16086 //
     /* 1171907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171946 */     // MIs[0] round
     /* 1171946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171956 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171981 */     // GIR_Coverage, 16086,
     /* 1171981 */     GIR_EraseRootFromParent_Done,
     /* 1171982 */   // Label 17102: @1171982
     /* 1171982 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1172062), // Rule ID 16087 //
     /* 1171987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1172001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1172004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1172007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172026 */     // MIs[0] round
     /* 1172026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172061 */     // GIR_Coverage, 16087,
     /* 1172061 */     GIR_EraseRootFromParent_Done,
     /* 1172062 */   // Label 17103: @1172062
     /* 1172062 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1172142), // Rule ID 16090 //
     /* 1172067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1172078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1172081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1172084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1172087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172106 */     // MIs[0] round
     /* 1172106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1172119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172141 */     // GIR_Coverage, 16090,
     /* 1172141 */     GIR_EraseRootFromParent_Done,
     /* 1172142 */   // Label 17104: @1172142
     /* 1172142 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1172222), // Rule ID 16091 //
     /* 1172147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1172158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1172161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1172164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1172167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172186 */     // MIs[0] round
     /* 1172186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1172199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172221 */     // GIR_Coverage, 16091,
     /* 1172221 */     GIR_EraseRootFromParent_Done,
     /* 1172222 */   // Label 17105: @1172222
     /* 1172222 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1172302), // Rule ID 16094 //
     /* 1172227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1172247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172266 */     // MIs[0] round
     /* 1172266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172301 */     // GIR_Coverage, 16094,
     /* 1172301 */     GIR_EraseRootFromParent_Done,
     /* 1172302 */   // Label 17106: @1172302
     /* 1172302 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1172382), // Rule ID 16095 //
     /* 1172307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1172318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1172321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1172324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1172327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172346 */     // MIs[0] round
     /* 1172346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172381 */     // GIR_Coverage, 16095,
     /* 1172381 */     GIR_EraseRootFromParent_Done,
     /* 1172382 */   // Label 17107: @1172382
     /* 1172382 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1172462), // Rule ID 16098 //
     /* 1172387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172426 */     // MIs[0] round
     /* 1172426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172461 */     // GIR_Coverage, 16098,
     /* 1172461 */     GIR_EraseRootFromParent_Done,
     /* 1172462 */   // Label 17108: @1172462
     /* 1172462 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1172542), // Rule ID 16099 //
     /* 1172467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172506 */     // MIs[0] round
     /* 1172506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172541 */     // GIR_Coverage, 16099,
     /* 1172541 */     GIR_EraseRootFromParent_Done,
     /* 1172542 */   // Label 17109: @1172542
     /* 1172542 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1172622), // Rule ID 16102 //
     /* 1172547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172586 */     // MIs[0] round
     /* 1172586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172621 */     // GIR_Coverage, 16102,
     /* 1172621 */     GIR_EraseRootFromParent_Done,
     /* 1172622 */   // Label 17110: @1172622
     /* 1172622 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1172702), // Rule ID 16103 //
     /* 1172627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172666 */     // MIs[0] round
     /* 1172666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172701 */     // GIR_Coverage, 16103,
     /* 1172701 */     GIR_EraseRootFromParent_Done,
     /* 1172702 */   // Label 17111: @1172702
     /* 1172702 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1172782), // Rule ID 16106 //
     /* 1172707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172746 */     // MIs[0] round
     /* 1172746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172781 */     // GIR_Coverage, 16106,
     /* 1172781 */     GIR_EraseRootFromParent_Done,
     /* 1172782 */   // Label 17112: @1172782
     /* 1172782 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1172862), // Rule ID 16107 //
     /* 1172787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172826 */     // MIs[0] round
     /* 1172826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172861 */     // GIR_Coverage, 16107,
     /* 1172861 */     GIR_EraseRootFromParent_Done,
     /* 1172862 */   // Label 17113: @1172862
     /* 1172862 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1172942), // Rule ID 16110 //
     /* 1172867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172906 */     // MIs[0] round
     /* 1172906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172941 */     // GIR_Coverage, 16110,
     /* 1172941 */     GIR_EraseRootFromParent_Done,
     /* 1172942 */   // Label 17114: @1172942
     /* 1172942 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1173022), // Rule ID 16111 //
     /* 1172947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172986 */     // MIs[0] round
     /* 1172986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173021 */     // GIR_Coverage, 16111,
     /* 1173021 */     GIR_EraseRootFromParent_Done,
     /* 1173022 */   // Label 17115: @1173022
     /* 1173022 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1173102), // Rule ID 16114 //
     /* 1173027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1173038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1173041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1173044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1173047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173066 */     // MIs[0] round
     /* 1173066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1173079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173101 */     // GIR_Coverage, 16114,
     /* 1173101 */     GIR_EraseRootFromParent_Done,
     /* 1173102 */   // Label 17116: @1173102
     /* 1173102 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1173182), // Rule ID 16115 //
     /* 1173107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1173118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1173121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1173124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1173127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173146 */     // MIs[0] round
     /* 1173146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1173159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173181 */     // GIR_Coverage, 16115,
     /* 1173181 */     GIR_EraseRootFromParent_Done,
     /* 1173182 */   // Label 17117: @1173182
     /* 1173182 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1173262), // Rule ID 16118 //
     /* 1173187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1173207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173226 */     // MIs[0] round
     /* 1173226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173261 */     // GIR_Coverage, 16118,
     /* 1173261 */     GIR_EraseRootFromParent_Done,
     /* 1173262 */   // Label 17118: @1173262
     /* 1173262 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1173342), // Rule ID 16119 //
     /* 1173267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1173278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1173281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1173284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1173287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173306 */     // MIs[0] round
     /* 1173306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173341 */     // GIR_Coverage, 16119,
     /* 1173341 */     GIR_EraseRootFromParent_Done,
     /* 1173342 */   // Label 17119: @1173342
     /* 1173342 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1173422), // Rule ID 16122 //
     /* 1173347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1173367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173386 */     // MIs[0] round
     /* 1173386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173421 */     // GIR_Coverage, 16122,
     /* 1173421 */     GIR_EraseRootFromParent_Done,
     /* 1173422 */   // Label 17120: @1173422
     /* 1173422 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1173502), // Rule ID 16123 //
     /* 1173427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1173438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1173441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1173444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1173447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173466 */     // MIs[0] round
     /* 1173466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173501 */     // GIR_Coverage, 16123,
     /* 1173501 */     GIR_EraseRootFromParent_Done,
     /* 1173502 */   // Label 17121: @1173502
     /* 1173502 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1173582), // Rule ID 16126 //
     /* 1173507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173546 */     // MIs[0] round
     /* 1173546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173581 */     // GIR_Coverage, 16126,
     /* 1173581 */     GIR_EraseRootFromParent_Done,
     /* 1173582 */   // Label 17122: @1173582
     /* 1173582 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1173662), // Rule ID 16127 //
     /* 1173587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173626 */     // MIs[0] round
     /* 1173626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173636 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173661 */     // GIR_Coverage, 16127,
     /* 1173661 */     GIR_EraseRootFromParent_Done,
     /* 1173662 */   // Label 17123: @1173662
     /* 1173662 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1173742), // Rule ID 16130 //
     /* 1173667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173706 */     // MIs[0] round
     /* 1173706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173741 */     // GIR_Coverage, 16130,
     /* 1173741 */     GIR_EraseRootFromParent_Done,
     /* 1173742 */   // Label 17124: @1173742
     /* 1173742 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1173822), // Rule ID 16131 //
     /* 1173747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173786 */     // MIs[0] round
     /* 1173786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173821 */     // GIR_Coverage, 16131,
     /* 1173821 */     GIR_EraseRootFromParent_Done,
     /* 1173822 */   // Label 17125: @1173822
     /* 1173822 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1173902), // Rule ID 16134 //
     /* 1173827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173866 */     // MIs[0] round
     /* 1173866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173901 */     // GIR_Coverage, 16134,
     /* 1173901 */     GIR_EraseRootFromParent_Done,
     /* 1173902 */   // Label 17126: @1173902
     /* 1173902 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1173982), // Rule ID 16135 //
     /* 1173907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173946 */     // MIs[0] round
     /* 1173946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173981 */     // GIR_Coverage, 16135,
     /* 1173981 */     GIR_EraseRootFromParent_Done,
     /* 1173982 */   // Label 17127: @1173982
     /* 1173982 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1174062), // Rule ID 16138 //
     /* 1173987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1174001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1174007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174026 */     // MIs[0] round
     /* 1174026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174061 */     // GIR_Coverage, 16138,
     /* 1174061 */     GIR_EraseRootFromParent_Done,
     /* 1174062 */   // Label 17128: @1174062
     /* 1174062 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1174142), // Rule ID 16139 //
     /* 1174067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1174078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1174081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1174087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174106 */     // MIs[0] round
     /* 1174106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174141 */     // GIR_Coverage, 16139,
     /* 1174141 */     GIR_EraseRootFromParent_Done,
     /* 1174142 */   // Label 17129: @1174142
     /* 1174142 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1174222), // Rule ID 16142 //
     /* 1174147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1174167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174186 */     // MIs[0] round
     /* 1174186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174221 */     // GIR_Coverage, 16142,
     /* 1174221 */     GIR_EraseRootFromParent_Done,
     /* 1174222 */   // Label 17130: @1174222
     /* 1174222 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1174302), // Rule ID 16143 //
     /* 1174227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1174238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1174241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1174247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174266 */     // MIs[0] round
     /* 1174266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174301 */     // GIR_Coverage, 16143,
     /* 1174301 */     GIR_EraseRootFromParent_Done,
     /* 1174302 */   // Label 17131: @1174302
     /* 1174302 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1174382), // Rule ID 16146 //
     /* 1174307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1174327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174346 */     // MIs[0] round
     /* 1174346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174381 */     // GIR_Coverage, 16146,
     /* 1174381 */     GIR_EraseRootFromParent_Done,
     /* 1174382 */   // Label 17132: @1174382
     /* 1174382 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1174462), // Rule ID 16147 //
     /* 1174387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1174398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1174401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1174404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1174407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174426 */     // MIs[0] round
     /* 1174426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174461 */     // GIR_Coverage, 16147,
     /* 1174461 */     GIR_EraseRootFromParent_Done,
     /* 1174462 */   // Label 17133: @1174462
     /* 1174462 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1174542), // Rule ID 16150 //
     /* 1174467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174506 */     // MIs[0] round
     /* 1174506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174541 */     // GIR_Coverage, 16150,
     /* 1174541 */     GIR_EraseRootFromParent_Done,
     /* 1174542 */   // Label 17134: @1174542
     /* 1174542 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1174622), // Rule ID 16151 //
     /* 1174547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174586 */     // MIs[0] round
     /* 1174586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174621 */     // GIR_Coverage, 16151,
     /* 1174621 */     GIR_EraseRootFromParent_Done,
     /* 1174622 */   // Label 17135: @1174622
     /* 1174622 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1174702), // Rule ID 16154 //
     /* 1174627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174666 */     // MIs[0] round
     /* 1174666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174701 */     // GIR_Coverage, 16154,
     /* 1174701 */     GIR_EraseRootFromParent_Done,
     /* 1174702 */   // Label 17136: @1174702
     /* 1174702 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1174782), // Rule ID 16155 //
     /* 1174707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174746 */     // MIs[0] round
     /* 1174746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174781 */     // GIR_Coverage, 16155,
     /* 1174781 */     GIR_EraseRootFromParent_Done,
     /* 1174782 */   // Label 17137: @1174782
     /* 1174782 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1174862), // Rule ID 16158 //
     /* 1174787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174826 */     // MIs[0] round
     /* 1174826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174836 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174861 */     // GIR_Coverage, 16158,
     /* 1174861 */     GIR_EraseRootFromParent_Done,
     /* 1174862 */   // Label 17138: @1174862
     /* 1174862 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1174942), // Rule ID 16159 //
     /* 1174867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174906 */     // MIs[0] round
     /* 1174906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174941 */     // GIR_Coverage, 16159,
     /* 1174941 */     GIR_EraseRootFromParent_Done,
     /* 1174942 */   // Label 17139: @1174942
     /* 1174942 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1175022), // Rule ID 16162 //
     /* 1174947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174986 */     // MIs[0] round
     /* 1174986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175021 */     // GIR_Coverage, 16162,
     /* 1175021 */     GIR_EraseRootFromParent_Done,
     /* 1175022 */   // Label 17140: @1175022
     /* 1175022 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1175102), // Rule ID 16163 //
     /* 1175027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1175030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1175038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1175041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1175044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1175047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175066 */     // MIs[0] round
     /* 1175066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1175079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175101 */     // GIR_Coverage, 16163,
     /* 1175101 */     GIR_EraseRootFromParent_Done,
     /* 1175102 */   // Label 17141: @1175102
     /* 1175102 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1175182), // Rule ID 16166 //
     /* 1175107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1175124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175146 */     // MIs[0] round
     /* 1175146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1175159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175181 */     // GIR_Coverage, 16166,
     /* 1175181 */     GIR_EraseRootFromParent_Done,
     /* 1175182 */   // Label 17142: @1175182
     /* 1175182 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1175262), // Rule ID 16167 //
     /* 1175187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1175204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175226 */     // MIs[0] round
     /* 1175226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175236 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1175239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175261 */     // GIR_Coverage, 16167,
     /* 1175261 */     GIR_EraseRootFromParent_Done,
     /* 1175262 */   // Label 17143: @1175262
     /* 1175262 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1175342), // Rule ID 16170 //
     /* 1175267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175306 */     // MIs[0] round
     /* 1175306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175341 */     // GIR_Coverage, 16170,
     /* 1175341 */     GIR_EraseRootFromParent_Done,
     /* 1175342 */   // Label 17144: @1175342
     /* 1175342 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1175422), // Rule ID 16171 //
     /* 1175347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1175358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1175361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1175364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175386 */     // MIs[0] round
     /* 1175386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175421 */     // GIR_Coverage, 16171,
     /* 1175421 */     GIR_EraseRootFromParent_Done,
     /* 1175422 */   // Label 17145: @1175422
     /* 1175422 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1175502), // Rule ID 16174 //
     /* 1175427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175466 */     // MIs[0] round
     /* 1175466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175476 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175501 */     // GIR_Coverage, 16174,
     /* 1175501 */     GIR_EraseRootFromParent_Done,
     /* 1175502 */   // Label 17146: @1175502
     /* 1175502 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1175582), // Rule ID 16175 //
     /* 1175507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175546 */     // MIs[0] round
     /* 1175546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175581 */     // GIR_Coverage, 16175,
     /* 1175581 */     GIR_EraseRootFromParent_Done,
     /* 1175582 */   // Label 17147: @1175582
     /* 1175582 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1175662), // Rule ID 16178 //
     /* 1175587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175626 */     // MIs[0] round
     /* 1175626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175661 */     // GIR_Coverage, 16178,
     /* 1175661 */     GIR_EraseRootFromParent_Done,
     /* 1175662 */   // Label 17148: @1175662
     /* 1175662 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1175742), // Rule ID 16179 //
     /* 1175667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175706 */     // MIs[0] round
     /* 1175706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175741 */     // GIR_Coverage, 16179,
     /* 1175741 */     GIR_EraseRootFromParent_Done,
     /* 1175742 */   // Label 17149: @1175742
     /* 1175742 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1175822), // Rule ID 16182 //
     /* 1175747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175786 */     // MIs[0] round
     /* 1175786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175821 */     // GIR_Coverage, 16182,
     /* 1175821 */     GIR_EraseRootFromParent_Done,
     /* 1175822 */   // Label 17150: @1175822
     /* 1175822 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1175902), // Rule ID 16183 //
     /* 1175827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175866 */     // MIs[0] round
     /* 1175866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175901 */     // GIR_Coverage, 16183,
     /* 1175901 */     GIR_EraseRootFromParent_Done,
     /* 1175902 */   // Label 17151: @1175902
     /* 1175902 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1175982), // Rule ID 16186 //
     /* 1175907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175946 */     // MIs[0] round
     /* 1175946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175956 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175981 */     // GIR_Coverage, 16186,
     /* 1175981 */     GIR_EraseRootFromParent_Done,
     /* 1175982 */   // Label 17152: @1175982
     /* 1175982 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1176062), // Rule ID 16187 //
     /* 1175987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1176004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176026 */     // MIs[0] round
     /* 1176026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1176039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176061 */     // GIR_Coverage, 16187,
     /* 1176061 */     GIR_EraseRootFromParent_Done,
     /* 1176062 */   // Label 17153: @1176062
     /* 1176062 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1176142), // Rule ID 16190 //
     /* 1176067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1176084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176106 */     // MIs[0] round
     /* 1176106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176116 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176141 */     // GIR_Coverage, 16190,
     /* 1176141 */     GIR_EraseRootFromParent_Done,
     /* 1176142 */   // Label 17154: @1176142
     /* 1176142 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1176222), // Rule ID 16191 //
     /* 1176147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1176164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176186 */     // MIs[0] round
     /* 1176186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11655:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176221 */     // GIR_Coverage, 16191,
     /* 1176221 */     GIR_EraseRootFromParent_Done,
     /* 1176222 */   // Label 17155: @1176222
     /* 1176222 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1176302), // Rule ID 16194 //
     /* 1176227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176266 */     // MIs[0] round
     /* 1176266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176301 */     // GIR_Coverage, 16194,
     /* 1176301 */     GIR_EraseRootFromParent_Done,
     /* 1176302 */   // Label 17156: @1176302
     /* 1176302 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1176382), // Rule ID 16195 //
     /* 1176307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1176318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1176321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176346 */     // MIs[0] round
     /* 1176346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176356 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176381 */     // GIR_Coverage, 16195,
     /* 1176381 */     GIR_EraseRootFromParent_Done,
     /* 1176382 */   // Label 17157: @1176382
     /* 1176382 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1176462), // Rule ID 16198 //
     /* 1176387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176426 */     // MIs[0] round
     /* 1176426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176461 */     // GIR_Coverage, 16198,
     /* 1176461 */     GIR_EraseRootFromParent_Done,
     /* 1176462 */   // Label 17158: @1176462
     /* 1176462 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1176542), // Rule ID 16199 //
     /* 1176467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176506 */     // MIs[0] round
     /* 1176506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176541 */     // GIR_Coverage, 16199,
     /* 1176541 */     GIR_EraseRootFromParent_Done,
     /* 1176542 */   // Label 17159: @1176542
     /* 1176542 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1176622), // Rule ID 16202 //
     /* 1176547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1176550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176586 */     // MIs[0] round
     /* 1176586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176621 */     // GIR_Coverage, 16202,
     /* 1176621 */     GIR_EraseRootFromParent_Done,
     /* 1176622 */   // Label 17160: @1176622
     /* 1176622 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1176702), // Rule ID 16203 //
     /* 1176627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1176630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176666 */     // MIs[0] round
     /* 1176666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176676 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176701 */     // GIR_Coverage, 16203,
     /* 1176701 */     GIR_EraseRootFromParent_Done,
     /* 1176702 */   // Label 17161: @1176702
     /* 1176702 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1176782), // Rule ID 16206 //
     /* 1176707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176746 */     // MIs[0] round
     /* 1176746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176781 */     // GIR_Coverage, 16206,
     /* 1176781 */     GIR_EraseRootFromParent_Done,
     /* 1176782 */   // Label 17162: @1176782
     /* 1176782 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1176862), // Rule ID 16207 //
     /* 1176787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176826 */     // MIs[0] round
     /* 1176826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176861 */     // GIR_Coverage, 16207,
     /* 1176861 */     GIR_EraseRootFromParent_Done,
     /* 1176862 */   // Label 17163: @1176862
     /* 1176862 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1176942), // Rule ID 16210 //
     /* 1176867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176906 */     // MIs[0] round
     /* 1176906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176941 */     // GIR_Coverage, 16210,
     /* 1176941 */     GIR_EraseRootFromParent_Done,
     /* 1176942 */   // Label 17164: @1176942
     /* 1176942 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1177022), // Rule ID 16211 //
     /* 1176947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176986 */     // MIs[0] round
     /* 1176986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177021 */     // GIR_Coverage, 16211,
     /* 1177021 */     GIR_EraseRootFromParent_Done,
     /* 1177022 */   // Label 17165: @1177022
     /* 1177022 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1177102), // Rule ID 16214 //
     /* 1177027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1177038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1177041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1177044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177066 */     // MIs[0] round
     /* 1177066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177076 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177101 */     // GIR_Coverage, 16214,
     /* 1177101 */     GIR_EraseRootFromParent_Done,
     /* 1177102 */   // Label 17166: @1177102
     /* 1177102 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1177182), // Rule ID 16215 //
     /* 1177107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1177118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1177121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1177124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177146 */     // MIs[0] round
     /* 1177146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177156 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177181 */     // GIR_Coverage, 16215,
     /* 1177181 */     GIR_EraseRootFromParent_Done,
     /* 1177182 */   // Label 17167: @1177182
     /* 1177182 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1177262), // Rule ID 16218 //
     /* 1177187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177226 */     // MIs[0] round
     /* 1177226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177261 */     // GIR_Coverage, 16218,
     /* 1177261 */     GIR_EraseRootFromParent_Done,
     /* 1177262 */   // Label 17168: @1177262
     /* 1177262 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1177342), // Rule ID 16219 //
     /* 1177267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1177284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177306 */     // MIs[0] round
     /* 1177306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177341 */     // GIR_Coverage, 16219,
     /* 1177341 */     GIR_EraseRootFromParent_Done,
     /* 1177342 */   // Label 17169: @1177342
     /* 1177342 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1177422), // Rule ID 16222 //
     /* 1177347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177386 */     // MIs[0] round
     /* 1177386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177421 */     // GIR_Coverage, 16222,
     /* 1177421 */     GIR_EraseRootFromParent_Done,
     /* 1177422 */   // Label 17170: @1177422
     /* 1177422 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1177502), // Rule ID 16223 //
     /* 1177427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1177444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177466 */     // MIs[0] round
     /* 1177466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177501 */     // GIR_Coverage, 16223,
     /* 1177501 */     GIR_EraseRootFromParent_Done,
     /* 1177502 */   // Label 17171: @1177502
     /* 1177502 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1177582), // Rule ID 16226 //
     /* 1177507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177546 */     // MIs[0] round
     /* 1177546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177581 */     // GIR_Coverage, 16226,
     /* 1177581 */     GIR_EraseRootFromParent_Done,
     /* 1177582 */   // Label 17172: @1177582
     /* 1177582 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1177662), // Rule ID 16227 //
     /* 1177587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177626 */     // MIs[0] round
     /* 1177626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177661 */     // GIR_Coverage, 16227,
     /* 1177661 */     GIR_EraseRootFromParent_Done,
     /* 1177662 */   // Label 17173: @1177662
     /* 1177662 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1177742), // Rule ID 16230 //
     /* 1177667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177706 */     // MIs[0] round
     /* 1177706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177741 */     // GIR_Coverage, 16230,
     /* 1177741 */     GIR_EraseRootFromParent_Done,
     /* 1177742 */   // Label 17174: @1177742
     /* 1177742 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1177822), // Rule ID 16231 //
     /* 1177747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177786 */     // MIs[0] round
     /* 1177786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177821 */     // GIR_Coverage, 16231,
     /* 1177821 */     GIR_EraseRootFromParent_Done,
     /* 1177822 */   // Label 17175: @1177822
     /* 1177822 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1177902), // Rule ID 16234 //
     /* 1177827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177866 */     // MIs[0] round
     /* 1177866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177901 */     // GIR_Coverage, 16234,
     /* 1177901 */     GIR_EraseRootFromParent_Done,
     /* 1177902 */   // Label 17176: @1177902
     /* 1177902 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1177982), // Rule ID 16235 //
     /* 1177907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177946 */     // MIs[0] round
     /* 1177946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177981 */     // GIR_Coverage, 16235,
     /* 1177981 */     GIR_EraseRootFromParent_Done,
     /* 1177982 */   // Label 17177: @1177982
     /* 1177982 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1178062), // Rule ID 16238 //
     /* 1177987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1178001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1178004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178026 */     // MIs[0] round
     /* 1178026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178061 */     // GIR_Coverage, 16238,
     /* 1178061 */     GIR_EraseRootFromParent_Done,
     /* 1178062 */   // Label 17178: @1178062
     /* 1178062 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1178142), // Rule ID 16239 //
     /* 1178067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1178078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1178081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1178084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178106 */     // MIs[0] round
     /* 1178106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178141 */     // GIR_Coverage, 16239,
     /* 1178141 */     GIR_EraseRootFromParent_Done,
     /* 1178142 */   // Label 17179: @1178142
     /* 1178142 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1178222), // Rule ID 16242 //
     /* 1178147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178186 */     // MIs[0] round
     /* 1178186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1178199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178221 */     // GIR_Coverage, 16242,
     /* 1178221 */     GIR_EraseRootFromParent_Done,
     /* 1178222 */   // Label 17180: @1178222
     /* 1178222 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1178302), // Rule ID 16243 //
     /* 1178227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1178238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1178241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178266 */     // MIs[0] round
     /* 1178266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1178279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178301 */     // GIR_Coverage, 16243,
     /* 1178301 */     GIR_EraseRootFromParent_Done,
     /* 1178302 */   // Label 17181: @1178302
     /* 1178302 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1178382), // Rule ID 16246 //
     /* 1178307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178346 */     // MIs[0] round
     /* 1178346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1178359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178381 */     // GIR_Coverage, 16246,
     /* 1178381 */     GIR_EraseRootFromParent_Done,
     /* 1178382 */   // Label 17182: @1178382
     /* 1178382 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1178462), // Rule ID 16247 //
     /* 1178387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1178398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1178401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178426 */     // MIs[0] round
     /* 1178426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1178439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178461 */     // GIR_Coverage, 16247,
     /* 1178461 */     GIR_EraseRootFromParent_Done,
     /* 1178462 */   // Label 17183: @1178462
     /* 1178462 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1178542), // Rule ID 16250 //
     /* 1178467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178506 */     // MIs[0] round
     /* 1178506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178541 */     // GIR_Coverage, 16250,
     /* 1178541 */     GIR_EraseRootFromParent_Done,
     /* 1178542 */   // Label 17184: @1178542
     /* 1178542 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1178622), // Rule ID 16251 //
     /* 1178547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178586 */     // MIs[0] round
     /* 1178586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178621 */     // GIR_Coverage, 16251,
     /* 1178621 */     GIR_EraseRootFromParent_Done,
     /* 1178622 */   // Label 17185: @1178622
     /* 1178622 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1178705), // Rule ID 16342 //
     /* 1178627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178666 */     // MIs[0] round
     /* 1178666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178704 */     // GIR_Coverage, 16342,
     /* 1178704 */     GIR_EraseRootFromParent_Done,
     /* 1178705 */   // Label 17186: @1178705
     /* 1178705 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1178788), // Rule ID 16343 //
     /* 1178710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178749 */     // MIs[0] round
     /* 1178749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178787 */     // GIR_Coverage, 16343,
     /* 1178787 */     GIR_EraseRootFromParent_Done,
     /* 1178788 */   // Label 17187: @1178788
     /* 1178788 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1178871), // Rule ID 16346 //
     /* 1178793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178832 */     // MIs[0] round
     /* 1178832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178842 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178870 */     // GIR_Coverage, 16346,
     /* 1178870 */     GIR_EraseRootFromParent_Done,
     /* 1178871 */   // Label 17188: @1178871
     /* 1178871 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1178954), // Rule ID 16347 //
     /* 1178876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178915 */     // MIs[0] round
     /* 1178915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178925 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178953 */     // GIR_Coverage, 16347,
     /* 1178953 */     GIR_EraseRootFromParent_Done,
     /* 1178954 */   // Label 17189: @1178954
     /* 1178954 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1179037), // Rule ID 16350 //
     /* 1178959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178998 */     // MIs[0] round
     /* 1178998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179008 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179036 */     // GIR_Coverage, 16350,
     /* 1179036 */     GIR_EraseRootFromParent_Done,
     /* 1179037 */   // Label 17190: @1179037
     /* 1179037 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1179120), // Rule ID 16351 //
     /* 1179042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1179053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1179056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1179059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1179062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179081 */     // MIs[0] round
     /* 1179081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179091 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179102 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179119 */     // GIR_Coverage, 16351,
     /* 1179119 */     GIR_EraseRootFromParent_Done,
     /* 1179120 */   // Label 17191: @1179120
     /* 1179120 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1179203), // Rule ID 16354 //
     /* 1179125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1179142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1179145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179164 */     // MIs[0] round
     /* 1179164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179202 */     // GIR_Coverage, 16354,
     /* 1179202 */     GIR_EraseRootFromParent_Done,
     /* 1179203 */   // Label 17192: @1179203
     /* 1179203 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1179286), // Rule ID 16355 //
     /* 1179208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1179225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1179228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179247 */     // MIs[0] round
     /* 1179247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179257 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179285 */     // GIR_Coverage, 16355,
     /* 1179285 */     GIR_EraseRootFromParent_Done,
     /* 1179286 */   // Label 17193: @1179286
     /* 1179286 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1179369), // Rule ID 16358 //
     /* 1179291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179330 */     // MIs[0] round
     /* 1179330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179368 */     // GIR_Coverage, 16358,
     /* 1179368 */     GIR_EraseRootFromParent_Done,
     /* 1179369 */   // Label 17194: @1179369
     /* 1179369 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1179452), // Rule ID 16359 //
     /* 1179374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179413 */     // MIs[0] round
     /* 1179413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179451 */     // GIR_Coverage, 16359,
     /* 1179451 */     GIR_EraseRootFromParent_Done,
     /* 1179452 */   // Label 17195: @1179452
     /* 1179452 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1179535), // Rule ID 16362 //
     /* 1179457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179496 */     // MIs[0] round
     /* 1179496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179534 */     // GIR_Coverage, 16362,
     /* 1179534 */     GIR_EraseRootFromParent_Done,
     /* 1179535 */   // Label 17196: @1179535
     /* 1179535 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1179618), // Rule ID 16363 //
     /* 1179540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179579 */     // MIs[0] round
     /* 1179579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179617 */     // GIR_Coverage, 16363,
     /* 1179617 */     GIR_EraseRootFromParent_Done,
     /* 1179618 */   // Label 17197: @1179618
     /* 1179618 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1179701), // Rule ID 16366 //
     /* 1179623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179662 */     // MIs[0] round
     /* 1179662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179700 */     // GIR_Coverage, 16366,
     /* 1179700 */     GIR_EraseRootFromParent_Done,
     /* 1179701 */   // Label 17198: @1179701
     /* 1179701 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1179784), // Rule ID 16367 //
     /* 1179706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179745 */     // MIs[0] round
     /* 1179745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179755 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179783 */     // GIR_Coverage, 16367,
     /* 1179783 */     GIR_EraseRootFromParent_Done,
     /* 1179784 */   // Label 17199: @1179784
     /* 1179784 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1179867), // Rule ID 16370 //
     /* 1179789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179828 */     // MIs[0] round
     /* 1179828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179866 */     // GIR_Coverage, 16370,
     /* 1179866 */     GIR_EraseRootFromParent_Done,
     /* 1179867 */   // Label 17200: @1179867
     /* 1179867 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1179950), // Rule ID 16371 //
     /* 1179872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179911 */     // MIs[0] round
     /* 1179911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179949 */     // GIR_Coverage, 16371,
     /* 1179949 */     GIR_EraseRootFromParent_Done,
     /* 1179950 */   // Label 17201: @1179950
     /* 1179950 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1180033), // Rule ID 16374 //
     /* 1179955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179994 */     // MIs[0] round
     /* 1179994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180032 */     // GIR_Coverage, 16374,
     /* 1180032 */     GIR_EraseRootFromParent_Done,
     /* 1180033 */   // Label 17202: @1180033
     /* 1180033 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1180116), // Rule ID 16375 //
     /* 1180038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1180049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1180052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1180055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1180058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180077 */     // MIs[0] round
     /* 1180077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180087 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180115 */     // GIR_Coverage, 16375,
     /* 1180115 */     GIR_EraseRootFromParent_Done,
     /* 1180116 */   // Label 17203: @1180116
     /* 1180116 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1180199), // Rule ID 16378 //
     /* 1180121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1180141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180160 */     // MIs[0] round
     /* 1180160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180198 */     // GIR_Coverage, 16378,
     /* 1180198 */     GIR_EraseRootFromParent_Done,
     /* 1180199 */   // Label 17204: @1180199
     /* 1180199 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1180282), // Rule ID 16379 //
     /* 1180204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1180224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180243 */     // MIs[0] round
     /* 1180243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180281 */     // GIR_Coverage, 16379,
     /* 1180281 */     GIR_EraseRootFromParent_Done,
     /* 1180282 */   // Label 17205: @1180282
     /* 1180282 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1180365), // Rule ID 16382 //
     /* 1180287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180326 */     // MIs[0] round
     /* 1180326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180364 */     // GIR_Coverage, 16382,
     /* 1180364 */     GIR_EraseRootFromParent_Done,
     /* 1180365 */   // Label 17206: @1180365
     /* 1180365 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1180448), // Rule ID 16383 //
     /* 1180370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180409 */     // MIs[0] round
     /* 1180409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180430 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180447 */     // GIR_Coverage, 16383,
     /* 1180447 */     GIR_EraseRootFromParent_Done,
     /* 1180448 */   // Label 17207: @1180448
     /* 1180448 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1180531), // Rule ID 16386 //
     /* 1180453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180492 */     // MIs[0] round
     /* 1180492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180530 */     // GIR_Coverage, 16386,
     /* 1180530 */     GIR_EraseRootFromParent_Done,
     /* 1180531 */   // Label 17208: @1180531
     /* 1180531 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1180614), // Rule ID 16387 //
     /* 1180536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180575 */     // MIs[0] round
     /* 1180575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180585 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180596 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180613 */     // GIR_Coverage, 16387,
     /* 1180613 */     GIR_EraseRootFromParent_Done,
     /* 1180614 */   // Label 17209: @1180614
     /* 1180614 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1180697), // Rule ID 16390 //
     /* 1180619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180658 */     // MIs[0] round
     /* 1180658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180696 */     // GIR_Coverage, 16390,
     /* 1180696 */     GIR_EraseRootFromParent_Done,
     /* 1180697 */   // Label 17210: @1180697
     /* 1180697 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1180780), // Rule ID 16391 //
     /* 1180702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180741 */     // MIs[0] round
     /* 1180741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180751 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180762 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180779 */     // GIR_Coverage, 16391,
     /* 1180779 */     GIR_EraseRootFromParent_Done,
     /* 1180780 */   // Label 17211: @1180780
     /* 1180780 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1180863), // Rule ID 16394 //
     /* 1180785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180824 */     // MIs[0] round
     /* 1180824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180862 */     // GIR_Coverage, 16394,
     /* 1180862 */     GIR_EraseRootFromParent_Done,
     /* 1180863 */   // Label 17212: @1180863
     /* 1180863 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1180946), // Rule ID 16395 //
     /* 1180868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180907 */     // MIs[0] round
     /* 1180907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180928 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180945 */     // GIR_Coverage, 16395,
     /* 1180945 */     GIR_EraseRootFromParent_Done,
     /* 1180946 */   // Label 17213: @1180946
     /* 1180946 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1181029), // Rule ID 16398 //
     /* 1180951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180990 */     // MIs[0] round
     /* 1180990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1181003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181028 */     // GIR_Coverage, 16398,
     /* 1181028 */     GIR_EraseRootFromParent_Done,
     /* 1181029 */   // Label 17214: @1181029
     /* 1181029 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1181112), // Rule ID 16399 //
     /* 1181034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1181037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1181045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1181048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1181051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1181054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181073 */     // MIs[0] round
     /* 1181073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181083 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1181086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1181104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181111 */     // GIR_Coverage, 16399,
     /* 1181111 */     GIR_EraseRootFromParent_Done,
     /* 1181112 */   // Label 17215: @1181112
     /* 1181112 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1181195), // Rule ID 16402 //
     /* 1181117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1181128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1181131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1181134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181156 */     // MIs[0] round
     /* 1181156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1181169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181194 */     // GIR_Coverage, 16402,
     /* 1181194 */     GIR_EraseRootFromParent_Done,
     /* 1181195 */   // Label 17216: @1181195
     /* 1181195 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1181278), // Rule ID 16403 //
     /* 1181200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1181211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1181214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1181217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181239 */     // MIs[0] round
     /* 1181239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181249 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1181252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181277 */     // GIR_Coverage, 16403,
     /* 1181277 */     GIR_EraseRootFromParent_Done,
     /* 1181278 */   // Label 17217: @1181278
     /* 1181278 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1181361), // Rule ID 16406 //
     /* 1181283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181322 */     // MIs[0] round
     /* 1181322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181360 */     // GIR_Coverage, 16406,
     /* 1181360 */     GIR_EraseRootFromParent_Done,
     /* 1181361 */   // Label 17218: @1181361
     /* 1181361 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1181444), // Rule ID 16407 //
     /* 1181366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181405 */     // MIs[0] round
     /* 1181405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181415 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181443 */     // GIR_Coverage, 16407,
     /* 1181443 */     GIR_EraseRootFromParent_Done,
     /* 1181444 */   // Label 17219: @1181444
     /* 1181444 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1181527), // Rule ID 16410 //
     /* 1181449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181488 */     // MIs[0] round
     /* 1181488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181498 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181526 */     // GIR_Coverage, 16410,
     /* 1181526 */     GIR_EraseRootFromParent_Done,
     /* 1181527 */   // Label 17220: @1181527
     /* 1181527 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1181610), // Rule ID 16411 //
     /* 1181532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181571 */     // MIs[0] round
     /* 1181571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181581 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181609 */     // GIR_Coverage, 16411,
     /* 1181609 */     GIR_EraseRootFromParent_Done,
     /* 1181610 */   // Label 17221: @1181610
     /* 1181610 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1181693), // Rule ID 16414 //
     /* 1181615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181654 */     // MIs[0] round
     /* 1181654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181692 */     // GIR_Coverage, 16414,
     /* 1181692 */     GIR_EraseRootFromParent_Done,
     /* 1181693 */   // Label 17222: @1181693
     /* 1181693 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1181776), // Rule ID 16415 //
     /* 1181698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181737 */     // MIs[0] round
     /* 1181737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181747 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181775 */     // GIR_Coverage, 16415,
     /* 1181775 */     GIR_EraseRootFromParent_Done,
     /* 1181776 */   // Label 17223: @1181776
     /* 1181776 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1181859), // Rule ID 16418 //
     /* 1181781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181820 */     // MIs[0] round
     /* 1181820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181858 */     // GIR_Coverage, 16418,
     /* 1181858 */     GIR_EraseRootFromParent_Done,
     /* 1181859 */   // Label 17224: @1181859
     /* 1181859 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1181942), // Rule ID 16419 //
     /* 1181864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181903 */     // MIs[0] round
     /* 1181903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181924 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181941 */     // GIR_Coverage, 16419,
     /* 1181941 */     GIR_EraseRootFromParent_Done,
     /* 1181942 */   // Label 17225: @1181942
     /* 1181942 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1182025), // Rule ID 16422 //
     /* 1181947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181986 */     // MIs[0] round
     /* 1181986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182024 */     // GIR_Coverage, 16422,
     /* 1182024 */     GIR_EraseRootFromParent_Done,
     /* 1182025 */   // Label 17226: @1182025
     /* 1182025 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1182108), // Rule ID 16423 //
     /* 1182030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1182041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1182044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1182047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182069 */     // MIs[0] round
     /* 1182069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182079 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182090 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182107 */     // GIR_Coverage, 16423,
     /* 1182107 */     GIR_EraseRootFromParent_Done,
     /* 1182108 */   // Label 17227: @1182108
     /* 1182108 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1182191), // Rule ID 16426 //
     /* 1182113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1182124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1182127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182152 */     // MIs[0] round
     /* 1182152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1182165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182190 */     // GIR_Coverage, 16426,
     /* 1182190 */     GIR_EraseRootFromParent_Done,
     /* 1182191 */   // Label 17228: @1182191
     /* 1182191 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1182274), // Rule ID 16427 //
     /* 1182196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1182207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1182210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182235 */     // MIs[0] round
     /* 1182235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182245 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1182248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182256 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182273 */     // GIR_Coverage, 16427,
     /* 1182273 */     GIR_EraseRootFromParent_Done,
     /* 1182274 */   // Label 17229: @1182274
     /* 1182274 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1182357), // Rule ID 16430 //
     /* 1182279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182318 */     // MIs[0] round
     /* 1182318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182356 */     // GIR_Coverage, 16430,
     /* 1182356 */     GIR_EraseRootFromParent_Done,
     /* 1182357 */   // Label 17230: @1182357
     /* 1182357 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1182440), // Rule ID 16431 //
     /* 1182362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182401 */     // MIs[0] round
     /* 1182401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182439 */     // GIR_Coverage, 16431,
     /* 1182439 */     GIR_EraseRootFromParent_Done,
     /* 1182440 */   // Label 17231: @1182440
     /* 1182440 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1182523), // Rule ID 16434 //
     /* 1182445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182484 */     // MIs[0] round
     /* 1182484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182522 */     // GIR_Coverage, 16434,
     /* 1182522 */     GIR_EraseRootFromParent_Done,
     /* 1182523 */   // Label 17232: @1182523
     /* 1182523 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1182606), // Rule ID 16435 //
     /* 1182528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182567 */     // MIs[0] round
     /* 1182567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182588 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182605 */     // GIR_Coverage, 16435,
     /* 1182605 */     GIR_EraseRootFromParent_Done,
     /* 1182606 */   // Label 17233: @1182606
     /* 1182606 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1182689), // Rule ID 16438 //
     /* 1182611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182650 */     // MIs[0] round
     /* 1182650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182688 */     // GIR_Coverage, 16438,
     /* 1182688 */     GIR_EraseRootFromParent_Done,
     /* 1182689 */   // Label 17234: @1182689
     /* 1182689 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1182772), // Rule ID 16439 //
     /* 1182694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182733 */     // MIs[0] round
     /* 1182733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182771 */     // GIR_Coverage, 16439,
     /* 1182771 */     GIR_EraseRootFromParent_Done,
     /* 1182772 */   // Label 17235: @1182772
     /* 1182772 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1182855), // Rule ID 16442 //
     /* 1182777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182816 */     // MIs[0] round
     /* 1182816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182854 */     // GIR_Coverage, 16442,
     /* 1182854 */     GIR_EraseRootFromParent_Done,
     /* 1182855 */   // Label 17236: @1182855
     /* 1182855 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1182938), // Rule ID 16443 //
     /* 1182860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182899 */     // MIs[0] round
     /* 1182899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182909 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182937 */     // GIR_Coverage, 16443,
     /* 1182937 */     GIR_EraseRootFromParent_Done,
     /* 1182938 */   // Label 17237: @1182938
     /* 1182938 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1183021), // Rule ID 16446 //
     /* 1182943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182982 */     // MIs[0] round
     /* 1182982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183020 */     // GIR_Coverage, 16446,
     /* 1183020 */     GIR_EraseRootFromParent_Done,
     /* 1183021 */   // Label 17238: @1183021
     /* 1183021 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1183104), // Rule ID 16447 //
     /* 1183026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1183043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183065 */     // MIs[0] round
     /* 1183065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183075 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1183078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183103 */     // GIR_Coverage, 16447,
     /* 1183103 */     GIR_EraseRootFromParent_Done,
     /* 1183104 */   // Label 17239: @1183104
     /* 1183104 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1183187), // Rule ID 16450 //
     /* 1183109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1183120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1183123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1183126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183148 */     // MIs[0] round
     /* 1183148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1183161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183186 */     // GIR_Coverage, 16450,
     /* 1183186 */     GIR_EraseRootFromParent_Done,
     /* 1183187 */   // Label 17240: @1183187
     /* 1183187 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1183270), // Rule ID 16451 //
     /* 1183192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1183203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1183206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1183209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183231 */     // MIs[0] round
     /* 1183231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183241 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1183244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183269 */     // GIR_Coverage, 16451,
     /* 1183269 */     GIR_EraseRootFromParent_Done,
     /* 1183270 */   // Label 17241: @1183270
     /* 1183270 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1183353), // Rule ID 16454 //
     /* 1183275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183314 */     // MIs[0] round
     /* 1183314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1183327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183352 */     // GIR_Coverage, 16454,
     /* 1183352 */     GIR_EraseRootFromParent_Done,
     /* 1183353 */   // Label 17242: @1183353
     /* 1183353 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1183436), // Rule ID 16455 //
     /* 1183358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183397 */     // MIs[0] round
     /* 1183397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1183410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183435 */     // GIR_Coverage, 16455,
     /* 1183435 */     GIR_EraseRootFromParent_Done,
     /* 1183436 */   // Label 17243: @1183436
     /* 1183436 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1183519), // Rule ID 16458 //
     /* 1183441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183480 */     // MIs[0] round
     /* 1183480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183518 */     // GIR_Coverage, 16458,
     /* 1183518 */     GIR_EraseRootFromParent_Done,
     /* 1183519 */   // Label 17244: @1183519
     /* 1183519 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1183602), // Rule ID 16459 //
     /* 1183524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183563 */     // MIs[0] round
     /* 1183563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183601 */     // GIR_Coverage, 16459,
     /* 1183601 */     GIR_EraseRootFromParent_Done,
     /* 1183602 */   // Label 17245: @1183602
     /* 1183602 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1183685), // Rule ID 16522 //
     /* 1183607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183646 */     // MIs[0] round
     /* 1183646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183684 */     // GIR_Coverage, 16522,
     /* 1183684 */     GIR_EraseRootFromParent_Done,
     /* 1183685 */   // Label 17246: @1183685
     /* 1183685 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1183768), // Rule ID 16523 //
     /* 1183690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183729 */     // MIs[0] round
     /* 1183729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183739 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183767 */     // GIR_Coverage, 16523,
     /* 1183767 */     GIR_EraseRootFromParent_Done,
     /* 1183768 */   // Label 17247: @1183768
     /* 1183768 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1183851), // Rule ID 16526 //
     /* 1183773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183812 */     // MIs[0] round
     /* 1183812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183850 */     // GIR_Coverage, 16526,
     /* 1183850 */     GIR_EraseRootFromParent_Done,
     /* 1183851 */   // Label 17248: @1183851
     /* 1183851 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1183934), // Rule ID 16527 //
     /* 1183856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183895 */     // MIs[0] round
     /* 1183895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183905 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183933 */     // GIR_Coverage, 16527,
     /* 1183933 */     GIR_EraseRootFromParent_Done,
     /* 1183934 */   // Label 17249: @1183934
     /* 1183934 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1184017), // Rule ID 16530 //
     /* 1183939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183978 */     // MIs[0] round
     /* 1183978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184016 */     // GIR_Coverage, 16530,
     /* 1184016 */     GIR_EraseRootFromParent_Done,
     /* 1184017 */   // Label 17250: @1184017
     /* 1184017 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1184100), // Rule ID 16531 //
     /* 1184022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1184033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1184036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1184039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1184042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184061 */     // MIs[0] round
     /* 1184061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184099 */     // GIR_Coverage, 16531,
     /* 1184099 */     GIR_EraseRootFromParent_Done,
     /* 1184100 */   // Label 17251: @1184100
     /* 1184100 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1184183), // Rule ID 16534 //
     /* 1184105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1184116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1184119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1184125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184144 */     // MIs[0] round
     /* 1184144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184154 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184182 */     // GIR_Coverage, 16534,
     /* 1184182 */     GIR_EraseRootFromParent_Done,
     /* 1184183 */   // Label 17252: @1184183
     /* 1184183 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1184266), // Rule ID 16535 //
     /* 1184188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1184199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1184202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1184208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184227 */     // MIs[0] round
     /* 1184227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184237 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184265 */     // GIR_Coverage, 16535,
     /* 1184265 */     GIR_EraseRootFromParent_Done,
     /* 1184266 */   // Label 17253: @1184266
     /* 1184266 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1184349), // Rule ID 16538 //
     /* 1184271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1184282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1184285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1184291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184310 */     // MIs[0] round
     /* 1184310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184348 */     // GIR_Coverage, 16538,
     /* 1184348 */     GIR_EraseRootFromParent_Done,
     /* 1184349 */   // Label 17254: @1184349
     /* 1184349 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1184432), // Rule ID 16539 //
     /* 1184354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1184365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1184368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1184374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184393 */     // MIs[0] round
     /* 1184393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184403 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184431 */     // GIR_Coverage, 16539,
     /* 1184431 */     GIR_EraseRootFromParent_Done,
     /* 1184432 */   // Label 17255: @1184432
     /* 1184432 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1184515), // Rule ID 16542 //
     /* 1184437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184476 */     // MIs[0] round
     /* 1184476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184514 */     // GIR_Coverage, 16542,
     /* 1184514 */     GIR_EraseRootFromParent_Done,
     /* 1184515 */   // Label 17256: @1184515
     /* 1184515 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1184598), // Rule ID 16543 //
     /* 1184520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184559 */     // MIs[0] round
     /* 1184559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184597 */     // GIR_Coverage, 16543,
     /* 1184597 */     GIR_EraseRootFromParent_Done,
     /* 1184598 */   // Label 17257: @1184598
     /* 1184598 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1184681), // Rule ID 16546 //
     /* 1184603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184642 */     // MIs[0] round
     /* 1184642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184680 */     // GIR_Coverage, 16546,
     /* 1184680 */     GIR_EraseRootFromParent_Done,
     /* 1184681 */   // Label 17258: @1184681
     /* 1184681 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1184764), // Rule ID 16547 //
     /* 1184686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184725 */     // MIs[0] round
     /* 1184725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184735 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184763 */     // GIR_Coverage, 16547,
     /* 1184763 */     GIR_EraseRootFromParent_Done,
     /* 1184764 */   // Label 17259: @1184764
     /* 1184764 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1184847), // Rule ID 16550 //
     /* 1184769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184808 */     // MIs[0] round
     /* 1184808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184846 */     // GIR_Coverage, 16550,
     /* 1184846 */     GIR_EraseRootFromParent_Done,
     /* 1184847 */   // Label 17260: @1184847
     /* 1184847 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1184930), // Rule ID 16551 //
     /* 1184852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184891 */     // MIs[0] round
     /* 1184891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184929 */     // GIR_Coverage, 16551,
     /* 1184929 */     GIR_EraseRootFromParent_Done,
     /* 1184930 */   // Label 17261: @1184930
     /* 1184930 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1185013), // Rule ID 16554 //
     /* 1184935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184974 */     // MIs[0] round
     /* 1184974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185012 */     // GIR_Coverage, 16554,
     /* 1185012 */     GIR_EraseRootFromParent_Done,
     /* 1185013 */   // Label 17262: @1185013
     /* 1185013 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1185096), // Rule ID 16555 //
     /* 1185018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1185029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1185032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1185035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1185038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185057 */     // MIs[0] round
     /* 1185057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185067 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185095 */     // GIR_Coverage, 16555,
     /* 1185095 */     GIR_EraseRootFromParent_Done,
     /* 1185096 */   // Label 17263: @1185096
     /* 1185096 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1185179), // Rule ID 16558 //
     /* 1185101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1185112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1185115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1185121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185140 */     // MIs[0] round
     /* 1185140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185178 */     // GIR_Coverage, 16558,
     /* 1185178 */     GIR_EraseRootFromParent_Done,
     /* 1185179 */   // Label 17264: @1185179
     /* 1185179 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1185262), // Rule ID 16559 //
     /* 1185184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1185195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1185198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1185204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185223 */     // MIs[0] round
     /* 1185223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185261 */     // GIR_Coverage, 16559,
     /* 1185261 */     GIR_EraseRootFromParent_Done,
     /* 1185262 */   // Label 17265: @1185262
     /* 1185262 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1185345), // Rule ID 16562 //
     /* 1185267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1185278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1185281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1185287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185306 */     // MIs[0] round
     /* 1185306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185344 */     // GIR_Coverage, 16562,
     /* 1185344 */     GIR_EraseRootFromParent_Done,
     /* 1185345 */   // Label 17266: @1185345
     /* 1185345 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1185428), // Rule ID 16563 //
     /* 1185350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1185361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1185364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1185370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185389 */     // MIs[0] round
     /* 1185389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185399 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185427 */     // GIR_Coverage, 16563,
     /* 1185427 */     GIR_EraseRootFromParent_Done,
     /* 1185428 */   // Label 17267: @1185428
     /* 1185428 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1185511), // Rule ID 16566 //
     /* 1185433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185472 */     // MIs[0] round
     /* 1185472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185510 */     // GIR_Coverage, 16566,
     /* 1185510 */     GIR_EraseRootFromParent_Done,
     /* 1185511 */   // Label 17268: @1185511
     /* 1185511 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1185594), // Rule ID 16567 //
     /* 1185516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185555 */     // MIs[0] round
     /* 1185555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185565 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185593 */     // GIR_Coverage, 16567,
     /* 1185593 */     GIR_EraseRootFromParent_Done,
     /* 1185594 */   // Label 17269: @1185594
     /* 1185594 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1185677), // Rule ID 16570 //
     /* 1185599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185638 */     // MIs[0] round
     /* 1185638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185676 */     // GIR_Coverage, 16570,
     /* 1185676 */     GIR_EraseRootFromParent_Done,
     /* 1185677 */   // Label 17270: @1185677
     /* 1185677 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1185760), // Rule ID 16571 //
     /* 1185682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185721 */     // MIs[0] round
     /* 1185721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185731 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185759 */     // GIR_Coverage, 16571,
     /* 1185759 */     GIR_EraseRootFromParent_Done,
     /* 1185760 */   // Label 17271: @1185760
     /* 1185760 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1185843), // Rule ID 16574 //
     /* 1185765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185804 */     // MIs[0] round
     /* 1185804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185842 */     // GIR_Coverage, 16574,
     /* 1185842 */     GIR_EraseRootFromParent_Done,
     /* 1185843 */   // Label 17272: @1185843
     /* 1185843 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1185926), // Rule ID 16575 //
     /* 1185848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185887 */     // MIs[0] round
     /* 1185887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185925 */     // GIR_Coverage, 16575,
     /* 1185925 */     GIR_EraseRootFromParent_Done,
     /* 1185926 */   // Label 17273: @1185926
     /* 1185926 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1186009), // Rule ID 16578 //
     /* 1185931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185970 */     // MIs[0] round
     /* 1185970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186008 */     // GIR_Coverage, 16578,
     /* 1186008 */     GIR_EraseRootFromParent_Done,
     /* 1186009 */   // Label 17274: @1186009
     /* 1186009 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1186092), // Rule ID 16579 //
     /* 1186014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1186017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1186025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1186028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1186031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1186034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186053 */     // MIs[0] round
     /* 1186053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186063 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1186066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186091 */     // GIR_Coverage, 16579,
     /* 1186091 */     GIR_EraseRootFromParent_Done,
     /* 1186092 */   // Label 17275: @1186092
     /* 1186092 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1186175), // Rule ID 16582 //
     /* 1186097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1186108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1186111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1186114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186136 */     // MIs[0] round
     /* 1186136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186146 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1186149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186174 */     // GIR_Coverage, 16582,
     /* 1186174 */     GIR_EraseRootFromParent_Done,
     /* 1186175 */   // Label 17276: @1186175
     /* 1186175 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1186258), // Rule ID 16583 //
     /* 1186180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1186191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1186194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1186197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186219 */     // MIs[0] round
     /* 1186219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186229 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1186232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186257 */     // GIR_Coverage, 16583,
     /* 1186257 */     GIR_EraseRootFromParent_Done,
     /* 1186258 */   // Label 17277: @1186258
     /* 1186258 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1186341), // Rule ID 16586 //
     /* 1186263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1186274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1186277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186302 */     // MIs[0] round
     /* 1186302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186340 */     // GIR_Coverage, 16586,
     /* 1186340 */     GIR_EraseRootFromParent_Done,
     /* 1186341 */   // Label 17278: @1186341
     /* 1186341 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1186424), // Rule ID 16587 //
     /* 1186346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1186357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1186360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186385 */     // MIs[0] round
     /* 1186385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186395 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186423 */     // GIR_Coverage, 16587,
     /* 1186423 */     GIR_EraseRootFromParent_Done,
     /* 1186424 */   // Label 17279: @1186424
     /* 1186424 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1186507), // Rule ID 16590 //
     /* 1186429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186468 */     // MIs[0] round
     /* 1186468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186478 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186506 */     // GIR_Coverage, 16590,
     /* 1186506 */     GIR_EraseRootFromParent_Done,
     /* 1186507 */   // Label 17280: @1186507
     /* 1186507 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1186590), // Rule ID 16591 //
     /* 1186512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186551 */     // MIs[0] round
     /* 1186551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186561 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186589 */     // GIR_Coverage, 16591,
     /* 1186589 */     GIR_EraseRootFromParent_Done,
     /* 1186590 */   // Label 17281: @1186590
     /* 1186590 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1186673), // Rule ID 16594 //
     /* 1186595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186634 */     // MIs[0] round
     /* 1186634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186672 */     // GIR_Coverage, 16594,
     /* 1186672 */     GIR_EraseRootFromParent_Done,
     /* 1186673 */   // Label 17282: @1186673
     /* 1186673 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1186756), // Rule ID 16595 //
     /* 1186678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186717 */     // MIs[0] round
     /* 1186717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186738 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186755 */     // GIR_Coverage, 16595,
     /* 1186755 */     GIR_EraseRootFromParent_Done,
     /* 1186756 */   // Label 17283: @1186756
     /* 1186756 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1186839), // Rule ID 16598 //
     /* 1186761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186800 */     // MIs[0] round
     /* 1186800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186838 */     // GIR_Coverage, 16598,
     /* 1186838 */     GIR_EraseRootFromParent_Done,
     /* 1186839 */   // Label 17284: @1186839
     /* 1186839 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1186922), // Rule ID 16599 //
     /* 1186844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186883 */     // MIs[0] round
     /* 1186883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186921 */     // GIR_Coverage, 16599,
     /* 1186921 */     GIR_EraseRootFromParent_Done,
     /* 1186922 */   // Label 17285: @1186922
     /* 1186922 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1187005), // Rule ID 16602 //
     /* 1186927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186966 */     // MIs[0] round
     /* 1186966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186976 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187004 */     // GIR_Coverage, 16602,
     /* 1187004 */     GIR_EraseRootFromParent_Done,
     /* 1187005 */   // Label 17286: @1187005
     /* 1187005 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1187088), // Rule ID 16603 //
     /* 1187010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1187021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1187024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187049 */     // MIs[0] round
     /* 1187049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187059 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1187080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187087 */     // GIR_Coverage, 16603,
     /* 1187087 */     GIR_EraseRootFromParent_Done,
     /* 1187088 */   // Label 17287: @1187088
     /* 1187088 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1187171), // Rule ID 16606 //
     /* 1187093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1187110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187132 */     // MIs[0] round
     /* 1187132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1187145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187170 */     // GIR_Coverage, 16606,
     /* 1187170 */     GIR_EraseRootFromParent_Done,
     /* 1187171 */   // Label 17288: @1187171
     /* 1187171 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1187254), // Rule ID 16607 //
     /* 1187176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1187193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187215 */     // MIs[0] round
     /* 1187215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187225 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1187228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187253 */     // GIR_Coverage, 16607,
     /* 1187253 */     GIR_EraseRootFromParent_Done,
     /* 1187254 */   // Label 17289: @1187254
     /* 1187254 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1187337), // Rule ID 16610 //
     /* 1187259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1187270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1187273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1187276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187298 */     // MIs[0] round
     /* 1187298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187336 */     // GIR_Coverage, 16610,
     /* 1187336 */     GIR_EraseRootFromParent_Done,
     /* 1187337 */   // Label 17290: @1187337
     /* 1187337 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1187420), // Rule ID 16611 //
     /* 1187342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1187353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1187356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1187359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187381 */     // MIs[0] round
     /* 1187381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187391 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187402 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187419 */     // GIR_Coverage, 16611,
     /* 1187419 */     GIR_EraseRootFromParent_Done,
     /* 1187420 */   // Label 17291: @1187420
     /* 1187420 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1187503), // Rule ID 16614 //
     /* 1187425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187464 */     // MIs[0] round
     /* 1187464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187502 */     // GIR_Coverage, 16614,
     /* 1187502 */     GIR_EraseRootFromParent_Done,
     /* 1187503 */   // Label 17292: @1187503
     /* 1187503 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1187586), // Rule ID 16615 //
     /* 1187508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187547 */     // MIs[0] round
     /* 1187547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187557 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187585 */     // GIR_Coverage, 16615,
     /* 1187585 */     GIR_EraseRootFromParent_Done,
     /* 1187586 */   // Label 17293: @1187586
     /* 1187586 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1187669), // Rule ID 16618 //
     /* 1187591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187630 */     // MIs[0] round
     /* 1187630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187668 */     // GIR_Coverage, 16618,
     /* 1187668 */     GIR_EraseRootFromParent_Done,
     /* 1187669 */   // Label 17294: @1187669
     /* 1187669 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1187752), // Rule ID 16619 //
     /* 1187674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187713 */     // MIs[0] round
     /* 1187713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187734 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187751 */     // GIR_Coverage, 16619,
     /* 1187751 */     GIR_EraseRootFromParent_Done,
     /* 1187752 */   // Label 17295: @1187752
     /* 1187752 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1187835), // Rule ID 16622 //
     /* 1187757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187796 */     // MIs[0] round
     /* 1187796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187834 */     // GIR_Coverage, 16622,
     /* 1187834 */     GIR_EraseRootFromParent_Done,
     /* 1187835 */   // Label 17296: @1187835
     /* 1187835 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1187918), // Rule ID 16623 //
     /* 1187840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187879 */     // MIs[0] round
     /* 1187879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187889 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187917 */     // GIR_Coverage, 16623,
     /* 1187917 */     GIR_EraseRootFromParent_Done,
     /* 1187918 */   // Label 17297: @1187918
     /* 1187918 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1188001), // Rule ID 16626 //
     /* 1187923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187962 */     // MIs[0] round
     /* 1187962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188000 */     // GIR_Coverage, 16626,
     /* 1188000 */     GIR_EraseRootFromParent_Done,
     /* 1188001 */   // Label 17298: @1188001
     /* 1188001 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1188084), // Rule ID 16627 //
     /* 1188006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188045 */     // MIs[0] round
     /* 1188045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188055 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1188058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188066 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188083 */     // GIR_Coverage, 16627,
     /* 1188083 */     GIR_EraseRootFromParent_Done,
     /* 1188084 */   // Label 17299: @1188084
     /* 1188084 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1188167), // Rule ID 16630 //
     /* 1188089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188128 */     // MIs[0] round
     /* 1188128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1188141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188166 */     // GIR_Coverage, 16630,
     /* 1188166 */     GIR_EraseRootFromParent_Done,
     /* 1188167 */   // Label 17300: @1188167
     /* 1188167 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1188250), // Rule ID 16631 //
     /* 1188172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1188189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188211 */     // MIs[0] round
     /* 1188211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188221 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1188224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188249 */     // GIR_Coverage, 16631,
     /* 1188249 */     GIR_EraseRootFromParent_Done,
     /* 1188250 */   // Label 17301: @1188250
     /* 1188250 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1188333), // Rule ID 16634 //
     /* 1188255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1188266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1188269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188294 */     // MIs[0] round
     /* 1188294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1188307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188332 */     // GIR_Coverage, 16634,
     /* 1188332 */     GIR_EraseRootFromParent_Done,
     /* 1188333 */   // Label 17302: @1188333
     /* 1188333 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1188416), // Rule ID 16635 //
     /* 1188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1188349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1188352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188377 */     // MIs[0] round
     /* 1188377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1188390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188398 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188415 */     // GIR_Coverage, 16635,
     /* 1188415 */     GIR_EraseRootFromParent_Done,
     /* 1188416 */   // Label 17303: @1188416
     /* 1188416 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1188499), // Rule ID 16638 //
     /* 1188421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1188424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188460 */     // MIs[0] round
     /* 1188460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188498 */     // GIR_Coverage, 16638,
     /* 1188498 */     GIR_EraseRootFromParent_Done,
     /* 1188499 */   // Label 17304: @1188499
     /* 1188499 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1188582), // Rule ID 16639 //
     /* 1188504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188543 */     // MIs[0] round
     /* 1188543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188564 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188581 */     // GIR_Coverage, 16639,
     /* 1188581 */     GIR_EraseRootFromParent_Done,
     /* 1188582 */   // Label 17305: @1188582
     /* 1188582 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1188662), // Rule ID 16702 //
     /* 1188587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188626 */     // MIs[0] round
     /* 1188626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188636 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188661 */     // GIR_Coverage, 16702,
     /* 1188661 */     GIR_EraseRootFromParent_Done,
     /* 1188662 */   // Label 17306: @1188662
     /* 1188662 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1188742), // Rule ID 16703 //
     /* 1188667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188706 */     // MIs[0] round
     /* 1188706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188716 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188741 */     // GIR_Coverage, 16703,
     /* 1188741 */     GIR_EraseRootFromParent_Done,
     /* 1188742 */   // Label 17307: @1188742
     /* 1188742 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1188822), // Rule ID 16706 //
     /* 1188747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188786 */     // MIs[0] round
     /* 1188786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188796 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188821 */     // GIR_Coverage, 16706,
     /* 1188821 */     GIR_EraseRootFromParent_Done,
     /* 1188822 */   // Label 17308: @1188822
     /* 1188822 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1188902), // Rule ID 16707 //
     /* 1188827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188866 */     // MIs[0] round
     /* 1188866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188876 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188901 */     // GIR_Coverage, 16707,
     /* 1188901 */     GIR_EraseRootFromParent_Done,
     /* 1188902 */   // Label 17309: @1188902
     /* 1188902 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1188982), // Rule ID 16710 //
     /* 1188907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188946 */     // MIs[0] round
     /* 1188946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188981 */     // GIR_Coverage, 16710,
     /* 1188981 */     GIR_EraseRootFromParent_Done,
     /* 1188982 */   // Label 17310: @1188982
     /* 1188982 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1189062), // Rule ID 16711 //
     /* 1188987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1189001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1189004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1189007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189026 */     // MIs[0] round
     /* 1189026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1189039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189061 */     // GIR_Coverage, 16711,
     /* 1189061 */     GIR_EraseRootFromParent_Done,
     /* 1189062 */   // Label 17311: @1189062
     /* 1189062 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1189142), // Rule ID 16714 //
     /* 1189067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1189078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1189081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1189087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189106 */     // MIs[0] round
     /* 1189106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189116 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1189119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189141 */     // GIR_Coverage, 16714,
     /* 1189141 */     GIR_EraseRootFromParent_Done,
     /* 1189142 */   // Label 17312: @1189142
     /* 1189142 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1189222), // Rule ID 16715 //
     /* 1189147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1189158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1189161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1189164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1189167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189186 */     // MIs[0] round
     /* 1189186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1189199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189221 */     // GIR_Coverage, 16715,
     /* 1189221 */     GIR_EraseRootFromParent_Done,
     /* 1189222 */   // Label 17313: @1189222
     /* 1189222 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1189302), // Rule ID 16718 //
     /* 1189227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1189238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1189241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1189244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1189247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189266 */     // MIs[0] round
     /* 1189266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189276 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1189279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189301 */     // GIR_Coverage, 16718,
     /* 1189301 */     GIR_EraseRootFromParent_Done,
     /* 1189302 */   // Label 17314: @1189302
     /* 1189302 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1189382), // Rule ID 16719 //
     /* 1189307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1189318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1189321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1189324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1189327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189346 */     // MIs[0] round
     /* 1189346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189356 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1189359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189381 */     // GIR_Coverage, 16719,
     /* 1189381 */     GIR_EraseRootFromParent_Done,
     /* 1189382 */   // Label 17315: @1189382
     /* 1189382 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1189462), // Rule ID 16722 //
     /* 1189387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1189390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189426 */     // MIs[0] round
     /* 1189426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189461 */     // GIR_Coverage, 16722,
     /* 1189461 */     GIR_EraseRootFromParent_Done,
     /* 1189462 */   // Label 17316: @1189462
     /* 1189462 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1189542), // Rule ID 16723 //
     /* 1189467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189506 */     // MIs[0] round
     /* 1189506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189541 */     // GIR_Coverage, 16723,
     /* 1189541 */     GIR_EraseRootFromParent_Done,
     /* 1189542 */   // Label 17317: @1189542
     /* 1189542 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1189622), // Rule ID 16726 //
     /* 1189547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189586 */     // MIs[0] round
     /* 1189586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189596 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189621 */     // GIR_Coverage, 16726,
     /* 1189621 */     GIR_EraseRootFromParent_Done,
     /* 1189622 */   // Label 17318: @1189622
     /* 1189622 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1189702), // Rule ID 16727 //
     /* 1189627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189666 */     // MIs[0] round
     /* 1189666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189676 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189701 */     // GIR_Coverage, 16727,
     /* 1189701 */     GIR_EraseRootFromParent_Done,
     /* 1189702 */   // Label 17319: @1189702
     /* 1189702 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1189782), // Rule ID 16730 //
     /* 1189707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189746 */     // MIs[0] round
     /* 1189746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189756 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189781 */     // GIR_Coverage, 16730,
     /* 1189781 */     GIR_EraseRootFromParent_Done,
     /* 1189782 */   // Label 17320: @1189782
     /* 1189782 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1189862), // Rule ID 16731 //
     /* 1189787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189826 */     // MIs[0] round
     /* 1189826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189836 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189861 */     // GIR_Coverage, 16731,
     /* 1189861 */     GIR_EraseRootFromParent_Done,
     /* 1189862 */   // Label 17321: @1189862
     /* 1189862 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1189942), // Rule ID 16734 //
     /* 1189867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189906 */     // MIs[0] round
     /* 1189906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189916 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189941 */     // GIR_Coverage, 16734,
     /* 1189941 */     GIR_EraseRootFromParent_Done,
     /* 1189942 */   // Label 17322: @1189942
     /* 1189942 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1190022), // Rule ID 16735 //
     /* 1189947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189986 */     // MIs[0] round
     /* 1189986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189996 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190021 */     // GIR_Coverage, 16735,
     /* 1190021 */     GIR_EraseRootFromParent_Done,
     /* 1190022 */   // Label 17323: @1190022
     /* 1190022 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1190102), // Rule ID 16738 //
     /* 1190027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1190038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1190041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1190047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190066 */     // MIs[0] round
     /* 1190066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1190079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190101 */     // GIR_Coverage, 16738,
     /* 1190101 */     GIR_EraseRootFromParent_Done,
     /* 1190102 */   // Label 17324: @1190102
     /* 1190102 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1190182), // Rule ID 16739 //
     /* 1190107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1190118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1190121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1190124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1190127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190146 */     // MIs[0] round
     /* 1190146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190156 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1190159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190181 */     // GIR_Coverage, 16739,
     /* 1190181 */     GIR_EraseRootFromParent_Done,
     /* 1190182 */   // Label 17325: @1190182
     /* 1190182 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1190262), // Rule ID 16742 //
     /* 1190187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1190198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1190201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1190204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1190207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190226 */     // MIs[0] round
     /* 1190226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1190239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190261 */     // GIR_Coverage, 16742,
     /* 1190261 */     GIR_EraseRootFromParent_Done,
     /* 1190262 */   // Label 17326: @1190262
     /* 1190262 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1190342), // Rule ID 16743 //
     /* 1190267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1190278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1190281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1190284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1190287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190306 */     // MIs[0] round
     /* 1190306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1190319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190341 */     // GIR_Coverage, 16743,
     /* 1190341 */     GIR_EraseRootFromParent_Done,
     /* 1190342 */   // Label 17327: @1190342
     /* 1190342 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1190422), // Rule ID 16746 //
     /* 1190347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190386 */     // MIs[0] round
     /* 1190386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190396 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190421 */     // GIR_Coverage, 16746,
     /* 1190421 */     GIR_EraseRootFromParent_Done,
     /* 1190422 */   // Label 17328: @1190422
     /* 1190422 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1190502), // Rule ID 16747 //
     /* 1190427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190466 */     // MIs[0] round
     /* 1190466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190476 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190501 */     // GIR_Coverage, 16747,
     /* 1190501 */     GIR_EraseRootFromParent_Done,
     /* 1190502 */   // Label 17329: @1190502
     /* 1190502 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1190582), // Rule ID 16750 //
     /* 1190507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190546 */     // MIs[0] round
     /* 1190546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190581 */     // GIR_Coverage, 16750,
     /* 1190581 */     GIR_EraseRootFromParent_Done,
     /* 1190582 */   // Label 17330: @1190582
     /* 1190582 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1190662), // Rule ID 16751 //
     /* 1190587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190626 */     // MIs[0] round
     /* 1190626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190661 */     // GIR_Coverage, 16751,
     /* 1190661 */     GIR_EraseRootFromParent_Done,
     /* 1190662 */   // Label 17331: @1190662
     /* 1190662 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1190742), // Rule ID 16754 //
     /* 1190667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190706 */     // MIs[0] round
     /* 1190706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190716 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190741 */     // GIR_Coverage, 16754,
     /* 1190741 */     GIR_EraseRootFromParent_Done,
     /* 1190742 */   // Label 17332: @1190742
     /* 1190742 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1190822), // Rule ID 16755 //
     /* 1190747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190786 */     // MIs[0] round
     /* 1190786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190796 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190821 */     // GIR_Coverage, 16755,
     /* 1190821 */     GIR_EraseRootFromParent_Done,
     /* 1190822 */   // Label 17333: @1190822
     /* 1190822 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1190902), // Rule ID 16758 //
     /* 1190827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190866 */     // MIs[0] round
     /* 1190866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190876 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190901 */     // GIR_Coverage, 16758,
     /* 1190901 */     GIR_EraseRootFromParent_Done,
     /* 1190902 */   // Label 17334: @1190902
     /* 1190902 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1190982), // Rule ID 16759 //
     /* 1190907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190946 */     // MIs[0] round
     /* 1190946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190981 */     // GIR_Coverage, 16759,
     /* 1190981 */     GIR_EraseRootFromParent_Done,
     /* 1190982 */   // Label 17335: @1190982
     /* 1190982 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1191062), // Rule ID 16762 //
     /* 1190987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1191001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1191004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191026 */     // MIs[0] round
     /* 1191026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191036 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1191039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191061 */     // GIR_Coverage, 16762,
     /* 1191061 */     GIR_EraseRootFromParent_Done,
     /* 1191062 */   // Label 17336: @1191062
     /* 1191062 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1191142), // Rule ID 16763 //
     /* 1191067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1191078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1191081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1191084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191106 */     // MIs[0] round
     /* 1191106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191116 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1191119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191141 */     // GIR_Coverage, 16763,
     /* 1191141 */     GIR_EraseRootFromParent_Done,
     /* 1191142 */   // Label 17337: @1191142
     /* 1191142 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1191222), // Rule ID 16766 //
     /* 1191147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1191158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1191161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1191164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191186 */     // MIs[0] round
     /* 1191186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191196 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1191199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191221 */     // GIR_Coverage, 16766,
     /* 1191221 */     GIR_EraseRootFromParent_Done,
     /* 1191222 */   // Label 17338: @1191222
     /* 1191222 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1191302), // Rule ID 16767 //
     /* 1191227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1191238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1191241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1191244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191266 */     // MIs[0] round
     /* 1191266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191276 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1191279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191301 */     // GIR_Coverage, 16767,
     /* 1191301 */     GIR_EraseRootFromParent_Done,
     /* 1191302 */   // Label 17339: @1191302
     /* 1191302 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1191382), // Rule ID 16770 //
     /* 1191307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1191324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191346 */     // MIs[0] round
     /* 1191346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191356 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1191359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191381 */     // GIR_Coverage, 16770,
     /* 1191381 */     GIR_EraseRootFromParent_Done,
     /* 1191382 */   // Label 17340: @1191382
     /* 1191382 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1191462), // Rule ID 16771 //
     /* 1191387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1191404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191426 */     // MIs[0] round
     /* 1191426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191436 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1191439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191461 */     // GIR_Coverage, 16771,
     /* 1191461 */     GIR_EraseRootFromParent_Done,
     /* 1191462 */   // Label 17341: @1191462
     /* 1191462 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1191542), // Rule ID 16774 //
     /* 1191467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191506 */     // MIs[0] round
     /* 1191506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191516 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191541 */     // GIR_Coverage, 16774,
     /* 1191541 */     GIR_EraseRootFromParent_Done,
     /* 1191542 */   // Label 17342: @1191542
     /* 1191542 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1191622), // Rule ID 16775 //
     /* 1191547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191586 */     // MIs[0] round
     /* 1191586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191621 */     // GIR_Coverage, 16775,
     /* 1191621 */     GIR_EraseRootFromParent_Done,
     /* 1191622 */   // Label 17343: @1191622
     /* 1191622 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1191702), // Rule ID 16778 //
     /* 1191627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191666 */     // MIs[0] round
     /* 1191666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191701 */     // GIR_Coverage, 16778,
     /* 1191701 */     GIR_EraseRootFromParent_Done,
     /* 1191702 */   // Label 17344: @1191702
     /* 1191702 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1191782), // Rule ID 16779 //
     /* 1191707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191746 */     // MIs[0] round
     /* 1191746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191781 */     // GIR_Coverage, 16779,
     /* 1191781 */     GIR_EraseRootFromParent_Done,
     /* 1191782 */   // Label 17345: @1191782
     /* 1191782 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1191862), // Rule ID 16782 //
     /* 1191787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191826 */     // MIs[0] round
     /* 1191826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191836 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191861 */     // GIR_Coverage, 16782,
     /* 1191861 */     GIR_EraseRootFromParent_Done,
     /* 1191862 */   // Label 17346: @1191862
     /* 1191862 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1191942), // Rule ID 16783 //
     /* 1191867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191906 */     // MIs[0] round
     /* 1191906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191941 */     // GIR_Coverage, 16783,
     /* 1191941 */     GIR_EraseRootFromParent_Done,
     /* 1191942 */   // Label 17347: @1191942
     /* 1191942 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1192022), // Rule ID 16786 //
     /* 1191947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191986 */     // MIs[0] round
     /* 1191986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191996 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192021 */     // GIR_Coverage, 16786,
     /* 1192021 */     GIR_EraseRootFromParent_Done,
     /* 1192022 */   // Label 17348: @1192022
     /* 1192022 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1192102), // Rule ID 16787 //
     /* 1192027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1192038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1192041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1192044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192066 */     // MIs[0] round
     /* 1192066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1192079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192101 */     // GIR_Coverage, 16787,
     /* 1192101 */     GIR_EraseRootFromParent_Done,
     /* 1192102 */   // Label 17349: @1192102
     /* 1192102 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1192182), // Rule ID 16790 //
     /* 1192107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1192118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1192121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1192124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192146 */     // MIs[0] round
     /* 1192146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192156 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1192159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192181 */     // GIR_Coverage, 16790,
     /* 1192181 */     GIR_EraseRootFromParent_Done,
     /* 1192182 */   // Label 17350: @1192182
     /* 1192182 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1192262), // Rule ID 16791 //
     /* 1192187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1192198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1192201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1192204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192226 */     // MIs[0] round
     /* 1192226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192236 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1192239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192261 */     // GIR_Coverage, 16791,
     /* 1192261 */     GIR_EraseRootFromParent_Done,
     /* 1192262 */   // Label 17351: @1192262
     /* 1192262 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1192342), // Rule ID 16794 //
     /* 1192267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1192278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1192281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1192284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192306 */     // MIs[0] round
     /* 1192306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192316 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1192319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192341 */     // GIR_Coverage, 16794,
     /* 1192341 */     GIR_EraseRootFromParent_Done,
     /* 1192342 */   // Label 17352: @1192342
     /* 1192342 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1192422), // Rule ID 16795 //
     /* 1192347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1192358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1192361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1192364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192386 */     // MIs[0] round
     /* 1192386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192396 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1192399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192421 */     // GIR_Coverage, 16795,
     /* 1192421 */     GIR_EraseRootFromParent_Done,
     /* 1192422 */   // Label 17353: @1192422
     /* 1192422 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1192502), // Rule ID 16798 //
     /* 1192427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192466 */     // MIs[0] round
     /* 1192466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192501 */     // GIR_Coverage, 16798,
     /* 1192501 */     GIR_EraseRootFromParent_Done,
     /* 1192502 */   // Label 17354: @1192502
     /* 1192502 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1192582), // Rule ID 16799 //
     /* 1192507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192546 */     // MIs[0] round
     /* 1192546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192581 */     // GIR_Coverage, 16799,
     /* 1192581 */     GIR_EraseRootFromParent_Done,
     /* 1192582 */   // Label 17355: @1192582
     /* 1192582 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1192662), // Rule ID 16802 //
     /* 1192587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192626 */     // MIs[0] round
     /* 1192626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192661 */     // GIR_Coverage, 16802,
     /* 1192661 */     GIR_EraseRootFromParent_Done,
     /* 1192662 */   // Label 17356: @1192662
     /* 1192662 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1192742), // Rule ID 16803 //
     /* 1192667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192706 */     // MIs[0] round
     /* 1192706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192716 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192741 */     // GIR_Coverage, 16803,
     /* 1192741 */     GIR_EraseRootFromParent_Done,
     /* 1192742 */   // Label 17357: @1192742
     /* 1192742 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1192822), // Rule ID 16806 //
     /* 1192747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192786 */     // MIs[0] round
     /* 1192786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192796 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192821 */     // GIR_Coverage, 16806,
     /* 1192821 */     GIR_EraseRootFromParent_Done,
     /* 1192822 */   // Label 17358: @1192822
     /* 1192822 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1192902), // Rule ID 16807 //
     /* 1192827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192866 */     // MIs[0] round
     /* 1192866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192901 */     // GIR_Coverage, 16807,
     /* 1192901 */     GIR_EraseRootFromParent_Done,
     /* 1192902 */   // Label 17359: @1192902
     /* 1192902 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1192982), // Rule ID 16810 //
     /* 1192907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192946 */     // MIs[0] round
     /* 1192946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192981 */     // GIR_Coverage, 16810,
     /* 1192981 */     GIR_EraseRootFromParent_Done,
     /* 1192982 */   // Label 17360: @1192982
     /* 1192982 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1193062), // Rule ID 16811 //
     /* 1192987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1193001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1193004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193026 */     // MIs[0] round
     /* 1193026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193036 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1193039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193061 */     // GIR_Coverage, 16811,
     /* 1193061 */     GIR_EraseRootFromParent_Done,
     /* 1193062 */   // Label 17361: @1193062
     /* 1193062 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1193142), // Rule ID 16814 //
     /* 1193067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1193078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1193081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1193084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193106 */     // MIs[0] round
     /* 1193106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193116 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1193119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193141 */     // GIR_Coverage, 16814,
     /* 1193141 */     GIR_EraseRootFromParent_Done,
     /* 1193142 */   // Label 17362: @1193142
     /* 1193142 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1193222), // Rule ID 16815 //
     /* 1193147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1193158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1193161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1193164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193186 */     // MIs[0] round
     /* 1193186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193196 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1193199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193221 */     // GIR_Coverage, 16815,
     /* 1193221 */     GIR_EraseRootFromParent_Done,
     /* 1193222 */   // Label 17363: @1193222
     /* 1193222 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1193302), // Rule ID 16818 //
     /* 1193227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1193238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1193241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1193244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193266 */     // MIs[0] round
     /* 1193266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193276 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1193279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193301 */     // GIR_Coverage, 16818,
     /* 1193301 */     GIR_EraseRootFromParent_Done,
     /* 1193302 */   // Label 17364: @1193302
     /* 1193302 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1193382), // Rule ID 16819 //
     /* 1193307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1193315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1193318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1193321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1193324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193346 */     // MIs[0] round
     /* 1193346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193356 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1193359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193381 */     // GIR_Coverage, 16819,
     /* 1193381 */     GIR_EraseRootFromParent_Done,
     /* 1193382 */   // Label 17365: @1193382
     /* 1193382 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1193462), // Rule ID 16822 //
     /* 1193387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193426 */     // MIs[0] round
     /* 1193426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193436 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193461 */     // GIR_Coverage, 16822,
     /* 1193461 */     GIR_EraseRootFromParent_Done,
     /* 1193462 */   // Label 17366: @1193462
     /* 1193462 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1193542), // Rule ID 16823 //
     /* 1193467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193506 */     // MIs[0] round
     /* 1193506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193516 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193541 */     // GIR_Coverage, 16823,
     /* 1193541 */     GIR_EraseRootFromParent_Done,
     /* 1193542 */   // Label 17367: @1193542
     /* 1193542 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1193622), // Rule ID 16826 //
     /* 1193547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193586 */     // MIs[0] round
     /* 1193586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193621 */     // GIR_Coverage, 16826,
     /* 1193621 */     GIR_EraseRootFromParent_Done,
     /* 1193622 */   // Label 17368: @1193622
     /* 1193622 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1193702), // Rule ID 16827 //
     /* 1193627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193666 */     // MIs[0] round
     /* 1193666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193676 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193701 */     // GIR_Coverage, 16827,
     /* 1193701 */     GIR_EraseRootFromParent_Done,
     /* 1193702 */   // Label 17369: @1193702
     /* 1193702 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1193782), // Rule ID 16830 //
     /* 1193707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193746 */     // MIs[0] round
     /* 1193746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193781 */     // GIR_Coverage, 16830,
     /* 1193781 */     GIR_EraseRootFromParent_Done,
     /* 1193782 */   // Label 17370: @1193782
     /* 1193782 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1193862), // Rule ID 16831 //
     /* 1193787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193826 */     // MIs[0] round
     /* 1193826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193861 */     // GIR_Coverage, 16831,
     /* 1193861 */     GIR_EraseRootFromParent_Done,
     /* 1193862 */   // Label 17371: @1193862
     /* 1193862 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1193942), // Rule ID 16834 //
     /* 1193867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193906 */     // MIs[0] round
     /* 1193906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193941 */     // GIR_Coverage, 16834,
     /* 1193941 */     GIR_EraseRootFromParent_Done,
     /* 1193942 */   // Label 17372: @1193942
     /* 1193942 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1194022), // Rule ID 16835 //
     /* 1193947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193986 */     // MIs[0] round
     /* 1193986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194021 */     // GIR_Coverage, 16835,
     /* 1194021 */     GIR_EraseRootFromParent_Done,
     /* 1194022 */   // Label 17373: @1194022
     /* 1194022 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1194102), // Rule ID 16838 //
     /* 1194027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1194038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1194041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1194047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194066 */     // MIs[0] round
     /* 1194066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1194079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194101 */     // GIR_Coverage, 16838,
     /* 1194101 */     GIR_EraseRootFromParent_Done,
     /* 1194102 */   // Label 17374: @1194102
     /* 1194102 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1194182), // Rule ID 16839 //
     /* 1194107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1194118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1194121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1194124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1194127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194146 */     // MIs[0] round
     /* 1194146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194156 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1194159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194181 */     // GIR_Coverage, 16839,
     /* 1194181 */     GIR_EraseRootFromParent_Done,
     /* 1194182 */   // Label 17375: @1194182
     /* 1194182 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1194262), // Rule ID 16842 //
     /* 1194187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1194198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1194201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1194207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194226 */     // MIs[0] round
     /* 1194226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1194239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194261 */     // GIR_Coverage, 16842,
     /* 1194261 */     GIR_EraseRootFromParent_Done,
     /* 1194262 */   // Label 17376: @1194262
     /* 1194262 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1194342), // Rule ID 16843 //
     /* 1194267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1194278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1194281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1194284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1194287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1194306 */     // MIs[0] round
     /* 1194306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194316 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1194319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194341 */     // GIR_Coverage, 16843,
     /* 1194341 */     GIR_EraseRootFromParent_Done,
     /* 1194342 */   // Label 17377: @1194342
     /* 1194342 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1194422), // Rule ID 16846 //
     /* 1194347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1194367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194386 */     // MIs[0] round
     /* 1194386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194421 */     // GIR_Coverage, 16846,
     /* 1194421 */     GIR_EraseRootFromParent_Done,
     /* 1194422 */   // Label 17378: @1194422
     /* 1194422 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1194502), // Rule ID 16847 //
     /* 1194427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1194447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194466 */     // MIs[0] round
     /* 1194466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194501 */     // GIR_Coverage, 16847,
     /* 1194501 */     GIR_EraseRootFromParent_Done,
     /* 1194502 */   // Label 17379: @1194502
     /* 1194502 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1194582), // Rule ID 16850 //
     /* 1194507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194546 */     // MIs[0] round
     /* 1194546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194556 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194581 */     // GIR_Coverage, 16850,
     /* 1194581 */     GIR_EraseRootFromParent_Done,
     /* 1194582 */   // Label 17380: @1194582
     /* 1194582 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1194662), // Rule ID 16851 //
     /* 1194587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194626 */     // MIs[0] round
     /* 1194626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194636 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194661 */     // GIR_Coverage, 16851,
     /* 1194661 */     GIR_EraseRootFromParent_Done,
     /* 1194662 */   // Label 17381: @1194662
     /* 1194662 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1194742), // Rule ID 16854 //
     /* 1194667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194706 */     // MIs[0] round
     /* 1194706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194716 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194741 */     // GIR_Coverage, 16854,
     /* 1194741 */     GIR_EraseRootFromParent_Done,
     /* 1194742 */   // Label 17382: @1194742
     /* 1194742 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1194822), // Rule ID 16855 //
     /* 1194747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194786 */     // MIs[0] round
     /* 1194786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194796 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194821 */     // GIR_Coverage, 16855,
     /* 1194821 */     GIR_EraseRootFromParent_Done,
     /* 1194822 */   // Label 17383: @1194822
     /* 1194822 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1194902), // Rule ID 16858 //
     /* 1194827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194866 */     // MIs[0] round
     /* 1194866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194901 */     // GIR_Coverage, 16858,
     /* 1194901 */     GIR_EraseRootFromParent_Done,
     /* 1194902 */   // Label 17384: @1194902
     /* 1194902 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1194982), // Rule ID 16859 //
     /* 1194907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194946 */     // MIs[0] round
     /* 1194946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194981 */     // GIR_Coverage, 16859,
     /* 1194981 */     GIR_EraseRootFromParent_Done,
     /* 1194982 */   // Label 17385: @1194982
     /* 1194982 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1195062), // Rule ID 16862 //
     /* 1194987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1195007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195026 */     // MIs[0] round
     /* 1195026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1195039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195061 */     // GIR_Coverage, 16862,
     /* 1195061 */     GIR_EraseRootFromParent_Done,
     /* 1195062 */   // Label 17386: @1195062
     /* 1195062 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1195142), // Rule ID 16863 //
     /* 1195067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1195078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1195084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1195087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195106 */     // MIs[0] round
     /* 1195106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195116 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1195119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195141 */     // GIR_Coverage, 16863,
     /* 1195141 */     GIR_EraseRootFromParent_Done,
     /* 1195142 */   // Label 17387: @1195142
     /* 1195142 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1195222), // Rule ID 16866 //
     /* 1195147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1195158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1195161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1195167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195186 */     // MIs[0] round
     /* 1195186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195196 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1195199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195221 */     // GIR_Coverage, 16866,
     /* 1195221 */     GIR_EraseRootFromParent_Done,
     /* 1195222 */   // Label 17388: @1195222
     /* 1195222 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1195302), // Rule ID 16867 //
     /* 1195227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1195238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1195241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1195244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1195247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195266 */     // MIs[0] round
     /* 1195266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195276 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1195279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195301 */     // GIR_Coverage, 16867,
     /* 1195301 */     GIR_EraseRootFromParent_Done,
     /* 1195302 */   // Label 17389: @1195302
     /* 1195302 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1195382), // Rule ID 16870 //
     /* 1195307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1195318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1195321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1195324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1195327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195346 */     // MIs[0] round
     /* 1195346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1195359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195381 */     // GIR_Coverage, 16870,
     /* 1195381 */     GIR_EraseRootFromParent_Done,
     /* 1195382 */   // Label 17390: @1195382
     /* 1195382 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1195462), // Rule ID 16871 //
     /* 1195387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1195398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1195401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1195404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1195407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195426 */     // MIs[0] round
     /* 1195426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1195439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195461 */     // GIR_Coverage, 16871,
     /* 1195461 */     GIR_EraseRootFromParent_Done,
     /* 1195462 */   // Label 17391: @1195462
     /* 1195462 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1195542), // Rule ID 16874 //
     /* 1195467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195506 */     // MIs[0] round
     /* 1195506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195516 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195541 */     // GIR_Coverage, 16874,
     /* 1195541 */     GIR_EraseRootFromParent_Done,
     /* 1195542 */   // Label 17392: @1195542
     /* 1195542 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1195622), // Rule ID 16875 //
     /* 1195547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195586 */     // MIs[0] round
     /* 1195586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195596 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195621 */     // GIR_Coverage, 16875,
     /* 1195621 */     GIR_EraseRootFromParent_Done,
     /* 1195622 */   // Label 17393: @1195622
     /* 1195622 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1195702), // Rule ID 16878 //
     /* 1195627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195666 */     // MIs[0] round
     /* 1195666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195676 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195701 */     // GIR_Coverage, 16878,
     /* 1195701 */     GIR_EraseRootFromParent_Done,
     /* 1195702 */   // Label 17394: @1195702
     /* 1195702 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1195782), // Rule ID 16879 //
     /* 1195707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195746 */     // MIs[0] round
     /* 1195746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195756 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195781 */     // GIR_Coverage, 16879,
     /* 1195781 */     GIR_EraseRootFromParent_Done,
     /* 1195782 */   // Label 17395: @1195782
     /* 1195782 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1195862), // Rule ID 16882 //
     /* 1195787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195826 */     // MIs[0] round
     /* 1195826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195861 */     // GIR_Coverage, 16882,
     /* 1195861 */     GIR_EraseRootFromParent_Done,
     /* 1195862 */   // Label 17396: @1195862
     /* 1195862 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1195942), // Rule ID 16883 //
     /* 1195867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195906 */     // MIs[0] round
     /* 1195906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195941 */     // GIR_Coverage, 16883,
     /* 1195941 */     GIR_EraseRootFromParent_Done,
     /* 1195942 */   // Label 17397: @1195942
     /* 1195942 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1196022), // Rule ID 16886 //
     /* 1195947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195986 */     // MIs[0] round
     /* 1195986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195996 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196021 */     // GIR_Coverage, 16886,
     /* 1196021 */     GIR_EraseRootFromParent_Done,
     /* 1196022 */   // Label 17398: @1196022
     /* 1196022 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1196102), // Rule ID 16887 //
     /* 1196027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1196038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1196041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1196044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196066 */     // MIs[0] round
     /* 1196066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196076 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1196079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196101 */     // GIR_Coverage, 16887,
     /* 1196101 */     GIR_EraseRootFromParent_Done,
     /* 1196102 */   // Label 17399: @1196102
     /* 1196102 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1196182), // Rule ID 16890 //
     /* 1196107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196146 */     // MIs[0] round
     /* 1196146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1196159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196181 */     // GIR_Coverage, 16890,
     /* 1196181 */     GIR_EraseRootFromParent_Done,
     /* 1196182 */   // Label 17400: @1196182
     /* 1196182 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1196262), // Rule ID 16891 //
     /* 1196187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196226 */     // MIs[0] round
     /* 1196226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196236 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1196239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196261 */     // GIR_Coverage, 16891,
     /* 1196261 */     GIR_EraseRootFromParent_Done,
     /* 1196262 */   // Label 17401: @1196262
     /* 1196262 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1196342), // Rule ID 16894 //
     /* 1196267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1196278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1196281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1196284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196306 */     // MIs[0] round
     /* 1196306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196316 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1196319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196341 */     // GIR_Coverage, 16894,
     /* 1196341 */     GIR_EraseRootFromParent_Done,
     /* 1196342 */   // Label 17402: @1196342
     /* 1196342 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1196422), // Rule ID 16895 //
     /* 1196347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1196358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1196361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1196364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196386 */     // MIs[0] round
     /* 1196386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11333:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1196399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196421 */     // GIR_Coverage, 16895,
     /* 1196421 */     GIR_EraseRootFromParent_Done,
     /* 1196422 */   // Label 17403: @1196422
     /* 1196422 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1196502), // Rule ID 16898 //
     /* 1196427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196466 */     // MIs[0] round
     /* 1196466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196501 */     // GIR_Coverage, 16898,
     /* 1196501 */     GIR_EraseRootFromParent_Done,
     /* 1196502 */   // Label 17404: @1196502
     /* 1196502 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1196582), // Rule ID 16899 //
     /* 1196507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196546 */     // MIs[0] round
     /* 1196546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11333:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196581 */     // GIR_Coverage, 16899,
     /* 1196581 */     GIR_EraseRootFromParent_Done,
     /* 1196582 */   // Label 17405: @1196582
     /* 1196582 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1196662), // Rule ID 16902 //
     /* 1196587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196626 */     // MIs[0] round
     /* 1196626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196661 */     // GIR_Coverage, 16902,
     /* 1196661 */     GIR_EraseRootFromParent_Done,
     /* 1196662 */   // Label 17406: @1196662
     /* 1196662 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1196742), // Rule ID 16903 //
     /* 1196667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196706 */     // MIs[0] round
     /* 1196706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196716 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11333:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196741 */     // GIR_Coverage, 16903,
     /* 1196741 */     GIR_EraseRootFromParent_Done,
     /* 1196742 */   // Label 17407: @1196742
     /* 1196742 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1196822), // Rule ID 16906 //
     /* 1196747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196786 */     // MIs[0] round
     /* 1196786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196796 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196821 */     // GIR_Coverage, 16906,
     /* 1196821 */     GIR_EraseRootFromParent_Done,
     /* 1196822 */   // Label 17408: @1196822
     /* 1196822 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1196902), // Rule ID 16907 //
     /* 1196827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196866 */     // MIs[0] round
     /* 1196866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196876 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196901 */     // GIR_Coverage, 16907,
     /* 1196901 */     GIR_EraseRootFromParent_Done,
     /* 1196902 */   // Label 17409: @1196902
     /* 1196902 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1196982), // Rule ID 16910 //
     /* 1196907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196946 */     // MIs[0] round
     /* 1196946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196956 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196981 */     // GIR_Coverage, 16910,
     /* 1196981 */     GIR_EraseRootFromParent_Done,
     /* 1196982 */   // Label 17410: @1196982
     /* 1196982 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1197062), // Rule ID 16911 //
     /* 1196987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1197001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197026 */     // MIs[0] round
     /* 1197026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1197039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197061 */     // GIR_Coverage, 16911,
     /* 1197061 */     GIR_EraseRootFromParent_Done,
     /* 1197062 */   // Label 17411: @1197062
     /* 1197062 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1197142), // Rule ID 16914 //
     /* 1197067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1197078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1197081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1197084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197106 */     // MIs[0] round
     /* 1197106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197116 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1197119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197141 */     // GIR_Coverage, 16914,
     /* 1197141 */     GIR_EraseRootFromParent_Done,
     /* 1197142 */   // Label 17412: @1197142
     /* 1197142 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1197222), // Rule ID 16915 //
     /* 1197147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1197158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1197161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1197164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197186 */     // MIs[0] round
     /* 1197186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197196 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1197199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197221 */     // GIR_Coverage, 16915,
     /* 1197221 */     GIR_EraseRootFromParent_Done,
     /* 1197222 */   // Label 17413: @1197222
     /* 1197222 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1197302), // Rule ID 16918 //
     /* 1197227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1197244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197266 */     // MIs[0] round
     /* 1197266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197276 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1197279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197301 */     // GIR_Coverage, 16918,
     /* 1197301 */     GIR_EraseRootFromParent_Done,
     /* 1197302 */   // Label 17414: @1197302
     /* 1197302 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1197382), // Rule ID 16919 //
     /* 1197307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1197324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197346 */     // MIs[0] round
     /* 1197346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1197359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197381 */     // GIR_Coverage, 16919,
     /* 1197381 */     GIR_EraseRootFromParent_Done,
     /* 1197382 */   // Label 17415: @1197382
     /* 1197382 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1197462), // Rule ID 16922 //
     /* 1197387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197426 */     // MIs[0] round
     /* 1197426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197436 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197461 */     // GIR_Coverage, 16922,
     /* 1197461 */     GIR_EraseRootFromParent_Done,
     /* 1197462 */   // Label 17416: @1197462
     /* 1197462 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1197542), // Rule ID 16923 //
     /* 1197467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197506 */     // MIs[0] round
     /* 1197506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197516 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197541 */     // GIR_Coverage, 16923,
     /* 1197541 */     GIR_EraseRootFromParent_Done,
     /* 1197542 */   // Label 17417: @1197542
     /* 1197542 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1197622), // Rule ID 16926 //
     /* 1197547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197586 */     // MIs[0] round
     /* 1197586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197596 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197621 */     // GIR_Coverage, 16926,
     /* 1197621 */     GIR_EraseRootFromParent_Done,
     /* 1197622 */   // Label 17418: @1197622
     /* 1197622 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1197702), // Rule ID 16927 //
     /* 1197627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197666 */     // MIs[0] round
     /* 1197666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197676 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197701 */     // GIR_Coverage, 16927,
     /* 1197701 */     GIR_EraseRootFromParent_Done,
     /* 1197702 */   // Label 17419: @1197702
     /* 1197702 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1197782), // Rule ID 16930 //
     /* 1197707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197746 */     // MIs[0] round
     /* 1197746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197756 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197781 */     // GIR_Coverage, 16930,
     /* 1197781 */     GIR_EraseRootFromParent_Done,
     /* 1197782 */   // Label 17420: @1197782
     /* 1197782 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1197862), // Rule ID 16931 //
     /* 1197787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197826 */     // MIs[0] round
     /* 1197826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11333:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197861 */     // GIR_Coverage, 16931,
     /* 1197861 */     GIR_EraseRootFromParent_Done,
     /* 1197862 */   // Label 17421: @1197862
     /* 1197862 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1197942), // Rule ID 16934 //
     /* 1197867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197906 */     // MIs[0] round
     /* 1197906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197916 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197941 */     // GIR_Coverage, 16934,
     /* 1197941 */     GIR_EraseRootFromParent_Done,
     /* 1197942 */   // Label 17422: @1197942
     /* 1197942 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1198022), // Rule ID 16935 //
     /* 1197947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197986 */     // MIs[0] round
     /* 1197986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197996 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11333:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198021 */     // GIR_Coverage, 16935,
     /* 1198021 */     GIR_EraseRootFromParent_Done,
     /* 1198022 */   // Label 17423: @1198022
     /* 1198022 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1198102), // Rule ID 16938 //
     /* 1198027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1198044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198066 */     // MIs[0] round
     /* 1198066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198076 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1198079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198101 */     // GIR_Coverage, 16938,
     /* 1198101 */     GIR_EraseRootFromParent_Done,
     /* 1198102 */   // Label 17424: @1198102
     /* 1198102 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1198182), // Rule ID 16939 //
     /* 1198107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1198115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1198124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198146 */     // MIs[0] round
     /* 1198146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11333:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1198159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198181 */     // GIR_Coverage, 16939,
     /* 1198181 */     GIR_EraseRootFromParent_Done,
     /* 1198182 */   // Label 17425: @1198182
     /* 1198182 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1198262), // Rule ID 16942 //
     /* 1198187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1198198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1198201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198226 */     // MIs[0] round
     /* 1198226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198236 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1198239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198261 */     // GIR_Coverage, 16942,
     /* 1198261 */     GIR_EraseRootFromParent_Done,
     /* 1198262 */   // Label 17426: @1198262
     /* 1198262 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1198342), // Rule ID 16943 //
     /* 1198267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1198278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1198281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198306 */     // MIs[0] round
     /* 1198306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198316 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1198319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198341 */     // GIR_Coverage, 16943,
     /* 1198341 */     GIR_EraseRootFromParent_Done,
     /* 1198342 */   // Label 17427: @1198342
     /* 1198342 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1198422), // Rule ID 16946 //
     /* 1198347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1198358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1198361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198386 */     // MIs[0] round
     /* 1198386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198396 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198421 */     // GIR_Coverage, 16946,
     /* 1198421 */     GIR_EraseRootFromParent_Done,
     /* 1198422 */   // Label 17428: @1198422
     /* 1198422 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1198502), // Rule ID 16947 //
     /* 1198427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1198438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1198441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198466 */     // MIs[0] round
     /* 1198466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198476 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198501 */     // GIR_Coverage, 16947,
     /* 1198501 */     GIR_EraseRootFromParent_Done,
     /* 1198502 */   // Label 17429: @1198502
     /* 1198502 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1198582), // Rule ID 16950 //
     /* 1198507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198546 */     // MIs[0] round
     /* 1198546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198556 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198581 */     // GIR_Coverage, 16950,
     /* 1198581 */     GIR_EraseRootFromParent_Done,
     /* 1198582 */   // Label 17430: @1198582
     /* 1198582 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1198662), // Rule ID 16951 //
     /* 1198587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198626 */     // MIs[0] round
     /* 1198626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198636 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198661 */     // GIR_Coverage, 16951,
     /* 1198661 */     GIR_EraseRootFromParent_Done,
     /* 1198662 */   // Label 17431: @1198662
     /* 1198662 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1198742), // Rule ID 16954 //
     /* 1198667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198706 */     // MIs[0] round
     /* 1198706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198741 */     // GIR_Coverage, 16954,
     /* 1198741 */     GIR_EraseRootFromParent_Done,
     /* 1198742 */   // Label 17432: @1198742
     /* 1198742 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1198822), // Rule ID 16955 //
     /* 1198747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198786 */     // MIs[0] round
     /* 1198786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198796 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11319:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198821 */     // GIR_Coverage, 16955,
     /* 1198821 */     GIR_EraseRootFromParent_Done,
     /* 1198822 */   // Label 17433: @1198822
     /* 1198822 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1198902), // Rule ID 16958 //
     /* 1198827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198866 */     // MIs[0] round
     /* 1198866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198901 */     // GIR_Coverage, 16958,
     /* 1198901 */     GIR_EraseRootFromParent_Done,
     /* 1198902 */   // Label 17434: @1198902
     /* 1198902 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1198982), // Rule ID 16959 //
     /* 1198907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198946 */     // MIs[0] round
     /* 1198946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198981 */     // GIR_Coverage, 16959,
     /* 1198981 */     GIR_EraseRootFromParent_Done,
     /* 1198982 */   // Label 17435: @1198982
     /* 1198982 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1199062), // Rule ID 16962 //
     /* 1198987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1199004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199026 */     // MIs[0] round
     /* 1199026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1199039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199061 */     // GIR_Coverage, 16962,
     /* 1199061 */     GIR_EraseRootFromParent_Done,
     /* 1199062 */   // Label 17436: @1199062
     /* 1199062 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1199142), // Rule ID 16963 //
     /* 1199067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1199084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199106 */     // MIs[0] round
     /* 1199106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1199119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199141 */     // GIR_Coverage, 16963,
     /* 1199141 */     GIR_EraseRootFromParent_Done,
     /* 1199142 */   // Label 17437: @1199142
     /* 1199142 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1199222), // Rule ID 16966 //
     /* 1199147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1199158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1199161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1199164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199186 */     // MIs[0] round
     /* 1199186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1199199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199221 */     // GIR_Coverage, 16966,
     /* 1199221 */     GIR_EraseRootFromParent_Done,
     /* 1199222 */   // Label 17438: @1199222
     /* 1199222 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1199302), // Rule ID 16967 //
     /* 1199227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1199238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1199241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1199244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199266 */     // MIs[0] round
     /* 1199266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199276 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1199279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199301 */     // GIR_Coverage, 16967,
     /* 1199301 */     GIR_EraseRootFromParent_Done,
     /* 1199302 */   // Label 17439: @1199302
     /* 1199302 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1199382), // Rule ID 16970 //
     /* 1199307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1199318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1199321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1199324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199346 */     // MIs[0] round
     /* 1199346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1199359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199381 */     // GIR_Coverage, 16970,
     /* 1199381 */     GIR_EraseRootFromParent_Done,
     /* 1199382 */   // Label 17440: @1199382
     /* 1199382 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1199462), // Rule ID 16971 //
     /* 1199387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1199398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1199401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1199404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199426 */     // MIs[0] round
     /* 1199426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199436 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1199439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199461 */     // GIR_Coverage, 16971,
     /* 1199461 */     GIR_EraseRootFromParent_Done,
     /* 1199462 */   // Label 17441: @1199462
     /* 1199462 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1199542), // Rule ID 16974 //
     /* 1199467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199506 */     // MIs[0] round
     /* 1199506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199541 */     // GIR_Coverage, 16974,
     /* 1199541 */     GIR_EraseRootFromParent_Done,
     /* 1199542 */   // Label 17442: @1199542
     /* 1199542 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1199622), // Rule ID 16975 //
     /* 1199547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199586 */     // MIs[0] round
     /* 1199586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199596 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199621 */     // GIR_Coverage, 16975,
     /* 1199621 */     GIR_EraseRootFromParent_Done,
     /* 1199622 */   // Label 17443: @1199622
     /* 1199622 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1199702), // Rule ID 16978 //
     /* 1199627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199666 */     // MIs[0] round
     /* 1199666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199676 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199701 */     // GIR_Coverage, 16978,
     /* 1199701 */     GIR_EraseRootFromParent_Done,
     /* 1199702 */   // Label 17444: @1199702
     /* 1199702 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1199782), // Rule ID 16979 //
     /* 1199707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199746 */     // MIs[0] round
     /* 1199746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199756 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199781 */     // GIR_Coverage, 16979,
     /* 1199781 */     GIR_EraseRootFromParent_Done,
     /* 1199782 */   // Label 17445: @1199782
     /* 1199782 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1199862), // Rule ID 16982 //
     /* 1199787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199826 */     // MIs[0] round
     /* 1199826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199836 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199861 */     // GIR_Coverage, 16982,
     /* 1199861 */     GIR_EraseRootFromParent_Done,
     /* 1199862 */   // Label 17446: @1199862
     /* 1199862 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1199942), // Rule ID 16983 //
     /* 1199867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199906 */     // MIs[0] round
     /* 1199906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199941 */     // GIR_Coverage, 16983,
     /* 1199941 */     GIR_EraseRootFromParent_Done,
     /* 1199942 */   // Label 17447: @1199942
     /* 1199942 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1200022), // Rule ID 16986 //
     /* 1199947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199986 */     // MIs[0] round
     /* 1199986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199996 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200021 */     // GIR_Coverage, 16986,
     /* 1200021 */     GIR_EraseRootFromParent_Done,
     /* 1200022 */   // Label 17448: @1200022
     /* 1200022 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1200102), // Rule ID 16987 //
     /* 1200027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1200030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1200044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200066 */     // MIs[0] round
     /* 1200066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200076 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1200079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200101 */     // GIR_Coverage, 16987,
     /* 1200101 */     GIR_EraseRootFromParent_Done,
     /* 1200102 */   // Label 17449: @1200102
     /* 1200102 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1200182), // Rule ID 16990 //
     /* 1200107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1200124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200146 */     // MIs[0] round
     /* 1200146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1200159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200181 */     // GIR_Coverage, 16990,
     /* 1200181 */     GIR_EraseRootFromParent_Done,
     /* 1200182 */   // Label 17450: @1200182
     /* 1200182 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1200262), // Rule ID 16991 //
     /* 1200187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1200204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200226 */     // MIs[0] round
     /* 1200226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1200239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200261 */     // GIR_Coverage, 16991,
     /* 1200261 */     GIR_EraseRootFromParent_Done,
     /* 1200262 */   // Label 17451: @1200262
     /* 1200262 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1200342), // Rule ID 16994 //
     /* 1200267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1200284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200306 */     // MIs[0] round
     /* 1200306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200316 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1200319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200341 */     // GIR_Coverage, 16994,
     /* 1200341 */     GIR_EraseRootFromParent_Done,
     /* 1200342 */   // Label 17452: @1200342
     /* 1200342 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1200422), // Rule ID 16995 //
     /* 1200347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1200364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200386 */     // MIs[0] round
     /* 1200386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200396 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1200399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200421 */     // GIR_Coverage, 16995,
     /* 1200421 */     GIR_EraseRootFromParent_Done,
     /* 1200422 */   // Label 17453: @1200422
     /* 1200422 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1200502), // Rule ID 16998 //
     /* 1200427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1200430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200466 */     // MIs[0] round
     /* 1200466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200476 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200501 */     // GIR_Coverage, 16998,
     /* 1200501 */     GIR_EraseRootFromParent_Done,
     /* 1200502 */   // Label 17454: @1200502
     /* 1200502 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1200582), // Rule ID 16999 //
     /* 1200507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200546 */     // MIs[0] round
     /* 1200546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200556 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200581 */     // GIR_Coverage, 16999,
     /* 1200581 */     GIR_EraseRootFromParent_Done,
     /* 1200582 */   // Label 17455: @1200582
     /* 1200582 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1200662), // Rule ID 17002 //
     /* 1200587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200626 */     // MIs[0] round
     /* 1200626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200636 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200661 */     // GIR_Coverage, 17002,
     /* 1200661 */     GIR_EraseRootFromParent_Done,
     /* 1200662 */   // Label 17456: @1200662
     /* 1200662 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1200742), // Rule ID 17003 //
     /* 1200667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200706 */     // MIs[0] round
     /* 1200706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200716 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200741 */     // GIR_Coverage, 17003,
     /* 1200741 */     GIR_EraseRootFromParent_Done,
     /* 1200742 */   // Label 17457: @1200742
     /* 1200742 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1200822), // Rule ID 17006 //
     /* 1200747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200786 */     // MIs[0] round
     /* 1200786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200821 */     // GIR_Coverage, 17006,
     /* 1200821 */     GIR_EraseRootFromParent_Done,
     /* 1200822 */   // Label 17458: @1200822
     /* 1200822 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1200902), // Rule ID 17007 //
     /* 1200827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200866 */     // MIs[0] round
     /* 1200866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200901 */     // GIR_Coverage, 17007,
     /* 1200901 */     GIR_EraseRootFromParent_Done,
     /* 1200902 */   // Label 17459: @1200902
     /* 1200902 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1200982), // Rule ID 17010 //
     /* 1200907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200946 */     // MIs[0] round
     /* 1200946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200981 */     // GIR_Coverage, 17010,
     /* 1200981 */     GIR_EraseRootFromParent_Done,
     /* 1200982 */   // Label 17460: @1200982
     /* 1200982 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1201062), // Rule ID 17011 //
     /* 1200987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1201007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201026 */     // MIs[0] round
     /* 1201026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1201039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201061 */     // GIR_Coverage, 17011,
     /* 1201061 */     GIR_EraseRootFromParent_Done,
     /* 1201062 */   // Label 17461: @1201062
     /* 1201062 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1201142), // Rule ID 17014 //
     /* 1201067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201106 */     // MIs[0] round
     /* 1201106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201116 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1201119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201141 */     // GIR_Coverage, 17014,
     /* 1201141 */     GIR_EraseRootFromParent_Done,
     /* 1201142 */   // Label 17462: @1201142
     /* 1201142 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1201222), // Rule ID 17015 //
     /* 1201147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201186 */     // MIs[0] round
     /* 1201186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201196 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1201199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201221 */     // GIR_Coverage, 17015,
     /* 1201221 */     GIR_EraseRootFromParent_Done,
     /* 1201222 */   // Label 17463: @1201222
     /* 1201222 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1201302), // Rule ID 17018 //
     /* 1201227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201266 */     // MIs[0] round
     /* 1201266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201276 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1201279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201301 */     // GIR_Coverage, 17018,
     /* 1201301 */     GIR_EraseRootFromParent_Done,
     /* 1201302 */   // Label 17464: @1201302
     /* 1201302 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1201382), // Rule ID 17019 //
     /* 1201307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201346 */     // MIs[0] round
     /* 1201346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201356 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1201359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201381 */     // GIR_Coverage, 17019,
     /* 1201381 */     GIR_EraseRootFromParent_Done,
     /* 1201382 */   // Label 17465: @1201382
     /* 1201382 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1201462), // Rule ID 17022 //
     /* 1201387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201426 */     // MIs[0] round
     /* 1201426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201461 */     // GIR_Coverage, 17022,
     /* 1201461 */     GIR_EraseRootFromParent_Done,
     /* 1201462 */   // Label 17466: @1201462
     /* 1201462 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1201542), // Rule ID 17023 //
     /* 1201467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201506 */     // MIs[0] round
     /* 1201506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201541 */     // GIR_Coverage, 17023,
     /* 1201541 */     GIR_EraseRootFromParent_Done,
     /* 1201542 */   // Label 17467: @1201542
     /* 1201542 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1201622), // Rule ID 17026 //
     /* 1201547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201586 */     // MIs[0] round
     /* 1201586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201596 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201621 */     // GIR_Coverage, 17026,
     /* 1201621 */     GIR_EraseRootFromParent_Done,
     /* 1201622 */   // Label 17468: @1201622
     /* 1201622 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1201702), // Rule ID 17027 //
     /* 1201627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201666 */     // MIs[0] round
     /* 1201666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201676 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201701 */     // GIR_Coverage, 17027,
     /* 1201701 */     GIR_EraseRootFromParent_Done,
     /* 1201702 */   // Label 17469: @1201702
     /* 1201702 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1201782), // Rule ID 17030 //
     /* 1201707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201746 */     // MIs[0] round
     /* 1201746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201781 */     // GIR_Coverage, 17030,
     /* 1201781 */     GIR_EraseRootFromParent_Done,
     /* 1201782 */   // Label 17470: @1201782
     /* 1201782 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1201862), // Rule ID 17031 //
     /* 1201787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201826 */     // MIs[0] round
     /* 1201826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201836 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201861 */     // GIR_Coverage, 17031,
     /* 1201861 */     GIR_EraseRootFromParent_Done,
     /* 1201862 */   // Label 17471: @1201862
     /* 1201862 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1201942), // Rule ID 17034 //
     /* 1201867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201906 */     // MIs[0] round
     /* 1201906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201916 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201941 */     // GIR_Coverage, 17034,
     /* 1201941 */     GIR_EraseRootFromParent_Done,
     /* 1201942 */   // Label 17472: @1201942
     /* 1201942 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1202022), // Rule ID 17035 //
     /* 1201947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201986 */     // MIs[0] round
     /* 1201986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202021 */     // GIR_Coverage, 17035,
     /* 1202021 */     GIR_EraseRootFromParent_Done,
     /* 1202022 */   // Label 17473: @1202022
     /* 1202022 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1202102), // Rule ID 17038 //
     /* 1202027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202066 */     // MIs[0] round
     /* 1202066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202076 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1202079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202101 */     // GIR_Coverage, 17038,
     /* 1202101 */     GIR_EraseRootFromParent_Done,
     /* 1202102 */   // Label 17474: @1202102
     /* 1202102 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1202182), // Rule ID 17039 //
     /* 1202107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202146 */     // MIs[0] round
     /* 1202146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1202159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202181 */     // GIR_Coverage, 17039,
     /* 1202181 */     GIR_EraseRootFromParent_Done,
     /* 1202182 */   // Label 17475: @1202182
     /* 1202182 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1202262), // Rule ID 17042 //
     /* 1202187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202226 */     // MIs[0] round
     /* 1202226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1202239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202261 */     // GIR_Coverage, 17042,
     /* 1202261 */     GIR_EraseRootFromParent_Done,
     /* 1202262 */   // Label 17476: @1202262
     /* 1202262 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1202342), // Rule ID 17043 //
     /* 1202267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202306 */     // MIs[0] round
     /* 1202306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11335:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1202319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202341 */     // GIR_Coverage, 17043,
     /* 1202341 */     GIR_EraseRootFromParent_Done,
     /* 1202342 */   // Label 17477: @1202342
     /* 1202342 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1202422), // Rule ID 17046 //
     /* 1202347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202386 */     // MIs[0] round
     /* 1202386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202421 */     // GIR_Coverage, 17046,
     /* 1202421 */     GIR_EraseRootFromParent_Done,
     /* 1202422 */   // Label 17478: @1202422
     /* 1202422 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1202502), // Rule ID 17047 //
     /* 1202427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1202444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202466 */     // MIs[0] round
     /* 1202466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202501 */     // GIR_Coverage, 17047,
     /* 1202501 */     GIR_EraseRootFromParent_Done,
     /* 1202502 */   // Label 17479: @1202502
     /* 1202502 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1202582), // Rule ID 17050 //
     /* 1202507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202546 */     // MIs[0] round
     /* 1202546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202581 */     // GIR_Coverage, 17050,
     /* 1202581 */     GIR_EraseRootFromParent_Done,
     /* 1202582 */   // Label 17480: @1202582
     /* 1202582 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1202662), // Rule ID 17051 //
     /* 1202587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202626 */     // MIs[0] round
     /* 1202626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202661 */     // GIR_Coverage, 17051,
     /* 1202661 */     GIR_EraseRootFromParent_Done,
     /* 1202662 */   // Label 17481: @1202662
     /* 1202662 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1202742), // Rule ID 17054 //
     /* 1202667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202706 */     // MIs[0] round
     /* 1202706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202741 */     // GIR_Coverage, 17054,
     /* 1202741 */     GIR_EraseRootFromParent_Done,
     /* 1202742 */   // Label 17482: @1202742
     /* 1202742 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1202822), // Rule ID 17055 //
     /* 1202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202786 */     // MIs[0] round
     /* 1202786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202796 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202821 */     // GIR_Coverage, 17055,
     /* 1202821 */     GIR_EraseRootFromParent_Done,
     /* 1202822 */   // Label 17483: @1202822
     /* 1202822 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1202902), // Rule ID 17058 //
     /* 1202827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202866 */     // MIs[0] round
     /* 1202866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202901 */     // GIR_Coverage, 17058,
     /* 1202901 */     GIR_EraseRootFromParent_Done,
     /* 1202902 */   // Label 17484: @1202902
     /* 1202902 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1202982), // Rule ID 17059 //
     /* 1202907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202946 */     // MIs[0] round
     /* 1202946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11335:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202981 */     // GIR_Coverage, 17059,
     /* 1202981 */     GIR_EraseRootFromParent_Done,
     /* 1202982 */   // Label 17485: @1202982
     /* 1202982 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1203062), // Rule ID 17062 //
     /* 1202987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203026 */     // MIs[0] round
     /* 1203026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203036 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1203039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203061 */     // GIR_Coverage, 17062,
     /* 1203061 */     GIR_EraseRootFromParent_Done,
     /* 1203062 */   // Label 17486: @1203062
     /* 1203062 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1203142), // Rule ID 17063 //
     /* 1203067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203106 */     // MIs[0] round
     /* 1203106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11335:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1203119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203141 */     // GIR_Coverage, 17063,
     /* 1203141 */     GIR_EraseRootFromParent_Done,
     /* 1203142 */   // Label 17487: @1203142
     /* 1203142 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1203222), // Rule ID 17066 //
     /* 1203147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203186 */     // MIs[0] round
     /* 1203186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203196 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1203199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203221 */     // GIR_Coverage, 17066,
     /* 1203221 */     GIR_EraseRootFromParent_Done,
     /* 1203222 */   // Label 17488: @1203222
     /* 1203222 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1203302), // Rule ID 17067 //
     /* 1203227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203266 */     // MIs[0] round
     /* 1203266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203276 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11335:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1203279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203301 */     // GIR_Coverage, 17067,
     /* 1203301 */     GIR_EraseRootFromParent_Done,
     /* 1203302 */   // Label 17489: @1203302
     /* 1203302 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1203382), // Rule ID 17070 //
     /* 1203307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203346 */     // MIs[0] round
     /* 1203346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203356 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1203359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203381 */     // GIR_Coverage, 17070,
     /* 1203381 */     GIR_EraseRootFromParent_Done,
     /* 1203382 */   // Label 17490: @1203382
     /* 1203382 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1203462), // Rule ID 17071 //
     /* 1203387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1203395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203426 */     // MIs[0] round
     /* 1203426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11335:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1203439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203461 */     // GIR_Coverage, 17071,
     /* 1203461 */     GIR_EraseRootFromParent_Done,
     /* 1203462 */   // Label 17491: @1203462
     /* 1203462 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1203542), // Rule ID 17074 //
     /* 1203467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203506 */     // MIs[0] round
     /* 1203506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203541 */     // GIR_Coverage, 17074,
     /* 1203541 */     GIR_EraseRootFromParent_Done,
     /* 1203542 */   // Label 17492: @1203542
     /* 1203542 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1203622), // Rule ID 17075 //
     /* 1203547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203586 */     // MIs[0] round
     /* 1203586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203621 */     // GIR_Coverage, 17075,
     /* 1203621 */     GIR_EraseRootFromParent_Done,
     /* 1203622 */   // Label 17493: @1203622
     /* 1203622 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1203702), // Rule ID 17078 //
     /* 1203627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203666 */     // MIs[0] round
     /* 1203666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203701 */     // GIR_Coverage, 17078,
     /* 1203701 */     GIR_EraseRootFromParent_Done,
     /* 1203702 */   // Label 17494: @1203702
     /* 1203702 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1203782), // Rule ID 17079 //
     /* 1203707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203746 */     // MIs[0] round
     /* 1203746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203781 */     // GIR_Coverage, 17079,
     /* 1203781 */     GIR_EraseRootFromParent_Done,
     /* 1203782 */   // Label 17495: @1203782
     /* 1203782 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1203862), // Rule ID 17082 //
     /* 1203787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203826 */     // MIs[0] round
     /* 1203826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203861 */     // GIR_Coverage, 17082,
     /* 1203861 */     GIR_EraseRootFromParent_Done,
     /* 1203862 */   // Label 17496: @1203862
     /* 1203862 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1203942), // Rule ID 17083 //
     /* 1203867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203906 */     // MIs[0] round
     /* 1203906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203916 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203941 */     // GIR_Coverage, 17083,
     /* 1203941 */     GIR_EraseRootFromParent_Done,
     /* 1203942 */   // Label 17497: @1203942
     /* 1203942 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1204022), // Rule ID 17086 //
     /* 1203947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203986 */     // MIs[0] round
     /* 1203986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204021 */     // GIR_Coverage, 17086,
     /* 1204021 */     GIR_EraseRootFromParent_Done,
     /* 1204022 */   // Label 17498: @1204022
     /* 1204022 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1204102), // Rule ID 17087 //
     /* 1204027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204066 */     // MIs[0] round
     /* 1204066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1204079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204101 */     // GIR_Coverage, 17087,
     /* 1204101 */     GIR_EraseRootFromParent_Done,
     /* 1204102 */   // Label 17499: @1204102
     /* 1204102 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1204182), // Rule ID 17090 //
     /* 1204107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204146 */     // MIs[0] round
     /* 1204146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1204159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204181 */     // GIR_Coverage, 17090,
     /* 1204181 */     GIR_EraseRootFromParent_Done,
     /* 1204182 */   // Label 17500: @1204182
     /* 1204182 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1204262), // Rule ID 17091 //
     /* 1204187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204226 */     // MIs[0] round
     /* 1204226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204236 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1204239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204261 */     // GIR_Coverage, 17091,
     /* 1204261 */     GIR_EraseRootFromParent_Done,
     /* 1204262 */   // Label 17501: @1204262
     /* 1204262 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1204342), // Rule ID 17094 //
     /* 1204267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204306 */     // MIs[0] round
     /* 1204306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204316 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1204319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204341 */     // GIR_Coverage, 17094,
     /* 1204341 */     GIR_EraseRootFromParent_Done,
     /* 1204342 */   // Label 17502: @1204342
     /* 1204342 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1204422), // Rule ID 17095 //
     /* 1204347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204386 */     // MIs[0] round
     /* 1204386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1204399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204421 */     // GIR_Coverage, 17095,
     /* 1204421 */     GIR_EraseRootFromParent_Done,
     /* 1204422 */   // Label 17503: @1204422
     /* 1204422 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1204502), // Rule ID 17098 //
     /* 1204427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204466 */     // MIs[0] round
     /* 1204466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204501 */     // GIR_Coverage, 17098,
     /* 1204501 */     GIR_EraseRootFromParent_Done,
     /* 1204502 */   // Label 17504: @1204502
     /* 1204502 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1204582), // Rule ID 17099 //
     /* 1204507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204546 */     // MIs[0] round
     /* 1204546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204581 */     // GIR_Coverage, 17099,
     /* 1204581 */     GIR_EraseRootFromParent_Done,
     /* 1204582 */   // Label 17505: @1204582
     /* 1204582 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1204662), // Rule ID 17102 //
     /* 1204587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204626 */     // MIs[0] round
     /* 1204626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204636 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204661 */     // GIR_Coverage, 17102,
     /* 1204661 */     GIR_EraseRootFromParent_Done,
     /* 1204662 */   // Label 17506: @1204662
     /* 1204662 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1204742), // Rule ID 17103 //
     /* 1204667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204706 */     // MIs[0] round
     /* 1204706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204716 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204741 */     // GIR_Coverage, 17103,
     /* 1204741 */     GIR_EraseRootFromParent_Done,
     /* 1204742 */   // Label 17507: @1204742
     /* 1204742 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1204822), // Rule ID 17106 //
     /* 1204747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204786 */     // MIs[0] round
     /* 1204786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204796 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204821 */     // GIR_Coverage, 17106,
     /* 1204821 */     GIR_EraseRootFromParent_Done,
     /* 1204822 */   // Label 17508: @1204822
     /* 1204822 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1204902), // Rule ID 17107 //
     /* 1204827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204866 */     // MIs[0] round
     /* 1204866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204876 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204901 */     // GIR_Coverage, 17107,
     /* 1204901 */     GIR_EraseRootFromParent_Done,
     /* 1204902 */   // Label 17509: @1204902
     /* 1204902 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1204982), // Rule ID 17110 //
     /* 1204907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204946 */     // MIs[0] round
     /* 1204946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204981 */     // GIR_Coverage, 17110,
     /* 1204981 */     GIR_EraseRootFromParent_Done,
     /* 1204982 */   // Label 17510: @1204982
     /* 1204982 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1205062), // Rule ID 17111 //
     /* 1204987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1205004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205026 */     // MIs[0] round
     /* 1205026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1205039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205061 */     // GIR_Coverage, 17111,
     /* 1205061 */     GIR_EraseRootFromParent_Done,
     /* 1205062 */   // Label 17511: @1205062
     /* 1205062 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1205142), // Rule ID 17114 //
     /* 1205067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205106 */     // MIs[0] round
     /* 1205106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1205119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205141 */     // GIR_Coverage, 17114,
     /* 1205141 */     GIR_EraseRootFromParent_Done,
     /* 1205142 */   // Label 17512: @1205142
     /* 1205142 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1205222), // Rule ID 17115 //
     /* 1205147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1205164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205186 */     // MIs[0] round
     /* 1205186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205196 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1205199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205221 */     // GIR_Coverage, 17115,
     /* 1205221 */     GIR_EraseRootFromParent_Done,
     /* 1205222 */   // Label 17513: @1205222
     /* 1205222 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1205302), // Rule ID 17118 //
     /* 1205227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205266 */     // MIs[0] round
     /* 1205266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205276 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1205279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205301 */     // GIR_Coverage, 17118,
     /* 1205301 */     GIR_EraseRootFromParent_Done,
     /* 1205302 */   // Label 17514: @1205302
     /* 1205302 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1205382), // Rule ID 17119 //
     /* 1205307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1205324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205346 */     // MIs[0] round
     /* 1205346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1205359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205381 */     // GIR_Coverage, 17119,
     /* 1205381 */     GIR_EraseRootFromParent_Done,
     /* 1205382 */   // Label 17515: @1205382
     /* 1205382 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1205462), // Rule ID 17122 //
     /* 1205387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205426 */     // MIs[0] round
     /* 1205426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205436 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205461 */     // GIR_Coverage, 17122,
     /* 1205461 */     GIR_EraseRootFromParent_Done,
     /* 1205462 */   // Label 17516: @1205462
     /* 1205462 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1205542), // Rule ID 17123 //
     /* 1205467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205506 */     // MIs[0] round
     /* 1205506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205516 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205541 */     // GIR_Coverage, 17123,
     /* 1205541 */     GIR_EraseRootFromParent_Done,
     /* 1205542 */   // Label 17517: @1205542
     /* 1205542 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1205622), // Rule ID 17126 //
     /* 1205547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205586 */     // MIs[0] round
     /* 1205586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205596 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205621 */     // GIR_Coverage, 17126,
     /* 1205621 */     GIR_EraseRootFromParent_Done,
     /* 1205622 */   // Label 17518: @1205622
     /* 1205622 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1205702), // Rule ID 17127 //
     /* 1205627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205666 */     // MIs[0] round
     /* 1205666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205676 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205701 */     // GIR_Coverage, 17127,
     /* 1205701 */     GIR_EraseRootFromParent_Done,
     /* 1205702 */   // Label 17519: @1205702
     /* 1205702 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1205782), // Rule ID 17130 //
     /* 1205707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205746 */     // MIs[0] round
     /* 1205746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205756 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205781 */     // GIR_Coverage, 17130,
     /* 1205781 */     GIR_EraseRootFromParent_Done,
     /* 1205782 */   // Label 17520: @1205782
     /* 1205782 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1205862), // Rule ID 17131 //
     /* 1205787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205826 */     // MIs[0] round
     /* 1205826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205836 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205861 */     // GIR_Coverage, 17131,
     /* 1205861 */     GIR_EraseRootFromParent_Done,
     /* 1205862 */   // Label 17521: @1205862
     /* 1205862 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1205942), // Rule ID 17134 //
     /* 1205867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205906 */     // MIs[0] round
     /* 1205906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205941 */     // GIR_Coverage, 17134,
     /* 1205941 */     GIR_EraseRootFromParent_Done,
     /* 1205942 */   // Label 17522: @1205942
     /* 1205942 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1206022), // Rule ID 17135 //
     /* 1205947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205986 */     // MIs[0] round
     /* 1205986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205996 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206021 */     // GIR_Coverage, 17135,
     /* 1206021 */     GIR_EraseRootFromParent_Done,
     /* 1206022 */   // Label 17523: @1206022
     /* 1206022 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1206102), // Rule ID 17138 //
     /* 1206027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206066 */     // MIs[0] round
     /* 1206066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206076 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1206079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206101 */     // GIR_Coverage, 17138,
     /* 1206101 */     GIR_EraseRootFromParent_Done,
     /* 1206102 */   // Label 17524: @1206102
     /* 1206102 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1206182), // Rule ID 17139 //
     /* 1206107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206146 */     // MIs[0] round
     /* 1206146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206156 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1206159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206181 */     // GIR_Coverage, 17139,
     /* 1206181 */     GIR_EraseRootFromParent_Done,
     /* 1206182 */   // Label 17525: @1206182
     /* 1206182 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1206262), // Rule ID 17142 //
     /* 1206187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206226 */     // MIs[0] round
     /* 1206226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1206239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206261 */     // GIR_Coverage, 17142,
     /* 1206261 */     GIR_EraseRootFromParent_Done,
     /* 1206262 */   // Label 17526: @1206262
     /* 1206262 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1206342), // Rule ID 17143 //
     /* 1206267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1206275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206306 */     // MIs[0] round
     /* 1206306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1206319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206341 */     // GIR_Coverage, 17143,
     /* 1206341 */     GIR_EraseRootFromParent_Done,
     /* 1206342 */   // Label 17527: @1206342
     /* 1206342 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1206422), // Rule ID 17148 //
     /* 1206347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1206358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1206361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1206367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206386 */     // MIs[0] round
     /* 1206386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206421 */     // GIR_Coverage, 17148,
     /* 1206421 */     GIR_EraseRootFromParent_Done,
     /* 1206422 */   // Label 17528: @1206422
     /* 1206422 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1206502), // Rule ID 17149 //
     /* 1206427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1206438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1206441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1206444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1206447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206466 */     // MIs[0] round
     /* 1206466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206501 */     // GIR_Coverage, 17149,
     /* 1206501 */     GIR_EraseRootFromParent_Done,
     /* 1206502 */   // Label 17529: @1206502
     /* 1206502 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1206582), // Rule ID 17158 //
     /* 1206507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206546 */     // MIs[0] round
     /* 1206546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206581 */     // GIR_Coverage, 17158,
     /* 1206581 */     GIR_EraseRootFromParent_Done,
     /* 1206582 */   // Label 17530: @1206582
     /* 1206582 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1206662), // Rule ID 17159 //
     /* 1206587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206626 */     // MIs[0] round
     /* 1206626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206636 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206661 */     // GIR_Coverage, 17159,
     /* 1206661 */     GIR_EraseRootFromParent_Done,
     /* 1206662 */   // Label 17531: @1206662
     /* 1206662 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1206742), // Rule ID 17168 //
     /* 1206667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206706 */     // MIs[0] round
     /* 1206706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206716 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206741 */     // GIR_Coverage, 17168,
     /* 1206741 */     GIR_EraseRootFromParent_Done,
     /* 1206742 */   // Label 17532: @1206742
     /* 1206742 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1206822), // Rule ID 17169 //
     /* 1206747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206786 */     // MIs[0] round
     /* 1206786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206796 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206821 */     // GIR_Coverage, 17169,
     /* 1206821 */     GIR_EraseRootFromParent_Done,
     /* 1206822 */   // Label 17533: @1206822
     /* 1206822 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1206902), // Rule ID 17178 //
     /* 1206827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206866 */     // MIs[0] round
     /* 1206866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206901 */     // GIR_Coverage, 17178,
     /* 1206901 */     GIR_EraseRootFromParent_Done,
     /* 1206902 */   // Label 17534: @1206902
     /* 1206902 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1206982), // Rule ID 17179 //
     /* 1206907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206946 */     // MIs[0] round
     /* 1206946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206956 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206981 */     // GIR_Coverage, 17179,
     /* 1206981 */     GIR_EraseRootFromParent_Done,
     /* 1206982 */   // Label 17535: @1206982
     /* 1206982 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1207062), // Rule ID 17188 //
     /* 1206987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207026 */     // MIs[0] round
     /* 1207026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1207039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207061 */     // GIR_Coverage, 17188,
     /* 1207061 */     GIR_EraseRootFromParent_Done,
     /* 1207062 */   // Label 17536: @1207062
     /* 1207062 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1207142), // Rule ID 17189 //
     /* 1207067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207106 */     // MIs[0] round
     /* 1207106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1207119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207141 */     // GIR_Coverage, 17189,
     /* 1207141 */     GIR_EraseRootFromParent_Done,
     /* 1207142 */   // Label 17537: @1207142
     /* 1207142 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1207222), // Rule ID 17198 //
     /* 1207147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207186 */     // MIs[0] round
     /* 1207186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207196 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1207199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207221 */     // GIR_Coverage, 17198,
     /* 1207221 */     GIR_EraseRootFromParent_Done,
     /* 1207222 */   // Label 17538: @1207222
     /* 1207222 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1207302), // Rule ID 17199 //
     /* 1207227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207266 */     // MIs[0] round
     /* 1207266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1207279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207301 */     // GIR_Coverage, 17199,
     /* 1207301 */     GIR_EraseRootFromParent_Done,
     /* 1207302 */   // Label 17539: @1207302
     /* 1207302 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1207382), // Rule ID 17208 //
     /* 1207307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1207327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207346 */     // MIs[0] round
     /* 1207346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1207359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207381 */     // GIR_Coverage, 17208,
     /* 1207381 */     GIR_EraseRootFromParent_Done,
     /* 1207382 */   // Label 17540: @1207382
     /* 1207382 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1207462), // Rule ID 17209 //
     /* 1207387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1207407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207426 */     // MIs[0] round
     /* 1207426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207436 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1207439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207461 */     // GIR_Coverage, 17209,
     /* 1207461 */     GIR_EraseRootFromParent_Done,
     /* 1207462 */   // Label 17541: @1207462
     /* 1207462 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1207542), // Rule ID 17218 //
     /* 1207467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207506 */     // MIs[0] round
     /* 1207506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207516 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207541 */     // GIR_Coverage, 17218,
     /* 1207541 */     GIR_EraseRootFromParent_Done,
     /* 1207542 */   // Label 17542: @1207542
     /* 1207542 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1207622), // Rule ID 17219 //
     /* 1207547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207586 */     // MIs[0] round
     /* 1207586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207596 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207621 */     // GIR_Coverage, 17219,
     /* 1207621 */     GIR_EraseRootFromParent_Done,
     /* 1207622 */   // Label 17543: @1207622
     /* 1207622 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1207702), // Rule ID 17226 //
     /* 1207627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207666 */     // MIs[0] round
     /* 1207666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207701 */     // GIR_Coverage, 17226,
     /* 1207701 */     GIR_EraseRootFromParent_Done,
     /* 1207702 */   // Label 17544: @1207702
     /* 1207702 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1207782), // Rule ID 17227 //
     /* 1207707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207746 */     // MIs[0] round
     /* 1207746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207781 */     // GIR_Coverage, 17227,
     /* 1207781 */     GIR_EraseRootFromParent_Done,
     /* 1207782 */   // Label 17545: @1207782
     /* 1207782 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1207862), // Rule ID 17230 //
     /* 1207787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207826 */     // MIs[0] round
     /* 1207826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207861 */     // GIR_Coverage, 17230,
     /* 1207861 */     GIR_EraseRootFromParent_Done,
     /* 1207862 */   // Label 17546: @1207862
     /* 1207862 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1207942), // Rule ID 17231 //
     /* 1207867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207906 */     // MIs[0] round
     /* 1207906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207941 */     // GIR_Coverage, 17231,
     /* 1207941 */     GIR_EraseRootFromParent_Done,
     /* 1207942 */   // Label 17547: @1207942
     /* 1207942 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1208022), // Rule ID 17234 //
     /* 1207947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207986 */     // MIs[0] round
     /* 1207986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207996 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208021 */     // GIR_Coverage, 17234,
     /* 1208021 */     GIR_EraseRootFromParent_Done,
     /* 1208022 */   // Label 17548: @1208022
     /* 1208022 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1208102), // Rule ID 17235 //
     /* 1208027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208066 */     // MIs[0] round
     /* 1208066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1208079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208101 */     // GIR_Coverage, 17235,
     /* 1208101 */     GIR_EraseRootFromParent_Done,
     /* 1208102 */   // Label 17549: @1208102
     /* 1208102 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1208182), // Rule ID 17238 //
     /* 1208107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208146 */     // MIs[0] round
     /* 1208146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1208159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208181 */     // GIR_Coverage, 17238,
     /* 1208181 */     GIR_EraseRootFromParent_Done,
     /* 1208182 */   // Label 17550: @1208182
     /* 1208182 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1208262), // Rule ID 17239 //
     /* 1208187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208226 */     // MIs[0] round
     /* 1208226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1208239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208261 */     // GIR_Coverage, 17239,
     /* 1208261 */     GIR_EraseRootFromParent_Done,
     /* 1208262 */   // Label 17551: @1208262
     /* 1208262 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1208342), // Rule ID 17242 //
     /* 1208267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208306 */     // MIs[0] round
     /* 1208306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208316 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1208319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208341 */     // GIR_Coverage, 17242,
     /* 1208341 */     GIR_EraseRootFromParent_Done,
     /* 1208342 */   // Label 17552: @1208342
     /* 1208342 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1208422), // Rule ID 17243 //
     /* 1208347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1208367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1208386 */     // MIs[0] round
     /* 1208386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208396 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1208399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208421 */     // GIR_Coverage, 17243,
     /* 1208421 */     GIR_EraseRootFromParent_Done,
     /* 1208422 */   // Label 17553: @1208422
     /* 1208422 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1208502), // Rule ID 17246 //
     /* 1208427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208466 */     // MIs[0] round
     /* 1208466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208501 */     // GIR_Coverage, 17246,
     /* 1208501 */     GIR_EraseRootFromParent_Done,
     /* 1208502 */   // Label 17554: @1208502
     /* 1208502 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1208582), // Rule ID 17247 //
     /* 1208507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208546 */     // MIs[0] round
     /* 1208546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208581 */     // GIR_Coverage, 17247,
     /* 1208581 */     GIR_EraseRootFromParent_Done,
     /* 1208582 */   // Label 17555: @1208582
     /* 1208582 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1208662), // Rule ID 17250 //
     /* 1208587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208626 */     // MIs[0] round
     /* 1208626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208661 */     // GIR_Coverage, 17250,
     /* 1208661 */     GIR_EraseRootFromParent_Done,
     /* 1208662 */   // Label 17556: @1208662
     /* 1208662 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1208742), // Rule ID 17251 //
     /* 1208667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208706 */     // MIs[0] round
     /* 1208706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208741 */     // GIR_Coverage, 17251,
     /* 1208741 */     GIR_EraseRootFromParent_Done,
     /* 1208742 */   // Label 17557: @1208742
     /* 1208742 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1208822), // Rule ID 17254 //
     /* 1208747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208786 */     // MIs[0] round
     /* 1208786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208796 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208821 */     // GIR_Coverage, 17254,
     /* 1208821 */     GIR_EraseRootFromParent_Done,
     /* 1208822 */   // Label 17558: @1208822
     /* 1208822 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1208902), // Rule ID 17255 //
     /* 1208827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208866 */     // MIs[0] round
     /* 1208866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208901 */     // GIR_Coverage, 17255,
     /* 1208901 */     GIR_EraseRootFromParent_Done,
     /* 1208902 */   // Label 17559: @1208902
     /* 1208902 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1208982), // Rule ID 17258 //
     /* 1208907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208946 */     // MIs[0] round
     /* 1208946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208981 */     // GIR_Coverage, 17258,
     /* 1208981 */     GIR_EraseRootFromParent_Done,
     /* 1208982 */   // Label 17560: @1208982
     /* 1208982 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1209062), // Rule ID 17259 //
     /* 1208987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209026 */     // MIs[0] round
     /* 1209026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209036 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1209039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209061 */     // GIR_Coverage, 17259,
     /* 1209061 */     GIR_EraseRootFromParent_Done,
     /* 1209062 */   // Label 17561: @1209062
     /* 1209062 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1209142), // Rule ID 17264 //
     /* 1209067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1209087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209106 */     // MIs[0] round
     /* 1209106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209116 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1209119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209141 */     // GIR_Coverage, 17264,
     /* 1209141 */     GIR_EraseRootFromParent_Done,
     /* 1209142 */   // Label 17562: @1209142
     /* 1209142 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1209222), // Rule ID 17265 //
     /* 1209147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1209167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209186 */     // MIs[0] round
     /* 1209186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209196 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1209199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209221 */     // GIR_Coverage, 17265,
     /* 1209221 */     GIR_EraseRootFromParent_Done,
     /* 1209222 */   // Label 17563: @1209222
     /* 1209222 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1209302), // Rule ID 17274 //
     /* 1209227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209266 */     // MIs[0] round
     /* 1209266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209276 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1209279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209301 */     // GIR_Coverage, 17274,
     /* 1209301 */     GIR_EraseRootFromParent_Done,
     /* 1209302 */   // Label 17564: @1209302
     /* 1209302 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1209382), // Rule ID 17275 //
     /* 1209307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1209327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209346 */     // MIs[0] round
     /* 1209346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209356 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1209359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209381 */     // GIR_Coverage, 17275,
     /* 1209381 */     GIR_EraseRootFromParent_Done,
     /* 1209382 */   // Label 17565: @1209382
     /* 1209382 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1209462), // Rule ID 17284 //
     /* 1209387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209426 */     // MIs[0] round
     /* 1209426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209436 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209461 */     // GIR_Coverage, 17284,
     /* 1209461 */     GIR_EraseRootFromParent_Done,
     /* 1209462 */   // Label 17566: @1209462
     /* 1209462 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1209542), // Rule ID 17285 //
     /* 1209467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209506 */     // MIs[0] round
     /* 1209506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209541 */     // GIR_Coverage, 17285,
     /* 1209541 */     GIR_EraseRootFromParent_Done,
     /* 1209542 */   // Label 17567: @1209542
     /* 1209542 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1209622), // Rule ID 17294 //
     /* 1209547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209586 */     // MIs[0] round
     /* 1209586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209596 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209621 */     // GIR_Coverage, 17294,
     /* 1209621 */     GIR_EraseRootFromParent_Done,
     /* 1209622 */   // Label 17568: @1209622
     /* 1209622 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1209702), // Rule ID 17295 //
     /* 1209627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209666 */     // MIs[0] round
     /* 1209666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209676 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209701 */     // GIR_Coverage, 17295,
     /* 1209701 */     GIR_EraseRootFromParent_Done,
     /* 1209702 */   // Label 17569: @1209702
     /* 1209702 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1209782), // Rule ID 17304 //
     /* 1209707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209746 */     // MIs[0] round
     /* 1209746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209781 */     // GIR_Coverage, 17304,
     /* 1209781 */     GIR_EraseRootFromParent_Done,
     /* 1209782 */   // Label 17570: @1209782
     /* 1209782 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1209862), // Rule ID 17305 //
     /* 1209787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209826 */     // MIs[0] round
     /* 1209826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209861 */     // GIR_Coverage, 17305,
     /* 1209861 */     GIR_EraseRootFromParent_Done,
     /* 1209862 */   // Label 17571: @1209862
     /* 1209862 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1209942), // Rule ID 17314 //
     /* 1209867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209906 */     // MIs[0] round
     /* 1209906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209941 */     // GIR_Coverage, 17314,
     /* 1209941 */     GIR_EraseRootFromParent_Done,
     /* 1209942 */   // Label 17572: @1209942
     /* 1209942 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1210022), // Rule ID 17315 //
     /* 1209947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209986 */     // MIs[0] round
     /* 1209986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209996 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210021 */     // GIR_Coverage, 17315,
     /* 1210021 */     GIR_EraseRootFromParent_Done,
     /* 1210022 */   // Label 17573: @1210022
     /* 1210022 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1210102), // Rule ID 17324 //
     /* 1210027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210066 */     // MIs[0] round
     /* 1210066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1210079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210101 */     // GIR_Coverage, 17324,
     /* 1210101 */     GIR_EraseRootFromParent_Done,
     /* 1210102 */   // Label 17574: @1210102
     /* 1210102 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1210182), // Rule ID 17325 //
     /* 1210107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1210127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210146 */     // MIs[0] round
     /* 1210146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1210159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210181 */     // GIR_Coverage, 17325,
     /* 1210181 */     GIR_EraseRootFromParent_Done,
     /* 1210182 */   // Label 17575: @1210182
     /* 1210182 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1210262), // Rule ID 17334 //
     /* 1210187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210226 */     // MIs[0] round
     /* 1210226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210236 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1210239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210261 */     // GIR_Coverage, 17334,
     /* 1210261 */     GIR_EraseRootFromParent_Done,
     /* 1210262 */   // Label 17576: @1210262
     /* 1210262 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1210342), // Rule ID 17335 //
     /* 1210267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1210287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210306 */     // MIs[0] round
     /* 1210306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210316 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1210319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210341 */     // GIR_Coverage, 17335,
     /* 1210341 */     GIR_EraseRootFromParent_Done,
     /* 1210342 */   // Label 17577: @1210342
     /* 1210342 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1210422), // Rule ID 17344 //
     /* 1210347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210386 */     // MIs[0] round
     /* 1210386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210396 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210421 */     // GIR_Coverage, 17344,
     /* 1210421 */     GIR_EraseRootFromParent_Done,
     /* 1210422 */   // Label 17578: @1210422
     /* 1210422 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1210502), // Rule ID 17345 //
     /* 1210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1210438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1210441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1210444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1210447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210466 */     // MIs[0] round
     /* 1210466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210476 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210501 */     // GIR_Coverage, 17345,
     /* 1210501 */     GIR_EraseRootFromParent_Done,
     /* 1210502 */   // Label 17579: @1210502
     /* 1210502 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1210582), // Rule ID 17352 //
     /* 1210507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210546 */     // MIs[0] round
     /* 1210546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210556 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210581 */     // GIR_Coverage, 17352,
     /* 1210581 */     GIR_EraseRootFromParent_Done,
     /* 1210582 */   // Label 17580: @1210582
     /* 1210582 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1210662), // Rule ID 17353 //
     /* 1210587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210626 */     // MIs[0] round
     /* 1210626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210636 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210661 */     // GIR_Coverage, 17353,
     /* 1210661 */     GIR_EraseRootFromParent_Done,
     /* 1210662 */   // Label 17581: @1210662
     /* 1210662 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1210742), // Rule ID 17356 //
     /* 1210667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210706 */     // MIs[0] round
     /* 1210706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210741 */     // GIR_Coverage, 17356,
     /* 1210741 */     GIR_EraseRootFromParent_Done,
     /* 1210742 */   // Label 17582: @1210742
     /* 1210742 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1210822), // Rule ID 17357 //
     /* 1210747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210786 */     // MIs[0] round
     /* 1210786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210821 */     // GIR_Coverage, 17357,
     /* 1210821 */     GIR_EraseRootFromParent_Done,
     /* 1210822 */   // Label 17583: @1210822
     /* 1210822 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1210902), // Rule ID 17360 //
     /* 1210827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210866 */     // MIs[0] round
     /* 1210866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210901 */     // GIR_Coverage, 17360,
     /* 1210901 */     GIR_EraseRootFromParent_Done,
     /* 1210902 */   // Label 17584: @1210902
     /* 1210902 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1210982), // Rule ID 17361 //
     /* 1210907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210946 */     // MIs[0] round
     /* 1210946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210981 */     // GIR_Coverage, 17361,
     /* 1210981 */     GIR_EraseRootFromParent_Done,
     /* 1210982 */   // Label 17585: @1210982
     /* 1210982 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1211062), // Rule ID 17364 //
     /* 1210987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211026 */     // MIs[0] round
     /* 1211026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1211039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211061 */     // GIR_Coverage, 17364,
     /* 1211061 */     GIR_EraseRootFromParent_Done,
     /* 1211062 */   // Label 17586: @1211062
     /* 1211062 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1211142), // Rule ID 17365 //
     /* 1211067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1211078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1211081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1211084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211106 */     // MIs[0] round
     /* 1211106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211116 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1211119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211141 */     // GIR_Coverage, 17365,
     /* 1211141 */     GIR_EraseRootFromParent_Done,
     /* 1211142 */   // Label 17587: @1211142
     /* 1211142 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1211222), // Rule ID 17368 //
     /* 1211147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1211150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211186 */     // MIs[0] round
     /* 1211186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211196 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1211199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211221 */     // GIR_Coverage, 17368,
     /* 1211221 */     GIR_EraseRootFromParent_Done,
     /* 1211222 */   // Label 17588: @1211222
     /* 1211222 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1211302), // Rule ID 17369 //
     /* 1211227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1211230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1211247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1211266 */     // MIs[0] round
     /* 1211266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211276 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1211279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211301 */     // GIR_Coverage, 17369,
     /* 1211301 */     GIR_EraseRootFromParent_Done,
     /* 1211302 */   // Label 17589: @1211302
     /* 1211302 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1211382), // Rule ID 17372 //
     /* 1211307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211346 */     // MIs[0] round
     /* 1211346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1211359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211381 */     // GIR_Coverage, 17372,
     /* 1211381 */     GIR_EraseRootFromParent_Done,
     /* 1211382 */   // Label 17590: @1211382
     /* 1211382 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1211462), // Rule ID 17373 //
     /* 1211387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211426 */     // MIs[0] round
     /* 1211426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1211439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211461 */     // GIR_Coverage, 17373,
     /* 1211461 */     GIR_EraseRootFromParent_Done,
     /* 1211462 */   // Label 17591: @1211462
     /* 1211462 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1211542), // Rule ID 17376 //
     /* 1211467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211506 */     // MIs[0] round
     /* 1211506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211541 */     // GIR_Coverage, 17376,
     /* 1211541 */     GIR_EraseRootFromParent_Done,
     /* 1211542 */   // Label 17592: @1211542
     /* 1211542 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1211622), // Rule ID 17377 //
     /* 1211547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211586 */     // MIs[0] round
     /* 1211586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211596 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211621 */     // GIR_Coverage, 17377,
     /* 1211621 */     GIR_EraseRootFromParent_Done,
     /* 1211622 */   // Label 17593: @1211622
     /* 1211622 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1211702), // Rule ID 17380 //
     /* 1211627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211666 */     // MIs[0] round
     /* 1211666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211676 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211701 */     // GIR_Coverage, 17380,
     /* 1211701 */     GIR_EraseRootFromParent_Done,
     /* 1211702 */   // Label 17594: @1211702
     /* 1211702 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1211782), // Rule ID 17381 //
     /* 1211707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211746 */     // MIs[0] round
     /* 1211746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211781 */     // GIR_Coverage, 17381,
     /* 1211781 */     GIR_EraseRootFromParent_Done,
     /* 1211782 */   // Label 17595: @1211782
     /* 1211782 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1211862), // Rule ID 17384 //
     /* 1211787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211826 */     // MIs[0] round
     /* 1211826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211836 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211861 */     // GIR_Coverage, 17384,
     /* 1211861 */     GIR_EraseRootFromParent_Done,
     /* 1211862 */   // Label 17596: @1211862
     /* 1211862 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1211942), // Rule ID 17385 //
     /* 1211867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211906 */     // MIs[0] round
     /* 1211906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211916 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211941 */     // GIR_Coverage, 17385,
     /* 1211941 */     GIR_EraseRootFromParent_Done,
     /* 1211942 */   // Label 17597: @1211942
     /* 1211942 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1212022), // Rule ID 17388 //
     /* 1211947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211986 */     // MIs[0] round
     /* 1211986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212021 */     // GIR_Coverage, 17388,
     /* 1212021 */     GIR_EraseRootFromParent_Done,
     /* 1212022 */   // Label 17598: @1212022
     /* 1212022 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1212102), // Rule ID 17389 //
     /* 1212027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1212038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1212041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1212044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1212047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212066 */     // MIs[0] round
     /* 1212066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212076 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1212079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212101 */     // GIR_Coverage, 17389,
     /* 1212101 */     GIR_EraseRootFromParent_Done,
     /* 1212102 */   // Label 17599: @1212102
     /* 1212102 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1212182), // Rule ID 17392 //
     /* 1212107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1212118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1212121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1212124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212146 */     // MIs[0] round
     /* 1212146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212156 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1212159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212181 */     // GIR_Coverage, 17392,
     /* 1212181 */     GIR_EraseRootFromParent_Done,
     /* 1212182 */   // Label 17600: @1212182
     /* 1212182 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1212262), // Rule ID 17393 //
     /* 1212187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1212198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1212201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1212204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1212207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212226 */     // MIs[0] round
     /* 1212226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212236 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1212239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212261 */     // GIR_Coverage, 17393,
     /* 1212261 */     GIR_EraseRootFromParent_Done,
     /* 1212262 */   // Label 17601: @1212262
     /* 1212262 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1212342), // Rule ID 17396 //
     /* 1212267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212306 */     // MIs[0] round
     /* 1212306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212316 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1212319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212341 */     // GIR_Coverage, 17396,
     /* 1212341 */     GIR_EraseRootFromParent_Done,
     /* 1212342 */   // Label 17602: @1212342
     /* 1212342 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1212422), // Rule ID 17397 //
     /* 1212347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212386 */     // MIs[0] round
     /* 1212386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212396 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1212399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212421 */     // GIR_Coverage, 17397,
     /* 1212421 */     GIR_EraseRootFromParent_Done,
     /* 1212422 */   // Label 17603: @1212422
     /* 1212422 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1212502), // Rule ID 17400 //
     /* 1212427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212466 */     // MIs[0] round
     /* 1212466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212476 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212501 */     // GIR_Coverage, 17400,
     /* 1212501 */     GIR_EraseRootFromParent_Done,
     /* 1212502 */   // Label 17604: @1212502
     /* 1212502 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1212582), // Rule ID 17401 //
     /* 1212507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212546 */     // MIs[0] round
     /* 1212546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212556 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212581 */     // GIR_Coverage, 17401,
     /* 1212581 */     GIR_EraseRootFromParent_Done,
     /* 1212582 */   // Label 17605: @1212582
     /* 1212582 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1212662), // Rule ID 17404 //
     /* 1212587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212626 */     // MIs[0] round
     /* 1212626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212636 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212661 */     // GIR_Coverage, 17404,
     /* 1212661 */     GIR_EraseRootFromParent_Done,
     /* 1212662 */   // Label 17606: @1212662
     /* 1212662 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1212742), // Rule ID 17405 //
     /* 1212667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212706 */     // MIs[0] round
     /* 1212706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212741 */     // GIR_Coverage, 17405,
     /* 1212741 */     GIR_EraseRootFromParent_Done,
     /* 1212742 */   // Label 17607: @1212742
     /* 1212742 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1212822), // Rule ID 17408 //
     /* 1212747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1212750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212786 */     // MIs[0] round
     /* 1212786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212821 */     // GIR_Coverage, 17408,
     /* 1212821 */     GIR_EraseRootFromParent_Done,
     /* 1212822 */   // Label 17608: @1212822
     /* 1212822 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1212902), // Rule ID 17409 //
     /* 1212827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212866 */     // MIs[0] round
     /* 1212866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212901 */     // GIR_Coverage, 17409,
     /* 1212901 */     GIR_EraseRootFromParent_Done,
     /* 1212902 */   // Label 17609: @1212902
     /* 1212902 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1212982), // Rule ID 17412 //
     /* 1212907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212946 */     // MIs[0] round
     /* 1212946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212956 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212981 */     // GIR_Coverage, 17412,
     /* 1212981 */     GIR_EraseRootFromParent_Done,
     /* 1212982 */   // Label 17610: @1212982
     /* 1212982 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1213062), // Rule ID 17413 //
     /* 1212987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1213001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1213004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1213007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213026 */     // MIs[0] round
     /* 1213026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213036 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1213039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213061 */     // GIR_Coverage, 17413,
     /* 1213061 */     GIR_EraseRootFromParent_Done,
     /* 1213062 */   // Label 17611: @1213062
     /* 1213062 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1213142), // Rule ID 17416 //
     /* 1213067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1213078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1213081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213106 */     // MIs[0] round
     /* 1213106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1213119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213141 */     // GIR_Coverage, 17416,
     /* 1213141 */     GIR_EraseRootFromParent_Done,
     /* 1213142 */   // Label 17612: @1213142
     /* 1213142 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1213222), // Rule ID 17417 //
     /* 1213147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1213158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1213161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1213164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1213167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213186 */     // MIs[0] round
     /* 1213186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1213199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213221 */     // GIR_Coverage, 17417,
     /* 1213221 */     GIR_EraseRootFromParent_Done,
     /* 1213222 */   // Label 17613: @1213222
     /* 1213222 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1213302), // Rule ID 17420 //
     /* 1213227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1213238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1213241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213266 */     // MIs[0] round
     /* 1213266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213276 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1213279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213301 */     // GIR_Coverage, 17420,
     /* 1213301 */     GIR_EraseRootFromParent_Done,
     /* 1213302 */   // Label 17614: @1213302
     /* 1213302 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1213382), // Rule ID 17421 //
     /* 1213307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1213318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1213321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1213324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1213327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213346 */     // MIs[0] round
     /* 1213346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213356 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1213359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213381 */     // GIR_Coverage, 17421,
     /* 1213381 */     GIR_EraseRootFromParent_Done,
     /* 1213382 */   // Label 17615: @1213382
     /* 1213382 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1213462), // Rule ID 17424 //
     /* 1213387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213426 */     // MIs[0] round
     /* 1213426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213436 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213461 */     // GIR_Coverage, 17424,
     /* 1213461 */     GIR_EraseRootFromParent_Done,
     /* 1213462 */   // Label 17616: @1213462
     /* 1213462 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1213542), // Rule ID 17425 //
     /* 1213467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213506 */     // MIs[0] round
     /* 1213506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213541 */     // GIR_Coverage, 17425,
     /* 1213541 */     GIR_EraseRootFromParent_Done,
     /* 1213542 */   // Label 17617: @1213542
     /* 1213542 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1213622), // Rule ID 17428 //
     /* 1213547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213586 */     // MIs[0] round
     /* 1213586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213596 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213621 */     // GIR_Coverage, 17428,
     /* 1213621 */     GIR_EraseRootFromParent_Done,
     /* 1213622 */   // Label 17618: @1213622
     /* 1213622 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1213702), // Rule ID 17429 //
     /* 1213627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213666 */     // MIs[0] round
     /* 1213666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213676 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213701 */     // GIR_Coverage, 17429,
     /* 1213701 */     GIR_EraseRootFromParent_Done,
     /* 1213702 */   // Label 17619: @1213702
     /* 1213702 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1213782), // Rule ID 17432 //
     /* 1213707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213746 */     // MIs[0] round
     /* 1213746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213781 */     // GIR_Coverage, 17432,
     /* 1213781 */     GIR_EraseRootFromParent_Done,
     /* 1213782 */   // Label 17620: @1213782
     /* 1213782 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1213862), // Rule ID 17433 //
     /* 1213787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213826 */     // MIs[0] round
     /* 1213826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213861 */     // GIR_Coverage, 17433,
     /* 1213861 */     GIR_EraseRootFromParent_Done,
     /* 1213862 */   // Label 17621: @1213862
     /* 1213862 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1213942), // Rule ID 17436 //
     /* 1213867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213906 */     // MIs[0] round
     /* 1213906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213941 */     // GIR_Coverage, 17436,
     /* 1213941 */     GIR_EraseRootFromParent_Done,
     /* 1213942 */   // Label 17622: @1213942
     /* 1213942 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1214022), // Rule ID 17437 //
     /* 1213947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213986 */     // MIs[0] round
     /* 1213986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213996 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214021 */     // GIR_Coverage, 17437,
     /* 1214021 */     GIR_EraseRootFromParent_Done,
     /* 1214022 */   // Label 17623: @1214022
     /* 1214022 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1214102), // Rule ID 17440 //
     /* 1214027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1214038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1214041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214066 */     // MIs[0] round
     /* 1214066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214076 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1214079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214101 */     // GIR_Coverage, 17440,
     /* 1214101 */     GIR_EraseRootFromParent_Done,
     /* 1214102 */   // Label 17624: @1214102
     /* 1214102 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1214182), // Rule ID 17441 //
     /* 1214107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1214118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1214121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1214124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1214127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214146 */     // MIs[0] round
     /* 1214146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214156 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1214159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214181 */     // GIR_Coverage, 17441,
     /* 1214181 */     GIR_EraseRootFromParent_Done,
     /* 1214182 */   // Label 17625: @1214182
     /* 1214182 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1214262), // Rule ID 17444 //
     /* 1214187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1214198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1214201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214226 */     // MIs[0] round
     /* 1214226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1214239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214261 */     // GIR_Coverage, 17444,
     /* 1214261 */     GIR_EraseRootFromParent_Done,
     /* 1214262 */   // Label 17626: @1214262
     /* 1214262 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1214342), // Rule ID 17445 //
     /* 1214267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1214278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1214281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1214284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1214287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214306 */     // MIs[0] round
     /* 1214306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1214319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214341 */     // GIR_Coverage, 17445,
     /* 1214341 */     GIR_EraseRootFromParent_Done,
     /* 1214342 */   // Label 17627: @1214342
     /* 1214342 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1214422), // Rule ID 17448 //
     /* 1214347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214386 */     // MIs[0] round
     /* 1214386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214396 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214421 */     // GIR_Coverage, 17448,
     /* 1214421 */     GIR_EraseRootFromParent_Done,
     /* 1214422 */   // Label 17628: @1214422
     /* 1214422 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1214502), // Rule ID 17449 //
     /* 1214427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214466 */     // MIs[0] round
     /* 1214466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214476 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214501 */     // GIR_Coverage, 17449,
     /* 1214501 */     GIR_EraseRootFromParent_Done,
     /* 1214502 */   // Label 17629: @1214502
     /* 1214502 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1214582), // Rule ID 17452 //
     /* 1214507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214546 */     // MIs[0] round
     /* 1214546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214556 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214581 */     // GIR_Coverage, 17452,
     /* 1214581 */     GIR_EraseRootFromParent_Done,
     /* 1214582 */   // Label 17630: @1214582
     /* 1214582 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1214662), // Rule ID 17453 //
     /* 1214587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214626 */     // MIs[0] round
     /* 1214626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214636 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214661 */     // GIR_Coverage, 17453,
     /* 1214661 */     GIR_EraseRootFromParent_Done,
     /* 1214662 */   // Label 17631: @1214662
     /* 1214662 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1214742), // Rule ID 17456 //
     /* 1214667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214706 */     // MIs[0] round
     /* 1214706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214716 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214741 */     // GIR_Coverage, 17456,
     /* 1214741 */     GIR_EraseRootFromParent_Done,
     /* 1214742 */   // Label 17632: @1214742
     /* 1214742 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1214822), // Rule ID 17457 //
     /* 1214747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214786 */     // MIs[0] round
     /* 1214786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214821 */     // GIR_Coverage, 17457,
     /* 1214821 */     GIR_EraseRootFromParent_Done,
     /* 1214822 */   // Label 17633: @1214822
     /* 1214822 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1214902), // Rule ID 17460 //
     /* 1214827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214866 */     // MIs[0] round
     /* 1214866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214876 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214901 */     // GIR_Coverage, 17460,
     /* 1214901 */     GIR_EraseRootFromParent_Done,
     /* 1214902 */   // Label 17634: @1214902
     /* 1214902 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1214982), // Rule ID 17461 //
     /* 1214907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214946 */     // MIs[0] round
     /* 1214946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214956 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214981 */     // GIR_Coverage, 17461,
     /* 1214981 */     GIR_EraseRootFromParent_Done,
     /* 1214982 */   // Label 17635: @1214982
     /* 1214982 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1215062), // Rule ID 17464 //
     /* 1214987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1215001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1215004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215026 */     // MIs[0] round
     /* 1215026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1215039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215061 */     // GIR_Coverage, 17464,
     /* 1215061 */     GIR_EraseRootFromParent_Done,
     /* 1215062 */   // Label 17636: @1215062
     /* 1215062 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1215142), // Rule ID 17465 //
     /* 1215067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1215078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1215081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1215084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215106 */     // MIs[0] round
     /* 1215106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1215119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215141 */     // GIR_Coverage, 17465,
     /* 1215141 */     GIR_EraseRootFromParent_Done,
     /* 1215142 */   // Label 17637: @1215142
     /* 1215142 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1215222), // Rule ID 17468 //
     /* 1215147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1215158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1215161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1215164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215186 */     // MIs[0] round
     /* 1215186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1215199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215221 */     // GIR_Coverage, 17468,
     /* 1215221 */     GIR_EraseRootFromParent_Done,
     /* 1215222 */   // Label 17638: @1215222
     /* 1215222 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1215302), // Rule ID 17469 //
     /* 1215227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1215238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1215241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1215244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215266 */     // MIs[0] round
     /* 1215266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1215279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215301 */     // GIR_Coverage, 17469,
     /* 1215301 */     GIR_EraseRootFromParent_Done,
     /* 1215302 */   // Label 17639: @1215302
     /* 1215302 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1215382), // Rule ID 17472 //
     /* 1215307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1215318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1215321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1215324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215346 */     // MIs[0] round
     /* 1215346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1215359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215381 */     // GIR_Coverage, 17472,
     /* 1215381 */     GIR_EraseRootFromParent_Done,
     /* 1215382 */   // Label 17640: @1215382
     /* 1215382 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1215462), // Rule ID 17473 //
     /* 1215387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1215398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1215401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1215404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215426 */     // MIs[0] round
     /* 1215426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215436 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1215439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215461 */     // GIR_Coverage, 17473,
     /* 1215461 */     GIR_EraseRootFromParent_Done,
     /* 1215462 */   // Label 17641: @1215462
     /* 1215462 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1215542), // Rule ID 17476 //
     /* 1215467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215506 */     // MIs[0] round
     /* 1215506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215516 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215541 */     // GIR_Coverage, 17476,
     /* 1215541 */     GIR_EraseRootFromParent_Done,
     /* 1215542 */   // Label 17642: @1215542
     /* 1215542 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1215622), // Rule ID 17477 //
     /* 1215547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215586 */     // MIs[0] round
     /* 1215586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215596 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215621 */     // GIR_Coverage, 17477,
     /* 1215621 */     GIR_EraseRootFromParent_Done,
     /* 1215622 */   // Label 17643: @1215622
     /* 1215622 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1215702), // Rule ID 17480 //
     /* 1215627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215666 */     // MIs[0] round
     /* 1215666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215676 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215701 */     // GIR_Coverage, 17480,
     /* 1215701 */     GIR_EraseRootFromParent_Done,
     /* 1215702 */   // Label 17644: @1215702
     /* 1215702 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1215782), // Rule ID 17481 //
     /* 1215707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215746 */     // MIs[0] round
     /* 1215746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215756 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215781 */     // GIR_Coverage, 17481,
     /* 1215781 */     GIR_EraseRootFromParent_Done,
     /* 1215782 */   // Label 17645: @1215782
     /* 1215782 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1215862), // Rule ID 17484 //
     /* 1215787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215826 */     // MIs[0] round
     /* 1215826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215861 */     // GIR_Coverage, 17484,
     /* 1215861 */     GIR_EraseRootFromParent_Done,
     /* 1215862 */   // Label 17646: @1215862
     /* 1215862 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1215942), // Rule ID 17485 //
     /* 1215867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215906 */     // MIs[0] round
     /* 1215906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215916 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215941 */     // GIR_Coverage, 17485,
     /* 1215941 */     GIR_EraseRootFromParent_Done,
     /* 1215942 */   // Label 17647: @1215942
     /* 1215942 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1216022), // Rule ID 17488 //
     /* 1215947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215986 */     // MIs[0] round
     /* 1215986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216021 */     // GIR_Coverage, 17488,
     /* 1216021 */     GIR_EraseRootFromParent_Done,
     /* 1216022 */   // Label 17648: @1216022
     /* 1216022 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1216102), // Rule ID 17489 //
     /* 1216027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1216038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1216041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1216044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216066 */     // MIs[0] round
     /* 1216066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1216079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216101 */     // GIR_Coverage, 17489,
     /* 1216101 */     GIR_EraseRootFromParent_Done,
     /* 1216102 */   // Label 17649: @1216102
     /* 1216102 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1216182), // Rule ID 17492 //
     /* 1216107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1216118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1216121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1216124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216146 */     // MIs[0] round
     /* 1216146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1216159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216181 */     // GIR_Coverage, 17492,
     /* 1216181 */     GIR_EraseRootFromParent_Done,
     /* 1216182 */   // Label 17650: @1216182
     /* 1216182 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1216262), // Rule ID 17493 //
     /* 1216187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1216198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1216201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1216204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216226 */     // MIs[0] round
     /* 1216226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216236 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1216239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216261 */     // GIR_Coverage, 17493,
     /* 1216261 */     GIR_EraseRootFromParent_Done,
     /* 1216262 */   // Label 17651: @1216262
     /* 1216262 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1216342), // Rule ID 17496 //
     /* 1216267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1216278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1216281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1216284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216306 */     // MIs[0] round
     /* 1216306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1216319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216341 */     // GIR_Coverage, 17496,
     /* 1216341 */     GIR_EraseRootFromParent_Done,
     /* 1216342 */   // Label 17652: @1216342
     /* 1216342 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1216422), // Rule ID 17497 //
     /* 1216347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1216358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1216361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1216364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216386 */     // MIs[0] round
     /* 1216386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1216399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216421 */     // GIR_Coverage, 17497,
     /* 1216421 */     GIR_EraseRootFromParent_Done,
     /* 1216422 */   // Label 17653: @1216422
     /* 1216422 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1216502), // Rule ID 17500 //
     /* 1216427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216466 */     // MIs[0] round
     /* 1216466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216476 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216501 */     // GIR_Coverage, 17500,
     /* 1216501 */     GIR_EraseRootFromParent_Done,
     /* 1216502 */   // Label 17654: @1216502
     /* 1216502 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1216582), // Rule ID 17501 //
     /* 1216507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216546 */     // MIs[0] round
     /* 1216546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216556 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216581 */     // GIR_Coverage, 17501,
     /* 1216581 */     GIR_EraseRootFromParent_Done,
     /* 1216582 */   // Label 17655: @1216582
     /* 1216582 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1216662), // Rule ID 17504 //
     /* 1216587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216626 */     // MIs[0] round
     /* 1216626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216636 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216661 */     // GIR_Coverage, 17504,
     /* 1216661 */     GIR_EraseRootFromParent_Done,
     /* 1216662 */   // Label 17656: @1216662
     /* 1216662 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1216742), // Rule ID 17505 //
     /* 1216667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216706 */     // MIs[0] round
     /* 1216706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216716 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216741 */     // GIR_Coverage, 17505,
     /* 1216741 */     GIR_EraseRootFromParent_Done,
     /* 1216742 */   // Label 17657: @1216742
     /* 1216742 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1216822), // Rule ID 17508 //
     /* 1216747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216786 */     // MIs[0] round
     /* 1216786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216796 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216821 */     // GIR_Coverage, 17508,
     /* 1216821 */     GIR_EraseRootFromParent_Done,
     /* 1216822 */   // Label 17658: @1216822
     /* 1216822 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1216902), // Rule ID 17509 //
     /* 1216827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216866 */     // MIs[0] round
     /* 1216866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216876 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216901 */     // GIR_Coverage, 17509,
     /* 1216901 */     GIR_EraseRootFromParent_Done,
     /* 1216902 */   // Label 17659: @1216902
     /* 1216902 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1216982), // Rule ID 17512 //
     /* 1216907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216946 */     // MIs[0] round
     /* 1216946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216956 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216981 */     // GIR_Coverage, 17512,
     /* 1216981 */     GIR_EraseRootFromParent_Done,
     /* 1216982 */   // Label 17660: @1216982
     /* 1216982 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1217062), // Rule ID 17513 //
     /* 1216987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1217001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1217004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1217007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217026 */     // MIs[0] round
     /* 1217026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217036 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1217039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217061 */     // GIR_Coverage, 17513,
     /* 1217061 */     GIR_EraseRootFromParent_Done,
     /* 1217062 */   // Label 17661: @1217062
     /* 1217062 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1217142), // Rule ID 17516 //
     /* 1217067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1217078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1217081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1217084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1217087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217106 */     // MIs[0] round
     /* 1217106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217116 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1217119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217141 */     // GIR_Coverage, 17516,
     /* 1217141 */     GIR_EraseRootFromParent_Done,
     /* 1217142 */   // Label 17662: @1217142
     /* 1217142 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1217222), // Rule ID 17517 //
     /* 1217147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1217158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1217161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1217164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1217167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217186 */     // MIs[0] round
     /* 1217186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217196 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1217199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217221 */     // GIR_Coverage, 17517,
     /* 1217221 */     GIR_EraseRootFromParent_Done,
     /* 1217222 */   // Label 17663: @1217222
     /* 1217222 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1217302), // Rule ID 17520 //
     /* 1217227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1217238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1217241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1217244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1217247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217266 */     // MIs[0] round
     /* 1217266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217276 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1217279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217301 */     // GIR_Coverage, 17520,
     /* 1217301 */     GIR_EraseRootFromParent_Done,
     /* 1217302 */   // Label 17664: @1217302
     /* 1217302 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1217382), // Rule ID 17521 //
     /* 1217307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1217318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1217321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1217324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1217327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217346 */     // MIs[0] round
     /* 1217346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1217359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217381 */     // GIR_Coverage, 17521,
     /* 1217381 */     GIR_EraseRootFromParent_Done,
     /* 1217382 */   // Label 17665: @1217382
     /* 1217382 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1217462), // Rule ID 17524 //
     /* 1217387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217426 */     // MIs[0] round
     /* 1217426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217461 */     // GIR_Coverage, 17524,
     /* 1217461 */     GIR_EraseRootFromParent_Done,
     /* 1217462 */   // Label 17666: @1217462
     /* 1217462 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1217542), // Rule ID 17525 //
     /* 1217467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217506 */     // MIs[0] round
     /* 1217506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217541 */     // GIR_Coverage, 17525,
     /* 1217541 */     GIR_EraseRootFromParent_Done,
     /* 1217542 */   // Label 17667: @1217542
     /* 1217542 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1217622), // Rule ID 17528 //
     /* 1217547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217586 */     // MIs[0] round
     /* 1217586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217621 */     // GIR_Coverage, 17528,
     /* 1217621 */     GIR_EraseRootFromParent_Done,
     /* 1217622 */   // Label 17668: @1217622
     /* 1217622 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1217702), // Rule ID 17529 //
     /* 1217627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217666 */     // MIs[0] round
     /* 1217666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217701 */     // GIR_Coverage, 17529,
     /* 1217701 */     GIR_EraseRootFromParent_Done,
     /* 1217702 */   // Label 17669: @1217702
     /* 1217702 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1217782), // Rule ID 17532 //
     /* 1217707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217746 */     // MIs[0] round
     /* 1217746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217756 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217781 */     // GIR_Coverage, 17532,
     /* 1217781 */     GIR_EraseRootFromParent_Done,
     /* 1217782 */   // Label 17670: @1217782
     /* 1217782 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1217862), // Rule ID 17533 //
     /* 1217787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217826 */     // MIs[0] round
     /* 1217826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217836 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217861 */     // GIR_Coverage, 17533,
     /* 1217861 */     GIR_EraseRootFromParent_Done,
     /* 1217862 */   // Label 17671: @1217862
     /* 1217862 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1217942), // Rule ID 17536 //
     /* 1217867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217906 */     // MIs[0] round
     /* 1217906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217941 */     // GIR_Coverage, 17536,
     /* 1217941 */     GIR_EraseRootFromParent_Done,
     /* 1217942 */   // Label 17672: @1217942
     /* 1217942 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1218022), // Rule ID 17537 //
     /* 1217947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217986 */     // MIs[0] round
     /* 1217986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217996 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218021 */     // GIR_Coverage, 17537,
     /* 1218021 */     GIR_EraseRootFromParent_Done,
     /* 1218022 */   // Label 17673: @1218022
     /* 1218022 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1218102), // Rule ID 17540 //
     /* 1218027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1218038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1218041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1218044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1218047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218066 */     // MIs[0] round
     /* 1218066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218076 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1218079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218101 */     // GIR_Coverage, 17540,
     /* 1218101 */     GIR_EraseRootFromParent_Done,
     /* 1218102 */   // Label 17674: @1218102
     /* 1218102 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1218182), // Rule ID 17541 //
     /* 1218107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1218118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1218121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1218124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1218127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218146 */     // MIs[0] round
     /* 1218146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218156 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1218159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218181 */     // GIR_Coverage, 17541,
     /* 1218181 */     GIR_EraseRootFromParent_Done,
     /* 1218182 */   // Label 17675: @1218182
     /* 1218182 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1218262), // Rule ID 17544 //
     /* 1218187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1218198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1218201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1218204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1218207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218226 */     // MIs[0] round
     /* 1218226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218236 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1218239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218261 */     // GIR_Coverage, 17544,
     /* 1218261 */     GIR_EraseRootFromParent_Done,
     /* 1218262 */   // Label 17676: @1218262
     /* 1218262 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1218342), // Rule ID 17545 //
     /* 1218267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1218278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1218281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1218284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1218287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218306 */     // MIs[0] round
     /* 1218306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218316 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1218319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218341 */     // GIR_Coverage, 17545,
     /* 1218341 */     GIR_EraseRootFromParent_Done,
     /* 1218342 */   // Label 17677: @1218342
     /* 1218342 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1218422), // Rule ID 17548 //
     /* 1218347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1218367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218386 */     // MIs[0] round
     /* 1218386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218396 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218421 */     // GIR_Coverage, 17548,
     /* 1218421 */     GIR_EraseRootFromParent_Done,
     /* 1218422 */   // Label 17678: @1218422
     /* 1218422 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1218502), // Rule ID 17549 //
     /* 1218427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1218447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218466 */     // MIs[0] round
     /* 1218466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218501 */     // GIR_Coverage, 17549,
     /* 1218501 */     GIR_EraseRootFromParent_Done,
     /* 1218502 */   // Label 17679: @1218502
     /* 1218502 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1218582), // Rule ID 17552 //
     /* 1218507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218546 */     // MIs[0] round
     /* 1218546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218556 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218581 */     // GIR_Coverage, 17552,
     /* 1218581 */     GIR_EraseRootFromParent_Done,
     /* 1218582 */   // Label 17680: @1218582
     /* 1218582 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1218662), // Rule ID 17553 //
     /* 1218587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218626 */     // MIs[0] round
     /* 1218626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218636 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218661 */     // GIR_Coverage, 17553,
     /* 1218661 */     GIR_EraseRootFromParent_Done,
     /* 1218662 */   // Label 17681: @1218662
     /* 1218662 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1218742), // Rule ID 17556 //
     /* 1218667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218706 */     // MIs[0] round
     /* 1218706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218741 */     // GIR_Coverage, 17556,
     /* 1218741 */     GIR_EraseRootFromParent_Done,
     /* 1218742 */   // Label 17682: @1218742
     /* 1218742 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1218822), // Rule ID 17557 //
     /* 1218747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218786 */     // MIs[0] round
     /* 1218786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218821 */     // GIR_Coverage, 17557,
     /* 1218821 */     GIR_EraseRootFromParent_Done,
     /* 1218822 */   // Label 17683: @1218822
     /* 1218822 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1218902), // Rule ID 17560 //
     /* 1218827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218866 */     // MIs[0] round
     /* 1218866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218901 */     // GIR_Coverage, 17560,
     /* 1218901 */     GIR_EraseRootFromParent_Done,
     /* 1218902 */   // Label 17684: @1218902
     /* 1218902 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1218982), // Rule ID 17561 //
     /* 1218907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218946 */     // MIs[0] round
     /* 1218946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218956 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218981 */     // GIR_Coverage, 17561,
     /* 1218981 */     GIR_EraseRootFromParent_Done,
     /* 1218982 */   // Label 17685: @1218982
     /* 1218982 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1219062), // Rule ID 17564 //
     /* 1218987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1219001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1219004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1219007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219026 */     // MIs[0] round
     /* 1219026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219036 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1219039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219061 */     // GIR_Coverage, 17564,
     /* 1219061 */     GIR_EraseRootFromParent_Done,
     /* 1219062 */   // Label 17686: @1219062
     /* 1219062 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1219142), // Rule ID 17565 //
     /* 1219067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1219078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1219081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1219084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1219087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219106 */     // MIs[0] round
     /* 1219106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219116 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1219119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219141 */     // GIR_Coverage, 17565,
     /* 1219141 */     GIR_EraseRootFromParent_Done,
     /* 1219142 */   // Label 17687: @1219142
     /* 1219142 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1219222), // Rule ID 17568 //
     /* 1219147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219186 */     // MIs[0] round
     /* 1219186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219196 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1219199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219221 */     // GIR_Coverage, 17568,
     /* 1219221 */     GIR_EraseRootFromParent_Done,
     /* 1219222 */   // Label 17688: @1219222
     /* 1219222 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1219302), // Rule ID 17569 //
     /* 1219227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1219238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1219241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1219244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219266 */     // MIs[0] round
     /* 1219266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219276 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1219279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219301 */     // GIR_Coverage, 17569,
     /* 1219301 */     GIR_EraseRootFromParent_Done,
     /* 1219302 */   // Label 17689: @1219302
     /* 1219302 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1219382), // Rule ID 17572 //
     /* 1219307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219346 */     // MIs[0] round
     /* 1219346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219356 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1219359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219381 */     // GIR_Coverage, 17572,
     /* 1219381 */     GIR_EraseRootFromParent_Done,
     /* 1219382 */   // Label 17690: @1219382
     /* 1219382 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1219462), // Rule ID 17573 //
     /* 1219387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1219398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1219401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219426 */     // MIs[0] round
     /* 1219426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219436 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1219439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219461 */     // GIR_Coverage, 17573,
     /* 1219461 */     GIR_EraseRootFromParent_Done,
     /* 1219462 */   // Label 17691: @1219462
     /* 1219462 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1219542), // Rule ID 17576 //
     /* 1219467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219506 */     // MIs[0] round
     /* 1219506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219541 */     // GIR_Coverage, 17576,
     /* 1219541 */     GIR_EraseRootFromParent_Done,
     /* 1219542 */   // Label 17692: @1219542
     /* 1219542 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1219622), // Rule ID 17577 //
     /* 1219547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219586 */     // MIs[0] round
     /* 1219586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219621 */     // GIR_Coverage, 17577,
     /* 1219621 */     GIR_EraseRootFromParent_Done,
     /* 1219622 */   // Label 17693: @1219622
     /* 1219622 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1219702), // Rule ID 17580 //
     /* 1219627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219666 */     // MIs[0] round
     /* 1219666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219676 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219701 */     // GIR_Coverage, 17580,
     /* 1219701 */     GIR_EraseRootFromParent_Done,
     /* 1219702 */   // Label 17694: @1219702
     /* 1219702 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1219782), // Rule ID 17581 //
     /* 1219707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219746 */     // MIs[0] round
     /* 1219746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219756 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219781 */     // GIR_Coverage, 17581,
     /* 1219781 */     GIR_EraseRootFromParent_Done,
     /* 1219782 */   // Label 17695: @1219782
     /* 1219782 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1219862), // Rule ID 17584 //
     /* 1219787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219826 */     // MIs[0] round
     /* 1219826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219861 */     // GIR_Coverage, 17584,
     /* 1219861 */     GIR_EraseRootFromParent_Done,
     /* 1219862 */   // Label 17696: @1219862
     /* 1219862 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1219942), // Rule ID 17585 //
     /* 1219867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219906 */     // MIs[0] round
     /* 1219906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219941 */     // GIR_Coverage, 17585,
     /* 1219941 */     GIR_EraseRootFromParent_Done,
     /* 1219942 */   // Label 17697: @1219942
     /* 1219942 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1220022), // Rule ID 17588 //
     /* 1219947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219986 */     // MIs[0] round
     /* 1219986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219996 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220021 */     // GIR_Coverage, 17588,
     /* 1220021 */     GIR_EraseRootFromParent_Done,
     /* 1220022 */   // Label 17698: @1220022
     /* 1220022 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1220102), // Rule ID 17589 //
     /* 1220027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1220038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1220041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1220044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220066 */     // MIs[0] round
     /* 1220066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220076 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1220079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220101 */     // GIR_Coverage, 17589,
     /* 1220101 */     GIR_EraseRootFromParent_Done,
     /* 1220102 */   // Label 17699: @1220102
     /* 1220102 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1220182), // Rule ID 17592 //
     /* 1220107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220146 */     // MIs[0] round
     /* 1220146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220156 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1220159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220181 */     // GIR_Coverage, 17592,
     /* 1220181 */     GIR_EraseRootFromParent_Done,
     /* 1220182 */   // Label 17700: @1220182
     /* 1220182 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1220262), // Rule ID 17593 //
     /* 1220187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1220198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1220201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220226 */     // MIs[0] round
     /* 1220226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220236 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1220239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220261 */     // GIR_Coverage, 17593,
     /* 1220261 */     GIR_EraseRootFromParent_Done,
     /* 1220262 */   // Label 17701: @1220262
     /* 1220262 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1220342), // Rule ID 17596 //
     /* 1220267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220306 */     // MIs[0] round
     /* 1220306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220316 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1220319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220341 */     // GIR_Coverage, 17596,
     /* 1220341 */     GIR_EraseRootFromParent_Done,
     /* 1220342 */   // Label 17702: @1220342
     /* 1220342 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1220422), // Rule ID 17597 //
     /* 1220347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1220358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1220361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220386 */     // MIs[0] round
     /* 1220386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220396 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1220399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220421 */     // GIR_Coverage, 17597,
     /* 1220421 */     GIR_EraseRootFromParent_Done,
     /* 1220422 */   // Label 17703: @1220422
     /* 1220422 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1220502), // Rule ID 17600 //
     /* 1220427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220466 */     // MIs[0] round
     /* 1220466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220501 */     // GIR_Coverage, 17600,
     /* 1220501 */     GIR_EraseRootFromParent_Done,
     /* 1220502 */   // Label 17704: @1220502
     /* 1220502 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1220582), // Rule ID 17601 //
     /* 1220507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220546 */     // MIs[0] round
     /* 1220546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220556 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220581 */     // GIR_Coverage, 17601,
     /* 1220581 */     GIR_EraseRootFromParent_Done,
     /* 1220582 */   // Label 17705: @1220582
     /* 1220582 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1220662), // Rule ID 17604 //
     /* 1220587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220626 */     // MIs[0] round
     /* 1220626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220636 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220661 */     // GIR_Coverage, 17604,
     /* 1220661 */     GIR_EraseRootFromParent_Done,
     /* 1220662 */   // Label 17706: @1220662
     /* 1220662 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1220742), // Rule ID 17605 //
     /* 1220667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220706 */     // MIs[0] round
     /* 1220706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220741 */     // GIR_Coverage, 17605,
     /* 1220741 */     GIR_EraseRootFromParent_Done,
     /* 1220742 */   // Label 17707: @1220742
     /* 1220742 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1220822), // Rule ID 17608 //
     /* 1220747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220786 */     // MIs[0] round
     /* 1220786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220796 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220821 */     // GIR_Coverage, 17608,
     /* 1220821 */     GIR_EraseRootFromParent_Done,
     /* 1220822 */   // Label 17708: @1220822
     /* 1220822 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1220902), // Rule ID 17609 //
     /* 1220827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220866 */     // MIs[0] round
     /* 1220866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220876 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220901 */     // GIR_Coverage, 17609,
     /* 1220901 */     GIR_EraseRootFromParent_Done,
     /* 1220902 */   // Label 17709: @1220902
     /* 1220902 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1220982), // Rule ID 17612 //
     /* 1220907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220946 */     // MIs[0] round
     /* 1220946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220956 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220981 */     // GIR_Coverage, 17612,
     /* 1220981 */     GIR_EraseRootFromParent_Done,
     /* 1220982 */   // Label 17710: @1220982
     /* 1220982 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1221062), // Rule ID 17613 //
     /* 1220987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1221001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1221004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221026 */     // MIs[0] round
     /* 1221026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221036 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1221039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221061 */     // GIR_Coverage, 17613,
     /* 1221061 */     GIR_EraseRootFromParent_Done,
     /* 1221062 */   // Label 17711: @1221062
     /* 1221062 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1221142), // Rule ID 17616 //
     /* 1221067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221106 */     // MIs[0] round
     /* 1221106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1221119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221141 */     // GIR_Coverage, 17616,
     /* 1221141 */     GIR_EraseRootFromParent_Done,
     /* 1221142 */   // Label 17712: @1221142
     /* 1221142 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1221222), // Rule ID 17617 //
     /* 1221147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1221164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221186 */     // MIs[0] round
     /* 1221186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221196 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1221199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221221 */     // GIR_Coverage, 17617,
     /* 1221221 */     GIR_EraseRootFromParent_Done,
     /* 1221222 */   // Label 17713: @1221222
     /* 1221222 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1221302), // Rule ID 17620 //
     /* 1221227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221266 */     // MIs[0] round
     /* 1221266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221276 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1221279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221301 */     // GIR_Coverage, 17620,
     /* 1221301 */     GIR_EraseRootFromParent_Done,
     /* 1221302 */   // Label 17714: @1221302
     /* 1221302 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1221382), // Rule ID 17621 //
     /* 1221307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1221324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221346 */     // MIs[0] round
     /* 1221346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1221359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221381 */     // GIR_Coverage, 17621,
     /* 1221381 */     GIR_EraseRootFromParent_Done,
     /* 1221382 */   // Label 17715: @1221382
     /* 1221382 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1221462), // Rule ID 17624 //
     /* 1221387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221426 */     // MIs[0] round
     /* 1221426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221461 */     // GIR_Coverage, 17624,
     /* 1221461 */     GIR_EraseRootFromParent_Done,
     /* 1221462 */   // Label 17716: @1221462
     /* 1221462 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1221542), // Rule ID 17625 //
     /* 1221467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221506 */     // MIs[0] round
     /* 1221506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221516 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221541 */     // GIR_Coverage, 17625,
     /* 1221541 */     GIR_EraseRootFromParent_Done,
     /* 1221542 */   // Label 17717: @1221542
     /* 1221542 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1221622), // Rule ID 17628 //
     /* 1221547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221586 */     // MIs[0] round
     /* 1221586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221596 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221621 */     // GIR_Coverage, 17628,
     /* 1221621 */     GIR_EraseRootFromParent_Done,
     /* 1221622 */   // Label 17718: @1221622
     /* 1221622 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1221702), // Rule ID 17629 //
     /* 1221627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221666 */     // MIs[0] round
     /* 1221666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221701 */     // GIR_Coverage, 17629,
     /* 1221701 */     GIR_EraseRootFromParent_Done,
     /* 1221702 */   // Label 17719: @1221702
     /* 1221702 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1221782), // Rule ID 17632 //
     /* 1221707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221746 */     // MIs[0] round
     /* 1221746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221756 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221781 */     // GIR_Coverage, 17632,
     /* 1221781 */     GIR_EraseRootFromParent_Done,
     /* 1221782 */   // Label 17720: @1221782
     /* 1221782 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1221862), // Rule ID 17633 //
     /* 1221787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221826 */     // MIs[0] round
     /* 1221826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221836 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221861 */     // GIR_Coverage, 17633,
     /* 1221861 */     GIR_EraseRootFromParent_Done,
     /* 1221862 */   // Label 17721: @1221862
     /* 1221862 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1221942), // Rule ID 17636 //
     /* 1221867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221906 */     // MIs[0] round
     /* 1221906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221941 */     // GIR_Coverage, 17636,
     /* 1221941 */     GIR_EraseRootFromParent_Done,
     /* 1221942 */   // Label 17722: @1221942
     /* 1221942 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1222022), // Rule ID 17637 //
     /* 1221947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221986 */     // MIs[0] round
     /* 1221986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222021 */     // GIR_Coverage, 17637,
     /* 1222021 */     GIR_EraseRootFromParent_Done,
     /* 1222022 */   // Label 17723: @1222022
     /* 1222022 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1222102), // Rule ID 17640 //
     /* 1222027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222066 */     // MIs[0] round
     /* 1222066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1222079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222101 */     // GIR_Coverage, 17640,
     /* 1222101 */     GIR_EraseRootFromParent_Done,
     /* 1222102 */   // Label 17724: @1222102
     /* 1222102 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1222182), // Rule ID 17641 //
     /* 1222107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222146 */     // MIs[0] round
     /* 1222146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11305:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1222159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222181 */     // GIR_Coverage, 17641,
     /* 1222181 */     GIR_EraseRootFromParent_Done,
     /* 1222182 */   // Label 17725: @1222182
     /* 1222182 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1222262), // Rule ID 17644 //
     /* 1222187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222226 */     // MIs[0] round
     /* 1222226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1222239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222261 */     // GIR_Coverage, 17644,
     /* 1222261 */     GIR_EraseRootFromParent_Done,
     /* 1222262 */   // Label 17726: @1222262
     /* 1222262 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1222342), // Rule ID 17645 //
     /* 1222267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222306 */     // MIs[0] round
     /* 1222306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1222319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222341 */     // GIR_Coverage, 17645,
     /* 1222341 */     GIR_EraseRootFromParent_Done,
     /* 1222342 */   // Label 17727: @1222342
     /* 1222342 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1222422), // Rule ID 17648 //
     /* 1222347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222386 */     // MIs[0] round
     /* 1222386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222421 */     // GIR_Coverage, 17648,
     /* 1222421 */     GIR_EraseRootFromParent_Done,
     /* 1222422 */   // Label 17728: @1222422
     /* 1222422 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1222502), // Rule ID 17649 //
     /* 1222427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222466 */     // MIs[0] round
     /* 1222466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222501 */     // GIR_Coverage, 17649,
     /* 1222501 */     GIR_EraseRootFromParent_Done,
     /* 1222502 */   // Label 17729: @1222502
     /* 1222502 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1222582), // Rule ID 17652 //
     /* 1222507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222546 */     // MIs[0] round
     /* 1222546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222556 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222581 */     // GIR_Coverage, 17652,
     /* 1222581 */     GIR_EraseRootFromParent_Done,
     /* 1222582 */   // Label 17730: @1222582
     /* 1222582 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1222662), // Rule ID 17653 //
     /* 1222587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222626 */     // MIs[0] round
     /* 1222626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222636 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222661 */     // GIR_Coverage, 17653,
     /* 1222661 */     GIR_EraseRootFromParent_Done,
     /* 1222662 */   // Label 17731: @1222662
     /* 1222662 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1222742), // Rule ID 17656 //
     /* 1222667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222706 */     // MIs[0] round
     /* 1222706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222716 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222741 */     // GIR_Coverage, 17656,
     /* 1222741 */     GIR_EraseRootFromParent_Done,
     /* 1222742 */   // Label 17732: @1222742
     /* 1222742 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1222822), // Rule ID 17657 //
     /* 1222747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222786 */     // MIs[0] round
     /* 1222786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222796 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222821 */     // GIR_Coverage, 17657,
     /* 1222821 */     GIR_EraseRootFromParent_Done,
     /* 1222822 */   // Label 17733: @1222822
     /* 1222822 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1222902), // Rule ID 17660 //
     /* 1222827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222866 */     // MIs[0] round
     /* 1222866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222876 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222901 */     // GIR_Coverage, 17660,
     /* 1222901 */     GIR_EraseRootFromParent_Done,
     /* 1222902 */   // Label 17734: @1222902
     /* 1222902 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1222982), // Rule ID 17661 //
     /* 1222907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222946 */     // MIs[0] round
     /* 1222946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222956 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222981 */     // GIR_Coverage, 17661,
     /* 1222981 */     GIR_EraseRootFromParent_Done,
     /* 1222982 */   // Label 17735: @1222982
     /* 1222982 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1223062), // Rule ID 17664 //
     /* 1222987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223026 */     // MIs[0] round
     /* 1223026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1223039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223061 */     // GIR_Coverage, 17664,
     /* 1223061 */     GIR_EraseRootFromParent_Done,
     /* 1223062 */   // Label 17736: @1223062
     /* 1223062 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1223142), // Rule ID 17665 //
     /* 1223067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223106 */     // MIs[0] round
     /* 1223106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223116 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1223119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223141 */     // GIR_Coverage, 17665,
     /* 1223141 */     GIR_EraseRootFromParent_Done,
     /* 1223142 */   // Label 17737: @1223142
     /* 1223142 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1223222), // Rule ID 17668 //
     /* 1223147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223186 */     // MIs[0] round
     /* 1223186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223196 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1223199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223221 */     // GIR_Coverage, 17668,
     /* 1223221 */     GIR_EraseRootFromParent_Done,
     /* 1223222 */   // Label 17738: @1223222
     /* 1223222 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1223302), // Rule ID 17669 //
     /* 1223227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223266 */     // MIs[0] round
     /* 1223266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1223279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223301 */     // GIR_Coverage, 17669,
     /* 1223301 */     GIR_EraseRootFromParent_Done,
     /* 1223302 */   // Label 17739: @1223302
     /* 1223302 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1223382), // Rule ID 17672 //
     /* 1223307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223346 */     // MIs[0] round
     /* 1223346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223356 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1223359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223381 */     // GIR_Coverage, 17672,
     /* 1223381 */     GIR_EraseRootFromParent_Done,
     /* 1223382 */   // Label 17740: @1223382
     /* 1223382 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1223462), // Rule ID 17673 //
     /* 1223387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1223407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1223426 */     // MIs[0] round
     /* 1223426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223436 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1223439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223461 */     // GIR_Coverage, 17673,
     /* 1223461 */     GIR_EraseRootFromParent_Done,
     /* 1223462 */   // Label 17741: @1223462
     /* 1223462 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1223542), // Rule ID 17676 //
     /* 1223467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223506 */     // MIs[0] round
     /* 1223506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223541 */     // GIR_Coverage, 17676,
     /* 1223541 */     GIR_EraseRootFromParent_Done,
     /* 1223542 */   // Label 17742: @1223542
     /* 1223542 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1223622), // Rule ID 17677 //
     /* 1223547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223586 */     // MIs[0] round
     /* 1223586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223596 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223621 */     // GIR_Coverage, 17677,
     /* 1223621 */     GIR_EraseRootFromParent_Done,
     /* 1223622 */   // Label 17743: @1223622
     /* 1223622 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1223702), // Rule ID 17680 //
     /* 1223627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223666 */     // MIs[0] round
     /* 1223666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223676 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223701 */     // GIR_Coverage, 17680,
     /* 1223701 */     GIR_EraseRootFromParent_Done,
     /* 1223702 */   // Label 17744: @1223702
     /* 1223702 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1223782), // Rule ID 17681 //
     /* 1223707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223746 */     // MIs[0] round
     /* 1223746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223781 */     // GIR_Coverage, 17681,
     /* 1223781 */     GIR_EraseRootFromParent_Done,
     /* 1223782 */   // Label 17745: @1223782
     /* 1223782 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1223862), // Rule ID 17684 //
     /* 1223787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223826 */     // MIs[0] round
     /* 1223826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223836 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223861 */     // GIR_Coverage, 17684,
     /* 1223861 */     GIR_EraseRootFromParent_Done,
     /* 1223862 */   // Label 17746: @1223862
     /* 1223862 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1223942), // Rule ID 17685 //
     /* 1223867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223906 */     // MIs[0] round
     /* 1223906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223916 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223941 */     // GIR_Coverage, 17685,
     /* 1223941 */     GIR_EraseRootFromParent_Done,
     /* 1223942 */   // Label 17747: @1223942
     /* 1223942 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1224022), // Rule ID 17688 //
     /* 1223947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223986 */     // MIs[0] round
     /* 1223986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224021 */     // GIR_Coverage, 17688,
     /* 1224021 */     GIR_EraseRootFromParent_Done,
     /* 1224022 */   // Label 17748: @1224022
     /* 1224022 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1224102), // Rule ID 17689 //
     /* 1224027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1224047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224066 */     // MIs[0] round
     /* 1224066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224076 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1224079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224101 */     // GIR_Coverage, 17689,
     /* 1224101 */     GIR_EraseRootFromParent_Done,
     /* 1224102 */   // Label 17749: @1224102
     /* 1224102 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1224182), // Rule ID 17692 //
     /* 1224107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1224127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224146 */     // MIs[0] round
     /* 1224146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224156 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1224159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224181 */     // GIR_Coverage, 17692,
     /* 1224181 */     GIR_EraseRootFromParent_Done,
     /* 1224182 */   // Label 17750: @1224182
     /* 1224182 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1224262), // Rule ID 17693 //
     /* 1224187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1224207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224226 */     // MIs[0] round
     /* 1224226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1224239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224261 */     // GIR_Coverage, 17693,
     /* 1224261 */     GIR_EraseRootFromParent_Done,
     /* 1224262 */   // Label 17751: @1224262
     /* 1224262 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1224342), // Rule ID 17696 //
     /* 1224267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224306 */     // MIs[0] round
     /* 1224306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224316 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1224319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224341 */     // GIR_Coverage, 17696,
     /* 1224341 */     GIR_EraseRootFromParent_Done,
     /* 1224342 */   // Label 17752: @1224342
     /* 1224342 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1224422), // Rule ID 17697 //
     /* 1224347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224386 */     // MIs[0] round
     /* 1224386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1224399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224421 */     // GIR_Coverage, 17697,
     /* 1224421 */     GIR_EraseRootFromParent_Done,
     /* 1224422 */   // Label 17753: @1224422
     /* 1224422 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1224502), // Rule ID 17700 //
     /* 1224427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224466 */     // MIs[0] round
     /* 1224466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224501 */     // GIR_Coverage, 17700,
     /* 1224501 */     GIR_EraseRootFromParent_Done,
     /* 1224502 */   // Label 17754: @1224502
     /* 1224502 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1224582), // Rule ID 17701 //
     /* 1224507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224546 */     // MIs[0] round
     /* 1224546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224581 */     // GIR_Coverage, 17701,
     /* 1224581 */     GIR_EraseRootFromParent_Done,
     /* 1224582 */   // Label 17755: @1224582
     /* 1224582 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1224662), // Rule ID 17704 //
     /* 1224587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224626 */     // MIs[0] round
     /* 1224626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224636 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224661 */     // GIR_Coverage, 17704,
     /* 1224661 */     GIR_EraseRootFromParent_Done,
     /* 1224662 */   // Label 17756: @1224662
     /* 1224662 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1224742), // Rule ID 17705 //
     /* 1224667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224706 */     // MIs[0] round
     /* 1224706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224741 */     // GIR_Coverage, 17705,
     /* 1224741 */     GIR_EraseRootFromParent_Done,
     /* 1224742 */   // Label 17757: @1224742
     /* 1224742 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1224822), // Rule ID 17708 //
     /* 1224747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224786 */     // MIs[0] round
     /* 1224786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224821 */     // GIR_Coverage, 17708,
     /* 1224821 */     GIR_EraseRootFromParent_Done,
     /* 1224822 */   // Label 17758: @1224822
     /* 1224822 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1224902), // Rule ID 17709 //
     /* 1224827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224866 */     // MIs[0] round
     /* 1224866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224901 */     // GIR_Coverage, 17709,
     /* 1224901 */     GIR_EraseRootFromParent_Done,
     /* 1224902 */   // Label 17759: @1224902
     /* 1224902 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1224982), // Rule ID 17712 //
     /* 1224907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224946 */     // MIs[0] round
     /* 1224946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224981 */     // GIR_Coverage, 17712,
     /* 1224981 */     GIR_EraseRootFromParent_Done,
     /* 1224982 */   // Label 17760: @1224982
     /* 1224982 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1225062), // Rule ID 17713 //
     /* 1224987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225026 */     // MIs[0] round
     /* 1225026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225036 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1225039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225061 */     // GIR_Coverage, 17713,
     /* 1225061 */     GIR_EraseRootFromParent_Done,
     /* 1225062 */   // Label 17761: @1225062
     /* 1225062 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1225142), // Rule ID 17716 //
     /* 1225067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1225087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225106 */     // MIs[0] round
     /* 1225106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225116 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1225119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225141 */     // GIR_Coverage, 17716,
     /* 1225141 */     GIR_EraseRootFromParent_Done,
     /* 1225142 */   // Label 17762: @1225142
     /* 1225142 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1225222), // Rule ID 17717 //
     /* 1225147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1225167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225186 */     // MIs[0] round
     /* 1225186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225196 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1225199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225221 */     // GIR_Coverage, 17717,
     /* 1225221 */     GIR_EraseRootFromParent_Done,
     /* 1225222 */   // Label 17763: @1225222
     /* 1225222 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1225302), // Rule ID 17720 //
     /* 1225227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1225247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225266 */     // MIs[0] round
     /* 1225266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225276 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1225279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225301 */     // GIR_Coverage, 17720,
     /* 1225301 */     GIR_EraseRootFromParent_Done,
     /* 1225302 */   // Label 17764: @1225302
     /* 1225302 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1225382), // Rule ID 17721 //
     /* 1225307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1225327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225346 */     // MIs[0] round
     /* 1225346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225356 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1225359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225381 */     // GIR_Coverage, 17721,
     /* 1225381 */     GIR_EraseRootFromParent_Done,
     /* 1225382 */   // Label 17765: @1225382
     /* 1225382 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1225462), // Rule ID 17724 //
     /* 1225387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225426 */     // MIs[0] round
     /* 1225426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225436 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225461 */     // GIR_Coverage, 17724,
     /* 1225461 */     GIR_EraseRootFromParent_Done,
     /* 1225462 */   // Label 17766: @1225462
     /* 1225462 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1225542), // Rule ID 17725 //
     /* 1225467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225506 */     // MIs[0] round
     /* 1225506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225541 */     // GIR_Coverage, 17725,
     /* 1225541 */     GIR_EraseRootFromParent_Done,
     /* 1225542 */   // Label 17767: @1225542
     /* 1225542 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1225622), // Rule ID 17728 //
     /* 1225547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225586 */     // MIs[0] round
     /* 1225586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225596 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225621 */     // GIR_Coverage, 17728,
     /* 1225621 */     GIR_EraseRootFromParent_Done,
     /* 1225622 */   // Label 17768: @1225622
     /* 1225622 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1225702), // Rule ID 17729 //
     /* 1225627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225666 */     // MIs[0] round
     /* 1225666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225701 */     // GIR_Coverage, 17729,
     /* 1225701 */     GIR_EraseRootFromParent_Done,
     /* 1225702 */   // Label 17769: @1225702
     /* 1225702 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1225782), // Rule ID 17732 //
     /* 1225707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225746 */     // MIs[0] round
     /* 1225746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225756 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225781 */     // GIR_Coverage, 17732,
     /* 1225781 */     GIR_EraseRootFromParent_Done,
     /* 1225782 */   // Label 17770: @1225782
     /* 1225782 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1225862), // Rule ID 17733 //
     /* 1225787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225826 */     // MIs[0] round
     /* 1225826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225861 */     // GIR_Coverage, 17733,
     /* 1225861 */     GIR_EraseRootFromParent_Done,
     /* 1225862 */   // Label 17771: @1225862
     /* 1225862 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1225942), // Rule ID 17736 //
     /* 1225867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225906 */     // MIs[0] round
     /* 1225906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225941 */     // GIR_Coverage, 17736,
     /* 1225941 */     GIR_EraseRootFromParent_Done,
     /* 1225942 */   // Label 17772: @1225942
     /* 1225942 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1226022), // Rule ID 17737 //
     /* 1225947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225986 */     // MIs[0] round
     /* 1225986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226021 */     // GIR_Coverage, 17737,
     /* 1226021 */     GIR_EraseRootFromParent_Done,
     /* 1226022 */   // Label 17773: @1226022
     /* 1226022 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1226102), // Rule ID 17740 //
     /* 1226027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1226030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226066 */     // MIs[0] round
     /* 1226066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226076 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1226079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226101 */     // GIR_Coverage, 17740,
     /* 1226101 */     GIR_EraseRootFromParent_Done,
     /* 1226102 */   // Label 17774: @1226102
     /* 1226102 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1226182), // Rule ID 17741 //
     /* 1226107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1226110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1226118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1226121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1226124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1226127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1226146 */     // MIs[0] round
     /* 1226146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1226159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226181 */     // GIR_Coverage, 17741,
     /* 1226181 */     GIR_EraseRootFromParent_Done,
     /* 1226182 */   // Label 17775: @1226182
     /* 1226182 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1226262), // Rule ID 17744 //
     /* 1226187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226226 */     // MIs[0] round
     /* 1226226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1226239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226261 */     // GIR_Coverage, 17744,
     /* 1226261 */     GIR_EraseRootFromParent_Done,
     /* 1226262 */   // Label 17776: @1226262
     /* 1226262 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1226342), // Rule ID 17745 //
     /* 1226267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226306 */     // MIs[0] round
     /* 1226306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226316 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1226319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226341 */     // GIR_Coverage, 17745,
     /* 1226341 */     GIR_EraseRootFromParent_Done,
     /* 1226342 */   // Label 17777: @1226342
     /* 1226342 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1226422), // Rule ID 17748 //
     /* 1226347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226386 */     // MIs[0] round
     /* 1226386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226421 */     // GIR_Coverage, 17748,
     /* 1226421 */     GIR_EraseRootFromParent_Done,
     /* 1226422 */   // Label 17778: @1226422
     /* 1226422 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1226502), // Rule ID 17749 //
     /* 1226427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1226438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1226441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226466 */     // MIs[0] round
     /* 1226466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226501 */     // GIR_Coverage, 17749,
     /* 1226501 */     GIR_EraseRootFromParent_Done,
     /* 1226502 */   // Label 17779: @1226502
     /* 1226502 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1226582), // Rule ID 17752 //
     /* 1226507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226546 */     // MIs[0] round
     /* 1226546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226556 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226581 */     // GIR_Coverage, 17752,
     /* 1226581 */     GIR_EraseRootFromParent_Done,
     /* 1226582 */   // Label 17780: @1226582
     /* 1226582 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1226662), // Rule ID 17753 //
     /* 1226587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226626 */     // MIs[0] round
     /* 1226626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226636 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226661 */     // GIR_Coverage, 17753,
     /* 1226661 */     GIR_EraseRootFromParent_Done,
     /* 1226662 */   // Label 17781: @1226662
     /* 1226662 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1226742), // Rule ID 17756 //
     /* 1226667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226706 */     // MIs[0] round
     /* 1226706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226716 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226741 */     // GIR_Coverage, 17756,
     /* 1226741 */     GIR_EraseRootFromParent_Done,
     /* 1226742 */   // Label 17782: @1226742
     /* 1226742 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1226822), // Rule ID 17757 //
     /* 1226747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226786 */     // MIs[0] round
     /* 1226786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226796 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226821 */     // GIR_Coverage, 17757,
     /* 1226821 */     GIR_EraseRootFromParent_Done,
     /* 1226822 */   // Label 17783: @1226822
     /* 1226822 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1226902), // Rule ID 22834 //
     /* 1226827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226866 */     // MIs[0] round
     /* 1226866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226876 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226901 */     // GIR_Coverage, 22834,
     /* 1226901 */     GIR_EraseRootFromParent_Done,
     /* 1226902 */   // Label 17784: @1226902
     /* 1226902 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1226982), // Rule ID 22835 //
     /* 1226907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226946 */     // MIs[0] round
     /* 1226946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226956 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226981 */     // GIR_Coverage, 22835,
     /* 1226981 */     GIR_EraseRootFromParent_Done,
     /* 1226982 */   // Label 17785: @1226982
     /* 1226982 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1227062), // Rule ID 22838 //
     /* 1226987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1227004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227026 */     // MIs[0] round
     /* 1227026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1227039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227061 */     // GIR_Coverage, 22838,
     /* 1227061 */     GIR_EraseRootFromParent_Done,
     /* 1227062 */   // Label 17786: @1227062
     /* 1227062 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1227142), // Rule ID 22839 //
     /* 1227067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1227084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227106 */     // MIs[0] round
     /* 1227106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1227119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227141 */     // GIR_Coverage, 22839,
     /* 1227141 */     GIR_EraseRootFromParent_Done,
     /* 1227142 */   // Label 17787: @1227142
     /* 1227142 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1227222), // Rule ID 22842 //
     /* 1227147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227186 */     // MIs[0] round
     /* 1227186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1227199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227221 */     // GIR_Coverage, 22842,
     /* 1227221 */     GIR_EraseRootFromParent_Done,
     /* 1227222 */   // Label 17788: @1227222
     /* 1227222 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1227302), // Rule ID 22843 //
     /* 1227227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1227244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227266 */     // MIs[0] round
     /* 1227266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227276 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1227279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227301 */     // GIR_Coverage, 22843,
     /* 1227301 */     GIR_EraseRootFromParent_Done,
     /* 1227302 */   // Label 17789: @1227302
     /* 1227302 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1227382), // Rule ID 22846 //
     /* 1227307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1227324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227346 */     // MIs[0] round
     /* 1227346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227356 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1227359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227381 */     // GIR_Coverage, 22846,
     /* 1227381 */     GIR_EraseRootFromParent_Done,
     /* 1227382 */   // Label 17790: @1227382
     /* 1227382 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1227462), // Rule ID 22847 //
     /* 1227387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1227404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227426 */     // MIs[0] round
     /* 1227426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1227439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227461 */     // GIR_Coverage, 22847,
     /* 1227461 */     GIR_EraseRootFromParent_Done,
     /* 1227462 */   // Label 17791: @1227462
     /* 1227462 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1227542), // Rule ID 22850 //
     /* 1227467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227506 */     // MIs[0] round
     /* 1227506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227541 */     // GIR_Coverage, 22850,
     /* 1227541 */     GIR_EraseRootFromParent_Done,
     /* 1227542 */   // Label 17792: @1227542
     /* 1227542 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1227622), // Rule ID 22851 //
     /* 1227547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227586 */     // MIs[0] round
     /* 1227586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227621 */     // GIR_Coverage, 22851,
     /* 1227621 */     GIR_EraseRootFromParent_Done,
     /* 1227622 */   // Label 17793: @1227622
     /* 1227622 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1227702), // Rule ID 22854 //
     /* 1227627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227666 */     // MIs[0] round
     /* 1227666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227676 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227701 */     // GIR_Coverage, 22854,
     /* 1227701 */     GIR_EraseRootFromParent_Done,
     /* 1227702 */   // Label 17794: @1227702
     /* 1227702 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1227782), // Rule ID 22855 //
     /* 1227707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227746 */     // MIs[0] round
     /* 1227746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227756 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227781 */     // GIR_Coverage, 22855,
     /* 1227781 */     GIR_EraseRootFromParent_Done,
     /* 1227782 */   // Label 17795: @1227782
     /* 1227782 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1227862), // Rule ID 22858 //
     /* 1227787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227826 */     // MIs[0] round
     /* 1227826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227836 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227861 */     // GIR_Coverage, 22858,
     /* 1227861 */     GIR_EraseRootFromParent_Done,
     /* 1227862 */   // Label 17796: @1227862
     /* 1227862 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1227942), // Rule ID 22859 //
     /* 1227867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227906 */     // MIs[0] round
     /* 1227906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227941 */     // GIR_Coverage, 22859,
     /* 1227941 */     GIR_EraseRootFromParent_Done,
     /* 1227942 */   // Label 17797: @1227942
     /* 1227942 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1228022), // Rule ID 22862 //
     /* 1227947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227986 */     // MIs[0] round
     /* 1227986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228021 */     // GIR_Coverage, 22862,
     /* 1228021 */     GIR_EraseRootFromParent_Done,
     /* 1228022 */   // Label 17798: @1228022
     /* 1228022 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1228102), // Rule ID 22863 //
     /* 1228027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1228044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228066 */     // MIs[0] round
     /* 1228066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11313:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1228079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228101 */     // GIR_Coverage, 22863,
     /* 1228101 */     GIR_EraseRootFromParent_Done,
     /* 1228102 */   // Label 17799: @1228102
     /* 1228102 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1228182), // Rule ID 22866 //
     /* 1228107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228146 */     // MIs[0] round
     /* 1228146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228156 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1228159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228181 */     // GIR_Coverage, 22866,
     /* 1228181 */     GIR_EraseRootFromParent_Done,
     /* 1228182 */   // Label 17800: @1228182
     /* 1228182 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1228262), // Rule ID 22867 //
     /* 1228187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1228204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228226 */     // MIs[0] round
     /* 1228226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1228239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228261 */     // GIR_Coverage, 22867,
     /* 1228261 */     GIR_EraseRootFromParent_Done,
     /* 1228262 */   // Label 17801: @1228262
     /* 1228262 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1228342), // Rule ID 22870 //
     /* 1228267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228306 */     // MIs[0] round
     /* 1228306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1228319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228341 */     // GIR_Coverage, 22870,
     /* 1228341 */     GIR_EraseRootFromParent_Done,
     /* 1228342 */   // Label 17802: @1228342
     /* 1228342 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1228422), // Rule ID 22871 //
     /* 1228347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1228364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228386 */     // MIs[0] round
     /* 1228386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1228399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228421 */     // GIR_Coverage, 22871,
     /* 1228421 */     GIR_EraseRootFromParent_Done,
     /* 1228422 */   // Label 17803: @1228422
     /* 1228422 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1228502), // Rule ID 22874 //
     /* 1228427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228466 */     // MIs[0] round
     /* 1228466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228501 */     // GIR_Coverage, 22874,
     /* 1228501 */     GIR_EraseRootFromParent_Done,
     /* 1228502 */   // Label 17804: @1228502
     /* 1228502 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1228582), // Rule ID 22875 //
     /* 1228507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228546 */     // MIs[0] round
     /* 1228546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228581 */     // GIR_Coverage, 22875,
     /* 1228581 */     GIR_EraseRootFromParent_Done,
     /* 1228582 */   // Label 17805: @1228582
     /* 1228582 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1228662), // Rule ID 22878 //
     /* 1228587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228626 */     // MIs[0] round
     /* 1228626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228661 */     // GIR_Coverage, 22878,
     /* 1228661 */     GIR_EraseRootFromParent_Done,
     /* 1228662 */   // Label 17806: @1228662
     /* 1228662 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1228742), // Rule ID 22879 //
     /* 1228667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228706 */     // MIs[0] round
     /* 1228706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228716 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228741 */     // GIR_Coverage, 22879,
     /* 1228741 */     GIR_EraseRootFromParent_Done,
     /* 1228742 */   // Label 17807: @1228742
     /* 1228742 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1228822), // Rule ID 22882 //
     /* 1228747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228786 */     // MIs[0] round
     /* 1228786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228821 */     // GIR_Coverage, 22882,
     /* 1228821 */     GIR_EraseRootFromParent_Done,
     /* 1228822 */   // Label 17808: @1228822
     /* 1228822 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1228902), // Rule ID 22883 //
     /* 1228827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228866 */     // MIs[0] round
     /* 1228866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228901 */     // GIR_Coverage, 22883,
     /* 1228901 */     GIR_EraseRootFromParent_Done,
     /* 1228902 */   // Label 17809: @1228902
     /* 1228902 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1228982), // Rule ID 22886 //
     /* 1228907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228946 */     // MIs[0] round
     /* 1228946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228981 */     // GIR_Coverage, 22886,
     /* 1228981 */     GIR_EraseRootFromParent_Done,
     /* 1228982 */   // Label 17810: @1228982
     /* 1228982 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1229062), // Rule ID 22887 //
     /* 1228987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1229004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229026 */     // MIs[0] round
     /* 1229026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1229039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229061 */     // GIR_Coverage, 22887,
     /* 1229061 */     GIR_EraseRootFromParent_Done,
     /* 1229062 */   // Label 17811: @1229062
     /* 1229062 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1229142), // Rule ID 22890 //
     /* 1229067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1229084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229106 */     // MIs[0] round
     /* 1229106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229116 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1229119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229141 */     // GIR_Coverage, 22890,
     /* 1229141 */     GIR_EraseRootFromParent_Done,
     /* 1229142 */   // Label 17812: @1229142
     /* 1229142 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1229222), // Rule ID 22891 //
     /* 1229147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1229164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229186 */     // MIs[0] round
     /* 1229186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1229199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229221 */     // GIR_Coverage, 22891,
     /* 1229221 */     GIR_EraseRootFromParent_Done,
     /* 1229222 */   // Label 17813: @1229222
     /* 1229222 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1229302), // Rule ID 22894 //
     /* 1229227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1229244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229266 */     // MIs[0] round
     /* 1229266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229276 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1229279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229301 */     // GIR_Coverage, 22894,
     /* 1229301 */     GIR_EraseRootFromParent_Done,
     /* 1229302 */   // Label 17814: @1229302
     /* 1229302 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1229382), // Rule ID 22895 //
     /* 1229307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1229324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229346 */     // MIs[0] round
     /* 1229346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1229359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229381 */     // GIR_Coverage, 22895,
     /* 1229381 */     GIR_EraseRootFromParent_Done,
     /* 1229382 */   // Label 17815: @1229382
     /* 1229382 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1229462), // Rule ID 22898 //
     /* 1229387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229426 */     // MIs[0] round
     /* 1229426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229461 */     // GIR_Coverage, 22898,
     /* 1229461 */     GIR_EraseRootFromParent_Done,
     /* 1229462 */   // Label 17816: @1229462
     /* 1229462 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1229542), // Rule ID 22899 //
     /* 1229467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229506 */     // MIs[0] round
     /* 1229506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229541 */     // GIR_Coverage, 22899,
     /* 1229541 */     GIR_EraseRootFromParent_Done,
     /* 1229542 */   // Label 17817: @1229542
     /* 1229542 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1229622), // Rule ID 22902 //
     /* 1229547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229586 */     // MIs[0] round
     /* 1229586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229621 */     // GIR_Coverage, 22902,
     /* 1229621 */     GIR_EraseRootFromParent_Done,
     /* 1229622 */   // Label 17818: @1229622
     /* 1229622 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1229702), // Rule ID 22903 //
     /* 1229627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229666 */     // MIs[0] round
     /* 1229666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229676 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229701 */     // GIR_Coverage, 22903,
     /* 1229701 */     GIR_EraseRootFromParent_Done,
     /* 1229702 */   // Label 17819: @1229702
     /* 1229702 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1229782), // Rule ID 22906 //
     /* 1229707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229746 */     // MIs[0] round
     /* 1229746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229781 */     // GIR_Coverage, 22906,
     /* 1229781 */     GIR_EraseRootFromParent_Done,
     /* 1229782 */   // Label 17820: @1229782
     /* 1229782 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1229862), // Rule ID 22907 //
     /* 1229787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229826 */     // MIs[0] round
     /* 1229826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229861 */     // GIR_Coverage, 22907,
     /* 1229861 */     GIR_EraseRootFromParent_Done,
     /* 1229862 */   // Label 17821: @1229862
     /* 1229862 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1229942), // Rule ID 22910 //
     /* 1229867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229906 */     // MIs[0] round
     /* 1229906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229941 */     // GIR_Coverage, 22910,
     /* 1229941 */     GIR_EraseRootFromParent_Done,
     /* 1229942 */   // Label 17822: @1229942
     /* 1229942 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1230022), // Rule ID 22911 //
     /* 1229947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229986 */     // MIs[0] round
     /* 1229986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229996 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230021 */     // GIR_Coverage, 22911,
     /* 1230021 */     GIR_EraseRootFromParent_Done,
     /* 1230022 */   // Label 17823: @1230022
     /* 1230022 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1230102), // Rule ID 22914 //
     /* 1230027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1230044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230066 */     // MIs[0] round
     /* 1230066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1230079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230101 */     // GIR_Coverage, 22914,
     /* 1230101 */     GIR_EraseRootFromParent_Done,
     /* 1230102 */   // Label 17824: @1230102
     /* 1230102 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1230182), // Rule ID 22915 //
     /* 1230107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1230124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230146 */     // MIs[0] round
     /* 1230146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1230159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230181 */     // GIR_Coverage, 22915,
     /* 1230181 */     GIR_EraseRootFromParent_Done,
     /* 1230182 */   // Label 17825: @1230182
     /* 1230182 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1230262), // Rule ID 22918 //
     /* 1230187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1230204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230226 */     // MIs[0] round
     /* 1230226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1230239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230261 */     // GIR_Coverage, 22918,
     /* 1230261 */     GIR_EraseRootFromParent_Done,
     /* 1230262 */   // Label 17826: @1230262
     /* 1230262 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1230342), // Rule ID 22919 //
     /* 1230267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1230284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230306 */     // MIs[0] round
     /* 1230306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230316 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1230319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230341 */     // GIR_Coverage, 22919,
     /* 1230341 */     GIR_EraseRootFromParent_Done,
     /* 1230342 */   // Label 17827: @1230342
     /* 1230342 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1230422), // Rule ID 22922 //
     /* 1230347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1230364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230386 */     // MIs[0] round
     /* 1230386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230421 */     // GIR_Coverage, 22922,
     /* 1230421 */     GIR_EraseRootFromParent_Done,
     /* 1230422 */   // Label 17828: @1230422
     /* 1230422 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1230502), // Rule ID 22923 //
     /* 1230427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1230438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1230441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1230444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1230447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230466 */     // MIs[0] round
     /* 1230466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230476 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11315:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230501 */     // GIR_Coverage, 22923,
     /* 1230501 */     GIR_EraseRootFromParent_Done,
     /* 1230502 */   // Label 17829: @1230502
     /* 1230502 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1230582), // Rule ID 22926 //
     /* 1230507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230546 */     // MIs[0] round
     /* 1230546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230581 */     // GIR_Coverage, 22926,
     /* 1230581 */     GIR_EraseRootFromParent_Done,
     /* 1230582 */   // Label 17830: @1230582
     /* 1230582 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1230662), // Rule ID 22927 //
     /* 1230587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230626 */     // MIs[0] round
     /* 1230626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230636 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230661 */     // GIR_Coverage, 22927,
     /* 1230661 */     GIR_EraseRootFromParent_Done,
     /* 1230662 */   // Label 17831: @1230662
     /* 1230662 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1230742), // Rule ID 22930 //
     /* 1230667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230706 */     // MIs[0] round
     /* 1230706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230741 */     // GIR_Coverage, 22930,
     /* 1230741 */     GIR_EraseRootFromParent_Done,
     /* 1230742 */   // Label 17832: @1230742
     /* 1230742 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1230822), // Rule ID 22931 //
     /* 1230747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230786 */     // MIs[0] round
     /* 1230786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230821 */     // GIR_Coverage, 22931,
     /* 1230821 */     GIR_EraseRootFromParent_Done,
     /* 1230822 */   // Label 17833: @1230822
     /* 1230822 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1230902), // Rule ID 22934 //
     /* 1230827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230866 */     // MIs[0] round
     /* 1230866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230901 */     // GIR_Coverage, 22934,
     /* 1230901 */     GIR_EraseRootFromParent_Done,
     /* 1230902 */   // Label 17834: @1230902
     /* 1230902 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1230982), // Rule ID 22935 //
     /* 1230907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230946 */     // MIs[0] round
     /* 1230946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230981 */     // GIR_Coverage, 22935,
     /* 1230981 */     GIR_EraseRootFromParent_Done,
     /* 1230982 */   // Label 17835: @1230982
     /* 1230982 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1231062), // Rule ID 22938 //
     /* 1230987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1231004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231026 */     // MIs[0] round
     /* 1231026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1231039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231061 */     // GIR_Coverage, 22938,
     /* 1231061 */     GIR_EraseRootFromParent_Done,
     /* 1231062 */   // Label 17836: @1231062
     /* 1231062 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1231142), // Rule ID 22939 //
     /* 1231067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1231084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231106 */     // MIs[0] round
     /* 1231106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1231119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231141 */     // GIR_Coverage, 22939,
     /* 1231141 */     GIR_EraseRootFromParent_Done,
     /* 1231142 */   // Label 17837: @1231142
     /* 1231142 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1231222), // Rule ID 22942 //
     /* 1231147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1231164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231186 */     // MIs[0] round
     /* 1231186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1231199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231221 */     // GIR_Coverage, 22942,
     /* 1231221 */     GIR_EraseRootFromParent_Done,
     /* 1231222 */   // Label 17838: @1231222
     /* 1231222 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1231302), // Rule ID 22943 //
     /* 1231227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1231244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231266 */     // MIs[0] round
     /* 1231266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1231279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231301 */     // GIR_Coverage, 22943,
     /* 1231301 */     GIR_EraseRootFromParent_Done,
     /* 1231302 */   // Label 17839: @1231302
     /* 1231302 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1231382), // Rule ID 22946 //
     /* 1231307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1231310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1231324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231346 */     // MIs[0] round
     /* 1231346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1231359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231381 */     // GIR_Coverage, 22946,
     /* 1231381 */     GIR_EraseRootFromParent_Done,
     /* 1231382 */   // Label 17840: @1231382
     /* 1231382 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1231462), // Rule ID 22947 //
     /* 1231387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1231390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1231395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1231404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231426 */     // MIs[0] round
     /* 1231426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1231439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1231457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231461 */     // GIR_Coverage, 22947,
     /* 1231461 */     GIR_EraseRootFromParent_Done,
     /* 1231462 */   // Label 17841: @1231462
     /* 1231462 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1231542), // Rule ID 23070 //
     /* 1231467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231506 */     // MIs[0] round
     /* 1231506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231541 */     // GIR_Coverage, 23070,
     /* 1231541 */     GIR_EraseRootFromParent_Done,
     /* 1231542 */   // Label 17842: @1231542
     /* 1231542 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1231622), // Rule ID 23071 //
     /* 1231547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231586 */     // MIs[0] round
     /* 1231586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231596 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231621 */     // GIR_Coverage, 23071,
     /* 1231621 */     GIR_EraseRootFromParent_Done,
     /* 1231622 */   // Label 17843: @1231622
     /* 1231622 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1231702), // Rule ID 23074 //
     /* 1231627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231666 */     // MIs[0] round
     /* 1231666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231701 */     // GIR_Coverage, 23074,
     /* 1231701 */     GIR_EraseRootFromParent_Done,
     /* 1231702 */   // Label 17844: @1231702
     /* 1231702 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1231782), // Rule ID 23075 //
     /* 1231707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231746 */     // MIs[0] round
     /* 1231746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231781 */     // GIR_Coverage, 23075,
     /* 1231781 */     GIR_EraseRootFromParent_Done,
     /* 1231782 */   // Label 17845: @1231782
     /* 1231782 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1231862), // Rule ID 23078 //
     /* 1231787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231826 */     // MIs[0] round
     /* 1231826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231836 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231861 */     // GIR_Coverage, 23078,
     /* 1231861 */     GIR_EraseRootFromParent_Done,
     /* 1231862 */   // Label 17846: @1231862
     /* 1231862 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1231942), // Rule ID 23079 //
     /* 1231867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231906 */     // MIs[0] round
     /* 1231906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231941 */     // GIR_Coverage, 23079,
     /* 1231941 */     GIR_EraseRootFromParent_Done,
     /* 1231942 */   // Label 17847: @1231942
     /* 1231942 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1232022), // Rule ID 23082 //
     /* 1231947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231986 */     // MIs[0] round
     /* 1231986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231996 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232021 */     // GIR_Coverage, 23082,
     /* 1232021 */     GIR_EraseRootFromParent_Done,
     /* 1232022 */   // Label 17848: @1232022
     /* 1232022 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1232102), // Rule ID 23083 //
     /* 1232027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1232044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232066 */     // MIs[0] round
     /* 1232066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1232079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232101 */     // GIR_Coverage, 23083,
     /* 1232101 */     GIR_EraseRootFromParent_Done,
     /* 1232102 */   // Label 17849: @1232102
     /* 1232102 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1232182), // Rule ID 23086 //
     /* 1232107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1232124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232146 */     // MIs[0] round
     /* 1232146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232156 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1232159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232181 */     // GIR_Coverage, 23086,
     /* 1232181 */     GIR_EraseRootFromParent_Done,
     /* 1232182 */   // Label 17850: @1232182
     /* 1232182 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1232262), // Rule ID 23087 //
     /* 1232187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1232204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232226 */     // MIs[0] round
     /* 1232226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1232239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232261 */     // GIR_Coverage, 23087,
     /* 1232261 */     GIR_EraseRootFromParent_Done,
     /* 1232262 */   // Label 17851: @1232262
     /* 1232262 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1232342), // Rule ID 23090 //
     /* 1232267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1232284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232306 */     // MIs[0] round
     /* 1232306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1232319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232341 */     // GIR_Coverage, 23090,
     /* 1232341 */     GIR_EraseRootFromParent_Done,
     /* 1232342 */   // Label 17852: @1232342
     /* 1232342 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1232422), // Rule ID 23091 //
     /* 1232347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1232364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232386 */     // MIs[0] round
     /* 1232386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1232399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232421 */     // GIR_Coverage, 23091,
     /* 1232421 */     GIR_EraseRootFromParent_Done,
     /* 1232422 */   // Label 17853: @1232422
     /* 1232422 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1232502), // Rule ID 23094 //
     /* 1232427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232466 */     // MIs[0] round
     /* 1232466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232501 */     // GIR_Coverage, 23094,
     /* 1232501 */     GIR_EraseRootFromParent_Done,
     /* 1232502 */   // Label 17854: @1232502
     /* 1232502 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1232582), // Rule ID 23095 //
     /* 1232507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232546 */     // MIs[0] round
     /* 1232546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232581 */     // GIR_Coverage, 23095,
     /* 1232581 */     GIR_EraseRootFromParent_Done,
     /* 1232582 */   // Label 17855: @1232582
     /* 1232582 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1232662), // Rule ID 23098 //
     /* 1232587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232626 */     // MIs[0] round
     /* 1232626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232636 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232661 */     // GIR_Coverage, 23098,
     /* 1232661 */     GIR_EraseRootFromParent_Done,
     /* 1232662 */   // Label 17856: @1232662
     /* 1232662 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1232742), // Rule ID 23099 //
     /* 1232667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232706 */     // MIs[0] round
     /* 1232706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232741 */     // GIR_Coverage, 23099,
     /* 1232741 */     GIR_EraseRootFromParent_Done,
     /* 1232742 */   // Label 17857: @1232742
     /* 1232742 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1232822), // Rule ID 23102 //
     /* 1232747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232786 */     // MIs[0] round
     /* 1232786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232821 */     // GIR_Coverage, 23102,
     /* 1232821 */     GIR_EraseRootFromParent_Done,
     /* 1232822 */   // Label 17858: @1232822
     /* 1232822 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1232902), // Rule ID 23103 //
     /* 1232827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232866 */     // MIs[0] round
     /* 1232866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232901 */     // GIR_Coverage, 23103,
     /* 1232901 */     GIR_EraseRootFromParent_Done,
     /* 1232902 */   // Label 17859: @1232902
     /* 1232902 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1232982), // Rule ID 23106 //
     /* 1232907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232946 */     // MIs[0] round
     /* 1232946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232981 */     // GIR_Coverage, 23106,
     /* 1232981 */     GIR_EraseRootFromParent_Done,
     /* 1232982 */   // Label 17860: @1232982
     /* 1232982 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1233062), // Rule ID 23107 //
     /* 1232987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1233004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233026 */     // MIs[0] round
     /* 1233026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1233039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233061 */     // GIR_Coverage, 23107,
     /* 1233061 */     GIR_EraseRootFromParent_Done,
     /* 1233062 */   // Label 17861: @1233062
     /* 1233062 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1233142), // Rule ID 23110 //
     /* 1233067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1233075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1233084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233106 */     // MIs[0] round
     /* 1233106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1233119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233141 */     // GIR_Coverage, 23110,
     /* 1233141 */     GIR_EraseRootFromParent_Done,
     /* 1233142 */   // Label 17862: @1233142
     /* 1233142 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1233222), // Rule ID 23111 //
     /* 1233147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1233155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1233164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233186 */     // MIs[0] round
     /* 1233186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1233199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233221 */     // GIR_Coverage, 23111,
     /* 1233221 */     GIR_EraseRootFromParent_Done,
     /* 1233222 */   // Label 17863: @1233222
     /* 1233222 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1233302), // Rule ID 23114 //
     /* 1233227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233266 */     // MIs[0] round
     /* 1233266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233276 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1233279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233301 */     // GIR_Coverage, 23114,
     /* 1233301 */     GIR_EraseRootFromParent_Done,
     /* 1233302 */   // Label 17864: @1233302
     /* 1233302 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1233382), // Rule ID 23115 //
     /* 1233307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1233324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233346 */     // MIs[0] round
     /* 1233346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233356 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1233359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233381 */     // GIR_Coverage, 23115,
     /* 1233381 */     GIR_EraseRootFromParent_Done,
     /* 1233382 */   // Label 17865: @1233382
     /* 1233382 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1233462), // Rule ID 23118 //
     /* 1233387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233426 */     // MIs[0] round
     /* 1233426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233461 */     // GIR_Coverage, 23118,
     /* 1233461 */     GIR_EraseRootFromParent_Done,
     /* 1233462 */   // Label 17866: @1233462
     /* 1233462 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1233542), // Rule ID 23119 //
     /* 1233467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233506 */     // MIs[0] round
     /* 1233506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233541 */     // GIR_Coverage, 23119,
     /* 1233541 */     GIR_EraseRootFromParent_Done,
     /* 1233542 */   // Label 17867: @1233542
     /* 1233542 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1233622), // Rule ID 23122 //
     /* 1233547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233586 */     // MIs[0] round
     /* 1233586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233621 */     // GIR_Coverage, 23122,
     /* 1233621 */     GIR_EraseRootFromParent_Done,
     /* 1233622 */   // Label 17868: @1233622
     /* 1233622 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1233702), // Rule ID 23123 //
     /* 1233627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233666 */     // MIs[0] round
     /* 1233666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233701 */     // GIR_Coverage, 23123,
     /* 1233701 */     GIR_EraseRootFromParent_Done,
     /* 1233702 */   // Label 17869: @1233702
     /* 1233702 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1233782), // Rule ID 23126 //
     /* 1233707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233746 */     // MIs[0] round
     /* 1233746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233756 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233781 */     // GIR_Coverage, 23126,
     /* 1233781 */     GIR_EraseRootFromParent_Done,
     /* 1233782 */   // Label 17870: @1233782
     /* 1233782 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1233862), // Rule ID 23127 //
     /* 1233787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233826 */     // MIs[0] round
     /* 1233826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233861 */     // GIR_Coverage, 23127,
     /* 1233861 */     GIR_EraseRootFromParent_Done,
     /* 1233862 */   // Label 17871: @1233862
     /* 1233862 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1233942), // Rule ID 23130 //
     /* 1233867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233906 */     // MIs[0] round
     /* 1233906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233941 */     // GIR_Coverage, 23130,
     /* 1233941 */     GIR_EraseRootFromParent_Done,
     /* 1233942 */   // Label 17872: @1233942
     /* 1233942 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1234022), // Rule ID 23131 //
     /* 1233947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233986 */     // MIs[0] round
     /* 1233986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233996 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234021 */     // GIR_Coverage, 23131,
     /* 1234021 */     GIR_EraseRootFromParent_Done,
     /* 1234022 */   // Label 17873: @1234022
     /* 1234022 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1234102), // Rule ID 23134 //
     /* 1234027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234066 */     // MIs[0] round
     /* 1234066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1234079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234101 */     // GIR_Coverage, 23134,
     /* 1234101 */     GIR_EraseRootFromParent_Done,
     /* 1234102 */   // Label 17874: @1234102
     /* 1234102 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1234182), // Rule ID 23135 //
     /* 1234107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234146 */     // MIs[0] round
     /* 1234146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234156 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1234159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234181 */     // GIR_Coverage, 23135,
     /* 1234181 */     GIR_EraseRootFromParent_Done,
     /* 1234182 */   // Label 17875: @1234182
     /* 1234182 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1234262), // Rule ID 23138 //
     /* 1234187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234226 */     // MIs[0] round
     /* 1234226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1234239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234261 */     // GIR_Coverage, 23138,
     /* 1234261 */     GIR_EraseRootFromParent_Done,
     /* 1234262 */   // Label 17876: @1234262
     /* 1234262 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1234342), // Rule ID 23139 //
     /* 1234267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234306 */     // MIs[0] round
     /* 1234306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1234319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234341 */     // GIR_Coverage, 23139,
     /* 1234341 */     GIR_EraseRootFromParent_Done,
     /* 1234342 */   // Label 17877: @1234342
     /* 1234342 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1234422), // Rule ID 23142 //
     /* 1234347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1234350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234386 */     // MIs[0] round
     /* 1234386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234396 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234421 */     // GIR_Coverage, 23142,
     /* 1234421 */     GIR_EraseRootFromParent_Done,
     /* 1234422 */   // Label 17878: @1234422
     /* 1234422 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1234502), // Rule ID 23143 //
     /* 1234427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1234430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1234438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1234441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1234447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234466 */     // MIs[0] round
     /* 1234466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234501 */     // GIR_Coverage, 23143,
     /* 1234501 */     GIR_EraseRootFromParent_Done,
     /* 1234502 */   // Label 17879: @1234502
     /* 1234502 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1234582), // Rule ID 23146 //
     /* 1234507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234546 */     // MIs[0] round
     /* 1234546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234581 */     // GIR_Coverage, 23146,
     /* 1234581 */     GIR_EraseRootFromParent_Done,
     /* 1234582 */   // Label 17880: @1234582
     /* 1234582 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1234662), // Rule ID 23147 //
     /* 1234587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234626 */     // MIs[0] round
     /* 1234626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234661 */     // GIR_Coverage, 23147,
     /* 1234661 */     GIR_EraseRootFromParent_Done,
     /* 1234662 */   // Label 17881: @1234662
     /* 1234662 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1234742), // Rule ID 23150 //
     /* 1234667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234706 */     // MIs[0] round
     /* 1234706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234716 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234741 */     // GIR_Coverage, 23150,
     /* 1234741 */     GIR_EraseRootFromParent_Done,
     /* 1234742 */   // Label 17882: @1234742
     /* 1234742 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1234822), // Rule ID 23151 //
     /* 1234747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234786 */     // MIs[0] round
     /* 1234786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234796 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234821 */     // GIR_Coverage, 23151,
     /* 1234821 */     GIR_EraseRootFromParent_Done,
     /* 1234822 */   // Label 17883: @1234822
     /* 1234822 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1234902), // Rule ID 23154 //
     /* 1234827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234866 */     // MIs[0] round
     /* 1234866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234901 */     // GIR_Coverage, 23154,
     /* 1234901 */     GIR_EraseRootFromParent_Done,
     /* 1234902 */   // Label 17884: @1234902
     /* 1234902 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1234982), // Rule ID 23155 //
     /* 1234907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234946 */     // MIs[0] round
     /* 1234946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234956 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234981 */     // GIR_Coverage, 23155,
     /* 1234981 */     GIR_EraseRootFromParent_Done,
     /* 1234982 */   // Label 17885: @1234982
     /* 1234982 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1235062), // Rule ID 64359 //
     /* 1234987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235026 */     // MIs[0] round
     /* 1235026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235036 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1235039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235061 */     // GIR_Coverage, 64359,
     /* 1235061 */     GIR_EraseRootFromParent_Done,
     /* 1235062 */   // Label 17886: @1235062
     /* 1235062 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1235142), // Rule ID 64360 //
     /* 1235067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235106 */     // MIs[0] round
     /* 1235106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8),
     /* 1235119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235141 */     // GIR_Coverage, 64360,
     /* 1235141 */     GIR_EraseRootFromParent_Done,
     /* 1235142 */   // Label 17887: @1235142
     /* 1235142 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1235222), // Rule ID 64363 //
     /* 1235147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235186 */     // MIs[0] round
     /* 1235186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1235199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235221 */     // GIR_Coverage, 64363,
     /* 1235221 */     GIR_EraseRootFromParent_Done,
     /* 1235222 */   // Label 17888: @1235222
     /* 1235222 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1235302), // Rule ID 64364 //
     /* 1235227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235266 */     // MIs[0] round
     /* 1235266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4),
     /* 1235279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235301 */     // GIR_Coverage, 64364,
     /* 1235301 */     GIR_EraseRootFromParent_Done,
     /* 1235302 */   // Label 17889: @1235302
     /* 1235302 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1235382), // Rule ID 64367 //
     /* 1235307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235346 */     // MIs[0] round
     /* 1235346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1235359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235381 */     // GIR_Coverage, 64367,
     /* 1235381 */     GIR_EraseRootFromParent_Done,
     /* 1235382 */   // Label 17890: @1235382
     /* 1235382 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1235462), // Rule ID 64368 //
     /* 1235387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235426 */     // MIs[0] round
     /* 1235426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2),
     /* 1235439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235461 */     // GIR_Coverage, 64368,
     /* 1235461 */     GIR_EraseRootFromParent_Done,
     /* 1235462 */   // Label 17891: @1235462
     /* 1235462 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1235542), // Rule ID 64371 //
     /* 1235467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235506 */     // MIs[0] round
     /* 1235506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235541 */     // GIR_Coverage, 64371,
     /* 1235541 */     GIR_EraseRootFromParent_Done,
     /* 1235542 */   // Label 17892: @1235542
     /* 1235542 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1235622), // Rule ID 64372 //
     /* 1235547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235586 */     // MIs[0] round
     /* 1235586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11154:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1),
     /* 1235599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235621 */     // GIR_Coverage, 64372,
     /* 1235621 */     GIR_EraseRootFromParent_Done,
     /* 1235622 */   // Label 17893: @1235622
     /* 1235622 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1235702), // Rule ID 64375 //
     /* 1235627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235666 */     // MIs[0] round
     /* 1235666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235701 */     // GIR_Coverage, 64375,
     /* 1235701 */     GIR_EraseRootFromParent_Done,
     /* 1235702 */   // Label 17894: @1235702
     /* 1235702 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1235782), // Rule ID 64376 //
     /* 1235707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235746 */     // MIs[0] round
     /* 1235746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2),
     /* 1235759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235781 */     // GIR_Coverage, 64376,
     /* 1235781 */     GIR_EraseRootFromParent_Done,
     /* 1235782 */   // Label 17895: @1235782
     /* 1235782 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1235862), // Rule ID 64379 //
     /* 1235787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235826 */     // MIs[0] round
     /* 1235826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235861 */     // GIR_Coverage, 64379,
     /* 1235861 */     GIR_EraseRootFromParent_Done,
     /* 1235862 */   // Label 17896: @1235862
     /* 1235862 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1235942), // Rule ID 64380 //
     /* 1235867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235906 */     // MIs[0] round
     /* 1235906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8),
     /* 1235919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235941 */     // GIR_Coverage, 64380,
     /* 1235941 */     GIR_EraseRootFromParent_Done,
     /* 1235942 */   // Label 17897: @1235942
     /* 1235942 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1236022), // Rule ID 64383 //
     /* 1235947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235986 */     // MIs[0] round
     /* 1235986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235996 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1235999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236021 */     // GIR_Coverage, 64383,
     /* 1236021 */     GIR_EraseRootFromParent_Done,
     /* 1236022 */   // Label 17898: @1236022
     /* 1236022 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1236102), // Rule ID 64384 //
     /* 1236027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1236038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1236041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236066 */     // MIs[0] round
     /* 1236066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4),
     /* 1236079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236101 */     // GIR_Coverage, 64384,
     /* 1236101 */     GIR_EraseRootFromParent_Done,
     /* 1236102 */   // Label 17899: @1236102
     /* 1236102 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1236182), // Rule ID 64387 //
     /* 1236107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236146 */     // MIs[0] round
     /* 1236146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1236159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236181 */     // GIR_Coverage, 64387,
     /* 1236181 */     GIR_EraseRootFromParent_Done,
     /* 1236182 */   // Label 17900: @1236182
     /* 1236182 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1236262), // Rule ID 64388 //
     /* 1236187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1236204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236226 */     // MIs[0] round
     /* 1236226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2),
     /* 1236239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236261 */     // GIR_Coverage, 64388,
     /* 1236261 */     GIR_EraseRootFromParent_Done,
     /* 1236262 */   // Label 17901: @1236262
     /* 1236262 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1236342), // Rule ID 64391 //
     /* 1236267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236306 */     // MIs[0] round
     /* 1236306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1236319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236341 */     // GIR_Coverage, 64391,
     /* 1236341 */     GIR_EraseRootFromParent_Done,
     /* 1236342 */   // Label 17902: @1236342
     /* 1236342 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1236422), // Rule ID 64392 //
     /* 1236347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1236364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236386 */     // MIs[0] round
     /* 1236386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11152:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1),
     /* 1236399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236421 */     // GIR_Coverage, 64392,
     /* 1236421 */     GIR_EraseRootFromParent_Done,
     /* 1236422 */   // Label 17903: @1236422
     /* 1236422 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1236502), // Rule ID 64395 //
     /* 1236427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1236430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236466 */     // MIs[0] round
     /* 1236466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236501 */     // GIR_Coverage, 64395,
     /* 1236501 */     GIR_EraseRootFromParent_Done,
     /* 1236502 */   // Label 17904: @1236502
     /* 1236502 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1236582), // Rule ID 64396 //
     /* 1236507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236546 */     // MIs[0] round
     /* 1236546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2),
     /* 1236559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236581 */     // GIR_Coverage, 64396,
     /* 1236581 */     GIR_EraseRootFromParent_Done,
     /* 1236582 */   // Label 17905: @1236582
     /* 1236582 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1236662), // Rule ID 65184 //
     /* 1236587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236626 */     // MIs[0] round
     /* 1236626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236636 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236661 */     // GIR_Coverage, 65184,
     /* 1236661 */     GIR_EraseRootFromParent_Done,
     /* 1236662 */   // Label 17906: @1236662
     /* 1236662 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1236742), // Rule ID 65185 //
     /* 1236667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236706 */     // MIs[0] round
     /* 1236706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236716 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236741 */     // GIR_Coverage, 65185,
     /* 1236741 */     GIR_EraseRootFromParent_Done,
     /* 1236742 */   // Label 17907: @1236742
     /* 1236742 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1236822), // Rule ID 65188 //
     /* 1236747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236786 */     // MIs[0] round
     /* 1236786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236796 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236821 */     // GIR_Coverage, 65188,
     /* 1236821 */     GIR_EraseRootFromParent_Done,
     /* 1236822 */   // Label 17908: @1236822
     /* 1236822 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1236902), // Rule ID 65189 //
     /* 1236827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236866 */     // MIs[0] round
     /* 1236866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236876 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236901 */     // GIR_Coverage, 65189,
     /* 1236901 */     GIR_EraseRootFromParent_Done,
     /* 1236902 */   // Label 17909: @1236902
     /* 1236902 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1236982), // Rule ID 65192 //
     /* 1236907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236946 */     // MIs[0] round
     /* 1236946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236956 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236981 */     // GIR_Coverage, 65192,
     /* 1236981 */     GIR_EraseRootFromParent_Done,
     /* 1236982 */   // Label 17910: @1236982
     /* 1236982 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1237062), // Rule ID 65193 //
     /* 1236987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237026 */     // MIs[0] round
     /* 1237026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237036 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1237039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237061 */     // GIR_Coverage, 65193,
     /* 1237061 */     GIR_EraseRootFromParent_Done,
     /* 1237062 */   // Label 17911: @1237062
     /* 1237062 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1237142), // Rule ID 65196 //
     /* 1237067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237106 */     // MIs[0] round
     /* 1237106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237116 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1237119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237141 */     // GIR_Coverage, 65196,
     /* 1237141 */     GIR_EraseRootFromParent_Done,
     /* 1237142 */   // Label 17912: @1237142
     /* 1237142 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1237222), // Rule ID 65197 //
     /* 1237147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237186 */     // MIs[0] round
     /* 1237186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1237199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237221 */     // GIR_Coverage, 65197,
     /* 1237221 */     GIR_EraseRootFromParent_Done,
     /* 1237222 */   // Label 17913: @1237222
     /* 1237222 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1237302), // Rule ID 65200 //
     /* 1237227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237266 */     // MIs[0] round
     /* 1237266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237276 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1237279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237301 */     // GIR_Coverage, 65200,
     /* 1237301 */     GIR_EraseRootFromParent_Done,
     /* 1237302 */   // Label 17914: @1237302
     /* 1237302 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1237382), // Rule ID 65201 //
     /* 1237307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237346 */     // MIs[0] round
     /* 1237346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1237359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237381 */     // GIR_Coverage, 65201,
     /* 1237381 */     GIR_EraseRootFromParent_Done,
     /* 1237382 */   // Label 17915: @1237382
     /* 1237382 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1237462), // Rule ID 65204 //
     /* 1237387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237426 */     // MIs[0] round
     /* 1237426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237436 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237461 */     // GIR_Coverage, 65204,
     /* 1237461 */     GIR_EraseRootFromParent_Done,
     /* 1237462 */   // Label 17916: @1237462
     /* 1237462 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1237542), // Rule ID 65205 //
     /* 1237467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237506 */     // MIs[0] round
     /* 1237506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237541 */     // GIR_Coverage, 65205,
     /* 1237541 */     GIR_EraseRootFromParent_Done,
     /* 1237542 */   // Label 17917: @1237542
     /* 1237542 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1237622), // Rule ID 65208 //
     /* 1237547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237586 */     // MIs[0] round
     /* 1237586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237596 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237621 */     // GIR_Coverage, 65208,
     /* 1237621 */     GIR_EraseRootFromParent_Done,
     /* 1237622 */   // Label 17918: @1237622
     /* 1237622 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1237702), // Rule ID 65209 //
     /* 1237627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237666 */     // MIs[0] round
     /* 1237666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237701 */     // GIR_Coverage, 65209,
     /* 1237701 */     GIR_EraseRootFromParent_Done,
     /* 1237702 */   // Label 17919: @1237702
     /* 1237702 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1237782), // Rule ID 65212 //
     /* 1237707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237746 */     // MIs[0] round
     /* 1237746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237756 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237781 */     // GIR_Coverage, 65212,
     /* 1237781 */     GIR_EraseRootFromParent_Done,
     /* 1237782 */   // Label 17920: @1237782
     /* 1237782 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1237862), // Rule ID 65213 //
     /* 1237787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237826 */     // MIs[0] round
     /* 1237826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237836 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237861 */     // GIR_Coverage, 65213,
     /* 1237861 */     GIR_EraseRootFromParent_Done,
     /* 1237862 */   // Label 17921: @1237862
     /* 1237862 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1237942), // Rule ID 65216 //
     /* 1237867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237906 */     // MIs[0] round
     /* 1237906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237941 */     // GIR_Coverage, 65216,
     /* 1237941 */     GIR_EraseRootFromParent_Done,
     /* 1237942 */   // Label 17922: @1237942
     /* 1237942 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1238022), // Rule ID 65217 //
     /* 1237947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237986 */     // MIs[0] round
     /* 1237986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11085:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238021 */     // GIR_Coverage, 65217,
     /* 1238021 */     GIR_EraseRootFromParent_Done,
     /* 1238022 */   // Label 17923: @1238022
     /* 1238022 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1238102), // Rule ID 65220 //
     /* 1238027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238066 */     // MIs[0] round
     /* 1238066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1238079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238101 */     // GIR_Coverage, 65220,
     /* 1238101 */     GIR_EraseRootFromParent_Done,
     /* 1238102 */   // Label 17924: @1238102
     /* 1238102 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1238182), // Rule ID 65221 //
     /* 1238107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238146 */     // MIs[0] round
     /* 1238146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238156 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1238159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238181 */     // GIR_Coverage, 65221,
     /* 1238181 */     GIR_EraseRootFromParent_Done,
     /* 1238182 */   // Label 17925: @1238182
     /* 1238182 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1238262), // Rule ID 65224 //
     /* 1238187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238226 */     // MIs[0] round
     /* 1238226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238236 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1238239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238261 */     // GIR_Coverage, 65224,
     /* 1238261 */     GIR_EraseRootFromParent_Done,
     /* 1238262 */   // Label 17926: @1238262
     /* 1238262 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1238342), // Rule ID 65225 //
     /* 1238267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238306 */     // MIs[0] round
     /* 1238306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238316 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1238319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238341 */     // GIR_Coverage, 65225,
     /* 1238341 */     GIR_EraseRootFromParent_Done,
     /* 1238342 */   // Label 17927: @1238342
     /* 1238342 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1238422), // Rule ID 65228 //
     /* 1238347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1238350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238386 */     // MIs[0] round
     /* 1238386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238396 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238421 */     // GIR_Coverage, 65228,
     /* 1238421 */     GIR_EraseRootFromParent_Done,
     /* 1238422 */   // Label 17928: @1238422
     /* 1238422 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1238502), // Rule ID 65229 //
     /* 1238427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1238430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1238435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238466 */     // MIs[0] round
     /* 1238466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238501 */     // GIR_Coverage, 65229,
     /* 1238501 */     GIR_EraseRootFromParent_Done,
     /* 1238502 */   // Label 17929: @1238502
     /* 1238502 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1238586), // Rule ID 2722 //
     /* 1238507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238585 */     // GIR_Coverage, 2722,
     /* 1238585 */     GIR_EraseRootFromParent_Done,
     /* 1238586 */   // Label 17930: @1238586
     /* 1238586 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1238670), // Rule ID 2723 //
     /* 1238591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238669 */     // GIR_Coverage, 2723,
     /* 1238669 */     GIR_EraseRootFromParent_Done,
     /* 1238670 */   // Label 17931: @1238670
     /* 1238670 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1238754), // Rule ID 2734 //
     /* 1238675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238753 */     // GIR_Coverage, 2734,
     /* 1238753 */     GIR_EraseRootFromParent_Done,
     /* 1238754 */   // Label 17932: @1238754
     /* 1238754 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1238838), // Rule ID 2735 //
     /* 1238759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238837 */     // GIR_Coverage, 2735,
     /* 1238837 */     GIR_EraseRootFromParent_Done,
     /* 1238838 */   // Label 17933: @1238838
     /* 1238838 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1238919), // Rule ID 2736 //
     /* 1238843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238918 */     // GIR_Coverage, 2736,
     /* 1238918 */     GIR_EraseRootFromParent_Done,
     /* 1238919 */   // Label 17934: @1238919
     /* 1238919 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1239000), // Rule ID 2737 //
     /* 1238924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238977 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238999 */     // GIR_Coverage, 2737,
     /* 1238999 */     GIR_EraseRootFromParent_Done,
     /* 1239000 */   // Label 17935: @1239000
     /* 1239000 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1239084), // Rule ID 2786 //
     /* 1239005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1239013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1239058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1239061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1239065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239083 */     // GIR_Coverage, 2786,
     /* 1239083 */     GIR_EraseRootFromParent_Done,
     /* 1239084 */   // Label 17936: @1239084
     /* 1239084 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1239168), // Rule ID 2787 //
     /* 1239089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1239097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1239142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1239145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1239149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1239166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239167 */     // GIR_Coverage, 2787,
     /* 1239167 */     GIR_EraseRootFromParent_Done,
     /* 1239168 */   // Label 17937: @1239168
     /* 1239168 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1239249), // Rule ID 5122 //
     /* 1239173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239248 */     // GIR_Coverage, 5122,
     /* 1239248 */     GIR_EraseRootFromParent_Done,
     /* 1239249 */   // Label 17938: @1239249
     /* 1239249 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1239330), // Rule ID 5123 //
     /* 1239254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239307 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239329 */     // GIR_Coverage, 5123,
     /* 1239329 */     GIR_EraseRootFromParent_Done,
     /* 1239330 */   // Label 17939: @1239330
     /* 1239330 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1239411), // Rule ID 5124 //
     /* 1239335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239388 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239410 */     // GIR_Coverage, 5124,
     /* 1239410 */     GIR_EraseRootFromParent_Done,
     /* 1239411 */   // Label 17940: @1239411
     /* 1239411 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1239492), // Rule ID 5125 //
     /* 1239416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239469 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239491 */     // GIR_Coverage, 5125,
     /* 1239491 */     GIR_EraseRootFromParent_Done,
     /* 1239492 */   // Label 17941: @1239492
     /* 1239492 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1239573), // Rule ID 5126 //
     /* 1239497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239572 */     // GIR_Coverage, 5126,
     /* 1239572 */     GIR_EraseRootFromParent_Done,
     /* 1239573 */   // Label 17942: @1239573
     /* 1239573 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1239654), // Rule ID 5127 //
     /* 1239578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239631 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239653 */     // GIR_Coverage, 5127,
     /* 1239653 */     GIR_EraseRootFromParent_Done,
     /* 1239654 */   // Label 17943: @1239654
     /* 1239654 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1239735), // Rule ID 5128 //
     /* 1239659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239734 */     // GIR_Coverage, 5128,
     /* 1239734 */     GIR_EraseRootFromParent_Done,
     /* 1239735 */   // Label 17944: @1239735
     /* 1239735 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1239816), // Rule ID 5129 //
     /* 1239740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239815 */     // GIR_Coverage, 5129,
     /* 1239815 */     GIR_EraseRootFromParent_Done,
     /* 1239816 */   // Label 17945: @1239816
     /* 1239816 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1239897), // Rule ID 5130 //
     /* 1239821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239896 */     // GIR_Coverage, 5130,
     /* 1239896 */     GIR_EraseRootFromParent_Done,
     /* 1239897 */   // Label 17946: @1239897
     /* 1239897 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1239978), // Rule ID 5131 //
     /* 1239902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239955 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239977 */     // GIR_Coverage, 5131,
     /* 1239977 */     GIR_EraseRootFromParent_Done,
     /* 1239978 */   // Label 17947: @1239978
     /* 1239978 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1240059), // Rule ID 5132 //
     /* 1239983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240058 */     // GIR_Coverage, 5132,
     /* 1240058 */     GIR_EraseRootFromParent_Done,
     /* 1240059 */   // Label 17948: @1240059
     /* 1240059 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1240140), // Rule ID 5133 //
     /* 1240064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240117 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240139 */     // GIR_Coverage, 5133,
     /* 1240139 */     GIR_EraseRootFromParent_Done,
     /* 1240140 */   // Label 17949: @1240140
     /* 1240140 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1240221), // Rule ID 5134 //
     /* 1240145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240220 */     // GIR_Coverage, 5134,
     /* 1240220 */     GIR_EraseRootFromParent_Done,
     /* 1240221 */   // Label 17950: @1240221
     /* 1240221 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1240302), // Rule ID 5135 //
     /* 1240226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240279 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240301 */     // GIR_Coverage, 5135,
     /* 1240301 */     GIR_EraseRootFromParent_Done,
     /* 1240302 */   // Label 17951: @1240302
     /* 1240302 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1240383), // Rule ID 5136 //
     /* 1240307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1240360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240382 */     // GIR_Coverage, 5136,
     /* 1240382 */     GIR_EraseRootFromParent_Done,
     /* 1240383 */   // Label 17952: @1240383
     /* 1240383 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1240464), // Rule ID 5137 //
     /* 1240388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240441 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1240441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240463 */     // GIR_Coverage, 5137,
     /* 1240463 */     GIR_EraseRootFromParent_Done,
     /* 1240464 */   // Label 17953: @1240464
     /* 1240464 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1240545), // Rule ID 5138 //
     /* 1240469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1240472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240522 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1240522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240544 */     // GIR_Coverage, 5138,
     /* 1240544 */     GIR_EraseRootFromParent_Done,
     /* 1240545 */   // Label 17954: @1240545
     /* 1240545 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1240626), // Rule ID 5139 //
     /* 1240550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1240553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240603 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1240603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240625 */     // GIR_Coverage, 5139,
     /* 1240625 */     GIR_EraseRootFromParent_Done,
     /* 1240626 */   // Label 17955: @1240626
     /* 1240626 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1240707), // Rule ID 5140 //
     /* 1240631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240706 */     // GIR_Coverage, 5140,
     /* 1240706 */     GIR_EraseRootFromParent_Done,
     /* 1240707 */   // Label 17956: @1240707
     /* 1240707 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1240788), // Rule ID 5141 //
     /* 1240712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240787 */     // GIR_Coverage, 5141,
     /* 1240787 */     GIR_EraseRootFromParent_Done,
     /* 1240788 */   // Label 17957: @1240788
     /* 1240788 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1240869), // Rule ID 5142 //
     /* 1240793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240868 */     // GIR_Coverage, 5142,
     /* 1240868 */     GIR_EraseRootFromParent_Done,
     /* 1240869 */   // Label 17958: @1240869
     /* 1240869 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1240950), // Rule ID 5143 //
     /* 1240874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240927 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240949 */     // GIR_Coverage, 5143,
     /* 1240949 */     GIR_EraseRootFromParent_Done,
     /* 1240950 */   // Label 17959: @1240950
     /* 1240950 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1241031), // Rule ID 5144 //
     /* 1240955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241030 */     // GIR_Coverage, 5144,
     /* 1241030 */     GIR_EraseRootFromParent_Done,
     /* 1241031 */   // Label 17960: @1241031
     /* 1241031 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1241112), // Rule ID 5145 //
     /* 1241036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1241056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241089 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241111 */     // GIR_Coverage, 5145,
     /* 1241111 */     GIR_EraseRootFromParent_Done,
     /* 1241112 */   // Label 17961: @1241112
     /* 1241112 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1241193), // Rule ID 5146 //
     /* 1241117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241192 */     // GIR_Coverage, 5146,
     /* 1241192 */     GIR_EraseRootFromParent_Done,
     /* 1241193 */   // Label 17962: @1241193
     /* 1241193 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1241274), // Rule ID 5147 //
     /* 1241198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241273 */     // GIR_Coverage, 5147,
     /* 1241273 */     GIR_EraseRootFromParent_Done,
     /* 1241274 */   // Label 17963: @1241274
     /* 1241274 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1241355), // Rule ID 5148 //
     /* 1241279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241354 */     // GIR_Coverage, 5148,
     /* 1241354 */     GIR_EraseRootFromParent_Done,
     /* 1241355 */   // Label 17964: @1241355
     /* 1241355 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1241436), // Rule ID 5149 //
     /* 1241360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241413 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241435 */     // GIR_Coverage, 5149,
     /* 1241435 */     GIR_EraseRootFromParent_Done,
     /* 1241436 */   // Label 17965: @1241436
     /* 1241436 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1241517), // Rule ID 5150 //
     /* 1241441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241516 */     // GIR_Coverage, 5150,
     /* 1241516 */     GIR_EraseRootFromParent_Done,
     /* 1241517 */   // Label 17966: @1241517
     /* 1241517 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1241598), // Rule ID 5151 //
     /* 1241522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241575 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241597 */     // GIR_Coverage, 5151,
     /* 1241597 */     GIR_EraseRootFromParent_Done,
     /* 1241598 */   // Label 17967: @1241598
     /* 1241598 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1241679), // Rule ID 5152 //
     /* 1241603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241678 */     // GIR_Coverage, 5152,
     /* 1241678 */     GIR_EraseRootFromParent_Done,
     /* 1241679 */   // Label 17968: @1241679
     /* 1241679 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1241760), // Rule ID 5153 //
     /* 1241684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241759 */     // GIR_Coverage, 5153,
     /* 1241759 */     GIR_EraseRootFromParent_Done,
     /* 1241760 */   // Label 17969: @1241760
     /* 1241760 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1241841), // Rule ID 5154 //
     /* 1241765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241840 */     // GIR_Coverage, 5154,
     /* 1241840 */     GIR_EraseRootFromParent_Done,
     /* 1241841 */   // Label 17970: @1241841
     /* 1241841 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1241922), // Rule ID 5155 //
     /* 1241846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241899 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241921 */     // GIR_Coverage, 5155,
     /* 1241921 */     GIR_EraseRootFromParent_Done,
     /* 1241922 */   // Label 17971: @1241922
     /* 1241922 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1242003), // Rule ID 5156 //
     /* 1241927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241980 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242002 */     // GIR_Coverage, 5156,
     /* 1242002 */     GIR_EraseRootFromParent_Done,
     /* 1242003 */   // Label 17972: @1242003
     /* 1242003 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1242084), // Rule ID 5157 //
     /* 1242008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242083 */     // GIR_Coverage, 5157,
     /* 1242083 */     GIR_EraseRootFromParent_Done,
     /* 1242084 */   // Label 17973: @1242084
     /* 1242084 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1242165), // Rule ID 5158 //
     /* 1242089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1242145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242164 */     // GIR_Coverage, 5158,
     /* 1242164 */     GIR_EraseRootFromParent_Done,
     /* 1242165 */   // Label 17974: @1242165
     /* 1242165 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1242246), // Rule ID 5159 //
     /* 1242170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1242226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242245 */     // GIR_Coverage, 5159,
     /* 1242245 */     GIR_EraseRootFromParent_Done,
     /* 1242246 */   // Label 17975: @1242246
     /* 1242246 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1242327), // Rule ID 5160 //
     /* 1242251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1242307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242326 */     // GIR_Coverage, 5160,
     /* 1242326 */     GIR_EraseRootFromParent_Done,
     /* 1242327 */   // Label 17976: @1242327
     /* 1242327 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1242408), // Rule ID 5161 //
     /* 1242332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242385 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1242388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242407 */     // GIR_Coverage, 5161,
     /* 1242407 */     GIR_EraseRootFromParent_Done,
     /* 1242408 */   // Label 17977: @1242408
     /* 1242408 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1242489), // Rule ID 5162 //
     /* 1242413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242488 */     // GIR_Coverage, 5162,
     /* 1242488 */     GIR_EraseRootFromParent_Done,
     /* 1242489 */   // Label 17978: @1242489
     /* 1242489 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1242570), // Rule ID 5163 //
     /* 1242494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242547 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242569 */     // GIR_Coverage, 5163,
     /* 1242569 */     GIR_EraseRootFromParent_Done,
     /* 1242570 */   // Label 17979: @1242570
     /* 1242570 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1242651), // Rule ID 5164 //
     /* 1242575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242650 */     // GIR_Coverage, 5164,
     /* 1242650 */     GIR_EraseRootFromParent_Done,
     /* 1242651 */   // Label 17980: @1242651
     /* 1242651 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1242732), // Rule ID 5165 //
     /* 1242656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242709 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242731 */     // GIR_Coverage, 5165,
     /* 1242731 */     GIR_EraseRootFromParent_Done,
     /* 1242732 */   // Label 17981: @1242732
     /* 1242732 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1242813), // Rule ID 5166 //
     /* 1242737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242812 */     // GIR_Coverage, 5166,
     /* 1242812 */     GIR_EraseRootFromParent_Done,
     /* 1242813 */   // Label 17982: @1242813
     /* 1242813 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1242894), // Rule ID 5167 //
     /* 1242818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242871 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242893 */     // GIR_Coverage, 5167,
     /* 1242893 */     GIR_EraseRootFromParent_Done,
     /* 1242894 */   // Label 17983: @1242894
     /* 1242894 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1242975), // Rule ID 5168 //
     /* 1242899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242974 */     // GIR_Coverage, 5168,
     /* 1242974 */     GIR_EraseRootFromParent_Done,
     /* 1242975 */   // Label 17984: @1242975
     /* 1242975 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1243056), // Rule ID 5169 //
     /* 1242980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243033 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243055 */     // GIR_Coverage, 5169,
     /* 1243055 */     GIR_EraseRootFromParent_Done,
     /* 1243056 */   // Label 17985: @1243056
     /* 1243056 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1243137), // Rule ID 5170 //
     /* 1243061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1243117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243136 */     // GIR_Coverage, 5170,
     /* 1243136 */     GIR_EraseRootFromParent_Done,
     /* 1243137 */   // Label 17986: @1243137
     /* 1243137 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1243218), // Rule ID 5171 //
     /* 1243142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1243198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243217 */     // GIR_Coverage, 5171,
     /* 1243217 */     GIR_EraseRootFromParent_Done,
     /* 1243218 */   // Label 17987: @1243218
     /* 1243218 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1243299), // Rule ID 5172 //
     /* 1243223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243298 */     // GIR_Coverage, 5172,
     /* 1243298 */     GIR_EraseRootFromParent_Done,
     /* 1243299 */   // Label 17988: @1243299
     /* 1243299 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1243380), // Rule ID 5173 //
     /* 1243304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243357 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243379 */     // GIR_Coverage, 5173,
     /* 1243379 */     GIR_EraseRootFromParent_Done,
     /* 1243380 */   // Label 17989: @1243380
     /* 1243380 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1243461), // Rule ID 5174 //
     /* 1243385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243460 */     // GIR_Coverage, 5174,
     /* 1243460 */     GIR_EraseRootFromParent_Done,
     /* 1243461 */   // Label 17990: @1243461
     /* 1243461 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1243542), // Rule ID 5175 //
     /* 1243466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243519 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243541 */     // GIR_Coverage, 5175,
     /* 1243541 */     GIR_EraseRootFromParent_Done,
     /* 1243542 */   // Label 17991: @1243542
     /* 1243542 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1243623), // Rule ID 5176 //
     /* 1243547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243622 */     // GIR_Coverage, 5176,
     /* 1243622 */     GIR_EraseRootFromParent_Done,
     /* 1243623 */   // Label 17992: @1243623
     /* 1243623 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1243704), // Rule ID 5177 //
     /* 1243628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243681 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11198:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243703 */     // GIR_Coverage, 5177,
     /* 1243703 */     GIR_EraseRootFromParent_Done,
     /* 1243704 */   // Label 17993: @1243704
     /* 1243704 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1243785), // Rule ID 5178 //
     /* 1243709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243784 */     // GIR_Coverage, 5178,
     /* 1243784 */     GIR_EraseRootFromParent_Done,
     /* 1243785 */   // Label 17994: @1243785
     /* 1243785 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1243866), // Rule ID 5179 //
     /* 1243790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243865 */     // GIR_Coverage, 5179,
     /* 1243865 */     GIR_EraseRootFromParent_Done,
     /* 1243866 */   // Label 17995: @1243866
     /* 1243866 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1243947), // Rule ID 5180 //
     /* 1243871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243946 */     // GIR_Coverage, 5180,
     /* 1243946 */     GIR_EraseRootFromParent_Done,
     /* 1243947 */   // Label 17996: @1243947
     /* 1243947 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1244028), // Rule ID 5181 //
     /* 1243952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244005 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244027 */     // GIR_Coverage, 5181,
     /* 1244027 */     GIR_EraseRootFromParent_Done,
     /* 1244028 */   // Label 17997: @1244028
     /* 1244028 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1244109), // Rule ID 5182 //
     /* 1244033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1244036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1244086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244108 */     // GIR_Coverage, 5182,
     /* 1244108 */     GIR_EraseRootFromParent_Done,
     /* 1244109 */   // Label 17998: @1244109
     /* 1244109 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1244190), // Rule ID 5183 //
     /* 1244114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1244117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244167 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1244167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1244170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244189 */     // GIR_Coverage, 5183,
     /* 1244189 */     GIR_EraseRootFromParent_Done,
     /* 1244190 */   // Label 17999: @1244190
     /* 1244190 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1244271), // Rule ID 5184 //
     /* 1244195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244270 */     // GIR_Coverage, 5184,
     /* 1244270 */     GIR_EraseRootFromParent_Done,
     /* 1244271 */   // Label 18000: @1244271
     /* 1244271 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1244352), // Rule ID 5185 //
     /* 1244276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244351 */     // GIR_Coverage, 5185,
     /* 1244351 */     GIR_EraseRootFromParent_Done,
     /* 1244352 */   // Label 18001: @1244352
     /* 1244352 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1244433), // Rule ID 5186 //
     /* 1244357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244432 */     // GIR_Coverage, 5186,
     /* 1244432 */     GIR_EraseRootFromParent_Done,
     /* 1244433 */   // Label 18002: @1244433
     /* 1244433 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1244514), // Rule ID 5187 //
     /* 1244438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244491 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244513 */     // GIR_Coverage, 5187,
     /* 1244513 */     GIR_EraseRootFromParent_Done,
     /* 1244514 */   // Label 18003: @1244514
     /* 1244514 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1244595), // Rule ID 5188 //
     /* 1244519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244572 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244594 */     // GIR_Coverage, 5188,
     /* 1244594 */     GIR_EraseRootFromParent_Done,
     /* 1244595 */   // Label 18004: @1244595
     /* 1244595 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1244676), // Rule ID 5189 //
     /* 1244600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244653 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244675 */     // GIR_Coverage, 5189,
     /* 1244675 */     GIR_EraseRootFromParent_Done,
     /* 1244676 */   // Label 18005: @1244676
     /* 1244676 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1244757), // Rule ID 5190 //
     /* 1244681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244756 */     // GIR_Coverage, 5190,
     /* 1244756 */     GIR_EraseRootFromParent_Done,
     /* 1244757 */   // Label 18006: @1244757
     /* 1244757 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1244838), // Rule ID 5191 //
     /* 1244762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244837 */     // GIR_Coverage, 5191,
     /* 1244837 */     GIR_EraseRootFromParent_Done,
     /* 1244838 */   // Label 18007: @1244838
     /* 1244838 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1244919), // Rule ID 5192 //
     /* 1244843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244918 */     // GIR_Coverage, 5192,
     /* 1244918 */     GIR_EraseRootFromParent_Done,
     /* 1244919 */   // Label 18008: @1244919
     /* 1244919 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1245000), // Rule ID 5193 //
     /* 1244924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244977 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244999 */     // GIR_Coverage, 5193,
     /* 1244999 */     GIR_EraseRootFromParent_Done,
     /* 1245000 */   // Label 18009: @1245000
     /* 1245000 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1245081), // Rule ID 5194 //
     /* 1245005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245080 */     // GIR_Coverage, 5194,
     /* 1245080 */     GIR_EraseRootFromParent_Done,
     /* 1245081 */   // Label 18010: @1245081
     /* 1245081 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1245162), // Rule ID 5195 //
     /* 1245086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245139 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245161 */     // GIR_Coverage, 5195,
     /* 1245161 */     GIR_EraseRootFromParent_Done,
     /* 1245162 */   // Label 18011: @1245162
     /* 1245162 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1245243), // Rule ID 5196 //
     /* 1245167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245242 */     // GIR_Coverage, 5196,
     /* 1245242 */     GIR_EraseRootFromParent_Done,
     /* 1245243 */   // Label 18012: @1245243
     /* 1245243 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1245324), // Rule ID 5197 //
     /* 1245248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245323 */     // GIR_Coverage, 5197,
     /* 1245323 */     GIR_EraseRootFromParent_Done,
     /* 1245324 */   // Label 18013: @1245324
     /* 1245324 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1245405), // Rule ID 5198 //
     /* 1245329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245404 */     // GIR_Coverage, 5198,
     /* 1245404 */     GIR_EraseRootFromParent_Done,
     /* 1245405 */   // Label 18014: @1245405
     /* 1245405 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1245486), // Rule ID 5199 //
     /* 1245410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245463 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245485 */     // GIR_Coverage, 5199,
     /* 1245485 */     GIR_EraseRootFromParent_Done,
     /* 1245486 */   // Label 18015: @1245486
     /* 1245486 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1245567), // Rule ID 5200 //
     /* 1245491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245566 */     // GIR_Coverage, 5200,
     /* 1245566 */     GIR_EraseRootFromParent_Done,
     /* 1245567 */   // Label 18016: @1245567
     /* 1245567 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1245648), // Rule ID 5201 //
     /* 1245572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245625 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245647 */     // GIR_Coverage, 5201,
     /* 1245647 */     GIR_EraseRootFromParent_Done,
     /* 1245648 */   // Label 18017: @1245648
     /* 1245648 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1245729), // Rule ID 5202 //
     /* 1245653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245728 */     // GIR_Coverage, 5202,
     /* 1245728 */     GIR_EraseRootFromParent_Done,
     /* 1245729 */   // Label 18018: @1245729
     /* 1245729 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1245810), // Rule ID 5203 //
     /* 1245734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245809 */     // GIR_Coverage, 5203,
     /* 1245809 */     GIR_EraseRootFromParent_Done,
     /* 1245810 */   // Label 18019: @1245810
     /* 1245810 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1245891), // Rule ID 5204 //
     /* 1245815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245890 */     // GIR_Coverage, 5204,
     /* 1245890 */     GIR_EraseRootFromParent_Done,
     /* 1245891 */   // Label 18020: @1245891
     /* 1245891 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1245972), // Rule ID 5205 //
     /* 1245896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245971 */     // GIR_Coverage, 5205,
     /* 1245971 */     GIR_EraseRootFromParent_Done,
     /* 1245972 */   // Label 18021: @1245972
     /* 1245972 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1246053), // Rule ID 5206 //
     /* 1245977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1246033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246052 */     // GIR_Coverage, 5206,
     /* 1246052 */     GIR_EraseRootFromParent_Done,
     /* 1246053 */   // Label 18022: @1246053
     /* 1246053 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1246134), // Rule ID 5207 //
     /* 1246058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1246066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246111 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1246114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246133 */     // GIR_Coverage, 5207,
     /* 1246133 */     GIR_EraseRootFromParent_Done,
     /* 1246134 */   // Label 18023: @1246134
     /* 1246134 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1246215), // Rule ID 5512 //
     /* 1246139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1246150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1246153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1246156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1246159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1246195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246214 */     // GIR_Coverage, 5512,
     /* 1246214 */     GIR_EraseRootFromParent_Done,
     /* 1246215 */   // Label 18024: @1246215
     /* 1246215 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1246296), // Rule ID 5513 //
     /* 1246220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1246231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1246234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1246237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1246240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246273 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1246276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246295 */     // GIR_Coverage, 5513,
     /* 1246295 */     GIR_EraseRootFromParent_Done,
     /* 1246296 */   // Label 18025: @1246296
     /* 1246296 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1246377), // Rule ID 5514 //
     /* 1246301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246376 */     // GIR_Coverage, 5514,
     /* 1246376 */     GIR_EraseRootFromParent_Done,
     /* 1246377 */   // Label 18026: @1246377
     /* 1246377 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1246458), // Rule ID 5515 //
     /* 1246382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1246393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1246396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246435 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246457 */     // GIR_Coverage, 5515,
     /* 1246457 */     GIR_EraseRootFromParent_Done,
     /* 1246458 */   // Label 18027: @1246458
     /* 1246458 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1246539), // Rule ID 5516 //
     /* 1246463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246516 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246538 */     // GIR_Coverage, 5516,
     /* 1246538 */     GIR_EraseRootFromParent_Done,
     /* 1246539 */   // Label 18028: @1246539
     /* 1246539 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1246620), // Rule ID 5517 //
     /* 1246544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246597 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246619 */     // GIR_Coverage, 5517,
     /* 1246619 */     GIR_EraseRootFromParent_Done,
     /* 1246620 */   // Label 18029: @1246620
     /* 1246620 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1246701), // Rule ID 5518 //
     /* 1246625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246700 */     // GIR_Coverage, 5518,
     /* 1246700 */     GIR_EraseRootFromParent_Done,
     /* 1246701 */   // Label 18030: @1246701
     /* 1246701 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1246782), // Rule ID 5519 //
     /* 1246706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246759 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246781 */     // GIR_Coverage, 5519,
     /* 1246781 */     GIR_EraseRootFromParent_Done,
     /* 1246782 */   // Label 18031: @1246782
     /* 1246782 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1246863), // Rule ID 5520 //
     /* 1246787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246862 */     // GIR_Coverage, 5520,
     /* 1246862 */     GIR_EraseRootFromParent_Done,
     /* 1246863 */   // Label 18032: @1246863
     /* 1246863 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1246944), // Rule ID 5521 //
     /* 1246868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246943 */     // GIR_Coverage, 5521,
     /* 1246943 */     GIR_EraseRootFromParent_Done,
     /* 1246944 */   // Label 18033: @1246944
     /* 1246944 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1247025), // Rule ID 5522 //
     /* 1246949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1247005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247024 */     // GIR_Coverage, 5522,
     /* 1247024 */     GIR_EraseRootFromParent_Done,
     /* 1247025 */   // Label 18034: @1247025
     /* 1247025 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1247106), // Rule ID 5523 //
     /* 1247030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1247041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1247044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1247047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1247050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1247086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247105 */     // GIR_Coverage, 5523,
     /* 1247105 */     GIR_EraseRootFromParent_Done,
     /* 1247106 */   // Label 18035: @1247106
     /* 1247106 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1247187), // Rule ID 5524 //
     /* 1247111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247186 */     // GIR_Coverage, 5524,
     /* 1247186 */     GIR_EraseRootFromParent_Done,
     /* 1247187 */   // Label 18036: @1247187
     /* 1247187 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1247268), // Rule ID 5525 //
     /* 1247192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247267 */     // GIR_Coverage, 5525,
     /* 1247267 */     GIR_EraseRootFromParent_Done,
     /* 1247268 */   // Label 18037: @1247268
     /* 1247268 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1247349), // Rule ID 5526 //
     /* 1247273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247348 */     // GIR_Coverage, 5526,
     /* 1247348 */     GIR_EraseRootFromParent_Done,
     /* 1247349 */   // Label 18038: @1247349
     /* 1247349 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1247430), // Rule ID 5527 //
     /* 1247354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1247365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1247368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247429 */     // GIR_Coverage, 5527,
     /* 1247429 */     GIR_EraseRootFromParent_Done,
     /* 1247430 */   // Label 18039: @1247430
     /* 1247430 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1247511), // Rule ID 5528 //
     /* 1247435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247510 */     // GIR_Coverage, 5528,
     /* 1247510 */     GIR_EraseRootFromParent_Done,
     /* 1247511 */   // Label 18040: @1247511
     /* 1247511 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1247592), // Rule ID 5529 //
     /* 1247516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247569 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247591 */     // GIR_Coverage, 5529,
     /* 1247591 */     GIR_EraseRootFromParent_Done,
     /* 1247592 */   // Label 18041: @1247592
     /* 1247592 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1247673), // Rule ID 5530 //
     /* 1247597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1247650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247672 */     // GIR_Coverage, 5530,
     /* 1247672 */     GIR_EraseRootFromParent_Done,
     /* 1247673 */   // Label 18042: @1247673
     /* 1247673 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1247754), // Rule ID 5531 //
     /* 1247678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1247731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247753 */     // GIR_Coverage, 5531,
     /* 1247753 */     GIR_EraseRootFromParent_Done,
     /* 1247754 */   // Label 18043: @1247754
     /* 1247754 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1247835), // Rule ID 5532 //
     /* 1247759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247834 */     // GIR_Coverage, 5532,
     /* 1247834 */     GIR_EraseRootFromParent_Done,
     /* 1247835 */   // Label 18044: @1247835
     /* 1247835 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1247916), // Rule ID 5533 //
     /* 1247840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247915 */     // GIR_Coverage, 5533,
     /* 1247915 */     GIR_EraseRootFromParent_Done,
     /* 1247916 */   // Label 18045: @1247916
     /* 1247916 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1247997), // Rule ID 5534 //
     /* 1247921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247974 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247996 */     // GIR_Coverage, 5534,
     /* 1247996 */     GIR_EraseRootFromParent_Done,
     /* 1247997 */   // Label 18046: @1247997
     /* 1247997 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1248078), // Rule ID 5535 //
     /* 1248002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1248013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1248016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1248019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1248022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248055 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248077 */     // GIR_Coverage, 5535,
     /* 1248077 */     GIR_EraseRootFromParent_Done,
     /* 1248078 */   // Label 18047: @1248078
     /* 1248078 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1248159), // Rule ID 5536 //
     /* 1248083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1248094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1248097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1248136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248158 */     // GIR_Coverage, 5536,
     /* 1248158 */     GIR_EraseRootFromParent_Done,
     /* 1248159 */   // Label 18048: @1248159
     /* 1248159 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1248240), // Rule ID 5537 //
     /* 1248164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1248175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1248178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248217 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248239 */     // GIR_Coverage, 5537,
     /* 1248239 */     GIR_EraseRootFromParent_Done,
     /* 1248240 */   // Label 18049: @1248240
     /* 1248240 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1248321), // Rule ID 5538 //
     /* 1248245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248320 */     // GIR_Coverage, 5538,
     /* 1248320 */     GIR_EraseRootFromParent_Done,
     /* 1248321 */   // Label 18050: @1248321
     /* 1248321 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1248402), // Rule ID 5539 //
     /* 1248326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1248337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1248340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248401 */     // GIR_Coverage, 5539,
     /* 1248401 */     GIR_EraseRootFromParent_Done,
     /* 1248402 */   // Label 18051: @1248402
     /* 1248402 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1248483), // Rule ID 5540 //
     /* 1248407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248482 */     // GIR_Coverage, 5540,
     /* 1248482 */     GIR_EraseRootFromParent_Done,
     /* 1248483 */   // Label 18052: @1248483
     /* 1248483 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1248564), // Rule ID 5541 //
     /* 1248488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248541 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248563 */     // GIR_Coverage, 5541,
     /* 1248563 */     GIR_EraseRootFromParent_Done,
     /* 1248564 */   // Label 18053: @1248564
     /* 1248564 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1248645), // Rule ID 5542 //
     /* 1248569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248644 */     // GIR_Coverage, 5542,
     /* 1248644 */     GIR_EraseRootFromParent_Done,
     /* 1248645 */   // Label 18054: @1248645
     /* 1248645 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1248726), // Rule ID 5543 //
     /* 1248650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248703 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248725 */     // GIR_Coverage, 5543,
     /* 1248725 */     GIR_EraseRootFromParent_Done,
     /* 1248726 */   // Label 18055: @1248726
     /* 1248726 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1248807), // Rule ID 5544 //
     /* 1248731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248806 */     // GIR_Coverage, 5544,
     /* 1248806 */     GIR_EraseRootFromParent_Done,
     /* 1248807 */   // Label 18056: @1248807
     /* 1248807 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1248888), // Rule ID 5545 //
     /* 1248812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248887 */     // GIR_Coverage, 5545,
     /* 1248887 */     GIR_EraseRootFromParent_Done,
     /* 1248888 */   // Label 18057: @1248888
     /* 1248888 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1248969), // Rule ID 5546 //
     /* 1248893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248968 */     // GIR_Coverage, 5546,
     /* 1248968 */     GIR_EraseRootFromParent_Done,
     /* 1248969 */   // Label 18058: @1248969
     /* 1248969 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1249050), // Rule ID 5547 //
     /* 1248974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249049 */     // GIR_Coverage, 5547,
     /* 1249049 */     GIR_EraseRootFromParent_Done,
     /* 1249050 */   // Label 18059: @1249050
     /* 1249050 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1249131), // Rule ID 5548 //
     /* 1249055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1249066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1249069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1249108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249130 */     // GIR_Coverage, 5548,
     /* 1249130 */     GIR_EraseRootFromParent_Done,
     /* 1249131 */   // Label 18060: @1249131
     /* 1249131 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1249212), // Rule ID 5549 //
     /* 1249136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1249147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1249150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249211 */     // GIR_Coverage, 5549,
     /* 1249211 */     GIR_EraseRootFromParent_Done,
     /* 1249212 */   // Label 18061: @1249212
     /* 1249212 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1249293), // Rule ID 5550 //
     /* 1249217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1249273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249292 */     // GIR_Coverage, 5550,
     /* 1249292 */     GIR_EraseRootFromParent_Done,
     /* 1249293 */   // Label 18062: @1249293
     /* 1249293 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1249374), // Rule ID 5551 //
     /* 1249298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1249309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1249312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1249354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249373 */     // GIR_Coverage, 5551,
     /* 1249373 */     GIR_EraseRootFromParent_Done,
     /* 1249374 */   // Label 18063: @1249374
     /* 1249374 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1249455), // Rule ID 5552 //
     /* 1249379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249454 */     // GIR_Coverage, 5552,
     /* 1249454 */     GIR_EraseRootFromParent_Done,
     /* 1249455 */   // Label 18064: @1249455
     /* 1249455 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1249536), // Rule ID 5553 //
     /* 1249460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249513 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249535 */     // GIR_Coverage, 5553,
     /* 1249535 */     GIR_EraseRootFromParent_Done,
     /* 1249536 */   // Label 18065: @1249536
     /* 1249536 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1249617), // Rule ID 5554 //
     /* 1249541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249616 */     // GIR_Coverage, 5554,
     /* 1249616 */     GIR_EraseRootFromParent_Done,
     /* 1249617 */   // Label 18066: @1249617
     /* 1249617 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1249698), // Rule ID 5555 //
     /* 1249622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249697 */     // GIR_Coverage, 5555,
     /* 1249697 */     GIR_EraseRootFromParent_Done,
     /* 1249698 */   // Label 18067: @1249698
     /* 1249698 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1249779), // Rule ID 5556 //
     /* 1249703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249778 */     // GIR_Coverage, 5556,
     /* 1249778 */     GIR_EraseRootFromParent_Done,
     /* 1249779 */   // Label 18068: @1249779
     /* 1249779 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1249860), // Rule ID 5557 //
     /* 1249784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249837 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249859 */     // GIR_Coverage, 5557,
     /* 1249859 */     GIR_EraseRootFromParent_Done,
     /* 1249860 */   // Label 18069: @1249860
     /* 1249860 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1249941), // Rule ID 5558 //
     /* 1249865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249940 */     // GIR_Coverage, 5558,
     /* 1249940 */     GIR_EraseRootFromParent_Done,
     /* 1249941 */   // Label 18070: @1249941
     /* 1249941 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1250022), // Rule ID 5559 //
     /* 1249946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249999 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250021 */     // GIR_Coverage, 5559,
     /* 1250021 */     GIR_EraseRootFromParent_Done,
     /* 1250022 */   // Label 18071: @1250022
     /* 1250022 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1250103), // Rule ID 5560 //
     /* 1250027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1250038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1250041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250080 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250102 */     // GIR_Coverage, 5560,
     /* 1250102 */     GIR_EraseRootFromParent_Done,
     /* 1250103 */   // Label 18072: @1250103
     /* 1250103 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1250184), // Rule ID 5561 //
     /* 1250108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1250119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1250122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250161 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250183 */     // GIR_Coverage, 5561,
     /* 1250183 */     GIR_EraseRootFromParent_Done,
     /* 1250184 */   // Label 18073: @1250184
     /* 1250184 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1250265), // Rule ID 5562 //
     /* 1250189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250264 */     // GIR_Coverage, 5562,
     /* 1250264 */     GIR_EraseRootFromParent_Done,
     /* 1250265 */   // Label 18074: @1250265
     /* 1250265 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1250346), // Rule ID 5563 //
     /* 1250270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1250281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1250284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250323 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1250326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250345 */     // GIR_Coverage, 5563,
     /* 1250345 */     GIR_EraseRootFromParent_Done,
     /* 1250346 */   // Label 18075: @1250346
     /* 1250346 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1250427), // Rule ID 5564 //
     /* 1250351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250426 */     // GIR_Coverage, 5564,
     /* 1250426 */     GIR_EraseRootFromParent_Done,
     /* 1250427 */   // Label 18076: @1250427
     /* 1250427 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1250508), // Rule ID 5565 //
     /* 1250432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1250443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1250446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250507 */     // GIR_Coverage, 5565,
     /* 1250507 */     GIR_EraseRootFromParent_Done,
     /* 1250508 */   // Label 18077: @1250508
     /* 1250508 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1250589), // Rule ID 5566 //
     /* 1250513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250588 */     // GIR_Coverage, 5566,
     /* 1250588 */     GIR_EraseRootFromParent_Done,
     /* 1250589 */   // Label 18078: @1250589
     /* 1250589 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1250670), // Rule ID 5567 //
     /* 1250594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250647 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250669 */     // GIR_Coverage, 5567,
     /* 1250669 */     GIR_EraseRootFromParent_Done,
     /* 1250670 */   // Label 18079: @1250670
     /* 1250670 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1250751), // Rule ID 5568 //
     /* 1250675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250750 */     // GIR_Coverage, 5568,
     /* 1250750 */     GIR_EraseRootFromParent_Done,
     /* 1250751 */   // Label 18080: @1250751
     /* 1250751 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1250832), // Rule ID 5569 //
     /* 1250756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250809 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11591:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250831 */     // GIR_Coverage, 5569,
     /* 1250831 */     GIR_EraseRootFromParent_Done,
     /* 1250832 */   // Label 18081: @1250832
     /* 1250832 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1250913), // Rule ID 5570 //
     /* 1250837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250912 */     // GIR_Coverage, 5570,
     /* 1250912 */     GIR_EraseRootFromParent_Done,
     /* 1250913 */   // Label 18082: @1250913
     /* 1250913 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1250994), // Rule ID 5571 //
     /* 1250918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250971 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250993 */     // GIR_Coverage, 5571,
     /* 1250993 */     GIR_EraseRootFromParent_Done,
     /* 1250994 */   // Label 18083: @1250994
     /* 1250994 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1251075), // Rule ID 5572 //
     /* 1250999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1251010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1251013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1251052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251074 */     // GIR_Coverage, 5572,
     /* 1251074 */     GIR_EraseRootFromParent_Done,
     /* 1251075 */   // Label 18084: @1251075
     /* 1251075 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1251156), // Rule ID 5573 //
     /* 1251080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1251091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1251094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1251133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251155 */     // GIR_Coverage, 5573,
     /* 1251155 */     GIR_EraseRootFromParent_Done,
     /* 1251156 */   // Label 18085: @1251156
     /* 1251156 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1251237), // Rule ID 5574 //
     /* 1251161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1251164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1251172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1251175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1251214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251236 */     // GIR_Coverage, 5574,
     /* 1251236 */     GIR_EraseRootFromParent_Done,
     /* 1251237 */   // Label 18086: @1251237
     /* 1251237 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1251318), // Rule ID 5575 //
     /* 1251242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1251245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1251253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1251256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1251272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251295 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1251295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1251298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251317 */     // GIR_Coverage, 5575,
     /* 1251317 */     GIR_EraseRootFromParent_Done,
     /* 1251318 */   // Label 18087: @1251318
     /* 1251318 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1251399), // Rule ID 5576 //
     /* 1251323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251398 */     // GIR_Coverage, 5576,
     /* 1251398 */     GIR_EraseRootFromParent_Done,
     /* 1251399 */   // Label 18088: @1251399
     /* 1251399 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1251480), // Rule ID 5577 //
     /* 1251404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1251415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1251418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251479 */     // GIR_Coverage, 5577,
     /* 1251479 */     GIR_EraseRootFromParent_Done,
     /* 1251480 */   // Label 18089: @1251480
     /* 1251480 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1251561), // Rule ID 5578 //
     /* 1251485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251538 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251560 */     // GIR_Coverage, 5578,
     /* 1251560 */     GIR_EraseRootFromParent_Done,
     /* 1251561 */   // Label 18090: @1251561
     /* 1251561 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1251642), // Rule ID 5579 //
     /* 1251566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251619 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251641 */     // GIR_Coverage, 5579,
     /* 1251641 */     GIR_EraseRootFromParent_Done,
     /* 1251642 */   // Label 18091: @1251642
     /* 1251642 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1251723), // Rule ID 5580 //
     /* 1251647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251700 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251722 */     // GIR_Coverage, 5580,
     /* 1251722 */     GIR_EraseRootFromParent_Done,
     /* 1251723 */   // Label 18092: @1251723
     /* 1251723 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1251804), // Rule ID 5581 //
     /* 1251728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251803 */     // GIR_Coverage, 5581,
     /* 1251803 */     GIR_EraseRootFromParent_Done,
     /* 1251804 */   // Label 18093: @1251804
     /* 1251804 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1251885), // Rule ID 5582 //
     /* 1251809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251884 */     // GIR_Coverage, 5582,
     /* 1251884 */     GIR_EraseRootFromParent_Done,
     /* 1251885 */   // Label 18094: @1251885
     /* 1251885 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1251966), // Rule ID 5583 //
     /* 1251890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251965 */     // GIR_Coverage, 5583,
     /* 1251965 */     GIR_EraseRootFromParent_Done,
     /* 1251966 */   // Label 18095: @1251966
     /* 1251966 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1252047), // Rule ID 5584 //
     /* 1251971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1252024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252046 */     // GIR_Coverage, 5584,
     /* 1252046 */     GIR_EraseRootFromParent_Done,
     /* 1252047 */   // Label 18096: @1252047
     /* 1252047 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1252128), // Rule ID 5585 //
     /* 1252052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1252063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1252066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252105 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1252105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252127 */     // GIR_Coverage, 5585,
     /* 1252127 */     GIR_EraseRootFromParent_Done,
     /* 1252128 */   // Label 18097: @1252128
     /* 1252128 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1252209), // Rule ID 5586 //
     /* 1252133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1252144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1252147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1252186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252208 */     // GIR_Coverage, 5586,
     /* 1252208 */     GIR_EraseRootFromParent_Done,
     /* 1252209 */   // Label 18098: @1252209
     /* 1252209 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1252290), // Rule ID 5587 //
     /* 1252214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1252225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1252228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252267 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1252267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252289 */     // GIR_Coverage, 5587,
     /* 1252289 */     GIR_EraseRootFromParent_Done,
     /* 1252290 */   // Label 18099: @1252290
     /* 1252290 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1252371), // Rule ID 5588 //
     /* 1252295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252370 */     // GIR_Coverage, 5588,
     /* 1252370 */     GIR_EraseRootFromParent_Done,
     /* 1252371 */   // Label 18100: @1252371
     /* 1252371 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1252452), // Rule ID 5589 //
     /* 1252376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1252387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1252390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252451 */     // GIR_Coverage, 5589,
     /* 1252451 */     GIR_EraseRootFromParent_Done,
     /* 1252452 */   // Label 18101: @1252452
     /* 1252452 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1252533), // Rule ID 5590 //
     /* 1252457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252532 */     // GIR_Coverage, 5590,
     /* 1252532 */     GIR_EraseRootFromParent_Done,
     /* 1252533 */   // Label 18102: @1252533
     /* 1252533 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1252614), // Rule ID 5591 //
     /* 1252538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252591 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252613 */     // GIR_Coverage, 5591,
     /* 1252613 */     GIR_EraseRootFromParent_Done,
     /* 1252614 */   // Label 18103: @1252614
     /* 1252614 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1252695), // Rule ID 5592 //
     /* 1252619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252694 */     // GIR_Coverage, 5592,
     /* 1252694 */     GIR_EraseRootFromParent_Done,
     /* 1252695 */   // Label 18104: @1252695
     /* 1252695 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1252776), // Rule ID 5593 //
     /* 1252700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252753 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252775 */     // GIR_Coverage, 5593,
     /* 1252775 */     GIR_EraseRootFromParent_Done,
     /* 1252776 */   // Label 18105: @1252776
     /* 1252776 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1252857), // Rule ID 5594 //
     /* 1252781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252856 */     // GIR_Coverage, 5594,
     /* 1252856 */     GIR_EraseRootFromParent_Done,
     /* 1252857 */   // Label 18106: @1252857
     /* 1252857 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1252938), // Rule ID 5595 //
     /* 1252862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252937 */     // GIR_Coverage, 5595,
     /* 1252937 */     GIR_EraseRootFromParent_Done,
     /* 1252938 */   // Label 18107: @1252938
     /* 1252938 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1253019), // Rule ID 5596 //
     /* 1252943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253018 */     // GIR_Coverage, 5596,
     /* 1253018 */     GIR_EraseRootFromParent_Done,
     /* 1253019 */   // Label 18108: @1253019
     /* 1253019 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1253100), // Rule ID 5597 //
     /* 1253024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1253035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1253038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1253054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253077 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1253077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1253080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253099 */     // GIR_Coverage, 5597,
     /* 1253099 */     GIR_EraseRootFromParent_Done,
     /* 1253100 */   // Label 18109: @1253100
     /* 1253100 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1253181), // Rule ID 5598 //
     /* 1253105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1253116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1253119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1253135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1253158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1253161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253180 */     // GIR_Coverage, 5598,
     /* 1253180 */     GIR_EraseRootFromParent_Done,
     /* 1253181 */   // Label 18110: @1253181
     /* 1253181 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1253262), // Rule ID 5599 //
     /* 1253186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1253194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1253197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1253200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1253216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253239 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1253239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1253242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253261 */     // GIR_Coverage, 5599,
     /* 1253261 */     GIR_EraseRootFromParent_Done,
     /* 1253262 */   // Label 18111: @1253262
     /* 1253262 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1253346), // Rule ID 7810 //
     /* 1253267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253345 */     // GIR_Coverage, 7810,
     /* 1253345 */     GIR_EraseRootFromParent_Done,
     /* 1253346 */   // Label 18112: @1253346
     /* 1253346 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1253430), // Rule ID 7811 //
     /* 1253351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253429 */     // GIR_Coverage, 7811,
     /* 1253429 */     GIR_EraseRootFromParent_Done,
     /* 1253430 */   // Label 18113: @1253430
     /* 1253430 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1253514), // Rule ID 7814 //
     /* 1253435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253513 */     // GIR_Coverage, 7814,
     /* 1253513 */     GIR_EraseRootFromParent_Done,
     /* 1253514 */   // Label 18114: @1253514
     /* 1253514 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1253598), // Rule ID 7815 //
     /* 1253519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253597 */     // GIR_Coverage, 7815,
     /* 1253597 */     GIR_EraseRootFromParent_Done,
     /* 1253598 */   // Label 18115: @1253598
     /* 1253598 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1253682), // Rule ID 7818 //
     /* 1253603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253681 */     // GIR_Coverage, 7818,
     /* 1253681 */     GIR_EraseRootFromParent_Done,
     /* 1253682 */   // Label 18116: @1253682
     /* 1253682 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1253766), // Rule ID 7819 //
     /* 1253687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253765 */     // GIR_Coverage, 7819,
     /* 1253765 */     GIR_EraseRootFromParent_Done,
     /* 1253766 */   // Label 18117: @1253766
     /* 1253766 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1253850), // Rule ID 7822 //
     /* 1253771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253849 */     // GIR_Coverage, 7822,
     /* 1253849 */     GIR_EraseRootFromParent_Done,
     /* 1253850 */   // Label 18118: @1253850
     /* 1253850 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1253934), // Rule ID 7823 //
     /* 1253855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253933 */     // GIR_Coverage, 7823,
     /* 1253933 */     GIR_EraseRootFromParent_Done,
     /* 1253934 */   // Label 18119: @1253934
     /* 1253934 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1254018), // Rule ID 7826 //
     /* 1253939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254017 */     // GIR_Coverage, 7826,
     /* 1254017 */     GIR_EraseRootFromParent_Done,
     /* 1254018 */   // Label 18120: @1254018
     /* 1254018 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1254102), // Rule ID 7827 //
     /* 1254023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1254040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1254043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1254079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254101 */     // GIR_Coverage, 7827,
     /* 1254101 */     GIR_EraseRootFromParent_Done,
     /* 1254102 */   // Label 18121: @1254102
     /* 1254102 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1254186), // Rule ID 7830 //
     /* 1254107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254185 */     // GIR_Coverage, 7830,
     /* 1254185 */     GIR_EraseRootFromParent_Done,
     /* 1254186 */   // Label 18122: @1254186
     /* 1254186 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1254270), // Rule ID 7831 //
     /* 1254191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254269 */     // GIR_Coverage, 7831,
     /* 1254269 */     GIR_EraseRootFromParent_Done,
     /* 1254270 */   // Label 18123: @1254270
     /* 1254270 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1254354), // Rule ID 7834 //
     /* 1254275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254353 */     // GIR_Coverage, 7834,
     /* 1254353 */     GIR_EraseRootFromParent_Done,
     /* 1254354 */   // Label 18124: @1254354
     /* 1254354 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1254438), // Rule ID 7835 //
     /* 1254359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254437 */     // GIR_Coverage, 7835,
     /* 1254437 */     GIR_EraseRootFromParent_Done,
     /* 1254438 */   // Label 18125: @1254438
     /* 1254438 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1254522), // Rule ID 7838 //
     /* 1254443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254521 */     // GIR_Coverage, 7838,
     /* 1254521 */     GIR_EraseRootFromParent_Done,
     /* 1254522 */   // Label 18126: @1254522
     /* 1254522 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1254606), // Rule ID 7839 //
     /* 1254527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254605 */     // GIR_Coverage, 7839,
     /* 1254605 */     GIR_EraseRootFromParent_Done,
     /* 1254606 */   // Label 18127: @1254606
     /* 1254606 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1254690), // Rule ID 7842 //
     /* 1254611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254689 */     // GIR_Coverage, 7842,
     /* 1254689 */     GIR_EraseRootFromParent_Done,
     /* 1254690 */   // Label 18128: @1254690
     /* 1254690 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1254774), // Rule ID 7843 //
     /* 1254695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254773 */     // GIR_Coverage, 7843,
     /* 1254773 */     GIR_EraseRootFromParent_Done,
     /* 1254774 */   // Label 18129: @1254774
     /* 1254774 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1254858), // Rule ID 7846 //
     /* 1254779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254857 */     // GIR_Coverage, 7846,
     /* 1254857 */     GIR_EraseRootFromParent_Done,
     /* 1254858 */   // Label 18130: @1254858
     /* 1254858 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1254942), // Rule ID 7847 //
     /* 1254863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254941 */     // GIR_Coverage, 7847,
     /* 1254941 */     GIR_EraseRootFromParent_Done,
     /* 1254942 */   // Label 18131: @1254942
     /* 1254942 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1255026), // Rule ID 7850 //
     /* 1254947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255000 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255025 */     // GIR_Coverage, 7850,
     /* 1255025 */     GIR_EraseRootFromParent_Done,
     /* 1255026 */   // Label 18132: @1255026
     /* 1255026 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1255110), // Rule ID 7851 //
     /* 1255031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1255048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1255051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255084 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255109 */     // GIR_Coverage, 7851,
     /* 1255109 */     GIR_EraseRootFromParent_Done,
     /* 1255110 */   // Label 18133: @1255110
     /* 1255110 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1255194), // Rule ID 7854 //
     /* 1255115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255168 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255193 */     // GIR_Coverage, 7854,
     /* 1255193 */     GIR_EraseRootFromParent_Done,
     /* 1255194 */   // Label 18134: @1255194
     /* 1255194 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1255278), // Rule ID 7855 //
     /* 1255199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255252 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255277 */     // GIR_Coverage, 7855,
     /* 1255277 */     GIR_EraseRootFromParent_Done,
     /* 1255278 */   // Label 18135: @1255278
     /* 1255278 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1255362), // Rule ID 7858 //
     /* 1255283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255361 */     // GIR_Coverage, 7858,
     /* 1255361 */     GIR_EraseRootFromParent_Done,
     /* 1255362 */   // Label 18136: @1255362
     /* 1255362 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1255446), // Rule ID 7859 //
     /* 1255367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255445 */     // GIR_Coverage, 7859,
     /* 1255445 */     GIR_EraseRootFromParent_Done,
     /* 1255446 */   // Label 18137: @1255446
     /* 1255446 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1255530), // Rule ID 7862 //
     /* 1255451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255529 */     // GIR_Coverage, 7862,
     /* 1255529 */     GIR_EraseRootFromParent_Done,
     /* 1255530 */   // Label 18138: @1255530
     /* 1255530 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1255614), // Rule ID 7863 //
     /* 1255535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255613 */     // GIR_Coverage, 7863,
     /* 1255613 */     GIR_EraseRootFromParent_Done,
     /* 1255614 */   // Label 18139: @1255614
     /* 1255614 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1255698), // Rule ID 7866 //
     /* 1255619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255697 */     // GIR_Coverage, 7866,
     /* 1255697 */     GIR_EraseRootFromParent_Done,
     /* 1255698 */   // Label 18140: @1255698
     /* 1255698 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1255782), // Rule ID 7867 //
     /* 1255703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255756 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255781 */     // GIR_Coverage, 7867,
     /* 1255781 */     GIR_EraseRootFromParent_Done,
     /* 1255782 */   // Label 18141: @1255782
     /* 1255782 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1255866), // Rule ID 7870 //
     /* 1255787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255865 */     // GIR_Coverage, 7870,
     /* 1255865 */     GIR_EraseRootFromParent_Done,
     /* 1255866 */   // Label 18142: @1255866
     /* 1255866 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1255950), // Rule ID 7871 //
     /* 1255871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255949 */     // GIR_Coverage, 7871,
     /* 1255949 */     GIR_EraseRootFromParent_Done,
     /* 1255950 */   // Label 18143: @1255950
     /* 1255950 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1256034), // Rule ID 7874 //
     /* 1255955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256033 */     // GIR_Coverage, 7874,
     /* 1256033 */     GIR_EraseRootFromParent_Done,
     /* 1256034 */   // Label 18144: @1256034
     /* 1256034 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1256118), // Rule ID 7875 //
     /* 1256039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1256056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1256059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256117 */     // GIR_Coverage, 7875,
     /* 1256117 */     GIR_EraseRootFromParent_Done,
     /* 1256118 */   // Label 18145: @1256118
     /* 1256118 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1256202), // Rule ID 7878 //
     /* 1256123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256201 */     // GIR_Coverage, 7878,
     /* 1256201 */     GIR_EraseRootFromParent_Done,
     /* 1256202 */   // Label 18146: @1256202
     /* 1256202 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1256286), // Rule ID 7879 //
     /* 1256207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256285 */     // GIR_Coverage, 7879,
     /* 1256285 */     GIR_EraseRootFromParent_Done,
     /* 1256286 */   // Label 18147: @1256286
     /* 1256286 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1256370), // Rule ID 7882 //
     /* 1256291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1256347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256369 */     // GIR_Coverage, 7882,
     /* 1256369 */     GIR_EraseRootFromParent_Done,
     /* 1256370 */   // Label 18148: @1256370
     /* 1256370 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1256454), // Rule ID 7883 //
     /* 1256375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1256431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256453 */     // GIR_Coverage, 7883,
     /* 1256453 */     GIR_EraseRootFromParent_Done,
     /* 1256454 */   // Label 18149: @1256454
     /* 1256454 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1256538), // Rule ID 7886 //
     /* 1256459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256537 */     // GIR_Coverage, 7886,
     /* 1256537 */     GIR_EraseRootFromParent_Done,
     /* 1256538 */   // Label 18150: @1256538
     /* 1256538 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1256622), // Rule ID 7887 //
     /* 1256543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256621 */     // GIR_Coverage, 7887,
     /* 1256621 */     GIR_EraseRootFromParent_Done,
     /* 1256622 */   // Label 18151: @1256622
     /* 1256622 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1256706), // Rule ID 7890 //
     /* 1256627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256705 */     // GIR_Coverage, 7890,
     /* 1256705 */     GIR_EraseRootFromParent_Done,
     /* 1256706 */   // Label 18152: @1256706
     /* 1256706 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1256790), // Rule ID 7891 //
     /* 1256711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256789 */     // GIR_Coverage, 7891,
     /* 1256789 */     GIR_EraseRootFromParent_Done,
     /* 1256790 */   // Label 18153: @1256790
     /* 1256790 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1256874), // Rule ID 7894 //
     /* 1256795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256873 */     // GIR_Coverage, 7894,
     /* 1256873 */     GIR_EraseRootFromParent_Done,
     /* 1256874 */   // Label 18154: @1256874
     /* 1256874 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1256958), // Rule ID 7895 //
     /* 1256879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256957 */     // GIR_Coverage, 7895,
     /* 1256957 */     GIR_EraseRootFromParent_Done,
     /* 1256958 */   // Label 18155: @1256958
     /* 1256958 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1257042), // Rule ID 7898 //
     /* 1256963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257041 */     // GIR_Coverage, 7898,
     /* 1257041 */     GIR_EraseRootFromParent_Done,
     /* 1257042 */   // Label 18156: @1257042
     /* 1257042 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1257126), // Rule ID 7899 //
     /* 1257047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1257064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257125 */     // GIR_Coverage, 7899,
     /* 1257125 */     GIR_EraseRootFromParent_Done,
     /* 1257126 */   // Label 18157: @1257126
     /* 1257126 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1257210), // Rule ID 7902 //
     /* 1257131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257209 */     // GIR_Coverage, 7902,
     /* 1257209 */     GIR_EraseRootFromParent_Done,
     /* 1257210 */   // Label 18158: @1257210
     /* 1257210 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1257294), // Rule ID 7903 //
     /* 1257215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257293 */     // GIR_Coverage, 7903,
     /* 1257293 */     GIR_EraseRootFromParent_Done,
     /* 1257294 */   // Label 18159: @1257294
     /* 1257294 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1257378), // Rule ID 7906 //
     /* 1257299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257377 */     // GIR_Coverage, 7906,
     /* 1257377 */     GIR_EraseRootFromParent_Done,
     /* 1257378 */   // Label 18160: @1257378
     /* 1257378 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1257462), // Rule ID 7907 //
     /* 1257383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1257439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257461 */     // GIR_Coverage, 7907,
     /* 1257461 */     GIR_EraseRootFromParent_Done,
     /* 1257462 */   // Label 18161: @1257462
     /* 1257462 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1257546), // Rule ID 7910 //
     /* 1257467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257545 */     // GIR_Coverage, 7910,
     /* 1257545 */     GIR_EraseRootFromParent_Done,
     /* 1257546 */   // Label 18162: @1257546
     /* 1257546 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1257630), // Rule ID 7911 //
     /* 1257551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257629 */     // GIR_Coverage, 7911,
     /* 1257629 */     GIR_EraseRootFromParent_Done,
     /* 1257630 */   // Label 18163: @1257630
     /* 1257630 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1257714), // Rule ID 7914 //
     /* 1257635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257713 */     // GIR_Coverage, 7914,
     /* 1257713 */     GIR_EraseRootFromParent_Done,
     /* 1257714 */   // Label 18164: @1257714
     /* 1257714 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1257798), // Rule ID 7915 //
     /* 1257719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257797 */     // GIR_Coverage, 7915,
     /* 1257797 */     GIR_EraseRootFromParent_Done,
     /* 1257798 */   // Label 18165: @1257798
     /* 1257798 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1257882), // Rule ID 7918 //
     /* 1257803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257881 */     // GIR_Coverage, 7918,
     /* 1257881 */     GIR_EraseRootFromParent_Done,
     /* 1257882 */   // Label 18166: @1257882
     /* 1257882 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1257966), // Rule ID 7919 //
     /* 1257887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257965 */     // GIR_Coverage, 7919,
     /* 1257965 */     GIR_EraseRootFromParent_Done,
     /* 1257966 */   // Label 18167: @1257966
     /* 1257966 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1258050), // Rule ID 7922 //
     /* 1257971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258049 */     // GIR_Coverage, 7922,
     /* 1258049 */     GIR_EraseRootFromParent_Done,
     /* 1258050 */   // Label 18168: @1258050
     /* 1258050 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1258134), // Rule ID 7923 //
     /* 1258055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1258072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258133 */     // GIR_Coverage, 7923,
     /* 1258133 */     GIR_EraseRootFromParent_Done,
     /* 1258134 */   // Label 18169: @1258134
     /* 1258134 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1258218), // Rule ID 7926 //
     /* 1258139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258217 */     // GIR_Coverage, 7926,
     /* 1258217 */     GIR_EraseRootFromParent_Done,
     /* 1258218 */   // Label 18170: @1258218
     /* 1258218 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1258302), // Rule ID 7927 //
     /* 1258223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258301 */     // GIR_Coverage, 7927,
     /* 1258301 */     GIR_EraseRootFromParent_Done,
     /* 1258302 */   // Label 18171: @1258302
     /* 1258302 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1258386), // Rule ID 7930 //
     /* 1258307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1258310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258385 */     // GIR_Coverage, 7930,
     /* 1258385 */     GIR_EraseRootFromParent_Done,
     /* 1258386 */   // Label 18172: @1258386
     /* 1258386 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1258470), // Rule ID 7931 //
     /* 1258391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1258394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1258447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258469 */     // GIR_Coverage, 7931,
     /* 1258469 */     GIR_EraseRootFromParent_Done,
     /* 1258470 */   // Label 18173: @1258470
     /* 1258470 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1258554), // Rule ID 7934 //
     /* 1258475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258553 */     // GIR_Coverage, 7934,
     /* 1258553 */     GIR_EraseRootFromParent_Done,
     /* 1258554 */   // Label 18174: @1258554
     /* 1258554 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1258638), // Rule ID 7935 //
     /* 1258559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258637 */     // GIR_Coverage, 7935,
     /* 1258637 */     GIR_EraseRootFromParent_Done,
     /* 1258638 */   // Label 18175: @1258638
     /* 1258638 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1258722), // Rule ID 7938 //
     /* 1258643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258721 */     // GIR_Coverage, 7938,
     /* 1258721 */     GIR_EraseRootFromParent_Done,
     /* 1258722 */   // Label 18176: @1258722
     /* 1258722 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1258806), // Rule ID 7939 //
     /* 1258727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258780 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258805 */     // GIR_Coverage, 7939,
     /* 1258805 */     GIR_EraseRootFromParent_Done,
     /* 1258806 */   // Label 18177: @1258806
     /* 1258806 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1258890), // Rule ID 7942 //
     /* 1258811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258864 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258889 */     // GIR_Coverage, 7942,
     /* 1258889 */     GIR_EraseRootFromParent_Done,
     /* 1258890 */   // Label 18178: @1258890
     /* 1258890 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1258974), // Rule ID 7943 //
     /* 1258895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258948 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258973 */     // GIR_Coverage, 7943,
     /* 1258973 */     GIR_EraseRootFromParent_Done,
     /* 1258974 */   // Label 18179: @1258974
     /* 1258974 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1259058), // Rule ID 7946 //
     /* 1258979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259057 */     // GIR_Coverage, 7946,
     /* 1259057 */     GIR_EraseRootFromParent_Done,
     /* 1259058 */   // Label 18180: @1259058
     /* 1259058 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1259142), // Rule ID 7947 //
     /* 1259063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259141 */     // GIR_Coverage, 7947,
     /* 1259141 */     GIR_EraseRootFromParent_Done,
     /* 1259142 */   // Label 18181: @1259142
     /* 1259142 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1259226), // Rule ID 7950 //
     /* 1259147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259225 */     // GIR_Coverage, 7950,
     /* 1259225 */     GIR_EraseRootFromParent_Done,
     /* 1259226 */   // Label 18182: @1259226
     /* 1259226 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1259310), // Rule ID 7951 //
     /* 1259231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259309 */     // GIR_Coverage, 7951,
     /* 1259309 */     GIR_EraseRootFromParent_Done,
     /* 1259310 */   // Label 18183: @1259310
     /* 1259310 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1259394), // Rule ID 7954 //
     /* 1259315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259368 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259393 */     // GIR_Coverage, 7954,
     /* 1259393 */     GIR_EraseRootFromParent_Done,
     /* 1259394 */   // Label 18184: @1259394
     /* 1259394 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1259478), // Rule ID 7955 //
     /* 1259399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259452 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259477 */     // GIR_Coverage, 7955,
     /* 1259477 */     GIR_EraseRootFromParent_Done,
     /* 1259478 */   // Label 18185: @1259478
     /* 1259478 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1259562), // Rule ID 7958 //
     /* 1259483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259561 */     // GIR_Coverage, 7958,
     /* 1259561 */     GIR_EraseRootFromParent_Done,
     /* 1259562 */   // Label 18186: @1259562
     /* 1259562 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1259646), // Rule ID 7959 //
     /* 1259567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259645 */     // GIR_Coverage, 7959,
     /* 1259645 */     GIR_EraseRootFromParent_Done,
     /* 1259646 */   // Label 18187: @1259646
     /* 1259646 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1259730), // Rule ID 7962 //
     /* 1259651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259704 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259729 */     // GIR_Coverage, 7962,
     /* 1259729 */     GIR_EraseRootFromParent_Done,
     /* 1259730 */   // Label 18188: @1259730
     /* 1259730 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1259814), // Rule ID 7963 //
     /* 1259735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259813 */     // GIR_Coverage, 7963,
     /* 1259813 */     GIR_EraseRootFromParent_Done,
     /* 1259814 */   // Label 18189: @1259814
     /* 1259814 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1259898), // Rule ID 7966 //
     /* 1259819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259897 */     // GIR_Coverage, 7966,
     /* 1259897 */     GIR_EraseRootFromParent_Done,
     /* 1259898 */   // Label 18190: @1259898
     /* 1259898 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1259982), // Rule ID 7967 //
     /* 1259903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259981 */     // GIR_Coverage, 7967,
     /* 1259981 */     GIR_EraseRootFromParent_Done,
     /* 1259982 */   // Label 18191: @1259982
     /* 1259982 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1260066), // Rule ID 7970 //
     /* 1259987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1260043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260065 */     // GIR_Coverage, 7970,
     /* 1260065 */     GIR_EraseRootFromParent_Done,
     /* 1260066 */   // Label 18192: @1260066
     /* 1260066 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1260150), // Rule ID 7971 //
     /* 1260071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1260127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260149 */     // GIR_Coverage, 7971,
     /* 1260149 */     GIR_EraseRootFromParent_Done,
     /* 1260150 */   // Label 18193: @1260150
     /* 1260150 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1260234), // Rule ID 7974 //
     /* 1260155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1260211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260233 */     // GIR_Coverage, 7974,
     /* 1260233 */     GIR_EraseRootFromParent_Done,
     /* 1260234 */   // Label 18194: @1260234
     /* 1260234 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1260318), // Rule ID 7975 //
     /* 1260239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1260295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260317 */     // GIR_Coverage, 7975,
     /* 1260317 */     GIR_EraseRootFromParent_Done,
     /* 1260318 */   // Label 18195: @1260318
     /* 1260318 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1260402), // Rule ID 7978 //
     /* 1260323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1260379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260401 */     // GIR_Coverage, 7978,
     /* 1260401 */     GIR_EraseRootFromParent_Done,
     /* 1260402 */   // Label 18196: @1260402
     /* 1260402 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1260486), // Rule ID 7979 //
     /* 1260407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1260415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1260463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260485 */     // GIR_Coverage, 7979,
     /* 1260485 */     GIR_EraseRootFromParent_Done,
     /* 1260486 */   // Label 18197: @1260486
     /* 1260486 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1260570), // Rule ID 8070 //
     /* 1260491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260569 */     // GIR_Coverage, 8070,
     /* 1260569 */     GIR_EraseRootFromParent_Done,
     /* 1260570 */   // Label 18198: @1260570
     /* 1260570 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1260654), // Rule ID 8071 //
     /* 1260575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260653 */     // GIR_Coverage, 8071,
     /* 1260653 */     GIR_EraseRootFromParent_Done,
     /* 1260654 */   // Label 18199: @1260654
     /* 1260654 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1260738), // Rule ID 8074 //
     /* 1260659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260737 */     // GIR_Coverage, 8074,
     /* 1260737 */     GIR_EraseRootFromParent_Done,
     /* 1260738 */   // Label 18200: @1260738
     /* 1260738 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1260822), // Rule ID 8075 //
     /* 1260743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260821 */     // GIR_Coverage, 8075,
     /* 1260821 */     GIR_EraseRootFromParent_Done,
     /* 1260822 */   // Label 18201: @1260822
     /* 1260822 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1260906), // Rule ID 8078 //
     /* 1260827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260905 */     // GIR_Coverage, 8078,
     /* 1260905 */     GIR_EraseRootFromParent_Done,
     /* 1260906 */   // Label 18202: @1260906
     /* 1260906 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1260990), // Rule ID 8079 //
     /* 1260911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260989 */     // GIR_Coverage, 8079,
     /* 1260989 */     GIR_EraseRootFromParent_Done,
     /* 1260990 */   // Label 18203: @1260990
     /* 1260990 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1261074), // Rule ID 8082 //
     /* 1260995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1261051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261073 */     // GIR_Coverage, 8082,
     /* 1261073 */     GIR_EraseRootFromParent_Done,
     /* 1261074 */   // Label 18204: @1261074
     /* 1261074 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1261158), // Rule ID 8083 //
     /* 1261079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1261135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261157 */     // GIR_Coverage, 8083,
     /* 1261157 */     GIR_EraseRootFromParent_Done,
     /* 1261158 */   // Label 18205: @1261158
     /* 1261158 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1261242), // Rule ID 8086 //
     /* 1261163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261241 */     // GIR_Coverage, 8086,
     /* 1261241 */     GIR_EraseRootFromParent_Done,
     /* 1261242 */   // Label 18206: @1261242
     /* 1261242 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1261326), // Rule ID 8087 //
     /* 1261247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261325 */     // GIR_Coverage, 8087,
     /* 1261325 */     GIR_EraseRootFromParent_Done,
     /* 1261326 */   // Label 18207: @1261326
     /* 1261326 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1261410), // Rule ID 8090 //
     /* 1261331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261409 */     // GIR_Coverage, 8090,
     /* 1261409 */     GIR_EraseRootFromParent_Done,
     /* 1261410 */   // Label 18208: @1261410
     /* 1261410 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1261494), // Rule ID 8091 //
     /* 1261415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261493 */     // GIR_Coverage, 8091,
     /* 1261493 */     GIR_EraseRootFromParent_Done,
     /* 1261494 */   // Label 18209: @1261494
     /* 1261494 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1261578), // Rule ID 8094 //
     /* 1261499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261577 */     // GIR_Coverage, 8094,
     /* 1261577 */     GIR_EraseRootFromParent_Done,
     /* 1261578 */   // Label 18210: @1261578
     /* 1261578 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1261662), // Rule ID 8095 //
     /* 1261583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261661 */     // GIR_Coverage, 8095,
     /* 1261661 */     GIR_EraseRootFromParent_Done,
     /* 1261662 */   // Label 18211: @1261662
     /* 1261662 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1261746), // Rule ID 8098 //
     /* 1261667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261745 */     // GIR_Coverage, 8098,
     /* 1261745 */     GIR_EraseRootFromParent_Done,
     /* 1261746 */   // Label 18212: @1261746
     /* 1261746 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1261830), // Rule ID 8099 //
     /* 1261751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261829 */     // GIR_Coverage, 8099,
     /* 1261829 */     GIR_EraseRootFromParent_Done,
     /* 1261830 */   // Label 18213: @1261830
     /* 1261830 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1261914), // Rule ID 8102 //
     /* 1261835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261913 */     // GIR_Coverage, 8102,
     /* 1261913 */     GIR_EraseRootFromParent_Done,
     /* 1261914 */   // Label 18214: @1261914
     /* 1261914 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1261998), // Rule ID 8103 //
     /* 1261919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261997 */     // GIR_Coverage, 8103,
     /* 1261997 */     GIR_EraseRootFromParent_Done,
     /* 1261998 */   // Label 18215: @1261998
     /* 1261998 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1262082), // Rule ID 8106 //
     /* 1262003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1262006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1262059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262081 */     // GIR_Coverage, 8106,
     /* 1262081 */     GIR_EraseRootFromParent_Done,
     /* 1262082 */   // Label 18216: @1262082
     /* 1262082 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1262166), // Rule ID 8107 //
     /* 1262087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1262090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1262143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262165 */     // GIR_Coverage, 8107,
     /* 1262165 */     GIR_EraseRootFromParent_Done,
     /* 1262166 */   // Label 18217: @1262166
     /* 1262166 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1262250), // Rule ID 8110 //
     /* 1262171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262249 */     // GIR_Coverage, 8110,
     /* 1262249 */     GIR_EraseRootFromParent_Done,
     /* 1262250 */   // Label 18218: @1262250
     /* 1262250 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1262334), // Rule ID 8111 //
     /* 1262255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262333 */     // GIR_Coverage, 8111,
     /* 1262333 */     GIR_EraseRootFromParent_Done,
     /* 1262334 */   // Label 18219: @1262334
     /* 1262334 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1262418), // Rule ID 8114 //
     /* 1262339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262392 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262417 */     // GIR_Coverage, 8114,
     /* 1262417 */     GIR_EraseRootFromParent_Done,
     /* 1262418 */   // Label 18220: @1262418
     /* 1262418 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1262502), // Rule ID 8115 //
     /* 1262423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262501 */     // GIR_Coverage, 8115,
     /* 1262501 */     GIR_EraseRootFromParent_Done,
     /* 1262502 */   // Label 18221: @1262502
     /* 1262502 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1262586), // Rule ID 8118 //
     /* 1262507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262560 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262585 */     // GIR_Coverage, 8118,
     /* 1262585 */     GIR_EraseRootFromParent_Done,
     /* 1262586 */   // Label 18222: @1262586
     /* 1262586 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1262670), // Rule ID 8119 //
     /* 1262591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262644 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262669 */     // GIR_Coverage, 8119,
     /* 1262669 */     GIR_EraseRootFromParent_Done,
     /* 1262670 */   // Label 18223: @1262670
     /* 1262670 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1262754), // Rule ID 8122 //
     /* 1262675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262753 */     // GIR_Coverage, 8122,
     /* 1262753 */     GIR_EraseRootFromParent_Done,
     /* 1262754 */   // Label 18224: @1262754
     /* 1262754 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1262838), // Rule ID 8123 //
     /* 1262759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262837 */     // GIR_Coverage, 8123,
     /* 1262837 */     GIR_EraseRootFromParent_Done,
     /* 1262838 */   // Label 18225: @1262838
     /* 1262838 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1262922), // Rule ID 8126 //
     /* 1262843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262921 */     // GIR_Coverage, 8126,
     /* 1262921 */     GIR_EraseRootFromParent_Done,
     /* 1262922 */   // Label 18226: @1262922
     /* 1262922 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1263006), // Rule ID 8127 //
     /* 1262927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263005 */     // GIR_Coverage, 8127,
     /* 1263005 */     GIR_EraseRootFromParent_Done,
     /* 1263006 */   // Label 18227: @1263006
     /* 1263006 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1263090), // Rule ID 8130 //
     /* 1263011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263064 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263089 */     // GIR_Coverage, 8130,
     /* 1263089 */     GIR_EraseRootFromParent_Done,
     /* 1263090 */   // Label 18228: @1263090
     /* 1263090 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1263174), // Rule ID 8131 //
     /* 1263095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263173 */     // GIR_Coverage, 8131,
     /* 1263173 */     GIR_EraseRootFromParent_Done,
     /* 1263174 */   // Label 18229: @1263174
     /* 1263174 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1263258), // Rule ID 8134 //
     /* 1263179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263257 */     // GIR_Coverage, 8134,
     /* 1263257 */     GIR_EraseRootFromParent_Done,
     /* 1263258 */   // Label 18230: @1263258
     /* 1263258 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1263342), // Rule ID 8135 //
     /* 1263263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263341 */     // GIR_Coverage, 8135,
     /* 1263341 */     GIR_EraseRootFromParent_Done,
     /* 1263342 */   // Label 18231: @1263342
     /* 1263342 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1263426), // Rule ID 8138 //
     /* 1263347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263425 */     // GIR_Coverage, 8138,
     /* 1263425 */     GIR_EraseRootFromParent_Done,
     /* 1263426 */   // Label 18232: @1263426
     /* 1263426 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1263510), // Rule ID 8139 //
     /* 1263431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263509 */     // GIR_Coverage, 8139,
     /* 1263509 */     GIR_EraseRootFromParent_Done,
     /* 1263510 */   // Label 18233: @1263510
     /* 1263510 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1263594), // Rule ID 8142 //
     /* 1263515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263593 */     // GIR_Coverage, 8142,
     /* 1263593 */     GIR_EraseRootFromParent_Done,
     /* 1263594 */   // Label 18234: @1263594
     /* 1263594 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1263678), // Rule ID 8143 //
     /* 1263599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263677 */     // GIR_Coverage, 8143,
     /* 1263677 */     GIR_EraseRootFromParent_Done,
     /* 1263678 */   // Label 18235: @1263678
     /* 1263678 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1263762), // Rule ID 8146 //
     /* 1263683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263736 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263761 */     // GIR_Coverage, 8146,
     /* 1263761 */     GIR_EraseRootFromParent_Done,
     /* 1263762 */   // Label 18236: @1263762
     /* 1263762 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1263846), // Rule ID 8147 //
     /* 1263767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263845 */     // GIR_Coverage, 8147,
     /* 1263845 */     GIR_EraseRootFromParent_Done,
     /* 1263846 */   // Label 18237: @1263846
     /* 1263846 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1263930), // Rule ID 8150 //
     /* 1263851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263929 */     // GIR_Coverage, 8150,
     /* 1263929 */     GIR_EraseRootFromParent_Done,
     /* 1263930 */   // Label 18238: @1263930
     /* 1263930 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1264014), // Rule ID 8151 //
     /* 1263935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264013 */     // GIR_Coverage, 8151,
     /* 1264013 */     GIR_EraseRootFromParent_Done,
     /* 1264014 */   // Label 18239: @1264014
     /* 1264014 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1264098), // Rule ID 8154 //
     /* 1264019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1264075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264097 */     // GIR_Coverage, 8154,
     /* 1264097 */     GIR_EraseRootFromParent_Done,
     /* 1264098 */   // Label 18240: @1264098
     /* 1264098 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1264182), // Rule ID 8155 //
     /* 1264103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1264159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264181 */     // GIR_Coverage, 8155,
     /* 1264181 */     GIR_EraseRootFromParent_Done,
     /* 1264182 */   // Label 18241: @1264182
     /* 1264182 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1264266), // Rule ID 8158 //
     /* 1264187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1264243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264265 */     // GIR_Coverage, 8158,
     /* 1264265 */     GIR_EraseRootFromParent_Done,
     /* 1264266 */   // Label 18242: @1264266
     /* 1264266 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1264350), // Rule ID 8159 //
     /* 1264271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1264327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264349 */     // GIR_Coverage, 8159,
     /* 1264349 */     GIR_EraseRootFromParent_Done,
     /* 1264350 */   // Label 18243: @1264350
     /* 1264350 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1264434), // Rule ID 8162 //
     /* 1264355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264433 */     // GIR_Coverage, 8162,
     /* 1264433 */     GIR_EraseRootFromParent_Done,
     /* 1264434 */   // Label 18244: @1264434
     /* 1264434 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1264518), // Rule ID 8163 //
     /* 1264439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264517 */     // GIR_Coverage, 8163,
     /* 1264517 */     GIR_EraseRootFromParent_Done,
     /* 1264518 */   // Label 18245: @1264518
     /* 1264518 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1264602), // Rule ID 8166 //
     /* 1264523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264601 */     // GIR_Coverage, 8166,
     /* 1264601 */     GIR_EraseRootFromParent_Done,
     /* 1264602 */   // Label 18246: @1264602
     /* 1264602 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1264686), // Rule ID 8167 //
     /* 1264607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264685 */     // GIR_Coverage, 8167,
     /* 1264685 */     GIR_EraseRootFromParent_Done,
     /* 1264686 */   // Label 18247: @1264686
     /* 1264686 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1264770), // Rule ID 8170 //
     /* 1264691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264769 */     // GIR_Coverage, 8170,
     /* 1264769 */     GIR_EraseRootFromParent_Done,
     /* 1264770 */   // Label 18248: @1264770
     /* 1264770 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1264854), // Rule ID 8171 //
     /* 1264775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264828 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264853 */     // GIR_Coverage, 8171,
     /* 1264853 */     GIR_EraseRootFromParent_Done,
     /* 1264854 */   // Label 18249: @1264854
     /* 1264854 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1264938), // Rule ID 8174 //
     /* 1264859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264937 */     // GIR_Coverage, 8174,
     /* 1264937 */     GIR_EraseRootFromParent_Done,
     /* 1264938 */   // Label 18250: @1264938
     /* 1264938 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1265022), // Rule ID 8175 //
     /* 1264943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265021 */     // GIR_Coverage, 8175,
     /* 1265021 */     GIR_EraseRootFromParent_Done,
     /* 1265022 */   // Label 18251: @1265022
     /* 1265022 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1265106), // Rule ID 8178 //
     /* 1265027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1265083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265105 */     // GIR_Coverage, 8178,
     /* 1265105 */     GIR_EraseRootFromParent_Done,
     /* 1265106 */   // Label 18252: @1265106
     /* 1265106 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1265190), // Rule ID 8179 //
     /* 1265111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1265167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265189 */     // GIR_Coverage, 8179,
     /* 1265189 */     GIR_EraseRootFromParent_Done,
     /* 1265190 */   // Label 18253: @1265190
     /* 1265190 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1265274), // Rule ID 8182 //
     /* 1265195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265273 */     // GIR_Coverage, 8182,
     /* 1265273 */     GIR_EraseRootFromParent_Done,
     /* 1265274 */   // Label 18254: @1265274
     /* 1265274 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1265358), // Rule ID 8183 //
     /* 1265279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265357 */     // GIR_Coverage, 8183,
     /* 1265357 */     GIR_EraseRootFromParent_Done,
     /* 1265358 */   // Label 18255: @1265358
     /* 1265358 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1265442), // Rule ID 8186 //
     /* 1265363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265441 */     // GIR_Coverage, 8186,
     /* 1265441 */     GIR_EraseRootFromParent_Done,
     /* 1265442 */   // Label 18256: @1265442
     /* 1265442 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1265526), // Rule ID 8187 //
     /* 1265447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265525 */     // GIR_Coverage, 8187,
     /* 1265525 */     GIR_EraseRootFromParent_Done,
     /* 1265526 */   // Label 18257: @1265526
     /* 1265526 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1265610), // Rule ID 8190 //
     /* 1265531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265609 */     // GIR_Coverage, 8190,
     /* 1265609 */     GIR_EraseRootFromParent_Done,
     /* 1265610 */   // Label 18258: @1265610
     /* 1265610 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1265694), // Rule ID 8191 //
     /* 1265615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265693 */     // GIR_Coverage, 8191,
     /* 1265693 */     GIR_EraseRootFromParent_Done,
     /* 1265694 */   // Label 18259: @1265694
     /* 1265694 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1265778), // Rule ID 8194 //
     /* 1265699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265777 */     // GIR_Coverage, 8194,
     /* 1265777 */     GIR_EraseRootFromParent_Done,
     /* 1265778 */   // Label 18260: @1265778
     /* 1265778 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1265862), // Rule ID 8195 //
     /* 1265783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265836 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265861 */     // GIR_Coverage, 8195,
     /* 1265861 */     GIR_EraseRootFromParent_Done,
     /* 1265862 */   // Label 18261: @1265862
     /* 1265862 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1265946), // Rule ID 8198 //
     /* 1265867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265945 */     // GIR_Coverage, 8198,
     /* 1265945 */     GIR_EraseRootFromParent_Done,
     /* 1265946 */   // Label 18262: @1265946
     /* 1265946 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1266030), // Rule ID 8199 //
     /* 1265951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266004 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266029 */     // GIR_Coverage, 8199,
     /* 1266029 */     GIR_EraseRootFromParent_Done,
     /* 1266030 */   // Label 18263: @1266030
     /* 1266030 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1266114), // Rule ID 8202 //
     /* 1266035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266088 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266113 */     // GIR_Coverage, 8202,
     /* 1266113 */     GIR_EraseRootFromParent_Done,
     /* 1266114 */   // Label 18264: @1266114
     /* 1266114 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1266198), // Rule ID 8203 //
     /* 1266119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266172 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266197 */     // GIR_Coverage, 8203,
     /* 1266197 */     GIR_EraseRootFromParent_Done,
     /* 1266198 */   // Label 18265: @1266198
     /* 1266198 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1266282), // Rule ID 8206 //
     /* 1266203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266256 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266281 */     // GIR_Coverage, 8206,
     /* 1266281 */     GIR_EraseRootFromParent_Done,
     /* 1266282 */   // Label 18266: @1266282
     /* 1266282 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1266366), // Rule ID 8207 //
     /* 1266287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266340 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266365 */     // GIR_Coverage, 8207,
     /* 1266365 */     GIR_EraseRootFromParent_Done,
     /* 1266366 */   // Label 18267: @1266366
     /* 1266366 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1266450), // Rule ID 8210 //
     /* 1266371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266449 */     // GIR_Coverage, 8210,
     /* 1266449 */     GIR_EraseRootFromParent_Done,
     /* 1266450 */   // Label 18268: @1266450
     /* 1266450 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1266534), // Rule ID 8211 //
     /* 1266455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266533 */     // GIR_Coverage, 8211,
     /* 1266533 */     GIR_EraseRootFromParent_Done,
     /* 1266534 */   // Label 18269: @1266534
     /* 1266534 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1266618), // Rule ID 8214 //
     /* 1266539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266592 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266617 */     // GIR_Coverage, 8214,
     /* 1266617 */     GIR_EraseRootFromParent_Done,
     /* 1266618 */   // Label 18270: @1266618
     /* 1266618 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1266702), // Rule ID 8215 //
     /* 1266623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266701 */     // GIR_Coverage, 8215,
     /* 1266701 */     GIR_EraseRootFromParent_Done,
     /* 1266702 */   // Label 18271: @1266702
     /* 1266702 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1266786), // Rule ID 8218 //
     /* 1266707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266760 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266785 */     // GIR_Coverage, 8218,
     /* 1266785 */     GIR_EraseRootFromParent_Done,
     /* 1266786 */   // Label 18272: @1266786
     /* 1266786 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1266870), // Rule ID 8219 //
     /* 1266791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266844 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266869 */     // GIR_Coverage, 8219,
     /* 1266869 */     GIR_EraseRootFromParent_Done,
     /* 1266870 */   // Label 18273: @1266870
     /* 1266870 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1266954), // Rule ID 8222 //
     /* 1266875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266953 */     // GIR_Coverage, 8222,
     /* 1266953 */     GIR_EraseRootFromParent_Done,
     /* 1266954 */   // Label 18274: @1266954
     /* 1266954 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1267038), // Rule ID 8223 //
     /* 1266959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267037 */     // GIR_Coverage, 8223,
     /* 1267037 */     GIR_EraseRootFromParent_Done,
     /* 1267038 */   // Label 18275: @1267038
     /* 1267038 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1267122), // Rule ID 8226 //
     /* 1267043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267121 */     // GIR_Coverage, 8226,
     /* 1267121 */     GIR_EraseRootFromParent_Done,
     /* 1267122 */   // Label 18276: @1267122
     /* 1267122 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1267206), // Rule ID 8227 //
     /* 1267127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267205 */     // GIR_Coverage, 8227,
     /* 1267205 */     GIR_EraseRootFromParent_Done,
     /* 1267206 */   // Label 18277: @1267206
     /* 1267206 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1267290), // Rule ID 8230 //
     /* 1267211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267264 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267289 */     // GIR_Coverage, 8230,
     /* 1267289 */     GIR_EraseRootFromParent_Done,
     /* 1267290 */   // Label 18278: @1267290
     /* 1267290 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1267374), // Rule ID 8231 //
     /* 1267295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267373 */     // GIR_Coverage, 8231,
     /* 1267373 */     GIR_EraseRootFromParent_Done,
     /* 1267374 */   // Label 18279: @1267374
     /* 1267374 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1267458), // Rule ID 8234 //
     /* 1267379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267457 */     // GIR_Coverage, 8234,
     /* 1267457 */     GIR_EraseRootFromParent_Done,
     /* 1267458 */   // Label 18280: @1267458
     /* 1267458 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1267542), // Rule ID 8235 //
     /* 1267463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267541 */     // GIR_Coverage, 8235,
     /* 1267541 */     GIR_EraseRootFromParent_Done,
     /* 1267542 */   // Label 18281: @1267542
     /* 1267542 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1267626), // Rule ID 8238 //
     /* 1267547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267625 */     // GIR_Coverage, 8238,
     /* 1267625 */     GIR_EraseRootFromParent_Done,
     /* 1267626 */   // Label 18282: @1267626
     /* 1267626 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1267710), // Rule ID 8239 //
     /* 1267631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267709 */     // GIR_Coverage, 8239,
     /* 1267709 */     GIR_EraseRootFromParent_Done,
     /* 1267710 */   // Label 18283: @1267710
     /* 1267710 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1267794), // Rule ID 8242 //
     /* 1267715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267793 */     // GIR_Coverage, 8242,
     /* 1267793 */     GIR_EraseRootFromParent_Done,
     /* 1267794 */   // Label 18284: @1267794
     /* 1267794 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1267878), // Rule ID 8243 //
     /* 1267799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267877 */     // GIR_Coverage, 8243,
     /* 1267877 */     GIR_EraseRootFromParent_Done,
     /* 1267878 */   // Label 18285: @1267878
     /* 1267878 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1267962), // Rule ID 8334 //
     /* 1267883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267961 */     // GIR_Coverage, 8334,
     /* 1267961 */     GIR_EraseRootFromParent_Done,
     /* 1267962 */   // Label 18286: @1267962
     /* 1267962 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1268046), // Rule ID 8335 //
     /* 1267967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1268023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268045 */     // GIR_Coverage, 8335,
     /* 1268045 */     GIR_EraseRootFromParent_Done,
     /* 1268046 */   // Label 18287: @1268046
     /* 1268046 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1268130), // Rule ID 8338 //
     /* 1268051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268129 */     // GIR_Coverage, 8338,
     /* 1268129 */     GIR_EraseRootFromParent_Done,
     /* 1268130 */   // Label 18288: @1268130
     /* 1268130 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1268214), // Rule ID 8339 //
     /* 1268135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268213 */     // GIR_Coverage, 8339,
     /* 1268213 */     GIR_EraseRootFromParent_Done,
     /* 1268214 */   // Label 18289: @1268214
     /* 1268214 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1268298), // Rule ID 8342 //
     /* 1268219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268297 */     // GIR_Coverage, 8342,
     /* 1268297 */     GIR_EraseRootFromParent_Done,
     /* 1268298 */   // Label 18290: @1268298
     /* 1268298 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1268382), // Rule ID 8343 //
     /* 1268303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268381 */     // GIR_Coverage, 8343,
     /* 1268381 */     GIR_EraseRootFromParent_Done,
     /* 1268382 */   // Label 18291: @1268382
     /* 1268382 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1268466), // Rule ID 8346 //
     /* 1268387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268440 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268465 */     // GIR_Coverage, 8346,
     /* 1268465 */     GIR_EraseRootFromParent_Done,
     /* 1268466 */   // Label 18292: @1268466
     /* 1268466 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1268550), // Rule ID 8347 //
     /* 1268471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268524 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268549 */     // GIR_Coverage, 8347,
     /* 1268549 */     GIR_EraseRootFromParent_Done,
     /* 1268550 */   // Label 18293: @1268550
     /* 1268550 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1268634), // Rule ID 8350 //
     /* 1268555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268633 */     // GIR_Coverage, 8350,
     /* 1268633 */     GIR_EraseRootFromParent_Done,
     /* 1268634 */   // Label 18294: @1268634
     /* 1268634 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1268718), // Rule ID 8351 //
     /* 1268639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268717 */     // GIR_Coverage, 8351,
     /* 1268717 */     GIR_EraseRootFromParent_Done,
     /* 1268718 */   // Label 18295: @1268718
     /* 1268718 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1268802), // Rule ID 8354 //
     /* 1268723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268776 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268801 */     // GIR_Coverage, 8354,
     /* 1268801 */     GIR_EraseRootFromParent_Done,
     /* 1268802 */   // Label 18296: @1268802
     /* 1268802 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1268886), // Rule ID 8355 //
     /* 1268807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268885 */     // GIR_Coverage, 8355,
     /* 1268885 */     GIR_EraseRootFromParent_Done,
     /* 1268886 */   // Label 18297: @1268886
     /* 1268886 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1268970), // Rule ID 8358 //
     /* 1268891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268969 */     // GIR_Coverage, 8358,
     /* 1268969 */     GIR_EraseRootFromParent_Done,
     /* 1268970 */   // Label 18298: @1268970
     /* 1268970 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1269054), // Rule ID 8359 //
     /* 1268975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269053 */     // GIR_Coverage, 8359,
     /* 1269053 */     GIR_EraseRootFromParent_Done,
     /* 1269054 */   // Label 18299: @1269054
     /* 1269054 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1269138), // Rule ID 8362 //
     /* 1269059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269137 */     // GIR_Coverage, 8362,
     /* 1269137 */     GIR_EraseRootFromParent_Done,
     /* 1269138 */   // Label 18300: @1269138
     /* 1269138 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1269222), // Rule ID 8363 //
     /* 1269143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269221 */     // GIR_Coverage, 8363,
     /* 1269221 */     GIR_EraseRootFromParent_Done,
     /* 1269222 */   // Label 18301: @1269222
     /* 1269222 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1269306), // Rule ID 8366 //
     /* 1269227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269305 */     // GIR_Coverage, 8366,
     /* 1269305 */     GIR_EraseRootFromParent_Done,
     /* 1269306 */   // Label 18302: @1269306
     /* 1269306 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1269390), // Rule ID 8367 //
     /* 1269311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269389 */     // GIR_Coverage, 8367,
     /* 1269389 */     GIR_EraseRootFromParent_Done,
     /* 1269390 */   // Label 18303: @1269390
     /* 1269390 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1269474), // Rule ID 8370 //
     /* 1269395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1269398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269473 */     // GIR_Coverage, 8370,
     /* 1269473 */     GIR_EraseRootFromParent_Done,
     /* 1269474 */   // Label 18304: @1269474
     /* 1269474 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1269558), // Rule ID 8371 //
     /* 1269479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269557 */     // GIR_Coverage, 8371,
     /* 1269557 */     GIR_EraseRootFromParent_Done,
     /* 1269558 */   // Label 18305: @1269558
     /* 1269558 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1269642), // Rule ID 8374 //
     /* 1269563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269641 */     // GIR_Coverage, 8374,
     /* 1269641 */     GIR_EraseRootFromParent_Done,
     /* 1269642 */   // Label 18306: @1269642
     /* 1269642 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1269726), // Rule ID 8375 //
     /* 1269647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269725 */     // GIR_Coverage, 8375,
     /* 1269725 */     GIR_EraseRootFromParent_Done,
     /* 1269726 */   // Label 18307: @1269726
     /* 1269726 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1269810), // Rule ID 8378 //
     /* 1269731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269784 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269809 */     // GIR_Coverage, 8378,
     /* 1269809 */     GIR_EraseRootFromParent_Done,
     /* 1269810 */   // Label 18308: @1269810
     /* 1269810 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1269894), // Rule ID 8379 //
     /* 1269815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269868 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269893 */     // GIR_Coverage, 8379,
     /* 1269893 */     GIR_EraseRootFromParent_Done,
     /* 1269894 */   // Label 18309: @1269894
     /* 1269894 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1269978), // Rule ID 8382 //
     /* 1269899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269952 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269977 */     // GIR_Coverage, 8382,
     /* 1269977 */     GIR_EraseRootFromParent_Done,
     /* 1269978 */   // Label 18310: @1269978
     /* 1269978 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1270062), // Rule ID 8383 //
     /* 1269983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1270003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270036 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270061 */     // GIR_Coverage, 8383,
     /* 1270061 */     GIR_EraseRootFromParent_Done,
     /* 1270062 */   // Label 18311: @1270062
     /* 1270062 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1270146), // Rule ID 8386 //
     /* 1270067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270145 */     // GIR_Coverage, 8386,
     /* 1270145 */     GIR_EraseRootFromParent_Done,
     /* 1270146 */   // Label 18312: @1270146
     /* 1270146 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1270230), // Rule ID 8387 //
     /* 1270151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270229 */     // GIR_Coverage, 8387,
     /* 1270229 */     GIR_EraseRootFromParent_Done,
     /* 1270230 */   // Label 18313: @1270230
     /* 1270230 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1270314), // Rule ID 8390 //
     /* 1270235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270288 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270313 */     // GIR_Coverage, 8390,
     /* 1270313 */     GIR_EraseRootFromParent_Done,
     /* 1270314 */   // Label 18314: @1270314
     /* 1270314 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1270398), // Rule ID 8391 //
     /* 1270319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270397 */     // GIR_Coverage, 8391,
     /* 1270397 */     GIR_EraseRootFromParent_Done,
     /* 1270398 */   // Label 18315: @1270398
     /* 1270398 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1270482), // Rule ID 8394 //
     /* 1270403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270456 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270481 */     // GIR_Coverage, 8394,
     /* 1270481 */     GIR_EraseRootFromParent_Done,
     /* 1270482 */   // Label 18316: @1270482
     /* 1270482 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1270566), // Rule ID 8395 //
     /* 1270487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270565 */     // GIR_Coverage, 8395,
     /* 1270565 */     GIR_EraseRootFromParent_Done,
     /* 1270566 */   // Label 18317: @1270566
     /* 1270566 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1270650), // Rule ID 8398 //
     /* 1270571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270624 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270649 */     // GIR_Coverage, 8398,
     /* 1270649 */     GIR_EraseRootFromParent_Done,
     /* 1270650 */   // Label 18318: @1270650
     /* 1270650 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1270734), // Rule ID 8399 //
     /* 1270655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270733 */     // GIR_Coverage, 8399,
     /* 1270733 */     GIR_EraseRootFromParent_Done,
     /* 1270734 */   // Label 18319: @1270734
     /* 1270734 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1270818), // Rule ID 8402 //
     /* 1270739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270817 */     // GIR_Coverage, 8402,
     /* 1270817 */     GIR_EraseRootFromParent_Done,
     /* 1270818 */   // Label 18320: @1270818
     /* 1270818 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1270902), // Rule ID 8403 //
     /* 1270823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270901 */     // GIR_Coverage, 8403,
     /* 1270901 */     GIR_EraseRootFromParent_Done,
     /* 1270902 */   // Label 18321: @1270902
     /* 1270902 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1270986), // Rule ID 8406 //
     /* 1270907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270985 */     // GIR_Coverage, 8406,
     /* 1270985 */     GIR_EraseRootFromParent_Done,
     /* 1270986 */   // Label 18322: @1270986
     /* 1270986 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1271070), // Rule ID 8407 //
     /* 1270991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1271011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271069 */     // GIR_Coverage, 8407,
     /* 1271069 */     GIR_EraseRootFromParent_Done,
     /* 1271070 */   // Label 18323: @1271070
     /* 1271070 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1271154), // Rule ID 8410 //
     /* 1271075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1271131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271153 */     // GIR_Coverage, 8410,
     /* 1271153 */     GIR_EraseRootFromParent_Done,
     /* 1271154 */   // Label 18324: @1271154
     /* 1271154 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1271238), // Rule ID 8411 //
     /* 1271159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1271215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271237 */     // GIR_Coverage, 8411,
     /* 1271237 */     GIR_EraseRootFromParent_Done,
     /* 1271238 */   // Label 18325: @1271238
     /* 1271238 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1271322), // Rule ID 8414 //
     /* 1271243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1271299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271321 */     // GIR_Coverage, 8414,
     /* 1271321 */     GIR_EraseRootFromParent_Done,
     /* 1271322 */   // Label 18326: @1271322
     /* 1271322 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1271406), // Rule ID 8415 //
     /* 1271327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1271383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271405 */     // GIR_Coverage, 8415,
     /* 1271405 */     GIR_EraseRootFromParent_Done,
     /* 1271406 */   // Label 18327: @1271406
     /* 1271406 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1271490), // Rule ID 8418 //
     /* 1271411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271464 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271489 */     // GIR_Coverage, 8418,
     /* 1271489 */     GIR_EraseRootFromParent_Done,
     /* 1271490 */   // Label 18328: @1271490
     /* 1271490 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1271574), // Rule ID 8419 //
     /* 1271495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271573 */     // GIR_Coverage, 8419,
     /* 1271573 */     GIR_EraseRootFromParent_Done,
     /* 1271574 */   // Label 18329: @1271574
     /* 1271574 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1271658), // Rule ID 8422 //
     /* 1271579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271657 */     // GIR_Coverage, 8422,
     /* 1271657 */     GIR_EraseRootFromParent_Done,
     /* 1271658 */   // Label 18330: @1271658
     /* 1271658 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1271742), // Rule ID 8423 //
     /* 1271663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271741 */     // GIR_Coverage, 8423,
     /* 1271741 */     GIR_EraseRootFromParent_Done,
     /* 1271742 */   // Label 18331: @1271742
     /* 1271742 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1271826), // Rule ID 8426 //
     /* 1271747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271825 */     // GIR_Coverage, 8426,
     /* 1271825 */     GIR_EraseRootFromParent_Done,
     /* 1271826 */   // Label 18332: @1271826
     /* 1271826 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1271910), // Rule ID 8427 //
     /* 1271831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271909 */     // GIR_Coverage, 8427,
     /* 1271909 */     GIR_EraseRootFromParent_Done,
     /* 1271910 */   // Label 18333: @1271910
     /* 1271910 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1271994), // Rule ID 8430 //
     /* 1271915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271993 */     // GIR_Coverage, 8430,
     /* 1271993 */     GIR_EraseRootFromParent_Done,
     /* 1271994 */   // Label 18334: @1271994
     /* 1271994 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1272078), // Rule ID 8431 //
     /* 1271999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272077 */     // GIR_Coverage, 8431,
     /* 1272077 */     GIR_EraseRootFromParent_Done,
     /* 1272078 */   // Label 18335: @1272078
     /* 1272078 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1272162), // Rule ID 8434 //
     /* 1272083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1272139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272161 */     // GIR_Coverage, 8434,
     /* 1272161 */     GIR_EraseRootFromParent_Done,
     /* 1272162 */   // Label 18336: @1272162
     /* 1272162 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1272246), // Rule ID 8435 //
     /* 1272167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1272223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272245 */     // GIR_Coverage, 8435,
     /* 1272245 */     GIR_EraseRootFromParent_Done,
     /* 1272246 */   // Label 18337: @1272246
     /* 1272246 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1272330), // Rule ID 8438 //
     /* 1272251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272329 */     // GIR_Coverage, 8438,
     /* 1272329 */     GIR_EraseRootFromParent_Done,
     /* 1272330 */   // Label 18338: @1272330
     /* 1272330 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1272414), // Rule ID 8439 //
     /* 1272335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272388 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272413 */     // GIR_Coverage, 8439,
     /* 1272413 */     GIR_EraseRootFromParent_Done,
     /* 1272414 */   // Label 18339: @1272414
     /* 1272414 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1272498), // Rule ID 8442 //
     /* 1272419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272497 */     // GIR_Coverage, 8442,
     /* 1272497 */     GIR_EraseRootFromParent_Done,
     /* 1272498 */   // Label 18340: @1272498
     /* 1272498 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1272582), // Rule ID 8443 //
     /* 1272503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272556 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272581 */     // GIR_Coverage, 8443,
     /* 1272581 */     GIR_EraseRootFromParent_Done,
     /* 1272582 */   // Label 18341: @1272582
     /* 1272582 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1272666), // Rule ID 8446 //
     /* 1272587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272665 */     // GIR_Coverage, 8446,
     /* 1272665 */     GIR_EraseRootFromParent_Done,
     /* 1272666 */   // Label 18342: @1272666
     /* 1272666 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1272750), // Rule ID 8447 //
     /* 1272671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272749 */     // GIR_Coverage, 8447,
     /* 1272749 */     GIR_EraseRootFromParent_Done,
     /* 1272750 */   // Label 18343: @1272750
     /* 1272750 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1272834), // Rule ID 8450 //
     /* 1272755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272833 */     // GIR_Coverage, 8450,
     /* 1272833 */     GIR_EraseRootFromParent_Done,
     /* 1272834 */   // Label 18344: @1272834
     /* 1272834 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1272918), // Rule ID 8451 //
     /* 1272839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272917 */     // GIR_Coverage, 8451,
     /* 1272917 */     GIR_EraseRootFromParent_Done,
     /* 1272918 */   // Label 18345: @1272918
     /* 1272918 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1273002), // Rule ID 8454 //
     /* 1272923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273001 */     // GIR_Coverage, 8454,
     /* 1273001 */     GIR_EraseRootFromParent_Done,
     /* 1273002 */   // Label 18346: @1273002
     /* 1273002 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1273086), // Rule ID 8455 //
     /* 1273007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273085 */     // GIR_Coverage, 8455,
     /* 1273085 */     GIR_EraseRootFromParent_Done,
     /* 1273086 */   // Label 18347: @1273086
     /* 1273086 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1273170), // Rule ID 8458 //
     /* 1273091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1273094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273169 */     // GIR_Coverage, 8458,
     /* 1273169 */     GIR_EraseRootFromParent_Done,
     /* 1273170 */   // Label 18348: @1273170
     /* 1273170 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1273254), // Rule ID 8459 //
     /* 1273175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1273178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1273231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273253 */     // GIR_Coverage, 8459,
     /* 1273253 */     GIR_EraseRootFromParent_Done,
     /* 1273254 */   // Label 18349: @1273254
     /* 1273254 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1273338), // Rule ID 8462 //
     /* 1273259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273337 */     // GIR_Coverage, 8462,
     /* 1273337 */     GIR_EraseRootFromParent_Done,
     /* 1273338 */   // Label 18350: @1273338
     /* 1273338 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1273422), // Rule ID 8463 //
     /* 1273343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273421 */     // GIR_Coverage, 8463,
     /* 1273421 */     GIR_EraseRootFromParent_Done,
     /* 1273422 */   // Label 18351: @1273422
     /* 1273422 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1273506), // Rule ID 8466 //
     /* 1273427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273480 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273505 */     // GIR_Coverage, 8466,
     /* 1273505 */     GIR_EraseRootFromParent_Done,
     /* 1273506 */   // Label 18352: @1273506
     /* 1273506 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1273590), // Rule ID 8467 //
     /* 1273511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273564 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273589 */     // GIR_Coverage, 8467,
     /* 1273589 */     GIR_EraseRootFromParent_Done,
     /* 1273590 */   // Label 18353: @1273590
     /* 1273590 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1273674), // Rule ID 8470 //
     /* 1273595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273648 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273673 */     // GIR_Coverage, 8470,
     /* 1273673 */     GIR_EraseRootFromParent_Done,
     /* 1273674 */   // Label 18354: @1273674
     /* 1273674 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1273758), // Rule ID 8471 //
     /* 1273679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273732 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273757 */     // GIR_Coverage, 8471,
     /* 1273757 */     GIR_EraseRootFromParent_Done,
     /* 1273758 */   // Label 18355: @1273758
     /* 1273758 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1273842), // Rule ID 8474 //
     /* 1273763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273841 */     // GIR_Coverage, 8474,
     /* 1273841 */     GIR_EraseRootFromParent_Done,
     /* 1273842 */   // Label 18356: @1273842
     /* 1273842 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1273926), // Rule ID 8475 //
     /* 1273847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273925 */     // GIR_Coverage, 8475,
     /* 1273925 */     GIR_EraseRootFromParent_Done,
     /* 1273926 */   // Label 18357: @1273926
     /* 1273926 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1274010), // Rule ID 8478 //
     /* 1273931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274009 */     // GIR_Coverage, 8478,
     /* 1274009 */     GIR_EraseRootFromParent_Done,
     /* 1274010 */   // Label 18358: @1274010
     /* 1274010 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1274094), // Rule ID 8479 //
     /* 1274015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274068 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274093 */     // GIR_Coverage, 8479,
     /* 1274093 */     GIR_EraseRootFromParent_Done,
     /* 1274094 */   // Label 18359: @1274094
     /* 1274094 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1274178), // Rule ID 8482 //
     /* 1274099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274152 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274177 */     // GIR_Coverage, 8482,
     /* 1274177 */     GIR_EraseRootFromParent_Done,
     /* 1274178 */   // Label 18360: @1274178
     /* 1274178 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1274262), // Rule ID 8483 //
     /* 1274183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274236 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274261 */     // GIR_Coverage, 8483,
     /* 1274261 */     GIR_EraseRootFromParent_Done,
     /* 1274262 */   // Label 18361: @1274262
     /* 1274262 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1274346), // Rule ID 8486 //
     /* 1274267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274345 */     // GIR_Coverage, 8486,
     /* 1274345 */     GIR_EraseRootFromParent_Done,
     /* 1274346 */   // Label 18362: @1274346
     /* 1274346 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1274430), // Rule ID 8487 //
     /* 1274351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274429 */     // GIR_Coverage, 8487,
     /* 1274429 */     GIR_EraseRootFromParent_Done,
     /* 1274430 */   // Label 18363: @1274430
     /* 1274430 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1274514), // Rule ID 8490 //
     /* 1274435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274513 */     // GIR_Coverage, 8490,
     /* 1274513 */     GIR_EraseRootFromParent_Done,
     /* 1274514 */   // Label 18364: @1274514
     /* 1274514 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1274598), // Rule ID 8491 //
     /* 1274519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274597 */     // GIR_Coverage, 8491,
     /* 1274597 */     GIR_EraseRootFromParent_Done,
     /* 1274598 */   // Label 18365: @1274598
     /* 1274598 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1274682), // Rule ID 8494 //
     /* 1274603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274656 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274681 */     // GIR_Coverage, 8494,
     /* 1274681 */     GIR_EraseRootFromParent_Done,
     /* 1274682 */   // Label 18366: @1274682
     /* 1274682 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1274766), // Rule ID 8495 //
     /* 1274687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274765 */     // GIR_Coverage, 8495,
     /* 1274765 */     GIR_EraseRootFromParent_Done,
     /* 1274766 */   // Label 18367: @1274766
     /* 1274766 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1274850), // Rule ID 8498 //
     /* 1274771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274849 */     // GIR_Coverage, 8498,
     /* 1274849 */     GIR_EraseRootFromParent_Done,
     /* 1274850 */   // Label 18368: @1274850
     /* 1274850 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1274934), // Rule ID 8499 //
     /* 1274855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274933 */     // GIR_Coverage, 8499,
     /* 1274933 */     GIR_EraseRootFromParent_Done,
     /* 1274934 */   // Label 18369: @1274934
     /* 1274934 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1275018), // Rule ID 8502 //
     /* 1274939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275017 */     // GIR_Coverage, 8502,
     /* 1275017 */     GIR_EraseRootFromParent_Done,
     /* 1275018 */   // Label 18370: @1275018
     /* 1275018 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1275102), // Rule ID 8503 //
     /* 1275023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1275079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275101 */     // GIR_Coverage, 8503,
     /* 1275101 */     GIR_EraseRootFromParent_Done,
     /* 1275102 */   // Label 18371: @1275102
     /* 1275102 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1275186), // Rule ID 8506 //
     /* 1275107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1275163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275185 */     // GIR_Coverage, 8506,
     /* 1275185 */     GIR_EraseRootFromParent_Done,
     /* 1275186 */   // Label 18372: @1275186
     /* 1275186 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1275270), // Rule ID 8507 //
     /* 1275191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1275199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1275247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275269 */     // GIR_Coverage, 8507,
     /* 1275269 */     GIR_EraseRootFromParent_Done,
     /* 1275270 */   // Label 18373: @1275270
     /* 1275270 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1275354), // Rule ID 8510 //
     /* 1275275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1275331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275353 */     // GIR_Coverage, 8510,
     /* 1275353 */     GIR_EraseRootFromParent_Done,
     /* 1275354 */   // Label 18374: @1275354
     /* 1275354 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1275438), // Rule ID 8511 //
     /* 1275359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1275415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275437 */     // GIR_Coverage, 8511,
     /* 1275437 */     GIR_EraseRootFromParent_Done,
     /* 1275438 */   // Label 18375: @1275438
     /* 1275438 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1275522), // Rule ID 8514 //
     /* 1275443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275521 */     // GIR_Coverage, 8514,
     /* 1275521 */     GIR_EraseRootFromParent_Done,
     /* 1275522 */   // Label 18376: @1275522
     /* 1275522 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1275606), // Rule ID 8515 //
     /* 1275527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275605 */     // GIR_Coverage, 8515,
     /* 1275605 */     GIR_EraseRootFromParent_Done,
     /* 1275606 */   // Label 18377: @1275606
     /* 1275606 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1275690), // Rule ID 8518 //
     /* 1275611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275664 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275689 */     // GIR_Coverage, 8518,
     /* 1275689 */     GIR_EraseRootFromParent_Done,
     /* 1275690 */   // Label 18378: @1275690
     /* 1275690 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1275774), // Rule ID 8519 //
     /* 1275695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275773 */     // GIR_Coverage, 8519,
     /* 1275773 */     GIR_EraseRootFromParent_Done,
     /* 1275774 */   // Label 18379: @1275774
     /* 1275774 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1275858), // Rule ID 8522 //
     /* 1275779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275857 */     // GIR_Coverage, 8522,
     /* 1275857 */     GIR_EraseRootFromParent_Done,
     /* 1275858 */   // Label 18380: @1275858
     /* 1275858 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1275942), // Rule ID 8523 //
     /* 1275863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275916 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275941 */     // GIR_Coverage, 8523,
     /* 1275941 */     GIR_EraseRootFromParent_Done,
     /* 1275942 */   // Label 18381: @1275942
     /* 1275942 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1276026), // Rule ID 8526 //
     /* 1275947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276025 */     // GIR_Coverage, 8526,
     /* 1276025 */     GIR_EraseRootFromParent_Done,
     /* 1276026 */   // Label 18382: @1276026
     /* 1276026 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1276110), // Rule ID 8527 //
     /* 1276031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1276051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276109 */     // GIR_Coverage, 8527,
     /* 1276109 */     GIR_EraseRootFromParent_Done,
     /* 1276110 */   // Label 18383: @1276110
     /* 1276110 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1276194), // Rule ID 8530 //
     /* 1276115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276193 */     // GIR_Coverage, 8530,
     /* 1276193 */     GIR_EraseRootFromParent_Done,
     /* 1276194 */   // Label 18384: @1276194
     /* 1276194 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1276278), // Rule ID 8531 //
     /* 1276199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1276255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276277 */     // GIR_Coverage, 8531,
     /* 1276277 */     GIR_EraseRootFromParent_Done,
     /* 1276278 */   // Label 18385: @1276278
     /* 1276278 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1276362), // Rule ID 8534 //
     /* 1276283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276361 */     // GIR_Coverage, 8534,
     /* 1276361 */     GIR_EraseRootFromParent_Done,
     /* 1276362 */   // Label 18386: @1276362
     /* 1276362 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1276446), // Rule ID 8535 //
     /* 1276367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276445 */     // GIR_Coverage, 8535,
     /* 1276445 */     GIR_EraseRootFromParent_Done,
     /* 1276446 */   // Label 18387: @1276446
     /* 1276446 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1276530), // Rule ID 8538 //
     /* 1276451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276529 */     // GIR_Coverage, 8538,
     /* 1276529 */     GIR_EraseRootFromParent_Done,
     /* 1276530 */   // Label 18388: @1276530
     /* 1276530 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1276614), // Rule ID 8539 //
     /* 1276535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276613 */     // GIR_Coverage, 8539,
     /* 1276613 */     GIR_EraseRootFromParent_Done,
     /* 1276614 */   // Label 18389: @1276614
     /* 1276614 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1276698), // Rule ID 8542 //
     /* 1276619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276697 */     // GIR_Coverage, 8542,
     /* 1276697 */     GIR_EraseRootFromParent_Done,
     /* 1276698 */   // Label 18390: @1276698
     /* 1276698 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1276782), // Rule ID 8543 //
     /* 1276703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276781 */     // GIR_Coverage, 8543,
     /* 1276781 */     GIR_EraseRootFromParent_Done,
     /* 1276782 */   // Label 18391: @1276782
     /* 1276782 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1276866), // Rule ID 8546 //
     /* 1276787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276865 */     // GIR_Coverage, 8546,
     /* 1276865 */     GIR_EraseRootFromParent_Done,
     /* 1276866 */   // Label 18392: @1276866
     /* 1276866 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1276950), // Rule ID 8547 //
     /* 1276871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276949 */     // GIR_Coverage, 8547,
     /* 1276949 */     GIR_EraseRootFromParent_Done,
     /* 1276950 */   // Label 18393: @1276950
     /* 1276950 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1277034), // Rule ID 8550 //
     /* 1276955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277033 */     // GIR_Coverage, 8550,
     /* 1277033 */     GIR_EraseRootFromParent_Done,
     /* 1277034 */   // Label 18394: @1277034
     /* 1277034 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1277118), // Rule ID 8551 //
     /* 1277039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1277059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277117 */     // GIR_Coverage, 8551,
     /* 1277117 */     GIR_EraseRootFromParent_Done,
     /* 1277118 */   // Label 18395: @1277118
     /* 1277118 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1277202), // Rule ID 8554 //
     /* 1277123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277176 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277201 */     // GIR_Coverage, 8554,
     /* 1277201 */     GIR_EraseRootFromParent_Done,
     /* 1277202 */   // Label 18396: @1277202
     /* 1277202 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1277286), // Rule ID 8555 //
     /* 1277207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277285 */     // GIR_Coverage, 8555,
     /* 1277285 */     GIR_EraseRootFromParent_Done,
     /* 1277286 */   // Label 18397: @1277286
     /* 1277286 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1277370), // Rule ID 8558 //
     /* 1277291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277344 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277369 */     // GIR_Coverage, 8558,
     /* 1277369 */     GIR_EraseRootFromParent_Done,
     /* 1277370 */   // Label 18398: @1277370
     /* 1277370 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1277454), // Rule ID 8559 //
     /* 1277375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277428 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277453 */     // GIR_Coverage, 8559,
     /* 1277453 */     GIR_EraseRootFromParent_Done,
     /* 1277454 */   // Label 18399: @1277454
     /* 1277454 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1277538), // Rule ID 8562 //
     /* 1277459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277537 */     // GIR_Coverage, 8562,
     /* 1277537 */     GIR_EraseRootFromParent_Done,
     /* 1277538 */   // Label 18400: @1277538
     /* 1277538 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1277622), // Rule ID 8563 //
     /* 1277543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277621 */     // GIR_Coverage, 8563,
     /* 1277621 */     GIR_EraseRootFromParent_Done,
     /* 1277622 */   // Label 18401: @1277622
     /* 1277622 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1277706), // Rule ID 8566 //
     /* 1277627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277705 */     // GIR_Coverage, 8566,
     /* 1277705 */     GIR_EraseRootFromParent_Done,
     /* 1277706 */   // Label 18402: @1277706
     /* 1277706 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1277790), // Rule ID 8567 //
     /* 1277711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277789 */     // GIR_Coverage, 8567,
     /* 1277789 */     GIR_EraseRootFromParent_Done,
     /* 1277790 */   // Label 18403: @1277790
     /* 1277790 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1277874), // Rule ID 8570 //
     /* 1277795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277848 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277873 */     // GIR_Coverage, 8570,
     /* 1277873 */     GIR_EraseRootFromParent_Done,
     /* 1277874 */   // Label 18404: @1277874
     /* 1277874 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1277958), // Rule ID 8571 //
     /* 1277879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277932 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277957 */     // GIR_Coverage, 8571,
     /* 1277957 */     GIR_EraseRootFromParent_Done,
     /* 1277958 */   // Label 18405: @1277958
     /* 1277958 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1278042), // Rule ID 8574 //
     /* 1277963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278041 */     // GIR_Coverage, 8574,
     /* 1278041 */     GIR_EraseRootFromParent_Done,
     /* 1278042 */   // Label 18406: @1278042
     /* 1278042 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1278126), // Rule ID 8575 //
     /* 1278047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1278067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278125 */     // GIR_Coverage, 8575,
     /* 1278125 */     GIR_EraseRootFromParent_Done,
     /* 1278126 */   // Label 18407: @1278126
     /* 1278126 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1278210), // Rule ID 8578 //
     /* 1278131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278184 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278209 */     // GIR_Coverage, 8578,
     /* 1278209 */     GIR_EraseRootFromParent_Done,
     /* 1278210 */   // Label 18408: @1278210
     /* 1278210 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1278294), // Rule ID 8579 //
     /* 1278215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278268 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278293 */     // GIR_Coverage, 8579,
     /* 1278293 */     GIR_EraseRootFromParent_Done,
     /* 1278294 */   // Label 18409: @1278294
     /* 1278294 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1278378), // Rule ID 8582 //
     /* 1278299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278377 */     // GIR_Coverage, 8582,
     /* 1278377 */     GIR_EraseRootFromParent_Done,
     /* 1278378 */   // Label 18410: @1278378
     /* 1278378 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1278462), // Rule ID 8583 //
     /* 1278383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278436 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278461 */     // GIR_Coverage, 8583,
     /* 1278461 */     GIR_EraseRootFromParent_Done,
     /* 1278462 */   // Label 18411: @1278462
     /* 1278462 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1278546), // Rule ID 8586 //
     /* 1278467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278545 */     // GIR_Coverage, 8586,
     /* 1278545 */     GIR_EraseRootFromParent_Done,
     /* 1278546 */   // Label 18412: @1278546
     /* 1278546 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1278630), // Rule ID 8587 //
     /* 1278551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278629 */     // GIR_Coverage, 8587,
     /* 1278629 */     GIR_EraseRootFromParent_Done,
     /* 1278630 */   // Label 18413: @1278630
     /* 1278630 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1278714), // Rule ID 8590 //
     /* 1278635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278688 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278713 */     // GIR_Coverage, 8590,
     /* 1278713 */     GIR_EraseRootFromParent_Done,
     /* 1278714 */   // Label 18414: @1278714
     /* 1278714 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1278798), // Rule ID 8591 //
     /* 1278719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278797 */     // GIR_Coverage, 8591,
     /* 1278797 */     GIR_EraseRootFromParent_Done,
     /* 1278798 */   // Label 18415: @1278798
     /* 1278798 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1278882), // Rule ID 8594 //
     /* 1278803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278881 */     // GIR_Coverage, 8594,
     /* 1278881 */     GIR_EraseRootFromParent_Done,
     /* 1278882 */   // Label 18416: @1278882
     /* 1278882 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1278966), // Rule ID 8595 //
     /* 1278887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278965 */     // GIR_Coverage, 8595,
     /* 1278965 */     GIR_EraseRootFromParent_Done,
     /* 1278966 */   // Label 18417: @1278966
     /* 1278966 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1279050), // Rule ID 8598 //
     /* 1278971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1279027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279049 */     // GIR_Coverage, 8598,
     /* 1279049 */     GIR_EraseRootFromParent_Done,
     /* 1279050 */   // Label 18418: @1279050
     /* 1279050 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1279134), // Rule ID 8599 //
     /* 1279055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1279111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279133 */     // GIR_Coverage, 8599,
     /* 1279133 */     GIR_EraseRootFromParent_Done,
     /* 1279134 */   // Label 18419: @1279134
     /* 1279134 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1279218), // Rule ID 8602 //
     /* 1279139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279217 */     // GIR_Coverage, 8602,
     /* 1279217 */     GIR_EraseRootFromParent_Done,
     /* 1279218 */   // Label 18420: @1279218
     /* 1279218 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1279302), // Rule ID 8603 //
     /* 1279223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279301 */     // GIR_Coverage, 8603,
     /* 1279301 */     GIR_EraseRootFromParent_Done,
     /* 1279302 */   // Label 18421: @1279302
     /* 1279302 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1279386), // Rule ID 8606 //
     /* 1279307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279385 */     // GIR_Coverage, 8606,
     /* 1279385 */     GIR_EraseRootFromParent_Done,
     /* 1279386 */   // Label 18422: @1279386
     /* 1279386 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1279470), // Rule ID 8607 //
     /* 1279391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279469 */     // GIR_Coverage, 8607,
     /* 1279469 */     GIR_EraseRootFromParent_Done,
     /* 1279470 */   // Label 18423: @1279470
     /* 1279470 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1279554), // Rule ID 8610 //
     /* 1279475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279528 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279553 */     // GIR_Coverage, 8610,
     /* 1279553 */     GIR_EraseRootFromParent_Done,
     /* 1279554 */   // Label 18424: @1279554
     /* 1279554 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1279638), // Rule ID 8611 //
     /* 1279559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279637 */     // GIR_Coverage, 8611,
     /* 1279637 */     GIR_EraseRootFromParent_Done,
     /* 1279638 */   // Label 18425: @1279638
     /* 1279638 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1279722), // Rule ID 8614 //
     /* 1279643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279721 */     // GIR_Coverage, 8614,
     /* 1279721 */     GIR_EraseRootFromParent_Done,
     /* 1279722 */   // Label 18426: @1279722
     /* 1279722 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1279806), // Rule ID 8615 //
     /* 1279727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279805 */     // GIR_Coverage, 8615,
     /* 1279805 */     GIR_EraseRootFromParent_Done,
     /* 1279806 */   // Label 18427: @1279806
     /* 1279806 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1279890), // Rule ID 8618 //
     /* 1279811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279889 */     // GIR_Coverage, 8618,
     /* 1279889 */     GIR_EraseRootFromParent_Done,
     /* 1279890 */   // Label 18428: @1279890
     /* 1279890 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1279974), // Rule ID 8619 //
     /* 1279895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279948 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279973 */     // GIR_Coverage, 8619,
     /* 1279973 */     GIR_EraseRootFromParent_Done,
     /* 1279974 */   // Label 18429: @1279974
     /* 1279974 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1280058), // Rule ID 8622 //
     /* 1279979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280057 */     // GIR_Coverage, 8622,
     /* 1280057 */     GIR_EraseRootFromParent_Done,
     /* 1280058 */   // Label 18430: @1280058
     /* 1280058 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1280142), // Rule ID 8623 //
     /* 1280063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280141 */     // GIR_Coverage, 8623,
     /* 1280141 */     GIR_EraseRootFromParent_Done,
     /* 1280142 */   // Label 18431: @1280142
     /* 1280142 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1280226), // Rule ID 8626 //
     /* 1280147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280225 */     // GIR_Coverage, 8626,
     /* 1280225 */     GIR_EraseRootFromParent_Done,
     /* 1280226 */   // Label 18432: @1280226
     /* 1280226 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1280310), // Rule ID 8627 //
     /* 1280231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280309 */     // GIR_Coverage, 8627,
     /* 1280309 */     GIR_EraseRootFromParent_Done,
     /* 1280310 */   // Label 18433: @1280310
     /* 1280310 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1280394), // Rule ID 8630 //
     /* 1280315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280393 */     // GIR_Coverage, 8630,
     /* 1280393 */     GIR_EraseRootFromParent_Done,
     /* 1280394 */   // Label 18434: @1280394
     /* 1280394 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1280478), // Rule ID 8631 //
     /* 1280399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280477 */     // GIR_Coverage, 8631,
     /* 1280477 */     GIR_EraseRootFromParent_Done,
     /* 1280478 */   // Label 18435: @1280478
     /* 1280478 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1280562), // Rule ID 8634 //
     /* 1280483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280561 */     // GIR_Coverage, 8634,
     /* 1280561 */     GIR_EraseRootFromParent_Done,
     /* 1280562 */   // Label 18436: @1280562
     /* 1280562 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1280646), // Rule ID 8635 //
     /* 1280567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280645 */     // GIR_Coverage, 8635,
     /* 1280645 */     GIR_EraseRootFromParent_Done,
     /* 1280646 */   // Label 18437: @1280646
     /* 1280646 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1280730), // Rule ID 8638 //
     /* 1280651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280729 */     // GIR_Coverage, 8638,
     /* 1280729 */     GIR_EraseRootFromParent_Done,
     /* 1280730 */   // Label 18438: @1280730
     /* 1280730 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1280814), // Rule ID 8639 //
     /* 1280735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280813 */     // GIR_Coverage, 8639,
     /* 1280813 */     GIR_EraseRootFromParent_Done,
     /* 1280814 */   // Label 18439: @1280814
     /* 1280814 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1280898), // Rule ID 8642 //
     /* 1280819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280872 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280897 */     // GIR_Coverage, 8642,
     /* 1280897 */     GIR_EraseRootFromParent_Done,
     /* 1280898 */   // Label 18440: @1280898
     /* 1280898 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1280982), // Rule ID 8643 //
     /* 1280903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280956 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280981 */     // GIR_Coverage, 8643,
     /* 1280981 */     GIR_EraseRootFromParent_Done,
     /* 1280982 */   // Label 18441: @1280982
     /* 1280982 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1281066), // Rule ID 8646 //
     /* 1280987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281040 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281065 */     // GIR_Coverage, 8646,
     /* 1281065 */     GIR_EraseRootFromParent_Done,
     /* 1281066 */   // Label 18442: @1281066
     /* 1281066 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1281150), // Rule ID 8647 //
     /* 1281071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281124 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281149 */     // GIR_Coverage, 8647,
     /* 1281149 */     GIR_EraseRootFromParent_Done,
     /* 1281150 */   // Label 18443: @1281150
     /* 1281150 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1281234), // Rule ID 8650 //
     /* 1281155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281233 */     // GIR_Coverage, 8650,
     /* 1281233 */     GIR_EraseRootFromParent_Done,
     /* 1281234 */   // Label 18444: @1281234
     /* 1281234 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1281318), // Rule ID 8651 //
     /* 1281239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281317 */     // GIR_Coverage, 8651,
     /* 1281317 */     GIR_EraseRootFromParent_Done,
     /* 1281318 */   // Label 18445: @1281318
     /* 1281318 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1281402), // Rule ID 8654 //
     /* 1281323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281401 */     // GIR_Coverage, 8654,
     /* 1281401 */     GIR_EraseRootFromParent_Done,
     /* 1281402 */   // Label 18446: @1281402
     /* 1281402 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1281486), // Rule ID 8655 //
     /* 1281407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281485 */     // GIR_Coverage, 8655,
     /* 1281485 */     GIR_EraseRootFromParent_Done,
     /* 1281486 */   // Label 18447: @1281486
     /* 1281486 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1281570), // Rule ID 8658 //
     /* 1281491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281544 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281569 */     // GIR_Coverage, 8658,
     /* 1281569 */     GIR_EraseRootFromParent_Done,
     /* 1281570 */   // Label 18448: @1281570
     /* 1281570 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1281654), // Rule ID 8659 //
     /* 1281575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281653 */     // GIR_Coverage, 8659,
     /* 1281653 */     GIR_EraseRootFromParent_Done,
     /* 1281654 */   // Label 18449: @1281654
     /* 1281654 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1281738), // Rule ID 8662 //
     /* 1281659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281737 */     // GIR_Coverage, 8662,
     /* 1281737 */     GIR_EraseRootFromParent_Done,
     /* 1281738 */   // Label 18450: @1281738
     /* 1281738 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1281822), // Rule ID 8663 //
     /* 1281743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281821 */     // GIR_Coverage, 8663,
     /* 1281821 */     GIR_EraseRootFromParent_Done,
     /* 1281822 */   // Label 18451: @1281822
     /* 1281822 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1281906), // Rule ID 8666 //
     /* 1281827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281905 */     // GIR_Coverage, 8666,
     /* 1281905 */     GIR_EraseRootFromParent_Done,
     /* 1281906 */   // Label 18452: @1281906
     /* 1281906 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1281990), // Rule ID 8667 //
     /* 1281911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281989 */     // GIR_Coverage, 8667,
     /* 1281989 */     GIR_EraseRootFromParent_Done,
     /* 1281990 */   // Label 18453: @1281990
     /* 1281990 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1282074), // Rule ID 8670 //
     /* 1281995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282073 */     // GIR_Coverage, 8670,
     /* 1282073 */     GIR_EraseRootFromParent_Done,
     /* 1282074 */   // Label 18454: @1282074
     /* 1282074 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1282158), // Rule ID 8671 //
     /* 1282079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282157 */     // GIR_Coverage, 8671,
     /* 1282157 */     GIR_EraseRootFromParent_Done,
     /* 1282158 */   // Label 18455: @1282158
     /* 1282158 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1282242), // Rule ID 8674 //
     /* 1282163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1282219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282241 */     // GIR_Coverage, 8674,
     /* 1282241 */     GIR_EraseRootFromParent_Done,
     /* 1282242 */   // Label 18456: @1282242
     /* 1282242 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1282326), // Rule ID 8675 //
     /* 1282247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1282303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282325 */     // GIR_Coverage, 8675,
     /* 1282325 */     GIR_EraseRootFromParent_Done,
     /* 1282326 */   // Label 18457: @1282326
     /* 1282326 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1282410), // Rule ID 8678 //
     /* 1282331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282409 */     // GIR_Coverage, 8678,
     /* 1282409 */     GIR_EraseRootFromParent_Done,
     /* 1282410 */   // Label 18458: @1282410
     /* 1282410 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1282494), // Rule ID 8679 //
     /* 1282415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282493 */     // GIR_Coverage, 8679,
     /* 1282493 */     GIR_EraseRootFromParent_Done,
     /* 1282494 */   // Label 18459: @1282494
     /* 1282494 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1282578), // Rule ID 8682 //
     /* 1282499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282577 */     // GIR_Coverage, 8682,
     /* 1282577 */     GIR_EraseRootFromParent_Done,
     /* 1282578 */   // Label 18460: @1282578
     /* 1282578 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1282662), // Rule ID 8683 //
     /* 1282583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282661 */     // GIR_Coverage, 8683,
     /* 1282661 */     GIR_EraseRootFromParent_Done,
     /* 1282662 */   // Label 18461: @1282662
     /* 1282662 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1282746), // Rule ID 8686 //
     /* 1282667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282745 */     // GIR_Coverage, 8686,
     /* 1282745 */     GIR_EraseRootFromParent_Done,
     /* 1282746 */   // Label 18462: @1282746
     /* 1282746 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1282830), // Rule ID 8687 //
     /* 1282751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282829 */     // GIR_Coverage, 8687,
     /* 1282829 */     GIR_EraseRootFromParent_Done,
     /* 1282830 */   // Label 18463: @1282830
     /* 1282830 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1282914), // Rule ID 8690 //
     /* 1282835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282913 */     // GIR_Coverage, 8690,
     /* 1282913 */     GIR_EraseRootFromParent_Done,
     /* 1282914 */   // Label 18464: @1282914
     /* 1282914 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1282998), // Rule ID 8691 //
     /* 1282919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282997 */     // GIR_Coverage, 8691,
     /* 1282997 */     GIR_EraseRootFromParent_Done,
     /* 1282998 */   // Label 18465: @1282998
     /* 1282998 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1283082), // Rule ID 8694 //
     /* 1283003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283056 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283081 */     // GIR_Coverage, 8694,
     /* 1283081 */     GIR_EraseRootFromParent_Done,
     /* 1283082 */   // Label 18466: @1283082
     /* 1283082 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1283166), // Rule ID 8695 //
     /* 1283087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283165 */     // GIR_Coverage, 8695,
     /* 1283165 */     GIR_EraseRootFromParent_Done,
     /* 1283166 */   // Label 18467: @1283166
     /* 1283166 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1283250), // Rule ID 8698 //
     /* 1283171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1283227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283249 */     // GIR_Coverage, 8698,
     /* 1283249 */     GIR_EraseRootFromParent_Done,
     /* 1283250 */   // Label 18468: @1283250
     /* 1283250 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1283334), // Rule ID 8699 //
     /* 1283255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283308 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1283311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283333 */     // GIR_Coverage, 8699,
     /* 1283333 */     GIR_EraseRootFromParent_Done,
     /* 1283334 */   // Label 18469: @1283334
     /* 1283334 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1283418), // Rule ID 8702 //
     /* 1283339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283417 */     // GIR_Coverage, 8702,
     /* 1283417 */     GIR_EraseRootFromParent_Done,
     /* 1283418 */   // Label 18470: @1283418
     /* 1283418 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1283502), // Rule ID 8703 //
     /* 1283423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283501 */     // GIR_Coverage, 8703,
     /* 1283501 */     GIR_EraseRootFromParent_Done,
     /* 1283502 */   // Label 18471: @1283502
     /* 1283502 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1283586), // Rule ID 8706 //
     /* 1283507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283585 */     // GIR_Coverage, 8706,
     /* 1283585 */     GIR_EraseRootFromParent_Done,
     /* 1283586 */   // Label 18472: @1283586
     /* 1283586 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1283670), // Rule ID 8707 //
     /* 1283591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283669 */     // GIR_Coverage, 8707,
     /* 1283669 */     GIR_EraseRootFromParent_Done,
     /* 1283670 */   // Label 18473: @1283670
     /* 1283670 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1283754), // Rule ID 8710 //
     /* 1283675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283753 */     // GIR_Coverage, 8710,
     /* 1283753 */     GIR_EraseRootFromParent_Done,
     /* 1283754 */   // Label 18474: @1283754
     /* 1283754 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1283838), // Rule ID 8711 //
     /* 1283759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283837 */     // GIR_Coverage, 8711,
     /* 1283837 */     GIR_EraseRootFromParent_Done,
     /* 1283838 */   // Label 18475: @1283838
     /* 1283838 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1283922), // Rule ID 8714 //
     /* 1283843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283921 */     // GIR_Coverage, 8714,
     /* 1283921 */     GIR_EraseRootFromParent_Done,
     /* 1283922 */   // Label 18476: @1283922
     /* 1283922 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1284006), // Rule ID 8715 //
     /* 1283927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284005 */     // GIR_Coverage, 8715,
     /* 1284005 */     GIR_EraseRootFromParent_Done,
     /* 1284006 */   // Label 18477: @1284006
     /* 1284006 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1284090), // Rule ID 8718 //
     /* 1284011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284089 */     // GIR_Coverage, 8718,
     /* 1284089 */     GIR_EraseRootFromParent_Done,
     /* 1284090 */   // Label 18478: @1284090
     /* 1284090 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1284174), // Rule ID 8719 //
     /* 1284095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284173 */     // GIR_Coverage, 8719,
     /* 1284173 */     GIR_EraseRootFromParent_Done,
     /* 1284174 */   // Label 18479: @1284174
     /* 1284174 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1284258), // Rule ID 8722 //
     /* 1284179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1284182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284257 */     // GIR_Coverage, 8722,
     /* 1284257 */     GIR_EraseRootFromParent_Done,
     /* 1284258 */   // Label 18480: @1284258
     /* 1284258 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1284342), // Rule ID 8723 //
     /* 1284263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1284266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1284319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284341 */     // GIR_Coverage, 8723,
     /* 1284341 */     GIR_EraseRootFromParent_Done,
     /* 1284342 */   // Label 18481: @1284342
     /* 1284342 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1284426), // Rule ID 8726 //
     /* 1284347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284425 */     // GIR_Coverage, 8726,
     /* 1284425 */     GIR_EraseRootFromParent_Done,
     /* 1284426 */   // Label 18482: @1284426
     /* 1284426 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1284510), // Rule ID 8727 //
     /* 1284431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284509 */     // GIR_Coverage, 8727,
     /* 1284509 */     GIR_EraseRootFromParent_Done,
     /* 1284510 */   // Label 18483: @1284510
     /* 1284510 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1284594), // Rule ID 8730 //
     /* 1284515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284568 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284593 */     // GIR_Coverage, 8730,
     /* 1284593 */     GIR_EraseRootFromParent_Done,
     /* 1284594 */   // Label 18484: @1284594
     /* 1284594 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1284678), // Rule ID 8731 //
     /* 1284599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284652 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284677 */     // GIR_Coverage, 8731,
     /* 1284677 */     GIR_EraseRootFromParent_Done,
     /* 1284678 */   // Label 18485: @1284678
     /* 1284678 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1284762), // Rule ID 8734 //
     /* 1284683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284736 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284761 */     // GIR_Coverage, 8734,
     /* 1284761 */     GIR_EraseRootFromParent_Done,
     /* 1284762 */   // Label 18486: @1284762
     /* 1284762 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1284846), // Rule ID 8735 //
     /* 1284767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284820 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284845 */     // GIR_Coverage, 8735,
     /* 1284845 */     GIR_EraseRootFromParent_Done,
     /* 1284846 */   // Label 18487: @1284846
     /* 1284846 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1284930), // Rule ID 8738 //
     /* 1284851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284929 */     // GIR_Coverage, 8738,
     /* 1284929 */     GIR_EraseRootFromParent_Done,
     /* 1284930 */   // Label 18488: @1284930
     /* 1284930 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1285014), // Rule ID 8739 //
     /* 1284935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285013 */     // GIR_Coverage, 8739,
     /* 1285013 */     GIR_EraseRootFromParent_Done,
     /* 1285014 */   // Label 18489: @1285014
     /* 1285014 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1285098), // Rule ID 8742 //
     /* 1285019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285097 */     // GIR_Coverage, 8742,
     /* 1285097 */     GIR_EraseRootFromParent_Done,
     /* 1285098 */   // Label 18490: @1285098
     /* 1285098 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1285182), // Rule ID 8743 //
     /* 1285103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285181 */     // GIR_Coverage, 8743,
     /* 1285181 */     GIR_EraseRootFromParent_Done,
     /* 1285182 */   // Label 18491: @1285182
     /* 1285182 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1285266), // Rule ID 8746 //
     /* 1285187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285240 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285265 */     // GIR_Coverage, 8746,
     /* 1285265 */     GIR_EraseRootFromParent_Done,
     /* 1285266 */   // Label 18492: @1285266
     /* 1285266 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1285350), // Rule ID 8747 //
     /* 1285271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285324 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285349 */     // GIR_Coverage, 8747,
     /* 1285349 */     GIR_EraseRootFromParent_Done,
     /* 1285350 */   // Label 18493: @1285350
     /* 1285350 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1285434), // Rule ID 8750 //
     /* 1285355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285433 */     // GIR_Coverage, 8750,
     /* 1285433 */     GIR_EraseRootFromParent_Done,
     /* 1285434 */   // Label 18494: @1285434
     /* 1285434 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1285518), // Rule ID 8751 //
     /* 1285439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285517 */     // GIR_Coverage, 8751,
     /* 1285517 */     GIR_EraseRootFromParent_Done,
     /* 1285518 */   // Label 18495: @1285518
     /* 1285518 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1285602), // Rule ID 8754 //
     /* 1285523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285601 */     // GIR_Coverage, 8754,
     /* 1285601 */     GIR_EraseRootFromParent_Done,
     /* 1285602 */   // Label 18496: @1285602
     /* 1285602 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1285686), // Rule ID 8755 //
     /* 1285607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285685 */     // GIR_Coverage, 8755,
     /* 1285685 */     GIR_EraseRootFromParent_Done,
     /* 1285686 */   // Label 18497: @1285686
     /* 1285686 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1285770), // Rule ID 8758 //
     /* 1285691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285769 */     // GIR_Coverage, 8758,
     /* 1285769 */     GIR_EraseRootFromParent_Done,
     /* 1285770 */   // Label 18498: @1285770
     /* 1285770 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1285854), // Rule ID 8759 //
     /* 1285775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285853 */     // GIR_Coverage, 8759,
     /* 1285853 */     GIR_EraseRootFromParent_Done,
     /* 1285854 */   // Label 18499: @1285854
     /* 1285854 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1285938), // Rule ID 8762 //
     /* 1285859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285937 */     // GIR_Coverage, 8762,
     /* 1285937 */     GIR_EraseRootFromParent_Done,
     /* 1285938 */   // Label 18500: @1285938
     /* 1285938 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1286022), // Rule ID 8763 //
     /* 1285943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286021 */     // GIR_Coverage, 8763,
     /* 1286021 */     GIR_EraseRootFromParent_Done,
     /* 1286022 */   // Label 18501: @1286022
     /* 1286022 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1286106), // Rule ID 8766 //
     /* 1286027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286080 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1286083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286105 */     // GIR_Coverage, 8766,
     /* 1286105 */     GIR_EraseRootFromParent_Done,
     /* 1286106 */   // Label 18502: @1286106
     /* 1286106 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1286190), // Rule ID 8767 //
     /* 1286111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1286167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286189 */     // GIR_Coverage, 8767,
     /* 1286189 */     GIR_EraseRootFromParent_Done,
     /* 1286190 */   // Label 18503: @1286190
     /* 1286190 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1286274), // Rule ID 8770 //
     /* 1286195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1286251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286273 */     // GIR_Coverage, 8770,
     /* 1286273 */     GIR_EraseRootFromParent_Done,
     /* 1286274 */   // Label 18504: @1286274
     /* 1286274 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1286358), // Rule ID 8771 //
     /* 1286279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1286335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286357 */     // GIR_Coverage, 8771,
     /* 1286357 */     GIR_EraseRootFromParent_Done,
     /* 1286358 */   // Label 18505: @1286358
     /* 1286358 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1286442), // Rule ID 8774 //
     /* 1286363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286441 */     // GIR_Coverage, 8774,
     /* 1286441 */     GIR_EraseRootFromParent_Done,
     /* 1286442 */   // Label 18506: @1286442
     /* 1286442 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1286526), // Rule ID 8775 //
     /* 1286447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286525 */     // GIR_Coverage, 8775,
     /* 1286525 */     GIR_EraseRootFromParent_Done,
     /* 1286526 */   // Label 18507: @1286526
     /* 1286526 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1286610), // Rule ID 8778 //
     /* 1286531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286609 */     // GIR_Coverage, 8778,
     /* 1286609 */     GIR_EraseRootFromParent_Done,
     /* 1286610 */   // Label 18508: @1286610
     /* 1286610 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1286694), // Rule ID 8779 //
     /* 1286615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286693 */     // GIR_Coverage, 8779,
     /* 1286693 */     GIR_EraseRootFromParent_Done,
     /* 1286694 */   // Label 18509: @1286694
     /* 1286694 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1286778), // Rule ID 8782 //
     /* 1286699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286777 */     // GIR_Coverage, 8782,
     /* 1286777 */     GIR_EraseRootFromParent_Done,
     /* 1286778 */   // Label 18510: @1286778
     /* 1286778 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1286862), // Rule ID 8783 //
     /* 1286783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286861 */     // GIR_Coverage, 8783,
     /* 1286861 */     GIR_EraseRootFromParent_Done,
     /* 1286862 */   // Label 18511: @1286862
     /* 1286862 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1286946), // Rule ID 8786 //
     /* 1286867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286945 */     // GIR_Coverage, 8786,
     /* 1286945 */     GIR_EraseRootFromParent_Done,
     /* 1286946 */   // Label 18512: @1286946
     /* 1286946 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1287030), // Rule ID 8787 //
     /* 1286951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1287007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287029 */     // GIR_Coverage, 8787,
     /* 1287029 */     GIR_EraseRootFromParent_Done,
     /* 1287030 */   // Label 18513: @1287030
     /* 1287030 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1287114), // Rule ID 8790 //
     /* 1287035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287113 */     // GIR_Coverage, 8790,
     /* 1287113 */     GIR_EraseRootFromParent_Done,
     /* 1287114 */   // Label 18514: @1287114
     /* 1287114 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1287198), // Rule ID 8791 //
     /* 1287119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287197 */     // GIR_Coverage, 8791,
     /* 1287197 */     GIR_EraseRootFromParent_Done,
     /* 1287198 */   // Label 18515: @1287198
     /* 1287198 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1287282), // Rule ID 8794 //
     /* 1287203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287281 */     // GIR_Coverage, 8794,
     /* 1287281 */     GIR_EraseRootFromParent_Done,
     /* 1287282 */   // Label 18516: @1287282
     /* 1287282 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1287366), // Rule ID 8795 //
     /* 1287287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1287343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287365 */     // GIR_Coverage, 8795,
     /* 1287365 */     GIR_EraseRootFromParent_Done,
     /* 1287366 */   // Label 18517: @1287366
     /* 1287366 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1287450), // Rule ID 8798 //
     /* 1287371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287449 */     // GIR_Coverage, 8798,
     /* 1287449 */     GIR_EraseRootFromParent_Done,
     /* 1287450 */   // Label 18518: @1287450
     /* 1287450 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1287534), // Rule ID 8799 //
     /* 1287455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287533 */     // GIR_Coverage, 8799,
     /* 1287533 */     GIR_EraseRootFromParent_Done,
     /* 1287534 */   // Label 18519: @1287534
     /* 1287534 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1287618), // Rule ID 8802 //
     /* 1287539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287592 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287617 */     // GIR_Coverage, 8802,
     /* 1287617 */     GIR_EraseRootFromParent_Done,
     /* 1287618 */   // Label 18520: @1287618
     /* 1287618 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1287702), // Rule ID 8803 //
     /* 1287623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287676 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287701 */     // GIR_Coverage, 8803,
     /* 1287701 */     GIR_EraseRootFromParent_Done,
     /* 1287702 */   // Label 18521: @1287702
     /* 1287702 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1287786), // Rule ID 8806 //
     /* 1287707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287785 */     // GIR_Coverage, 8806,
     /* 1287785 */     GIR_EraseRootFromParent_Done,
     /* 1287786 */   // Label 18522: @1287786
     /* 1287786 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1287870), // Rule ID 8807 //
     /* 1287791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287844 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287869 */     // GIR_Coverage, 8807,
     /* 1287869 */     GIR_EraseRootFromParent_Done,
     /* 1287870 */   // Label 18523: @1287870
     /* 1287870 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1287954), // Rule ID 8810 //
     /* 1287875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287953 */     // GIR_Coverage, 8810,
     /* 1287953 */     GIR_EraseRootFromParent_Done,
     /* 1287954 */   // Label 18524: @1287954
     /* 1287954 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1288038), // Rule ID 8811 //
     /* 1287959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1288015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288037 */     // GIR_Coverage, 8811,
     /* 1288037 */     GIR_EraseRootFromParent_Done,
     /* 1288038 */   // Label 18525: @1288038
     /* 1288038 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1288122), // Rule ID 8814 //
     /* 1288043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288096 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288121 */     // GIR_Coverage, 8814,
     /* 1288121 */     GIR_EraseRootFromParent_Done,
     /* 1288122 */   // Label 18526: @1288122
     /* 1288122 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1288206), // Rule ID 8815 //
     /* 1288127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288205 */     // GIR_Coverage, 8815,
     /* 1288205 */     GIR_EraseRootFromParent_Done,
     /* 1288206 */   // Label 18527: @1288206
     /* 1288206 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1288290), // Rule ID 8818 //
     /* 1288211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288264 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288289 */     // GIR_Coverage, 8818,
     /* 1288289 */     GIR_EraseRootFromParent_Done,
     /* 1288290 */   // Label 18528: @1288290
     /* 1288290 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1288374), // Rule ID 8819 //
     /* 1288295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288348 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288373 */     // GIR_Coverage, 8819,
     /* 1288373 */     GIR_EraseRootFromParent_Done,
     /* 1288374 */   // Label 18529: @1288374
     /* 1288374 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1288458), // Rule ID 8822 //
     /* 1288379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288432 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288457 */     // GIR_Coverage, 8822,
     /* 1288457 */     GIR_EraseRootFromParent_Done,
     /* 1288458 */   // Label 18530: @1288458
     /* 1288458 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1288542), // Rule ID 8823 //
     /* 1288463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288516 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288541 */     // GIR_Coverage, 8823,
     /* 1288541 */     GIR_EraseRootFromParent_Done,
     /* 1288542 */   // Label 18531: @1288542
     /* 1288542 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1288626), // Rule ID 8826 //
     /* 1288547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288625 */     // GIR_Coverage, 8826,
     /* 1288625 */     GIR_EraseRootFromParent_Done,
     /* 1288626 */   // Label 18532: @1288626
     /* 1288626 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1288710), // Rule ID 8827 //
     /* 1288631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288709 */     // GIR_Coverage, 8827,
     /* 1288709 */     GIR_EraseRootFromParent_Done,
     /* 1288710 */   // Label 18533: @1288710
     /* 1288710 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1288794), // Rule ID 8830 //
     /* 1288715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288793 */     // GIR_Coverage, 8830,
     /* 1288793 */     GIR_EraseRootFromParent_Done,
     /* 1288794 */   // Label 18534: @1288794
     /* 1288794 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1288878), // Rule ID 8831 //
     /* 1288799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288877 */     // GIR_Coverage, 8831,
     /* 1288877 */     GIR_EraseRootFromParent_Done,
     /* 1288878 */   // Label 18535: @1288878
     /* 1288878 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1288962), // Rule ID 8834 //
     /* 1288883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288936 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288961 */     // GIR_Coverage, 8834,
     /* 1288961 */     GIR_EraseRootFromParent_Done,
     /* 1288962 */   // Label 18536: @1288962
     /* 1288962 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1289046), // Rule ID 8835 //
     /* 1288967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289020 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289045 */     // GIR_Coverage, 8835,
     /* 1289045 */     GIR_EraseRootFromParent_Done,
     /* 1289046 */   // Label 18537: @1289046
     /* 1289046 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1289130), // Rule ID 8838 //
     /* 1289051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289129 */     // GIR_Coverage, 8838,
     /* 1289129 */     GIR_EraseRootFromParent_Done,
     /* 1289130 */   // Label 18538: @1289130
     /* 1289130 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1289214), // Rule ID 8839 //
     /* 1289135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289213 */     // GIR_Coverage, 8839,
     /* 1289213 */     GIR_EraseRootFromParent_Done,
     /* 1289214 */   // Label 18539: @1289214
     /* 1289214 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1289298), // Rule ID 8842 //
     /* 1289219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289297 */     // GIR_Coverage, 8842,
     /* 1289297 */     GIR_EraseRootFromParent_Done,
     /* 1289298 */   // Label 18540: @1289298
     /* 1289298 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1289382), // Rule ID 8843 //
     /* 1289303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289356 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289381 */     // GIR_Coverage, 8843,
     /* 1289381 */     GIR_EraseRootFromParent_Done,
     /* 1289382 */   // Label 18541: @1289382
     /* 1289382 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1289466), // Rule ID 8846 //
     /* 1289387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289465 */     // GIR_Coverage, 8846,
     /* 1289465 */     GIR_EraseRootFromParent_Done,
     /* 1289466 */   // Label 18542: @1289466
     /* 1289466 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1289550), // Rule ID 8847 //
     /* 1289471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289549 */     // GIR_Coverage, 8847,
     /* 1289549 */     GIR_EraseRootFromParent_Done,
     /* 1289550 */   // Label 18543: @1289550
     /* 1289550 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1289634), // Rule ID 8850 //
     /* 1289555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289633 */     // GIR_Coverage, 8850,
     /* 1289633 */     GIR_EraseRootFromParent_Done,
     /* 1289634 */   // Label 18544: @1289634
     /* 1289634 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1289718), // Rule ID 8851 //
     /* 1289639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289717 */     // GIR_Coverage, 8851,
     /* 1289717 */     GIR_EraseRootFromParent_Done,
     /* 1289718 */   // Label 18545: @1289718
     /* 1289718 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1289802), // Rule ID 8854 //
     /* 1289723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289801 */     // GIR_Coverage, 8854,
     /* 1289801 */     GIR_EraseRootFromParent_Done,
     /* 1289802 */   // Label 18546: @1289802
     /* 1289802 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1289886), // Rule ID 8855 //
     /* 1289807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289885 */     // GIR_Coverage, 8855,
     /* 1289885 */     GIR_EraseRootFromParent_Done,
     /* 1289886 */   // Label 18547: @1289886
     /* 1289886 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1289970), // Rule ID 8858 //
     /* 1289891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289969 */     // GIR_Coverage, 8858,
     /* 1289969 */     GIR_EraseRootFromParent_Done,
     /* 1289970 */   // Label 18548: @1289970
     /* 1289970 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1290054), // Rule ID 8859 //
     /* 1289975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1290031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290053 */     // GIR_Coverage, 8859,
     /* 1290053 */     GIR_EraseRootFromParent_Done,
     /* 1290054 */   // Label 18549: @1290054
     /* 1290054 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1290138), // Rule ID 8950 //
     /* 1290059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1290079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1290115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290137 */     // GIR_Coverage, 8950,
     /* 1290137 */     GIR_EraseRootFromParent_Done,
     /* 1290138 */   // Label 18550: @1290138
     /* 1290138 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1290222), // Rule ID 8951 //
     /* 1290143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1290163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290196 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1290199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290221 */     // GIR_Coverage, 8951,
     /* 1290221 */     GIR_EraseRootFromParent_Done,
     /* 1290222 */   // Label 18551: @1290222
     /* 1290222 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1290306), // Rule ID 8954 //
     /* 1290227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1290247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290305 */     // GIR_Coverage, 8954,
     /* 1290305 */     GIR_EraseRootFromParent_Done,
     /* 1290306 */   // Label 18552: @1290306
     /* 1290306 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1290390), // Rule ID 8955 //
     /* 1290311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1290331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290389 */     // GIR_Coverage, 8955,
     /* 1290389 */     GIR_EraseRootFromParent_Done,
     /* 1290390 */   // Label 18553: @1290390
     /* 1290390 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1290474), // Rule ID 8958 //
     /* 1290395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290473 */     // GIR_Coverage, 8958,
     /* 1290473 */     GIR_EraseRootFromParent_Done,
     /* 1290474 */   // Label 18554: @1290474
     /* 1290474 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1290558), // Rule ID 8959 //
     /* 1290479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290557 */     // GIR_Coverage, 8959,
     /* 1290557 */     GIR_EraseRootFromParent_Done,
     /* 1290558 */   // Label 18555: @1290558
     /* 1290558 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1290642), // Rule ID 8962 //
     /* 1290563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290641 */     // GIR_Coverage, 8962,
     /* 1290641 */     GIR_EraseRootFromParent_Done,
     /* 1290642 */   // Label 18556: @1290642
     /* 1290642 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1290726), // Rule ID 8963 //
     /* 1290647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290725 */     // GIR_Coverage, 8963,
     /* 1290725 */     GIR_EraseRootFromParent_Done,
     /* 1290726 */   // Label 18557: @1290726
     /* 1290726 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1290810), // Rule ID 8966 //
     /* 1290731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290809 */     // GIR_Coverage, 8966,
     /* 1290809 */     GIR_EraseRootFromParent_Done,
     /* 1290810 */   // Label 18558: @1290810
     /* 1290810 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1290894), // Rule ID 8967 //
     /* 1290815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290893 */     // GIR_Coverage, 8967,
     /* 1290893 */     GIR_EraseRootFromParent_Done,
     /* 1290894 */   // Label 18559: @1290894
     /* 1290894 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1290978), // Rule ID 8970 //
     /* 1290899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290977 */     // GIR_Coverage, 8970,
     /* 1290977 */     GIR_EraseRootFromParent_Done,
     /* 1290978 */   // Label 18560: @1290978
     /* 1290978 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1291062), // Rule ID 8971 //
     /* 1290983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1291003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291036 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1291039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291061 */     // GIR_Coverage, 8971,
     /* 1291061 */     GIR_EraseRootFromParent_Done,
     /* 1291062 */   // Label 18561: @1291062
     /* 1291062 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1291146), // Rule ID 8974 //
     /* 1291067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1291087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291145 */     // GIR_Coverage, 8974,
     /* 1291145 */     GIR_EraseRootFromParent_Done,
     /* 1291146 */   // Label 18562: @1291146
     /* 1291146 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1291230), // Rule ID 8975 //
     /* 1291151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1291171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291229 */     // GIR_Coverage, 8975,
     /* 1291229 */     GIR_EraseRootFromParent_Done,
     /* 1291230 */   // Label 18563: @1291230
     /* 1291230 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1291314), // Rule ID 8978 //
     /* 1291235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291313 */     // GIR_Coverage, 8978,
     /* 1291313 */     GIR_EraseRootFromParent_Done,
     /* 1291314 */   // Label 18564: @1291314
     /* 1291314 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1291398), // Rule ID 8979 //
     /* 1291319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1291339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291372 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291397 */     // GIR_Coverage, 8979,
     /* 1291397 */     GIR_EraseRootFromParent_Done,
     /* 1291398 */   // Label 18565: @1291398
     /* 1291398 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1291482), // Rule ID 8982 //
     /* 1291403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291481 */     // GIR_Coverage, 8982,
     /* 1291481 */     GIR_EraseRootFromParent_Done,
     /* 1291482 */   // Label 18566: @1291482
     /* 1291482 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1291566), // Rule ID 8983 //
     /* 1291487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291565 */     // GIR_Coverage, 8983,
     /* 1291565 */     GIR_EraseRootFromParent_Done,
     /* 1291566 */   // Label 18567: @1291566
     /* 1291566 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1291650), // Rule ID 8986 //
     /* 1291571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291649 */     // GIR_Coverage, 8986,
     /* 1291649 */     GIR_EraseRootFromParent_Done,
     /* 1291650 */   // Label 18568: @1291650
     /* 1291650 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1291734), // Rule ID 8987 //
     /* 1291655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291733 */     // GIR_Coverage, 8987,
     /* 1291733 */     GIR_EraseRootFromParent_Done,
     /* 1291734 */   // Label 18569: @1291734
     /* 1291734 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1291818), // Rule ID 8990 //
     /* 1291739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291792 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291817 */     // GIR_Coverage, 8990,
     /* 1291817 */     GIR_EraseRootFromParent_Done,
     /* 1291818 */   // Label 18570: @1291818
     /* 1291818 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1291902), // Rule ID 8991 //
     /* 1291823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291876 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291901 */     // GIR_Coverage, 8991,
     /* 1291901 */     GIR_EraseRootFromParent_Done,
     /* 1291902 */   // Label 18571: @1291902
     /* 1291902 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1291986), // Rule ID 8994 //
     /* 1291907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291985 */     // GIR_Coverage, 8994,
     /* 1291985 */     GIR_EraseRootFromParent_Done,
     /* 1291986 */   // Label 18572: @1291986
     /* 1291986 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1292070), // Rule ID 8995 //
     /* 1291991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1292008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1292011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292044 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292069 */     // GIR_Coverage, 8995,
     /* 1292069 */     GIR_EraseRootFromParent_Done,
     /* 1292070 */   // Label 18573: @1292070
     /* 1292070 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1292154), // Rule ID 8998 //
     /* 1292075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1292095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292128 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292153 */     // GIR_Coverage, 8998,
     /* 1292153 */     GIR_EraseRootFromParent_Done,
     /* 1292154 */   // Label 18574: @1292154
     /* 1292154 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1292238), // Rule ID 8999 //
     /* 1292159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1292179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292212 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292237 */     // GIR_Coverage, 8999,
     /* 1292237 */     GIR_EraseRootFromParent_Done,
     /* 1292238 */   // Label 18575: @1292238
     /* 1292238 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1292322), // Rule ID 9002 //
     /* 1292243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1292263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292321 */     // GIR_Coverage, 9002,
     /* 1292321 */     GIR_EraseRootFromParent_Done,
     /* 1292322 */   // Label 18576: @1292322
     /* 1292322 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1292406), // Rule ID 9003 //
     /* 1292327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1292347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292405 */     // GIR_Coverage, 9003,
     /* 1292405 */     GIR_EraseRootFromParent_Done,
     /* 1292406 */   // Label 18577: @1292406
     /* 1292406 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1292490), // Rule ID 9006 //
     /* 1292411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292489 */     // GIR_Coverage, 9006,
     /* 1292489 */     GIR_EraseRootFromParent_Done,
     /* 1292490 */   // Label 18578: @1292490
     /* 1292490 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1292574), // Rule ID 9007 //
     /* 1292495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292573 */     // GIR_Coverage, 9007,
     /* 1292573 */     GIR_EraseRootFromParent_Done,
     /* 1292574 */   // Label 18579: @1292574
     /* 1292574 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1292658), // Rule ID 9010 //
     /* 1292579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292632 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292657 */     // GIR_Coverage, 9010,
     /* 1292657 */     GIR_EraseRootFromParent_Done,
     /* 1292658 */   // Label 18580: @1292658
     /* 1292658 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1292742), // Rule ID 9011 //
     /* 1292663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292716 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292741 */     // GIR_Coverage, 9011,
     /* 1292741 */     GIR_EraseRootFromParent_Done,
     /* 1292742 */   // Label 18581: @1292742
     /* 1292742 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1292826), // Rule ID 9014 //
     /* 1292747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292825 */     // GIR_Coverage, 9014,
     /* 1292825 */     GIR_EraseRootFromParent_Done,
     /* 1292826 */   // Label 18582: @1292826
     /* 1292826 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1292910), // Rule ID 9015 //
     /* 1292831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292884 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292909 */     // GIR_Coverage, 9015,
     /* 1292909 */     GIR_EraseRootFromParent_Done,
     /* 1292910 */   // Label 18583: @1292910
     /* 1292910 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1292994), // Rule ID 9018 //
     /* 1292915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292993 */     // GIR_Coverage, 9018,
     /* 1292993 */     GIR_EraseRootFromParent_Done,
     /* 1292994 */   // Label 18584: @1292994
     /* 1292994 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1293078), // Rule ID 9019 //
     /* 1292999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1293016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1293019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293077 */     // GIR_Coverage, 9019,
     /* 1293077 */     GIR_EraseRootFromParent_Done,
     /* 1293078 */   // Label 18585: @1293078
     /* 1293078 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1293162), // Rule ID 9022 //
     /* 1293083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1293103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293136 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293161 */     // GIR_Coverage, 9022,
     /* 1293161 */     GIR_EraseRootFromParent_Done,
     /* 1293162 */   // Label 18586: @1293162
     /* 1293162 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1293246), // Rule ID 9023 //
     /* 1293167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1293187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293245 */     // GIR_Coverage, 9023,
     /* 1293245 */     GIR_EraseRootFromParent_Done,
     /* 1293246 */   // Label 18587: @1293246
     /* 1293246 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1293330), // Rule ID 9026 //
     /* 1293251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1293271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1293307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293329 */     // GIR_Coverage, 9026,
     /* 1293329 */     GIR_EraseRootFromParent_Done,
     /* 1293330 */   // Label 18588: @1293330
     /* 1293330 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1293414), // Rule ID 9027 //
     /* 1293335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1293355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293388 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1293391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293413 */     // GIR_Coverage, 9027,
     /* 1293413 */     GIR_EraseRootFromParent_Done,
     /* 1293414 */   // Label 18589: @1293414
     /* 1293414 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1293498), // Rule ID 9030 //
     /* 1293419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293497 */     // GIR_Coverage, 9030,
     /* 1293497 */     GIR_EraseRootFromParent_Done,
     /* 1293498 */   // Label 18590: @1293498
     /* 1293498 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1293582), // Rule ID 9031 //
     /* 1293503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293581 */     // GIR_Coverage, 9031,
     /* 1293581 */     GIR_EraseRootFromParent_Done,
     /* 1293582 */   // Label 18591: @1293582
     /* 1293582 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1293666), // Rule ID 9034 //
     /* 1293587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293665 */     // GIR_Coverage, 9034,
     /* 1293665 */     GIR_EraseRootFromParent_Done,
     /* 1293666 */   // Label 18592: @1293666
     /* 1293666 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1293750), // Rule ID 9035 //
     /* 1293671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293749 */     // GIR_Coverage, 9035,
     /* 1293749 */     GIR_EraseRootFromParent_Done,
     /* 1293750 */   // Label 18593: @1293750
     /* 1293750 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1293834), // Rule ID 9038 //
     /* 1293755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293833 */     // GIR_Coverage, 9038,
     /* 1293833 */     GIR_EraseRootFromParent_Done,
     /* 1293834 */   // Label 18594: @1293834
     /* 1293834 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1293918), // Rule ID 9039 //
     /* 1293839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293892 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293917 */     // GIR_Coverage, 9039,
     /* 1293917 */     GIR_EraseRootFromParent_Done,
     /* 1293918 */   // Label 18595: @1293918
     /* 1293918 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1294002), // Rule ID 9042 //
     /* 1293923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294001 */     // GIR_Coverage, 9042,
     /* 1294001 */     GIR_EraseRootFromParent_Done,
     /* 1294002 */   // Label 18596: @1294002
     /* 1294002 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1294086), // Rule ID 9043 //
     /* 1294007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1294024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294085 */     // GIR_Coverage, 9043,
     /* 1294085 */     GIR_EraseRootFromParent_Done,
     /* 1294086 */   // Label 18597: @1294086
     /* 1294086 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1294170), // Rule ID 9046 //
     /* 1294091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294169 */     // GIR_Coverage, 9046,
     /* 1294169 */     GIR_EraseRootFromParent_Done,
     /* 1294170 */   // Label 18598: @1294170
     /* 1294170 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1294254), // Rule ID 9047 //
     /* 1294175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294253 */     // GIR_Coverage, 9047,
     /* 1294253 */     GIR_EraseRootFromParent_Done,
     /* 1294254 */   // Label 18599: @1294254
     /* 1294254 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1294338), // Rule ID 9050 //
     /* 1294259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294337 */     // GIR_Coverage, 9050,
     /* 1294337 */     GIR_EraseRootFromParent_Done,
     /* 1294338 */   // Label 18600: @1294338
     /* 1294338 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1294422), // Rule ID 9051 //
     /* 1294343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294396 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1294399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294421 */     // GIR_Coverage, 9051,
     /* 1294421 */     GIR_EraseRootFromParent_Done,
     /* 1294422 */   // Label 18601: @1294422
     /* 1294422 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1294506), // Rule ID 9054 //
     /* 1294427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294505 */     // GIR_Coverage, 9054,
     /* 1294505 */     GIR_EraseRootFromParent_Done,
     /* 1294506 */   // Label 18602: @1294506
     /* 1294506 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1294590), // Rule ID 9055 //
     /* 1294511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294589 */     // GIR_Coverage, 9055,
     /* 1294589 */     GIR_EraseRootFromParent_Done,
     /* 1294590 */   // Label 18603: @1294590
     /* 1294590 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1294674), // Rule ID 9058 //
     /* 1294595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294673 */     // GIR_Coverage, 9058,
     /* 1294673 */     GIR_EraseRootFromParent_Done,
     /* 1294674 */   // Label 18604: @1294674
     /* 1294674 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1294758), // Rule ID 9059 //
     /* 1294679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294757 */     // GIR_Coverage, 9059,
     /* 1294757 */     GIR_EraseRootFromParent_Done,
     /* 1294758 */   // Label 18605: @1294758
     /* 1294758 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1294842), // Rule ID 9062 //
     /* 1294763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294841 */     // GIR_Coverage, 9062,
     /* 1294841 */     GIR_EraseRootFromParent_Done,
     /* 1294842 */   // Label 18606: @1294842
     /* 1294842 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1294926), // Rule ID 9063 //
     /* 1294847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294925 */     // GIR_Coverage, 9063,
     /* 1294925 */     GIR_EraseRootFromParent_Done,
     /* 1294926 */   // Label 18607: @1294926
     /* 1294926 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1295010), // Rule ID 9066 //
     /* 1294931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295009 */     // GIR_Coverage, 9066,
     /* 1295009 */     GIR_EraseRootFromParent_Done,
     /* 1295010 */   // Label 18608: @1295010
     /* 1295010 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1295094), // Rule ID 9067 //
     /* 1295015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1295032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295093 */     // GIR_Coverage, 9067,
     /* 1295093 */     GIR_EraseRootFromParent_Done,
     /* 1295094 */   // Label 18609: @1295094
     /* 1295094 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1295178), // Rule ID 9070 //
     /* 1295099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295152 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295177 */     // GIR_Coverage, 9070,
     /* 1295177 */     GIR_EraseRootFromParent_Done,
     /* 1295178 */   // Label 18610: @1295178
     /* 1295178 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1295262), // Rule ID 9071 //
     /* 1295183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295236 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295261 */     // GIR_Coverage, 9071,
     /* 1295261 */     GIR_EraseRootFromParent_Done,
     /* 1295262 */   // Label 18611: @1295262
     /* 1295262 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1295346), // Rule ID 9074 //
     /* 1295267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1295270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295345 */     // GIR_Coverage, 9074,
     /* 1295345 */     GIR_EraseRootFromParent_Done,
     /* 1295346 */   // Label 18612: @1295346
     /* 1295346 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1295430), // Rule ID 9075 //
     /* 1295351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1295354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1295407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295429 */     // GIR_Coverage, 9075,
     /* 1295429 */     GIR_EraseRootFromParent_Done,
     /* 1295430 */   // Label 18613: @1295430
     /* 1295430 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1295514), // Rule ID 9078 //
     /* 1295435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295513 */     // GIR_Coverage, 9078,
     /* 1295513 */     GIR_EraseRootFromParent_Done,
     /* 1295514 */   // Label 18614: @1295514
     /* 1295514 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1295598), // Rule ID 9079 //
     /* 1295519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295572 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295597 */     // GIR_Coverage, 9079,
     /* 1295597 */     GIR_EraseRootFromParent_Done,
     /* 1295598 */   // Label 18615: @1295598
     /* 1295598 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1295682), // Rule ID 9082 //
     /* 1295603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295656 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295681 */     // GIR_Coverage, 9082,
     /* 1295681 */     GIR_EraseRootFromParent_Done,
     /* 1295682 */   // Label 18616: @1295682
     /* 1295682 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1295766), // Rule ID 9083 //
     /* 1295687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295740 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295765 */     // GIR_Coverage, 9083,
     /* 1295765 */     GIR_EraseRootFromParent_Done,
     /* 1295766 */   // Label 18617: @1295766
     /* 1295766 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1295850), // Rule ID 9086 //
     /* 1295771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295824 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295849 */     // GIR_Coverage, 9086,
     /* 1295849 */     GIR_EraseRootFromParent_Done,
     /* 1295850 */   // Label 18618: @1295850
     /* 1295850 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1295934), // Rule ID 9087 //
     /* 1295855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295908 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295933 */     // GIR_Coverage, 9087,
     /* 1295933 */     GIR_EraseRootFromParent_Done,
     /* 1295934 */   // Label 18619: @1295934
     /* 1295934 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1296018), // Rule ID 9090 //
     /* 1295939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296017 */     // GIR_Coverage, 9090,
     /* 1296017 */     GIR_EraseRootFromParent_Done,
     /* 1296018 */   // Label 18620: @1296018
     /* 1296018 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1296102), // Rule ID 9091 //
     /* 1296023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1296040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296101 */     // GIR_Coverage, 9091,
     /* 1296101 */     GIR_EraseRootFromParent_Done,
     /* 1296102 */   // Label 18621: @1296102
     /* 1296102 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1296186), // Rule ID 9094 //
     /* 1296107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296160 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296185 */     // GIR_Coverage, 9094,
     /* 1296185 */     GIR_EraseRootFromParent_Done,
     /* 1296186 */   // Label 18622: @1296186
     /* 1296186 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1296270), // Rule ID 9095 //
     /* 1296191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296244 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296269 */     // GIR_Coverage, 9095,
     /* 1296269 */     GIR_EraseRootFromParent_Done,
     /* 1296270 */   // Label 18623: @1296270
     /* 1296270 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1296354), // Rule ID 9098 //
     /* 1296275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296328 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296353 */     // GIR_Coverage, 9098,
     /* 1296353 */     GIR_EraseRootFromParent_Done,
     /* 1296354 */   // Label 18624: @1296354
     /* 1296354 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1296438), // Rule ID 9099 //
     /* 1296359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296412 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296437 */     // GIR_Coverage, 9099,
     /* 1296437 */     GIR_EraseRootFromParent_Done,
     /* 1296438 */   // Label 18625: @1296438
     /* 1296438 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1296522), // Rule ID 9102 //
     /* 1296443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296521 */     // GIR_Coverage, 9102,
     /* 1296521 */     GIR_EraseRootFromParent_Done,
     /* 1296522 */   // Label 18626: @1296522
     /* 1296522 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1296606), // Rule ID 9103 //
     /* 1296527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296605 */     // GIR_Coverage, 9103,
     /* 1296605 */     GIR_EraseRootFromParent_Done,
     /* 1296606 */   // Label 18627: @1296606
     /* 1296606 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1296690), // Rule ID 9106 //
     /* 1296611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296689 */     // GIR_Coverage, 9106,
     /* 1296689 */     GIR_EraseRootFromParent_Done,
     /* 1296690 */   // Label 18628: @1296690
     /* 1296690 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1296774), // Rule ID 9107 //
     /* 1296695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296748 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296773 */     // GIR_Coverage, 9107,
     /* 1296773 */     GIR_EraseRootFromParent_Done,
     /* 1296774 */   // Label 18629: @1296774
     /* 1296774 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1296858), // Rule ID 9110 //
     /* 1296779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296857 */     // GIR_Coverage, 9110,
     /* 1296857 */     GIR_EraseRootFromParent_Done,
     /* 1296858 */   // Label 18630: @1296858
     /* 1296858 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1296942), // Rule ID 9111 //
     /* 1296863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296941 */     // GIR_Coverage, 9111,
     /* 1296941 */     GIR_EraseRootFromParent_Done,
     /* 1296942 */   // Label 18631: @1296942
     /* 1296942 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1297026), // Rule ID 9114 //
     /* 1296947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1297003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297025 */     // GIR_Coverage, 9114,
     /* 1297025 */     GIR_EraseRootFromParent_Done,
     /* 1297026 */   // Label 18632: @1297026
     /* 1297026 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1297110), // Rule ID 9115 //
     /* 1297031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1297048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1297087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297109 */     // GIR_Coverage, 9115,
     /* 1297109 */     GIR_EraseRootFromParent_Done,
     /* 1297110 */   // Label 18633: @1297110
     /* 1297110 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1297194), // Rule ID 9118 //
     /* 1297115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1297171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297193 */     // GIR_Coverage, 9118,
     /* 1297193 */     GIR_EraseRootFromParent_Done,
     /* 1297194 */   // Label 18634: @1297194
     /* 1297194 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1297278), // Rule ID 9119 //
     /* 1297199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297252 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1297255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297277 */     // GIR_Coverage, 9119,
     /* 1297277 */     GIR_EraseRootFromParent_Done,
     /* 1297278 */   // Label 18635: @1297278
     /* 1297278 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1297362), // Rule ID 9122 //
     /* 1297283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1297339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297361 */     // GIR_Coverage, 9122,
     /* 1297361 */     GIR_EraseRootFromParent_Done,
     /* 1297362 */   // Label 18636: @1297362
     /* 1297362 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1297446), // Rule ID 9123 //
     /* 1297367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1297375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1297423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297445 */     // GIR_Coverage, 9123,
     /* 1297445 */     GIR_EraseRootFromParent_Done,
     /* 1297446 */   // Label 18637: @1297446
     /* 1297446 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1297530), // Rule ID 9214 //
     /* 1297451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297529 */     // GIR_Coverage, 9214,
     /* 1297529 */     GIR_EraseRootFromParent_Done,
     /* 1297530 */   // Label 18638: @1297530
     /* 1297530 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1297614), // Rule ID 9215 //
     /* 1297535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297613 */     // GIR_Coverage, 9215,
     /* 1297613 */     GIR_EraseRootFromParent_Done,
     /* 1297614 */   // Label 18639: @1297614
     /* 1297614 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1297698), // Rule ID 9218 //
     /* 1297619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297697 */     // GIR_Coverage, 9218,
     /* 1297697 */     GIR_EraseRootFromParent_Done,
     /* 1297698 */   // Label 18640: @1297698
     /* 1297698 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1297782), // Rule ID 9219 //
     /* 1297703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297781 */     // GIR_Coverage, 9219,
     /* 1297781 */     GIR_EraseRootFromParent_Done,
     /* 1297782 */   // Label 18641: @1297782
     /* 1297782 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1297866), // Rule ID 9222 //
     /* 1297787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297865 */     // GIR_Coverage, 9222,
     /* 1297865 */     GIR_EraseRootFromParent_Done,
     /* 1297866 */   // Label 18642: @1297866
     /* 1297866 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1297950), // Rule ID 9223 //
     /* 1297871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297949 */     // GIR_Coverage, 9223,
     /* 1297949 */     GIR_EraseRootFromParent_Done,
     /* 1297950 */   // Label 18643: @1297950
     /* 1297950 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1298034), // Rule ID 9226 //
     /* 1297955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1298011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298033 */     // GIR_Coverage, 9226,
     /* 1298033 */     GIR_EraseRootFromParent_Done,
     /* 1298034 */   // Label 18644: @1298034
     /* 1298034 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1298118), // Rule ID 9227 //
     /* 1298039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1298095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298117 */     // GIR_Coverage, 9227,
     /* 1298117 */     GIR_EraseRootFromParent_Done,
     /* 1298118 */   // Label 18645: @1298118
     /* 1298118 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1298202), // Rule ID 9230 //
     /* 1298123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298176 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298201 */     // GIR_Coverage, 9230,
     /* 1298201 */     GIR_EraseRootFromParent_Done,
     /* 1298202 */   // Label 18646: @1298202
     /* 1298202 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1298286), // Rule ID 9231 //
     /* 1298207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298285 */     // GIR_Coverage, 9231,
     /* 1298285 */     GIR_EraseRootFromParent_Done,
     /* 1298286 */   // Label 18647: @1298286
     /* 1298286 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1298370), // Rule ID 9234 //
     /* 1298291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298369 */     // GIR_Coverage, 9234,
     /* 1298369 */     GIR_EraseRootFromParent_Done,
     /* 1298370 */   // Label 18648: @1298370
     /* 1298370 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1298454), // Rule ID 9235 //
     /* 1298375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1298431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298453 */     // GIR_Coverage, 9235,
     /* 1298453 */     GIR_EraseRootFromParent_Done,
     /* 1298454 */   // Label 18649: @1298454
     /* 1298454 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1298538), // Rule ID 9238 //
     /* 1298459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298537 */     // GIR_Coverage, 9238,
     /* 1298537 */     GIR_EraseRootFromParent_Done,
     /* 1298538 */   // Label 18650: @1298538
     /* 1298538 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1298622), // Rule ID 9239 //
     /* 1298543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298621 */     // GIR_Coverage, 9239,
     /* 1298621 */     GIR_EraseRootFromParent_Done,
     /* 1298622 */   // Label 18651: @1298622
     /* 1298622 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1298706), // Rule ID 9242 //
     /* 1298627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298705 */     // GIR_Coverage, 9242,
     /* 1298705 */     GIR_EraseRootFromParent_Done,
     /* 1298706 */   // Label 18652: @1298706
     /* 1298706 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1298790), // Rule ID 9243 //
     /* 1298711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298789 */     // GIR_Coverage, 9243,
     /* 1298789 */     GIR_EraseRootFromParent_Done,
     /* 1298790 */   // Label 18653: @1298790
     /* 1298790 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1298874), // Rule ID 9246 //
     /* 1298795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298873 */     // GIR_Coverage, 9246,
     /* 1298873 */     GIR_EraseRootFromParent_Done,
     /* 1298874 */   // Label 18654: @1298874
     /* 1298874 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1298958), // Rule ID 9247 //
     /* 1298879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298957 */     // GIR_Coverage, 9247,
     /* 1298957 */     GIR_EraseRootFromParent_Done,
     /* 1298958 */   // Label 18655: @1298958
     /* 1298958 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1299042), // Rule ID 9250 //
     /* 1298963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1299019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299041 */     // GIR_Coverage, 9250,
     /* 1299041 */     GIR_EraseRootFromParent_Done,
     /* 1299042 */   // Label 18656: @1299042
     /* 1299042 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1299126), // Rule ID 9251 //
     /* 1299047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1299050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1299103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299125 */     // GIR_Coverage, 9251,
     /* 1299125 */     GIR_EraseRootFromParent_Done,
     /* 1299126 */   // Label 18657: @1299126
     /* 1299126 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1299210), // Rule ID 9254 //
     /* 1299131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299209 */     // GIR_Coverage, 9254,
     /* 1299209 */     GIR_EraseRootFromParent_Done,
     /* 1299210 */   // Label 18658: @1299210
     /* 1299210 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1299294), // Rule ID 9255 //
     /* 1299215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299293 */     // GIR_Coverage, 9255,
     /* 1299293 */     GIR_EraseRootFromParent_Done,
     /* 1299294 */   // Label 18659: @1299294
     /* 1299294 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1299378), // Rule ID 9258 //
     /* 1299299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299352 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299377 */     // GIR_Coverage, 9258,
     /* 1299377 */     GIR_EraseRootFromParent_Done,
     /* 1299378 */   // Label 18660: @1299378
     /* 1299378 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1299462), // Rule ID 9259 //
     /* 1299383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299436 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299461 */     // GIR_Coverage, 9259,
     /* 1299461 */     GIR_EraseRootFromParent_Done,
     /* 1299462 */   // Label 18661: @1299462
     /* 1299462 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1299546), // Rule ID 9262 //
     /* 1299467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299520 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299545 */     // GIR_Coverage, 9262,
     /* 1299545 */     GIR_EraseRootFromParent_Done,
     /* 1299546 */   // Label 18662: @1299546
     /* 1299546 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1299630), // Rule ID 9263 //
     /* 1299551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299604 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299629 */     // GIR_Coverage, 9263,
     /* 1299629 */     GIR_EraseRootFromParent_Done,
     /* 1299630 */   // Label 18663: @1299630
     /* 1299630 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1299714), // Rule ID 9266 //
     /* 1299635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299713 */     // GIR_Coverage, 9266,
     /* 1299713 */     GIR_EraseRootFromParent_Done,
     /* 1299714 */   // Label 18664: @1299714
     /* 1299714 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1299798), // Rule ID 9267 //
     /* 1299719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299797 */     // GIR_Coverage, 9267,
     /* 1299797 */     GIR_EraseRootFromParent_Done,
     /* 1299798 */   // Label 18665: @1299798
     /* 1299798 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1299882), // Rule ID 9270 //
     /* 1299803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299881 */     // GIR_Coverage, 9270,
     /* 1299881 */     GIR_EraseRootFromParent_Done,
     /* 1299882 */   // Label 18666: @1299882
     /* 1299882 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1299966), // Rule ID 9271 //
     /* 1299887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299940 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299965 */     // GIR_Coverage, 9271,
     /* 1299965 */     GIR_EraseRootFromParent_Done,
     /* 1299966 */   // Label 18667: @1299966
     /* 1299966 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1300050), // Rule ID 9274 //
     /* 1299971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300024 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300049 */     // GIR_Coverage, 9274,
     /* 1300049 */     GIR_EraseRootFromParent_Done,
     /* 1300050 */   // Label 18668: @1300050
     /* 1300050 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1300134), // Rule ID 9275 //
     /* 1300055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300108 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300133 */     // GIR_Coverage, 9275,
     /* 1300133 */     GIR_EraseRootFromParent_Done,
     /* 1300134 */   // Label 18669: @1300134
     /* 1300134 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1300218), // Rule ID 9278 //
     /* 1300139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300217 */     // GIR_Coverage, 9278,
     /* 1300217 */     GIR_EraseRootFromParent_Done,
     /* 1300218 */   // Label 18670: @1300218
     /* 1300218 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1300302), // Rule ID 9279 //
     /* 1300223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300276 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300301 */     // GIR_Coverage, 9279,
     /* 1300301 */     GIR_EraseRootFromParent_Done,
     /* 1300302 */   // Label 18671: @1300302
     /* 1300302 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1300386), // Rule ID 9282 //
     /* 1300307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300385 */     // GIR_Coverage, 9282,
     /* 1300385 */     GIR_EraseRootFromParent_Done,
     /* 1300386 */   // Label 18672: @1300386
     /* 1300386 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1300470), // Rule ID 9283 //
     /* 1300391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300469 */     // GIR_Coverage, 9283,
     /* 1300469 */     GIR_EraseRootFromParent_Done,
     /* 1300470 */   // Label 18673: @1300470
     /* 1300470 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1300554), // Rule ID 9286 //
     /* 1300475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300553 */     // GIR_Coverage, 9286,
     /* 1300553 */     GIR_EraseRootFromParent_Done,
     /* 1300554 */   // Label 18674: @1300554
     /* 1300554 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1300638), // Rule ID 9287 //
     /* 1300559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300637 */     // GIR_Coverage, 9287,
     /* 1300637 */     GIR_EraseRootFromParent_Done,
     /* 1300638 */   // Label 18675: @1300638
     /* 1300638 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1300722), // Rule ID 9290 //
     /* 1300643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300721 */     // GIR_Coverage, 9290,
     /* 1300721 */     GIR_EraseRootFromParent_Done,
     /* 1300722 */   // Label 18676: @1300722
     /* 1300722 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1300806), // Rule ID 9291 //
     /* 1300727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300805 */     // GIR_Coverage, 9291,
     /* 1300805 */     GIR_EraseRootFromParent_Done,
     /* 1300806 */   // Label 18677: @1300806
     /* 1300806 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1300890), // Rule ID 9294 //
     /* 1300811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300889 */     // GIR_Coverage, 9294,
     /* 1300889 */     GIR_EraseRootFromParent_Done,
     /* 1300890 */   // Label 18678: @1300890
     /* 1300890 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1300974), // Rule ID 9295 //
     /* 1300895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300973 */     // GIR_Coverage, 9295,
     /* 1300973 */     GIR_EraseRootFromParent_Done,
     /* 1300974 */   // Label 18679: @1300974
     /* 1300974 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1301058), // Rule ID 9298 //
     /* 1300979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1301035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301057 */     // GIR_Coverage, 9298,
     /* 1301057 */     GIR_EraseRootFromParent_Done,
     /* 1301058 */   // Label 18680: @1301058
     /* 1301058 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1301142), // Rule ID 9299 //
     /* 1301063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1301119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301141 */     // GIR_Coverage, 9299,
     /* 1301141 */     GIR_EraseRootFromParent_Done,
     /* 1301142 */   // Label 18681: @1301142
     /* 1301142 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1301226), // Rule ID 9390 //
     /* 1301147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1301203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301225 */     // GIR_Coverage, 9390,
     /* 1301225 */     GIR_EraseRootFromParent_Done,
     /* 1301226 */   // Label 18682: @1301226
     /* 1301226 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1301310), // Rule ID 9391 //
     /* 1301231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301284 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1301287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301309 */     // GIR_Coverage, 9391,
     /* 1301309 */     GIR_EraseRootFromParent_Done,
     /* 1301310 */   // Label 18683: @1301310
     /* 1301310 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1301394), // Rule ID 9394 //
     /* 1301315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301393 */     // GIR_Coverage, 9394,
     /* 1301393 */     GIR_EraseRootFromParent_Done,
     /* 1301394 */   // Label 18684: @1301394
     /* 1301394 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1301478), // Rule ID 9395 //
     /* 1301399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301477 */     // GIR_Coverage, 9395,
     /* 1301477 */     GIR_EraseRootFromParent_Done,
     /* 1301478 */   // Label 18685: @1301478
     /* 1301478 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1301562), // Rule ID 9398 //
     /* 1301483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301561 */     // GIR_Coverage, 9398,
     /* 1301561 */     GIR_EraseRootFromParent_Done,
     /* 1301562 */   // Label 18686: @1301562
     /* 1301562 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1301646), // Rule ID 9399 //
     /* 1301567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301645 */     // GIR_Coverage, 9399,
     /* 1301645 */     GIR_EraseRootFromParent_Done,
     /* 1301646 */   // Label 18687: @1301646
     /* 1301646 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1301730), // Rule ID 9402 //
     /* 1301651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301729 */     // GIR_Coverage, 9402,
     /* 1301729 */     GIR_EraseRootFromParent_Done,
     /* 1301730 */   // Label 18688: @1301730
     /* 1301730 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1301814), // Rule ID 9403 //
     /* 1301735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301813 */     // GIR_Coverage, 9403,
     /* 1301813 */     GIR_EraseRootFromParent_Done,
     /* 1301814 */   // Label 18689: @1301814
     /* 1301814 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1301898), // Rule ID 9406 //
     /* 1301819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301897 */     // GIR_Coverage, 9406,
     /* 1301897 */     GIR_EraseRootFromParent_Done,
     /* 1301898 */   // Label 18690: @1301898
     /* 1301898 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1301982), // Rule ID 9407 //
     /* 1301903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301981 */     // GIR_Coverage, 9407,
     /* 1301981 */     GIR_EraseRootFromParent_Done,
     /* 1301982 */   // Label 18691: @1301982
     /* 1301982 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1302066), // Rule ID 9410 //
     /* 1301987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1302043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302065 */     // GIR_Coverage, 9410,
     /* 1302065 */     GIR_EraseRootFromParent_Done,
     /* 1302066 */   // Label 18692: @1302066
     /* 1302066 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1302150), // Rule ID 9411 //
     /* 1302071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1302127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302149 */     // GIR_Coverage, 9411,
     /* 1302149 */     GIR_EraseRootFromParent_Done,
     /* 1302150 */   // Label 18693: @1302150
     /* 1302150 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1302234), // Rule ID 9414 //
     /* 1302155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302233 */     // GIR_Coverage, 9414,
     /* 1302233 */     GIR_EraseRootFromParent_Done,
     /* 1302234 */   // Label 18694: @1302234
     /* 1302234 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1302318), // Rule ID 9415 //
     /* 1302239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302317 */     // GIR_Coverage, 9415,
     /* 1302317 */     GIR_EraseRootFromParent_Done,
     /* 1302318 */   // Label 18695: @1302318
     /* 1302318 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1302402), // Rule ID 9418 //
     /* 1302323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302401 */     // GIR_Coverage, 9418,
     /* 1302401 */     GIR_EraseRootFromParent_Done,
     /* 1302402 */   // Label 18696: @1302402
     /* 1302402 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1302486), // Rule ID 9419 //
     /* 1302407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302485 */     // GIR_Coverage, 9419,
     /* 1302485 */     GIR_EraseRootFromParent_Done,
     /* 1302486 */   // Label 18697: @1302486
     /* 1302486 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1302570), // Rule ID 9422 //
     /* 1302491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302569 */     // GIR_Coverage, 9422,
     /* 1302569 */     GIR_EraseRootFromParent_Done,
     /* 1302570 */   // Label 18698: @1302570
     /* 1302570 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1302654), // Rule ID 9423 //
     /* 1302575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302628 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302653 */     // GIR_Coverage, 9423,
     /* 1302653 */     GIR_EraseRootFromParent_Done,
     /* 1302654 */   // Label 18699: @1302654
     /* 1302654 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1302738), // Rule ID 9426 //
     /* 1302659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302737 */     // GIR_Coverage, 9426,
     /* 1302737 */     GIR_EraseRootFromParent_Done,
     /* 1302738 */   // Label 18700: @1302738
     /* 1302738 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1302822), // Rule ID 9427 //
     /* 1302743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302821 */     // GIR_Coverage, 9427,
     /* 1302821 */     GIR_EraseRootFromParent_Done,
     /* 1302822 */   // Label 18701: @1302822
     /* 1302822 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1302906), // Rule ID 9430 //
     /* 1302827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302905 */     // GIR_Coverage, 9430,
     /* 1302905 */     GIR_EraseRootFromParent_Done,
     /* 1302906 */   // Label 18702: @1302906
     /* 1302906 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1302990), // Rule ID 9431 //
     /* 1302911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302989 */     // GIR_Coverage, 9431,
     /* 1302989 */     GIR_EraseRootFromParent_Done,
     /* 1302990 */   // Label 18703: @1302990
     /* 1302990 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1303074), // Rule ID 9434 //
     /* 1302995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303073 */     // GIR_Coverage, 9434,
     /* 1303073 */     GIR_EraseRootFromParent_Done,
     /* 1303074 */   // Label 18704: @1303074
     /* 1303074 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1303158), // Rule ID 9435 //
     /* 1303079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303132 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303157 */     // GIR_Coverage, 9435,
     /* 1303157 */     GIR_EraseRootFromParent_Done,
     /* 1303158 */   // Label 18705: @1303158
     /* 1303158 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1303242), // Rule ID 9438 //
     /* 1303163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303216 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303241 */     // GIR_Coverage, 9438,
     /* 1303241 */     GIR_EraseRootFromParent_Done,
     /* 1303242 */   // Label 18706: @1303242
     /* 1303242 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1303326), // Rule ID 9439 //
     /* 1303247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303300 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303325 */     // GIR_Coverage, 9439,
     /* 1303325 */     GIR_EraseRootFromParent_Done,
     /* 1303326 */   // Label 18707: @1303326
     /* 1303326 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1303410), // Rule ID 9442 //
     /* 1303331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303409 */     // GIR_Coverage, 9442,
     /* 1303409 */     GIR_EraseRootFromParent_Done,
     /* 1303410 */   // Label 18708: @1303410
     /* 1303410 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1303494), // Rule ID 9443 //
     /* 1303415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303493 */     // GIR_Coverage, 9443,
     /* 1303493 */     GIR_EraseRootFromParent_Done,
     /* 1303494 */   // Label 18709: @1303494
     /* 1303494 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1303578), // Rule ID 9446 //
     /* 1303499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303577 */     // GIR_Coverage, 9446,
     /* 1303577 */     GIR_EraseRootFromParent_Done,
     /* 1303578 */   // Label 18710: @1303578
     /* 1303578 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1303662), // Rule ID 9447 //
     /* 1303583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303661 */     // GIR_Coverage, 9447,
     /* 1303661 */     GIR_EraseRootFromParent_Done,
     /* 1303662 */   // Label 18711: @1303662
     /* 1303662 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1303746), // Rule ID 9450 //
     /* 1303667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303745 */     // GIR_Coverage, 9450,
     /* 1303745 */     GIR_EraseRootFromParent_Done,
     /* 1303746 */   // Label 18712: @1303746
     /* 1303746 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1303830), // Rule ID 9451 //
     /* 1303751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303804 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303829 */     // GIR_Coverage, 9451,
     /* 1303829 */     GIR_EraseRootFromParent_Done,
     /* 1303830 */   // Label 18713: @1303830
     /* 1303830 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1303914), // Rule ID 9454 //
     /* 1303835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303913 */     // GIR_Coverage, 9454,
     /* 1303913 */     GIR_EraseRootFromParent_Done,
     /* 1303914 */   // Label 18714: @1303914
     /* 1303914 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1303998), // Rule ID 9455 //
     /* 1303919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303997 */     // GIR_Coverage, 9455,
     /* 1303997 */     GIR_EraseRootFromParent_Done,
     /* 1303998 */   // Label 18715: @1303998
     /* 1303998 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1304082), // Rule ID 9458 //
     /* 1304003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304081 */     // GIR_Coverage, 9458,
     /* 1304081 */     GIR_EraseRootFromParent_Done,
     /* 1304082 */   // Label 18716: @1304082
     /* 1304082 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1304166), // Rule ID 9459 //
     /* 1304087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304165 */     // GIR_Coverage, 9459,
     /* 1304165 */     GIR_EraseRootFromParent_Done,
     /* 1304166 */   // Label 18717: @1304166
     /* 1304166 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1304250), // Rule ID 9462 //
     /* 1304171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304249 */     // GIR_Coverage, 9462,
     /* 1304249 */     GIR_EraseRootFromParent_Done,
     /* 1304250 */   // Label 18718: @1304250
     /* 1304250 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1304334), // Rule ID 9463 //
     /* 1304255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304333 */     // GIR_Coverage, 9463,
     /* 1304333 */     GIR_EraseRootFromParent_Done,
     /* 1304334 */   // Label 18719: @1304334
     /* 1304334 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1304418), // Rule ID 9466 //
     /* 1304339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304417 */     // GIR_Coverage, 9466,
     /* 1304417 */     GIR_EraseRootFromParent_Done,
     /* 1304418 */   // Label 18720: @1304418
     /* 1304418 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1304502), // Rule ID 9467 //
     /* 1304423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304501 */     // GIR_Coverage, 9467,
     /* 1304501 */     GIR_EraseRootFromParent_Done,
     /* 1304502 */   // Label 18721: @1304502
     /* 1304502 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1304586), // Rule ID 9470 //
     /* 1304507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304585 */     // GIR_Coverage, 9470,
     /* 1304585 */     GIR_EraseRootFromParent_Done,
     /* 1304586 */   // Label 18722: @1304586
     /* 1304586 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1304670), // Rule ID 9471 //
     /* 1304591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304669 */     // GIR_Coverage, 9471,
     /* 1304669 */     GIR_EraseRootFromParent_Done,
     /* 1304670 */   // Label 18723: @1304670
     /* 1304670 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1304754), // Rule ID 9474 //
     /* 1304675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304753 */     // GIR_Coverage, 9474,
     /* 1304753 */     GIR_EraseRootFromParent_Done,
     /* 1304754 */   // Label 18724: @1304754
     /* 1304754 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1304838), // Rule ID 9475 //
     /* 1304759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304837 */     // GIR_Coverage, 9475,
     /* 1304837 */     GIR_EraseRootFromParent_Done,
     /* 1304838 */   // Label 18725: @1304838
     /* 1304838 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1304922), // Rule ID 9566 //
     /* 1304843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304921 */     // GIR_Coverage, 9566,
     /* 1304921 */     GIR_EraseRootFromParent_Done,
     /* 1304922 */   // Label 18726: @1304922
     /* 1304922 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1305006), // Rule ID 9567 //
     /* 1304927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305005 */     // GIR_Coverage, 9567,
     /* 1305005 */     GIR_EraseRootFromParent_Done,
     /* 1305006 */   // Label 18727: @1305006
     /* 1305006 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1305090), // Rule ID 9570 //
     /* 1305011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305089 */     // GIR_Coverage, 9570,
     /* 1305089 */     GIR_EraseRootFromParent_Done,
     /* 1305090 */   // Label 18728: @1305090
     /* 1305090 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1305174), // Rule ID 9571 //
     /* 1305095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305148 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305173 */     // GIR_Coverage, 9571,
     /* 1305173 */     GIR_EraseRootFromParent_Done,
     /* 1305174 */   // Label 18729: @1305174
     /* 1305174 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1305258), // Rule ID 9574 //
     /* 1305179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1305235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305257 */     // GIR_Coverage, 9574,
     /* 1305257 */     GIR_EraseRootFromParent_Done,
     /* 1305258 */   // Label 18730: @1305258
     /* 1305258 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1305342), // Rule ID 9575 //
     /* 1305263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1305319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305341 */     // GIR_Coverage, 9575,
     /* 1305341 */     GIR_EraseRootFromParent_Done,
     /* 1305342 */   // Label 18731: @1305342
     /* 1305342 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1305426), // Rule ID 9578 //
     /* 1305347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305425 */     // GIR_Coverage, 9578,
     /* 1305425 */     GIR_EraseRootFromParent_Done,
     /* 1305426 */   // Label 18732: @1305426
     /* 1305426 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1305510), // Rule ID 9579 //
     /* 1305431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305509 */     // GIR_Coverage, 9579,
     /* 1305509 */     GIR_EraseRootFromParent_Done,
     /* 1305510 */   // Label 18733: @1305510
     /* 1305510 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1305594), // Rule ID 9582 //
     /* 1305515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305593 */     // GIR_Coverage, 9582,
     /* 1305593 */     GIR_EraseRootFromParent_Done,
     /* 1305594 */   // Label 18734: @1305594
     /* 1305594 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1305678), // Rule ID 9583 //
     /* 1305599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305677 */     // GIR_Coverage, 9583,
     /* 1305677 */     GIR_EraseRootFromParent_Done,
     /* 1305678 */   // Label 18735: @1305678
     /* 1305678 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1305762), // Rule ID 9586 //
     /* 1305683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305761 */     // GIR_Coverage, 9586,
     /* 1305761 */     GIR_EraseRootFromParent_Done,
     /* 1305762 */   // Label 18736: @1305762
     /* 1305762 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1305846), // Rule ID 9587 //
     /* 1305767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305845 */     // GIR_Coverage, 9587,
     /* 1305845 */     GIR_EraseRootFromParent_Done,
     /* 1305846 */   // Label 18737: @1305846
     /* 1305846 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1305930), // Rule ID 9590 //
     /* 1305851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305929 */     // GIR_Coverage, 9590,
     /* 1305929 */     GIR_EraseRootFromParent_Done,
     /* 1305930 */   // Label 18738: @1305930
     /* 1305930 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1306014), // Rule ID 9591 //
     /* 1305935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306013 */     // GIR_Coverage, 9591,
     /* 1306013 */     GIR_EraseRootFromParent_Done,
     /* 1306014 */   // Label 18739: @1306014
     /* 1306014 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1306098), // Rule ID 9594 //
     /* 1306019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306097 */     // GIR_Coverage, 9594,
     /* 1306097 */     GIR_EraseRootFromParent_Done,
     /* 1306098 */   // Label 18740: @1306098
     /* 1306098 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1306182), // Rule ID 9595 //
     /* 1306103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306181 */     // GIR_Coverage, 9595,
     /* 1306181 */     GIR_EraseRootFromParent_Done,
     /* 1306182 */   // Label 18741: @1306182
     /* 1306182 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1306266), // Rule ID 9598 //
     /* 1306187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1306190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306265 */     // GIR_Coverage, 9598,
     /* 1306265 */     GIR_EraseRootFromParent_Done,
     /* 1306266 */   // Label 18742: @1306266
     /* 1306266 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1306350), // Rule ID 9599 //
     /* 1306271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1306274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1306327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306349 */     // GIR_Coverage, 9599,
     /* 1306349 */     GIR_EraseRootFromParent_Done,
     /* 1306350 */   // Label 18743: @1306350
     /* 1306350 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1306434), // Rule ID 9602 //
     /* 1306355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306433 */     // GIR_Coverage, 9602,
     /* 1306433 */     GIR_EraseRootFromParent_Done,
     /* 1306434 */   // Label 18744: @1306434
     /* 1306434 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1306518), // Rule ID 9603 //
     /* 1306439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306492 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306517 */     // GIR_Coverage, 9603,
     /* 1306517 */     GIR_EraseRootFromParent_Done,
     /* 1306518 */   // Label 18745: @1306518
     /* 1306518 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1306602), // Rule ID 9606 //
     /* 1306523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306601 */     // GIR_Coverage, 9606,
     /* 1306601 */     GIR_EraseRootFromParent_Done,
     /* 1306602 */   // Label 18746: @1306602
     /* 1306602 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1306686), // Rule ID 9607 //
     /* 1306607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306660 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306685 */     // GIR_Coverage, 9607,
     /* 1306685 */     GIR_EraseRootFromParent_Done,
     /* 1306686 */   // Label 18747: @1306686
     /* 1306686 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1306770), // Rule ID 9610 //
     /* 1306691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306744 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306769 */     // GIR_Coverage, 9610,
     /* 1306769 */     GIR_EraseRootFromParent_Done,
     /* 1306770 */   // Label 18748: @1306770
     /* 1306770 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1306854), // Rule ID 9611 //
     /* 1306775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306828 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306853 */     // GIR_Coverage, 9611,
     /* 1306853 */     GIR_EraseRootFromParent_Done,
     /* 1306854 */   // Label 18749: @1306854
     /* 1306854 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1306938), // Rule ID 9614 //
     /* 1306859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306937 */     // GIR_Coverage, 9614,
     /* 1306937 */     GIR_EraseRootFromParent_Done,
     /* 1306938 */   // Label 18750: @1306938
     /* 1306938 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1307022), // Rule ID 9615 //
     /* 1306943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307021 */     // GIR_Coverage, 9615,
     /* 1307021 */     GIR_EraseRootFromParent_Done,
     /* 1307022 */   // Label 18751: @1307022
     /* 1307022 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1307106), // Rule ID 9618 //
     /* 1307027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307105 */     // GIR_Coverage, 9618,
     /* 1307105 */     GIR_EraseRootFromParent_Done,
     /* 1307106 */   // Label 18752: @1307106
     /* 1307106 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1307190), // Rule ID 9619 //
     /* 1307111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307164 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307189 */     // GIR_Coverage, 9619,
     /* 1307189 */     GIR_EraseRootFromParent_Done,
     /* 1307190 */   // Label 18753: @1307190
     /* 1307190 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1307274), // Rule ID 9622 //
     /* 1307195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307248 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307273 */     // GIR_Coverage, 9622,
     /* 1307273 */     GIR_EraseRootFromParent_Done,
     /* 1307274 */   // Label 18754: @1307274
     /* 1307274 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1307358), // Rule ID 9623 //
     /* 1307279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307332 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307357 */     // GIR_Coverage, 9623,
     /* 1307357 */     GIR_EraseRootFromParent_Done,
     /* 1307358 */   // Label 18755: @1307358
     /* 1307358 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1307442), // Rule ID 9626 //
     /* 1307363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307441 */     // GIR_Coverage, 9626,
     /* 1307441 */     GIR_EraseRootFromParent_Done,
     /* 1307442 */   // Label 18756: @1307442
     /* 1307442 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1307526), // Rule ID 9627 //
     /* 1307447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307525 */     // GIR_Coverage, 9627,
     /* 1307525 */     GIR_EraseRootFromParent_Done,
     /* 1307526 */   // Label 18757: @1307526
     /* 1307526 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1307610), // Rule ID 9630 //
     /* 1307531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307609 */     // GIR_Coverage, 9630,
     /* 1307609 */     GIR_EraseRootFromParent_Done,
     /* 1307610 */   // Label 18758: @1307610
     /* 1307610 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1307694), // Rule ID 9631 //
     /* 1307615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307668 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307693 */     // GIR_Coverage, 9631,
     /* 1307693 */     GIR_EraseRootFromParent_Done,
     /* 1307694 */   // Label 18759: @1307694
     /* 1307694 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1307778), // Rule ID 9634 //
     /* 1307699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307752 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307777 */     // GIR_Coverage, 9634,
     /* 1307777 */     GIR_EraseRootFromParent_Done,
     /* 1307778 */   // Label 18760: @1307778
     /* 1307778 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1307862), // Rule ID 9635 //
     /* 1307783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307836 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307861 */     // GIR_Coverage, 9635,
     /* 1307861 */     GIR_EraseRootFromParent_Done,
     /* 1307862 */   // Label 18761: @1307862
     /* 1307862 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1307946), // Rule ID 9638 //
     /* 1307867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307945 */     // GIR_Coverage, 9638,
     /* 1307945 */     GIR_EraseRootFromParent_Done,
     /* 1307946 */   // Label 18762: @1307946
     /* 1307946 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1308030), // Rule ID 9639 //
     /* 1307951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1308007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308029 */     // GIR_Coverage, 9639,
     /* 1308029 */     GIR_EraseRootFromParent_Done,
     /* 1308030 */   // Label 18763: @1308030
     /* 1308030 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1308114), // Rule ID 9642 //
     /* 1308035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1308091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308113 */     // GIR_Coverage, 9642,
     /* 1308113 */     GIR_EraseRootFromParent_Done,
     /* 1308114 */   // Label 18764: @1308114
     /* 1308114 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1308198), // Rule ID 9643 //
     /* 1308119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1308175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308197 */     // GIR_Coverage, 9643,
     /* 1308197 */     GIR_EraseRootFromParent_Done,
     /* 1308198 */   // Label 18765: @1308198
     /* 1308198 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1308282), // Rule ID 9646 //
     /* 1308203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1308259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308281 */     // GIR_Coverage, 9646,
     /* 1308281 */     GIR_EraseRootFromParent_Done,
     /* 1308282 */   // Label 18766: @1308282
     /* 1308282 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1308366), // Rule ID 9647 //
     /* 1308287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1308295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1308343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308365 */     // GIR_Coverage, 9647,
     /* 1308365 */     GIR_EraseRootFromParent_Done,
     /* 1308366 */   // Label 18767: @1308366
     /* 1308366 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1308450), // Rule ID 9650 //
     /* 1308371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308449 */     // GIR_Coverage, 9650,
     /* 1308449 */     GIR_EraseRootFromParent_Done,
     /* 1308450 */   // Label 18768: @1308450
     /* 1308450 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1308534), // Rule ID 9651 //
     /* 1308455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308533 */     // GIR_Coverage, 9651,
     /* 1308533 */     GIR_EraseRootFromParent_Done,
     /* 1308534 */   // Label 18769: @1308534
     /* 1308534 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1308618), // Rule ID 9654 //
     /* 1308539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308617 */     // GIR_Coverage, 9654,
     /* 1308617 */     GIR_EraseRootFromParent_Done,
     /* 1308618 */   // Label 18770: @1308618
     /* 1308618 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1308702), // Rule ID 9655 //
     /* 1308623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308676 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308701 */     // GIR_Coverage, 9655,
     /* 1308701 */     GIR_EraseRootFromParent_Done,
     /* 1308702 */   // Label 18771: @1308702
     /* 1308702 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1308786), // Rule ID 9658 //
     /* 1308707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308785 */     // GIR_Coverage, 9658,
     /* 1308785 */     GIR_EraseRootFromParent_Done,
     /* 1308786 */   // Label 18772: @1308786
     /* 1308786 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1308870), // Rule ID 9659 //
     /* 1308791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308869 */     // GIR_Coverage, 9659,
     /* 1308869 */     GIR_EraseRootFromParent_Done,
     /* 1308870 */   // Label 18773: @1308870
     /* 1308870 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1308954), // Rule ID 9662 //
     /* 1308875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308953 */     // GIR_Coverage, 9662,
     /* 1308953 */     GIR_EraseRootFromParent_Done,
     /* 1308954 */   // Label 18774: @1308954
     /* 1308954 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1309038), // Rule ID 9663 //
     /* 1308959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1309015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309037 */     // GIR_Coverage, 9663,
     /* 1309037 */     GIR_EraseRootFromParent_Done,
     /* 1309038 */   // Label 18775: @1309038
     /* 1309038 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1309122), // Rule ID 9666 //
     /* 1309043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309121 */     // GIR_Coverage, 9666,
     /* 1309121 */     GIR_EraseRootFromParent_Done,
     /* 1309122 */   // Label 18776: @1309122
     /* 1309122 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1309206), // Rule ID 9667 //
     /* 1309127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309205 */     // GIR_Coverage, 9667,
     /* 1309205 */     GIR_EraseRootFromParent_Done,
     /* 1309206 */   // Label 18777: @1309206
     /* 1309206 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1309290), // Rule ID 9670 //
     /* 1309211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309289 */     // GIR_Coverage, 9670,
     /* 1309289 */     GIR_EraseRootFromParent_Done,
     /* 1309290 */   // Label 18778: @1309290
     /* 1309290 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1309374), // Rule ID 9671 //
     /* 1309295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309348 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1309351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309373 */     // GIR_Coverage, 9671,
     /* 1309373 */     GIR_EraseRootFromParent_Done,
     /* 1309374 */   // Label 18779: @1309374
     /* 1309374 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1309458), // Rule ID 9674 //
     /* 1309379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309457 */     // GIR_Coverage, 9674,
     /* 1309457 */     GIR_EraseRootFromParent_Done,
     /* 1309458 */   // Label 18780: @1309458
     /* 1309458 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1309542), // Rule ID 9675 //
     /* 1309463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309541 */     // GIR_Coverage, 9675,
     /* 1309541 */     GIR_EraseRootFromParent_Done,
     /* 1309542 */   // Label 18781: @1309542
     /* 1309542 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1309626), // Rule ID 9678 //
     /* 1309547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309625 */     // GIR_Coverage, 9678,
     /* 1309625 */     GIR_EraseRootFromParent_Done,
     /* 1309626 */   // Label 18782: @1309626
     /* 1309626 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1309710), // Rule ID 9679 //
     /* 1309631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309709 */     // GIR_Coverage, 9679,
     /* 1309709 */     GIR_EraseRootFromParent_Done,
     /* 1309710 */   // Label 18783: @1309710
     /* 1309710 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1309794), // Rule ID 9682 //
     /* 1309715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309793 */     // GIR_Coverage, 9682,
     /* 1309793 */     GIR_EraseRootFromParent_Done,
     /* 1309794 */   // Label 18784: @1309794
     /* 1309794 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1309878), // Rule ID 9683 //
     /* 1309799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309852 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309877 */     // GIR_Coverage, 9683,
     /* 1309877 */     GIR_EraseRootFromParent_Done,
     /* 1309878 */   // Label 18785: @1309878
     /* 1309878 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1309962), // Rule ID 9686 //
     /* 1309883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309961 */     // GIR_Coverage, 9686,
     /* 1309961 */     GIR_EraseRootFromParent_Done,
     /* 1309962 */   // Label 18786: @1309962
     /* 1309962 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1310046), // Rule ID 9687 //
     /* 1309967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1310023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310045 */     // GIR_Coverage, 9687,
     /* 1310045 */     GIR_EraseRootFromParent_Done,
     /* 1310046 */   // Label 18787: @1310046
     /* 1310046 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1310130), // Rule ID 9690 //
     /* 1310051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310129 */     // GIR_Coverage, 9690,
     /* 1310129 */     GIR_EraseRootFromParent_Done,
     /* 1310130 */   // Label 18788: @1310130
     /* 1310130 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1310214), // Rule ID 9691 //
     /* 1310135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310213 */     // GIR_Coverage, 9691,
     /* 1310213 */     GIR_EraseRootFromParent_Done,
     /* 1310214 */   // Label 18789: @1310214
     /* 1310214 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1310298), // Rule ID 9694 //
     /* 1310219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310297 */     // GIR_Coverage, 9694,
     /* 1310297 */     GIR_EraseRootFromParent_Done,
     /* 1310298 */   // Label 18790: @1310298
     /* 1310298 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1310382), // Rule ID 9695 //
     /* 1310303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310356 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310381 */     // GIR_Coverage, 9695,
     /* 1310381 */     GIR_EraseRootFromParent_Done,
     /* 1310382 */   // Label 18791: @1310382
     /* 1310382 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1310466), // Rule ID 9698 //
     /* 1310387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310440 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310465 */     // GIR_Coverage, 9698,
     /* 1310465 */     GIR_EraseRootFromParent_Done,
     /* 1310466 */   // Label 18792: @1310466
     /* 1310466 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1310550), // Rule ID 9699 //
     /* 1310471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310524 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310549 */     // GIR_Coverage, 9699,
     /* 1310549 */     GIR_EraseRootFromParent_Done,
     /* 1310550 */   // Label 18793: @1310550
     /* 1310550 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1310634), // Rule ID 9702 //
     /* 1310555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310633 */     // GIR_Coverage, 9702,
     /* 1310633 */     GIR_EraseRootFromParent_Done,
     /* 1310634 */   // Label 18794: @1310634
     /* 1310634 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1310718), // Rule ID 9703 //
     /* 1310639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310692 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310717 */     // GIR_Coverage, 9703,
     /* 1310717 */     GIR_EraseRootFromParent_Done,
     /* 1310718 */   // Label 18795: @1310718
     /* 1310718 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1310802), // Rule ID 9706 //
     /* 1310723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310776 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310801 */     // GIR_Coverage, 9706,
     /* 1310801 */     GIR_EraseRootFromParent_Done,
     /* 1310802 */   // Label 18796: @1310802
     /* 1310802 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1310886), // Rule ID 9707 //
     /* 1310807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310885 */     // GIR_Coverage, 9707,
     /* 1310885 */     GIR_EraseRootFromParent_Done,
     /* 1310886 */   // Label 18797: @1310886
     /* 1310886 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1310970), // Rule ID 9710 //
     /* 1310891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310944 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310969 */     // GIR_Coverage, 9710,
     /* 1310969 */     GIR_EraseRootFromParent_Done,
     /* 1310970 */   // Label 18798: @1310970
     /* 1310970 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1311054), // Rule ID 9711 //
     /* 1310975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311028 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311053 */     // GIR_Coverage, 9711,
     /* 1311053 */     GIR_EraseRootFromParent_Done,
     /* 1311054 */   // Label 18799: @1311054
     /* 1311054 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1311138), // Rule ID 9714 //
     /* 1311059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311137 */     // GIR_Coverage, 9714,
     /* 1311137 */     GIR_EraseRootFromParent_Done,
     /* 1311138 */   // Label 18800: @1311138
     /* 1311138 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1311222), // Rule ID 9715 //
     /* 1311143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311221 */     // GIR_Coverage, 9715,
     /* 1311221 */     GIR_EraseRootFromParent_Done,
     /* 1311222 */   // Label 18801: @1311222
     /* 1311222 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1311306), // Rule ID 9718 //
     /* 1311227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311305 */     // GIR_Coverage, 9718,
     /* 1311305 */     GIR_EraseRootFromParent_Done,
     /* 1311306 */   // Label 18802: @1311306
     /* 1311306 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1311390), // Rule ID 9719 //
     /* 1311311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311389 */     // GIR_Coverage, 9719,
     /* 1311389 */     GIR_EraseRootFromParent_Done,
     /* 1311390 */   // Label 18803: @1311390
     /* 1311390 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1311474), // Rule ID 9722 //
     /* 1311395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311473 */     // GIR_Coverage, 9722,
     /* 1311473 */     GIR_EraseRootFromParent_Done,
     /* 1311474 */   // Label 18804: @1311474
     /* 1311474 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1311558), // Rule ID 9723 //
     /* 1311479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311557 */     // GIR_Coverage, 9723,
     /* 1311557 */     GIR_EraseRootFromParent_Done,
     /* 1311558 */   // Label 18805: @1311558
     /* 1311558 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1311642), // Rule ID 9726 //
     /* 1311563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311641 */     // GIR_Coverage, 9726,
     /* 1311641 */     GIR_EraseRootFromParent_Done,
     /* 1311642 */   // Label 18806: @1311642
     /* 1311642 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1311726), // Rule ID 9727 //
     /* 1311647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311725 */     // GIR_Coverage, 9727,
     /* 1311725 */     GIR_EraseRootFromParent_Done,
     /* 1311726 */   // Label 18807: @1311726
     /* 1311726 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1311810), // Rule ID 9730 //
     /* 1311731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311809 */     // GIR_Coverage, 9730,
     /* 1311809 */     GIR_EraseRootFromParent_Done,
     /* 1311810 */   // Label 18808: @1311810
     /* 1311810 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1311894), // Rule ID 9731 //
     /* 1311815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311893 */     // GIR_Coverage, 9731,
     /* 1311893 */     GIR_EraseRootFromParent_Done,
     /* 1311894 */   // Label 18809: @1311894
     /* 1311894 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1311978), // Rule ID 9734 //
     /* 1311899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311952 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311977 */     // GIR_Coverage, 9734,
     /* 1311977 */     GIR_EraseRootFromParent_Done,
     /* 1311978 */   // Label 18810: @1311978
     /* 1311978 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1312062), // Rule ID 9735 //
     /* 1311983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1312039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312061 */     // GIR_Coverage, 9735,
     /* 1312061 */     GIR_EraseRootFromParent_Done,
     /* 1312062 */   // Label 18811: @1312062
     /* 1312062 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1312146), // Rule ID 9738 //
     /* 1312067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1312123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312145 */     // GIR_Coverage, 9738,
     /* 1312145 */     GIR_EraseRootFromParent_Done,
     /* 1312146 */   // Label 18812: @1312146
     /* 1312146 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1312230), // Rule ID 9739 //
     /* 1312151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312204 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1312207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312229 */     // GIR_Coverage, 9739,
     /* 1312229 */     GIR_EraseRootFromParent_Done,
     /* 1312230 */   // Label 18813: @1312230
     /* 1312230 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1312314), // Rule ID 9742 //
     /* 1312235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312313 */     // GIR_Coverage, 9742,
     /* 1312313 */     GIR_EraseRootFromParent_Done,
     /* 1312314 */   // Label 18814: @1312314
     /* 1312314 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1312398), // Rule ID 9743 //
     /* 1312319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312397 */     // GIR_Coverage, 9743,
     /* 1312397 */     GIR_EraseRootFromParent_Done,
     /* 1312398 */   // Label 18815: @1312398
     /* 1312398 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1312482), // Rule ID 9746 //
     /* 1312403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312481 */     // GIR_Coverage, 9746,
     /* 1312481 */     GIR_EraseRootFromParent_Done,
     /* 1312482 */   // Label 18816: @1312482
     /* 1312482 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1312566), // Rule ID 9747 //
     /* 1312487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312540 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312565 */     // GIR_Coverage, 9747,
     /* 1312565 */     GIR_EraseRootFromParent_Done,
     /* 1312566 */   // Label 18817: @1312566
     /* 1312566 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1312650), // Rule ID 9750 //
     /* 1312571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312649 */     // GIR_Coverage, 9750,
     /* 1312649 */     GIR_EraseRootFromParent_Done,
     /* 1312650 */   // Label 18818: @1312650
     /* 1312650 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1312734), // Rule ID 9751 //
     /* 1312655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312733 */     // GIR_Coverage, 9751,
     /* 1312733 */     GIR_EraseRootFromParent_Done,
     /* 1312734 */   // Label 18819: @1312734
     /* 1312734 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1312818), // Rule ID 9754 //
     /* 1312739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312817 */     // GIR_Coverage, 9754,
     /* 1312817 */     GIR_EraseRootFromParent_Done,
     /* 1312818 */   // Label 18820: @1312818
     /* 1312818 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1312902), // Rule ID 9755 //
     /* 1312823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312901 */     // GIR_Coverage, 9755,
     /* 1312901 */     GIR_EraseRootFromParent_Done,
     /* 1312902 */   // Label 18821: @1312902
     /* 1312902 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1312986), // Rule ID 9758 //
     /* 1312907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312985 */     // GIR_Coverage, 9758,
     /* 1312985 */     GIR_EraseRootFromParent_Done,
     /* 1312986 */   // Label 18822: @1312986
     /* 1312986 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1313070), // Rule ID 9759 //
     /* 1312991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1313008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1313011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1313047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313069 */     // GIR_Coverage, 9759,
     /* 1313069 */     GIR_EraseRootFromParent_Done,
     /* 1313070 */   // Label 18823: @1313070
     /* 1313070 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1313154), // Rule ID 9762 //
     /* 1313075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313128 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313153 */     // GIR_Coverage, 9762,
     /* 1313153 */     GIR_EraseRootFromParent_Done,
     /* 1313154 */   // Label 18824: @1313154
     /* 1313154 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1313238), // Rule ID 9763 //
     /* 1313159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313237 */     // GIR_Coverage, 9763,
     /* 1313237 */     GIR_EraseRootFromParent_Done,
     /* 1313238 */   // Label 18825: @1313238
     /* 1313238 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1313322), // Rule ID 9766 //
     /* 1313243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313321 */     // GIR_Coverage, 9766,
     /* 1313321 */     GIR_EraseRootFromParent_Done,
     /* 1313322 */   // Label 18826: @1313322
     /* 1313322 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1313406), // Rule ID 9767 //
     /* 1313327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313405 */     // GIR_Coverage, 9767,
     /* 1313405 */     GIR_EraseRootFromParent_Done,
     /* 1313406 */   // Label 18827: @1313406
     /* 1313406 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1313490), // Rule ID 9770 //
     /* 1313411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313489 */     // GIR_Coverage, 9770,
     /* 1313489 */     GIR_EraseRootFromParent_Done,
     /* 1313490 */   // Label 18828: @1313490
     /* 1313490 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1313574), // Rule ID 9771 //
     /* 1313495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313573 */     // GIR_Coverage, 9771,
     /* 1313573 */     GIR_EraseRootFromParent_Done,
     /* 1313574 */   // Label 18829: @1313574
     /* 1313574 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1313658), // Rule ID 9774 //
     /* 1313579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313657 */     // GIR_Coverage, 9774,
     /* 1313657 */     GIR_EraseRootFromParent_Done,
     /* 1313658 */   // Label 18830: @1313658
     /* 1313658 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1313742), // Rule ID 9775 //
     /* 1313663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313741 */     // GIR_Coverage, 9775,
     /* 1313741 */     GIR_EraseRootFromParent_Done,
     /* 1313742 */   // Label 18831: @1313742
     /* 1313742 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1313826), // Rule ID 9778 //
     /* 1313747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313825 */     // GIR_Coverage, 9778,
     /* 1313825 */     GIR_EraseRootFromParent_Done,
     /* 1313826 */   // Label 18832: @1313826
     /* 1313826 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1313910), // Rule ID 9779 //
     /* 1313831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313909 */     // GIR_Coverage, 9779,
     /* 1313909 */     GIR_EraseRootFromParent_Done,
     /* 1313910 */   // Label 18833: @1313910
     /* 1313910 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1313994), // Rule ID 9782 //
     /* 1313915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313968 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313993 */     // GIR_Coverage, 9782,
     /* 1313993 */     GIR_EraseRootFromParent_Done,
     /* 1313994 */   // Label 18834: @1313994
     /* 1313994 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1314078), // Rule ID 9783 //
     /* 1313999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1314016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1314019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314052 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314077 */     // GIR_Coverage, 9783,
     /* 1314077 */     GIR_EraseRootFromParent_Done,
     /* 1314078 */   // Label 18835: @1314078
     /* 1314078 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1314162), // Rule ID 9786 //
     /* 1314083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1314094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1314097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314136 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314161 */     // GIR_Coverage, 9786,
     /* 1314161 */     GIR_EraseRootFromParent_Done,
     /* 1314162 */   // Label 18836: @1314162
     /* 1314162 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1314246), // Rule ID 9787 //
     /* 1314167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1314178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1314181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314220 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314245 */     // GIR_Coverage, 9787,
     /* 1314245 */     GIR_EraseRootFromParent_Done,
     /* 1314246 */   // Label 18837: @1314246
     /* 1314246 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1314330), // Rule ID 9790 //
     /* 1314251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314329 */     // GIR_Coverage, 9790,
     /* 1314329 */     GIR_EraseRootFromParent_Done,
     /* 1314330 */   // Label 18838: @1314330
     /* 1314330 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1314414), // Rule ID 9791 //
     /* 1314335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314413 */     // GIR_Coverage, 9791,
     /* 1314413 */     GIR_EraseRootFromParent_Done,
     /* 1314414 */   // Label 18839: @1314414
     /* 1314414 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1314498), // Rule ID 9794 //
     /* 1314419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314497 */     // GIR_Coverage, 9794,
     /* 1314497 */     GIR_EraseRootFromParent_Done,
     /* 1314498 */   // Label 18840: @1314498
     /* 1314498 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1314582), // Rule ID 9795 //
     /* 1314503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314556 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314581 */     // GIR_Coverage, 9795,
     /* 1314581 */     GIR_EraseRootFromParent_Done,
     /* 1314582 */   // Label 18841: @1314582
     /* 1314582 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1314666), // Rule ID 9798 //
     /* 1314587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314640 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314665 */     // GIR_Coverage, 9798,
     /* 1314665 */     GIR_EraseRootFromParent_Done,
     /* 1314666 */   // Label 18842: @1314666
     /* 1314666 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1314750), // Rule ID 9799 //
     /* 1314671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314724 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314749 */     // GIR_Coverage, 9799,
     /* 1314749 */     GIR_EraseRootFromParent_Done,
     /* 1314750 */   // Label 18843: @1314750
     /* 1314750 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1314834), // Rule ID 9802 //
     /* 1314755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314833 */     // GIR_Coverage, 9802,
     /* 1314833 */     GIR_EraseRootFromParent_Done,
     /* 1314834 */   // Label 18844: @1314834
     /* 1314834 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1314918), // Rule ID 9803 //
     /* 1314839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314917 */     // GIR_Coverage, 9803,
     /* 1314917 */     GIR_EraseRootFromParent_Done,
     /* 1314918 */   // Label 18845: @1314918
     /* 1314918 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1315002), // Rule ID 9806 //
     /* 1314923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315001 */     // GIR_Coverage, 9806,
     /* 1315001 */     GIR_EraseRootFromParent_Done,
     /* 1315002 */   // Label 18846: @1315002
     /* 1315002 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1315086), // Rule ID 9807 //
     /* 1315007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1315027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315060 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315085 */     // GIR_Coverage, 9807,
     /* 1315085 */     GIR_EraseRootFromParent_Done,
     /* 1315086 */   // Label 18847: @1315086
     /* 1315086 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1315170), // Rule ID 9810 //
     /* 1315091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315169 */     // GIR_Coverage, 9810,
     /* 1315169 */     GIR_EraseRootFromParent_Done,
     /* 1315170 */   // Label 18848: @1315170
     /* 1315170 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1315254), // Rule ID 9811 //
     /* 1315175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315228 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315253 */     // GIR_Coverage, 9811,
     /* 1315253 */     GIR_EraseRootFromParent_Done,
     /* 1315254 */   // Label 18849: @1315254
     /* 1315254 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1315338), // Rule ID 9814 //
     /* 1315259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1315315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315337 */     // GIR_Coverage, 9814,
     /* 1315337 */     GIR_EraseRootFromParent_Done,
     /* 1315338 */   // Label 18850: @1315338
     /* 1315338 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1315422), // Rule ID 9815 //
     /* 1315343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1315399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315421 */     // GIR_Coverage, 9815,
     /* 1315421 */     GIR_EraseRootFromParent_Done,
     /* 1315422 */   // Label 18851: @1315422
     /* 1315422 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1315506), // Rule ID 9818 //
     /* 1315427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315480 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315505 */     // GIR_Coverage, 9818,
     /* 1315505 */     GIR_EraseRootFromParent_Done,
     /* 1315506 */   // Label 18852: @1315506
     /* 1315506 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1315590), // Rule ID 9819 //
     /* 1315511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315564 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315589 */     // GIR_Coverage, 9819,
     /* 1315589 */     GIR_EraseRootFromParent_Done,
     /* 1315590 */   // Label 18853: @1315590
     /* 1315590 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1315674), // Rule ID 9822 //
     /* 1315595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315673 */     // GIR_Coverage, 9822,
     /* 1315673 */     GIR_EraseRootFromParent_Done,
     /* 1315674 */   // Label 18854: @1315674
     /* 1315674 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1315758), // Rule ID 9823 //
     /* 1315679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315757 */     // GIR_Coverage, 9823,
     /* 1315757 */     GIR_EraseRootFromParent_Done,
     /* 1315758 */   // Label 18855: @1315758
     /* 1315758 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1315842), // Rule ID 9826 //
     /* 1315763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315816 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315841 */     // GIR_Coverage, 9826,
     /* 1315841 */     GIR_EraseRootFromParent_Done,
     /* 1315842 */   // Label 18856: @1315842
     /* 1315842 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1315926), // Rule ID 9827 //
     /* 1315847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315925 */     // GIR_Coverage, 9827,
     /* 1315925 */     GIR_EraseRootFromParent_Done,
     /* 1315926 */   // Label 18857: @1315926
     /* 1315926 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1316010), // Rule ID 9830 //
     /* 1315931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315984 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316009 */     // GIR_Coverage, 9830,
     /* 1316009 */     GIR_EraseRootFromParent_Done,
     /* 1316010 */   // Label 18858: @1316010
     /* 1316010 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1316094), // Rule ID 9831 //
     /* 1316015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1316032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1316035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316093 */     // GIR_Coverage, 9831,
     /* 1316093 */     GIR_EraseRootFromParent_Done,
     /* 1316094 */   // Label 18859: @1316094
     /* 1316094 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1316178), // Rule ID 9834 //
     /* 1316099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1316119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316177 */     // GIR_Coverage, 9834,
     /* 1316177 */     GIR_EraseRootFromParent_Done,
     /* 1316178 */   // Label 18860: @1316178
     /* 1316178 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1316262), // Rule ID 9835 //
     /* 1316183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1316203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316261 */     // GIR_Coverage, 9835,
     /* 1316261 */     GIR_EraseRootFromParent_Done,
     /* 1316262 */   // Label 18861: @1316262
     /* 1316262 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1316346), // Rule ID 9838 //
     /* 1316267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1316287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316345 */     // GIR_Coverage, 9838,
     /* 1316345 */     GIR_EraseRootFromParent_Done,
     /* 1316346 */   // Label 18862: @1316346
     /* 1316346 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1316430), // Rule ID 9839 //
     /* 1316351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1316371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1316407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316429 */     // GIR_Coverage, 9839,
     /* 1316429 */     GIR_EraseRootFromParent_Done,
     /* 1316430 */   // Label 18863: @1316430
     /* 1316430 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1316514), // Rule ID 9842 //
     /* 1316435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316513 */     // GIR_Coverage, 9842,
     /* 1316513 */     GIR_EraseRootFromParent_Done,
     /* 1316514 */   // Label 18864: @1316514
     /* 1316514 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1316598), // Rule ID 9843 //
     /* 1316519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316597 */     // GIR_Coverage, 9843,
     /* 1316597 */     GIR_EraseRootFromParent_Done,
     /* 1316598 */   // Label 18865: @1316598
     /* 1316598 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1316682), // Rule ID 9846 //
     /* 1316603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316681 */     // GIR_Coverage, 9846,
     /* 1316681 */     GIR_EraseRootFromParent_Done,
     /* 1316682 */   // Label 18866: @1316682
     /* 1316682 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1316766), // Rule ID 9847 //
     /* 1316687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316765 */     // GIR_Coverage, 9847,
     /* 1316765 */     GIR_EraseRootFromParent_Done,
     /* 1316766 */   // Label 18867: @1316766
     /* 1316766 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1316850), // Rule ID 9850 //
     /* 1316771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316849 */     // GIR_Coverage, 9850,
     /* 1316849 */     GIR_EraseRootFromParent_Done,
     /* 1316850 */   // Label 18868: @1316850
     /* 1316850 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1316934), // Rule ID 9851 //
     /* 1316855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316933 */     // GIR_Coverage, 9851,
     /* 1316933 */     GIR_EraseRootFromParent_Done,
     /* 1316934 */   // Label 18869: @1316934
     /* 1316934 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1317018), // Rule ID 9854 //
     /* 1316939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317017 */     // GIR_Coverage, 9854,
     /* 1317017 */     GIR_EraseRootFromParent_Done,
     /* 1317018 */   // Label 18870: @1317018
     /* 1317018 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1317102), // Rule ID 9855 //
     /* 1317023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1317034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1317037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1317043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317101 */     // GIR_Coverage, 9855,
     /* 1317101 */     GIR_EraseRootFromParent_Done,
     /* 1317102 */   // Label 18871: @1317102
     /* 1317102 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1317186), // Rule ID 9858 //
     /* 1317107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1317118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1317121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1317127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317185 */     // GIR_Coverage, 9858,
     /* 1317185 */     GIR_EraseRootFromParent_Done,
     /* 1317186 */   // Label 18872: @1317186
     /* 1317186 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1317270), // Rule ID 9859 //
     /* 1317191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1317202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1317205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1317211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317269 */     // GIR_Coverage, 9859,
     /* 1317269 */     GIR_EraseRootFromParent_Done,
     /* 1317270 */   // Label 18873: @1317270
     /* 1317270 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1317354), // Rule ID 9862 //
     /* 1317275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1317278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1317286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1317289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1317295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317353 */     // GIR_Coverage, 9862,
     /* 1317353 */     GIR_EraseRootFromParent_Done,
     /* 1317354 */   // Label 18874: @1317354
     /* 1317354 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1317438), // Rule ID 9863 //
     /* 1317359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1317362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1317370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1317373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1317379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1317415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317437 */     // GIR_Coverage, 9863,
     /* 1317437 */     GIR_EraseRootFromParent_Done,
     /* 1317438 */   // Label 18875: @1317438
     /* 1317438 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1317522), // Rule ID 9866 //
     /* 1317443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317521 */     // GIR_Coverage, 9866,
     /* 1317521 */     GIR_EraseRootFromParent_Done,
     /* 1317522 */   // Label 18876: @1317522
     /* 1317522 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1317606), // Rule ID 9867 //
     /* 1317527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317605 */     // GIR_Coverage, 9867,
     /* 1317605 */     GIR_EraseRootFromParent_Done,
     /* 1317606 */   // Label 18877: @1317606
     /* 1317606 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1317690), // Rule ID 9870 //
     /* 1317611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317689 */     // GIR_Coverage, 9870,
     /* 1317689 */     GIR_EraseRootFromParent_Done,
     /* 1317690 */   // Label 18878: @1317690
     /* 1317690 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1317774), // Rule ID 9871 //
     /* 1317695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317748 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317773 */     // GIR_Coverage, 9871,
     /* 1317773 */     GIR_EraseRootFromParent_Done,
     /* 1317774 */   // Label 18879: @1317774
     /* 1317774 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1317858), // Rule ID 9874 //
     /* 1317779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317832 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317857 */     // GIR_Coverage, 9874,
     /* 1317857 */     GIR_EraseRootFromParent_Done,
     /* 1317858 */   // Label 18880: @1317858
     /* 1317858 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1317942), // Rule ID 9875 //
     /* 1317863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317916 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317941 */     // GIR_Coverage, 9875,
     /* 1317941 */     GIR_EraseRootFromParent_Done,
     /* 1317942 */   // Label 18881: @1317942
     /* 1317942 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1318026), // Rule ID 9878 //
     /* 1317947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318025 */     // GIR_Coverage, 9878,
     /* 1318025 */     GIR_EraseRootFromParent_Done,
     /* 1318026 */   // Label 18882: @1318026
     /* 1318026 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1318110), // Rule ID 9879 //
     /* 1318031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1318051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318109 */     // GIR_Coverage, 9879,
     /* 1318109 */     GIR_EraseRootFromParent_Done,
     /* 1318110 */   // Label 18883: @1318110
     /* 1318110 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1318194), // Rule ID 9882 //
     /* 1318115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1318135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318193 */     // GIR_Coverage, 9882,
     /* 1318193 */     GIR_EraseRootFromParent_Done,
     /* 1318194 */   // Label 18884: @1318194
     /* 1318194 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1318278), // Rule ID 9883 //
     /* 1318199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1318219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318277 */     // GIR_Coverage, 9883,
     /* 1318277 */     GIR_EraseRootFromParent_Done,
     /* 1318278 */   // Label 18885: @1318278
     /* 1318278 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1318362), // Rule ID 9886 //
     /* 1318283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1318294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1318297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1318303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318361 */     // GIR_Coverage, 9886,
     /* 1318361 */     GIR_EraseRootFromParent_Done,
     /* 1318362 */   // Label 18886: @1318362
     /* 1318362 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1318446), // Rule ID 9887 //
     /* 1318367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1318378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1318381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1318387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318420 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318445 */     // GIR_Coverage, 9887,
     /* 1318445 */     GIR_EraseRootFromParent_Done,
     /* 1318446 */   // Label 18887: @1318446
     /* 1318446 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1318530), // Rule ID 9890 //
     /* 1318451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318529 */     // GIR_Coverage, 9890,
     /* 1318529 */     GIR_EraseRootFromParent_Done,
     /* 1318530 */   // Label 18888: @1318530
     /* 1318530 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1318614), // Rule ID 9891 //
     /* 1318535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318613 */     // GIR_Coverage, 9891,
     /* 1318613 */     GIR_EraseRootFromParent_Done,
     /* 1318614 */   // Label 18889: @1318614
     /* 1318614 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1318698), // Rule ID 9894 //
     /* 1318619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318697 */     // GIR_Coverage, 9894,
     /* 1318697 */     GIR_EraseRootFromParent_Done,
     /* 1318698 */   // Label 18890: @1318698
     /* 1318698 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1318782), // Rule ID 9895 //
     /* 1318703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318781 */     // GIR_Coverage, 9895,
     /* 1318781 */     GIR_EraseRootFromParent_Done,
     /* 1318782 */   // Label 18891: @1318782
     /* 1318782 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1318866), // Rule ID 9898 //
     /* 1318787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318865 */     // GIR_Coverage, 9898,
     /* 1318865 */     GIR_EraseRootFromParent_Done,
     /* 1318866 */   // Label 18892: @1318866
     /* 1318866 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1318950), // Rule ID 9899 //
     /* 1318871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318949 */     // GIR_Coverage, 9899,
     /* 1318949 */     GIR_EraseRootFromParent_Done,
     /* 1318950 */   // Label 18893: @1318950
     /* 1318950 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1319034), // Rule ID 9902 //
     /* 1318955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1319011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319033 */     // GIR_Coverage, 9902,
     /* 1319033 */     GIR_EraseRootFromParent_Done,
     /* 1319034 */   // Label 18894: @1319034
     /* 1319034 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1319118), // Rule ID 9903 //
     /* 1319039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1319059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1319095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319117 */     // GIR_Coverage, 9903,
     /* 1319117 */     GIR_EraseRootFromParent_Done,
     /* 1319118 */   // Label 18895: @1319118
     /* 1319118 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1319202), // Rule ID 9906 //
     /* 1319123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1319143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1319179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319201 */     // GIR_Coverage, 9906,
     /* 1319201 */     GIR_EraseRootFromParent_Done,
     /* 1319202 */   // Label 18896: @1319202
     /* 1319202 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1319286), // Rule ID 9907 //
     /* 1319207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1319218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1319221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1319227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1319263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319285 */     // GIR_Coverage, 9907,
     /* 1319285 */     GIR_EraseRootFromParent_Done,
     /* 1319286 */   // Label 18897: @1319286
     /* 1319286 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1319370), // Rule ID 9910 //
     /* 1319291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1319302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1319305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1319311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1319347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319369 */     // GIR_Coverage, 9910,
     /* 1319369 */     GIR_EraseRootFromParent_Done,
     /* 1319370 */   // Label 18898: @1319370
     /* 1319370 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1319454), // Rule ID 9911 //
     /* 1319375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1319383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1319386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1319389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1319395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1319431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1319437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1319439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319453 */     // GIR_Coverage, 9911,
     /* 1319453 */     GIR_EraseRootFromParent_Done,
     /* 1319454 */   // Label 18899: @1319454
     /* 1319454 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1319535), // Rule ID 13852 //
     /* 1319459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319534 */     // GIR_Coverage, 13852,
     /* 1319534 */     GIR_EraseRootFromParent_Done,
     /* 1319535 */   // Label 18900: @1319535
     /* 1319535 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1319616), // Rule ID 13853 //
     /* 1319540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319615 */     // GIR_Coverage, 13853,
     /* 1319615 */     GIR_EraseRootFromParent_Done,
     /* 1319616 */   // Label 18901: @1319616
     /* 1319616 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1319697), // Rule ID 13854 //
     /* 1319621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319696 */     // GIR_Coverage, 13854,
     /* 1319696 */     GIR_EraseRootFromParent_Done,
     /* 1319697 */   // Label 18902: @1319697
     /* 1319697 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1319778), // Rule ID 13855 //
     /* 1319702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319755 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319777 */     // GIR_Coverage, 13855,
     /* 1319777 */     GIR_EraseRootFromParent_Done,
     /* 1319778 */   // Label 18903: @1319778
     /* 1319778 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1319859), // Rule ID 13856 //
     /* 1319783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319858 */     // GIR_Coverage, 13856,
     /* 1319858 */     GIR_EraseRootFromParent_Done,
     /* 1319859 */   // Label 18904: @1319859
     /* 1319859 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1319940), // Rule ID 13857 //
     /* 1319864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319917 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319939 */     // GIR_Coverage, 13857,
     /* 1319939 */     GIR_EraseRootFromParent_Done,
     /* 1319940 */   // Label 18905: @1319940
     /* 1319940 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1320021), // Rule ID 13858 //
     /* 1319945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1320001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320020 */     // GIR_Coverage, 13858,
     /* 1320020 */     GIR_EraseRootFromParent_Done,
     /* 1320021 */   // Label 18906: @1320021
     /* 1320021 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1320102), // Rule ID 13859 //
     /* 1320026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1320037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1320040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1320043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1320046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320079 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1320082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320101 */     // GIR_Coverage, 13859,
     /* 1320101 */     GIR_EraseRootFromParent_Done,
     /* 1320102 */   // Label 18907: @1320102
     /* 1320102 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1320183), // Rule ID 13860 //
     /* 1320107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1320118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1320121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1320124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1320127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320182 */     // GIR_Coverage, 13860,
     /* 1320182 */     GIR_EraseRootFromParent_Done,
     /* 1320183 */   // Label 18908: @1320183
     /* 1320183 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1320264), // Rule ID 13861 //
     /* 1320188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1320199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1320202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1320205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1320208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320263 */     // GIR_Coverage, 13861,
     /* 1320263 */     GIR_EraseRootFromParent_Done,
     /* 1320264 */   // Label 18909: @1320264
     /* 1320264 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1320345), // Rule ID 13862 //
     /* 1320269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1320280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1320283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1320286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320344 */     // GIR_Coverage, 13862,
     /* 1320344 */     GIR_EraseRootFromParent_Done,
     /* 1320345 */   // Label 18910: @1320345
     /* 1320345 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1320426), // Rule ID 13863 //
     /* 1320350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1320361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1320364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1320367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1320370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320403 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1320406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320425 */     // GIR_Coverage, 13863,
     /* 1320425 */     GIR_EraseRootFromParent_Done,
     /* 1320426 */   // Label 18911: @1320426
     /* 1320426 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1320507), // Rule ID 13864 //
     /* 1320431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320484 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320506 */     // GIR_Coverage, 13864,
     /* 1320506 */     GIR_EraseRootFromParent_Done,
     /* 1320507 */   // Label 18912: @1320507
     /* 1320507 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1320588), // Rule ID 13865 //
     /* 1320512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320587 */     // GIR_Coverage, 13865,
     /* 1320587 */     GIR_EraseRootFromParent_Done,
     /* 1320588 */   // Label 18913: @1320588
     /* 1320588 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1320669), // Rule ID 13866 //
     /* 1320593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320668 */     // GIR_Coverage, 13866,
     /* 1320668 */     GIR_EraseRootFromParent_Done,
     /* 1320669 */   // Label 18914: @1320669
     /* 1320669 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1320750), // Rule ID 13867 //
     /* 1320674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320749 */     // GIR_Coverage, 13867,
     /* 1320749 */     GIR_EraseRootFromParent_Done,
     /* 1320750 */   // Label 18915: @1320750
     /* 1320750 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1320831), // Rule ID 13868 //
     /* 1320755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320830 */     // GIR_Coverage, 13868,
     /* 1320830 */     GIR_EraseRootFromParent_Done,
     /* 1320831 */   // Label 18916: @1320831
     /* 1320831 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1320912), // Rule ID 13869 //
     /* 1320836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320889 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320911 */     // GIR_Coverage, 13869,
     /* 1320911 */     GIR_EraseRootFromParent_Done,
     /* 1320912 */   // Label 18917: @1320912
     /* 1320912 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1320993), // Rule ID 13870 //
     /* 1320917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320992 */     // GIR_Coverage, 13870,
     /* 1320992 */     GIR_EraseRootFromParent_Done,
     /* 1320993 */   // Label 18918: @1320993
     /* 1320993 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1321074), // Rule ID 13871 //
     /* 1320998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1321001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1321009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1321012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1321015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1321018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1321051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1321054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321073 */     // GIR_Coverage, 13871,
     /* 1321073 */     GIR_EraseRootFromParent_Done,
     /* 1321074 */   // Label 18919: @1321074
     /* 1321074 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1321155), // Rule ID 13872 //
     /* 1321079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1321090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1321093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1321096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1321099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321154 */     // GIR_Coverage, 13872,
     /* 1321154 */     GIR_EraseRootFromParent_Done,
     /* 1321155 */   // Label 18920: @1321155
     /* 1321155 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1321236), // Rule ID 13873 //
     /* 1321160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1321171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1321174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1321177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1321180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321213 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321235 */     // GIR_Coverage, 13873,
     /* 1321235 */     GIR_EraseRootFromParent_Done,
     /* 1321236 */   // Label 18921: @1321236
     /* 1321236 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1321317), // Rule ID 13874 //
     /* 1321241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1321252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1321255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321316 */     // GIR_Coverage, 13874,
     /* 1321316 */     GIR_EraseRootFromParent_Done,
     /* 1321317 */   // Label 18922: @1321317
     /* 1321317 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1321398), // Rule ID 13875 //
     /* 1321322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1321333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1321336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1321339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1321342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321375 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321397 */     // GIR_Coverage, 13875,
     /* 1321397 */     GIR_EraseRootFromParent_Done,
     /* 1321398 */   // Label 18923: @1321398
     /* 1321398 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1321479), // Rule ID 13876 //
     /* 1321403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321456 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321478 */     // GIR_Coverage, 13876,
     /* 1321478 */     GIR_EraseRootFromParent_Done,
     /* 1321479 */   // Label 18924: @1321479
     /* 1321479 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1321560), // Rule ID 13877 //
     /* 1321484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321537 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321559 */     // GIR_Coverage, 13877,
     /* 1321559 */     GIR_EraseRootFromParent_Done,
     /* 1321560 */   // Label 18925: @1321560
     /* 1321560 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1321641), // Rule ID 13878 //
     /* 1321565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321640 */     // GIR_Coverage, 13878,
     /* 1321640 */     GIR_EraseRootFromParent_Done,
     /* 1321641 */   // Label 18926: @1321641
     /* 1321641 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1321722), // Rule ID 13879 //
     /* 1321646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321721 */     // GIR_Coverage, 13879,
     /* 1321721 */     GIR_EraseRootFromParent_Done,
     /* 1321722 */   // Label 18927: @1321722
     /* 1321722 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1321803), // Rule ID 13880 //
     /* 1321727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321802 */     // GIR_Coverage, 13880,
     /* 1321802 */     GIR_EraseRootFromParent_Done,
     /* 1321803 */   // Label 18928: @1321803
     /* 1321803 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1321884), // Rule ID 13881 //
     /* 1321808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321883 */     // GIR_Coverage, 13881,
     /* 1321883 */     GIR_EraseRootFromParent_Done,
     /* 1321884 */   // Label 18929: @1321884
     /* 1321884 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1321965), // Rule ID 13882 //
     /* 1321889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321964 */     // GIR_Coverage, 13882,
     /* 1321964 */     GIR_EraseRootFromParent_Done,
     /* 1321965 */   // Label 18930: @1321965
     /* 1321965 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1322046), // Rule ID 13883 //
     /* 1321970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1322023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322045 */     // GIR_Coverage, 13883,
     /* 1322045 */     GIR_EraseRootFromParent_Done,
     /* 1322046 */   // Label 18931: @1322046
     /* 1322046 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1322127), // Rule ID 13884 //
     /* 1322051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1322071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322126 */     // GIR_Coverage, 13884,
     /* 1322126 */     GIR_EraseRootFromParent_Done,
     /* 1322127 */   // Label 18932: @1322127
     /* 1322127 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1322208), // Rule ID 13885 //
     /* 1322132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1322152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322207 */     // GIR_Coverage, 13885,
     /* 1322207 */     GIR_EraseRootFromParent_Done,
     /* 1322208 */   // Label 18933: @1322208
     /* 1322208 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1322289), // Rule ID 13886 //
     /* 1322213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322288 */     // GIR_Coverage, 13886,
     /* 1322288 */     GIR_EraseRootFromParent_Done,
     /* 1322289 */   // Label 18934: @1322289
     /* 1322289 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1322370), // Rule ID 13887 //
     /* 1322294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1322305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1322308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1322311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1322314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322347 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322369 */     // GIR_Coverage, 13887,
     /* 1322369 */     GIR_EraseRootFromParent_Done,
     /* 1322370 */   // Label 18935: @1322370
     /* 1322370 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1322451), // Rule ID 13888 //
     /* 1322375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322450 */     // GIR_Coverage, 13888,
     /* 1322450 */     GIR_EraseRootFromParent_Done,
     /* 1322451 */   // Label 18936: @1322451
     /* 1322451 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1322532), // Rule ID 13889 //
     /* 1322456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322509 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322531 */     // GIR_Coverage, 13889,
     /* 1322531 */     GIR_EraseRootFromParent_Done,
     /* 1322532 */   // Label 18937: @1322532
     /* 1322532 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1322613), // Rule ID 13890 //
     /* 1322537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322612 */     // GIR_Coverage, 13890,
     /* 1322612 */     GIR_EraseRootFromParent_Done,
     /* 1322613 */   // Label 18938: @1322613
     /* 1322613 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1322694), // Rule ID 13891 //
     /* 1322618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322693 */     // GIR_Coverage, 13891,
     /* 1322693 */     GIR_EraseRootFromParent_Done,
     /* 1322694 */   // Label 18939: @1322694
     /* 1322694 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1322775), // Rule ID 13892 //
     /* 1322699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322774 */     // GIR_Coverage, 13892,
     /* 1322774 */     GIR_EraseRootFromParent_Done,
     /* 1322775 */   // Label 18940: @1322775
     /* 1322775 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1322856), // Rule ID 13893 //
     /* 1322780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322833 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322855 */     // GIR_Coverage, 13893,
     /* 1322855 */     GIR_EraseRootFromParent_Done,
     /* 1322856 */   // Label 18941: @1322856
     /* 1322856 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1322937), // Rule ID 13894 //
     /* 1322861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322936 */     // GIR_Coverage, 13894,
     /* 1322936 */     GIR_EraseRootFromParent_Done,
     /* 1322937 */   // Label 18942: @1322937
     /* 1322937 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1323018), // Rule ID 13895 //
     /* 1322942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323017 */     // GIR_Coverage, 13895,
     /* 1323017 */     GIR_EraseRootFromParent_Done,
     /* 1323018 */   // Label 18943: @1323018
     /* 1323018 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1323099), // Rule ID 13896 //
     /* 1323023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323076 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1323079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323098 */     // GIR_Coverage, 13896,
     /* 1323098 */     GIR_EraseRootFromParent_Done,
     /* 1323099 */   // Label 18944: @1323099
     /* 1323099 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1323180), // Rule ID 13897 //
     /* 1323104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1323115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1323118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1323121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323157 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1323160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323179 */     // GIR_Coverage, 13897,
     /* 1323179 */     GIR_EraseRootFromParent_Done,
     /* 1323180 */   // Label 18945: @1323180
     /* 1323180 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1323261), // Rule ID 13898 //
     /* 1323185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323260 */     // GIR_Coverage, 13898,
     /* 1323260 */     GIR_EraseRootFromParent_Done,
     /* 1323261 */   // Label 18946: @1323261
     /* 1323261 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1323342), // Rule ID 13899 //
     /* 1323266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1323277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1323280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1323283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323319 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323341 */     // GIR_Coverage, 13899,
     /* 1323341 */     GIR_EraseRootFromParent_Done,
     /* 1323342 */   // Label 18947: @1323342
     /* 1323342 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1323423), // Rule ID 13900 //
     /* 1323347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323400 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323422 */     // GIR_Coverage, 13900,
     /* 1323422 */     GIR_EraseRootFromParent_Done,
     /* 1323423 */   // Label 18948: @1323423
     /* 1323423 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1323504), // Rule ID 13901 //
     /* 1323428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1323439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1323442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1323445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323481 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323503 */     // GIR_Coverage, 13901,
     /* 1323503 */     GIR_EraseRootFromParent_Done,
     /* 1323504 */   // Label 18949: @1323504
     /* 1323504 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1323585), // Rule ID 13902 //
     /* 1323509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323584 */     // GIR_Coverage, 13902,
     /* 1323584 */     GIR_EraseRootFromParent_Done,
     /* 1323585 */   // Label 18950: @1323585
     /* 1323585 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1323666), // Rule ID 13903 //
     /* 1323590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323665 */     // GIR_Coverage, 13903,
     /* 1323665 */     GIR_EraseRootFromParent_Done,
     /* 1323666 */   // Label 18951: @1323666
     /* 1323666 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1323747), // Rule ID 13904 //
     /* 1323671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323724 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323746 */     // GIR_Coverage, 13904,
     /* 1323746 */     GIR_EraseRootFromParent_Done,
     /* 1323747 */   // Label 18952: @1323747
     /* 1323747 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1323828), // Rule ID 13905 //
     /* 1323752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323805 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323827 */     // GIR_Coverage, 13905,
     /* 1323827 */     GIR_EraseRootFromParent_Done,
     /* 1323828 */   // Label 18953: @1323828
     /* 1323828 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1323909), // Rule ID 13906 //
     /* 1323833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323908 */     // GIR_Coverage, 13906,
     /* 1323908 */     GIR_EraseRootFromParent_Done,
     /* 1323909 */   // Label 18954: @1323909
     /* 1323909 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1323990), // Rule ID 13907 //
     /* 1323914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323967 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323989 */     // GIR_Coverage, 13907,
     /* 1323989 */     GIR_EraseRootFromParent_Done,
     /* 1323990 */   // Label 18955: @1323990
     /* 1323990 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1324071), // Rule ID 13908 //
     /* 1323995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324070 */     // GIR_Coverage, 13908,
     /* 1324070 */     GIR_EraseRootFromParent_Done,
     /* 1324071 */   // Label 18956: @1324071
     /* 1324071 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1324152), // Rule ID 13909 //
     /* 1324076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1324087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1324090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1324093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324129 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324151 */     // GIR_Coverage, 13909,
     /* 1324151 */     GIR_EraseRootFromParent_Done,
     /* 1324152 */   // Label 18957: @1324152
     /* 1324152 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1324233), // Rule ID 13910 //
     /* 1324157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324232 */     // GIR_Coverage, 13910,
     /* 1324232 */     GIR_EraseRootFromParent_Done,
     /* 1324233 */   // Label 18958: @1324233
     /* 1324233 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1324314), // Rule ID 13911 //
     /* 1324238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1324249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1324252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324313 */     // GIR_Coverage, 13911,
     /* 1324313 */     GIR_EraseRootFromParent_Done,
     /* 1324314 */   // Label 18959: @1324314
     /* 1324314 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1324395), // Rule ID 13912 //
     /* 1324319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1324372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324394 */     // GIR_Coverage, 13912,
     /* 1324394 */     GIR_EraseRootFromParent_Done,
     /* 1324395 */   // Label 18960: @1324395
     /* 1324395 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1324476), // Rule ID 13913 //
     /* 1324400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1324411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1324414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1324453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324475 */     // GIR_Coverage, 13913,
     /* 1324475 */     GIR_EraseRootFromParent_Done,
     /* 1324476 */   // Label 18961: @1324476
     /* 1324476 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1324557), // Rule ID 13914 //
     /* 1324481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1324534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324556 */     // GIR_Coverage, 13914,
     /* 1324556 */     GIR_EraseRootFromParent_Done,
     /* 1324557 */   // Label 18962: @1324557
     /* 1324557 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1324638), // Rule ID 13915 //
     /* 1324562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1324615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324637 */     // GIR_Coverage, 13915,
     /* 1324637 */     GIR_EraseRootFromParent_Done,
     /* 1324638 */   // Label 18963: @1324638
     /* 1324638 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1324719), // Rule ID 13916 //
     /* 1324643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324718 */     // GIR_Coverage, 13916,
     /* 1324718 */     GIR_EraseRootFromParent_Done,
     /* 1324719 */   // Label 18964: @1324719
     /* 1324719 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1324800), // Rule ID 13917 //
     /* 1324724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324799 */     // GIR_Coverage, 13917,
     /* 1324799 */     GIR_EraseRootFromParent_Done,
     /* 1324800 */   // Label 18965: @1324800
     /* 1324800 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1324881), // Rule ID 13918 //
     /* 1324805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324880 */     // GIR_Coverage, 13918,
     /* 1324880 */     GIR_EraseRootFromParent_Done,
     /* 1324881 */   // Label 18966: @1324881
     /* 1324881 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1324962), // Rule ID 13919 //
     /* 1324886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324939 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324961 */     // GIR_Coverage, 13919,
     /* 1324961 */     GIR_EraseRootFromParent_Done,
     /* 1324962 */   // Label 18967: @1324962
     /* 1324962 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1325043), // Rule ID 13920 //
     /* 1324967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325020 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1325020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325042 */     // GIR_Coverage, 13920,
     /* 1325042 */     GIR_EraseRootFromParent_Done,
     /* 1325043 */   // Label 18968: @1325043
     /* 1325043 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1325124), // Rule ID 13921 //
     /* 1325048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1325059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1325062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1325065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1325071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1325101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1325122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325123 */     // GIR_Coverage, 13921,
     /* 1325123 */     GIR_EraseRootFromParent_Done,
     /* 1325124 */   // Label 18969: @1325124
     /* 1325124 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1325205), // Rule ID 13922 //
     /* 1325129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325204 */     // GIR_Coverage, 13922,
     /* 1325204 */     GIR_EraseRootFromParent_Done,
     /* 1325205 */   // Label 18970: @1325205
     /* 1325205 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1325286), // Rule ID 13923 //
     /* 1325210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1325221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1325224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325263 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325285 */     // GIR_Coverage, 13923,
     /* 1325285 */     GIR_EraseRootFromParent_Done,
     /* 1325286 */   // Label 18971: @1325286
     /* 1325286 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1325367), // Rule ID 13924 //
     /* 1325291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325366 */     // GIR_Coverage, 13924,
     /* 1325366 */     GIR_EraseRootFromParent_Done,
     /* 1325367 */   // Label 18972: @1325367
     /* 1325367 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1325448), // Rule ID 13925 //
     /* 1325372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1325383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1325386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325425 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325447 */     // GIR_Coverage, 13925,
     /* 1325447 */     GIR_EraseRootFromParent_Done,
     /* 1325448 */   // Label 18973: @1325448
     /* 1325448 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1325529), // Rule ID 13926 //
     /* 1325453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325506 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325528 */     // GIR_Coverage, 13926,
     /* 1325528 */     GIR_EraseRootFromParent_Done,
     /* 1325529 */   // Label 18974: @1325529
     /* 1325529 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1325610), // Rule ID 13927 //
     /* 1325534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325587 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325609 */     // GIR_Coverage, 13927,
     /* 1325609 */     GIR_EraseRootFromParent_Done,
     /* 1325610 */   // Label 18975: @1325610
     /* 1325610 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1325691), // Rule ID 13928 //
     /* 1325615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325690 */     // GIR_Coverage, 13928,
     /* 1325690 */     GIR_EraseRootFromParent_Done,
     /* 1325691 */   // Label 18976: @1325691
     /* 1325691 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1325772), // Rule ID 13929 //
     /* 1325696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325771 */     // GIR_Coverage, 13929,
     /* 1325771 */     GIR_EraseRootFromParent_Done,
     /* 1325772 */   // Label 18977: @1325772
     /* 1325772 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1325853), // Rule ID 13930 //
     /* 1325777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325852 */     // GIR_Coverage, 13930,
     /* 1325852 */     GIR_EraseRootFromParent_Done,
     /* 1325853 */   // Label 18978: @1325853
     /* 1325853 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1325934), // Rule ID 13931 //
     /* 1325858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325911 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325933 */     // GIR_Coverage, 13931,
     /* 1325933 */     GIR_EraseRootFromParent_Done,
     /* 1325934 */   // Label 18979: @1325934
     /* 1325934 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1326015), // Rule ID 13932 //
     /* 1325939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326014 */     // GIR_Coverage, 13932,
     /* 1326014 */     GIR_EraseRootFromParent_Done,
     /* 1326015 */   // Label 18980: @1326015
     /* 1326015 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1326096), // Rule ID 13933 //
     /* 1326020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1326023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1326031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1326034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326073 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1326073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326095 */     // GIR_Coverage, 13933,
     /* 1326095 */     GIR_EraseRootFromParent_Done,
     /* 1326096 */   // Label 18981: @1326096
     /* 1326096 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1326177), // Rule ID 13934 //
     /* 1326101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1326157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326176 */     // GIR_Coverage, 13934,
     /* 1326176 */     GIR_EraseRootFromParent_Done,
     /* 1326177 */   // Label 18982: @1326177
     /* 1326177 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1326258), // Rule ID 13935 //
     /* 1326182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1326193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1326196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1326212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1326238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326257 */     // GIR_Coverage, 13935,
     /* 1326257 */     GIR_EraseRootFromParent_Done,
     /* 1326258 */   // Label 18983: @1326258
     /* 1326258 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1326339), // Rule ID 13936 //
     /* 1326263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1326319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326338 */     // GIR_Coverage, 13936,
     /* 1326338 */     GIR_EraseRootFromParent_Done,
     /* 1326339 */   // Label 18984: @1326339
     /* 1326339 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1326420), // Rule ID 13937 //
     /* 1326344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1326355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1326358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1326374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1326400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326419 */     // GIR_Coverage, 13937,
     /* 1326419 */     GIR_EraseRootFromParent_Done,
     /* 1326420 */   // Label 18985: @1326420
     /* 1326420 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1326501), // Rule ID 13938 //
     /* 1326425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1326428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1326445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326500 */     // GIR_Coverage, 13938,
     /* 1326500 */     GIR_EraseRootFromParent_Done,
     /* 1326501 */   // Label 18986: @1326501
     /* 1326501 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1326582), // Rule ID 13939 //
     /* 1326506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326559 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326581 */     // GIR_Coverage, 13939,
     /* 1326581 */     GIR_EraseRootFromParent_Done,
     /* 1326582 */   // Label 18987: @1326582
     /* 1326582 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1326666), // Rule ID 19778 //
     /* 1326587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326665 */     // GIR_Coverage, 19778,
     /* 1326665 */     GIR_EraseRootFromParent_Done,
     /* 1326666 */   // Label 18988: @1326666
     /* 1326666 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1326750), // Rule ID 19779 //
     /* 1326671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326749 */     // GIR_Coverage, 19779,
     /* 1326749 */     GIR_EraseRootFromParent_Done,
     /* 1326750 */   // Label 18989: @1326750
     /* 1326750 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1326834), // Rule ID 19782 //
     /* 1326755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326833 */     // GIR_Coverage, 19782,
     /* 1326833 */     GIR_EraseRootFromParent_Done,
     /* 1326834 */   // Label 18990: @1326834
     /* 1326834 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1326918), // Rule ID 19783 //
     /* 1326839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326917 */     // GIR_Coverage, 19783,
     /* 1326917 */     GIR_EraseRootFromParent_Done,
     /* 1326918 */   // Label 18991: @1326918
     /* 1326918 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1327002), // Rule ID 19786 //
     /* 1326923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326976 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327001 */     // GIR_Coverage, 19786,
     /* 1327001 */     GIR_EraseRootFromParent_Done,
     /* 1327002 */   // Label 18992: @1327002
     /* 1327002 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1327086), // Rule ID 19787 //
     /* 1327007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1327027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1327063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327085 */     // GIR_Coverage, 19787,
     /* 1327085 */     GIR_EraseRootFromParent_Done,
     /* 1327086 */   // Label 18993: @1327086
     /* 1327086 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1327170), // Rule ID 19790 //
     /* 1327091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1327111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327169 */     // GIR_Coverage, 19790,
     /* 1327169 */     GIR_EraseRootFromParent_Done,
     /* 1327170 */   // Label 18994: @1327170
     /* 1327170 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1327254), // Rule ID 19791 //
     /* 1327175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1327195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327253 */     // GIR_Coverage, 19791,
     /* 1327253 */     GIR_EraseRootFromParent_Done,
     /* 1327254 */   // Label 18995: @1327254
     /* 1327254 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1327338), // Rule ID 19794 //
     /* 1327259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1327279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327337 */     // GIR_Coverage, 19794,
     /* 1327337 */     GIR_EraseRootFromParent_Done,
     /* 1327338 */   // Label 18996: @1327338
     /* 1327338 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1327422), // Rule ID 19795 //
     /* 1327343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1327363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327421 */     // GIR_Coverage, 19795,
     /* 1327421 */     GIR_EraseRootFromParent_Done,
     /* 1327422 */   // Label 18997: @1327422
     /* 1327422 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1327506), // Rule ID 19798 //
     /* 1327427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1327430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327505 */     // GIR_Coverage, 19798,
     /* 1327505 */     GIR_EraseRootFromParent_Done,
     /* 1327506 */   // Label 18998: @1327506
     /* 1327506 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1327590), // Rule ID 19799 //
     /* 1327511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327589 */     // GIR_Coverage, 19799,
     /* 1327589 */     GIR_EraseRootFromParent_Done,
     /* 1327590 */   // Label 18999: @1327590
     /* 1327590 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1327674), // Rule ID 19802 //
     /* 1327595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327673 */     // GIR_Coverage, 19802,
     /* 1327673 */     GIR_EraseRootFromParent_Done,
     /* 1327674 */   // Label 19000: @1327674
     /* 1327674 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1327758), // Rule ID 19803 //
     /* 1327679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327757 */     // GIR_Coverage, 19803,
     /* 1327757 */     GIR_EraseRootFromParent_Done,
     /* 1327758 */   // Label 19001: @1327758
     /* 1327758 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1327842), // Rule ID 19806 //
     /* 1327763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327841 */     // GIR_Coverage, 19806,
     /* 1327841 */     GIR_EraseRootFromParent_Done,
     /* 1327842 */   // Label 19002: @1327842
     /* 1327842 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1327926), // Rule ID 19807 //
     /* 1327847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327925 */     // GIR_Coverage, 19807,
     /* 1327925 */     GIR_EraseRootFromParent_Done,
     /* 1327926 */   // Label 19003: @1327926
     /* 1327926 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1328010), // Rule ID 19810 //
     /* 1327931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327984 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328009 */     // GIR_Coverage, 19810,
     /* 1328009 */     GIR_EraseRootFromParent_Done,
     /* 1328010 */   // Label 19004: @1328010
     /* 1328010 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1328094), // Rule ID 19811 //
     /* 1328015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1328026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1328029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1328035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328068 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328093 */     // GIR_Coverage, 19811,
     /* 1328093 */     GIR_EraseRootFromParent_Done,
     /* 1328094 */   // Label 19005: @1328094
     /* 1328094 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1328178), // Rule ID 19814 //
     /* 1328099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1328119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328177 */     // GIR_Coverage, 19814,
     /* 1328177 */     GIR_EraseRootFromParent_Done,
     /* 1328178 */   // Label 19006: @1328178
     /* 1328178 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1328262), // Rule ID 19815 //
     /* 1328183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1328203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328261 */     // GIR_Coverage, 19815,
     /* 1328261 */     GIR_EraseRootFromParent_Done,
     /* 1328262 */   // Label 19007: @1328262
     /* 1328262 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1328346), // Rule ID 19818 //
     /* 1328267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1328287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328345 */     // GIR_Coverage, 19818,
     /* 1328345 */     GIR_EraseRootFromParent_Done,
     /* 1328346 */   // Label 19008: @1328346
     /* 1328346 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1328430), // Rule ID 19819 //
     /* 1328351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1328371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328404 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328429 */     // GIR_Coverage, 19819,
     /* 1328429 */     GIR_EraseRootFromParent_Done,
     /* 1328430 */   // Label 19009: @1328430
     /* 1328430 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1328514), // Rule ID 19822 //
     /* 1328435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328513 */     // GIR_Coverage, 19822,
     /* 1328513 */     GIR_EraseRootFromParent_Done,
     /* 1328514 */   // Label 19010: @1328514
     /* 1328514 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1328598), // Rule ID 19823 //
     /* 1328519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328572 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328597 */     // GIR_Coverage, 19823,
     /* 1328597 */     GIR_EraseRootFromParent_Done,
     /* 1328598 */   // Label 19011: @1328598
     /* 1328598 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1328682), // Rule ID 19826 //
     /* 1328603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328681 */     // GIR_Coverage, 19826,
     /* 1328681 */     GIR_EraseRootFromParent_Done,
     /* 1328682 */   // Label 19012: @1328682
     /* 1328682 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1328766), // Rule ID 19827 //
     /* 1328687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328740 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328765 */     // GIR_Coverage, 19827,
     /* 1328765 */     GIR_EraseRootFromParent_Done,
     /* 1328766 */   // Label 19013: @1328766
     /* 1328766 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1328850), // Rule ID 19830 //
     /* 1328771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328849 */     // GIR_Coverage, 19830,
     /* 1328849 */     GIR_EraseRootFromParent_Done,
     /* 1328850 */   // Label 19014: @1328850
     /* 1328850 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1328934), // Rule ID 19831 //
     /* 1328855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328908 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328933 */     // GIR_Coverage, 19831,
     /* 1328933 */     GIR_EraseRootFromParent_Done,
     /* 1328934 */   // Label 19015: @1328934
     /* 1328934 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1329018), // Rule ID 19834 //
     /* 1328939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329017 */     // GIR_Coverage, 19834,
     /* 1329017 */     GIR_EraseRootFromParent_Done,
     /* 1329018 */   // Label 19016: @1329018
     /* 1329018 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1329102), // Rule ID 19835 //
     /* 1329023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1329043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1329079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329101 */     // GIR_Coverage, 19835,
     /* 1329101 */     GIR_EraseRootFromParent_Done,
     /* 1329102 */   // Label 19017: @1329102
     /* 1329102 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1329186), // Rule ID 19838 //
     /* 1329107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1329163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329185 */     // GIR_Coverage, 19838,
     /* 1329185 */     GIR_EraseRootFromParent_Done,
     /* 1329186 */   // Label 19018: @1329186
     /* 1329186 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1329270), // Rule ID 19839 //
     /* 1329191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329244 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1329247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329269 */     // GIR_Coverage, 19839,
     /* 1329269 */     GIR_EraseRootFromParent_Done,
     /* 1329270 */   // Label 19019: @1329270
     /* 1329270 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1329354), // Rule ID 19842 //
     /* 1329275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1329331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329353 */     // GIR_Coverage, 19842,
     /* 1329353 */     GIR_EraseRootFromParent_Done,
     /* 1329354 */   // Label 19020: @1329354
     /* 1329354 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1329438), // Rule ID 19843 //
     /* 1329359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1329415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329437 */     // GIR_Coverage, 19843,
     /* 1329437 */     GIR_EraseRootFromParent_Done,
     /* 1329438 */   // Label 19021: @1329438
     /* 1329438 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1329522), // Rule ID 19846 //
     /* 1329443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329521 */     // GIR_Coverage, 19846,
     /* 1329521 */     GIR_EraseRootFromParent_Done,
     /* 1329522 */   // Label 19022: @1329522
     /* 1329522 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1329606), // Rule ID 19847 //
     /* 1329527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329605 */     // GIR_Coverage, 19847,
     /* 1329605 */     GIR_EraseRootFromParent_Done,
     /* 1329606 */   // Label 19023: @1329606
     /* 1329606 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1329690), // Rule ID 19850 //
     /* 1329611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329664 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329689 */     // GIR_Coverage, 19850,
     /* 1329689 */     GIR_EraseRootFromParent_Done,
     /* 1329690 */   // Label 19024: @1329690
     /* 1329690 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1329774), // Rule ID 19851 //
     /* 1329695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329773 */     // GIR_Coverage, 19851,
     /* 1329773 */     GIR_EraseRootFromParent_Done,
     /* 1329774 */   // Label 19025: @1329774
     /* 1329774 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1329858), // Rule ID 19854 //
     /* 1329779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329857 */     // GIR_Coverage, 19854,
     /* 1329857 */     GIR_EraseRootFromParent_Done,
     /* 1329858 */   // Label 19026: @1329858
     /* 1329858 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1329942), // Rule ID 19855 //
     /* 1329863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329941 */     // GIR_Coverage, 19855,
     /* 1329941 */     GIR_EraseRootFromParent_Done,
     /* 1329942 */   // Label 19027: @1329942
     /* 1329942 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1330026), // Rule ID 19858 //
     /* 1329947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1330003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330025 */     // GIR_Coverage, 19858,
     /* 1330025 */     GIR_EraseRootFromParent_Done,
     /* 1330026 */   // Label 19028: @1330026
     /* 1330026 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1330110), // Rule ID 19859 //
     /* 1330031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1330087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330109 */     // GIR_Coverage, 19859,
     /* 1330109 */     GIR_EraseRootFromParent_Done,
     /* 1330110 */   // Label 19029: @1330110
     /* 1330110 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1330194), // Rule ID 19862 //
     /* 1330115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1330171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330193 */     // GIR_Coverage, 19862,
     /* 1330193 */     GIR_EraseRootFromParent_Done,
     /* 1330194 */   // Label 19030: @1330194
     /* 1330194 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1330278), // Rule ID 19863 //
     /* 1330199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1330255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330277 */     // GIR_Coverage, 19863,
     /* 1330277 */     GIR_EraseRootFromParent_Done,
     /* 1330278 */   // Label 19031: @1330278
     /* 1330278 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1330362), // Rule ID 19866 //
     /* 1330283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1330339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330361 */     // GIR_Coverage, 19866,
     /* 1330361 */     GIR_EraseRootFromParent_Done,
     /* 1330362 */   // Label 19032: @1330362
     /* 1330362 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1330446), // Rule ID 19867 //
     /* 1330367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1330423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330445 */     // GIR_Coverage, 19867,
     /* 1330445 */     GIR_EraseRootFromParent_Done,
     /* 1330446 */   // Label 19033: @1330446
     /* 1330446 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1330530), // Rule ID 19870 //
     /* 1330451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330504 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330529 */     // GIR_Coverage, 19870,
     /* 1330529 */     GIR_EraseRootFromParent_Done,
     /* 1330530 */   // Label 19034: @1330530
     /* 1330530 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1330614), // Rule ID 19871 //
     /* 1330535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330588 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330613 */     // GIR_Coverage, 19871,
     /* 1330613 */     GIR_EraseRootFromParent_Done,
     /* 1330614 */   // Label 19035: @1330614
     /* 1330614 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1330698), // Rule ID 19874 //
     /* 1330619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330697 */     // GIR_Coverage, 19874,
     /* 1330697 */     GIR_EraseRootFromParent_Done,
     /* 1330698 */   // Label 19036: @1330698
     /* 1330698 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1330782), // Rule ID 19875 //
     /* 1330703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330781 */     // GIR_Coverage, 19875,
     /* 1330781 */     GIR_EraseRootFromParent_Done,
     /* 1330782 */   // Label 19037: @1330782
     /* 1330782 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1330866), // Rule ID 19878 //
     /* 1330787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330865 */     // GIR_Coverage, 19878,
     /* 1330865 */     GIR_EraseRootFromParent_Done,
     /* 1330866 */   // Label 19038: @1330866
     /* 1330866 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1330950), // Rule ID 19879 //
     /* 1330871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330924 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330949 */     // GIR_Coverage, 19879,
     /* 1330949 */     GIR_EraseRootFromParent_Done,
     /* 1330950 */   // Label 19039: @1330950
     /* 1330950 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1331034), // Rule ID 19882 //
     /* 1330955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1331011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331033 */     // GIR_Coverage, 19882,
     /* 1331033 */     GIR_EraseRootFromParent_Done,
     /* 1331034 */   // Label 19040: @1331034
     /* 1331034 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1331118), // Rule ID 19883 //
     /* 1331039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1331081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1331095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331117 */     // GIR_Coverage, 19883,
     /* 1331117 */     GIR_EraseRootFromParent_Done,
     /* 1331118 */   // Label 19041: @1331118
     /* 1331118 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1331202), // Rule ID 19886 //
     /* 1331123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331176 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1331179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331201 */     // GIR_Coverage, 19886,
     /* 1331201 */     GIR_EraseRootFromParent_Done,
     /* 1331202 */   // Label 19042: @1331202
     /* 1331202 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1331286), // Rule ID 19887 //
     /* 1331207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1331263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331285 */     // GIR_Coverage, 19887,
     /* 1331285 */     GIR_EraseRootFromParent_Done,
     /* 1331286 */   // Label 19043: @1331286
     /* 1331286 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1331370), // Rule ID 19890 //
     /* 1331291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1331347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331369 */     // GIR_Coverage, 19890,
     /* 1331369 */     GIR_EraseRootFromParent_Done,
     /* 1331370 */   // Label 19044: @1331370
     /* 1331370 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1331454), // Rule ID 19891 //
     /* 1331375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1331431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331453 */     // GIR_Coverage, 19891,
     /* 1331453 */     GIR_EraseRootFromParent_Done,
     /* 1331454 */   // Label 19045: @1331454
     /* 1331454 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1331538), // Rule ID 19894 //
     /* 1331459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331537 */     // GIR_Coverage, 19894,
     /* 1331537 */     GIR_EraseRootFromParent_Done,
     /* 1331538 */   // Label 19046: @1331538
     /* 1331538 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1331622), // Rule ID 19895 //
     /* 1331543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331621 */     // GIR_Coverage, 19895,
     /* 1331621 */     GIR_EraseRootFromParent_Done,
     /* 1331622 */   // Label 19047: @1331622
     /* 1331622 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1331706), // Rule ID 19898 //
     /* 1331627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331680 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331705 */     // GIR_Coverage, 19898,
     /* 1331705 */     GIR_EraseRootFromParent_Done,
     /* 1331706 */   // Label 19048: @1331706
     /* 1331706 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1331790), // Rule ID 19899 //
     /* 1331711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331764 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331789 */     // GIR_Coverage, 19899,
     /* 1331789 */     GIR_EraseRootFromParent_Done,
     /* 1331790 */   // Label 19049: @1331790
     /* 1331790 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1331874), // Rule ID 19902 //
     /* 1331795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331873 */     // GIR_Coverage, 19902,
     /* 1331873 */     GIR_EraseRootFromParent_Done,
     /* 1331874 */   // Label 19050: @1331874
     /* 1331874 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1331958), // Rule ID 19903 //
     /* 1331879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331957 */     // GIR_Coverage, 19903,
     /* 1331957 */     GIR_EraseRootFromParent_Done,
     /* 1331958 */   // Label 19051: @1331958
     /* 1331958 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1332042), // Rule ID 19906 //
     /* 1331963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1332019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332041 */     // GIR_Coverage, 19906,
     /* 1332041 */     GIR_EraseRootFromParent_Done,
     /* 1332042 */   // Label 19052: @1332042
     /* 1332042 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1332126), // Rule ID 19907 //
     /* 1332047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1332067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1332103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332125 */     // GIR_Coverage, 19907,
     /* 1332125 */     GIR_EraseRootFromParent_Done,
     /* 1332126 */   // Label 19053: @1332126
     /* 1332126 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1332210), // Rule ID 19910 //
     /* 1332131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1332151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332209 */     // GIR_Coverage, 19910,
     /* 1332209 */     GIR_EraseRootFromParent_Done,
     /* 1332210 */   // Label 19054: @1332210
     /* 1332210 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1332294), // Rule ID 19911 //
     /* 1332215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1332235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332293 */     // GIR_Coverage, 19911,
     /* 1332293 */     GIR_EraseRootFromParent_Done,
     /* 1332294 */   // Label 19055: @1332294
     /* 1332294 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1332378), // Rule ID 19914 //
     /* 1332299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1332319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332377 */     // GIR_Coverage, 19914,
     /* 1332377 */     GIR_EraseRootFromParent_Done,
     /* 1332378 */   // Label 19056: @1332378
     /* 1332378 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1332462), // Rule ID 19915 //
     /* 1332383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1332403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332461 */     // GIR_Coverage, 19915,
     /* 1332461 */     GIR_EraseRootFromParent_Done,
     /* 1332462 */   // Label 19057: @1332462
     /* 1332462 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1332546), // Rule ID 19918 //
     /* 1332467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332545 */     // GIR_Coverage, 19918,
     /* 1332545 */     GIR_EraseRootFromParent_Done,
     /* 1332546 */   // Label 19058: @1332546
     /* 1332546 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1332630), // Rule ID 19919 //
     /* 1332551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332629 */     // GIR_Coverage, 19919,
     /* 1332629 */     GIR_EraseRootFromParent_Done,
     /* 1332630 */   // Label 19059: @1332630
     /* 1332630 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1332714), // Rule ID 19922 //
     /* 1332635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332713 */     // GIR_Coverage, 19922,
     /* 1332713 */     GIR_EraseRootFromParent_Done,
     /* 1332714 */   // Label 19060: @1332714
     /* 1332714 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1332798), // Rule ID 19923 //
     /* 1332719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332797 */     // GIR_Coverage, 19923,
     /* 1332797 */     GIR_EraseRootFromParent_Done,
     /* 1332798 */   // Label 19061: @1332798
     /* 1332798 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1332882), // Rule ID 19926 //
     /* 1332803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332881 */     // GIR_Coverage, 19926,
     /* 1332881 */     GIR_EraseRootFromParent_Done,
     /* 1332882 */   // Label 19062: @1332882
     /* 1332882 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1332966), // Rule ID 19927 //
     /* 1332887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332940 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332965 */     // GIR_Coverage, 19927,
     /* 1332965 */     GIR_EraseRootFromParent_Done,
     /* 1332966 */   // Label 19063: @1332966
     /* 1332966 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1333050), // Rule ID 19930 //
     /* 1332971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333024 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333049 */     // GIR_Coverage, 19930,
     /* 1333049 */     GIR_EraseRootFromParent_Done,
     /* 1333050 */   // Label 19064: @1333050
     /* 1333050 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1333134), // Rule ID 19931 //
     /* 1333055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1333075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333108 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333133 */     // GIR_Coverage, 19931,
     /* 1333133 */     GIR_EraseRootFromParent_Done,
     /* 1333134 */   // Label 19065: @1333134
     /* 1333134 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1333218), // Rule ID 19934 //
     /* 1333139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1333159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333217 */     // GIR_Coverage, 19934,
     /* 1333217 */     GIR_EraseRootFromParent_Done,
     /* 1333218 */   // Label 19066: @1333218
     /* 1333218 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1333302), // Rule ID 19935 //
     /* 1333223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1333243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333276 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333301 */     // GIR_Coverage, 19935,
     /* 1333301 */     GIR_EraseRootFromParent_Done,
     /* 1333302 */   // Label 19067: @1333302
     /* 1333302 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1333386), // Rule ID 19938 //
     /* 1333307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1333327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333385 */     // GIR_Coverage, 19938,
     /* 1333385 */     GIR_EraseRootFromParent_Done,
     /* 1333386 */   // Label 19068: @1333386
     /* 1333386 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1333470), // Rule ID 19939 //
     /* 1333391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1333411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333469 */     // GIR_Coverage, 19939,
     /* 1333469 */     GIR_EraseRootFromParent_Done,
     /* 1333470 */   // Label 19069: @1333470
     /* 1333470 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1333554), // Rule ID 19942 //
     /* 1333475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333553 */     // GIR_Coverage, 19942,
     /* 1333553 */     GIR_EraseRootFromParent_Done,
     /* 1333554 */   // Label 19070: @1333554
     /* 1333554 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1333638), // Rule ID 19943 //
     /* 1333559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333637 */     // GIR_Coverage, 19943,
     /* 1333637 */     GIR_EraseRootFromParent_Done,
     /* 1333638 */   // Label 19071: @1333638
     /* 1333638 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1333722), // Rule ID 19946 //
     /* 1333643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333721 */     // GIR_Coverage, 19946,
     /* 1333721 */     GIR_EraseRootFromParent_Done,
     /* 1333722 */   // Label 19072: @1333722
     /* 1333722 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1333806), // Rule ID 19947 //
     /* 1333727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333805 */     // GIR_Coverage, 19947,
     /* 1333805 */     GIR_EraseRootFromParent_Done,
     /* 1333806 */   // Label 19073: @1333806
     /* 1333806 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1333890), // Rule ID 19950 //
     /* 1333811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333889 */     // GIR_Coverage, 19950,
     /* 1333889 */     GIR_EraseRootFromParent_Done,
     /* 1333890 */   // Label 19074: @1333890
     /* 1333890 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1333974), // Rule ID 19951 //
     /* 1333895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333973 */     // GIR_Coverage, 19951,
     /* 1333973 */     GIR_EraseRootFromParent_Done,
     /* 1333974 */   // Label 19075: @1333974
     /* 1333974 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1334058), // Rule ID 19954 //
     /* 1333979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1333999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1334035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334057 */     // GIR_Coverage, 19954,
     /* 1334057 */     GIR_EraseRootFromParent_Done,
     /* 1334058 */   // Label 19076: @1334058
     /* 1334058 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1334142), // Rule ID 19955 //
     /* 1334063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1334083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1334119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334141 */     // GIR_Coverage, 19955,
     /* 1334141 */     GIR_EraseRootFromParent_Done,
     /* 1334142 */   // Label 19077: @1334142
     /* 1334142 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1334226), // Rule ID 19958 //
     /* 1334147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1334203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334225 */     // GIR_Coverage, 19958,
     /* 1334225 */     GIR_EraseRootFromParent_Done,
     /* 1334226 */   // Label 19078: @1334226
     /* 1334226 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1334310), // Rule ID 19959 //
     /* 1334231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334284 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1334287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334309 */     // GIR_Coverage, 19959,
     /* 1334309 */     GIR_EraseRootFromParent_Done,
     /* 1334310 */   // Label 19079: @1334310
     /* 1334310 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1334394), // Rule ID 19962 //
     /* 1334315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1334371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334393 */     // GIR_Coverage, 19962,
     /* 1334393 */     GIR_EraseRootFromParent_Done,
     /* 1334394 */   // Label 19080: @1334394
     /* 1334394 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1334478), // Rule ID 19963 //
     /* 1334399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1334455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334477 */     // GIR_Coverage, 19963,
     /* 1334477 */     GIR_EraseRootFromParent_Done,
     /* 1334478 */   // Label 19081: @1334478
     /* 1334478 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1334562), // Rule ID 19966 //
     /* 1334483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334561 */     // GIR_Coverage, 19966,
     /* 1334561 */     GIR_EraseRootFromParent_Done,
     /* 1334562 */   // Label 19082: @1334562
     /* 1334562 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1334646), // Rule ID 19967 //
     /* 1334567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334645 */     // GIR_Coverage, 19967,
     /* 1334645 */     GIR_EraseRootFromParent_Done,
     /* 1334646 */   // Label 19083: @1334646
     /* 1334646 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1334730), // Rule ID 19970 //
     /* 1334651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334704 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334729 */     // GIR_Coverage, 19970,
     /* 1334729 */     GIR_EraseRootFromParent_Done,
     /* 1334730 */   // Label 19084: @1334730
     /* 1334730 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1334814), // Rule ID 19971 //
     /* 1334735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334813 */     // GIR_Coverage, 19971,
     /* 1334813 */     GIR_EraseRootFromParent_Done,
     /* 1334814 */   // Label 19085: @1334814
     /* 1334814 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1334898), // Rule ID 19974 //
     /* 1334819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334897 */     // GIR_Coverage, 19974,
     /* 1334897 */     GIR_EraseRootFromParent_Done,
     /* 1334898 */   // Label 19086: @1334898
     /* 1334898 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1334982), // Rule ID 19975 //
     /* 1334903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334981 */     // GIR_Coverage, 19975,
     /* 1334981 */     GIR_EraseRootFromParent_Done,
     /* 1334982 */   // Label 19087: @1334982
     /* 1334982 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1335066), // Rule ID 19978 //
     /* 1334987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1335043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335065 */     // GIR_Coverage, 19978,
     /* 1335065 */     GIR_EraseRootFromParent_Done,
     /* 1335066 */   // Label 19088: @1335066
     /* 1335066 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1335150), // Rule ID 19979 //
     /* 1335071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1335127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335149 */     // GIR_Coverage, 19979,
     /* 1335149 */     GIR_EraseRootFromParent_Done,
     /* 1335150 */   // Label 19089: @1335150
     /* 1335150 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1335234), // Rule ID 19982 //
     /* 1335155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1335211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335233 */     // GIR_Coverage, 19982,
     /* 1335233 */     GIR_EraseRootFromParent_Done,
     /* 1335234 */   // Label 19090: @1335234
     /* 1335234 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1335318), // Rule ID 19983 //
     /* 1335239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1335295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335317 */     // GIR_Coverage, 19983,
     /* 1335317 */     GIR_EraseRootFromParent_Done,
     /* 1335318 */   // Label 19091: @1335318
     /* 1335318 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1335402), // Rule ID 19986 //
     /* 1335323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1335379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335401 */     // GIR_Coverage, 19986,
     /* 1335401 */     GIR_EraseRootFromParent_Done,
     /* 1335402 */   // Label 19092: @1335402
     /* 1335402 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1335486), // Rule ID 19987 //
     /* 1335407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1335463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335485 */     // GIR_Coverage, 19987,
     /* 1335485 */     GIR_EraseRootFromParent_Done,
     /* 1335486 */   // Label 19093: @1335486
     /* 1335486 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1335570), // Rule ID 19990 //
     /* 1335491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335544 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335569 */     // GIR_Coverage, 19990,
     /* 1335569 */     GIR_EraseRootFromParent_Done,
     /* 1335570 */   // Label 19094: @1335570
     /* 1335570 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1335654), // Rule ID 19991 //
     /* 1335575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335653 */     // GIR_Coverage, 19991,
     /* 1335653 */     GIR_EraseRootFromParent_Done,
     /* 1335654 */   // Label 19095: @1335654
     /* 1335654 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1335738), // Rule ID 19994 //
     /* 1335659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335737 */     // GIR_Coverage, 19994,
     /* 1335737 */     GIR_EraseRootFromParent_Done,
     /* 1335738 */   // Label 19096: @1335738
     /* 1335738 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1335822), // Rule ID 19995 //
     /* 1335743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335821 */     // GIR_Coverage, 19995,
     /* 1335821 */     GIR_EraseRootFromParent_Done,
     /* 1335822 */   // Label 19097: @1335822
     /* 1335822 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1335906), // Rule ID 19998 //
     /* 1335827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335905 */     // GIR_Coverage, 19998,
     /* 1335905 */     GIR_EraseRootFromParent_Done,
     /* 1335906 */   // Label 19098: @1335906
     /* 1335906 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1335990), // Rule ID 19999 //
     /* 1335911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335989 */     // GIR_Coverage, 19999,
     /* 1335989 */     GIR_EraseRootFromParent_Done,
     /* 1335990 */   // Label 19099: @1335990
     /* 1335990 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1336074), // Rule ID 20002 //
     /* 1335995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1336051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336073 */     // GIR_Coverage, 20002,
     /* 1336073 */     GIR_EraseRootFromParent_Done,
     /* 1336074 */   // Label 19100: @1336074
     /* 1336074 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1336158), // Rule ID 20003 //
     /* 1336079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1336135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336157 */     // GIR_Coverage, 20003,
     /* 1336157 */     GIR_EraseRootFromParent_Done,
     /* 1336158 */   // Label 19101: @1336158
     /* 1336158 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1336242), // Rule ID 20006 //
     /* 1336163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1336219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336241 */     // GIR_Coverage, 20006,
     /* 1336241 */     GIR_EraseRootFromParent_Done,
     /* 1336242 */   // Label 19102: @1336242
     /* 1336242 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1336326), // Rule ID 20007 //
     /* 1336247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1336303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336325 */     // GIR_Coverage, 20007,
     /* 1336325 */     GIR_EraseRootFromParent_Done,
     /* 1336326 */   // Label 19103: @1336326
     /* 1336326 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1336410), // Rule ID 20010 //
     /* 1336331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336409 */     // GIR_Coverage, 20010,
     /* 1336409 */     GIR_EraseRootFromParent_Done,
     /* 1336410 */   // Label 19104: @1336410
     /* 1336410 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1336494), // Rule ID 20011 //
     /* 1336415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336493 */     // GIR_Coverage, 20011,
     /* 1336493 */     GIR_EraseRootFromParent_Done,
     /* 1336494 */   // Label 19105: @1336494
     /* 1336494 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1336578), // Rule ID 20014 //
     /* 1336499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336577 */     // GIR_Coverage, 20014,
     /* 1336577 */     GIR_EraseRootFromParent_Done,
     /* 1336578 */   // Label 19106: @1336578
     /* 1336578 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1336662), // Rule ID 20015 //
     /* 1336583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336661 */     // GIR_Coverage, 20015,
     /* 1336661 */     GIR_EraseRootFromParent_Done,
     /* 1336662 */   // Label 19107: @1336662
     /* 1336662 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1336746), // Rule ID 20018 //
     /* 1336667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336745 */     // GIR_Coverage, 20018,
     /* 1336745 */     GIR_EraseRootFromParent_Done,
     /* 1336746 */   // Label 19108: @1336746
     /* 1336746 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1336830), // Rule ID 20019 //
     /* 1336751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336829 */     // GIR_Coverage, 20019,
     /* 1336829 */     GIR_EraseRootFromParent_Done,
     /* 1336830 */   // Label 19109: @1336830
     /* 1336830 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1336914), // Rule ID 20022 //
     /* 1336835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336913 */     // GIR_Coverage, 20022,
     /* 1336913 */     GIR_EraseRootFromParent_Done,
     /* 1336914 */   // Label 19110: @1336914
     /* 1336914 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1336998), // Rule ID 20023 //
     /* 1336919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336997 */     // GIR_Coverage, 20023,
     /* 1336997 */     GIR_EraseRootFromParent_Done,
     /* 1336998 */   // Label 19111: @1336998
     /* 1336998 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1337082), // Rule ID 20026 //
     /* 1337003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1337023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1337059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337081 */     // GIR_Coverage, 20026,
     /* 1337081 */     GIR_EraseRootFromParent_Done,
     /* 1337082 */   // Label 19112: @1337082
     /* 1337082 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1337166), // Rule ID 20027 //
     /* 1337087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1337107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1337143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337165 */     // GIR_Coverage, 20027,
     /* 1337165 */     GIR_EraseRootFromParent_Done,
     /* 1337166 */   // Label 19113: @1337166
     /* 1337166 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1337250), // Rule ID 20030 //
     /* 1337171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1337191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337249 */     // GIR_Coverage, 20030,
     /* 1337249 */     GIR_EraseRootFromParent_Done,
     /* 1337250 */   // Label 19114: @1337250
     /* 1337250 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1337334), // Rule ID 20031 //
     /* 1337255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1337275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337333 */     // GIR_Coverage, 20031,
     /* 1337333 */     GIR_EraseRootFromParent_Done,
     /* 1337334 */   // Label 19115: @1337334
     /* 1337334 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1337418), // Rule ID 20034 //
     /* 1337339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1337359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337417 */     // GIR_Coverage, 20034,
     /* 1337417 */     GIR_EraseRootFromParent_Done,
     /* 1337418 */   // Label 19116: @1337418
     /* 1337418 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1337502), // Rule ID 20035 //
     /* 1337423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1337443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337501 */     // GIR_Coverage, 20035,
     /* 1337501 */     GIR_EraseRootFromParent_Done,
     /* 1337502 */   // Label 19117: @1337502
     /* 1337502 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1337586), // Rule ID 20038 //
     /* 1337507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337585 */     // GIR_Coverage, 20038,
     /* 1337585 */     GIR_EraseRootFromParent_Done,
     /* 1337586 */   // Label 19118: @1337586
     /* 1337586 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1337670), // Rule ID 20039 //
     /* 1337591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337669 */     // GIR_Coverage, 20039,
     /* 1337669 */     GIR_EraseRootFromParent_Done,
     /* 1337670 */   // Label 19119: @1337670
     /* 1337670 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1337754), // Rule ID 20042 //
     /* 1337675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337753 */     // GIR_Coverage, 20042,
     /* 1337753 */     GIR_EraseRootFromParent_Done,
     /* 1337754 */   // Label 19120: @1337754
     /* 1337754 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1337838), // Rule ID 20043 //
     /* 1337759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337837 */     // GIR_Coverage, 20043,
     /* 1337837 */     GIR_EraseRootFromParent_Done,
     /* 1337838 */   // Label 19121: @1337838
     /* 1337838 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1337922), // Rule ID 20046 //
     /* 1337843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337921 */     // GIR_Coverage, 20046,
     /* 1337921 */     GIR_EraseRootFromParent_Done,
     /* 1337922 */   // Label 19122: @1337922
     /* 1337922 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1338006), // Rule ID 20047 //
     /* 1337927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338005 */     // GIR_Coverage, 20047,
     /* 1338005 */     GIR_EraseRootFromParent_Done,
     /* 1338006 */   // Label 19123: @1338006
     /* 1338006 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1338090), // Rule ID 20050 //
     /* 1338011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1338031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338064 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338089 */     // GIR_Coverage, 20050,
     /* 1338089 */     GIR_EraseRootFromParent_Done,
     /* 1338090 */   // Label 19124: @1338090
     /* 1338090 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1338174), // Rule ID 20051 //
     /* 1338095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1338115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338173 */     // GIR_Coverage, 20051,
     /* 1338173 */     GIR_EraseRootFromParent_Done,
     /* 1338174 */   // Label 19125: @1338174
     /* 1338174 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1338258), // Rule ID 20054 //
     /* 1338179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1338199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338257 */     // GIR_Coverage, 20054,
     /* 1338257 */     GIR_EraseRootFromParent_Done,
     /* 1338258 */   // Label 19126: @1338258
     /* 1338258 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1338342), // Rule ID 20055 //
     /* 1338263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1338283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338341 */     // GIR_Coverage, 20055,
     /* 1338341 */     GIR_EraseRootFromParent_Done,
     /* 1338342 */   // Label 19127: @1338342
     /* 1338342 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1338426), // Rule ID 20058 //
     /* 1338347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1338367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338425 */     // GIR_Coverage, 20058,
     /* 1338425 */     GIR_EraseRootFromParent_Done,
     /* 1338426 */   // Label 19128: @1338426
     /* 1338426 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1338510), // Rule ID 20059 //
     /* 1338431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1338451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338509 */     // GIR_Coverage, 20059,
     /* 1338509 */     GIR_EraseRootFromParent_Done,
     /* 1338510 */   // Label 19129: @1338510
     /* 1338510 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1338594), // Rule ID 20062 //
     /* 1338515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338593 */     // GIR_Coverage, 20062,
     /* 1338593 */     GIR_EraseRootFromParent_Done,
     /* 1338594 */   // Label 19130: @1338594
     /* 1338594 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1338678), // Rule ID 20063 //
     /* 1338599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338677 */     // GIR_Coverage, 20063,
     /* 1338677 */     GIR_EraseRootFromParent_Done,
     /* 1338678 */   // Label 19131: @1338678
     /* 1338678 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1338762), // Rule ID 20066 //
     /* 1338683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338736 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338761 */     // GIR_Coverage, 20066,
     /* 1338761 */     GIR_EraseRootFromParent_Done,
     /* 1338762 */   // Label 19132: @1338762
     /* 1338762 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1338846), // Rule ID 20067 //
     /* 1338767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338845 */     // GIR_Coverage, 20067,
     /* 1338845 */     GIR_EraseRootFromParent_Done,
     /* 1338846 */   // Label 19133: @1338846
     /* 1338846 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1338930), // Rule ID 20070 //
     /* 1338851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338929 */     // GIR_Coverage, 20070,
     /* 1338929 */     GIR_EraseRootFromParent_Done,
     /* 1338930 */   // Label 19134: @1338930
     /* 1338930 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1339014), // Rule ID 20071 //
     /* 1338935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339013 */     // GIR_Coverage, 20071,
     /* 1339013 */     GIR_EraseRootFromParent_Done,
     /* 1339014 */   // Label 19135: @1339014
     /* 1339014 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1339098), // Rule ID 20074 //
     /* 1339019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1339039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1339075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339097 */     // GIR_Coverage, 20074,
     /* 1339097 */     GIR_EraseRootFromParent_Done,
     /* 1339098 */   // Label 19136: @1339098
     /* 1339098 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1339182), // Rule ID 20075 //
     /* 1339103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1339123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1339159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339181 */     // GIR_Coverage, 20075,
     /* 1339181 */     GIR_EraseRootFromParent_Done,
     /* 1339182 */   // Label 19137: @1339182
     /* 1339182 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1339266), // Rule ID 20078 //
     /* 1339187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1339243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339265 */     // GIR_Coverage, 20078,
     /* 1339265 */     GIR_EraseRootFromParent_Done,
     /* 1339266 */   // Label 19138: @1339266
     /* 1339266 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1339350), // Rule ID 20079 //
     /* 1339271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1339327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339349 */     // GIR_Coverage, 20079,
     /* 1339349 */     GIR_EraseRootFromParent_Done,
     /* 1339350 */   // Label 19139: @1339350
     /* 1339350 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1339434), // Rule ID 20082 //
     /* 1339355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339433 */     // GIR_Coverage, 20082,
     /* 1339433 */     GIR_EraseRootFromParent_Done,
     /* 1339434 */   // Label 19140: @1339434
     /* 1339434 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1339518), // Rule ID 20083 //
     /* 1339439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339517 */     // GIR_Coverage, 20083,
     /* 1339517 */     GIR_EraseRootFromParent_Done,
     /* 1339518 */   // Label 19141: @1339518
     /* 1339518 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1339602), // Rule ID 20086 //
     /* 1339523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339576 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339601 */     // GIR_Coverage, 20086,
     /* 1339601 */     GIR_EraseRootFromParent_Done,
     /* 1339602 */   // Label 19142: @1339602
     /* 1339602 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1339686), // Rule ID 20087 //
     /* 1339607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339685 */     // GIR_Coverage, 20087,
     /* 1339685 */     GIR_EraseRootFromParent_Done,
     /* 1339686 */   // Label 19143: @1339686
     /* 1339686 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1339770), // Rule ID 20090 //
     /* 1339691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339769 */     // GIR_Coverage, 20090,
     /* 1339769 */     GIR_EraseRootFromParent_Done,
     /* 1339770 */   // Label 19144: @1339770
     /* 1339770 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1339854), // Rule ID 20091 //
     /* 1339775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339853 */     // GIR_Coverage, 20091,
     /* 1339853 */     GIR_EraseRootFromParent_Done,
     /* 1339854 */   // Label 19145: @1339854
     /* 1339854 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1339938), // Rule ID 20094 //
     /* 1339859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339937 */     // GIR_Coverage, 20094,
     /* 1339937 */     GIR_EraseRootFromParent_Done,
     /* 1339938 */   // Label 19146: @1339938
     /* 1339938 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1340022), // Rule ID 20095 //
     /* 1339943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340021 */     // GIR_Coverage, 20095,
     /* 1340021 */     GIR_EraseRootFromParent_Done,
     /* 1340022 */   // Label 19147: @1340022
     /* 1340022 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1340106), // Rule ID 20098 //
     /* 1340027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1340083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340105 */     // GIR_Coverage, 20098,
     /* 1340105 */     GIR_EraseRootFromParent_Done,
     /* 1340106 */   // Label 19148: @1340106
     /* 1340106 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1340190), // Rule ID 20099 //
     /* 1340111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1340167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340189 */     // GIR_Coverage, 20099,
     /* 1340189 */     GIR_EraseRootFromParent_Done,
     /* 1340190 */   // Label 19149: @1340190
     /* 1340190 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1340274), // Rule ID 20102 //
     /* 1340195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1340251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340273 */     // GIR_Coverage, 20102,
     /* 1340273 */     GIR_EraseRootFromParent_Done,
     /* 1340274 */   // Label 19150: @1340274
     /* 1340274 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1340358), // Rule ID 20103 //
     /* 1340279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1340335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340357 */     // GIR_Coverage, 20103,
     /* 1340357 */     GIR_EraseRootFromParent_Done,
     /* 1340358 */   // Label 19151: @1340358
     /* 1340358 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1340442), // Rule ID 20106 //
     /* 1340363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340441 */     // GIR_Coverage, 20106,
     /* 1340441 */     GIR_EraseRootFromParent_Done,
     /* 1340442 */   // Label 19152: @1340442
     /* 1340442 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1340526), // Rule ID 20107 //
     /* 1340447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340525 */     // GIR_Coverage, 20107,
     /* 1340525 */     GIR_EraseRootFromParent_Done,
     /* 1340526 */   // Label 19153: @1340526
     /* 1340526 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1340610), // Rule ID 20110 //
     /* 1340531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340584 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340609 */     // GIR_Coverage, 20110,
     /* 1340609 */     GIR_EraseRootFromParent_Done,
     /* 1340610 */   // Label 19154: @1340610
     /* 1340610 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1340694), // Rule ID 20111 //
     /* 1340615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340668 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340693 */     // GIR_Coverage, 20111,
     /* 1340693 */     GIR_EraseRootFromParent_Done,
     /* 1340694 */   // Label 19155: @1340694
     /* 1340694 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1340778), // Rule ID 20114 //
     /* 1340699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340777 */     // GIR_Coverage, 20114,
     /* 1340777 */     GIR_EraseRootFromParent_Done,
     /* 1340778 */   // Label 19156: @1340778
     /* 1340778 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1340862), // Rule ID 20115 //
     /* 1340783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340861 */     // GIR_Coverage, 20115,
     /* 1340861 */     GIR_EraseRootFromParent_Done,
     /* 1340862 */   // Label 19157: @1340862
     /* 1340862 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1340946), // Rule ID 20118 //
     /* 1340867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340945 */     // GIR_Coverage, 20118,
     /* 1340945 */     GIR_EraseRootFromParent_Done,
     /* 1340946 */   // Label 19158: @1340946
     /* 1340946 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1341030), // Rule ID 20119 //
     /* 1340951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1341007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341029 */     // GIR_Coverage, 20119,
     /* 1341029 */     GIR_EraseRootFromParent_Done,
     /* 1341030 */   // Label 19159: @1341030
     /* 1341030 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1341114), // Rule ID 20122 //
     /* 1341035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1341091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341113 */     // GIR_Coverage, 20122,
     /* 1341113 */     GIR_EraseRootFromParent_Done,
     /* 1341114 */   // Label 19160: @1341114
     /* 1341114 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1341198), // Rule ID 20123 //
     /* 1341119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1341175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341197 */     // GIR_Coverage, 20123,
     /* 1341197 */     GIR_EraseRootFromParent_Done,
     /* 1341198 */   // Label 19161: @1341198
     /* 1341198 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1341282), // Rule ID 20126 //
     /* 1341203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1341259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341281 */     // GIR_Coverage, 20126,
     /* 1341281 */     GIR_EraseRootFromParent_Done,
     /* 1341282 */   // Label 19162: @1341282
     /* 1341282 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1341366), // Rule ID 20127 //
     /* 1341287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1341343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341365 */     // GIR_Coverage, 20127,
     /* 1341365 */     GIR_EraseRootFromParent_Done,
     /* 1341366 */   // Label 19163: @1341366
     /* 1341366 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1341450), // Rule ID 20130 //
     /* 1341371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341449 */     // GIR_Coverage, 20130,
     /* 1341449 */     GIR_EraseRootFromParent_Done,
     /* 1341450 */   // Label 19164: @1341450
     /* 1341450 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1341534), // Rule ID 20131 //
     /* 1341455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341533 */     // GIR_Coverage, 20131,
     /* 1341533 */     GIR_EraseRootFromParent_Done,
     /* 1341534 */   // Label 19165: @1341534
     /* 1341534 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1341618), // Rule ID 20134 //
     /* 1341539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341617 */     // GIR_Coverage, 20134,
     /* 1341617 */     GIR_EraseRootFromParent_Done,
     /* 1341618 */   // Label 19166: @1341618
     /* 1341618 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1341702), // Rule ID 20135 //
     /* 1341623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341701 */     // GIR_Coverage, 20135,
     /* 1341701 */     GIR_EraseRootFromParent_Done,
     /* 1341702 */   // Label 19167: @1341702
     /* 1341702 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1341786), // Rule ID 20138 //
     /* 1341707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341785 */     // GIR_Coverage, 20138,
     /* 1341785 */     GIR_EraseRootFromParent_Done,
     /* 1341786 */   // Label 19168: @1341786
     /* 1341786 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1341870), // Rule ID 20139 //
     /* 1341791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341869 */     // GIR_Coverage, 20139,
     /* 1341869 */     GIR_EraseRootFromParent_Done,
     /* 1341870 */   // Label 19169: @1341870
     /* 1341870 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1341954), // Rule ID 20142 //
     /* 1341875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341953 */     // GIR_Coverage, 20142,
     /* 1341953 */     GIR_EraseRootFromParent_Done,
     /* 1341954 */   // Label 19170: @1341954
     /* 1341954 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1342038), // Rule ID 20143 //
     /* 1341959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342037 */     // GIR_Coverage, 20143,
     /* 1342037 */     GIR_EraseRootFromParent_Done,
     /* 1342038 */   // Label 19171: @1342038
     /* 1342038 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1342122), // Rule ID 20146 //
     /* 1342043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1342063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342121 */     // GIR_Coverage, 20146,
     /* 1342121 */     GIR_EraseRootFromParent_Done,
     /* 1342122 */   // Label 19172: @1342122
     /* 1342122 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1342206), // Rule ID 20147 //
     /* 1342127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1342147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1342183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342205 */     // GIR_Coverage, 20147,
     /* 1342205 */     GIR_EraseRootFromParent_Done,
     /* 1342206 */   // Label 19173: @1342206
     /* 1342206 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1342290), // Rule ID 20150 //
     /* 1342211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1342231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342289 */     // GIR_Coverage, 20150,
     /* 1342289 */     GIR_EraseRootFromParent_Done,
     /* 1342290 */   // Label 19174: @1342290
     /* 1342290 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1342374), // Rule ID 20151 //
     /* 1342295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1342315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342373 */     // GIR_Coverage, 20151,
     /* 1342373 */     GIR_EraseRootFromParent_Done,
     /* 1342374 */   // Label 19175: @1342374
     /* 1342374 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1342458), // Rule ID 20154 //
     /* 1342379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342457 */     // GIR_Coverage, 20154,
     /* 1342457 */     GIR_EraseRootFromParent_Done,
     /* 1342458 */   // Label 19176: @1342458
     /* 1342458 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1342542), // Rule ID 20155 //
     /* 1342463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342541 */     // GIR_Coverage, 20155,
     /* 1342541 */     GIR_EraseRootFromParent_Done,
     /* 1342542 */   // Label 19177: @1342542
     /* 1342542 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1342626), // Rule ID 20158 //
     /* 1342547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342600 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342625 */     // GIR_Coverage, 20158,
     /* 1342625 */     GIR_EraseRootFromParent_Done,
     /* 1342626 */   // Label 19178: @1342626
     /* 1342626 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1342710), // Rule ID 20159 //
     /* 1342631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342684 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342709 */     // GIR_Coverage, 20159,
     /* 1342709 */     GIR_EraseRootFromParent_Done,
     /* 1342710 */   // Label 19179: @1342710
     /* 1342710 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1342794), // Rule ID 20162 //
     /* 1342715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342793 */     // GIR_Coverage, 20162,
     /* 1342793 */     GIR_EraseRootFromParent_Done,
     /* 1342794 */   // Label 19180: @1342794
     /* 1342794 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1342878), // Rule ID 20163 //
     /* 1342799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342877 */     // GIR_Coverage, 20163,
     /* 1342877 */     GIR_EraseRootFromParent_Done,
     /* 1342878 */   // Label 19181: @1342878
     /* 1342878 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1342962), // Rule ID 20166 //
     /* 1342883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342936 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342961 */     // GIR_Coverage, 20166,
     /* 1342961 */     GIR_EraseRootFromParent_Done,
     /* 1342962 */   // Label 19182: @1342962
     /* 1342962 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1343046), // Rule ID 20167 //
     /* 1342967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343045 */     // GIR_Coverage, 20167,
     /* 1343045 */     GIR_EraseRootFromParent_Done,
     /* 1343046 */   // Label 19183: @1343046
     /* 1343046 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1343130), // Rule ID 20170 //
     /* 1343051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1343071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343104 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343129 */     // GIR_Coverage, 20170,
     /* 1343129 */     GIR_EraseRootFromParent_Done,
     /* 1343130 */   // Label 19184: @1343130
     /* 1343130 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1343214), // Rule ID 20171 //
     /* 1343135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1343155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343188 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343213 */     // GIR_Coverage, 20171,
     /* 1343213 */     GIR_EraseRootFromParent_Done,
     /* 1343214 */   // Label 19185: @1343214
     /* 1343214 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1343298), // Rule ID 20174 //
     /* 1343219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1343239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343297 */     // GIR_Coverage, 20174,
     /* 1343297 */     GIR_EraseRootFromParent_Done,
     /* 1343298 */   // Label 19186: @1343298
     /* 1343298 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1343382), // Rule ID 20175 //
     /* 1343303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1343323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343381 */     // GIR_Coverage, 20175,
     /* 1343381 */     GIR_EraseRootFromParent_Done,
     /* 1343382 */   // Label 19187: @1343382
     /* 1343382 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1343466), // Rule ID 20178 //
     /* 1343387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343465 */     // GIR_Coverage, 20178,
     /* 1343465 */     GIR_EraseRootFromParent_Done,
     /* 1343466 */   // Label 19188: @1343466
     /* 1343466 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1343550), // Rule ID 20179 //
     /* 1343471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343549 */     // GIR_Coverage, 20179,
     /* 1343549 */     GIR_EraseRootFromParent_Done,
     /* 1343550 */   // Label 19189: @1343550
     /* 1343550 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1343634), // Rule ID 20182 //
     /* 1343555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343633 */     // GIR_Coverage, 20182,
     /* 1343633 */     GIR_EraseRootFromParent_Done,
     /* 1343634 */   // Label 19190: @1343634
     /* 1343634 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1343718), // Rule ID 20183 //
     /* 1343639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343717 */     // GIR_Coverage, 20183,
     /* 1343717 */     GIR_EraseRootFromParent_Done,
     /* 1343718 */   // Label 19191: @1343718
     /* 1343718 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1343802), // Rule ID 20186 //
     /* 1343723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343801 */     // GIR_Coverage, 20186,
     /* 1343801 */     GIR_EraseRootFromParent_Done,
     /* 1343802 */   // Label 19192: @1343802
     /* 1343802 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1343886), // Rule ID 20187 //
     /* 1343807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343885 */     // GIR_Coverage, 20187,
     /* 1343885 */     GIR_EraseRootFromParent_Done,
     /* 1343886 */   // Label 19193: @1343886
     /* 1343886 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1343970), // Rule ID 20190 //
     /* 1343891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343969 */     // GIR_Coverage, 20190,
     /* 1343969 */     GIR_EraseRootFromParent_Done,
     /* 1343970 */   // Label 19194: @1343970
     /* 1343970 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1344054), // Rule ID 20191 //
     /* 1343975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1344031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344053 */     // GIR_Coverage, 20191,
     /* 1344053 */     GIR_EraseRootFromParent_Done,
     /* 1344054 */   // Label 19195: @1344054
     /* 1344054 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1344138), // Rule ID 20194 //
     /* 1344059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1344079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1344115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344137 */     // GIR_Coverage, 20194,
     /* 1344137 */     GIR_EraseRootFromParent_Done,
     /* 1344138 */   // Label 19196: @1344138
     /* 1344138 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1344222), // Rule ID 20195 //
     /* 1344143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1344163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1344199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344221 */     // GIR_Coverage, 20195,
     /* 1344221 */     GIR_EraseRootFromParent_Done,
     /* 1344222 */   // Label 19197: @1344222
     /* 1344222 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1344306), // Rule ID 20198 //
     /* 1344227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1344283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344305 */     // GIR_Coverage, 20198,
     /* 1344305 */     GIR_EraseRootFromParent_Done,
     /* 1344306 */   // Label 19198: @1344306
     /* 1344306 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1344390), // Rule ID 20199 //
     /* 1344311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1344367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344389 */     // GIR_Coverage, 20199,
     /* 1344389 */     GIR_EraseRootFromParent_Done,
     /* 1344390 */   // Label 19199: @1344390
     /* 1344390 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1344474), // Rule ID 20202 //
     /* 1344395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344473 */     // GIR_Coverage, 20202,
     /* 1344473 */     GIR_EraseRootFromParent_Done,
     /* 1344474 */   // Label 19200: @1344474
     /* 1344474 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1344558), // Rule ID 20203 //
     /* 1344479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344557 */     // GIR_Coverage, 20203,
     /* 1344557 */     GIR_EraseRootFromParent_Done,
     /* 1344558 */   // Label 19201: @1344558
     /* 1344558 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1344642), // Rule ID 20206 //
     /* 1344563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344641 */     // GIR_Coverage, 20206,
     /* 1344641 */     GIR_EraseRootFromParent_Done,
     /* 1344642 */   // Label 19202: @1344642
     /* 1344642 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1344726), // Rule ID 20207 //
     /* 1344647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344725 */     // GIR_Coverage, 20207,
     /* 1344725 */     GIR_EraseRootFromParent_Done,
     /* 1344726 */   // Label 19203: @1344726
     /* 1344726 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1344810), // Rule ID 20210 //
     /* 1344731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344809 */     // GIR_Coverage, 20210,
     /* 1344809 */     GIR_EraseRootFromParent_Done,
     /* 1344810 */   // Label 19204: @1344810
     /* 1344810 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1344894), // Rule ID 20211 //
     /* 1344815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344893 */     // GIR_Coverage, 20211,
     /* 1344893 */     GIR_EraseRootFromParent_Done,
     /* 1344894 */   // Label 19205: @1344894
     /* 1344894 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1344978), // Rule ID 20214 //
     /* 1344899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344977 */     // GIR_Coverage, 20214,
     /* 1344977 */     GIR_EraseRootFromParent_Done,
     /* 1344978 */   // Label 19206: @1344978
     /* 1344978 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1345062), // Rule ID 20215 //
     /* 1344983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1345039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345061 */     // GIR_Coverage, 20215,
     /* 1345061 */     GIR_EraseRootFromParent_Done,
     /* 1345062 */   // Label 19207: @1345062
     /* 1345062 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1345146), // Rule ID 20218 //
     /* 1345067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1345123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345145 */     // GIR_Coverage, 20218,
     /* 1345145 */     GIR_EraseRootFromParent_Done,
     /* 1345146 */   // Label 19208: @1345146
     /* 1345146 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1345230), // Rule ID 20219 //
     /* 1345151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345204 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1345207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345229 */     // GIR_Coverage, 20219,
     /* 1345229 */     GIR_EraseRootFromParent_Done,
     /* 1345230 */   // Label 19209: @1345230
     /* 1345230 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1345314), // Rule ID 20222 //
     /* 1345235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1345291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345313 */     // GIR_Coverage, 20222,
     /* 1345313 */     GIR_EraseRootFromParent_Done,
     /* 1345314 */   // Label 19210: @1345314
     /* 1345314 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1345398), // Rule ID 20223 //
     /* 1345319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1345375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345397 */     // GIR_Coverage, 20223,
     /* 1345397 */     GIR_EraseRootFromParent_Done,
     /* 1345398 */   // Label 19211: @1345398
     /* 1345398 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1345482), // Rule ID 20226 //
     /* 1345403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345456 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345481 */     // GIR_Coverage, 20226,
     /* 1345481 */     GIR_EraseRootFromParent_Done,
     /* 1345482 */   // Label 19212: @1345482
     /* 1345482 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1345566), // Rule ID 20227 //
     /* 1345487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345565 */     // GIR_Coverage, 20227,
     /* 1345565 */     GIR_EraseRootFromParent_Done,
     /* 1345566 */   // Label 19213: @1345566
     /* 1345566 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1345650), // Rule ID 20230 //
     /* 1345571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345649 */     // GIR_Coverage, 20230,
     /* 1345649 */     GIR_EraseRootFromParent_Done,
     /* 1345650 */   // Label 19214: @1345650
     /* 1345650 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1345734), // Rule ID 20231 //
     /* 1345655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345708 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345733 */     // GIR_Coverage, 20231,
     /* 1345733 */     GIR_EraseRootFromParent_Done,
     /* 1345734 */   // Label 19215: @1345734
     /* 1345734 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1345818), // Rule ID 20234 //
     /* 1345739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345817 */     // GIR_Coverage, 20234,
     /* 1345817 */     GIR_EraseRootFromParent_Done,
     /* 1345818 */   // Label 19216: @1345818
     /* 1345818 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1345902), // Rule ID 20235 //
     /* 1345823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345901 */     // GIR_Coverage, 20235,
     /* 1345901 */     GIR_EraseRootFromParent_Done,
     /* 1345902 */   // Label 19217: @1345902
     /* 1345902 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1345986), // Rule ID 20238 //
     /* 1345907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345960 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345985 */     // GIR_Coverage, 20238,
     /* 1345985 */     GIR_EraseRootFromParent_Done,
     /* 1345986 */   // Label 19218: @1345986
     /* 1345986 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1346070), // Rule ID 20239 //
     /* 1345991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1346047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346069 */     // GIR_Coverage, 20239,
     /* 1346069 */     GIR_EraseRootFromParent_Done,
     /* 1346070 */   // Label 19219: @1346070
     /* 1346070 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1346154), // Rule ID 20242 //
     /* 1346075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1346131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346153 */     // GIR_Coverage, 20242,
     /* 1346153 */     GIR_EraseRootFromParent_Done,
     /* 1346154 */   // Label 19220: @1346154
     /* 1346154 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1346238), // Rule ID 20243 //
     /* 1346159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1346215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346237 */     // GIR_Coverage, 20243,
     /* 1346237 */     GIR_EraseRootFromParent_Done,
     /* 1346238 */   // Label 19221: @1346238
     /* 1346238 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1346322), // Rule ID 20246 //
     /* 1346243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1346299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346321 */     // GIR_Coverage, 20246,
     /* 1346321 */     GIR_EraseRootFromParent_Done,
     /* 1346322 */   // Label 19222: @1346322
     /* 1346322 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1346406), // Rule ID 20247 //
     /* 1346327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1346383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346405 */     // GIR_Coverage, 20247,
     /* 1346405 */     GIR_EraseRootFromParent_Done,
     /* 1346406 */   // Label 19223: @1346406
     /* 1346406 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1346490), // Rule ID 20250 //
     /* 1346411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346464 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346489 */     // GIR_Coverage, 20250,
     /* 1346489 */     GIR_EraseRootFromParent_Done,
     /* 1346490 */   // Label 19224: @1346490
     /* 1346490 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1346574), // Rule ID 20251 //
     /* 1346495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346573 */     // GIR_Coverage, 20251,
     /* 1346573 */     GIR_EraseRootFromParent_Done,
     /* 1346574 */   // Label 19225: @1346574
     /* 1346574 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1346658), // Rule ID 20254 //
     /* 1346579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346657 */     // GIR_Coverage, 20254,
     /* 1346657 */     GIR_EraseRootFromParent_Done,
     /* 1346658 */   // Label 19226: @1346658
     /* 1346658 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1346742), // Rule ID 20255 //
     /* 1346663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346741 */     // GIR_Coverage, 20255,
     /* 1346741 */     GIR_EraseRootFromParent_Done,
     /* 1346742 */   // Label 19227: @1346742
     /* 1346742 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1346826), // Rule ID 20258 //
     /* 1346747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346825 */     // GIR_Coverage, 20258,
     /* 1346825 */     GIR_EraseRootFromParent_Done,
     /* 1346826 */   // Label 19228: @1346826
     /* 1346826 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1346910), // Rule ID 20259 //
     /* 1346831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346909 */     // GIR_Coverage, 20259,
     /* 1346909 */     GIR_EraseRootFromParent_Done,
     /* 1346910 */   // Label 19229: @1346910
     /* 1346910 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1346994), // Rule ID 20262 //
     /* 1346915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346993 */     // GIR_Coverage, 20262,
     /* 1346993 */     GIR_EraseRootFromParent_Done,
     /* 1346994 */   // Label 19230: @1346994
     /* 1346994 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1347078), // Rule ID 20263 //
     /* 1346999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1347055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347077 */     // GIR_Coverage, 20263,
     /* 1347077 */     GIR_EraseRootFromParent_Done,
     /* 1347078 */   // Label 19231: @1347078
     /* 1347078 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1347162), // Rule ID 20266 //
     /* 1347083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1347139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347161 */     // GIR_Coverage, 20266,
     /* 1347161 */     GIR_EraseRootFromParent_Done,
     /* 1347162 */   // Label 19232: @1347162
     /* 1347162 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1347246), // Rule ID 20267 //
     /* 1347167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1347223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347245 */     // GIR_Coverage, 20267,
     /* 1347245 */     GIR_EraseRootFromParent_Done,
     /* 1347246 */   // Label 19233: @1347246
     /* 1347246 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1347330), // Rule ID 20270 //
     /* 1347251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1347307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347329 */     // GIR_Coverage, 20270,
     /* 1347329 */     GIR_EraseRootFromParent_Done,
     /* 1347330 */   // Label 19234: @1347330
     /* 1347330 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1347414), // Rule ID 20271 //
     /* 1347335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1347391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347413 */     // GIR_Coverage, 20271,
     /* 1347413 */     GIR_EraseRootFromParent_Done,
     /* 1347414 */   // Label 19235: @1347414
     /* 1347414 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1347498), // Rule ID 20274 //
     /* 1347419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347497 */     // GIR_Coverage, 20274,
     /* 1347497 */     GIR_EraseRootFromParent_Done,
     /* 1347498 */   // Label 19236: @1347498
     /* 1347498 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1347582), // Rule ID 20275 //
     /* 1347503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347581 */     // GIR_Coverage, 20275,
     /* 1347581 */     GIR_EraseRootFromParent_Done,
     /* 1347582 */   // Label 19237: @1347582
     /* 1347582 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1347666), // Rule ID 20278 //
     /* 1347587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347665 */     // GIR_Coverage, 20278,
     /* 1347665 */     GIR_EraseRootFromParent_Done,
     /* 1347666 */   // Label 19238: @1347666
     /* 1347666 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1347750), // Rule ID 20279 //
     /* 1347671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347749 */     // GIR_Coverage, 20279,
     /* 1347749 */     GIR_EraseRootFromParent_Done,
     /* 1347750 */   // Label 19239: @1347750
     /* 1347750 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1347834), // Rule ID 20282 //
     /* 1347755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347833 */     // GIR_Coverage, 20282,
     /* 1347833 */     GIR_EraseRootFromParent_Done,
     /* 1347834 */   // Label 19240: @1347834
     /* 1347834 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1347918), // Rule ID 20283 //
     /* 1347839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347917 */     // GIR_Coverage, 20283,
     /* 1347917 */     GIR_EraseRootFromParent_Done,
     /* 1347918 */   // Label 19241: @1347918
     /* 1347918 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1348002), // Rule ID 20286 //
     /* 1347923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348001 */     // GIR_Coverage, 20286,
     /* 1348001 */     GIR_EraseRootFromParent_Done,
     /* 1348002 */   // Label 19242: @1348002
     /* 1348002 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1348086), // Rule ID 20287 //
     /* 1348007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1348063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348085 */     // GIR_Coverage, 20287,
     /* 1348085 */     GIR_EraseRootFromParent_Done,
     /* 1348086 */   // Label 19243: @1348086
     /* 1348086 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1348170), // Rule ID 20290 //
     /* 1348091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348144 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1348147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348169 */     // GIR_Coverage, 20290,
     /* 1348169 */     GIR_EraseRootFromParent_Done,
     /* 1348170 */   // Label 19244: @1348170
     /* 1348170 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1348254), // Rule ID 20291 //
     /* 1348175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348228 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1348231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348253 */     // GIR_Coverage, 20291,
     /* 1348253 */     GIR_EraseRootFromParent_Done,
     /* 1348254 */   // Label 19245: @1348254
     /* 1348254 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1348338), // Rule ID 20294 //
     /* 1348259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348312 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1348315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348337 */     // GIR_Coverage, 20294,
     /* 1348337 */     GIR_EraseRootFromParent_Done,
     /* 1348338 */   // Label 19246: @1348338
     /* 1348338 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1348422), // Rule ID 20295 //
     /* 1348343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1348399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348421 */     // GIR_Coverage, 20295,
     /* 1348421 */     GIR_EraseRootFromParent_Done,
     /* 1348422 */   // Label 19247: @1348422
     /* 1348422 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1348506), // Rule ID 20298 //
     /* 1348427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348505 */     // GIR_Coverage, 20298,
     /* 1348505 */     GIR_EraseRootFromParent_Done,
     /* 1348506 */   // Label 19248: @1348506
     /* 1348506 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1348590), // Rule ID 20299 //
     /* 1348511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348564 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348589 */     // GIR_Coverage, 20299,
     /* 1348589 */     GIR_EraseRootFromParent_Done,
     /* 1348590 */   // Label 19249: @1348590
     /* 1348590 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1348674), // Rule ID 20302 //
     /* 1348595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348673 */     // GIR_Coverage, 20302,
     /* 1348673 */     GIR_EraseRootFromParent_Done,
     /* 1348674 */   // Label 19250: @1348674
     /* 1348674 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1348758), // Rule ID 20303 //
     /* 1348679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348757 */     // GIR_Coverage, 20303,
     /* 1348757 */     GIR_EraseRootFromParent_Done,
     /* 1348758 */   // Label 19251: @1348758
     /* 1348758 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1348842), // Rule ID 20306 //
     /* 1348763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348841 */     // GIR_Coverage, 20306,
     /* 1348841 */     GIR_EraseRootFromParent_Done,
     /* 1348842 */   // Label 19252: @1348842
     /* 1348842 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1348926), // Rule ID 20307 //
     /* 1348847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348925 */     // GIR_Coverage, 20307,
     /* 1348925 */     GIR_EraseRootFromParent_Done,
     /* 1348926 */   // Label 19253: @1348926
     /* 1348926 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1349010), // Rule ID 20310 //
     /* 1348931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349009 */     // GIR_Coverage, 20310,
     /* 1349009 */     GIR_EraseRootFromParent_Done,
     /* 1349010 */   // Label 19254: @1349010
     /* 1349010 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1349094), // Rule ID 20311 //
     /* 1349015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1349071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349093 */     // GIR_Coverage, 20311,
     /* 1349093 */     GIR_EraseRootFromParent_Done,
     /* 1349094 */   // Label 19255: @1349094
     /* 1349094 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1349178), // Rule ID 20314 //
     /* 1349099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1349155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349177 */     // GIR_Coverage, 20314,
     /* 1349177 */     GIR_EraseRootFromParent_Done,
     /* 1349178 */   // Label 19256: @1349178
     /* 1349178 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1349262), // Rule ID 20315 //
     /* 1349183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1349239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349261 */     // GIR_Coverage, 20315,
     /* 1349261 */     GIR_EraseRootFromParent_Done,
     /* 1349262 */   // Label 19257: @1349262
     /* 1349262 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1349346), // Rule ID 20318 //
     /* 1349267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1349323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349345 */     // GIR_Coverage, 20318,
     /* 1349345 */     GIR_EraseRootFromParent_Done,
     /* 1349346 */   // Label 19258: @1349346
     /* 1349346 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1349430), // Rule ID 20319 //
     /* 1349351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1349407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349429 */     // GIR_Coverage, 20319,
     /* 1349429 */     GIR_EraseRootFromParent_Done,
     /* 1349430 */   // Label 19259: @1349430
     /* 1349430 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1349514), // Rule ID 20322 //
     /* 1349435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349513 */     // GIR_Coverage, 20322,
     /* 1349513 */     GIR_EraseRootFromParent_Done,
     /* 1349514 */   // Label 19260: @1349514
     /* 1349514 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1349598), // Rule ID 20323 //
     /* 1349519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349572 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349597 */     // GIR_Coverage, 20323,
     /* 1349597 */     GIR_EraseRootFromParent_Done,
     /* 1349598 */   // Label 19261: @1349598
     /* 1349598 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1349682), // Rule ID 20326 //
     /* 1349603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349681 */     // GIR_Coverage, 20326,
     /* 1349681 */     GIR_EraseRootFromParent_Done,
     /* 1349682 */   // Label 19262: @1349682
     /* 1349682 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1349766), // Rule ID 20327 //
     /* 1349687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349765 */     // GIR_Coverage, 20327,
     /* 1349765 */     GIR_EraseRootFromParent_Done,
     /* 1349766 */   // Label 19263: @1349766
     /* 1349766 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1349850), // Rule ID 20330 //
     /* 1349771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349849 */     // GIR_Coverage, 20330,
     /* 1349849 */     GIR_EraseRootFromParent_Done,
     /* 1349850 */   // Label 19264: @1349850
     /* 1349850 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1349934), // Rule ID 20331 //
     /* 1349855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349908 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349933 */     // GIR_Coverage, 20331,
     /* 1349933 */     GIR_EraseRootFromParent_Done,
     /* 1349934 */   // Label 19265: @1349934
     /* 1349934 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1350018), // Rule ID 20334 //
     /* 1349939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349992 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1349995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350017 */     // GIR_Coverage, 20334,
     /* 1350017 */     GIR_EraseRootFromParent_Done,
     /* 1350018 */   // Label 19266: @1350018
     /* 1350018 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1350102), // Rule ID 20335 //
     /* 1350023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1350040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1350079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350101 */     // GIR_Coverage, 20335,
     /* 1350101 */     GIR_EraseRootFromParent_Done,
     /* 1350102 */   // Label 19267: @1350102
     /* 1350102 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1350186), // Rule ID 20338 //
     /* 1350107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1350163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350185 */     // GIR_Coverage, 20338,
     /* 1350185 */     GIR_EraseRootFromParent_Done,
     /* 1350186 */   // Label 19268: @1350186
     /* 1350186 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1350270), // Rule ID 20339 //
     /* 1350191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350244 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1350247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350269 */     // GIR_Coverage, 20339,
     /* 1350269 */     GIR_EraseRootFromParent_Done,
     /* 1350270 */   // Label 19269: @1350270
     /* 1350270 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1350354), // Rule ID 20342 //
     /* 1350275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1350331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350353 */     // GIR_Coverage, 20342,
     /* 1350353 */     GIR_EraseRootFromParent_Done,
     /* 1350354 */   // Label 19270: @1350354
     /* 1350354 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1350438), // Rule ID 20343 //
     /* 1350359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1350415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350437 */     // GIR_Coverage, 20343,
     /* 1350437 */     GIR_EraseRootFromParent_Done,
     /* 1350438 */   // Label 19271: @1350438
     /* 1350438 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1350522), // Rule ID 20346 //
     /* 1350443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350521 */     // GIR_Coverage, 20346,
     /* 1350521 */     GIR_EraseRootFromParent_Done,
     /* 1350522 */   // Label 19272: @1350522
     /* 1350522 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1350606), // Rule ID 20347 //
     /* 1350527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350605 */     // GIR_Coverage, 20347,
     /* 1350605 */     GIR_EraseRootFromParent_Done,
     /* 1350606 */   // Label 19273: @1350606
     /* 1350606 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1350690), // Rule ID 20350 //
     /* 1350611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350689 */     // GIR_Coverage, 20350,
     /* 1350689 */     GIR_EraseRootFromParent_Done,
     /* 1350690 */   // Label 19274: @1350690
     /* 1350690 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1350774), // Rule ID 20351 //
     /* 1350695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350748 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350773 */     // GIR_Coverage, 20351,
     /* 1350773 */     GIR_EraseRootFromParent_Done,
     /* 1350774 */   // Label 19275: @1350774
     /* 1350774 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1350858), // Rule ID 20354 //
     /* 1350779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350857 */     // GIR_Coverage, 20354,
     /* 1350857 */     GIR_EraseRootFromParent_Done,
     /* 1350858 */   // Label 19276: @1350858
     /* 1350858 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1350942), // Rule ID 20355 //
     /* 1350863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350941 */     // GIR_Coverage, 20355,
     /* 1350941 */     GIR_EraseRootFromParent_Done,
     /* 1350942 */   // Label 19277: @1350942
     /* 1350942 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1351026), // Rule ID 20358 //
     /* 1350947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1351003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351025 */     // GIR_Coverage, 20358,
     /* 1351025 */     GIR_EraseRootFromParent_Done,
     /* 1351026 */   // Label 19278: @1351026
     /* 1351026 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1351110), // Rule ID 20359 //
     /* 1351031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1351048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1351087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351109 */     // GIR_Coverage, 20359,
     /* 1351109 */     GIR_EraseRootFromParent_Done,
     /* 1351110 */   // Label 19279: @1351110
     /* 1351110 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1351194), // Rule ID 20362 //
     /* 1351115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1351171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351193 */     // GIR_Coverage, 20362,
     /* 1351193 */     GIR_EraseRootFromParent_Done,
     /* 1351194 */   // Label 19280: @1351194
     /* 1351194 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1351278), // Rule ID 20363 //
     /* 1351199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1351255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351277 */     // GIR_Coverage, 20363,
     /* 1351277 */     GIR_EraseRootFromParent_Done,
     /* 1351278 */   // Label 19281: @1351278
     /* 1351278 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1351362), // Rule ID 20366 //
     /* 1351283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1351339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351361 */     // GIR_Coverage, 20366,
     /* 1351361 */     GIR_EraseRootFromParent_Done,
     /* 1351362 */   // Label 19282: @1351362
     /* 1351362 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1351446), // Rule ID 20367 //
     /* 1351367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1351423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351445 */     // GIR_Coverage, 20367,
     /* 1351445 */     GIR_EraseRootFromParent_Done,
     /* 1351446 */   // Label 19283: @1351446
     /* 1351446 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1351530), // Rule ID 20370 //
     /* 1351451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351529 */     // GIR_Coverage, 20370,
     /* 1351529 */     GIR_EraseRootFromParent_Done,
     /* 1351530 */   // Label 19284: @1351530
     /* 1351530 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1351614), // Rule ID 20371 //
     /* 1351535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351613 */     // GIR_Coverage, 20371,
     /* 1351613 */     GIR_EraseRootFromParent_Done,
     /* 1351614 */   // Label 19285: @1351614
     /* 1351614 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1351698), // Rule ID 20374 //
     /* 1351619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351697 */     // GIR_Coverage, 20374,
     /* 1351697 */     GIR_EraseRootFromParent_Done,
     /* 1351698 */   // Label 19286: @1351698
     /* 1351698 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1351782), // Rule ID 20375 //
     /* 1351703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351781 */     // GIR_Coverage, 20375,
     /* 1351781 */     GIR_EraseRootFromParent_Done,
     /* 1351782 */   // Label 19287: @1351782
     /* 1351782 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1351866), // Rule ID 20378 //
     /* 1351787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351865 */     // GIR_Coverage, 20378,
     /* 1351865 */     GIR_EraseRootFromParent_Done,
     /* 1351866 */   // Label 19288: @1351866
     /* 1351866 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1351950), // Rule ID 20379 //
     /* 1351871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351949 */     // GIR_Coverage, 20379,
     /* 1351949 */     GIR_EraseRootFromParent_Done,
     /* 1351950 */   // Label 19289: @1351950
     /* 1351950 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1352034), // Rule ID 20382 //
     /* 1351955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352033 */     // GIR_Coverage, 20382,
     /* 1352033 */     GIR_EraseRootFromParent_Done,
     /* 1352034 */   // Label 19290: @1352034
     /* 1352034 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1352118), // Rule ID 20383 //
     /* 1352039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1352056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1352059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352117 */     // GIR_Coverage, 20383,
     /* 1352117 */     GIR_EraseRootFromParent_Done,
     /* 1352118 */   // Label 19291: @1352118
     /* 1352118 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1352202), // Rule ID 20386 //
     /* 1352123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1352143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352201 */     // GIR_Coverage, 20386,
     /* 1352201 */     GIR_EraseRootFromParent_Done,
     /* 1352202 */   // Label 19292: @1352202
     /* 1352202 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1352286), // Rule ID 20387 //
     /* 1352207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1352227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1352263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352285 */     // GIR_Coverage, 20387,
     /* 1352285 */     GIR_EraseRootFromParent_Done,
     /* 1352286 */   // Label 19293: @1352286
     /* 1352286 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1352370), // Rule ID 20390 //
     /* 1352291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352369 */     // GIR_Coverage, 20390,
     /* 1352369 */     GIR_EraseRootFromParent_Done,
     /* 1352370 */   // Label 19294: @1352370
     /* 1352370 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1352454), // Rule ID 20391 //
     /* 1352375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352453 */     // GIR_Coverage, 20391,
     /* 1352453 */     GIR_EraseRootFromParent_Done,
     /* 1352454 */   // Label 19295: @1352454
     /* 1352454 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1352538), // Rule ID 20394 //
     /* 1352459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352537 */     // GIR_Coverage, 20394,
     /* 1352537 */     GIR_EraseRootFromParent_Done,
     /* 1352538 */   // Label 19296: @1352538
     /* 1352538 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1352622), // Rule ID 20395 //
     /* 1352543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352621 */     // GIR_Coverage, 20395,
     /* 1352621 */     GIR_EraseRootFromParent_Done,
     /* 1352622 */   // Label 19297: @1352622
     /* 1352622 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1352706), // Rule ID 20398 //
     /* 1352627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352680 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352705 */     // GIR_Coverage, 20398,
     /* 1352705 */     GIR_EraseRootFromParent_Done,
     /* 1352706 */   // Label 19298: @1352706
     /* 1352706 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1352790), // Rule ID 20399 //
     /* 1352711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352764 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352789 */     // GIR_Coverage, 20399,
     /* 1352789 */     GIR_EraseRootFromParent_Done,
     /* 1352790 */   // Label 19299: @1352790
     /* 1352790 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1352874), // Rule ID 20402 //
     /* 1352795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352873 */     // GIR_Coverage, 20402,
     /* 1352873 */     GIR_EraseRootFromParent_Done,
     /* 1352874 */   // Label 19300: @1352874
     /* 1352874 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1352958), // Rule ID 20403 //
     /* 1352879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352957 */     // GIR_Coverage, 20403,
     /* 1352957 */     GIR_EraseRootFromParent_Done,
     /* 1352958 */   // Label 19301: @1352958
     /* 1352958 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1353042), // Rule ID 20406 //
     /* 1352963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353041 */     // GIR_Coverage, 20406,
     /* 1353041 */     GIR_EraseRootFromParent_Done,
     /* 1353042 */   // Label 19302: @1353042
     /* 1353042 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1353126), // Rule ID 20407 //
     /* 1353047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1353064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1353067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353125 */     // GIR_Coverage, 20407,
     /* 1353125 */     GIR_EraseRootFromParent_Done,
     /* 1353126 */   // Label 19303: @1353126
     /* 1353126 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1353210), // Rule ID 20410 //
     /* 1353131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1353142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1353145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1353148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1353151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1353154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353209 */     // GIR_Coverage, 20410,
     /* 1353209 */     GIR_EraseRootFromParent_Done,
     /* 1353210 */   // Label 19304: @1353210
     /* 1353210 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1353294), // Rule ID 20411 //
     /* 1353215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1353226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1353229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1353232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1353235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1353238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353268 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353293 */     // GIR_Coverage, 20411,
     /* 1353293 */     GIR_EraseRootFromParent_Done,
     /* 1353294 */   // Label 19305: @1353294
     /* 1353294 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1353378), // Rule ID 20414 //
     /* 1353299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353377 */     // GIR_Coverage, 20414,
     /* 1353377 */     GIR_EraseRootFromParent_Done,
     /* 1353378 */   // Label 19306: @1353378
     /* 1353378 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1353462), // Rule ID 20415 //
     /* 1353383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353461 */     // GIR_Coverage, 20415,
     /* 1353461 */     GIR_EraseRootFromParent_Done,
     /* 1353462 */   // Label 19307: @1353462
     /* 1353462 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1353546), // Rule ID 20418 //
     /* 1353467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353545 */     // GIR_Coverage, 20418,
     /* 1353545 */     GIR_EraseRootFromParent_Done,
     /* 1353546 */   // Label 19308: @1353546
     /* 1353546 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1353630), // Rule ID 20419 //
     /* 1353551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353604 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353629 */     // GIR_Coverage, 20419,
     /* 1353629 */     GIR_EraseRootFromParent_Done,
     /* 1353630 */   // Label 19309: @1353630
     /* 1353630 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1353714), // Rule ID 20422 //
     /* 1353635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353713 */     // GIR_Coverage, 20422,
     /* 1353713 */     GIR_EraseRootFromParent_Done,
     /* 1353714 */   // Label 19310: @1353714
     /* 1353714 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1353798), // Rule ID 20423 //
     /* 1353719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353797 */     // GIR_Coverage, 20423,
     /* 1353797 */     GIR_EraseRootFromParent_Done,
     /* 1353798 */   // Label 19311: @1353798
     /* 1353798 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1353882), // Rule ID 20426 //
     /* 1353803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353881 */     // GIR_Coverage, 20426,
     /* 1353881 */     GIR_EraseRootFromParent_Done,
     /* 1353882 */   // Label 19312: @1353882
     /* 1353882 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1353966), // Rule ID 20427 //
     /* 1353887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353965 */     // GIR_Coverage, 20427,
     /* 1353965 */     GIR_EraseRootFromParent_Done,
     /* 1353966 */   // Label 19313: @1353966
     /* 1353966 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1354050), // Rule ID 20430 //
     /* 1353971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1354027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354049 */     // GIR_Coverage, 20430,
     /* 1354049 */     GIR_EraseRootFromParent_Done,
     /* 1354050 */   // Label 19314: @1354050
     /* 1354050 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1354134), // Rule ID 20431 //
     /* 1354055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1354075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1354111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354133 */     // GIR_Coverage, 20431,
     /* 1354133 */     GIR_EraseRootFromParent_Done,
     /* 1354134 */   // Label 19315: @1354134
     /* 1354134 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1354218), // Rule ID 20434 //
     /* 1354139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1354195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354217 */     // GIR_Coverage, 20434,
     /* 1354217 */     GIR_EraseRootFromParent_Done,
     /* 1354218 */   // Label 19316: @1354218
     /* 1354218 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1354302), // Rule ID 20435 //
     /* 1354223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1354231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1354279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354301 */     // GIR_Coverage, 20435,
     /* 1354301 */     GIR_EraseRootFromParent_Done,
     /* 1354302 */   // Label 19317: @1354302
     /* 1354302 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1354386), // Rule ID 20438 //
     /* 1354307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1354363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354385 */     // GIR_Coverage, 20438,
     /* 1354385 */     GIR_EraseRootFromParent_Done,
     /* 1354386 */   // Label 19318: @1354386
     /* 1354386 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1354470), // Rule ID 20439 //
     /* 1354391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1354447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354469 */     // GIR_Coverage, 20439,
     /* 1354469 */     GIR_EraseRootFromParent_Done,
     /* 1354470 */   // Label 19319: @1354470
     /* 1354470 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1354554), // Rule ID 20442 //
     /* 1354475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354553 */     // GIR_Coverage, 20442,
     /* 1354553 */     GIR_EraseRootFromParent_Done,
     /* 1354554 */   // Label 19320: @1354554
     /* 1354554 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1354638), // Rule ID 20443 //
     /* 1354559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354637 */     // GIR_Coverage, 20443,
     /* 1354637 */     GIR_EraseRootFromParent_Done,
     /* 1354638 */   // Label 19321: @1354638
     /* 1354638 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1354722), // Rule ID 20446 //
     /* 1354643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354721 */     // GIR_Coverage, 20446,
     /* 1354721 */     GIR_EraseRootFromParent_Done,
     /* 1354722 */   // Label 19322: @1354722
     /* 1354722 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1354806), // Rule ID 20447 //
     /* 1354727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354805 */     // GIR_Coverage, 20447,
     /* 1354805 */     GIR_EraseRootFromParent_Done,
     /* 1354806 */   // Label 19323: @1354806
     /* 1354806 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1354890), // Rule ID 20450 //
     /* 1354811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354889 */     // GIR_Coverage, 20450,
     /* 1354889 */     GIR_EraseRootFromParent_Done,
     /* 1354890 */   // Label 19324: @1354890
     /* 1354890 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1354974), // Rule ID 20451 //
     /* 1354895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354973 */     // GIR_Coverage, 20451,
     /* 1354973 */     GIR_EraseRootFromParent_Done,
     /* 1354974 */   // Label 19325: @1354974
     /* 1354974 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1355058), // Rule ID 20454 //
     /* 1354979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1354999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355057 */     // GIR_Coverage, 20454,
     /* 1355057 */     GIR_EraseRootFromParent_Done,
     /* 1355058 */   // Label 19326: @1355058
     /* 1355058 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1355142), // Rule ID 20455 //
     /* 1355063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355141 */     // GIR_Coverage, 20455,
     /* 1355141 */     GIR_EraseRootFromParent_Done,
     /* 1355142 */   // Label 19327: @1355142
     /* 1355142 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1355226), // Rule ID 20458 //
     /* 1355147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355225 */     // GIR_Coverage, 20458,
     /* 1355225 */     GIR_EraseRootFromParent_Done,
     /* 1355226 */   // Label 19328: @1355226
     /* 1355226 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1355310), // Rule ID 20459 //
     /* 1355231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1355242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1355245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355284 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1355287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355309 */     // GIR_Coverage, 20459,
     /* 1355309 */     GIR_EraseRootFromParent_Done,
     /* 1355310 */   // Label 19329: @1355310
     /* 1355310 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1355394), // Rule ID 20462 //
     /* 1355315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1355335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355393 */     // GIR_Coverage, 20462,
     /* 1355393 */     GIR_EraseRootFromParent_Done,
     /* 1355394 */   // Label 19330: @1355394
     /* 1355394 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1355478), // Rule ID 20463 //
     /* 1355399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1355416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1355419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355477 */     // GIR_Coverage, 20463,
     /* 1355477 */     GIR_EraseRootFromParent_Done,
     /* 1355478 */   // Label 19331: @1355478
     /* 1355478 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1355562), // Rule ID 20466 //
     /* 1355483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355561 */     // GIR_Coverage, 20466,
     /* 1355561 */     GIR_EraseRootFromParent_Done,
     /* 1355562 */   // Label 19332: @1355562
     /* 1355562 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1355646), // Rule ID 20467 //
     /* 1355567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355645 */     // GIR_Coverage, 20467,
     /* 1355645 */     GIR_EraseRootFromParent_Done,
     /* 1355646 */   // Label 19333: @1355646
     /* 1355646 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1355730), // Rule ID 20470 //
     /* 1355651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355704 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355729 */     // GIR_Coverage, 20470,
     /* 1355729 */     GIR_EraseRootFromParent_Done,
     /* 1355730 */   // Label 19334: @1355730
     /* 1355730 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1355814), // Rule ID 20471 //
     /* 1355735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355788 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355813 */     // GIR_Coverage, 20471,
     /* 1355813 */     GIR_EraseRootFromParent_Done,
     /* 1355814 */   // Label 19335: @1355814
     /* 1355814 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1355898), // Rule ID 20474 //
     /* 1355819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355897 */     // GIR_Coverage, 20474,
     /* 1355897 */     GIR_EraseRootFromParent_Done,
     /* 1355898 */   // Label 19336: @1355898
     /* 1355898 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1355982), // Rule ID 20475 //
     /* 1355903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355981 */     // GIR_Coverage, 20475,
     /* 1355981 */     GIR_EraseRootFromParent_Done,
     /* 1355982 */   // Label 19337: @1355982
     /* 1355982 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1356066), // Rule ID 20478 //
     /* 1355987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356065 */     // GIR_Coverage, 20478,
     /* 1356065 */     GIR_EraseRootFromParent_Done,
     /* 1356066 */   // Label 19338: @1356066
     /* 1356066 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1356150), // Rule ID 20479 //
     /* 1356071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1356088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1356091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356149 */     // GIR_Coverage, 20479,
     /* 1356149 */     GIR_EraseRootFromParent_Done,
     /* 1356150 */   // Label 19339: @1356150
     /* 1356150 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1356234), // Rule ID 20482 //
     /* 1356155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1356158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1356175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356233 */     // GIR_Coverage, 20482,
     /* 1356233 */     GIR_EraseRootFromParent_Done,
     /* 1356234 */   // Label 19340: @1356234
     /* 1356234 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1356318), // Rule ID 20483 //
     /* 1356239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1356242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1356250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1356253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1356256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1356259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1356313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356317 */     // GIR_Coverage, 20483,
     /* 1356317 */     GIR_EraseRootFromParent_Done,
     /* 1356318 */   // Label 19341: @1356318
     /* 1356318 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1356402), // Rule ID 20486 //
     /* 1356323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1356334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1356337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1356343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1356379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356401 */     // GIR_Coverage, 20486,
     /* 1356401 */     GIR_EraseRootFromParent_Done,
     /* 1356402 */   // Label 19342: @1356402
     /* 1356402 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1356486), // Rule ID 20487 //
     /* 1356407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1356418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1356421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1356424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1356427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1356463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356485 */     // GIR_Coverage, 20487,
     /* 1356485 */     GIR_EraseRootFromParent_Done,
     /* 1356486 */   // Label 19343: @1356486
     /* 1356486 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1356570), // Rule ID 20490 //
     /* 1356491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356569 */     // GIR_Coverage, 20490,
     /* 1356569 */     GIR_EraseRootFromParent_Done,
     /* 1356570 */   // Label 19344: @1356570
     /* 1356570 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1356654), // Rule ID 20491 //
     /* 1356575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356653 */     // GIR_Coverage, 20491,
     /* 1356653 */     GIR_EraseRootFromParent_Done,
     /* 1356654 */   // Label 19345: @1356654
     /* 1356654 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1356738), // Rule ID 20494 //
     /* 1356659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356712 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356737 */     // GIR_Coverage, 20494,
     /* 1356737 */     GIR_EraseRootFromParent_Done,
     /* 1356738 */   // Label 19346: @1356738
     /* 1356738 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1356822), // Rule ID 20495 //
     /* 1356743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356821 */     // GIR_Coverage, 20495,
     /* 1356821 */     GIR_EraseRootFromParent_Done,
     /* 1356822 */   // Label 19347: @1356822
     /* 1356822 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1356903), // Rule ID 20552 //
     /* 1356827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356880 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356902 */     // GIR_Coverage, 20552,
     /* 1356902 */     GIR_EraseRootFromParent_Done,
     /* 1356903 */   // Label 19348: @1356903
     /* 1356903 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1356984), // Rule ID 20553 //
     /* 1356908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356961 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356983 */     // GIR_Coverage, 20553,
     /* 1356983 */     GIR_EraseRootFromParent_Done,
     /* 1356984 */   // Label 19349: @1356984
     /* 1356984 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1357065), // Rule ID 20554 //
     /* 1356989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1357000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1357003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357042 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1357045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357064 */     // GIR_Coverage, 20554,
     /* 1357064 */     GIR_EraseRootFromParent_Done,
     /* 1357065 */   // Label 19350: @1357065
     /* 1357065 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1357146), // Rule ID 20555 //
     /* 1357070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1357081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1357084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1357087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357123 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1357126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357145 */     // GIR_Coverage, 20555,
     /* 1357145 */     GIR_EraseRootFromParent_Done,
     /* 1357146 */   // Label 19351: @1357146
     /* 1357146 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1357227), // Rule ID 20556 //
     /* 1357151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357204 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357226 */     // GIR_Coverage, 20556,
     /* 1357226 */     GIR_EraseRootFromParent_Done,
     /* 1357227 */   // Label 19352: @1357227
     /* 1357227 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1357308), // Rule ID 20557 //
     /* 1357232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1357252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357285 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357307 */     // GIR_Coverage, 20557,
     /* 1357307 */     GIR_EraseRootFromParent_Done,
     /* 1357308 */   // Label 19353: @1357308
     /* 1357308 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1357389), // Rule ID 20558 //
     /* 1357313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357366 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1357369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357388 */     // GIR_Coverage, 20558,
     /* 1357388 */     GIR_EraseRootFromParent_Done,
     /* 1357389 */   // Label 19354: @1357389
     /* 1357389 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1357470), // Rule ID 20559 //
     /* 1357394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1357405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1357408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1357411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357447 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1357450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357469 */     // GIR_Coverage, 20559,
     /* 1357469 */     GIR_EraseRootFromParent_Done,
     /* 1357470 */   // Label 19355: @1357470
     /* 1357470 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1357551), // Rule ID 20560 //
     /* 1357475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357528 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357550 */     // GIR_Coverage, 20560,
     /* 1357550 */     GIR_EraseRootFromParent_Done,
     /* 1357551 */   // Label 19356: @1357551
     /* 1357551 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1357632), // Rule ID 20561 //
     /* 1357556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357609 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357631 */     // GIR_Coverage, 20561,
     /* 1357631 */     GIR_EraseRootFromParent_Done,
     /* 1357632 */   // Label 19357: @1357632
     /* 1357632 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1357713), // Rule ID 20562 //
     /* 1357637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357712 */     // GIR_Coverage, 20562,
     /* 1357712 */     GIR_EraseRootFromParent_Done,
     /* 1357713 */   // Label 19358: @1357713
     /* 1357713 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1357794), // Rule ID 20563 //
     /* 1357718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357771 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357793 */     // GIR_Coverage, 20563,
     /* 1357793 */     GIR_EraseRootFromParent_Done,
     /* 1357794 */   // Label 19359: @1357794
     /* 1357794 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1357875), // Rule ID 20564 //
     /* 1357799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357874 */     // GIR_Coverage, 20564,
     /* 1357874 */     GIR_EraseRootFromParent_Done,
     /* 1357875 */   // Label 19360: @1357875
     /* 1357875 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1357956), // Rule ID 20565 //
     /* 1357880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357955 */     // GIR_Coverage, 20565,
     /* 1357955 */     GIR_EraseRootFromParent_Done,
     /* 1357956 */   // Label 19361: @1357956
     /* 1357956 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1358037), // Rule ID 20566 //
     /* 1357961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358014 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1358017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358036 */     // GIR_Coverage, 20566,
     /* 1358036 */     GIR_EraseRootFromParent_Done,
     /* 1358037 */   // Label 19362: @1358037
     /* 1358037 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1358118), // Rule ID 20567 //
     /* 1358042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1358059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358095 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1358098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358117 */     // GIR_Coverage, 20567,
     /* 1358117 */     GIR_EraseRootFromParent_Done,
     /* 1358118 */   // Label 19363: @1358118
     /* 1358118 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1358199), // Rule ID 20568 //
     /* 1358123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1358176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358198 */     // GIR_Coverage, 20568,
     /* 1358198 */     GIR_EraseRootFromParent_Done,
     /* 1358199 */   // Label 19364: @1358199
     /* 1358199 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1358280), // Rule ID 20569 //
     /* 1358204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1358224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358257 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1358257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358279 */     // GIR_Coverage, 20569,
     /* 1358279 */     GIR_EraseRootFromParent_Done,
     /* 1358280 */   // Label 19365: @1358280
     /* 1358280 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1358361), // Rule ID 20570 //
     /* 1358285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1358288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1358327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358338 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1358338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1358341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358360 */     // GIR_Coverage, 20570,
     /* 1358360 */     GIR_EraseRootFromParent_Done,
     /* 1358361 */   // Label 19366: @1358361
     /* 1358361 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1358442), // Rule ID 20571 //
     /* 1358366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1358369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1358377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1358380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1358383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1358386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1358408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358419 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1358419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1358422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358441 */     // GIR_Coverage, 20571,
     /* 1358441 */     GIR_EraseRootFromParent_Done,
     /* 1358442 */   // Label 19367: @1358442
     /* 1358442 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1358523), // Rule ID 20572 //
     /* 1358447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358522 */     // GIR_Coverage, 20572,
     /* 1358522 */     GIR_EraseRootFromParent_Done,
     /* 1358523 */   // Label 19368: @1358523
     /* 1358523 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1358604), // Rule ID 20573 //
     /* 1358528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358581 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358603 */     // GIR_Coverage, 20573,
     /* 1358603 */     GIR_EraseRootFromParent_Done,
     /* 1358604 */   // Label 19369: @1358604
     /* 1358604 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1358685), // Rule ID 20574 //
     /* 1358609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358684 */     // GIR_Coverage, 20574,
     /* 1358684 */     GIR_EraseRootFromParent_Done,
     /* 1358685 */   // Label 19370: @1358685
     /* 1358685 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1358766), // Rule ID 20575 //
     /* 1358690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358743 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358765 */     // GIR_Coverage, 20575,
     /* 1358765 */     GIR_EraseRootFromParent_Done,
     /* 1358766 */   // Label 19371: @1358766
     /* 1358766 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1358847), // Rule ID 20576 //
     /* 1358771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358846 */     // GIR_Coverage, 20576,
     /* 1358846 */     GIR_EraseRootFromParent_Done,
     /* 1358847 */   // Label 19372: @1358847
     /* 1358847 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1358928), // Rule ID 20577 //
     /* 1358852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358905 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358927 */     // GIR_Coverage, 20577,
     /* 1358927 */     GIR_EraseRootFromParent_Done,
     /* 1358928 */   // Label 19373: @1358928
     /* 1358928 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1359009), // Rule ID 20578 //
     /* 1358933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358986 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359008 */     // GIR_Coverage, 20578,
     /* 1359008 */     GIR_EraseRootFromParent_Done,
     /* 1359009 */   // Label 19374: @1359009
     /* 1359009 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1359090), // Rule ID 20579 //
     /* 1359014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1359025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1359028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1359031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359067 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1359070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359089 */     // GIR_Coverage, 20579,
     /* 1359089 */     GIR_EraseRootFromParent_Done,
     /* 1359090 */   // Label 19375: @1359090
     /* 1359090 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1359171), // Rule ID 20580 //
     /* 1359095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1359098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1359115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359148 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359170 */     // GIR_Coverage, 20580,
     /* 1359170 */     GIR_EraseRootFromParent_Done,
     /* 1359171 */   // Label 19376: @1359171
     /* 1359171 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1359252), // Rule ID 20581 //
     /* 1359176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1359196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359229 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359251 */     // GIR_Coverage, 20581,
     /* 1359251 */     GIR_EraseRootFromParent_Done,
     /* 1359252 */   // Label 19377: @1359252
     /* 1359252 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1359333), // Rule ID 20582 //
     /* 1359257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359310 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1359313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359332 */     // GIR_Coverage, 20582,
     /* 1359332 */     GIR_EraseRootFromParent_Done,
     /* 1359333 */   // Label 19378: @1359333
     /* 1359333 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1359414), // Rule ID 20583 //
     /* 1359338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1359349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1359352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1359355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359391 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1359394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359413 */     // GIR_Coverage, 20583,
     /* 1359413 */     GIR_EraseRootFromParent_Done,
     /* 1359414 */   // Label 19379: @1359414
     /* 1359414 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1359495), // Rule ID 20584 //
     /* 1359419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1359422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359472 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359494 */     // GIR_Coverage, 20584,
     /* 1359494 */     GIR_EraseRootFromParent_Done,
     /* 1359495 */   // Label 19380: @1359495
     /* 1359495 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1359576), // Rule ID 20585 //
     /* 1359500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359553 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359575 */     // GIR_Coverage, 20585,
     /* 1359575 */     GIR_EraseRootFromParent_Done,
     /* 1359576 */   // Label 19381: @1359576
     /* 1359576 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1359657), // Rule ID 20586 //
     /* 1359581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359634 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359656 */     // GIR_Coverage, 20586,
     /* 1359656 */     GIR_EraseRootFromParent_Done,
     /* 1359657 */   // Label 19382: @1359657
     /* 1359657 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1359738), // Rule ID 20587 //
     /* 1359662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359715 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359737 */     // GIR_Coverage, 20587,
     /* 1359737 */     GIR_EraseRootFromParent_Done,
     /* 1359738 */   // Label 19383: @1359738
     /* 1359738 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1359819), // Rule ID 20588 //
     /* 1359743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359796 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359818 */     // GIR_Coverage, 20588,
     /* 1359818 */     GIR_EraseRootFromParent_Done,
     /* 1359819 */   // Label 19384: @1359819
     /* 1359819 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1359900), // Rule ID 20589 //
     /* 1359824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359877 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359899 */     // GIR_Coverage, 20589,
     /* 1359899 */     GIR_EraseRootFromParent_Done,
     /* 1359900 */   // Label 19385: @1359900
     /* 1359900 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1359981), // Rule ID 20590 //
     /* 1359905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359958 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359980 */     // GIR_Coverage, 20590,
     /* 1359980 */     GIR_EraseRootFromParent_Done,
     /* 1359981 */   // Label 19386: @1359981
     /* 1359981 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1360062), // Rule ID 20591 //
     /* 1359986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1360000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1360003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1360042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360061 */     // GIR_Coverage, 20591,
     /* 1360061 */     GIR_EraseRootFromParent_Done,
     /* 1360062 */   // Label 19387: @1360062
     /* 1360062 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1360143), // Rule ID 20592 //
     /* 1360067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1360087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360120 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360142 */     // GIR_Coverage, 20592,
     /* 1360142 */     GIR_EraseRootFromParent_Done,
     /* 1360143 */   // Label 19388: @1360143
     /* 1360143 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1360224), // Rule ID 20593 //
     /* 1360148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1360168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360201 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360223 */     // GIR_Coverage, 20593,
     /* 1360223 */     GIR_EraseRootFromParent_Done,
     /* 1360224 */   // Label 19389: @1360224
     /* 1360224 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1360305), // Rule ID 20594 //
     /* 1360229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1360285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360304 */     // GIR_Coverage, 20594,
     /* 1360304 */     GIR_EraseRootFromParent_Done,
     /* 1360305 */   // Label 19390: @1360305
     /* 1360305 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1360386), // Rule ID 20595 //
     /* 1360310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1360321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1360324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1360327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360363 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1360366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360385 */     // GIR_Coverage, 20595,
     /* 1360385 */     GIR_EraseRootFromParent_Done,
     /* 1360386 */   // Label 19391: @1360386
     /* 1360386 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1360467), // Rule ID 20596 //
     /* 1360391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360466 */     // GIR_Coverage, 20596,
     /* 1360466 */     GIR_EraseRootFromParent_Done,
     /* 1360467 */   // Label 19392: @1360467
     /* 1360467 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1360548), // Rule ID 20597 //
     /* 1360472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360547 */     // GIR_Coverage, 20597,
     /* 1360547 */     GIR_EraseRootFromParent_Done,
     /* 1360548 */   // Label 19393: @1360548
     /* 1360548 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1360629), // Rule ID 20598 //
     /* 1360553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360606 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360628 */     // GIR_Coverage, 20598,
     /* 1360628 */     GIR_EraseRootFromParent_Done,
     /* 1360629 */   // Label 19394: @1360629
     /* 1360629 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1360710), // Rule ID 20599 //
     /* 1360634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360687 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360709 */     // GIR_Coverage, 20599,
     /* 1360709 */     GIR_EraseRootFromParent_Done,
     /* 1360710 */   // Label 19395: @1360710
     /* 1360710 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1360791), // Rule ID 20600 //
     /* 1360715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360768 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360790 */     // GIR_Coverage, 20600,
     /* 1360790 */     GIR_EraseRootFromParent_Done,
     /* 1360791 */   // Label 19396: @1360791
     /* 1360791 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1360872), // Rule ID 20601 //
     /* 1360796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360849 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360871 */     // GIR_Coverage, 20601,
     /* 1360871 */     GIR_EraseRootFromParent_Done,
     /* 1360872 */   // Label 19397: @1360872
     /* 1360872 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1360953), // Rule ID 20602 //
     /* 1360877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360952 */     // GIR_Coverage, 20602,
     /* 1360952 */     GIR_EraseRootFromParent_Done,
     /* 1360953 */   // Label 19398: @1360953
     /* 1360953 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1361034), // Rule ID 20603 //
     /* 1360958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361011 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1361014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361033 */     // GIR_Coverage, 20603,
     /* 1361033 */     GIR_EraseRootFromParent_Done,
     /* 1361034 */   // Label 19399: @1361034
     /* 1361034 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1361115), // Rule ID 20604 //
     /* 1361039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1361059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361092 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1361095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361114 */     // GIR_Coverage, 20604,
     /* 1361114 */     GIR_EraseRootFromParent_Done,
     /* 1361115 */   // Label 19400: @1361115
     /* 1361115 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1361196), // Rule ID 20605 //
     /* 1361120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1361140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361173 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1361176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361195 */     // GIR_Coverage, 20605,
     /* 1361195 */     GIR_EraseRootFromParent_Done,
     /* 1361196 */   // Label 19401: @1361196
     /* 1361196 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1361277), // Rule ID 20606 //
     /* 1361201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1361257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361276 */     // GIR_Coverage, 20606,
     /* 1361276 */     GIR_EraseRootFromParent_Done,
     /* 1361277 */   // Label 19402: @1361277
     /* 1361277 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1361358), // Rule ID 20607 //
     /* 1361282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1361293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1361296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1361312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361335 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1361338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361357 */     // GIR_Coverage, 20607,
     /* 1361357 */     GIR_EraseRootFromParent_Done,
     /* 1361358 */   // Label 19403: @1361358
     /* 1361358 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1361439), // Rule ID 20608 //
     /* 1361363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1361383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361416 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361438 */     // GIR_Coverage, 20608,
     /* 1361438 */     GIR_EraseRootFromParent_Done,
     /* 1361439 */   // Label 19404: @1361439
     /* 1361439 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1361520), // Rule ID 20609 //
     /* 1361444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1361452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1361464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361497 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361519 */     // GIR_Coverage, 20609,
     /* 1361519 */     GIR_EraseRootFromParent_Done,
     /* 1361520 */   // Label 19405: @1361520
     /* 1361520 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1361601), // Rule ID 20610 //
     /* 1361525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361578 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361600 */     // GIR_Coverage, 20610,
     /* 1361600 */     GIR_EraseRootFromParent_Done,
     /* 1361601 */   // Label 19406: @1361601
     /* 1361601 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1361682), // Rule ID 20611 //
     /* 1361606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361659 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361681 */     // GIR_Coverage, 20611,
     /* 1361681 */     GIR_EraseRootFromParent_Done,
     /* 1361682 */   // Label 19407: @1361682
     /* 1361682 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1361766), // Rule ID 21992 //
     /* 1361687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361765 */     // GIR_Coverage, 21992,
     /* 1361765 */     GIR_EraseRootFromParent_Done,
     /* 1361766 */   // Label 19408: @1361766
     /* 1361766 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1361850), // Rule ID 21993 //
     /* 1361771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361849 */     // GIR_Coverage, 21993,
     /* 1361849 */     GIR_EraseRootFromParent_Done,
     /* 1361850 */   // Label 19409: @1361850
     /* 1361850 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1361934), // Rule ID 21996 //
     /* 1361855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361933 */     // GIR_Coverage, 21996,
     /* 1361933 */     GIR_EraseRootFromParent_Done,
     /* 1361934 */   // Label 19410: @1361934
     /* 1361934 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1362018), // Rule ID 21997 //
     /* 1361939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362017 */     // GIR_Coverage, 21997,
     /* 1362017 */     GIR_EraseRootFromParent_Done,
     /* 1362018 */   // Label 19411: @1362018
     /* 1362018 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1362102), // Rule ID 22000 //
     /* 1362023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362076 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1362079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362101 */     // GIR_Coverage, 22000,
     /* 1362101 */     GIR_EraseRootFromParent_Done,
     /* 1362102 */   // Label 19412: @1362102
     /* 1362102 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1362186), // Rule ID 22001 //
     /* 1362107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1362163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362185 */     // GIR_Coverage, 22001,
     /* 1362185 */     GIR_EraseRootFromParent_Done,
     /* 1362186 */   // Label 19413: @1362186
     /* 1362186 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1362270), // Rule ID 22004 //
     /* 1362191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1362247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362269 */     // GIR_Coverage, 22004,
     /* 1362269 */     GIR_EraseRootFromParent_Done,
     /* 1362270 */   // Label 19414: @1362270
     /* 1362270 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1362354), // Rule ID 22005 //
     /* 1362275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1362331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362353 */     // GIR_Coverage, 22005,
     /* 1362353 */     GIR_EraseRootFromParent_Done,
     /* 1362354 */   // Label 19415: @1362354
     /* 1362354 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1362438), // Rule ID 22008 //
     /* 1362359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362437 */     // GIR_Coverage, 22008,
     /* 1362437 */     GIR_EraseRootFromParent_Done,
     /* 1362438 */   // Label 19416: @1362438
     /* 1362438 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1362522), // Rule ID 22009 //
     /* 1362443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362521 */     // GIR_Coverage, 22009,
     /* 1362521 */     GIR_EraseRootFromParent_Done,
     /* 1362522 */   // Label 19417: @1362522
     /* 1362522 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1362606), // Rule ID 22012 //
     /* 1362527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362580 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362605 */     // GIR_Coverage, 22012,
     /* 1362605 */     GIR_EraseRootFromParent_Done,
     /* 1362606 */   // Label 19418: @1362606
     /* 1362606 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1362690), // Rule ID 22013 //
     /* 1362611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362689 */     // GIR_Coverage, 22013,
     /* 1362689 */     GIR_EraseRootFromParent_Done,
     /* 1362690 */   // Label 19419: @1362690
     /* 1362690 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1362774), // Rule ID 22016 //
     /* 1362695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362748 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362773 */     // GIR_Coverage, 22016,
     /* 1362773 */     GIR_EraseRootFromParent_Done,
     /* 1362774 */   // Label 19420: @1362774
     /* 1362774 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1362858), // Rule ID 22017 //
     /* 1362779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362857 */     // GIR_Coverage, 22017,
     /* 1362857 */     GIR_EraseRootFromParent_Done,
     /* 1362858 */   // Label 19421: @1362858
     /* 1362858 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1362942), // Rule ID 22020 //
     /* 1362863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362941 */     // GIR_Coverage, 22020,
     /* 1362941 */     GIR_EraseRootFromParent_Done,
     /* 1362942 */   // Label 19422: @1362942
     /* 1362942 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1363026), // Rule ID 22021 //
     /* 1362947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1363003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363025 */     // GIR_Coverage, 22021,
     /* 1363025 */     GIR_EraseRootFromParent_Done,
     /* 1363026 */   // Label 19423: @1363026
     /* 1363026 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1363110), // Rule ID 22024 //
     /* 1363031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1363034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1363087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363109 */     // GIR_Coverage, 22024,
     /* 1363109 */     GIR_EraseRootFromParent_Done,
     /* 1363110 */   // Label 19424: @1363110
     /* 1363110 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1363194), // Rule ID 22025 //
     /* 1363115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1363118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1363171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363193 */     // GIR_Coverage, 22025,
     /* 1363193 */     GIR_EraseRootFromParent_Done,
     /* 1363194 */   // Label 19425: @1363194
     /* 1363194 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1363278), // Rule ID 22028 //
     /* 1363199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1363255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363277 */     // GIR_Coverage, 22028,
     /* 1363277 */     GIR_EraseRootFromParent_Done,
     /* 1363278 */   // Label 19426: @1363278
     /* 1363278 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1363362), // Rule ID 22029 //
     /* 1363283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1363339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363361 */     // GIR_Coverage, 22029,
     /* 1363361 */     GIR_EraseRootFromParent_Done,
     /* 1363362 */   // Label 19427: @1363362
     /* 1363362 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1363446), // Rule ID 22032 //
     /* 1363367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363445 */     // GIR_Coverage, 22032,
     /* 1363445 */     GIR_EraseRootFromParent_Done,
     /* 1363446 */   // Label 19428: @1363446
     /* 1363446 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1363530), // Rule ID 22033 //
     /* 1363451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363529 */     // GIR_Coverage, 22033,
     /* 1363529 */     GIR_EraseRootFromParent_Done,
     /* 1363530 */   // Label 19429: @1363530
     /* 1363530 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1363614), // Rule ID 22036 //
     /* 1363535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363588 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363613 */     // GIR_Coverage, 22036,
     /* 1363613 */     GIR_EraseRootFromParent_Done,
     /* 1363614 */   // Label 19430: @1363614
     /* 1363614 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1363698), // Rule ID 22037 //
     /* 1363619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11566:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363697 */     // GIR_Coverage, 22037,
     /* 1363697 */     GIR_EraseRootFromParent_Done,
     /* 1363698 */   // Label 19431: @1363698
     /* 1363698 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1363782), // Rule ID 22040 //
     /* 1363703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363781 */     // GIR_Coverage, 22040,
     /* 1363781 */     GIR_EraseRootFromParent_Done,
     /* 1363782 */   // Label 19432: @1363782
     /* 1363782 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1363866), // Rule ID 22041 //
     /* 1363787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363865 */     // GIR_Coverage, 22041,
     /* 1363865 */     GIR_EraseRootFromParent_Done,
     /* 1363866 */   // Label 19433: @1363866
     /* 1363866 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1363950), // Rule ID 22044 //
     /* 1363871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363949 */     // GIR_Coverage, 22044,
     /* 1363949 */     GIR_EraseRootFromParent_Done,
     /* 1363950 */   // Label 19434: @1363950
     /* 1363950 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1364034), // Rule ID 22045 //
     /* 1363955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1364011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364033 */     // GIR_Coverage, 22045,
     /* 1364033 */     GIR_EraseRootFromParent_Done,
     /* 1364034 */   // Label 19435: @1364034
     /* 1364034 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1364118), // Rule ID 22048 //
     /* 1364039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1364095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364117 */     // GIR_Coverage, 22048,
     /* 1364117 */     GIR_EraseRootFromParent_Done,
     /* 1364118 */   // Label 19436: @1364118
     /* 1364118 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1364202), // Rule ID 22049 //
     /* 1364123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11566:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1364179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364201 */     // GIR_Coverage, 22049,
     /* 1364201 */     GIR_EraseRootFromParent_Done,
     /* 1364202 */   // Label 19437: @1364202
     /* 1364202 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1364286), // Rule ID 22052 //
     /* 1364207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1364263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364285 */     // GIR_Coverage, 22052,
     /* 1364285 */     GIR_EraseRootFromParent_Done,
     /* 1364286 */   // Label 19438: @1364286
     /* 1364286 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1364370), // Rule ID 22053 //
     /* 1364291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1364347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364369 */     // GIR_Coverage, 22053,
     /* 1364369 */     GIR_EraseRootFromParent_Done,
     /* 1364370 */   // Label 19439: @1364370
     /* 1364370 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1364454), // Rule ID 22056 //
     /* 1364375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364453 */     // GIR_Coverage, 22056,
     /* 1364453 */     GIR_EraseRootFromParent_Done,
     /* 1364454 */   // Label 19440: @1364454
     /* 1364454 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1364538), // Rule ID 22057 //
     /* 1364459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364512 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364537 */     // GIR_Coverage, 22057,
     /* 1364537 */     GIR_EraseRootFromParent_Done,
     /* 1364538 */   // Label 19441: @1364538
     /* 1364538 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1364622), // Rule ID 22060 //
     /* 1364543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364621 */     // GIR_Coverage, 22060,
     /* 1364621 */     GIR_EraseRootFromParent_Done,
     /* 1364622 */   // Label 19442: @1364622
     /* 1364622 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1364706), // Rule ID 22061 //
     /* 1364627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11566:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364705 */     // GIR_Coverage, 22061,
     /* 1364705 */     GIR_EraseRootFromParent_Done,
     /* 1364706 */   // Label 19443: @1364706
     /* 1364706 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1364790), // Rule ID 22064 //
     /* 1364711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364789 */     // GIR_Coverage, 22064,
     /* 1364789 */     GIR_EraseRootFromParent_Done,
     /* 1364790 */   // Label 19444: @1364790
     /* 1364790 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1364874), // Rule ID 22065 //
     /* 1364795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364873 */     // GIR_Coverage, 22065,
     /* 1364873 */     GIR_EraseRootFromParent_Done,
     /* 1364874 */   // Label 19445: @1364874
     /* 1364874 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1364958), // Rule ID 22068 //
     /* 1364879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364957 */     // GIR_Coverage, 22068,
     /* 1364957 */     GIR_EraseRootFromParent_Done,
     /* 1364958 */   // Label 19446: @1364958
     /* 1364958 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1365042), // Rule ID 22069 //
     /* 1364963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1365019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365041 */     // GIR_Coverage, 22069,
     /* 1365041 */     GIR_EraseRootFromParent_Done,
     /* 1365042 */   // Label 19447: @1365042
     /* 1365042 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1365126), // Rule ID 22072 //
     /* 1365047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1365103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365125 */     // GIR_Coverage, 22072,
     /* 1365125 */     GIR_EraseRootFromParent_Done,
     /* 1365126 */   // Label 19448: @1365126
     /* 1365126 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1365210), // Rule ID 22073 //
     /* 1365131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1365139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11566:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1365187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365209 */     // GIR_Coverage, 22073,
     /* 1365209 */     GIR_EraseRootFromParent_Done,
     /* 1365210 */   // Label 19449: @1365210
     /* 1365210 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1365294), // Rule ID 22076 //
     /* 1365215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365268 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1365271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365293 */     // GIR_Coverage, 22076,
     /* 1365293 */     GIR_EraseRootFromParent_Done,
     /* 1365294 */   // Label 19450: @1365294
     /* 1365294 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1365378), // Rule ID 22077 //
     /* 1365299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1365355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365377 */     // GIR_Coverage, 22077,
     /* 1365377 */     GIR_EraseRootFromParent_Done,
     /* 1365378 */   // Label 19451: @1365378
     /* 1365378 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1365462), // Rule ID 22080 //
     /* 1365383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365461 */     // GIR_Coverage, 22080,
     /* 1365461 */     GIR_EraseRootFromParent_Done,
     /* 1365462 */   // Label 19452: @1365462
     /* 1365462 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1365546), // Rule ID 22081 //
     /* 1365467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365545 */     // GIR_Coverage, 22081,
     /* 1365545 */     GIR_EraseRootFromParent_Done,
     /* 1365546 */   // Label 19453: @1365546
     /* 1365546 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1365630), // Rule ID 22084 //
     /* 1365551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365629 */     // GIR_Coverage, 22084,
     /* 1365629 */     GIR_EraseRootFromParent_Done,
     /* 1365630 */   // Label 19454: @1365630
     /* 1365630 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1365714), // Rule ID 22085 //
     /* 1365635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365713 */     // GIR_Coverage, 22085,
     /* 1365713 */     GIR_EraseRootFromParent_Done,
     /* 1365714 */   // Label 19455: @1365714
     /* 1365714 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1365798), // Rule ID 22088 //
     /* 1365719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365797 */     // GIR_Coverage, 22088,
     /* 1365797 */     GIR_EraseRootFromParent_Done,
     /* 1365798 */   // Label 19456: @1365798
     /* 1365798 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1365882), // Rule ID 22089 //
     /* 1365803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365856 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365881 */     // GIR_Coverage, 22089,
     /* 1365881 */     GIR_EraseRootFromParent_Done,
     /* 1365882 */   // Label 19457: @1365882
     /* 1365882 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1365966), // Rule ID 22092 //
     /* 1365887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365965 */     // GIR_Coverage, 22092,
     /* 1365965 */     GIR_EraseRootFromParent_Done,
     /* 1365966 */   // Label 19458: @1365966
     /* 1365966 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1366050), // Rule ID 22093 //
     /* 1365971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1366027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366049 */     // GIR_Coverage, 22093,
     /* 1366049 */     GIR_EraseRootFromParent_Done,
     /* 1366050 */   // Label 19459: @1366050
     /* 1366050 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1366134), // Rule ID 22096 //
     /* 1366055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1366111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366133 */     // GIR_Coverage, 22096,
     /* 1366133 */     GIR_EraseRootFromParent_Done,
     /* 1366134 */   // Label 19460: @1366134
     /* 1366134 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1366218), // Rule ID 22097 //
     /* 1366139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1366195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366217 */     // GIR_Coverage, 22097,
     /* 1366217 */     GIR_EraseRootFromParent_Done,
     /* 1366218 */   // Label 19461: @1366218
     /* 1366218 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1366302), // Rule ID 22100 //
     /* 1366223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1366279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366301 */     // GIR_Coverage, 22100,
     /* 1366301 */     GIR_EraseRootFromParent_Done,
     /* 1366302 */   // Label 19462: @1366302
     /* 1366302 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1366386), // Rule ID 22101 //
     /* 1366307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1366363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366385 */     // GIR_Coverage, 22101,
     /* 1366385 */     GIR_EraseRootFromParent_Done,
     /* 1366386 */   // Label 19463: @1366386
     /* 1366386 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1366470), // Rule ID 22104 //
     /* 1366391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366469 */     // GIR_Coverage, 22104,
     /* 1366469 */     GIR_EraseRootFromParent_Done,
     /* 1366470 */   // Label 19464: @1366470
     /* 1366470 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1366554), // Rule ID 22105 //
     /* 1366475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366553 */     // GIR_Coverage, 22105,
     /* 1366553 */     GIR_EraseRootFromParent_Done,
     /* 1366554 */   // Label 19465: @1366554
     /* 1366554 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1366638), // Rule ID 22108 //
     /* 1366559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366612 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366637 */     // GIR_Coverage, 22108,
     /* 1366637 */     GIR_EraseRootFromParent_Done,
     /* 1366638 */   // Label 19466: @1366638
     /* 1366638 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1366722), // Rule ID 22109 //
     /* 1366643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366721 */     // GIR_Coverage, 22109,
     /* 1366721 */     GIR_EraseRootFromParent_Done,
     /* 1366722 */   // Label 19467: @1366722
     /* 1366722 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1366806), // Rule ID 22112 //
     /* 1366727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366780 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366805 */     // GIR_Coverage, 22112,
     /* 1366805 */     GIR_EraseRootFromParent_Done,
     /* 1366806 */   // Label 19468: @1366806
     /* 1366806 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1366890), // Rule ID 22113 //
     /* 1366811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366889 */     // GIR_Coverage, 22113,
     /* 1366889 */     GIR_EraseRootFromParent_Done,
     /* 1366890 */   // Label 19469: @1366890
     /* 1366890 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1366974), // Rule ID 22116 //
     /* 1366895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366973 */     // GIR_Coverage, 22116,
     /* 1366973 */     GIR_EraseRootFromParent_Done,
     /* 1366974 */   // Label 19470: @1366974
     /* 1366974 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1367058), // Rule ID 22117 //
     /* 1366979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1367035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367057 */     // GIR_Coverage, 22117,
     /* 1367057 */     GIR_EraseRootFromParent_Done,
     /* 1367058 */   // Label 19471: @1367058
     /* 1367058 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1367142), // Rule ID 22120 //
     /* 1367063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367116 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1367119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367141 */     // GIR_Coverage, 22120,
     /* 1367141 */     GIR_EraseRootFromParent_Done,
     /* 1367142 */   // Label 19472: @1367142
     /* 1367142 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1367226), // Rule ID 22121 //
     /* 1367147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1367203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367225 */     // GIR_Coverage, 22121,
     /* 1367225 */     GIR_EraseRootFromParent_Done,
     /* 1367226 */   // Label 19473: @1367226
     /* 1367226 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1367310), // Rule ID 22124 //
     /* 1367231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1367287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367309 */     // GIR_Coverage, 22124,
     /* 1367309 */     GIR_EraseRootFromParent_Done,
     /* 1367310 */   // Label 19474: @1367310
     /* 1367310 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1367394), // Rule ID 22125 //
     /* 1367315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1367371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367393 */     // GIR_Coverage, 22125,
     /* 1367393 */     GIR_EraseRootFromParent_Done,
     /* 1367394 */   // Label 19475: @1367394
     /* 1367394 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1367478), // Rule ID 22128 //
     /* 1367399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367477 */     // GIR_Coverage, 22128,
     /* 1367477 */     GIR_EraseRootFromParent_Done,
     /* 1367478 */   // Label 19476: @1367478
     /* 1367478 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1367562), // Rule ID 22129 //
     /* 1367483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367561 */     // GIR_Coverage, 22129,
     /* 1367561 */     GIR_EraseRootFromParent_Done,
     /* 1367562 */   // Label 19477: @1367562
     /* 1367562 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1367646), // Rule ID 22132 //
     /* 1367567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367645 */     // GIR_Coverage, 22132,
     /* 1367645 */     GIR_EraseRootFromParent_Done,
     /* 1367646 */   // Label 19478: @1367646
     /* 1367646 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1367730), // Rule ID 22133 //
     /* 1367651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367729 */     // GIR_Coverage, 22133,
     /* 1367729 */     GIR_EraseRootFromParent_Done,
     /* 1367730 */   // Label 19479: @1367730
     /* 1367730 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1367814), // Rule ID 22136 //
     /* 1367735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367813 */     // GIR_Coverage, 22136,
     /* 1367813 */     GIR_EraseRootFromParent_Done,
     /* 1367814 */   // Label 19480: @1367814
     /* 1367814 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1367898), // Rule ID 22137 //
     /* 1367819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367897 */     // GIR_Coverage, 22137,
     /* 1367897 */     GIR_EraseRootFromParent_Done,
     /* 1367898 */   // Label 19481: @1367898
     /* 1367898 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1367982), // Rule ID 22140 //
     /* 1367903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367981 */     // GIR_Coverage, 22140,
     /* 1367981 */     GIR_EraseRootFromParent_Done,
     /* 1367982 */   // Label 19482: @1367982
     /* 1367982 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1368066), // Rule ID 22141 //
     /* 1367987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1368004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1368043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368065 */     // GIR_Coverage, 22141,
     /* 1368065 */     GIR_EraseRootFromParent_Done,
     /* 1368066 */   // Label 19483: @1368066
     /* 1368066 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1368150), // Rule ID 22144 //
     /* 1368071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1368127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368149 */     // GIR_Coverage, 22144,
     /* 1368149 */     GIR_EraseRootFromParent_Done,
     /* 1368150 */   // Label 19484: @1368150
     /* 1368150 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1368234), // Rule ID 22145 //
     /* 1368155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1368211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368233 */     // GIR_Coverage, 22145,
     /* 1368233 */     GIR_EraseRootFromParent_Done,
     /* 1368234 */   // Label 19485: @1368234
     /* 1368234 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1368318), // Rule ID 22148 //
     /* 1368239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1368295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368317 */     // GIR_Coverage, 22148,
     /* 1368317 */     GIR_EraseRootFromParent_Done,
     /* 1368318 */   // Label 19486: @1368318
     /* 1368318 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1368402), // Rule ID 22149 //
     /* 1368323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1368379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368401 */     // GIR_Coverage, 22149,
     /* 1368401 */     GIR_EraseRootFromParent_Done,
     /* 1368402 */   // Label 19487: @1368402
     /* 1368402 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1368486), // Rule ID 22152 //
     /* 1368407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368460 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368485 */     // GIR_Coverage, 22152,
     /* 1368485 */     GIR_EraseRootFromParent_Done,
     /* 1368486 */   // Label 19488: @1368486
     /* 1368486 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1368570), // Rule ID 22153 //
     /* 1368491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368569 */     // GIR_Coverage, 22153,
     /* 1368569 */     GIR_EraseRootFromParent_Done,
     /* 1368570 */   // Label 19489: @1368570
     /* 1368570 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1368654), // Rule ID 22156 //
     /* 1368575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368653 */     // GIR_Coverage, 22156,
     /* 1368653 */     GIR_EraseRootFromParent_Done,
     /* 1368654 */   // Label 19490: @1368654
     /* 1368654 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1368738), // Rule ID 22157 //
     /* 1368659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368737 */     // GIR_Coverage, 22157,
     /* 1368737 */     GIR_EraseRootFromParent_Done,
     /* 1368738 */   // Label 19491: @1368738
     /* 1368738 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1368822), // Rule ID 22160 //
     /* 1368743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368821 */     // GIR_Coverage, 22160,
     /* 1368821 */     GIR_EraseRootFromParent_Done,
     /* 1368822 */   // Label 19492: @1368822
     /* 1368822 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1368906), // Rule ID 22161 //
     /* 1368827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368880 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368905 */     // GIR_Coverage, 22161,
     /* 1368905 */     GIR_EraseRootFromParent_Done,
     /* 1368906 */   // Label 19493: @1368906
     /* 1368906 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1368990), // Rule ID 22164 //
     /* 1368911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368989 */     // GIR_Coverage, 22164,
     /* 1368989 */     GIR_EraseRootFromParent_Done,
     /* 1368990 */   // Label 19494: @1368990
     /* 1368990 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1369074), // Rule ID 22165 //
     /* 1368995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1369012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1369051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369073 */     // GIR_Coverage, 22165,
     /* 1369073 */     GIR_EraseRootFromParent_Done,
     /* 1369074 */   // Label 19495: @1369074
     /* 1369074 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1369158), // Rule ID 22168 //
     /* 1369079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1369135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369157 */     // GIR_Coverage, 22168,
     /* 1369157 */     GIR_EraseRootFromParent_Done,
     /* 1369158 */   // Label 19496: @1369158
     /* 1369158 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1369242), // Rule ID 22169 //
     /* 1369163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1369219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369241 */     // GIR_Coverage, 22169,
     /* 1369241 */     GIR_EraseRootFromParent_Done,
     /* 1369242 */   // Label 19497: @1369242
     /* 1369242 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1369326), // Rule ID 22172 //
     /* 1369247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1369303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369325 */     // GIR_Coverage, 22172,
     /* 1369325 */     GIR_EraseRootFromParent_Done,
     /* 1369326 */   // Label 19498: @1369326
     /* 1369326 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1369410), // Rule ID 22173 //
     /* 1369331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1369387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369409 */     // GIR_Coverage, 22173,
     /* 1369409 */     GIR_EraseRootFromParent_Done,
     /* 1369410 */   // Label 19499: @1369410
     /* 1369410 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1369494), // Rule ID 22176 //
     /* 1369415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369493 */     // GIR_Coverage, 22176,
     /* 1369493 */     GIR_EraseRootFromParent_Done,
     /* 1369494 */   // Label 19500: @1369494
     /* 1369494 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1369578), // Rule ID 22177 //
     /* 1369499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369577 */     // GIR_Coverage, 22177,
     /* 1369577 */     GIR_EraseRootFromParent_Done,
     /* 1369578 */   // Label 19501: @1369578
     /* 1369578 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1369662), // Rule ID 22180 //
     /* 1369583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369661 */     // GIR_Coverage, 22180,
     /* 1369661 */     GIR_EraseRootFromParent_Done,
     /* 1369662 */   // Label 19502: @1369662
     /* 1369662 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1369746), // Rule ID 22181 //
     /* 1369667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369745 */     // GIR_Coverage, 22181,
     /* 1369745 */     GIR_EraseRootFromParent_Done,
     /* 1369746 */   // Label 19503: @1369746
     /* 1369746 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1369830), // Rule ID 22184 //
     /* 1369751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369829 */     // GIR_Coverage, 22184,
     /* 1369829 */     GIR_EraseRootFromParent_Done,
     /* 1369830 */   // Label 19504: @1369830
     /* 1369830 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1369914), // Rule ID 22185 //
     /* 1369835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369913 */     // GIR_Coverage, 22185,
     /* 1369913 */     GIR_EraseRootFromParent_Done,
     /* 1369914 */   // Label 19505: @1369914
     /* 1369914 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1369998), // Rule ID 22188 //
     /* 1369919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369972 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369997 */     // GIR_Coverage, 22188,
     /* 1369997 */     GIR_EraseRootFromParent_Done,
     /* 1369998 */   // Label 19506: @1369998
     /* 1369998 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1370082), // Rule ID 22189 //
     /* 1370003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1370020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1370059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370081 */     // GIR_Coverage, 22189,
     /* 1370081 */     GIR_EraseRootFromParent_Done,
     /* 1370082 */   // Label 19507: @1370082
     /* 1370082 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1370166), // Rule ID 22192 //
     /* 1370087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1370143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370165 */     // GIR_Coverage, 22192,
     /* 1370165 */     GIR_EraseRootFromParent_Done,
     /* 1370166 */   // Label 19508: @1370166
     /* 1370166 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1370250), // Rule ID 22193 //
     /* 1370171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1370227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370249 */     // GIR_Coverage, 22193,
     /* 1370249 */     GIR_EraseRootFromParent_Done,
     /* 1370250 */   // Label 19509: @1370250
     /* 1370250 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1370334), // Rule ID 22196 //
     /* 1370255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1370311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370333 */     // GIR_Coverage, 22196,
     /* 1370333 */     GIR_EraseRootFromParent_Done,
     /* 1370334 */   // Label 19510: @1370334
     /* 1370334 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1370418), // Rule ID 22197 //
     /* 1370339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1370395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370417 */     // GIR_Coverage, 22197,
     /* 1370417 */     GIR_EraseRootFromParent_Done,
     /* 1370418 */   // Label 19511: @1370418
     /* 1370418 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1370502), // Rule ID 22200 //
     /* 1370423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1370426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370501 */     // GIR_Coverage, 22200,
     /* 1370501 */     GIR_EraseRootFromParent_Done,
     /* 1370502 */   // Label 19512: @1370502
     /* 1370502 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1370586), // Rule ID 22201 //
     /* 1370507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370585 */     // GIR_Coverage, 22201,
     /* 1370585 */     GIR_EraseRootFromParent_Done,
     /* 1370586 */   // Label 19513: @1370586
     /* 1370586 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1370670), // Rule ID 22204 //
     /* 1370591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370669 */     // GIR_Coverage, 22204,
     /* 1370669 */     GIR_EraseRootFromParent_Done,
     /* 1370670 */   // Label 19514: @1370670
     /* 1370670 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1370754), // Rule ID 22205 //
     /* 1370675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370753 */     // GIR_Coverage, 22205,
     /* 1370753 */     GIR_EraseRootFromParent_Done,
     /* 1370754 */   // Label 19515: @1370754
     /* 1370754 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1370838), // Rule ID 22208 //
     /* 1370759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370837 */     // GIR_Coverage, 22208,
     /* 1370837 */     GIR_EraseRootFromParent_Done,
     /* 1370838 */   // Label 19516: @1370838
     /* 1370838 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1370922), // Rule ID 22209 //
     /* 1370843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370921 */     // GIR_Coverage, 22209,
     /* 1370921 */     GIR_EraseRootFromParent_Done,
     /* 1370922 */   // Label 19517: @1370922
     /* 1370922 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1371006), // Rule ID 22212 //
     /* 1370927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371005 */     // GIR_Coverage, 22212,
     /* 1371005 */     GIR_EraseRootFromParent_Done,
     /* 1371006 */   // Label 19518: @1371006
     /* 1371006 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1371090), // Rule ID 22213 //
     /* 1371011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1371028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1371034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11564:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1371067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371089 */     // GIR_Coverage, 22213,
     /* 1371089 */     GIR_EraseRootFromParent_Done,
     /* 1371090 */   // Label 19519: @1371090
     /* 1371090 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1371174), // Rule ID 22216 //
     /* 1371095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1371151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371173 */     // GIR_Coverage, 22216,
     /* 1371173 */     GIR_EraseRootFromParent_Done,
     /* 1371174 */   // Label 19520: @1371174
     /* 1371174 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1371258), // Rule ID 22217 //
     /* 1371179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1371235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371257 */     // GIR_Coverage, 22217,
     /* 1371257 */     GIR_EraseRootFromParent_Done,
     /* 1371258 */   // Label 19521: @1371258
     /* 1371258 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1371342), // Rule ID 22220 //
     /* 1371263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1371319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371341 */     // GIR_Coverage, 22220,
     /* 1371341 */     GIR_EraseRootFromParent_Done,
     /* 1371342 */   // Label 19522: @1371342
     /* 1371342 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1371426), // Rule ID 22221 //
     /* 1371347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1371403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371425 */     // GIR_Coverage, 22221,
     /* 1371425 */     GIR_EraseRootFromParent_Done,
     /* 1371426 */   // Label 19523: @1371426
     /* 1371426 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1371510), // Rule ID 22224 //
     /* 1371431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371509 */     // GIR_Coverage, 22224,
     /* 1371509 */     GIR_EraseRootFromParent_Done,
     /* 1371510 */   // Label 19524: @1371510
     /* 1371510 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1371594), // Rule ID 22225 //
     /* 1371515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11564:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371593 */     // GIR_Coverage, 22225,
     /* 1371593 */     GIR_EraseRootFromParent_Done,
     /* 1371594 */   // Label 19525: @1371594
     /* 1371594 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1371678), // Rule ID 22228 //
     /* 1371599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371677 */     // GIR_Coverage, 22228,
     /* 1371677 */     GIR_EraseRootFromParent_Done,
     /* 1371678 */   // Label 19526: @1371678
     /* 1371678 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1371762), // Rule ID 22229 //
     /* 1371683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371761 */     // GIR_Coverage, 22229,
     /* 1371761 */     GIR_EraseRootFromParent_Done,
     /* 1371762 */   // Label 19527: @1371762
     /* 1371762 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1371846), // Rule ID 22232 //
     /* 1371767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371845 */     // GIR_Coverage, 22232,
     /* 1371845 */     GIR_EraseRootFromParent_Done,
     /* 1371846 */   // Label 19528: @1371846
     /* 1371846 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1371930), // Rule ID 22233 //
     /* 1371851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371929 */     // GIR_Coverage, 22233,
     /* 1371929 */     GIR_EraseRootFromParent_Done,
     /* 1371930 */   // Label 19529: @1371930
     /* 1371930 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1372014), // Rule ID 22236 //
     /* 1371935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372013 */     // GIR_Coverage, 22236,
     /* 1372013 */     GIR_EraseRootFromParent_Done,
     /* 1372014 */   // Label 19530: @1372014
     /* 1372014 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1372098), // Rule ID 22237 //
     /* 1372019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1372036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11564:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1372075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372097 */     // GIR_Coverage, 22237,
     /* 1372097 */     GIR_EraseRootFromParent_Done,
     /* 1372098 */   // Label 19531: @1372098
     /* 1372098 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1372182), // Rule ID 22240 //
     /* 1372103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1372159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372181 */     // GIR_Coverage, 22240,
     /* 1372181 */     GIR_EraseRootFromParent_Done,
     /* 1372182 */   // Label 19532: @1372182
     /* 1372182 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1372266), // Rule ID 22241 //
     /* 1372187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1372243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372265 */     // GIR_Coverage, 22241,
     /* 1372265 */     GIR_EraseRootFromParent_Done,
     /* 1372266 */   // Label 19533: @1372266
     /* 1372266 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1372350), // Rule ID 22244 //
     /* 1372271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1372327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372349 */     // GIR_Coverage, 22244,
     /* 1372349 */     GIR_EraseRootFromParent_Done,
     /* 1372350 */   // Label 19534: @1372350
     /* 1372350 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1372434), // Rule ID 22245 //
     /* 1372355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1372411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372433 */     // GIR_Coverage, 22245,
     /* 1372433 */     GIR_EraseRootFromParent_Done,
     /* 1372434 */   // Label 19535: @1372434
     /* 1372434 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1372518), // Rule ID 22248 //
     /* 1372439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372517 */     // GIR_Coverage, 22248,
     /* 1372517 */     GIR_EraseRootFromParent_Done,
     /* 1372518 */   // Label 19536: @1372518
     /* 1372518 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1372602), // Rule ID 22249 //
     /* 1372523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11564:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372601 */     // GIR_Coverage, 22249,
     /* 1372601 */     GIR_EraseRootFromParent_Done,
     /* 1372602 */   // Label 19537: @1372602
     /* 1372602 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1372686), // Rule ID 22252 //
     /* 1372607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372685 */     // GIR_Coverage, 22252,
     /* 1372685 */     GIR_EraseRootFromParent_Done,
     /* 1372686 */   // Label 19538: @1372686
     /* 1372686 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1372770), // Rule ID 22253 //
     /* 1372691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372769 */     // GIR_Coverage, 22253,
     /* 1372769 */     GIR_EraseRootFromParent_Done,
     /* 1372770 */   // Label 19539: @1372770
     /* 1372770 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1372854), // Rule ID 22256 //
     /* 1372775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372853 */     // GIR_Coverage, 22256,
     /* 1372853 */     GIR_EraseRootFromParent_Done,
     /* 1372854 */   // Label 19540: @1372854
     /* 1372854 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1372938), // Rule ID 22257 //
     /* 1372859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372937 */     // GIR_Coverage, 22257,
     /* 1372937 */     GIR_EraseRootFromParent_Done,
     /* 1372938 */   // Label 19541: @1372938
     /* 1372938 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1373022), // Rule ID 22260 //
     /* 1372943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1372999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373021 */     // GIR_Coverage, 22260,
     /* 1373021 */     GIR_EraseRootFromParent_Done,
     /* 1373022 */   // Label 19542: @1373022
     /* 1373022 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1373106), // Rule ID 22261 //
     /* 1373027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1373044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373080 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1373083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373105 */     // GIR_Coverage, 22261,
     /* 1373105 */     GIR_EraseRootFromParent_Done,
     /* 1373106 */   // Label 19543: @1373106
     /* 1373106 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1373190), // Rule ID 22264 //
     /* 1373111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1373167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373189 */     // GIR_Coverage, 22264,
     /* 1373189 */     GIR_EraseRootFromParent_Done,
     /* 1373190 */   // Label 19544: @1373190
     /* 1373190 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1373274), // Rule ID 22265 //
     /* 1373195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1373251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373273 */     // GIR_Coverage, 22265,
     /* 1373273 */     GIR_EraseRootFromParent_Done,
     /* 1373274 */   // Label 19545: @1373274
     /* 1373274 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1373358), // Rule ID 22268 //
     /* 1373279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1373335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373357 */     // GIR_Coverage, 22268,
     /* 1373357 */     GIR_EraseRootFromParent_Done,
     /* 1373358 */   // Label 19546: @1373358
     /* 1373358 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1373442), // Rule ID 22269 //
     /* 1373363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1373419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373441 */     // GIR_Coverage, 22269,
     /* 1373441 */     GIR_EraseRootFromParent_Done,
     /* 1373442 */   // Label 19547: @1373442
     /* 1373442 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1373526), // Rule ID 22272 //
     /* 1373447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373525 */     // GIR_Coverage, 22272,
     /* 1373525 */     GIR_EraseRootFromParent_Done,
     /* 1373526 */   // Label 19548: @1373526
     /* 1373526 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1373610), // Rule ID 22273 //
     /* 1373531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373609 */     // GIR_Coverage, 22273,
     /* 1373609 */     GIR_EraseRootFromParent_Done,
     /* 1373610 */   // Label 19549: @1373610
     /* 1373610 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1373694), // Rule ID 22276 //
     /* 1373615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373693 */     // GIR_Coverage, 22276,
     /* 1373693 */     GIR_EraseRootFromParent_Done,
     /* 1373694 */   // Label 19550: @1373694
     /* 1373694 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1373778), // Rule ID 22277 //
     /* 1373699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373777 */     // GIR_Coverage, 22277,
     /* 1373777 */     GIR_EraseRootFromParent_Done,
     /* 1373778 */   // Label 19551: @1373778
     /* 1373778 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1373862), // Rule ID 22280 //
     /* 1373783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373861 */     // GIR_Coverage, 22280,
     /* 1373861 */     GIR_EraseRootFromParent_Done,
     /* 1373862 */   // Label 19552: @1373862
     /* 1373862 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1373946), // Rule ID 22281 //
     /* 1373867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373945 */     // GIR_Coverage, 22281,
     /* 1373945 */     GIR_EraseRootFromParent_Done,
     /* 1373946 */   // Label 19553: @1373946
     /* 1373946 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1374030), // Rule ID 22284 //
     /* 1373951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1374007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374029 */     // GIR_Coverage, 22284,
     /* 1374029 */     GIR_EraseRootFromParent_Done,
     /* 1374030 */   // Label 19554: @1374030
     /* 1374030 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1374114), // Rule ID 22285 //
     /* 1374035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1374052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1374091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374113 */     // GIR_Coverage, 22285,
     /* 1374113 */     GIR_EraseRootFromParent_Done,
     /* 1374114 */   // Label 19555: @1374114
     /* 1374114 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1374198), // Rule ID 22288 //
     /* 1374119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1374122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1374175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374197 */     // GIR_Coverage, 22288,
     /* 1374197 */     GIR_EraseRootFromParent_Done,
     /* 1374198 */   // Label 19556: @1374198
     /* 1374198 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1374282), // Rule ID 22289 //
     /* 1374203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1374206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1374259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374281 */     // GIR_Coverage, 22289,
     /* 1374281 */     GIR_EraseRootFromParent_Done,
     /* 1374282 */   // Label 19557: @1374282
     /* 1374282 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1374366), // Rule ID 22292 //
     /* 1374287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1374343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374365 */     // GIR_Coverage, 22292,
     /* 1374365 */     GIR_EraseRootFromParent_Done,
     /* 1374366 */   // Label 19558: @1374366
     /* 1374366 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1374450), // Rule ID 22293 //
     /* 1374371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1374427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374449 */     // GIR_Coverage, 22293,
     /* 1374449 */     GIR_EraseRootFromParent_Done,
     /* 1374450 */   // Label 19559: @1374450
     /* 1374450 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1374534), // Rule ID 22296 //
     /* 1374455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374533 */     // GIR_Coverage, 22296,
     /* 1374533 */     GIR_EraseRootFromParent_Done,
     /* 1374534 */   // Label 19560: @1374534
     /* 1374534 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1374618), // Rule ID 22297 //
     /* 1374539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374617 */     // GIR_Coverage, 22297,
     /* 1374617 */     GIR_EraseRootFromParent_Done,
     /* 1374618 */   // Label 19561: @1374618
     /* 1374618 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1374702), // Rule ID 22300 //
     /* 1374623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374701 */     // GIR_Coverage, 22300,
     /* 1374701 */     GIR_EraseRootFromParent_Done,
     /* 1374702 */   // Label 19562: @1374702
     /* 1374702 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1374786), // Rule ID 22301 //
     /* 1374707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11568:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374785 */     // GIR_Coverage, 22301,
     /* 1374785 */     GIR_EraseRootFromParent_Done,
     /* 1374786 */   // Label 19563: @1374786
     /* 1374786 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1374870), // Rule ID 22304 //
     /* 1374791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374869 */     // GIR_Coverage, 22304,
     /* 1374869 */     GIR_EraseRootFromParent_Done,
     /* 1374870 */   // Label 19564: @1374870
     /* 1374870 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1374954), // Rule ID 22305 //
     /* 1374875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374953 */     // GIR_Coverage, 22305,
     /* 1374953 */     GIR_EraseRootFromParent_Done,
     /* 1374954 */   // Label 19565: @1374954
     /* 1374954 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1375038), // Rule ID 22308 //
     /* 1374959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1375015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375037 */     // GIR_Coverage, 22308,
     /* 1375037 */     GIR_EraseRootFromParent_Done,
     /* 1375038 */   // Label 19566: @1375038
     /* 1375038 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1375122), // Rule ID 22309 //
     /* 1375043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1375060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1375099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375121 */     // GIR_Coverage, 22309,
     /* 1375121 */     GIR_EraseRootFromParent_Done,
     /* 1375122 */   // Label 19567: @1375122
     /* 1375122 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1375206), // Rule ID 22312 //
     /* 1375127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1375183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375205 */     // GIR_Coverage, 22312,
     /* 1375205 */     GIR_EraseRootFromParent_Done,
     /* 1375206 */   // Label 19568: @1375206
     /* 1375206 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1375290), // Rule ID 22313 //
     /* 1375211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11568:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1375267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375289 */     // GIR_Coverage, 22313,
     /* 1375289 */     GIR_EraseRootFromParent_Done,
     /* 1375290 */   // Label 19569: @1375290
     /* 1375290 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1375374), // Rule ID 22316 //
     /* 1375295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1375351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375373 */     // GIR_Coverage, 22316,
     /* 1375373 */     GIR_EraseRootFromParent_Done,
     /* 1375374 */   // Label 19570: @1375374
     /* 1375374 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1375458), // Rule ID 22317 //
     /* 1375379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1375435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375457 */     // GIR_Coverage, 22317,
     /* 1375457 */     GIR_EraseRootFromParent_Done,
     /* 1375458 */   // Label 19571: @1375458
     /* 1375458 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1375542), // Rule ID 22320 //
     /* 1375463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375541 */     // GIR_Coverage, 22320,
     /* 1375541 */     GIR_EraseRootFromParent_Done,
     /* 1375542 */   // Label 19572: @1375542
     /* 1375542 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1375626), // Rule ID 22321 //
     /* 1375547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375625 */     // GIR_Coverage, 22321,
     /* 1375625 */     GIR_EraseRootFromParent_Done,
     /* 1375626 */   // Label 19573: @1375626
     /* 1375626 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1375710), // Rule ID 22324 //
     /* 1375631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375709 */     // GIR_Coverage, 22324,
     /* 1375709 */     GIR_EraseRootFromParent_Done,
     /* 1375710 */   // Label 19574: @1375710
     /* 1375710 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1375794), // Rule ID 22325 //
     /* 1375715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11568:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375793 */     // GIR_Coverage, 22325,
     /* 1375793 */     GIR_EraseRootFromParent_Done,
     /* 1375794 */   // Label 19575: @1375794
     /* 1375794 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1375878), // Rule ID 22328 //
     /* 1375799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375877 */     // GIR_Coverage, 22328,
     /* 1375877 */     GIR_EraseRootFromParent_Done,
     /* 1375878 */   // Label 19576: @1375878
     /* 1375878 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1375962), // Rule ID 22329 //
     /* 1375883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375961 */     // GIR_Coverage, 22329,
     /* 1375961 */     GIR_EraseRootFromParent_Done,
     /* 1375962 */   // Label 19577: @1375962
     /* 1375962 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1376046), // Rule ID 22332 //
     /* 1375967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1376023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376045 */     // GIR_Coverage, 22332,
     /* 1376045 */     GIR_EraseRootFromParent_Done,
     /* 1376046 */   // Label 19578: @1376046
     /* 1376046 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1376130), // Rule ID 22333 //
     /* 1376051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1376068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1376107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376129 */     // GIR_Coverage, 22333,
     /* 1376129 */     GIR_EraseRootFromParent_Done,
     /* 1376130 */   // Label 19579: @1376130
     /* 1376130 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1376214), // Rule ID 22336 //
     /* 1376135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1376191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376213 */     // GIR_Coverage, 22336,
     /* 1376213 */     GIR_EraseRootFromParent_Done,
     /* 1376214 */   // Label 19580: @1376214
     /* 1376214 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1376298), // Rule ID 22337 //
     /* 1376219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1376227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11568:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1376275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376297 */     // GIR_Coverage, 22337,
     /* 1376297 */     GIR_EraseRootFromParent_Done,
     /* 1376298 */   // Label 19581: @1376298
     /* 1376298 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1376382), // Rule ID 22340 //
     /* 1376303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1376359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376381 */     // GIR_Coverage, 22340,
     /* 1376381 */     GIR_EraseRootFromParent_Done,
     /* 1376382 */   // Label 19582: @1376382
     /* 1376382 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1376466), // Rule ID 22341 //
     /* 1376387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1376443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376465 */     // GIR_Coverage, 22341,
     /* 1376465 */     GIR_EraseRootFromParent_Done,
     /* 1376466 */   // Label 19583: @1376466
     /* 1376466 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1376550), // Rule ID 22344 //
     /* 1376471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376549 */     // GIR_Coverage, 22344,
     /* 1376549 */     GIR_EraseRootFromParent_Done,
     /* 1376550 */   // Label 19584: @1376550
     /* 1376550 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1376634), // Rule ID 22345 //
     /* 1376555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376633 */     // GIR_Coverage, 22345,
     /* 1376633 */     GIR_EraseRootFromParent_Done,
     /* 1376634 */   // Label 19585: @1376634
     /* 1376634 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1376718), // Rule ID 22348 //
     /* 1376639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376717 */     // GIR_Coverage, 22348,
     /* 1376717 */     GIR_EraseRootFromParent_Done,
     /* 1376718 */   // Label 19586: @1376718
     /* 1376718 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1376802), // Rule ID 22349 //
     /* 1376723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376801 */     // GIR_Coverage, 22349,
     /* 1376801 */     GIR_EraseRootFromParent_Done,
     /* 1376802 */   // Label 19587: @1376802
     /* 1376802 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1376886), // Rule ID 22352 //
     /* 1376807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376885 */     // GIR_Coverage, 22352,
     /* 1376885 */     GIR_EraseRootFromParent_Done,
     /* 1376886 */   // Label 19588: @1376886
     /* 1376886 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1376970), // Rule ID 22353 //
     /* 1376891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376969 */     // GIR_Coverage, 22353,
     /* 1376969 */     GIR_EraseRootFromParent_Done,
     /* 1376970 */   // Label 19589: @1376970
     /* 1376970 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1377054), // Rule ID 22356 //
     /* 1376975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1377031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377053 */     // GIR_Coverage, 22356,
     /* 1377053 */     GIR_EraseRootFromParent_Done,
     /* 1377054 */   // Label 19590: @1377054
     /* 1377054 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1377138), // Rule ID 22357 //
     /* 1377059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1377115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377137 */     // GIR_Coverage, 22357,
     /* 1377137 */     GIR_EraseRootFromParent_Done,
     /* 1377138 */   // Label 19591: @1377138
     /* 1377138 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1377222), // Rule ID 22360 //
     /* 1377143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1377199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377221 */     // GIR_Coverage, 22360,
     /* 1377221 */     GIR_EraseRootFromParent_Done,
     /* 1377222 */   // Label 19592: @1377222
     /* 1377222 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1377306), // Rule ID 22361 //
     /* 1377227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377305 */     // GIR_Coverage, 22361,
     /* 1377305 */     GIR_EraseRootFromParent_Done,
     /* 1377306 */   // Label 19593: @1377306
     /* 1377306 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1377390), // Rule ID 22364 //
     /* 1377311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1377367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377389 */     // GIR_Coverage, 22364,
     /* 1377389 */     GIR_EraseRootFromParent_Done,
     /* 1377390 */   // Label 19594: @1377390
     /* 1377390 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1377474), // Rule ID 22365 //
     /* 1377395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1377451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377473 */     // GIR_Coverage, 22365,
     /* 1377473 */     GIR_EraseRootFromParent_Done,
     /* 1377474 */   // Label 19595: @1377474
     /* 1377474 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1377558), // Rule ID 22368 //
     /* 1377479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377557 */     // GIR_Coverage, 22368,
     /* 1377557 */     GIR_EraseRootFromParent_Done,
     /* 1377558 */   // Label 19596: @1377558
     /* 1377558 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1377642), // Rule ID 22369 //
     /* 1377563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377641 */     // GIR_Coverage, 22369,
     /* 1377641 */     GIR_EraseRootFromParent_Done,
     /* 1377642 */   // Label 19597: @1377642
     /* 1377642 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1377726), // Rule ID 22372 //
     /* 1377647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377725 */     // GIR_Coverage, 22372,
     /* 1377725 */     GIR_EraseRootFromParent_Done,
     /* 1377726 */   // Label 19598: @1377726
     /* 1377726 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1377810), // Rule ID 22373 //
     /* 1377731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377809 */     // GIR_Coverage, 22373,
     /* 1377809 */     GIR_EraseRootFromParent_Done,
     /* 1377810 */   // Label 19599: @1377810
     /* 1377810 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1377894), // Rule ID 22376 //
     /* 1377815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377893 */     // GIR_Coverage, 22376,
     /* 1377893 */     GIR_EraseRootFromParent_Done,
     /* 1377894 */   // Label 19600: @1377894
     /* 1377894 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1377978), // Rule ID 22377 //
     /* 1377899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377977 */     // GIR_Coverage, 22377,
     /* 1377977 */     GIR_EraseRootFromParent_Done,
     /* 1377978 */   // Label 19601: @1377978
     /* 1377978 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1378062), // Rule ID 22380 //
     /* 1377983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1378039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378061 */     // GIR_Coverage, 22380,
     /* 1378061 */     GIR_EraseRootFromParent_Done,
     /* 1378062 */   // Label 19602: @1378062
     /* 1378062 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1378146), // Rule ID 22381 //
     /* 1378067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1378123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378145 */     // GIR_Coverage, 22381,
     /* 1378145 */     GIR_EraseRootFromParent_Done,
     /* 1378146 */   // Label 19603: @1378146
     /* 1378146 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1378230), // Rule ID 22384 //
     /* 1378151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378204 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1378207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378229 */     // GIR_Coverage, 22384,
     /* 1378229 */     GIR_EraseRootFromParent_Done,
     /* 1378230 */   // Label 19604: @1378230
     /* 1378230 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1378314), // Rule ID 22385 //
     /* 1378235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1378291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378313 */     // GIR_Coverage, 22385,
     /* 1378313 */     GIR_EraseRootFromParent_Done,
     /* 1378314 */   // Label 19605: @1378314
     /* 1378314 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1378398), // Rule ID 22388 //
     /* 1378319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378372 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1378375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378397 */     // GIR_Coverage, 22388,
     /* 1378397 */     GIR_EraseRootFromParent_Done,
     /* 1378398 */   // Label 19606: @1378398
     /* 1378398 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1378482), // Rule ID 22389 //
     /* 1378403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1378459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378481 */     // GIR_Coverage, 22389,
     /* 1378481 */     GIR_EraseRootFromParent_Done,
     /* 1378482 */   // Label 19607: @1378482
     /* 1378482 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1378566), // Rule ID 22392 //
     /* 1378487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378565 */     // GIR_Coverage, 22392,
     /* 1378565 */     GIR_EraseRootFromParent_Done,
     /* 1378566 */   // Label 19608: @1378566
     /* 1378566 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1378650), // Rule ID 22393 //
     /* 1378571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378649 */     // GIR_Coverage, 22393,
     /* 1378649 */     GIR_EraseRootFromParent_Done,
     /* 1378650 */   // Label 19609: @1378650
     /* 1378650 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1378734), // Rule ID 22396 //
     /* 1378655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378733 */     // GIR_Coverage, 22396,
     /* 1378733 */     GIR_EraseRootFromParent_Done,
     /* 1378734 */   // Label 19610: @1378734
     /* 1378734 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1378818), // Rule ID 22397 //
     /* 1378739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378817 */     // GIR_Coverage, 22397,
     /* 1378817 */     GIR_EraseRootFromParent_Done,
     /* 1378818 */   // Label 19611: @1378818
     /* 1378818 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1378902), // Rule ID 22400 //
     /* 1378823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378901 */     // GIR_Coverage, 22400,
     /* 1378901 */     GIR_EraseRootFromParent_Done,
     /* 1378902 */   // Label 19612: @1378902
     /* 1378902 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1378986), // Rule ID 22401 //
     /* 1378907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378985 */     // GIR_Coverage, 22401,
     /* 1378985 */     GIR_EraseRootFromParent_Done,
     /* 1378986 */   // Label 19613: @1378986
     /* 1378986 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1379070), // Rule ID 22404 //
     /* 1378991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1379047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379069 */     // GIR_Coverage, 22404,
     /* 1379069 */     GIR_EraseRootFromParent_Done,
     /* 1379070 */   // Label 19614: @1379070
     /* 1379070 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1379154), // Rule ID 22405 //
     /* 1379075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1379131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379153 */     // GIR_Coverage, 22405,
     /* 1379153 */     GIR_EraseRootFromParent_Done,
     /* 1379154 */   // Label 19615: @1379154
     /* 1379154 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1379238), // Rule ID 22408 //
     /* 1379159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1379215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379237 */     // GIR_Coverage, 22408,
     /* 1379237 */     GIR_EraseRootFromParent_Done,
     /* 1379238 */   // Label 19616: @1379238
     /* 1379238 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1379322), // Rule ID 22409 //
     /* 1379243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1379299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379321 */     // GIR_Coverage, 22409,
     /* 1379321 */     GIR_EraseRootFromParent_Done,
     /* 1379322 */   // Label 19617: @1379322
     /* 1379322 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1379406), // Rule ID 22412 //
     /* 1379327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379405 */     // GIR_Coverage, 22412,
     /* 1379405 */     GIR_EraseRootFromParent_Done,
     /* 1379406 */   // Label 19618: @1379406
     /* 1379406 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1379490), // Rule ID 22413 //
     /* 1379411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379489 */     // GIR_Coverage, 22413,
     /* 1379489 */     GIR_EraseRootFromParent_Done,
     /* 1379490 */   // Label 19619: @1379490
     /* 1379490 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1379574), // Rule ID 22416 //
     /* 1379495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379573 */     // GIR_Coverage, 22416,
     /* 1379573 */     GIR_EraseRootFromParent_Done,
     /* 1379574 */   // Label 19620: @1379574
     /* 1379574 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1379658), // Rule ID 22417 //
     /* 1379579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379657 */     // GIR_Coverage, 22417,
     /* 1379657 */     GIR_EraseRootFromParent_Done,
     /* 1379658 */   // Label 19621: @1379658
     /* 1379658 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1379742), // Rule ID 22420 //
     /* 1379663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379741 */     // GIR_Coverage, 22420,
     /* 1379741 */     GIR_EraseRootFromParent_Done,
     /* 1379742 */   // Label 19622: @1379742
     /* 1379742 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1379826), // Rule ID 22421 //
     /* 1379747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379825 */     // GIR_Coverage, 22421,
     /* 1379825 */     GIR_EraseRootFromParent_Done,
     /* 1379826 */   // Label 19623: @1379826
     /* 1379826 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1379910), // Rule ID 22424 //
     /* 1379831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379909 */     // GIR_Coverage, 22424,
     /* 1379909 */     GIR_EraseRootFromParent_Done,
     /* 1379910 */   // Label 19624: @1379910
     /* 1379910 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1379994), // Rule ID 22425 //
     /* 1379915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379993 */     // GIR_Coverage, 22425,
     /* 1379993 */     GIR_EraseRootFromParent_Done,
     /* 1379994 */   // Label 19625: @1379994
     /* 1379994 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1380078), // Rule ID 22428 //
     /* 1379999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1380055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380077 */     // GIR_Coverage, 22428,
     /* 1380077 */     GIR_EraseRootFromParent_Done,
     /* 1380078 */   // Label 19626: @1380078
     /* 1380078 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1380162), // Rule ID 22429 //
     /* 1380083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1380139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380161 */     // GIR_Coverage, 22429,
     /* 1380161 */     GIR_EraseRootFromParent_Done,
     /* 1380162 */   // Label 19627: @1380162
     /* 1380162 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1380246), // Rule ID 22432 //
     /* 1380167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1380223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380245 */     // GIR_Coverage, 22432,
     /* 1380245 */     GIR_EraseRootFromParent_Done,
     /* 1380246 */   // Label 19628: @1380246
     /* 1380246 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1380330), // Rule ID 22433 //
     /* 1380251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380304 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1380307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380329 */     // GIR_Coverage, 22433,
     /* 1380329 */     GIR_EraseRootFromParent_Done,
     /* 1380330 */   // Label 19629: @1380330
     /* 1380330 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1380414), // Rule ID 22436 //
     /* 1380335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380413 */     // GIR_Coverage, 22436,
     /* 1380413 */     GIR_EraseRootFromParent_Done,
     /* 1380414 */   // Label 19630: @1380414
     /* 1380414 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1380498), // Rule ID 22437 //
     /* 1380419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380497 */     // GIR_Coverage, 22437,
     /* 1380497 */     GIR_EraseRootFromParent_Done,
     /* 1380498 */   // Label 19631: @1380498
     /* 1380498 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1380582), // Rule ID 22440 //
     /* 1380503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380581 */     // GIR_Coverage, 22440,
     /* 1380581 */     GIR_EraseRootFromParent_Done,
     /* 1380582 */   // Label 19632: @1380582
     /* 1380582 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1380666), // Rule ID 22441 //
     /* 1380587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380665 */     // GIR_Coverage, 22441,
     /* 1380665 */     GIR_EraseRootFromParent_Done,
     /* 1380666 */   // Label 19633: @1380666
     /* 1380666 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1380750), // Rule ID 22444 //
     /* 1380671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380749 */     // GIR_Coverage, 22444,
     /* 1380749 */     GIR_EraseRootFromParent_Done,
     /* 1380750 */   // Label 19634: @1380750
     /* 1380750 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1380834), // Rule ID 22445 //
     /* 1380755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380833 */     // GIR_Coverage, 22445,
     /* 1380833 */     GIR_EraseRootFromParent_Done,
     /* 1380834 */   // Label 19635: @1380834
     /* 1380834 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1380918), // Rule ID 22448 //
     /* 1380839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380917 */     // GIR_Coverage, 22448,
     /* 1380917 */     GIR_EraseRootFromParent_Done,
     /* 1380918 */   // Label 19636: @1380918
     /* 1380918 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1381002), // Rule ID 22449 //
     /* 1380923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381001 */     // GIR_Coverage, 22449,
     /* 1381001 */     GIR_EraseRootFromParent_Done,
     /* 1381002 */   // Label 19637: @1381002
     /* 1381002 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1381086), // Rule ID 22452 //
     /* 1381007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1381063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381085 */     // GIR_Coverage, 22452,
     /* 1381085 */     GIR_EraseRootFromParent_Done,
     /* 1381086 */   // Label 19638: @1381086
     /* 1381086 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1381170), // Rule ID 22453 //
     /* 1381091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1381147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381169 */     // GIR_Coverage, 22453,
     /* 1381169 */     GIR_EraseRootFromParent_Done,
     /* 1381170 */   // Label 19639: @1381170
     /* 1381170 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1381254), // Rule ID 22456 //
     /* 1381175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1381231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381253 */     // GIR_Coverage, 22456,
     /* 1381253 */     GIR_EraseRootFromParent_Done,
     /* 1381254 */   // Label 19640: @1381254
     /* 1381254 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1381338), // Rule ID 22457 //
     /* 1381259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1381315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381337 */     // GIR_Coverage, 22457,
     /* 1381337 */     GIR_EraseRootFromParent_Done,
     /* 1381338 */   // Label 19641: @1381338
     /* 1381338 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1381422), // Rule ID 22460 //
     /* 1381343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381421 */     // GIR_Coverage, 22460,
     /* 1381421 */     GIR_EraseRootFromParent_Done,
     /* 1381422 */   // Label 19642: @1381422
     /* 1381422 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1381506), // Rule ID 22461 //
     /* 1381427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381505 */     // GIR_Coverage, 22461,
     /* 1381505 */     GIR_EraseRootFromParent_Done,
     /* 1381506 */   // Label 19643: @1381506
     /* 1381506 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1381590), // Rule ID 22464 //
     /* 1381511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381589 */     // GIR_Coverage, 22464,
     /* 1381589 */     GIR_EraseRootFromParent_Done,
     /* 1381590 */   // Label 19644: @1381590
     /* 1381590 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1381674), // Rule ID 22465 //
     /* 1381595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381673 */     // GIR_Coverage, 22465,
     /* 1381673 */     GIR_EraseRootFromParent_Done,
     /* 1381674 */   // Label 19645: @1381674
     /* 1381674 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1381758), // Rule ID 22468 //
     /* 1381679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381757 */     // GIR_Coverage, 22468,
     /* 1381757 */     GIR_EraseRootFromParent_Done,
     /* 1381758 */   // Label 19646: @1381758
     /* 1381758 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1381842), // Rule ID 22469 //
     /* 1381763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381841 */     // GIR_Coverage, 22469,
     /* 1381841 */     GIR_EraseRootFromParent_Done,
     /* 1381842 */   // Label 19647: @1381842
     /* 1381842 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1381926), // Rule ID 22472 //
     /* 1381847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381925 */     // GIR_Coverage, 22472,
     /* 1381925 */     GIR_EraseRootFromParent_Done,
     /* 1381926 */   // Label 19648: @1381926
     /* 1381926 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1382010), // Rule ID 22473 //
     /* 1381931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382009 */     // GIR_Coverage, 22473,
     /* 1382009 */     GIR_EraseRootFromParent_Done,
     /* 1382010 */   // Label 19649: @1382010
     /* 1382010 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1382094), // Rule ID 22476 //
     /* 1382015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1382071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382093 */     // GIR_Coverage, 22476,
     /* 1382093 */     GIR_EraseRootFromParent_Done,
     /* 1382094 */   // Label 19650: @1382094
     /* 1382094 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1382178), // Rule ID 22477 //
     /* 1382099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1382155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382177 */     // GIR_Coverage, 22477,
     /* 1382177 */     GIR_EraseRootFromParent_Done,
     /* 1382178 */   // Label 19651: @1382178
     /* 1382178 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1382262), // Rule ID 22480 //
     /* 1382183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1382239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382261 */     // GIR_Coverage, 22480,
     /* 1382261 */     GIR_EraseRootFromParent_Done,
     /* 1382262 */   // Label 19652: @1382262
     /* 1382262 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1382346), // Rule ID 22481 //
     /* 1382267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1382323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382345 */     // GIR_Coverage, 22481,
     /* 1382345 */     GIR_EraseRootFromParent_Done,
     /* 1382346 */   // Label 19653: @1382346
     /* 1382346 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1382430), // Rule ID 22484 //
     /* 1382351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382429 */     // GIR_Coverage, 22484,
     /* 1382429 */     GIR_EraseRootFromParent_Done,
     /* 1382430 */   // Label 19654: @1382430
     /* 1382430 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1382514), // Rule ID 22485 //
     /* 1382435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382513 */     // GIR_Coverage, 22485,
     /* 1382513 */     GIR_EraseRootFromParent_Done,
     /* 1382514 */   // Label 19655: @1382514
     /* 1382514 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1382598), // Rule ID 22488 //
     /* 1382519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382597 */     // GIR_Coverage, 22488,
     /* 1382597 */     GIR_EraseRootFromParent_Done,
     /* 1382598 */   // Label 19656: @1382598
     /* 1382598 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1382682), // Rule ID 22489 //
     /* 1382603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382681 */     // GIR_Coverage, 22489,
     /* 1382681 */     GIR_EraseRootFromParent_Done,
     /* 1382682 */   // Label 19657: @1382682
     /* 1382682 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1382766), // Rule ID 22492 //
     /* 1382687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382765 */     // GIR_Coverage, 22492,
     /* 1382765 */     GIR_EraseRootFromParent_Done,
     /* 1382766 */   // Label 19658: @1382766
     /* 1382766 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1382850), // Rule ID 22493 //
     /* 1382771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382849 */     // GIR_Coverage, 22493,
     /* 1382849 */     GIR_EraseRootFromParent_Done,
     /* 1382850 */   // Label 19659: @1382850
     /* 1382850 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1382934), // Rule ID 22496 //
     /* 1382855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382933 */     // GIR_Coverage, 22496,
     /* 1382933 */     GIR_EraseRootFromParent_Done,
     /* 1382934 */   // Label 19660: @1382934
     /* 1382934 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1383018), // Rule ID 22497 //
     /* 1382939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383017 */     // GIR_Coverage, 22497,
     /* 1383017 */     GIR_EraseRootFromParent_Done,
     /* 1383018 */   // Label 19661: @1383018
     /* 1383018 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1383102), // Rule ID 22500 //
     /* 1383023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1383079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383101 */     // GIR_Coverage, 22500,
     /* 1383101 */     GIR_EraseRootFromParent_Done,
     /* 1383102 */   // Label 19662: @1383102
     /* 1383102 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1383186), // Rule ID 22501 //
     /* 1383107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1383163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383185 */     // GIR_Coverage, 22501,
     /* 1383185 */     GIR_EraseRootFromParent_Done,
     /* 1383186 */   // Label 19663: @1383186
     /* 1383186 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1383270), // Rule ID 22504 //
     /* 1383191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1383247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383269 */     // GIR_Coverage, 22504,
     /* 1383269 */     GIR_EraseRootFromParent_Done,
     /* 1383270 */   // Label 19664: @1383270
     /* 1383270 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1383354), // Rule ID 22505 //
     /* 1383275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1383331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383353 */     // GIR_Coverage, 22505,
     /* 1383353 */     GIR_EraseRootFromParent_Done,
     /* 1383354 */   // Label 19665: @1383354
     /* 1383354 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1383438), // Rule ID 22508 //
     /* 1383359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383437 */     // GIR_Coverage, 22508,
     /* 1383437 */     GIR_EraseRootFromParent_Done,
     /* 1383438 */   // Label 19666: @1383438
     /* 1383438 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1383522), // Rule ID 22509 //
     /* 1383443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383521 */     // GIR_Coverage, 22509,
     /* 1383521 */     GIR_EraseRootFromParent_Done,
     /* 1383522 */   // Label 19667: @1383522
     /* 1383522 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1383606), // Rule ID 22512 //
     /* 1383527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383605 */     // GIR_Coverage, 22512,
     /* 1383605 */     GIR_EraseRootFromParent_Done,
     /* 1383606 */   // Label 19668: @1383606
     /* 1383606 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1383690), // Rule ID 22513 //
     /* 1383611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383689 */     // GIR_Coverage, 22513,
     /* 1383689 */     GIR_EraseRootFromParent_Done,
     /* 1383690 */   // Label 19669: @1383690
     /* 1383690 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1383774), // Rule ID 22516 //
     /* 1383695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383748 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383773 */     // GIR_Coverage, 22516,
     /* 1383773 */     GIR_EraseRootFromParent_Done,
     /* 1383774 */   // Label 19670: @1383774
     /* 1383774 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1383858), // Rule ID 22517 //
     /* 1383779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383857 */     // GIR_Coverage, 22517,
     /* 1383857 */     GIR_EraseRootFromParent_Done,
     /* 1383858 */   // Label 19671: @1383858
     /* 1383858 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1383942), // Rule ID 22520 //
     /* 1383863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383941 */     // GIR_Coverage, 22520,
     /* 1383941 */     GIR_EraseRootFromParent_Done,
     /* 1383942 */   // Label 19672: @1383942
     /* 1383942 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1384026), // Rule ID 22521 //
     /* 1383947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1384003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384025 */     // GIR_Coverage, 22521,
     /* 1384025 */     GIR_EraseRootFromParent_Done,
     /* 1384026 */   // Label 19673: @1384026
     /* 1384026 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1384110), // Rule ID 22524 //
     /* 1384031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1384087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384109 */     // GIR_Coverage, 22524,
     /* 1384109 */     GIR_EraseRootFromParent_Done,
     /* 1384110 */   // Label 19674: @1384110
     /* 1384110 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1384194), // Rule ID 22525 //
     /* 1384115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1384171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384193 */     // GIR_Coverage, 22525,
     /* 1384193 */     GIR_EraseRootFromParent_Done,
     /* 1384194 */   // Label 19675: @1384194
     /* 1384194 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1384278), // Rule ID 22528 //
     /* 1384199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1384255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384277 */     // GIR_Coverage, 22528,
     /* 1384277 */     GIR_EraseRootFromParent_Done,
     /* 1384278 */   // Label 19676: @1384278
     /* 1384278 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1384362), // Rule ID 22529 //
     /* 1384283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1384339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384361 */     // GIR_Coverage, 22529,
     /* 1384361 */     GIR_EraseRootFromParent_Done,
     /* 1384362 */   // Label 19677: @1384362
     /* 1384362 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1384446), // Rule ID 22532 //
     /* 1384367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384445 */     // GIR_Coverage, 22532,
     /* 1384445 */     GIR_EraseRootFromParent_Done,
     /* 1384446 */   // Label 19678: @1384446
     /* 1384446 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1384530), // Rule ID 22533 //
     /* 1384451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384529 */     // GIR_Coverage, 22533,
     /* 1384529 */     GIR_EraseRootFromParent_Done,
     /* 1384530 */   // Label 19679: @1384530
     /* 1384530 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1384614), // Rule ID 22536 //
     /* 1384535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384613 */     // GIR_Coverage, 22536,
     /* 1384613 */     GIR_EraseRootFromParent_Done,
     /* 1384614 */   // Label 19680: @1384614
     /* 1384614 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1384698), // Rule ID 22537 //
     /* 1384619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384697 */     // GIR_Coverage, 22537,
     /* 1384697 */     GIR_EraseRootFromParent_Done,
     /* 1384698 */   // Label 19681: @1384698
     /* 1384698 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1384782), // Rule ID 22540 //
     /* 1384703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384781 */     // GIR_Coverage, 22540,
     /* 1384781 */     GIR_EraseRootFromParent_Done,
     /* 1384782 */   // Label 19682: @1384782
     /* 1384782 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1384866), // Rule ID 22541 //
     /* 1384787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384865 */     // GIR_Coverage, 22541,
     /* 1384865 */     GIR_EraseRootFromParent_Done,
     /* 1384866 */   // Label 19683: @1384866
     /* 1384866 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1384950), // Rule ID 22544 //
     /* 1384871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384949 */     // GIR_Coverage, 22544,
     /* 1384949 */     GIR_EraseRootFromParent_Done,
     /* 1384950 */   // Label 19684: @1384950
     /* 1384950 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1385034), // Rule ID 22545 //
     /* 1384955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1385011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385033 */     // GIR_Coverage, 22545,
     /* 1385033 */     GIR_EraseRootFromParent_Done,
     /* 1385034 */   // Label 19685: @1385034
     /* 1385034 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1385118), // Rule ID 22548 //
     /* 1385039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1385095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385117 */     // GIR_Coverage, 22548,
     /* 1385117 */     GIR_EraseRootFromParent_Done,
     /* 1385118 */   // Label 19686: @1385118
     /* 1385118 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1385202), // Rule ID 22549 //
     /* 1385123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1385179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385201 */     // GIR_Coverage, 22549,
     /* 1385201 */     GIR_EraseRootFromParent_Done,
     /* 1385202 */   // Label 19687: @1385202
     /* 1385202 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1385286), // Rule ID 22552 //
     /* 1385207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1385210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1385224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1385263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385285 */     // GIR_Coverage, 22552,
     /* 1385285 */     GIR_EraseRootFromParent_Done,
     /* 1385286 */   // Label 19688: @1385286
     /* 1385286 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1385370), // Rule ID 22553 //
     /* 1385291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1385294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1385308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1385347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1385365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385369 */     // GIR_Coverage, 22553,
     /* 1385369 */     GIR_EraseRootFromParent_Done,
     /* 1385370 */   // Label 19689: @1385370
     /* 1385370 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1385454), // Rule ID 22556 //
     /* 1385375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385428 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385453 */     // GIR_Coverage, 22556,
     /* 1385453 */     GIR_EraseRootFromParent_Done,
     /* 1385454 */   // Label 19690: @1385454
     /* 1385454 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1385538), // Rule ID 22557 //
     /* 1385459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385537 */     // GIR_Coverage, 22557,
     /* 1385537 */     GIR_EraseRootFromParent_Done,
     /* 1385538 */   // Label 19691: @1385538
     /* 1385538 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1385622), // Rule ID 22560 //
     /* 1385543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385621 */     // GIR_Coverage, 22560,
     /* 1385621 */     GIR_EraseRootFromParent_Done,
     /* 1385622 */   // Label 19692: @1385622
     /* 1385622 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1385706), // Rule ID 22561 //
     /* 1385627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385705 */     // GIR_Coverage, 22561,
     /* 1385705 */     GIR_EraseRootFromParent_Done,
     /* 1385706 */   // Label 19693: @1385706
     /* 1385706 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1385790), // Rule ID 22564 //
     /* 1385711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385789 */     // GIR_Coverage, 22564,
     /* 1385789 */     GIR_EraseRootFromParent_Done,
     /* 1385790 */   // Label 19694: @1385790
     /* 1385790 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1385874), // Rule ID 22565 //
     /* 1385795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385873 */     // GIR_Coverage, 22565,
     /* 1385873 */     GIR_EraseRootFromParent_Done,
     /* 1385874 */   // Label 19695: @1385874
     /* 1385874 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1385958), // Rule ID 22568 //
     /* 1385879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385957 */     // GIR_Coverage, 22568,
     /* 1385957 */     GIR_EraseRootFromParent_Done,
     /* 1385958 */   // Label 19696: @1385958
     /* 1385958 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1386042), // Rule ID 22569 //
     /* 1385963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1386019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386041 */     // GIR_Coverage, 22569,
     /* 1386041 */     GIR_EraseRootFromParent_Done,
     /* 1386042 */   // Label 19697: @1386042
     /* 1386042 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1386126), // Rule ID 22572 //
     /* 1386047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1386103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386125 */     // GIR_Coverage, 22572,
     /* 1386125 */     GIR_EraseRootFromParent_Done,
     /* 1386126 */   // Label 19698: @1386126
     /* 1386126 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1386210), // Rule ID 22573 //
     /* 1386131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1386187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386209 */     // GIR_Coverage, 22573,
     /* 1386209 */     GIR_EraseRootFromParent_Done,
     /* 1386210 */   // Label 19699: @1386210
     /* 1386210 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1386294), // Rule ID 22576 //
     /* 1386215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1386271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386293 */     // GIR_Coverage, 22576,
     /* 1386293 */     GIR_EraseRootFromParent_Done,
     /* 1386294 */   // Label 19700: @1386294
     /* 1386294 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1386378), // Rule ID 22577 //
     /* 1386299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1386355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386377 */     // GIR_Coverage, 22577,
     /* 1386377 */     GIR_EraseRootFromParent_Done,
     /* 1386378 */   // Label 19701: @1386378
     /* 1386378 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1386462), // Rule ID 22580 //
     /* 1386383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386461 */     // GIR_Coverage, 22580,
     /* 1386461 */     GIR_EraseRootFromParent_Done,
     /* 1386462 */   // Label 19702: @1386462
     /* 1386462 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1386546), // Rule ID 22581 //
     /* 1386467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386545 */     // GIR_Coverage, 22581,
     /* 1386545 */     GIR_EraseRootFromParent_Done,
     /* 1386546 */   // Label 19703: @1386546
     /* 1386546 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1386630), // Rule ID 22584 //
     /* 1386551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386629 */     // GIR_Coverage, 22584,
     /* 1386629 */     GIR_EraseRootFromParent_Done,
     /* 1386630 */   // Label 19704: @1386630
     /* 1386630 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1386714), // Rule ID 22585 //
     /* 1386635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386713 */     // GIR_Coverage, 22585,
     /* 1386713 */     GIR_EraseRootFromParent_Done,
     /* 1386714 */   // Label 19705: @1386714
     /* 1386714 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1386798), // Rule ID 22588 //
     /* 1386719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386772 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386797 */     // GIR_Coverage, 22588,
     /* 1386797 */     GIR_EraseRootFromParent_Done,
     /* 1386798 */   // Label 19706: @1386798
     /* 1386798 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1386882), // Rule ID 22589 //
     /* 1386803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386881 */     // GIR_Coverage, 22589,
     /* 1386881 */     GIR_EraseRootFromParent_Done,
     /* 1386882 */   // Label 19707: @1386882
     /* 1386882 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1386966), // Rule ID 22592 //
     /* 1386887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386965 */     // GIR_Coverage, 22592,
     /* 1386965 */     GIR_EraseRootFromParent_Done,
     /* 1386966 */   // Label 19708: @1386966
     /* 1386966 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1387050), // Rule ID 22593 //
     /* 1386971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1387009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1387027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387049 */     // GIR_Coverage, 22593,
     /* 1387049 */     GIR_EraseRootFromParent_Done,
     /* 1387050 */   // Label 19709: @1387050
     /* 1387050 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1387134), // Rule ID 22596 //
     /* 1387055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1387072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1387111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387133 */     // GIR_Coverage, 22596,
     /* 1387133 */     GIR_EraseRootFromParent_Done,
     /* 1387134 */   // Label 19710: @1387134
     /* 1387134 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1387218), // Rule ID 22597 //
     /* 1387139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1387142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1387156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1387195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387217 */     // GIR_Coverage, 22597,
     /* 1387217 */     GIR_EraseRootFromParent_Done,
     /* 1387218 */   // Label 19711: @1387218
     /* 1387218 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1387302), // Rule ID 22600 //
     /* 1387223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1387240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1387279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387301 */     // GIR_Coverage, 22600,
     /* 1387301 */     GIR_EraseRootFromParent_Done,
     /* 1387302 */   // Label 19712: @1387302
     /* 1387302 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1387386), // Rule ID 22601 //
     /* 1387307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1387310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1387315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1387324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1387363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387385 */     // GIR_Coverage, 22601,
     /* 1387385 */     GIR_EraseRootFromParent_Done,
     /* 1387386 */   // Label 19713: @1387386
     /* 1387386 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1387470), // Rule ID 22604 //
     /* 1387391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387469 */     // GIR_Coverage, 22604,
     /* 1387469 */     GIR_EraseRootFromParent_Done,
     /* 1387470 */   // Label 19714: @1387470
     /* 1387470 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1387554), // Rule ID 22605 //
     /* 1387475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387553 */     // GIR_Coverage, 22605,
     /* 1387553 */     GIR_EraseRootFromParent_Done,
     /* 1387554 */   // Label 19715: @1387554
     /* 1387554 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1387638), // Rule ID 22608 //
     /* 1387559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387637 */     // GIR_Coverage, 22608,
     /* 1387637 */     GIR_EraseRootFromParent_Done,
     /* 1387638 */   // Label 19716: @1387638
     /* 1387638 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1387722), // Rule ID 22609 //
     /* 1387643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387721 */     // GIR_Coverage, 22609,
     /* 1387721 */     GIR_EraseRootFromParent_Done,
     /* 1387722 */   // Label 19717: @1387722
     /* 1387722 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1387806), // Rule ID 22612 //
     /* 1387727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387805 */     // GIR_Coverage, 22612,
     /* 1387805 */     GIR_EraseRootFromParent_Done,
     /* 1387806 */   // Label 19718: @1387806
     /* 1387806 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1387890), // Rule ID 22613 //
     /* 1387811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387889 */     // GIR_Coverage, 22613,
     /* 1387889 */     GIR_EraseRootFromParent_Done,
     /* 1387890 */   // Label 19719: @1387890
     /* 1387890 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1387974), // Rule ID 22616 //
     /* 1387895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387973 */     // GIR_Coverage, 22616,
     /* 1387973 */     GIR_EraseRootFromParent_Done,
     /* 1387974 */   // Label 19720: @1387974
     /* 1387974 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1388058), // Rule ID 22617 //
     /* 1387979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1388035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388057 */     // GIR_Coverage, 22617,
     /* 1388057 */     GIR_EraseRootFromParent_Done,
     /* 1388058 */   // Label 19721: @1388058
     /* 1388058 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1388142), // Rule ID 22620 //
     /* 1388063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1388080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1388119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388141 */     // GIR_Coverage, 22620,
     /* 1388141 */     GIR_EraseRootFromParent_Done,
     /* 1388142 */   // Label 19722: @1388142
     /* 1388142 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1388226), // Rule ID 22621 //
     /* 1388147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1388164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1388203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388225 */     // GIR_Coverage, 22621,
     /* 1388225 */     GIR_EraseRootFromParent_Done,
     /* 1388226 */   // Label 19723: @1388226
     /* 1388226 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1388310), // Rule ID 22624 //
     /* 1388231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1388287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388309 */     // GIR_Coverage, 22624,
     /* 1388309 */     GIR_EraseRootFromParent_Done,
     /* 1388310 */   // Label 19724: @1388310
     /* 1388310 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1388394), // Rule ID 22625 //
     /* 1388315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1388371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388393 */     // GIR_Coverage, 22625,
     /* 1388393 */     GIR_EraseRootFromParent_Done,
     /* 1388394 */   // Label 19725: @1388394
     /* 1388394 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1388478), // Rule ID 22628 //
     /* 1388399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388477 */     // GIR_Coverage, 22628,
     /* 1388477 */     GIR_EraseRootFromParent_Done,
     /* 1388478 */   // Label 19726: @1388478
     /* 1388478 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1388562), // Rule ID 22629 //
     /* 1388483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388561 */     // GIR_Coverage, 22629,
     /* 1388561 */     GIR_EraseRootFromParent_Done,
     /* 1388562 */   // Label 19727: @1388562
     /* 1388562 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1388646), // Rule ID 22632 //
     /* 1388567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388645 */     // GIR_Coverage, 22632,
     /* 1388645 */     GIR_EraseRootFromParent_Done,
     /* 1388646 */   // Label 19728: @1388646
     /* 1388646 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1388730), // Rule ID 22633 //
     /* 1388651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388729 */     // GIR_Coverage, 22633,
     /* 1388729 */     GIR_EraseRootFromParent_Done,
     /* 1388730 */   // Label 19729: @1388730
     /* 1388730 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1388814), // Rule ID 22636 //
     /* 1388735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388813 */     // GIR_Coverage, 22636,
     /* 1388813 */     GIR_EraseRootFromParent_Done,
     /* 1388814 */   // Label 19730: @1388814
     /* 1388814 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1388898), // Rule ID 22637 //
     /* 1388819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388897 */     // GIR_Coverage, 22637,
     /* 1388897 */     GIR_EraseRootFromParent_Done,
     /* 1388898 */   // Label 19731: @1388898
     /* 1388898 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1388982), // Rule ID 22640 //
     /* 1388903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388981 */     // GIR_Coverage, 22640,
     /* 1388981 */     GIR_EraseRootFromParent_Done,
     /* 1388982 */   // Label 19732: @1388982
     /* 1388982 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1389066), // Rule ID 22641 //
     /* 1388987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1389004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1389010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1389043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1389061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389065 */     // GIR_Coverage, 22641,
     /* 1389065 */     GIR_EraseRootFromParent_Done,
     /* 1389066 */   // Label 19733: @1389066
     /* 1389066 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1389150), // Rule ID 22644 //
     /* 1389071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1389088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1389127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389149 */     // GIR_Coverage, 22644,
     /* 1389149 */     GIR_EraseRootFromParent_Done,
     /* 1389150 */   // Label 19734: @1389150
     /* 1389150 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1389234), // Rule ID 22645 //
     /* 1389155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1389172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1389211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389233 */     // GIR_Coverage, 22645,
     /* 1389233 */     GIR_EraseRootFromParent_Done,
     /* 1389234 */   // Label 19735: @1389234
     /* 1389234 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1389318), // Rule ID 22648 //
     /* 1389239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1389256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1389295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389317 */     // GIR_Coverage, 22648,
     /* 1389317 */     GIR_EraseRootFromParent_Done,
     /* 1389318 */   // Label 19736: @1389318
     /* 1389318 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1389402), // Rule ID 22649 //
     /* 1389323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1389340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389376 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1389379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389401 */     // GIR_Coverage, 22649,
     /* 1389401 */     GIR_EraseRootFromParent_Done,
     /* 1389402 */   // Label 19737: @1389402
     /* 1389402 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1389486), // Rule ID 22652 //
     /* 1389407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389485 */     // GIR_Coverage, 22652,
     /* 1389485 */     GIR_EraseRootFromParent_Done,
     /* 1389486 */   // Label 19738: @1389486
     /* 1389486 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1389570), // Rule ID 22653 //
     /* 1389491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389569 */     // GIR_Coverage, 22653,
     /* 1389569 */     GIR_EraseRootFromParent_Done,
     /* 1389570 */   // Label 19739: @1389570
     /* 1389570 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1389654), // Rule ID 22656 //
     /* 1389575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389653 */     // GIR_Coverage, 22656,
     /* 1389653 */     GIR_EraseRootFromParent_Done,
     /* 1389654 */   // Label 19740: @1389654
     /* 1389654 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1389738), // Rule ID 22657 //
     /* 1389659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389737 */     // GIR_Coverage, 22657,
     /* 1389737 */     GIR_EraseRootFromParent_Done,
     /* 1389738 */   // Label 19741: @1389738
     /* 1389738 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1389822), // Rule ID 22660 //
     /* 1389743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389821 */     // GIR_Coverage, 22660,
     /* 1389821 */     GIR_EraseRootFromParent_Done,
     /* 1389822 */   // Label 19742: @1389822
     /* 1389822 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1389906), // Rule ID 22661 //
     /* 1389827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389905 */     // GIR_Coverage, 22661,
     /* 1389905 */     GIR_EraseRootFromParent_Done,
     /* 1389906 */   // Label 19743: @1389906
     /* 1389906 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1389990), // Rule ID 22664 //
     /* 1389911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389989 */     // GIR_Coverage, 22664,
     /* 1389989 */     GIR_EraseRootFromParent_Done,
     /* 1389990 */   // Label 19744: @1389990
     /* 1389990 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1390074), // Rule ID 22665 //
     /* 1389995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1390012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1390051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390073 */     // GIR_Coverage, 22665,
     /* 1390073 */     GIR_EraseRootFromParent_Done,
     /* 1390074 */   // Label 19745: @1390074
     /* 1390074 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1390158), // Rule ID 22668 //
     /* 1390079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1390096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1390135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390157 */     // GIR_Coverage, 22668,
     /* 1390157 */     GIR_EraseRootFromParent_Done,
     /* 1390158 */   // Label 19746: @1390158
     /* 1390158 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1390242), // Rule ID 22669 //
     /* 1390163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1390180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1390219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390241 */     // GIR_Coverage, 22669,
     /* 1390241 */     GIR_EraseRootFromParent_Done,
     /* 1390242 */   // Label 19747: @1390242
     /* 1390242 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1390326), // Rule ID 22672 //
     /* 1390247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1390264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1390303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390325 */     // GIR_Coverage, 22672,
     /* 1390325 */     GIR_EraseRootFromParent_Done,
     /* 1390326 */   // Label 19748: @1390326
     /* 1390326 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1390410), // Rule ID 22673 //
     /* 1390331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1390348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1390387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390409 */     // GIR_Coverage, 22673,
     /* 1390409 */     GIR_EraseRootFromParent_Done,
     /* 1390410 */   // Label 19749: @1390410
     /* 1390410 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1390494), // Rule ID 22676 //
     /* 1390415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390493 */     // GIR_Coverage, 22676,
     /* 1390493 */     GIR_EraseRootFromParent_Done,
     /* 1390494 */   // Label 19750: @1390494
     /* 1390494 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1390578), // Rule ID 22677 //
     /* 1390499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390577 */     // GIR_Coverage, 22677,
     /* 1390577 */     GIR_EraseRootFromParent_Done,
     /* 1390578 */   // Label 19751: @1390578
     /* 1390578 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1390662), // Rule ID 22680 //
     /* 1390583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390661 */     // GIR_Coverage, 22680,
     /* 1390661 */     GIR_EraseRootFromParent_Done,
     /* 1390662 */   // Label 19752: @1390662
     /* 1390662 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1390746), // Rule ID 22681 //
     /* 1390667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390745 */     // GIR_Coverage, 22681,
     /* 1390745 */     GIR_EraseRootFromParent_Done,
     /* 1390746 */   // Label 19753: @1390746
     /* 1390746 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1390830), // Rule ID 22684 //
     /* 1390751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390829 */     // GIR_Coverage, 22684,
     /* 1390829 */     GIR_EraseRootFromParent_Done,
     /* 1390830 */   // Label 19754: @1390830
     /* 1390830 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1390914), // Rule ID 22685 //
     /* 1390835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390913 */     // GIR_Coverage, 22685,
     /* 1390913 */     GIR_EraseRootFromParent_Done,
     /* 1390914 */   // Label 19755: @1390914
     /* 1390914 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1390998), // Rule ID 22688 //
     /* 1390919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390997 */     // GIR_Coverage, 22688,
     /* 1390997 */     GIR_EraseRootFromParent_Done,
     /* 1390998 */   // Label 19756: @1390998
     /* 1390998 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1391082), // Rule ID 22689 //
     /* 1391003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1391006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1391011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1391020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1391059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391081 */     // GIR_Coverage, 22689,
     /* 1391081 */     GIR_EraseRootFromParent_Done,
     /* 1391082 */   // Label 19757: @1391082
     /* 1391082 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1391166), // Rule ID 22692 //
     /* 1391087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1391143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391165 */     // GIR_Coverage, 22692,
     /* 1391165 */     GIR_EraseRootFromParent_Done,
     /* 1391166 */   // Label 19758: @1391166
     /* 1391166 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1391250), // Rule ID 22693 //
     /* 1391171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1391227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391249 */     // GIR_Coverage, 22693,
     /* 1391249 */     GIR_EraseRootFromParent_Done,
     /* 1391250 */   // Label 19759: @1391250
     /* 1391250 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1391334), // Rule ID 22696 //
     /* 1391255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1391311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391333 */     // GIR_Coverage, 22696,
     /* 1391333 */     GIR_EraseRootFromParent_Done,
     /* 1391334 */   // Label 19760: @1391334
     /* 1391334 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1391418), // Rule ID 22697 //
     /* 1391339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1391395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391417 */     // GIR_Coverage, 22697,
     /* 1391417 */     GIR_EraseRootFromParent_Done,
     /* 1391418 */   // Label 19761: @1391418
     /* 1391418 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1391502), // Rule ID 22700 //
     /* 1391423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391501 */     // GIR_Coverage, 22700,
     /* 1391501 */     GIR_EraseRootFromParent_Done,
     /* 1391502 */   // Label 19762: @1391502
     /* 1391502 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1391586), // Rule ID 22701 //
     /* 1391507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391585 */     // GIR_Coverage, 22701,
     /* 1391585 */     GIR_EraseRootFromParent_Done,
     /* 1391586 */   // Label 19763: @1391586
     /* 1391586 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1391670), // Rule ID 22704 //
     /* 1391591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391669 */     // GIR_Coverage, 22704,
     /* 1391669 */     GIR_EraseRootFromParent_Done,
     /* 1391670 */   // Label 19764: @1391670
     /* 1391670 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1391754), // Rule ID 22705 //
     /* 1391675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391753 */     // GIR_Coverage, 22705,
     /* 1391753 */     GIR_EraseRootFromParent_Done,
     /* 1391754 */   // Label 19765: @1391754
     /* 1391754 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1391838), // Rule ID 22708 //
     /* 1391759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391837 */     // GIR_Coverage, 22708,
     /* 1391837 */     GIR_EraseRootFromParent_Done,
     /* 1391838 */   // Label 19766: @1391838
     /* 1391838 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1391922), // Rule ID 22709 //
     /* 1391843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391921 */     // GIR_Coverage, 22709,
     /* 1391921 */     GIR_EraseRootFromParent_Done,
     /* 1391922 */   // Label 19767: @1391922
     /* 1391922 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1392006), // Rule ID 22712 //
     /* 1391927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392005 */     // GIR_Coverage, 22712,
     /* 1392005 */     GIR_EraseRootFromParent_Done,
     /* 1392006 */   // Label 19768: @1392006
     /* 1392006 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1392090), // Rule ID 22713 //
     /* 1392011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1392028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1392067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392089 */     // GIR_Coverage, 22713,
     /* 1392089 */     GIR_EraseRootFromParent_Done,
     /* 1392090 */   // Label 19769: @1392090
     /* 1392090 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1392174), // Rule ID 22716 //
     /* 1392095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1392151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392173 */     // GIR_Coverage, 22716,
     /* 1392173 */     GIR_EraseRootFromParent_Done,
     /* 1392174 */   // Label 19770: @1392174
     /* 1392174 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1392258), // Rule ID 22717 //
     /* 1392179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1392235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392257 */     // GIR_Coverage, 22717,
     /* 1392257 */     GIR_EraseRootFromParent_Done,
     /* 1392258 */   // Label 19771: @1392258
     /* 1392258 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1392342), // Rule ID 22720 //
     /* 1392263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1392319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392341 */     // GIR_Coverage, 22720,
     /* 1392341 */     GIR_EraseRootFromParent_Done,
     /* 1392342 */   // Label 19772: @1392342
     /* 1392342 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1392426), // Rule ID 22721 //
     /* 1392347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1392403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392425 */     // GIR_Coverage, 22721,
     /* 1392425 */     GIR_EraseRootFromParent_Done,
     /* 1392426 */   // Label 19773: @1392426
     /* 1392426 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1392510), // Rule ID 22724 //
     /* 1392431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392509 */     // GIR_Coverage, 22724,
     /* 1392509 */     GIR_EraseRootFromParent_Done,
     /* 1392510 */   // Label 19774: @1392510
     /* 1392510 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1392594), // Rule ID 22725 //
     /* 1392515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392593 */     // GIR_Coverage, 22725,
     /* 1392593 */     GIR_EraseRootFromParent_Done,
     /* 1392594 */   // Label 19775: @1392594
     /* 1392594 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1392678), // Rule ID 22728 //
     /* 1392599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392677 */     // GIR_Coverage, 22728,
     /* 1392677 */     GIR_EraseRootFromParent_Done,
     /* 1392678 */   // Label 19776: @1392678
     /* 1392678 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1392762), // Rule ID 22729 //
     /* 1392683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392761 */     // GIR_Coverage, 22729,
     /* 1392761 */     GIR_EraseRootFromParent_Done,
     /* 1392762 */   // Label 19777: @1392762
     /* 1392762 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1392846), // Rule ID 22732 //
     /* 1392767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392845 */     // GIR_Coverage, 22732,
     /* 1392845 */     GIR_EraseRootFromParent_Done,
     /* 1392846 */   // Label 19778: @1392846
     /* 1392846 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1392930), // Rule ID 22733 //
     /* 1392851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392929 */     // GIR_Coverage, 22733,
     /* 1392929 */     GIR_EraseRootFromParent_Done,
     /* 1392930 */   // Label 19779: @1392930
     /* 1392930 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1393014), // Rule ID 22736 //
     /* 1392935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393013 */     // GIR_Coverage, 22736,
     /* 1393013 */     GIR_EraseRootFromParent_Done,
     /* 1393014 */   // Label 19780: @1393014
     /* 1393014 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1393098), // Rule ID 22737 //
     /* 1393019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1393036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1393042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11720:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1393075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393097 */     // GIR_Coverage, 22737,
     /* 1393097 */     GIR_EraseRootFromParent_Done,
     /* 1393098 */   // Label 19781: @1393098
     /* 1393098 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1393182), // Rule ID 22740 //
     /* 1393103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1393159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393181 */     // GIR_Coverage, 22740,
     /* 1393181 */     GIR_EraseRootFromParent_Done,
     /* 1393182 */   // Label 19782: @1393182
     /* 1393182 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1393266), // Rule ID 22741 //
     /* 1393187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1393243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393265 */     // GIR_Coverage, 22741,
     /* 1393265 */     GIR_EraseRootFromParent_Done,
     /* 1393266 */   // Label 19783: @1393266
     /* 1393266 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1393350), // Rule ID 22744 //
     /* 1393271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1393327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393349 */     // GIR_Coverage, 22744,
     /* 1393349 */     GIR_EraseRootFromParent_Done,
     /* 1393350 */   // Label 19784: @1393350
     /* 1393350 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1393434), // Rule ID 22745 //
     /* 1393355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1393411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393433 */     // GIR_Coverage, 22745,
     /* 1393433 */     GIR_EraseRootFromParent_Done,
     /* 1393434 */   // Label 19785: @1393434
     /* 1393434 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1393518), // Rule ID 22748 //
     /* 1393439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393517 */     // GIR_Coverage, 22748,
     /* 1393517 */     GIR_EraseRootFromParent_Done,
     /* 1393518 */   // Label 19786: @1393518
     /* 1393518 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1393602), // Rule ID 22749 //
     /* 1393523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11720:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393601 */     // GIR_Coverage, 22749,
     /* 1393601 */     GIR_EraseRootFromParent_Done,
     /* 1393602 */   // Label 19787: @1393602
     /* 1393602 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1393686), // Rule ID 22752 //
     /* 1393607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393685 */     // GIR_Coverage, 22752,
     /* 1393685 */     GIR_EraseRootFromParent_Done,
     /* 1393686 */   // Label 19788: @1393686
     /* 1393686 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1393770), // Rule ID 22753 //
     /* 1393691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393769 */     // GIR_Coverage, 22753,
     /* 1393769 */     GIR_EraseRootFromParent_Done,
     /* 1393770 */   // Label 19789: @1393770
     /* 1393770 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1393854), // Rule ID 22756 //
     /* 1393775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393853 */     // GIR_Coverage, 22756,
     /* 1393853 */     GIR_EraseRootFromParent_Done,
     /* 1393854 */   // Label 19790: @1393854
     /* 1393854 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1393938), // Rule ID 22757 //
     /* 1393859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393937 */     // GIR_Coverage, 22757,
     /* 1393937 */     GIR_EraseRootFromParent_Done,
     /* 1393938 */   // Label 19791: @1393938
     /* 1393938 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1394022), // Rule ID 22760 //
     /* 1393943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1393999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394021 */     // GIR_Coverage, 22760,
     /* 1394021 */     GIR_EraseRootFromParent_Done,
     /* 1394022 */   // Label 19792: @1394022
     /* 1394022 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1394106), // Rule ID 22761 //
     /* 1394027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1394035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11720:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1394083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394105 */     // GIR_Coverage, 22761,
     /* 1394105 */     GIR_EraseRootFromParent_Done,
     /* 1394106 */   // Label 19793: @1394106
     /* 1394106 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1394190), // Rule ID 22764 //
     /* 1394111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1394167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394189 */     // GIR_Coverage, 22764,
     /* 1394189 */     GIR_EraseRootFromParent_Done,
     /* 1394190 */   // Label 19794: @1394190
     /* 1394190 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1394274), // Rule ID 22765 //
     /* 1394195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1394212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1394251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394273 */     // GIR_Coverage, 22765,
     /* 1394273 */     GIR_EraseRootFromParent_Done,
     /* 1394274 */   // Label 19795: @1394274
     /* 1394274 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1394358), // Rule ID 22768 //
     /* 1394279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1394335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394357 */     // GIR_Coverage, 22768,
     /* 1394357 */     GIR_EraseRootFromParent_Done,
     /* 1394358 */   // Label 19796: @1394358
     /* 1394358 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1394442), // Rule ID 22769 //
     /* 1394363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1394380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1394419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394441 */     // GIR_Coverage, 22769,
     /* 1394441 */     GIR_EraseRootFromParent_Done,
     /* 1394442 */   // Label 19797: @1394442
     /* 1394442 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1394526), // Rule ID 22772 //
     /* 1394447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394525 */     // GIR_Coverage, 22772,
     /* 1394525 */     GIR_EraseRootFromParent_Done,
     /* 1394526 */   // Label 19798: @1394526
     /* 1394526 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1394610), // Rule ID 22773 //
     /* 1394531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394609 */     // GIR_Coverage, 22773,
     /* 1394609 */     GIR_EraseRootFromParent_Done,
     /* 1394610 */   // Label 19799: @1394610
     /* 1394610 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1394694), // Rule ID 22776 //
     /* 1394615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394693 */     // GIR_Coverage, 22776,
     /* 1394693 */     GIR_EraseRootFromParent_Done,
     /* 1394694 */   // Label 19800: @1394694
     /* 1394694 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1394778), // Rule ID 22777 //
     /* 1394699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394777 */     // GIR_Coverage, 22777,
     /* 1394777 */     GIR_EraseRootFromParent_Done,
     /* 1394778 */   // Label 19801: @1394778
     /* 1394778 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1394862), // Rule ID 22780 //
     /* 1394783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394861 */     // GIR_Coverage, 22780,
     /* 1394861 */     GIR_EraseRootFromParent_Done,
     /* 1394862 */   // Label 19802: @1394862
     /* 1394862 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1394946), // Rule ID 22781 //
     /* 1394867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394945 */     // GIR_Coverage, 22781,
     /* 1394945 */     GIR_EraseRootFromParent_Done,
     /* 1394946 */   // Label 19803: @1394946
     /* 1394946 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1395030), // Rule ID 22784 //
     /* 1394951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1395007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395029 */     // GIR_Coverage, 22784,
     /* 1395029 */     GIR_EraseRootFromParent_Done,
     /* 1395030 */   // Label 19804: @1395030
     /* 1395030 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1395114), // Rule ID 22785 //
     /* 1395035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1395052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1395091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395113 */     // GIR_Coverage, 22785,
     /* 1395113 */     GIR_EraseRootFromParent_Done,
     /* 1395114 */   // Label 19805: @1395114
     /* 1395114 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1395198), // Rule ID 22788 //
     /* 1395119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1395175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395197 */     // GIR_Coverage, 22788,
     /* 1395197 */     GIR_EraseRootFromParent_Done,
     /* 1395198 */   // Label 19806: @1395198
     /* 1395198 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1395282), // Rule ID 22789 //
     /* 1395203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1395220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1395259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395281 */     // GIR_Coverage, 22789,
     /* 1395281 */     GIR_EraseRootFromParent_Done,
     /* 1395282 */   // Label 19807: @1395282
     /* 1395282 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1395366), // Rule ID 22792 //
     /* 1395287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1395343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395365 */     // GIR_Coverage, 22792,
     /* 1395365 */     GIR_EraseRootFromParent_Done,
     /* 1395366 */   // Label 19808: @1395366
     /* 1395366 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1395450), // Rule ID 22793 //
     /* 1395371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1395427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395449 */     // GIR_Coverage, 22793,
     /* 1395449 */     GIR_EraseRootFromParent_Done,
     /* 1395450 */   // Label 19809: @1395450
     /* 1395450 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1395534), // Rule ID 22796 //
     /* 1395455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395533 */     // GIR_Coverage, 22796,
     /* 1395533 */     GIR_EraseRootFromParent_Done,
     /* 1395534 */   // Label 19810: @1395534
     /* 1395534 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1395618), // Rule ID 22797 //
     /* 1395539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395617 */     // GIR_Coverage, 22797,
     /* 1395617 */     GIR_EraseRootFromParent_Done,
     /* 1395618 */   // Label 19811: @1395618
     /* 1395618 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1395702), // Rule ID 22800 //
     /* 1395623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395701 */     // GIR_Coverage, 22800,
     /* 1395701 */     GIR_EraseRootFromParent_Done,
     /* 1395702 */   // Label 19812: @1395702
     /* 1395702 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1395786), // Rule ID 22801 //
     /* 1395707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395760 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395785 */     // GIR_Coverage, 22801,
     /* 1395785 */     GIR_EraseRootFromParent_Done,
     /* 1395786 */   // Label 19813: @1395786
     /* 1395786 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1395870), // Rule ID 22804 //
     /* 1395791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395869 */     // GIR_Coverage, 22804,
     /* 1395869 */     GIR_EraseRootFromParent_Done,
     /* 1395870 */   // Label 19814: @1395870
     /* 1395870 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1395954), // Rule ID 22805 //
     /* 1395875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395953 */     // GIR_Coverage, 22805,
     /* 1395953 */     GIR_EraseRootFromParent_Done,
     /* 1395954 */   // Label 19815: @1395954
     /* 1395954 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1396038), // Rule ID 22808 //
     /* 1395959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1396015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396037 */     // GIR_Coverage, 22808,
     /* 1396037 */     GIR_EraseRootFromParent_Done,
     /* 1396038 */   // Label 19816: @1396038
     /* 1396038 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1396122), // Rule ID 22809 //
     /* 1396043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1396060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1396066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11718:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1396099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396121 */     // GIR_Coverage, 22809,
     /* 1396121 */     GIR_EraseRootFromParent_Done,
     /* 1396122 */   // Label 19817: @1396122
     /* 1396122 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1396206), // Rule ID 22812 //
     /* 1396127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1396183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396205 */     // GIR_Coverage, 22812,
     /* 1396205 */     GIR_EraseRootFromParent_Done,
     /* 1396206 */   // Label 19818: @1396206
     /* 1396206 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1396290), // Rule ID 22813 //
     /* 1396211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1396228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1396267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396289 */     // GIR_Coverage, 22813,
     /* 1396289 */     GIR_EraseRootFromParent_Done,
     /* 1396290 */   // Label 19819: @1396290
     /* 1396290 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1396374), // Rule ID 22816 //
     /* 1396295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1396351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396373 */     // GIR_Coverage, 22816,
     /* 1396373 */     GIR_EraseRootFromParent_Done,
     /* 1396374 */   // Label 19820: @1396374
     /* 1396374 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1396458), // Rule ID 22817 //
     /* 1396379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1396396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1396435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396457 */     // GIR_Coverage, 22817,
     /* 1396457 */     GIR_EraseRootFromParent_Done,
     /* 1396458 */   // Label 19821: @1396458
     /* 1396458 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1396542), // Rule ID 22820 //
     /* 1396463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396541 */     // GIR_Coverage, 22820,
     /* 1396541 */     GIR_EraseRootFromParent_Done,
     /* 1396542 */   // Label 19822: @1396542
     /* 1396542 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1396626), // Rule ID 22821 //
     /* 1396547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11718:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396625 */     // GIR_Coverage, 22821,
     /* 1396625 */     GIR_EraseRootFromParent_Done,
     /* 1396626 */   // Label 19823: @1396626
     /* 1396626 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1396710), // Rule ID 22824 //
     /* 1396631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396684 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396709 */     // GIR_Coverage, 22824,
     /* 1396709 */     GIR_EraseRootFromParent_Done,
     /* 1396710 */   // Label 19824: @1396710
     /* 1396710 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1396794), // Rule ID 22825 //
     /* 1396715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396793 */     // GIR_Coverage, 22825,
     /* 1396793 */     GIR_EraseRootFromParent_Done,
     /* 1396794 */   // Label 19825: @1396794
     /* 1396794 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1396878), // Rule ID 22828 //
     /* 1396799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396877 */     // GIR_Coverage, 22828,
     /* 1396877 */     GIR_EraseRootFromParent_Done,
     /* 1396878 */   // Label 19826: @1396878
     /* 1396878 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1396962), // Rule ID 22829 //
     /* 1396883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396961 */     // GIR_Coverage, 22829,
     /* 1396961 */     GIR_EraseRootFromParent_Done,
     /* 1396962 */   // Label 19827: @1396962
     /* 1396962 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1397046), // Rule ID 22832 //
     /* 1396967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1397023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397045 */     // GIR_Coverage, 22832,
     /* 1397045 */     GIR_EraseRootFromParent_Done,
     /* 1397046 */   // Label 19828: @1397046
     /* 1397046 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1397130), // Rule ID 22833 //
     /* 1397051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1397059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1397068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11718:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1397107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397129 */     // GIR_Coverage, 22833,
     /* 1397129 */     GIR_EraseRootFromParent_Done,
     /* 1397130 */   // Label 19829: @1397130
     /* 1397130 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1397214), // Rule ID 22952 //
     /* 1397135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397188 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1397191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397213 */     // GIR_Coverage, 22952,
     /* 1397213 */     GIR_EraseRootFromParent_Done,
     /* 1397214 */   // Label 19830: @1397214
     /* 1397214 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1397298), // Rule ID 22953 //
     /* 1397219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397272 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1397275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397297 */     // GIR_Coverage, 22953,
     /* 1397297 */     GIR_EraseRootFromParent_Done,
     /* 1397298 */   // Label 19831: @1397298
     /* 1397298 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1397382), // Rule ID 22956 //
     /* 1397303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1397359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397381 */     // GIR_Coverage, 22956,
     /* 1397381 */     GIR_EraseRootFromParent_Done,
     /* 1397382 */   // Label 19832: @1397382
     /* 1397382 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1397466), // Rule ID 22957 //
     /* 1397387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1397443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397465 */     // GIR_Coverage, 22957,
     /* 1397465 */     GIR_EraseRootFromParent_Done,
     /* 1397466 */   // Label 19833: @1397466
     /* 1397466 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1397550), // Rule ID 22960 //
     /* 1397471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397549 */     // GIR_Coverage, 22960,
     /* 1397549 */     GIR_EraseRootFromParent_Done,
     /* 1397550 */   // Label 19834: @1397550
     /* 1397550 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1397634), // Rule ID 22961 //
     /* 1397555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397633 */     // GIR_Coverage, 22961,
     /* 1397633 */     GIR_EraseRootFromParent_Done,
     /* 1397634 */   // Label 19835: @1397634
     /* 1397634 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1397718), // Rule ID 22964 //
     /* 1397639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397717 */     // GIR_Coverage, 22964,
     /* 1397717 */     GIR_EraseRootFromParent_Done,
     /* 1397718 */   // Label 19836: @1397718
     /* 1397718 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1397802), // Rule ID 22965 //
     /* 1397723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397801 */     // GIR_Coverage, 22965,
     /* 1397801 */     GIR_EraseRootFromParent_Done,
     /* 1397802 */   // Label 19837: @1397802
     /* 1397802 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1397886), // Rule ID 22968 //
     /* 1397807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397885 */     // GIR_Coverage, 22968,
     /* 1397885 */     GIR_EraseRootFromParent_Done,
     /* 1397886 */   // Label 19838: @1397886
     /* 1397886 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1397970), // Rule ID 22969 //
     /* 1397891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397969 */     // GIR_Coverage, 22969,
     /* 1397969 */     GIR_EraseRootFromParent_Done,
     /* 1397970 */   // Label 19839: @1397970
     /* 1397970 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1398054), // Rule ID 22972 //
     /* 1397975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1397978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1398031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398053 */     // GIR_Coverage, 22972,
     /* 1398053 */     GIR_EraseRootFromParent_Done,
     /* 1398054 */   // Label 19840: @1398054
     /* 1398054 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1398138), // Rule ID 22973 //
     /* 1398059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1398076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1398082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398112 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1398115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398137 */     // GIR_Coverage, 22973,
     /* 1398137 */     GIR_EraseRootFromParent_Done,
     /* 1398138 */   // Label 19841: @1398138
     /* 1398138 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1398222), // Rule ID 22976 //
     /* 1398143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1398199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398221 */     // GIR_Coverage, 22976,
     /* 1398221 */     GIR_EraseRootFromParent_Done,
     /* 1398222 */   // Label 19842: @1398222
     /* 1398222 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1398306), // Rule ID 22977 //
     /* 1398227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1398283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398305 */     // GIR_Coverage, 22977,
     /* 1398305 */     GIR_EraseRootFromParent_Done,
     /* 1398306 */   // Label 19843: @1398306
     /* 1398306 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1398390), // Rule ID 22980 //
     /* 1398311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1398367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398389 */     // GIR_Coverage, 22980,
     /* 1398389 */     GIR_EraseRootFromParent_Done,
     /* 1398390 */   // Label 19844: @1398390
     /* 1398390 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1398474), // Rule ID 22981 //
     /* 1398395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398448 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1398451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398473 */     // GIR_Coverage, 22981,
     /* 1398473 */     GIR_EraseRootFromParent_Done,
     /* 1398474 */   // Label 19845: @1398474
     /* 1398474 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1398558), // Rule ID 22984 //
     /* 1398479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398532 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398557 */     // GIR_Coverage, 22984,
     /* 1398557 */     GIR_EraseRootFromParent_Done,
     /* 1398558 */   // Label 19846: @1398558
     /* 1398558 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1398642), // Rule ID 22985 //
     /* 1398563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11312:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398641 */     // GIR_Coverage, 22985,
     /* 1398641 */     GIR_EraseRootFromParent_Done,
     /* 1398642 */   // Label 19847: @1398642
     /* 1398642 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1398726), // Rule ID 22988 //
     /* 1398647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398725 */     // GIR_Coverage, 22988,
     /* 1398725 */     GIR_EraseRootFromParent_Done,
     /* 1398726 */   // Label 19848: @1398726
     /* 1398726 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1398810), // Rule ID 22989 //
     /* 1398731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398809 */     // GIR_Coverage, 22989,
     /* 1398809 */     GIR_EraseRootFromParent_Done,
     /* 1398810 */   // Label 19849: @1398810
     /* 1398810 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1398894), // Rule ID 22992 //
     /* 1398815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398893 */     // GIR_Coverage, 22992,
     /* 1398893 */     GIR_EraseRootFromParent_Done,
     /* 1398894 */   // Label 19850: @1398894
     /* 1398894 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1398978), // Rule ID 22993 //
     /* 1398899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398977 */     // GIR_Coverage, 22993,
     /* 1398977 */     GIR_EraseRootFromParent_Done,
     /* 1398978 */   // Label 19851: @1398978
     /* 1398978 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1399062), // Rule ID 22996 //
     /* 1398983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1399039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399061 */     // GIR_Coverage, 22996,
     /* 1399061 */     GIR_EraseRootFromParent_Done,
     /* 1399062 */   // Label 19852: @1399062
     /* 1399062 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1399146), // Rule ID 22997 //
     /* 1399067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1399084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1399090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399120 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1399123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399145 */     // GIR_Coverage, 22997,
     /* 1399145 */     GIR_EraseRootFromParent_Done,
     /* 1399146 */   // Label 19853: @1399146
     /* 1399146 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1399230), // Rule ID 23000 //
     /* 1399151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1399168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1399207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399229 */     // GIR_Coverage, 23000,
     /* 1399229 */     GIR_EraseRootFromParent_Done,
     /* 1399230 */   // Label 19854: @1399230
     /* 1399230 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1399314), // Rule ID 23001 //
     /* 1399235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1399252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1399291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399313 */     // GIR_Coverage, 23001,
     /* 1399313 */     GIR_EraseRootFromParent_Done,
     /* 1399314 */   // Label 19855: @1399314
     /* 1399314 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1399398), // Rule ID 23004 //
     /* 1399319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399372 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1399375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399397 */     // GIR_Coverage, 23004,
     /* 1399397 */     GIR_EraseRootFromParent_Done,
     /* 1399398 */   // Label 19856: @1399398
     /* 1399398 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1399482), // Rule ID 23005 //
     /* 1399403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1399459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399481 */     // GIR_Coverage, 23005,
     /* 1399481 */     GIR_EraseRootFromParent_Done,
     /* 1399482 */   // Label 19857: @1399482
     /* 1399482 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1399566), // Rule ID 23008 //
     /* 1399487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399565 */     // GIR_Coverage, 23008,
     /* 1399565 */     GIR_EraseRootFromParent_Done,
     /* 1399566 */   // Label 19858: @1399566
     /* 1399566 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1399650), // Rule ID 23009 //
     /* 1399571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399649 */     // GIR_Coverage, 23009,
     /* 1399649 */     GIR_EraseRootFromParent_Done,
     /* 1399650 */   // Label 19859: @1399650
     /* 1399650 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1399734), // Rule ID 23012 //
     /* 1399655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399733 */     // GIR_Coverage, 23012,
     /* 1399733 */     GIR_EraseRootFromParent_Done,
     /* 1399734 */   // Label 19860: @1399734
     /* 1399734 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1399818), // Rule ID 23013 //
     /* 1399739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399792 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399817 */     // GIR_Coverage, 23013,
     /* 1399817 */     GIR_EraseRootFromParent_Done,
     /* 1399818 */   // Label 19861: @1399818
     /* 1399818 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1399902), // Rule ID 23016 //
     /* 1399823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399876 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399901 */     // GIR_Coverage, 23016,
     /* 1399901 */     GIR_EraseRootFromParent_Done,
     /* 1399902 */   // Label 19862: @1399902
     /* 1399902 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1399986), // Rule ID 23017 //
     /* 1399907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399960 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399985 */     // GIR_Coverage, 23017,
     /* 1399985 */     GIR_EraseRootFromParent_Done,
     /* 1399986 */   // Label 19863: @1399986
     /* 1399986 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1400070), // Rule ID 23020 //
     /* 1399991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1399994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400044 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1400047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400069 */     // GIR_Coverage, 23020,
     /* 1400069 */     GIR_EraseRootFromParent_Done,
     /* 1400070 */   // Label 19864: @1400070
     /* 1400070 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1400154), // Rule ID 23021 //
     /* 1400075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400128 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1400131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400153 */     // GIR_Coverage, 23021,
     /* 1400153 */     GIR_EraseRootFromParent_Done,
     /* 1400154 */   // Label 19865: @1400154
     /* 1400154 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1400238), // Rule ID 23024 //
     /* 1400159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400212 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1400215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400237 */     // GIR_Coverage, 23024,
     /* 1400237 */     GIR_EraseRootFromParent_Done,
     /* 1400238 */   // Label 19866: @1400238
     /* 1400238 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1400322), // Rule ID 23025 //
     /* 1400243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400296 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1400299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400321 */     // GIR_Coverage, 23025,
     /* 1400321 */     GIR_EraseRootFromParent_Done,
     /* 1400322 */   // Label 19867: @1400322
     /* 1400322 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1400406), // Rule ID 23028 //
     /* 1400327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400405 */     // GIR_Coverage, 23028,
     /* 1400405 */     GIR_EraseRootFromParent_Done,
     /* 1400406 */   // Label 19868: @1400406
     /* 1400406 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1400490), // Rule ID 23029 //
     /* 1400411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400489 */     // GIR_Coverage, 23029,
     /* 1400489 */     GIR_EraseRootFromParent_Done,
     /* 1400490 */   // Label 19869: @1400490
     /* 1400490 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1400574), // Rule ID 23032 //
     /* 1400495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1400498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400573 */     // GIR_Coverage, 23032,
     /* 1400573 */     GIR_EraseRootFromParent_Done,
     /* 1400574 */   // Label 19870: @1400574
     /* 1400574 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1400658), // Rule ID 23033 //
     /* 1400579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1400582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400632 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400657 */     // GIR_Coverage, 23033,
     /* 1400657 */     GIR_EraseRootFromParent_Done,
     /* 1400658 */   // Label 19871: @1400658
     /* 1400658 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1400742), // Rule ID 23036 //
     /* 1400663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400741 */     // GIR_Coverage, 23036,
     /* 1400741 */     GIR_EraseRootFromParent_Done,
     /* 1400742 */   // Label 19872: @1400742
     /* 1400742 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1400826), // Rule ID 23037 //
     /* 1400747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400825 */     // GIR_Coverage, 23037,
     /* 1400825 */     GIR_EraseRootFromParent_Done,
     /* 1400826 */   // Label 19873: @1400826
     /* 1400826 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1400910), // Rule ID 23040 //
     /* 1400831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400884 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400909 */     // GIR_Coverage, 23040,
     /* 1400909 */     GIR_EraseRootFromParent_Done,
     /* 1400910 */   // Label 19874: @1400910
     /* 1400910 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1400994), // Rule ID 23041 //
     /* 1400915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400968 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400993 */     // GIR_Coverage, 23041,
     /* 1400993 */     GIR_EraseRootFromParent_Done,
     /* 1400994 */   // Label 19875: @1400994
     /* 1400994 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1401078), // Rule ID 23044 //
     /* 1400999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1401002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1401055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401077 */     // GIR_Coverage, 23044,
     /* 1401077 */     GIR_EraseRootFromParent_Done,
     /* 1401078 */   // Label 19876: @1401078
     /* 1401078 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1401162), // Rule ID 23045 //
     /* 1401083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1401086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1401094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1401097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1401100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1401103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401136 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11310:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1401139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401161 */     // GIR_Coverage, 23045,
     /* 1401161 */     GIR_EraseRootFromParent_Done,
     /* 1401162 */   // Label 19877: @1401162
     /* 1401162 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1401246), // Rule ID 23048 //
     /* 1401167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1401184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401220 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1401223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401245 */     // GIR_Coverage, 23048,
     /* 1401245 */     GIR_EraseRootFromParent_Done,
     /* 1401246 */   // Label 19878: @1401246
     /* 1401246 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1401330), // Rule ID 23049 //
     /* 1401251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1401268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1401307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401329 */     // GIR_Coverage, 23049,
     /* 1401329 */     GIR_EraseRootFromParent_Done,
     /* 1401330 */   // Label 19879: @1401330
     /* 1401330 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1401414), // Rule ID 23052 //
     /* 1401335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1401352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401388 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401413 */     // GIR_Coverage, 23052,
     /* 1401413 */     GIR_EraseRootFromParent_Done,
     /* 1401414 */   // Label 19880: @1401414
     /* 1401414 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1401498), // Rule ID 23053 //
     /* 1401419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1401436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401497 */     // GIR_Coverage, 23053,
     /* 1401497 */     GIR_EraseRootFromParent_Done,
     /* 1401498 */   // Label 19881: @1401498
     /* 1401498 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1401582), // Rule ID 23056 //
     /* 1401503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401581 */     // GIR_Coverage, 23056,
     /* 1401581 */     GIR_EraseRootFromParent_Done,
     /* 1401582 */   // Label 19882: @1401582
     /* 1401582 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1401666), // Rule ID 23057 //
     /* 1401587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401640 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401665 */     // GIR_Coverage, 23057,
     /* 1401665 */     GIR_EraseRootFromParent_Done,
     /* 1401666 */   // Label 19883: @1401666
     /* 1401666 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1401750), // Rule ID 23060 //
     /* 1401671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401749 */     // GIR_Coverage, 23060,
     /* 1401749 */     GIR_EraseRootFromParent_Done,
     /* 1401750 */   // Label 19884: @1401750
     /* 1401750 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1401834), // Rule ID 23061 //
     /* 1401755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401833 */     // GIR_Coverage, 23061,
     /* 1401833 */     GIR_EraseRootFromParent_Done,
     /* 1401834 */   // Label 19885: @1401834
     /* 1401834 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1401918), // Rule ID 23064 //
     /* 1401839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401892 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401917 */     // GIR_Coverage, 23064,
     /* 1401917 */     GIR_EraseRootFromParent_Done,
     /* 1401918 */   // Label 19886: @1401918
     /* 1401918 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1402002), // Rule ID 23065 //
     /* 1401923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402001 */     // GIR_Coverage, 23065,
     /* 1402001 */     GIR_EraseRootFromParent_Done,
     /* 1402002 */   // Label 19887: @1402002
     /* 1402002 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1402086), // Rule ID 23068 //
     /* 1402007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1402010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1402015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402060 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1402060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1402063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402085 */     // GIR_Coverage, 23068,
     /* 1402085 */     GIR_EraseRootFromParent_Done,
     /* 1402086 */   // Label 19888: @1402086
     /* 1402086 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1402170), // Rule ID 23069 //
     /* 1402091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1402094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1402099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1402108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1402111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1402144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1402147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1402151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1402155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1402168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402169 */     // GIR_Coverage, 23069,
     /* 1402169 */     GIR_EraseRootFromParent_Done,
     /* 1402170 */   // Label 19889: @1402170
     /* 1402170 */   GIM_Reject,
     /* 1402171 */ // Label 13831: @1402171
     /* 1402171 */ GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(2015972),
     /* 1402176 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1402179 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1402265), // Rule ID 7362 //
     /* 1402184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1402195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1402198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1402201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402230 */     // MIs[0] policy
     /* 1402230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1402243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402264 */     // GIR_Coverage, 7362,
     /* 1402264 */     GIR_EraseRootFromParent_Done,
     /* 1402265 */   // Label 19891: @1402265
     /* 1402265 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1402351), // Rule ID 7363 //
     /* 1402270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1402281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1402284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1402287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402316 */     // MIs[0] policy
     /* 1402316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1402329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402350 */     // GIR_Coverage, 7363,
     /* 1402350 */     GIR_EraseRootFromParent_Done,
     /* 1402351 */   // Label 19892: @1402351
     /* 1402351 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1402437), // Rule ID 7366 //
     /* 1402356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1402367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1402370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1402373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402402 */     // MIs[0] policy
     /* 1402402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402436 */     // GIR_Coverage, 7366,
     /* 1402436 */     GIR_EraseRootFromParent_Done,
     /* 1402437 */   // Label 19893: @1402437
     /* 1402437 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1402523), // Rule ID 7367 //
     /* 1402442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1402453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1402456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1402459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402488 */     // MIs[0] policy
     /* 1402488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402522 */     // GIR_Coverage, 7367,
     /* 1402522 */     GIR_EraseRootFromParent_Done,
     /* 1402523 */   // Label 19894: @1402523
     /* 1402523 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1402609), // Rule ID 7370 //
     /* 1402528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402574 */     // MIs[0] policy
     /* 1402574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402584 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402608 */     // GIR_Coverage, 7370,
     /* 1402608 */     GIR_EraseRootFromParent_Done,
     /* 1402609 */   // Label 19895: @1402609
     /* 1402609 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1402695), // Rule ID 7371 //
     /* 1402614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402660 */     // MIs[0] policy
     /* 1402660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402694 */     // GIR_Coverage, 7371,
     /* 1402694 */     GIR_EraseRootFromParent_Done,
     /* 1402695 */   // Label 19896: @1402695
     /* 1402695 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1402781), // Rule ID 7374 //
     /* 1402700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402746 */     // MIs[0] policy
     /* 1402746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402780 */     // GIR_Coverage, 7374,
     /* 1402780 */     GIR_EraseRootFromParent_Done,
     /* 1402781 */   // Label 19897: @1402781
     /* 1402781 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1402867), // Rule ID 7375 //
     /* 1402786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402832 */     // MIs[0] policy
     /* 1402832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402866 */     // GIR_Coverage, 7375,
     /* 1402866 */     GIR_EraseRootFromParent_Done,
     /* 1402867 */   // Label 19898: @1402867
     /* 1402867 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1402953), // Rule ID 7378 //
     /* 1402872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402918 */     // MIs[0] policy
     /* 1402918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402952 */     // GIR_Coverage, 7378,
     /* 1402952 */     GIR_EraseRootFromParent_Done,
     /* 1402953 */   // Label 19899: @1402953
     /* 1402953 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1403039), // Rule ID 7379 //
     /* 1402958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403004 */     // MIs[0] policy
     /* 1403004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403038 */     // GIR_Coverage, 7379,
     /* 1403038 */     GIR_EraseRootFromParent_Done,
     /* 1403039 */   // Label 19900: @1403039
     /* 1403039 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1403125), // Rule ID 7382 //
     /* 1403044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403090 */     // MIs[0] policy
     /* 1403090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403124 */     // GIR_Coverage, 7382,
     /* 1403124 */     GIR_EraseRootFromParent_Done,
     /* 1403125 */   // Label 19901: @1403125
     /* 1403125 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1403211), // Rule ID 7383 //
     /* 1403130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403176 */     // MIs[0] policy
     /* 1403176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1403189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403210 */     // GIR_Coverage, 7383,
     /* 1403210 */     GIR_EraseRootFromParent_Done,
     /* 1403211 */   // Label 19902: @1403211
     /* 1403211 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1403297), // Rule ID 7386 //
     /* 1403216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1403227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1403230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1403233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403262 */     // MIs[0] policy
     /* 1403262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403272 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403296 */     // GIR_Coverage, 7386,
     /* 1403296 */     GIR_EraseRootFromParent_Done,
     /* 1403297 */   // Label 19903: @1403297
     /* 1403297 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1403383), // Rule ID 7387 //
     /* 1403302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1403313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1403316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1403319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403348 */     // MIs[0] policy
     /* 1403348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403382 */     // GIR_Coverage, 7387,
     /* 1403382 */     GIR_EraseRootFromParent_Done,
     /* 1403383 */   // Label 19904: @1403383
     /* 1403383 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1403469), // Rule ID 7390 //
     /* 1403388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403434 */     // MIs[0] policy
     /* 1403434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403468 */     // GIR_Coverage, 7390,
     /* 1403468 */     GIR_EraseRootFromParent_Done,
     /* 1403469 */   // Label 19905: @1403469
     /* 1403469 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1403555), // Rule ID 7391 //
     /* 1403474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403520 */     // MIs[0] policy
     /* 1403520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403554 */     // GIR_Coverage, 7391,
     /* 1403554 */     GIR_EraseRootFromParent_Done,
     /* 1403555 */   // Label 19906: @1403555
     /* 1403555 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1403641), // Rule ID 7394 //
     /* 1403560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403606 */     // MIs[0] policy
     /* 1403606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403640 */     // GIR_Coverage, 7394,
     /* 1403640 */     GIR_EraseRootFromParent_Done,
     /* 1403641 */   // Label 19907: @1403641
     /* 1403641 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1403727), // Rule ID 7395 //
     /* 1403646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403692 */     // MIs[0] policy
     /* 1403692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403726 */     // GIR_Coverage, 7395,
     /* 1403726 */     GIR_EraseRootFromParent_Done,
     /* 1403727 */   // Label 19908: @1403727
     /* 1403727 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1403813), // Rule ID 7398 //
     /* 1403732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1403735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403778 */     // MIs[0] policy
     /* 1403778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403812 */     // GIR_Coverage, 7398,
     /* 1403812 */     GIR_EraseRootFromParent_Done,
     /* 1403813 */   // Label 19909: @1403813
     /* 1403813 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1403899), // Rule ID 7399 //
     /* 1403818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403864 */     // MIs[0] policy
     /* 1403864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403898 */     // GIR_Coverage, 7399,
     /* 1403898 */     GIR_EraseRootFromParent_Done,
     /* 1403899 */   // Label 19910: @1403899
     /* 1403899 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1403985), // Rule ID 7402 //
     /* 1403904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403950 */     // MIs[0] policy
     /* 1403950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403984 */     // GIR_Coverage, 7402,
     /* 1403984 */     GIR_EraseRootFromParent_Done,
     /* 1403985 */   // Label 19911: @1403985
     /* 1403985 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1404071), // Rule ID 7403 //
     /* 1403990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1404001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1404004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1404007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404036 */     // MIs[0] policy
     /* 1404036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404070 */     // GIR_Coverage, 7403,
     /* 1404070 */     GIR_EraseRootFromParent_Done,
     /* 1404071 */   // Label 19912: @1404071
     /* 1404071 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1404157), // Rule ID 7406 //
     /* 1404076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1404087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1404090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1404093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404122 */     // MIs[0] policy
     /* 1404122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404132 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404156 */     // GIR_Coverage, 7406,
     /* 1404156 */     GIR_EraseRootFromParent_Done,
     /* 1404157 */   // Label 19913: @1404157
     /* 1404157 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1404243), // Rule ID 7407 //
     /* 1404162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1404173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1404176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1404179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404208 */     // MIs[0] policy
     /* 1404208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404218 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404242 */     // GIR_Coverage, 7407,
     /* 1404242 */     GIR_EraseRootFromParent_Done,
     /* 1404243 */   // Label 19914: @1404243
     /* 1404243 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1404329), // Rule ID 7410 //
     /* 1404248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1404259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1404262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1404265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1404271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404294 */     // MIs[0] policy
     /* 1404294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404328 */     // GIR_Coverage, 7410,
     /* 1404328 */     GIR_EraseRootFromParent_Done,
     /* 1404329 */   // Label 19915: @1404329
     /* 1404329 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1404415), // Rule ID 7411 //
     /* 1404334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1404345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1404348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1404351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1404357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404380 */     // MIs[0] policy
     /* 1404380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1404411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404414 */     // GIR_Coverage, 7411,
     /* 1404414 */     GIR_EraseRootFromParent_Done,
     /* 1404415 */   // Label 19916: @1404415
     /* 1404415 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1404501), // Rule ID 7414 //
     /* 1404420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404466 */     // MIs[0] policy
     /* 1404466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404500 */     // GIR_Coverage, 7414,
     /* 1404500 */     GIR_EraseRootFromParent_Done,
     /* 1404501 */   // Label 19917: @1404501
     /* 1404501 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1404587), // Rule ID 7415 //
     /* 1404506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404552 */     // MIs[0] policy
     /* 1404552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404586 */     // GIR_Coverage, 7415,
     /* 1404586 */     GIR_EraseRootFromParent_Done,
     /* 1404587 */   // Label 19918: @1404587
     /* 1404587 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1404673), // Rule ID 7418 //
     /* 1404592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404638 */     // MIs[0] policy
     /* 1404638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404672 */     // GIR_Coverage, 7418,
     /* 1404672 */     GIR_EraseRootFromParent_Done,
     /* 1404673 */   // Label 19919: @1404673
     /* 1404673 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1404759), // Rule ID 7419 //
     /* 1404678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404724 */     // MIs[0] policy
     /* 1404724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404758 */     // GIR_Coverage, 7419,
     /* 1404758 */     GIR_EraseRootFromParent_Done,
     /* 1404759 */   // Label 19920: @1404759
     /* 1404759 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1404845), // Rule ID 7422 //
     /* 1404764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404810 */     // MIs[0] policy
     /* 1404810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404844 */     // GIR_Coverage, 7422,
     /* 1404844 */     GIR_EraseRootFromParent_Done,
     /* 1404845 */   // Label 19921: @1404845
     /* 1404845 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1404931), // Rule ID 7423 //
     /* 1404850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404896 */     // MIs[0] policy
     /* 1404896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404930 */     // GIR_Coverage, 7423,
     /* 1404930 */     GIR_EraseRootFromParent_Done,
     /* 1404931 */   // Label 19922: @1404931
     /* 1404931 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1405017), // Rule ID 7426 //
     /* 1404936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404982 */     // MIs[0] policy
     /* 1404982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405016 */     // GIR_Coverage, 7426,
     /* 1405016 */     GIR_EraseRootFromParent_Done,
     /* 1405017 */   // Label 19923: @1405017
     /* 1405017 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1405103), // Rule ID 7427 //
     /* 1405022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1405033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1405036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1405039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405068 */     // MIs[0] policy
     /* 1405068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405102 */     // GIR_Coverage, 7427,
     /* 1405102 */     GIR_EraseRootFromParent_Done,
     /* 1405103 */   // Label 19924: @1405103
     /* 1405103 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1405189), // Rule ID 7430 //
     /* 1405108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405154 */     // MIs[0] policy
     /* 1405154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405188 */     // GIR_Coverage, 7430,
     /* 1405188 */     GIR_EraseRootFromParent_Done,
     /* 1405189 */   // Label 19925: @1405189
     /* 1405189 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1405275), // Rule ID 7431 //
     /* 1405194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405240 */     // MIs[0] policy
     /* 1405240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405274 */     // GIR_Coverage, 7431,
     /* 1405274 */     GIR_EraseRootFromParent_Done,
     /* 1405275 */   // Label 19926: @1405275
     /* 1405275 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1405361), // Rule ID 7434 //
     /* 1405280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1405283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1405303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405326 */     // MIs[0] policy
     /* 1405326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405360 */     // GIR_Coverage, 7434,
     /* 1405360 */     GIR_EraseRootFromParent_Done,
     /* 1405361 */   // Label 19927: @1405361
     /* 1405361 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1405447), // Rule ID 7435 //
     /* 1405366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1405369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1405389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405412 */     // MIs[0] policy
     /* 1405412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405446 */     // GIR_Coverage, 7435,
     /* 1405446 */     GIR_EraseRootFromParent_Done,
     /* 1405447 */   // Label 19928: @1405447
     /* 1405447 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1405533), // Rule ID 7438 //
     /* 1405452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405498 */     // MIs[0] policy
     /* 1405498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405532 */     // GIR_Coverage, 7438,
     /* 1405532 */     GIR_EraseRootFromParent_Done,
     /* 1405533 */   // Label 19929: @1405533
     /* 1405533 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1405619), // Rule ID 7439 //
     /* 1405538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405584 */     // MIs[0] policy
     /* 1405584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405618 */     // GIR_Coverage, 7439,
     /* 1405618 */     GIR_EraseRootFromParent_Done,
     /* 1405619 */   // Label 19930: @1405619
     /* 1405619 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1405705), // Rule ID 7442 //
     /* 1405624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405670 */     // MIs[0] policy
     /* 1405670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405704 */     // GIR_Coverage, 7442,
     /* 1405704 */     GIR_EraseRootFromParent_Done,
     /* 1405705 */   // Label 19931: @1405705
     /* 1405705 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1405791), // Rule ID 7443 //
     /* 1405710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405756 */     // MIs[0] policy
     /* 1405756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405790 */     // GIR_Coverage, 7443,
     /* 1405790 */     GIR_EraseRootFromParent_Done,
     /* 1405791 */   // Label 19932: @1405791
     /* 1405791 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1405877), // Rule ID 7446 //
     /* 1405796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405842 */     // MIs[0] policy
     /* 1405842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405876 */     // GIR_Coverage, 7446,
     /* 1405876 */     GIR_EraseRootFromParent_Done,
     /* 1405877 */   // Label 19933: @1405877
     /* 1405877 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1405963), // Rule ID 7447 //
     /* 1405882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405928 */     // MIs[0] policy
     /* 1405928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405962 */     // GIR_Coverage, 7447,
     /* 1405962 */     GIR_EraseRootFromParent_Done,
     /* 1405963 */   // Label 19934: @1405963
     /* 1405963 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1406051), // Rule ID 2752 //
     /* 1405968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406007 */     // MIs[0] Operand 5
     /* 1406007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406018 */     // MIs[0] policy
     /* 1406018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1406031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406050 */     // GIR_Coverage, 2752,
     /* 1406050 */     GIR_EraseRootFromParent_Done,
     /* 1406051 */   // Label 19935: @1406051
     /* 1406051 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1406139), // Rule ID 2753 //
     /* 1406056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1406067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1406070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1406073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406095 */     // MIs[0] Operand 5
     /* 1406095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406106 */     // MIs[0] policy
     /* 1406106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1406119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406138 */     // GIR_Coverage, 2753,
     /* 1406138 */     GIR_EraseRootFromParent_Done,
     /* 1406139 */   // Label 19936: @1406139
     /* 1406139 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1406227), // Rule ID 20644 //
     /* 1406144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406183 */     // MIs[0] Operand 5
     /* 1406183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406194 */     // MIs[0] policy
     /* 1406194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406226 */     // GIR_Coverage, 20644,
     /* 1406226 */     GIR_EraseRootFromParent_Done,
     /* 1406227 */   // Label 19937: @1406227
     /* 1406227 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1406315), // Rule ID 20645 //
     /* 1406232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406271 */     // MIs[0] Operand 5
     /* 1406271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406282 */     // MIs[0] policy
     /* 1406282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406314 */     // GIR_Coverage, 20645,
     /* 1406314 */     GIR_EraseRootFromParent_Done,
     /* 1406315 */   // Label 19938: @1406315
     /* 1406315 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1406403), // Rule ID 20648 //
     /* 1406320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406359 */     // MIs[0] Operand 5
     /* 1406359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406370 */     // MIs[0] policy
     /* 1406370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406402 */     // GIR_Coverage, 20648,
     /* 1406402 */     GIR_EraseRootFromParent_Done,
     /* 1406403 */   // Label 19939: @1406403
     /* 1406403 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1406491), // Rule ID 20649 //
     /* 1406408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406447 */     // MIs[0] Operand 5
     /* 1406447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406458 */     // MIs[0] policy
     /* 1406458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406490 */     // GIR_Coverage, 20649,
     /* 1406490 */     GIR_EraseRootFromParent_Done,
     /* 1406491 */   // Label 19940: @1406491
     /* 1406491 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1406579), // Rule ID 20652 //
     /* 1406496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406535 */     // MIs[0] Operand 5
     /* 1406535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406546 */     // MIs[0] policy
     /* 1406546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406578 */     // GIR_Coverage, 20652,
     /* 1406578 */     GIR_EraseRootFromParent_Done,
     /* 1406579 */   // Label 19941: @1406579
     /* 1406579 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1406667), // Rule ID 20653 //
     /* 1406584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406623 */     // MIs[0] Operand 5
     /* 1406623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406634 */     // MIs[0] policy
     /* 1406634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406666 */     // GIR_Coverage, 20653,
     /* 1406666 */     GIR_EraseRootFromParent_Done,
     /* 1406667 */   // Label 19942: @1406667
     /* 1406667 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1406755), // Rule ID 20656 //
     /* 1406672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406711 */     // MIs[0] Operand 5
     /* 1406711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406722 */     // MIs[0] policy
     /* 1406722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406754 */     // GIR_Coverage, 20656,
     /* 1406754 */     GIR_EraseRootFromParent_Done,
     /* 1406755 */   // Label 19943: @1406755
     /* 1406755 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1406843), // Rule ID 20657 //
     /* 1406760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406799 */     // MIs[0] Operand 5
     /* 1406799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406810 */     // MIs[0] policy
     /* 1406810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406842 */     // GIR_Coverage, 20657,
     /* 1406842 */     GIR_EraseRootFromParent_Done,
     /* 1406843 */   // Label 19944: @1406843
     /* 1406843 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1406931), // Rule ID 20660 //
     /* 1406848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1406851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406887 */     // MIs[0] Operand 5
     /* 1406887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406898 */     // MIs[0] policy
     /* 1406898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406930 */     // GIR_Coverage, 20660,
     /* 1406930 */     GIR_EraseRootFromParent_Done,
     /* 1406931 */   // Label 19945: @1406931
     /* 1406931 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1407019), // Rule ID 20661 //
     /* 1406936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1406939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406975 */     // MIs[0] Operand 5
     /* 1406975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406986 */     // MIs[0] policy
     /* 1406986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407018 */     // GIR_Coverage, 20661,
     /* 1407018 */     GIR_EraseRootFromParent_Done,
     /* 1407019 */   // Label 19946: @1407019
     /* 1407019 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1407107), // Rule ID 20664 //
     /* 1407024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407063 */     // MIs[0] Operand 5
     /* 1407063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407074 */     // MIs[0] policy
     /* 1407074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407106 */     // GIR_Coverage, 20664,
     /* 1407106 */     GIR_EraseRootFromParent_Done,
     /* 1407107 */   // Label 19947: @1407107
     /* 1407107 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1407195), // Rule ID 20665 //
     /* 1407112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407151 */     // MIs[0] Operand 5
     /* 1407151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407162 */     // MIs[0] policy
     /* 1407162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407194 */     // GIR_Coverage, 20665,
     /* 1407194 */     GIR_EraseRootFromParent_Done,
     /* 1407195 */   // Label 19948: @1407195
     /* 1407195 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1407283), // Rule ID 20668 //
     /* 1407200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407239 */     // MIs[0] Operand 5
     /* 1407239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407250 */     // MIs[0] policy
     /* 1407250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407260 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407282 */     // GIR_Coverage, 20668,
     /* 1407282 */     GIR_EraseRootFromParent_Done,
     /* 1407283 */   // Label 19949: @1407283
     /* 1407283 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1407371), // Rule ID 20669 //
     /* 1407288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407327 */     // MIs[0] Operand 5
     /* 1407327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407338 */     // MIs[0] policy
     /* 1407338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407370 */     // GIR_Coverage, 20669,
     /* 1407370 */     GIR_EraseRootFromParent_Done,
     /* 1407371 */   // Label 19950: @1407371
     /* 1407371 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1407459), // Rule ID 20672 //
     /* 1407376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407415 */     // MIs[0] Operand 5
     /* 1407415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407426 */     // MIs[0] policy
     /* 1407426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407458 */     // GIR_Coverage, 20672,
     /* 1407458 */     GIR_EraseRootFromParent_Done,
     /* 1407459 */   // Label 19951: @1407459
     /* 1407459 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1407547), // Rule ID 20673 //
     /* 1407464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407503 */     // MIs[0] Operand 5
     /* 1407503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407514 */     // MIs[0] policy
     /* 1407514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407546 */     // GIR_Coverage, 20673,
     /* 1407546 */     GIR_EraseRootFromParent_Done,
     /* 1407547 */   // Label 19952: @1407547
     /* 1407547 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1407635), // Rule ID 20676 //
     /* 1407552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407591 */     // MIs[0] Operand 5
     /* 1407591 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407602 */     // MIs[0] policy
     /* 1407602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407634 */     // GIR_Coverage, 20676,
     /* 1407634 */     GIR_EraseRootFromParent_Done,
     /* 1407635 */   // Label 19953: @1407635
     /* 1407635 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1407723), // Rule ID 20677 //
     /* 1407640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407679 */     // MIs[0] Operand 5
     /* 1407679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407690 */     // MIs[0] policy
     /* 1407690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407722 */     // GIR_Coverage, 20677,
     /* 1407722 */     GIR_EraseRootFromParent_Done,
     /* 1407723 */   // Label 19954: @1407723
     /* 1407723 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1407811), // Rule ID 20680 //
     /* 1407728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407767 */     // MIs[0] Operand 5
     /* 1407767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407778 */     // MIs[0] policy
     /* 1407778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407810 */     // GIR_Coverage, 20680,
     /* 1407810 */     GIR_EraseRootFromParent_Done,
     /* 1407811 */   // Label 19955: @1407811
     /* 1407811 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1407899), // Rule ID 20681 //
     /* 1407816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407855 */     // MIs[0] Operand 5
     /* 1407855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407866 */     // MIs[0] policy
     /* 1407866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407898 */     // GIR_Coverage, 20681,
     /* 1407898 */     GIR_EraseRootFromParent_Done,
     /* 1407899 */   // Label 19956: @1407899
     /* 1407899 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1407987), // Rule ID 20684 //
     /* 1407904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407943 */     // MIs[0] Operand 5
     /* 1407943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407954 */     // MIs[0] policy
     /* 1407954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407986 */     // GIR_Coverage, 20684,
     /* 1407986 */     GIR_EraseRootFromParent_Done,
     /* 1407987 */   // Label 19957: @1407987
     /* 1407987 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1408075), // Rule ID 20685 //
     /* 1407992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1408003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1408006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1408009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1408012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408031 */     // MIs[0] Operand 5
     /* 1408031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408042 */     // MIs[0] policy
     /* 1408042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408074 */     // GIR_Coverage, 20685,
     /* 1408074 */     GIR_EraseRootFromParent_Done,
     /* 1408075 */   // Label 19958: @1408075
     /* 1408075 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1408163), // Rule ID 20688 //
     /* 1408080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408119 */     // MIs[0] Operand 5
     /* 1408119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408130 */     // MIs[0] policy
     /* 1408130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1408143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408162 */     // GIR_Coverage, 20688,
     /* 1408162 */     GIR_EraseRootFromParent_Done,
     /* 1408163 */   // Label 19959: @1408163
     /* 1408163 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1408251), // Rule ID 20689 //
     /* 1408168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408207 */     // MIs[0] Operand 5
     /* 1408207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408218 */     // MIs[0] policy
     /* 1408218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1408231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408250 */     // GIR_Coverage, 20689,
     /* 1408250 */     GIR_EraseRootFromParent_Done,
     /* 1408251 */   // Label 19960: @1408251
     /* 1408251 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1408339), // Rule ID 20692 //
     /* 1408256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408295 */     // MIs[0] Operand 5
     /* 1408295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408306 */     // MIs[0] policy
     /* 1408306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1408319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408338 */     // GIR_Coverage, 20692,
     /* 1408338 */     GIR_EraseRootFromParent_Done,
     /* 1408339 */   // Label 19961: @1408339
     /* 1408339 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1408427), // Rule ID 20693 //
     /* 1408344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408383 */     // MIs[0] Operand 5
     /* 1408383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408394 */     // MIs[0] policy
     /* 1408394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1408407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408426 */     // GIR_Coverage, 20693,
     /* 1408426 */     GIR_EraseRootFromParent_Done,
     /* 1408427 */   // Label 19962: @1408427
     /* 1408427 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1408515), // Rule ID 20696 //
     /* 1408432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408471 */     // MIs[0] Operand 5
     /* 1408471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408482 */     // MIs[0] policy
     /* 1408482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408514 */     // GIR_Coverage, 20696,
     /* 1408514 */     GIR_EraseRootFromParent_Done,
     /* 1408515 */   // Label 19963: @1408515
     /* 1408515 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1408603), // Rule ID 20697 //
     /* 1408520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408559 */     // MIs[0] Operand 5
     /* 1408559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408570 */     // MIs[0] policy
     /* 1408570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408602 */     // GIR_Coverage, 20697,
     /* 1408602 */     GIR_EraseRootFromParent_Done,
     /* 1408603 */   // Label 19964: @1408603
     /* 1408603 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1408691), // Rule ID 20700 //
     /* 1408608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408647 */     // MIs[0] Operand 5
     /* 1408647 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408658 */     // MIs[0] policy
     /* 1408658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408690 */     // GIR_Coverage, 20700,
     /* 1408690 */     GIR_EraseRootFromParent_Done,
     /* 1408691 */   // Label 19965: @1408691
     /* 1408691 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1408779), // Rule ID 20701 //
     /* 1408696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408735 */     // MIs[0] Operand 5
     /* 1408735 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408746 */     // MIs[0] policy
     /* 1408746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408778 */     // GIR_Coverage, 20701,
     /* 1408778 */     GIR_EraseRootFromParent_Done,
     /* 1408779 */   // Label 19966: @1408779
     /* 1408779 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1408867), // Rule ID 20704 //
     /* 1408784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408823 */     // MIs[0] Operand 5
     /* 1408823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408834 */     // MIs[0] policy
     /* 1408834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408866 */     // GIR_Coverage, 20704,
     /* 1408866 */     GIR_EraseRootFromParent_Done,
     /* 1408867 */   // Label 19967: @1408867
     /* 1408867 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1408955), // Rule ID 20705 //
     /* 1408872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408911 */     // MIs[0] Operand 5
     /* 1408911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408922 */     // MIs[0] policy
     /* 1408922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408954 */     // GIR_Coverage, 20705,
     /* 1408954 */     GIR_EraseRootFromParent_Done,
     /* 1408955 */   // Label 19968: @1408955
     /* 1408955 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1409043), // Rule ID 20708 //
     /* 1408960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408999 */     // MIs[0] Operand 5
     /* 1408999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409010 */     // MIs[0] policy
     /* 1409010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409020 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409042 */     // GIR_Coverage, 20708,
     /* 1409042 */     GIR_EraseRootFromParent_Done,
     /* 1409043 */   // Label 19969: @1409043
     /* 1409043 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1409131), // Rule ID 20709 //
     /* 1409048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409087 */     // MIs[0] Operand 5
     /* 1409087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409098 */     // MIs[0] policy
     /* 1409098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409130 */     // GIR_Coverage, 20709,
     /* 1409130 */     GIR_EraseRootFromParent_Done,
     /* 1409131 */   // Label 19970: @1409131
     /* 1409131 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1409219), // Rule ID 20712 //
     /* 1409136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409175 */     // MIs[0] Operand 5
     /* 1409175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409186 */     // MIs[0] policy
     /* 1409186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409218 */     // GIR_Coverage, 20712,
     /* 1409218 */     GIR_EraseRootFromParent_Done,
     /* 1409219 */   // Label 19971: @1409219
     /* 1409219 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1409307), // Rule ID 20713 //
     /* 1409224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1409235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1409238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409263 */     // MIs[0] Operand 5
     /* 1409263 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409274 */     // MIs[0] policy
     /* 1409274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409306 */     // GIR_Coverage, 20713,
     /* 1409306 */     GIR_EraseRootFromParent_Done,
     /* 1409307 */   // Label 19972: @1409307
     /* 1409307 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1409395), // Rule ID 20716 //
     /* 1409312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409351 */     // MIs[0] Operand 5
     /* 1409351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409362 */     // MIs[0] policy
     /* 1409362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409394 */     // GIR_Coverage, 20716,
     /* 1409394 */     GIR_EraseRootFromParent_Done,
     /* 1409395 */   // Label 19973: @1409395
     /* 1409395 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1409483), // Rule ID 20717 //
     /* 1409400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409439 */     // MIs[0] Operand 5
     /* 1409439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409450 */     // MIs[0] policy
     /* 1409450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409482 */     // GIR_Coverage, 20717,
     /* 1409482 */     GIR_EraseRootFromParent_Done,
     /* 1409483 */   // Label 19974: @1409483
     /* 1409483 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1409571), // Rule ID 20720 //
     /* 1409488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1409491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409527 */     // MIs[0] Operand 5
     /* 1409527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409538 */     // MIs[0] policy
     /* 1409538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409570 */     // GIR_Coverage, 20720,
     /* 1409570 */     GIR_EraseRootFromParent_Done,
     /* 1409571 */   // Label 19975: @1409571
     /* 1409571 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1409659), // Rule ID 20721 //
     /* 1409576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1409579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409615 */     // MIs[0] Operand 5
     /* 1409615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409626 */     // MIs[0] policy
     /* 1409626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409658 */     // GIR_Coverage, 20721,
     /* 1409658 */     GIR_EraseRootFromParent_Done,
     /* 1409659 */   // Label 19976: @1409659
     /* 1409659 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1409747), // Rule ID 20724 //
     /* 1409664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409703 */     // MIs[0] Operand 5
     /* 1409703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409714 */     // MIs[0] policy
     /* 1409714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409746 */     // GIR_Coverage, 20724,
     /* 1409746 */     GIR_EraseRootFromParent_Done,
     /* 1409747 */   // Label 19977: @1409747
     /* 1409747 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1409835), // Rule ID 20725 //
     /* 1409752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409791 */     // MIs[0] Operand 5
     /* 1409791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409802 */     // MIs[0] policy
     /* 1409802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409834 */     // GIR_Coverage, 20725,
     /* 1409834 */     GIR_EraseRootFromParent_Done,
     /* 1409835 */   // Label 19978: @1409835
     /* 1409835 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1409923), // Rule ID 20728 //
     /* 1409840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409879 */     // MIs[0] Operand 5
     /* 1409879 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409890 */     // MIs[0] policy
     /* 1409890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409922 */     // GIR_Coverage, 20728,
     /* 1409922 */     GIR_EraseRootFromParent_Done,
     /* 1409923 */   // Label 19979: @1409923
     /* 1409923 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1410011), // Rule ID 20729 //
     /* 1409928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409967 */     // MIs[0] Operand 5
     /* 1409967 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409978 */     // MIs[0] policy
     /* 1409978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410010 */     // GIR_Coverage, 20729,
     /* 1410010 */     GIR_EraseRootFromParent_Done,
     /* 1410011 */   // Label 19980: @1410011
     /* 1410011 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1410099), // Rule ID 20732 //
     /* 1410016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410055 */     // MIs[0] Operand 5
     /* 1410055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410066 */     // MIs[0] policy
     /* 1410066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410098 */     // GIR_Coverage, 20732,
     /* 1410098 */     GIR_EraseRootFromParent_Done,
     /* 1410099 */   // Label 19981: @1410099
     /* 1410099 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1410187), // Rule ID 20733 //
     /* 1410104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1410115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1410118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410143 */     // MIs[0] Operand 5
     /* 1410143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410154 */     // MIs[0] policy
     /* 1410154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410186 */     // GIR_Coverage, 20733,
     /* 1410186 */     GIR_EraseRootFromParent_Done,
     /* 1410187 */   // Label 19982: @1410187
     /* 1410187 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1410275), // Rule ID 20736 //
     /* 1410192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1410209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410231 */     // MIs[0] Operand 5
     /* 1410231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410242 */     // MIs[0] policy
     /* 1410242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410274 */     // GIR_Coverage, 20736,
     /* 1410274 */     GIR_EraseRootFromParent_Done,
     /* 1410275 */   // Label 19983: @1410275
     /* 1410275 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1410363), // Rule ID 20737 //
     /* 1410280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1410297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410319 */     // MIs[0] Operand 5
     /* 1410319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410330 */     // MIs[0] policy
     /* 1410330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410362 */     // GIR_Coverage, 20737,
     /* 1410362 */     GIR_EraseRootFromParent_Done,
     /* 1410363 */   // Label 19984: @1410363
     /* 1410363 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1410451), // Rule ID 20740 //
     /* 1410368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410407 */     // MIs[0] Operand 5
     /* 1410407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410418 */     // MIs[0] policy
     /* 1410418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410450 */     // GIR_Coverage, 20740,
     /* 1410450 */     GIR_EraseRootFromParent_Done,
     /* 1410451 */   // Label 19985: @1410451
     /* 1410451 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1410539), // Rule ID 20741 //
     /* 1410456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410495 */     // MIs[0] Operand 5
     /* 1410495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410506 */     // MIs[0] policy
     /* 1410506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410538 */     // GIR_Coverage, 20741,
     /* 1410538 */     GIR_EraseRootFromParent_Done,
     /* 1410539 */   // Label 19986: @1410539
     /* 1410539 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1410627), // Rule ID 20744 //
     /* 1410544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410583 */     // MIs[0] Operand 5
     /* 1410583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410594 */     // MIs[0] policy
     /* 1410594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410626 */     // GIR_Coverage, 20744,
     /* 1410626 */     GIR_EraseRootFromParent_Done,
     /* 1410627 */   // Label 19987: @1410627
     /* 1410627 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1410715), // Rule ID 20745 //
     /* 1410632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410671 */     // MIs[0] Operand 5
     /* 1410671 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410682 */     // MIs[0] policy
     /* 1410682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410714 */     // GIR_Coverage, 20745,
     /* 1410714 */     GIR_EraseRootFromParent_Done,
     /* 1410715 */   // Label 19988: @1410715
     /* 1410715 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1410803), // Rule ID 20748 //
     /* 1410720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410759 */     // MIs[0] Operand 5
     /* 1410759 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410770 */     // MIs[0] policy
     /* 1410770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410802 */     // GIR_Coverage, 20748,
     /* 1410802 */     GIR_EraseRootFromParent_Done,
     /* 1410803 */   // Label 19989: @1410803
     /* 1410803 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1410891), // Rule ID 20749 //
     /* 1410808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410847 */     // MIs[0] Operand 5
     /* 1410847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410858 */     // MIs[0] policy
     /* 1410858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410890 */     // GIR_Coverage, 20749,
     /* 1410890 */     GIR_EraseRootFromParent_Done,
     /* 1410891 */   // Label 19990: @1410891
     /* 1410891 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1410979), // Rule ID 20752 //
     /* 1410896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410935 */     // MIs[0] Operand 5
     /* 1410935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410946 */     // MIs[0] policy
     /* 1410946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410978 */     // GIR_Coverage, 20752,
     /* 1410978 */     GIR_EraseRootFromParent_Done,
     /* 1410979 */   // Label 19991: @1410979
     /* 1410979 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1411067), // Rule ID 20753 //
     /* 1410984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1411001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411023 */     // MIs[0] Operand 5
     /* 1411023 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411034 */     // MIs[0] policy
     /* 1411034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411066 */     // GIR_Coverage, 20753,
     /* 1411066 */     GIR_EraseRootFromParent_Done,
     /* 1411067 */   // Label 19992: @1411067
     /* 1411067 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1411155), // Rule ID 20756 //
     /* 1411072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1411075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411111 */     // MIs[0] Operand 5
     /* 1411111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411122 */     // MIs[0] policy
     /* 1411122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1411135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411154 */     // GIR_Coverage, 20756,
     /* 1411154 */     GIR_EraseRootFromParent_Done,
     /* 1411155 */   // Label 19993: @1411155
     /* 1411155 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1411243), // Rule ID 20757 //
     /* 1411160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1411163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1411168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1411177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411199 */     // MIs[0] Operand 5
     /* 1411199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411210 */     // MIs[0] policy
     /* 1411210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1411223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1411239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411242 */     // GIR_Coverage, 20757,
     /* 1411242 */     GIR_EraseRootFromParent_Done,
     /* 1411243 */   // Label 19994: @1411243
     /* 1411243 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1411331), // Rule ID 21116 //
     /* 1411248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411287 */     // MIs[0] Operand 5
     /* 1411287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411298 */     // MIs[0] policy
     /* 1411298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1411311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411330 */     // GIR_Coverage, 21116,
     /* 1411330 */     GIR_EraseRootFromParent_Done,
     /* 1411331 */   // Label 19995: @1411331
     /* 1411331 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1411419), // Rule ID 21117 //
     /* 1411336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411375 */     // MIs[0] Operand 5
     /* 1411375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411386 */     // MIs[0] policy
     /* 1411386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1411399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411418 */     // GIR_Coverage, 21117,
     /* 1411418 */     GIR_EraseRootFromParent_Done,
     /* 1411419 */   // Label 19996: @1411419
     /* 1411419 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1411507), // Rule ID 21120 //
     /* 1411424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411463 */     // MIs[0] Operand 5
     /* 1411463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411474 */     // MIs[0] policy
     /* 1411474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411506 */     // GIR_Coverage, 21120,
     /* 1411506 */     GIR_EraseRootFromParent_Done,
     /* 1411507 */   // Label 19997: @1411507
     /* 1411507 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1411595), // Rule ID 21121 //
     /* 1411512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411551 */     // MIs[0] Operand 5
     /* 1411551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411562 */     // MIs[0] policy
     /* 1411562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411594 */     // GIR_Coverage, 21121,
     /* 1411594 */     GIR_EraseRootFromParent_Done,
     /* 1411595 */   // Label 19998: @1411595
     /* 1411595 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1411683), // Rule ID 21124 //
     /* 1411600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411639 */     // MIs[0] Operand 5
     /* 1411639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411650 */     // MIs[0] policy
     /* 1411650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411682 */     // GIR_Coverage, 21124,
     /* 1411682 */     GIR_EraseRootFromParent_Done,
     /* 1411683 */   // Label 19999: @1411683
     /* 1411683 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1411771), // Rule ID 21125 //
     /* 1411688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411727 */     // MIs[0] Operand 5
     /* 1411727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411738 */     // MIs[0] policy
     /* 1411738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411770 */     // GIR_Coverage, 21125,
     /* 1411770 */     GIR_EraseRootFromParent_Done,
     /* 1411771 */   // Label 20000: @1411771
     /* 1411771 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1411859), // Rule ID 21128 //
     /* 1411776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411815 */     // MIs[0] Operand 5
     /* 1411815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411826 */     // MIs[0] policy
     /* 1411826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411858 */     // GIR_Coverage, 21128,
     /* 1411858 */     GIR_EraseRootFromParent_Done,
     /* 1411859 */   // Label 20001: @1411859
     /* 1411859 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1411947), // Rule ID 21129 //
     /* 1411864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411903 */     // MIs[0] Operand 5
     /* 1411903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411914 */     // MIs[0] policy
     /* 1411914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411946 */     // GIR_Coverage, 21129,
     /* 1411946 */     GIR_EraseRootFromParent_Done,
     /* 1411947 */   // Label 20002: @1411947
     /* 1411947 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1412035), // Rule ID 21132 //
     /* 1411952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411991 */     // MIs[0] Operand 5
     /* 1411991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412002 */     // MIs[0] policy
     /* 1412002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412034 */     // GIR_Coverage, 21132,
     /* 1412034 */     GIR_EraseRootFromParent_Done,
     /* 1412035 */   // Label 20003: @1412035
     /* 1412035 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1412123), // Rule ID 21133 //
     /* 1412040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1412051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1412054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1412057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1412060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412079 */     // MIs[0] Operand 5
     /* 1412079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412090 */     // MIs[0] policy
     /* 1412090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412122 */     // GIR_Coverage, 21133,
     /* 1412122 */     GIR_EraseRootFromParent_Done,
     /* 1412123 */   // Label 20004: @1412123
     /* 1412123 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1412211), // Rule ID 21136 //
     /* 1412128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412167 */     // MIs[0] Operand 5
     /* 1412167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412178 */     // MIs[0] policy
     /* 1412178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412210 */     // GIR_Coverage, 21136,
     /* 1412210 */     GIR_EraseRootFromParent_Done,
     /* 1412211 */   // Label 20005: @1412211
     /* 1412211 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1412299), // Rule ID 21137 //
     /* 1412216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1412227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1412230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412255 */     // MIs[0] Operand 5
     /* 1412255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412266 */     // MIs[0] policy
     /* 1412266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1412279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412298 */     // GIR_Coverage, 21137,
     /* 1412298 */     GIR_EraseRootFromParent_Done,
     /* 1412299 */   // Label 20006: @1412299
     /* 1412299 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1412387), // Rule ID 21140 //
     /* 1412304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412343 */     // MIs[0] Operand 5
     /* 1412343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412354 */     // MIs[0] policy
     /* 1412354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412386 */     // GIR_Coverage, 21140,
     /* 1412386 */     GIR_EraseRootFromParent_Done,
     /* 1412387 */   // Label 20007: @1412387
     /* 1412387 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1412475), // Rule ID 21141 //
     /* 1412392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1412403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1412406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412431 */     // MIs[0] Operand 5
     /* 1412431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412442 */     // MIs[0] policy
     /* 1412442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1412455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412474 */     // GIR_Coverage, 21141,
     /* 1412474 */     GIR_EraseRootFromParent_Done,
     /* 1412475 */   // Label 20008: @1412475
     /* 1412475 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1412563), // Rule ID 21144 //
     /* 1412480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412519 */     // MIs[0] Operand 5
     /* 1412519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412530 */     // MIs[0] policy
     /* 1412530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412562 */     // GIR_Coverage, 21144,
     /* 1412562 */     GIR_EraseRootFromParent_Done,
     /* 1412563 */   // Label 20009: @1412563
     /* 1412563 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1412651), // Rule ID 21145 //
     /* 1412568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412607 */     // MIs[0] Operand 5
     /* 1412607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412618 */     // MIs[0] policy
     /* 1412618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412650 */     // GIR_Coverage, 21145,
     /* 1412650 */     GIR_EraseRootFromParent_Done,
     /* 1412651 */   // Label 20010: @1412651
     /* 1412651 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1412739), // Rule ID 21148 //
     /* 1412656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412695 */     // MIs[0] Operand 5
     /* 1412695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412706 */     // MIs[0] policy
     /* 1412706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412738 */     // GIR_Coverage, 21148,
     /* 1412738 */     GIR_EraseRootFromParent_Done,
     /* 1412739 */   // Label 20011: @1412739
     /* 1412739 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1412827), // Rule ID 21149 //
     /* 1412744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412783 */     // MIs[0] Operand 5
     /* 1412783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412794 */     // MIs[0] policy
     /* 1412794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412826 */     // GIR_Coverage, 21149,
     /* 1412826 */     GIR_EraseRootFromParent_Done,
     /* 1412827 */   // Label 20012: @1412827
     /* 1412827 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1412915), // Rule ID 21152 //
     /* 1412832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412871 */     // MIs[0] Operand 5
     /* 1412871 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412882 */     // MIs[0] policy
     /* 1412882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412914 */     // GIR_Coverage, 21152,
     /* 1412914 */     GIR_EraseRootFromParent_Done,
     /* 1412915 */   // Label 20013: @1412915
     /* 1412915 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1413003), // Rule ID 21153 //
     /* 1412920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412959 */     // MIs[0] Operand 5
     /* 1412959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412970 */     // MIs[0] policy
     /* 1412970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413002 */     // GIR_Coverage, 21153,
     /* 1413002 */     GIR_EraseRootFromParent_Done,
     /* 1413003 */   // Label 20014: @1413003
     /* 1413003 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1413091), // Rule ID 21156 //
     /* 1413008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413047 */     // MIs[0] Operand 5
     /* 1413047 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413058 */     // MIs[0] policy
     /* 1413058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413090 */     // GIR_Coverage, 21156,
     /* 1413090 */     GIR_EraseRootFromParent_Done,
     /* 1413091 */   // Label 20015: @1413091
     /* 1413091 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1413179), // Rule ID 21157 //
     /* 1413096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413135 */     // MIs[0] Operand 5
     /* 1413135 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413146 */     // MIs[0] policy
     /* 1413146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413178 */     // GIR_Coverage, 21157,
     /* 1413178 */     GIR_EraseRootFromParent_Done,
     /* 1413179 */   // Label 20016: @1413179
     /* 1413179 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1413267), // Rule ID 21160 //
     /* 1413184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1413201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413223 */     // MIs[0] Operand 5
     /* 1413223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413234 */     // MIs[0] policy
     /* 1413234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413266 */     // GIR_Coverage, 21160,
     /* 1413266 */     GIR_EraseRootFromParent_Done,
     /* 1413267 */   // Label 20017: @1413267
     /* 1413267 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1413355), // Rule ID 21161 //
     /* 1413272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1413283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1413286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1413289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413311 */     // MIs[0] Operand 5
     /* 1413311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413322 */     // MIs[0] policy
     /* 1413322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413354 */     // GIR_Coverage, 21161,
     /* 1413354 */     GIR_EraseRootFromParent_Done,
     /* 1413355 */   // Label 20018: @1413355
     /* 1413355 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1413443), // Rule ID 21164 //
     /* 1413360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413399 */     // MIs[0] Operand 5
     /* 1413399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413410 */     // MIs[0] policy
     /* 1413410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413442 */     // GIR_Coverage, 21164,
     /* 1413442 */     GIR_EraseRootFromParent_Done,
     /* 1413443 */   // Label 20019: @1413443
     /* 1413443 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1413531), // Rule ID 21165 //
     /* 1413448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1413459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1413462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1413465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413487 */     // MIs[0] Operand 5
     /* 1413487 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413498 */     // MIs[0] policy
     /* 1413498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413530 */     // GIR_Coverage, 21165,
     /* 1413530 */     GIR_EraseRootFromParent_Done,
     /* 1413531 */   // Label 20020: @1413531
     /* 1413531 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1413619), // Rule ID 21168 //
     /* 1413536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413575 */     // MIs[0] Operand 5
     /* 1413575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413586 */     // MIs[0] policy
     /* 1413586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413618 */     // GIR_Coverage, 21168,
     /* 1413618 */     GIR_EraseRootFromParent_Done,
     /* 1413619 */   // Label 20021: @1413619
     /* 1413619 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1413707), // Rule ID 21169 //
     /* 1413624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413663 */     // MIs[0] Operand 5
     /* 1413663 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413674 */     // MIs[0] policy
     /* 1413674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413706 */     // GIR_Coverage, 21169,
     /* 1413706 */     GIR_EraseRootFromParent_Done,
     /* 1413707 */   // Label 20022: @1413707
     /* 1413707 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1413795), // Rule ID 21172 //
     /* 1413712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413751 */     // MIs[0] Operand 5
     /* 1413751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413762 */     // MIs[0] policy
     /* 1413762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413794 */     // GIR_Coverage, 21172,
     /* 1413794 */     GIR_EraseRootFromParent_Done,
     /* 1413795 */   // Label 20023: @1413795
     /* 1413795 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1413883), // Rule ID 21173 //
     /* 1413800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413839 */     // MIs[0] Operand 5
     /* 1413839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413850 */     // MIs[0] policy
     /* 1413850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413882 */     // GIR_Coverage, 21173,
     /* 1413882 */     GIR_EraseRootFromParent_Done,
     /* 1413883 */   // Label 20024: @1413883
     /* 1413883 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1413971), // Rule ID 21176 //
     /* 1413888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413927 */     // MIs[0] Operand 5
     /* 1413927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413938 */     // MIs[0] policy
     /* 1413938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413970 */     // GIR_Coverage, 21176,
     /* 1413970 */     GIR_EraseRootFromParent_Done,
     /* 1413971 */   // Label 20025: @1413971
     /* 1413971 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1414059), // Rule ID 21177 //
     /* 1413976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414015 */     // MIs[0] Operand 5
     /* 1414015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414026 */     // MIs[0] policy
     /* 1414026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1414039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414058 */     // GIR_Coverage, 21177,
     /* 1414058 */     GIR_EraseRootFromParent_Done,
     /* 1414059 */   // Label 20026: @1414059
     /* 1414059 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1414147), // Rule ID 21180 //
     /* 1414064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1414067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1414081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414103 */     // MIs[0] Operand 5
     /* 1414103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414114 */     // MIs[0] policy
     /* 1414114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1414127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414146 */     // GIR_Coverage, 21180,
     /* 1414146 */     GIR_EraseRootFromParent_Done,
     /* 1414147 */   // Label 20027: @1414147
     /* 1414147 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1414235), // Rule ID 21181 //
     /* 1414152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1414155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1414163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1414166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1414169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414191 */     // MIs[0] Operand 5
     /* 1414191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414202 */     // MIs[0] policy
     /* 1414202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1414215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414234 */     // GIR_Coverage, 21181,
     /* 1414234 */     GIR_EraseRootFromParent_Done,
     /* 1414235 */   // Label 20028: @1414235
     /* 1414235 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1414323), // Rule ID 21184 //
     /* 1414240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1414243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1414257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414279 */     // MIs[0] Operand 5
     /* 1414279 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414290 */     // MIs[0] policy
     /* 1414290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414300 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1414303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414322 */     // GIR_Coverage, 21184,
     /* 1414322 */     GIR_EraseRootFromParent_Done,
     /* 1414323 */   // Label 20029: @1414323
     /* 1414323 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1414411), // Rule ID 21185 //
     /* 1414328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1414331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1414336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1414339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1414342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1414345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1414355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414367 */     // MIs[0] Operand 5
     /* 1414367 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414378 */     // MIs[0] policy
     /* 1414378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414388 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1414391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414410 */     // GIR_Coverage, 21185,
     /* 1414410 */     GIR_EraseRootFromParent_Done,
     /* 1414411 */   // Label 20030: @1414411
     /* 1414411 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1414499), // Rule ID 21488 //
     /* 1414416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414455 */     // MIs[0] Operand 5
     /* 1414455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414466 */     // MIs[0] policy
     /* 1414466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414498 */     // GIR_Coverage, 21488,
     /* 1414498 */     GIR_EraseRootFromParent_Done,
     /* 1414499 */   // Label 20031: @1414499
     /* 1414499 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1414587), // Rule ID 21489 //
     /* 1414504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414543 */     // MIs[0] Operand 5
     /* 1414543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414554 */     // MIs[0] policy
     /* 1414554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414586 */     // GIR_Coverage, 21489,
     /* 1414586 */     GIR_EraseRootFromParent_Done,
     /* 1414587 */   // Label 20032: @1414587
     /* 1414587 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1414675), // Rule ID 21492 //
     /* 1414592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414631 */     // MIs[0] Operand 5
     /* 1414631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414642 */     // MIs[0] policy
     /* 1414642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414652 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414674 */     // GIR_Coverage, 21492,
     /* 1414674 */     GIR_EraseRootFromParent_Done,
     /* 1414675 */   // Label 20033: @1414675
     /* 1414675 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1414763), // Rule ID 21493 //
     /* 1414680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414719 */     // MIs[0] Operand 5
     /* 1414719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414730 */     // MIs[0] policy
     /* 1414730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414740 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414762 */     // GIR_Coverage, 21493,
     /* 1414762 */     GIR_EraseRootFromParent_Done,
     /* 1414763 */   // Label 20034: @1414763
     /* 1414763 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1414851), // Rule ID 21496 //
     /* 1414768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414807 */     // MIs[0] Operand 5
     /* 1414807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414818 */     // MIs[0] policy
     /* 1414818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414850 */     // GIR_Coverage, 21496,
     /* 1414850 */     GIR_EraseRootFromParent_Done,
     /* 1414851 */   // Label 20035: @1414851
     /* 1414851 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1414939), // Rule ID 21497 //
     /* 1414856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414895 */     // MIs[0] Operand 5
     /* 1414895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414906 */     // MIs[0] policy
     /* 1414906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414938 */     // GIR_Coverage, 21497,
     /* 1414938 */     GIR_EraseRootFromParent_Done,
     /* 1414939 */   // Label 20036: @1414939
     /* 1414939 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1415027), // Rule ID 21500 //
     /* 1414944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414983 */     // MIs[0] Operand 5
     /* 1414983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414994 */     // MIs[0] policy
     /* 1414994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415026 */     // GIR_Coverage, 21500,
     /* 1415026 */     GIR_EraseRootFromParent_Done,
     /* 1415027 */   // Label 20037: @1415027
     /* 1415027 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1415115), // Rule ID 21501 //
     /* 1415032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1415043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1415046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415071 */     // MIs[0] Operand 5
     /* 1415071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415082 */     // MIs[0] policy
     /* 1415082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415114 */     // GIR_Coverage, 21501,
     /* 1415114 */     GIR_EraseRootFromParent_Done,
     /* 1415115 */   // Label 20038: @1415115
     /* 1415115 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1415203), // Rule ID 21504 //
     /* 1415120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415159 */     // MIs[0] Operand 5
     /* 1415159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415170 */     // MIs[0] policy
     /* 1415170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415202 */     // GIR_Coverage, 21504,
     /* 1415202 */     GIR_EraseRootFromParent_Done,
     /* 1415203 */   // Label 20039: @1415203
     /* 1415203 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1415291), // Rule ID 21505 //
     /* 1415208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415247 */     // MIs[0] Operand 5
     /* 1415247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415258 */     // MIs[0] policy
     /* 1415258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415290 */     // GIR_Coverage, 21505,
     /* 1415290 */     GIR_EraseRootFromParent_Done,
     /* 1415291 */   // Label 20040: @1415291
     /* 1415291 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1415379), // Rule ID 21508 //
     /* 1415296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415335 */     // MIs[0] Operand 5
     /* 1415335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415346 */     // MIs[0] policy
     /* 1415346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415378 */     // GIR_Coverage, 21508,
     /* 1415378 */     GIR_EraseRootFromParent_Done,
     /* 1415379 */   // Label 20041: @1415379
     /* 1415379 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1415467), // Rule ID 21509 //
     /* 1415384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415423 */     // MIs[0] Operand 5
     /* 1415423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415434 */     // MIs[0] policy
     /* 1415434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415466 */     // GIR_Coverage, 21509,
     /* 1415466 */     GIR_EraseRootFromParent_Done,
     /* 1415467 */   // Label 20042: @1415467
     /* 1415467 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1415555), // Rule ID 21512 //
     /* 1415472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415511 */     // MIs[0] Operand 5
     /* 1415511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415522 */     // MIs[0] policy
     /* 1415522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415554 */     // GIR_Coverage, 21512,
     /* 1415554 */     GIR_EraseRootFromParent_Done,
     /* 1415555 */   // Label 20043: @1415555
     /* 1415555 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1415643), // Rule ID 21513 //
     /* 1415560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415599 */     // MIs[0] Operand 5
     /* 1415599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415610 */     // MIs[0] policy
     /* 1415610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415642 */     // GIR_Coverage, 21513,
     /* 1415642 */     GIR_EraseRootFromParent_Done,
     /* 1415643 */   // Label 20044: @1415643
     /* 1415643 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1415731), // Rule ID 21516 //
     /* 1415648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415687 */     // MIs[0] Operand 5
     /* 1415687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415698 */     // MIs[0] policy
     /* 1415698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415708 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415730 */     // GIR_Coverage, 21516,
     /* 1415730 */     GIR_EraseRootFromParent_Done,
     /* 1415731 */   // Label 20045: @1415731
     /* 1415731 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1415819), // Rule ID 21517 //
     /* 1415736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415775 */     // MIs[0] Operand 5
     /* 1415775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415786 */     // MIs[0] policy
     /* 1415786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415818 */     // GIR_Coverage, 21517,
     /* 1415818 */     GIR_EraseRootFromParent_Done,
     /* 1415819 */   // Label 20046: @1415819
     /* 1415819 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1415907), // Rule ID 21520 //
     /* 1415824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415863 */     // MIs[0] Operand 5
     /* 1415863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415874 */     // MIs[0] policy
     /* 1415874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415906 */     // GIR_Coverage, 21520,
     /* 1415906 */     GIR_EraseRootFromParent_Done,
     /* 1415907 */   // Label 20047: @1415907
     /* 1415907 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1415995), // Rule ID 21521 //
     /* 1415912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415951 */     // MIs[0] Operand 5
     /* 1415951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415962 */     // MIs[0] policy
     /* 1415962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415994 */     // GIR_Coverage, 21521,
     /* 1415994 */     GIR_EraseRootFromParent_Done,
     /* 1415995 */   // Label 20048: @1415995
     /* 1415995 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1416083), // Rule ID 21524 //
     /* 1416000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1416003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416039 */     // MIs[0] Operand 5
     /* 1416039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416050 */     // MIs[0] policy
     /* 1416050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416082 */     // GIR_Coverage, 21524,
     /* 1416082 */     GIR_EraseRootFromParent_Done,
     /* 1416083 */   // Label 20049: @1416083
     /* 1416083 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1416171), // Rule ID 21525 //
     /* 1416088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416127 */     // MIs[0] Operand 5
     /* 1416127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416138 */     // MIs[0] policy
     /* 1416138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416170 */     // GIR_Coverage, 21525,
     /* 1416170 */     GIR_EraseRootFromParent_Done,
     /* 1416171 */   // Label 20050: @1416171
     /* 1416171 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1416259), // Rule ID 21528 //
     /* 1416176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1416179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416215 */     // MIs[0] Operand 5
     /* 1416215 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416226 */     // MIs[0] policy
     /* 1416226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416258 */     // GIR_Coverage, 21528,
     /* 1416258 */     GIR_EraseRootFromParent_Done,
     /* 1416259 */   // Label 20051: @1416259
     /* 1416259 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1416347), // Rule ID 21529 //
     /* 1416264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416303 */     // MIs[0] Operand 5
     /* 1416303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416314 */     // MIs[0] policy
     /* 1416314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416346 */     // GIR_Coverage, 21529,
     /* 1416346 */     GIR_EraseRootFromParent_Done,
     /* 1416347 */   // Label 20052: @1416347
     /* 1416347 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1416435), // Rule ID 21532 //
     /* 1416352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416391 */     // MIs[0] Operand 5
     /* 1416391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416402 */     // MIs[0] policy
     /* 1416402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416434 */     // GIR_Coverage, 21532,
     /* 1416434 */     GIR_EraseRootFromParent_Done,
     /* 1416435 */   // Label 20053: @1416435
     /* 1416435 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1416523), // Rule ID 21533 //
     /* 1416440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416479 */     // MIs[0] Operand 5
     /* 1416479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416490 */     // MIs[0] policy
     /* 1416490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416522 */     // GIR_Coverage, 21533,
     /* 1416522 */     GIR_EraseRootFromParent_Done,
     /* 1416523 */   // Label 20054: @1416523
     /* 1416523 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1416611), // Rule ID 21536 //
     /* 1416528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416567 */     // MIs[0] Operand 5
     /* 1416567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416578 */     // MIs[0] policy
     /* 1416578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416610 */     // GIR_Coverage, 21536,
     /* 1416610 */     GIR_EraseRootFromParent_Done,
     /* 1416611 */   // Label 20055: @1416611
     /* 1416611 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1416699), // Rule ID 21537 //
     /* 1416616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416655 */     // MIs[0] Operand 5
     /* 1416655 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416666 */     // MIs[0] policy
     /* 1416666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416698 */     // GIR_Coverage, 21537,
     /* 1416698 */     GIR_EraseRootFromParent_Done,
     /* 1416699 */   // Label 20056: @1416699
     /* 1416699 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1416787), // Rule ID 21540 //
     /* 1416704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416743 */     // MIs[0] Operand 5
     /* 1416743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416754 */     // MIs[0] policy
     /* 1416754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416786 */     // GIR_Coverage, 21540,
     /* 1416786 */     GIR_EraseRootFromParent_Done,
     /* 1416787 */   // Label 20057: @1416787
     /* 1416787 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1416875), // Rule ID 21541 //
     /* 1416792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416831 */     // MIs[0] Operand 5
     /* 1416831 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416842 */     // MIs[0] policy
     /* 1416842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416874 */     // GIR_Coverage, 21541,
     /* 1416874 */     GIR_EraseRootFromParent_Done,
     /* 1416875 */   // Label 20058: @1416875
     /* 1416875 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1416963), // Rule ID 21544 //
     /* 1416880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416919 */     // MIs[0] Operand 5
     /* 1416919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416930 */     // MIs[0] policy
     /* 1416930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416962 */     // GIR_Coverage, 21544,
     /* 1416962 */     GIR_EraseRootFromParent_Done,
     /* 1416963 */   // Label 20059: @1416963
     /* 1416963 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1417051), // Rule ID 21545 //
     /* 1416968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417007 */     // MIs[0] Operand 5
     /* 1417007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417018 */     // MIs[0] policy
     /* 1417018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1417031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1417047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417050 */     // GIR_Coverage, 21545,
     /* 1417050 */     GIR_EraseRootFromParent_Done,
     /* 1417051 */   // Label 20060: @1417051
     /* 1417051 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1417139), // Rule ID 21548 //
     /* 1417056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417095 */     // MIs[0] Operand 5
     /* 1417095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417106 */     // MIs[0] policy
     /* 1417106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1417119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417138 */     // GIR_Coverage, 21548,
     /* 1417138 */     GIR_EraseRootFromParent_Done,
     /* 1417139 */   // Label 20061: @1417139
     /* 1417139 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1417227), // Rule ID 21549 //
     /* 1417144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417183 */     // MIs[0] Operand 5
     /* 1417183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417194 */     // MIs[0] policy
     /* 1417194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417204 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1417207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417226 */     // GIR_Coverage, 21549,
     /* 1417226 */     GIR_EraseRootFromParent_Done,
     /* 1417227 */   // Label 20062: @1417227
     /* 1417227 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1417315), // Rule ID 21552 //
     /* 1417232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417271 */     // MIs[0] Operand 5
     /* 1417271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417282 */     // MIs[0] policy
     /* 1417282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417314 */     // GIR_Coverage, 21552,
     /* 1417314 */     GIR_EraseRootFromParent_Done,
     /* 1417315 */   // Label 20063: @1417315
     /* 1417315 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1417403), // Rule ID 21553 //
     /* 1417320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417359 */     // MIs[0] Operand 5
     /* 1417359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417370 */     // MIs[0] policy
     /* 1417370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417402 */     // GIR_Coverage, 21553,
     /* 1417402 */     GIR_EraseRootFromParent_Done,
     /* 1417403 */   // Label 20064: @1417403
     /* 1417403 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1417491), // Rule ID 21556 //
     /* 1417408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417447 */     // MIs[0] Operand 5
     /* 1417447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417458 */     // MIs[0] policy
     /* 1417458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417468 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417490 */     // GIR_Coverage, 21556,
     /* 1417490 */     GIR_EraseRootFromParent_Done,
     /* 1417491 */   // Label 20065: @1417491
     /* 1417491 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1417579), // Rule ID 21557 //
     /* 1417496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417535 */     // MIs[0] Operand 5
     /* 1417535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417546 */     // MIs[0] policy
     /* 1417546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417578 */     // GIR_Coverage, 21557,
     /* 1417578 */     GIR_EraseRootFromParent_Done,
     /* 1417579 */   // Label 20066: @1417579
     /* 1417579 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1417667), // Rule ID 21560 //
     /* 1417584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417623 */     // MIs[0] Operand 5
     /* 1417623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417634 */     // MIs[0] policy
     /* 1417634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417666 */     // GIR_Coverage, 21560,
     /* 1417666 */     GIR_EraseRootFromParent_Done,
     /* 1417667 */   // Label 20067: @1417667
     /* 1417667 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1417755), // Rule ID 21561 //
     /* 1417672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417711 */     // MIs[0] Operand 5
     /* 1417711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417722 */     // MIs[0] policy
     /* 1417722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417754 */     // GIR_Coverage, 21561,
     /* 1417754 */     GIR_EraseRootFromParent_Done,
     /* 1417755 */   // Label 20068: @1417755
     /* 1417755 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1417843), // Rule ID 21564 //
     /* 1417760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417799 */     // MIs[0] Operand 5
     /* 1417799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417810 */     // MIs[0] policy
     /* 1417810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417842 */     // GIR_Coverage, 21564,
     /* 1417842 */     GIR_EraseRootFromParent_Done,
     /* 1417843 */   // Label 20069: @1417843
     /* 1417843 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1417931), // Rule ID 21565 //
     /* 1417848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417887 */     // MIs[0] Operand 5
     /* 1417887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417898 */     // MIs[0] policy
     /* 1417898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417930 */     // GIR_Coverage, 21565,
     /* 1417930 */     GIR_EraseRootFromParent_Done,
     /* 1417931 */   // Label 20070: @1417931
     /* 1417931 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1418019), // Rule ID 21568 //
     /* 1417936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417975 */     // MIs[0] Operand 5
     /* 1417975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417986 */     // MIs[0] policy
     /* 1417986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1417999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418018 */     // GIR_Coverage, 21568,
     /* 1418018 */     GIR_EraseRootFromParent_Done,
     /* 1418019 */   // Label 20071: @1418019
     /* 1418019 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1418107), // Rule ID 21569 //
     /* 1418024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1418027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1418035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1418038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1418041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1418044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418063 */     // MIs[0] Operand 5
     /* 1418063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418074 */     // MIs[0] policy
     /* 1418074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418106 */     // GIR_Coverage, 21569,
     /* 1418106 */     GIR_EraseRootFromParent_Done,
     /* 1418107 */   // Label 20072: @1418107
     /* 1418107 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1418195), // Rule ID 21572 //
     /* 1418112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418151 */     // MIs[0] Operand 5
     /* 1418151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418162 */     // MIs[0] policy
     /* 1418162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1418175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418194 */     // GIR_Coverage, 21572,
     /* 1418194 */     GIR_EraseRootFromParent_Done,
     /* 1418195 */   // Label 20073: @1418195
     /* 1418195 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1418283), // Rule ID 21573 //
     /* 1418200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1418211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1418214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418239 */     // MIs[0] Operand 5
     /* 1418239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418250 */     // MIs[0] policy
     /* 1418250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1418263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418282 */     // GIR_Coverage, 21573,
     /* 1418282 */     GIR_EraseRootFromParent_Done,
     /* 1418283 */   // Label 20074: @1418283
     /* 1418283 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1418371), // Rule ID 21576 //
     /* 1418288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418327 */     // MIs[0] Operand 5
     /* 1418327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418338 */     // MIs[0] policy
     /* 1418338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418370 */     // GIR_Coverage, 21576,
     /* 1418370 */     GIR_EraseRootFromParent_Done,
     /* 1418371 */   // Label 20075: @1418371
     /* 1418371 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1418459), // Rule ID 21577 //
     /* 1418376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1418387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1418390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418415 */     // MIs[0] Operand 5
     /* 1418415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418426 */     // MIs[0] policy
     /* 1418426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418458 */     // GIR_Coverage, 21577,
     /* 1418458 */     GIR_EraseRootFromParent_Done,
     /* 1418459 */   // Label 20076: @1418459
     /* 1418459 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1418547), // Rule ID 21580 //
     /* 1418464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418503 */     // MIs[0] Operand 5
     /* 1418503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418514 */     // MIs[0] policy
     /* 1418514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418546 */     // GIR_Coverage, 21580,
     /* 1418546 */     GIR_EraseRootFromParent_Done,
     /* 1418547 */   // Label 20077: @1418547
     /* 1418547 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1418635), // Rule ID 21581 //
     /* 1418552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418591 */     // MIs[0] Operand 5
     /* 1418591 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418602 */     // MIs[0] policy
     /* 1418602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418634 */     // GIR_Coverage, 21581,
     /* 1418634 */     GIR_EraseRootFromParent_Done,
     /* 1418635 */   // Label 20078: @1418635
     /* 1418635 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1418723), // Rule ID 21584 //
     /* 1418640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418679 */     // MIs[0] Operand 5
     /* 1418679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418690 */     // MIs[0] policy
     /* 1418690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418722 */     // GIR_Coverage, 21584,
     /* 1418722 */     GIR_EraseRootFromParent_Done,
     /* 1418723 */   // Label 20079: @1418723
     /* 1418723 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1418811), // Rule ID 21585 //
     /* 1418728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418767 */     // MIs[0] Operand 5
     /* 1418767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418778 */     // MIs[0] policy
     /* 1418778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418810 */     // GIR_Coverage, 21585,
     /* 1418810 */     GIR_EraseRootFromParent_Done,
     /* 1418811 */   // Label 20080: @1418811
     /* 1418811 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1418899), // Rule ID 21588 //
     /* 1418816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418855 */     // MIs[0] Operand 5
     /* 1418855 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418866 */     // MIs[0] policy
     /* 1418866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418898 */     // GIR_Coverage, 21588,
     /* 1418898 */     GIR_EraseRootFromParent_Done,
     /* 1418899 */   // Label 20081: @1418899
     /* 1418899 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1418987), // Rule ID 21589 //
     /* 1418904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418943 */     // MIs[0] Operand 5
     /* 1418943 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418954 */     // MIs[0] policy
     /* 1418954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418986 */     // GIR_Coverage, 21589,
     /* 1418986 */     GIR_EraseRootFromParent_Done,
     /* 1418987 */   // Label 20082: @1418987
     /* 1418987 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1419075), // Rule ID 21592 //
     /* 1418992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419031 */     // MIs[0] Operand 5
     /* 1419031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419042 */     // MIs[0] policy
     /* 1419042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1419055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419074 */     // GIR_Coverage, 21592,
     /* 1419074 */     GIR_EraseRootFromParent_Done,
     /* 1419075 */   // Label 20083: @1419075
     /* 1419075 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1419163), // Rule ID 21593 //
     /* 1419080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1419091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1419094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1419097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1419100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419119 */     // MIs[0] Operand 5
     /* 1419119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419130 */     // MIs[0] policy
     /* 1419130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1419143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419162 */     // GIR_Coverage, 21593,
     /* 1419162 */     GIR_EraseRootFromParent_Done,
     /* 1419163 */   // Label 20084: @1419163
     /* 1419163 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1419251), // Rule ID 21596 //
     /* 1419168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1419179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1419182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1419185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419207 */     // MIs[0] Operand 5
     /* 1419207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419218 */     // MIs[0] policy
     /* 1419218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1419231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419250 */     // GIR_Coverage, 21596,
     /* 1419250 */     GIR_EraseRootFromParent_Done,
     /* 1419251 */   // Label 20085: @1419251
     /* 1419251 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1419339), // Rule ID 21597 //
     /* 1419256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1419267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1419270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1419273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1419276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419295 */     // MIs[0] Operand 5
     /* 1419295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419306 */     // MIs[0] policy
     /* 1419306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1419319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419338 */     // GIR_Coverage, 21597,
     /* 1419338 */     GIR_EraseRootFromParent_Done,
     /* 1419339 */   // Label 20086: @1419339
     /* 1419339 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1419427), // Rule ID 21600 //
     /* 1419344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1419361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419383 */     // MIs[0] Operand 5
     /* 1419383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419394 */     // MIs[0] policy
     /* 1419394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419426 */     // GIR_Coverage, 21600,
     /* 1419426 */     GIR_EraseRootFromParent_Done,
     /* 1419427 */   // Label 20087: @1419427
     /* 1419427 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1419515), // Rule ID 21601 //
     /* 1419432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1419443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1419446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1419449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1419452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419471 */     // MIs[0] Operand 5
     /* 1419471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419482 */     // MIs[0] policy
     /* 1419482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419514 */     // GIR_Coverage, 21601,
     /* 1419514 */     GIR_EraseRootFromParent_Done,
     /* 1419515 */   // Label 20088: @1419515
     /* 1419515 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1419603), // Rule ID 21604 //
     /* 1419520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419559 */     // MIs[0] Operand 5
     /* 1419559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419570 */     // MIs[0] policy
     /* 1419570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419602 */     // GIR_Coverage, 21604,
     /* 1419602 */     GIR_EraseRootFromParent_Done,
     /* 1419603 */   // Label 20089: @1419603
     /* 1419603 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1419691), // Rule ID 21605 //
     /* 1419608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419647 */     // MIs[0] Operand 5
     /* 1419647 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419658 */     // MIs[0] policy
     /* 1419658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419690 */     // GIR_Coverage, 21605,
     /* 1419690 */     GIR_EraseRootFromParent_Done,
     /* 1419691 */   // Label 20090: @1419691
     /* 1419691 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1419790), // Rule ID 2802 //
     /* 1419696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419746 */     // MIs[1] Operand 1
     /* 1419746 */     // No operand predicates
     /* 1419746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419750 */     // MIs[0] policy
     /* 1419750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419771 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419789 */     // GIR_Coverage, 2802,
     /* 1419789 */     GIR_EraseRootFromParent_Done,
     /* 1419790 */   // Label 20091: @1419790
     /* 1419790 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1419889), // Rule ID 2803 //
     /* 1419795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419845 */     // MIs[1] Operand 1
     /* 1419845 */     // No operand predicates
     /* 1419845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419849 */     // MIs[0] policy
     /* 1419849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419861 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419870 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419888 */     // GIR_Coverage, 2803,
     /* 1419888 */     GIR_EraseRootFromParent_Done,
     /* 1419889 */   // Label 20092: @1419889
     /* 1419889 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1419988), // Rule ID 2810 //
     /* 1419894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419944 */     // MIs[1] Operand 1
     /* 1419944 */     // No operand predicates
     /* 1419944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419948 */     // MIs[0] policy
     /* 1419948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419987 */     // GIR_Coverage, 2810,
     /* 1419987 */     GIR_EraseRootFromParent_Done,
     /* 1419988 */   // Label 20093: @1419988
     /* 1419988 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1420087), // Rule ID 2811 //
     /* 1419993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1420004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1420007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1420010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420043 */     // MIs[1] Operand 1
     /* 1420043 */     // No operand predicates
     /* 1420043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420047 */     // MIs[0] policy
     /* 1420047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420059 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420068 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420086 */     // GIR_Coverage, 2811,
     /* 1420086 */     GIR_EraseRootFromParent_Done,
     /* 1420087 */   // Label 20094: @1420087
     /* 1420087 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1420186), // Rule ID 2818 //
     /* 1420092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1420109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420142 */     // MIs[1] Operand 1
     /* 1420142 */     // No operand predicates
     /* 1420142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420146 */     // MIs[0] policy
     /* 1420146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420167 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420185 */     // GIR_Coverage, 2818,
     /* 1420185 */     GIR_EraseRootFromParent_Done,
     /* 1420186 */   // Label 20095: @1420186
     /* 1420186 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1420285), // Rule ID 2819 //
     /* 1420191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1420202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1420205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1420208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420241 */     // MIs[1] Operand 1
     /* 1420241 */     // No operand predicates
     /* 1420241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420245 */     // MIs[0] policy
     /* 1420245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420257 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420266 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420284 */     // GIR_Coverage, 2819,
     /* 1420284 */     GIR_EraseRootFromParent_Done,
     /* 1420285 */   // Label 20096: @1420285
     /* 1420285 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1420384), // Rule ID 2826 //
     /* 1420290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420340 */     // MIs[1] Operand 1
     /* 1420340 */     // No operand predicates
     /* 1420340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420344 */     // MIs[0] policy
     /* 1420344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420365 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420383 */     // GIR_Coverage, 2826,
     /* 1420383 */     GIR_EraseRootFromParent_Done,
     /* 1420384 */   // Label 20097: @1420384
     /* 1420384 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1420483), // Rule ID 2827 //
     /* 1420389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1420400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1420403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1420406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420439 */     // MIs[1] Operand 1
     /* 1420439 */     // No operand predicates
     /* 1420439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420443 */     // MIs[0] policy
     /* 1420443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420455 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1420458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420464 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420482 */     // GIR_Coverage, 2827,
     /* 1420482 */     GIR_EraseRootFromParent_Done,
     /* 1420483 */   // Label 20098: @1420483
     /* 1420483 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1420582), // Rule ID 2834 //
     /* 1420488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420538 */     // MIs[1] Operand 1
     /* 1420538 */     // No operand predicates
     /* 1420538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420542 */     // MIs[0] policy
     /* 1420542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420554 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420563 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420581 */     // GIR_Coverage, 2834,
     /* 1420581 */     GIR_EraseRootFromParent_Done,
     /* 1420582 */   // Label 20099: @1420582
     /* 1420582 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1420681), // Rule ID 2835 //
     /* 1420587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420637 */     // MIs[1] Operand 1
     /* 1420637 */     // No operand predicates
     /* 1420637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420641 */     // MIs[0] policy
     /* 1420641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420653 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420662 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420680 */     // GIR_Coverage, 2835,
     /* 1420680 */     GIR_EraseRootFromParent_Done,
     /* 1420681 */   // Label 20100: @1420681
     /* 1420681 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1420780), // Rule ID 2842 //
     /* 1420686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420736 */     // MIs[1] Operand 1
     /* 1420736 */     // No operand predicates
     /* 1420736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420740 */     // MIs[0] policy
     /* 1420740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420761 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420779 */     // GIR_Coverage, 2842,
     /* 1420779 */     GIR_EraseRootFromParent_Done,
     /* 1420780 */   // Label 20101: @1420780
     /* 1420780 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1420879), // Rule ID 2843 //
     /* 1420785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420835 */     // MIs[1] Operand 1
     /* 1420835 */     // No operand predicates
     /* 1420835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420839 */     // MIs[0] policy
     /* 1420839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420860 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420878 */     // GIR_Coverage, 2843,
     /* 1420878 */     GIR_EraseRootFromParent_Done,
     /* 1420879 */   // Label 20102: @1420879
     /* 1420879 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1420978), // Rule ID 2850 //
     /* 1420884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420934 */     // MIs[1] Operand 1
     /* 1420934 */     // No operand predicates
     /* 1420934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420938 */     // MIs[0] policy
     /* 1420938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420959 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420977 */     // GIR_Coverage, 2850,
     /* 1420977 */     GIR_EraseRootFromParent_Done,
     /* 1420978 */   // Label 20103: @1420978
     /* 1420978 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1421077), // Rule ID 2851 //
     /* 1420983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1421000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421033 */     // MIs[1] Operand 1
     /* 1421033 */     // No operand predicates
     /* 1421033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421037 */     // MIs[0] policy
     /* 1421037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421049 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421058 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421076 */     // GIR_Coverage, 2851,
     /* 1421076 */     GIR_EraseRootFromParent_Done,
     /* 1421077 */   // Label 20104: @1421077
     /* 1421077 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1421176), // Rule ID 2858 //
     /* 1421082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421132 */     // MIs[1] Operand 1
     /* 1421132 */     // No operand predicates
     /* 1421132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421136 */     // MIs[0] policy
     /* 1421136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421157 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421175 */     // GIR_Coverage, 2858,
     /* 1421175 */     GIR_EraseRootFromParent_Done,
     /* 1421176 */   // Label 20105: @1421176
     /* 1421176 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1421275), // Rule ID 2859 //
     /* 1421181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1421192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1421195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1421198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421231 */     // MIs[1] Operand 1
     /* 1421231 */     // No operand predicates
     /* 1421231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421235 */     // MIs[0] policy
     /* 1421235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421247 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421256 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421274 */     // GIR_Coverage, 2859,
     /* 1421274 */     GIR_EraseRootFromParent_Done,
     /* 1421275 */   // Label 20106: @1421275
     /* 1421275 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1421374), // Rule ID 2866 //
     /* 1421280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421330 */     // MIs[1] Operand 1
     /* 1421330 */     // No operand predicates
     /* 1421330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421334 */     // MIs[0] policy
     /* 1421334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421355 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421373 */     // GIR_Coverage, 2866,
     /* 1421373 */     GIR_EraseRootFromParent_Done,
     /* 1421374 */   // Label 20107: @1421374
     /* 1421374 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1421473), // Rule ID 2867 //
     /* 1421379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1421390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1421393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1421396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421429 */     // MIs[1] Operand 1
     /* 1421429 */     // No operand predicates
     /* 1421429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421433 */     // MIs[0] policy
     /* 1421433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421454 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421472 */     // GIR_Coverage, 2867,
     /* 1421472 */     GIR_EraseRootFromParent_Done,
     /* 1421473 */   // Label 20108: @1421473
     /* 1421473 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1421572), // Rule ID 2874 //
     /* 1421478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421528 */     // MIs[1] Operand 1
     /* 1421528 */     // No operand predicates
     /* 1421528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421532 */     // MIs[0] policy
     /* 1421532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421553 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421571 */     // GIR_Coverage, 2874,
     /* 1421571 */     GIR_EraseRootFromParent_Done,
     /* 1421572 */   // Label 20109: @1421572
     /* 1421572 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1421671), // Rule ID 2875 //
     /* 1421577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421627 */     // MIs[1] Operand 1
     /* 1421627 */     // No operand predicates
     /* 1421627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421631 */     // MIs[0] policy
     /* 1421631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421652 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421670 */     // GIR_Coverage, 2875,
     /* 1421670 */     GIR_EraseRootFromParent_Done,
     /* 1421671 */   // Label 20110: @1421671
     /* 1421671 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1421770), // Rule ID 2882 //
     /* 1421676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421726 */     // MIs[1] Operand 1
     /* 1421726 */     // No operand predicates
     /* 1421726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421730 */     // MIs[0] policy
     /* 1421730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421742 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421751 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421769 */     // GIR_Coverage, 2882,
     /* 1421769 */     GIR_EraseRootFromParent_Done,
     /* 1421770 */   // Label 20111: @1421770
     /* 1421770 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1421869), // Rule ID 2883 //
     /* 1421775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421825 */     // MIs[1] Operand 1
     /* 1421825 */     // No operand predicates
     /* 1421825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421829 */     // MIs[0] policy
     /* 1421829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421850 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421868 */     // GIR_Coverage, 2883,
     /* 1421868 */     GIR_EraseRootFromParent_Done,
     /* 1421869 */   // Label 20112: @1421869
     /* 1421869 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1421968), // Rule ID 2890 //
     /* 1421874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421924 */     // MIs[1] Operand 1
     /* 1421924 */     // No operand predicates
     /* 1421924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421928 */     // MIs[0] policy
     /* 1421928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421940 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421949 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421967 */     // GIR_Coverage, 2890,
     /* 1421967 */     GIR_EraseRootFromParent_Done,
     /* 1421968 */   // Label 20113: @1421968
     /* 1421968 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1422067), // Rule ID 2891 //
     /* 1421973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422023 */     // MIs[1] Operand 1
     /* 1422023 */     // No operand predicates
     /* 1422023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422027 */     // MIs[0] policy
     /* 1422027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422039 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422048 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422066 */     // GIR_Coverage, 2891,
     /* 1422066 */     GIR_EraseRootFromParent_Done,
     /* 1422067 */   // Label 20114: @1422067
     /* 1422067 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1422166), // Rule ID 2898 //
     /* 1422072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1422083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1422086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1422089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1422095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422122 */     // MIs[1] Operand 1
     /* 1422122 */     // No operand predicates
     /* 1422122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422126 */     // MIs[0] policy
     /* 1422126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422138 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422147 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422165 */     // GIR_Coverage, 2898,
     /* 1422165 */     GIR_EraseRootFromParent_Done,
     /* 1422166 */   // Label 20115: @1422166
     /* 1422166 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1422265), // Rule ID 2899 //
     /* 1422171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1422182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1422185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1422188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1422194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422221 */     // MIs[1] Operand 1
     /* 1422221 */     // No operand predicates
     /* 1422221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422225 */     // MIs[0] policy
     /* 1422225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422237 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422246 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422264 */     // GIR_Coverage, 2899,
     /* 1422264 */     GIR_EraseRootFromParent_Done,
     /* 1422265 */   // Label 20116: @1422265
     /* 1422265 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1422364), // Rule ID 2906 //
     /* 1422270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1422287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422320 */     // MIs[1] Operand 1
     /* 1422320 */     // No operand predicates
     /* 1422320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422324 */     // MIs[0] policy
     /* 1422324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422345 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422363 */     // GIR_Coverage, 2906,
     /* 1422363 */     GIR_EraseRootFromParent_Done,
     /* 1422364 */   // Label 20117: @1422364
     /* 1422364 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1422463), // Rule ID 2907 //
     /* 1422369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1422380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1422383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1422386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422419 */     // MIs[1] Operand 1
     /* 1422419 */     // No operand predicates
     /* 1422419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422423 */     // MIs[0] policy
     /* 1422423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422444 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422462 */     // GIR_Coverage, 2907,
     /* 1422462 */     GIR_EraseRootFromParent_Done,
     /* 1422463 */   // Label 20118: @1422463
     /* 1422463 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1422562), // Rule ID 2914 //
     /* 1422468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422518 */     // MIs[1] Operand 1
     /* 1422518 */     // No operand predicates
     /* 1422518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422522 */     // MIs[0] policy
     /* 1422522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422543 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422561 */     // GIR_Coverage, 2914,
     /* 1422561 */     GIR_EraseRootFromParent_Done,
     /* 1422562 */   // Label 20119: @1422562
     /* 1422562 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1422661), // Rule ID 2915 //
     /* 1422567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422617 */     // MIs[1] Operand 1
     /* 1422617 */     // No operand predicates
     /* 1422617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422621 */     // MIs[0] policy
     /* 1422621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422633 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422642 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422660 */     // GIR_Coverage, 2915,
     /* 1422660 */     GIR_EraseRootFromParent_Done,
     /* 1422661 */   // Label 20120: @1422661
     /* 1422661 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1422760), // Rule ID 2922 //
     /* 1422666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422716 */     // MIs[1] Operand 1
     /* 1422716 */     // No operand predicates
     /* 1422716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422720 */     // MIs[0] policy
     /* 1422720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422741 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422759 */     // GIR_Coverage, 2922,
     /* 1422759 */     GIR_EraseRootFromParent_Done,
     /* 1422760 */   // Label 20121: @1422760
     /* 1422760 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1422859), // Rule ID 2923 //
     /* 1422765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422815 */     // MIs[1] Operand 1
     /* 1422815 */     // No operand predicates
     /* 1422815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422819 */     // MIs[0] policy
     /* 1422819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422831 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422840 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422858 */     // GIR_Coverage, 2923,
     /* 1422858 */     GIR_EraseRootFromParent_Done,
     /* 1422859 */   // Label 20122: @1422859
     /* 1422859 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1422958), // Rule ID 2930 //
     /* 1422864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422914 */     // MIs[1] Operand 1
     /* 1422914 */     // No operand predicates
     /* 1422914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422918 */     // MIs[0] policy
     /* 1422918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422939 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422957 */     // GIR_Coverage, 2930,
     /* 1422957 */     GIR_EraseRootFromParent_Done,
     /* 1422958 */   // Label 20123: @1422958
     /* 1422958 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1423057), // Rule ID 2931 //
     /* 1422963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423013 */     // MIs[1] Operand 1
     /* 1423013 */     // No operand predicates
     /* 1423013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423017 */     // MIs[0] policy
     /* 1423017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423038 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423056 */     // GIR_Coverage, 2931,
     /* 1423056 */     GIR_EraseRootFromParent_Done,
     /* 1423057 */   // Label 20124: @1423057
     /* 1423057 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1423156), // Rule ID 2938 //
     /* 1423062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1423073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1423076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1423079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423112 */     // MIs[1] Operand 1
     /* 1423112 */     // No operand predicates
     /* 1423112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423116 */     // MIs[0] policy
     /* 1423116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423137 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423155 */     // GIR_Coverage, 2938,
     /* 1423155 */     GIR_EraseRootFromParent_Done,
     /* 1423156 */   // Label 20125: @1423156
     /* 1423156 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1423255), // Rule ID 2939 //
     /* 1423161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1423172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1423175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1423178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423211 */     // MIs[1] Operand 1
     /* 1423211 */     // No operand predicates
     /* 1423211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423215 */     // MIs[0] policy
     /* 1423215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423236 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423254 */     // GIR_Coverage, 2939,
     /* 1423254 */     GIR_EraseRootFromParent_Done,
     /* 1423255 */   // Label 20126: @1423255
     /* 1423255 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1423354), // Rule ID 2946 //
     /* 1423260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1423271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1423274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1423277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423310 */     // MIs[1] Operand 1
     /* 1423310 */     // No operand predicates
     /* 1423310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423314 */     // MIs[0] policy
     /* 1423314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423335 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423353 */     // GIR_Coverage, 2946,
     /* 1423353 */     GIR_EraseRootFromParent_Done,
     /* 1423354 */   // Label 20127: @1423354
     /* 1423354 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1423453), // Rule ID 2947 //
     /* 1423359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1423370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1423373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1423376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423409 */     // MIs[1] Operand 1
     /* 1423409 */     // No operand predicates
     /* 1423409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423413 */     // MIs[0] policy
     /* 1423413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423425 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423434 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423452 */     // GIR_Coverage, 2947,
     /* 1423452 */     GIR_EraseRootFromParent_Done,
     /* 1423453 */   // Label 20128: @1423453
     /* 1423453 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1423552), // Rule ID 2954 //
     /* 1423458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423508 */     // MIs[1] Operand 1
     /* 1423508 */     // No operand predicates
     /* 1423508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423512 */     // MIs[0] policy
     /* 1423512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423533 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423551 */     // GIR_Coverage, 2954,
     /* 1423551 */     GIR_EraseRootFromParent_Done,
     /* 1423552 */   // Label 20129: @1423552
     /* 1423552 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1423651), // Rule ID 2955 //
     /* 1423557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423607 */     // MIs[1] Operand 1
     /* 1423607 */     // No operand predicates
     /* 1423607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423611 */     // MIs[0] policy
     /* 1423611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423632 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423650 */     // GIR_Coverage, 2955,
     /* 1423650 */     GIR_EraseRootFromParent_Done,
     /* 1423651 */   // Label 20130: @1423651
     /* 1423651 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1423750), // Rule ID 2962 //
     /* 1423656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423706 */     // MIs[1] Operand 1
     /* 1423706 */     // No operand predicates
     /* 1423706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423710 */     // MIs[0] policy
     /* 1423710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423731 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423749 */     // GIR_Coverage, 2962,
     /* 1423749 */     GIR_EraseRootFromParent_Done,
     /* 1423750 */   // Label 20131: @1423750
     /* 1423750 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1423849), // Rule ID 2963 //
     /* 1423755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423805 */     // MIs[1] Operand 1
     /* 1423805 */     // No operand predicates
     /* 1423805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423809 */     // MIs[0] policy
     /* 1423809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423821 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423830 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423848 */     // GIR_Coverage, 2963,
     /* 1423848 */     GIR_EraseRootFromParent_Done,
     /* 1423849 */   // Label 20132: @1423849
     /* 1423849 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1423948), // Rule ID 2970 //
     /* 1423854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423904 */     // MIs[1] Operand 1
     /* 1423904 */     // No operand predicates
     /* 1423904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423908 */     // MIs[0] policy
     /* 1423908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423929 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423947 */     // GIR_Coverage, 2970,
     /* 1423947 */     GIR_EraseRootFromParent_Done,
     /* 1423948 */   // Label 20133: @1423948
     /* 1423948 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1424047), // Rule ID 2971 //
     /* 1423953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1424003 */     // MIs[1] Operand 1
     /* 1424003 */     // No operand predicates
     /* 1424003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424007 */     // MIs[0] policy
     /* 1424007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1424022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424028 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1424033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1424043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424046 */     // GIR_Coverage, 2971,
     /* 1424046 */     GIR_EraseRootFromParent_Done,
     /* 1424047 */   // Label 20134: @1424047
     /* 1424047 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1424144), // Rule ID 3154 //
     /* 1424052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1424063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1424066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1424069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424102 */     // MIs[1] Operand 1
     /* 1424102 */     // No operand predicates
     /* 1424102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424106 */     // MIs[0] policy
     /* 1424106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424118 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1424121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424143 */     // GIR_Coverage, 3154,
     /* 1424143 */     GIR_EraseRootFromParent_Done,
     /* 1424144 */   // Label 20135: @1424144
     /* 1424144 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1424241), // Rule ID 3155 //
     /* 1424149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1424160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1424163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1424166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424199 */     // MIs[1] Operand 1
     /* 1424199 */     // No operand predicates
     /* 1424199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424203 */     // MIs[0] policy
     /* 1424203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424215 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1424218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424240 */     // GIR_Coverage, 3155,
     /* 1424240 */     GIR_EraseRootFromParent_Done,
     /* 1424241 */   // Label 20136: @1424241
     /* 1424241 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1424338), // Rule ID 3158 //
     /* 1424246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1424257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1424260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1424263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424296 */     // MIs[1] Operand 1
     /* 1424296 */     // No operand predicates
     /* 1424296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424300 */     // MIs[0] policy
     /* 1424300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424337 */     // GIR_Coverage, 3158,
     /* 1424337 */     GIR_EraseRootFromParent_Done,
     /* 1424338 */   // Label 20137: @1424338
     /* 1424338 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1424435), // Rule ID 3159 //
     /* 1424343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1424354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1424357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1424360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424393 */     // MIs[1] Operand 1
     /* 1424393 */     // No operand predicates
     /* 1424393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424397 */     // MIs[0] policy
     /* 1424397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424434 */     // GIR_Coverage, 3159,
     /* 1424434 */     GIR_EraseRootFromParent_Done,
     /* 1424435 */   // Label 20138: @1424435
     /* 1424435 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1424532), // Rule ID 3162 //
     /* 1424440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424490 */     // MIs[1] Operand 1
     /* 1424490 */     // No operand predicates
     /* 1424490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424494 */     // MIs[0] policy
     /* 1424494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424506 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424531 */     // GIR_Coverage, 3162,
     /* 1424531 */     GIR_EraseRootFromParent_Done,
     /* 1424532 */   // Label 20139: @1424532
     /* 1424532 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1424629), // Rule ID 3163 //
     /* 1424537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424587 */     // MIs[1] Operand 1
     /* 1424587 */     // No operand predicates
     /* 1424587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424591 */     // MIs[0] policy
     /* 1424591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424603 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424628 */     // GIR_Coverage, 3163,
     /* 1424628 */     GIR_EraseRootFromParent_Done,
     /* 1424629 */   // Label 20140: @1424629
     /* 1424629 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1424726), // Rule ID 3166 //
     /* 1424634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424684 */     // MIs[1] Operand 1
     /* 1424684 */     // No operand predicates
     /* 1424684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424688 */     // MIs[0] policy
     /* 1424688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424725 */     // GIR_Coverage, 3166,
     /* 1424725 */     GIR_EraseRootFromParent_Done,
     /* 1424726 */   // Label 20141: @1424726
     /* 1424726 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1424823), // Rule ID 3167 //
     /* 1424731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424781 */     // MIs[1] Operand 1
     /* 1424781 */     // No operand predicates
     /* 1424781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424785 */     // MIs[0] policy
     /* 1424785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424797 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424822 */     // GIR_Coverage, 3167,
     /* 1424822 */     GIR_EraseRootFromParent_Done,
     /* 1424823 */   // Label 20142: @1424823
     /* 1424823 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1424920), // Rule ID 3170 //
     /* 1424828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424878 */     // MIs[1] Operand 1
     /* 1424878 */     // No operand predicates
     /* 1424878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424882 */     // MIs[0] policy
     /* 1424882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424919 */     // GIR_Coverage, 3170,
     /* 1424919 */     GIR_EraseRootFromParent_Done,
     /* 1424920 */   // Label 20143: @1424920
     /* 1424920 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1425017), // Rule ID 3171 //
     /* 1424925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424975 */     // MIs[1] Operand 1
     /* 1424975 */     // No operand predicates
     /* 1424975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424979 */     // MIs[0] policy
     /* 1424979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425016 */     // GIR_Coverage, 3171,
     /* 1425016 */     GIR_EraseRootFromParent_Done,
     /* 1425017 */   // Label 20144: @1425017
     /* 1425017 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1425114), // Rule ID 3174 //
     /* 1425022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425072 */     // MIs[1] Operand 1
     /* 1425072 */     // No operand predicates
     /* 1425072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425076 */     // MIs[0] policy
     /* 1425076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1425091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425113 */     // GIR_Coverage, 3174,
     /* 1425113 */     GIR_EraseRootFromParent_Done,
     /* 1425114 */   // Label 20145: @1425114
     /* 1425114 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1425211), // Rule ID 3175 //
     /* 1425119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1425130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1425133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1425136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425169 */     // MIs[1] Operand 1
     /* 1425169 */     // No operand predicates
     /* 1425169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425173 */     // MIs[0] policy
     /* 1425173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425185 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1425188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425210 */     // GIR_Coverage, 3175,
     /* 1425210 */     GIR_EraseRootFromParent_Done,
     /* 1425211 */   // Label 20146: @1425211
     /* 1425211 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1425308), // Rule ID 3178 //
     /* 1425216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1425227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1425230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1425233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425266 */     // MIs[1] Operand 1
     /* 1425266 */     // No operand predicates
     /* 1425266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425270 */     // MIs[0] policy
     /* 1425270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425307 */     // GIR_Coverage, 3178,
     /* 1425307 */     GIR_EraseRootFromParent_Done,
     /* 1425308 */   // Label 20147: @1425308
     /* 1425308 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1425405), // Rule ID 3179 //
     /* 1425313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1425324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1425327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1425330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425363 */     // MIs[1] Operand 1
     /* 1425363 */     // No operand predicates
     /* 1425363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425367 */     // MIs[0] policy
     /* 1425367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425379 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425404 */     // GIR_Coverage, 3179,
     /* 1425404 */     GIR_EraseRootFromParent_Done,
     /* 1425405 */   // Label 20148: @1425405
     /* 1425405 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1425502), // Rule ID 3182 //
     /* 1425410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425460 */     // MIs[1] Operand 1
     /* 1425460 */     // No operand predicates
     /* 1425460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425464 */     // MIs[0] policy
     /* 1425464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425501 */     // GIR_Coverage, 3182,
     /* 1425501 */     GIR_EraseRootFromParent_Done,
     /* 1425502 */   // Label 20149: @1425502
     /* 1425502 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1425599), // Rule ID 3183 //
     /* 1425507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425557 */     // MIs[1] Operand 1
     /* 1425557 */     // No operand predicates
     /* 1425557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425561 */     // MIs[0] policy
     /* 1425561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425573 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425598 */     // GIR_Coverage, 3183,
     /* 1425598 */     GIR_EraseRootFromParent_Done,
     /* 1425599 */   // Label 20150: @1425599
     /* 1425599 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1425696), // Rule ID 3186 //
     /* 1425604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425654 */     // MIs[1] Operand 1
     /* 1425654 */     // No operand predicates
     /* 1425654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425658 */     // MIs[0] policy
     /* 1425658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425695 */     // GIR_Coverage, 3186,
     /* 1425695 */     GIR_EraseRootFromParent_Done,
     /* 1425696 */   // Label 20151: @1425696
     /* 1425696 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1425793), // Rule ID 3187 //
     /* 1425701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425751 */     // MIs[1] Operand 1
     /* 1425751 */     // No operand predicates
     /* 1425751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425755 */     // MIs[0] policy
     /* 1425755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425792 */     // GIR_Coverage, 3187,
     /* 1425792 */     GIR_EraseRootFromParent_Done,
     /* 1425793 */   // Label 20152: @1425793
     /* 1425793 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1425890), // Rule ID 3190 //
     /* 1425798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425848 */     // MIs[1] Operand 1
     /* 1425848 */     // No operand predicates
     /* 1425848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425852 */     // MIs[0] policy
     /* 1425852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425889 */     // GIR_Coverage, 3190,
     /* 1425889 */     GIR_EraseRootFromParent_Done,
     /* 1425890 */   // Label 20153: @1425890
     /* 1425890 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1425987), // Rule ID 3191 //
     /* 1425895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425945 */     // MIs[1] Operand 1
     /* 1425945 */     // No operand predicates
     /* 1425945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425949 */     // MIs[0] policy
     /* 1425949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425961 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425986 */     // GIR_Coverage, 3191,
     /* 1425986 */     GIR_EraseRootFromParent_Done,
     /* 1425987 */   // Label 20154: @1425987
     /* 1425987 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1426084), // Rule ID 3194 //
     /* 1425992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1426003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1426006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1426009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426042 */     // MIs[1] Operand 1
     /* 1426042 */     // No operand predicates
     /* 1426042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426046 */     // MIs[0] policy
     /* 1426046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426083 */     // GIR_Coverage, 3194,
     /* 1426083 */     GIR_EraseRootFromParent_Done,
     /* 1426084 */   // Label 20155: @1426084
     /* 1426084 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1426181), // Rule ID 3195 //
     /* 1426089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1426100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1426103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1426106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426139 */     // MIs[1] Operand 1
     /* 1426139 */     // No operand predicates
     /* 1426139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426143 */     // MIs[0] policy
     /* 1426143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426180 */     // GIR_Coverage, 3195,
     /* 1426180 */     GIR_EraseRootFromParent_Done,
     /* 1426181 */   // Label 20156: @1426181
     /* 1426181 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1426278), // Rule ID 3198 //
     /* 1426186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1426197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1426200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1426203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426236 */     // MIs[1] Operand 1
     /* 1426236 */     // No operand predicates
     /* 1426236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426240 */     // MIs[0] policy
     /* 1426240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426277 */     // GIR_Coverage, 3198,
     /* 1426277 */     GIR_EraseRootFromParent_Done,
     /* 1426278 */   // Label 20157: @1426278
     /* 1426278 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1426375), // Rule ID 3199 //
     /* 1426283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1426294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1426297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1426300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426333 */     // MIs[1] Operand 1
     /* 1426333 */     // No operand predicates
     /* 1426333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426337 */     // MIs[0] policy
     /* 1426337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426349 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426374 */     // GIR_Coverage, 3199,
     /* 1426374 */     GIR_EraseRootFromParent_Done,
     /* 1426375 */   // Label 20158: @1426375
     /* 1426375 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1426472), // Rule ID 3202 //
     /* 1426380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426430 */     // MIs[1] Operand 1
     /* 1426430 */     // No operand predicates
     /* 1426430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426434 */     // MIs[0] policy
     /* 1426434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426446 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426471 */     // GIR_Coverage, 3202,
     /* 1426471 */     GIR_EraseRootFromParent_Done,
     /* 1426472 */   // Label 20159: @1426472
     /* 1426472 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1426569), // Rule ID 3203 //
     /* 1426477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426527 */     // MIs[1] Operand 1
     /* 1426527 */     // No operand predicates
     /* 1426527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426531 */     // MIs[0] policy
     /* 1426531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426543 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426568 */     // GIR_Coverage, 3203,
     /* 1426568 */     GIR_EraseRootFromParent_Done,
     /* 1426569 */   // Label 20160: @1426569
     /* 1426569 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1426666), // Rule ID 3206 //
     /* 1426574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426624 */     // MIs[1] Operand 1
     /* 1426624 */     // No operand predicates
     /* 1426624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426628 */     // MIs[0] policy
     /* 1426628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426665 */     // GIR_Coverage, 3206,
     /* 1426665 */     GIR_EraseRootFromParent_Done,
     /* 1426666 */   // Label 20161: @1426666
     /* 1426666 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1426763), // Rule ID 3207 //
     /* 1426671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426721 */     // MIs[1] Operand 1
     /* 1426721 */     // No operand predicates
     /* 1426721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426725 */     // MIs[0] policy
     /* 1426725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426737 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426762 */     // GIR_Coverage, 3207,
     /* 1426762 */     GIR_EraseRootFromParent_Done,
     /* 1426763 */   // Label 20162: @1426763
     /* 1426763 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1426860), // Rule ID 3210 //
     /* 1426768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426818 */     // MIs[1] Operand 1
     /* 1426818 */     // No operand predicates
     /* 1426818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426822 */     // MIs[0] policy
     /* 1426822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426859 */     // GIR_Coverage, 3210,
     /* 1426859 */     GIR_EraseRootFromParent_Done,
     /* 1426860 */   // Label 20163: @1426860
     /* 1426860 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1426957), // Rule ID 3211 //
     /* 1426865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426915 */     // MIs[1] Operand 1
     /* 1426915 */     // No operand predicates
     /* 1426915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426919 */     // MIs[0] policy
     /* 1426919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426931 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426956 */     // GIR_Coverage, 3211,
     /* 1426956 */     GIR_EraseRootFromParent_Done,
     /* 1426957 */   // Label 20164: @1426957
     /* 1426957 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1427054), // Rule ID 3214 //
     /* 1426962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427012 */     // MIs[1] Operand 1
     /* 1427012 */     // No operand predicates
     /* 1427012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427016 */     // MIs[0] policy
     /* 1427016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427053 */     // GIR_Coverage, 3214,
     /* 1427053 */     GIR_EraseRootFromParent_Done,
     /* 1427054 */   // Label 20165: @1427054
     /* 1427054 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1427151), // Rule ID 3215 //
     /* 1427059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1427070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1427073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1427076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427109 */     // MIs[1] Operand 1
     /* 1427109 */     // No operand predicates
     /* 1427109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427113 */     // MIs[0] policy
     /* 1427113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427125 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427150 */     // GIR_Coverage, 3215,
     /* 1427150 */     GIR_EraseRootFromParent_Done,
     /* 1427151 */   // Label 20166: @1427151
     /* 1427151 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1427248), // Rule ID 3218 //
     /* 1427156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427206 */     // MIs[1] Operand 1
     /* 1427206 */     // No operand predicates
     /* 1427206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427210 */     // MIs[0] policy
     /* 1427210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427247 */     // GIR_Coverage, 3218,
     /* 1427247 */     GIR_EraseRootFromParent_Done,
     /* 1427248 */   // Label 20167: @1427248
     /* 1427248 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1427345), // Rule ID 3219 //
     /* 1427253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1427264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1427267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1427270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427303 */     // MIs[1] Operand 1
     /* 1427303 */     // No operand predicates
     /* 1427303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427307 */     // MIs[0] policy
     /* 1427307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427344 */     // GIR_Coverage, 3219,
     /* 1427344 */     GIR_EraseRootFromParent_Done,
     /* 1427345 */   // Label 20168: @1427345
     /* 1427345 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1427442), // Rule ID 3222 //
     /* 1427350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427400 */     // MIs[1] Operand 1
     /* 1427400 */     // No operand predicates
     /* 1427400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427404 */     // MIs[0] policy
     /* 1427404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427441 */     // GIR_Coverage, 3222,
     /* 1427441 */     GIR_EraseRootFromParent_Done,
     /* 1427442 */   // Label 20169: @1427442
     /* 1427442 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1427539), // Rule ID 3223 //
     /* 1427447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1427458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1427461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1427464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427497 */     // MIs[1] Operand 1
     /* 1427497 */     // No operand predicates
     /* 1427497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427501 */     // MIs[0] policy
     /* 1427501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427513 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427538 */     // GIR_Coverage, 3223,
     /* 1427538 */     GIR_EraseRootFromParent_Done,
     /* 1427539 */   // Label 20170: @1427539
     /* 1427539 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1427636), // Rule ID 3226 //
     /* 1427544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427594 */     // MIs[1] Operand 1
     /* 1427594 */     // No operand predicates
     /* 1427594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427598 */     // MIs[0] policy
     /* 1427598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427635 */     // GIR_Coverage, 3226,
     /* 1427635 */     GIR_EraseRootFromParent_Done,
     /* 1427636 */   // Label 20171: @1427636
     /* 1427636 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1427733), // Rule ID 3227 //
     /* 1427641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427691 */     // MIs[1] Operand 1
     /* 1427691 */     // No operand predicates
     /* 1427691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427695 */     // MIs[0] policy
     /* 1427695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427707 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427732 */     // GIR_Coverage, 3227,
     /* 1427732 */     GIR_EraseRootFromParent_Done,
     /* 1427733 */   // Label 20172: @1427733
     /* 1427733 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1427830), // Rule ID 3230 //
     /* 1427738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427788 */     // MIs[1] Operand 1
     /* 1427788 */     // No operand predicates
     /* 1427788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427792 */     // MIs[0] policy
     /* 1427792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427829 */     // GIR_Coverage, 3230,
     /* 1427829 */     GIR_EraseRootFromParent_Done,
     /* 1427830 */   // Label 20173: @1427830
     /* 1427830 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1427927), // Rule ID 3231 //
     /* 1427835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427885 */     // MIs[1] Operand 1
     /* 1427885 */     // No operand predicates
     /* 1427885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427889 */     // MIs[0] policy
     /* 1427889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427901 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427926 */     // GIR_Coverage, 3231,
     /* 1427926 */     GIR_EraseRootFromParent_Done,
     /* 1427927 */   // Label 20174: @1427927
     /* 1427927 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1428024), // Rule ID 3234 //
     /* 1427932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427982 */     // MIs[1] Operand 1
     /* 1427982 */     // No operand predicates
     /* 1427982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427986 */     // MIs[0] policy
     /* 1427986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1428001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428023 */     // GIR_Coverage, 3234,
     /* 1428023 */     GIR_EraseRootFromParent_Done,
     /* 1428024 */   // Label 20175: @1428024
     /* 1428024 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1428121), // Rule ID 3235 //
     /* 1428029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1428032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1428040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1428043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1428046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428079 */     // MIs[1] Operand 1
     /* 1428079 */     // No operand predicates
     /* 1428079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428083 */     // MIs[0] policy
     /* 1428083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428095 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1428098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428120 */     // GIR_Coverage, 3235,
     /* 1428120 */     GIR_EraseRootFromParent_Done,
     /* 1428121 */   // Label 20176: @1428121
     /* 1428121 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1428218), // Rule ID 3238 //
     /* 1428126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1428129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1428137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1428140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1428143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428176 */     // MIs[1] Operand 1
     /* 1428176 */     // No operand predicates
     /* 1428176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428180 */     // MIs[0] policy
     /* 1428180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1428195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428217 */     // GIR_Coverage, 3238,
     /* 1428217 */     GIR_EraseRootFromParent_Done,
     /* 1428218 */   // Label 20177: @1428218
     /* 1428218 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1428315), // Rule ID 3239 //
     /* 1428223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1428226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1428231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1428234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1428237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1428240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428273 */     // MIs[1] Operand 1
     /* 1428273 */     // No operand predicates
     /* 1428273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428277 */     // MIs[0] policy
     /* 1428277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1428292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1428311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428314 */     // GIR_Coverage, 3239,
     /* 1428314 */     GIR_EraseRootFromParent_Done,
     /* 1428315 */   // Label 20178: @1428315
     /* 1428315 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1428412), // Rule ID 3506 //
     /* 1428320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1428331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1428334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1428337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428370 */     // MIs[1] Operand 1
     /* 1428370 */     // No operand predicates
     /* 1428370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428374 */     // MIs[0] policy
     /* 1428374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428411 */     // GIR_Coverage, 3506,
     /* 1428411 */     GIR_EraseRootFromParent_Done,
     /* 1428412 */   // Label 20179: @1428412
     /* 1428412 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1428509), // Rule ID 3507 //
     /* 1428417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1428428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1428431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1428434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428467 */     // MIs[1] Operand 1
     /* 1428467 */     // No operand predicates
     /* 1428467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428471 */     // MIs[0] policy
     /* 1428471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428483 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428508 */     // GIR_Coverage, 3507,
     /* 1428508 */     GIR_EraseRootFromParent_Done,
     /* 1428509 */   // Label 20180: @1428509
     /* 1428509 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1428606), // Rule ID 3510 //
     /* 1428514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428564 */     // MIs[1] Operand 1
     /* 1428564 */     // No operand predicates
     /* 1428564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428568 */     // MIs[0] policy
     /* 1428568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428580 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428605 */     // GIR_Coverage, 3510,
     /* 1428605 */     GIR_EraseRootFromParent_Done,
     /* 1428606 */   // Label 20181: @1428606
     /* 1428606 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1428703), // Rule ID 3511 //
     /* 1428611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428661 */     // MIs[1] Operand 1
     /* 1428661 */     // No operand predicates
     /* 1428661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428665 */     // MIs[0] policy
     /* 1428665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428702 */     // GIR_Coverage, 3511,
     /* 1428702 */     GIR_EraseRootFromParent_Done,
     /* 1428703 */   // Label 20182: @1428703
     /* 1428703 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1428800), // Rule ID 3514 //
     /* 1428708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428758 */     // MIs[1] Operand 1
     /* 1428758 */     // No operand predicates
     /* 1428758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428762 */     // MIs[0] policy
     /* 1428762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428799 */     // GIR_Coverage, 3514,
     /* 1428799 */     GIR_EraseRootFromParent_Done,
     /* 1428800 */   // Label 20183: @1428800
     /* 1428800 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1428897), // Rule ID 3515 //
     /* 1428805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428855 */     // MIs[1] Operand 1
     /* 1428855 */     // No operand predicates
     /* 1428855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428859 */     // MIs[0] policy
     /* 1428859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428896 */     // GIR_Coverage, 3515,
     /* 1428896 */     GIR_EraseRootFromParent_Done,
     /* 1428897 */   // Label 20184: @1428897
     /* 1428897 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1428994), // Rule ID 3518 //
     /* 1428902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428952 */     // MIs[1] Operand 1
     /* 1428952 */     // No operand predicates
     /* 1428952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428956 */     // MIs[0] policy
     /* 1428956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428993 */     // GIR_Coverage, 3518,
     /* 1428993 */     GIR_EraseRootFromParent_Done,
     /* 1428994 */   // Label 20185: @1428994
     /* 1428994 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1429091), // Rule ID 3519 //
     /* 1428999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1429010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1429013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1429016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429049 */     // MIs[1] Operand 1
     /* 1429049 */     // No operand predicates
     /* 1429049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429053 */     // MIs[0] policy
     /* 1429053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429065 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1429068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429090 */     // GIR_Coverage, 3519,
     /* 1429090 */     GIR_EraseRootFromParent_Done,
     /* 1429091 */   // Label 20186: @1429091
     /* 1429091 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1429188), // Rule ID 3522 //
     /* 1429096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1429107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1429110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1429113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429146 */     // MIs[1] Operand 1
     /* 1429146 */     // No operand predicates
     /* 1429146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429150 */     // MIs[0] policy
     /* 1429150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429162 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429187 */     // GIR_Coverage, 3522,
     /* 1429187 */     GIR_EraseRootFromParent_Done,
     /* 1429188 */   // Label 20187: @1429188
     /* 1429188 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1429285), // Rule ID 3523 //
     /* 1429193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1429204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1429207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1429210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429243 */     // MIs[1] Operand 1
     /* 1429243 */     // No operand predicates
     /* 1429243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429247 */     // MIs[0] policy
     /* 1429247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429284 */     // GIR_Coverage, 3523,
     /* 1429284 */     GIR_EraseRootFromParent_Done,
     /* 1429285 */   // Label 20188: @1429285
     /* 1429285 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1429382), // Rule ID 3526 //
     /* 1429290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1429301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1429304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1429307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429340 */     // MIs[1] Operand 1
     /* 1429340 */     // No operand predicates
     /* 1429340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429344 */     // MIs[0] policy
     /* 1429344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429356 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429381 */     // GIR_Coverage, 3526,
     /* 1429381 */     GIR_EraseRootFromParent_Done,
     /* 1429382 */   // Label 20189: @1429382
     /* 1429382 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1429479), // Rule ID 3527 //
     /* 1429387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1429398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1429401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1429404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429437 */     // MIs[1] Operand 1
     /* 1429437 */     // No operand predicates
     /* 1429437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429441 */     // MIs[0] policy
     /* 1429441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1429456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429478 */     // GIR_Coverage, 3527,
     /* 1429478 */     GIR_EraseRootFromParent_Done,
     /* 1429479 */   // Label 20190: @1429479
     /* 1429479 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1429576), // Rule ID 3530 //
     /* 1429484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429534 */     // MIs[1] Operand 1
     /* 1429534 */     // No operand predicates
     /* 1429534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429538 */     // MIs[0] policy
     /* 1429538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429575 */     // GIR_Coverage, 3530,
     /* 1429575 */     GIR_EraseRootFromParent_Done,
     /* 1429576 */   // Label 20191: @1429576
     /* 1429576 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1429673), // Rule ID 3531 //
     /* 1429581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429631 */     // MIs[1] Operand 1
     /* 1429631 */     // No operand predicates
     /* 1429631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429635 */     // MIs[0] policy
     /* 1429635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429647 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429672 */     // GIR_Coverage, 3531,
     /* 1429672 */     GIR_EraseRootFromParent_Done,
     /* 1429673 */   // Label 20192: @1429673
     /* 1429673 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1429770), // Rule ID 3534 //
     /* 1429678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429728 */     // MIs[1] Operand 1
     /* 1429728 */     // No operand predicates
     /* 1429728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429732 */     // MIs[0] policy
     /* 1429732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429769 */     // GIR_Coverage, 3534,
     /* 1429769 */     GIR_EraseRootFromParent_Done,
     /* 1429770 */   // Label 20193: @1429770
     /* 1429770 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1429867), // Rule ID 3535 //
     /* 1429775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429825 */     // MIs[1] Operand 1
     /* 1429825 */     // No operand predicates
     /* 1429825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429829 */     // MIs[0] policy
     /* 1429829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429841 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429866 */     // GIR_Coverage, 3535,
     /* 1429866 */     GIR_EraseRootFromParent_Done,
     /* 1429867 */   // Label 20194: @1429867
     /* 1429867 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1429964), // Rule ID 3538 //
     /* 1429872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429922 */     // MIs[1] Operand 1
     /* 1429922 */     // No operand predicates
     /* 1429922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429926 */     // MIs[0] policy
     /* 1429926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429963 */     // GIR_Coverage, 3538,
     /* 1429963 */     GIR_EraseRootFromParent_Done,
     /* 1429964 */   // Label 20195: @1429964
     /* 1429964 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1430061), // Rule ID 3539 //
     /* 1429969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430019 */     // MIs[1] Operand 1
     /* 1430019 */     // No operand predicates
     /* 1430019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430023 */     // MIs[0] policy
     /* 1430023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430060 */     // GIR_Coverage, 3539,
     /* 1430060 */     GIR_EraseRootFromParent_Done,
     /* 1430061 */   // Label 20196: @1430061
     /* 1430061 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1430158), // Rule ID 3542 //
     /* 1430066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1430069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1430077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1430080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1430083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430116 */     // MIs[1] Operand 1
     /* 1430116 */     // No operand predicates
     /* 1430116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430120 */     // MIs[0] policy
     /* 1430120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430157 */     // GIR_Coverage, 3542,
     /* 1430157 */     GIR_EraseRootFromParent_Done,
     /* 1430158 */   // Label 20197: @1430158
     /* 1430158 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1430255), // Rule ID 3543 //
     /* 1430163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1430166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1430174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1430177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1430180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430213 */     // MIs[1] Operand 1
     /* 1430213 */     // No operand predicates
     /* 1430213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430217 */     // MIs[0] policy
     /* 1430217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1430232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1430251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430254 */     // GIR_Coverage, 3543,
     /* 1430254 */     GIR_EraseRootFromParent_Done,
     /* 1430255 */   // Label 20198: @1430255
     /* 1430255 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1430352), // Rule ID 3546 //
     /* 1430260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1430271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1430274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1430277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430310 */     // MIs[1] Operand 1
     /* 1430310 */     // No operand predicates
     /* 1430310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430314 */     // MIs[0] policy
     /* 1430314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430351 */     // GIR_Coverage, 3546,
     /* 1430351 */     GIR_EraseRootFromParent_Done,
     /* 1430352 */   // Label 20199: @1430352
     /* 1430352 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1430449), // Rule ID 3547 //
     /* 1430357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1430368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1430371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1430374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430407 */     // MIs[1] Operand 1
     /* 1430407 */     // No operand predicates
     /* 1430407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430411 */     // MIs[0] policy
     /* 1430411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430448 */     // GIR_Coverage, 3547,
     /* 1430448 */     GIR_EraseRootFromParent_Done,
     /* 1430449 */   // Label 20200: @1430449
     /* 1430449 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1430546), // Rule ID 3550 //
     /* 1430454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430504 */     // MIs[1] Operand 1
     /* 1430504 */     // No operand predicates
     /* 1430504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430508 */     // MIs[0] policy
     /* 1430508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430520 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430545 */     // GIR_Coverage, 3550,
     /* 1430545 */     GIR_EraseRootFromParent_Done,
     /* 1430546 */   // Label 20201: @1430546
     /* 1430546 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1430643), // Rule ID 3551 //
     /* 1430551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430601 */     // MIs[1] Operand 1
     /* 1430601 */     // No operand predicates
     /* 1430601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430605 */     // MIs[0] policy
     /* 1430605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430642 */     // GIR_Coverage, 3551,
     /* 1430642 */     GIR_EraseRootFromParent_Done,
     /* 1430643 */   // Label 20202: @1430643
     /* 1430643 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1430740), // Rule ID 3554 //
     /* 1430648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430698 */     // MIs[1] Operand 1
     /* 1430698 */     // No operand predicates
     /* 1430698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430702 */     // MIs[0] policy
     /* 1430702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430739 */     // GIR_Coverage, 3554,
     /* 1430739 */     GIR_EraseRootFromParent_Done,
     /* 1430740 */   // Label 20203: @1430740
     /* 1430740 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1430837), // Rule ID 3555 //
     /* 1430745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430795 */     // MIs[1] Operand 1
     /* 1430795 */     // No operand predicates
     /* 1430795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430799 */     // MIs[0] policy
     /* 1430799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430811 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430836 */     // GIR_Coverage, 3555,
     /* 1430836 */     GIR_EraseRootFromParent_Done,
     /* 1430837 */   // Label 20204: @1430837
     /* 1430837 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1430934), // Rule ID 3558 //
     /* 1430842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430892 */     // MIs[1] Operand 1
     /* 1430892 */     // No operand predicates
     /* 1430892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430896 */     // MIs[0] policy
     /* 1430896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430933 */     // GIR_Coverage, 3558,
     /* 1430933 */     GIR_EraseRootFromParent_Done,
     /* 1430934 */   // Label 20205: @1430934
     /* 1430934 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1431031), // Rule ID 3559 //
     /* 1430939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430989 */     // MIs[1] Operand 1
     /* 1430989 */     // No operand predicates
     /* 1430989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430993 */     // MIs[0] policy
     /* 1430993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431030 */     // GIR_Coverage, 3559,
     /* 1431030 */     GIR_EraseRootFromParent_Done,
     /* 1431031 */   // Label 20206: @1431031
     /* 1431031 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1431128), // Rule ID 3562 //
     /* 1431036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431086 */     // MIs[1] Operand 1
     /* 1431086 */     // No operand predicates
     /* 1431086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431090 */     // MIs[0] policy
     /* 1431090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431127 */     // GIR_Coverage, 3562,
     /* 1431127 */     GIR_EraseRootFromParent_Done,
     /* 1431128 */   // Label 20207: @1431128
     /* 1431128 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1431225), // Rule ID 3563 //
     /* 1431133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1431144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1431147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1431150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431183 */     // MIs[1] Operand 1
     /* 1431183 */     // No operand predicates
     /* 1431183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431187 */     // MIs[0] policy
     /* 1431187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431224 */     // GIR_Coverage, 3563,
     /* 1431224 */     GIR_EraseRootFromParent_Done,
     /* 1431225 */   // Label 20208: @1431225
     /* 1431225 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1431322), // Rule ID 3566 //
     /* 1431230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1431253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431280 */     // MIs[1] Operand 1
     /* 1431280 */     // No operand predicates
     /* 1431280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431284 */     // MIs[0] policy
     /* 1431284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431321 */     // GIR_Coverage, 3566,
     /* 1431321 */     GIR_EraseRootFromParent_Done,
     /* 1431322 */   // Label 20209: @1431322
     /* 1431322 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1431419), // Rule ID 3567 //
     /* 1431327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1431338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1431341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1431344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1431350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431377 */     // MIs[1] Operand 1
     /* 1431377 */     // No operand predicates
     /* 1431377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431381 */     // MIs[0] policy
     /* 1431381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431393 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431418 */     // GIR_Coverage, 3567,
     /* 1431418 */     GIR_EraseRootFromParent_Done,
     /* 1431419 */   // Label 20210: @1431419
     /* 1431419 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1431516), // Rule ID 3570 //
     /* 1431424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431474 */     // MIs[1] Operand 1
     /* 1431474 */     // No operand predicates
     /* 1431474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431478 */     // MIs[0] policy
     /* 1431478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431515 */     // GIR_Coverage, 3570,
     /* 1431515 */     GIR_EraseRootFromParent_Done,
     /* 1431516 */   // Label 20211: @1431516
     /* 1431516 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1431613), // Rule ID 3571 //
     /* 1431521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431571 */     // MIs[1] Operand 1
     /* 1431571 */     // No operand predicates
     /* 1431571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431575 */     // MIs[0] policy
     /* 1431575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431612 */     // GIR_Coverage, 3571,
     /* 1431612 */     GIR_EraseRootFromParent_Done,
     /* 1431613 */   // Label 20212: @1431613
     /* 1431613 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1431710), // Rule ID 3574 //
     /* 1431618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431668 */     // MIs[1] Operand 1
     /* 1431668 */     // No operand predicates
     /* 1431668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431672 */     // MIs[0] policy
     /* 1431672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431709 */     // GIR_Coverage, 3574,
     /* 1431709 */     GIR_EraseRootFromParent_Done,
     /* 1431710 */   // Label 20213: @1431710
     /* 1431710 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1431807), // Rule ID 3575 //
     /* 1431715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431765 */     // MIs[1] Operand 1
     /* 1431765 */     // No operand predicates
     /* 1431765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431769 */     // MIs[0] policy
     /* 1431769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431781 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431806 */     // GIR_Coverage, 3575,
     /* 1431806 */     GIR_EraseRootFromParent_Done,
     /* 1431807 */   // Label 20214: @1431807
     /* 1431807 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1431904), // Rule ID 3578 //
     /* 1431812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431862 */     // MIs[1] Operand 1
     /* 1431862 */     // No operand predicates
     /* 1431862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431866 */     // MIs[0] policy
     /* 1431866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431903 */     // GIR_Coverage, 3578,
     /* 1431903 */     GIR_EraseRootFromParent_Done,
     /* 1431904 */   // Label 20215: @1431904
     /* 1431904 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1432001), // Rule ID 3579 //
     /* 1431909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431959 */     // MIs[1] Operand 1
     /* 1431959 */     // No operand predicates
     /* 1431959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431963 */     // MIs[0] policy
     /* 1431963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431975 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432000 */     // GIR_Coverage, 3579,
     /* 1432000 */     GIR_EraseRootFromParent_Done,
     /* 1432001 */   // Label 20216: @1432001
     /* 1432001 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1432098), // Rule ID 3582 //
     /* 1432006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432056 */     // MIs[1] Operand 1
     /* 1432056 */     // No operand predicates
     /* 1432056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432060 */     // MIs[0] policy
     /* 1432060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1432075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432097 */     // GIR_Coverage, 3582,
     /* 1432097 */     GIR_EraseRootFromParent_Done,
     /* 1432098 */   // Label 20217: @1432098
     /* 1432098 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1432195), // Rule ID 3583 //
     /* 1432103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1432114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1432117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1432120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432153 */     // MIs[1] Operand 1
     /* 1432153 */     // No operand predicates
     /* 1432153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432157 */     // MIs[0] policy
     /* 1432157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1432172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432194 */     // GIR_Coverage, 3583,
     /* 1432194 */     GIR_EraseRootFromParent_Done,
     /* 1432195 */   // Label 20218: @1432195
     /* 1432195 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1432292), // Rule ID 3586 //
     /* 1432200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432250 */     // MIs[1] Operand 1
     /* 1432250 */     // No operand predicates
     /* 1432250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432254 */     // MIs[0] policy
     /* 1432254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1432269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432291 */     // GIR_Coverage, 3586,
     /* 1432291 */     GIR_EraseRootFromParent_Done,
     /* 1432292 */   // Label 20219: @1432292
     /* 1432292 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1432389), // Rule ID 3587 //
     /* 1432297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1432308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1432311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1432314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432347 */     // MIs[1] Operand 1
     /* 1432347 */     // No operand predicates
     /* 1432347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432351 */     // MIs[0] policy
     /* 1432351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432363 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1432366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432388 */     // GIR_Coverage, 3587,
     /* 1432388 */     GIR_EraseRootFromParent_Done,
     /* 1432389 */   // Label 20220: @1432389
     /* 1432389 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1432486), // Rule ID 3590 //
     /* 1432394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1432397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432444 */     // MIs[1] Operand 1
     /* 1432444 */     // No operand predicates
     /* 1432444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432448 */     // MIs[0] policy
     /* 1432448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432485 */     // GIR_Coverage, 3590,
     /* 1432485 */     GIR_EraseRootFromParent_Done,
     /* 1432486 */   // Label 20221: @1432486
     /* 1432486 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1432583), // Rule ID 3591 //
     /* 1432491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432541 */     // MIs[1] Operand 1
     /* 1432541 */     // No operand predicates
     /* 1432541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432545 */     // MIs[0] policy
     /* 1432545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432557 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432582 */     // GIR_Coverage, 3591,
     /* 1432582 */     GIR_EraseRootFromParent_Done,
     /* 1432583 */   // Label 20222: @1432583
     /* 1432583 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1432680), // Rule ID 5954 //
     /* 1432588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432638 */     // MIs[1] Operand 1
     /* 1432638 */     // No operand predicates
     /* 1432638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432642 */     // MIs[0] policy
     /* 1432642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432679 */     // GIR_Coverage, 5954,
     /* 1432679 */     GIR_EraseRootFromParent_Done,
     /* 1432680 */   // Label 20223: @1432680
     /* 1432680 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1432777), // Rule ID 5955 //
     /* 1432685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432735 */     // MIs[1] Operand 1
     /* 1432735 */     // No operand predicates
     /* 1432735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432739 */     // MIs[0] policy
     /* 1432739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432751 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432776 */     // GIR_Coverage, 5955,
     /* 1432776 */     GIR_EraseRootFromParent_Done,
     /* 1432777 */   // Label 20224: @1432777
     /* 1432777 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1432874), // Rule ID 5958 //
     /* 1432782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432832 */     // MIs[1] Operand 1
     /* 1432832 */     // No operand predicates
     /* 1432832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432836 */     // MIs[0] policy
     /* 1432836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432873 */     // GIR_Coverage, 5958,
     /* 1432873 */     GIR_EraseRootFromParent_Done,
     /* 1432874 */   // Label 20225: @1432874
     /* 1432874 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1432971), // Rule ID 5959 //
     /* 1432879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432929 */     // MIs[1] Operand 1
     /* 1432929 */     // No operand predicates
     /* 1432929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432933 */     // MIs[0] policy
     /* 1432933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432945 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432970 */     // GIR_Coverage, 5959,
     /* 1432970 */     GIR_EraseRootFromParent_Done,
     /* 1432971 */   // Label 20226: @1432971
     /* 1432971 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1433068), // Rule ID 5962 //
     /* 1432976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433026 */     // MIs[1] Operand 1
     /* 1433026 */     // No operand predicates
     /* 1433026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433030 */     // MIs[0] policy
     /* 1433030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433042 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433067 */     // GIR_Coverage, 5962,
     /* 1433067 */     GIR_EraseRootFromParent_Done,
     /* 1433068 */   // Label 20227: @1433068
     /* 1433068 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1433165), // Rule ID 5963 //
     /* 1433073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1433084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1433087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1433090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433123 */     // MIs[1] Operand 1
     /* 1433123 */     // No operand predicates
     /* 1433123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433127 */     // MIs[0] policy
     /* 1433127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433139 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433164 */     // GIR_Coverage, 5963,
     /* 1433164 */     GIR_EraseRootFromParent_Done,
     /* 1433165 */   // Label 20228: @1433165
     /* 1433165 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1433262), // Rule ID 5966 //
     /* 1433170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1433181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1433184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1433187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433220 */     // MIs[1] Operand 1
     /* 1433220 */     // No operand predicates
     /* 1433220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433224 */     // MIs[0] policy
     /* 1433224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1433239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433261 */     // GIR_Coverage, 5966,
     /* 1433261 */     GIR_EraseRootFromParent_Done,
     /* 1433262 */   // Label 20229: @1433262
     /* 1433262 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1433359), // Rule ID 5967 //
     /* 1433267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1433278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1433281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1433284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433317 */     // MIs[1] Operand 1
     /* 1433317 */     // No operand predicates
     /* 1433317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433321 */     // MIs[0] policy
     /* 1433321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433333 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1433336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433358 */     // GIR_Coverage, 5967,
     /* 1433358 */     GIR_EraseRootFromParent_Done,
     /* 1433359 */   // Label 20230: @1433359
     /* 1433359 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1433456), // Rule ID 5970 //
     /* 1433364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433414 */     // MIs[1] Operand 1
     /* 1433414 */     // No operand predicates
     /* 1433414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433418 */     // MIs[0] policy
     /* 1433418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433455 */     // GIR_Coverage, 5970,
     /* 1433455 */     GIR_EraseRootFromParent_Done,
     /* 1433456 */   // Label 20231: @1433456
     /* 1433456 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1433553), // Rule ID 5971 //
     /* 1433461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433511 */     // MIs[1] Operand 1
     /* 1433511 */     // No operand predicates
     /* 1433511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433515 */     // MIs[0] policy
     /* 1433515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433527 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433552 */     // GIR_Coverage, 5971,
     /* 1433552 */     GIR_EraseRootFromParent_Done,
     /* 1433553 */   // Label 20232: @1433553
     /* 1433553 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1433650), // Rule ID 5974 //
     /* 1433558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433608 */     // MIs[1] Operand 1
     /* 1433608 */     // No operand predicates
     /* 1433608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433612 */     // MIs[0] policy
     /* 1433612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433649 */     // GIR_Coverage, 5974,
     /* 1433649 */     GIR_EraseRootFromParent_Done,
     /* 1433650 */   // Label 20233: @1433650
     /* 1433650 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1433747), // Rule ID 5975 //
     /* 1433655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433705 */     // MIs[1] Operand 1
     /* 1433705 */     // No operand predicates
     /* 1433705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433709 */     // MIs[0] policy
     /* 1433709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433746 */     // GIR_Coverage, 5975,
     /* 1433746 */     GIR_EraseRootFromParent_Done,
     /* 1433747 */   // Label 20234: @1433747
     /* 1433747 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1433844), // Rule ID 5978 //
     /* 1433752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433802 */     // MIs[1] Operand 1
     /* 1433802 */     // No operand predicates
     /* 1433802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433806 */     // MIs[0] policy
     /* 1433806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433843 */     // GIR_Coverage, 5978,
     /* 1433843 */     GIR_EraseRootFromParent_Done,
     /* 1433844 */   // Label 20235: @1433844
     /* 1433844 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1433941), // Rule ID 5979 //
     /* 1433849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433899 */     // MIs[1] Operand 1
     /* 1433899 */     // No operand predicates
     /* 1433899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433903 */     // MIs[0] policy
     /* 1433903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433915 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433940 */     // GIR_Coverage, 5979,
     /* 1433940 */     GIR_EraseRootFromParent_Done,
     /* 1433941 */   // Label 20236: @1433941
     /* 1433941 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1434038), // Rule ID 5982 //
     /* 1433946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433996 */     // MIs[1] Operand 1
     /* 1433996 */     // No operand predicates
     /* 1433996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434000 */     // MIs[0] policy
     /* 1434000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434037 */     // GIR_Coverage, 5982,
     /* 1434037 */     GIR_EraseRootFromParent_Done,
     /* 1434038 */   // Label 20237: @1434038
     /* 1434038 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1434135), // Rule ID 5983 //
     /* 1434043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1434054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1434057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1434060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434093 */     // MIs[1] Operand 1
     /* 1434093 */     // No operand predicates
     /* 1434093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434097 */     // MIs[0] policy
     /* 1434097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434134 */     // GIR_Coverage, 5983,
     /* 1434134 */     GIR_EraseRootFromParent_Done,
     /* 1434135 */   // Label 20238: @1434135
     /* 1434135 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1434232), // Rule ID 5986 //
     /* 1434140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1434151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1434154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1434157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434190 */     // MIs[1] Operand 1
     /* 1434190 */     // No operand predicates
     /* 1434190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434194 */     // MIs[0] policy
     /* 1434194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434231 */     // GIR_Coverage, 5986,
     /* 1434231 */     GIR_EraseRootFromParent_Done,
     /* 1434232 */   // Label 20239: @1434232
     /* 1434232 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1434329), // Rule ID 5987 //
     /* 1434237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1434248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1434251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1434254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434287 */     // MIs[1] Operand 1
     /* 1434287 */     // No operand predicates
     /* 1434287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434291 */     // MIs[0] policy
     /* 1434291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434303 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1434325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434328 */     // GIR_Coverage, 5987,
     /* 1434328 */     GIR_EraseRootFromParent_Done,
     /* 1434329 */   // Label 20240: @1434329
     /* 1434329 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1434426), // Rule ID 5990 //
     /* 1434334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1434337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1434345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1434348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1434351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434384 */     // MIs[1] Operand 1
     /* 1434384 */     // No operand predicates
     /* 1434384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434388 */     // MIs[0] policy
     /* 1434388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434425 */     // GIR_Coverage, 5990,
     /* 1434425 */     GIR_EraseRootFromParent_Done,
     /* 1434426 */   // Label 20241: @1434426
     /* 1434426 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1434523), // Rule ID 5991 //
     /* 1434431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1434434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1434442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1434445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1434448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434481 */     // MIs[1] Operand 1
     /* 1434481 */     // No operand predicates
     /* 1434481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434485 */     // MIs[0] policy
     /* 1434485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434497 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434522 */     // GIR_Coverage, 5991,
     /* 1434522 */     GIR_EraseRootFromParent_Done,
     /* 1434523 */   // Label 20242: @1434523
     /* 1434523 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1434620), // Rule ID 5994 //
     /* 1434528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434578 */     // MIs[1] Operand 1
     /* 1434578 */     // No operand predicates
     /* 1434578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434582 */     // MIs[0] policy
     /* 1434582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434619 */     // GIR_Coverage, 5994,
     /* 1434619 */     GIR_EraseRootFromParent_Done,
     /* 1434620 */   // Label 20243: @1434620
     /* 1434620 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1434717), // Rule ID 5995 //
     /* 1434625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434675 */     // MIs[1] Operand 1
     /* 1434675 */     // No operand predicates
     /* 1434675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434679 */     // MIs[0] policy
     /* 1434679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434716 */     // GIR_Coverage, 5995,
     /* 1434716 */     GIR_EraseRootFromParent_Done,
     /* 1434717 */   // Label 20244: @1434717
     /* 1434717 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1434814), // Rule ID 5998 //
     /* 1434722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434772 */     // MIs[1] Operand 1
     /* 1434772 */     // No operand predicates
     /* 1434772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434776 */     // MIs[0] policy
     /* 1434776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434813 */     // GIR_Coverage, 5998,
     /* 1434813 */     GIR_EraseRootFromParent_Done,
     /* 1434814 */   // Label 20245: @1434814
     /* 1434814 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1434911), // Rule ID 5999 //
     /* 1434819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434869 */     // MIs[1] Operand 1
     /* 1434869 */     // No operand predicates
     /* 1434869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434873 */     // MIs[0] policy
     /* 1434873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434885 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434910 */     // GIR_Coverage, 5999,
     /* 1434910 */     GIR_EraseRootFromParent_Done,
     /* 1434911 */   // Label 20246: @1434911
     /* 1434911 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1435008), // Rule ID 6002 //
     /* 1434916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434966 */     // MIs[1] Operand 1
     /* 1434966 */     // No operand predicates
     /* 1434966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434970 */     // MIs[0] policy
     /* 1434970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434982 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435007 */     // GIR_Coverage, 6002,
     /* 1435007 */     GIR_EraseRootFromParent_Done,
     /* 1435008 */   // Label 20247: @1435008
     /* 1435008 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1435105), // Rule ID 6003 //
     /* 1435013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1435024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1435027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1435030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1435036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435063 */     // MIs[1] Operand 1
     /* 1435063 */     // No operand predicates
     /* 1435063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435067 */     // MIs[0] policy
     /* 1435067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435079 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435104 */     // GIR_Coverage, 6003,
     /* 1435104 */     GIR_EraseRootFromParent_Done,
     /* 1435105 */   // Label 20248: @1435105
     /* 1435105 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1435202), // Rule ID 6006 //
     /* 1435110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1435121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1435124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1435127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435160 */     // MIs[1] Operand 1
     /* 1435160 */     // No operand predicates
     /* 1435160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435164 */     // MIs[0] policy
     /* 1435164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435201 */     // GIR_Coverage, 6006,
     /* 1435201 */     GIR_EraseRootFromParent_Done,
     /* 1435202 */   // Label 20249: @1435202
     /* 1435202 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1435299), // Rule ID 6007 //
     /* 1435207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1435218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1435221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1435224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435257 */     // MIs[1] Operand 1
     /* 1435257 */     // No operand predicates
     /* 1435257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435261 */     // MIs[0] policy
     /* 1435261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435298 */     // GIR_Coverage, 6007,
     /* 1435298 */     GIR_EraseRootFromParent_Done,
     /* 1435299 */   // Label 20250: @1435299
     /* 1435299 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1435396), // Rule ID 6010 //
     /* 1435304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1435315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1435318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1435321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435354 */     // MIs[1] Operand 1
     /* 1435354 */     // No operand predicates
     /* 1435354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435358 */     // MIs[0] policy
     /* 1435358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435395 */     // GIR_Coverage, 6010,
     /* 1435395 */     GIR_EraseRootFromParent_Done,
     /* 1435396 */   // Label 20251: @1435396
     /* 1435396 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1435493), // Rule ID 6011 //
     /* 1435401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1435412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1435415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1435418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435451 */     // MIs[1] Operand 1
     /* 1435451 */     // No operand predicates
     /* 1435451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435455 */     // MIs[0] policy
     /* 1435455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435467 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435492 */     // GIR_Coverage, 6011,
     /* 1435492 */     GIR_EraseRootFromParent_Done,
     /* 1435493 */   // Label 20252: @1435493
     /* 1435493 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1435590), // Rule ID 6014 //
     /* 1435498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435548 */     // MIs[1] Operand 1
     /* 1435548 */     // No operand predicates
     /* 1435548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435552 */     // MIs[0] policy
     /* 1435552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435589 */     // GIR_Coverage, 6014,
     /* 1435589 */     GIR_EraseRootFromParent_Done,
     /* 1435590 */   // Label 20253: @1435590
     /* 1435590 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1435687), // Rule ID 6015 //
     /* 1435595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435645 */     // MIs[1] Operand 1
     /* 1435645 */     // No operand predicates
     /* 1435645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435649 */     // MIs[0] policy
     /* 1435649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435686 */     // GIR_Coverage, 6015,
     /* 1435686 */     GIR_EraseRootFromParent_Done,
     /* 1435687 */   // Label 20254: @1435687
     /* 1435687 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1435784), // Rule ID 6018 //
     /* 1435692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435742 */     // MIs[1] Operand 1
     /* 1435742 */     // No operand predicates
     /* 1435742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435746 */     // MIs[0] policy
     /* 1435746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435783 */     // GIR_Coverage, 6018,
     /* 1435783 */     GIR_EraseRootFromParent_Done,
     /* 1435784 */   // Label 20255: @1435784
     /* 1435784 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1435881), // Rule ID 6019 //
     /* 1435789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435839 */     // MIs[1] Operand 1
     /* 1435839 */     // No operand predicates
     /* 1435839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435843 */     // MIs[0] policy
     /* 1435843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435855 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435880 */     // GIR_Coverage, 6019,
     /* 1435880 */     GIR_EraseRootFromParent_Done,
     /* 1435881 */   // Label 20256: @1435881
     /* 1435881 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1435978), // Rule ID 6022 //
     /* 1435886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435936 */     // MIs[1] Operand 1
     /* 1435936 */     // No operand predicates
     /* 1435936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435940 */     // MIs[0] policy
     /* 1435940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435977 */     // GIR_Coverage, 6022,
     /* 1435977 */     GIR_EraseRootFromParent_Done,
     /* 1435978 */   // Label 20257: @1435978
     /* 1435978 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1436075), // Rule ID 6023 //
     /* 1435983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1436000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436033 */     // MIs[1] Operand 1
     /* 1436033 */     // No operand predicates
     /* 1436033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436037 */     // MIs[0] policy
     /* 1436037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436049 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436074 */     // GIR_Coverage, 6023,
     /* 1436074 */     GIR_EraseRootFromParent_Done,
     /* 1436075 */   // Label 20258: @1436075
     /* 1436075 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1436172), // Rule ID 6026 //
     /* 1436080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1436091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1436094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1436097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436130 */     // MIs[1] Operand 1
     /* 1436130 */     // No operand predicates
     /* 1436130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436134 */     // MIs[0] policy
     /* 1436134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436171 */     // GIR_Coverage, 6026,
     /* 1436171 */     GIR_EraseRootFromParent_Done,
     /* 1436172 */   // Label 20259: @1436172
     /* 1436172 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1436269), // Rule ID 6027 //
     /* 1436177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1436188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1436191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1436194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436227 */     // MIs[1] Operand 1
     /* 1436227 */     // No operand predicates
     /* 1436227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436231 */     // MIs[0] policy
     /* 1436231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436243 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1436265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436268 */     // GIR_Coverage, 6027,
     /* 1436268 */     GIR_EraseRootFromParent_Done,
     /* 1436269 */   // Label 20260: @1436269
     /* 1436269 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1436366), // Rule ID 6030 //
     /* 1436274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1436285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1436288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1436291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436324 */     // MIs[1] Operand 1
     /* 1436324 */     // No operand predicates
     /* 1436324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436328 */     // MIs[0] policy
     /* 1436328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1436343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436365 */     // GIR_Coverage, 6030,
     /* 1436365 */     GIR_EraseRootFromParent_Done,
     /* 1436366 */   // Label 20261: @1436366
     /* 1436366 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1436463), // Rule ID 6031 //
     /* 1436371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1436382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1436385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1436388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436421 */     // MIs[1] Operand 1
     /* 1436421 */     // No operand predicates
     /* 1436421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436425 */     // MIs[0] policy
     /* 1436425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1436440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436462 */     // GIR_Coverage, 6031,
     /* 1436462 */     GIR_EraseRootFromParent_Done,
     /* 1436463 */   // Label 20262: @1436463
     /* 1436463 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1436560), // Rule ID 6034 //
     /* 1436468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436518 */     // MIs[1] Operand 1
     /* 1436518 */     // No operand predicates
     /* 1436518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436522 */     // MIs[0] policy
     /* 1436522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436534 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436559 */     // GIR_Coverage, 6034,
     /* 1436559 */     GIR_EraseRootFromParent_Done,
     /* 1436560 */   // Label 20263: @1436560
     /* 1436560 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1436657), // Rule ID 6035 //
     /* 1436565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436615 */     // MIs[1] Operand 1
     /* 1436615 */     // No operand predicates
     /* 1436615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436619 */     // MIs[0] policy
     /* 1436619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436631 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436656 */     // GIR_Coverage, 6035,
     /* 1436656 */     GIR_EraseRootFromParent_Done,
     /* 1436657 */   // Label 20264: @1436657
     /* 1436657 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1436754), // Rule ID 6038 //
     /* 1436662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436712 */     // MIs[1] Operand 1
     /* 1436712 */     // No operand predicates
     /* 1436712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436716 */     // MIs[0] policy
     /* 1436716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436753 */     // GIR_Coverage, 6038,
     /* 1436753 */     GIR_EraseRootFromParent_Done,
     /* 1436754 */   // Label 20265: @1436754
     /* 1436754 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1436851), // Rule ID 6039 //
     /* 1436759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436809 */     // MIs[1] Operand 1
     /* 1436809 */     // No operand predicates
     /* 1436809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436813 */     // MIs[0] policy
     /* 1436813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436825 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436850 */     // GIR_Coverage, 6039,
     /* 1436850 */     GIR_EraseRootFromParent_Done,
     /* 1436851 */   // Label 20266: @1436851
     /* 1436851 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1436948), // Rule ID 6218 //
     /* 1436856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436906 */     // MIs[1] Operand 1
     /* 1436906 */     // No operand predicates
     /* 1436906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436910 */     // MIs[0] policy
     /* 1436910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436947 */     // GIR_Coverage, 6218,
     /* 1436947 */     GIR_EraseRootFromParent_Done,
     /* 1436948 */   // Label 20267: @1436948
     /* 1436948 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1437045), // Rule ID 6219 //
     /* 1436953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437003 */     // MIs[1] Operand 1
     /* 1437003 */     // No operand predicates
     /* 1437003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437007 */     // MIs[0] policy
     /* 1437007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1437022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437044 */     // GIR_Coverage, 6219,
     /* 1437044 */     GIR_EraseRootFromParent_Done,
     /* 1437045 */   // Label 20268: @1437045
     /* 1437045 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1437142), // Rule ID 6222 //
     /* 1437050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1437061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1437064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1437067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437100 */     // MIs[1] Operand 1
     /* 1437100 */     // No operand predicates
     /* 1437100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437104 */     // MIs[0] policy
     /* 1437104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437141 */     // GIR_Coverage, 6222,
     /* 1437141 */     GIR_EraseRootFromParent_Done,
     /* 1437142 */   // Label 20269: @1437142
     /* 1437142 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1437239), // Rule ID 6223 //
     /* 1437147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1437158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1437161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1437164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437197 */     // MIs[1] Operand 1
     /* 1437197 */     // No operand predicates
     /* 1437197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437201 */     // MIs[0] policy
     /* 1437201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437213 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437238 */     // GIR_Coverage, 6223,
     /* 1437238 */     GIR_EraseRootFromParent_Done,
     /* 1437239 */   // Label 20270: @1437239
     /* 1437239 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1437336), // Rule ID 6226 //
     /* 1437244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1437255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1437258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1437261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437294 */     // MIs[1] Operand 1
     /* 1437294 */     // No operand predicates
     /* 1437294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437298 */     // MIs[0] policy
     /* 1437298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437335 */     // GIR_Coverage, 6226,
     /* 1437335 */     GIR_EraseRootFromParent_Done,
     /* 1437336 */   // Label 20271: @1437336
     /* 1437336 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1437433), // Rule ID 6227 //
     /* 1437341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1437352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1437355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1437358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437391 */     // MIs[1] Operand 1
     /* 1437391 */     // No operand predicates
     /* 1437391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437395 */     // MIs[0] policy
     /* 1437395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437407 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437432 */     // GIR_Coverage, 6227,
     /* 1437432 */     GIR_EraseRootFromParent_Done,
     /* 1437433 */   // Label 20272: @1437433
     /* 1437433 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1437530), // Rule ID 6230 //
     /* 1437438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437488 */     // MIs[1] Operand 1
     /* 1437488 */     // No operand predicates
     /* 1437488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437492 */     // MIs[0] policy
     /* 1437492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437504 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437529 */     // GIR_Coverage, 6230,
     /* 1437529 */     GIR_EraseRootFromParent_Done,
     /* 1437530 */   // Label 20273: @1437530
     /* 1437530 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1437627), // Rule ID 6231 //
     /* 1437535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437585 */     // MIs[1] Operand 1
     /* 1437585 */     // No operand predicates
     /* 1437585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437589 */     // MIs[0] policy
     /* 1437589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437601 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437626 */     // GIR_Coverage, 6231,
     /* 1437626 */     GIR_EraseRootFromParent_Done,
     /* 1437627 */   // Label 20274: @1437627
     /* 1437627 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1437724), // Rule ID 6234 //
     /* 1437632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437682 */     // MIs[1] Operand 1
     /* 1437682 */     // No operand predicates
     /* 1437682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437686 */     // MIs[0] policy
     /* 1437686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437723 */     // GIR_Coverage, 6234,
     /* 1437723 */     GIR_EraseRootFromParent_Done,
     /* 1437724 */   // Label 20275: @1437724
     /* 1437724 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1437821), // Rule ID 6235 //
     /* 1437729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437779 */     // MIs[1] Operand 1
     /* 1437779 */     // No operand predicates
     /* 1437779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437783 */     // MIs[0] policy
     /* 1437783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437795 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437820 */     // GIR_Coverage, 6235,
     /* 1437820 */     GIR_EraseRootFromParent_Done,
     /* 1437821 */   // Label 20276: @1437821
     /* 1437821 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1437918), // Rule ID 6238 //
     /* 1437826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437876 */     // MIs[1] Operand 1
     /* 1437876 */     // No operand predicates
     /* 1437876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437880 */     // MIs[0] policy
     /* 1437880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437917 */     // GIR_Coverage, 6238,
     /* 1437917 */     GIR_EraseRootFromParent_Done,
     /* 1437918 */   // Label 20277: @1437918
     /* 1437918 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1438015), // Rule ID 6239 //
     /* 1437923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437973 */     // MIs[1] Operand 1
     /* 1437973 */     // No operand predicates
     /* 1437973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437977 */     // MIs[0] policy
     /* 1437977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437989 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438014 */     // GIR_Coverage, 6239,
     /* 1438014 */     GIR_EraseRootFromParent_Done,
     /* 1438015 */   // Label 20278: @1438015
     /* 1438015 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1438112), // Rule ID 6242 //
     /* 1438020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1438031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1438034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1438037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438070 */     // MIs[1] Operand 1
     /* 1438070 */     // No operand predicates
     /* 1438070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438074 */     // MIs[0] policy
     /* 1438074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438086 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438111 */     // GIR_Coverage, 6242,
     /* 1438111 */     GIR_EraseRootFromParent_Done,
     /* 1438112 */   // Label 20279: @1438112
     /* 1438112 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1438209), // Rule ID 6243 //
     /* 1438117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1438128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1438131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1438134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438167 */     // MIs[1] Operand 1
     /* 1438167 */     // No operand predicates
     /* 1438167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438171 */     // MIs[0] policy
     /* 1438171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438208 */     // GIR_Coverage, 6243,
     /* 1438208 */     GIR_EraseRootFromParent_Done,
     /* 1438209 */   // Label 20280: @1438209
     /* 1438209 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1438306), // Rule ID 6246 //
     /* 1438214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1438231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438264 */     // MIs[1] Operand 1
     /* 1438264 */     // No operand predicates
     /* 1438264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438268 */     // MIs[0] policy
     /* 1438268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438305 */     // GIR_Coverage, 6246,
     /* 1438305 */     GIR_EraseRootFromParent_Done,
     /* 1438306 */   // Label 20281: @1438306
     /* 1438306 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1438403), // Rule ID 6247 //
     /* 1438311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1438322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1438325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1438328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438361 */     // MIs[1] Operand 1
     /* 1438361 */     // No operand predicates
     /* 1438361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438365 */     // MIs[0] policy
     /* 1438365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1438399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438402 */     // GIR_Coverage, 6247,
     /* 1438402 */     GIR_EraseRootFromParent_Done,
     /* 1438403 */   // Label 20282: @1438403
     /* 1438403 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1438500), // Rule ID 6250 //
     /* 1438408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438458 */     // MIs[1] Operand 1
     /* 1438458 */     // No operand predicates
     /* 1438458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438462 */     // MIs[0] policy
     /* 1438462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438499 */     // GIR_Coverage, 6250,
     /* 1438499 */     GIR_EraseRootFromParent_Done,
     /* 1438500 */   // Label 20283: @1438500
     /* 1438500 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1438597), // Rule ID 6251 //
     /* 1438505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438555 */     // MIs[1] Operand 1
     /* 1438555 */     // No operand predicates
     /* 1438555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438559 */     // MIs[0] policy
     /* 1438559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438596 */     // GIR_Coverage, 6251,
     /* 1438596 */     GIR_EraseRootFromParent_Done,
     /* 1438597 */   // Label 20284: @1438597
     /* 1438597 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1438694), // Rule ID 6254 //
     /* 1438602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438652 */     // MIs[1] Operand 1
     /* 1438652 */     // No operand predicates
     /* 1438652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438656 */     // MIs[0] policy
     /* 1438656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438693 */     // GIR_Coverage, 6254,
     /* 1438693 */     GIR_EraseRootFromParent_Done,
     /* 1438694 */   // Label 20285: @1438694
     /* 1438694 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1438791), // Rule ID 6255 //
     /* 1438699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438749 */     // MIs[1] Operand 1
     /* 1438749 */     // No operand predicates
     /* 1438749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438753 */     // MIs[0] policy
     /* 1438753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438765 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438790 */     // GIR_Coverage, 6255,
     /* 1438790 */     GIR_EraseRootFromParent_Done,
     /* 1438791 */   // Label 20286: @1438791
     /* 1438791 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1438888), // Rule ID 6258 //
     /* 1438796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438846 */     // MIs[1] Operand 1
     /* 1438846 */     // No operand predicates
     /* 1438846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438850 */     // MIs[0] policy
     /* 1438850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438887 */     // GIR_Coverage, 6258,
     /* 1438887 */     GIR_EraseRootFromParent_Done,
     /* 1438888 */   // Label 20287: @1438888
     /* 1438888 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1438985), // Rule ID 6259 //
     /* 1438893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438943 */     // MIs[1] Operand 1
     /* 1438943 */     // No operand predicates
     /* 1438943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438947 */     // MIs[0] policy
     /* 1438947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438984 */     // GIR_Coverage, 6259,
     /* 1438984 */     GIR_EraseRootFromParent_Done,
     /* 1438985 */   // Label 20288: @1438985
     /* 1438985 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1439082), // Rule ID 6262 //
     /* 1438990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1439001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1439004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1439007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439040 */     // MIs[1] Operand 1
     /* 1439040 */     // No operand predicates
     /* 1439040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439044 */     // MIs[0] policy
     /* 1439044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439081 */     // GIR_Coverage, 6262,
     /* 1439081 */     GIR_EraseRootFromParent_Done,
     /* 1439082 */   // Label 20289: @1439082
     /* 1439082 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1439179), // Rule ID 6263 //
     /* 1439087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1439098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1439101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1439104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439137 */     // MIs[1] Operand 1
     /* 1439137 */     // No operand predicates
     /* 1439137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439141 */     // MIs[0] policy
     /* 1439141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439153 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439178 */     // GIR_Coverage, 6263,
     /* 1439178 */     GIR_EraseRootFromParent_Done,
     /* 1439179 */   // Label 20290: @1439179
     /* 1439179 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1439276), // Rule ID 6266 //
     /* 1439184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1439195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1439198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1439201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1439207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439234 */     // MIs[1] Operand 1
     /* 1439234 */     // No operand predicates
     /* 1439234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439238 */     // MIs[0] policy
     /* 1439238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439250 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439275 */     // GIR_Coverage, 6266,
     /* 1439275 */     GIR_EraseRootFromParent_Done,
     /* 1439276 */   // Label 20291: @1439276
     /* 1439276 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1439373), // Rule ID 6267 //
     /* 1439281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1439292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1439295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1439298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1439304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439331 */     // MIs[1] Operand 1
     /* 1439331 */     // No operand predicates
     /* 1439331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439335 */     // MIs[0] policy
     /* 1439335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439347 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439372 */     // GIR_Coverage, 6267,
     /* 1439372 */     GIR_EraseRootFromParent_Done,
     /* 1439373 */   // Label 20292: @1439373
     /* 1439373 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1439470), // Rule ID 6270 //
     /* 1439378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439428 */     // MIs[1] Operand 1
     /* 1439428 */     // No operand predicates
     /* 1439428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439432 */     // MIs[0] policy
     /* 1439432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439469 */     // GIR_Coverage, 6270,
     /* 1439469 */     GIR_EraseRootFromParent_Done,
     /* 1439470 */   // Label 20293: @1439470
     /* 1439470 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1439567), // Rule ID 6271 //
     /* 1439475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439525 */     // MIs[1] Operand 1
     /* 1439525 */     // No operand predicates
     /* 1439525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439529 */     // MIs[0] policy
     /* 1439529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439566 */     // GIR_Coverage, 6271,
     /* 1439566 */     GIR_EraseRootFromParent_Done,
     /* 1439567 */   // Label 20294: @1439567
     /* 1439567 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1439664), // Rule ID 6274 //
     /* 1439572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439622 */     // MIs[1] Operand 1
     /* 1439622 */     // No operand predicates
     /* 1439622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439626 */     // MIs[0] policy
     /* 1439626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439663 */     // GIR_Coverage, 6274,
     /* 1439663 */     GIR_EraseRootFromParent_Done,
     /* 1439664 */   // Label 20295: @1439664
     /* 1439664 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1439761), // Rule ID 6275 //
     /* 1439669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439719 */     // MIs[1] Operand 1
     /* 1439719 */     // No operand predicates
     /* 1439719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439723 */     // MIs[0] policy
     /* 1439723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439735 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439760 */     // GIR_Coverage, 6275,
     /* 1439760 */     GIR_EraseRootFromParent_Done,
     /* 1439761 */   // Label 20296: @1439761
     /* 1439761 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1439858), // Rule ID 6278 //
     /* 1439766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439816 */     // MIs[1] Operand 1
     /* 1439816 */     // No operand predicates
     /* 1439816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439820 */     // MIs[0] policy
     /* 1439820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439857 */     // GIR_Coverage, 6278,
     /* 1439857 */     GIR_EraseRootFromParent_Done,
     /* 1439858 */   // Label 20297: @1439858
     /* 1439858 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1439955), // Rule ID 6279 //
     /* 1439863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439913 */     // MIs[1] Operand 1
     /* 1439913 */     // No operand predicates
     /* 1439913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439917 */     // MIs[0] policy
     /* 1439917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439954 */     // GIR_Coverage, 6279,
     /* 1439954 */     GIR_EraseRootFromParent_Done,
     /* 1439955 */   // Label 20298: @1439955
     /* 1439955 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1440052), // Rule ID 6282 //
     /* 1439960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440010 */     // MIs[1] Operand 1
     /* 1440010 */     // No operand predicates
     /* 1440010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440014 */     // MIs[0] policy
     /* 1440014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440051 */     // GIR_Coverage, 6282,
     /* 1440051 */     GIR_EraseRootFromParent_Done,
     /* 1440052 */   // Label 20299: @1440052
     /* 1440052 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1440149), // Rule ID 6283 //
     /* 1440057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1440068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1440071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1440074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440107 */     // MIs[1] Operand 1
     /* 1440107 */     // No operand predicates
     /* 1440107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440111 */     // MIs[0] policy
     /* 1440111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440148 */     // GIR_Coverage, 6283,
     /* 1440148 */     GIR_EraseRootFromParent_Done,
     /* 1440149 */   // Label 20300: @1440149
     /* 1440149 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1440246), // Rule ID 6286 //
     /* 1440154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1440171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440204 */     // MIs[1] Operand 1
     /* 1440204 */     // No operand predicates
     /* 1440204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440208 */     // MIs[0] policy
     /* 1440208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440245 */     // GIR_Coverage, 6286,
     /* 1440245 */     GIR_EraseRootFromParent_Done,
     /* 1440246 */   // Label 20301: @1440246
     /* 1440246 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1440343), // Rule ID 6287 //
     /* 1440251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1440262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1440265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1440268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440301 */     // MIs[1] Operand 1
     /* 1440301 */     // No operand predicates
     /* 1440301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440305 */     // MIs[0] policy
     /* 1440305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440342 */     // GIR_Coverage, 6287,
     /* 1440342 */     GIR_EraseRootFromParent_Done,
     /* 1440343 */   // Label 20302: @1440343
     /* 1440343 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1440440), // Rule ID 6290 //
     /* 1440348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1440365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440398 */     // MIs[1] Operand 1
     /* 1440398 */     // No operand predicates
     /* 1440398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440402 */     // MIs[0] policy
     /* 1440402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440439 */     // GIR_Coverage, 6290,
     /* 1440439 */     GIR_EraseRootFromParent_Done,
     /* 1440440 */   // Label 20303: @1440440
     /* 1440440 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1440537), // Rule ID 6291 //
     /* 1440445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1440456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1440459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1440462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440495 */     // MIs[1] Operand 1
     /* 1440495 */     // No operand predicates
     /* 1440495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440499 */     // MIs[0] policy
     /* 1440499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440536 */     // GIR_Coverage, 6291,
     /* 1440536 */     GIR_EraseRootFromParent_Done,
     /* 1440537 */   // Label 20304: @1440537
     /* 1440537 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1440634), // Rule ID 6294 //
     /* 1440542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440592 */     // MIs[1] Operand 1
     /* 1440592 */     // No operand predicates
     /* 1440592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440596 */     // MIs[0] policy
     /* 1440596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440633 */     // GIR_Coverage, 6294,
     /* 1440633 */     GIR_EraseRootFromParent_Done,
     /* 1440634 */   // Label 20305: @1440634
     /* 1440634 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1440731), // Rule ID 6295 //
     /* 1440639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440689 */     // MIs[1] Operand 1
     /* 1440689 */     // No operand predicates
     /* 1440689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440693 */     // MIs[0] policy
     /* 1440693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440730 */     // GIR_Coverage, 6295,
     /* 1440730 */     GIR_EraseRootFromParent_Done,
     /* 1440731 */   // Label 20306: @1440731
     /* 1440731 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1440828), // Rule ID 6298 //
     /* 1440736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440786 */     // MIs[1] Operand 1
     /* 1440786 */     // No operand predicates
     /* 1440786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440790 */     // MIs[0] policy
     /* 1440790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440827 */     // GIR_Coverage, 6298,
     /* 1440827 */     GIR_EraseRootFromParent_Done,
     /* 1440828 */   // Label 20307: @1440828
     /* 1440828 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1440925), // Rule ID 6299 //
     /* 1440833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440883 */     // MIs[1] Operand 1
     /* 1440883 */     // No operand predicates
     /* 1440883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440887 */     // MIs[0] policy
     /* 1440887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440899 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440924 */     // GIR_Coverage, 6299,
     /* 1440924 */     GIR_EraseRootFromParent_Done,
     /* 1440925 */   // Label 20308: @1440925
     /* 1440925 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1441022), // Rule ID 6302 //
     /* 1440930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440980 */     // MIs[1] Operand 1
     /* 1440980 */     // No operand predicates
     /* 1440980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440984 */     // MIs[0] policy
     /* 1440984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1441018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441021 */     // GIR_Coverage, 6302,
     /* 1441021 */     GIR_EraseRootFromParent_Done,
     /* 1441022 */   // Label 20309: @1441022
     /* 1441022 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1441119), // Rule ID 6303 //
     /* 1441027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1441030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1441035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1441038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1441041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1441044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441077 */     // MIs[1] Operand 1
     /* 1441077 */     // No operand predicates
     /* 1441077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441081 */     // MIs[0] policy
     /* 1441081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1441096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1441115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441118 */     // GIR_Coverage, 6303,
     /* 1441118 */     GIR_EraseRootFromParent_Done,
     /* 1441119 */   // Label 20310: @1441119
     /* 1441119 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1441216), // Rule ID 6482 //
     /* 1441124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1441135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1441138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1441141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441174 */     // MIs[1] Operand 1
     /* 1441174 */     // No operand predicates
     /* 1441174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441178 */     // MIs[0] policy
     /* 1441178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1441193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441215 */     // GIR_Coverage, 6482,
     /* 1441215 */     GIR_EraseRootFromParent_Done,
     /* 1441216 */   // Label 20311: @1441216
     /* 1441216 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1441313), // Rule ID 6483 //
     /* 1441221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1441232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1441235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1441238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441271 */     // MIs[1] Operand 1
     /* 1441271 */     // No operand predicates
     /* 1441271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441275 */     // MIs[0] policy
     /* 1441275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441287 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1441290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441312 */     // GIR_Coverage, 6483,
     /* 1441312 */     GIR_EraseRootFromParent_Done,
     /* 1441313 */   // Label 20312: @1441313
     /* 1441313 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1441410), // Rule ID 6486 //
     /* 1441318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1441329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1441332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1441335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441368 */     // MIs[1] Operand 1
     /* 1441368 */     // No operand predicates
     /* 1441368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441372 */     // MIs[0] policy
     /* 1441372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441409 */     // GIR_Coverage, 6486,
     /* 1441409 */     GIR_EraseRootFromParent_Done,
     /* 1441410 */   // Label 20313: @1441410
     /* 1441410 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1441507), // Rule ID 6487 //
     /* 1441415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1441426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1441429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1441432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441465 */     // MIs[1] Operand 1
     /* 1441465 */     // No operand predicates
     /* 1441465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441469 */     // MIs[0] policy
     /* 1441469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441481 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441506 */     // GIR_Coverage, 6487,
     /* 1441506 */     GIR_EraseRootFromParent_Done,
     /* 1441507 */   // Label 20314: @1441507
     /* 1441507 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1441604), // Rule ID 6490 //
     /* 1441512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441562 */     // MIs[1] Operand 1
     /* 1441562 */     // No operand predicates
     /* 1441562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441566 */     // MIs[0] policy
     /* 1441566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441603 */     // GIR_Coverage, 6490,
     /* 1441603 */     GIR_EraseRootFromParent_Done,
     /* 1441604 */   // Label 20315: @1441604
     /* 1441604 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1441701), // Rule ID 6491 //
     /* 1441609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441659 */     // MIs[1] Operand 1
     /* 1441659 */     // No operand predicates
     /* 1441659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441663 */     // MIs[0] policy
     /* 1441663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441675 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441700 */     // GIR_Coverage, 6491,
     /* 1441700 */     GIR_EraseRootFromParent_Done,
     /* 1441701 */   // Label 20316: @1441701
     /* 1441701 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1441798), // Rule ID 6494 //
     /* 1441706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441756 */     // MIs[1] Operand 1
     /* 1441756 */     // No operand predicates
     /* 1441756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441760 */     // MIs[0] policy
     /* 1441760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441772 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441797 */     // GIR_Coverage, 6494,
     /* 1441797 */     GIR_EraseRootFromParent_Done,
     /* 1441798 */   // Label 20317: @1441798
     /* 1441798 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1441895), // Rule ID 6495 //
     /* 1441803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441853 */     // MIs[1] Operand 1
     /* 1441853 */     // No operand predicates
     /* 1441853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441857 */     // MIs[0] policy
     /* 1441857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441894 */     // GIR_Coverage, 6495,
     /* 1441894 */     GIR_EraseRootFromParent_Done,
     /* 1441895 */   // Label 20318: @1441895
     /* 1441895 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1441992), // Rule ID 6498 //
     /* 1441900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441950 */     // MIs[1] Operand 1
     /* 1441950 */     // No operand predicates
     /* 1441950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441954 */     // MIs[0] policy
     /* 1441954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441991 */     // GIR_Coverage, 6498,
     /* 1441991 */     GIR_EraseRootFromParent_Done,
     /* 1441992 */   // Label 20319: @1441992
     /* 1441992 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1442089), // Rule ID 6499 //
     /* 1441997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1442008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1442011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1442014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442047 */     // MIs[1] Operand 1
     /* 1442047 */     // No operand predicates
     /* 1442047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442051 */     // MIs[0] policy
     /* 1442051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442063 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442088 */     // GIR_Coverage, 6499,
     /* 1442088 */     GIR_EraseRootFromParent_Done,
     /* 1442089 */   // Label 20320: @1442089
     /* 1442089 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1442186), // Rule ID 6502 //
     /* 1442094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1442105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1442108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1442111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442144 */     // MIs[1] Operand 1
     /* 1442144 */     // No operand predicates
     /* 1442144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442148 */     // MIs[0] policy
     /* 1442148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442160 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442185 */     // GIR_Coverage, 6502,
     /* 1442185 */     GIR_EraseRootFromParent_Done,
     /* 1442186 */   // Label 20321: @1442186
     /* 1442186 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1442283), // Rule ID 6503 //
     /* 1442191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1442202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1442205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1442208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442241 */     // MIs[1] Operand 1
     /* 1442241 */     // No operand predicates
     /* 1442241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442245 */     // MIs[0] policy
     /* 1442245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442257 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1442260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442282 */     // GIR_Coverage, 6503,
     /* 1442282 */     GIR_EraseRootFromParent_Done,
     /* 1442283 */   // Label 20322: @1442283
     /* 1442283 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1442380), // Rule ID 6506 //
     /* 1442288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1442299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1442302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1442305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442338 */     // MIs[1] Operand 1
     /* 1442338 */     // No operand predicates
     /* 1442338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442342 */     // MIs[0] policy
     /* 1442342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442354 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442379 */     // GIR_Coverage, 6506,
     /* 1442379 */     GIR_EraseRootFromParent_Done,
     /* 1442380 */   // Label 20323: @1442380
     /* 1442380 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1442477), // Rule ID 6507 //
     /* 1442385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1442396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1442399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1442402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442435 */     // MIs[1] Operand 1
     /* 1442435 */     // No operand predicates
     /* 1442435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442439 */     // MIs[0] policy
     /* 1442439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442451 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442476 */     // GIR_Coverage, 6507,
     /* 1442476 */     GIR_EraseRootFromParent_Done,
     /* 1442477 */   // Label 20324: @1442477
     /* 1442477 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1442574), // Rule ID 6510 //
     /* 1442482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442532 */     // MIs[1] Operand 1
     /* 1442532 */     // No operand predicates
     /* 1442532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442536 */     // MIs[0] policy
     /* 1442536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442573 */     // GIR_Coverage, 6510,
     /* 1442573 */     GIR_EraseRootFromParent_Done,
     /* 1442574 */   // Label 20325: @1442574
     /* 1442574 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1442671), // Rule ID 6511 //
     /* 1442579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442629 */     // MIs[1] Operand 1
     /* 1442629 */     // No operand predicates
     /* 1442629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442633 */     // MIs[0] policy
     /* 1442633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442645 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442670 */     // GIR_Coverage, 6511,
     /* 1442670 */     GIR_EraseRootFromParent_Done,
     /* 1442671 */   // Label 20326: @1442671
     /* 1442671 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1442768), // Rule ID 6514 //
     /* 1442676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442726 */     // MIs[1] Operand 1
     /* 1442726 */     // No operand predicates
     /* 1442726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442730 */     // MIs[0] policy
     /* 1442730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442767 */     // GIR_Coverage, 6514,
     /* 1442767 */     GIR_EraseRootFromParent_Done,
     /* 1442768 */   // Label 20327: @1442768
     /* 1442768 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1442865), // Rule ID 6515 //
     /* 1442773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442823 */     // MIs[1] Operand 1
     /* 1442823 */     // No operand predicates
     /* 1442823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442827 */     // MIs[0] policy
     /* 1442827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442839 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442864 */     // GIR_Coverage, 6515,
     /* 1442864 */     GIR_EraseRootFromParent_Done,
     /* 1442865 */   // Label 20328: @1442865
     /* 1442865 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1442962), // Rule ID 6518 //
     /* 1442870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442920 */     // MIs[1] Operand 1
     /* 1442920 */     // No operand predicates
     /* 1442920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442924 */     // MIs[0] policy
     /* 1442924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442961 */     // GIR_Coverage, 6518,
     /* 1442961 */     GIR_EraseRootFromParent_Done,
     /* 1442962 */   // Label 20329: @1442962
     /* 1442962 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1443059), // Rule ID 6519 //
     /* 1442967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443017 */     // MIs[1] Operand 1
     /* 1443017 */     // No operand predicates
     /* 1443017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443021 */     // MIs[0] policy
     /* 1443021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1443036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1443055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443058 */     // GIR_Coverage, 6519,
     /* 1443058 */     GIR_EraseRootFromParent_Done,
     /* 1443059 */   // Label 20330: @1443059
     /* 1443059 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1443156), // Rule ID 6522 //
     /* 1443064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1443075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1443078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1443081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443114 */     // MIs[1] Operand 1
     /* 1443114 */     // No operand predicates
     /* 1443114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443118 */     // MIs[0] policy
     /* 1443118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443155 */     // GIR_Coverage, 6522,
     /* 1443155 */     GIR_EraseRootFromParent_Done,
     /* 1443156 */   // Label 20331: @1443156
     /* 1443156 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1443253), // Rule ID 6523 //
     /* 1443161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1443172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1443175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1443178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443211 */     // MIs[1] Operand 1
     /* 1443211 */     // No operand predicates
     /* 1443211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443215 */     // MIs[0] policy
     /* 1443215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443252 */     // GIR_Coverage, 6523,
     /* 1443252 */     GIR_EraseRootFromParent_Done,
     /* 1443253 */   // Label 20332: @1443253
     /* 1443253 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1443350), // Rule ID 6526 //
     /* 1443258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1443269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1443272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1443275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443308 */     // MIs[1] Operand 1
     /* 1443308 */     // No operand predicates
     /* 1443308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443312 */     // MIs[0] policy
     /* 1443312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443324 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443349 */     // GIR_Coverage, 6526,
     /* 1443349 */     GIR_EraseRootFromParent_Done,
     /* 1443350 */   // Label 20333: @1443350
     /* 1443350 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1443447), // Rule ID 6527 //
     /* 1443355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1443366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1443369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1443372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443405 */     // MIs[1] Operand 1
     /* 1443405 */     // No operand predicates
     /* 1443405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443409 */     // MIs[0] policy
     /* 1443409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443446 */     // GIR_Coverage, 6527,
     /* 1443446 */     GIR_EraseRootFromParent_Done,
     /* 1443447 */   // Label 20334: @1443447
     /* 1443447 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1443544), // Rule ID 6530 //
     /* 1443452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443502 */     // MIs[1] Operand 1
     /* 1443502 */     // No operand predicates
     /* 1443502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443506 */     // MIs[0] policy
     /* 1443506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443518 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443543 */     // GIR_Coverage, 6530,
     /* 1443543 */     GIR_EraseRootFromParent_Done,
     /* 1443544 */   // Label 20335: @1443544
     /* 1443544 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1443641), // Rule ID 6531 //
     /* 1443549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443599 */     // MIs[1] Operand 1
     /* 1443599 */     // No operand predicates
     /* 1443599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443603 */     // MIs[0] policy
     /* 1443603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443615 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443640 */     // GIR_Coverage, 6531,
     /* 1443640 */     GIR_EraseRootFromParent_Done,
     /* 1443641 */   // Label 20336: @1443641
     /* 1443641 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1443738), // Rule ID 6534 //
     /* 1443646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443696 */     // MIs[1] Operand 1
     /* 1443696 */     // No operand predicates
     /* 1443696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443700 */     // MIs[0] policy
     /* 1443700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443737 */     // GIR_Coverage, 6534,
     /* 1443737 */     GIR_EraseRootFromParent_Done,
     /* 1443738 */   // Label 20337: @1443738
     /* 1443738 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1443835), // Rule ID 6535 //
     /* 1443743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443793 */     // MIs[1] Operand 1
     /* 1443793 */     // No operand predicates
     /* 1443793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443797 */     // MIs[0] policy
     /* 1443797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443834 */     // GIR_Coverage, 6535,
     /* 1443834 */     GIR_EraseRootFromParent_Done,
     /* 1443835 */   // Label 20338: @1443835
     /* 1443835 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1443932), // Rule ID 6538 //
     /* 1443840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443890 */     // MIs[1] Operand 1
     /* 1443890 */     // No operand predicates
     /* 1443890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443894 */     // MIs[0] policy
     /* 1443894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443931 */     // GIR_Coverage, 6538,
     /* 1443931 */     GIR_EraseRootFromParent_Done,
     /* 1443932 */   // Label 20339: @1443932
     /* 1443932 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1444029), // Rule ID 6539 //
     /* 1443937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443987 */     // MIs[1] Operand 1
     /* 1443987 */     // No operand predicates
     /* 1443987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443991 */     // MIs[0] policy
     /* 1443991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444003 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444028 */     // GIR_Coverage, 6539,
     /* 1444028 */     GIR_EraseRootFromParent_Done,
     /* 1444029 */   // Label 20340: @1444029
     /* 1444029 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1444126), // Rule ID 6542 //
     /* 1444034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1444045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1444048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1444051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444084 */     // MIs[1] Operand 1
     /* 1444084 */     // No operand predicates
     /* 1444084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444088 */     // MIs[0] policy
     /* 1444088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444125 */     // GIR_Coverage, 6542,
     /* 1444125 */     GIR_EraseRootFromParent_Done,
     /* 1444126 */   // Label 20341: @1444126
     /* 1444126 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1444223), // Rule ID 6543 //
     /* 1444131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1444142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1444145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1444148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444181 */     // MIs[1] Operand 1
     /* 1444181 */     // No operand predicates
     /* 1444181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444185 */     // MIs[0] policy
     /* 1444185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444197 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444222 */     // GIR_Coverage, 6543,
     /* 1444222 */     GIR_EraseRootFromParent_Done,
     /* 1444223 */   // Label 20342: @1444223
     /* 1444223 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1444320), // Rule ID 6546 //
     /* 1444228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1444239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1444242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444278 */     // MIs[1] Operand 1
     /* 1444278 */     // No operand predicates
     /* 1444278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444282 */     // MIs[0] policy
     /* 1444282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444319 */     // GIR_Coverage, 6546,
     /* 1444319 */     GIR_EraseRootFromParent_Done,
     /* 1444320 */   // Label 20343: @1444320
     /* 1444320 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1444417), // Rule ID 6547 //
     /* 1444325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1444336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1444339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1444342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444375 */     // MIs[1] Operand 1
     /* 1444375 */     // No operand predicates
     /* 1444375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444379 */     // MIs[0] policy
     /* 1444379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444416 */     // GIR_Coverage, 6547,
     /* 1444416 */     GIR_EraseRootFromParent_Done,
     /* 1444417 */   // Label 20344: @1444417
     /* 1444417 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1444514), // Rule ID 6550 //
     /* 1444422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444472 */     // MIs[1] Operand 1
     /* 1444472 */     // No operand predicates
     /* 1444472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444476 */     // MIs[0] policy
     /* 1444476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444513 */     // GIR_Coverage, 6550,
     /* 1444513 */     GIR_EraseRootFromParent_Done,
     /* 1444514 */   // Label 20345: @1444514
     /* 1444514 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1444611), // Rule ID 6551 //
     /* 1444519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444569 */     // MIs[1] Operand 1
     /* 1444569 */     // No operand predicates
     /* 1444569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444573 */     // MIs[0] policy
     /* 1444573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444610 */     // GIR_Coverage, 6551,
     /* 1444610 */     GIR_EraseRootFromParent_Done,
     /* 1444611 */   // Label 20346: @1444611
     /* 1444611 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1444708), // Rule ID 6554 //
     /* 1444616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444666 */     // MIs[1] Operand 1
     /* 1444666 */     // No operand predicates
     /* 1444666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444670 */     // MIs[0] policy
     /* 1444670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444707 */     // GIR_Coverage, 6554,
     /* 1444707 */     GIR_EraseRootFromParent_Done,
     /* 1444708 */   // Label 20347: @1444708
     /* 1444708 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1444805), // Rule ID 6555 //
     /* 1444713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444763 */     // MIs[1] Operand 1
     /* 1444763 */     // No operand predicates
     /* 1444763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444767 */     // MIs[0] policy
     /* 1444767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444779 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444804 */     // GIR_Coverage, 6555,
     /* 1444804 */     GIR_EraseRootFromParent_Done,
     /* 1444805 */   // Label 20348: @1444805
     /* 1444805 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1444902), // Rule ID 6558 //
     /* 1444810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444860 */     // MIs[1] Operand 1
     /* 1444860 */     // No operand predicates
     /* 1444860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444864 */     // MIs[0] policy
     /* 1444864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444901 */     // GIR_Coverage, 6558,
     /* 1444901 */     GIR_EraseRootFromParent_Done,
     /* 1444902 */   // Label 20349: @1444902
     /* 1444902 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1444999), // Rule ID 6559 //
     /* 1444907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444957 */     // MIs[1] Operand 1
     /* 1444957 */     // No operand predicates
     /* 1444957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444961 */     // MIs[0] policy
     /* 1444961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444998 */     // GIR_Coverage, 6559,
     /* 1444998 */     GIR_EraseRootFromParent_Done,
     /* 1444999 */   // Label 20350: @1444999
     /* 1444999 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1445096), // Rule ID 6562 //
     /* 1445004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1445007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1445021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445054 */     // MIs[1] Operand 1
     /* 1445054 */     // No operand predicates
     /* 1445054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445058 */     // MIs[0] policy
     /* 1445058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1445073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445095 */     // GIR_Coverage, 6562,
     /* 1445095 */     GIR_EraseRootFromParent_Done,
     /* 1445096 */   // Label 20351: @1445096
     /* 1445096 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1445193), // Rule ID 6563 //
     /* 1445101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1445104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1445112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1445115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1445118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445151 */     // MIs[1] Operand 1
     /* 1445151 */     // No operand predicates
     /* 1445151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445155 */     // MIs[0] policy
     /* 1445155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445167 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1445170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445192 */     // GIR_Coverage, 6563,
     /* 1445192 */     GIR_EraseRootFromParent_Done,
     /* 1445193 */   // Label 20352: @1445193
     /* 1445193 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1445290), // Rule ID 6566 //
     /* 1445198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1445201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1445209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1445212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1445215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445248 */     // MIs[1] Operand 1
     /* 1445248 */     // No operand predicates
     /* 1445248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445252 */     // MIs[0] policy
     /* 1445252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1445267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445289 */     // GIR_Coverage, 6566,
     /* 1445289 */     GIR_EraseRootFromParent_Done,
     /* 1445290 */   // Label 20353: @1445290
     /* 1445290 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1445387), // Rule ID 6567 //
     /* 1445295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1445298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1445303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1445306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1445309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1445312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1445345 */     // MIs[1] Operand 1
     /* 1445345 */     // No operand predicates
     /* 1445345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445349 */     // MIs[0] policy
     /* 1445349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1445364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1445383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445386 */     // GIR_Coverage, 6567,
     /* 1445386 */     GIR_EraseRootFromParent_Done,
     /* 1445387 */   // Label 20354: @1445387
     /* 1445387 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1445484), // Rule ID 6746 //
     /* 1445392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445442 */     // MIs[1] Operand 1
     /* 1445442 */     // No operand predicates
     /* 1445442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445446 */     // MIs[0] policy
     /* 1445446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445483 */     // GIR_Coverage, 6746,
     /* 1445483 */     GIR_EraseRootFromParent_Done,
     /* 1445484 */   // Label 20355: @1445484
     /* 1445484 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1445581), // Rule ID 6747 //
     /* 1445489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445539 */     // MIs[1] Operand 1
     /* 1445539 */     // No operand predicates
     /* 1445539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445543 */     // MIs[0] policy
     /* 1445543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445555 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445580 */     // GIR_Coverage, 6747,
     /* 1445580 */     GIR_EraseRootFromParent_Done,
     /* 1445581 */   // Label 20356: @1445581
     /* 1445581 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1445678), // Rule ID 6750 //
     /* 1445586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445636 */     // MIs[1] Operand 1
     /* 1445636 */     // No operand predicates
     /* 1445636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445640 */     // MIs[0] policy
     /* 1445640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445652 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445677 */     // GIR_Coverage, 6750,
     /* 1445677 */     GIR_EraseRootFromParent_Done,
     /* 1445678 */   // Label 20357: @1445678
     /* 1445678 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1445775), // Rule ID 6751 //
     /* 1445683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445733 */     // MIs[1] Operand 1
     /* 1445733 */     // No operand predicates
     /* 1445733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445737 */     // MIs[0] policy
     /* 1445737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445749 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445774 */     // GIR_Coverage, 6751,
     /* 1445774 */     GIR_EraseRootFromParent_Done,
     /* 1445775 */   // Label 20358: @1445775
     /* 1445775 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1445872), // Rule ID 6754 //
     /* 1445780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445830 */     // MIs[1] Operand 1
     /* 1445830 */     // No operand predicates
     /* 1445830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445834 */     // MIs[0] policy
     /* 1445834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445846 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445871 */     // GIR_Coverage, 6754,
     /* 1445871 */     GIR_EraseRootFromParent_Done,
     /* 1445872 */   // Label 20359: @1445872
     /* 1445872 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1445969), // Rule ID 6755 //
     /* 1445877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445927 */     // MIs[1] Operand 1
     /* 1445927 */     // No operand predicates
     /* 1445927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445931 */     // MIs[0] policy
     /* 1445931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445943 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445968 */     // GIR_Coverage, 6755,
     /* 1445968 */     GIR_EraseRootFromParent_Done,
     /* 1445969 */   // Label 20360: @1445969
     /* 1445969 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1446066), // Rule ID 6758 //
     /* 1445974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446024 */     // MIs[1] Operand 1
     /* 1446024 */     // No operand predicates
     /* 1446024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446028 */     // MIs[0] policy
     /* 1446028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1446043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446065 */     // GIR_Coverage, 6758,
     /* 1446065 */     GIR_EraseRootFromParent_Done,
     /* 1446066 */   // Label 20361: @1446066
     /* 1446066 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1446163), // Rule ID 6759 //
     /* 1446071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1446082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1446085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1446088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446121 */     // MIs[1] Operand 1
     /* 1446121 */     // No operand predicates
     /* 1446121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446125 */     // MIs[0] policy
     /* 1446125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1446140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446162 */     // GIR_Coverage, 6759,
     /* 1446162 */     GIR_EraseRootFromParent_Done,
     /* 1446163 */   // Label 20362: @1446163
     /* 1446163 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1446260), // Rule ID 6762 //
     /* 1446168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1446179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1446182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446218 */     // MIs[1] Operand 1
     /* 1446218 */     // No operand predicates
     /* 1446218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446222 */     // MIs[0] policy
     /* 1446222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446259 */     // GIR_Coverage, 6762,
     /* 1446259 */     GIR_EraseRootFromParent_Done,
     /* 1446260 */   // Label 20363: @1446260
     /* 1446260 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1446357), // Rule ID 6763 //
     /* 1446265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1446276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1446279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1446282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446315 */     // MIs[1] Operand 1
     /* 1446315 */     // No operand predicates
     /* 1446315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446319 */     // MIs[0] policy
     /* 1446319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446331 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446356 */     // GIR_Coverage, 6763,
     /* 1446356 */     GIR_EraseRootFromParent_Done,
     /* 1446357 */   // Label 20364: @1446357
     /* 1446357 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1446454), // Rule ID 6766 //
     /* 1446362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446412 */     // MIs[1] Operand 1
     /* 1446412 */     // No operand predicates
     /* 1446412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446416 */     // MIs[0] policy
     /* 1446416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446453 */     // GIR_Coverage, 6766,
     /* 1446453 */     GIR_EraseRootFromParent_Done,
     /* 1446454 */   // Label 20365: @1446454
     /* 1446454 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1446551), // Rule ID 6767 //
     /* 1446459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446509 */     // MIs[1] Operand 1
     /* 1446509 */     // No operand predicates
     /* 1446509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446513 */     // MIs[0] policy
     /* 1446513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446525 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446550 */     // GIR_Coverage, 6767,
     /* 1446550 */     GIR_EraseRootFromParent_Done,
     /* 1446551 */   // Label 20366: @1446551
     /* 1446551 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1446648), // Rule ID 6770 //
     /* 1446556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446606 */     // MIs[1] Operand 1
     /* 1446606 */     // No operand predicates
     /* 1446606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446610 */     // MIs[0] policy
     /* 1446610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446647 */     // GIR_Coverage, 6770,
     /* 1446647 */     GIR_EraseRootFromParent_Done,
     /* 1446648 */   // Label 20367: @1446648
     /* 1446648 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1446745), // Rule ID 6771 //
     /* 1446653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446703 */     // MIs[1] Operand 1
     /* 1446703 */     // No operand predicates
     /* 1446703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446707 */     // MIs[0] policy
     /* 1446707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446719 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446744 */     // GIR_Coverage, 6771,
     /* 1446744 */     GIR_EraseRootFromParent_Done,
     /* 1446745 */   // Label 20368: @1446745
     /* 1446745 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1446842), // Rule ID 6774 //
     /* 1446750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446800 */     // MIs[1] Operand 1
     /* 1446800 */     // No operand predicates
     /* 1446800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446804 */     // MIs[0] policy
     /* 1446804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446841 */     // GIR_Coverage, 6774,
     /* 1446841 */     GIR_EraseRootFromParent_Done,
     /* 1446842 */   // Label 20369: @1446842
     /* 1446842 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1446939), // Rule ID 6775 //
     /* 1446847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446897 */     // MIs[1] Operand 1
     /* 1446897 */     // No operand predicates
     /* 1446897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446901 */     // MIs[0] policy
     /* 1446901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446913 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446938 */     // GIR_Coverage, 6775,
     /* 1446938 */     GIR_EraseRootFromParent_Done,
     /* 1446939 */   // Label 20370: @1446939
     /* 1446939 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1447036), // Rule ID 6778 //
     /* 1446944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446994 */     // MIs[1] Operand 1
     /* 1446994 */     // No operand predicates
     /* 1446994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446998 */     // MIs[0] policy
     /* 1446998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447035 */     // GIR_Coverage, 6778,
     /* 1447035 */     GIR_EraseRootFromParent_Done,
     /* 1447036 */   // Label 20371: @1447036
     /* 1447036 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1447133), // Rule ID 6779 //
     /* 1447041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1447052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1447055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1447058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447091 */     // MIs[1] Operand 1
     /* 1447091 */     // No operand predicates
     /* 1447091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447095 */     // MIs[0] policy
     /* 1447095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447107 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447132 */     // GIR_Coverage, 6779,
     /* 1447132 */     GIR_EraseRootFromParent_Done,
     /* 1447133 */   // Label 20372: @1447133
     /* 1447133 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1447230), // Rule ID 6782 //
     /* 1447138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1447141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1447155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447188 */     // MIs[1] Operand 1
     /* 1447188 */     // No operand predicates
     /* 1447188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447192 */     // MIs[0] policy
     /* 1447192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1447226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447229 */     // GIR_Coverage, 6782,
     /* 1447229 */     GIR_EraseRootFromParent_Done,
     /* 1447230 */   // Label 20373: @1447230
     /* 1447230 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1447327), // Rule ID 6783 //
     /* 1447235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1447238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1447246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1447249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1447252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447285 */     // MIs[1] Operand 1
     /* 1447285 */     // No operand predicates
     /* 1447285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447289 */     // MIs[0] policy
     /* 1447289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447301 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1447304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1447323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447326 */     // GIR_Coverage, 6783,
     /* 1447326 */     GIR_EraseRootFromParent_Done,
     /* 1447327 */   // Label 20374: @1447327
     /* 1447327 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1447424), // Rule ID 6786 //
     /* 1447332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1447343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1447346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1447349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447382 */     // MIs[1] Operand 1
     /* 1447382 */     // No operand predicates
     /* 1447382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447386 */     // MIs[0] policy
     /* 1447386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447423 */     // GIR_Coverage, 6786,
     /* 1447423 */     GIR_EraseRootFromParent_Done,
     /* 1447424 */   // Label 20375: @1447424
     /* 1447424 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1447521), // Rule ID 6787 //
     /* 1447429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1447440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1447443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1447446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447479 */     // MIs[1] Operand 1
     /* 1447479 */     // No operand predicates
     /* 1447479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447483 */     // MIs[0] policy
     /* 1447483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447495 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447520 */     // GIR_Coverage, 6787,
     /* 1447520 */     GIR_EraseRootFromParent_Done,
     /* 1447521 */   // Label 20376: @1447521
     /* 1447521 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1447618), // Rule ID 6790 //
     /* 1447526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447576 */     // MIs[1] Operand 1
     /* 1447576 */     // No operand predicates
     /* 1447576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447580 */     // MIs[0] policy
     /* 1447580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447617 */     // GIR_Coverage, 6790,
     /* 1447617 */     GIR_EraseRootFromParent_Done,
     /* 1447618 */   // Label 20377: @1447618
     /* 1447618 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1447715), // Rule ID 6791 //
     /* 1447623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447673 */     // MIs[1] Operand 1
     /* 1447673 */     // No operand predicates
     /* 1447673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447677 */     // MIs[0] policy
     /* 1447677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447689 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447714 */     // GIR_Coverage, 6791,
     /* 1447714 */     GIR_EraseRootFromParent_Done,
     /* 1447715 */   // Label 20378: @1447715
     /* 1447715 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1447812), // Rule ID 6794 //
     /* 1447720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447770 */     // MIs[1] Operand 1
     /* 1447770 */     // No operand predicates
     /* 1447770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447774 */     // MIs[0] policy
     /* 1447774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447786 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447811 */     // GIR_Coverage, 6794,
     /* 1447811 */     GIR_EraseRootFromParent_Done,
     /* 1447812 */   // Label 20379: @1447812
     /* 1447812 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1447909), // Rule ID 6795 //
     /* 1447817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447867 */     // MIs[1] Operand 1
     /* 1447867 */     // No operand predicates
     /* 1447867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447871 */     // MIs[0] policy
     /* 1447871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447883 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447908 */     // GIR_Coverage, 6795,
     /* 1447908 */     GIR_EraseRootFromParent_Done,
     /* 1447909 */   // Label 20380: @1447909
     /* 1447909 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1448006), // Rule ID 6798 //
     /* 1447914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447964 */     // MIs[1] Operand 1
     /* 1447964 */     // No operand predicates
     /* 1447964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447968 */     // MIs[0] policy
     /* 1447968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448005 */     // GIR_Coverage, 6798,
     /* 1448005 */     GIR_EraseRootFromParent_Done,
     /* 1448006 */   // Label 20381: @1448006
     /* 1448006 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1448103), // Rule ID 6799 //
     /* 1448011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1448022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1448025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1448028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448061 */     // MIs[1] Operand 1
     /* 1448061 */     // No operand predicates
     /* 1448061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448065 */     // MIs[0] policy
     /* 1448065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448102 */     // GIR_Coverage, 6799,
     /* 1448102 */     GIR_EraseRootFromParent_Done,
     /* 1448103 */   // Label 20382: @1448103
     /* 1448103 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1448200), // Rule ID 6802 //
     /* 1448108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1448119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1448122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1448125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448158 */     // MIs[1] Operand 1
     /* 1448158 */     // No operand predicates
     /* 1448158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448162 */     // MIs[0] policy
     /* 1448162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448174 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448199 */     // GIR_Coverage, 6802,
     /* 1448199 */     GIR_EraseRootFromParent_Done,
     /* 1448200 */   // Label 20383: @1448200
     /* 1448200 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1448297), // Rule ID 6803 //
     /* 1448205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1448216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1448219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1448222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448255 */     // MIs[1] Operand 1
     /* 1448255 */     // No operand predicates
     /* 1448255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448259 */     // MIs[0] policy
     /* 1448259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448296 */     // GIR_Coverage, 6803,
     /* 1448296 */     GIR_EraseRootFromParent_Done,
     /* 1448297 */   // Label 20384: @1448297
     /* 1448297 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1448394), // Rule ID 6806 //
     /* 1448302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1448313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1448316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1448319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1448325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448352 */     // MIs[1] Operand 1
     /* 1448352 */     // No operand predicates
     /* 1448352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448356 */     // MIs[0] policy
     /* 1448356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448393 */     // GIR_Coverage, 6806,
     /* 1448393 */     GIR_EraseRootFromParent_Done,
     /* 1448394 */   // Label 20385: @1448394
     /* 1448394 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1448491), // Rule ID 6807 //
     /* 1448399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1448410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1448413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1448416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1448422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448449 */     // MIs[1] Operand 1
     /* 1448449 */     // No operand predicates
     /* 1448449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448453 */     // MIs[0] policy
     /* 1448453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448465 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448490 */     // GIR_Coverage, 6807,
     /* 1448490 */     GIR_EraseRootFromParent_Done,
     /* 1448491 */   // Label 20386: @1448491
     /* 1448491 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1448588), // Rule ID 6810 //
     /* 1448496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448546 */     // MIs[1] Operand 1
     /* 1448546 */     // No operand predicates
     /* 1448546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448550 */     // MIs[0] policy
     /* 1448550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448587 */     // GIR_Coverage, 6810,
     /* 1448587 */     GIR_EraseRootFromParent_Done,
     /* 1448588 */   // Label 20387: @1448588
     /* 1448588 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1448685), // Rule ID 6811 //
     /* 1448593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448643 */     // MIs[1] Operand 1
     /* 1448643 */     // No operand predicates
     /* 1448643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448647 */     // MIs[0] policy
     /* 1448647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448684 */     // GIR_Coverage, 6811,
     /* 1448684 */     GIR_EraseRootFromParent_Done,
     /* 1448685 */   // Label 20388: @1448685
     /* 1448685 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1448782), // Rule ID 6814 //
     /* 1448690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448740 */     // MIs[1] Operand 1
     /* 1448740 */     // No operand predicates
     /* 1448740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448744 */     // MIs[0] policy
     /* 1448744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448781 */     // GIR_Coverage, 6814,
     /* 1448781 */     GIR_EraseRootFromParent_Done,
     /* 1448782 */   // Label 20389: @1448782
     /* 1448782 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1448879), // Rule ID 6815 //
     /* 1448787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448837 */     // MIs[1] Operand 1
     /* 1448837 */     // No operand predicates
     /* 1448837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448841 */     // MIs[0] policy
     /* 1448841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448853 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448878 */     // GIR_Coverage, 6815,
     /* 1448878 */     GIR_EraseRootFromParent_Done,
     /* 1448879 */   // Label 20390: @1448879
     /* 1448879 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1448976), // Rule ID 6818 //
     /* 1448884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448934 */     // MIs[1] Operand 1
     /* 1448934 */     // No operand predicates
     /* 1448934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448938 */     // MIs[0] policy
     /* 1448938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448975 */     // GIR_Coverage, 6818,
     /* 1448975 */     GIR_EraseRootFromParent_Done,
     /* 1448976 */   // Label 20391: @1448976
     /* 1448976 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1449073), // Rule ID 6819 //
     /* 1448981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449031 */     // MIs[1] Operand 1
     /* 1449031 */     // No operand predicates
     /* 1449031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449035 */     // MIs[0] policy
     /* 1449035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449047 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1449069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449072 */     // GIR_Coverage, 6819,
     /* 1449072 */     GIR_EraseRootFromParent_Done,
     /* 1449073 */   // Label 20392: @1449073
     /* 1449073 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1449170), // Rule ID 6822 //
     /* 1449078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1449089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1449092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1449095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449128 */     // MIs[1] Operand 1
     /* 1449128 */     // No operand predicates
     /* 1449128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449132 */     // MIs[0] policy
     /* 1449132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1449147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449169 */     // GIR_Coverage, 6822,
     /* 1449169 */     GIR_EraseRootFromParent_Done,
     /* 1449170 */   // Label 20393: @1449170
     /* 1449170 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1449267), // Rule ID 6823 //
     /* 1449175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1449186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1449189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1449192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449225 */     // MIs[1] Operand 1
     /* 1449225 */     // No operand predicates
     /* 1449225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449229 */     // MIs[0] policy
     /* 1449229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449241 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1449244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449266 */     // GIR_Coverage, 6823,
     /* 1449266 */     GIR_EraseRootFromParent_Done,
     /* 1449267 */   // Label 20394: @1449267
     /* 1449267 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1449364), // Rule ID 6826 //
     /* 1449272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1449283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1449286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1449289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449322 */     // MIs[1] Operand 1
     /* 1449322 */     // No operand predicates
     /* 1449322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449326 */     // MIs[0] policy
     /* 1449326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1449341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449363 */     // GIR_Coverage, 6826,
     /* 1449363 */     GIR_EraseRootFromParent_Done,
     /* 1449364 */   // Label 20395: @1449364
     /* 1449364 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1449461), // Rule ID 6827 //
     /* 1449369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1449380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1449383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1449386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449419 */     // MIs[1] Operand 1
     /* 1449419 */     // No operand predicates
     /* 1449419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449423 */     // MIs[0] policy
     /* 1449423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449435 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1449438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449460 */     // GIR_Coverage, 6827,
     /* 1449460 */     GIR_EraseRootFromParent_Done,
     /* 1449461 */   // Label 20396: @1449461
     /* 1449461 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1449558), // Rule ID 6830 //
     /* 1449466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449516 */     // MIs[1] Operand 1
     /* 1449516 */     // No operand predicates
     /* 1449516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449520 */     // MIs[0] policy
     /* 1449520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449532 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449557 */     // GIR_Coverage, 6830,
     /* 1449557 */     GIR_EraseRootFromParent_Done,
     /* 1449558 */   // Label 20397: @1449558
     /* 1449558 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1449655), // Rule ID 6831 //
     /* 1449563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449613 */     // MIs[1] Operand 1
     /* 1449613 */     // No operand predicates
     /* 1449613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449617 */     // MIs[0] policy
     /* 1449617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449654 */     // GIR_Coverage, 6831,
     /* 1449654 */     GIR_EraseRootFromParent_Done,
     /* 1449655 */   // Label 20398: @1449655
     /* 1449655 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1449752), // Rule ID 7010 //
     /* 1449660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449710 */     // MIs[1] Operand 1
     /* 1449710 */     // No operand predicates
     /* 1449710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449714 */     // MIs[0] policy
     /* 1449714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449751 */     // GIR_Coverage, 7010,
     /* 1449751 */     GIR_EraseRootFromParent_Done,
     /* 1449752 */   // Label 20399: @1449752
     /* 1449752 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1449849), // Rule ID 7011 //
     /* 1449757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449807 */     // MIs[1] Operand 1
     /* 1449807 */     // No operand predicates
     /* 1449807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449811 */     // MIs[0] policy
     /* 1449811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449823 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449848 */     // GIR_Coverage, 7011,
     /* 1449848 */     GIR_EraseRootFromParent_Done,
     /* 1449849 */   // Label 20400: @1449849
     /* 1449849 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1449946), // Rule ID 7014 //
     /* 1449854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449904 */     // MIs[1] Operand 1
     /* 1449904 */     // No operand predicates
     /* 1449904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449908 */     // MIs[0] policy
     /* 1449908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449920 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449945 */     // GIR_Coverage, 7014,
     /* 1449945 */     GIR_EraseRootFromParent_Done,
     /* 1449946 */   // Label 20401: @1449946
     /* 1449946 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1450043), // Rule ID 7015 //
     /* 1449951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450001 */     // MIs[1] Operand 1
     /* 1450001 */     // No operand predicates
     /* 1450001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450005 */     // MIs[0] policy
     /* 1450005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450017 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450042 */     // GIR_Coverage, 7015,
     /* 1450042 */     GIR_EraseRootFromParent_Done,
     /* 1450043 */   // Label 20402: @1450043
     /* 1450043 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1450140), // Rule ID 7018 //
     /* 1450048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1450059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1450062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1450065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450098 */     // MIs[1] Operand 1
     /* 1450098 */     // No operand predicates
     /* 1450098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450102 */     // MIs[0] policy
     /* 1450102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450114 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450139 */     // GIR_Coverage, 7018,
     /* 1450139 */     GIR_EraseRootFromParent_Done,
     /* 1450140 */   // Label 20403: @1450140
     /* 1450140 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1450237), // Rule ID 7019 //
     /* 1450145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1450156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1450159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1450162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450195 */     // MIs[1] Operand 1
     /* 1450195 */     // No operand predicates
     /* 1450195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450199 */     // MIs[0] policy
     /* 1450199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450211 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450236 */     // GIR_Coverage, 7019,
     /* 1450236 */     GIR_EraseRootFromParent_Done,
     /* 1450237 */   // Label 20404: @1450237
     /* 1450237 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1450334), // Rule ID 7022 //
     /* 1450242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1450253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1450256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1450259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450292 */     // MIs[1] Operand 1
     /* 1450292 */     // No operand predicates
     /* 1450292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450296 */     // MIs[0] policy
     /* 1450296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450333 */     // GIR_Coverage, 7022,
     /* 1450333 */     GIR_EraseRootFromParent_Done,
     /* 1450334 */   // Label 20405: @1450334
     /* 1450334 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1450431), // Rule ID 7023 //
     /* 1450339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1450350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1450353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1450356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450389 */     // MIs[1] Operand 1
     /* 1450389 */     // No operand predicates
     /* 1450389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450393 */     // MIs[0] policy
     /* 1450393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1450408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450430 */     // GIR_Coverage, 7023,
     /* 1450430 */     GIR_EraseRootFromParent_Done,
     /* 1450431 */   // Label 20406: @1450431
     /* 1450431 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1450528), // Rule ID 7026 //
     /* 1450436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450486 */     // MIs[1] Operand 1
     /* 1450486 */     // No operand predicates
     /* 1450486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450490 */     // MIs[0] policy
     /* 1450490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450527 */     // GIR_Coverage, 7026,
     /* 1450527 */     GIR_EraseRootFromParent_Done,
     /* 1450528 */   // Label 20407: @1450528
     /* 1450528 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1450625), // Rule ID 7027 //
     /* 1450533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450583 */     // MIs[1] Operand 1
     /* 1450583 */     // No operand predicates
     /* 1450583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450587 */     // MIs[0] policy
     /* 1450587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450599 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450624 */     // GIR_Coverage, 7027,
     /* 1450624 */     GIR_EraseRootFromParent_Done,
     /* 1450625 */   // Label 20408: @1450625
     /* 1450625 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1450722), // Rule ID 7030 //
     /* 1450630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450680 */     // MIs[1] Operand 1
     /* 1450680 */     // No operand predicates
     /* 1450680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450684 */     // MIs[0] policy
     /* 1450684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450721 */     // GIR_Coverage, 7030,
     /* 1450721 */     GIR_EraseRootFromParent_Done,
     /* 1450722 */   // Label 20409: @1450722
     /* 1450722 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1450819), // Rule ID 7031 //
     /* 1450727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450777 */     // MIs[1] Operand 1
     /* 1450777 */     // No operand predicates
     /* 1450777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450781 */     // MIs[0] policy
     /* 1450781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450793 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450818 */     // GIR_Coverage, 7031,
     /* 1450818 */     GIR_EraseRootFromParent_Done,
     /* 1450819 */   // Label 20410: @1450819
     /* 1450819 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1450916), // Rule ID 7034 //
     /* 1450824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450874 */     // MIs[1] Operand 1
     /* 1450874 */     // No operand predicates
     /* 1450874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450878 */     // MIs[0] policy
     /* 1450878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450915 */     // GIR_Coverage, 7034,
     /* 1450915 */     GIR_EraseRootFromParent_Done,
     /* 1450916 */   // Label 20411: @1450916
     /* 1450916 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1451013), // Rule ID 7035 //
     /* 1450921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450971 */     // MIs[1] Operand 1
     /* 1450971 */     // No operand predicates
     /* 1450971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450975 */     // MIs[0] policy
     /* 1450975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450987 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451012 */     // GIR_Coverage, 7035,
     /* 1451012 */     GIR_EraseRootFromParent_Done,
     /* 1451013 */   // Label 20412: @1451013
     /* 1451013 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1451110), // Rule ID 7038 //
     /* 1451018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1451029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1451032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451068 */     // MIs[1] Operand 1
     /* 1451068 */     // No operand predicates
     /* 1451068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451072 */     // MIs[0] policy
     /* 1451072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451109 */     // GIR_Coverage, 7038,
     /* 1451109 */     GIR_EraseRootFromParent_Done,
     /* 1451110 */   // Label 20413: @1451110
     /* 1451110 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1451207), // Rule ID 7039 //
     /* 1451115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1451126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1451129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451165 */     // MIs[1] Operand 1
     /* 1451165 */     // No operand predicates
     /* 1451165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451169 */     // MIs[0] policy
     /* 1451169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451181 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451206 */     // GIR_Coverage, 7039,
     /* 1451206 */     GIR_EraseRootFromParent_Done,
     /* 1451207 */   // Label 20414: @1451207
     /* 1451207 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1451304), // Rule ID 7042 //
     /* 1451212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1451223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1451226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1451229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451262 */     // MIs[1] Operand 1
     /* 1451262 */     // No operand predicates
     /* 1451262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451266 */     // MIs[0] policy
     /* 1451266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451303 */     // GIR_Coverage, 7042,
     /* 1451303 */     GIR_EraseRootFromParent_Done,
     /* 1451304 */   // Label 20415: @1451304
     /* 1451304 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1451401), // Rule ID 7043 //
     /* 1451309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1451320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1451323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1451326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451359 */     // MIs[1] Operand 1
     /* 1451359 */     // No operand predicates
     /* 1451359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451363 */     // MIs[0] policy
     /* 1451363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451375 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1451397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451400 */     // GIR_Coverage, 7043,
     /* 1451400 */     GIR_EraseRootFromParent_Done,
     /* 1451401 */   // Label 20416: @1451401
     /* 1451401 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1451498), // Rule ID 7046 //
     /* 1451406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1451409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451456 */     // MIs[1] Operand 1
     /* 1451456 */     // No operand predicates
     /* 1451456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451460 */     // MIs[0] policy
     /* 1451460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451497 */     // GIR_Coverage, 7046,
     /* 1451497 */     GIR_EraseRootFromParent_Done,
     /* 1451498 */   // Label 20417: @1451498
     /* 1451498 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1451595), // Rule ID 7047 //
     /* 1451503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451553 */     // MIs[1] Operand 1
     /* 1451553 */     // No operand predicates
     /* 1451553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451557 */     // MIs[0] policy
     /* 1451557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451594 */     // GIR_Coverage, 7047,
     /* 1451594 */     GIR_EraseRootFromParent_Done,
     /* 1451595 */   // Label 20418: @1451595
     /* 1451595 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1451692), // Rule ID 7050 //
     /* 1451600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451650 */     // MIs[1] Operand 1
     /* 1451650 */     // No operand predicates
     /* 1451650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451654 */     // MIs[0] policy
     /* 1451654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451691 */     // GIR_Coverage, 7050,
     /* 1451691 */     GIR_EraseRootFromParent_Done,
     /* 1451692 */   // Label 20419: @1451692
     /* 1451692 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1451789), // Rule ID 7051 //
     /* 1451697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451747 */     // MIs[1] Operand 1
     /* 1451747 */     // No operand predicates
     /* 1451747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451751 */     // MIs[0] policy
     /* 1451751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451763 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451788 */     // GIR_Coverage, 7051,
     /* 1451788 */     GIR_EraseRootFromParent_Done,
     /* 1451789 */   // Label 20420: @1451789
     /* 1451789 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1451886), // Rule ID 7054 //
     /* 1451794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451844 */     // MIs[1] Operand 1
     /* 1451844 */     // No operand predicates
     /* 1451844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451848 */     // MIs[0] policy
     /* 1451848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451860 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451885 */     // GIR_Coverage, 7054,
     /* 1451885 */     GIR_EraseRootFromParent_Done,
     /* 1451886 */   // Label 20421: @1451886
     /* 1451886 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1451983), // Rule ID 7055 //
     /* 1451891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451941 */     // MIs[1] Operand 1
     /* 1451941 */     // No operand predicates
     /* 1451941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451945 */     // MIs[0] policy
     /* 1451945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451957 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451982 */     // GIR_Coverage, 7055,
     /* 1451982 */     GIR_EraseRootFromParent_Done,
     /* 1451983 */   // Label 20422: @1451983
     /* 1451983 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1452080), // Rule ID 7058 //
     /* 1451988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1452002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1452005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1452011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452038 */     // MIs[1] Operand 1
     /* 1452038 */     // No operand predicates
     /* 1452038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452042 */     // MIs[0] policy
     /* 1452042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452054 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452079 */     // GIR_Coverage, 7058,
     /* 1452079 */     GIR_EraseRootFromParent_Done,
     /* 1452080 */   // Label 20423: @1452080
     /* 1452080 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1452177), // Rule ID 7059 //
     /* 1452085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1452096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1452099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1452102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1452108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452135 */     // MIs[1] Operand 1
     /* 1452135 */     // No operand predicates
     /* 1452135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452139 */     // MIs[0] policy
     /* 1452139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452151 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452176 */     // GIR_Coverage, 7059,
     /* 1452176 */     GIR_EraseRootFromParent_Done,
     /* 1452177 */   // Label 20424: @1452177
     /* 1452177 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1452274), // Rule ID 7062 //
     /* 1452182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1452199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452232 */     // MIs[1] Operand 1
     /* 1452232 */     // No operand predicates
     /* 1452232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452236 */     // MIs[0] policy
     /* 1452236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452273 */     // GIR_Coverage, 7062,
     /* 1452273 */     GIR_EraseRootFromParent_Done,
     /* 1452274 */   // Label 20425: @1452274
     /* 1452274 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1452371), // Rule ID 7063 //
     /* 1452279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1452296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452329 */     // MIs[1] Operand 1
     /* 1452329 */     // No operand predicates
     /* 1452329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452333 */     // MIs[0] policy
     /* 1452333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452370 */     // GIR_Coverage, 7063,
     /* 1452370 */     GIR_EraseRootFromParent_Done,
     /* 1452371 */   // Label 20426: @1452371
     /* 1452371 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1452468), // Rule ID 7066 //
     /* 1452376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452426 */     // MIs[1] Operand 1
     /* 1452426 */     // No operand predicates
     /* 1452426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452430 */     // MIs[0] policy
     /* 1452430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452467 */     // GIR_Coverage, 7066,
     /* 1452467 */     GIR_EraseRootFromParent_Done,
     /* 1452468 */   // Label 20427: @1452468
     /* 1452468 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1452565), // Rule ID 7067 //
     /* 1452473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452523 */     // MIs[1] Operand 1
     /* 1452523 */     // No operand predicates
     /* 1452523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452527 */     // MIs[0] policy
     /* 1452527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452564 */     // GIR_Coverage, 7067,
     /* 1452564 */     GIR_EraseRootFromParent_Done,
     /* 1452565 */   // Label 20428: @1452565
     /* 1452565 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1452662), // Rule ID 7070 //
     /* 1452570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452620 */     // MIs[1] Operand 1
     /* 1452620 */     // No operand predicates
     /* 1452620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452624 */     // MIs[0] policy
     /* 1452624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452636 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452661 */     // GIR_Coverage, 7070,
     /* 1452661 */     GIR_EraseRootFromParent_Done,
     /* 1452662 */   // Label 20429: @1452662
     /* 1452662 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1452759), // Rule ID 7071 //
     /* 1452667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452717 */     // MIs[1] Operand 1
     /* 1452717 */     // No operand predicates
     /* 1452717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452721 */     // MIs[0] policy
     /* 1452721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452733 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452758 */     // GIR_Coverage, 7071,
     /* 1452758 */     GIR_EraseRootFromParent_Done,
     /* 1452759 */   // Label 20430: @1452759
     /* 1452759 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1452856), // Rule ID 7074 //
     /* 1452764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452814 */     // MIs[1] Operand 1
     /* 1452814 */     // No operand predicates
     /* 1452814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452818 */     // MIs[0] policy
     /* 1452818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452855 */     // GIR_Coverage, 7074,
     /* 1452855 */     GIR_EraseRootFromParent_Done,
     /* 1452856 */   // Label 20431: @1452856
     /* 1452856 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1452953), // Rule ID 7075 //
     /* 1452861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452911 */     // MIs[1] Operand 1
     /* 1452911 */     // No operand predicates
     /* 1452911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452915 */     // MIs[0] policy
     /* 1452915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452952 */     // GIR_Coverage, 7075,
     /* 1452952 */     GIR_EraseRootFromParent_Done,
     /* 1452953 */   // Label 20432: @1452953
     /* 1452953 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1453050), // Rule ID 7078 //
     /* 1452958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453008 */     // MIs[1] Operand 1
     /* 1453008 */     // No operand predicates
     /* 1453008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453012 */     // MIs[0] policy
     /* 1453012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453049 */     // GIR_Coverage, 7078,
     /* 1453049 */     GIR_EraseRootFromParent_Done,
     /* 1453050 */   // Label 20433: @1453050
     /* 1453050 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1453147), // Rule ID 7079 //
     /* 1453055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1453072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453105 */     // MIs[1] Operand 1
     /* 1453105 */     // No operand predicates
     /* 1453105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453109 */     // MIs[0] policy
     /* 1453109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453146 */     // GIR_Coverage, 7079,
     /* 1453146 */     GIR_EraseRootFromParent_Done,
     /* 1453147 */   // Label 20434: @1453147
     /* 1453147 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1453244), // Rule ID 7082 //
     /* 1453152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453202 */     // MIs[1] Operand 1
     /* 1453202 */     // No operand predicates
     /* 1453202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453206 */     // MIs[0] policy
     /* 1453206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453243 */     // GIR_Coverage, 7082,
     /* 1453243 */     GIR_EraseRootFromParent_Done,
     /* 1453244 */   // Label 20435: @1453244
     /* 1453244 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1453341), // Rule ID 7083 //
     /* 1453249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1453260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1453263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453299 */     // MIs[1] Operand 1
     /* 1453299 */     // No operand predicates
     /* 1453299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453303 */     // MIs[0] policy
     /* 1453303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453340 */     // GIR_Coverage, 7083,
     /* 1453340 */     GIR_EraseRootFromParent_Done,
     /* 1453341 */   // Label 20436: @1453341
     /* 1453341 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1453438), // Rule ID 7086 //
     /* 1453346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453396 */     // MIs[1] Operand 1
     /* 1453396 */     // No operand predicates
     /* 1453396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453400 */     // MIs[0] policy
     /* 1453400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453437 */     // GIR_Coverage, 7086,
     /* 1453437 */     GIR_EraseRootFromParent_Done,
     /* 1453438 */   // Label 20437: @1453438
     /* 1453438 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1453535), // Rule ID 7087 //
     /* 1453443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1453454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1453457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453493 */     // MIs[1] Operand 1
     /* 1453493 */     // No operand predicates
     /* 1453493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453497 */     // MIs[0] policy
     /* 1453497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453534 */     // GIR_Coverage, 7087,
     /* 1453534 */     GIR_EraseRootFromParent_Done,
     /* 1453535 */   // Label 20438: @1453535
     /* 1453535 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1453632), // Rule ID 7090 //
     /* 1453540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453590 */     // MIs[1] Operand 1
     /* 1453590 */     // No operand predicates
     /* 1453590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453594 */     // MIs[0] policy
     /* 1453594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453631 */     // GIR_Coverage, 7090,
     /* 1453631 */     GIR_EraseRootFromParent_Done,
     /* 1453632 */   // Label 20439: @1453632
     /* 1453632 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1453729), // Rule ID 7091 //
     /* 1453637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453687 */     // MIs[1] Operand 1
     /* 1453687 */     // No operand predicates
     /* 1453687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453691 */     // MIs[0] policy
     /* 1453691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453703 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453728 */     // GIR_Coverage, 7091,
     /* 1453728 */     GIR_EraseRootFromParent_Done,
     /* 1453729 */   // Label 20440: @1453729
     /* 1453729 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1453826), // Rule ID 7094 //
     /* 1453734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453784 */     // MIs[1] Operand 1
     /* 1453784 */     // No operand predicates
     /* 1453784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453788 */     // MIs[0] policy
     /* 1453788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453825 */     // GIR_Coverage, 7094,
     /* 1453825 */     GIR_EraseRootFromParent_Done,
     /* 1453826 */   // Label 20441: @1453826
     /* 1453826 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1453923), // Rule ID 7095 //
     /* 1453831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453881 */     // MIs[1] Operand 1
     /* 1453881 */     // No operand predicates
     /* 1453881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453885 */     // MIs[0] policy
     /* 1453885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453897 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453922 */     // GIR_Coverage, 7095,
     /* 1453922 */     GIR_EraseRootFromParent_Done,
     /* 1453923 */   // Label 20442: @1453923
     /* 1453923 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1454020), // Rule ID 7274 //
     /* 1453928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453978 */     // MIs[1] Operand 1
     /* 1453978 */     // No operand predicates
     /* 1453978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453982 */     // MIs[0] policy
     /* 1453982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1453997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454019 */     // GIR_Coverage, 7274,
     /* 1454019 */     GIR_EraseRootFromParent_Done,
     /* 1454020 */   // Label 20443: @1454020
     /* 1454020 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1454117), // Rule ID 7275 //
     /* 1454025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1454036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1454039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1454042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454075 */     // MIs[1] Operand 1
     /* 1454075 */     // No operand predicates
     /* 1454075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454079 */     // MIs[0] policy
     /* 1454079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454091 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1454094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454116 */     // GIR_Coverage, 7275,
     /* 1454116 */     GIR_EraseRootFromParent_Done,
     /* 1454117 */   // Label 20444: @1454117
     /* 1454117 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1454214), // Rule ID 7278 //
     /* 1454122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1454139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454172 */     // MIs[1] Operand 1
     /* 1454172 */     // No operand predicates
     /* 1454172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454176 */     // MIs[0] policy
     /* 1454176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454188 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454213 */     // GIR_Coverage, 7278,
     /* 1454213 */     GIR_EraseRootFromParent_Done,
     /* 1454214 */   // Label 20445: @1454214
     /* 1454214 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1454311), // Rule ID 7279 //
     /* 1454219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1454236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454269 */     // MIs[1] Operand 1
     /* 1454269 */     // No operand predicates
     /* 1454269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454273 */     // MIs[0] policy
     /* 1454273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454285 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454310 */     // GIR_Coverage, 7279,
     /* 1454310 */     GIR_EraseRootFromParent_Done,
     /* 1454311 */   // Label 20446: @1454311
     /* 1454311 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1454408), // Rule ID 7282 //
     /* 1454316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1454333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454366 */     // MIs[1] Operand 1
     /* 1454366 */     // No operand predicates
     /* 1454366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454370 */     // MIs[0] policy
     /* 1454370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454382 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454407 */     // GIR_Coverage, 7282,
     /* 1454407 */     GIR_EraseRootFromParent_Done,
     /* 1454408 */   // Label 20447: @1454408
     /* 1454408 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1454505), // Rule ID 7283 //
     /* 1454413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1454430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454463 */     // MIs[1] Operand 1
     /* 1454463 */     // No operand predicates
     /* 1454463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454467 */     // MIs[0] policy
     /* 1454467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454479 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454504 */     // GIR_Coverage, 7283,
     /* 1454504 */     GIR_EraseRootFromParent_Done,
     /* 1454505 */   // Label 20448: @1454505
     /* 1454505 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1454602), // Rule ID 7286 //
     /* 1454510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454560 */     // MIs[1] Operand 1
     /* 1454560 */     // No operand predicates
     /* 1454560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454564 */     // MIs[0] policy
     /* 1454564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454601 */     // GIR_Coverage, 7286,
     /* 1454601 */     GIR_EraseRootFromParent_Done,
     /* 1454602 */   // Label 20449: @1454602
     /* 1454602 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1454699), // Rule ID 7287 //
     /* 1454607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454657 */     // MIs[1] Operand 1
     /* 1454657 */     // No operand predicates
     /* 1454657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454661 */     // MIs[0] policy
     /* 1454661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454673 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454698 */     // GIR_Coverage, 7287,
     /* 1454698 */     GIR_EraseRootFromParent_Done,
     /* 1454699 */   // Label 20450: @1454699
     /* 1454699 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1454796), // Rule ID 7290 //
     /* 1454704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454754 */     // MIs[1] Operand 1
     /* 1454754 */     // No operand predicates
     /* 1454754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454758 */     // MIs[0] policy
     /* 1454758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454795 */     // GIR_Coverage, 7290,
     /* 1454795 */     GIR_EraseRootFromParent_Done,
     /* 1454796 */   // Label 20451: @1454796
     /* 1454796 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1454893), // Rule ID 7291 //
     /* 1454801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454851 */     // MIs[1] Operand 1
     /* 1454851 */     // No operand predicates
     /* 1454851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454855 */     // MIs[0] policy
     /* 1454855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454867 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454892 */     // GIR_Coverage, 7291,
     /* 1454892 */     GIR_EraseRootFromParent_Done,
     /* 1454893 */   // Label 20452: @1454893
     /* 1454893 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1454990), // Rule ID 7294 //
     /* 1454898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454948 */     // MIs[1] Operand 1
     /* 1454948 */     // No operand predicates
     /* 1454948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454952 */     // MIs[0] policy
     /* 1454952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454989 */     // GIR_Coverage, 7294,
     /* 1454989 */     GIR_EraseRootFromParent_Done,
     /* 1454990 */   // Label 20453: @1454990
     /* 1454990 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1455087), // Rule ID 7295 //
     /* 1454995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1455006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1455009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1455012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455045 */     // MIs[1] Operand 1
     /* 1455045 */     // No operand predicates
     /* 1455045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455049 */     // MIs[0] policy
     /* 1455049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1455064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455086 */     // GIR_Coverage, 7295,
     /* 1455086 */     GIR_EraseRootFromParent_Done,
     /* 1455087 */   // Label 20454: @1455087
     /* 1455087 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1455184), // Rule ID 7298 //
     /* 1455092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1455103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1455106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1455109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455142 */     // MIs[1] Operand 1
     /* 1455142 */     // No operand predicates
     /* 1455142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455146 */     // MIs[0] policy
     /* 1455146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455183 */     // GIR_Coverage, 7298,
     /* 1455183 */     GIR_EraseRootFromParent_Done,
     /* 1455184 */   // Label 20455: @1455184
     /* 1455184 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1455281), // Rule ID 7299 //
     /* 1455189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1455200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1455203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1455206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455239 */     // MIs[1] Operand 1
     /* 1455239 */     // No operand predicates
     /* 1455239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455243 */     // MIs[0] policy
     /* 1455243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455255 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455280 */     // GIR_Coverage, 7299,
     /* 1455280 */     GIR_EraseRootFromParent_Done,
     /* 1455281 */   // Label 20456: @1455281
     /* 1455281 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1455378), // Rule ID 7302 //
     /* 1455286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455336 */     // MIs[1] Operand 1
     /* 1455336 */     // No operand predicates
     /* 1455336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455340 */     // MIs[0] policy
     /* 1455340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455377 */     // GIR_Coverage, 7302,
     /* 1455377 */     GIR_EraseRootFromParent_Done,
     /* 1455378 */   // Label 20457: @1455378
     /* 1455378 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1455475), // Rule ID 7303 //
     /* 1455383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455433 */     // MIs[1] Operand 1
     /* 1455433 */     // No operand predicates
     /* 1455433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455437 */     // MIs[0] policy
     /* 1455437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455449 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455474 */     // GIR_Coverage, 7303,
     /* 1455474 */     GIR_EraseRootFromParent_Done,
     /* 1455475 */   // Label 20458: @1455475
     /* 1455475 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1455572), // Rule ID 7306 //
     /* 1455480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455530 */     // MIs[1] Operand 1
     /* 1455530 */     // No operand predicates
     /* 1455530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455534 */     // MIs[0] policy
     /* 1455534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455571 */     // GIR_Coverage, 7306,
     /* 1455571 */     GIR_EraseRootFromParent_Done,
     /* 1455572 */   // Label 20459: @1455572
     /* 1455572 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1455669), // Rule ID 7307 //
     /* 1455577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455627 */     // MIs[1] Operand 1
     /* 1455627 */     // No operand predicates
     /* 1455627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455631 */     // MIs[0] policy
     /* 1455631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455668 */     // GIR_Coverage, 7307,
     /* 1455668 */     GIR_EraseRootFromParent_Done,
     /* 1455669 */   // Label 20460: @1455669
     /* 1455669 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1455766), // Rule ID 7310 //
     /* 1455674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455724 */     // MIs[1] Operand 1
     /* 1455724 */     // No operand predicates
     /* 1455724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455728 */     // MIs[0] policy
     /* 1455728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455765 */     // GIR_Coverage, 7310,
     /* 1455765 */     GIR_EraseRootFromParent_Done,
     /* 1455766 */   // Label 20461: @1455766
     /* 1455766 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1455863), // Rule ID 7311 //
     /* 1455771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455821 */     // MIs[1] Operand 1
     /* 1455821 */     // No operand predicates
     /* 1455821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455825 */     // MIs[0] policy
     /* 1455825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455837 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455862 */     // GIR_Coverage, 7311,
     /* 1455862 */     GIR_EraseRootFromParent_Done,
     /* 1455863 */   // Label 20462: @1455863
     /* 1455863 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1455960), // Rule ID 7314 //
     /* 1455868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455918 */     // MIs[1] Operand 1
     /* 1455918 */     // No operand predicates
     /* 1455918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455922 */     // MIs[0] policy
     /* 1455922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455959 */     // GIR_Coverage, 7314,
     /* 1455959 */     GIR_EraseRootFromParent_Done,
     /* 1455960 */   // Label 20463: @1455960
     /* 1455960 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1456057), // Rule ID 7315 //
     /* 1455965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456015 */     // MIs[1] Operand 1
     /* 1456015 */     // No operand predicates
     /* 1456015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456019 */     // MIs[0] policy
     /* 1456019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456056 */     // GIR_Coverage, 7315,
     /* 1456056 */     GIR_EraseRootFromParent_Done,
     /* 1456057 */   // Label 20464: @1456057
     /* 1456057 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1456154), // Rule ID 7318 //
     /* 1456062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1456079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456112 */     // MIs[1] Operand 1
     /* 1456112 */     // No operand predicates
     /* 1456112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456116 */     // MIs[0] policy
     /* 1456116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456128 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456153 */     // GIR_Coverage, 7318,
     /* 1456153 */     GIR_EraseRootFromParent_Done,
     /* 1456154 */   // Label 20465: @1456154
     /* 1456154 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1456251), // Rule ID 7319 //
     /* 1456159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1456176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456209 */     // MIs[1] Operand 1
     /* 1456209 */     // No operand predicates
     /* 1456209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456213 */     // MIs[0] policy
     /* 1456213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456250 */     // GIR_Coverage, 7319,
     /* 1456250 */     GIR_EraseRootFromParent_Done,
     /* 1456251 */   // Label 20466: @1456251
     /* 1456251 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1456348), // Rule ID 7322 //
     /* 1456256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1456267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1456270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1456273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1456279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456306 */     // MIs[1] Operand 1
     /* 1456306 */     // No operand predicates
     /* 1456306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456310 */     // MIs[0] policy
     /* 1456310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456322 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456347 */     // GIR_Coverage, 7322,
     /* 1456347 */     GIR_EraseRootFromParent_Done,
     /* 1456348 */   // Label 20467: @1456348
     /* 1456348 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1456445), // Rule ID 7323 //
     /* 1456353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1456364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1456367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1456370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1456376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456403 */     // MIs[1] Operand 1
     /* 1456403 */     // No operand predicates
     /* 1456403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456407 */     // MIs[0] policy
     /* 1456407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456444 */     // GIR_Coverage, 7323,
     /* 1456444 */     GIR_EraseRootFromParent_Done,
     /* 1456445 */   // Label 20468: @1456445
     /* 1456445 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1456542), // Rule ID 7326 //
     /* 1456450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456500 */     // MIs[1] Operand 1
     /* 1456500 */     // No operand predicates
     /* 1456500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456504 */     // MIs[0] policy
     /* 1456504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456541 */     // GIR_Coverage, 7326,
     /* 1456541 */     GIR_EraseRootFromParent_Done,
     /* 1456542 */   // Label 20469: @1456542
     /* 1456542 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1456639), // Rule ID 7327 //
     /* 1456547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456597 */     // MIs[1] Operand 1
     /* 1456597 */     // No operand predicates
     /* 1456597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456601 */     // MIs[0] policy
     /* 1456601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456638 */     // GIR_Coverage, 7327,
     /* 1456638 */     GIR_EraseRootFromParent_Done,
     /* 1456639 */   // Label 20470: @1456639
     /* 1456639 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1456736), // Rule ID 7330 //
     /* 1456644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456694 */     // MIs[1] Operand 1
     /* 1456694 */     // No operand predicates
     /* 1456694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456698 */     // MIs[0] policy
     /* 1456698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456735 */     // GIR_Coverage, 7330,
     /* 1456735 */     GIR_EraseRootFromParent_Done,
     /* 1456736 */   // Label 20471: @1456736
     /* 1456736 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1456833), // Rule ID 7331 //
     /* 1456741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456791 */     // MIs[1] Operand 1
     /* 1456791 */     // No operand predicates
     /* 1456791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456795 */     // MIs[0] policy
     /* 1456795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456807 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456832 */     // GIR_Coverage, 7331,
     /* 1456832 */     GIR_EraseRootFromParent_Done,
     /* 1456833 */   // Label 20472: @1456833
     /* 1456833 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1456930), // Rule ID 7334 //
     /* 1456838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456888 */     // MIs[1] Operand 1
     /* 1456888 */     // No operand predicates
     /* 1456888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456892 */     // MIs[0] policy
     /* 1456892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456904 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456929 */     // GIR_Coverage, 7334,
     /* 1456929 */     GIR_EraseRootFromParent_Done,
     /* 1456930 */   // Label 20473: @1456930
     /* 1456930 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1457027), // Rule ID 7335 //
     /* 1456935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456985 */     // MIs[1] Operand 1
     /* 1456985 */     // No operand predicates
     /* 1456985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456989 */     // MIs[0] policy
     /* 1456989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457001 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457026 */     // GIR_Coverage, 7335,
     /* 1457026 */     GIR_EraseRootFromParent_Done,
     /* 1457027 */   // Label 20474: @1457027
     /* 1457027 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1457124), // Rule ID 7338 //
     /* 1457032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1457043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1457046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457082 */     // MIs[1] Operand 1
     /* 1457082 */     // No operand predicates
     /* 1457082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457086 */     // MIs[0] policy
     /* 1457086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457123 */     // GIR_Coverage, 7338,
     /* 1457123 */     GIR_EraseRootFromParent_Done,
     /* 1457124 */   // Label 20475: @1457124
     /* 1457124 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1457221), // Rule ID 7339 //
     /* 1457129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1457140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1457143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457179 */     // MIs[1] Operand 1
     /* 1457179 */     // No operand predicates
     /* 1457179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457183 */     // MIs[0] policy
     /* 1457183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457220 */     // GIR_Coverage, 7339,
     /* 1457220 */     GIR_EraseRootFromParent_Done,
     /* 1457221 */   // Label 20476: @1457221
     /* 1457221 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1457318), // Rule ID 7342 //
     /* 1457226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1457237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1457240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457276 */     // MIs[1] Operand 1
     /* 1457276 */     // No operand predicates
     /* 1457276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457280 */     // MIs[0] policy
     /* 1457280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457317 */     // GIR_Coverage, 7342,
     /* 1457317 */     GIR_EraseRootFromParent_Done,
     /* 1457318 */   // Label 20477: @1457318
     /* 1457318 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1457415), // Rule ID 7343 //
     /* 1457323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1457334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1457337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457373 */     // MIs[1] Operand 1
     /* 1457373 */     // No operand predicates
     /* 1457373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457377 */     // MIs[0] policy
     /* 1457377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457414 */     // GIR_Coverage, 7343,
     /* 1457414 */     GIR_EraseRootFromParent_Done,
     /* 1457415 */   // Label 20478: @1457415
     /* 1457415 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1457512), // Rule ID 7346 //
     /* 1457420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457470 */     // MIs[1] Operand 1
     /* 1457470 */     // No operand predicates
     /* 1457470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457474 */     // MIs[0] policy
     /* 1457474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457511 */     // GIR_Coverage, 7346,
     /* 1457511 */     GIR_EraseRootFromParent_Done,
     /* 1457512 */   // Label 20479: @1457512
     /* 1457512 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1457609), // Rule ID 7347 //
     /* 1457517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457567 */     // MIs[1] Operand 1
     /* 1457567 */     // No operand predicates
     /* 1457567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457571 */     // MIs[0] policy
     /* 1457571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457583 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457608 */     // GIR_Coverage, 7347,
     /* 1457608 */     GIR_EraseRootFromParent_Done,
     /* 1457609 */   // Label 20480: @1457609
     /* 1457609 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1457706), // Rule ID 7350 //
     /* 1457614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457664 */     // MIs[1] Operand 1
     /* 1457664 */     // No operand predicates
     /* 1457664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457668 */     // MIs[0] policy
     /* 1457668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457705 */     // GIR_Coverage, 7350,
     /* 1457705 */     GIR_EraseRootFromParent_Done,
     /* 1457706 */   // Label 20481: @1457706
     /* 1457706 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1457803), // Rule ID 7351 //
     /* 1457711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457761 */     // MIs[1] Operand 1
     /* 1457761 */     // No operand predicates
     /* 1457761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457765 */     // MIs[0] policy
     /* 1457765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457802 */     // GIR_Coverage, 7351,
     /* 1457802 */     GIR_EraseRootFromParent_Done,
     /* 1457803 */   // Label 20482: @1457803
     /* 1457803 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1457900), // Rule ID 7354 //
     /* 1457808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457858 */     // MIs[1] Operand 1
     /* 1457858 */     // No operand predicates
     /* 1457858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457862 */     // MIs[0] policy
     /* 1457862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457899 */     // GIR_Coverage, 7354,
     /* 1457899 */     GIR_EraseRootFromParent_Done,
     /* 1457900 */   // Label 20483: @1457900
     /* 1457900 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1457997), // Rule ID 7355 //
     /* 1457905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457955 */     // MIs[1] Operand 1
     /* 1457955 */     // No operand predicates
     /* 1457955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457959 */     // MIs[0] policy
     /* 1457959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457996 */     // GIR_Coverage, 7355,
     /* 1457996 */     GIR_EraseRootFromParent_Done,
     /* 1457997 */   // Label 20484: @1457997
     /* 1457997 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1458094), // Rule ID 7358 //
     /* 1458002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1458005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1458013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1458016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458052 */     // MIs[1] Operand 1
     /* 1458052 */     // No operand predicates
     /* 1458052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458056 */     // MIs[0] policy
     /* 1458056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1458071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458093 */     // GIR_Coverage, 7358,
     /* 1458093 */     GIR_EraseRootFromParent_Done,
     /* 1458094 */   // Label 20485: @1458094
     /* 1458094 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1458191), // Rule ID 7359 //
     /* 1458099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1458102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1458107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1458110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1458113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1458129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458149 */     // MIs[1] Operand 1
     /* 1458149 */     // No operand predicates
     /* 1458149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458153 */     // MIs[0] policy
     /* 1458153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1458168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458190 */     // GIR_Coverage, 7359,
     /* 1458190 */     GIR_EraseRootFromParent_Done,
     /* 1458191 */   // Label 20486: @1458191
     /* 1458191 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1458288), // Rule ID 7570 //
     /* 1458196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458246 */     // MIs[1] Operand 1
     /* 1458246 */     // No operand predicates
     /* 1458246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458250 */     // MIs[0] policy
     /* 1458250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1458265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458287 */     // GIR_Coverage, 7570,
     /* 1458287 */     GIR_EraseRootFromParent_Done,
     /* 1458288 */   // Label 20487: @1458288
     /* 1458288 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1458385), // Rule ID 7571 //
     /* 1458293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458343 */     // MIs[1] Operand 1
     /* 1458343 */     // No operand predicates
     /* 1458343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458347 */     // MIs[0] policy
     /* 1458347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1458362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458384 */     // GIR_Coverage, 7571,
     /* 1458384 */     GIR_EraseRootFromParent_Done,
     /* 1458385 */   // Label 20488: @1458385
     /* 1458385 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1458482), // Rule ID 7574 //
     /* 1458390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458440 */     // MIs[1] Operand 1
     /* 1458440 */     // No operand predicates
     /* 1458440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458444 */     // MIs[0] policy
     /* 1458444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458456 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458481 */     // GIR_Coverage, 7574,
     /* 1458481 */     GIR_EraseRootFromParent_Done,
     /* 1458482 */   // Label 20489: @1458482
     /* 1458482 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1458579), // Rule ID 7575 //
     /* 1458487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458537 */     // MIs[1] Operand 1
     /* 1458537 */     // No operand predicates
     /* 1458537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458541 */     // MIs[0] policy
     /* 1458541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458553 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458578 */     // GIR_Coverage, 7575,
     /* 1458578 */     GIR_EraseRootFromParent_Done,
     /* 1458579 */   // Label 20490: @1458579
     /* 1458579 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1458676), // Rule ID 7578 //
     /* 1458584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458634 */     // MIs[1] Operand 1
     /* 1458634 */     // No operand predicates
     /* 1458634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458638 */     // MIs[0] policy
     /* 1458638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458650 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458675 */     // GIR_Coverage, 7578,
     /* 1458675 */     GIR_EraseRootFromParent_Done,
     /* 1458676 */   // Label 20491: @1458676
     /* 1458676 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1458773), // Rule ID 7579 //
     /* 1458681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458731 */     // MIs[1] Operand 1
     /* 1458731 */     // No operand predicates
     /* 1458731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458735 */     // MIs[0] policy
     /* 1458735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458747 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458772 */     // GIR_Coverage, 7579,
     /* 1458772 */     GIR_EraseRootFromParent_Done,
     /* 1458773 */   // Label 20492: @1458773
     /* 1458773 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1458870), // Rule ID 7582 //
     /* 1458778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458828 */     // MIs[1] Operand 1
     /* 1458828 */     // No operand predicates
     /* 1458828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458832 */     // MIs[0] policy
     /* 1458832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458869 */     // GIR_Coverage, 7582,
     /* 1458869 */     GIR_EraseRootFromParent_Done,
     /* 1458870 */   // Label 20493: @1458870
     /* 1458870 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1458967), // Rule ID 7583 //
     /* 1458875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458925 */     // MIs[1] Operand 1
     /* 1458925 */     // No operand predicates
     /* 1458925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458929 */     // MIs[0] policy
     /* 1458929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458941 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458966 */     // GIR_Coverage, 7583,
     /* 1458966 */     GIR_EraseRootFromParent_Done,
     /* 1458967 */   // Label 20494: @1458967
     /* 1458967 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1459064), // Rule ID 7586 //
     /* 1458972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459022 */     // MIs[1] Operand 1
     /* 1459022 */     // No operand predicates
     /* 1459022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459026 */     // MIs[0] policy
     /* 1459026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459063 */     // GIR_Coverage, 7586,
     /* 1459063 */     GIR_EraseRootFromParent_Done,
     /* 1459064 */   // Label 20495: @1459064
     /* 1459064 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1459161), // Rule ID 7587 //
     /* 1459069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459119 */     // MIs[1] Operand 1
     /* 1459119 */     // No operand predicates
     /* 1459119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459123 */     // MIs[0] policy
     /* 1459123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459160 */     // GIR_Coverage, 7587,
     /* 1459160 */     GIR_EraseRootFromParent_Done,
     /* 1459161 */   // Label 20496: @1459161
     /* 1459161 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1459258), // Rule ID 7590 //
     /* 1459166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459216 */     // MIs[1] Operand 1
     /* 1459216 */     // No operand predicates
     /* 1459216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459220 */     // MIs[0] policy
     /* 1459220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459257 */     // GIR_Coverage, 7590,
     /* 1459257 */     GIR_EraseRootFromParent_Done,
     /* 1459258 */   // Label 20497: @1459258
     /* 1459258 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1459355), // Rule ID 7591 //
     /* 1459263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459313 */     // MIs[1] Operand 1
     /* 1459313 */     // No operand predicates
     /* 1459313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459317 */     // MIs[0] policy
     /* 1459317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459329 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459354 */     // GIR_Coverage, 7591,
     /* 1459354 */     GIR_EraseRootFromParent_Done,
     /* 1459355 */   // Label 20498: @1459355
     /* 1459355 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1459452), // Rule ID 7594 //
     /* 1459360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459410 */     // MIs[1] Operand 1
     /* 1459410 */     // No operand predicates
     /* 1459410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459414 */     // MIs[0] policy
     /* 1459414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459451 */     // GIR_Coverage, 7594,
     /* 1459451 */     GIR_EraseRootFromParent_Done,
     /* 1459452 */   // Label 20499: @1459452
     /* 1459452 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1459549), // Rule ID 7595 //
     /* 1459457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459507 */     // MIs[1] Operand 1
     /* 1459507 */     // No operand predicates
     /* 1459507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459511 */     // MIs[0] policy
     /* 1459511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459523 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459548 */     // GIR_Coverage, 7595,
     /* 1459548 */     GIR_EraseRootFromParent_Done,
     /* 1459549 */   // Label 20500: @1459549
     /* 1459549 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1459646), // Rule ID 7598 //
     /* 1459554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459604 */     // MIs[1] Operand 1
     /* 1459604 */     // No operand predicates
     /* 1459604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459608 */     // MIs[0] policy
     /* 1459608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459645 */     // GIR_Coverage, 7598,
     /* 1459645 */     GIR_EraseRootFromParent_Done,
     /* 1459646 */   // Label 20501: @1459646
     /* 1459646 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1459743), // Rule ID 7599 //
     /* 1459651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459701 */     // MIs[1] Operand 1
     /* 1459701 */     // No operand predicates
     /* 1459701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459705 */     // MIs[0] policy
     /* 1459705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459717 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459742 */     // GIR_Coverage, 7599,
     /* 1459742 */     GIR_EraseRootFromParent_Done,
     /* 1459743 */   // Label 20502: @1459743
     /* 1459743 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1459840), // Rule ID 7602 //
     /* 1459748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459798 */     // MIs[1] Operand 1
     /* 1459798 */     // No operand predicates
     /* 1459798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459802 */     // MIs[0] policy
     /* 1459802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459839 */     // GIR_Coverage, 7602,
     /* 1459839 */     GIR_EraseRootFromParent_Done,
     /* 1459840 */   // Label 20503: @1459840
     /* 1459840 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1459937), // Rule ID 7603 //
     /* 1459845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459895 */     // MIs[1] Operand 1
     /* 1459895 */     // No operand predicates
     /* 1459895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459899 */     // MIs[0] policy
     /* 1459899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459936 */     // GIR_Coverage, 7603,
     /* 1459936 */     GIR_EraseRootFromParent_Done,
     /* 1459937 */   // Label 20504: @1459937
     /* 1459937 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1460034), // Rule ID 7606 //
     /* 1459942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459992 */     // MIs[1] Operand 1
     /* 1459992 */     // No operand predicates
     /* 1459992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459996 */     // MIs[0] policy
     /* 1459996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460033 */     // GIR_Coverage, 7606,
     /* 1460033 */     GIR_EraseRootFromParent_Done,
     /* 1460034 */   // Label 20505: @1460034
     /* 1460034 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1460131), // Rule ID 7607 //
     /* 1460039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460089 */     // MIs[1] Operand 1
     /* 1460089 */     // No operand predicates
     /* 1460089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460093 */     // MIs[0] policy
     /* 1460093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460105 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460130 */     // GIR_Coverage, 7607,
     /* 1460130 */     GIR_EraseRootFromParent_Done,
     /* 1460131 */   // Label 20506: @1460131
     /* 1460131 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1460228), // Rule ID 7610 //
     /* 1460136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460186 */     // MIs[1] Operand 1
     /* 1460186 */     // No operand predicates
     /* 1460186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460190 */     // MIs[0] policy
     /* 1460190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460227 */     // GIR_Coverage, 7610,
     /* 1460227 */     GIR_EraseRootFromParent_Done,
     /* 1460228 */   // Label 20507: @1460228
     /* 1460228 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1460325), // Rule ID 7611 //
     /* 1460233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460283 */     // MIs[1] Operand 1
     /* 1460283 */     // No operand predicates
     /* 1460283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460287 */     // MIs[0] policy
     /* 1460287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460299 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460324 */     // GIR_Coverage, 7611,
     /* 1460324 */     GIR_EraseRootFromParent_Done,
     /* 1460325 */   // Label 20508: @1460325
     /* 1460325 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1460422), // Rule ID 7614 //
     /* 1460330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460380 */     // MIs[1] Operand 1
     /* 1460380 */     // No operand predicates
     /* 1460380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460384 */     // MIs[0] policy
     /* 1460384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460421 */     // GIR_Coverage, 7614,
     /* 1460421 */     GIR_EraseRootFromParent_Done,
     /* 1460422 */   // Label 20509: @1460422
     /* 1460422 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1460519), // Rule ID 7615 //
     /* 1460427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460477 */     // MIs[1] Operand 1
     /* 1460477 */     // No operand predicates
     /* 1460477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460481 */     // MIs[0] policy
     /* 1460481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460518 */     // GIR_Coverage, 7615,
     /* 1460518 */     GIR_EraseRootFromParent_Done,
     /* 1460519 */   // Label 20510: @1460519
     /* 1460519 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1460616), // Rule ID 7618 //
     /* 1460524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460574 */     // MIs[1] Operand 1
     /* 1460574 */     // No operand predicates
     /* 1460574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460578 */     // MIs[0] policy
     /* 1460578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460615 */     // GIR_Coverage, 7618,
     /* 1460615 */     GIR_EraseRootFromParent_Done,
     /* 1460616 */   // Label 20511: @1460616
     /* 1460616 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1460713), // Rule ID 7619 //
     /* 1460621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460671 */     // MIs[1] Operand 1
     /* 1460671 */     // No operand predicates
     /* 1460671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460675 */     // MIs[0] policy
     /* 1460675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460687 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460712 */     // GIR_Coverage, 7619,
     /* 1460712 */     GIR_EraseRootFromParent_Done,
     /* 1460713 */   // Label 20512: @1460713
     /* 1460713 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1460810), // Rule ID 7622 //
     /* 1460718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460768 */     // MIs[1] Operand 1
     /* 1460768 */     // No operand predicates
     /* 1460768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460772 */     // MIs[0] policy
     /* 1460772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460809 */     // GIR_Coverage, 7622,
     /* 1460809 */     GIR_EraseRootFromParent_Done,
     /* 1460810 */   // Label 20513: @1460810
     /* 1460810 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1460907), // Rule ID 7623 //
     /* 1460815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460865 */     // MIs[1] Operand 1
     /* 1460865 */     // No operand predicates
     /* 1460865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460869 */     // MIs[0] policy
     /* 1460869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460906 */     // GIR_Coverage, 7623,
     /* 1460906 */     GIR_EraseRootFromParent_Done,
     /* 1460907 */   // Label 20514: @1460907
     /* 1460907 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1461004), // Rule ID 7626 //
     /* 1460912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460962 */     // MIs[1] Operand 1
     /* 1460962 */     // No operand predicates
     /* 1460962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460966 */     // MIs[0] policy
     /* 1460966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461003 */     // GIR_Coverage, 7626,
     /* 1461003 */     GIR_EraseRootFromParent_Done,
     /* 1461004 */   // Label 20515: @1461004
     /* 1461004 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1461101), // Rule ID 7627 //
     /* 1461009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1461012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1461017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1461020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1461023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461059 */     // MIs[1] Operand 1
     /* 1461059 */     // No operand predicates
     /* 1461059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461063 */     // MIs[0] policy
     /* 1461063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461075 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1461078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461100 */     // GIR_Coverage, 7627,
     /* 1461100 */     GIR_EraseRootFromParent_Done,
     /* 1461101 */   // Label 20516: @1461101
     /* 1461101 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1461198), // Rule ID 7750 //
     /* 1461106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461156 */     // MIs[1] Operand 1
     /* 1461156 */     // No operand predicates
     /* 1461156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461160 */     // MIs[0] policy
     /* 1461160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461172 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1461175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461197 */     // GIR_Coverage, 7750,
     /* 1461197 */     GIR_EraseRootFromParent_Done,
     /* 1461198 */   // Label 20517: @1461198
     /* 1461198 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1461295), // Rule ID 7751 //
     /* 1461203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461253 */     // MIs[1] Operand 1
     /* 1461253 */     // No operand predicates
     /* 1461253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461257 */     // MIs[0] policy
     /* 1461257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461269 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1461272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461294 */     // GIR_Coverage, 7751,
     /* 1461294 */     GIR_EraseRootFromParent_Done,
     /* 1461295 */   // Label 20518: @1461295
     /* 1461295 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1461392), // Rule ID 7754 //
     /* 1461300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461350 */     // MIs[1] Operand 1
     /* 1461350 */     // No operand predicates
     /* 1461350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461354 */     // MIs[0] policy
     /* 1461354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461391 */     // GIR_Coverage, 7754,
     /* 1461391 */     GIR_EraseRootFromParent_Done,
     /* 1461392 */   // Label 20519: @1461392
     /* 1461392 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1461489), // Rule ID 7755 //
     /* 1461397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1461414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461447 */     // MIs[1] Operand 1
     /* 1461447 */     // No operand predicates
     /* 1461447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461451 */     // MIs[0] policy
     /* 1461451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461463 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461488 */     // GIR_Coverage, 7755,
     /* 1461488 */     GIR_EraseRootFromParent_Done,
     /* 1461489 */   // Label 20520: @1461489
     /* 1461489 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1461586), // Rule ID 7758 //
     /* 1461494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461544 */     // MIs[1] Operand 1
     /* 1461544 */     // No operand predicates
     /* 1461544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461548 */     // MIs[0] policy
     /* 1461548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461585 */     // GIR_Coverage, 7758,
     /* 1461585 */     GIR_EraseRootFromParent_Done,
     /* 1461586 */   // Label 20521: @1461586
     /* 1461586 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1461683), // Rule ID 7759 //
     /* 1461591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461641 */     // MIs[1] Operand 1
     /* 1461641 */     // No operand predicates
     /* 1461641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461645 */     // MIs[0] policy
     /* 1461645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461657 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461682 */     // GIR_Coverage, 7759,
     /* 1461682 */     GIR_EraseRootFromParent_Done,
     /* 1461683 */   // Label 20522: @1461683
     /* 1461683 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1461780), // Rule ID 7762 //
     /* 1461688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461738 */     // MIs[1] Operand 1
     /* 1461738 */     // No operand predicates
     /* 1461738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461742 */     // MIs[0] policy
     /* 1461742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461779 */     // GIR_Coverage, 7762,
     /* 1461779 */     GIR_EraseRootFromParent_Done,
     /* 1461780 */   // Label 20523: @1461780
     /* 1461780 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1461877), // Rule ID 7763 //
     /* 1461785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461835 */     // MIs[1] Operand 1
     /* 1461835 */     // No operand predicates
     /* 1461835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461839 */     // MIs[0] policy
     /* 1461839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461851 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461876 */     // GIR_Coverage, 7763,
     /* 1461876 */     GIR_EraseRootFromParent_Done,
     /* 1461877 */   // Label 20524: @1461877
     /* 1461877 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1461974), // Rule ID 7766 //
     /* 1461882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461932 */     // MIs[1] Operand 1
     /* 1461932 */     // No operand predicates
     /* 1461932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461936 */     // MIs[0] policy
     /* 1461936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461973 */     // GIR_Coverage, 7766,
     /* 1461973 */     GIR_EraseRootFromParent_Done,
     /* 1461974 */   // Label 20525: @1461974
     /* 1461974 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1462071), // Rule ID 7767 //
     /* 1461979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462029 */     // MIs[1] Operand 1
     /* 1462029 */     // No operand predicates
     /* 1462029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462033 */     // MIs[0] policy
     /* 1462033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462045 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462070 */     // GIR_Coverage, 7767,
     /* 1462070 */     GIR_EraseRootFromParent_Done,
     /* 1462071 */   // Label 20526: @1462071
     /* 1462071 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1462168), // Rule ID 7770 //
     /* 1462076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462126 */     // MIs[1] Operand 1
     /* 1462126 */     // No operand predicates
     /* 1462126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462130 */     // MIs[0] policy
     /* 1462130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462167 */     // GIR_Coverage, 7770,
     /* 1462167 */     GIR_EraseRootFromParent_Done,
     /* 1462168 */   // Label 20527: @1462168
     /* 1462168 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1462265), // Rule ID 7771 //
     /* 1462173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1462184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1462187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1462190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1462196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462223 */     // MIs[1] Operand 1
     /* 1462223 */     // No operand predicates
     /* 1462223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462227 */     // MIs[0] policy
     /* 1462227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462264 */     // GIR_Coverage, 7771,
     /* 1462264 */     GIR_EraseRootFromParent_Done,
     /* 1462265 */   // Label 20528: @1462265
     /* 1462265 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1462362), // Rule ID 7774 //
     /* 1462270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462320 */     // MIs[1] Operand 1
     /* 1462320 */     // No operand predicates
     /* 1462320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462324 */     // MIs[0] policy
     /* 1462324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1462339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462361 */     // GIR_Coverage, 7774,
     /* 1462361 */     GIR_EraseRootFromParent_Done,
     /* 1462362 */   // Label 20529: @1462362
     /* 1462362 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1462459), // Rule ID 7775 //
     /* 1462367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462417 */     // MIs[1] Operand 1
     /* 1462417 */     // No operand predicates
     /* 1462417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462421 */     // MIs[0] policy
     /* 1462421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462433 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1462436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462458 */     // GIR_Coverage, 7775,
     /* 1462458 */     GIR_EraseRootFromParent_Done,
     /* 1462459 */   // Label 20530: @1462459
     /* 1462459 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1462556), // Rule ID 7778 //
     /* 1462464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462514 */     // MIs[1] Operand 1
     /* 1462514 */     // No operand predicates
     /* 1462514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462518 */     // MIs[0] policy
     /* 1462518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462555 */     // GIR_Coverage, 7778,
     /* 1462555 */     GIR_EraseRootFromParent_Done,
     /* 1462556 */   // Label 20531: @1462556
     /* 1462556 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1462653), // Rule ID 7779 //
     /* 1462561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462611 */     // MIs[1] Operand 1
     /* 1462611 */     // No operand predicates
     /* 1462611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462615 */     // MIs[0] policy
     /* 1462615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462652 */     // GIR_Coverage, 7779,
     /* 1462652 */     GIR_EraseRootFromParent_Done,
     /* 1462653 */   // Label 20532: @1462653
     /* 1462653 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1462750), // Rule ID 7782 //
     /* 1462658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462708 */     // MIs[1] Operand 1
     /* 1462708 */     // No operand predicates
     /* 1462708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462712 */     // MIs[0] policy
     /* 1462712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462749 */     // GIR_Coverage, 7782,
     /* 1462749 */     GIR_EraseRootFromParent_Done,
     /* 1462750 */   // Label 20533: @1462750
     /* 1462750 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1462847), // Rule ID 7783 //
     /* 1462755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462805 */     // MIs[1] Operand 1
     /* 1462805 */     // No operand predicates
     /* 1462805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462809 */     // MIs[0] policy
     /* 1462809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462846 */     // GIR_Coverage, 7783,
     /* 1462846 */     GIR_EraseRootFromParent_Done,
     /* 1462847 */   // Label 20534: @1462847
     /* 1462847 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1462944), // Rule ID 7786 //
     /* 1462852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462902 */     // MIs[1] Operand 1
     /* 1462902 */     // No operand predicates
     /* 1462902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462906 */     // MIs[0] policy
     /* 1462906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462943 */     // GIR_Coverage, 7786,
     /* 1462943 */     GIR_EraseRootFromParent_Done,
     /* 1462944 */   // Label 20535: @1462944
     /* 1462944 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1463041), // Rule ID 7787 //
     /* 1462949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462999 */     // MIs[1] Operand 1
     /* 1462999 */     // No operand predicates
     /* 1462999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463003 */     // MIs[0] policy
     /* 1463003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463040 */     // GIR_Coverage, 7787,
     /* 1463040 */     GIR_EraseRootFromParent_Done,
     /* 1463041 */   // Label 20536: @1463041
     /* 1463041 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1463138), // Rule ID 7790 //
     /* 1463046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463096 */     // MIs[1] Operand 1
     /* 1463096 */     // No operand predicates
     /* 1463096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463100 */     // MIs[0] policy
     /* 1463100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463137 */     // GIR_Coverage, 7790,
     /* 1463137 */     GIR_EraseRootFromParent_Done,
     /* 1463138 */   // Label 20537: @1463138
     /* 1463138 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1463235), // Rule ID 7791 //
     /* 1463143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1463154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1463157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1463160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463193 */     // MIs[1] Operand 1
     /* 1463193 */     // No operand predicates
     /* 1463193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463197 */     // MIs[0] policy
     /* 1463197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463209 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1463231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463234 */     // GIR_Coverage, 7791,
     /* 1463234 */     GIR_EraseRootFromParent_Done,
     /* 1463235 */   // Label 20538: @1463235
     /* 1463235 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1463332), // Rule ID 7794 //
     /* 1463240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463290 */     // MIs[1] Operand 1
     /* 1463290 */     // No operand predicates
     /* 1463290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463294 */     // MIs[0] policy
     /* 1463294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1463309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463331 */     // GIR_Coverage, 7794,
     /* 1463331 */     GIR_EraseRootFromParent_Done,
     /* 1463332 */   // Label 20539: @1463332
     /* 1463332 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1463429), // Rule ID 7795 //
     /* 1463337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1463348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1463351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463387 */     // MIs[1] Operand 1
     /* 1463387 */     // No operand predicates
     /* 1463387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463391 */     // MIs[0] policy
     /* 1463391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463403 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1463406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463428 */     // GIR_Coverage, 7795,
     /* 1463428 */     GIR_EraseRootFromParent_Done,
     /* 1463429 */   // Label 20540: @1463429
     /* 1463429 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1463526), // Rule ID 7798 //
     /* 1463434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463484 */     // MIs[1] Operand 1
     /* 1463484 */     // No operand predicates
     /* 1463484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463488 */     // MIs[0] policy
     /* 1463488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463525 */     // GIR_Coverage, 7798,
     /* 1463525 */     GIR_EraseRootFromParent_Done,
     /* 1463526 */   // Label 20541: @1463526
     /* 1463526 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1463623), // Rule ID 7799 //
     /* 1463531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463581 */     // MIs[1] Operand 1
     /* 1463581 */     // No operand predicates
     /* 1463581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463585 */     // MIs[0] policy
     /* 1463585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463597 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463622 */     // GIR_Coverage, 7799,
     /* 1463622 */     GIR_EraseRootFromParent_Done,
     /* 1463623 */   // Label 20542: @1463623
     /* 1463623 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1463720), // Rule ID 7802 //
     /* 1463628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463678 */     // MIs[1] Operand 1
     /* 1463678 */     // No operand predicates
     /* 1463678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463682 */     // MIs[0] policy
     /* 1463682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463719 */     // GIR_Coverage, 7802,
     /* 1463719 */     GIR_EraseRootFromParent_Done,
     /* 1463720 */   // Label 20543: @1463720
     /* 1463720 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1463817), // Rule ID 7803 //
     /* 1463725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463775 */     // MIs[1] Operand 1
     /* 1463775 */     // No operand predicates
     /* 1463775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463779 */     // MIs[0] policy
     /* 1463779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463816 */     // GIR_Coverage, 7803,
     /* 1463816 */     GIR_EraseRootFromParent_Done,
     /* 1463817 */   // Label 20544: @1463817
     /* 1463817 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1463914), // Rule ID 7806 //
     /* 1463822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463872 */     // MIs[1] Operand 1
     /* 1463872 */     // No operand predicates
     /* 1463872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463876 */     // MIs[0] policy
     /* 1463876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463913 */     // GIR_Coverage, 7806,
     /* 1463913 */     GIR_EraseRootFromParent_Done,
     /* 1463914 */   // Label 20545: @1463914
     /* 1463914 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1464011), // Rule ID 7807 //
     /* 1463919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463969 */     // MIs[1] Operand 1
     /* 1463969 */     // No operand predicates
     /* 1463969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463973 */     // MIs[0] policy
     /* 1463973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464010 */     // GIR_Coverage, 7807,
     /* 1464010 */     GIR_EraseRootFromParent_Done,
     /* 1464011 */   // Label 20546: @1464011
     /* 1464011 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1464111), // Rule ID 14236 //
     /* 1464016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1464033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464066 */     // MIs[1] Operand 1
     /* 1464066 */     // No operand predicates
     /* 1464066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464070 */     // MIs[0] policy
     /* 1464070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1464085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464110 */     // GIR_Coverage, 14236,
     /* 1464110 */     GIR_EraseRootFromParent_Done,
     /* 1464111 */   // Label 20547: @1464111
     /* 1464111 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1464211), // Rule ID 14237 //
     /* 1464116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1464127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1464130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1464133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464166 */     // MIs[1] Operand 1
     /* 1464166 */     // No operand predicates
     /* 1464166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464170 */     // MIs[0] policy
     /* 1464170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1464185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464210 */     // GIR_Coverage, 14237,
     /* 1464210 */     GIR_EraseRootFromParent_Done,
     /* 1464211 */   // Label 20548: @1464211
     /* 1464211 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1464311), // Rule ID 14240 //
     /* 1464216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1464233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464266 */     // MIs[1] Operand 1
     /* 1464266 */     // No operand predicates
     /* 1464266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464270 */     // MIs[0] policy
     /* 1464270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464310 */     // GIR_Coverage, 14240,
     /* 1464310 */     GIR_EraseRootFromParent_Done,
     /* 1464311 */   // Label 20549: @1464311
     /* 1464311 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1464411), // Rule ID 14241 //
     /* 1464316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1464327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1464330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1464333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464366 */     // MIs[1] Operand 1
     /* 1464366 */     // No operand predicates
     /* 1464366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464370 */     // MIs[0] policy
     /* 1464370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464410 */     // GIR_Coverage, 14241,
     /* 1464410 */     GIR_EraseRootFromParent_Done,
     /* 1464411 */   // Label 20550: @1464411
     /* 1464411 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1464511), // Rule ID 14244 //
     /* 1464416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464466 */     // MIs[1] Operand 1
     /* 1464466 */     // No operand predicates
     /* 1464466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464470 */     // MIs[0] policy
     /* 1464470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464510 */     // GIR_Coverage, 14244,
     /* 1464510 */     GIR_EraseRootFromParent_Done,
     /* 1464511 */   // Label 20551: @1464511
     /* 1464511 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1464611), // Rule ID 14245 //
     /* 1464516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464566 */     // MIs[1] Operand 1
     /* 1464566 */     // No operand predicates
     /* 1464566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464570 */     // MIs[0] policy
     /* 1464570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464582 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464610 */     // GIR_Coverage, 14245,
     /* 1464610 */     GIR_EraseRootFromParent_Done,
     /* 1464611 */   // Label 20552: @1464611
     /* 1464611 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1464711), // Rule ID 14248 //
     /* 1464616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464666 */     // MIs[1] Operand 1
     /* 1464666 */     // No operand predicates
     /* 1464666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464670 */     // MIs[0] policy
     /* 1464670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464710 */     // GIR_Coverage, 14248,
     /* 1464710 */     GIR_EraseRootFromParent_Done,
     /* 1464711 */   // Label 20553: @1464711
     /* 1464711 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1464811), // Rule ID 14249 //
     /* 1464716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464766 */     // MIs[1] Operand 1
     /* 1464766 */     // No operand predicates
     /* 1464766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464770 */     // MIs[0] policy
     /* 1464770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464810 */     // GIR_Coverage, 14249,
     /* 1464810 */     GIR_EraseRootFromParent_Done,
     /* 1464811 */   // Label 20554: @1464811
     /* 1464811 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1464911), // Rule ID 14252 //
     /* 1464816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464866 */     // MIs[1] Operand 1
     /* 1464866 */     // No operand predicates
     /* 1464866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464870 */     // MIs[0] policy
     /* 1464870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464910 */     // GIR_Coverage, 14252,
     /* 1464910 */     GIR_EraseRootFromParent_Done,
     /* 1464911 */   // Label 20555: @1464911
     /* 1464911 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1465011), // Rule ID 14253 //
     /* 1464916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464966 */     // MIs[1] Operand 1
     /* 1464966 */     // No operand predicates
     /* 1464966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464970 */     // MIs[0] policy
     /* 1464970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465010 */     // GIR_Coverage, 14253,
     /* 1465010 */     GIR_EraseRootFromParent_Done,
     /* 1465011 */   // Label 20556: @1465011
     /* 1465011 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1465111), // Rule ID 14256 //
     /* 1465016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1465027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1465030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465066 */     // MIs[1] Operand 1
     /* 1465066 */     // No operand predicates
     /* 1465066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465070 */     // MIs[0] policy
     /* 1465070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1465085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465110 */     // GIR_Coverage, 14256,
     /* 1465110 */     GIR_EraseRootFromParent_Done,
     /* 1465111 */   // Label 20557: @1465111
     /* 1465111 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1465211), // Rule ID 14257 //
     /* 1465116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1465127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1465130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1465133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465166 */     // MIs[1] Operand 1
     /* 1465166 */     // No operand predicates
     /* 1465166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465170 */     // MIs[0] policy
     /* 1465170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1465185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465210 */     // GIR_Coverage, 14257,
     /* 1465210 */     GIR_EraseRootFromParent_Done,
     /* 1465211 */   // Label 20558: @1465211
     /* 1465211 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1465311), // Rule ID 14260 //
     /* 1465216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1465233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465266 */     // MIs[1] Operand 1
     /* 1465266 */     // No operand predicates
     /* 1465266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465270 */     // MIs[0] policy
     /* 1465270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465310 */     // GIR_Coverage, 14260,
     /* 1465310 */     GIR_EraseRootFromParent_Done,
     /* 1465311 */   // Label 20559: @1465311
     /* 1465311 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1465411), // Rule ID 14261 //
     /* 1465316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1465327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1465330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1465333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465366 */     // MIs[1] Operand 1
     /* 1465366 */     // No operand predicates
     /* 1465366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465370 */     // MIs[0] policy
     /* 1465370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465410 */     // GIR_Coverage, 14261,
     /* 1465410 */     GIR_EraseRootFromParent_Done,
     /* 1465411 */   // Label 20560: @1465411
     /* 1465411 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1465511), // Rule ID 14264 //
     /* 1465416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465466 */     // MIs[1] Operand 1
     /* 1465466 */     // No operand predicates
     /* 1465466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465470 */     // MIs[0] policy
     /* 1465470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465510 */     // GIR_Coverage, 14264,
     /* 1465510 */     GIR_EraseRootFromParent_Done,
     /* 1465511 */   // Label 20561: @1465511
     /* 1465511 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1465611), // Rule ID 14265 //
     /* 1465516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465566 */     // MIs[1] Operand 1
     /* 1465566 */     // No operand predicates
     /* 1465566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465570 */     // MIs[0] policy
     /* 1465570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465610 */     // GIR_Coverage, 14265,
     /* 1465610 */     GIR_EraseRootFromParent_Done,
     /* 1465611 */   // Label 20562: @1465611
     /* 1465611 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1465711), // Rule ID 14268 //
     /* 1465616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465666 */     // MIs[1] Operand 1
     /* 1465666 */     // No operand predicates
     /* 1465666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465670 */     // MIs[0] policy
     /* 1465670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465710 */     // GIR_Coverage, 14268,
     /* 1465710 */     GIR_EraseRootFromParent_Done,
     /* 1465711 */   // Label 20563: @1465711
     /* 1465711 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1465811), // Rule ID 14269 //
     /* 1465716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465766 */     // MIs[1] Operand 1
     /* 1465766 */     // No operand predicates
     /* 1465766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465770 */     // MIs[0] policy
     /* 1465770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465810 */     // GIR_Coverage, 14269,
     /* 1465810 */     GIR_EraseRootFromParent_Done,
     /* 1465811 */   // Label 20564: @1465811
     /* 1465811 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1465911), // Rule ID 14272 //
     /* 1465816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465866 */     // MIs[1] Operand 1
     /* 1465866 */     // No operand predicates
     /* 1465866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465870 */     // MIs[0] policy
     /* 1465870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465910 */     // GIR_Coverage, 14272,
     /* 1465910 */     GIR_EraseRootFromParent_Done,
     /* 1465911 */   // Label 20565: @1465911
     /* 1465911 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1466011), // Rule ID 14273 //
     /* 1465916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465966 */     // MIs[1] Operand 1
     /* 1465966 */     // No operand predicates
     /* 1465966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465970 */     // MIs[0] policy
     /* 1465970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1466004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466010 */     // GIR_Coverage, 14273,
     /* 1466010 */     GIR_EraseRootFromParent_Done,
     /* 1466011 */   // Label 20566: @1466011
     /* 1466011 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1466111), // Rule ID 14276 //
     /* 1466016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1466027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1466030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1466033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466066 */     // MIs[1] Operand 1
     /* 1466066 */     // No operand predicates
     /* 1466066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466070 */     // MIs[0] policy
     /* 1466070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466082 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466110 */     // GIR_Coverage, 14276,
     /* 1466110 */     GIR_EraseRootFromParent_Done,
     /* 1466111 */   // Label 20567: @1466111
     /* 1466111 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1466211), // Rule ID 14277 //
     /* 1466116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1466127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1466130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1466133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466166 */     // MIs[1] Operand 1
     /* 1466166 */     // No operand predicates
     /* 1466166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466170 */     // MIs[0] policy
     /* 1466170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466210 */     // GIR_Coverage, 14277,
     /* 1466210 */     GIR_EraseRootFromParent_Done,
     /* 1466211 */   // Label 20568: @1466211
     /* 1466211 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1466311), // Rule ID 14280 //
     /* 1466216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1466227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1466230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1466233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466266 */     // MIs[1] Operand 1
     /* 1466266 */     // No operand predicates
     /* 1466266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466270 */     // MIs[0] policy
     /* 1466270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466310 */     // GIR_Coverage, 14280,
     /* 1466310 */     GIR_EraseRootFromParent_Done,
     /* 1466311 */   // Label 20569: @1466311
     /* 1466311 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1466411), // Rule ID 14281 //
     /* 1466316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1466327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1466330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1466333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466366 */     // MIs[1] Operand 1
     /* 1466366 */     // No operand predicates
     /* 1466366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466370 */     // MIs[0] policy
     /* 1466370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466382 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466410 */     // GIR_Coverage, 14281,
     /* 1466410 */     GIR_EraseRootFromParent_Done,
     /* 1466411 */   // Label 20570: @1466411
     /* 1466411 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1466511), // Rule ID 14284 //
     /* 1466416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466466 */     // MIs[1] Operand 1
     /* 1466466 */     // No operand predicates
     /* 1466466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466470 */     // MIs[0] policy
     /* 1466470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466482 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466510 */     // GIR_Coverage, 14284,
     /* 1466510 */     GIR_EraseRootFromParent_Done,
     /* 1466511 */   // Label 20571: @1466511
     /* 1466511 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1466611), // Rule ID 14285 //
     /* 1466516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466566 */     // MIs[1] Operand 1
     /* 1466566 */     // No operand predicates
     /* 1466566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466570 */     // MIs[0] policy
     /* 1466570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466610 */     // GIR_Coverage, 14285,
     /* 1466610 */     GIR_EraseRootFromParent_Done,
     /* 1466611 */   // Label 20572: @1466611
     /* 1466611 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1466711), // Rule ID 14288 //
     /* 1466616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466666 */     // MIs[1] Operand 1
     /* 1466666 */     // No operand predicates
     /* 1466666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466670 */     // MIs[0] policy
     /* 1466670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466710 */     // GIR_Coverage, 14288,
     /* 1466710 */     GIR_EraseRootFromParent_Done,
     /* 1466711 */   // Label 20573: @1466711
     /* 1466711 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1466811), // Rule ID 14289 //
     /* 1466716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466766 */     // MIs[1] Operand 1
     /* 1466766 */     // No operand predicates
     /* 1466766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466770 */     // MIs[0] policy
     /* 1466770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466810 */     // GIR_Coverage, 14289,
     /* 1466810 */     GIR_EraseRootFromParent_Done,
     /* 1466811 */   // Label 20574: @1466811
     /* 1466811 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1466911), // Rule ID 14292 //
     /* 1466816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466866 */     // MIs[1] Operand 1
     /* 1466866 */     // No operand predicates
     /* 1466866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466870 */     // MIs[0] policy
     /* 1466870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466910 */     // GIR_Coverage, 14292,
     /* 1466910 */     GIR_EraseRootFromParent_Done,
     /* 1466911 */   // Label 20575: @1466911
     /* 1466911 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1467011), // Rule ID 14293 //
     /* 1466916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466966 */     // MIs[1] Operand 1
     /* 1466966 */     // No operand predicates
     /* 1466966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466970 */     // MIs[0] policy
     /* 1466970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466982 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467010 */     // GIR_Coverage, 14293,
     /* 1467010 */     GIR_EraseRootFromParent_Done,
     /* 1467011 */   // Label 20576: @1467011
     /* 1467011 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1467111), // Rule ID 14296 //
     /* 1467016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1467027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1467030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1467033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467066 */     // MIs[1] Operand 1
     /* 1467066 */     // No operand predicates
     /* 1467066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467070 */     // MIs[0] policy
     /* 1467070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467082 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467110 */     // GIR_Coverage, 14296,
     /* 1467110 */     GIR_EraseRootFromParent_Done,
     /* 1467111 */   // Label 20577: @1467111
     /* 1467111 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1467211), // Rule ID 14297 //
     /* 1467116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1467127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1467130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1467133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467166 */     // MIs[1] Operand 1
     /* 1467166 */     // No operand predicates
     /* 1467166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467170 */     // MIs[0] policy
     /* 1467170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467210 */     // GIR_Coverage, 14297,
     /* 1467210 */     GIR_EraseRootFromParent_Done,
     /* 1467211 */   // Label 20578: @1467211
     /* 1467211 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1467311), // Rule ID 14300 //
     /* 1467216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467266 */     // MIs[1] Operand 1
     /* 1467266 */     // No operand predicates
     /* 1467266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467270 */     // MIs[0] policy
     /* 1467270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467310 */     // GIR_Coverage, 14300,
     /* 1467310 */     GIR_EraseRootFromParent_Done,
     /* 1467311 */   // Label 20579: @1467311
     /* 1467311 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1467411), // Rule ID 14301 //
     /* 1467316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1467327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1467330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1467333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467366 */     // MIs[1] Operand 1
     /* 1467366 */     // No operand predicates
     /* 1467366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467370 */     // MIs[0] policy
     /* 1467370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467410 */     // GIR_Coverage, 14301,
     /* 1467410 */     GIR_EraseRootFromParent_Done,
     /* 1467411 */   // Label 20580: @1467411
     /* 1467411 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1467511), // Rule ID 14304 //
     /* 1467416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467466 */     // MIs[1] Operand 1
     /* 1467466 */     // No operand predicates
     /* 1467466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467470 */     // MIs[0] policy
     /* 1467470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467510 */     // GIR_Coverage, 14304,
     /* 1467510 */     GIR_EraseRootFromParent_Done,
     /* 1467511 */   // Label 20581: @1467511
     /* 1467511 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1467611), // Rule ID 14305 //
     /* 1467516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467566 */     // MIs[1] Operand 1
     /* 1467566 */     // No operand predicates
     /* 1467566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467570 */     // MIs[0] policy
     /* 1467570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467610 */     // GIR_Coverage, 14305,
     /* 1467610 */     GIR_EraseRootFromParent_Done,
     /* 1467611 */   // Label 20582: @1467611
     /* 1467611 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1467711), // Rule ID 14308 //
     /* 1467616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467666 */     // MIs[1] Operand 1
     /* 1467666 */     // No operand predicates
     /* 1467666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467670 */     // MIs[0] policy
     /* 1467670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467710 */     // GIR_Coverage, 14308,
     /* 1467710 */     GIR_EraseRootFromParent_Done,
     /* 1467711 */   // Label 20583: @1467711
     /* 1467711 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1467811), // Rule ID 14309 //
     /* 1467716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467766 */     // MIs[1] Operand 1
     /* 1467766 */     // No operand predicates
     /* 1467766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467770 */     // MIs[0] policy
     /* 1467770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467810 */     // GIR_Coverage, 14309,
     /* 1467810 */     GIR_EraseRootFromParent_Done,
     /* 1467811 */   // Label 20584: @1467811
     /* 1467811 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1467911), // Rule ID 14312 //
     /* 1467816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467866 */     // MIs[1] Operand 1
     /* 1467866 */     // No operand predicates
     /* 1467866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467870 */     // MIs[0] policy
     /* 1467870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467910 */     // GIR_Coverage, 14312,
     /* 1467910 */     GIR_EraseRootFromParent_Done,
     /* 1467911 */   // Label 20585: @1467911
     /* 1467911 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1468011), // Rule ID 14313 //
     /* 1467916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467966 */     // MIs[1] Operand 1
     /* 1467966 */     // No operand predicates
     /* 1467966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467970 */     // MIs[0] policy
     /* 1467970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468010 */     // GIR_Coverage, 14313,
     /* 1468010 */     GIR_EraseRootFromParent_Done,
     /* 1468011 */   // Label 20586: @1468011
     /* 1468011 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1468111), // Rule ID 14316 //
     /* 1468016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1468019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1468027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1468030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1468033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468066 */     // MIs[1] Operand 1
     /* 1468066 */     // No operand predicates
     /* 1468066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468070 */     // MIs[0] policy
     /* 1468070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1468085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468110 */     // GIR_Coverage, 14316,
     /* 1468110 */     GIR_EraseRootFromParent_Done,
     /* 1468111 */   // Label 20587: @1468111
     /* 1468111 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1468211), // Rule ID 14317 //
     /* 1468116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1468119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1468127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1468130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1468133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468166 */     // MIs[1] Operand 1
     /* 1468166 */     // No operand predicates
     /* 1468166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468170 */     // MIs[0] policy
     /* 1468170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1468185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468210 */     // GIR_Coverage, 14317,
     /* 1468210 */     GIR_EraseRootFromParent_Done,
     /* 1468211 */   // Label 20588: @1468211
     /* 1468211 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1468311), // Rule ID 14320 //
     /* 1468216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1468219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1468227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1468230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1468233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468266 */     // MIs[1] Operand 1
     /* 1468266 */     // No operand predicates
     /* 1468266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468270 */     // MIs[0] policy
     /* 1468270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1468285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468310 */     // GIR_Coverage, 14320,
     /* 1468310 */     GIR_EraseRootFromParent_Done,
     /* 1468311 */   // Label 20589: @1468311
     /* 1468311 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1468411), // Rule ID 14321 //
     /* 1468316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1468319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1468324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1468327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1468330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1468333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468366 */     // MIs[1] Operand 1
     /* 1468366 */     // No operand predicates
     /* 1468366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468370 */     // MIs[0] policy
     /* 1468370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1468385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1468404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468410 */     // GIR_Coverage, 14321,
     /* 1468410 */     GIR_EraseRootFromParent_Done,
     /* 1468411 */   // Label 20590: @1468411
     /* 1468411 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1468511), // Rule ID 14500 //
     /* 1468416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468466 */     // MIs[1] Operand 1
     /* 1468466 */     // No operand predicates
     /* 1468466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468470 */     // MIs[0] policy
     /* 1468470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468482 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468510 */     // GIR_Coverage, 14500,
     /* 1468510 */     GIR_EraseRootFromParent_Done,
     /* 1468511 */   // Label 20591: @1468511
     /* 1468511 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1468611), // Rule ID 14501 //
     /* 1468516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468566 */     // MIs[1] Operand 1
     /* 1468566 */     // No operand predicates
     /* 1468566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468570 */     // MIs[0] policy
     /* 1468570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468582 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468610 */     // GIR_Coverage, 14501,
     /* 1468610 */     GIR_EraseRootFromParent_Done,
     /* 1468611 */   // Label 20592: @1468611
     /* 1468611 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1468711), // Rule ID 14504 //
     /* 1468616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468666 */     // MIs[1] Operand 1
     /* 1468666 */     // No operand predicates
     /* 1468666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468670 */     // MIs[0] policy
     /* 1468670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468710 */     // GIR_Coverage, 14504,
     /* 1468710 */     GIR_EraseRootFromParent_Done,
     /* 1468711 */   // Label 20593: @1468711
     /* 1468711 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1468811), // Rule ID 14505 //
     /* 1468716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468766 */     // MIs[1] Operand 1
     /* 1468766 */     // No operand predicates
     /* 1468766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468770 */     // MIs[0] policy
     /* 1468770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468782 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468810 */     // GIR_Coverage, 14505,
     /* 1468810 */     GIR_EraseRootFromParent_Done,
     /* 1468811 */   // Label 20594: @1468811
     /* 1468811 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1468911), // Rule ID 14508 //
     /* 1468816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468866 */     // MIs[1] Operand 1
     /* 1468866 */     // No operand predicates
     /* 1468866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468870 */     // MIs[0] policy
     /* 1468870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468910 */     // GIR_Coverage, 14508,
     /* 1468910 */     GIR_EraseRootFromParent_Done,
     /* 1468911 */   // Label 20595: @1468911
     /* 1468911 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1469011), // Rule ID 14509 //
     /* 1468916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468966 */     // MIs[1] Operand 1
     /* 1468966 */     // No operand predicates
     /* 1468966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468970 */     // MIs[0] policy
     /* 1468970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469010 */     // GIR_Coverage, 14509,
     /* 1469010 */     GIR_EraseRootFromParent_Done,
     /* 1469011 */   // Label 20596: @1469011
     /* 1469011 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1469111), // Rule ID 14512 //
     /* 1469016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1469027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1469030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469066 */     // MIs[1] Operand 1
     /* 1469066 */     // No operand predicates
     /* 1469066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469070 */     // MIs[0] policy
     /* 1469070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1469085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469110 */     // GIR_Coverage, 14512,
     /* 1469110 */     GIR_EraseRootFromParent_Done,
     /* 1469111 */   // Label 20597: @1469111
     /* 1469111 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1469211), // Rule ID 14513 //
     /* 1469116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1469127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1469130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1469133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469166 */     // MIs[1] Operand 1
     /* 1469166 */     // No operand predicates
     /* 1469166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469170 */     // MIs[0] policy
     /* 1469170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1469185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469210 */     // GIR_Coverage, 14513,
     /* 1469210 */     GIR_EraseRootFromParent_Done,
     /* 1469211 */   // Label 20598: @1469211
     /* 1469211 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1469311), // Rule ID 14516 //
     /* 1469216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1469227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1469230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469266 */     // MIs[1] Operand 1
     /* 1469266 */     // No operand predicates
     /* 1469266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469270 */     // MIs[0] policy
     /* 1469270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469310 */     // GIR_Coverage, 14516,
     /* 1469310 */     GIR_EraseRootFromParent_Done,
     /* 1469311 */   // Label 20599: @1469311
     /* 1469311 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1469411), // Rule ID 14517 //
     /* 1469316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1469327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1469330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1469333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469366 */     // MIs[1] Operand 1
     /* 1469366 */     // No operand predicates
     /* 1469366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469370 */     // MIs[0] policy
     /* 1469370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469410 */     // GIR_Coverage, 14517,
     /* 1469410 */     GIR_EraseRootFromParent_Done,
     /* 1469411 */   // Label 20600: @1469411
     /* 1469411 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1469511), // Rule ID 14520 //
     /* 1469416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469466 */     // MIs[1] Operand 1
     /* 1469466 */     // No operand predicates
     /* 1469466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469470 */     // MIs[0] policy
     /* 1469470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469510 */     // GIR_Coverage, 14520,
     /* 1469510 */     GIR_EraseRootFromParent_Done,
     /* 1469511 */   // Label 20601: @1469511
     /* 1469511 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1469611), // Rule ID 14521 //
     /* 1469516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469566 */     // MIs[1] Operand 1
     /* 1469566 */     // No operand predicates
     /* 1469566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469570 */     // MIs[0] policy
     /* 1469570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469582 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469610 */     // GIR_Coverage, 14521,
     /* 1469610 */     GIR_EraseRootFromParent_Done,
     /* 1469611 */   // Label 20602: @1469611
     /* 1469611 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1469711), // Rule ID 14524 //
     /* 1469616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469666 */     // MIs[1] Operand 1
     /* 1469666 */     // No operand predicates
     /* 1469666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469670 */     // MIs[0] policy
     /* 1469670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469710 */     // GIR_Coverage, 14524,
     /* 1469710 */     GIR_EraseRootFromParent_Done,
     /* 1469711 */   // Label 20603: @1469711
     /* 1469711 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1469811), // Rule ID 14525 //
     /* 1469716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469766 */     // MIs[1] Operand 1
     /* 1469766 */     // No operand predicates
     /* 1469766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469770 */     // MIs[0] policy
     /* 1469770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469810 */     // GIR_Coverage, 14525,
     /* 1469810 */     GIR_EraseRootFromParent_Done,
     /* 1469811 */   // Label 20604: @1469811
     /* 1469811 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1469911), // Rule ID 14528 //
     /* 1469816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469866 */     // MIs[1] Operand 1
     /* 1469866 */     // No operand predicates
     /* 1469866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469870 */     // MIs[0] policy
     /* 1469870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469910 */     // GIR_Coverage, 14528,
     /* 1469910 */     GIR_EraseRootFromParent_Done,
     /* 1469911 */   // Label 20605: @1469911
     /* 1469911 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1470011), // Rule ID 14529 //
     /* 1469916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469966 */     // MIs[1] Operand 1
     /* 1469966 */     // No operand predicates
     /* 1469966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469970 */     // MIs[0] policy
     /* 1469970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470010 */     // GIR_Coverage, 14529,
     /* 1470010 */     GIR_EraseRootFromParent_Done,
     /* 1470011 */   // Label 20606: @1470011
     /* 1470011 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1470111), // Rule ID 14532 //
     /* 1470016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1470027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1470030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470066 */     // MIs[1] Operand 1
     /* 1470066 */     // No operand predicates
     /* 1470066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470070 */     // MIs[0] policy
     /* 1470070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470110 */     // GIR_Coverage, 14532,
     /* 1470110 */     GIR_EraseRootFromParent_Done,
     /* 1470111 */   // Label 20607: @1470111
     /* 1470111 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1470211), // Rule ID 14533 //
     /* 1470116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1470127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1470130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1470133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470166 */     // MIs[1] Operand 1
     /* 1470166 */     // No operand predicates
     /* 1470166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470170 */     // MIs[0] policy
     /* 1470170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1470204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470210 */     // GIR_Coverage, 14533,
     /* 1470210 */     GIR_EraseRootFromParent_Done,
     /* 1470211 */   // Label 20608: @1470211
     /* 1470211 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1470311), // Rule ID 14536 //
     /* 1470216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1470219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1470227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1470230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1470233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470266 */     // MIs[1] Operand 1
     /* 1470266 */     // No operand predicates
     /* 1470266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470270 */     // MIs[0] policy
     /* 1470270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470310 */     // GIR_Coverage, 14536,
     /* 1470310 */     GIR_EraseRootFromParent_Done,
     /* 1470311 */   // Label 20609: @1470311
     /* 1470311 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1470411), // Rule ID 14537 //
     /* 1470316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1470319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1470327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1470330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1470333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470366 */     // MIs[1] Operand 1
     /* 1470366 */     // No operand predicates
     /* 1470366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470370 */     // MIs[0] policy
     /* 1470370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1470385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470410 */     // GIR_Coverage, 14537,
     /* 1470410 */     GIR_EraseRootFromParent_Done,
     /* 1470411 */   // Label 20610: @1470411
     /* 1470411 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1470511), // Rule ID 14540 //
     /* 1470416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470466 */     // MIs[1] Operand 1
     /* 1470466 */     // No operand predicates
     /* 1470466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470470 */     // MIs[0] policy
     /* 1470470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470510 */     // GIR_Coverage, 14540,
     /* 1470510 */     GIR_EraseRootFromParent_Done,
     /* 1470511 */   // Label 20611: @1470511
     /* 1470511 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1470611), // Rule ID 14541 //
     /* 1470516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470566 */     // MIs[1] Operand 1
     /* 1470566 */     // No operand predicates
     /* 1470566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470570 */     // MIs[0] policy
     /* 1470570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470610 */     // GIR_Coverage, 14541,
     /* 1470610 */     GIR_EraseRootFromParent_Done,
     /* 1470611 */   // Label 20612: @1470611
     /* 1470611 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1470711), // Rule ID 14544 //
     /* 1470616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470666 */     // MIs[1] Operand 1
     /* 1470666 */     // No operand predicates
     /* 1470666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470670 */     // MIs[0] policy
     /* 1470670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470682 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470710 */     // GIR_Coverage, 14544,
     /* 1470710 */     GIR_EraseRootFromParent_Done,
     /* 1470711 */   // Label 20613: @1470711
     /* 1470711 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1470811), // Rule ID 14545 //
     /* 1470716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470766 */     // MIs[1] Operand 1
     /* 1470766 */     // No operand predicates
     /* 1470766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470770 */     // MIs[0] policy
     /* 1470770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470810 */     // GIR_Coverage, 14545,
     /* 1470810 */     GIR_EraseRootFromParent_Done,
     /* 1470811 */   // Label 20614: @1470811
     /* 1470811 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1470911), // Rule ID 14548 //
     /* 1470816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470866 */     // MIs[1] Operand 1
     /* 1470866 */     // No operand predicates
     /* 1470866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470870 */     // MIs[0] policy
     /* 1470870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470882 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470910 */     // GIR_Coverage, 14548,
     /* 1470910 */     GIR_EraseRootFromParent_Done,
     /* 1470911 */   // Label 20615: @1470911
     /* 1470911 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1471011), // Rule ID 14549 //
     /* 1470916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470966 */     // MIs[1] Operand 1
     /* 1470966 */     // No operand predicates
     /* 1470966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470970 */     // MIs[0] policy
     /* 1470970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470982 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471010 */     // GIR_Coverage, 14549,
     /* 1471010 */     GIR_EraseRootFromParent_Done,
     /* 1471011 */   // Label 20616: @1471011
     /* 1471011 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1471111), // Rule ID 14552 //
     /* 1471016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1471027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1471030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1471033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471066 */     // MIs[1] Operand 1
     /* 1471066 */     // No operand predicates
     /* 1471066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471070 */     // MIs[0] policy
     /* 1471070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471110 */     // GIR_Coverage, 14552,
     /* 1471110 */     GIR_EraseRootFromParent_Done,
     /* 1471111 */   // Label 20617: @1471111
     /* 1471111 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1471211), // Rule ID 14553 //
     /* 1471116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1471127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1471130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1471133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471166 */     // MIs[1] Operand 1
     /* 1471166 */     // No operand predicates
     /* 1471166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471170 */     // MIs[0] policy
     /* 1471170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471210 */     // GIR_Coverage, 14553,
     /* 1471210 */     GIR_EraseRootFromParent_Done,
     /* 1471211 */   // Label 20618: @1471211
     /* 1471211 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1471311), // Rule ID 14556 //
     /* 1471216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1471233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471266 */     // MIs[1] Operand 1
     /* 1471266 */     // No operand predicates
     /* 1471266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471270 */     // MIs[0] policy
     /* 1471270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471282 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471310 */     // GIR_Coverage, 14556,
     /* 1471310 */     GIR_EraseRootFromParent_Done,
     /* 1471311 */   // Label 20619: @1471311
     /* 1471311 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1471411), // Rule ID 14557 //
     /* 1471316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1471327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1471330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1471333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471366 */     // MIs[1] Operand 1
     /* 1471366 */     // No operand predicates
     /* 1471366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471370 */     // MIs[0] policy
     /* 1471370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471410 */     // GIR_Coverage, 14557,
     /* 1471410 */     GIR_EraseRootFromParent_Done,
     /* 1471411 */   // Label 20620: @1471411
     /* 1471411 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1471511), // Rule ID 14560 //
     /* 1471416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471466 */     // MIs[1] Operand 1
     /* 1471466 */     // No operand predicates
     /* 1471466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471470 */     // MIs[0] policy
     /* 1471470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471510 */     // GIR_Coverage, 14560,
     /* 1471510 */     GIR_EraseRootFromParent_Done,
     /* 1471511 */   // Label 20621: @1471511
     /* 1471511 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1471611), // Rule ID 14561 //
     /* 1471516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471566 */     // MIs[1] Operand 1
     /* 1471566 */     // No operand predicates
     /* 1471566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471570 */     // MIs[0] policy
     /* 1471570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471610 */     // GIR_Coverage, 14561,
     /* 1471610 */     GIR_EraseRootFromParent_Done,
     /* 1471611 */   // Label 20622: @1471611
     /* 1471611 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1471711), // Rule ID 14564 //
     /* 1471616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471666 */     // MIs[1] Operand 1
     /* 1471666 */     // No operand predicates
     /* 1471666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471670 */     // MIs[0] policy
     /* 1471670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471710 */     // GIR_Coverage, 14564,
     /* 1471710 */     GIR_EraseRootFromParent_Done,
     /* 1471711 */   // Label 20623: @1471711
     /* 1471711 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1471811), // Rule ID 14565 //
     /* 1471716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471766 */     // MIs[1] Operand 1
     /* 1471766 */     // No operand predicates
     /* 1471766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471770 */     // MIs[0] policy
     /* 1471770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471810 */     // GIR_Coverage, 14565,
     /* 1471810 */     GIR_EraseRootFromParent_Done,
     /* 1471811 */   // Label 20624: @1471811
     /* 1471811 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1471911), // Rule ID 14568 //
     /* 1471816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471866 */     // MIs[1] Operand 1
     /* 1471866 */     // No operand predicates
     /* 1471866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471870 */     // MIs[0] policy
     /* 1471870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471910 */     // GIR_Coverage, 14568,
     /* 1471910 */     GIR_EraseRootFromParent_Done,
     /* 1471911 */   // Label 20625: @1471911
     /* 1471911 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1472011), // Rule ID 14569 //
     /* 1471916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471966 */     // MIs[1] Operand 1
     /* 1471966 */     // No operand predicates
     /* 1471966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471970 */     // MIs[0] policy
     /* 1471970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472010 */     // GIR_Coverage, 14569,
     /* 1472010 */     GIR_EraseRootFromParent_Done,
     /* 1472011 */   // Label 20626: @1472011
     /* 1472011 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1472111), // Rule ID 14572 //
     /* 1472016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1472027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1472030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1472033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472066 */     // MIs[1] Operand 1
     /* 1472066 */     // No operand predicates
     /* 1472066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472070 */     // MIs[0] policy
     /* 1472070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472110 */     // GIR_Coverage, 14572,
     /* 1472110 */     GIR_EraseRootFromParent_Done,
     /* 1472111 */   // Label 20627: @1472111
     /* 1472111 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1472211), // Rule ID 14573 //
     /* 1472116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1472127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1472130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1472133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472166 */     // MIs[1] Operand 1
     /* 1472166 */     // No operand predicates
     /* 1472166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472170 */     // MIs[0] policy
     /* 1472170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1472204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472210 */     // GIR_Coverage, 14573,
     /* 1472210 */     GIR_EraseRootFromParent_Done,
     /* 1472211 */   // Label 20628: @1472211
     /* 1472211 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1472311), // Rule ID 14576 //
     /* 1472216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1472227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1472230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1472233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472266 */     // MIs[1] Operand 1
     /* 1472266 */     // No operand predicates
     /* 1472266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472270 */     // MIs[0] policy
     /* 1472270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1472285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472310 */     // GIR_Coverage, 14576,
     /* 1472310 */     GIR_EraseRootFromParent_Done,
     /* 1472311 */   // Label 20629: @1472311
     /* 1472311 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1472411), // Rule ID 14577 //
     /* 1472316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1472327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1472330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1472333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472366 */     // MIs[1] Operand 1
     /* 1472366 */     // No operand predicates
     /* 1472366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472370 */     // MIs[0] policy
     /* 1472370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1472385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472410 */     // GIR_Coverage, 14577,
     /* 1472410 */     GIR_EraseRootFromParent_Done,
     /* 1472411 */   // Label 20630: @1472411
     /* 1472411 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1472511), // Rule ID 14580 //
     /* 1472416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472466 */     // MIs[1] Operand 1
     /* 1472466 */     // No operand predicates
     /* 1472466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472470 */     // MIs[0] policy
     /* 1472470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472510 */     // GIR_Coverage, 14580,
     /* 1472510 */     GIR_EraseRootFromParent_Done,
     /* 1472511 */   // Label 20631: @1472511
     /* 1472511 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1472611), // Rule ID 14581 //
     /* 1472516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472566 */     // MIs[1] Operand 1
     /* 1472566 */     // No operand predicates
     /* 1472566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472570 */     // MIs[0] policy
     /* 1472570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472610 */     // GIR_Coverage, 14581,
     /* 1472610 */     GIR_EraseRootFromParent_Done,
     /* 1472611 */   // Label 20632: @1472611
     /* 1472611 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1472711), // Rule ID 14584 //
     /* 1472616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472666 */     // MIs[1] Operand 1
     /* 1472666 */     // No operand predicates
     /* 1472666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472670 */     // MIs[0] policy
     /* 1472670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472710 */     // GIR_Coverage, 14584,
     /* 1472710 */     GIR_EraseRootFromParent_Done,
     /* 1472711 */   // Label 20633: @1472711
     /* 1472711 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1472811), // Rule ID 14585 //
     /* 1472716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472766 */     // MIs[1] Operand 1
     /* 1472766 */     // No operand predicates
     /* 1472766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472770 */     // MIs[0] policy
     /* 1472770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472810 */     // GIR_Coverage, 14585,
     /* 1472810 */     GIR_EraseRootFromParent_Done,
     /* 1472811 */   // Label 20634: @1472811
     /* 1472811 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1472908), // Rule ID 23704 //
     /* 1472816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472866 */     // MIs[1] Operand 1
     /* 1472866 */     // No operand predicates
     /* 1472866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472870 */     // MIs[0] policy
     /* 1472870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472907 */     // GIR_Coverage, 23704,
     /* 1472907 */     GIR_EraseRootFromParent_Done,
     /* 1472908 */   // Label 20635: @1472908
     /* 1472908 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1473005), // Rule ID 23705 //
     /* 1472913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472963 */     // MIs[1] Operand 1
     /* 1472963 */     // No operand predicates
     /* 1472963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472967 */     // MIs[0] policy
     /* 1472967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472979 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473004 */     // GIR_Coverage, 23705,
     /* 1473004 */     GIR_EraseRootFromParent_Done,
     /* 1473005 */   // Label 20636: @1473005
     /* 1473005 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1473102), // Rule ID 23708 //
     /* 1473010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1473021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1473024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1473027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473060 */     // MIs[1] Operand 1
     /* 1473060 */     // No operand predicates
     /* 1473060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473064 */     // MIs[0] policy
     /* 1473064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473101 */     // GIR_Coverage, 23708,
     /* 1473101 */     GIR_EraseRootFromParent_Done,
     /* 1473102 */   // Label 20637: @1473102
     /* 1473102 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1473199), // Rule ID 23709 //
     /* 1473107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1473118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1473121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1473124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473157 */     // MIs[1] Operand 1
     /* 1473157 */     // No operand predicates
     /* 1473157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473161 */     // MIs[0] policy
     /* 1473161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473173 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473198 */     // GIR_Coverage, 23709,
     /* 1473198 */     GIR_EraseRootFromParent_Done,
     /* 1473199 */   // Label 20638: @1473199
     /* 1473199 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1473296), // Rule ID 23712 //
     /* 1473204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1473215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1473218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1473221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473254 */     // MIs[1] Operand 1
     /* 1473254 */     // No operand predicates
     /* 1473254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473258 */     // MIs[0] policy
     /* 1473258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473270 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473295 */     // GIR_Coverage, 23712,
     /* 1473295 */     GIR_EraseRootFromParent_Done,
     /* 1473296 */   // Label 20639: @1473296
     /* 1473296 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1473393), // Rule ID 23713 //
     /* 1473301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1473312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1473315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1473318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473351 */     // MIs[1] Operand 1
     /* 1473351 */     // No operand predicates
     /* 1473351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473355 */     // MIs[0] policy
     /* 1473355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473367 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473392 */     // GIR_Coverage, 23713,
     /* 1473392 */     GIR_EraseRootFromParent_Done,
     /* 1473393 */   // Label 20640: @1473393
     /* 1473393 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1473490), // Rule ID 23716 //
     /* 1473398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473448 */     // MIs[1] Operand 1
     /* 1473448 */     // No operand predicates
     /* 1473448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473452 */     // MIs[0] policy
     /* 1473452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473489 */     // GIR_Coverage, 23716,
     /* 1473489 */     GIR_EraseRootFromParent_Done,
     /* 1473490 */   // Label 20641: @1473490
     /* 1473490 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1473587), // Rule ID 23717 //
     /* 1473495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473545 */     // MIs[1] Operand 1
     /* 1473545 */     // No operand predicates
     /* 1473545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473549 */     // MIs[0] policy
     /* 1473549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473586 */     // GIR_Coverage, 23717,
     /* 1473586 */     GIR_EraseRootFromParent_Done,
     /* 1473587 */   // Label 20642: @1473587
     /* 1473587 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1473684), // Rule ID 23720 //
     /* 1473592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473642 */     // MIs[1] Operand 1
     /* 1473642 */     // No operand predicates
     /* 1473642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473646 */     // MIs[0] policy
     /* 1473646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473658 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473683 */     // GIR_Coverage, 23720,
     /* 1473683 */     GIR_EraseRootFromParent_Done,
     /* 1473684 */   // Label 20643: @1473684
     /* 1473684 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1473781), // Rule ID 23721 //
     /* 1473689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473739 */     // MIs[1] Operand 1
     /* 1473739 */     // No operand predicates
     /* 1473739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473743 */     // MIs[0] policy
     /* 1473743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473755 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473780 */     // GIR_Coverage, 23721,
     /* 1473780 */     GIR_EraseRootFromParent_Done,
     /* 1473781 */   // Label 20644: @1473781
     /* 1473781 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1473878), // Rule ID 23724 //
     /* 1473786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473836 */     // MIs[1] Operand 1
     /* 1473836 */     // No operand predicates
     /* 1473836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473840 */     // MIs[0] policy
     /* 1473840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473877 */     // GIR_Coverage, 23724,
     /* 1473877 */     GIR_EraseRootFromParent_Done,
     /* 1473878 */   // Label 20645: @1473878
     /* 1473878 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1473975), // Rule ID 23725 //
     /* 1473883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473933 */     // MIs[1] Operand 1
     /* 1473933 */     // No operand predicates
     /* 1473933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473937 */     // MIs[0] policy
     /* 1473937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473949 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473974 */     // GIR_Coverage, 23725,
     /* 1473974 */     GIR_EraseRootFromParent_Done,
     /* 1473975 */   // Label 20646: @1473975
     /* 1473975 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1474072), // Rule ID 23728 //
     /* 1473980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474030 */     // MIs[1] Operand 1
     /* 1474030 */     // No operand predicates
     /* 1474030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474034 */     // MIs[0] policy
     /* 1474034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474046 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474071 */     // GIR_Coverage, 23728,
     /* 1474071 */     GIR_EraseRootFromParent_Done,
     /* 1474072 */   // Label 20647: @1474072
     /* 1474072 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1474169), // Rule ID 23729 //
     /* 1474077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1474088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1474091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1474094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474127 */     // MIs[1] Operand 1
     /* 1474127 */     // No operand predicates
     /* 1474127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474131 */     // MIs[0] policy
     /* 1474131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474143 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474168 */     // GIR_Coverage, 23729,
     /* 1474168 */     GIR_EraseRootFromParent_Done,
     /* 1474169 */   // Label 20648: @1474169
     /* 1474169 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1474266), // Rule ID 23732 //
     /* 1474174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474224 */     // MIs[1] Operand 1
     /* 1474224 */     // No operand predicates
     /* 1474224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474228 */     // MIs[0] policy
     /* 1474228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474265 */     // GIR_Coverage, 23732,
     /* 1474265 */     GIR_EraseRootFromParent_Done,
     /* 1474266 */   // Label 20649: @1474266
     /* 1474266 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1474363), // Rule ID 23733 //
     /* 1474271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474321 */     // MIs[1] Operand 1
     /* 1474321 */     // No operand predicates
     /* 1474321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474325 */     // MIs[0] policy
     /* 1474325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474337 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474362 */     // GIR_Coverage, 23733,
     /* 1474362 */     GIR_EraseRootFromParent_Done,
     /* 1474363 */   // Label 20650: @1474363
     /* 1474363 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1474460), // Rule ID 23736 //
     /* 1474368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474418 */     // MIs[1] Operand 1
     /* 1474418 */     // No operand predicates
     /* 1474418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474422 */     // MIs[0] policy
     /* 1474422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474459 */     // GIR_Coverage, 23736,
     /* 1474459 */     GIR_EraseRootFromParent_Done,
     /* 1474460 */   // Label 20651: @1474460
     /* 1474460 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1474557), // Rule ID 23737 //
     /* 1474465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474515 */     // MIs[1] Operand 1
     /* 1474515 */     // No operand predicates
     /* 1474515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474519 */     // MIs[0] policy
     /* 1474519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474531 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474556 */     // GIR_Coverage, 23737,
     /* 1474556 */     GIR_EraseRootFromParent_Done,
     /* 1474557 */   // Label 20652: @1474557
     /* 1474557 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1474654), // Rule ID 23740 //
     /* 1474562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474612 */     // MIs[1] Operand 1
     /* 1474612 */     // No operand predicates
     /* 1474612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474616 */     // MIs[0] policy
     /* 1474616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474653 */     // GIR_Coverage, 23740,
     /* 1474653 */     GIR_EraseRootFromParent_Done,
     /* 1474654 */   // Label 20653: @1474654
     /* 1474654 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1474751), // Rule ID 23741 //
     /* 1474659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474709 */     // MIs[1] Operand 1
     /* 1474709 */     // No operand predicates
     /* 1474709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474713 */     // MIs[0] policy
     /* 1474713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474725 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474750 */     // GIR_Coverage, 23741,
     /* 1474750 */     GIR_EraseRootFromParent_Done,
     /* 1474751 */   // Label 20654: @1474751
     /* 1474751 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1474848), // Rule ID 23744 //
     /* 1474756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474806 */     // MIs[1] Operand 1
     /* 1474806 */     // No operand predicates
     /* 1474806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474810 */     // MIs[0] policy
     /* 1474810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474822 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474847 */     // GIR_Coverage, 23744,
     /* 1474847 */     GIR_EraseRootFromParent_Done,
     /* 1474848 */   // Label 20655: @1474848
     /* 1474848 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1474945), // Rule ID 23745 //
     /* 1474853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474903 */     // MIs[1] Operand 1
     /* 1474903 */     // No operand predicates
     /* 1474903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474907 */     // MIs[0] policy
     /* 1474907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474944 */     // GIR_Coverage, 23745,
     /* 1474944 */     GIR_EraseRootFromParent_Done,
     /* 1474945 */   // Label 20656: @1474945
     /* 1474945 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1475042), // Rule ID 23748 //
     /* 1474950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475000 */     // MIs[1] Operand 1
     /* 1475000 */     // No operand predicates
     /* 1475000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475004 */     // MIs[0] policy
     /* 1475004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475016 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475041 */     // GIR_Coverage, 23748,
     /* 1475041 */     GIR_EraseRootFromParent_Done,
     /* 1475042 */   // Label 20657: @1475042
     /* 1475042 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1475139), // Rule ID 23749 //
     /* 1475047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1475058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1475061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1475064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475097 */     // MIs[1] Operand 1
     /* 1475097 */     // No operand predicates
     /* 1475097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475101 */     // MIs[0] policy
     /* 1475101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475113 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475138 */     // GIR_Coverage, 23749,
     /* 1475138 */     GIR_EraseRootFromParent_Done,
     /* 1475139 */   // Label 20658: @1475139
     /* 1475139 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1475236), // Rule ID 23752 //
     /* 1475144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1475155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1475158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1475161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1475167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475194 */     // MIs[1] Operand 1
     /* 1475194 */     // No operand predicates
     /* 1475194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475198 */     // MIs[0] policy
     /* 1475198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475210 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475235 */     // GIR_Coverage, 23752,
     /* 1475235 */     GIR_EraseRootFromParent_Done,
     /* 1475236 */   // Label 20659: @1475236
     /* 1475236 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1475333), // Rule ID 23753 //
     /* 1475241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1475252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1475255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1475258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1475264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475291 */     // MIs[1] Operand 1
     /* 1475291 */     // No operand predicates
     /* 1475291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475295 */     // MIs[0] policy
     /* 1475295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475307 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475332 */     // GIR_Coverage, 23753,
     /* 1475332 */     GIR_EraseRootFromParent_Done,
     /* 1475333 */   // Label 20660: @1475333
     /* 1475333 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1475430), // Rule ID 23756 //
     /* 1475338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475388 */     // MIs[1] Operand 1
     /* 1475388 */     // No operand predicates
     /* 1475388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475392 */     // MIs[0] policy
     /* 1475392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475429 */     // GIR_Coverage, 23756,
     /* 1475429 */     GIR_EraseRootFromParent_Done,
     /* 1475430 */   // Label 20661: @1475430
     /* 1475430 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1475527), // Rule ID 23757 //
     /* 1475435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475485 */     // MIs[1] Operand 1
     /* 1475485 */     // No operand predicates
     /* 1475485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475489 */     // MIs[0] policy
     /* 1475489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475526 */     // GIR_Coverage, 23757,
     /* 1475526 */     GIR_EraseRootFromParent_Done,
     /* 1475527 */   // Label 20662: @1475527
     /* 1475527 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1475624), // Rule ID 23760 //
     /* 1475532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475582 */     // MIs[1] Operand 1
     /* 1475582 */     // No operand predicates
     /* 1475582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475586 */     // MIs[0] policy
     /* 1475586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475623 */     // GIR_Coverage, 23760,
     /* 1475623 */     GIR_EraseRootFromParent_Done,
     /* 1475624 */   // Label 20663: @1475624
     /* 1475624 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1475721), // Rule ID 23761 //
     /* 1475629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475679 */     // MIs[1] Operand 1
     /* 1475679 */     // No operand predicates
     /* 1475679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475683 */     // MIs[0] policy
     /* 1475683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475695 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475720 */     // GIR_Coverage, 23761,
     /* 1475720 */     GIR_EraseRootFromParent_Done,
     /* 1475721 */   // Label 20664: @1475721
     /* 1475721 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1475818), // Rule ID 23764 //
     /* 1475726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475776 */     // MIs[1] Operand 1
     /* 1475776 */     // No operand predicates
     /* 1475776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475780 */     // MIs[0] policy
     /* 1475780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475817 */     // GIR_Coverage, 23764,
     /* 1475817 */     GIR_EraseRootFromParent_Done,
     /* 1475818 */   // Label 20665: @1475818
     /* 1475818 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1475915), // Rule ID 23765 //
     /* 1475823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475873 */     // MIs[1] Operand 1
     /* 1475873 */     // No operand predicates
     /* 1475873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475877 */     // MIs[0] policy
     /* 1475877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475914 */     // GIR_Coverage, 23765,
     /* 1475914 */     GIR_EraseRootFromParent_Done,
     /* 1475915 */   // Label 20666: @1475915
     /* 1475915 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1476012), // Rule ID 23768 //
     /* 1475920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475970 */     // MIs[1] Operand 1
     /* 1475970 */     // No operand predicates
     /* 1475970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475974 */     // MIs[0] policy
     /* 1475974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476011 */     // GIR_Coverage, 23768,
     /* 1476011 */     GIR_EraseRootFromParent_Done,
     /* 1476012 */   // Label 20667: @1476012
     /* 1476012 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1476109), // Rule ID 23769 //
     /* 1476017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1476028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1476031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476067 */     // MIs[1] Operand 1
     /* 1476067 */     // No operand predicates
     /* 1476067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476071 */     // MIs[0] policy
     /* 1476071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476108 */     // GIR_Coverage, 23769,
     /* 1476108 */     GIR_EraseRootFromParent_Done,
     /* 1476109 */   // Label 20668: @1476109
     /* 1476109 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1476206), // Rule ID 23772 //
     /* 1476114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476164 */     // MIs[1] Operand 1
     /* 1476164 */     // No operand predicates
     /* 1476164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476168 */     // MIs[0] policy
     /* 1476168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476180 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476205 */     // GIR_Coverage, 23772,
     /* 1476205 */     GIR_EraseRootFromParent_Done,
     /* 1476206 */   // Label 20669: @1476206
     /* 1476206 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1476303), // Rule ID 23773 //
     /* 1476211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476261 */     // MIs[1] Operand 1
     /* 1476261 */     // No operand predicates
     /* 1476261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476265 */     // MIs[0] policy
     /* 1476265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476302 */     // GIR_Coverage, 23773,
     /* 1476302 */     GIR_EraseRootFromParent_Done,
     /* 1476303 */   // Label 20670: @1476303
     /* 1476303 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1476400), // Rule ID 23776 //
     /* 1476308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476358 */     // MIs[1] Operand 1
     /* 1476358 */     // No operand predicates
     /* 1476358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476362 */     // MIs[0] policy
     /* 1476362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476399 */     // GIR_Coverage, 23776,
     /* 1476399 */     GIR_EraseRootFromParent_Done,
     /* 1476400 */   // Label 20671: @1476400
     /* 1476400 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1476497), // Rule ID 23777 //
     /* 1476405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476455 */     // MIs[1] Operand 1
     /* 1476455 */     // No operand predicates
     /* 1476455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476459 */     // MIs[0] policy
     /* 1476459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476496 */     // GIR_Coverage, 23777,
     /* 1476496 */     GIR_EraseRootFromParent_Done,
     /* 1476497 */   // Label 20672: @1476497
     /* 1476497 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1476594), // Rule ID 23780 //
     /* 1476502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476552 */     // MIs[1] Operand 1
     /* 1476552 */     // No operand predicates
     /* 1476552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476556 */     // MIs[0] policy
     /* 1476556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476593 */     // GIR_Coverage, 23780,
     /* 1476593 */     GIR_EraseRootFromParent_Done,
     /* 1476594 */   // Label 20673: @1476594
     /* 1476594 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1476691), // Rule ID 23781 //
     /* 1476599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476649 */     // MIs[1] Operand 1
     /* 1476649 */     // No operand predicates
     /* 1476649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476653 */     // MIs[0] policy
     /* 1476653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476690 */     // GIR_Coverage, 23781,
     /* 1476690 */     GIR_EraseRootFromParent_Done,
     /* 1476691 */   // Label 20674: @1476691
     /* 1476691 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1476788), // Rule ID 23784 //
     /* 1476696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476746 */     // MIs[1] Operand 1
     /* 1476746 */     // No operand predicates
     /* 1476746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476750 */     // MIs[0] policy
     /* 1476750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476787 */     // GIR_Coverage, 23784,
     /* 1476787 */     GIR_EraseRootFromParent_Done,
     /* 1476788 */   // Label 20675: @1476788
     /* 1476788 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1476885), // Rule ID 23785 //
     /* 1476793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476843 */     // MIs[1] Operand 1
     /* 1476843 */     // No operand predicates
     /* 1476843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476847 */     // MIs[0] policy
     /* 1476847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476884 */     // GIR_Coverage, 23785,
     /* 1476884 */     GIR_EraseRootFromParent_Done,
     /* 1476885 */   // Label 20676: @1476885
     /* 1476885 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1476982), // Rule ID 23788 //
     /* 1476890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476940 */     // MIs[1] Operand 1
     /* 1476940 */     // No operand predicates
     /* 1476940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476944 */     // MIs[0] policy
     /* 1476944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476981 */     // GIR_Coverage, 23788,
     /* 1476981 */     GIR_EraseRootFromParent_Done,
     /* 1476982 */   // Label 20677: @1476982
     /* 1476982 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1477079), // Rule ID 23789 //
     /* 1476987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1477001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477037 */     // MIs[1] Operand 1
     /* 1477037 */     // No operand predicates
     /* 1477037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477041 */     // MIs[0] policy
     /* 1477041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477053 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1477056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1477075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477078 */     // GIR_Coverage, 23789,
     /* 1477078 */     GIR_EraseRootFromParent_Done,
     /* 1477079 */   // Label 20678: @1477079
     /* 1477079 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1477176), // Rule ID 23880 //
     /* 1477084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1477095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1477098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1477101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477134 */     // MIs[1] Operand 1
     /* 1477134 */     // No operand predicates
     /* 1477134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477138 */     // MIs[0] policy
     /* 1477138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477150 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1477153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477175 */     // GIR_Coverage, 23880,
     /* 1477175 */     GIR_EraseRootFromParent_Done,
     /* 1477176 */   // Label 20679: @1477176
     /* 1477176 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1477273), // Rule ID 23881 //
     /* 1477181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1477192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1477195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1477198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477231 */     // MIs[1] Operand 1
     /* 1477231 */     // No operand predicates
     /* 1477231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477235 */     // MIs[0] policy
     /* 1477235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477247 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1477250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477272 */     // GIR_Coverage, 23881,
     /* 1477272 */     GIR_EraseRootFromParent_Done,
     /* 1477273 */   // Label 20680: @1477273
     /* 1477273 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1477370), // Rule ID 23884 //
     /* 1477278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1477289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1477292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1477295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477328 */     // MIs[1] Operand 1
     /* 1477328 */     // No operand predicates
     /* 1477328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477332 */     // MIs[0] policy
     /* 1477332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477344 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477369 */     // GIR_Coverage, 23884,
     /* 1477369 */     GIR_EraseRootFromParent_Done,
     /* 1477370 */   // Label 20681: @1477370
     /* 1477370 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1477467), // Rule ID 23885 //
     /* 1477375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1477386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1477389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1477392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477425 */     // MIs[1] Operand 1
     /* 1477425 */     // No operand predicates
     /* 1477425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477429 */     // MIs[0] policy
     /* 1477429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477441 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477466 */     // GIR_Coverage, 23885,
     /* 1477466 */     GIR_EraseRootFromParent_Done,
     /* 1477467 */   // Label 20682: @1477467
     /* 1477467 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1477564), // Rule ID 23888 //
     /* 1477472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477522 */     // MIs[1] Operand 1
     /* 1477522 */     // No operand predicates
     /* 1477522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477526 */     // MIs[0] policy
     /* 1477526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477563 */     // GIR_Coverage, 23888,
     /* 1477563 */     GIR_EraseRootFromParent_Done,
     /* 1477564 */   // Label 20683: @1477564
     /* 1477564 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1477661), // Rule ID 23889 //
     /* 1477569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477619 */     // MIs[1] Operand 1
     /* 1477619 */     // No operand predicates
     /* 1477619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477623 */     // MIs[0] policy
     /* 1477623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477660 */     // GIR_Coverage, 23889,
     /* 1477660 */     GIR_EraseRootFromParent_Done,
     /* 1477661 */   // Label 20684: @1477661
     /* 1477661 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1477758), // Rule ID 23892 //
     /* 1477666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477716 */     // MIs[1] Operand 1
     /* 1477716 */     // No operand predicates
     /* 1477716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477720 */     // MIs[0] policy
     /* 1477720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477757 */     // GIR_Coverage, 23892,
     /* 1477757 */     GIR_EraseRootFromParent_Done,
     /* 1477758 */   // Label 20685: @1477758
     /* 1477758 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1477855), // Rule ID 23893 //
     /* 1477763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477813 */     // MIs[1] Operand 1
     /* 1477813 */     // No operand predicates
     /* 1477813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477817 */     // MIs[0] policy
     /* 1477817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477829 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477854 */     // GIR_Coverage, 23893,
     /* 1477854 */     GIR_EraseRootFromParent_Done,
     /* 1477855 */   // Label 20686: @1477855
     /* 1477855 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1477952), // Rule ID 23896 //
     /* 1477860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477910 */     // MIs[1] Operand 1
     /* 1477910 */     // No operand predicates
     /* 1477910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477914 */     // MIs[0] policy
     /* 1477914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477926 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477951 */     // GIR_Coverage, 23896,
     /* 1477951 */     GIR_EraseRootFromParent_Done,
     /* 1477952 */   // Label 20687: @1477952
     /* 1477952 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1478049), // Rule ID 23897 //
     /* 1477957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478007 */     // MIs[1] Operand 1
     /* 1478007 */     // No operand predicates
     /* 1478007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478011 */     // MIs[0] policy
     /* 1478011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478023 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478048 */     // GIR_Coverage, 23897,
     /* 1478048 */     GIR_EraseRootFromParent_Done,
     /* 1478049 */   // Label 20688: @1478049
     /* 1478049 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1478146), // Rule ID 23900 //
     /* 1478054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1478065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1478068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478104 */     // MIs[1] Operand 1
     /* 1478104 */     // No operand predicates
     /* 1478104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478108 */     // MIs[0] policy
     /* 1478108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478145 */     // GIR_Coverage, 23900,
     /* 1478145 */     GIR_EraseRootFromParent_Done,
     /* 1478146 */   // Label 20689: @1478146
     /* 1478146 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1478243), // Rule ID 23901 //
     /* 1478151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1478162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1478165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1478168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478201 */     // MIs[1] Operand 1
     /* 1478201 */     // No operand predicates
     /* 1478201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478205 */     // MIs[0] policy
     /* 1478205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478217 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1478220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478242 */     // GIR_Coverage, 23901,
     /* 1478242 */     GIR_EraseRootFromParent_Done,
     /* 1478243 */   // Label 20690: @1478243
     /* 1478243 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1478340), // Rule ID 23904 //
     /* 1478248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1478259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1478262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1478265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478298 */     // MIs[1] Operand 1
     /* 1478298 */     // No operand predicates
     /* 1478298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478302 */     // MIs[0] policy
     /* 1478302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478314 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478339 */     // GIR_Coverage, 23904,
     /* 1478339 */     GIR_EraseRootFromParent_Done,
     /* 1478340 */   // Label 20691: @1478340
     /* 1478340 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1478437), // Rule ID 23905 //
     /* 1478345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1478356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1478359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1478362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478395 */     // MIs[1] Operand 1
     /* 1478395 */     // No operand predicates
     /* 1478395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478399 */     // MIs[0] policy
     /* 1478399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478411 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478436 */     // GIR_Coverage, 23905,
     /* 1478436 */     GIR_EraseRootFromParent_Done,
     /* 1478437 */   // Label 20692: @1478437
     /* 1478437 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1478534), // Rule ID 23908 //
     /* 1478442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478492 */     // MIs[1] Operand 1
     /* 1478492 */     // No operand predicates
     /* 1478492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478496 */     // MIs[0] policy
     /* 1478496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478533 */     // GIR_Coverage, 23908,
     /* 1478533 */     GIR_EraseRootFromParent_Done,
     /* 1478534 */   // Label 20693: @1478534
     /* 1478534 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1478631), // Rule ID 23909 //
     /* 1478539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478589 */     // MIs[1] Operand 1
     /* 1478589 */     // No operand predicates
     /* 1478589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478593 */     // MIs[0] policy
     /* 1478593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478605 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478630 */     // GIR_Coverage, 23909,
     /* 1478630 */     GIR_EraseRootFromParent_Done,
     /* 1478631 */   // Label 20694: @1478631
     /* 1478631 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1478728), // Rule ID 23912 //
     /* 1478636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478686 */     // MIs[1] Operand 1
     /* 1478686 */     // No operand predicates
     /* 1478686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478690 */     // MIs[0] policy
     /* 1478690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478727 */     // GIR_Coverage, 23912,
     /* 1478727 */     GIR_EraseRootFromParent_Done,
     /* 1478728 */   // Label 20695: @1478728
     /* 1478728 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1478825), // Rule ID 23913 //
     /* 1478733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478783 */     // MIs[1] Operand 1
     /* 1478783 */     // No operand predicates
     /* 1478783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478787 */     // MIs[0] policy
     /* 1478787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478824 */     // GIR_Coverage, 23913,
     /* 1478824 */     GIR_EraseRootFromParent_Done,
     /* 1478825 */   // Label 20696: @1478825
     /* 1478825 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1478922), // Rule ID 23916 //
     /* 1478830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478880 */     // MIs[1] Operand 1
     /* 1478880 */     // No operand predicates
     /* 1478880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478884 */     // MIs[0] policy
     /* 1478884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478921 */     // GIR_Coverage, 23916,
     /* 1478921 */     GIR_EraseRootFromParent_Done,
     /* 1478922 */   // Label 20697: @1478922
     /* 1478922 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1479019), // Rule ID 23917 //
     /* 1478927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478977 */     // MIs[1] Operand 1
     /* 1478977 */     // No operand predicates
     /* 1478977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478981 */     // MIs[0] policy
     /* 1478981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479018 */     // GIR_Coverage, 23917,
     /* 1479018 */     GIR_EraseRootFromParent_Done,
     /* 1479019 */   // Label 20698: @1479019
     /* 1479019 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1479116), // Rule ID 23920 //
     /* 1479024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1479035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1479038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1479041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479074 */     // MIs[1] Operand 1
     /* 1479074 */     // No operand predicates
     /* 1479074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479078 */     // MIs[0] policy
     /* 1479078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479090 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479115 */     // GIR_Coverage, 23920,
     /* 1479115 */     GIR_EraseRootFromParent_Done,
     /* 1479116 */   // Label 20699: @1479116
     /* 1479116 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1479213), // Rule ID 23921 //
     /* 1479121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1479132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1479135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1479138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479171 */     // MIs[1] Operand 1
     /* 1479171 */     // No operand predicates
     /* 1479171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479175 */     // MIs[0] policy
     /* 1479175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479187 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479212 */     // GIR_Coverage, 23921,
     /* 1479212 */     GIR_EraseRootFromParent_Done,
     /* 1479213 */   // Label 20700: @1479213
     /* 1479213 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1479310), // Rule ID 23924 //
     /* 1479218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1479229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1479232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1479235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479268 */     // MIs[1] Operand 1
     /* 1479268 */     // No operand predicates
     /* 1479268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479272 */     // MIs[0] policy
     /* 1479272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479309 */     // GIR_Coverage, 23924,
     /* 1479309 */     GIR_EraseRootFromParent_Done,
     /* 1479310 */   // Label 20701: @1479310
     /* 1479310 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1479407), // Rule ID 23925 //
     /* 1479315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1479326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1479329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1479332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479365 */     // MIs[1] Operand 1
     /* 1479365 */     // No operand predicates
     /* 1479365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479369 */     // MIs[0] policy
     /* 1479369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479381 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479406 */     // GIR_Coverage, 23925,
     /* 1479406 */     GIR_EraseRootFromParent_Done,
     /* 1479407 */   // Label 20702: @1479407
     /* 1479407 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1479504), // Rule ID 23928 //
     /* 1479412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479462 */     // MIs[1] Operand 1
     /* 1479462 */     // No operand predicates
     /* 1479462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479466 */     // MIs[0] policy
     /* 1479466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479478 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479503 */     // GIR_Coverage, 23928,
     /* 1479503 */     GIR_EraseRootFromParent_Done,
     /* 1479504 */   // Label 20703: @1479504
     /* 1479504 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1479601), // Rule ID 23929 //
     /* 1479509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479559 */     // MIs[1] Operand 1
     /* 1479559 */     // No operand predicates
     /* 1479559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479563 */     // MIs[0] policy
     /* 1479563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479575 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479600 */     // GIR_Coverage, 23929,
     /* 1479600 */     GIR_EraseRootFromParent_Done,
     /* 1479601 */   // Label 20704: @1479601
     /* 1479601 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1479698), // Rule ID 23932 //
     /* 1479606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479656 */     // MIs[1] Operand 1
     /* 1479656 */     // No operand predicates
     /* 1479656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479660 */     // MIs[0] policy
     /* 1479660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479697 */     // GIR_Coverage, 23932,
     /* 1479697 */     GIR_EraseRootFromParent_Done,
     /* 1479698 */   // Label 20705: @1479698
     /* 1479698 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1479795), // Rule ID 23933 //
     /* 1479703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479753 */     // MIs[1] Operand 1
     /* 1479753 */     // No operand predicates
     /* 1479753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479757 */     // MIs[0] policy
     /* 1479757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479794 */     // GIR_Coverage, 23933,
     /* 1479794 */     GIR_EraseRootFromParent_Done,
     /* 1479795 */   // Label 20706: @1479795
     /* 1479795 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1479892), // Rule ID 23936 //
     /* 1479800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479850 */     // MIs[1] Operand 1
     /* 1479850 */     // No operand predicates
     /* 1479850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479854 */     // MIs[0] policy
     /* 1479854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479891 */     // GIR_Coverage, 23936,
     /* 1479891 */     GIR_EraseRootFromParent_Done,
     /* 1479892 */   // Label 20707: @1479892
     /* 1479892 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1479989), // Rule ID 23937 //
     /* 1479897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479947 */     // MIs[1] Operand 1
     /* 1479947 */     // No operand predicates
     /* 1479947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479951 */     // MIs[0] policy
     /* 1479951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479963 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479988 */     // GIR_Coverage, 23937,
     /* 1479988 */     GIR_EraseRootFromParent_Done,
     /* 1479989 */   // Label 20708: @1479989
     /* 1479989 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1480086), // Rule ID 23940 //
     /* 1479994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480044 */     // MIs[1] Operand 1
     /* 1480044 */     // No operand predicates
     /* 1480044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480048 */     // MIs[0] policy
     /* 1480048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480085 */     // GIR_Coverage, 23940,
     /* 1480085 */     GIR_EraseRootFromParent_Done,
     /* 1480086 */   // Label 20709: @1480086
     /* 1480086 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1480183), // Rule ID 23941 //
     /* 1480091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480141 */     // MIs[1] Operand 1
     /* 1480141 */     // No operand predicates
     /* 1480141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480145 */     // MIs[0] policy
     /* 1480145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480157 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480182 */     // GIR_Coverage, 23941,
     /* 1480182 */     GIR_EraseRootFromParent_Done,
     /* 1480183 */   // Label 20710: @1480183
     /* 1480183 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1480280), // Rule ID 23944 //
     /* 1480188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480238 */     // MIs[1] Operand 1
     /* 1480238 */     // No operand predicates
     /* 1480238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480242 */     // MIs[0] policy
     /* 1480242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480279 */     // GIR_Coverage, 23944,
     /* 1480279 */     GIR_EraseRootFromParent_Done,
     /* 1480280 */   // Label 20711: @1480280
     /* 1480280 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1480377), // Rule ID 23945 //
     /* 1480285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480335 */     // MIs[1] Operand 1
     /* 1480335 */     // No operand predicates
     /* 1480335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480339 */     // MIs[0] policy
     /* 1480339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480376 */     // GIR_Coverage, 23945,
     /* 1480376 */     GIR_EraseRootFromParent_Done,
     /* 1480377 */   // Label 20712: @1480377
     /* 1480377 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1480474), // Rule ID 23948 //
     /* 1480382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480432 */     // MIs[1] Operand 1
     /* 1480432 */     // No operand predicates
     /* 1480432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480436 */     // MIs[0] policy
     /* 1480436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480473 */     // GIR_Coverage, 23948,
     /* 1480473 */     GIR_EraseRootFromParent_Done,
     /* 1480474 */   // Label 20713: @1480474
     /* 1480474 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1480571), // Rule ID 23949 //
     /* 1480479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480529 */     // MIs[1] Operand 1
     /* 1480529 */     // No operand predicates
     /* 1480529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480533 */     // MIs[0] policy
     /* 1480533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480545 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480570 */     // GIR_Coverage, 23949,
     /* 1480570 */     GIR_EraseRootFromParent_Done,
     /* 1480571 */   // Label 20714: @1480571
     /* 1480571 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1480668), // Rule ID 23952 //
     /* 1480576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480626 */     // MIs[1] Operand 1
     /* 1480626 */     // No operand predicates
     /* 1480626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480630 */     // MIs[0] policy
     /* 1480630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480667 */     // GIR_Coverage, 23952,
     /* 1480667 */     GIR_EraseRootFromParent_Done,
     /* 1480668 */   // Label 20715: @1480668
     /* 1480668 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1480765), // Rule ID 23953 //
     /* 1480673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480723 */     // MIs[1] Operand 1
     /* 1480723 */     // No operand predicates
     /* 1480723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480727 */     // MIs[0] policy
     /* 1480727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480764 */     // GIR_Coverage, 23953,
     /* 1480764 */     GIR_EraseRootFromParent_Done,
     /* 1480765 */   // Label 20716: @1480765
     /* 1480765 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1480862), // Rule ID 23956 //
     /* 1480770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480820 */     // MIs[1] Operand 1
     /* 1480820 */     // No operand predicates
     /* 1480820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480824 */     // MIs[0] policy
     /* 1480824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480861 */     // GIR_Coverage, 23956,
     /* 1480861 */     GIR_EraseRootFromParent_Done,
     /* 1480862 */   // Label 20717: @1480862
     /* 1480862 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1480959), // Rule ID 23957 //
     /* 1480867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480917 */     // MIs[1] Operand 1
     /* 1480917 */     // No operand predicates
     /* 1480917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480921 */     // MIs[0] policy
     /* 1480921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480958 */     // GIR_Coverage, 23957,
     /* 1480958 */     GIR_EraseRootFromParent_Done,
     /* 1480959 */   // Label 20718: @1480959
     /* 1480959 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1481056), // Rule ID 23960 //
     /* 1480964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481014 */     // MIs[1] Operand 1
     /* 1481014 */     // No operand predicates
     /* 1481014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481018 */     // MIs[0] policy
     /* 1481018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1481033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481055 */     // GIR_Coverage, 23960,
     /* 1481055 */     GIR_EraseRootFromParent_Done,
     /* 1481056 */   // Label 20719: @1481056
     /* 1481056 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1481153), // Rule ID 23961 //
     /* 1481061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1481072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1481075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1481078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481111 */     // MIs[1] Operand 1
     /* 1481111 */     // No operand predicates
     /* 1481111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481115 */     // MIs[0] policy
     /* 1481115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1481130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481152 */     // GIR_Coverage, 23961,
     /* 1481152 */     GIR_EraseRootFromParent_Done,
     /* 1481153 */   // Label 20720: @1481153
     /* 1481153 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1481250), // Rule ID 23964 //
     /* 1481158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1481161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481208 */     // MIs[1] Operand 1
     /* 1481208 */     // No operand predicates
     /* 1481208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481212 */     // MIs[0] policy
     /* 1481212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1481227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481249 */     // GIR_Coverage, 23964,
     /* 1481249 */     GIR_EraseRootFromParent_Done,
     /* 1481250 */   // Label 20721: @1481250
     /* 1481250 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1481347), // Rule ID 23965 //
     /* 1481255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481305 */     // MIs[1] Operand 1
     /* 1481305 */     // No operand predicates
     /* 1481305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481309 */     // MIs[0] policy
     /* 1481309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1481324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481346 */     // GIR_Coverage, 23965,
     /* 1481346 */     GIR_EraseRootFromParent_Done,
     /* 1481347 */   // Label 20722: @1481347
     /* 1481347 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1481444), // Rule ID 24204 //
     /* 1481352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481402 */     // MIs[1] Operand 1
     /* 1481402 */     // No operand predicates
     /* 1481402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481406 */     // MIs[0] policy
     /* 1481406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481418 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481443 */     // GIR_Coverage, 24204,
     /* 1481443 */     GIR_EraseRootFromParent_Done,
     /* 1481444 */   // Label 20723: @1481444
     /* 1481444 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1481541), // Rule ID 24205 //
     /* 1481449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481499 */     // MIs[1] Operand 1
     /* 1481499 */     // No operand predicates
     /* 1481499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481503 */     // MIs[0] policy
     /* 1481503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481515 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481540 */     // GIR_Coverage, 24205,
     /* 1481540 */     GIR_EraseRootFromParent_Done,
     /* 1481541 */   // Label 20724: @1481541
     /* 1481541 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1481638), // Rule ID 24208 //
     /* 1481546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481596 */     // MIs[1] Operand 1
     /* 1481596 */     // No operand predicates
     /* 1481596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481600 */     // MIs[0] policy
     /* 1481600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481612 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481637 */     // GIR_Coverage, 24208,
     /* 1481637 */     GIR_EraseRootFromParent_Done,
     /* 1481638 */   // Label 20725: @1481638
     /* 1481638 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1481735), // Rule ID 24209 //
     /* 1481643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481693 */     // MIs[1] Operand 1
     /* 1481693 */     // No operand predicates
     /* 1481693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481697 */     // MIs[0] policy
     /* 1481697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481709 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481734 */     // GIR_Coverage, 24209,
     /* 1481734 */     GIR_EraseRootFromParent_Done,
     /* 1481735 */   // Label 20726: @1481735
     /* 1481735 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1481832), // Rule ID 24212 //
     /* 1481740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481790 */     // MIs[1] Operand 1
     /* 1481790 */     // No operand predicates
     /* 1481790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481794 */     // MIs[0] policy
     /* 1481794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481806 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481831 */     // GIR_Coverage, 24212,
     /* 1481831 */     GIR_EraseRootFromParent_Done,
     /* 1481832 */   // Label 20727: @1481832
     /* 1481832 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1481929), // Rule ID 24213 //
     /* 1481837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481887 */     // MIs[1] Operand 1
     /* 1481887 */     // No operand predicates
     /* 1481887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481891 */     // MIs[0] policy
     /* 1481891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481903 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481928 */     // GIR_Coverage, 24213,
     /* 1481928 */     GIR_EraseRootFromParent_Done,
     /* 1481929 */   // Label 20728: @1481929
     /* 1481929 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1482026), // Rule ID 24216 //
     /* 1481934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481984 */     // MIs[1] Operand 1
     /* 1481984 */     // No operand predicates
     /* 1481984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481988 */     // MIs[0] policy
     /* 1481988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482025 */     // GIR_Coverage, 24216,
     /* 1482025 */     GIR_EraseRootFromParent_Done,
     /* 1482026 */   // Label 20729: @1482026
     /* 1482026 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1482123), // Rule ID 24217 //
     /* 1482031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1482042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1482045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1482048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482081 */     // MIs[1] Operand 1
     /* 1482081 */     // No operand predicates
     /* 1482081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482085 */     // MIs[0] policy
     /* 1482085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482097 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482122 */     // GIR_Coverage, 24217,
     /* 1482122 */     GIR_EraseRootFromParent_Done,
     /* 1482123 */   // Label 20730: @1482123
     /* 1482123 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1482220), // Rule ID 24220 //
     /* 1482128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482178 */     // MIs[1] Operand 1
     /* 1482178 */     // No operand predicates
     /* 1482178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482182 */     // MIs[0] policy
     /* 1482182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482194 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482219 */     // GIR_Coverage, 24220,
     /* 1482219 */     GIR_EraseRootFromParent_Done,
     /* 1482220 */   // Label 20731: @1482220
     /* 1482220 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1482317), // Rule ID 24221 //
     /* 1482225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482275 */     // MIs[1] Operand 1
     /* 1482275 */     // No operand predicates
     /* 1482275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482279 */     // MIs[0] policy
     /* 1482279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482291 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482316 */     // GIR_Coverage, 24221,
     /* 1482316 */     GIR_EraseRootFromParent_Done,
     /* 1482317 */   // Label 20732: @1482317
     /* 1482317 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1482414), // Rule ID 24224 //
     /* 1482322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1482325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482372 */     // MIs[1] Operand 1
     /* 1482372 */     // No operand predicates
     /* 1482372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482376 */     // MIs[0] policy
     /* 1482376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482388 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482413 */     // GIR_Coverage, 24224,
     /* 1482413 */     GIR_EraseRootFromParent_Done,
     /* 1482414 */   // Label 20733: @1482414
     /* 1482414 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1482511), // Rule ID 24225 //
     /* 1482419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1482422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482469 */     // MIs[1] Operand 1
     /* 1482469 */     // No operand predicates
     /* 1482469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482473 */     // MIs[0] policy
     /* 1482473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482485 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482510 */     // GIR_Coverage, 24225,
     /* 1482510 */     GIR_EraseRootFromParent_Done,
     /* 1482511 */   // Label 20734: @1482511
     /* 1482511 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1482608), // Rule ID 24228 //
     /* 1482516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482566 */     // MIs[1] Operand 1
     /* 1482566 */     // No operand predicates
     /* 1482566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482570 */     // MIs[0] policy
     /* 1482570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482582 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482607 */     // GIR_Coverage, 24228,
     /* 1482607 */     GIR_EraseRootFromParent_Done,
     /* 1482608 */   // Label 20735: @1482608
     /* 1482608 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1482705), // Rule ID 24229 //
     /* 1482613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482663 */     // MIs[1] Operand 1
     /* 1482663 */     // No operand predicates
     /* 1482663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482667 */     // MIs[0] policy
     /* 1482667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482679 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482704 */     // GIR_Coverage, 24229,
     /* 1482704 */     GIR_EraseRootFromParent_Done,
     /* 1482705 */   // Label 20736: @1482705
     /* 1482705 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1482802), // Rule ID 24232 //
     /* 1482710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482760 */     // MIs[1] Operand 1
     /* 1482760 */     // No operand predicates
     /* 1482760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482764 */     // MIs[0] policy
     /* 1482764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482776 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482801 */     // GIR_Coverage, 24232,
     /* 1482801 */     GIR_EraseRootFromParent_Done,
     /* 1482802 */   // Label 20737: @1482802
     /* 1482802 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1482899), // Rule ID 24233 //
     /* 1482807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482857 */     // MIs[1] Operand 1
     /* 1482857 */     // No operand predicates
     /* 1482857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482861 */     // MIs[0] policy
     /* 1482861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482873 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482898 */     // GIR_Coverage, 24233,
     /* 1482898 */     GIR_EraseRootFromParent_Done,
     /* 1482899 */   // Label 20738: @1482899
     /* 1482899 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1482996), // Rule ID 24236 //
     /* 1482904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482954 */     // MIs[1] Operand 1
     /* 1482954 */     // No operand predicates
     /* 1482954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482958 */     // MIs[0] policy
     /* 1482958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482970 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482995 */     // GIR_Coverage, 24236,
     /* 1482995 */     GIR_EraseRootFromParent_Done,
     /* 1482996 */   // Label 20739: @1482996
     /* 1482996 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1483093), // Rule ID 24237 //
     /* 1483001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483051 */     // MIs[1] Operand 1
     /* 1483051 */     // No operand predicates
     /* 1483051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483055 */     // MIs[0] policy
     /* 1483055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483067 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483092 */     // GIR_Coverage, 24237,
     /* 1483092 */     GIR_EraseRootFromParent_Done,
     /* 1483093 */   // Label 20740: @1483093
     /* 1483093 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1483190), // Rule ID 24240 //
     /* 1483098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483148 */     // MIs[1] Operand 1
     /* 1483148 */     // No operand predicates
     /* 1483148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483152 */     // MIs[0] policy
     /* 1483152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483189 */     // GIR_Coverage, 24240,
     /* 1483189 */     GIR_EraseRootFromParent_Done,
     /* 1483190 */   // Label 20741: @1483190
     /* 1483190 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1483287), // Rule ID 24241 //
     /* 1483195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483245 */     // MIs[1] Operand 1
     /* 1483245 */     // No operand predicates
     /* 1483245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483249 */     // MIs[0] policy
     /* 1483249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483261 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483286 */     // GIR_Coverage, 24241,
     /* 1483286 */     GIR_EraseRootFromParent_Done,
     /* 1483287 */   // Label 20742: @1483287
     /* 1483287 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1483384), // Rule ID 24244 //
     /* 1483292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483342 */     // MIs[1] Operand 1
     /* 1483342 */     // No operand predicates
     /* 1483342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483346 */     // MIs[0] policy
     /* 1483346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483358 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483383 */     // GIR_Coverage, 24244,
     /* 1483383 */     GIR_EraseRootFromParent_Done,
     /* 1483384 */   // Label 20743: @1483384
     /* 1483384 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1483481), // Rule ID 24245 //
     /* 1483389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483439 */     // MIs[1] Operand 1
     /* 1483439 */     // No operand predicates
     /* 1483439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483443 */     // MIs[0] policy
     /* 1483443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483455 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483480 */     // GIR_Coverage, 24245,
     /* 1483480 */     GIR_EraseRootFromParent_Done,
     /* 1483481 */   // Label 20744: @1483481
     /* 1483481 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1483578), // Rule ID 24248 //
     /* 1483486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483536 */     // MIs[1] Operand 1
     /* 1483536 */     // No operand predicates
     /* 1483536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483540 */     // MIs[0] policy
     /* 1483540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483577 */     // GIR_Coverage, 24248,
     /* 1483577 */     GIR_EraseRootFromParent_Done,
     /* 1483578 */   // Label 20745: @1483578
     /* 1483578 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1483675), // Rule ID 24249 //
     /* 1483583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483633 */     // MIs[1] Operand 1
     /* 1483633 */     // No operand predicates
     /* 1483633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483637 */     // MIs[0] policy
     /* 1483637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483649 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483674 */     // GIR_Coverage, 24249,
     /* 1483674 */     GIR_EraseRootFromParent_Done,
     /* 1483675 */   // Label 20746: @1483675
     /* 1483675 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1483772), // Rule ID 24252 //
     /* 1483680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483730 */     // MIs[1] Operand 1
     /* 1483730 */     // No operand predicates
     /* 1483730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483734 */     // MIs[0] policy
     /* 1483734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483771 */     // GIR_Coverage, 24252,
     /* 1483771 */     GIR_EraseRootFromParent_Done,
     /* 1483772 */   // Label 20747: @1483772
     /* 1483772 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1483869), // Rule ID 24253 //
     /* 1483777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483827 */     // MIs[1] Operand 1
     /* 1483827 */     // No operand predicates
     /* 1483827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483831 */     // MIs[0] policy
     /* 1483831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483843 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483868 */     // GIR_Coverage, 24253,
     /* 1483868 */     GIR_EraseRootFromParent_Done,
     /* 1483869 */   // Label 20748: @1483869
     /* 1483869 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1483966), // Rule ID 24256 //
     /* 1483874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483924 */     // MIs[1] Operand 1
     /* 1483924 */     // No operand predicates
     /* 1483924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483928 */     // MIs[0] policy
     /* 1483928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483965 */     // GIR_Coverage, 24256,
     /* 1483965 */     GIR_EraseRootFromParent_Done,
     /* 1483966 */   // Label 20749: @1483966
     /* 1483966 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1484063), // Rule ID 24257 //
     /* 1483971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484021 */     // MIs[1] Operand 1
     /* 1484021 */     // No operand predicates
     /* 1484021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484025 */     // MIs[0] policy
     /* 1484025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484037 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1484040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484062 */     // GIR_Coverage, 24257,
     /* 1484062 */     GIR_EraseRootFromParent_Done,
     /* 1484063 */   // Label 20750: @1484063
     /* 1484063 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1484160), // Rule ID 24260 //
     /* 1484068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484118 */     // MIs[1] Operand 1
     /* 1484118 */     // No operand predicates
     /* 1484118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484122 */     // MIs[0] policy
     /* 1484122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484134 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1484137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484159 */     // GIR_Coverage, 24260,
     /* 1484159 */     GIR_EraseRootFromParent_Done,
     /* 1484160 */   // Label 20751: @1484160
     /* 1484160 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1484257), // Rule ID 24261 //
     /* 1484165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1484173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484215 */     // MIs[1] Operand 1
     /* 1484215 */     // No operand predicates
     /* 1484215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484219 */     // MIs[0] policy
     /* 1484219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484231 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1484234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484256 */     // GIR_Coverage, 24261,
     /* 1484256 */     GIR_EraseRootFromParent_Done,
     /* 1484257 */   // Label 20752: @1484257
     /* 1484257 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1484354), // Rule ID 24324 //
     /* 1484262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484312 */     // MIs[1] Operand 1
     /* 1484312 */     // No operand predicates
     /* 1484312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484316 */     // MIs[0] policy
     /* 1484316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484328 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1484331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484353 */     // GIR_Coverage, 24324,
     /* 1484353 */     GIR_EraseRootFromParent_Done,
     /* 1484354 */   // Label 20753: @1484354
     /* 1484354 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1484451), // Rule ID 24325 //
     /* 1484359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1484370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1484373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1484376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484409 */     // MIs[1] Operand 1
     /* 1484409 */     // No operand predicates
     /* 1484409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484413 */     // MIs[0] policy
     /* 1484413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484425 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1484428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484450 */     // GIR_Coverage, 24325,
     /* 1484450 */     GIR_EraseRootFromParent_Done,
     /* 1484451 */   // Label 20754: @1484451
     /* 1484451 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1484548), // Rule ID 24328 //
     /* 1484456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484506 */     // MIs[1] Operand 1
     /* 1484506 */     // No operand predicates
     /* 1484506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484510 */     // MIs[0] policy
     /* 1484510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484522 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484547 */     // GIR_Coverage, 24328,
     /* 1484547 */     GIR_EraseRootFromParent_Done,
     /* 1484548 */   // Label 20755: @1484548
     /* 1484548 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1484645), // Rule ID 24329 //
     /* 1484553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484603 */     // MIs[1] Operand 1
     /* 1484603 */     // No operand predicates
     /* 1484603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484607 */     // MIs[0] policy
     /* 1484607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484619 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484644 */     // GIR_Coverage, 24329,
     /* 1484644 */     GIR_EraseRootFromParent_Done,
     /* 1484645 */   // Label 20756: @1484645
     /* 1484645 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1484742), // Rule ID 24332 //
     /* 1484650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484700 */     // MIs[1] Operand 1
     /* 1484700 */     // No operand predicates
     /* 1484700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484704 */     // MIs[0] policy
     /* 1484704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484716 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484741 */     // GIR_Coverage, 24332,
     /* 1484741 */     GIR_EraseRootFromParent_Done,
     /* 1484742 */   // Label 20757: @1484742
     /* 1484742 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1484839), // Rule ID 24333 //
     /* 1484747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484797 */     // MIs[1] Operand 1
     /* 1484797 */     // No operand predicates
     /* 1484797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484801 */     // MIs[0] policy
     /* 1484801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484813 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484838 */     // GIR_Coverage, 24333,
     /* 1484838 */     GIR_EraseRootFromParent_Done,
     /* 1484839 */   // Label 20758: @1484839
     /* 1484839 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1484936), // Rule ID 24336 //
     /* 1484844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484894 */     // MIs[1] Operand 1
     /* 1484894 */     // No operand predicates
     /* 1484894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484898 */     // MIs[0] policy
     /* 1484898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484910 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484935 */     // GIR_Coverage, 24336,
     /* 1484935 */     GIR_EraseRootFromParent_Done,
     /* 1484936 */   // Label 20759: @1484936
     /* 1484936 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1485033), // Rule ID 24337 //
     /* 1484941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484991 */     // MIs[1] Operand 1
     /* 1484991 */     // No operand predicates
     /* 1484991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484995 */     // MIs[0] policy
     /* 1484995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485007 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485032 */     // GIR_Coverage, 24337,
     /* 1485032 */     GIR_EraseRootFromParent_Done,
     /* 1485033 */   // Label 20760: @1485033
     /* 1485033 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1485130), // Rule ID 24340 //
     /* 1485038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485088 */     // MIs[1] Operand 1
     /* 1485088 */     // No operand predicates
     /* 1485088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485092 */     // MIs[0] policy
     /* 1485092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485129 */     // GIR_Coverage, 24340,
     /* 1485129 */     GIR_EraseRootFromParent_Done,
     /* 1485130 */   // Label 20761: @1485130
     /* 1485130 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1485227), // Rule ID 24341 //
     /* 1485135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1485146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1485149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1485152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485185 */     // MIs[1] Operand 1
     /* 1485185 */     // No operand predicates
     /* 1485185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485189 */     // MIs[0] policy
     /* 1485189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485201 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485226 */     // GIR_Coverage, 24341,
     /* 1485226 */     GIR_EraseRootFromParent_Done,
     /* 1485227 */   // Label 20762: @1485227
     /* 1485227 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1485324), // Rule ID 24344 //
     /* 1485232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1485235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485282 */     // MIs[1] Operand 1
     /* 1485282 */     // No operand predicates
     /* 1485282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485286 */     // MIs[0] policy
     /* 1485286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485323 */     // GIR_Coverage, 24344,
     /* 1485323 */     GIR_EraseRootFromParent_Done,
     /* 1485324 */   // Label 20763: @1485324
     /* 1485324 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1485421), // Rule ID 24345 //
     /* 1485329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1485332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1485340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1485343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1485346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485379 */     // MIs[1] Operand 1
     /* 1485379 */     // No operand predicates
     /* 1485379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485383 */     // MIs[0] policy
     /* 1485383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485395 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1485398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485420 */     // GIR_Coverage, 24345,
     /* 1485420 */     GIR_EraseRootFromParent_Done,
     /* 1485421 */   // Label 20764: @1485421
     /* 1485421 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1485518), // Rule ID 24348 //
     /* 1485426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485476 */     // MIs[1] Operand 1
     /* 1485476 */     // No operand predicates
     /* 1485476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485480 */     // MIs[0] policy
     /* 1485480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485517 */     // GIR_Coverage, 24348,
     /* 1485517 */     GIR_EraseRootFromParent_Done,
     /* 1485518 */   // Label 20765: @1485518
     /* 1485518 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1485615), // Rule ID 24349 //
     /* 1485523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485573 */     // MIs[1] Operand 1
     /* 1485573 */     // No operand predicates
     /* 1485573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485577 */     // MIs[0] policy
     /* 1485577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485589 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485614 */     // GIR_Coverage, 24349,
     /* 1485614 */     GIR_EraseRootFromParent_Done,
     /* 1485615 */   // Label 20766: @1485615
     /* 1485615 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1485712), // Rule ID 24352 //
     /* 1485620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485670 */     // MIs[1] Operand 1
     /* 1485670 */     // No operand predicates
     /* 1485670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485674 */     // MIs[0] policy
     /* 1485674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485686 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485711 */     // GIR_Coverage, 24352,
     /* 1485711 */     GIR_EraseRootFromParent_Done,
     /* 1485712 */   // Label 20767: @1485712
     /* 1485712 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1485809), // Rule ID 24353 //
     /* 1485717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485767 */     // MIs[1] Operand 1
     /* 1485767 */     // No operand predicates
     /* 1485767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485771 */     // MIs[0] policy
     /* 1485771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485783 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485808 */     // GIR_Coverage, 24353,
     /* 1485808 */     GIR_EraseRootFromParent_Done,
     /* 1485809 */   // Label 20768: @1485809
     /* 1485809 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1485906), // Rule ID 24356 //
     /* 1485814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485864 */     // MIs[1] Operand 1
     /* 1485864 */     // No operand predicates
     /* 1485864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485868 */     // MIs[0] policy
     /* 1485868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485880 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485905 */     // GIR_Coverage, 24356,
     /* 1485905 */     GIR_EraseRootFromParent_Done,
     /* 1485906 */   // Label 20769: @1485906
     /* 1485906 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1486003), // Rule ID 24357 //
     /* 1485911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485961 */     // MIs[1] Operand 1
     /* 1485961 */     // No operand predicates
     /* 1485961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485965 */     // MIs[0] policy
     /* 1485965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485977 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486002 */     // GIR_Coverage, 24357,
     /* 1486002 */     GIR_EraseRootFromParent_Done,
     /* 1486003 */   // Label 20770: @1486003
     /* 1486003 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1486100), // Rule ID 24360 //
     /* 1486008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486058 */     // MIs[1] Operand 1
     /* 1486058 */     // No operand predicates
     /* 1486058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486062 */     // MIs[0] policy
     /* 1486062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486074 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486099 */     // GIR_Coverage, 24360,
     /* 1486099 */     GIR_EraseRootFromParent_Done,
     /* 1486100 */   // Label 20771: @1486100
     /* 1486100 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1486197), // Rule ID 24361 //
     /* 1486105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1486116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1486119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1486122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486155 */     // MIs[1] Operand 1
     /* 1486155 */     // No operand predicates
     /* 1486155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486159 */     // MIs[0] policy
     /* 1486159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486171 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486196 */     // GIR_Coverage, 24361,
     /* 1486196 */     GIR_EraseRootFromParent_Done,
     /* 1486197 */   // Label 20772: @1486197
     /* 1486197 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1486294), // Rule ID 24364 //
     /* 1486202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486252 */     // MIs[1] Operand 1
     /* 1486252 */     // No operand predicates
     /* 1486252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486256 */     // MIs[0] policy
     /* 1486256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486268 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486293 */     // GIR_Coverage, 24364,
     /* 1486293 */     GIR_EraseRootFromParent_Done,
     /* 1486294 */   // Label 20773: @1486294
     /* 1486294 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1486391), // Rule ID 24365 //
     /* 1486299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1486310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1486313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1486316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486349 */     // MIs[1] Operand 1
     /* 1486349 */     // No operand predicates
     /* 1486349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486353 */     // MIs[0] policy
     /* 1486353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486365 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486390 */     // GIR_Coverage, 24365,
     /* 1486390 */     GIR_EraseRootFromParent_Done,
     /* 1486391 */   // Label 20774: @1486391
     /* 1486391 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1486488), // Rule ID 24368 //
     /* 1486396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486446 */     // MIs[1] Operand 1
     /* 1486446 */     // No operand predicates
     /* 1486446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486450 */     // MIs[0] policy
     /* 1486450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486462 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486487 */     // GIR_Coverage, 24368,
     /* 1486487 */     GIR_EraseRootFromParent_Done,
     /* 1486488 */   // Label 20775: @1486488
     /* 1486488 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1486585), // Rule ID 24369 //
     /* 1486493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486543 */     // MIs[1] Operand 1
     /* 1486543 */     // No operand predicates
     /* 1486543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486547 */     // MIs[0] policy
     /* 1486547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486559 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486584 */     // GIR_Coverage, 24369,
     /* 1486584 */     GIR_EraseRootFromParent_Done,
     /* 1486585 */   // Label 20776: @1486585
     /* 1486585 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1486682), // Rule ID 24372 //
     /* 1486590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486640 */     // MIs[1] Operand 1
     /* 1486640 */     // No operand predicates
     /* 1486640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486644 */     // MIs[0] policy
     /* 1486644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486656 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486681 */     // GIR_Coverage, 24372,
     /* 1486681 */     GIR_EraseRootFromParent_Done,
     /* 1486682 */   // Label 20777: @1486682
     /* 1486682 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1486779), // Rule ID 24373 //
     /* 1486687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486737 */     // MIs[1] Operand 1
     /* 1486737 */     // No operand predicates
     /* 1486737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486741 */     // MIs[0] policy
     /* 1486741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486753 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486778 */     // GIR_Coverage, 24373,
     /* 1486778 */     GIR_EraseRootFromParent_Done,
     /* 1486779 */   // Label 20778: @1486779
     /* 1486779 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1486876), // Rule ID 24376 //
     /* 1486784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486834 */     // MIs[1] Operand 1
     /* 1486834 */     // No operand predicates
     /* 1486834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486838 */     // MIs[0] policy
     /* 1486838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486850 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486875 */     // GIR_Coverage, 24376,
     /* 1486875 */     GIR_EraseRootFromParent_Done,
     /* 1486876 */   // Label 20779: @1486876
     /* 1486876 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1486973), // Rule ID 24377 //
     /* 1486881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486931 */     // MIs[1] Operand 1
     /* 1486931 */     // No operand predicates
     /* 1486931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486935 */     // MIs[0] policy
     /* 1486935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486947 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486972 */     // GIR_Coverage, 24377,
     /* 1486972 */     GIR_EraseRootFromParent_Done,
     /* 1486973 */   // Label 20780: @1486973
     /* 1486973 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1487070), // Rule ID 24380 //
     /* 1486978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487028 */     // MIs[1] Operand 1
     /* 1487028 */     // No operand predicates
     /* 1487028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487032 */     // MIs[0] policy
     /* 1487032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1487047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487069 */     // GIR_Coverage, 24380,
     /* 1487069 */     GIR_EraseRootFromParent_Done,
     /* 1487070 */   // Label 20781: @1487070
     /* 1487070 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1487167), // Rule ID 24381 //
     /* 1487075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1487078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1487083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1487086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1487089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1487092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487125 */     // MIs[1] Operand 1
     /* 1487125 */     // No operand predicates
     /* 1487125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487129 */     // MIs[0] policy
     /* 1487129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487141 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1487144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1487148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1487163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487166 */     // GIR_Coverage, 24381,
     /* 1487166 */     GIR_EraseRootFromParent_Done,
     /* 1487167 */   // Label 20782: @1487167
     /* 1487167 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1487264), // Rule ID 24680 //
     /* 1487172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1487183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1487186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487222 */     // MIs[1] Operand 1
     /* 1487222 */     // No operand predicates
     /* 1487222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487226 */     // MIs[0] policy
     /* 1487226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487238 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1487241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487263 */     // GIR_Coverage, 24680,
     /* 1487263 */     GIR_EraseRootFromParent_Done,
     /* 1487264 */   // Label 20783: @1487264
     /* 1487264 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1487361), // Rule ID 24681 //
     /* 1487269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1487280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1487283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487319 */     // MIs[1] Operand 1
     /* 1487319 */     // No operand predicates
     /* 1487319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487323 */     // MIs[0] policy
     /* 1487323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487335 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1487338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487360 */     // GIR_Coverage, 24681,
     /* 1487360 */     GIR_EraseRootFromParent_Done,
     /* 1487361 */   // Label 20784: @1487361
     /* 1487361 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1487458), // Rule ID 24684 //
     /* 1487366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487416 */     // MIs[1] Operand 1
     /* 1487416 */     // No operand predicates
     /* 1487416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487420 */     // MIs[0] policy
     /* 1487420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487432 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487457 */     // GIR_Coverage, 24684,
     /* 1487457 */     GIR_EraseRootFromParent_Done,
     /* 1487458 */   // Label 20785: @1487458
     /* 1487458 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1487555), // Rule ID 24685 //
     /* 1487463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487513 */     // MIs[1] Operand 1
     /* 1487513 */     // No operand predicates
     /* 1487513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487517 */     // MIs[0] policy
     /* 1487517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487529 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487554 */     // GIR_Coverage, 24685,
     /* 1487554 */     GIR_EraseRootFromParent_Done,
     /* 1487555 */   // Label 20786: @1487555
     /* 1487555 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1487652), // Rule ID 24688 //
     /* 1487560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487610 */     // MIs[1] Operand 1
     /* 1487610 */     // No operand predicates
     /* 1487610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487614 */     // MIs[0] policy
     /* 1487614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487651 */     // GIR_Coverage, 24688,
     /* 1487651 */     GIR_EraseRootFromParent_Done,
     /* 1487652 */   // Label 20787: @1487652
     /* 1487652 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1487749), // Rule ID 24689 //
     /* 1487657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487707 */     // MIs[1] Operand 1
     /* 1487707 */     // No operand predicates
     /* 1487707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487711 */     // MIs[0] policy
     /* 1487711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487723 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487748 */     // GIR_Coverage, 24689,
     /* 1487748 */     GIR_EraseRootFromParent_Done,
     /* 1487749 */   // Label 20788: @1487749
     /* 1487749 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1487846), // Rule ID 24692 //
     /* 1487754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487804 */     // MIs[1] Operand 1
     /* 1487804 */     // No operand predicates
     /* 1487804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487808 */     // MIs[0] policy
     /* 1487808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487845 */     // GIR_Coverage, 24692,
     /* 1487845 */     GIR_EraseRootFromParent_Done,
     /* 1487846 */   // Label 20789: @1487846
     /* 1487846 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1487943), // Rule ID 24693 //
     /* 1487851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487901 */     // MIs[1] Operand 1
     /* 1487901 */     // No operand predicates
     /* 1487901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487905 */     // MIs[0] policy
     /* 1487905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487917 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487942 */     // GIR_Coverage, 24693,
     /* 1487942 */     GIR_EraseRootFromParent_Done,
     /* 1487943 */   // Label 20790: @1487943
     /* 1487943 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1488040), // Rule ID 24696 //
     /* 1487948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487998 */     // MIs[1] Operand 1
     /* 1487998 */     // No operand predicates
     /* 1487998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488002 */     // MIs[0] policy
     /* 1488002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488039 */     // GIR_Coverage, 24696,
     /* 1488039 */     GIR_EraseRootFromParent_Done,
     /* 1488040 */   // Label 20791: @1488040
     /* 1488040 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1488137), // Rule ID 24697 //
     /* 1488045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1488056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1488059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1488062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488095 */     // MIs[1] Operand 1
     /* 1488095 */     // No operand predicates
     /* 1488095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488099 */     // MIs[0] policy
     /* 1488099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488136 */     // GIR_Coverage, 24697,
     /* 1488136 */     GIR_EraseRootFromParent_Done,
     /* 1488137 */   // Label 20792: @1488137
     /* 1488137 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1488234), // Rule ID 24700 //
     /* 1488142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488192 */     // MIs[1] Operand 1
     /* 1488192 */     // No operand predicates
     /* 1488192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488196 */     // MIs[0] policy
     /* 1488196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488233 */     // GIR_Coverage, 24700,
     /* 1488233 */     GIR_EraseRootFromParent_Done,
     /* 1488234 */   // Label 20793: @1488234
     /* 1488234 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1488331), // Rule ID 24701 //
     /* 1488239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488289 */     // MIs[1] Operand 1
     /* 1488289 */     // No operand predicates
     /* 1488289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488293 */     // MIs[0] policy
     /* 1488293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488305 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488330 */     // GIR_Coverage, 24701,
     /* 1488330 */     GIR_EraseRootFromParent_Done,
     /* 1488331 */   // Label 20794: @1488331
     /* 1488331 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1488428), // Rule ID 24704 //
     /* 1488336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1488347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1488350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1488353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488386 */     // MIs[1] Operand 1
     /* 1488386 */     // No operand predicates
     /* 1488386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488390 */     // MIs[0] policy
     /* 1488390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488427 */     // GIR_Coverage, 24704,
     /* 1488427 */     GIR_EraseRootFromParent_Done,
     /* 1488428 */   // Label 20795: @1488428
     /* 1488428 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1488525), // Rule ID 24705 //
     /* 1488433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1488444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1488447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1488450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488483 */     // MIs[1] Operand 1
     /* 1488483 */     // No operand predicates
     /* 1488483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488487 */     // MIs[0] policy
     /* 1488487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488499 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488524 */     // GIR_Coverage, 24705,
     /* 1488524 */     GIR_EraseRootFromParent_Done,
     /* 1488525 */   // Label 20796: @1488525
     /* 1488525 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1488622), // Rule ID 24708 //
     /* 1488530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488580 */     // MIs[1] Operand 1
     /* 1488580 */     // No operand predicates
     /* 1488580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488584 */     // MIs[0] policy
     /* 1488584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488621 */     // GIR_Coverage, 24708,
     /* 1488621 */     GIR_EraseRootFromParent_Done,
     /* 1488622 */   // Label 20797: @1488622
     /* 1488622 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1488719), // Rule ID 24709 //
     /* 1488627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488677 */     // MIs[1] Operand 1
     /* 1488677 */     // No operand predicates
     /* 1488677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488681 */     // MIs[0] policy
     /* 1488681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488718 */     // GIR_Coverage, 24709,
     /* 1488718 */     GIR_EraseRootFromParent_Done,
     /* 1488719 */   // Label 20798: @1488719
     /* 1488719 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1488816), // Rule ID 24712 //
     /* 1488724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488774 */     // MIs[1] Operand 1
     /* 1488774 */     // No operand predicates
     /* 1488774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488778 */     // MIs[0] policy
     /* 1488778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488815 */     // GIR_Coverage, 24712,
     /* 1488815 */     GIR_EraseRootFromParent_Done,
     /* 1488816 */   // Label 20799: @1488816
     /* 1488816 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1488913), // Rule ID 24713 //
     /* 1488821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488871 */     // MIs[1] Operand 1
     /* 1488871 */     // No operand predicates
     /* 1488871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488875 */     // MIs[0] policy
     /* 1488875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488887 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488912 */     // GIR_Coverage, 24713,
     /* 1488912 */     GIR_EraseRootFromParent_Done,
     /* 1488913 */   // Label 20800: @1488913
     /* 1488913 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1489010), // Rule ID 24716 //
     /* 1488918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488968 */     // MIs[1] Operand 1
     /* 1488968 */     // No operand predicates
     /* 1488968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488972 */     // MIs[0] policy
     /* 1488972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489009 */     // GIR_Coverage, 24716,
     /* 1489009 */     GIR_EraseRootFromParent_Done,
     /* 1489010 */   // Label 20801: @1489010
     /* 1489010 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1489107), // Rule ID 24717 //
     /* 1489015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1489018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1489032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489065 */     // MIs[1] Operand 1
     /* 1489065 */     // No operand predicates
     /* 1489065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489069 */     // MIs[0] policy
     /* 1489069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489081 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489106 */     // GIR_Coverage, 24717,
     /* 1489106 */     GIR_EraseRootFromParent_Done,
     /* 1489107 */   // Label 20802: @1489107
     /* 1489107 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1489204), // Rule ID 24720 //
     /* 1489112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1489123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1489126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1489129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489162 */     // MIs[1] Operand 1
     /* 1489162 */     // No operand predicates
     /* 1489162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489166 */     // MIs[0] policy
     /* 1489166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489203 */     // GIR_Coverage, 24720,
     /* 1489203 */     GIR_EraseRootFromParent_Done,
     /* 1489204 */   // Label 20803: @1489204
     /* 1489204 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1489301), // Rule ID 24721 //
     /* 1489209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1489220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1489223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1489226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489259 */     // MIs[1] Operand 1
     /* 1489259 */     // No operand predicates
     /* 1489259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489263 */     // MIs[0] policy
     /* 1489263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489300 */     // GIR_Coverage, 24721,
     /* 1489300 */     GIR_EraseRootFromParent_Done,
     /* 1489301 */   // Label 20804: @1489301
     /* 1489301 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1489398), // Rule ID 24724 //
     /* 1489306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1489317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1489320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1489323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489356 */     // MIs[1] Operand 1
     /* 1489356 */     // No operand predicates
     /* 1489356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489360 */     // MIs[0] policy
     /* 1489360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489397 */     // GIR_Coverage, 24724,
     /* 1489397 */     GIR_EraseRootFromParent_Done,
     /* 1489398 */   // Label 20805: @1489398
     /* 1489398 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1489495), // Rule ID 24725 //
     /* 1489403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1489414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1489417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1489420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489453 */     // MIs[1] Operand 1
     /* 1489453 */     // No operand predicates
     /* 1489453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489457 */     // MIs[0] policy
     /* 1489457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489494 */     // GIR_Coverage, 24725,
     /* 1489494 */     GIR_EraseRootFromParent_Done,
     /* 1489495 */   // Label 20806: @1489495
     /* 1489495 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1489592), // Rule ID 24728 //
     /* 1489500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489550 */     // MIs[1] Operand 1
     /* 1489550 */     // No operand predicates
     /* 1489550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489554 */     // MIs[0] policy
     /* 1489554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489566 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489591 */     // GIR_Coverage, 24728,
     /* 1489591 */     GIR_EraseRootFromParent_Done,
     /* 1489592 */   // Label 20807: @1489592
     /* 1489592 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1489689), // Rule ID 24729 //
     /* 1489597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489647 */     // MIs[1] Operand 1
     /* 1489647 */     // No operand predicates
     /* 1489647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489651 */     // MIs[0] policy
     /* 1489651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489663 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489688 */     // GIR_Coverage, 24729,
     /* 1489688 */     GIR_EraseRootFromParent_Done,
     /* 1489689 */   // Label 20808: @1489689
     /* 1489689 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1489786), // Rule ID 24732 //
     /* 1489694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489744 */     // MIs[1] Operand 1
     /* 1489744 */     // No operand predicates
     /* 1489744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489748 */     // MIs[0] policy
     /* 1489748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489785 */     // GIR_Coverage, 24732,
     /* 1489785 */     GIR_EraseRootFromParent_Done,
     /* 1489786 */   // Label 20809: @1489786
     /* 1489786 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1489883), // Rule ID 24733 //
     /* 1489791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489841 */     // MIs[1] Operand 1
     /* 1489841 */     // No operand predicates
     /* 1489841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489845 */     // MIs[0] policy
     /* 1489845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489882 */     // GIR_Coverage, 24733,
     /* 1489882 */     GIR_EraseRootFromParent_Done,
     /* 1489883 */   // Label 20810: @1489883
     /* 1489883 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1489980), // Rule ID 24736 //
     /* 1489888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489938 */     // MIs[1] Operand 1
     /* 1489938 */     // No operand predicates
     /* 1489938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489942 */     // MIs[0] policy
     /* 1489942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489979 */     // GIR_Coverage, 24736,
     /* 1489979 */     GIR_EraseRootFromParent_Done,
     /* 1489980 */   // Label 20811: @1489980
     /* 1489980 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1490077), // Rule ID 24737 //
     /* 1489985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1490002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490035 */     // MIs[1] Operand 1
     /* 1490035 */     // No operand predicates
     /* 1490035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490039 */     // MIs[0] policy
     /* 1490039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490051 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490076 */     // GIR_Coverage, 24737,
     /* 1490076 */     GIR_EraseRootFromParent_Done,
     /* 1490077 */   // Label 20812: @1490077
     /* 1490077 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1490174), // Rule ID 24740 //
     /* 1490082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1490093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1490096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1490099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1490105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490132 */     // MIs[1] Operand 1
     /* 1490132 */     // No operand predicates
     /* 1490132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490136 */     // MIs[0] policy
     /* 1490136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490173 */     // GIR_Coverage, 24740,
     /* 1490173 */     GIR_EraseRootFromParent_Done,
     /* 1490174 */   // Label 20813: @1490174
     /* 1490174 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1490271), // Rule ID 24741 //
     /* 1490179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1490190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1490193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1490196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1490202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490229 */     // MIs[1] Operand 1
     /* 1490229 */     // No operand predicates
     /* 1490229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490233 */     // MIs[0] policy
     /* 1490233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490270 */     // GIR_Coverage, 24741,
     /* 1490270 */     GIR_EraseRootFromParent_Done,
     /* 1490271 */   // Label 20814: @1490271
     /* 1490271 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1490368), // Rule ID 24744 //
     /* 1490276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1490287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1490290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1490293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490326 */     // MIs[1] Operand 1
     /* 1490326 */     // No operand predicates
     /* 1490326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490330 */     // MIs[0] policy
     /* 1490330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490367 */     // GIR_Coverage, 24744,
     /* 1490367 */     GIR_EraseRootFromParent_Done,
     /* 1490368 */   // Label 20815: @1490368
     /* 1490368 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1490465), // Rule ID 24745 //
     /* 1490373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1490384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1490387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1490390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490423 */     // MIs[1] Operand 1
     /* 1490423 */     // No operand predicates
     /* 1490423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490427 */     // MIs[0] policy
     /* 1490427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490464 */     // GIR_Coverage, 24745,
     /* 1490464 */     GIR_EraseRootFromParent_Done,
     /* 1490465 */   // Label 20816: @1490465
     /* 1490465 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1490562), // Rule ID 24748 //
     /* 1490470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490520 */     // MIs[1] Operand 1
     /* 1490520 */     // No operand predicates
     /* 1490520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490524 */     // MIs[0] policy
     /* 1490524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490561 */     // GIR_Coverage, 24748,
     /* 1490561 */     GIR_EraseRootFromParent_Done,
     /* 1490562 */   // Label 20817: @1490562
     /* 1490562 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1490659), // Rule ID 24749 //
     /* 1490567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490617 */     // MIs[1] Operand 1
     /* 1490617 */     // No operand predicates
     /* 1490617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490621 */     // MIs[0] policy
     /* 1490621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490633 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490658 */     // GIR_Coverage, 24749,
     /* 1490658 */     GIR_EraseRootFromParent_Done,
     /* 1490659 */   // Label 20818: @1490659
     /* 1490659 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1490756), // Rule ID 24752 //
     /* 1490664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490714 */     // MIs[1] Operand 1
     /* 1490714 */     // No operand predicates
     /* 1490714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490718 */     // MIs[0] policy
     /* 1490718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490755 */     // GIR_Coverage, 24752,
     /* 1490755 */     GIR_EraseRootFromParent_Done,
     /* 1490756 */   // Label 20819: @1490756
     /* 1490756 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1490853), // Rule ID 24753 //
     /* 1490761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490811 */     // MIs[1] Operand 1
     /* 1490811 */     // No operand predicates
     /* 1490811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490815 */     // MIs[0] policy
     /* 1490815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490852 */     // GIR_Coverage, 24753,
     /* 1490852 */     GIR_EraseRootFromParent_Done,
     /* 1490853 */   // Label 20820: @1490853
     /* 1490853 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1490950), // Rule ID 24756 //
     /* 1490858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490908 */     // MIs[1] Operand 1
     /* 1490908 */     // No operand predicates
     /* 1490908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490912 */     // MIs[0] policy
     /* 1490912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490949 */     // GIR_Coverage, 24756,
     /* 1490949 */     GIR_EraseRootFromParent_Done,
     /* 1490950 */   // Label 20821: @1490950
     /* 1490950 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1491047), // Rule ID 24757 //
     /* 1490955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491005 */     // MIs[1] Operand 1
     /* 1491005 */     // No operand predicates
     /* 1491005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491009 */     // MIs[0] policy
     /* 1491009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1491024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491046 */     // GIR_Coverage, 24757,
     /* 1491046 */     GIR_EraseRootFromParent_Done,
     /* 1491047 */   // Label 20822: @1491047
     /* 1491047 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1491144), // Rule ID 24760 //
     /* 1491052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1491055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1491063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1491066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1491069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491102 */     // MIs[1] Operand 1
     /* 1491102 */     // No operand predicates
     /* 1491102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491106 */     // MIs[0] policy
     /* 1491106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491143 */     // GIR_Coverage, 24760,
     /* 1491143 */     GIR_EraseRootFromParent_Done,
     /* 1491144 */   // Label 20823: @1491144
     /* 1491144 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1491241), // Rule ID 24761 //
     /* 1491149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1491152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1491160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1491163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1491166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491199 */     // MIs[1] Operand 1
     /* 1491199 */     // No operand predicates
     /* 1491199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491203 */     // MIs[0] policy
     /* 1491203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491215 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491240 */     // GIR_Coverage, 24761,
     /* 1491240 */     GIR_EraseRootFromParent_Done,
     /* 1491241 */   // Label 20824: @1491241
     /* 1491241 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1491338), // Rule ID 24764 //
     /* 1491246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1491249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1491257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1491260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1491263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491296 */     // MIs[1] Operand 1
     /* 1491296 */     // No operand predicates
     /* 1491296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491300 */     // MIs[0] policy
     /* 1491300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491337 */     // GIR_Coverage, 24764,
     /* 1491337 */     GIR_EraseRootFromParent_Done,
     /* 1491338 */   // Label 20825: @1491338
     /* 1491338 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1491435), // Rule ID 24765 //
     /* 1491343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1491346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1491354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1491357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1491360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491393 */     // MIs[1] Operand 1
     /* 1491393 */     // No operand predicates
     /* 1491393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491397 */     // MIs[0] policy
     /* 1491397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1491431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491434 */     // GIR_Coverage, 24765,
     /* 1491434 */     GIR_EraseRootFromParent_Done,
     /* 1491435 */   // Label 20826: @1491435
     /* 1491435 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1491532), // Rule ID 24972 //
     /* 1491440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491490 */     // MIs[1] Operand 1
     /* 1491490 */     // No operand predicates
     /* 1491490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491494 */     // MIs[0] policy
     /* 1491494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491506 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491531 */     // GIR_Coverage, 24972,
     /* 1491531 */     GIR_EraseRootFromParent_Done,
     /* 1491532 */   // Label 20827: @1491532
     /* 1491532 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1491629), // Rule ID 24973 //
     /* 1491537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491587 */     // MIs[1] Operand 1
     /* 1491587 */     // No operand predicates
     /* 1491587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491591 */     // MIs[0] policy
     /* 1491591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491603 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491628 */     // GIR_Coverage, 24973,
     /* 1491628 */     GIR_EraseRootFromParent_Done,
     /* 1491629 */   // Label 20828: @1491629
     /* 1491629 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1491726), // Rule ID 24976 //
     /* 1491634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491684 */     // MIs[1] Operand 1
     /* 1491684 */     // No operand predicates
     /* 1491684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491688 */     // MIs[0] policy
     /* 1491688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491725 */     // GIR_Coverage, 24976,
     /* 1491725 */     GIR_EraseRootFromParent_Done,
     /* 1491726 */   // Label 20829: @1491726
     /* 1491726 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1491823), // Rule ID 24977 //
     /* 1491731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491781 */     // MIs[1] Operand 1
     /* 1491781 */     // No operand predicates
     /* 1491781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491785 */     // MIs[0] policy
     /* 1491785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491797 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491822 */     // GIR_Coverage, 24977,
     /* 1491822 */     GIR_EraseRootFromParent_Done,
     /* 1491823 */   // Label 20830: @1491823
     /* 1491823 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1491920), // Rule ID 24980 //
     /* 1491828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1491831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491878 */     // MIs[1] Operand 1
     /* 1491878 */     // No operand predicates
     /* 1491878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491882 */     // MIs[0] policy
     /* 1491882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491894 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491919 */     // GIR_Coverage, 24980,
     /* 1491919 */     GIR_EraseRootFromParent_Done,
     /* 1491920 */   // Label 20831: @1491920
     /* 1491920 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1492017), // Rule ID 24981 //
     /* 1491925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1491928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491975 */     // MIs[1] Operand 1
     /* 1491975 */     // No operand predicates
     /* 1491975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491979 */     // MIs[0] policy
     /* 1491979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491991 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492016 */     // GIR_Coverage, 24981,
     /* 1492016 */     GIR_EraseRootFromParent_Done,
     /* 1492017 */   // Label 20832: @1492017
     /* 1492017 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1492114), // Rule ID 24984 //
     /* 1492022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1492039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492072 */     // MIs[1] Operand 1
     /* 1492072 */     // No operand predicates
     /* 1492072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492076 */     // MIs[0] policy
     /* 1492076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492113 */     // GIR_Coverage, 24984,
     /* 1492113 */     GIR_EraseRootFromParent_Done,
     /* 1492114 */   // Label 20833: @1492114
     /* 1492114 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1492211), // Rule ID 24985 //
     /* 1492119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1492136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492169 */     // MIs[1] Operand 1
     /* 1492169 */     // No operand predicates
     /* 1492169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492173 */     // MIs[0] policy
     /* 1492173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492185 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492210 */     // GIR_Coverage, 24985,
     /* 1492210 */     GIR_EraseRootFromParent_Done,
     /* 1492211 */   // Label 20834: @1492211
     /* 1492211 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1492308), // Rule ID 24988 //
     /* 1492216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492266 */     // MIs[1] Operand 1
     /* 1492266 */     // No operand predicates
     /* 1492266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492270 */     // MIs[0] policy
     /* 1492270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492282 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492307 */     // GIR_Coverage, 24988,
     /* 1492307 */     GIR_EraseRootFromParent_Done,
     /* 1492308 */   // Label 20835: @1492308
     /* 1492308 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1492405), // Rule ID 24989 //
     /* 1492313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1492324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1492327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1492330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1492336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492363 */     // MIs[1] Operand 1
     /* 1492363 */     // No operand predicates
     /* 1492363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492367 */     // MIs[0] policy
     /* 1492367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492379 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492404 */     // GIR_Coverage, 24989,
     /* 1492404 */     GIR_EraseRootFromParent_Done,
     /* 1492405 */   // Label 20836: @1492405
     /* 1492405 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1492502), // Rule ID 24992 //
     /* 1492410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1492413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492460 */     // MIs[1] Operand 1
     /* 1492460 */     // No operand predicates
     /* 1492460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492464 */     // MIs[0] policy
     /* 1492464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492501 */     // GIR_Coverage, 24992,
     /* 1492501 */     GIR_EraseRootFromParent_Done,
     /* 1492502 */   // Label 20837: @1492502
     /* 1492502 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1492599), // Rule ID 24993 //
     /* 1492507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1492510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492557 */     // MIs[1] Operand 1
     /* 1492557 */     // No operand predicates
     /* 1492557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492561 */     // MIs[0] policy
     /* 1492561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492573 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492598 */     // GIR_Coverage, 24993,
     /* 1492598 */     GIR_EraseRootFromParent_Done,
     /* 1492599 */   // Label 20838: @1492599
     /* 1492599 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1492696), // Rule ID 24996 //
     /* 1492604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492654 */     // MIs[1] Operand 1
     /* 1492654 */     // No operand predicates
     /* 1492654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492658 */     // MIs[0] policy
     /* 1492658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492695 */     // GIR_Coverage, 24996,
     /* 1492695 */     GIR_EraseRootFromParent_Done,
     /* 1492696 */   // Label 20839: @1492696
     /* 1492696 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1492793), // Rule ID 24997 //
     /* 1492701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492751 */     // MIs[1] Operand 1
     /* 1492751 */     // No operand predicates
     /* 1492751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492755 */     // MIs[0] policy
     /* 1492755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492792 */     // GIR_Coverage, 24997,
     /* 1492792 */     GIR_EraseRootFromParent_Done,
     /* 1492793 */   // Label 20840: @1492793
     /* 1492793 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1492890), // Rule ID 25000 //
     /* 1492798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492848 */     // MIs[1] Operand 1
     /* 1492848 */     // No operand predicates
     /* 1492848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492852 */     // MIs[0] policy
     /* 1492852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492864 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492889 */     // GIR_Coverage, 25000,
     /* 1492889 */     GIR_EraseRootFromParent_Done,
     /* 1492890 */   // Label 20841: @1492890
     /* 1492890 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1492987), // Rule ID 25001 //
     /* 1492895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1492898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492945 */     // MIs[1] Operand 1
     /* 1492945 */     // No operand predicates
     /* 1492945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492949 */     // MIs[0] policy
     /* 1492949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492961 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492986 */     // GIR_Coverage, 25001,
     /* 1492986 */     GIR_EraseRootFromParent_Done,
     /* 1492987 */   // Label 20842: @1492987
     /* 1492987 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1493084), // Rule ID 25004 //
     /* 1492992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1492995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493042 */     // MIs[1] Operand 1
     /* 1493042 */     // No operand predicates
     /* 1493042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493046 */     // MIs[0] policy
     /* 1493046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493058 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493083 */     // GIR_Coverage, 25004,
     /* 1493083 */     GIR_EraseRootFromParent_Done,
     /* 1493084 */   // Label 20843: @1493084
     /* 1493084 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1493181), // Rule ID 25005 //
     /* 1493089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493139 */     // MIs[1] Operand 1
     /* 1493139 */     // No operand predicates
     /* 1493139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493143 */     // MIs[0] policy
     /* 1493143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493155 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493180 */     // GIR_Coverage, 25005,
     /* 1493180 */     GIR_EraseRootFromParent_Done,
     /* 1493181 */   // Label 20844: @1493181
     /* 1493181 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1493278), // Rule ID 25008 //
     /* 1493186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493236 */     // MIs[1] Operand 1
     /* 1493236 */     // No operand predicates
     /* 1493236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493240 */     // MIs[0] policy
     /* 1493240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493277 */     // GIR_Coverage, 25008,
     /* 1493277 */     GIR_EraseRootFromParent_Done,
     /* 1493278 */   // Label 20845: @1493278
     /* 1493278 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1493375), // Rule ID 25009 //
     /* 1493283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493333 */     // MIs[1] Operand 1
     /* 1493333 */     // No operand predicates
     /* 1493333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493337 */     // MIs[0] policy
     /* 1493337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493349 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493374 */     // GIR_Coverage, 25009,
     /* 1493374 */     GIR_EraseRootFromParent_Done,
     /* 1493375 */   // Label 20846: @1493375
     /* 1493375 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1493472), // Rule ID 25012 //
     /* 1493380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493430 */     // MIs[1] Operand 1
     /* 1493430 */     // No operand predicates
     /* 1493430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493434 */     // MIs[0] policy
     /* 1493434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493446 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493471 */     // GIR_Coverage, 25012,
     /* 1493471 */     GIR_EraseRootFromParent_Done,
     /* 1493472 */   // Label 20847: @1493472
     /* 1493472 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1493569), // Rule ID 25013 //
     /* 1493477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493527 */     // MIs[1] Operand 1
     /* 1493527 */     // No operand predicates
     /* 1493527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493531 */     // MIs[0] policy
     /* 1493531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493543 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493568 */     // GIR_Coverage, 25013,
     /* 1493568 */     GIR_EraseRootFromParent_Done,
     /* 1493569 */   // Label 20848: @1493569
     /* 1493569 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1493666), // Rule ID 25016 //
     /* 1493574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1493577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493624 */     // MIs[1] Operand 1
     /* 1493624 */     // No operand predicates
     /* 1493624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493628 */     // MIs[0] policy
     /* 1493628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493665 */     // GIR_Coverage, 25016,
     /* 1493665 */     GIR_EraseRootFromParent_Done,
     /* 1493666 */   // Label 20849: @1493666
     /* 1493666 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1493763), // Rule ID 25017 //
     /* 1493671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1493674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493721 */     // MIs[1] Operand 1
     /* 1493721 */     // No operand predicates
     /* 1493721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493725 */     // MIs[0] policy
     /* 1493725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493737 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493762 */     // GIR_Coverage, 25017,
     /* 1493762 */     GIR_EraseRootFromParent_Done,
     /* 1493763 */   // Label 20850: @1493763
     /* 1493763 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1493860), // Rule ID 25020 //
     /* 1493768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493818 */     // MIs[1] Operand 1
     /* 1493818 */     // No operand predicates
     /* 1493818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493822 */     // MIs[0] policy
     /* 1493822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493834 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493859 */     // GIR_Coverage, 25020,
     /* 1493859 */     GIR_EraseRootFromParent_Done,
     /* 1493860 */   // Label 20851: @1493860
     /* 1493860 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1493957), // Rule ID 25021 //
     /* 1493865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1493868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493915 */     // MIs[1] Operand 1
     /* 1493915 */     // No operand predicates
     /* 1493915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493919 */     // MIs[0] policy
     /* 1493919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493931 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493956 */     // GIR_Coverage, 25021,
     /* 1493956 */     GIR_EraseRootFromParent_Done,
     /* 1493957 */   // Label 20852: @1493957
     /* 1493957 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1494054), // Rule ID 25024 //
     /* 1493962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1493965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494012 */     // MIs[1] Operand 1
     /* 1494012 */     // No operand predicates
     /* 1494012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494016 */     // MIs[0] policy
     /* 1494016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494028 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494053 */     // GIR_Coverage, 25024,
     /* 1494053 */     GIR_EraseRootFromParent_Done,
     /* 1494054 */   // Label 20853: @1494054
     /* 1494054 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1494151), // Rule ID 25025 //
     /* 1494059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494109 */     // MIs[1] Operand 1
     /* 1494109 */     // No operand predicates
     /* 1494109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494113 */     // MIs[0] policy
     /* 1494113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494125 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1494128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494150 */     // GIR_Coverage, 25025,
     /* 1494150 */     GIR_EraseRootFromParent_Done,
     /* 1494151 */   // Label 20854: @1494151
     /* 1494151 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1494248), // Rule ID 25028 //
     /* 1494156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1494159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494206 */     // MIs[1] Operand 1
     /* 1494206 */     // No operand predicates
     /* 1494206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494210 */     // MIs[0] policy
     /* 1494210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494222 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494247 */     // GIR_Coverage, 25028,
     /* 1494247 */     GIR_EraseRootFromParent_Done,
     /* 1494248 */   // Label 20855: @1494248
     /* 1494248 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1494345), // Rule ID 25029 //
     /* 1494253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1494256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1494261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494303 */     // MIs[1] Operand 1
     /* 1494303 */     // No operand predicates
     /* 1494303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494307 */     // MIs[0] policy
     /* 1494307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494319 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1494322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494344 */     // GIR_Coverage, 25029,
     /* 1494344 */     GIR_EraseRootFromParent_Done,
     /* 1494345 */   // Label 20856: @1494345
     /* 1494345 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1494442), // Rule ID 61040 //
     /* 1494350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494400 */     // MIs[1] Operand 1
     /* 1494400 */     // No operand predicates
     /* 1494400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494404 */     // MIs[0] policy
     /* 1494404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494441 */     // GIR_Coverage, 61040,
     /* 1494441 */     GIR_EraseRootFromParent_Done,
     /* 1494442 */   // Label 20857: @1494442
     /* 1494442 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1494539), // Rule ID 61041 //
     /* 1494447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494497 */     // MIs[1] Operand 1
     /* 1494497 */     // No operand predicates
     /* 1494497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494501 */     // MIs[0] policy
     /* 1494501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494513 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494538 */     // GIR_Coverage, 61041,
     /* 1494538 */     GIR_EraseRootFromParent_Done,
     /* 1494539 */   // Label 20858: @1494539
     /* 1494539 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1494636), // Rule ID 61048 //
     /* 1494544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494594 */     // MIs[1] Operand 1
     /* 1494594 */     // No operand predicates
     /* 1494594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494598 */     // MIs[0] policy
     /* 1494598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494635 */     // GIR_Coverage, 61048,
     /* 1494635 */     GIR_EraseRootFromParent_Done,
     /* 1494636 */   // Label 20859: @1494636
     /* 1494636 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1494733), // Rule ID 61049 //
     /* 1494641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494691 */     // MIs[1] Operand 1
     /* 1494691 */     // No operand predicates
     /* 1494691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494695 */     // MIs[0] policy
     /* 1494695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494707 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494732 */     // GIR_Coverage, 61049,
     /* 1494732 */     GIR_EraseRootFromParent_Done,
     /* 1494733 */   // Label 20860: @1494733
     /* 1494733 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1494830), // Rule ID 61056 //
     /* 1494738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494788 */     // MIs[1] Operand 1
     /* 1494788 */     // No operand predicates
     /* 1494788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494792 */     // MIs[0] policy
     /* 1494792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494829 */     // GIR_Coverage, 61056,
     /* 1494829 */     GIR_EraseRootFromParent_Done,
     /* 1494830 */   // Label 20861: @1494830
     /* 1494830 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1494927), // Rule ID 61057 //
     /* 1494835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494885 */     // MIs[1] Operand 1
     /* 1494885 */     // No operand predicates
     /* 1494885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494889 */     // MIs[0] policy
     /* 1494889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494901 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494926 */     // GIR_Coverage, 61057,
     /* 1494926 */     GIR_EraseRootFromParent_Done,
     /* 1494927 */   // Label 20862: @1494927
     /* 1494927 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1495024), // Rule ID 61064 //
     /* 1494932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494982 */     // MIs[1] Operand 1
     /* 1494982 */     // No operand predicates
     /* 1494982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494986 */     // MIs[0] policy
     /* 1494986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495023 */     // GIR_Coverage, 61064,
     /* 1495023 */     GIR_EraseRootFromParent_Done,
     /* 1495024 */   // Label 20863: @1495024
     /* 1495024 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1495121), // Rule ID 61065 //
     /* 1495029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1495046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495079 */     // MIs[1] Operand 1
     /* 1495079 */     // No operand predicates
     /* 1495079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495083 */     // MIs[0] policy
     /* 1495083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495120 */     // GIR_Coverage, 61065,
     /* 1495120 */     GIR_EraseRootFromParent_Done,
     /* 1495121 */   // Label 20864: @1495121
     /* 1495121 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1495218), // Rule ID 61072 //
     /* 1495126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1495143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495176 */     // MIs[1] Operand 1
     /* 1495176 */     // No operand predicates
     /* 1495176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495180 */     // MIs[0] policy
     /* 1495180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495217 */     // GIR_Coverage, 61072,
     /* 1495217 */     GIR_EraseRootFromParent_Done,
     /* 1495218 */   // Label 20865: @1495218
     /* 1495218 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1495315), // Rule ID 61073 //
     /* 1495223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1495240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495273 */     // MIs[1] Operand 1
     /* 1495273 */     // No operand predicates
     /* 1495273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495277 */     // MIs[0] policy
     /* 1495277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495289 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495314 */     // GIR_Coverage, 61073,
     /* 1495314 */     GIR_EraseRootFromParent_Done,
     /* 1495315 */   // Label 20866: @1495315
     /* 1495315 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1495412), // Rule ID 61080 //
     /* 1495320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1495337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495370 */     // MIs[1] Operand 1
     /* 1495370 */     // No operand predicates
     /* 1495370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495374 */     // MIs[0] policy
     /* 1495374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495411 */     // GIR_Coverage, 61080,
     /* 1495411 */     GIR_EraseRootFromParent_Done,
     /* 1495412 */   // Label 20867: @1495412
     /* 1495412 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1495509), // Rule ID 61081 //
     /* 1495417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1495428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1495431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1495434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1495440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495467 */     // MIs[1] Operand 1
     /* 1495467 */     // No operand predicates
     /* 1495467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495471 */     // MIs[0] policy
     /* 1495471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495483 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495508 */     // GIR_Coverage, 61081,
     /* 1495508 */     GIR_EraseRootFromParent_Done,
     /* 1495509 */   // Label 20868: @1495509
     /* 1495509 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1495606), // Rule ID 61088 //
     /* 1495514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495564 */     // MIs[1] Operand 1
     /* 1495564 */     // No operand predicates
     /* 1495564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495568 */     // MIs[0] policy
     /* 1495568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495605 */     // GIR_Coverage, 61088,
     /* 1495605 */     GIR_EraseRootFromParent_Done,
     /* 1495606 */   // Label 20869: @1495606
     /* 1495606 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1495703), // Rule ID 61089 //
     /* 1495611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495661 */     // MIs[1] Operand 1
     /* 1495661 */     // No operand predicates
     /* 1495661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495665 */     // MIs[0] policy
     /* 1495665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495702 */     // GIR_Coverage, 61089,
     /* 1495702 */     GIR_EraseRootFromParent_Done,
     /* 1495703 */   // Label 20870: @1495703
     /* 1495703 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1495800), // Rule ID 61096 //
     /* 1495708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495758 */     // MIs[1] Operand 1
     /* 1495758 */     // No operand predicates
     /* 1495758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495762 */     // MIs[0] policy
     /* 1495762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495799 */     // GIR_Coverage, 61096,
     /* 1495799 */     GIR_EraseRootFromParent_Done,
     /* 1495800 */   // Label 20871: @1495800
     /* 1495800 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1495897), // Rule ID 61097 //
     /* 1495805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495855 */     // MIs[1] Operand 1
     /* 1495855 */     // No operand predicates
     /* 1495855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495859 */     // MIs[0] policy
     /* 1495859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495896 */     // GIR_Coverage, 61097,
     /* 1495896 */     GIR_EraseRootFromParent_Done,
     /* 1495897 */   // Label 20872: @1495897
     /* 1495897 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1495994), // Rule ID 61104 //
     /* 1495902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495952 */     // MIs[1] Operand 1
     /* 1495952 */     // No operand predicates
     /* 1495952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495956 */     // MIs[0] policy
     /* 1495956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495993 */     // GIR_Coverage, 61104,
     /* 1495993 */     GIR_EraseRootFromParent_Done,
     /* 1495994 */   // Label 20873: @1495994
     /* 1495994 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1496091), // Rule ID 61105 //
     /* 1495999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1496010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1496013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1496016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496049 */     // MIs[1] Operand 1
     /* 1496049 */     // No operand predicates
     /* 1496049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496053 */     // MIs[0] policy
     /* 1496053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496065 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496090 */     // GIR_Coverage, 61105,
     /* 1496090 */     GIR_EraseRootFromParent_Done,
     /* 1496091 */   // Label 20874: @1496091
     /* 1496091 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1496188), // Rule ID 61112 //
     /* 1496096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1496113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496146 */     // MIs[1] Operand 1
     /* 1496146 */     // No operand predicates
     /* 1496146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496150 */     // MIs[0] policy
     /* 1496150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496187 */     // GIR_Coverage, 61112,
     /* 1496187 */     GIR_EraseRootFromParent_Done,
     /* 1496188 */   // Label 20875: @1496188
     /* 1496188 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1496285), // Rule ID 61113 //
     /* 1496193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1496210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496243 */     // MIs[1] Operand 1
     /* 1496243 */     // No operand predicates
     /* 1496243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496247 */     // MIs[0] policy
     /* 1496247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496259 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496284 */     // GIR_Coverage, 61113,
     /* 1496284 */     GIR_EraseRootFromParent_Done,
     /* 1496285 */   // Label 20876: @1496285
     /* 1496285 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1496382), // Rule ID 61120 //
     /* 1496290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1496307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496340 */     // MIs[1] Operand 1
     /* 1496340 */     // No operand predicates
     /* 1496340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496344 */     // MIs[0] policy
     /* 1496344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496356 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496381 */     // GIR_Coverage, 61120,
     /* 1496381 */     GIR_EraseRootFromParent_Done,
     /* 1496382 */   // Label 20877: @1496382
     /* 1496382 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1496479), // Rule ID 61121 //
     /* 1496387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1496404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496437 */     // MIs[1] Operand 1
     /* 1496437 */     // No operand predicates
     /* 1496437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496441 */     // MIs[0] policy
     /* 1496441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496453 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496478 */     // GIR_Coverage, 61121,
     /* 1496478 */     GIR_EraseRootFromParent_Done,
     /* 1496479 */   // Label 20878: @1496479
     /* 1496479 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1496576), // Rule ID 61128 //
     /* 1496484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496534 */     // MIs[1] Operand 1
     /* 1496534 */     // No operand predicates
     /* 1496534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496538 */     // MIs[0] policy
     /* 1496538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496575 */     // GIR_Coverage, 61128,
     /* 1496575 */     GIR_EraseRootFromParent_Done,
     /* 1496576 */   // Label 20879: @1496576
     /* 1496576 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1496673), // Rule ID 61129 //
     /* 1496581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496631 */     // MIs[1] Operand 1
     /* 1496631 */     // No operand predicates
     /* 1496631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496635 */     // MIs[0] policy
     /* 1496635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496647 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496672 */     // GIR_Coverage, 61129,
     /* 1496672 */     GIR_EraseRootFromParent_Done,
     /* 1496673 */   // Label 20880: @1496673
     /* 1496673 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1496770), // Rule ID 61136 //
     /* 1496678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496728 */     // MIs[1] Operand 1
     /* 1496728 */     // No operand predicates
     /* 1496728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496732 */     // MIs[0] policy
     /* 1496732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496769 */     // GIR_Coverage, 61136,
     /* 1496769 */     GIR_EraseRootFromParent_Done,
     /* 1496770 */   // Label 20881: @1496770
     /* 1496770 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1496867), // Rule ID 61137 //
     /* 1496775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496825 */     // MIs[1] Operand 1
     /* 1496825 */     // No operand predicates
     /* 1496825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496829 */     // MIs[0] policy
     /* 1496829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496866 */     // GIR_Coverage, 61137,
     /* 1496866 */     GIR_EraseRootFromParent_Done,
     /* 1496867 */   // Label 20882: @1496867
     /* 1496867 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1496964), // Rule ID 61144 //
     /* 1496872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496922 */     // MIs[1] Operand 1
     /* 1496922 */     // No operand predicates
     /* 1496922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496926 */     // MIs[0] policy
     /* 1496926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496963 */     // GIR_Coverage, 61144,
     /* 1496963 */     GIR_EraseRootFromParent_Done,
     /* 1496964 */   // Label 20883: @1496964
     /* 1496964 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1497061), // Rule ID 61145 //
     /* 1496969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497019 */     // MIs[1] Operand 1
     /* 1497019 */     // No operand predicates
     /* 1497019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497023 */     // MIs[0] policy
     /* 1497023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497035 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1497038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497060 */     // GIR_Coverage, 61145,
     /* 1497060 */     GIR_EraseRootFromParent_Done,
     /* 1497061 */   // Label 20884: @1497061
     /* 1497061 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1497158), // Rule ID 61152 //
     /* 1497066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1497069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497116 */     // MIs[1] Operand 1
     /* 1497116 */     // No operand predicates
     /* 1497116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497120 */     // MIs[0] policy
     /* 1497120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497132 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1497135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497157 */     // GIR_Coverage, 61152,
     /* 1497157 */     GIR_EraseRootFromParent_Done,
     /* 1497158 */   // Label 20885: @1497158
     /* 1497158 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1497255), // Rule ID 61153 //
     /* 1497163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1497166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1497171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1497213 */     // MIs[1] Operand 1
     /* 1497213 */     // No operand predicates
     /* 1497213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497217 */     // MIs[0] policy
     /* 1497217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497229 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1497232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497254 */     // GIR_Coverage, 61153,
     /* 1497254 */     GIR_EraseRootFromParent_Done,
     /* 1497255 */   // Label 20886: @1497255
     /* 1497255 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1497352), // Rule ID 62008 //
     /* 1497260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1497271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1497274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497310 */     // MIs[1] Operand 1
     /* 1497310 */     // No operand predicates
     /* 1497310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497314 */     // MIs[0] policy
     /* 1497314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1497329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497351 */     // GIR_Coverage, 62008,
     /* 1497351 */     GIR_EraseRootFromParent_Done,
     /* 1497352 */   // Label 20887: @1497352
     /* 1497352 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1497449), // Rule ID 62009 //
     /* 1497357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1497368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1497371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1497374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497407 */     // MIs[1] Operand 1
     /* 1497407 */     // No operand predicates
     /* 1497407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497411 */     // MIs[0] policy
     /* 1497411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497423 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1497426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497448 */     // GIR_Coverage, 62009,
     /* 1497448 */     GIR_EraseRootFromParent_Done,
     /* 1497449 */   // Label 20888: @1497449
     /* 1497449 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1497546), // Rule ID 62012 //
     /* 1497454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497504 */     // MIs[1] Operand 1
     /* 1497504 */     // No operand predicates
     /* 1497504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497508 */     // MIs[0] policy
     /* 1497508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497545 */     // GIR_Coverage, 62012,
     /* 1497545 */     GIR_EraseRootFromParent_Done,
     /* 1497546 */   // Label 20889: @1497546
     /* 1497546 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1497643), // Rule ID 62013 //
     /* 1497551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497601 */     // MIs[1] Operand 1
     /* 1497601 */     // No operand predicates
     /* 1497601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497605 */     // MIs[0] policy
     /* 1497605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497617 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497642 */     // GIR_Coverage, 62013,
     /* 1497642 */     GIR_EraseRootFromParent_Done,
     /* 1497643 */   // Label 20890: @1497643
     /* 1497643 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1497740), // Rule ID 62016 //
     /* 1497648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497698 */     // MIs[1] Operand 1
     /* 1497698 */     // No operand predicates
     /* 1497698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497702 */     // MIs[0] policy
     /* 1497702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497739 */     // GIR_Coverage, 62016,
     /* 1497739 */     GIR_EraseRootFromParent_Done,
     /* 1497740 */   // Label 20891: @1497740
     /* 1497740 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1497837), // Rule ID 62017 //
     /* 1497745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497795 */     // MIs[1] Operand 1
     /* 1497795 */     // No operand predicates
     /* 1497795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497799 */     // MIs[0] policy
     /* 1497799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497811 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497836 */     // GIR_Coverage, 62017,
     /* 1497836 */     GIR_EraseRootFromParent_Done,
     /* 1497837 */   // Label 20892: @1497837
     /* 1497837 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1497934), // Rule ID 62020 //
     /* 1497842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497892 */     // MIs[1] Operand 1
     /* 1497892 */     // No operand predicates
     /* 1497892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497896 */     // MIs[0] policy
     /* 1497896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497933 */     // GIR_Coverage, 62020,
     /* 1497933 */     GIR_EraseRootFromParent_Done,
     /* 1497934 */   // Label 20893: @1497934
     /* 1497934 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1498031), // Rule ID 62021 //
     /* 1497939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497989 */     // MIs[1] Operand 1
     /* 1497989 */     // No operand predicates
     /* 1497989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497993 */     // MIs[0] policy
     /* 1497993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498005 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1498008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498030 */     // GIR_Coverage, 62021,
     /* 1498030 */     GIR_EraseRootFromParent_Done,
     /* 1498031 */   // Label 20894: @1498031
     /* 1498031 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1498128), // Rule ID 62024 //
     /* 1498036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1498047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1498050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1498053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498086 */     // MIs[1] Operand 1
     /* 1498086 */     // No operand predicates
     /* 1498086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498090 */     // MIs[0] policy
     /* 1498090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498127 */     // GIR_Coverage, 62024,
     /* 1498127 */     GIR_EraseRootFromParent_Done,
     /* 1498128 */   // Label 20895: @1498128
     /* 1498128 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1498225), // Rule ID 62025 //
     /* 1498133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1498144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1498147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1498150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498183 */     // MIs[1] Operand 1
     /* 1498183 */     // No operand predicates
     /* 1498183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498187 */     // MIs[0] policy
     /* 1498187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498199 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498224 */     // GIR_Coverage, 62025,
     /* 1498224 */     GIR_EraseRootFromParent_Done,
     /* 1498225 */   // Label 20896: @1498225
     /* 1498225 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1498322), // Rule ID 62028 //
     /* 1498230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1498241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1498244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1498247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498280 */     // MIs[1] Operand 1
     /* 1498280 */     // No operand predicates
     /* 1498280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498284 */     // MIs[0] policy
     /* 1498284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498321 */     // GIR_Coverage, 62028,
     /* 1498321 */     GIR_EraseRootFromParent_Done,
     /* 1498322 */   // Label 20897: @1498322
     /* 1498322 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1498419), // Rule ID 62029 //
     /* 1498327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1498338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1498341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1498344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498377 */     // MIs[1] Operand 1
     /* 1498377 */     // No operand predicates
     /* 1498377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498381 */     // MIs[0] policy
     /* 1498381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498393 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1498396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498418 */     // GIR_Coverage, 62029,
     /* 1498418 */     GIR_EraseRootFromParent_Done,
     /* 1498419 */   // Label 20898: @1498419
     /* 1498419 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1498516), // Rule ID 62032 //
     /* 1498424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498474 */     // MIs[1] Operand 1
     /* 1498474 */     // No operand predicates
     /* 1498474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498478 */     // MIs[0] policy
     /* 1498478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498490 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498515 */     // GIR_Coverage, 62032,
     /* 1498515 */     GIR_EraseRootFromParent_Done,
     /* 1498516 */   // Label 20899: @1498516
     /* 1498516 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1498613), // Rule ID 62033 //
     /* 1498521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498571 */     // MIs[1] Operand 1
     /* 1498571 */     // No operand predicates
     /* 1498571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498575 */     // MIs[0] policy
     /* 1498575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498587 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498612 */     // GIR_Coverage, 62033,
     /* 1498612 */     GIR_EraseRootFromParent_Done,
     /* 1498613 */   // Label 20900: @1498613
     /* 1498613 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1498710), // Rule ID 62036 //
     /* 1498618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498668 */     // MIs[1] Operand 1
     /* 1498668 */     // No operand predicates
     /* 1498668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498672 */     // MIs[0] policy
     /* 1498672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498709 */     // GIR_Coverage, 62036,
     /* 1498709 */     GIR_EraseRootFromParent_Done,
     /* 1498710 */   // Label 20901: @1498710
     /* 1498710 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1498807), // Rule ID 62037 //
     /* 1498715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498765 */     // MIs[1] Operand 1
     /* 1498765 */     // No operand predicates
     /* 1498765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498769 */     // MIs[0] policy
     /* 1498769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498781 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498806 */     // GIR_Coverage, 62037,
     /* 1498806 */     GIR_EraseRootFromParent_Done,
     /* 1498807 */   // Label 20902: @1498807
     /* 1498807 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1498904), // Rule ID 62040 //
     /* 1498812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498862 */     // MIs[1] Operand 1
     /* 1498862 */     // No operand predicates
     /* 1498862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498866 */     // MIs[0] policy
     /* 1498866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498903 */     // GIR_Coverage, 62040,
     /* 1498903 */     GIR_EraseRootFromParent_Done,
     /* 1498904 */   // Label 20903: @1498904
     /* 1498904 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1499001), // Rule ID 62041 //
     /* 1498909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498959 */     // MIs[1] Operand 1
     /* 1498959 */     // No operand predicates
     /* 1498959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498963 */     // MIs[0] policy
     /* 1498963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499000 */     // GIR_Coverage, 62041,
     /* 1499000 */     GIR_EraseRootFromParent_Done,
     /* 1499001 */   // Label 20904: @1499001
     /* 1499001 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1499098), // Rule ID 62044 //
     /* 1499006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1499023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499056 */     // MIs[1] Operand 1
     /* 1499056 */     // No operand predicates
     /* 1499056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499060 */     // MIs[0] policy
     /* 1499060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1499075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499097 */     // GIR_Coverage, 62044,
     /* 1499097 */     GIR_EraseRootFromParent_Done,
     /* 1499098 */   // Label 20905: @1499098
     /* 1499098 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1499195), // Rule ID 62045 //
     /* 1499103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1499120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1499126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499153 */     // MIs[1] Operand 1
     /* 1499153 */     // No operand predicates
     /* 1499153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499157 */     // MIs[0] policy
     /* 1499157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1499172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499194 */     // GIR_Coverage, 62045,
     /* 1499194 */     GIR_EraseRootFromParent_Done,
     /* 1499195 */   // Label 20906: @1499195
     /* 1499195 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1499292), // Rule ID 62048 //
     /* 1499200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1499211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1499214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1499217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499250 */     // MIs[1] Operand 1
     /* 1499250 */     // No operand predicates
     /* 1499250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499254 */     // MIs[0] policy
     /* 1499254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499291 */     // GIR_Coverage, 62048,
     /* 1499291 */     GIR_EraseRootFromParent_Done,
     /* 1499292 */   // Label 20907: @1499292
     /* 1499292 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1499389), // Rule ID 62049 //
     /* 1499297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1499308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1499311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1499314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499347 */     // MIs[1] Operand 1
     /* 1499347 */     // No operand predicates
     /* 1499347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499351 */     // MIs[0] policy
     /* 1499351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499388 */     // GIR_Coverage, 62049,
     /* 1499388 */     GIR_EraseRootFromParent_Done,
     /* 1499389 */   // Label 20908: @1499389
     /* 1499389 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1499486), // Rule ID 62052 //
     /* 1499394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499444 */     // MIs[1] Operand 1
     /* 1499444 */     // No operand predicates
     /* 1499444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499448 */     // MIs[0] policy
     /* 1499448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499460 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499485 */     // GIR_Coverage, 62052,
     /* 1499485 */     GIR_EraseRootFromParent_Done,
     /* 1499486 */   // Label 20909: @1499486
     /* 1499486 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1499583), // Rule ID 62053 //
     /* 1499491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499541 */     // MIs[1] Operand 1
     /* 1499541 */     // No operand predicates
     /* 1499541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499545 */     // MIs[0] policy
     /* 1499545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499557 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499582 */     // GIR_Coverage, 62053,
     /* 1499582 */     GIR_EraseRootFromParent_Done,
     /* 1499583 */   // Label 20910: @1499583
     /* 1499583 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1499680), // Rule ID 62056 //
     /* 1499588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499638 */     // MIs[1] Operand 1
     /* 1499638 */     // No operand predicates
     /* 1499638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499642 */     // MIs[0] policy
     /* 1499642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499654 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499679 */     // GIR_Coverage, 62056,
     /* 1499679 */     GIR_EraseRootFromParent_Done,
     /* 1499680 */   // Label 20911: @1499680
     /* 1499680 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1499777), // Rule ID 62057 //
     /* 1499685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499735 */     // MIs[1] Operand 1
     /* 1499735 */     // No operand predicates
     /* 1499735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499739 */     // MIs[0] policy
     /* 1499739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499751 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499776 */     // GIR_Coverage, 62057,
     /* 1499776 */     GIR_EraseRootFromParent_Done,
     /* 1499777 */   // Label 20912: @1499777
     /* 1499777 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1499874), // Rule ID 62060 //
     /* 1499782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499832 */     // MIs[1] Operand 1
     /* 1499832 */     // No operand predicates
     /* 1499832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499836 */     // MIs[0] policy
     /* 1499836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499873 */     // GIR_Coverage, 62060,
     /* 1499873 */     GIR_EraseRootFromParent_Done,
     /* 1499874 */   // Label 20913: @1499874
     /* 1499874 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1499971), // Rule ID 62061 //
     /* 1499879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499929 */     // MIs[1] Operand 1
     /* 1499929 */     // No operand predicates
     /* 1499929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499933 */     // MIs[0] policy
     /* 1499933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499970 */     // GIR_Coverage, 62061,
     /* 1499970 */     GIR_EraseRootFromParent_Done,
     /* 1499971 */   // Label 20914: @1499971
     /* 1499971 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1500068), // Rule ID 62064 //
     /* 1499976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500026 */     // MIs[1] Operand 1
     /* 1500026 */     // No operand predicates
     /* 1500026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500030 */     // MIs[0] policy
     /* 1500030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500042 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500067 */     // GIR_Coverage, 62064,
     /* 1500067 */     GIR_EraseRootFromParent_Done,
     /* 1500068 */   // Label 20915: @1500068
     /* 1500068 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1500165), // Rule ID 62065 //
     /* 1500073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500123 */     // MIs[1] Operand 1
     /* 1500123 */     // No operand predicates
     /* 1500123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500127 */     // MIs[0] policy
     /* 1500127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500164 */     // GIR_Coverage, 62065,
     /* 1500164 */     GIR_EraseRootFromParent_Done,
     /* 1500165 */   // Label 20916: @1500165
     /* 1500165 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1500262), // Rule ID 62068 //
     /* 1500170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1500193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500220 */     // MIs[1] Operand 1
     /* 1500220 */     // No operand predicates
     /* 1500220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500224 */     // MIs[0] policy
     /* 1500224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500261 */     // GIR_Coverage, 62068,
     /* 1500261 */     GIR_EraseRootFromParent_Done,
     /* 1500262 */   // Label 20917: @1500262
     /* 1500262 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1500359), // Rule ID 62069 //
     /* 1500267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1500290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500317 */     // MIs[1] Operand 1
     /* 1500317 */     // No operand predicates
     /* 1500317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500321 */     // MIs[0] policy
     /* 1500321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500333 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500358 */     // GIR_Coverage, 62069,
     /* 1500358 */     GIR_EraseRootFromParent_Done,
     /* 1500359 */   // Label 20918: @1500359
     /* 1500359 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1500456), // Rule ID 62072 //
     /* 1500364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500414 */     // MIs[1] Operand 1
     /* 1500414 */     // No operand predicates
     /* 1500414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500418 */     // MIs[0] policy
     /* 1500418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500455 */     // GIR_Coverage, 62072,
     /* 1500455 */     GIR_EraseRootFromParent_Done,
     /* 1500456 */   // Label 20919: @1500456
     /* 1500456 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1500553), // Rule ID 62073 //
     /* 1500461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500511 */     // MIs[1] Operand 1
     /* 1500511 */     // No operand predicates
     /* 1500511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500515 */     // MIs[0] policy
     /* 1500515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500552 */     // GIR_Coverage, 62073,
     /* 1500552 */     GIR_EraseRootFromParent_Done,
     /* 1500553 */   // Label 20920: @1500553
     /* 1500553 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1500650), // Rule ID 62076 //
     /* 1500558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500608 */     // MIs[1] Operand 1
     /* 1500608 */     // No operand predicates
     /* 1500608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500612 */     // MIs[0] policy
     /* 1500612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500649 */     // GIR_Coverage, 62076,
     /* 1500649 */     GIR_EraseRootFromParent_Done,
     /* 1500650 */   // Label 20921: @1500650
     /* 1500650 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1500747), // Rule ID 62077 //
     /* 1500655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500705 */     // MIs[1] Operand 1
     /* 1500705 */     // No operand predicates
     /* 1500705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500709 */     // MIs[0] policy
     /* 1500709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500746 */     // GIR_Coverage, 62077,
     /* 1500746 */     GIR_EraseRootFromParent_Done,
     /* 1500747 */   // Label 20922: @1500747
     /* 1500747 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1500844), // Rule ID 62080 //
     /* 1500752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500802 */     // MIs[1] Operand 1
     /* 1500802 */     // No operand predicates
     /* 1500802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500806 */     // MIs[0] policy
     /* 1500806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500843 */     // GIR_Coverage, 62080,
     /* 1500843 */     GIR_EraseRootFromParent_Done,
     /* 1500844 */   // Label 20923: @1500844
     /* 1500844 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1500941), // Rule ID 62081 //
     /* 1500849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500899 */     // MIs[1] Operand 1
     /* 1500899 */     // No operand predicates
     /* 1500899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500903 */     // MIs[0] policy
     /* 1500903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500915 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500940 */     // GIR_Coverage, 62081,
     /* 1500940 */     GIR_EraseRootFromParent_Done,
     /* 1500941 */   // Label 20924: @1500941
     /* 1500941 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1501038), // Rule ID 62084 //
     /* 1500946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500996 */     // MIs[1] Operand 1
     /* 1500996 */     // No operand predicates
     /* 1500996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501000 */     // MIs[0] policy
     /* 1501000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1501015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501037 */     // GIR_Coverage, 62084,
     /* 1501037 */     GIR_EraseRootFromParent_Done,
     /* 1501038 */   // Label 20925: @1501038
     /* 1501038 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1501135), // Rule ID 62085 //
     /* 1501043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1501066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1501073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501093 */     // MIs[1] Operand 1
     /* 1501093 */     // No operand predicates
     /* 1501093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501097 */     // MIs[0] policy
     /* 1501097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1501112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501134 */     // GIR_Coverage, 62085,
     /* 1501134 */     GIR_EraseRootFromParent_Done,
     /* 1501135 */   // Label 20926: @1501135
     /* 1501135 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1501232), // Rule ID 62088 //
     /* 1501140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1501170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501190 */     // MIs[1] Operand 1
     /* 1501190 */     // No operand predicates
     /* 1501190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501194 */     // MIs[0] policy
     /* 1501194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501206 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1501209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501231 */     // GIR_Coverage, 62088,
     /* 1501231 */     GIR_EraseRootFromParent_Done,
     /* 1501232 */   // Label 20927: @1501232
     /* 1501232 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1501329), // Rule ID 62089 //
     /* 1501237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1501260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1501267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501287 */     // MIs[1] Operand 1
     /* 1501287 */     // No operand predicates
     /* 1501287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501291 */     // MIs[0] policy
     /* 1501291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501303 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1501306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501328 */     // GIR_Coverage, 62089,
     /* 1501328 */     GIR_EraseRootFromParent_Done,
     /* 1501329 */   // Label 20928: @1501329
     /* 1501329 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1501426), // Rule ID 62092 //
     /* 1501334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1501337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1501354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1501364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501384 */     // MIs[1] Operand 1
     /* 1501384 */     // No operand predicates
     /* 1501384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501388 */     // MIs[0] policy
     /* 1501388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501425 */     // GIR_Coverage, 62092,
     /* 1501425 */     GIR_EraseRootFromParent_Done,
     /* 1501426 */   // Label 20929: @1501426
     /* 1501426 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1501523), // Rule ID 62093 //
     /* 1501431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1501434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1501439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1501451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1501454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1501461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501481 */     // MIs[1] Operand 1
     /* 1501481 */     // No operand predicates
     /* 1501481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501485 */     // MIs[0] policy
     /* 1501485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501497 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501522 */     // GIR_Coverage, 62093,
     /* 1501522 */     GIR_EraseRootFromParent_Done,
     /* 1501523 */   // Label 20930: @1501523
     /* 1501523 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1501605), // Rule ID 2712 //
     /* 1501528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501567 */     // MIs[0] round
     /* 1501567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501570 */     // MIs[0] policy
     /* 1501570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501580 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501604 */     // GIR_Coverage, 2712,
     /* 1501604 */     GIR_EraseRootFromParent_Done,
     /* 1501605 */   // Label 20931: @1501605
     /* 1501605 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1501687), // Rule ID 2713 //
     /* 1501610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501649 */     // MIs[0] round
     /* 1501649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501652 */     // MIs[0] policy
     /* 1501652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501662 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501686 */     // GIR_Coverage, 2713,
     /* 1501686 */     GIR_EraseRootFromParent_Done,
     /* 1501687 */   // Label 20932: @1501687
     /* 1501687 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1501769), // Rule ID 2748 //
     /* 1501692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1501695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501731 */     // MIs[0] round
     /* 1501731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501734 */     // MIs[0] policy
     /* 1501734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501768 */     // GIR_Coverage, 2748,
     /* 1501768 */     GIR_EraseRootFromParent_Done,
     /* 1501769 */   // Label 20933: @1501769
     /* 1501769 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1501851), // Rule ID 2749 //
     /* 1501774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1501777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501813 */     // MIs[0] round
     /* 1501813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501816 */     // MIs[0] policy
     /* 1501816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501850 */     // GIR_Coverage, 2749,
     /* 1501850 */     GIR_EraseRootFromParent_Done,
     /* 1501851 */   // Label 20934: @1501851
     /* 1501851 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1501933), // Rule ID 2780 //
     /* 1501856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501895 */     // MIs[0] round
     /* 1501895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501898 */     // MIs[0] policy
     /* 1501898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501908 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501932 */     // GIR_Coverage, 2780,
     /* 1501932 */     GIR_EraseRootFromParent_Done,
     /* 1501933 */   // Label 20935: @1501933
     /* 1501933 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1502015), // Rule ID 2781 //
     /* 1501938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501977 */     // MIs[0] round
     /* 1501977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501980 */     // MIs[0] policy
     /* 1501980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501990 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502014 */     // GIR_Coverage, 2781,
     /* 1502014 */     GIR_EraseRootFromParent_Done,
     /* 1502015 */   // Label 20936: @1502015
     /* 1502015 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1502097), // Rule ID 17760 //
     /* 1502020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1502037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502059 */     // MIs[0] round
     /* 1502059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502062 */     // MIs[0] policy
     /* 1502062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502072 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1502075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502096 */     // GIR_Coverage, 17760,
     /* 1502096 */     GIR_EraseRootFromParent_Done,
     /* 1502097 */   // Label 20937: @1502097
     /* 1502097 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1502179), // Rule ID 17761 //
     /* 1502102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1502119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502141 */     // MIs[0] round
     /* 1502141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502144 */     // MIs[0] policy
     /* 1502144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502154 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1502157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502178 */     // GIR_Coverage, 17761,
     /* 1502178 */     GIR_EraseRootFromParent_Done,
     /* 1502179 */   // Label 20938: @1502179
     /* 1502179 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1502261), // Rule ID 17764 //
     /* 1502184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1502201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502223 */     // MIs[0] round
     /* 1502223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502226 */     // MIs[0] policy
     /* 1502226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502236 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1502239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502260 */     // GIR_Coverage, 17764,
     /* 1502260 */     GIR_EraseRootFromParent_Done,
     /* 1502261 */   // Label 20939: @1502261
     /* 1502261 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1502343), // Rule ID 17765 //
     /* 1502266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1502283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502305 */     // MIs[0] round
     /* 1502305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502308 */     // MIs[0] policy
     /* 1502308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502318 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1502321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502342 */     // GIR_Coverage, 17765,
     /* 1502342 */     GIR_EraseRootFromParent_Done,
     /* 1502343 */   // Label 20940: @1502343
     /* 1502343 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1502425), // Rule ID 17768 //
     /* 1502348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502387 */     // MIs[0] round
     /* 1502387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502390 */     // MIs[0] policy
     /* 1502390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502400 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502424 */     // GIR_Coverage, 17768,
     /* 1502424 */     GIR_EraseRootFromParent_Done,
     /* 1502425 */   // Label 20941: @1502425
     /* 1502425 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1502507), // Rule ID 17769 //
     /* 1502430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1502447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502469 */     // MIs[0] round
     /* 1502469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502472 */     // MIs[0] policy
     /* 1502472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502482 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502506 */     // GIR_Coverage, 17769,
     /* 1502506 */     GIR_EraseRootFromParent_Done,
     /* 1502507 */   // Label 20942: @1502507
     /* 1502507 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1502589), // Rule ID 17772 //
     /* 1502512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502551 */     // MIs[0] round
     /* 1502551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502554 */     // MIs[0] policy
     /* 1502554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502588 */     // GIR_Coverage, 17772,
     /* 1502588 */     GIR_EraseRootFromParent_Done,
     /* 1502589 */   // Label 20943: @1502589
     /* 1502589 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1502671), // Rule ID 17773 //
     /* 1502594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502633 */     // MIs[0] round
     /* 1502633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502636 */     // MIs[0] policy
     /* 1502636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502646 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502670 */     // GIR_Coverage, 17773,
     /* 1502670 */     GIR_EraseRootFromParent_Done,
     /* 1502671 */   // Label 20944: @1502671
     /* 1502671 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1502753), // Rule ID 17776 //
     /* 1502676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502715 */     // MIs[0] round
     /* 1502715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502718 */     // MIs[0] policy
     /* 1502718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502728 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502752 */     // GIR_Coverage, 17776,
     /* 1502752 */     GIR_EraseRootFromParent_Done,
     /* 1502753 */   // Label 20945: @1502753
     /* 1502753 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1502835), // Rule ID 17777 //
     /* 1502758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502797 */     // MIs[0] round
     /* 1502797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502800 */     // MIs[0] policy
     /* 1502800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502810 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502834 */     // GIR_Coverage, 17777,
     /* 1502834 */     GIR_EraseRootFromParent_Done,
     /* 1502835 */   // Label 20946: @1502835
     /* 1502835 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1502917), // Rule ID 17780 //
     /* 1502840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502879 */     // MIs[0] round
     /* 1502879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502882 */     // MIs[0] policy
     /* 1502882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502892 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502916 */     // GIR_Coverage, 17780,
     /* 1502916 */     GIR_EraseRootFromParent_Done,
     /* 1502917 */   // Label 20947: @1502917
     /* 1502917 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1502999), // Rule ID 17781 //
     /* 1502922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502961 */     // MIs[0] round
     /* 1502961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502964 */     // MIs[0] policy
     /* 1502964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502998 */     // GIR_Coverage, 17781,
     /* 1502998 */     GIR_EraseRootFromParent_Done,
     /* 1502999 */   // Label 20948: @1502999
     /* 1502999 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1503081), // Rule ID 17784 //
     /* 1503004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503043 */     // MIs[0] round
     /* 1503043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503046 */     // MIs[0] policy
     /* 1503046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503056 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1503059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503080 */     // GIR_Coverage, 17784,
     /* 1503080 */     GIR_EraseRootFromParent_Done,
     /* 1503081 */   // Label 20949: @1503081
     /* 1503081 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1503163), // Rule ID 17785 //
     /* 1503086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1503103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503125 */     // MIs[0] round
     /* 1503125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503128 */     // MIs[0] policy
     /* 1503128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503138 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1503141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503162 */     // GIR_Coverage, 17785,
     /* 1503162 */     GIR_EraseRootFromParent_Done,
     /* 1503163 */   // Label 20950: @1503163
     /* 1503163 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1503245), // Rule ID 17788 //
     /* 1503168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503207 */     // MIs[0] round
     /* 1503207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503210 */     // MIs[0] policy
     /* 1503210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503220 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1503223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503244 */     // GIR_Coverage, 17788,
     /* 1503244 */     GIR_EraseRootFromParent_Done,
     /* 1503245 */   // Label 20951: @1503245
     /* 1503245 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1503327), // Rule ID 17789 //
     /* 1503250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1503267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503289 */     // MIs[0] round
     /* 1503289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503292 */     // MIs[0] policy
     /* 1503292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503302 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1503305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503326 */     // GIR_Coverage, 17789,
     /* 1503326 */     GIR_EraseRootFromParent_Done,
     /* 1503327 */   // Label 20952: @1503327
     /* 1503327 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1503409), // Rule ID 17792 //
     /* 1503332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503371 */     // MIs[0] round
     /* 1503371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503374 */     // MIs[0] policy
     /* 1503374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503384 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503408 */     // GIR_Coverage, 17792,
     /* 1503408 */     GIR_EraseRootFromParent_Done,
     /* 1503409 */   // Label 20953: @1503409
     /* 1503409 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1503491), // Rule ID 17793 //
     /* 1503414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1503431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503453 */     // MIs[0] round
     /* 1503453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503456 */     // MIs[0] policy
     /* 1503456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503466 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503490 */     // GIR_Coverage, 17793,
     /* 1503490 */     GIR_EraseRootFromParent_Done,
     /* 1503491 */   // Label 20954: @1503491
     /* 1503491 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1503573), // Rule ID 17796 //
     /* 1503496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503535 */     // MIs[0] round
     /* 1503535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503538 */     // MIs[0] policy
     /* 1503538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503548 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503572 */     // GIR_Coverage, 17796,
     /* 1503572 */     GIR_EraseRootFromParent_Done,
     /* 1503573 */   // Label 20955: @1503573
     /* 1503573 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1503655), // Rule ID 17797 //
     /* 1503578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503617 */     // MIs[0] round
     /* 1503617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503620 */     // MIs[0] policy
     /* 1503620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503630 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503654 */     // GIR_Coverage, 17797,
     /* 1503654 */     GIR_EraseRootFromParent_Done,
     /* 1503655 */   // Label 20956: @1503655
     /* 1503655 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1503737), // Rule ID 17800 //
     /* 1503660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503699 */     // MIs[0] round
     /* 1503699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503702 */     // MIs[0] policy
     /* 1503702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503712 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503736 */     // GIR_Coverage, 17800,
     /* 1503736 */     GIR_EraseRootFromParent_Done,
     /* 1503737 */   // Label 20957: @1503737
     /* 1503737 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1503819), // Rule ID 17801 //
     /* 1503742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503781 */     // MIs[0] round
     /* 1503781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503784 */     // MIs[0] policy
     /* 1503784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503794 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503818 */     // GIR_Coverage, 17801,
     /* 1503818 */     GIR_EraseRootFromParent_Done,
     /* 1503819 */   // Label 20958: @1503819
     /* 1503819 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1503901), // Rule ID 17804 //
     /* 1503824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503863 */     // MIs[0] round
     /* 1503863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503866 */     // MIs[0] policy
     /* 1503866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503876 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503900 */     // GIR_Coverage, 17804,
     /* 1503900 */     GIR_EraseRootFromParent_Done,
     /* 1503901 */   // Label 20959: @1503901
     /* 1503901 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1503983), // Rule ID 17805 //
     /* 1503906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503945 */     // MIs[0] round
     /* 1503945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503948 */     // MIs[0] policy
     /* 1503948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503958 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503982 */     // GIR_Coverage, 17805,
     /* 1503982 */     GIR_EraseRootFromParent_Done,
     /* 1503983 */   // Label 20960: @1503983
     /* 1503983 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1504065), // Rule ID 17808 //
     /* 1503988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504027 */     // MIs[0] round
     /* 1504027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504030 */     // MIs[0] policy
     /* 1504030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504040 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1504043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504064 */     // GIR_Coverage, 17808,
     /* 1504064 */     GIR_EraseRootFromParent_Done,
     /* 1504065 */   // Label 20961: @1504065
     /* 1504065 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1504147), // Rule ID 17809 //
     /* 1504070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1504087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504109 */     // MIs[0] round
     /* 1504109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504112 */     // MIs[0] policy
     /* 1504112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504122 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1504125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504146 */     // GIR_Coverage, 17809,
     /* 1504146 */     GIR_EraseRootFromParent_Done,
     /* 1504147 */   // Label 20962: @1504147
     /* 1504147 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1504229), // Rule ID 17812 //
     /* 1504152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504191 */     // MIs[0] round
     /* 1504191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504194 */     // MIs[0] policy
     /* 1504194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504204 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1504207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504228 */     // GIR_Coverage, 17812,
     /* 1504228 */     GIR_EraseRootFromParent_Done,
     /* 1504229 */   // Label 20963: @1504229
     /* 1504229 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1504311), // Rule ID 17813 //
     /* 1504234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1504251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504273 */     // MIs[0] round
     /* 1504273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504276 */     // MIs[0] policy
     /* 1504276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1504289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504310 */     // GIR_Coverage, 17813,
     /* 1504310 */     GIR_EraseRootFromParent_Done,
     /* 1504311 */   // Label 20964: @1504311
     /* 1504311 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1504393), // Rule ID 17816 //
     /* 1504316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504355 */     // MIs[0] round
     /* 1504355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504358 */     // MIs[0] policy
     /* 1504358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504368 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1504371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504392 */     // GIR_Coverage, 17816,
     /* 1504392 */     GIR_EraseRootFromParent_Done,
     /* 1504393 */   // Label 20965: @1504393
     /* 1504393 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1504475), // Rule ID 17817 //
     /* 1504398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504437 */     // MIs[0] round
     /* 1504437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504440 */     // MIs[0] policy
     /* 1504440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504450 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1504453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504474 */     // GIR_Coverage, 17817,
     /* 1504474 */     GIR_EraseRootFromParent_Done,
     /* 1504475 */   // Label 20966: @1504475
     /* 1504475 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1504557), // Rule ID 17820 //
     /* 1504480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504519 */     // MIs[0] round
     /* 1504519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504522 */     // MIs[0] policy
     /* 1504522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504532 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504556 */     // GIR_Coverage, 17820,
     /* 1504556 */     GIR_EraseRootFromParent_Done,
     /* 1504557 */   // Label 20967: @1504557
     /* 1504557 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1504639), // Rule ID 17821 //
     /* 1504562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504601 */     // MIs[0] round
     /* 1504601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504604 */     // MIs[0] policy
     /* 1504604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504614 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504638 */     // GIR_Coverage, 17821,
     /* 1504638 */     GIR_EraseRootFromParent_Done,
     /* 1504639 */   // Label 20968: @1504639
     /* 1504639 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1504721), // Rule ID 17824 //
     /* 1504644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504683 */     // MIs[0] round
     /* 1504683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504686 */     // MIs[0] policy
     /* 1504686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504696 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504720 */     // GIR_Coverage, 17824,
     /* 1504720 */     GIR_EraseRootFromParent_Done,
     /* 1504721 */   // Label 20969: @1504721
     /* 1504721 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1504803), // Rule ID 17825 //
     /* 1504726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504765 */     // MIs[0] round
     /* 1504765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504768 */     // MIs[0] policy
     /* 1504768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504778 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504802 */     // GIR_Coverage, 17825,
     /* 1504802 */     GIR_EraseRootFromParent_Done,
     /* 1504803 */   // Label 20970: @1504803
     /* 1504803 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1504885), // Rule ID 17828 //
     /* 1504808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504847 */     // MIs[0] round
     /* 1504847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504850 */     // MIs[0] policy
     /* 1504850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504860 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504884 */     // GIR_Coverage, 17828,
     /* 1504884 */     GIR_EraseRootFromParent_Done,
     /* 1504885 */   // Label 20971: @1504885
     /* 1504885 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1504967), // Rule ID 17829 //
     /* 1504890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504929 */     // MIs[0] round
     /* 1504929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504932 */     // MIs[0] policy
     /* 1504932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504942 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504966 */     // GIR_Coverage, 17829,
     /* 1504966 */     GIR_EraseRootFromParent_Done,
     /* 1504967 */   // Label 20972: @1504967
     /* 1504967 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1505049), // Rule ID 17832 //
     /* 1504972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505011 */     // MIs[0] round
     /* 1505011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505014 */     // MIs[0] policy
     /* 1505014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1505027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505048 */     // GIR_Coverage, 17832,
     /* 1505048 */     GIR_EraseRootFromParent_Done,
     /* 1505049 */   // Label 20973: @1505049
     /* 1505049 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1505131), // Rule ID 17833 //
     /* 1505054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505093 */     // MIs[0] round
     /* 1505093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505096 */     // MIs[0] policy
     /* 1505096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505106 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1505109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505130 */     // GIR_Coverage, 17833,
     /* 1505130 */     GIR_EraseRootFromParent_Done,
     /* 1505131 */   // Label 20974: @1505131
     /* 1505131 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1505213), // Rule ID 17836 //
     /* 1505136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505175 */     // MIs[0] round
     /* 1505175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505178 */     // MIs[0] policy
     /* 1505178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1505191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505212 */     // GIR_Coverage, 17836,
     /* 1505212 */     GIR_EraseRootFromParent_Done,
     /* 1505213 */   // Label 20975: @1505213
     /* 1505213 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1505295), // Rule ID 17837 //
     /* 1505218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1505221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505257 */     // MIs[0] round
     /* 1505257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505260 */     // MIs[0] policy
     /* 1505260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505270 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1505273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505294 */     // GIR_Coverage, 17837,
     /* 1505294 */     GIR_EraseRootFromParent_Done,
     /* 1505295 */   // Label 20976: @1505295
     /* 1505295 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1505377), // Rule ID 17840 //
     /* 1505300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505339 */     // MIs[0] round
     /* 1505339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505342 */     // MIs[0] policy
     /* 1505342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505352 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1505355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505376 */     // GIR_Coverage, 17840,
     /* 1505376 */     GIR_EraseRootFromParent_Done,
     /* 1505377 */   // Label 20977: @1505377
     /* 1505377 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1505459), // Rule ID 17841 //
     /* 1505382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505421 */     // MIs[0] round
     /* 1505421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505424 */     // MIs[0] policy
     /* 1505424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1505437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505458 */     // GIR_Coverage, 17841,
     /* 1505458 */     GIR_EraseRootFromParent_Done,
     /* 1505459 */   // Label 20978: @1505459
     /* 1505459 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1505541), // Rule ID 17844 //
     /* 1505464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505503 */     // MIs[0] round
     /* 1505503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505506 */     // MIs[0] policy
     /* 1505506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505516 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505540 */     // GIR_Coverage, 17844,
     /* 1505540 */     GIR_EraseRootFromParent_Done,
     /* 1505541 */   // Label 20979: @1505541
     /* 1505541 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1505623), // Rule ID 17845 //
     /* 1505546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505585 */     // MIs[0] round
     /* 1505585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505588 */     // MIs[0] policy
     /* 1505588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505598 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505622 */     // GIR_Coverage, 17845,
     /* 1505622 */     GIR_EraseRootFromParent_Done,
     /* 1505623 */   // Label 20980: @1505623
     /* 1505623 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1505705), // Rule ID 17848 //
     /* 1505628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505667 */     // MIs[0] round
     /* 1505667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505670 */     // MIs[0] policy
     /* 1505670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505680 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505704 */     // GIR_Coverage, 17848,
     /* 1505704 */     GIR_EraseRootFromParent_Done,
     /* 1505705 */   // Label 20981: @1505705
     /* 1505705 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1505787), // Rule ID 17849 //
     /* 1505710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505749 */     // MIs[0] round
     /* 1505749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505752 */     // MIs[0] policy
     /* 1505752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505762 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505786 */     // GIR_Coverage, 17849,
     /* 1505786 */     GIR_EraseRootFromParent_Done,
     /* 1505787 */   // Label 20982: @1505787
     /* 1505787 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1505869), // Rule ID 17852 //
     /* 1505792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505831 */     // MIs[0] round
     /* 1505831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505834 */     // MIs[0] policy
     /* 1505834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505868 */     // GIR_Coverage, 17852,
     /* 1505868 */     GIR_EraseRootFromParent_Done,
     /* 1505869 */   // Label 20983: @1505869
     /* 1505869 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1505951), // Rule ID 17853 //
     /* 1505874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505913 */     // MIs[0] round
     /* 1505913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505916 */     // MIs[0] policy
     /* 1505916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505926 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505950 */     // GIR_Coverage, 17853,
     /* 1505950 */     GIR_EraseRootFromParent_Done,
     /* 1505951 */   // Label 20984: @1505951
     /* 1505951 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1506033), // Rule ID 17856 //
     /* 1505956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505995 */     // MIs[0] round
     /* 1505995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505998 */     // MIs[0] policy
     /* 1505998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506008 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1506011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506032 */     // GIR_Coverage, 17856,
     /* 1506032 */     GIR_EraseRootFromParent_Done,
     /* 1506033 */   // Label 20985: @1506033
     /* 1506033 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1506115), // Rule ID 17857 //
     /* 1506038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506077 */     // MIs[0] round
     /* 1506077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506080 */     // MIs[0] policy
     /* 1506080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1506093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506114 */     // GIR_Coverage, 17857,
     /* 1506114 */     GIR_EraseRootFromParent_Done,
     /* 1506115 */   // Label 20986: @1506115
     /* 1506115 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1506197), // Rule ID 17860 //
     /* 1506120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506159 */     // MIs[0] round
     /* 1506159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506162 */     // MIs[0] policy
     /* 1506162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506172 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1506175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506196 */     // GIR_Coverage, 17860,
     /* 1506196 */     GIR_EraseRootFromParent_Done,
     /* 1506197 */   // Label 20987: @1506197
     /* 1506197 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1506279), // Rule ID 17861 //
     /* 1506202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506241 */     // MIs[0] round
     /* 1506241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506244 */     // MIs[0] policy
     /* 1506244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1506257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506278 */     // GIR_Coverage, 17861,
     /* 1506278 */     GIR_EraseRootFromParent_Done,
     /* 1506279 */   // Label 20988: @1506279
     /* 1506279 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1506361), // Rule ID 17864 //
     /* 1506284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506323 */     // MIs[0] round
     /* 1506323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506326 */     // MIs[0] policy
     /* 1506326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1506339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506360 */     // GIR_Coverage, 17864,
     /* 1506360 */     GIR_EraseRootFromParent_Done,
     /* 1506361 */   // Label 20989: @1506361
     /* 1506361 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1506443), // Rule ID 17865 //
     /* 1506366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506405 */     // MIs[0] round
     /* 1506405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506408 */     // MIs[0] policy
     /* 1506408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506418 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1506421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506442 */     // GIR_Coverage, 17865,
     /* 1506442 */     GIR_EraseRootFromParent_Done,
     /* 1506443 */   // Label 20990: @1506443
     /* 1506443 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1506525), // Rule ID 17868 //
     /* 1506448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506487 */     // MIs[0] round
     /* 1506487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506490 */     // MIs[0] policy
     /* 1506490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506524 */     // GIR_Coverage, 17868,
     /* 1506524 */     GIR_EraseRootFromParent_Done,
     /* 1506525 */   // Label 20991: @1506525
     /* 1506525 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1506607), // Rule ID 17869 //
     /* 1506530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506569 */     // MIs[0] round
     /* 1506569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506572 */     // MIs[0] policy
     /* 1506572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506582 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506606 */     // GIR_Coverage, 17869,
     /* 1506606 */     GIR_EraseRootFromParent_Done,
     /* 1506607 */   // Label 20992: @1506607
     /* 1506607 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1506689), // Rule ID 17872 //
     /* 1506612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506651 */     // MIs[0] round
     /* 1506651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506654 */     // MIs[0] policy
     /* 1506654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506688 */     // GIR_Coverage, 17872,
     /* 1506688 */     GIR_EraseRootFromParent_Done,
     /* 1506689 */   // Label 20993: @1506689
     /* 1506689 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1506771), // Rule ID 17873 //
     /* 1506694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506733 */     // MIs[0] round
     /* 1506733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506736 */     // MIs[0] policy
     /* 1506736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506746 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506770 */     // GIR_Coverage, 17873,
     /* 1506770 */     GIR_EraseRootFromParent_Done,
     /* 1506771 */   // Label 20994: @1506771
     /* 1506771 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1506853), // Rule ID 17876 //
     /* 1506776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506815 */     // MIs[0] round
     /* 1506815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506818 */     // MIs[0] policy
     /* 1506818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506828 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506852 */     // GIR_Coverage, 17876,
     /* 1506852 */     GIR_EraseRootFromParent_Done,
     /* 1506853 */   // Label 20995: @1506853
     /* 1506853 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1506935), // Rule ID 17877 //
     /* 1506858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506897 */     // MIs[0] round
     /* 1506897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506900 */     // MIs[0] policy
     /* 1506900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506910 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506934 */     // GIR_Coverage, 17877,
     /* 1506934 */     GIR_EraseRootFromParent_Done,
     /* 1506935 */   // Label 20996: @1506935
     /* 1506935 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1507017), // Rule ID 17880 //
     /* 1506940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506979 */     // MIs[0] round
     /* 1506979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506982 */     // MIs[0] policy
     /* 1506982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506992 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1506995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507016 */     // GIR_Coverage, 17880,
     /* 1507016 */     GIR_EraseRootFromParent_Done,
     /* 1507017 */   // Label 20997: @1507017
     /* 1507017 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1507099), // Rule ID 17881 //
     /* 1507022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1507039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507061 */     // MIs[0] round
     /* 1507061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507064 */     // MIs[0] policy
     /* 1507064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507074 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1507077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507098 */     // GIR_Coverage, 17881,
     /* 1507098 */     GIR_EraseRootFromParent_Done,
     /* 1507099 */   // Label 20998: @1507099
     /* 1507099 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1507181), // Rule ID 17884 //
     /* 1507104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1507121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507143 */     // MIs[0] round
     /* 1507143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507146 */     // MIs[0] policy
     /* 1507146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1507159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507180 */     // GIR_Coverage, 17884,
     /* 1507180 */     GIR_EraseRootFromParent_Done,
     /* 1507181 */   // Label 20999: @1507181
     /* 1507181 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1507263), // Rule ID 17885 //
     /* 1507186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1507203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507225 */     // MIs[0] round
     /* 1507225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507228 */     // MIs[0] policy
     /* 1507228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507238 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1507241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507262 */     // GIR_Coverage, 17885,
     /* 1507262 */     GIR_EraseRootFromParent_Done,
     /* 1507263 */   // Label 21000: @1507263
     /* 1507263 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1507345), // Rule ID 17888 //
     /* 1507268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1507285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507307 */     // MIs[0] round
     /* 1507307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507310 */     // MIs[0] policy
     /* 1507310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507320 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1507323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507344 */     // GIR_Coverage, 17888,
     /* 1507344 */     GIR_EraseRootFromParent_Done,
     /* 1507345 */   // Label 21001: @1507345
     /* 1507345 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1507427), // Rule ID 17889 //
     /* 1507350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1507367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507389 */     // MIs[0] round
     /* 1507389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507392 */     // MIs[0] policy
     /* 1507392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507402 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1507405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507426 */     // GIR_Coverage, 17889,
     /* 1507426 */     GIR_EraseRootFromParent_Done,
     /* 1507427 */   // Label 21002: @1507427
     /* 1507427 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1507509), // Rule ID 17892 //
     /* 1507432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507471 */     // MIs[0] round
     /* 1507471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507474 */     // MIs[0] policy
     /* 1507474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507508 */     // GIR_Coverage, 17892,
     /* 1507508 */     GIR_EraseRootFromParent_Done,
     /* 1507509 */   // Label 21003: @1507509
     /* 1507509 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1507591), // Rule ID 17893 //
     /* 1507514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507553 */     // MIs[0] round
     /* 1507553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507556 */     // MIs[0] policy
     /* 1507556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507566 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507590 */     // GIR_Coverage, 17893,
     /* 1507590 */     GIR_EraseRootFromParent_Done,
     /* 1507591 */   // Label 21004: @1507591
     /* 1507591 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1507673), // Rule ID 17896 //
     /* 1507596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507635 */     // MIs[0] round
     /* 1507635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507638 */     // MIs[0] policy
     /* 1507638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507648 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507672 */     // GIR_Coverage, 17896,
     /* 1507672 */     GIR_EraseRootFromParent_Done,
     /* 1507673 */   // Label 21005: @1507673
     /* 1507673 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1507755), // Rule ID 17897 //
     /* 1507678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507717 */     // MIs[0] round
     /* 1507717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507720 */     // MIs[0] policy
     /* 1507720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507754 */     // GIR_Coverage, 17897,
     /* 1507754 */     GIR_EraseRootFromParent_Done,
     /* 1507755 */   // Label 21006: @1507755
     /* 1507755 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1507837), // Rule ID 17900 //
     /* 1507760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507799 */     // MIs[0] round
     /* 1507799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507802 */     // MIs[0] policy
     /* 1507802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507812 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507836 */     // GIR_Coverage, 17900,
     /* 1507836 */     GIR_EraseRootFromParent_Done,
     /* 1507837 */   // Label 21007: @1507837
     /* 1507837 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1507919), // Rule ID 17901 //
     /* 1507842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507881 */     // MIs[0] round
     /* 1507881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507884 */     // MIs[0] policy
     /* 1507884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507894 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507918 */     // GIR_Coverage, 17901,
     /* 1507918 */     GIR_EraseRootFromParent_Done,
     /* 1507919 */   // Label 21008: @1507919
     /* 1507919 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1508001), // Rule ID 17904 //
     /* 1507924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507963 */     // MIs[0] round
     /* 1507963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507966 */     // MIs[0] policy
     /* 1507966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507976 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508000 */     // GIR_Coverage, 17904,
     /* 1508000 */     GIR_EraseRootFromParent_Done,
     /* 1508001 */   // Label 21009: @1508001
     /* 1508001 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1508083), // Rule ID 17905 //
     /* 1508006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1508023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508045 */     // MIs[0] round
     /* 1508045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508048 */     // MIs[0] policy
     /* 1508048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508058 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1508061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508082 */     // GIR_Coverage, 17905,
     /* 1508082 */     GIR_EraseRootFromParent_Done,
     /* 1508083 */   // Label 21010: @1508083
     /* 1508083 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1508165), // Rule ID 17908 //
     /* 1508088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1508105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508127 */     // MIs[0] round
     /* 1508127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508130 */     // MIs[0] policy
     /* 1508130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508140 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1508143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508164 */     // GIR_Coverage, 17908,
     /* 1508164 */     GIR_EraseRootFromParent_Done,
     /* 1508165 */   // Label 21011: @1508165
     /* 1508165 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1508247), // Rule ID 17909 //
     /* 1508170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1508187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508209 */     // MIs[0] round
     /* 1508209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508212 */     // MIs[0] policy
     /* 1508212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508222 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1508225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508246 */     // GIR_Coverage, 17909,
     /* 1508246 */     GIR_EraseRootFromParent_Done,
     /* 1508247 */   // Label 21012: @1508247
     /* 1508247 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1508329), // Rule ID 17912 //
     /* 1508252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1508269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508291 */     // MIs[0] round
     /* 1508291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508294 */     // MIs[0] policy
     /* 1508294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1508307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508328 */     // GIR_Coverage, 17912,
     /* 1508328 */     GIR_EraseRootFromParent_Done,
     /* 1508329 */   // Label 21013: @1508329
     /* 1508329 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1508411), // Rule ID 17913 //
     /* 1508334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1508351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508373 */     // MIs[0] round
     /* 1508373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508376 */     // MIs[0] policy
     /* 1508376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508386 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1508389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508410 */     // GIR_Coverage, 17913,
     /* 1508410 */     GIR_EraseRootFromParent_Done,
     /* 1508411 */   // Label 21014: @1508411
     /* 1508411 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1508493), // Rule ID 17916 //
     /* 1508416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508455 */     // MIs[0] round
     /* 1508455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508458 */     // MIs[0] policy
     /* 1508458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508492 */     // GIR_Coverage, 17916,
     /* 1508492 */     GIR_EraseRootFromParent_Done,
     /* 1508493 */   // Label 21015: @1508493
     /* 1508493 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1508575), // Rule ID 17917 //
     /* 1508498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508537 */     // MIs[0] round
     /* 1508537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508540 */     // MIs[0] policy
     /* 1508540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508550 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508574 */     // GIR_Coverage, 17917,
     /* 1508574 */     GIR_EraseRootFromParent_Done,
     /* 1508575 */   // Label 21016: @1508575
     /* 1508575 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1508657), // Rule ID 17920 //
     /* 1508580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508619 */     // MIs[0] round
     /* 1508619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508622 */     // MIs[0] policy
     /* 1508622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508632 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508656 */     // GIR_Coverage, 17920,
     /* 1508656 */     GIR_EraseRootFromParent_Done,
     /* 1508657 */   // Label 21017: @1508657
     /* 1508657 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1508739), // Rule ID 17921 //
     /* 1508662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508701 */     // MIs[0] round
     /* 1508701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508704 */     // MIs[0] policy
     /* 1508704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508714 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508738 */     // GIR_Coverage, 17921,
     /* 1508738 */     GIR_EraseRootFromParent_Done,
     /* 1508739 */   // Label 21018: @1508739
     /* 1508739 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1508821), // Rule ID 17924 //
     /* 1508744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508783 */     // MIs[0] round
     /* 1508783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508786 */     // MIs[0] policy
     /* 1508786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508820 */     // GIR_Coverage, 17924,
     /* 1508820 */     GIR_EraseRootFromParent_Done,
     /* 1508821 */   // Label 21019: @1508821
     /* 1508821 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1508903), // Rule ID 17925 //
     /* 1508826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508865 */     // MIs[0] round
     /* 1508865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508868 */     // MIs[0] policy
     /* 1508868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508902 */     // GIR_Coverage, 17925,
     /* 1508902 */     GIR_EraseRootFromParent_Done,
     /* 1508903 */   // Label 21020: @1508903
     /* 1508903 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1508985), // Rule ID 17928 //
     /* 1508908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508947 */     // MIs[0] round
     /* 1508947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508950 */     // MIs[0] policy
     /* 1508950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508960 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508984 */     // GIR_Coverage, 17928,
     /* 1508984 */     GIR_EraseRootFromParent_Done,
     /* 1508985 */   // Label 21021: @1508985
     /* 1508985 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1509067), // Rule ID 17929 //
     /* 1508990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1509007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509029 */     // MIs[0] round
     /* 1509029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509032 */     // MIs[0] policy
     /* 1509032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509042 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1509045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509066 */     // GIR_Coverage, 17929,
     /* 1509066 */     GIR_EraseRootFromParent_Done,
     /* 1509067 */   // Label 21022: @1509067
     /* 1509067 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1509149), // Rule ID 17932 //
     /* 1509072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1509089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509111 */     // MIs[0] round
     /* 1509111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509114 */     // MIs[0] policy
     /* 1509114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1509127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509148 */     // GIR_Coverage, 17932,
     /* 1509148 */     GIR_EraseRootFromParent_Done,
     /* 1509149 */   // Label 21023: @1509149
     /* 1509149 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1509231), // Rule ID 17933 //
     /* 1509154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1509171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509193 */     // MIs[0] round
     /* 1509193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509196 */     // MIs[0] policy
     /* 1509196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509206 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1509209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509230 */     // GIR_Coverage, 17933,
     /* 1509230 */     GIR_EraseRootFromParent_Done,
     /* 1509231 */   // Label 21024: @1509231
     /* 1509231 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1509313), // Rule ID 17936 //
     /* 1509236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509275 */     // MIs[0] round
     /* 1509275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509278 */     // MIs[0] policy
     /* 1509278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509288 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1509291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509312 */     // GIR_Coverage, 17936,
     /* 1509312 */     GIR_EraseRootFromParent_Done,
     /* 1509313 */   // Label 21025: @1509313
     /* 1509313 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1509395), // Rule ID 17937 //
     /* 1509318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509357 */     // MIs[0] round
     /* 1509357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509360 */     // MIs[0] policy
     /* 1509360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509370 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1509373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509394 */     // GIR_Coverage, 17937,
     /* 1509394 */     GIR_EraseRootFromParent_Done,
     /* 1509395 */   // Label 21026: @1509395
     /* 1509395 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1509477), // Rule ID 17940 //
     /* 1509400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509439 */     // MIs[0] round
     /* 1509439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509442 */     // MIs[0] policy
     /* 1509442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509452 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509476 */     // GIR_Coverage, 17940,
     /* 1509476 */     GIR_EraseRootFromParent_Done,
     /* 1509477 */   // Label 21027: @1509477
     /* 1509477 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1509559), // Rule ID 17941 //
     /* 1509482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509521 */     // MIs[0] round
     /* 1509521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509524 */     // MIs[0] policy
     /* 1509524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509534 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509558 */     // GIR_Coverage, 17941,
     /* 1509558 */     GIR_EraseRootFromParent_Done,
     /* 1509559 */   // Label 21028: @1509559
     /* 1509559 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1509641), // Rule ID 17944 //
     /* 1509564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509603 */     // MIs[0] round
     /* 1509603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509606 */     // MIs[0] policy
     /* 1509606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509616 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509640 */     // GIR_Coverage, 17944,
     /* 1509640 */     GIR_EraseRootFromParent_Done,
     /* 1509641 */   // Label 21029: @1509641
     /* 1509641 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1509723), // Rule ID 17945 //
     /* 1509646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509685 */     // MIs[0] round
     /* 1509685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509688 */     // MIs[0] policy
     /* 1509688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509698 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509722 */     // GIR_Coverage, 17945,
     /* 1509722 */     GIR_EraseRootFromParent_Done,
     /* 1509723 */   // Label 21030: @1509723
     /* 1509723 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1509805), // Rule ID 17948 //
     /* 1509728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509767 */     // MIs[0] round
     /* 1509767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509770 */     // MIs[0] policy
     /* 1509770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509780 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509804 */     // GIR_Coverage, 17948,
     /* 1509804 */     GIR_EraseRootFromParent_Done,
     /* 1509805 */   // Label 21031: @1509805
     /* 1509805 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1509887), // Rule ID 17949 //
     /* 1509810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509849 */     // MIs[0] round
     /* 1509849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509852 */     // MIs[0] policy
     /* 1509852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509862 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11297:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509886 */     // GIR_Coverage, 17949,
     /* 1509886 */     GIR_EraseRootFromParent_Done,
     /* 1509887 */   // Label 21032: @1509887
     /* 1509887 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1509969), // Rule ID 17952 //
     /* 1509892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509931 */     // MIs[0] round
     /* 1509931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509934 */     // MIs[0] policy
     /* 1509934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509968 */     // GIR_Coverage, 17952,
     /* 1509968 */     GIR_EraseRootFromParent_Done,
     /* 1509969 */   // Label 21033: @1509969
     /* 1509969 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1510051), // Rule ID 17953 //
     /* 1509974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510013 */     // MIs[0] round
     /* 1510013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510016 */     // MIs[0] policy
     /* 1510016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510026 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11297:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1510029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510050 */     // GIR_Coverage, 17953,
     /* 1510050 */     GIR_EraseRootFromParent_Done,
     /* 1510051 */   // Label 21034: @1510051
     /* 1510051 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1510133), // Rule ID 17956 //
     /* 1510056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510095 */     // MIs[0] round
     /* 1510095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510098 */     // MIs[0] policy
     /* 1510098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510108 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1510111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510132 */     // GIR_Coverage, 17956,
     /* 1510132 */     GIR_EraseRootFromParent_Done,
     /* 1510133 */   // Label 21035: @1510133
     /* 1510133 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1510215), // Rule ID 17957 //
     /* 1510138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510177 */     // MIs[0] round
     /* 1510177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510180 */     // MIs[0] policy
     /* 1510180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510190 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11297:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1510193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510214 */     // GIR_Coverage, 17957,
     /* 1510214 */     GIR_EraseRootFromParent_Done,
     /* 1510215 */   // Label 21036: @1510215
     /* 1510215 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1510297), // Rule ID 17960 //
     /* 1510220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510259 */     // MIs[0] round
     /* 1510259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510262 */     // MIs[0] policy
     /* 1510262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510272 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1510275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510296 */     // GIR_Coverage, 17960,
     /* 1510296 */     GIR_EraseRootFromParent_Done,
     /* 1510297 */   // Label 21037: @1510297
     /* 1510297 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1510379), // Rule ID 17961 //
     /* 1510302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510341 */     // MIs[0] round
     /* 1510341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510344 */     // MIs[0] policy
     /* 1510344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1510357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510378 */     // GIR_Coverage, 17961,
     /* 1510378 */     GIR_EraseRootFromParent_Done,
     /* 1510379 */   // Label 21038: @1510379
     /* 1510379 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1510461), // Rule ID 17964 //
     /* 1510384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510423 */     // MIs[0] round
     /* 1510423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510426 */     // MIs[0] policy
     /* 1510426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510436 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510460 */     // GIR_Coverage, 17964,
     /* 1510460 */     GIR_EraseRootFromParent_Done,
     /* 1510461 */   // Label 21039: @1510461
     /* 1510461 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1510543), // Rule ID 17965 //
     /* 1510466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510505 */     // MIs[0] round
     /* 1510505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510508 */     // MIs[0] policy
     /* 1510508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510518 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510542 */     // GIR_Coverage, 17965,
     /* 1510542 */     GIR_EraseRootFromParent_Done,
     /* 1510543 */   // Label 21040: @1510543
     /* 1510543 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1510625), // Rule ID 17968 //
     /* 1510548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510587 */     // MIs[0] round
     /* 1510587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510590 */     // MIs[0] policy
     /* 1510590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510600 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510624 */     // GIR_Coverage, 17968,
     /* 1510624 */     GIR_EraseRootFromParent_Done,
     /* 1510625 */   // Label 21041: @1510625
     /* 1510625 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1510707), // Rule ID 17969 //
     /* 1510630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510669 */     // MIs[0] round
     /* 1510669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510672 */     // MIs[0] policy
     /* 1510672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510682 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510706 */     // GIR_Coverage, 17969,
     /* 1510706 */     GIR_EraseRootFromParent_Done,
     /* 1510707 */   // Label 21042: @1510707
     /* 1510707 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1510789), // Rule ID 17972 //
     /* 1510712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510751 */     // MIs[0] round
     /* 1510751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510754 */     // MIs[0] policy
     /* 1510754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510788 */     // GIR_Coverage, 17972,
     /* 1510788 */     GIR_EraseRootFromParent_Done,
     /* 1510789 */   // Label 21043: @1510789
     /* 1510789 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1510871), // Rule ID 17973 //
     /* 1510794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510833 */     // MIs[0] round
     /* 1510833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510836 */     // MIs[0] policy
     /* 1510836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510846 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510870 */     // GIR_Coverage, 17973,
     /* 1510870 */     GIR_EraseRootFromParent_Done,
     /* 1510871 */   // Label 21044: @1510871
     /* 1510871 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1510953), // Rule ID 17976 //
     /* 1510876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510915 */     // MIs[0] round
     /* 1510915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510918 */     // MIs[0] policy
     /* 1510918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510928 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510952 */     // GIR_Coverage, 17976,
     /* 1510952 */     GIR_EraseRootFromParent_Done,
     /* 1510953 */   // Label 21045: @1510953
     /* 1510953 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1511035), // Rule ID 17977 //
     /* 1510958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510997 */     // MIs[0] round
     /* 1510997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511000 */     // MIs[0] policy
     /* 1511000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511010 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1511013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511034 */     // GIR_Coverage, 17977,
     /* 1511034 */     GIR_EraseRootFromParent_Done,
     /* 1511035 */   // Label 21046: @1511035
     /* 1511035 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1511117), // Rule ID 17980 //
     /* 1511040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511079 */     // MIs[0] round
     /* 1511079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511082 */     // MIs[0] policy
     /* 1511082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1511095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511116 */     // GIR_Coverage, 17980,
     /* 1511116 */     GIR_EraseRootFromParent_Done,
     /* 1511117 */   // Label 21047: @1511117
     /* 1511117 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1511199), // Rule ID 17981 //
     /* 1511122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511161 */     // MIs[0] round
     /* 1511161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511164 */     // MIs[0] policy
     /* 1511164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1511177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511198 */     // GIR_Coverage, 17981,
     /* 1511198 */     GIR_EraseRootFromParent_Done,
     /* 1511199 */   // Label 21048: @1511199
     /* 1511199 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1511281), // Rule ID 17984 //
     /* 1511204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511243 */     // MIs[0] round
     /* 1511243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511246 */     // MIs[0] policy
     /* 1511246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1511259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511280 */     // GIR_Coverage, 17984,
     /* 1511280 */     GIR_EraseRootFromParent_Done,
     /* 1511281 */   // Label 21049: @1511281
     /* 1511281 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1511363), // Rule ID 17985 //
     /* 1511286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511325 */     // MIs[0] round
     /* 1511325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511328 */     // MIs[0] policy
     /* 1511328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511338 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11297:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1511341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511362 */     // GIR_Coverage, 17985,
     /* 1511362 */     GIR_EraseRootFromParent_Done,
     /* 1511363 */   // Label 21050: @1511363
     /* 1511363 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1511445), // Rule ID 17988 //
     /* 1511368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511407 */     // MIs[0] round
     /* 1511407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511410 */     // MIs[0] policy
     /* 1511410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511420 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511444 */     // GIR_Coverage, 17988,
     /* 1511444 */     GIR_EraseRootFromParent_Done,
     /* 1511445 */   // Label 21051: @1511445
     /* 1511445 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1511527), // Rule ID 17989 //
     /* 1511450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511489 */     // MIs[0] round
     /* 1511489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511492 */     // MIs[0] policy
     /* 1511492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511502 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11297:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511526 */     // GIR_Coverage, 17989,
     /* 1511526 */     GIR_EraseRootFromParent_Done,
     /* 1511527 */   // Label 21052: @1511527
     /* 1511527 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1511609), // Rule ID 17992 //
     /* 1511532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511571 */     // MIs[0] round
     /* 1511571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511574 */     // MIs[0] policy
     /* 1511574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511584 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511608 */     // GIR_Coverage, 17992,
     /* 1511608 */     GIR_EraseRootFromParent_Done,
     /* 1511609 */   // Label 21053: @1511609
     /* 1511609 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1511691), // Rule ID 17993 //
     /* 1511614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511653 */     // MIs[0] round
     /* 1511653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511656 */     // MIs[0] policy
     /* 1511656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511666 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11297:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511690 */     // GIR_Coverage, 17993,
     /* 1511690 */     GIR_EraseRootFromParent_Done,
     /* 1511691 */   // Label 21054: @1511691
     /* 1511691 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1511773), // Rule ID 17996 //
     /* 1511696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511735 */     // MIs[0] round
     /* 1511735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511738 */     // MIs[0] policy
     /* 1511738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511748 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511772 */     // GIR_Coverage, 17996,
     /* 1511772 */     GIR_EraseRootFromParent_Done,
     /* 1511773 */   // Label 21055: @1511773
     /* 1511773 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1511855), // Rule ID 17997 //
     /* 1511778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511817 */     // MIs[0] round
     /* 1511817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511820 */     // MIs[0] policy
     /* 1511820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511830 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511854 */     // GIR_Coverage, 17997,
     /* 1511854 */     GIR_EraseRootFromParent_Done,
     /* 1511855 */   // Label 21056: @1511855
     /* 1511855 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1511937), // Rule ID 18000 //
     /* 1511860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511899 */     // MIs[0] round
     /* 1511899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511902 */     // MIs[0] policy
     /* 1511902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511912 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511936 */     // GIR_Coverage, 18000,
     /* 1511936 */     GIR_EraseRootFromParent_Done,
     /* 1511937 */   // Label 21057: @1511937
     /* 1511937 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1512019), // Rule ID 18001 //
     /* 1511942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511981 */     // MIs[0] round
     /* 1511981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511984 */     // MIs[0] policy
     /* 1511984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511994 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512018 */     // GIR_Coverage, 18001,
     /* 1512018 */     GIR_EraseRootFromParent_Done,
     /* 1512019 */   // Label 21058: @1512019
     /* 1512019 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1512101), // Rule ID 18004 //
     /* 1512024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1512041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512063 */     // MIs[0] round
     /* 1512063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512066 */     // MIs[0] policy
     /* 1512066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512076 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1512079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512100 */     // GIR_Coverage, 18004,
     /* 1512100 */     GIR_EraseRootFromParent_Done,
     /* 1512101 */   // Label 21059: @1512101
     /* 1512101 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1512183), // Rule ID 18005 //
     /* 1512106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1512123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512145 */     // MIs[0] round
     /* 1512145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512148 */     // MIs[0] policy
     /* 1512148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512158 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1512161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512182 */     // GIR_Coverage, 18005,
     /* 1512182 */     GIR_EraseRootFromParent_Done,
     /* 1512183 */   // Label 21060: @1512183
     /* 1512183 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1512265), // Rule ID 18008 //
     /* 1512188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1512205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512227 */     // MIs[0] round
     /* 1512227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512230 */     // MIs[0] policy
     /* 1512230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512240 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1512243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512264 */     // GIR_Coverage, 18008,
     /* 1512264 */     GIR_EraseRootFromParent_Done,
     /* 1512265 */   // Label 21061: @1512265
     /* 1512265 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1512347), // Rule ID 18009 //
     /* 1512270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1512287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512309 */     // MIs[0] round
     /* 1512309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512312 */     // MIs[0] policy
     /* 1512312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512322 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1512325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512346 */     // GIR_Coverage, 18009,
     /* 1512346 */     GIR_EraseRootFromParent_Done,
     /* 1512347 */   // Label 21062: @1512347
     /* 1512347 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1512429), // Rule ID 18012 //
     /* 1512352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1512369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512391 */     // MIs[0] round
     /* 1512391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512394 */     // MIs[0] policy
     /* 1512394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512428 */     // GIR_Coverage, 18012,
     /* 1512428 */     GIR_EraseRootFromParent_Done,
     /* 1512429 */   // Label 21063: @1512429
     /* 1512429 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1512511), // Rule ID 18013 //
     /* 1512434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1512451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512473 */     // MIs[0] round
     /* 1512473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512476 */     // MIs[0] policy
     /* 1512476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512486 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512510 */     // GIR_Coverage, 18013,
     /* 1512510 */     GIR_EraseRootFromParent_Done,
     /* 1512511 */   // Label 21064: @1512511
     /* 1512511 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1512593), // Rule ID 18016 //
     /* 1512516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512555 */     // MIs[0] round
     /* 1512555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512558 */     // MIs[0] policy
     /* 1512558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512568 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512592 */     // GIR_Coverage, 18016,
     /* 1512592 */     GIR_EraseRootFromParent_Done,
     /* 1512593 */   // Label 21065: @1512593
     /* 1512593 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1512675), // Rule ID 18017 //
     /* 1512598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512637 */     // MIs[0] round
     /* 1512637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512640 */     // MIs[0] policy
     /* 1512640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512674 */     // GIR_Coverage, 18017,
     /* 1512674 */     GIR_EraseRootFromParent_Done,
     /* 1512675 */   // Label 21066: @1512675
     /* 1512675 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1512757), // Rule ID 18020 //
     /* 1512680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512719 */     // MIs[0] round
     /* 1512719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512722 */     // MIs[0] policy
     /* 1512722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512756 */     // GIR_Coverage, 18020,
     /* 1512756 */     GIR_EraseRootFromParent_Done,
     /* 1512757 */   // Label 21067: @1512757
     /* 1512757 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1512839), // Rule ID 18021 //
     /* 1512762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512801 */     // MIs[0] round
     /* 1512801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512804 */     // MIs[0] policy
     /* 1512804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512814 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512838 */     // GIR_Coverage, 18021,
     /* 1512838 */     GIR_EraseRootFromParent_Done,
     /* 1512839 */   // Label 21068: @1512839
     /* 1512839 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1512921), // Rule ID 18024 //
     /* 1512844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512883 */     // MIs[0] round
     /* 1512883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512886 */     // MIs[0] policy
     /* 1512886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512896 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512920 */     // GIR_Coverage, 18024,
     /* 1512920 */     GIR_EraseRootFromParent_Done,
     /* 1512921 */   // Label 21069: @1512921
     /* 1512921 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1513003), // Rule ID 18025 //
     /* 1512926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512965 */     // MIs[0] round
     /* 1512965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512968 */     // MIs[0] policy
     /* 1512968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512978 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513002 */     // GIR_Coverage, 18025,
     /* 1513002 */     GIR_EraseRootFromParent_Done,
     /* 1513003 */   // Label 21070: @1513003
     /* 1513003 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1513085), // Rule ID 18028 //
     /* 1513008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1513025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513047 */     // MIs[0] round
     /* 1513047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513050 */     // MIs[0] policy
     /* 1513050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513060 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1513063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513084 */     // GIR_Coverage, 18028,
     /* 1513084 */     GIR_EraseRootFromParent_Done,
     /* 1513085 */   // Label 21071: @1513085
     /* 1513085 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1513167), // Rule ID 18029 //
     /* 1513090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1513107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513129 */     // MIs[0] round
     /* 1513129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513132 */     // MIs[0] policy
     /* 1513132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513142 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1513145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513166 */     // GIR_Coverage, 18029,
     /* 1513166 */     GIR_EraseRootFromParent_Done,
     /* 1513167 */   // Label 21072: @1513167
     /* 1513167 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1513249), // Rule ID 18032 //
     /* 1513172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1513189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513211 */     // MIs[0] round
     /* 1513211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513214 */     // MIs[0] policy
     /* 1513214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1513227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513248 */     // GIR_Coverage, 18032,
     /* 1513248 */     GIR_EraseRootFromParent_Done,
     /* 1513249 */   // Label 21073: @1513249
     /* 1513249 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1513331), // Rule ID 18033 //
     /* 1513254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1513271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513293 */     // MIs[0] round
     /* 1513293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513296 */     // MIs[0] policy
     /* 1513296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1513309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513330 */     // GIR_Coverage, 18033,
     /* 1513330 */     GIR_EraseRootFromParent_Done,
     /* 1513331 */   // Label 21074: @1513331
     /* 1513331 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1513413), // Rule ID 18036 //
     /* 1513336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1513353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513375 */     // MIs[0] round
     /* 1513375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513378 */     // MIs[0] policy
     /* 1513378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513388 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513412 */     // GIR_Coverage, 18036,
     /* 1513412 */     GIR_EraseRootFromParent_Done,
     /* 1513413 */   // Label 21075: @1513413
     /* 1513413 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1513495), // Rule ID 18037 //
     /* 1513418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1513435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513457 */     // MIs[0] round
     /* 1513457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513460 */     // MIs[0] policy
     /* 1513460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513470 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513494 */     // GIR_Coverage, 18037,
     /* 1513494 */     GIR_EraseRootFromParent_Done,
     /* 1513495 */   // Label 21076: @1513495
     /* 1513495 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1513577), // Rule ID 18040 //
     /* 1513500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513539 */     // MIs[0] round
     /* 1513539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513542 */     // MIs[0] policy
     /* 1513542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513576 */     // GIR_Coverage, 18040,
     /* 1513576 */     GIR_EraseRootFromParent_Done,
     /* 1513577 */   // Label 21077: @1513577
     /* 1513577 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1513659), // Rule ID 18041 //
     /* 1513582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513621 */     // MIs[0] round
     /* 1513621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513624 */     // MIs[0] policy
     /* 1513624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513634 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513658 */     // GIR_Coverage, 18041,
     /* 1513658 */     GIR_EraseRootFromParent_Done,
     /* 1513659 */   // Label 21078: @1513659
     /* 1513659 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1513741), // Rule ID 18044 //
     /* 1513664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513703 */     // MIs[0] round
     /* 1513703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513706 */     // MIs[0] policy
     /* 1513706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513740 */     // GIR_Coverage, 18044,
     /* 1513740 */     GIR_EraseRootFromParent_Done,
     /* 1513741 */   // Label 21079: @1513741
     /* 1513741 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1513823), // Rule ID 18045 //
     /* 1513746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513785 */     // MIs[0] round
     /* 1513785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513788 */     // MIs[0] policy
     /* 1513788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513822 */     // GIR_Coverage, 18045,
     /* 1513822 */     GIR_EraseRootFromParent_Done,
     /* 1513823 */   // Label 21080: @1513823
     /* 1513823 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1513905), // Rule ID 18048 //
     /* 1513828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513867 */     // MIs[0] round
     /* 1513867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513870 */     // MIs[0] policy
     /* 1513870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513880 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513904 */     // GIR_Coverage, 18048,
     /* 1513904 */     GIR_EraseRootFromParent_Done,
     /* 1513905 */   // Label 21081: @1513905
     /* 1513905 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1513987), // Rule ID 18049 //
     /* 1513910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513949 */     // MIs[0] round
     /* 1513949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513952 */     // MIs[0] policy
     /* 1513952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513962 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513986 */     // GIR_Coverage, 18049,
     /* 1513986 */     GIR_EraseRootFromParent_Done,
     /* 1513987 */   // Label 21082: @1513987
     /* 1513987 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1514069), // Rule ID 18052 //
     /* 1513992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1514009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514031 */     // MIs[0] round
     /* 1514031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514034 */     // MIs[0] policy
     /* 1514034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1514047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514068 */     // GIR_Coverage, 18052,
     /* 1514068 */     GIR_EraseRootFromParent_Done,
     /* 1514069 */   // Label 21083: @1514069
     /* 1514069 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1514151), // Rule ID 18053 //
     /* 1514074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1514091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514113 */     // MIs[0] round
     /* 1514113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514116 */     // MIs[0] policy
     /* 1514116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514126 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1514129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514150 */     // GIR_Coverage, 18053,
     /* 1514150 */     GIR_EraseRootFromParent_Done,
     /* 1514151 */   // Label 21084: @1514151
     /* 1514151 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1514233), // Rule ID 18056 //
     /* 1514156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514195 */     // MIs[0] round
     /* 1514195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514198 */     // MIs[0] policy
     /* 1514198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514208 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1514211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514232 */     // GIR_Coverage, 18056,
     /* 1514232 */     GIR_EraseRootFromParent_Done,
     /* 1514233 */   // Label 21085: @1514233
     /* 1514233 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1514315), // Rule ID 18057 //
     /* 1514238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514277 */     // MIs[0] round
     /* 1514277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514280 */     // MIs[0] policy
     /* 1514280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514290 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1514293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514314 */     // GIR_Coverage, 18057,
     /* 1514314 */     GIR_EraseRootFromParent_Done,
     /* 1514315 */   // Label 21086: @1514315
     /* 1514315 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1514397), // Rule ID 18060 //
     /* 1514320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514359 */     // MIs[0] round
     /* 1514359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514362 */     // MIs[0] policy
     /* 1514362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514372 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1514375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514396 */     // GIR_Coverage, 18060,
     /* 1514396 */     GIR_EraseRootFromParent_Done,
     /* 1514397 */   // Label 21087: @1514397
     /* 1514397 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1514479), // Rule ID 18061 //
     /* 1514402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514441 */     // MIs[0] round
     /* 1514441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514444 */     // MIs[0] policy
     /* 1514444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1514457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514478 */     // GIR_Coverage, 18061,
     /* 1514478 */     GIR_EraseRootFromParent_Done,
     /* 1514479 */   // Label 21088: @1514479
     /* 1514479 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1514561), // Rule ID 18064 //
     /* 1514484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514523 */     // MIs[0] round
     /* 1514523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514526 */     // MIs[0] policy
     /* 1514526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514536 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514560 */     // GIR_Coverage, 18064,
     /* 1514560 */     GIR_EraseRootFromParent_Done,
     /* 1514561 */   // Label 21089: @1514561
     /* 1514561 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1514643), // Rule ID 18065 //
     /* 1514566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514605 */     // MIs[0] round
     /* 1514605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514608 */     // MIs[0] policy
     /* 1514608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514618 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514642 */     // GIR_Coverage, 18065,
     /* 1514642 */     GIR_EraseRootFromParent_Done,
     /* 1514643 */   // Label 21090: @1514643
     /* 1514643 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1514725), // Rule ID 18068 //
     /* 1514648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514687 */     // MIs[0] round
     /* 1514687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514690 */     // MIs[0] policy
     /* 1514690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514724 */     // GIR_Coverage, 18068,
     /* 1514724 */     GIR_EraseRootFromParent_Done,
     /* 1514725 */   // Label 21091: @1514725
     /* 1514725 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1514807), // Rule ID 18069 //
     /* 1514730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514769 */     // MIs[0] round
     /* 1514769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514772 */     // MIs[0] policy
     /* 1514772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514782 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514806 */     // GIR_Coverage, 18069,
     /* 1514806 */     GIR_EraseRootFromParent_Done,
     /* 1514807 */   // Label 21092: @1514807
     /* 1514807 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1514889), // Rule ID 18072 //
     /* 1514812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514851 */     // MIs[0] round
     /* 1514851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514854 */     // MIs[0] policy
     /* 1514854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514864 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514888 */     // GIR_Coverage, 18072,
     /* 1514888 */     GIR_EraseRootFromParent_Done,
     /* 1514889 */   // Label 21093: @1514889
     /* 1514889 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1514971), // Rule ID 18073 //
     /* 1514894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514933 */     // MIs[0] round
     /* 1514933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514936 */     // MIs[0] policy
     /* 1514936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514946 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514970 */     // GIR_Coverage, 18073,
     /* 1514970 */     GIR_EraseRootFromParent_Done,
     /* 1514971 */   // Label 21094: @1514971
     /* 1514971 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1515053), // Rule ID 18076 //
     /* 1514976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515015 */     // MIs[0] round
     /* 1515015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515018 */     // MIs[0] policy
     /* 1515018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1515031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515052 */     // GIR_Coverage, 18076,
     /* 1515052 */     GIR_EraseRootFromParent_Done,
     /* 1515053 */   // Label 21095: @1515053
     /* 1515053 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1515135), // Rule ID 18077 //
     /* 1515058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515097 */     // MIs[0] round
     /* 1515097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515100 */     // MIs[0] policy
     /* 1515100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515110 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1515113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515134 */     // GIR_Coverage, 18077,
     /* 1515134 */     GIR_EraseRootFromParent_Done,
     /* 1515135 */   // Label 21096: @1515135
     /* 1515135 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1515217), // Rule ID 18080 //
     /* 1515140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515179 */     // MIs[0] round
     /* 1515179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515182 */     // MIs[0] policy
     /* 1515182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515192 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1515195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515216 */     // GIR_Coverage, 18080,
     /* 1515216 */     GIR_EraseRootFromParent_Done,
     /* 1515217 */   // Label 21097: @1515217
     /* 1515217 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1515299), // Rule ID 18081 //
     /* 1515222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515261 */     // MIs[0] round
     /* 1515261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515264 */     // MIs[0] policy
     /* 1515264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1515277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515298 */     // GIR_Coverage, 18081,
     /* 1515298 */     GIR_EraseRootFromParent_Done,
     /* 1515299 */   // Label 21098: @1515299
     /* 1515299 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1515381), // Rule ID 18084 //
     /* 1515304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515343 */     // MIs[0] round
     /* 1515343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515346 */     // MIs[0] policy
     /* 1515346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1515359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515380 */     // GIR_Coverage, 18084,
     /* 1515380 */     GIR_EraseRootFromParent_Done,
     /* 1515381 */   // Label 21099: @1515381
     /* 1515381 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1515463), // Rule ID 18085 //
     /* 1515386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515425 */     // MIs[0] round
     /* 1515425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515428 */     // MIs[0] policy
     /* 1515428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515438 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1515441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515462 */     // GIR_Coverage, 18085,
     /* 1515462 */     GIR_EraseRootFromParent_Done,
     /* 1515463 */   // Label 21100: @1515463
     /* 1515463 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1515545), // Rule ID 18088 //
     /* 1515468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515507 */     // MIs[0] round
     /* 1515507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515510 */     // MIs[0] policy
     /* 1515510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515544 */     // GIR_Coverage, 18088,
     /* 1515544 */     GIR_EraseRootFromParent_Done,
     /* 1515545 */   // Label 21101: @1515545
     /* 1515545 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1515627), // Rule ID 18089 //
     /* 1515550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515589 */     // MIs[0] round
     /* 1515589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515592 */     // MIs[0] policy
     /* 1515592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515626 */     // GIR_Coverage, 18089,
     /* 1515626 */     GIR_EraseRootFromParent_Done,
     /* 1515627 */   // Label 21102: @1515627
     /* 1515627 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1515709), // Rule ID 18092 //
     /* 1515632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515671 */     // MIs[0] round
     /* 1515671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515674 */     // MIs[0] policy
     /* 1515674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515684 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515708 */     // GIR_Coverage, 18092,
     /* 1515708 */     GIR_EraseRootFromParent_Done,
     /* 1515709 */   // Label 21103: @1515709
     /* 1515709 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1515791), // Rule ID 18093 //
     /* 1515714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515753 */     // MIs[0] round
     /* 1515753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515756 */     // MIs[0] policy
     /* 1515756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515766 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515790 */     // GIR_Coverage, 18093,
     /* 1515790 */     GIR_EraseRootFromParent_Done,
     /* 1515791 */   // Label 21104: @1515791
     /* 1515791 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1515873), // Rule ID 18096 //
     /* 1515796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515835 */     // MIs[0] round
     /* 1515835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515838 */     // MIs[0] policy
     /* 1515838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515848 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515872 */     // GIR_Coverage, 18096,
     /* 1515872 */     GIR_EraseRootFromParent_Done,
     /* 1515873 */   // Label 21105: @1515873
     /* 1515873 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1515955), // Rule ID 18097 //
     /* 1515878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515917 */     // MIs[0] round
     /* 1515917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515920 */     // MIs[0] policy
     /* 1515920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515954 */     // GIR_Coverage, 18097,
     /* 1515954 */     GIR_EraseRootFromParent_Done,
     /* 1515955 */   // Label 21106: @1515955
     /* 1515955 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1516037), // Rule ID 18100 //
     /* 1515960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515999 */     // MIs[0] round
     /* 1515999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516002 */     // MIs[0] policy
     /* 1516002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1516015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516036 */     // GIR_Coverage, 18100,
     /* 1516036 */     GIR_EraseRootFromParent_Done,
     /* 1516037 */   // Label 21107: @1516037
     /* 1516037 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1516119), // Rule ID 18101 //
     /* 1516042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1516059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1516077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516081 */     // MIs[0] round
     /* 1516081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516084 */     // MIs[0] policy
     /* 1516084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516094 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1516097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516118 */     // GIR_Coverage, 18101,
     /* 1516118 */     GIR_EraseRootFromParent_Done,
     /* 1516119 */   // Label 21108: @1516119
     /* 1516119 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1516201), // Rule ID 18104 //
     /* 1516124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516163 */     // MIs[0] round
     /* 1516163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516166 */     // MIs[0] policy
     /* 1516166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1516179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516200 */     // GIR_Coverage, 18104,
     /* 1516200 */     GIR_EraseRootFromParent_Done,
     /* 1516201 */   // Label 21109: @1516201
     /* 1516201 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1516283), // Rule ID 18105 //
     /* 1516206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516245 */     // MIs[0] round
     /* 1516245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516248 */     // MIs[0] policy
     /* 1516248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516258 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1516261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516282 */     // GIR_Coverage, 18105,
     /* 1516282 */     GIR_EraseRootFromParent_Done,
     /* 1516283 */   // Label 21110: @1516283
     /* 1516283 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1516365), // Rule ID 18108 //
     /* 1516288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516327 */     // MIs[0] round
     /* 1516327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516330 */     // MIs[0] policy
     /* 1516330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1516343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516364 */     // GIR_Coverage, 18108,
     /* 1516364 */     GIR_EraseRootFromParent_Done,
     /* 1516365 */   // Label 21111: @1516365
     /* 1516365 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1516447), // Rule ID 18109 //
     /* 1516370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516409 */     // MIs[0] round
     /* 1516409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516412 */     // MIs[0] policy
     /* 1516412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1516425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516446 */     // GIR_Coverage, 18109,
     /* 1516446 */     GIR_EraseRootFromParent_Done,
     /* 1516447 */   // Label 21112: @1516447
     /* 1516447 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1516529), // Rule ID 18112 //
     /* 1516452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516491 */     // MIs[0] round
     /* 1516491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516494 */     // MIs[0] policy
     /* 1516494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516504 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516528 */     // GIR_Coverage, 18112,
     /* 1516528 */     GIR_EraseRootFromParent_Done,
     /* 1516529 */   // Label 21113: @1516529
     /* 1516529 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1516611), // Rule ID 18113 //
     /* 1516534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516573 */     // MIs[0] round
     /* 1516573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516576 */     // MIs[0] policy
     /* 1516576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516610 */     // GIR_Coverage, 18113,
     /* 1516610 */     GIR_EraseRootFromParent_Done,
     /* 1516611 */   // Label 21114: @1516611
     /* 1516611 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1516693), // Rule ID 18116 //
     /* 1516616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516655 */     // MIs[0] round
     /* 1516655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516658 */     // MIs[0] policy
     /* 1516658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516668 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516692 */     // GIR_Coverage, 18116,
     /* 1516692 */     GIR_EraseRootFromParent_Done,
     /* 1516693 */   // Label 21115: @1516693
     /* 1516693 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1516775), // Rule ID 18117 //
     /* 1516698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516737 */     // MIs[0] round
     /* 1516737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516740 */     // MIs[0] policy
     /* 1516740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516774 */     // GIR_Coverage, 18117,
     /* 1516774 */     GIR_EraseRootFromParent_Done,
     /* 1516775 */   // Label 21116: @1516775
     /* 1516775 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1516857), // Rule ID 18120 //
     /* 1516780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516819 */     // MIs[0] round
     /* 1516819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516822 */     // MIs[0] policy
     /* 1516822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516832 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516856 */     // GIR_Coverage, 18120,
     /* 1516856 */     GIR_EraseRootFromParent_Done,
     /* 1516857 */   // Label 21117: @1516857
     /* 1516857 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1516939), // Rule ID 18121 //
     /* 1516862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516901 */     // MIs[0] round
     /* 1516901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516904 */     // MIs[0] policy
     /* 1516904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516938 */     // GIR_Coverage, 18121,
     /* 1516938 */     GIR_EraseRootFromParent_Done,
     /* 1516939 */   // Label 21118: @1516939
     /* 1516939 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1517021), // Rule ID 18124 //
     /* 1516944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516983 */     // MIs[0] round
     /* 1516983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516986 */     // MIs[0] policy
     /* 1516986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1516999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517020 */     // GIR_Coverage, 18124,
     /* 1517020 */     GIR_EraseRootFromParent_Done,
     /* 1517021 */   // Label 21119: @1517021
     /* 1517021 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1517103), // Rule ID 18125 //
     /* 1517026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1517043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517065 */     // MIs[0] round
     /* 1517065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517068 */     // MIs[0] policy
     /* 1517068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1517081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517102 */     // GIR_Coverage, 18125,
     /* 1517102 */     GIR_EraseRootFromParent_Done,
     /* 1517103 */   // Label 21120: @1517103
     /* 1517103 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1517185), // Rule ID 18128 //
     /* 1517108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1517125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517147 */     // MIs[0] round
     /* 1517147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517150 */     // MIs[0] policy
     /* 1517150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1517163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517184 */     // GIR_Coverage, 18128,
     /* 1517184 */     GIR_EraseRootFromParent_Done,
     /* 1517185 */   // Label 21121: @1517185
     /* 1517185 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1517267), // Rule ID 18129 //
     /* 1517190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1517207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517229 */     // MIs[0] round
     /* 1517229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517232 */     // MIs[0] policy
     /* 1517232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1517245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517266 */     // GIR_Coverage, 18129,
     /* 1517266 */     GIR_EraseRootFromParent_Done,
     /* 1517267 */   // Label 21122: @1517267
     /* 1517267 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1517349), // Rule ID 18132 //
     /* 1517272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1517289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517311 */     // MIs[0] round
     /* 1517311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517314 */     // MIs[0] policy
     /* 1517314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1517327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517348 */     // GIR_Coverage, 18132,
     /* 1517348 */     GIR_EraseRootFromParent_Done,
     /* 1517349 */   // Label 21123: @1517349
     /* 1517349 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1517431), // Rule ID 18133 //
     /* 1517354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1517371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517393 */     // MIs[0] round
     /* 1517393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517396 */     // MIs[0] policy
     /* 1517396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1517409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517430 */     // GIR_Coverage, 18133,
     /* 1517430 */     GIR_EraseRootFromParent_Done,
     /* 1517431 */   // Label 21124: @1517431
     /* 1517431 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1517513), // Rule ID 18136 //
     /* 1517436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517475 */     // MIs[0] round
     /* 1517475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517478 */     // MIs[0] policy
     /* 1517478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517512 */     // GIR_Coverage, 18136,
     /* 1517512 */     GIR_EraseRootFromParent_Done,
     /* 1517513 */   // Label 21125: @1517513
     /* 1517513 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1517595), // Rule ID 18137 //
     /* 1517518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517557 */     // MIs[0] round
     /* 1517557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517560 */     // MIs[0] policy
     /* 1517560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517594 */     // GIR_Coverage, 18137,
     /* 1517594 */     GIR_EraseRootFromParent_Done,
     /* 1517595 */   // Label 21126: @1517595
     /* 1517595 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1517677), // Rule ID 18140 //
     /* 1517600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517639 */     // MIs[0] round
     /* 1517639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517642 */     // MIs[0] policy
     /* 1517642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517676 */     // GIR_Coverage, 18140,
     /* 1517676 */     GIR_EraseRootFromParent_Done,
     /* 1517677 */   // Label 21127: @1517677
     /* 1517677 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1517759), // Rule ID 18141 //
     /* 1517682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517721 */     // MIs[0] round
     /* 1517721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517724 */     // MIs[0] policy
     /* 1517724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517734 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517758 */     // GIR_Coverage, 18141,
     /* 1517758 */     GIR_EraseRootFromParent_Done,
     /* 1517759 */   // Label 21128: @1517759
     /* 1517759 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1517841), // Rule ID 18144 //
     /* 1517764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517803 */     // MIs[0] round
     /* 1517803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517806 */     // MIs[0] policy
     /* 1517806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517816 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517840 */     // GIR_Coverage, 18144,
     /* 1517840 */     GIR_EraseRootFromParent_Done,
     /* 1517841 */   // Label 21129: @1517841
     /* 1517841 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1517923), // Rule ID 18145 //
     /* 1517846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517885 */     // MIs[0] round
     /* 1517885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517888 */     // MIs[0] policy
     /* 1517888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517898 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517922 */     // GIR_Coverage, 18145,
     /* 1517922 */     GIR_EraseRootFromParent_Done,
     /* 1517923 */   // Label 21130: @1517923
     /* 1517923 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1518005), // Rule ID 18148 //
     /* 1517928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517967 */     // MIs[0] round
     /* 1517967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517970 */     // MIs[0] policy
     /* 1517970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517980 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518004 */     // GIR_Coverage, 18148,
     /* 1518004 */     GIR_EraseRootFromParent_Done,
     /* 1518005 */   // Label 21131: @1518005
     /* 1518005 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1518087), // Rule ID 18149 //
     /* 1518010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1518027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518049 */     // MIs[0] round
     /* 1518049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518052 */     // MIs[0] policy
     /* 1518052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1518065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518086 */     // GIR_Coverage, 18149,
     /* 1518086 */     GIR_EraseRootFromParent_Done,
     /* 1518087 */   // Label 21132: @1518087
     /* 1518087 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1518169), // Rule ID 18152 //
     /* 1518092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1518109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518131 */     // MIs[0] round
     /* 1518131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518134 */     // MIs[0] policy
     /* 1518134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1518147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518168 */     // GIR_Coverage, 18152,
     /* 1518168 */     GIR_EraseRootFromParent_Done,
     /* 1518169 */   // Label 21133: @1518169
     /* 1518169 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1518251), // Rule ID 18153 //
     /* 1518174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1518191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518213 */     // MIs[0] round
     /* 1518213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518216 */     // MIs[0] policy
     /* 1518216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518226 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1518229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518250 */     // GIR_Coverage, 18153,
     /* 1518250 */     GIR_EraseRootFromParent_Done,
     /* 1518251 */   // Label 21134: @1518251
     /* 1518251 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1518333), // Rule ID 18156 //
     /* 1518256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1518273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518295 */     // MIs[0] round
     /* 1518295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518298 */     // MIs[0] policy
     /* 1518298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1518311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518332 */     // GIR_Coverage, 18156,
     /* 1518332 */     GIR_EraseRootFromParent_Done,
     /* 1518333 */   // Label 21135: @1518333
     /* 1518333 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1518415), // Rule ID 18157 //
     /* 1518338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1518355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518377 */     // MIs[0] round
     /* 1518377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518380 */     // MIs[0] policy
     /* 1518380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518390 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1518393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518414 */     // GIR_Coverage, 18157,
     /* 1518414 */     GIR_EraseRootFromParent_Done,
     /* 1518415 */   // Label 21136: @1518415
     /* 1518415 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1518497), // Rule ID 18160 //
     /* 1518420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518459 */     // MIs[0] round
     /* 1518459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518462 */     // MIs[0] policy
     /* 1518462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518472 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518496 */     // GIR_Coverage, 18160,
     /* 1518496 */     GIR_EraseRootFromParent_Done,
     /* 1518497 */   // Label 21137: @1518497
     /* 1518497 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1518579), // Rule ID 18161 //
     /* 1518502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518541 */     // MIs[0] round
     /* 1518541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518544 */     // MIs[0] policy
     /* 1518544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518554 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518578 */     // GIR_Coverage, 18161,
     /* 1518578 */     GIR_EraseRootFromParent_Done,
     /* 1518579 */   // Label 21138: @1518579
     /* 1518579 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1518661), // Rule ID 18164 //
     /* 1518584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518623 */     // MIs[0] round
     /* 1518623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518626 */     // MIs[0] policy
     /* 1518626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518660 */     // GIR_Coverage, 18164,
     /* 1518660 */     GIR_EraseRootFromParent_Done,
     /* 1518661 */   // Label 21139: @1518661
     /* 1518661 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1518743), // Rule ID 18165 //
     /* 1518666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518705 */     // MIs[0] round
     /* 1518705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518708 */     // MIs[0] policy
     /* 1518708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518718 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518742 */     // GIR_Coverage, 18165,
     /* 1518742 */     GIR_EraseRootFromParent_Done,
     /* 1518743 */   // Label 21140: @1518743
     /* 1518743 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1518825), // Rule ID 18168 //
     /* 1518748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518787 */     // MIs[0] round
     /* 1518787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518790 */     // MIs[0] policy
     /* 1518790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518800 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518824 */     // GIR_Coverage, 18168,
     /* 1518824 */     GIR_EraseRootFromParent_Done,
     /* 1518825 */   // Label 21141: @1518825
     /* 1518825 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1518907), // Rule ID 18169 //
     /* 1518830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518869 */     // MIs[0] round
     /* 1518869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518872 */     // MIs[0] policy
     /* 1518872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518882 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518906 */     // GIR_Coverage, 18169,
     /* 1518906 */     GIR_EraseRootFromParent_Done,
     /* 1518907 */   // Label 21142: @1518907
     /* 1518907 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1518989), // Rule ID 18172 //
     /* 1518912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518951 */     // MIs[0] round
     /* 1518951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518954 */     // MIs[0] policy
     /* 1518954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518988 */     // GIR_Coverage, 18172,
     /* 1518988 */     GIR_EraseRootFromParent_Done,
     /* 1518989 */   // Label 21143: @1518989
     /* 1518989 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1519071), // Rule ID 18173 //
     /* 1518994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1519011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519033 */     // MIs[0] round
     /* 1519033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519036 */     // MIs[0] policy
     /* 1519036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1519049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519070 */     // GIR_Coverage, 18173,
     /* 1519070 */     GIR_EraseRootFromParent_Done,
     /* 1519071 */   // Label 21144: @1519071
     /* 1519071 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1519153), // Rule ID 18176 //
     /* 1519076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519115 */     // MIs[0] round
     /* 1519115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519118 */     // MIs[0] policy
     /* 1519118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519128 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1519131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519152 */     // GIR_Coverage, 18176,
     /* 1519152 */     GIR_EraseRootFromParent_Done,
     /* 1519153 */   // Label 21145: @1519153
     /* 1519153 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1519235), // Rule ID 18177 //
     /* 1519158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519197 */     // MIs[0] round
     /* 1519197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519200 */     // MIs[0] policy
     /* 1519200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1519213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519234 */     // GIR_Coverage, 18177,
     /* 1519234 */     GIR_EraseRootFromParent_Done,
     /* 1519235 */   // Label 21146: @1519235
     /* 1519235 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1519317), // Rule ID 18180 //
     /* 1519240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519279 */     // MIs[0] round
     /* 1519279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519282 */     // MIs[0] policy
     /* 1519282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519292 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1519295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519316 */     // GIR_Coverage, 18180,
     /* 1519316 */     GIR_EraseRootFromParent_Done,
     /* 1519317 */   // Label 21147: @1519317
     /* 1519317 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1519399), // Rule ID 18181 //
     /* 1519322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519361 */     // MIs[0] round
     /* 1519361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519364 */     // MIs[0] policy
     /* 1519364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1519377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519398 */     // GIR_Coverage, 18181,
     /* 1519398 */     GIR_EraseRootFromParent_Done,
     /* 1519399 */   // Label 21148: @1519399
     /* 1519399 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1519481), // Rule ID 18184 //
     /* 1519404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519443 */     // MIs[0] round
     /* 1519443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519446 */     // MIs[0] policy
     /* 1519446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519456 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519480 */     // GIR_Coverage, 18184,
     /* 1519480 */     GIR_EraseRootFromParent_Done,
     /* 1519481 */   // Label 21149: @1519481
     /* 1519481 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1519563), // Rule ID 18185 //
     /* 1519486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519525 */     // MIs[0] round
     /* 1519525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519528 */     // MIs[0] policy
     /* 1519528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519538 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519562 */     // GIR_Coverage, 18185,
     /* 1519562 */     GIR_EraseRootFromParent_Done,
     /* 1519563 */   // Label 21150: @1519563
     /* 1519563 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1519645), // Rule ID 18188 //
     /* 1519568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519607 */     // MIs[0] round
     /* 1519607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519610 */     // MIs[0] policy
     /* 1519610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519644 */     // GIR_Coverage, 18188,
     /* 1519644 */     GIR_EraseRootFromParent_Done,
     /* 1519645 */   // Label 21151: @1519645
     /* 1519645 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1519727), // Rule ID 18189 //
     /* 1519650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519689 */     // MIs[0] round
     /* 1519689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519692 */     // MIs[0] policy
     /* 1519692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11301:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519726 */     // GIR_Coverage, 18189,
     /* 1519726 */     GIR_EraseRootFromParent_Done,
     /* 1519727 */   // Label 21152: @1519727
     /* 1519727 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1519809), // Rule ID 18192 //
     /* 1519732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519771 */     // MIs[0] round
     /* 1519771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519774 */     // MIs[0] policy
     /* 1519774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519808 */     // GIR_Coverage, 18192,
     /* 1519808 */     GIR_EraseRootFromParent_Done,
     /* 1519809 */   // Label 21153: @1519809
     /* 1519809 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1519891), // Rule ID 18193 //
     /* 1519814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519853 */     // MIs[0] round
     /* 1519853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519856 */     // MIs[0] policy
     /* 1519856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11301:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519890 */     // GIR_Coverage, 18193,
     /* 1519890 */     GIR_EraseRootFromParent_Done,
     /* 1519891 */   // Label 21154: @1519891
     /* 1519891 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1519973), // Rule ID 18196 //
     /* 1519896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519935 */     // MIs[0] round
     /* 1519935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519938 */     // MIs[0] policy
     /* 1519938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519972 */     // GIR_Coverage, 18196,
     /* 1519972 */     GIR_EraseRootFromParent_Done,
     /* 1519973 */   // Label 21155: @1519973
     /* 1519973 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1520055), // Rule ID 18197 //
     /* 1519978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520017 */     // MIs[0] round
     /* 1520017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520020 */     // MIs[0] policy
     /* 1520020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520030 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11301:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1520033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520054 */     // GIR_Coverage, 18197,
     /* 1520054 */     GIR_EraseRootFromParent_Done,
     /* 1520055 */   // Label 21156: @1520055
     /* 1520055 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1520137), // Rule ID 18200 //
     /* 1520060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520099 */     // MIs[0] round
     /* 1520099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520102 */     // MIs[0] policy
     /* 1520102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520112 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1520115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520136 */     // GIR_Coverage, 18200,
     /* 1520136 */     GIR_EraseRootFromParent_Done,
     /* 1520137 */   // Label 21157: @1520137
     /* 1520137 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1520219), // Rule ID 18201 //
     /* 1520142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520181 */     // MIs[0] round
     /* 1520181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520184 */     // MIs[0] policy
     /* 1520184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1520197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520218 */     // GIR_Coverage, 18201,
     /* 1520218 */     GIR_EraseRootFromParent_Done,
     /* 1520219 */   // Label 21158: @1520219
     /* 1520219 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1520301), // Rule ID 18204 //
     /* 1520224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520263 */     // MIs[0] round
     /* 1520263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520266 */     // MIs[0] policy
     /* 1520266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520276 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1520279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520300 */     // GIR_Coverage, 18204,
     /* 1520300 */     GIR_EraseRootFromParent_Done,
     /* 1520301 */   // Label 21159: @1520301
     /* 1520301 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1520383), // Rule ID 18205 //
     /* 1520306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520345 */     // MIs[0] round
     /* 1520345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520348 */     // MIs[0] policy
     /* 1520348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1520361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520382 */     // GIR_Coverage, 18205,
     /* 1520382 */     GIR_EraseRootFromParent_Done,
     /* 1520383 */   // Label 21160: @1520383
     /* 1520383 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1520465), // Rule ID 18208 //
     /* 1520388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520427 */     // MIs[0] round
     /* 1520427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520430 */     // MIs[0] policy
     /* 1520430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520464 */     // GIR_Coverage, 18208,
     /* 1520464 */     GIR_EraseRootFromParent_Done,
     /* 1520465 */   // Label 21161: @1520465
     /* 1520465 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1520547), // Rule ID 18209 //
     /* 1520470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520509 */     // MIs[0] round
     /* 1520509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520512 */     // MIs[0] policy
     /* 1520512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520522 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520546 */     // GIR_Coverage, 18209,
     /* 1520546 */     GIR_EraseRootFromParent_Done,
     /* 1520547 */   // Label 21162: @1520547
     /* 1520547 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1520629), // Rule ID 18212 //
     /* 1520552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520591 */     // MIs[0] round
     /* 1520591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520594 */     // MIs[0] policy
     /* 1520594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520628 */     // GIR_Coverage, 18212,
     /* 1520628 */     GIR_EraseRootFromParent_Done,
     /* 1520629 */   // Label 21163: @1520629
     /* 1520629 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1520711), // Rule ID 18213 //
     /* 1520634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520673 */     // MIs[0] round
     /* 1520673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520676 */     // MIs[0] policy
     /* 1520676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520686 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520710 */     // GIR_Coverage, 18213,
     /* 1520710 */     GIR_EraseRootFromParent_Done,
     /* 1520711 */   // Label 21164: @1520711
     /* 1520711 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1520793), // Rule ID 18216 //
     /* 1520716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520755 */     // MIs[0] round
     /* 1520755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520758 */     // MIs[0] policy
     /* 1520758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520792 */     // GIR_Coverage, 18216,
     /* 1520792 */     GIR_EraseRootFromParent_Done,
     /* 1520793 */   // Label 21165: @1520793
     /* 1520793 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1520875), // Rule ID 18217 //
     /* 1520798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520837 */     // MIs[0] round
     /* 1520837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520840 */     // MIs[0] policy
     /* 1520840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520874 */     // GIR_Coverage, 18217,
     /* 1520874 */     GIR_EraseRootFromParent_Done,
     /* 1520875 */   // Label 21166: @1520875
     /* 1520875 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1520957), // Rule ID 18220 //
     /* 1520880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520919 */     // MIs[0] round
     /* 1520919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520922 */     // MIs[0] policy
     /* 1520922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520956 */     // GIR_Coverage, 18220,
     /* 1520956 */     GIR_EraseRootFromParent_Done,
     /* 1520957 */   // Label 21167: @1520957
     /* 1520957 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1521039), // Rule ID 18221 //
     /* 1520962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521001 */     // MIs[0] round
     /* 1521001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521004 */     // MIs[0] policy
     /* 1521004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1521017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521038 */     // GIR_Coverage, 18221,
     /* 1521038 */     GIR_EraseRootFromParent_Done,
     /* 1521039 */   // Label 21168: @1521039
     /* 1521039 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1521121), // Rule ID 18224 //
     /* 1521044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521083 */     // MIs[0] round
     /* 1521083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521086 */     // MIs[0] policy
     /* 1521086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521096 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1521099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521120 */     // GIR_Coverage, 18224,
     /* 1521120 */     GIR_EraseRootFromParent_Done,
     /* 1521121 */   // Label 21169: @1521121
     /* 1521121 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1521203), // Rule ID 18225 //
     /* 1521126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521165 */     // MIs[0] round
     /* 1521165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521168 */     // MIs[0] policy
     /* 1521168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521178 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11301:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1521181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521202 */     // GIR_Coverage, 18225,
     /* 1521202 */     GIR_EraseRootFromParent_Done,
     /* 1521203 */   // Label 21170: @1521203
     /* 1521203 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1521285), // Rule ID 18228 //
     /* 1521208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521247 */     // MIs[0] round
     /* 1521247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521250 */     // MIs[0] policy
     /* 1521250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521260 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1521263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521284 */     // GIR_Coverage, 18228,
     /* 1521284 */     GIR_EraseRootFromParent_Done,
     /* 1521285 */   // Label 21171: @1521285
     /* 1521285 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1521367), // Rule ID 18229 //
     /* 1521290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521329 */     // MIs[0] round
     /* 1521329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521332 */     // MIs[0] policy
     /* 1521332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11301:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1521345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521366 */     // GIR_Coverage, 18229,
     /* 1521366 */     GIR_EraseRootFromParent_Done,
     /* 1521367 */   // Label 21172: @1521367
     /* 1521367 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1521449), // Rule ID 18232 //
     /* 1521372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521411 */     // MIs[0] round
     /* 1521411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521414 */     // MIs[0] policy
     /* 1521414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521448 */     // GIR_Coverage, 18232,
     /* 1521448 */     GIR_EraseRootFromParent_Done,
     /* 1521449 */   // Label 21173: @1521449
     /* 1521449 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1521531), // Rule ID 18233 //
     /* 1521454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1521462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521493 */     // MIs[0] round
     /* 1521493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521496 */     // MIs[0] policy
     /* 1521496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11301:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521530 */     // GIR_Coverage, 18233,
     /* 1521530 */     GIR_EraseRootFromParent_Done,
     /* 1521531 */   // Label 21174: @1521531
     /* 1521531 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1521613), // Rule ID 18236 //
     /* 1521536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521575 */     // MIs[0] round
     /* 1521575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521578 */     // MIs[0] policy
     /* 1521578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521612 */     // GIR_Coverage, 18236,
     /* 1521612 */     GIR_EraseRootFromParent_Done,
     /* 1521613 */   // Label 21175: @1521613
     /* 1521613 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1521695), // Rule ID 18237 //
     /* 1521618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521657 */     // MIs[0] round
     /* 1521657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521660 */     // MIs[0] policy
     /* 1521660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521670 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521694 */     // GIR_Coverage, 18237,
     /* 1521694 */     GIR_EraseRootFromParent_Done,
     /* 1521695 */   // Label 21176: @1521695
     /* 1521695 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1521777), // Rule ID 18240 //
     /* 1521700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521739 */     // MIs[0] round
     /* 1521739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521742 */     // MIs[0] policy
     /* 1521742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521776 */     // GIR_Coverage, 18240,
     /* 1521776 */     GIR_EraseRootFromParent_Done,
     /* 1521777 */   // Label 21177: @1521777
     /* 1521777 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1521859), // Rule ID 18241 //
     /* 1521782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521821 */     // MIs[0] round
     /* 1521821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521824 */     // MIs[0] policy
     /* 1521824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521834 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521858 */     // GIR_Coverage, 18241,
     /* 1521858 */     GIR_EraseRootFromParent_Done,
     /* 1521859 */   // Label 21178: @1521859
     /* 1521859 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1521941), // Rule ID 18244 //
     /* 1521864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521903 */     // MIs[0] round
     /* 1521903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521906 */     // MIs[0] policy
     /* 1521906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521940 */     // GIR_Coverage, 18244,
     /* 1521940 */     GIR_EraseRootFromParent_Done,
     /* 1521941 */   // Label 21179: @1521941
     /* 1521941 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1522023), // Rule ID 18245 //
     /* 1521946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521985 */     // MIs[0] round
     /* 1521985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521988 */     // MIs[0] policy
     /* 1521988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1522001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522022 */     // GIR_Coverage, 18245,
     /* 1522022 */     GIR_EraseRootFromParent_Done,
     /* 1522023 */   // Label 21180: @1522023
     /* 1522023 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1522105), // Rule ID 18248 //
     /* 1522028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1522045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522067 */     // MIs[0] round
     /* 1522067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522070 */     // MIs[0] policy
     /* 1522070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1522083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522104 */     // GIR_Coverage, 18248,
     /* 1522104 */     GIR_EraseRootFromParent_Done,
     /* 1522105 */   // Label 21181: @1522105
     /* 1522105 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1522187), // Rule ID 18249 //
     /* 1522110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1522127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522149 */     // MIs[0] round
     /* 1522149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522152 */     // MIs[0] policy
     /* 1522152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522162 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1522165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522186 */     // GIR_Coverage, 18249,
     /* 1522186 */     GIR_EraseRootFromParent_Done,
     /* 1522187 */   // Label 21182: @1522187
     /* 1522187 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1522269), // Rule ID 18252 //
     /* 1522192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1522209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522231 */     // MIs[0] round
     /* 1522231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522234 */     // MIs[0] policy
     /* 1522234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1522247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522268 */     // GIR_Coverage, 18252,
     /* 1522268 */     GIR_EraseRootFromParent_Done,
     /* 1522269 */   // Label 21183: @1522269
     /* 1522269 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1522351), // Rule ID 18253 //
     /* 1522274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1522291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522313 */     // MIs[0] round
     /* 1522313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522316 */     // MIs[0] policy
     /* 1522316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522326 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1522329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522350 */     // GIR_Coverage, 18253,
     /* 1522350 */     GIR_EraseRootFromParent_Done,
     /* 1522351 */   // Label 21184: @1522351
     /* 1522351 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1522433), // Rule ID 18256 //
     /* 1522356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1522373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522395 */     // MIs[0] round
     /* 1522395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522398 */     // MIs[0] policy
     /* 1522398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522432 */     // GIR_Coverage, 18256,
     /* 1522432 */     GIR_EraseRootFromParent_Done,
     /* 1522433 */   // Label 21185: @1522433
     /* 1522433 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1522515), // Rule ID 18257 //
     /* 1522438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1522455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522477 */     // MIs[0] round
     /* 1522477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522480 */     // MIs[0] policy
     /* 1522480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522514 */     // GIR_Coverage, 18257,
     /* 1522514 */     GIR_EraseRootFromParent_Done,
     /* 1522515 */   // Label 21186: @1522515
     /* 1522515 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1522597), // Rule ID 18260 //
     /* 1522520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522559 */     // MIs[0] round
     /* 1522559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522562 */     // MIs[0] policy
     /* 1522562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522596 */     // GIR_Coverage, 18260,
     /* 1522596 */     GIR_EraseRootFromParent_Done,
     /* 1522597 */   // Label 21187: @1522597
     /* 1522597 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1522679), // Rule ID 18261 //
     /* 1522602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522641 */     // MIs[0] round
     /* 1522641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522644 */     // MIs[0] policy
     /* 1522644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522678 */     // GIR_Coverage, 18261,
     /* 1522678 */     GIR_EraseRootFromParent_Done,
     /* 1522679 */   // Label 21188: @1522679
     /* 1522679 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1522761), // Rule ID 18264 //
     /* 1522684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522723 */     // MIs[0] round
     /* 1522723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522726 */     // MIs[0] policy
     /* 1522726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522760 */     // GIR_Coverage, 18264,
     /* 1522760 */     GIR_EraseRootFromParent_Done,
     /* 1522761 */   // Label 21189: @1522761
     /* 1522761 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1522843), // Rule ID 18265 //
     /* 1522766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522805 */     // MIs[0] round
     /* 1522805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522808 */     // MIs[0] policy
     /* 1522808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522818 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522842 */     // GIR_Coverage, 18265,
     /* 1522842 */     GIR_EraseRootFromParent_Done,
     /* 1522843 */   // Label 21190: @1522843
     /* 1522843 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1522925), // Rule ID 18268 //
     /* 1522848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522887 */     // MIs[0] round
     /* 1522887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522890 */     // MIs[0] policy
     /* 1522890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522900 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522924 */     // GIR_Coverage, 18268,
     /* 1522924 */     GIR_EraseRootFromParent_Done,
     /* 1522925 */   // Label 21191: @1522925
     /* 1522925 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1523007), // Rule ID 18269 //
     /* 1522930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522969 */     // MIs[0] round
     /* 1522969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522972 */     // MIs[0] policy
     /* 1522972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523006 */     // GIR_Coverage, 18269,
     /* 1523006 */     GIR_EraseRootFromParent_Done,
     /* 1523007 */   // Label 21192: @1523007
     /* 1523007 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1523089), // Rule ID 18272 //
     /* 1523012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1523029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523051 */     // MIs[0] round
     /* 1523051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523054 */     // MIs[0] policy
     /* 1523054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1523067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523088 */     // GIR_Coverage, 18272,
     /* 1523088 */     GIR_EraseRootFromParent_Done,
     /* 1523089 */   // Label 21193: @1523089
     /* 1523089 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1523171), // Rule ID 18273 //
     /* 1523094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1523111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523133 */     // MIs[0] round
     /* 1523133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523136 */     // MIs[0] policy
     /* 1523136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1523149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523170 */     // GIR_Coverage, 18273,
     /* 1523170 */     GIR_EraseRootFromParent_Done,
     /* 1523171 */   // Label 21194: @1523171
     /* 1523171 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1523253), // Rule ID 18276 //
     /* 1523176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1523193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523215 */     // MIs[0] round
     /* 1523215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523218 */     // MIs[0] policy
     /* 1523218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523228 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1523231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523252 */     // GIR_Coverage, 18276,
     /* 1523252 */     GIR_EraseRootFromParent_Done,
     /* 1523253 */   // Label 21195: @1523253
     /* 1523253 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1523335), // Rule ID 18277 //
     /* 1523258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1523275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523297 */     // MIs[0] round
     /* 1523297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523300 */     // MIs[0] policy
     /* 1523300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523310 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1523313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523334 */     // GIR_Coverage, 18277,
     /* 1523334 */     GIR_EraseRootFromParent_Done,
     /* 1523335 */   // Label 21196: @1523335
     /* 1523335 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1523417), // Rule ID 18280 //
     /* 1523340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1523357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523379 */     // MIs[0] round
     /* 1523379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523382 */     // MIs[0] policy
     /* 1523382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523416 */     // GIR_Coverage, 18280,
     /* 1523416 */     GIR_EraseRootFromParent_Done,
     /* 1523417 */   // Label 21197: @1523417
     /* 1523417 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1523499), // Rule ID 18281 //
     /* 1523422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1523439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523461 */     // MIs[0] round
     /* 1523461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523464 */     // MIs[0] policy
     /* 1523464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523474 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523498 */     // GIR_Coverage, 18281,
     /* 1523498 */     GIR_EraseRootFromParent_Done,
     /* 1523499 */   // Label 21198: @1523499
     /* 1523499 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1523581), // Rule ID 18284 //
     /* 1523504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523543 */     // MIs[0] round
     /* 1523543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523546 */     // MIs[0] policy
     /* 1523546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523580 */     // GIR_Coverage, 18284,
     /* 1523580 */     GIR_EraseRootFromParent_Done,
     /* 1523581 */   // Label 21199: @1523581
     /* 1523581 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1523663), // Rule ID 18285 //
     /* 1523586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523625 */     // MIs[0] round
     /* 1523625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523628 */     // MIs[0] policy
     /* 1523628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523662 */     // GIR_Coverage, 18285,
     /* 1523662 */     GIR_EraseRootFromParent_Done,
     /* 1523663 */   // Label 21200: @1523663
     /* 1523663 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1523745), // Rule ID 18288 //
     /* 1523668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523707 */     // MIs[0] round
     /* 1523707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523710 */     // MIs[0] policy
     /* 1523710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523744 */     // GIR_Coverage, 18288,
     /* 1523744 */     GIR_EraseRootFromParent_Done,
     /* 1523745 */   // Label 21201: @1523745
     /* 1523745 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1523827), // Rule ID 18289 //
     /* 1523750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523789 */     // MIs[0] round
     /* 1523789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523792 */     // MIs[0] policy
     /* 1523792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523802 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523826 */     // GIR_Coverage, 18289,
     /* 1523826 */     GIR_EraseRootFromParent_Done,
     /* 1523827 */   // Label 21202: @1523827
     /* 1523827 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1523909), // Rule ID 18292 //
     /* 1523832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523871 */     // MIs[0] round
     /* 1523871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523874 */     // MIs[0] policy
     /* 1523874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523908 */     // GIR_Coverage, 18292,
     /* 1523908 */     GIR_EraseRootFromParent_Done,
     /* 1523909 */   // Label 21203: @1523909
     /* 1523909 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1523991), // Rule ID 18293 //
     /* 1523914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523953 */     // MIs[0] round
     /* 1523953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523956 */     // MIs[0] policy
     /* 1523956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523990 */     // GIR_Coverage, 18293,
     /* 1523990 */     GIR_EraseRootFromParent_Done,
     /* 1523991 */   // Label 21204: @1523991
     /* 1523991 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1524073), // Rule ID 18296 //
     /* 1523996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524035 */     // MIs[0] round
     /* 1524035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524038 */     // MIs[0] policy
     /* 1524038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1524051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524072 */     // GIR_Coverage, 18296,
     /* 1524072 */     GIR_EraseRootFromParent_Done,
     /* 1524073 */   // Label 21205: @1524073
     /* 1524073 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1524155), // Rule ID 18297 //
     /* 1524078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524117 */     // MIs[0] round
     /* 1524117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524120 */     // MIs[0] policy
     /* 1524120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524130 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1524133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524154 */     // GIR_Coverage, 18297,
     /* 1524154 */     GIR_EraseRootFromParent_Done,
     /* 1524155 */   // Label 21206: @1524155
     /* 1524155 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1524237), // Rule ID 18300 //
     /* 1524160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524199 */     // MIs[0] round
     /* 1524199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524202 */     // MIs[0] policy
     /* 1524202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1524215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524236 */     // GIR_Coverage, 18300,
     /* 1524236 */     GIR_EraseRootFromParent_Done,
     /* 1524237 */   // Label 21207: @1524237
     /* 1524237 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1524319), // Rule ID 18301 //
     /* 1524242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524281 */     // MIs[0] round
     /* 1524281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524284 */     // MIs[0] policy
     /* 1524284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524294 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1524297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524318 */     // GIR_Coverage, 18301,
     /* 1524318 */     GIR_EraseRootFromParent_Done,
     /* 1524319 */   // Label 21208: @1524319
     /* 1524319 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1524401), // Rule ID 18304 //
     /* 1524324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524363 */     // MIs[0] round
     /* 1524363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524366 */     // MIs[0] policy
     /* 1524366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1524379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524400 */     // GIR_Coverage, 18304,
     /* 1524400 */     GIR_EraseRootFromParent_Done,
     /* 1524401 */   // Label 21209: @1524401
     /* 1524401 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1524483), // Rule ID 18305 //
     /* 1524406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524445 */     // MIs[0] round
     /* 1524445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524448 */     // MIs[0] policy
     /* 1524448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524458 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1524461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524482 */     // GIR_Coverage, 18305,
     /* 1524482 */     GIR_EraseRootFromParent_Done,
     /* 1524483 */   // Label 21210: @1524483
     /* 1524483 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1524565), // Rule ID 18308 //
     /* 1524488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524527 */     // MIs[0] round
     /* 1524527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524530 */     // MIs[0] policy
     /* 1524530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524564 */     // GIR_Coverage, 18308,
     /* 1524564 */     GIR_EraseRootFromParent_Done,
     /* 1524565 */   // Label 21211: @1524565
     /* 1524565 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1524647), // Rule ID 18309 //
     /* 1524570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524609 */     // MIs[0] round
     /* 1524609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524612 */     // MIs[0] policy
     /* 1524612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524646 */     // GIR_Coverage, 18309,
     /* 1524646 */     GIR_EraseRootFromParent_Done,
     /* 1524647 */   // Label 21212: @1524647
     /* 1524647 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1524729), // Rule ID 18312 //
     /* 1524652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524691 */     // MIs[0] round
     /* 1524691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524694 */     // MIs[0] policy
     /* 1524694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524728 */     // GIR_Coverage, 18312,
     /* 1524728 */     GIR_EraseRootFromParent_Done,
     /* 1524729 */   // Label 21213: @1524729
     /* 1524729 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1524811), // Rule ID 18313 //
     /* 1524734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524773 */     // MIs[0] round
     /* 1524773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524776 */     // MIs[0] policy
     /* 1524776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524786 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524810 */     // GIR_Coverage, 18313,
     /* 1524810 */     GIR_EraseRootFromParent_Done,
     /* 1524811 */   // Label 21214: @1524811
     /* 1524811 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1524893), // Rule ID 18316 //
     /* 1524816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524855 */     // MIs[0] round
     /* 1524855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524858 */     // MIs[0] policy
     /* 1524858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524892 */     // GIR_Coverage, 18316,
     /* 1524892 */     GIR_EraseRootFromParent_Done,
     /* 1524893 */   // Label 21215: @1524893
     /* 1524893 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1524975), // Rule ID 18317 //
     /* 1524898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524937 */     // MIs[0] round
     /* 1524937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524940 */     // MIs[0] policy
     /* 1524940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524950 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524974 */     // GIR_Coverage, 18317,
     /* 1524974 */     GIR_EraseRootFromParent_Done,
     /* 1524975 */   // Label 21216: @1524975
     /* 1524975 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1525057), // Rule ID 18320 //
     /* 1524980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525019 */     // MIs[0] round
     /* 1525019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525022 */     // MIs[0] policy
     /* 1525022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1525035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525056 */     // GIR_Coverage, 18320,
     /* 1525056 */     GIR_EraseRootFromParent_Done,
     /* 1525057 */   // Label 21217: @1525057
     /* 1525057 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1525139), // Rule ID 18321 //
     /* 1525062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525101 */     // MIs[0] round
     /* 1525101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525104 */     // MIs[0] policy
     /* 1525104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1525117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525138 */     // GIR_Coverage, 18321,
     /* 1525138 */     GIR_EraseRootFromParent_Done,
     /* 1525139 */   // Label 21218: @1525139
     /* 1525139 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1525221), // Rule ID 18324 //
     /* 1525144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525183 */     // MIs[0] round
     /* 1525183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525186 */     // MIs[0] policy
     /* 1525186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1525199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525220 */     // GIR_Coverage, 18324,
     /* 1525220 */     GIR_EraseRootFromParent_Done,
     /* 1525221 */   // Label 21219: @1525221
     /* 1525221 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1525303), // Rule ID 18325 //
     /* 1525226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525265 */     // MIs[0] round
     /* 1525265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525268 */     // MIs[0] policy
     /* 1525268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525278 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1525281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525302 */     // GIR_Coverage, 18325,
     /* 1525302 */     GIR_EraseRootFromParent_Done,
     /* 1525303 */   // Label 21220: @1525303
     /* 1525303 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1525385), // Rule ID 18328 //
     /* 1525308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525347 */     // MIs[0] round
     /* 1525347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525350 */     // MIs[0] policy
     /* 1525350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525360 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1525363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525384 */     // GIR_Coverage, 18328,
     /* 1525384 */     GIR_EraseRootFromParent_Done,
     /* 1525385 */   // Label 21221: @1525385
     /* 1525385 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1525467), // Rule ID 18329 //
     /* 1525390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1525407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1525425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525429 */     // MIs[0] round
     /* 1525429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525432 */     // MIs[0] policy
     /* 1525432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525442 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1525445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525466 */     // GIR_Coverage, 18329,
     /* 1525466 */     GIR_EraseRootFromParent_Done,
     /* 1525467 */   // Label 21222: @1525467
     /* 1525467 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1525549), // Rule ID 18332 //
     /* 1525472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525511 */     // MIs[0] round
     /* 1525511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525514 */     // MIs[0] policy
     /* 1525514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525548 */     // GIR_Coverage, 18332,
     /* 1525548 */     GIR_EraseRootFromParent_Done,
     /* 1525549 */   // Label 21223: @1525549
     /* 1525549 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1525631), // Rule ID 18333 //
     /* 1525554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525593 */     // MIs[0] round
     /* 1525593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525596 */     // MIs[0] policy
     /* 1525596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525630 */     // GIR_Coverage, 18333,
     /* 1525630 */     GIR_EraseRootFromParent_Done,
     /* 1525631 */   // Label 21224: @1525631
     /* 1525631 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1525713), // Rule ID 18336 //
     /* 1525636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525675 */     // MIs[0] round
     /* 1525675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525678 */     // MIs[0] policy
     /* 1525678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525712 */     // GIR_Coverage, 18336,
     /* 1525712 */     GIR_EraseRootFromParent_Done,
     /* 1525713 */   // Label 21225: @1525713
     /* 1525713 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1525795), // Rule ID 18337 //
     /* 1525718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525757 */     // MIs[0] round
     /* 1525757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525760 */     // MIs[0] policy
     /* 1525760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525794 */     // GIR_Coverage, 18337,
     /* 1525794 */     GIR_EraseRootFromParent_Done,
     /* 1525795 */   // Label 21226: @1525795
     /* 1525795 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1525877), // Rule ID 18340 //
     /* 1525800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525839 */     // MIs[0] round
     /* 1525839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525842 */     // MIs[0] policy
     /* 1525842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525876 */     // GIR_Coverage, 18340,
     /* 1525876 */     GIR_EraseRootFromParent_Done,
     /* 1525877 */   // Label 21227: @1525877
     /* 1525877 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1525959), // Rule ID 18341 //
     /* 1525882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525921 */     // MIs[0] round
     /* 1525921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525924 */     // MIs[0] policy
     /* 1525924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525958 */     // GIR_Coverage, 18341,
     /* 1525958 */     GIR_EraseRootFromParent_Done,
     /* 1525959 */   // Label 21228: @1525959
     /* 1525959 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1526041), // Rule ID 18344 //
     /* 1525964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526003 */     // MIs[0] round
     /* 1526003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526006 */     // MIs[0] policy
     /* 1526006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1526019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526040 */     // GIR_Coverage, 18344,
     /* 1526040 */     GIR_EraseRootFromParent_Done,
     /* 1526041 */   // Label 21229: @1526041
     /* 1526041 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1526123), // Rule ID 18345 //
     /* 1526046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526085 */     // MIs[0] round
     /* 1526085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526088 */     // MIs[0] policy
     /* 1526088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1526101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526122 */     // GIR_Coverage, 18345,
     /* 1526122 */     GIR_EraseRootFromParent_Done,
     /* 1526123 */   // Label 21230: @1526123
     /* 1526123 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1526205), // Rule ID 18348 //
     /* 1526128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526167 */     // MIs[0] round
     /* 1526167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526170 */     // MIs[0] policy
     /* 1526170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1526183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526204 */     // GIR_Coverage, 18348,
     /* 1526204 */     GIR_EraseRootFromParent_Done,
     /* 1526205 */   // Label 21231: @1526205
     /* 1526205 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1526287), // Rule ID 18349 //
     /* 1526210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526249 */     // MIs[0] round
     /* 1526249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526252 */     // MIs[0] policy
     /* 1526252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1526265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526286 */     // GIR_Coverage, 18349,
     /* 1526286 */     GIR_EraseRootFromParent_Done,
     /* 1526287 */   // Label 21232: @1526287
     /* 1526287 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1526369), // Rule ID 18352 //
     /* 1526292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526331 */     // MIs[0] round
     /* 1526331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526334 */     // MIs[0] policy
     /* 1526334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1526347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526368 */     // GIR_Coverage, 18352,
     /* 1526368 */     GIR_EraseRootFromParent_Done,
     /* 1526369 */   // Label 21233: @1526369
     /* 1526369 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1526451), // Rule ID 18353 //
     /* 1526374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1526382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1526391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1526409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526413 */     // MIs[0] round
     /* 1526413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526416 */     // MIs[0] policy
     /* 1526416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1526429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526450 */     // GIR_Coverage, 18353,
     /* 1526450 */     GIR_EraseRootFromParent_Done,
     /* 1526451 */   // Label 21234: @1526451
     /* 1526451 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1526533), // Rule ID 18356 //
     /* 1526456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526495 */     // MIs[0] round
     /* 1526495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526498 */     // MIs[0] policy
     /* 1526498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526508 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526532 */     // GIR_Coverage, 18356,
     /* 1526532 */     GIR_EraseRootFromParent_Done,
     /* 1526533 */   // Label 21235: @1526533
     /* 1526533 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1526615), // Rule ID 18357 //
     /* 1526538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526577 */     // MIs[0] round
     /* 1526577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526580 */     // MIs[0] policy
     /* 1526580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526590 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526614 */     // GIR_Coverage, 18357,
     /* 1526614 */     GIR_EraseRootFromParent_Done,
     /* 1526615 */   // Label 21236: @1526615
     /* 1526615 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1526697), // Rule ID 18360 //
     /* 1526620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526659 */     // MIs[0] round
     /* 1526659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526662 */     // MIs[0] policy
     /* 1526662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526696 */     // GIR_Coverage, 18360,
     /* 1526696 */     GIR_EraseRootFromParent_Done,
     /* 1526697 */   // Label 21237: @1526697
     /* 1526697 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1526779), // Rule ID 18361 //
     /* 1526702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526741 */     // MIs[0] round
     /* 1526741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526744 */     // MIs[0] policy
     /* 1526744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526778 */     // GIR_Coverage, 18361,
     /* 1526778 */     GIR_EraseRootFromParent_Done,
     /* 1526779 */   // Label 21238: @1526779
     /* 1526779 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1526861), // Rule ID 18364 //
     /* 1526784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526823 */     // MIs[0] round
     /* 1526823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526826 */     // MIs[0] policy
     /* 1526826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526860 */     // GIR_Coverage, 18364,
     /* 1526860 */     GIR_EraseRootFromParent_Done,
     /* 1526861 */   // Label 21239: @1526861
     /* 1526861 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1526943), // Rule ID 18365 //
     /* 1526866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526905 */     // MIs[0] round
     /* 1526905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526908 */     // MIs[0] policy
     /* 1526908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526918 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526942 */     // GIR_Coverage, 18365,
     /* 1526942 */     GIR_EraseRootFromParent_Done,
     /* 1526943 */   // Label 21240: @1526943
     /* 1526943 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1527025), // Rule ID 18368 //
     /* 1526948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526987 */     // MIs[0] round
     /* 1526987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526990 */     // MIs[0] policy
     /* 1526990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1527003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527024 */     // GIR_Coverage, 18368,
     /* 1527024 */     GIR_EraseRootFromParent_Done,
     /* 1527025 */   // Label 21241: @1527025
     /* 1527025 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1527107), // Rule ID 18369 //
     /* 1527030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1527047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527069 */     // MIs[0] round
     /* 1527069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527072 */     // MIs[0] policy
     /* 1527072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527082 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1527085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527106 */     // GIR_Coverage, 18369,
     /* 1527106 */     GIR_EraseRootFromParent_Done,
     /* 1527107 */   // Label 21242: @1527107
     /* 1527107 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1527189), // Rule ID 18372 //
     /* 1527112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1527129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527151 */     // MIs[0] round
     /* 1527151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527154 */     // MIs[0] policy
     /* 1527154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1527167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527188 */     // GIR_Coverage, 18372,
     /* 1527188 */     GIR_EraseRootFromParent_Done,
     /* 1527189 */   // Label 21243: @1527189
     /* 1527189 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1527271), // Rule ID 18373 //
     /* 1527194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1527211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527233 */     // MIs[0] round
     /* 1527233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527236 */     // MIs[0] policy
     /* 1527236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527246 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1527249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527270 */     // GIR_Coverage, 18373,
     /* 1527270 */     GIR_EraseRootFromParent_Done,
     /* 1527271 */   // Label 21244: @1527271
     /* 1527271 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1527353), // Rule ID 18376 //
     /* 1527276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1527293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527315 */     // MIs[0] round
     /* 1527315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527318 */     // MIs[0] policy
     /* 1527318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1527331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527352 */     // GIR_Coverage, 18376,
     /* 1527352 */     GIR_EraseRootFromParent_Done,
     /* 1527353 */   // Label 21245: @1527353
     /* 1527353 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1527435), // Rule ID 18377 //
     /* 1527358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1527375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527397 */     // MIs[0] round
     /* 1527397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527400 */     // MIs[0] policy
     /* 1527400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1527413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527434 */     // GIR_Coverage, 18377,
     /* 1527434 */     GIR_EraseRootFromParent_Done,
     /* 1527435 */   // Label 21246: @1527435
     /* 1527435 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1527517), // Rule ID 18380 //
     /* 1527440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527479 */     // MIs[0] round
     /* 1527479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527482 */     // MIs[0] policy
     /* 1527482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527516 */     // GIR_Coverage, 18380,
     /* 1527516 */     GIR_EraseRootFromParent_Done,
     /* 1527517 */   // Label 21247: @1527517
     /* 1527517 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1527599), // Rule ID 18381 //
     /* 1527522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527561 */     // MIs[0] round
     /* 1527561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527564 */     // MIs[0] policy
     /* 1527564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527598 */     // GIR_Coverage, 18381,
     /* 1527598 */     GIR_EraseRootFromParent_Done,
     /* 1527599 */   // Label 21248: @1527599
     /* 1527599 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1527681), // Rule ID 18384 //
     /* 1527604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527643 */     // MIs[0] round
     /* 1527643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527646 */     // MIs[0] policy
     /* 1527646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527680 */     // GIR_Coverage, 18384,
     /* 1527680 */     GIR_EraseRootFromParent_Done,
     /* 1527681 */   // Label 21249: @1527681
     /* 1527681 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1527763), // Rule ID 18385 //
     /* 1527686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527725 */     // MIs[0] round
     /* 1527725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527728 */     // MIs[0] policy
     /* 1527728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527738 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527762 */     // GIR_Coverage, 18385,
     /* 1527762 */     GIR_EraseRootFromParent_Done,
     /* 1527763 */   // Label 21250: @1527763
     /* 1527763 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1527845), // Rule ID 18388 //
     /* 1527768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527807 */     // MIs[0] round
     /* 1527807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527810 */     // MIs[0] policy
     /* 1527810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527820 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527844 */     // GIR_Coverage, 18388,
     /* 1527844 */     GIR_EraseRootFromParent_Done,
     /* 1527845 */   // Label 21251: @1527845
     /* 1527845 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1527927), // Rule ID 18389 //
     /* 1527850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527889 */     // MIs[0] round
     /* 1527889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527892 */     // MIs[0] policy
     /* 1527892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527902 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527926 */     // GIR_Coverage, 18389,
     /* 1527926 */     GIR_EraseRootFromParent_Done,
     /* 1527927 */   // Label 21252: @1527927
     /* 1527927 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1528009), // Rule ID 18392 //
     /* 1527932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527971 */     // MIs[0] round
     /* 1527971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527974 */     // MIs[0] policy
     /* 1527974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528008 */     // GIR_Coverage, 18392,
     /* 1528008 */     GIR_EraseRootFromParent_Done,
     /* 1528009 */   // Label 21253: @1528009
     /* 1528009 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1528091), // Rule ID 18393 //
     /* 1528014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1528031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528053 */     // MIs[0] round
     /* 1528053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528056 */     // MIs[0] policy
     /* 1528056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1528069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528090 */     // GIR_Coverage, 18393,
     /* 1528090 */     GIR_EraseRootFromParent_Done,
     /* 1528091 */   // Label 21254: @1528091
     /* 1528091 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1528173), // Rule ID 18396 //
     /* 1528096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1528113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528135 */     // MIs[0] round
     /* 1528135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528138 */     // MIs[0] policy
     /* 1528138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1528151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528172 */     // GIR_Coverage, 18396,
     /* 1528172 */     GIR_EraseRootFromParent_Done,
     /* 1528173 */   // Label 21255: @1528173
     /* 1528173 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1528255), // Rule ID 18397 //
     /* 1528178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1528195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528217 */     // MIs[0] round
     /* 1528217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528220 */     // MIs[0] policy
     /* 1528220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1528233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528254 */     // GIR_Coverage, 18397,
     /* 1528254 */     GIR_EraseRootFromParent_Done,
     /* 1528255 */   // Label 21256: @1528255
     /* 1528255 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1528337), // Rule ID 18400 //
     /* 1528260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1528277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528299 */     // MIs[0] round
     /* 1528299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528302 */     // MIs[0] policy
     /* 1528302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1528315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528336 */     // GIR_Coverage, 18400,
     /* 1528336 */     GIR_EraseRootFromParent_Done,
     /* 1528337 */   // Label 21257: @1528337
     /* 1528337 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1528419), // Rule ID 18401 //
     /* 1528342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1528359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528381 */     // MIs[0] round
     /* 1528381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528384 */     // MIs[0] policy
     /* 1528384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528394 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1528397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528418 */     // GIR_Coverage, 18401,
     /* 1528418 */     GIR_EraseRootFromParent_Done,
     /* 1528419 */   // Label 21258: @1528419
     /* 1528419 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1528501), // Rule ID 18404 //
     /* 1528424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528463 */     // MIs[0] round
     /* 1528463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528466 */     // MIs[0] policy
     /* 1528466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528500 */     // GIR_Coverage, 18404,
     /* 1528500 */     GIR_EraseRootFromParent_Done,
     /* 1528501 */   // Label 21259: @1528501
     /* 1528501 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1528583), // Rule ID 18405 //
     /* 1528506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528545 */     // MIs[0] round
     /* 1528545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528548 */     // MIs[0] policy
     /* 1528548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528582 */     // GIR_Coverage, 18405,
     /* 1528582 */     GIR_EraseRootFromParent_Done,
     /* 1528583 */   // Label 21260: @1528583
     /* 1528583 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1528665), // Rule ID 18408 //
     /* 1528588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528627 */     // MIs[0] round
     /* 1528627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528630 */     // MIs[0] policy
     /* 1528630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528640 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528664 */     // GIR_Coverage, 18408,
     /* 1528664 */     GIR_EraseRootFromParent_Done,
     /* 1528665 */   // Label 21261: @1528665
     /* 1528665 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1528747), // Rule ID 18409 //
     /* 1528670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528709 */     // MIs[0] round
     /* 1528709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528712 */     // MIs[0] policy
     /* 1528712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528722 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528746 */     // GIR_Coverage, 18409,
     /* 1528746 */     GIR_EraseRootFromParent_Done,
     /* 1528747 */   // Label 21262: @1528747
     /* 1528747 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1528829), // Rule ID 18412 //
     /* 1528752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528791 */     // MIs[0] round
     /* 1528791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528794 */     // MIs[0] policy
     /* 1528794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528828 */     // GIR_Coverage, 18412,
     /* 1528828 */     GIR_EraseRootFromParent_Done,
     /* 1528829 */   // Label 21263: @1528829
     /* 1528829 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1528911), // Rule ID 18413 //
     /* 1528834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528873 */     // MIs[0] round
     /* 1528873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528876 */     // MIs[0] policy
     /* 1528876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528886 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528910 */     // GIR_Coverage, 18413,
     /* 1528910 */     GIR_EraseRootFromParent_Done,
     /* 1528911 */   // Label 21264: @1528911
     /* 1528911 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1528993), // Rule ID 18416 //
     /* 1528916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528955 */     // MIs[0] round
     /* 1528955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528958 */     // MIs[0] policy
     /* 1528958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528968 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528992 */     // GIR_Coverage, 18416,
     /* 1528992 */     GIR_EraseRootFromParent_Done,
     /* 1528993 */   // Label 21265: @1528993
     /* 1528993 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1529075), // Rule ID 18417 //
     /* 1528998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529037 */     // MIs[0] round
     /* 1529037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529040 */     // MIs[0] policy
     /* 1529040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1529053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529074 */     // GIR_Coverage, 18417,
     /* 1529074 */     GIR_EraseRootFromParent_Done,
     /* 1529075 */   // Label 21266: @1529075
     /* 1529075 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1529157), // Rule ID 18420 //
     /* 1529080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529119 */     // MIs[0] round
     /* 1529119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529122 */     // MIs[0] policy
     /* 1529122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1529135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529156 */     // GIR_Coverage, 18420,
     /* 1529156 */     GIR_EraseRootFromParent_Done,
     /* 1529157 */   // Label 21267: @1529157
     /* 1529157 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1529239), // Rule ID 18421 //
     /* 1529162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529201 */     // MIs[0] round
     /* 1529201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529204 */     // MIs[0] policy
     /* 1529204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529214 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1529217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529238 */     // GIR_Coverage, 18421,
     /* 1529238 */     GIR_EraseRootFromParent_Done,
     /* 1529239 */   // Label 21268: @1529239
     /* 1529239 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1529321), // Rule ID 18424 //
     /* 1529244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529283 */     // MIs[0] round
     /* 1529283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529286 */     // MIs[0] policy
     /* 1529286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1529299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529320 */     // GIR_Coverage, 18424,
     /* 1529320 */     GIR_EraseRootFromParent_Done,
     /* 1529321 */   // Label 21269: @1529321
     /* 1529321 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1529403), // Rule ID 18425 //
     /* 1529326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529365 */     // MIs[0] round
     /* 1529365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529368 */     // MIs[0] policy
     /* 1529368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529378 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1529381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529402 */     // GIR_Coverage, 18425,
     /* 1529402 */     GIR_EraseRootFromParent_Done,
     /* 1529403 */   // Label 21270: @1529403
     /* 1529403 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1529485), // Rule ID 18428 //
     /* 1529408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529447 */     // MIs[0] round
     /* 1529447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529450 */     // MIs[0] policy
     /* 1529450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529484 */     // GIR_Coverage, 18428,
     /* 1529484 */     GIR_EraseRootFromParent_Done,
     /* 1529485 */   // Label 21271: @1529485
     /* 1529485 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1529567), // Rule ID 18429 //
     /* 1529490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529529 */     // MIs[0] round
     /* 1529529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529532 */     // MIs[0] policy
     /* 1529532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11299:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529566 */     // GIR_Coverage, 18429,
     /* 1529566 */     GIR_EraseRootFromParent_Done,
     /* 1529567 */   // Label 21272: @1529567
     /* 1529567 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1529649), // Rule ID 18432 //
     /* 1529572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529611 */     // MIs[0] round
     /* 1529611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529614 */     // MIs[0] policy
     /* 1529614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529648 */     // GIR_Coverage, 18432,
     /* 1529648 */     GIR_EraseRootFromParent_Done,
     /* 1529649 */   // Label 21273: @1529649
     /* 1529649 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1529731), // Rule ID 18433 //
     /* 1529654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529693 */     // MIs[0] round
     /* 1529693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529696 */     // MIs[0] policy
     /* 1529696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529706 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529730 */     // GIR_Coverage, 18433,
     /* 1529730 */     GIR_EraseRootFromParent_Done,
     /* 1529731 */   // Label 21274: @1529731
     /* 1529731 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1529813), // Rule ID 18436 //
     /* 1529736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529775 */     // MIs[0] round
     /* 1529775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529778 */     // MIs[0] policy
     /* 1529778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529788 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529812 */     // GIR_Coverage, 18436,
     /* 1529812 */     GIR_EraseRootFromParent_Done,
     /* 1529813 */   // Label 21275: @1529813
     /* 1529813 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1529895), // Rule ID 18437 //
     /* 1529818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529857 */     // MIs[0] round
     /* 1529857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529860 */     // MIs[0] policy
     /* 1529860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529894 */     // GIR_Coverage, 18437,
     /* 1529894 */     GIR_EraseRootFromParent_Done,
     /* 1529895 */   // Label 21276: @1529895
     /* 1529895 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1529977), // Rule ID 18440 //
     /* 1529900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529939 */     // MIs[0] round
     /* 1529939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529942 */     // MIs[0] policy
     /* 1529942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529952 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529976 */     // GIR_Coverage, 18440,
     /* 1529976 */     GIR_EraseRootFromParent_Done,
     /* 1529977 */   // Label 21277: @1529977
     /* 1529977 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1530059), // Rule ID 18441 //
     /* 1529982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530021 */     // MIs[0] round
     /* 1530021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530024 */     // MIs[0] policy
     /* 1530024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530034 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1530037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530058 */     // GIR_Coverage, 18441,
     /* 1530058 */     GIR_EraseRootFromParent_Done,
     /* 1530059 */   // Label 21278: @1530059
     /* 1530059 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1530141), // Rule ID 18444 //
     /* 1530064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530103 */     // MIs[0] round
     /* 1530103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530106 */     // MIs[0] policy
     /* 1530106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1530119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530140 */     // GIR_Coverage, 18444,
     /* 1530140 */     GIR_EraseRootFromParent_Done,
     /* 1530141 */   // Label 21279: @1530141
     /* 1530141 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1530223), // Rule ID 18445 //
     /* 1530146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530185 */     // MIs[0] round
     /* 1530185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530188 */     // MIs[0] policy
     /* 1530188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530198 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1530201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530222 */     // GIR_Coverage, 18445,
     /* 1530222 */     GIR_EraseRootFromParent_Done,
     /* 1530223 */   // Label 21280: @1530223
     /* 1530223 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1530305), // Rule ID 18448 //
     /* 1530228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530267 */     // MIs[0] round
     /* 1530267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530270 */     // MIs[0] policy
     /* 1530270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530280 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1530283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530304 */     // GIR_Coverage, 18448,
     /* 1530304 */     GIR_EraseRootFromParent_Done,
     /* 1530305 */   // Label 21281: @1530305
     /* 1530305 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1530387), // Rule ID 18449 //
     /* 1530310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1530327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1530345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530349 */     // MIs[0] round
     /* 1530349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530352 */     // MIs[0] policy
     /* 1530352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530362 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1530365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530386 */     // GIR_Coverage, 18449,
     /* 1530386 */     GIR_EraseRootFromParent_Done,
     /* 1530387 */   // Label 21282: @1530387
     /* 1530387 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1530469), // Rule ID 18452 //
     /* 1530392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530431 */     // MIs[0] round
     /* 1530431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530434 */     // MIs[0] policy
     /* 1530434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530468 */     // GIR_Coverage, 18452,
     /* 1530468 */     GIR_EraseRootFromParent_Done,
     /* 1530469 */   // Label 21283: @1530469
     /* 1530469 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1530551), // Rule ID 18453 //
     /* 1530474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530513 */     // MIs[0] round
     /* 1530513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530516 */     // MIs[0] policy
     /* 1530516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530526 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530550 */     // GIR_Coverage, 18453,
     /* 1530550 */     GIR_EraseRootFromParent_Done,
     /* 1530551 */   // Label 21284: @1530551
     /* 1530551 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1530633), // Rule ID 18456 //
     /* 1530556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530595 */     // MIs[0] round
     /* 1530595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530598 */     // MIs[0] policy
     /* 1530598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530608 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530632 */     // GIR_Coverage, 18456,
     /* 1530632 */     GIR_EraseRootFromParent_Done,
     /* 1530633 */   // Label 21285: @1530633
     /* 1530633 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1530715), // Rule ID 18457 //
     /* 1530638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530677 */     // MIs[0] round
     /* 1530677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530680 */     // MIs[0] policy
     /* 1530680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530714 */     // GIR_Coverage, 18457,
     /* 1530714 */     GIR_EraseRootFromParent_Done,
     /* 1530715 */   // Label 21286: @1530715
     /* 1530715 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1530797), // Rule ID 18460 //
     /* 1530720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530759 */     // MIs[0] round
     /* 1530759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530762 */     // MIs[0] policy
     /* 1530762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530772 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530796 */     // GIR_Coverage, 18460,
     /* 1530796 */     GIR_EraseRootFromParent_Done,
     /* 1530797 */   // Label 21287: @1530797
     /* 1530797 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1530879), // Rule ID 18461 //
     /* 1530802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530841 */     // MIs[0] round
     /* 1530841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530844 */     // MIs[0] policy
     /* 1530844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530854 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530878 */     // GIR_Coverage, 18461,
     /* 1530878 */     GIR_EraseRootFromParent_Done,
     /* 1530879 */   // Label 21288: @1530879
     /* 1530879 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1530961), // Rule ID 18464 //
     /* 1530884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530923 */     // MIs[0] round
     /* 1530923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530926 */     // MIs[0] policy
     /* 1530926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530960 */     // GIR_Coverage, 18464,
     /* 1530960 */     GIR_EraseRootFromParent_Done,
     /* 1530961 */   // Label 21289: @1530961
     /* 1530961 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1531043), // Rule ID 18465 //
     /* 1530966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531005 */     // MIs[0] round
     /* 1531005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531008 */     // MIs[0] policy
     /* 1531008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531018 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1531021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531042 */     // GIR_Coverage, 18465,
     /* 1531042 */     GIR_EraseRootFromParent_Done,
     /* 1531043 */   // Label 21290: @1531043
     /* 1531043 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1531125), // Rule ID 18468 //
     /* 1531048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531087 */     // MIs[0] round
     /* 1531087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531090 */     // MIs[0] policy
     /* 1531090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1531103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531124 */     // GIR_Coverage, 18468,
     /* 1531124 */     GIR_EraseRootFromParent_Done,
     /* 1531125 */   // Label 21291: @1531125
     /* 1531125 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1531207), // Rule ID 18469 //
     /* 1531130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531169 */     // MIs[0] round
     /* 1531169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531172 */     // MIs[0] policy
     /* 1531172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1531185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531206 */     // GIR_Coverage, 18469,
     /* 1531206 */     GIR_EraseRootFromParent_Done,
     /* 1531207 */   // Label 21292: @1531207
     /* 1531207 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1531289), // Rule ID 18472 //
     /* 1531212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531251 */     // MIs[0] round
     /* 1531251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531254 */     // MIs[0] policy
     /* 1531254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531264 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1531267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531288 */     // GIR_Coverage, 18472,
     /* 1531288 */     GIR_EraseRootFromParent_Done,
     /* 1531289 */   // Label 21293: @1531289
     /* 1531289 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1531371), // Rule ID 18473 //
     /* 1531294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1531302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531333 */     // MIs[0] round
     /* 1531333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531336 */     // MIs[0] policy
     /* 1531336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531346 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1531349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531370 */     // GIR_Coverage, 18473,
     /* 1531370 */     GIR_EraseRootFromParent_Done,
     /* 1531371 */   // Label 21294: @1531371
     /* 1531371 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1531453), // Rule ID 18476 //
     /* 1531376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531415 */     // MIs[0] round
     /* 1531415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531418 */     // MIs[0] policy
     /* 1531418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531428 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531452 */     // GIR_Coverage, 18476,
     /* 1531452 */     GIR_EraseRootFromParent_Done,
     /* 1531453 */   // Label 21295: @1531453
     /* 1531453 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1531535), // Rule ID 18477 //
     /* 1531458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531497 */     // MIs[0] round
     /* 1531497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531500 */     // MIs[0] policy
     /* 1531500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531510 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531534 */     // GIR_Coverage, 18477,
     /* 1531534 */     GIR_EraseRootFromParent_Done,
     /* 1531535 */   // Label 21296: @1531535
     /* 1531535 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1531617), // Rule ID 18480 //
     /* 1531540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531579 */     // MIs[0] round
     /* 1531579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531582 */     // MIs[0] policy
     /* 1531582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531616 */     // GIR_Coverage, 18480,
     /* 1531616 */     GIR_EraseRootFromParent_Done,
     /* 1531617 */   // Label 21297: @1531617
     /* 1531617 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1531699), // Rule ID 18481 //
     /* 1531622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531661 */     // MIs[0] round
     /* 1531661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531664 */     // MIs[0] policy
     /* 1531664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531698 */     // GIR_Coverage, 18481,
     /* 1531698 */     GIR_EraseRootFromParent_Done,
     /* 1531699 */   // Label 21298: @1531699
     /* 1531699 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1531781), // Rule ID 18484 //
     /* 1531704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531743 */     // MIs[0] round
     /* 1531743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531746 */     // MIs[0] policy
     /* 1531746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531780 */     // GIR_Coverage, 18484,
     /* 1531780 */     GIR_EraseRootFromParent_Done,
     /* 1531781 */   // Label 21299: @1531781
     /* 1531781 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1531863), // Rule ID 18485 //
     /* 1531786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531825 */     // MIs[0] round
     /* 1531825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531828 */     // MIs[0] policy
     /* 1531828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531838 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531862 */     // GIR_Coverage, 18485,
     /* 1531862 */     GIR_EraseRootFromParent_Done,
     /* 1531863 */   // Label 21300: @1531863
     /* 1531863 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1531945), // Rule ID 18488 //
     /* 1531868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531907 */     // MIs[0] round
     /* 1531907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531910 */     // MIs[0] policy
     /* 1531910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531920 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531944 */     // GIR_Coverage, 18488,
     /* 1531944 */     GIR_EraseRootFromParent_Done,
     /* 1531945 */   // Label 21301: @1531945
     /* 1531945 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1532027), // Rule ID 18489 //
     /* 1531950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531989 */     // MIs[0] round
     /* 1531989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531992 */     // MIs[0] policy
     /* 1531992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1532005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532026 */     // GIR_Coverage, 18489,
     /* 1532026 */     GIR_EraseRootFromParent_Done,
     /* 1532027 */   // Label 21302: @1532027
     /* 1532027 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1532109), // Rule ID 18492 //
     /* 1532032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1532049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532071 */     // MIs[0] round
     /* 1532071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532074 */     // MIs[0] policy
     /* 1532074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1532087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532108 */     // GIR_Coverage, 18492,
     /* 1532108 */     GIR_EraseRootFromParent_Done,
     /* 1532109 */   // Label 21303: @1532109
     /* 1532109 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1532191), // Rule ID 18493 //
     /* 1532114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1532131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532153 */     // MIs[0] round
     /* 1532153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532156 */     // MIs[0] policy
     /* 1532156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532166 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1532169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532190 */     // GIR_Coverage, 18493,
     /* 1532190 */     GIR_EraseRootFromParent_Done,
     /* 1532191 */   // Label 21304: @1532191
     /* 1532191 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1532273), // Rule ID 18496 //
     /* 1532196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1532213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532235 */     // MIs[0] round
     /* 1532235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532238 */     // MIs[0] policy
     /* 1532238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1532251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532272 */     // GIR_Coverage, 18496,
     /* 1532272 */     GIR_EraseRootFromParent_Done,
     /* 1532273 */   // Label 21305: @1532273
     /* 1532273 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1532355), // Rule ID 18497 //
     /* 1532278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1532295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532317 */     // MIs[0] round
     /* 1532317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532320 */     // MIs[0] policy
     /* 1532320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1532333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532354 */     // GIR_Coverage, 18497,
     /* 1532354 */     GIR_EraseRootFromParent_Done,
     /* 1532355 */   // Label 21306: @1532355
     /* 1532355 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1532437), // Rule ID 18500 //
     /* 1532360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532399 */     // MIs[0] round
     /* 1532399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532402 */     // MIs[0] policy
     /* 1532402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532436 */     // GIR_Coverage, 18500,
     /* 1532436 */     GIR_EraseRootFromParent_Done,
     /* 1532437 */   // Label 21307: @1532437
     /* 1532437 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1532519), // Rule ID 18501 //
     /* 1532442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1532459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532481 */     // MIs[0] round
     /* 1532481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532484 */     // MIs[0] policy
     /* 1532484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532518 */     // GIR_Coverage, 18501,
     /* 1532518 */     GIR_EraseRootFromParent_Done,
     /* 1532519 */   // Label 21308: @1532519
     /* 1532519 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1532601), // Rule ID 18504 //
     /* 1532524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532563 */     // MIs[0] round
     /* 1532563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532566 */     // MIs[0] policy
     /* 1532566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532576 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532600 */     // GIR_Coverage, 18504,
     /* 1532600 */     GIR_EraseRootFromParent_Done,
     /* 1532601 */   // Label 21309: @1532601
     /* 1532601 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1532683), // Rule ID 18505 //
     /* 1532606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532645 */     // MIs[0] round
     /* 1532645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532648 */     // MIs[0] policy
     /* 1532648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532658 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532682 */     // GIR_Coverage, 18505,
     /* 1532682 */     GIR_EraseRootFromParent_Done,
     /* 1532683 */   // Label 21310: @1532683
     /* 1532683 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1532765), // Rule ID 18508 //
     /* 1532688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532727 */     // MIs[0] round
     /* 1532727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532730 */     // MIs[0] policy
     /* 1532730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532740 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532764 */     // GIR_Coverage, 18508,
     /* 1532764 */     GIR_EraseRootFromParent_Done,
     /* 1532765 */   // Label 21311: @1532765
     /* 1532765 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1532847), // Rule ID 18509 //
     /* 1532770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532809 */     // MIs[0] round
     /* 1532809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532812 */     // MIs[0] policy
     /* 1532812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532846 */     // GIR_Coverage, 18509,
     /* 1532846 */     GIR_EraseRootFromParent_Done,
     /* 1532847 */   // Label 21312: @1532847
     /* 1532847 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1532929), // Rule ID 18512 //
     /* 1532852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532891 */     // MIs[0] round
     /* 1532891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532894 */     // MIs[0] policy
     /* 1532894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532928 */     // GIR_Coverage, 18512,
     /* 1532928 */     GIR_EraseRootFromParent_Done,
     /* 1532929 */   // Label 21313: @1532929
     /* 1532929 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1533011), // Rule ID 18513 //
     /* 1532934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532973 */     // MIs[0] round
     /* 1532973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532976 */     // MIs[0] policy
     /* 1532976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533010 */     // GIR_Coverage, 18513,
     /* 1533010 */     GIR_EraseRootFromParent_Done,
     /* 1533011 */   // Label 21314: @1533011
     /* 1533011 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1533093), // Rule ID 18516 //
     /* 1533016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533055 */     // MIs[0] round
     /* 1533055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533058 */     // MIs[0] policy
     /* 1533058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1533071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533092 */     // GIR_Coverage, 18516,
     /* 1533092 */     GIR_EraseRootFromParent_Done,
     /* 1533093 */   // Label 21315: @1533093
     /* 1533093 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1533175), // Rule ID 18517 //
     /* 1533098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1533115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533137 */     // MIs[0] round
     /* 1533137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533140 */     // MIs[0] policy
     /* 1533140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1533153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533174 */     // GIR_Coverage, 18517,
     /* 1533174 */     GIR_EraseRootFromParent_Done,
     /* 1533175 */   // Label 21316: @1533175
     /* 1533175 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1533257), // Rule ID 18520 //
     /* 1533180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533219 */     // MIs[0] round
     /* 1533219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533222 */     // MIs[0] policy
     /* 1533222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533232 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1533235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533256 */     // GIR_Coverage, 18520,
     /* 1533256 */     GIR_EraseRootFromParent_Done,
     /* 1533257 */   // Label 21317: @1533257
     /* 1533257 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1533339), // Rule ID 18521 //
     /* 1533262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1533279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533301 */     // MIs[0] round
     /* 1533301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533304 */     // MIs[0] policy
     /* 1533304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533314 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1533317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533338 */     // GIR_Coverage, 18521,
     /* 1533338 */     GIR_EraseRootFromParent_Done,
     /* 1533339 */   // Label 21318: @1533339
     /* 1533339 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1533421), // Rule ID 18524 //
     /* 1533344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1533361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533383 */     // MIs[0] round
     /* 1533383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533386 */     // MIs[0] policy
     /* 1533386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533420 */     // GIR_Coverage, 18524,
     /* 1533420 */     GIR_EraseRootFromParent_Done,
     /* 1533421 */   // Label 21319: @1533421
     /* 1533421 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1533503), // Rule ID 18525 //
     /* 1533426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1533443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533465 */     // MIs[0] round
     /* 1533465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533468 */     // MIs[0] policy
     /* 1533468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533478 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533502 */     // GIR_Coverage, 18525,
     /* 1533502 */     GIR_EraseRootFromParent_Done,
     /* 1533503 */   // Label 21320: @1533503
     /* 1533503 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1533585), // Rule ID 18528 //
     /* 1533508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533547 */     // MIs[0] round
     /* 1533547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533550 */     // MIs[0] policy
     /* 1533550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533560 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533584 */     // GIR_Coverage, 18528,
     /* 1533584 */     GIR_EraseRootFromParent_Done,
     /* 1533585 */   // Label 21321: @1533585
     /* 1533585 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1533667), // Rule ID 18529 //
     /* 1533590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533629 */     // MIs[0] round
     /* 1533629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533632 */     // MIs[0] policy
     /* 1533632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533642 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533666 */     // GIR_Coverage, 18529,
     /* 1533666 */     GIR_EraseRootFromParent_Done,
     /* 1533667 */   // Label 21322: @1533667
     /* 1533667 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1533749), // Rule ID 18532 //
     /* 1533672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533711 */     // MIs[0] round
     /* 1533711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533714 */     // MIs[0] policy
     /* 1533714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533748 */     // GIR_Coverage, 18532,
     /* 1533748 */     GIR_EraseRootFromParent_Done,
     /* 1533749 */   // Label 21323: @1533749
     /* 1533749 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1533831), // Rule ID 18533 //
     /* 1533754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533793 */     // MIs[0] round
     /* 1533793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533796 */     // MIs[0] policy
     /* 1533796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533806 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533830 */     // GIR_Coverage, 18533,
     /* 1533830 */     GIR_EraseRootFromParent_Done,
     /* 1533831 */   // Label 21324: @1533831
     /* 1533831 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1533913), // Rule ID 18536 //
     /* 1533836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533875 */     // MIs[0] round
     /* 1533875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533878 */     // MIs[0] policy
     /* 1533878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533912 */     // GIR_Coverage, 18536,
     /* 1533912 */     GIR_EraseRootFromParent_Done,
     /* 1533913 */   // Label 21325: @1533913
     /* 1533913 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1533995), // Rule ID 18537 //
     /* 1533918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533957 */     // MIs[0] round
     /* 1533957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533960 */     // MIs[0] policy
     /* 1533960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533970 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533994 */     // GIR_Coverage, 18537,
     /* 1533994 */     GIR_EraseRootFromParent_Done,
     /* 1533995 */   // Label 21326: @1533995
     /* 1533995 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1534077), // Rule ID 18540 //
     /* 1534000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534039 */     // MIs[0] round
     /* 1534039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534042 */     // MIs[0] policy
     /* 1534042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1534055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534076 */     // GIR_Coverage, 18540,
     /* 1534076 */     GIR_EraseRootFromParent_Done,
     /* 1534077 */   // Label 21327: @1534077
     /* 1534077 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1534159), // Rule ID 18541 //
     /* 1534082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1534093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1534096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534121 */     // MIs[0] round
     /* 1534121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534124 */     // MIs[0] policy
     /* 1534124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1534137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534158 */     // GIR_Coverage, 18541,
     /* 1534158 */     GIR_EraseRootFromParent_Done,
     /* 1534159 */   // Label 21328: @1534159
     /* 1534159 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1534241), // Rule ID 18544 //
     /* 1534164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534203 */     // MIs[0] round
     /* 1534203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534206 */     // MIs[0] policy
     /* 1534206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1534219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534240 */     // GIR_Coverage, 18544,
     /* 1534240 */     GIR_EraseRootFromParent_Done,
     /* 1534241 */   // Label 21329: @1534241
     /* 1534241 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1534323), // Rule ID 18545 //
     /* 1534246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534285 */     // MIs[0] round
     /* 1534285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534288 */     // MIs[0] policy
     /* 1534288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534298 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1534301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534322 */     // GIR_Coverage, 18545,
     /* 1534322 */     GIR_EraseRootFromParent_Done,
     /* 1534323 */   // Label 21330: @1534323
     /* 1534323 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1534405), // Rule ID 18548 //
     /* 1534328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534367 */     // MIs[0] round
     /* 1534367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534370 */     // MIs[0] policy
     /* 1534370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1534383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534404 */     // GIR_Coverage, 18548,
     /* 1534404 */     GIR_EraseRootFromParent_Done,
     /* 1534405 */   // Label 21331: @1534405
     /* 1534405 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1534487), // Rule ID 18549 //
     /* 1534410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534449 */     // MIs[0] round
     /* 1534449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534452 */     // MIs[0] policy
     /* 1534452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1534465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534486 */     // GIR_Coverage, 18549,
     /* 1534486 */     GIR_EraseRootFromParent_Done,
     /* 1534487 */   // Label 21332: @1534487
     /* 1534487 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1534569), // Rule ID 18552 //
     /* 1534492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534531 */     // MIs[0] round
     /* 1534531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534534 */     // MIs[0] policy
     /* 1534534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534568 */     // GIR_Coverage, 18552,
     /* 1534568 */     GIR_EraseRootFromParent_Done,
     /* 1534569 */   // Label 21333: @1534569
     /* 1534569 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1534651), // Rule ID 18553 //
     /* 1534574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534613 */     // MIs[0] round
     /* 1534613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534616 */     // MIs[0] policy
     /* 1534616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534626 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534650 */     // GIR_Coverage, 18553,
     /* 1534650 */     GIR_EraseRootFromParent_Done,
     /* 1534651 */   // Label 21334: @1534651
     /* 1534651 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1534733), // Rule ID 18556 //
     /* 1534656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534695 */     // MIs[0] round
     /* 1534695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534698 */     // MIs[0] policy
     /* 1534698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534732 */     // GIR_Coverage, 18556,
     /* 1534732 */     GIR_EraseRootFromParent_Done,
     /* 1534733 */   // Label 21335: @1534733
     /* 1534733 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1534815), // Rule ID 18557 //
     /* 1534738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534777 */     // MIs[0] round
     /* 1534777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534780 */     // MIs[0] policy
     /* 1534780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534790 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534814 */     // GIR_Coverage, 18557,
     /* 1534814 */     GIR_EraseRootFromParent_Done,
     /* 1534815 */   // Label 21336: @1534815
     /* 1534815 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1534897), // Rule ID 18560 //
     /* 1534820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534859 */     // MIs[0] round
     /* 1534859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534862 */     // MIs[0] policy
     /* 1534862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534896 */     // GIR_Coverage, 18560,
     /* 1534896 */     GIR_EraseRootFromParent_Done,
     /* 1534897 */   // Label 21337: @1534897
     /* 1534897 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1534979), // Rule ID 18561 //
     /* 1534902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534941 */     // MIs[0] round
     /* 1534941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534944 */     // MIs[0] policy
     /* 1534944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534978 */     // GIR_Coverage, 18561,
     /* 1534978 */     GIR_EraseRootFromParent_Done,
     /* 1534979 */   // Label 21338: @1534979
     /* 1534979 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1535061), // Rule ID 18564 //
     /* 1534984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1535004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535023 */     // MIs[0] round
     /* 1535023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535026 */     // MIs[0] policy
     /* 1535026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1535039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535060 */     // GIR_Coverage, 18564,
     /* 1535060 */     GIR_EraseRootFromParent_Done,
     /* 1535061 */   // Label 21339: @1535061
     /* 1535061 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1535143), // Rule ID 18565 //
     /* 1535066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1535077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1535080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1535086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535105 */     // MIs[0] round
     /* 1535105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535108 */     // MIs[0] policy
     /* 1535108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535118 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1535121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535142 */     // GIR_Coverage, 18565,
     /* 1535142 */     GIR_EraseRootFromParent_Done,
     /* 1535143 */   // Label 21340: @1535143
     /* 1535143 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1535225), // Rule ID 18568 //
     /* 1535148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1535168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535187 */     // MIs[0] round
     /* 1535187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535190 */     // MIs[0] policy
     /* 1535190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1535203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535224 */     // GIR_Coverage, 18568,
     /* 1535224 */     GIR_EraseRootFromParent_Done,
     /* 1535225 */   // Label 21341: @1535225
     /* 1535225 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1535307), // Rule ID 18569 //
     /* 1535230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1535250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535269 */     // MIs[0] round
     /* 1535269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535272 */     // MIs[0] policy
     /* 1535272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1535285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535306 */     // GIR_Coverage, 18569,
     /* 1535306 */     GIR_EraseRootFromParent_Done,
     /* 1535307 */   // Label 21342: @1535307
     /* 1535307 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1535389), // Rule ID 18572 //
     /* 1535312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535351 */     // MIs[0] round
     /* 1535351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535354 */     // MIs[0] policy
     /* 1535354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1535367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535388 */     // GIR_Coverage, 18572,
     /* 1535388 */     GIR_EraseRootFromParent_Done,
     /* 1535389 */   // Label 21343: @1535389
     /* 1535389 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1535471), // Rule ID 18573 //
     /* 1535394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535433 */     // MIs[0] round
     /* 1535433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535436 */     // MIs[0] policy
     /* 1535436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1535449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535470 */     // GIR_Coverage, 18573,
     /* 1535470 */     GIR_EraseRootFromParent_Done,
     /* 1535471 */   // Label 21344: @1535471
     /* 1535471 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1535553), // Rule ID 18576 //
     /* 1535476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535515 */     // MIs[0] round
     /* 1535515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535518 */     // MIs[0] policy
     /* 1535518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535552 */     // GIR_Coverage, 18576,
     /* 1535552 */     GIR_EraseRootFromParent_Done,
     /* 1535553 */   // Label 21345: @1535553
     /* 1535553 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1535635), // Rule ID 18577 //
     /* 1535558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535597 */     // MIs[0] round
     /* 1535597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535600 */     // MIs[0] policy
     /* 1535600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535610 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535634 */     // GIR_Coverage, 18577,
     /* 1535634 */     GIR_EraseRootFromParent_Done,
     /* 1535635 */   // Label 21346: @1535635
     /* 1535635 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1535717), // Rule ID 18580 //
     /* 1535640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535679 */     // MIs[0] round
     /* 1535679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535682 */     // MIs[0] policy
     /* 1535682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535716 */     // GIR_Coverage, 18580,
     /* 1535716 */     GIR_EraseRootFromParent_Done,
     /* 1535717 */   // Label 21347: @1535717
     /* 1535717 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1535799), // Rule ID 18581 //
     /* 1535722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535761 */     // MIs[0] round
     /* 1535761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535764 */     // MIs[0] policy
     /* 1535764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535798 */     // GIR_Coverage, 18581,
     /* 1535798 */     GIR_EraseRootFromParent_Done,
     /* 1535799 */   // Label 21348: @1535799
     /* 1535799 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1535881), // Rule ID 18584 //
     /* 1535804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535843 */     // MIs[0] round
     /* 1535843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535846 */     // MIs[0] policy
     /* 1535846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535880 */     // GIR_Coverage, 18584,
     /* 1535880 */     GIR_EraseRootFromParent_Done,
     /* 1535881 */   // Label 21349: @1535881
     /* 1535881 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1535963), // Rule ID 18585 //
     /* 1535886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535925 */     // MIs[0] round
     /* 1535925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535928 */     // MIs[0] policy
     /* 1535928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535962 */     // GIR_Coverage, 18585,
     /* 1535962 */     GIR_EraseRootFromParent_Done,
     /* 1535963 */   // Label 21350: @1535963
     /* 1535963 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1536045), // Rule ID 18588 //
     /* 1535968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536007 */     // MIs[0] round
     /* 1536007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536010 */     // MIs[0] policy
     /* 1536010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1536023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536044 */     // GIR_Coverage, 18588,
     /* 1536044 */     GIR_EraseRootFromParent_Done,
     /* 1536045 */   // Label 21351: @1536045
     /* 1536045 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1536127), // Rule ID 18589 //
     /* 1536050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1536070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536089 */     // MIs[0] round
     /* 1536089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536092 */     // MIs[0] policy
     /* 1536092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1536105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536126 */     // GIR_Coverage, 18589,
     /* 1536126 */     GIR_EraseRootFromParent_Done,
     /* 1536127 */   // Label 21352: @1536127
     /* 1536127 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1536209), // Rule ID 18592 //
     /* 1536132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1536143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1536146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1536152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536171 */     // MIs[0] round
     /* 1536171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536174 */     // MIs[0] policy
     /* 1536174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1536187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536208 */     // GIR_Coverage, 18592,
     /* 1536208 */     GIR_EraseRootFromParent_Done,
     /* 1536209 */   // Label 21353: @1536209
     /* 1536209 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1536291), // Rule ID 18593 //
     /* 1536214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1536222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1536225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1536228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1536234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536253 */     // MIs[0] round
     /* 1536253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536256 */     // MIs[0] policy
     /* 1536256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1536269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536290 */     // GIR_Coverage, 18593,
     /* 1536290 */     GIR_EraseRootFromParent_Done,
     /* 1536291 */   // Label 21354: @1536291
     /* 1536291 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1536373), // Rule ID 18596 //
     /* 1536296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1536313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536335 */     // MIs[0] round
     /* 1536335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536338 */     // MIs[0] policy
     /* 1536338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536348 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1536351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536372 */     // GIR_Coverage, 18596,
     /* 1536372 */     GIR_EraseRootFromParent_Done,
     /* 1536373 */   // Label 21355: @1536373
     /* 1536373 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1536455), // Rule ID 18597 //
     /* 1536378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1536395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536417 */     // MIs[0] round
     /* 1536417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536420 */     // MIs[0] policy
     /* 1536420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536430 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1536433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536454 */     // GIR_Coverage, 18597,
     /* 1536454 */     GIR_EraseRootFromParent_Done,
     /* 1536455 */   // Label 21356: @1536455
     /* 1536455 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1536537), // Rule ID 18600 //
     /* 1536460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536499 */     // MIs[0] round
     /* 1536499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536502 */     // MIs[0] policy
     /* 1536502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536512 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536536 */     // GIR_Coverage, 18600,
     /* 1536536 */     GIR_EraseRootFromParent_Done,
     /* 1536537 */   // Label 21357: @1536537
     /* 1536537 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1536619), // Rule ID 18601 //
     /* 1536542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536581 */     // MIs[0] round
     /* 1536581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536584 */     // MIs[0] policy
     /* 1536584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536594 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536618 */     // GIR_Coverage, 18601,
     /* 1536618 */     GIR_EraseRootFromParent_Done,
     /* 1536619 */   // Label 21358: @1536619
     /* 1536619 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1536701), // Rule ID 18604 //
     /* 1536624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536663 */     // MIs[0] round
     /* 1536663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536666 */     // MIs[0] policy
     /* 1536666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536700 */     // GIR_Coverage, 18604,
     /* 1536700 */     GIR_EraseRootFromParent_Done,
     /* 1536701 */   // Label 21359: @1536701
     /* 1536701 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1536783), // Rule ID 18605 //
     /* 1536706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536745 */     // MIs[0] round
     /* 1536745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536748 */     // MIs[0] policy
     /* 1536748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536782 */     // GIR_Coverage, 18605,
     /* 1536782 */     GIR_EraseRootFromParent_Done,
     /* 1536783 */   // Label 21360: @1536783
     /* 1536783 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1536865), // Rule ID 18608 //
     /* 1536788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536827 */     // MIs[0] round
     /* 1536827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536830 */     // MIs[0] policy
     /* 1536830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536864 */     // GIR_Coverage, 18608,
     /* 1536864 */     GIR_EraseRootFromParent_Done,
     /* 1536865 */   // Label 21361: @1536865
     /* 1536865 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1536947), // Rule ID 18609 //
     /* 1536870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536909 */     // MIs[0] round
     /* 1536909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536912 */     // MIs[0] policy
     /* 1536912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536946 */     // GIR_Coverage, 18609,
     /* 1536946 */     GIR_EraseRootFromParent_Done,
     /* 1536947 */   // Label 21362: @1536947
     /* 1536947 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1537029), // Rule ID 18612 //
     /* 1536952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536991 */     // MIs[0] round
     /* 1536991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536994 */     // MIs[0] policy
     /* 1536994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1537007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537028 */     // GIR_Coverage, 18612,
     /* 1537028 */     GIR_EraseRootFromParent_Done,
     /* 1537029 */   // Label 21363: @1537029
     /* 1537029 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1537111), // Rule ID 18613 //
     /* 1537034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1537051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1537054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537073 */     // MIs[0] round
     /* 1537073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537076 */     // MIs[0] policy
     /* 1537076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537086 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1537089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537110 */     // GIR_Coverage, 18613,
     /* 1537110 */     GIR_EraseRootFromParent_Done,
     /* 1537111 */   // Label 21364: @1537111
     /* 1537111 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1537193), // Rule ID 18616 //
     /* 1537116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1537127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1537130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1537133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1537136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537155 */     // MIs[0] round
     /* 1537155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537158 */     // MIs[0] policy
     /* 1537158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1537171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537192 */     // GIR_Coverage, 18616,
     /* 1537192 */     GIR_EraseRootFromParent_Done,
     /* 1537193 */   // Label 21365: @1537193
     /* 1537193 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1537275), // Rule ID 18617 //
     /* 1537198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1537201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1537209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1537212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1537215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1537218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537237 */     // MIs[0] round
     /* 1537237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537240 */     // MIs[0] policy
     /* 1537240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1537253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537274 */     // GIR_Coverage, 18617,
     /* 1537274 */     GIR_EraseRootFromParent_Done,
     /* 1537275 */   // Label 21366: @1537275
     /* 1537275 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1537357), // Rule ID 18620 //
     /* 1537280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537319 */     // MIs[0] round
     /* 1537319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537322 */     // MIs[0] policy
     /* 1537322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1537335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537356 */     // GIR_Coverage, 18620,
     /* 1537356 */     GIR_EraseRootFromParent_Done,
     /* 1537357 */   // Label 21367: @1537357
     /* 1537357 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1537439), // Rule ID 18621 //
     /* 1537362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537401 */     // MIs[0] round
     /* 1537401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537404 */     // MIs[0] policy
     /* 1537404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1537417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537438 */     // GIR_Coverage, 18621,
     /* 1537438 */     GIR_EraseRootFromParent_Done,
     /* 1537439 */   // Label 21368: @1537439
     /* 1537439 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1537521), // Rule ID 18624 //
     /* 1537444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537483 */     // MIs[0] round
     /* 1537483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537486 */     // MIs[0] policy
     /* 1537486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537520 */     // GIR_Coverage, 18624,
     /* 1537520 */     GIR_EraseRootFromParent_Done,
     /* 1537521 */   // Label 21369: @1537521
     /* 1537521 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1537603), // Rule ID 18625 //
     /* 1537526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537565 */     // MIs[0] round
     /* 1537565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537568 */     // MIs[0] policy
     /* 1537568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537602 */     // GIR_Coverage, 18625,
     /* 1537602 */     GIR_EraseRootFromParent_Done,
     /* 1537603 */   // Label 21370: @1537603
     /* 1537603 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1537685), // Rule ID 18628 //
     /* 1537608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537647 */     // MIs[0] round
     /* 1537647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537650 */     // MIs[0] policy
     /* 1537650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537684 */     // GIR_Coverage, 18628,
     /* 1537684 */     GIR_EraseRootFromParent_Done,
     /* 1537685 */   // Label 21371: @1537685
     /* 1537685 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1537767), // Rule ID 18629 //
     /* 1537690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537729 */     // MIs[0] round
     /* 1537729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537732 */     // MIs[0] policy
     /* 1537732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537766 */     // GIR_Coverage, 18629,
     /* 1537766 */     GIR_EraseRootFromParent_Done,
     /* 1537767 */   // Label 21372: @1537767
     /* 1537767 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1537849), // Rule ID 18632 //
     /* 1537772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537811 */     // MIs[0] round
     /* 1537811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537814 */     // MIs[0] policy
     /* 1537814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537848 */     // GIR_Coverage, 18632,
     /* 1537848 */     GIR_EraseRootFromParent_Done,
     /* 1537849 */   // Label 21373: @1537849
     /* 1537849 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1537931), // Rule ID 18633 //
     /* 1537854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537893 */     // MIs[0] round
     /* 1537893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537896 */     // MIs[0] policy
     /* 1537896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537930 */     // GIR_Coverage, 18633,
     /* 1537930 */     GIR_EraseRootFromParent_Done,
     /* 1537931 */   // Label 21374: @1537931
     /* 1537931 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1538013), // Rule ID 18636 //
     /* 1537936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537975 */     // MIs[0] round
     /* 1537975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537978 */     // MIs[0] policy
     /* 1537978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538012 */     // GIR_Coverage, 18636,
     /* 1538012 */     GIR_EraseRootFromParent_Done,
     /* 1538013 */   // Label 21375: @1538013
     /* 1538013 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1538095), // Rule ID 18637 //
     /* 1538018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1538029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1538032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538057 */     // MIs[0] round
     /* 1538057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538060 */     // MIs[0] policy
     /* 1538060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1538073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538094 */     // GIR_Coverage, 18637,
     /* 1538094 */     GIR_EraseRootFromParent_Done,
     /* 1538095 */   // Label 21376: @1538095
     /* 1538095 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1538177), // Rule ID 18640 //
     /* 1538100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1538111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1538114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1538117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1538120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538139 */     // MIs[0] round
     /* 1538139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538142 */     // MIs[0] policy
     /* 1538142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1538155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538176 */     // GIR_Coverage, 18640,
     /* 1538176 */     GIR_EraseRootFromParent_Done,
     /* 1538177 */   // Label 21377: @1538177
     /* 1538177 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1538259), // Rule ID 18641 //
     /* 1538182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1538193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1538196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1538199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1538202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538221 */     // MIs[0] round
     /* 1538221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538224 */     // MIs[0] policy
     /* 1538224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538234 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1538237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538258 */     // GIR_Coverage, 18641,
     /* 1538258 */     GIR_EraseRootFromParent_Done,
     /* 1538259 */   // Label 21378: @1538259
     /* 1538259 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1538341), // Rule ID 18644 //
     /* 1538264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1538281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538303 */     // MIs[0] round
     /* 1538303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538306 */     // MIs[0] policy
     /* 1538306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1538319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538340 */     // GIR_Coverage, 18644,
     /* 1538340 */     GIR_EraseRootFromParent_Done,
     /* 1538341 */   // Label 21379: @1538341
     /* 1538341 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1538423), // Rule ID 18645 //
     /* 1538346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1538363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538385 */     // MIs[0] round
     /* 1538385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538388 */     // MIs[0] policy
     /* 1538388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1538401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538422 */     // GIR_Coverage, 18645,
     /* 1538422 */     GIR_EraseRootFromParent_Done,
     /* 1538423 */   // Label 21380: @1538423
     /* 1538423 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1538505), // Rule ID 18648 //
     /* 1538428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538467 */     // MIs[0] round
     /* 1538467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538470 */     // MIs[0] policy
     /* 1538470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538480 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538504 */     // GIR_Coverage, 18648,
     /* 1538504 */     GIR_EraseRootFromParent_Done,
     /* 1538505 */   // Label 21381: @1538505
     /* 1538505 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1538587), // Rule ID 18649 //
     /* 1538510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538549 */     // MIs[0] round
     /* 1538549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538552 */     // MIs[0] policy
     /* 1538552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538562 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538586 */     // GIR_Coverage, 18649,
     /* 1538586 */     GIR_EraseRootFromParent_Done,
     /* 1538587 */   // Label 21382: @1538587
     /* 1538587 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1538669), // Rule ID 18652 //
     /* 1538592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538631 */     // MIs[0] round
     /* 1538631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538634 */     // MIs[0] policy
     /* 1538634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538668 */     // GIR_Coverage, 18652,
     /* 1538668 */     GIR_EraseRootFromParent_Done,
     /* 1538669 */   // Label 21383: @1538669
     /* 1538669 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1538751), // Rule ID 18653 //
     /* 1538674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538713 */     // MIs[0] round
     /* 1538713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538716 */     // MIs[0] policy
     /* 1538716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538726 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538750 */     // GIR_Coverage, 18653,
     /* 1538750 */     GIR_EraseRootFromParent_Done,
     /* 1538751 */   // Label 21384: @1538751
     /* 1538751 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1538833), // Rule ID 18656 //
     /* 1538756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538795 */     // MIs[0] round
     /* 1538795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538798 */     // MIs[0] policy
     /* 1538798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538832 */     // GIR_Coverage, 18656,
     /* 1538832 */     GIR_EraseRootFromParent_Done,
     /* 1538833 */   // Label 21385: @1538833
     /* 1538833 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1538915), // Rule ID 18657 //
     /* 1538838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538877 */     // MIs[0] round
     /* 1538877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538880 */     // MIs[0] policy
     /* 1538880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538890 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538914 */     // GIR_Coverage, 18657,
     /* 1538914 */     GIR_EraseRootFromParent_Done,
     /* 1538915 */   // Label 21386: @1538915
     /* 1538915 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1538997), // Rule ID 18660 //
     /* 1538920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538959 */     // MIs[0] round
     /* 1538959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538962 */     // MIs[0] policy
     /* 1538962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538996 */     // GIR_Coverage, 18660,
     /* 1538996 */     GIR_EraseRootFromParent_Done,
     /* 1538997 */   // Label 21387: @1538997
     /* 1538997 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1539079), // Rule ID 18661 //
     /* 1539002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1539013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1539016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1539022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539041 */     // MIs[0] round
     /* 1539041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539044 */     // MIs[0] policy
     /* 1539044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539054 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1539057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539078 */     // GIR_Coverage, 18661,
     /* 1539078 */     GIR_EraseRootFromParent_Done,
     /* 1539079 */   // Label 21388: @1539079
     /* 1539079 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1539161), // Rule ID 18664 //
     /* 1539084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1539095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1539098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539123 */     // MIs[0] round
     /* 1539123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539126 */     // MIs[0] policy
     /* 1539126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1539139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539160 */     // GIR_Coverage, 18664,
     /* 1539160 */     GIR_EraseRootFromParent_Done,
     /* 1539161 */   // Label 21389: @1539161
     /* 1539161 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1539243), // Rule ID 18665 //
     /* 1539166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1539177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1539180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539205 */     // MIs[0] round
     /* 1539205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539208 */     // MIs[0] policy
     /* 1539208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539218 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1539221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539242 */     // GIR_Coverage, 18665,
     /* 1539242 */     GIR_EraseRootFromParent_Done,
     /* 1539243 */   // Label 21390: @1539243
     /* 1539243 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1539325), // Rule ID 18668 //
     /* 1539248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1539259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1539262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1539268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539287 */     // MIs[0] round
     /* 1539287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539290 */     // MIs[0] policy
     /* 1539290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1539303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539324 */     // GIR_Coverage, 18668,
     /* 1539324 */     GIR_EraseRootFromParent_Done,
     /* 1539325 */   // Label 21391: @1539325
     /* 1539325 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1539407), // Rule ID 18669 //
     /* 1539330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1539341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1539344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1539350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539369 */     // MIs[0] round
     /* 1539369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539372 */     // MIs[0] policy
     /* 1539372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11303:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1539385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539406 */     // GIR_Coverage, 18669,
     /* 1539406 */     GIR_EraseRootFromParent_Done,
     /* 1539407 */   // Label 21392: @1539407
     /* 1539407 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1539489), // Rule ID 18672 //
     /* 1539412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539451 */     // MIs[0] round
     /* 1539451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539454 */     // MIs[0] policy
     /* 1539454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539488 */     // GIR_Coverage, 18672,
     /* 1539488 */     GIR_EraseRootFromParent_Done,
     /* 1539489 */   // Label 21393: @1539489
     /* 1539489 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1539571), // Rule ID 18673 //
     /* 1539494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539533 */     // MIs[0] round
     /* 1539533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539536 */     // MIs[0] policy
     /* 1539536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539546 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539570 */     // GIR_Coverage, 18673,
     /* 1539570 */     GIR_EraseRootFromParent_Done,
     /* 1539571 */   // Label 21394: @1539571
     /* 1539571 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1539653), // Rule ID 18676 //
     /* 1539576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539615 */     // MIs[0] round
     /* 1539615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539618 */     // MIs[0] policy
     /* 1539618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539628 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539652 */     // GIR_Coverage, 18676,
     /* 1539652 */     GIR_EraseRootFromParent_Done,
     /* 1539653 */   // Label 21395: @1539653
     /* 1539653 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1539735), // Rule ID 18677 //
     /* 1539658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539697 */     // MIs[0] round
     /* 1539697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539700 */     // MIs[0] policy
     /* 1539700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539710 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539734 */     // GIR_Coverage, 18677,
     /* 1539734 */     GIR_EraseRootFromParent_Done,
     /* 1539735 */   // Label 21396: @1539735
     /* 1539735 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1539817), // Rule ID 18680 //
     /* 1539740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539779 */     // MIs[0] round
     /* 1539779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539782 */     // MIs[0] policy
     /* 1539782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539792 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539816 */     // GIR_Coverage, 18680,
     /* 1539816 */     GIR_EraseRootFromParent_Done,
     /* 1539817 */   // Label 21397: @1539817
     /* 1539817 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1539899), // Rule ID 18681 //
     /* 1539822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539861 */     // MIs[0] round
     /* 1539861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539864 */     // MIs[0] policy
     /* 1539864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539874 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539898 */     // GIR_Coverage, 18681,
     /* 1539898 */     GIR_EraseRootFromParent_Done,
     /* 1539899 */   // Label 21398: @1539899
     /* 1539899 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1539981), // Rule ID 18684 //
     /* 1539904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539943 */     // MIs[0] round
     /* 1539943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539946 */     // MIs[0] policy
     /* 1539946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539956 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539980 */     // GIR_Coverage, 18684,
     /* 1539980 */     GIR_EraseRootFromParent_Done,
     /* 1539981 */   // Label 21399: @1539981
     /* 1539981 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1540063), // Rule ID 18685 //
     /* 1539986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1540000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540025 */     // MIs[0] round
     /* 1540025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540028 */     // MIs[0] policy
     /* 1540028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540038 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1540041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540062 */     // GIR_Coverage, 18685,
     /* 1540062 */     GIR_EraseRootFromParent_Done,
     /* 1540063 */   // Label 21400: @1540063
     /* 1540063 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1540145), // Rule ID 18688 //
     /* 1540068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1540071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1540088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540107 */     // MIs[0] round
     /* 1540107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540110 */     // MIs[0] policy
     /* 1540110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540120 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1540123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540144 */     // GIR_Coverage, 18688,
     /* 1540144 */     GIR_EraseRootFromParent_Done,
     /* 1540145 */   // Label 21401: @1540145
     /* 1540145 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1540227), // Rule ID 18689 //
     /* 1540150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1540153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1540161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1540164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1540170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540189 */     // MIs[0] round
     /* 1540189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540192 */     // MIs[0] policy
     /* 1540192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540202 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1540205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540226 */     // GIR_Coverage, 18689,
     /* 1540226 */     GIR_EraseRootFromParent_Done,
     /* 1540227 */   // Label 21402: @1540227
     /* 1540227 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1540309), // Rule ID 18692 //
     /* 1540232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1540252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540271 */     // MIs[0] round
     /* 1540271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540274 */     // MIs[0] policy
     /* 1540274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1540287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540308 */     // GIR_Coverage, 18692,
     /* 1540308 */     GIR_EraseRootFromParent_Done,
     /* 1540309 */   // Label 21403: @1540309
     /* 1540309 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1540391), // Rule ID 18693 //
     /* 1540314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1540334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540353 */     // MIs[0] round
     /* 1540353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540356 */     // MIs[0] policy
     /* 1540356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540366 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1540369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540390 */     // GIR_Coverage, 18693,
     /* 1540390 */     GIR_EraseRootFromParent_Done,
     /* 1540391 */   // Label 21404: @1540391
     /* 1540391 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1540473), // Rule ID 18696 //
     /* 1540396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540435 */     // MIs[0] round
     /* 1540435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540438 */     // MIs[0] policy
     /* 1540438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540448 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540472 */     // GIR_Coverage, 18696,
     /* 1540472 */     GIR_EraseRootFromParent_Done,
     /* 1540473 */   // Label 21405: @1540473
     /* 1540473 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1540555), // Rule ID 18697 //
     /* 1540478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540517 */     // MIs[0] round
     /* 1540517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540520 */     // MIs[0] policy
     /* 1540520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540554 */     // GIR_Coverage, 18697,
     /* 1540554 */     GIR_EraseRootFromParent_Done,
     /* 1540555 */   // Label 21406: @1540555
     /* 1540555 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1540637), // Rule ID 18700 //
     /* 1540560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540599 */     // MIs[0] round
     /* 1540599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540602 */     // MIs[0] policy
     /* 1540602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540636 */     // GIR_Coverage, 18700,
     /* 1540636 */     GIR_EraseRootFromParent_Done,
     /* 1540637 */   // Label 21407: @1540637
     /* 1540637 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1540719), // Rule ID 18701 //
     /* 1540642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540681 */     // MIs[0] round
     /* 1540681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540684 */     // MIs[0] policy
     /* 1540684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540718 */     // GIR_Coverage, 18701,
     /* 1540718 */     GIR_EraseRootFromParent_Done,
     /* 1540719 */   // Label 21408: @1540719
     /* 1540719 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1540801), // Rule ID 18704 //
     /* 1540724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540763 */     // MIs[0] round
     /* 1540763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540766 */     // MIs[0] policy
     /* 1540766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540800 */     // GIR_Coverage, 18704,
     /* 1540800 */     GIR_EraseRootFromParent_Done,
     /* 1540801 */   // Label 21409: @1540801
     /* 1540801 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1540883), // Rule ID 18705 //
     /* 1540806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540845 */     // MIs[0] round
     /* 1540845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540848 */     // MIs[0] policy
     /* 1540848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540882 */     // GIR_Coverage, 18705,
     /* 1540882 */     GIR_EraseRootFromParent_Done,
     /* 1540883 */   // Label 21410: @1540883
     /* 1540883 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1540965), // Rule ID 18708 //
     /* 1540888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540927 */     // MIs[0] round
     /* 1540927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540930 */     // MIs[0] policy
     /* 1540930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540964 */     // GIR_Coverage, 18708,
     /* 1540964 */     GIR_EraseRootFromParent_Done,
     /* 1540965 */   // Label 21411: @1540965
     /* 1540965 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1541047), // Rule ID 18709 //
     /* 1540970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541009 */     // MIs[0] round
     /* 1541009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541012 */     // MIs[0] policy
     /* 1541012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541022 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1541025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541046 */     // GIR_Coverage, 18709,
     /* 1541046 */     GIR_EraseRootFromParent_Done,
     /* 1541047 */   // Label 21412: @1541047
     /* 1541047 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1541129), // Rule ID 18712 //
     /* 1541052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1541055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1541069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1541072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541091 */     // MIs[0] round
     /* 1541091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541094 */     // MIs[0] policy
     /* 1541094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1541107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541128 */     // GIR_Coverage, 18712,
     /* 1541128 */     GIR_EraseRootFromParent_Done,
     /* 1541129 */   // Label 21413: @1541129
     /* 1541129 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1541211), // Rule ID 18713 //
     /* 1541134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1541137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1541142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1541151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1541154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1541169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541173 */     // MIs[0] round
     /* 1541173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541176 */     // MIs[0] policy
     /* 1541176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541186 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1541189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1541207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541210 */     // GIR_Coverage, 18713,
     /* 1541210 */     GIR_EraseRootFromParent_Done,
     /* 1541211 */   // Label 21414: @1541211
     /* 1541211 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1541293), // Rule ID 18716 //
     /* 1541216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541255 */     // MIs[0] round
     /* 1541255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541258 */     // MIs[0] policy
     /* 1541258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541268 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1541271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541292 */     // GIR_Coverage, 18716,
     /* 1541292 */     GIR_EraseRootFromParent_Done,
     /* 1541293 */   // Label 21415: @1541293
     /* 1541293 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1541375), // Rule ID 18717 //
     /* 1541298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541337 */     // MIs[0] round
     /* 1541337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541340 */     // MIs[0] policy
     /* 1541340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1541353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541374 */     // GIR_Coverage, 18717,
     /* 1541374 */     GIR_EraseRootFromParent_Done,
     /* 1541375 */   // Label 21416: @1541375
     /* 1541375 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1541457), // Rule ID 18720 //
     /* 1541380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541419 */     // MIs[0] round
     /* 1541419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541422 */     // MIs[0] policy
     /* 1541422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541432 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541456 */     // GIR_Coverage, 18720,
     /* 1541456 */     GIR_EraseRootFromParent_Done,
     /* 1541457 */   // Label 21417: @1541457
     /* 1541457 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1541539), // Rule ID 18721 //
     /* 1541462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541501 */     // MIs[0] round
     /* 1541501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541504 */     // MIs[0] policy
     /* 1541504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541514 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541538 */     // GIR_Coverage, 18721,
     /* 1541538 */     GIR_EraseRootFromParent_Done,
     /* 1541539 */   // Label 21418: @1541539
     /* 1541539 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1541621), // Rule ID 18724 //
     /* 1541544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541583 */     // MIs[0] round
     /* 1541583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541586 */     // MIs[0] policy
     /* 1541586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541620 */     // GIR_Coverage, 18724,
     /* 1541620 */     GIR_EraseRootFromParent_Done,
     /* 1541621 */   // Label 21419: @1541621
     /* 1541621 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1541703), // Rule ID 18725 //
     /* 1541626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541665 */     // MIs[0] round
     /* 1541665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541668 */     // MIs[0] policy
     /* 1541668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541678 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541702 */     // GIR_Coverage, 18725,
     /* 1541702 */     GIR_EraseRootFromParent_Done,
     /* 1541703 */   // Label 21420: @1541703
     /* 1541703 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1541785), // Rule ID 18728 //
     /* 1541708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541747 */     // MIs[0] round
     /* 1541747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541750 */     // MIs[0] policy
     /* 1541750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541760 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541784 */     // GIR_Coverage, 18728,
     /* 1541784 */     GIR_EraseRootFromParent_Done,
     /* 1541785 */   // Label 21421: @1541785
     /* 1541785 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1541867), // Rule ID 18729 //
     /* 1541790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541829 */     // MIs[0] round
     /* 1541829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541832 */     // MIs[0] policy
     /* 1541832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541842 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541866 */     // GIR_Coverage, 18729,
     /* 1541866 */     GIR_EraseRootFromParent_Done,
     /* 1541867 */   // Label 21422: @1541867
     /* 1541867 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1541949), // Rule ID 18732 //
     /* 1541872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541911 */     // MIs[0] round
     /* 1541911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541914 */     // MIs[0] policy
     /* 1541914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541948 */     // GIR_Coverage, 18732,
     /* 1541948 */     GIR_EraseRootFromParent_Done,
     /* 1541949 */   // Label 21423: @1541949
     /* 1541949 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1542031), // Rule ID 18733 //
     /* 1541954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541993 */     // MIs[0] round
     /* 1541993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541996 */     // MIs[0] policy
     /* 1541996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542006 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1542009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542030 */     // GIR_Coverage, 18733,
     /* 1542030 */     GIR_EraseRootFromParent_Done,
     /* 1542031 */   // Label 21424: @1542031
     /* 1542031 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1542113), // Rule ID 18736 //
     /* 1542036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542075 */     // MIs[0] round
     /* 1542075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542078 */     // MIs[0] policy
     /* 1542078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542088 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1542091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542112 */     // GIR_Coverage, 18736,
     /* 1542112 */     GIR_EraseRootFromParent_Done,
     /* 1542113 */   // Label 21425: @1542113
     /* 1542113 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1542195), // Rule ID 18737 //
     /* 1542118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542157 */     // MIs[0] round
     /* 1542157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542160 */     // MIs[0] policy
     /* 1542160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1542173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542194 */     // GIR_Coverage, 18737,
     /* 1542194 */     GIR_EraseRootFromParent_Done,
     /* 1542195 */   // Label 21426: @1542195
     /* 1542195 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1542277), // Rule ID 18740 //
     /* 1542200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542239 */     // MIs[0] round
     /* 1542239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542242 */     // MIs[0] policy
     /* 1542242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542252 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1542255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542276 */     // GIR_Coverage, 18740,
     /* 1542276 */     GIR_EraseRootFromParent_Done,
     /* 1542277 */   // Label 21427: @1542277
     /* 1542277 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1542359), // Rule ID 18741 //
     /* 1542282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542321 */     // MIs[0] round
     /* 1542321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542324 */     // MIs[0] policy
     /* 1542324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542334 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1542337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542358 */     // GIR_Coverage, 18741,
     /* 1542358 */     GIR_EraseRootFromParent_Done,
     /* 1542359 */   // Label 21428: @1542359
     /* 1542359 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1542441), // Rule ID 18744 //
     /* 1542364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542403 */     // MIs[0] round
     /* 1542403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542406 */     // MIs[0] policy
     /* 1542406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542440 */     // GIR_Coverage, 18744,
     /* 1542440 */     GIR_EraseRootFromParent_Done,
     /* 1542441 */   // Label 21429: @1542441
     /* 1542441 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1542523), // Rule ID 18745 //
     /* 1542446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542485 */     // MIs[0] round
     /* 1542485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542488 */     // MIs[0] policy
     /* 1542488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542498 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542522 */     // GIR_Coverage, 18745,
     /* 1542522 */     GIR_EraseRootFromParent_Done,
     /* 1542523 */   // Label 21430: @1542523
     /* 1542523 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1542605), // Rule ID 18748 //
     /* 1542528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542567 */     // MIs[0] round
     /* 1542567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542570 */     // MIs[0] policy
     /* 1542570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542580 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542604 */     // GIR_Coverage, 18748,
     /* 1542604 */     GIR_EraseRootFromParent_Done,
     /* 1542605 */   // Label 21431: @1542605
     /* 1542605 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1542687), // Rule ID 18749 //
     /* 1542610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542649 */     // MIs[0] round
     /* 1542649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542652 */     // MIs[0] policy
     /* 1542652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542662 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542686 */     // GIR_Coverage, 18749,
     /* 1542686 */     GIR_EraseRootFromParent_Done,
     /* 1542687 */   // Label 21432: @1542687
     /* 1542687 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1542769), // Rule ID 18752 //
     /* 1542692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542731 */     // MIs[0] round
     /* 1542731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542734 */     // MIs[0] policy
     /* 1542734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542744 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542768 */     // GIR_Coverage, 18752,
     /* 1542768 */     GIR_EraseRootFromParent_Done,
     /* 1542769 */   // Label 21433: @1542769
     /* 1542769 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1542851), // Rule ID 18753 //
     /* 1542774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542813 */     // MIs[0] round
     /* 1542813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542816 */     // MIs[0] policy
     /* 1542816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542826 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542850 */     // GIR_Coverage, 18753,
     /* 1542850 */     GIR_EraseRootFromParent_Done,
     /* 1542851 */   // Label 21434: @1542851
     /* 1542851 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1542933), // Rule ID 18756 //
     /* 1542856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542895 */     // MIs[0] round
     /* 1542895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542898 */     // MIs[0] policy
     /* 1542898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542932 */     // GIR_Coverage, 18756,
     /* 1542932 */     GIR_EraseRootFromParent_Done,
     /* 1542933 */   // Label 21435: @1542933
     /* 1542933 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1543015), // Rule ID 18757 //
     /* 1542938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542977 */     // MIs[0] round
     /* 1542977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542980 */     // MIs[0] policy
     /* 1542980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543014 */     // GIR_Coverage, 18757,
     /* 1543014 */     GIR_EraseRootFromParent_Done,
     /* 1543015 */   // Label 21436: @1543015
     /* 1543015 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1543097), // Rule ID 18760 //
     /* 1543020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543059 */     // MIs[0] round
     /* 1543059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543062 */     // MIs[0] policy
     /* 1543062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543072 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1543075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543096 */     // GIR_Coverage, 18760,
     /* 1543096 */     GIR_EraseRootFromParent_Done,
     /* 1543097 */   // Label 21437: @1543097
     /* 1543097 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1543179), // Rule ID 18761 //
     /* 1543102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543141 */     // MIs[0] round
     /* 1543141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543144 */     // MIs[0] policy
     /* 1543144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1543157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543178 */     // GIR_Coverage, 18761,
     /* 1543178 */     GIR_EraseRootFromParent_Done,
     /* 1543179 */   // Label 21438: @1543179
     /* 1543179 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1543261), // Rule ID 18764 //
     /* 1543184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543223 */     // MIs[0] round
     /* 1543223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543226 */     // MIs[0] policy
     /* 1543226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1543239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543260 */     // GIR_Coverage, 18764,
     /* 1543260 */     GIR_EraseRootFromParent_Done,
     /* 1543261 */   // Label 21439: @1543261
     /* 1543261 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1543343), // Rule ID 18765 //
     /* 1543266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543305 */     // MIs[0] round
     /* 1543305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543308 */     // MIs[0] policy
     /* 1543308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1543321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543342 */     // GIR_Coverage, 18765,
     /* 1543342 */     GIR_EraseRootFromParent_Done,
     /* 1543343 */   // Label 21440: @1543343
     /* 1543343 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1543425), // Rule ID 18768 //
     /* 1543348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543387 */     // MIs[0] round
     /* 1543387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543390 */     // MIs[0] policy
     /* 1543390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543400 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543424 */     // GIR_Coverage, 18768,
     /* 1543424 */     GIR_EraseRootFromParent_Done,
     /* 1543425 */   // Label 21441: @1543425
     /* 1543425 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1543507), // Rule ID 18769 //
     /* 1543430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543469 */     // MIs[0] round
     /* 1543469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543472 */     // MIs[0] policy
     /* 1543472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543482 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543506 */     // GIR_Coverage, 18769,
     /* 1543506 */     GIR_EraseRootFromParent_Done,
     /* 1543507 */   // Label 21442: @1543507
     /* 1543507 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1543589), // Rule ID 18772 //
     /* 1543512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543551 */     // MIs[0] round
     /* 1543551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543554 */     // MIs[0] policy
     /* 1543554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543588 */     // GIR_Coverage, 18772,
     /* 1543588 */     GIR_EraseRootFromParent_Done,
     /* 1543589 */   // Label 21443: @1543589
     /* 1543589 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1543671), // Rule ID 18773 //
     /* 1543594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543633 */     // MIs[0] round
     /* 1543633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543636 */     // MIs[0] policy
     /* 1543636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543646 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543670 */     // GIR_Coverage, 18773,
     /* 1543670 */     GIR_EraseRootFromParent_Done,
     /* 1543671 */   // Label 21444: @1543671
     /* 1543671 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1543753), // Rule ID 18776 //
     /* 1543676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543715 */     // MIs[0] round
     /* 1543715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543718 */     // MIs[0] policy
     /* 1543718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543728 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543752 */     // GIR_Coverage, 18776,
     /* 1543752 */     GIR_EraseRootFromParent_Done,
     /* 1543753 */   // Label 21445: @1543753
     /* 1543753 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1543835), // Rule ID 18777 //
     /* 1543758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543797 */     // MIs[0] round
     /* 1543797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543800 */     // MIs[0] policy
     /* 1543800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543834 */     // GIR_Coverage, 18777,
     /* 1543834 */     GIR_EraseRootFromParent_Done,
     /* 1543835 */   // Label 21446: @1543835
     /* 1543835 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1543917), // Rule ID 18780 //
     /* 1543840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543879 */     // MIs[0] round
     /* 1543879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543882 */     // MIs[0] policy
     /* 1543882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543892 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543916 */     // GIR_Coverage, 18780,
     /* 1543916 */     GIR_EraseRootFromParent_Done,
     /* 1543917 */   // Label 21447: @1543917
     /* 1543917 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1543999), // Rule ID 18781 //
     /* 1543922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543961 */     // MIs[0] round
     /* 1543961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543964 */     // MIs[0] policy
     /* 1543964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543998 */     // GIR_Coverage, 18781,
     /* 1543998 */     GIR_EraseRootFromParent_Done,
     /* 1543999 */   // Label 21448: @1543999
     /* 1543999 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1544081), // Rule ID 18784 //
     /* 1544004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544043 */     // MIs[0] round
     /* 1544043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544046 */     // MIs[0] policy
     /* 1544046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544056 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1544059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544080 */     // GIR_Coverage, 18784,
     /* 1544080 */     GIR_EraseRootFromParent_Done,
     /* 1544081 */   // Label 21449: @1544081
     /* 1544081 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1544163), // Rule ID 18785 //
     /* 1544086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1544094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544125 */     // MIs[0] round
     /* 1544125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544128 */     // MIs[0] policy
     /* 1544128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544138 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1544141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544162 */     // GIR_Coverage, 18785,
     /* 1544162 */     GIR_EraseRootFromParent_Done,
     /* 1544163 */   // Label 21450: @1544163
     /* 1544163 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1544245), // Rule ID 18788 //
     /* 1544168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544207 */     // MIs[0] round
     /* 1544207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544210 */     // MIs[0] policy
     /* 1544210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544220 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1544223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544244 */     // GIR_Coverage, 18788,
     /* 1544244 */     GIR_EraseRootFromParent_Done,
     /* 1544245 */   // Label 21451: @1544245
     /* 1544245 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1544327), // Rule ID 18789 //
     /* 1544250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544289 */     // MIs[0] round
     /* 1544289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544292 */     // MIs[0] policy
     /* 1544292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544302 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1544305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544326 */     // GIR_Coverage, 18789,
     /* 1544326 */     GIR_EraseRootFromParent_Done,
     /* 1544327 */   // Label 21452: @1544327
     /* 1544327 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1544409), // Rule ID 18792 //
     /* 1544332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544371 */     // MIs[0] round
     /* 1544371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544374 */     // MIs[0] policy
     /* 1544374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544408 */     // GIR_Coverage, 18792,
     /* 1544408 */     GIR_EraseRootFromParent_Done,
     /* 1544409 */   // Label 21453: @1544409
     /* 1544409 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1544491), // Rule ID 18793 //
     /* 1544414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544453 */     // MIs[0] round
     /* 1544453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544456 */     // MIs[0] policy
     /* 1544456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544466 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544490 */     // GIR_Coverage, 18793,
     /* 1544490 */     GIR_EraseRootFromParent_Done,
     /* 1544491 */   // Label 21454: @1544491
     /* 1544491 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1544573), // Rule ID 18796 //
     /* 1544496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544535 */     // MIs[0] round
     /* 1544535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544538 */     // MIs[0] policy
     /* 1544538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544548 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544572 */     // GIR_Coverage, 18796,
     /* 1544572 */     GIR_EraseRootFromParent_Done,
     /* 1544573 */   // Label 21455: @1544573
     /* 1544573 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1544655), // Rule ID 18797 //
     /* 1544578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544617 */     // MIs[0] round
     /* 1544617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544620 */     // MIs[0] policy
     /* 1544620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544654 */     // GIR_Coverage, 18797,
     /* 1544654 */     GIR_EraseRootFromParent_Done,
     /* 1544655 */   // Label 21456: @1544655
     /* 1544655 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1544737), // Rule ID 18800 //
     /* 1544660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544699 */     // MIs[0] round
     /* 1544699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544702 */     // MIs[0] policy
     /* 1544702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544712 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544736 */     // GIR_Coverage, 18800,
     /* 1544736 */     GIR_EraseRootFromParent_Done,
     /* 1544737 */   // Label 21457: @1544737
     /* 1544737 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1544819), // Rule ID 18801 //
     /* 1544742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544781 */     // MIs[0] round
     /* 1544781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544784 */     // MIs[0] policy
     /* 1544784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544794 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544818 */     // GIR_Coverage, 18801,
     /* 1544818 */     GIR_EraseRootFromParent_Done,
     /* 1544819 */   // Label 21458: @1544819
     /* 1544819 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1544901), // Rule ID 18804 //
     /* 1544824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544863 */     // MIs[0] round
     /* 1544863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544866 */     // MIs[0] policy
     /* 1544866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544876 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544900 */     // GIR_Coverage, 18804,
     /* 1544900 */     GIR_EraseRootFromParent_Done,
     /* 1544901 */   // Label 21459: @1544901
     /* 1544901 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1544983), // Rule ID 18805 //
     /* 1544906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544945 */     // MIs[0] round
     /* 1544945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544948 */     // MIs[0] policy
     /* 1544948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544982 */     // GIR_Coverage, 18805,
     /* 1544982 */     GIR_EraseRootFromParent_Done,
     /* 1544983 */   // Label 21460: @1544983
     /* 1544983 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1545065), // Rule ID 18808 //
     /* 1544988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545027 */     // MIs[0] round
     /* 1545027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545030 */     // MIs[0] policy
     /* 1545030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545040 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1545043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545064 */     // GIR_Coverage, 18808,
     /* 1545064 */     GIR_EraseRootFromParent_Done,
     /* 1545065 */   // Label 21461: @1545065
     /* 1545065 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1545147), // Rule ID 18809 //
     /* 1545070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545109 */     // MIs[0] round
     /* 1545109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545112 */     // MIs[0] policy
     /* 1545112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545122 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1545125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545146 */     // GIR_Coverage, 18809,
     /* 1545146 */     GIR_EraseRootFromParent_Done,
     /* 1545147 */   // Label 21462: @1545147
     /* 1545147 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1545229), // Rule ID 18812 //
     /* 1545152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545191 */     // MIs[0] round
     /* 1545191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545194 */     // MIs[0] policy
     /* 1545194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1545207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545228 */     // GIR_Coverage, 18812,
     /* 1545228 */     GIR_EraseRootFromParent_Done,
     /* 1545229 */   // Label 21463: @1545229
     /* 1545229 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1545311), // Rule ID 18813 //
     /* 1545234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545273 */     // MIs[0] round
     /* 1545273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545276 */     // MIs[0] policy
     /* 1545276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545286 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1545289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545310 */     // GIR_Coverage, 18813,
     /* 1545310 */     GIR_EraseRootFromParent_Done,
     /* 1545311 */   // Label 21464: @1545311
     /* 1545311 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1545393), // Rule ID 18816 //
     /* 1545316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545355 */     // MIs[0] round
     /* 1545355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545358 */     // MIs[0] policy
     /* 1545358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1545371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545392 */     // GIR_Coverage, 18816,
     /* 1545392 */     GIR_EraseRootFromParent_Done,
     /* 1545393 */   // Label 21465: @1545393
     /* 1545393 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1545475), // Rule ID 18817 //
     /* 1545398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545437 */     // MIs[0] round
     /* 1545437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545440 */     // MIs[0] policy
     /* 1545440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545450 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1545453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545474 */     // GIR_Coverage, 18817,
     /* 1545474 */     GIR_EraseRootFromParent_Done,
     /* 1545475 */   // Label 21466: @1545475
     /* 1545475 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1545557), // Rule ID 18820 //
     /* 1545480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545519 */     // MIs[0] round
     /* 1545519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545522 */     // MIs[0] policy
     /* 1545522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545532 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545556 */     // GIR_Coverage, 18820,
     /* 1545556 */     GIR_EraseRootFromParent_Done,
     /* 1545557 */   // Label 21467: @1545557
     /* 1545557 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1545639), // Rule ID 18821 //
     /* 1545562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545601 */     // MIs[0] round
     /* 1545601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545604 */     // MIs[0] policy
     /* 1545604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545638 */     // GIR_Coverage, 18821,
     /* 1545638 */     GIR_EraseRootFromParent_Done,
     /* 1545639 */   // Label 21468: @1545639
     /* 1545639 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1545721), // Rule ID 18824 //
     /* 1545644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545683 */     // MIs[0] round
     /* 1545683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545686 */     // MIs[0] policy
     /* 1545686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545696 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545720 */     // GIR_Coverage, 18824,
     /* 1545720 */     GIR_EraseRootFromParent_Done,
     /* 1545721 */   // Label 21469: @1545721
     /* 1545721 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1545803), // Rule ID 18825 //
     /* 1545726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545765 */     // MIs[0] round
     /* 1545765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545768 */     // MIs[0] policy
     /* 1545768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545778 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545802 */     // GIR_Coverage, 18825,
     /* 1545802 */     GIR_EraseRootFromParent_Done,
     /* 1545803 */   // Label 21470: @1545803
     /* 1545803 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1545885), // Rule ID 18828 //
     /* 1545808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545847 */     // MIs[0] round
     /* 1545847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545850 */     // MIs[0] policy
     /* 1545850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545884 */     // GIR_Coverage, 18828,
     /* 1545884 */     GIR_EraseRootFromParent_Done,
     /* 1545885 */   // Label 21471: @1545885
     /* 1545885 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1545967), // Rule ID 18829 //
     /* 1545890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545929 */     // MIs[0] round
     /* 1545929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545932 */     // MIs[0] policy
     /* 1545932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545966 */     // GIR_Coverage, 18829,
     /* 1545966 */     GIR_EraseRootFromParent_Done,
     /* 1545967 */   // Label 21472: @1545967
     /* 1545967 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1546049), // Rule ID 18832 //
     /* 1545972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546011 */     // MIs[0] round
     /* 1546011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546014 */     // MIs[0] policy
     /* 1546014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1546027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546048 */     // GIR_Coverage, 18832,
     /* 1546048 */     GIR_EraseRootFromParent_Done,
     /* 1546049 */   // Label 21473: @1546049
     /* 1546049 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1546131), // Rule ID 18833 //
     /* 1546054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546093 */     // MIs[0] round
     /* 1546093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546096 */     // MIs[0] policy
     /* 1546096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546106 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1546109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546130 */     // GIR_Coverage, 18833,
     /* 1546130 */     GIR_EraseRootFromParent_Done,
     /* 1546131 */   // Label 21474: @1546131
     /* 1546131 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1546213), // Rule ID 18836 //
     /* 1546136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546175 */     // MIs[0] round
     /* 1546175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546178 */     // MIs[0] policy
     /* 1546178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546188 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1546191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546212 */     // GIR_Coverage, 18836,
     /* 1546212 */     GIR_EraseRootFromParent_Done,
     /* 1546213 */   // Label 21475: @1546213
     /* 1546213 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1546295), // Rule ID 18837 //
     /* 1546218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546257 */     // MIs[0] round
     /* 1546257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546260 */     // MIs[0] policy
     /* 1546260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546270 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1546273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546294 */     // GIR_Coverage, 18837,
     /* 1546294 */     GIR_EraseRootFromParent_Done,
     /* 1546295 */   // Label 21476: @1546295
     /* 1546295 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1546377), // Rule ID 18840 //
     /* 1546300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546339 */     // MIs[0] round
     /* 1546339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546342 */     // MIs[0] policy
     /* 1546342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546352 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1546355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546376 */     // GIR_Coverage, 18840,
     /* 1546376 */     GIR_EraseRootFromParent_Done,
     /* 1546377 */   // Label 21477: @1546377
     /* 1546377 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1546459), // Rule ID 18841 //
     /* 1546382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546421 */     // MIs[0] round
     /* 1546421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546424 */     // MIs[0] policy
     /* 1546424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546434 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1546437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546458 */     // GIR_Coverage, 18841,
     /* 1546458 */     GIR_EraseRootFromParent_Done,
     /* 1546459 */   // Label 21478: @1546459
     /* 1546459 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1546541), // Rule ID 18844 //
     /* 1546464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546503 */     // MIs[0] round
     /* 1546503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546506 */     // MIs[0] policy
     /* 1546506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546540 */     // GIR_Coverage, 18844,
     /* 1546540 */     GIR_EraseRootFromParent_Done,
     /* 1546541 */   // Label 21479: @1546541
     /* 1546541 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1546623), // Rule ID 18845 //
     /* 1546546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546585 */     // MIs[0] round
     /* 1546585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546588 */     // MIs[0] policy
     /* 1546588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546622 */     // GIR_Coverage, 18845,
     /* 1546622 */     GIR_EraseRootFromParent_Done,
     /* 1546623 */   // Label 21480: @1546623
     /* 1546623 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1546705), // Rule ID 18848 //
     /* 1546628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546667 */     // MIs[0] round
     /* 1546667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546670 */     // MIs[0] policy
     /* 1546670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546680 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546704 */     // GIR_Coverage, 18848,
     /* 1546704 */     GIR_EraseRootFromParent_Done,
     /* 1546705 */   // Label 21481: @1546705
     /* 1546705 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1546787), // Rule ID 18849 //
     /* 1546710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546749 */     // MIs[0] round
     /* 1546749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546752 */     // MIs[0] policy
     /* 1546752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546786 */     // GIR_Coverage, 18849,
     /* 1546786 */     GIR_EraseRootFromParent_Done,
     /* 1546787 */   // Label 21482: @1546787
     /* 1546787 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1546869), // Rule ID 18852 //
     /* 1546792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546831 */     // MIs[0] round
     /* 1546831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546834 */     // MIs[0] policy
     /* 1546834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546844 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546868 */     // GIR_Coverage, 18852,
     /* 1546868 */     GIR_EraseRootFromParent_Done,
     /* 1546869 */   // Label 21483: @1546869
     /* 1546869 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1546951), // Rule ID 18853 //
     /* 1546874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546913 */     // MIs[0] round
     /* 1546913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546916 */     // MIs[0] policy
     /* 1546916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546926 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546950 */     // GIR_Coverage, 18853,
     /* 1546950 */     GIR_EraseRootFromParent_Done,
     /* 1546951 */   // Label 21484: @1546951
     /* 1546951 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1547033), // Rule ID 18856 //
     /* 1546956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546995 */     // MIs[0] round
     /* 1546995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546998 */     // MIs[0] policy
     /* 1546998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547008 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1547011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547032 */     // GIR_Coverage, 18856,
     /* 1547032 */     GIR_EraseRootFromParent_Done,
     /* 1547033 */   // Label 21485: @1547033
     /* 1547033 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1547115), // Rule ID 18857 //
     /* 1547038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1547046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547077 */     // MIs[0] round
     /* 1547077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547080 */     // MIs[0] policy
     /* 1547080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1547093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547114 */     // GIR_Coverage, 18857,
     /* 1547114 */     GIR_EraseRootFromParent_Done,
     /* 1547115 */   // Label 21486: @1547115
     /* 1547115 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1547197), // Rule ID 18860 //
     /* 1547120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547159 */     // MIs[0] round
     /* 1547159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547162 */     // MIs[0] policy
     /* 1547162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547172 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1547175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547196 */     // GIR_Coverage, 18860,
     /* 1547196 */     GIR_EraseRootFromParent_Done,
     /* 1547197 */   // Label 21487: @1547197
     /* 1547197 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1547279), // Rule ID 18861 //
     /* 1547202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547241 */     // MIs[0] round
     /* 1547241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547244 */     // MIs[0] policy
     /* 1547244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547254 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1547257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547278 */     // GIR_Coverage, 18861,
     /* 1547278 */     GIR_EraseRootFromParent_Done,
     /* 1547279 */   // Label 21488: @1547279
     /* 1547279 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1547361), // Rule ID 18864 //
     /* 1547284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547323 */     // MIs[0] round
     /* 1547323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547326 */     // MIs[0] policy
     /* 1547326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1547339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547360 */     // GIR_Coverage, 18864,
     /* 1547360 */     GIR_EraseRootFromParent_Done,
     /* 1547361 */   // Label 21489: @1547361
     /* 1547361 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1547443), // Rule ID 18865 //
     /* 1547366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547405 */     // MIs[0] round
     /* 1547405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547408 */     // MIs[0] policy
     /* 1547408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547418 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1547421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547442 */     // GIR_Coverage, 18865,
     /* 1547442 */     GIR_EraseRootFromParent_Done,
     /* 1547443 */   // Label 21490: @1547443
     /* 1547443 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1547525), // Rule ID 18868 //
     /* 1547448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547487 */     // MIs[0] round
     /* 1547487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547490 */     // MIs[0] policy
     /* 1547490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547524 */     // GIR_Coverage, 18868,
     /* 1547524 */     GIR_EraseRootFromParent_Done,
     /* 1547525 */   // Label 21491: @1547525
     /* 1547525 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1547607), // Rule ID 18869 //
     /* 1547530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547569 */     // MIs[0] round
     /* 1547569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547572 */     // MIs[0] policy
     /* 1547572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547606 */     // GIR_Coverage, 18869,
     /* 1547606 */     GIR_EraseRootFromParent_Done,
     /* 1547607 */   // Label 21492: @1547607
     /* 1547607 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1547689), // Rule ID 18872 //
     /* 1547612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547651 */     // MIs[0] round
     /* 1547651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547654 */     // MIs[0] policy
     /* 1547654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547664 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547688 */     // GIR_Coverage, 18872,
     /* 1547688 */     GIR_EraseRootFromParent_Done,
     /* 1547689 */   // Label 21493: @1547689
     /* 1547689 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1547771), // Rule ID 18873 //
     /* 1547694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547733 */     // MIs[0] round
     /* 1547733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547736 */     // MIs[0] policy
     /* 1547736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547746 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547770 */     // GIR_Coverage, 18873,
     /* 1547770 */     GIR_EraseRootFromParent_Done,
     /* 1547771 */   // Label 21494: @1547771
     /* 1547771 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1547853), // Rule ID 18876 //
     /* 1547776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547815 */     // MIs[0] round
     /* 1547815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547818 */     // MIs[0] policy
     /* 1547818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547828 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547852 */     // GIR_Coverage, 18876,
     /* 1547852 */     GIR_EraseRootFromParent_Done,
     /* 1547853 */   // Label 21495: @1547853
     /* 1547853 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1547935), // Rule ID 18877 //
     /* 1547858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547897 */     // MIs[0] round
     /* 1547897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547900 */     // MIs[0] policy
     /* 1547900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547910 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547934 */     // GIR_Coverage, 18877,
     /* 1547934 */     GIR_EraseRootFromParent_Done,
     /* 1547935 */   // Label 21496: @1547935
     /* 1547935 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1548017), // Rule ID 18880 //
     /* 1547940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547979 */     // MIs[0] round
     /* 1547979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547982 */     // MIs[0] policy
     /* 1547982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547992 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1547995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548016 */     // GIR_Coverage, 18880,
     /* 1548016 */     GIR_EraseRootFromParent_Done,
     /* 1548017 */   // Label 21497: @1548017
     /* 1548017 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1548099), // Rule ID 18881 //
     /* 1548022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548061 */     // MIs[0] round
     /* 1548061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548064 */     // MIs[0] policy
     /* 1548064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548074 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1548077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548098 */     // GIR_Coverage, 18881,
     /* 1548098 */     GIR_EraseRootFromParent_Done,
     /* 1548099 */   // Label 21498: @1548099
     /* 1548099 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1548181), // Rule ID 18884 //
     /* 1548104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548143 */     // MIs[0] round
     /* 1548143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548146 */     // MIs[0] policy
     /* 1548146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1548159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548180 */     // GIR_Coverage, 18884,
     /* 1548180 */     GIR_EraseRootFromParent_Done,
     /* 1548181 */   // Label 21499: @1548181
     /* 1548181 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1548263), // Rule ID 18885 //
     /* 1548186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548225 */     // MIs[0] round
     /* 1548225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548228 */     // MIs[0] policy
     /* 1548228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1548241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548262 */     // GIR_Coverage, 18885,
     /* 1548262 */     GIR_EraseRootFromParent_Done,
     /* 1548263 */   // Label 21500: @1548263
     /* 1548263 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1548345), // Rule ID 18888 //
     /* 1548268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548307 */     // MIs[0] round
     /* 1548307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548310 */     // MIs[0] policy
     /* 1548310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548320 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1548323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548344 */     // GIR_Coverage, 18888,
     /* 1548344 */     GIR_EraseRootFromParent_Done,
     /* 1548345 */   // Label 21501: @1548345
     /* 1548345 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1548427), // Rule ID 18889 //
     /* 1548350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548389 */     // MIs[0] round
     /* 1548389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548392 */     // MIs[0] policy
     /* 1548392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548402 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1548405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548426 */     // GIR_Coverage, 18889,
     /* 1548426 */     GIR_EraseRootFromParent_Done,
     /* 1548427 */   // Label 21502: @1548427
     /* 1548427 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1548509), // Rule ID 18892 //
     /* 1548432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548471 */     // MIs[0] round
     /* 1548471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548474 */     // MIs[0] policy
     /* 1548474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548484 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548508 */     // GIR_Coverage, 18892,
     /* 1548508 */     GIR_EraseRootFromParent_Done,
     /* 1548509 */   // Label 21503: @1548509
     /* 1548509 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1548591), // Rule ID 18893 //
     /* 1548514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548553 */     // MIs[0] round
     /* 1548553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548556 */     // MIs[0] policy
     /* 1548556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548566 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548590 */     // GIR_Coverage, 18893,
     /* 1548590 */     GIR_EraseRootFromParent_Done,
     /* 1548591 */   // Label 21504: @1548591
     /* 1548591 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1548673), // Rule ID 18896 //
     /* 1548596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548635 */     // MIs[0] round
     /* 1548635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548638 */     // MIs[0] policy
     /* 1548638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548648 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548672 */     // GIR_Coverage, 18896,
     /* 1548672 */     GIR_EraseRootFromParent_Done,
     /* 1548673 */   // Label 21505: @1548673
     /* 1548673 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1548755), // Rule ID 18897 //
     /* 1548678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548717 */     // MIs[0] round
     /* 1548717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548720 */     // MIs[0] policy
     /* 1548720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548754 */     // GIR_Coverage, 18897,
     /* 1548754 */     GIR_EraseRootFromParent_Done,
     /* 1548755 */   // Label 21506: @1548755
     /* 1548755 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1548837), // Rule ID 18900 //
     /* 1548760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548799 */     // MIs[0] round
     /* 1548799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548802 */     // MIs[0] policy
     /* 1548802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548812 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548836 */     // GIR_Coverage, 18900,
     /* 1548836 */     GIR_EraseRootFromParent_Done,
     /* 1548837 */   // Label 21507: @1548837
     /* 1548837 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1548919), // Rule ID 18901 //
     /* 1548842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548881 */     // MIs[0] round
     /* 1548881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548884 */     // MIs[0] policy
     /* 1548884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548918 */     // GIR_Coverage, 18901,
     /* 1548918 */     GIR_EraseRootFromParent_Done,
     /* 1548919 */   // Label 21508: @1548919
     /* 1548919 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1549001), // Rule ID 18904 //
     /* 1548924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548963 */     // MIs[0] round
     /* 1548963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548966 */     // MIs[0] policy
     /* 1548966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549000 */     // GIR_Coverage, 18904,
     /* 1549000 */     GIR_EraseRootFromParent_Done,
     /* 1549001 */   // Label 21509: @1549001
     /* 1549001 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1549083), // Rule ID 18905 //
     /* 1549006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549045 */     // MIs[0] round
     /* 1549045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549048 */     // MIs[0] policy
     /* 1549048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1549061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549082 */     // GIR_Coverage, 18905,
     /* 1549082 */     GIR_EraseRootFromParent_Done,
     /* 1549083 */   // Label 21510: @1549083
     /* 1549083 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1549165), // Rule ID 18908 //
     /* 1549088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549127 */     // MIs[0] round
     /* 1549127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549130 */     // MIs[0] policy
     /* 1549130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549140 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1549143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549164 */     // GIR_Coverage, 18908,
     /* 1549164 */     GIR_EraseRootFromParent_Done,
     /* 1549165 */   // Label 21511: @1549165
     /* 1549165 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1549247), // Rule ID 18909 //
     /* 1549170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549209 */     // MIs[0] round
     /* 1549209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549212 */     // MIs[0] policy
     /* 1549212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1549225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549246 */     // GIR_Coverage, 18909,
     /* 1549246 */     GIR_EraseRootFromParent_Done,
     /* 1549247 */   // Label 21512: @1549247
     /* 1549247 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1549329), // Rule ID 18912 //
     /* 1549252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549291 */     // MIs[0] round
     /* 1549291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549294 */     // MIs[0] policy
     /* 1549294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549304 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1549307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549328 */     // GIR_Coverage, 18912,
     /* 1549328 */     GIR_EraseRootFromParent_Done,
     /* 1549329 */   // Label 21513: @1549329
     /* 1549329 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1549411), // Rule ID 18913 //
     /* 1549334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549373 */     // MIs[0] round
     /* 1549373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549376 */     // MIs[0] policy
     /* 1549376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549386 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1549389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549410 */     // GIR_Coverage, 18913,
     /* 1549410 */     GIR_EraseRootFromParent_Done,
     /* 1549411 */   // Label 21514: @1549411
     /* 1549411 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1549493), // Rule ID 18916 //
     /* 1549416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549455 */     // MIs[0] round
     /* 1549455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549458 */     // MIs[0] policy
     /* 1549458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549468 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549492 */     // GIR_Coverage, 18916,
     /* 1549492 */     GIR_EraseRootFromParent_Done,
     /* 1549493 */   // Label 21515: @1549493
     /* 1549493 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1549575), // Rule ID 18917 //
     /* 1549498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549537 */     // MIs[0] round
     /* 1549537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549540 */     // MIs[0] policy
     /* 1549540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549574 */     // GIR_Coverage, 18917,
     /* 1549574 */     GIR_EraseRootFromParent_Done,
     /* 1549575 */   // Label 21516: @1549575
     /* 1549575 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1549657), // Rule ID 18920 //
     /* 1549580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549619 */     // MIs[0] round
     /* 1549619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549622 */     // MIs[0] policy
     /* 1549622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549656 */     // GIR_Coverage, 18920,
     /* 1549656 */     GIR_EraseRootFromParent_Done,
     /* 1549657 */   // Label 21517: @1549657
     /* 1549657 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1549739), // Rule ID 18921 //
     /* 1549662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549701 */     // MIs[0] round
     /* 1549701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549704 */     // MIs[0] policy
     /* 1549704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549714 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549738 */     // GIR_Coverage, 18921,
     /* 1549738 */     GIR_EraseRootFromParent_Done,
     /* 1549739 */   // Label 21518: @1549739
     /* 1549739 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1549821), // Rule ID 18924 //
     /* 1549744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549783 */     // MIs[0] round
     /* 1549783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549786 */     // MIs[0] policy
     /* 1549786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549796 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549820 */     // GIR_Coverage, 18924,
     /* 1549820 */     GIR_EraseRootFromParent_Done,
     /* 1549821 */   // Label 21519: @1549821
     /* 1549821 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1549903), // Rule ID 18925 //
     /* 1549826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549865 */     // MIs[0] round
     /* 1549865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549868 */     // MIs[0] policy
     /* 1549868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549878 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549902 */     // GIR_Coverage, 18925,
     /* 1549902 */     GIR_EraseRootFromParent_Done,
     /* 1549903 */   // Label 21520: @1549903
     /* 1549903 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1549985), // Rule ID 18928 //
     /* 1549908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549947 */     // MIs[0] round
     /* 1549947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549950 */     // MIs[0] policy
     /* 1549950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549960 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549984 */     // GIR_Coverage, 18928,
     /* 1549984 */     GIR_EraseRootFromParent_Done,
     /* 1549985 */   // Label 21521: @1549985
     /* 1549985 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1550067), // Rule ID 18929 //
     /* 1549990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550029 */     // MIs[0] round
     /* 1550029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550032 */     // MIs[0] policy
     /* 1550032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550042 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1550045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550066 */     // GIR_Coverage, 18929,
     /* 1550066 */     GIR_EraseRootFromParent_Done,
     /* 1550067 */   // Label 21522: @1550067
     /* 1550067 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1550149), // Rule ID 18932 //
     /* 1550072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550111 */     // MIs[0] round
     /* 1550111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550114 */     // MIs[0] policy
     /* 1550114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1550127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550148 */     // GIR_Coverage, 18932,
     /* 1550148 */     GIR_EraseRootFromParent_Done,
     /* 1550149 */   // Label 21523: @1550149
     /* 1550149 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1550231), // Rule ID 18933 //
     /* 1550154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1550171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1550174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550193 */     // MIs[0] round
     /* 1550193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550196 */     // MIs[0] policy
     /* 1550196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550206 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1550209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550230 */     // GIR_Coverage, 18933,
     /* 1550230 */     GIR_EraseRootFromParent_Done,
     /* 1550231 */   // Label 21524: @1550231
     /* 1550231 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1550313), // Rule ID 18936 //
     /* 1550236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550275 */     // MIs[0] round
     /* 1550275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550278 */     // MIs[0] policy
     /* 1550278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550288 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1550291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550312 */     // GIR_Coverage, 18936,
     /* 1550312 */     GIR_EraseRootFromParent_Done,
     /* 1550313 */   // Label 21525: @1550313
     /* 1550313 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1550395), // Rule ID 18937 //
     /* 1550318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1550338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550357 */     // MIs[0] round
     /* 1550357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550360 */     // MIs[0] policy
     /* 1550360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1550373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550394 */     // GIR_Coverage, 18937,
     /* 1550394 */     GIR_EraseRootFromParent_Done,
     /* 1550395 */   // Label 21526: @1550395
     /* 1550395 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1550477), // Rule ID 18940 //
     /* 1550400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550439 */     // MIs[0] round
     /* 1550439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550442 */     // MIs[0] policy
     /* 1550442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550476 */     // GIR_Coverage, 18940,
     /* 1550476 */     GIR_EraseRootFromParent_Done,
     /* 1550477 */   // Label 21527: @1550477
     /* 1550477 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1550559), // Rule ID 18941 //
     /* 1550482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550521 */     // MIs[0] round
     /* 1550521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550524 */     // MIs[0] policy
     /* 1550524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550534 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550558 */     // GIR_Coverage, 18941,
     /* 1550558 */     GIR_EraseRootFromParent_Done,
     /* 1550559 */   // Label 21528: @1550559
     /* 1550559 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1550641), // Rule ID 18944 //
     /* 1550564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550603 */     // MIs[0] round
     /* 1550603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550606 */     // MIs[0] policy
     /* 1550606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550616 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550640 */     // GIR_Coverage, 18944,
     /* 1550640 */     GIR_EraseRootFromParent_Done,
     /* 1550641 */   // Label 21529: @1550641
     /* 1550641 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1550723), // Rule ID 18945 //
     /* 1550646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550685 */     // MIs[0] round
     /* 1550685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550688 */     // MIs[0] policy
     /* 1550688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550698 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550722 */     // GIR_Coverage, 18945,
     /* 1550722 */     GIR_EraseRootFromParent_Done,
     /* 1550723 */   // Label 21530: @1550723
     /* 1550723 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1550805), // Rule ID 18948 //
     /* 1550728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550767 */     // MIs[0] round
     /* 1550767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550770 */     // MIs[0] policy
     /* 1550770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550780 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550804 */     // GIR_Coverage, 18948,
     /* 1550804 */     GIR_EraseRootFromParent_Done,
     /* 1550805 */   // Label 21531: @1550805
     /* 1550805 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1550887), // Rule ID 18949 //
     /* 1550810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550849 */     // MIs[0] round
     /* 1550849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550852 */     // MIs[0] policy
     /* 1550852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550862 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550886 */     // GIR_Coverage, 18949,
     /* 1550886 */     GIR_EraseRootFromParent_Done,
     /* 1550887 */   // Label 21532: @1550887
     /* 1550887 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1550969), // Rule ID 18952 //
     /* 1550892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550931 */     // MIs[0] round
     /* 1550931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550934 */     // MIs[0] policy
     /* 1550934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550944 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550968 */     // GIR_Coverage, 18952,
     /* 1550968 */     GIR_EraseRootFromParent_Done,
     /* 1550969 */   // Label 21533: @1550969
     /* 1550969 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1551051), // Rule ID 18953 //
     /* 1550974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551013 */     // MIs[0] round
     /* 1551013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551016 */     // MIs[0] policy
     /* 1551016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1551029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551050 */     // GIR_Coverage, 18953,
     /* 1551050 */     GIR_EraseRootFromParent_Done,
     /* 1551051 */   // Label 21534: @1551051
     /* 1551051 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1551133), // Rule ID 18956 //
     /* 1551056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551095 */     // MIs[0] round
     /* 1551095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551098 */     // MIs[0] policy
     /* 1551098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1551111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551132 */     // GIR_Coverage, 18956,
     /* 1551132 */     GIR_EraseRootFromParent_Done,
     /* 1551133 */   // Label 21535: @1551133
     /* 1551133 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1551215), // Rule ID 18957 //
     /* 1551138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1551149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1551152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1551158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551177 */     // MIs[0] round
     /* 1551177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551180 */     // MIs[0] policy
     /* 1551180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551190 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1551193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551214 */     // GIR_Coverage, 18957,
     /* 1551214 */     GIR_EraseRootFromParent_Done,
     /* 1551215 */   // Label 21536: @1551215
     /* 1551215 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1551297), // Rule ID 18960 //
     /* 1551220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551259 */     // MIs[0] round
     /* 1551259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551262 */     // MIs[0] policy
     /* 1551262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551272 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1551275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551296 */     // GIR_Coverage, 18960,
     /* 1551296 */     GIR_EraseRootFromParent_Done,
     /* 1551297 */   // Label 21537: @1551297
     /* 1551297 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1551379), // Rule ID 18961 //
     /* 1551302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1551313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1551316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1551322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551341 */     // MIs[0] round
     /* 1551341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551344 */     // MIs[0] policy
     /* 1551344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551354 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1551357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551378 */     // GIR_Coverage, 18961,
     /* 1551378 */     GIR_EraseRootFromParent_Done,
     /* 1551379 */   // Label 21538: @1551379
     /* 1551379 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1551461), // Rule ID 18964 //
     /* 1551384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551423 */     // MIs[0] round
     /* 1551423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551426 */     // MIs[0] policy
     /* 1551426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551460 */     // GIR_Coverage, 18964,
     /* 1551460 */     GIR_EraseRootFromParent_Done,
     /* 1551461 */   // Label 21539: @1551461
     /* 1551461 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1551543), // Rule ID 18965 //
     /* 1551466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551505 */     // MIs[0] round
     /* 1551505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551508 */     // MIs[0] policy
     /* 1551508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551518 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551542 */     // GIR_Coverage, 18965,
     /* 1551542 */     GIR_EraseRootFromParent_Done,
     /* 1551543 */   // Label 21540: @1551543
     /* 1551543 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1551625), // Rule ID 18968 //
     /* 1551548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551587 */     // MIs[0] round
     /* 1551587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551590 */     // MIs[0] policy
     /* 1551590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551624 */     // GIR_Coverage, 18968,
     /* 1551624 */     GIR_EraseRootFromParent_Done,
     /* 1551625 */   // Label 21541: @1551625
     /* 1551625 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1551707), // Rule ID 18969 //
     /* 1551630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551669 */     // MIs[0] round
     /* 1551669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551672 */     // MIs[0] policy
     /* 1551672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551682 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551706 */     // GIR_Coverage, 18969,
     /* 1551706 */     GIR_EraseRootFromParent_Done,
     /* 1551707 */   // Label 21542: @1551707
     /* 1551707 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1551789), // Rule ID 18972 //
     /* 1551712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551751 */     // MIs[0] round
     /* 1551751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551754 */     // MIs[0] policy
     /* 1551754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551788 */     // GIR_Coverage, 18972,
     /* 1551788 */     GIR_EraseRootFromParent_Done,
     /* 1551789 */   // Label 21543: @1551789
     /* 1551789 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1551871), // Rule ID 18973 //
     /* 1551794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551833 */     // MIs[0] round
     /* 1551833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551836 */     // MIs[0] policy
     /* 1551836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551846 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551870 */     // GIR_Coverage, 18973,
     /* 1551870 */     GIR_EraseRootFromParent_Done,
     /* 1551871 */   // Label 21544: @1551871
     /* 1551871 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1551953), // Rule ID 18976 //
     /* 1551876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551915 */     // MIs[0] round
     /* 1551915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551918 */     // MIs[0] policy
     /* 1551918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551928 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551952 */     // GIR_Coverage, 18976,
     /* 1551952 */     GIR_EraseRootFromParent_Done,
     /* 1551953 */   // Label 21545: @1551953
     /* 1551953 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1552035), // Rule ID 18977 //
     /* 1551958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551997 */     // MIs[0] round
     /* 1551997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552000 */     // MIs[0] policy
     /* 1552000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1552013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552034 */     // GIR_Coverage, 18977,
     /* 1552034 */     GIR_EraseRootFromParent_Done,
     /* 1552035 */   // Label 21546: @1552035
     /* 1552035 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1552117), // Rule ID 18980 //
     /* 1552040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552079 */     // MIs[0] round
     /* 1552079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552082 */     // MIs[0] policy
     /* 1552082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552092 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1552095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552116 */     // GIR_Coverage, 18980,
     /* 1552116 */     GIR_EraseRootFromParent_Done,
     /* 1552117 */   // Label 21547: @1552117
     /* 1552117 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1552199), // Rule ID 18981 //
     /* 1552122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1552142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552161 */     // MIs[0] round
     /* 1552161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552164 */     // MIs[0] policy
     /* 1552164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552174 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1552177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552198 */     // GIR_Coverage, 18981,
     /* 1552198 */     GIR_EraseRootFromParent_Done,
     /* 1552199 */   // Label 21548: @1552199
     /* 1552199 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1552281), // Rule ID 18984 //
     /* 1552204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1552207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552243 */     // MIs[0] round
     /* 1552243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552246 */     // MIs[0] policy
     /* 1552246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552256 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1552259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552280 */     // GIR_Coverage, 18984,
     /* 1552280 */     GIR_EraseRootFromParent_Done,
     /* 1552281 */   // Label 21549: @1552281
     /* 1552281 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1552363), // Rule ID 18985 //
     /* 1552286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1552289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1552303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1552306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1552321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552325 */     // MIs[0] round
     /* 1552325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552328 */     // MIs[0] policy
     /* 1552328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1552341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552362 */     // GIR_Coverage, 18985,
     /* 1552362 */     GIR_EraseRootFromParent_Done,
     /* 1552363 */   // Label 21550: @1552363
     /* 1552363 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1552445), // Rule ID 18988 //
     /* 1552368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552407 */     // MIs[0] round
     /* 1552407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552410 */     // MIs[0] policy
     /* 1552410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552420 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552444 */     // GIR_Coverage, 18988,
     /* 1552444 */     GIR_EraseRootFromParent_Done,
     /* 1552445 */   // Label 21551: @1552445
     /* 1552445 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1552527), // Rule ID 18989 //
     /* 1552450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1552461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1552464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552489 */     // MIs[0] round
     /* 1552489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552492 */     // MIs[0] policy
     /* 1552492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552526 */     // GIR_Coverage, 18989,
     /* 1552526 */     GIR_EraseRootFromParent_Done,
     /* 1552527 */   // Label 21552: @1552527
     /* 1552527 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1552609), // Rule ID 18992 //
     /* 1552532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552571 */     // MIs[0] round
     /* 1552571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552574 */     // MIs[0] policy
     /* 1552574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552608 */     // GIR_Coverage, 18992,
     /* 1552608 */     GIR_EraseRootFromParent_Done,
     /* 1552609 */   // Label 21553: @1552609
     /* 1552609 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1552691), // Rule ID 18993 //
     /* 1552614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552653 */     // MIs[0] round
     /* 1552653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552656 */     // MIs[0] policy
     /* 1552656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552690 */     // GIR_Coverage, 18993,
     /* 1552690 */     GIR_EraseRootFromParent_Done,
     /* 1552691 */   // Label 21554: @1552691
     /* 1552691 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1552773), // Rule ID 18996 //
     /* 1552696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552735 */     // MIs[0] round
     /* 1552735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552738 */     // MIs[0] policy
     /* 1552738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552748 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552772 */     // GIR_Coverage, 18996,
     /* 1552772 */     GIR_EraseRootFromParent_Done,
     /* 1552773 */   // Label 21555: @1552773
     /* 1552773 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1552855), // Rule ID 18997 //
     /* 1552778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552817 */     // MIs[0] round
     /* 1552817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552820 */     // MIs[0] policy
     /* 1552820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552830 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552854 */     // GIR_Coverage, 18997,
     /* 1552854 */     GIR_EraseRootFromParent_Done,
     /* 1552855 */   // Label 21556: @1552855
     /* 1552855 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1552937), // Rule ID 19000 //
     /* 1552860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552899 */     // MIs[0] round
     /* 1552899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552902 */     // MIs[0] policy
     /* 1552902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552912 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552936 */     // GIR_Coverage, 19000,
     /* 1552936 */     GIR_EraseRootFromParent_Done,
     /* 1552937 */   // Label 21557: @1552937
     /* 1552937 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1553019), // Rule ID 19001 //
     /* 1552942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552981 */     // MIs[0] round
     /* 1552981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552984 */     // MIs[0] policy
     /* 1552984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552994 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1553001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1553003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1553005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553018 */     // GIR_Coverage, 19001,
     /* 1553018 */     GIR_EraseRootFromParent_Done,
     /* 1553019 */   // Label 21558: @1553019
     /* 1553019 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1553101), // Rule ID 19006 //
     /* 1553024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553063 */     // MIs[0] round
     /* 1553063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553066 */     // MIs[0] policy
     /* 1553066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553076 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1553079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553100 */     // GIR_Coverage, 19006,
     /* 1553100 */     GIR_EraseRootFromParent_Done,
     /* 1553101 */   // Label 21559: @1553101
     /* 1553101 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1553183), // Rule ID 19007 //
     /* 1553106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553145 */     // MIs[0] round
     /* 1553145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553148 */     // MIs[0] policy
     /* 1553148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553158 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1553161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553182 */     // GIR_Coverage, 19007,
     /* 1553182 */     GIR_EraseRootFromParent_Done,
     /* 1553183 */   // Label 21560: @1553183
     /* 1553183 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1553265), // Rule ID 19010 //
     /* 1553188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553227 */     // MIs[0] round
     /* 1553227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553230 */     // MIs[0] policy
     /* 1553230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1553243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553264 */     // GIR_Coverage, 19010,
     /* 1553264 */     GIR_EraseRootFromParent_Done,
     /* 1553265 */   // Label 21561: @1553265
     /* 1553265 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1553347), // Rule ID 19011 //
     /* 1553270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553309 */     // MIs[0] round
     /* 1553309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553312 */     // MIs[0] policy
     /* 1553312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1553325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553346 */     // GIR_Coverage, 19011,
     /* 1553346 */     GIR_EraseRootFromParent_Done,
     /* 1553347 */   // Label 21562: @1553347
     /* 1553347 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1553429), // Rule ID 19014 //
     /* 1553352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553391 */     // MIs[0] round
     /* 1553391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553394 */     // MIs[0] policy
     /* 1553394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553404 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553428 */     // GIR_Coverage, 19014,
     /* 1553428 */     GIR_EraseRootFromParent_Done,
     /* 1553429 */   // Label 21563: @1553429
     /* 1553429 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1553511), // Rule ID 19015 //
     /* 1553434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553473 */     // MIs[0] round
     /* 1553473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553476 */     // MIs[0] policy
     /* 1553476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553486 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11332:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553510 */     // GIR_Coverage, 19015,
     /* 1553510 */     GIR_EraseRootFromParent_Done,
     /* 1553511 */   // Label 21564: @1553511
     /* 1553511 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1553593), // Rule ID 19018 //
     /* 1553516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553555 */     // MIs[0] round
     /* 1553555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553558 */     // MIs[0] policy
     /* 1553558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553568 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553592 */     // GIR_Coverage, 19018,
     /* 1553592 */     GIR_EraseRootFromParent_Done,
     /* 1553593 */   // Label 21565: @1553593
     /* 1553593 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1553675), // Rule ID 19019 //
     /* 1553598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553637 */     // MIs[0] round
     /* 1553637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553640 */     // MIs[0] policy
     /* 1553640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11332:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553674 */     // GIR_Coverage, 19019,
     /* 1553674 */     GIR_EraseRootFromParent_Done,
     /* 1553675 */   // Label 21566: @1553675
     /* 1553675 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1553757), // Rule ID 19022 //
     /* 1553680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1553683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553719 */     // MIs[0] round
     /* 1553719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553722 */     // MIs[0] policy
     /* 1553722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553732 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553756 */     // GIR_Coverage, 19022,
     /* 1553756 */     GIR_EraseRootFromParent_Done,
     /* 1553757 */   // Label 21567: @1553757
     /* 1553757 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1553839), // Rule ID 19023 //
     /* 1553762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1553765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553801 */     // MIs[0] round
     /* 1553801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553804 */     // MIs[0] policy
     /* 1553804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553814 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11332:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553838 */     // GIR_Coverage, 19023,
     /* 1553838 */     GIR_EraseRootFromParent_Done,
     /* 1553839 */   // Label 21568: @1553839
     /* 1553839 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1553921), // Rule ID 19026 //
     /* 1553844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553883 */     // MIs[0] round
     /* 1553883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553886 */     // MIs[0] policy
     /* 1553886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553896 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553920 */     // GIR_Coverage, 19026,
     /* 1553920 */     GIR_EraseRootFromParent_Done,
     /* 1553921 */   // Label 21569: @1553921
     /* 1553921 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1554003), // Rule ID 19027 //
     /* 1553926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553965 */     // MIs[0] round
     /* 1553965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553968 */     // MIs[0] policy
     /* 1553968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553978 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554002 */     // GIR_Coverage, 19027,
     /* 1554002 */     GIR_EraseRootFromParent_Done,
     /* 1554003 */   // Label 21570: @1554003
     /* 1554003 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1554085), // Rule ID 19030 //
     /* 1554008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554047 */     // MIs[0] round
     /* 1554047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554050 */     // MIs[0] policy
     /* 1554050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554060 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1554063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554084 */     // GIR_Coverage, 19030,
     /* 1554084 */     GIR_EraseRootFromParent_Done,
     /* 1554085 */   // Label 21571: @1554085
     /* 1554085 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1554167), // Rule ID 19031 //
     /* 1554090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554129 */     // MIs[0] round
     /* 1554129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554132 */     // MIs[0] policy
     /* 1554132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554142 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1554145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554166 */     // GIR_Coverage, 19031,
     /* 1554166 */     GIR_EraseRootFromParent_Done,
     /* 1554167 */   // Label 21572: @1554167
     /* 1554167 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1554249), // Rule ID 19034 //
     /* 1554172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554211 */     // MIs[0] round
     /* 1554211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554214 */     // MIs[0] policy
     /* 1554214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1554227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554248 */     // GIR_Coverage, 19034,
     /* 1554248 */     GIR_EraseRootFromParent_Done,
     /* 1554249 */   // Label 21573: @1554249
     /* 1554249 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1554331), // Rule ID 19035 //
     /* 1554254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554293 */     // MIs[0] round
     /* 1554293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554296 */     // MIs[0] policy
     /* 1554296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554306 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1554309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554330 */     // GIR_Coverage, 19035,
     /* 1554330 */     GIR_EraseRootFromParent_Done,
     /* 1554331 */   // Label 21574: @1554331
     /* 1554331 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1554413), // Rule ID 19038 //
     /* 1554336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554375 */     // MIs[0] round
     /* 1554375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554378 */     // MIs[0] policy
     /* 1554378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554412 */     // GIR_Coverage, 19038,
     /* 1554412 */     GIR_EraseRootFromParent_Done,
     /* 1554413 */   // Label 21575: @1554413
     /* 1554413 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1554495), // Rule ID 19039 //
     /* 1554418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554457 */     // MIs[0] round
     /* 1554457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554460 */     // MIs[0] policy
     /* 1554460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554470 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554494 */     // GIR_Coverage, 19039,
     /* 1554494 */     GIR_EraseRootFromParent_Done,
     /* 1554495 */   // Label 21576: @1554495
     /* 1554495 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1554577), // Rule ID 19042 //
     /* 1554500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554539 */     // MIs[0] round
     /* 1554539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554542 */     // MIs[0] policy
     /* 1554542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554576 */     // GIR_Coverage, 19042,
     /* 1554576 */     GIR_EraseRootFromParent_Done,
     /* 1554577 */   // Label 21577: @1554577
     /* 1554577 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1554659), // Rule ID 19043 //
     /* 1554582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554621 */     // MIs[0] round
     /* 1554621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554624 */     // MIs[0] policy
     /* 1554624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554634 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554658 */     // GIR_Coverage, 19043,
     /* 1554658 */     GIR_EraseRootFromParent_Done,
     /* 1554659 */   // Label 21578: @1554659
     /* 1554659 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1554741), // Rule ID 19046 //
     /* 1554664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554703 */     // MIs[0] round
     /* 1554703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554706 */     // MIs[0] policy
     /* 1554706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554716 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554740 */     // GIR_Coverage, 19046,
     /* 1554740 */     GIR_EraseRootFromParent_Done,
     /* 1554741 */   // Label 21579: @1554741
     /* 1554741 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1554823), // Rule ID 19047 //
     /* 1554746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554785 */     // MIs[0] round
     /* 1554785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554788 */     // MIs[0] policy
     /* 1554788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554798 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554822 */     // GIR_Coverage, 19047,
     /* 1554822 */     GIR_EraseRootFromParent_Done,
     /* 1554823 */   // Label 21580: @1554823
     /* 1554823 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1554905), // Rule ID 19050 //
     /* 1554828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554867 */     // MIs[0] round
     /* 1554867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554870 */     // MIs[0] policy
     /* 1554870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554880 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554904 */     // GIR_Coverage, 19050,
     /* 1554904 */     GIR_EraseRootFromParent_Done,
     /* 1554905 */   // Label 21581: @1554905
     /* 1554905 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1554987), // Rule ID 19051 //
     /* 1554910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554949 */     // MIs[0] round
     /* 1554949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554952 */     // MIs[0] policy
     /* 1554952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554962 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11332:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554986 */     // GIR_Coverage, 19051,
     /* 1554986 */     GIR_EraseRootFromParent_Done,
     /* 1554987 */   // Label 21582: @1554987
     /* 1554987 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1555069), // Rule ID 19054 //
     /* 1554992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555031 */     // MIs[0] round
     /* 1555031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555034 */     // MIs[0] policy
     /* 1555034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555044 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1555047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555068 */     // GIR_Coverage, 19054,
     /* 1555068 */     GIR_EraseRootFromParent_Done,
     /* 1555069 */   // Label 21583: @1555069
     /* 1555069 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1555151), // Rule ID 19055 //
     /* 1555074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555113 */     // MIs[0] round
     /* 1555113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555116 */     // MIs[0] policy
     /* 1555116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555126 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11332:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1555129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555150 */     // GIR_Coverage, 19055,
     /* 1555150 */     GIR_EraseRootFromParent_Done,
     /* 1555151 */   // Label 21584: @1555151
     /* 1555151 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1555233), // Rule ID 19058 //
     /* 1555156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1555159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555195 */     // MIs[0] round
     /* 1555195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555198 */     // MIs[0] policy
     /* 1555198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555208 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1555211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555232 */     // GIR_Coverage, 19058,
     /* 1555232 */     GIR_EraseRootFromParent_Done,
     /* 1555233 */   // Label 21585: @1555233
     /* 1555233 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1555315), // Rule ID 19059 //
     /* 1555238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1555246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555277 */     // MIs[0] round
     /* 1555277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555280 */     // MIs[0] policy
     /* 1555280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555290 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11332:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1555293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555314 */     // GIR_Coverage, 19059,
     /* 1555314 */     GIR_EraseRootFromParent_Done,
     /* 1555315 */   // Label 21586: @1555315
     /* 1555315 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1555397), // Rule ID 19118 //
     /* 1555320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555359 */     // MIs[0] round
     /* 1555359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555362 */     // MIs[0] policy
     /* 1555362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555372 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1555375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555396 */     // GIR_Coverage, 19118,
     /* 1555396 */     GIR_EraseRootFromParent_Done,
     /* 1555397 */   // Label 21587: @1555397
     /* 1555397 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1555479), // Rule ID 19119 //
     /* 1555402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555441 */     // MIs[0] round
     /* 1555441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555444 */     // MIs[0] policy
     /* 1555444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555454 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1555457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555478 */     // GIR_Coverage, 19119,
     /* 1555478 */     GIR_EraseRootFromParent_Done,
     /* 1555479 */   // Label 21588: @1555479
     /* 1555479 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1555561), // Rule ID 19122 //
     /* 1555484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555523 */     // MIs[0] round
     /* 1555523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555526 */     // MIs[0] policy
     /* 1555526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555536 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555560 */     // GIR_Coverage, 19122,
     /* 1555560 */     GIR_EraseRootFromParent_Done,
     /* 1555561 */   // Label 21589: @1555561
     /* 1555561 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1555643), // Rule ID 19123 //
     /* 1555566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555605 */     // MIs[0] round
     /* 1555605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555608 */     // MIs[0] policy
     /* 1555608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555642 */     // GIR_Coverage, 19123,
     /* 1555642 */     GIR_EraseRootFromParent_Done,
     /* 1555643 */   // Label 21590: @1555643
     /* 1555643 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1555725), // Rule ID 19126 //
     /* 1555648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555687 */     // MIs[0] round
     /* 1555687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555690 */     // MIs[0] policy
     /* 1555690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555700 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555724 */     // GIR_Coverage, 19126,
     /* 1555724 */     GIR_EraseRootFromParent_Done,
     /* 1555725 */   // Label 21591: @1555725
     /* 1555725 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1555807), // Rule ID 19127 //
     /* 1555730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555769 */     // MIs[0] round
     /* 1555769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555772 */     // MIs[0] policy
     /* 1555772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555806 */     // GIR_Coverage, 19127,
     /* 1555806 */     GIR_EraseRootFromParent_Done,
     /* 1555807 */   // Label 21592: @1555807
     /* 1555807 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1555889), // Rule ID 19130 //
     /* 1555812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555851 */     // MIs[0] round
     /* 1555851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555854 */     // MIs[0] policy
     /* 1555854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555864 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555888 */     // GIR_Coverage, 19130,
     /* 1555888 */     GIR_EraseRootFromParent_Done,
     /* 1555889 */   // Label 21593: @1555889
     /* 1555889 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1555971), // Rule ID 19131 //
     /* 1555894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555933 */     // MIs[0] round
     /* 1555933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555936 */     // MIs[0] policy
     /* 1555936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555946 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11308:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555970 */     // GIR_Coverage, 19131,
     /* 1555970 */     GIR_EraseRootFromParent_Done,
     /* 1555971 */   // Label 21594: @1555971
     /* 1555971 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1556053), // Rule ID 19134 //
     /* 1555976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556015 */     // MIs[0] round
     /* 1556015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556018 */     // MIs[0] policy
     /* 1556018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1556031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556052 */     // GIR_Coverage, 19134,
     /* 1556052 */     GIR_EraseRootFromParent_Done,
     /* 1556053 */   // Label 21595: @1556053
     /* 1556053 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1556135), // Rule ID 19135 //
     /* 1556058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556097 */     // MIs[0] round
     /* 1556097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556100 */     // MIs[0] policy
     /* 1556100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556110 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1556113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556134 */     // GIR_Coverage, 19135,
     /* 1556134 */     GIR_EraseRootFromParent_Done,
     /* 1556135 */   // Label 21596: @1556135
     /* 1556135 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1556217), // Rule ID 19138 //
     /* 1556140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1556143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556179 */     // MIs[0] round
     /* 1556179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556182 */     // MIs[0] policy
     /* 1556182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556192 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1556195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556216 */     // GIR_Coverage, 19138,
     /* 1556216 */     GIR_EraseRootFromParent_Done,
     /* 1556217 */   // Label 21597: @1556217
     /* 1556217 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1556299), // Rule ID 19139 //
     /* 1556222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1556225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556261 */     // MIs[0] round
     /* 1556261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556264 */     // MIs[0] policy
     /* 1556264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1556277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556298 */     // GIR_Coverage, 19139,
     /* 1556298 */     GIR_EraseRootFromParent_Done,
     /* 1556299 */   // Label 21598: @1556299
     /* 1556299 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1556381), // Rule ID 19142 //
     /* 1556304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556343 */     // MIs[0] round
     /* 1556343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556346 */     // MIs[0] policy
     /* 1556346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1556359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556380 */     // GIR_Coverage, 19142,
     /* 1556380 */     GIR_EraseRootFromParent_Done,
     /* 1556381 */   // Label 21599: @1556381
     /* 1556381 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1556463), // Rule ID 19143 //
     /* 1556386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556425 */     // MIs[0] round
     /* 1556425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556428 */     // MIs[0] policy
     /* 1556428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1556441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556462 */     // GIR_Coverage, 19143,
     /* 1556462 */     GIR_EraseRootFromParent_Done,
     /* 1556463 */   // Label 21600: @1556463
     /* 1556463 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1556545), // Rule ID 19146 //
     /* 1556468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556507 */     // MIs[0] round
     /* 1556507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556510 */     // MIs[0] policy
     /* 1556510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556520 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556544 */     // GIR_Coverage, 19146,
     /* 1556544 */     GIR_EraseRootFromParent_Done,
     /* 1556545 */   // Label 21601: @1556545
     /* 1556545 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1556627), // Rule ID 19147 //
     /* 1556550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556589 */     // MIs[0] round
     /* 1556589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556592 */     // MIs[0] policy
     /* 1556592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556602 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556626 */     // GIR_Coverage, 19147,
     /* 1556626 */     GIR_EraseRootFromParent_Done,
     /* 1556627 */   // Label 21602: @1556627
     /* 1556627 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1556709), // Rule ID 19150 //
     /* 1556632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556671 */     // MIs[0] round
     /* 1556671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556674 */     // MIs[0] policy
     /* 1556674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556708 */     // GIR_Coverage, 19150,
     /* 1556708 */     GIR_EraseRootFromParent_Done,
     /* 1556709 */   // Label 21603: @1556709
     /* 1556709 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1556791), // Rule ID 19151 //
     /* 1556714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556753 */     // MIs[0] round
     /* 1556753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556756 */     // MIs[0] policy
     /* 1556756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556766 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556790 */     // GIR_Coverage, 19151,
     /* 1556790 */     GIR_EraseRootFromParent_Done,
     /* 1556791 */   // Label 21604: @1556791
     /* 1556791 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1556873), // Rule ID 19154 //
     /* 1556796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556835 */     // MIs[0] round
     /* 1556835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556838 */     // MIs[0] policy
     /* 1556838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556872 */     // GIR_Coverage, 19154,
     /* 1556872 */     GIR_EraseRootFromParent_Done,
     /* 1556873 */   // Label 21605: @1556873
     /* 1556873 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1556955), // Rule ID 19155 //
     /* 1556878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556917 */     // MIs[0] round
     /* 1556917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556920 */     // MIs[0] policy
     /* 1556920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556954 */     // GIR_Coverage, 19155,
     /* 1556954 */     GIR_EraseRootFromParent_Done,
     /* 1556955 */   // Label 21606: @1556955
     /* 1556955 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1557037), // Rule ID 19158 //
     /* 1556960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556999 */     // MIs[0] round
     /* 1556999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557002 */     // MIs[0] policy
     /* 1557002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1557015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557036 */     // GIR_Coverage, 19158,
     /* 1557036 */     GIR_EraseRootFromParent_Done,
     /* 1557037 */   // Label 21607: @1557037
     /* 1557037 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1557119), // Rule ID 19159 //
     /* 1557042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557081 */     // MIs[0] round
     /* 1557081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557084 */     // MIs[0] policy
     /* 1557084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1557097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557118 */     // GIR_Coverage, 19159,
     /* 1557118 */     GIR_EraseRootFromParent_Done,
     /* 1557119 */   // Label 21608: @1557119
     /* 1557119 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1557201), // Rule ID 19162 //
     /* 1557124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1557127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557163 */     // MIs[0] round
     /* 1557163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557166 */     // MIs[0] policy
     /* 1557166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557176 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1557179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557200 */     // GIR_Coverage, 19162,
     /* 1557200 */     GIR_EraseRootFromParent_Done,
     /* 1557201 */   // Label 21609: @1557201
     /* 1557201 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1557283), // Rule ID 19163 //
     /* 1557206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1557209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557245 */     // MIs[0] round
     /* 1557245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557248 */     // MIs[0] policy
     /* 1557248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557258 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1557261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557282 */     // GIR_Coverage, 19163,
     /* 1557282 */     GIR_EraseRootFromParent_Done,
     /* 1557283 */   // Label 21610: @1557283
     /* 1557283 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1557365), // Rule ID 19166 //
     /* 1557288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557327 */     // MIs[0] round
     /* 1557327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557330 */     // MIs[0] policy
     /* 1557330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557340 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1557343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557364 */     // GIR_Coverage, 19166,
     /* 1557364 */     GIR_EraseRootFromParent_Done,
     /* 1557365 */   // Label 21611: @1557365
     /* 1557365 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1557447), // Rule ID 19167 //
     /* 1557370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557409 */     // MIs[0] round
     /* 1557409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557412 */     // MIs[0] policy
     /* 1557412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557422 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1557425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557446 */     // GIR_Coverage, 19167,
     /* 1557446 */     GIR_EraseRootFromParent_Done,
     /* 1557447 */   // Label 21612: @1557447
     /* 1557447 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1557529), // Rule ID 19170 //
     /* 1557452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557491 */     // MIs[0] round
     /* 1557491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557494 */     // MIs[0] policy
     /* 1557494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557504 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557528 */     // GIR_Coverage, 19170,
     /* 1557528 */     GIR_EraseRootFromParent_Done,
     /* 1557529 */   // Label 21613: @1557529
     /* 1557529 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1557611), // Rule ID 19171 //
     /* 1557534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557573 */     // MIs[0] round
     /* 1557573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557576 */     // MIs[0] policy
     /* 1557576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557586 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557610 */     // GIR_Coverage, 19171,
     /* 1557610 */     GIR_EraseRootFromParent_Done,
     /* 1557611 */   // Label 21614: @1557611
     /* 1557611 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1557693), // Rule ID 19174 //
     /* 1557616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557655 */     // MIs[0] round
     /* 1557655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557658 */     // MIs[0] policy
     /* 1557658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557692 */     // GIR_Coverage, 19174,
     /* 1557692 */     GIR_EraseRootFromParent_Done,
     /* 1557693 */   // Label 21615: @1557693
     /* 1557693 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1557775), // Rule ID 19175 //
     /* 1557698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557737 */     // MIs[0] round
     /* 1557737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557740 */     // MIs[0] policy
     /* 1557740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557774 */     // GIR_Coverage, 19175,
     /* 1557774 */     GIR_EraseRootFromParent_Done,
     /* 1557775 */   // Label 21616: @1557775
     /* 1557775 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1557857), // Rule ID 20760 //
     /* 1557780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557819 */     // MIs[0] round
     /* 1557819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557822 */     // MIs[0] policy
     /* 1557822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557832 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557856 */     // GIR_Coverage, 20760,
     /* 1557856 */     GIR_EraseRootFromParent_Done,
     /* 1557857 */   // Label 21617: @1557857
     /* 1557857 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1557939), // Rule ID 20761 //
     /* 1557862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557901 */     // MIs[0] round
     /* 1557901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557904 */     // MIs[0] policy
     /* 1557904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557938 */     // GIR_Coverage, 20761,
     /* 1557938 */     GIR_EraseRootFromParent_Done,
     /* 1557939 */   // Label 21618: @1557939
     /* 1557939 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1558021), // Rule ID 20764 //
     /* 1557944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557983 */     // MIs[0] round
     /* 1557983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557986 */     // MIs[0] policy
     /* 1557986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558020 */     // GIR_Coverage, 20764,
     /* 1558020 */     GIR_EraseRootFromParent_Done,
     /* 1558021 */   // Label 21619: @1558021
     /* 1558021 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1558103), // Rule ID 20765 //
     /* 1558026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1558037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1558040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1558043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558065 */     // MIs[0] round
     /* 1558065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558068 */     // MIs[0] policy
     /* 1558068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1558081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558102 */     // GIR_Coverage, 20765,
     /* 1558102 */     GIR_EraseRootFromParent_Done,
     /* 1558103 */   // Label 21620: @1558103
     /* 1558103 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1558185), // Rule ID 20768 //
     /* 1558108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558147 */     // MIs[0] round
     /* 1558147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558150 */     // MIs[0] policy
     /* 1558150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558184 */     // GIR_Coverage, 20768,
     /* 1558184 */     GIR_EraseRootFromParent_Done,
     /* 1558185 */   // Label 21621: @1558185
     /* 1558185 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1558267), // Rule ID 20769 //
     /* 1558190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558229 */     // MIs[0] round
     /* 1558229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558232 */     // MIs[0] policy
     /* 1558232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558266 */     // GIR_Coverage, 20769,
     /* 1558266 */     GIR_EraseRootFromParent_Done,
     /* 1558267 */   // Label 21622: @1558267
     /* 1558267 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1558349), // Rule ID 20772 //
     /* 1558272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558311 */     // MIs[0] round
     /* 1558311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558314 */     // MIs[0] policy
     /* 1558314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558348 */     // GIR_Coverage, 20772,
     /* 1558348 */     GIR_EraseRootFromParent_Done,
     /* 1558349 */   // Label 21623: @1558349
     /* 1558349 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1558431), // Rule ID 20773 //
     /* 1558354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558393 */     // MIs[0] round
     /* 1558393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558396 */     // MIs[0] policy
     /* 1558396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558430 */     // GIR_Coverage, 20773,
     /* 1558430 */     GIR_EraseRootFromParent_Done,
     /* 1558431 */   // Label 21624: @1558431
     /* 1558431 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1558513), // Rule ID 20776 //
     /* 1558436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1558439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558475 */     // MIs[0] round
     /* 1558475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558478 */     // MIs[0] policy
     /* 1558478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558512 */     // GIR_Coverage, 20776,
     /* 1558512 */     GIR_EraseRootFromParent_Done,
     /* 1558513 */   // Label 21625: @1558513
     /* 1558513 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1558595), // Rule ID 20777 //
     /* 1558518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558557 */     // MIs[0] round
     /* 1558557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558560 */     // MIs[0] policy
     /* 1558560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558570 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558594 */     // GIR_Coverage, 20777,
     /* 1558594 */     GIR_EraseRootFromParent_Done,
     /* 1558595 */   // Label 21626: @1558595
     /* 1558595 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1558677), // Rule ID 20780 //
     /* 1558600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558639 */     // MIs[0] round
     /* 1558639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558642 */     // MIs[0] policy
     /* 1558642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558676 */     // GIR_Coverage, 20780,
     /* 1558676 */     GIR_EraseRootFromParent_Done,
     /* 1558677 */   // Label 21627: @1558677
     /* 1558677 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1558759), // Rule ID 20781 //
     /* 1558682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558721 */     // MIs[0] round
     /* 1558721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558724 */     // MIs[0] policy
     /* 1558724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558758 */     // GIR_Coverage, 20781,
     /* 1558758 */     GIR_EraseRootFromParent_Done,
     /* 1558759 */   // Label 21628: @1558759
     /* 1558759 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1558841), // Rule ID 20784 //
     /* 1558764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558803 */     // MIs[0] round
     /* 1558803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558806 */     // MIs[0] policy
     /* 1558806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558840 */     // GIR_Coverage, 20784,
     /* 1558840 */     GIR_EraseRootFromParent_Done,
     /* 1558841 */   // Label 21629: @1558841
     /* 1558841 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1558923), // Rule ID 20785 //
     /* 1558846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558885 */     // MIs[0] round
     /* 1558885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558888 */     // MIs[0] policy
     /* 1558888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558922 */     // GIR_Coverage, 20785,
     /* 1558922 */     GIR_EraseRootFromParent_Done,
     /* 1558923 */   // Label 21630: @1558923
     /* 1558923 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1559005), // Rule ID 20788 //
     /* 1558928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558967 */     // MIs[0] round
     /* 1558967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558970 */     // MIs[0] policy
     /* 1558970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559004 */     // GIR_Coverage, 20788,
     /* 1559004 */     GIR_EraseRootFromParent_Done,
     /* 1559005 */   // Label 21631: @1559005
     /* 1559005 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1559087), // Rule ID 20789 //
     /* 1559010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1559030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559049 */     // MIs[0] round
     /* 1559049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559052 */     // MIs[0] policy
     /* 1559052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559086 */     // GIR_Coverage, 20789,
     /* 1559086 */     GIR_EraseRootFromParent_Done,
     /* 1559087 */   // Label 21632: @1559087
     /* 1559087 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1559169), // Rule ID 20792 //
     /* 1559092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559131 */     // MIs[0] round
     /* 1559131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559134 */     // MIs[0] policy
     /* 1559134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559168 */     // GIR_Coverage, 20792,
     /* 1559168 */     GIR_EraseRootFromParent_Done,
     /* 1559169 */   // Label 21633: @1559169
     /* 1559169 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1559251), // Rule ID 20793 //
     /* 1559174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559213 */     // MIs[0] round
     /* 1559213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559216 */     // MIs[0] policy
     /* 1559216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559250 */     // GIR_Coverage, 20793,
     /* 1559250 */     GIR_EraseRootFromParent_Done,
     /* 1559251 */   // Label 21634: @1559251
     /* 1559251 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1559333), // Rule ID 20796 //
     /* 1559256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559295 */     // MIs[0] round
     /* 1559295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559298 */     // MIs[0] policy
     /* 1559298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559332 */     // GIR_Coverage, 20796,
     /* 1559332 */     GIR_EraseRootFromParent_Done,
     /* 1559333 */   // Label 21635: @1559333
     /* 1559333 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1559415), // Rule ID 20797 //
     /* 1559338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559377 */     // MIs[0] round
     /* 1559377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559380 */     // MIs[0] policy
     /* 1559380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559414 */     // GIR_Coverage, 20797,
     /* 1559414 */     GIR_EraseRootFromParent_Done,
     /* 1559415 */   // Label 21636: @1559415
     /* 1559415 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1559497), // Rule ID 20800 //
     /* 1559420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559459 */     // MIs[0] round
     /* 1559459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559462 */     // MIs[0] policy
     /* 1559462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559496 */     // GIR_Coverage, 20800,
     /* 1559496 */     GIR_EraseRootFromParent_Done,
     /* 1559497 */   // Label 21637: @1559497
     /* 1559497 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1559579), // Rule ID 20801 //
     /* 1559502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559541 */     // MIs[0] round
     /* 1559541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559544 */     // MIs[0] policy
     /* 1559544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559578 */     // GIR_Coverage, 20801,
     /* 1559578 */     GIR_EraseRootFromParent_Done,
     /* 1559579 */   // Label 21638: @1559579
     /* 1559579 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1559661), // Rule ID 20804 //
     /* 1559584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559623 */     // MIs[0] round
     /* 1559623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559626 */     // MIs[0] policy
     /* 1559626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559660 */     // GIR_Coverage, 20804,
     /* 1559660 */     GIR_EraseRootFromParent_Done,
     /* 1559661 */   // Label 21639: @1559661
     /* 1559661 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1559743), // Rule ID 20805 //
     /* 1559666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559705 */     // MIs[0] round
     /* 1559705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559708 */     // MIs[0] policy
     /* 1559708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559742 */     // GIR_Coverage, 20805,
     /* 1559742 */     GIR_EraseRootFromParent_Done,
     /* 1559743 */   // Label 21640: @1559743
     /* 1559743 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1559825), // Rule ID 20808 //
     /* 1559748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559787 */     // MIs[0] round
     /* 1559787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559790 */     // MIs[0] policy
     /* 1559790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559824 */     // GIR_Coverage, 20808,
     /* 1559824 */     GIR_EraseRootFromParent_Done,
     /* 1559825 */   // Label 21641: @1559825
     /* 1559825 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1559907), // Rule ID 20809 //
     /* 1559830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559869 */     // MIs[0] round
     /* 1559869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559872 */     // MIs[0] policy
     /* 1559872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559906 */     // GIR_Coverage, 20809,
     /* 1559906 */     GIR_EraseRootFromParent_Done,
     /* 1559907 */   // Label 21642: @1559907
     /* 1559907 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1559989), // Rule ID 20812 //
     /* 1559912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559951 */     // MIs[0] round
     /* 1559951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559954 */     // MIs[0] policy
     /* 1559954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559988 */     // GIR_Coverage, 20812,
     /* 1559988 */     GIR_EraseRootFromParent_Done,
     /* 1559989 */   // Label 21643: @1559989
     /* 1559989 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1560071), // Rule ID 20813 //
     /* 1559994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1560002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560033 */     // MIs[0] round
     /* 1560033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560036 */     // MIs[0] policy
     /* 1560036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1560049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560070 */     // GIR_Coverage, 20813,
     /* 1560070 */     GIR_EraseRootFromParent_Done,
     /* 1560071 */   // Label 21644: @1560071
     /* 1560071 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1560153), // Rule ID 20816 //
     /* 1560076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560115 */     // MIs[0] round
     /* 1560115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560118 */     // MIs[0] policy
     /* 1560118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1560131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560152 */     // GIR_Coverage, 20816,
     /* 1560152 */     GIR_EraseRootFromParent_Done,
     /* 1560153 */   // Label 21645: @1560153
     /* 1560153 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1560235), // Rule ID 20817 //
     /* 1560158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1560169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1560172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560197 */     // MIs[0] round
     /* 1560197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560200 */     // MIs[0] policy
     /* 1560200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1560213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560234 */     // GIR_Coverage, 20817,
     /* 1560234 */     GIR_EraseRootFromParent_Done,
     /* 1560235 */   // Label 21646: @1560235
     /* 1560235 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1560317), // Rule ID 20820 //
     /* 1560240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560279 */     // MIs[0] round
     /* 1560279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560282 */     // MIs[0] policy
     /* 1560282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560316 */     // GIR_Coverage, 20820,
     /* 1560316 */     GIR_EraseRootFromParent_Done,
     /* 1560317 */   // Label 21647: @1560317
     /* 1560317 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1560399), // Rule ID 20821 //
     /* 1560322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560361 */     // MIs[0] round
     /* 1560361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560364 */     // MIs[0] policy
     /* 1560364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560398 */     // GIR_Coverage, 20821,
     /* 1560398 */     GIR_EraseRootFromParent_Done,
     /* 1560399 */   // Label 21648: @1560399
     /* 1560399 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1560481), // Rule ID 20824 //
     /* 1560404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560443 */     // MIs[0] round
     /* 1560443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560446 */     // MIs[0] policy
     /* 1560446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560480 */     // GIR_Coverage, 20824,
     /* 1560480 */     GIR_EraseRootFromParent_Done,
     /* 1560481 */   // Label 21649: @1560481
     /* 1560481 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1560563), // Rule ID 20825 //
     /* 1560486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560525 */     // MIs[0] round
     /* 1560525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560528 */     // MIs[0] policy
     /* 1560528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560562 */     // GIR_Coverage, 20825,
     /* 1560562 */     GIR_EraseRootFromParent_Done,
     /* 1560563 */   // Label 21650: @1560563
     /* 1560563 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1560645), // Rule ID 20828 //
     /* 1560568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560607 */     // MIs[0] round
     /* 1560607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560610 */     // MIs[0] policy
     /* 1560610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560644 */     // GIR_Coverage, 20828,
     /* 1560644 */     GIR_EraseRootFromParent_Done,
     /* 1560645 */   // Label 21651: @1560645
     /* 1560645 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1560727), // Rule ID 20829 //
     /* 1560650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560689 */     // MIs[0] round
     /* 1560689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560692 */     // MIs[0] policy
     /* 1560692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560726 */     // GIR_Coverage, 20829,
     /* 1560726 */     GIR_EraseRootFromParent_Done,
     /* 1560727 */   // Label 21652: @1560727
     /* 1560727 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1560809), // Rule ID 20832 //
     /* 1560732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560771 */     // MIs[0] round
     /* 1560771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560774 */     // MIs[0] policy
     /* 1560774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560808 */     // GIR_Coverage, 20832,
     /* 1560808 */     GIR_EraseRootFromParent_Done,
     /* 1560809 */   // Label 21653: @1560809
     /* 1560809 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1560891), // Rule ID 20833 //
     /* 1560814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560853 */     // MIs[0] round
     /* 1560853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560856 */     // MIs[0] policy
     /* 1560856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560890 */     // GIR_Coverage, 20833,
     /* 1560890 */     GIR_EraseRootFromParent_Done,
     /* 1560891 */   // Label 21654: @1560891
     /* 1560891 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1560973), // Rule ID 20836 //
     /* 1560896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560935 */     // MIs[0] round
     /* 1560935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560938 */     // MIs[0] policy
     /* 1560938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560972 */     // GIR_Coverage, 20836,
     /* 1560972 */     GIR_EraseRootFromParent_Done,
     /* 1560973 */   // Label 21655: @1560973
     /* 1560973 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1561055), // Rule ID 20837 //
     /* 1560978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561017 */     // MIs[0] round
     /* 1561017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561020 */     // MIs[0] policy
     /* 1561020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1561033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561054 */     // GIR_Coverage, 20837,
     /* 1561054 */     GIR_EraseRootFromParent_Done,
     /* 1561055 */   // Label 21656: @1561055
     /* 1561055 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1561137), // Rule ID 20840 //
     /* 1561060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1561071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1561074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1561077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561099 */     // MIs[0] round
     /* 1561099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561102 */     // MIs[0] policy
     /* 1561102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561136 */     // GIR_Coverage, 20840,
     /* 1561136 */     GIR_EraseRootFromParent_Done,
     /* 1561137 */   // Label 21657: @1561137
     /* 1561137 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1561219), // Rule ID 20841 //
     /* 1561142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1561153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1561156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1561159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561181 */     // MIs[0] round
     /* 1561181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561184 */     // MIs[0] policy
     /* 1561184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561218 */     // GIR_Coverage, 20841,
     /* 1561218 */     GIR_EraseRootFromParent_Done,
     /* 1561219 */   // Label 21658: @1561219
     /* 1561219 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1561301), // Rule ID 20844 //
     /* 1561224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1561235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1561238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561263 */     // MIs[0] round
     /* 1561263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561266 */     // MIs[0] policy
     /* 1561266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561300 */     // GIR_Coverage, 20844,
     /* 1561300 */     GIR_EraseRootFromParent_Done,
     /* 1561301 */   // Label 21659: @1561301
     /* 1561301 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1561383), // Rule ID 20845 //
     /* 1561306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1561317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1561320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561345 */     // MIs[0] round
     /* 1561345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561348 */     // MIs[0] policy
     /* 1561348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561382 */     // GIR_Coverage, 20845,
     /* 1561382 */     GIR_EraseRootFromParent_Done,
     /* 1561383 */   // Label 21660: @1561383
     /* 1561383 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1561465), // Rule ID 20848 //
     /* 1561388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561427 */     // MIs[0] round
     /* 1561427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561430 */     // MIs[0] policy
     /* 1561430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561464 */     // GIR_Coverage, 20848,
     /* 1561464 */     GIR_EraseRootFromParent_Done,
     /* 1561465 */   // Label 21661: @1561465
     /* 1561465 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1561547), // Rule ID 20849 //
     /* 1561470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561509 */     // MIs[0] round
     /* 1561509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561512 */     // MIs[0] policy
     /* 1561512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561546 */     // GIR_Coverage, 20849,
     /* 1561546 */     GIR_EraseRootFromParent_Done,
     /* 1561547 */   // Label 21662: @1561547
     /* 1561547 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1561629), // Rule ID 20852 //
     /* 1561552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561591 */     // MIs[0] round
     /* 1561591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561594 */     // MIs[0] policy
     /* 1561594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561628 */     // GIR_Coverage, 20852,
     /* 1561628 */     GIR_EraseRootFromParent_Done,
     /* 1561629 */   // Label 21663: @1561629
     /* 1561629 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1561711), // Rule ID 20853 //
     /* 1561634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561673 */     // MIs[0] round
     /* 1561673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561676 */     // MIs[0] policy
     /* 1561676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561710 */     // GIR_Coverage, 20853,
     /* 1561710 */     GIR_EraseRootFromParent_Done,
     /* 1561711 */   // Label 21664: @1561711
     /* 1561711 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1561793), // Rule ID 20856 //
     /* 1561716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561755 */     // MIs[0] round
     /* 1561755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561758 */     // MIs[0] policy
     /* 1561758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561792 */     // GIR_Coverage, 20856,
     /* 1561792 */     GIR_EraseRootFromParent_Done,
     /* 1561793 */   // Label 21665: @1561793
     /* 1561793 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1561875), // Rule ID 20857 //
     /* 1561798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561837 */     // MIs[0] round
     /* 1561837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561840 */     // MIs[0] policy
     /* 1561840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561874 */     // GIR_Coverage, 20857,
     /* 1561874 */     GIR_EraseRootFromParent_Done,
     /* 1561875 */   // Label 21666: @1561875
     /* 1561875 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1561957), // Rule ID 20860 //
     /* 1561880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561919 */     // MIs[0] round
     /* 1561919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561922 */     // MIs[0] policy
     /* 1561922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561956 */     // GIR_Coverage, 20860,
     /* 1561956 */     GIR_EraseRootFromParent_Done,
     /* 1561957 */   // Label 21667: @1561957
     /* 1561957 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1562039), // Rule ID 20861 //
     /* 1561962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562001 */     // MIs[0] round
     /* 1562001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562004 */     // MIs[0] policy
     /* 1562004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562038 */     // GIR_Coverage, 20861,
     /* 1562038 */     GIR_EraseRootFromParent_Done,
     /* 1562039 */   // Label 21668: @1562039
     /* 1562039 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1562121), // Rule ID 20864 //
     /* 1562044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1562061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562083 */     // MIs[0] round
     /* 1562083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562086 */     // MIs[0] policy
     /* 1562086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1562099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562120 */     // GIR_Coverage, 20864,
     /* 1562120 */     GIR_EraseRootFromParent_Done,
     /* 1562121 */   // Label 21669: @1562121
     /* 1562121 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1562203), // Rule ID 20865 //
     /* 1562126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1562143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562165 */     // MIs[0] round
     /* 1562165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562168 */     // MIs[0] policy
     /* 1562168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1562181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562202 */     // GIR_Coverage, 20865,
     /* 1562202 */     GIR_EraseRootFromParent_Done,
     /* 1562203 */   // Label 21670: @1562203
     /* 1562203 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1562285), // Rule ID 20868 //
     /* 1562208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1562219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1562222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1562225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562247 */     // MIs[0] round
     /* 1562247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562250 */     // MIs[0] policy
     /* 1562250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1562263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562284 */     // GIR_Coverage, 20868,
     /* 1562284 */     GIR_EraseRootFromParent_Done,
     /* 1562285 */   // Label 21671: @1562285
     /* 1562285 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1562367), // Rule ID 20869 //
     /* 1562290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1562301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1562304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1562307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562329 */     // MIs[0] round
     /* 1562329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562332 */     // MIs[0] policy
     /* 1562332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1562345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562366 */     // GIR_Coverage, 20869,
     /* 1562366 */     GIR_EraseRootFromParent_Done,
     /* 1562367 */   // Label 21672: @1562367
     /* 1562367 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1562449), // Rule ID 20872 //
     /* 1562372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562411 */     // MIs[0] round
     /* 1562411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562414 */     // MIs[0] policy
     /* 1562414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562448 */     // GIR_Coverage, 20872,
     /* 1562448 */     GIR_EraseRootFromParent_Done,
     /* 1562449 */   // Label 21673: @1562449
     /* 1562449 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1562531), // Rule ID 20873 //
     /* 1562454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1562462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562493 */     // MIs[0] round
     /* 1562493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562496 */     // MIs[0] policy
     /* 1562496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562530 */     // GIR_Coverage, 20873,
     /* 1562530 */     GIR_EraseRootFromParent_Done,
     /* 1562531 */   // Label 21674: @1562531
     /* 1562531 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1562613), // Rule ID 20996 //
     /* 1562536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562575 */     // MIs[0] round
     /* 1562575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562578 */     // MIs[0] policy
     /* 1562578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562612 */     // GIR_Coverage, 20996,
     /* 1562612 */     GIR_EraseRootFromParent_Done,
     /* 1562613 */   // Label 21675: @1562613
     /* 1562613 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1562695), // Rule ID 20997 //
     /* 1562618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562657 */     // MIs[0] round
     /* 1562657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562660 */     // MIs[0] policy
     /* 1562660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562670 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562694 */     // GIR_Coverage, 20997,
     /* 1562694 */     GIR_EraseRootFromParent_Done,
     /* 1562695 */   // Label 21676: @1562695
     /* 1562695 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1562777), // Rule ID 21000 //
     /* 1562700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562739 */     // MIs[0] round
     /* 1562739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562742 */     // MIs[0] policy
     /* 1562742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562776 */     // GIR_Coverage, 21000,
     /* 1562776 */     GIR_EraseRootFromParent_Done,
     /* 1562777 */   // Label 21677: @1562777
     /* 1562777 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1562859), // Rule ID 21001 //
     /* 1562782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562821 */     // MIs[0] round
     /* 1562821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562824 */     // MIs[0] policy
     /* 1562824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562834 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562858 */     // GIR_Coverage, 21001,
     /* 1562858 */     GIR_EraseRootFromParent_Done,
     /* 1562859 */   // Label 21678: @1562859
     /* 1562859 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1562941), // Rule ID 21004 //
     /* 1562864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562903 */     // MIs[0] round
     /* 1562903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562906 */     // MIs[0] policy
     /* 1562906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562940 */     // GIR_Coverage, 21004,
     /* 1562940 */     GIR_EraseRootFromParent_Done,
     /* 1562941 */   // Label 21679: @1562941
     /* 1562941 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1563023), // Rule ID 21005 //
     /* 1562946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562985 */     // MIs[0] round
     /* 1562985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562988 */     // MIs[0] policy
     /* 1562988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1563001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563022 */     // GIR_Coverage, 21005,
     /* 1563022 */     GIR_EraseRootFromParent_Done,
     /* 1563023 */   // Label 21680: @1563023
     /* 1563023 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1563105), // Rule ID 21008 //
     /* 1563028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1563039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1563042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563067 */     // MIs[0] round
     /* 1563067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563070 */     // MIs[0] policy
     /* 1563070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1563083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563104 */     // GIR_Coverage, 21008,
     /* 1563104 */     GIR_EraseRootFromParent_Done,
     /* 1563105 */   // Label 21681: @1563105
     /* 1563105 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1563187), // Rule ID 21009 //
     /* 1563110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1563121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1563124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563149 */     // MIs[0] round
     /* 1563149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563152 */     // MIs[0] policy
     /* 1563152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563162 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1563165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563186 */     // GIR_Coverage, 21009,
     /* 1563186 */     GIR_EraseRootFromParent_Done,
     /* 1563187 */   // Label 21682: @1563187
     /* 1563187 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1563269), // Rule ID 21012 //
     /* 1563192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1563203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1563206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1563209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563231 */     // MIs[0] round
     /* 1563231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563234 */     // MIs[0] policy
     /* 1563234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1563247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563268 */     // GIR_Coverage, 21012,
     /* 1563268 */     GIR_EraseRootFromParent_Done,
     /* 1563269 */   // Label 21683: @1563269
     /* 1563269 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1563351), // Rule ID 21013 //
     /* 1563274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1563285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1563288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1563291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563313 */     // MIs[0] round
     /* 1563313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563316 */     // MIs[0] policy
     /* 1563316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563326 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1563329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563350 */     // GIR_Coverage, 21013,
     /* 1563350 */     GIR_EraseRootFromParent_Done,
     /* 1563351 */   // Label 21684: @1563351
     /* 1563351 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1563433), // Rule ID 21016 //
     /* 1563356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1563359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563395 */     // MIs[0] round
     /* 1563395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563398 */     // MIs[0] policy
     /* 1563398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563432 */     // GIR_Coverage, 21016,
     /* 1563432 */     GIR_EraseRootFromParent_Done,
     /* 1563433 */   // Label 21685: @1563433
     /* 1563433 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1563515), // Rule ID 21017 //
     /* 1563438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563477 */     // MIs[0] round
     /* 1563477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563480 */     // MIs[0] policy
     /* 1563480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563514 */     // GIR_Coverage, 21017,
     /* 1563514 */     GIR_EraseRootFromParent_Done,
     /* 1563515 */   // Label 21686: @1563515
     /* 1563515 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1563597), // Rule ID 21020 //
     /* 1563520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563559 */     // MIs[0] round
     /* 1563559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563562 */     // MIs[0] policy
     /* 1563562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563596 */     // GIR_Coverage, 21020,
     /* 1563596 */     GIR_EraseRootFromParent_Done,
     /* 1563597 */   // Label 21687: @1563597
     /* 1563597 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1563679), // Rule ID 21021 //
     /* 1563602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563641 */     // MIs[0] round
     /* 1563641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563644 */     // MIs[0] policy
     /* 1563644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563678 */     // GIR_Coverage, 21021,
     /* 1563678 */     GIR_EraseRootFromParent_Done,
     /* 1563679 */   // Label 21688: @1563679
     /* 1563679 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1563761), // Rule ID 21024 //
     /* 1563684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563723 */     // MIs[0] round
     /* 1563723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563726 */     // MIs[0] policy
     /* 1563726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563760 */     // GIR_Coverage, 21024,
     /* 1563760 */     GIR_EraseRootFromParent_Done,
     /* 1563761 */   // Label 21689: @1563761
     /* 1563761 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1563843), // Rule ID 21025 //
     /* 1563766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563805 */     // MIs[0] round
     /* 1563805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563808 */     // MIs[0] policy
     /* 1563808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563818 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563842 */     // GIR_Coverage, 21025,
     /* 1563842 */     GIR_EraseRootFromParent_Done,
     /* 1563843 */   // Label 21690: @1563843
     /* 1563843 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1563925), // Rule ID 21028 //
     /* 1563848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563887 */     // MIs[0] round
     /* 1563887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563890 */     // MIs[0] policy
     /* 1563890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563900 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563924 */     // GIR_Coverage, 21028,
     /* 1563924 */     GIR_EraseRootFromParent_Done,
     /* 1563925 */   // Label 21691: @1563925
     /* 1563925 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1564007), // Rule ID 21029 //
     /* 1563930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563969 */     // MIs[0] round
     /* 1563969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563972 */     // MIs[0] policy
     /* 1563972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564006 */     // GIR_Coverage, 21029,
     /* 1564006 */     GIR_EraseRootFromParent_Done,
     /* 1564007 */   // Label 21692: @1564007
     /* 1564007 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1564089), // Rule ID 21032 //
     /* 1564012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1564023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1564026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564051 */     // MIs[0] round
     /* 1564051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564054 */     // MIs[0] policy
     /* 1564054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1564067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564088 */     // GIR_Coverage, 21032,
     /* 1564088 */     GIR_EraseRootFromParent_Done,
     /* 1564089 */   // Label 21693: @1564089
     /* 1564089 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1564171), // Rule ID 21033 //
     /* 1564094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1564105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1564108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564133 */     // MIs[0] round
     /* 1564133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564136 */     // MIs[0] policy
     /* 1564136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1564149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564170 */     // GIR_Coverage, 21033,
     /* 1564170 */     GIR_EraseRootFromParent_Done,
     /* 1564171 */   // Label 21694: @1564171
     /* 1564171 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1564253), // Rule ID 21036 //
     /* 1564176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1564187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1564190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564215 */     // MIs[0] round
     /* 1564215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564218 */     // MIs[0] policy
     /* 1564218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564228 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1564231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564252 */     // GIR_Coverage, 21036,
     /* 1564252 */     GIR_EraseRootFromParent_Done,
     /* 1564253 */   // Label 21695: @1564253
     /* 1564253 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1564335), // Rule ID 21037 //
     /* 1564258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1564269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1564272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564297 */     // MIs[0] round
     /* 1564297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564300 */     // MIs[0] policy
     /* 1564300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564310 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1564313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564334 */     // GIR_Coverage, 21037,
     /* 1564334 */     GIR_EraseRootFromParent_Done,
     /* 1564335 */   // Label 21696: @1564335
     /* 1564335 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1564417), // Rule ID 21040 //
     /* 1564340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564379 */     // MIs[0] round
     /* 1564379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564382 */     // MIs[0] policy
     /* 1564382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564416 */     // GIR_Coverage, 21040,
     /* 1564416 */     GIR_EraseRootFromParent_Done,
     /* 1564417 */   // Label 21697: @1564417
     /* 1564417 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1564499), // Rule ID 21041 //
     /* 1564422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564461 */     // MIs[0] round
     /* 1564461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564464 */     // MIs[0] policy
     /* 1564464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564474 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564498 */     // GIR_Coverage, 21041,
     /* 1564498 */     GIR_EraseRootFromParent_Done,
     /* 1564499 */   // Label 21698: @1564499
     /* 1564499 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1564581), // Rule ID 21044 //
     /* 1564504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564543 */     // MIs[0] round
     /* 1564543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564546 */     // MIs[0] policy
     /* 1564546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564580 */     // GIR_Coverage, 21044,
     /* 1564580 */     GIR_EraseRootFromParent_Done,
     /* 1564581 */   // Label 21699: @1564581
     /* 1564581 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1564663), // Rule ID 21045 //
     /* 1564586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564625 */     // MIs[0] round
     /* 1564625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564628 */     // MIs[0] policy
     /* 1564628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564662 */     // GIR_Coverage, 21045,
     /* 1564662 */     GIR_EraseRootFromParent_Done,
     /* 1564663 */   // Label 21700: @1564663
     /* 1564663 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1564745), // Rule ID 21048 //
     /* 1564668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564707 */     // MIs[0] round
     /* 1564707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564710 */     // MIs[0] policy
     /* 1564710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564744 */     // GIR_Coverage, 21048,
     /* 1564744 */     GIR_EraseRootFromParent_Done,
     /* 1564745 */   // Label 21701: @1564745
     /* 1564745 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1564827), // Rule ID 21049 //
     /* 1564750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564789 */     // MIs[0] round
     /* 1564789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564792 */     // MIs[0] policy
     /* 1564792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564802 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564826 */     // GIR_Coverage, 21049,
     /* 1564826 */     GIR_EraseRootFromParent_Done,
     /* 1564827 */   // Label 21702: @1564827
     /* 1564827 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1564909), // Rule ID 21052 //
     /* 1564832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564871 */     // MIs[0] round
     /* 1564871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564874 */     // MIs[0] policy
     /* 1564874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564908 */     // GIR_Coverage, 21052,
     /* 1564908 */     GIR_EraseRootFromParent_Done,
     /* 1564909 */   // Label 21703: @1564909
     /* 1564909 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1564991), // Rule ID 21053 //
     /* 1564914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564953 */     // MIs[0] round
     /* 1564953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564956 */     // MIs[0] policy
     /* 1564956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564990 */     // GIR_Coverage, 21053,
     /* 1564990 */     GIR_EraseRootFromParent_Done,
     /* 1564991 */   // Label 21704: @1564991
     /* 1564991 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1565073), // Rule ID 21056 //
     /* 1564996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1565007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1565010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565035 */     // MIs[0] round
     /* 1565035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565038 */     // MIs[0] policy
     /* 1565038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1565051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565072 */     // GIR_Coverage, 21056,
     /* 1565072 */     GIR_EraseRootFromParent_Done,
     /* 1565073 */   // Label 21705: @1565073
     /* 1565073 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1565155), // Rule ID 21057 //
     /* 1565078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1565089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1565092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565117 */     // MIs[0] round
     /* 1565117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565120 */     // MIs[0] policy
     /* 1565120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565130 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1565133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565154 */     // GIR_Coverage, 21057,
     /* 1565154 */     GIR_EraseRootFromParent_Done,
     /* 1565155 */   // Label 21706: @1565155
     /* 1565155 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1565237), // Rule ID 21060 //
     /* 1565160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1565171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1565174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565199 */     // MIs[0] round
     /* 1565199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565202 */     // MIs[0] policy
     /* 1565202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1565215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565236 */     // GIR_Coverage, 21060,
     /* 1565236 */     GIR_EraseRootFromParent_Done,
     /* 1565237 */   // Label 21707: @1565237
     /* 1565237 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1565319), // Rule ID 21061 //
     /* 1565242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1565253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1565256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565281 */     // MIs[0] round
     /* 1565281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565284 */     // MIs[0] policy
     /* 1565284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565294 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1565297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565318 */     // GIR_Coverage, 21061,
     /* 1565318 */     GIR_EraseRootFromParent_Done,
     /* 1565319 */   // Label 21708: @1565319
     /* 1565319 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1565401), // Rule ID 21064 //
     /* 1565324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565363 */     // MIs[0] round
     /* 1565363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565366 */     // MIs[0] policy
     /* 1565366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1565379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565400 */     // GIR_Coverage, 21064,
     /* 1565400 */     GIR_EraseRootFromParent_Done,
     /* 1565401 */   // Label 21709: @1565401
     /* 1565401 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1565483), // Rule ID 21065 //
     /* 1565406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565445 */     // MIs[0] round
     /* 1565445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565448 */     // MIs[0] policy
     /* 1565448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565458 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1565461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565482 */     // GIR_Coverage, 21065,
     /* 1565482 */     GIR_EraseRootFromParent_Done,
     /* 1565483 */   // Label 21710: @1565483
     /* 1565483 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1565565), // Rule ID 21068 //
     /* 1565488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565527 */     // MIs[0] round
     /* 1565527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565530 */     // MIs[0] policy
     /* 1565530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565564 */     // GIR_Coverage, 21068,
     /* 1565564 */     GIR_EraseRootFromParent_Done,
     /* 1565565 */   // Label 21711: @1565565
     /* 1565565 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1565647), // Rule ID 21069 //
     /* 1565570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565609 */     // MIs[0] round
     /* 1565609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565612 */     // MIs[0] policy
     /* 1565612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565646 */     // GIR_Coverage, 21069,
     /* 1565646 */     GIR_EraseRootFromParent_Done,
     /* 1565647 */   // Label 21712: @1565647
     /* 1565647 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1565729), // Rule ID 21072 //
     /* 1565652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565691 */     // MIs[0] round
     /* 1565691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565694 */     // MIs[0] policy
     /* 1565694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565728 */     // GIR_Coverage, 21072,
     /* 1565728 */     GIR_EraseRootFromParent_Done,
     /* 1565729 */   // Label 21713: @1565729
     /* 1565729 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1565811), // Rule ID 21073 //
     /* 1565734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565773 */     // MIs[0] round
     /* 1565773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565776 */     // MIs[0] policy
     /* 1565776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565786 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565810 */     // GIR_Coverage, 21073,
     /* 1565810 */     GIR_EraseRootFromParent_Done,
     /* 1565811 */   // Label 21714: @1565811
     /* 1565811 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1565893), // Rule ID 21076 //
     /* 1565816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565855 */     // MIs[0] round
     /* 1565855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565858 */     // MIs[0] policy
     /* 1565858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565892 */     // GIR_Coverage, 21076,
     /* 1565892 */     GIR_EraseRootFromParent_Done,
     /* 1565893 */   // Label 21715: @1565893
     /* 1565893 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1565975), // Rule ID 21077 //
     /* 1565898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565937 */     // MIs[0] round
     /* 1565937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565940 */     // MIs[0] policy
     /* 1565940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565950 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565974 */     // GIR_Coverage, 21077,
     /* 1565974 */     GIR_EraseRootFromParent_Done,
     /* 1565975 */   // Label 21716: @1565975
     /* 1565975 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1566057), // Rule ID 21080 //
     /* 1565980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1565994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566019 */     // MIs[0] round
     /* 1566019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566022 */     // MIs[0] policy
     /* 1566022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1566035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566056 */     // GIR_Coverage, 21080,
     /* 1566056 */     GIR_EraseRootFromParent_Done,
     /* 1566057 */   // Label 21717: @1566057
     /* 1566057 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1566139), // Rule ID 21081 //
     /* 1566062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1566073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1566076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566101 */     // MIs[0] round
     /* 1566101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566104 */     // MIs[0] policy
     /* 1566104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1566117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566138 */     // GIR_Coverage, 21081,
     /* 1566138 */     GIR_EraseRootFromParent_Done,
     /* 1566139 */   // Label 21718: @1566139
     /* 1566139 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1566221), // Rule ID 21084 //
     /* 1566144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566183 */     // MIs[0] round
     /* 1566183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566186 */     // MIs[0] policy
     /* 1566186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1566199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566220 */     // GIR_Coverage, 21084,
     /* 1566220 */     GIR_EraseRootFromParent_Done,
     /* 1566221 */   // Label 21719: @1566221
     /* 1566221 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1566303), // Rule ID 21085 //
     /* 1566226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1566237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1566240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566265 */     // MIs[0] round
     /* 1566265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566268 */     // MIs[0] policy
     /* 1566268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566278 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1566281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566302 */     // GIR_Coverage, 21085,
     /* 1566302 */     GIR_EraseRootFromParent_Done,
     /* 1566303 */   // Label 21720: @1566303
     /* 1566303 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1566385), // Rule ID 21088 //
     /* 1566308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566347 */     // MIs[0] round
     /* 1566347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566350 */     // MIs[0] policy
     /* 1566350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566360 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1566363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566384 */     // GIR_Coverage, 21088,
     /* 1566384 */     GIR_EraseRootFromParent_Done,
     /* 1566385 */   // Label 21721: @1566385
     /* 1566385 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1566467), // Rule ID 21089 //
     /* 1566390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1566401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1566404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566429 */     // MIs[0] round
     /* 1566429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566432 */     // MIs[0] policy
     /* 1566432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566442 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1566445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566466 */     // GIR_Coverage, 21089,
     /* 1566466 */     GIR_EraseRootFromParent_Done,
     /* 1566467 */   // Label 21722: @1566467
     /* 1566467 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1566549), // Rule ID 21092 //
     /* 1566472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566511 */     // MIs[0] round
     /* 1566511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566514 */     // MIs[0] policy
     /* 1566514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566548 */     // GIR_Coverage, 21092,
     /* 1566548 */     GIR_EraseRootFromParent_Done,
     /* 1566549 */   // Label 21723: @1566549
     /* 1566549 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1566631), // Rule ID 21093 //
     /* 1566554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566593 */     // MIs[0] round
     /* 1566593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566596 */     // MIs[0] policy
     /* 1566596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566630 */     // GIR_Coverage, 21093,
     /* 1566630 */     GIR_EraseRootFromParent_Done,
     /* 1566631 */   // Label 21724: @1566631
     /* 1566631 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1566713), // Rule ID 21096 //
     /* 1566636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566675 */     // MIs[0] round
     /* 1566675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566678 */     // MIs[0] policy
     /* 1566678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566712 */     // GIR_Coverage, 21096,
     /* 1566712 */     GIR_EraseRootFromParent_Done,
     /* 1566713 */   // Label 21725: @1566713
     /* 1566713 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1566795), // Rule ID 21097 //
     /* 1566718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566757 */     // MIs[0] round
     /* 1566757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566760 */     // MIs[0] policy
     /* 1566760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566794 */     // GIR_Coverage, 21097,
     /* 1566794 */     GIR_EraseRootFromParent_Done,
     /* 1566795 */   // Label 21726: @1566795
     /* 1566795 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1566877), // Rule ID 21100 //
     /* 1566800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566839 */     // MIs[0] round
     /* 1566839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566842 */     // MIs[0] policy
     /* 1566842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566876 */     // GIR_Coverage, 21100,
     /* 1566876 */     GIR_EraseRootFromParent_Done,
     /* 1566877 */   // Label 21727: @1566877
     /* 1566877 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1566959), // Rule ID 21101 //
     /* 1566882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566921 */     // MIs[0] round
     /* 1566921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566924 */     // MIs[0] policy
     /* 1566924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566958 */     // GIR_Coverage, 21101,
     /* 1566958 */     GIR_EraseRootFromParent_Done,
     /* 1566959 */   // Label 21728: @1566959
     /* 1566959 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1567041), // Rule ID 21104 //
     /* 1566964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567003 */     // MIs[0] round
     /* 1567003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567006 */     // MIs[0] policy
     /* 1567006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1567019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567040 */     // GIR_Coverage, 21104,
     /* 1567040 */     GIR_EraseRootFromParent_Done,
     /* 1567041 */   // Label 21729: @1567041
     /* 1567041 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1567123), // Rule ID 21105 //
     /* 1567046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567085 */     // MIs[0] round
     /* 1567085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567088 */     // MIs[0] policy
     /* 1567088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1567101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567122 */     // GIR_Coverage, 21105,
     /* 1567122 */     GIR_EraseRootFromParent_Done,
     /* 1567123 */   // Label 21730: @1567123
     /* 1567123 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1567205), // Rule ID 21108 //
     /* 1567128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1567131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567167 */     // MIs[0] round
     /* 1567167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567170 */     // MIs[0] policy
     /* 1567170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1567183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567204 */     // GIR_Coverage, 21108,
     /* 1567204 */     GIR_EraseRootFromParent_Done,
     /* 1567205 */   // Label 21731: @1567205
     /* 1567205 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1567287), // Rule ID 21109 //
     /* 1567210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567249 */     // MIs[0] round
     /* 1567249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567252 */     // MIs[0] policy
     /* 1567252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1567265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567286 */     // GIR_Coverage, 21109,
     /* 1567286 */     GIR_EraseRootFromParent_Done,
     /* 1567287 */   // Label 21732: @1567287
     /* 1567287 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1567369), // Rule ID 21112 //
     /* 1567292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1567295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567331 */     // MIs[0] round
     /* 1567331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567334 */     // MIs[0] policy
     /* 1567334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1567347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567368 */     // GIR_Coverage, 21112,
     /* 1567368 */     GIR_EraseRootFromParent_Done,
     /* 1567369 */   // Label 21733: @1567369
     /* 1567369 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1567451), // Rule ID 21113 //
     /* 1567374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1567377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1567382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1567391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567413 */     // MIs[0] round
     /* 1567413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567416 */     // MIs[0] policy
     /* 1567416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1567429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1567447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567450 */     // GIR_Coverage, 21113,
     /* 1567450 */     GIR_EraseRootFromParent_Done,
     /* 1567451 */   // Label 21734: @1567451
     /* 1567451 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1567533), // Rule ID 21188 //
     /* 1567456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567495 */     // MIs[0] round
     /* 1567495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567498 */     // MIs[0] policy
     /* 1567498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567532 */     // GIR_Coverage, 21188,
     /* 1567532 */     GIR_EraseRootFromParent_Done,
     /* 1567533 */   // Label 21735: @1567533
     /* 1567533 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1567615), // Rule ID 21189 //
     /* 1567538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567577 */     // MIs[0] round
     /* 1567577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567580 */     // MIs[0] policy
     /* 1567580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567614 */     // GIR_Coverage, 21189,
     /* 1567614 */     GIR_EraseRootFromParent_Done,
     /* 1567615 */   // Label 21736: @1567615
     /* 1567615 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1567697), // Rule ID 21192 //
     /* 1567620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567659 */     // MIs[0] round
     /* 1567659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567662 */     // MIs[0] policy
     /* 1567662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567696 */     // GIR_Coverage, 21192,
     /* 1567696 */     GIR_EraseRootFromParent_Done,
     /* 1567697 */   // Label 21737: @1567697
     /* 1567697 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1567779), // Rule ID 21193 //
     /* 1567702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567741 */     // MIs[0] round
     /* 1567741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567744 */     // MIs[0] policy
     /* 1567744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567754 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567778 */     // GIR_Coverage, 21193,
     /* 1567778 */     GIR_EraseRootFromParent_Done,
     /* 1567779 */   // Label 21738: @1567779
     /* 1567779 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1567861), // Rule ID 21196 //
     /* 1567784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567823 */     // MIs[0] round
     /* 1567823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567826 */     // MIs[0] policy
     /* 1567826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567860 */     // GIR_Coverage, 21196,
     /* 1567860 */     GIR_EraseRootFromParent_Done,
     /* 1567861 */   // Label 21739: @1567861
     /* 1567861 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1567943), // Rule ID 21197 //
     /* 1567866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567905 */     // MIs[0] round
     /* 1567905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567908 */     // MIs[0] policy
     /* 1567908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567942 */     // GIR_Coverage, 21197,
     /* 1567942 */     GIR_EraseRootFromParent_Done,
     /* 1567943 */   // Label 21740: @1567943
     /* 1567943 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1568025), // Rule ID 21200 //
     /* 1567948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567987 */     // MIs[0] round
     /* 1567987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567990 */     // MIs[0] policy
     /* 1567990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568024 */     // GIR_Coverage, 21200,
     /* 1568024 */     GIR_EraseRootFromParent_Done,
     /* 1568025 */   // Label 21741: @1568025
     /* 1568025 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1568107), // Rule ID 21201 //
     /* 1568030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568069 */     // MIs[0] round
     /* 1568069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568072 */     // MIs[0] policy
     /* 1568072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568106 */     // GIR_Coverage, 21201,
     /* 1568106 */     GIR_EraseRootFromParent_Done,
     /* 1568107 */   // Label 21742: @1568107
     /* 1568107 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1568189), // Rule ID 21204 //
     /* 1568112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1568123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1568126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568151 */     // MIs[0] round
     /* 1568151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568154 */     // MIs[0] policy
     /* 1568154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568188 */     // GIR_Coverage, 21204,
     /* 1568188 */     GIR_EraseRootFromParent_Done,
     /* 1568189 */   // Label 21743: @1568189
     /* 1568189 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1568271), // Rule ID 21205 //
     /* 1568194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1568205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1568208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568233 */     // MIs[0] round
     /* 1568233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568236 */     // MIs[0] policy
     /* 1568236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568270 */     // GIR_Coverage, 21205,
     /* 1568270 */     GIR_EraseRootFromParent_Done,
     /* 1568271 */   // Label 21744: @1568271
     /* 1568271 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1568353), // Rule ID 21208 //
     /* 1568276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1568287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1568290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568315 */     // MIs[0] round
     /* 1568315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568318 */     // MIs[0] policy
     /* 1568318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1568331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568352 */     // GIR_Coverage, 21208,
     /* 1568352 */     GIR_EraseRootFromParent_Done,
     /* 1568353 */   // Label 21745: @1568353
     /* 1568353 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1568435), // Rule ID 21209 //
     /* 1568358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1568369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1568372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568397 */     // MIs[0] round
     /* 1568397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568400 */     // MIs[0] policy
     /* 1568400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1568413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568434 */     // GIR_Coverage, 21209,
     /* 1568434 */     GIR_EraseRootFromParent_Done,
     /* 1568435 */   // Label 21746: @1568435
     /* 1568435 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1568517), // Rule ID 21212 //
     /* 1568440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568479 */     // MIs[0] round
     /* 1568479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568482 */     // MIs[0] policy
     /* 1568482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568516 */     // GIR_Coverage, 21212,
     /* 1568516 */     GIR_EraseRootFromParent_Done,
     /* 1568517 */   // Label 21747: @1568517
     /* 1568517 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1568599), // Rule ID 21213 //
     /* 1568522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568561 */     // MIs[0] round
     /* 1568561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568564 */     // MIs[0] policy
     /* 1568564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11352:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568598 */     // GIR_Coverage, 21213,
     /* 1568598 */     GIR_EraseRootFromParent_Done,
     /* 1568599 */   // Label 21748: @1568599
     /* 1568599 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1568681), // Rule ID 21216 //
     /* 1568604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568643 */     // MIs[0] round
     /* 1568643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568646 */     // MIs[0] policy
     /* 1568646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568680 */     // GIR_Coverage, 21216,
     /* 1568680 */     GIR_EraseRootFromParent_Done,
     /* 1568681 */   // Label 21749: @1568681
     /* 1568681 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1568763), // Rule ID 21217 //
     /* 1568686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568725 */     // MIs[0] round
     /* 1568725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568728 */     // MIs[0] policy
     /* 1568728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568738 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11352:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568762 */     // GIR_Coverage, 21217,
     /* 1568762 */     GIR_EraseRootFromParent_Done,
     /* 1568763 */   // Label 21750: @1568763
     /* 1568763 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1568845), // Rule ID 21220 //
     /* 1568768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568807 */     // MIs[0] round
     /* 1568807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568810 */     // MIs[0] policy
     /* 1568810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568844 */     // GIR_Coverage, 21220,
     /* 1568844 */     GIR_EraseRootFromParent_Done,
     /* 1568845 */   // Label 21751: @1568845
     /* 1568845 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1568927), // Rule ID 21221 //
     /* 1568850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568889 */     // MIs[0] round
     /* 1568889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568892 */     // MIs[0] policy
     /* 1568892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11352:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568926 */     // GIR_Coverage, 21221,
     /* 1568926 */     GIR_EraseRootFromParent_Done,
     /* 1568927 */   // Label 21752: @1568927
     /* 1568927 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1569009), // Rule ID 21224 //
     /* 1568932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568971 */     // MIs[0] round
     /* 1568971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568974 */     // MIs[0] policy
     /* 1568974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569008 */     // GIR_Coverage, 21224,
     /* 1569008 */     GIR_EraseRootFromParent_Done,
     /* 1569009 */   // Label 21753: @1569009
     /* 1569009 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1569091), // Rule ID 21225 //
     /* 1569014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1569031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569053 */     // MIs[0] round
     /* 1569053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569056 */     // MIs[0] policy
     /* 1569056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1569069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569090 */     // GIR_Coverage, 21225,
     /* 1569090 */     GIR_EraseRootFromParent_Done,
     /* 1569091 */   // Label 21754: @1569091
     /* 1569091 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1569173), // Rule ID 21228 //
     /* 1569096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1569113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569135 */     // MIs[0] round
     /* 1569135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569138 */     // MIs[0] policy
     /* 1569138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569172 */     // GIR_Coverage, 21228,
     /* 1569172 */     GIR_EraseRootFromParent_Done,
     /* 1569173 */   // Label 21755: @1569173
     /* 1569173 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1569255), // Rule ID 21229 //
     /* 1569178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1569195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569217 */     // MIs[0] round
     /* 1569217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569220 */     // MIs[0] policy
     /* 1569220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569254 */     // GIR_Coverage, 21229,
     /* 1569254 */     GIR_EraseRootFromParent_Done,
     /* 1569255 */   // Label 21756: @1569255
     /* 1569255 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1569337), // Rule ID 21232 //
     /* 1569260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569299 */     // MIs[0] round
     /* 1569299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569302 */     // MIs[0] policy
     /* 1569302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569336 */     // GIR_Coverage, 21232,
     /* 1569336 */     GIR_EraseRootFromParent_Done,
     /* 1569337 */   // Label 21757: @1569337
     /* 1569337 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1569419), // Rule ID 21233 //
     /* 1569342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1569359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569381 */     // MIs[0] round
     /* 1569381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569384 */     // MIs[0] policy
     /* 1569384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569418 */     // GIR_Coverage, 21233,
     /* 1569418 */     GIR_EraseRootFromParent_Done,
     /* 1569419 */   // Label 21758: @1569419
     /* 1569419 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1569501), // Rule ID 21236 //
     /* 1569424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569463 */     // MIs[0] round
     /* 1569463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569466 */     // MIs[0] policy
     /* 1569466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569476 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569500 */     // GIR_Coverage, 21236,
     /* 1569500 */     GIR_EraseRootFromParent_Done,
     /* 1569501 */   // Label 21759: @1569501
     /* 1569501 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1569583), // Rule ID 21237 //
     /* 1569506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569545 */     // MIs[0] round
     /* 1569545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569548 */     // MIs[0] policy
     /* 1569548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569582 */     // GIR_Coverage, 21237,
     /* 1569582 */     GIR_EraseRootFromParent_Done,
     /* 1569583 */   // Label 21760: @1569583
     /* 1569583 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1569665), // Rule ID 21240 //
     /* 1569588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569627 */     // MIs[0] round
     /* 1569627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569630 */     // MIs[0] policy
     /* 1569630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569664 */     // GIR_Coverage, 21240,
     /* 1569664 */     GIR_EraseRootFromParent_Done,
     /* 1569665 */   // Label 21761: @1569665
     /* 1569665 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1569747), // Rule ID 21241 //
     /* 1569670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569709 */     // MIs[0] round
     /* 1569709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569712 */     // MIs[0] policy
     /* 1569712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569746 */     // GIR_Coverage, 21241,
     /* 1569746 */     GIR_EraseRootFromParent_Done,
     /* 1569747 */   // Label 21762: @1569747
     /* 1569747 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1569829), // Rule ID 21244 //
     /* 1569752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569791 */     // MIs[0] round
     /* 1569791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569794 */     // MIs[0] policy
     /* 1569794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569804 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569828 */     // GIR_Coverage, 21244,
     /* 1569828 */     GIR_EraseRootFromParent_Done,
     /* 1569829 */   // Label 21763: @1569829
     /* 1569829 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1569911), // Rule ID 21245 //
     /* 1569834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569873 */     // MIs[0] round
     /* 1569873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569876 */     // MIs[0] policy
     /* 1569876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569910 */     // GIR_Coverage, 21245,
     /* 1569910 */     GIR_EraseRootFromParent_Done,
     /* 1569911 */   // Label 21764: @1569911
     /* 1569911 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1569993), // Rule ID 21248 //
     /* 1569916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569955 */     // MIs[0] round
     /* 1569955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569958 */     // MIs[0] policy
     /* 1569958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569992 */     // GIR_Coverage, 21248,
     /* 1569992 */     GIR_EraseRootFromParent_Done,
     /* 1569993 */   // Label 21765: @1569993
     /* 1569993 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1570075), // Rule ID 21249 //
     /* 1569998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1570009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1570012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1570015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570037 */     // MIs[0] round
     /* 1570037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570040 */     // MIs[0] policy
     /* 1570040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1570053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570074 */     // GIR_Coverage, 21249,
     /* 1570074 */     GIR_EraseRootFromParent_Done,
     /* 1570075 */   // Label 21766: @1570075
     /* 1570075 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1570157), // Rule ID 21252 //
     /* 1570080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570119 */     // MIs[0] round
     /* 1570119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570122 */     // MIs[0] policy
     /* 1570122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1570135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570156 */     // GIR_Coverage, 21252,
     /* 1570156 */     GIR_EraseRootFromParent_Done,
     /* 1570157 */   // Label 21767: @1570157
     /* 1570157 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1570239), // Rule ID 21253 //
     /* 1570162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1570173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1570176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570201 */     // MIs[0] round
     /* 1570201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570204 */     // MIs[0] policy
     /* 1570204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1570217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570238 */     // GIR_Coverage, 21253,
     /* 1570238 */     GIR_EraseRootFromParent_Done,
     /* 1570239 */   // Label 21768: @1570239
     /* 1570239 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1570321), // Rule ID 21256 //
     /* 1570244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570283 */     // MIs[0] round
     /* 1570283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570286 */     // MIs[0] policy
     /* 1570286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1570299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570320 */     // GIR_Coverage, 21256,
     /* 1570320 */     GIR_EraseRootFromParent_Done,
     /* 1570321 */   // Label 21769: @1570321
     /* 1570321 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1570403), // Rule ID 21257 //
     /* 1570326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1570334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1570337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1570340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1570353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570365 */     // MIs[0] round
     /* 1570365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570368 */     // MIs[0] policy
     /* 1570368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570378 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1570381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570402 */     // GIR_Coverage, 21257,
     /* 1570402 */     GIR_EraseRootFromParent_Done,
     /* 1570403 */   // Label 21770: @1570403
     /* 1570403 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1570485), // Rule ID 21608 //
     /* 1570408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570447 */     // MIs[0] round
     /* 1570447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570450 */     // MIs[0] policy
     /* 1570450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570484 */     // GIR_Coverage, 21608,
     /* 1570484 */     GIR_EraseRootFromParent_Done,
     /* 1570485 */   // Label 21771: @1570485
     /* 1570485 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1570567), // Rule ID 21609 //
     /* 1570490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570529 */     // MIs[0] round
     /* 1570529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570532 */     // MIs[0] policy
     /* 1570532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570542 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570566 */     // GIR_Coverage, 21609,
     /* 1570566 */     GIR_EraseRootFromParent_Done,
     /* 1570567 */   // Label 21772: @1570567
     /* 1570567 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1570649), // Rule ID 21612 //
     /* 1570572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570611 */     // MIs[0] round
     /* 1570611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570614 */     // MIs[0] policy
     /* 1570614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570648 */     // GIR_Coverage, 21612,
     /* 1570648 */     GIR_EraseRootFromParent_Done,
     /* 1570649 */   // Label 21773: @1570649
     /* 1570649 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1570731), // Rule ID 21613 //
     /* 1570654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570693 */     // MIs[0] round
     /* 1570693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570696 */     // MIs[0] policy
     /* 1570696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570706 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570730 */     // GIR_Coverage, 21613,
     /* 1570730 */     GIR_EraseRootFromParent_Done,
     /* 1570731 */   // Label 21774: @1570731
     /* 1570731 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1570813), // Rule ID 21616 //
     /* 1570736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570775 */     // MIs[0] round
     /* 1570775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570778 */     // MIs[0] policy
     /* 1570778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570788 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570812 */     // GIR_Coverage, 21616,
     /* 1570812 */     GIR_EraseRootFromParent_Done,
     /* 1570813 */   // Label 21775: @1570813
     /* 1570813 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1570895), // Rule ID 21617 //
     /* 1570818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570857 */     // MIs[0] round
     /* 1570857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570860 */     // MIs[0] policy
     /* 1570860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570894 */     // GIR_Coverage, 21617,
     /* 1570894 */     GIR_EraseRootFromParent_Done,
     /* 1570895 */   // Label 21776: @1570895
     /* 1570895 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1570977), // Rule ID 21620 //
     /* 1570900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570939 */     // MIs[0] round
     /* 1570939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570942 */     // MIs[0] policy
     /* 1570942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570976 */     // GIR_Coverage, 21620,
     /* 1570976 */     GIR_EraseRootFromParent_Done,
     /* 1570977 */   // Label 21777: @1570977
     /* 1570977 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1571059), // Rule ID 21621 //
     /* 1570982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571021 */     // MIs[0] round
     /* 1571021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571024 */     // MIs[0] policy
     /* 1571024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11294:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571058 */     // GIR_Coverage, 21621,
     /* 1571058 */     GIR_EraseRootFromParent_Done,
     /* 1571059 */   // Label 21778: @1571059
     /* 1571059 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1571141), // Rule ID 21624 //
     /* 1571064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1571075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1571078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571103 */     // MIs[0] round
     /* 1571103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571106 */     // MIs[0] policy
     /* 1571106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571140 */     // GIR_Coverage, 21624,
     /* 1571140 */     GIR_EraseRootFromParent_Done,
     /* 1571141 */   // Label 21779: @1571141
     /* 1571141 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1571223), // Rule ID 21625 //
     /* 1571146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1571157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1571160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1571163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571185 */     // MIs[0] round
     /* 1571185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571188 */     // MIs[0] policy
     /* 1571188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571222 */     // GIR_Coverage, 21625,
     /* 1571222 */     GIR_EraseRootFromParent_Done,
     /* 1571223 */   // Label 21780: @1571223
     /* 1571223 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1571305), // Rule ID 21628 //
     /* 1571228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1571231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1571239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571267 */     // MIs[0] round
     /* 1571267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571270 */     // MIs[0] policy
     /* 1571270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571280 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571304 */     // GIR_Coverage, 21628,
     /* 1571304 */     GIR_EraseRootFromParent_Done,
     /* 1571305 */   // Label 21781: @1571305
     /* 1571305 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1571387), // Rule ID 21629 //
     /* 1571310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1571321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571349 */     // MIs[0] round
     /* 1571349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571352 */     // MIs[0] policy
     /* 1571352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571362 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571386 */     // GIR_Coverage, 21629,
     /* 1571386 */     GIR_EraseRootFromParent_Done,
     /* 1571387 */   // Label 21782: @1571387
     /* 1571387 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1571469), // Rule ID 21632 //
     /* 1571392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571431 */     // MIs[0] round
     /* 1571431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571434 */     // MIs[0] policy
     /* 1571434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571468 */     // GIR_Coverage, 21632,
     /* 1571468 */     GIR_EraseRootFromParent_Done,
     /* 1571469 */   // Label 21783: @1571469
     /* 1571469 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1571551), // Rule ID 21633 //
     /* 1571474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571513 */     // MIs[0] round
     /* 1571513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571516 */     // MIs[0] policy
     /* 1571516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571550 */     // GIR_Coverage, 21633,
     /* 1571550 */     GIR_EraseRootFromParent_Done,
     /* 1571551 */   // Label 21784: @1571551
     /* 1571551 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1571633), // Rule ID 21636 //
     /* 1571556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571595 */     // MIs[0] round
     /* 1571595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571598 */     // MIs[0] policy
     /* 1571598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571608 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571632 */     // GIR_Coverage, 21636,
     /* 1571632 */     GIR_EraseRootFromParent_Done,
     /* 1571633 */   // Label 21785: @1571633
     /* 1571633 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1571715), // Rule ID 21637 //
     /* 1571638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571677 */     // MIs[0] round
     /* 1571677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571680 */     // MIs[0] policy
     /* 1571680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571690 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571714 */     // GIR_Coverage, 21637,
     /* 1571714 */     GIR_EraseRootFromParent_Done,
     /* 1571715 */   // Label 21786: @1571715
     /* 1571715 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1571797), // Rule ID 21640 //
     /* 1571720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571759 */     // MIs[0] round
     /* 1571759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571762 */     // MIs[0] policy
     /* 1571762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571796 */     // GIR_Coverage, 21640,
     /* 1571796 */     GIR_EraseRootFromParent_Done,
     /* 1571797 */   // Label 21787: @1571797
     /* 1571797 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1571879), // Rule ID 21641 //
     /* 1571802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571841 */     // MIs[0] round
     /* 1571841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571844 */     // MIs[0] policy
     /* 1571844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11294:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571878 */     // GIR_Coverage, 21641,
     /* 1571878 */     GIR_EraseRootFromParent_Done,
     /* 1571879 */   // Label 21788: @1571879
     /* 1571879 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1571961), // Rule ID 21644 //
     /* 1571884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571923 */     // MIs[0] round
     /* 1571923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571926 */     // MIs[0] policy
     /* 1571926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571960 */     // GIR_Coverage, 21644,
     /* 1571960 */     GIR_EraseRootFromParent_Done,
     /* 1571961 */   // Label 21789: @1571961
     /* 1571961 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1572043), // Rule ID 21645 //
     /* 1571966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572005 */     // MIs[0] round
     /* 1572005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572008 */     // MIs[0] policy
     /* 1572008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572042 */     // GIR_Coverage, 21645,
     /* 1572042 */     GIR_EraseRootFromParent_Done,
     /* 1572043 */   // Label 21790: @1572043
     /* 1572043 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1572125), // Rule ID 21648 //
     /* 1572048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1572051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572087 */     // MIs[0] round
     /* 1572087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572090 */     // MIs[0] policy
     /* 1572090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572124 */     // GIR_Coverage, 21648,
     /* 1572124 */     GIR_EraseRootFromParent_Done,
     /* 1572125 */   // Label 21791: @1572125
     /* 1572125 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1572207), // Rule ID 21649 //
     /* 1572130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1572133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572169 */     // MIs[0] round
     /* 1572169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572172 */     // MIs[0] policy
     /* 1572172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572206 */     // GIR_Coverage, 21649,
     /* 1572206 */     GIR_EraseRootFromParent_Done,
     /* 1572207 */   // Label 21792: @1572207
     /* 1572207 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1572289), // Rule ID 21652 //
     /* 1572212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1572229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572251 */     // MIs[0] round
     /* 1572251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572254 */     // MIs[0] policy
     /* 1572254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1572267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572288 */     // GIR_Coverage, 21652,
     /* 1572288 */     GIR_EraseRootFromParent_Done,
     /* 1572289 */   // Label 21793: @1572289
     /* 1572289 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1572371), // Rule ID 21653 //
     /* 1572294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1572311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572333 */     // MIs[0] round
     /* 1572333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572336 */     // MIs[0] policy
     /* 1572336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1572349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572370 */     // GIR_Coverage, 21653,
     /* 1572370 */     GIR_EraseRootFromParent_Done,
     /* 1572371 */   // Label 21794: @1572371
     /* 1572371 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1572453), // Rule ID 21656 //
     /* 1572376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572415 */     // MIs[0] round
     /* 1572415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572418 */     // MIs[0] policy
     /* 1572418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572452 */     // GIR_Coverage, 21656,
     /* 1572452 */     GIR_EraseRootFromParent_Done,
     /* 1572453 */   // Label 21795: @1572453
     /* 1572453 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1572535), // Rule ID 21657 //
     /* 1572458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572497 */     // MIs[0] round
     /* 1572497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572500 */     // MIs[0] policy
     /* 1572500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572534 */     // GIR_Coverage, 21657,
     /* 1572534 */     GIR_EraseRootFromParent_Done,
     /* 1572535 */   // Label 21796: @1572535
     /* 1572535 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1572617), // Rule ID 21660 //
     /* 1572540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572579 */     // MIs[0] round
     /* 1572579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572582 */     // MIs[0] policy
     /* 1572582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572616 */     // GIR_Coverage, 21660,
     /* 1572616 */     GIR_EraseRootFromParent_Done,
     /* 1572617 */   // Label 21797: @1572617
     /* 1572617 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1572699), // Rule ID 21661 //
     /* 1572622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572661 */     // MIs[0] round
     /* 1572661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572664 */     // MIs[0] policy
     /* 1572664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572698 */     // GIR_Coverage, 21661,
     /* 1572698 */     GIR_EraseRootFromParent_Done,
     /* 1572699 */   // Label 21798: @1572699
     /* 1572699 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1572781), // Rule ID 21664 //
     /* 1572704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572743 */     // MIs[0] round
     /* 1572743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572746 */     // MIs[0] policy
     /* 1572746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572780 */     // GIR_Coverage, 21664,
     /* 1572780 */     GIR_EraseRootFromParent_Done,
     /* 1572781 */   // Label 21799: @1572781
     /* 1572781 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1572863), // Rule ID 21665 //
     /* 1572786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572825 */     // MIs[0] round
     /* 1572825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572828 */     // MIs[0] policy
     /* 1572828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572862 */     // GIR_Coverage, 21665,
     /* 1572862 */     GIR_EraseRootFromParent_Done,
     /* 1572863 */   // Label 21800: @1572863
     /* 1572863 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1572945), // Rule ID 21668 //
     /* 1572868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572907 */     // MIs[0] round
     /* 1572907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572910 */     // MIs[0] policy
     /* 1572910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572944 */     // GIR_Coverage, 21668,
     /* 1572944 */     GIR_EraseRootFromParent_Done,
     /* 1572945 */   // Label 21801: @1572945
     /* 1572945 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1573027), // Rule ID 21669 //
     /* 1572950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572989 */     // MIs[0] round
     /* 1572989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572992 */     // MIs[0] policy
     /* 1572992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1573005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573026 */     // GIR_Coverage, 21669,
     /* 1573026 */     GIR_EraseRootFromParent_Done,
     /* 1573027 */   // Label 21802: @1573027
     /* 1573027 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1573109), // Rule ID 21672 //
     /* 1573032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1573043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1573046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1573049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573071 */     // MIs[0] round
     /* 1573071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573074 */     // MIs[0] policy
     /* 1573074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573084 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573108 */     // GIR_Coverage, 21672,
     /* 1573108 */     GIR_EraseRootFromParent_Done,
     /* 1573109 */   // Label 21803: @1573109
     /* 1573109 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1573191), // Rule ID 21673 //
     /* 1573114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1573125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1573128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1573131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573153 */     // MIs[0] round
     /* 1573153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573156 */     // MIs[0] policy
     /* 1573156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573166 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573190 */     // GIR_Coverage, 21673,
     /* 1573190 */     GIR_EraseRootFromParent_Done,
     /* 1573191 */   // Label 21804: @1573191
     /* 1573191 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1573273), // Rule ID 21676 //
     /* 1573196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1573207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1573210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1573213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573235 */     // MIs[0] round
     /* 1573235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573238 */     // MIs[0] policy
     /* 1573238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573272 */     // GIR_Coverage, 21676,
     /* 1573272 */     GIR_EraseRootFromParent_Done,
     /* 1573273 */   // Label 21805: @1573273
     /* 1573273 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1573355), // Rule ID 21677 //
     /* 1573278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1573289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1573292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1573295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573317 */     // MIs[0] round
     /* 1573317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573320 */     // MIs[0] policy
     /* 1573320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573330 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573354 */     // GIR_Coverage, 21677,
     /* 1573354 */     GIR_EraseRootFromParent_Done,
     /* 1573355 */   // Label 21806: @1573355
     /* 1573355 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1573437), // Rule ID 21680 //
     /* 1573360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1573371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1573374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573399 */     // MIs[0] round
     /* 1573399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573402 */     // MIs[0] policy
     /* 1573402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573436 */     // GIR_Coverage, 21680,
     /* 1573436 */     GIR_EraseRootFromParent_Done,
     /* 1573437 */   // Label 21807: @1573437
     /* 1573437 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1573519), // Rule ID 21681 //
     /* 1573442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1573453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1573456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1573459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573481 */     // MIs[0] round
     /* 1573481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573484 */     // MIs[0] policy
     /* 1573484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11292:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573518 */     // GIR_Coverage, 21681,
     /* 1573518 */     GIR_EraseRootFromParent_Done,
     /* 1573519 */   // Label 21808: @1573519
     /* 1573519 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1573601), // Rule ID 21684 //
     /* 1573524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573563 */     // MIs[0] round
     /* 1573563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573566 */     // MIs[0] policy
     /* 1573566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573600 */     // GIR_Coverage, 21684,
     /* 1573600 */     GIR_EraseRootFromParent_Done,
     /* 1573601 */   // Label 21809: @1573601
     /* 1573601 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1573683), // Rule ID 21685 //
     /* 1573606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573645 */     // MIs[0] round
     /* 1573645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573648 */     // MIs[0] policy
     /* 1573648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573658 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573682 */     // GIR_Coverage, 21685,
     /* 1573682 */     GIR_EraseRootFromParent_Done,
     /* 1573683 */   // Label 21810: @1573683
     /* 1573683 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1573765), // Rule ID 21688 //
     /* 1573688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573727 */     // MIs[0] round
     /* 1573727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573730 */     // MIs[0] policy
     /* 1573730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573764 */     // GIR_Coverage, 21688,
     /* 1573764 */     GIR_EraseRootFromParent_Done,
     /* 1573765 */   // Label 21811: @1573765
     /* 1573765 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1573847), // Rule ID 21689 //
     /* 1573770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573809 */     // MIs[0] round
     /* 1573809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573812 */     // MIs[0] policy
     /* 1573812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573846 */     // GIR_Coverage, 21689,
     /* 1573846 */     GIR_EraseRootFromParent_Done,
     /* 1573847 */   // Label 21812: @1573847
     /* 1573847 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1573929), // Rule ID 21692 //
     /* 1573852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573891 */     // MIs[0] round
     /* 1573891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573894 */     // MIs[0] policy
     /* 1573894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573928 */     // GIR_Coverage, 21692,
     /* 1573928 */     GIR_EraseRootFromParent_Done,
     /* 1573929 */   // Label 21813: @1573929
     /* 1573929 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1574011), // Rule ID 21693 //
     /* 1573934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573973 */     // MIs[0] round
     /* 1573973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573976 */     // MIs[0] policy
     /* 1573976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574010 */     // GIR_Coverage, 21693,
     /* 1574010 */     GIR_EraseRootFromParent_Done,
     /* 1574011 */   // Label 21814: @1574011
     /* 1574011 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1574093), // Rule ID 21696 //
     /* 1574016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574055 */     // MIs[0] round
     /* 1574055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574058 */     // MIs[0] policy
     /* 1574058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574092 */     // GIR_Coverage, 21696,
     /* 1574092 */     GIR_EraseRootFromParent_Done,
     /* 1574093 */   // Label 21815: @1574093
     /* 1574093 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1574175), // Rule ID 21697 //
     /* 1574098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574137 */     // MIs[0] round
     /* 1574137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574140 */     // MIs[0] policy
     /* 1574140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574174 */     // GIR_Coverage, 21697,
     /* 1574174 */     GIR_EraseRootFromParent_Done,
     /* 1574175 */   // Label 21816: @1574175
     /* 1574175 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1574257), // Rule ID 21700 //
     /* 1574180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574219 */     // MIs[0] round
     /* 1574219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574222 */     // MIs[0] policy
     /* 1574222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574256 */     // GIR_Coverage, 21700,
     /* 1574256 */     GIR_EraseRootFromParent_Done,
     /* 1574257 */   // Label 21817: @1574257
     /* 1574257 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1574339), // Rule ID 21701 //
     /* 1574262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574301 */     // MIs[0] round
     /* 1574301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574304 */     // MIs[0] policy
     /* 1574304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11292:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574338 */     // GIR_Coverage, 21701,
     /* 1574338 */     GIR_EraseRootFromParent_Done,
     /* 1574339 */   // Label 21818: @1574339
     /* 1574339 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1574421), // Rule ID 21704 //
     /* 1574344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574383 */     // MIs[0] round
     /* 1574383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574386 */     // MIs[0] policy
     /* 1574386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574420 */     // GIR_Coverage, 21704,
     /* 1574420 */     GIR_EraseRootFromParent_Done,
     /* 1574421 */   // Label 21819: @1574421
     /* 1574421 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1574503), // Rule ID 21705 //
     /* 1574426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574465 */     // MIs[0] round
     /* 1574465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574468 */     // MIs[0] policy
     /* 1574468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574478 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574502 */     // GIR_Coverage, 21705,
     /* 1574502 */     GIR_EraseRootFromParent_Done,
     /* 1574503 */   // Label 21820: @1574503
     /* 1574503 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1574585), // Rule ID 21708 //
     /* 1574508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574547 */     // MIs[0] round
     /* 1574547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574550 */     // MIs[0] policy
     /* 1574550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574584 */     // GIR_Coverage, 21708,
     /* 1574584 */     GIR_EraseRootFromParent_Done,
     /* 1574585 */   // Label 21821: @1574585
     /* 1574585 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1574667), // Rule ID 21709 //
     /* 1574590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574629 */     // MIs[0] round
     /* 1574629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574632 */     // MIs[0] policy
     /* 1574632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574666 */     // GIR_Coverage, 21709,
     /* 1574666 */     GIR_EraseRootFromParent_Done,
     /* 1574667 */   // Label 21822: @1574667
     /* 1574667 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1574749), // Rule ID 21712 //
     /* 1574672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574711 */     // MIs[0] round
     /* 1574711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574714 */     // MIs[0] policy
     /* 1574714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574748 */     // GIR_Coverage, 21712,
     /* 1574748 */     GIR_EraseRootFromParent_Done,
     /* 1574749 */   // Label 21823: @1574749
     /* 1574749 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1574831), // Rule ID 21713 //
     /* 1574754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574793 */     // MIs[0] round
     /* 1574793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574796 */     // MIs[0] policy
     /* 1574796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574830 */     // GIR_Coverage, 21713,
     /* 1574830 */     GIR_EraseRootFromParent_Done,
     /* 1574831 */   // Label 21824: @1574831
     /* 1574831 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1574913), // Rule ID 21716 //
     /* 1574836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574875 */     // MIs[0] round
     /* 1574875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574878 */     // MIs[0] policy
     /* 1574878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574912 */     // GIR_Coverage, 21716,
     /* 1574912 */     GIR_EraseRootFromParent_Done,
     /* 1574913 */   // Label 21825: @1574913
     /* 1574913 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1574995), // Rule ID 21717 //
     /* 1574918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574957 */     // MIs[0] round
     /* 1574957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574960 */     // MIs[0] policy
     /* 1574960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574994 */     // GIR_Coverage, 21717,
     /* 1574994 */     GIR_EraseRootFromParent_Done,
     /* 1574995 */   // Label 21826: @1574995
     /* 1574995 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1575077), // Rule ID 21720 //
     /* 1575000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575039 */     // MIs[0] round
     /* 1575039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575042 */     // MIs[0] policy
     /* 1575042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1575055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575076 */     // GIR_Coverage, 21720,
     /* 1575076 */     GIR_EraseRootFromParent_Done,
     /* 1575077 */   // Label 21827: @1575077
     /* 1575077 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1575159), // Rule ID 21721 //
     /* 1575082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575121 */     // MIs[0] round
     /* 1575121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575124 */     // MIs[0] policy
     /* 1575124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1575137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575158 */     // GIR_Coverage, 21721,
     /* 1575158 */     GIR_EraseRootFromParent_Done,
     /* 1575159 */   // Label 21828: @1575159
     /* 1575159 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1575241), // Rule ID 21724 //
     /* 1575164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1575167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575203 */     // MIs[0] round
     /* 1575203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575206 */     // MIs[0] policy
     /* 1575206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1575219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575240 */     // GIR_Coverage, 21724,
     /* 1575240 */     GIR_EraseRootFromParent_Done,
     /* 1575241 */   // Label 21829: @1575241
     /* 1575241 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1575323), // Rule ID 21725 //
     /* 1575246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1575249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1575254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575285 */     // MIs[0] round
     /* 1575285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575288 */     // MIs[0] policy
     /* 1575288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1575301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575322 */     // GIR_Coverage, 21725,
     /* 1575322 */     GIR_EraseRootFromParent_Done,
     /* 1575323 */   // Label 21830: @1575323
     /* 1575323 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1575405), // Rule ID 21848 //
     /* 1575328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1575345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575367 */     // MIs[0] round
     /* 1575367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575370 */     // MIs[0] policy
     /* 1575370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1575383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575404 */     // GIR_Coverage, 21848,
     /* 1575404 */     GIR_EraseRootFromParent_Done,
     /* 1575405 */   // Label 21831: @1575405
     /* 1575405 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1575487), // Rule ID 21849 //
     /* 1575410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1575427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575449 */     // MIs[0] round
     /* 1575449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575452 */     // MIs[0] policy
     /* 1575452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1575465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575486 */     // GIR_Coverage, 21849,
     /* 1575486 */     GIR_EraseRootFromParent_Done,
     /* 1575487 */   // Label 21832: @1575487
     /* 1575487 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1575569), // Rule ID 21852 //
     /* 1575492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575531 */     // MIs[0] round
     /* 1575531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575534 */     // MIs[0] policy
     /* 1575534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575544 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575568 */     // GIR_Coverage, 21852,
     /* 1575568 */     GIR_EraseRootFromParent_Done,
     /* 1575569 */   // Label 21833: @1575569
     /* 1575569 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1575651), // Rule ID 21853 //
     /* 1575574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575613 */     // MIs[0] round
     /* 1575613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575616 */     // MIs[0] policy
     /* 1575616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575626 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575650 */     // GIR_Coverage, 21853,
     /* 1575650 */     GIR_EraseRootFromParent_Done,
     /* 1575651 */   // Label 21834: @1575651
     /* 1575651 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1575733), // Rule ID 21856 //
     /* 1575656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575695 */     // MIs[0] round
     /* 1575695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575698 */     // MIs[0] policy
     /* 1575698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575708 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575732 */     // GIR_Coverage, 21856,
     /* 1575732 */     GIR_EraseRootFromParent_Done,
     /* 1575733 */   // Label 21835: @1575733
     /* 1575733 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1575815), // Rule ID 21857 //
     /* 1575738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575777 */     // MIs[0] round
     /* 1575777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575780 */     // MIs[0] policy
     /* 1575780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575790 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11284:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575814 */     // GIR_Coverage, 21857,
     /* 1575814 */     GIR_EraseRootFromParent_Done,
     /* 1575815 */   // Label 21836: @1575815
     /* 1575815 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1575897), // Rule ID 21860 //
     /* 1575820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575859 */     // MIs[0] round
     /* 1575859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575862 */     // MIs[0] policy
     /* 1575862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575896 */     // GIR_Coverage, 21860,
     /* 1575896 */     GIR_EraseRootFromParent_Done,
     /* 1575897 */   // Label 21837: @1575897
     /* 1575897 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1575979), // Rule ID 21861 //
     /* 1575902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575941 */     // MIs[0] round
     /* 1575941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575944 */     // MIs[0] policy
     /* 1575944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575978 */     // GIR_Coverage, 21861,
     /* 1575978 */     GIR_EraseRootFromParent_Done,
     /* 1575979 */   // Label 21838: @1575979
     /* 1575979 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1576061), // Rule ID 21864 //
     /* 1575984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576023 */     // MIs[0] round
     /* 1576023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576026 */     // MIs[0] policy
     /* 1576026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1576039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576060 */     // GIR_Coverage, 21864,
     /* 1576060 */     GIR_EraseRootFromParent_Done,
     /* 1576061 */   // Label 21839: @1576061
     /* 1576061 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1576143), // Rule ID 21865 //
     /* 1576066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1576077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1576080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576105 */     // MIs[0] round
     /* 1576105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576108 */     // MIs[0] policy
     /* 1576108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576118 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1576121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576142 */     // GIR_Coverage, 21865,
     /* 1576142 */     GIR_EraseRootFromParent_Done,
     /* 1576143 */   // Label 21840: @1576143
     /* 1576143 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1576225), // Rule ID 21868 //
     /* 1576148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1576165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576187 */     // MIs[0] round
     /* 1576187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576190 */     // MIs[0] policy
     /* 1576190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576200 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1576203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576224 */     // GIR_Coverage, 21868,
     /* 1576224 */     GIR_EraseRootFromParent_Done,
     /* 1576225 */   // Label 21841: @1576225
     /* 1576225 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1576307), // Rule ID 21869 //
     /* 1576230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1576247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576269 */     // MIs[0] round
     /* 1576269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576272 */     // MIs[0] policy
     /* 1576272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576282 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1576285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576306 */     // GIR_Coverage, 21869,
     /* 1576306 */     GIR_EraseRootFromParent_Done,
     /* 1576307 */   // Label 21842: @1576307
     /* 1576307 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1576389), // Rule ID 21872 //
     /* 1576312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1576329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576351 */     // MIs[0] round
     /* 1576351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576354 */     // MIs[0] policy
     /* 1576354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1576367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576388 */     // GIR_Coverage, 21872,
     /* 1576388 */     GIR_EraseRootFromParent_Done,
     /* 1576389 */   // Label 21843: @1576389
     /* 1576389 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1576471), // Rule ID 21873 //
     /* 1576394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1576411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576433 */     // MIs[0] round
     /* 1576433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576436 */     // MIs[0] policy
     /* 1576436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576446 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1576449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576470 */     // GIR_Coverage, 21873,
     /* 1576470 */     GIR_EraseRootFromParent_Done,
     /* 1576471 */   // Label 21844: @1576471
     /* 1576471 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1576553), // Rule ID 21876 //
     /* 1576476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576515 */     // MIs[0] round
     /* 1576515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576518 */     // MIs[0] policy
     /* 1576518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576528 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576552 */     // GIR_Coverage, 21876,
     /* 1576552 */     GIR_EraseRootFromParent_Done,
     /* 1576553 */   // Label 21845: @1576553
     /* 1576553 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1576635), // Rule ID 21877 //
     /* 1576558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576597 */     // MIs[0] round
     /* 1576597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576600 */     // MIs[0] policy
     /* 1576600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576634 */     // GIR_Coverage, 21877,
     /* 1576634 */     GIR_EraseRootFromParent_Done,
     /* 1576635 */   // Label 21846: @1576635
     /* 1576635 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1576717), // Rule ID 21880 //
     /* 1576640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576679 */     // MIs[0] round
     /* 1576679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576682 */     // MIs[0] policy
     /* 1576682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576692 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576716 */     // GIR_Coverage, 21880,
     /* 1576716 */     GIR_EraseRootFromParent_Done,
     /* 1576717 */   // Label 21847: @1576717
     /* 1576717 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1576799), // Rule ID 21881 //
     /* 1576722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576761 */     // MIs[0] round
     /* 1576761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576764 */     // MIs[0] policy
     /* 1576764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576774 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576798 */     // GIR_Coverage, 21881,
     /* 1576798 */     GIR_EraseRootFromParent_Done,
     /* 1576799 */   // Label 21848: @1576799
     /* 1576799 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1576881), // Rule ID 21884 //
     /* 1576804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576843 */     // MIs[0] round
     /* 1576843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576846 */     // MIs[0] policy
     /* 1576846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576856 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576880 */     // GIR_Coverage, 21884,
     /* 1576880 */     GIR_EraseRootFromParent_Done,
     /* 1576881 */   // Label 21849: @1576881
     /* 1576881 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1576963), // Rule ID 21885 //
     /* 1576886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576925 */     // MIs[0] round
     /* 1576925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576928 */     // MIs[0] policy
     /* 1576928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576938 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576962 */     // GIR_Coverage, 21885,
     /* 1576962 */     GIR_EraseRootFromParent_Done,
     /* 1576963 */   // Label 21850: @1576963
     /* 1576963 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1577045), // Rule ID 21888 //
     /* 1576968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577007 */     // MIs[0] round
     /* 1577007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577010 */     // MIs[0] policy
     /* 1577010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577020 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1577023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577044 */     // GIR_Coverage, 21888,
     /* 1577044 */     GIR_EraseRootFromParent_Done,
     /* 1577045 */   // Label 21851: @1577045
     /* 1577045 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1577127), // Rule ID 21889 //
     /* 1577050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1577067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577089 */     // MIs[0] round
     /* 1577089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577092 */     // MIs[0] policy
     /* 1577092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577102 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1577105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577126 */     // GIR_Coverage, 21889,
     /* 1577126 */     GIR_EraseRootFromParent_Done,
     /* 1577127 */   // Label 21852: @1577127
     /* 1577127 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1577209), // Rule ID 21892 //
     /* 1577132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577171 */     // MIs[0] round
     /* 1577171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577174 */     // MIs[0] policy
     /* 1577174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1577187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577208 */     // GIR_Coverage, 21892,
     /* 1577208 */     GIR_EraseRootFromParent_Done,
     /* 1577209 */   // Label 21853: @1577209
     /* 1577209 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1577291), // Rule ID 21893 //
     /* 1577214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1577231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577253 */     // MIs[0] round
     /* 1577253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577256 */     // MIs[0] policy
     /* 1577256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577266 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11282:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1577269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577290 */     // GIR_Coverage, 21893,
     /* 1577290 */     GIR_EraseRootFromParent_Done,
     /* 1577291 */   // Label 21854: @1577291
     /* 1577291 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1577373), // Rule ID 21896 //
     /* 1577296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577335 */     // MIs[0] round
     /* 1577335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577338 */     // MIs[0] policy
     /* 1577338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577348 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1577351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577372 */     // GIR_Coverage, 21896,
     /* 1577372 */     GIR_EraseRootFromParent_Done,
     /* 1577373 */   // Label 21855: @1577373
     /* 1577373 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1577455), // Rule ID 21897 //
     /* 1577378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1577395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577417 */     // MIs[0] round
     /* 1577417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577420 */     // MIs[0] policy
     /* 1577420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577430 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1577433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577454 */     // GIR_Coverage, 21897,
     /* 1577454 */     GIR_EraseRootFromParent_Done,
     /* 1577455 */   // Label 21856: @1577455
     /* 1577455 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1577537), // Rule ID 21900 //
     /* 1577460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1577463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577499 */     // MIs[0] round
     /* 1577499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577502 */     // MIs[0] policy
     /* 1577502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577512 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577536 */     // GIR_Coverage, 21900,
     /* 1577536 */     GIR_EraseRootFromParent_Done,
     /* 1577537 */   // Label 21857: @1577537
     /* 1577537 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1577619), // Rule ID 21901 //
     /* 1577542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577581 */     // MIs[0] round
     /* 1577581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577584 */     // MIs[0] policy
     /* 1577584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577594 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577618 */     // GIR_Coverage, 21901,
     /* 1577618 */     GIR_EraseRootFromParent_Done,
     /* 1577619 */   // Label 21858: @1577619
     /* 1577619 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1577701), // Rule ID 21904 //
     /* 1577624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577663 */     // MIs[0] round
     /* 1577663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577666 */     // MIs[0] policy
     /* 1577666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577700 */     // GIR_Coverage, 21904,
     /* 1577700 */     GIR_EraseRootFromParent_Done,
     /* 1577701 */   // Label 21859: @1577701
     /* 1577701 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1577783), // Rule ID 21905 //
     /* 1577706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577745 */     // MIs[0] round
     /* 1577745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577748 */     // MIs[0] policy
     /* 1577748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577782 */     // GIR_Coverage, 21905,
     /* 1577782 */     GIR_EraseRootFromParent_Done,
     /* 1577783 */   // Label 21860: @1577783
     /* 1577783 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1577865), // Rule ID 21908 //
     /* 1577788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577827 */     // MIs[0] round
     /* 1577827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577830 */     // MIs[0] policy
     /* 1577830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577864 */     // GIR_Coverage, 21908,
     /* 1577864 */     GIR_EraseRootFromParent_Done,
     /* 1577865 */   // Label 21861: @1577865
     /* 1577865 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1577947), // Rule ID 21909 //
     /* 1577870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577909 */     // MIs[0] round
     /* 1577909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577912 */     // MIs[0] policy
     /* 1577912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577922 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577946 */     // GIR_Coverage, 21909,
     /* 1577946 */     GIR_EraseRootFromParent_Done,
     /* 1577947 */   // Label 21862: @1577947
     /* 1577947 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1578029), // Rule ID 21912 //
     /* 1577952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577991 */     // MIs[0] round
     /* 1577991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577994 */     // MIs[0] policy
     /* 1577994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1578007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578028 */     // GIR_Coverage, 21912,
     /* 1578028 */     GIR_EraseRootFromParent_Done,
     /* 1578029 */   // Label 21863: @1578029
     /* 1578029 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1578111), // Rule ID 21913 //
     /* 1578034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1578037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578073 */     // MIs[0] round
     /* 1578073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578076 */     // MIs[0] policy
     /* 1578076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578086 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1578089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578110 */     // GIR_Coverage, 21913,
     /* 1578110 */     GIR_EraseRootFromParent_Done,
     /* 1578111 */   // Label 21864: @1578111
     /* 1578111 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1578193), // Rule ID 21916 //
     /* 1578116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1578119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578155 */     // MIs[0] round
     /* 1578155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578158 */     // MIs[0] policy
     /* 1578158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578168 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1578171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578192 */     // GIR_Coverage, 21916,
     /* 1578192 */     GIR_EraseRootFromParent_Done,
     /* 1578193 */   // Label 21865: @1578193
     /* 1578193 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1578275), // Rule ID 21917 //
     /* 1578198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1578201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1578206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1578215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578237 */     // MIs[0] round
     /* 1578237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578240 */     // MIs[0] policy
     /* 1578240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1578253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578274 */     // GIR_Coverage, 21917,
     /* 1578274 */     GIR_EraseRootFromParent_Done,
     /* 1578275 */   // Label 21866: @1578275
     /* 1578275 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1578357), // Rule ID 21920 //
     /* 1578280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578319 */     // MIs[0] round
     /* 1578319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578322 */     // MIs[0] policy
     /* 1578322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578332 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1578335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578356 */     // GIR_Coverage, 21920,
     /* 1578356 */     GIR_EraseRootFromParent_Done,
     /* 1578357 */   // Label 21867: @1578357
     /* 1578357 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1578439), // Rule ID 21921 //
     /* 1578362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1578373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1578376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1578379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578401 */     // MIs[0] round
     /* 1578401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578404 */     // MIs[0] policy
     /* 1578404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578414 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1578417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578438 */     // GIR_Coverage, 21921,
     /* 1578438 */     GIR_EraseRootFromParent_Done,
     /* 1578439 */   // Label 21868: @1578439
     /* 1578439 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1578521), // Rule ID 21924 //
     /* 1578444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578483 */     // MIs[0] round
     /* 1578483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578486 */     // MIs[0] policy
     /* 1578486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578496 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578520 */     // GIR_Coverage, 21924,
     /* 1578520 */     GIR_EraseRootFromParent_Done,
     /* 1578521 */   // Label 21869: @1578521
     /* 1578521 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1578603), // Rule ID 21925 //
     /* 1578526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578565 */     // MIs[0] round
     /* 1578565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578568 */     // MIs[0] policy
     /* 1578568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578578 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578602 */     // GIR_Coverage, 21925,
     /* 1578602 */     GIR_EraseRootFromParent_Done,
     /* 1578603 */   // Label 21870: @1578603
     /* 1578603 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1578685), // Rule ID 21928 //
     /* 1578608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578647 */     // MIs[0] round
     /* 1578647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578650 */     // MIs[0] policy
     /* 1578650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578660 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578684 */     // GIR_Coverage, 21928,
     /* 1578684 */     GIR_EraseRootFromParent_Done,
     /* 1578685 */   // Label 21871: @1578685
     /* 1578685 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1578767), // Rule ID 21929 //
     /* 1578690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578729 */     // MIs[0] round
     /* 1578729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578732 */     // MIs[0] policy
     /* 1578732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578742 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11280:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578766 */     // GIR_Coverage, 21929,
     /* 1578766 */     GIR_EraseRootFromParent_Done,
     /* 1578767 */   // Label 21872: @1578767
     /* 1578767 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1578849), // Rule ID 21932 //
     /* 1578772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578811 */     // MIs[0] round
     /* 1578811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578814 */     // MIs[0] policy
     /* 1578814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578848 */     // GIR_Coverage, 21932,
     /* 1578848 */     GIR_EraseRootFromParent_Done,
     /* 1578849 */   // Label 21873: @1578849
     /* 1578849 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1578931), // Rule ID 21933 //
     /* 1578854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578893 */     // MIs[0] round
     /* 1578893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578896 */     // MIs[0] policy
     /* 1578896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578906 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578930 */     // GIR_Coverage, 21933,
     /* 1578930 */     GIR_EraseRootFromParent_Done,
     /* 1578931 */   // Label 21874: @1578931
     /* 1578931 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1579013), // Rule ID 21936 //
     /* 1578936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578975 */     // MIs[0] round
     /* 1578975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578978 */     // MIs[0] policy
     /* 1578978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578988 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579012 */     // GIR_Coverage, 21936,
     /* 1579012 */     GIR_EraseRootFromParent_Done,
     /* 1579013 */   // Label 21875: @1579013
     /* 1579013 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1579095), // Rule ID 21937 //
     /* 1579018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1579021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1579035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1579038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579057 */     // MIs[0] round
     /* 1579057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579060 */     // MIs[0] policy
     /* 1579060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579070 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1579073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579094 */     // GIR_Coverage, 21937,
     /* 1579094 */     GIR_EraseRootFromParent_Done,
     /* 1579095 */   // Label 21876: @1579095
     /* 1579095 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1579177), // Rule ID 21940 //
     /* 1579100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579139 */     // MIs[0] round
     /* 1579139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579142 */     // MIs[0] policy
     /* 1579142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579152 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1579155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579176 */     // GIR_Coverage, 21940,
     /* 1579176 */     GIR_EraseRootFromParent_Done,
     /* 1579177 */   // Label 21877: @1579177
     /* 1579177 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1579259), // Rule ID 21941 //
     /* 1579182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1579193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1579196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1579199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1579202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579221 */     // MIs[0] round
     /* 1579221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579224 */     // MIs[0] policy
     /* 1579224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1579237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579258 */     // GIR_Coverage, 21941,
     /* 1579258 */     GIR_EraseRootFromParent_Done,
     /* 1579259 */   // Label 21878: @1579259
     /* 1579259 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1579341), // Rule ID 21944 //
     /* 1579264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579303 */     // MIs[0] round
     /* 1579303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579306 */     // MIs[0] policy
     /* 1579306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579316 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1579319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579340 */     // GIR_Coverage, 21944,
     /* 1579340 */     GIR_EraseRootFromParent_Done,
     /* 1579341 */   // Label 21879: @1579341
     /* 1579341 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1579423), // Rule ID 21945 //
     /* 1579346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1579357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1579360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1579363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1579366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579385 */     // MIs[0] round
     /* 1579385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579388 */     // MIs[0] policy
     /* 1579388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579398 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1579401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579422 */     // GIR_Coverage, 21945,
     /* 1579422 */     GIR_EraseRootFromParent_Done,
     /* 1579423 */   // Label 21880: @1579423
     /* 1579423 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1579505), // Rule ID 21948 //
     /* 1579428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579467 */     // MIs[0] round
     /* 1579467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579470 */     // MIs[0] policy
     /* 1579470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579480 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579504 */     // GIR_Coverage, 21948,
     /* 1579504 */     GIR_EraseRootFromParent_Done,
     /* 1579505 */   // Label 21881: @1579505
     /* 1579505 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1579587), // Rule ID 21949 //
     /* 1579510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579549 */     // MIs[0] round
     /* 1579549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579552 */     // MIs[0] policy
     /* 1579552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579586 */     // GIR_Coverage, 21949,
     /* 1579586 */     GIR_EraseRootFromParent_Done,
     /* 1579587 */   // Label 21882: @1579587
     /* 1579587 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1579669), // Rule ID 21952 //
     /* 1579592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579631 */     // MIs[0] round
     /* 1579631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579634 */     // MIs[0] policy
     /* 1579634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579644 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579668 */     // GIR_Coverage, 21952,
     /* 1579668 */     GIR_EraseRootFromParent_Done,
     /* 1579669 */   // Label 21883: @1579669
     /* 1579669 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1579751), // Rule ID 21953 //
     /* 1579674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579713 */     // MIs[0] round
     /* 1579713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579716 */     // MIs[0] policy
     /* 1579716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579726 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579750 */     // GIR_Coverage, 21953,
     /* 1579750 */     GIR_EraseRootFromParent_Done,
     /* 1579751 */   // Label 21884: @1579751
     /* 1579751 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1579833), // Rule ID 2762 //
     /* 1579756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579787 */     // MIs[0] passthru
     /* 1579787 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579800 */     // MIs[0] policy
     /* 1579800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579832 */     // GIR_Coverage, 2762,
     /* 1579832 */     GIR_EraseRootFromParent_Done,
     /* 1579833 */   // Label 21885: @1579833
     /* 1579833 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1579915), // Rule ID 2763 //
     /* 1579838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579869 */     // MIs[0] passthru
     /* 1579869 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579882 */     // MIs[0] policy
     /* 1579882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579914 */     // GIR_Coverage, 2763,
     /* 1579914 */     GIR_EraseRootFromParent_Done,
     /* 1579915 */   // Label 21886: @1579915
     /* 1579915 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1579997), // Rule ID 4078 //
     /* 1579920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579951 */     // MIs[0] passthru
     /* 1579951 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579964 */     // MIs[0] policy
     /* 1579964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579996 */     // GIR_Coverage, 4078,
     /* 1579996 */     GIR_EraseRootFromParent_Done,
     /* 1579997 */   // Label 21887: @1579997
     /* 1579997 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1580079), // Rule ID 4079 //
     /* 1580002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1580019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580033 */     // MIs[0] passthru
     /* 1580033 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580046 */     // MIs[0] policy
     /* 1580046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580078 */     // GIR_Coverage, 4079,
     /* 1580078 */     GIR_EraseRootFromParent_Done,
     /* 1580079 */   // Label 21888: @1580079
     /* 1580079 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1580161), // Rule ID 4088 //
     /* 1580084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580115 */     // MIs[0] passthru
     /* 1580115 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580128 */     // MIs[0] policy
     /* 1580128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580160 */     // GIR_Coverage, 4088,
     /* 1580160 */     GIR_EraseRootFromParent_Done,
     /* 1580161 */   // Label 21889: @1580161
     /* 1580161 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1580243), // Rule ID 4089 //
     /* 1580166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580197 */     // MIs[0] passthru
     /* 1580197 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580210 */     // MIs[0] policy
     /* 1580210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580242 */     // GIR_Coverage, 4089,
     /* 1580242 */     GIR_EraseRootFromParent_Done,
     /* 1580243 */   // Label 21890: @1580243
     /* 1580243 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1580325), // Rule ID 4098 //
     /* 1580248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580279 */     // MIs[0] passthru
     /* 1580279 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580292 */     // MIs[0] policy
     /* 1580292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580324 */     // GIR_Coverage, 4098,
     /* 1580324 */     GIR_EraseRootFromParent_Done,
     /* 1580325 */   // Label 21891: @1580325
     /* 1580325 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1580407), // Rule ID 4099 //
     /* 1580330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580361 */     // MIs[0] passthru
     /* 1580361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580374 */     // MIs[0] policy
     /* 1580374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580406 */     // GIR_Coverage, 4099,
     /* 1580406 */     GIR_EraseRootFromParent_Done,
     /* 1580407 */   // Label 21892: @1580407
     /* 1580407 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1580489), // Rule ID 4108 //
     /* 1580412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580443 */     // MIs[0] passthru
     /* 1580443 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580456 */     // MIs[0] policy
     /* 1580456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580488 */     // GIR_Coverage, 4108,
     /* 1580488 */     GIR_EraseRootFromParent_Done,
     /* 1580489 */   // Label 21893: @1580489
     /* 1580489 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1580571), // Rule ID 4109 //
     /* 1580494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580525 */     // MIs[0] passthru
     /* 1580525 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580538 */     // MIs[0] policy
     /* 1580538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580570 */     // GIR_Coverage, 4109,
     /* 1580570 */     GIR_EraseRootFromParent_Done,
     /* 1580571 */   // Label 21894: @1580571
     /* 1580571 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1580653), // Rule ID 4118 //
     /* 1580576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580607 */     // MIs[0] passthru
     /* 1580607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580620 */     // MIs[0] policy
     /* 1580620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580630 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580652 */     // GIR_Coverage, 4118,
     /* 1580652 */     GIR_EraseRootFromParent_Done,
     /* 1580653 */   // Label 21895: @1580653
     /* 1580653 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1580735), // Rule ID 4119 //
     /* 1580658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580689 */     // MIs[0] passthru
     /* 1580689 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580702 */     // MIs[0] policy
     /* 1580702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580734 */     // GIR_Coverage, 4119,
     /* 1580734 */     GIR_EraseRootFromParent_Done,
     /* 1580735 */   // Label 21896: @1580735
     /* 1580735 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1580817), // Rule ID 4128 //
     /* 1580740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580771 */     // MIs[0] passthru
     /* 1580771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580784 */     // MIs[0] policy
     /* 1580784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580816 */     // GIR_Coverage, 4128,
     /* 1580816 */     GIR_EraseRootFromParent_Done,
     /* 1580817 */   // Label 21897: @1580817
     /* 1580817 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1580899), // Rule ID 4129 //
     /* 1580822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580853 */     // MIs[0] passthru
     /* 1580853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580866 */     // MIs[0] policy
     /* 1580866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580898 */     // GIR_Coverage, 4129,
     /* 1580898 */     GIR_EraseRootFromParent_Done,
     /* 1580899 */   // Label 21898: @1580899
     /* 1580899 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1580981), // Rule ID 4138 //
     /* 1580904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580935 */     // MIs[0] passthru
     /* 1580935 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580948 */     // MIs[0] policy
     /* 1580948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580980 */     // GIR_Coverage, 4138,
     /* 1580980 */     GIR_EraseRootFromParent_Done,
     /* 1580981 */   // Label 21899: @1580981
     /* 1580981 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1581063), // Rule ID 4139 //
     /* 1580986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1581003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581017 */     // MIs[0] passthru
     /* 1581017 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581030 */     // MIs[0] policy
     /* 1581030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581062 */     // GIR_Coverage, 4139,
     /* 1581062 */     GIR_EraseRootFromParent_Done,
     /* 1581063 */   // Label 21900: @1581063
     /* 1581063 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1581145), // Rule ID 4148 //
     /* 1581068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581099 */     // MIs[0] passthru
     /* 1581099 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581112 */     // MIs[0] policy
     /* 1581112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581144 */     // GIR_Coverage, 4148,
     /* 1581144 */     GIR_EraseRootFromParent_Done,
     /* 1581145 */   // Label 21901: @1581145
     /* 1581145 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1581227), // Rule ID 4149 //
     /* 1581150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581181 */     // MIs[0] passthru
     /* 1581181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581194 */     // MIs[0] policy
     /* 1581194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581226 */     // GIR_Coverage, 4149,
     /* 1581226 */     GIR_EraseRootFromParent_Done,
     /* 1581227 */   // Label 21902: @1581227
     /* 1581227 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1581309), // Rule ID 4158 //
     /* 1581232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581263 */     // MIs[0] passthru
     /* 1581263 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581276 */     // MIs[0] policy
     /* 1581276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581308 */     // GIR_Coverage, 4158,
     /* 1581308 */     GIR_EraseRootFromParent_Done,
     /* 1581309 */   // Label 21903: @1581309
     /* 1581309 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1581391), // Rule ID 4159 //
     /* 1581314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581345 */     // MIs[0] passthru
     /* 1581345 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581358 */     // MIs[0] policy
     /* 1581358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581390 */     // GIR_Coverage, 4159,
     /* 1581390 */     GIR_EraseRootFromParent_Done,
     /* 1581391 */   // Label 21904: @1581391
     /* 1581391 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1581473), // Rule ID 4168 //
     /* 1581396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581427 */     // MIs[0] passthru
     /* 1581427 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581440 */     // MIs[0] policy
     /* 1581440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581472 */     // GIR_Coverage, 4168,
     /* 1581472 */     GIR_EraseRootFromParent_Done,
     /* 1581473 */   // Label 21905: @1581473
     /* 1581473 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1581555), // Rule ID 4169 //
     /* 1581478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581509 */     // MIs[0] passthru
     /* 1581509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581522 */     // MIs[0] policy
     /* 1581522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581554 */     // GIR_Coverage, 4169,
     /* 1581554 */     GIR_EraseRootFromParent_Done,
     /* 1581555 */   // Label 21906: @1581555
     /* 1581555 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1581637), // Rule ID 4178 //
     /* 1581560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581591 */     // MIs[0] passthru
     /* 1581591 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581604 */     // MIs[0] policy
     /* 1581604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581636 */     // GIR_Coverage, 4178,
     /* 1581636 */     GIR_EraseRootFromParent_Done,
     /* 1581637 */   // Label 21907: @1581637
     /* 1581637 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1581719), // Rule ID 4179 //
     /* 1581642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581673 */     // MIs[0] passthru
     /* 1581673 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581686 */     // MIs[0] policy
     /* 1581686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581718 */     // GIR_Coverage, 4179,
     /* 1581718 */     GIR_EraseRootFromParent_Done,
     /* 1581719 */   // Label 21908: @1581719
     /* 1581719 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1581801), // Rule ID 4188 //
     /* 1581724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581755 */     // MIs[0] passthru
     /* 1581755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581768 */     // MIs[0] policy
     /* 1581768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581800 */     // GIR_Coverage, 4188,
     /* 1581800 */     GIR_EraseRootFromParent_Done,
     /* 1581801 */   // Label 21909: @1581801
     /* 1581801 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1581883), // Rule ID 4189 //
     /* 1581806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581837 */     // MIs[0] passthru
     /* 1581837 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581850 */     // MIs[0] policy
     /* 1581850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581882 */     // GIR_Coverage, 4189,
     /* 1581882 */     GIR_EraseRootFromParent_Done,
     /* 1581883 */   // Label 21910: @1581883
     /* 1581883 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1581965), // Rule ID 4198 //
     /* 1581888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581919 */     // MIs[0] passthru
     /* 1581919 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581932 */     // MIs[0] policy
     /* 1581932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581964 */     // GIR_Coverage, 4198,
     /* 1581964 */     GIR_EraseRootFromParent_Done,
     /* 1581965 */   // Label 21911: @1581965
     /* 1581965 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1582047), // Rule ID 4199 //
     /* 1581970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582001 */     // MIs[0] passthru
     /* 1582001 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582014 */     // MIs[0] policy
     /* 1582014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1582027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582046 */     // GIR_Coverage, 4199,
     /* 1582046 */     GIR_EraseRootFromParent_Done,
     /* 1582047 */   // Label 21912: @1582047
     /* 1582047 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1582129), // Rule ID 4208 //
     /* 1582052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1582055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582083 */     // MIs[0] passthru
     /* 1582083 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582096 */     // MIs[0] policy
     /* 1582096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1582109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582128 */     // GIR_Coverage, 4208,
     /* 1582128 */     GIR_EraseRootFromParent_Done,
     /* 1582129 */   // Label 21913: @1582129
     /* 1582129 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1582211), // Rule ID 4209 //
     /* 1582134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1582137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582165 */     // MIs[0] passthru
     /* 1582165 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582178 */     // MIs[0] policy
     /* 1582178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1582191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582210 */     // GIR_Coverage, 4209,
     /* 1582210 */     GIR_EraseRootFromParent_Done,
     /* 1582211 */   // Label 21914: @1582211
     /* 1582211 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1582293), // Rule ID 4278 //
     /* 1582216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582247 */     // MIs[0] passthru
     /* 1582247 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582260 */     // MIs[0] policy
     /* 1582260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1582273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582292 */     // GIR_Coverage, 4278,
     /* 1582292 */     GIR_EraseRootFromParent_Done,
     /* 1582293 */   // Label 21915: @1582293
     /* 1582293 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1582375), // Rule ID 4279 //
     /* 1582298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582329 */     // MIs[0] passthru
     /* 1582329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582342 */     // MIs[0] policy
     /* 1582342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1582355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582374 */     // GIR_Coverage, 4279,
     /* 1582374 */     GIR_EraseRootFromParent_Done,
     /* 1582375 */   // Label 21916: @1582375
     /* 1582375 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1582457), // Rule ID 4288 //
     /* 1582380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582411 */     // MIs[0] passthru
     /* 1582411 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582424 */     // MIs[0] policy
     /* 1582424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582456 */     // GIR_Coverage, 4288,
     /* 1582456 */     GIR_EraseRootFromParent_Done,
     /* 1582457 */   // Label 21917: @1582457
     /* 1582457 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1582539), // Rule ID 4289 //
     /* 1582462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582493 */     // MIs[0] passthru
     /* 1582493 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582506 */     // MIs[0] policy
     /* 1582506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582516 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582538 */     // GIR_Coverage, 4289,
     /* 1582538 */     GIR_EraseRootFromParent_Done,
     /* 1582539 */   // Label 21918: @1582539
     /* 1582539 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1582621), // Rule ID 4298 //
     /* 1582544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582575 */     // MIs[0] passthru
     /* 1582575 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582588 */     // MIs[0] policy
     /* 1582588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582620 */     // GIR_Coverage, 4298,
     /* 1582620 */     GIR_EraseRootFromParent_Done,
     /* 1582621 */   // Label 21919: @1582621
     /* 1582621 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1582703), // Rule ID 4299 //
     /* 1582626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582657 */     // MIs[0] passthru
     /* 1582657 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582670 */     // MIs[0] policy
     /* 1582670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582702 */     // GIR_Coverage, 4299,
     /* 1582702 */     GIR_EraseRootFromParent_Done,
     /* 1582703 */   // Label 21920: @1582703
     /* 1582703 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1582785), // Rule ID 4308 //
     /* 1582708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582739 */     // MIs[0] passthru
     /* 1582739 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582752 */     // MIs[0] policy
     /* 1582752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582784 */     // GIR_Coverage, 4308,
     /* 1582784 */     GIR_EraseRootFromParent_Done,
     /* 1582785 */   // Label 21921: @1582785
     /* 1582785 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1582867), // Rule ID 4309 //
     /* 1582790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582821 */     // MIs[0] passthru
     /* 1582821 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582834 */     // MIs[0] policy
     /* 1582834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582866 */     // GIR_Coverage, 4309,
     /* 1582866 */     GIR_EraseRootFromParent_Done,
     /* 1582867 */   // Label 21922: @1582867
     /* 1582867 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1582949), // Rule ID 4318 //
     /* 1582872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582903 */     // MIs[0] passthru
     /* 1582903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582916 */     // MIs[0] policy
     /* 1582916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582948 */     // GIR_Coverage, 4318,
     /* 1582948 */     GIR_EraseRootFromParent_Done,
     /* 1582949 */   // Label 21923: @1582949
     /* 1582949 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1583031), // Rule ID 4319 //
     /* 1582954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582985 */     // MIs[0] passthru
     /* 1582985 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582998 */     // MIs[0] policy
     /* 1582998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583030 */     // GIR_Coverage, 4319,
     /* 1583030 */     GIR_EraseRootFromParent_Done,
     /* 1583031 */   // Label 21924: @1583031
     /* 1583031 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1583113), // Rule ID 4328 //
     /* 1583036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1583047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1583050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1583053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1583056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583067 */     // MIs[0] passthru
     /* 1583067 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583080 */     // MIs[0] policy
     /* 1583080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583112 */     // GIR_Coverage, 4328,
     /* 1583112 */     GIR_EraseRootFromParent_Done,
     /* 1583113 */   // Label 21925: @1583113
     /* 1583113 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1583195), // Rule ID 4329 //
     /* 1583118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1583129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1583132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1583135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1583138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583149 */     // MIs[0] passthru
     /* 1583149 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583162 */     // MIs[0] policy
     /* 1583162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583194 */     // GIR_Coverage, 4329,
     /* 1583194 */     GIR_EraseRootFromParent_Done,
     /* 1583195 */   // Label 21926: @1583195
     /* 1583195 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1583277), // Rule ID 4338 //
     /* 1583200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583231 */     // MIs[0] passthru
     /* 1583231 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583244 */     // MIs[0] policy
     /* 1583244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1583257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583276 */     // GIR_Coverage, 4338,
     /* 1583276 */     GIR_EraseRootFromParent_Done,
     /* 1583277 */   // Label 21927: @1583277
     /* 1583277 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1583359), // Rule ID 4339 //
     /* 1583282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583313 */     // MIs[0] passthru
     /* 1583313 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583326 */     // MIs[0] policy
     /* 1583326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1583339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583358 */     // GIR_Coverage, 4339,
     /* 1583358 */     GIR_EraseRootFromParent_Done,
     /* 1583359 */   // Label 21928: @1583359
     /* 1583359 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1583441), // Rule ID 4348 //
     /* 1583364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583395 */     // MIs[0] passthru
     /* 1583395 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583408 */     // MIs[0] policy
     /* 1583408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583440 */     // GIR_Coverage, 4348,
     /* 1583440 */     GIR_EraseRootFromParent_Done,
     /* 1583441 */   // Label 21929: @1583441
     /* 1583441 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1583523), // Rule ID 4349 //
     /* 1583446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583477 */     // MIs[0] passthru
     /* 1583477 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583490 */     // MIs[0] policy
     /* 1583490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583522 */     // GIR_Coverage, 4349,
     /* 1583522 */     GIR_EraseRootFromParent_Done,
     /* 1583523 */   // Label 21930: @1583523
     /* 1583523 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1583605), // Rule ID 4358 //
     /* 1583528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583559 */     // MIs[0] passthru
     /* 1583559 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583572 */     // MIs[0] policy
     /* 1583572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583604 */     // GIR_Coverage, 4358,
     /* 1583604 */     GIR_EraseRootFromParent_Done,
     /* 1583605 */   // Label 21931: @1583605
     /* 1583605 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1583687), // Rule ID 4359 //
     /* 1583610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583641 */     // MIs[0] passthru
     /* 1583641 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583654 */     // MIs[0] policy
     /* 1583654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583686 */     // GIR_Coverage, 4359,
     /* 1583686 */     GIR_EraseRootFromParent_Done,
     /* 1583687 */   // Label 21932: @1583687
     /* 1583687 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1583769), // Rule ID 4368 //
     /* 1583692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583723 */     // MIs[0] passthru
     /* 1583723 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583736 */     // MIs[0] policy
     /* 1583736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583768 */     // GIR_Coverage, 4368,
     /* 1583768 */     GIR_EraseRootFromParent_Done,
     /* 1583769 */   // Label 21933: @1583769
     /* 1583769 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1583851), // Rule ID 4369 //
     /* 1583774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583805 */     // MIs[0] passthru
     /* 1583805 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583818 */     // MIs[0] policy
     /* 1583818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583850 */     // GIR_Coverage, 4369,
     /* 1583850 */     GIR_EraseRootFromParent_Done,
     /* 1583851 */   // Label 21934: @1583851
     /* 1583851 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1583933), // Rule ID 4378 //
     /* 1583856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583887 */     // MIs[0] passthru
     /* 1583887 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583900 */     // MIs[0] policy
     /* 1583900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583932 */     // GIR_Coverage, 4378,
     /* 1583932 */     GIR_EraseRootFromParent_Done,
     /* 1583933 */   // Label 21935: @1583933
     /* 1583933 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1584015), // Rule ID 4379 //
     /* 1583938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583969 */     // MIs[0] passthru
     /* 1583969 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583982 */     // MIs[0] policy
     /* 1583982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584014 */     // GIR_Coverage, 4379,
     /* 1584014 */     GIR_EraseRootFromParent_Done,
     /* 1584015 */   // Label 21936: @1584015
     /* 1584015 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1584097), // Rule ID 4388 //
     /* 1584020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584051 */     // MIs[0] passthru
     /* 1584051 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584064 */     // MIs[0] policy
     /* 1584064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1584077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584096 */     // GIR_Coverage, 4388,
     /* 1584096 */     GIR_EraseRootFromParent_Done,
     /* 1584097 */   // Label 21937: @1584097
     /* 1584097 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1584179), // Rule ID 4389 //
     /* 1584102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584133 */     // MIs[0] passthru
     /* 1584133 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584146 */     // MIs[0] policy
     /* 1584146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1584159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584178 */     // GIR_Coverage, 4389,
     /* 1584178 */     GIR_EraseRootFromParent_Done,
     /* 1584179 */   // Label 21938: @1584179
     /* 1584179 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1584261), // Rule ID 4398 //
     /* 1584184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1584195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1584198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584215 */     // MIs[0] passthru
     /* 1584215 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584228 */     // MIs[0] policy
     /* 1584228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1584241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584260 */     // GIR_Coverage, 4398,
     /* 1584260 */     GIR_EraseRootFromParent_Done,
     /* 1584261 */   // Label 21939: @1584261
     /* 1584261 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1584343), // Rule ID 4399 //
     /* 1584266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1584277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1584280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584297 */     // MIs[0] passthru
     /* 1584297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584310 */     // MIs[0] policy
     /* 1584310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1584323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584342 */     // GIR_Coverage, 4399,
     /* 1584342 */     GIR_EraseRootFromParent_Done,
     /* 1584343 */   // Label 21940: @1584343
     /* 1584343 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1584425), // Rule ID 4408 //
     /* 1584348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584379 */     // MIs[0] passthru
     /* 1584379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584392 */     // MIs[0] policy
     /* 1584392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584424 */     // GIR_Coverage, 4408,
     /* 1584424 */     GIR_EraseRootFromParent_Done,
     /* 1584425 */   // Label 21941: @1584425
     /* 1584425 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1584507), // Rule ID 4409 //
     /* 1584430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584461 */     // MIs[0] passthru
     /* 1584461 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584474 */     // MIs[0] policy
     /* 1584474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584506 */     // GIR_Coverage, 4409,
     /* 1584506 */     GIR_EraseRootFromParent_Done,
     /* 1584507 */   // Label 21942: @1584507
     /* 1584507 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1584589), // Rule ID 4418 //
     /* 1584512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584543 */     // MIs[0] passthru
     /* 1584543 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584556 */     // MIs[0] policy
     /* 1584556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584588 */     // GIR_Coverage, 4418,
     /* 1584588 */     GIR_EraseRootFromParent_Done,
     /* 1584589 */   // Label 21943: @1584589
     /* 1584589 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1584671), // Rule ID 4419 //
     /* 1584594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584625 */     // MIs[0] passthru
     /* 1584625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584638 */     // MIs[0] policy
     /* 1584638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584648 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584670 */     // GIR_Coverage, 4419,
     /* 1584670 */     GIR_EraseRootFromParent_Done,
     /* 1584671 */   // Label 21944: @1584671
     /* 1584671 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1584753), // Rule ID 4488 //
     /* 1584676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584707 */     // MIs[0] passthru
     /* 1584707 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584720 */     // MIs[0] policy
     /* 1584720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584752 */     // GIR_Coverage, 4488,
     /* 1584752 */     GIR_EraseRootFromParent_Done,
     /* 1584753 */   // Label 21945: @1584753
     /* 1584753 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1584835), // Rule ID 4489 //
     /* 1584758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584789 */     // MIs[0] passthru
     /* 1584789 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584802 */     // MIs[0] policy
     /* 1584802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584834 */     // GIR_Coverage, 4489,
     /* 1584834 */     GIR_EraseRootFromParent_Done,
     /* 1584835 */   // Label 21946: @1584835
     /* 1584835 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1584917), // Rule ID 4498 //
     /* 1584840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584871 */     // MIs[0] passthru
     /* 1584871 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584884 */     // MIs[0] policy
     /* 1584884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584916 */     // GIR_Coverage, 4498,
     /* 1584916 */     GIR_EraseRootFromParent_Done,
     /* 1584917 */   // Label 21947: @1584917
     /* 1584917 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1584999), // Rule ID 4499 //
     /* 1584922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584953 */     // MIs[0] passthru
     /* 1584953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584966 */     // MIs[0] policy
     /* 1584966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584998 */     // GIR_Coverage, 4499,
     /* 1584998 */     GIR_EraseRootFromParent_Done,
     /* 1584999 */   // Label 21948: @1584999
     /* 1584999 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1585081), // Rule ID 4508 //
     /* 1585004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1585015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1585018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1585021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585035 */     // MIs[0] passthru
     /* 1585035 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585048 */     // MIs[0] policy
     /* 1585048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585080 */     // GIR_Coverage, 4508,
     /* 1585080 */     GIR_EraseRootFromParent_Done,
     /* 1585081 */   // Label 21949: @1585081
     /* 1585081 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1585163), // Rule ID 4509 //
     /* 1585086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1585097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1585100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1585103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585117 */     // MIs[0] passthru
     /* 1585117 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585130 */     // MIs[0] policy
     /* 1585130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585162 */     // GIR_Coverage, 4509,
     /* 1585162 */     GIR_EraseRootFromParent_Done,
     /* 1585163 */   // Label 21950: @1585163
     /* 1585163 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1585245), // Rule ID 4518 //
     /* 1585168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1585185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585199 */     // MIs[0] passthru
     /* 1585199 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585212 */     // MIs[0] policy
     /* 1585212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585244 */     // GIR_Coverage, 4518,
     /* 1585244 */     GIR_EraseRootFromParent_Done,
     /* 1585245 */   // Label 21951: @1585245
     /* 1585245 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1585327), // Rule ID 4519 //
     /* 1585250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1585267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585281 */     // MIs[0] passthru
     /* 1585281 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585294 */     // MIs[0] policy
     /* 1585294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585326 */     // GIR_Coverage, 4519,
     /* 1585326 */     GIR_EraseRootFromParent_Done,
     /* 1585327 */   // Label 21952: @1585327
     /* 1585327 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1585409), // Rule ID 4528 //
     /* 1585332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585363 */     // MIs[0] passthru
     /* 1585363 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585376 */     // MIs[0] policy
     /* 1585376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585408 */     // GIR_Coverage, 4528,
     /* 1585408 */     GIR_EraseRootFromParent_Done,
     /* 1585409 */   // Label 21953: @1585409
     /* 1585409 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1585491), // Rule ID 4529 //
     /* 1585414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585445 */     // MIs[0] passthru
     /* 1585445 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585458 */     // MIs[0] policy
     /* 1585458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585490 */     // GIR_Coverage, 4529,
     /* 1585490 */     GIR_EraseRootFromParent_Done,
     /* 1585491 */   // Label 21954: @1585491
     /* 1585491 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1585573), // Rule ID 4538 //
     /* 1585496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585527 */     // MIs[0] passthru
     /* 1585527 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585540 */     // MIs[0] policy
     /* 1585540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585572 */     // GIR_Coverage, 4538,
     /* 1585572 */     GIR_EraseRootFromParent_Done,
     /* 1585573 */   // Label 21955: @1585573
     /* 1585573 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1585655), // Rule ID 4539 //
     /* 1585578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585609 */     // MIs[0] passthru
     /* 1585609 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585622 */     // MIs[0] policy
     /* 1585622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585654 */     // GIR_Coverage, 4539,
     /* 1585654 */     GIR_EraseRootFromParent_Done,
     /* 1585655 */   // Label 21956: @1585655
     /* 1585655 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1585737), // Rule ID 4548 //
     /* 1585660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585691 */     // MIs[0] passthru
     /* 1585691 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585704 */     // MIs[0] policy
     /* 1585704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585736 */     // GIR_Coverage, 4548,
     /* 1585736 */     GIR_EraseRootFromParent_Done,
     /* 1585737 */   // Label 21957: @1585737
     /* 1585737 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1585819), // Rule ID 4549 //
     /* 1585742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585773 */     // MIs[0] passthru
     /* 1585773 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585786 */     // MIs[0] policy
     /* 1585786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585818 */     // GIR_Coverage, 4549,
     /* 1585818 */     GIR_EraseRootFromParent_Done,
     /* 1585819 */   // Label 21958: @1585819
     /* 1585819 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1585901), // Rule ID 4558 //
     /* 1585824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585855 */     // MIs[0] passthru
     /* 1585855 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585868 */     // MIs[0] policy
     /* 1585868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585900 */     // GIR_Coverage, 4558,
     /* 1585900 */     GIR_EraseRootFromParent_Done,
     /* 1585901 */   // Label 21959: @1585901
     /* 1585901 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1585983), // Rule ID 4559 //
     /* 1585906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585937 */     // MIs[0] passthru
     /* 1585937 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585950 */     // MIs[0] policy
     /* 1585950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585982 */     // GIR_Coverage, 4559,
     /* 1585982 */     GIR_EraseRootFromParent_Done,
     /* 1585983 */   // Label 21960: @1585983
     /* 1585983 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1586065), // Rule ID 4568 //
     /* 1585988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1586002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1586005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586019 */     // MIs[0] passthru
     /* 1586019 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586032 */     // MIs[0] policy
     /* 1586032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586064 */     // GIR_Coverage, 4568,
     /* 1586064 */     GIR_EraseRootFromParent_Done,
     /* 1586065 */   // Label 21961: @1586065
     /* 1586065 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1586147), // Rule ID 4569 //
     /* 1586070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1586081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1586084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1586087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586101 */     // MIs[0] passthru
     /* 1586101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586114 */     // MIs[0] policy
     /* 1586114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586146 */     // GIR_Coverage, 4569,
     /* 1586146 */     GIR_EraseRootFromParent_Done,
     /* 1586147 */   // Label 21962: @1586147
     /* 1586147 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1586229), // Rule ID 4578 //
     /* 1586152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1586169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586183 */     // MIs[0] passthru
     /* 1586183 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586196 */     // MIs[0] policy
     /* 1586196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586228 */     // GIR_Coverage, 4578,
     /* 1586228 */     GIR_EraseRootFromParent_Done,
     /* 1586229 */   // Label 21963: @1586229
     /* 1586229 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1586311), // Rule ID 4579 //
     /* 1586234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1586251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586265 */     // MIs[0] passthru
     /* 1586265 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586278 */     // MIs[0] policy
     /* 1586278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586288 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586310 */     // GIR_Coverage, 4579,
     /* 1586310 */     GIR_EraseRootFromParent_Done,
     /* 1586311 */   // Label 21964: @1586311
     /* 1586311 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1586393), // Rule ID 4588 //
     /* 1586316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586347 */     // MIs[0] passthru
     /* 1586347 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586360 */     // MIs[0] policy
     /* 1586360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586392 */     // GIR_Coverage, 4588,
     /* 1586392 */     GIR_EraseRootFromParent_Done,
     /* 1586393 */   // Label 21965: @1586393
     /* 1586393 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1586475), // Rule ID 4589 //
     /* 1586398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586429 */     // MIs[0] passthru
     /* 1586429 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586442 */     // MIs[0] policy
     /* 1586442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586474 */     // GIR_Coverage, 4589,
     /* 1586474 */     GIR_EraseRootFromParent_Done,
     /* 1586475 */   // Label 21966: @1586475
     /* 1586475 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1586557), // Rule ID 4598 //
     /* 1586480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586511 */     // MIs[0] passthru
     /* 1586511 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586524 */     // MIs[0] policy
     /* 1586524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586556 */     // GIR_Coverage, 4598,
     /* 1586556 */     GIR_EraseRootFromParent_Done,
     /* 1586557 */   // Label 21967: @1586557
     /* 1586557 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1586639), // Rule ID 4599 //
     /* 1586562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586593 */     // MIs[0] passthru
     /* 1586593 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586606 */     // MIs[0] policy
     /* 1586606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586638 */     // GIR_Coverage, 4599,
     /* 1586638 */     GIR_EraseRootFromParent_Done,
     /* 1586639 */   // Label 21968: @1586639
     /* 1586639 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1586721), // Rule ID 4608 //
     /* 1586644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586675 */     // MIs[0] passthru
     /* 1586675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586688 */     // MIs[0] policy
     /* 1586688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586720 */     // GIR_Coverage, 4608,
     /* 1586720 */     GIR_EraseRootFromParent_Done,
     /* 1586721 */   // Label 21969: @1586721
     /* 1586721 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1586803), // Rule ID 4609 //
     /* 1586726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586757 */     // MIs[0] passthru
     /* 1586757 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586770 */     // MIs[0] policy
     /* 1586770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586802 */     // GIR_Coverage, 4609,
     /* 1586802 */     GIR_EraseRootFromParent_Done,
     /* 1586803 */   // Label 21970: @1586803
     /* 1586803 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1586885), // Rule ID 4618 //
     /* 1586808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586839 */     // MIs[0] passthru
     /* 1586839 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586852 */     // MIs[0] policy
     /* 1586852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586884 */     // GIR_Coverage, 4618,
     /* 1586884 */     GIR_EraseRootFromParent_Done,
     /* 1586885 */   // Label 21971: @1586885
     /* 1586885 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1586967), // Rule ID 4619 //
     /* 1586890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586921 */     // MIs[0] passthru
     /* 1586921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586934 */     // MIs[0] policy
     /* 1586934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586966 */     // GIR_Coverage, 4619,
     /* 1586966 */     GIR_EraseRootFromParent_Done,
     /* 1586967 */   // Label 21972: @1586967
     /* 1586967 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1587049), // Rule ID 4628 //
     /* 1586972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587003 */     // MIs[0] passthru
     /* 1587003 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587016 */     // MIs[0] policy
     /* 1587016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1587029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587048 */     // GIR_Coverage, 4628,
     /* 1587048 */     GIR_EraseRootFromParent_Done,
     /* 1587049 */   // Label 21973: @1587049
     /* 1587049 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1587131), // Rule ID 4629 //
     /* 1587054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1587057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1587062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1587065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1587068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1587071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587085 */     // MIs[0] passthru
     /* 1587085 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587098 */     // MIs[0] policy
     /* 1587098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1587111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587130 */     // GIR_Coverage, 4629,
     /* 1587130 */     GIR_EraseRootFromParent_Done,
     /* 1587131 */   // Label 21974: @1587131
     /* 1587131 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1587213), // Rule ID 4698 //
     /* 1587136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587167 */     // MIs[0] passthru
     /* 1587167 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587180 */     // MIs[0] policy
     /* 1587180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1587193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587212 */     // GIR_Coverage, 4698,
     /* 1587212 */     GIR_EraseRootFromParent_Done,
     /* 1587213 */   // Label 21975: @1587213
     /* 1587213 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1587295), // Rule ID 4699 //
     /* 1587218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587249 */     // MIs[0] passthru
     /* 1587249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587262 */     // MIs[0] policy
     /* 1587262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1587275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587294 */     // GIR_Coverage, 4699,
     /* 1587294 */     GIR_EraseRootFromParent_Done,
     /* 1587295 */   // Label 21976: @1587295
     /* 1587295 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1587377), // Rule ID 4708 //
     /* 1587300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587331 */     // MIs[0] passthru
     /* 1587331 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587344 */     // MIs[0] policy
     /* 1587344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587376 */     // GIR_Coverage, 4708,
     /* 1587376 */     GIR_EraseRootFromParent_Done,
     /* 1587377 */   // Label 21977: @1587377
     /* 1587377 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1587459), // Rule ID 4709 //
     /* 1587382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587413 */     // MIs[0] passthru
     /* 1587413 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587426 */     // MIs[0] policy
     /* 1587426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587458 */     // GIR_Coverage, 4709,
     /* 1587458 */     GIR_EraseRootFromParent_Done,
     /* 1587459 */   // Label 21978: @1587459
     /* 1587459 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1587541), // Rule ID 4718 //
     /* 1587464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587495 */     // MIs[0] passthru
     /* 1587495 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587508 */     // MIs[0] policy
     /* 1587508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587540 */     // GIR_Coverage, 4718,
     /* 1587540 */     GIR_EraseRootFromParent_Done,
     /* 1587541 */   // Label 21979: @1587541
     /* 1587541 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1587623), // Rule ID 4719 //
     /* 1587546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587577 */     // MIs[0] passthru
     /* 1587577 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587590 */     // MIs[0] policy
     /* 1587590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587622 */     // GIR_Coverage, 4719,
     /* 1587622 */     GIR_EraseRootFromParent_Done,
     /* 1587623 */   // Label 21980: @1587623
     /* 1587623 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1587705), // Rule ID 4728 //
     /* 1587628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587659 */     // MIs[0] passthru
     /* 1587659 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587672 */     // MIs[0] policy
     /* 1587672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587704 */     // GIR_Coverage, 4728,
     /* 1587704 */     GIR_EraseRootFromParent_Done,
     /* 1587705 */   // Label 21981: @1587705
     /* 1587705 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1587787), // Rule ID 4729 //
     /* 1587710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587741 */     // MIs[0] passthru
     /* 1587741 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587754 */     // MIs[0] policy
     /* 1587754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587786 */     // GIR_Coverage, 4729,
     /* 1587786 */     GIR_EraseRootFromParent_Done,
     /* 1587787 */   // Label 21982: @1587787
     /* 1587787 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1587869), // Rule ID 4738 //
     /* 1587792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587823 */     // MIs[0] passthru
     /* 1587823 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587836 */     // MIs[0] policy
     /* 1587836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587868 */     // GIR_Coverage, 4738,
     /* 1587868 */     GIR_EraseRootFromParent_Done,
     /* 1587869 */   // Label 21983: @1587869
     /* 1587869 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1587951), // Rule ID 4739 //
     /* 1587874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587905 */     // MIs[0] passthru
     /* 1587905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587918 */     // MIs[0] policy
     /* 1587918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587950 */     // GIR_Coverage, 4739,
     /* 1587950 */     GIR_EraseRootFromParent_Done,
     /* 1587951 */   // Label 21984: @1587951
     /* 1587951 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1588033), // Rule ID 4748 //
     /* 1587956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587987 */     // MIs[0] passthru
     /* 1587987 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588000 */     // MIs[0] policy
     /* 1588000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588010 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588032 */     // GIR_Coverage, 4748,
     /* 1588032 */     GIR_EraseRootFromParent_Done,
     /* 1588033 */   // Label 21985: @1588033
     /* 1588033 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1588115), // Rule ID 4749 //
     /* 1588038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1588049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1588052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588069 */     // MIs[0] passthru
     /* 1588069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588082 */     // MIs[0] policy
     /* 1588082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588114 */     // GIR_Coverage, 4749,
     /* 1588114 */     GIR_EraseRootFromParent_Done,
     /* 1588115 */   // Label 21986: @1588115
     /* 1588115 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1588197), // Rule ID 4758 //
     /* 1588120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1588137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588151 */     // MIs[0] passthru
     /* 1588151 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588164 */     // MIs[0] policy
     /* 1588164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1588177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588196 */     // GIR_Coverage, 4758,
     /* 1588196 */     GIR_EraseRootFromParent_Done,
     /* 1588197 */   // Label 21987: @1588197
     /* 1588197 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1588279), // Rule ID 4759 //
     /* 1588202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1588219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588233 */     // MIs[0] passthru
     /* 1588233 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588246 */     // MIs[0] policy
     /* 1588246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1588259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588278 */     // GIR_Coverage, 4759,
     /* 1588278 */     GIR_EraseRootFromParent_Done,
     /* 1588279 */   // Label 21988: @1588279
     /* 1588279 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1588361), // Rule ID 4768 //
     /* 1588284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588315 */     // MIs[0] passthru
     /* 1588315 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588328 */     // MIs[0] policy
     /* 1588328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588360 */     // GIR_Coverage, 4768,
     /* 1588360 */     GIR_EraseRootFromParent_Done,
     /* 1588361 */   // Label 21989: @1588361
     /* 1588361 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1588443), // Rule ID 4769 //
     /* 1588366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588397 */     // MIs[0] passthru
     /* 1588397 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588410 */     // MIs[0] policy
     /* 1588410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588442 */     // GIR_Coverage, 4769,
     /* 1588442 */     GIR_EraseRootFromParent_Done,
     /* 1588443 */   // Label 21990: @1588443
     /* 1588443 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1588525), // Rule ID 4778 //
     /* 1588448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588479 */     // MIs[0] passthru
     /* 1588479 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588492 */     // MIs[0] policy
     /* 1588492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588524 */     // GIR_Coverage, 4778,
     /* 1588524 */     GIR_EraseRootFromParent_Done,
     /* 1588525 */   // Label 21991: @1588525
     /* 1588525 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1588607), // Rule ID 4779 //
     /* 1588530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588561 */     // MIs[0] passthru
     /* 1588561 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588574 */     // MIs[0] policy
     /* 1588574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588606 */     // GIR_Coverage, 4779,
     /* 1588606 */     GIR_EraseRootFromParent_Done,
     /* 1588607 */   // Label 21992: @1588607
     /* 1588607 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1588689), // Rule ID 4788 //
     /* 1588612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588643 */     // MIs[0] passthru
     /* 1588643 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588656 */     // MIs[0] policy
     /* 1588656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588688 */     // GIR_Coverage, 4788,
     /* 1588688 */     GIR_EraseRootFromParent_Done,
     /* 1588689 */   // Label 21993: @1588689
     /* 1588689 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1588771), // Rule ID 4789 //
     /* 1588694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588725 */     // MIs[0] passthru
     /* 1588725 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588738 */     // MIs[0] policy
     /* 1588738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588770 */     // GIR_Coverage, 4789,
     /* 1588770 */     GIR_EraseRootFromParent_Done,
     /* 1588771 */   // Label 21994: @1588771
     /* 1588771 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1588853), // Rule ID 4798 //
     /* 1588776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588807 */     // MIs[0] passthru
     /* 1588807 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588820 */     // MIs[0] policy
     /* 1588820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588852 */     // GIR_Coverage, 4798,
     /* 1588852 */     GIR_EraseRootFromParent_Done,
     /* 1588853 */   // Label 21995: @1588853
     /* 1588853 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1588935), // Rule ID 4799 //
     /* 1588858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588889 */     // MIs[0] passthru
     /* 1588889 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588902 */     // MIs[0] policy
     /* 1588902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588934 */     // GIR_Coverage, 4799,
     /* 1588934 */     GIR_EraseRootFromParent_Done,
     /* 1588935 */   // Label 21996: @1588935
     /* 1588935 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1589017), // Rule ID 4808 //
     /* 1588940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588971 */     // MIs[0] passthru
     /* 1588971 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588984 */     // MIs[0] policy
     /* 1588984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589016 */     // GIR_Coverage, 4808,
     /* 1589016 */     GIR_EraseRootFromParent_Done,
     /* 1589017 */   // Label 21997: @1589017
     /* 1589017 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1589099), // Rule ID 4809 //
     /* 1589022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1589033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1589036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1589039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589053 */     // MIs[0] passthru
     /* 1589053 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589066 */     // MIs[0] policy
     /* 1589066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1589079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589098 */     // GIR_Coverage, 4809,
     /* 1589098 */     GIR_EraseRootFromParent_Done,
     /* 1589099 */   // Label 21998: @1589099
     /* 1589099 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1589181), // Rule ID 4818 //
     /* 1589104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1589115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1589118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1589121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589135 */     // MIs[0] passthru
     /* 1589135 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589148 */     // MIs[0] policy
     /* 1589148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1589161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589180 */     // GIR_Coverage, 4818,
     /* 1589180 */     GIR_EraseRootFromParent_Done,
     /* 1589181 */   // Label 21999: @1589181
     /* 1589181 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1589263), // Rule ID 4819 //
     /* 1589186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1589197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1589200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1589203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589217 */     // MIs[0] passthru
     /* 1589217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589230 */     // MIs[0] policy
     /* 1589230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1589243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589262 */     // GIR_Coverage, 4819,
     /* 1589262 */     GIR_EraseRootFromParent_Done,
     /* 1589263 */   // Label 22000: @1589263
     /* 1589263 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1589345), // Rule ID 4828 //
     /* 1589268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1589279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1589282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589299 */     // MIs[0] passthru
     /* 1589299 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589312 */     // MIs[0] policy
     /* 1589312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1589325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589344 */     // GIR_Coverage, 4828,
     /* 1589344 */     GIR_EraseRootFromParent_Done,
     /* 1589345 */   // Label 22001: @1589345
     /* 1589345 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1589427), // Rule ID 4829 //
     /* 1589350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1589361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1589364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589381 */     // MIs[0] passthru
     /* 1589381 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589394 */     // MIs[0] policy
     /* 1589394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1589407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589426 */     // GIR_Coverage, 4829,
     /* 1589426 */     GIR_EraseRootFromParent_Done,
     /* 1589427 */   // Label 22002: @1589427
     /* 1589427 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1589509), // Rule ID 4838 //
     /* 1589432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1589435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589463 */     // MIs[0] passthru
     /* 1589463 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589476 */     // MIs[0] policy
     /* 1589476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589508 */     // GIR_Coverage, 4838,
     /* 1589508 */     GIR_EraseRootFromParent_Done,
     /* 1589509 */   // Label 22003: @1589509
     /* 1589509 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1589591), // Rule ID 4839 //
     /* 1589514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589545 */     // MIs[0] passthru
     /* 1589545 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589558 */     // MIs[0] policy
     /* 1589558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589590 */     // GIR_Coverage, 4839,
     /* 1589590 */     GIR_EraseRootFromParent_Done,
     /* 1589591 */   // Label 22004: @1589591
     /* 1589591 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1589677), // Rule ID 2726 //
     /* 1589596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589642 */     // MIs[0] policy
     /* 1589642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589676 */     // GIR_Coverage, 2726,
     /* 1589676 */     GIR_EraseRootFromParent_Done,
     /* 1589677 */   // Label 22005: @1589677
     /* 1589677 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1589763), // Rule ID 2727 //
     /* 1589682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589728 */     // MIs[0] policy
     /* 1589728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589762 */     // GIR_Coverage, 2727,
     /* 1589762 */     GIR_EraseRootFromParent_Done,
     /* 1589763 */   // Label 22006: @1589763
     /* 1589763 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1589849), // Rule ID 2764 //
     /* 1589768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589814 */     // MIs[0] policy
     /* 1589814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589848 */     // GIR_Coverage, 2764,
     /* 1589848 */     GIR_EraseRootFromParent_Done,
     /* 1589849 */   // Label 22007: @1589849
     /* 1589849 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1589935), // Rule ID 2765 //
     /* 1589854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589900 */     // MIs[0] policy
     /* 1589900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589934 */     // GIR_Coverage, 2765,
     /* 1589934 */     GIR_EraseRootFromParent_Done,
     /* 1589935 */   // Label 22008: @1589935
     /* 1589935 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1590021), // Rule ID 2778 //
     /* 1589940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589986 */     // MIs[0] policy
     /* 1589986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1589999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1590003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590020 */     // GIR_Coverage, 2778,
     /* 1590020 */     GIR_EraseRootFromParent_Done,
     /* 1590021 */   // Label 22009: @1590021
     /* 1590021 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1590107), // Rule ID 2779 //
     /* 1590026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1590034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590072 */     // MIs[0] policy
     /* 1590072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1590085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1590089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590106 */     // GIR_Coverage, 2779,
     /* 1590106 */     GIR_EraseRootFromParent_Done,
     /* 1590107 */   // Label 22010: @1590107
     /* 1590107 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1590193), // Rule ID 2798 //
     /* 1590112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590158 */     // MIs[0] policy
     /* 1590158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590168 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1590171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590192 */     // GIR_Coverage, 2798,
     /* 1590192 */     GIR_EraseRootFromParent_Done,
     /* 1590193 */   // Label 22011: @1590193
     /* 1590193 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1590279), // Rule ID 2799 //
     /* 1590198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1590218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590244 */     // MIs[0] policy
     /* 1590244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590254 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1590257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590278 */     // GIR_Coverage, 2799,
     /* 1590278 */     GIR_EraseRootFromParent_Done,
     /* 1590279 */   // Label 22012: @1590279
     /* 1590279 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1590365), // Rule ID 2806 //
     /* 1590284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590330 */     // MIs[0] policy
     /* 1590330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590364 */     // GIR_Coverage, 2806,
     /* 1590364 */     GIR_EraseRootFromParent_Done,
     /* 1590365 */   // Label 22013: @1590365
     /* 1590365 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1590451), // Rule ID 2807 //
     /* 1590370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1590390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590416 */     // MIs[0] policy
     /* 1590416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590450 */     // GIR_Coverage, 2807,
     /* 1590450 */     GIR_EraseRootFromParent_Done,
     /* 1590451 */   // Label 22014: @1590451
     /* 1590451 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1590537), // Rule ID 2814 //
     /* 1590456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590502 */     // MIs[0] policy
     /* 1590502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590536 */     // GIR_Coverage, 2814,
     /* 1590536 */     GIR_EraseRootFromParent_Done,
     /* 1590537 */   // Label 22015: @1590537
     /* 1590537 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1590623), // Rule ID 2815 //
     /* 1590542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590588 */     // MIs[0] policy
     /* 1590588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590622 */     // GIR_Coverage, 2815,
     /* 1590622 */     GIR_EraseRootFromParent_Done,
     /* 1590623 */   // Label 22016: @1590623
     /* 1590623 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1590709), // Rule ID 2822 //
     /* 1590628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590674 */     // MIs[0] policy
     /* 1590674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590708 */     // GIR_Coverage, 2822,
     /* 1590708 */     GIR_EraseRootFromParent_Done,
     /* 1590709 */   // Label 22017: @1590709
     /* 1590709 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1590795), // Rule ID 2823 //
     /* 1590714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590760 */     // MIs[0] policy
     /* 1590760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590770 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590794 */     // GIR_Coverage, 2823,
     /* 1590794 */     GIR_EraseRootFromParent_Done,
     /* 1590795 */   // Label 22018: @1590795
     /* 1590795 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1590881), // Rule ID 2830 //
     /* 1590800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590846 */     // MIs[0] policy
     /* 1590846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590880 */     // GIR_Coverage, 2830,
     /* 1590880 */     GIR_EraseRootFromParent_Done,
     /* 1590881 */   // Label 22019: @1590881
     /* 1590881 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1590967), // Rule ID 2831 //
     /* 1590886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590932 */     // MIs[0] policy
     /* 1590932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590942 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590966 */     // GIR_Coverage, 2831,
     /* 1590966 */     GIR_EraseRootFromParent_Done,
     /* 1590967 */   // Label 22020: @1590967
     /* 1590967 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1591053), // Rule ID 2838 //
     /* 1590972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1590992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591018 */     // MIs[0] policy
     /* 1591018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1591031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591052 */     // GIR_Coverage, 2838,
     /* 1591052 */     GIR_EraseRootFromParent_Done,
     /* 1591053 */   // Label 22021: @1591053
     /* 1591053 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1591139), // Rule ID 2839 //
     /* 1591058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591104 */     // MIs[0] policy
     /* 1591104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1591117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591138 */     // GIR_Coverage, 2839,
     /* 1591138 */     GIR_EraseRootFromParent_Done,
     /* 1591139 */   // Label 22022: @1591139
     /* 1591139 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1591225), // Rule ID 2846 //
     /* 1591144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591190 */     // MIs[0] policy
     /* 1591190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591224 */     // GIR_Coverage, 2846,
     /* 1591224 */     GIR_EraseRootFromParent_Done,
     /* 1591225 */   // Label 22023: @1591225
     /* 1591225 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1591311), // Rule ID 2847 //
     /* 1591230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1591250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591276 */     // MIs[0] policy
     /* 1591276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591310 */     // GIR_Coverage, 2847,
     /* 1591310 */     GIR_EraseRootFromParent_Done,
     /* 1591311 */   // Label 22024: @1591311
     /* 1591311 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1591397), // Rule ID 2854 //
     /* 1591316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591362 */     // MIs[0] policy
     /* 1591362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591396 */     // GIR_Coverage, 2854,
     /* 1591396 */     GIR_EraseRootFromParent_Done,
     /* 1591397 */   // Label 22025: @1591397
     /* 1591397 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1591483), // Rule ID 2855 //
     /* 1591402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1591422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591448 */     // MIs[0] policy
     /* 1591448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591482 */     // GIR_Coverage, 2855,
     /* 1591482 */     GIR_EraseRootFromParent_Done,
     /* 1591483 */   // Label 22026: @1591483
     /* 1591483 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1591569), // Rule ID 2862 //
     /* 1591488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591534 */     // MIs[0] policy
     /* 1591534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591568 */     // GIR_Coverage, 2862,
     /* 1591568 */     GIR_EraseRootFromParent_Done,
     /* 1591569 */   // Label 22027: @1591569
     /* 1591569 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1591655), // Rule ID 2863 //
     /* 1591574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591620 */     // MIs[0] policy
     /* 1591620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591654 */     // GIR_Coverage, 2863,
     /* 1591654 */     GIR_EraseRootFromParent_Done,
     /* 1591655 */   // Label 22028: @1591655
     /* 1591655 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1591741), // Rule ID 2870 //
     /* 1591660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1591663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591706 */     // MIs[0] policy
     /* 1591706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591740 */     // GIR_Coverage, 2870,
     /* 1591740 */     GIR_EraseRootFromParent_Done,
     /* 1591741 */   // Label 22029: @1591741
     /* 1591741 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1591827), // Rule ID 2871 //
     /* 1591746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1591749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591792 */     // MIs[0] policy
     /* 1591792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591826 */     // GIR_Coverage, 2871,
     /* 1591826 */     GIR_EraseRootFromParent_Done,
     /* 1591827 */   // Label 22030: @1591827
     /* 1591827 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1591913), // Rule ID 2878 //
     /* 1591832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591878 */     // MIs[0] policy
     /* 1591878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591912 */     // GIR_Coverage, 2878,
     /* 1591912 */     GIR_EraseRootFromParent_Done,
     /* 1591913 */   // Label 22031: @1591913
     /* 1591913 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1591999), // Rule ID 2879 //
     /* 1591918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591964 */     // MIs[0] policy
     /* 1591964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591998 */     // GIR_Coverage, 2879,
     /* 1591998 */     GIR_EraseRootFromParent_Done,
     /* 1591999 */   // Label 22032: @1591999
     /* 1591999 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1592085), // Rule ID 2886 //
     /* 1592004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592050 */     // MIs[0] policy
     /* 1592050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592060 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592084 */     // GIR_Coverage, 2886,
     /* 1592084 */     GIR_EraseRootFromParent_Done,
     /* 1592085 */   // Label 22033: @1592085
     /* 1592085 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1592171), // Rule ID 2887 //
     /* 1592090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592136 */     // MIs[0] policy
     /* 1592136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592170 */     // GIR_Coverage, 2887,
     /* 1592170 */     GIR_EraseRootFromParent_Done,
     /* 1592171 */   // Label 22034: @1592171
     /* 1592171 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1592257), // Rule ID 2894 //
     /* 1592176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592222 */     // MIs[0] policy
     /* 1592222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592232 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592256 */     // GIR_Coverage, 2894,
     /* 1592256 */     GIR_EraseRootFromParent_Done,
     /* 1592257 */   // Label 22035: @1592257
     /* 1592257 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1592343), // Rule ID 2895 //
     /* 1592262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1592282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592308 */     // MIs[0] policy
     /* 1592308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592342 */     // GIR_Coverage, 2895,
     /* 1592342 */     GIR_EraseRootFromParent_Done,
     /* 1592343 */   // Label 22036: @1592343
     /* 1592343 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1592429), // Rule ID 2902 //
     /* 1592348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592394 */     // MIs[0] policy
     /* 1592394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592428 */     // GIR_Coverage, 2902,
     /* 1592428 */     GIR_EraseRootFromParent_Done,
     /* 1592429 */   // Label 22037: @1592429
     /* 1592429 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1592515), // Rule ID 2903 //
     /* 1592434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1592454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592480 */     // MIs[0] policy
     /* 1592480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592514 */     // GIR_Coverage, 2903,
     /* 1592514 */     GIR_EraseRootFromParent_Done,
     /* 1592515 */   // Label 22038: @1592515
     /* 1592515 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1592601), // Rule ID 2910 //
     /* 1592520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592566 */     // MIs[0] policy
     /* 1592566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592600 */     // GIR_Coverage, 2910,
     /* 1592600 */     GIR_EraseRootFromParent_Done,
     /* 1592601 */   // Label 22039: @1592601
     /* 1592601 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1592687), // Rule ID 2911 //
     /* 1592606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592652 */     // MIs[0] policy
     /* 1592652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592662 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592686 */     // GIR_Coverage, 2911,
     /* 1592686 */     GIR_EraseRootFromParent_Done,
     /* 1592687 */   // Label 22040: @1592687
     /* 1592687 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1592773), // Rule ID 2918 //
     /* 1592692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592738 */     // MIs[0] policy
     /* 1592738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592748 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592772 */     // GIR_Coverage, 2918,
     /* 1592772 */     GIR_EraseRootFromParent_Done,
     /* 1592773 */   // Label 22041: @1592773
     /* 1592773 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1592859), // Rule ID 2919 //
     /* 1592778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592824 */     // MIs[0] policy
     /* 1592824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592834 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592858 */     // GIR_Coverage, 2919,
     /* 1592858 */     GIR_EraseRootFromParent_Done,
     /* 1592859 */   // Label 22042: @1592859
     /* 1592859 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1592945), // Rule ID 2926 //
     /* 1592864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592910 */     // MIs[0] policy
     /* 1592910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592944 */     // GIR_Coverage, 2926,
     /* 1592944 */     GIR_EraseRootFromParent_Done,
     /* 1592945 */   // Label 22043: @1592945
     /* 1592945 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1593031), // Rule ID 2927 //
     /* 1592950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592996 */     // MIs[0] policy
     /* 1592996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593030 */     // GIR_Coverage, 2927,
     /* 1593030 */     GIR_EraseRootFromParent_Done,
     /* 1593031 */   // Label 22044: @1593031
     /* 1593031 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1593117), // Rule ID 2934 //
     /* 1593036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593082 */     // MIs[0] policy
     /* 1593082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593116 */     // GIR_Coverage, 2934,
     /* 1593116 */     GIR_EraseRootFromParent_Done,
     /* 1593117 */   // Label 22045: @1593117
     /* 1593117 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1593203), // Rule ID 2935 //
     /* 1593122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593168 */     // MIs[0] policy
     /* 1593168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593202 */     // GIR_Coverage, 2935,
     /* 1593202 */     GIR_EraseRootFromParent_Done,
     /* 1593203 */   // Label 22046: @1593203
     /* 1593203 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1593289), // Rule ID 2942 //
     /* 1593208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593254 */     // MIs[0] policy
     /* 1593254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593288 */     // GIR_Coverage, 2942,
     /* 1593288 */     GIR_EraseRootFromParent_Done,
     /* 1593289 */   // Label 22047: @1593289
     /* 1593289 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1593375), // Rule ID 2943 //
     /* 1593294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1593314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593340 */     // MIs[0] policy
     /* 1593340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593374 */     // GIR_Coverage, 2943,
     /* 1593374 */     GIR_EraseRootFromParent_Done,
     /* 1593375 */   // Label 22048: @1593375
     /* 1593375 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1593461), // Rule ID 2950 //
     /* 1593380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593426 */     // MIs[0] policy
     /* 1593426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593460 */     // GIR_Coverage, 2950,
     /* 1593460 */     GIR_EraseRootFromParent_Done,
     /* 1593461 */   // Label 22049: @1593461
     /* 1593461 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1593547), // Rule ID 2951 //
     /* 1593466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593512 */     // MIs[0] policy
     /* 1593512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593546 */     // GIR_Coverage, 2951,
     /* 1593546 */     GIR_EraseRootFromParent_Done,
     /* 1593547 */   // Label 22050: @1593547
     /* 1593547 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1593633), // Rule ID 2958 //
     /* 1593552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593598 */     // MIs[0] policy
     /* 1593598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593632 */     // GIR_Coverage, 2958,
     /* 1593632 */     GIR_EraseRootFromParent_Done,
     /* 1593633 */   // Label 22051: @1593633
     /* 1593633 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1593719), // Rule ID 2959 //
     /* 1593638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593684 */     // MIs[0] policy
     /* 1593684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593718 */     // GIR_Coverage, 2959,
     /* 1593718 */     GIR_EraseRootFromParent_Done,
     /* 1593719 */   // Label 22052: @1593719
     /* 1593719 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1593805), // Rule ID 2966 //
     /* 1593724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593770 */     // MIs[0] policy
     /* 1593770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593780 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593804 */     // GIR_Coverage, 2966,
     /* 1593804 */     GIR_EraseRootFromParent_Done,
     /* 1593805 */   // Label 22053: @1593805
     /* 1593805 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1593891), // Rule ID 2967 //
     /* 1593810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593856 */     // MIs[0] policy
     /* 1593856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593890 */     // GIR_Coverage, 2967,
     /* 1593890 */     GIR_EraseRootFromParent_Done,
     /* 1593891 */   // Label 22054: @1593891
     /* 1593891 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1593977), // Rule ID 2982 //
     /* 1593896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593942 */     // MIs[0] policy
     /* 1593942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593976 */     // GIR_Coverage, 2982,
     /* 1593976 */     GIR_EraseRootFromParent_Done,
     /* 1593977 */   // Label 22055: @1593977
     /* 1593977 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1594063), // Rule ID 2983 //
     /* 1593982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1594002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594028 */     // MIs[0] policy
     /* 1594028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594038 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594062 */     // GIR_Coverage, 2983,
     /* 1594062 */     GIR_EraseRootFromParent_Done,
     /* 1594063 */   // Label 22056: @1594063
     /* 1594063 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1594149), // Rule ID 2986 //
     /* 1594068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594114 */     // MIs[0] policy
     /* 1594114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594148 */     // GIR_Coverage, 2986,
     /* 1594148 */     GIR_EraseRootFromParent_Done,
     /* 1594149 */   // Label 22057: @1594149
     /* 1594149 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1594235), // Rule ID 2987 //
     /* 1594154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594200 */     // MIs[0] policy
     /* 1594200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594210 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594234 */     // GIR_Coverage, 2987,
     /* 1594234 */     GIR_EraseRootFromParent_Done,
     /* 1594235 */   // Label 22058: @1594235
     /* 1594235 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1594321), // Rule ID 2990 //
     /* 1594240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594286 */     // MIs[0] policy
     /* 1594286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594320 */     // GIR_Coverage, 2990,
     /* 1594320 */     GIR_EraseRootFromParent_Done,
     /* 1594321 */   // Label 22059: @1594321
     /* 1594321 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1594407), // Rule ID 2991 //
     /* 1594326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594372 */     // MIs[0] policy
     /* 1594372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1594385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594406 */     // GIR_Coverage, 2991,
     /* 1594406 */     GIR_EraseRootFromParent_Done,
     /* 1594407 */   // Label 22060: @1594407
     /* 1594407 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1594493), // Rule ID 2994 //
     /* 1594412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594458 */     // MIs[0] policy
     /* 1594458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594492 */     // GIR_Coverage, 2994,
     /* 1594492 */     GIR_EraseRootFromParent_Done,
     /* 1594493 */   // Label 22061: @1594493
     /* 1594493 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1594579), // Rule ID 2995 //
     /* 1594498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594544 */     // MIs[0] policy
     /* 1594544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594554 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594578 */     // GIR_Coverage, 2995,
     /* 1594578 */     GIR_EraseRootFromParent_Done,
     /* 1594579 */   // Label 22062: @1594579
     /* 1594579 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1594665), // Rule ID 2998 //
     /* 1594584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594630 */     // MIs[0] policy
     /* 1594630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594664 */     // GIR_Coverage, 2998,
     /* 1594664 */     GIR_EraseRootFromParent_Done,
     /* 1594665 */   // Label 22063: @1594665
     /* 1594665 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1594751), // Rule ID 2999 //
     /* 1594670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594716 */     // MIs[0] policy
     /* 1594716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594750 */     // GIR_Coverage, 2999,
     /* 1594750 */     GIR_EraseRootFromParent_Done,
     /* 1594751 */   // Label 22064: @1594751
     /* 1594751 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1594837), // Rule ID 3002 //
     /* 1594756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594802 */     // MIs[0] policy
     /* 1594802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594836 */     // GIR_Coverage, 3002,
     /* 1594836 */     GIR_EraseRootFromParent_Done,
     /* 1594837 */   // Label 22065: @1594837
     /* 1594837 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1594923), // Rule ID 3003 //
     /* 1594842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594888 */     // MIs[0] policy
     /* 1594888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594922 */     // GIR_Coverage, 3003,
     /* 1594922 */     GIR_EraseRootFromParent_Done,
     /* 1594923 */   // Label 22066: @1594923
     /* 1594923 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1595009), // Rule ID 3006 //
     /* 1594928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594974 */     // MIs[0] policy
     /* 1594974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595008 */     // GIR_Coverage, 3006,
     /* 1595008 */     GIR_EraseRootFromParent_Done,
     /* 1595009 */   // Label 22067: @1595009
     /* 1595009 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1595095), // Rule ID 3007 //
     /* 1595014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1595034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595060 */     // MIs[0] policy
     /* 1595060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595094 */     // GIR_Coverage, 3007,
     /* 1595094 */     GIR_EraseRootFromParent_Done,
     /* 1595095 */   // Label 22068: @1595095
     /* 1595095 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1595181), // Rule ID 3010 //
     /* 1595100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595146 */     // MIs[0] policy
     /* 1595146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595180 */     // GIR_Coverage, 3010,
     /* 1595180 */     GIR_EraseRootFromParent_Done,
     /* 1595181 */   // Label 22069: @1595181
     /* 1595181 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1595267), // Rule ID 3011 //
     /* 1595186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595232 */     // MIs[0] policy
     /* 1595232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595266 */     // GIR_Coverage, 3011,
     /* 1595266 */     GIR_EraseRootFromParent_Done,
     /* 1595267 */   // Label 22070: @1595267
     /* 1595267 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1595353), // Rule ID 3014 //
     /* 1595272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1595275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595318 */     // MIs[0] policy
     /* 1595318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595352 */     // GIR_Coverage, 3014,
     /* 1595352 */     GIR_EraseRootFromParent_Done,
     /* 1595353 */   // Label 22071: @1595353
     /* 1595353 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1595439), // Rule ID 3015 //
     /* 1595358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1595361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595404 */     // MIs[0] policy
     /* 1595404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1595417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595438 */     // GIR_Coverage, 3015,
     /* 1595438 */     GIR_EraseRootFromParent_Done,
     /* 1595439 */   // Label 22072: @1595439
     /* 1595439 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1595525), // Rule ID 3018 //
     /* 1595444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595490 */     // MIs[0] policy
     /* 1595490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595500 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595524 */     // GIR_Coverage, 3018,
     /* 1595524 */     GIR_EraseRootFromParent_Done,
     /* 1595525 */   // Label 22073: @1595525
     /* 1595525 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1595611), // Rule ID 3019 //
     /* 1595530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595576 */     // MIs[0] policy
     /* 1595576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595586 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595610 */     // GIR_Coverage, 3019,
     /* 1595610 */     GIR_EraseRootFromParent_Done,
     /* 1595611 */   // Label 22074: @1595611
     /* 1595611 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1595697), // Rule ID 3022 //
     /* 1595616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595662 */     // MIs[0] policy
     /* 1595662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595696 */     // GIR_Coverage, 3022,
     /* 1595696 */     GIR_EraseRootFromParent_Done,
     /* 1595697 */   // Label 22075: @1595697
     /* 1595697 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1595783), // Rule ID 3023 //
     /* 1595702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595748 */     // MIs[0] policy
     /* 1595748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595758 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595782 */     // GIR_Coverage, 3023,
     /* 1595782 */     GIR_EraseRootFromParent_Done,
     /* 1595783 */   // Label 22076: @1595783
     /* 1595783 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1595869), // Rule ID 3026 //
     /* 1595788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595834 */     // MIs[0] policy
     /* 1595834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595868 */     // GIR_Coverage, 3026,
     /* 1595868 */     GIR_EraseRootFromParent_Done,
     /* 1595869 */   // Label 22077: @1595869
     /* 1595869 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1595955), // Rule ID 3027 //
     /* 1595874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595920 */     // MIs[0] policy
     /* 1595920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595954 */     // GIR_Coverage, 3027,
     /* 1595954 */     GIR_EraseRootFromParent_Done,
     /* 1595955 */   // Label 22078: @1595955
     /* 1595955 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1596041), // Rule ID 3030 //
     /* 1595960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596006 */     // MIs[0] policy
     /* 1596006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596040 */     // GIR_Coverage, 3030,
     /* 1596040 */     GIR_EraseRootFromParent_Done,
     /* 1596041 */   // Label 22079: @1596041
     /* 1596041 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1596127), // Rule ID 3031 //
     /* 1596046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1596066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596092 */     // MIs[0] policy
     /* 1596092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596126 */     // GIR_Coverage, 3031,
     /* 1596126 */     GIR_EraseRootFromParent_Done,
     /* 1596127 */   // Label 22080: @1596127
     /* 1596127 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1596213), // Rule ID 3034 //
     /* 1596132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596178 */     // MIs[0] policy
     /* 1596178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596212 */     // GIR_Coverage, 3034,
     /* 1596212 */     GIR_EraseRootFromParent_Done,
     /* 1596213 */   // Label 22081: @1596213
     /* 1596213 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1596299), // Rule ID 3035 //
     /* 1596218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596264 */     // MIs[0] policy
     /* 1596264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596298 */     // GIR_Coverage, 3035,
     /* 1596298 */     GIR_EraseRootFromParent_Done,
     /* 1596299 */   // Label 22082: @1596299
     /* 1596299 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1596385), // Rule ID 3038 //
     /* 1596304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596350 */     // MIs[0] policy
     /* 1596350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596384 */     // GIR_Coverage, 3038,
     /* 1596384 */     GIR_EraseRootFromParent_Done,
     /* 1596385 */   // Label 22083: @1596385
     /* 1596385 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1596471), // Rule ID 3039 //
     /* 1596390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596436 */     // MIs[0] policy
     /* 1596436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596470 */     // GIR_Coverage, 3039,
     /* 1596470 */     GIR_EraseRootFromParent_Done,
     /* 1596471 */   // Label 22084: @1596471
     /* 1596471 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1596557), // Rule ID 3042 //
     /* 1596476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596522 */     // MIs[0] policy
     /* 1596522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596556 */     // GIR_Coverage, 3042,
     /* 1596556 */     GIR_EraseRootFromParent_Done,
     /* 1596557 */   // Label 22085: @1596557
     /* 1596557 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1596643), // Rule ID 3043 //
     /* 1596562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596608 */     // MIs[0] policy
     /* 1596608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596642 */     // GIR_Coverage, 3043,
     /* 1596642 */     GIR_EraseRootFromParent_Done,
     /* 1596643 */   // Label 22086: @1596643
     /* 1596643 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1596729), // Rule ID 3046 //
     /* 1596648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596694 */     // MIs[0] policy
     /* 1596694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596728 */     // GIR_Coverage, 3046,
     /* 1596728 */     GIR_EraseRootFromParent_Done,
     /* 1596729 */   // Label 22087: @1596729
     /* 1596729 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1596815), // Rule ID 3047 //
     /* 1596734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596780 */     // MIs[0] policy
     /* 1596780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596814 */     // GIR_Coverage, 3047,
     /* 1596814 */     GIR_EraseRootFromParent_Done,
     /* 1596815 */   // Label 22088: @1596815
     /* 1596815 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1596901), // Rule ID 3050 //
     /* 1596820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596866 */     // MIs[0] policy
     /* 1596866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596900 */     // GIR_Coverage, 3050,
     /* 1596900 */     GIR_EraseRootFromParent_Done,
     /* 1596901 */   // Label 22089: @1596901
     /* 1596901 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1596987), // Rule ID 3051 //
     /* 1596906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596952 */     // MIs[0] policy
     /* 1596952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596986 */     // GIR_Coverage, 3051,
     /* 1596986 */     GIR_EraseRootFromParent_Done,
     /* 1596987 */   // Label 22090: @1596987
     /* 1596987 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1597073), // Rule ID 3054 //
     /* 1596992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597038 */     // MIs[0] policy
     /* 1597038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1597051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597072 */     // GIR_Coverage, 3054,
     /* 1597072 */     GIR_EraseRootFromParent_Done,
     /* 1597073 */   // Label 22091: @1597073
     /* 1597073 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1597159), // Rule ID 3055 //
     /* 1597078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597124 */     // MIs[0] policy
     /* 1597124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1597137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597158 */     // GIR_Coverage, 3055,
     /* 1597158 */     GIR_EraseRootFromParent_Done,
     /* 1597159 */   // Label 22092: @1597159
     /* 1597159 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1597245), // Rule ID 3058 //
     /* 1597164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597210 */     // MIs[0] policy
     /* 1597210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1597223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597244 */     // GIR_Coverage, 3058,
     /* 1597244 */     GIR_EraseRootFromParent_Done,
     /* 1597245 */   // Label 22093: @1597245
     /* 1597245 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1597331), // Rule ID 3059 //
     /* 1597250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597296 */     // MIs[0] policy
     /* 1597296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1597309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597330 */     // GIR_Coverage, 3059,
     /* 1597330 */     GIR_EraseRootFromParent_Done,
     /* 1597331 */   // Label 22094: @1597331
     /* 1597331 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1597417), // Rule ID 3062 //
     /* 1597336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597382 */     // MIs[0] policy
     /* 1597382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597416 */     // GIR_Coverage, 3062,
     /* 1597416 */     GIR_EraseRootFromParent_Done,
     /* 1597417 */   // Label 22095: @1597417
     /* 1597417 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1597503), // Rule ID 3063 //
     /* 1597422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597468 */     // MIs[0] policy
     /* 1597468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597502 */     // GIR_Coverage, 3063,
     /* 1597502 */     GIR_EraseRootFromParent_Done,
     /* 1597503 */   // Label 22096: @1597503
     /* 1597503 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1597589), // Rule ID 3066 //
     /* 1597508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597554 */     // MIs[0] policy
     /* 1597554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597588 */     // GIR_Coverage, 3066,
     /* 1597588 */     GIR_EraseRootFromParent_Done,
     /* 1597589 */   // Label 22097: @1597589
     /* 1597589 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1597675), // Rule ID 3067 //
     /* 1597594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597640 */     // MIs[0] policy
     /* 1597640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597674 */     // GIR_Coverage, 3067,
     /* 1597674 */     GIR_EraseRootFromParent_Done,
     /* 1597675 */   // Label 22098: @1597675
     /* 1597675 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1597761), // Rule ID 3070 //
     /* 1597680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597726 */     // MIs[0] policy
     /* 1597726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597736 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597760 */     // GIR_Coverage, 3070,
     /* 1597760 */     GIR_EraseRootFromParent_Done,
     /* 1597761 */   // Label 22099: @1597761
     /* 1597761 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1597847), // Rule ID 3071 //
     /* 1597766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597812 */     // MIs[0] policy
     /* 1597812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597846 */     // GIR_Coverage, 3071,
     /* 1597846 */     GIR_EraseRootFromParent_Done,
     /* 1597847 */   // Label 22100: @1597847
     /* 1597847 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1597933), // Rule ID 3074 //
     /* 1597852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597898 */     // MIs[0] policy
     /* 1597898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597908 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597932 */     // GIR_Coverage, 3074,
     /* 1597932 */     GIR_EraseRootFromParent_Done,
     /* 1597933 */   // Label 22101: @1597933
     /* 1597933 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1598019), // Rule ID 3075 //
     /* 1597938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597984 */     // MIs[0] policy
     /* 1597984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597994 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598018 */     // GIR_Coverage, 3075,
     /* 1598018 */     GIR_EraseRootFromParent_Done,
     /* 1598019 */   // Label 22102: @1598019
     /* 1598019 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1598105), // Rule ID 3078 //
     /* 1598024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598070 */     // MIs[0] policy
     /* 1598070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1598083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598104 */     // GIR_Coverage, 3078,
     /* 1598104 */     GIR_EraseRootFromParent_Done,
     /* 1598105 */   // Label 22103: @1598105
     /* 1598105 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1598191), // Rule ID 3079 //
     /* 1598110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598156 */     // MIs[0] policy
     /* 1598156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598166 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1598169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598190 */     // GIR_Coverage, 3079,
     /* 1598190 */     GIR_EraseRootFromParent_Done,
     /* 1598191 */   // Label 22104: @1598191
     /* 1598191 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1598277), // Rule ID 3082 //
     /* 1598196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598242 */     // MIs[0] policy
     /* 1598242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598276 */     // GIR_Coverage, 3082,
     /* 1598276 */     GIR_EraseRootFromParent_Done,
     /* 1598277 */   // Label 22105: @1598277
     /* 1598277 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1598363), // Rule ID 3083 //
     /* 1598282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598328 */     // MIs[0] policy
     /* 1598328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598338 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598362 */     // GIR_Coverage, 3083,
     /* 1598362 */     GIR_EraseRootFromParent_Done,
     /* 1598363 */   // Label 22106: @1598363
     /* 1598363 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1598449), // Rule ID 3086 //
     /* 1598368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598414 */     // MIs[0] policy
     /* 1598414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598448 */     // GIR_Coverage, 3086,
     /* 1598448 */     GIR_EraseRootFromParent_Done,
     /* 1598449 */   // Label 22107: @1598449
     /* 1598449 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1598535), // Rule ID 3087 //
     /* 1598454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598500 */     // MIs[0] policy
     /* 1598500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598534 */     // GIR_Coverage, 3087,
     /* 1598534 */     GIR_EraseRootFromParent_Done,
     /* 1598535 */   // Label 22108: @1598535
     /* 1598535 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1598621), // Rule ID 3090 //
     /* 1598540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598586 */     // MIs[0] policy
     /* 1598586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598620 */     // GIR_Coverage, 3090,
     /* 1598620 */     GIR_EraseRootFromParent_Done,
     /* 1598621 */   // Label 22109: @1598621
     /* 1598621 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1598707), // Rule ID 3091 //
     /* 1598626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598672 */     // MIs[0] policy
     /* 1598672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11200:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598706 */     // GIR_Coverage, 3091,
     /* 1598706 */     GIR_EraseRootFromParent_Done,
     /* 1598707 */   // Label 22110: @1598707
     /* 1598707 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1598793), // Rule ID 3094 //
     /* 1598712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598758 */     // MIs[0] policy
     /* 1598758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598792 */     // GIR_Coverage, 3094,
     /* 1598792 */     GIR_EraseRootFromParent_Done,
     /* 1598793 */   // Label 22111: @1598793
     /* 1598793 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1598879), // Rule ID 3095 //
     /* 1598798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598844 */     // MIs[0] policy
     /* 1598844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598878 */     // GIR_Coverage, 3095,
     /* 1598878 */     GIR_EraseRootFromParent_Done,
     /* 1598879 */   // Label 22112: @1598879
     /* 1598879 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1598965), // Rule ID 3098 //
     /* 1598884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598930 */     // MIs[0] policy
     /* 1598930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598964 */     // GIR_Coverage, 3098,
     /* 1598964 */     GIR_EraseRootFromParent_Done,
     /* 1598965 */   // Label 22113: @1598965
     /* 1598965 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1599051), // Rule ID 3099 //
     /* 1598970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599016 */     // MIs[0] policy
     /* 1599016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599050 */     // GIR_Coverage, 3099,
     /* 1599050 */     GIR_EraseRootFromParent_Done,
     /* 1599051 */   // Label 22114: @1599051
     /* 1599051 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1599137), // Rule ID 3102 //
     /* 1599056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1599059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599102 */     // MIs[0] policy
     /* 1599102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599136 */     // GIR_Coverage, 3102,
     /* 1599136 */     GIR_EraseRootFromParent_Done,
     /* 1599137 */   // Label 22115: @1599137
     /* 1599137 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1599223), // Rule ID 3103 //
     /* 1599142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1599145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599188 */     // MIs[0] policy
     /* 1599188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1599201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599222 */     // GIR_Coverage, 3103,
     /* 1599222 */     GIR_EraseRootFromParent_Done,
     /* 1599223 */   // Label 22116: @1599223
     /* 1599223 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1599309), // Rule ID 3106 //
     /* 1599228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599274 */     // MIs[0] policy
     /* 1599274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599308 */     // GIR_Coverage, 3106,
     /* 1599308 */     GIR_EraseRootFromParent_Done,
     /* 1599309 */   // Label 22117: @1599309
     /* 1599309 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1599395), // Rule ID 3107 //
     /* 1599314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599360 */     // MIs[0] policy
     /* 1599360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599394 */     // GIR_Coverage, 3107,
     /* 1599394 */     GIR_EraseRootFromParent_Done,
     /* 1599395 */   // Label 22118: @1599395
     /* 1599395 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1599481), // Rule ID 3110 //
     /* 1599400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599446 */     // MIs[0] policy
     /* 1599446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599456 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599480 */     // GIR_Coverage, 3110,
     /* 1599480 */     GIR_EraseRootFromParent_Done,
     /* 1599481 */   // Label 22119: @1599481
     /* 1599481 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1599567), // Rule ID 3111 //
     /* 1599486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599532 */     // MIs[0] policy
     /* 1599532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599566 */     // GIR_Coverage, 3111,
     /* 1599566 */     GIR_EraseRootFromParent_Done,
     /* 1599567 */   // Label 22120: @1599567
     /* 1599567 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1599653), // Rule ID 3114 //
     /* 1599572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599618 */     // MIs[0] policy
     /* 1599618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599628 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599652 */     // GIR_Coverage, 3114,
     /* 1599652 */     GIR_EraseRootFromParent_Done,
     /* 1599653 */   // Label 22121: @1599653
     /* 1599653 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1599739), // Rule ID 3115 //
     /* 1599658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599704 */     // MIs[0] policy
     /* 1599704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599738 */     // GIR_Coverage, 3115,
     /* 1599738 */     GIR_EraseRootFromParent_Done,
     /* 1599739 */   // Label 22122: @1599739
     /* 1599739 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1599825), // Rule ID 3118 //
     /* 1599744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599790 */     // MIs[0] policy
     /* 1599790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599824 */     // GIR_Coverage, 3118,
     /* 1599824 */     GIR_EraseRootFromParent_Done,
     /* 1599825 */   // Label 22123: @1599825
     /* 1599825 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1599911), // Rule ID 3119 //
     /* 1599830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599876 */     // MIs[0] policy
     /* 1599876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599910 */     // GIR_Coverage, 3119,
     /* 1599910 */     GIR_EraseRootFromParent_Done,
     /* 1599911 */   // Label 22124: @1599911
     /* 1599911 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1599997), // Rule ID 3122 //
     /* 1599916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599962 */     // MIs[0] policy
     /* 1599962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599996 */     // GIR_Coverage, 3122,
     /* 1599996 */     GIR_EraseRootFromParent_Done,
     /* 1599997 */   // Label 22125: @1599997
     /* 1599997 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1600083), // Rule ID 3123 //
     /* 1600002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1600013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1600016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1600019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600048 */     // MIs[0] policy
     /* 1600048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600082 */     // GIR_Coverage, 3123,
     /* 1600082 */     GIR_EraseRootFromParent_Done,
     /* 1600083 */   // Label 22126: @1600083
     /* 1600083 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1600169), // Rule ID 3126 //
     /* 1600088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600134 */     // MIs[0] policy
     /* 1600134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600144 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600168 */     // GIR_Coverage, 3126,
     /* 1600168 */     GIR_EraseRootFromParent_Done,
     /* 1600169 */   // Label 22127: @1600169
     /* 1600169 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1600255), // Rule ID 3127 //
     /* 1600174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600220 */     // MIs[0] policy
     /* 1600220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600254 */     // GIR_Coverage, 3127,
     /* 1600254 */     GIR_EraseRootFromParent_Done,
     /* 1600255 */   // Label 22128: @1600255
     /* 1600255 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1600341), // Rule ID 3130 //
     /* 1600260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600306 */     // MIs[0] policy
     /* 1600306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600340 */     // GIR_Coverage, 3130,
     /* 1600340 */     GIR_EraseRootFromParent_Done,
     /* 1600341 */   // Label 22129: @1600341
     /* 1600341 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1600427), // Rule ID 3131 //
     /* 1600346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600392 */     // MIs[0] policy
     /* 1600392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600426 */     // GIR_Coverage, 3131,
     /* 1600426 */     GIR_EraseRootFromParent_Done,
     /* 1600427 */   // Label 22130: @1600427
     /* 1600427 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1600513), // Rule ID 3134 //
     /* 1600432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600478 */     // MIs[0] policy
     /* 1600478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600512 */     // GIR_Coverage, 3134,
     /* 1600512 */     GIR_EraseRootFromParent_Done,
     /* 1600513 */   // Label 22131: @1600513
     /* 1600513 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1600599), // Rule ID 3135 //
     /* 1600518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600564 */     // MIs[0] policy
     /* 1600564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600598 */     // GIR_Coverage, 3135,
     /* 1600598 */     GIR_EraseRootFromParent_Done,
     /* 1600599 */   // Label 22132: @1600599
     /* 1600599 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1600685), // Rule ID 3138 //
     /* 1600604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600650 */     // MIs[0] policy
     /* 1600650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600684 */     // GIR_Coverage, 3138,
     /* 1600684 */     GIR_EraseRootFromParent_Done,
     /* 1600685 */   // Label 22133: @1600685
     /* 1600685 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1600771), // Rule ID 3139 //
     /* 1600690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600736 */     // MIs[0] policy
     /* 1600736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600770 */     // GIR_Coverage, 3139,
     /* 1600770 */     GIR_EraseRootFromParent_Done,
     /* 1600771 */   // Label 22134: @1600771
     /* 1600771 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1600857), // Rule ID 3142 //
     /* 1600776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600822 */     // MIs[0] policy
     /* 1600822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600856 */     // GIR_Coverage, 3142,
     /* 1600856 */     GIR_EraseRootFromParent_Done,
     /* 1600857 */   // Label 22135: @1600857
     /* 1600857 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1600943), // Rule ID 3143 //
     /* 1600862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600908 */     // MIs[0] policy
     /* 1600908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600942 */     // GIR_Coverage, 3143,
     /* 1600942 */     GIR_EraseRootFromParent_Done,
     /* 1600943 */   // Label 22136: @1600943
     /* 1600943 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1601029), // Rule ID 3146 //
     /* 1600948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600994 */     // MIs[0] policy
     /* 1600994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1601007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601028 */     // GIR_Coverage, 3146,
     /* 1601028 */     GIR_EraseRootFromParent_Done,
     /* 1601029 */   // Label 22137: @1601029
     /* 1601029 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1601115), // Rule ID 3147 //
     /* 1601034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1601045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1601048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1601051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601080 */     // MIs[0] policy
     /* 1601080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1601093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601114 */     // GIR_Coverage, 3147,
     /* 1601114 */     GIR_EraseRootFromParent_Done,
     /* 1601115 */   // Label 22138: @1601115
     /* 1601115 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1601201), // Rule ID 3150 //
     /* 1601120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601166 */     // MIs[0] policy
     /* 1601166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1601179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601200 */     // GIR_Coverage, 3150,
     /* 1601200 */     GIR_EraseRootFromParent_Done,
     /* 1601201 */   // Label 22139: @1601201
     /* 1601201 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1601287), // Rule ID 3151 //
     /* 1601206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1601214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601252 */     // MIs[0] policy
     /* 1601252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1601265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601286 */     // GIR_Coverage, 3151,
     /* 1601286 */     GIR_EraseRootFromParent_Done,
     /* 1601287 */   // Label 22140: @1601287
     /* 1601287 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1601373), // Rule ID 3242 //
     /* 1601292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1601312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601338 */     // MIs[0] policy
     /* 1601338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601348 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1601351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601372 */     // GIR_Coverage, 3242,
     /* 1601372 */     GIR_EraseRootFromParent_Done,
     /* 1601373 */   // Label 22141: @1601373
     /* 1601373 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1601459), // Rule ID 3243 //
     /* 1601378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1601398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601424 */     // MIs[0] policy
     /* 1601424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1601437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601458 */     // GIR_Coverage, 3243,
     /* 1601458 */     GIR_EraseRootFromParent_Done,
     /* 1601459 */   // Label 22142: @1601459
     /* 1601459 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1601545), // Rule ID 3246 //
     /* 1601464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601510 */     // MIs[0] policy
     /* 1601510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601544 */     // GIR_Coverage, 3246,
     /* 1601544 */     GIR_EraseRootFromParent_Done,
     /* 1601545 */   // Label 22143: @1601545
     /* 1601545 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1601631), // Rule ID 3247 //
     /* 1601550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601596 */     // MIs[0] policy
     /* 1601596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601630 */     // GIR_Coverage, 3247,
     /* 1601630 */     GIR_EraseRootFromParent_Done,
     /* 1601631 */   // Label 22144: @1601631
     /* 1601631 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1601717), // Rule ID 3250 //
     /* 1601636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601682 */     // MIs[0] policy
     /* 1601682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601692 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601716 */     // GIR_Coverage, 3250,
     /* 1601716 */     GIR_EraseRootFromParent_Done,
     /* 1601717 */   // Label 22145: @1601717
     /* 1601717 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1601803), // Rule ID 3251 //
     /* 1601722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601768 */     // MIs[0] policy
     /* 1601768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601802 */     // GIR_Coverage, 3251,
     /* 1601802 */     GIR_EraseRootFromParent_Done,
     /* 1601803 */   // Label 22146: @1601803
     /* 1601803 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1601889), // Rule ID 3254 //
     /* 1601808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601854 */     // MIs[0] policy
     /* 1601854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601864 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601888 */     // GIR_Coverage, 3254,
     /* 1601888 */     GIR_EraseRootFromParent_Done,
     /* 1601889 */   // Label 22147: @1601889
     /* 1601889 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1601975), // Rule ID 3255 //
     /* 1601894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601940 */     // MIs[0] policy
     /* 1601940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601950 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601974 */     // GIR_Coverage, 3255,
     /* 1601974 */     GIR_EraseRootFromParent_Done,
     /* 1601975 */   // Label 22148: @1601975
     /* 1601975 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1602061), // Rule ID 3258 //
     /* 1601980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1602000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602026 */     // MIs[0] policy
     /* 1602026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602060 */     // GIR_Coverage, 3258,
     /* 1602060 */     GIR_EraseRootFromParent_Done,
     /* 1602061 */   // Label 22149: @1602061
     /* 1602061 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1602147), // Rule ID 3259 //
     /* 1602066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1602083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1602086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602112 */     // MIs[0] policy
     /* 1602112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602122 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602146 */     // GIR_Coverage, 3259,
     /* 1602146 */     GIR_EraseRootFromParent_Done,
     /* 1602147 */   // Label 22150: @1602147
     /* 1602147 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1602233), // Rule ID 3262 //
     /* 1602152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1602172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602198 */     // MIs[0] policy
     /* 1602198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602232 */     // GIR_Coverage, 3262,
     /* 1602232 */     GIR_EraseRootFromParent_Done,
     /* 1602233 */   // Label 22151: @1602233
     /* 1602233 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1602319), // Rule ID 3263 //
     /* 1602238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1602258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602284 */     // MIs[0] policy
     /* 1602284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1602297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602318 */     // GIR_Coverage, 3263,
     /* 1602318 */     GIR_EraseRootFromParent_Done,
     /* 1602319 */   // Label 22152: @1602319
     /* 1602319 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1602405), // Rule ID 3266 //
     /* 1602324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1602344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602370 */     // MIs[0] policy
     /* 1602370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602404 */     // GIR_Coverage, 3266,
     /* 1602404 */     GIR_EraseRootFromParent_Done,
     /* 1602405 */   // Label 22153: @1602405
     /* 1602405 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1602491), // Rule ID 3267 //
     /* 1602410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1602430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602456 */     // MIs[0] policy
     /* 1602456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602490 */     // GIR_Coverage, 3267,
     /* 1602490 */     GIR_EraseRootFromParent_Done,
     /* 1602491 */   // Label 22154: @1602491
     /* 1602491 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1602577), // Rule ID 3270 //
     /* 1602496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602542 */     // MIs[0] policy
     /* 1602542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602576 */     // GIR_Coverage, 3270,
     /* 1602576 */     GIR_EraseRootFromParent_Done,
     /* 1602577 */   // Label 22155: @1602577
     /* 1602577 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1602663), // Rule ID 3271 //
     /* 1602582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602628 */     // MIs[0] policy
     /* 1602628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602662 */     // GIR_Coverage, 3271,
     /* 1602662 */     GIR_EraseRootFromParent_Done,
     /* 1602663 */   // Label 22156: @1602663
     /* 1602663 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1602749), // Rule ID 3274 //
     /* 1602668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602714 */     // MIs[0] policy
     /* 1602714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602748 */     // GIR_Coverage, 3274,
     /* 1602748 */     GIR_EraseRootFromParent_Done,
     /* 1602749 */   // Label 22157: @1602749
     /* 1602749 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1602835), // Rule ID 3275 //
     /* 1602754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602800 */     // MIs[0] policy
     /* 1602800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602834 */     // GIR_Coverage, 3275,
     /* 1602834 */     GIR_EraseRootFromParent_Done,
     /* 1602835 */   // Label 22158: @1602835
     /* 1602835 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1602921), // Rule ID 3278 //
     /* 1602840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602886 */     // MIs[0] policy
     /* 1602886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602920 */     // GIR_Coverage, 3278,
     /* 1602920 */     GIR_EraseRootFromParent_Done,
     /* 1602921 */   // Label 22159: @1602921
     /* 1602921 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1603007), // Rule ID 3279 //
     /* 1602926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602972 */     // MIs[0] policy
     /* 1602972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1603003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603006 */     // GIR_Coverage, 3279,
     /* 1603006 */     GIR_EraseRootFromParent_Done,
     /* 1603007 */   // Label 22160: @1603007
     /* 1603007 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1603093), // Rule ID 3282 //
     /* 1603012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1603032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603058 */     // MIs[0] policy
     /* 1603058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603092 */     // GIR_Coverage, 3282,
     /* 1603092 */     GIR_EraseRootFromParent_Done,
     /* 1603093 */   // Label 22161: @1603093
     /* 1603093 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1603179), // Rule ID 3283 //
     /* 1603098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1603118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603144 */     // MIs[0] policy
     /* 1603144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603178 */     // GIR_Coverage, 3283,
     /* 1603178 */     GIR_EraseRootFromParent_Done,
     /* 1603179 */   // Label 22162: @1603179
     /* 1603179 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1603265), // Rule ID 3286 //
     /* 1603184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1603204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603230 */     // MIs[0] policy
     /* 1603230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603264 */     // GIR_Coverage, 3286,
     /* 1603264 */     GIR_EraseRootFromParent_Done,
     /* 1603265 */   // Label 22163: @1603265
     /* 1603265 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1603351), // Rule ID 3287 //
     /* 1603270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1603290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603316 */     // MIs[0] policy
     /* 1603316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603326 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603350 */     // GIR_Coverage, 3287,
     /* 1603350 */     GIR_EraseRootFromParent_Done,
     /* 1603351 */   // Label 22164: @1603351
     /* 1603351 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1603437), // Rule ID 3290 //
     /* 1603356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1603376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603402 */     // MIs[0] policy
     /* 1603402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603412 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603436 */     // GIR_Coverage, 3290,
     /* 1603436 */     GIR_EraseRootFromParent_Done,
     /* 1603437 */   // Label 22165: @1603437
     /* 1603437 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1603523), // Rule ID 3291 //
     /* 1603442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1603462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603488 */     // MIs[0] policy
     /* 1603488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603498 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603522 */     // GIR_Coverage, 3291,
     /* 1603522 */     GIR_EraseRootFromParent_Done,
     /* 1603523 */   // Label 22166: @1603523
     /* 1603523 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1603609), // Rule ID 3294 //
     /* 1603528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603574 */     // MIs[0] policy
     /* 1603574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603608 */     // GIR_Coverage, 3294,
     /* 1603608 */     GIR_EraseRootFromParent_Done,
     /* 1603609 */   // Label 22167: @1603609
     /* 1603609 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1603695), // Rule ID 3295 //
     /* 1603614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603660 */     // MIs[0] policy
     /* 1603660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603694 */     // GIR_Coverage, 3295,
     /* 1603694 */     GIR_EraseRootFromParent_Done,
     /* 1603695 */   // Label 22168: @1603695
     /* 1603695 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1603781), // Rule ID 3298 //
     /* 1603700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603746 */     // MIs[0] policy
     /* 1603746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603780 */     // GIR_Coverage, 3298,
     /* 1603780 */     GIR_EraseRootFromParent_Done,
     /* 1603781 */   // Label 22169: @1603781
     /* 1603781 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1603867), // Rule ID 3299 //
     /* 1603786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603832 */     // MIs[0] policy
     /* 1603832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603866 */     // GIR_Coverage, 3299,
     /* 1603866 */     GIR_EraseRootFromParent_Done,
     /* 1603867 */   // Label 22170: @1603867
     /* 1603867 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1603953), // Rule ID 3302 //
     /* 1603872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603918 */     // MIs[0] policy
     /* 1603918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603952 */     // GIR_Coverage, 3302,
     /* 1603952 */     GIR_EraseRootFromParent_Done,
     /* 1603953 */   // Label 22171: @1603953
     /* 1603953 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1604039), // Rule ID 3303 //
     /* 1603958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604004 */     // MIs[0] policy
     /* 1604004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604038 */     // GIR_Coverage, 3303,
     /* 1604038 */     GIR_EraseRootFromParent_Done,
     /* 1604039 */   // Label 22172: @1604039
     /* 1604039 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1604125), // Rule ID 3306 //
     /* 1604044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1604064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604090 */     // MIs[0] policy
     /* 1604090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604124 */     // GIR_Coverage, 3306,
     /* 1604124 */     GIR_EraseRootFromParent_Done,
     /* 1604125 */   // Label 22173: @1604125
     /* 1604125 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1604211), // Rule ID 3307 //
     /* 1604130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1604150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604176 */     // MIs[0] policy
     /* 1604176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604210 */     // GIR_Coverage, 3307,
     /* 1604210 */     GIR_EraseRootFromParent_Done,
     /* 1604211 */   // Label 22174: @1604211
     /* 1604211 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1604297), // Rule ID 3310 //
     /* 1604216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1604236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604262 */     // MIs[0] policy
     /* 1604262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604296 */     // GIR_Coverage, 3310,
     /* 1604296 */     GIR_EraseRootFromParent_Done,
     /* 1604297 */   // Label 22175: @1604297
     /* 1604297 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1604383), // Rule ID 3311 //
     /* 1604302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1604322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604348 */     // MIs[0] policy
     /* 1604348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604382 */     // GIR_Coverage, 3311,
     /* 1604382 */     GIR_EraseRootFromParent_Done,
     /* 1604383 */   // Label 22176: @1604383
     /* 1604383 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1604469), // Rule ID 3314 //
     /* 1604388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604434 */     // MIs[0] policy
     /* 1604434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604468 */     // GIR_Coverage, 3314,
     /* 1604468 */     GIR_EraseRootFromParent_Done,
     /* 1604469 */   // Label 22177: @1604469
     /* 1604469 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1604555), // Rule ID 3315 //
     /* 1604474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604520 */     // MIs[0] policy
     /* 1604520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604554 */     // GIR_Coverage, 3315,
     /* 1604554 */     GIR_EraseRootFromParent_Done,
     /* 1604555 */   // Label 22178: @1604555
     /* 1604555 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1604641), // Rule ID 3318 //
     /* 1604560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604606 */     // MIs[0] policy
     /* 1604606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604640 */     // GIR_Coverage, 3318,
     /* 1604640 */     GIR_EraseRootFromParent_Done,
     /* 1604641 */   // Label 22179: @1604641
     /* 1604641 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1604727), // Rule ID 3319 //
     /* 1604646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604692 */     // MIs[0] policy
     /* 1604692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604726 */     // GIR_Coverage, 3319,
     /* 1604726 */     GIR_EraseRootFromParent_Done,
     /* 1604727 */   // Label 22180: @1604727
     /* 1604727 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1604813), // Rule ID 3322 //
     /* 1604732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604778 */     // MIs[0] policy
     /* 1604778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604812 */     // GIR_Coverage, 3322,
     /* 1604812 */     GIR_EraseRootFromParent_Done,
     /* 1604813 */   // Label 22181: @1604813
     /* 1604813 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1604899), // Rule ID 3323 //
     /* 1604818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604864 */     // MIs[0] policy
     /* 1604864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604898 */     // GIR_Coverage, 3323,
     /* 1604898 */     GIR_EraseRootFromParent_Done,
     /* 1604899 */   // Label 22182: @1604899
     /* 1604899 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1604985), // Rule ID 3326 //
     /* 1604904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604950 */     // MIs[0] policy
     /* 1604950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604984 */     // GIR_Coverage, 3326,
     /* 1604984 */     GIR_EraseRootFromParent_Done,
     /* 1604985 */   // Label 22183: @1604985
     /* 1604985 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1605071), // Rule ID 3327 //
     /* 1604990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1605001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1605004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1605010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605036 */     // MIs[0] policy
     /* 1605036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1605049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605070 */     // GIR_Coverage, 3327,
     /* 1605070 */     GIR_EraseRootFromParent_Done,
     /* 1605071 */   // Label 22184: @1605071
     /* 1605071 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1605157), // Rule ID 3330 //
     /* 1605076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1605087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1605090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605122 */     // MIs[0] policy
     /* 1605122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1605135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605156 */     // GIR_Coverage, 3330,
     /* 1605156 */     GIR_EraseRootFromParent_Done,
     /* 1605157 */   // Label 22185: @1605157
     /* 1605157 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1605243), // Rule ID 3331 //
     /* 1605162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1605173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1605176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605208 */     // MIs[0] policy
     /* 1605208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1605221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605242 */     // GIR_Coverage, 3331,
     /* 1605242 */     GIR_EraseRootFromParent_Done,
     /* 1605243 */   // Label 22186: @1605243
     /* 1605243 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1605329), // Rule ID 3334 //
     /* 1605248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1605259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1605262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605294 */     // MIs[0] policy
     /* 1605294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605304 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605328 */     // GIR_Coverage, 3334,
     /* 1605328 */     GIR_EraseRootFromParent_Done,
     /* 1605329 */   // Label 22187: @1605329
     /* 1605329 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1605415), // Rule ID 3335 //
     /* 1605334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1605345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1605348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605380 */     // MIs[0] policy
     /* 1605380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605414 */     // GIR_Coverage, 3335,
     /* 1605414 */     GIR_EraseRootFromParent_Done,
     /* 1605415 */   // Label 22188: @1605415
     /* 1605415 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1605501), // Rule ID 3338 //
     /* 1605420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605466 */     // MIs[0] policy
     /* 1605466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605476 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605500 */     // GIR_Coverage, 3338,
     /* 1605500 */     GIR_EraseRootFromParent_Done,
     /* 1605501 */   // Label 22189: @1605501
     /* 1605501 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1605587), // Rule ID 3339 //
     /* 1605506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605552 */     // MIs[0] policy
     /* 1605552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605562 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605586 */     // GIR_Coverage, 3339,
     /* 1605586 */     GIR_EraseRootFromParent_Done,
     /* 1605587 */   // Label 22190: @1605587
     /* 1605587 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1605673), // Rule ID 3342 //
     /* 1605592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605638 */     // MIs[0] policy
     /* 1605638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605672 */     // GIR_Coverage, 3342,
     /* 1605672 */     GIR_EraseRootFromParent_Done,
     /* 1605673 */   // Label 22191: @1605673
     /* 1605673 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1605759), // Rule ID 3343 //
     /* 1605678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605724 */     // MIs[0] policy
     /* 1605724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605758 */     // GIR_Coverage, 3343,
     /* 1605758 */     GIR_EraseRootFromParent_Done,
     /* 1605759 */   // Label 22192: @1605759
     /* 1605759 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1605845), // Rule ID 3346 //
     /* 1605764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605810 */     // MIs[0] policy
     /* 1605810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605844 */     // GIR_Coverage, 3346,
     /* 1605844 */     GIR_EraseRootFromParent_Done,
     /* 1605845 */   // Label 22193: @1605845
     /* 1605845 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1605931), // Rule ID 3347 //
     /* 1605850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605896 */     // MIs[0] policy
     /* 1605896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605930 */     // GIR_Coverage, 3347,
     /* 1605930 */     GIR_EraseRootFromParent_Done,
     /* 1605931 */   // Label 22194: @1605931
     /* 1605931 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1606017), // Rule ID 3350 //
     /* 1605936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605982 */     // MIs[0] policy
     /* 1605982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606016 */     // GIR_Coverage, 3350,
     /* 1606016 */     GIR_EraseRootFromParent_Done,
     /* 1606017 */   // Label 22195: @1606017
     /* 1606017 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1606103), // Rule ID 3351 //
     /* 1606022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1606033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1606036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1606039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606068 */     // MIs[0] policy
     /* 1606068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1606081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606102 */     // GIR_Coverage, 3351,
     /* 1606102 */     GIR_EraseRootFromParent_Done,
     /* 1606103 */   // Label 22196: @1606103
     /* 1606103 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1606189), // Rule ID 3354 //
     /* 1606108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606154 */     // MIs[0] policy
     /* 1606154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606188 */     // GIR_Coverage, 3354,
     /* 1606188 */     GIR_EraseRootFromParent_Done,
     /* 1606189 */   // Label 22197: @1606189
     /* 1606189 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1606275), // Rule ID 3355 //
     /* 1606194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1606205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1606208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606240 */     // MIs[0] policy
     /* 1606240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11678:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606274 */     // GIR_Coverage, 3355,
     /* 1606274 */     GIR_EraseRootFromParent_Done,
     /* 1606275 */   // Label 22198: @1606275
     /* 1606275 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1606361), // Rule ID 3358 //
     /* 1606280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1606291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1606294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606326 */     // MIs[0] policy
     /* 1606326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606360 */     // GIR_Coverage, 3358,
     /* 1606360 */     GIR_EraseRootFromParent_Done,
     /* 1606361 */   // Label 22199: @1606361
     /* 1606361 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1606447), // Rule ID 3359 //
     /* 1606366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1606377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1606380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606412 */     // MIs[0] policy
     /* 1606412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606446 */     // GIR_Coverage, 3359,
     /* 1606446 */     GIR_EraseRootFromParent_Done,
     /* 1606447 */   // Label 22200: @1606447
     /* 1606447 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1606533), // Rule ID 3362 //
     /* 1606452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606498 */     // MIs[0] policy
     /* 1606498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606532 */     // GIR_Coverage, 3362,
     /* 1606532 */     GIR_EraseRootFromParent_Done,
     /* 1606533 */   // Label 22201: @1606533
     /* 1606533 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1606619), // Rule ID 3363 //
     /* 1606538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606584 */     // MIs[0] policy
     /* 1606584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606618 */     // GIR_Coverage, 3363,
     /* 1606618 */     GIR_EraseRootFromParent_Done,
     /* 1606619 */   // Label 22202: @1606619
     /* 1606619 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1606705), // Rule ID 3366 //
     /* 1606624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1606627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606670 */     // MIs[0] policy
     /* 1606670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606704 */     // GIR_Coverage, 3366,
     /* 1606704 */     GIR_EraseRootFromParent_Done,
     /* 1606705 */   // Label 22203: @1606705
     /* 1606705 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1606791), // Rule ID 3367 //
     /* 1606710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606756 */     // MIs[0] policy
     /* 1606756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606790 */     // GIR_Coverage, 3367,
     /* 1606790 */     GIR_EraseRootFromParent_Done,
     /* 1606791 */   // Label 22204: @1606791
     /* 1606791 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1606877), // Rule ID 3370 //
     /* 1606796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606842 */     // MIs[0] policy
     /* 1606842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606876 */     // GIR_Coverage, 3370,
     /* 1606876 */     GIR_EraseRootFromParent_Done,
     /* 1606877 */   // Label 22205: @1606877
     /* 1606877 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1606963), // Rule ID 3371 //
     /* 1606882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606928 */     // MIs[0] policy
     /* 1606928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606962 */     // GIR_Coverage, 3371,
     /* 1606962 */     GIR_EraseRootFromParent_Done,
     /* 1606963 */   // Label 22206: @1606963
     /* 1606963 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1607049), // Rule ID 3374 //
     /* 1606968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607014 */     // MIs[0] policy
     /* 1607014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607048 */     // GIR_Coverage, 3374,
     /* 1607048 */     GIR_EraseRootFromParent_Done,
     /* 1607049 */   // Label 22207: @1607049
     /* 1607049 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1607135), // Rule ID 3375 //
     /* 1607054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1607065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1607068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1607071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607100 */     // MIs[0] policy
     /* 1607100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607110 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607134 */     // GIR_Coverage, 3375,
     /* 1607134 */     GIR_EraseRootFromParent_Done,
     /* 1607135 */   // Label 22208: @1607135
     /* 1607135 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1607221), // Rule ID 3378 //
     /* 1607140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1607151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1607154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1607157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1607163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607186 */     // MIs[0] policy
     /* 1607186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607220 */     // GIR_Coverage, 3378,
     /* 1607220 */     GIR_EraseRootFromParent_Done,
     /* 1607221 */   // Label 22209: @1607221
     /* 1607221 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1607307), // Rule ID 3379 //
     /* 1607226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1607237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1607240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1607243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1607249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607272 */     // MIs[0] policy
     /* 1607272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607306 */     // GIR_Coverage, 3379,
     /* 1607306 */     GIR_EraseRootFromParent_Done,
     /* 1607307 */   // Label 22210: @1607307
     /* 1607307 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1607393), // Rule ID 3382 //
     /* 1607312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607358 */     // MIs[0] policy
     /* 1607358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607392 */     // GIR_Coverage, 3382,
     /* 1607392 */     GIR_EraseRootFromParent_Done,
     /* 1607393 */   // Label 22211: @1607393
     /* 1607393 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1607479), // Rule ID 3383 //
     /* 1607398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1607409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1607412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607444 */     // MIs[0] policy
     /* 1607444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607478 */     // GIR_Coverage, 3383,
     /* 1607478 */     GIR_EraseRootFromParent_Done,
     /* 1607479 */   // Label 22212: @1607479
     /* 1607479 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1607565), // Rule ID 3386 //
     /* 1607484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607530 */     // MIs[0] policy
     /* 1607530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607564 */     // GIR_Coverage, 3386,
     /* 1607564 */     GIR_EraseRootFromParent_Done,
     /* 1607565 */   // Label 22213: @1607565
     /* 1607565 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1607651), // Rule ID 3387 //
     /* 1607570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607616 */     // MIs[0] policy
     /* 1607616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607650 */     // GIR_Coverage, 3387,
     /* 1607650 */     GIR_EraseRootFromParent_Done,
     /* 1607651 */   // Label 22214: @1607651
     /* 1607651 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1607737), // Rule ID 3390 //
     /* 1607656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607702 */     // MIs[0] policy
     /* 1607702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607736 */     // GIR_Coverage, 3390,
     /* 1607736 */     GIR_EraseRootFromParent_Done,
     /* 1607737 */   // Label 22215: @1607737
     /* 1607737 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1607823), // Rule ID 3391 //
     /* 1607742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607788 */     // MIs[0] policy
     /* 1607788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607822 */     // GIR_Coverage, 3391,
     /* 1607822 */     GIR_EraseRootFromParent_Done,
     /* 1607823 */   // Label 22216: @1607823
     /* 1607823 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1607909), // Rule ID 3394 //
     /* 1607828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607874 */     // MIs[0] policy
     /* 1607874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607908 */     // GIR_Coverage, 3394,
     /* 1607908 */     GIR_EraseRootFromParent_Done,
     /* 1607909 */   // Label 22217: @1607909
     /* 1607909 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1607995), // Rule ID 3395 //
     /* 1607914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607960 */     // MIs[0] policy
     /* 1607960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607994 */     // GIR_Coverage, 3395,
     /* 1607994 */     GIR_EraseRootFromParent_Done,
     /* 1607995 */   // Label 22218: @1607995
     /* 1607995 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1608081), // Rule ID 3398 //
     /* 1608000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608046 */     // MIs[0] policy
     /* 1608046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608080 */     // GIR_Coverage, 3398,
     /* 1608080 */     GIR_EraseRootFromParent_Done,
     /* 1608081 */   // Label 22219: @1608081
     /* 1608081 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1608167), // Rule ID 3399 //
     /* 1608086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1608097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1608100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608132 */     // MIs[0] policy
     /* 1608132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608166 */     // GIR_Coverage, 3399,
     /* 1608166 */     GIR_EraseRootFromParent_Done,
     /* 1608167 */   // Label 22220: @1608167
     /* 1608167 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1608253), // Rule ID 3402 //
     /* 1608172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1608183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1608186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1608189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608218 */     // MIs[0] policy
     /* 1608218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608252 */     // GIR_Coverage, 3402,
     /* 1608252 */     GIR_EraseRootFromParent_Done,
     /* 1608253 */   // Label 22221: @1608253
     /* 1608253 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1608339), // Rule ID 3403 //
     /* 1608258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1608269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1608272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1608275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608304 */     // MIs[0] policy
     /* 1608304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608314 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608338 */     // GIR_Coverage, 3403,
     /* 1608338 */     GIR_EraseRootFromParent_Done,
     /* 1608339 */   // Label 22222: @1608339
     /* 1608339 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1608425), // Rule ID 3406 //
     /* 1608344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1608355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1608358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608390 */     // MIs[0] policy
     /* 1608390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608424 */     // GIR_Coverage, 3406,
     /* 1608424 */     GIR_EraseRootFromParent_Done,
     /* 1608425 */   // Label 22223: @1608425
     /* 1608425 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1608511), // Rule ID 3407 //
     /* 1608430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1608441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1608444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1608447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608476 */     // MIs[0] policy
     /* 1608476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608510 */     // GIR_Coverage, 3407,
     /* 1608510 */     GIR_EraseRootFromParent_Done,
     /* 1608511 */   // Label 22224: @1608511
     /* 1608511 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1608597), // Rule ID 3410 //
     /* 1608516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608562 */     // MIs[0] policy
     /* 1608562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608596 */     // GIR_Coverage, 3410,
     /* 1608596 */     GIR_EraseRootFromParent_Done,
     /* 1608597 */   // Label 22225: @1608597
     /* 1608597 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1608683), // Rule ID 3411 //
     /* 1608602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608648 */     // MIs[0] policy
     /* 1608648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608682 */     // GIR_Coverage, 3411,
     /* 1608682 */     GIR_EraseRootFromParent_Done,
     /* 1608683 */   // Label 22226: @1608683
     /* 1608683 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1608769), // Rule ID 3414 //
     /* 1608688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608734 */     // MIs[0] policy
     /* 1608734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608768 */     // GIR_Coverage, 3414,
     /* 1608768 */     GIR_EraseRootFromParent_Done,
     /* 1608769 */   // Label 22227: @1608769
     /* 1608769 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1608855), // Rule ID 3415 //
     /* 1608774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608820 */     // MIs[0] policy
     /* 1608820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608854 */     // GIR_Coverage, 3415,
     /* 1608854 */     GIR_EraseRootFromParent_Done,
     /* 1608855 */   // Label 22228: @1608855
     /* 1608855 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1608941), // Rule ID 3418 //
     /* 1608860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608906 */     // MIs[0] policy
     /* 1608906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608940 */     // GIR_Coverage, 3418,
     /* 1608940 */     GIR_EraseRootFromParent_Done,
     /* 1608941 */   // Label 22229: @1608941
     /* 1608941 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1609027), // Rule ID 3419 //
     /* 1608946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608992 */     // MIs[0] policy
     /* 1608992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1609005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609026 */     // GIR_Coverage, 3419,
     /* 1609026 */     GIR_EraseRootFromParent_Done,
     /* 1609027 */   // Label 22230: @1609027
     /* 1609027 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1609113), // Rule ID 3422 //
     /* 1609032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1609043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1609046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1609049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609078 */     // MIs[0] policy
     /* 1609078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609088 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609112 */     // GIR_Coverage, 3422,
     /* 1609112 */     GIR_EraseRootFromParent_Done,
     /* 1609113 */   // Label 22231: @1609113
     /* 1609113 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1609199), // Rule ID 3423 //
     /* 1609118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1609129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1609132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1609135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609164 */     // MIs[0] policy
     /* 1609164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609198 */     // GIR_Coverage, 3423,
     /* 1609198 */     GIR_EraseRootFromParent_Done,
     /* 1609199 */   // Label 22232: @1609199
     /* 1609199 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1609285), // Rule ID 3426 //
     /* 1609204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1609215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1609218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1609221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609250 */     // MIs[0] policy
     /* 1609250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609284 */     // GIR_Coverage, 3426,
     /* 1609284 */     GIR_EraseRootFromParent_Done,
     /* 1609285 */   // Label 22233: @1609285
     /* 1609285 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1609371), // Rule ID 3427 //
     /* 1609290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1609301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1609304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1609307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609336 */     // MIs[0] policy
     /* 1609336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609346 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609370 */     // GIR_Coverage, 3427,
     /* 1609370 */     GIR_EraseRootFromParent_Done,
     /* 1609371 */   // Label 22234: @1609371
     /* 1609371 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1609457), // Rule ID 3430 //
     /* 1609376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609422 */     // MIs[0] policy
     /* 1609422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609432 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609456 */     // GIR_Coverage, 3430,
     /* 1609456 */     GIR_EraseRootFromParent_Done,
     /* 1609457 */   // Label 22235: @1609457
     /* 1609457 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1609543), // Rule ID 3431 //
     /* 1609462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609508 */     // MIs[0] policy
     /* 1609508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609542 */     // GIR_Coverage, 3431,
     /* 1609542 */     GIR_EraseRootFromParent_Done,
     /* 1609543 */   // Label 22236: @1609543
     /* 1609543 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1609629), // Rule ID 3434 //
     /* 1609548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609594 */     // MIs[0] policy
     /* 1609594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609628 */     // GIR_Coverage, 3434,
     /* 1609628 */     GIR_EraseRootFromParent_Done,
     /* 1609629 */   // Label 22237: @1609629
     /* 1609629 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1609715), // Rule ID 3435 //
     /* 1609634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609680 */     // MIs[0] policy
     /* 1609680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609690 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609714 */     // GIR_Coverage, 3435,
     /* 1609714 */     GIR_EraseRootFromParent_Done,
     /* 1609715 */   // Label 22238: @1609715
     /* 1609715 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1609801), // Rule ID 3438 //
     /* 1609720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609766 */     // MIs[0] policy
     /* 1609766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609800 */     // GIR_Coverage, 3438,
     /* 1609800 */     GIR_EraseRootFromParent_Done,
     /* 1609801 */   // Label 22239: @1609801
     /* 1609801 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1609887), // Rule ID 3439 //
     /* 1609806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609852 */     // MIs[0] policy
     /* 1609852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609862 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609886 */     // GIR_Coverage, 3439,
     /* 1609886 */     GIR_EraseRootFromParent_Done,
     /* 1609887 */   // Label 22240: @1609887
     /* 1609887 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1609973), // Rule ID 3442 //
     /* 1609892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609938 */     // MIs[0] policy
     /* 1609938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609972 */     // GIR_Coverage, 3442,
     /* 1609972 */     GIR_EraseRootFromParent_Done,
     /* 1609973 */   // Label 22241: @1609973
     /* 1609973 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1610059), // Rule ID 3443 //
     /* 1609978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610024 */     // MIs[0] policy
     /* 1610024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11586:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610058 */     // GIR_Coverage, 3443,
     /* 1610058 */     GIR_EraseRootFromParent_Done,
     /* 1610059 */   // Label 22242: @1610059
     /* 1610059 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1610145), // Rule ID 3446 //
     /* 1610064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1610081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610110 */     // MIs[0] policy
     /* 1610110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610144 */     // GIR_Coverage, 3446,
     /* 1610144 */     GIR_EraseRootFromParent_Done,
     /* 1610145 */   // Label 22243: @1610145
     /* 1610145 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1610231), // Rule ID 3447 //
     /* 1610150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1610167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610196 */     // MIs[0] policy
     /* 1610196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610230 */     // GIR_Coverage, 3447,
     /* 1610230 */     GIR_EraseRootFromParent_Done,
     /* 1610231 */   // Label 22244: @1610231
     /* 1610231 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1610317), // Rule ID 3450 //
     /* 1610236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1610247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1610250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610282 */     // MIs[0] policy
     /* 1610282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610316 */     // GIR_Coverage, 3450,
     /* 1610316 */     GIR_EraseRootFromParent_Done,
     /* 1610317 */   // Label 22245: @1610317
     /* 1610317 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1610403), // Rule ID 3451 //
     /* 1610322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1610333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1610336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610368 */     // MIs[0] policy
     /* 1610368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610402 */     // GIR_Coverage, 3451,
     /* 1610402 */     GIR_EraseRootFromParent_Done,
     /* 1610403 */   // Label 22246: @1610403
     /* 1610403 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1610489), // Rule ID 3454 //
     /* 1610408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1610411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610454 */     // MIs[0] policy
     /* 1610454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610488 */     // GIR_Coverage, 3454,
     /* 1610488 */     GIR_EraseRootFromParent_Done,
     /* 1610489 */   // Label 22247: @1610489
     /* 1610489 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1610575), // Rule ID 3455 //
     /* 1610494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610540 */     // MIs[0] policy
     /* 1610540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610574 */     // GIR_Coverage, 3455,
     /* 1610574 */     GIR_EraseRootFromParent_Done,
     /* 1610575 */   // Label 22248: @1610575
     /* 1610575 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1610661), // Rule ID 3458 //
     /* 1610580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610626 */     // MIs[0] policy
     /* 1610626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610660 */     // GIR_Coverage, 3458,
     /* 1610660 */     GIR_EraseRootFromParent_Done,
     /* 1610661 */   // Label 22249: @1610661
     /* 1610661 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1610747), // Rule ID 3459 //
     /* 1610666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610712 */     // MIs[0] policy
     /* 1610712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610722 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610746 */     // GIR_Coverage, 3459,
     /* 1610746 */     GIR_EraseRootFromParent_Done,
     /* 1610747 */   // Label 22250: @1610747
     /* 1610747 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1610833), // Rule ID 3462 //
     /* 1610752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610798 */     // MIs[0] policy
     /* 1610798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610832 */     // GIR_Coverage, 3462,
     /* 1610832 */     GIR_EraseRootFromParent_Done,
     /* 1610833 */   // Label 22251: @1610833
     /* 1610833 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1610919), // Rule ID 3463 //
     /* 1610838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610884 */     // MIs[0] policy
     /* 1610884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610918 */     // GIR_Coverage, 3463,
     /* 1610918 */     GIR_EraseRootFromParent_Done,
     /* 1610919 */   // Label 22252: @1610919
     /* 1610919 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1611005), // Rule ID 3466 //
     /* 1610924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610970 */     // MIs[0] policy
     /* 1610970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611004 */     // GIR_Coverage, 3466,
     /* 1611004 */     GIR_EraseRootFromParent_Done,
     /* 1611005 */   // Label 22253: @1611005
     /* 1611005 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1611091), // Rule ID 3467 //
     /* 1611010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1611021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1611024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1611027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1611033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611056 */     // MIs[0] policy
     /* 1611056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611066 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611090 */     // GIR_Coverage, 3467,
     /* 1611090 */     GIR_EraseRootFromParent_Done,
     /* 1611091 */   // Label 22254: @1611091
     /* 1611091 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1611177), // Rule ID 3470 //
     /* 1611096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611142 */     // MIs[0] policy
     /* 1611142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611176 */     // GIR_Coverage, 3470,
     /* 1611176 */     GIR_EraseRootFromParent_Done,
     /* 1611177 */   // Label 22255: @1611177
     /* 1611177 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1611263), // Rule ID 3471 //
     /* 1611182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611228 */     // MIs[0] policy
     /* 1611228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611262 */     // GIR_Coverage, 3471,
     /* 1611262 */     GIR_EraseRootFromParent_Done,
     /* 1611263 */   // Label 22256: @1611263
     /* 1611263 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1611349), // Rule ID 3474 //
     /* 1611268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611314 */     // MIs[0] policy
     /* 1611314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611348 */     // GIR_Coverage, 3474,
     /* 1611348 */     GIR_EraseRootFromParent_Done,
     /* 1611349 */   // Label 22257: @1611349
     /* 1611349 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1611435), // Rule ID 3475 //
     /* 1611354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611400 */     // MIs[0] policy
     /* 1611400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611434 */     // GIR_Coverage, 3475,
     /* 1611434 */     GIR_EraseRootFromParent_Done,
     /* 1611435 */   // Label 22258: @1611435
     /* 1611435 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1611521), // Rule ID 3478 //
     /* 1611440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611486 */     // MIs[0] policy
     /* 1611486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611496 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611520 */     // GIR_Coverage, 3478,
     /* 1611520 */     GIR_EraseRootFromParent_Done,
     /* 1611521 */   // Label 22259: @1611521
     /* 1611521 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1611607), // Rule ID 3479 //
     /* 1611526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611572 */     // MIs[0] policy
     /* 1611572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611582 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611606 */     // GIR_Coverage, 3479,
     /* 1611606 */     GIR_EraseRootFromParent_Done,
     /* 1611607 */   // Label 22260: @1611607
     /* 1611607 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1611693), // Rule ID 3482 //
     /* 1611612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611658 */     // MIs[0] policy
     /* 1611658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611692 */     // GIR_Coverage, 3482,
     /* 1611692 */     GIR_EraseRootFromParent_Done,
     /* 1611693 */   // Label 22261: @1611693
     /* 1611693 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1611779), // Rule ID 3483 //
     /* 1611698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611744 */     // MIs[0] policy
     /* 1611744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611778 */     // GIR_Coverage, 3483,
     /* 1611778 */     GIR_EraseRootFromParent_Done,
     /* 1611779 */   // Label 22262: @1611779
     /* 1611779 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1611865), // Rule ID 3486 //
     /* 1611784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611830 */     // MIs[0] policy
     /* 1611830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611864 */     // GIR_Coverage, 3486,
     /* 1611864 */     GIR_EraseRootFromParent_Done,
     /* 1611865 */   // Label 22263: @1611865
     /* 1611865 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1611951), // Rule ID 3487 //
     /* 1611870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611916 */     // MIs[0] policy
     /* 1611916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611950 */     // GIR_Coverage, 3487,
     /* 1611950 */     GIR_EraseRootFromParent_Done,
     /* 1611951 */   // Label 22264: @1611951
     /* 1611951 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1612037), // Rule ID 3490 //
     /* 1611956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612002 */     // MIs[0] policy
     /* 1612002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612036 */     // GIR_Coverage, 3490,
     /* 1612036 */     GIR_EraseRootFromParent_Done,
     /* 1612037 */   // Label 22265: @1612037
     /* 1612037 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1612123), // Rule ID 3491 //
     /* 1612042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1612053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1612056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1612059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612088 */     // MIs[0] policy
     /* 1612088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612122 */     // GIR_Coverage, 3491,
     /* 1612122 */     GIR_EraseRootFromParent_Done,
     /* 1612123 */   // Label 22266: @1612123
     /* 1612123 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1612209), // Rule ID 3494 //
     /* 1612128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1612145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612174 */     // MIs[0] policy
     /* 1612174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1612187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612208 */     // GIR_Coverage, 3494,
     /* 1612208 */     GIR_EraseRootFromParent_Done,
     /* 1612209 */   // Label 22267: @1612209
     /* 1612209 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1612295), // Rule ID 3495 //
     /* 1612214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1612231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612260 */     // MIs[0] policy
     /* 1612260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1612273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612294 */     // GIR_Coverage, 3495,
     /* 1612294 */     GIR_EraseRootFromParent_Done,
     /* 1612295 */   // Label 22268: @1612295
     /* 1612295 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1612381), // Rule ID 3498 //
     /* 1612300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612346 */     // MIs[0] policy
     /* 1612346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1612359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612380 */     // GIR_Coverage, 3498,
     /* 1612380 */     GIR_EraseRootFromParent_Done,
     /* 1612381 */   // Label 22269: @1612381
     /* 1612381 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1612467), // Rule ID 3499 //
     /* 1612386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1612403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612432 */     // MIs[0] policy
     /* 1612432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1612445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612466 */     // GIR_Coverage, 3499,
     /* 1612466 */     GIR_EraseRootFromParent_Done,
     /* 1612467 */   // Label 22270: @1612467
     /* 1612467 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1612553), // Rule ID 3502 //
     /* 1612472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612518 */     // MIs[0] policy
     /* 1612518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612552 */     // GIR_Coverage, 3502,
     /* 1612552 */     GIR_EraseRootFromParent_Done,
     /* 1612553 */   // Label 22271: @1612553
     /* 1612553 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1612639), // Rule ID 3503 //
     /* 1612558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612604 */     // MIs[0] policy
     /* 1612604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612638 */     // GIR_Coverage, 3503,
     /* 1612638 */     GIR_EraseRootFromParent_Done,
     /* 1612639 */   // Label 22272: @1612639
     /* 1612639 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1612725), // Rule ID 3594 //
     /* 1612644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612690 */     // MIs[0] policy
     /* 1612690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612724 */     // GIR_Coverage, 3594,
     /* 1612724 */     GIR_EraseRootFromParent_Done,
     /* 1612725 */   // Label 22273: @1612725
     /* 1612725 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1612811), // Rule ID 3595 //
     /* 1612730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612776 */     // MIs[0] policy
     /* 1612776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612810 */     // GIR_Coverage, 3595,
     /* 1612810 */     GIR_EraseRootFromParent_Done,
     /* 1612811 */   // Label 22274: @1612811
     /* 1612811 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1612897), // Rule ID 3598 //
     /* 1612816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612862 */     // MIs[0] policy
     /* 1612862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612896 */     // GIR_Coverage, 3598,
     /* 1612896 */     GIR_EraseRootFromParent_Done,
     /* 1612897 */   // Label 22275: @1612897
     /* 1612897 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1612983), // Rule ID 3599 //
     /* 1612902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612948 */     // MIs[0] policy
     /* 1612948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612982 */     // GIR_Coverage, 3599,
     /* 1612982 */     GIR_EraseRootFromParent_Done,
     /* 1612983 */   // Label 22276: @1612983
     /* 1612983 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1613069), // Rule ID 3602 //
     /* 1612988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1613008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613034 */     // MIs[0] policy
     /* 1613034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613068 */     // GIR_Coverage, 3602,
     /* 1613068 */     GIR_EraseRootFromParent_Done,
     /* 1613069 */   // Label 22277: @1613069
     /* 1613069 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1613155), // Rule ID 3603 //
     /* 1613074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1613094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613120 */     // MIs[0] policy
     /* 1613120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613154 */     // GIR_Coverage, 3603,
     /* 1613154 */     GIR_EraseRootFromParent_Done,
     /* 1613155 */   // Label 22278: @1613155
     /* 1613155 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1613241), // Rule ID 3606 //
     /* 1613160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1613180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613206 */     // MIs[0] policy
     /* 1613206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613240 */     // GIR_Coverage, 3606,
     /* 1613240 */     GIR_EraseRootFromParent_Done,
     /* 1613241 */   // Label 22279: @1613241
     /* 1613241 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1613327), // Rule ID 3607 //
     /* 1613246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1613266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613292 */     // MIs[0] policy
     /* 1613292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613326 */     // GIR_Coverage, 3607,
     /* 1613326 */     GIR_EraseRootFromParent_Done,
     /* 1613327 */   // Label 22280: @1613327
     /* 1613327 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1613413), // Rule ID 3610 //
     /* 1613332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1613352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613378 */     // MIs[0] policy
     /* 1613378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613412 */     // GIR_Coverage, 3610,
     /* 1613412 */     GIR_EraseRootFromParent_Done,
     /* 1613413 */   // Label 22281: @1613413
     /* 1613413 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1613499), // Rule ID 3611 //
     /* 1613418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1613438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613464 */     // MIs[0] policy
     /* 1613464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613498 */     // GIR_Coverage, 3611,
     /* 1613498 */     GIR_EraseRootFromParent_Done,
     /* 1613499 */   // Label 22282: @1613499
     /* 1613499 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1613585), // Rule ID 3614 //
     /* 1613504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613550 */     // MIs[0] policy
     /* 1613550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613584 */     // GIR_Coverage, 3614,
     /* 1613584 */     GIR_EraseRootFromParent_Done,
     /* 1613585 */   // Label 22283: @1613585
     /* 1613585 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1613671), // Rule ID 3615 //
     /* 1613590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613636 */     // MIs[0] policy
     /* 1613636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613670 */     // GIR_Coverage, 3615,
     /* 1613670 */     GIR_EraseRootFromParent_Done,
     /* 1613671 */   // Label 22284: @1613671
     /* 1613671 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1613757), // Rule ID 3618 //
     /* 1613676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613722 */     // MIs[0] policy
     /* 1613722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613756 */     // GIR_Coverage, 3618,
     /* 1613756 */     GIR_EraseRootFromParent_Done,
     /* 1613757 */   // Label 22285: @1613757
     /* 1613757 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1613843), // Rule ID 3619 //
     /* 1613762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613808 */     // MIs[0] policy
     /* 1613808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613842 */     // GIR_Coverage, 3619,
     /* 1613842 */     GIR_EraseRootFromParent_Done,
     /* 1613843 */   // Label 22286: @1613843
     /* 1613843 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1613929), // Rule ID 3622 //
     /* 1613848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613894 */     // MIs[0] policy
     /* 1613894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613928 */     // GIR_Coverage, 3622,
     /* 1613928 */     GIR_EraseRootFromParent_Done,
     /* 1613929 */   // Label 22287: @1613929
     /* 1613929 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1614015), // Rule ID 3623 //
     /* 1613934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613980 */     // MIs[0] policy
     /* 1613980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614014 */     // GIR_Coverage, 3623,
     /* 1614014 */     GIR_EraseRootFromParent_Done,
     /* 1614015 */   // Label 22288: @1614015
     /* 1614015 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1614101), // Rule ID 3626 //
     /* 1614020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1614040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614066 */     // MIs[0] policy
     /* 1614066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614100 */     // GIR_Coverage, 3626,
     /* 1614100 */     GIR_EraseRootFromParent_Done,
     /* 1614101 */   // Label 22289: @1614101
     /* 1614101 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1614187), // Rule ID 3627 //
     /* 1614106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1614126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614152 */     // MIs[0] policy
     /* 1614152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614186 */     // GIR_Coverage, 3627,
     /* 1614186 */     GIR_EraseRootFromParent_Done,
     /* 1614187 */   // Label 22290: @1614187
     /* 1614187 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1614273), // Rule ID 3630 //
     /* 1614192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1614212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614238 */     // MIs[0] policy
     /* 1614238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614272 */     // GIR_Coverage, 3630,
     /* 1614272 */     GIR_EraseRootFromParent_Done,
     /* 1614273 */   // Label 22291: @1614273
     /* 1614273 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1614359), // Rule ID 3631 //
     /* 1614278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1614298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614324 */     // MIs[0] policy
     /* 1614324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614358 */     // GIR_Coverage, 3631,
     /* 1614358 */     GIR_EraseRootFromParent_Done,
     /* 1614359 */   // Label 22292: @1614359
     /* 1614359 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1614445), // Rule ID 3634 //
     /* 1614364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614410 */     // MIs[0] policy
     /* 1614410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614444 */     // GIR_Coverage, 3634,
     /* 1614444 */     GIR_EraseRootFromParent_Done,
     /* 1614445 */   // Label 22293: @1614445
     /* 1614445 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1614531), // Rule ID 3635 //
     /* 1614450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614496 */     // MIs[0] policy
     /* 1614496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614530 */     // GIR_Coverage, 3635,
     /* 1614530 */     GIR_EraseRootFromParent_Done,
     /* 1614531 */   // Label 22294: @1614531
     /* 1614531 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1614617), // Rule ID 3638 //
     /* 1614536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614582 */     // MIs[0] policy
     /* 1614582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614616 */     // GIR_Coverage, 3638,
     /* 1614616 */     GIR_EraseRootFromParent_Done,
     /* 1614617 */   // Label 22295: @1614617
     /* 1614617 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1614703), // Rule ID 3639 //
     /* 1614622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614668 */     // MIs[0] policy
     /* 1614668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614702 */     // GIR_Coverage, 3639,
     /* 1614702 */     GIR_EraseRootFromParent_Done,
     /* 1614703 */   // Label 22296: @1614703
     /* 1614703 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1614789), // Rule ID 3642 //
     /* 1614708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614754 */     // MIs[0] policy
     /* 1614754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614788 */     // GIR_Coverage, 3642,
     /* 1614788 */     GIR_EraseRootFromParent_Done,
     /* 1614789 */   // Label 22297: @1614789
     /* 1614789 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1614875), // Rule ID 3643 //
     /* 1614794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614840 */     // MIs[0] policy
     /* 1614840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614874 */     // GIR_Coverage, 3643,
     /* 1614874 */     GIR_EraseRootFromParent_Done,
     /* 1614875 */   // Label 22298: @1614875
     /* 1614875 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1614961), // Rule ID 3646 //
     /* 1614880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614926 */     // MIs[0] policy
     /* 1614926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614960 */     // GIR_Coverage, 3646,
     /* 1614960 */     GIR_EraseRootFromParent_Done,
     /* 1614961 */   // Label 22299: @1614961
     /* 1614961 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1615047), // Rule ID 3647 //
     /* 1614966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615012 */     // MIs[0] policy
     /* 1615012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1615025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615046 */     // GIR_Coverage, 3647,
     /* 1615046 */     GIR_EraseRootFromParent_Done,
     /* 1615047 */   // Label 22300: @1615047
     /* 1615047 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1615133), // Rule ID 3650 //
     /* 1615052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1615072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615098 */     // MIs[0] policy
     /* 1615098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1615111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615132 */     // GIR_Coverage, 3650,
     /* 1615132 */     GIR_EraseRootFromParent_Done,
     /* 1615133 */   // Label 22301: @1615133
     /* 1615133 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1615219), // Rule ID 3651 //
     /* 1615138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1615158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615184 */     // MIs[0] policy
     /* 1615184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1615197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615218 */     // GIR_Coverage, 3651,
     /* 1615218 */     GIR_EraseRootFromParent_Done,
     /* 1615219 */   // Label 22302: @1615219
     /* 1615219 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1615305), // Rule ID 3654 //
     /* 1615224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615270 */     // MIs[0] policy
     /* 1615270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1615283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615304 */     // GIR_Coverage, 3654,
     /* 1615304 */     GIR_EraseRootFromParent_Done,
     /* 1615305 */   // Label 22303: @1615305
     /* 1615305 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1615391), // Rule ID 3655 //
     /* 1615310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615356 */     // MIs[0] policy
     /* 1615356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1615369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615390 */     // GIR_Coverage, 3655,
     /* 1615390 */     GIR_EraseRootFromParent_Done,
     /* 1615391 */   // Label 22304: @1615391
     /* 1615391 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1615477), // Rule ID 3658 //
     /* 1615396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615442 */     // MIs[0] policy
     /* 1615442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615476 */     // GIR_Coverage, 3658,
     /* 1615476 */     GIR_EraseRootFromParent_Done,
     /* 1615477 */   // Label 22305: @1615477
     /* 1615477 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1615563), // Rule ID 3659 //
     /* 1615482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615528 */     // MIs[0] policy
     /* 1615528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615562 */     // GIR_Coverage, 3659,
     /* 1615562 */     GIR_EraseRootFromParent_Done,
     /* 1615563 */   // Label 22306: @1615563
     /* 1615563 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1615649), // Rule ID 3662 //
     /* 1615568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615614 */     // MIs[0] policy
     /* 1615614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615648 */     // GIR_Coverage, 3662,
     /* 1615648 */     GIR_EraseRootFromParent_Done,
     /* 1615649 */   // Label 22307: @1615649
     /* 1615649 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1615735), // Rule ID 3663 //
     /* 1615654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615700 */     // MIs[0] policy
     /* 1615700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11700:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615734 */     // GIR_Coverage, 3663,
     /* 1615734 */     GIR_EraseRootFromParent_Done,
     /* 1615735 */   // Label 22308: @1615735
     /* 1615735 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1615821), // Rule ID 3666 //
     /* 1615740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615786 */     // MIs[0] policy
     /* 1615786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615820 */     // GIR_Coverage, 3666,
     /* 1615820 */     GIR_EraseRootFromParent_Done,
     /* 1615821 */   // Label 22309: @1615821
     /* 1615821 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1615907), // Rule ID 3667 //
     /* 1615826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615872 */     // MIs[0] policy
     /* 1615872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615906 */     // GIR_Coverage, 3667,
     /* 1615906 */     GIR_EraseRootFromParent_Done,
     /* 1615907 */   // Label 22310: @1615907
     /* 1615907 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1615993), // Rule ID 3670 //
     /* 1615912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615958 */     // MIs[0] policy
     /* 1615958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615992 */     // GIR_Coverage, 3670,
     /* 1615992 */     GIR_EraseRootFromParent_Done,
     /* 1615993 */   // Label 22311: @1615993
     /* 1615993 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1616079), // Rule ID 3671 //
     /* 1615998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616044 */     // MIs[0] policy
     /* 1616044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616078 */     // GIR_Coverage, 3671,
     /* 1616078 */     GIR_EraseRootFromParent_Done,
     /* 1616079 */   // Label 22312: @1616079
     /* 1616079 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1616165), // Rule ID 3674 //
     /* 1616084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616130 */     // MIs[0] policy
     /* 1616130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616164 */     // GIR_Coverage, 3674,
     /* 1616164 */     GIR_EraseRootFromParent_Done,
     /* 1616165 */   // Label 22313: @1616165
     /* 1616165 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1616251), // Rule ID 3675 //
     /* 1616170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616216 */     // MIs[0] policy
     /* 1616216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616250 */     // GIR_Coverage, 3675,
     /* 1616250 */     GIR_EraseRootFromParent_Done,
     /* 1616251 */   // Label 22314: @1616251
     /* 1616251 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1616337), // Rule ID 3678 //
     /* 1616256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616302 */     // MIs[0] policy
     /* 1616302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1616315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616336 */     // GIR_Coverage, 3678,
     /* 1616336 */     GIR_EraseRootFromParent_Done,
     /* 1616337 */   // Label 22315: @1616337
     /* 1616337 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1616423), // Rule ID 3679 //
     /* 1616342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616388 */     // MIs[0] policy
     /* 1616388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1616401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616422 */     // GIR_Coverage, 3679,
     /* 1616422 */     GIR_EraseRootFromParent_Done,
     /* 1616423 */   // Label 22316: @1616423
     /* 1616423 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1616509), // Rule ID 3682 //
     /* 1616428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616474 */     // MIs[0] policy
     /* 1616474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616508 */     // GIR_Coverage, 3682,
     /* 1616508 */     GIR_EraseRootFromParent_Done,
     /* 1616509 */   // Label 22317: @1616509
     /* 1616509 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1616595), // Rule ID 3683 //
     /* 1616514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616560 */     // MIs[0] policy
     /* 1616560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11700:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616594 */     // GIR_Coverage, 3683,
     /* 1616594 */     GIR_EraseRootFromParent_Done,
     /* 1616595 */   // Label 22318: @1616595
     /* 1616595 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1616681), // Rule ID 3686 //
     /* 1616600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616646 */     // MIs[0] policy
     /* 1616646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616680 */     // GIR_Coverage, 3686,
     /* 1616680 */     GIR_EraseRootFromParent_Done,
     /* 1616681 */   // Label 22319: @1616681
     /* 1616681 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1616767), // Rule ID 3687 //
     /* 1616686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616732 */     // MIs[0] policy
     /* 1616732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616766 */     // GIR_Coverage, 3687,
     /* 1616766 */     GIR_EraseRootFromParent_Done,
     /* 1616767 */   // Label 22320: @1616767
     /* 1616767 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1616853), // Rule ID 3690 //
     /* 1616772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616818 */     // MIs[0] policy
     /* 1616818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616852 */     // GIR_Coverage, 3690,
     /* 1616852 */     GIR_EraseRootFromParent_Done,
     /* 1616853 */   // Label 22321: @1616853
     /* 1616853 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1616939), // Rule ID 3691 //
     /* 1616858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616904 */     // MIs[0] policy
     /* 1616904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616938 */     // GIR_Coverage, 3691,
     /* 1616938 */     GIR_EraseRootFromParent_Done,
     /* 1616939 */   // Label 22322: @1616939
     /* 1616939 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1617025), // Rule ID 3694 //
     /* 1616944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616990 */     // MIs[0] policy
     /* 1616990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617024 */     // GIR_Coverage, 3694,
     /* 1617024 */     GIR_EraseRootFromParent_Done,
     /* 1617025 */   // Label 22323: @1617025
     /* 1617025 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1617111), // Rule ID 3695 //
     /* 1617030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617076 */     // MIs[0] policy
     /* 1617076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617110 */     // GIR_Coverage, 3695,
     /* 1617110 */     GIR_EraseRootFromParent_Done,
     /* 1617111 */   // Label 22324: @1617111
     /* 1617111 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1617197), // Rule ID 3698 //
     /* 1617116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617162 */     // MIs[0] policy
     /* 1617162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1617175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617196 */     // GIR_Coverage, 3698,
     /* 1617196 */     GIR_EraseRootFromParent_Done,
     /* 1617197 */   // Label 22325: @1617197
     /* 1617197 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1617283), // Rule ID 3699 //
     /* 1617202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617248 */     // MIs[0] policy
     /* 1617248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11700:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1617261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617282 */     // GIR_Coverage, 3699,
     /* 1617282 */     GIR_EraseRootFromParent_Done,
     /* 1617283 */   // Label 22326: @1617283
     /* 1617283 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1617369), // Rule ID 3702 //
     /* 1617288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617334 */     // MIs[0] policy
     /* 1617334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1617347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617368 */     // GIR_Coverage, 3702,
     /* 1617368 */     GIR_EraseRootFromParent_Done,
     /* 1617369 */   // Label 22327: @1617369
     /* 1617369 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1617455), // Rule ID 3703 //
     /* 1617374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617420 */     // MIs[0] policy
     /* 1617420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11700:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1617433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617454 */     // GIR_Coverage, 3703,
     /* 1617454 */     GIR_EraseRootFromParent_Done,
     /* 1617455 */   // Label 22328: @1617455
     /* 1617455 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1617541), // Rule ID 3706 //
     /* 1617460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617506 */     // MIs[0] policy
     /* 1617506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617540 */     // GIR_Coverage, 3706,
     /* 1617540 */     GIR_EraseRootFromParent_Done,
     /* 1617541 */   // Label 22329: @1617541
     /* 1617541 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1617627), // Rule ID 3707 //
     /* 1617546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617592 */     // MIs[0] policy
     /* 1617592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11700:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617626 */     // GIR_Coverage, 3707,
     /* 1617626 */     GIR_EraseRootFromParent_Done,
     /* 1617627 */   // Label 22330: @1617627
     /* 1617627 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1617713), // Rule ID 3710 //
     /* 1617632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617678 */     // MIs[0] policy
     /* 1617678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617712 */     // GIR_Coverage, 3710,
     /* 1617712 */     GIR_EraseRootFromParent_Done,
     /* 1617713 */   // Label 22331: @1617713
     /* 1617713 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1617799), // Rule ID 3711 //
     /* 1617718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617764 */     // MIs[0] policy
     /* 1617764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11700:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617798 */     // GIR_Coverage, 3711,
     /* 1617798 */     GIR_EraseRootFromParent_Done,
     /* 1617799 */   // Label 22332: @1617799
     /* 1617799 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1617885), // Rule ID 3714 //
     /* 1617804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617850 */     // MIs[0] policy
     /* 1617850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617860 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617884 */     // GIR_Coverage, 3714,
     /* 1617884 */     GIR_EraseRootFromParent_Done,
     /* 1617885 */   // Label 22333: @1617885
     /* 1617885 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1617971), // Rule ID 3715 //
     /* 1617890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617936 */     // MIs[0] policy
     /* 1617936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617970 */     // GIR_Coverage, 3715,
     /* 1617970 */     GIR_EraseRootFromParent_Done,
     /* 1617971 */   // Label 22334: @1617971
     /* 1617971 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1618057), // Rule ID 3718 //
     /* 1617976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1617996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618022 */     // MIs[0] policy
     /* 1618022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618032 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618056 */     // GIR_Coverage, 3718,
     /* 1618056 */     GIR_EraseRootFromParent_Done,
     /* 1618057 */   // Label 22335: @1618057
     /* 1618057 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1618143), // Rule ID 3719 //
     /* 1618062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1618082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618108 */     // MIs[0] policy
     /* 1618108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618142 */     // GIR_Coverage, 3719,
     /* 1618142 */     GIR_EraseRootFromParent_Done,
     /* 1618143 */   // Label 22336: @1618143
     /* 1618143 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1618229), // Rule ID 3722 //
     /* 1618148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1618168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618194 */     // MIs[0] policy
     /* 1618194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618228 */     // GIR_Coverage, 3722,
     /* 1618228 */     GIR_EraseRootFromParent_Done,
     /* 1618229 */   // Label 22337: @1618229
     /* 1618229 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1618315), // Rule ID 3723 //
     /* 1618234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1618254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618280 */     // MIs[0] policy
     /* 1618280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618314 */     // GIR_Coverage, 3723,
     /* 1618314 */     GIR_EraseRootFromParent_Done,
     /* 1618315 */   // Label 22338: @1618315
     /* 1618315 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1618401), // Rule ID 3726 //
     /* 1618320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1618340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618366 */     // MIs[0] policy
     /* 1618366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618400 */     // GIR_Coverage, 3726,
     /* 1618400 */     GIR_EraseRootFromParent_Done,
     /* 1618401 */   // Label 22339: @1618401
     /* 1618401 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1618487), // Rule ID 3727 //
     /* 1618406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1618426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618452 */     // MIs[0] policy
     /* 1618452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618486 */     // GIR_Coverage, 3727,
     /* 1618486 */     GIR_EraseRootFromParent_Done,
     /* 1618487 */   // Label 22340: @1618487
     /* 1618487 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1618573), // Rule ID 3730 //
     /* 1618492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618538 */     // MIs[0] policy
     /* 1618538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618572 */     // GIR_Coverage, 3730,
     /* 1618572 */     GIR_EraseRootFromParent_Done,
     /* 1618573 */   // Label 22341: @1618573
     /* 1618573 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1618659), // Rule ID 3731 //
     /* 1618578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618624 */     // MIs[0] policy
     /* 1618624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618658 */     // GIR_Coverage, 3731,
     /* 1618658 */     GIR_EraseRootFromParent_Done,
     /* 1618659 */   // Label 22342: @1618659
     /* 1618659 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1618745), // Rule ID 3734 //
     /* 1618664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618710 */     // MIs[0] policy
     /* 1618710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618744 */     // GIR_Coverage, 3734,
     /* 1618744 */     GIR_EraseRootFromParent_Done,
     /* 1618745 */   // Label 22343: @1618745
     /* 1618745 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1618831), // Rule ID 3735 //
     /* 1618750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618796 */     // MIs[0] policy
     /* 1618796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618830 */     // GIR_Coverage, 3735,
     /* 1618830 */     GIR_EraseRootFromParent_Done,
     /* 1618831 */   // Label 22344: @1618831
     /* 1618831 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1618917), // Rule ID 3738 //
     /* 1618836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618882 */     // MIs[0] policy
     /* 1618882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618916 */     // GIR_Coverage, 3738,
     /* 1618916 */     GIR_EraseRootFromParent_Done,
     /* 1618917 */   // Label 22345: @1618917
     /* 1618917 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1619003), // Rule ID 3739 //
     /* 1618922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618968 */     // MIs[0] policy
     /* 1618968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618978 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619002 */     // GIR_Coverage, 3739,
     /* 1619002 */     GIR_EraseRootFromParent_Done,
     /* 1619003 */   // Label 22346: @1619003
     /* 1619003 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1619089), // Rule ID 3742 //
     /* 1619008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1619028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619054 */     // MIs[0] policy
     /* 1619054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619088 */     // GIR_Coverage, 3742,
     /* 1619088 */     GIR_EraseRootFromParent_Done,
     /* 1619089 */   // Label 22347: @1619089
     /* 1619089 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1619175), // Rule ID 3743 //
     /* 1619094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1619114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619140 */     // MIs[0] policy
     /* 1619140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619174 */     // GIR_Coverage, 3743,
     /* 1619174 */     GIR_EraseRootFromParent_Done,
     /* 1619175 */   // Label 22348: @1619175
     /* 1619175 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1619261), // Rule ID 3746 //
     /* 1619180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1619200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619226 */     // MIs[0] policy
     /* 1619226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619260 */     // GIR_Coverage, 3746,
     /* 1619260 */     GIR_EraseRootFromParent_Done,
     /* 1619261 */   // Label 22349: @1619261
     /* 1619261 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1619347), // Rule ID 3747 //
     /* 1619266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1619286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619312 */     // MIs[0] policy
     /* 1619312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619346 */     // GIR_Coverage, 3747,
     /* 1619346 */     GIR_EraseRootFromParent_Done,
     /* 1619347 */   // Label 22350: @1619347
     /* 1619347 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1619433), // Rule ID 3750 //
     /* 1619352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1619372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619398 */     // MIs[0] policy
     /* 1619398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619432 */     // GIR_Coverage, 3750,
     /* 1619432 */     GIR_EraseRootFromParent_Done,
     /* 1619433 */   // Label 22351: @1619433
     /* 1619433 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1619519), // Rule ID 3751 //
     /* 1619438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1619458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619484 */     // MIs[0] policy
     /* 1619484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619518 */     // GIR_Coverage, 3751,
     /* 1619518 */     GIR_EraseRootFromParent_Done,
     /* 1619519 */   // Label 22352: @1619519
     /* 1619519 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1619605), // Rule ID 3754 //
     /* 1619524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619570 */     // MIs[0] policy
     /* 1619570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619604 */     // GIR_Coverage, 3754,
     /* 1619604 */     GIR_EraseRootFromParent_Done,
     /* 1619605 */   // Label 22353: @1619605
     /* 1619605 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1619691), // Rule ID 3755 //
     /* 1619610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619656 */     // MIs[0] policy
     /* 1619656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619690 */     // GIR_Coverage, 3755,
     /* 1619690 */     GIR_EraseRootFromParent_Done,
     /* 1619691 */   // Label 22354: @1619691
     /* 1619691 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1619777), // Rule ID 3758 //
     /* 1619696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619742 */     // MIs[0] policy
     /* 1619742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619776 */     // GIR_Coverage, 3758,
     /* 1619776 */     GIR_EraseRootFromParent_Done,
     /* 1619777 */   // Label 22355: @1619777
     /* 1619777 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1619863), // Rule ID 3759 //
     /* 1619782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619828 */     // MIs[0] policy
     /* 1619828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619862 */     // GIR_Coverage, 3759,
     /* 1619862 */     GIR_EraseRootFromParent_Done,
     /* 1619863 */   // Label 22356: @1619863
     /* 1619863 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1619949), // Rule ID 3762 //
     /* 1619868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619914 */     // MIs[0] policy
     /* 1619914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619948 */     // GIR_Coverage, 3762,
     /* 1619948 */     GIR_EraseRootFromParent_Done,
     /* 1619949 */   // Label 22357: @1619949
     /* 1619949 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1620035), // Rule ID 3763 //
     /* 1619954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620000 */     // MIs[0] policy
     /* 1620000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1620013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620034 */     // GIR_Coverage, 3763,
     /* 1620034 */     GIR_EraseRootFromParent_Done,
     /* 1620035 */   // Label 22358: @1620035
     /* 1620035 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1620121), // Rule ID 3766 //
     /* 1620040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1620060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620086 */     // MIs[0] policy
     /* 1620086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1620099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620120 */     // GIR_Coverage, 3766,
     /* 1620120 */     GIR_EraseRootFromParent_Done,
     /* 1620121 */   // Label 22359: @1620121
     /* 1620121 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1620207), // Rule ID 3767 //
     /* 1620126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1620146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620172 */     // MIs[0] policy
     /* 1620172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1620185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620206 */     // GIR_Coverage, 3767,
     /* 1620206 */     GIR_EraseRootFromParent_Done,
     /* 1620207 */   // Label 22360: @1620207
     /* 1620207 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1620293), // Rule ID 3770 //
     /* 1620212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1620232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620258 */     // MIs[0] policy
     /* 1620258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620268 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1620271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620292 */     // GIR_Coverage, 3770,
     /* 1620292 */     GIR_EraseRootFromParent_Done,
     /* 1620293 */   // Label 22361: @1620293
     /* 1620293 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1620379), // Rule ID 3771 //
     /* 1620298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1620318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620344 */     // MIs[0] policy
     /* 1620344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1620357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620378 */     // GIR_Coverage, 3771,
     /* 1620378 */     GIR_EraseRootFromParent_Done,
     /* 1620379 */   // Label 22362: @1620379
     /* 1620379 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1620465), // Rule ID 3774 //
     /* 1620384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620430 */     // MIs[0] policy
     /* 1620430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620440 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620464 */     // GIR_Coverage, 3774,
     /* 1620464 */     GIR_EraseRootFromParent_Done,
     /* 1620465 */   // Label 22363: @1620465
     /* 1620465 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1620551), // Rule ID 3775 //
     /* 1620470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620516 */     // MIs[0] policy
     /* 1620516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620550 */     // GIR_Coverage, 3775,
     /* 1620550 */     GIR_EraseRootFromParent_Done,
     /* 1620551 */   // Label 22364: @1620551
     /* 1620551 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1620637), // Rule ID 3778 //
     /* 1620556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620602 */     // MIs[0] policy
     /* 1620602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620636 */     // GIR_Coverage, 3778,
     /* 1620636 */     GIR_EraseRootFromParent_Done,
     /* 1620637 */   // Label 22365: @1620637
     /* 1620637 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1620723), // Rule ID 3779 //
     /* 1620642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620688 */     // MIs[0] policy
     /* 1620688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620722 */     // GIR_Coverage, 3779,
     /* 1620722 */     GIR_EraseRootFromParent_Done,
     /* 1620723 */   // Label 22366: @1620723
     /* 1620723 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1620809), // Rule ID 3782 //
     /* 1620728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620774 */     // MIs[0] policy
     /* 1620774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620808 */     // GIR_Coverage, 3782,
     /* 1620808 */     GIR_EraseRootFromParent_Done,
     /* 1620809 */   // Label 22367: @1620809
     /* 1620809 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1620895), // Rule ID 3783 //
     /* 1620814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620860 */     // MIs[0] policy
     /* 1620860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11728:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620894 */     // GIR_Coverage, 3783,
     /* 1620894 */     GIR_EraseRootFromParent_Done,
     /* 1620895 */   // Label 22368: @1620895
     /* 1620895 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1620981), // Rule ID 3786 //
     /* 1620900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620946 */     // MIs[0] policy
     /* 1620946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620980 */     // GIR_Coverage, 3786,
     /* 1620980 */     GIR_EraseRootFromParent_Done,
     /* 1620981 */   // Label 22369: @1620981
     /* 1620981 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1621067), // Rule ID 3787 //
     /* 1620986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621032 */     // MIs[0] policy
     /* 1621032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621066 */     // GIR_Coverage, 3787,
     /* 1621066 */     GIR_EraseRootFromParent_Done,
     /* 1621067 */   // Label 22370: @1621067
     /* 1621067 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1621153), // Rule ID 3790 //
     /* 1621072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621118 */     // MIs[0] policy
     /* 1621118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621152 */     // GIR_Coverage, 3790,
     /* 1621152 */     GIR_EraseRootFromParent_Done,
     /* 1621153 */   // Label 22371: @1621153
     /* 1621153 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1621239), // Rule ID 3791 //
     /* 1621158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621204 */     // MIs[0] policy
     /* 1621204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621238 */     // GIR_Coverage, 3791,
     /* 1621238 */     GIR_EraseRootFromParent_Done,
     /* 1621239 */   // Label 22372: @1621239
     /* 1621239 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1621325), // Rule ID 3794 //
     /* 1621244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621290 */     // MIs[0] policy
     /* 1621290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621300 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621324 */     // GIR_Coverage, 3794,
     /* 1621324 */     GIR_EraseRootFromParent_Done,
     /* 1621325 */   // Label 22373: @1621325
     /* 1621325 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1621411), // Rule ID 3795 //
     /* 1621330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621376 */     // MIs[0] policy
     /* 1621376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621410 */     // GIR_Coverage, 3795,
     /* 1621410 */     GIR_EraseRootFromParent_Done,
     /* 1621411 */   // Label 22374: @1621411
     /* 1621411 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1621497), // Rule ID 3798 //
     /* 1621416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621462 */     // MIs[0] policy
     /* 1621462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621496 */     // GIR_Coverage, 3798,
     /* 1621496 */     GIR_EraseRootFromParent_Done,
     /* 1621497 */   // Label 22375: @1621497
     /* 1621497 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1621583), // Rule ID 3799 //
     /* 1621502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621548 */     // MIs[0] policy
     /* 1621548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621582 */     // GIR_Coverage, 3799,
     /* 1621582 */     GIR_EraseRootFromParent_Done,
     /* 1621583 */   // Label 22376: @1621583
     /* 1621583 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1621669), // Rule ID 3802 //
     /* 1621588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621634 */     // MIs[0] policy
     /* 1621634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621668 */     // GIR_Coverage, 3802,
     /* 1621668 */     GIR_EraseRootFromParent_Done,
     /* 1621669 */   // Label 22377: @1621669
     /* 1621669 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1621755), // Rule ID 3803 //
     /* 1621674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621720 */     // MIs[0] policy
     /* 1621720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11728:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621754 */     // GIR_Coverage, 3803,
     /* 1621754 */     GIR_EraseRootFromParent_Done,
     /* 1621755 */   // Label 22378: @1621755
     /* 1621755 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1621841), // Rule ID 3806 //
     /* 1621760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621806 */     // MIs[0] policy
     /* 1621806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621840 */     // GIR_Coverage, 3806,
     /* 1621840 */     GIR_EraseRootFromParent_Done,
     /* 1621841 */   // Label 22379: @1621841
     /* 1621841 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1621927), // Rule ID 3807 //
     /* 1621846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621892 */     // MIs[0] policy
     /* 1621892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621926 */     // GIR_Coverage, 3807,
     /* 1621926 */     GIR_EraseRootFromParent_Done,
     /* 1621927 */   // Label 22380: @1621927
     /* 1621927 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1622013), // Rule ID 3810 //
     /* 1621932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621978 */     // MIs[0] policy
     /* 1621978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622012 */     // GIR_Coverage, 3810,
     /* 1622012 */     GIR_EraseRootFromParent_Done,
     /* 1622013 */   // Label 22381: @1622013
     /* 1622013 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1622099), // Rule ID 3811 //
     /* 1622018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622064 */     // MIs[0] policy
     /* 1622064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622098 */     // GIR_Coverage, 3811,
     /* 1622098 */     GIR_EraseRootFromParent_Done,
     /* 1622099 */   // Label 22382: @1622099
     /* 1622099 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1622185), // Rule ID 3814 //
     /* 1622104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622150 */     // MIs[0] policy
     /* 1622150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622184 */     // GIR_Coverage, 3814,
     /* 1622184 */     GIR_EraseRootFromParent_Done,
     /* 1622185 */   // Label 22383: @1622185
     /* 1622185 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1622271), // Rule ID 3815 //
     /* 1622190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622236 */     // MIs[0] policy
     /* 1622236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622270 */     // GIR_Coverage, 3815,
     /* 1622270 */     GIR_EraseRootFromParent_Done,
     /* 1622271 */   // Label 22384: @1622271
     /* 1622271 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1622357), // Rule ID 3818 //
     /* 1622276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622322 */     // MIs[0] policy
     /* 1622322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1622335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622356 */     // GIR_Coverage, 3818,
     /* 1622356 */     GIR_EraseRootFromParent_Done,
     /* 1622357 */   // Label 22385: @1622357
     /* 1622357 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1622443), // Rule ID 3819 //
     /* 1622362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622408 */     // MIs[0] policy
     /* 1622408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11728:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1622421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622442 */     // GIR_Coverage, 3819,
     /* 1622442 */     GIR_EraseRootFromParent_Done,
     /* 1622443 */   // Label 22386: @1622443
     /* 1622443 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1622529), // Rule ID 3822 //
     /* 1622448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622494 */     // MIs[0] policy
     /* 1622494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622528 */     // GIR_Coverage, 3822,
     /* 1622528 */     GIR_EraseRootFromParent_Done,
     /* 1622529 */   // Label 22387: @1622529
     /* 1622529 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1622615), // Rule ID 3823 //
     /* 1622534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622580 */     // MIs[0] policy
     /* 1622580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11728:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622614 */     // GIR_Coverage, 3823,
     /* 1622614 */     GIR_EraseRootFromParent_Done,
     /* 1622615 */   // Label 22388: @1622615
     /* 1622615 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1622701), // Rule ID 3826 //
     /* 1622620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622666 */     // MIs[0] policy
     /* 1622666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622676 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622700 */     // GIR_Coverage, 3826,
     /* 1622700 */     GIR_EraseRootFromParent_Done,
     /* 1622701 */   // Label 22389: @1622701
     /* 1622701 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1622787), // Rule ID 3827 //
     /* 1622706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622752 */     // MIs[0] policy
     /* 1622752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11728:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622786 */     // GIR_Coverage, 3827,
     /* 1622786 */     GIR_EraseRootFromParent_Done,
     /* 1622787 */   // Label 22390: @1622787
     /* 1622787 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1622873), // Rule ID 3830 //
     /* 1622792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622838 */     // MIs[0] policy
     /* 1622838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622872 */     // GIR_Coverage, 3830,
     /* 1622872 */     GIR_EraseRootFromParent_Done,
     /* 1622873 */   // Label 22391: @1622873
     /* 1622873 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1622959), // Rule ID 3831 //
     /* 1622878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622924 */     // MIs[0] policy
     /* 1622924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11728:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622958 */     // GIR_Coverage, 3831,
     /* 1622958 */     GIR_EraseRootFromParent_Done,
     /* 1622959 */   // Label 22392: @1622959
     /* 1622959 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1623045), // Rule ID 3834 //
     /* 1622964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623010 */     // MIs[0] policy
     /* 1623010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623020 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1623023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623044 */     // GIR_Coverage, 3834,
     /* 1623044 */     GIR_EraseRootFromParent_Done,
     /* 1623045 */   // Label 22393: @1623045
     /* 1623045 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1623131), // Rule ID 3835 //
     /* 1623050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1623070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623096 */     // MIs[0] policy
     /* 1623096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1623109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623130 */     // GIR_Coverage, 3835,
     /* 1623130 */     GIR_EraseRootFromParent_Done,
     /* 1623131 */   // Label 22394: @1623131
     /* 1623131 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1623217), // Rule ID 3838 //
     /* 1623136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623182 */     // MIs[0] policy
     /* 1623182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623216 */     // GIR_Coverage, 3838,
     /* 1623216 */     GIR_EraseRootFromParent_Done,
     /* 1623217 */   // Label 22395: @1623217
     /* 1623217 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1623303), // Rule ID 3839 //
     /* 1623222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1623242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623268 */     // MIs[0] policy
     /* 1623268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623278 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623302 */     // GIR_Coverage, 3839,
     /* 1623302 */     GIR_EraseRootFromParent_Done,
     /* 1623303 */   // Label 22396: @1623303
     /* 1623303 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1623389), // Rule ID 3842 //
     /* 1623308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1623328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623354 */     // MIs[0] policy
     /* 1623354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623388 */     // GIR_Coverage, 3842,
     /* 1623388 */     GIR_EraseRootFromParent_Done,
     /* 1623389 */   // Label 22397: @1623389
     /* 1623389 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1623475), // Rule ID 3843 //
     /* 1623394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1623414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623440 */     // MIs[0] policy
     /* 1623440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623474 */     // GIR_Coverage, 3843,
     /* 1623474 */     GIR_EraseRootFromParent_Done,
     /* 1623475 */   // Label 22398: @1623475
     /* 1623475 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1623561), // Rule ID 3846 //
     /* 1623480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623526 */     // MIs[0] policy
     /* 1623526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623560 */     // GIR_Coverage, 3846,
     /* 1623560 */     GIR_EraseRootFromParent_Done,
     /* 1623561 */   // Label 22399: @1623561
     /* 1623561 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1623647), // Rule ID 3847 //
     /* 1623566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623612 */     // MIs[0] policy
     /* 1623612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623622 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623646 */     // GIR_Coverage, 3847,
     /* 1623646 */     GIR_EraseRootFromParent_Done,
     /* 1623647 */   // Label 22400: @1623647
     /* 1623647 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1623733), // Rule ID 3850 //
     /* 1623652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623698 */     // MIs[0] policy
     /* 1623698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623732 */     // GIR_Coverage, 3850,
     /* 1623732 */     GIR_EraseRootFromParent_Done,
     /* 1623733 */   // Label 22401: @1623733
     /* 1623733 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1623819), // Rule ID 3851 //
     /* 1623738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623784 */     // MIs[0] policy
     /* 1623784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623818 */     // GIR_Coverage, 3851,
     /* 1623818 */     GIR_EraseRootFromParent_Done,
     /* 1623819 */   // Label 22402: @1623819
     /* 1623819 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1623905), // Rule ID 3854 //
     /* 1623824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623870 */     // MIs[0] policy
     /* 1623870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623880 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623904 */     // GIR_Coverage, 3854,
     /* 1623904 */     GIR_EraseRootFromParent_Done,
     /* 1623905 */   // Label 22403: @1623905
     /* 1623905 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1623991), // Rule ID 3855 //
     /* 1623910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623956 */     // MIs[0] policy
     /* 1623956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623966 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623990 */     // GIR_Coverage, 3855,
     /* 1623990 */     GIR_EraseRootFromParent_Done,
     /* 1623991 */   // Label 22404: @1623991
     /* 1623991 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1624077), // Rule ID 3858 //
     /* 1623996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624042 */     // MIs[0] policy
     /* 1624042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1624055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624076 */     // GIR_Coverage, 3858,
     /* 1624076 */     GIR_EraseRootFromParent_Done,
     /* 1624077 */   // Label 22405: @1624077
     /* 1624077 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1624163), // Rule ID 3859 //
     /* 1624082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1624102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624128 */     // MIs[0] policy
     /* 1624128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624138 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1624141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624162 */     // GIR_Coverage, 3859,
     /* 1624162 */     GIR_EraseRootFromParent_Done,
     /* 1624163 */   // Label 22406: @1624163
     /* 1624163 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1624249), // Rule ID 3862 //
     /* 1624168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624214 */     // MIs[0] policy
     /* 1624214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624248 */     // GIR_Coverage, 3862,
     /* 1624248 */     GIR_EraseRootFromParent_Done,
     /* 1624249 */   // Label 22407: @1624249
     /* 1624249 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1624335), // Rule ID 3863 //
     /* 1624254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1624274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624300 */     // MIs[0] policy
     /* 1624300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624334 */     // GIR_Coverage, 3863,
     /* 1624334 */     GIR_EraseRootFromParent_Done,
     /* 1624335 */   // Label 22408: @1624335
     /* 1624335 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1624421), // Rule ID 3866 //
     /* 1624340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624386 */     // MIs[0] policy
     /* 1624386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624420 */     // GIR_Coverage, 3866,
     /* 1624420 */     GIR_EraseRootFromParent_Done,
     /* 1624421 */   // Label 22409: @1624421
     /* 1624421 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1624507), // Rule ID 3867 //
     /* 1624426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1624446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624472 */     // MIs[0] policy
     /* 1624472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624506 */     // GIR_Coverage, 3867,
     /* 1624506 */     GIR_EraseRootFromParent_Done,
     /* 1624507 */   // Label 22410: @1624507
     /* 1624507 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1624593), // Rule ID 3870 //
     /* 1624512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624558 */     // MIs[0] policy
     /* 1624558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624592 */     // GIR_Coverage, 3870,
     /* 1624592 */     GIR_EraseRootFromParent_Done,
     /* 1624593 */   // Label 22411: @1624593
     /* 1624593 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1624679), // Rule ID 3871 //
     /* 1624598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624644 */     // MIs[0] policy
     /* 1624644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624678 */     // GIR_Coverage, 3871,
     /* 1624678 */     GIR_EraseRootFromParent_Done,
     /* 1624679 */   // Label 22412: @1624679
     /* 1624679 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1624765), // Rule ID 3874 //
     /* 1624684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624730 */     // MIs[0] policy
     /* 1624730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624764 */     // GIR_Coverage, 3874,
     /* 1624764 */     GIR_EraseRootFromParent_Done,
     /* 1624765 */   // Label 22413: @1624765
     /* 1624765 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1624851), // Rule ID 3875 //
     /* 1624770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624816 */     // MIs[0] policy
     /* 1624816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624850 */     // GIR_Coverage, 3875,
     /* 1624850 */     GIR_EraseRootFromParent_Done,
     /* 1624851 */   // Label 22414: @1624851
     /* 1624851 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1624937), // Rule ID 3878 //
     /* 1624856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624902 */     // MIs[0] policy
     /* 1624902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624936 */     // GIR_Coverage, 3878,
     /* 1624936 */     GIR_EraseRootFromParent_Done,
     /* 1624937 */   // Label 22415: @1624937
     /* 1624937 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1625023), // Rule ID 3879 //
     /* 1624942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624988 */     // MIs[0] policy
     /* 1624988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1625001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625022 */     // GIR_Coverage, 3879,
     /* 1625022 */     GIR_EraseRootFromParent_Done,
     /* 1625023 */   // Label 22416: @1625023
     /* 1625023 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1625109), // Rule ID 3882 //
     /* 1625028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625074 */     // MIs[0] policy
     /* 1625074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1625087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625108 */     // GIR_Coverage, 3882,
     /* 1625108 */     GIR_EraseRootFromParent_Done,
     /* 1625109 */   // Label 22417: @1625109
     /* 1625109 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1625195), // Rule ID 3883 //
     /* 1625114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1625134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625160 */     // MIs[0] policy
     /* 1625160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1625173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625194 */     // GIR_Coverage, 3883,
     /* 1625194 */     GIR_EraseRootFromParent_Done,
     /* 1625195 */   // Label 22418: @1625195
     /* 1625195 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1625281), // Rule ID 3886 //
     /* 1625200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1625220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625246 */     // MIs[0] policy
     /* 1625246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1625259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625280 */     // GIR_Coverage, 3886,
     /* 1625280 */     GIR_EraseRootFromParent_Done,
     /* 1625281 */   // Label 22419: @1625281
     /* 1625281 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1625367), // Rule ID 3887 //
     /* 1625286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1625306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625332 */     // MIs[0] policy
     /* 1625332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1625345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625366 */     // GIR_Coverage, 3887,
     /* 1625366 */     GIR_EraseRootFromParent_Done,
     /* 1625367 */   // Label 22420: @1625367
     /* 1625367 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1625453), // Rule ID 3890 //
     /* 1625372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625418 */     // MIs[0] policy
     /* 1625418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625452 */     // GIR_Coverage, 3890,
     /* 1625452 */     GIR_EraseRootFromParent_Done,
     /* 1625453 */   // Label 22421: @1625453
     /* 1625453 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1625539), // Rule ID 3891 //
     /* 1625458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625504 */     // MIs[0] policy
     /* 1625504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625538 */     // GIR_Coverage, 3891,
     /* 1625538 */     GIR_EraseRootFromParent_Done,
     /* 1625539 */   // Label 22422: @1625539
     /* 1625539 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1625625), // Rule ID 3894 //
     /* 1625544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625590 */     // MIs[0] policy
     /* 1625590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625600 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625624 */     // GIR_Coverage, 3894,
     /* 1625624 */     GIR_EraseRootFromParent_Done,
     /* 1625625 */   // Label 22423: @1625625
     /* 1625625 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1625711), // Rule ID 3895 //
     /* 1625630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625676 */     // MIs[0] policy
     /* 1625676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625710 */     // GIR_Coverage, 3895,
     /* 1625710 */     GIR_EraseRootFromParent_Done,
     /* 1625711 */   // Label 22424: @1625711
     /* 1625711 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1625797), // Rule ID 3898 //
     /* 1625716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625762 */     // MIs[0] policy
     /* 1625762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625796 */     // GIR_Coverage, 3898,
     /* 1625796 */     GIR_EraseRootFromParent_Done,
     /* 1625797 */   // Label 22425: @1625797
     /* 1625797 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1625883), // Rule ID 3899 //
     /* 1625802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625848 */     // MIs[0] policy
     /* 1625848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625882 */     // GIR_Coverage, 3899,
     /* 1625882 */     GIR_EraseRootFromParent_Done,
     /* 1625883 */   // Label 22426: @1625883
     /* 1625883 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1625969), // Rule ID 3902 //
     /* 1625888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625934 */     // MIs[0] policy
     /* 1625934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625968 */     // GIR_Coverage, 3902,
     /* 1625968 */     GIR_EraseRootFromParent_Done,
     /* 1625969 */   // Label 22427: @1625969
     /* 1625969 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1626055), // Rule ID 3903 //
     /* 1625974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626020 */     // MIs[0] policy
     /* 1626020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11696:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626054 */     // GIR_Coverage, 3903,
     /* 1626054 */     GIR_EraseRootFromParent_Done,
     /* 1626055 */   // Label 22428: @1626055
     /* 1626055 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1626141), // Rule ID 3906 //
     /* 1626060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626106 */     // MIs[0] policy
     /* 1626106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626140 */     // GIR_Coverage, 3906,
     /* 1626140 */     GIR_EraseRootFromParent_Done,
     /* 1626141 */   // Label 22429: @1626141
     /* 1626141 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1626227), // Rule ID 3907 //
     /* 1626146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626192 */     // MIs[0] policy
     /* 1626192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626226 */     // GIR_Coverage, 3907,
     /* 1626226 */     GIR_EraseRootFromParent_Done,
     /* 1626227 */   // Label 22430: @1626227
     /* 1626227 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1626313), // Rule ID 3910 //
     /* 1626232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626278 */     // MIs[0] policy
     /* 1626278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626312 */     // GIR_Coverage, 3910,
     /* 1626312 */     GIR_EraseRootFromParent_Done,
     /* 1626313 */   // Label 22431: @1626313
     /* 1626313 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1626399), // Rule ID 3911 //
     /* 1626318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626364 */     // MIs[0] policy
     /* 1626364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626398 */     // GIR_Coverage, 3911,
     /* 1626398 */     GIR_EraseRootFromParent_Done,
     /* 1626399 */   // Label 22432: @1626399
     /* 1626399 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1626485), // Rule ID 3914 //
     /* 1626404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626450 */     // MIs[0] policy
     /* 1626450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626460 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626484 */     // GIR_Coverage, 3914,
     /* 1626484 */     GIR_EraseRootFromParent_Done,
     /* 1626485 */   // Label 22433: @1626485
     /* 1626485 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1626571), // Rule ID 3915 //
     /* 1626490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626536 */     // MIs[0] policy
     /* 1626536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626570 */     // GIR_Coverage, 3915,
     /* 1626570 */     GIR_EraseRootFromParent_Done,
     /* 1626571 */   // Label 22434: @1626571
     /* 1626571 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1626657), // Rule ID 3918 //
     /* 1626576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626622 */     // MIs[0] policy
     /* 1626622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626656 */     // GIR_Coverage, 3918,
     /* 1626656 */     GIR_EraseRootFromParent_Done,
     /* 1626657 */   // Label 22435: @1626657
     /* 1626657 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1626743), // Rule ID 3919 //
     /* 1626662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626708 */     // MIs[0] policy
     /* 1626708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626742 */     // GIR_Coverage, 3919,
     /* 1626742 */     GIR_EraseRootFromParent_Done,
     /* 1626743 */   // Label 22436: @1626743
     /* 1626743 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1626829), // Rule ID 3922 //
     /* 1626748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626794 */     // MIs[0] policy
     /* 1626794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626828 */     // GIR_Coverage, 3922,
     /* 1626828 */     GIR_EraseRootFromParent_Done,
     /* 1626829 */   // Label 22437: @1626829
     /* 1626829 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1626915), // Rule ID 3923 //
     /* 1626834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626880 */     // MIs[0] policy
     /* 1626880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11696:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626914 */     // GIR_Coverage, 3923,
     /* 1626914 */     GIR_EraseRootFromParent_Done,
     /* 1626915 */   // Label 22438: @1626915
     /* 1626915 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1627001), // Rule ID 3926 //
     /* 1626920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626966 */     // MIs[0] policy
     /* 1626966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627000 */     // GIR_Coverage, 3926,
     /* 1627000 */     GIR_EraseRootFromParent_Done,
     /* 1627001 */   // Label 22439: @1627001
     /* 1627001 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1627087), // Rule ID 3927 //
     /* 1627006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1627023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627052 */     // MIs[0] policy
     /* 1627052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627086 */     // GIR_Coverage, 3927,
     /* 1627086 */     GIR_EraseRootFromParent_Done,
     /* 1627087 */   // Label 22440: @1627087
     /* 1627087 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1627173), // Rule ID 3930 //
     /* 1627092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627138 */     // MIs[0] policy
     /* 1627138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627148 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627172 */     // GIR_Coverage, 3930,
     /* 1627172 */     GIR_EraseRootFromParent_Done,
     /* 1627173 */   // Label 22441: @1627173
     /* 1627173 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1627259), // Rule ID 3931 //
     /* 1627178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627224 */     // MIs[0] policy
     /* 1627224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627258 */     // GIR_Coverage, 3931,
     /* 1627258 */     GIR_EraseRootFromParent_Done,
     /* 1627259 */   // Label 22442: @1627259
     /* 1627259 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1627345), // Rule ID 3934 //
     /* 1627264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627310 */     // MIs[0] policy
     /* 1627310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627344 */     // GIR_Coverage, 3934,
     /* 1627344 */     GIR_EraseRootFromParent_Done,
     /* 1627345 */   // Label 22443: @1627345
     /* 1627345 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1627431), // Rule ID 3935 //
     /* 1627350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627396 */     // MIs[0] policy
     /* 1627396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627406 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627430 */     // GIR_Coverage, 3935,
     /* 1627430 */     GIR_EraseRootFromParent_Done,
     /* 1627431 */   // Label 22444: @1627431
     /* 1627431 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1627517), // Rule ID 3938 //
     /* 1627436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627482 */     // MIs[0] policy
     /* 1627482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627516 */     // GIR_Coverage, 3938,
     /* 1627516 */     GIR_EraseRootFromParent_Done,
     /* 1627517 */   // Label 22445: @1627517
     /* 1627517 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1627603), // Rule ID 3939 //
     /* 1627522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627568 */     // MIs[0] policy
     /* 1627568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11696:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627602 */     // GIR_Coverage, 3939,
     /* 1627602 */     GIR_EraseRootFromParent_Done,
     /* 1627603 */   // Label 22446: @1627603
     /* 1627603 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1627689), // Rule ID 3942 //
     /* 1627608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627654 */     // MIs[0] policy
     /* 1627654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627688 */     // GIR_Coverage, 3942,
     /* 1627688 */     GIR_EraseRootFromParent_Done,
     /* 1627689 */   // Label 22447: @1627689
     /* 1627689 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1627775), // Rule ID 3943 //
     /* 1627694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627740 */     // MIs[0] policy
     /* 1627740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11696:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627774 */     // GIR_Coverage, 3943,
     /* 1627774 */     GIR_EraseRootFromParent_Done,
     /* 1627775 */   // Label 22448: @1627775
     /* 1627775 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1627861), // Rule ID 3946 //
     /* 1627780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627826 */     // MIs[0] policy
     /* 1627826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627836 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627860 */     // GIR_Coverage, 3946,
     /* 1627860 */     GIR_EraseRootFromParent_Done,
     /* 1627861 */   // Label 22449: @1627861
     /* 1627861 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1627947), // Rule ID 3947 //
     /* 1627866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627912 */     // MIs[0] policy
     /* 1627912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11696:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627946 */     // GIR_Coverage, 3947,
     /* 1627946 */     GIR_EraseRootFromParent_Done,
     /* 1627947 */   // Label 22450: @1627947
     /* 1627947 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1628033), // Rule ID 3950 //
     /* 1627952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627998 */     // MIs[0] policy
     /* 1627998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628008 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1628011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628032 */     // GIR_Coverage, 3950,
     /* 1628032 */     GIR_EraseRootFromParent_Done,
     /* 1628033 */   // Label 22451: @1628033
     /* 1628033 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1628119), // Rule ID 3951 //
     /* 1628038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1628046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1628055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628084 */     // MIs[0] policy
     /* 1628084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11696:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1628097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628118 */     // GIR_Coverage, 3951,
     /* 1628118 */     GIR_EraseRootFromParent_Done,
     /* 1628119 */   // Label 22452: @1628119
     /* 1628119 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1628205), // Rule ID 3954 //
     /* 1628124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1628144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628170 */     // MIs[0] policy
     /* 1628170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1628183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628204 */     // GIR_Coverage, 3954,
     /* 1628204 */     GIR_EraseRootFromParent_Done,
     /* 1628205 */   // Label 22453: @1628205
     /* 1628205 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1628291), // Rule ID 3955 //
     /* 1628210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1628230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628256 */     // MIs[0] policy
     /* 1628256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1628269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628290 */     // GIR_Coverage, 3955,
     /* 1628290 */     GIR_EraseRootFromParent_Done,
     /* 1628291 */   // Label 22454: @1628291
     /* 1628291 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1628377), // Rule ID 3958 //
     /* 1628296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1628316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628342 */     // MIs[0] policy
     /* 1628342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628376 */     // GIR_Coverage, 3958,
     /* 1628376 */     GIR_EraseRootFromParent_Done,
     /* 1628377 */   // Label 22455: @1628377
     /* 1628377 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1628463), // Rule ID 3959 //
     /* 1628382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1628402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628428 */     // MIs[0] policy
     /* 1628428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628462 */     // GIR_Coverage, 3959,
     /* 1628462 */     GIR_EraseRootFromParent_Done,
     /* 1628463 */   // Label 22456: @1628463
     /* 1628463 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1628549), // Rule ID 3962 //
     /* 1628468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628514 */     // MIs[0] policy
     /* 1628514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628548 */     // GIR_Coverage, 3962,
     /* 1628548 */     GIR_EraseRootFromParent_Done,
     /* 1628549 */   // Label 22457: @1628549
     /* 1628549 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1628635), // Rule ID 3963 //
     /* 1628554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628600 */     // MIs[0] policy
     /* 1628600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628634 */     // GIR_Coverage, 3963,
     /* 1628634 */     GIR_EraseRootFromParent_Done,
     /* 1628635 */   // Label 22458: @1628635
     /* 1628635 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1628721), // Rule ID 3966 //
     /* 1628640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628686 */     // MIs[0] policy
     /* 1628686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628720 */     // GIR_Coverage, 3966,
     /* 1628720 */     GIR_EraseRootFromParent_Done,
     /* 1628721 */   // Label 22459: @1628721
     /* 1628721 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1628807), // Rule ID 3967 //
     /* 1628726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628772 */     // MIs[0] policy
     /* 1628772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628806 */     // GIR_Coverage, 3967,
     /* 1628806 */     GIR_EraseRootFromParent_Done,
     /* 1628807 */   // Label 22460: @1628807
     /* 1628807 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1628893), // Rule ID 3970 //
     /* 1628812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628858 */     // MIs[0] policy
     /* 1628858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628892 */     // GIR_Coverage, 3970,
     /* 1628892 */     GIR_EraseRootFromParent_Done,
     /* 1628893 */   // Label 22461: @1628893
     /* 1628893 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1628979), // Rule ID 3971 //
     /* 1628898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628944 */     // MIs[0] policy
     /* 1628944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628978 */     // GIR_Coverage, 3971,
     /* 1628978 */     GIR_EraseRootFromParent_Done,
     /* 1628979 */   // Label 22462: @1628979
     /* 1628979 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1629065), // Rule ID 3974 //
     /* 1628984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1629004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629030 */     // MIs[0] policy
     /* 1629030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629064 */     // GIR_Coverage, 3974,
     /* 1629064 */     GIR_EraseRootFromParent_Done,
     /* 1629065 */   // Label 22463: @1629065
     /* 1629065 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1629151), // Rule ID 3975 //
     /* 1629070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1629087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1629090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629116 */     // MIs[0] policy
     /* 1629116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629150 */     // GIR_Coverage, 3975,
     /* 1629150 */     GIR_EraseRootFromParent_Done,
     /* 1629151 */   // Label 22464: @1629151
     /* 1629151 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1629237), // Rule ID 3978 //
     /* 1629156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1629176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629202 */     // MIs[0] policy
     /* 1629202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1629215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629236 */     // GIR_Coverage, 3978,
     /* 1629236 */     GIR_EraseRootFromParent_Done,
     /* 1629237 */   // Label 22465: @1629237
     /* 1629237 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1629323), // Rule ID 3979 //
     /* 1629242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1629262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629288 */     // MIs[0] policy
     /* 1629288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1629301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629322 */     // GIR_Coverage, 3979,
     /* 1629322 */     GIR_EraseRootFromParent_Done,
     /* 1629323 */   // Label 22466: @1629323
     /* 1629323 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1629409), // Rule ID 3982 //
     /* 1629328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1629348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629374 */     // MIs[0] policy
     /* 1629374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629408 */     // GIR_Coverage, 3982,
     /* 1629408 */     GIR_EraseRootFromParent_Done,
     /* 1629409 */   // Label 22467: @1629409
     /* 1629409 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1629495), // Rule ID 3983 //
     /* 1629414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1629434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629460 */     // MIs[0] policy
     /* 1629460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629494 */     // GIR_Coverage, 3983,
     /* 1629494 */     GIR_EraseRootFromParent_Done,
     /* 1629495 */   // Label 22468: @1629495
     /* 1629495 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1629581), // Rule ID 3986 //
     /* 1629500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629546 */     // MIs[0] policy
     /* 1629546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629580 */     // GIR_Coverage, 3986,
     /* 1629580 */     GIR_EraseRootFromParent_Done,
     /* 1629581 */   // Label 22469: @1629581
     /* 1629581 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1629667), // Rule ID 3987 //
     /* 1629586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629632 */     // MIs[0] policy
     /* 1629632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629666 */     // GIR_Coverage, 3987,
     /* 1629666 */     GIR_EraseRootFromParent_Done,
     /* 1629667 */   // Label 22470: @1629667
     /* 1629667 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1629753), // Rule ID 3990 //
     /* 1629672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629718 */     // MIs[0] policy
     /* 1629718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629752 */     // GIR_Coverage, 3990,
     /* 1629752 */     GIR_EraseRootFromParent_Done,
     /* 1629753 */   // Label 22471: @1629753
     /* 1629753 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1629839), // Rule ID 3991 //
     /* 1629758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629804 */     // MIs[0] policy
     /* 1629804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629838 */     // GIR_Coverage, 3991,
     /* 1629838 */     GIR_EraseRootFromParent_Done,
     /* 1629839 */   // Label 22472: @1629839
     /* 1629839 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1629925), // Rule ID 3994 //
     /* 1629844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629890 */     // MIs[0] policy
     /* 1629890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629924 */     // GIR_Coverage, 3994,
     /* 1629924 */     GIR_EraseRootFromParent_Done,
     /* 1629925 */   // Label 22473: @1629925
     /* 1629925 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1630011), // Rule ID 3995 //
     /* 1629930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629976 */     // MIs[0] policy
     /* 1629976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630010 */     // GIR_Coverage, 3995,
     /* 1630010 */     GIR_EraseRootFromParent_Done,
     /* 1630011 */   // Label 22474: @1630011
     /* 1630011 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1630097), // Rule ID 3998 //
     /* 1630016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1630036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630062 */     // MIs[0] policy
     /* 1630062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1630075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630096 */     // GIR_Coverage, 3998,
     /* 1630096 */     GIR_EraseRootFromParent_Done,
     /* 1630097 */   // Label 22475: @1630097
     /* 1630097 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1630183), // Rule ID 3999 //
     /* 1630102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1630119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1630122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630148 */     // MIs[0] policy
     /* 1630148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1630161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630182 */     // GIR_Coverage, 3999,
     /* 1630182 */     GIR_EraseRootFromParent_Done,
     /* 1630183 */   // Label 22476: @1630183
     /* 1630183 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1630269), // Rule ID 4002 //
     /* 1630188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1630208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630234 */     // MIs[0] policy
     /* 1630234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1630247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630268 */     // GIR_Coverage, 4002,
     /* 1630268 */     GIR_EraseRootFromParent_Done,
     /* 1630269 */   // Label 22477: @1630269
     /* 1630269 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1630355), // Rule ID 4003 //
     /* 1630274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1630294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630320 */     // MIs[0] policy
     /* 1630320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630330 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1630333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630354 */     // GIR_Coverage, 4003,
     /* 1630354 */     GIR_EraseRootFromParent_Done,
     /* 1630355 */   // Label 22478: @1630355
     /* 1630355 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1630441), // Rule ID 4006 //
     /* 1630360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630406 */     // MIs[0] policy
     /* 1630406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630440 */     // GIR_Coverage, 4006,
     /* 1630440 */     GIR_EraseRootFromParent_Done,
     /* 1630441 */   // Label 22479: @1630441
     /* 1630441 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1630527), // Rule ID 4007 //
     /* 1630446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630492 */     // MIs[0] policy
     /* 1630492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630526 */     // GIR_Coverage, 4007,
     /* 1630526 */     GIR_EraseRootFromParent_Done,
     /* 1630527 */   // Label 22480: @1630527
     /* 1630527 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1630613), // Rule ID 4010 //
     /* 1630532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630578 */     // MIs[0] policy
     /* 1630578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630612 */     // GIR_Coverage, 4010,
     /* 1630612 */     GIR_EraseRootFromParent_Done,
     /* 1630613 */   // Label 22481: @1630613
     /* 1630613 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1630699), // Rule ID 4011 //
     /* 1630618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630664 */     // MIs[0] policy
     /* 1630664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630674 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630698 */     // GIR_Coverage, 4011,
     /* 1630698 */     GIR_EraseRootFromParent_Done,
     /* 1630699 */   // Label 22482: @1630699
     /* 1630699 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1630785), // Rule ID 4014 //
     /* 1630704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630750 */     // MIs[0] policy
     /* 1630750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630784 */     // GIR_Coverage, 4014,
     /* 1630784 */     GIR_EraseRootFromParent_Done,
     /* 1630785 */   // Label 22483: @1630785
     /* 1630785 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1630871), // Rule ID 4015 //
     /* 1630790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630836 */     // MIs[0] policy
     /* 1630836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630870 */     // GIR_Coverage, 4015,
     /* 1630870 */     GIR_EraseRootFromParent_Done,
     /* 1630871 */   // Label 22484: @1630871
     /* 1630871 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1630957), // Rule ID 4018 //
     /* 1630876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630922 */     // MIs[0] policy
     /* 1630922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630956 */     // GIR_Coverage, 4018,
     /* 1630956 */     GIR_EraseRootFromParent_Done,
     /* 1630957 */   // Label 22485: @1630957
     /* 1630957 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1631043), // Rule ID 4019 //
     /* 1630962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631008 */     // MIs[0] policy
     /* 1631008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631042 */     // GIR_Coverage, 4019,
     /* 1631042 */     GIR_EraseRootFromParent_Done,
     /* 1631043 */   // Label 22486: @1631043
     /* 1631043 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1631129), // Rule ID 4022 //
     /* 1631048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631094 */     // MIs[0] policy
     /* 1631094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631128 */     // GIR_Coverage, 4022,
     /* 1631128 */     GIR_EraseRootFromParent_Done,
     /* 1631129 */   // Label 22487: @1631129
     /* 1631129 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1631215), // Rule ID 4023 //
     /* 1631134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1631151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631180 */     // MIs[0] policy
     /* 1631180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11724:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631214 */     // GIR_Coverage, 4023,
     /* 1631214 */     GIR_EraseRootFromParent_Done,
     /* 1631215 */   // Label 22488: @1631215
     /* 1631215 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1631301), // Rule ID 4026 //
     /* 1631220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1631237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631266 */     // MIs[0] policy
     /* 1631266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631300 */     // GIR_Coverage, 4026,
     /* 1631300 */     GIR_EraseRootFromParent_Done,
     /* 1631301 */   // Label 22489: @1631301
     /* 1631301 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1631387), // Rule ID 4027 //
     /* 1631306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1631323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631352 */     // MIs[0] policy
     /* 1631352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631386 */     // GIR_Coverage, 4027,
     /* 1631386 */     GIR_EraseRootFromParent_Done,
     /* 1631387 */   // Label 22490: @1631387
     /* 1631387 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1631473), // Rule ID 4030 //
     /* 1631392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631438 */     // MIs[0] policy
     /* 1631438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631448 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631472 */     // GIR_Coverage, 4030,
     /* 1631472 */     GIR_EraseRootFromParent_Done,
     /* 1631473 */   // Label 22491: @1631473
     /* 1631473 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1631559), // Rule ID 4031 //
     /* 1631478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631524 */     // MIs[0] policy
     /* 1631524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631558 */     // GIR_Coverage, 4031,
     /* 1631558 */     GIR_EraseRootFromParent_Done,
     /* 1631559 */   // Label 22492: @1631559
     /* 1631559 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1631645), // Rule ID 4034 //
     /* 1631564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631610 */     // MIs[0] policy
     /* 1631610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631644 */     // GIR_Coverage, 4034,
     /* 1631644 */     GIR_EraseRootFromParent_Done,
     /* 1631645 */   // Label 22493: @1631645
     /* 1631645 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1631731), // Rule ID 4035 //
     /* 1631650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631696 */     // MIs[0] policy
     /* 1631696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631730 */     // GIR_Coverage, 4035,
     /* 1631730 */     GIR_EraseRootFromParent_Done,
     /* 1631731 */   // Label 22494: @1631731
     /* 1631731 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1631817), // Rule ID 4038 //
     /* 1631736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631782 */     // MIs[0] policy
     /* 1631782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631816 */     // GIR_Coverage, 4038,
     /* 1631816 */     GIR_EraseRootFromParent_Done,
     /* 1631817 */   // Label 22495: @1631817
     /* 1631817 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1631903), // Rule ID 4039 //
     /* 1631822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631868 */     // MIs[0] policy
     /* 1631868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631902 */     // GIR_Coverage, 4039,
     /* 1631902 */     GIR_EraseRootFromParent_Done,
     /* 1631903 */   // Label 22496: @1631903
     /* 1631903 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1631989), // Rule ID 4042 //
     /* 1631908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631954 */     // MIs[0] policy
     /* 1631954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631964 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631988 */     // GIR_Coverage, 4042,
     /* 1631988 */     GIR_EraseRootFromParent_Done,
     /* 1631989 */   // Label 22497: @1631989
     /* 1631989 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1632075), // Rule ID 4043 //
     /* 1631994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632040 */     // MIs[0] policy
     /* 1632040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11724:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632074 */     // GIR_Coverage, 4043,
     /* 1632074 */     GIR_EraseRootFromParent_Done,
     /* 1632075 */   // Label 22498: @1632075
     /* 1632075 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1632161), // Rule ID 4046 //
     /* 1632080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632126 */     // MIs[0] policy
     /* 1632126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632160 */     // GIR_Coverage, 4046,
     /* 1632160 */     GIR_EraseRootFromParent_Done,
     /* 1632161 */   // Label 22499: @1632161
     /* 1632161 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1632247), // Rule ID 4047 //
     /* 1632166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1632183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632212 */     // MIs[0] policy
     /* 1632212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632246 */     // GIR_Coverage, 4047,
     /* 1632246 */     GIR_EraseRootFromParent_Done,
     /* 1632247 */   // Label 22500: @1632247
     /* 1632247 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1632333), // Rule ID 4050 //
     /* 1632252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1632269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632298 */     // MIs[0] policy
     /* 1632298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632332 */     // GIR_Coverage, 4050,
     /* 1632332 */     GIR_EraseRootFromParent_Done,
     /* 1632333 */   // Label 22501: @1632333
     /* 1632333 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1632419), // Rule ID 4051 //
     /* 1632338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1632355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632384 */     // MIs[0] policy
     /* 1632384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632418 */     // GIR_Coverage, 4051,
     /* 1632418 */     GIR_EraseRootFromParent_Done,
     /* 1632419 */   // Label 22502: @1632419
     /* 1632419 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1632505), // Rule ID 4054 //
     /* 1632424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632470 */     // MIs[0] policy
     /* 1632470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632504 */     // GIR_Coverage, 4054,
     /* 1632504 */     GIR_EraseRootFromParent_Done,
     /* 1632505 */   // Label 22503: @1632505
     /* 1632505 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1632591), // Rule ID 4055 //
     /* 1632510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632556 */     // MIs[0] policy
     /* 1632556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632590 */     // GIR_Coverage, 4055,
     /* 1632590 */     GIR_EraseRootFromParent_Done,
     /* 1632591 */   // Label 22504: @1632591
     /* 1632591 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1632677), // Rule ID 4058 //
     /* 1632596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632642 */     // MIs[0] policy
     /* 1632642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632676 */     // GIR_Coverage, 4058,
     /* 1632676 */     GIR_EraseRootFromParent_Done,
     /* 1632677 */   // Label 22505: @1632677
     /* 1632677 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1632763), // Rule ID 4059 //
     /* 1632682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632728 */     // MIs[0] policy
     /* 1632728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11724:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632762 */     // GIR_Coverage, 4059,
     /* 1632762 */     GIR_EraseRootFromParent_Done,
     /* 1632763 */   // Label 22506: @1632763
     /* 1632763 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1632849), // Rule ID 4062 //
     /* 1632768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632814 */     // MIs[0] policy
     /* 1632814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632848 */     // GIR_Coverage, 4062,
     /* 1632848 */     GIR_EraseRootFromParent_Done,
     /* 1632849 */   // Label 22507: @1632849
     /* 1632849 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1632935), // Rule ID 4063 //
     /* 1632854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632900 */     // MIs[0] policy
     /* 1632900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11724:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632934 */     // GIR_Coverage, 4063,
     /* 1632934 */     GIR_EraseRootFromParent_Done,
     /* 1632935 */   // Label 22508: @1632935
     /* 1632935 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1633021), // Rule ID 4066 //
     /* 1632940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632986 */     // MIs[0] policy
     /* 1632986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633020 */     // GIR_Coverage, 4066,
     /* 1633020 */     GIR_EraseRootFromParent_Done,
     /* 1633021 */   // Label 22509: @1633021
     /* 1633021 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1633107), // Rule ID 4067 //
     /* 1633026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1633043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633072 */     // MIs[0] policy
     /* 1633072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11724:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1633085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633106 */     // GIR_Coverage, 4067,
     /* 1633106 */     GIR_EraseRootFromParent_Done,
     /* 1633107 */   // Label 22510: @1633107
     /* 1633107 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1633193), // Rule ID 4070 //
     /* 1633112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1633129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633158 */     // MIs[0] policy
     /* 1633158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1633171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633192 */     // GIR_Coverage, 4070,
     /* 1633192 */     GIR_EraseRootFromParent_Done,
     /* 1633193 */   // Label 22511: @1633193
     /* 1633193 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1633279), // Rule ID 4071 //
     /* 1633198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1633206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1633215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633244 */     // MIs[0] policy
     /* 1633244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633254 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11724:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1633257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633278 */     // GIR_Coverage, 4071,
     /* 1633278 */     GIR_EraseRootFromParent_Done,
     /* 1633279 */   // Label 22512: @1633279
     /* 1633279 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1633365), // Rule ID 4080 //
     /* 1633284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1633304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633330 */     // MIs[0] policy
     /* 1633330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633340 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633364 */     // GIR_Coverage, 4080,
     /* 1633364 */     GIR_EraseRootFromParent_Done,
     /* 1633365 */   // Label 22513: @1633365
     /* 1633365 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1633451), // Rule ID 4081 //
     /* 1633370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1633390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633416 */     // MIs[0] policy
     /* 1633416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633450 */     // GIR_Coverage, 4081,
     /* 1633450 */     GIR_EraseRootFromParent_Done,
     /* 1633451 */   // Label 22514: @1633451
     /* 1633451 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1633537), // Rule ID 4090 //
     /* 1633456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633502 */     // MIs[0] policy
     /* 1633502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633536 */     // GIR_Coverage, 4090,
     /* 1633536 */     GIR_EraseRootFromParent_Done,
     /* 1633537 */   // Label 22515: @1633537
     /* 1633537 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1633623), // Rule ID 4091 //
     /* 1633542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633588 */     // MIs[0] policy
     /* 1633588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633622 */     // GIR_Coverage, 4091,
     /* 1633622 */     GIR_EraseRootFromParent_Done,
     /* 1633623 */   // Label 22516: @1633623
     /* 1633623 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1633709), // Rule ID 4100 //
     /* 1633628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633674 */     // MIs[0] policy
     /* 1633674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633708 */     // GIR_Coverage, 4100,
     /* 1633708 */     GIR_EraseRootFromParent_Done,
     /* 1633709 */   // Label 22517: @1633709
     /* 1633709 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1633795), // Rule ID 4101 //
     /* 1633714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633760 */     // MIs[0] policy
     /* 1633760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633794 */     // GIR_Coverage, 4101,
     /* 1633794 */     GIR_EraseRootFromParent_Done,
     /* 1633795 */   // Label 22518: @1633795
     /* 1633795 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1633881), // Rule ID 4110 //
     /* 1633800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633846 */     // MIs[0] policy
     /* 1633846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633856 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633880 */     // GIR_Coverage, 4110,
     /* 1633880 */     GIR_EraseRootFromParent_Done,
     /* 1633881 */   // Label 22519: @1633881
     /* 1633881 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1633967), // Rule ID 4111 //
     /* 1633886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633932 */     // MIs[0] policy
     /* 1633932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633966 */     // GIR_Coverage, 4111,
     /* 1633966 */     GIR_EraseRootFromParent_Done,
     /* 1633967 */   // Label 22520: @1633967
     /* 1633967 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1634053), // Rule ID 4120 //
     /* 1633972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634018 */     // MIs[0] policy
     /* 1634018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634052 */     // GIR_Coverage, 4120,
     /* 1634052 */     GIR_EraseRootFromParent_Done,
     /* 1634053 */   // Label 22521: @1634053
     /* 1634053 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1634139), // Rule ID 4121 //
     /* 1634058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1634069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1634072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1634075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1634078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634104 */     // MIs[0] policy
     /* 1634104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634138 */     // GIR_Coverage, 4121,
     /* 1634138 */     GIR_EraseRootFromParent_Done,
     /* 1634139 */   // Label 22522: @1634139
     /* 1634139 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1634225), // Rule ID 4130 //
     /* 1634144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1634164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634190 */     // MIs[0] policy
     /* 1634190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634200 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1634203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634224 */     // GIR_Coverage, 4130,
     /* 1634224 */     GIR_EraseRootFromParent_Done,
     /* 1634225 */   // Label 22523: @1634225
     /* 1634225 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1634311), // Rule ID 4131 //
     /* 1634230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1634250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634276 */     // MIs[0] policy
     /* 1634276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634286 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1634289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634310 */     // GIR_Coverage, 4131,
     /* 1634310 */     GIR_EraseRootFromParent_Done,
     /* 1634311 */   // Label 22524: @1634311
     /* 1634311 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1634397), // Rule ID 4140 //
     /* 1634316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1634336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634362 */     // MIs[0] policy
     /* 1634362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634396 */     // GIR_Coverage, 4140,
     /* 1634396 */     GIR_EraseRootFromParent_Done,
     /* 1634397 */   // Label 22525: @1634397
     /* 1634397 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1634483), // Rule ID 4141 //
     /* 1634402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1634422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634448 */     // MIs[0] policy
     /* 1634448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634482 */     // GIR_Coverage, 4141,
     /* 1634482 */     GIR_EraseRootFromParent_Done,
     /* 1634483 */   // Label 22526: @1634483
     /* 1634483 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1634569), // Rule ID 4150 //
     /* 1634488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634534 */     // MIs[0] policy
     /* 1634534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634568 */     // GIR_Coverage, 4150,
     /* 1634568 */     GIR_EraseRootFromParent_Done,
     /* 1634569 */   // Label 22527: @1634569
     /* 1634569 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1634655), // Rule ID 4151 //
     /* 1634574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634620 */     // MIs[0] policy
     /* 1634620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634654 */     // GIR_Coverage, 4151,
     /* 1634654 */     GIR_EraseRootFromParent_Done,
     /* 1634655 */   // Label 22528: @1634655
     /* 1634655 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1634741), // Rule ID 4160 //
     /* 1634660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634706 */     // MIs[0] policy
     /* 1634706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634740 */     // GIR_Coverage, 4160,
     /* 1634740 */     GIR_EraseRootFromParent_Done,
     /* 1634741 */   // Label 22529: @1634741
     /* 1634741 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1634827), // Rule ID 4161 //
     /* 1634746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634792 */     // MIs[0] policy
     /* 1634792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634826 */     // GIR_Coverage, 4161,
     /* 1634826 */     GIR_EraseRootFromParent_Done,
     /* 1634827 */   // Label 22530: @1634827
     /* 1634827 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1634913), // Rule ID 4170 //
     /* 1634832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634878 */     // MIs[0] policy
     /* 1634878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634912 */     // GIR_Coverage, 4170,
     /* 1634912 */     GIR_EraseRootFromParent_Done,
     /* 1634913 */   // Label 22531: @1634913
     /* 1634913 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1634999), // Rule ID 4171 //
     /* 1634918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634964 */     // MIs[0] policy
     /* 1634964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634998 */     // GIR_Coverage, 4171,
     /* 1634998 */     GIR_EraseRootFromParent_Done,
     /* 1634999 */   // Label 22532: @1634999
     /* 1634999 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1635085), // Rule ID 4180 //
     /* 1635004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1635024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635050 */     // MIs[0] policy
     /* 1635050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635060 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1635063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635084 */     // GIR_Coverage, 4180,
     /* 1635084 */     GIR_EraseRootFromParent_Done,
     /* 1635085 */   // Label 22533: @1635085
     /* 1635085 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1635171), // Rule ID 4181 //
     /* 1635090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1635110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635136 */     // MIs[0] policy
     /* 1635136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1635149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635170 */     // GIR_Coverage, 4181,
     /* 1635170 */     GIR_EraseRootFromParent_Done,
     /* 1635171 */   // Label 22534: @1635171
     /* 1635171 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1635257), // Rule ID 4190 //
     /* 1635176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1635196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635222 */     // MIs[0] policy
     /* 1635222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1635235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635256 */     // GIR_Coverage, 4190,
     /* 1635256 */     GIR_EraseRootFromParent_Done,
     /* 1635257 */   // Label 22535: @1635257
     /* 1635257 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1635343), // Rule ID 4191 //
     /* 1635262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1635282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635308 */     // MIs[0] policy
     /* 1635308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1635321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635342 */     // GIR_Coverage, 4191,
     /* 1635342 */     GIR_EraseRootFromParent_Done,
     /* 1635343 */   // Label 22536: @1635343
     /* 1635343 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1635429), // Rule ID 4200 //
     /* 1635348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1635368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635394 */     // MIs[0] policy
     /* 1635394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635404 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635428 */     // GIR_Coverage, 4200,
     /* 1635428 */     GIR_EraseRootFromParent_Done,
     /* 1635429 */   // Label 22537: @1635429
     /* 1635429 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1635515), // Rule ID 4201 //
     /* 1635434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1635454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635480 */     // MIs[0] policy
     /* 1635480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635514 */     // GIR_Coverage, 4201,
     /* 1635514 */     GIR_EraseRootFromParent_Done,
     /* 1635515 */   // Label 22538: @1635515
     /* 1635515 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1635601), // Rule ID 4210 //
     /* 1635520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635566 */     // MIs[0] policy
     /* 1635566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635600 */     // GIR_Coverage, 4210,
     /* 1635600 */     GIR_EraseRootFromParent_Done,
     /* 1635601 */   // Label 22539: @1635601
     /* 1635601 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1635687), // Rule ID 4211 //
     /* 1635606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635652 */     // MIs[0] policy
     /* 1635652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635662 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635686 */     // GIR_Coverage, 4211,
     /* 1635686 */     GIR_EraseRootFromParent_Done,
     /* 1635687 */   // Label 22540: @1635687
     /* 1635687 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1635773), // Rule ID 4214 //
     /* 1635692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635738 */     // MIs[0] policy
     /* 1635738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635772 */     // GIR_Coverage, 4214,
     /* 1635772 */     GIR_EraseRootFromParent_Done,
     /* 1635773 */   // Label 22541: @1635773
     /* 1635773 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1635859), // Rule ID 4215 //
     /* 1635778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635824 */     // MIs[0] policy
     /* 1635824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635834 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635858 */     // GIR_Coverage, 4215,
     /* 1635858 */     GIR_EraseRootFromParent_Done,
     /* 1635859 */   // Label 22542: @1635859
     /* 1635859 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1635945), // Rule ID 4218 //
     /* 1635864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635910 */     // MIs[0] policy
     /* 1635910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635944 */     // GIR_Coverage, 4218,
     /* 1635944 */     GIR_EraseRootFromParent_Done,
     /* 1635945 */   // Label 22543: @1635945
     /* 1635945 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1636031), // Rule ID 4219 //
     /* 1635950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635996 */     // MIs[0] policy
     /* 1635996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636030 */     // GIR_Coverage, 4219,
     /* 1636030 */     GIR_EraseRootFromParent_Done,
     /* 1636031 */   // Label 22544: @1636031
     /* 1636031 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1636117), // Rule ID 4222 //
     /* 1636036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636082 */     // MIs[0] policy
     /* 1636082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636116 */     // GIR_Coverage, 4222,
     /* 1636116 */     GIR_EraseRootFromParent_Done,
     /* 1636117 */   // Label 22545: @1636117
     /* 1636117 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1636203), // Rule ID 4223 //
     /* 1636122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636168 */     // MIs[0] policy
     /* 1636168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636178 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11702:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636202 */     // GIR_Coverage, 4223,
     /* 1636202 */     GIR_EraseRootFromParent_Done,
     /* 1636203 */   // Label 22546: @1636203
     /* 1636203 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1636289), // Rule ID 4226 //
     /* 1636208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636254 */     // MIs[0] policy
     /* 1636254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636288 */     // GIR_Coverage, 4226,
     /* 1636288 */     GIR_EraseRootFromParent_Done,
     /* 1636289 */   // Label 22547: @1636289
     /* 1636289 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1636375), // Rule ID 4227 //
     /* 1636294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636340 */     // MIs[0] policy
     /* 1636340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636374 */     // GIR_Coverage, 4227,
     /* 1636374 */     GIR_EraseRootFromParent_Done,
     /* 1636375 */   // Label 22548: @1636375
     /* 1636375 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1636461), // Rule ID 4230 //
     /* 1636380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636426 */     // MIs[0] policy
     /* 1636426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636460 */     // GIR_Coverage, 4230,
     /* 1636460 */     GIR_EraseRootFromParent_Done,
     /* 1636461 */   // Label 22549: @1636461
     /* 1636461 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1636547), // Rule ID 4231 //
     /* 1636466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636512 */     // MIs[0] policy
     /* 1636512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636546 */     // GIR_Coverage, 4231,
     /* 1636546 */     GIR_EraseRootFromParent_Done,
     /* 1636547 */   // Label 22550: @1636547
     /* 1636547 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1636633), // Rule ID 4234 //
     /* 1636552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636598 */     // MIs[0] policy
     /* 1636598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636632 */     // GIR_Coverage, 4234,
     /* 1636632 */     GIR_EraseRootFromParent_Done,
     /* 1636633 */   // Label 22551: @1636633
     /* 1636633 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1636719), // Rule ID 4235 //
     /* 1636638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636684 */     // MIs[0] policy
     /* 1636684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636718 */     // GIR_Coverage, 4235,
     /* 1636718 */     GIR_EraseRootFromParent_Done,
     /* 1636719 */   // Label 22552: @1636719
     /* 1636719 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1636805), // Rule ID 4238 //
     /* 1636724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636770 */     // MIs[0] policy
     /* 1636770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636804 */     // GIR_Coverage, 4238,
     /* 1636804 */     GIR_EraseRootFromParent_Done,
     /* 1636805 */   // Label 22553: @1636805
     /* 1636805 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1636891), // Rule ID 4239 //
     /* 1636810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636856 */     // MIs[0] policy
     /* 1636856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636890 */     // GIR_Coverage, 4239,
     /* 1636890 */     GIR_EraseRootFromParent_Done,
     /* 1636891 */   // Label 22554: @1636891
     /* 1636891 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1636977), // Rule ID 4242 //
     /* 1636896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636942 */     // MIs[0] policy
     /* 1636942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636976 */     // GIR_Coverage, 4242,
     /* 1636976 */     GIR_EraseRootFromParent_Done,
     /* 1636977 */   // Label 22555: @1636977
     /* 1636977 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1637063), // Rule ID 4243 //
     /* 1636982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637028 */     // MIs[0] policy
     /* 1637028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11702:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637062 */     // GIR_Coverage, 4243,
     /* 1637062 */     GIR_EraseRootFromParent_Done,
     /* 1637063 */   // Label 22556: @1637063
     /* 1637063 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1637149), // Rule ID 4246 //
     /* 1637068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637114 */     // MIs[0] policy
     /* 1637114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637148 */     // GIR_Coverage, 4246,
     /* 1637148 */     GIR_EraseRootFromParent_Done,
     /* 1637149 */   // Label 22557: @1637149
     /* 1637149 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1637235), // Rule ID 4247 //
     /* 1637154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637200 */     // MIs[0] policy
     /* 1637200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637234 */     // GIR_Coverage, 4247,
     /* 1637234 */     GIR_EraseRootFromParent_Done,
     /* 1637235 */   // Label 22558: @1637235
     /* 1637235 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1637321), // Rule ID 4250 //
     /* 1637240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637286 */     // MIs[0] policy
     /* 1637286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637320 */     // GIR_Coverage, 4250,
     /* 1637320 */     GIR_EraseRootFromParent_Done,
     /* 1637321 */   // Label 22559: @1637321
     /* 1637321 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1637407), // Rule ID 4251 //
     /* 1637326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637372 */     // MIs[0] policy
     /* 1637372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637406 */     // GIR_Coverage, 4251,
     /* 1637406 */     GIR_EraseRootFromParent_Done,
     /* 1637407 */   // Label 22560: @1637407
     /* 1637407 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1637493), // Rule ID 4254 //
     /* 1637412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637458 */     // MIs[0] policy
     /* 1637458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637492 */     // GIR_Coverage, 4254,
     /* 1637492 */     GIR_EraseRootFromParent_Done,
     /* 1637493 */   // Label 22561: @1637493
     /* 1637493 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1637579), // Rule ID 4255 //
     /* 1637498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637544 */     // MIs[0] policy
     /* 1637544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637578 */     // GIR_Coverage, 4255,
     /* 1637578 */     GIR_EraseRootFromParent_Done,
     /* 1637579 */   // Label 22562: @1637579
     /* 1637579 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1637665), // Rule ID 4258 //
     /* 1637584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637630 */     // MIs[0] policy
     /* 1637630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637664 */     // GIR_Coverage, 4258,
     /* 1637664 */     GIR_EraseRootFromParent_Done,
     /* 1637665 */   // Label 22563: @1637665
     /* 1637665 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1637751), // Rule ID 4259 //
     /* 1637670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637716 */     // MIs[0] policy
     /* 1637716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11702:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637750 */     // GIR_Coverage, 4259,
     /* 1637750 */     GIR_EraseRootFromParent_Done,
     /* 1637751 */   // Label 22564: @1637751
     /* 1637751 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1637837), // Rule ID 4262 //
     /* 1637756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637802 */     // MIs[0] policy
     /* 1637802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637836 */     // GIR_Coverage, 4262,
     /* 1637836 */     GIR_EraseRootFromParent_Done,
     /* 1637837 */   // Label 22565: @1637837
     /* 1637837 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1637923), // Rule ID 4263 //
     /* 1637842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637888 */     // MIs[0] policy
     /* 1637888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11702:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637922 */     // GIR_Coverage, 4263,
     /* 1637922 */     GIR_EraseRootFromParent_Done,
     /* 1637923 */   // Label 22566: @1637923
     /* 1637923 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1638009), // Rule ID 4266 //
     /* 1637928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637974 */     // MIs[0] policy
     /* 1637974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638008 */     // GIR_Coverage, 4266,
     /* 1638008 */     GIR_EraseRootFromParent_Done,
     /* 1638009 */   // Label 22567: @1638009
     /* 1638009 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1638095), // Rule ID 4267 //
     /* 1638014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638060 */     // MIs[0] policy
     /* 1638060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11702:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1638073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638094 */     // GIR_Coverage, 4267,
     /* 1638094 */     GIR_EraseRootFromParent_Done,
     /* 1638095 */   // Label 22568: @1638095
     /* 1638095 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1638181), // Rule ID 4270 //
     /* 1638100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638146 */     // MIs[0] policy
     /* 1638146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1638159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638180 */     // GIR_Coverage, 4270,
     /* 1638180 */     GIR_EraseRootFromParent_Done,
     /* 1638181 */   // Label 22569: @1638181
     /* 1638181 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1638267), // Rule ID 4271 //
     /* 1638186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1638194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638232 */     // MIs[0] policy
     /* 1638232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11702:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1638245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638266 */     // GIR_Coverage, 4271,
     /* 1638266 */     GIR_EraseRootFromParent_Done,
     /* 1638267 */   // Label 22570: @1638267
     /* 1638267 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1638353), // Rule ID 4280 //
     /* 1638272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638318 */     // MIs[0] policy
     /* 1638318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1638331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638352 */     // GIR_Coverage, 4280,
     /* 1638352 */     GIR_EraseRootFromParent_Done,
     /* 1638353 */   // Label 22571: @1638353
     /* 1638353 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1638439), // Rule ID 4281 //
     /* 1638358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1638378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638404 */     // MIs[0] policy
     /* 1638404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1638417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638438 */     // GIR_Coverage, 4281,
     /* 1638438 */     GIR_EraseRootFromParent_Done,
     /* 1638439 */   // Label 22572: @1638439
     /* 1638439 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1638525), // Rule ID 4290 //
     /* 1638444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638490 */     // MIs[0] policy
     /* 1638490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638524 */     // GIR_Coverage, 4290,
     /* 1638524 */     GIR_EraseRootFromParent_Done,
     /* 1638525 */   // Label 22573: @1638525
     /* 1638525 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1638611), // Rule ID 4291 //
     /* 1638530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638576 */     // MIs[0] policy
     /* 1638576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638610 */     // GIR_Coverage, 4291,
     /* 1638610 */     GIR_EraseRootFromParent_Done,
     /* 1638611 */   // Label 22574: @1638611
     /* 1638611 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1638697), // Rule ID 4300 //
     /* 1638616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638662 */     // MIs[0] policy
     /* 1638662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638696 */     // GIR_Coverage, 4300,
     /* 1638696 */     GIR_EraseRootFromParent_Done,
     /* 1638697 */   // Label 22575: @1638697
     /* 1638697 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1638783), // Rule ID 4301 //
     /* 1638702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638748 */     // MIs[0] policy
     /* 1638748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638782 */     // GIR_Coverage, 4301,
     /* 1638782 */     GIR_EraseRootFromParent_Done,
     /* 1638783 */   // Label 22576: @1638783
     /* 1638783 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1638869), // Rule ID 4310 //
     /* 1638788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638834 */     // MIs[0] policy
     /* 1638834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638868 */     // GIR_Coverage, 4310,
     /* 1638868 */     GIR_EraseRootFromParent_Done,
     /* 1638869 */   // Label 22577: @1638869
     /* 1638869 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1638955), // Rule ID 4311 //
     /* 1638874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638920 */     // MIs[0] policy
     /* 1638920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638954 */     // GIR_Coverage, 4311,
     /* 1638954 */     GIR_EraseRootFromParent_Done,
     /* 1638955 */   // Label 22578: @1638955
     /* 1638955 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1639041), // Rule ID 4320 //
     /* 1638960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639006 */     // MIs[0] policy
     /* 1639006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639040 */     // GIR_Coverage, 4320,
     /* 1639040 */     GIR_EraseRootFromParent_Done,
     /* 1639041 */   // Label 22579: @1639041
     /* 1639041 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1639127), // Rule ID 4321 //
     /* 1639046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1639066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639092 */     // MIs[0] policy
     /* 1639092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639126 */     // GIR_Coverage, 4321,
     /* 1639126 */     GIR_EraseRootFromParent_Done,
     /* 1639127 */   // Label 22580: @1639127
     /* 1639127 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1639213), // Rule ID 4330 //
     /* 1639132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1639152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639178 */     // MIs[0] policy
     /* 1639178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639188 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639212 */     // GIR_Coverage, 4330,
     /* 1639212 */     GIR_EraseRootFromParent_Done,
     /* 1639213 */   // Label 22581: @1639213
     /* 1639213 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1639299), // Rule ID 4331 //
     /* 1639218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1639238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639264 */     // MIs[0] policy
     /* 1639264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639298 */     // GIR_Coverage, 4331,
     /* 1639298 */     GIR_EraseRootFromParent_Done,
     /* 1639299 */   // Label 22582: @1639299
     /* 1639299 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1639385), // Rule ID 4340 //
     /* 1639304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639350 */     // MIs[0] policy
     /* 1639350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639360 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1639363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639384 */     // GIR_Coverage, 4340,
     /* 1639384 */     GIR_EraseRootFromParent_Done,
     /* 1639385 */   // Label 22583: @1639385
     /* 1639385 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1639471), // Rule ID 4341 //
     /* 1639390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1639410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639436 */     // MIs[0] policy
     /* 1639436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1639449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639470 */     // GIR_Coverage, 4341,
     /* 1639470 */     GIR_EraseRootFromParent_Done,
     /* 1639471 */   // Label 22584: @1639471
     /* 1639471 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1639557), // Rule ID 4350 //
     /* 1639476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639522 */     // MIs[0] policy
     /* 1639522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639556 */     // GIR_Coverage, 4350,
     /* 1639556 */     GIR_EraseRootFromParent_Done,
     /* 1639557 */   // Label 22585: @1639557
     /* 1639557 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1639643), // Rule ID 4351 //
     /* 1639562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639608 */     // MIs[0] policy
     /* 1639608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639642 */     // GIR_Coverage, 4351,
     /* 1639642 */     GIR_EraseRootFromParent_Done,
     /* 1639643 */   // Label 22586: @1639643
     /* 1639643 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1639729), // Rule ID 4360 //
     /* 1639648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639694 */     // MIs[0] policy
     /* 1639694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639728 */     // GIR_Coverage, 4360,
     /* 1639728 */     GIR_EraseRootFromParent_Done,
     /* 1639729 */   // Label 22587: @1639729
     /* 1639729 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1639815), // Rule ID 4361 //
     /* 1639734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639780 */     // MIs[0] policy
     /* 1639780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639814 */     // GIR_Coverage, 4361,
     /* 1639814 */     GIR_EraseRootFromParent_Done,
     /* 1639815 */   // Label 22588: @1639815
     /* 1639815 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1639901), // Rule ID 4370 //
     /* 1639820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639866 */     // MIs[0] policy
     /* 1639866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639900 */     // GIR_Coverage, 4370,
     /* 1639900 */     GIR_EraseRootFromParent_Done,
     /* 1639901 */   // Label 22589: @1639901
     /* 1639901 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1639987), // Rule ID 4371 //
     /* 1639906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639952 */     // MIs[0] policy
     /* 1639952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639986 */     // GIR_Coverage, 4371,
     /* 1639986 */     GIR_EraseRootFromParent_Done,
     /* 1639987 */   // Label 22590: @1639987
     /* 1639987 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1640073), // Rule ID 4380 //
     /* 1639992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1640012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640038 */     // MIs[0] policy
     /* 1640038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640072 */     // GIR_Coverage, 4380,
     /* 1640072 */     GIR_EraseRootFromParent_Done,
     /* 1640073 */   // Label 22591: @1640073
     /* 1640073 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1640159), // Rule ID 4381 //
     /* 1640078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1640098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640124 */     // MIs[0] policy
     /* 1640124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640158 */     // GIR_Coverage, 4381,
     /* 1640158 */     GIR_EraseRootFromParent_Done,
     /* 1640159 */   // Label 22592: @1640159
     /* 1640159 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1640245), // Rule ID 4390 //
     /* 1640164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1640184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640210 */     // MIs[0] policy
     /* 1640210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1640223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640244 */     // GIR_Coverage, 4390,
     /* 1640244 */     GIR_EraseRootFromParent_Done,
     /* 1640245 */   // Label 22593: @1640245
     /* 1640245 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1640331), // Rule ID 4391 //
     /* 1640250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1640270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640296 */     // MIs[0] policy
     /* 1640296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1640309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640330 */     // GIR_Coverage, 4391,
     /* 1640330 */     GIR_EraseRootFromParent_Done,
     /* 1640331 */   // Label 22594: @1640331
     /* 1640331 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1640417), // Rule ID 4400 //
     /* 1640336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640382 */     // MIs[0] policy
     /* 1640382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640416 */     // GIR_Coverage, 4400,
     /* 1640416 */     GIR_EraseRootFromParent_Done,
     /* 1640417 */   // Label 22595: @1640417
     /* 1640417 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1640503), // Rule ID 4401 //
     /* 1640422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1640442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640468 */     // MIs[0] policy
     /* 1640468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640502 */     // GIR_Coverage, 4401,
     /* 1640502 */     GIR_EraseRootFromParent_Done,
     /* 1640503 */   // Label 22596: @1640503
     /* 1640503 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1640589), // Rule ID 4410 //
     /* 1640508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640554 */     // MIs[0] policy
     /* 1640554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640588 */     // GIR_Coverage, 4410,
     /* 1640588 */     GIR_EraseRootFromParent_Done,
     /* 1640589 */   // Label 22597: @1640589
     /* 1640589 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1640675), // Rule ID 4411 //
     /* 1640594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640640 */     // MIs[0] policy
     /* 1640640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640650 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640674 */     // GIR_Coverage, 4411,
     /* 1640674 */     GIR_EraseRootFromParent_Done,
     /* 1640675 */   // Label 22598: @1640675
     /* 1640675 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1640761), // Rule ID 4420 //
     /* 1640680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640726 */     // MIs[0] policy
     /* 1640726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640760 */     // GIR_Coverage, 4420,
     /* 1640760 */     GIR_EraseRootFromParent_Done,
     /* 1640761 */   // Label 22599: @1640761
     /* 1640761 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1640847), // Rule ID 4421 //
     /* 1640766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640812 */     // MIs[0] policy
     /* 1640812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640822 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640846 */     // GIR_Coverage, 4421,
     /* 1640846 */     GIR_EraseRootFromParent_Done,
     /* 1640847 */   // Label 22600: @1640847
     /* 1640847 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1640933), // Rule ID 4424 //
     /* 1640852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640898 */     // MIs[0] policy
     /* 1640898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640932 */     // GIR_Coverage, 4424,
     /* 1640932 */     GIR_EraseRootFromParent_Done,
     /* 1640933 */   // Label 22601: @1640933
     /* 1640933 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1641019), // Rule ID 4425 //
     /* 1640938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640984 */     // MIs[0] policy
     /* 1640984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641018 */     // GIR_Coverage, 4425,
     /* 1641018 */     GIR_EraseRootFromParent_Done,
     /* 1641019 */   // Label 22602: @1641019
     /* 1641019 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1641105), // Rule ID 4428 //
     /* 1641024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641070 */     // MIs[0] policy
     /* 1641070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641080 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641104 */     // GIR_Coverage, 4428,
     /* 1641104 */     GIR_EraseRootFromParent_Done,
     /* 1641105 */   // Label 22603: @1641105
     /* 1641105 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1641191), // Rule ID 4429 //
     /* 1641110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641156 */     // MIs[0] policy
     /* 1641156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641190 */     // GIR_Coverage, 4429,
     /* 1641190 */     GIR_EraseRootFromParent_Done,
     /* 1641191 */   // Label 22604: @1641191
     /* 1641191 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1641277), // Rule ID 4432 //
     /* 1641196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641242 */     // MIs[0] policy
     /* 1641242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641276 */     // GIR_Coverage, 4432,
     /* 1641276 */     GIR_EraseRootFromParent_Done,
     /* 1641277 */   // Label 22605: @1641277
     /* 1641277 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1641363), // Rule ID 4433 //
     /* 1641282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641328 */     // MIs[0] policy
     /* 1641328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641338 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11730:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641362 */     // GIR_Coverage, 4433,
     /* 1641362 */     GIR_EraseRootFromParent_Done,
     /* 1641363 */   // Label 22606: @1641363
     /* 1641363 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1641449), // Rule ID 4436 //
     /* 1641368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641414 */     // MIs[0] policy
     /* 1641414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641448 */     // GIR_Coverage, 4436,
     /* 1641448 */     GIR_EraseRootFromParent_Done,
     /* 1641449 */   // Label 22607: @1641449
     /* 1641449 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1641535), // Rule ID 4437 //
     /* 1641454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641500 */     // MIs[0] policy
     /* 1641500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641534 */     // GIR_Coverage, 4437,
     /* 1641534 */     GIR_EraseRootFromParent_Done,
     /* 1641535 */   // Label 22608: @1641535
     /* 1641535 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1641621), // Rule ID 4440 //
     /* 1641540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641586 */     // MIs[0] policy
     /* 1641586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641620 */     // GIR_Coverage, 4440,
     /* 1641620 */     GIR_EraseRootFromParent_Done,
     /* 1641621 */   // Label 22609: @1641621
     /* 1641621 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1641707), // Rule ID 4441 //
     /* 1641626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641672 */     // MIs[0] policy
     /* 1641672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641706 */     // GIR_Coverage, 4441,
     /* 1641706 */     GIR_EraseRootFromParent_Done,
     /* 1641707 */   // Label 22610: @1641707
     /* 1641707 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1641793), // Rule ID 4444 //
     /* 1641712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641758 */     // MIs[0] policy
     /* 1641758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641792 */     // GIR_Coverage, 4444,
     /* 1641792 */     GIR_EraseRootFromParent_Done,
     /* 1641793 */   // Label 22611: @1641793
     /* 1641793 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1641879), // Rule ID 4445 //
     /* 1641798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641844 */     // MIs[0] policy
     /* 1641844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641878 */     // GIR_Coverage, 4445,
     /* 1641878 */     GIR_EraseRootFromParent_Done,
     /* 1641879 */   // Label 22612: @1641879
     /* 1641879 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1641965), // Rule ID 4448 //
     /* 1641884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641930 */     // MIs[0] policy
     /* 1641930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641964 */     // GIR_Coverage, 4448,
     /* 1641964 */     GIR_EraseRootFromParent_Done,
     /* 1641965 */   // Label 22613: @1641965
     /* 1641965 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1642051), // Rule ID 4449 //
     /* 1641970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642016 */     // MIs[0] policy
     /* 1642016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1642029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642050 */     // GIR_Coverage, 4449,
     /* 1642050 */     GIR_EraseRootFromParent_Done,
     /* 1642051 */   // Label 22614: @1642051
     /* 1642051 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1642137), // Rule ID 4452 //
     /* 1642056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642102 */     // MIs[0] policy
     /* 1642102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642136 */     // GIR_Coverage, 4452,
     /* 1642136 */     GIR_EraseRootFromParent_Done,
     /* 1642137 */   // Label 22615: @1642137
     /* 1642137 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1642223), // Rule ID 4453 //
     /* 1642142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642188 */     // MIs[0] policy
     /* 1642188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642198 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11730:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642222 */     // GIR_Coverage, 4453,
     /* 1642222 */     GIR_EraseRootFromParent_Done,
     /* 1642223 */   // Label 22616: @1642223
     /* 1642223 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1642309), // Rule ID 4456 //
     /* 1642228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642274 */     // MIs[0] policy
     /* 1642274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642308 */     // GIR_Coverage, 4456,
     /* 1642308 */     GIR_EraseRootFromParent_Done,
     /* 1642309 */   // Label 22617: @1642309
     /* 1642309 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1642395), // Rule ID 4457 //
     /* 1642314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642360 */     // MIs[0] policy
     /* 1642360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642394 */     // GIR_Coverage, 4457,
     /* 1642394 */     GIR_EraseRootFromParent_Done,
     /* 1642395 */   // Label 22618: @1642395
     /* 1642395 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1642481), // Rule ID 4460 //
     /* 1642400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642446 */     // MIs[0] policy
     /* 1642446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642480 */     // GIR_Coverage, 4460,
     /* 1642480 */     GIR_EraseRootFromParent_Done,
     /* 1642481 */   // Label 22619: @1642481
     /* 1642481 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1642567), // Rule ID 4461 //
     /* 1642486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642532 */     // MIs[0] policy
     /* 1642532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642542 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642566 */     // GIR_Coverage, 4461,
     /* 1642566 */     GIR_EraseRootFromParent_Done,
     /* 1642567 */   // Label 22620: @1642567
     /* 1642567 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1642653), // Rule ID 4464 //
     /* 1642572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642618 */     // MIs[0] policy
     /* 1642618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642652 */     // GIR_Coverage, 4464,
     /* 1642652 */     GIR_EraseRootFromParent_Done,
     /* 1642653 */   // Label 22621: @1642653
     /* 1642653 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1642739), // Rule ID 4465 //
     /* 1642658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642704 */     // MIs[0] policy
     /* 1642704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642738 */     // GIR_Coverage, 4465,
     /* 1642738 */     GIR_EraseRootFromParent_Done,
     /* 1642739 */   // Label 22622: @1642739
     /* 1642739 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1642825), // Rule ID 4468 //
     /* 1642744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642790 */     // MIs[0] policy
     /* 1642790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642824 */     // GIR_Coverage, 4468,
     /* 1642824 */     GIR_EraseRootFromParent_Done,
     /* 1642825 */   // Label 22623: @1642825
     /* 1642825 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1642911), // Rule ID 4469 //
     /* 1642830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642876 */     // MIs[0] policy
     /* 1642876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11730:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642910 */     // GIR_Coverage, 4469,
     /* 1642910 */     GIR_EraseRootFromParent_Done,
     /* 1642911 */   // Label 22624: @1642911
     /* 1642911 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1642997), // Rule ID 4472 //
     /* 1642916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642962 */     // MIs[0] policy
     /* 1642962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642996 */     // GIR_Coverage, 4472,
     /* 1642996 */     GIR_EraseRootFromParent_Done,
     /* 1642997 */   // Label 22625: @1642997
     /* 1642997 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1643083), // Rule ID 4473 //
     /* 1643002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643048 */     // MIs[0] policy
     /* 1643048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11730:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1643061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643082 */     // GIR_Coverage, 4473,
     /* 1643082 */     GIR_EraseRootFromParent_Done,
     /* 1643083 */   // Label 22626: @1643083
     /* 1643083 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1643169), // Rule ID 4476 //
     /* 1643088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643134 */     // MIs[0] policy
     /* 1643134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1643147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643168 */     // GIR_Coverage, 4476,
     /* 1643168 */     GIR_EraseRootFromParent_Done,
     /* 1643169 */   // Label 22627: @1643169
     /* 1643169 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1643255), // Rule ID 4477 //
     /* 1643174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643220 */     // MIs[0] policy
     /* 1643220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643230 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11730:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1643233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643254 */     // GIR_Coverage, 4477,
     /* 1643254 */     GIR_EraseRootFromParent_Done,
     /* 1643255 */   // Label 22628: @1643255
     /* 1643255 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1643341), // Rule ID 4480 //
     /* 1643260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643306 */     // MIs[0] policy
     /* 1643306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1643319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643340 */     // GIR_Coverage, 4480,
     /* 1643340 */     GIR_EraseRootFromParent_Done,
     /* 1643341 */   // Label 22629: @1643341
     /* 1643341 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1643427), // Rule ID 4481 //
     /* 1643346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1643354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643392 */     // MIs[0] policy
     /* 1643392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643402 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11730:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1643405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643426 */     // GIR_Coverage, 4481,
     /* 1643426 */     GIR_EraseRootFromParent_Done,
     /* 1643427 */   // Label 22630: @1643427
     /* 1643427 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1643513), // Rule ID 4490 //
     /* 1643432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643478 */     // MIs[0] policy
     /* 1643478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643488 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643512 */     // GIR_Coverage, 4490,
     /* 1643512 */     GIR_EraseRootFromParent_Done,
     /* 1643513 */   // Label 22631: @1643513
     /* 1643513 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1643599), // Rule ID 4491 //
     /* 1643518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643564 */     // MIs[0] policy
     /* 1643564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643598 */     // GIR_Coverage, 4491,
     /* 1643598 */     GIR_EraseRootFromParent_Done,
     /* 1643599 */   // Label 22632: @1643599
     /* 1643599 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1643685), // Rule ID 4500 //
     /* 1643604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643650 */     // MIs[0] policy
     /* 1643650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643684 */     // GIR_Coverage, 4500,
     /* 1643684 */     GIR_EraseRootFromParent_Done,
     /* 1643685 */   // Label 22633: @1643685
     /* 1643685 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1643771), // Rule ID 4501 //
     /* 1643690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643736 */     // MIs[0] policy
     /* 1643736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643770 */     // GIR_Coverage, 4501,
     /* 1643770 */     GIR_EraseRootFromParent_Done,
     /* 1643771 */   // Label 22634: @1643771
     /* 1643771 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1643857), // Rule ID 4510 //
     /* 1643776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643822 */     // MIs[0] policy
     /* 1643822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643856 */     // GIR_Coverage, 4510,
     /* 1643856 */     GIR_EraseRootFromParent_Done,
     /* 1643857 */   // Label 22635: @1643857
     /* 1643857 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1643943), // Rule ID 4511 //
     /* 1643862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643908 */     // MIs[0] policy
     /* 1643908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643942 */     // GIR_Coverage, 4511,
     /* 1643942 */     GIR_EraseRootFromParent_Done,
     /* 1643943 */   // Label 22636: @1643943
     /* 1643943 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1644029), // Rule ID 4520 //
     /* 1643948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643994 */     // MIs[0] policy
     /* 1643994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644028 */     // GIR_Coverage, 4520,
     /* 1644028 */     GIR_EraseRootFromParent_Done,
     /* 1644029 */   // Label 22637: @1644029
     /* 1644029 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1644115), // Rule ID 4521 //
     /* 1644034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1644054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644080 */     // MIs[0] policy
     /* 1644080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644114 */     // GIR_Coverage, 4521,
     /* 1644114 */     GIR_EraseRootFromParent_Done,
     /* 1644115 */   // Label 22638: @1644115
     /* 1644115 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1644201), // Rule ID 4530 //
     /* 1644120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1644140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644166 */     // MIs[0] policy
     /* 1644166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644200 */     // GIR_Coverage, 4530,
     /* 1644200 */     GIR_EraseRootFromParent_Done,
     /* 1644201 */   // Label 22639: @1644201
     /* 1644201 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1644287), // Rule ID 4531 //
     /* 1644206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1644226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644252 */     // MIs[0] policy
     /* 1644252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644262 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644286 */     // GIR_Coverage, 4531,
     /* 1644286 */     GIR_EraseRootFromParent_Done,
     /* 1644287 */   // Label 22640: @1644287
     /* 1644287 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1644373), // Rule ID 4540 //
     /* 1644292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1644312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644338 */     // MIs[0] policy
     /* 1644338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644348 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644372 */     // GIR_Coverage, 4540,
     /* 1644372 */     GIR_EraseRootFromParent_Done,
     /* 1644373 */   // Label 22641: @1644373
     /* 1644373 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1644459), // Rule ID 4541 //
     /* 1644378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1644398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644424 */     // MIs[0] policy
     /* 1644424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644434 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644458 */     // GIR_Coverage, 4541,
     /* 1644458 */     GIR_EraseRootFromParent_Done,
     /* 1644459 */   // Label 22642: @1644459
     /* 1644459 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1644545), // Rule ID 4550 //
     /* 1644464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644510 */     // MIs[0] policy
     /* 1644510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644544 */     // GIR_Coverage, 4550,
     /* 1644544 */     GIR_EraseRootFromParent_Done,
     /* 1644545 */   // Label 22643: @1644545
     /* 1644545 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1644631), // Rule ID 4551 //
     /* 1644550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644596 */     // MIs[0] policy
     /* 1644596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644630 */     // GIR_Coverage, 4551,
     /* 1644630 */     GIR_EraseRootFromParent_Done,
     /* 1644631 */   // Label 22644: @1644631
     /* 1644631 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1644717), // Rule ID 4560 //
     /* 1644636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644682 */     // MIs[0] policy
     /* 1644682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644716 */     // GIR_Coverage, 4560,
     /* 1644716 */     GIR_EraseRootFromParent_Done,
     /* 1644717 */   // Label 22645: @1644717
     /* 1644717 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1644803), // Rule ID 4561 //
     /* 1644722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644768 */     // MIs[0] policy
     /* 1644768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644778 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644802 */     // GIR_Coverage, 4561,
     /* 1644802 */     GIR_EraseRootFromParent_Done,
     /* 1644803 */   // Label 22646: @1644803
     /* 1644803 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1644889), // Rule ID 4570 //
     /* 1644808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644854 */     // MIs[0] policy
     /* 1644854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644888 */     // GIR_Coverage, 4570,
     /* 1644888 */     GIR_EraseRootFromParent_Done,
     /* 1644889 */   // Label 22647: @1644889
     /* 1644889 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1644975), // Rule ID 4571 //
     /* 1644894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644940 */     // MIs[0] policy
     /* 1644940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644974 */     // GIR_Coverage, 4571,
     /* 1644974 */     GIR_EraseRootFromParent_Done,
     /* 1644975 */   // Label 22648: @1644975
     /* 1644975 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1645061), // Rule ID 4580 //
     /* 1644980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1645000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645026 */     // MIs[0] policy
     /* 1645026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645060 */     // GIR_Coverage, 4580,
     /* 1645060 */     GIR_EraseRootFromParent_Done,
     /* 1645061 */   // Label 22649: @1645061
     /* 1645061 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1645147), // Rule ID 4581 //
     /* 1645066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1645086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645112 */     // MIs[0] policy
     /* 1645112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645146 */     // GIR_Coverage, 4581,
     /* 1645146 */     GIR_EraseRootFromParent_Done,
     /* 1645147 */   // Label 22650: @1645147
     /* 1645147 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1645233), // Rule ID 4590 //
     /* 1645152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1645172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645198 */     // MIs[0] policy
     /* 1645198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645232 */     // GIR_Coverage, 4590,
     /* 1645232 */     GIR_EraseRootFromParent_Done,
     /* 1645233 */   // Label 22651: @1645233
     /* 1645233 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1645319), // Rule ID 4591 //
     /* 1645238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1645258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645284 */     // MIs[0] policy
     /* 1645284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645294 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645318 */     // GIR_Coverage, 4591,
     /* 1645318 */     GIR_EraseRootFromParent_Done,
     /* 1645319 */   // Label 22652: @1645319
     /* 1645319 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1645405), // Rule ID 4600 //
     /* 1645324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1645344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645370 */     // MIs[0] policy
     /* 1645370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645380 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645404 */     // GIR_Coverage, 4600,
     /* 1645404 */     GIR_EraseRootFromParent_Done,
     /* 1645405 */   // Label 22653: @1645405
     /* 1645405 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1645491), // Rule ID 4601 //
     /* 1645410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1645430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645456 */     // MIs[0] policy
     /* 1645456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645490 */     // GIR_Coverage, 4601,
     /* 1645490 */     GIR_EraseRootFromParent_Done,
     /* 1645491 */   // Label 22654: @1645491
     /* 1645491 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1645577), // Rule ID 4610 //
     /* 1645496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645542 */     // MIs[0] policy
     /* 1645542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645576 */     // GIR_Coverage, 4610,
     /* 1645576 */     GIR_EraseRootFromParent_Done,
     /* 1645577 */   // Label 22655: @1645577
     /* 1645577 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1645663), // Rule ID 4611 //
     /* 1645582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645628 */     // MIs[0] policy
     /* 1645628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645638 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645662 */     // GIR_Coverage, 4611,
     /* 1645662 */     GIR_EraseRootFromParent_Done,
     /* 1645663 */   // Label 22656: @1645663
     /* 1645663 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1645749), // Rule ID 4620 //
     /* 1645668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645714 */     // MIs[0] policy
     /* 1645714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645748 */     // GIR_Coverage, 4620,
     /* 1645748 */     GIR_EraseRootFromParent_Done,
     /* 1645749 */   // Label 22657: @1645749
     /* 1645749 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1645835), // Rule ID 4621 //
     /* 1645754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645800 */     // MIs[0] policy
     /* 1645800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645834 */     // GIR_Coverage, 4621,
     /* 1645834 */     GIR_EraseRootFromParent_Done,
     /* 1645835 */   // Label 22658: @1645835
     /* 1645835 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1645921), // Rule ID 4630 //
     /* 1645840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645886 */     // MIs[0] policy
     /* 1645886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645896 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645920 */     // GIR_Coverage, 4630,
     /* 1645920 */     GIR_EraseRootFromParent_Done,
     /* 1645921 */   // Label 22659: @1645921
     /* 1645921 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1646007), // Rule ID 4631 //
     /* 1645926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645972 */     // MIs[0] policy
     /* 1645972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646006 */     // GIR_Coverage, 4631,
     /* 1646006 */     GIR_EraseRootFromParent_Done,
     /* 1646007 */   // Label 22660: @1646007
     /* 1646007 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1646093), // Rule ID 4634 //
     /* 1646012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646058 */     // MIs[0] policy
     /* 1646058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1646071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646092 */     // GIR_Coverage, 4634,
     /* 1646092 */     GIR_EraseRootFromParent_Done,
     /* 1646093 */   // Label 22661: @1646093
     /* 1646093 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1646179), // Rule ID 4635 //
     /* 1646098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1646109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1646112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1646115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646144 */     // MIs[0] policy
     /* 1646144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1646157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646178 */     // GIR_Coverage, 4635,
     /* 1646178 */     GIR_EraseRootFromParent_Done,
     /* 1646179 */   // Label 22662: @1646179
     /* 1646179 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1646265), // Rule ID 4638 //
     /* 1646184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646230 */     // MIs[0] policy
     /* 1646230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646264 */     // GIR_Coverage, 4638,
     /* 1646264 */     GIR_EraseRootFromParent_Done,
     /* 1646265 */   // Label 22663: @1646265
     /* 1646265 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1646351), // Rule ID 4639 //
     /* 1646270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646316 */     // MIs[0] policy
     /* 1646316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646350 */     // GIR_Coverage, 4639,
     /* 1646350 */     GIR_EraseRootFromParent_Done,
     /* 1646351 */   // Label 22664: @1646351
     /* 1646351 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1646437), // Rule ID 4642 //
     /* 1646356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646402 */     // MIs[0] policy
     /* 1646402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646436 */     // GIR_Coverage, 4642,
     /* 1646436 */     GIR_EraseRootFromParent_Done,
     /* 1646437 */   // Label 22665: @1646437
     /* 1646437 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1646523), // Rule ID 4643 //
     /* 1646442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646488 */     // MIs[0] policy
     /* 1646488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11698:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646522 */     // GIR_Coverage, 4643,
     /* 1646522 */     GIR_EraseRootFromParent_Done,
     /* 1646523 */   // Label 22666: @1646523
     /* 1646523 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1646609), // Rule ID 4646 //
     /* 1646528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646574 */     // MIs[0] policy
     /* 1646574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646608 */     // GIR_Coverage, 4646,
     /* 1646608 */     GIR_EraseRootFromParent_Done,
     /* 1646609 */   // Label 22667: @1646609
     /* 1646609 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1646695), // Rule ID 4647 //
     /* 1646614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646660 */     // MIs[0] policy
     /* 1646660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646694 */     // GIR_Coverage, 4647,
     /* 1646694 */     GIR_EraseRootFromParent_Done,
     /* 1646695 */   // Label 22668: @1646695
     /* 1646695 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1646781), // Rule ID 4650 //
     /* 1646700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646746 */     // MIs[0] policy
     /* 1646746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646780 */     // GIR_Coverage, 4650,
     /* 1646780 */     GIR_EraseRootFromParent_Done,
     /* 1646781 */   // Label 22669: @1646781
     /* 1646781 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1646867), // Rule ID 4651 //
     /* 1646786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646832 */     // MIs[0] policy
     /* 1646832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646866 */     // GIR_Coverage, 4651,
     /* 1646866 */     GIR_EraseRootFromParent_Done,
     /* 1646867 */   // Label 22670: @1646867
     /* 1646867 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1646953), // Rule ID 4654 //
     /* 1646872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646918 */     // MIs[0] policy
     /* 1646918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646952 */     // GIR_Coverage, 4654,
     /* 1646952 */     GIR_EraseRootFromParent_Done,
     /* 1646953 */   // Label 22671: @1646953
     /* 1646953 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1647039), // Rule ID 4655 //
     /* 1646958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647004 */     // MIs[0] policy
     /* 1647004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647038 */     // GIR_Coverage, 4655,
     /* 1647038 */     GIR_EraseRootFromParent_Done,
     /* 1647039 */   // Label 22672: @1647039
     /* 1647039 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1647125), // Rule ID 4658 //
     /* 1647044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647090 */     // MIs[0] policy
     /* 1647090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1647103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647124 */     // GIR_Coverage, 4658,
     /* 1647124 */     GIR_EraseRootFromParent_Done,
     /* 1647125 */   // Label 22673: @1647125
     /* 1647125 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1647211), // Rule ID 4659 //
     /* 1647130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647176 */     // MIs[0] policy
     /* 1647176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1647189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647210 */     // GIR_Coverage, 4659,
     /* 1647210 */     GIR_EraseRootFromParent_Done,
     /* 1647211 */   // Label 22674: @1647211
     /* 1647211 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1647297), // Rule ID 4662 //
     /* 1647216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647262 */     // MIs[0] policy
     /* 1647262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647296 */     // GIR_Coverage, 4662,
     /* 1647296 */     GIR_EraseRootFromParent_Done,
     /* 1647297 */   // Label 22675: @1647297
     /* 1647297 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1647383), // Rule ID 4663 //
     /* 1647302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647348 */     // MIs[0] policy
     /* 1647348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11698:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647382 */     // GIR_Coverage, 4663,
     /* 1647382 */     GIR_EraseRootFromParent_Done,
     /* 1647383 */   // Label 22676: @1647383
     /* 1647383 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1647469), // Rule ID 4666 //
     /* 1647388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647434 */     // MIs[0] policy
     /* 1647434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647468 */     // GIR_Coverage, 4666,
     /* 1647468 */     GIR_EraseRootFromParent_Done,
     /* 1647469 */   // Label 22677: @1647469
     /* 1647469 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1647555), // Rule ID 4667 //
     /* 1647474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647520 */     // MIs[0] policy
     /* 1647520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647554 */     // GIR_Coverage, 4667,
     /* 1647554 */     GIR_EraseRootFromParent_Done,
     /* 1647555 */   // Label 22678: @1647555
     /* 1647555 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1647641), // Rule ID 4670 //
     /* 1647560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647606 */     // MIs[0] policy
     /* 1647606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647640 */     // GIR_Coverage, 4670,
     /* 1647640 */     GIR_EraseRootFromParent_Done,
     /* 1647641 */   // Label 22679: @1647641
     /* 1647641 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1647727), // Rule ID 4671 //
     /* 1647646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647692 */     // MIs[0] policy
     /* 1647692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647726 */     // GIR_Coverage, 4671,
     /* 1647726 */     GIR_EraseRootFromParent_Done,
     /* 1647727 */   // Label 22680: @1647727
     /* 1647727 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1647813), // Rule ID 4674 //
     /* 1647732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647778 */     // MIs[0] policy
     /* 1647778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647812 */     // GIR_Coverage, 4674,
     /* 1647812 */     GIR_EraseRootFromParent_Done,
     /* 1647813 */   // Label 22681: @1647813
     /* 1647813 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1647899), // Rule ID 4675 //
     /* 1647818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647864 */     // MIs[0] policy
     /* 1647864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647874 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647898 */     // GIR_Coverage, 4675,
     /* 1647898 */     GIR_EraseRootFromParent_Done,
     /* 1647899 */   // Label 22682: @1647899
     /* 1647899 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1647985), // Rule ID 4678 //
     /* 1647904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647950 */     // MIs[0] policy
     /* 1647950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647984 */     // GIR_Coverage, 4678,
     /* 1647984 */     GIR_EraseRootFromParent_Done,
     /* 1647985 */   // Label 22683: @1647985
     /* 1647985 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1648071), // Rule ID 4679 //
     /* 1647990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648036 */     // MIs[0] policy
     /* 1648036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11698:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1648049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648070 */     // GIR_Coverage, 4679,
     /* 1648070 */     GIR_EraseRootFromParent_Done,
     /* 1648071 */   // Label 22684: @1648071
     /* 1648071 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1648157), // Rule ID 4682 //
     /* 1648076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648122 */     // MIs[0] policy
     /* 1648122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1648135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648156 */     // GIR_Coverage, 4682,
     /* 1648156 */     GIR_EraseRootFromParent_Done,
     /* 1648157 */   // Label 22685: @1648157
     /* 1648157 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1648243), // Rule ID 4683 //
     /* 1648162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648208 */     // MIs[0] policy
     /* 1648208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11698:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1648221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648242 */     // GIR_Coverage, 4683,
     /* 1648242 */     GIR_EraseRootFromParent_Done,
     /* 1648243 */   // Label 22686: @1648243
     /* 1648243 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1648329), // Rule ID 4686 //
     /* 1648248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648294 */     // MIs[0] policy
     /* 1648294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1648307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648328 */     // GIR_Coverage, 4686,
     /* 1648328 */     GIR_EraseRootFromParent_Done,
     /* 1648329 */   // Label 22687: @1648329
     /* 1648329 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1648415), // Rule ID 4687 //
     /* 1648334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648380 */     // MIs[0] policy
     /* 1648380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11698:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1648393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648414 */     // GIR_Coverage, 4687,
     /* 1648414 */     GIR_EraseRootFromParent_Done,
     /* 1648415 */   // Label 22688: @1648415
     /* 1648415 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1648501), // Rule ID 4690 //
     /* 1648420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648466 */     // MIs[0] policy
     /* 1648466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648500 */     // GIR_Coverage, 4690,
     /* 1648500 */     GIR_EraseRootFromParent_Done,
     /* 1648501 */   // Label 22689: @1648501
     /* 1648501 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1648587), // Rule ID 4691 //
     /* 1648506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648552 */     // MIs[0] policy
     /* 1648552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11698:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648586 */     // GIR_Coverage, 4691,
     /* 1648586 */     GIR_EraseRootFromParent_Done,
     /* 1648587 */   // Label 22690: @1648587
     /* 1648587 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1648673), // Rule ID 4700 //
     /* 1648592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648638 */     // MIs[0] policy
     /* 1648638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648672 */     // GIR_Coverage, 4700,
     /* 1648672 */     GIR_EraseRootFromParent_Done,
     /* 1648673 */   // Label 22691: @1648673
     /* 1648673 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1648759), // Rule ID 4701 //
     /* 1648678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648724 */     // MIs[0] policy
     /* 1648724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648758 */     // GIR_Coverage, 4701,
     /* 1648758 */     GIR_EraseRootFromParent_Done,
     /* 1648759 */   // Label 22692: @1648759
     /* 1648759 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1648845), // Rule ID 4710 //
     /* 1648764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648810 */     // MIs[0] policy
     /* 1648810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648844 */     // GIR_Coverage, 4710,
     /* 1648844 */     GIR_EraseRootFromParent_Done,
     /* 1648845 */   // Label 22693: @1648845
     /* 1648845 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1648931), // Rule ID 4711 //
     /* 1648850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648896 */     // MIs[0] policy
     /* 1648896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648930 */     // GIR_Coverage, 4711,
     /* 1648930 */     GIR_EraseRootFromParent_Done,
     /* 1648931 */   // Label 22694: @1648931
     /* 1648931 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1649017), // Rule ID 4720 //
     /* 1648936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648982 */     // MIs[0] policy
     /* 1648982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1648995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649016 */     // GIR_Coverage, 4720,
     /* 1649016 */     GIR_EraseRootFromParent_Done,
     /* 1649017 */   // Label 22695: @1649017
     /* 1649017 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1649103), // Rule ID 4721 //
     /* 1649022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1649033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1649036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1649039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1649042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649068 */     // MIs[0] policy
     /* 1649068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649102 */     // GIR_Coverage, 4721,
     /* 1649102 */     GIR_EraseRootFromParent_Done,
     /* 1649103 */   // Label 22696: @1649103
     /* 1649103 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1649189), // Rule ID 4730 //
     /* 1649108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1649128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649154 */     // MIs[0] policy
     /* 1649154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649188 */     // GIR_Coverage, 4730,
     /* 1649188 */     GIR_EraseRootFromParent_Done,
     /* 1649189 */   // Label 22697: @1649189
     /* 1649189 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1649275), // Rule ID 4731 //
     /* 1649194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1649214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649240 */     // MIs[0] policy
     /* 1649240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649274 */     // GIR_Coverage, 4731,
     /* 1649274 */     GIR_EraseRootFromParent_Done,
     /* 1649275 */   // Label 22698: @1649275
     /* 1649275 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1649361), // Rule ID 4740 //
     /* 1649280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1649300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649326 */     // MIs[0] policy
     /* 1649326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649360 */     // GIR_Coverage, 4740,
     /* 1649360 */     GIR_EraseRootFromParent_Done,
     /* 1649361 */   // Label 22699: @1649361
     /* 1649361 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1649447), // Rule ID 4741 //
     /* 1649366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1649386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649412 */     // MIs[0] policy
     /* 1649412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649446 */     // GIR_Coverage, 4741,
     /* 1649446 */     GIR_EraseRootFromParent_Done,
     /* 1649447 */   // Label 22700: @1649447
     /* 1649447 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1649533), // Rule ID 4750 //
     /* 1649452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649498 */     // MIs[0] policy
     /* 1649498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649508 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649532 */     // GIR_Coverage, 4750,
     /* 1649532 */     GIR_EraseRootFromParent_Done,
     /* 1649533 */   // Label 22701: @1649533
     /* 1649533 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1649619), // Rule ID 4751 //
     /* 1649538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649584 */     // MIs[0] policy
     /* 1649584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649618 */     // GIR_Coverage, 4751,
     /* 1649618 */     GIR_EraseRootFromParent_Done,
     /* 1649619 */   // Label 22702: @1649619
     /* 1649619 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1649705), // Rule ID 4760 //
     /* 1649624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649670 */     // MIs[0] policy
     /* 1649670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649704 */     // GIR_Coverage, 4760,
     /* 1649704 */     GIR_EraseRootFromParent_Done,
     /* 1649705 */   // Label 22703: @1649705
     /* 1649705 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1649791), // Rule ID 4761 //
     /* 1649710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649756 */     // MIs[0] policy
     /* 1649756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649790 */     // GIR_Coverage, 4761,
     /* 1649790 */     GIR_EraseRootFromParent_Done,
     /* 1649791 */   // Label 22704: @1649791
     /* 1649791 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1649877), // Rule ID 4770 //
     /* 1649796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649842 */     // MIs[0] policy
     /* 1649842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649876 */     // GIR_Coverage, 4770,
     /* 1649876 */     GIR_EraseRootFromParent_Done,
     /* 1649877 */   // Label 22705: @1649877
     /* 1649877 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1649963), // Rule ID 4771 //
     /* 1649882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649928 */     // MIs[0] policy
     /* 1649928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649962 */     // GIR_Coverage, 4771,
     /* 1649962 */     GIR_EraseRootFromParent_Done,
     /* 1649963 */   // Label 22706: @1649963
     /* 1649963 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1650049), // Rule ID 4780 //
     /* 1649968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650014 */     // MIs[0] policy
     /* 1650014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650048 */     // GIR_Coverage, 4780,
     /* 1650048 */     GIR_EraseRootFromParent_Done,
     /* 1650049 */   // Label 22707: @1650049
     /* 1650049 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1650135), // Rule ID 4781 //
     /* 1650054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1650065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1650068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1650071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1650074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650100 */     // MIs[0] policy
     /* 1650100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650134 */     // GIR_Coverage, 4781,
     /* 1650134 */     GIR_EraseRootFromParent_Done,
     /* 1650135 */   // Label 22708: @1650135
     /* 1650135 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1650221), // Rule ID 4790 //
     /* 1650140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1650160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650186 */     // MIs[0] policy
     /* 1650186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650220 */     // GIR_Coverage, 4790,
     /* 1650220 */     GIR_EraseRootFromParent_Done,
     /* 1650221 */   // Label 22709: @1650221
     /* 1650221 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1650307), // Rule ID 4791 //
     /* 1650226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1650246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650272 */     // MIs[0] policy
     /* 1650272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650306 */     // GIR_Coverage, 4791,
     /* 1650306 */     GIR_EraseRootFromParent_Done,
     /* 1650307 */   // Label 22710: @1650307
     /* 1650307 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1650393), // Rule ID 4800 //
     /* 1650312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1650332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650358 */     // MIs[0] policy
     /* 1650358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650392 */     // GIR_Coverage, 4800,
     /* 1650392 */     GIR_EraseRootFromParent_Done,
     /* 1650393 */   // Label 22711: @1650393
     /* 1650393 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1650479), // Rule ID 4801 //
     /* 1650398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1650418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650444 */     // MIs[0] policy
     /* 1650444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650454 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650478 */     // GIR_Coverage, 4801,
     /* 1650478 */     GIR_EraseRootFromParent_Done,
     /* 1650479 */   // Label 22712: @1650479
     /* 1650479 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1650565), // Rule ID 4810 //
     /* 1650484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650530 */     // MIs[0] policy
     /* 1650530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650564 */     // GIR_Coverage, 4810,
     /* 1650564 */     GIR_EraseRootFromParent_Done,
     /* 1650565 */   // Label 22713: @1650565
     /* 1650565 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1650651), // Rule ID 4811 //
     /* 1650570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650616 */     // MIs[0] policy
     /* 1650616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650650 */     // GIR_Coverage, 4811,
     /* 1650650 */     GIR_EraseRootFromParent_Done,
     /* 1650651 */   // Label 22714: @1650651
     /* 1650651 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1650737), // Rule ID 4820 //
     /* 1650656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650702 */     // MIs[0] policy
     /* 1650702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650736 */     // GIR_Coverage, 4820,
     /* 1650736 */     GIR_EraseRootFromParent_Done,
     /* 1650737 */   // Label 22715: @1650737
     /* 1650737 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1650823), // Rule ID 4821 //
     /* 1650742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650788 */     // MIs[0] policy
     /* 1650788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650822 */     // GIR_Coverage, 4821,
     /* 1650822 */     GIR_EraseRootFromParent_Done,
     /* 1650823 */   // Label 22716: @1650823
     /* 1650823 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1650909), // Rule ID 4830 //
     /* 1650828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650874 */     // MIs[0] policy
     /* 1650874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650908 */     // GIR_Coverage, 4830,
     /* 1650908 */     GIR_EraseRootFromParent_Done,
     /* 1650909 */   // Label 22717: @1650909
     /* 1650909 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1650995), // Rule ID 4831 //
     /* 1650914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650960 */     // MIs[0] policy
     /* 1650960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650994 */     // GIR_Coverage, 4831,
     /* 1650994 */     GIR_EraseRootFromParent_Done,
     /* 1650995 */   // Label 22718: @1650995
     /* 1650995 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1651081), // Rule ID 4840 //
     /* 1651000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1651003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1651020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651046 */     // MIs[0] policy
     /* 1651046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1651059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651080 */     // GIR_Coverage, 4840,
     /* 1651080 */     GIR_EraseRootFromParent_Done,
     /* 1651081 */   // Label 22719: @1651081
     /* 1651081 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1651167), // Rule ID 4841 //
     /* 1651086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1651089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1651097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1651100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1651103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1651106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651132 */     // MIs[0] policy
     /* 1651132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1651145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651166 */     // GIR_Coverage, 4841,
     /* 1651166 */     GIR_EraseRootFromParent_Done,
     /* 1651167 */   // Label 22720: @1651167
     /* 1651167 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1651253), // Rule ID 4844 //
     /* 1651172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651218 */     // MIs[0] policy
     /* 1651218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1651231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651252 */     // GIR_Coverage, 4844,
     /* 1651252 */     GIR_EraseRootFromParent_Done,
     /* 1651253 */   // Label 22721: @1651253
     /* 1651253 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1651339), // Rule ID 4845 //
     /* 1651258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651304 */     // MIs[0] policy
     /* 1651304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1651317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651338 */     // GIR_Coverage, 4845,
     /* 1651338 */     GIR_EraseRootFromParent_Done,
     /* 1651339 */   // Label 22722: @1651339
     /* 1651339 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1651425), // Rule ID 4848 //
     /* 1651344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651390 */     // MIs[0] policy
     /* 1651390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651424 */     // GIR_Coverage, 4848,
     /* 1651424 */     GIR_EraseRootFromParent_Done,
     /* 1651425 */   // Label 22723: @1651425
     /* 1651425 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1651511), // Rule ID 4849 //
     /* 1651430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651476 */     // MIs[0] policy
     /* 1651476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651510 */     // GIR_Coverage, 4849,
     /* 1651510 */     GIR_EraseRootFromParent_Done,
     /* 1651511 */   // Label 22724: @1651511
     /* 1651511 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1651597), // Rule ID 4852 //
     /* 1651516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651562 */     // MIs[0] policy
     /* 1651562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651596 */     // GIR_Coverage, 4852,
     /* 1651596 */     GIR_EraseRootFromParent_Done,
     /* 1651597 */   // Label 22725: @1651597
     /* 1651597 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1651683), // Rule ID 4853 //
     /* 1651602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651648 */     // MIs[0] policy
     /* 1651648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11726:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651682 */     // GIR_Coverage, 4853,
     /* 1651682 */     GIR_EraseRootFromParent_Done,
     /* 1651683 */   // Label 22726: @1651683
     /* 1651683 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1651769), // Rule ID 4856 //
     /* 1651688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651734 */     // MIs[0] policy
     /* 1651734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651768 */     // GIR_Coverage, 4856,
     /* 1651768 */     GIR_EraseRootFromParent_Done,
     /* 1651769 */   // Label 22727: @1651769
     /* 1651769 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1651855), // Rule ID 4857 //
     /* 1651774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651820 */     // MIs[0] policy
     /* 1651820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651854 */     // GIR_Coverage, 4857,
     /* 1651854 */     GIR_EraseRootFromParent_Done,
     /* 1651855 */   // Label 22728: @1651855
     /* 1651855 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1651941), // Rule ID 4860 //
     /* 1651860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651906 */     // MIs[0] policy
     /* 1651906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651940 */     // GIR_Coverage, 4860,
     /* 1651940 */     GIR_EraseRootFromParent_Done,
     /* 1651941 */   // Label 22729: @1651941
     /* 1651941 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1652027), // Rule ID 4861 //
     /* 1651946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651992 */     // MIs[0] policy
     /* 1651992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652026 */     // GIR_Coverage, 4861,
     /* 1652026 */     GIR_EraseRootFromParent_Done,
     /* 1652027 */   // Label 22730: @1652027
     /* 1652027 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1652113), // Rule ID 4864 //
     /* 1652032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652078 */     // MIs[0] policy
     /* 1652078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652088 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652112 */     // GIR_Coverage, 4864,
     /* 1652112 */     GIR_EraseRootFromParent_Done,
     /* 1652113 */   // Label 22731: @1652113
     /* 1652113 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1652199), // Rule ID 4865 //
     /* 1652118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1652129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1652132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1652135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652164 */     // MIs[0] policy
     /* 1652164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652198 */     // GIR_Coverage, 4865,
     /* 1652198 */     GIR_EraseRootFromParent_Done,
     /* 1652199 */   // Label 22732: @1652199
     /* 1652199 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1652285), // Rule ID 4868 //
     /* 1652204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1652215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1652218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1652221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652250 */     // MIs[0] policy
     /* 1652250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1652263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652284 */     // GIR_Coverage, 4868,
     /* 1652284 */     GIR_EraseRootFromParent_Done,
     /* 1652285 */   // Label 22733: @1652285
     /* 1652285 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1652371), // Rule ID 4869 //
     /* 1652290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1652301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1652304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1652307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652336 */     // MIs[0] policy
     /* 1652336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1652349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652370 */     // GIR_Coverage, 4869,
     /* 1652370 */     GIR_EraseRootFromParent_Done,
     /* 1652371 */   // Label 22734: @1652371
     /* 1652371 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1652457), // Rule ID 4872 //
     /* 1652376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652422 */     // MIs[0] policy
     /* 1652422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652456 */     // GIR_Coverage, 4872,
     /* 1652456 */     GIR_EraseRootFromParent_Done,
     /* 1652457 */   // Label 22735: @1652457
     /* 1652457 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1652543), // Rule ID 4873 //
     /* 1652462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652508 */     // MIs[0] policy
     /* 1652508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11726:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652542 */     // GIR_Coverage, 4873,
     /* 1652542 */     GIR_EraseRootFromParent_Done,
     /* 1652543 */   // Label 22736: @1652543
     /* 1652543 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1652629), // Rule ID 4876 //
     /* 1652548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652594 */     // MIs[0] policy
     /* 1652594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652628 */     // GIR_Coverage, 4876,
     /* 1652628 */     GIR_EraseRootFromParent_Done,
     /* 1652629 */   // Label 22737: @1652629
     /* 1652629 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1652715), // Rule ID 4877 //
     /* 1652634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652680 */     // MIs[0] policy
     /* 1652680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652714 */     // GIR_Coverage, 4877,
     /* 1652714 */     GIR_EraseRootFromParent_Done,
     /* 1652715 */   // Label 22738: @1652715
     /* 1652715 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1652801), // Rule ID 4880 //
     /* 1652720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652766 */     // MIs[0] policy
     /* 1652766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652800 */     // GIR_Coverage, 4880,
     /* 1652800 */     GIR_EraseRootFromParent_Done,
     /* 1652801 */   // Label 22739: @1652801
     /* 1652801 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1652887), // Rule ID 4881 //
     /* 1652806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652852 */     // MIs[0] policy
     /* 1652852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652886 */     // GIR_Coverage, 4881,
     /* 1652886 */     GIR_EraseRootFromParent_Done,
     /* 1652887 */   // Label 22740: @1652887
     /* 1652887 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1652973), // Rule ID 4884 //
     /* 1652892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652938 */     // MIs[0] policy
     /* 1652938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652972 */     // GIR_Coverage, 4884,
     /* 1652972 */     GIR_EraseRootFromParent_Done,
     /* 1652973 */   // Label 22741: @1652973
     /* 1652973 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1653059), // Rule ID 4885 //
     /* 1652978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653024 */     // MIs[0] policy
     /* 1653024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653058 */     // GIR_Coverage, 4885,
     /* 1653058 */     GIR_EraseRootFromParent_Done,
     /* 1653059 */   // Label 22742: @1653059
     /* 1653059 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1653145), // Rule ID 4888 //
     /* 1653064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653110 */     // MIs[0] policy
     /* 1653110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1653123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653144 */     // GIR_Coverage, 4888,
     /* 1653144 */     GIR_EraseRootFromParent_Done,
     /* 1653145 */   // Label 22743: @1653145
     /* 1653145 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1653231), // Rule ID 4889 //
     /* 1653150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1653161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1653164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1653167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653196 */     // MIs[0] policy
     /* 1653196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11726:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1653209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653230 */     // GIR_Coverage, 4889,
     /* 1653230 */     GIR_EraseRootFromParent_Done,
     /* 1653231 */   // Label 22744: @1653231
     /* 1653231 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1653317), // Rule ID 4892 //
     /* 1653236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653282 */     // MIs[0] policy
     /* 1653282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1653295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653316 */     // GIR_Coverage, 4892,
     /* 1653316 */     GIR_EraseRootFromParent_Done,
     /* 1653317 */   // Label 22745: @1653317
     /* 1653317 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1653403), // Rule ID 4893 //
     /* 1653322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653368 */     // MIs[0] policy
     /* 1653368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11726:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1653381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653402 */     // GIR_Coverage, 4893,
     /* 1653402 */     GIR_EraseRootFromParent_Done,
     /* 1653403 */   // Label 22746: @1653403
     /* 1653403 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1653489), // Rule ID 4896 //
     /* 1653408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653454 */     // MIs[0] policy
     /* 1653454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653488 */     // GIR_Coverage, 4896,
     /* 1653488 */     GIR_EraseRootFromParent_Done,
     /* 1653489 */   // Label 22747: @1653489
     /* 1653489 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1653575), // Rule ID 4897 //
     /* 1653494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653540 */     // MIs[0] policy
     /* 1653540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11726:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653574 */     // GIR_Coverage, 4897,
     /* 1653574 */     GIR_EraseRootFromParent_Done,
     /* 1653575 */   // Label 22748: @1653575
     /* 1653575 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1653661), // Rule ID 4900 //
     /* 1653580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653626 */     // MIs[0] policy
     /* 1653626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653660 */     // GIR_Coverage, 4900,
     /* 1653660 */     GIR_EraseRootFromParent_Done,
     /* 1653661 */   // Label 22749: @1653661
     /* 1653661 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1653747), // Rule ID 4901 //
     /* 1653666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653712 */     // MIs[0] policy
     /* 1653712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11726:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653746 */     // GIR_Coverage, 4901,
     /* 1653746 */     GIR_EraseRootFromParent_Done,
     /* 1653747 */   // Label 22750: @1653747
     /* 1653747 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1653833), // Rule ID 5778 //
     /* 1653752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653798 */     // MIs[0] policy
     /* 1653798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653808 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653832 */     // GIR_Coverage, 5778,
     /* 1653832 */     GIR_EraseRootFromParent_Done,
     /* 1653833 */   // Label 22751: @1653833
     /* 1653833 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1653919), // Rule ID 5779 //
     /* 1653838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653884 */     // MIs[0] policy
     /* 1653884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653918 */     // GIR_Coverage, 5779,
     /* 1653918 */     GIR_EraseRootFromParent_Done,
     /* 1653919 */   // Label 22752: @1653919
     /* 1653919 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1654005), // Rule ID 5782 //
     /* 1653924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653970 */     // MIs[0] policy
     /* 1653970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654004 */     // GIR_Coverage, 5782,
     /* 1654004 */     GIR_EraseRootFromParent_Done,
     /* 1654005 */   // Label 22753: @1654005
     /* 1654005 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1654091), // Rule ID 5783 //
     /* 1654010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1654021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1654024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1654027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1654030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654056 */     // MIs[0] policy
     /* 1654056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654090 */     // GIR_Coverage, 5783,
     /* 1654090 */     GIR_EraseRootFromParent_Done,
     /* 1654091 */   // Label 22754: @1654091
     /* 1654091 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1654177), // Rule ID 5786 //
     /* 1654096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654142 */     // MIs[0] policy
     /* 1654142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654176 */     // GIR_Coverage, 5786,
     /* 1654176 */     GIR_EraseRootFromParent_Done,
     /* 1654177 */   // Label 22755: @1654177
     /* 1654177 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1654263), // Rule ID 5787 //
     /* 1654182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654228 */     // MIs[0] policy
     /* 1654228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654238 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654262 */     // GIR_Coverage, 5787,
     /* 1654262 */     GIR_EraseRootFromParent_Done,
     /* 1654263 */   // Label 22756: @1654263
     /* 1654263 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1654349), // Rule ID 5790 //
     /* 1654268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654314 */     // MIs[0] policy
     /* 1654314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654348 */     // GIR_Coverage, 5790,
     /* 1654348 */     GIR_EraseRootFromParent_Done,
     /* 1654349 */   // Label 22757: @1654349
     /* 1654349 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1654435), // Rule ID 5791 //
     /* 1654354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654400 */     // MIs[0] policy
     /* 1654400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1654413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654434 */     // GIR_Coverage, 5791,
     /* 1654434 */     GIR_EraseRootFromParent_Done,
     /* 1654435 */   // Label 22758: @1654435
     /* 1654435 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1654521), // Rule ID 5794 //
     /* 1654440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654486 */     // MIs[0] policy
     /* 1654486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654520 */     // GIR_Coverage, 5794,
     /* 1654520 */     GIR_EraseRootFromParent_Done,
     /* 1654521 */   // Label 22759: @1654521
     /* 1654521 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1654607), // Rule ID 5795 //
     /* 1654526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654572 */     // MIs[0] policy
     /* 1654572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654606 */     // GIR_Coverage, 5795,
     /* 1654606 */     GIR_EraseRootFromParent_Done,
     /* 1654607 */   // Label 22760: @1654607
     /* 1654607 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1654693), // Rule ID 5798 //
     /* 1654612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654658 */     // MIs[0] policy
     /* 1654658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654692 */     // GIR_Coverage, 5798,
     /* 1654692 */     GIR_EraseRootFromParent_Done,
     /* 1654693 */   // Label 22761: @1654693
     /* 1654693 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1654779), // Rule ID 5799 //
     /* 1654698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654744 */     // MIs[0] policy
     /* 1654744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654778 */     // GIR_Coverage, 5799,
     /* 1654778 */     GIR_EraseRootFromParent_Done,
     /* 1654779 */   // Label 22762: @1654779
     /* 1654779 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1654865), // Rule ID 5802 //
     /* 1654784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654830 */     // MIs[0] policy
     /* 1654830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654864 */     // GIR_Coverage, 5802,
     /* 1654864 */     GIR_EraseRootFromParent_Done,
     /* 1654865 */   // Label 22763: @1654865
     /* 1654865 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1654951), // Rule ID 5803 //
     /* 1654870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654916 */     // MIs[0] policy
     /* 1654916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654950 */     // GIR_Coverage, 5803,
     /* 1654950 */     GIR_EraseRootFromParent_Done,
     /* 1654951 */   // Label 22764: @1654951
     /* 1654951 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1655037), // Rule ID 5806 //
     /* 1654956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655002 */     // MIs[0] policy
     /* 1655002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655036 */     // GIR_Coverage, 5806,
     /* 1655036 */     GIR_EraseRootFromParent_Done,
     /* 1655037 */   // Label 22765: @1655037
     /* 1655037 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1655123), // Rule ID 5807 //
     /* 1655042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1655053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1655056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1655059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1655062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655088 */     // MIs[0] policy
     /* 1655088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655122 */     // GIR_Coverage, 5807,
     /* 1655122 */     GIR_EraseRootFromParent_Done,
     /* 1655123 */   // Label 22766: @1655123
     /* 1655123 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1655209), // Rule ID 5810 //
     /* 1655128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655174 */     // MIs[0] policy
     /* 1655174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655208 */     // GIR_Coverage, 5810,
     /* 1655208 */     GIR_EraseRootFromParent_Done,
     /* 1655209 */   // Label 22767: @1655209
     /* 1655209 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1655295), // Rule ID 5811 //
     /* 1655214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655260 */     // MIs[0] policy
     /* 1655260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655294 */     // GIR_Coverage, 5811,
     /* 1655294 */     GIR_EraseRootFromParent_Done,
     /* 1655295 */   // Label 22768: @1655295
     /* 1655295 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1655381), // Rule ID 5814 //
     /* 1655300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1655303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655346 */     // MIs[0] policy
     /* 1655346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655380 */     // GIR_Coverage, 5814,
     /* 1655380 */     GIR_EraseRootFromParent_Done,
     /* 1655381 */   // Label 22769: @1655381
     /* 1655381 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1655467), // Rule ID 5815 //
     /* 1655386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1655389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655432 */     // MIs[0] policy
     /* 1655432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1655445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655466 */     // GIR_Coverage, 5815,
     /* 1655466 */     GIR_EraseRootFromParent_Done,
     /* 1655467 */   // Label 22770: @1655467
     /* 1655467 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1655553), // Rule ID 5818 //
     /* 1655472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655518 */     // MIs[0] policy
     /* 1655518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655552 */     // GIR_Coverage, 5818,
     /* 1655552 */     GIR_EraseRootFromParent_Done,
     /* 1655553 */   // Label 22771: @1655553
     /* 1655553 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1655639), // Rule ID 5819 //
     /* 1655558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655604 */     // MIs[0] policy
     /* 1655604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655638 */     // GIR_Coverage, 5819,
     /* 1655638 */     GIR_EraseRootFromParent_Done,
     /* 1655639 */   // Label 22772: @1655639
     /* 1655639 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1655725), // Rule ID 5822 //
     /* 1655644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655690 */     // MIs[0] policy
     /* 1655690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655700 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655724 */     // GIR_Coverage, 5822,
     /* 1655724 */     GIR_EraseRootFromParent_Done,
     /* 1655725 */   // Label 22773: @1655725
     /* 1655725 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1655811), // Rule ID 5823 //
     /* 1655730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655776 */     // MIs[0] policy
     /* 1655776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655810 */     // GIR_Coverage, 5823,
     /* 1655810 */     GIR_EraseRootFromParent_Done,
     /* 1655811 */   // Label 22774: @1655811
     /* 1655811 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1655897), // Rule ID 5826 //
     /* 1655816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655862 */     // MIs[0] policy
     /* 1655862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655896 */     // GIR_Coverage, 5826,
     /* 1655896 */     GIR_EraseRootFromParent_Done,
     /* 1655897 */   // Label 22775: @1655897
     /* 1655897 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1655983), // Rule ID 5827 //
     /* 1655902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655948 */     // MIs[0] policy
     /* 1655948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655958 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655982 */     // GIR_Coverage, 5827,
     /* 1655982 */     GIR_EraseRootFromParent_Done,
     /* 1655983 */   // Label 22776: @1655983
     /* 1655983 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1656069), // Rule ID 5830 //
     /* 1655988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656034 */     // MIs[0] policy
     /* 1656034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656068 */     // GIR_Coverage, 5830,
     /* 1656068 */     GIR_EraseRootFromParent_Done,
     /* 1656069 */   // Label 22777: @1656069
     /* 1656069 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1656155), // Rule ID 5831 //
     /* 1656074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1656085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656120 */     // MIs[0] policy
     /* 1656120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656154 */     // GIR_Coverage, 5831,
     /* 1656154 */     GIR_EraseRootFromParent_Done,
     /* 1656155 */   // Label 22778: @1656155
     /* 1656155 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1656241), // Rule ID 5834 //
     /* 1656160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656206 */     // MIs[0] policy
     /* 1656206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656240 */     // GIR_Coverage, 5834,
     /* 1656240 */     GIR_EraseRootFromParent_Done,
     /* 1656241 */   // Label 22779: @1656241
     /* 1656241 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1656327), // Rule ID 5835 //
     /* 1656246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656292 */     // MIs[0] policy
     /* 1656292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656326 */     // GIR_Coverage, 5835,
     /* 1656326 */     GIR_EraseRootFromParent_Done,
     /* 1656327 */   // Label 22780: @1656327
     /* 1656327 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1656413), // Rule ID 5838 //
     /* 1656332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656378 */     // MIs[0] policy
     /* 1656378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656412 */     // GIR_Coverage, 5838,
     /* 1656412 */     GIR_EraseRootFromParent_Done,
     /* 1656413 */   // Label 22781: @1656413
     /* 1656413 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1656499), // Rule ID 5839 //
     /* 1656418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656464 */     // MIs[0] policy
     /* 1656464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656498 */     // GIR_Coverage, 5839,
     /* 1656498 */     GIR_EraseRootFromParent_Done,
     /* 1656499 */   // Label 22782: @1656499
     /* 1656499 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1656585), // Rule ID 5842 //
     /* 1656504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656550 */     // MIs[0] policy
     /* 1656550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656584 */     // GIR_Coverage, 5842,
     /* 1656584 */     GIR_EraseRootFromParent_Done,
     /* 1656585 */   // Label 22783: @1656585
     /* 1656585 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1656671), // Rule ID 5843 //
     /* 1656590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656636 */     // MIs[0] policy
     /* 1656636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656670 */     // GIR_Coverage, 5843,
     /* 1656670 */     GIR_EraseRootFromParent_Done,
     /* 1656671 */   // Label 22784: @1656671
     /* 1656671 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1656757), // Rule ID 5846 //
     /* 1656676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656722 */     // MIs[0] policy
     /* 1656722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656756 */     // GIR_Coverage, 5846,
     /* 1656756 */     GIR_EraseRootFromParent_Done,
     /* 1656757 */   // Label 22785: @1656757
     /* 1656757 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1656843), // Rule ID 5847 //
     /* 1656762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656808 */     // MIs[0] policy
     /* 1656808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656842 */     // GIR_Coverage, 5847,
     /* 1656842 */     GIR_EraseRootFromParent_Done,
     /* 1656843 */   // Label 22786: @1656843
     /* 1656843 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1656929), // Rule ID 5850 //
     /* 1656848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656894 */     // MIs[0] policy
     /* 1656894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656928 */     // GIR_Coverage, 5850,
     /* 1656928 */     GIR_EraseRootFromParent_Done,
     /* 1656929 */   // Label 22787: @1656929
     /* 1656929 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1657015), // Rule ID 5851 //
     /* 1656934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656980 */     // MIs[0] policy
     /* 1656980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657014 */     // GIR_Coverage, 5851,
     /* 1657014 */     GIR_EraseRootFromParent_Done,
     /* 1657015 */   // Label 22788: @1657015
     /* 1657015 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1657101), // Rule ID 5854 //
     /* 1657020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657066 */     // MIs[0] policy
     /* 1657066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1657079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657100 */     // GIR_Coverage, 5854,
     /* 1657100 */     GIR_EraseRootFromParent_Done,
     /* 1657101 */   // Label 22789: @1657101
     /* 1657101 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1657187), // Rule ID 5855 //
     /* 1657106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657152 */     // MIs[0] policy
     /* 1657152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1657165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657186 */     // GIR_Coverage, 5855,
     /* 1657186 */     GIR_EraseRootFromParent_Done,
     /* 1657187 */   // Label 22790: @1657187
     /* 1657187 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1657273), // Rule ID 5858 //
     /* 1657192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657238 */     // MIs[0] policy
     /* 1657238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1657251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657272 */     // GIR_Coverage, 5858,
     /* 1657272 */     GIR_EraseRootFromParent_Done,
     /* 1657273 */   // Label 22791: @1657273
     /* 1657273 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1657359), // Rule ID 5859 //
     /* 1657278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657324 */     // MIs[0] policy
     /* 1657324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1657337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657358 */     // GIR_Coverage, 5859,
     /* 1657358 */     GIR_EraseRootFromParent_Done,
     /* 1657359 */   // Label 22792: @1657359
     /* 1657359 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1657445), // Rule ID 5862 //
     /* 1657364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657410 */     // MIs[0] policy
     /* 1657410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657420 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657444 */     // GIR_Coverage, 5862,
     /* 1657444 */     GIR_EraseRootFromParent_Done,
     /* 1657445 */   // Label 22793: @1657445
     /* 1657445 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1657531), // Rule ID 5863 //
     /* 1657450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657496 */     // MIs[0] policy
     /* 1657496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657530 */     // GIR_Coverage, 5863,
     /* 1657530 */     GIR_EraseRootFromParent_Done,
     /* 1657531 */   // Label 22794: @1657531
     /* 1657531 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1657617), // Rule ID 5866 //
     /* 1657536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657582 */     // MIs[0] policy
     /* 1657582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657592 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657616 */     // GIR_Coverage, 5866,
     /* 1657616 */     GIR_EraseRootFromParent_Done,
     /* 1657617 */   // Label 22795: @1657617
     /* 1657617 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1657703), // Rule ID 5867 //
     /* 1657622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657668 */     // MIs[0] policy
     /* 1657668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657702 */     // GIR_Coverage, 5867,
     /* 1657702 */     GIR_EraseRootFromParent_Done,
     /* 1657703 */   // Label 22796: @1657703
     /* 1657703 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1657789), // Rule ID 5870 //
     /* 1657708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657754 */     // MIs[0] policy
     /* 1657754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657788 */     // GIR_Coverage, 5870,
     /* 1657788 */     GIR_EraseRootFromParent_Done,
     /* 1657789 */   // Label 22797: @1657789
     /* 1657789 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1657875), // Rule ID 5871 //
     /* 1657794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657840 */     // MIs[0] policy
     /* 1657840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657874 */     // GIR_Coverage, 5871,
     /* 1657874 */     GIR_EraseRootFromParent_Done,
     /* 1657875 */   // Label 22798: @1657875
     /* 1657875 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1657961), // Rule ID 5874 //
     /* 1657880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657926 */     // MIs[0] policy
     /* 1657926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657960 */     // GIR_Coverage, 5874,
     /* 1657960 */     GIR_EraseRootFromParent_Done,
     /* 1657961 */   // Label 22799: @1657961
     /* 1657961 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1658047), // Rule ID 5875 //
     /* 1657966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658012 */     // MIs[0] policy
     /* 1658012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658046 */     // GIR_Coverage, 5875,
     /* 1658046 */     GIR_EraseRootFromParent_Done,
     /* 1658047 */   // Label 22800: @1658047
     /* 1658047 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1658133), // Rule ID 5878 //
     /* 1658052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658098 */     // MIs[0] policy
     /* 1658098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1658111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658132 */     // GIR_Coverage, 5878,
     /* 1658132 */     GIR_EraseRootFromParent_Done,
     /* 1658133 */   // Label 22801: @1658133
     /* 1658133 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1658219), // Rule ID 5879 //
     /* 1658138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658184 */     // MIs[0] policy
     /* 1658184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1658197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658218 */     // GIR_Coverage, 5879,
     /* 1658218 */     GIR_EraseRootFromParent_Done,
     /* 1658219 */   // Label 22802: @1658219
     /* 1658219 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1658305), // Rule ID 5882 //
     /* 1658224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658270 */     // MIs[0] policy
     /* 1658270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658304 */     // GIR_Coverage, 5882,
     /* 1658304 */     GIR_EraseRootFromParent_Done,
     /* 1658305 */   // Label 22803: @1658305
     /* 1658305 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1658391), // Rule ID 5883 //
     /* 1658310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658356 */     // MIs[0] policy
     /* 1658356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658390 */     // GIR_Coverage, 5883,
     /* 1658390 */     GIR_EraseRootFromParent_Done,
     /* 1658391 */   // Label 22804: @1658391
     /* 1658391 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1658477), // Rule ID 5886 //
     /* 1658396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658442 */     // MIs[0] policy
     /* 1658442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658476 */     // GIR_Coverage, 5886,
     /* 1658476 */     GIR_EraseRootFromParent_Done,
     /* 1658477 */   // Label 22805: @1658477
     /* 1658477 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1658563), // Rule ID 5887 //
     /* 1658482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658528 */     // MIs[0] policy
     /* 1658528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658562 */     // GIR_Coverage, 5887,
     /* 1658562 */     GIR_EraseRootFromParent_Done,
     /* 1658563 */   // Label 22806: @1658563
     /* 1658563 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1658649), // Rule ID 5890 //
     /* 1658568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658614 */     // MIs[0] policy
     /* 1658614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658648 */     // GIR_Coverage, 5890,
     /* 1658648 */     GIR_EraseRootFromParent_Done,
     /* 1658649 */   // Label 22807: @1658649
     /* 1658649 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1658735), // Rule ID 5891 //
     /* 1658654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658700 */     // MIs[0] policy
     /* 1658700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11213:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658734 */     // GIR_Coverage, 5891,
     /* 1658734 */     GIR_EraseRootFromParent_Done,
     /* 1658735 */   // Label 22808: @1658735
     /* 1658735 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1658821), // Rule ID 5894 //
     /* 1658740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658786 */     // MIs[0] policy
     /* 1658786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658820 */     // GIR_Coverage, 5894,
     /* 1658820 */     GIR_EraseRootFromParent_Done,
     /* 1658821 */   // Label 22809: @1658821
     /* 1658821 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1658907), // Rule ID 5895 //
     /* 1658826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658872 */     // MIs[0] policy
     /* 1658872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658906 */     // GIR_Coverage, 5895,
     /* 1658906 */     GIR_EraseRootFromParent_Done,
     /* 1658907 */   // Label 22810: @1658907
     /* 1658907 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1658993), // Rule ID 5898 //
     /* 1658912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658958 */     // MIs[0] policy
     /* 1658958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658992 */     // GIR_Coverage, 5898,
     /* 1658992 */     GIR_EraseRootFromParent_Done,
     /* 1658993 */   // Label 22811: @1658993
     /* 1658993 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1659079), // Rule ID 5899 //
     /* 1658998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1659009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1659012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1659015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659044 */     // MIs[0] policy
     /* 1659044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659078 */     // GIR_Coverage, 5899,
     /* 1659078 */     GIR_EraseRootFromParent_Done,
     /* 1659079 */   // Label 22812: @1659079
     /* 1659079 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1659165), // Rule ID 5902 //
     /* 1659084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1659087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659130 */     // MIs[0] policy
     /* 1659130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659164 */     // GIR_Coverage, 5902,
     /* 1659164 */     GIR_EraseRootFromParent_Done,
     /* 1659165 */   // Label 22813: @1659165
     /* 1659165 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1659251), // Rule ID 5903 //
     /* 1659170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1659173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659216 */     // MIs[0] policy
     /* 1659216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1659229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659250 */     // GIR_Coverage, 5903,
     /* 1659250 */     GIR_EraseRootFromParent_Done,
     /* 1659251 */   // Label 22814: @1659251
     /* 1659251 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1659337), // Rule ID 5906 //
     /* 1659256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659302 */     // MIs[0] policy
     /* 1659302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659336 */     // GIR_Coverage, 5906,
     /* 1659336 */     GIR_EraseRootFromParent_Done,
     /* 1659337 */   // Label 22815: @1659337
     /* 1659337 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1659423), // Rule ID 5907 //
     /* 1659342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659388 */     // MIs[0] policy
     /* 1659388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659422 */     // GIR_Coverage, 5907,
     /* 1659422 */     GIR_EraseRootFromParent_Done,
     /* 1659423 */   // Label 22816: @1659423
     /* 1659423 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1659509), // Rule ID 5910 //
     /* 1659428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659474 */     // MIs[0] policy
     /* 1659474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659508 */     // GIR_Coverage, 5910,
     /* 1659508 */     GIR_EraseRootFromParent_Done,
     /* 1659509 */   // Label 22817: @1659509
     /* 1659509 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1659595), // Rule ID 5911 //
     /* 1659514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659560 */     // MIs[0] policy
     /* 1659560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659594 */     // GIR_Coverage, 5911,
     /* 1659594 */     GIR_EraseRootFromParent_Done,
     /* 1659595 */   // Label 22818: @1659595
     /* 1659595 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1659681), // Rule ID 5914 //
     /* 1659600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659646 */     // MIs[0] policy
     /* 1659646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659680 */     // GIR_Coverage, 5914,
     /* 1659680 */     GIR_EraseRootFromParent_Done,
     /* 1659681 */   // Label 22819: @1659681
     /* 1659681 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1659767), // Rule ID 5915 //
     /* 1659686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659732 */     // MIs[0] policy
     /* 1659732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659742 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659766 */     // GIR_Coverage, 5915,
     /* 1659766 */     GIR_EraseRootFromParent_Done,
     /* 1659767 */   // Label 22820: @1659767
     /* 1659767 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1659853), // Rule ID 5918 //
     /* 1659772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659818 */     // MIs[0] policy
     /* 1659818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659852 */     // GIR_Coverage, 5918,
     /* 1659852 */     GIR_EraseRootFromParent_Done,
     /* 1659853 */   // Label 22821: @1659853
     /* 1659853 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1659939), // Rule ID 5919 //
     /* 1659858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659904 */     // MIs[0] policy
     /* 1659904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659938 */     // GIR_Coverage, 5919,
     /* 1659938 */     GIR_EraseRootFromParent_Done,
     /* 1659939 */   // Label 22822: @1659939
     /* 1659939 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1660025), // Rule ID 5922 //
     /* 1659944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659990 */     // MIs[0] policy
     /* 1659990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660024 */     // GIR_Coverage, 5922,
     /* 1660024 */     GIR_EraseRootFromParent_Done,
     /* 1660025 */   // Label 22823: @1660025
     /* 1660025 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1660111), // Rule ID 5923 //
     /* 1660030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1660041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1660044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1660047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660076 */     // MIs[0] policy
     /* 1660076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660110 */     // GIR_Coverage, 5923,
     /* 1660110 */     GIR_EraseRootFromParent_Done,
     /* 1660111 */   // Label 22824: @1660111
     /* 1660111 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1660197), // Rule ID 5926 //
     /* 1660116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660162 */     // MIs[0] policy
     /* 1660162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660196 */     // GIR_Coverage, 5926,
     /* 1660196 */     GIR_EraseRootFromParent_Done,
     /* 1660197 */   // Label 22825: @1660197
     /* 1660197 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1660283), // Rule ID 5927 //
     /* 1660202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660248 */     // MIs[0] policy
     /* 1660248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660282 */     // GIR_Coverage, 5927,
     /* 1660282 */     GIR_EraseRootFromParent_Done,
     /* 1660283 */   // Label 22826: @1660283
     /* 1660283 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1660369), // Rule ID 5930 //
     /* 1660288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660334 */     // MIs[0] policy
     /* 1660334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660368 */     // GIR_Coverage, 5930,
     /* 1660368 */     GIR_EraseRootFromParent_Done,
     /* 1660369 */   // Label 22827: @1660369
     /* 1660369 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1660455), // Rule ID 5931 //
     /* 1660374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660420 */     // MIs[0] policy
     /* 1660420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660454 */     // GIR_Coverage, 5931,
     /* 1660454 */     GIR_EraseRootFromParent_Done,
     /* 1660455 */   // Label 22828: @1660455
     /* 1660455 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1660541), // Rule ID 5934 //
     /* 1660460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660506 */     // MIs[0] policy
     /* 1660506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660540 */     // GIR_Coverage, 5934,
     /* 1660540 */     GIR_EraseRootFromParent_Done,
     /* 1660541 */   // Label 22829: @1660541
     /* 1660541 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1660627), // Rule ID 5935 //
     /* 1660546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660592 */     // MIs[0] policy
     /* 1660592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660626 */     // GIR_Coverage, 5935,
     /* 1660626 */     GIR_EraseRootFromParent_Done,
     /* 1660627 */   // Label 22830: @1660627
     /* 1660627 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1660713), // Rule ID 5938 //
     /* 1660632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660678 */     // MIs[0] policy
     /* 1660678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660712 */     // GIR_Coverage, 5938,
     /* 1660712 */     GIR_EraseRootFromParent_Done,
     /* 1660713 */   // Label 22831: @1660713
     /* 1660713 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1660799), // Rule ID 5939 //
     /* 1660718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660764 */     // MIs[0] policy
     /* 1660764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660798 */     // GIR_Coverage, 5939,
     /* 1660798 */     GIR_EraseRootFromParent_Done,
     /* 1660799 */   // Label 22832: @1660799
     /* 1660799 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1660885), // Rule ID 5942 //
     /* 1660804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660850 */     // MIs[0] policy
     /* 1660850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660884 */     // GIR_Coverage, 5942,
     /* 1660884 */     GIR_EraseRootFromParent_Done,
     /* 1660885 */   // Label 22833: @1660885
     /* 1660885 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1660971), // Rule ID 5943 //
     /* 1660890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660936 */     // MIs[0] policy
     /* 1660936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660970 */     // GIR_Coverage, 5943,
     /* 1660970 */     GIR_EraseRootFromParent_Done,
     /* 1660971 */   // Label 22834: @1660971
     /* 1660971 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1661057), // Rule ID 5946 //
     /* 1660976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661022 */     // MIs[0] policy
     /* 1661022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1661035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661056 */     // GIR_Coverage, 5946,
     /* 1661056 */     GIR_EraseRootFromParent_Done,
     /* 1661057 */   // Label 22835: @1661057
     /* 1661057 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1661143), // Rule ID 5947 //
     /* 1661062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1661073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1661076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1661079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661108 */     // MIs[0] policy
     /* 1661108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1661121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661142 */     // GIR_Coverage, 5947,
     /* 1661142 */     GIR_EraseRootFromParent_Done,
     /* 1661143 */   // Label 22836: @1661143
     /* 1661143 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1661229), // Rule ID 5950 //
     /* 1661148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661194 */     // MIs[0] policy
     /* 1661194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1661207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661228 */     // GIR_Coverage, 5950,
     /* 1661228 */     GIR_EraseRootFromParent_Done,
     /* 1661229 */   // Label 22837: @1661229
     /* 1661229 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1661315), // Rule ID 5951 //
     /* 1661234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1661242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661280 */     // MIs[0] policy
     /* 1661280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1661293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661314 */     // GIR_Coverage, 5951,
     /* 1661314 */     GIR_EraseRootFromParent_Done,
     /* 1661315 */   // Label 22838: @1661315
     /* 1661315 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1661401), // Rule ID 6042 //
     /* 1661320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661366 */     // MIs[0] policy
     /* 1661366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1661379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661400 */     // GIR_Coverage, 6042,
     /* 1661400 */     GIR_EraseRootFromParent_Done,
     /* 1661401 */   // Label 22839: @1661401
     /* 1661401 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1661487), // Rule ID 6043 //
     /* 1661406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661452 */     // MIs[0] policy
     /* 1661452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1661465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661486 */     // GIR_Coverage, 6043,
     /* 1661486 */     GIR_EraseRootFromParent_Done,
     /* 1661487 */   // Label 22840: @1661487
     /* 1661487 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1661573), // Rule ID 6046 //
     /* 1661492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661538 */     // MIs[0] policy
     /* 1661538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661572 */     // GIR_Coverage, 6046,
     /* 1661572 */     GIR_EraseRootFromParent_Done,
     /* 1661573 */   // Label 22841: @1661573
     /* 1661573 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1661659), // Rule ID 6047 //
     /* 1661578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661624 */     // MIs[0] policy
     /* 1661624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661658 */     // GIR_Coverage, 6047,
     /* 1661658 */     GIR_EraseRootFromParent_Done,
     /* 1661659 */   // Label 22842: @1661659
     /* 1661659 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1661745), // Rule ID 6050 //
     /* 1661664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661710 */     // MIs[0] policy
     /* 1661710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661744 */     // GIR_Coverage, 6050,
     /* 1661744 */     GIR_EraseRootFromParent_Done,
     /* 1661745 */   // Label 22843: @1661745
     /* 1661745 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1661831), // Rule ID 6051 //
     /* 1661750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661796 */     // MIs[0] policy
     /* 1661796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661830 */     // GIR_Coverage, 6051,
     /* 1661830 */     GIR_EraseRootFromParent_Done,
     /* 1661831 */   // Label 22844: @1661831
     /* 1661831 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1661917), // Rule ID 6054 //
     /* 1661836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661882 */     // MIs[0] policy
     /* 1661882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661916 */     // GIR_Coverage, 6054,
     /* 1661916 */     GIR_EraseRootFromParent_Done,
     /* 1661917 */   // Label 22845: @1661917
     /* 1661917 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1662003), // Rule ID 6055 //
     /* 1661922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661968 */     // MIs[0] policy
     /* 1661968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662002 */     // GIR_Coverage, 6055,
     /* 1662002 */     GIR_EraseRootFromParent_Done,
     /* 1662003 */   // Label 22846: @1662003
     /* 1662003 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1662089), // Rule ID 6058 //
     /* 1662008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662054 */     // MIs[0] policy
     /* 1662054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662088 */     // GIR_Coverage, 6058,
     /* 1662088 */     GIR_EraseRootFromParent_Done,
     /* 1662089 */   // Label 22847: @1662089
     /* 1662089 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1662175), // Rule ID 6059 //
     /* 1662094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662140 */     // MIs[0] policy
     /* 1662140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662174 */     // GIR_Coverage, 6059,
     /* 1662174 */     GIR_EraseRootFromParent_Done,
     /* 1662175 */   // Label 22848: @1662175
     /* 1662175 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1662261), // Rule ID 6062 //
     /* 1662180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662226 */     // MIs[0] policy
     /* 1662226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662260 */     // GIR_Coverage, 6062,
     /* 1662260 */     GIR_EraseRootFromParent_Done,
     /* 1662261 */   // Label 22849: @1662261
     /* 1662261 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1662347), // Rule ID 6063 //
     /* 1662266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662312 */     // MIs[0] policy
     /* 1662312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1662325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662346 */     // GIR_Coverage, 6063,
     /* 1662346 */     GIR_EraseRootFromParent_Done,
     /* 1662347 */   // Label 22850: @1662347
     /* 1662347 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1662433), // Rule ID 6066 //
     /* 1662352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662398 */     // MIs[0] policy
     /* 1662398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662432 */     // GIR_Coverage, 6066,
     /* 1662432 */     GIR_EraseRootFromParent_Done,
     /* 1662433 */   // Label 22851: @1662433
     /* 1662433 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1662519), // Rule ID 6067 //
     /* 1662438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662484 */     // MIs[0] policy
     /* 1662484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662518 */     // GIR_Coverage, 6067,
     /* 1662518 */     GIR_EraseRootFromParent_Done,
     /* 1662519 */   // Label 22852: @1662519
     /* 1662519 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1662605), // Rule ID 6070 //
     /* 1662524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662570 */     // MIs[0] policy
     /* 1662570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662604 */     // GIR_Coverage, 6070,
     /* 1662604 */     GIR_EraseRootFromParent_Done,
     /* 1662605 */   // Label 22853: @1662605
     /* 1662605 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1662691), // Rule ID 6071 //
     /* 1662610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662656 */     // MIs[0] policy
     /* 1662656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662690 */     // GIR_Coverage, 6071,
     /* 1662690 */     GIR_EraseRootFromParent_Done,
     /* 1662691 */   // Label 22854: @1662691
     /* 1662691 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1662777), // Rule ID 6074 //
     /* 1662696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662742 */     // MIs[0] policy
     /* 1662742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662776 */     // GIR_Coverage, 6074,
     /* 1662776 */     GIR_EraseRootFromParent_Done,
     /* 1662777 */   // Label 22855: @1662777
     /* 1662777 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1662863), // Rule ID 6075 //
     /* 1662782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662828 */     // MIs[0] policy
     /* 1662828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662862 */     // GIR_Coverage, 6075,
     /* 1662862 */     GIR_EraseRootFromParent_Done,
     /* 1662863 */   // Label 22856: @1662863
     /* 1662863 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1662949), // Rule ID 6078 //
     /* 1662868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662914 */     // MIs[0] policy
     /* 1662914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662948 */     // GIR_Coverage, 6078,
     /* 1662948 */     GIR_EraseRootFromParent_Done,
     /* 1662949 */   // Label 22857: @1662949
     /* 1662949 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1663035), // Rule ID 6079 //
     /* 1662954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663000 */     // MIs[0] policy
     /* 1663000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1663013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1663031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663034 */     // GIR_Coverage, 6079,
     /* 1663034 */     GIR_EraseRootFromParent_Done,
     /* 1663035 */   // Label 22858: @1663035
     /* 1663035 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1663121), // Rule ID 6082 //
     /* 1663040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663086 */     // MIs[0] policy
     /* 1663086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663120 */     // GIR_Coverage, 6082,
     /* 1663120 */     GIR_EraseRootFromParent_Done,
     /* 1663121 */   // Label 22859: @1663121
     /* 1663121 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1663207), // Rule ID 6083 //
     /* 1663126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663172 */     // MIs[0] policy
     /* 1663172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663206 */     // GIR_Coverage, 6083,
     /* 1663206 */     GIR_EraseRootFromParent_Done,
     /* 1663207 */   // Label 22860: @1663207
     /* 1663207 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1663293), // Rule ID 6086 //
     /* 1663212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663258 */     // MIs[0] policy
     /* 1663258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663292 */     // GIR_Coverage, 6086,
     /* 1663292 */     GIR_EraseRootFromParent_Done,
     /* 1663293 */   // Label 22861: @1663293
     /* 1663293 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1663379), // Rule ID 6087 //
     /* 1663298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663344 */     // MIs[0] policy
     /* 1663344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663378 */     // GIR_Coverage, 6087,
     /* 1663378 */     GIR_EraseRootFromParent_Done,
     /* 1663379 */   // Label 22862: @1663379
     /* 1663379 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1663465), // Rule ID 6090 //
     /* 1663384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663430 */     // MIs[0] policy
     /* 1663430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663440 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663464 */     // GIR_Coverage, 6090,
     /* 1663464 */     GIR_EraseRootFromParent_Done,
     /* 1663465 */   // Label 22863: @1663465
     /* 1663465 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1663551), // Rule ID 6091 //
     /* 1663470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663516 */     // MIs[0] policy
     /* 1663516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663526 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663550 */     // GIR_Coverage, 6091,
     /* 1663550 */     GIR_EraseRootFromParent_Done,
     /* 1663551 */   // Label 22864: @1663551
     /* 1663551 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1663637), // Rule ID 6094 //
     /* 1663556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663602 */     // MIs[0] policy
     /* 1663602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663612 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663636 */     // GIR_Coverage, 6094,
     /* 1663636 */     GIR_EraseRootFromParent_Done,
     /* 1663637 */   // Label 22865: @1663637
     /* 1663637 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1663723), // Rule ID 6095 //
     /* 1663642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663688 */     // MIs[0] policy
     /* 1663688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663722 */     // GIR_Coverage, 6095,
     /* 1663722 */     GIR_EraseRootFromParent_Done,
     /* 1663723 */   // Label 22866: @1663723
     /* 1663723 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1663809), // Rule ID 6098 //
     /* 1663728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663774 */     // MIs[0] policy
     /* 1663774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663808 */     // GIR_Coverage, 6098,
     /* 1663808 */     GIR_EraseRootFromParent_Done,
     /* 1663809 */   // Label 22867: @1663809
     /* 1663809 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1663895), // Rule ID 6099 //
     /* 1663814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663860 */     // MIs[0] policy
     /* 1663860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663894 */     // GIR_Coverage, 6099,
     /* 1663894 */     GIR_EraseRootFromParent_Done,
     /* 1663895 */   // Label 22868: @1663895
     /* 1663895 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1663981), // Rule ID 6102 //
     /* 1663900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663946 */     // MIs[0] policy
     /* 1663946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663956 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663980 */     // GIR_Coverage, 6102,
     /* 1663980 */     GIR_EraseRootFromParent_Done,
     /* 1663981 */   // Label 22869: @1663981
     /* 1663981 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1664067), // Rule ID 6103 //
     /* 1663986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1664006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664032 */     // MIs[0] policy
     /* 1664032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664066 */     // GIR_Coverage, 6103,
     /* 1664066 */     GIR_EraseRootFromParent_Done,
     /* 1664067 */   // Label 22870: @1664067
     /* 1664067 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1664153), // Rule ID 6106 //
     /* 1664072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664118 */     // MIs[0] policy
     /* 1664118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664152 */     // GIR_Coverage, 6106,
     /* 1664152 */     GIR_EraseRootFromParent_Done,
     /* 1664153 */   // Label 22871: @1664153
     /* 1664153 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1664239), // Rule ID 6107 //
     /* 1664158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664204 */     // MIs[0] policy
     /* 1664204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664238 */     // GIR_Coverage, 6107,
     /* 1664238 */     GIR_EraseRootFromParent_Done,
     /* 1664239 */   // Label 22872: @1664239
     /* 1664239 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1664325), // Rule ID 6110 //
     /* 1664244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664290 */     // MIs[0] policy
     /* 1664290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664324 */     // GIR_Coverage, 6110,
     /* 1664324 */     GIR_EraseRootFromParent_Done,
     /* 1664325 */   // Label 22873: @1664325
     /* 1664325 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1664411), // Rule ID 6111 //
     /* 1664330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664376 */     // MIs[0] policy
     /* 1664376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664410 */     // GIR_Coverage, 6111,
     /* 1664410 */     GIR_EraseRootFromParent_Done,
     /* 1664411 */   // Label 22874: @1664411
     /* 1664411 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1664497), // Rule ID 6114 //
     /* 1664416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664462 */     // MIs[0] policy
     /* 1664462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664472 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664496 */     // GIR_Coverage, 6114,
     /* 1664496 */     GIR_EraseRootFromParent_Done,
     /* 1664497 */   // Label 22875: @1664497
     /* 1664497 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1664583), // Rule ID 6115 //
     /* 1664502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664548 */     // MIs[0] policy
     /* 1664548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664582 */     // GIR_Coverage, 6115,
     /* 1664582 */     GIR_EraseRootFromParent_Done,
     /* 1664583 */   // Label 22876: @1664583
     /* 1664583 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1664669), // Rule ID 6118 //
     /* 1664588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664634 */     // MIs[0] policy
     /* 1664634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664668 */     // GIR_Coverage, 6118,
     /* 1664668 */     GIR_EraseRootFromParent_Done,
     /* 1664669 */   // Label 22877: @1664669
     /* 1664669 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1664755), // Rule ID 6119 //
     /* 1664674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664720 */     // MIs[0] policy
     /* 1664720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664754 */     // GIR_Coverage, 6119,
     /* 1664754 */     GIR_EraseRootFromParent_Done,
     /* 1664755 */   // Label 22878: @1664755
     /* 1664755 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1664841), // Rule ID 6122 //
     /* 1664760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664806 */     // MIs[0] policy
     /* 1664806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664816 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664840 */     // GIR_Coverage, 6122,
     /* 1664840 */     GIR_EraseRootFromParent_Done,
     /* 1664841 */   // Label 22879: @1664841
     /* 1664841 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1664927), // Rule ID 6123 //
     /* 1664846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664892 */     // MIs[0] policy
     /* 1664892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664926 */     // GIR_Coverage, 6123,
     /* 1664926 */     GIR_EraseRootFromParent_Done,
     /* 1664927 */   // Label 22880: @1664927
     /* 1664927 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1665013), // Rule ID 6126 //
     /* 1664932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664978 */     // MIs[0] policy
     /* 1664978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664988 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665012 */     // GIR_Coverage, 6126,
     /* 1665012 */     GIR_EraseRootFromParent_Done,
     /* 1665013 */   // Label 22881: @1665013
     /* 1665013 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1665099), // Rule ID 6127 //
     /* 1665018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665064 */     // MIs[0] policy
     /* 1665064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665074 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1665077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665098 */     // GIR_Coverage, 6127,
     /* 1665098 */     GIR_EraseRootFromParent_Done,
     /* 1665099 */   // Label 22882: @1665099
     /* 1665099 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1665185), // Rule ID 6130 //
     /* 1665104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665150 */     // MIs[0] policy
     /* 1665150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1665163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665184 */     // GIR_Coverage, 6130,
     /* 1665184 */     GIR_EraseRootFromParent_Done,
     /* 1665185 */   // Label 22883: @1665185
     /* 1665185 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1665271), // Rule ID 6131 //
     /* 1665190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665236 */     // MIs[0] policy
     /* 1665236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1665249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665270 */     // GIR_Coverage, 6131,
     /* 1665270 */     GIR_EraseRootFromParent_Done,
     /* 1665271 */   // Label 22884: @1665271
     /* 1665271 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1665357), // Rule ID 6134 //
     /* 1665276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665322 */     // MIs[0] policy
     /* 1665322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665356 */     // GIR_Coverage, 6134,
     /* 1665356 */     GIR_EraseRootFromParent_Done,
     /* 1665357 */   // Label 22885: @1665357
     /* 1665357 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1665443), // Rule ID 6135 //
     /* 1665362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665408 */     // MIs[0] policy
     /* 1665408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665418 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665442 */     // GIR_Coverage, 6135,
     /* 1665442 */     GIR_EraseRootFromParent_Done,
     /* 1665443 */   // Label 22886: @1665443
     /* 1665443 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1665529), // Rule ID 6138 //
     /* 1665448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665494 */     // MIs[0] policy
     /* 1665494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665528 */     // GIR_Coverage, 6138,
     /* 1665528 */     GIR_EraseRootFromParent_Done,
     /* 1665529 */   // Label 22887: @1665529
     /* 1665529 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1665615), // Rule ID 6139 //
     /* 1665534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665580 */     // MIs[0] policy
     /* 1665580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665590 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665614 */     // GIR_Coverage, 6139,
     /* 1665614 */     GIR_EraseRootFromParent_Done,
     /* 1665615 */   // Label 22888: @1665615
     /* 1665615 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1665701), // Rule ID 6142 //
     /* 1665620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665666 */     // MIs[0] policy
     /* 1665666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665700 */     // GIR_Coverage, 6142,
     /* 1665700 */     GIR_EraseRootFromParent_Done,
     /* 1665701 */   // Label 22889: @1665701
     /* 1665701 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1665787), // Rule ID 6143 //
     /* 1665706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665752 */     // MIs[0] policy
     /* 1665752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665762 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665786 */     // GIR_Coverage, 6143,
     /* 1665786 */     GIR_EraseRootFromParent_Done,
     /* 1665787 */   // Label 22890: @1665787
     /* 1665787 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1665873), // Rule ID 6146 //
     /* 1665792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665838 */     // MIs[0] policy
     /* 1665838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665872 */     // GIR_Coverage, 6146,
     /* 1665872 */     GIR_EraseRootFromParent_Done,
     /* 1665873 */   // Label 22891: @1665873
     /* 1665873 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1665959), // Rule ID 6147 //
     /* 1665878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665924 */     // MIs[0] policy
     /* 1665924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665958 */     // GIR_Coverage, 6147,
     /* 1665958 */     GIR_EraseRootFromParent_Done,
     /* 1665959 */   // Label 22892: @1665959
     /* 1665959 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1666045), // Rule ID 6150 //
     /* 1665964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666010 */     // MIs[0] policy
     /* 1666010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666020 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1666023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666044 */     // GIR_Coverage, 6150,
     /* 1666044 */     GIR_EraseRootFromParent_Done,
     /* 1666045 */   // Label 22893: @1666045
     /* 1666045 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1666131), // Rule ID 6151 //
     /* 1666050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1666061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1666064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1666067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666096 */     // MIs[0] policy
     /* 1666096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1666109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666130 */     // GIR_Coverage, 6151,
     /* 1666130 */     GIR_EraseRootFromParent_Done,
     /* 1666131 */   // Label 22894: @1666131
     /* 1666131 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1666217), // Rule ID 6154 //
     /* 1666136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666182 */     // MIs[0] policy
     /* 1666182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666216 */     // GIR_Coverage, 6154,
     /* 1666216 */     GIR_EraseRootFromParent_Done,
     /* 1666217 */   // Label 22895: @1666217
     /* 1666217 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1666303), // Rule ID 6155 //
     /* 1666222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666268 */     // MIs[0] policy
     /* 1666268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666302 */     // GIR_Coverage, 6155,
     /* 1666302 */     GIR_EraseRootFromParent_Done,
     /* 1666303 */   // Label 22896: @1666303
     /* 1666303 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1666389), // Rule ID 6158 //
     /* 1666308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666354 */     // MIs[0] policy
     /* 1666354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666388 */     // GIR_Coverage, 6158,
     /* 1666388 */     GIR_EraseRootFromParent_Done,
     /* 1666389 */   // Label 22897: @1666389
     /* 1666389 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1666475), // Rule ID 6159 //
     /* 1666394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666440 */     // MIs[0] policy
     /* 1666440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666474 */     // GIR_Coverage, 6159,
     /* 1666474 */     GIR_EraseRootFromParent_Done,
     /* 1666475 */   // Label 22898: @1666475
     /* 1666475 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1666561), // Rule ID 6162 //
     /* 1666480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666526 */     // MIs[0] policy
     /* 1666526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666560 */     // GIR_Coverage, 6162,
     /* 1666560 */     GIR_EraseRootFromParent_Done,
     /* 1666561 */   // Label 22899: @1666561
     /* 1666561 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1666647), // Rule ID 6163 //
     /* 1666566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666612 */     // MIs[0] policy
     /* 1666612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666646 */     // GIR_Coverage, 6163,
     /* 1666646 */     GIR_EraseRootFromParent_Done,
     /* 1666647 */   // Label 22900: @1666647
     /* 1666647 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1666733), // Rule ID 6166 //
     /* 1666652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666698 */     // MIs[0] policy
     /* 1666698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666732 */     // GIR_Coverage, 6166,
     /* 1666732 */     GIR_EraseRootFromParent_Done,
     /* 1666733 */   // Label 22901: @1666733
     /* 1666733 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1666819), // Rule ID 6167 //
     /* 1666738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666784 */     // MIs[0] policy
     /* 1666784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666818 */     // GIR_Coverage, 6167,
     /* 1666818 */     GIR_EraseRootFromParent_Done,
     /* 1666819 */   // Label 22902: @1666819
     /* 1666819 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1666905), // Rule ID 6170 //
     /* 1666824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666870 */     // MIs[0] policy
     /* 1666870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666904 */     // GIR_Coverage, 6170,
     /* 1666904 */     GIR_EraseRootFromParent_Done,
     /* 1666905 */   // Label 22903: @1666905
     /* 1666905 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1666991), // Rule ID 6171 //
     /* 1666910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666956 */     // MIs[0] policy
     /* 1666956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666966 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666990 */     // GIR_Coverage, 6171,
     /* 1666990 */     GIR_EraseRootFromParent_Done,
     /* 1666991 */   // Label 22904: @1666991
     /* 1666991 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1667077), // Rule ID 6174 //
     /* 1666996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667042 */     // MIs[0] policy
     /* 1667042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667076 */     // GIR_Coverage, 6174,
     /* 1667076 */     GIR_EraseRootFromParent_Done,
     /* 1667077 */   // Label 22905: @1667077
     /* 1667077 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1667163), // Rule ID 6175 //
     /* 1667082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667128 */     // MIs[0] policy
     /* 1667128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667138 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667162 */     // GIR_Coverage, 6175,
     /* 1667162 */     GIR_EraseRootFromParent_Done,
     /* 1667163 */   // Label 22906: @1667163
     /* 1667163 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1667249), // Rule ID 6178 //
     /* 1667168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667214 */     // MIs[0] policy
     /* 1667214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667224 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667248 */     // GIR_Coverage, 6178,
     /* 1667248 */     GIR_EraseRootFromParent_Done,
     /* 1667249 */   // Label 22907: @1667249
     /* 1667249 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1667335), // Rule ID 6179 //
     /* 1667254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667300 */     // MIs[0] policy
     /* 1667300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667310 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667334 */     // GIR_Coverage, 6179,
     /* 1667334 */     GIR_EraseRootFromParent_Done,
     /* 1667335 */   // Label 22908: @1667335
     /* 1667335 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1667421), // Rule ID 6182 //
     /* 1667340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667386 */     // MIs[0] policy
     /* 1667386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667420 */     // GIR_Coverage, 6182,
     /* 1667420 */     GIR_EraseRootFromParent_Done,
     /* 1667421 */   // Label 22909: @1667421
     /* 1667421 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1667507), // Rule ID 6183 //
     /* 1667426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667472 */     // MIs[0] policy
     /* 1667472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667506 */     // GIR_Coverage, 6183,
     /* 1667506 */     GIR_EraseRootFromParent_Done,
     /* 1667507 */   // Label 22910: @1667507
     /* 1667507 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1667593), // Rule ID 6186 //
     /* 1667512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667558 */     // MIs[0] policy
     /* 1667558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667592 */     // GIR_Coverage, 6186,
     /* 1667592 */     GIR_EraseRootFromParent_Done,
     /* 1667593 */   // Label 22911: @1667593
     /* 1667593 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1667679), // Rule ID 6187 //
     /* 1667598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667644 */     // MIs[0] policy
     /* 1667644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667678 */     // GIR_Coverage, 6187,
     /* 1667678 */     GIR_EraseRootFromParent_Done,
     /* 1667679 */   // Label 22912: @1667679
     /* 1667679 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1667765), // Rule ID 6190 //
     /* 1667684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667730 */     // MIs[0] policy
     /* 1667730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667764 */     // GIR_Coverage, 6190,
     /* 1667764 */     GIR_EraseRootFromParent_Done,
     /* 1667765 */   // Label 22913: @1667765
     /* 1667765 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1667851), // Rule ID 6191 //
     /* 1667770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667816 */     // MIs[0] policy
     /* 1667816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667826 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667850 */     // GIR_Coverage, 6191,
     /* 1667850 */     GIR_EraseRootFromParent_Done,
     /* 1667851 */   // Label 22914: @1667851
     /* 1667851 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1667937), // Rule ID 6194 //
     /* 1667856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667902 */     // MIs[0] policy
     /* 1667902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667936 */     // GIR_Coverage, 6194,
     /* 1667936 */     GIR_EraseRootFromParent_Done,
     /* 1667937 */   // Label 22915: @1667937
     /* 1667937 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1668023), // Rule ID 6195 //
     /* 1667942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667988 */     // MIs[0] policy
     /* 1667988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668022 */     // GIR_Coverage, 6195,
     /* 1668022 */     GIR_EraseRootFromParent_Done,
     /* 1668023 */   // Label 22916: @1668023
     /* 1668023 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1668109), // Rule ID 6198 //
     /* 1668028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668074 */     // MIs[0] policy
     /* 1668074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668108 */     // GIR_Coverage, 6198,
     /* 1668108 */     GIR_EraseRootFromParent_Done,
     /* 1668109 */   // Label 22917: @1668109
     /* 1668109 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1668195), // Rule ID 6199 //
     /* 1668114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668160 */     // MIs[0] policy
     /* 1668160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668194 */     // GIR_Coverage, 6199,
     /* 1668194 */     GIR_EraseRootFromParent_Done,
     /* 1668195 */   // Label 22918: @1668195
     /* 1668195 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1668281), // Rule ID 6202 //
     /* 1668200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668246 */     // MIs[0] policy
     /* 1668246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668280 */     // GIR_Coverage, 6202,
     /* 1668280 */     GIR_EraseRootFromParent_Done,
     /* 1668281 */   // Label 22919: @1668281
     /* 1668281 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1668367), // Rule ID 6203 //
     /* 1668286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668332 */     // MIs[0] policy
     /* 1668332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668342 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668366 */     // GIR_Coverage, 6203,
     /* 1668366 */     GIR_EraseRootFromParent_Done,
     /* 1668367 */   // Label 22920: @1668367
     /* 1668367 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1668453), // Rule ID 6206 //
     /* 1668372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668418 */     // MIs[0] policy
     /* 1668418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668452 */     // GIR_Coverage, 6206,
     /* 1668452 */     GIR_EraseRootFromParent_Done,
     /* 1668453 */   // Label 22921: @1668453
     /* 1668453 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1668539), // Rule ID 6207 //
     /* 1668458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668504 */     // MIs[0] policy
     /* 1668504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668538 */     // GIR_Coverage, 6207,
     /* 1668538 */     GIR_EraseRootFromParent_Done,
     /* 1668539 */   // Label 22922: @1668539
     /* 1668539 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1668625), // Rule ID 6210 //
     /* 1668544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668590 */     // MIs[0] policy
     /* 1668590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668624 */     // GIR_Coverage, 6210,
     /* 1668624 */     GIR_EraseRootFromParent_Done,
     /* 1668625 */   // Label 22923: @1668625
     /* 1668625 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1668711), // Rule ID 6211 //
     /* 1668630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668676 */     // MIs[0] policy
     /* 1668676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668686 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668710 */     // GIR_Coverage, 6211,
     /* 1668710 */     GIR_EraseRootFromParent_Done,
     /* 1668711 */   // Label 22924: @1668711
     /* 1668711 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1668797), // Rule ID 6214 //
     /* 1668716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668762 */     // MIs[0] policy
     /* 1668762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668772 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668796 */     // GIR_Coverage, 6214,
     /* 1668796 */     GIR_EraseRootFromParent_Done,
     /* 1668797 */   // Label 22925: @1668797
     /* 1668797 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1668883), // Rule ID 6215 //
     /* 1668802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668848 */     // MIs[0] policy
     /* 1668848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668858 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668882 */     // GIR_Coverage, 6215,
     /* 1668882 */     GIR_EraseRootFromParent_Done,
     /* 1668883 */   // Label 22926: @1668883
     /* 1668883 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1668969), // Rule ID 6306 //
     /* 1668888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668934 */     // MIs[0] policy
     /* 1668934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668968 */     // GIR_Coverage, 6306,
     /* 1668968 */     GIR_EraseRootFromParent_Done,
     /* 1668969 */   // Label 22927: @1668969
     /* 1668969 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1669055), // Rule ID 6307 //
     /* 1668974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669020 */     // MIs[0] policy
     /* 1669020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1669033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669054 */     // GIR_Coverage, 6307,
     /* 1669054 */     GIR_EraseRootFromParent_Done,
     /* 1669055 */   // Label 22928: @1669055
     /* 1669055 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1669141), // Rule ID 6310 //
     /* 1669060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669106 */     // MIs[0] policy
     /* 1669106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669140 */     // GIR_Coverage, 6310,
     /* 1669140 */     GIR_EraseRootFromParent_Done,
     /* 1669141 */   // Label 22929: @1669141
     /* 1669141 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1669227), // Rule ID 6311 //
     /* 1669146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669192 */     // MIs[0] policy
     /* 1669192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669226 */     // GIR_Coverage, 6311,
     /* 1669226 */     GIR_EraseRootFromParent_Done,
     /* 1669227 */   // Label 22930: @1669227
     /* 1669227 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1669313), // Rule ID 6314 //
     /* 1669232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669278 */     // MIs[0] policy
     /* 1669278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669312 */     // GIR_Coverage, 6314,
     /* 1669312 */     GIR_EraseRootFromParent_Done,
     /* 1669313 */   // Label 22931: @1669313
     /* 1669313 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1669399), // Rule ID 6315 //
     /* 1669318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669364 */     // MIs[0] policy
     /* 1669364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669374 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669398 */     // GIR_Coverage, 6315,
     /* 1669398 */     GIR_EraseRootFromParent_Done,
     /* 1669399 */   // Label 22932: @1669399
     /* 1669399 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1669485), // Rule ID 6318 //
     /* 1669404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669450 */     // MIs[0] policy
     /* 1669450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669484 */     // GIR_Coverage, 6318,
     /* 1669484 */     GIR_EraseRootFromParent_Done,
     /* 1669485 */   // Label 22933: @1669485
     /* 1669485 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1669571), // Rule ID 6319 //
     /* 1669490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669536 */     // MIs[0] policy
     /* 1669536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669570 */     // GIR_Coverage, 6319,
     /* 1669570 */     GIR_EraseRootFromParent_Done,
     /* 1669571 */   // Label 22934: @1669571
     /* 1669571 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1669657), // Rule ID 6322 //
     /* 1669576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669622 */     // MIs[0] policy
     /* 1669622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669656 */     // GIR_Coverage, 6322,
     /* 1669656 */     GIR_EraseRootFromParent_Done,
     /* 1669657 */   // Label 22935: @1669657
     /* 1669657 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1669743), // Rule ID 6323 //
     /* 1669662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669708 */     // MIs[0] policy
     /* 1669708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669742 */     // GIR_Coverage, 6323,
     /* 1669742 */     GIR_EraseRootFromParent_Done,
     /* 1669743 */   // Label 22936: @1669743
     /* 1669743 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1669829), // Rule ID 6326 //
     /* 1669748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669794 */     // MIs[0] policy
     /* 1669794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669804 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669828 */     // GIR_Coverage, 6326,
     /* 1669828 */     GIR_EraseRootFromParent_Done,
     /* 1669829 */   // Label 22937: @1669829
     /* 1669829 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1669915), // Rule ID 6327 //
     /* 1669834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669880 */     // MIs[0] policy
     /* 1669880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669914 */     // GIR_Coverage, 6327,
     /* 1669914 */     GIR_EraseRootFromParent_Done,
     /* 1669915 */   // Label 22938: @1669915
     /* 1669915 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1670001), // Rule ID 6330 //
     /* 1669920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669966 */     // MIs[0] policy
     /* 1669966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670000 */     // GIR_Coverage, 6330,
     /* 1670000 */     GIR_EraseRootFromParent_Done,
     /* 1670001 */   // Label 22939: @1670001
     /* 1670001 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1670087), // Rule ID 6331 //
     /* 1670006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670052 */     // MIs[0] policy
     /* 1670052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670086 */     // GIR_Coverage, 6331,
     /* 1670086 */     GIR_EraseRootFromParent_Done,
     /* 1670087 */   // Label 22940: @1670087
     /* 1670087 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1670173), // Rule ID 6334 //
     /* 1670092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670138 */     // MIs[0] policy
     /* 1670138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670172 */     // GIR_Coverage, 6334,
     /* 1670172 */     GIR_EraseRootFromParent_Done,
     /* 1670173 */   // Label 22941: @1670173
     /* 1670173 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1670259), // Rule ID 6335 //
     /* 1670178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670224 */     // MIs[0] policy
     /* 1670224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670258 */     // GIR_Coverage, 6335,
     /* 1670258 */     GIR_EraseRootFromParent_Done,
     /* 1670259 */   // Label 22942: @1670259
     /* 1670259 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1670345), // Rule ID 6338 //
     /* 1670264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670310 */     // MIs[0] policy
     /* 1670310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670344 */     // GIR_Coverage, 6338,
     /* 1670344 */     GIR_EraseRootFromParent_Done,
     /* 1670345 */   // Label 22943: @1670345
     /* 1670345 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1670431), // Rule ID 6339 //
     /* 1670350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670396 */     // MIs[0] policy
     /* 1670396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670430 */     // GIR_Coverage, 6339,
     /* 1670430 */     GIR_EraseRootFromParent_Done,
     /* 1670431 */   // Label 22944: @1670431
     /* 1670431 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1670517), // Rule ID 6342 //
     /* 1670436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1670439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670482 */     // MIs[0] policy
     /* 1670482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670516 */     // GIR_Coverage, 6342,
     /* 1670516 */     GIR_EraseRootFromParent_Done,
     /* 1670517 */   // Label 22945: @1670517
     /* 1670517 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1670603), // Rule ID 6343 //
     /* 1670522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670568 */     // MIs[0] policy
     /* 1670568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670602 */     // GIR_Coverage, 6343,
     /* 1670602 */     GIR_EraseRootFromParent_Done,
     /* 1670603 */   // Label 22946: @1670603
     /* 1670603 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1670689), // Rule ID 6346 //
     /* 1670608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670654 */     // MIs[0] policy
     /* 1670654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670688 */     // GIR_Coverage, 6346,
     /* 1670688 */     GIR_EraseRootFromParent_Done,
     /* 1670689 */   // Label 22947: @1670689
     /* 1670689 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1670775), // Rule ID 6347 //
     /* 1670694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670740 */     // MIs[0] policy
     /* 1670740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670774 */     // GIR_Coverage, 6347,
     /* 1670774 */     GIR_EraseRootFromParent_Done,
     /* 1670775 */   // Label 22948: @1670775
     /* 1670775 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1670861), // Rule ID 6350 //
     /* 1670780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670826 */     // MIs[0] policy
     /* 1670826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670836 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670860 */     // GIR_Coverage, 6350,
     /* 1670860 */     GIR_EraseRootFromParent_Done,
     /* 1670861 */   // Label 22949: @1670861
     /* 1670861 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1670947), // Rule ID 6351 //
     /* 1670866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670912 */     // MIs[0] policy
     /* 1670912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670922 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670946 */     // GIR_Coverage, 6351,
     /* 1670946 */     GIR_EraseRootFromParent_Done,
     /* 1670947 */   // Label 22950: @1670947
     /* 1670947 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1671033), // Rule ID 6354 //
     /* 1670952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670998 */     // MIs[0] policy
     /* 1670998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671032 */     // GIR_Coverage, 6354,
     /* 1671032 */     GIR_EraseRootFromParent_Done,
     /* 1671033 */   // Label 22951: @1671033
     /* 1671033 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1671119), // Rule ID 6355 //
     /* 1671038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671084 */     // MIs[0] policy
     /* 1671084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671094 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671118 */     // GIR_Coverage, 6355,
     /* 1671118 */     GIR_EraseRootFromParent_Done,
     /* 1671119 */   // Label 22952: @1671119
     /* 1671119 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1671205), // Rule ID 6358 //
     /* 1671124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671170 */     // MIs[0] policy
     /* 1671170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671204 */     // GIR_Coverage, 6358,
     /* 1671204 */     GIR_EraseRootFromParent_Done,
     /* 1671205 */   // Label 22953: @1671205
     /* 1671205 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1671291), // Rule ID 6359 //
     /* 1671210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671256 */     // MIs[0] policy
     /* 1671256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671290 */     // GIR_Coverage, 6359,
     /* 1671290 */     GIR_EraseRootFromParent_Done,
     /* 1671291 */   // Label 22954: @1671291
     /* 1671291 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1671377), // Rule ID 6362 //
     /* 1671296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671342 */     // MIs[0] policy
     /* 1671342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671376 */     // GIR_Coverage, 6362,
     /* 1671376 */     GIR_EraseRootFromParent_Done,
     /* 1671377 */   // Label 22955: @1671377
     /* 1671377 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1671463), // Rule ID 6363 //
     /* 1671382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671428 */     // MIs[0] policy
     /* 1671428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671438 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671462 */     // GIR_Coverage, 6363,
     /* 1671462 */     GIR_EraseRootFromParent_Done,
     /* 1671463 */   // Label 22956: @1671463
     /* 1671463 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1671549), // Rule ID 6366 //
     /* 1671468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671514 */     // MIs[0] policy
     /* 1671514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671548 */     // GIR_Coverage, 6366,
     /* 1671548 */     GIR_EraseRootFromParent_Done,
     /* 1671549 */   // Label 22957: @1671549
     /* 1671549 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1671635), // Rule ID 6367 //
     /* 1671554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671600 */     // MIs[0] policy
     /* 1671600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671634 */     // GIR_Coverage, 6367,
     /* 1671634 */     GIR_EraseRootFromParent_Done,
     /* 1671635 */   // Label 22958: @1671635
     /* 1671635 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1671721), // Rule ID 6370 //
     /* 1671640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671686 */     // MIs[0] policy
     /* 1671686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671720 */     // GIR_Coverage, 6370,
     /* 1671720 */     GIR_EraseRootFromParent_Done,
     /* 1671721 */   // Label 22959: @1671721
     /* 1671721 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1671807), // Rule ID 6371 //
     /* 1671726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671772 */     // MIs[0] policy
     /* 1671772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671806 */     // GIR_Coverage, 6371,
     /* 1671806 */     GIR_EraseRootFromParent_Done,
     /* 1671807 */   // Label 22960: @1671807
     /* 1671807 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1671893), // Rule ID 6374 //
     /* 1671812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671858 */     // MIs[0] policy
     /* 1671858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671892 */     // GIR_Coverage, 6374,
     /* 1671892 */     GIR_EraseRootFromParent_Done,
     /* 1671893 */   // Label 22961: @1671893
     /* 1671893 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1671979), // Rule ID 6375 //
     /* 1671898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671944 */     // MIs[0] policy
     /* 1671944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671978 */     // GIR_Coverage, 6375,
     /* 1671978 */     GIR_EraseRootFromParent_Done,
     /* 1671979 */   // Label 22962: @1671979
     /* 1671979 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1672065), // Rule ID 6378 //
     /* 1671984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672030 */     // MIs[0] policy
     /* 1672030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672064 */     // GIR_Coverage, 6378,
     /* 1672064 */     GIR_EraseRootFromParent_Done,
     /* 1672065 */   // Label 22963: @1672065
     /* 1672065 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1672151), // Rule ID 6379 //
     /* 1672070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672116 */     // MIs[0] policy
     /* 1672116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672150 */     // GIR_Coverage, 6379,
     /* 1672150 */     GIR_EraseRootFromParent_Done,
     /* 1672151 */   // Label 22964: @1672151
     /* 1672151 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1672237), // Rule ID 6382 //
     /* 1672156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672202 */     // MIs[0] policy
     /* 1672202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1672215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672236 */     // GIR_Coverage, 6382,
     /* 1672236 */     GIR_EraseRootFromParent_Done,
     /* 1672237 */   // Label 22965: @1672237
     /* 1672237 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1672323), // Rule ID 6383 //
     /* 1672242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672288 */     // MIs[0] policy
     /* 1672288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1672301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672322 */     // GIR_Coverage, 6383,
     /* 1672322 */     GIR_EraseRootFromParent_Done,
     /* 1672323 */   // Label 22966: @1672323
     /* 1672323 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1672409), // Rule ID 6386 //
     /* 1672328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672374 */     // MIs[0] policy
     /* 1672374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672408 */     // GIR_Coverage, 6386,
     /* 1672408 */     GIR_EraseRootFromParent_Done,
     /* 1672409 */   // Label 22967: @1672409
     /* 1672409 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1672495), // Rule ID 6387 //
     /* 1672414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672460 */     // MIs[0] policy
     /* 1672460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672494 */     // GIR_Coverage, 6387,
     /* 1672494 */     GIR_EraseRootFromParent_Done,
     /* 1672495 */   // Label 22968: @1672495
     /* 1672495 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1672581), // Rule ID 6390 //
     /* 1672500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672546 */     // MIs[0] policy
     /* 1672546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672580 */     // GIR_Coverage, 6390,
     /* 1672580 */     GIR_EraseRootFromParent_Done,
     /* 1672581 */   // Label 22969: @1672581
     /* 1672581 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1672667), // Rule ID 6391 //
     /* 1672586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672632 */     // MIs[0] policy
     /* 1672632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672666 */     // GIR_Coverage, 6391,
     /* 1672666 */     GIR_EraseRootFromParent_Done,
     /* 1672667 */   // Label 22970: @1672667
     /* 1672667 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1672753), // Rule ID 6394 //
     /* 1672672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672718 */     // MIs[0] policy
     /* 1672718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672728 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672752 */     // GIR_Coverage, 6394,
     /* 1672752 */     GIR_EraseRootFromParent_Done,
     /* 1672753 */   // Label 22971: @1672753
     /* 1672753 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1672839), // Rule ID 6395 //
     /* 1672758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672804 */     // MIs[0] policy
     /* 1672804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672814 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672838 */     // GIR_Coverage, 6395,
     /* 1672838 */     GIR_EraseRootFromParent_Done,
     /* 1672839 */   // Label 22972: @1672839
     /* 1672839 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1672925), // Rule ID 6398 //
     /* 1672844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672890 */     // MIs[0] policy
     /* 1672890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672924 */     // GIR_Coverage, 6398,
     /* 1672924 */     GIR_EraseRootFromParent_Done,
     /* 1672925 */   // Label 22973: @1672925
     /* 1672925 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1673011), // Rule ID 6399 //
     /* 1672930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672976 */     // MIs[0] policy
     /* 1672976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673010 */     // GIR_Coverage, 6399,
     /* 1673010 */     GIR_EraseRootFromParent_Done,
     /* 1673011 */   // Label 22974: @1673011
     /* 1673011 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1673097), // Rule ID 6402 //
     /* 1673016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673062 */     // MIs[0] policy
     /* 1673062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673072 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673096 */     // GIR_Coverage, 6402,
     /* 1673096 */     GIR_EraseRootFromParent_Done,
     /* 1673097 */   // Label 22975: @1673097
     /* 1673097 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1673183), // Rule ID 6403 //
     /* 1673102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673148 */     // MIs[0] policy
     /* 1673148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673182 */     // GIR_Coverage, 6403,
     /* 1673182 */     GIR_EraseRootFromParent_Done,
     /* 1673183 */   // Label 22976: @1673183
     /* 1673183 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1673269), // Rule ID 6406 //
     /* 1673188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673234 */     // MIs[0] policy
     /* 1673234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673244 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1673247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673268 */     // GIR_Coverage, 6406,
     /* 1673268 */     GIR_EraseRootFromParent_Done,
     /* 1673269 */   // Label 22977: @1673269
     /* 1673269 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1673355), // Rule ID 6407 //
     /* 1673274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673320 */     // MIs[0] policy
     /* 1673320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1673333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673354 */     // GIR_Coverage, 6407,
     /* 1673354 */     GIR_EraseRootFromParent_Done,
     /* 1673355 */   // Label 22978: @1673355
     /* 1673355 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1673441), // Rule ID 6410 //
     /* 1673360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673406 */     // MIs[0] policy
     /* 1673406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673440 */     // GIR_Coverage, 6410,
     /* 1673440 */     GIR_EraseRootFromParent_Done,
     /* 1673441 */   // Label 22979: @1673441
     /* 1673441 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1673527), // Rule ID 6411 //
     /* 1673446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673492 */     // MIs[0] policy
     /* 1673492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673526 */     // GIR_Coverage, 6411,
     /* 1673526 */     GIR_EraseRootFromParent_Done,
     /* 1673527 */   // Label 22980: @1673527
     /* 1673527 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1673613), // Rule ID 6414 //
     /* 1673532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673578 */     // MIs[0] policy
     /* 1673578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673612 */     // GIR_Coverage, 6414,
     /* 1673612 */     GIR_EraseRootFromParent_Done,
     /* 1673613 */   // Label 22981: @1673613
     /* 1673613 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1673699), // Rule ID 6415 //
     /* 1673618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673664 */     // MIs[0] policy
     /* 1673664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673698 */     // GIR_Coverage, 6415,
     /* 1673698 */     GIR_EraseRootFromParent_Done,
     /* 1673699 */   // Label 22982: @1673699
     /* 1673699 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1673785), // Rule ID 6418 //
     /* 1673704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673750 */     // MIs[0] policy
     /* 1673750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673784 */     // GIR_Coverage, 6418,
     /* 1673784 */     GIR_EraseRootFromParent_Done,
     /* 1673785 */   // Label 22983: @1673785
     /* 1673785 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1673871), // Rule ID 6419 //
     /* 1673790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673836 */     // MIs[0] policy
     /* 1673836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673846 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11732:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673870 */     // GIR_Coverage, 6419,
     /* 1673870 */     GIR_EraseRootFromParent_Done,
     /* 1673871 */   // Label 22984: @1673871
     /* 1673871 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1673957), // Rule ID 6422 //
     /* 1673876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673922 */     // MIs[0] policy
     /* 1673922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673956 */     // GIR_Coverage, 6422,
     /* 1673956 */     GIR_EraseRootFromParent_Done,
     /* 1673957 */   // Label 22985: @1673957
     /* 1673957 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1674043), // Rule ID 6423 //
     /* 1673962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674008 */     // MIs[0] policy
     /* 1674008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11732:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674042 */     // GIR_Coverage, 6423,
     /* 1674042 */     GIR_EraseRootFromParent_Done,
     /* 1674043 */   // Label 22986: @1674043
     /* 1674043 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1674129), // Rule ID 6426 //
     /* 1674048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674094 */     // MIs[0] policy
     /* 1674094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674128 */     // GIR_Coverage, 6426,
     /* 1674128 */     GIR_EraseRootFromParent_Done,
     /* 1674129 */   // Label 22987: @1674129
     /* 1674129 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1674215), // Rule ID 6427 //
     /* 1674134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674180 */     // MIs[0] policy
     /* 1674180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11732:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674214 */     // GIR_Coverage, 6427,
     /* 1674214 */     GIR_EraseRootFromParent_Done,
     /* 1674215 */   // Label 22988: @1674215
     /* 1674215 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1674301), // Rule ID 6430 //
     /* 1674220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1674223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674266 */     // MIs[0] policy
     /* 1674266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674300 */     // GIR_Coverage, 6430,
     /* 1674300 */     GIR_EraseRootFromParent_Done,
     /* 1674301 */   // Label 22989: @1674301
     /* 1674301 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1674387), // Rule ID 6431 //
     /* 1674306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1674309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674352 */     // MIs[0] policy
     /* 1674352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11732:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1674365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674386 */     // GIR_Coverage, 6431,
     /* 1674386 */     GIR_EraseRootFromParent_Done,
     /* 1674387 */   // Label 22990: @1674387
     /* 1674387 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1674473), // Rule ID 6434 //
     /* 1674392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674438 */     // MIs[0] policy
     /* 1674438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674472 */     // GIR_Coverage, 6434,
     /* 1674472 */     GIR_EraseRootFromParent_Done,
     /* 1674473 */   // Label 22991: @1674473
     /* 1674473 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1674559), // Rule ID 6435 //
     /* 1674478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674524 */     // MIs[0] policy
     /* 1674524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674558 */     // GIR_Coverage, 6435,
     /* 1674558 */     GIR_EraseRootFromParent_Done,
     /* 1674559 */   // Label 22992: @1674559
     /* 1674559 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1674645), // Rule ID 6438 //
     /* 1674564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674610 */     // MIs[0] policy
     /* 1674610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674644 */     // GIR_Coverage, 6438,
     /* 1674644 */     GIR_EraseRootFromParent_Done,
     /* 1674645 */   // Label 22993: @1674645
     /* 1674645 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1674731), // Rule ID 6439 //
     /* 1674650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674696 */     // MIs[0] policy
     /* 1674696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674730 */     // GIR_Coverage, 6439,
     /* 1674730 */     GIR_EraseRootFromParent_Done,
     /* 1674731 */   // Label 22994: @1674731
     /* 1674731 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1674817), // Rule ID 6442 //
     /* 1674736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674782 */     // MIs[0] policy
     /* 1674782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674816 */     // GIR_Coverage, 6442,
     /* 1674816 */     GIR_EraseRootFromParent_Done,
     /* 1674817 */   // Label 22995: @1674817
     /* 1674817 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1674903), // Rule ID 6443 //
     /* 1674822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674868 */     // MIs[0] policy
     /* 1674868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674878 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674902 */     // GIR_Coverage, 6443,
     /* 1674902 */     GIR_EraseRootFromParent_Done,
     /* 1674903 */   // Label 22996: @1674903
     /* 1674903 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1674989), // Rule ID 6446 //
     /* 1674908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674954 */     // MIs[0] policy
     /* 1674954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674988 */     // GIR_Coverage, 6446,
     /* 1674988 */     GIR_EraseRootFromParent_Done,
     /* 1674989 */   // Label 22997: @1674989
     /* 1674989 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1675075), // Rule ID 6447 //
     /* 1674994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675040 */     // MIs[0] policy
     /* 1675040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675074 */     // GIR_Coverage, 6447,
     /* 1675074 */     GIR_EraseRootFromParent_Done,
     /* 1675075 */   // Label 22998: @1675075
     /* 1675075 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1675161), // Rule ID 6450 //
     /* 1675080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675126 */     // MIs[0] policy
     /* 1675126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675160 */     // GIR_Coverage, 6450,
     /* 1675160 */     GIR_EraseRootFromParent_Done,
     /* 1675161 */   // Label 22999: @1675161
     /* 1675161 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1675247), // Rule ID 6451 //
     /* 1675166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675212 */     // MIs[0] policy
     /* 1675212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675246 */     // GIR_Coverage, 6451,
     /* 1675246 */     GIR_EraseRootFromParent_Done,
     /* 1675247 */   // Label 23000: @1675247
     /* 1675247 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1675333), // Rule ID 6454 //
     /* 1675252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675298 */     // MIs[0] policy
     /* 1675298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675332 */     // GIR_Coverage, 6454,
     /* 1675332 */     GIR_EraseRootFromParent_Done,
     /* 1675333 */   // Label 23001: @1675333
     /* 1675333 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1675419), // Rule ID 6455 //
     /* 1675338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675384 */     // MIs[0] policy
     /* 1675384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675418 */     // GIR_Coverage, 6455,
     /* 1675418 */     GIR_EraseRootFromParent_Done,
     /* 1675419 */   // Label 23002: @1675419
     /* 1675419 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1675505), // Rule ID 6458 //
     /* 1675424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675470 */     // MIs[0] policy
     /* 1675470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675504 */     // GIR_Coverage, 6458,
     /* 1675504 */     GIR_EraseRootFromParent_Done,
     /* 1675505 */   // Label 23003: @1675505
     /* 1675505 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1675591), // Rule ID 6459 //
     /* 1675510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675556 */     // MIs[0] policy
     /* 1675556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675590 */     // GIR_Coverage, 6459,
     /* 1675590 */     GIR_EraseRootFromParent_Done,
     /* 1675591 */   // Label 23004: @1675591
     /* 1675591 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1675677), // Rule ID 6462 //
     /* 1675596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675642 */     // MIs[0] policy
     /* 1675642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675652 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675676 */     // GIR_Coverage, 6462,
     /* 1675676 */     GIR_EraseRootFromParent_Done,
     /* 1675677 */   // Label 23005: @1675677
     /* 1675677 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1675763), // Rule ID 6463 //
     /* 1675682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675728 */     // MIs[0] policy
     /* 1675728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675762 */     // GIR_Coverage, 6463,
     /* 1675762 */     GIR_EraseRootFromParent_Done,
     /* 1675763 */   // Label 23006: @1675763
     /* 1675763 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1675849), // Rule ID 6466 //
     /* 1675768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675814 */     // MIs[0] policy
     /* 1675814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675848 */     // GIR_Coverage, 6466,
     /* 1675848 */     GIR_EraseRootFromParent_Done,
     /* 1675849 */   // Label 23007: @1675849
     /* 1675849 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1675935), // Rule ID 6467 //
     /* 1675854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675900 */     // MIs[0] policy
     /* 1675900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675934 */     // GIR_Coverage, 6467,
     /* 1675934 */     GIR_EraseRootFromParent_Done,
     /* 1675935 */   // Label 23008: @1675935
     /* 1675935 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1676021), // Rule ID 6470 //
     /* 1675940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675986 */     // MIs[0] policy
     /* 1675986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676020 */     // GIR_Coverage, 6470,
     /* 1676020 */     GIR_EraseRootFromParent_Done,
     /* 1676021 */   // Label 23009: @1676021
     /* 1676021 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1676107), // Rule ID 6471 //
     /* 1676026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676072 */     // MIs[0] policy
     /* 1676072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11732:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1676085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676106 */     // GIR_Coverage, 6471,
     /* 1676106 */     GIR_EraseRootFromParent_Done,
     /* 1676107 */   // Label 23010: @1676107
     /* 1676107 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1676193), // Rule ID 6474 //
     /* 1676112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676158 */     // MIs[0] policy
     /* 1676158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1676171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676192 */     // GIR_Coverage, 6474,
     /* 1676192 */     GIR_EraseRootFromParent_Done,
     /* 1676193 */   // Label 23011: @1676193
     /* 1676193 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1676279), // Rule ID 6475 //
     /* 1676198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676244 */     // MIs[0] policy
     /* 1676244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11732:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1676257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676278 */     // GIR_Coverage, 6475,
     /* 1676278 */     GIR_EraseRootFromParent_Done,
     /* 1676279 */   // Label 23012: @1676279
     /* 1676279 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1676365), // Rule ID 6478 //
     /* 1676284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676330 */     // MIs[0] policy
     /* 1676330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1676343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676364 */     // GIR_Coverage, 6478,
     /* 1676364 */     GIR_EraseRootFromParent_Done,
     /* 1676365 */   // Label 23013: @1676365
     /* 1676365 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1676451), // Rule ID 6479 //
     /* 1676370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1676378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676416 */     // MIs[0] policy
     /* 1676416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11732:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1676429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676450 */     // GIR_Coverage, 6479,
     /* 1676450 */     GIR_EraseRootFromParent_Done,
     /* 1676451 */   // Label 23014: @1676451
     /* 1676451 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1676537), // Rule ID 6570 //
     /* 1676456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676502 */     // MIs[0] policy
     /* 1676502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676536 */     // GIR_Coverage, 6570,
     /* 1676536 */     GIR_EraseRootFromParent_Done,
     /* 1676537 */   // Label 23015: @1676537
     /* 1676537 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1676623), // Rule ID 6571 //
     /* 1676542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676588 */     // MIs[0] policy
     /* 1676588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676622 */     // GIR_Coverage, 6571,
     /* 1676622 */     GIR_EraseRootFromParent_Done,
     /* 1676623 */   // Label 23016: @1676623
     /* 1676623 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1676709), // Rule ID 6574 //
     /* 1676628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676674 */     // MIs[0] policy
     /* 1676674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676708 */     // GIR_Coverage, 6574,
     /* 1676708 */     GIR_EraseRootFromParent_Done,
     /* 1676709 */   // Label 23017: @1676709
     /* 1676709 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1676795), // Rule ID 6575 //
     /* 1676714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676760 */     // MIs[0] policy
     /* 1676760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676770 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676794 */     // GIR_Coverage, 6575,
     /* 1676794 */     GIR_EraseRootFromParent_Done,
     /* 1676795 */   // Label 23018: @1676795
     /* 1676795 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1676881), // Rule ID 6578 //
     /* 1676800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676846 */     // MIs[0] policy
     /* 1676846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676880 */     // GIR_Coverage, 6578,
     /* 1676880 */     GIR_EraseRootFromParent_Done,
     /* 1676881 */   // Label 23019: @1676881
     /* 1676881 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1676967), // Rule ID 6579 //
     /* 1676886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676932 */     // MIs[0] policy
     /* 1676932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676966 */     // GIR_Coverage, 6579,
     /* 1676966 */     GIR_EraseRootFromParent_Done,
     /* 1676967 */   // Label 23020: @1676967
     /* 1676967 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1677053), // Rule ID 6582 //
     /* 1676972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1676992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677018 */     // MIs[0] policy
     /* 1677018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1677031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677052 */     // GIR_Coverage, 6582,
     /* 1677052 */     GIR_EraseRootFromParent_Done,
     /* 1677053 */   // Label 23021: @1677053
     /* 1677053 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1677139), // Rule ID 6583 //
     /* 1677058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677104 */     // MIs[0] policy
     /* 1677104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1677117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677138 */     // GIR_Coverage, 6583,
     /* 1677138 */     GIR_EraseRootFromParent_Done,
     /* 1677139 */   // Label 23022: @1677139
     /* 1677139 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1677225), // Rule ID 6586 //
     /* 1677144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677190 */     // MIs[0] policy
     /* 1677190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677224 */     // GIR_Coverage, 6586,
     /* 1677224 */     GIR_EraseRootFromParent_Done,
     /* 1677225 */   // Label 23023: @1677225
     /* 1677225 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1677311), // Rule ID 6587 //
     /* 1677230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677276 */     // MIs[0] policy
     /* 1677276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677286 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677310 */     // GIR_Coverage, 6587,
     /* 1677310 */     GIR_EraseRootFromParent_Done,
     /* 1677311 */   // Label 23024: @1677311
     /* 1677311 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1677397), // Rule ID 6590 //
     /* 1677316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677362 */     // MIs[0] policy
     /* 1677362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677372 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677396 */     // GIR_Coverage, 6590,
     /* 1677396 */     GIR_EraseRootFromParent_Done,
     /* 1677397 */   // Label 23025: @1677397
     /* 1677397 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1677483), // Rule ID 6591 //
     /* 1677402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677448 */     // MIs[0] policy
     /* 1677448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677458 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1677461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677482 */     // GIR_Coverage, 6591,
     /* 1677482 */     GIR_EraseRootFromParent_Done,
     /* 1677483 */   // Label 23026: @1677483
     /* 1677483 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1677569), // Rule ID 6594 //
     /* 1677488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677534 */     // MIs[0] policy
     /* 1677534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677568 */     // GIR_Coverage, 6594,
     /* 1677568 */     GIR_EraseRootFromParent_Done,
     /* 1677569 */   // Label 23027: @1677569
     /* 1677569 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1677655), // Rule ID 6595 //
     /* 1677574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677620 */     // MIs[0] policy
     /* 1677620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677654 */     // GIR_Coverage, 6595,
     /* 1677654 */     GIR_EraseRootFromParent_Done,
     /* 1677655 */   // Label 23028: @1677655
     /* 1677655 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1677741), // Rule ID 6598 //
     /* 1677660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677706 */     // MIs[0] policy
     /* 1677706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677740 */     // GIR_Coverage, 6598,
     /* 1677740 */     GIR_EraseRootFromParent_Done,
     /* 1677741 */   // Label 23029: @1677741
     /* 1677741 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1677827), // Rule ID 6599 //
     /* 1677746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677792 */     // MIs[0] policy
     /* 1677792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677826 */     // GIR_Coverage, 6599,
     /* 1677826 */     GIR_EraseRootFromParent_Done,
     /* 1677827 */   // Label 23030: @1677827
     /* 1677827 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1677913), // Rule ID 6602 //
     /* 1677832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677878 */     // MIs[0] policy
     /* 1677878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677912 */     // GIR_Coverage, 6602,
     /* 1677912 */     GIR_EraseRootFromParent_Done,
     /* 1677913 */   // Label 23031: @1677913
     /* 1677913 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1677999), // Rule ID 6603 //
     /* 1677918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677964 */     // MIs[0] policy
     /* 1677964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677998 */     // GIR_Coverage, 6603,
     /* 1677998 */     GIR_EraseRootFromParent_Done,
     /* 1677999 */   // Label 23032: @1677999
     /* 1677999 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1678085), // Rule ID 6606 //
     /* 1678004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1678007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678050 */     // MIs[0] policy
     /* 1678050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678060 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1678063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678084 */     // GIR_Coverage, 6606,
     /* 1678084 */     GIR_EraseRootFromParent_Done,
     /* 1678085 */   // Label 23033: @1678085
     /* 1678085 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1678171), // Rule ID 6607 //
     /* 1678090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1678093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678136 */     // MIs[0] policy
     /* 1678136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1678149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678170 */     // GIR_Coverage, 6607,
     /* 1678170 */     GIR_EraseRootFromParent_Done,
     /* 1678171 */   // Label 23034: @1678171
     /* 1678171 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1678257), // Rule ID 6610 //
     /* 1678176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678222 */     // MIs[0] policy
     /* 1678222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678232 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678256 */     // GIR_Coverage, 6610,
     /* 1678256 */     GIR_EraseRootFromParent_Done,
     /* 1678257 */   // Label 23035: @1678257
     /* 1678257 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1678343), // Rule ID 6611 //
     /* 1678262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678308 */     // MIs[0] policy
     /* 1678308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678342 */     // GIR_Coverage, 6611,
     /* 1678342 */     GIR_EraseRootFromParent_Done,
     /* 1678343 */   // Label 23036: @1678343
     /* 1678343 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1678429), // Rule ID 6614 //
     /* 1678348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678394 */     // MIs[0] policy
     /* 1678394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678404 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678428 */     // GIR_Coverage, 6614,
     /* 1678428 */     GIR_EraseRootFromParent_Done,
     /* 1678429 */   // Label 23037: @1678429
     /* 1678429 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1678515), // Rule ID 6615 //
     /* 1678434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678480 */     // MIs[0] policy
     /* 1678480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678514 */     // GIR_Coverage, 6615,
     /* 1678514 */     GIR_EraseRootFromParent_Done,
     /* 1678515 */   // Label 23038: @1678515
     /* 1678515 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1678601), // Rule ID 6618 //
     /* 1678520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678566 */     // MIs[0] policy
     /* 1678566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678600 */     // GIR_Coverage, 6618,
     /* 1678600 */     GIR_EraseRootFromParent_Done,
     /* 1678601 */   // Label 23039: @1678601
     /* 1678601 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1678687), // Rule ID 6619 //
     /* 1678606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678652 */     // MIs[0] policy
     /* 1678652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678686 */     // GIR_Coverage, 6619,
     /* 1678686 */     GIR_EraseRootFromParent_Done,
     /* 1678687 */   // Label 23040: @1678687
     /* 1678687 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1678773), // Rule ID 6622 //
     /* 1678692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678738 */     // MIs[0] policy
     /* 1678738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678772 */     // GIR_Coverage, 6622,
     /* 1678772 */     GIR_EraseRootFromParent_Done,
     /* 1678773 */   // Label 23041: @1678773
     /* 1678773 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1678859), // Rule ID 6623 //
     /* 1678778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678824 */     // MIs[0] policy
     /* 1678824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678858 */     // GIR_Coverage, 6623,
     /* 1678858 */     GIR_EraseRootFromParent_Done,
     /* 1678859 */   // Label 23042: @1678859
     /* 1678859 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1678945), // Rule ID 6626 //
     /* 1678864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678910 */     // MIs[0] policy
     /* 1678910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678944 */     // GIR_Coverage, 6626,
     /* 1678944 */     GIR_EraseRootFromParent_Done,
     /* 1678945 */   // Label 23043: @1678945
     /* 1678945 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1679031), // Rule ID 6627 //
     /* 1678950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678996 */     // MIs[0] policy
     /* 1678996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679006 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679030 */     // GIR_Coverage, 6627,
     /* 1679030 */     GIR_EraseRootFromParent_Done,
     /* 1679031 */   // Label 23044: @1679031
     /* 1679031 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1679117), // Rule ID 6630 //
     /* 1679036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679082 */     // MIs[0] policy
     /* 1679082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679116 */     // GIR_Coverage, 6630,
     /* 1679116 */     GIR_EraseRootFromParent_Done,
     /* 1679117 */   // Label 23045: @1679117
     /* 1679117 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1679203), // Rule ID 6631 //
     /* 1679122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679168 */     // MIs[0] policy
     /* 1679168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679202 */     // GIR_Coverage, 6631,
     /* 1679202 */     GIR_EraseRootFromParent_Done,
     /* 1679203 */   // Label 23046: @1679203
     /* 1679203 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1679289), // Rule ID 6634 //
     /* 1679208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679254 */     // MIs[0] policy
     /* 1679254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679288 */     // GIR_Coverage, 6634,
     /* 1679288 */     GIR_EraseRootFromParent_Done,
     /* 1679289 */   // Label 23047: @1679289
     /* 1679289 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1679375), // Rule ID 6635 //
     /* 1679294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679340 */     // MIs[0] policy
     /* 1679340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679374 */     // GIR_Coverage, 6635,
     /* 1679374 */     GIR_EraseRootFromParent_Done,
     /* 1679375 */   // Label 23048: @1679375
     /* 1679375 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1679461), // Rule ID 6638 //
     /* 1679380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679426 */     // MIs[0] policy
     /* 1679426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679460 */     // GIR_Coverage, 6638,
     /* 1679460 */     GIR_EraseRootFromParent_Done,
     /* 1679461 */   // Label 23049: @1679461
     /* 1679461 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1679547), // Rule ID 6639 //
     /* 1679466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679512 */     // MIs[0] policy
     /* 1679512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679546 */     // GIR_Coverage, 6639,
     /* 1679546 */     GIR_EraseRootFromParent_Done,
     /* 1679547 */   // Label 23050: @1679547
     /* 1679547 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1679633), // Rule ID 6642 //
     /* 1679552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679598 */     // MIs[0] policy
     /* 1679598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679632 */     // GIR_Coverage, 6642,
     /* 1679632 */     GIR_EraseRootFromParent_Done,
     /* 1679633 */   // Label 23051: @1679633
     /* 1679633 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1679719), // Rule ID 6643 //
     /* 1679638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679684 */     // MIs[0] policy
     /* 1679684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679718 */     // GIR_Coverage, 6643,
     /* 1679718 */     GIR_EraseRootFromParent_Done,
     /* 1679719 */   // Label 23052: @1679719
     /* 1679719 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1679805), // Rule ID 6646 //
     /* 1679724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679770 */     // MIs[0] policy
     /* 1679770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679804 */     // GIR_Coverage, 6646,
     /* 1679804 */     GIR_EraseRootFromParent_Done,
     /* 1679805 */   // Label 23053: @1679805
     /* 1679805 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1679891), // Rule ID 6647 //
     /* 1679810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679856 */     // MIs[0] policy
     /* 1679856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679890 */     // GIR_Coverage, 6647,
     /* 1679890 */     GIR_EraseRootFromParent_Done,
     /* 1679891 */   // Label 23054: @1679891
     /* 1679891 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1679977), // Rule ID 6650 //
     /* 1679896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679942 */     // MIs[0] policy
     /* 1679942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679976 */     // GIR_Coverage, 6650,
     /* 1679976 */     GIR_EraseRootFromParent_Done,
     /* 1679977 */   // Label 23055: @1679977
     /* 1679977 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1680063), // Rule ID 6651 //
     /* 1679982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680028 */     // MIs[0] policy
     /* 1680028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1680041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680062 */     // GIR_Coverage, 6651,
     /* 1680062 */     GIR_EraseRootFromParent_Done,
     /* 1680063 */   // Label 23056: @1680063
     /* 1680063 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1680149), // Rule ID 6654 //
     /* 1680068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680114 */     // MIs[0] policy
     /* 1680114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1680127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680148 */     // GIR_Coverage, 6654,
     /* 1680148 */     GIR_EraseRootFromParent_Done,
     /* 1680149 */   // Label 23057: @1680149
     /* 1680149 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1680235), // Rule ID 6655 //
     /* 1680154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680200 */     // MIs[0] policy
     /* 1680200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680210 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1680213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680234 */     // GIR_Coverage, 6655,
     /* 1680234 */     GIR_EraseRootFromParent_Done,
     /* 1680235 */   // Label 23058: @1680235
     /* 1680235 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1680321), // Rule ID 6658 //
     /* 1680240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680286 */     // MIs[0] policy
     /* 1680286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1680299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680320 */     // GIR_Coverage, 6658,
     /* 1680320 */     GIR_EraseRootFromParent_Done,
     /* 1680321 */   // Label 23059: @1680321
     /* 1680321 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1680407), // Rule ID 6659 //
     /* 1680326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680372 */     // MIs[0] policy
     /* 1680372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1680385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680406 */     // GIR_Coverage, 6659,
     /* 1680406 */     GIR_EraseRootFromParent_Done,
     /* 1680407 */   // Label 23060: @1680407
     /* 1680407 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1680493), // Rule ID 6662 //
     /* 1680412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680458 */     // MIs[0] policy
     /* 1680458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680492 */     // GIR_Coverage, 6662,
     /* 1680492 */     GIR_EraseRootFromParent_Done,
     /* 1680493 */   // Label 23061: @1680493
     /* 1680493 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1680579), // Rule ID 6663 //
     /* 1680498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680544 */     // MIs[0] policy
     /* 1680544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680578 */     // GIR_Coverage, 6663,
     /* 1680578 */     GIR_EraseRootFromParent_Done,
     /* 1680579 */   // Label 23062: @1680579
     /* 1680579 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1680665), // Rule ID 6666 //
     /* 1680584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680630 */     // MIs[0] policy
     /* 1680630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680664 */     // GIR_Coverage, 6666,
     /* 1680664 */     GIR_EraseRootFromParent_Done,
     /* 1680665 */   // Label 23063: @1680665
     /* 1680665 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1680751), // Rule ID 6667 //
     /* 1680670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680716 */     // MIs[0] policy
     /* 1680716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680750 */     // GIR_Coverage, 6667,
     /* 1680750 */     GIR_EraseRootFromParent_Done,
     /* 1680751 */   // Label 23064: @1680751
     /* 1680751 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1680837), // Rule ID 6670 //
     /* 1680756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680802 */     // MIs[0] policy
     /* 1680802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680836 */     // GIR_Coverage, 6670,
     /* 1680836 */     GIR_EraseRootFromParent_Done,
     /* 1680837 */   // Label 23065: @1680837
     /* 1680837 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1680923), // Rule ID 6671 //
     /* 1680842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680888 */     // MIs[0] policy
     /* 1680888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680922 */     // GIR_Coverage, 6671,
     /* 1680922 */     GIR_EraseRootFromParent_Done,
     /* 1680923 */   // Label 23066: @1680923
     /* 1680923 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1681009), // Rule ID 6674 //
     /* 1680928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680974 */     // MIs[0] policy
     /* 1680974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681008 */     // GIR_Coverage, 6674,
     /* 1681008 */     GIR_EraseRootFromParent_Done,
     /* 1681009 */   // Label 23067: @1681009
     /* 1681009 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1681095), // Rule ID 6675 //
     /* 1681014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681060 */     // MIs[0] policy
     /* 1681060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681094 */     // GIR_Coverage, 6675,
     /* 1681094 */     GIR_EraseRootFromParent_Done,
     /* 1681095 */   // Label 23068: @1681095
     /* 1681095 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1681181), // Rule ID 6678 //
     /* 1681100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681146 */     // MIs[0] policy
     /* 1681146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681180 */     // GIR_Coverage, 6678,
     /* 1681180 */     GIR_EraseRootFromParent_Done,
     /* 1681181 */   // Label 23069: @1681181
     /* 1681181 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1681267), // Rule ID 6679 //
     /* 1681186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681232 */     // MIs[0] policy
     /* 1681232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1681245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681266 */     // GIR_Coverage, 6679,
     /* 1681266 */     GIR_EraseRootFromParent_Done,
     /* 1681267 */   // Label 23070: @1681267
     /* 1681267 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1681353), // Rule ID 6682 //
     /* 1681272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681318 */     // MIs[0] policy
     /* 1681318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681352 */     // GIR_Coverage, 6682,
     /* 1681352 */     GIR_EraseRootFromParent_Done,
     /* 1681353 */   // Label 23071: @1681353
     /* 1681353 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1681439), // Rule ID 6683 //
     /* 1681358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681404 */     // MIs[0] policy
     /* 1681404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11610:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681438 */     // GIR_Coverage, 6683,
     /* 1681438 */     GIR_EraseRootFromParent_Done,
     /* 1681439 */   // Label 23072: @1681439
     /* 1681439 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1681525), // Rule ID 6686 //
     /* 1681444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681490 */     // MIs[0] policy
     /* 1681490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681524 */     // GIR_Coverage, 6686,
     /* 1681524 */     GIR_EraseRootFromParent_Done,
     /* 1681525 */   // Label 23073: @1681525
     /* 1681525 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1681611), // Rule ID 6687 //
     /* 1681530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681576 */     // MIs[0] policy
     /* 1681576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681586 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681610 */     // GIR_Coverage, 6687,
     /* 1681610 */     GIR_EraseRootFromParent_Done,
     /* 1681611 */   // Label 23074: @1681611
     /* 1681611 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1681697), // Rule ID 6690 //
     /* 1681616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681662 */     // MIs[0] policy
     /* 1681662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681696 */     // GIR_Coverage, 6690,
     /* 1681696 */     GIR_EraseRootFromParent_Done,
     /* 1681697 */   // Label 23075: @1681697
     /* 1681697 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1681783), // Rule ID 6691 //
     /* 1681702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681748 */     // MIs[0] policy
     /* 1681748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681782 */     // GIR_Coverage, 6691,
     /* 1681782 */     GIR_EraseRootFromParent_Done,
     /* 1681783 */   // Label 23076: @1681783
     /* 1681783 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1681869), // Rule ID 6694 //
     /* 1681788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681834 */     // MIs[0] policy
     /* 1681834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681868 */     // GIR_Coverage, 6694,
     /* 1681868 */     GIR_EraseRootFromParent_Done,
     /* 1681869 */   // Label 23077: @1681869
     /* 1681869 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1681955), // Rule ID 6695 //
     /* 1681874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681920 */     // MIs[0] policy
     /* 1681920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681930 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681954 */     // GIR_Coverage, 6695,
     /* 1681954 */     GIR_EraseRootFromParent_Done,
     /* 1681955 */   // Label 23078: @1681955
     /* 1681955 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1682041), // Rule ID 6698 //
     /* 1681960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682006 */     // MIs[0] policy
     /* 1682006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682040 */     // GIR_Coverage, 6698,
     /* 1682040 */     GIR_EraseRootFromParent_Done,
     /* 1682041 */   // Label 23079: @1682041
     /* 1682041 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1682127), // Rule ID 6699 //
     /* 1682046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682092 */     // MIs[0] policy
     /* 1682092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682126 */     // GIR_Coverage, 6699,
     /* 1682126 */     GIR_EraseRootFromParent_Done,
     /* 1682127 */   // Label 23080: @1682127
     /* 1682127 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1682213), // Rule ID 6702 //
     /* 1682132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682178 */     // MIs[0] policy
     /* 1682178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682212 */     // GIR_Coverage, 6702,
     /* 1682212 */     GIR_EraseRootFromParent_Done,
     /* 1682213 */   // Label 23081: @1682213
     /* 1682213 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1682299), // Rule ID 6703 //
     /* 1682218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682264 */     // MIs[0] policy
     /* 1682264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682298 */     // GIR_Coverage, 6703,
     /* 1682298 */     GIR_EraseRootFromParent_Done,
     /* 1682299 */   // Label 23082: @1682299
     /* 1682299 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1682385), // Rule ID 6706 //
     /* 1682304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682350 */     // MIs[0] policy
     /* 1682350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682384 */     // GIR_Coverage, 6706,
     /* 1682384 */     GIR_EraseRootFromParent_Done,
     /* 1682385 */   // Label 23083: @1682385
     /* 1682385 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1682471), // Rule ID 6707 //
     /* 1682390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682436 */     // MIs[0] policy
     /* 1682436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682446 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682470 */     // GIR_Coverage, 6707,
     /* 1682470 */     GIR_EraseRootFromParent_Done,
     /* 1682471 */   // Label 23084: @1682471
     /* 1682471 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1682557), // Rule ID 6710 //
     /* 1682476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682522 */     // MIs[0] policy
     /* 1682522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682556 */     // GIR_Coverage, 6710,
     /* 1682556 */     GIR_EraseRootFromParent_Done,
     /* 1682557 */   // Label 23085: @1682557
     /* 1682557 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1682643), // Rule ID 6711 //
     /* 1682562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682608 */     // MIs[0] policy
     /* 1682608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682642 */     // GIR_Coverage, 6711,
     /* 1682642 */     GIR_EraseRootFromParent_Done,
     /* 1682643 */   // Label 23086: @1682643
     /* 1682643 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1682729), // Rule ID 6714 //
     /* 1682648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682694 */     // MIs[0] policy
     /* 1682694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682704 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682728 */     // GIR_Coverage, 6714,
     /* 1682728 */     GIR_EraseRootFromParent_Done,
     /* 1682729 */   // Label 23087: @1682729
     /* 1682729 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1682815), // Rule ID 6715 //
     /* 1682734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682780 */     // MIs[0] policy
     /* 1682780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682814 */     // GIR_Coverage, 6715,
     /* 1682814 */     GIR_EraseRootFromParent_Done,
     /* 1682815 */   // Label 23088: @1682815
     /* 1682815 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1682901), // Rule ID 6718 //
     /* 1682820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682866 */     // MIs[0] policy
     /* 1682866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682900 */     // GIR_Coverage, 6718,
     /* 1682900 */     GIR_EraseRootFromParent_Done,
     /* 1682901 */   // Label 23089: @1682901
     /* 1682901 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1682987), // Rule ID 6719 //
     /* 1682906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682952 */     // MIs[0] policy
     /* 1682952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682962 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682986 */     // GIR_Coverage, 6719,
     /* 1682986 */     GIR_EraseRootFromParent_Done,
     /* 1682987 */   // Label 23090: @1682987
     /* 1682987 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1683073), // Rule ID 6722 //
     /* 1682992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683038 */     // MIs[0] policy
     /* 1683038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683072 */     // GIR_Coverage, 6722,
     /* 1683072 */     GIR_EraseRootFromParent_Done,
     /* 1683073 */   // Label 23091: @1683073
     /* 1683073 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1683159), // Rule ID 6723 //
     /* 1683078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683124 */     // MIs[0] policy
     /* 1683124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683158 */     // GIR_Coverage, 6723,
     /* 1683158 */     GIR_EraseRootFromParent_Done,
     /* 1683159 */   // Label 23092: @1683159
     /* 1683159 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1683245), // Rule ID 6726 //
     /* 1683164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683210 */     // MIs[0] policy
     /* 1683210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683244 */     // GIR_Coverage, 6726,
     /* 1683244 */     GIR_EraseRootFromParent_Done,
     /* 1683245 */   // Label 23093: @1683245
     /* 1683245 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1683331), // Rule ID 6727 //
     /* 1683250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683296 */     // MIs[0] policy
     /* 1683296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683330 */     // GIR_Coverage, 6727,
     /* 1683330 */     GIR_EraseRootFromParent_Done,
     /* 1683331 */   // Label 23094: @1683331
     /* 1683331 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1683417), // Rule ID 6730 //
     /* 1683336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683382 */     // MIs[0] policy
     /* 1683382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683416 */     // GIR_Coverage, 6730,
     /* 1683416 */     GIR_EraseRootFromParent_Done,
     /* 1683417 */   // Label 23095: @1683417
     /* 1683417 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1683503), // Rule ID 6731 //
     /* 1683422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683468 */     // MIs[0] policy
     /* 1683468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683502 */     // GIR_Coverage, 6731,
     /* 1683502 */     GIR_EraseRootFromParent_Done,
     /* 1683503 */   // Label 23096: @1683503
     /* 1683503 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1683589), // Rule ID 6734 //
     /* 1683508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683554 */     // MIs[0] policy
     /* 1683554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683588 */     // GIR_Coverage, 6734,
     /* 1683588 */     GIR_EraseRootFromParent_Done,
     /* 1683589 */   // Label 23097: @1683589
     /* 1683589 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1683675), // Rule ID 6735 //
     /* 1683594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683640 */     // MIs[0] policy
     /* 1683640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683674 */     // GIR_Coverage, 6735,
     /* 1683674 */     GIR_EraseRootFromParent_Done,
     /* 1683675 */   // Label 23098: @1683675
     /* 1683675 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1683761), // Rule ID 6738 //
     /* 1683680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683726 */     // MIs[0] policy
     /* 1683726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683760 */     // GIR_Coverage, 6738,
     /* 1683760 */     GIR_EraseRootFromParent_Done,
     /* 1683761 */   // Label 23099: @1683761
     /* 1683761 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1683847), // Rule ID 6739 //
     /* 1683766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683812 */     // MIs[0] policy
     /* 1683812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683822 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683846 */     // GIR_Coverage, 6739,
     /* 1683846 */     GIR_EraseRootFromParent_Done,
     /* 1683847 */   // Label 23100: @1683847
     /* 1683847 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1683933), // Rule ID 6742 //
     /* 1683852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683898 */     // MIs[0] policy
     /* 1683898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683932 */     // GIR_Coverage, 6742,
     /* 1683932 */     GIR_EraseRootFromParent_Done,
     /* 1683933 */   // Label 23101: @1683933
     /* 1683933 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1684019), // Rule ID 6743 //
     /* 1683938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683984 */     // MIs[0] policy
     /* 1683984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684018 */     // GIR_Coverage, 6743,
     /* 1684018 */     GIR_EraseRootFromParent_Done,
     /* 1684019 */   // Label 23102: @1684019
     /* 1684019 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1684105), // Rule ID 6834 //
     /* 1684024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684070 */     // MIs[0] policy
     /* 1684070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1684083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684104 */     // GIR_Coverage, 6834,
     /* 1684104 */     GIR_EraseRootFromParent_Done,
     /* 1684105 */   // Label 23103: @1684105
     /* 1684105 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1684191), // Rule ID 6835 //
     /* 1684110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684156 */     // MIs[0] policy
     /* 1684156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1684169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684190 */     // GIR_Coverage, 6835,
     /* 1684190 */     GIR_EraseRootFromParent_Done,
     /* 1684191 */   // Label 23104: @1684191
     /* 1684191 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1684277), // Rule ID 6838 //
     /* 1684196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684242 */     // MIs[0] policy
     /* 1684242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684276 */     // GIR_Coverage, 6838,
     /* 1684276 */     GIR_EraseRootFromParent_Done,
     /* 1684277 */   // Label 23105: @1684277
     /* 1684277 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1684363), // Rule ID 6839 //
     /* 1684282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684328 */     // MIs[0] policy
     /* 1684328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684362 */     // GIR_Coverage, 6839,
     /* 1684362 */     GIR_EraseRootFromParent_Done,
     /* 1684363 */   // Label 23106: @1684363
     /* 1684363 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1684449), // Rule ID 6842 //
     /* 1684368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684414 */     // MIs[0] policy
     /* 1684414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684448 */     // GIR_Coverage, 6842,
     /* 1684448 */     GIR_EraseRootFromParent_Done,
     /* 1684449 */   // Label 23107: @1684449
     /* 1684449 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1684535), // Rule ID 6843 //
     /* 1684454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684500 */     // MIs[0] policy
     /* 1684500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684534 */     // GIR_Coverage, 6843,
     /* 1684534 */     GIR_EraseRootFromParent_Done,
     /* 1684535 */   // Label 23108: @1684535
     /* 1684535 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1684621), // Rule ID 6846 //
     /* 1684540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684586 */     // MIs[0] policy
     /* 1684586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684620 */     // GIR_Coverage, 6846,
     /* 1684620 */     GIR_EraseRootFromParent_Done,
     /* 1684621 */   // Label 23109: @1684621
     /* 1684621 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1684707), // Rule ID 6847 //
     /* 1684626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684672 */     // MIs[0] policy
     /* 1684672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684706 */     // GIR_Coverage, 6847,
     /* 1684706 */     GIR_EraseRootFromParent_Done,
     /* 1684707 */   // Label 23110: @1684707
     /* 1684707 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1684793), // Rule ID 6850 //
     /* 1684712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684758 */     // MIs[0] policy
     /* 1684758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684792 */     // GIR_Coverage, 6850,
     /* 1684792 */     GIR_EraseRootFromParent_Done,
     /* 1684793 */   // Label 23111: @1684793
     /* 1684793 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1684879), // Rule ID 6851 //
     /* 1684798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684844 */     // MIs[0] policy
     /* 1684844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684878 */     // GIR_Coverage, 6851,
     /* 1684878 */     GIR_EraseRootFromParent_Done,
     /* 1684879 */   // Label 23112: @1684879
     /* 1684879 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1684965), // Rule ID 6854 //
     /* 1684884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684930 */     // MIs[0] policy
     /* 1684930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684964 */     // GIR_Coverage, 6854,
     /* 1684964 */     GIR_EraseRootFromParent_Done,
     /* 1684965 */   // Label 23113: @1684965
     /* 1684965 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1685051), // Rule ID 6855 //
     /* 1684970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685016 */     // MIs[0] policy
     /* 1685016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1685029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685050 */     // GIR_Coverage, 6855,
     /* 1685050 */     GIR_EraseRootFromParent_Done,
     /* 1685051 */   // Label 23114: @1685051
     /* 1685051 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1685137), // Rule ID 6858 //
     /* 1685056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685102 */     // MIs[0] policy
     /* 1685102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685136 */     // GIR_Coverage, 6858,
     /* 1685136 */     GIR_EraseRootFromParent_Done,
     /* 1685137 */   // Label 23115: @1685137
     /* 1685137 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1685223), // Rule ID 6859 //
     /* 1685142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685188 */     // MIs[0] policy
     /* 1685188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685222 */     // GIR_Coverage, 6859,
     /* 1685222 */     GIR_EraseRootFromParent_Done,
     /* 1685223 */   // Label 23116: @1685223
     /* 1685223 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1685309), // Rule ID 6862 //
     /* 1685228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685274 */     // MIs[0] policy
     /* 1685274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685308 */     // GIR_Coverage, 6862,
     /* 1685308 */     GIR_EraseRootFromParent_Done,
     /* 1685309 */   // Label 23117: @1685309
     /* 1685309 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1685395), // Rule ID 6863 //
     /* 1685314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685360 */     // MIs[0] policy
     /* 1685360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685394 */     // GIR_Coverage, 6863,
     /* 1685394 */     GIR_EraseRootFromParent_Done,
     /* 1685395 */   // Label 23118: @1685395
     /* 1685395 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1685481), // Rule ID 6866 //
     /* 1685400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685446 */     // MIs[0] policy
     /* 1685446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685480 */     // GIR_Coverage, 6866,
     /* 1685480 */     GIR_EraseRootFromParent_Done,
     /* 1685481 */   // Label 23119: @1685481
     /* 1685481 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1685567), // Rule ID 6867 //
     /* 1685486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685532 */     // MIs[0] policy
     /* 1685532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685566 */     // GIR_Coverage, 6867,
     /* 1685566 */     GIR_EraseRootFromParent_Done,
     /* 1685567 */   // Label 23120: @1685567
     /* 1685567 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1685653), // Rule ID 6870 //
     /* 1685572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685618 */     // MIs[0] policy
     /* 1685618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685652 */     // GIR_Coverage, 6870,
     /* 1685652 */     GIR_EraseRootFromParent_Done,
     /* 1685653 */   // Label 23121: @1685653
     /* 1685653 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1685739), // Rule ID 6871 //
     /* 1685658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685704 */     // MIs[0] policy
     /* 1685704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685738 */     // GIR_Coverage, 6871,
     /* 1685738 */     GIR_EraseRootFromParent_Done,
     /* 1685739 */   // Label 23122: @1685739
     /* 1685739 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1685825), // Rule ID 6874 //
     /* 1685744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685790 */     // MIs[0] policy
     /* 1685790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685824 */     // GIR_Coverage, 6874,
     /* 1685824 */     GIR_EraseRootFromParent_Done,
     /* 1685825 */   // Label 23123: @1685825
     /* 1685825 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1685911), // Rule ID 6875 //
     /* 1685830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685876 */     // MIs[0] policy
     /* 1685876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685910 */     // GIR_Coverage, 6875,
     /* 1685910 */     GIR_EraseRootFromParent_Done,
     /* 1685911 */   // Label 23124: @1685911
     /* 1685911 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1685997), // Rule ID 6878 //
     /* 1685916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685962 */     // MIs[0] policy
     /* 1685962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685996 */     // GIR_Coverage, 6878,
     /* 1685996 */     GIR_EraseRootFromParent_Done,
     /* 1685997 */   // Label 23125: @1685997
     /* 1685997 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1686083), // Rule ID 6879 //
     /* 1686002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686048 */     // MIs[0] policy
     /* 1686048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686082 */     // GIR_Coverage, 6879,
     /* 1686082 */     GIR_EraseRootFromParent_Done,
     /* 1686083 */   // Label 23126: @1686083
     /* 1686083 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1686169), // Rule ID 6882 //
     /* 1686088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686134 */     // MIs[0] policy
     /* 1686134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686168 */     // GIR_Coverage, 6882,
     /* 1686168 */     GIR_EraseRootFromParent_Done,
     /* 1686169 */   // Label 23127: @1686169
     /* 1686169 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1686255), // Rule ID 6883 //
     /* 1686174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686220 */     // MIs[0] policy
     /* 1686220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686254 */     // GIR_Coverage, 6883,
     /* 1686254 */     GIR_EraseRootFromParent_Done,
     /* 1686255 */   // Label 23128: @1686255
     /* 1686255 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1686341), // Rule ID 6886 //
     /* 1686260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686306 */     // MIs[0] policy
     /* 1686306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686340 */     // GIR_Coverage, 6886,
     /* 1686340 */     GIR_EraseRootFromParent_Done,
     /* 1686341 */   // Label 23129: @1686341
     /* 1686341 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1686427), // Rule ID 6887 //
     /* 1686346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686392 */     // MIs[0] policy
     /* 1686392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686426 */     // GIR_Coverage, 6887,
     /* 1686426 */     GIR_EraseRootFromParent_Done,
     /* 1686427 */   // Label 23130: @1686427
     /* 1686427 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1686513), // Rule ID 6890 //
     /* 1686432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686478 */     // MIs[0] policy
     /* 1686478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686512 */     // GIR_Coverage, 6890,
     /* 1686512 */     GIR_EraseRootFromParent_Done,
     /* 1686513 */   // Label 23131: @1686513
     /* 1686513 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1686599), // Rule ID 6891 //
     /* 1686518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686564 */     // MIs[0] policy
     /* 1686564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686598 */     // GIR_Coverage, 6891,
     /* 1686598 */     GIR_EraseRootFromParent_Done,
     /* 1686599 */   // Label 23132: @1686599
     /* 1686599 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1686685), // Rule ID 6894 //
     /* 1686604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686650 */     // MIs[0] policy
     /* 1686650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686684 */     // GIR_Coverage, 6894,
     /* 1686684 */     GIR_EraseRootFromParent_Done,
     /* 1686685 */   // Label 23133: @1686685
     /* 1686685 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1686771), // Rule ID 6895 //
     /* 1686690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686736 */     // MIs[0] policy
     /* 1686736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686770 */     // GIR_Coverage, 6895,
     /* 1686770 */     GIR_EraseRootFromParent_Done,
     /* 1686771 */   // Label 23134: @1686771
     /* 1686771 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1686857), // Rule ID 6898 //
     /* 1686776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686822 */     // MIs[0] policy
     /* 1686822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686856 */     // GIR_Coverage, 6898,
     /* 1686856 */     GIR_EraseRootFromParent_Done,
     /* 1686857 */   // Label 23135: @1686857
     /* 1686857 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1686943), // Rule ID 6899 //
     /* 1686862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686908 */     // MIs[0] policy
     /* 1686908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686942 */     // GIR_Coverage, 6899,
     /* 1686942 */     GIR_EraseRootFromParent_Done,
     /* 1686943 */   // Label 23136: @1686943
     /* 1686943 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1687029), // Rule ID 6902 //
     /* 1686948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686994 */     // MIs[0] policy
     /* 1686994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687028 */     // GIR_Coverage, 6902,
     /* 1687028 */     GIR_EraseRootFromParent_Done,
     /* 1687029 */   // Label 23137: @1687029
     /* 1687029 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1687115), // Rule ID 6903 //
     /* 1687034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687080 */     // MIs[0] policy
     /* 1687080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687114 */     // GIR_Coverage, 6903,
     /* 1687114 */     GIR_EraseRootFromParent_Done,
     /* 1687115 */   // Label 23138: @1687115
     /* 1687115 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1687201), // Rule ID 6906 //
     /* 1687120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687166 */     // MIs[0] policy
     /* 1687166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687200 */     // GIR_Coverage, 6906,
     /* 1687200 */     GIR_EraseRootFromParent_Done,
     /* 1687201 */   // Label 23139: @1687201
     /* 1687201 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1687287), // Rule ID 6907 //
     /* 1687206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687252 */     // MIs[0] policy
     /* 1687252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687286 */     // GIR_Coverage, 6907,
     /* 1687286 */     GIR_EraseRootFromParent_Done,
     /* 1687287 */   // Label 23140: @1687287
     /* 1687287 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1687373), // Rule ID 6910 //
     /* 1687292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687338 */     // MIs[0] policy
     /* 1687338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1687351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687372 */     // GIR_Coverage, 6910,
     /* 1687372 */     GIR_EraseRootFromParent_Done,
     /* 1687373 */   // Label 23141: @1687373
     /* 1687373 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1687459), // Rule ID 6911 //
     /* 1687378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687424 */     // MIs[0] policy
     /* 1687424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1687437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687458 */     // GIR_Coverage, 6911,
     /* 1687458 */     GIR_EraseRootFromParent_Done,
     /* 1687459 */   // Label 23142: @1687459
     /* 1687459 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1687545), // Rule ID 6914 //
     /* 1687464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687510 */     // MIs[0] policy
     /* 1687510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687544 */     // GIR_Coverage, 6914,
     /* 1687544 */     GIR_EraseRootFromParent_Done,
     /* 1687545 */   // Label 23143: @1687545
     /* 1687545 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1687631), // Rule ID 6915 //
     /* 1687550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687596 */     // MIs[0] policy
     /* 1687596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687630 */     // GIR_Coverage, 6915,
     /* 1687630 */     GIR_EraseRootFromParent_Done,
     /* 1687631 */   // Label 23144: @1687631
     /* 1687631 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1687717), // Rule ID 6918 //
     /* 1687636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687682 */     // MIs[0] policy
     /* 1687682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687716 */     // GIR_Coverage, 6918,
     /* 1687716 */     GIR_EraseRootFromParent_Done,
     /* 1687717 */   // Label 23145: @1687717
     /* 1687717 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1687803), // Rule ID 6919 //
     /* 1687722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687768 */     // MIs[0] policy
     /* 1687768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687802 */     // GIR_Coverage, 6919,
     /* 1687802 */     GIR_EraseRootFromParent_Done,
     /* 1687803 */   // Label 23146: @1687803
     /* 1687803 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1687889), // Rule ID 6922 //
     /* 1687808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687854 */     // MIs[0] policy
     /* 1687854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687888 */     // GIR_Coverage, 6922,
     /* 1687888 */     GIR_EraseRootFromParent_Done,
     /* 1687889 */   // Label 23147: @1687889
     /* 1687889 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1687975), // Rule ID 6923 //
     /* 1687894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687940 */     // MIs[0] policy
     /* 1687940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687974 */     // GIR_Coverage, 6923,
     /* 1687974 */     GIR_EraseRootFromParent_Done,
     /* 1687975 */   // Label 23148: @1687975
     /* 1687975 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1688061), // Rule ID 6926 //
     /* 1687980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688026 */     // MIs[0] policy
     /* 1688026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688060 */     // GIR_Coverage, 6926,
     /* 1688060 */     GIR_EraseRootFromParent_Done,
     /* 1688061 */   // Label 23149: @1688061
     /* 1688061 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1688147), // Rule ID 6927 //
     /* 1688066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688112 */     // MIs[0] policy
     /* 1688112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688146 */     // GIR_Coverage, 6927,
     /* 1688146 */     GIR_EraseRootFromParent_Done,
     /* 1688147 */   // Label 23150: @1688147
     /* 1688147 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1688233), // Rule ID 6930 //
     /* 1688152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688198 */     // MIs[0] policy
     /* 1688198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688232 */     // GIR_Coverage, 6930,
     /* 1688232 */     GIR_EraseRootFromParent_Done,
     /* 1688233 */   // Label 23151: @1688233
     /* 1688233 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1688319), // Rule ID 6931 //
     /* 1688238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688284 */     // MIs[0] policy
     /* 1688284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688318 */     // GIR_Coverage, 6931,
     /* 1688318 */     GIR_EraseRootFromParent_Done,
     /* 1688319 */   // Label 23152: @1688319
     /* 1688319 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1688405), // Rule ID 6934 //
     /* 1688324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688370 */     // MIs[0] policy
     /* 1688370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688404 */     // GIR_Coverage, 6934,
     /* 1688404 */     GIR_EraseRootFromParent_Done,
     /* 1688405 */   // Label 23153: @1688405
     /* 1688405 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1688491), // Rule ID 6935 //
     /* 1688410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688456 */     // MIs[0] policy
     /* 1688456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688490 */     // GIR_Coverage, 6935,
     /* 1688490 */     GIR_EraseRootFromParent_Done,
     /* 1688491 */   // Label 23154: @1688491
     /* 1688491 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1688577), // Rule ID 6938 //
     /* 1688496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688542 */     // MIs[0] policy
     /* 1688542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688576 */     // GIR_Coverage, 6938,
     /* 1688576 */     GIR_EraseRootFromParent_Done,
     /* 1688577 */   // Label 23155: @1688577
     /* 1688577 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1688663), // Rule ID 6939 //
     /* 1688582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688628 */     // MIs[0] policy
     /* 1688628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688662 */     // GIR_Coverage, 6939,
     /* 1688662 */     GIR_EraseRootFromParent_Done,
     /* 1688663 */   // Label 23156: @1688663
     /* 1688663 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1688749), // Rule ID 6942 //
     /* 1688668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688714 */     // MIs[0] policy
     /* 1688714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688748 */     // GIR_Coverage, 6942,
     /* 1688748 */     GIR_EraseRootFromParent_Done,
     /* 1688749 */   // Label 23157: @1688749
     /* 1688749 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1688835), // Rule ID 6943 //
     /* 1688754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688800 */     // MIs[0] policy
     /* 1688800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688834 */     // GIR_Coverage, 6943,
     /* 1688834 */     GIR_EraseRootFromParent_Done,
     /* 1688835 */   // Label 23158: @1688835
     /* 1688835 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1688921), // Rule ID 6946 //
     /* 1688840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688886 */     // MIs[0] policy
     /* 1688886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688920 */     // GIR_Coverage, 6946,
     /* 1688920 */     GIR_EraseRootFromParent_Done,
     /* 1688921 */   // Label 23159: @1688921
     /* 1688921 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1689007), // Rule ID 6947 //
     /* 1688926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688972 */     // MIs[0] policy
     /* 1688972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11638:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689006 */     // GIR_Coverage, 6947,
     /* 1689006 */     GIR_EraseRootFromParent_Done,
     /* 1689007 */   // Label 23160: @1689007
     /* 1689007 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1689093), // Rule ID 6950 //
     /* 1689012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689058 */     // MIs[0] policy
     /* 1689058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689092 */     // GIR_Coverage, 6950,
     /* 1689092 */     GIR_EraseRootFromParent_Done,
     /* 1689093 */   // Label 23161: @1689093
     /* 1689093 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1689179), // Rule ID 6951 //
     /* 1689098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689144 */     // MIs[0] policy
     /* 1689144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11638:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689178 */     // GIR_Coverage, 6951,
     /* 1689178 */     GIR_EraseRootFromParent_Done,
     /* 1689179 */   // Label 23162: @1689179
     /* 1689179 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1689265), // Rule ID 6954 //
     /* 1689184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689230 */     // MIs[0] policy
     /* 1689230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689264 */     // GIR_Coverage, 6954,
     /* 1689264 */     GIR_EraseRootFromParent_Done,
     /* 1689265 */   // Label 23163: @1689265
     /* 1689265 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1689351), // Rule ID 6955 //
     /* 1689270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689316 */     // MIs[0] policy
     /* 1689316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11638:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689350 */     // GIR_Coverage, 6955,
     /* 1689350 */     GIR_EraseRootFromParent_Done,
     /* 1689351 */   // Label 23164: @1689351
     /* 1689351 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1689437), // Rule ID 6958 //
     /* 1689356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1689359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689402 */     // MIs[0] policy
     /* 1689402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689436 */     // GIR_Coverage, 6958,
     /* 1689436 */     GIR_EraseRootFromParent_Done,
     /* 1689437 */   // Label 23165: @1689437
     /* 1689437 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1689523), // Rule ID 6959 //
     /* 1689442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1689445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689488 */     // MIs[0] policy
     /* 1689488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11638:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689522 */     // GIR_Coverage, 6959,
     /* 1689522 */     GIR_EraseRootFromParent_Done,
     /* 1689523 */   // Label 23166: @1689523
     /* 1689523 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1689609), // Rule ID 6962 //
     /* 1689528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689574 */     // MIs[0] policy
     /* 1689574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689608 */     // GIR_Coverage, 6962,
     /* 1689608 */     GIR_EraseRootFromParent_Done,
     /* 1689609 */   // Label 23167: @1689609
     /* 1689609 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1689695), // Rule ID 6963 //
     /* 1689614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689660 */     // MIs[0] policy
     /* 1689660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689694 */     // GIR_Coverage, 6963,
     /* 1689694 */     GIR_EraseRootFromParent_Done,
     /* 1689695 */   // Label 23168: @1689695
     /* 1689695 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1689781), // Rule ID 6966 //
     /* 1689700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689746 */     // MIs[0] policy
     /* 1689746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689756 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689780 */     // GIR_Coverage, 6966,
     /* 1689780 */     GIR_EraseRootFromParent_Done,
     /* 1689781 */   // Label 23169: @1689781
     /* 1689781 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1689867), // Rule ID 6967 //
     /* 1689786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689832 */     // MIs[0] policy
     /* 1689832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689866 */     // GIR_Coverage, 6967,
     /* 1689866 */     GIR_EraseRootFromParent_Done,
     /* 1689867 */   // Label 23170: @1689867
     /* 1689867 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1689953), // Rule ID 6970 //
     /* 1689872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689918 */     // MIs[0] policy
     /* 1689918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689952 */     // GIR_Coverage, 6970,
     /* 1689952 */     GIR_EraseRootFromParent_Done,
     /* 1689953 */   // Label 23171: @1689953
     /* 1689953 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1690039), // Rule ID 6971 //
     /* 1689958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690004 */     // MIs[0] policy
     /* 1690004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690038 */     // GIR_Coverage, 6971,
     /* 1690038 */     GIR_EraseRootFromParent_Done,
     /* 1690039 */   // Label 23172: @1690039
     /* 1690039 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1690125), // Rule ID 6974 //
     /* 1690044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690090 */     // MIs[0] policy
     /* 1690090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690124 */     // GIR_Coverage, 6974,
     /* 1690124 */     GIR_EraseRootFromParent_Done,
     /* 1690125 */   // Label 23173: @1690125
     /* 1690125 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1690211), // Rule ID 6975 //
     /* 1690130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690176 */     // MIs[0] policy
     /* 1690176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690210 */     // GIR_Coverage, 6975,
     /* 1690210 */     GIR_EraseRootFromParent_Done,
     /* 1690211 */   // Label 23174: @1690211
     /* 1690211 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1690297), // Rule ID 6978 //
     /* 1690216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690262 */     // MIs[0] policy
     /* 1690262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690296 */     // GIR_Coverage, 6978,
     /* 1690296 */     GIR_EraseRootFromParent_Done,
     /* 1690297 */   // Label 23175: @1690297
     /* 1690297 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1690383), // Rule ID 6979 //
     /* 1690302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690348 */     // MIs[0] policy
     /* 1690348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690382 */     // GIR_Coverage, 6979,
     /* 1690382 */     GIR_EraseRootFromParent_Done,
     /* 1690383 */   // Label 23176: @1690383
     /* 1690383 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1690469), // Rule ID 6982 //
     /* 1690388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690434 */     // MIs[0] policy
     /* 1690434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690444 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690468 */     // GIR_Coverage, 6982,
     /* 1690468 */     GIR_EraseRootFromParent_Done,
     /* 1690469 */   // Label 23177: @1690469
     /* 1690469 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1690555), // Rule ID 6983 //
     /* 1690474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690520 */     // MIs[0] policy
     /* 1690520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690554 */     // GIR_Coverage, 6983,
     /* 1690554 */     GIR_EraseRootFromParent_Done,
     /* 1690555 */   // Label 23178: @1690555
     /* 1690555 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1690641), // Rule ID 6986 //
     /* 1690560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690606 */     // MIs[0] policy
     /* 1690606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690640 */     // GIR_Coverage, 6986,
     /* 1690640 */     GIR_EraseRootFromParent_Done,
     /* 1690641 */   // Label 23179: @1690641
     /* 1690641 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1690727), // Rule ID 6987 //
     /* 1690646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690692 */     // MIs[0] policy
     /* 1690692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690726 */     // GIR_Coverage, 6987,
     /* 1690726 */     GIR_EraseRootFromParent_Done,
     /* 1690727 */   // Label 23180: @1690727
     /* 1690727 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1690813), // Rule ID 6990 //
     /* 1690732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690778 */     // MIs[0] policy
     /* 1690778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690812 */     // GIR_Coverage, 6990,
     /* 1690812 */     GIR_EraseRootFromParent_Done,
     /* 1690813 */   // Label 23181: @1690813
     /* 1690813 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1690899), // Rule ID 6991 //
     /* 1690818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690864 */     // MIs[0] policy
     /* 1690864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690898 */     // GIR_Coverage, 6991,
     /* 1690898 */     GIR_EraseRootFromParent_Done,
     /* 1690899 */   // Label 23182: @1690899
     /* 1690899 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1690985), // Rule ID 6994 //
     /* 1690904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690950 */     // MIs[0] policy
     /* 1690950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690984 */     // GIR_Coverage, 6994,
     /* 1690984 */     GIR_EraseRootFromParent_Done,
     /* 1690985 */   // Label 23183: @1690985
     /* 1690985 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1691071), // Rule ID 6995 //
     /* 1690990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691036 */     // MIs[0] policy
     /* 1691036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691070 */     // GIR_Coverage, 6995,
     /* 1691070 */     GIR_EraseRootFromParent_Done,
     /* 1691071 */   // Label 23184: @1691071
     /* 1691071 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1691157), // Rule ID 6998 //
     /* 1691076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691122 */     // MIs[0] policy
     /* 1691122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1691135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691156 */     // GIR_Coverage, 6998,
     /* 1691156 */     GIR_EraseRootFromParent_Done,
     /* 1691157 */   // Label 23185: @1691157
     /* 1691157 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1691243), // Rule ID 6999 //
     /* 1691162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691208 */     // MIs[0] policy
     /* 1691208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11638:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1691221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691242 */     // GIR_Coverage, 6999,
     /* 1691242 */     GIR_EraseRootFromParent_Done,
     /* 1691243 */   // Label 23186: @1691243
     /* 1691243 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1691329), // Rule ID 7002 //
     /* 1691248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691294 */     // MIs[0] policy
     /* 1691294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1691307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691328 */     // GIR_Coverage, 7002,
     /* 1691328 */     GIR_EraseRootFromParent_Done,
     /* 1691329 */   // Label 23187: @1691329
     /* 1691329 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1691415), // Rule ID 7003 //
     /* 1691334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691380 */     // MIs[0] policy
     /* 1691380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11638:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1691393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691414 */     // GIR_Coverage, 7003,
     /* 1691414 */     GIR_EraseRootFromParent_Done,
     /* 1691415 */   // Label 23188: @1691415
     /* 1691415 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1691501), // Rule ID 7006 //
     /* 1691420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691466 */     // MIs[0] policy
     /* 1691466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691500 */     // GIR_Coverage, 7006,
     /* 1691500 */     GIR_EraseRootFromParent_Done,
     /* 1691501 */   // Label 23189: @1691501
     /* 1691501 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1691587), // Rule ID 7007 //
     /* 1691506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691552 */     // MIs[0] policy
     /* 1691552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11638:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691586 */     // GIR_Coverage, 7007,
     /* 1691586 */     GIR_EraseRootFromParent_Done,
     /* 1691587 */   // Label 23190: @1691587
     /* 1691587 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1691673), // Rule ID 7098 //
     /* 1691592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691638 */     // MIs[0] policy
     /* 1691638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691648 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691672 */     // GIR_Coverage, 7098,
     /* 1691672 */     GIR_EraseRootFromParent_Done,
     /* 1691673 */   // Label 23191: @1691673
     /* 1691673 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1691759), // Rule ID 7099 //
     /* 1691678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691724 */     // MIs[0] policy
     /* 1691724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691758 */     // GIR_Coverage, 7099,
     /* 1691758 */     GIR_EraseRootFromParent_Done,
     /* 1691759 */   // Label 23192: @1691759
     /* 1691759 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1691845), // Rule ID 7102 //
     /* 1691764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691810 */     // MIs[0] policy
     /* 1691810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691844 */     // GIR_Coverage, 7102,
     /* 1691844 */     GIR_EraseRootFromParent_Done,
     /* 1691845 */   // Label 23193: @1691845
     /* 1691845 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1691931), // Rule ID 7103 //
     /* 1691850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691896 */     // MIs[0] policy
     /* 1691896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691930 */     // GIR_Coverage, 7103,
     /* 1691930 */     GIR_EraseRootFromParent_Done,
     /* 1691931 */   // Label 23194: @1691931
     /* 1691931 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1692017), // Rule ID 7106 //
     /* 1691936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691982 */     // MIs[0] policy
     /* 1691982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691992 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692016 */     // GIR_Coverage, 7106,
     /* 1692016 */     GIR_EraseRootFromParent_Done,
     /* 1692017 */   // Label 23195: @1692017
     /* 1692017 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1692103), // Rule ID 7107 //
     /* 1692022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1692039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692068 */     // MIs[0] policy
     /* 1692068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692102 */     // GIR_Coverage, 7107,
     /* 1692102 */     GIR_EraseRootFromParent_Done,
     /* 1692103 */   // Label 23196: @1692103
     /* 1692103 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1692189), // Rule ID 7110 //
     /* 1692108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692154 */     // MIs[0] policy
     /* 1692154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1692167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692188 */     // GIR_Coverage, 7110,
     /* 1692188 */     GIR_EraseRootFromParent_Done,
     /* 1692189 */   // Label 23197: @1692189
     /* 1692189 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1692275), // Rule ID 7111 //
     /* 1692194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1692205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1692208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1692214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692240 */     // MIs[0] policy
     /* 1692240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1692253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692274 */     // GIR_Coverage, 7111,
     /* 1692274 */     GIR_EraseRootFromParent_Done,
     /* 1692275 */   // Label 23198: @1692275
     /* 1692275 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1692361), // Rule ID 7114 //
     /* 1692280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692326 */     // MIs[0] policy
     /* 1692326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692360 */     // GIR_Coverage, 7114,
     /* 1692360 */     GIR_EraseRootFromParent_Done,
     /* 1692361 */   // Label 23199: @1692361
     /* 1692361 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1692447), // Rule ID 7115 //
     /* 1692366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1692377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1692380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1692386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692412 */     // MIs[0] policy
     /* 1692412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692422 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692446 */     // GIR_Coverage, 7115,
     /* 1692446 */     GIR_EraseRootFromParent_Done,
     /* 1692447 */   // Label 23200: @1692447
     /* 1692447 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1692533), // Rule ID 7118 //
     /* 1692452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692498 */     // MIs[0] policy
     /* 1692498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692532 */     // GIR_Coverage, 7118,
     /* 1692532 */     GIR_EraseRootFromParent_Done,
     /* 1692533 */   // Label 23201: @1692533
     /* 1692533 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1692619), // Rule ID 7119 //
     /* 1692538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692584 */     // MIs[0] policy
     /* 1692584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692618 */     // GIR_Coverage, 7119,
     /* 1692618 */     GIR_EraseRootFromParent_Done,
     /* 1692619 */   // Label 23202: @1692619
     /* 1692619 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1692705), // Rule ID 7122 //
     /* 1692624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692670 */     // MIs[0] policy
     /* 1692670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692704 */     // GIR_Coverage, 7122,
     /* 1692704 */     GIR_EraseRootFromParent_Done,
     /* 1692705 */   // Label 23203: @1692705
     /* 1692705 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1692791), // Rule ID 7123 //
     /* 1692710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692756 */     // MIs[0] policy
     /* 1692756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692790 */     // GIR_Coverage, 7123,
     /* 1692790 */     GIR_EraseRootFromParent_Done,
     /* 1692791 */   // Label 23204: @1692791
     /* 1692791 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1692877), // Rule ID 7126 //
     /* 1692796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692842 */     // MIs[0] policy
     /* 1692842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692876 */     // GIR_Coverage, 7126,
     /* 1692876 */     GIR_EraseRootFromParent_Done,
     /* 1692877 */   // Label 23205: @1692877
     /* 1692877 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1692963), // Rule ID 7127 //
     /* 1692882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692928 */     // MIs[0] policy
     /* 1692928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692962 */     // GIR_Coverage, 7127,
     /* 1692962 */     GIR_EraseRootFromParent_Done,
     /* 1692963 */   // Label 23206: @1692963
     /* 1692963 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1693049), // Rule ID 7130 //
     /* 1692968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693014 */     // MIs[0] policy
     /* 1693014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693048 */     // GIR_Coverage, 7130,
     /* 1693048 */     GIR_EraseRootFromParent_Done,
     /* 1693049 */   // Label 23207: @1693049
     /* 1693049 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1693135), // Rule ID 7131 //
     /* 1693054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1693065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1693068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1693074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693100 */     // MIs[0] policy
     /* 1693100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693134 */     // GIR_Coverage, 7131,
     /* 1693134 */     GIR_EraseRootFromParent_Done,
     /* 1693135 */   // Label 23208: @1693135
     /* 1693135 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1693221), // Rule ID 7134 //
     /* 1693140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1693143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693186 */     // MIs[0] policy
     /* 1693186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693220 */     // GIR_Coverage, 7134,
     /* 1693220 */     GIR_EraseRootFromParent_Done,
     /* 1693221 */   // Label 23209: @1693221
     /* 1693221 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1693307), // Rule ID 7135 //
     /* 1693226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1693229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1693237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1693240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1693243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1693246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693272 */     // MIs[0] policy
     /* 1693272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1693285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1693303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693306 */     // GIR_Coverage, 7135,
     /* 1693306 */     GIR_EraseRootFromParent_Done,
     /* 1693307 */   // Label 23210: @1693307
     /* 1693307 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1693393), // Rule ID 7138 //
     /* 1693312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693358 */     // MIs[0] policy
     /* 1693358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693392 */     // GIR_Coverage, 7138,
     /* 1693392 */     GIR_EraseRootFromParent_Done,
     /* 1693393 */   // Label 23211: @1693393
     /* 1693393 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1693479), // Rule ID 7139 //
     /* 1693398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1693409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1693412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1693415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1693418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693444 */     // MIs[0] policy
     /* 1693444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693454 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693478 */     // GIR_Coverage, 7139,
     /* 1693478 */     GIR_EraseRootFromParent_Done,
     /* 1693479 */   // Label 23212: @1693479
     /* 1693479 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1693565), // Rule ID 7142 //
     /* 1693484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693530 */     // MIs[0] policy
     /* 1693530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693564 */     // GIR_Coverage, 7142,
     /* 1693564 */     GIR_EraseRootFromParent_Done,
     /* 1693565 */   // Label 23213: @1693565
     /* 1693565 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1693651), // Rule ID 7143 //
     /* 1693570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693616 */     // MIs[0] policy
     /* 1693616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693650 */     // GIR_Coverage, 7143,
     /* 1693650 */     GIR_EraseRootFromParent_Done,
     /* 1693651 */   // Label 23214: @1693651
     /* 1693651 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1693737), // Rule ID 7146 //
     /* 1693656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693702 */     // MIs[0] policy
     /* 1693702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693712 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693736 */     // GIR_Coverage, 7146,
     /* 1693736 */     GIR_EraseRootFromParent_Done,
     /* 1693737 */   // Label 23215: @1693737
     /* 1693737 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1693823), // Rule ID 7147 //
     /* 1693742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693788 */     // MIs[0] policy
     /* 1693788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693822 */     // GIR_Coverage, 7147,
     /* 1693822 */     GIR_EraseRootFromParent_Done,
     /* 1693823 */   // Label 23216: @1693823
     /* 1693823 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1693909), // Rule ID 7150 //
     /* 1693828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693874 */     // MIs[0] policy
     /* 1693874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693908 */     // GIR_Coverage, 7150,
     /* 1693908 */     GIR_EraseRootFromParent_Done,
     /* 1693909 */   // Label 23217: @1693909
     /* 1693909 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1693995), // Rule ID 7151 //
     /* 1693914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693960 */     // MIs[0] policy
     /* 1693960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693994 */     // GIR_Coverage, 7151,
     /* 1693994 */     GIR_EraseRootFromParent_Done,
     /* 1693995 */   // Label 23218: @1693995
     /* 1693995 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1694081), // Rule ID 7154 //
     /* 1694000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694046 */     // MIs[0] policy
     /* 1694046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694080 */     // GIR_Coverage, 7154,
     /* 1694080 */     GIR_EraseRootFromParent_Done,
     /* 1694081 */   // Label 23219: @1694081
     /* 1694081 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1694167), // Rule ID 7155 //
     /* 1694086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1694097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1694100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1694103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1694106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694132 */     // MIs[0] policy
     /* 1694132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694166 */     // GIR_Coverage, 7155,
     /* 1694166 */     GIR_EraseRootFromParent_Done,
     /* 1694167 */   // Label 23220: @1694167
     /* 1694167 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1694253), // Rule ID 7158 //
     /* 1694172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694218 */     // MIs[0] policy
     /* 1694218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694252 */     // GIR_Coverage, 7158,
     /* 1694252 */     GIR_EraseRootFromParent_Done,
     /* 1694253 */   // Label 23221: @1694253
     /* 1694253 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1694339), // Rule ID 7159 //
     /* 1694258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1694269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1694272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1694275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1694278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694304 */     // MIs[0] policy
     /* 1694304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694338 */     // GIR_Coverage, 7159,
     /* 1694338 */     GIR_EraseRootFromParent_Done,
     /* 1694339 */   // Label 23222: @1694339
     /* 1694339 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1694425), // Rule ID 7162 //
     /* 1694344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694390 */     // MIs[0] policy
     /* 1694390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694424 */     // GIR_Coverage, 7162,
     /* 1694424 */     GIR_EraseRootFromParent_Done,
     /* 1694425 */   // Label 23223: @1694425
     /* 1694425 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1694511), // Rule ID 7163 //
     /* 1694430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1694447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694476 */     // MIs[0] policy
     /* 1694476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694510 */     // GIR_Coverage, 7163,
     /* 1694510 */     GIR_EraseRootFromParent_Done,
     /* 1694511 */   // Label 23224: @1694511
     /* 1694511 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1694597), // Rule ID 7166 //
     /* 1694516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694562 */     // MIs[0] policy
     /* 1694562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694596 */     // GIR_Coverage, 7166,
     /* 1694596 */     GIR_EraseRootFromParent_Done,
     /* 1694597 */   // Label 23225: @1694597
     /* 1694597 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1694683), // Rule ID 7167 //
     /* 1694602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694648 */     // MIs[0] policy
     /* 1694648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694682 */     // GIR_Coverage, 7167,
     /* 1694682 */     GIR_EraseRootFromParent_Done,
     /* 1694683 */   // Label 23226: @1694683
     /* 1694683 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1694769), // Rule ID 7170 //
     /* 1694688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694734 */     // MIs[0] policy
     /* 1694734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694768 */     // GIR_Coverage, 7170,
     /* 1694768 */     GIR_EraseRootFromParent_Done,
     /* 1694769 */   // Label 23227: @1694769
     /* 1694769 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1694855), // Rule ID 7171 //
     /* 1694774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694820 */     // MIs[0] policy
     /* 1694820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694854 */     // GIR_Coverage, 7171,
     /* 1694854 */     GIR_EraseRootFromParent_Done,
     /* 1694855 */   // Label 23228: @1694855
     /* 1694855 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1694941), // Rule ID 7174 //
     /* 1694860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694906 */     // MIs[0] policy
     /* 1694906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694940 */     // GIR_Coverage, 7174,
     /* 1694940 */     GIR_EraseRootFromParent_Done,
     /* 1694941 */   // Label 23229: @1694941
     /* 1694941 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1695027), // Rule ID 7175 //
     /* 1694946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694992 */     // MIs[0] policy
     /* 1694992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1695005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695026 */     // GIR_Coverage, 7175,
     /* 1695026 */     GIR_EraseRootFromParent_Done,
     /* 1695027 */   // Label 23230: @1695027
     /* 1695027 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1695113), // Rule ID 7178 //
     /* 1695032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695078 */     // MIs[0] policy
     /* 1695078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695088 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1695091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695112 */     // GIR_Coverage, 7178,
     /* 1695112 */     GIR_EraseRootFromParent_Done,
     /* 1695113 */   // Label 23231: @1695113
     /* 1695113 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1695199), // Rule ID 7179 //
     /* 1695118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1695129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1695132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1695135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1695138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695164 */     // MIs[0] policy
     /* 1695164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1695177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695198 */     // GIR_Coverage, 7179,
     /* 1695198 */     GIR_EraseRootFromParent_Done,
     /* 1695199 */   // Label 23232: @1695199
     /* 1695199 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1695285), // Rule ID 7182 //
     /* 1695204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695250 */     // MIs[0] policy
     /* 1695250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695260 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1695263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695284 */     // GIR_Coverage, 7182,
     /* 1695284 */     GIR_EraseRootFromParent_Done,
     /* 1695285 */   // Label 23233: @1695285
     /* 1695285 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1695371), // Rule ID 7183 //
     /* 1695290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1695293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1695301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1695304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1695307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1695310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695336 */     // MIs[0] policy
     /* 1695336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1695349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1695367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695370 */     // GIR_Coverage, 7183,
     /* 1695370 */     GIR_EraseRootFromParent_Done,
     /* 1695371 */   // Label 23234: @1695371
     /* 1695371 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1695457), // Rule ID 7186 //
     /* 1695376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695422 */     // MIs[0] policy
     /* 1695422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695456 */     // GIR_Coverage, 7186,
     /* 1695456 */     GIR_EraseRootFromParent_Done,
     /* 1695457 */   // Label 23235: @1695457
     /* 1695457 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1695543), // Rule ID 7187 //
     /* 1695462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695508 */     // MIs[0] policy
     /* 1695508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695542 */     // GIR_Coverage, 7187,
     /* 1695542 */     GIR_EraseRootFromParent_Done,
     /* 1695543 */   // Label 23236: @1695543
     /* 1695543 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1695629), // Rule ID 7190 //
     /* 1695548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695594 */     // MIs[0] policy
     /* 1695594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695628 */     // GIR_Coverage, 7190,
     /* 1695628 */     GIR_EraseRootFromParent_Done,
     /* 1695629 */   // Label 23237: @1695629
     /* 1695629 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1695715), // Rule ID 7191 //
     /* 1695634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695680 */     // MIs[0] policy
     /* 1695680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695714 */     // GIR_Coverage, 7191,
     /* 1695714 */     GIR_EraseRootFromParent_Done,
     /* 1695715 */   // Label 23238: @1695715
     /* 1695715 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1695801), // Rule ID 7194 //
     /* 1695720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695766 */     // MIs[0] policy
     /* 1695766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695800 */     // GIR_Coverage, 7194,
     /* 1695800 */     GIR_EraseRootFromParent_Done,
     /* 1695801 */   // Label 23239: @1695801
     /* 1695801 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1695887), // Rule ID 7195 //
     /* 1695806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695852 */     // MIs[0] policy
     /* 1695852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695862 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695886 */     // GIR_Coverage, 7195,
     /* 1695886 */     GIR_EraseRootFromParent_Done,
     /* 1695887 */   // Label 23240: @1695887
     /* 1695887 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1695973), // Rule ID 7198 //
     /* 1695892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695938 */     // MIs[0] policy
     /* 1695938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695972 */     // GIR_Coverage, 7198,
     /* 1695972 */     GIR_EraseRootFromParent_Done,
     /* 1695973 */   // Label 23241: @1695973
     /* 1695973 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1696059), // Rule ID 7199 //
     /* 1695978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696024 */     // MIs[0] policy
     /* 1696024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1696037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696058 */     // GIR_Coverage, 7199,
     /* 1696058 */     GIR_EraseRootFromParent_Done,
     /* 1696059 */   // Label 23242: @1696059
     /* 1696059 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1696145), // Rule ID 7202 //
     /* 1696064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696110 */     // MIs[0] policy
     /* 1696110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696144 */     // GIR_Coverage, 7202,
     /* 1696144 */     GIR_EraseRootFromParent_Done,
     /* 1696145 */   // Label 23243: @1696145
     /* 1696145 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1696231), // Rule ID 7203 //
     /* 1696150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1696161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1696164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696196 */     // MIs[0] policy
     /* 1696196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696230 */     // GIR_Coverage, 7203,
     /* 1696230 */     GIR_EraseRootFromParent_Done,
     /* 1696231 */   // Label 23244: @1696231
     /* 1696231 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1696317), // Rule ID 7206 //
     /* 1696236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696282 */     // MIs[0] policy
     /* 1696282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696316 */     // GIR_Coverage, 7206,
     /* 1696316 */     GIR_EraseRootFromParent_Done,
     /* 1696317 */   // Label 23245: @1696317
     /* 1696317 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1696403), // Rule ID 7207 //
     /* 1696322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1696339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696368 */     // MIs[0] policy
     /* 1696368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1696381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696402 */     // GIR_Coverage, 7207,
     /* 1696402 */     GIR_EraseRootFromParent_Done,
     /* 1696403 */   // Label 23246: @1696403
     /* 1696403 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1696489), // Rule ID 7210 //
     /* 1696408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696454 */     // MIs[0] policy
     /* 1696454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696488 */     // GIR_Coverage, 7210,
     /* 1696488 */     GIR_EraseRootFromParent_Done,
     /* 1696489 */   // Label 23247: @1696489
     /* 1696489 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1696575), // Rule ID 7211 //
     /* 1696494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696540 */     // MIs[0] policy
     /* 1696540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11636:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696574 */     // GIR_Coverage, 7211,
     /* 1696574 */     GIR_EraseRootFromParent_Done,
     /* 1696575 */   // Label 23248: @1696575
     /* 1696575 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1696661), // Rule ID 7214 //
     /* 1696580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696626 */     // MIs[0] policy
     /* 1696626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696660 */     // GIR_Coverage, 7214,
     /* 1696660 */     GIR_EraseRootFromParent_Done,
     /* 1696661 */   // Label 23249: @1696661
     /* 1696661 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1696747), // Rule ID 7215 //
     /* 1696666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696712 */     // MIs[0] policy
     /* 1696712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11636:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696746 */     // GIR_Coverage, 7215,
     /* 1696746 */     GIR_EraseRootFromParent_Done,
     /* 1696747 */   // Label 23250: @1696747
     /* 1696747 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1696833), // Rule ID 7218 //
     /* 1696752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696798 */     // MIs[0] policy
     /* 1696798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696832 */     // GIR_Coverage, 7218,
     /* 1696832 */     GIR_EraseRootFromParent_Done,
     /* 1696833 */   // Label 23251: @1696833
     /* 1696833 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1696919), // Rule ID 7219 //
     /* 1696838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696884 */     // MIs[0] policy
     /* 1696884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11636:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696918 */     // GIR_Coverage, 7219,
     /* 1696918 */     GIR_EraseRootFromParent_Done,
     /* 1696919 */   // Label 23252: @1696919
     /* 1696919 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1697005), // Rule ID 7222 //
     /* 1696924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696970 */     // MIs[0] policy
     /* 1696970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697004 */     // GIR_Coverage, 7222,
     /* 1697004 */     GIR_EraseRootFromParent_Done,
     /* 1697005 */   // Label 23253: @1697005
     /* 1697005 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1697091), // Rule ID 7223 //
     /* 1697010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1697013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1697021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1697024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1697027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697056 */     // MIs[0] policy
     /* 1697056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11636:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1697069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1697087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697090 */     // GIR_Coverage, 7223,
     /* 1697090 */     GIR_EraseRootFromParent_Done,
     /* 1697091 */   // Label 23254: @1697091
     /* 1697091 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1697177), // Rule ID 7226 //
     /* 1697096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697142 */     // MIs[0] policy
     /* 1697142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697176 */     // GIR_Coverage, 7226,
     /* 1697176 */     GIR_EraseRootFromParent_Done,
     /* 1697177 */   // Label 23255: @1697177
     /* 1697177 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1697263), // Rule ID 7227 //
     /* 1697182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1697199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697228 */     // MIs[0] policy
     /* 1697228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697238 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697262 */     // GIR_Coverage, 7227,
     /* 1697262 */     GIR_EraseRootFromParent_Done,
     /* 1697263 */   // Label 23256: @1697263
     /* 1697263 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1697349), // Rule ID 7230 //
     /* 1697268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697314 */     // MIs[0] policy
     /* 1697314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697324 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697348 */     // GIR_Coverage, 7230,
     /* 1697348 */     GIR_EraseRootFromParent_Done,
     /* 1697349 */   // Label 23257: @1697349
     /* 1697349 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1697435), // Rule ID 7231 //
     /* 1697354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1697371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697400 */     // MIs[0] policy
     /* 1697400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697434 */     // GIR_Coverage, 7231,
     /* 1697434 */     GIR_EraseRootFromParent_Done,
     /* 1697435 */   // Label 23258: @1697435
     /* 1697435 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1697521), // Rule ID 7234 //
     /* 1697440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697486 */     // MIs[0] policy
     /* 1697486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697520 */     // GIR_Coverage, 7234,
     /* 1697520 */     GIR_EraseRootFromParent_Done,
     /* 1697521 */   // Label 23259: @1697521
     /* 1697521 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1697607), // Rule ID 7235 //
     /* 1697526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697572 */     // MIs[0] policy
     /* 1697572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697606 */     // GIR_Coverage, 7235,
     /* 1697606 */     GIR_EraseRootFromParent_Done,
     /* 1697607 */   // Label 23260: @1697607
     /* 1697607 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1697693), // Rule ID 7238 //
     /* 1697612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697658 */     // MIs[0] policy
     /* 1697658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697692 */     // GIR_Coverage, 7238,
     /* 1697692 */     GIR_EraseRootFromParent_Done,
     /* 1697693 */   // Label 23261: @1697693
     /* 1697693 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1697779), // Rule ID 7239 //
     /* 1697698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697744 */     // MIs[0] policy
     /* 1697744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697778 */     // GIR_Coverage, 7239,
     /* 1697778 */     GIR_EraseRootFromParent_Done,
     /* 1697779 */   // Label 23262: @1697779
     /* 1697779 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1697865), // Rule ID 7242 //
     /* 1697784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697830 */     // MIs[0] policy
     /* 1697830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697864 */     // GIR_Coverage, 7242,
     /* 1697864 */     GIR_EraseRootFromParent_Done,
     /* 1697865 */   // Label 23263: @1697865
     /* 1697865 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1697951), // Rule ID 7243 //
     /* 1697870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697916 */     // MIs[0] policy
     /* 1697916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697950 */     // GIR_Coverage, 7243,
     /* 1697950 */     GIR_EraseRootFromParent_Done,
     /* 1697951 */   // Label 23264: @1697951
     /* 1697951 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1698037), // Rule ID 7246 //
     /* 1697956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698002 */     // MIs[0] policy
     /* 1698002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698012 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698036 */     // GIR_Coverage, 7246,
     /* 1698036 */     GIR_EraseRootFromParent_Done,
     /* 1698037 */   // Label 23265: @1698037
     /* 1698037 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1698123), // Rule ID 7247 //
     /* 1698042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1698053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1698056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698088 */     // MIs[0] policy
     /* 1698088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698122 */     // GIR_Coverage, 7247,
     /* 1698122 */     GIR_EraseRootFromParent_Done,
     /* 1698123 */   // Label 23266: @1698123
     /* 1698123 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1698209), // Rule ID 7250 //
     /* 1698128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698174 */     // MIs[0] policy
     /* 1698174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698208 */     // GIR_Coverage, 7250,
     /* 1698208 */     GIR_EraseRootFromParent_Done,
     /* 1698209 */   // Label 23267: @1698209
     /* 1698209 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1698295), // Rule ID 7251 //
     /* 1698214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698260 */     // MIs[0] policy
     /* 1698260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698294 */     // GIR_Coverage, 7251,
     /* 1698294 */     GIR_EraseRootFromParent_Done,
     /* 1698295 */   // Label 23268: @1698295
     /* 1698295 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1698381), // Rule ID 7254 //
     /* 1698300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698346 */     // MIs[0] policy
     /* 1698346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698380 */     // GIR_Coverage, 7254,
     /* 1698380 */     GIR_EraseRootFromParent_Done,
     /* 1698381 */   // Label 23269: @1698381
     /* 1698381 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1698467), // Rule ID 7255 //
     /* 1698386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698432 */     // MIs[0] policy
     /* 1698432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698466 */     // GIR_Coverage, 7255,
     /* 1698466 */     GIR_EraseRootFromParent_Done,
     /* 1698467 */   // Label 23270: @1698467
     /* 1698467 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1698553), // Rule ID 7258 //
     /* 1698472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698518 */     // MIs[0] policy
     /* 1698518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698552 */     // GIR_Coverage, 7258,
     /* 1698552 */     GIR_EraseRootFromParent_Done,
     /* 1698553 */   // Label 23271: @1698553
     /* 1698553 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1698639), // Rule ID 7259 //
     /* 1698558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698604 */     // MIs[0] policy
     /* 1698604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698638 */     // GIR_Coverage, 7259,
     /* 1698638 */     GIR_EraseRootFromParent_Done,
     /* 1698639 */   // Label 23272: @1698639
     /* 1698639 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1698725), // Rule ID 7262 //
     /* 1698644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698690 */     // MIs[0] policy
     /* 1698690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698724 */     // GIR_Coverage, 7262,
     /* 1698724 */     GIR_EraseRootFromParent_Done,
     /* 1698725 */   // Label 23273: @1698725
     /* 1698725 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1698811), // Rule ID 7263 //
     /* 1698730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698776 */     // MIs[0] policy
     /* 1698776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11636:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698810 */     // GIR_Coverage, 7263,
     /* 1698810 */     GIR_EraseRootFromParent_Done,
     /* 1698811 */   // Label 23274: @1698811
     /* 1698811 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1698897), // Rule ID 7266 //
     /* 1698816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698862 */     // MIs[0] policy
     /* 1698862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698896 */     // GIR_Coverage, 7266,
     /* 1698896 */     GIR_EraseRootFromParent_Done,
     /* 1698897 */   // Label 23275: @1698897
     /* 1698897 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1698983), // Rule ID 7267 //
     /* 1698902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698948 */     // MIs[0] policy
     /* 1698948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11636:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698982 */     // GIR_Coverage, 7267,
     /* 1698982 */     GIR_EraseRootFromParent_Done,
     /* 1698983 */   // Label 23276: @1698983
     /* 1698983 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1699069), // Rule ID 7270 //
     /* 1698988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699034 */     // MIs[0] policy
     /* 1699034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1699047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699068 */     // GIR_Coverage, 7270,
     /* 1699068 */     GIR_EraseRootFromParent_Done,
     /* 1699069 */   // Label 23277: @1699069
     /* 1699069 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1699155), // Rule ID 7271 //
     /* 1699074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1699077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1699082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1699085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1699088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1699104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699120 */     // MIs[0] policy
     /* 1699120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11636:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1699133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1699151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699154 */     // GIR_Coverage, 7271,
     /* 1699154 */     GIR_EraseRootFromParent_Done,
     /* 1699155 */   // Label 23278: @1699155
     /* 1699155 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1699241), // Rule ID 7450 //
     /* 1699160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699206 */     // MIs[0] policy
     /* 1699206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699216 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1699219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699240 */     // GIR_Coverage, 7450,
     /* 1699240 */     GIR_EraseRootFromParent_Done,
     /* 1699241 */   // Label 23279: @1699241
     /* 1699241 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1699327), // Rule ID 7451 //
     /* 1699246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1699266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699292 */     // MIs[0] policy
     /* 1699292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1699305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699326 */     // GIR_Coverage, 7451,
     /* 1699326 */     GIR_EraseRootFromParent_Done,
     /* 1699327 */   // Label 23280: @1699327
     /* 1699327 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1699413), // Rule ID 7454 //
     /* 1699332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699378 */     // MIs[0] policy
     /* 1699378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699412 */     // GIR_Coverage, 7454,
     /* 1699412 */     GIR_EraseRootFromParent_Done,
     /* 1699413 */   // Label 23281: @1699413
     /* 1699413 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1699499), // Rule ID 7455 //
     /* 1699418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1699438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699464 */     // MIs[0] policy
     /* 1699464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699474 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699498 */     // GIR_Coverage, 7455,
     /* 1699498 */     GIR_EraseRootFromParent_Done,
     /* 1699499 */   // Label 23282: @1699499
     /* 1699499 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1699585), // Rule ID 7458 //
     /* 1699504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699550 */     // MIs[0] policy
     /* 1699550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699584 */     // GIR_Coverage, 7458,
     /* 1699584 */     GIR_EraseRootFromParent_Done,
     /* 1699585 */   // Label 23283: @1699585
     /* 1699585 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1699671), // Rule ID 7459 //
     /* 1699590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699636 */     // MIs[0] policy
     /* 1699636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699670 */     // GIR_Coverage, 7459,
     /* 1699670 */     GIR_EraseRootFromParent_Done,
     /* 1699671 */   // Label 23284: @1699671
     /* 1699671 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1699757), // Rule ID 7462 //
     /* 1699676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699722 */     // MIs[0] policy
     /* 1699722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699756 */     // GIR_Coverage, 7462,
     /* 1699756 */     GIR_EraseRootFromParent_Done,
     /* 1699757 */   // Label 23285: @1699757
     /* 1699757 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1699843), // Rule ID 7463 //
     /* 1699762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699808 */     // MIs[0] policy
     /* 1699808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699842 */     // GIR_Coverage, 7463,
     /* 1699842 */     GIR_EraseRootFromParent_Done,
     /* 1699843 */   // Label 23286: @1699843
     /* 1699843 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1699929), // Rule ID 7466 //
     /* 1699848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699894 */     // MIs[0] policy
     /* 1699894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699928 */     // GIR_Coverage, 7466,
     /* 1699928 */     GIR_EraseRootFromParent_Done,
     /* 1699929 */   // Label 23287: @1699929
     /* 1699929 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1700015), // Rule ID 7467 //
     /* 1699934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699980 */     // MIs[0] policy
     /* 1699980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700014 */     // GIR_Coverage, 7467,
     /* 1700014 */     GIR_EraseRootFromParent_Done,
     /* 1700015 */   // Label 23288: @1700015
     /* 1700015 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1700101), // Rule ID 7470 //
     /* 1700020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700066 */     // MIs[0] policy
     /* 1700066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700100 */     // GIR_Coverage, 7470,
     /* 1700100 */     GIR_EraseRootFromParent_Done,
     /* 1700101 */   // Label 23289: @1700101
     /* 1700101 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1700187), // Rule ID 7471 //
     /* 1700106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1700126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700152 */     // MIs[0] policy
     /* 1700152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700186 */     // GIR_Coverage, 7471,
     /* 1700186 */     GIR_EraseRootFromParent_Done,
     /* 1700187 */   // Label 23290: @1700187
     /* 1700187 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1700273), // Rule ID 7474 //
     /* 1700192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700238 */     // MIs[0] policy
     /* 1700238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1700251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700272 */     // GIR_Coverage, 7474,
     /* 1700272 */     GIR_EraseRootFromParent_Done,
     /* 1700273 */   // Label 23291: @1700273
     /* 1700273 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1700359), // Rule ID 7475 //
     /* 1700278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1700298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700324 */     // MIs[0] policy
     /* 1700324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1700337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700358 */     // GIR_Coverage, 7475,
     /* 1700358 */     GIR_EraseRootFromParent_Done,
     /* 1700359 */   // Label 23292: @1700359
     /* 1700359 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1700445), // Rule ID 7478 //
     /* 1700364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700410 */     // MIs[0] policy
     /* 1700410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700444 */     // GIR_Coverage, 7478,
     /* 1700444 */     GIR_EraseRootFromParent_Done,
     /* 1700445 */   // Label 23293: @1700445
     /* 1700445 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1700531), // Rule ID 7479 //
     /* 1700450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700496 */     // MIs[0] policy
     /* 1700496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700530 */     // GIR_Coverage, 7479,
     /* 1700530 */     GIR_EraseRootFromParent_Done,
     /* 1700531 */   // Label 23294: @1700531
     /* 1700531 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1700617), // Rule ID 7482 //
     /* 1700536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700582 */     // MIs[0] policy
     /* 1700582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700616 */     // GIR_Coverage, 7482,
     /* 1700616 */     GIR_EraseRootFromParent_Done,
     /* 1700617 */   // Label 23295: @1700617
     /* 1700617 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1700703), // Rule ID 7483 //
     /* 1700622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700668 */     // MIs[0] policy
     /* 1700668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700678 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700702 */     // GIR_Coverage, 7483,
     /* 1700702 */     GIR_EraseRootFromParent_Done,
     /* 1700703 */   // Label 23296: @1700703
     /* 1700703 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1700789), // Rule ID 7486 //
     /* 1700708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700754 */     // MIs[0] policy
     /* 1700754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700788 */     // GIR_Coverage, 7486,
     /* 1700788 */     GIR_EraseRootFromParent_Done,
     /* 1700789 */   // Label 23297: @1700789
     /* 1700789 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1700875), // Rule ID 7487 //
     /* 1700794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700840 */     // MIs[0] policy
     /* 1700840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700874 */     // GIR_Coverage, 7487,
     /* 1700874 */     GIR_EraseRootFromParent_Done,
     /* 1700875 */   // Label 23298: @1700875
     /* 1700875 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1700961), // Rule ID 7490 //
     /* 1700880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700926 */     // MIs[0] policy
     /* 1700926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700960 */     // GIR_Coverage, 7490,
     /* 1700960 */     GIR_EraseRootFromParent_Done,
     /* 1700961 */   // Label 23299: @1700961
     /* 1700961 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1701047), // Rule ID 7491 //
     /* 1700966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701012 */     // MIs[0] policy
     /* 1701012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701046 */     // GIR_Coverage, 7491,
     /* 1701046 */     GIR_EraseRootFromParent_Done,
     /* 1701047 */   // Label 23300: @1701047
     /* 1701047 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1701133), // Rule ID 7494 //
     /* 1701052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701098 */     // MIs[0] policy
     /* 1701098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1701111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701132 */     // GIR_Coverage, 7494,
     /* 1701132 */     GIR_EraseRootFromParent_Done,
     /* 1701133 */   // Label 23301: @1701133
     /* 1701133 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1701219), // Rule ID 7495 //
     /* 1701138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1701158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701184 */     // MIs[0] policy
     /* 1701184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1701197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701218 */     // GIR_Coverage, 7495,
     /* 1701218 */     GIR_EraseRootFromParent_Done,
     /* 1701219 */   // Label 23302: @1701219
     /* 1701219 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1701305), // Rule ID 7498 //
     /* 1701224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701270 */     // MIs[0] policy
     /* 1701270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1701283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701304 */     // GIR_Coverage, 7498,
     /* 1701304 */     GIR_EraseRootFromParent_Done,
     /* 1701305 */   // Label 23303: @1701305
     /* 1701305 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1701391), // Rule ID 7499 //
     /* 1701310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1701330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701356 */     // MIs[0] policy
     /* 1701356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1701369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701390 */     // GIR_Coverage, 7499,
     /* 1701390 */     GIR_EraseRootFromParent_Done,
     /* 1701391 */   // Label 23304: @1701391
     /* 1701391 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1701477), // Rule ID 7502 //
     /* 1701396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701442 */     // MIs[0] policy
     /* 1701442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701476 */     // GIR_Coverage, 7502,
     /* 1701476 */     GIR_EraseRootFromParent_Done,
     /* 1701477 */   // Label 23305: @1701477
     /* 1701477 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1701563), // Rule ID 7503 //
     /* 1701482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701528 */     // MIs[0] policy
     /* 1701528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701562 */     // GIR_Coverage, 7503,
     /* 1701562 */     GIR_EraseRootFromParent_Done,
     /* 1701563 */   // Label 23306: @1701563
     /* 1701563 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1701649), // Rule ID 7506 //
     /* 1701568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701614 */     // MIs[0] policy
     /* 1701614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701648 */     // GIR_Coverage, 7506,
     /* 1701648 */     GIR_EraseRootFromParent_Done,
     /* 1701649 */   // Label 23307: @1701649
     /* 1701649 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1701735), // Rule ID 7507 //
     /* 1701654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701700 */     // MIs[0] policy
     /* 1701700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701734 */     // GIR_Coverage, 7507,
     /* 1701734 */     GIR_EraseRootFromParent_Done,
     /* 1701735 */   // Label 23308: @1701735
     /* 1701735 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1701821), // Rule ID 7510 //
     /* 1701740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701786 */     // MIs[0] policy
     /* 1701786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701820 */     // GIR_Coverage, 7510,
     /* 1701820 */     GIR_EraseRootFromParent_Done,
     /* 1701821 */   // Label 23309: @1701821
     /* 1701821 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1701907), // Rule ID 7511 //
     /* 1701826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701872 */     // MIs[0] policy
     /* 1701872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701906 */     // GIR_Coverage, 7511,
     /* 1701906 */     GIR_EraseRootFromParent_Done,
     /* 1701907 */   // Label 23310: @1701907
     /* 1701907 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1701993), // Rule ID 7514 //
     /* 1701912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701958 */     // MIs[0] policy
     /* 1701958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701992 */     // GIR_Coverage, 7514,
     /* 1701992 */     GIR_EraseRootFromParent_Done,
     /* 1701993 */   // Label 23311: @1701993
     /* 1701993 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1702079), // Rule ID 7515 //
     /* 1701998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1702015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702044 */     // MIs[0] policy
     /* 1702044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702078 */     // GIR_Coverage, 7515,
     /* 1702078 */     GIR_EraseRootFromParent_Done,
     /* 1702079 */   // Label 23312: @1702079
     /* 1702079 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1702165), // Rule ID 7518 //
     /* 1702084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702130 */     // MIs[0] policy
     /* 1702130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702164 */     // GIR_Coverage, 7518,
     /* 1702164 */     GIR_EraseRootFromParent_Done,
     /* 1702165 */   // Label 23313: @1702165
     /* 1702165 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1702251), // Rule ID 7519 //
     /* 1702170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702216 */     // MIs[0] policy
     /* 1702216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702250 */     // GIR_Coverage, 7519,
     /* 1702250 */     GIR_EraseRootFromParent_Done,
     /* 1702251 */   // Label 23314: @1702251
     /* 1702251 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1702337), // Rule ID 7522 //
     /* 1702256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702302 */     // MIs[0] policy
     /* 1702302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702336 */     // GIR_Coverage, 7522,
     /* 1702336 */     GIR_EraseRootFromParent_Done,
     /* 1702337 */   // Label 23315: @1702337
     /* 1702337 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1702423), // Rule ID 7523 //
     /* 1702342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702388 */     // MIs[0] policy
     /* 1702388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702422 */     // GIR_Coverage, 7523,
     /* 1702422 */     GIR_EraseRootFromParent_Done,
     /* 1702423 */   // Label 23316: @1702423
     /* 1702423 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1702509), // Rule ID 7526 //
     /* 1702428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702474 */     // MIs[0] policy
     /* 1702474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702508 */     // GIR_Coverage, 7526,
     /* 1702508 */     GIR_EraseRootFromParent_Done,
     /* 1702509 */   // Label 23317: @1702509
     /* 1702509 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1702595), // Rule ID 7527 //
     /* 1702514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702560 */     // MIs[0] policy
     /* 1702560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702594 */     // GIR_Coverage, 7527,
     /* 1702594 */     GIR_EraseRootFromParent_Done,
     /* 1702595 */   // Label 23318: @1702595
     /* 1702595 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1702681), // Rule ID 7530 //
     /* 1702600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702646 */     // MIs[0] policy
     /* 1702646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702680 */     // GIR_Coverage, 7530,
     /* 1702680 */     GIR_EraseRootFromParent_Done,
     /* 1702681 */   // Label 23319: @1702681
     /* 1702681 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1702767), // Rule ID 7531 //
     /* 1702686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702732 */     // MIs[0] policy
     /* 1702732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702742 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702766 */     // GIR_Coverage, 7531,
     /* 1702766 */     GIR_EraseRootFromParent_Done,
     /* 1702767 */   // Label 23320: @1702767
     /* 1702767 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1702853), // Rule ID 7534 //
     /* 1702772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702818 */     // MIs[0] policy
     /* 1702818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702828 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702852 */     // GIR_Coverage, 7534,
     /* 1702852 */     GIR_EraseRootFromParent_Done,
     /* 1702853 */   // Label 23321: @1702853
     /* 1702853 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1702939), // Rule ID 7535 //
     /* 1702858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702904 */     // MIs[0] policy
     /* 1702904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702938 */     // GIR_Coverage, 7535,
     /* 1702938 */     GIR_EraseRootFromParent_Done,
     /* 1702939 */   // Label 23322: @1702939
     /* 1702939 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1703025), // Rule ID 7538 //
     /* 1702944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702990 */     // MIs[0] policy
     /* 1702990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703024 */     // GIR_Coverage, 7538,
     /* 1703024 */     GIR_EraseRootFromParent_Done,
     /* 1703025 */   // Label 23323: @1703025
     /* 1703025 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1703111), // Rule ID 7539 //
     /* 1703030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703076 */     // MIs[0] policy
     /* 1703076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703110 */     // GIR_Coverage, 7539,
     /* 1703110 */     GIR_EraseRootFromParent_Done,
     /* 1703111 */   // Label 23324: @1703111
     /* 1703111 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1703197), // Rule ID 7542 //
     /* 1703116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703162 */     // MIs[0] policy
     /* 1703162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703196 */     // GIR_Coverage, 7542,
     /* 1703196 */     GIR_EraseRootFromParent_Done,
     /* 1703197 */   // Label 23325: @1703197
     /* 1703197 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1703283), // Rule ID 7543 //
     /* 1703202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703248 */     // MIs[0] policy
     /* 1703248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703282 */     // GIR_Coverage, 7543,
     /* 1703282 */     GIR_EraseRootFromParent_Done,
     /* 1703283 */   // Label 23326: @1703283
     /* 1703283 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1703369), // Rule ID 7546 //
     /* 1703288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703334 */     // MIs[0] policy
     /* 1703334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703368 */     // GIR_Coverage, 7546,
     /* 1703368 */     GIR_EraseRootFromParent_Done,
     /* 1703369 */   // Label 23327: @1703369
     /* 1703369 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1703455), // Rule ID 7547 //
     /* 1703374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703420 */     // MIs[0] policy
     /* 1703420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703454 */     // GIR_Coverage, 7547,
     /* 1703454 */     GIR_EraseRootFromParent_Done,
     /* 1703455 */   // Label 23328: @1703455
     /* 1703455 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1703541), // Rule ID 7550 //
     /* 1703460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703506 */     // MIs[0] policy
     /* 1703506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703540 */     // GIR_Coverage, 7550,
     /* 1703540 */     GIR_EraseRootFromParent_Done,
     /* 1703541 */   // Label 23329: @1703541
     /* 1703541 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1703627), // Rule ID 7551 //
     /* 1703546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703592 */     // MIs[0] policy
     /* 1703592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703626 */     // GIR_Coverage, 7551,
     /* 1703626 */     GIR_EraseRootFromParent_Done,
     /* 1703627 */   // Label 23330: @1703627
     /* 1703627 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1703713), // Rule ID 7554 //
     /* 1703632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703678 */     // MIs[0] policy
     /* 1703678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703688 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703712 */     // GIR_Coverage, 7554,
     /* 1703712 */     GIR_EraseRootFromParent_Done,
     /* 1703713 */   // Label 23331: @1703713
     /* 1703713 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1703799), // Rule ID 7555 //
     /* 1703718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703764 */     // MIs[0] policy
     /* 1703764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703798 */     // GIR_Coverage, 7555,
     /* 1703798 */     GIR_EraseRootFromParent_Done,
     /* 1703799 */   // Label 23332: @1703799
     /* 1703799 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1703885), // Rule ID 7558 //
     /* 1703804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703850 */     // MIs[0] policy
     /* 1703850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703884 */     // GIR_Coverage, 7558,
     /* 1703884 */     GIR_EraseRootFromParent_Done,
     /* 1703885 */   // Label 23333: @1703885
     /* 1703885 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1703971), // Rule ID 7559 //
     /* 1703890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703936 */     // MIs[0] policy
     /* 1703936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703970 */     // GIR_Coverage, 7559,
     /* 1703970 */     GIR_EraseRootFromParent_Done,
     /* 1703971 */   // Label 23334: @1703971
     /* 1703971 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1704057), // Rule ID 7562 //
     /* 1703976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704022 */     // MIs[0] policy
     /* 1704022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1704035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704056 */     // GIR_Coverage, 7562,
     /* 1704056 */     GIR_EraseRootFromParent_Done,
     /* 1704057 */   // Label 23335: @1704057
     /* 1704057 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1704143), // Rule ID 7563 //
     /* 1704062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1704073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1704076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1704079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704108 */     // MIs[0] policy
     /* 1704108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1704121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704142 */     // GIR_Coverage, 7563,
     /* 1704142 */     GIR_EraseRootFromParent_Done,
     /* 1704143 */   // Label 23336: @1704143
     /* 1704143 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1704229), // Rule ID 7566 //
     /* 1704148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704194 */     // MIs[0] policy
     /* 1704194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1704207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704228 */     // GIR_Coverage, 7566,
     /* 1704228 */     GIR_EraseRootFromParent_Done,
     /* 1704229 */   // Label 23337: @1704229
     /* 1704229 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1704315), // Rule ID 7567 //
     /* 1704234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1704242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704280 */     // MIs[0] policy
     /* 1704280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1704293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704314 */     // GIR_Coverage, 7567,
     /* 1704314 */     GIR_EraseRootFromParent_Done,
     /* 1704315 */   // Label 23338: @1704315
     /* 1704315 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1704401), // Rule ID 7630 //
     /* 1704320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704366 */     // MIs[0] policy
     /* 1704366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1704379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704400 */     // GIR_Coverage, 7630,
     /* 1704400 */     GIR_EraseRootFromParent_Done,
     /* 1704401 */   // Label 23339: @1704401
     /* 1704401 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1704487), // Rule ID 7631 //
     /* 1704406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1704426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704452 */     // MIs[0] policy
     /* 1704452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1704465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704486 */     // GIR_Coverage, 7631,
     /* 1704486 */     GIR_EraseRootFromParent_Done,
     /* 1704487 */   // Label 23340: @1704487
     /* 1704487 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1704573), // Rule ID 7634 //
     /* 1704492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704538 */     // MIs[0] policy
     /* 1704538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704572 */     // GIR_Coverage, 7634,
     /* 1704572 */     GIR_EraseRootFromParent_Done,
     /* 1704573 */   // Label 23341: @1704573
     /* 1704573 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1704659), // Rule ID 7635 //
     /* 1704578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704624 */     // MIs[0] policy
     /* 1704624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704658 */     // GIR_Coverage, 7635,
     /* 1704658 */     GIR_EraseRootFromParent_Done,
     /* 1704659 */   // Label 23342: @1704659
     /* 1704659 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1704745), // Rule ID 7638 //
     /* 1704664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704710 */     // MIs[0] policy
     /* 1704710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704744 */     // GIR_Coverage, 7638,
     /* 1704744 */     GIR_EraseRootFromParent_Done,
     /* 1704745 */   // Label 23343: @1704745
     /* 1704745 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1704831), // Rule ID 7639 //
     /* 1704750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704796 */     // MIs[0] policy
     /* 1704796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704830 */     // GIR_Coverage, 7639,
     /* 1704830 */     GIR_EraseRootFromParent_Done,
     /* 1704831 */   // Label 23344: @1704831
     /* 1704831 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1704917), // Rule ID 7642 //
     /* 1704836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704882 */     // MIs[0] policy
     /* 1704882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704916 */     // GIR_Coverage, 7642,
     /* 1704916 */     GIR_EraseRootFromParent_Done,
     /* 1704917 */   // Label 23345: @1704917
     /* 1704917 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1705003), // Rule ID 7643 //
     /* 1704922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704968 */     // MIs[0] policy
     /* 1704968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705002 */     // GIR_Coverage, 7643,
     /* 1705002 */     GIR_EraseRootFromParent_Done,
     /* 1705003 */   // Label 23346: @1705003
     /* 1705003 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1705089), // Rule ID 7646 //
     /* 1705008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705054 */     // MIs[0] policy
     /* 1705054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705088 */     // GIR_Coverage, 7646,
     /* 1705088 */     GIR_EraseRootFromParent_Done,
     /* 1705089 */   // Label 23347: @1705089
     /* 1705089 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1705175), // Rule ID 7647 //
     /* 1705094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1705105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1705108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1705111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1705114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705140 */     // MIs[0] policy
     /* 1705140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705174 */     // GIR_Coverage, 7647,
     /* 1705174 */     GIR_EraseRootFromParent_Done,
     /* 1705175 */   // Label 23348: @1705175
     /* 1705175 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1705261), // Rule ID 7650 //
     /* 1705180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705226 */     // MIs[0] policy
     /* 1705226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705236 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705260 */     // GIR_Coverage, 7650,
     /* 1705260 */     GIR_EraseRootFromParent_Done,
     /* 1705261 */   // Label 23349: @1705261
     /* 1705261 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1705347), // Rule ID 7651 //
     /* 1705266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1705286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705312 */     // MIs[0] policy
     /* 1705312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705322 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705346 */     // GIR_Coverage, 7651,
     /* 1705346 */     GIR_EraseRootFromParent_Done,
     /* 1705347 */   // Label 23350: @1705347
     /* 1705347 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1705433), // Rule ID 7654 //
     /* 1705352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705398 */     // MIs[0] policy
     /* 1705398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705432 */     // GIR_Coverage, 7654,
     /* 1705432 */     GIR_EraseRootFromParent_Done,
     /* 1705433 */   // Label 23351: @1705433
     /* 1705433 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1705519), // Rule ID 7655 //
     /* 1705438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1705458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705484 */     // MIs[0] policy
     /* 1705484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705518 */     // GIR_Coverage, 7655,
     /* 1705518 */     GIR_EraseRootFromParent_Done,
     /* 1705519 */   // Label 23352: @1705519
     /* 1705519 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1705605), // Rule ID 7658 //
     /* 1705524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705570 */     // MIs[0] policy
     /* 1705570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705604 */     // GIR_Coverage, 7658,
     /* 1705604 */     GIR_EraseRootFromParent_Done,
     /* 1705605 */   // Label 23353: @1705605
     /* 1705605 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1705691), // Rule ID 7659 //
     /* 1705610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705656 */     // MIs[0] policy
     /* 1705656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705690 */     // GIR_Coverage, 7659,
     /* 1705690 */     GIR_EraseRootFromParent_Done,
     /* 1705691 */   // Label 23354: @1705691
     /* 1705691 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1705777), // Rule ID 7662 //
     /* 1705696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705742 */     // MIs[0] policy
     /* 1705742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705776 */     // GIR_Coverage, 7662,
     /* 1705776 */     GIR_EraseRootFromParent_Done,
     /* 1705777 */   // Label 23355: @1705777
     /* 1705777 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1705863), // Rule ID 7663 //
     /* 1705782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705828 */     // MIs[0] policy
     /* 1705828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705862 */     // GIR_Coverage, 7663,
     /* 1705862 */     GIR_EraseRootFromParent_Done,
     /* 1705863 */   // Label 23356: @1705863
     /* 1705863 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1705949), // Rule ID 7666 //
     /* 1705868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705914 */     // MIs[0] policy
     /* 1705914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705948 */     // GIR_Coverage, 7666,
     /* 1705948 */     GIR_EraseRootFromParent_Done,
     /* 1705949 */   // Label 23357: @1705949
     /* 1705949 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1706035), // Rule ID 7667 //
     /* 1705954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706000 */     // MIs[0] policy
     /* 1706000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706034 */     // GIR_Coverage, 7667,
     /* 1706034 */     GIR_EraseRootFromParent_Done,
     /* 1706035 */   // Label 23358: @1706035
     /* 1706035 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1706121), // Rule ID 7670 //
     /* 1706040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706086 */     // MIs[0] policy
     /* 1706086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706120 */     // GIR_Coverage, 7670,
     /* 1706120 */     GIR_EraseRootFromParent_Done,
     /* 1706121 */   // Label 23359: @1706121
     /* 1706121 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1706207), // Rule ID 7671 //
     /* 1706126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1706146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706172 */     // MIs[0] policy
     /* 1706172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706206 */     // GIR_Coverage, 7671,
     /* 1706206 */     GIR_EraseRootFromParent_Done,
     /* 1706207 */   // Label 23360: @1706207
     /* 1706207 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1706293), // Rule ID 7674 //
     /* 1706212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706258 */     // MIs[0] policy
     /* 1706258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1706271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706292 */     // GIR_Coverage, 7674,
     /* 1706292 */     GIR_EraseRootFromParent_Done,
     /* 1706293 */   // Label 23361: @1706293
     /* 1706293 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1706379), // Rule ID 7675 //
     /* 1706298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1706318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706344 */     // MIs[0] policy
     /* 1706344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1706357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706378 */     // GIR_Coverage, 7675,
     /* 1706378 */     GIR_EraseRootFromParent_Done,
     /* 1706379 */   // Label 23362: @1706379
     /* 1706379 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1706465), // Rule ID 7678 //
     /* 1706384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706430 */     // MIs[0] policy
     /* 1706430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706464 */     // GIR_Coverage, 7678,
     /* 1706464 */     GIR_EraseRootFromParent_Done,
     /* 1706465 */   // Label 23363: @1706465
     /* 1706465 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1706551), // Rule ID 7679 //
     /* 1706470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706516 */     // MIs[0] policy
     /* 1706516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706550 */     // GIR_Coverage, 7679,
     /* 1706550 */     GIR_EraseRootFromParent_Done,
     /* 1706551 */   // Label 23364: @1706551
     /* 1706551 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1706637), // Rule ID 7682 //
     /* 1706556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706602 */     // MIs[0] policy
     /* 1706602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706636 */     // GIR_Coverage, 7682,
     /* 1706636 */     GIR_EraseRootFromParent_Done,
     /* 1706637 */   // Label 23365: @1706637
     /* 1706637 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1706723), // Rule ID 7683 //
     /* 1706642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706688 */     // MIs[0] policy
     /* 1706688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706722 */     // GIR_Coverage, 7683,
     /* 1706722 */     GIR_EraseRootFromParent_Done,
     /* 1706723 */   // Label 23366: @1706723
     /* 1706723 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1706809), // Rule ID 7686 //
     /* 1706728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706774 */     // MIs[0] policy
     /* 1706774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706808 */     // GIR_Coverage, 7686,
     /* 1706808 */     GIR_EraseRootFromParent_Done,
     /* 1706809 */   // Label 23367: @1706809
     /* 1706809 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1706895), // Rule ID 7687 //
     /* 1706814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706860 */     // MIs[0] policy
     /* 1706860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706894 */     // GIR_Coverage, 7687,
     /* 1706894 */     GIR_EraseRootFromParent_Done,
     /* 1706895 */   // Label 23368: @1706895
     /* 1706895 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1706981), // Rule ID 7690 //
     /* 1706900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706946 */     // MIs[0] policy
     /* 1706946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706980 */     // GIR_Coverage, 7690,
     /* 1706980 */     GIR_EraseRootFromParent_Done,
     /* 1706981 */   // Label 23369: @1706981
     /* 1706981 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1707067), // Rule ID 7691 //
     /* 1706986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1707000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707032 */     // MIs[0] policy
     /* 1707032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707042 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1707045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707066 */     // GIR_Coverage, 7691,
     /* 1707066 */     GIR_EraseRootFromParent_Done,
     /* 1707067 */   // Label 23370: @1707067
     /* 1707067 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1707153), // Rule ID 7694 //
     /* 1707072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707118 */     // MIs[0] policy
     /* 1707118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707128 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707152 */     // GIR_Coverage, 7694,
     /* 1707152 */     GIR_EraseRootFromParent_Done,
     /* 1707153 */   // Label 23371: @1707153
     /* 1707153 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1707239), // Rule ID 7695 //
     /* 1707158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707204 */     // MIs[0] policy
     /* 1707204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707214 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707238 */     // GIR_Coverage, 7695,
     /* 1707238 */     GIR_EraseRootFromParent_Done,
     /* 1707239 */   // Label 23372: @1707239
     /* 1707239 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1707325), // Rule ID 7698 //
     /* 1707244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707290 */     // MIs[0] policy
     /* 1707290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707300 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707324 */     // GIR_Coverage, 7698,
     /* 1707324 */     GIR_EraseRootFromParent_Done,
     /* 1707325 */   // Label 23373: @1707325
     /* 1707325 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1707411), // Rule ID 7699 //
     /* 1707330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707376 */     // MIs[0] policy
     /* 1707376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707410 */     // GIR_Coverage, 7699,
     /* 1707410 */     GIR_EraseRootFromParent_Done,
     /* 1707411 */   // Label 23374: @1707411
     /* 1707411 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1707497), // Rule ID 7702 //
     /* 1707416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707462 */     // MIs[0] policy
     /* 1707462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707496 */     // GIR_Coverage, 7702,
     /* 1707496 */     GIR_EraseRootFromParent_Done,
     /* 1707497 */   // Label 23375: @1707497
     /* 1707497 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1707583), // Rule ID 7703 //
     /* 1707502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707548 */     // MIs[0] policy
     /* 1707548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707582 */     // GIR_Coverage, 7703,
     /* 1707582 */     GIR_EraseRootFromParent_Done,
     /* 1707583 */   // Label 23376: @1707583
     /* 1707583 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1707669), // Rule ID 7706 //
     /* 1707588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707634 */     // MIs[0] policy
     /* 1707634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707668 */     // GIR_Coverage, 7706,
     /* 1707668 */     GIR_EraseRootFromParent_Done,
     /* 1707669 */   // Label 23377: @1707669
     /* 1707669 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1707755), // Rule ID 7707 //
     /* 1707674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707720 */     // MIs[0] policy
     /* 1707720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707754 */     // GIR_Coverage, 7707,
     /* 1707754 */     GIR_EraseRootFromParent_Done,
     /* 1707755 */   // Label 23378: @1707755
     /* 1707755 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1707841), // Rule ID 7710 //
     /* 1707760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707806 */     // MIs[0] policy
     /* 1707806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707840 */     // GIR_Coverage, 7710,
     /* 1707840 */     GIR_EraseRootFromParent_Done,
     /* 1707841 */   // Label 23379: @1707841
     /* 1707841 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1707927), // Rule ID 7711 //
     /* 1707846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707892 */     // MIs[0] policy
     /* 1707892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707926 */     // GIR_Coverage, 7711,
     /* 1707926 */     GIR_EraseRootFromParent_Done,
     /* 1707927 */   // Label 23380: @1707927
     /* 1707927 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1708013), // Rule ID 7714 //
     /* 1707932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707978 */     // MIs[0] policy
     /* 1707978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707988 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708012 */     // GIR_Coverage, 7714,
     /* 1708012 */     GIR_EraseRootFromParent_Done,
     /* 1708013 */   // Label 23381: @1708013
     /* 1708013 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1708099), // Rule ID 7715 //
     /* 1708018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1708029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1708032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1708035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708064 */     // MIs[0] policy
     /* 1708064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1708077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708098 */     // GIR_Coverage, 7715,
     /* 1708098 */     GIR_EraseRootFromParent_Done,
     /* 1708099 */   // Label 23382: @1708099
     /* 1708099 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1708185), // Rule ID 7718 //
     /* 1708104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1708118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708150 */     // MIs[0] policy
     /* 1708150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708184 */     // GIR_Coverage, 7718,
     /* 1708184 */     GIR_EraseRootFromParent_Done,
     /* 1708185 */   // Label 23383: @1708185
     /* 1708185 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1708271), // Rule ID 7719 //
     /* 1708190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1708201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1708204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708236 */     // MIs[0] policy
     /* 1708236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708270 */     // GIR_Coverage, 7719,
     /* 1708270 */     GIR_EraseRootFromParent_Done,
     /* 1708271 */   // Label 23384: @1708271
     /* 1708271 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1708357), // Rule ID 7722 //
     /* 1708276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1708287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1708290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1708293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708322 */     // MIs[0] policy
     /* 1708322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708356 */     // GIR_Coverage, 7722,
     /* 1708356 */     GIR_EraseRootFromParent_Done,
     /* 1708357 */   // Label 23385: @1708357
     /* 1708357 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1708443), // Rule ID 7723 //
     /* 1708362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1708373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1708376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1708379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708408 */     // MIs[0] policy
     /* 1708408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708442 */     // GIR_Coverage, 7723,
     /* 1708442 */     GIR_EraseRootFromParent_Done,
     /* 1708443 */   // Label 23386: @1708443
     /* 1708443 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1708529), // Rule ID 7726 //
     /* 1708448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708494 */     // MIs[0] policy
     /* 1708494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708528 */     // GIR_Coverage, 7726,
     /* 1708528 */     GIR_EraseRootFromParent_Done,
     /* 1708529 */   // Label 23387: @1708529
     /* 1708529 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1708615), // Rule ID 7727 //
     /* 1708534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708580 */     // MIs[0] policy
     /* 1708580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708614 */     // GIR_Coverage, 7727,
     /* 1708614 */     GIR_EraseRootFromParent_Done,
     /* 1708615 */   // Label 23388: @1708615
     /* 1708615 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1708701), // Rule ID 7730 //
     /* 1708620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708666 */     // MIs[0] policy
     /* 1708666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708700 */     // GIR_Coverage, 7730,
     /* 1708700 */     GIR_EraseRootFromParent_Done,
     /* 1708701 */   // Label 23389: @1708701
     /* 1708701 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1708787), // Rule ID 7731 //
     /* 1708706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708752 */     // MIs[0] policy
     /* 1708752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708786 */     // GIR_Coverage, 7731,
     /* 1708786 */     GIR_EraseRootFromParent_Done,
     /* 1708787 */   // Label 23390: @1708787
     /* 1708787 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1708873), // Rule ID 7734 //
     /* 1708792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708838 */     // MIs[0] policy
     /* 1708838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708872 */     // GIR_Coverage, 7734,
     /* 1708872 */     GIR_EraseRootFromParent_Done,
     /* 1708873 */   // Label 23391: @1708873
     /* 1708873 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1708959), // Rule ID 7735 //
     /* 1708878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708924 */     // MIs[0] policy
     /* 1708924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708934 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708958 */     // GIR_Coverage, 7735,
     /* 1708958 */     GIR_EraseRootFromParent_Done,
     /* 1708959 */   // Label 23392: @1708959
     /* 1708959 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1709045), // Rule ID 7738 //
     /* 1708964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709010 */     // MIs[0] policy
     /* 1709010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1709023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709044 */     // GIR_Coverage, 7738,
     /* 1709044 */     GIR_EraseRootFromParent_Done,
     /* 1709045 */   // Label 23393: @1709045
     /* 1709045 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1709131), // Rule ID 7739 //
     /* 1709050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1709061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1709064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709096 */     // MIs[0] policy
     /* 1709096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1709109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709130 */     // GIR_Coverage, 7739,
     /* 1709130 */     GIR_EraseRootFromParent_Done,
     /* 1709131 */   // Label 23394: @1709131
     /* 1709131 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1709217), // Rule ID 7742 //
     /* 1709136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709182 */     // MIs[0] policy
     /* 1709182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1709195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709216 */     // GIR_Coverage, 7742,
     /* 1709216 */     GIR_EraseRootFromParent_Done,
     /* 1709217 */   // Label 23395: @1709217
     /* 1709217 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1709303), // Rule ID 7743 //
     /* 1709222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709268 */     // MIs[0] policy
     /* 1709268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1709281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709302 */     // GIR_Coverage, 7743,
     /* 1709302 */     GIR_EraseRootFromParent_Done,
     /* 1709303 */   // Label 23396: @1709303
     /* 1709303 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1709389), // Rule ID 7746 //
     /* 1709308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1709311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709354 */     // MIs[0] policy
     /* 1709354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1709367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709388 */     // GIR_Coverage, 7746,
     /* 1709388 */     GIR_EraseRootFromParent_Done,
     /* 1709389 */   // Label 23397: @1709389
     /* 1709389 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1709475), // Rule ID 7747 //
     /* 1709394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1709397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1709402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709440 */     // MIs[0] policy
     /* 1709440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1709453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709474 */     // GIR_Coverage, 7747,
     /* 1709474 */     GIR_EraseRootFromParent_Done,
     /* 1709475 */   // Label 23398: @1709475
     /* 1709475 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1709561), // Rule ID 10262 //
     /* 1709480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709526 */     // MIs[0] policy
     /* 1709526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709536 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709560 */     // GIR_Coverage, 10262,
     /* 1709560 */     GIR_EraseRootFromParent_Done,
     /* 1709561 */   // Label 23399: @1709561
     /* 1709561 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1709647), // Rule ID 10263 //
     /* 1709566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709612 */     // MIs[0] policy
     /* 1709612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709622 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709646 */     // GIR_Coverage, 10263,
     /* 1709646 */     GIR_EraseRootFromParent_Done,
     /* 1709647 */   // Label 23400: @1709647
     /* 1709647 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1709733), // Rule ID 10266 //
     /* 1709652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709698 */     // MIs[0] policy
     /* 1709698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709732 */     // GIR_Coverage, 10266,
     /* 1709732 */     GIR_EraseRootFromParent_Done,
     /* 1709733 */   // Label 23401: @1709733
     /* 1709733 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1709819), // Rule ID 10267 //
     /* 1709738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709784 */     // MIs[0] policy
     /* 1709784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709818 */     // GIR_Coverage, 10267,
     /* 1709818 */     GIR_EraseRootFromParent_Done,
     /* 1709819 */   // Label 23402: @1709819
     /* 1709819 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1709905), // Rule ID 10270 //
     /* 1709824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709870 */     // MIs[0] policy
     /* 1709870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709904 */     // GIR_Coverage, 10270,
     /* 1709904 */     GIR_EraseRootFromParent_Done,
     /* 1709905 */   // Label 23403: @1709905
     /* 1709905 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1709991), // Rule ID 10271 //
     /* 1709910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709956 */     // MIs[0] policy
     /* 1709956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709966 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709990 */     // GIR_Coverage, 10271,
     /* 1709990 */     GIR_EraseRootFromParent_Done,
     /* 1709991 */   // Label 23404: @1709991
     /* 1709991 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1710077), // Rule ID 10274 //
     /* 1709996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710042 */     // MIs[0] policy
     /* 1710042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1710055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710076 */     // GIR_Coverage, 10274,
     /* 1710076 */     GIR_EraseRootFromParent_Done,
     /* 1710077 */   // Label 23405: @1710077
     /* 1710077 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1710163), // Rule ID 10275 //
     /* 1710082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710128 */     // MIs[0] policy
     /* 1710128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710138 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1710141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710162 */     // GIR_Coverage, 10275,
     /* 1710162 */     GIR_EraseRootFromParent_Done,
     /* 1710163 */   // Label 23406: @1710163
     /* 1710163 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1710249), // Rule ID 10278 //
     /* 1710168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710214 */     // MIs[0] policy
     /* 1710214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710248 */     // GIR_Coverage, 10278,
     /* 1710248 */     GIR_EraseRootFromParent_Done,
     /* 1710249 */   // Label 23407: @1710249
     /* 1710249 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1710335), // Rule ID 10279 //
     /* 1710254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710300 */     // MIs[0] policy
     /* 1710300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710334 */     // GIR_Coverage, 10279,
     /* 1710334 */     GIR_EraseRootFromParent_Done,
     /* 1710335 */   // Label 23408: @1710335
     /* 1710335 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1710421), // Rule ID 10282 //
     /* 1710340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710386 */     // MIs[0] policy
     /* 1710386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710420 */     // GIR_Coverage, 10282,
     /* 1710420 */     GIR_EraseRootFromParent_Done,
     /* 1710421 */   // Label 23409: @1710421
     /* 1710421 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1710507), // Rule ID 10283 //
     /* 1710426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710472 */     // MIs[0] policy
     /* 1710472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710506 */     // GIR_Coverage, 10283,
     /* 1710506 */     GIR_EraseRootFromParent_Done,
     /* 1710507 */   // Label 23410: @1710507
     /* 1710507 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1710593), // Rule ID 10286 //
     /* 1710512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710558 */     // MIs[0] policy
     /* 1710558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710592 */     // GIR_Coverage, 10286,
     /* 1710592 */     GIR_EraseRootFromParent_Done,
     /* 1710593 */   // Label 23411: @1710593
     /* 1710593 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1710679), // Rule ID 10287 //
     /* 1710598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710644 */     // MIs[0] policy
     /* 1710644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710678 */     // GIR_Coverage, 10287,
     /* 1710678 */     GIR_EraseRootFromParent_Done,
     /* 1710679 */   // Label 23412: @1710679
     /* 1710679 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1710765), // Rule ID 10290 //
     /* 1710684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710730 */     // MIs[0] policy
     /* 1710730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710764 */     // GIR_Coverage, 10290,
     /* 1710764 */     GIR_EraseRootFromParent_Done,
     /* 1710765 */   // Label 23413: @1710765
     /* 1710765 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1710851), // Rule ID 10291 //
     /* 1710770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710816 */     // MIs[0] policy
     /* 1710816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710850 */     // GIR_Coverage, 10291,
     /* 1710850 */     GIR_EraseRootFromParent_Done,
     /* 1710851 */   // Label 23414: @1710851
     /* 1710851 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1710937), // Rule ID 10294 //
     /* 1710856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710902 */     // MIs[0] policy
     /* 1710902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710936 */     // GIR_Coverage, 10294,
     /* 1710936 */     GIR_EraseRootFromParent_Done,
     /* 1710937 */   // Label 23415: @1710937
     /* 1710937 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1711023), // Rule ID 10295 //
     /* 1710942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710988 */     // MIs[0] policy
     /* 1710988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711022 */     // GIR_Coverage, 10295,
     /* 1711022 */     GIR_EraseRootFromParent_Done,
     /* 1711023 */   // Label 23416: @1711023
     /* 1711023 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1711109), // Rule ID 10298 //
     /* 1711028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1711031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711074 */     // MIs[0] policy
     /* 1711074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711108 */     // GIR_Coverage, 10298,
     /* 1711108 */     GIR_EraseRootFromParent_Done,
     /* 1711109 */   // Label 23417: @1711109
     /* 1711109 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1711195), // Rule ID 10299 //
     /* 1711114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1711117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711160 */     // MIs[0] policy
     /* 1711160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1711173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711194 */     // GIR_Coverage, 10299,
     /* 1711194 */     GIR_EraseRootFromParent_Done,
     /* 1711195 */   // Label 23418: @1711195
     /* 1711195 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1711281), // Rule ID 10302 //
     /* 1711200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711246 */     // MIs[0] policy
     /* 1711246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711280 */     // GIR_Coverage, 10302,
     /* 1711280 */     GIR_EraseRootFromParent_Done,
     /* 1711281 */   // Label 23419: @1711281
     /* 1711281 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1711367), // Rule ID 10303 //
     /* 1711286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711332 */     // MIs[0] policy
     /* 1711332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711366 */     // GIR_Coverage, 10303,
     /* 1711366 */     GIR_EraseRootFromParent_Done,
     /* 1711367 */   // Label 23420: @1711367
     /* 1711367 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1711453), // Rule ID 10306 //
     /* 1711372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711418 */     // MIs[0] policy
     /* 1711418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711452 */     // GIR_Coverage, 10306,
     /* 1711452 */     GIR_EraseRootFromParent_Done,
     /* 1711453 */   // Label 23421: @1711453
     /* 1711453 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1711539), // Rule ID 10307 //
     /* 1711458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711504 */     // MIs[0] policy
     /* 1711504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711538 */     // GIR_Coverage, 10307,
     /* 1711538 */     GIR_EraseRootFromParent_Done,
     /* 1711539 */   // Label 23422: @1711539
     /* 1711539 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1711625), // Rule ID 10310 //
     /* 1711544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711590 */     // MIs[0] policy
     /* 1711590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711624 */     // GIR_Coverage, 10310,
     /* 1711624 */     GIR_EraseRootFromParent_Done,
     /* 1711625 */   // Label 23423: @1711625
     /* 1711625 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1711711), // Rule ID 10311 //
     /* 1711630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711676 */     // MIs[0] policy
     /* 1711676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711686 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711710 */     // GIR_Coverage, 10311,
     /* 1711710 */     GIR_EraseRootFromParent_Done,
     /* 1711711 */   // Label 23424: @1711711
     /* 1711711 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1711797), // Rule ID 10314 //
     /* 1711716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711762 */     // MIs[0] policy
     /* 1711762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711796 */     // GIR_Coverage, 10314,
     /* 1711796 */     GIR_EraseRootFromParent_Done,
     /* 1711797 */   // Label 23425: @1711797
     /* 1711797 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1711883), // Rule ID 10315 //
     /* 1711802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711848 */     // MIs[0] policy
     /* 1711848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711882 */     // GIR_Coverage, 10315,
     /* 1711882 */     GIR_EraseRootFromParent_Done,
     /* 1711883 */   // Label 23426: @1711883
     /* 1711883 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1711969), // Rule ID 10318 //
     /* 1711888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711934 */     // MIs[0] policy
     /* 1711934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711968 */     // GIR_Coverage, 10318,
     /* 1711968 */     GIR_EraseRootFromParent_Done,
     /* 1711969 */   // Label 23427: @1711969
     /* 1711969 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1712055), // Rule ID 10319 //
     /* 1711974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712020 */     // MIs[0] policy
     /* 1712020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712054 */     // GIR_Coverage, 10319,
     /* 1712054 */     GIR_EraseRootFromParent_Done,
     /* 1712055 */   // Label 23428: @1712055
     /* 1712055 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1712141), // Rule ID 10322 //
     /* 1712060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712106 */     // MIs[0] policy
     /* 1712106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712140 */     // GIR_Coverage, 10322,
     /* 1712140 */     GIR_EraseRootFromParent_Done,
     /* 1712141 */   // Label 23429: @1712141
     /* 1712141 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1712227), // Rule ID 10323 //
     /* 1712146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712192 */     // MIs[0] policy
     /* 1712192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712226 */     // GIR_Coverage, 10323,
     /* 1712226 */     GIR_EraseRootFromParent_Done,
     /* 1712227 */   // Label 23430: @1712227
     /* 1712227 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1712313), // Rule ID 10326 //
     /* 1712232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712278 */     // MIs[0] policy
     /* 1712278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712312 */     // GIR_Coverage, 10326,
     /* 1712312 */     GIR_EraseRootFromParent_Done,
     /* 1712313 */   // Label 23431: @1712313
     /* 1712313 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1712399), // Rule ID 10327 //
     /* 1712318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712364 */     // MIs[0] policy
     /* 1712364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712398 */     // GIR_Coverage, 10327,
     /* 1712398 */     GIR_EraseRootFromParent_Done,
     /* 1712399 */   // Label 23432: @1712399
     /* 1712399 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1712485), // Rule ID 10330 //
     /* 1712404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712450 */     // MIs[0] policy
     /* 1712450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712484 */     // GIR_Coverage, 10330,
     /* 1712484 */     GIR_EraseRootFromParent_Done,
     /* 1712485 */   // Label 23433: @1712485
     /* 1712485 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1712571), // Rule ID 10331 //
     /* 1712490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712536 */     // MIs[0] policy
     /* 1712536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712570 */     // GIR_Coverage, 10331,
     /* 1712570 */     GIR_EraseRootFromParent_Done,
     /* 1712571 */   // Label 23434: @1712571
     /* 1712571 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1712657), // Rule ID 10334 //
     /* 1712576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712622 */     // MIs[0] policy
     /* 1712622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712656 */     // GIR_Coverage, 10334,
     /* 1712656 */     GIR_EraseRootFromParent_Done,
     /* 1712657 */   // Label 23435: @1712657
     /* 1712657 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1712743), // Rule ID 10335 //
     /* 1712662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712708 */     // MIs[0] policy
     /* 1712708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712742 */     // GIR_Coverage, 10335,
     /* 1712742 */     GIR_EraseRootFromParent_Done,
     /* 1712743 */   // Label 23436: @1712743
     /* 1712743 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1712829), // Rule ID 10338 //
     /* 1712748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712794 */     // MIs[0] policy
     /* 1712794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712828 */     // GIR_Coverage, 10338,
     /* 1712828 */     GIR_EraseRootFromParent_Done,
     /* 1712829 */   // Label 23437: @1712829
     /* 1712829 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1712915), // Rule ID 10339 //
     /* 1712834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712880 */     // MIs[0] policy
     /* 1712880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712914 */     // GIR_Coverage, 10339,
     /* 1712914 */     GIR_EraseRootFromParent_Done,
     /* 1712915 */   // Label 23438: @1712915
     /* 1712915 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1713001), // Rule ID 10342 //
     /* 1712920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712966 */     // MIs[0] policy
     /* 1712966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712976 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713000 */     // GIR_Coverage, 10342,
     /* 1713000 */     GIR_EraseRootFromParent_Done,
     /* 1713001 */   // Label 23439: @1713001
     /* 1713001 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1713087), // Rule ID 10343 //
     /* 1713006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1713017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1713020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1713023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1713026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713052 */     // MIs[0] policy
     /* 1713052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1713065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713086 */     // GIR_Coverage, 10343,
     /* 1713086 */     GIR_EraseRootFromParent_Done,
     /* 1713087 */   // Label 23440: @1713087
     /* 1713087 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1713173), // Rule ID 10346 //
     /* 1713092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713138 */     // MIs[0] policy
     /* 1713138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1713151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713172 */     // GIR_Coverage, 10346,
     /* 1713172 */     GIR_EraseRootFromParent_Done,
     /* 1713173 */   // Label 23441: @1713173
     /* 1713173 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1713259), // Rule ID 10347 //
     /* 1713178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713224 */     // MIs[0] policy
     /* 1713224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1713237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713258 */     // GIR_Coverage, 10347,
     /* 1713258 */     GIR_EraseRootFromParent_Done,
     /* 1713259 */   // Label 23442: @1713259
     /* 1713259 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1713345), // Rule ID 10350 //
     /* 1713264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713310 */     // MIs[0] policy
     /* 1713310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1713323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713344 */     // GIR_Coverage, 10350,
     /* 1713344 */     GIR_EraseRootFromParent_Done,
     /* 1713345 */   // Label 23443: @1713345
     /* 1713345 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1713431), // Rule ID 10351 //
     /* 1713350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713396 */     // MIs[0] policy
     /* 1713396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713406 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1713409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713430 */     // GIR_Coverage, 10351,
     /* 1713430 */     GIR_EraseRootFromParent_Done,
     /* 1713431 */   // Label 23444: @1713431
     /* 1713431 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1713517), // Rule ID 10354 //
     /* 1713436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713482 */     // MIs[0] policy
     /* 1713482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713516 */     // GIR_Coverage, 10354,
     /* 1713516 */     GIR_EraseRootFromParent_Done,
     /* 1713517 */   // Label 23445: @1713517
     /* 1713517 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1713603), // Rule ID 10355 //
     /* 1713522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713568 */     // MIs[0] policy
     /* 1713568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713578 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713602 */     // GIR_Coverage, 10355,
     /* 1713602 */     GIR_EraseRootFromParent_Done,
     /* 1713603 */   // Label 23446: @1713603
     /* 1713603 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1713689), // Rule ID 10358 //
     /* 1713608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713654 */     // MIs[0] policy
     /* 1713654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713688 */     // GIR_Coverage, 10358,
     /* 1713688 */     GIR_EraseRootFromParent_Done,
     /* 1713689 */   // Label 23447: @1713689
     /* 1713689 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1713775), // Rule ID 10359 //
     /* 1713694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713740 */     // MIs[0] policy
     /* 1713740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713750 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713774 */     // GIR_Coverage, 10359,
     /* 1713774 */     GIR_EraseRootFromParent_Done,
     /* 1713775 */   // Label 23448: @1713775
     /* 1713775 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1713861), // Rule ID 10362 //
     /* 1713780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713826 */     // MIs[0] policy
     /* 1713826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713860 */     // GIR_Coverage, 10362,
     /* 1713860 */     GIR_EraseRootFromParent_Done,
     /* 1713861 */   // Label 23449: @1713861
     /* 1713861 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1713947), // Rule ID 10363 //
     /* 1713866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713912 */     // MIs[0] policy
     /* 1713912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713946 */     // GIR_Coverage, 10363,
     /* 1713946 */     GIR_EraseRootFromParent_Done,
     /* 1713947 */   // Label 23450: @1713947
     /* 1713947 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1714033), // Rule ID 10366 //
     /* 1713952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713998 */     // MIs[0] policy
     /* 1713998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714032 */     // GIR_Coverage, 10366,
     /* 1714032 */     GIR_EraseRootFromParent_Done,
     /* 1714033 */   // Label 23451: @1714033
     /* 1714033 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1714119), // Rule ID 10367 //
     /* 1714038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1714049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1714052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1714055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714084 */     // MIs[0] policy
     /* 1714084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714118 */     // GIR_Coverage, 10367,
     /* 1714118 */     GIR_EraseRootFromParent_Done,
     /* 1714119 */   // Label 23452: @1714119
     /* 1714119 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1714205), // Rule ID 10370 //
     /* 1714124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714170 */     // MIs[0] policy
     /* 1714170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714204 */     // GIR_Coverage, 10370,
     /* 1714204 */     GIR_EraseRootFromParent_Done,
     /* 1714205 */   // Label 23453: @1714205
     /* 1714205 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1714291), // Rule ID 10371 //
     /* 1714210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714256 */     // MIs[0] policy
     /* 1714256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714266 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1714269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714290 */     // GIR_Coverage, 10371,
     /* 1714290 */     GIR_EraseRootFromParent_Done,
     /* 1714291 */   // Label 23454: @1714291
     /* 1714291 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1714377), // Rule ID 10374 //
     /* 1714296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714342 */     // MIs[0] policy
     /* 1714342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714376 */     // GIR_Coverage, 10374,
     /* 1714376 */     GIR_EraseRootFromParent_Done,
     /* 1714377 */   // Label 23455: @1714377
     /* 1714377 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1714463), // Rule ID 10375 //
     /* 1714382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714428 */     // MIs[0] policy
     /* 1714428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714462 */     // GIR_Coverage, 10375,
     /* 1714462 */     GIR_EraseRootFromParent_Done,
     /* 1714463 */   // Label 23456: @1714463
     /* 1714463 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1714549), // Rule ID 10378 //
     /* 1714468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714514 */     // MIs[0] policy
     /* 1714514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714548 */     // GIR_Coverage, 10378,
     /* 1714548 */     GIR_EraseRootFromParent_Done,
     /* 1714549 */   // Label 23457: @1714549
     /* 1714549 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1714635), // Rule ID 10379 //
     /* 1714554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714600 */     // MIs[0] policy
     /* 1714600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714634 */     // GIR_Coverage, 10379,
     /* 1714634 */     GIR_EraseRootFromParent_Done,
     /* 1714635 */   // Label 23458: @1714635
     /* 1714635 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1714721), // Rule ID 10382 //
     /* 1714640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714686 */     // MIs[0] policy
     /* 1714686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714720 */     // GIR_Coverage, 10382,
     /* 1714720 */     GIR_EraseRootFromParent_Done,
     /* 1714721 */   // Label 23459: @1714721
     /* 1714721 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1714807), // Rule ID 10383 //
     /* 1714726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714772 */     // MIs[0] policy
     /* 1714772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714806 */     // GIR_Coverage, 10383,
     /* 1714806 */     GIR_EraseRootFromParent_Done,
     /* 1714807 */   // Label 23460: @1714807
     /* 1714807 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1714893), // Rule ID 10386 //
     /* 1714812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714858 */     // MIs[0] policy
     /* 1714858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714892 */     // GIR_Coverage, 10386,
     /* 1714892 */     GIR_EraseRootFromParent_Done,
     /* 1714893 */   // Label 23461: @1714893
     /* 1714893 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1714979), // Rule ID 10387 //
     /* 1714898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714944 */     // MIs[0] policy
     /* 1714944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714978 */     // GIR_Coverage, 10387,
     /* 1714978 */     GIR_EraseRootFromParent_Done,
     /* 1714979 */   // Label 23462: @1714979
     /* 1714979 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1715065), // Rule ID 10390 //
     /* 1714984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715030 */     // MIs[0] policy
     /* 1715030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715064 */     // GIR_Coverage, 10390,
     /* 1715064 */     GIR_EraseRootFromParent_Done,
     /* 1715065 */   // Label 23463: @1715065
     /* 1715065 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1715151), // Rule ID 10391 //
     /* 1715070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1715081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1715084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715116 */     // MIs[0] policy
     /* 1715116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715150 */     // GIR_Coverage, 10391,
     /* 1715150 */     GIR_EraseRootFromParent_Done,
     /* 1715151 */   // Label 23464: @1715151
     /* 1715151 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1715237), // Rule ID 10394 //
     /* 1715156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715202 */     // MIs[0] policy
     /* 1715202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715212 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715236 */     // GIR_Coverage, 10394,
     /* 1715236 */     GIR_EraseRootFromParent_Done,
     /* 1715237 */   // Label 23465: @1715237
     /* 1715237 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1715323), // Rule ID 10395 //
     /* 1715242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715288 */     // MIs[0] policy
     /* 1715288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715298 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715322 */     // GIR_Coverage, 10395,
     /* 1715322 */     GIR_EraseRootFromParent_Done,
     /* 1715323 */   // Label 23466: @1715323
     /* 1715323 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1715409), // Rule ID 10398 //
     /* 1715328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715374 */     // MIs[0] policy
     /* 1715374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715384 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715408 */     // GIR_Coverage, 10398,
     /* 1715408 */     GIR_EraseRootFromParent_Done,
     /* 1715409 */   // Label 23467: @1715409
     /* 1715409 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1715495), // Rule ID 10399 //
     /* 1715414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715460 */     // MIs[0] policy
     /* 1715460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715470 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715494 */     // GIR_Coverage, 10399,
     /* 1715494 */     GIR_EraseRootFromParent_Done,
     /* 1715495 */   // Label 23468: @1715495
     /* 1715495 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1715581), // Rule ID 10402 //
     /* 1715500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715546 */     // MIs[0] policy
     /* 1715546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715580 */     // GIR_Coverage, 10402,
     /* 1715580 */     GIR_EraseRootFromParent_Done,
     /* 1715581 */   // Label 23469: @1715581
     /* 1715581 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1715667), // Rule ID 10403 //
     /* 1715586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715632 */     // MIs[0] policy
     /* 1715632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715666 */     // GIR_Coverage, 10403,
     /* 1715666 */     GIR_EraseRootFromParent_Done,
     /* 1715667 */   // Label 23470: @1715667
     /* 1715667 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1715753), // Rule ID 10406 //
     /* 1715672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715718 */     // MIs[0] policy
     /* 1715718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715752 */     // GIR_Coverage, 10406,
     /* 1715752 */     GIR_EraseRootFromParent_Done,
     /* 1715753 */   // Label 23471: @1715753
     /* 1715753 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1715839), // Rule ID 10407 //
     /* 1715758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715804 */     // MIs[0] policy
     /* 1715804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715838 */     // GIR_Coverage, 10407,
     /* 1715838 */     GIR_EraseRootFromParent_Done,
     /* 1715839 */   // Label 23472: @1715839
     /* 1715839 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1715925), // Rule ID 10410 //
     /* 1715844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715890 */     // MIs[0] policy
     /* 1715890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715900 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715924 */     // GIR_Coverage, 10410,
     /* 1715924 */     GIR_EraseRootFromParent_Done,
     /* 1715925 */   // Label 23473: @1715925
     /* 1715925 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1716011), // Rule ID 10411 //
     /* 1715930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715976 */     // MIs[0] policy
     /* 1715976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716010 */     // GIR_Coverage, 10411,
     /* 1716010 */     GIR_EraseRootFromParent_Done,
     /* 1716011 */   // Label 23474: @1716011
     /* 1716011 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1716097), // Rule ID 10414 //
     /* 1716016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716062 */     // MIs[0] policy
     /* 1716062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716096 */     // GIR_Coverage, 10414,
     /* 1716096 */     GIR_EraseRootFromParent_Done,
     /* 1716097 */   // Label 23475: @1716097
     /* 1716097 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1716183), // Rule ID 10415 //
     /* 1716102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716148 */     // MIs[0] policy
     /* 1716148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716182 */     // GIR_Coverage, 10415,
     /* 1716182 */     GIR_EraseRootFromParent_Done,
     /* 1716183 */   // Label 23476: @1716183
     /* 1716183 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1716269), // Rule ID 10418 //
     /* 1716188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716234 */     // MIs[0] policy
     /* 1716234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716268 */     // GIR_Coverage, 10418,
     /* 1716268 */     GIR_EraseRootFromParent_Done,
     /* 1716269 */   // Label 23477: @1716269
     /* 1716269 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1716355), // Rule ID 10419 //
     /* 1716274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716320 */     // MIs[0] policy
     /* 1716320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716354 */     // GIR_Coverage, 10419,
     /* 1716354 */     GIR_EraseRootFromParent_Done,
     /* 1716355 */   // Label 23478: @1716355
     /* 1716355 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1716441), // Rule ID 10422 //
     /* 1716360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716406 */     // MIs[0] policy
     /* 1716406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716440 */     // GIR_Coverage, 10422,
     /* 1716440 */     GIR_EraseRootFromParent_Done,
     /* 1716441 */   // Label 23479: @1716441
     /* 1716441 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1716527), // Rule ID 10423 //
     /* 1716446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716492 */     // MIs[0] policy
     /* 1716492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716526 */     // GIR_Coverage, 10423,
     /* 1716526 */     GIR_EraseRootFromParent_Done,
     /* 1716527 */   // Label 23480: @1716527
     /* 1716527 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1716613), // Rule ID 10426 //
     /* 1716532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716578 */     // MIs[0] policy
     /* 1716578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716612 */     // GIR_Coverage, 10426,
     /* 1716612 */     GIR_EraseRootFromParent_Done,
     /* 1716613 */   // Label 23481: @1716613
     /* 1716613 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1716699), // Rule ID 10427 //
     /* 1716618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716664 */     // MIs[0] policy
     /* 1716664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716698 */     // GIR_Coverage, 10427,
     /* 1716698 */     GIR_EraseRootFromParent_Done,
     /* 1716699 */   // Label 23482: @1716699
     /* 1716699 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1716785), // Rule ID 10430 //
     /* 1716704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716750 */     // MIs[0] policy
     /* 1716750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716784 */     // GIR_Coverage, 10430,
     /* 1716784 */     GIR_EraseRootFromParent_Done,
     /* 1716785 */   // Label 23483: @1716785
     /* 1716785 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1716871), // Rule ID 10431 //
     /* 1716790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716836 */     // MIs[0] policy
     /* 1716836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716870 */     // GIR_Coverage, 10431,
     /* 1716870 */     GIR_EraseRootFromParent_Done,
     /* 1716871 */   // Label 23484: @1716871
     /* 1716871 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1716957), // Rule ID 10434 //
     /* 1716876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716922 */     // MIs[0] policy
     /* 1716922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716956 */     // GIR_Coverage, 10434,
     /* 1716956 */     GIR_EraseRootFromParent_Done,
     /* 1716957 */   // Label 23485: @1716957
     /* 1716957 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1717043), // Rule ID 10435 //
     /* 1716962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717008 */     // MIs[0] policy
     /* 1717008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1717021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717042 */     // GIR_Coverage, 10435,
     /* 1717042 */     GIR_EraseRootFromParent_Done,
     /* 1717043 */   // Label 23486: @1717043
     /* 1717043 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1717129), // Rule ID 10438 //
     /* 1717048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717094 */     // MIs[0] policy
     /* 1717094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717104 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1717107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717128 */     // GIR_Coverage, 10438,
     /* 1717128 */     GIR_EraseRootFromParent_Done,
     /* 1717129 */   // Label 23487: @1717129
     /* 1717129 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1717215), // Rule ID 10439 //
     /* 1717134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717180 */     // MIs[0] policy
     /* 1717180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1717193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717214 */     // GIR_Coverage, 10439,
     /* 1717214 */     GIR_EraseRootFromParent_Done,
     /* 1717215 */   // Label 23488: @1717215
     /* 1717215 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1717301), // Rule ID 10442 //
     /* 1717220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717266 */     // MIs[0] policy
     /* 1717266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717276 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717300 */     // GIR_Coverage, 10442,
     /* 1717300 */     GIR_EraseRootFromParent_Done,
     /* 1717301 */   // Label 23489: @1717301
     /* 1717301 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1717387), // Rule ID 10443 //
     /* 1717306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717352 */     // MIs[0] policy
     /* 1717352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717362 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717386 */     // GIR_Coverage, 10443,
     /* 1717386 */     GIR_EraseRootFromParent_Done,
     /* 1717387 */   // Label 23490: @1717387
     /* 1717387 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1717473), // Rule ID 10446 //
     /* 1717392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717438 */     // MIs[0] policy
     /* 1717438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717472 */     // GIR_Coverage, 10446,
     /* 1717472 */     GIR_EraseRootFromParent_Done,
     /* 1717473 */   // Label 23491: @1717473
     /* 1717473 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1717559), // Rule ID 10447 //
     /* 1717478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717524 */     // MIs[0] policy
     /* 1717524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717534 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717558 */     // GIR_Coverage, 10447,
     /* 1717558 */     GIR_EraseRootFromParent_Done,
     /* 1717559 */   // Label 23492: @1717559
     /* 1717559 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1717645), // Rule ID 10450 //
     /* 1717564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717610 */     // MIs[0] policy
     /* 1717610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717644 */     // GIR_Coverage, 10450,
     /* 1717644 */     GIR_EraseRootFromParent_Done,
     /* 1717645 */   // Label 23493: @1717645
     /* 1717645 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1717731), // Rule ID 10451 //
     /* 1717650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717696 */     // MIs[0] policy
     /* 1717696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717730 */     // GIR_Coverage, 10451,
     /* 1717730 */     GIR_EraseRootFromParent_Done,
     /* 1717731 */   // Label 23494: @1717731
     /* 1717731 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1717817), // Rule ID 10454 //
     /* 1717736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717782 */     // MIs[0] policy
     /* 1717782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717816 */     // GIR_Coverage, 10454,
     /* 1717816 */     GIR_EraseRootFromParent_Done,
     /* 1717817 */   // Label 23495: @1717817
     /* 1717817 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1717903), // Rule ID 10455 //
     /* 1717822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717868 */     // MIs[0] policy
     /* 1717868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717902 */     // GIR_Coverage, 10455,
     /* 1717902 */     GIR_EraseRootFromParent_Done,
     /* 1717903 */   // Label 23496: @1717903
     /* 1717903 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1717989), // Rule ID 10458 //
     /* 1717908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717954 */     // MIs[0] policy
     /* 1717954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717988 */     // GIR_Coverage, 10458,
     /* 1717988 */     GIR_EraseRootFromParent_Done,
     /* 1717989 */   // Label 23497: @1717989
     /* 1717989 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1718075), // Rule ID 10459 //
     /* 1717994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1718005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1718008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1718011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1718014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718040 */     // MIs[0] policy
     /* 1718040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1718053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718074 */     // GIR_Coverage, 10459,
     /* 1718074 */     GIR_EraseRootFromParent_Done,
     /* 1718075 */   // Label 23498: @1718075
     /* 1718075 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1718161), // Rule ID 10462 //
     /* 1718080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718126 */     // MIs[0] policy
     /* 1718126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718160 */     // GIR_Coverage, 10462,
     /* 1718160 */     GIR_EraseRootFromParent_Done,
     /* 1718161 */   // Label 23499: @1718161
     /* 1718161 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1718247), // Rule ID 10463 //
     /* 1718166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718212 */     // MIs[0] policy
     /* 1718212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718246 */     // GIR_Coverage, 10463,
     /* 1718246 */     GIR_EraseRootFromParent_Done,
     /* 1718247 */   // Label 23500: @1718247
     /* 1718247 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1718333), // Rule ID 10466 //
     /* 1718252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718298 */     // MIs[0] policy
     /* 1718298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718332 */     // GIR_Coverage, 10466,
     /* 1718332 */     GIR_EraseRootFromParent_Done,
     /* 1718333 */   // Label 23501: @1718333
     /* 1718333 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1718419), // Rule ID 10467 //
     /* 1718338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718384 */     // MIs[0] policy
     /* 1718384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718418 */     // GIR_Coverage, 10467,
     /* 1718418 */     GIR_EraseRootFromParent_Done,
     /* 1718419 */   // Label 23502: @1718419
     /* 1718419 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1718505), // Rule ID 10470 //
     /* 1718424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718470 */     // MIs[0] policy
     /* 1718470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718504 */     // GIR_Coverage, 10470,
     /* 1718504 */     GIR_EraseRootFromParent_Done,
     /* 1718505 */   // Label 23503: @1718505
     /* 1718505 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1718591), // Rule ID 10471 //
     /* 1718510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718556 */     // MIs[0] policy
     /* 1718556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718590 */     // GIR_Coverage, 10471,
     /* 1718590 */     GIR_EraseRootFromParent_Done,
     /* 1718591 */   // Label 23504: @1718591
     /* 1718591 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1718677), // Rule ID 10474 //
     /* 1718596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718642 */     // MIs[0] policy
     /* 1718642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718676 */     // GIR_Coverage, 10474,
     /* 1718676 */     GIR_EraseRootFromParent_Done,
     /* 1718677 */   // Label 23505: @1718677
     /* 1718677 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1718763), // Rule ID 10475 //
     /* 1718682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718728 */     // MIs[0] policy
     /* 1718728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718762 */     // GIR_Coverage, 10475,
     /* 1718762 */     GIR_EraseRootFromParent_Done,
     /* 1718763 */   // Label 23506: @1718763
     /* 1718763 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1718849), // Rule ID 10478 //
     /* 1718768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718814 */     // MIs[0] policy
     /* 1718814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718824 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718848 */     // GIR_Coverage, 10478,
     /* 1718848 */     GIR_EraseRootFromParent_Done,
     /* 1718849 */   // Label 23507: @1718849
     /* 1718849 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1718935), // Rule ID 10479 //
     /* 1718854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718900 */     // MIs[0] policy
     /* 1718900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718934 */     // GIR_Coverage, 10479,
     /* 1718934 */     GIR_EraseRootFromParent_Done,
     /* 1718935 */   // Label 23508: @1718935
     /* 1718935 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1719021), // Rule ID 10482 //
     /* 1718940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718986 */     // MIs[0] policy
     /* 1718986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1718999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719020 */     // GIR_Coverage, 10482,
     /* 1719020 */     GIR_EraseRootFromParent_Done,
     /* 1719021 */   // Label 23509: @1719021
     /* 1719021 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1719107), // Rule ID 10483 //
     /* 1719026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1719037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1719040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1719043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1719046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719072 */     // MIs[0] policy
     /* 1719072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719082 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719106 */     // GIR_Coverage, 10483,
     /* 1719106 */     GIR_EraseRootFromParent_Done,
     /* 1719107 */   // Label 23510: @1719107
     /* 1719107 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1719193), // Rule ID 10486 //
     /* 1719112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719158 */     // MIs[0] policy
     /* 1719158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719168 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719192 */     // GIR_Coverage, 10486,
     /* 1719192 */     GIR_EraseRootFromParent_Done,
     /* 1719193 */   // Label 23511: @1719193
     /* 1719193 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1719279), // Rule ID 10487 //
     /* 1719198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719244 */     // MIs[0] policy
     /* 1719244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719254 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719278 */     // GIR_Coverage, 10487,
     /* 1719278 */     GIR_EraseRootFromParent_Done,
     /* 1719279 */   // Label 23512: @1719279
     /* 1719279 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1719365), // Rule ID 10490 //
     /* 1719284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719330 */     // MIs[0] policy
     /* 1719330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719364 */     // GIR_Coverage, 10490,
     /* 1719364 */     GIR_EraseRootFromParent_Done,
     /* 1719365 */   // Label 23513: @1719365
     /* 1719365 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1719451), // Rule ID 10491 //
     /* 1719370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719416 */     // MIs[0] policy
     /* 1719416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719450 */     // GIR_Coverage, 10491,
     /* 1719450 */     GIR_EraseRootFromParent_Done,
     /* 1719451 */   // Label 23514: @1719451
     /* 1719451 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1719537), // Rule ID 10494 //
     /* 1719456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719502 */     // MIs[0] policy
     /* 1719502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719512 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719536 */     // GIR_Coverage, 10494,
     /* 1719536 */     GIR_EraseRootFromParent_Done,
     /* 1719537 */   // Label 23515: @1719537
     /* 1719537 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1719623), // Rule ID 10495 //
     /* 1719542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719588 */     // MIs[0] policy
     /* 1719588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719622 */     // GIR_Coverage, 10495,
     /* 1719622 */     GIR_EraseRootFromParent_Done,
     /* 1719623 */   // Label 23516: @1719623
     /* 1719623 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1719709), // Rule ID 10498 //
     /* 1719628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719674 */     // MIs[0] policy
     /* 1719674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719708 */     // GIR_Coverage, 10498,
     /* 1719708 */     GIR_EraseRootFromParent_Done,
     /* 1719709 */   // Label 23517: @1719709
     /* 1719709 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1719795), // Rule ID 10499 //
     /* 1719714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719760 */     // MIs[0] policy
     /* 1719760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719794 */     // GIR_Coverage, 10499,
     /* 1719794 */     GIR_EraseRootFromParent_Done,
     /* 1719795 */   // Label 23518: @1719795
     /* 1719795 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1719881), // Rule ID 10502 //
     /* 1719800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719846 */     // MIs[0] policy
     /* 1719846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719880 */     // GIR_Coverage, 10502,
     /* 1719880 */     GIR_EraseRootFromParent_Done,
     /* 1719881 */   // Label 23519: @1719881
     /* 1719881 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1719967), // Rule ID 10503 //
     /* 1719886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719932 */     // MIs[0] policy
     /* 1719932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719966 */     // GIR_Coverage, 10503,
     /* 1719966 */     GIR_EraseRootFromParent_Done,
     /* 1719967 */   // Label 23520: @1719967
     /* 1719967 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1720053), // Rule ID 10506 //
     /* 1719972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1719992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720018 */     // MIs[0] policy
     /* 1720018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720052 */     // GIR_Coverage, 10506,
     /* 1720052 */     GIR_EraseRootFromParent_Done,
     /* 1720053 */   // Label 23521: @1720053
     /* 1720053 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1720139), // Rule ID 10507 //
     /* 1720058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1720069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1720072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1720075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1720078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720104 */     // MIs[0] policy
     /* 1720104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720138 */     // GIR_Coverage, 10507,
     /* 1720138 */     GIR_EraseRootFromParent_Done,
     /* 1720139 */   // Label 23522: @1720139
     /* 1720139 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1720225), // Rule ID 10510 //
     /* 1720144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720190 */     // MIs[0] policy
     /* 1720190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720224 */     // GIR_Coverage, 10510,
     /* 1720224 */     GIR_EraseRootFromParent_Done,
     /* 1720225 */   // Label 23523: @1720225
     /* 1720225 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1720311), // Rule ID 10511 //
     /* 1720230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720276 */     // MIs[0] policy
     /* 1720276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720310 */     // GIR_Coverage, 10511,
     /* 1720310 */     GIR_EraseRootFromParent_Done,
     /* 1720311 */   // Label 23524: @1720311
     /* 1720311 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1720397), // Rule ID 10514 //
     /* 1720316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720362 */     // MIs[0] policy
     /* 1720362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1720375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720396 */     // GIR_Coverage, 10514,
     /* 1720396 */     GIR_EraseRootFromParent_Done,
     /* 1720397 */   // Label 23525: @1720397
     /* 1720397 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1720483), // Rule ID 10515 //
     /* 1720402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720448 */     // MIs[0] policy
     /* 1720448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1720461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720482 */     // GIR_Coverage, 10515,
     /* 1720482 */     GIR_EraseRootFromParent_Done,
     /* 1720483 */   // Label 23526: @1720483
     /* 1720483 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1720569), // Rule ID 10518 //
     /* 1720488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720534 */     // MIs[0] policy
     /* 1720534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720568 */     // GIR_Coverage, 10518,
     /* 1720568 */     GIR_EraseRootFromParent_Done,
     /* 1720569 */   // Label 23527: @1720569
     /* 1720569 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1720655), // Rule ID 10519 //
     /* 1720574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720620 */     // MIs[0] policy
     /* 1720620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720630 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720654 */     // GIR_Coverage, 10519,
     /* 1720654 */     GIR_EraseRootFromParent_Done,
     /* 1720655 */   // Label 23528: @1720655
     /* 1720655 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1720741), // Rule ID 10522 //
     /* 1720660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720706 */     // MIs[0] policy
     /* 1720706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720740 */     // GIR_Coverage, 10522,
     /* 1720740 */     GIR_EraseRootFromParent_Done,
     /* 1720741 */   // Label 23529: @1720741
     /* 1720741 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1720827), // Rule ID 10523 //
     /* 1720746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720792 */     // MIs[0] policy
     /* 1720792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720826 */     // GIR_Coverage, 10523,
     /* 1720826 */     GIR_EraseRootFromParent_Done,
     /* 1720827 */   // Label 23530: @1720827
     /* 1720827 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1720913), // Rule ID 10526 //
     /* 1720832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720878 */     // MIs[0] policy
     /* 1720878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720888 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720912 */     // GIR_Coverage, 10526,
     /* 1720912 */     GIR_EraseRootFromParent_Done,
     /* 1720913 */   // Label 23531: @1720913
     /* 1720913 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1720999), // Rule ID 10527 //
     /* 1720918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720964 */     // MIs[0] policy
     /* 1720964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720974 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720998 */     // GIR_Coverage, 10527,
     /* 1720998 */     GIR_EraseRootFromParent_Done,
     /* 1720999 */   // Label 23532: @1720999
     /* 1720999 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1721085), // Rule ID 10530 //
     /* 1721004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721050 */     // MIs[0] policy
     /* 1721050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721084 */     // GIR_Coverage, 10530,
     /* 1721084 */     GIR_EraseRootFromParent_Done,
     /* 1721085 */   // Label 23533: @1721085
     /* 1721085 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1721171), // Rule ID 10531 //
     /* 1721090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721136 */     // MIs[0] policy
     /* 1721136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721170 */     // GIR_Coverage, 10531,
     /* 1721170 */     GIR_EraseRootFromParent_Done,
     /* 1721171 */   // Label 23534: @1721171
     /* 1721171 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1721257), // Rule ID 10534 //
     /* 1721176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721222 */     // MIs[0] policy
     /* 1721222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721256 */     // GIR_Coverage, 10534,
     /* 1721256 */     GIR_EraseRootFromParent_Done,
     /* 1721257 */   // Label 23535: @1721257
     /* 1721257 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1721343), // Rule ID 10535 //
     /* 1721262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721308 */     // MIs[0] policy
     /* 1721308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721342 */     // GIR_Coverage, 10535,
     /* 1721342 */     GIR_EraseRootFromParent_Done,
     /* 1721343 */   // Label 23536: @1721343
     /* 1721343 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1721429), // Rule ID 10538 //
     /* 1721348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721394 */     // MIs[0] policy
     /* 1721394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721404 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721428 */     // GIR_Coverage, 10538,
     /* 1721428 */     GIR_EraseRootFromParent_Done,
     /* 1721429 */   // Label 23537: @1721429
     /* 1721429 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1721515), // Rule ID 10539 //
     /* 1721434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721480 */     // MIs[0] policy
     /* 1721480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721514 */     // GIR_Coverage, 10539,
     /* 1721514 */     GIR_EraseRootFromParent_Done,
     /* 1721515 */   // Label 23538: @1721515
     /* 1721515 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1721601), // Rule ID 10542 //
     /* 1721520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721566 */     // MIs[0] policy
     /* 1721566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721600 */     // GIR_Coverage, 10542,
     /* 1721600 */     GIR_EraseRootFromParent_Done,
     /* 1721601 */   // Label 23539: @1721601
     /* 1721601 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1721687), // Rule ID 10543 //
     /* 1721606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721652 */     // MIs[0] policy
     /* 1721652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721686 */     // GIR_Coverage, 10543,
     /* 1721686 */     GIR_EraseRootFromParent_Done,
     /* 1721687 */   // Label 23540: @1721687
     /* 1721687 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1721773), // Rule ID 10546 //
     /* 1721692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721738 */     // MIs[0] policy
     /* 1721738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721772 */     // GIR_Coverage, 10546,
     /* 1721772 */     GIR_EraseRootFromParent_Done,
     /* 1721773 */   // Label 23541: @1721773
     /* 1721773 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1721859), // Rule ID 10547 //
     /* 1721778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721824 */     // MIs[0] policy
     /* 1721824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721834 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721858 */     // GIR_Coverage, 10547,
     /* 1721858 */     GIR_EraseRootFromParent_Done,
     /* 1721859 */   // Label 23542: @1721859
     /* 1721859 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1721945), // Rule ID 10550 //
     /* 1721864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721910 */     // MIs[0] policy
     /* 1721910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721944 */     // GIR_Coverage, 10550,
     /* 1721944 */     GIR_EraseRootFromParent_Done,
     /* 1721945 */   // Label 23543: @1721945
     /* 1721945 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1722031), // Rule ID 10551 //
     /* 1721950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721996 */     // MIs[0] policy
     /* 1721996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722030 */     // GIR_Coverage, 10551,
     /* 1722030 */     GIR_EraseRootFromParent_Done,
     /* 1722031 */   // Label 23544: @1722031
     /* 1722031 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1722117), // Rule ID 10554 //
     /* 1722036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722082 */     // MIs[0] policy
     /* 1722082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722116 */     // GIR_Coverage, 10554,
     /* 1722116 */     GIR_EraseRootFromParent_Done,
     /* 1722117 */   // Label 23545: @1722117
     /* 1722117 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1722203), // Rule ID 10555 //
     /* 1722122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722168 */     // MIs[0] policy
     /* 1722168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722178 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722202 */     // GIR_Coverage, 10555,
     /* 1722202 */     GIR_EraseRootFromParent_Done,
     /* 1722203 */   // Label 23546: @1722203
     /* 1722203 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1722289), // Rule ID 10558 //
     /* 1722208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722254 */     // MIs[0] policy
     /* 1722254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722288 */     // GIR_Coverage, 10558,
     /* 1722288 */     GIR_EraseRootFromParent_Done,
     /* 1722289 */   // Label 23547: @1722289
     /* 1722289 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1722375), // Rule ID 10559 //
     /* 1722294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722340 */     // MIs[0] policy
     /* 1722340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722374 */     // GIR_Coverage, 10559,
     /* 1722374 */     GIR_EraseRootFromParent_Done,
     /* 1722375 */   // Label 23548: @1722375
     /* 1722375 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1722461), // Rule ID 10562 //
     /* 1722380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1722383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722426 */     // MIs[0] policy
     /* 1722426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722460 */     // GIR_Coverage, 10562,
     /* 1722460 */     GIR_EraseRootFromParent_Done,
     /* 1722461 */   // Label 23549: @1722461
     /* 1722461 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1722547), // Rule ID 10563 //
     /* 1722466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722512 */     // MIs[0] policy
     /* 1722512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722522 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722546 */     // GIR_Coverage, 10563,
     /* 1722546 */     GIR_EraseRootFromParent_Done,
     /* 1722547 */   // Label 23550: @1722547
     /* 1722547 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1722633), // Rule ID 10566 //
     /* 1722552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722598 */     // MIs[0] policy
     /* 1722598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722632 */     // GIR_Coverage, 10566,
     /* 1722632 */     GIR_EraseRootFromParent_Done,
     /* 1722633 */   // Label 23551: @1722633
     /* 1722633 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1722719), // Rule ID 10567 //
     /* 1722638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722684 */     // MIs[0] policy
     /* 1722684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722718 */     // GIR_Coverage, 10567,
     /* 1722718 */     GIR_EraseRootFromParent_Done,
     /* 1722719 */   // Label 23552: @1722719
     /* 1722719 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1722805), // Rule ID 10570 //
     /* 1722724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722770 */     // MIs[0] policy
     /* 1722770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722780 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722804 */     // GIR_Coverage, 10570,
     /* 1722804 */     GIR_EraseRootFromParent_Done,
     /* 1722805 */   // Label 23553: @1722805
     /* 1722805 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1722891), // Rule ID 10571 //
     /* 1722810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722856 */     // MIs[0] policy
     /* 1722856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722866 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722890 */     // GIR_Coverage, 10571,
     /* 1722890 */     GIR_EraseRootFromParent_Done,
     /* 1722891 */   // Label 23554: @1722891
     /* 1722891 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1722977), // Rule ID 10574 //
     /* 1722896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722942 */     // MIs[0] policy
     /* 1722942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722976 */     // GIR_Coverage, 10574,
     /* 1722976 */     GIR_EraseRootFromParent_Done,
     /* 1722977 */   // Label 23555: @1722977
     /* 1722977 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1723063), // Rule ID 10575 //
     /* 1722982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1723005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723028 */     // MIs[0] policy
     /* 1723028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723038 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723062 */     // GIR_Coverage, 10575,
     /* 1723062 */     GIR_EraseRootFromParent_Done,
     /* 1723063 */   // Label 23556: @1723063
     /* 1723063 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1723149), // Rule ID 10578 //
     /* 1723068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723114 */     // MIs[0] policy
     /* 1723114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723148 */     // GIR_Coverage, 10578,
     /* 1723148 */     GIR_EraseRootFromParent_Done,
     /* 1723149 */   // Label 23557: @1723149
     /* 1723149 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1723235), // Rule ID 10579 //
     /* 1723154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723200 */     // MIs[0] policy
     /* 1723200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723234 */     // GIR_Coverage, 10579,
     /* 1723234 */     GIR_EraseRootFromParent_Done,
     /* 1723235 */   // Label 23558: @1723235
     /* 1723235 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1723321), // Rule ID 10582 //
     /* 1723240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723286 */     // MIs[0] policy
     /* 1723286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723320 */     // GIR_Coverage, 10582,
     /* 1723320 */     GIR_EraseRootFromParent_Done,
     /* 1723321 */   // Label 23559: @1723321
     /* 1723321 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1723407), // Rule ID 10583 //
     /* 1723326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723372 */     // MIs[0] policy
     /* 1723372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723406 */     // GIR_Coverage, 10583,
     /* 1723406 */     GIR_EraseRootFromParent_Done,
     /* 1723407 */   // Label 23560: @1723407
     /* 1723407 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1723493), // Rule ID 10586 //
     /* 1723412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723458 */     // MIs[0] policy
     /* 1723458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723492 */     // GIR_Coverage, 10586,
     /* 1723492 */     GIR_EraseRootFromParent_Done,
     /* 1723493 */   // Label 23561: @1723493
     /* 1723493 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1723579), // Rule ID 10587 //
     /* 1723498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723544 */     // MIs[0] policy
     /* 1723544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723578 */     // GIR_Coverage, 10587,
     /* 1723578 */     GIR_EraseRootFromParent_Done,
     /* 1723579 */   // Label 23562: @1723579
     /* 1723579 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1723665), // Rule ID 10590 //
     /* 1723584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723630 */     // MIs[0] policy
     /* 1723630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723664 */     // GIR_Coverage, 10590,
     /* 1723664 */     GIR_EraseRootFromParent_Done,
     /* 1723665 */   // Label 23563: @1723665
     /* 1723665 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1723751), // Rule ID 10591 //
     /* 1723670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723716 */     // MIs[0] policy
     /* 1723716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723750 */     // GIR_Coverage, 10591,
     /* 1723750 */     GIR_EraseRootFromParent_Done,
     /* 1723751 */   // Label 23564: @1723751
     /* 1723751 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1723837), // Rule ID 10594 //
     /* 1723756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723802 */     // MIs[0] policy
     /* 1723802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723836 */     // GIR_Coverage, 10594,
     /* 1723836 */     GIR_EraseRootFromParent_Done,
     /* 1723837 */   // Label 23565: @1723837
     /* 1723837 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1723923), // Rule ID 10595 //
     /* 1723842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723888 */     // MIs[0] policy
     /* 1723888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723922 */     // GIR_Coverage, 10595,
     /* 1723922 */     GIR_EraseRootFromParent_Done,
     /* 1723923 */   // Label 23566: @1723923
     /* 1723923 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1724009), // Rule ID 10598 //
     /* 1723928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723974 */     // MIs[0] policy
     /* 1723974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724008 */     // GIR_Coverage, 10598,
     /* 1724008 */     GIR_EraseRootFromParent_Done,
     /* 1724009 */   // Label 23567: @1724009
     /* 1724009 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1724095), // Rule ID 10599 //
     /* 1724014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1724025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1724028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1724031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724060 */     // MIs[0] policy
     /* 1724060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724094 */     // GIR_Coverage, 10599,
     /* 1724094 */     GIR_EraseRootFromParent_Done,
     /* 1724095 */   // Label 23568: @1724095
     /* 1724095 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1724181), // Rule ID 10602 //
     /* 1724100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724146 */     // MIs[0] policy
     /* 1724146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1724159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724180 */     // GIR_Coverage, 10602,
     /* 1724180 */     GIR_EraseRootFromParent_Done,
     /* 1724181 */   // Label 23569: @1724181
     /* 1724181 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1724267), // Rule ID 10603 //
     /* 1724186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724232 */     // MIs[0] policy
     /* 1724232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1724245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724266 */     // GIR_Coverage, 10603,
     /* 1724266 */     GIR_EraseRootFromParent_Done,
     /* 1724267 */   // Label 23570: @1724267
     /* 1724267 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1724353), // Rule ID 10606 //
     /* 1724272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724318 */     // MIs[0] policy
     /* 1724318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1724331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724352 */     // GIR_Coverage, 10606,
     /* 1724352 */     GIR_EraseRootFromParent_Done,
     /* 1724353 */   // Label 23571: @1724353
     /* 1724353 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1724439), // Rule ID 10607 //
     /* 1724358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724404 */     // MIs[0] policy
     /* 1724404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724414 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1724417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724438 */     // GIR_Coverage, 10607,
     /* 1724438 */     GIR_EraseRootFromParent_Done,
     /* 1724439 */   // Label 23572: @1724439
     /* 1724439 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1724525), // Rule ID 10610 //
     /* 1724444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724490 */     // MIs[0] policy
     /* 1724490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724524 */     // GIR_Coverage, 10610,
     /* 1724524 */     GIR_EraseRootFromParent_Done,
     /* 1724525 */   // Label 23573: @1724525
     /* 1724525 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1724611), // Rule ID 10611 //
     /* 1724530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724576 */     // MIs[0] policy
     /* 1724576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724610 */     // GIR_Coverage, 10611,
     /* 1724610 */     GIR_EraseRootFromParent_Done,
     /* 1724611 */   // Label 23574: @1724611
     /* 1724611 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1724697), // Rule ID 10614 //
     /* 1724616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724662 */     // MIs[0] policy
     /* 1724662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724696 */     // GIR_Coverage, 10614,
     /* 1724696 */     GIR_EraseRootFromParent_Done,
     /* 1724697 */   // Label 23575: @1724697
     /* 1724697 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1724783), // Rule ID 10615 //
     /* 1724702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724748 */     // MIs[0] policy
     /* 1724748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724782 */     // GIR_Coverage, 10615,
     /* 1724782 */     GIR_EraseRootFromParent_Done,
     /* 1724783 */   // Label 23576: @1724783
     /* 1724783 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1724869), // Rule ID 10618 //
     /* 1724788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724834 */     // MIs[0] policy
     /* 1724834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724868 */     // GIR_Coverage, 10618,
     /* 1724868 */     GIR_EraseRootFromParent_Done,
     /* 1724869 */   // Label 23577: @1724869
     /* 1724869 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1724955), // Rule ID 10619 //
     /* 1724874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724920 */     // MIs[0] policy
     /* 1724920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724930 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724954 */     // GIR_Coverage, 10619,
     /* 1724954 */     GIR_EraseRootFromParent_Done,
     /* 1724955 */   // Label 23578: @1724955
     /* 1724955 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1725041), // Rule ID 10622 //
     /* 1724960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725006 */     // MIs[0] policy
     /* 1725006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725040 */     // GIR_Coverage, 10622,
     /* 1725040 */     GIR_EraseRootFromParent_Done,
     /* 1725041 */   // Label 23579: @1725041
     /* 1725041 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1725127), // Rule ID 10623 //
     /* 1725046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1725057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1725060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1725063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1725066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725092 */     // MIs[0] policy
     /* 1725092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725102 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725126 */     // GIR_Coverage, 10623,
     /* 1725126 */     GIR_EraseRootFromParent_Done,
     /* 1725127 */   // Label 23580: @1725127
     /* 1725127 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1725213), // Rule ID 10626 //
     /* 1725132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725178 */     // MIs[0] policy
     /* 1725178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1725191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725212 */     // GIR_Coverage, 10626,
     /* 1725212 */     GIR_EraseRootFromParent_Done,
     /* 1725213 */   // Label 23581: @1725213
     /* 1725213 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1725299), // Rule ID 10627 //
     /* 1725218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725264 */     // MIs[0] policy
     /* 1725264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1725277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725298 */     // GIR_Coverage, 10627,
     /* 1725298 */     GIR_EraseRootFromParent_Done,
     /* 1725299 */   // Label 23582: @1725299
     /* 1725299 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1725385), // Rule ID 10630 //
     /* 1725304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725350 */     // MIs[0] policy
     /* 1725350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725384 */     // GIR_Coverage, 10630,
     /* 1725384 */     GIR_EraseRootFromParent_Done,
     /* 1725385 */   // Label 23583: @1725385
     /* 1725385 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1725471), // Rule ID 10631 //
     /* 1725390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725436 */     // MIs[0] policy
     /* 1725436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725446 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725470 */     // GIR_Coverage, 10631,
     /* 1725470 */     GIR_EraseRootFromParent_Done,
     /* 1725471 */   // Label 23584: @1725471
     /* 1725471 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1725557), // Rule ID 10634 //
     /* 1725476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725522 */     // MIs[0] policy
     /* 1725522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725556 */     // GIR_Coverage, 10634,
     /* 1725556 */     GIR_EraseRootFromParent_Done,
     /* 1725557 */   // Label 23585: @1725557
     /* 1725557 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1725643), // Rule ID 10635 //
     /* 1725562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725608 */     // MIs[0] policy
     /* 1725608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725618 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725642 */     // GIR_Coverage, 10635,
     /* 1725642 */     GIR_EraseRootFromParent_Done,
     /* 1725643 */   // Label 23586: @1725643
     /* 1725643 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1725729), // Rule ID 10638 //
     /* 1725648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725694 */     // MIs[0] policy
     /* 1725694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725728 */     // GIR_Coverage, 10638,
     /* 1725728 */     GIR_EraseRootFromParent_Done,
     /* 1725729 */   // Label 23587: @1725729
     /* 1725729 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1725815), // Rule ID 10639 //
     /* 1725734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725780 */     // MIs[0] policy
     /* 1725780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725814 */     // GIR_Coverage, 10639,
     /* 1725814 */     GIR_EraseRootFromParent_Done,
     /* 1725815 */   // Label 23588: @1725815
     /* 1725815 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1725901), // Rule ID 10642 //
     /* 1725820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725866 */     // MIs[0] policy
     /* 1725866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725900 */     // GIR_Coverage, 10642,
     /* 1725900 */     GIR_EraseRootFromParent_Done,
     /* 1725901 */   // Label 23589: @1725901
     /* 1725901 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1725987), // Rule ID 10643 //
     /* 1725906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725952 */     // MIs[0] policy
     /* 1725952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725986 */     // GIR_Coverage, 10643,
     /* 1725986 */     GIR_EraseRootFromParent_Done,
     /* 1725987 */   // Label 23590: @1725987
     /* 1725987 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1726073), // Rule ID 10646 //
     /* 1725992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726038 */     // MIs[0] policy
     /* 1726038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726072 */     // GIR_Coverage, 10646,
     /* 1726072 */     GIR_EraseRootFromParent_Done,
     /* 1726073 */   // Label 23591: @1726073
     /* 1726073 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1726159), // Rule ID 10647 //
     /* 1726078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726124 */     // MIs[0] policy
     /* 1726124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726158 */     // GIR_Coverage, 10647,
     /* 1726158 */     GIR_EraseRootFromParent_Done,
     /* 1726159 */   // Label 23592: @1726159
     /* 1726159 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1726245), // Rule ID 10650 //
     /* 1726164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1726167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726210 */     // MIs[0] policy
     /* 1726210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726244 */     // GIR_Coverage, 10650,
     /* 1726244 */     GIR_EraseRootFromParent_Done,
     /* 1726245 */   // Label 23593: @1726245
     /* 1726245 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1726331), // Rule ID 10651 //
     /* 1726250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1726253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726296 */     // MIs[0] policy
     /* 1726296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1726309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726330 */     // GIR_Coverage, 10651,
     /* 1726330 */     GIR_EraseRootFromParent_Done,
     /* 1726331 */   // Label 23594: @1726331
     /* 1726331 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1726417), // Rule ID 10654 //
     /* 1726336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726382 */     // MIs[0] policy
     /* 1726382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726416 */     // GIR_Coverage, 10654,
     /* 1726416 */     GIR_EraseRootFromParent_Done,
     /* 1726417 */   // Label 23595: @1726417
     /* 1726417 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1726503), // Rule ID 10655 //
     /* 1726422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726468 */     // MIs[0] policy
     /* 1726468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726502 */     // GIR_Coverage, 10655,
     /* 1726502 */     GIR_EraseRootFromParent_Done,
     /* 1726503 */   // Label 23596: @1726503
     /* 1726503 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1726589), // Rule ID 10658 //
     /* 1726508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726554 */     // MIs[0] policy
     /* 1726554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726564 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726588 */     // GIR_Coverage, 10658,
     /* 1726588 */     GIR_EraseRootFromParent_Done,
     /* 1726589 */   // Label 23597: @1726589
     /* 1726589 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1726675), // Rule ID 10659 //
     /* 1726594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726640 */     // MIs[0] policy
     /* 1726640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726650 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726674 */     // GIR_Coverage, 10659,
     /* 1726674 */     GIR_EraseRootFromParent_Done,
     /* 1726675 */   // Label 23598: @1726675
     /* 1726675 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1726761), // Rule ID 10662 //
     /* 1726680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726726 */     // MIs[0] policy
     /* 1726726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726736 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726760 */     // GIR_Coverage, 10662,
     /* 1726760 */     GIR_EraseRootFromParent_Done,
     /* 1726761 */   // Label 23599: @1726761
     /* 1726761 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1726847), // Rule ID 10663 //
     /* 1726766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726812 */     // MIs[0] policy
     /* 1726812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726822 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726846 */     // GIR_Coverage, 10663,
     /* 1726846 */     GIR_EraseRootFromParent_Done,
     /* 1726847 */   // Label 23600: @1726847
     /* 1726847 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1726933), // Rule ID 10666 //
     /* 1726852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726898 */     // MIs[0] policy
     /* 1726898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726932 */     // GIR_Coverage, 10666,
     /* 1726932 */     GIR_EraseRootFromParent_Done,
     /* 1726933 */   // Label 23601: @1726933
     /* 1726933 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1727019), // Rule ID 10667 //
     /* 1726938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726984 */     // MIs[0] policy
     /* 1726984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727018 */     // GIR_Coverage, 10667,
     /* 1727018 */     GIR_EraseRootFromParent_Done,
     /* 1727019 */   // Label 23602: @1727019
     /* 1727019 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1727105), // Rule ID 10670 //
     /* 1727024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727070 */     // MIs[0] policy
     /* 1727070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727104 */     // GIR_Coverage, 10670,
     /* 1727104 */     GIR_EraseRootFromParent_Done,
     /* 1727105 */   // Label 23603: @1727105
     /* 1727105 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1727191), // Rule ID 10671 //
     /* 1727110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727156 */     // MIs[0] policy
     /* 1727156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727190 */     // GIR_Coverage, 10671,
     /* 1727190 */     GIR_EraseRootFromParent_Done,
     /* 1727191 */   // Label 23604: @1727191
     /* 1727191 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1727277), // Rule ID 10674 //
     /* 1727196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727242 */     // MIs[0] policy
     /* 1727242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727276 */     // GIR_Coverage, 10674,
     /* 1727276 */     GIR_EraseRootFromParent_Done,
     /* 1727277 */   // Label 23605: @1727277
     /* 1727277 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1727363), // Rule ID 10675 //
     /* 1727282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727328 */     // MIs[0] policy
     /* 1727328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727362 */     // GIR_Coverage, 10675,
     /* 1727362 */     GIR_EraseRootFromParent_Done,
     /* 1727363 */   // Label 23606: @1727363
     /* 1727363 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1727449), // Rule ID 10678 //
     /* 1727368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727414 */     // MIs[0] policy
     /* 1727414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727448 */     // GIR_Coverage, 10678,
     /* 1727448 */     GIR_EraseRootFromParent_Done,
     /* 1727449 */   // Label 23607: @1727449
     /* 1727449 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1727535), // Rule ID 10679 //
     /* 1727454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727500 */     // MIs[0] policy
     /* 1727500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727534 */     // GIR_Coverage, 10679,
     /* 1727534 */     GIR_EraseRootFromParent_Done,
     /* 1727535 */   // Label 23608: @1727535
     /* 1727535 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1727621), // Rule ID 10682 //
     /* 1727540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727586 */     // MIs[0] policy
     /* 1727586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727620 */     // GIR_Coverage, 10682,
     /* 1727620 */     GIR_EraseRootFromParent_Done,
     /* 1727621 */   // Label 23609: @1727621
     /* 1727621 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1727707), // Rule ID 10683 //
     /* 1727626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727672 */     // MIs[0] policy
     /* 1727672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727706 */     // GIR_Coverage, 10683,
     /* 1727706 */     GIR_EraseRootFromParent_Done,
     /* 1727707 */   // Label 23610: @1727707
     /* 1727707 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1727793), // Rule ID 10686 //
     /* 1727712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727758 */     // MIs[0] policy
     /* 1727758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727792 */     // GIR_Coverage, 10686,
     /* 1727792 */     GIR_EraseRootFromParent_Done,
     /* 1727793 */   // Label 23611: @1727793
     /* 1727793 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1727879), // Rule ID 10687 //
     /* 1727798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727844 */     // MIs[0] policy
     /* 1727844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727878 */     // GIR_Coverage, 10687,
     /* 1727878 */     GIR_EraseRootFromParent_Done,
     /* 1727879 */   // Label 23612: @1727879
     /* 1727879 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1727965), // Rule ID 10690 //
     /* 1727884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727930 */     // MIs[0] policy
     /* 1727930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727964 */     // GIR_Coverage, 10690,
     /* 1727964 */     GIR_EraseRootFromParent_Done,
     /* 1727965 */   // Label 23613: @1727965
     /* 1727965 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1728051), // Rule ID 10691 //
     /* 1727970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728016 */     // MIs[0] policy
     /* 1728016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1728029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728050 */     // GIR_Coverage, 10691,
     /* 1728050 */     GIR_EraseRootFromParent_Done,
     /* 1728051 */   // Label 23614: @1728051
     /* 1728051 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1728137), // Rule ID 10694 //
     /* 1728056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728102 */     // MIs[0] policy
     /* 1728102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1728115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728136 */     // GIR_Coverage, 10694,
     /* 1728136 */     GIR_EraseRootFromParent_Done,
     /* 1728137 */   // Label 23615: @1728137
     /* 1728137 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1728223), // Rule ID 10695 //
     /* 1728142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728188 */     // MIs[0] policy
     /* 1728188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1728201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728222 */     // GIR_Coverage, 10695,
     /* 1728222 */     GIR_EraseRootFromParent_Done,
     /* 1728223 */   // Label 23616: @1728223
     /* 1728223 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1728309), // Rule ID 10698 //
     /* 1728228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728274 */     // MIs[0] policy
     /* 1728274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728284 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1728287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728308 */     // GIR_Coverage, 10698,
     /* 1728308 */     GIR_EraseRootFromParent_Done,
     /* 1728309 */   // Label 23617: @1728309
     /* 1728309 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1728395), // Rule ID 10699 //
     /* 1728314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728360 */     // MIs[0] policy
     /* 1728360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728370 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1728373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728394 */     // GIR_Coverage, 10699,
     /* 1728394 */     GIR_EraseRootFromParent_Done,
     /* 1728395 */   // Label 23618: @1728395
     /* 1728395 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1728481), // Rule ID 10702 //
     /* 1728400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728446 */     // MIs[0] policy
     /* 1728446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728456 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728480 */     // GIR_Coverage, 10702,
     /* 1728480 */     GIR_EraseRootFromParent_Done,
     /* 1728481 */   // Label 23619: @1728481
     /* 1728481 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1728567), // Rule ID 10703 //
     /* 1728486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728532 */     // MIs[0] policy
     /* 1728532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728542 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728566 */     // GIR_Coverage, 10703,
     /* 1728566 */     GIR_EraseRootFromParent_Done,
     /* 1728567 */   // Label 23620: @1728567
     /* 1728567 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1728653), // Rule ID 10706 //
     /* 1728572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728618 */     // MIs[0] policy
     /* 1728618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728628 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728652 */     // GIR_Coverage, 10706,
     /* 1728652 */     GIR_EraseRootFromParent_Done,
     /* 1728653 */   // Label 23621: @1728653
     /* 1728653 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1728739), // Rule ID 10707 //
     /* 1728658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728704 */     // MIs[0] policy
     /* 1728704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728738 */     // GIR_Coverage, 10707,
     /* 1728738 */     GIR_EraseRootFromParent_Done,
     /* 1728739 */   // Label 23622: @1728739
     /* 1728739 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1728825), // Rule ID 10710 //
     /* 1728744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728790 */     // MIs[0] policy
     /* 1728790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728800 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728824 */     // GIR_Coverage, 10710,
     /* 1728824 */     GIR_EraseRootFromParent_Done,
     /* 1728825 */   // Label 23623: @1728825
     /* 1728825 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1728911), // Rule ID 10711 //
     /* 1728830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728876 */     // MIs[0] policy
     /* 1728876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728886 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728910 */     // GIR_Coverage, 10711,
     /* 1728910 */     GIR_EraseRootFromParent_Done,
     /* 1728911 */   // Label 23624: @1728911
     /* 1728911 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1728997), // Rule ID 10714 //
     /* 1728916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728962 */     // MIs[0] policy
     /* 1728962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728996 */     // GIR_Coverage, 10714,
     /* 1728996 */     GIR_EraseRootFromParent_Done,
     /* 1728997 */   // Label 23625: @1728997
     /* 1728997 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1729083), // Rule ID 10715 //
     /* 1729002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1729013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1729016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1729019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729048 */     // MIs[0] policy
     /* 1729048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1729061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729082 */     // GIR_Coverage, 10715,
     /* 1729082 */     GIR_EraseRootFromParent_Done,
     /* 1729083 */   // Label 23626: @1729083
     /* 1729083 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1729169), // Rule ID 10718 //
     /* 1729088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729134 */     // MIs[0] policy
     /* 1729134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729168 */     // GIR_Coverage, 10718,
     /* 1729168 */     GIR_EraseRootFromParent_Done,
     /* 1729169 */   // Label 23627: @1729169
     /* 1729169 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1729255), // Rule ID 10719 //
     /* 1729174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729220 */     // MIs[0] policy
     /* 1729220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729254 */     // GIR_Coverage, 10719,
     /* 1729254 */     GIR_EraseRootFromParent_Done,
     /* 1729255 */   // Label 23628: @1729255
     /* 1729255 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1729341), // Rule ID 10722 //
     /* 1729260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729306 */     // MIs[0] policy
     /* 1729306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729340 */     // GIR_Coverage, 10722,
     /* 1729340 */     GIR_EraseRootFromParent_Done,
     /* 1729341 */   // Label 23629: @1729341
     /* 1729341 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1729427), // Rule ID 10723 //
     /* 1729346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729392 */     // MIs[0] policy
     /* 1729392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1729405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729426 */     // GIR_Coverage, 10723,
     /* 1729426 */     GIR_EraseRootFromParent_Done,
     /* 1729427 */   // Label 23630: @1729427
     /* 1729427 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1729513), // Rule ID 10726 //
     /* 1729432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729478 */     // MIs[0] policy
     /* 1729478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729488 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729512 */     // GIR_Coverage, 10726,
     /* 1729512 */     GIR_EraseRootFromParent_Done,
     /* 1729513 */   // Label 23631: @1729513
     /* 1729513 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1729599), // Rule ID 10727 //
     /* 1729518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729564 */     // MIs[0] policy
     /* 1729564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729574 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729598 */     // GIR_Coverage, 10727,
     /* 1729598 */     GIR_EraseRootFromParent_Done,
     /* 1729599 */   // Label 23632: @1729599
     /* 1729599 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1729685), // Rule ID 10730 //
     /* 1729604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729650 */     // MIs[0] policy
     /* 1729650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729684 */     // GIR_Coverage, 10730,
     /* 1729684 */     GIR_EraseRootFromParent_Done,
     /* 1729685 */   // Label 23633: @1729685
     /* 1729685 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1729771), // Rule ID 10731 //
     /* 1729690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729736 */     // MIs[0] policy
     /* 1729736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729770 */     // GIR_Coverage, 10731,
     /* 1729770 */     GIR_EraseRootFromParent_Done,
     /* 1729771 */   // Label 23634: @1729771
     /* 1729771 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1729857), // Rule ID 10734 //
     /* 1729776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729822 */     // MIs[0] policy
     /* 1729822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729856 */     // GIR_Coverage, 10734,
     /* 1729856 */     GIR_EraseRootFromParent_Done,
     /* 1729857 */   // Label 23635: @1729857
     /* 1729857 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1729943), // Rule ID 10735 //
     /* 1729862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729908 */     // MIs[0] policy
     /* 1729908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729942 */     // GIR_Coverage, 10735,
     /* 1729942 */     GIR_EraseRootFromParent_Done,
     /* 1729943 */   // Label 23636: @1729943
     /* 1729943 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1730029), // Rule ID 10738 //
     /* 1729948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729994 */     // MIs[0] policy
     /* 1729994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1730007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730028 */     // GIR_Coverage, 10738,
     /* 1730028 */     GIR_EraseRootFromParent_Done,
     /* 1730029 */   // Label 23637: @1730029
     /* 1730029 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1730115), // Rule ID 10739 //
     /* 1730034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1730037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1730045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1730048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1730051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730080 */     // MIs[0] policy
     /* 1730080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1730093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730114 */     // GIR_Coverage, 10739,
     /* 1730114 */     GIR_EraseRootFromParent_Done,
     /* 1730115 */   // Label 23638: @1730115
     /* 1730115 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1730201), // Rule ID 10742 //
     /* 1730120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730166 */     // MIs[0] policy
     /* 1730166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730200 */     // GIR_Coverage, 10742,
     /* 1730200 */     GIR_EraseRootFromParent_Done,
     /* 1730201 */   // Label 23639: @1730201
     /* 1730201 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1730287), // Rule ID 10743 //
     /* 1730206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730252 */     // MIs[0] policy
     /* 1730252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730262 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730286 */     // GIR_Coverage, 10743,
     /* 1730286 */     GIR_EraseRootFromParent_Done,
     /* 1730287 */   // Label 23640: @1730287
     /* 1730287 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1730373), // Rule ID 10746 //
     /* 1730292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730338 */     // MIs[0] policy
     /* 1730338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730348 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730372 */     // GIR_Coverage, 10746,
     /* 1730372 */     GIR_EraseRootFromParent_Done,
     /* 1730373 */   // Label 23641: @1730373
     /* 1730373 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1730459), // Rule ID 10747 //
     /* 1730378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730424 */     // MIs[0] policy
     /* 1730424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730434 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730458 */     // GIR_Coverage, 10747,
     /* 1730458 */     GIR_EraseRootFromParent_Done,
     /* 1730459 */   // Label 23642: @1730459
     /* 1730459 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1730545), // Rule ID 10750 //
     /* 1730464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730510 */     // MIs[0] policy
     /* 1730510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730544 */     // GIR_Coverage, 10750,
     /* 1730544 */     GIR_EraseRootFromParent_Done,
     /* 1730545 */   // Label 23643: @1730545
     /* 1730545 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1730631), // Rule ID 10751 //
     /* 1730550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730596 */     // MIs[0] policy
     /* 1730596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730606 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730630 */     // GIR_Coverage, 10751,
     /* 1730630 */     GIR_EraseRootFromParent_Done,
     /* 1730631 */   // Label 23644: @1730631
     /* 1730631 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1730717), // Rule ID 10754 //
     /* 1730636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730682 */     // MIs[0] policy
     /* 1730682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730716 */     // GIR_Coverage, 10754,
     /* 1730716 */     GIR_EraseRootFromParent_Done,
     /* 1730717 */   // Label 23645: @1730717
     /* 1730717 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1730803), // Rule ID 10755 //
     /* 1730722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730768 */     // MIs[0] policy
     /* 1730768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730802 */     // GIR_Coverage, 10755,
     /* 1730802 */     GIR_EraseRootFromParent_Done,
     /* 1730803 */   // Label 23646: @1730803
     /* 1730803 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1730889), // Rule ID 10758 //
     /* 1730808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730854 */     // MIs[0] policy
     /* 1730854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730888 */     // GIR_Coverage, 10758,
     /* 1730888 */     GIR_EraseRootFromParent_Done,
     /* 1730889 */   // Label 23647: @1730889
     /* 1730889 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1730975), // Rule ID 10759 //
     /* 1730894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730940 */     // MIs[0] policy
     /* 1730940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730974 */     // GIR_Coverage, 10759,
     /* 1730974 */     GIR_EraseRootFromParent_Done,
     /* 1730975 */   // Label 23648: @1730975
     /* 1730975 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1731061), // Rule ID 10762 //
     /* 1730980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731026 */     // MIs[0] policy
     /* 1731026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731060 */     // GIR_Coverage, 10762,
     /* 1731060 */     GIR_EraseRootFromParent_Done,
     /* 1731061 */   // Label 23649: @1731061
     /* 1731061 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1731147), // Rule ID 10763 //
     /* 1731066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1731077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1731080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1731083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731112 */     // MIs[0] policy
     /* 1731112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731122 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731146 */     // GIR_Coverage, 10763,
     /* 1731146 */     GIR_EraseRootFromParent_Done,
     /* 1731147 */   // Label 23650: @1731147
     /* 1731147 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1731233), // Rule ID 10766 //
     /* 1731152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731198 */     // MIs[0] policy
     /* 1731198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731232 */     // GIR_Coverage, 10766,
     /* 1731232 */     GIR_EraseRootFromParent_Done,
     /* 1731233 */   // Label 23651: @1731233
     /* 1731233 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1731319), // Rule ID 10767 //
     /* 1731238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731284 */     // MIs[0] policy
     /* 1731284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731318 */     // GIR_Coverage, 10767,
     /* 1731318 */     GIR_EraseRootFromParent_Done,
     /* 1731319 */   // Label 23652: @1731319
     /* 1731319 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1731405), // Rule ID 10770 //
     /* 1731324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731370 */     // MIs[0] policy
     /* 1731370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731404 */     // GIR_Coverage, 10770,
     /* 1731404 */     GIR_EraseRootFromParent_Done,
     /* 1731405 */   // Label 23653: @1731405
     /* 1731405 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1731491), // Rule ID 10771 //
     /* 1731410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731456 */     // MIs[0] policy
     /* 1731456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731490 */     // GIR_Coverage, 10771,
     /* 1731490 */     GIR_EraseRootFromParent_Done,
     /* 1731491 */   // Label 23654: @1731491
     /* 1731491 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1731577), // Rule ID 10774 //
     /* 1731496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731542 */     // MIs[0] policy
     /* 1731542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731576 */     // GIR_Coverage, 10774,
     /* 1731576 */     GIR_EraseRootFromParent_Done,
     /* 1731577 */   // Label 23655: @1731577
     /* 1731577 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1731663), // Rule ID 10775 //
     /* 1731582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731628 */     // MIs[0] policy
     /* 1731628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731662 */     // GIR_Coverage, 10775,
     /* 1731662 */     GIR_EraseRootFromParent_Done,
     /* 1731663 */   // Label 23656: @1731663
     /* 1731663 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1731749), // Rule ID 10778 //
     /* 1731668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731714 */     // MIs[0] policy
     /* 1731714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731748 */     // GIR_Coverage, 10778,
     /* 1731748 */     GIR_EraseRootFromParent_Done,
     /* 1731749 */   // Label 23657: @1731749
     /* 1731749 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1731835), // Rule ID 10779 //
     /* 1731754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731800 */     // MIs[0] policy
     /* 1731800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731834 */     // GIR_Coverage, 10779,
     /* 1731834 */     GIR_EraseRootFromParent_Done,
     /* 1731835 */   // Label 23658: @1731835
     /* 1731835 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1731921), // Rule ID 10782 //
     /* 1731840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731886 */     // MIs[0] policy
     /* 1731886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731920 */     // GIR_Coverage, 10782,
     /* 1731920 */     GIR_EraseRootFromParent_Done,
     /* 1731921 */   // Label 23659: @1731921
     /* 1731921 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1732007), // Rule ID 10783 //
     /* 1731926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731972 */     // MIs[0] policy
     /* 1731972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731982 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732006 */     // GIR_Coverage, 10783,
     /* 1732006 */     GIR_EraseRootFromParent_Done,
     /* 1732007 */   // Label 23660: @1732007
     /* 1732007 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1732093), // Rule ID 10786 //
     /* 1732012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732058 */     // MIs[0] policy
     /* 1732058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1732071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732092 */     // GIR_Coverage, 10786,
     /* 1732092 */     GIR_EraseRootFromParent_Done,
     /* 1732093 */   // Label 23661: @1732093
     /* 1732093 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1732179), // Rule ID 10787 //
     /* 1732098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1732106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732144 */     // MIs[0] policy
     /* 1732144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732154 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1732157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732178 */     // GIR_Coverage, 10787,
     /* 1732178 */     GIR_EraseRootFromParent_Done,
     /* 1732179 */   // Label 23662: @1732179
     /* 1732179 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1732265), // Rule ID 10790 //
     /* 1732184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732230 */     // MIs[0] policy
     /* 1732230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1732243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732264 */     // GIR_Coverage, 10790,
     /* 1732264 */     GIR_EraseRootFromParent_Done,
     /* 1732265 */   // Label 23663: @1732265
     /* 1732265 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1732351), // Rule ID 10791 //
     /* 1732270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732316 */     // MIs[0] policy
     /* 1732316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1732329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732350 */     // GIR_Coverage, 10791,
     /* 1732350 */     GIR_EraseRootFromParent_Done,
     /* 1732351 */   // Label 23664: @1732351
     /* 1732351 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1732437), // Rule ID 10794 //
     /* 1732356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732402 */     // MIs[0] policy
     /* 1732402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732436 */     // GIR_Coverage, 10794,
     /* 1732436 */     GIR_EraseRootFromParent_Done,
     /* 1732437 */   // Label 23665: @1732437
     /* 1732437 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1732523), // Rule ID 10795 //
     /* 1732442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732488 */     // MIs[0] policy
     /* 1732488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732522 */     // GIR_Coverage, 10795,
     /* 1732522 */     GIR_EraseRootFromParent_Done,
     /* 1732523 */   // Label 23666: @1732523
     /* 1732523 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1732609), // Rule ID 10798 //
     /* 1732528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732574 */     // MIs[0] policy
     /* 1732574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732584 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732608 */     // GIR_Coverage, 10798,
     /* 1732608 */     GIR_EraseRootFromParent_Done,
     /* 1732609 */   // Label 23667: @1732609
     /* 1732609 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1732695), // Rule ID 10799 //
     /* 1732614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732660 */     // MIs[0] policy
     /* 1732660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732694 */     // GIR_Coverage, 10799,
     /* 1732694 */     GIR_EraseRootFromParent_Done,
     /* 1732695 */   // Label 23668: @1732695
     /* 1732695 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1732781), // Rule ID 10802 //
     /* 1732700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732746 */     // MIs[0] policy
     /* 1732746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732780 */     // GIR_Coverage, 10802,
     /* 1732780 */     GIR_EraseRootFromParent_Done,
     /* 1732781 */   // Label 23669: @1732781
     /* 1732781 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1732867), // Rule ID 10803 //
     /* 1732786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732832 */     // MIs[0] policy
     /* 1732832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732866 */     // GIR_Coverage, 10803,
     /* 1732866 */     GIR_EraseRootFromParent_Done,
     /* 1732867 */   // Label 23670: @1732867
     /* 1732867 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1732953), // Rule ID 10806 //
     /* 1732872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732918 */     // MIs[0] policy
     /* 1732918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732952 */     // GIR_Coverage, 10806,
     /* 1732952 */     GIR_EraseRootFromParent_Done,
     /* 1732953 */   // Label 23671: @1732953
     /* 1732953 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1733039), // Rule ID 10807 //
     /* 1732958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733004 */     // MIs[0] policy
     /* 1733004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733038 */     // GIR_Coverage, 10807,
     /* 1733038 */     GIR_EraseRootFromParent_Done,
     /* 1733039 */   // Label 23672: @1733039
     /* 1733039 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1733125), // Rule ID 10810 //
     /* 1733044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733090 */     // MIs[0] policy
     /* 1733090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733124 */     // GIR_Coverage, 10810,
     /* 1733124 */     GIR_EraseRootFromParent_Done,
     /* 1733125 */   // Label 23673: @1733125
     /* 1733125 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1733211), // Rule ID 10811 //
     /* 1733130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733176 */     // MIs[0] policy
     /* 1733176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1733189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733210 */     // GIR_Coverage, 10811,
     /* 1733210 */     GIR_EraseRootFromParent_Done,
     /* 1733211 */   // Label 23674: @1733211
     /* 1733211 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1733297), // Rule ID 10814 //
     /* 1733216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733262 */     // MIs[0] policy
     /* 1733262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733272 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733296 */     // GIR_Coverage, 10814,
     /* 1733296 */     GIR_EraseRootFromParent_Done,
     /* 1733297 */   // Label 23675: @1733297
     /* 1733297 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1733383), // Rule ID 10815 //
     /* 1733302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733348 */     // MIs[0] policy
     /* 1733348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733382 */     // GIR_Coverage, 10815,
     /* 1733382 */     GIR_EraseRootFromParent_Done,
     /* 1733383 */   // Label 23676: @1733383
     /* 1733383 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1733469), // Rule ID 10818 //
     /* 1733388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733434 */     // MIs[0] policy
     /* 1733434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733468 */     // GIR_Coverage, 10818,
     /* 1733468 */     GIR_EraseRootFromParent_Done,
     /* 1733469 */   // Label 23677: @1733469
     /* 1733469 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1733555), // Rule ID 10819 //
     /* 1733474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733520 */     // MIs[0] policy
     /* 1733520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733554 */     // GIR_Coverage, 10819,
     /* 1733554 */     GIR_EraseRootFromParent_Done,
     /* 1733555 */   // Label 23678: @1733555
     /* 1733555 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1733641), // Rule ID 10822 //
     /* 1733560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733606 */     // MIs[0] policy
     /* 1733606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733640 */     // GIR_Coverage, 10822,
     /* 1733640 */     GIR_EraseRootFromParent_Done,
     /* 1733641 */   // Label 23679: @1733641
     /* 1733641 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1733727), // Rule ID 10823 //
     /* 1733646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733692 */     // MIs[0] policy
     /* 1733692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733726 */     // GIR_Coverage, 10823,
     /* 1733726 */     GIR_EraseRootFromParent_Done,
     /* 1733727 */   // Label 23680: @1733727
     /* 1733727 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1733813), // Rule ID 10826 //
     /* 1733732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733778 */     // MIs[0] policy
     /* 1733778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733812 */     // GIR_Coverage, 10826,
     /* 1733812 */     GIR_EraseRootFromParent_Done,
     /* 1733813 */   // Label 23681: @1733813
     /* 1733813 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1733899), // Rule ID 10827 //
     /* 1733818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733864 */     // MIs[0] policy
     /* 1733864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733898 */     // GIR_Coverage, 10827,
     /* 1733898 */     GIR_EraseRootFromParent_Done,
     /* 1733899 */   // Label 23682: @1733899
     /* 1733899 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1733985), // Rule ID 10830 //
     /* 1733904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733950 */     // MIs[0] policy
     /* 1733950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733984 */     // GIR_Coverage, 10830,
     /* 1733984 */     GIR_EraseRootFromParent_Done,
     /* 1733985 */   // Label 23683: @1733985
     /* 1733985 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1734071), // Rule ID 10831 //
     /* 1733990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1734001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1734004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1734007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1734010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734036 */     // MIs[0] policy
     /* 1734036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734070 */     // GIR_Coverage, 10831,
     /* 1734070 */     GIR_EraseRootFromParent_Done,
     /* 1734071 */   // Label 23684: @1734071
     /* 1734071 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1734157), // Rule ID 10834 //
     /* 1734076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734122 */     // MIs[0] policy
     /* 1734122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734132 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734156 */     // GIR_Coverage, 10834,
     /* 1734156 */     GIR_EraseRootFromParent_Done,
     /* 1734157 */   // Label 23685: @1734157
     /* 1734157 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1734243), // Rule ID 10835 //
     /* 1734162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734208 */     // MIs[0] policy
     /* 1734208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734218 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734242 */     // GIR_Coverage, 10835,
     /* 1734242 */     GIR_EraseRootFromParent_Done,
     /* 1734243 */   // Label 23686: @1734243
     /* 1734243 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1734329), // Rule ID 10838 //
     /* 1734248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734294 */     // MIs[0] policy
     /* 1734294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734328 */     // GIR_Coverage, 10838,
     /* 1734328 */     GIR_EraseRootFromParent_Done,
     /* 1734329 */   // Label 23687: @1734329
     /* 1734329 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1734415), // Rule ID 10839 //
     /* 1734334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734380 */     // MIs[0] policy
     /* 1734380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734390 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734414 */     // GIR_Coverage, 10839,
     /* 1734414 */     GIR_EraseRootFromParent_Done,
     /* 1734415 */   // Label 23688: @1734415
     /* 1734415 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1734501), // Rule ID 10842 //
     /* 1734420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734466 */     // MIs[0] policy
     /* 1734466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734500 */     // GIR_Coverage, 10842,
     /* 1734500 */     GIR_EraseRootFromParent_Done,
     /* 1734501 */   // Label 23689: @1734501
     /* 1734501 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1734587), // Rule ID 10843 //
     /* 1734506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734552 */     // MIs[0] policy
     /* 1734552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734586 */     // GIR_Coverage, 10843,
     /* 1734586 */     GIR_EraseRootFromParent_Done,
     /* 1734587 */   // Label 23690: @1734587
     /* 1734587 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1734673), // Rule ID 10846 //
     /* 1734592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734638 */     // MIs[0] policy
     /* 1734638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734672 */     // GIR_Coverage, 10846,
     /* 1734672 */     GIR_EraseRootFromParent_Done,
     /* 1734673 */   // Label 23691: @1734673
     /* 1734673 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1734759), // Rule ID 10847 //
     /* 1734678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734724 */     // MIs[0] policy
     /* 1734724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734758 */     // GIR_Coverage, 10847,
     /* 1734758 */     GIR_EraseRootFromParent_Done,
     /* 1734759 */   // Label 23692: @1734759
     /* 1734759 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1734845), // Rule ID 10850 //
     /* 1734764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734810 */     // MIs[0] policy
     /* 1734810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734844 */     // GIR_Coverage, 10850,
     /* 1734844 */     GIR_EraseRootFromParent_Done,
     /* 1734845 */   // Label 23693: @1734845
     /* 1734845 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1734931), // Rule ID 10851 //
     /* 1734850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734896 */     // MIs[0] policy
     /* 1734896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734930 */     // GIR_Coverage, 10851,
     /* 1734930 */     GIR_EraseRootFromParent_Done,
     /* 1734931 */   // Label 23694: @1734931
     /* 1734931 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1735017), // Rule ID 10854 //
     /* 1734936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734982 */     // MIs[0] policy
     /* 1734982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735016 */     // GIR_Coverage, 10854,
     /* 1735016 */     GIR_EraseRootFromParent_Done,
     /* 1735017 */   // Label 23695: @1735017
     /* 1735017 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1735103), // Rule ID 10855 //
     /* 1735022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1735033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1735036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1735039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1735042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735068 */     // MIs[0] policy
     /* 1735068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735102 */     // GIR_Coverage, 10855,
     /* 1735102 */     GIR_EraseRootFromParent_Done,
     /* 1735103 */   // Label 23696: @1735103
     /* 1735103 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1735189), // Rule ID 10858 //
     /* 1735108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735154 */     // MIs[0] policy
     /* 1735154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735188 */     // GIR_Coverage, 10858,
     /* 1735188 */     GIR_EraseRootFromParent_Done,
     /* 1735189 */   // Label 23697: @1735189
     /* 1735189 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1735275), // Rule ID 10859 //
     /* 1735194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735240 */     // MIs[0] policy
     /* 1735240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735274 */     // GIR_Coverage, 10859,
     /* 1735274 */     GIR_EraseRootFromParent_Done,
     /* 1735275 */   // Label 23698: @1735275
     /* 1735275 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1735361), // Rule ID 10862 //
     /* 1735280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735326 */     // MIs[0] policy
     /* 1735326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735360 */     // GIR_Coverage, 10862,
     /* 1735360 */     GIR_EraseRootFromParent_Done,
     /* 1735361 */   // Label 23699: @1735361
     /* 1735361 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1735447), // Rule ID 10863 //
     /* 1735366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735412 */     // MIs[0] policy
     /* 1735412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735446 */     // GIR_Coverage, 10863,
     /* 1735446 */     GIR_EraseRootFromParent_Done,
     /* 1735447 */   // Label 23700: @1735447
     /* 1735447 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1735533), // Rule ID 10866 //
     /* 1735452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735498 */     // MIs[0] policy
     /* 1735498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735532 */     // GIR_Coverage, 10866,
     /* 1735532 */     GIR_EraseRootFromParent_Done,
     /* 1735533 */   // Label 23701: @1735533
     /* 1735533 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1735619), // Rule ID 10867 //
     /* 1735538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735584 */     // MIs[0] policy
     /* 1735584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735618 */     // GIR_Coverage, 10867,
     /* 1735618 */     GIR_EraseRootFromParent_Done,
     /* 1735619 */   // Label 23702: @1735619
     /* 1735619 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1735705), // Rule ID 10870 //
     /* 1735624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735670 */     // MIs[0] policy
     /* 1735670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735704 */     // GIR_Coverage, 10870,
     /* 1735704 */     GIR_EraseRootFromParent_Done,
     /* 1735705 */   // Label 23703: @1735705
     /* 1735705 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1735791), // Rule ID 10871 //
     /* 1735710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735756 */     // MIs[0] policy
     /* 1735756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735790 */     // GIR_Coverage, 10871,
     /* 1735790 */     GIR_EraseRootFromParent_Done,
     /* 1735791 */   // Label 23704: @1735791
     /* 1735791 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1735877), // Rule ID 10874 //
     /* 1735796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735842 */     // MIs[0] policy
     /* 1735842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735876 */     // GIR_Coverage, 10874,
     /* 1735876 */     GIR_EraseRootFromParent_Done,
     /* 1735877 */   // Label 23705: @1735877
     /* 1735877 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1735963), // Rule ID 10875 //
     /* 1735882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735928 */     // MIs[0] policy
     /* 1735928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735962 */     // GIR_Coverage, 10875,
     /* 1735962 */     GIR_EraseRootFromParent_Done,
     /* 1735963 */   // Label 23706: @1735963
     /* 1735963 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1736049), // Rule ID 10878 //
     /* 1735968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736014 */     // MIs[0] policy
     /* 1736014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1736027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736048 */     // GIR_Coverage, 10878,
     /* 1736048 */     GIR_EraseRootFromParent_Done,
     /* 1736049 */   // Label 23707: @1736049
     /* 1736049 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1736135), // Rule ID 10879 //
     /* 1736054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1736065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1736068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1736071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736100 */     // MIs[0] policy
     /* 1736100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1736113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736134 */     // GIR_Coverage, 10879,
     /* 1736134 */     GIR_EraseRootFromParent_Done,
     /* 1736135 */   // Label 23708: @1736135
     /* 1736135 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1736221), // Rule ID 10882 //
     /* 1736140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736186 */     // MIs[0] policy
     /* 1736186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736196 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736220 */     // GIR_Coverage, 10882,
     /* 1736220 */     GIR_EraseRootFromParent_Done,
     /* 1736221 */   // Label 23709: @1736221
     /* 1736221 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1736307), // Rule ID 10883 //
     /* 1736226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736272 */     // MIs[0] policy
     /* 1736272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736306 */     // GIR_Coverage, 10883,
     /* 1736306 */     GIR_EraseRootFromParent_Done,
     /* 1736307 */   // Label 23710: @1736307
     /* 1736307 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1736393), // Rule ID 10886 //
     /* 1736312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736358 */     // MIs[0] policy
     /* 1736358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736368 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736392 */     // GIR_Coverage, 10886,
     /* 1736392 */     GIR_EraseRootFromParent_Done,
     /* 1736393 */   // Label 23711: @1736393
     /* 1736393 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1736479), // Rule ID 10887 //
     /* 1736398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736444 */     // MIs[0] policy
     /* 1736444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736478 */     // GIR_Coverage, 10887,
     /* 1736478 */     GIR_EraseRootFromParent_Done,
     /* 1736479 */   // Label 23712: @1736479
     /* 1736479 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1736565), // Rule ID 10890 //
     /* 1736484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736530 */     // MIs[0] policy
     /* 1736530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736564 */     // GIR_Coverage, 10890,
     /* 1736564 */     GIR_EraseRootFromParent_Done,
     /* 1736565 */   // Label 23713: @1736565
     /* 1736565 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1736651), // Rule ID 10891 //
     /* 1736570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736616 */     // MIs[0] policy
     /* 1736616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736650 */     // GIR_Coverage, 10891,
     /* 1736650 */     GIR_EraseRootFromParent_Done,
     /* 1736651 */   // Label 23714: @1736651
     /* 1736651 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1736737), // Rule ID 10894 //
     /* 1736656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736702 */     // MIs[0] policy
     /* 1736702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736736 */     // GIR_Coverage, 10894,
     /* 1736736 */     GIR_EraseRootFromParent_Done,
     /* 1736737 */   // Label 23715: @1736737
     /* 1736737 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1736823), // Rule ID 10895 //
     /* 1736742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736788 */     // MIs[0] policy
     /* 1736788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736822 */     // GIR_Coverage, 10895,
     /* 1736822 */     GIR_EraseRootFromParent_Done,
     /* 1736823 */   // Label 23716: @1736823
     /* 1736823 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1736909), // Rule ID 10898 //
     /* 1736828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736874 */     // MIs[0] policy
     /* 1736874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736908 */     // GIR_Coverage, 10898,
     /* 1736908 */     GIR_EraseRootFromParent_Done,
     /* 1736909 */   // Label 23717: @1736909
     /* 1736909 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1736995), // Rule ID 10899 //
     /* 1736914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736960 */     // MIs[0] policy
     /* 1736960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736994 */     // GIR_Coverage, 10899,
     /* 1736994 */     GIR_EraseRootFromParent_Done,
     /* 1736995 */   // Label 23718: @1736995
     /* 1736995 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1737081), // Rule ID 10902 //
     /* 1737000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737046 */     // MIs[0] policy
     /* 1737046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737080 */     // GIR_Coverage, 10902,
     /* 1737080 */     GIR_EraseRootFromParent_Done,
     /* 1737081 */   // Label 23719: @1737081
     /* 1737081 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1737167), // Rule ID 10903 //
     /* 1737086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737132 */     // MIs[0] policy
     /* 1737132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737166 */     // GIR_Coverage, 10903,
     /* 1737166 */     GIR_EraseRootFromParent_Done,
     /* 1737167 */   // Label 23720: @1737167
     /* 1737167 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1737253), // Rule ID 10906 //
     /* 1737172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737218 */     // MIs[0] policy
     /* 1737218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737252 */     // GIR_Coverage, 10906,
     /* 1737252 */     GIR_EraseRootFromParent_Done,
     /* 1737253 */   // Label 23721: @1737253
     /* 1737253 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1737339), // Rule ID 10907 //
     /* 1737258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737304 */     // MIs[0] policy
     /* 1737304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737338 */     // GIR_Coverage, 10907,
     /* 1737338 */     GIR_EraseRootFromParent_Done,
     /* 1737339 */   // Label 23722: @1737339
     /* 1737339 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1737425), // Rule ID 10910 //
     /* 1737344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737390 */     // MIs[0] policy
     /* 1737390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737424 */     // GIR_Coverage, 10910,
     /* 1737424 */     GIR_EraseRootFromParent_Done,
     /* 1737425 */   // Label 23723: @1737425
     /* 1737425 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1737511), // Rule ID 10911 //
     /* 1737430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737476 */     // MIs[0] policy
     /* 1737476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737510 */     // GIR_Coverage, 10911,
     /* 1737510 */     GIR_EraseRootFromParent_Done,
     /* 1737511 */   // Label 23724: @1737511
     /* 1737511 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1737597), // Rule ID 10914 //
     /* 1737516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737562 */     // MIs[0] policy
     /* 1737562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737596 */     // GIR_Coverage, 10914,
     /* 1737596 */     GIR_EraseRootFromParent_Done,
     /* 1737597 */   // Label 23725: @1737597
     /* 1737597 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1737683), // Rule ID 10915 //
     /* 1737602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737648 */     // MIs[0] policy
     /* 1737648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737682 */     // GIR_Coverage, 10915,
     /* 1737682 */     GIR_EraseRootFromParent_Done,
     /* 1737683 */   // Label 23726: @1737683
     /* 1737683 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1737769), // Rule ID 10918 //
     /* 1737688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737734 */     // MIs[0] policy
     /* 1737734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737768 */     // GIR_Coverage, 10918,
     /* 1737768 */     GIR_EraseRootFromParent_Done,
     /* 1737769 */   // Label 23727: @1737769
     /* 1737769 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1737855), // Rule ID 10919 //
     /* 1737774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737820 */     // MIs[0] policy
     /* 1737820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737854 */     // GIR_Coverage, 10919,
     /* 1737854 */     GIR_EraseRootFromParent_Done,
     /* 1737855 */   // Label 23728: @1737855
     /* 1737855 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1737941), // Rule ID 10922 //
     /* 1737860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737906 */     // MIs[0] policy
     /* 1737906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737940 */     // GIR_Coverage, 10922,
     /* 1737940 */     GIR_EraseRootFromParent_Done,
     /* 1737941 */   // Label 23729: @1737941
     /* 1737941 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1738027), // Rule ID 10923 //
     /* 1737946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737992 */     // MIs[0] policy
     /* 1737992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738026 */     // GIR_Coverage, 10923,
     /* 1738026 */     GIR_EraseRootFromParent_Done,
     /* 1738027 */   // Label 23730: @1738027
     /* 1738027 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1738113), // Rule ID 10926 //
     /* 1738032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738078 */     // MIs[0] policy
     /* 1738078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738088 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738112 */     // GIR_Coverage, 10926,
     /* 1738112 */     GIR_EraseRootFromParent_Done,
     /* 1738113 */   // Label 23731: @1738113
     /* 1738113 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1738199), // Rule ID 10927 //
     /* 1738118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738164 */     // MIs[0] policy
     /* 1738164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738174 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738198 */     // GIR_Coverage, 10927,
     /* 1738198 */     GIR_EraseRootFromParent_Done,
     /* 1738199 */   // Label 23732: @1738199
     /* 1738199 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1738285), // Rule ID 10930 //
     /* 1738204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738250 */     // MIs[0] policy
     /* 1738250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738284 */     // GIR_Coverage, 10930,
     /* 1738284 */     GIR_EraseRootFromParent_Done,
     /* 1738285 */   // Label 23733: @1738285
     /* 1738285 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1738371), // Rule ID 10931 //
     /* 1738290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738336 */     // MIs[0] policy
     /* 1738336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738370 */     // GIR_Coverage, 10931,
     /* 1738370 */     GIR_EraseRootFromParent_Done,
     /* 1738371 */   // Label 23734: @1738371
     /* 1738371 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1738457), // Rule ID 10934 //
     /* 1738376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738422 */     // MIs[0] policy
     /* 1738422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738456 */     // GIR_Coverage, 10934,
     /* 1738456 */     GIR_EraseRootFromParent_Done,
     /* 1738457 */   // Label 23735: @1738457
     /* 1738457 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1738543), // Rule ID 10935 //
     /* 1738462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738508 */     // MIs[0] policy
     /* 1738508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738542 */     // GIR_Coverage, 10935,
     /* 1738542 */     GIR_EraseRootFromParent_Done,
     /* 1738543 */   // Label 23736: @1738543
     /* 1738543 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1738629), // Rule ID 10938 //
     /* 1738548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738594 */     // MIs[0] policy
     /* 1738594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738604 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738628 */     // GIR_Coverage, 10938,
     /* 1738628 */     GIR_EraseRootFromParent_Done,
     /* 1738629 */   // Label 23737: @1738629
     /* 1738629 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1738715), // Rule ID 10939 //
     /* 1738634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738680 */     // MIs[0] policy
     /* 1738680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738714 */     // GIR_Coverage, 10939,
     /* 1738714 */     GIR_EraseRootFromParent_Done,
     /* 1738715 */   // Label 23738: @1738715
     /* 1738715 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1738801), // Rule ID 10942 //
     /* 1738720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738766 */     // MIs[0] policy
     /* 1738766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738800 */     // GIR_Coverage, 10942,
     /* 1738800 */     GIR_EraseRootFromParent_Done,
     /* 1738801 */   // Label 23739: @1738801
     /* 1738801 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1738887), // Rule ID 10943 //
     /* 1738806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738852 */     // MIs[0] policy
     /* 1738852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738886 */     // GIR_Coverage, 10943,
     /* 1738886 */     GIR_EraseRootFromParent_Done,
     /* 1738887 */   // Label 23740: @1738887
     /* 1738887 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1738973), // Rule ID 10946 //
     /* 1738892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738938 */     // MIs[0] policy
     /* 1738938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738972 */     // GIR_Coverage, 10946,
     /* 1738972 */     GIR_EraseRootFromParent_Done,
     /* 1738973 */   // Label 23741: @1738973
     /* 1738973 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1739059), // Rule ID 10947 //
     /* 1738978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739024 */     // MIs[0] policy
     /* 1739024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739058 */     // GIR_Coverage, 10947,
     /* 1739058 */     GIR_EraseRootFromParent_Done,
     /* 1739059 */   // Label 23742: @1739059
     /* 1739059 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1739145), // Rule ID 10950 //
     /* 1739064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739110 */     // MIs[0] policy
     /* 1739110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739144 */     // GIR_Coverage, 10950,
     /* 1739144 */     GIR_EraseRootFromParent_Done,
     /* 1739145 */   // Label 23743: @1739145
     /* 1739145 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1739231), // Rule ID 10951 //
     /* 1739150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739196 */     // MIs[0] policy
     /* 1739196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739230 */     // GIR_Coverage, 10951,
     /* 1739230 */     GIR_EraseRootFromParent_Done,
     /* 1739231 */   // Label 23744: @1739231
     /* 1739231 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1739317), // Rule ID 10954 //
     /* 1739236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739282 */     // MIs[0] policy
     /* 1739282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1739295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739316 */     // GIR_Coverage, 10954,
     /* 1739316 */     GIR_EraseRootFromParent_Done,
     /* 1739317 */   // Label 23745: @1739317
     /* 1739317 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1739403), // Rule ID 10955 //
     /* 1739322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739368 */     // MIs[0] policy
     /* 1739368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1739381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739402 */     // GIR_Coverage, 10955,
     /* 1739402 */     GIR_EraseRootFromParent_Done,
     /* 1739403 */   // Label 23746: @1739403
     /* 1739403 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1739489), // Rule ID 10958 //
     /* 1739408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739454 */     // MIs[0] policy
     /* 1739454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739488 */     // GIR_Coverage, 10958,
     /* 1739488 */     GIR_EraseRootFromParent_Done,
     /* 1739489 */   // Label 23747: @1739489
     /* 1739489 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1739575), // Rule ID 10959 //
     /* 1739494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739540 */     // MIs[0] policy
     /* 1739540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739574 */     // GIR_Coverage, 10959,
     /* 1739574 */     GIR_EraseRootFromParent_Done,
     /* 1739575 */   // Label 23748: @1739575
     /* 1739575 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1739661), // Rule ID 10962 //
     /* 1739580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739626 */     // MIs[0] policy
     /* 1739626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739660 */     // GIR_Coverage, 10962,
     /* 1739660 */     GIR_EraseRootFromParent_Done,
     /* 1739661 */   // Label 23749: @1739661
     /* 1739661 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1739747), // Rule ID 10963 //
     /* 1739666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739712 */     // MIs[0] policy
     /* 1739712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739746 */     // GIR_Coverage, 10963,
     /* 1739746 */     GIR_EraseRootFromParent_Done,
     /* 1739747 */   // Label 23750: @1739747
     /* 1739747 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1739833), // Rule ID 10966 //
     /* 1739752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739798 */     // MIs[0] policy
     /* 1739798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739808 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739832 */     // GIR_Coverage, 10966,
     /* 1739832 */     GIR_EraseRootFromParent_Done,
     /* 1739833 */   // Label 23751: @1739833
     /* 1739833 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1739919), // Rule ID 10967 //
     /* 1739838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739884 */     // MIs[0] policy
     /* 1739884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739918 */     // GIR_Coverage, 10967,
     /* 1739918 */     GIR_EraseRootFromParent_Done,
     /* 1739919 */   // Label 23752: @1739919
     /* 1739919 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1740005), // Rule ID 10970 //
     /* 1739924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739970 */     // MIs[0] policy
     /* 1739970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740004 */     // GIR_Coverage, 10970,
     /* 1740004 */     GIR_EraseRootFromParent_Done,
     /* 1740005 */   // Label 23753: @1740005
     /* 1740005 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1740091), // Rule ID 10971 //
     /* 1740010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1740021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1740024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1740027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1740030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740056 */     // MIs[0] policy
     /* 1740056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740090 */     // GIR_Coverage, 10971,
     /* 1740090 */     GIR_EraseRootFromParent_Done,
     /* 1740091 */   // Label 23754: @1740091
     /* 1740091 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1740177), // Rule ID 10974 //
     /* 1740096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740142 */     // MIs[0] policy
     /* 1740142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740176 */     // GIR_Coverage, 10974,
     /* 1740176 */     GIR_EraseRootFromParent_Done,
     /* 1740177 */   // Label 23755: @1740177
     /* 1740177 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1740263), // Rule ID 10975 //
     /* 1740182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740228 */     // MIs[0] policy
     /* 1740228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740238 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740262 */     // GIR_Coverage, 10975,
     /* 1740262 */     GIR_EraseRootFromParent_Done,
     /* 1740263 */   // Label 23756: @1740263
     /* 1740263 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1740349), // Rule ID 10978 //
     /* 1740268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740314 */     // MIs[0] policy
     /* 1740314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740348 */     // GIR_Coverage, 10978,
     /* 1740348 */     GIR_EraseRootFromParent_Done,
     /* 1740349 */   // Label 23757: @1740349
     /* 1740349 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1740435), // Rule ID 10979 //
     /* 1740354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740400 */     // MIs[0] policy
     /* 1740400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1740413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740434 */     // GIR_Coverage, 10979,
     /* 1740434 */     GIR_EraseRootFromParent_Done,
     /* 1740435 */   // Label 23758: @1740435
     /* 1740435 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1740521), // Rule ID 10982 //
     /* 1740440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740486 */     // MIs[0] policy
     /* 1740486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740520 */     // GIR_Coverage, 10982,
     /* 1740520 */     GIR_EraseRootFromParent_Done,
     /* 1740521 */   // Label 23759: @1740521
     /* 1740521 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1740607), // Rule ID 10983 //
     /* 1740526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740572 */     // MIs[0] policy
     /* 1740572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740606 */     // GIR_Coverage, 10983,
     /* 1740606 */     GIR_EraseRootFromParent_Done,
     /* 1740607 */   // Label 23760: @1740607
     /* 1740607 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1740693), // Rule ID 10986 //
     /* 1740612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740658 */     // MIs[0] policy
     /* 1740658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740692 */     // GIR_Coverage, 10986,
     /* 1740692 */     GIR_EraseRootFromParent_Done,
     /* 1740693 */   // Label 23761: @1740693
     /* 1740693 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1740779), // Rule ID 10987 //
     /* 1740698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740744 */     // MIs[0] policy
     /* 1740744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740778 */     // GIR_Coverage, 10987,
     /* 1740778 */     GIR_EraseRootFromParent_Done,
     /* 1740779 */   // Label 23762: @1740779
     /* 1740779 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1740865), // Rule ID 10990 //
     /* 1740784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740830 */     // MIs[0] policy
     /* 1740830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740864 */     // GIR_Coverage, 10990,
     /* 1740864 */     GIR_EraseRootFromParent_Done,
     /* 1740865 */   // Label 23763: @1740865
     /* 1740865 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1740951), // Rule ID 10991 //
     /* 1740870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740916 */     // MIs[0] policy
     /* 1740916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740950 */     // GIR_Coverage, 10991,
     /* 1740950 */     GIR_EraseRootFromParent_Done,
     /* 1740951 */   // Label 23764: @1740951
     /* 1740951 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1741037), // Rule ID 10994 //
     /* 1740956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741002 */     // MIs[0] policy
     /* 1741002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741036 */     // GIR_Coverage, 10994,
     /* 1741036 */     GIR_EraseRootFromParent_Done,
     /* 1741037 */   // Label 23765: @1741037
     /* 1741037 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1741123), // Rule ID 10995 //
     /* 1741042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1741053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1741056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1741059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1741062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741088 */     // MIs[0] policy
     /* 1741088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741122 */     // GIR_Coverage, 10995,
     /* 1741122 */     GIR_EraseRootFromParent_Done,
     /* 1741123 */   // Label 23766: @1741123
     /* 1741123 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1741209), // Rule ID 10998 //
     /* 1741128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741174 */     // MIs[0] policy
     /* 1741174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741208 */     // GIR_Coverage, 10998,
     /* 1741208 */     GIR_EraseRootFromParent_Done,
     /* 1741209 */   // Label 23767: @1741209
     /* 1741209 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1741295), // Rule ID 10999 //
     /* 1741214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741260 */     // MIs[0] policy
     /* 1741260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741294 */     // GIR_Coverage, 10999,
     /* 1741294 */     GIR_EraseRootFromParent_Done,
     /* 1741295 */   // Label 23768: @1741295
     /* 1741295 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1741381), // Rule ID 11002 //
     /* 1741300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1741303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1741311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1741314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1741317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1741320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741346 */     // MIs[0] policy
     /* 1741346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741380 */     // GIR_Coverage, 11002,
     /* 1741380 */     GIR_EraseRootFromParent_Done,
     /* 1741381 */   // Label 23769: @1741381
     /* 1741381 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1741467), // Rule ID 11003 //
     /* 1741386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1741389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1741397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1741400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1741403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1741406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741432 */     // MIs[0] policy
     /* 1741432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1741445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1741463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741466 */     // GIR_Coverage, 11003,
     /* 1741466 */     GIR_EraseRootFromParent_Done,
     /* 1741467 */   // Label 23770: @1741467
     /* 1741467 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1741553), // Rule ID 11006 //
     /* 1741472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741518 */     // MIs[0] policy
     /* 1741518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741552 */     // GIR_Coverage, 11006,
     /* 1741552 */     GIR_EraseRootFromParent_Done,
     /* 1741553 */   // Label 23771: @1741553
     /* 1741553 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1741639), // Rule ID 11007 //
     /* 1741558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741604 */     // MIs[0] policy
     /* 1741604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741638 */     // GIR_Coverage, 11007,
     /* 1741638 */     GIR_EraseRootFromParent_Done,
     /* 1741639 */   // Label 23772: @1741639
     /* 1741639 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1741725), // Rule ID 11010 //
     /* 1741644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741690 */     // MIs[0] policy
     /* 1741690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741700 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741724 */     // GIR_Coverage, 11010,
     /* 1741724 */     GIR_EraseRootFromParent_Done,
     /* 1741725 */   // Label 23773: @1741725
     /* 1741725 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1741811), // Rule ID 11011 //
     /* 1741730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741776 */     // MIs[0] policy
     /* 1741776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741810 */     // GIR_Coverage, 11011,
     /* 1741810 */     GIR_EraseRootFromParent_Done,
     /* 1741811 */   // Label 23774: @1741811
     /* 1741811 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1741897), // Rule ID 11014 //
     /* 1741816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741862 */     // MIs[0] policy
     /* 1741862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741896 */     // GIR_Coverage, 11014,
     /* 1741896 */     GIR_EraseRootFromParent_Done,
     /* 1741897 */   // Label 23775: @1741897
     /* 1741897 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1741983), // Rule ID 11015 //
     /* 1741902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741948 */     // MIs[0] policy
     /* 1741948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741958 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741982 */     // GIR_Coverage, 11015,
     /* 1741982 */     GIR_EraseRootFromParent_Done,
     /* 1741983 */   // Label 23776: @1741983
     /* 1741983 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1742069), // Rule ID 11018 //
     /* 1741988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742034 */     // MIs[0] policy
     /* 1742034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742068 */     // GIR_Coverage, 11018,
     /* 1742068 */     GIR_EraseRootFromParent_Done,
     /* 1742069 */   // Label 23777: @1742069
     /* 1742069 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1742155), // Rule ID 11019 //
     /* 1742074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1742085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742120 */     // MIs[0] policy
     /* 1742120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742154 */     // GIR_Coverage, 11019,
     /* 1742154 */     GIR_EraseRootFromParent_Done,
     /* 1742155 */   // Label 23778: @1742155
     /* 1742155 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1742241), // Rule ID 11022 //
     /* 1742160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742206 */     // MIs[0] policy
     /* 1742206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742240 */     // GIR_Coverage, 11022,
     /* 1742240 */     GIR_EraseRootFromParent_Done,
     /* 1742241 */   // Label 23779: @1742241
     /* 1742241 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1742327), // Rule ID 11023 //
     /* 1742246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742292 */     // MIs[0] policy
     /* 1742292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742326 */     // GIR_Coverage, 11023,
     /* 1742326 */     GIR_EraseRootFromParent_Done,
     /* 1742327 */   // Label 23780: @1742327
     /* 1742327 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1742413), // Rule ID 11026 //
     /* 1742332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742378 */     // MIs[0] policy
     /* 1742378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742412 */     // GIR_Coverage, 11026,
     /* 1742412 */     GIR_EraseRootFromParent_Done,
     /* 1742413 */   // Label 23781: @1742413
     /* 1742413 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1742499), // Rule ID 11027 //
     /* 1742418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742464 */     // MIs[0] policy
     /* 1742464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742498 */     // GIR_Coverage, 11027,
     /* 1742498 */     GIR_EraseRootFromParent_Done,
     /* 1742499 */   // Label 23782: @1742499
     /* 1742499 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1742585), // Rule ID 11030 //
     /* 1742504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742550 */     // MIs[0] policy
     /* 1742550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742584 */     // GIR_Coverage, 11030,
     /* 1742584 */     GIR_EraseRootFromParent_Done,
     /* 1742585 */   // Label 23783: @1742585
     /* 1742585 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1742671), // Rule ID 11031 //
     /* 1742590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742636 */     // MIs[0] policy
     /* 1742636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742670 */     // GIR_Coverage, 11031,
     /* 1742670 */     GIR_EraseRootFromParent_Done,
     /* 1742671 */   // Label 23784: @1742671
     /* 1742671 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1742757), // Rule ID 11034 //
     /* 1742676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742722 */     // MIs[0] policy
     /* 1742722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742756 */     // GIR_Coverage, 11034,
     /* 1742756 */     GIR_EraseRootFromParent_Done,
     /* 1742757 */   // Label 23785: @1742757
     /* 1742757 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1742843), // Rule ID 11035 //
     /* 1742762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742808 */     // MIs[0] policy
     /* 1742808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742842 */     // GIR_Coverage, 11035,
     /* 1742842 */     GIR_EraseRootFromParent_Done,
     /* 1742843 */   // Label 23786: @1742843
     /* 1742843 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1742929), // Rule ID 11038 //
     /* 1742848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742894 */     // MIs[0] policy
     /* 1742894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742928 */     // GIR_Coverage, 11038,
     /* 1742928 */     GIR_EraseRootFromParent_Done,
     /* 1742929 */   // Label 23787: @1742929
     /* 1742929 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1743015), // Rule ID 11039 //
     /* 1742934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742980 */     // MIs[0] policy
     /* 1742980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743014 */     // GIR_Coverage, 11039,
     /* 1743014 */     GIR_EraseRootFromParent_Done,
     /* 1743015 */   // Label 23788: @1743015
     /* 1743015 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1743101), // Rule ID 11042 //
     /* 1743020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1743031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1743034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1743037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1743040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743066 */     // MIs[0] policy
     /* 1743066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1743079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743100 */     // GIR_Coverage, 11042,
     /* 1743100 */     GIR_EraseRootFromParent_Done,
     /* 1743101 */   // Label 23789: @1743101
     /* 1743101 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1743187), // Rule ID 11043 //
     /* 1743106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1743117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1743120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1743123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1743126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743152 */     // MIs[0] policy
     /* 1743152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1743165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743186 */     // GIR_Coverage, 11043,
     /* 1743186 */     GIR_EraseRootFromParent_Done,
     /* 1743187 */   // Label 23790: @1743187
     /* 1743187 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1743273), // Rule ID 11046 //
     /* 1743192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1743203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1743206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1743209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1743212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743238 */     // MIs[0] policy
     /* 1743238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1743251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743272 */     // GIR_Coverage, 11046,
     /* 1743272 */     GIR_EraseRootFromParent_Done,
     /* 1743273 */   // Label 23791: @1743273
     /* 1743273 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1743359), // Rule ID 11047 //
     /* 1743278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1743289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1743292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1743295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1743298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743324 */     // MIs[0] policy
     /* 1743324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1743337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743358 */     // GIR_Coverage, 11047,
     /* 1743358 */     GIR_EraseRootFromParent_Done,
     /* 1743359 */   // Label 23792: @1743359
     /* 1743359 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1743445), // Rule ID 11050 //
     /* 1743364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1743367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743410 */     // MIs[0] policy
     /* 1743410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743420 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743444 */     // GIR_Coverage, 11050,
     /* 1743444 */     GIR_EraseRootFromParent_Done,
     /* 1743445 */   // Label 23793: @1743445
     /* 1743445 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1743531), // Rule ID 11051 //
     /* 1743450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1743453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1743461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1743464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743496 */     // MIs[0] policy
     /* 1743496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743530 */     // GIR_Coverage, 11051,
     /* 1743530 */     GIR_EraseRootFromParent_Done,
     /* 1743531 */   // Label 23794: @1743531
     /* 1743531 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1743617), // Rule ID 11054 //
     /* 1743536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743582 */     // MIs[0] policy
     /* 1743582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743592 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743616 */     // GIR_Coverage, 11054,
     /* 1743616 */     GIR_EraseRootFromParent_Done,
     /* 1743617 */   // Label 23795: @1743617
     /* 1743617 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1743703), // Rule ID 11055 //
     /* 1743622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743668 */     // MIs[0] policy
     /* 1743668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743702 */     // GIR_Coverage, 11055,
     /* 1743702 */     GIR_EraseRootFromParent_Done,
     /* 1743703 */   // Label 23796: @1743703
     /* 1743703 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1743789), // Rule ID 11058 //
     /* 1743708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743754 */     // MIs[0] policy
     /* 1743754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743788 */     // GIR_Coverage, 11058,
     /* 1743788 */     GIR_EraseRootFromParent_Done,
     /* 1743789 */   // Label 23797: @1743789
     /* 1743789 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1743875), // Rule ID 11059 //
     /* 1743794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743840 */     // MIs[0] policy
     /* 1743840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743874 */     // GIR_Coverage, 11059,
     /* 1743874 */     GIR_EraseRootFromParent_Done,
     /* 1743875 */   // Label 23798: @1743875
     /* 1743875 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1743961), // Rule ID 11062 //
     /* 1743880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743926 */     // MIs[0] policy
     /* 1743926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743960 */     // GIR_Coverage, 11062,
     /* 1743960 */     GIR_EraseRootFromParent_Done,
     /* 1743961 */   // Label 23799: @1743961
     /* 1743961 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1744047), // Rule ID 11063 //
     /* 1743966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744012 */     // MIs[0] policy
     /* 1744012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744046 */     // GIR_Coverage, 11063,
     /* 1744046 */     GIR_EraseRootFromParent_Done,
     /* 1744047 */   // Label 23800: @1744047
     /* 1744047 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1744133), // Rule ID 11066 //
     /* 1744052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1744063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1744066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1744069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744098 */     // MIs[0] policy
     /* 1744098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1744111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744132 */     // GIR_Coverage, 11066,
     /* 1744132 */     GIR_EraseRootFromParent_Done,
     /* 1744133 */   // Label 23801: @1744133
     /* 1744133 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1744219), // Rule ID 11067 //
     /* 1744138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1744149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1744152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1744155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744184 */     // MIs[0] policy
     /* 1744184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1744197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744218 */     // GIR_Coverage, 11067,
     /* 1744218 */     GIR_EraseRootFromParent_Done,
     /* 1744219 */   // Label 23802: @1744219
     /* 1744219 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1744305), // Rule ID 11070 //
     /* 1744224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744270 */     // MIs[0] policy
     /* 1744270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744304 */     // GIR_Coverage, 11070,
     /* 1744304 */     GIR_EraseRootFromParent_Done,
     /* 1744305 */   // Label 23803: @1744305
     /* 1744305 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1744391), // Rule ID 11071 //
     /* 1744310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744356 */     // MIs[0] policy
     /* 1744356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744390 */     // GIR_Coverage, 11071,
     /* 1744390 */     GIR_EraseRootFromParent_Done,
     /* 1744391 */   // Label 23804: @1744391
     /* 1744391 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1744477), // Rule ID 11074 //
     /* 1744396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744442 */     // MIs[0] policy
     /* 1744442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744476 */     // GIR_Coverage, 11074,
     /* 1744476 */     GIR_EraseRootFromParent_Done,
     /* 1744477 */   // Label 23805: @1744477
     /* 1744477 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1744563), // Rule ID 11075 //
     /* 1744482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744528 */     // MIs[0] policy
     /* 1744528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744562 */     // GIR_Coverage, 11075,
     /* 1744562 */     GIR_EraseRootFromParent_Done,
     /* 1744563 */   // Label 23806: @1744563
     /* 1744563 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1744649), // Rule ID 11078 //
     /* 1744568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744614 */     // MIs[0] policy
     /* 1744614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744648 */     // GIR_Coverage, 11078,
     /* 1744648 */     GIR_EraseRootFromParent_Done,
     /* 1744649 */   // Label 23807: @1744649
     /* 1744649 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1744735), // Rule ID 11079 //
     /* 1744654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744700 */     // MIs[0] policy
     /* 1744700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744734 */     // GIR_Coverage, 11079,
     /* 1744734 */     GIR_EraseRootFromParent_Done,
     /* 1744735 */   // Label 23808: @1744735
     /* 1744735 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1744821), // Rule ID 11082 //
     /* 1744740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744786 */     // MIs[0] policy
     /* 1744786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744820 */     // GIR_Coverage, 11082,
     /* 1744820 */     GIR_EraseRootFromParent_Done,
     /* 1744821 */   // Label 23809: @1744821
     /* 1744821 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1744907), // Rule ID 11083 //
     /* 1744826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744872 */     // MIs[0] policy
     /* 1744872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744906 */     // GIR_Coverage, 11083,
     /* 1744906 */     GIR_EraseRootFromParent_Done,
     /* 1744907 */   // Label 23810: @1744907
     /* 1744907 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1744993), // Rule ID 11086 //
     /* 1744912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744958 */     // MIs[0] policy
     /* 1744958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744992 */     // GIR_Coverage, 11086,
     /* 1744992 */     GIR_EraseRootFromParent_Done,
     /* 1744993 */   // Label 23811: @1744993
     /* 1744993 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1745079), // Rule ID 11087 //
     /* 1744998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1745009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1745012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1745015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745044 */     // MIs[0] policy
     /* 1745044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745078 */     // GIR_Coverage, 11087,
     /* 1745078 */     GIR_EraseRootFromParent_Done,
     /* 1745079 */   // Label 23812: @1745079
     /* 1745079 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1745165), // Rule ID 11090 //
     /* 1745084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1745087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1745095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1745098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1745101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745130 */     // MIs[0] policy
     /* 1745130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1745161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745164 */     // GIR_Coverage, 11090,
     /* 1745164 */     GIR_EraseRootFromParent_Done,
     /* 1745165 */   // Label 23813: @1745165
     /* 1745165 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1745251), // Rule ID 11091 //
     /* 1745170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1745173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1745181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1745184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1745187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745216 */     // MIs[0] policy
     /* 1745216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1745229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1745247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745250 */     // GIR_Coverage, 11091,
     /* 1745250 */     GIR_EraseRootFromParent_Done,
     /* 1745251 */   // Label 23814: @1745251
     /* 1745251 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1745337), // Rule ID 11094 //
     /* 1745256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1745267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1745270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745302 */     // MIs[0] policy
     /* 1745302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745336 */     // GIR_Coverage, 11094,
     /* 1745336 */     GIR_EraseRootFromParent_Done,
     /* 1745337 */   // Label 23815: @1745337
     /* 1745337 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1745423), // Rule ID 11095 //
     /* 1745342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1745353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1745356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745388 */     // MIs[0] policy
     /* 1745388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745422 */     // GIR_Coverage, 11095,
     /* 1745422 */     GIR_EraseRootFromParent_Done,
     /* 1745423 */   // Label 23816: @1745423
     /* 1745423 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1745509), // Rule ID 11098 //
     /* 1745428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745474 */     // MIs[0] policy
     /* 1745474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745508 */     // GIR_Coverage, 11098,
     /* 1745508 */     GIR_EraseRootFromParent_Done,
     /* 1745509 */   // Label 23817: @1745509
     /* 1745509 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1745595), // Rule ID 11099 //
     /* 1745514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745560 */     // MIs[0] policy
     /* 1745560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745594 */     // GIR_Coverage, 11099,
     /* 1745594 */     GIR_EraseRootFromParent_Done,
     /* 1745595 */   // Label 23818: @1745595
     /* 1745595 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1745681), // Rule ID 11102 //
     /* 1745600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745646 */     // MIs[0] policy
     /* 1745646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745680 */     // GIR_Coverage, 11102,
     /* 1745680 */     GIR_EraseRootFromParent_Done,
     /* 1745681 */   // Label 23819: @1745681
     /* 1745681 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1745767), // Rule ID 11103 //
     /* 1745686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745732 */     // MIs[0] policy
     /* 1745732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745742 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745766 */     // GIR_Coverage, 11103,
     /* 1745766 */     GIR_EraseRootFromParent_Done,
     /* 1745767 */   // Label 23820: @1745767
     /* 1745767 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1745853), // Rule ID 11106 //
     /* 1745772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745818 */     // MIs[0] policy
     /* 1745818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745852 */     // GIR_Coverage, 11106,
     /* 1745852 */     GIR_EraseRootFromParent_Done,
     /* 1745853 */   // Label 23821: @1745853
     /* 1745853 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1745939), // Rule ID 11107 //
     /* 1745858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745904 */     // MIs[0] policy
     /* 1745904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745938 */     // GIR_Coverage, 11107,
     /* 1745938 */     GIR_EraseRootFromParent_Done,
     /* 1745939 */   // Label 23822: @1745939
     /* 1745939 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1746025), // Rule ID 11110 //
     /* 1745944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745990 */     // MIs[0] policy
     /* 1745990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746024 */     // GIR_Coverage, 11110,
     /* 1746024 */     GIR_EraseRootFromParent_Done,
     /* 1746025 */   // Label 23823: @1746025
     /* 1746025 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1746111), // Rule ID 11111 //
     /* 1746030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1746041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1746044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746076 */     // MIs[0] policy
     /* 1746076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746110 */     // GIR_Coverage, 11111,
     /* 1746110 */     GIR_EraseRootFromParent_Done,
     /* 1746111 */   // Label 23824: @1746111
     /* 1746111 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1746197), // Rule ID 11114 //
     /* 1746116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1746127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1746130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1746133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746162 */     // MIs[0] policy
     /* 1746162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746196 */     // GIR_Coverage, 11114,
     /* 1746196 */     GIR_EraseRootFromParent_Done,
     /* 1746197 */   // Label 23825: @1746197
     /* 1746197 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1746283), // Rule ID 11115 //
     /* 1746202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1746213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1746216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1746219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746248 */     // MIs[0] policy
     /* 1746248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746282 */     // GIR_Coverage, 11115,
     /* 1746282 */     GIR_EraseRootFromParent_Done,
     /* 1746283 */   // Label 23826: @1746283
     /* 1746283 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1746369), // Rule ID 11118 //
     /* 1746288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1746305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746334 */     // MIs[0] policy
     /* 1746334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746368 */     // GIR_Coverage, 11118,
     /* 1746368 */     GIR_EraseRootFromParent_Done,
     /* 1746369 */   // Label 23827: @1746369
     /* 1746369 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1746455), // Rule ID 11119 //
     /* 1746374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1746391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746420 */     // MIs[0] policy
     /* 1746420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746454 */     // GIR_Coverage, 11119,
     /* 1746454 */     GIR_EraseRootFromParent_Done,
     /* 1746455 */   // Label 23828: @1746455
     /* 1746455 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1746541), // Rule ID 11122 //
     /* 1746460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746506 */     // MIs[0] policy
     /* 1746506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746540 */     // GIR_Coverage, 11122,
     /* 1746540 */     GIR_EraseRootFromParent_Done,
     /* 1746541 */   // Label 23829: @1746541
     /* 1746541 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1746627), // Rule ID 11123 //
     /* 1746546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746592 */     // MIs[0] policy
     /* 1746592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746626 */     // GIR_Coverage, 11123,
     /* 1746626 */     GIR_EraseRootFromParent_Done,
     /* 1746627 */   // Label 23830: @1746627
     /* 1746627 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1746713), // Rule ID 11126 //
     /* 1746632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746678 */     // MIs[0] policy
     /* 1746678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746712 */     // GIR_Coverage, 11126,
     /* 1746712 */     GIR_EraseRootFromParent_Done,
     /* 1746713 */   // Label 23831: @1746713
     /* 1746713 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1746799), // Rule ID 11127 //
     /* 1746718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746764 */     // MIs[0] policy
     /* 1746764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746798 */     // GIR_Coverage, 11127,
     /* 1746798 */     GIR_EraseRootFromParent_Done,
     /* 1746799 */   // Label 23832: @1746799
     /* 1746799 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1746885), // Rule ID 11130 //
     /* 1746804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746850 */     // MIs[0] policy
     /* 1746850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746884 */     // GIR_Coverage, 11130,
     /* 1746884 */     GIR_EraseRootFromParent_Done,
     /* 1746885 */   // Label 23833: @1746885
     /* 1746885 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1746971), // Rule ID 11131 //
     /* 1746890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746936 */     // MIs[0] policy
     /* 1746936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746970 */     // GIR_Coverage, 11131,
     /* 1746970 */     GIR_EraseRootFromParent_Done,
     /* 1746971 */   // Label 23834: @1746971
     /* 1746971 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1747057), // Rule ID 11134 //
     /* 1746976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747022 */     // MIs[0] policy
     /* 1747022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1747035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747056 */     // GIR_Coverage, 11134,
     /* 1747056 */     GIR_EraseRootFromParent_Done,
     /* 1747057 */   // Label 23835: @1747057
     /* 1747057 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1747143), // Rule ID 11135 //
     /* 1747062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1747065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1747073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1747076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1747079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747108 */     // MIs[0] policy
     /* 1747108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1747121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747142 */     // GIR_Coverage, 11135,
     /* 1747142 */     GIR_EraseRootFromParent_Done,
     /* 1747143 */   // Label 23836: @1747143
     /* 1747143 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1747229), // Rule ID 11138 //
     /* 1747148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1747151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1747165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747194 */     // MIs[0] policy
     /* 1747194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1747207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747228 */     // GIR_Coverage, 11138,
     /* 1747228 */     GIR_EraseRootFromParent_Done,
     /* 1747229 */   // Label 23837: @1747229
     /* 1747229 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1747315), // Rule ID 11139 //
     /* 1747234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1747237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1747242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1747245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1747248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1747251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747280 */     // MIs[0] policy
     /* 1747280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1747293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1747311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747314 */     // GIR_Coverage, 11139,
     /* 1747314 */     GIR_EraseRootFromParent_Done,
     /* 1747315 */   // Label 23838: @1747315
     /* 1747315 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1747401), // Rule ID 11142 //
     /* 1747320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747366 */     // MIs[0] policy
     /* 1747366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1747379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747400 */     // GIR_Coverage, 11142,
     /* 1747400 */     GIR_EraseRootFromParent_Done,
     /* 1747401 */   // Label 23839: @1747401
     /* 1747401 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1747487), // Rule ID 11143 //
     /* 1747406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1747426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747452 */     // MIs[0] policy
     /* 1747452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1747465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747486 */     // GIR_Coverage, 11143,
     /* 1747486 */     GIR_EraseRootFromParent_Done,
     /* 1747487 */   // Label 23840: @1747487
     /* 1747487 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1747573), // Rule ID 11146 //
     /* 1747492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747538 */     // MIs[0] policy
     /* 1747538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747572 */     // GIR_Coverage, 11146,
     /* 1747572 */     GIR_EraseRootFromParent_Done,
     /* 1747573 */   // Label 23841: @1747573
     /* 1747573 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1747659), // Rule ID 11147 //
     /* 1747578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747624 */     // MIs[0] policy
     /* 1747624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747658 */     // GIR_Coverage, 11147,
     /* 1747658 */     GIR_EraseRootFromParent_Done,
     /* 1747659 */   // Label 23842: @1747659
     /* 1747659 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1747745), // Rule ID 11150 //
     /* 1747664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747710 */     // MIs[0] policy
     /* 1747710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747720 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747744 */     // GIR_Coverage, 11150,
     /* 1747744 */     GIR_EraseRootFromParent_Done,
     /* 1747745 */   // Label 23843: @1747745
     /* 1747745 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1747831), // Rule ID 11151 //
     /* 1747750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747796 */     // MIs[0] policy
     /* 1747796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747830 */     // GIR_Coverage, 11151,
     /* 1747830 */     GIR_EraseRootFromParent_Done,
     /* 1747831 */   // Label 23844: @1747831
     /* 1747831 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1747917), // Rule ID 11154 //
     /* 1747836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747882 */     // MIs[0] policy
     /* 1747882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747916 */     // GIR_Coverage, 11154,
     /* 1747916 */     GIR_EraseRootFromParent_Done,
     /* 1747917 */   // Label 23845: @1747917
     /* 1747917 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1748003), // Rule ID 11155 //
     /* 1747922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747968 */     // MIs[0] policy
     /* 1747968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748002 */     // GIR_Coverage, 11155,
     /* 1748002 */     GIR_EraseRootFromParent_Done,
     /* 1748003 */   // Label 23846: @1748003
     /* 1748003 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1748089), // Rule ID 11158 //
     /* 1748008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748054 */     // MIs[0] policy
     /* 1748054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748088 */     // GIR_Coverage, 11158,
     /* 1748088 */     GIR_EraseRootFromParent_Done,
     /* 1748089 */   // Label 23847: @1748089
     /* 1748089 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1748175), // Rule ID 11159 //
     /* 1748094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1748114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748140 */     // MIs[0] policy
     /* 1748140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748150 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748174 */     // GIR_Coverage, 11159,
     /* 1748174 */     GIR_EraseRootFromParent_Done,
     /* 1748175 */   // Label 23848: @1748175
     /* 1748175 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1748261), // Rule ID 11162 //
     /* 1748180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1748200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748226 */     // MIs[0] policy
     /* 1748226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748260 */     // GIR_Coverage, 11162,
     /* 1748260 */     GIR_EraseRootFromParent_Done,
     /* 1748261 */   // Label 23849: @1748261
     /* 1748261 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1748347), // Rule ID 11163 //
     /* 1748266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1748286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748312 */     // MIs[0] policy
     /* 1748312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1748325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748346 */     // GIR_Coverage, 11163,
     /* 1748346 */     GIR_EraseRootFromParent_Done,
     /* 1748347 */   // Label 23850: @1748347
     /* 1748347 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1748433), // Rule ID 11166 //
     /* 1748352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748398 */     // MIs[0] policy
     /* 1748398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748432 */     // GIR_Coverage, 11166,
     /* 1748432 */     GIR_EraseRootFromParent_Done,
     /* 1748433 */   // Label 23851: @1748433
     /* 1748433 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1748519), // Rule ID 11167 //
     /* 1748438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1748458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748484 */     // MIs[0] policy
     /* 1748484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748494 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748518 */     // GIR_Coverage, 11167,
     /* 1748518 */     GIR_EraseRootFromParent_Done,
     /* 1748519 */   // Label 23852: @1748519
     /* 1748519 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1748605), // Rule ID 11170 //
     /* 1748524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748570 */     // MIs[0] policy
     /* 1748570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748604 */     // GIR_Coverage, 11170,
     /* 1748604 */     GIR_EraseRootFromParent_Done,
     /* 1748605 */   // Label 23853: @1748605
     /* 1748605 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1748691), // Rule ID 11171 //
     /* 1748610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748656 */     // MIs[0] policy
     /* 1748656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748690 */     // GIR_Coverage, 11171,
     /* 1748690 */     GIR_EraseRootFromParent_Done,
     /* 1748691 */   // Label 23854: @1748691
     /* 1748691 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1748777), // Rule ID 11174 //
     /* 1748696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748742 */     // MIs[0] policy
     /* 1748742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748776 */     // GIR_Coverage, 11174,
     /* 1748776 */     GIR_EraseRootFromParent_Done,
     /* 1748777 */   // Label 23855: @1748777
     /* 1748777 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1748863), // Rule ID 11175 //
     /* 1748782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748828 */     // MIs[0] policy
     /* 1748828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748862 */     // GIR_Coverage, 11175,
     /* 1748862 */     GIR_EraseRootFromParent_Done,
     /* 1748863 */   // Label 23856: @1748863
     /* 1748863 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1748949), // Rule ID 11178 //
     /* 1748868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748914 */     // MIs[0] policy
     /* 1748914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748948 */     // GIR_Coverage, 11178,
     /* 1748948 */     GIR_EraseRootFromParent_Done,
     /* 1748949 */   // Label 23857: @1748949
     /* 1748949 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1749035), // Rule ID 11179 //
     /* 1748954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749000 */     // MIs[0] policy
     /* 1749000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749034 */     // GIR_Coverage, 11179,
     /* 1749034 */     GIR_EraseRootFromParent_Done,
     /* 1749035 */   // Label 23858: @1749035
     /* 1749035 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1749121), // Rule ID 11182 //
     /* 1749040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1749060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749086 */     // MIs[0] policy
     /* 1749086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749120 */     // GIR_Coverage, 11182,
     /* 1749120 */     GIR_EraseRootFromParent_Done,
     /* 1749121 */   // Label 23859: @1749121
     /* 1749121 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1749207), // Rule ID 11183 //
     /* 1749126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1749146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749172 */     // MIs[0] policy
     /* 1749172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749182 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749206 */     // GIR_Coverage, 11183,
     /* 1749206 */     GIR_EraseRootFromParent_Done,
     /* 1749207 */   // Label 23860: @1749207
     /* 1749207 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1749293), // Rule ID 11186 //
     /* 1749212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1749232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749258 */     // MIs[0] policy
     /* 1749258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749268 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749292 */     // GIR_Coverage, 11186,
     /* 1749292 */     GIR_EraseRootFromParent_Done,
     /* 1749293 */   // Label 23861: @1749293
     /* 1749293 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1749379), // Rule ID 11187 //
     /* 1749298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1749318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749344 */     // MIs[0] policy
     /* 1749344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749354 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749378 */     // GIR_Coverage, 11187,
     /* 1749378 */     GIR_EraseRootFromParent_Done,
     /* 1749379 */   // Label 23862: @1749379
     /* 1749379 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1749465), // Rule ID 11190 //
     /* 1749384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749430 */     // MIs[0] policy
     /* 1749430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749464 */     // GIR_Coverage, 11190,
     /* 1749464 */     GIR_EraseRootFromParent_Done,
     /* 1749465 */   // Label 23863: @1749465
     /* 1749465 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1749551), // Rule ID 11191 //
     /* 1749470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749516 */     // MIs[0] policy
     /* 1749516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749550 */     // GIR_Coverage, 11191,
     /* 1749550 */     GIR_EraseRootFromParent_Done,
     /* 1749551 */   // Label 23864: @1749551
     /* 1749551 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1749637), // Rule ID 11194 //
     /* 1749556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749602 */     // MIs[0] policy
     /* 1749602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749612 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749636 */     // GIR_Coverage, 11194,
     /* 1749636 */     GIR_EraseRootFromParent_Done,
     /* 1749637 */   // Label 23865: @1749637
     /* 1749637 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1749723), // Rule ID 11195 //
     /* 1749642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749688 */     // MIs[0] policy
     /* 1749688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749698 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749722 */     // GIR_Coverage, 11195,
     /* 1749722 */     GIR_EraseRootFromParent_Done,
     /* 1749723 */   // Label 23866: @1749723
     /* 1749723 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1749809), // Rule ID 11198 //
     /* 1749728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749774 */     // MIs[0] policy
     /* 1749774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749808 */     // GIR_Coverage, 11198,
     /* 1749808 */     GIR_EraseRootFromParent_Done,
     /* 1749809 */   // Label 23867: @1749809
     /* 1749809 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1749895), // Rule ID 11199 //
     /* 1749814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749860 */     // MIs[0] policy
     /* 1749860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749870 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749894 */     // GIR_Coverage, 11199,
     /* 1749894 */     GIR_EraseRootFromParent_Done,
     /* 1749895 */   // Label 23868: @1749895
     /* 1749895 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1749981), // Rule ID 11202 //
     /* 1749900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749946 */     // MIs[0] policy
     /* 1749946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749980 */     // GIR_Coverage, 11202,
     /* 1749980 */     GIR_EraseRootFromParent_Done,
     /* 1749981 */   // Label 23869: @1749981
     /* 1749981 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1750067), // Rule ID 11203 //
     /* 1749986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1750000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1750003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1750006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750032 */     // MIs[0] policy
     /* 1750032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1750045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750066 */     // GIR_Coverage, 11203,
     /* 1750066 */     GIR_EraseRootFromParent_Done,
     /* 1750067 */   // Label 23870: @1750067
     /* 1750067 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1750153), // Rule ID 11206 //
     /* 1750072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1750092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750118 */     // MIs[0] policy
     /* 1750118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1750131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750152 */     // GIR_Coverage, 11206,
     /* 1750152 */     GIR_EraseRootFromParent_Done,
     /* 1750153 */   // Label 23871: @1750153
     /* 1750153 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1750239), // Rule ID 11207 //
     /* 1750158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1750178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750204 */     // MIs[0] policy
     /* 1750204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1750217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750238 */     // GIR_Coverage, 11207,
     /* 1750238 */     GIR_EraseRootFromParent_Done,
     /* 1750239 */   // Label 23872: @1750239
     /* 1750239 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1750325), // Rule ID 11210 //
     /* 1750244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1750264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750290 */     // MIs[0] policy
     /* 1750290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1750303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750324 */     // GIR_Coverage, 11210,
     /* 1750324 */     GIR_EraseRootFromParent_Done,
     /* 1750325 */   // Label 23873: @1750325
     /* 1750325 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1750411), // Rule ID 11211 //
     /* 1750330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1750350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750376 */     // MIs[0] policy
     /* 1750376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750386 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1750389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750410 */     // GIR_Coverage, 11211,
     /* 1750410 */     GIR_EraseRootFromParent_Done,
     /* 1750411 */   // Label 23874: @1750411
     /* 1750411 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1750497), // Rule ID 11214 //
     /* 1750416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750462 */     // MIs[0] policy
     /* 1750462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750496 */     // GIR_Coverage, 11214,
     /* 1750496 */     GIR_EraseRootFromParent_Done,
     /* 1750497 */   // Label 23875: @1750497
     /* 1750497 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1750583), // Rule ID 11215 //
     /* 1750502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750548 */     // MIs[0] policy
     /* 1750548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750582 */     // GIR_Coverage, 11215,
     /* 1750582 */     GIR_EraseRootFromParent_Done,
     /* 1750583 */   // Label 23876: @1750583
     /* 1750583 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1750669), // Rule ID 11218 //
     /* 1750588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750634 */     // MIs[0] policy
     /* 1750634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750644 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750668 */     // GIR_Coverage, 11218,
     /* 1750668 */     GIR_EraseRootFromParent_Done,
     /* 1750669 */   // Label 23877: @1750669
     /* 1750669 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1750755), // Rule ID 11219 //
     /* 1750674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750720 */     // MIs[0] policy
     /* 1750720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750754 */     // GIR_Coverage, 11219,
     /* 1750754 */     GIR_EraseRootFromParent_Done,
     /* 1750755 */   // Label 23878: @1750755
     /* 1750755 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1750841), // Rule ID 11222 //
     /* 1750760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750806 */     // MIs[0] policy
     /* 1750806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750840 */     // GIR_Coverage, 11222,
     /* 1750840 */     GIR_EraseRootFromParent_Done,
     /* 1750841 */   // Label 23879: @1750841
     /* 1750841 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1750927), // Rule ID 11223 //
     /* 1750846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750892 */     // MIs[0] policy
     /* 1750892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750926 */     // GIR_Coverage, 11223,
     /* 1750926 */     GIR_EraseRootFromParent_Done,
     /* 1750927 */   // Label 23880: @1750927
     /* 1750927 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1751013), // Rule ID 11226 //
     /* 1750932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750978 */     // MIs[0] policy
     /* 1750978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750988 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751012 */     // GIR_Coverage, 11226,
     /* 1751012 */     GIR_EraseRootFromParent_Done,
     /* 1751013 */   // Label 23881: @1751013
     /* 1751013 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1751099), // Rule ID 11227 //
     /* 1751018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751064 */     // MIs[0] policy
     /* 1751064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1751077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751098 */     // GIR_Coverage, 11227,
     /* 1751098 */     GIR_EraseRootFromParent_Done,
     /* 1751099 */   // Label 23882: @1751099
     /* 1751099 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1751185), // Rule ID 11230 //
     /* 1751104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751150 */     // MIs[0] policy
     /* 1751150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751184 */     // GIR_Coverage, 11230,
     /* 1751184 */     GIR_EraseRootFromParent_Done,
     /* 1751185 */   // Label 23883: @1751185
     /* 1751185 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1751271), // Rule ID 11231 //
     /* 1751190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751236 */     // MIs[0] policy
     /* 1751236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751270 */     // GIR_Coverage, 11231,
     /* 1751270 */     GIR_EraseRootFromParent_Done,
     /* 1751271 */   // Label 23884: @1751271
     /* 1751271 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1751357), // Rule ID 11234 //
     /* 1751276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751322 */     // MIs[0] policy
     /* 1751322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751356 */     // GIR_Coverage, 11234,
     /* 1751356 */     GIR_EraseRootFromParent_Done,
     /* 1751357 */   // Label 23885: @1751357
     /* 1751357 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1751443), // Rule ID 11235 //
     /* 1751362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751408 */     // MIs[0] policy
     /* 1751408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1751421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751442 */     // GIR_Coverage, 11235,
     /* 1751442 */     GIR_EraseRootFromParent_Done,
     /* 1751443 */   // Label 23886: @1751443
     /* 1751443 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1751529), // Rule ID 11238 //
     /* 1751448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751494 */     // MIs[0] policy
     /* 1751494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751528 */     // GIR_Coverage, 11238,
     /* 1751528 */     GIR_EraseRootFromParent_Done,
     /* 1751529 */   // Label 23887: @1751529
     /* 1751529 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1751615), // Rule ID 11239 //
     /* 1751534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751580 */     // MIs[0] policy
     /* 1751580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751614 */     // GIR_Coverage, 11239,
     /* 1751614 */     GIR_EraseRootFromParent_Done,
     /* 1751615 */   // Label 23888: @1751615
     /* 1751615 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1751701), // Rule ID 11242 //
     /* 1751620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751666 */     // MIs[0] policy
     /* 1751666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751700 */     // GIR_Coverage, 11242,
     /* 1751700 */     GIR_EraseRootFromParent_Done,
     /* 1751701 */   // Label 23889: @1751701
     /* 1751701 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1751787), // Rule ID 11243 //
     /* 1751706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751752 */     // MIs[0] policy
     /* 1751752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751786 */     // GIR_Coverage, 11243,
     /* 1751786 */     GIR_EraseRootFromParent_Done,
     /* 1751787 */   // Label 23890: @1751787
     /* 1751787 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1751873), // Rule ID 11246 //
     /* 1751792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751838 */     // MIs[0] policy
     /* 1751838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751848 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751872 */     // GIR_Coverage, 11246,
     /* 1751872 */     GIR_EraseRootFromParent_Done,
     /* 1751873 */   // Label 23891: @1751873
     /* 1751873 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1751959), // Rule ID 11247 //
     /* 1751878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751924 */     // MIs[0] policy
     /* 1751924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751958 */     // GIR_Coverage, 11247,
     /* 1751958 */     GIR_EraseRootFromParent_Done,
     /* 1751959 */   // Label 23892: @1751959
     /* 1751959 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1752045), // Rule ID 11250 //
     /* 1751964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752010 */     // MIs[0] policy
     /* 1752010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752020 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752044 */     // GIR_Coverage, 11250,
     /* 1752044 */     GIR_EraseRootFromParent_Done,
     /* 1752045 */   // Label 23893: @1752045
     /* 1752045 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1752131), // Rule ID 11251 //
     /* 1752050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752096 */     // MIs[0] policy
     /* 1752096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752130 */     // GIR_Coverage, 11251,
     /* 1752130 */     GIR_EraseRootFromParent_Done,
     /* 1752131 */   // Label 23894: @1752131
     /* 1752131 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1752217), // Rule ID 11254 //
     /* 1752136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752182 */     // MIs[0] policy
     /* 1752182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752216 */     // GIR_Coverage, 11254,
     /* 1752216 */     GIR_EraseRootFromParent_Done,
     /* 1752217 */   // Label 23895: @1752217
     /* 1752217 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1752303), // Rule ID 11255 //
     /* 1752222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752268 */     // MIs[0] policy
     /* 1752268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752278 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752302 */     // GIR_Coverage, 11255,
     /* 1752302 */     GIR_EraseRootFromParent_Done,
     /* 1752303 */   // Label 23896: @1752303
     /* 1752303 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1752389), // Rule ID 11258 //
     /* 1752308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752354 */     // MIs[0] policy
     /* 1752354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752388 */     // GIR_Coverage, 11258,
     /* 1752388 */     GIR_EraseRootFromParent_Done,
     /* 1752389 */   // Label 23897: @1752389
     /* 1752389 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1752475), // Rule ID 11259 //
     /* 1752394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752440 */     // MIs[0] policy
     /* 1752440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752450 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752474 */     // GIR_Coverage, 11259,
     /* 1752474 */     GIR_EraseRootFromParent_Done,
     /* 1752475 */   // Label 23898: @1752475
     /* 1752475 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1752561), // Rule ID 11262 //
     /* 1752480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752526 */     // MIs[0] policy
     /* 1752526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752560 */     // GIR_Coverage, 11262,
     /* 1752560 */     GIR_EraseRootFromParent_Done,
     /* 1752561 */   // Label 23899: @1752561
     /* 1752561 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1752647), // Rule ID 11263 //
     /* 1752566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752612 */     // MIs[0] policy
     /* 1752612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752622 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752646 */     // GIR_Coverage, 11263,
     /* 1752646 */     GIR_EraseRootFromParent_Done,
     /* 1752647 */   // Label 23900: @1752647
     /* 1752647 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1752733), // Rule ID 11266 //
     /* 1752652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752698 */     // MIs[0] policy
     /* 1752698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752732 */     // GIR_Coverage, 11266,
     /* 1752732 */     GIR_EraseRootFromParent_Done,
     /* 1752733 */   // Label 23901: @1752733
     /* 1752733 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1752819), // Rule ID 11267 //
     /* 1752738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752784 */     // MIs[0] policy
     /* 1752784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752818 */     // GIR_Coverage, 11267,
     /* 1752818 */     GIR_EraseRootFromParent_Done,
     /* 1752819 */   // Label 23902: @1752819
     /* 1752819 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1752905), // Rule ID 11270 //
     /* 1752824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752870 */     // MIs[0] policy
     /* 1752870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752880 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752904 */     // GIR_Coverage, 11270,
     /* 1752904 */     GIR_EraseRootFromParent_Done,
     /* 1752905 */   // Label 23903: @1752905
     /* 1752905 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1752991), // Rule ID 11271 //
     /* 1752910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752956 */     // MIs[0] policy
     /* 1752956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752966 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752990 */     // GIR_Coverage, 11271,
     /* 1752990 */     GIR_EraseRootFromParent_Done,
     /* 1752991 */   // Label 23904: @1752991
     /* 1752991 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1753077), // Rule ID 11274 //
     /* 1752996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753042 */     // MIs[0] policy
     /* 1753042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1753055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753076 */     // GIR_Coverage, 11274,
     /* 1753076 */     GIR_EraseRootFromParent_Done,
     /* 1753077 */   // Label 23905: @1753077
     /* 1753077 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1753163), // Rule ID 11275 //
     /* 1753082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753128 */     // MIs[0] policy
     /* 1753128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1753141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753162 */     // GIR_Coverage, 11275,
     /* 1753162 */     GIR_EraseRootFromParent_Done,
     /* 1753163 */   // Label 23906: @1753163
     /* 1753163 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1753249), // Rule ID 11278 //
     /* 1753168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753214 */     // MIs[0] policy
     /* 1753214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1753227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753248 */     // GIR_Coverage, 11278,
     /* 1753248 */     GIR_EraseRootFromParent_Done,
     /* 1753249 */   // Label 23907: @1753249
     /* 1753249 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1753335), // Rule ID 11279 //
     /* 1753254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753300 */     // MIs[0] policy
     /* 1753300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1753313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753334 */     // GIR_Coverage, 11279,
     /* 1753334 */     GIR_EraseRootFromParent_Done,
     /* 1753335 */   // Label 23908: @1753335
     /* 1753335 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1753421), // Rule ID 11282 //
     /* 1753340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753386 */     // MIs[0] policy
     /* 1753386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753420 */     // GIR_Coverage, 11282,
     /* 1753420 */     GIR_EraseRootFromParent_Done,
     /* 1753421 */   // Label 23909: @1753421
     /* 1753421 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1753507), // Rule ID 11283 //
     /* 1753426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1753434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1753446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753472 */     // MIs[0] policy
     /* 1753472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753506 */     // GIR_Coverage, 11283,
     /* 1753506 */     GIR_EraseRootFromParent_Done,
     /* 1753507 */   // Label 23910: @1753507
     /* 1753507 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1753593), // Rule ID 11286 //
     /* 1753512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753558 */     // MIs[0] policy
     /* 1753558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753568 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753592 */     // GIR_Coverage, 11286,
     /* 1753592 */     GIR_EraseRootFromParent_Done,
     /* 1753593 */   // Label 23911: @1753593
     /* 1753593 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1753679), // Rule ID 11287 //
     /* 1753598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753644 */     // MIs[0] policy
     /* 1753644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753678 */     // GIR_Coverage, 11287,
     /* 1753678 */     GIR_EraseRootFromParent_Done,
     /* 1753679 */   // Label 23912: @1753679
     /* 1753679 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1753765), // Rule ID 11290 //
     /* 1753684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753730 */     // MIs[0] policy
     /* 1753730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753740 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753764 */     // GIR_Coverage, 11290,
     /* 1753764 */     GIR_EraseRootFromParent_Done,
     /* 1753765 */   // Label 23913: @1753765
     /* 1753765 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1753851), // Rule ID 11291 //
     /* 1753770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753816 */     // MIs[0] policy
     /* 1753816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753850 */     // GIR_Coverage, 11291,
     /* 1753850 */     GIR_EraseRootFromParent_Done,
     /* 1753851 */   // Label 23914: @1753851
     /* 1753851 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1753937), // Rule ID 11294 //
     /* 1753856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753902 */     // MIs[0] policy
     /* 1753902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753936 */     // GIR_Coverage, 11294,
     /* 1753936 */     GIR_EraseRootFromParent_Done,
     /* 1753937 */   // Label 23915: @1753937
     /* 1753937 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1754023), // Rule ID 11295 //
     /* 1753942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753988 */     // MIs[0] policy
     /* 1753988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754022 */     // GIR_Coverage, 11295,
     /* 1754022 */     GIR_EraseRootFromParent_Done,
     /* 1754023 */   // Label 23916: @1754023
     /* 1754023 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1754109), // Rule ID 11298 //
     /* 1754028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1754048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754074 */     // MIs[0] policy
     /* 1754074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1754087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754108 */     // GIR_Coverage, 11298,
     /* 1754108 */     GIR_EraseRootFromParent_Done,
     /* 1754109 */   // Label 23917: @1754109
     /* 1754109 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1754195), // Rule ID 11299 //
     /* 1754114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1754134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754160 */     // MIs[0] policy
     /* 1754160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1754173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754194 */     // GIR_Coverage, 11299,
     /* 1754194 */     GIR_EraseRootFromParent_Done,
     /* 1754195 */   // Label 23918: @1754195
     /* 1754195 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1754281), // Rule ID 11302 //
     /* 1754200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1754220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754246 */     // MIs[0] policy
     /* 1754246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754280 */     // GIR_Coverage, 11302,
     /* 1754280 */     GIR_EraseRootFromParent_Done,
     /* 1754281 */   // Label 23919: @1754281
     /* 1754281 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1754367), // Rule ID 11303 //
     /* 1754286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1754306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754332 */     // MIs[0] policy
     /* 1754332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754366 */     // GIR_Coverage, 11303,
     /* 1754366 */     GIR_EraseRootFromParent_Done,
     /* 1754367 */   // Label 23920: @1754367
     /* 1754367 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1754453), // Rule ID 11306 //
     /* 1754372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754418 */     // MIs[0] policy
     /* 1754418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754452 */     // GIR_Coverage, 11306,
     /* 1754452 */     GIR_EraseRootFromParent_Done,
     /* 1754453 */   // Label 23921: @1754453
     /* 1754453 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1754539), // Rule ID 11307 //
     /* 1754458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754504 */     // MIs[0] policy
     /* 1754504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754538 */     // GIR_Coverage, 11307,
     /* 1754538 */     GIR_EraseRootFromParent_Done,
     /* 1754539 */   // Label 23922: @1754539
     /* 1754539 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1754625), // Rule ID 11310 //
     /* 1754544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754590 */     // MIs[0] policy
     /* 1754590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754624 */     // GIR_Coverage, 11310,
     /* 1754624 */     GIR_EraseRootFromParent_Done,
     /* 1754625 */   // Label 23923: @1754625
     /* 1754625 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1754711), // Rule ID 11311 //
     /* 1754630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754676 */     // MIs[0] policy
     /* 1754676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754710 */     // GIR_Coverage, 11311,
     /* 1754710 */     GIR_EraseRootFromParent_Done,
     /* 1754711 */   // Label 23924: @1754711
     /* 1754711 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1754797), // Rule ID 11314 //
     /* 1754716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754762 */     // MIs[0] policy
     /* 1754762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754796 */     // GIR_Coverage, 11314,
     /* 1754796 */     GIR_EraseRootFromParent_Done,
     /* 1754797 */   // Label 23925: @1754797
     /* 1754797 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1754883), // Rule ID 11315 //
     /* 1754802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754848 */     // MIs[0] policy
     /* 1754848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754882 */     // GIR_Coverage, 11315,
     /* 1754882 */     GIR_EraseRootFromParent_Done,
     /* 1754883 */   // Label 23926: @1754883
     /* 1754883 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1754969), // Rule ID 11318 //
     /* 1754888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754934 */     // MIs[0] policy
     /* 1754934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754968 */     // GIR_Coverage, 11318,
     /* 1754968 */     GIR_EraseRootFromParent_Done,
     /* 1754969 */   // Label 23927: @1754969
     /* 1754969 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1755055), // Rule ID 11319 //
     /* 1754974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755020 */     // MIs[0] policy
     /* 1755020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1755033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755054 */     // GIR_Coverage, 11319,
     /* 1755054 */     GIR_EraseRootFromParent_Done,
     /* 1755055 */   // Label 23928: @1755055
     /* 1755055 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1755141), // Rule ID 11322 //
     /* 1755060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1755080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755106 */     // MIs[0] policy
     /* 1755106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755140 */     // GIR_Coverage, 11322,
     /* 1755140 */     GIR_EraseRootFromParent_Done,
     /* 1755141 */   // Label 23929: @1755141
     /* 1755141 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1755227), // Rule ID 11323 //
     /* 1755146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1755166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755192 */     // MIs[0] policy
     /* 1755192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755226 */     // GIR_Coverage, 11323,
     /* 1755226 */     GIR_EraseRootFromParent_Done,
     /* 1755227 */   // Label 23930: @1755227
     /* 1755227 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1755313), // Rule ID 11326 //
     /* 1755232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1755252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755278 */     // MIs[0] policy
     /* 1755278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755312 */     // GIR_Coverage, 11326,
     /* 1755312 */     GIR_EraseRootFromParent_Done,
     /* 1755313 */   // Label 23931: @1755313
     /* 1755313 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1755399), // Rule ID 11327 //
     /* 1755318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1755338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755364 */     // MIs[0] policy
     /* 1755364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755398 */     // GIR_Coverage, 11327,
     /* 1755398 */     GIR_EraseRootFromParent_Done,
     /* 1755399 */   // Label 23932: @1755399
     /* 1755399 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1755485), // Rule ID 11330 //
     /* 1755404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755450 */     // MIs[0] policy
     /* 1755450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755460 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755484 */     // GIR_Coverage, 11330,
     /* 1755484 */     GIR_EraseRootFromParent_Done,
     /* 1755485 */   // Label 23933: @1755485
     /* 1755485 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1755571), // Rule ID 11331 //
     /* 1755490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755536 */     // MIs[0] policy
     /* 1755536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755570 */     // GIR_Coverage, 11331,
     /* 1755570 */     GIR_EraseRootFromParent_Done,
     /* 1755571 */   // Label 23934: @1755571
     /* 1755571 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1755657), // Rule ID 11334 //
     /* 1755576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755622 */     // MIs[0] policy
     /* 1755622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755656 */     // GIR_Coverage, 11334,
     /* 1755656 */     GIR_EraseRootFromParent_Done,
     /* 1755657 */   // Label 23935: @1755657
     /* 1755657 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1755743), // Rule ID 11335 //
     /* 1755662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755708 */     // MIs[0] policy
     /* 1755708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755742 */     // GIR_Coverage, 11335,
     /* 1755742 */     GIR_EraseRootFromParent_Done,
     /* 1755743 */   // Label 23936: @1755743
     /* 1755743 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1755829), // Rule ID 11338 //
     /* 1755748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755794 */     // MIs[0] policy
     /* 1755794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755828 */     // GIR_Coverage, 11338,
     /* 1755828 */     GIR_EraseRootFromParent_Done,
     /* 1755829 */   // Label 23937: @1755829
     /* 1755829 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1755915), // Rule ID 11339 //
     /* 1755834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755880 */     // MIs[0] policy
     /* 1755880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755914 */     // GIR_Coverage, 11339,
     /* 1755914 */     GIR_EraseRootFromParent_Done,
     /* 1755915 */   // Label 23938: @1755915
     /* 1755915 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1756001), // Rule ID 11342 //
     /* 1755920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755966 */     // MIs[0] policy
     /* 1755966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756000 */     // GIR_Coverage, 11342,
     /* 1756000 */     GIR_EraseRootFromParent_Done,
     /* 1756001 */   // Label 23939: @1756001
     /* 1756001 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1756087), // Rule ID 11343 //
     /* 1756006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1756026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756052 */     // MIs[0] policy
     /* 1756052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756086 */     // GIR_Coverage, 11343,
     /* 1756086 */     GIR_EraseRootFromParent_Done,
     /* 1756087 */   // Label 23940: @1756087
     /* 1756087 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1756173), // Rule ID 11346 //
     /* 1756092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1756112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756138 */     // MIs[0] policy
     /* 1756138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1756151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756172 */     // GIR_Coverage, 11346,
     /* 1756172 */     GIR_EraseRootFromParent_Done,
     /* 1756173 */   // Label 23941: @1756173
     /* 1756173 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1756259), // Rule ID 11347 //
     /* 1756178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1756198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756224 */     // MIs[0] policy
     /* 1756224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1756237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756258 */     // GIR_Coverage, 11347,
     /* 1756258 */     GIR_EraseRootFromParent_Done,
     /* 1756259 */   // Label 23942: @1756259
     /* 1756259 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1756345), // Rule ID 11350 //
     /* 1756264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1756284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756310 */     // MIs[0] policy
     /* 1756310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1756323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756344 */     // GIR_Coverage, 11350,
     /* 1756344 */     GIR_EraseRootFromParent_Done,
     /* 1756345 */   // Label 23943: @1756345
     /* 1756345 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1756431), // Rule ID 11351 //
     /* 1756350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1756370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756396 */     // MIs[0] policy
     /* 1756396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1756409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756430 */     // GIR_Coverage, 11351,
     /* 1756430 */     GIR_EraseRootFromParent_Done,
     /* 1756431 */   // Label 23944: @1756431
     /* 1756431 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1756517), // Rule ID 11354 //
     /* 1756436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756482 */     // MIs[0] policy
     /* 1756482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756516 */     // GIR_Coverage, 11354,
     /* 1756516 */     GIR_EraseRootFromParent_Done,
     /* 1756517 */   // Label 23945: @1756517
     /* 1756517 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1756603), // Rule ID 11355 //
     /* 1756522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756568 */     // MIs[0] policy
     /* 1756568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756602 */     // GIR_Coverage, 11355,
     /* 1756602 */     GIR_EraseRootFromParent_Done,
     /* 1756603 */   // Label 23946: @1756603
     /* 1756603 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1756689), // Rule ID 11358 //
     /* 1756608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756654 */     // MIs[0] policy
     /* 1756654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756688 */     // GIR_Coverage, 11358,
     /* 1756688 */     GIR_EraseRootFromParent_Done,
     /* 1756689 */   // Label 23947: @1756689
     /* 1756689 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1756775), // Rule ID 11359 //
     /* 1756694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756740 */     // MIs[0] policy
     /* 1756740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756774 */     // GIR_Coverage, 11359,
     /* 1756774 */     GIR_EraseRootFromParent_Done,
     /* 1756775 */   // Label 23948: @1756775
     /* 1756775 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1756861), // Rule ID 11362 //
     /* 1756780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756826 */     // MIs[0] policy
     /* 1756826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756860 */     // GIR_Coverage, 11362,
     /* 1756860 */     GIR_EraseRootFromParent_Done,
     /* 1756861 */   // Label 23949: @1756861
     /* 1756861 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1756947), // Rule ID 11363 //
     /* 1756866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756912 */     // MIs[0] policy
     /* 1756912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756922 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756946 */     // GIR_Coverage, 11363,
     /* 1756946 */     GIR_EraseRootFromParent_Done,
     /* 1756947 */   // Label 23950: @1756947
     /* 1756947 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1757033), // Rule ID 11366 //
     /* 1756952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756998 */     // MIs[0] policy
     /* 1756998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757008 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757032 */     // GIR_Coverage, 11366,
     /* 1757032 */     GIR_EraseRootFromParent_Done,
     /* 1757033 */   // Label 23951: @1757033
     /* 1757033 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1757119), // Rule ID 11367 //
     /* 1757038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757084 */     // MIs[0] policy
     /* 1757084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757118 */     // GIR_Coverage, 11367,
     /* 1757118 */     GIR_EraseRootFromParent_Done,
     /* 1757119 */   // Label 23952: @1757119
     /* 1757119 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1757205), // Rule ID 11370 //
     /* 1757124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757170 */     // MIs[0] policy
     /* 1757170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1757183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757204 */     // GIR_Coverage, 11370,
     /* 1757204 */     GIR_EraseRootFromParent_Done,
     /* 1757205 */   // Label 23953: @1757205
     /* 1757205 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1757291), // Rule ID 11371 //
     /* 1757210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757256 */     // MIs[0] policy
     /* 1757256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1757269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757290 */     // GIR_Coverage, 11371,
     /* 1757290 */     GIR_EraseRootFromParent_Done,
     /* 1757291 */   // Label 23954: @1757291
     /* 1757291 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1757377), // Rule ID 11374 //
     /* 1757296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757342 */     // MIs[0] policy
     /* 1757342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757376 */     // GIR_Coverage, 11374,
     /* 1757376 */     GIR_EraseRootFromParent_Done,
     /* 1757377 */   // Label 23955: @1757377
     /* 1757377 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1757463), // Rule ID 11375 //
     /* 1757382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757428 */     // MIs[0] policy
     /* 1757428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757462 */     // GIR_Coverage, 11375,
     /* 1757462 */     GIR_EraseRootFromParent_Done,
     /* 1757463 */   // Label 23956: @1757463
     /* 1757463 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1757549), // Rule ID 11378 //
     /* 1757468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757514 */     // MIs[0] policy
     /* 1757514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757548 */     // GIR_Coverage, 11378,
     /* 1757548 */     GIR_EraseRootFromParent_Done,
     /* 1757549 */   // Label 23957: @1757549
     /* 1757549 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1757635), // Rule ID 11379 //
     /* 1757554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757600 */     // MIs[0] policy
     /* 1757600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757610 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757634 */     // GIR_Coverage, 11379,
     /* 1757634 */     GIR_EraseRootFromParent_Done,
     /* 1757635 */   // Label 23958: @1757635
     /* 1757635 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1757721), // Rule ID 11382 //
     /* 1757640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757686 */     // MIs[0] policy
     /* 1757686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757720 */     // GIR_Coverage, 11382,
     /* 1757720 */     GIR_EraseRootFromParent_Done,
     /* 1757721 */   // Label 23959: @1757721
     /* 1757721 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1757807), // Rule ID 11383 //
     /* 1757726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757772 */     // MIs[0] policy
     /* 1757772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757806 */     // GIR_Coverage, 11383,
     /* 1757806 */     GIR_EraseRootFromParent_Done,
     /* 1757807 */   // Label 23960: @1757807
     /* 1757807 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1757893), // Rule ID 11386 //
     /* 1757812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757858 */     // MIs[0] policy
     /* 1757858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757892 */     // GIR_Coverage, 11386,
     /* 1757892 */     GIR_EraseRootFromParent_Done,
     /* 1757893 */   // Label 23961: @1757893
     /* 1757893 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1757979), // Rule ID 11387 //
     /* 1757898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757944 */     // MIs[0] policy
     /* 1757944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757978 */     // GIR_Coverage, 11387,
     /* 1757978 */     GIR_EraseRootFromParent_Done,
     /* 1757979 */   // Label 23962: @1757979
     /* 1757979 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1758065), // Rule ID 11390 //
     /* 1757984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758030 */     // MIs[0] policy
     /* 1758030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1758043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758064 */     // GIR_Coverage, 11390,
     /* 1758064 */     GIR_EraseRootFromParent_Done,
     /* 1758065 */   // Label 23963: @1758065
     /* 1758065 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1758151), // Rule ID 11391 //
     /* 1758070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758116 */     // MIs[0] policy
     /* 1758116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1758129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758150 */     // GIR_Coverage, 11391,
     /* 1758150 */     GIR_EraseRootFromParent_Done,
     /* 1758151 */   // Label 23964: @1758151
     /* 1758151 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1758237), // Rule ID 11394 //
     /* 1758156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758202 */     // MIs[0] policy
     /* 1758202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758236 */     // GIR_Coverage, 11394,
     /* 1758236 */     GIR_EraseRootFromParent_Done,
     /* 1758237 */   // Label 23965: @1758237
     /* 1758237 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1758323), // Rule ID 11395 //
     /* 1758242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758288 */     // MIs[0] policy
     /* 1758288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758322 */     // GIR_Coverage, 11395,
     /* 1758322 */     GIR_EraseRootFromParent_Done,
     /* 1758323 */   // Label 23966: @1758323
     /* 1758323 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1758409), // Rule ID 11398 //
     /* 1758328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758374 */     // MIs[0] policy
     /* 1758374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758408 */     // GIR_Coverage, 11398,
     /* 1758408 */     GIR_EraseRootFromParent_Done,
     /* 1758409 */   // Label 23967: @1758409
     /* 1758409 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1758495), // Rule ID 11399 //
     /* 1758414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758460 */     // MIs[0] policy
     /* 1758460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758470 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758494 */     // GIR_Coverage, 11399,
     /* 1758494 */     GIR_EraseRootFromParent_Done,
     /* 1758495 */   // Label 23968: @1758495
     /* 1758495 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1758581), // Rule ID 11402 //
     /* 1758500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758546 */     // MIs[0] policy
     /* 1758546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758580 */     // GIR_Coverage, 11402,
     /* 1758580 */     GIR_EraseRootFromParent_Done,
     /* 1758581 */   // Label 23969: @1758581
     /* 1758581 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1758667), // Rule ID 11403 //
     /* 1758586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758632 */     // MIs[0] policy
     /* 1758632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758666 */     // GIR_Coverage, 11403,
     /* 1758666 */     GIR_EraseRootFromParent_Done,
     /* 1758667 */   // Label 23970: @1758667
     /* 1758667 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1758753), // Rule ID 11406 //
     /* 1758672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758718 */     // MIs[0] policy
     /* 1758718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758752 */     // GIR_Coverage, 11406,
     /* 1758752 */     GIR_EraseRootFromParent_Done,
     /* 1758753 */   // Label 23971: @1758753
     /* 1758753 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1758839), // Rule ID 11407 //
     /* 1758758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758804 */     // MIs[0] policy
     /* 1758804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758838 */     // GIR_Coverage, 11407,
     /* 1758838 */     GIR_EraseRootFromParent_Done,
     /* 1758839 */   // Label 23972: @1758839
     /* 1758839 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1758925), // Rule ID 11410 //
     /* 1758844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758890 */     // MIs[0] policy
     /* 1758890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758924 */     // GIR_Coverage, 11410,
     /* 1758924 */     GIR_EraseRootFromParent_Done,
     /* 1758925 */   // Label 23973: @1758925
     /* 1758925 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1759011), // Rule ID 11411 //
     /* 1758930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758976 */     // MIs[0] policy
     /* 1758976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759010 */     // GIR_Coverage, 11411,
     /* 1759010 */     GIR_EraseRootFromParent_Done,
     /* 1759011 */   // Label 23974: @1759011
     /* 1759011 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1759097), // Rule ID 11414 //
     /* 1759016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759062 */     // MIs[0] policy
     /* 1759062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759096 */     // GIR_Coverage, 11414,
     /* 1759096 */     GIR_EraseRootFromParent_Done,
     /* 1759097 */   // Label 23975: @1759097
     /* 1759097 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1759183), // Rule ID 11415 //
     /* 1759102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759148 */     // MIs[0] policy
     /* 1759148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759182 */     // GIR_Coverage, 11415,
     /* 1759182 */     GIR_EraseRootFromParent_Done,
     /* 1759183 */   // Label 23976: @1759183
     /* 1759183 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1759269), // Rule ID 11418 //
     /* 1759188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759234 */     // MIs[0] policy
     /* 1759234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1759247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759268 */     // GIR_Coverage, 11418,
     /* 1759268 */     GIR_EraseRootFromParent_Done,
     /* 1759269 */   // Label 23977: @1759269
     /* 1759269 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1759355), // Rule ID 11419 //
     /* 1759274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759320 */     // MIs[0] policy
     /* 1759320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1759333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759354 */     // GIR_Coverage, 11419,
     /* 1759354 */     GIR_EraseRootFromParent_Done,
     /* 1759355 */   // Label 23978: @1759355
     /* 1759355 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1759441), // Rule ID 11422 //
     /* 1759360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759406 */     // MIs[0] policy
     /* 1759406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759440 */     // GIR_Coverage, 11422,
     /* 1759440 */     GIR_EraseRootFromParent_Done,
     /* 1759441 */   // Label 23979: @1759441
     /* 1759441 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1759527), // Rule ID 11423 //
     /* 1759446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759492 */     // MIs[0] policy
     /* 1759492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759526 */     // GIR_Coverage, 11423,
     /* 1759526 */     GIR_EraseRootFromParent_Done,
     /* 1759527 */   // Label 23980: @1759527
     /* 1759527 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1759613), // Rule ID 11426 //
     /* 1759532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759578 */     // MIs[0] policy
     /* 1759578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759612 */     // GIR_Coverage, 11426,
     /* 1759612 */     GIR_EraseRootFromParent_Done,
     /* 1759613 */   // Label 23981: @1759613
     /* 1759613 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1759699), // Rule ID 11427 //
     /* 1759618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759664 */     // MIs[0] policy
     /* 1759664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759698 */     // GIR_Coverage, 11427,
     /* 1759698 */     GIR_EraseRootFromParent_Done,
     /* 1759699 */   // Label 23982: @1759699
     /* 1759699 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1759785), // Rule ID 11430 //
     /* 1759704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759750 */     // MIs[0] policy
     /* 1759750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759784 */     // GIR_Coverage, 11430,
     /* 1759784 */     GIR_EraseRootFromParent_Done,
     /* 1759785 */   // Label 23983: @1759785
     /* 1759785 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1759871), // Rule ID 11431 //
     /* 1759790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759836 */     // MIs[0] policy
     /* 1759836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759846 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759870 */     // GIR_Coverage, 11431,
     /* 1759870 */     GIR_EraseRootFromParent_Done,
     /* 1759871 */   // Label 23984: @1759871
     /* 1759871 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1759957), // Rule ID 11434 //
     /* 1759876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759922 */     // MIs[0] policy
     /* 1759922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759932 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759956 */     // GIR_Coverage, 11434,
     /* 1759956 */     GIR_EraseRootFromParent_Done,
     /* 1759957 */   // Label 23985: @1759957
     /* 1759957 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1760043), // Rule ID 11435 //
     /* 1759962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760008 */     // MIs[0] policy
     /* 1760008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760042 */     // GIR_Coverage, 11435,
     /* 1760042 */     GIR_EraseRootFromParent_Done,
     /* 1760043 */   // Label 23986: @1760043
     /* 1760043 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1760129), // Rule ID 11438 //
     /* 1760048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760094 */     // MIs[0] policy
     /* 1760094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760128 */     // GIR_Coverage, 11438,
     /* 1760128 */     GIR_EraseRootFromParent_Done,
     /* 1760129 */   // Label 23987: @1760129
     /* 1760129 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1760215), // Rule ID 11439 //
     /* 1760134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1760154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760180 */     // MIs[0] policy
     /* 1760180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760190 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760214 */     // GIR_Coverage, 11439,
     /* 1760214 */     GIR_EraseRootFromParent_Done,
     /* 1760215 */   // Label 23988: @1760215
     /* 1760215 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1760301), // Rule ID 11442 //
     /* 1760220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1760240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760266 */     // MIs[0] policy
     /* 1760266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760300 */     // GIR_Coverage, 11442,
     /* 1760300 */     GIR_EraseRootFromParent_Done,
     /* 1760301 */   // Label 23989: @1760301
     /* 1760301 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1760387), // Rule ID 11443 //
     /* 1760306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1760326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760352 */     // MIs[0] policy
     /* 1760352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1760365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760386 */     // GIR_Coverage, 11443,
     /* 1760386 */     GIR_EraseRootFromParent_Done,
     /* 1760387 */   // Label 23990: @1760387
     /* 1760387 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1760473), // Rule ID 11446 //
     /* 1760392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760438 */     // MIs[0] policy
     /* 1760438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760472 */     // GIR_Coverage, 11446,
     /* 1760472 */     GIR_EraseRootFromParent_Done,
     /* 1760473 */   // Label 23991: @1760473
     /* 1760473 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1760559), // Rule ID 11447 //
     /* 1760478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760524 */     // MIs[0] policy
     /* 1760524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760558 */     // GIR_Coverage, 11447,
     /* 1760558 */     GIR_EraseRootFromParent_Done,
     /* 1760559 */   // Label 23992: @1760559
     /* 1760559 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1760645), // Rule ID 11450 //
     /* 1760564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760610 */     // MIs[0] policy
     /* 1760610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760644 */     // GIR_Coverage, 11450,
     /* 1760644 */     GIR_EraseRootFromParent_Done,
     /* 1760645 */   // Label 23993: @1760645
     /* 1760645 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1760731), // Rule ID 11451 //
     /* 1760650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760696 */     // MIs[0] policy
     /* 1760696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760730 */     // GIR_Coverage, 11451,
     /* 1760730 */     GIR_EraseRootFromParent_Done,
     /* 1760731 */   // Label 23994: @1760731
     /* 1760731 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1760817), // Rule ID 11454 //
     /* 1760736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760782 */     // MIs[0] policy
     /* 1760782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760816 */     // GIR_Coverage, 11454,
     /* 1760816 */     GIR_EraseRootFromParent_Done,
     /* 1760817 */   // Label 23995: @1760817
     /* 1760817 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1760903), // Rule ID 11455 //
     /* 1760822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760868 */     // MIs[0] policy
     /* 1760868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760878 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760902 */     // GIR_Coverage, 11455,
     /* 1760902 */     GIR_EraseRootFromParent_Done,
     /* 1760903 */   // Label 23996: @1760903
     /* 1760903 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1760989), // Rule ID 11458 //
     /* 1760908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760954 */     // MIs[0] policy
     /* 1760954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760988 */     // GIR_Coverage, 11458,
     /* 1760988 */     GIR_EraseRootFromParent_Done,
     /* 1760989 */   // Label 23997: @1760989
     /* 1760989 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1761075), // Rule ID 11459 //
     /* 1760994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1761014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761040 */     // MIs[0] policy
     /* 1761040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761074 */     // GIR_Coverage, 11459,
     /* 1761074 */     GIR_EraseRootFromParent_Done,
     /* 1761075 */   // Label 23998: @1761075
     /* 1761075 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1761161), // Rule ID 11462 //
     /* 1761080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1761100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761126 */     // MIs[0] policy
     /* 1761126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761160 */     // GIR_Coverage, 11462,
     /* 1761160 */     GIR_EraseRootFromParent_Done,
     /* 1761161 */   // Label 23999: @1761161
     /* 1761161 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1761247), // Rule ID 11463 //
     /* 1761166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1761186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761212 */     // MIs[0] policy
     /* 1761212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761246 */     // GIR_Coverage, 11463,
     /* 1761246 */     GIR_EraseRootFromParent_Done,
     /* 1761247 */   // Label 24000: @1761247
     /* 1761247 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1761333), // Rule ID 11466 //
     /* 1761252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761298 */     // MIs[0] policy
     /* 1761298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761308 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761332 */     // GIR_Coverage, 11466,
     /* 1761332 */     GIR_EraseRootFromParent_Done,
     /* 1761333 */   // Label 24001: @1761333
     /* 1761333 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1761419), // Rule ID 11467 //
     /* 1761338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1761358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761384 */     // MIs[0] policy
     /* 1761384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761418 */     // GIR_Coverage, 11467,
     /* 1761418 */     GIR_EraseRootFromParent_Done,
     /* 1761419 */   // Label 24002: @1761419
     /* 1761419 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1761505), // Rule ID 11470 //
     /* 1761424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761470 */     // MIs[0] policy
     /* 1761470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761480 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761504 */     // GIR_Coverage, 11470,
     /* 1761504 */     GIR_EraseRootFromParent_Done,
     /* 1761505 */   // Label 24003: @1761505
     /* 1761505 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1761591), // Rule ID 11471 //
     /* 1761510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761556 */     // MIs[0] policy
     /* 1761556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761590 */     // GIR_Coverage, 11471,
     /* 1761590 */     GIR_EraseRootFromParent_Done,
     /* 1761591 */   // Label 24004: @1761591
     /* 1761591 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1761677), // Rule ID 11474 //
     /* 1761596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761642 */     // MIs[0] policy
     /* 1761642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761676 */     // GIR_Coverage, 11474,
     /* 1761676 */     GIR_EraseRootFromParent_Done,
     /* 1761677 */   // Label 24005: @1761677
     /* 1761677 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1761763), // Rule ID 11475 //
     /* 1761682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761728 */     // MIs[0] policy
     /* 1761728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761762 */     // GIR_Coverage, 11475,
     /* 1761762 */     GIR_EraseRootFromParent_Done,
     /* 1761763 */   // Label 24006: @1761763
     /* 1761763 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1761849), // Rule ID 11478 //
     /* 1761768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761814 */     // MIs[0] policy
     /* 1761814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761848 */     // GIR_Coverage, 11478,
     /* 1761848 */     GIR_EraseRootFromParent_Done,
     /* 1761849 */   // Label 24007: @1761849
     /* 1761849 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1761935), // Rule ID 11479 //
     /* 1761854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761900 */     // MIs[0] policy
     /* 1761900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761934 */     // GIR_Coverage, 11479,
     /* 1761934 */     GIR_EraseRootFromParent_Done,
     /* 1761935 */   // Label 24008: @1761935
     /* 1761935 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1762021), // Rule ID 11482 //
     /* 1761940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761986 */     // MIs[0] policy
     /* 1761986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762020 */     // GIR_Coverage, 11482,
     /* 1762020 */     GIR_EraseRootFromParent_Done,
     /* 1762021 */   // Label 24009: @1762021
     /* 1762021 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1762107), // Rule ID 11483 //
     /* 1762026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1762046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762072 */     // MIs[0] policy
     /* 1762072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762106 */     // GIR_Coverage, 11483,
     /* 1762106 */     GIR_EraseRootFromParent_Done,
     /* 1762107 */   // Label 24010: @1762107
     /* 1762107 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1762193), // Rule ID 11486 //
     /* 1762112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1762132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762158 */     // MIs[0] policy
     /* 1762158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762192 */     // GIR_Coverage, 11486,
     /* 1762192 */     GIR_EraseRootFromParent_Done,
     /* 1762193 */   // Label 24011: @1762193
     /* 1762193 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1762279), // Rule ID 11487 //
     /* 1762198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1762218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762244 */     // MIs[0] policy
     /* 1762244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762254 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762278 */     // GIR_Coverage, 11487,
     /* 1762278 */     GIR_EraseRootFromParent_Done,
     /* 1762279 */   // Label 24012: @1762279
     /* 1762279 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1762365), // Rule ID 11490 //
     /* 1762284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762330 */     // MIs[0] policy
     /* 1762330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1762343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762364 */     // GIR_Coverage, 11490,
     /* 1762364 */     GIR_EraseRootFromParent_Done,
     /* 1762365 */   // Label 24013: @1762365
     /* 1762365 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1762451), // Rule ID 11491 //
     /* 1762370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1762390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762416 */     // MIs[0] policy
     /* 1762416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1762429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762450 */     // GIR_Coverage, 11491,
     /* 1762450 */     GIR_EraseRootFromParent_Done,
     /* 1762451 */   // Label 24014: @1762451
     /* 1762451 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1762537), // Rule ID 11494 //
     /* 1762456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762502 */     // MIs[0] policy
     /* 1762502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762536 */     // GIR_Coverage, 11494,
     /* 1762536 */     GIR_EraseRootFromParent_Done,
     /* 1762537 */   // Label 24015: @1762537
     /* 1762537 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1762623), // Rule ID 11495 //
     /* 1762542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762588 */     // MIs[0] policy
     /* 1762588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762622 */     // GIR_Coverage, 11495,
     /* 1762622 */     GIR_EraseRootFromParent_Done,
     /* 1762623 */   // Label 24016: @1762623
     /* 1762623 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1762709), // Rule ID 11498 //
     /* 1762628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762674 */     // MIs[0] policy
     /* 1762674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762708 */     // GIR_Coverage, 11498,
     /* 1762708 */     GIR_EraseRootFromParent_Done,
     /* 1762709 */   // Label 24017: @1762709
     /* 1762709 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1762795), // Rule ID 11499 //
     /* 1762714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762760 */     // MIs[0] policy
     /* 1762760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762794 */     // GIR_Coverage, 11499,
     /* 1762794 */     GIR_EraseRootFromParent_Done,
     /* 1762795 */   // Label 24018: @1762795
     /* 1762795 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1762881), // Rule ID 11502 //
     /* 1762800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762846 */     // MIs[0] policy
     /* 1762846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762880 */     // GIR_Coverage, 11502,
     /* 1762880 */     GIR_EraseRootFromParent_Done,
     /* 1762881 */   // Label 24019: @1762881
     /* 1762881 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1762967), // Rule ID 11503 //
     /* 1762886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762932 */     // MIs[0] policy
     /* 1762932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762966 */     // GIR_Coverage, 11503,
     /* 1762966 */     GIR_EraseRootFromParent_Done,
     /* 1762967 */   // Label 24020: @1762967
     /* 1762967 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1763053), // Rule ID 11506 //
     /* 1762972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763018 */     // MIs[0] policy
     /* 1763018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763028 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763052 */     // GIR_Coverage, 11506,
     /* 1763052 */     GIR_EraseRootFromParent_Done,
     /* 1763053 */   // Label 24021: @1763053
     /* 1763053 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1763139), // Rule ID 11507 //
     /* 1763058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763104 */     // MIs[0] policy
     /* 1763104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763138 */     // GIR_Coverage, 11507,
     /* 1763138 */     GIR_EraseRootFromParent_Done,
     /* 1763139 */   // Label 24022: @1763139
     /* 1763139 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1763225), // Rule ID 11510 //
     /* 1763144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763190 */     // MIs[0] policy
     /* 1763190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763224 */     // GIR_Coverage, 11510,
     /* 1763224 */     GIR_EraseRootFromParent_Done,
     /* 1763225 */   // Label 24023: @1763225
     /* 1763225 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1763311), // Rule ID 11511 //
     /* 1763230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763276 */     // MIs[0] policy
     /* 1763276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763310 */     // GIR_Coverage, 11511,
     /* 1763310 */     GIR_EraseRootFromParent_Done,
     /* 1763311 */   // Label 24024: @1763311
     /* 1763311 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1763397), // Rule ID 11514 //
     /* 1763316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763362 */     // MIs[0] policy
     /* 1763362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763396 */     // GIR_Coverage, 11514,
     /* 1763396 */     GIR_EraseRootFromParent_Done,
     /* 1763397 */   // Label 24025: @1763397
     /* 1763397 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1763483), // Rule ID 11515 //
     /* 1763402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763448 */     // MIs[0] policy
     /* 1763448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1763461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763482 */     // GIR_Coverage, 11515,
     /* 1763482 */     GIR_EraseRootFromParent_Done,
     /* 1763483 */   // Label 24026: @1763483
     /* 1763483 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1763569), // Rule ID 11518 //
     /* 1763488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763534 */     // MIs[0] policy
     /* 1763534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763568 */     // GIR_Coverage, 11518,
     /* 1763568 */     GIR_EraseRootFromParent_Done,
     /* 1763569 */   // Label 24027: @1763569
     /* 1763569 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1763655), // Rule ID 11519 //
     /* 1763574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763620 */     // MIs[0] policy
     /* 1763620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763654 */     // GIR_Coverage, 11519,
     /* 1763654 */     GIR_EraseRootFromParent_Done,
     /* 1763655 */   // Label 24028: @1763655
     /* 1763655 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1763741), // Rule ID 11522 //
     /* 1763660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763706 */     // MIs[0] policy
     /* 1763706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763740 */     // GIR_Coverage, 11522,
     /* 1763740 */     GIR_EraseRootFromParent_Done,
     /* 1763741 */   // Label 24029: @1763741
     /* 1763741 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1763827), // Rule ID 11523 //
     /* 1763746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763792 */     // MIs[0] policy
     /* 1763792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763826 */     // GIR_Coverage, 11523,
     /* 1763826 */     GIR_EraseRootFromParent_Done,
     /* 1763827 */   // Label 24030: @1763827
     /* 1763827 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1763913), // Rule ID 11526 //
     /* 1763832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763878 */     // MIs[0] policy
     /* 1763878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763912 */     // GIR_Coverage, 11526,
     /* 1763912 */     GIR_EraseRootFromParent_Done,
     /* 1763913 */   // Label 24031: @1763913
     /* 1763913 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1763999), // Rule ID 11527 //
     /* 1763918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763964 */     // MIs[0] policy
     /* 1763964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763998 */     // GIR_Coverage, 11527,
     /* 1763998 */     GIR_EraseRootFromParent_Done,
     /* 1763999 */   // Label 24032: @1763999
     /* 1763999 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1764085), // Rule ID 11530 //
     /* 1764004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764050 */     // MIs[0] policy
     /* 1764050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764084 */     // GIR_Coverage, 11530,
     /* 1764084 */     GIR_EraseRootFromParent_Done,
     /* 1764085 */   // Label 24033: @1764085
     /* 1764085 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1764171), // Rule ID 11531 //
     /* 1764090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764136 */     // MIs[0] policy
     /* 1764136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764170 */     // GIR_Coverage, 11531,
     /* 1764170 */     GIR_EraseRootFromParent_Done,
     /* 1764171 */   // Label 24034: @1764171
     /* 1764171 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1764257), // Rule ID 11534 //
     /* 1764176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764222 */     // MIs[0] policy
     /* 1764222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764256 */     // GIR_Coverage, 11534,
     /* 1764256 */     GIR_EraseRootFromParent_Done,
     /* 1764257 */   // Label 24035: @1764257
     /* 1764257 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1764343), // Rule ID 11535 //
     /* 1764262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764308 */     // MIs[0] policy
     /* 1764308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1764321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764342 */     // GIR_Coverage, 11535,
     /* 1764342 */     GIR_EraseRootFromParent_Done,
     /* 1764343 */   // Label 24036: @1764343
     /* 1764343 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1764429), // Rule ID 11538 //
     /* 1764348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764394 */     // MIs[0] policy
     /* 1764394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764428 */     // GIR_Coverage, 11538,
     /* 1764428 */     GIR_EraseRootFromParent_Done,
     /* 1764429 */   // Label 24037: @1764429
     /* 1764429 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1764515), // Rule ID 11539 //
     /* 1764434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764480 */     // MIs[0] policy
     /* 1764480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764514 */     // GIR_Coverage, 11539,
     /* 1764514 */     GIR_EraseRootFromParent_Done,
     /* 1764515 */   // Label 24038: @1764515
     /* 1764515 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1764601), // Rule ID 11542 //
     /* 1764520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764566 */     // MIs[0] policy
     /* 1764566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764576 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764600 */     // GIR_Coverage, 11542,
     /* 1764600 */     GIR_EraseRootFromParent_Done,
     /* 1764601 */   // Label 24039: @1764601
     /* 1764601 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1764687), // Rule ID 11543 //
     /* 1764606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764652 */     // MIs[0] policy
     /* 1764652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764686 */     // GIR_Coverage, 11543,
     /* 1764686 */     GIR_EraseRootFromParent_Done,
     /* 1764687 */   // Label 24040: @1764687
     /* 1764687 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1764773), // Rule ID 11546 //
     /* 1764692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764738 */     // MIs[0] policy
     /* 1764738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764748 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764772 */     // GIR_Coverage, 11546,
     /* 1764772 */     GIR_EraseRootFromParent_Done,
     /* 1764773 */   // Label 24041: @1764773
     /* 1764773 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1764859), // Rule ID 11547 //
     /* 1764778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764824 */     // MIs[0] policy
     /* 1764824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764858 */     // GIR_Coverage, 11547,
     /* 1764858 */     GIR_EraseRootFromParent_Done,
     /* 1764859 */   // Label 24042: @1764859
     /* 1764859 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1764945), // Rule ID 11550 //
     /* 1764864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764910 */     // MIs[0] policy
     /* 1764910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764944 */     // GIR_Coverage, 11550,
     /* 1764944 */     GIR_EraseRootFromParent_Done,
     /* 1764945 */   // Label 24043: @1764945
     /* 1764945 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1765031), // Rule ID 11551 //
     /* 1764950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764996 */     // MIs[0] policy
     /* 1764996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765030 */     // GIR_Coverage, 11551,
     /* 1765030 */     GIR_EraseRootFromParent_Done,
     /* 1765031 */   // Label 24044: @1765031
     /* 1765031 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1765117), // Rule ID 11554 //
     /* 1765036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765082 */     // MIs[0] policy
     /* 1765082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765092 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765116 */     // GIR_Coverage, 11554,
     /* 1765116 */     GIR_EraseRootFromParent_Done,
     /* 1765117 */   // Label 24045: @1765117
     /* 1765117 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1765203), // Rule ID 11555 //
     /* 1765122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765168 */     // MIs[0] policy
     /* 1765168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765178 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765202 */     // GIR_Coverage, 11555,
     /* 1765202 */     GIR_EraseRootFromParent_Done,
     /* 1765203 */   // Label 24046: @1765203
     /* 1765203 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1765289), // Rule ID 11558 //
     /* 1765208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765254 */     // MIs[0] policy
     /* 1765254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765288 */     // GIR_Coverage, 11558,
     /* 1765288 */     GIR_EraseRootFromParent_Done,
     /* 1765289 */   // Label 24047: @1765289
     /* 1765289 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1765375), // Rule ID 11559 //
     /* 1765294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765340 */     // MIs[0] policy
     /* 1765340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765350 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765374 */     // GIR_Coverage, 11559,
     /* 1765374 */     GIR_EraseRootFromParent_Done,
     /* 1765375 */   // Label 24048: @1765375
     /* 1765375 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1765461), // Rule ID 11562 //
     /* 1765380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765426 */     // MIs[0] policy
     /* 1765426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765460 */     // GIR_Coverage, 11562,
     /* 1765460 */     GIR_EraseRootFromParent_Done,
     /* 1765461 */   // Label 24049: @1765461
     /* 1765461 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1765547), // Rule ID 11563 //
     /* 1765466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765512 */     // MIs[0] policy
     /* 1765512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765546 */     // GIR_Coverage, 11563,
     /* 1765546 */     GIR_EraseRootFromParent_Done,
     /* 1765547 */   // Label 24050: @1765547
     /* 1765547 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1765633), // Rule ID 11566 //
     /* 1765552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765598 */     // MIs[0] policy
     /* 1765598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765632 */     // GIR_Coverage, 11566,
     /* 1765632 */     GIR_EraseRootFromParent_Done,
     /* 1765633 */   // Label 24051: @1765633
     /* 1765633 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1765719), // Rule ID 11567 //
     /* 1765638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765684 */     // MIs[0] policy
     /* 1765684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765718 */     // GIR_Coverage, 11567,
     /* 1765718 */     GIR_EraseRootFromParent_Done,
     /* 1765719 */   // Label 24052: @1765719
     /* 1765719 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1765805), // Rule ID 11570 //
     /* 1765724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765770 */     // MIs[0] policy
     /* 1765770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765780 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765804 */     // GIR_Coverage, 11570,
     /* 1765804 */     GIR_EraseRootFromParent_Done,
     /* 1765805 */   // Label 24053: @1765805
     /* 1765805 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1765891), // Rule ID 11571 //
     /* 1765810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765856 */     // MIs[0] policy
     /* 1765856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765866 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765890 */     // GIR_Coverage, 11571,
     /* 1765890 */     GIR_EraseRootFromParent_Done,
     /* 1765891 */   // Label 24054: @1765891
     /* 1765891 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1765977), // Rule ID 11574 //
     /* 1765896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765942 */     // MIs[0] policy
     /* 1765942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765976 */     // GIR_Coverage, 11574,
     /* 1765976 */     GIR_EraseRootFromParent_Done,
     /* 1765977 */   // Label 24055: @1765977
     /* 1765977 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1766063), // Rule ID 11575 //
     /* 1765982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766028 */     // MIs[0] policy
     /* 1766028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1766041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766062 */     // GIR_Coverage, 11575,
     /* 1766062 */     GIR_EraseRootFromParent_Done,
     /* 1766063 */   // Label 24056: @1766063
     /* 1766063 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1766149), // Rule ID 11578 //
     /* 1766068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766114 */     // MIs[0] policy
     /* 1766114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1766127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766148 */     // GIR_Coverage, 11578,
     /* 1766148 */     GIR_EraseRootFromParent_Done,
     /* 1766149 */   // Label 24057: @1766149
     /* 1766149 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1766235), // Rule ID 11579 //
     /* 1766154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766200 */     // MIs[0] policy
     /* 1766200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1766213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766234 */     // GIR_Coverage, 11579,
     /* 1766234 */     GIR_EraseRootFromParent_Done,
     /* 1766235 */   // Label 24058: @1766235
     /* 1766235 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1766321), // Rule ID 11582 //
     /* 1766240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766286 */     // MIs[0] policy
     /* 1766286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1766299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766320 */     // GIR_Coverage, 11582,
     /* 1766320 */     GIR_EraseRootFromParent_Done,
     /* 1766321 */   // Label 24059: @1766321
     /* 1766321 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1766407), // Rule ID 11583 //
     /* 1766326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766372 */     // MIs[0] policy
     /* 1766372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1766385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766406 */     // GIR_Coverage, 11583,
     /* 1766406 */     GIR_EraseRootFromParent_Done,
     /* 1766407 */   // Label 24060: @1766407
     /* 1766407 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1766493), // Rule ID 11586 //
     /* 1766412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766458 */     // MIs[0] policy
     /* 1766458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766492 */     // GIR_Coverage, 11586,
     /* 1766492 */     GIR_EraseRootFromParent_Done,
     /* 1766493 */   // Label 24061: @1766493
     /* 1766493 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1766579), // Rule ID 11587 //
     /* 1766498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766544 */     // MIs[0] policy
     /* 1766544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766578 */     // GIR_Coverage, 11587,
     /* 1766578 */     GIR_EraseRootFromParent_Done,
     /* 1766579 */   // Label 24062: @1766579
     /* 1766579 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1766665), // Rule ID 11590 //
     /* 1766584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766630 */     // MIs[0] policy
     /* 1766630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766664 */     // GIR_Coverage, 11590,
     /* 1766664 */     GIR_EraseRootFromParent_Done,
     /* 1766665 */   // Label 24063: @1766665
     /* 1766665 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1766751), // Rule ID 11591 //
     /* 1766670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766716 */     // MIs[0] policy
     /* 1766716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766750 */     // GIR_Coverage, 11591,
     /* 1766750 */     GIR_EraseRootFromParent_Done,
     /* 1766751 */   // Label 24064: @1766751
     /* 1766751 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1766837), // Rule ID 11594 //
     /* 1766756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766802 */     // MIs[0] policy
     /* 1766802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766836 */     // GIR_Coverage, 11594,
     /* 1766836 */     GIR_EraseRootFromParent_Done,
     /* 1766837 */   // Label 24065: @1766837
     /* 1766837 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1766923), // Rule ID 11595 //
     /* 1766842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766888 */     // MIs[0] policy
     /* 1766888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766922 */     // GIR_Coverage, 11595,
     /* 1766922 */     GIR_EraseRootFromParent_Done,
     /* 1766923 */   // Label 24066: @1766923
     /* 1766923 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1767009), // Rule ID 11598 //
     /* 1766928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766974 */     // MIs[0] policy
     /* 1766974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767008 */     // GIR_Coverage, 11598,
     /* 1767008 */     GIR_EraseRootFromParent_Done,
     /* 1767009 */   // Label 24067: @1767009
     /* 1767009 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1767095), // Rule ID 11599 //
     /* 1767014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767060 */     // MIs[0] policy
     /* 1767060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1767073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767094 */     // GIR_Coverage, 11599,
     /* 1767094 */     GIR_EraseRootFromParent_Done,
     /* 1767095 */   // Label 24068: @1767095
     /* 1767095 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1767181), // Rule ID 11602 //
     /* 1767100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767146 */     // MIs[0] policy
     /* 1767146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1767159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767180 */     // GIR_Coverage, 11602,
     /* 1767180 */     GIR_EraseRootFromParent_Done,
     /* 1767181 */   // Label 24069: @1767181
     /* 1767181 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1767267), // Rule ID 11603 //
     /* 1767186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1767194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767232 */     // MIs[0] policy
     /* 1767232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1767245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767266 */     // GIR_Coverage, 11603,
     /* 1767266 */     GIR_EraseRootFromParent_Done,
     /* 1767267 */   // Label 24070: @1767267
     /* 1767267 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1767353), // Rule ID 11606 //
     /* 1767272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1767292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767318 */     // MIs[0] policy
     /* 1767318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1767331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767352 */     // GIR_Coverage, 11606,
     /* 1767352 */     GIR_EraseRootFromParent_Done,
     /* 1767353 */   // Label 24071: @1767353
     /* 1767353 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1767439), // Rule ID 11607 //
     /* 1767358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1767378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767404 */     // MIs[0] policy
     /* 1767404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1767417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767438 */     // GIR_Coverage, 11607,
     /* 1767438 */     GIR_EraseRootFromParent_Done,
     /* 1767439 */   // Label 24072: @1767439
     /* 1767439 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1767525), // Rule ID 11610 //
     /* 1767444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767490 */     // MIs[0] policy
     /* 1767490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767524 */     // GIR_Coverage, 11610,
     /* 1767524 */     GIR_EraseRootFromParent_Done,
     /* 1767525 */   // Label 24073: @1767525
     /* 1767525 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1767611), // Rule ID 11611 //
     /* 1767530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767576 */     // MIs[0] policy
     /* 1767576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767610 */     // GIR_Coverage, 11611,
     /* 1767610 */     GIR_EraseRootFromParent_Done,
     /* 1767611 */   // Label 24074: @1767611
     /* 1767611 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1767697), // Rule ID 11614 //
     /* 1767616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767662 */     // MIs[0] policy
     /* 1767662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767696 */     // GIR_Coverage, 11614,
     /* 1767696 */     GIR_EraseRootFromParent_Done,
     /* 1767697 */   // Label 24075: @1767697
     /* 1767697 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1767783), // Rule ID 11615 //
     /* 1767702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767748 */     // MIs[0] policy
     /* 1767748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767782 */     // GIR_Coverage, 11615,
     /* 1767782 */     GIR_EraseRootFromParent_Done,
     /* 1767783 */   // Label 24076: @1767783
     /* 1767783 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1767869), // Rule ID 11618 //
     /* 1767788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767834 */     // MIs[0] policy
     /* 1767834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767868 */     // GIR_Coverage, 11618,
     /* 1767868 */     GIR_EraseRootFromParent_Done,
     /* 1767869 */   // Label 24077: @1767869
     /* 1767869 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1767955), // Rule ID 11619 //
     /* 1767874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767920 */     // MIs[0] policy
     /* 1767920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767954 */     // GIR_Coverage, 11619,
     /* 1767954 */     GIR_EraseRootFromParent_Done,
     /* 1767955 */   // Label 24078: @1767955
     /* 1767955 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1768041), // Rule ID 11622 //
     /* 1767960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768006 */     // MIs[0] policy
     /* 1768006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1768019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768040 */     // GIR_Coverage, 11622,
     /* 1768040 */     GIR_EraseRootFromParent_Done,
     /* 1768041 */   // Label 24079: @1768041
     /* 1768041 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1768127), // Rule ID 11623 //
     /* 1768046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768092 */     // MIs[0] policy
     /* 1768092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1768105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768126 */     // GIR_Coverage, 11623,
     /* 1768126 */     GIR_EraseRootFromParent_Done,
     /* 1768127 */   // Label 24080: @1768127
     /* 1768127 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1768213), // Rule ID 11626 //
     /* 1768132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768178 */     // MIs[0] policy
     /* 1768178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1768191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768212 */     // GIR_Coverage, 11626,
     /* 1768212 */     GIR_EraseRootFromParent_Done,
     /* 1768213 */   // Label 24081: @1768213
     /* 1768213 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1768299), // Rule ID 11627 //
     /* 1768218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768264 */     // MIs[0] policy
     /* 1768264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1768277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768298 */     // GIR_Coverage, 11627,
     /* 1768298 */     GIR_EraseRootFromParent_Done,
     /* 1768299 */   // Label 24082: @1768299
     /* 1768299 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1768385), // Rule ID 11630 //
     /* 1768304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768350 */     // MIs[0] policy
     /* 1768350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768360 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1768363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768384 */     // GIR_Coverage, 11630,
     /* 1768384 */     GIR_EraseRootFromParent_Done,
     /* 1768385 */   // Label 24083: @1768385
     /* 1768385 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1768471), // Rule ID 11631 //
     /* 1768390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768436 */     // MIs[0] policy
     /* 1768436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1768449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768470 */     // GIR_Coverage, 11631,
     /* 1768470 */     GIR_EraseRootFromParent_Done,
     /* 1768471 */   // Label 24084: @1768471
     /* 1768471 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1768557), // Rule ID 11634 //
     /* 1768476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768522 */     // MIs[0] policy
     /* 1768522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768532 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768556 */     // GIR_Coverage, 11634,
     /* 1768556 */     GIR_EraseRootFromParent_Done,
     /* 1768557 */   // Label 24085: @1768557
     /* 1768557 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1768643), // Rule ID 11635 //
     /* 1768562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768608 */     // MIs[0] policy
     /* 1768608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768642 */     // GIR_Coverage, 11635,
     /* 1768642 */     GIR_EraseRootFromParent_Done,
     /* 1768643 */   // Label 24086: @1768643
     /* 1768643 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1768729), // Rule ID 11638 //
     /* 1768648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768694 */     // MIs[0] policy
     /* 1768694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768728 */     // GIR_Coverage, 11638,
     /* 1768728 */     GIR_EraseRootFromParent_Done,
     /* 1768729 */   // Label 24087: @1768729
     /* 1768729 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1768815), // Rule ID 11639 //
     /* 1768734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768780 */     // MIs[0] policy
     /* 1768780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768814 */     // GIR_Coverage, 11639,
     /* 1768814 */     GIR_EraseRootFromParent_Done,
     /* 1768815 */   // Label 24088: @1768815
     /* 1768815 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1768901), // Rule ID 11642 //
     /* 1768820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768866 */     // MIs[0] policy
     /* 1768866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768900 */     // GIR_Coverage, 11642,
     /* 1768900 */     GIR_EraseRootFromParent_Done,
     /* 1768901 */   // Label 24089: @1768901
     /* 1768901 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1768987), // Rule ID 11643 //
     /* 1768906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768952 */     // MIs[0] policy
     /* 1768952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768986 */     // GIR_Coverage, 11643,
     /* 1768986 */     GIR_EraseRootFromParent_Done,
     /* 1768987 */   // Label 24090: @1768987
     /* 1768987 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1769073), // Rule ID 11646 //
     /* 1768992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769038 */     // MIs[0] policy
     /* 1769038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1769051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769072 */     // GIR_Coverage, 11646,
     /* 1769072 */     GIR_EraseRootFromParent_Done,
     /* 1769073 */   // Label 24091: @1769073
     /* 1769073 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1769159), // Rule ID 11647 //
     /* 1769078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1769098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769124 */     // MIs[0] policy
     /* 1769124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1769137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769158 */     // GIR_Coverage, 11647,
     /* 1769158 */     GIR_EraseRootFromParent_Done,
     /* 1769159 */   // Label 24092: @1769159
     /* 1769159 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1769245), // Rule ID 11650 //
     /* 1769164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769210 */     // MIs[0] policy
     /* 1769210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1769223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769244 */     // GIR_Coverage, 11650,
     /* 1769244 */     GIR_EraseRootFromParent_Done,
     /* 1769245 */   // Label 24093: @1769245
     /* 1769245 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1769331), // Rule ID 11651 //
     /* 1769250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1769270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769296 */     // MIs[0] policy
     /* 1769296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1769309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769330 */     // GIR_Coverage, 11651,
     /* 1769330 */     GIR_EraseRootFromParent_Done,
     /* 1769331 */   // Label 24094: @1769331
     /* 1769331 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1769417), // Rule ID 11654 //
     /* 1769336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769382 */     // MIs[0] policy
     /* 1769382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769392 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769416 */     // GIR_Coverage, 11654,
     /* 1769416 */     GIR_EraseRootFromParent_Done,
     /* 1769417 */   // Label 24095: @1769417
     /* 1769417 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1769503), // Rule ID 11655 //
     /* 1769422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1769433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1769436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1769439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769468 */     // MIs[0] policy
     /* 1769468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769502 */     // GIR_Coverage, 11655,
     /* 1769502 */     GIR_EraseRootFromParent_Done,
     /* 1769503 */   // Label 24096: @1769503
     /* 1769503 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1769589), // Rule ID 11658 //
     /* 1769508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769554 */     // MIs[0] policy
     /* 1769554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769588 */     // GIR_Coverage, 11658,
     /* 1769588 */     GIR_EraseRootFromParent_Done,
     /* 1769589 */   // Label 24097: @1769589
     /* 1769589 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1769675), // Rule ID 11659 //
     /* 1769594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769640 */     // MIs[0] policy
     /* 1769640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769674 */     // GIR_Coverage, 11659,
     /* 1769674 */     GIR_EraseRootFromParent_Done,
     /* 1769675 */   // Label 24098: @1769675
     /* 1769675 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1769761), // Rule ID 11662 //
     /* 1769680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769726 */     // MIs[0] policy
     /* 1769726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769760 */     // GIR_Coverage, 11662,
     /* 1769760 */     GIR_EraseRootFromParent_Done,
     /* 1769761 */   // Label 24099: @1769761
     /* 1769761 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1769847), // Rule ID 11663 //
     /* 1769766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769812 */     // MIs[0] policy
     /* 1769812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769822 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769846 */     // GIR_Coverage, 11663,
     /* 1769846 */     GIR_EraseRootFromParent_Done,
     /* 1769847 */   // Label 24100: @1769847
     /* 1769847 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1769933), // Rule ID 11666 //
     /* 1769852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769898 */     // MIs[0] policy
     /* 1769898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769932 */     // GIR_Coverage, 11666,
     /* 1769932 */     GIR_EraseRootFromParent_Done,
     /* 1769933 */   // Label 24101: @1769933
     /* 1769933 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1770019), // Rule ID 11667 //
     /* 1769938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769984 */     // MIs[0] policy
     /* 1769984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770018 */     // GIR_Coverage, 11667,
     /* 1770018 */     GIR_EraseRootFromParent_Done,
     /* 1770019 */   // Label 24102: @1770019
     /* 1770019 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1770105), // Rule ID 11670 //
     /* 1770024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770070 */     // MIs[0] policy
     /* 1770070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1770083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770104 */     // GIR_Coverage, 11670,
     /* 1770104 */     GIR_EraseRootFromParent_Done,
     /* 1770105 */   // Label 24103: @1770105
     /* 1770105 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1770191), // Rule ID 11671 //
     /* 1770110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770156 */     // MIs[0] policy
     /* 1770156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1770169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770190 */     // GIR_Coverage, 11671,
     /* 1770190 */     GIR_EraseRootFromParent_Done,
     /* 1770191 */   // Label 24104: @1770191
     /* 1770191 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1770277), // Rule ID 11674 //
     /* 1770196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770242 */     // MIs[0] policy
     /* 1770242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1770255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770276 */     // GIR_Coverage, 11674,
     /* 1770276 */     GIR_EraseRootFromParent_Done,
     /* 1770277 */   // Label 24105: @1770277
     /* 1770277 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1770363), // Rule ID 11675 //
     /* 1770282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770328 */     // MIs[0] policy
     /* 1770328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1770341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770362 */     // GIR_Coverage, 11675,
     /* 1770362 */     GIR_EraseRootFromParent_Done,
     /* 1770363 */   // Label 24106: @1770363
     /* 1770363 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1770449), // Rule ID 11678 //
     /* 1770368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770414 */     // MIs[0] policy
     /* 1770414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770448 */     // GIR_Coverage, 11678,
     /* 1770448 */     GIR_EraseRootFromParent_Done,
     /* 1770449 */   // Label 24107: @1770449
     /* 1770449 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1770535), // Rule ID 11679 //
     /* 1770454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770500 */     // MIs[0] policy
     /* 1770500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770534 */     // GIR_Coverage, 11679,
     /* 1770534 */     GIR_EraseRootFromParent_Done,
     /* 1770535 */   // Label 24108: @1770535
     /* 1770535 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1770621), // Rule ID 11682 //
     /* 1770540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770586 */     // MIs[0] policy
     /* 1770586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770620 */     // GIR_Coverage, 11682,
     /* 1770620 */     GIR_EraseRootFromParent_Done,
     /* 1770621 */   // Label 24109: @1770621
     /* 1770621 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1770707), // Rule ID 11683 //
     /* 1770626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770672 */     // MIs[0] policy
     /* 1770672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770706 */     // GIR_Coverage, 11683,
     /* 1770706 */     GIR_EraseRootFromParent_Done,
     /* 1770707 */   // Label 24110: @1770707
     /* 1770707 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1770793), // Rule ID 11686 //
     /* 1770712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770758 */     // MIs[0] policy
     /* 1770758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770792 */     // GIR_Coverage, 11686,
     /* 1770792 */     GIR_EraseRootFromParent_Done,
     /* 1770793 */   // Label 24111: @1770793
     /* 1770793 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1770879), // Rule ID 11687 //
     /* 1770798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770844 */     // MIs[0] policy
     /* 1770844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770878 */     // GIR_Coverage, 11687,
     /* 1770878 */     GIR_EraseRootFromParent_Done,
     /* 1770879 */   // Label 24112: @1770879
     /* 1770879 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1770965), // Rule ID 11690 //
     /* 1770884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770930 */     // MIs[0] policy
     /* 1770930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770964 */     // GIR_Coverage, 11690,
     /* 1770964 */     GIR_EraseRootFromParent_Done,
     /* 1770965 */   // Label 24113: @1770965
     /* 1770965 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1771051), // Rule ID 11691 //
     /* 1770970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771016 */     // MIs[0] policy
     /* 1771016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1771029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771050 */     // GIR_Coverage, 11691,
     /* 1771050 */     GIR_EraseRootFromParent_Done,
     /* 1771051 */   // Label 24114: @1771051
     /* 1771051 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1771137), // Rule ID 11694 //
     /* 1771056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771102 */     // MIs[0] policy
     /* 1771102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1771115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771136 */     // GIR_Coverage, 11694,
     /* 1771136 */     GIR_EraseRootFromParent_Done,
     /* 1771137 */   // Label 24115: @1771137
     /* 1771137 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1771223), // Rule ID 11695 //
     /* 1771142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771188 */     // MIs[0] policy
     /* 1771188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1771201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771222 */     // GIR_Coverage, 11695,
     /* 1771222 */     GIR_EraseRootFromParent_Done,
     /* 1771223 */   // Label 24116: @1771223
     /* 1771223 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1771309), // Rule ID 11698 //
     /* 1771228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771274 */     // MIs[0] policy
     /* 1771274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1771287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771308 */     // GIR_Coverage, 11698,
     /* 1771308 */     GIR_EraseRootFromParent_Done,
     /* 1771309 */   // Label 24117: @1771309
     /* 1771309 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1771395), // Rule ID 11699 //
     /* 1771314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771360 */     // MIs[0] policy
     /* 1771360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1771373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771394 */     // GIR_Coverage, 11699,
     /* 1771394 */     GIR_EraseRootFromParent_Done,
     /* 1771395 */   // Label 24118: @1771395
     /* 1771395 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1771481), // Rule ID 11702 //
     /* 1771400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771446 */     // MIs[0] policy
     /* 1771446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771480 */     // GIR_Coverage, 11702,
     /* 1771480 */     GIR_EraseRootFromParent_Done,
     /* 1771481 */   // Label 24119: @1771481
     /* 1771481 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1771567), // Rule ID 11703 //
     /* 1771486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771532 */     // MIs[0] policy
     /* 1771532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771566 */     // GIR_Coverage, 11703,
     /* 1771566 */     GIR_EraseRootFromParent_Done,
     /* 1771567 */   // Label 24120: @1771567
     /* 1771567 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1771653), // Rule ID 11706 //
     /* 1771572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1771575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771618 */     // MIs[0] policy
     /* 1771618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771652 */     // GIR_Coverage, 11706,
     /* 1771652 */     GIR_EraseRootFromParent_Done,
     /* 1771653 */   // Label 24121: @1771653
     /* 1771653 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1771739), // Rule ID 11707 //
     /* 1771658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1771661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771704 */     // MIs[0] policy
     /* 1771704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771738 */     // GIR_Coverage, 11707,
     /* 1771738 */     GIR_EraseRootFromParent_Done,
     /* 1771739 */   // Label 24122: @1771739
     /* 1771739 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1771825), // Rule ID 11710 //
     /* 1771744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771790 */     // MIs[0] policy
     /* 1771790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771824 */     // GIR_Coverage, 11710,
     /* 1771824 */     GIR_EraseRootFromParent_Done,
     /* 1771825 */   // Label 24123: @1771825
     /* 1771825 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1771911), // Rule ID 11711 //
     /* 1771830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771876 */     // MIs[0] policy
     /* 1771876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771910 */     // GIR_Coverage, 11711,
     /* 1771910 */     GIR_EraseRootFromParent_Done,
     /* 1771911 */   // Label 24124: @1771911
     /* 1771911 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1771997), // Rule ID 11714 //
     /* 1771916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771962 */     // MIs[0] policy
     /* 1771962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771996 */     // GIR_Coverage, 11714,
     /* 1771996 */     GIR_EraseRootFromParent_Done,
     /* 1771997 */   // Label 24125: @1771997
     /* 1771997 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1772083), // Rule ID 11715 //
     /* 1772002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772048 */     // MIs[0] policy
     /* 1772048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1772061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772082 */     // GIR_Coverage, 11715,
     /* 1772082 */     GIR_EraseRootFromParent_Done,
     /* 1772083 */   // Label 24126: @1772083
     /* 1772083 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1772169), // Rule ID 11718 //
     /* 1772088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772134 */     // MIs[0] policy
     /* 1772134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1772147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772168 */     // GIR_Coverage, 11718,
     /* 1772168 */     GIR_EraseRootFromParent_Done,
     /* 1772169 */   // Label 24127: @1772169
     /* 1772169 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1772255), // Rule ID 11719 //
     /* 1772174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772220 */     // MIs[0] policy
     /* 1772220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1772233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772254 */     // GIR_Coverage, 11719,
     /* 1772254 */     GIR_EraseRootFromParent_Done,
     /* 1772255 */   // Label 24128: @1772255
     /* 1772255 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1772341), // Rule ID 11722 //
     /* 1772260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772306 */     // MIs[0] policy
     /* 1772306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1772319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772340 */     // GIR_Coverage, 11722,
     /* 1772340 */     GIR_EraseRootFromParent_Done,
     /* 1772341 */   // Label 24129: @1772341
     /* 1772341 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1772427), // Rule ID 11723 //
     /* 1772346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772392 */     // MIs[0] policy
     /* 1772392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1772405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772426 */     // GIR_Coverage, 11723,
     /* 1772426 */     GIR_EraseRootFromParent_Done,
     /* 1772427 */   // Label 24130: @1772427
     /* 1772427 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1772513), // Rule ID 11726 //
     /* 1772432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772478 */     // MIs[0] policy
     /* 1772478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772512 */     // GIR_Coverage, 11726,
     /* 1772512 */     GIR_EraseRootFromParent_Done,
     /* 1772513 */   // Label 24131: @1772513
     /* 1772513 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1772599), // Rule ID 11727 //
     /* 1772518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772564 */     // MIs[0] policy
     /* 1772564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772598 */     // GIR_Coverage, 11727,
     /* 1772598 */     GIR_EraseRootFromParent_Done,
     /* 1772599 */   // Label 24132: @1772599
     /* 1772599 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1772685), // Rule ID 11730 //
     /* 1772604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772650 */     // MIs[0] policy
     /* 1772650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772684 */     // GIR_Coverage, 11730,
     /* 1772684 */     GIR_EraseRootFromParent_Done,
     /* 1772685 */   // Label 24133: @1772685
     /* 1772685 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1772771), // Rule ID 11731 //
     /* 1772690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772736 */     // MIs[0] policy
     /* 1772736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772770 */     // GIR_Coverage, 11731,
     /* 1772770 */     GIR_EraseRootFromParent_Done,
     /* 1772771 */   // Label 24134: @1772771
     /* 1772771 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1772857), // Rule ID 11734 //
     /* 1772776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772822 */     // MIs[0] policy
     /* 1772822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772856 */     // GIR_Coverage, 11734,
     /* 1772856 */     GIR_EraseRootFromParent_Done,
     /* 1772857 */   // Label 24135: @1772857
     /* 1772857 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1772943), // Rule ID 11735 //
     /* 1772862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772908 */     // MIs[0] policy
     /* 1772908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772942 */     // GIR_Coverage, 11735,
     /* 1772942 */     GIR_EraseRootFromParent_Done,
     /* 1772943 */   // Label 24136: @1772943
     /* 1772943 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1773029), // Rule ID 11738 //
     /* 1772948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772994 */     // MIs[0] policy
     /* 1772994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1773007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773028 */     // GIR_Coverage, 11738,
     /* 1773028 */     GIR_EraseRootFromParent_Done,
     /* 1773029 */   // Label 24137: @1773029
     /* 1773029 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1773115), // Rule ID 11739 //
     /* 1773034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773080 */     // MIs[0] policy
     /* 1773080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1773093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773114 */     // GIR_Coverage, 11739,
     /* 1773114 */     GIR_EraseRootFromParent_Done,
     /* 1773115 */   // Label 24138: @1773115
     /* 1773115 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1773201), // Rule ID 11742 //
     /* 1773120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773166 */     // MIs[0] policy
     /* 1773166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1773179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773200 */     // GIR_Coverage, 11742,
     /* 1773200 */     GIR_EraseRootFromParent_Done,
     /* 1773201 */   // Label 24139: @1773201
     /* 1773201 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1773287), // Rule ID 11743 //
     /* 1773206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773252 */     // MIs[0] policy
     /* 1773252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1773265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773286 */     // GIR_Coverage, 11743,
     /* 1773286 */     GIR_EraseRootFromParent_Done,
     /* 1773287 */   // Label 24140: @1773287
     /* 1773287 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1773373), // Rule ID 11746 //
     /* 1773292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773338 */     // MIs[0] policy
     /* 1773338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1773351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773372 */     // GIR_Coverage, 11746,
     /* 1773372 */     GIR_EraseRootFromParent_Done,
     /* 1773373 */   // Label 24141: @1773373
     /* 1773373 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1773459), // Rule ID 11747 //
     /* 1773378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773424 */     // MIs[0] policy
     /* 1773424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1773437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773458 */     // GIR_Coverage, 11747,
     /* 1773458 */     GIR_EraseRootFromParent_Done,
     /* 1773459 */   // Label 24142: @1773459
     /* 1773459 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1773545), // Rule ID 11750 //
     /* 1773464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773510 */     // MIs[0] policy
     /* 1773510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773544 */     // GIR_Coverage, 11750,
     /* 1773544 */     GIR_EraseRootFromParent_Done,
     /* 1773545 */   // Label 24143: @1773545
     /* 1773545 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1773631), // Rule ID 11751 //
     /* 1773550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773596 */     // MIs[0] policy
     /* 1773596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773630 */     // GIR_Coverage, 11751,
     /* 1773630 */     GIR_EraseRootFromParent_Done,
     /* 1773631 */   // Label 24144: @1773631
     /* 1773631 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1773717), // Rule ID 11754 //
     /* 1773636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773682 */     // MIs[0] policy
     /* 1773682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773716 */     // GIR_Coverage, 11754,
     /* 1773716 */     GIR_EraseRootFromParent_Done,
     /* 1773717 */   // Label 24145: @1773717
     /* 1773717 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1773803), // Rule ID 11755 //
     /* 1773722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773768 */     // MIs[0] policy
     /* 1773768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773802 */     // GIR_Coverage, 11755,
     /* 1773802 */     GIR_EraseRootFromParent_Done,
     /* 1773803 */   // Label 24146: @1773803
     /* 1773803 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1773889), // Rule ID 11758 //
     /* 1773808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773854 */     // MIs[0] policy
     /* 1773854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773888 */     // GIR_Coverage, 11758,
     /* 1773888 */     GIR_EraseRootFromParent_Done,
     /* 1773889 */   // Label 24147: @1773889
     /* 1773889 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1773975), // Rule ID 11759 //
     /* 1773894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773940 */     // MIs[0] policy
     /* 1773940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773974 */     // GIR_Coverage, 11759,
     /* 1773974 */     GIR_EraseRootFromParent_Done,
     /* 1773975 */   // Label 24148: @1773975
     /* 1773975 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1774061), // Rule ID 11762 //
     /* 1773980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774026 */     // MIs[0] policy
     /* 1774026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1774039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774060 */     // GIR_Coverage, 11762,
     /* 1774060 */     GIR_EraseRootFromParent_Done,
     /* 1774061 */   // Label 24149: @1774061
     /* 1774061 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1774147), // Rule ID 11763 //
     /* 1774066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1774077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774112 */     // MIs[0] policy
     /* 1774112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1774125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774146 */     // GIR_Coverage, 11763,
     /* 1774146 */     GIR_EraseRootFromParent_Done,
     /* 1774147 */   // Label 24150: @1774147
     /* 1774147 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1774233), // Rule ID 11766 //
     /* 1774152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774198 */     // MIs[0] policy
     /* 1774198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1774211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774232 */     // GIR_Coverage, 11766,
     /* 1774232 */     GIR_EraseRootFromParent_Done,
     /* 1774233 */   // Label 24151: @1774233
     /* 1774233 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1774319), // Rule ID 11767 //
     /* 1774238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774284 */     // MIs[0] policy
     /* 1774284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1774297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774318 */     // GIR_Coverage, 11767,
     /* 1774318 */     GIR_EraseRootFromParent_Done,
     /* 1774319 */   // Label 24152: @1774319
     /* 1774319 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1774405), // Rule ID 11770 //
     /* 1774324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774370 */     // MIs[0] policy
     /* 1774370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774404 */     // GIR_Coverage, 11770,
     /* 1774404 */     GIR_EraseRootFromParent_Done,
     /* 1774405 */   // Label 24153: @1774405
     /* 1774405 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1774491), // Rule ID 11771 //
     /* 1774410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774456 */     // MIs[0] policy
     /* 1774456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774490 */     // GIR_Coverage, 11771,
     /* 1774490 */     GIR_EraseRootFromParent_Done,
     /* 1774491 */   // Label 24154: @1774491
     /* 1774491 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1774577), // Rule ID 11774 //
     /* 1774496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774542 */     // MIs[0] policy
     /* 1774542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774576 */     // GIR_Coverage, 11774,
     /* 1774576 */     GIR_EraseRootFromParent_Done,
     /* 1774577 */   // Label 24155: @1774577
     /* 1774577 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1774663), // Rule ID 11775 //
     /* 1774582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774628 */     // MIs[0] policy
     /* 1774628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774662 */     // GIR_Coverage, 11775,
     /* 1774662 */     GIR_EraseRootFromParent_Done,
     /* 1774663 */   // Label 24156: @1774663
     /* 1774663 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1774749), // Rule ID 11778 //
     /* 1774668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774714 */     // MIs[0] policy
     /* 1774714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774748 */     // GIR_Coverage, 11778,
     /* 1774748 */     GIR_EraseRootFromParent_Done,
     /* 1774749 */   // Label 24157: @1774749
     /* 1774749 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1774835), // Rule ID 11779 //
     /* 1774754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774800 */     // MIs[0] policy
     /* 1774800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774834 */     // GIR_Coverage, 11779,
     /* 1774834 */     GIR_EraseRootFromParent_Done,
     /* 1774835 */   // Label 24158: @1774835
     /* 1774835 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1774921), // Rule ID 11782 //
     /* 1774840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774886 */     // MIs[0] policy
     /* 1774886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774920 */     // GIR_Coverage, 11782,
     /* 1774920 */     GIR_EraseRootFromParent_Done,
     /* 1774921 */   // Label 24159: @1774921
     /* 1774921 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1775007), // Rule ID 11783 //
     /* 1774926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774972 */     // MIs[0] policy
     /* 1774972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11240:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775006 */     // GIR_Coverage, 11783,
     /* 1775006 */     GIR_EraseRootFromParent_Done,
     /* 1775007 */   // Label 24160: @1775007
     /* 1775007 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1775093), // Rule ID 11786 //
     /* 1775012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775058 */     // MIs[0] policy
     /* 1775058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1775071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775092 */     // GIR_Coverage, 11786,
     /* 1775092 */     GIR_EraseRootFromParent_Done,
     /* 1775093 */   // Label 24161: @1775093
     /* 1775093 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1775179), // Rule ID 11787 //
     /* 1775098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775144 */     // MIs[0] policy
     /* 1775144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11240:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1775157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775178 */     // GIR_Coverage, 11787,
     /* 1775178 */     GIR_EraseRootFromParent_Done,
     /* 1775179 */   // Label 24162: @1775179
     /* 1775179 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1775265), // Rule ID 11790 //
     /* 1775184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775230 */     // MIs[0] policy
     /* 1775230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1775243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775264 */     // GIR_Coverage, 11790,
     /* 1775264 */     GIR_EraseRootFromParent_Done,
     /* 1775265 */   // Label 24163: @1775265
     /* 1775265 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1775351), // Rule ID 11791 //
     /* 1775270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775316 */     // MIs[0] policy
     /* 1775316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1775329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775350 */     // GIR_Coverage, 11791,
     /* 1775350 */     GIR_EraseRootFromParent_Done,
     /* 1775351 */   // Label 24164: @1775351
     /* 1775351 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1775437), // Rule ID 11794 //
     /* 1775356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1775359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775402 */     // MIs[0] policy
     /* 1775402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775436 */     // GIR_Coverage, 11794,
     /* 1775436 */     GIR_EraseRootFromParent_Done,
     /* 1775437 */   // Label 24165: @1775437
     /* 1775437 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1775523), // Rule ID 11795 //
     /* 1775442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1775445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775488 */     // MIs[0] policy
     /* 1775488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775522 */     // GIR_Coverage, 11795,
     /* 1775522 */     GIR_EraseRootFromParent_Done,
     /* 1775523 */   // Label 24166: @1775523
     /* 1775523 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1775609), // Rule ID 11798 //
     /* 1775528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775574 */     // MIs[0] policy
     /* 1775574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775608 */     // GIR_Coverage, 11798,
     /* 1775608 */     GIR_EraseRootFromParent_Done,
     /* 1775609 */   // Label 24167: @1775609
     /* 1775609 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1775695), // Rule ID 11799 //
     /* 1775614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775660 */     // MIs[0] policy
     /* 1775660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775694 */     // GIR_Coverage, 11799,
     /* 1775694 */     GIR_EraseRootFromParent_Done,
     /* 1775695 */   // Label 24168: @1775695
     /* 1775695 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1775781), // Rule ID 11802 //
     /* 1775700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775746 */     // MIs[0] policy
     /* 1775746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775756 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775780 */     // GIR_Coverage, 11802,
     /* 1775780 */     GIR_EraseRootFromParent_Done,
     /* 1775781 */   // Label 24169: @1775781
     /* 1775781 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1775867), // Rule ID 11803 //
     /* 1775786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775832 */     // MIs[0] policy
     /* 1775832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775866 */     // GIR_Coverage, 11803,
     /* 1775866 */     GIR_EraseRootFromParent_Done,
     /* 1775867 */   // Label 24170: @1775867
     /* 1775867 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1775953), // Rule ID 11806 //
     /* 1775872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775918 */     // MIs[0] policy
     /* 1775918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775952 */     // GIR_Coverage, 11806,
     /* 1775952 */     GIR_EraseRootFromParent_Done,
     /* 1775953 */   // Label 24171: @1775953
     /* 1775953 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1776039), // Rule ID 11807 //
     /* 1775958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776004 */     // MIs[0] policy
     /* 1776004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1776017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776038 */     // GIR_Coverage, 11807,
     /* 1776038 */     GIR_EraseRootFromParent_Done,
     /* 1776039 */   // Label 24172: @1776039
     /* 1776039 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1776125), // Rule ID 11810 //
     /* 1776044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776090 */     // MIs[0] policy
     /* 1776090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1776103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776124 */     // GIR_Coverage, 11810,
     /* 1776124 */     GIR_EraseRootFromParent_Done,
     /* 1776125 */   // Label 24173: @1776125
     /* 1776125 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1776211), // Rule ID 11811 //
     /* 1776130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776176 */     // MIs[0] policy
     /* 1776176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1776189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776210 */     // GIR_Coverage, 11811,
     /* 1776210 */     GIR_EraseRootFromParent_Done,
     /* 1776211 */   // Label 24174: @1776211
     /* 1776211 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1776297), // Rule ID 11814 //
     /* 1776216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776262 */     // MIs[0] policy
     /* 1776262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1776275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776296 */     // GIR_Coverage, 11814,
     /* 1776296 */     GIR_EraseRootFromParent_Done,
     /* 1776297 */   // Label 24175: @1776297
     /* 1776297 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1776383), // Rule ID 11815 //
     /* 1776302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776348 */     // MIs[0] policy
     /* 1776348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1776361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776382 */     // GIR_Coverage, 11815,
     /* 1776382 */     GIR_EraseRootFromParent_Done,
     /* 1776383 */   // Label 24176: @1776383
     /* 1776383 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1776469), // Rule ID 11818 //
     /* 1776388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776434 */     // MIs[0] policy
     /* 1776434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776444 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776468 */     // GIR_Coverage, 11818,
     /* 1776468 */     GIR_EraseRootFromParent_Done,
     /* 1776469 */   // Label 24177: @1776469
     /* 1776469 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1776555), // Rule ID 11819 //
     /* 1776474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776520 */     // MIs[0] policy
     /* 1776520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776554 */     // GIR_Coverage, 11819,
     /* 1776554 */     GIR_EraseRootFromParent_Done,
     /* 1776555 */   // Label 24178: @1776555
     /* 1776555 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1776641), // Rule ID 11822 //
     /* 1776560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776606 */     // MIs[0] policy
     /* 1776606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776640 */     // GIR_Coverage, 11822,
     /* 1776640 */     GIR_EraseRootFromParent_Done,
     /* 1776641 */   // Label 24179: @1776641
     /* 1776641 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1776727), // Rule ID 11823 //
     /* 1776646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776692 */     // MIs[0] policy
     /* 1776692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776726 */     // GIR_Coverage, 11823,
     /* 1776726 */     GIR_EraseRootFromParent_Done,
     /* 1776727 */   // Label 24180: @1776727
     /* 1776727 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1776813), // Rule ID 11826 //
     /* 1776732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776778 */     // MIs[0] policy
     /* 1776778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776812 */     // GIR_Coverage, 11826,
     /* 1776812 */     GIR_EraseRootFromParent_Done,
     /* 1776813 */   // Label 24181: @1776813
     /* 1776813 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1776899), // Rule ID 11827 //
     /* 1776818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776864 */     // MIs[0] policy
     /* 1776864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776898 */     // GIR_Coverage, 11827,
     /* 1776898 */     GIR_EraseRootFromParent_Done,
     /* 1776899 */   // Label 24182: @1776899
     /* 1776899 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1776985), // Rule ID 11830 //
     /* 1776904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776950 */     // MIs[0] policy
     /* 1776950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776984 */     // GIR_Coverage, 11830,
     /* 1776984 */     GIR_EraseRootFromParent_Done,
     /* 1776985 */   // Label 24183: @1776985
     /* 1776985 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1777071), // Rule ID 11831 //
     /* 1776990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1777004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1777007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777036 */     // MIs[0] policy
     /* 1777036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1777049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777070 */     // GIR_Coverage, 11831,
     /* 1777070 */     GIR_EraseRootFromParent_Done,
     /* 1777071 */   // Label 24184: @1777071
     /* 1777071 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1777157), // Rule ID 11834 //
     /* 1777076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777122 */     // MIs[0] policy
     /* 1777122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1777135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777156 */     // GIR_Coverage, 11834,
     /* 1777156 */     GIR_EraseRootFromParent_Done,
     /* 1777157 */   // Label 24185: @1777157
     /* 1777157 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1777243), // Rule ID 11835 //
     /* 1777162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777208 */     // MIs[0] policy
     /* 1777208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1777221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777242 */     // GIR_Coverage, 11835,
     /* 1777242 */     GIR_EraseRootFromParent_Done,
     /* 1777243 */   // Label 24186: @1777243
     /* 1777243 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1777329), // Rule ID 11838 //
     /* 1777248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777294 */     // MIs[0] policy
     /* 1777294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1777307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777328 */     // GIR_Coverage, 11838,
     /* 1777328 */     GIR_EraseRootFromParent_Done,
     /* 1777329 */   // Label 24187: @1777329
     /* 1777329 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1777415), // Rule ID 11839 //
     /* 1777334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777380 */     // MIs[0] policy
     /* 1777380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1777393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777414 */     // GIR_Coverage, 11839,
     /* 1777414 */     GIR_EraseRootFromParent_Done,
     /* 1777415 */   // Label 24188: @1777415
     /* 1777415 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1777501), // Rule ID 11842 //
     /* 1777420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777466 */     // MIs[0] policy
     /* 1777466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777500 */     // GIR_Coverage, 11842,
     /* 1777500 */     GIR_EraseRootFromParent_Done,
     /* 1777501 */   // Label 24189: @1777501
     /* 1777501 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1777587), // Rule ID 11843 //
     /* 1777506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777552 */     // MIs[0] policy
     /* 1777552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777586 */     // GIR_Coverage, 11843,
     /* 1777586 */     GIR_EraseRootFromParent_Done,
     /* 1777587 */   // Label 24190: @1777587
     /* 1777587 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1777673), // Rule ID 11846 //
     /* 1777592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777638 */     // MIs[0] policy
     /* 1777638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777648 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777672 */     // GIR_Coverage, 11846,
     /* 1777672 */     GIR_EraseRootFromParent_Done,
     /* 1777673 */   // Label 24191: @1777673
     /* 1777673 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1777759), // Rule ID 11847 //
     /* 1777678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777724 */     // MIs[0] policy
     /* 1777724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777758 */     // GIR_Coverage, 11847,
     /* 1777758 */     GIR_EraseRootFromParent_Done,
     /* 1777759 */   // Label 24192: @1777759
     /* 1777759 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1777845), // Rule ID 11850 //
     /* 1777764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777810 */     // MIs[0] policy
     /* 1777810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777844 */     // GIR_Coverage, 11850,
     /* 1777844 */     GIR_EraseRootFromParent_Done,
     /* 1777845 */   // Label 24193: @1777845
     /* 1777845 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1777931), // Rule ID 11851 //
     /* 1777850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777896 */     // MIs[0] policy
     /* 1777896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777930 */     // GIR_Coverage, 11851,
     /* 1777930 */     GIR_EraseRootFromParent_Done,
     /* 1777931 */   // Label 24194: @1777931
     /* 1777931 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1778017), // Rule ID 11854 //
     /* 1777936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777982 */     // MIs[0] policy
     /* 1777982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777992 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1777995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778016 */     // GIR_Coverage, 11854,
     /* 1778016 */     GIR_EraseRootFromParent_Done,
     /* 1778017 */   // Label 24195: @1778017
     /* 1778017 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1778103), // Rule ID 11855 //
     /* 1778022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1778033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1778036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1778039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1778042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778068 */     // MIs[0] policy
     /* 1778068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1778081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778102 */     // GIR_Coverage, 11855,
     /* 1778102 */     GIR_EraseRootFromParent_Done,
     /* 1778103 */   // Label 24196: @1778103
     /* 1778103 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1778189), // Rule ID 11858 //
     /* 1778108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778154 */     // MIs[0] policy
     /* 1778154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1778167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778188 */     // GIR_Coverage, 11858,
     /* 1778188 */     GIR_EraseRootFromParent_Done,
     /* 1778189 */   // Label 24197: @1778189
     /* 1778189 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1778275), // Rule ID 11859 //
     /* 1778194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778240 */     // MIs[0] policy
     /* 1778240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1778253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778274 */     // GIR_Coverage, 11859,
     /* 1778274 */     GIR_EraseRootFromParent_Done,
     /* 1778275 */   // Label 24198: @1778275
     /* 1778275 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1778361), // Rule ID 11862 //
     /* 1778280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778326 */     // MIs[0] policy
     /* 1778326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1778339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778360 */     // GIR_Coverage, 11862,
     /* 1778360 */     GIR_EraseRootFromParent_Done,
     /* 1778361 */   // Label 24199: @1778361
     /* 1778361 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1778447), // Rule ID 11863 //
     /* 1778366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778412 */     // MIs[0] policy
     /* 1778412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778422 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1778425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778446 */     // GIR_Coverage, 11863,
     /* 1778446 */     GIR_EraseRootFromParent_Done,
     /* 1778447 */   // Label 24200: @1778447
     /* 1778447 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1778533), // Rule ID 11866 //
     /* 1778452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778498 */     // MIs[0] policy
     /* 1778498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778532 */     // GIR_Coverage, 11866,
     /* 1778532 */     GIR_EraseRootFromParent_Done,
     /* 1778533 */   // Label 24201: @1778533
     /* 1778533 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1778619), // Rule ID 11867 //
     /* 1778538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778584 */     // MIs[0] policy
     /* 1778584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778618 */     // GIR_Coverage, 11867,
     /* 1778618 */     GIR_EraseRootFromParent_Done,
     /* 1778619 */   // Label 24202: @1778619
     /* 1778619 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1778705), // Rule ID 11870 //
     /* 1778624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778670 */     // MIs[0] policy
     /* 1778670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778704 */     // GIR_Coverage, 11870,
     /* 1778704 */     GIR_EraseRootFromParent_Done,
     /* 1778705 */   // Label 24203: @1778705
     /* 1778705 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1778791), // Rule ID 11871 //
     /* 1778710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778756 */     // MIs[0] policy
     /* 1778756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778790 */     // GIR_Coverage, 11871,
     /* 1778790 */     GIR_EraseRootFromParent_Done,
     /* 1778791 */   // Label 24204: @1778791
     /* 1778791 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1778877), // Rule ID 11874 //
     /* 1778796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778842 */     // MIs[0] policy
     /* 1778842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778876 */     // GIR_Coverage, 11874,
     /* 1778876 */     GIR_EraseRootFromParent_Done,
     /* 1778877 */   // Label 24205: @1778877
     /* 1778877 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1778963), // Rule ID 11875 //
     /* 1778882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778928 */     // MIs[0] policy
     /* 1778928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778962 */     // GIR_Coverage, 11875,
     /* 1778962 */     GIR_EraseRootFromParent_Done,
     /* 1778963 */   // Label 24206: @1778963
     /* 1778963 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1779049), // Rule ID 11878 //
     /* 1778968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779014 */     // MIs[0] policy
     /* 1779014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1779027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779048 */     // GIR_Coverage, 11878,
     /* 1779048 */     GIR_EraseRootFromParent_Done,
     /* 1779049 */   // Label 24207: @1779049
     /* 1779049 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1779135), // Rule ID 11879 //
     /* 1779054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1779065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1779068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1779071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1779074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779100 */     // MIs[0] policy
     /* 1779100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1779113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779134 */     // GIR_Coverage, 11879,
     /* 1779134 */     GIR_EraseRootFromParent_Done,
     /* 1779135 */   // Label 24208: @1779135
     /* 1779135 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1779221), // Rule ID 11882 //
     /* 1779140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1779143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779186 */     // MIs[0] policy
     /* 1779186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1779199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779220 */     // GIR_Coverage, 11882,
     /* 1779220 */     GIR_EraseRootFromParent_Done,
     /* 1779221 */   // Label 24209: @1779221
     /* 1779221 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1779307), // Rule ID 11883 //
     /* 1779226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1779229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779272 */     // MIs[0] policy
     /* 1779272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1779285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779306 */     // GIR_Coverage, 11883,
     /* 1779306 */     GIR_EraseRootFromParent_Done,
     /* 1779307 */   // Label 24210: @1779307
     /* 1779307 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1779393), // Rule ID 11886 //
     /* 1779312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779358 */     // MIs[0] policy
     /* 1779358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1779371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779392 */     // GIR_Coverage, 11886,
     /* 1779392 */     GIR_EraseRootFromParent_Done,
     /* 1779393 */   // Label 24211: @1779393
     /* 1779393 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1779479), // Rule ID 11887 //
     /* 1779398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779444 */     // MIs[0] policy
     /* 1779444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779454 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1779457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779478 */     // GIR_Coverage, 11887,
     /* 1779478 */     GIR_EraseRootFromParent_Done,
     /* 1779479 */   // Label 24212: @1779479
     /* 1779479 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1779565), // Rule ID 11890 //
     /* 1779484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779530 */     // MIs[0] policy
     /* 1779530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779564 */     // GIR_Coverage, 11890,
     /* 1779564 */     GIR_EraseRootFromParent_Done,
     /* 1779565 */   // Label 24213: @1779565
     /* 1779565 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1779651), // Rule ID 11891 //
     /* 1779570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779616 */     // MIs[0] policy
     /* 1779616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779650 */     // GIR_Coverage, 11891,
     /* 1779650 */     GIR_EraseRootFromParent_Done,
     /* 1779651 */   // Label 24214: @1779651
     /* 1779651 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1779737), // Rule ID 11894 //
     /* 1779656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779702 */     // MIs[0] policy
     /* 1779702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779712 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779736 */     // GIR_Coverage, 11894,
     /* 1779736 */     GIR_EraseRootFromParent_Done,
     /* 1779737 */   // Label 24215: @1779737
     /* 1779737 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1779823), // Rule ID 11895 //
     /* 1779742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779788 */     // MIs[0] policy
     /* 1779788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779822 */     // GIR_Coverage, 11895,
     /* 1779822 */     GIR_EraseRootFromParent_Done,
     /* 1779823 */   // Label 24216: @1779823
     /* 1779823 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1779909), // Rule ID 11898 //
     /* 1779828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779874 */     // MIs[0] policy
     /* 1779874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779908 */     // GIR_Coverage, 11898,
     /* 1779908 */     GIR_EraseRootFromParent_Done,
     /* 1779909 */   // Label 24217: @1779909
     /* 1779909 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1779995), // Rule ID 11899 //
     /* 1779914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779960 */     // MIs[0] policy
     /* 1779960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779994 */     // GIR_Coverage, 11899,
     /* 1779994 */     GIR_EraseRootFromParent_Done,
     /* 1779995 */   // Label 24218: @1779995
     /* 1779995 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1780081), // Rule ID 11902 //
     /* 1780000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780046 */     // MIs[0] policy
     /* 1780046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1780059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780080 */     // GIR_Coverage, 11902,
     /* 1780080 */     GIR_EraseRootFromParent_Done,
     /* 1780081 */   // Label 24219: @1780081
     /* 1780081 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1780167), // Rule ID 11903 //
     /* 1780086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780132 */     // MIs[0] policy
     /* 1780132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1780145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780166 */     // GIR_Coverage, 11903,
     /* 1780166 */     GIR_EraseRootFromParent_Done,
     /* 1780167 */   // Label 24220: @1780167
     /* 1780167 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1780253), // Rule ID 11906 //
     /* 1780172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780218 */     // MIs[0] policy
     /* 1780218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1780231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780252 */     // GIR_Coverage, 11906,
     /* 1780252 */     GIR_EraseRootFromParent_Done,
     /* 1780253 */   // Label 24221: @1780253
     /* 1780253 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1780339), // Rule ID 11907 //
     /* 1780258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780304 */     // MIs[0] policy
     /* 1780304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1780317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780338 */     // GIR_Coverage, 11907,
     /* 1780338 */     GIR_EraseRootFromParent_Done,
     /* 1780339 */   // Label 24222: @1780339
     /* 1780339 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1780425), // Rule ID 11910 //
     /* 1780344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780390 */     // MIs[0] policy
     /* 1780390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780424 */     // GIR_Coverage, 11910,
     /* 1780424 */     GIR_EraseRootFromParent_Done,
     /* 1780425 */   // Label 24223: @1780425
     /* 1780425 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1780511), // Rule ID 11911 //
     /* 1780430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780476 */     // MIs[0] policy
     /* 1780476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780510 */     // GIR_Coverage, 11911,
     /* 1780510 */     GIR_EraseRootFromParent_Done,
     /* 1780511 */   // Label 24224: @1780511
     /* 1780511 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1780597), // Rule ID 11914 //
     /* 1780516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780562 */     // MIs[0] policy
     /* 1780562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780596 */     // GIR_Coverage, 11914,
     /* 1780596 */     GIR_EraseRootFromParent_Done,
     /* 1780597 */   // Label 24225: @1780597
     /* 1780597 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1780683), // Rule ID 11915 //
     /* 1780602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780648 */     // MIs[0] policy
     /* 1780648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780682 */     // GIR_Coverage, 11915,
     /* 1780682 */     GIR_EraseRootFromParent_Done,
     /* 1780683 */   // Label 24226: @1780683
     /* 1780683 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1780769), // Rule ID 11918 //
     /* 1780688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780734 */     // MIs[0] policy
     /* 1780734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780768 */     // GIR_Coverage, 11918,
     /* 1780768 */     GIR_EraseRootFromParent_Done,
     /* 1780769 */   // Label 24227: @1780769
     /* 1780769 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1780855), // Rule ID 11919 //
     /* 1780774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780820 */     // MIs[0] policy
     /* 1780820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780854 */     // GIR_Coverage, 11919,
     /* 1780854 */     GIR_EraseRootFromParent_Done,
     /* 1780855 */   // Label 24228: @1780855
     /* 1780855 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1780941), // Rule ID 11922 //
     /* 1780860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780906 */     // MIs[0] policy
     /* 1780906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780940 */     // GIR_Coverage, 11922,
     /* 1780940 */     GIR_EraseRootFromParent_Done,
     /* 1780941 */   // Label 24229: @1780941
     /* 1780941 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1781027), // Rule ID 11923 //
     /* 1780946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780992 */     // MIs[0] policy
     /* 1780992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1781005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781026 */     // GIR_Coverage, 11923,
     /* 1781026 */     GIR_EraseRootFromParent_Done,
     /* 1781027 */   // Label 24230: @1781027
     /* 1781027 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1781113), // Rule ID 11926 //
     /* 1781032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781078 */     // MIs[0] policy
     /* 1781078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781088 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1781091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781112 */     // GIR_Coverage, 11926,
     /* 1781112 */     GIR_EraseRootFromParent_Done,
     /* 1781113 */   // Label 24231: @1781113
     /* 1781113 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1781199), // Rule ID 11927 //
     /* 1781118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781164 */     // MIs[0] policy
     /* 1781164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1781177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781198 */     // GIR_Coverage, 11927,
     /* 1781198 */     GIR_EraseRootFromParent_Done,
     /* 1781199 */   // Label 24232: @1781199
     /* 1781199 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1781285), // Rule ID 11930 //
     /* 1781204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781250 */     // MIs[0] policy
     /* 1781250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781260 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1781263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781284 */     // GIR_Coverage, 11930,
     /* 1781284 */     GIR_EraseRootFromParent_Done,
     /* 1781285 */   // Label 24233: @1781285
     /* 1781285 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1781371), // Rule ID 11931 //
     /* 1781290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781336 */     // MIs[0] policy
     /* 1781336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1781349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781370 */     // GIR_Coverage, 11931,
     /* 1781370 */     GIR_EraseRootFromParent_Done,
     /* 1781371 */   // Label 24234: @1781371
     /* 1781371 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1781457), // Rule ID 11934 //
     /* 1781376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781422 */     // MIs[0] policy
     /* 1781422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781456 */     // GIR_Coverage, 11934,
     /* 1781456 */     GIR_EraseRootFromParent_Done,
     /* 1781457 */   // Label 24235: @1781457
     /* 1781457 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1781543), // Rule ID 11935 //
     /* 1781462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781508 */     // MIs[0] policy
     /* 1781508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781542 */     // GIR_Coverage, 11935,
     /* 1781542 */     GIR_EraseRootFromParent_Done,
     /* 1781543 */   // Label 24236: @1781543
     /* 1781543 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1781629), // Rule ID 11938 //
     /* 1781548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781594 */     // MIs[0] policy
     /* 1781594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781628 */     // GIR_Coverage, 11938,
     /* 1781628 */     GIR_EraseRootFromParent_Done,
     /* 1781629 */   // Label 24237: @1781629
     /* 1781629 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1781715), // Rule ID 11939 //
     /* 1781634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781680 */     // MIs[0] policy
     /* 1781680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781714 */     // GIR_Coverage, 11939,
     /* 1781714 */     GIR_EraseRootFromParent_Done,
     /* 1781715 */   // Label 24238: @1781715
     /* 1781715 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1781801), // Rule ID 11942 //
     /* 1781720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781766 */     // MIs[0] policy
     /* 1781766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781800 */     // GIR_Coverage, 11942,
     /* 1781800 */     GIR_EraseRootFromParent_Done,
     /* 1781801 */   // Label 24239: @1781801
     /* 1781801 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1781887), // Rule ID 11943 //
     /* 1781806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781852 */     // MIs[0] policy
     /* 1781852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781862 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781886 */     // GIR_Coverage, 11943,
     /* 1781886 */     GIR_EraseRootFromParent_Done,
     /* 1781887 */   // Label 24240: @1781887
     /* 1781887 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1781973), // Rule ID 11946 //
     /* 1781892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781938 */     // MIs[0] policy
     /* 1781938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781972 */     // GIR_Coverage, 11946,
     /* 1781972 */     GIR_EraseRootFromParent_Done,
     /* 1781973 */   // Label 24241: @1781973
     /* 1781973 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1782059), // Rule ID 11947 //
     /* 1781978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782024 */     // MIs[0] policy
     /* 1782024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1782037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782058 */     // GIR_Coverage, 11947,
     /* 1782058 */     GIR_EraseRootFromParent_Done,
     /* 1782059 */   // Label 24242: @1782059
     /* 1782059 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1782145), // Rule ID 11950 //
     /* 1782064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782110 */     // MIs[0] policy
     /* 1782110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1782123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782144 */     // GIR_Coverage, 11950,
     /* 1782144 */     GIR_EraseRootFromParent_Done,
     /* 1782145 */   // Label 24243: @1782145
     /* 1782145 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1782231), // Rule ID 11951 //
     /* 1782150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782196 */     // MIs[0] policy
     /* 1782196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1782209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782230 */     // GIR_Coverage, 11951,
     /* 1782230 */     GIR_EraseRootFromParent_Done,
     /* 1782231 */   // Label 24244: @1782231
     /* 1782231 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1782317), // Rule ID 11954 //
     /* 1782236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782282 */     // MIs[0] policy
     /* 1782282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1782295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782316 */     // GIR_Coverage, 11954,
     /* 1782316 */     GIR_EraseRootFromParent_Done,
     /* 1782317 */   // Label 24245: @1782317
     /* 1782317 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1782403), // Rule ID 11955 //
     /* 1782322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782368 */     // MIs[0] policy
     /* 1782368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1782381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782402 */     // GIR_Coverage, 11955,
     /* 1782402 */     GIR_EraseRootFromParent_Done,
     /* 1782403 */   // Label 24246: @1782403
     /* 1782403 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1782489), // Rule ID 11958 //
     /* 1782408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782454 */     // MIs[0] policy
     /* 1782454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782488 */     // GIR_Coverage, 11958,
     /* 1782488 */     GIR_EraseRootFromParent_Done,
     /* 1782489 */   // Label 24247: @1782489
     /* 1782489 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1782575), // Rule ID 11959 //
     /* 1782494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782540 */     // MIs[0] policy
     /* 1782540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782574 */     // GIR_Coverage, 11959,
     /* 1782574 */     GIR_EraseRootFromParent_Done,
     /* 1782575 */   // Label 24248: @1782575
     /* 1782575 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1782661), // Rule ID 11962 //
     /* 1782580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782626 */     // MIs[0] policy
     /* 1782626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782660 */     // GIR_Coverage, 11962,
     /* 1782660 */     GIR_EraseRootFromParent_Done,
     /* 1782661 */   // Label 24249: @1782661
     /* 1782661 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1782747), // Rule ID 11963 //
     /* 1782666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782712 */     // MIs[0] policy
     /* 1782712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782746 */     // GIR_Coverage, 11963,
     /* 1782746 */     GIR_EraseRootFromParent_Done,
     /* 1782747 */   // Label 24250: @1782747
     /* 1782747 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1782833), // Rule ID 11966 //
     /* 1782752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782798 */     // MIs[0] policy
     /* 1782798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782832 */     // GIR_Coverage, 11966,
     /* 1782832 */     GIR_EraseRootFromParent_Done,
     /* 1782833 */   // Label 24251: @1782833
     /* 1782833 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1782919), // Rule ID 11967 //
     /* 1782838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782884 */     // MIs[0] policy
     /* 1782884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782918 */     // GIR_Coverage, 11967,
     /* 1782918 */     GIR_EraseRootFromParent_Done,
     /* 1782919 */   // Label 24252: @1782919
     /* 1782919 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1783005), // Rule ID 11970 //
     /* 1782924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782970 */     // MIs[0] policy
     /* 1782970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783004 */     // GIR_Coverage, 11970,
     /* 1783004 */     GIR_EraseRootFromParent_Done,
     /* 1783005 */   // Label 24253: @1783005
     /* 1783005 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1783091), // Rule ID 11971 //
     /* 1783010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1783013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1783021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1783024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1783027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783056 */     // MIs[0] policy
     /* 1783056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1783069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783090 */     // GIR_Coverage, 11971,
     /* 1783090 */     GIR_EraseRootFromParent_Done,
     /* 1783091 */   // Label 24254: @1783091
     /* 1783091 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1783177), // Rule ID 11974 //
     /* 1783096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783142 */     // MIs[0] policy
     /* 1783142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1783155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783176 */     // GIR_Coverage, 11974,
     /* 1783176 */     GIR_EraseRootFromParent_Done,
     /* 1783177 */   // Label 24255: @1783177
     /* 1783177 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1783263), // Rule ID 11975 //
     /* 1783182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783228 */     // MIs[0] policy
     /* 1783228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783238 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1783241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783262 */     // GIR_Coverage, 11975,
     /* 1783262 */     GIR_EraseRootFromParent_Done,
     /* 1783263 */   // Label 24256: @1783263
     /* 1783263 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1783349), // Rule ID 11978 //
     /* 1783268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783314 */     // MIs[0] policy
     /* 1783314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783324 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1783327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783348 */     // GIR_Coverage, 11978,
     /* 1783348 */     GIR_EraseRootFromParent_Done,
     /* 1783349 */   // Label 24257: @1783349
     /* 1783349 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1783435), // Rule ID 11979 //
     /* 1783354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783400 */     // MIs[0] policy
     /* 1783400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1783413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783434 */     // GIR_Coverage, 11979,
     /* 1783434 */     GIR_EraseRootFromParent_Done,
     /* 1783435 */   // Label 24258: @1783435
     /* 1783435 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1783521), // Rule ID 11982 //
     /* 1783440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783486 */     // MIs[0] policy
     /* 1783486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783520 */     // GIR_Coverage, 11982,
     /* 1783520 */     GIR_EraseRootFromParent_Done,
     /* 1783521 */   // Label 24259: @1783521
     /* 1783521 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1783607), // Rule ID 11983 //
     /* 1783526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783572 */     // MIs[0] policy
     /* 1783572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783606 */     // GIR_Coverage, 11983,
     /* 1783606 */     GIR_EraseRootFromParent_Done,
     /* 1783607 */   // Label 24260: @1783607
     /* 1783607 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1783693), // Rule ID 11986 //
     /* 1783612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783658 */     // MIs[0] policy
     /* 1783658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783692 */     // GIR_Coverage, 11986,
     /* 1783692 */     GIR_EraseRootFromParent_Done,
     /* 1783693 */   // Label 24261: @1783693
     /* 1783693 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1783779), // Rule ID 11987 //
     /* 1783698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783744 */     // MIs[0] policy
     /* 1783744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783778 */     // GIR_Coverage, 11987,
     /* 1783778 */     GIR_EraseRootFromParent_Done,
     /* 1783779 */   // Label 24262: @1783779
     /* 1783779 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1783865), // Rule ID 11990 //
     /* 1783784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783830 */     // MIs[0] policy
     /* 1783830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783864 */     // GIR_Coverage, 11990,
     /* 1783864 */     GIR_EraseRootFromParent_Done,
     /* 1783865 */   // Label 24263: @1783865
     /* 1783865 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1783951), // Rule ID 11991 //
     /* 1783870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783916 */     // MIs[0] policy
     /* 1783916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783950 */     // GIR_Coverage, 11991,
     /* 1783950 */     GIR_EraseRootFromParent_Done,
     /* 1783951 */   // Label 24264: @1783951
     /* 1783951 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1784037), // Rule ID 11994 //
     /* 1783956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784002 */     // MIs[0] policy
     /* 1784002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784012 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1784015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784036 */     // GIR_Coverage, 11994,
     /* 1784036 */     GIR_EraseRootFromParent_Done,
     /* 1784037 */   // Label 24265: @1784037
     /* 1784037 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1784123), // Rule ID 11995 //
     /* 1784042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1784053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1784056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1784059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784088 */     // MIs[0] policy
     /* 1784088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1784101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784122 */     // GIR_Coverage, 11995,
     /* 1784122 */     GIR_EraseRootFromParent_Done,
     /* 1784123 */   // Label 24266: @1784123
     /* 1784123 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1784209), // Rule ID 11998 //
     /* 1784128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784174 */     // MIs[0] policy
     /* 1784174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1784187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784208 */     // GIR_Coverage, 11998,
     /* 1784208 */     GIR_EraseRootFromParent_Done,
     /* 1784209 */   // Label 24267: @1784209
     /* 1784209 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1784295), // Rule ID 11999 //
     /* 1784214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784260 */     // MIs[0] policy
     /* 1784260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1784273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784294 */     // GIR_Coverage, 11999,
     /* 1784294 */     GIR_EraseRootFromParent_Done,
     /* 1784295 */   // Label 24268: @1784295
     /* 1784295 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1784381), // Rule ID 12002 //
     /* 1784300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784346 */     // MIs[0] policy
     /* 1784346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1784359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784380 */     // GIR_Coverage, 12002,
     /* 1784380 */     GIR_EraseRootFromParent_Done,
     /* 1784381 */   // Label 24269: @1784381
     /* 1784381 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1784467), // Rule ID 12003 //
     /* 1784386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784432 */     // MIs[0] policy
     /* 1784432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1784445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784466 */     // GIR_Coverage, 12003,
     /* 1784466 */     GIR_EraseRootFromParent_Done,
     /* 1784467 */   // Label 24270: @1784467
     /* 1784467 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1784553), // Rule ID 12006 //
     /* 1784472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784518 */     // MIs[0] policy
     /* 1784518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784552 */     // GIR_Coverage, 12006,
     /* 1784552 */     GIR_EraseRootFromParent_Done,
     /* 1784553 */   // Label 24271: @1784553
     /* 1784553 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1784639), // Rule ID 12007 //
     /* 1784558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784604 */     // MIs[0] policy
     /* 1784604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784638 */     // GIR_Coverage, 12007,
     /* 1784638 */     GIR_EraseRootFromParent_Done,
     /* 1784639 */   // Label 24272: @1784639
     /* 1784639 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1784725), // Rule ID 12010 //
     /* 1784644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784690 */     // MIs[0] policy
     /* 1784690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784724 */     // GIR_Coverage, 12010,
     /* 1784724 */     GIR_EraseRootFromParent_Done,
     /* 1784725 */   // Label 24273: @1784725
     /* 1784725 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1784811), // Rule ID 12011 //
     /* 1784730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784776 */     // MIs[0] policy
     /* 1784776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784810 */     // GIR_Coverage, 12011,
     /* 1784810 */     GIR_EraseRootFromParent_Done,
     /* 1784811 */   // Label 24274: @1784811
     /* 1784811 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1784897), // Rule ID 12014 //
     /* 1784816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784862 */     // MIs[0] policy
     /* 1784862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784896 */     // GIR_Coverage, 12014,
     /* 1784896 */     GIR_EraseRootFromParent_Done,
     /* 1784897 */   // Label 24275: @1784897
     /* 1784897 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1784983), // Rule ID 12015 //
     /* 1784902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784948 */     // MIs[0] policy
     /* 1784948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784982 */     // GIR_Coverage, 12015,
     /* 1784982 */     GIR_EraseRootFromParent_Done,
     /* 1784983 */   // Label 24276: @1784983
     /* 1784983 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1785069), // Rule ID 12018 //
     /* 1784988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785034 */     // MIs[0] policy
     /* 1785034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1785047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785068 */     // GIR_Coverage, 12018,
     /* 1785068 */     GIR_EraseRootFromParent_Done,
     /* 1785069 */   // Label 24277: @1785069
     /* 1785069 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1785155), // Rule ID 12019 //
     /* 1785074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1785082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1785085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785120 */     // MIs[0] policy
     /* 1785120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1785133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785154 */     // GIR_Coverage, 12019,
     /* 1785154 */     GIR_EraseRootFromParent_Done,
     /* 1785155 */   // Label 24278: @1785155
     /* 1785155 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1785241), // Rule ID 12022 //
     /* 1785160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785206 */     // MIs[0] policy
     /* 1785206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785216 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1785219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785240 */     // GIR_Coverage, 12022,
     /* 1785240 */     GIR_EraseRootFromParent_Done,
     /* 1785241 */   // Label 24279: @1785241
     /* 1785241 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1785327), // Rule ID 12023 //
     /* 1785246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785292 */     // MIs[0] policy
     /* 1785292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1785305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785326 */     // GIR_Coverage, 12023,
     /* 1785326 */     GIR_EraseRootFromParent_Done,
     /* 1785327 */   // Label 24280: @1785327
     /* 1785327 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1785413), // Rule ID 12026 //
     /* 1785332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785378 */     // MIs[0] policy
     /* 1785378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785412 */     // GIR_Coverage, 12026,
     /* 1785412 */     GIR_EraseRootFromParent_Done,
     /* 1785413 */   // Label 24281: @1785413
     /* 1785413 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1785499), // Rule ID 12027 //
     /* 1785418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785464 */     // MIs[0] policy
     /* 1785464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785474 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785498 */     // GIR_Coverage, 12027,
     /* 1785498 */     GIR_EraseRootFromParent_Done,
     /* 1785499 */   // Label 24282: @1785499
     /* 1785499 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1785585), // Rule ID 12030 //
     /* 1785504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785550 */     // MIs[0] policy
     /* 1785550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785584 */     // GIR_Coverage, 12030,
     /* 1785584 */     GIR_EraseRootFromParent_Done,
     /* 1785585 */   // Label 24283: @1785585
     /* 1785585 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1785671), // Rule ID 12031 //
     /* 1785590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785636 */     // MIs[0] policy
     /* 1785636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785670 */     // GIR_Coverage, 12031,
     /* 1785670 */     GIR_EraseRootFromParent_Done,
     /* 1785671 */   // Label 24284: @1785671
     /* 1785671 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1785757), // Rule ID 12034 //
     /* 1785676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785722 */     // MIs[0] policy
     /* 1785722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785756 */     // GIR_Coverage, 12034,
     /* 1785756 */     GIR_EraseRootFromParent_Done,
     /* 1785757 */   // Label 24285: @1785757
     /* 1785757 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1785843), // Rule ID 12035 //
     /* 1785762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785808 */     // MIs[0] policy
     /* 1785808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785842 */     // GIR_Coverage, 12035,
     /* 1785842 */     GIR_EraseRootFromParent_Done,
     /* 1785843 */   // Label 24286: @1785843
     /* 1785843 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1785929), // Rule ID 12038 //
     /* 1785848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785894 */     // MIs[0] policy
     /* 1785894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785928 */     // GIR_Coverage, 12038,
     /* 1785928 */     GIR_EraseRootFromParent_Done,
     /* 1785929 */   // Label 24287: @1785929
     /* 1785929 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1786015), // Rule ID 12039 //
     /* 1785934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785980 */     // MIs[0] policy
     /* 1785980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786014 */     // GIR_Coverage, 12039,
     /* 1786014 */     GIR_EraseRootFromParent_Done,
     /* 1786015 */   // Label 24288: @1786015
     /* 1786015 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1786101), // Rule ID 12042 //
     /* 1786020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786066 */     // MIs[0] policy
     /* 1786066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1786079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786100 */     // GIR_Coverage, 12042,
     /* 1786100 */     GIR_EraseRootFromParent_Done,
     /* 1786101 */   // Label 24289: @1786101
     /* 1786101 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1786187), // Rule ID 12043 //
     /* 1786106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786152 */     // MIs[0] policy
     /* 1786152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786162 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1786165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786186 */     // GIR_Coverage, 12043,
     /* 1786186 */     GIR_EraseRootFromParent_Done,
     /* 1786187 */   // Label 24290: @1786187
     /* 1786187 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1786273), // Rule ID 12046 //
     /* 1786192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786238 */     // MIs[0] policy
     /* 1786238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786248 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1786251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786272 */     // GIR_Coverage, 12046,
     /* 1786272 */     GIR_EraseRootFromParent_Done,
     /* 1786273 */   // Label 24291: @1786273
     /* 1786273 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1786359), // Rule ID 12047 //
     /* 1786278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786324 */     // MIs[0] policy
     /* 1786324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1786337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786358 */     // GIR_Coverage, 12047,
     /* 1786358 */     GIR_EraseRootFromParent_Done,
     /* 1786359 */   // Label 24292: @1786359
     /* 1786359 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1786445), // Rule ID 12050 //
     /* 1786364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786410 */     // MIs[0] policy
     /* 1786410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786444 */     // GIR_Coverage, 12050,
     /* 1786444 */     GIR_EraseRootFromParent_Done,
     /* 1786445 */   // Label 24293: @1786445
     /* 1786445 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1786531), // Rule ID 12051 //
     /* 1786450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786496 */     // MIs[0] policy
     /* 1786496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786530 */     // GIR_Coverage, 12051,
     /* 1786530 */     GIR_EraseRootFromParent_Done,
     /* 1786531 */   // Label 24294: @1786531
     /* 1786531 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1786617), // Rule ID 12054 //
     /* 1786536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786582 */     // MIs[0] policy
     /* 1786582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786616 */     // GIR_Coverage, 12054,
     /* 1786616 */     GIR_EraseRootFromParent_Done,
     /* 1786617 */   // Label 24295: @1786617
     /* 1786617 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1786703), // Rule ID 12055 //
     /* 1786622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786668 */     // MIs[0] policy
     /* 1786668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786702 */     // GIR_Coverage, 12055,
     /* 1786702 */     GIR_EraseRootFromParent_Done,
     /* 1786703 */   // Label 24296: @1786703
     /* 1786703 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1786789), // Rule ID 12058 //
     /* 1786708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786754 */     // MIs[0] policy
     /* 1786754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786788 */     // GIR_Coverage, 12058,
     /* 1786788 */     GIR_EraseRootFromParent_Done,
     /* 1786789 */   // Label 24297: @1786789
     /* 1786789 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1786875), // Rule ID 12059 //
     /* 1786794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786840 */     // MIs[0] policy
     /* 1786840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786874 */     // GIR_Coverage, 12059,
     /* 1786874 */     GIR_EraseRootFromParent_Done,
     /* 1786875 */   // Label 24298: @1786875
     /* 1786875 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1786961), // Rule ID 12062 //
     /* 1786880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786926 */     // MIs[0] policy
     /* 1786926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786960 */     // GIR_Coverage, 12062,
     /* 1786960 */     GIR_EraseRootFromParent_Done,
     /* 1786961 */   // Label 24299: @1786961
     /* 1786961 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1787047), // Rule ID 12063 //
     /* 1786966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787012 */     // MIs[0] policy
     /* 1787012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1787025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787046 */     // GIR_Coverage, 12063,
     /* 1787046 */     GIR_EraseRootFromParent_Done,
     /* 1787047 */   // Label 24300: @1787047
     /* 1787047 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1787133), // Rule ID 12066 //
     /* 1787052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787098 */     // MIs[0] policy
     /* 1787098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787108 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1787111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787132 */     // GIR_Coverage, 12066,
     /* 1787132 */     GIR_EraseRootFromParent_Done,
     /* 1787133 */   // Label 24301: @1787133
     /* 1787133 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1787219), // Rule ID 12067 //
     /* 1787138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787184 */     // MIs[0] policy
     /* 1787184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1787197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787218 */     // GIR_Coverage, 12067,
     /* 1787218 */     GIR_EraseRootFromParent_Done,
     /* 1787219 */   // Label 24302: @1787219
     /* 1787219 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1787305), // Rule ID 12070 //
     /* 1787224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787270 */     // MIs[0] policy
     /* 1787270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787280 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1787283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787304 */     // GIR_Coverage, 12070,
     /* 1787304 */     GIR_EraseRootFromParent_Done,
     /* 1787305 */   // Label 24303: @1787305
     /* 1787305 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1787391), // Rule ID 12071 //
     /* 1787310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787356 */     // MIs[0] policy
     /* 1787356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787366 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1787369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787390 */     // GIR_Coverage, 12071,
     /* 1787390 */     GIR_EraseRootFromParent_Done,
     /* 1787391 */   // Label 24304: @1787391
     /* 1787391 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1787477), // Rule ID 12074 //
     /* 1787396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787442 */     // MIs[0] policy
     /* 1787442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787476 */     // GIR_Coverage, 12074,
     /* 1787476 */     GIR_EraseRootFromParent_Done,
     /* 1787477 */   // Label 24305: @1787477
     /* 1787477 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1787563), // Rule ID 12075 //
     /* 1787482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787528 */     // MIs[0] policy
     /* 1787528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787562 */     // GIR_Coverage, 12075,
     /* 1787562 */     GIR_EraseRootFromParent_Done,
     /* 1787563 */   // Label 24306: @1787563
     /* 1787563 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1787649), // Rule ID 12078 //
     /* 1787568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787614 */     // MIs[0] policy
     /* 1787614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787648 */     // GIR_Coverage, 12078,
     /* 1787648 */     GIR_EraseRootFromParent_Done,
     /* 1787649 */   // Label 24307: @1787649
     /* 1787649 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1787735), // Rule ID 12079 //
     /* 1787654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787700 */     // MIs[0] policy
     /* 1787700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787734 */     // GIR_Coverage, 12079,
     /* 1787734 */     GIR_EraseRootFromParent_Done,
     /* 1787735 */   // Label 24308: @1787735
     /* 1787735 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1787821), // Rule ID 12082 //
     /* 1787740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787786 */     // MIs[0] policy
     /* 1787786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787820 */     // GIR_Coverage, 12082,
     /* 1787820 */     GIR_EraseRootFromParent_Done,
     /* 1787821 */   // Label 24309: @1787821
     /* 1787821 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1787907), // Rule ID 12083 //
     /* 1787826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787872 */     // MIs[0] policy
     /* 1787872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787882 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787906 */     // GIR_Coverage, 12083,
     /* 1787906 */     GIR_EraseRootFromParent_Done,
     /* 1787907 */   // Label 24310: @1787907
     /* 1787907 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1787993), // Rule ID 12086 //
     /* 1787912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787958 */     // MIs[0] policy
     /* 1787958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787992 */     // GIR_Coverage, 12086,
     /* 1787992 */     GIR_EraseRootFromParent_Done,
     /* 1787993 */   // Label 24311: @1787993
     /* 1787993 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1788079), // Rule ID 12087 //
     /* 1787998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1788009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1788012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1788015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1788018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788044 */     // MIs[0] policy
     /* 1788044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1788057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788078 */     // GIR_Coverage, 12087,
     /* 1788078 */     GIR_EraseRootFromParent_Done,
     /* 1788079 */   // Label 24312: @1788079
     /* 1788079 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1788165), // Rule ID 12090 //
     /* 1788084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788130 */     // MIs[0] policy
     /* 1788130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1788143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788164 */     // GIR_Coverage, 12090,
     /* 1788164 */     GIR_EraseRootFromParent_Done,
     /* 1788165 */   // Label 24313: @1788165
     /* 1788165 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1788251), // Rule ID 12091 //
     /* 1788170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788216 */     // MIs[0] policy
     /* 1788216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1788229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788250 */     // GIR_Coverage, 12091,
     /* 1788250 */     GIR_EraseRootFromParent_Done,
     /* 1788251 */   // Label 24314: @1788251
     /* 1788251 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1788337), // Rule ID 12094 //
     /* 1788256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788302 */     // MIs[0] policy
     /* 1788302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1788315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788336 */     // GIR_Coverage, 12094,
     /* 1788336 */     GIR_EraseRootFromParent_Done,
     /* 1788337 */   // Label 24315: @1788337
     /* 1788337 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1788423), // Rule ID 12095 //
     /* 1788342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788388 */     // MIs[0] policy
     /* 1788388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1788401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788422 */     // GIR_Coverage, 12095,
     /* 1788422 */     GIR_EraseRootFromParent_Done,
     /* 1788423 */   // Label 24316: @1788423
     /* 1788423 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1788509), // Rule ID 12098 //
     /* 1788428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788474 */     // MIs[0] policy
     /* 1788474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788508 */     // GIR_Coverage, 12098,
     /* 1788508 */     GIR_EraseRootFromParent_Done,
     /* 1788509 */   // Label 24317: @1788509
     /* 1788509 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1788595), // Rule ID 12099 //
     /* 1788514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788560 */     // MIs[0] policy
     /* 1788560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788594 */     // GIR_Coverage, 12099,
     /* 1788594 */     GIR_EraseRootFromParent_Done,
     /* 1788595 */   // Label 24318: @1788595
     /* 1788595 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1788681), // Rule ID 12102 //
     /* 1788600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788646 */     // MIs[0] policy
     /* 1788646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788680 */     // GIR_Coverage, 12102,
     /* 1788680 */     GIR_EraseRootFromParent_Done,
     /* 1788681 */   // Label 24319: @1788681
     /* 1788681 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1788767), // Rule ID 12103 //
     /* 1788686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788732 */     // MIs[0] policy
     /* 1788732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788766 */     // GIR_Coverage, 12103,
     /* 1788766 */     GIR_EraseRootFromParent_Done,
     /* 1788767 */   // Label 24320: @1788767
     /* 1788767 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1788853), // Rule ID 12106 //
     /* 1788772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788818 */     // MIs[0] policy
     /* 1788818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788828 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788852 */     // GIR_Coverage, 12106,
     /* 1788852 */     GIR_EraseRootFromParent_Done,
     /* 1788853 */   // Label 24321: @1788853
     /* 1788853 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1788939), // Rule ID 12107 //
     /* 1788858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788904 */     // MIs[0] policy
     /* 1788904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788938 */     // GIR_Coverage, 12107,
     /* 1788938 */     GIR_EraseRootFromParent_Done,
     /* 1788939 */   // Label 24322: @1788939
     /* 1788939 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1789025), // Rule ID 12110 //
     /* 1788944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788990 */     // MIs[0] policy
     /* 1788990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789000 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1789003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789024 */     // GIR_Coverage, 12110,
     /* 1789024 */     GIR_EraseRootFromParent_Done,
     /* 1789025 */   // Label 24323: @1789025
     /* 1789025 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1789111), // Rule ID 12111 //
     /* 1789030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1789041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1789044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1789047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789076 */     // MIs[0] policy
     /* 1789076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789086 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1789089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789110 */     // GIR_Coverage, 12111,
     /* 1789110 */     GIR_EraseRootFromParent_Done,
     /* 1789111 */   // Label 24324: @1789111
     /* 1789111 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1789197), // Rule ID 12114 //
     /* 1789116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789162 */     // MIs[0] policy
     /* 1789162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789172 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1789175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789196 */     // GIR_Coverage, 12114,
     /* 1789196 */     GIR_EraseRootFromParent_Done,
     /* 1789197 */   // Label 24325: @1789197
     /* 1789197 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1789283), // Rule ID 12115 //
     /* 1789202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789248 */     // MIs[0] policy
     /* 1789248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789258 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1789261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789282 */     // GIR_Coverage, 12115,
     /* 1789282 */     GIR_EraseRootFromParent_Done,
     /* 1789283 */   // Label 24326: @1789283
     /* 1789283 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1789369), // Rule ID 12118 //
     /* 1789288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789334 */     // MIs[0] policy
     /* 1789334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1789347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789368 */     // GIR_Coverage, 12118,
     /* 1789368 */     GIR_EraseRootFromParent_Done,
     /* 1789369 */   // Label 24327: @1789369
     /* 1789369 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1789455), // Rule ID 12119 //
     /* 1789374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789420 */     // MIs[0] policy
     /* 1789420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1789433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789454 */     // GIR_Coverage, 12119,
     /* 1789454 */     GIR_EraseRootFromParent_Done,
     /* 1789455 */   // Label 24328: @1789455
     /* 1789455 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1789541), // Rule ID 12122 //
     /* 1789460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789506 */     // MIs[0] policy
     /* 1789506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789540 */     // GIR_Coverage, 12122,
     /* 1789540 */     GIR_EraseRootFromParent_Done,
     /* 1789541 */   // Label 24329: @1789541
     /* 1789541 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1789627), // Rule ID 12123 //
     /* 1789546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789592 */     // MIs[0] policy
     /* 1789592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789626 */     // GIR_Coverage, 12123,
     /* 1789626 */     GIR_EraseRootFromParent_Done,
     /* 1789627 */   // Label 24330: @1789627
     /* 1789627 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1789713), // Rule ID 12126 //
     /* 1789632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789678 */     // MIs[0] policy
     /* 1789678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789712 */     // GIR_Coverage, 12126,
     /* 1789712 */     GIR_EraseRootFromParent_Done,
     /* 1789713 */   // Label 24331: @1789713
     /* 1789713 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1789799), // Rule ID 12127 //
     /* 1789718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789764 */     // MIs[0] policy
     /* 1789764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789798 */     // GIR_Coverage, 12127,
     /* 1789798 */     GIR_EraseRootFromParent_Done,
     /* 1789799 */   // Label 24332: @1789799
     /* 1789799 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1789885), // Rule ID 12130 //
     /* 1789804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789850 */     // MIs[0] policy
     /* 1789850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789884 */     // GIR_Coverage, 12130,
     /* 1789884 */     GIR_EraseRootFromParent_Done,
     /* 1789885 */   // Label 24333: @1789885
     /* 1789885 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1789971), // Rule ID 12131 //
     /* 1789890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789936 */     // MIs[0] policy
     /* 1789936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789970 */     // GIR_Coverage, 12131,
     /* 1789970 */     GIR_EraseRootFromParent_Done,
     /* 1789971 */   // Label 24334: @1789971
     /* 1789971 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1790057), // Rule ID 12134 //
     /* 1789976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790022 */     // MIs[0] policy
     /* 1790022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1790035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790056 */     // GIR_Coverage, 12134,
     /* 1790056 */     GIR_EraseRootFromParent_Done,
     /* 1790057 */   // Label 24335: @1790057
     /* 1790057 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1790143), // Rule ID 12135 //
     /* 1790062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1790073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1790076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1790079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790108 */     // MIs[0] policy
     /* 1790108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11572:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1790121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790142 */     // GIR_Coverage, 12135,
     /* 1790142 */     GIR_EraseRootFromParent_Done,
     /* 1790143 */   // Label 24336: @1790143
     /* 1790143 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1790229), // Rule ID 12138 //
     /* 1790148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790194 */     // MIs[0] policy
     /* 1790194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1790207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790228 */     // GIR_Coverage, 12138,
     /* 1790228 */     GIR_EraseRootFromParent_Done,
     /* 1790229 */   // Label 24337: @1790229
     /* 1790229 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1790315), // Rule ID 12139 //
     /* 1790234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790280 */     // MIs[0] policy
     /* 1790280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1790293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790314 */     // GIR_Coverage, 12139,
     /* 1790314 */     GIR_EraseRootFromParent_Done,
     /* 1790315 */   // Label 24338: @1790315
     /* 1790315 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1790401), // Rule ID 12142 //
     /* 1790320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790366 */     // MIs[0] policy
     /* 1790366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1790379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790400 */     // GIR_Coverage, 12142,
     /* 1790400 */     GIR_EraseRootFromParent_Done,
     /* 1790401 */   // Label 24339: @1790401
     /* 1790401 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1790487), // Rule ID 12143 //
     /* 1790406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790452 */     // MIs[0] policy
     /* 1790452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1790465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790486 */     // GIR_Coverage, 12143,
     /* 1790486 */     GIR_EraseRootFromParent_Done,
     /* 1790487 */   // Label 24340: @1790487
     /* 1790487 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1790573), // Rule ID 12146 //
     /* 1790492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790538 */     // MIs[0] policy
     /* 1790538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790548 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790572 */     // GIR_Coverage, 12146,
     /* 1790572 */     GIR_EraseRootFromParent_Done,
     /* 1790573 */   // Label 24341: @1790573
     /* 1790573 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1790659), // Rule ID 12147 //
     /* 1790578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790624 */     // MIs[0] policy
     /* 1790624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790658 */     // GIR_Coverage, 12147,
     /* 1790658 */     GIR_EraseRootFromParent_Done,
     /* 1790659 */   // Label 24342: @1790659
     /* 1790659 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1790745), // Rule ID 12150 //
     /* 1790664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790710 */     // MIs[0] policy
     /* 1790710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790744 */     // GIR_Coverage, 12150,
     /* 1790744 */     GIR_EraseRootFromParent_Done,
     /* 1790745 */   // Label 24343: @1790745
     /* 1790745 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1790831), // Rule ID 12151 //
     /* 1790750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790796 */     // MIs[0] policy
     /* 1790796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790806 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790830 */     // GIR_Coverage, 12151,
     /* 1790830 */     GIR_EraseRootFromParent_Done,
     /* 1790831 */   // Label 24344: @1790831
     /* 1790831 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1790917), // Rule ID 12154 //
     /* 1790836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790882 */     // MIs[0] policy
     /* 1790882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790916 */     // GIR_Coverage, 12154,
     /* 1790916 */     GIR_EraseRootFromParent_Done,
     /* 1790917 */   // Label 24345: @1790917
     /* 1790917 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1791003), // Rule ID 12155 //
     /* 1790922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790968 */     // MIs[0] policy
     /* 1790968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790978 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791002 */     // GIR_Coverage, 12155,
     /* 1791002 */     GIR_EraseRootFromParent_Done,
     /* 1791003 */   // Label 24346: @1791003
     /* 1791003 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1791089), // Rule ID 12158 //
     /* 1791008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791054 */     // MIs[0] policy
     /* 1791054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791064 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1791067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791088 */     // GIR_Coverage, 12158,
     /* 1791088 */     GIR_EraseRootFromParent_Done,
     /* 1791089 */   // Label 24347: @1791089
     /* 1791089 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1791175), // Rule ID 12159 //
     /* 1791094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791140 */     // MIs[0] policy
     /* 1791140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1791153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791174 */     // GIR_Coverage, 12159,
     /* 1791174 */     GIR_EraseRootFromParent_Done,
     /* 1791175 */   // Label 24348: @1791175
     /* 1791175 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1791261), // Rule ID 12162 //
     /* 1791180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791226 */     // MIs[0] policy
     /* 1791226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1791239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791260 */     // GIR_Coverage, 12162,
     /* 1791260 */     GIR_EraseRootFromParent_Done,
     /* 1791261 */   // Label 24349: @1791261
     /* 1791261 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1791347), // Rule ID 12163 //
     /* 1791266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791312 */     // MIs[0] policy
     /* 1791312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1791325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791346 */     // GIR_Coverage, 12163,
     /* 1791346 */     GIR_EraseRootFromParent_Done,
     /* 1791347 */   // Label 24350: @1791347
     /* 1791347 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1791433), // Rule ID 12166 //
     /* 1791352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791398 */     // MIs[0] policy
     /* 1791398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791408 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791432 */     // GIR_Coverage, 12166,
     /* 1791432 */     GIR_EraseRootFromParent_Done,
     /* 1791433 */   // Label 24351: @1791433
     /* 1791433 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1791519), // Rule ID 12167 //
     /* 1791438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791484 */     // MIs[0] policy
     /* 1791484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791494 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791518 */     // GIR_Coverage, 12167,
     /* 1791518 */     GIR_EraseRootFromParent_Done,
     /* 1791519 */   // Label 24352: @1791519
     /* 1791519 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1791605), // Rule ID 12170 //
     /* 1791524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791570 */     // MIs[0] policy
     /* 1791570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791580 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791604 */     // GIR_Coverage, 12170,
     /* 1791604 */     GIR_EraseRootFromParent_Done,
     /* 1791605 */   // Label 24353: @1791605
     /* 1791605 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1791691), // Rule ID 12171 //
     /* 1791610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791656 */     // MIs[0] policy
     /* 1791656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791690 */     // GIR_Coverage, 12171,
     /* 1791690 */     GIR_EraseRootFromParent_Done,
     /* 1791691 */   // Label 24354: @1791691
     /* 1791691 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1791777), // Rule ID 12174 //
     /* 1791696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791742 */     // MIs[0] policy
     /* 1791742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791776 */     // GIR_Coverage, 12174,
     /* 1791776 */     GIR_EraseRootFromParent_Done,
     /* 1791777 */   // Label 24355: @1791777
     /* 1791777 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1791863), // Rule ID 12175 //
     /* 1791782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791828 */     // MIs[0] policy
     /* 1791828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791862 */     // GIR_Coverage, 12175,
     /* 1791862 */     GIR_EraseRootFromParent_Done,
     /* 1791863 */   // Label 24356: @1791863
     /* 1791863 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1791949), // Rule ID 12178 //
     /* 1791868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791914 */     // MIs[0] policy
     /* 1791914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791948 */     // GIR_Coverage, 12178,
     /* 1791948 */     GIR_EraseRootFromParent_Done,
     /* 1791949 */   // Label 24357: @1791949
     /* 1791949 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1792035), // Rule ID 12179 //
     /* 1791954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792000 */     // MIs[0] policy
     /* 1792000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1792013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792034 */     // GIR_Coverage, 12179,
     /* 1792034 */     GIR_EraseRootFromParent_Done,
     /* 1792035 */   // Label 24358: @1792035
     /* 1792035 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1792121), // Rule ID 12182 //
     /* 1792040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792086 */     // MIs[0] policy
     /* 1792086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1792099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792120 */     // GIR_Coverage, 12182,
     /* 1792120 */     GIR_EraseRootFromParent_Done,
     /* 1792121 */   // Label 24359: @1792121
     /* 1792121 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1792207), // Rule ID 12183 //
     /* 1792126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792172 */     // MIs[0] policy
     /* 1792172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1792185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792206 */     // GIR_Coverage, 12183,
     /* 1792206 */     GIR_EraseRootFromParent_Done,
     /* 1792207 */   // Label 24360: @1792207
     /* 1792207 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1792293), // Rule ID 12186 //
     /* 1792212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792258 */     // MIs[0] policy
     /* 1792258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1792271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792292 */     // GIR_Coverage, 12186,
     /* 1792292 */     GIR_EraseRootFromParent_Done,
     /* 1792293 */   // Label 24361: @1792293
     /* 1792293 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1792379), // Rule ID 12187 //
     /* 1792298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792344 */     // MIs[0] policy
     /* 1792344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1792357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792378 */     // GIR_Coverage, 12187,
     /* 1792378 */     GIR_EraseRootFromParent_Done,
     /* 1792379 */   // Label 24362: @1792379
     /* 1792379 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1792465), // Rule ID 12190 //
     /* 1792384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792430 */     // MIs[0] policy
     /* 1792430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792464 */     // GIR_Coverage, 12190,
     /* 1792464 */     GIR_EraseRootFromParent_Done,
     /* 1792465 */   // Label 24363: @1792465
     /* 1792465 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1792551), // Rule ID 12191 //
     /* 1792470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792516 */     // MIs[0] policy
     /* 1792516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792550 */     // GIR_Coverage, 12191,
     /* 1792550 */     GIR_EraseRootFromParent_Done,
     /* 1792551 */   // Label 24364: @1792551
     /* 1792551 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1792637), // Rule ID 12194 //
     /* 1792556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792602 */     // MIs[0] policy
     /* 1792602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792636 */     // GIR_Coverage, 12194,
     /* 1792636 */     GIR_EraseRootFromParent_Done,
     /* 1792637 */   // Label 24365: @1792637
     /* 1792637 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1792723), // Rule ID 12195 //
     /* 1792642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792688 */     // MIs[0] policy
     /* 1792688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792698 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792722 */     // GIR_Coverage, 12195,
     /* 1792722 */     GIR_EraseRootFromParent_Done,
     /* 1792723 */   // Label 24366: @1792723
     /* 1792723 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1792809), // Rule ID 12198 //
     /* 1792728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792774 */     // MIs[0] policy
     /* 1792774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792808 */     // GIR_Coverage, 12198,
     /* 1792808 */     GIR_EraseRootFromParent_Done,
     /* 1792809 */   // Label 24367: @1792809
     /* 1792809 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1792895), // Rule ID 12199 //
     /* 1792814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792860 */     // MIs[0] policy
     /* 1792860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792870 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792894 */     // GIR_Coverage, 12199,
     /* 1792894 */     GIR_EraseRootFromParent_Done,
     /* 1792895 */   // Label 24368: @1792895
     /* 1792895 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1792981), // Rule ID 12202 //
     /* 1792900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792946 */     // MIs[0] policy
     /* 1792946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792956 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792980 */     // GIR_Coverage, 12202,
     /* 1792980 */     GIR_EraseRootFromParent_Done,
     /* 1792981 */   // Label 24369: @1792981
     /* 1792981 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1793067), // Rule ID 12203 //
     /* 1792986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1793000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1793003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1793006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793032 */     // MIs[0] policy
     /* 1793032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793042 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1793045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793066 */     // GIR_Coverage, 12203,
     /* 1793066 */     GIR_EraseRootFromParent_Done,
     /* 1793067 */   // Label 24370: @1793067
     /* 1793067 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1793153), // Rule ID 12206 //
     /* 1793072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1793083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1793086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793118 */     // MIs[0] policy
     /* 1793118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1793131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793152 */     // GIR_Coverage, 12206,
     /* 1793152 */     GIR_EraseRootFromParent_Done,
     /* 1793153 */   // Label 24371: @1793153
     /* 1793153 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1793239), // Rule ID 12207 //
     /* 1793158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1793169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1793172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793204 */     // MIs[0] policy
     /* 1793204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793214 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1793217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793238 */     // GIR_Coverage, 12207,
     /* 1793238 */     GIR_EraseRootFromParent_Done,
     /* 1793239 */   // Label 24372: @1793239
     /* 1793239 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1793325), // Rule ID 12210 //
     /* 1793244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1793261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1793264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793290 */     // MIs[0] policy
     /* 1793290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1793303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793324 */     // GIR_Coverage, 12210,
     /* 1793324 */     GIR_EraseRootFromParent_Done,
     /* 1793325 */   // Label 24373: @1793325
     /* 1793325 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1793411), // Rule ID 12211 //
     /* 1793330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1793347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1793350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793376 */     // MIs[0] policy
     /* 1793376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1793389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793410 */     // GIR_Coverage, 12211,
     /* 1793410 */     GIR_EraseRootFromParent_Done,
     /* 1793411 */   // Label 24374: @1793411
     /* 1793411 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1793497), // Rule ID 12214 //
     /* 1793416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793462 */     // MIs[0] policy
     /* 1793462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793496 */     // GIR_Coverage, 12214,
     /* 1793496 */     GIR_EraseRootFromParent_Done,
     /* 1793497 */   // Label 24375: @1793497
     /* 1793497 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1793583), // Rule ID 12215 //
     /* 1793502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793548 */     // MIs[0] policy
     /* 1793548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793582 */     // GIR_Coverage, 12215,
     /* 1793582 */     GIR_EraseRootFromParent_Done,
     /* 1793583 */   // Label 24376: @1793583
     /* 1793583 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1793669), // Rule ID 12218 //
     /* 1793588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793634 */     // MIs[0] policy
     /* 1793634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793668 */     // GIR_Coverage, 12218,
     /* 1793668 */     GIR_EraseRootFromParent_Done,
     /* 1793669 */   // Label 24377: @1793669
     /* 1793669 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1793755), // Rule ID 12219 //
     /* 1793674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793720 */     // MIs[0] policy
     /* 1793720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793754 */     // GIR_Coverage, 12219,
     /* 1793754 */     GIR_EraseRootFromParent_Done,
     /* 1793755 */   // Label 24378: @1793755
     /* 1793755 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1793841), // Rule ID 12222 //
     /* 1793760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793806 */     // MIs[0] policy
     /* 1793806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793840 */     // GIR_Coverage, 12222,
     /* 1793840 */     GIR_EraseRootFromParent_Done,
     /* 1793841 */   // Label 24379: @1793841
     /* 1793841 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1793927), // Rule ID 12223 //
     /* 1793846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793892 */     // MIs[0] policy
     /* 1793892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793926 */     // GIR_Coverage, 12223,
     /* 1793926 */     GIR_EraseRootFromParent_Done,
     /* 1793927 */   // Label 24380: @1793927
     /* 1793927 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1794013), // Rule ID 12226 //
     /* 1793932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793978 */     // MIs[0] policy
     /* 1793978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794012 */     // GIR_Coverage, 12226,
     /* 1794012 */     GIR_EraseRootFromParent_Done,
     /* 1794013 */   // Label 24381: @1794013
     /* 1794013 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1794099), // Rule ID 12227 //
     /* 1794018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1794029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1794032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794064 */     // MIs[0] policy
     /* 1794064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1794077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794098 */     // GIR_Coverage, 12227,
     /* 1794098 */     GIR_EraseRootFromParent_Done,
     /* 1794099 */   // Label 24382: @1794099
     /* 1794099 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1794185), // Rule ID 12230 //
     /* 1794104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1794121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1794124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794150 */     // MIs[0] policy
     /* 1794150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1794163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794184 */     // GIR_Coverage, 12230,
     /* 1794184 */     GIR_EraseRootFromParent_Done,
     /* 1794185 */   // Label 24383: @1794185
     /* 1794185 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1794271), // Rule ID 12231 //
     /* 1794190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1794207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1794210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794236 */     // MIs[0] policy
     /* 1794236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1794249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794270 */     // GIR_Coverage, 12231,
     /* 1794270 */     GIR_EraseRootFromParent_Done,
     /* 1794271 */   // Label 24384: @1794271
     /* 1794271 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1794357), // Rule ID 12234 //
     /* 1794276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1794279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1794287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1794290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1794293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1794296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794322 */     // MIs[0] policy
     /* 1794322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1794335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794356 */     // GIR_Coverage, 12234,
     /* 1794356 */     GIR_EraseRootFromParent_Done,
     /* 1794357 */   // Label 24385: @1794357
     /* 1794357 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1794443), // Rule ID 12235 //
     /* 1794362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1794365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1794373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1794376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1794379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1794382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794408 */     // MIs[0] policy
     /* 1794408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1794421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1794439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794442 */     // GIR_Coverage, 12235,
     /* 1794442 */     GIR_EraseRootFromParent_Done,
     /* 1794443 */   // Label 24386: @1794443
     /* 1794443 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1794529), // Rule ID 12238 //
     /* 1794448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794494 */     // MIs[0] policy
     /* 1794494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794528 */     // GIR_Coverage, 12238,
     /* 1794528 */     GIR_EraseRootFromParent_Done,
     /* 1794529 */   // Label 24387: @1794529
     /* 1794529 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1794615), // Rule ID 12239 //
     /* 1794534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794580 */     // MIs[0] policy
     /* 1794580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794590 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794614 */     // GIR_Coverage, 12239,
     /* 1794614 */     GIR_EraseRootFromParent_Done,
     /* 1794615 */   // Label 24388: @1794615
     /* 1794615 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1794701), // Rule ID 12242 //
     /* 1794620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794666 */     // MIs[0] policy
     /* 1794666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794700 */     // GIR_Coverage, 12242,
     /* 1794700 */     GIR_EraseRootFromParent_Done,
     /* 1794701 */   // Label 24389: @1794701
     /* 1794701 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1794787), // Rule ID 12243 //
     /* 1794706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794752 */     // MIs[0] policy
     /* 1794752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794762 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794786 */     // GIR_Coverage, 12243,
     /* 1794786 */     GIR_EraseRootFromParent_Done,
     /* 1794787 */   // Label 24390: @1794787
     /* 1794787 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1794873), // Rule ID 12246 //
     /* 1794792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794838 */     // MIs[0] policy
     /* 1794838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794848 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794872 */     // GIR_Coverage, 12246,
     /* 1794872 */     GIR_EraseRootFromParent_Done,
     /* 1794873 */   // Label 24391: @1794873
     /* 1794873 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1794959), // Rule ID 12247 //
     /* 1794878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794924 */     // MIs[0] policy
     /* 1794924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794934 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794958 */     // GIR_Coverage, 12247,
     /* 1794958 */     GIR_EraseRootFromParent_Done,
     /* 1794959 */   // Label 24392: @1794959
     /* 1794959 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1795045), // Rule ID 12250 //
     /* 1794964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795010 */     // MIs[0] policy
     /* 1795010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1795023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795044 */     // GIR_Coverage, 12250,
     /* 1795044 */     GIR_EraseRootFromParent_Done,
     /* 1795045 */   // Label 24393: @1795045
     /* 1795045 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1795131), // Rule ID 12251 //
     /* 1795050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1795061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1795064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1795067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1795070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795096 */     // MIs[0] policy
     /* 1795096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795106 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1795109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795130 */     // GIR_Coverage, 12251,
     /* 1795130 */     GIR_EraseRootFromParent_Done,
     /* 1795131 */   // Label 24394: @1795131
     /* 1795131 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1795217), // Rule ID 12254 //
     /* 1795136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795182 */     // MIs[0] policy
     /* 1795182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1795195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795216 */     // GIR_Coverage, 12254,
     /* 1795216 */     GIR_EraseRootFromParent_Done,
     /* 1795217 */   // Label 24395: @1795217
     /* 1795217 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1795303), // Rule ID 12255 //
     /* 1795222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1795233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1795236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795268 */     // MIs[0] policy
     /* 1795268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795278 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1795281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795302 */     // GIR_Coverage, 12255,
     /* 1795302 */     GIR_EraseRootFromParent_Done,
     /* 1795303 */   // Label 24396: @1795303
     /* 1795303 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1795389), // Rule ID 12258 //
     /* 1795308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795354 */     // MIs[0] policy
     /* 1795354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795364 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1795367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795388 */     // GIR_Coverage, 12258,
     /* 1795388 */     GIR_EraseRootFromParent_Done,
     /* 1795389 */   // Label 24397: @1795389
     /* 1795389 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1795475), // Rule ID 12259 //
     /* 1795394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1795405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1795408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1795411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1795414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795440 */     // MIs[0] policy
     /* 1795440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1795453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795474 */     // GIR_Coverage, 12259,
     /* 1795474 */     GIR_EraseRootFromParent_Done,
     /* 1795475 */   // Label 24398: @1795475
     /* 1795475 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1795561), // Rule ID 12262 //
     /* 1795480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795526 */     // MIs[0] policy
     /* 1795526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795560 */     // GIR_Coverage, 12262,
     /* 1795560 */     GIR_EraseRootFromParent_Done,
     /* 1795561 */   // Label 24399: @1795561
     /* 1795561 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1795647), // Rule ID 12263 //
     /* 1795566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795612 */     // MIs[0] policy
     /* 1795612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795646 */     // GIR_Coverage, 12263,
     /* 1795646 */     GIR_EraseRootFromParent_Done,
     /* 1795647 */   // Label 24400: @1795647
     /* 1795647 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1795733), // Rule ID 12266 //
     /* 1795652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795698 */     // MIs[0] policy
     /* 1795698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795732 */     // GIR_Coverage, 12266,
     /* 1795732 */     GIR_EraseRootFromParent_Done,
     /* 1795733 */   // Label 24401: @1795733
     /* 1795733 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1795819), // Rule ID 12267 //
     /* 1795738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795784 */     // MIs[0] policy
     /* 1795784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795818 */     // GIR_Coverage, 12267,
     /* 1795818 */     GIR_EraseRootFromParent_Done,
     /* 1795819 */   // Label 24402: @1795819
     /* 1795819 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1795905), // Rule ID 12270 //
     /* 1795824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795870 */     // MIs[0] policy
     /* 1795870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795904 */     // GIR_Coverage, 12270,
     /* 1795904 */     GIR_EraseRootFromParent_Done,
     /* 1795905 */   // Label 24403: @1795905
     /* 1795905 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1795991), // Rule ID 12271 //
     /* 1795910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795956 */     // MIs[0] policy
     /* 1795956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795990 */     // GIR_Coverage, 12271,
     /* 1795990 */     GIR_EraseRootFromParent_Done,
     /* 1795991 */   // Label 24404: @1795991
     /* 1795991 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1796077), // Rule ID 12274 //
     /* 1795996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796042 */     // MIs[0] policy
     /* 1796042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796052 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1796055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796076 */     // GIR_Coverage, 12274,
     /* 1796076 */     GIR_EraseRootFromParent_Done,
     /* 1796077 */   // Label 24405: @1796077
     /* 1796077 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1796163), // Rule ID 12275 //
     /* 1796082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1796093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1796096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1796099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1796102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796128 */     // MIs[0] policy
     /* 1796128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1796141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796162 */     // GIR_Coverage, 12275,
     /* 1796162 */     GIR_EraseRootFromParent_Done,
     /* 1796163 */   // Label 24406: @1796163
     /* 1796163 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1796249), // Rule ID 12278 //
     /* 1796168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1796171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796214 */     // MIs[0] policy
     /* 1796214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1796227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796248 */     // GIR_Coverage, 12278,
     /* 1796248 */     GIR_EraseRootFromParent_Done,
     /* 1796249 */   // Label 24407: @1796249
     /* 1796249 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1796335), // Rule ID 12279 //
     /* 1796254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1796265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1796268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1796271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1796274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796300 */     // MIs[0] policy
     /* 1796300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796310 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1796313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796334 */     // GIR_Coverage, 12279,
     /* 1796334 */     GIR_EraseRootFromParent_Done,
     /* 1796335 */   // Label 24408: @1796335
     /* 1796335 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1796421), // Rule ID 12282 //
     /* 1796340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1796343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796386 */     // MIs[0] policy
     /* 1796386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796396 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796420 */     // GIR_Coverage, 12282,
     /* 1796420 */     GIR_EraseRootFromParent_Done,
     /* 1796421 */   // Label 24409: @1796421
     /* 1796421 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1796507), // Rule ID 12283 //
     /* 1796426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1796429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1796437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1796440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1796443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1796446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796472 */     // MIs[0] policy
     /* 1796472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796506 */     // GIR_Coverage, 12283,
     /* 1796506 */     GIR_EraseRootFromParent_Done,
     /* 1796507 */   // Label 24410: @1796507
     /* 1796507 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1796593), // Rule ID 12286 //
     /* 1796512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796558 */     // MIs[0] policy
     /* 1796558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796568 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796592 */     // GIR_Coverage, 12286,
     /* 1796592 */     GIR_EraseRootFromParent_Done,
     /* 1796593 */   // Label 24411: @1796593
     /* 1796593 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1796679), // Rule ID 12287 //
     /* 1796598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796644 */     // MIs[0] policy
     /* 1796644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796678 */     // GIR_Coverage, 12287,
     /* 1796678 */     GIR_EraseRootFromParent_Done,
     /* 1796679 */   // Label 24412: @1796679
     /* 1796679 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1796765), // Rule ID 12290 //
     /* 1796684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796730 */     // MIs[0] policy
     /* 1796730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796740 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796764 */     // GIR_Coverage, 12290,
     /* 1796764 */     GIR_EraseRootFromParent_Done,
     /* 1796765 */   // Label 24413: @1796765
     /* 1796765 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1796851), // Rule ID 12291 //
     /* 1796770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796816 */     // MIs[0] policy
     /* 1796816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796850 */     // GIR_Coverage, 12291,
     /* 1796850 */     GIR_EraseRootFromParent_Done,
     /* 1796851 */   // Label 24414: @1796851
     /* 1796851 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1796937), // Rule ID 12294 //
     /* 1796856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796902 */     // MIs[0] policy
     /* 1796902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796936 */     // GIR_Coverage, 12294,
     /* 1796936 */     GIR_EraseRootFromParent_Done,
     /* 1796937 */   // Label 24415: @1796937
     /* 1796937 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1797023), // Rule ID 12295 //
     /* 1796942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796988 */     // MIs[0] policy
     /* 1796988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1797001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797022 */     // GIR_Coverage, 12295,
     /* 1797022 */     GIR_EraseRootFromParent_Done,
     /* 1797023 */   // Label 24416: @1797023
     /* 1797023 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1797109), // Rule ID 12298 //
     /* 1797028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1797045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797074 */     // MIs[0] policy
     /* 1797074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1797087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797108 */     // GIR_Coverage, 12298,
     /* 1797108 */     GIR_EraseRootFromParent_Done,
     /* 1797109 */   // Label 24417: @1797109
     /* 1797109 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1797195), // Rule ID 12299 //
     /* 1797114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1797131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797160 */     // MIs[0] policy
     /* 1797160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1797173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797194 */     // GIR_Coverage, 12299,
     /* 1797194 */     GIR_EraseRootFromParent_Done,
     /* 1797195 */   // Label 24418: @1797195
     /* 1797195 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1797281), // Rule ID 12302 //
     /* 1797200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797246 */     // MIs[0] policy
     /* 1797246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1797259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797280 */     // GIR_Coverage, 12302,
     /* 1797280 */     GIR_EraseRootFromParent_Done,
     /* 1797281 */   // Label 24419: @1797281
     /* 1797281 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1797367), // Rule ID 12303 //
     /* 1797286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797332 */     // MIs[0] policy
     /* 1797332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1797345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797366 */     // GIR_Coverage, 12303,
     /* 1797366 */     GIR_EraseRootFromParent_Done,
     /* 1797367 */   // Label 24420: @1797367
     /* 1797367 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1797453), // Rule ID 12306 //
     /* 1797372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797418 */     // MIs[0] policy
     /* 1797418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797452 */     // GIR_Coverage, 12306,
     /* 1797452 */     GIR_EraseRootFromParent_Done,
     /* 1797453 */   // Label 24421: @1797453
     /* 1797453 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1797539), // Rule ID 12307 //
     /* 1797458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797504 */     // MIs[0] policy
     /* 1797504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797538 */     // GIR_Coverage, 12307,
     /* 1797538 */     GIR_EraseRootFromParent_Done,
     /* 1797539 */   // Label 24422: @1797539
     /* 1797539 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1797625), // Rule ID 12310 //
     /* 1797544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797590 */     // MIs[0] policy
     /* 1797590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797624 */     // GIR_Coverage, 12310,
     /* 1797624 */     GIR_EraseRootFromParent_Done,
     /* 1797625 */   // Label 24423: @1797625
     /* 1797625 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1797711), // Rule ID 12311 //
     /* 1797630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797676 */     // MIs[0] policy
     /* 1797676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11570:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797710 */     // GIR_Coverage, 12311,
     /* 1797710 */     GIR_EraseRootFromParent_Done,
     /* 1797711 */   // Label 24424: @1797711
     /* 1797711 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1797797), // Rule ID 12314 //
     /* 1797716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797762 */     // MIs[0] policy
     /* 1797762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797796 */     // GIR_Coverage, 12314,
     /* 1797796 */     GIR_EraseRootFromParent_Done,
     /* 1797797 */   // Label 24425: @1797797
     /* 1797797 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1797883), // Rule ID 12315 //
     /* 1797802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797848 */     // MIs[0] policy
     /* 1797848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797882 */     // GIR_Coverage, 12315,
     /* 1797882 */     GIR_EraseRootFromParent_Done,
     /* 1797883 */   // Label 24426: @1797883
     /* 1797883 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1797969), // Rule ID 12318 //
     /* 1797888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797934 */     // MIs[0] policy
     /* 1797934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797968 */     // GIR_Coverage, 12318,
     /* 1797968 */     GIR_EraseRootFromParent_Done,
     /* 1797969 */   // Label 24427: @1797969
     /* 1797969 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1798055), // Rule ID 12319 //
     /* 1797974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798020 */     // MIs[0] policy
     /* 1798020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1798033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798054 */     // GIR_Coverage, 12319,
     /* 1798054 */     GIR_EraseRootFromParent_Done,
     /* 1798055 */   // Label 24428: @1798055
     /* 1798055 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1798141), // Rule ID 12322 //
     /* 1798060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1798063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1798071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1798074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1798077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798106 */     // MIs[0] policy
     /* 1798106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1798119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1798137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798140 */     // GIR_Coverage, 12322,
     /* 1798140 */     GIR_EraseRootFromParent_Done,
     /* 1798141 */   // Label 24429: @1798141
     /* 1798141 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1798227), // Rule ID 12323 //
     /* 1798146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1798149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1798157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1798160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1798163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798192 */     // MIs[0] policy
     /* 1798192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1798205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1798223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798226 */     // GIR_Coverage, 12323,
     /* 1798226 */     GIR_EraseRootFromParent_Done,
     /* 1798227 */   // Label 24430: @1798227
     /* 1798227 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1798313), // Rule ID 12326 //
     /* 1798232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1798243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1798246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798278 */     // MIs[0] policy
     /* 1798278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798288 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1798291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798312 */     // GIR_Coverage, 12326,
     /* 1798312 */     GIR_EraseRootFromParent_Done,
     /* 1798313 */   // Label 24431: @1798313
     /* 1798313 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1798399), // Rule ID 12327 //
     /* 1798318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1798329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1798332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798364 */     // MIs[0] policy
     /* 1798364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1798377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798398 */     // GIR_Coverage, 12327,
     /* 1798398 */     GIR_EraseRootFromParent_Done,
     /* 1798399 */   // Label 24432: @1798399
     /* 1798399 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1798485), // Rule ID 12330 //
     /* 1798404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798450 */     // MIs[0] policy
     /* 1798450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798460 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798484 */     // GIR_Coverage, 12330,
     /* 1798484 */     GIR_EraseRootFromParent_Done,
     /* 1798485 */   // Label 24433: @1798485
     /* 1798485 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1798571), // Rule ID 12331 //
     /* 1798490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798536 */     // MIs[0] policy
     /* 1798536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798570 */     // GIR_Coverage, 12331,
     /* 1798570 */     GIR_EraseRootFromParent_Done,
     /* 1798571 */   // Label 24434: @1798571
     /* 1798571 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1798657), // Rule ID 12334 //
     /* 1798576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798622 */     // MIs[0] policy
     /* 1798622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798632 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798656 */     // GIR_Coverage, 12334,
     /* 1798656 */     GIR_EraseRootFromParent_Done,
     /* 1798657 */   // Label 24435: @1798657
     /* 1798657 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1798743), // Rule ID 12335 //
     /* 1798662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798708 */     // MIs[0] policy
     /* 1798708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798742 */     // GIR_Coverage, 12335,
     /* 1798742 */     GIR_EraseRootFromParent_Done,
     /* 1798743 */   // Label 24436: @1798743
     /* 1798743 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1798829), // Rule ID 12338 //
     /* 1798748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798794 */     // MIs[0] policy
     /* 1798794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798828 */     // GIR_Coverage, 12338,
     /* 1798828 */     GIR_EraseRootFromParent_Done,
     /* 1798829 */   // Label 24437: @1798829
     /* 1798829 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1798915), // Rule ID 12339 //
     /* 1798834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798880 */     // MIs[0] policy
     /* 1798880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798914 */     // GIR_Coverage, 12339,
     /* 1798914 */     GIR_EraseRootFromParent_Done,
     /* 1798915 */   // Label 24438: @1798915
     /* 1798915 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1799001), // Rule ID 12342 //
     /* 1798920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798966 */     // MIs[0] policy
     /* 1798966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799000 */     // GIR_Coverage, 12342,
     /* 1799000 */     GIR_EraseRootFromParent_Done,
     /* 1799001 */   // Label 24439: @1799001
     /* 1799001 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1799087), // Rule ID 12343 //
     /* 1799006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1799017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1799020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1799023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799052 */     // MIs[0] policy
     /* 1799052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1799065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799086 */     // GIR_Coverage, 12343,
     /* 1799086 */     GIR_EraseRootFromParent_Done,
     /* 1799087 */   // Label 24440: @1799087
     /* 1799087 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1799173), // Rule ID 12346 //
     /* 1799092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1799109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799138 */     // MIs[0] policy
     /* 1799138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1799151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799172 */     // GIR_Coverage, 12346,
     /* 1799172 */     GIR_EraseRootFromParent_Done,
     /* 1799173 */   // Label 24441: @1799173
     /* 1799173 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1799259), // Rule ID 12347 //
     /* 1799178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1799195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799224 */     // MIs[0] policy
     /* 1799224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1799237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799258 */     // GIR_Coverage, 12347,
     /* 1799258 */     GIR_EraseRootFromParent_Done,
     /* 1799259 */   // Label 24442: @1799259
     /* 1799259 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1799345), // Rule ID 12350 //
     /* 1799264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799310 */     // MIs[0] policy
     /* 1799310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1799323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799344 */     // GIR_Coverage, 12350,
     /* 1799344 */     GIR_EraseRootFromParent_Done,
     /* 1799345 */   // Label 24443: @1799345
     /* 1799345 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1799431), // Rule ID 12351 //
     /* 1799350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799396 */     // MIs[0] policy
     /* 1799396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1799409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799430 */     // GIR_Coverage, 12351,
     /* 1799430 */     GIR_EraseRootFromParent_Done,
     /* 1799431 */   // Label 24444: @1799431
     /* 1799431 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1799517), // Rule ID 12354 //
     /* 1799436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799482 */     // MIs[0] policy
     /* 1799482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799516 */     // GIR_Coverage, 12354,
     /* 1799516 */     GIR_EraseRootFromParent_Done,
     /* 1799517 */   // Label 24445: @1799517
     /* 1799517 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1799603), // Rule ID 12355 //
     /* 1799522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799568 */     // MIs[0] policy
     /* 1799568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799602 */     // GIR_Coverage, 12355,
     /* 1799602 */     GIR_EraseRootFromParent_Done,
     /* 1799603 */   // Label 24446: @1799603
     /* 1799603 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1799689), // Rule ID 12358 //
     /* 1799608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799654 */     // MIs[0] policy
     /* 1799654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799688 */     // GIR_Coverage, 12358,
     /* 1799688 */     GIR_EraseRootFromParent_Done,
     /* 1799689 */   // Label 24447: @1799689
     /* 1799689 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1799775), // Rule ID 12359 //
     /* 1799694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799740 */     // MIs[0] policy
     /* 1799740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799774 */     // GIR_Coverage, 12359,
     /* 1799774 */     GIR_EraseRootFromParent_Done,
     /* 1799775 */   // Label 24448: @1799775
     /* 1799775 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1799861), // Rule ID 12362 //
     /* 1799780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799826 */     // MIs[0] policy
     /* 1799826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799860 */     // GIR_Coverage, 12362,
     /* 1799860 */     GIR_EraseRootFromParent_Done,
     /* 1799861 */   // Label 24449: @1799861
     /* 1799861 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1799947), // Rule ID 12363 //
     /* 1799866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799912 */     // MIs[0] policy
     /* 1799912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799946 */     // GIR_Coverage, 12363,
     /* 1799946 */     GIR_EraseRootFromParent_Done,
     /* 1799947 */   // Label 24450: @1799947
     /* 1799947 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1800033), // Rule ID 12366 //
     /* 1799952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799998 */     // MIs[0] policy
     /* 1799998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1800011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800032 */     // GIR_Coverage, 12366,
     /* 1800032 */     GIR_EraseRootFromParent_Done,
     /* 1800033 */   // Label 24451: @1800033
     /* 1800033 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1800119), // Rule ID 12367 //
     /* 1800038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1800041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1800049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1800052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1800055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800084 */     // MIs[0] policy
     /* 1800084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1800097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800118 */     // GIR_Coverage, 12367,
     /* 1800118 */     GIR_EraseRootFromParent_Done,
     /* 1800119 */   // Label 24452: @1800119
     /* 1800119 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1800205), // Rule ID 12370 //
     /* 1800124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1800127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1800141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800170 */     // MIs[0] policy
     /* 1800170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1800183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800204 */     // GIR_Coverage, 12370,
     /* 1800204 */     GIR_EraseRootFromParent_Done,
     /* 1800205 */   // Label 24453: @1800205
     /* 1800205 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1800291), // Rule ID 12371 //
     /* 1800210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1800213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1800218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1800227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800256 */     // MIs[0] policy
     /* 1800256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1800269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1800287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800290 */     // GIR_Coverage, 12371,
     /* 1800290 */     GIR_EraseRootFromParent_Done,
     /* 1800291 */   // Label 24454: @1800291
     /* 1800291 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1800377), // Rule ID 12374 //
     /* 1800296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1800316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800342 */     // MIs[0] policy
     /* 1800342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1800355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800376 */     // GIR_Coverage, 12374,
     /* 1800376 */     GIR_EraseRootFromParent_Done,
     /* 1800377 */   // Label 24455: @1800377
     /* 1800377 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1800463), // Rule ID 12375 //
     /* 1800382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1800402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800428 */     // MIs[0] policy
     /* 1800428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1800441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800462 */     // GIR_Coverage, 12375,
     /* 1800462 */     GIR_EraseRootFromParent_Done,
     /* 1800463 */   // Label 24456: @1800463
     /* 1800463 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1800549), // Rule ID 12378 //
     /* 1800468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800514 */     // MIs[0] policy
     /* 1800514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800548 */     // GIR_Coverage, 12378,
     /* 1800548 */     GIR_EraseRootFromParent_Done,
     /* 1800549 */   // Label 24457: @1800549
     /* 1800549 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1800635), // Rule ID 12379 //
     /* 1800554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800600 */     // MIs[0] policy
     /* 1800600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800634 */     // GIR_Coverage, 12379,
     /* 1800634 */     GIR_EraseRootFromParent_Done,
     /* 1800635 */   // Label 24458: @1800635
     /* 1800635 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1800721), // Rule ID 12382 //
     /* 1800640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800686 */     // MIs[0] policy
     /* 1800686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800720 */     // GIR_Coverage, 12382,
     /* 1800720 */     GIR_EraseRootFromParent_Done,
     /* 1800721 */   // Label 24459: @1800721
     /* 1800721 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1800807), // Rule ID 12383 //
     /* 1800726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800772 */     // MIs[0] policy
     /* 1800772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800806 */     // GIR_Coverage, 12383,
     /* 1800806 */     GIR_EraseRootFromParent_Done,
     /* 1800807 */   // Label 24460: @1800807
     /* 1800807 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1800893), // Rule ID 12386 //
     /* 1800812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800858 */     // MIs[0] policy
     /* 1800858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800892 */     // GIR_Coverage, 12386,
     /* 1800892 */     GIR_EraseRootFromParent_Done,
     /* 1800893 */   // Label 24461: @1800893
     /* 1800893 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1800979), // Rule ID 12387 //
     /* 1800898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800944 */     // MIs[0] policy
     /* 1800944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800978 */     // GIR_Coverage, 12387,
     /* 1800978 */     GIR_EraseRootFromParent_Done,
     /* 1800979 */   // Label 24462: @1800979
     /* 1800979 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1801065), // Rule ID 12390 //
     /* 1800984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1801004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801030 */     // MIs[0] policy
     /* 1801030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801064 */     // GIR_Coverage, 12390,
     /* 1801064 */     GIR_EraseRootFromParent_Done,
     /* 1801065 */   // Label 24463: @1801065
     /* 1801065 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1801151), // Rule ID 12391 //
     /* 1801070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1801081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1801084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1801090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801116 */     // MIs[0] policy
     /* 1801116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801150 */     // GIR_Coverage, 12391,
     /* 1801150 */     GIR_EraseRootFromParent_Done,
     /* 1801151 */   // Label 24464: @1801151
     /* 1801151 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1801237), // Rule ID 12394 //
     /* 1801156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1801176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801202 */     // MIs[0] policy
     /* 1801202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801236 */     // GIR_Coverage, 12394,
     /* 1801236 */     GIR_EraseRootFromParent_Done,
     /* 1801237 */   // Label 24465: @1801237
     /* 1801237 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1801323), // Rule ID 12395 //
     /* 1801242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1801262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801288 */     // MIs[0] policy
     /* 1801288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801298 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801322 */     // GIR_Coverage, 12395,
     /* 1801322 */     GIR_EraseRootFromParent_Done,
     /* 1801323 */   // Label 24466: @1801323
     /* 1801323 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1801409), // Rule ID 12398 //
     /* 1801328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1801348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801374 */     // MIs[0] policy
     /* 1801374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801408 */     // GIR_Coverage, 12398,
     /* 1801408 */     GIR_EraseRootFromParent_Done,
     /* 1801409 */   // Label 24467: @1801409
     /* 1801409 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1801495), // Rule ID 12399 //
     /* 1801414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1801434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801460 */     // MIs[0] policy
     /* 1801460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801494 */     // GIR_Coverage, 12399,
     /* 1801494 */     GIR_EraseRootFromParent_Done,
     /* 1801495 */   // Label 24468: @1801495
     /* 1801495 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1801581), // Rule ID 12402 //
     /* 1801500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801546 */     // MIs[0] policy
     /* 1801546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801556 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801580 */     // GIR_Coverage, 12402,
     /* 1801580 */     GIR_EraseRootFromParent_Done,
     /* 1801581 */   // Label 24469: @1801581
     /* 1801581 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1801667), // Rule ID 12403 //
     /* 1801586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801632 */     // MIs[0] policy
     /* 1801632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801666 */     // GIR_Coverage, 12403,
     /* 1801666 */     GIR_EraseRootFromParent_Done,
     /* 1801667 */   // Label 24470: @1801667
     /* 1801667 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1801753), // Rule ID 12406 //
     /* 1801672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801718 */     // MIs[0] policy
     /* 1801718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801752 */     // GIR_Coverage, 12406,
     /* 1801752 */     GIR_EraseRootFromParent_Done,
     /* 1801753 */   // Label 24471: @1801753
     /* 1801753 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1801839), // Rule ID 12407 //
     /* 1801758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801804 */     // MIs[0] policy
     /* 1801804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801838 */     // GIR_Coverage, 12407,
     /* 1801838 */     GIR_EraseRootFromParent_Done,
     /* 1801839 */   // Label 24472: @1801839
     /* 1801839 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1801925), // Rule ID 12410 //
     /* 1801844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801890 */     // MIs[0] policy
     /* 1801890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801924 */     // GIR_Coverage, 12410,
     /* 1801924 */     GIR_EraseRootFromParent_Done,
     /* 1801925 */   // Label 24473: @1801925
     /* 1801925 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1802011), // Rule ID 12411 //
     /* 1801930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801976 */     // MIs[0] policy
     /* 1801976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802010 */     // GIR_Coverage, 12411,
     /* 1802010 */     GIR_EraseRootFromParent_Done,
     /* 1802011 */   // Label 24474: @1802011
     /* 1802011 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1802097), // Rule ID 12414 //
     /* 1802016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1802036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802062 */     // MIs[0] policy
     /* 1802062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802072 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802096 */     // GIR_Coverage, 12414,
     /* 1802096 */     GIR_EraseRootFromParent_Done,
     /* 1802097 */   // Label 24475: @1802097
     /* 1802097 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1802183), // Rule ID 12415 //
     /* 1802102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1802122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802148 */     // MIs[0] policy
     /* 1802148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802182 */     // GIR_Coverage, 12415,
     /* 1802182 */     GIR_EraseRootFromParent_Done,
     /* 1802183 */   // Label 24476: @1802183
     /* 1802183 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1802269), // Rule ID 12418 //
     /* 1802188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1802208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802234 */     // MIs[0] policy
     /* 1802234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1802247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802268 */     // GIR_Coverage, 12418,
     /* 1802268 */     GIR_EraseRootFromParent_Done,
     /* 1802269 */   // Label 24477: @1802269
     /* 1802269 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1802355), // Rule ID 12419 //
     /* 1802274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1802294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802320 */     // MIs[0] policy
     /* 1802320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1802333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802354 */     // GIR_Coverage, 12419,
     /* 1802354 */     GIR_EraseRootFromParent_Done,
     /* 1802355 */   // Label 24478: @1802355
     /* 1802355 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1802441), // Rule ID 12422 //
     /* 1802360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802406 */     // MIs[0] policy
     /* 1802406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802440 */     // GIR_Coverage, 12422,
     /* 1802440 */     GIR_EraseRootFromParent_Done,
     /* 1802441 */   // Label 24479: @1802441
     /* 1802441 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1802527), // Rule ID 12423 //
     /* 1802446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802492 */     // MIs[0] policy
     /* 1802492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802526 */     // GIR_Coverage, 12423,
     /* 1802526 */     GIR_EraseRootFromParent_Done,
     /* 1802527 */   // Label 24480: @1802527
     /* 1802527 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1802613), // Rule ID 12426 //
     /* 1802532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802578 */     // MIs[0] policy
     /* 1802578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802588 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802612 */     // GIR_Coverage, 12426,
     /* 1802612 */     GIR_EraseRootFromParent_Done,
     /* 1802613 */   // Label 24481: @1802613
     /* 1802613 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1802699), // Rule ID 12427 //
     /* 1802618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802664 */     // MIs[0] policy
     /* 1802664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802698 */     // GIR_Coverage, 12427,
     /* 1802698 */     GIR_EraseRootFromParent_Done,
     /* 1802699 */   // Label 24482: @1802699
     /* 1802699 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1802785), // Rule ID 12430 //
     /* 1802704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802750 */     // MIs[0] policy
     /* 1802750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802784 */     // GIR_Coverage, 12430,
     /* 1802784 */     GIR_EraseRootFromParent_Done,
     /* 1802785 */   // Label 24483: @1802785
     /* 1802785 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1802871), // Rule ID 12431 //
     /* 1802790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802836 */     // MIs[0] policy
     /* 1802836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802870 */     // GIR_Coverage, 12431,
     /* 1802870 */     GIR_EraseRootFromParent_Done,
     /* 1802871 */   // Label 24484: @1802871
     /* 1802871 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1802957), // Rule ID 12434 //
     /* 1802876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802922 */     // MIs[0] policy
     /* 1802922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802956 */     // GIR_Coverage, 12434,
     /* 1802956 */     GIR_EraseRootFromParent_Done,
     /* 1802957 */   // Label 24485: @1802957
     /* 1802957 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1803043), // Rule ID 12435 //
     /* 1802962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803008 */     // MIs[0] policy
     /* 1803008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1803021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803042 */     // GIR_Coverage, 12435,
     /* 1803042 */     GIR_EraseRootFromParent_Done,
     /* 1803043 */   // Label 24486: @1803043
     /* 1803043 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1803129), // Rule ID 12438 //
     /* 1803048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803094 */     // MIs[0] policy
     /* 1803094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803128 */     // GIR_Coverage, 12438,
     /* 1803128 */     GIR_EraseRootFromParent_Done,
     /* 1803129 */   // Label 24487: @1803129
     /* 1803129 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1803215), // Rule ID 12439 //
     /* 1803134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803180 */     // MIs[0] policy
     /* 1803180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803214 */     // GIR_Coverage, 12439,
     /* 1803214 */     GIR_EraseRootFromParent_Done,
     /* 1803215 */   // Label 24488: @1803215
     /* 1803215 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1803301), // Rule ID 12442 //
     /* 1803220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803266 */     // MIs[0] policy
     /* 1803266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803300 */     // GIR_Coverage, 12442,
     /* 1803300 */     GIR_EraseRootFromParent_Done,
     /* 1803301 */   // Label 24489: @1803301
     /* 1803301 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1803387), // Rule ID 12443 //
     /* 1803306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803352 */     // MIs[0] policy
     /* 1803352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11712:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803386 */     // GIR_Coverage, 12443,
     /* 1803386 */     GIR_EraseRootFromParent_Done,
     /* 1803387 */   // Label 24490: @1803387
     /* 1803387 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1803473), // Rule ID 12446 //
     /* 1803392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803438 */     // MIs[0] policy
     /* 1803438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803472 */     // GIR_Coverage, 12446,
     /* 1803472 */     GIR_EraseRootFromParent_Done,
     /* 1803473 */   // Label 24491: @1803473
     /* 1803473 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1803559), // Rule ID 12447 //
     /* 1803478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803524 */     // MIs[0] policy
     /* 1803524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803558 */     // GIR_Coverage, 12447,
     /* 1803558 */     GIR_EraseRootFromParent_Done,
     /* 1803559 */   // Label 24492: @1803559
     /* 1803559 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1803645), // Rule ID 12450 //
     /* 1803564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803610 */     // MIs[0] policy
     /* 1803610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803644 */     // GIR_Coverage, 12450,
     /* 1803644 */     GIR_EraseRootFromParent_Done,
     /* 1803645 */   // Label 24493: @1803645
     /* 1803645 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1803731), // Rule ID 12451 //
     /* 1803650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803696 */     // MIs[0] policy
     /* 1803696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803706 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803730 */     // GIR_Coverage, 12451,
     /* 1803730 */     GIR_EraseRootFromParent_Done,
     /* 1803731 */   // Label 24494: @1803731
     /* 1803731 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1803817), // Rule ID 12454 //
     /* 1803736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803782 */     // MIs[0] policy
     /* 1803782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803816 */     // GIR_Coverage, 12454,
     /* 1803816 */     GIR_EraseRootFromParent_Done,
     /* 1803817 */   // Label 24495: @1803817
     /* 1803817 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1803903), // Rule ID 12455 //
     /* 1803822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803868 */     // MIs[0] policy
     /* 1803868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803902 */     // GIR_Coverage, 12455,
     /* 1803902 */     GIR_EraseRootFromParent_Done,
     /* 1803903 */   // Label 24496: @1803903
     /* 1803903 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1803989), // Rule ID 12458 //
     /* 1803908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803954 */     // MIs[0] policy
     /* 1803954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803988 */     // GIR_Coverage, 12458,
     /* 1803988 */     GIR_EraseRootFromParent_Done,
     /* 1803989 */   // Label 24497: @1803989
     /* 1803989 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1804075), // Rule ID 12459 //
     /* 1803994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804040 */     // MIs[0] policy
     /* 1804040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1804053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804074 */     // GIR_Coverage, 12459,
     /* 1804074 */     GIR_EraseRootFromParent_Done,
     /* 1804075 */   // Label 24498: @1804075
     /* 1804075 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1804161), // Rule ID 12462 //
     /* 1804080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804126 */     // MIs[0] policy
     /* 1804126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804160 */     // GIR_Coverage, 12462,
     /* 1804160 */     GIR_EraseRootFromParent_Done,
     /* 1804161 */   // Label 24499: @1804161
     /* 1804161 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1804247), // Rule ID 12463 //
     /* 1804166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804212 */     // MIs[0] policy
     /* 1804212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11712:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804246 */     // GIR_Coverage, 12463,
     /* 1804246 */     GIR_EraseRootFromParent_Done,
     /* 1804247 */   // Label 24500: @1804247
     /* 1804247 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1804333), // Rule ID 12466 //
     /* 1804252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804298 */     // MIs[0] policy
     /* 1804298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804332 */     // GIR_Coverage, 12466,
     /* 1804332 */     GIR_EraseRootFromParent_Done,
     /* 1804333 */   // Label 24501: @1804333
     /* 1804333 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1804419), // Rule ID 12467 //
     /* 1804338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804384 */     // MIs[0] policy
     /* 1804384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804418 */     // GIR_Coverage, 12467,
     /* 1804418 */     GIR_EraseRootFromParent_Done,
     /* 1804419 */   // Label 24502: @1804419
     /* 1804419 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1804505), // Rule ID 12470 //
     /* 1804424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804470 */     // MIs[0] policy
     /* 1804470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804504 */     // GIR_Coverage, 12470,
     /* 1804504 */     GIR_EraseRootFromParent_Done,
     /* 1804505 */   // Label 24503: @1804505
     /* 1804505 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1804591), // Rule ID 12471 //
     /* 1804510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804556 */     // MIs[0] policy
     /* 1804556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804590 */     // GIR_Coverage, 12471,
     /* 1804590 */     GIR_EraseRootFromParent_Done,
     /* 1804591 */   // Label 24504: @1804591
     /* 1804591 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1804677), // Rule ID 12474 //
     /* 1804596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804642 */     // MIs[0] policy
     /* 1804642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804676 */     // GIR_Coverage, 12474,
     /* 1804676 */     GIR_EraseRootFromParent_Done,
     /* 1804677 */   // Label 24505: @1804677
     /* 1804677 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1804763), // Rule ID 12475 //
     /* 1804682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804728 */     // MIs[0] policy
     /* 1804728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804738 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804762 */     // GIR_Coverage, 12475,
     /* 1804762 */     GIR_EraseRootFromParent_Done,
     /* 1804763 */   // Label 24506: @1804763
     /* 1804763 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1804849), // Rule ID 12478 //
     /* 1804768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804814 */     // MIs[0] policy
     /* 1804814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804848 */     // GIR_Coverage, 12478,
     /* 1804848 */     GIR_EraseRootFromParent_Done,
     /* 1804849 */   // Label 24507: @1804849
     /* 1804849 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1804935), // Rule ID 12479 //
     /* 1804854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804900 */     // MIs[0] policy
     /* 1804900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11712:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804934 */     // GIR_Coverage, 12479,
     /* 1804934 */     GIR_EraseRootFromParent_Done,
     /* 1804935 */   // Label 24508: @1804935
     /* 1804935 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1805021), // Rule ID 12482 //
     /* 1804940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804986 */     // MIs[0] policy
     /* 1804986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805020 */     // GIR_Coverage, 12482,
     /* 1805020 */     GIR_EraseRootFromParent_Done,
     /* 1805021 */   // Label 24509: @1805021
     /* 1805021 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1805107), // Rule ID 12483 //
     /* 1805026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805072 */     // MIs[0] policy
     /* 1805072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11712:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1805085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805106 */     // GIR_Coverage, 12483,
     /* 1805106 */     GIR_EraseRootFromParent_Done,
     /* 1805107 */   // Label 24510: @1805107
     /* 1805107 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1805193), // Rule ID 12486 //
     /* 1805112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805158 */     // MIs[0] policy
     /* 1805158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1805171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805192 */     // GIR_Coverage, 12486,
     /* 1805192 */     GIR_EraseRootFromParent_Done,
     /* 1805193 */   // Label 24511: @1805193
     /* 1805193 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1805279), // Rule ID 12487 //
     /* 1805198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805244 */     // MIs[0] policy
     /* 1805244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11712:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1805257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805278 */     // GIR_Coverage, 12487,
     /* 1805278 */     GIR_EraseRootFromParent_Done,
     /* 1805279 */   // Label 24512: @1805279
     /* 1805279 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1805365), // Rule ID 12490 //
     /* 1805284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805330 */     // MIs[0] policy
     /* 1805330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1805343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805364 */     // GIR_Coverage, 12490,
     /* 1805364 */     GIR_EraseRootFromParent_Done,
     /* 1805365 */   // Label 24513: @1805365
     /* 1805365 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1805451), // Rule ID 12491 //
     /* 1805370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1805378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805416 */     // MIs[0] policy
     /* 1805416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11712:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1805429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805450 */     // GIR_Coverage, 12491,
     /* 1805450 */     GIR_EraseRootFromParent_Done,
     /* 1805451 */   // Label 24514: @1805451
     /* 1805451 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1805537), // Rule ID 12494 //
     /* 1805456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805502 */     // MIs[0] policy
     /* 1805502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805536 */     // GIR_Coverage, 12494,
     /* 1805536 */     GIR_EraseRootFromParent_Done,
     /* 1805537 */   // Label 24515: @1805537
     /* 1805537 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1805623), // Rule ID 12495 //
     /* 1805542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805588 */     // MIs[0] policy
     /* 1805588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805598 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805622 */     // GIR_Coverage, 12495,
     /* 1805622 */     GIR_EraseRootFromParent_Done,
     /* 1805623 */   // Label 24516: @1805623
     /* 1805623 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1805709), // Rule ID 12498 //
     /* 1805628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805674 */     // MIs[0] policy
     /* 1805674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805708 */     // GIR_Coverage, 12498,
     /* 1805708 */     GIR_EraseRootFromParent_Done,
     /* 1805709 */   // Label 24517: @1805709
     /* 1805709 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1805795), // Rule ID 12499 //
     /* 1805714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805760 */     // MIs[0] policy
     /* 1805760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805794 */     // GIR_Coverage, 12499,
     /* 1805794 */     GIR_EraseRootFromParent_Done,
     /* 1805795 */   // Label 24518: @1805795
     /* 1805795 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1805881), // Rule ID 12502 //
     /* 1805800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805846 */     // MIs[0] policy
     /* 1805846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805856 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805880 */     // GIR_Coverage, 12502,
     /* 1805880 */     GIR_EraseRootFromParent_Done,
     /* 1805881 */   // Label 24519: @1805881
     /* 1805881 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1805967), // Rule ID 12503 //
     /* 1805886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805932 */     // MIs[0] policy
     /* 1805932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805966 */     // GIR_Coverage, 12503,
     /* 1805966 */     GIR_EraseRootFromParent_Done,
     /* 1805967 */   // Label 24520: @1805967
     /* 1805967 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1806053), // Rule ID 12506 //
     /* 1805972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1805992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806018 */     // MIs[0] policy
     /* 1806018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806052 */     // GIR_Coverage, 12506,
     /* 1806052 */     GIR_EraseRootFromParent_Done,
     /* 1806053 */   // Label 24521: @1806053
     /* 1806053 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1806139), // Rule ID 12507 //
     /* 1806058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1806078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806104 */     // MIs[0] policy
     /* 1806104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806138 */     // GIR_Coverage, 12507,
     /* 1806138 */     GIR_EraseRootFromParent_Done,
     /* 1806139 */   // Label 24522: @1806139
     /* 1806139 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1806225), // Rule ID 12510 //
     /* 1806144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1806164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806190 */     // MIs[0] policy
     /* 1806190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806224 */     // GIR_Coverage, 12510,
     /* 1806224 */     GIR_EraseRootFromParent_Done,
     /* 1806225 */   // Label 24523: @1806225
     /* 1806225 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1806311), // Rule ID 12511 //
     /* 1806230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1806250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806276 */     // MIs[0] policy
     /* 1806276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806310 */     // GIR_Coverage, 12511,
     /* 1806310 */     GIR_EraseRootFromParent_Done,
     /* 1806311 */   // Label 24524: @1806311
     /* 1806311 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1806397), // Rule ID 12514 //
     /* 1806316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1806336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806362 */     // MIs[0] policy
     /* 1806362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806396 */     // GIR_Coverage, 12514,
     /* 1806396 */     GIR_EraseRootFromParent_Done,
     /* 1806397 */   // Label 24525: @1806397
     /* 1806397 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1806483), // Rule ID 12515 //
     /* 1806402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1806422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806448 */     // MIs[0] policy
     /* 1806448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806482 */     // GIR_Coverage, 12515,
     /* 1806482 */     GIR_EraseRootFromParent_Done,
     /* 1806483 */   // Label 24526: @1806483
     /* 1806483 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1806569), // Rule ID 12518 //
     /* 1806488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806534 */     // MIs[0] policy
     /* 1806534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806568 */     // GIR_Coverage, 12518,
     /* 1806568 */     GIR_EraseRootFromParent_Done,
     /* 1806569 */   // Label 24527: @1806569
     /* 1806569 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1806655), // Rule ID 12519 //
     /* 1806574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806620 */     // MIs[0] policy
     /* 1806620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806654 */     // GIR_Coverage, 12519,
     /* 1806654 */     GIR_EraseRootFromParent_Done,
     /* 1806655 */   // Label 24528: @1806655
     /* 1806655 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1806741), // Rule ID 12522 //
     /* 1806660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806706 */     // MIs[0] policy
     /* 1806706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806740 */     // GIR_Coverage, 12522,
     /* 1806740 */     GIR_EraseRootFromParent_Done,
     /* 1806741 */   // Label 24529: @1806741
     /* 1806741 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1806827), // Rule ID 12523 //
     /* 1806746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806792 */     // MIs[0] policy
     /* 1806792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806826 */     // GIR_Coverage, 12523,
     /* 1806826 */     GIR_EraseRootFromParent_Done,
     /* 1806827 */   // Label 24530: @1806827
     /* 1806827 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1806913), // Rule ID 12526 //
     /* 1806832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806878 */     // MIs[0] policy
     /* 1806878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806912 */     // GIR_Coverage, 12526,
     /* 1806912 */     GIR_EraseRootFromParent_Done,
     /* 1806913 */   // Label 24531: @1806913
     /* 1806913 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1806999), // Rule ID 12527 //
     /* 1806918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806964 */     // MIs[0] policy
     /* 1806964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806998 */     // GIR_Coverage, 12527,
     /* 1806998 */     GIR_EraseRootFromParent_Done,
     /* 1806999 */   // Label 24532: @1806999
     /* 1806999 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1807085), // Rule ID 12530 //
     /* 1807004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1807024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807050 */     // MIs[0] policy
     /* 1807050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807084 */     // GIR_Coverage, 12530,
     /* 1807084 */     GIR_EraseRootFromParent_Done,
     /* 1807085 */   // Label 24533: @1807085
     /* 1807085 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1807171), // Rule ID 12531 //
     /* 1807090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1807110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807136 */     // MIs[0] policy
     /* 1807136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807170 */     // GIR_Coverage, 12531,
     /* 1807170 */     GIR_EraseRootFromParent_Done,
     /* 1807171 */   // Label 24534: @1807171
     /* 1807171 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1807257), // Rule ID 12534 //
     /* 1807176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1807196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807222 */     // MIs[0] policy
     /* 1807222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807256 */     // GIR_Coverage, 12534,
     /* 1807256 */     GIR_EraseRootFromParent_Done,
     /* 1807257 */   // Label 24535: @1807257
     /* 1807257 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1807343), // Rule ID 12535 //
     /* 1807262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1807282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807308 */     // MIs[0] policy
     /* 1807308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807342 */     // GIR_Coverage, 12535,
     /* 1807342 */     GIR_EraseRootFromParent_Done,
     /* 1807343 */   // Label 24536: @1807343
     /* 1807343 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1807429), // Rule ID 12538 //
     /* 1807348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1807368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807394 */     // MIs[0] policy
     /* 1807394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807428 */     // GIR_Coverage, 12538,
     /* 1807428 */     GIR_EraseRootFromParent_Done,
     /* 1807429 */   // Label 24537: @1807429
     /* 1807429 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1807515), // Rule ID 12539 //
     /* 1807434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1807454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807480 */     // MIs[0] policy
     /* 1807480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807514 */     // GIR_Coverage, 12539,
     /* 1807514 */     GIR_EraseRootFromParent_Done,
     /* 1807515 */   // Label 24538: @1807515
     /* 1807515 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1807601), // Rule ID 12542 //
     /* 1807520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807566 */     // MIs[0] policy
     /* 1807566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807600 */     // GIR_Coverage, 12542,
     /* 1807600 */     GIR_EraseRootFromParent_Done,
     /* 1807601 */   // Label 24539: @1807601
     /* 1807601 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1807687), // Rule ID 12543 //
     /* 1807606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807652 */     // MIs[0] policy
     /* 1807652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807686 */     // GIR_Coverage, 12543,
     /* 1807686 */     GIR_EraseRootFromParent_Done,
     /* 1807687 */   // Label 24540: @1807687
     /* 1807687 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1807773), // Rule ID 12546 //
     /* 1807692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807738 */     // MIs[0] policy
     /* 1807738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807772 */     // GIR_Coverage, 12546,
     /* 1807772 */     GIR_EraseRootFromParent_Done,
     /* 1807773 */   // Label 24541: @1807773
     /* 1807773 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1807859), // Rule ID 12547 //
     /* 1807778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807824 */     // MIs[0] policy
     /* 1807824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807858 */     // GIR_Coverage, 12547,
     /* 1807858 */     GIR_EraseRootFromParent_Done,
     /* 1807859 */   // Label 24542: @1807859
     /* 1807859 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1807945), // Rule ID 12550 //
     /* 1807864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807910 */     // MIs[0] policy
     /* 1807910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807944 */     // GIR_Coverage, 12550,
     /* 1807944 */     GIR_EraseRootFromParent_Done,
     /* 1807945 */   // Label 24543: @1807945
     /* 1807945 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1808031), // Rule ID 12551 //
     /* 1807950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807996 */     // MIs[0] policy
     /* 1807996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808006 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1808009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808030 */     // GIR_Coverage, 12551,
     /* 1808030 */     GIR_EraseRootFromParent_Done,
     /* 1808031 */   // Label 24544: @1808031
     /* 1808031 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1808117), // Rule ID 12554 //
     /* 1808036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808082 */     // MIs[0] policy
     /* 1808082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1808095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808116 */     // GIR_Coverage, 12554,
     /* 1808116 */     GIR_EraseRootFromParent_Done,
     /* 1808117 */   // Label 24545: @1808117
     /* 1808117 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1808203), // Rule ID 12555 //
     /* 1808122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808168 */     // MIs[0] policy
     /* 1808168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1808181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808202 */     // GIR_Coverage, 12555,
     /* 1808202 */     GIR_EraseRootFromParent_Done,
     /* 1808203 */   // Label 24546: @1808203
     /* 1808203 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1808289), // Rule ID 12558 //
     /* 1808208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808254 */     // MIs[0] policy
     /* 1808254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808288 */     // GIR_Coverage, 12558,
     /* 1808288 */     GIR_EraseRootFromParent_Done,
     /* 1808289 */   // Label 24547: @1808289
     /* 1808289 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1808375), // Rule ID 12559 //
     /* 1808294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808340 */     // MIs[0] policy
     /* 1808340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808374 */     // GIR_Coverage, 12559,
     /* 1808374 */     GIR_EraseRootFromParent_Done,
     /* 1808375 */   // Label 24548: @1808375
     /* 1808375 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1808461), // Rule ID 12562 //
     /* 1808380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808426 */     // MIs[0] policy
     /* 1808426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808460 */     // GIR_Coverage, 12562,
     /* 1808460 */     GIR_EraseRootFromParent_Done,
     /* 1808461 */   // Label 24549: @1808461
     /* 1808461 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1808547), // Rule ID 12563 //
     /* 1808466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808512 */     // MIs[0] policy
     /* 1808512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11716:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808546 */     // GIR_Coverage, 12563,
     /* 1808546 */     GIR_EraseRootFromParent_Done,
     /* 1808547 */   // Label 24550: @1808547
     /* 1808547 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1808633), // Rule ID 12566 //
     /* 1808552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808598 */     // MIs[0] policy
     /* 1808598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808632 */     // GIR_Coverage, 12566,
     /* 1808632 */     GIR_EraseRootFromParent_Done,
     /* 1808633 */   // Label 24551: @1808633
     /* 1808633 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1808719), // Rule ID 12567 //
     /* 1808638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808684 */     // MIs[0] policy
     /* 1808684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808718 */     // GIR_Coverage, 12567,
     /* 1808718 */     GIR_EraseRootFromParent_Done,
     /* 1808719 */   // Label 24552: @1808719
     /* 1808719 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1808805), // Rule ID 12570 //
     /* 1808724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808770 */     // MIs[0] policy
     /* 1808770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808804 */     // GIR_Coverage, 12570,
     /* 1808804 */     GIR_EraseRootFromParent_Done,
     /* 1808805 */   // Label 24553: @1808805
     /* 1808805 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1808891), // Rule ID 12571 //
     /* 1808810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808856 */     // MIs[0] policy
     /* 1808856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808890 */     // GIR_Coverage, 12571,
     /* 1808890 */     GIR_EraseRootFromParent_Done,
     /* 1808891 */   // Label 24554: @1808891
     /* 1808891 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1808977), // Rule ID 12574 //
     /* 1808896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808942 */     // MIs[0] policy
     /* 1808942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808976 */     // GIR_Coverage, 12574,
     /* 1808976 */     GIR_EraseRootFromParent_Done,
     /* 1808977 */   // Label 24555: @1808977
     /* 1808977 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1809063), // Rule ID 12575 //
     /* 1808982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1809005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809028 */     // MIs[0] policy
     /* 1809028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809062 */     // GIR_Coverage, 12575,
     /* 1809062 */     GIR_EraseRootFromParent_Done,
     /* 1809063 */   // Label 24556: @1809063
     /* 1809063 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1809149), // Rule ID 12578 //
     /* 1809068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809114 */     // MIs[0] policy
     /* 1809114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1809127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809148 */     // GIR_Coverage, 12578,
     /* 1809148 */     GIR_EraseRootFromParent_Done,
     /* 1809149 */   // Label 24557: @1809149
     /* 1809149 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1809235), // Rule ID 12579 //
     /* 1809154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809200 */     // MIs[0] policy
     /* 1809200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1809213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809234 */     // GIR_Coverage, 12579,
     /* 1809234 */     GIR_EraseRootFromParent_Done,
     /* 1809235 */   // Label 24558: @1809235
     /* 1809235 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1809321), // Rule ID 12582 //
     /* 1809240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809286 */     // MIs[0] policy
     /* 1809286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809320 */     // GIR_Coverage, 12582,
     /* 1809320 */     GIR_EraseRootFromParent_Done,
     /* 1809321 */   // Label 24559: @1809321
     /* 1809321 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1809407), // Rule ID 12583 //
     /* 1809326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809372 */     // MIs[0] policy
     /* 1809372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11716:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809406 */     // GIR_Coverage, 12583,
     /* 1809406 */     GIR_EraseRootFromParent_Done,
     /* 1809407 */   // Label 24560: @1809407
     /* 1809407 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1809493), // Rule ID 12586 //
     /* 1809412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809458 */     // MIs[0] policy
     /* 1809458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809492 */     // GIR_Coverage, 12586,
     /* 1809492 */     GIR_EraseRootFromParent_Done,
     /* 1809493 */   // Label 24561: @1809493
     /* 1809493 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1809579), // Rule ID 12587 //
     /* 1809498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809544 */     // MIs[0] policy
     /* 1809544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809578 */     // GIR_Coverage, 12587,
     /* 1809578 */     GIR_EraseRootFromParent_Done,
     /* 1809579 */   // Label 24562: @1809579
     /* 1809579 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1809665), // Rule ID 12590 //
     /* 1809584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809630 */     // MIs[0] policy
     /* 1809630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809664 */     // GIR_Coverage, 12590,
     /* 1809664 */     GIR_EraseRootFromParent_Done,
     /* 1809665 */   // Label 24563: @1809665
     /* 1809665 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1809751), // Rule ID 12591 //
     /* 1809670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809716 */     // MIs[0] policy
     /* 1809716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809750 */     // GIR_Coverage, 12591,
     /* 1809750 */     GIR_EraseRootFromParent_Done,
     /* 1809751 */   // Label 24564: @1809751
     /* 1809751 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1809837), // Rule ID 12594 //
     /* 1809756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809802 */     // MIs[0] policy
     /* 1809802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809836 */     // GIR_Coverage, 12594,
     /* 1809836 */     GIR_EraseRootFromParent_Done,
     /* 1809837 */   // Label 24565: @1809837
     /* 1809837 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1809923), // Rule ID 12595 //
     /* 1809842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809888 */     // MIs[0] policy
     /* 1809888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809922 */     // GIR_Coverage, 12595,
     /* 1809922 */     GIR_EraseRootFromParent_Done,
     /* 1809923 */   // Label 24566: @1809923
     /* 1809923 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1810009), // Rule ID 12598 //
     /* 1809928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809974 */     // MIs[0] policy
     /* 1809974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810008 */     // GIR_Coverage, 12598,
     /* 1810008 */     GIR_EraseRootFromParent_Done,
     /* 1810009 */   // Label 24567: @1810009
     /* 1810009 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1810095), // Rule ID 12599 //
     /* 1810014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1810031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810060 */     // MIs[0] policy
     /* 1810060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11716:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1810073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810094 */     // GIR_Coverage, 12599,
     /* 1810094 */     GIR_EraseRootFromParent_Done,
     /* 1810095 */   // Label 24568: @1810095
     /* 1810095 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1810181), // Rule ID 12602 //
     /* 1810100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810146 */     // MIs[0] policy
     /* 1810146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1810159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810180 */     // GIR_Coverage, 12602,
     /* 1810180 */     GIR_EraseRootFromParent_Done,
     /* 1810181 */   // Label 24569: @1810181
     /* 1810181 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1810267), // Rule ID 12603 //
     /* 1810186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810232 */     // MIs[0] policy
     /* 1810232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11716:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1810245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810266 */     // GIR_Coverage, 12603,
     /* 1810266 */     GIR_EraseRootFromParent_Done,
     /* 1810267 */   // Label 24570: @1810267
     /* 1810267 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1810353), // Rule ID 12606 //
     /* 1810272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810318 */     // MIs[0] policy
     /* 1810318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1810331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810352 */     // GIR_Coverage, 12606,
     /* 1810352 */     GIR_EraseRootFromParent_Done,
     /* 1810353 */   // Label 24571: @1810353
     /* 1810353 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1810439), // Rule ID 12607 //
     /* 1810358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810404 */     // MIs[0] policy
     /* 1810404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810414 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11716:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1810417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810438 */     // GIR_Coverage, 12607,
     /* 1810438 */     GIR_EraseRootFromParent_Done,
     /* 1810439 */   // Label 24572: @1810439
     /* 1810439 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1810525), // Rule ID 12610 //
     /* 1810444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810490 */     // MIs[0] policy
     /* 1810490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810524 */     // GIR_Coverage, 12610,
     /* 1810524 */     GIR_EraseRootFromParent_Done,
     /* 1810525 */   // Label 24573: @1810525
     /* 1810525 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1810611), // Rule ID 12611 //
     /* 1810530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810576 */     // MIs[0] policy
     /* 1810576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11716:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810610 */     // GIR_Coverage, 12611,
     /* 1810610 */     GIR_EraseRootFromParent_Done,
     /* 1810611 */   // Label 24574: @1810611
     /* 1810611 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1810697), // Rule ID 12614 //
     /* 1810616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810662 */     // MIs[0] policy
     /* 1810662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810696 */     // GIR_Coverage, 12614,
     /* 1810696 */     GIR_EraseRootFromParent_Done,
     /* 1810697 */   // Label 24575: @1810697
     /* 1810697 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1810783), // Rule ID 12615 //
     /* 1810702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810748 */     // MIs[0] policy
     /* 1810748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810782 */     // GIR_Coverage, 12615,
     /* 1810782 */     GIR_EraseRootFromParent_Done,
     /* 1810783 */   // Label 24576: @1810783
     /* 1810783 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1810869), // Rule ID 12618 //
     /* 1810788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810834 */     // MIs[0] policy
     /* 1810834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810868 */     // GIR_Coverage, 12618,
     /* 1810868 */     GIR_EraseRootFromParent_Done,
     /* 1810869 */   // Label 24577: @1810869
     /* 1810869 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1810955), // Rule ID 12619 //
     /* 1810874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810920 */     // MIs[0] policy
     /* 1810920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810954 */     // GIR_Coverage, 12619,
     /* 1810954 */     GIR_EraseRootFromParent_Done,
     /* 1810955 */   // Label 24578: @1810955
     /* 1810955 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1811041), // Rule ID 12622 //
     /* 1810960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811006 */     // MIs[0] policy
     /* 1811006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811040 */     // GIR_Coverage, 12622,
     /* 1811040 */     GIR_EraseRootFromParent_Done,
     /* 1811041 */   // Label 24579: @1811041
     /* 1811041 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1811127), // Rule ID 12623 //
     /* 1811046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1811057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1811060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1811063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1811066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811092 */     // MIs[0] policy
     /* 1811092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811126 */     // GIR_Coverage, 12623,
     /* 1811126 */     GIR_EraseRootFromParent_Done,
     /* 1811127 */   // Label 24580: @1811127
     /* 1811127 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1811213), // Rule ID 12626 //
     /* 1811132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1811152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811178 */     // MIs[0] policy
     /* 1811178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811212 */     // GIR_Coverage, 12626,
     /* 1811212 */     GIR_EraseRootFromParent_Done,
     /* 1811213 */   // Label 24581: @1811213
     /* 1811213 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1811299), // Rule ID 12627 //
     /* 1811218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1811238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811264 */     // MIs[0] policy
     /* 1811264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811298 */     // GIR_Coverage, 12627,
     /* 1811298 */     GIR_EraseRootFromParent_Done,
     /* 1811299 */   // Label 24582: @1811299
     /* 1811299 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1811385), // Rule ID 12630 //
     /* 1811304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1811324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811350 */     // MIs[0] policy
     /* 1811350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811384 */     // GIR_Coverage, 12630,
     /* 1811384 */     GIR_EraseRootFromParent_Done,
     /* 1811385 */   // Label 24583: @1811385
     /* 1811385 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1811471), // Rule ID 12631 //
     /* 1811390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1811410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811436 */     // MIs[0] policy
     /* 1811436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811470 */     // GIR_Coverage, 12631,
     /* 1811470 */     GIR_EraseRootFromParent_Done,
     /* 1811471 */   // Label 24584: @1811471
     /* 1811471 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1811557), // Rule ID 12634 //
     /* 1811476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811522 */     // MIs[0] policy
     /* 1811522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811556 */     // GIR_Coverage, 12634,
     /* 1811556 */     GIR_EraseRootFromParent_Done,
     /* 1811557 */   // Label 24585: @1811557
     /* 1811557 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1811643), // Rule ID 12635 //
     /* 1811562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811608 */     // MIs[0] policy
     /* 1811608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811642 */     // GIR_Coverage, 12635,
     /* 1811642 */     GIR_EraseRootFromParent_Done,
     /* 1811643 */   // Label 24586: @1811643
     /* 1811643 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1811729), // Rule ID 12638 //
     /* 1811648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811694 */     // MIs[0] policy
     /* 1811694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811728 */     // GIR_Coverage, 12638,
     /* 1811728 */     GIR_EraseRootFromParent_Done,
     /* 1811729 */   // Label 24587: @1811729
     /* 1811729 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1811815), // Rule ID 12639 //
     /* 1811734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811780 */     // MIs[0] policy
     /* 1811780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811814 */     // GIR_Coverage, 12639,
     /* 1811814 */     GIR_EraseRootFromParent_Done,
     /* 1811815 */   // Label 24588: @1811815
     /* 1811815 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1811901), // Rule ID 12642 //
     /* 1811820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811866 */     // MIs[0] policy
     /* 1811866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811900 */     // GIR_Coverage, 12642,
     /* 1811900 */     GIR_EraseRootFromParent_Done,
     /* 1811901 */   // Label 24589: @1811901
     /* 1811901 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1811987), // Rule ID 12643 //
     /* 1811906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811952 */     // MIs[0] policy
     /* 1811952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811986 */     // GIR_Coverage, 12643,
     /* 1811986 */     GIR_EraseRootFromParent_Done,
     /* 1811987 */   // Label 24590: @1811987
     /* 1811987 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1812073), // Rule ID 12646 //
     /* 1811992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1812012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812038 */     // MIs[0] policy
     /* 1812038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812072 */     // GIR_Coverage, 12646,
     /* 1812072 */     GIR_EraseRootFromParent_Done,
     /* 1812073 */   // Label 24591: @1812073
     /* 1812073 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1812159), // Rule ID 12647 //
     /* 1812078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1812089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1812092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1812095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1812098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812124 */     // MIs[0] policy
     /* 1812124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812158 */     // GIR_Coverage, 12647,
     /* 1812158 */     GIR_EraseRootFromParent_Done,
     /* 1812159 */   // Label 24592: @1812159
     /* 1812159 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1812245), // Rule ID 12650 //
     /* 1812164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1812184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812210 */     // MIs[0] policy
     /* 1812210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812244 */     // GIR_Coverage, 12650,
     /* 1812244 */     GIR_EraseRootFromParent_Done,
     /* 1812245 */   // Label 24593: @1812245
     /* 1812245 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1812331), // Rule ID 12651 //
     /* 1812250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1812270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812296 */     // MIs[0] policy
     /* 1812296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812330 */     // GIR_Coverage, 12651,
     /* 1812330 */     GIR_EraseRootFromParent_Done,
     /* 1812331 */   // Label 24594: @1812331
     /* 1812331 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1812417), // Rule ID 12654 //
     /* 1812336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1812356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812382 */     // MIs[0] policy
     /* 1812382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812416 */     // GIR_Coverage, 12654,
     /* 1812416 */     GIR_EraseRootFromParent_Done,
     /* 1812417 */   // Label 24595: @1812417
     /* 1812417 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1812503), // Rule ID 12655 //
     /* 1812422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1812442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812468 */     // MIs[0] policy
     /* 1812468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812502 */     // GIR_Coverage, 12655,
     /* 1812502 */     GIR_EraseRootFromParent_Done,
     /* 1812503 */   // Label 24596: @1812503
     /* 1812503 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1812589), // Rule ID 12658 //
     /* 1812508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812554 */     // MIs[0] policy
     /* 1812554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812588 */     // GIR_Coverage, 12658,
     /* 1812588 */     GIR_EraseRootFromParent_Done,
     /* 1812589 */   // Label 24597: @1812589
     /* 1812589 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1812675), // Rule ID 12659 //
     /* 1812594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812640 */     // MIs[0] policy
     /* 1812640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812674 */     // GIR_Coverage, 12659,
     /* 1812674 */     GIR_EraseRootFromParent_Done,
     /* 1812675 */   // Label 24598: @1812675
     /* 1812675 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1812761), // Rule ID 12662 //
     /* 1812680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812726 */     // MIs[0] policy
     /* 1812726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812760 */     // GIR_Coverage, 12662,
     /* 1812760 */     GIR_EraseRootFromParent_Done,
     /* 1812761 */   // Label 24599: @1812761
     /* 1812761 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1812847), // Rule ID 12663 //
     /* 1812766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812812 */     // MIs[0] policy
     /* 1812812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812846 */     // GIR_Coverage, 12663,
     /* 1812846 */     GIR_EraseRootFromParent_Done,
     /* 1812847 */   // Label 24600: @1812847
     /* 1812847 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1812933), // Rule ID 12666 //
     /* 1812852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812898 */     // MIs[0] policy
     /* 1812898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812932 */     // GIR_Coverage, 12666,
     /* 1812932 */     GIR_EraseRootFromParent_Done,
     /* 1812933 */   // Label 24601: @1812933
     /* 1812933 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1813019), // Rule ID 12667 //
     /* 1812938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812984 */     // MIs[0] policy
     /* 1812984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813018 */     // GIR_Coverage, 12667,
     /* 1813018 */     GIR_EraseRootFromParent_Done,
     /* 1813019 */   // Label 24602: @1813019
     /* 1813019 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1813105), // Rule ID 12670 //
     /* 1813024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1813027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1813044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813070 */     // MIs[0] policy
     /* 1813070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1813083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813104 */     // GIR_Coverage, 12670,
     /* 1813104 */     GIR_EraseRootFromParent_Done,
     /* 1813105 */   // Label 24603: @1813105
     /* 1813105 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1813191), // Rule ID 12671 //
     /* 1813110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1813113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1813130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813156 */     // MIs[0] policy
     /* 1813156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1813169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813190 */     // GIR_Coverage, 12671,
     /* 1813190 */     GIR_EraseRootFromParent_Done,
     /* 1813191 */   // Label 24604: @1813191
     /* 1813191 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1813277), // Rule ID 12674 //
     /* 1813196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1813213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813242 */     // MIs[0] policy
     /* 1813242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1813255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813276 */     // GIR_Coverage, 12674,
     /* 1813276 */     GIR_EraseRootFromParent_Done,
     /* 1813277 */   // Label 24605: @1813277
     /* 1813277 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1813363), // Rule ID 12675 //
     /* 1813282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1813299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813328 */     // MIs[0] policy
     /* 1813328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1813341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813362 */     // GIR_Coverage, 12675,
     /* 1813362 */     GIR_EraseRootFromParent_Done,
     /* 1813363 */   // Label 24606: @1813363
     /* 1813363 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1813449), // Rule ID 12678 //
     /* 1813368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813414 */     // MIs[0] policy
     /* 1813414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813448 */     // GIR_Coverage, 12678,
     /* 1813448 */     GIR_EraseRootFromParent_Done,
     /* 1813449 */   // Label 24607: @1813449
     /* 1813449 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1813535), // Rule ID 12679 //
     /* 1813454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813500 */     // MIs[0] policy
     /* 1813500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813534 */     // GIR_Coverage, 12679,
     /* 1813534 */     GIR_EraseRootFromParent_Done,
     /* 1813535 */   // Label 24608: @1813535
     /* 1813535 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1813621), // Rule ID 12682 //
     /* 1813540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813586 */     // MIs[0] policy
     /* 1813586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813620 */     // GIR_Coverage, 12682,
     /* 1813620 */     GIR_EraseRootFromParent_Done,
     /* 1813621 */   // Label 24609: @1813621
     /* 1813621 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1813707), // Rule ID 12683 //
     /* 1813626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813672 */     // MIs[0] policy
     /* 1813672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11714:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813706 */     // GIR_Coverage, 12683,
     /* 1813706 */     GIR_EraseRootFromParent_Done,
     /* 1813707 */   // Label 24610: @1813707
     /* 1813707 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1813793), // Rule ID 12686 //
     /* 1813712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813758 */     // MIs[0] policy
     /* 1813758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813792 */     // GIR_Coverage, 12686,
     /* 1813792 */     GIR_EraseRootFromParent_Done,
     /* 1813793 */   // Label 24611: @1813793
     /* 1813793 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1813879), // Rule ID 12687 //
     /* 1813798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813844 */     // MIs[0] policy
     /* 1813844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813878 */     // GIR_Coverage, 12687,
     /* 1813878 */     GIR_EraseRootFromParent_Done,
     /* 1813879 */   // Label 24612: @1813879
     /* 1813879 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1813965), // Rule ID 12690 //
     /* 1813884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813930 */     // MIs[0] policy
     /* 1813930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813940 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813964 */     // GIR_Coverage, 12690,
     /* 1813964 */     GIR_EraseRootFromParent_Done,
     /* 1813965 */   // Label 24613: @1813965
     /* 1813965 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1814051), // Rule ID 12691 //
     /* 1813970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814016 */     // MIs[0] policy
     /* 1814016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814050 */     // GIR_Coverage, 12691,
     /* 1814050 */     GIR_EraseRootFromParent_Done,
     /* 1814051 */   // Label 24614: @1814051
     /* 1814051 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1814137), // Rule ID 12694 //
     /* 1814056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814102 */     // MIs[0] policy
     /* 1814102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814112 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814136 */     // GIR_Coverage, 12694,
     /* 1814136 */     GIR_EraseRootFromParent_Done,
     /* 1814137 */   // Label 24615: @1814137
     /* 1814137 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1814223), // Rule ID 12695 //
     /* 1814142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814188 */     // MIs[0] policy
     /* 1814188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814222 */     // GIR_Coverage, 12695,
     /* 1814222 */     GIR_EraseRootFromParent_Done,
     /* 1814223 */   // Label 24616: @1814223
     /* 1814223 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1814309), // Rule ID 12698 //
     /* 1814228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1814239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1814242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1814245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814274 */     // MIs[0] policy
     /* 1814274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1814287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814308 */     // GIR_Coverage, 12698,
     /* 1814308 */     GIR_EraseRootFromParent_Done,
     /* 1814309 */   // Label 24617: @1814309
     /* 1814309 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1814395), // Rule ID 12699 //
     /* 1814314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1814325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1814328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1814331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814360 */     // MIs[0] policy
     /* 1814360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1814373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814394 */     // GIR_Coverage, 12699,
     /* 1814394 */     GIR_EraseRootFromParent_Done,
     /* 1814395 */   // Label 24618: @1814395
     /* 1814395 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1814481), // Rule ID 12702 //
     /* 1814400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814446 */     // MIs[0] policy
     /* 1814446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814480 */     // GIR_Coverage, 12702,
     /* 1814480 */     GIR_EraseRootFromParent_Done,
     /* 1814481 */   // Label 24619: @1814481
     /* 1814481 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1814567), // Rule ID 12703 //
     /* 1814486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814532 */     // MIs[0] policy
     /* 1814532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11714:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814566 */     // GIR_Coverage, 12703,
     /* 1814566 */     GIR_EraseRootFromParent_Done,
     /* 1814567 */   // Label 24620: @1814567
     /* 1814567 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1814653), // Rule ID 12706 //
     /* 1814572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814618 */     // MIs[0] policy
     /* 1814618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814652 */     // GIR_Coverage, 12706,
     /* 1814652 */     GIR_EraseRootFromParent_Done,
     /* 1814653 */   // Label 24621: @1814653
     /* 1814653 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1814739), // Rule ID 12707 //
     /* 1814658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814704 */     // MIs[0] policy
     /* 1814704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814738 */     // GIR_Coverage, 12707,
     /* 1814738 */     GIR_EraseRootFromParent_Done,
     /* 1814739 */   // Label 24622: @1814739
     /* 1814739 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1814825), // Rule ID 12710 //
     /* 1814744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814790 */     // MIs[0] policy
     /* 1814790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814824 */     // GIR_Coverage, 12710,
     /* 1814824 */     GIR_EraseRootFromParent_Done,
     /* 1814825 */   // Label 24623: @1814825
     /* 1814825 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1814911), // Rule ID 12711 //
     /* 1814830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814876 */     // MIs[0] policy
     /* 1814876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814910 */     // GIR_Coverage, 12711,
     /* 1814910 */     GIR_EraseRootFromParent_Done,
     /* 1814911 */   // Label 24624: @1814911
     /* 1814911 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1814997), // Rule ID 12714 //
     /* 1814916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814962 */     // MIs[0] policy
     /* 1814962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814996 */     // GIR_Coverage, 12714,
     /* 1814996 */     GIR_EraseRootFromParent_Done,
     /* 1814997 */   // Label 24625: @1814997
     /* 1814997 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1815083), // Rule ID 12715 //
     /* 1815002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815048 */     // MIs[0] policy
     /* 1815048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815082 */     // GIR_Coverage, 12715,
     /* 1815082 */     GIR_EraseRootFromParent_Done,
     /* 1815083 */   // Label 24626: @1815083
     /* 1815083 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1815169), // Rule ID 12718 //
     /* 1815088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815134 */     // MIs[0] policy
     /* 1815134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1815147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815168 */     // GIR_Coverage, 12718,
     /* 1815168 */     GIR_EraseRootFromParent_Done,
     /* 1815169 */   // Label 24627: @1815169
     /* 1815169 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1815255), // Rule ID 12719 //
     /* 1815174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1815185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1815188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1815191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815220 */     // MIs[0] policy
     /* 1815220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11714:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1815233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815254 */     // GIR_Coverage, 12719,
     /* 1815254 */     GIR_EraseRootFromParent_Done,
     /* 1815255 */   // Label 24628: @1815255
     /* 1815255 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1815341), // Rule ID 12722 //
     /* 1815260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815306 */     // MIs[0] policy
     /* 1815306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1815319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815340 */     // GIR_Coverage, 12722,
     /* 1815340 */     GIR_EraseRootFromParent_Done,
     /* 1815341 */   // Label 24629: @1815341
     /* 1815341 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1815427), // Rule ID 12723 //
     /* 1815346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1815363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815392 */     // MIs[0] policy
     /* 1815392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11714:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1815405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815426 */     // GIR_Coverage, 12723,
     /* 1815426 */     GIR_EraseRootFromParent_Done,
     /* 1815427 */   // Label 24630: @1815427
     /* 1815427 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1815513), // Rule ID 12726 //
     /* 1815432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815478 */     // MIs[0] policy
     /* 1815478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815488 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815512 */     // GIR_Coverage, 12726,
     /* 1815512 */     GIR_EraseRootFromParent_Done,
     /* 1815513 */   // Label 24631: @1815513
     /* 1815513 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1815599), // Rule ID 12727 //
     /* 1815518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815564 */     // MIs[0] policy
     /* 1815564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11714:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815598 */     // GIR_Coverage, 12727,
     /* 1815598 */     GIR_EraseRootFromParent_Done,
     /* 1815599 */   // Label 24632: @1815599
     /* 1815599 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1815685), // Rule ID 12730 //
     /* 1815604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815650 */     // MIs[0] policy
     /* 1815650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815684 */     // GIR_Coverage, 12730,
     /* 1815684 */     GIR_EraseRootFromParent_Done,
     /* 1815685 */   // Label 24633: @1815685
     /* 1815685 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1815771), // Rule ID 12731 //
     /* 1815690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815736 */     // MIs[0] policy
     /* 1815736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11714:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815770 */     // GIR_Coverage, 12731,
     /* 1815770 */     GIR_EraseRootFromParent_Done,
     /* 1815771 */   // Label 24634: @1815771
     /* 1815771 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1815857), // Rule ID 12734 //
     /* 1815776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815822 */     // MIs[0] policy
     /* 1815822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815832 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815856 */     // GIR_Coverage, 12734,
     /* 1815856 */     GIR_EraseRootFromParent_Done,
     /* 1815857 */   // Label 24635: @1815857
     /* 1815857 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1815943), // Rule ID 12735 //
     /* 1815862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815908 */     // MIs[0] policy
     /* 1815908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815942 */     // GIR_Coverage, 12735,
     /* 1815942 */     GIR_EraseRootFromParent_Done,
     /* 1815943 */   // Label 24636: @1815943
     /* 1815943 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1816029), // Rule ID 12738 //
     /* 1815948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815994 */     // MIs[0] policy
     /* 1815994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816028 */     // GIR_Coverage, 12738,
     /* 1816028 */     GIR_EraseRootFromParent_Done,
     /* 1816029 */   // Label 24637: @1816029
     /* 1816029 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1816115), // Rule ID 12739 //
     /* 1816034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1816045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1816048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1816051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1816054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816080 */     // MIs[0] policy
     /* 1816080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816090 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816114 */     // GIR_Coverage, 12739,
     /* 1816114 */     GIR_EraseRootFromParent_Done,
     /* 1816115 */   // Label 24638: @1816115
     /* 1816115 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1816201), // Rule ID 12742 //
     /* 1816120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816166 */     // MIs[0] policy
     /* 1816166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1816179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816200 */     // GIR_Coverage, 12742,
     /* 1816200 */     GIR_EraseRootFromParent_Done,
     /* 1816201 */   // Label 24639: @1816201
     /* 1816201 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1816287), // Rule ID 12743 //
     /* 1816206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816252 */     // MIs[0] policy
     /* 1816252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1816265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816286 */     // GIR_Coverage, 12743,
     /* 1816286 */     GIR_EraseRootFromParent_Done,
     /* 1816287 */   // Label 24640: @1816287
     /* 1816287 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1816373), // Rule ID 12746 //
     /* 1816292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816338 */     // MIs[0] policy
     /* 1816338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816372 */     // GIR_Coverage, 12746,
     /* 1816372 */     GIR_EraseRootFromParent_Done,
     /* 1816373 */   // Label 24641: @1816373
     /* 1816373 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1816459), // Rule ID 12747 //
     /* 1816378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816424 */     // MIs[0] policy
     /* 1816424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816458 */     // GIR_Coverage, 12747,
     /* 1816458 */     GIR_EraseRootFromParent_Done,
     /* 1816459 */   // Label 24642: @1816459
     /* 1816459 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1816545), // Rule ID 12750 //
     /* 1816464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816510 */     // MIs[0] policy
     /* 1816510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816544 */     // GIR_Coverage, 12750,
     /* 1816544 */     GIR_EraseRootFromParent_Done,
     /* 1816545 */   // Label 24643: @1816545
     /* 1816545 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1816631), // Rule ID 12751 //
     /* 1816550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816596 */     // MIs[0] policy
     /* 1816596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816630 */     // GIR_Coverage, 12751,
     /* 1816630 */     GIR_EraseRootFromParent_Done,
     /* 1816631 */   // Label 24644: @1816631
     /* 1816631 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1816717), // Rule ID 12754 //
     /* 1816636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816682 */     // MIs[0] policy
     /* 1816682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816716 */     // GIR_Coverage, 12754,
     /* 1816716 */     GIR_EraseRootFromParent_Done,
     /* 1816717 */   // Label 24645: @1816717
     /* 1816717 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1816803), // Rule ID 12755 //
     /* 1816722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816768 */     // MIs[0] policy
     /* 1816768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816802 */     // GIR_Coverage, 12755,
     /* 1816802 */     GIR_EraseRootFromParent_Done,
     /* 1816803 */   // Label 24646: @1816803
     /* 1816803 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1816889), // Rule ID 12758 //
     /* 1816808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816854 */     // MIs[0] policy
     /* 1816854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816888 */     // GIR_Coverage, 12758,
     /* 1816888 */     GIR_EraseRootFromParent_Done,
     /* 1816889 */   // Label 24647: @1816889
     /* 1816889 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1816975), // Rule ID 12759 //
     /* 1816894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816940 */     // MIs[0] policy
     /* 1816940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816974 */     // GIR_Coverage, 12759,
     /* 1816974 */     GIR_EraseRootFromParent_Done,
     /* 1816975 */   // Label 24648: @1816975
     /* 1816975 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1817061), // Rule ID 12762 //
     /* 1816980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1816994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817026 */     // MIs[0] policy
     /* 1817026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817060 */     // GIR_Coverage, 12762,
     /* 1817060 */     GIR_EraseRootFromParent_Done,
     /* 1817061 */   // Label 24649: @1817061
     /* 1817061 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1817147), // Rule ID 12763 //
     /* 1817066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1817083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817112 */     // MIs[0] policy
     /* 1817112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817146 */     // GIR_Coverage, 12763,
     /* 1817146 */     GIR_EraseRootFromParent_Done,
     /* 1817147 */   // Label 24650: @1817147
     /* 1817147 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1817233), // Rule ID 12766 //
     /* 1817152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1817155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817198 */     // MIs[0] policy
     /* 1817198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817232 */     // GIR_Coverage, 12766,
     /* 1817232 */     GIR_EraseRootFromParent_Done,
     /* 1817233 */   // Label 24651: @1817233
     /* 1817233 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1817319), // Rule ID 12767 //
     /* 1817238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1817241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817284 */     // MIs[0] policy
     /* 1817284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1817297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817318 */     // GIR_Coverage, 12767,
     /* 1817318 */     GIR_EraseRootFromParent_Done,
     /* 1817319 */   // Label 24652: @1817319
     /* 1817319 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1817405), // Rule ID 12770 //
     /* 1817324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817370 */     // MIs[0] policy
     /* 1817370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817404 */     // GIR_Coverage, 12770,
     /* 1817404 */     GIR_EraseRootFromParent_Done,
     /* 1817405 */   // Label 24653: @1817405
     /* 1817405 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1817491), // Rule ID 12771 //
     /* 1817410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817456 */     // MIs[0] policy
     /* 1817456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817490 */     // GIR_Coverage, 12771,
     /* 1817490 */     GIR_EraseRootFromParent_Done,
     /* 1817491 */   // Label 24654: @1817491
     /* 1817491 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1817577), // Rule ID 12774 //
     /* 1817496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817542 */     // MIs[0] policy
     /* 1817542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817576 */     // GIR_Coverage, 12774,
     /* 1817576 */     GIR_EraseRootFromParent_Done,
     /* 1817577 */   // Label 24655: @1817577
     /* 1817577 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1817663), // Rule ID 12775 //
     /* 1817582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817628 */     // MIs[0] policy
     /* 1817628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817662 */     // GIR_Coverage, 12775,
     /* 1817662 */     GIR_EraseRootFromParent_Done,
     /* 1817663 */   // Label 24656: @1817663
     /* 1817663 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1817749), // Rule ID 12778 //
     /* 1817668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817714 */     // MIs[0] policy
     /* 1817714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817724 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817748 */     // GIR_Coverage, 12778,
     /* 1817748 */     GIR_EraseRootFromParent_Done,
     /* 1817749 */   // Label 24657: @1817749
     /* 1817749 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1817835), // Rule ID 12779 //
     /* 1817754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817800 */     // MIs[0] policy
     /* 1817800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817810 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817834 */     // GIR_Coverage, 12779,
     /* 1817834 */     GIR_EraseRootFromParent_Done,
     /* 1817835 */   // Label 24658: @1817835
     /* 1817835 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1817921), // Rule ID 12782 //
     /* 1817840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817886 */     // MIs[0] policy
     /* 1817886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817920 */     // GIR_Coverage, 12782,
     /* 1817920 */     GIR_EraseRootFromParent_Done,
     /* 1817921 */   // Label 24659: @1817921
     /* 1817921 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1818007), // Rule ID 12783 //
     /* 1817926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817972 */     // MIs[0] policy
     /* 1817972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818006 */     // GIR_Coverage, 12783,
     /* 1818006 */     GIR_EraseRootFromParent_Done,
     /* 1818007 */   // Label 24660: @1818007
     /* 1818007 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1818093), // Rule ID 12786 //
     /* 1818012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818058 */     // MIs[0] policy
     /* 1818058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818092 */     // GIR_Coverage, 12786,
     /* 1818092 */     GIR_EraseRootFromParent_Done,
     /* 1818093 */   // Label 24661: @1818093
     /* 1818093 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1818179), // Rule ID 12787 //
     /* 1818098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818144 */     // MIs[0] policy
     /* 1818144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818178 */     // GIR_Coverage, 12787,
     /* 1818178 */     GIR_EraseRootFromParent_Done,
     /* 1818179 */   // Label 24662: @1818179
     /* 1818179 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1818265), // Rule ID 12790 //
     /* 1818184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818230 */     // MIs[0] policy
     /* 1818230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818264 */     // GIR_Coverage, 12790,
     /* 1818264 */     GIR_EraseRootFromParent_Done,
     /* 1818265 */   // Label 24663: @1818265
     /* 1818265 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1818351), // Rule ID 12791 //
     /* 1818270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818316 */     // MIs[0] policy
     /* 1818316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818350 */     // GIR_Coverage, 12791,
     /* 1818350 */     GIR_EraseRootFromParent_Done,
     /* 1818351 */   // Label 24664: @1818351
     /* 1818351 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1818437), // Rule ID 12794 //
     /* 1818356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818402 */     // MIs[0] policy
     /* 1818402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818436 */     // GIR_Coverage, 12794,
     /* 1818436 */     GIR_EraseRootFromParent_Done,
     /* 1818437 */   // Label 24665: @1818437
     /* 1818437 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1818523), // Rule ID 12795 //
     /* 1818442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818488 */     // MIs[0] policy
     /* 1818488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818522 */     // GIR_Coverage, 12795,
     /* 1818522 */     GIR_EraseRootFromParent_Done,
     /* 1818523 */   // Label 24666: @1818523
     /* 1818523 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1818609), // Rule ID 12798 //
     /* 1818528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818574 */     // MIs[0] policy
     /* 1818574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818608 */     // GIR_Coverage, 12798,
     /* 1818608 */     GIR_EraseRootFromParent_Done,
     /* 1818609 */   // Label 24667: @1818609
     /* 1818609 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1818695), // Rule ID 12799 //
     /* 1818614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818660 */     // MIs[0] policy
     /* 1818660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818694 */     // GIR_Coverage, 12799,
     /* 1818694 */     GIR_EraseRootFromParent_Done,
     /* 1818695 */   // Label 24668: @1818695
     /* 1818695 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1818781), // Rule ID 12802 //
     /* 1818700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818746 */     // MIs[0] policy
     /* 1818746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818756 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818780 */     // GIR_Coverage, 12802,
     /* 1818780 */     GIR_EraseRootFromParent_Done,
     /* 1818781 */   // Label 24669: @1818781
     /* 1818781 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1818867), // Rule ID 12803 //
     /* 1818786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818832 */     // MIs[0] policy
     /* 1818832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818866 */     // GIR_Coverage, 12803,
     /* 1818866 */     GIR_EraseRootFromParent_Done,
     /* 1818867 */   // Label 24670: @1818867
     /* 1818867 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1818953), // Rule ID 12806 //
     /* 1818872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818918 */     // MIs[0] policy
     /* 1818918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818952 */     // GIR_Coverage, 12806,
     /* 1818952 */     GIR_EraseRootFromParent_Done,
     /* 1818953 */   // Label 24671: @1818953
     /* 1818953 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1819039), // Rule ID 12807 //
     /* 1818958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819004 */     // MIs[0] policy
     /* 1819004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1819017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819038 */     // GIR_Coverage, 12807,
     /* 1819038 */     GIR_EraseRootFromParent_Done,
     /* 1819039 */   // Label 24672: @1819039
     /* 1819039 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1819125), // Rule ID 12810 //
     /* 1819044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819090 */     // MIs[0] policy
     /* 1819090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819100 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1819103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819124 */     // GIR_Coverage, 12810,
     /* 1819124 */     GIR_EraseRootFromParent_Done,
     /* 1819125 */   // Label 24673: @1819125
     /* 1819125 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1819211), // Rule ID 12811 //
     /* 1819130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819176 */     // MIs[0] policy
     /* 1819176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1819189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819210 */     // GIR_Coverage, 12811,
     /* 1819210 */     GIR_EraseRootFromParent_Done,
     /* 1819211 */   // Label 24674: @1819211
     /* 1819211 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1819297), // Rule ID 12814 //
     /* 1819216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819262 */     // MIs[0] policy
     /* 1819262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1819275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819296 */     // GIR_Coverage, 12814,
     /* 1819296 */     GIR_EraseRootFromParent_Done,
     /* 1819297 */   // Label 24675: @1819297
     /* 1819297 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1819383), // Rule ID 12815 //
     /* 1819302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819348 */     // MIs[0] policy
     /* 1819348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819358 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1819361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819382 */     // GIR_Coverage, 12815,
     /* 1819382 */     GIR_EraseRootFromParent_Done,
     /* 1819383 */   // Label 24676: @1819383
     /* 1819383 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1819469), // Rule ID 12818 //
     /* 1819388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819434 */     // MIs[0] policy
     /* 1819434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819468 */     // GIR_Coverage, 12818,
     /* 1819468 */     GIR_EraseRootFromParent_Done,
     /* 1819469 */   // Label 24677: @1819469
     /* 1819469 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1819555), // Rule ID 12819 //
     /* 1819474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819520 */     // MIs[0] policy
     /* 1819520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819554 */     // GIR_Coverage, 12819,
     /* 1819554 */     GIR_EraseRootFromParent_Done,
     /* 1819555 */   // Label 24678: @1819555
     /* 1819555 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1819641), // Rule ID 12822 //
     /* 1819560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819606 */     // MIs[0] policy
     /* 1819606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819640 */     // GIR_Coverage, 12822,
     /* 1819640 */     GIR_EraseRootFromParent_Done,
     /* 1819641 */   // Label 24679: @1819641
     /* 1819641 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1819727), // Rule ID 12823 //
     /* 1819646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819692 */     // MIs[0] policy
     /* 1819692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819726 */     // GIR_Coverage, 12823,
     /* 1819726 */     GIR_EraseRootFromParent_Done,
     /* 1819727 */   // Label 24680: @1819727
     /* 1819727 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1819813), // Rule ID 12826 //
     /* 1819732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819778 */     // MIs[0] policy
     /* 1819778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819788 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819812 */     // GIR_Coverage, 12826,
     /* 1819812 */     GIR_EraseRootFromParent_Done,
     /* 1819813 */   // Label 24681: @1819813
     /* 1819813 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1819899), // Rule ID 12827 //
     /* 1819818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819864 */     // MIs[0] policy
     /* 1819864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819898 */     // GIR_Coverage, 12827,
     /* 1819898 */     GIR_EraseRootFromParent_Done,
     /* 1819899 */   // Label 24682: @1819899
     /* 1819899 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1819985), // Rule ID 12830 //
     /* 1819904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819950 */     // MIs[0] policy
     /* 1819950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819984 */     // GIR_Coverage, 12830,
     /* 1819984 */     GIR_EraseRootFromParent_Done,
     /* 1819985 */   // Label 24683: @1819985
     /* 1819985 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1820071), // Rule ID 12831 //
     /* 1819990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1820010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820036 */     // MIs[0] policy
     /* 1820036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1820049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820070 */     // GIR_Coverage, 12831,
     /* 1820070 */     GIR_EraseRootFromParent_Done,
     /* 1820071 */   // Label 24684: @1820071
     /* 1820071 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1820157), // Rule ID 12834 //
     /* 1820076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820122 */     // MIs[0] policy
     /* 1820122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820156 */     // GIR_Coverage, 12834,
     /* 1820156 */     GIR_EraseRootFromParent_Done,
     /* 1820157 */   // Label 24685: @1820157
     /* 1820157 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1820243), // Rule ID 12835 //
     /* 1820162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820208 */     // MIs[0] policy
     /* 1820208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820242 */     // GIR_Coverage, 12835,
     /* 1820242 */     GIR_EraseRootFromParent_Done,
     /* 1820243 */   // Label 24686: @1820243
     /* 1820243 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1820329), // Rule ID 12838 //
     /* 1820248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820294 */     // MIs[0] policy
     /* 1820294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820328 */     // GIR_Coverage, 12838,
     /* 1820328 */     GIR_EraseRootFromParent_Done,
     /* 1820329 */   // Label 24687: @1820329
     /* 1820329 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1820415), // Rule ID 12839 //
     /* 1820334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820380 */     // MIs[0] policy
     /* 1820380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1820393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820414 */     // GIR_Coverage, 12839,
     /* 1820414 */     GIR_EraseRootFromParent_Done,
     /* 1820415 */   // Label 24688: @1820415
     /* 1820415 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1820501), // Rule ID 12842 //
     /* 1820420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820466 */     // MIs[0] policy
     /* 1820466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820476 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820500 */     // GIR_Coverage, 12842,
     /* 1820500 */     GIR_EraseRootFromParent_Done,
     /* 1820501 */   // Label 24689: @1820501
     /* 1820501 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1820587), // Rule ID 12843 //
     /* 1820506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820552 */     // MIs[0] policy
     /* 1820552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820562 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820586 */     // GIR_Coverage, 12843,
     /* 1820586 */     GIR_EraseRootFromParent_Done,
     /* 1820587 */   // Label 24690: @1820587
     /* 1820587 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1820673), // Rule ID 12846 //
     /* 1820592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820638 */     // MIs[0] policy
     /* 1820638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820672 */     // GIR_Coverage, 12846,
     /* 1820672 */     GIR_EraseRootFromParent_Done,
     /* 1820673 */   // Label 24691: @1820673
     /* 1820673 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1820759), // Rule ID 12847 //
     /* 1820678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820724 */     // MIs[0] policy
     /* 1820724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820758 */     // GIR_Coverage, 12847,
     /* 1820758 */     GIR_EraseRootFromParent_Done,
     /* 1820759 */   // Label 24692: @1820759
     /* 1820759 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1820845), // Rule ID 12850 //
     /* 1820764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820810 */     // MIs[0] policy
     /* 1820810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820844 */     // GIR_Coverage, 12850,
     /* 1820844 */     GIR_EraseRootFromParent_Done,
     /* 1820845 */   // Label 24693: @1820845
     /* 1820845 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1820931), // Rule ID 12851 //
     /* 1820850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820896 */     // MIs[0] policy
     /* 1820896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820930 */     // GIR_Coverage, 12851,
     /* 1820930 */     GIR_EraseRootFromParent_Done,
     /* 1820931 */   // Label 24694: @1820931
     /* 1820931 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1821017), // Rule ID 12854 //
     /* 1820936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820982 */     // MIs[0] policy
     /* 1820982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821016 */     // GIR_Coverage, 12854,
     /* 1821016 */     GIR_EraseRootFromParent_Done,
     /* 1821017 */   // Label 24695: @1821017
     /* 1821017 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1821103), // Rule ID 12855 //
     /* 1821022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1821025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1821042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821068 */     // MIs[0] policy
     /* 1821068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1821081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821102 */     // GIR_Coverage, 12855,
     /* 1821102 */     GIR_EraseRootFromParent_Done,
     /* 1821103 */   // Label 24696: @1821103
     /* 1821103 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1821189), // Rule ID 12858 //
     /* 1821108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821154 */     // MIs[0] policy
     /* 1821154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821188 */     // GIR_Coverage, 12858,
     /* 1821188 */     GIR_EraseRootFromParent_Done,
     /* 1821189 */   // Label 24697: @1821189
     /* 1821189 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1821275), // Rule ID 12859 //
     /* 1821194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821240 */     // MIs[0] policy
     /* 1821240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821274 */     // GIR_Coverage, 12859,
     /* 1821274 */     GIR_EraseRootFromParent_Done,
     /* 1821275 */   // Label 24698: @1821275
     /* 1821275 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1821361), // Rule ID 12862 //
     /* 1821280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821326 */     // MIs[0] policy
     /* 1821326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821336 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821360 */     // GIR_Coverage, 12862,
     /* 1821360 */     GIR_EraseRootFromParent_Done,
     /* 1821361 */   // Label 24699: @1821361
     /* 1821361 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1821447), // Rule ID 12863 //
     /* 1821366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821412 */     // MIs[0] policy
     /* 1821412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821446 */     // GIR_Coverage, 12863,
     /* 1821446 */     GIR_EraseRootFromParent_Done,
     /* 1821447 */   // Label 24700: @1821447
     /* 1821447 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1821533), // Rule ID 12866 //
     /* 1821452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821498 */     // MIs[0] policy
     /* 1821498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821508 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821532 */     // GIR_Coverage, 12866,
     /* 1821532 */     GIR_EraseRootFromParent_Done,
     /* 1821533 */   // Label 24701: @1821533
     /* 1821533 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1821619), // Rule ID 12867 //
     /* 1821538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821584 */     // MIs[0] policy
     /* 1821584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821594 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821618 */     // GIR_Coverage, 12867,
     /* 1821618 */     GIR_EraseRootFromParent_Done,
     /* 1821619 */   // Label 24702: @1821619
     /* 1821619 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1821705), // Rule ID 12870 //
     /* 1821624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821670 */     // MIs[0] policy
     /* 1821670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821704 */     // GIR_Coverage, 12870,
     /* 1821704 */     GIR_EraseRootFromParent_Done,
     /* 1821705 */   // Label 24703: @1821705
     /* 1821705 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1821791), // Rule ID 12871 //
     /* 1821710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821756 */     // MIs[0] policy
     /* 1821756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821790 */     // GIR_Coverage, 12871,
     /* 1821790 */     GIR_EraseRootFromParent_Done,
     /* 1821791 */   // Label 24704: @1821791
     /* 1821791 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1821877), // Rule ID 12874 //
     /* 1821796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821842 */     // MIs[0] policy
     /* 1821842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821876 */     // GIR_Coverage, 12874,
     /* 1821876 */     GIR_EraseRootFromParent_Done,
     /* 1821877 */   // Label 24705: @1821877
     /* 1821877 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1821963), // Rule ID 12875 //
     /* 1821882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821928 */     // MIs[0] policy
     /* 1821928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821962 */     // GIR_Coverage, 12875,
     /* 1821962 */     GIR_EraseRootFromParent_Done,
     /* 1821963 */   // Label 24706: @1821963
     /* 1821963 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1822049), // Rule ID 12878 //
     /* 1821968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822014 */     // MIs[0] policy
     /* 1822014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822048 */     // GIR_Coverage, 12878,
     /* 1822048 */     GIR_EraseRootFromParent_Done,
     /* 1822049 */   // Label 24707: @1822049
     /* 1822049 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1822135), // Rule ID 12879 //
     /* 1822054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1822074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822100 */     // MIs[0] policy
     /* 1822100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822110 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822134 */     // GIR_Coverage, 12879,
     /* 1822134 */     GIR_EraseRootFromParent_Done,
     /* 1822135 */   // Label 24708: @1822135
     /* 1822135 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1822221), // Rule ID 12882 //
     /* 1822140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822186 */     // MIs[0] policy
     /* 1822186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822220 */     // GIR_Coverage, 12882,
     /* 1822220 */     GIR_EraseRootFromParent_Done,
     /* 1822221 */   // Label 24709: @1822221
     /* 1822221 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1822307), // Rule ID 12883 //
     /* 1822226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822272 */     // MIs[0] policy
     /* 1822272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822306 */     // GIR_Coverage, 12883,
     /* 1822306 */     GIR_EraseRootFromParent_Done,
     /* 1822307 */   // Label 24710: @1822307
     /* 1822307 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1822393), // Rule ID 12886 //
     /* 1822312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822358 */     // MIs[0] policy
     /* 1822358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822392 */     // GIR_Coverage, 12886,
     /* 1822392 */     GIR_EraseRootFromParent_Done,
     /* 1822393 */   // Label 24711: @1822393
     /* 1822393 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1822479), // Rule ID 12887 //
     /* 1822398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822444 */     // MIs[0] policy
     /* 1822444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822454 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822478 */     // GIR_Coverage, 12887,
     /* 1822478 */     GIR_EraseRootFromParent_Done,
     /* 1822479 */   // Label 24712: @1822479
     /* 1822479 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1822565), // Rule ID 12890 //
     /* 1822484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822530 */     // MIs[0] policy
     /* 1822530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822564 */     // GIR_Coverage, 12890,
     /* 1822564 */     GIR_EraseRootFromParent_Done,
     /* 1822565 */   // Label 24713: @1822565
     /* 1822565 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1822651), // Rule ID 12891 //
     /* 1822570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822616 */     // MIs[0] policy
     /* 1822616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822650 */     // GIR_Coverage, 12891,
     /* 1822650 */     GIR_EraseRootFromParent_Done,
     /* 1822651 */   // Label 24714: @1822651
     /* 1822651 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1822737), // Rule ID 12894 //
     /* 1822656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822702 */     // MIs[0] policy
     /* 1822702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822736 */     // GIR_Coverage, 12894,
     /* 1822736 */     GIR_EraseRootFromParent_Done,
     /* 1822737 */   // Label 24715: @1822737
     /* 1822737 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1822823), // Rule ID 12895 //
     /* 1822742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822788 */     // MIs[0] policy
     /* 1822788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822822 */     // GIR_Coverage, 12895,
     /* 1822822 */     GIR_EraseRootFromParent_Done,
     /* 1822823 */   // Label 24716: @1822823
     /* 1822823 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1822909), // Rule ID 12898 //
     /* 1822828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822874 */     // MIs[0] policy
     /* 1822874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822908 */     // GIR_Coverage, 12898,
     /* 1822908 */     GIR_EraseRootFromParent_Done,
     /* 1822909 */   // Label 24717: @1822909
     /* 1822909 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1822995), // Rule ID 12899 //
     /* 1822914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822960 */     // MIs[0] policy
     /* 1822960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822994 */     // GIR_Coverage, 12899,
     /* 1822994 */     GIR_EraseRootFromParent_Done,
     /* 1822995 */   // Label 24718: @1822995
     /* 1822995 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1823081), // Rule ID 12902 //
     /* 1823000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823046 */     // MIs[0] policy
     /* 1823046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1823059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823080 */     // GIR_Coverage, 12902,
     /* 1823080 */     GIR_EraseRootFromParent_Done,
     /* 1823081 */   // Label 24719: @1823081
     /* 1823081 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1823167), // Rule ID 12903 //
     /* 1823086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1823094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823132 */     // MIs[0] policy
     /* 1823132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1823145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823166 */     // GIR_Coverage, 12903,
     /* 1823166 */     GIR_EraseRootFromParent_Done,
     /* 1823167 */   // Label 24720: @1823167
     /* 1823167 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1823253), // Rule ID 12906 //
     /* 1823172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823218 */     // MIs[0] policy
     /* 1823218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823228 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1823231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823252 */     // GIR_Coverage, 12906,
     /* 1823252 */     GIR_EraseRootFromParent_Done,
     /* 1823253 */   // Label 24721: @1823253
     /* 1823253 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1823339), // Rule ID 12907 //
     /* 1823258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823304 */     // MIs[0] policy
     /* 1823304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823314 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1823317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823338 */     // GIR_Coverage, 12907,
     /* 1823338 */     GIR_EraseRootFromParent_Done,
     /* 1823339 */   // Label 24722: @1823339
     /* 1823339 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1823425), // Rule ID 12910 //
     /* 1823344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823390 */     // MIs[0] policy
     /* 1823390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823424 */     // GIR_Coverage, 12910,
     /* 1823424 */     GIR_EraseRootFromParent_Done,
     /* 1823425 */   // Label 24723: @1823425
     /* 1823425 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1823511), // Rule ID 12911 //
     /* 1823430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823476 */     // MIs[0] policy
     /* 1823476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823510 */     // GIR_Coverage, 12911,
     /* 1823510 */     GIR_EraseRootFromParent_Done,
     /* 1823511 */   // Label 24724: @1823511
     /* 1823511 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1823597), // Rule ID 12914 //
     /* 1823516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823562 */     // MIs[0] policy
     /* 1823562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823572 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823596 */     // GIR_Coverage, 12914,
     /* 1823596 */     GIR_EraseRootFromParent_Done,
     /* 1823597 */   // Label 24725: @1823597
     /* 1823597 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1823683), // Rule ID 12915 //
     /* 1823602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823648 */     // MIs[0] policy
     /* 1823648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823682 */     // GIR_Coverage, 12915,
     /* 1823682 */     GIR_EraseRootFromParent_Done,
     /* 1823683 */   // Label 24726: @1823683
     /* 1823683 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1823769), // Rule ID 12918 //
     /* 1823688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823734 */     // MIs[0] policy
     /* 1823734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823768 */     // GIR_Coverage, 12918,
     /* 1823768 */     GIR_EraseRootFromParent_Done,
     /* 1823769 */   // Label 24727: @1823769
     /* 1823769 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1823855), // Rule ID 12919 //
     /* 1823774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823820 */     // MIs[0] policy
     /* 1823820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823854 */     // GIR_Coverage, 12919,
     /* 1823854 */     GIR_EraseRootFromParent_Done,
     /* 1823855 */   // Label 24728: @1823855
     /* 1823855 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1823941), // Rule ID 12922 //
     /* 1823860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823906 */     // MIs[0] policy
     /* 1823906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823940 */     // GIR_Coverage, 12922,
     /* 1823940 */     GIR_EraseRootFromParent_Done,
     /* 1823941 */   // Label 24729: @1823941
     /* 1823941 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1824027), // Rule ID 12923 //
     /* 1823946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823992 */     // MIs[0] policy
     /* 1823992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824026 */     // GIR_Coverage, 12923,
     /* 1824026 */     GIR_EraseRootFromParent_Done,
     /* 1824027 */   // Label 24730: @1824027
     /* 1824027 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1824113), // Rule ID 12926 //
     /* 1824032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824078 */     // MIs[0] policy
     /* 1824078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824112 */     // GIR_Coverage, 12926,
     /* 1824112 */     GIR_EraseRootFromParent_Done,
     /* 1824113 */   // Label 24731: @1824113
     /* 1824113 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1824199), // Rule ID 12927 //
     /* 1824118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824164 */     // MIs[0] policy
     /* 1824164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1824177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824198 */     // GIR_Coverage, 12927,
     /* 1824198 */     GIR_EraseRootFromParent_Done,
     /* 1824199 */   // Label 24732: @1824199
     /* 1824199 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1824285), // Rule ID 12930 //
     /* 1824204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824250 */     // MIs[0] policy
     /* 1824250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824260 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824284 */     // GIR_Coverage, 12930,
     /* 1824284 */     GIR_EraseRootFromParent_Done,
     /* 1824285 */   // Label 24733: @1824285
     /* 1824285 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1824371), // Rule ID 12931 //
     /* 1824290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824336 */     // MIs[0] policy
     /* 1824336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824370 */     // GIR_Coverage, 12931,
     /* 1824370 */     GIR_EraseRootFromParent_Done,
     /* 1824371 */   // Label 24734: @1824371
     /* 1824371 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1824457), // Rule ID 12934 //
     /* 1824376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824422 */     // MIs[0] policy
     /* 1824422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824456 */     // GIR_Coverage, 12934,
     /* 1824456 */     GIR_EraseRootFromParent_Done,
     /* 1824457 */   // Label 24735: @1824457
     /* 1824457 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1824543), // Rule ID 12935 //
     /* 1824462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824508 */     // MIs[0] policy
     /* 1824508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824542 */     // GIR_Coverage, 12935,
     /* 1824542 */     GIR_EraseRootFromParent_Done,
     /* 1824543 */   // Label 24736: @1824543
     /* 1824543 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1824629), // Rule ID 12938 //
     /* 1824548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824594 */     // MIs[0] policy
     /* 1824594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824628 */     // GIR_Coverage, 12938,
     /* 1824628 */     GIR_EraseRootFromParent_Done,
     /* 1824629 */   // Label 24737: @1824629
     /* 1824629 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1824715), // Rule ID 12939 //
     /* 1824634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824680 */     // MIs[0] policy
     /* 1824680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824714 */     // GIR_Coverage, 12939,
     /* 1824714 */     GIR_EraseRootFromParent_Done,
     /* 1824715 */   // Label 24738: @1824715
     /* 1824715 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1824801), // Rule ID 12942 //
     /* 1824720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824766 */     // MIs[0] policy
     /* 1824766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824800 */     // GIR_Coverage, 12942,
     /* 1824800 */     GIR_EraseRootFromParent_Done,
     /* 1824801 */   // Label 24739: @1824801
     /* 1824801 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1824887), // Rule ID 12943 //
     /* 1824806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824852 */     // MIs[0] policy
     /* 1824852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824886 */     // GIR_Coverage, 12943,
     /* 1824886 */     GIR_EraseRootFromParent_Done,
     /* 1824887 */   // Label 24740: @1824887
     /* 1824887 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1824973), // Rule ID 12946 //
     /* 1824892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824938 */     // MIs[0] policy
     /* 1824938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824972 */     // GIR_Coverage, 12946,
     /* 1824972 */     GIR_EraseRootFromParent_Done,
     /* 1824973 */   // Label 24741: @1824973
     /* 1824973 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1825059), // Rule ID 12947 //
     /* 1824978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825024 */     // MIs[0] policy
     /* 1825024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825058 */     // GIR_Coverage, 12947,
     /* 1825058 */     GIR_EraseRootFromParent_Done,
     /* 1825059 */   // Label 24742: @1825059
     /* 1825059 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1825145), // Rule ID 12950 //
     /* 1825064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825110 */     // MIs[0] policy
     /* 1825110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825120 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825144 */     // GIR_Coverage, 12950,
     /* 1825144 */     GIR_EraseRootFromParent_Done,
     /* 1825145 */   // Label 24743: @1825145
     /* 1825145 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1825231), // Rule ID 12951 //
     /* 1825150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825196 */     // MIs[0] policy
     /* 1825196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825206 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825230 */     // GIR_Coverage, 12951,
     /* 1825230 */     GIR_EraseRootFromParent_Done,
     /* 1825231 */   // Label 24744: @1825231
     /* 1825231 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1825317), // Rule ID 12954 //
     /* 1825236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825282 */     // MIs[0] policy
     /* 1825282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825292 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825316 */     // GIR_Coverage, 12954,
     /* 1825316 */     GIR_EraseRootFromParent_Done,
     /* 1825317 */   // Label 24745: @1825317
     /* 1825317 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1825403), // Rule ID 12955 //
     /* 1825322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825368 */     // MIs[0] policy
     /* 1825368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825402 */     // GIR_Coverage, 12955,
     /* 1825402 */     GIR_EraseRootFromParent_Done,
     /* 1825403 */   // Label 24746: @1825403
     /* 1825403 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1825489), // Rule ID 12958 //
     /* 1825408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825454 */     // MIs[0] policy
     /* 1825454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825488 */     // GIR_Coverage, 12958,
     /* 1825488 */     GIR_EraseRootFromParent_Done,
     /* 1825489 */   // Label 24747: @1825489
     /* 1825489 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1825575), // Rule ID 12959 //
     /* 1825494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825540 */     // MIs[0] policy
     /* 1825540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825574 */     // GIR_Coverage, 12959,
     /* 1825574 */     GIR_EraseRootFromParent_Done,
     /* 1825575 */   // Label 24748: @1825575
     /* 1825575 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1825661), // Rule ID 12962 //
     /* 1825580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825626 */     // MIs[0] policy
     /* 1825626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825660 */     // GIR_Coverage, 12962,
     /* 1825660 */     GIR_EraseRootFromParent_Done,
     /* 1825661 */   // Label 24749: @1825661
     /* 1825661 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1825747), // Rule ID 12963 //
     /* 1825666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825712 */     // MIs[0] policy
     /* 1825712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825746 */     // GIR_Coverage, 12963,
     /* 1825746 */     GIR_EraseRootFromParent_Done,
     /* 1825747 */   // Label 24750: @1825747
     /* 1825747 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1825833), // Rule ID 12966 //
     /* 1825752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825798 */     // MIs[0] policy
     /* 1825798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825808 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825832 */     // GIR_Coverage, 12966,
     /* 1825832 */     GIR_EraseRootFromParent_Done,
     /* 1825833 */   // Label 24751: @1825833
     /* 1825833 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1825919), // Rule ID 12967 //
     /* 1825838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825884 */     // MIs[0] policy
     /* 1825884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825918 */     // GIR_Coverage, 12967,
     /* 1825918 */     GIR_EraseRootFromParent_Done,
     /* 1825919 */   // Label 24752: @1825919
     /* 1825919 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1826005), // Rule ID 12970 //
     /* 1825924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825970 */     // MIs[0] policy
     /* 1825970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826004 */     // GIR_Coverage, 12970,
     /* 1826004 */     GIR_EraseRootFromParent_Done,
     /* 1826005 */   // Label 24753: @1826005
     /* 1826005 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1826091), // Rule ID 12971 //
     /* 1826010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1826030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826056 */     // MIs[0] policy
     /* 1826056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826090 */     // GIR_Coverage, 12971,
     /* 1826090 */     GIR_EraseRootFromParent_Done,
     /* 1826091 */   // Label 24754: @1826091
     /* 1826091 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1826177), // Rule ID 12974 //
     /* 1826096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826142 */     // MIs[0] policy
     /* 1826142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826176 */     // GIR_Coverage, 12974,
     /* 1826176 */     GIR_EraseRootFromParent_Done,
     /* 1826177 */   // Label 24755: @1826177
     /* 1826177 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1826263), // Rule ID 12975 //
     /* 1826182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826228 */     // MIs[0] policy
     /* 1826228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826262 */     // GIR_Coverage, 12975,
     /* 1826262 */     GIR_EraseRootFromParent_Done,
     /* 1826263 */   // Label 24756: @1826263
     /* 1826263 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1826349), // Rule ID 12978 //
     /* 1826268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826314 */     // MIs[0] policy
     /* 1826314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826324 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826348 */     // GIR_Coverage, 12978,
     /* 1826348 */     GIR_EraseRootFromParent_Done,
     /* 1826349 */   // Label 24757: @1826349
     /* 1826349 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1826435), // Rule ID 12979 //
     /* 1826354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826400 */     // MIs[0] policy
     /* 1826400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826434 */     // GIR_Coverage, 12979,
     /* 1826434 */     GIR_EraseRootFromParent_Done,
     /* 1826435 */   // Label 24758: @1826435
     /* 1826435 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1826521), // Rule ID 12982 //
     /* 1826440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826486 */     // MIs[0] policy
     /* 1826486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826520 */     // GIR_Coverage, 12982,
     /* 1826520 */     GIR_EraseRootFromParent_Done,
     /* 1826521 */   // Label 24759: @1826521
     /* 1826521 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1826607), // Rule ID 12983 //
     /* 1826526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826572 */     // MIs[0] policy
     /* 1826572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826606 */     // GIR_Coverage, 12983,
     /* 1826606 */     GIR_EraseRootFromParent_Done,
     /* 1826607 */   // Label 24760: @1826607
     /* 1826607 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1826693), // Rule ID 12986 //
     /* 1826612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826658 */     // MIs[0] policy
     /* 1826658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826668 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826692 */     // GIR_Coverage, 12986,
     /* 1826692 */     GIR_EraseRootFromParent_Done,
     /* 1826693 */   // Label 24761: @1826693
     /* 1826693 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1826779), // Rule ID 12987 //
     /* 1826698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826744 */     // MIs[0] policy
     /* 1826744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826754 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826778 */     // GIR_Coverage, 12987,
     /* 1826778 */     GIR_EraseRootFromParent_Done,
     /* 1826779 */   // Label 24762: @1826779
     /* 1826779 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1826865), // Rule ID 12990 //
     /* 1826784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826830 */     // MIs[0] policy
     /* 1826830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826864 */     // GIR_Coverage, 12990,
     /* 1826864 */     GIR_EraseRootFromParent_Done,
     /* 1826865 */   // Label 24763: @1826865
     /* 1826865 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1826951), // Rule ID 12991 //
     /* 1826870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826916 */     // MIs[0] policy
     /* 1826916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826950 */     // GIR_Coverage, 12991,
     /* 1826950 */     GIR_EraseRootFromParent_Done,
     /* 1826951 */   // Label 24764: @1826951
     /* 1826951 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1827037), // Rule ID 12994 //
     /* 1826956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827002 */     // MIs[0] policy
     /* 1827002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827012 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1827015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827036 */     // GIR_Coverage, 12994,
     /* 1827036 */     GIR_EraseRootFromParent_Done,
     /* 1827037 */   // Label 24765: @1827037
     /* 1827037 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1827123), // Rule ID 12995 //
     /* 1827042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1827062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827088 */     // MIs[0] policy
     /* 1827088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1827101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827122 */     // GIR_Coverage, 12995,
     /* 1827122 */     GIR_EraseRootFromParent_Done,
     /* 1827123 */   // Label 24766: @1827123
     /* 1827123 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1827209), // Rule ID 12998 //
     /* 1827128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827174 */     // MIs[0] policy
     /* 1827174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827208 */     // GIR_Coverage, 12998,
     /* 1827208 */     GIR_EraseRootFromParent_Done,
     /* 1827209 */   // Label 24767: @1827209
     /* 1827209 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1827295), // Rule ID 12999 //
     /* 1827214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827260 */     // MIs[0] policy
     /* 1827260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827294 */     // GIR_Coverage, 12999,
     /* 1827294 */     GIR_EraseRootFromParent_Done,
     /* 1827295 */   // Label 24768: @1827295
     /* 1827295 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1827381), // Rule ID 13002 //
     /* 1827300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827346 */     // MIs[0] policy
     /* 1827346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827380 */     // GIR_Coverage, 13002,
     /* 1827380 */     GIR_EraseRootFromParent_Done,
     /* 1827381 */   // Label 24769: @1827381
     /* 1827381 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1827467), // Rule ID 13003 //
     /* 1827386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827432 */     // MIs[0] policy
     /* 1827432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827442 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827466 */     // GIR_Coverage, 13003,
     /* 1827466 */     GIR_EraseRootFromParent_Done,
     /* 1827467 */   // Label 24770: @1827467
     /* 1827467 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1827553), // Rule ID 13006 //
     /* 1827472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827518 */     // MIs[0] policy
     /* 1827518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827552 */     // GIR_Coverage, 13006,
     /* 1827552 */     GIR_EraseRootFromParent_Done,
     /* 1827553 */   // Label 24771: @1827553
     /* 1827553 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1827639), // Rule ID 13007 //
     /* 1827558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827604 */     // MIs[0] policy
     /* 1827604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827638 */     // GIR_Coverage, 13007,
     /* 1827638 */     GIR_EraseRootFromParent_Done,
     /* 1827639 */   // Label 24772: @1827639
     /* 1827639 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1827725), // Rule ID 13010 //
     /* 1827644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827690 */     // MIs[0] policy
     /* 1827690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827724 */     // GIR_Coverage, 13010,
     /* 1827724 */     GIR_EraseRootFromParent_Done,
     /* 1827725 */   // Label 24773: @1827725
     /* 1827725 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1827811), // Rule ID 13011 //
     /* 1827730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827776 */     // MIs[0] policy
     /* 1827776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827810 */     // GIR_Coverage, 13011,
     /* 1827810 */     GIR_EraseRootFromParent_Done,
     /* 1827811 */   // Label 24774: @1827811
     /* 1827811 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1827897), // Rule ID 13014 //
     /* 1827816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827862 */     // MIs[0] policy
     /* 1827862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827896 */     // GIR_Coverage, 13014,
     /* 1827896 */     GIR_EraseRootFromParent_Done,
     /* 1827897 */   // Label 24775: @1827897
     /* 1827897 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1827983), // Rule ID 13015 //
     /* 1827902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827948 */     // MIs[0] policy
     /* 1827948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827982 */     // GIR_Coverage, 13015,
     /* 1827982 */     GIR_EraseRootFromParent_Done,
     /* 1827983 */   // Label 24776: @1827983
     /* 1827983 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1828069), // Rule ID 13018 //
     /* 1827988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828034 */     // MIs[0] policy
     /* 1828034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828068 */     // GIR_Coverage, 13018,
     /* 1828068 */     GIR_EraseRootFromParent_Done,
     /* 1828069 */   // Label 24777: @1828069
     /* 1828069 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1828155), // Rule ID 13019 //
     /* 1828074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828120 */     // MIs[0] policy
     /* 1828120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828154 */     // GIR_Coverage, 13019,
     /* 1828154 */     GIR_EraseRootFromParent_Done,
     /* 1828155 */   // Label 24778: @1828155
     /* 1828155 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1828241), // Rule ID 13022 //
     /* 1828160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828206 */     // MIs[0] policy
     /* 1828206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828240 */     // GIR_Coverage, 13022,
     /* 1828240 */     GIR_EraseRootFromParent_Done,
     /* 1828241 */   // Label 24779: @1828241
     /* 1828241 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1828327), // Rule ID 13023 //
     /* 1828246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828292 */     // MIs[0] policy
     /* 1828292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828326 */     // GIR_Coverage, 13023,
     /* 1828326 */     GIR_EraseRootFromParent_Done,
     /* 1828327 */   // Label 24780: @1828327
     /* 1828327 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1828413), // Rule ID 13026 //
     /* 1828332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828378 */     // MIs[0] policy
     /* 1828378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828412 */     // GIR_Coverage, 13026,
     /* 1828412 */     GIR_EraseRootFromParent_Done,
     /* 1828413 */   // Label 24781: @1828413
     /* 1828413 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1828499), // Rule ID 13027 //
     /* 1828418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828464 */     // MIs[0] policy
     /* 1828464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828498 */     // GIR_Coverage, 13027,
     /* 1828498 */     GIR_EraseRootFromParent_Done,
     /* 1828499 */   // Label 24782: @1828499
     /* 1828499 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1828585), // Rule ID 13030 //
     /* 1828504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1828507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828550 */     // MIs[0] policy
     /* 1828550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828584 */     // GIR_Coverage, 13030,
     /* 1828584 */     GIR_EraseRootFromParent_Done,
     /* 1828585 */   // Label 24783: @1828585
     /* 1828585 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1828671), // Rule ID 13031 //
     /* 1828590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1828593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828636 */     // MIs[0] policy
     /* 1828636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828670 */     // GIR_Coverage, 13031,
     /* 1828670 */     GIR_EraseRootFromParent_Done,
     /* 1828671 */   // Label 24784: @1828671
     /* 1828671 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1828757), // Rule ID 13034 //
     /* 1828676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828722 */     // MIs[0] policy
     /* 1828722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828756 */     // GIR_Coverage, 13034,
     /* 1828756 */     GIR_EraseRootFromParent_Done,
     /* 1828757 */   // Label 24785: @1828757
     /* 1828757 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1828843), // Rule ID 13035 //
     /* 1828762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828808 */     // MIs[0] policy
     /* 1828808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828842 */     // GIR_Coverage, 13035,
     /* 1828842 */     GIR_EraseRootFromParent_Done,
     /* 1828843 */   // Label 24786: @1828843
     /* 1828843 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1828929), // Rule ID 13038 //
     /* 1828848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828894 */     // MIs[0] policy
     /* 1828894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828904 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828928 */     // GIR_Coverage, 13038,
     /* 1828928 */     GIR_EraseRootFromParent_Done,
     /* 1828929 */   // Label 24787: @1828929
     /* 1828929 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1829015), // Rule ID 13039 //
     /* 1828934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828980 */     // MIs[0] policy
     /* 1828980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829014 */     // GIR_Coverage, 13039,
     /* 1829014 */     GIR_EraseRootFromParent_Done,
     /* 1829015 */   // Label 24788: @1829015
     /* 1829015 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1829101), // Rule ID 13042 //
     /* 1829020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829066 */     // MIs[0] policy
     /* 1829066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829076 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829100 */     // GIR_Coverage, 13042,
     /* 1829100 */     GIR_EraseRootFromParent_Done,
     /* 1829101 */   // Label 24789: @1829101
     /* 1829101 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1829187), // Rule ID 13043 //
     /* 1829106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829152 */     // MIs[0] policy
     /* 1829152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829186 */     // GIR_Coverage, 13043,
     /* 1829186 */     GIR_EraseRootFromParent_Done,
     /* 1829187 */   // Label 24790: @1829187
     /* 1829187 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1829273), // Rule ID 13046 //
     /* 1829192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829238 */     // MIs[0] policy
     /* 1829238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829272 */     // GIR_Coverage, 13046,
     /* 1829272 */     GIR_EraseRootFromParent_Done,
     /* 1829273 */   // Label 24791: @1829273
     /* 1829273 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1829359), // Rule ID 13047 //
     /* 1829278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829324 */     // MIs[0] policy
     /* 1829324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829358 */     // GIR_Coverage, 13047,
     /* 1829358 */     GIR_EraseRootFromParent_Done,
     /* 1829359 */   // Label 24792: @1829359
     /* 1829359 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1829445), // Rule ID 13050 //
     /* 1829364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829410 */     // MIs[0] policy
     /* 1829410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829420 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829444 */     // GIR_Coverage, 13050,
     /* 1829444 */     GIR_EraseRootFromParent_Done,
     /* 1829445 */   // Label 24793: @1829445
     /* 1829445 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1829531), // Rule ID 13051 //
     /* 1829450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829496 */     // MIs[0] policy
     /* 1829496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829530 */     // GIR_Coverage, 13051,
     /* 1829530 */     GIR_EraseRootFromParent_Done,
     /* 1829531 */   // Label 24794: @1829531
     /* 1829531 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1829617), // Rule ID 13054 //
     /* 1829536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829582 */     // MIs[0] policy
     /* 1829582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829592 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829616 */     // GIR_Coverage, 13054,
     /* 1829616 */     GIR_EraseRootFromParent_Done,
     /* 1829617 */   // Label 24795: @1829617
     /* 1829617 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1829703), // Rule ID 13055 //
     /* 1829622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829668 */     // MIs[0] policy
     /* 1829668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829702 */     // GIR_Coverage, 13055,
     /* 1829702 */     GIR_EraseRootFromParent_Done,
     /* 1829703 */   // Label 24796: @1829703
     /* 1829703 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1829789), // Rule ID 13058 //
     /* 1829708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829754 */     // MIs[0] policy
     /* 1829754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829788 */     // GIR_Coverage, 13058,
     /* 1829788 */     GIR_EraseRootFromParent_Done,
     /* 1829789 */   // Label 24797: @1829789
     /* 1829789 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1829875), // Rule ID 13059 //
     /* 1829794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829840 */     // MIs[0] policy
     /* 1829840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829874 */     // GIR_Coverage, 13059,
     /* 1829874 */     GIR_EraseRootFromParent_Done,
     /* 1829875 */   // Label 24798: @1829875
     /* 1829875 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1829961), // Rule ID 13062 //
     /* 1829880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829926 */     // MIs[0] policy
     /* 1829926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829960 */     // GIR_Coverage, 13062,
     /* 1829960 */     GIR_EraseRootFromParent_Done,
     /* 1829961 */   // Label 24799: @1829961
     /* 1829961 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1830047), // Rule ID 13063 //
     /* 1829966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830012 */     // MIs[0] policy
     /* 1830012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830046 */     // GIR_Coverage, 13063,
     /* 1830046 */     GIR_EraseRootFromParent_Done,
     /* 1830047 */   // Label 24800: @1830047
     /* 1830047 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1830133), // Rule ID 13066 //
     /* 1830052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830098 */     // MIs[0] policy
     /* 1830098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830132 */     // GIR_Coverage, 13066,
     /* 1830132 */     GIR_EraseRootFromParent_Done,
     /* 1830133 */   // Label 24801: @1830133
     /* 1830133 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1830219), // Rule ID 13067 //
     /* 1830138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830184 */     // MIs[0] policy
     /* 1830184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830218 */     // GIR_Coverage, 13067,
     /* 1830218 */     GIR_EraseRootFromParent_Done,
     /* 1830219 */   // Label 24802: @1830219
     /* 1830219 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1830305), // Rule ID 13070 //
     /* 1830224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830270 */     // MIs[0] policy
     /* 1830270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1830283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830304 */     // GIR_Coverage, 13070,
     /* 1830304 */     GIR_EraseRootFromParent_Done,
     /* 1830305 */   // Label 24803: @1830305
     /* 1830305 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1830391), // Rule ID 13071 //
     /* 1830310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830356 */     // MIs[0] policy
     /* 1830356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1830369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830390 */     // GIR_Coverage, 13071,
     /* 1830390 */     GIR_EraseRootFromParent_Done,
     /* 1830391 */   // Label 24804: @1830391
     /* 1830391 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1830477), // Rule ID 13074 //
     /* 1830396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830442 */     // MIs[0] policy
     /* 1830442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830476 */     // GIR_Coverage, 13074,
     /* 1830476 */     GIR_EraseRootFromParent_Done,
     /* 1830477 */   // Label 24805: @1830477
     /* 1830477 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1830563), // Rule ID 13075 //
     /* 1830482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830528 */     // MIs[0] policy
     /* 1830528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830562 */     // GIR_Coverage, 13075,
     /* 1830562 */     GIR_EraseRootFromParent_Done,
     /* 1830563 */   // Label 24806: @1830563
     /* 1830563 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1830649), // Rule ID 13078 //
     /* 1830568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830614 */     // MIs[0] policy
     /* 1830614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830648 */     // GIR_Coverage, 13078,
     /* 1830648 */     GIR_EraseRootFromParent_Done,
     /* 1830649 */   // Label 24807: @1830649
     /* 1830649 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1830735), // Rule ID 13079 //
     /* 1830654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830700 */     // MIs[0] policy
     /* 1830700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830734 */     // GIR_Coverage, 13079,
     /* 1830734 */     GIR_EraseRootFromParent_Done,
     /* 1830735 */   // Label 24808: @1830735
     /* 1830735 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1830821), // Rule ID 13082 //
     /* 1830740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830786 */     // MIs[0] policy
     /* 1830786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830820 */     // GIR_Coverage, 13082,
     /* 1830820 */     GIR_EraseRootFromParent_Done,
     /* 1830821 */   // Label 24809: @1830821
     /* 1830821 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1830907), // Rule ID 13083 //
     /* 1830826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830872 */     // MIs[0] policy
     /* 1830872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830906 */     // GIR_Coverage, 13083,
     /* 1830906 */     GIR_EraseRootFromParent_Done,
     /* 1830907 */   // Label 24810: @1830907
     /* 1830907 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1830993), // Rule ID 13086 //
     /* 1830912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830958 */     // MIs[0] policy
     /* 1830958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830992 */     // GIR_Coverage, 13086,
     /* 1830992 */     GIR_EraseRootFromParent_Done,
     /* 1830993 */   // Label 24811: @1830993
     /* 1830993 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1831079), // Rule ID 13087 //
     /* 1830998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1831018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831044 */     // MIs[0] policy
     /* 1831044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831078 */     // GIR_Coverage, 13087,
     /* 1831078 */     GIR_EraseRootFromParent_Done,
     /* 1831079 */   // Label 24812: @1831079
     /* 1831079 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1831165), // Rule ID 13090 //
     /* 1831084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831130 */     // MIs[0] policy
     /* 1831130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831164 */     // GIR_Coverage, 13090,
     /* 1831164 */     GIR_EraseRootFromParent_Done,
     /* 1831165 */   // Label 24813: @1831165
     /* 1831165 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1831251), // Rule ID 13091 //
     /* 1831170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831216 */     // MIs[0] policy
     /* 1831216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831250 */     // GIR_Coverage, 13091,
     /* 1831250 */     GIR_EraseRootFromParent_Done,
     /* 1831251 */   // Label 24814: @1831251
     /* 1831251 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1831337), // Rule ID 13094 //
     /* 1831256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831302 */     // MIs[0] policy
     /* 1831302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831312 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831336 */     // GIR_Coverage, 13094,
     /* 1831336 */     GIR_EraseRootFromParent_Done,
     /* 1831337 */   // Label 24815: @1831337
     /* 1831337 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1831423), // Rule ID 13095 //
     /* 1831342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831388 */     // MIs[0] policy
     /* 1831388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1831401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831422 */     // GIR_Coverage, 13095,
     /* 1831422 */     GIR_EraseRootFromParent_Done,
     /* 1831423 */   // Label 24816: @1831423
     /* 1831423 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1831509), // Rule ID 13098 //
     /* 1831428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831474 */     // MIs[0] policy
     /* 1831474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831484 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831508 */     // GIR_Coverage, 13098,
     /* 1831508 */     GIR_EraseRootFromParent_Done,
     /* 1831509 */   // Label 24817: @1831509
     /* 1831509 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1831595), // Rule ID 13099 //
     /* 1831514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831560 */     // MIs[0] policy
     /* 1831560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831594 */     // GIR_Coverage, 13099,
     /* 1831594 */     GIR_EraseRootFromParent_Done,
     /* 1831595 */   // Label 24818: @1831595
     /* 1831595 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1831681), // Rule ID 13102 //
     /* 1831600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831646 */     // MIs[0] policy
     /* 1831646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831680 */     // GIR_Coverage, 13102,
     /* 1831680 */     GIR_EraseRootFromParent_Done,
     /* 1831681 */   // Label 24819: @1831681
     /* 1831681 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1831767), // Rule ID 13103 //
     /* 1831686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831732 */     // MIs[0] policy
     /* 1831732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831766 */     // GIR_Coverage, 13103,
     /* 1831766 */     GIR_EraseRootFromParent_Done,
     /* 1831767 */   // Label 24820: @1831767
     /* 1831767 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1831853), // Rule ID 13106 //
     /* 1831772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831818 */     // MIs[0] policy
     /* 1831818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831852 */     // GIR_Coverage, 13106,
     /* 1831852 */     GIR_EraseRootFromParent_Done,
     /* 1831853 */   // Label 24821: @1831853
     /* 1831853 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1831939), // Rule ID 13107 //
     /* 1831858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831904 */     // MIs[0] policy
     /* 1831904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831938 */     // GIR_Coverage, 13107,
     /* 1831938 */     GIR_EraseRootFromParent_Done,
     /* 1831939 */   // Label 24822: @1831939
     /* 1831939 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1832025), // Rule ID 13110 //
     /* 1831944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831990 */     // MIs[0] policy
     /* 1831990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832024 */     // GIR_Coverage, 13110,
     /* 1832024 */     GIR_EraseRootFromParent_Done,
     /* 1832025 */   // Label 24823: @1832025
     /* 1832025 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1832111), // Rule ID 13111 //
     /* 1832030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1832050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832076 */     // MIs[0] policy
     /* 1832076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832110 */     // GIR_Coverage, 13111,
     /* 1832110 */     GIR_EraseRootFromParent_Done,
     /* 1832111 */   // Label 24824: @1832111
     /* 1832111 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1832197), // Rule ID 13114 //
     /* 1832116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832162 */     // MIs[0] policy
     /* 1832162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832196 */     // GIR_Coverage, 13114,
     /* 1832196 */     GIR_EraseRootFromParent_Done,
     /* 1832197 */   // Label 24825: @1832197
     /* 1832197 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1832283), // Rule ID 13115 //
     /* 1832202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832248 */     // MIs[0] policy
     /* 1832248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832282 */     // GIR_Coverage, 13115,
     /* 1832282 */     GIR_EraseRootFromParent_Done,
     /* 1832283 */   // Label 24826: @1832283
     /* 1832283 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1832369), // Rule ID 13118 //
     /* 1832288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1832291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832334 */     // MIs[0] policy
     /* 1832334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832368 */     // GIR_Coverage, 13118,
     /* 1832368 */     GIR_EraseRootFromParent_Done,
     /* 1832369 */   // Label 24827: @1832369
     /* 1832369 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1832455), // Rule ID 13119 //
     /* 1832374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1832377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832420 */     // MIs[0] policy
     /* 1832420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1832433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832454 */     // GIR_Coverage, 13119,
     /* 1832454 */     GIR_EraseRootFromParent_Done,
     /* 1832455 */   // Label 24828: @1832455
     /* 1832455 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1832541), // Rule ID 13122 //
     /* 1832460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832506 */     // MIs[0] policy
     /* 1832506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832540 */     // GIR_Coverage, 13122,
     /* 1832540 */     GIR_EraseRootFromParent_Done,
     /* 1832541 */   // Label 24829: @1832541
     /* 1832541 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1832627), // Rule ID 13123 //
     /* 1832546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832592 */     // MIs[0] policy
     /* 1832592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832626 */     // GIR_Coverage, 13123,
     /* 1832626 */     GIR_EraseRootFromParent_Done,
     /* 1832627 */   // Label 24830: @1832627
     /* 1832627 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1832713), // Rule ID 13126 //
     /* 1832632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832678 */     // MIs[0] policy
     /* 1832678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832688 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832712 */     // GIR_Coverage, 13126,
     /* 1832712 */     GIR_EraseRootFromParent_Done,
     /* 1832713 */   // Label 24831: @1832713
     /* 1832713 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1832799), // Rule ID 13127 //
     /* 1832718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832764 */     // MIs[0] policy
     /* 1832764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832798 */     // GIR_Coverage, 13127,
     /* 1832798 */     GIR_EraseRootFromParent_Done,
     /* 1832799 */   // Label 24832: @1832799
     /* 1832799 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1832885), // Rule ID 13130 //
     /* 1832804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832850 */     // MIs[0] policy
     /* 1832850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832884 */     // GIR_Coverage, 13130,
     /* 1832884 */     GIR_EraseRootFromParent_Done,
     /* 1832885 */   // Label 24833: @1832885
     /* 1832885 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1832971), // Rule ID 13131 //
     /* 1832890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832936 */     // MIs[0] policy
     /* 1832936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832970 */     // GIR_Coverage, 13131,
     /* 1832970 */     GIR_EraseRootFromParent_Done,
     /* 1832971 */   // Label 24834: @1832971
     /* 1832971 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1833057), // Rule ID 13134 //
     /* 1832976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1832993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833022 */     // MIs[0] policy
     /* 1833022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833056 */     // GIR_Coverage, 13134,
     /* 1833056 */     GIR_EraseRootFromParent_Done,
     /* 1833057 */   // Label 24835: @1833057
     /* 1833057 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1833143), // Rule ID 13135 //
     /* 1833062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1833082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833108 */     // MIs[0] policy
     /* 1833108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833142 */     // GIR_Coverage, 13135,
     /* 1833142 */     GIR_EraseRootFromParent_Done,
     /* 1833143 */   // Label 24836: @1833143
     /* 1833143 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1833229), // Rule ID 13138 //
     /* 1833148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833194 */     // MIs[0] policy
     /* 1833194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833204 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833228 */     // GIR_Coverage, 13138,
     /* 1833228 */     GIR_EraseRootFromParent_Done,
     /* 1833229 */   // Label 24837: @1833229
     /* 1833229 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1833315), // Rule ID 13139 //
     /* 1833234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833280 */     // MIs[0] policy
     /* 1833280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833314 */     // GIR_Coverage, 13139,
     /* 1833314 */     GIR_EraseRootFromParent_Done,
     /* 1833315 */   // Label 24838: @1833315
     /* 1833315 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1833401), // Rule ID 13142 //
     /* 1833320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833366 */     // MIs[0] policy
     /* 1833366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833400 */     // GIR_Coverage, 13142,
     /* 1833400 */     GIR_EraseRootFromParent_Done,
     /* 1833401 */   // Label 24839: @1833401
     /* 1833401 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1833487), // Rule ID 13143 //
     /* 1833406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833452 */     // MIs[0] policy
     /* 1833452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833486 */     // GIR_Coverage, 13143,
     /* 1833486 */     GIR_EraseRootFromParent_Done,
     /* 1833487 */   // Label 24840: @1833487
     /* 1833487 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1833573), // Rule ID 13146 //
     /* 1833492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833538 */     // MIs[0] policy
     /* 1833538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833572 */     // GIR_Coverage, 13146,
     /* 1833572 */     GIR_EraseRootFromParent_Done,
     /* 1833573 */   // Label 24841: @1833573
     /* 1833573 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1833659), // Rule ID 13147 //
     /* 1833578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833624 */     // MIs[0] policy
     /* 1833624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833658 */     // GIR_Coverage, 13147,
     /* 1833658 */     GIR_EraseRootFromParent_Done,
     /* 1833659 */   // Label 24842: @1833659
     /* 1833659 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1833745), // Rule ID 13150 //
     /* 1833664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833710 */     // MIs[0] policy
     /* 1833710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833720 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833744 */     // GIR_Coverage, 13150,
     /* 1833744 */     GIR_EraseRootFromParent_Done,
     /* 1833745 */   // Label 24843: @1833745
     /* 1833745 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1833831), // Rule ID 13151 //
     /* 1833750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833796 */     // MIs[0] policy
     /* 1833796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833830 */     // GIR_Coverage, 13151,
     /* 1833830 */     GIR_EraseRootFromParent_Done,
     /* 1833831 */   // Label 24844: @1833831
     /* 1833831 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1833917), // Rule ID 13154 //
     /* 1833836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833882 */     // MIs[0] policy
     /* 1833882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833916 */     // GIR_Coverage, 13154,
     /* 1833916 */     GIR_EraseRootFromParent_Done,
     /* 1833917 */   // Label 24845: @1833917
     /* 1833917 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1834003), // Rule ID 13155 //
     /* 1833922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833968 */     // MIs[0] policy
     /* 1833968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834002 */     // GIR_Coverage, 13155,
     /* 1834002 */     GIR_EraseRootFromParent_Done,
     /* 1834003 */   // Label 24846: @1834003
     /* 1834003 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1834089), // Rule ID 13158 //
     /* 1834008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834054 */     // MIs[0] policy
     /* 1834054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1834067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834088 */     // GIR_Coverage, 13158,
     /* 1834088 */     GIR_EraseRootFromParent_Done,
     /* 1834089 */   // Label 24847: @1834089
     /* 1834089 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1834175), // Rule ID 13159 //
     /* 1834094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834140 */     // MIs[0] policy
     /* 1834140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1834153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834174 */     // GIR_Coverage, 13159,
     /* 1834174 */     GIR_EraseRootFromParent_Done,
     /* 1834175 */   // Label 24848: @1834175
     /* 1834175 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1834261), // Rule ID 13162 //
     /* 1834180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834226 */     // MIs[0] policy
     /* 1834226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1834239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834260 */     // GIR_Coverage, 13162,
     /* 1834260 */     GIR_EraseRootFromParent_Done,
     /* 1834261 */   // Label 24849: @1834261
     /* 1834261 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1834347), // Rule ID 13163 //
     /* 1834266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834312 */     // MIs[0] policy
     /* 1834312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1834325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834346 */     // GIR_Coverage, 13163,
     /* 1834346 */     GIR_EraseRootFromParent_Done,
     /* 1834347 */   // Label 24850: @1834347
     /* 1834347 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1834433), // Rule ID 13166 //
     /* 1834352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834398 */     // MIs[0] policy
     /* 1834398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834432 */     // GIR_Coverage, 13166,
     /* 1834432 */     GIR_EraseRootFromParent_Done,
     /* 1834433 */   // Label 24851: @1834433
     /* 1834433 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1834519), // Rule ID 13167 //
     /* 1834438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834484 */     // MIs[0] policy
     /* 1834484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834518 */     // GIR_Coverage, 13167,
     /* 1834518 */     GIR_EraseRootFromParent_Done,
     /* 1834519 */   // Label 24852: @1834519
     /* 1834519 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1834605), // Rule ID 13170 //
     /* 1834524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834570 */     // MIs[0] policy
     /* 1834570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834580 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834604 */     // GIR_Coverage, 13170,
     /* 1834604 */     GIR_EraseRootFromParent_Done,
     /* 1834605 */   // Label 24853: @1834605
     /* 1834605 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1834691), // Rule ID 13171 //
     /* 1834610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834656 */     // MIs[0] policy
     /* 1834656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834690 */     // GIR_Coverage, 13171,
     /* 1834690 */     GIR_EraseRootFromParent_Done,
     /* 1834691 */   // Label 24854: @1834691
     /* 1834691 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1834777), // Rule ID 13174 //
     /* 1834696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834742 */     // MIs[0] policy
     /* 1834742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834752 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834776 */     // GIR_Coverage, 13174,
     /* 1834776 */     GIR_EraseRootFromParent_Done,
     /* 1834777 */   // Label 24855: @1834777
     /* 1834777 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1834863), // Rule ID 13175 //
     /* 1834782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834828 */     // MIs[0] policy
     /* 1834828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834862 */     // GIR_Coverage, 13175,
     /* 1834862 */     GIR_EraseRootFromParent_Done,
     /* 1834863 */   // Label 24856: @1834863
     /* 1834863 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1834949), // Rule ID 13178 //
     /* 1834868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834914 */     // MIs[0] policy
     /* 1834914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834948 */     // GIR_Coverage, 13178,
     /* 1834948 */     GIR_EraseRootFromParent_Done,
     /* 1834949 */   // Label 24857: @1834949
     /* 1834949 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1835035), // Rule ID 13179 //
     /* 1834954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835000 */     // MIs[0] policy
     /* 1835000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835034 */     // GIR_Coverage, 13179,
     /* 1835034 */     GIR_EraseRootFromParent_Done,
     /* 1835035 */   // Label 24858: @1835035
     /* 1835035 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1835121), // Rule ID 13182 //
     /* 1835040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835086 */     // MIs[0] policy
     /* 1835086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1835099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835120 */     // GIR_Coverage, 13182,
     /* 1835120 */     GIR_EraseRootFromParent_Done,
     /* 1835121 */   // Label 24859: @1835121
     /* 1835121 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1835207), // Rule ID 13183 //
     /* 1835126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835172 */     // MIs[0] policy
     /* 1835172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1835185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835206 */     // GIR_Coverage, 13183,
     /* 1835206 */     GIR_EraseRootFromParent_Done,
     /* 1835207 */   // Label 24860: @1835207
     /* 1835207 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1835293), // Rule ID 13186 //
     /* 1835212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835258 */     // MIs[0] policy
     /* 1835258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835292 */     // GIR_Coverage, 13186,
     /* 1835292 */     GIR_EraseRootFromParent_Done,
     /* 1835293 */   // Label 24861: @1835293
     /* 1835293 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1835379), // Rule ID 13187 //
     /* 1835298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835344 */     // MIs[0] policy
     /* 1835344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835378 */     // GIR_Coverage, 13187,
     /* 1835378 */     GIR_EraseRootFromParent_Done,
     /* 1835379 */   // Label 24862: @1835379
     /* 1835379 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1835465), // Rule ID 13190 //
     /* 1835384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835430 */     // MIs[0] policy
     /* 1835430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835464 */     // GIR_Coverage, 13190,
     /* 1835464 */     GIR_EraseRootFromParent_Done,
     /* 1835465 */   // Label 24863: @1835465
     /* 1835465 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1835551), // Rule ID 13191 //
     /* 1835470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835516 */     // MIs[0] policy
     /* 1835516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835550 */     // GIR_Coverage, 13191,
     /* 1835550 */     GIR_EraseRootFromParent_Done,
     /* 1835551 */   // Label 24864: @1835551
     /* 1835551 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1835637), // Rule ID 13194 //
     /* 1835556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835602 */     // MIs[0] policy
     /* 1835602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835636 */     // GIR_Coverage, 13194,
     /* 1835636 */     GIR_EraseRootFromParent_Done,
     /* 1835637 */   // Label 24865: @1835637
     /* 1835637 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1835723), // Rule ID 13195 //
     /* 1835642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835688 */     // MIs[0] policy
     /* 1835688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835722 */     // GIR_Coverage, 13195,
     /* 1835722 */     GIR_EraseRootFromParent_Done,
     /* 1835723 */   // Label 24866: @1835723
     /* 1835723 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1835809), // Rule ID 13198 //
     /* 1835728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835774 */     // MIs[0] policy
     /* 1835774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835808 */     // GIR_Coverage, 13198,
     /* 1835808 */     GIR_EraseRootFromParent_Done,
     /* 1835809 */   // Label 24867: @1835809
     /* 1835809 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1835895), // Rule ID 13199 //
     /* 1835814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835860 */     // MIs[0] policy
     /* 1835860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835894 */     // GIR_Coverage, 13199,
     /* 1835894 */     GIR_EraseRootFromParent_Done,
     /* 1835895 */   // Label 24868: @1835895
     /* 1835895 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1835981), // Rule ID 13202 //
     /* 1835900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835946 */     // MIs[0] policy
     /* 1835946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835980 */     // GIR_Coverage, 13202,
     /* 1835980 */     GIR_EraseRootFromParent_Done,
     /* 1835981 */   // Label 24869: @1835981
     /* 1835981 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1836067), // Rule ID 13203 //
     /* 1835986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1836006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836032 */     // MIs[0] policy
     /* 1836032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836066 */     // GIR_Coverage, 13203,
     /* 1836066 */     GIR_EraseRootFromParent_Done,
     /* 1836067 */   // Label 24870: @1836067
     /* 1836067 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1836153), // Rule ID 13206 //
     /* 1836072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1836075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836118 */     // MIs[0] policy
     /* 1836118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836152 */     // GIR_Coverage, 13206,
     /* 1836152 */     GIR_EraseRootFromParent_Done,
     /* 1836153 */   // Label 24871: @1836153
     /* 1836153 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1836239), // Rule ID 13207 //
     /* 1836158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1836161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836204 */     // MIs[0] policy
     /* 1836204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1836217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836238 */     // GIR_Coverage, 13207,
     /* 1836238 */     GIR_EraseRootFromParent_Done,
     /* 1836239 */   // Label 24872: @1836239
     /* 1836239 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1836325), // Rule ID 13210 //
     /* 1836244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836290 */     // MIs[0] policy
     /* 1836290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836324 */     // GIR_Coverage, 13210,
     /* 1836324 */     GIR_EraseRootFromParent_Done,
     /* 1836325 */   // Label 24873: @1836325
     /* 1836325 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1836411), // Rule ID 13211 //
     /* 1836330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836376 */     // MIs[0] policy
     /* 1836376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836410 */     // GIR_Coverage, 13211,
     /* 1836410 */     GIR_EraseRootFromParent_Done,
     /* 1836411 */   // Label 24874: @1836411
     /* 1836411 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1836497), // Rule ID 13214 //
     /* 1836416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836462 */     // MIs[0] policy
     /* 1836462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836472 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836496 */     // GIR_Coverage, 13214,
     /* 1836496 */     GIR_EraseRootFromParent_Done,
     /* 1836497 */   // Label 24875: @1836497
     /* 1836497 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1836583), // Rule ID 13215 //
     /* 1836502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836548 */     // MIs[0] policy
     /* 1836548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836582 */     // GIR_Coverage, 13215,
     /* 1836582 */     GIR_EraseRootFromParent_Done,
     /* 1836583 */   // Label 24876: @1836583
     /* 1836583 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1836669), // Rule ID 13218 //
     /* 1836588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836634 */     // MIs[0] policy
     /* 1836634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836668 */     // GIR_Coverage, 13218,
     /* 1836668 */     GIR_EraseRootFromParent_Done,
     /* 1836669 */   // Label 24877: @1836669
     /* 1836669 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1836755), // Rule ID 13219 //
     /* 1836674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836720 */     // MIs[0] policy
     /* 1836720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836730 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836754 */     // GIR_Coverage, 13219,
     /* 1836754 */     GIR_EraseRootFromParent_Done,
     /* 1836755 */   // Label 24878: @1836755
     /* 1836755 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1836841), // Rule ID 13222 //
     /* 1836760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836806 */     // MIs[0] policy
     /* 1836806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836840 */     // GIR_Coverage, 13222,
     /* 1836840 */     GIR_EraseRootFromParent_Done,
     /* 1836841 */   // Label 24879: @1836841
     /* 1836841 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1836927), // Rule ID 13223 //
     /* 1836846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836892 */     // MIs[0] policy
     /* 1836892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836926 */     // GIR_Coverage, 13223,
     /* 1836926 */     GIR_EraseRootFromParent_Done,
     /* 1836927 */   // Label 24880: @1836927
     /* 1836927 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1837013), // Rule ID 13226 //
     /* 1836932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836978 */     // MIs[0] policy
     /* 1836978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837012 */     // GIR_Coverage, 13226,
     /* 1837012 */     GIR_EraseRootFromParent_Done,
     /* 1837013 */   // Label 24881: @1837013
     /* 1837013 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1837099), // Rule ID 13227 //
     /* 1837018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1837029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1837032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1837038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837064 */     // MIs[0] policy
     /* 1837064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837098 */     // GIR_Coverage, 13227,
     /* 1837098 */     GIR_EraseRootFromParent_Done,
     /* 1837099 */   // Label 24882: @1837099
     /* 1837099 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1837185), // Rule ID 13230 //
     /* 1837104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837150 */     // MIs[0] policy
     /* 1837150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837160 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837184 */     // GIR_Coverage, 13230,
     /* 1837184 */     GIR_EraseRootFromParent_Done,
     /* 1837185 */   // Label 24883: @1837185
     /* 1837185 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1837271), // Rule ID 13231 //
     /* 1837190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837236 */     // MIs[0] policy
     /* 1837236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837270 */     // GIR_Coverage, 13231,
     /* 1837270 */     GIR_EraseRootFromParent_Done,
     /* 1837271 */   // Label 24884: @1837271
     /* 1837271 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1837357), // Rule ID 13234 //
     /* 1837276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837322 */     // MIs[0] policy
     /* 1837322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837356 */     // GIR_Coverage, 13234,
     /* 1837356 */     GIR_EraseRootFromParent_Done,
     /* 1837357 */   // Label 24885: @1837357
     /* 1837357 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1837443), // Rule ID 13235 //
     /* 1837362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837408 */     // MIs[0] policy
     /* 1837408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837442 */     // GIR_Coverage, 13235,
     /* 1837442 */     GIR_EraseRootFromParent_Done,
     /* 1837443 */   // Label 24886: @1837443
     /* 1837443 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1837529), // Rule ID 13238 //
     /* 1837448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837494 */     // MIs[0] policy
     /* 1837494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837504 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837528 */     // GIR_Coverage, 13238,
     /* 1837528 */     GIR_EraseRootFromParent_Done,
     /* 1837529 */   // Label 24887: @1837529
     /* 1837529 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1837615), // Rule ID 13239 //
     /* 1837534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837580 */     // MIs[0] policy
     /* 1837580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837614 */     // GIR_Coverage, 13239,
     /* 1837614 */     GIR_EraseRootFromParent_Done,
     /* 1837615 */   // Label 24888: @1837615
     /* 1837615 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1837701), // Rule ID 13242 //
     /* 1837620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837666 */     // MIs[0] policy
     /* 1837666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837700 */     // GIR_Coverage, 13242,
     /* 1837700 */     GIR_EraseRootFromParent_Done,
     /* 1837701 */   // Label 24889: @1837701
     /* 1837701 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1837787), // Rule ID 13243 //
     /* 1837706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837752 */     // MIs[0] policy
     /* 1837752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837762 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837786 */     // GIR_Coverage, 13243,
     /* 1837786 */     GIR_EraseRootFromParent_Done,
     /* 1837787 */   // Label 24890: @1837787
     /* 1837787 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1837873), // Rule ID 13246 //
     /* 1837792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837838 */     // MIs[0] policy
     /* 1837838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837872 */     // GIR_Coverage, 13246,
     /* 1837872 */     GIR_EraseRootFromParent_Done,
     /* 1837873 */   // Label 24891: @1837873
     /* 1837873 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1837959), // Rule ID 13247 //
     /* 1837878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837924 */     // MIs[0] policy
     /* 1837924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837958 */     // GIR_Coverage, 13247,
     /* 1837958 */     GIR_EraseRootFromParent_Done,
     /* 1837959 */   // Label 24892: @1837959
     /* 1837959 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1838045), // Rule ID 13250 //
     /* 1837964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838010 */     // MIs[0] policy
     /* 1838010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1838023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838044 */     // GIR_Coverage, 13250,
     /* 1838044 */     GIR_EraseRootFromParent_Done,
     /* 1838045 */   // Label 24893: @1838045
     /* 1838045 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1838131), // Rule ID 13251 //
     /* 1838050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1838061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1838064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1838070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838096 */     // MIs[0] policy
     /* 1838096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1838109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838130 */     // GIR_Coverage, 13251,
     /* 1838130 */     GIR_EraseRootFromParent_Done,
     /* 1838131 */   // Label 24894: @1838131
     /* 1838131 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1838217), // Rule ID 13254 //
     /* 1838136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838182 */     // MIs[0] policy
     /* 1838182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1838195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838216 */     // GIR_Coverage, 13254,
     /* 1838216 */     GIR_EraseRootFromParent_Done,
     /* 1838217 */   // Label 24895: @1838217
     /* 1838217 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1838303), // Rule ID 13255 //
     /* 1838222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1838230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838268 */     // MIs[0] policy
     /* 1838268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1838281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838302 */     // GIR_Coverage, 13255,
     /* 1838302 */     GIR_EraseRootFromParent_Done,
     /* 1838303 */   // Label 24896: @1838303
     /* 1838303 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1838389), // Rule ID 13258 //
     /* 1838308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1838319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1838322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838354 */     // MIs[0] policy
     /* 1838354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1838367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838388 */     // GIR_Coverage, 13258,
     /* 1838388 */     GIR_EraseRootFromParent_Done,
     /* 1838389 */   // Label 24897: @1838389
     /* 1838389 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1838475), // Rule ID 13259 //
     /* 1838394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1838405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1838408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838440 */     // MIs[0] policy
     /* 1838440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1838453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838474 */     // GIR_Coverage, 13259,
     /* 1838474 */     GIR_EraseRootFromParent_Done,
     /* 1838475 */   // Label 24898: @1838475
     /* 1838475 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1838561), // Rule ID 13262 //
     /* 1838480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838526 */     // MIs[0] policy
     /* 1838526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838560 */     // GIR_Coverage, 13262,
     /* 1838560 */     GIR_EraseRootFromParent_Done,
     /* 1838561 */   // Label 24899: @1838561
     /* 1838561 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1838647), // Rule ID 13263 //
     /* 1838566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838612 */     // MIs[0] policy
     /* 1838612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838646 */     // GIR_Coverage, 13263,
     /* 1838646 */     GIR_EraseRootFromParent_Done,
     /* 1838647 */   // Label 24900: @1838647
     /* 1838647 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1838733), // Rule ID 13266 //
     /* 1838652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838698 */     // MIs[0] policy
     /* 1838698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838732 */     // GIR_Coverage, 13266,
     /* 1838732 */     GIR_EraseRootFromParent_Done,
     /* 1838733 */   // Label 24901: @1838733
     /* 1838733 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1838819), // Rule ID 13267 //
     /* 1838738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838784 */     // MIs[0] policy
     /* 1838784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838818 */     // GIR_Coverage, 13267,
     /* 1838818 */     GIR_EraseRootFromParent_Done,
     /* 1838819 */   // Label 24902: @1838819
     /* 1838819 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1838905), // Rule ID 13270 //
     /* 1838824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838870 */     // MIs[0] policy
     /* 1838870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838904 */     // GIR_Coverage, 13270,
     /* 1838904 */     GIR_EraseRootFromParent_Done,
     /* 1838905 */   // Label 24903: @1838905
     /* 1838905 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1838991), // Rule ID 13271 //
     /* 1838910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838956 */     // MIs[0] policy
     /* 1838956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838990 */     // GIR_Coverage, 13271,
     /* 1838990 */     GIR_EraseRootFromParent_Done,
     /* 1838991 */   // Label 24904: @1838991
     /* 1838991 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1839077), // Rule ID 13274 //
     /* 1838996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1839013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1839016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839042 */     // MIs[0] policy
     /* 1839042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839076 */     // GIR_Coverage, 13274,
     /* 1839076 */     GIR_EraseRootFromParent_Done,
     /* 1839077 */   // Label 24905: @1839077
     /* 1839077 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1839163), // Rule ID 13275 //
     /* 1839082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1839099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1839102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839128 */     // MIs[0] policy
     /* 1839128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839162 */     // GIR_Coverage, 13275,
     /* 1839162 */     GIR_EraseRootFromParent_Done,
     /* 1839163 */   // Label 24906: @1839163
     /* 1839163 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1839249), // Rule ID 13278 //
     /* 1839168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1839185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1839188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839214 */     // MIs[0] policy
     /* 1839214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839224 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839248 */     // GIR_Coverage, 13278,
     /* 1839248 */     GIR_EraseRootFromParent_Done,
     /* 1839249 */   // Label 24907: @1839249
     /* 1839249 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1839335), // Rule ID 13279 //
     /* 1839254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1839271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1839274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839300 */     // MIs[0] policy
     /* 1839300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1839313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839334 */     // GIR_Coverage, 13279,
     /* 1839334 */     GIR_EraseRootFromParent_Done,
     /* 1839335 */   // Label 24908: @1839335
     /* 1839335 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1839421), // Rule ID 13282 //
     /* 1839340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1839351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1839354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839386 */     // MIs[0] policy
     /* 1839386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839420 */     // GIR_Coverage, 13282,
     /* 1839420 */     GIR_EraseRootFromParent_Done,
     /* 1839421 */   // Label 24909: @1839421
     /* 1839421 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1839507), // Rule ID 13283 //
     /* 1839426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1839437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1839440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839472 */     // MIs[0] policy
     /* 1839472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839506 */     // GIR_Coverage, 13283,
     /* 1839506 */     GIR_EraseRootFromParent_Done,
     /* 1839507 */   // Label 24910: @1839507
     /* 1839507 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1839593), // Rule ID 13286 //
     /* 1839512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839558 */     // MIs[0] policy
     /* 1839558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839592 */     // GIR_Coverage, 13286,
     /* 1839592 */     GIR_EraseRootFromParent_Done,
     /* 1839593 */   // Label 24911: @1839593
     /* 1839593 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1839679), // Rule ID 13287 //
     /* 1839598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839644 */     // MIs[0] policy
     /* 1839644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839678 */     // GIR_Coverage, 13287,
     /* 1839678 */     GIR_EraseRootFromParent_Done,
     /* 1839679 */   // Label 24912: @1839679
     /* 1839679 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1839765), // Rule ID 13290 //
     /* 1839684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839730 */     // MIs[0] policy
     /* 1839730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839764 */     // GIR_Coverage, 13290,
     /* 1839764 */     GIR_EraseRootFromParent_Done,
     /* 1839765 */   // Label 24913: @1839765
     /* 1839765 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1839851), // Rule ID 13291 //
     /* 1839770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839816 */     // MIs[0] policy
     /* 1839816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839850 */     // GIR_Coverage, 13291,
     /* 1839850 */     GIR_EraseRootFromParent_Done,
     /* 1839851 */   // Label 24914: @1839851
     /* 1839851 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1839937), // Rule ID 13294 //
     /* 1839856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839902 */     // MIs[0] policy
     /* 1839902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839936 */     // GIR_Coverage, 13294,
     /* 1839936 */     GIR_EraseRootFromParent_Done,
     /* 1839937 */   // Label 24915: @1839937
     /* 1839937 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1840023), // Rule ID 13295 //
     /* 1839942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839988 */     // MIs[0] policy
     /* 1839988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1840001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1840019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840022 */     // GIR_Coverage, 13295,
     /* 1840022 */     GIR_EraseRootFromParent_Done,
     /* 1840023 */   // Label 24916: @1840023
     /* 1840023 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1840109), // Rule ID 13298 //
     /* 1840028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1840039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1840042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1840045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1840048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840074 */     // MIs[0] policy
     /* 1840074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840108 */     // GIR_Coverage, 13298,
     /* 1840108 */     GIR_EraseRootFromParent_Done,
     /* 1840109 */   // Label 24917: @1840109
     /* 1840109 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1840195), // Rule ID 13299 //
     /* 1840114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1840125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1840128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1840131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1840134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840160 */     // MIs[0] policy
     /* 1840160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840194 */     // GIR_Coverage, 13299,
     /* 1840194 */     GIR_EraseRootFromParent_Done,
     /* 1840195 */   // Label 24918: @1840195
     /* 1840195 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1840281), // Rule ID 13302 //
     /* 1840200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1840211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1840214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1840217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1840220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840246 */     // MIs[0] policy
     /* 1840246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840256 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840280 */     // GIR_Coverage, 13302,
     /* 1840280 */     GIR_EraseRootFromParent_Done,
     /* 1840281 */   // Label 24919: @1840281
     /* 1840281 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1840367), // Rule ID 13303 //
     /* 1840286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1840297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1840300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1840303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1840306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840332 */     // MIs[0] policy
     /* 1840332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840366 */     // GIR_Coverage, 13303,
     /* 1840366 */     GIR_EraseRootFromParent_Done,
     /* 1840367 */   // Label 24920: @1840367
     /* 1840367 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1840453), // Rule ID 13306 //
     /* 1840372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840418 */     // MIs[0] policy
     /* 1840418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840428 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840452 */     // GIR_Coverage, 13306,
     /* 1840452 */     GIR_EraseRootFromParent_Done,
     /* 1840453 */   // Label 24921: @1840453
     /* 1840453 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1840539), // Rule ID 13307 //
     /* 1840458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840504 */     // MIs[0] policy
     /* 1840504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840538 */     // GIR_Coverage, 13307,
     /* 1840538 */     GIR_EraseRootFromParent_Done,
     /* 1840539 */   // Label 24922: @1840539
     /* 1840539 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1840625), // Rule ID 13310 //
     /* 1840544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840590 */     // MIs[0] policy
     /* 1840590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840624 */     // GIR_Coverage, 13310,
     /* 1840624 */     GIR_EraseRootFromParent_Done,
     /* 1840625 */   // Label 24923: @1840625
     /* 1840625 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1840711), // Rule ID 13311 //
     /* 1840630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840676 */     // MIs[0] policy
     /* 1840676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840710 */     // GIR_Coverage, 13311,
     /* 1840710 */     GIR_EraseRootFromParent_Done,
     /* 1840711 */   // Label 24924: @1840711
     /* 1840711 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1840797), // Rule ID 13314 //
     /* 1840716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840762 */     // MIs[0] policy
     /* 1840762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840772 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840796 */     // GIR_Coverage, 13314,
     /* 1840796 */     GIR_EraseRootFromParent_Done,
     /* 1840797 */   // Label 24925: @1840797
     /* 1840797 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1840883), // Rule ID 13315 //
     /* 1840802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840848 */     // MIs[0] policy
     /* 1840848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840882 */     // GIR_Coverage, 13315,
     /* 1840882 */     GIR_EraseRootFromParent_Done,
     /* 1840883 */   // Label 24926: @1840883
     /* 1840883 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1840969), // Rule ID 13318 //
     /* 1840888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840934 */     // MIs[0] policy
     /* 1840934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840968 */     // GIR_Coverage, 13318,
     /* 1840968 */     GIR_EraseRootFromParent_Done,
     /* 1840969 */   // Label 24927: @1840969
     /* 1840969 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1841055), // Rule ID 13319 //
     /* 1840974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841020 */     // MIs[0] policy
     /* 1841020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841054 */     // GIR_Coverage, 13319,
     /* 1841054 */     GIR_EraseRootFromParent_Done,
     /* 1841055 */   // Label 24928: @1841055
     /* 1841055 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1841141), // Rule ID 13322 //
     /* 1841060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1841071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1841074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841106 */     // MIs[0] policy
     /* 1841106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841140 */     // GIR_Coverage, 13322,
     /* 1841140 */     GIR_EraseRootFromParent_Done,
     /* 1841141 */   // Label 24929: @1841141
     /* 1841141 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1841227), // Rule ID 13323 //
     /* 1841146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1841157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1841160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841192 */     // MIs[0] policy
     /* 1841192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841226 */     // GIR_Coverage, 13323,
     /* 1841226 */     GIR_EraseRootFromParent_Done,
     /* 1841227 */   // Label 24930: @1841227
     /* 1841227 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1841313), // Rule ID 13326 //
     /* 1841232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1841243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1841246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841278 */     // MIs[0] policy
     /* 1841278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841288 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841312 */     // GIR_Coverage, 13326,
     /* 1841312 */     GIR_EraseRootFromParent_Done,
     /* 1841313 */   // Label 24931: @1841313
     /* 1841313 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1841399), // Rule ID 13327 //
     /* 1841318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1841329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1841332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841364 */     // MIs[0] policy
     /* 1841364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841398 */     // GIR_Coverage, 13327,
     /* 1841398 */     GIR_EraseRootFromParent_Done,
     /* 1841399 */   // Label 24932: @1841399
     /* 1841399 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1841485), // Rule ID 13330 //
     /* 1841404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841450 */     // MIs[0] policy
     /* 1841450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841484 */     // GIR_Coverage, 13330,
     /* 1841484 */     GIR_EraseRootFromParent_Done,
     /* 1841485 */   // Label 24933: @1841485
     /* 1841485 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1841571), // Rule ID 13331 //
     /* 1841490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841536 */     // MIs[0] policy
     /* 1841536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841570 */     // GIR_Coverage, 13331,
     /* 1841570 */     GIR_EraseRootFromParent_Done,
     /* 1841571 */   // Label 24934: @1841571
     /* 1841571 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1841657), // Rule ID 13334 //
     /* 1841576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841622 */     // MIs[0] policy
     /* 1841622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841656 */     // GIR_Coverage, 13334,
     /* 1841656 */     GIR_EraseRootFromParent_Done,
     /* 1841657 */   // Label 24935: @1841657
     /* 1841657 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1841743), // Rule ID 13335 //
     /* 1841662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841708 */     // MIs[0] policy
     /* 1841708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841742 */     // GIR_Coverage, 13335,
     /* 1841742 */     GIR_EraseRootFromParent_Done,
     /* 1841743 */   // Label 24936: @1841743
     /* 1841743 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1841829), // Rule ID 13338 //
     /* 1841748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841794 */     // MIs[0] policy
     /* 1841794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841804 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841828 */     // GIR_Coverage, 13338,
     /* 1841828 */     GIR_EraseRootFromParent_Done,
     /* 1841829 */   // Label 24937: @1841829
     /* 1841829 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1841915), // Rule ID 13339 //
     /* 1841834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841880 */     // MIs[0] policy
     /* 1841880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841914 */     // GIR_Coverage, 13339,
     /* 1841914 */     GIR_EraseRootFromParent_Done,
     /* 1841915 */   // Label 24938: @1841915
     /* 1841915 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1842001), // Rule ID 13342 //
     /* 1841920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841966 */     // MIs[0] policy
     /* 1841966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842000 */     // GIR_Coverage, 13342,
     /* 1842000 */     GIR_EraseRootFromParent_Done,
     /* 1842001 */   // Label 24939: @1842001
     /* 1842001 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1842087), // Rule ID 13343 //
     /* 1842006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1842009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1842017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1842020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1842023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1842026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842052 */     // MIs[0] policy
     /* 1842052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1842065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842086 */     // GIR_Coverage, 13343,
     /* 1842086 */     GIR_EraseRootFromParent_Done,
     /* 1842087 */   // Label 24940: @1842087
     /* 1842087 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1842173), // Rule ID 13346 //
     /* 1842092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1842103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1842106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1842112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842138 */     // MIs[0] policy
     /* 1842138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1842151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842172 */     // GIR_Coverage, 13346,
     /* 1842172 */     GIR_EraseRootFromParent_Done,
     /* 1842173 */   // Label 24941: @1842173
     /* 1842173 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1842259), // Rule ID 13347 //
     /* 1842178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1842189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1842192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1842198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842224 */     // MIs[0] policy
     /* 1842224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1842237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842258 */     // GIR_Coverage, 13347,
     /* 1842258 */     GIR_EraseRootFromParent_Done,
     /* 1842259 */   // Label 24942: @1842259
     /* 1842259 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1842345), // Rule ID 13350 //
     /* 1842264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1842275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1842278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1842284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842310 */     // MIs[0] policy
     /* 1842310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842344 */     // GIR_Coverage, 13350,
     /* 1842344 */     GIR_EraseRootFromParent_Done,
     /* 1842345 */   // Label 24943: @1842345
     /* 1842345 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1842431), // Rule ID 13351 //
     /* 1842350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1842361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1842364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1842370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842396 */     // MIs[0] policy
     /* 1842396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842406 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842430 */     // GIR_Coverage, 13351,
     /* 1842430 */     GIR_EraseRootFromParent_Done,
     /* 1842431 */   // Label 24944: @1842431
     /* 1842431 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1842517), // Rule ID 13354 //
     /* 1842436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842482 */     // MIs[0] policy
     /* 1842482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842516 */     // GIR_Coverage, 13354,
     /* 1842516 */     GIR_EraseRootFromParent_Done,
     /* 1842517 */   // Label 24945: @1842517
     /* 1842517 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1842603), // Rule ID 13355 //
     /* 1842522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842568 */     // MIs[0] policy
     /* 1842568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842602 */     // GIR_Coverage, 13355,
     /* 1842602 */     GIR_EraseRootFromParent_Done,
     /* 1842603 */   // Label 24946: @1842603
     /* 1842603 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1842689), // Rule ID 13358 //
     /* 1842608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842654 */     // MIs[0] policy
     /* 1842654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842688 */     // GIR_Coverage, 13358,
     /* 1842688 */     GIR_EraseRootFromParent_Done,
     /* 1842689 */   // Label 24947: @1842689
     /* 1842689 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1842775), // Rule ID 13359 //
     /* 1842694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842740 */     // MIs[0] policy
     /* 1842740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842750 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842774 */     // GIR_Coverage, 13359,
     /* 1842774 */     GIR_EraseRootFromParent_Done,
     /* 1842775 */   // Label 24948: @1842775
     /* 1842775 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1842861), // Rule ID 13362 //
     /* 1842780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842826 */     // MIs[0] policy
     /* 1842826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842860 */     // GIR_Coverage, 13362,
     /* 1842860 */     GIR_EraseRootFromParent_Done,
     /* 1842861 */   // Label 24949: @1842861
     /* 1842861 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1842947), // Rule ID 13363 //
     /* 1842866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842912 */     // MIs[0] policy
     /* 1842912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842946 */     // GIR_Coverage, 13363,
     /* 1842946 */     GIR_EraseRootFromParent_Done,
     /* 1842947 */   // Label 24950: @1842947
     /* 1842947 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1843033), // Rule ID 13366 //
     /* 1842952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842998 */     // MIs[0] policy
     /* 1842998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1843011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843032 */     // GIR_Coverage, 13366,
     /* 1843032 */     GIR_EraseRootFromParent_Done,
     /* 1843033 */   // Label 24951: @1843033
     /* 1843033 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1843119), // Rule ID 13367 //
     /* 1843038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1843049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1843052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1843058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843084 */     // MIs[0] policy
     /* 1843084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1843097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843118 */     // GIR_Coverage, 13367,
     /* 1843118 */     GIR_EraseRootFromParent_Done,
     /* 1843119 */   // Label 24952: @1843119
     /* 1843119 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1843205), // Rule ID 13370 //
     /* 1843124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1843135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1843138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843170 */     // MIs[0] policy
     /* 1843170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843180 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843204 */     // GIR_Coverage, 13370,
     /* 1843204 */     GIR_EraseRootFromParent_Done,
     /* 1843205 */   // Label 24953: @1843205
     /* 1843205 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1843291), // Rule ID 13371 //
     /* 1843210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1843221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1843224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843256 */     // MIs[0] policy
     /* 1843256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11544:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843290 */     // GIR_Coverage, 13371,
     /* 1843290 */     GIR_EraseRootFromParent_Done,
     /* 1843291 */   // Label 24954: @1843291
     /* 1843291 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1843377), // Rule ID 13374 //
     /* 1843296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1843316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843342 */     // MIs[0] policy
     /* 1843342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843376 */     // GIR_Coverage, 13374,
     /* 1843376 */     GIR_EraseRootFromParent_Done,
     /* 1843377 */   // Label 24955: @1843377
     /* 1843377 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1843463), // Rule ID 13375 //
     /* 1843382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1843402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843428 */     // MIs[0] policy
     /* 1843428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11544:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843462 */     // GIR_Coverage, 13375,
     /* 1843462 */     GIR_EraseRootFromParent_Done,
     /* 1843463 */   // Label 24956: @1843463
     /* 1843463 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1843549), // Rule ID 13378 //
     /* 1843468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843514 */     // MIs[0] policy
     /* 1843514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843548 */     // GIR_Coverage, 13378,
     /* 1843548 */     GIR_EraseRootFromParent_Done,
     /* 1843549 */   // Label 24957: @1843549
     /* 1843549 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1843635), // Rule ID 13379 //
     /* 1843554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843600 */     // MIs[0] policy
     /* 1843600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843634 */     // GIR_Coverage, 13379,
     /* 1843634 */     GIR_EraseRootFromParent_Done,
     /* 1843635 */   // Label 24958: @1843635
     /* 1843635 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1843721), // Rule ID 13382 //
     /* 1843640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843686 */     // MIs[0] policy
     /* 1843686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843720 */     // GIR_Coverage, 13382,
     /* 1843720 */     GIR_EraseRootFromParent_Done,
     /* 1843721 */   // Label 24959: @1843721
     /* 1843721 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1843807), // Rule ID 13383 //
     /* 1843726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843772 */     // MIs[0] policy
     /* 1843772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843806 */     // GIR_Coverage, 13383,
     /* 1843806 */     GIR_EraseRootFromParent_Done,
     /* 1843807 */   // Label 24960: @1843807
     /* 1843807 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1843893), // Rule ID 13386 //
     /* 1843812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843858 */     // MIs[0] policy
     /* 1843858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843868 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843892 */     // GIR_Coverage, 13386,
     /* 1843892 */     GIR_EraseRootFromParent_Done,
     /* 1843893 */   // Label 24961: @1843893
     /* 1843893 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1843979), // Rule ID 13387 //
     /* 1843898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843944 */     // MIs[0] policy
     /* 1843944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843978 */     // GIR_Coverage, 13387,
     /* 1843978 */     GIR_EraseRootFromParent_Done,
     /* 1843979 */   // Label 24962: @1843979
     /* 1843979 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1844065), // Rule ID 13390 //
     /* 1843984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844030 */     // MIs[0] policy
     /* 1844030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844040 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844064 */     // GIR_Coverage, 13390,
     /* 1844064 */     GIR_EraseRootFromParent_Done,
     /* 1844065 */   // Label 24963: @1844065
     /* 1844065 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1844151), // Rule ID 13391 //
     /* 1844070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1844081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1844084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844116 */     // MIs[0] policy
     /* 1844116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844150 */     // GIR_Coverage, 13391,
     /* 1844150 */     GIR_EraseRootFromParent_Done,
     /* 1844151 */   // Label 24964: @1844151
     /* 1844151 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1844237), // Rule ID 13394 //
     /* 1844156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1844167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1844170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1844176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1844179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844202 */     // MIs[0] policy
     /* 1844202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844236 */     // GIR_Coverage, 13394,
     /* 1844236 */     GIR_EraseRootFromParent_Done,
     /* 1844237 */   // Label 24965: @1844237
     /* 1844237 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1844323), // Rule ID 13395 //
     /* 1844242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1844253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1844256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1844262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1844265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844288 */     // MIs[0] policy
     /* 1844288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844298 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844322 */     // GIR_Coverage, 13395,
     /* 1844322 */     GIR_EraseRootFromParent_Done,
     /* 1844323 */   // Label 24966: @1844323
     /* 1844323 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1844409), // Rule ID 13398 //
     /* 1844328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844374 */     // MIs[0] policy
     /* 1844374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844408 */     // GIR_Coverage, 13398,
     /* 1844408 */     GIR_EraseRootFromParent_Done,
     /* 1844409 */   // Label 24967: @1844409
     /* 1844409 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1844495), // Rule ID 13399 //
     /* 1844414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844460 */     // MIs[0] policy
     /* 1844460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844494 */     // GIR_Coverage, 13399,
     /* 1844494 */     GIR_EraseRootFromParent_Done,
     /* 1844495 */   // Label 24968: @1844495
     /* 1844495 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1844581), // Rule ID 13402 //
     /* 1844500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844546 */     // MIs[0] policy
     /* 1844546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844580 */     // GIR_Coverage, 13402,
     /* 1844580 */     GIR_EraseRootFromParent_Done,
     /* 1844581 */   // Label 24969: @1844581
     /* 1844581 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1844667), // Rule ID 13403 //
     /* 1844586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844632 */     // MIs[0] policy
     /* 1844632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844666 */     // GIR_Coverage, 13403,
     /* 1844666 */     GIR_EraseRootFromParent_Done,
     /* 1844667 */   // Label 24970: @1844667
     /* 1844667 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1844753), // Rule ID 13406 //
     /* 1844672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844718 */     // MIs[0] policy
     /* 1844718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844752 */     // GIR_Coverage, 13406,
     /* 1844752 */     GIR_EraseRootFromParent_Done,
     /* 1844753 */   // Label 24971: @1844753
     /* 1844753 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1844839), // Rule ID 13407 //
     /* 1844758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844804 */     // MIs[0] policy
     /* 1844804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844838 */     // GIR_Coverage, 13407,
     /* 1844838 */     GIR_EraseRootFromParent_Done,
     /* 1844839 */   // Label 24972: @1844839
     /* 1844839 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1844925), // Rule ID 13410 //
     /* 1844844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844890 */     // MIs[0] policy
     /* 1844890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844924 */     // GIR_Coverage, 13410,
     /* 1844924 */     GIR_EraseRootFromParent_Done,
     /* 1844925 */   // Label 24973: @1844925
     /* 1844925 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1845011), // Rule ID 13411 //
     /* 1844930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844976 */     // MIs[0] policy
     /* 1844976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845010 */     // GIR_Coverage, 13411,
     /* 1845010 */     GIR_EraseRootFromParent_Done,
     /* 1845011 */   // Label 24974: @1845011
     /* 1845011 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1845097), // Rule ID 13414 //
     /* 1845016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845062 */     // MIs[0] policy
     /* 1845062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845096 */     // GIR_Coverage, 13414,
     /* 1845096 */     GIR_EraseRootFromParent_Done,
     /* 1845097 */   // Label 24975: @1845097
     /* 1845097 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1845183), // Rule ID 13415 //
     /* 1845102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845148 */     // MIs[0] policy
     /* 1845148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845182 */     // GIR_Coverage, 13415,
     /* 1845182 */     GIR_EraseRootFromParent_Done,
     /* 1845183 */   // Label 24976: @1845183
     /* 1845183 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1845269), // Rule ID 13418 //
     /* 1845188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1845208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845234 */     // MIs[0] policy
     /* 1845234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845268 */     // GIR_Coverage, 13418,
     /* 1845268 */     GIR_EraseRootFromParent_Done,
     /* 1845269 */   // Label 24977: @1845269
     /* 1845269 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1845355), // Rule ID 13419 //
     /* 1845274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1845294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845320 */     // MIs[0] policy
     /* 1845320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845354 */     // GIR_Coverage, 13419,
     /* 1845354 */     GIR_EraseRootFromParent_Done,
     /* 1845355 */   // Label 24978: @1845355
     /* 1845355 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1845441), // Rule ID 13422 //
     /* 1845360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845406 */     // MIs[0] policy
     /* 1845406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845440 */     // GIR_Coverage, 13422,
     /* 1845440 */     GIR_EraseRootFromParent_Done,
     /* 1845441 */   // Label 24979: @1845441
     /* 1845441 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1845527), // Rule ID 13423 //
     /* 1845446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845492 */     // MIs[0] policy
     /* 1845492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845526 */     // GIR_Coverage, 13423,
     /* 1845526 */     GIR_EraseRootFromParent_Done,
     /* 1845527 */   // Label 24980: @1845527
     /* 1845527 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1845613), // Rule ID 13426 //
     /* 1845532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845578 */     // MIs[0] policy
     /* 1845578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845588 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845612 */     // GIR_Coverage, 13426,
     /* 1845612 */     GIR_EraseRootFromParent_Done,
     /* 1845613 */   // Label 24981: @1845613
     /* 1845613 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1845699), // Rule ID 13427 //
     /* 1845618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845664 */     // MIs[0] policy
     /* 1845664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845698 */     // GIR_Coverage, 13427,
     /* 1845698 */     GIR_EraseRootFromParent_Done,
     /* 1845699 */   // Label 24982: @1845699
     /* 1845699 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1845785), // Rule ID 13430 //
     /* 1845704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845750 */     // MIs[0] policy
     /* 1845750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845784 */     // GIR_Coverage, 13430,
     /* 1845784 */     GIR_EraseRootFromParent_Done,
     /* 1845785 */   // Label 24983: @1845785
     /* 1845785 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1845871), // Rule ID 13431 //
     /* 1845790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845836 */     // MIs[0] policy
     /* 1845836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845870 */     // GIR_Coverage, 13431,
     /* 1845870 */     GIR_EraseRootFromParent_Done,
     /* 1845871 */   // Label 24984: @1845871
     /* 1845871 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1845957), // Rule ID 13434 //
     /* 1845876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845922 */     // MIs[0] policy
     /* 1845922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845956 */     // GIR_Coverage, 13434,
     /* 1845956 */     GIR_EraseRootFromParent_Done,
     /* 1845957 */   // Label 24985: @1845957
     /* 1845957 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1846043), // Rule ID 13435 //
     /* 1845962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846008 */     // MIs[0] policy
     /* 1846008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1846021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846042 */     // GIR_Coverage, 13435,
     /* 1846042 */     GIR_EraseRootFromParent_Done,
     /* 1846043 */   // Label 24986: @1846043
     /* 1846043 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1846129), // Rule ID 13438 //
     /* 1846048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1846065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846094 */     // MIs[0] policy
     /* 1846094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846128 */     // GIR_Coverage, 13438,
     /* 1846128 */     GIR_EraseRootFromParent_Done,
     /* 1846129 */   // Label 24987: @1846129
     /* 1846129 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1846215), // Rule ID 13439 //
     /* 1846134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1846151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846180 */     // MIs[0] policy
     /* 1846180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846214 */     // GIR_Coverage, 13439,
     /* 1846214 */     GIR_EraseRootFromParent_Done,
     /* 1846215 */   // Label 24988: @1846215
     /* 1846215 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1846301), // Rule ID 13442 //
     /* 1846220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1846237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846266 */     // MIs[0] policy
     /* 1846266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846300 */     // GIR_Coverage, 13442,
     /* 1846300 */     GIR_EraseRootFromParent_Done,
     /* 1846301 */   // Label 24989: @1846301
     /* 1846301 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1846387), // Rule ID 13443 //
     /* 1846306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1846323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846352 */     // MIs[0] policy
     /* 1846352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846386 */     // GIR_Coverage, 13443,
     /* 1846386 */     GIR_EraseRootFromParent_Done,
     /* 1846387 */   // Label 24990: @1846387
     /* 1846387 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1846473), // Rule ID 13446 //
     /* 1846392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846438 */     // MIs[0] policy
     /* 1846438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846472 */     // GIR_Coverage, 13446,
     /* 1846472 */     GIR_EraseRootFromParent_Done,
     /* 1846473 */   // Label 24991: @1846473
     /* 1846473 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1846559), // Rule ID 13447 //
     /* 1846478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846524 */     // MIs[0] policy
     /* 1846524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846558 */     // GIR_Coverage, 13447,
     /* 1846558 */     GIR_EraseRootFromParent_Done,
     /* 1846559 */   // Label 24992: @1846559
     /* 1846559 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1846645), // Rule ID 13450 //
     /* 1846564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846610 */     // MIs[0] policy
     /* 1846610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846644 */     // GIR_Coverage, 13450,
     /* 1846644 */     GIR_EraseRootFromParent_Done,
     /* 1846645 */   // Label 24993: @1846645
     /* 1846645 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1846731), // Rule ID 13451 //
     /* 1846650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846696 */     // MIs[0] policy
     /* 1846696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846706 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846730 */     // GIR_Coverage, 13451,
     /* 1846730 */     GIR_EraseRootFromParent_Done,
     /* 1846731 */   // Label 24994: @1846731
     /* 1846731 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1846817), // Rule ID 13454 //
     /* 1846736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846782 */     // MIs[0] policy
     /* 1846782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846816 */     // GIR_Coverage, 13454,
     /* 1846816 */     GIR_EraseRootFromParent_Done,
     /* 1846817 */   // Label 24995: @1846817
     /* 1846817 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1846903), // Rule ID 13455 //
     /* 1846822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846868 */     // MIs[0] policy
     /* 1846868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846902 */     // GIR_Coverage, 13455,
     /* 1846902 */     GIR_EraseRootFromParent_Done,
     /* 1846903 */   // Label 24996: @1846903
     /* 1846903 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1846989), // Rule ID 13458 //
     /* 1846908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846954 */     // MIs[0] policy
     /* 1846954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846964 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846988 */     // GIR_Coverage, 13458,
     /* 1846988 */     GIR_EraseRootFromParent_Done,
     /* 1846989 */   // Label 24997: @1846989
     /* 1846989 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1847075), // Rule ID 13459 //
     /* 1846994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1847005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1847008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1847011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1847014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847040 */     // MIs[0] policy
     /* 1847040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1847053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847074 */     // GIR_Coverage, 13459,
     /* 1847074 */     GIR_EraseRootFromParent_Done,
     /* 1847075 */   // Label 24998: @1847075
     /* 1847075 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1847161), // Rule ID 13462 //
     /* 1847080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1847097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847126 */     // MIs[0] policy
     /* 1847126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847160 */     // GIR_Coverage, 13462,
     /* 1847160 */     GIR_EraseRootFromParent_Done,
     /* 1847161 */   // Label 24999: @1847161
     /* 1847161 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1847247), // Rule ID 13463 //
     /* 1847166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1847183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847212 */     // MIs[0] policy
     /* 1847212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847246 */     // GIR_Coverage, 13463,
     /* 1847246 */     GIR_EraseRootFromParent_Done,
     /* 1847247 */   // Label 25000: @1847247
     /* 1847247 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1847333), // Rule ID 13466 //
     /* 1847252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1847269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847298 */     // MIs[0] policy
     /* 1847298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847332 */     // GIR_Coverage, 13466,
     /* 1847332 */     GIR_EraseRootFromParent_Done,
     /* 1847333 */   // Label 25001: @1847333
     /* 1847333 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1847419), // Rule ID 13467 //
     /* 1847338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1847355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847384 */     // MIs[0] policy
     /* 1847384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847418 */     // GIR_Coverage, 13467,
     /* 1847418 */     GIR_EraseRootFromParent_Done,
     /* 1847419 */   // Label 25002: @1847419
     /* 1847419 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1847505), // Rule ID 13470 //
     /* 1847424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847470 */     // MIs[0] policy
     /* 1847470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847504 */     // GIR_Coverage, 13470,
     /* 1847504 */     GIR_EraseRootFromParent_Done,
     /* 1847505 */   // Label 25003: @1847505
     /* 1847505 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1847591), // Rule ID 13471 //
     /* 1847510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847556 */     // MIs[0] policy
     /* 1847556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847590 */     // GIR_Coverage, 13471,
     /* 1847590 */     GIR_EraseRootFromParent_Done,
     /* 1847591 */   // Label 25004: @1847591
     /* 1847591 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1847677), // Rule ID 13474 //
     /* 1847596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847642 */     // MIs[0] policy
     /* 1847642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847676 */     // GIR_Coverage, 13474,
     /* 1847676 */     GIR_EraseRootFromParent_Done,
     /* 1847677 */   // Label 25005: @1847677
     /* 1847677 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1847763), // Rule ID 13475 //
     /* 1847682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847728 */     // MIs[0] policy
     /* 1847728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847738 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847762 */     // GIR_Coverage, 13475,
     /* 1847762 */     GIR_EraseRootFromParent_Done,
     /* 1847763 */   // Label 25006: @1847763
     /* 1847763 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1847849), // Rule ID 13478 //
     /* 1847768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847814 */     // MIs[0] policy
     /* 1847814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847848 */     // GIR_Coverage, 13478,
     /* 1847848 */     GIR_EraseRootFromParent_Done,
     /* 1847849 */   // Label 25007: @1847849
     /* 1847849 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1847935), // Rule ID 13479 //
     /* 1847854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847900 */     // MIs[0] policy
     /* 1847900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847934 */     // GIR_Coverage, 13479,
     /* 1847934 */     GIR_EraseRootFromParent_Done,
     /* 1847935 */   // Label 25008: @1847935
     /* 1847935 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1848021), // Rule ID 13482 //
     /* 1847940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847986 */     // MIs[0] policy
     /* 1847986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848020 */     // GIR_Coverage, 13482,
     /* 1848020 */     GIR_EraseRootFromParent_Done,
     /* 1848021 */   // Label 25009: @1848021
     /* 1848021 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1848107), // Rule ID 13483 //
     /* 1848026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1848043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1848046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848072 */     // MIs[0] policy
     /* 1848072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1848085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848106 */     // GIR_Coverage, 13483,
     /* 1848106 */     GIR_EraseRootFromParent_Done,
     /* 1848107 */   // Label 25010: @1848107
     /* 1848107 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1848193), // Rule ID 13486 //
     /* 1848112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848158 */     // MIs[0] policy
     /* 1848158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1848171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848192 */     // GIR_Coverage, 13486,
     /* 1848192 */     GIR_EraseRootFromParent_Done,
     /* 1848193 */   // Label 25011: @1848193
     /* 1848193 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1848279), // Rule ID 13487 //
     /* 1848198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1848215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848244 */     // MIs[0] policy
     /* 1848244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1848257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848278 */     // GIR_Coverage, 13487,
     /* 1848278 */     GIR_EraseRootFromParent_Done,
     /* 1848279 */   // Label 25012: @1848279
     /* 1848279 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1848365), // Rule ID 13490 //
     /* 1848284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848330 */     // MIs[0] policy
     /* 1848330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1848343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848364 */     // GIR_Coverage, 13490,
     /* 1848364 */     GIR_EraseRootFromParent_Done,
     /* 1848365 */   // Label 25013: @1848365
     /* 1848365 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1848451), // Rule ID 13491 //
     /* 1848370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1848387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848416 */     // MIs[0] policy
     /* 1848416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1848429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848450 */     // GIR_Coverage, 13491,
     /* 1848450 */     GIR_EraseRootFromParent_Done,
     /* 1848451 */   // Label 25014: @1848451
     /* 1848451 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1848537), // Rule ID 13494 //
     /* 1848456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848502 */     // MIs[0] policy
     /* 1848502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848536 */     // GIR_Coverage, 13494,
     /* 1848536 */     GIR_EraseRootFromParent_Done,
     /* 1848537 */   // Label 25015: @1848537
     /* 1848537 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1848623), // Rule ID 13495 //
     /* 1848542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848588 */     // MIs[0] policy
     /* 1848588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848598 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848622 */     // GIR_Coverage, 13495,
     /* 1848622 */     GIR_EraseRootFromParent_Done,
     /* 1848623 */   // Label 25016: @1848623
     /* 1848623 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1848709), // Rule ID 13498 //
     /* 1848628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848674 */     // MIs[0] policy
     /* 1848674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848708 */     // GIR_Coverage, 13498,
     /* 1848708 */     GIR_EraseRootFromParent_Done,
     /* 1848709 */   // Label 25017: @1848709
     /* 1848709 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1848795), // Rule ID 13499 //
     /* 1848714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848760 */     // MIs[0] policy
     /* 1848760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848794 */     // GIR_Coverage, 13499,
     /* 1848794 */     GIR_EraseRootFromParent_Done,
     /* 1848795 */   // Label 25018: @1848795
     /* 1848795 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1848881), // Rule ID 13502 //
     /* 1848800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848846 */     // MIs[0] policy
     /* 1848846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848856 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848880 */     // GIR_Coverage, 13502,
     /* 1848880 */     GIR_EraseRootFromParent_Done,
     /* 1848881 */   // Label 25019: @1848881
     /* 1848881 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1848967), // Rule ID 13503 //
     /* 1848886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848932 */     // MIs[0] policy
     /* 1848932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11708:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848966 */     // GIR_Coverage, 13503,
     /* 1848966 */     GIR_EraseRootFromParent_Done,
     /* 1848967 */   // Label 25020: @1848967
     /* 1848967 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1849053), // Rule ID 13506 //
     /* 1848972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849018 */     // MIs[0] policy
     /* 1849018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849052 */     // GIR_Coverage, 13506,
     /* 1849052 */     GIR_EraseRootFromParent_Done,
     /* 1849053 */   // Label 25021: @1849053
     /* 1849053 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1849139), // Rule ID 13507 //
     /* 1849058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849104 */     // MIs[0] policy
     /* 1849104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849138 */     // GIR_Coverage, 13507,
     /* 1849138 */     GIR_EraseRootFromParent_Done,
     /* 1849139 */   // Label 25022: @1849139
     /* 1849139 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1849225), // Rule ID 13510 //
     /* 1849144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849190 */     // MIs[0] policy
     /* 1849190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849224 */     // GIR_Coverage, 13510,
     /* 1849224 */     GIR_EraseRootFromParent_Done,
     /* 1849225 */   // Label 25023: @1849225
     /* 1849225 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1849311), // Rule ID 13511 //
     /* 1849230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849276 */     // MIs[0] policy
     /* 1849276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849310 */     // GIR_Coverage, 13511,
     /* 1849310 */     GIR_EraseRootFromParent_Done,
     /* 1849311 */   // Label 25024: @1849311
     /* 1849311 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1849397), // Rule ID 13514 //
     /* 1849316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849362 */     // MIs[0] policy
     /* 1849362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849396 */     // GIR_Coverage, 13514,
     /* 1849396 */     GIR_EraseRootFromParent_Done,
     /* 1849397 */   // Label 25025: @1849397
     /* 1849397 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1849483), // Rule ID 13515 //
     /* 1849402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849448 */     // MIs[0] policy
     /* 1849448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849482 */     // GIR_Coverage, 13515,
     /* 1849482 */     GIR_EraseRootFromParent_Done,
     /* 1849483 */   // Label 25026: @1849483
     /* 1849483 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1849569), // Rule ID 13518 //
     /* 1849488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849534 */     // MIs[0] policy
     /* 1849534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849568 */     // GIR_Coverage, 13518,
     /* 1849568 */     GIR_EraseRootFromParent_Done,
     /* 1849569 */   // Label 25027: @1849569
     /* 1849569 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1849655), // Rule ID 13519 //
     /* 1849574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849620 */     // MIs[0] policy
     /* 1849620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849654 */     // GIR_Coverage, 13519,
     /* 1849654 */     GIR_EraseRootFromParent_Done,
     /* 1849655 */   // Label 25028: @1849655
     /* 1849655 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1849741), // Rule ID 13522 //
     /* 1849660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849706 */     // MIs[0] policy
     /* 1849706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849740 */     // GIR_Coverage, 13522,
     /* 1849740 */     GIR_EraseRootFromParent_Done,
     /* 1849741 */   // Label 25029: @1849741
     /* 1849741 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1849827), // Rule ID 13523 //
     /* 1849746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849792 */     // MIs[0] policy
     /* 1849792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11708:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849826 */     // GIR_Coverage, 13523,
     /* 1849826 */     GIR_EraseRootFromParent_Done,
     /* 1849827 */   // Label 25030: @1849827
     /* 1849827 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1849913), // Rule ID 13526 //
     /* 1849832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849878 */     // MIs[0] policy
     /* 1849878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849912 */     // GIR_Coverage, 13526,
     /* 1849912 */     GIR_EraseRootFromParent_Done,
     /* 1849913 */   // Label 25031: @1849913
     /* 1849913 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1849999), // Rule ID 13527 //
     /* 1849918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849964 */     // MIs[0] policy
     /* 1849964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849998 */     // GIR_Coverage, 13527,
     /* 1849998 */     GIR_EraseRootFromParent_Done,
     /* 1849999 */   // Label 25032: @1849999
     /* 1849999 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1850085), // Rule ID 13530 //
     /* 1850004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850050 */     // MIs[0] policy
     /* 1850050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850084 */     // GIR_Coverage, 13530,
     /* 1850084 */     GIR_EraseRootFromParent_Done,
     /* 1850085 */   // Label 25033: @1850085
     /* 1850085 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1850171), // Rule ID 13531 //
     /* 1850090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850136 */     // MIs[0] policy
     /* 1850136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850170 */     // GIR_Coverage, 13531,
     /* 1850170 */     GIR_EraseRootFromParent_Done,
     /* 1850171 */   // Label 25034: @1850171
     /* 1850171 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1850257), // Rule ID 13534 //
     /* 1850176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850222 */     // MIs[0] policy
     /* 1850222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850256 */     // GIR_Coverage, 13534,
     /* 1850256 */     GIR_EraseRootFromParent_Done,
     /* 1850257 */   // Label 25035: @1850257
     /* 1850257 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1850343), // Rule ID 13535 //
     /* 1850262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850308 */     // MIs[0] policy
     /* 1850308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850342 */     // GIR_Coverage, 13535,
     /* 1850342 */     GIR_EraseRootFromParent_Done,
     /* 1850343 */   // Label 25036: @1850343
     /* 1850343 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1850429), // Rule ID 13538 //
     /* 1850348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850394 */     // MIs[0] policy
     /* 1850394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850428 */     // GIR_Coverage, 13538,
     /* 1850428 */     GIR_EraseRootFromParent_Done,
     /* 1850429 */   // Label 25037: @1850429
     /* 1850429 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1850515), // Rule ID 13539 //
     /* 1850434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850480 */     // MIs[0] policy
     /* 1850480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11708:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850514 */     // GIR_Coverage, 13539,
     /* 1850514 */     GIR_EraseRootFromParent_Done,
     /* 1850515 */   // Label 25038: @1850515
     /* 1850515 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1850601), // Rule ID 13542 //
     /* 1850520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850566 */     // MIs[0] policy
     /* 1850566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850600 */     // GIR_Coverage, 13542,
     /* 1850600 */     GIR_EraseRootFromParent_Done,
     /* 1850601 */   // Label 25039: @1850601
     /* 1850601 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1850687), // Rule ID 13543 //
     /* 1850606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850652 */     // MIs[0] policy
     /* 1850652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11708:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850686 */     // GIR_Coverage, 13543,
     /* 1850686 */     GIR_EraseRootFromParent_Done,
     /* 1850687 */   // Label 25040: @1850687
     /* 1850687 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1850773), // Rule ID 13546 //
     /* 1850692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850738 */     // MIs[0] policy
     /* 1850738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850772 */     // GIR_Coverage, 13546,
     /* 1850772 */     GIR_EraseRootFromParent_Done,
     /* 1850773 */   // Label 25041: @1850773
     /* 1850773 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1850859), // Rule ID 13547 //
     /* 1850778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850824 */     // MIs[0] policy
     /* 1850824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11708:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850858 */     // GIR_Coverage, 13547,
     /* 1850858 */     GIR_EraseRootFromParent_Done,
     /* 1850859 */   // Label 25042: @1850859
     /* 1850859 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1850945), // Rule ID 13550 //
     /* 1850864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850910 */     // MIs[0] policy
     /* 1850910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850944 */     // GIR_Coverage, 13550,
     /* 1850944 */     GIR_EraseRootFromParent_Done,
     /* 1850945 */   // Label 25043: @1850945
     /* 1850945 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1851031), // Rule ID 13551 //
     /* 1850950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850996 */     // MIs[0] policy
     /* 1850996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851006 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11708:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1851009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851030 */     // GIR_Coverage, 13551,
     /* 1851030 */     GIR_EraseRootFromParent_Done,
     /* 1851031 */   // Label 25044: @1851031
     /* 1851031 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1851117), // Rule ID 13554 //
     /* 1851036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1851053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851082 */     // MIs[0] policy
     /* 1851082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1851095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851116 */     // GIR_Coverage, 13554,
     /* 1851116 */     GIR_EraseRootFromParent_Done,
     /* 1851117 */   // Label 25045: @1851117
     /* 1851117 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1851203), // Rule ID 13555 //
     /* 1851122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1851139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851168 */     // MIs[0] policy
     /* 1851168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1851181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851202 */     // GIR_Coverage, 13555,
     /* 1851202 */     GIR_EraseRootFromParent_Done,
     /* 1851203 */   // Label 25046: @1851203
     /* 1851203 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1851289), // Rule ID 13558 //
     /* 1851208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1851225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851254 */     // MIs[0] policy
     /* 1851254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851288 */     // GIR_Coverage, 13558,
     /* 1851288 */     GIR_EraseRootFromParent_Done,
     /* 1851289 */   // Label 25047: @1851289
     /* 1851289 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1851375), // Rule ID 13559 //
     /* 1851294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1851311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851340 */     // MIs[0] policy
     /* 1851340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851374 */     // GIR_Coverage, 13559,
     /* 1851374 */     GIR_EraseRootFromParent_Done,
     /* 1851375 */   // Label 25048: @1851375
     /* 1851375 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1851461), // Rule ID 13562 //
     /* 1851380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851426 */     // MIs[0] policy
     /* 1851426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851460 */     // GIR_Coverage, 13562,
     /* 1851460 */     GIR_EraseRootFromParent_Done,
     /* 1851461 */   // Label 25049: @1851461
     /* 1851461 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1851547), // Rule ID 13563 //
     /* 1851466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851512 */     // MIs[0] policy
     /* 1851512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851546 */     // GIR_Coverage, 13563,
     /* 1851546 */     GIR_EraseRootFromParent_Done,
     /* 1851547 */   // Label 25050: @1851547
     /* 1851547 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1851633), // Rule ID 13566 //
     /* 1851552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851598 */     // MIs[0] policy
     /* 1851598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851632 */     // GIR_Coverage, 13566,
     /* 1851632 */     GIR_EraseRootFromParent_Done,
     /* 1851633 */   // Label 25051: @1851633
     /* 1851633 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1851719), // Rule ID 13567 //
     /* 1851638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851684 */     // MIs[0] policy
     /* 1851684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851718 */     // GIR_Coverage, 13567,
     /* 1851718 */     GIR_EraseRootFromParent_Done,
     /* 1851719 */   // Label 25052: @1851719
     /* 1851719 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1851805), // Rule ID 13570 //
     /* 1851724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851770 */     // MIs[0] policy
     /* 1851770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851804 */     // GIR_Coverage, 13570,
     /* 1851804 */     GIR_EraseRootFromParent_Done,
     /* 1851805 */   // Label 25053: @1851805
     /* 1851805 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1851891), // Rule ID 13571 //
     /* 1851810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851856 */     // MIs[0] policy
     /* 1851856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851890 */     // GIR_Coverage, 13571,
     /* 1851890 */     GIR_EraseRootFromParent_Done,
     /* 1851891 */   // Label 25054: @1851891
     /* 1851891 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1851977), // Rule ID 13574 //
     /* 1851896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851942 */     // MIs[0] policy
     /* 1851942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851976 */     // GIR_Coverage, 13574,
     /* 1851976 */     GIR_EraseRootFromParent_Done,
     /* 1851977 */   // Label 25055: @1851977
     /* 1851977 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1852063), // Rule ID 13575 //
     /* 1851982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852028 */     // MIs[0] policy
     /* 1852028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852062 */     // GIR_Coverage, 13575,
     /* 1852062 */     GIR_EraseRootFromParent_Done,
     /* 1852063 */   // Label 25056: @1852063
     /* 1852063 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1852149), // Rule ID 13578 //
     /* 1852068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1852085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852114 */     // MIs[0] policy
     /* 1852114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1852127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852148 */     // GIR_Coverage, 13578,
     /* 1852148 */     GIR_EraseRootFromParent_Done,
     /* 1852149 */   // Label 25057: @1852149
     /* 1852149 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1852235), // Rule ID 13579 //
     /* 1852154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1852171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852200 */     // MIs[0] policy
     /* 1852200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1852213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852234 */     // GIR_Coverage, 13579,
     /* 1852234 */     GIR_EraseRootFromParent_Done,
     /* 1852235 */   // Label 25058: @1852235
     /* 1852235 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1852321), // Rule ID 13582 //
     /* 1852240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1852257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852286 */     // MIs[0] policy
     /* 1852286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852320 */     // GIR_Coverage, 13582,
     /* 1852320 */     GIR_EraseRootFromParent_Done,
     /* 1852321 */   // Label 25059: @1852321
     /* 1852321 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1852407), // Rule ID 13583 //
     /* 1852326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1852343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852372 */     // MIs[0] policy
     /* 1852372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852406 */     // GIR_Coverage, 13583,
     /* 1852406 */     GIR_EraseRootFromParent_Done,
     /* 1852407 */   // Label 25060: @1852407
     /* 1852407 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1852493), // Rule ID 13586 //
     /* 1852412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852458 */     // MIs[0] policy
     /* 1852458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852492 */     // GIR_Coverage, 13586,
     /* 1852492 */     GIR_EraseRootFromParent_Done,
     /* 1852493 */   // Label 25061: @1852493
     /* 1852493 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1852579), // Rule ID 13587 //
     /* 1852498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852544 */     // MIs[0] policy
     /* 1852544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852578 */     // GIR_Coverage, 13587,
     /* 1852578 */     GIR_EraseRootFromParent_Done,
     /* 1852579 */   // Label 25062: @1852579
     /* 1852579 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1852665), // Rule ID 13590 //
     /* 1852584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852630 */     // MIs[0] policy
     /* 1852630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852664 */     // GIR_Coverage, 13590,
     /* 1852664 */     GIR_EraseRootFromParent_Done,
     /* 1852665 */   // Label 25063: @1852665
     /* 1852665 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1852751), // Rule ID 13591 //
     /* 1852670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852716 */     // MIs[0] policy
     /* 1852716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852750 */     // GIR_Coverage, 13591,
     /* 1852750 */     GIR_EraseRootFromParent_Done,
     /* 1852751 */   // Label 25064: @1852751
     /* 1852751 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1852837), // Rule ID 13594 //
     /* 1852756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852802 */     // MIs[0] policy
     /* 1852802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852836 */     // GIR_Coverage, 13594,
     /* 1852836 */     GIR_EraseRootFromParent_Done,
     /* 1852837 */   // Label 25065: @1852837
     /* 1852837 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1852923), // Rule ID 13595 //
     /* 1852842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852888 */     // MIs[0] policy
     /* 1852888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852922 */     // GIR_Coverage, 13595,
     /* 1852922 */     GIR_EraseRootFromParent_Done,
     /* 1852923 */   // Label 25066: @1852923
     /* 1852923 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1853009), // Rule ID 13598 //
     /* 1852928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852974 */     // MIs[0] policy
     /* 1852974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853008 */     // GIR_Coverage, 13598,
     /* 1853008 */     GIR_EraseRootFromParent_Done,
     /* 1853009 */   // Label 25067: @1853009
     /* 1853009 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1853095), // Rule ID 13599 //
     /* 1853014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1853031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853060 */     // MIs[0] policy
     /* 1853060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1853073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853094 */     // GIR_Coverage, 13599,
     /* 1853094 */     GIR_EraseRootFromParent_Done,
     /* 1853095 */   // Label 25068: @1853095
     /* 1853095 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1853181), // Rule ID 13602 //
     /* 1853100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1853117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853146 */     // MIs[0] policy
     /* 1853146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1853159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853180 */     // GIR_Coverage, 13602,
     /* 1853180 */     GIR_EraseRootFromParent_Done,
     /* 1853181 */   // Label 25069: @1853181
     /* 1853181 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1853267), // Rule ID 13603 //
     /* 1853186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1853203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853232 */     // MIs[0] policy
     /* 1853232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1853245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853266 */     // GIR_Coverage, 13603,
     /* 1853266 */     GIR_EraseRootFromParent_Done,
     /* 1853267 */   // Label 25070: @1853267
     /* 1853267 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1853353), // Rule ID 13606 //
     /* 1853272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1853289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853318 */     // MIs[0] policy
     /* 1853318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853328 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1853331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853352 */     // GIR_Coverage, 13606,
     /* 1853352 */     GIR_EraseRootFromParent_Done,
     /* 1853353 */   // Label 25071: @1853353
     /* 1853353 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1853439), // Rule ID 13607 //
     /* 1853358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1853375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853404 */     // MIs[0] policy
     /* 1853404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853414 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1853417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853438 */     // GIR_Coverage, 13607,
     /* 1853438 */     GIR_EraseRootFromParent_Done,
     /* 1853439 */   // Label 25072: @1853439
     /* 1853439 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1853525), // Rule ID 13610 //
     /* 1853444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853490 */     // MIs[0] policy
     /* 1853490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853524 */     // GIR_Coverage, 13610,
     /* 1853524 */     GIR_EraseRootFromParent_Done,
     /* 1853525 */   // Label 25073: @1853525
     /* 1853525 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1853611), // Rule ID 13611 //
     /* 1853530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853576 */     // MIs[0] policy
     /* 1853576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853610 */     // GIR_Coverage, 13611,
     /* 1853610 */     GIR_EraseRootFromParent_Done,
     /* 1853611 */   // Label 25074: @1853611
     /* 1853611 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1853697), // Rule ID 13614 //
     /* 1853616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853662 */     // MIs[0] policy
     /* 1853662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853696 */     // GIR_Coverage, 13614,
     /* 1853696 */     GIR_EraseRootFromParent_Done,
     /* 1853697 */   // Label 25075: @1853697
     /* 1853697 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1853783), // Rule ID 13615 //
     /* 1853702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853748 */     // MIs[0] policy
     /* 1853748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853782 */     // GIR_Coverage, 13615,
     /* 1853782 */     GIR_EraseRootFromParent_Done,
     /* 1853783 */   // Label 25076: @1853783
     /* 1853783 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1853869), // Rule ID 13618 //
     /* 1853788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853834 */     // MIs[0] policy
     /* 1853834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853868 */     // GIR_Coverage, 13618,
     /* 1853868 */     GIR_EraseRootFromParent_Done,
     /* 1853869 */   // Label 25077: @1853869
     /* 1853869 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1853955), // Rule ID 13619 //
     /* 1853874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853920 */     // MIs[0] policy
     /* 1853920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853954 */     // GIR_Coverage, 13619,
     /* 1853954 */     GIR_EraseRootFromParent_Done,
     /* 1853955 */   // Label 25078: @1853955
     /* 1853955 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1854041), // Rule ID 13622 //
     /* 1853960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854006 */     // MIs[0] policy
     /* 1854006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854040 */     // GIR_Coverage, 13622,
     /* 1854040 */     GIR_EraseRootFromParent_Done,
     /* 1854041 */   // Label 25079: @1854041
     /* 1854041 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1854127), // Rule ID 13623 //
     /* 1854046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854092 */     // MIs[0] policy
     /* 1854092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11704:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854126 */     // GIR_Coverage, 13623,
     /* 1854126 */     GIR_EraseRootFromParent_Done,
     /* 1854127 */   // Label 25080: @1854127
     /* 1854127 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1854213), // Rule ID 13626 //
     /* 1854132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854178 */     // MIs[0] policy
     /* 1854178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854212 */     // GIR_Coverage, 13626,
     /* 1854212 */     GIR_EraseRootFromParent_Done,
     /* 1854213 */   // Label 25081: @1854213
     /* 1854213 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1854299), // Rule ID 13627 //
     /* 1854218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854264 */     // MIs[0] policy
     /* 1854264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854298 */     // GIR_Coverage, 13627,
     /* 1854298 */     GIR_EraseRootFromParent_Done,
     /* 1854299 */   // Label 25082: @1854299
     /* 1854299 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1854385), // Rule ID 13630 //
     /* 1854304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854350 */     // MIs[0] policy
     /* 1854350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854384 */     // GIR_Coverage, 13630,
     /* 1854384 */     GIR_EraseRootFromParent_Done,
     /* 1854385 */   // Label 25083: @1854385
     /* 1854385 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1854471), // Rule ID 13631 //
     /* 1854390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854436 */     // MIs[0] policy
     /* 1854436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854470 */     // GIR_Coverage, 13631,
     /* 1854470 */     GIR_EraseRootFromParent_Done,
     /* 1854471 */   // Label 25084: @1854471
     /* 1854471 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1854557), // Rule ID 13634 //
     /* 1854476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854522 */     // MIs[0] policy
     /* 1854522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854532 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854556 */     // GIR_Coverage, 13634,
     /* 1854556 */     GIR_EraseRootFromParent_Done,
     /* 1854557 */   // Label 25085: @1854557
     /* 1854557 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1854643), // Rule ID 13635 //
     /* 1854562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854608 */     // MIs[0] policy
     /* 1854608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854642 */     // GIR_Coverage, 13635,
     /* 1854642 */     GIR_EraseRootFromParent_Done,
     /* 1854643 */   // Label 25086: @1854643
     /* 1854643 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1854729), // Rule ID 13638 //
     /* 1854648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854694 */     // MIs[0] policy
     /* 1854694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854728 */     // GIR_Coverage, 13638,
     /* 1854728 */     GIR_EraseRootFromParent_Done,
     /* 1854729 */   // Label 25087: @1854729
     /* 1854729 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1854815), // Rule ID 13639 //
     /* 1854734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854780 */     // MIs[0] policy
     /* 1854780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854814 */     // GIR_Coverage, 13639,
     /* 1854814 */     GIR_EraseRootFromParent_Done,
     /* 1854815 */   // Label 25088: @1854815
     /* 1854815 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1854901), // Rule ID 13642 //
     /* 1854820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854866 */     // MIs[0] policy
     /* 1854866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854900 */     // GIR_Coverage, 13642,
     /* 1854900 */     GIR_EraseRootFromParent_Done,
     /* 1854901 */   // Label 25089: @1854901
     /* 1854901 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1854987), // Rule ID 13643 //
     /* 1854906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854952 */     // MIs[0] policy
     /* 1854952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11704:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854986 */     // GIR_Coverage, 13643,
     /* 1854986 */     GIR_EraseRootFromParent_Done,
     /* 1854987 */   // Label 25090: @1854987
     /* 1854987 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1855073), // Rule ID 13646 //
     /* 1854992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855038 */     // MIs[0] policy
     /* 1855038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855072 */     // GIR_Coverage, 13646,
     /* 1855072 */     GIR_EraseRootFromParent_Done,
     /* 1855073 */   // Label 25091: @1855073
     /* 1855073 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1855159), // Rule ID 13647 //
     /* 1855078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855124 */     // MIs[0] policy
     /* 1855124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855158 */     // GIR_Coverage, 13647,
     /* 1855158 */     GIR_EraseRootFromParent_Done,
     /* 1855159 */   // Label 25092: @1855159
     /* 1855159 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1855245), // Rule ID 13650 //
     /* 1855164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855210 */     // MIs[0] policy
     /* 1855210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855244 */     // GIR_Coverage, 13650,
     /* 1855244 */     GIR_EraseRootFromParent_Done,
     /* 1855245 */   // Label 25093: @1855245
     /* 1855245 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1855331), // Rule ID 13651 //
     /* 1855250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855296 */     // MIs[0] policy
     /* 1855296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855330 */     // GIR_Coverage, 13651,
     /* 1855330 */     GIR_EraseRootFromParent_Done,
     /* 1855331 */   // Label 25094: @1855331
     /* 1855331 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1855417), // Rule ID 13654 //
     /* 1855336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855382 */     // MIs[0] policy
     /* 1855382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855416 */     // GIR_Coverage, 13654,
     /* 1855416 */     GIR_EraseRootFromParent_Done,
     /* 1855417 */   // Label 25095: @1855417
     /* 1855417 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1855503), // Rule ID 13655 //
     /* 1855422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855468 */     // MIs[0] policy
     /* 1855468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855502 */     // GIR_Coverage, 13655,
     /* 1855502 */     GIR_EraseRootFromParent_Done,
     /* 1855503 */   // Label 25096: @1855503
     /* 1855503 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1855589), // Rule ID 13658 //
     /* 1855508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855554 */     // MIs[0] policy
     /* 1855554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855588 */     // GIR_Coverage, 13658,
     /* 1855588 */     GIR_EraseRootFromParent_Done,
     /* 1855589 */   // Label 25097: @1855589
     /* 1855589 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1855675), // Rule ID 13659 //
     /* 1855594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855640 */     // MIs[0] policy
     /* 1855640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11704:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855674 */     // GIR_Coverage, 13659,
     /* 1855674 */     GIR_EraseRootFromParent_Done,
     /* 1855675 */   // Label 25098: @1855675
     /* 1855675 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1855761), // Rule ID 13662 //
     /* 1855680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855726 */     // MIs[0] policy
     /* 1855726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855760 */     // GIR_Coverage, 13662,
     /* 1855760 */     GIR_EraseRootFromParent_Done,
     /* 1855761 */   // Label 25099: @1855761
     /* 1855761 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1855847), // Rule ID 13663 //
     /* 1855766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855812 */     // MIs[0] policy
     /* 1855812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11704:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855846 */     // GIR_Coverage, 13663,
     /* 1855846 */     GIR_EraseRootFromParent_Done,
     /* 1855847 */   // Label 25100: @1855847
     /* 1855847 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1855933), // Rule ID 13666 //
     /* 1855852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855898 */     // MIs[0] policy
     /* 1855898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855932 */     // GIR_Coverage, 13666,
     /* 1855932 */     GIR_EraseRootFromParent_Done,
     /* 1855933 */   // Label 25101: @1855933
     /* 1855933 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1856019), // Rule ID 13667 //
     /* 1855938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855984 */     // MIs[0] policy
     /* 1855984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11704:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856018 */     // GIR_Coverage, 13667,
     /* 1856018 */     GIR_EraseRootFromParent_Done,
     /* 1856019 */   // Label 25102: @1856019
     /* 1856019 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1856105), // Rule ID 13670 //
     /* 1856024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856070 */     // MIs[0] policy
     /* 1856070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1856083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856104 */     // GIR_Coverage, 13670,
     /* 1856104 */     GIR_EraseRootFromParent_Done,
     /* 1856105 */   // Label 25103: @1856105
     /* 1856105 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1856191), // Rule ID 13671 //
     /* 1856110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1856118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856156 */     // MIs[0] policy
     /* 1856156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11704:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1856169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856190 */     // GIR_Coverage, 13671,
     /* 1856190 */     GIR_EraseRootFromParent_Done,
     /* 1856191 */   // Label 25104: @1856191
     /* 1856191 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1856277), // Rule ID 13674 //
     /* 1856196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856242 */     // MIs[0] policy
     /* 1856242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1856255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856276 */     // GIR_Coverage, 13674,
     /* 1856276 */     GIR_EraseRootFromParent_Done,
     /* 1856277 */   // Label 25105: @1856277
     /* 1856277 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1856363), // Rule ID 13675 //
     /* 1856282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856328 */     // MIs[0] policy
     /* 1856328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1856341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856362 */     // GIR_Coverage, 13675,
     /* 1856362 */     GIR_EraseRootFromParent_Done,
     /* 1856363 */   // Label 25106: @1856363
     /* 1856363 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1856449), // Rule ID 13678 //
     /* 1856368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856414 */     // MIs[0] policy
     /* 1856414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856448 */     // GIR_Coverage, 13678,
     /* 1856448 */     GIR_EraseRootFromParent_Done,
     /* 1856449 */   // Label 25107: @1856449
     /* 1856449 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1856535), // Rule ID 13679 //
     /* 1856454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856500 */     // MIs[0] policy
     /* 1856500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856534 */     // GIR_Coverage, 13679,
     /* 1856534 */     GIR_EraseRootFromParent_Done,
     /* 1856535 */   // Label 25108: @1856535
     /* 1856535 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1856621), // Rule ID 13682 //
     /* 1856540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856586 */     // MIs[0] policy
     /* 1856586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856620 */     // GIR_Coverage, 13682,
     /* 1856620 */     GIR_EraseRootFromParent_Done,
     /* 1856621 */   // Label 25109: @1856621
     /* 1856621 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1856707), // Rule ID 13683 //
     /* 1856626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856672 */     // MIs[0] policy
     /* 1856672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856706 */     // GIR_Coverage, 13683,
     /* 1856706 */     GIR_EraseRootFromParent_Done,
     /* 1856707 */   // Label 25110: @1856707
     /* 1856707 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1856793), // Rule ID 13686 //
     /* 1856712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856758 */     // MIs[0] policy
     /* 1856758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856792 */     // GIR_Coverage, 13686,
     /* 1856792 */     GIR_EraseRootFromParent_Done,
     /* 1856793 */   // Label 25111: @1856793
     /* 1856793 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1856879), // Rule ID 13687 //
     /* 1856798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856844 */     // MIs[0] policy
     /* 1856844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856878 */     // GIR_Coverage, 13687,
     /* 1856878 */     GIR_EraseRootFromParent_Done,
     /* 1856879 */   // Label 25112: @1856879
     /* 1856879 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1856965), // Rule ID 13690 //
     /* 1856884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856930 */     // MIs[0] policy
     /* 1856930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856940 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856964 */     // GIR_Coverage, 13690,
     /* 1856964 */     GIR_EraseRootFromParent_Done,
     /* 1856965 */   // Label 25113: @1856965
     /* 1856965 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1857051), // Rule ID 13691 //
     /* 1856970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857016 */     // MIs[0] policy
     /* 1857016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857050 */     // GIR_Coverage, 13691,
     /* 1857050 */     GIR_EraseRootFromParent_Done,
     /* 1857051 */   // Label 25114: @1857051
     /* 1857051 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1857137), // Rule ID 13694 //
     /* 1857056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1857073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857102 */     // MIs[0] policy
     /* 1857102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857112 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857136 */     // GIR_Coverage, 13694,
     /* 1857136 */     GIR_EraseRootFromParent_Done,
     /* 1857137 */   // Label 25115: @1857137
     /* 1857137 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1857223), // Rule ID 13695 //
     /* 1857142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1857159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857188 */     // MIs[0] policy
     /* 1857188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857198 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857222 */     // GIR_Coverage, 13695,
     /* 1857222 */     GIR_EraseRootFromParent_Done,
     /* 1857223 */   // Label 25116: @1857223
     /* 1857223 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1857309), // Rule ID 13698 //
     /* 1857228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857274 */     // MIs[0] policy
     /* 1857274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1857287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857308 */     // GIR_Coverage, 13698,
     /* 1857308 */     GIR_EraseRootFromParent_Done,
     /* 1857309 */   // Label 25117: @1857309
     /* 1857309 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1857395), // Rule ID 13699 //
     /* 1857314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857360 */     // MIs[0] policy
     /* 1857360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1857373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857394 */     // GIR_Coverage, 13699,
     /* 1857394 */     GIR_EraseRootFromParent_Done,
     /* 1857395 */   // Label 25118: @1857395
     /* 1857395 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1857481), // Rule ID 13702 //
     /* 1857400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857446 */     // MIs[0] policy
     /* 1857446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857480 */     // GIR_Coverage, 13702,
     /* 1857480 */     GIR_EraseRootFromParent_Done,
     /* 1857481 */   // Label 25119: @1857481
     /* 1857481 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1857567), // Rule ID 13703 //
     /* 1857486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857532 */     // MIs[0] policy
     /* 1857532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857566 */     // GIR_Coverage, 13703,
     /* 1857566 */     GIR_EraseRootFromParent_Done,
     /* 1857567 */   // Label 25120: @1857567
     /* 1857567 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1857653), // Rule ID 13706 //
     /* 1857572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857618 */     // MIs[0] policy
     /* 1857618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857652 */     // GIR_Coverage, 13706,
     /* 1857652 */     GIR_EraseRootFromParent_Done,
     /* 1857653 */   // Label 25121: @1857653
     /* 1857653 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1857739), // Rule ID 13707 //
     /* 1857658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857704 */     // MIs[0] policy
     /* 1857704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857738 */     // GIR_Coverage, 13707,
     /* 1857738 */     GIR_EraseRootFromParent_Done,
     /* 1857739 */   // Label 25122: @1857739
     /* 1857739 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1857825), // Rule ID 13710 //
     /* 1857744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857790 */     // MIs[0] policy
     /* 1857790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857824 */     // GIR_Coverage, 13710,
     /* 1857824 */     GIR_EraseRootFromParent_Done,
     /* 1857825 */   // Label 25123: @1857825
     /* 1857825 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1857911), // Rule ID 13711 //
     /* 1857830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857876 */     // MIs[0] policy
     /* 1857876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857910 */     // GIR_Coverage, 13711,
     /* 1857910 */     GIR_EraseRootFromParent_Done,
     /* 1857911 */   // Label 25124: @1857911
     /* 1857911 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1857997), // Rule ID 13714 //
     /* 1857916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857962 */     // MIs[0] policy
     /* 1857962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857996 */     // GIR_Coverage, 13714,
     /* 1857996 */     GIR_EraseRootFromParent_Done,
     /* 1857997 */   // Label 25125: @1857997
     /* 1857997 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1858083), // Rule ID 13715 //
     /* 1858002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1858013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1858016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1858019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1858022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858048 */     // MIs[0] policy
     /* 1858048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858082 */     // GIR_Coverage, 13715,
     /* 1858082 */     GIR_EraseRootFromParent_Done,
     /* 1858083 */   // Label 25126: @1858083
     /* 1858083 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1858169), // Rule ID 13718 //
     /* 1858088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858134 */     // MIs[0] policy
     /* 1858134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1858147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858168 */     // GIR_Coverage, 13718,
     /* 1858168 */     GIR_EraseRootFromParent_Done,
     /* 1858169 */   // Label 25127: @1858169
     /* 1858169 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1858255), // Rule ID 13719 //
     /* 1858174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1858191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858220 */     // MIs[0] policy
     /* 1858220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1858233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858254 */     // GIR_Coverage, 13719,
     /* 1858254 */     GIR_EraseRootFromParent_Done,
     /* 1858255 */   // Label 25128: @1858255
     /* 1858255 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1858341), // Rule ID 13722 //
     /* 1858260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858306 */     // MIs[0] policy
     /* 1858306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1858319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858340 */     // GIR_Coverage, 13722,
     /* 1858340 */     GIR_EraseRootFromParent_Done,
     /* 1858341 */   // Label 25129: @1858341
     /* 1858341 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1858427), // Rule ID 13723 //
     /* 1858346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858392 */     // MIs[0] policy
     /* 1858392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1858405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858426 */     // GIR_Coverage, 13723,
     /* 1858426 */     GIR_EraseRootFromParent_Done,
     /* 1858427 */   // Label 25130: @1858427
     /* 1858427 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1858513), // Rule ID 13726 //
     /* 1858432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858478 */     // MIs[0] policy
     /* 1858478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858488 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858512 */     // GIR_Coverage, 13726,
     /* 1858512 */     GIR_EraseRootFromParent_Done,
     /* 1858513 */   // Label 25131: @1858513
     /* 1858513 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1858599), // Rule ID 13727 //
     /* 1858518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858564 */     // MIs[0] policy
     /* 1858564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858598 */     // GIR_Coverage, 13727,
     /* 1858598 */     GIR_EraseRootFromParent_Done,
     /* 1858599 */   // Label 25132: @1858599
     /* 1858599 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1858685), // Rule ID 13730 //
     /* 1858604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858650 */     // MIs[0] policy
     /* 1858650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858684 */     // GIR_Coverage, 13730,
     /* 1858684 */     GIR_EraseRootFromParent_Done,
     /* 1858685 */   // Label 25133: @1858685
     /* 1858685 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1858771), // Rule ID 13731 //
     /* 1858690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858736 */     // MIs[0] policy
     /* 1858736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858770 */     // GIR_Coverage, 13731,
     /* 1858770 */     GIR_EraseRootFromParent_Done,
     /* 1858771 */   // Label 25134: @1858771
     /* 1858771 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1858857), // Rule ID 13734 //
     /* 1858776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858822 */     // MIs[0] policy
     /* 1858822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858856 */     // GIR_Coverage, 13734,
     /* 1858856 */     GIR_EraseRootFromParent_Done,
     /* 1858857 */   // Label 25135: @1858857
     /* 1858857 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1858943), // Rule ID 13735 //
     /* 1858862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858908 */     // MIs[0] policy
     /* 1858908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858918 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858942 */     // GIR_Coverage, 13735,
     /* 1858942 */     GIR_EraseRootFromParent_Done,
     /* 1858943 */   // Label 25136: @1858943
     /* 1858943 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1859029), // Rule ID 13738 //
     /* 1858948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858994 */     // MIs[0] policy
     /* 1858994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859004 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859028 */     // GIR_Coverage, 13738,
     /* 1859028 */     GIR_EraseRootFromParent_Done,
     /* 1859029 */   // Label 25137: @1859029
     /* 1859029 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1859115), // Rule ID 13739 //
     /* 1859034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1859045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1859048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1859054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859080 */     // MIs[0] policy
     /* 1859080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859114 */     // GIR_Coverage, 13739,
     /* 1859114 */     GIR_EraseRootFromParent_Done,
     /* 1859115 */   // Label 25138: @1859115
     /* 1859115 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1859201), // Rule ID 13742 //
     /* 1859120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859166 */     // MIs[0] policy
     /* 1859166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859200 */     // GIR_Coverage, 13742,
     /* 1859200 */     GIR_EraseRootFromParent_Done,
     /* 1859201 */   // Label 25139: @1859201
     /* 1859201 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1859287), // Rule ID 13743 //
     /* 1859206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859252 */     // MIs[0] policy
     /* 1859252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11706:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859286 */     // GIR_Coverage, 13743,
     /* 1859286 */     GIR_EraseRootFromParent_Done,
     /* 1859287 */   // Label 25140: @1859287
     /* 1859287 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1859373), // Rule ID 13746 //
     /* 1859292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859338 */     // MIs[0] policy
     /* 1859338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859372 */     // GIR_Coverage, 13746,
     /* 1859372 */     GIR_EraseRootFromParent_Done,
     /* 1859373 */   // Label 25141: @1859373
     /* 1859373 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1859459), // Rule ID 13747 //
     /* 1859378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859424 */     // MIs[0] policy
     /* 1859424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859458 */     // GIR_Coverage, 13747,
     /* 1859458 */     GIR_EraseRootFromParent_Done,
     /* 1859459 */   // Label 25142: @1859459
     /* 1859459 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1859545), // Rule ID 13750 //
     /* 1859464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859510 */     // MIs[0] policy
     /* 1859510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859544 */     // GIR_Coverage, 13750,
     /* 1859544 */     GIR_EraseRootFromParent_Done,
     /* 1859545 */   // Label 25143: @1859545
     /* 1859545 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1859631), // Rule ID 13751 //
     /* 1859550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859596 */     // MIs[0] policy
     /* 1859596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859606 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859630 */     // GIR_Coverage, 13751,
     /* 1859630 */     GIR_EraseRootFromParent_Done,
     /* 1859631 */   // Label 25144: @1859631
     /* 1859631 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1859717), // Rule ID 13754 //
     /* 1859636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859682 */     // MIs[0] policy
     /* 1859682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859716 */     // GIR_Coverage, 13754,
     /* 1859716 */     GIR_EraseRootFromParent_Done,
     /* 1859717 */   // Label 25145: @1859717
     /* 1859717 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1859803), // Rule ID 13755 //
     /* 1859722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859768 */     // MIs[0] policy
     /* 1859768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859802 */     // GIR_Coverage, 13755,
     /* 1859802 */     GIR_EraseRootFromParent_Done,
     /* 1859803 */   // Label 25146: @1859803
     /* 1859803 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1859889), // Rule ID 13758 //
     /* 1859808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859854 */     // MIs[0] policy
     /* 1859854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859864 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859888 */     // GIR_Coverage, 13758,
     /* 1859888 */     GIR_EraseRootFromParent_Done,
     /* 1859889 */   // Label 25147: @1859889
     /* 1859889 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1859975), // Rule ID 13759 //
     /* 1859894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859940 */     // MIs[0] policy
     /* 1859940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859974 */     // GIR_Coverage, 13759,
     /* 1859974 */     GIR_EraseRootFromParent_Done,
     /* 1859975 */   // Label 25148: @1859975
     /* 1859975 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1860061), // Rule ID 13762 //
     /* 1859980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860026 */     // MIs[0] policy
     /* 1860026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860060 */     // GIR_Coverage, 13762,
     /* 1860060 */     GIR_EraseRootFromParent_Done,
     /* 1860061 */   // Label 25149: @1860061
     /* 1860061 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1860147), // Rule ID 13763 //
     /* 1860066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1860077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1860080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1860086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860112 */     // MIs[0] policy
     /* 1860112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11706:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860146 */     // GIR_Coverage, 13763,
     /* 1860146 */     GIR_EraseRootFromParent_Done,
     /* 1860147 */   // Label 25150: @1860147
     /* 1860147 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1860233), // Rule ID 13766 //
     /* 1860152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860198 */     // MIs[0] policy
     /* 1860198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860232 */     // GIR_Coverage, 13766,
     /* 1860232 */     GIR_EraseRootFromParent_Done,
     /* 1860233 */   // Label 25151: @1860233
     /* 1860233 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1860319), // Rule ID 13767 //
     /* 1860238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860284 */     // MIs[0] policy
     /* 1860284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860318 */     // GIR_Coverage, 13767,
     /* 1860318 */     GIR_EraseRootFromParent_Done,
     /* 1860319 */   // Label 25152: @1860319
     /* 1860319 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1860405), // Rule ID 13770 //
     /* 1860324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860370 */     // MIs[0] policy
     /* 1860370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860404 */     // GIR_Coverage, 13770,
     /* 1860404 */     GIR_EraseRootFromParent_Done,
     /* 1860405 */   // Label 25153: @1860405
     /* 1860405 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1860491), // Rule ID 13771 //
     /* 1860410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860456 */     // MIs[0] policy
     /* 1860456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860490 */     // GIR_Coverage, 13771,
     /* 1860490 */     GIR_EraseRootFromParent_Done,
     /* 1860491 */   // Label 25154: @1860491
     /* 1860491 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1860577), // Rule ID 13774 //
     /* 1860496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860542 */     // MIs[0] policy
     /* 1860542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860576 */     // GIR_Coverage, 13774,
     /* 1860576 */     GIR_EraseRootFromParent_Done,
     /* 1860577 */   // Label 25155: @1860577
     /* 1860577 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1860663), // Rule ID 13775 //
     /* 1860582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860628 */     // MIs[0] policy
     /* 1860628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860662 */     // GIR_Coverage, 13775,
     /* 1860662 */     GIR_EraseRootFromParent_Done,
     /* 1860663 */   // Label 25156: @1860663
     /* 1860663 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1860749), // Rule ID 13778 //
     /* 1860668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860714 */     // MIs[0] policy
     /* 1860714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860748 */     // GIR_Coverage, 13778,
     /* 1860748 */     GIR_EraseRootFromParent_Done,
     /* 1860749 */   // Label 25157: @1860749
     /* 1860749 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1860835), // Rule ID 13779 //
     /* 1860754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860800 */     // MIs[0] policy
     /* 1860800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11706:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860834 */     // GIR_Coverage, 13779,
     /* 1860834 */     GIR_EraseRootFromParent_Done,
     /* 1860835 */   // Label 25158: @1860835
     /* 1860835 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1860921), // Rule ID 13782 //
     /* 1860840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860886 */     // MIs[0] policy
     /* 1860886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860920 */     // GIR_Coverage, 13782,
     /* 1860920 */     GIR_EraseRootFromParent_Done,
     /* 1860921 */   // Label 25159: @1860921
     /* 1860921 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1861007), // Rule ID 13783 //
     /* 1860926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860972 */     // MIs[0] policy
     /* 1860972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11706:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861006 */     // GIR_Coverage, 13783,
     /* 1861006 */     GIR_EraseRootFromParent_Done,
     /* 1861007 */   // Label 25160: @1861007
     /* 1861007 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1861093), // Rule ID 13786 //
     /* 1861012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861058 */     // MIs[0] policy
     /* 1861058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1861071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861092 */     // GIR_Coverage, 13786,
     /* 1861092 */     GIR_EraseRootFromParent_Done,
     /* 1861093 */   // Label 25161: @1861093
     /* 1861093 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1861179), // Rule ID 13787 //
     /* 1861098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1861109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1861112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1861118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861144 */     // MIs[0] policy
     /* 1861144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11706:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1861157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861178 */     // GIR_Coverage, 13787,
     /* 1861178 */     GIR_EraseRootFromParent_Done,
     /* 1861179 */   // Label 25162: @1861179
     /* 1861179 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1861265), // Rule ID 13790 //
     /* 1861184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861230 */     // MIs[0] policy
     /* 1861230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861240 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1861243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861264 */     // GIR_Coverage, 13790,
     /* 1861264 */     GIR_EraseRootFromParent_Done,
     /* 1861265 */   // Label 25163: @1861265
     /* 1861265 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1861351), // Rule ID 13791 //
     /* 1861270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1861278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861316 */     // MIs[0] policy
     /* 1861316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11706:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1861329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861350 */     // GIR_Coverage, 13791,
     /* 1861350 */     GIR_EraseRootFromParent_Done,
     /* 1861351 */   // Label 25164: @1861351
     /* 1861351 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1861437), // Rule ID 13794 //
     /* 1861356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861402 */     // MIs[0] policy
     /* 1861402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861436 */     // GIR_Coverage, 13794,
     /* 1861436 */     GIR_EraseRootFromParent_Done,
     /* 1861437 */   // Label 25165: @1861437
     /* 1861437 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1861523), // Rule ID 13795 //
     /* 1861442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861488 */     // MIs[0] policy
     /* 1861488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861522 */     // GIR_Coverage, 13795,
     /* 1861522 */     GIR_EraseRootFromParent_Done,
     /* 1861523 */   // Label 25166: @1861523
     /* 1861523 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1861609), // Rule ID 13798 //
     /* 1861528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861574 */     // MIs[0] policy
     /* 1861574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861608 */     // GIR_Coverage, 13798,
     /* 1861608 */     GIR_EraseRootFromParent_Done,
     /* 1861609 */   // Label 25167: @1861609
     /* 1861609 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1861695), // Rule ID 13799 //
     /* 1861614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861660 */     // MIs[0] policy
     /* 1861660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861694 */     // GIR_Coverage, 13799,
     /* 1861694 */     GIR_EraseRootFromParent_Done,
     /* 1861695 */   // Label 25168: @1861695
     /* 1861695 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1861781), // Rule ID 13802 //
     /* 1861700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861746 */     // MIs[0] policy
     /* 1861746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861780 */     // GIR_Coverage, 13802,
     /* 1861780 */     GIR_EraseRootFromParent_Done,
     /* 1861781 */   // Label 25169: @1861781
     /* 1861781 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1861867), // Rule ID 13803 //
     /* 1861786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861832 */     // MIs[0] policy
     /* 1861832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11710:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861866 */     // GIR_Coverage, 13803,
     /* 1861866 */     GIR_EraseRootFromParent_Done,
     /* 1861867 */   // Label 25170: @1861867
     /* 1861867 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1861953), // Rule ID 13806 //
     /* 1861872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861918 */     // MIs[0] policy
     /* 1861918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861952 */     // GIR_Coverage, 13806,
     /* 1861952 */     GIR_EraseRootFromParent_Done,
     /* 1861953 */   // Label 25171: @1861953
     /* 1861953 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1862039), // Rule ID 13807 //
     /* 1861958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862004 */     // MIs[0] policy
     /* 1862004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862038 */     // GIR_Coverage, 13807,
     /* 1862038 */     GIR_EraseRootFromParent_Done,
     /* 1862039 */   // Label 25172: @1862039
     /* 1862039 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1862125), // Rule ID 13810 //
     /* 1862044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862090 */     // MIs[0] policy
     /* 1862090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862100 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862124 */     // GIR_Coverage, 13810,
     /* 1862124 */     GIR_EraseRootFromParent_Done,
     /* 1862125 */   // Label 25173: @1862125
     /* 1862125 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1862211), // Rule ID 13811 //
     /* 1862130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1862141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1862144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1862150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862176 */     // MIs[0] policy
     /* 1862176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862210 */     // GIR_Coverage, 13811,
     /* 1862210 */     GIR_EraseRootFromParent_Done,
     /* 1862211 */   // Label 25174: @1862211
     /* 1862211 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1862297), // Rule ID 13814 //
     /* 1862216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1862227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1862230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1862236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862262 */     // MIs[0] policy
     /* 1862262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862296 */     // GIR_Coverage, 13814,
     /* 1862296 */     GIR_EraseRootFromParent_Done,
     /* 1862297 */   // Label 25175: @1862297
     /* 1862297 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1862383), // Rule ID 13815 //
     /* 1862302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1862313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1862316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1862322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862348 */     // MIs[0] policy
     /* 1862348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862358 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862382 */     // GIR_Coverage, 13815,
     /* 1862382 */     GIR_EraseRootFromParent_Done,
     /* 1862383 */   // Label 25176: @1862383
     /* 1862383 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1862469), // Rule ID 13818 //
     /* 1862388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862434 */     // MIs[0] policy
     /* 1862434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862468 */     // GIR_Coverage, 13818,
     /* 1862468 */     GIR_EraseRootFromParent_Done,
     /* 1862469 */   // Label 25177: @1862469
     /* 1862469 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1862555), // Rule ID 13819 //
     /* 1862474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862520 */     // MIs[0] policy
     /* 1862520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862554 */     // GIR_Coverage, 13819,
     /* 1862554 */     GIR_EraseRootFromParent_Done,
     /* 1862555 */   // Label 25178: @1862555
     /* 1862555 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1862641), // Rule ID 13822 //
     /* 1862560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862606 */     // MIs[0] policy
     /* 1862606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862640 */     // GIR_Coverage, 13822,
     /* 1862640 */     GIR_EraseRootFromParent_Done,
     /* 1862641 */   // Label 25179: @1862641
     /* 1862641 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1862727), // Rule ID 13823 //
     /* 1862646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862692 */     // MIs[0] policy
     /* 1862692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11710:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862726 */     // GIR_Coverage, 13823,
     /* 1862726 */     GIR_EraseRootFromParent_Done,
     /* 1862727 */   // Label 25180: @1862727
     /* 1862727 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1862813), // Rule ID 13826 //
     /* 1862732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862778 */     // MIs[0] policy
     /* 1862778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862812 */     // GIR_Coverage, 13826,
     /* 1862812 */     GIR_EraseRootFromParent_Done,
     /* 1862813 */   // Label 25181: @1862813
     /* 1862813 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1862899), // Rule ID 13827 //
     /* 1862818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862864 */     // MIs[0] policy
     /* 1862864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862898 */     // GIR_Coverage, 13827,
     /* 1862898 */     GIR_EraseRootFromParent_Done,
     /* 1862899 */   // Label 25182: @1862899
     /* 1862899 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1862985), // Rule ID 13830 //
     /* 1862904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862950 */     // MIs[0] policy
     /* 1862950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862960 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862984 */     // GIR_Coverage, 13830,
     /* 1862984 */     GIR_EraseRootFromParent_Done,
     /* 1862985 */   // Label 25183: @1862985
     /* 1862985 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1863071), // Rule ID 13831 //
     /* 1862990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863036 */     // MIs[0] policy
     /* 1863036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863070 */     // GIR_Coverage, 13831,
     /* 1863070 */     GIR_EraseRootFromParent_Done,
     /* 1863071 */   // Label 25184: @1863071
     /* 1863071 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1863157), // Rule ID 13834 //
     /* 1863076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863122 */     // MIs[0] policy
     /* 1863122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863132 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863156 */     // GIR_Coverage, 13834,
     /* 1863156 */     GIR_EraseRootFromParent_Done,
     /* 1863157 */   // Label 25185: @1863157
     /* 1863157 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1863243), // Rule ID 13835 //
     /* 1863162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1863173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1863176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863208 */     // MIs[0] policy
     /* 1863208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863242 */     // GIR_Coverage, 13835,
     /* 1863242 */     GIR_EraseRootFromParent_Done,
     /* 1863243 */   // Label 25186: @1863243
     /* 1863243 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1863329), // Rule ID 13838 //
     /* 1863248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1863259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1863262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1863268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863294 */     // MIs[0] policy
     /* 1863294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1863307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863328 */     // GIR_Coverage, 13838,
     /* 1863328 */     GIR_EraseRootFromParent_Done,
     /* 1863329 */   // Label 25187: @1863329
     /* 1863329 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1863415), // Rule ID 13839 //
     /* 1863334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1863345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1863348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1863354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863380 */     // MIs[0] policy
     /* 1863380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11710:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1863393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863414 */     // GIR_Coverage, 13839,
     /* 1863414 */     GIR_EraseRootFromParent_Done,
     /* 1863415 */   // Label 25188: @1863415
     /* 1863415 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1863501), // Rule ID 13842 //
     /* 1863420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863466 */     // MIs[0] policy
     /* 1863466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863500 */     // GIR_Coverage, 13842,
     /* 1863500 */     GIR_EraseRootFromParent_Done,
     /* 1863501 */   // Label 25189: @1863501
     /* 1863501 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1863587), // Rule ID 13843 //
     /* 1863506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863552 */     // MIs[0] policy
     /* 1863552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11710:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863586 */     // GIR_Coverage, 13843,
     /* 1863586 */     GIR_EraseRootFromParent_Done,
     /* 1863587 */   // Label 25190: @1863587
     /* 1863587 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1863673), // Rule ID 13846 //
     /* 1863592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863638 */     // MIs[0] policy
     /* 1863638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863672 */     // GIR_Coverage, 13846,
     /* 1863672 */     GIR_EraseRootFromParent_Done,
     /* 1863673 */   // Label 25191: @1863673
     /* 1863673 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1863759), // Rule ID 13847 //
     /* 1863678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863724 */     // MIs[0] policy
     /* 1863724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11710:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863758 */     // GIR_Coverage, 13847,
     /* 1863758 */     GIR_EraseRootFromParent_Done,
     /* 1863759 */   // Label 25192: @1863759
     /* 1863759 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1863845), // Rule ID 13850 //
     /* 1863764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863810 */     // MIs[0] policy
     /* 1863810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863844 */     // GIR_Coverage, 13850,
     /* 1863844 */     GIR_EraseRootFromParent_Done,
     /* 1863845 */   // Label 25193: @1863845
     /* 1863845 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1863931), // Rule ID 13851 //
     /* 1863850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863896 */     // MIs[0] policy
     /* 1863896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11710:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863930 */     // GIR_Coverage, 13851,
     /* 1863930 */     GIR_EraseRootFromParent_Done,
     /* 1863931 */   // Label 25194: @1863931
     /* 1863931 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1864020), // Rule ID 14060 //
     /* 1863936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863982 */     // MIs[0] policy
     /* 1863982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1863995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864019 */     // GIR_Coverage, 14060,
     /* 1864019 */     GIR_EraseRootFromParent_Done,
     /* 1864020 */   // Label 25195: @1864020
     /* 1864020 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1864109), // Rule ID 14061 //
     /* 1864025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1864036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1864039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864071 */     // MIs[0] policy
     /* 1864071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864081 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1864084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864108 */     // GIR_Coverage, 14061,
     /* 1864108 */     GIR_EraseRootFromParent_Done,
     /* 1864109 */   // Label 25196: @1864109
     /* 1864109 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1864198), // Rule ID 14064 //
     /* 1864114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864160 */     // MIs[0] policy
     /* 1864160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864170 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864197 */     // GIR_Coverage, 14064,
     /* 1864197 */     GIR_EraseRootFromParent_Done,
     /* 1864198 */   // Label 25197: @1864198
     /* 1864198 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1864287), // Rule ID 14065 //
     /* 1864203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864249 */     // MIs[0] policy
     /* 1864249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864259 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864286 */     // GIR_Coverage, 14065,
     /* 1864286 */     GIR_EraseRootFromParent_Done,
     /* 1864287 */   // Label 25198: @1864287
     /* 1864287 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1864376), // Rule ID 14068 //
     /* 1864292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1864303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1864306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864338 */     // MIs[0] policy
     /* 1864338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864348 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864375 */     // GIR_Coverage, 14068,
     /* 1864375 */     GIR_EraseRootFromParent_Done,
     /* 1864376 */   // Label 25199: @1864376
     /* 1864376 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1864465), // Rule ID 14069 //
     /* 1864381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1864392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1864395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1864398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1864401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864427 */     // MIs[0] policy
     /* 1864427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864437 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864464 */     // GIR_Coverage, 14069,
     /* 1864464 */     GIR_EraseRootFromParent_Done,
     /* 1864465 */   // Label 25200: @1864465
     /* 1864465 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1864554), // Rule ID 14072 //
     /* 1864470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864516 */     // MIs[0] policy
     /* 1864516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864553 */     // GIR_Coverage, 14072,
     /* 1864553 */     GIR_EraseRootFromParent_Done,
     /* 1864554 */   // Label 25201: @1864554
     /* 1864554 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1864643), // Rule ID 14073 //
     /* 1864559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864605 */     // MIs[0] policy
     /* 1864605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864615 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864642 */     // GIR_Coverage, 14073,
     /* 1864642 */     GIR_EraseRootFromParent_Done,
     /* 1864643 */   // Label 25202: @1864643
     /* 1864643 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1864732), // Rule ID 14076 //
     /* 1864648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864694 */     // MIs[0] policy
     /* 1864694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864731 */     // GIR_Coverage, 14076,
     /* 1864731 */     GIR_EraseRootFromParent_Done,
     /* 1864732 */   // Label 25203: @1864732
     /* 1864732 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1864821), // Rule ID 14077 //
     /* 1864737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864783 */     // MIs[0] policy
     /* 1864783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864820 */     // GIR_Coverage, 14077,
     /* 1864820 */     GIR_EraseRootFromParent_Done,
     /* 1864821 */   // Label 25204: @1864821
     /* 1864821 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1864910), // Rule ID 14080 //
     /* 1864826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864872 */     // MIs[0] policy
     /* 1864872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864909 */     // GIR_Coverage, 14080,
     /* 1864909 */     GIR_EraseRootFromParent_Done,
     /* 1864910 */   // Label 25205: @1864910
     /* 1864910 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1864999), // Rule ID 14081 //
     /* 1864915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864961 */     // MIs[0] policy
     /* 1864961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864971 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864998 */     // GIR_Coverage, 14081,
     /* 1864998 */     GIR_EraseRootFromParent_Done,
     /* 1864999 */   // Label 25206: @1864999
     /* 1864999 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1865088), // Rule ID 14084 //
     /* 1865004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865050 */     // MIs[0] policy
     /* 1865050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865087 */     // GIR_Coverage, 14084,
     /* 1865087 */     GIR_EraseRootFromParent_Done,
     /* 1865088 */   // Label 25207: @1865088
     /* 1865088 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1865177), // Rule ID 14085 //
     /* 1865093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865139 */     // MIs[0] policy
     /* 1865139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865149 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865176 */     // GIR_Coverage, 14085,
     /* 1865176 */     GIR_EraseRootFromParent_Done,
     /* 1865177 */   // Label 25208: @1865177
     /* 1865177 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1865266), // Rule ID 14088 //
     /* 1865182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865228 */     // MIs[0] policy
     /* 1865228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865265 */     // GIR_Coverage, 14088,
     /* 1865265 */     GIR_EraseRootFromParent_Done,
     /* 1865266 */   // Label 25209: @1865266
     /* 1865266 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1865355), // Rule ID 14089 //
     /* 1865271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865317 */     // MIs[0] policy
     /* 1865317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865354 */     // GIR_Coverage, 14089,
     /* 1865354 */     GIR_EraseRootFromParent_Done,
     /* 1865355 */   // Label 25210: @1865355
     /* 1865355 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1865444), // Rule ID 14092 //
     /* 1865360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865406 */     // MIs[0] policy
     /* 1865406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865443 */     // GIR_Coverage, 14092,
     /* 1865443 */     GIR_EraseRootFromParent_Done,
     /* 1865444 */   // Label 25211: @1865444
     /* 1865444 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1865533), // Rule ID 14093 //
     /* 1865449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1865460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1865463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865495 */     // MIs[0] policy
     /* 1865495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865505 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865532 */     // GIR_Coverage, 14093,
     /* 1865532 */     GIR_EraseRootFromParent_Done,
     /* 1865533 */   // Label 25212: @1865533
     /* 1865533 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1865622), // Rule ID 14096 //
     /* 1865538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1865541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865584 */     // MIs[0] policy
     /* 1865584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865621 */     // GIR_Coverage, 14096,
     /* 1865621 */     GIR_EraseRootFromParent_Done,
     /* 1865622 */   // Label 25213: @1865622
     /* 1865622 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1865711), // Rule ID 14097 //
     /* 1865627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1865630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865673 */     // MIs[0] policy
     /* 1865673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865710 */     // GIR_Coverage, 14097,
     /* 1865710 */     GIR_EraseRootFromParent_Done,
     /* 1865711 */   // Label 25214: @1865711
     /* 1865711 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1865800), // Rule ID 14100 //
     /* 1865716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865762 */     // MIs[0] policy
     /* 1865762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865799 */     // GIR_Coverage, 14100,
     /* 1865799 */     GIR_EraseRootFromParent_Done,
     /* 1865800 */   // Label 25215: @1865800
     /* 1865800 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1865889), // Rule ID 14101 //
     /* 1865805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865851 */     // MIs[0] policy
     /* 1865851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865888 */     // GIR_Coverage, 14101,
     /* 1865888 */     GIR_EraseRootFromParent_Done,
     /* 1865889 */   // Label 25216: @1865889
     /* 1865889 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1865978), // Rule ID 14104 //
     /* 1865894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865940 */     // MIs[0] policy
     /* 1865940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865950 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865977 */     // GIR_Coverage, 14104,
     /* 1865977 */     GIR_EraseRootFromParent_Done,
     /* 1865978 */   // Label 25217: @1865978
     /* 1865978 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1866067), // Rule ID 14105 //
     /* 1865983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1866000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1866003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866029 */     // MIs[0] policy
     /* 1866029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866039 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866066 */     // GIR_Coverage, 14105,
     /* 1866066 */     GIR_EraseRootFromParent_Done,
     /* 1866067 */   // Label 25218: @1866067
     /* 1866067 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1866156), // Rule ID 14108 //
     /* 1866072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866118 */     // MIs[0] policy
     /* 1866118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866155 */     // GIR_Coverage, 14108,
     /* 1866155 */     GIR_EraseRootFromParent_Done,
     /* 1866156 */   // Label 25219: @1866156
     /* 1866156 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1866245), // Rule ID 14109 //
     /* 1866161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866207 */     // MIs[0] policy
     /* 1866207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866217 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866244 */     // GIR_Coverage, 14109,
     /* 1866244 */     GIR_EraseRootFromParent_Done,
     /* 1866245 */   // Label 25220: @1866245
     /* 1866245 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1866334), // Rule ID 14112 //
     /* 1866250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1866261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1866264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866296 */     // MIs[0] policy
     /* 1866296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866333 */     // GIR_Coverage, 14112,
     /* 1866333 */     GIR_EraseRootFromParent_Done,
     /* 1866334 */   // Label 25221: @1866334
     /* 1866334 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1866423), // Rule ID 14113 //
     /* 1866339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1866350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1866353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1866356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1866359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866385 */     // MIs[0] policy
     /* 1866385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866422 */     // GIR_Coverage, 14113,
     /* 1866422 */     GIR_EraseRootFromParent_Done,
     /* 1866423 */   // Label 25222: @1866423
     /* 1866423 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1866512), // Rule ID 14116 //
     /* 1866428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866474 */     // MIs[0] policy
     /* 1866474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866511 */     // GIR_Coverage, 14116,
     /* 1866511 */     GIR_EraseRootFromParent_Done,
     /* 1866512 */   // Label 25223: @1866512
     /* 1866512 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1866601), // Rule ID 14117 //
     /* 1866517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866563 */     // MIs[0] policy
     /* 1866563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866573 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866600 */     // GIR_Coverage, 14117,
     /* 1866600 */     GIR_EraseRootFromParent_Done,
     /* 1866601 */   // Label 25224: @1866601
     /* 1866601 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1866690), // Rule ID 14120 //
     /* 1866606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866652 */     // MIs[0] policy
     /* 1866652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866662 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866689 */     // GIR_Coverage, 14120,
     /* 1866689 */     GIR_EraseRootFromParent_Done,
     /* 1866690 */   // Label 25225: @1866690
     /* 1866690 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1866779), // Rule ID 14121 //
     /* 1866695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866741 */     // MIs[0] policy
     /* 1866741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866778 */     // GIR_Coverage, 14121,
     /* 1866778 */     GIR_EraseRootFromParent_Done,
     /* 1866779 */   // Label 25226: @1866779
     /* 1866779 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1866868), // Rule ID 14124 //
     /* 1866784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866830 */     // MIs[0] policy
     /* 1866830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866867 */     // GIR_Coverage, 14124,
     /* 1866867 */     GIR_EraseRootFromParent_Done,
     /* 1866868 */   // Label 25227: @1866868
     /* 1866868 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1866957), // Rule ID 14125 //
     /* 1866873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866919 */     // MIs[0] policy
     /* 1866919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866956 */     // GIR_Coverage, 14125,
     /* 1866956 */     GIR_EraseRootFromParent_Done,
     /* 1866957 */   // Label 25228: @1866957
     /* 1866957 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1867046), // Rule ID 14128 //
     /* 1866962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867008 */     // MIs[0] policy
     /* 1867008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867045 */     // GIR_Coverage, 14128,
     /* 1867045 */     GIR_EraseRootFromParent_Done,
     /* 1867046 */   // Label 25229: @1867046
     /* 1867046 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1867135), // Rule ID 14129 //
     /* 1867051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1867062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1867065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1867068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867097 */     // MIs[0] policy
     /* 1867097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867134 */     // GIR_Coverage, 14129,
     /* 1867134 */     GIR_EraseRootFromParent_Done,
     /* 1867135 */   // Label 25230: @1867135
     /* 1867135 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1867224), // Rule ID 14132 //
     /* 1867140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1867151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1867154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1867157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1867160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867186 */     // MIs[0] policy
     /* 1867186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867223 */     // GIR_Coverage, 14132,
     /* 1867223 */     GIR_EraseRootFromParent_Done,
     /* 1867224 */   // Label 25231: @1867224
     /* 1867224 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1867313), // Rule ID 14133 //
     /* 1867229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1867240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1867243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1867246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1867249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867275 */     // MIs[0] policy
     /* 1867275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867285 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867312 */     // GIR_Coverage, 14133,
     /* 1867312 */     GIR_EraseRootFromParent_Done,
     /* 1867313 */   // Label 25232: @1867313
     /* 1867313 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1867402), // Rule ID 14136 //
     /* 1867318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1867329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1867332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1867335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1867338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867364 */     // MIs[0] policy
     /* 1867364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867401 */     // GIR_Coverage, 14136,
     /* 1867401 */     GIR_EraseRootFromParent_Done,
     /* 1867402 */   // Label 25233: @1867402
     /* 1867402 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1867491), // Rule ID 14137 //
     /* 1867407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1867418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1867421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1867424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1867427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867453 */     // MIs[0] policy
     /* 1867453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867490 */     // GIR_Coverage, 14137,
     /* 1867490 */     GIR_EraseRootFromParent_Done,
     /* 1867491 */   // Label 25234: @1867491
     /* 1867491 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1867580), // Rule ID 14140 //
     /* 1867496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867542 */     // MIs[0] policy
     /* 1867542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867579 */     // GIR_Coverage, 14140,
     /* 1867579 */     GIR_EraseRootFromParent_Done,
     /* 1867580 */   // Label 25235: @1867580
     /* 1867580 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1867669), // Rule ID 14141 //
     /* 1867585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867631 */     // MIs[0] policy
     /* 1867631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867668 */     // GIR_Coverage, 14141,
     /* 1867668 */     GIR_EraseRootFromParent_Done,
     /* 1867669 */   // Label 25236: @1867669
     /* 1867669 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1867758), // Rule ID 14144 //
     /* 1867674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867720 */     // MIs[0] policy
     /* 1867720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867757 */     // GIR_Coverage, 14144,
     /* 1867757 */     GIR_EraseRootFromParent_Done,
     /* 1867758 */   // Label 25237: @1867758
     /* 1867758 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1867847), // Rule ID 14145 //
     /* 1867763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867809 */     // MIs[0] policy
     /* 1867809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867819 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867846 */     // GIR_Coverage, 14145,
     /* 1867846 */     GIR_EraseRootFromParent_Done,
     /* 1867847 */   // Label 25238: @1867847
     /* 1867847 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1867936), // Rule ID 14148 //
     /* 1867852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867898 */     // MIs[0] policy
     /* 1867898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867908 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867935 */     // GIR_Coverage, 14148,
     /* 1867935 */     GIR_EraseRootFromParent_Done,
     /* 1867936 */   // Label 25239: @1867936
     /* 1867936 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1868025), // Rule ID 14149 //
     /* 1867941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867987 */     // MIs[0] policy
     /* 1867987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867997 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1868000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868024 */     // GIR_Coverage, 14149,
     /* 1868024 */     GIR_EraseRootFromParent_Done,
     /* 1868025 */   // Label 25240: @1868025
     /* 1868025 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1868114), // Rule ID 14152 //
     /* 1868030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868076 */     // MIs[0] policy
     /* 1868076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868113 */     // GIR_Coverage, 14152,
     /* 1868113 */     GIR_EraseRootFromParent_Done,
     /* 1868114 */   // Label 25241: @1868114
     /* 1868114 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1868203), // Rule ID 14153 //
     /* 1868119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868165 */     // MIs[0] policy
     /* 1868165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868175 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868202 */     // GIR_Coverage, 14153,
     /* 1868202 */     GIR_EraseRootFromParent_Done,
     /* 1868203 */   // Label 25242: @1868203
     /* 1868203 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1868292), // Rule ID 14156 //
     /* 1868208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1868219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1868222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1868225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868254 */     // MIs[0] policy
     /* 1868254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868291 */     // GIR_Coverage, 14156,
     /* 1868291 */     GIR_EraseRootFromParent_Done,
     /* 1868292 */   // Label 25243: @1868292
     /* 1868292 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1868381), // Rule ID 14157 //
     /* 1868297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1868308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1868311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1868314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868343 */     // MIs[0] policy
     /* 1868343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868353 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868380 */     // GIR_Coverage, 14157,
     /* 1868380 */     GIR_EraseRootFromParent_Done,
     /* 1868381 */   // Label 25244: @1868381
     /* 1868381 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1868470), // Rule ID 14160 //
     /* 1868386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868432 */     // MIs[0] policy
     /* 1868432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868442 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868469 */     // GIR_Coverage, 14160,
     /* 1868469 */     GIR_EraseRootFromParent_Done,
     /* 1868470 */   // Label 25245: @1868470
     /* 1868470 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1868559), // Rule ID 14161 //
     /* 1868475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868521 */     // MIs[0] policy
     /* 1868521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868531 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868558 */     // GIR_Coverage, 14161,
     /* 1868558 */     GIR_EraseRootFromParent_Done,
     /* 1868559 */   // Label 25246: @1868559
     /* 1868559 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1868648), // Rule ID 14164 //
     /* 1868564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868610 */     // MIs[0] policy
     /* 1868610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868647 */     // GIR_Coverage, 14164,
     /* 1868647 */     GIR_EraseRootFromParent_Done,
     /* 1868648 */   // Label 25247: @1868648
     /* 1868648 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1868737), // Rule ID 14165 //
     /* 1868653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868699 */     // MIs[0] policy
     /* 1868699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868709 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868736 */     // GIR_Coverage, 14165,
     /* 1868736 */     GIR_EraseRootFromParent_Done,
     /* 1868737 */   // Label 25248: @1868737
     /* 1868737 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1868826), // Rule ID 14168 //
     /* 1868742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868788 */     // MIs[0] policy
     /* 1868788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868825 */     // GIR_Coverage, 14168,
     /* 1868825 */     GIR_EraseRootFromParent_Done,
     /* 1868826 */   // Label 25249: @1868826
     /* 1868826 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1868915), // Rule ID 14169 //
     /* 1868831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868877 */     // MIs[0] policy
     /* 1868877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868887 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868914 */     // GIR_Coverage, 14169,
     /* 1868914 */     GIR_EraseRootFromParent_Done,
     /* 1868915 */   // Label 25250: @1868915
     /* 1868915 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1869004), // Rule ID 14172 //
     /* 1868920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868966 */     // MIs[0] policy
     /* 1868966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869003 */     // GIR_Coverage, 14172,
     /* 1869003 */     GIR_EraseRootFromParent_Done,
     /* 1869004 */   // Label 25251: @1869004
     /* 1869004 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1869093), // Rule ID 14173 //
     /* 1869009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1869020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1869023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1869026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869055 */     // MIs[0] policy
     /* 1869055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11590:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869092 */     // GIR_Coverage, 14173,
     /* 1869092 */     GIR_EraseRootFromParent_Done,
     /* 1869093 */   // Label 25252: @1869093
     /* 1869093 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1869182), // Rule ID 14176 //
     /* 1869098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869144 */     // MIs[0] policy
     /* 1869144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869181 */     // GIR_Coverage, 14176,
     /* 1869181 */     GIR_EraseRootFromParent_Done,
     /* 1869182 */   // Label 25253: @1869182
     /* 1869182 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1869271), // Rule ID 14177 //
     /* 1869187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869233 */     // MIs[0] policy
     /* 1869233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869270 */     // GIR_Coverage, 14177,
     /* 1869270 */     GIR_EraseRootFromParent_Done,
     /* 1869271 */   // Label 25254: @1869271
     /* 1869271 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1869360), // Rule ID 14180 //
     /* 1869276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1869287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1869290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869322 */     // MIs[0] policy
     /* 1869322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869359 */     // GIR_Coverage, 14180,
     /* 1869359 */     GIR_EraseRootFromParent_Done,
     /* 1869360 */   // Label 25255: @1869360
     /* 1869360 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1869449), // Rule ID 14181 //
     /* 1869365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1869376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1869379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1869382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869411 */     // MIs[0] policy
     /* 1869411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869421 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869448 */     // GIR_Coverage, 14181,
     /* 1869448 */     GIR_EraseRootFromParent_Done,
     /* 1869449 */   // Label 25256: @1869449
     /* 1869449 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1869538), // Rule ID 14184 //
     /* 1869454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1869457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869500 */     // MIs[0] policy
     /* 1869500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869510 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869537 */     // GIR_Coverage, 14184,
     /* 1869537 */     GIR_EraseRootFromParent_Done,
     /* 1869538 */   // Label 25257: @1869538
     /* 1869538 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1869627), // Rule ID 14185 //
     /* 1869543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1869546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869589 */     // MIs[0] policy
     /* 1869589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869599 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869626 */     // GIR_Coverage, 14185,
     /* 1869626 */     GIR_EraseRootFromParent_Done,
     /* 1869627 */   // Label 25258: @1869627
     /* 1869627 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1869716), // Rule ID 14188 //
     /* 1869632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869678 */     // MIs[0] policy
     /* 1869678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869715 */     // GIR_Coverage, 14188,
     /* 1869715 */     GIR_EraseRootFromParent_Done,
     /* 1869716 */   // Label 25259: @1869716
     /* 1869716 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1869805), // Rule ID 14189 //
     /* 1869721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869767 */     // MIs[0] policy
     /* 1869767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869804 */     // GIR_Coverage, 14189,
     /* 1869804 */     GIR_EraseRootFromParent_Done,
     /* 1869805 */   // Label 25260: @1869805
     /* 1869805 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1869894), // Rule ID 14192 //
     /* 1869810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869856 */     // MIs[0] policy
     /* 1869856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869866 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869893 */     // GIR_Coverage, 14192,
     /* 1869893 */     GIR_EraseRootFromParent_Done,
     /* 1869894 */   // Label 25261: @1869894
     /* 1869894 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1869983), // Rule ID 14193 //
     /* 1869899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869945 */     // MIs[0] policy
     /* 1869945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869982 */     // GIR_Coverage, 14193,
     /* 1869982 */     GIR_EraseRootFromParent_Done,
     /* 1869983 */   // Label 25262: @1869983
     /* 1869983 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1870072), // Rule ID 14196 //
     /* 1869988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870034 */     // MIs[0] policy
     /* 1870034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870071 */     // GIR_Coverage, 14196,
     /* 1870071 */     GIR_EraseRootFromParent_Done,
     /* 1870072 */   // Label 25263: @1870072
     /* 1870072 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1870161), // Rule ID 14197 //
     /* 1870077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1870088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870123 */     // MIs[0] policy
     /* 1870123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870133 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870160 */     // GIR_Coverage, 14197,
     /* 1870160 */     GIR_EraseRootFromParent_Done,
     /* 1870161 */   // Label 25264: @1870161
     /* 1870161 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1870250), // Rule ID 14200 //
     /* 1870166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1870177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1870180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1870183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870212 */     // MIs[0] policy
     /* 1870212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870249 */     // GIR_Coverage, 14200,
     /* 1870249 */     GIR_EraseRootFromParent_Done,
     /* 1870250 */   // Label 25265: @1870250
     /* 1870250 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1870339), // Rule ID 14201 //
     /* 1870255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1870266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1870269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1870272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870301 */     // MIs[0] policy
     /* 1870301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870338 */     // GIR_Coverage, 14201,
     /* 1870338 */     GIR_EraseRootFromParent_Done,
     /* 1870339 */   // Label 25266: @1870339
     /* 1870339 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1870428), // Rule ID 14204 //
     /* 1870344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1870355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1870358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1870361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870390 */     // MIs[0] policy
     /* 1870390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870427 */     // GIR_Coverage, 14204,
     /* 1870427 */     GIR_EraseRootFromParent_Done,
     /* 1870428 */   // Label 25267: @1870428
     /* 1870428 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1870517), // Rule ID 14205 //
     /* 1870433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1870444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1870447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1870450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870479 */     // MIs[0] policy
     /* 1870479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870489 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870516 */     // GIR_Coverage, 14205,
     /* 1870516 */     GIR_EraseRootFromParent_Done,
     /* 1870517 */   // Label 25268: @1870517
     /* 1870517 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1870606), // Rule ID 14208 //
     /* 1870522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870568 */     // MIs[0] policy
     /* 1870568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870605 */     // GIR_Coverage, 14208,
     /* 1870605 */     GIR_EraseRootFromParent_Done,
     /* 1870606 */   // Label 25269: @1870606
     /* 1870606 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1870695), // Rule ID 14209 //
     /* 1870611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870657 */     // MIs[0] policy
     /* 1870657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870667 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870694 */     // GIR_Coverage, 14209,
     /* 1870694 */     GIR_EraseRootFromParent_Done,
     /* 1870695 */   // Label 25270: @1870695
     /* 1870695 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1870784), // Rule ID 14212 //
     /* 1870700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870746 */     // MIs[0] policy
     /* 1870746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870783 */     // GIR_Coverage, 14212,
     /* 1870783 */     GIR_EraseRootFromParent_Done,
     /* 1870784 */   // Label 25271: @1870784
     /* 1870784 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1870873), // Rule ID 14213 //
     /* 1870789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870835 */     // MIs[0] policy
     /* 1870835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870872 */     // GIR_Coverage, 14213,
     /* 1870872 */     GIR_EraseRootFromParent_Done,
     /* 1870873 */   // Label 25272: @1870873
     /* 1870873 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1870962), // Rule ID 14216 //
     /* 1870878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870924 */     // MIs[0] policy
     /* 1870924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870961 */     // GIR_Coverage, 14216,
     /* 1870961 */     GIR_EraseRootFromParent_Done,
     /* 1870962 */   // Label 25273: @1870962
     /* 1870962 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1871051), // Rule ID 14217 //
     /* 1870967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871013 */     // MIs[0] policy
     /* 1871013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871050 */     // GIR_Coverage, 14217,
     /* 1871050 */     GIR_EraseRootFromParent_Done,
     /* 1871051 */   // Label 25274: @1871051
     /* 1871051 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1871140), // Rule ID 14220 //
     /* 1871056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871102 */     // MIs[0] policy
     /* 1871102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871139 */     // GIR_Coverage, 14220,
     /* 1871139 */     GIR_EraseRootFromParent_Done,
     /* 1871140 */   // Label 25275: @1871140
     /* 1871140 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1871229), // Rule ID 14221 //
     /* 1871145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871191 */     // MIs[0] policy
     /* 1871191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871201 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871228 */     // GIR_Coverage, 14221,
     /* 1871228 */     GIR_EraseRootFromParent_Done,
     /* 1871229 */   // Label 25276: @1871229
     /* 1871229 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1871318), // Rule ID 14224 //
     /* 1871234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871280 */     // MIs[0] policy
     /* 1871280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1871293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871317 */     // GIR_Coverage, 14224,
     /* 1871317 */     GIR_EraseRootFromParent_Done,
     /* 1871318 */   // Label 25277: @1871318
     /* 1871318 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1871407), // Rule ID 14225 //
     /* 1871323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1871334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1871337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1871340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871369 */     // MIs[0] policy
     /* 1871369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1871382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871406 */     // GIR_Coverage, 14225,
     /* 1871406 */     GIR_EraseRootFromParent_Done,
     /* 1871407 */   // Label 25278: @1871407
     /* 1871407 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1871496), // Rule ID 14228 //
     /* 1871412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871458 */     // MIs[0] policy
     /* 1871458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871495 */     // GIR_Coverage, 14228,
     /* 1871495 */     GIR_EraseRootFromParent_Done,
     /* 1871496 */   // Label 25279: @1871496
     /* 1871496 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1871585), // Rule ID 14229 //
     /* 1871501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871547 */     // MIs[0] policy
     /* 1871547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871584 */     // GIR_Coverage, 14229,
     /* 1871584 */     GIR_EraseRootFromParent_Done,
     /* 1871585 */   // Label 25280: @1871585
     /* 1871585 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1871674), // Rule ID 14232 //
     /* 1871590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871636 */     // MIs[0] policy
     /* 1871636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871673 */     // GIR_Coverage, 14232,
     /* 1871673 */     GIR_EraseRootFromParent_Done,
     /* 1871674 */   // Label 25281: @1871674
     /* 1871674 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1871763), // Rule ID 14233 //
     /* 1871679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871725 */     // MIs[0] policy
     /* 1871725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871735 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871762 */     // GIR_Coverage, 14233,
     /* 1871762 */     GIR_EraseRootFromParent_Done,
     /* 1871763 */   // Label 25282: @1871763
     /* 1871763 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1871852), // Rule ID 14324 //
     /* 1871768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871814 */     // MIs[0] policy
     /* 1871814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871824 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871851 */     // GIR_Coverage, 14324,
     /* 1871851 */     GIR_EraseRootFromParent_Done,
     /* 1871852 */   // Label 25283: @1871852
     /* 1871852 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1871941), // Rule ID 14325 //
     /* 1871857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871903 */     // MIs[0] policy
     /* 1871903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871913 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871940 */     // GIR_Coverage, 14325,
     /* 1871940 */     GIR_EraseRootFromParent_Done,
     /* 1871941 */   // Label 25284: @1871941
     /* 1871941 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1872030), // Rule ID 14328 //
     /* 1871946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871992 */     // MIs[0] policy
     /* 1871992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872029 */     // GIR_Coverage, 14328,
     /* 1872029 */     GIR_EraseRootFromParent_Done,
     /* 1872030 */   // Label 25285: @1872030
     /* 1872030 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1872119), // Rule ID 14329 //
     /* 1872035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872081 */     // MIs[0] policy
     /* 1872081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872091 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872118 */     // GIR_Coverage, 14329,
     /* 1872118 */     GIR_EraseRootFromParent_Done,
     /* 1872119 */   // Label 25286: @1872119
     /* 1872119 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1872208), // Rule ID 14332 //
     /* 1872124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872170 */     // MIs[0] policy
     /* 1872170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872207 */     // GIR_Coverage, 14332,
     /* 1872207 */     GIR_EraseRootFromParent_Done,
     /* 1872208 */   // Label 25287: @1872208
     /* 1872208 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1872297), // Rule ID 14333 //
     /* 1872213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872259 */     // MIs[0] policy
     /* 1872259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872269 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872296 */     // GIR_Coverage, 14333,
     /* 1872296 */     GIR_EraseRootFromParent_Done,
     /* 1872297 */   // Label 25288: @1872297
     /* 1872297 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1872386), // Rule ID 14336 //
     /* 1872302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1872313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1872316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1872319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1872322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872348 */     // MIs[0] policy
     /* 1872348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872385 */     // GIR_Coverage, 14336,
     /* 1872385 */     GIR_EraseRootFromParent_Done,
     /* 1872386 */   // Label 25289: @1872386
     /* 1872386 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1872475), // Rule ID 14337 //
     /* 1872391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1872402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1872405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1872408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1872411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872437 */     // MIs[0] policy
     /* 1872437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1872450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872474 */     // GIR_Coverage, 14337,
     /* 1872474 */     GIR_EraseRootFromParent_Done,
     /* 1872475 */   // Label 25290: @1872475
     /* 1872475 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1872564), // Rule ID 14340 //
     /* 1872480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872526 */     // MIs[0] policy
     /* 1872526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872563 */     // GIR_Coverage, 14340,
     /* 1872563 */     GIR_EraseRootFromParent_Done,
     /* 1872564 */   // Label 25291: @1872564
     /* 1872564 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1872653), // Rule ID 14341 //
     /* 1872569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872615 */     // MIs[0] policy
     /* 1872615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872625 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872652 */     // GIR_Coverage, 14341,
     /* 1872652 */     GIR_EraseRootFromParent_Done,
     /* 1872653 */   // Label 25292: @1872653
     /* 1872653 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1872742), // Rule ID 14344 //
     /* 1872658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872704 */     // MIs[0] policy
     /* 1872704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872741 */     // GIR_Coverage, 14344,
     /* 1872741 */     GIR_EraseRootFromParent_Done,
     /* 1872742 */   // Label 25293: @1872742
     /* 1872742 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1872831), // Rule ID 14345 //
     /* 1872747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872793 */     // MIs[0] policy
     /* 1872793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872803 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872830 */     // GIR_Coverage, 14345,
     /* 1872830 */     GIR_EraseRootFromParent_Done,
     /* 1872831 */   // Label 25294: @1872831
     /* 1872831 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1872920), // Rule ID 14348 //
     /* 1872836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872882 */     // MIs[0] policy
     /* 1872882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872919 */     // GIR_Coverage, 14348,
     /* 1872919 */     GIR_EraseRootFromParent_Done,
     /* 1872920 */   // Label 25295: @1872920
     /* 1872920 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1873009), // Rule ID 14349 //
     /* 1872925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872971 */     // MIs[0] policy
     /* 1872971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872981 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873008 */     // GIR_Coverage, 14349,
     /* 1873008 */     GIR_EraseRootFromParent_Done,
     /* 1873009 */   // Label 25296: @1873009
     /* 1873009 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1873098), // Rule ID 14352 //
     /* 1873014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873060 */     // MIs[0] policy
     /* 1873060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873097 */     // GIR_Coverage, 14352,
     /* 1873097 */     GIR_EraseRootFromParent_Done,
     /* 1873098 */   // Label 25297: @1873098
     /* 1873098 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1873187), // Rule ID 14353 //
     /* 1873103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873149 */     // MIs[0] policy
     /* 1873149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873159 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873186 */     // GIR_Coverage, 14353,
     /* 1873186 */     GIR_EraseRootFromParent_Done,
     /* 1873187 */   // Label 25298: @1873187
     /* 1873187 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1873276), // Rule ID 14356 //
     /* 1873192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873238 */     // MIs[0] policy
     /* 1873238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873275 */     // GIR_Coverage, 14356,
     /* 1873275 */     GIR_EraseRootFromParent_Done,
     /* 1873276 */   // Label 25299: @1873276
     /* 1873276 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1873365), // Rule ID 14357 //
     /* 1873281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873327 */     // MIs[0] policy
     /* 1873327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873364 */     // GIR_Coverage, 14357,
     /* 1873364 */     GIR_EraseRootFromParent_Done,
     /* 1873365 */   // Label 25300: @1873365
     /* 1873365 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1873454), // Rule ID 14360 //
     /* 1873370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1873373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873416 */     // MIs[0] policy
     /* 1873416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873453 */     // GIR_Coverage, 14360,
     /* 1873453 */     GIR_EraseRootFromParent_Done,
     /* 1873454 */   // Label 25301: @1873454
     /* 1873454 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1873543), // Rule ID 14361 //
     /* 1873459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1873462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873505 */     // MIs[0] policy
     /* 1873505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873515 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873542 */     // GIR_Coverage, 14361,
     /* 1873542 */     GIR_EraseRootFromParent_Done,
     /* 1873543 */   // Label 25302: @1873543
     /* 1873543 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1873632), // Rule ID 14364 //
     /* 1873548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873594 */     // MIs[0] policy
     /* 1873594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873631 */     // GIR_Coverage, 14364,
     /* 1873631 */     GIR_EraseRootFromParent_Done,
     /* 1873632 */   // Label 25303: @1873632
     /* 1873632 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1873721), // Rule ID 14365 //
     /* 1873637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873683 */     // MIs[0] policy
     /* 1873683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873720 */     // GIR_Coverage, 14365,
     /* 1873720 */     GIR_EraseRootFromParent_Done,
     /* 1873721 */   // Label 25304: @1873721
     /* 1873721 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1873810), // Rule ID 14368 //
     /* 1873726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873772 */     // MIs[0] policy
     /* 1873772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873809 */     // GIR_Coverage, 14368,
     /* 1873809 */     GIR_EraseRootFromParent_Done,
     /* 1873810 */   // Label 25305: @1873810
     /* 1873810 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1873899), // Rule ID 14369 //
     /* 1873815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873861 */     // MIs[0] policy
     /* 1873861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873871 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873898 */     // GIR_Coverage, 14369,
     /* 1873898 */     GIR_EraseRootFromParent_Done,
     /* 1873899 */   // Label 25306: @1873899
     /* 1873899 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1873988), // Rule ID 14372 //
     /* 1873904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873950 */     // MIs[0] policy
     /* 1873950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873987 */     // GIR_Coverage, 14372,
     /* 1873987 */     GIR_EraseRootFromParent_Done,
     /* 1873988 */   // Label 25307: @1873988
     /* 1873988 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1874077), // Rule ID 14373 //
     /* 1873993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874039 */     // MIs[0] policy
     /* 1874039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874049 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874076 */     // GIR_Coverage, 14373,
     /* 1874076 */     GIR_EraseRootFromParent_Done,
     /* 1874077 */   // Label 25308: @1874077
     /* 1874077 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1874166), // Rule ID 14376 //
     /* 1874082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874128 */     // MIs[0] policy
     /* 1874128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874165 */     // GIR_Coverage, 14376,
     /* 1874165 */     GIR_EraseRootFromParent_Done,
     /* 1874166 */   // Label 25309: @1874166
     /* 1874166 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1874255), // Rule ID 14377 //
     /* 1874171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874217 */     // MIs[0] policy
     /* 1874217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874254 */     // GIR_Coverage, 14377,
     /* 1874254 */     GIR_EraseRootFromParent_Done,
     /* 1874255 */   // Label 25310: @1874255
     /* 1874255 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1874344), // Rule ID 14380 //
     /* 1874260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874306 */     // MIs[0] policy
     /* 1874306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874343 */     // GIR_Coverage, 14380,
     /* 1874343 */     GIR_EraseRootFromParent_Done,
     /* 1874344 */   // Label 25311: @1874344
     /* 1874344 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1874433), // Rule ID 14381 //
     /* 1874349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1874360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1874363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1874366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1874369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874395 */     // MIs[0] policy
     /* 1874395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874405 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874432 */     // GIR_Coverage, 14381,
     /* 1874432 */     GIR_EraseRootFromParent_Done,
     /* 1874433 */   // Label 25312: @1874433
     /* 1874433 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1874522), // Rule ID 14384 //
     /* 1874438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874484 */     // MIs[0] policy
     /* 1874484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874521 */     // GIR_Coverage, 14384,
     /* 1874521 */     GIR_EraseRootFromParent_Done,
     /* 1874522 */   // Label 25313: @1874522
     /* 1874522 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1874611), // Rule ID 14385 //
     /* 1874527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874573 */     // MIs[0] policy
     /* 1874573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874583 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874610 */     // GIR_Coverage, 14385,
     /* 1874610 */     GIR_EraseRootFromParent_Done,
     /* 1874611 */   // Label 25314: @1874611
     /* 1874611 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1874700), // Rule ID 14388 //
     /* 1874616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874662 */     // MIs[0] policy
     /* 1874662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874699 */     // GIR_Coverage, 14388,
     /* 1874699 */     GIR_EraseRootFromParent_Done,
     /* 1874700 */   // Label 25315: @1874700
     /* 1874700 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1874789), // Rule ID 14389 //
     /* 1874705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874751 */     // MIs[0] policy
     /* 1874751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874788 */     // GIR_Coverage, 14389,
     /* 1874788 */     GIR_EraseRootFromParent_Done,
     /* 1874789 */   // Label 25316: @1874789
     /* 1874789 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1874878), // Rule ID 14392 //
     /* 1874794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874840 */     // MIs[0] policy
     /* 1874840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874877 */     // GIR_Coverage, 14392,
     /* 1874877 */     GIR_EraseRootFromParent_Done,
     /* 1874878 */   // Label 25317: @1874878
     /* 1874878 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1874967), // Rule ID 14393 //
     /* 1874883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874929 */     // MIs[0] policy
     /* 1874929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874966 */     // GIR_Coverage, 14393,
     /* 1874966 */     GIR_EraseRootFromParent_Done,
     /* 1874967 */   // Label 25318: @1874967
     /* 1874967 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1875056), // Rule ID 14396 //
     /* 1874972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1874992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875018 */     // MIs[0] policy
     /* 1875018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875055 */     // GIR_Coverage, 14396,
     /* 1875055 */     GIR_EraseRootFromParent_Done,
     /* 1875056 */   // Label 25319: @1875056
     /* 1875056 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1875145), // Rule ID 14397 //
     /* 1875061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875107 */     // MIs[0] policy
     /* 1875107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875117 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875144 */     // GIR_Coverage, 14397,
     /* 1875144 */     GIR_EraseRootFromParent_Done,
     /* 1875145 */   // Label 25320: @1875145
     /* 1875145 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1875234), // Rule ID 14400 //
     /* 1875150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875196 */     // MIs[0] policy
     /* 1875196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1875209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875233 */     // GIR_Coverage, 14400,
     /* 1875233 */     GIR_EraseRootFromParent_Done,
     /* 1875234 */   // Label 25321: @1875234
     /* 1875234 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1875323), // Rule ID 14401 //
     /* 1875239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875285 */     // MIs[0] policy
     /* 1875285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1875298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875322 */     // GIR_Coverage, 14401,
     /* 1875322 */     GIR_EraseRootFromParent_Done,
     /* 1875323 */   // Label 25322: @1875323
     /* 1875323 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1875412), // Rule ID 14404 //
     /* 1875328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875374 */     // MIs[0] policy
     /* 1875374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875411 */     // GIR_Coverage, 14404,
     /* 1875411 */     GIR_EraseRootFromParent_Done,
     /* 1875412 */   // Label 25323: @1875412
     /* 1875412 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1875501), // Rule ID 14405 //
     /* 1875417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1875428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1875431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1875434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1875437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875463 */     // MIs[0] policy
     /* 1875463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875473 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875500 */     // GIR_Coverage, 14405,
     /* 1875500 */     GIR_EraseRootFromParent_Done,
     /* 1875501 */   // Label 25324: @1875501
     /* 1875501 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1875590), // Rule ID 14408 //
     /* 1875506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875552 */     // MIs[0] policy
     /* 1875552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875589 */     // GIR_Coverage, 14408,
     /* 1875589 */     GIR_EraseRootFromParent_Done,
     /* 1875590 */   // Label 25325: @1875590
     /* 1875590 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1875679), // Rule ID 14409 //
     /* 1875595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875641 */     // MIs[0] policy
     /* 1875641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875678 */     // GIR_Coverage, 14409,
     /* 1875678 */     GIR_EraseRootFromParent_Done,
     /* 1875679 */   // Label 25326: @1875679
     /* 1875679 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1875768), // Rule ID 14412 //
     /* 1875684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875730 */     // MIs[0] policy
     /* 1875730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875740 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875767 */     // GIR_Coverage, 14412,
     /* 1875767 */     GIR_EraseRootFromParent_Done,
     /* 1875768 */   // Label 25327: @1875768
     /* 1875768 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1875857), // Rule ID 14413 //
     /* 1875773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875819 */     // MIs[0] policy
     /* 1875819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875829 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875856 */     // GIR_Coverage, 14413,
     /* 1875856 */     GIR_EraseRootFromParent_Done,
     /* 1875857 */   // Label 25328: @1875857
     /* 1875857 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1875946), // Rule ID 14416 //
     /* 1875862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875908 */     // MIs[0] policy
     /* 1875908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875945 */     // GIR_Coverage, 14416,
     /* 1875945 */     GIR_EraseRootFromParent_Done,
     /* 1875946 */   // Label 25329: @1875946
     /* 1875946 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1876035), // Rule ID 14417 //
     /* 1875951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875997 */     // MIs[0] policy
     /* 1875997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876007 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876034 */     // GIR_Coverage, 14417,
     /* 1876034 */     GIR_EraseRootFromParent_Done,
     /* 1876035 */   // Label 25330: @1876035
     /* 1876035 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1876124), // Rule ID 14420 //
     /* 1876040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876086 */     // MIs[0] policy
     /* 1876086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876123 */     // GIR_Coverage, 14420,
     /* 1876123 */     GIR_EraseRootFromParent_Done,
     /* 1876124 */   // Label 25331: @1876124
     /* 1876124 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1876213), // Rule ID 14421 //
     /* 1876129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876175 */     // MIs[0] policy
     /* 1876175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876185 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876212 */     // GIR_Coverage, 14421,
     /* 1876212 */     GIR_EraseRootFromParent_Done,
     /* 1876213 */   // Label 25332: @1876213
     /* 1876213 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1876302), // Rule ID 14424 //
     /* 1876218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876264 */     // MIs[0] policy
     /* 1876264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876301 */     // GIR_Coverage, 14424,
     /* 1876301 */     GIR_EraseRootFromParent_Done,
     /* 1876302 */   // Label 25333: @1876302
     /* 1876302 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1876391), // Rule ID 14425 //
     /* 1876307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1876318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1876321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1876324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876353 */     // MIs[0] policy
     /* 1876353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876363 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1876366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876390 */     // GIR_Coverage, 14425,
     /* 1876390 */     GIR_EraseRootFromParent_Done,
     /* 1876391 */   // Label 25334: @1876391
     /* 1876391 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1876480), // Rule ID 14428 //
     /* 1876396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876442 */     // MIs[0] policy
     /* 1876442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876479 */     // GIR_Coverage, 14428,
     /* 1876479 */     GIR_EraseRootFromParent_Done,
     /* 1876480 */   // Label 25335: @1876480
     /* 1876480 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1876569), // Rule ID 14429 //
     /* 1876485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876531 */     // MIs[0] policy
     /* 1876531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876541 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876568 */     // GIR_Coverage, 14429,
     /* 1876568 */     GIR_EraseRootFromParent_Done,
     /* 1876569 */   // Label 25336: @1876569
     /* 1876569 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1876658), // Rule ID 14432 //
     /* 1876574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876620 */     // MIs[0] policy
     /* 1876620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876657 */     // GIR_Coverage, 14432,
     /* 1876657 */     GIR_EraseRootFromParent_Done,
     /* 1876658 */   // Label 25337: @1876658
     /* 1876658 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1876747), // Rule ID 14433 //
     /* 1876663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876709 */     // MIs[0] policy
     /* 1876709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876719 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876746 */     // GIR_Coverage, 14433,
     /* 1876746 */     GIR_EraseRootFromParent_Done,
     /* 1876747 */   // Label 25338: @1876747
     /* 1876747 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1876836), // Rule ID 14436 //
     /* 1876752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876798 */     // MIs[0] policy
     /* 1876798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876835 */     // GIR_Coverage, 14436,
     /* 1876835 */     GIR_EraseRootFromParent_Done,
     /* 1876836 */   // Label 25339: @1876836
     /* 1876836 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1876925), // Rule ID 14437 //
     /* 1876841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876887 */     // MIs[0] policy
     /* 1876887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876897 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11588:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876924 */     // GIR_Coverage, 14437,
     /* 1876924 */     GIR_EraseRootFromParent_Done,
     /* 1876925 */   // Label 25340: @1876925
     /* 1876925 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1877014), // Rule ID 14440 //
     /* 1876930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876976 */     // MIs[0] policy
     /* 1876976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877013 */     // GIR_Coverage, 14440,
     /* 1877013 */     GIR_EraseRootFromParent_Done,
     /* 1877014 */   // Label 25341: @1877014
     /* 1877014 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1877103), // Rule ID 14441 //
     /* 1877019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877065 */     // MIs[0] policy
     /* 1877065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877102 */     // GIR_Coverage, 14441,
     /* 1877102 */     GIR_EraseRootFromParent_Done,
     /* 1877103 */   // Label 25342: @1877103
     /* 1877103 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1877192), // Rule ID 14444 //
     /* 1877108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877154 */     // MIs[0] policy
     /* 1877154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877191 */     // GIR_Coverage, 14444,
     /* 1877191 */     GIR_EraseRootFromParent_Done,
     /* 1877192 */   // Label 25343: @1877192
     /* 1877192 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1877281), // Rule ID 14445 //
     /* 1877197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877243 */     // MIs[0] policy
     /* 1877243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877253 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877280 */     // GIR_Coverage, 14445,
     /* 1877280 */     GIR_EraseRootFromParent_Done,
     /* 1877281 */   // Label 25344: @1877281
     /* 1877281 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1877370), // Rule ID 14448 //
     /* 1877286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1877289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877332 */     // MIs[0] policy
     /* 1877332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877369 */     // GIR_Coverage, 14448,
     /* 1877369 */     GIR_EraseRootFromParent_Done,
     /* 1877370 */   // Label 25345: @1877370
     /* 1877370 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1877459), // Rule ID 14449 //
     /* 1877375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1877378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1877386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1877389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1877392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877421 */     // MIs[0] policy
     /* 1877421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877431 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1877434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1877452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877458 */     // GIR_Coverage, 14449,
     /* 1877458 */     GIR_EraseRootFromParent_Done,
     /* 1877459 */   // Label 25346: @1877459
     /* 1877459 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1877548), // Rule ID 14452 //
     /* 1877464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877510 */     // MIs[0] policy
     /* 1877510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877547 */     // GIR_Coverage, 14452,
     /* 1877547 */     GIR_EraseRootFromParent_Done,
     /* 1877548 */   // Label 25347: @1877548
     /* 1877548 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1877637), // Rule ID 14453 //
     /* 1877553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877599 */     // MIs[0] policy
     /* 1877599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877609 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877636 */     // GIR_Coverage, 14453,
     /* 1877636 */     GIR_EraseRootFromParent_Done,
     /* 1877637 */   // Label 25348: @1877637
     /* 1877637 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1877726), // Rule ID 14456 //
     /* 1877642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877688 */     // MIs[0] policy
     /* 1877688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877698 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877725 */     // GIR_Coverage, 14456,
     /* 1877725 */     GIR_EraseRootFromParent_Done,
     /* 1877726 */   // Label 25349: @1877726
     /* 1877726 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1877815), // Rule ID 14457 //
     /* 1877731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877777 */     // MIs[0] policy
     /* 1877777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877787 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877814 */     // GIR_Coverage, 14457,
     /* 1877814 */     GIR_EraseRootFromParent_Done,
     /* 1877815 */   // Label 25350: @1877815
     /* 1877815 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1877904), // Rule ID 14460 //
     /* 1877820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877866 */     // MIs[0] policy
     /* 1877866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877903 */     // GIR_Coverage, 14460,
     /* 1877903 */     GIR_EraseRootFromParent_Done,
     /* 1877904 */   // Label 25351: @1877904
     /* 1877904 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1877993), // Rule ID 14461 //
     /* 1877909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877955 */     // MIs[0] policy
     /* 1877955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877965 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877992 */     // GIR_Coverage, 14461,
     /* 1877992 */     GIR_EraseRootFromParent_Done,
     /* 1877993 */   // Label 25352: @1877993
     /* 1877993 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1878082), // Rule ID 14464 //
     /* 1877998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878044 */     // MIs[0] policy
     /* 1878044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878081 */     // GIR_Coverage, 14464,
     /* 1878081 */     GIR_EraseRootFromParent_Done,
     /* 1878082 */   // Label 25353: @1878082
     /* 1878082 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1878171), // Rule ID 14465 //
     /* 1878087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878133 */     // MIs[0] policy
     /* 1878133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878170 */     // GIR_Coverage, 14465,
     /* 1878170 */     GIR_EraseRootFromParent_Done,
     /* 1878171 */   // Label 25354: @1878171
     /* 1878171 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1878260), // Rule ID 14468 //
     /* 1878176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878222 */     // MIs[0] policy
     /* 1878222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878259 */     // GIR_Coverage, 14468,
     /* 1878259 */     GIR_EraseRootFromParent_Done,
     /* 1878260 */   // Label 25355: @1878260
     /* 1878260 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1878349), // Rule ID 14469 //
     /* 1878265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878311 */     // MIs[0] policy
     /* 1878311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878348 */     // GIR_Coverage, 14469,
     /* 1878348 */     GIR_EraseRootFromParent_Done,
     /* 1878349 */   // Label 25356: @1878349
     /* 1878349 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1878438), // Rule ID 14472 //
     /* 1878354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878400 */     // MIs[0] policy
     /* 1878400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878437 */     // GIR_Coverage, 14472,
     /* 1878437 */     GIR_EraseRootFromParent_Done,
     /* 1878438 */   // Label 25357: @1878438
     /* 1878438 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1878527), // Rule ID 14473 //
     /* 1878443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1878454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1878457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1878460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878489 */     // MIs[0] policy
     /* 1878489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878526 */     // GIR_Coverage, 14473,
     /* 1878526 */     GIR_EraseRootFromParent_Done,
     /* 1878527 */   // Label 25358: @1878527
     /* 1878527 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1878616), // Rule ID 14476 //
     /* 1878532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878578 */     // MIs[0] policy
     /* 1878578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878615 */     // GIR_Coverage, 14476,
     /* 1878615 */     GIR_EraseRootFromParent_Done,
     /* 1878616 */   // Label 25359: @1878616
     /* 1878616 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1878705), // Rule ID 14477 //
     /* 1878621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878667 */     // MIs[0] policy
     /* 1878667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878704 */     // GIR_Coverage, 14477,
     /* 1878704 */     GIR_EraseRootFromParent_Done,
     /* 1878705 */   // Label 25360: @1878705
     /* 1878705 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1878794), // Rule ID 14480 //
     /* 1878710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878756 */     // MIs[0] policy
     /* 1878756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878793 */     // GIR_Coverage, 14480,
     /* 1878793 */     GIR_EraseRootFromParent_Done,
     /* 1878794 */   // Label 25361: @1878794
     /* 1878794 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1878883), // Rule ID 14481 //
     /* 1878799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878845 */     // MIs[0] policy
     /* 1878845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878855 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878882 */     // GIR_Coverage, 14481,
     /* 1878882 */     GIR_EraseRootFromParent_Done,
     /* 1878883 */   // Label 25362: @1878883
     /* 1878883 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1878972), // Rule ID 14484 //
     /* 1878888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878934 */     // MIs[0] policy
     /* 1878934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878971 */     // GIR_Coverage, 14484,
     /* 1878971 */     GIR_EraseRootFromParent_Done,
     /* 1878972 */   // Label 25363: @1878972
     /* 1878972 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1879061), // Rule ID 14485 //
     /* 1878977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879023 */     // MIs[0] policy
     /* 1879023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879060 */     // GIR_Coverage, 14485,
     /* 1879060 */     GIR_EraseRootFromParent_Done,
     /* 1879061 */   // Label 25364: @1879061
     /* 1879061 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1879150), // Rule ID 14488 //
     /* 1879066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879112 */     // MIs[0] policy
     /* 1879112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1879125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879149 */     // GIR_Coverage, 14488,
     /* 1879149 */     GIR_EraseRootFromParent_Done,
     /* 1879150 */   // Label 25365: @1879150
     /* 1879150 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1879239), // Rule ID 14489 //
     /* 1879155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879201 */     // MIs[0] policy
     /* 1879201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1879214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879238 */     // GIR_Coverage, 14489,
     /* 1879238 */     GIR_EraseRootFromParent_Done,
     /* 1879239 */   // Label 25366: @1879239
     /* 1879239 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1879328), // Rule ID 14492 //
     /* 1879244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879290 */     // MIs[0] policy
     /* 1879290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1879303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879327 */     // GIR_Coverage, 14492,
     /* 1879327 */     GIR_EraseRootFromParent_Done,
     /* 1879328 */   // Label 25367: @1879328
     /* 1879328 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1879417), // Rule ID 14493 //
     /* 1879333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1879344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1879347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1879350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879379 */     // MIs[0] policy
     /* 1879379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879389 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1879392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879416 */     // GIR_Coverage, 14493,
     /* 1879416 */     GIR_EraseRootFromParent_Done,
     /* 1879417 */   // Label 25368: @1879417
     /* 1879417 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1879506), // Rule ID 14496 //
     /* 1879422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879468 */     // MIs[0] policy
     /* 1879468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879505 */     // GIR_Coverage, 14496,
     /* 1879505 */     GIR_EraseRootFromParent_Done,
     /* 1879506 */   // Label 25369: @1879506
     /* 1879506 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1879595), // Rule ID 14497 //
     /* 1879511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879557 */     // MIs[0] policy
     /* 1879557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879567 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879594 */     // GIR_Coverage, 14497,
     /* 1879594 */     GIR_EraseRootFromParent_Done,
     /* 1879595 */   // Label 25370: @1879595
     /* 1879595 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1879684), // Rule ID 14588 //
     /* 1879600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879646 */     // MIs[0] policy
     /* 1879646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879683 */     // GIR_Coverage, 14588,
     /* 1879683 */     GIR_EraseRootFromParent_Done,
     /* 1879684 */   // Label 25371: @1879684
     /* 1879684 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1879773), // Rule ID 14589 //
     /* 1879689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879735 */     // MIs[0] policy
     /* 1879735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879745 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879772 */     // GIR_Coverage, 14589,
     /* 1879772 */     GIR_EraseRootFromParent_Done,
     /* 1879773 */   // Label 25372: @1879773
     /* 1879773 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1879862), // Rule ID 14592 //
     /* 1879778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879824 */     // MIs[0] policy
     /* 1879824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879861 */     // GIR_Coverage, 14592,
     /* 1879861 */     GIR_EraseRootFromParent_Done,
     /* 1879862 */   // Label 25373: @1879862
     /* 1879862 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1879951), // Rule ID 14593 //
     /* 1879867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879913 */     // MIs[0] policy
     /* 1879913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879923 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879950 */     // GIR_Coverage, 14593,
     /* 1879950 */     GIR_EraseRootFromParent_Done,
     /* 1879951 */   // Label 25374: @1879951
     /* 1879951 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1880040), // Rule ID 14596 //
     /* 1879956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880002 */     // MIs[0] policy
     /* 1880002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880012 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880039 */     // GIR_Coverage, 14596,
     /* 1880039 */     GIR_EraseRootFromParent_Done,
     /* 1880040 */   // Label 25375: @1880040
     /* 1880040 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1880129), // Rule ID 14597 //
     /* 1880045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880091 */     // MIs[0] policy
     /* 1880091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880101 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880128 */     // GIR_Coverage, 14597,
     /* 1880128 */     GIR_EraseRootFromParent_Done,
     /* 1880129 */   // Label 25376: @1880129
     /* 1880129 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1880218), // Rule ID 14600 //
     /* 1880134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880180 */     // MIs[0] policy
     /* 1880180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1880193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880217 */     // GIR_Coverage, 14600,
     /* 1880217 */     GIR_EraseRootFromParent_Done,
     /* 1880218 */   // Label 25377: @1880218
     /* 1880218 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1880307), // Rule ID 14601 //
     /* 1880223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880269 */     // MIs[0] policy
     /* 1880269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880279 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1880282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880306 */     // GIR_Coverage, 14601,
     /* 1880306 */     GIR_EraseRootFromParent_Done,
     /* 1880307 */   // Label 25378: @1880307
     /* 1880307 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1880396), // Rule ID 14604 //
     /* 1880312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880358 */     // MIs[0] policy
     /* 1880358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880395 */     // GIR_Coverage, 14604,
     /* 1880395 */     GIR_EraseRootFromParent_Done,
     /* 1880396 */   // Label 25379: @1880396
     /* 1880396 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1880485), // Rule ID 14605 //
     /* 1880401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1880412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1880415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1880418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1880421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880447 */     // MIs[0] policy
     /* 1880447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880457 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880484 */     // GIR_Coverage, 14605,
     /* 1880484 */     GIR_EraseRootFromParent_Done,
     /* 1880485 */   // Label 25380: @1880485
     /* 1880485 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1880574), // Rule ID 14608 //
     /* 1880490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880536 */     // MIs[0] policy
     /* 1880536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880573 */     // GIR_Coverage, 14608,
     /* 1880573 */     GIR_EraseRootFromParent_Done,
     /* 1880574 */   // Label 25381: @1880574
     /* 1880574 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1880663), // Rule ID 14609 //
     /* 1880579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880625 */     // MIs[0] policy
     /* 1880625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880662 */     // GIR_Coverage, 14609,
     /* 1880662 */     GIR_EraseRootFromParent_Done,
     /* 1880663 */   // Label 25382: @1880663
     /* 1880663 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1880752), // Rule ID 14612 //
     /* 1880668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880714 */     // MIs[0] policy
     /* 1880714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880751 */     // GIR_Coverage, 14612,
     /* 1880751 */     GIR_EraseRootFromParent_Done,
     /* 1880752 */   // Label 25383: @1880752
     /* 1880752 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1880841), // Rule ID 14613 //
     /* 1880757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880803 */     // MIs[0] policy
     /* 1880803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880813 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880840 */     // GIR_Coverage, 14613,
     /* 1880840 */     GIR_EraseRootFromParent_Done,
     /* 1880841 */   // Label 25384: @1880841
     /* 1880841 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1880930), // Rule ID 14616 //
     /* 1880846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880892 */     // MIs[0] policy
     /* 1880892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880929 */     // GIR_Coverage, 14616,
     /* 1880929 */     GIR_EraseRootFromParent_Done,
     /* 1880930 */   // Label 25385: @1880930
     /* 1880930 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1881019), // Rule ID 14617 //
     /* 1880935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880981 */     // MIs[0] policy
     /* 1880981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881018 */     // GIR_Coverage, 14617,
     /* 1881018 */     GIR_EraseRootFromParent_Done,
     /* 1881019 */   // Label 25386: @1881019
     /* 1881019 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1881108), // Rule ID 14620 //
     /* 1881024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881070 */     // MIs[0] policy
     /* 1881070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881107 */     // GIR_Coverage, 14620,
     /* 1881107 */     GIR_EraseRootFromParent_Done,
     /* 1881108 */   // Label 25387: @1881108
     /* 1881108 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1881197), // Rule ID 14621 //
     /* 1881113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881159 */     // MIs[0] policy
     /* 1881159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881169 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881196 */     // GIR_Coverage, 14621,
     /* 1881196 */     GIR_EraseRootFromParent_Done,
     /* 1881197 */   // Label 25388: @1881197
     /* 1881197 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1881286), // Rule ID 14624 //
     /* 1881202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1881205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881248 */     // MIs[0] policy
     /* 1881248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881285 */     // GIR_Coverage, 14624,
     /* 1881285 */     GIR_EraseRootFromParent_Done,
     /* 1881286 */   // Label 25389: @1881286
     /* 1881286 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1881375), // Rule ID 14625 //
     /* 1881291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1881294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1881311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881337 */     // MIs[0] policy
     /* 1881337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881347 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1881350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1881368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881374 */     // GIR_Coverage, 14625,
     /* 1881374 */     GIR_EraseRootFromParent_Done,
     /* 1881375 */   // Label 25390: @1881375
     /* 1881375 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1881464), // Rule ID 14628 //
     /* 1881380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881426 */     // MIs[0] policy
     /* 1881426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881436 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881463 */     // GIR_Coverage, 14628,
     /* 1881463 */     GIR_EraseRootFromParent_Done,
     /* 1881464 */   // Label 25391: @1881464
     /* 1881464 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1881553), // Rule ID 14629 //
     /* 1881469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881515 */     // MIs[0] policy
     /* 1881515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881552 */     // GIR_Coverage, 14629,
     /* 1881552 */     GIR_EraseRootFromParent_Done,
     /* 1881553 */   // Label 25392: @1881553
     /* 1881553 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1881642), // Rule ID 14632 //
     /* 1881558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881604 */     // MIs[0] policy
     /* 1881604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881641 */     // GIR_Coverage, 14632,
     /* 1881641 */     GIR_EraseRootFromParent_Done,
     /* 1881642 */   // Label 25393: @1881642
     /* 1881642 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1881731), // Rule ID 14633 //
     /* 1881647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881693 */     // MIs[0] policy
     /* 1881693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881703 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881730 */     // GIR_Coverage, 14633,
     /* 1881730 */     GIR_EraseRootFromParent_Done,
     /* 1881731 */   // Label 25394: @1881731
     /* 1881731 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1881820), // Rule ID 14636 //
     /* 1881736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881782 */     // MIs[0] policy
     /* 1881782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881819 */     // GIR_Coverage, 14636,
     /* 1881819 */     GIR_EraseRootFromParent_Done,
     /* 1881820 */   // Label 25395: @1881820
     /* 1881820 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1881909), // Rule ID 14637 //
     /* 1881825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881871 */     // MIs[0] policy
     /* 1881871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881881 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881908 */     // GIR_Coverage, 14637,
     /* 1881908 */     GIR_EraseRootFromParent_Done,
     /* 1881909 */   // Label 25396: @1881909
     /* 1881909 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1881998), // Rule ID 14640 //
     /* 1881914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881960 */     // MIs[0] policy
     /* 1881960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881997 */     // GIR_Coverage, 14640,
     /* 1881997 */     GIR_EraseRootFromParent_Done,
     /* 1881998 */   // Label 25397: @1881998
     /* 1881998 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1882087), // Rule ID 14641 //
     /* 1882003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882049 */     // MIs[0] policy
     /* 1882049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882086 */     // GIR_Coverage, 14641,
     /* 1882086 */     GIR_EraseRootFromParent_Done,
     /* 1882087 */   // Label 25398: @1882087
     /* 1882087 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1882176), // Rule ID 14644 //
     /* 1882092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882138 */     // MIs[0] policy
     /* 1882138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882175 */     // GIR_Coverage, 14644,
     /* 1882175 */     GIR_EraseRootFromParent_Done,
     /* 1882176 */   // Label 25399: @1882176
     /* 1882176 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1882265), // Rule ID 14645 //
     /* 1882181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882227 */     // MIs[0] policy
     /* 1882227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882264 */     // GIR_Coverage, 14645,
     /* 1882264 */     GIR_EraseRootFromParent_Done,
     /* 1882265 */   // Label 25400: @1882265
     /* 1882265 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1882354), // Rule ID 14648 //
     /* 1882270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882316 */     // MIs[0] policy
     /* 1882316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882353 */     // GIR_Coverage, 14648,
     /* 1882353 */     GIR_EraseRootFromParent_Done,
     /* 1882354 */   // Label 25401: @1882354
     /* 1882354 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1882443), // Rule ID 14649 //
     /* 1882359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1882370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1882373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1882376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1882379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882405 */     // MIs[0] policy
     /* 1882405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882415 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882442 */     // GIR_Coverage, 14649,
     /* 1882442 */     GIR_EraseRootFromParent_Done,
     /* 1882443 */   // Label 25402: @1882443
     /* 1882443 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1882532), // Rule ID 14652 //
     /* 1882448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882494 */     // MIs[0] policy
     /* 1882494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882531 */     // GIR_Coverage, 14652,
     /* 1882531 */     GIR_EraseRootFromParent_Done,
     /* 1882532 */   // Label 25403: @1882532
     /* 1882532 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1882621), // Rule ID 14653 //
     /* 1882537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882583 */     // MIs[0] policy
     /* 1882583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882620 */     // GIR_Coverage, 14653,
     /* 1882620 */     GIR_EraseRootFromParent_Done,
     /* 1882621 */   // Label 25404: @1882621
     /* 1882621 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1882710), // Rule ID 14656 //
     /* 1882626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882672 */     // MIs[0] policy
     /* 1882672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882709 */     // GIR_Coverage, 14656,
     /* 1882709 */     GIR_EraseRootFromParent_Done,
     /* 1882710 */   // Label 25405: @1882710
     /* 1882710 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1882799), // Rule ID 14657 //
     /* 1882715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882761 */     // MIs[0] policy
     /* 1882761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882798 */     // GIR_Coverage, 14657,
     /* 1882798 */     GIR_EraseRootFromParent_Done,
     /* 1882799 */   // Label 25406: @1882799
     /* 1882799 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1882888), // Rule ID 14660 //
     /* 1882804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882850 */     // MIs[0] policy
     /* 1882850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882887 */     // GIR_Coverage, 14660,
     /* 1882887 */     GIR_EraseRootFromParent_Done,
     /* 1882888 */   // Label 25407: @1882888
     /* 1882888 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1882977), // Rule ID 14661 //
     /* 1882893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882939 */     // MIs[0] policy
     /* 1882939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882949 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882976 */     // GIR_Coverage, 14661,
     /* 1882976 */     GIR_EraseRootFromParent_Done,
     /* 1882977 */   // Label 25408: @1882977
     /* 1882977 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1883066), // Rule ID 14664 //
     /* 1882982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883028 */     // MIs[0] policy
     /* 1883028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1883041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883065 */     // GIR_Coverage, 14664,
     /* 1883065 */     GIR_EraseRootFromParent_Done,
     /* 1883066 */   // Label 25409: @1883066
     /* 1883066 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1883155), // Rule ID 14665 //
     /* 1883071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883117 */     // MIs[0] policy
     /* 1883117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1883130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883154 */     // GIR_Coverage, 14665,
     /* 1883154 */     GIR_EraseRootFromParent_Done,
     /* 1883155 */   // Label 25410: @1883155
     /* 1883155 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1883244), // Rule ID 14668 //
     /* 1883160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883206 */     // MIs[0] policy
     /* 1883206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1883219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883243 */     // GIR_Coverage, 14668,
     /* 1883243 */     GIR_EraseRootFromParent_Done,
     /* 1883244 */   // Label 25411: @1883244
     /* 1883244 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1883333), // Rule ID 14669 //
     /* 1883249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883295 */     // MIs[0] policy
     /* 1883295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883305 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1883308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883332 */     // GIR_Coverage, 14669,
     /* 1883332 */     GIR_EraseRootFromParent_Done,
     /* 1883333 */   // Label 25412: @1883333
     /* 1883333 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1883422), // Rule ID 14672 //
     /* 1883338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883384 */     // MIs[0] policy
     /* 1883384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883421 */     // GIR_Coverage, 14672,
     /* 1883421 */     GIR_EraseRootFromParent_Done,
     /* 1883422 */   // Label 25413: @1883422
     /* 1883422 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1883511), // Rule ID 14673 //
     /* 1883427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1883438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1883441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1883444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1883447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883473 */     // MIs[0] policy
     /* 1883473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883483 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883510 */     // GIR_Coverage, 14673,
     /* 1883510 */     GIR_EraseRootFromParent_Done,
     /* 1883511 */   // Label 25414: @1883511
     /* 1883511 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1883600), // Rule ID 14676 //
     /* 1883516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883562 */     // MIs[0] policy
     /* 1883562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883599 */     // GIR_Coverage, 14676,
     /* 1883599 */     GIR_EraseRootFromParent_Done,
     /* 1883600 */   // Label 25415: @1883600
     /* 1883600 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1883689), // Rule ID 14677 //
     /* 1883605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883651 */     // MIs[0] policy
     /* 1883651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883661 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883688 */     // GIR_Coverage, 14677,
     /* 1883688 */     GIR_EraseRootFromParent_Done,
     /* 1883689 */   // Label 25416: @1883689
     /* 1883689 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1883778), // Rule ID 14680 //
     /* 1883694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883740 */     // MIs[0] policy
     /* 1883740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883777 */     // GIR_Coverage, 14680,
     /* 1883777 */     GIR_EraseRootFromParent_Done,
     /* 1883778 */   // Label 25417: @1883778
     /* 1883778 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1883867), // Rule ID 14681 //
     /* 1883783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883829 */     // MIs[0] policy
     /* 1883829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883839 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883866 */     // GIR_Coverage, 14681,
     /* 1883866 */     GIR_EraseRootFromParent_Done,
     /* 1883867 */   // Label 25418: @1883867
     /* 1883867 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1883956), // Rule ID 14684 //
     /* 1883872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883918 */     // MIs[0] policy
     /* 1883918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883928 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883955 */     // GIR_Coverage, 14684,
     /* 1883955 */     GIR_EraseRootFromParent_Done,
     /* 1883956 */   // Label 25419: @1883956
     /* 1883956 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1884045), // Rule ID 14685 //
     /* 1883961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884007 */     // MIs[0] policy
     /* 1884007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884017 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884044 */     // GIR_Coverage, 14685,
     /* 1884044 */     GIR_EraseRootFromParent_Done,
     /* 1884045 */   // Label 25420: @1884045
     /* 1884045 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1884134), // Rule ID 14688 //
     /* 1884050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884096 */     // MIs[0] policy
     /* 1884096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1884109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884133 */     // GIR_Coverage, 14688,
     /* 1884133 */     GIR_EraseRootFromParent_Done,
     /* 1884134 */   // Label 25421: @1884134
     /* 1884134 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1884223), // Rule ID 14689 //
     /* 1884139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884185 */     // MIs[0] policy
     /* 1884185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1884198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884222 */     // GIR_Coverage, 14689,
     /* 1884222 */     GIR_EraseRootFromParent_Done,
     /* 1884223 */   // Label 25422: @1884223
     /* 1884223 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1884312), // Rule ID 14692 //
     /* 1884228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884274 */     // MIs[0] policy
     /* 1884274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884311 */     // GIR_Coverage, 14692,
     /* 1884311 */     GIR_EraseRootFromParent_Done,
     /* 1884312 */   // Label 25423: @1884312
     /* 1884312 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1884401), // Rule ID 14693 //
     /* 1884317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1884328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1884331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1884334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884363 */     // MIs[0] policy
     /* 1884363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884373 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884400 */     // GIR_Coverage, 14693,
     /* 1884400 */     GIR_EraseRootFromParent_Done,
     /* 1884401 */   // Label 25424: @1884401
     /* 1884401 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1884490), // Rule ID 14696 //
     /* 1884406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884452 */     // MIs[0] policy
     /* 1884452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884489 */     // GIR_Coverage, 14696,
     /* 1884489 */     GIR_EraseRootFromParent_Done,
     /* 1884490 */   // Label 25425: @1884490
     /* 1884490 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1884579), // Rule ID 14697 //
     /* 1884495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884541 */     // MIs[0] policy
     /* 1884541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884551 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884578 */     // GIR_Coverage, 14697,
     /* 1884578 */     GIR_EraseRootFromParent_Done,
     /* 1884579 */   // Label 25426: @1884579
     /* 1884579 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1884668), // Rule ID 14700 //
     /* 1884584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884630 */     // MIs[0] policy
     /* 1884630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884667 */     // GIR_Coverage, 14700,
     /* 1884667 */     GIR_EraseRootFromParent_Done,
     /* 1884668 */   // Label 25427: @1884668
     /* 1884668 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1884757), // Rule ID 14701 //
     /* 1884673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884719 */     // MIs[0] policy
     /* 1884719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884729 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884756 */     // GIR_Coverage, 14701,
     /* 1884756 */     GIR_EraseRootFromParent_Done,
     /* 1884757 */   // Label 25428: @1884757
     /* 1884757 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1884846), // Rule ID 14704 //
     /* 1884762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884808 */     // MIs[0] policy
     /* 1884808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884845 */     // GIR_Coverage, 14704,
     /* 1884845 */     GIR_EraseRootFromParent_Done,
     /* 1884846 */   // Label 25429: @1884846
     /* 1884846 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1884935), // Rule ID 14705 //
     /* 1884851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884897 */     // MIs[0] policy
     /* 1884897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884934 */     // GIR_Coverage, 14705,
     /* 1884934 */     GIR_EraseRootFromParent_Done,
     /* 1884935 */   // Label 25430: @1884935
     /* 1884935 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1885024), // Rule ID 14708 //
     /* 1884940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884986 */     // MIs[0] policy
     /* 1884986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885023 */     // GIR_Coverage, 14708,
     /* 1885023 */     GIR_EraseRootFromParent_Done,
     /* 1885024 */   // Label 25431: @1885024
     /* 1885024 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1885113), // Rule ID 14709 //
     /* 1885029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885075 */     // MIs[0] policy
     /* 1885075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885085 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885112 */     // GIR_Coverage, 14709,
     /* 1885112 */     GIR_EraseRootFromParent_Done,
     /* 1885113 */   // Label 25432: @1885113
     /* 1885113 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1885202), // Rule ID 14712 //
     /* 1885118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1885121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885164 */     // MIs[0] policy
     /* 1885164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885201 */     // GIR_Coverage, 14712,
     /* 1885201 */     GIR_EraseRootFromParent_Done,
     /* 1885202 */   // Label 25433: @1885202
     /* 1885202 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1885291), // Rule ID 14713 //
     /* 1885207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1885210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885253 */     // MIs[0] policy
     /* 1885253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885263 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1885266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885290 */     // GIR_Coverage, 14713,
     /* 1885290 */     GIR_EraseRootFromParent_Done,
     /* 1885291 */   // Label 25434: @1885291
     /* 1885291 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1885380), // Rule ID 14716 //
     /* 1885296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885342 */     // MIs[0] policy
     /* 1885342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885379 */     // GIR_Coverage, 14716,
     /* 1885379 */     GIR_EraseRootFromParent_Done,
     /* 1885380 */   // Label 25435: @1885380
     /* 1885380 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1885469), // Rule ID 14717 //
     /* 1885385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1885396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1885399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1885402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885431 */     // MIs[0] policy
     /* 1885431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885441 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885468 */     // GIR_Coverage, 14717,
     /* 1885468 */     GIR_EraseRootFromParent_Done,
     /* 1885469 */   // Label 25436: @1885469
     /* 1885469 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1885558), // Rule ID 14720 //
     /* 1885474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885520 */     // MIs[0] policy
     /* 1885520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885557 */     // GIR_Coverage, 14720,
     /* 1885557 */     GIR_EraseRootFromParent_Done,
     /* 1885558 */   // Label 25437: @1885558
     /* 1885558 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1885647), // Rule ID 14721 //
     /* 1885563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885609 */     // MIs[0] policy
     /* 1885609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885619 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885646 */     // GIR_Coverage, 14721,
     /* 1885646 */     GIR_EraseRootFromParent_Done,
     /* 1885647 */   // Label 25438: @1885647
     /* 1885647 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1885736), // Rule ID 14724 //
     /* 1885652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885698 */     // MIs[0] policy
     /* 1885698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885708 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885735 */     // GIR_Coverage, 14724,
     /* 1885735 */     GIR_EraseRootFromParent_Done,
     /* 1885736 */   // Label 25439: @1885736
     /* 1885736 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1885825), // Rule ID 14725 //
     /* 1885741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885787 */     // MIs[0] policy
     /* 1885787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885797 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885824 */     // GIR_Coverage, 14725,
     /* 1885824 */     GIR_EraseRootFromParent_Done,
     /* 1885825 */   // Label 25440: @1885825
     /* 1885825 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1885914), // Rule ID 14728 //
     /* 1885830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885876 */     // MIs[0] policy
     /* 1885876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885913 */     // GIR_Coverage, 14728,
     /* 1885913 */     GIR_EraseRootFromParent_Done,
     /* 1885914 */   // Label 25441: @1885914
     /* 1885914 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1886003), // Rule ID 14729 //
     /* 1885919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885965 */     // MIs[0] policy
     /* 1885965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886002 */     // GIR_Coverage, 14729,
     /* 1886002 */     GIR_EraseRootFromParent_Done,
     /* 1886003 */   // Label 25442: @1886003
     /* 1886003 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1886092), // Rule ID 14732 //
     /* 1886008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886054 */     // MIs[0] policy
     /* 1886054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886091 */     // GIR_Coverage, 14732,
     /* 1886091 */     GIR_EraseRootFromParent_Done,
     /* 1886092 */   // Label 25443: @1886092
     /* 1886092 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1886181), // Rule ID 14733 //
     /* 1886097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886143 */     // MIs[0] policy
     /* 1886143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886153 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886180 */     // GIR_Coverage, 14733,
     /* 1886180 */     GIR_EraseRootFromParent_Done,
     /* 1886181 */   // Label 25444: @1886181
     /* 1886181 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1886270), // Rule ID 14736 //
     /* 1886186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886232 */     // MIs[0] policy
     /* 1886232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886269 */     // GIR_Coverage, 14736,
     /* 1886269 */     GIR_EraseRootFromParent_Done,
     /* 1886270 */   // Label 25445: @1886270
     /* 1886270 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1886359), // Rule ID 14737 //
     /* 1886275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886321 */     // MIs[0] policy
     /* 1886321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886331 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886358 */     // GIR_Coverage, 14737,
     /* 1886358 */     GIR_EraseRootFromParent_Done,
     /* 1886359 */   // Label 25446: @1886359
     /* 1886359 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1886448), // Rule ID 14740 //
     /* 1886364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886410 */     // MIs[0] policy
     /* 1886410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886447 */     // GIR_Coverage, 14740,
     /* 1886447 */     GIR_EraseRootFromParent_Done,
     /* 1886448 */   // Label 25447: @1886448
     /* 1886448 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1886537), // Rule ID 14741 //
     /* 1886453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1886464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886499 */     // MIs[0] policy
     /* 1886499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886536 */     // GIR_Coverage, 14741,
     /* 1886536 */     GIR_EraseRootFromParent_Done,
     /* 1886537 */   // Label 25448: @1886537
     /* 1886537 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1886626), // Rule ID 14744 //
     /* 1886542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886588 */     // MIs[0] policy
     /* 1886588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886625 */     // GIR_Coverage, 14744,
     /* 1886625 */     GIR_EraseRootFromParent_Done,
     /* 1886626 */   // Label 25449: @1886626
     /* 1886626 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1886715), // Rule ID 14745 //
     /* 1886631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886677 */     // MIs[0] policy
     /* 1886677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886687 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886714 */     // GIR_Coverage, 14745,
     /* 1886714 */     GIR_EraseRootFromParent_Done,
     /* 1886715 */   // Label 25450: @1886715
     /* 1886715 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1886804), // Rule ID 14748 //
     /* 1886720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886766 */     // MIs[0] policy
     /* 1886766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886803 */     // GIR_Coverage, 14748,
     /* 1886803 */     GIR_EraseRootFromParent_Done,
     /* 1886804 */   // Label 25451: @1886804
     /* 1886804 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1886893), // Rule ID 14749 //
     /* 1886809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886855 */     // MIs[0] policy
     /* 1886855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886892 */     // GIR_Coverage, 14749,
     /* 1886892 */     GIR_EraseRootFromParent_Done,
     /* 1886893 */   // Label 25452: @1886893
     /* 1886893 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1886982), // Rule ID 14752 //
     /* 1886898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886944 */     // MIs[0] policy
     /* 1886944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886981 */     // GIR_Coverage, 14752,
     /* 1886981 */     GIR_EraseRootFromParent_Done,
     /* 1886982 */   // Label 25453: @1886982
     /* 1886982 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1887071), // Rule ID 14753 //
     /* 1886987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887033 */     // MIs[0] policy
     /* 1887033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1887046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887070 */     // GIR_Coverage, 14753,
     /* 1887070 */     GIR_EraseRootFromParent_Done,
     /* 1887071 */   // Label 25454: @1887071
     /* 1887071 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1887160), // Rule ID 14756 //
     /* 1887076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887122 */     // MIs[0] policy
     /* 1887122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1887135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887159 */     // GIR_Coverage, 14756,
     /* 1887159 */     GIR_EraseRootFromParent_Done,
     /* 1887160 */   // Label 25455: @1887160
     /* 1887160 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1887249), // Rule ID 14757 //
     /* 1887165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887211 */     // MIs[0] policy
     /* 1887211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887221 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1887224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887248 */     // GIR_Coverage, 14757,
     /* 1887248 */     GIR_EraseRootFromParent_Done,
     /* 1887249 */   // Label 25456: @1887249
     /* 1887249 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1887338), // Rule ID 14760 //
     /* 1887254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887300 */     // MIs[0] policy
     /* 1887300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1887313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887337 */     // GIR_Coverage, 14760,
     /* 1887337 */     GIR_EraseRootFromParent_Done,
     /* 1887338 */   // Label 25457: @1887338
     /* 1887338 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1887427), // Rule ID 14761 //
     /* 1887343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1887351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1887354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1887357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1887360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887389 */     // MIs[0] policy
     /* 1887389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887399 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1887402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887426 */     // GIR_Coverage, 14761,
     /* 1887426 */     GIR_EraseRootFromParent_Done,
     /* 1887427 */   // Label 25458: @1887427
     /* 1887427 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1887516), // Rule ID 14764 //
     /* 1887432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887478 */     // MIs[0] policy
     /* 1887478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887515 */     // GIR_Coverage, 14764,
     /* 1887515 */     GIR_EraseRootFromParent_Done,
     /* 1887516 */   // Label 25459: @1887516
     /* 1887516 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1887605), // Rule ID 14765 //
     /* 1887521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887567 */     // MIs[0] policy
     /* 1887567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887577 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887604 */     // GIR_Coverage, 14765,
     /* 1887604 */     GIR_EraseRootFromParent_Done,
     /* 1887605 */   // Label 25460: @1887605
     /* 1887605 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1887694), // Rule ID 14768 //
     /* 1887610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887656 */     // MIs[0] policy
     /* 1887656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887693 */     // GIR_Coverage, 14768,
     /* 1887693 */     GIR_EraseRootFromParent_Done,
     /* 1887694 */   // Label 25461: @1887694
     /* 1887694 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1887783), // Rule ID 14769 //
     /* 1887699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887745 */     // MIs[0] policy
     /* 1887745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887755 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887782 */     // GIR_Coverage, 14769,
     /* 1887782 */     GIR_EraseRootFromParent_Done,
     /* 1887783 */   // Label 25462: @1887783
     /* 1887783 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1887872), // Rule ID 14772 //
     /* 1887788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887834 */     // MIs[0] policy
     /* 1887834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887871 */     // GIR_Coverage, 14772,
     /* 1887871 */     GIR_EraseRootFromParent_Done,
     /* 1887872 */   // Label 25463: @1887872
     /* 1887872 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1887961), // Rule ID 14773 //
     /* 1887877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887923 */     // MIs[0] policy
     /* 1887923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887933 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887960 */     // GIR_Coverage, 14773,
     /* 1887960 */     GIR_EraseRootFromParent_Done,
     /* 1887961 */   // Label 25464: @1887961
     /* 1887961 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1888050), // Rule ID 14776 //
     /* 1887966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888012 */     // MIs[0] policy
     /* 1888012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1888025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888049 */     // GIR_Coverage, 14776,
     /* 1888049 */     GIR_EraseRootFromParent_Done,
     /* 1888050 */   // Label 25465: @1888050
     /* 1888050 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1888139), // Rule ID 14777 //
     /* 1888055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888101 */     // MIs[0] policy
     /* 1888101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888111 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1888114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888138 */     // GIR_Coverage, 14777,
     /* 1888138 */     GIR_EraseRootFromParent_Done,
     /* 1888139 */   // Label 25466: @1888139
     /* 1888139 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1888228), // Rule ID 14780 //
     /* 1888144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888190 */     // MIs[0] policy
     /* 1888190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888227 */     // GIR_Coverage, 14780,
     /* 1888227 */     GIR_EraseRootFromParent_Done,
     /* 1888228 */   // Label 25467: @1888228
     /* 1888228 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1888317), // Rule ID 14781 //
     /* 1888233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888279 */     // MIs[0] policy
     /* 1888279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888316 */     // GIR_Coverage, 14781,
     /* 1888316 */     GIR_EraseRootFromParent_Done,
     /* 1888317 */   // Label 25468: @1888317
     /* 1888317 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1888406), // Rule ID 14784 //
     /* 1888322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888368 */     // MIs[0] policy
     /* 1888368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888405 */     // GIR_Coverage, 14784,
     /* 1888405 */     GIR_EraseRootFromParent_Done,
     /* 1888406 */   // Label 25469: @1888406
     /* 1888406 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1888495), // Rule ID 14785 //
     /* 1888411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888457 */     // MIs[0] policy
     /* 1888457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888467 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888494 */     // GIR_Coverage, 14785,
     /* 1888494 */     GIR_EraseRootFromParent_Done,
     /* 1888495 */   // Label 25470: @1888495
     /* 1888495 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1888584), // Rule ID 14788 //
     /* 1888500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888546 */     // MIs[0] policy
     /* 1888546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888583 */     // GIR_Coverage, 14788,
     /* 1888583 */     GIR_EraseRootFromParent_Done,
     /* 1888584 */   // Label 25471: @1888584
     /* 1888584 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1888673), // Rule ID 14789 //
     /* 1888589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888635 */     // MIs[0] policy
     /* 1888635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888645 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888672 */     // GIR_Coverage, 14789,
     /* 1888672 */     GIR_EraseRootFromParent_Done,
     /* 1888673 */   // Label 25472: @1888673
     /* 1888673 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1888762), // Rule ID 14792 //
     /* 1888678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888724 */     // MIs[0] policy
     /* 1888724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888761 */     // GIR_Coverage, 14792,
     /* 1888761 */     GIR_EraseRootFromParent_Done,
     /* 1888762 */   // Label 25473: @1888762
     /* 1888762 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1888851), // Rule ID 14793 //
     /* 1888767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888813 */     // MIs[0] policy
     /* 1888813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888823 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888850 */     // GIR_Coverage, 14793,
     /* 1888850 */     GIR_EraseRootFromParent_Done,
     /* 1888851 */   // Label 25474: @1888851
     /* 1888851 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1888940), // Rule ID 14796 //
     /* 1888856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888902 */     // MIs[0] policy
     /* 1888902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888939 */     // GIR_Coverage, 14796,
     /* 1888939 */     GIR_EraseRootFromParent_Done,
     /* 1888940 */   // Label 25475: @1888940
     /* 1888940 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1889029), // Rule ID 14797 //
     /* 1888945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888991 */     // MIs[0] policy
     /* 1888991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889028 */     // GIR_Coverage, 14797,
     /* 1889028 */     GIR_EraseRootFromParent_Done,
     /* 1889029 */   // Label 25476: @1889029
     /* 1889029 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1889118), // Rule ID 14800 //
     /* 1889034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1889037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889080 */     // MIs[0] policy
     /* 1889080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889117 */     // GIR_Coverage, 14800,
     /* 1889117 */     GIR_EraseRootFromParent_Done,
     /* 1889118 */   // Label 25477: @1889118
     /* 1889118 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1889207), // Rule ID 14801 //
     /* 1889123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1889126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889169 */     // MIs[0] policy
     /* 1889169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889179 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1889182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889206 */     // GIR_Coverage, 14801,
     /* 1889206 */     GIR_EraseRootFromParent_Done,
     /* 1889207 */   // Label 25478: @1889207
     /* 1889207 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1889296), // Rule ID 14804 //
     /* 1889212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889258 */     // MIs[0] policy
     /* 1889258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889295 */     // GIR_Coverage, 14804,
     /* 1889295 */     GIR_EraseRootFromParent_Done,
     /* 1889296 */   // Label 25479: @1889296
     /* 1889296 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1889385), // Rule ID 14805 //
     /* 1889301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1889312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1889315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1889318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1889321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889347 */     // MIs[0] policy
     /* 1889347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889384 */     // GIR_Coverage, 14805,
     /* 1889384 */     GIR_EraseRootFromParent_Done,
     /* 1889385 */   // Label 25480: @1889385
     /* 1889385 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1889474), // Rule ID 14808 //
     /* 1889390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889436 */     // MIs[0] policy
     /* 1889436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889473 */     // GIR_Coverage, 14808,
     /* 1889473 */     GIR_EraseRootFromParent_Done,
     /* 1889474 */   // Label 25481: @1889474
     /* 1889474 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1889563), // Rule ID 14809 //
     /* 1889479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889525 */     // MIs[0] policy
     /* 1889525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889535 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889562 */     // GIR_Coverage, 14809,
     /* 1889562 */     GIR_EraseRootFromParent_Done,
     /* 1889563 */   // Label 25482: @1889563
     /* 1889563 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1889652), // Rule ID 14812 //
     /* 1889568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889614 */     // MIs[0] policy
     /* 1889614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889624 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889651 */     // GIR_Coverage, 14812,
     /* 1889651 */     GIR_EraseRootFromParent_Done,
     /* 1889652 */   // Label 25483: @1889652
     /* 1889652 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1889741), // Rule ID 14813 //
     /* 1889657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889703 */     // MIs[0] policy
     /* 1889703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889713 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889740 */     // GIR_Coverage, 14813,
     /* 1889740 */     GIR_EraseRootFromParent_Done,
     /* 1889741 */   // Label 25484: @1889741
     /* 1889741 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1889830), // Rule ID 14816 //
     /* 1889746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889792 */     // MIs[0] policy
     /* 1889792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889829 */     // GIR_Coverage, 14816,
     /* 1889829 */     GIR_EraseRootFromParent_Done,
     /* 1889830 */   // Label 25485: @1889830
     /* 1889830 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1889919), // Rule ID 14817 //
     /* 1889835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889881 */     // MIs[0] policy
     /* 1889881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889918 */     // GIR_Coverage, 14817,
     /* 1889918 */     GIR_EraseRootFromParent_Done,
     /* 1889919 */   // Label 25486: @1889919
     /* 1889919 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1890008), // Rule ID 14820 //
     /* 1889924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889970 */     // MIs[0] policy
     /* 1889970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890007 */     // GIR_Coverage, 14820,
     /* 1890007 */     GIR_EraseRootFromParent_Done,
     /* 1890008 */   // Label 25487: @1890008
     /* 1890008 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1890097), // Rule ID 14821 //
     /* 1890013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1890024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1890027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1890030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1890033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890059 */     // MIs[0] policy
     /* 1890059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890069 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890096 */     // GIR_Coverage, 14821,
     /* 1890096 */     GIR_EraseRootFromParent_Done,
     /* 1890097 */   // Label 25488: @1890097
     /* 1890097 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1890186), // Rule ID 14824 //
     /* 1890102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890148 */     // MIs[0] policy
     /* 1890148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890185 */     // GIR_Coverage, 14824,
     /* 1890185 */     GIR_EraseRootFromParent_Done,
     /* 1890186 */   // Label 25489: @1890186
     /* 1890186 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1890275), // Rule ID 14825 //
     /* 1890191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1890202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1890205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1890208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1890211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890237 */     // MIs[0] policy
     /* 1890237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890247 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890274 */     // GIR_Coverage, 14825,
     /* 1890274 */     GIR_EraseRootFromParent_Done,
     /* 1890275 */   // Label 25490: @1890275
     /* 1890275 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1890364), // Rule ID 14828 //
     /* 1890280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890326 */     // MIs[0] policy
     /* 1890326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890363 */     // GIR_Coverage, 14828,
     /* 1890363 */     GIR_EraseRootFromParent_Done,
     /* 1890364 */   // Label 25491: @1890364
     /* 1890364 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1890453), // Rule ID 14829 //
     /* 1890369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1890380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1890383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1890386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1890389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890415 */     // MIs[0] policy
     /* 1890415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890452 */     // GIR_Coverage, 14829,
     /* 1890452 */     GIR_EraseRootFromParent_Done,
     /* 1890453 */   // Label 25492: @1890453
     /* 1890453 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1890542), // Rule ID 14832 //
     /* 1890458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890504 */     // MIs[0] policy
     /* 1890504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890541 */     // GIR_Coverage, 14832,
     /* 1890541 */     GIR_EraseRootFromParent_Done,
     /* 1890542 */   // Label 25493: @1890542
     /* 1890542 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1890631), // Rule ID 14833 //
     /* 1890547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890593 */     // MIs[0] policy
     /* 1890593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890630 */     // GIR_Coverage, 14833,
     /* 1890630 */     GIR_EraseRootFromParent_Done,
     /* 1890631 */   // Label 25494: @1890631
     /* 1890631 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1890720), // Rule ID 14836 //
     /* 1890636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890682 */     // MIs[0] policy
     /* 1890682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890719 */     // GIR_Coverage, 14836,
     /* 1890719 */     GIR_EraseRootFromParent_Done,
     /* 1890720 */   // Label 25495: @1890720
     /* 1890720 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1890809), // Rule ID 14837 //
     /* 1890725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890771 */     // MIs[0] policy
     /* 1890771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890781 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890808 */     // GIR_Coverage, 14837,
     /* 1890808 */     GIR_EraseRootFromParent_Done,
     /* 1890809 */   // Label 25496: @1890809
     /* 1890809 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1890898), // Rule ID 14840 //
     /* 1890814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890860 */     // MIs[0] policy
     /* 1890860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890897 */     // GIR_Coverage, 14840,
     /* 1890897 */     GIR_EraseRootFromParent_Done,
     /* 1890898 */   // Label 25497: @1890898
     /* 1890898 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1890987), // Rule ID 14841 //
     /* 1890903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890949 */     // MIs[0] policy
     /* 1890949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890986 */     // GIR_Coverage, 14841,
     /* 1890986 */     GIR_EraseRootFromParent_Done,
     /* 1890987 */   // Label 25498: @1890987
     /* 1890987 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1891076), // Rule ID 14844 //
     /* 1890992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891038 */     // MIs[0] policy
     /* 1891038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1891051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891075 */     // GIR_Coverage, 14844,
     /* 1891075 */     GIR_EraseRootFromParent_Done,
     /* 1891076 */   // Label 25499: @1891076
     /* 1891076 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1891165), // Rule ID 14845 //
     /* 1891081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1891084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1891092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1891095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1891098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1891101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891127 */     // MIs[0] policy
     /* 1891127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891137 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1891140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891164 */     // GIR_Coverage, 14845,
     /* 1891164 */     GIR_EraseRootFromParent_Done,
     /* 1891165 */   // Label 25500: @1891165
     /* 1891165 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1891254), // Rule ID 14848 //
     /* 1891170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1891173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891216 */     // MIs[0] policy
     /* 1891216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1891229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891253 */     // GIR_Coverage, 14848,
     /* 1891253 */     GIR_EraseRootFromParent_Done,
     /* 1891254 */   // Label 25501: @1891254
     /* 1891254 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1891343), // Rule ID 14849 //
     /* 1891259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1891262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1891270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1891273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1891276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1891279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891305 */     // MIs[0] policy
     /* 1891305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891315 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1891318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891342 */     // GIR_Coverage, 14849,
     /* 1891342 */     GIR_EraseRootFromParent_Done,
     /* 1891343 */   // Label 25502: @1891343
     /* 1891343 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1891432), // Rule ID 14852 //
     /* 1891348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891394 */     // MIs[0] policy
     /* 1891394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891404 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891431 */     // GIR_Coverage, 14852,
     /* 1891431 */     GIR_EraseRootFromParent_Done,
     /* 1891432 */   // Label 25503: @1891432
     /* 1891432 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1891521), // Rule ID 14853 //
     /* 1891437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1891448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1891451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1891454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891483 */     // MIs[0] policy
     /* 1891483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891493 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891520 */     // GIR_Coverage, 14853,
     /* 1891520 */     GIR_EraseRootFromParent_Done,
     /* 1891521 */   // Label 25504: @1891521
     /* 1891521 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1891610), // Rule ID 14856 //
     /* 1891526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891572 */     // MIs[0] policy
     /* 1891572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891609 */     // GIR_Coverage, 14856,
     /* 1891609 */     GIR_EraseRootFromParent_Done,
     /* 1891610 */   // Label 25505: @1891610
     /* 1891610 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1891699), // Rule ID 14857 //
     /* 1891615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891661 */     // MIs[0] policy
     /* 1891661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891671 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891698 */     // GIR_Coverage, 14857,
     /* 1891698 */     GIR_EraseRootFromParent_Done,
     /* 1891699 */   // Label 25506: @1891699
     /* 1891699 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1891788), // Rule ID 14860 //
     /* 1891704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891750 */     // MIs[0] policy
     /* 1891750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891787 */     // GIR_Coverage, 14860,
     /* 1891787 */     GIR_EraseRootFromParent_Done,
     /* 1891788 */   // Label 25507: @1891788
     /* 1891788 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1891877), // Rule ID 14861 //
     /* 1891793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891839 */     // MIs[0] policy
     /* 1891839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891849 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891876 */     // GIR_Coverage, 14861,
     /* 1891876 */     GIR_EraseRootFromParent_Done,
     /* 1891877 */   // Label 25508: @1891877
     /* 1891877 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1891966), // Rule ID 14864 //
     /* 1891882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891928 */     // MIs[0] policy
     /* 1891928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891965 */     // GIR_Coverage, 14864,
     /* 1891965 */     GIR_EraseRootFromParent_Done,
     /* 1891966 */   // Label 25509: @1891966
     /* 1891966 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1892055), // Rule ID 14865 //
     /* 1891971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892017 */     // MIs[0] policy
     /* 1892017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892027 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1892030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892054 */     // GIR_Coverage, 14865,
     /* 1892054 */     GIR_EraseRootFromParent_Done,
     /* 1892055 */   // Label 25510: @1892055
     /* 1892055 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1892144), // Rule ID 14868 //
     /* 1892060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892106 */     // MIs[0] policy
     /* 1892106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892143 */     // GIR_Coverage, 14868,
     /* 1892143 */     GIR_EraseRootFromParent_Done,
     /* 1892144 */   // Label 25511: @1892144
     /* 1892144 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1892233), // Rule ID 14869 //
     /* 1892149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892195 */     // MIs[0] policy
     /* 1892195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892205 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892232 */     // GIR_Coverage, 14869,
     /* 1892232 */     GIR_EraseRootFromParent_Done,
     /* 1892233 */   // Label 25512: @1892233
     /* 1892233 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1892322), // Rule ID 14872 //
     /* 1892238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892284 */     // MIs[0] policy
     /* 1892284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892321 */     // GIR_Coverage, 14872,
     /* 1892321 */     GIR_EraseRootFromParent_Done,
     /* 1892322 */   // Label 25513: @1892322
     /* 1892322 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1892411), // Rule ID 14873 //
     /* 1892327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892373 */     // MIs[0] policy
     /* 1892373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892383 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1892386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892410 */     // GIR_Coverage, 14873,
     /* 1892410 */     GIR_EraseRootFromParent_Done,
     /* 1892411 */   // Label 25514: @1892411
     /* 1892411 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1892500), // Rule ID 14876 //
     /* 1892416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892462 */     // MIs[0] policy
     /* 1892462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892499 */     // GIR_Coverage, 14876,
     /* 1892499 */     GIR_EraseRootFromParent_Done,
     /* 1892500 */   // Label 25515: @1892500
     /* 1892500 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1892589), // Rule ID 14877 //
     /* 1892505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892551 */     // MIs[0] policy
     /* 1892551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892561 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11674:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892588 */     // GIR_Coverage, 14877,
     /* 1892588 */     GIR_EraseRootFromParent_Done,
     /* 1892589 */   // Label 25516: @1892589
     /* 1892589 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1892678), // Rule ID 14880 //
     /* 1892594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892640 */     // MIs[0] policy
     /* 1892640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892677 */     // GIR_Coverage, 14880,
     /* 1892677 */     GIR_EraseRootFromParent_Done,
     /* 1892678 */   // Label 25517: @1892678
     /* 1892678 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1892767), // Rule ID 14881 //
     /* 1892683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892729 */     // MIs[0] policy
     /* 1892729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892766 */     // GIR_Coverage, 14881,
     /* 1892766 */     GIR_EraseRootFromParent_Done,
     /* 1892767 */   // Label 25518: @1892767
     /* 1892767 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1892856), // Rule ID 14884 //
     /* 1892772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892818 */     // MIs[0] policy
     /* 1892818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892855 */     // GIR_Coverage, 14884,
     /* 1892855 */     GIR_EraseRootFromParent_Done,
     /* 1892856 */   // Label 25519: @1892856
     /* 1892856 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1892945), // Rule ID 14885 //
     /* 1892861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892907 */     // MIs[0] policy
     /* 1892907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892917 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892944 */     // GIR_Coverage, 14885,
     /* 1892944 */     GIR_EraseRootFromParent_Done,
     /* 1892945 */   // Label 25520: @1892945
     /* 1892945 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1893034), // Rule ID 14888 //
     /* 1892950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892996 */     // MIs[0] policy
     /* 1892996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1893009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893033 */     // GIR_Coverage, 14888,
     /* 1893033 */     GIR_EraseRootFromParent_Done,
     /* 1893034 */   // Label 25521: @1893034
     /* 1893034 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1893123), // Rule ID 14889 //
     /* 1893039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1893042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1893050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1893053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1893056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893085 */     // MIs[0] policy
     /* 1893085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1893098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893122 */     // GIR_Coverage, 14889,
     /* 1893122 */     GIR_EraseRootFromParent_Done,
     /* 1893123 */   // Label 25522: @1893123
     /* 1893123 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1893212), // Rule ID 14892 //
     /* 1893128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893174 */     // MIs[0] policy
     /* 1893174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893211 */     // GIR_Coverage, 14892,
     /* 1893211 */     GIR_EraseRootFromParent_Done,
     /* 1893212 */   // Label 25523: @1893212
     /* 1893212 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1893301), // Rule ID 14893 //
     /* 1893217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1893228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1893231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1893234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893263 */     // MIs[0] policy
     /* 1893263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893300 */     // GIR_Coverage, 14893,
     /* 1893300 */     GIR_EraseRootFromParent_Done,
     /* 1893301 */   // Label 25524: @1893301
     /* 1893301 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1893390), // Rule ID 14896 //
     /* 1893306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893352 */     // MIs[0] policy
     /* 1893352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893362 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893389 */     // GIR_Coverage, 14896,
     /* 1893389 */     GIR_EraseRootFromParent_Done,
     /* 1893390 */   // Label 25525: @1893390
     /* 1893390 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1893479), // Rule ID 14897 //
     /* 1893395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1893406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1893409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1893412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893441 */     // MIs[0] policy
     /* 1893441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893478 */     // GIR_Coverage, 14897,
     /* 1893478 */     GIR_EraseRootFromParent_Done,
     /* 1893479 */   // Label 25526: @1893479
     /* 1893479 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1893568), // Rule ID 14900 //
     /* 1893484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893530 */     // MIs[0] policy
     /* 1893530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893540 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893567 */     // GIR_Coverage, 14900,
     /* 1893567 */     GIR_EraseRootFromParent_Done,
     /* 1893568 */   // Label 25527: @1893568
     /* 1893568 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1893657), // Rule ID 14901 //
     /* 1893573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893619 */     // MIs[0] policy
     /* 1893619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893629 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893656 */     // GIR_Coverage, 14901,
     /* 1893656 */     GIR_EraseRootFromParent_Done,
     /* 1893657 */   // Label 25528: @1893657
     /* 1893657 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1893746), // Rule ID 14904 //
     /* 1893662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893708 */     // MIs[0] policy
     /* 1893708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893745 */     // GIR_Coverage, 14904,
     /* 1893745 */     GIR_EraseRootFromParent_Done,
     /* 1893746 */   // Label 25529: @1893746
     /* 1893746 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1893835), // Rule ID 14905 //
     /* 1893751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893797 */     // MIs[0] policy
     /* 1893797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893834 */     // GIR_Coverage, 14905,
     /* 1893834 */     GIR_EraseRootFromParent_Done,
     /* 1893835 */   // Label 25530: @1893835
     /* 1893835 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1893924), // Rule ID 14908 //
     /* 1893840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893886 */     // MIs[0] policy
     /* 1893886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893923 */     // GIR_Coverage, 14908,
     /* 1893923 */     GIR_EraseRootFromParent_Done,
     /* 1893924 */   // Label 25531: @1893924
     /* 1893924 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1894013), // Rule ID 14909 //
     /* 1893929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893975 */     // MIs[0] policy
     /* 1893975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893985 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894012 */     // GIR_Coverage, 14909,
     /* 1894012 */     GIR_EraseRootFromParent_Done,
     /* 1894013 */   // Label 25532: @1894013
     /* 1894013 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1894102), // Rule ID 14912 //
     /* 1894018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894064 */     // MIs[0] policy
     /* 1894064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894101 */     // GIR_Coverage, 14912,
     /* 1894101 */     GIR_EraseRootFromParent_Done,
     /* 1894102 */   // Label 25533: @1894102
     /* 1894102 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1894191), // Rule ID 14913 //
     /* 1894107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894153 */     // MIs[0] policy
     /* 1894153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894163 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894190 */     // GIR_Coverage, 14913,
     /* 1894190 */     GIR_EraseRootFromParent_Done,
     /* 1894191 */   // Label 25534: @1894191
     /* 1894191 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1894280), // Rule ID 14916 //
     /* 1894196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894242 */     // MIs[0] policy
     /* 1894242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894279 */     // GIR_Coverage, 14916,
     /* 1894279 */     GIR_EraseRootFromParent_Done,
     /* 1894280 */   // Label 25535: @1894280
     /* 1894280 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1894369), // Rule ID 14917 //
     /* 1894285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894331 */     // MIs[0] policy
     /* 1894331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894368 */     // GIR_Coverage, 14917,
     /* 1894368 */     GIR_EraseRootFromParent_Done,
     /* 1894369 */   // Label 25536: @1894369
     /* 1894369 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1894458), // Rule ID 14920 //
     /* 1894374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894420 */     // MIs[0] policy
     /* 1894420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894457 */     // GIR_Coverage, 14920,
     /* 1894457 */     GIR_EraseRootFromParent_Done,
     /* 1894458 */   // Label 25537: @1894458
     /* 1894458 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1894547), // Rule ID 14921 //
     /* 1894463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894509 */     // MIs[0] policy
     /* 1894509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894519 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894546 */     // GIR_Coverage, 14921,
     /* 1894546 */     GIR_EraseRootFromParent_Done,
     /* 1894547 */   // Label 25538: @1894547
     /* 1894547 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1894636), // Rule ID 14924 //
     /* 1894552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894598 */     // MIs[0] policy
     /* 1894598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894635 */     // GIR_Coverage, 14924,
     /* 1894635 */     GIR_EraseRootFromParent_Done,
     /* 1894636 */   // Label 25539: @1894636
     /* 1894636 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1894725), // Rule ID 14925 //
     /* 1894641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894687 */     // MIs[0] policy
     /* 1894687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894697 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894724 */     // GIR_Coverage, 14925,
     /* 1894724 */     GIR_EraseRootFromParent_Done,
     /* 1894725 */   // Label 25540: @1894725
     /* 1894725 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1894814), // Rule ID 14928 //
     /* 1894730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894776 */     // MIs[0] policy
     /* 1894776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894813 */     // GIR_Coverage, 14928,
     /* 1894813 */     GIR_EraseRootFromParent_Done,
     /* 1894814 */   // Label 25541: @1894814
     /* 1894814 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1894903), // Rule ID 14929 //
     /* 1894819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894865 */     // MIs[0] policy
     /* 1894865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894902 */     // GIR_Coverage, 14929,
     /* 1894902 */     GIR_EraseRootFromParent_Done,
     /* 1894903 */   // Label 25542: @1894903
     /* 1894903 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1894992), // Rule ID 14932 //
     /* 1894908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894954 */     // MIs[0] policy
     /* 1894954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894991 */     // GIR_Coverage, 14932,
     /* 1894991 */     GIR_EraseRootFromParent_Done,
     /* 1894992 */   // Label 25543: @1894992
     /* 1894992 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1895081), // Rule ID 14933 //
     /* 1894997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1895000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1895008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1895011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1895014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895043 */     // MIs[0] policy
     /* 1895043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895053 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1895056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895080 */     // GIR_Coverage, 14933,
     /* 1895080 */     GIR_EraseRootFromParent_Done,
     /* 1895081 */   // Label 25544: @1895081
     /* 1895081 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1895170), // Rule ID 14936 //
     /* 1895086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1895089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1895106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895132 */     // MIs[0] policy
     /* 1895132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1895145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895169 */     // GIR_Coverage, 14936,
     /* 1895169 */     GIR_EraseRootFromParent_Done,
     /* 1895170 */   // Label 25545: @1895170
     /* 1895170 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1895259), // Rule ID 14937 //
     /* 1895175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1895178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1895183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1895217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895221 */     // MIs[0] policy
     /* 1895221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895231 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1895234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1895257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895258 */     // GIR_Coverage, 14937,
     /* 1895258 */     GIR_EraseRootFromParent_Done,
     /* 1895259 */   // Label 25546: @1895259
     /* 1895259 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1895345), // Rule ID 19178 //
     /* 1895264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1895284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895310 */     // MIs[0] policy
     /* 1895310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1895323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895344 */     // GIR_Coverage, 19178,
     /* 1895344 */     GIR_EraseRootFromParent_Done,
     /* 1895345 */   // Label 25547: @1895345
     /* 1895345 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1895431), // Rule ID 19179 //
     /* 1895350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1895370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895396 */     // MIs[0] policy
     /* 1895396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895406 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1895409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895430 */     // GIR_Coverage, 19179,
     /* 1895430 */     GIR_EraseRootFromParent_Done,
     /* 1895431 */   // Label 25548: @1895431
     /* 1895431 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1895517), // Rule ID 19182 //
     /* 1895436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895482 */     // MIs[0] policy
     /* 1895482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895492 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895516 */     // GIR_Coverage, 19182,
     /* 1895516 */     GIR_EraseRootFromParent_Done,
     /* 1895517 */   // Label 25549: @1895517
     /* 1895517 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1895603), // Rule ID 19183 //
     /* 1895522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895568 */     // MIs[0] policy
     /* 1895568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895578 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895602 */     // GIR_Coverage, 19183,
     /* 1895602 */     GIR_EraseRootFromParent_Done,
     /* 1895603 */   // Label 25550: @1895603
     /* 1895603 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1895689), // Rule ID 19186 //
     /* 1895608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895654 */     // MIs[0] policy
     /* 1895654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895688 */     // GIR_Coverage, 19186,
     /* 1895688 */     GIR_EraseRootFromParent_Done,
     /* 1895689 */   // Label 25551: @1895689
     /* 1895689 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1895775), // Rule ID 19187 //
     /* 1895694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895740 */     // MIs[0] policy
     /* 1895740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895750 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895774 */     // GIR_Coverage, 19187,
     /* 1895774 */     GIR_EraseRootFromParent_Done,
     /* 1895775 */   // Label 25552: @1895775
     /* 1895775 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1895861), // Rule ID 19190 //
     /* 1895780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895826 */     // MIs[0] policy
     /* 1895826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895836 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895860 */     // GIR_Coverage, 19190,
     /* 1895860 */     GIR_EraseRootFromParent_Done,
     /* 1895861 */   // Label 25553: @1895861
     /* 1895861 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1895947), // Rule ID 19191 //
     /* 1895866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895912 */     // MIs[0] policy
     /* 1895912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895946 */     // GIR_Coverage, 19191,
     /* 1895946 */     GIR_EraseRootFromParent_Done,
     /* 1895947 */   // Label 25554: @1895947
     /* 1895947 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1896033), // Rule ID 19194 //
     /* 1895952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895998 */     // MIs[0] policy
     /* 1895998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896008 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1896011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896032 */     // GIR_Coverage, 19194,
     /* 1896032 */     GIR_EraseRootFromParent_Done,
     /* 1896033 */   // Label 25555: @1896033
     /* 1896033 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1896119), // Rule ID 19195 //
     /* 1896038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1896058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896084 */     // MIs[0] policy
     /* 1896084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896094 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1896097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896118 */     // GIR_Coverage, 19195,
     /* 1896118 */     GIR_EraseRootFromParent_Done,
     /* 1896119 */   // Label 25556: @1896119
     /* 1896119 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1896205), // Rule ID 19198 //
     /* 1896124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1896144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896170 */     // MIs[0] policy
     /* 1896170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896180 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1896183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896204 */     // GIR_Coverage, 19198,
     /* 1896204 */     GIR_EraseRootFromParent_Done,
     /* 1896205 */   // Label 25557: @1896205
     /* 1896205 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1896291), // Rule ID 19199 //
     /* 1896210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1896230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896256 */     // MIs[0] policy
     /* 1896256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896266 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1896269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896290 */     // GIR_Coverage, 19199,
     /* 1896290 */     GIR_EraseRootFromParent_Done,
     /* 1896291 */   // Label 25558: @1896291
     /* 1896291 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1896377), // Rule ID 19202 //
     /* 1896296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1896316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896342 */     // MIs[0] policy
     /* 1896342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896352 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1896355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896376 */     // GIR_Coverage, 19202,
     /* 1896376 */     GIR_EraseRootFromParent_Done,
     /* 1896377 */   // Label 25559: @1896377
     /* 1896377 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1896463), // Rule ID 19203 //
     /* 1896382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1896402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896428 */     // MIs[0] policy
     /* 1896428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1896441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896462 */     // GIR_Coverage, 19203,
     /* 1896462 */     GIR_EraseRootFromParent_Done,
     /* 1896463 */   // Label 25560: @1896463
     /* 1896463 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1896549), // Rule ID 19206 //
     /* 1896468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896514 */     // MIs[0] policy
     /* 1896514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896524 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896548 */     // GIR_Coverage, 19206,
     /* 1896548 */     GIR_EraseRootFromParent_Done,
     /* 1896549 */   // Label 25561: @1896549
     /* 1896549 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1896635), // Rule ID 19207 //
     /* 1896554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896600 */     // MIs[0] policy
     /* 1896600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896634 */     // GIR_Coverage, 19207,
     /* 1896634 */     GIR_EraseRootFromParent_Done,
     /* 1896635 */   // Label 25562: @1896635
     /* 1896635 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1896721), // Rule ID 19210 //
     /* 1896640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896686 */     // MIs[0] policy
     /* 1896686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896696 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896720 */     // GIR_Coverage, 19210,
     /* 1896720 */     GIR_EraseRootFromParent_Done,
     /* 1896721 */   // Label 25563: @1896721
     /* 1896721 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1896807), // Rule ID 19211 //
     /* 1896726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896772 */     // MIs[0] policy
     /* 1896772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896782 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896806 */     // GIR_Coverage, 19211,
     /* 1896806 */     GIR_EraseRootFromParent_Done,
     /* 1896807 */   // Label 25564: @1896807
     /* 1896807 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1896893), // Rule ID 19214 //
     /* 1896812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896858 */     // MIs[0] policy
     /* 1896858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896892 */     // GIR_Coverage, 19214,
     /* 1896892 */     GIR_EraseRootFromParent_Done,
     /* 1896893 */   // Label 25565: @1896893
     /* 1896893 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1896979), // Rule ID 19215 //
     /* 1896898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896944 */     // MIs[0] policy
     /* 1896944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896978 */     // GIR_Coverage, 19215,
     /* 1896978 */     GIR_EraseRootFromParent_Done,
     /* 1896979 */   // Label 25566: @1896979
     /* 1896979 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1897065), // Rule ID 19218 //
     /* 1896984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1897004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897030 */     // MIs[0] policy
     /* 1897030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897040 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1897043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897064 */     // GIR_Coverage, 19218,
     /* 1897064 */     GIR_EraseRootFromParent_Done,
     /* 1897065 */   // Label 25567: @1897065
     /* 1897065 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1897151), // Rule ID 19219 //
     /* 1897070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1897090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897116 */     // MIs[0] policy
     /* 1897116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897126 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1897129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897150 */     // GIR_Coverage, 19219,
     /* 1897150 */     GIR_EraseRootFromParent_Done,
     /* 1897151 */   // Label 25568: @1897151
     /* 1897151 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1897237), // Rule ID 19222 //
     /* 1897156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1897176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897202 */     // MIs[0] policy
     /* 1897202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897212 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1897215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897236 */     // GIR_Coverage, 19222,
     /* 1897236 */     GIR_EraseRootFromParent_Done,
     /* 1897237 */   // Label 25569: @1897237
     /* 1897237 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1897323), // Rule ID 19223 //
     /* 1897242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1897262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897288 */     // MIs[0] policy
     /* 1897288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897298 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1897301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897322 */     // GIR_Coverage, 19223,
     /* 1897322 */     GIR_EraseRootFromParent_Done,
     /* 1897323 */   // Label 25570: @1897323
     /* 1897323 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1897409), // Rule ID 19226 //
     /* 1897328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1897348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897374 */     // MIs[0] policy
     /* 1897374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897408 */     // GIR_Coverage, 19226,
     /* 1897408 */     GIR_EraseRootFromParent_Done,
     /* 1897409 */   // Label 25571: @1897409
     /* 1897409 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1897495), // Rule ID 19227 //
     /* 1897414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1897434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897460 */     // MIs[0] policy
     /* 1897460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897494 */     // GIR_Coverage, 19227,
     /* 1897494 */     GIR_EraseRootFromParent_Done,
     /* 1897495 */   // Label 25572: @1897495
     /* 1897495 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1897581), // Rule ID 19230 //
     /* 1897500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897546 */     // MIs[0] policy
     /* 1897546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897556 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897580 */     // GIR_Coverage, 19230,
     /* 1897580 */     GIR_EraseRootFromParent_Done,
     /* 1897581 */   // Label 25573: @1897581
     /* 1897581 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1897667), // Rule ID 19231 //
     /* 1897586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897632 */     // MIs[0] policy
     /* 1897632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897642 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897666 */     // GIR_Coverage, 19231,
     /* 1897666 */     GIR_EraseRootFromParent_Done,
     /* 1897667 */   // Label 25574: @1897667
     /* 1897667 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1897753), // Rule ID 19234 //
     /* 1897672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897718 */     // MIs[0] policy
     /* 1897718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897728 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897752 */     // GIR_Coverage, 19234,
     /* 1897752 */     GIR_EraseRootFromParent_Done,
     /* 1897753 */   // Label 25575: @1897753
     /* 1897753 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1897839), // Rule ID 19235 //
     /* 1897758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897804 */     // MIs[0] policy
     /* 1897804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897838 */     // GIR_Coverage, 19235,
     /* 1897838 */     GIR_EraseRootFromParent_Done,
     /* 1897839 */   // Label 25576: @1897839
     /* 1897839 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1897925), // Rule ID 19238 //
     /* 1897844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897890 */     // MIs[0] policy
     /* 1897890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897900 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897924 */     // GIR_Coverage, 19238,
     /* 1897924 */     GIR_EraseRootFromParent_Done,
     /* 1897925 */   // Label 25577: @1897925
     /* 1897925 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1898011), // Rule ID 19239 //
     /* 1897930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897976 */     // MIs[0] policy
     /* 1897976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897986 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898010 */     // GIR_Coverage, 19239,
     /* 1898010 */     GIR_EraseRootFromParent_Done,
     /* 1898011 */   // Label 25578: @1898011
     /* 1898011 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1898097), // Rule ID 19242 //
     /* 1898016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898062 */     // MIs[0] policy
     /* 1898062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898072 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1898075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898096 */     // GIR_Coverage, 19242,
     /* 1898096 */     GIR_EraseRootFromParent_Done,
     /* 1898097 */   // Label 25579: @1898097
     /* 1898097 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1898183), // Rule ID 19243 //
     /* 1898102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898148 */     // MIs[0] policy
     /* 1898148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898158 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1898161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898182 */     // GIR_Coverage, 19243,
     /* 1898182 */     GIR_EraseRootFromParent_Done,
     /* 1898183 */   // Label 25580: @1898183
     /* 1898183 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1898269), // Rule ID 19246 //
     /* 1898188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898234 */     // MIs[0] policy
     /* 1898234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1898247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898268 */     // GIR_Coverage, 19246,
     /* 1898268 */     GIR_EraseRootFromParent_Done,
     /* 1898269 */   // Label 25581: @1898269
     /* 1898269 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1898355), // Rule ID 19247 //
     /* 1898274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898320 */     // MIs[0] policy
     /* 1898320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898330 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1898333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898354 */     // GIR_Coverage, 19247,
     /* 1898354 */     GIR_EraseRootFromParent_Done,
     /* 1898355 */   // Label 25582: @1898355
     /* 1898355 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1898441), // Rule ID 19250 //
     /* 1898360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898406 */     // MIs[0] policy
     /* 1898406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898440 */     // GIR_Coverage, 19250,
     /* 1898440 */     GIR_EraseRootFromParent_Done,
     /* 1898441 */   // Label 25583: @1898441
     /* 1898441 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1898527), // Rule ID 19251 //
     /* 1898446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898492 */     // MIs[0] policy
     /* 1898492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898526 */     // GIR_Coverage, 19251,
     /* 1898526 */     GIR_EraseRootFromParent_Done,
     /* 1898527 */   // Label 25584: @1898527
     /* 1898527 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1898613), // Rule ID 19254 //
     /* 1898532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898578 */     // MIs[0] policy
     /* 1898578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898588 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898612 */     // GIR_Coverage, 19254,
     /* 1898612 */     GIR_EraseRootFromParent_Done,
     /* 1898613 */   // Label 25585: @1898613
     /* 1898613 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1898699), // Rule ID 19255 //
     /* 1898618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898664 */     // MIs[0] policy
     /* 1898664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898674 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898698 */     // GIR_Coverage, 19255,
     /* 1898698 */     GIR_EraseRootFromParent_Done,
     /* 1898699 */   // Label 25586: @1898699
     /* 1898699 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1898785), // Rule ID 19258 //
     /* 1898704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898750 */     // MIs[0] policy
     /* 1898750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898760 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898784 */     // GIR_Coverage, 19258,
     /* 1898784 */     GIR_EraseRootFromParent_Done,
     /* 1898785 */   // Label 25587: @1898785
     /* 1898785 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1898871), // Rule ID 19259 //
     /* 1898790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898836 */     // MIs[0] policy
     /* 1898836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898846 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898870 */     // GIR_Coverage, 19259,
     /* 1898870 */     GIR_EraseRootFromParent_Done,
     /* 1898871 */   // Label 25588: @1898871
     /* 1898871 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1898957), // Rule ID 19262 //
     /* 1898876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898922 */     // MIs[0] policy
     /* 1898922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898956 */     // GIR_Coverage, 19262,
     /* 1898956 */     GIR_EraseRootFromParent_Done,
     /* 1898957 */   // Label 25589: @1898957
     /* 1898957 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1899043), // Rule ID 19263 //
     /* 1898962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899008 */     // MIs[0] policy
     /* 1899008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1899021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899042 */     // GIR_Coverage, 19263,
     /* 1899042 */     GIR_EraseRootFromParent_Done,
     /* 1899043 */   // Label 25590: @1899043
     /* 1899043 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1899129), // Rule ID 19266 //
     /* 1899048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899094 */     // MIs[0] policy
     /* 1899094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899104 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1899107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899128 */     // GIR_Coverage, 19266,
     /* 1899128 */     GIR_EraseRootFromParent_Done,
     /* 1899129 */   // Label 25591: @1899129
     /* 1899129 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1899215), // Rule ID 19267 //
     /* 1899134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899180 */     // MIs[0] policy
     /* 1899180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1899193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899214 */     // GIR_Coverage, 19267,
     /* 1899214 */     GIR_EraseRootFromParent_Done,
     /* 1899215 */   // Label 25592: @1899215
     /* 1899215 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1899301), // Rule ID 19270 //
     /* 1899220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899266 */     // MIs[0] policy
     /* 1899266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899276 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1899279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899300 */     // GIR_Coverage, 19270,
     /* 1899300 */     GIR_EraseRootFromParent_Done,
     /* 1899301 */   // Label 25593: @1899301
     /* 1899301 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1899387), // Rule ID 19271 //
     /* 1899306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1899326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1899348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899352 */     // MIs[0] policy
     /* 1899352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899362 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1899365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899386 */     // GIR_Coverage, 19271,
     /* 1899386 */     GIR_EraseRootFromParent_Done,
     /* 1899387 */   // Label 25594: @1899387
     /* 1899387 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1899473), // Rule ID 19274 //
     /* 1899392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899438 */     // MIs[0] policy
     /* 1899438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899448 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899472 */     // GIR_Coverage, 19274,
     /* 1899472 */     GIR_EraseRootFromParent_Done,
     /* 1899473 */   // Label 25595: @1899473
     /* 1899473 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1899559), // Rule ID 19275 //
     /* 1899478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899524 */     // MIs[0] policy
     /* 1899524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899534 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899558 */     // GIR_Coverage, 19275,
     /* 1899558 */     GIR_EraseRootFromParent_Done,
     /* 1899559 */   // Label 25596: @1899559
     /* 1899559 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1899645), // Rule ID 19278 //
     /* 1899564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899610 */     // MIs[0] policy
     /* 1899610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899620 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899644 */     // GIR_Coverage, 19278,
     /* 1899644 */     GIR_EraseRootFromParent_Done,
     /* 1899645 */   // Label 25597: @1899645
     /* 1899645 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1899731), // Rule ID 19279 //
     /* 1899650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899696 */     // MIs[0] policy
     /* 1899696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899706 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899730 */     // GIR_Coverage, 19279,
     /* 1899730 */     GIR_EraseRootFromParent_Done,
     /* 1899731 */   // Label 25598: @1899731
     /* 1899731 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1899817), // Rule ID 19282 //
     /* 1899736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899782 */     // MIs[0] policy
     /* 1899782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899792 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899816 */     // GIR_Coverage, 19282,
     /* 1899816 */     GIR_EraseRootFromParent_Done,
     /* 1899817 */   // Label 25599: @1899817
     /* 1899817 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1899903), // Rule ID 19283 //
     /* 1899822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899868 */     // MIs[0] policy
     /* 1899868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899878 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899902 */     // GIR_Coverage, 19283,
     /* 1899902 */     GIR_EraseRootFromParent_Done,
     /* 1899903 */   // Label 25600: @1899903
     /* 1899903 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1899989), // Rule ID 19286 //
     /* 1899908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899954 */     // MIs[0] policy
     /* 1899954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899988 */     // GIR_Coverage, 19286,
     /* 1899988 */     GIR_EraseRootFromParent_Done,
     /* 1899989 */   // Label 25601: @1899989
     /* 1899989 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1900075), // Rule ID 19287 //
     /* 1899994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900040 */     // MIs[0] policy
     /* 1900040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1900053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900074 */     // GIR_Coverage, 19287,
     /* 1900074 */     GIR_EraseRootFromParent_Done,
     /* 1900075 */   // Label 25602: @1900075
     /* 1900075 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1900161), // Rule ID 19290 //
     /* 1900080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900126 */     // MIs[0] policy
     /* 1900126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900136 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1900139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900160 */     // GIR_Coverage, 19290,
     /* 1900160 */     GIR_EraseRootFromParent_Done,
     /* 1900161 */   // Label 25603: @1900161
     /* 1900161 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1900247), // Rule ID 19291 //
     /* 1900166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900212 */     // MIs[0] policy
     /* 1900212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900222 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1900225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900246 */     // GIR_Coverage, 19291,
     /* 1900246 */     GIR_EraseRootFromParent_Done,
     /* 1900247 */   // Label 25604: @1900247
     /* 1900247 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1900333), // Rule ID 19294 //
     /* 1900252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900298 */     // MIs[0] policy
     /* 1900298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900308 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1900311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900332 */     // GIR_Coverage, 19294,
     /* 1900332 */     GIR_EraseRootFromParent_Done,
     /* 1900333 */   // Label 25605: @1900333
     /* 1900333 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1900419), // Rule ID 19295 //
     /* 1900338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1900346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1900358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1900380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900384 */     // MIs[0] policy
     /* 1900384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900394 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1900397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900418 */     // GIR_Coverage, 19295,
     /* 1900418 */     GIR_EraseRootFromParent_Done,
     /* 1900419 */   // Label 25606: @1900419
     /* 1900419 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1900505), // Rule ID 19298 //
     /* 1900424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900470 */     // MIs[0] policy
     /* 1900470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900480 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900504 */     // GIR_Coverage, 19298,
     /* 1900504 */     GIR_EraseRootFromParent_Done,
     /* 1900505 */   // Label 25607: @1900505
     /* 1900505 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1900591), // Rule ID 19299 //
     /* 1900510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900556 */     // MIs[0] policy
     /* 1900556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900566 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900590 */     // GIR_Coverage, 19299,
     /* 1900590 */     GIR_EraseRootFromParent_Done,
     /* 1900591 */   // Label 25608: @1900591
     /* 1900591 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1900677), // Rule ID 19302 //
     /* 1900596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900642 */     // MIs[0] policy
     /* 1900642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900652 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900676 */     // GIR_Coverage, 19302,
     /* 1900676 */     GIR_EraseRootFromParent_Done,
     /* 1900677 */   // Label 25609: @1900677
     /* 1900677 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1900763), // Rule ID 19303 //
     /* 1900682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900728 */     // MIs[0] policy
     /* 1900728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900738 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900762 */     // GIR_Coverage, 19303,
     /* 1900762 */     GIR_EraseRootFromParent_Done,
     /* 1900763 */   // Label 25610: @1900763
     /* 1900763 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1900849), // Rule ID 19306 //
     /* 1900768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900814 */     // MIs[0] policy
     /* 1900814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900848 */     // GIR_Coverage, 19306,
     /* 1900848 */     GIR_EraseRootFromParent_Done,
     /* 1900849 */   // Label 25611: @1900849
     /* 1900849 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1900935), // Rule ID 19307 //
     /* 1900854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900900 */     // MIs[0] policy
     /* 1900900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900910 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900934 */     // GIR_Coverage, 19307,
     /* 1900934 */     GIR_EraseRootFromParent_Done,
     /* 1900935 */   // Label 25612: @1900935
     /* 1900935 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1901021), // Rule ID 19310 //
     /* 1900940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900986 */     // MIs[0] policy
     /* 1900986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1900999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901020 */     // GIR_Coverage, 19310,
     /* 1901020 */     GIR_EraseRootFromParent_Done,
     /* 1901021 */   // Label 25613: @1901021
     /* 1901021 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1901107), // Rule ID 19311 //
     /* 1901026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1901046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901072 */     // MIs[0] policy
     /* 1901072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901082 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1901085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901106 */     // GIR_Coverage, 19311,
     /* 1901106 */     GIR_EraseRootFromParent_Done,
     /* 1901107 */   // Label 25614: @1901107
     /* 1901107 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1901193), // Rule ID 19314 //
     /* 1901112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901158 */     // MIs[0] policy
     /* 1901158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901168 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1901171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901192 */     // GIR_Coverage, 19314,
     /* 1901192 */     GIR_EraseRootFromParent_Done,
     /* 1901193 */   // Label 25615: @1901193
     /* 1901193 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1901279), // Rule ID 19315 //
     /* 1901198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1901218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901244 */     // MIs[0] policy
     /* 1901244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1901257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901278 */     // GIR_Coverage, 19315,
     /* 1901278 */     GIR_EraseRootFromParent_Done,
     /* 1901279 */   // Label 25616: @1901279
     /* 1901279 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1901365), // Rule ID 19318 //
     /* 1901284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1901287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1901304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901330 */     // MIs[0] policy
     /* 1901330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901340 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1901343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901364 */     // GIR_Coverage, 19318,
     /* 1901364 */     GIR_EraseRootFromParent_Done,
     /* 1901365 */   // Label 25617: @1901365
     /* 1901365 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1901451), // Rule ID 19319 //
     /* 1901370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1901373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1901390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901416 */     // MIs[0] policy
     /* 1901416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901426 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1901429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901450 */     // GIR_Coverage, 19319,
     /* 1901450 */     GIR_EraseRootFromParent_Done,
     /* 1901451 */   // Label 25618: @1901451
     /* 1901451 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1901537), // Rule ID 19322 //
     /* 1901456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901502 */     // MIs[0] policy
     /* 1901502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901512 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901536 */     // GIR_Coverage, 19322,
     /* 1901536 */     GIR_EraseRootFromParent_Done,
     /* 1901537 */   // Label 25619: @1901537
     /* 1901537 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1901623), // Rule ID 19323 //
     /* 1901542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901588 */     // MIs[0] policy
     /* 1901588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901598 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901622 */     // GIR_Coverage, 19323,
     /* 1901622 */     GIR_EraseRootFromParent_Done,
     /* 1901623 */   // Label 25620: @1901623
     /* 1901623 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1901709), // Rule ID 19326 //
     /* 1901628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901674 */     // MIs[0] policy
     /* 1901674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901708 */     // GIR_Coverage, 19326,
     /* 1901708 */     GIR_EraseRootFromParent_Done,
     /* 1901709 */   // Label 25621: @1901709
     /* 1901709 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1901795), // Rule ID 19327 //
     /* 1901714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901760 */     // MIs[0] policy
     /* 1901760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901770 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901794 */     // GIR_Coverage, 19327,
     /* 1901794 */     GIR_EraseRootFromParent_Done,
     /* 1901795 */   // Label 25622: @1901795
     /* 1901795 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1901881), // Rule ID 19330 //
     /* 1901800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901846 */     // MIs[0] policy
     /* 1901846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901856 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901880 */     // GIR_Coverage, 19330,
     /* 1901880 */     GIR_EraseRootFromParent_Done,
     /* 1901881 */   // Label 25623: @1901881
     /* 1901881 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1901967), // Rule ID 19331 //
     /* 1901886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901932 */     // MIs[0] policy
     /* 1901932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901966 */     // GIR_Coverage, 19331,
     /* 1901966 */     GIR_EraseRootFromParent_Done,
     /* 1901967 */   // Label 25624: @1901967
     /* 1901967 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1902053), // Rule ID 19334 //
     /* 1901972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1901992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902018 */     // MIs[0] policy
     /* 1902018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1902031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902052 */     // GIR_Coverage, 19334,
     /* 1902052 */     GIR_EraseRootFromParent_Done,
     /* 1902053 */   // Label 25625: @1902053
     /* 1902053 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1902139), // Rule ID 19335 //
     /* 1902058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1902078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902104 */     // MIs[0] policy
     /* 1902104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902114 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1902117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902138 */     // GIR_Coverage, 19335,
     /* 1902138 */     GIR_EraseRootFromParent_Done,
     /* 1902139 */   // Label 25626: @1902139
     /* 1902139 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1902225), // Rule ID 19338 //
     /* 1902144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1902164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902190 */     // MIs[0] policy
     /* 1902190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902200 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1902203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902224 */     // GIR_Coverage, 19338,
     /* 1902224 */     GIR_EraseRootFromParent_Done,
     /* 1902225 */   // Label 25627: @1902225
     /* 1902225 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1902311), // Rule ID 19339 //
     /* 1902230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1902250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902276 */     // MIs[0] policy
     /* 1902276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902286 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1902289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902310 */     // GIR_Coverage, 19339,
     /* 1902310 */     GIR_EraseRootFromParent_Done,
     /* 1902311 */   // Label 25628: @1902311
     /* 1902311 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1902397), // Rule ID 19342 //
     /* 1902316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1902336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902362 */     // MIs[0] policy
     /* 1902362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902372 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1902375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902396 */     // GIR_Coverage, 19342,
     /* 1902396 */     GIR_EraseRootFromParent_Done,
     /* 1902397 */   // Label 25629: @1902397
     /* 1902397 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1902483), // Rule ID 19343 //
     /* 1902402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1902422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902448 */     // MIs[0] policy
     /* 1902448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1902461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902482 */     // GIR_Coverage, 19343,
     /* 1902482 */     GIR_EraseRootFromParent_Done,
     /* 1902483 */   // Label 25630: @1902483
     /* 1902483 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1902569), // Rule ID 19346 //
     /* 1902488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902534 */     // MIs[0] policy
     /* 1902534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902544 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902568 */     // GIR_Coverage, 19346,
     /* 1902568 */     GIR_EraseRootFromParent_Done,
     /* 1902569 */   // Label 25631: @1902569
     /* 1902569 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1902655), // Rule ID 19347 //
     /* 1902574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902620 */     // MIs[0] policy
     /* 1902620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902654 */     // GIR_Coverage, 19347,
     /* 1902654 */     GIR_EraseRootFromParent_Done,
     /* 1902655 */   // Label 25632: @1902655
     /* 1902655 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1902741), // Rule ID 19350 //
     /* 1902660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902706 */     // MIs[0] policy
     /* 1902706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902716 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902740 */     // GIR_Coverage, 19350,
     /* 1902740 */     GIR_EraseRootFromParent_Done,
     /* 1902741 */   // Label 25633: @1902741
     /* 1902741 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1902827), // Rule ID 19351 //
     /* 1902746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902792 */     // MIs[0] policy
     /* 1902792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902802 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902826 */     // GIR_Coverage, 19351,
     /* 1902826 */     GIR_EraseRootFromParent_Done,
     /* 1902827 */   // Label 25634: @1902827
     /* 1902827 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1902913), // Rule ID 19354 //
     /* 1902832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902878 */     // MIs[0] policy
     /* 1902878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902888 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902912 */     // GIR_Coverage, 19354,
     /* 1902912 */     GIR_EraseRootFromParent_Done,
     /* 1902913 */   // Label 25635: @1902913
     /* 1902913 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1902999), // Rule ID 19355 //
     /* 1902918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902964 */     // MIs[0] policy
     /* 1902964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902974 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902998 */     // GIR_Coverage, 19355,
     /* 1902998 */     GIR_EraseRootFromParent_Done,
     /* 1902999 */   // Label 25636: @1902999
     /* 1902999 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1903085), // Rule ID 19358 //
     /* 1903004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903050 */     // MIs[0] policy
     /* 1903050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903060 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1903063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903084 */     // GIR_Coverage, 19358,
     /* 1903084 */     GIR_EraseRootFromParent_Done,
     /* 1903085 */   // Label 25637: @1903085
     /* 1903085 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1903171), // Rule ID 19359 //
     /* 1903090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903136 */     // MIs[0] policy
     /* 1903136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903146 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1903149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903170 */     // GIR_Coverage, 19359,
     /* 1903170 */     GIR_EraseRootFromParent_Done,
     /* 1903171 */   // Label 25638: @1903171
     /* 1903171 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1903257), // Rule ID 19362 //
     /* 1903176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903222 */     // MIs[0] policy
     /* 1903222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903232 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1903235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903256 */     // GIR_Coverage, 19362,
     /* 1903256 */     GIR_EraseRootFromParent_Done,
     /* 1903257 */   // Label 25639: @1903257
     /* 1903257 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1903343), // Rule ID 19363 //
     /* 1903262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903308 */     // MIs[0] policy
     /* 1903308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903318 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1903321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903342 */     // GIR_Coverage, 19363,
     /* 1903342 */     GIR_EraseRootFromParent_Done,
     /* 1903343 */   // Label 25640: @1903343
     /* 1903343 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1903429), // Rule ID 19366 //
     /* 1903348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903394 */     // MIs[0] policy
     /* 1903394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903404 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903428 */     // GIR_Coverage, 19366,
     /* 1903428 */     GIR_EraseRootFromParent_Done,
     /* 1903429 */   // Label 25641: @1903429
     /* 1903429 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1903515), // Rule ID 19367 //
     /* 1903434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903480 */     // MIs[0] policy
     /* 1903480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903514 */     // GIR_Coverage, 19367,
     /* 1903514 */     GIR_EraseRootFromParent_Done,
     /* 1903515 */   // Label 25642: @1903515
     /* 1903515 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1903601), // Rule ID 19370 //
     /* 1903520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903566 */     // MIs[0] policy
     /* 1903566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903576 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903600 */     // GIR_Coverage, 19370,
     /* 1903600 */     GIR_EraseRootFromParent_Done,
     /* 1903601 */   // Label 25643: @1903601
     /* 1903601 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1903687), // Rule ID 19371 //
     /* 1903606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903652 */     // MIs[0] policy
     /* 1903652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903662 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903686 */     // GIR_Coverage, 19371,
     /* 1903686 */     GIR_EraseRootFromParent_Done,
     /* 1903687 */   // Label 25644: @1903687
     /* 1903687 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1903773), // Rule ID 19374 //
     /* 1903692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903738 */     // MIs[0] policy
     /* 1903738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903748 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903772 */     // GIR_Coverage, 19374,
     /* 1903772 */     GIR_EraseRootFromParent_Done,
     /* 1903773 */   // Label 25645: @1903773
     /* 1903773 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1903859), // Rule ID 19375 //
     /* 1903778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903824 */     // MIs[0] policy
     /* 1903824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903834 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903858 */     // GIR_Coverage, 19375,
     /* 1903858 */     GIR_EraseRootFromParent_Done,
     /* 1903859 */   // Label 25646: @1903859
     /* 1903859 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1903945), // Rule ID 19378 //
     /* 1903864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903910 */     // MIs[0] policy
     /* 1903910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903920 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903944 */     // GIR_Coverage, 19378,
     /* 1903944 */     GIR_EraseRootFromParent_Done,
     /* 1903945 */   // Label 25647: @1903945
     /* 1903945 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1904031), // Rule ID 19379 //
     /* 1903950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903996 */     // MIs[0] policy
     /* 1903996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904006 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1904009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904030 */     // GIR_Coverage, 19379,
     /* 1904030 */     GIR_EraseRootFromParent_Done,
     /* 1904031 */   // Label 25648: @1904031
     /* 1904031 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1904117), // Rule ID 19382 //
     /* 1904036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904082 */     // MIs[0] policy
     /* 1904082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904092 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1904095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904116 */     // GIR_Coverage, 19382,
     /* 1904116 */     GIR_EraseRootFromParent_Done,
     /* 1904117 */   // Label 25649: @1904117
     /* 1904117 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1904203), // Rule ID 19383 //
     /* 1904122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904168 */     // MIs[0] policy
     /* 1904168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904178 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1904181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904202 */     // GIR_Coverage, 19383,
     /* 1904202 */     GIR_EraseRootFromParent_Done,
     /* 1904203 */   // Label 25650: @1904203
     /* 1904203 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1904289), // Rule ID 19386 //
     /* 1904208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904254 */     // MIs[0] policy
     /* 1904254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904264 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1904267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904288 */     // GIR_Coverage, 19386,
     /* 1904288 */     GIR_EraseRootFromParent_Done,
     /* 1904289 */   // Label 25651: @1904289
     /* 1904289 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1904375), // Rule ID 19387 //
     /* 1904294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904340 */     // MIs[0] policy
     /* 1904340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1904353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904374 */     // GIR_Coverage, 19387,
     /* 1904374 */     GIR_EraseRootFromParent_Done,
     /* 1904375 */   // Label 25652: @1904375
     /* 1904375 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1904461), // Rule ID 19390 //
     /* 1904380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904426 */     // MIs[0] policy
     /* 1904426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904436 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904460 */     // GIR_Coverage, 19390,
     /* 1904460 */     GIR_EraseRootFromParent_Done,
     /* 1904461 */   // Label 25653: @1904461
     /* 1904461 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1904547), // Rule ID 19391 //
     /* 1904466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904512 */     // MIs[0] policy
     /* 1904512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904522 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904546 */     // GIR_Coverage, 19391,
     /* 1904546 */     GIR_EraseRootFromParent_Done,
     /* 1904547 */   // Label 25654: @1904547
     /* 1904547 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1904633), // Rule ID 19394 //
     /* 1904552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904598 */     // MIs[0] policy
     /* 1904598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904632 */     // GIR_Coverage, 19394,
     /* 1904632 */     GIR_EraseRootFromParent_Done,
     /* 1904633 */   // Label 25655: @1904633
     /* 1904633 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1904719), // Rule ID 19395 //
     /* 1904638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904684 */     // MIs[0] policy
     /* 1904684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904694 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904718 */     // GIR_Coverage, 19395,
     /* 1904718 */     GIR_EraseRootFromParent_Done,
     /* 1904719 */   // Label 25656: @1904719
     /* 1904719 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1904805), // Rule ID 19398 //
     /* 1904724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904770 */     // MIs[0] policy
     /* 1904770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904780 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904804 */     // GIR_Coverage, 19398,
     /* 1904804 */     GIR_EraseRootFromParent_Done,
     /* 1904805 */   // Label 25657: @1904805
     /* 1904805 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1904891), // Rule ID 19399 //
     /* 1904810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904856 */     // MIs[0] policy
     /* 1904856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904866 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904890 */     // GIR_Coverage, 19399,
     /* 1904890 */     GIR_EraseRootFromParent_Done,
     /* 1904891 */   // Label 25658: @1904891
     /* 1904891 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1904977), // Rule ID 19402 //
     /* 1904896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904942 */     // MIs[0] policy
     /* 1904942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904952 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904976 */     // GIR_Coverage, 19402,
     /* 1904976 */     GIR_EraseRootFromParent_Done,
     /* 1904977 */   // Label 25659: @1904977
     /* 1904977 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1905063), // Rule ID 19403 //
     /* 1904982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1905002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1905024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905028 */     // MIs[0] policy
     /* 1905028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905038 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1905041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905062 */     // GIR_Coverage, 19403,
     /* 1905062 */     GIR_EraseRootFromParent_Done,
     /* 1905063 */   // Label 25660: @1905063
     /* 1905063 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1905149), // Rule ID 19406 //
     /* 1905068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905114 */     // MIs[0] policy
     /* 1905114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1905127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905148 */     // GIR_Coverage, 19406,
     /* 1905148 */     GIR_EraseRootFromParent_Done,
     /* 1905149 */   // Label 25661: @1905149
     /* 1905149 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1905235), // Rule ID 19407 //
     /* 1905154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905200 */     // MIs[0] policy
     /* 1905200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905210 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1905213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905234 */     // GIR_Coverage, 19407,
     /* 1905234 */     GIR_EraseRootFromParent_Done,
     /* 1905235 */   // Label 25662: @1905235
     /* 1905235 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1905321), // Rule ID 19410 //
     /* 1905240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905286 */     // MIs[0] policy
     /* 1905286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905296 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1905299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905320 */     // GIR_Coverage, 19410,
     /* 1905320 */     GIR_EraseRootFromParent_Done,
     /* 1905321 */   // Label 25663: @1905321
     /* 1905321 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1905407), // Rule ID 19411 //
     /* 1905326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905372 */     // MIs[0] policy
     /* 1905372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905382 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1905385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905406 */     // GIR_Coverage, 19411,
     /* 1905406 */     GIR_EraseRootFromParent_Done,
     /* 1905407 */   // Label 25664: @1905407
     /* 1905407 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1905493), // Rule ID 19414 //
     /* 1905412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905458 */     // MIs[0] policy
     /* 1905458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905468 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905492 */     // GIR_Coverage, 19414,
     /* 1905492 */     GIR_EraseRootFromParent_Done,
     /* 1905493 */   // Label 25665: @1905493
     /* 1905493 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1905579), // Rule ID 19415 //
     /* 1905498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905544 */     // MIs[0] policy
     /* 1905544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905554 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905578 */     // GIR_Coverage, 19415,
     /* 1905578 */     GIR_EraseRootFromParent_Done,
     /* 1905579 */   // Label 25666: @1905579
     /* 1905579 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1905665), // Rule ID 19418 //
     /* 1905584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905630 */     // MIs[0] policy
     /* 1905630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905640 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905664 */     // GIR_Coverage, 19418,
     /* 1905664 */     GIR_EraseRootFromParent_Done,
     /* 1905665 */   // Label 25667: @1905665
     /* 1905665 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1905751), // Rule ID 19419 //
     /* 1905670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905716 */     // MIs[0] policy
     /* 1905716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905726 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905750 */     // GIR_Coverage, 19419,
     /* 1905750 */     GIR_EraseRootFromParent_Done,
     /* 1905751 */   // Label 25668: @1905751
     /* 1905751 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1905837), // Rule ID 19422 //
     /* 1905756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905802 */     // MIs[0] policy
     /* 1905802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905812 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905836 */     // GIR_Coverage, 19422,
     /* 1905836 */     GIR_EraseRootFromParent_Done,
     /* 1905837 */   // Label 25669: @1905837
     /* 1905837 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1905923), // Rule ID 19423 //
     /* 1905842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905888 */     // MIs[0] policy
     /* 1905888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905898 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905922 */     // GIR_Coverage, 19423,
     /* 1905922 */     GIR_EraseRootFromParent_Done,
     /* 1905923 */   // Label 25670: @1905923
     /* 1905923 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1906009), // Rule ID 19426 //
     /* 1905928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905974 */     // MIs[0] policy
     /* 1905974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905984 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906008 */     // GIR_Coverage, 19426,
     /* 1906008 */     GIR_EraseRootFromParent_Done,
     /* 1906009 */   // Label 25671: @1906009
     /* 1906009 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1906095), // Rule ID 19427 //
     /* 1906014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1906034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906060 */     // MIs[0] policy
     /* 1906060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906070 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1906073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906094 */     // GIR_Coverage, 19427,
     /* 1906094 */     GIR_EraseRootFromParent_Done,
     /* 1906095 */   // Label 25672: @1906095
     /* 1906095 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1906181), // Rule ID 19430 //
     /* 1906100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1906120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906146 */     // MIs[0] policy
     /* 1906146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1906159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906180 */     // GIR_Coverage, 19430,
     /* 1906180 */     GIR_EraseRootFromParent_Done,
     /* 1906181 */   // Label 25673: @1906181
     /* 1906181 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1906267), // Rule ID 19431 //
     /* 1906186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1906206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906232 */     // MIs[0] policy
     /* 1906232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1906245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906266 */     // GIR_Coverage, 19431,
     /* 1906266 */     GIR_EraseRootFromParent_Done,
     /* 1906267 */   // Label 25674: @1906267
     /* 1906267 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1906353), // Rule ID 19434 //
     /* 1906272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906318 */     // MIs[0] policy
     /* 1906318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906328 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1906331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906352 */     // GIR_Coverage, 19434,
     /* 1906352 */     GIR_EraseRootFromParent_Done,
     /* 1906353 */   // Label 25675: @1906353
     /* 1906353 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1906439), // Rule ID 19435 //
     /* 1906358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1906378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906404 */     // MIs[0] policy
     /* 1906404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1906417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906438 */     // GIR_Coverage, 19435,
     /* 1906438 */     GIR_EraseRootFromParent_Done,
     /* 1906439 */   // Label 25676: @1906439
     /* 1906439 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1906525), // Rule ID 19438 //
     /* 1906444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906490 */     // MIs[0] policy
     /* 1906490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906524 */     // GIR_Coverage, 19438,
     /* 1906524 */     GIR_EraseRootFromParent_Done,
     /* 1906525 */   // Label 25677: @1906525
     /* 1906525 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1906611), // Rule ID 19439 //
     /* 1906530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906576 */     // MIs[0] policy
     /* 1906576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906586 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906610 */     // GIR_Coverage, 19439,
     /* 1906610 */     GIR_EraseRootFromParent_Done,
     /* 1906611 */   // Label 25678: @1906611
     /* 1906611 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1906697), // Rule ID 19442 //
     /* 1906616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906662 */     // MIs[0] policy
     /* 1906662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906672 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906696 */     // GIR_Coverage, 19442,
     /* 1906696 */     GIR_EraseRootFromParent_Done,
     /* 1906697 */   // Label 25679: @1906697
     /* 1906697 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1906783), // Rule ID 19443 //
     /* 1906702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906748 */     // MIs[0] policy
     /* 1906748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906758 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906782 */     // GIR_Coverage, 19443,
     /* 1906782 */     GIR_EraseRootFromParent_Done,
     /* 1906783 */   // Label 25680: @1906783
     /* 1906783 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1906869), // Rule ID 19446 //
     /* 1906788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906834 */     // MIs[0] policy
     /* 1906834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906844 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906868 */     // GIR_Coverage, 19446,
     /* 1906868 */     GIR_EraseRootFromParent_Done,
     /* 1906869 */   // Label 25681: @1906869
     /* 1906869 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1906955), // Rule ID 19447 //
     /* 1906874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906920 */     // MIs[0] policy
     /* 1906920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906930 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906954 */     // GIR_Coverage, 19447,
     /* 1906954 */     GIR_EraseRootFromParent_Done,
     /* 1906955 */   // Label 25682: @1906955
     /* 1906955 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1907041), // Rule ID 19450 //
     /* 1906960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907006 */     // MIs[0] policy
     /* 1907006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907016 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1907019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907040 */     // GIR_Coverage, 19450,
     /* 1907040 */     GIR_EraseRootFromParent_Done,
     /* 1907041 */   // Label 25683: @1907041
     /* 1907041 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1907127), // Rule ID 19451 //
     /* 1907046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1907066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907092 */     // MIs[0] policy
     /* 1907092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1907105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907126 */     // GIR_Coverage, 19451,
     /* 1907126 */     GIR_EraseRootFromParent_Done,
     /* 1907127 */   // Label 25684: @1907127
     /* 1907127 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1907213), // Rule ID 19454 //
     /* 1907132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1907152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907178 */     // MIs[0] policy
     /* 1907178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907188 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1907191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907212 */     // GIR_Coverage, 19454,
     /* 1907212 */     GIR_EraseRootFromParent_Done,
     /* 1907213 */   // Label 25685: @1907213
     /* 1907213 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1907299), // Rule ID 19455 //
     /* 1907218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1907238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907264 */     // MIs[0] policy
     /* 1907264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907274 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1907277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907298 */     // GIR_Coverage, 19455,
     /* 1907298 */     GIR_EraseRootFromParent_Done,
     /* 1907299 */   // Label 25686: @1907299
     /* 1907299 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1907385), // Rule ID 19458 //
     /* 1907304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1907324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907350 */     // MIs[0] policy
     /* 1907350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907360 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1907363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907384 */     // GIR_Coverage, 19458,
     /* 1907384 */     GIR_EraseRootFromParent_Done,
     /* 1907385 */   // Label 25687: @1907385
     /* 1907385 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1907471), // Rule ID 19459 //
     /* 1907390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1907410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907436 */     // MIs[0] policy
     /* 1907436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907446 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1907449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907470 */     // GIR_Coverage, 19459,
     /* 1907470 */     GIR_EraseRootFromParent_Done,
     /* 1907471 */   // Label 25688: @1907471
     /* 1907471 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1907557), // Rule ID 19462 //
     /* 1907476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907522 */     // MIs[0] policy
     /* 1907522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907532 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907556 */     // GIR_Coverage, 19462,
     /* 1907556 */     GIR_EraseRootFromParent_Done,
     /* 1907557 */   // Label 25689: @1907557
     /* 1907557 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1907643), // Rule ID 19463 //
     /* 1907562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907608 */     // MIs[0] policy
     /* 1907608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907618 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907642 */     // GIR_Coverage, 19463,
     /* 1907642 */     GIR_EraseRootFromParent_Done,
     /* 1907643 */   // Label 25690: @1907643
     /* 1907643 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1907729), // Rule ID 19466 //
     /* 1907648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907694 */     // MIs[0] policy
     /* 1907694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907728 */     // GIR_Coverage, 19466,
     /* 1907728 */     GIR_EraseRootFromParent_Done,
     /* 1907729 */   // Label 25691: @1907729
     /* 1907729 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1907815), // Rule ID 19467 //
     /* 1907734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907780 */     // MIs[0] policy
     /* 1907780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907814 */     // GIR_Coverage, 19467,
     /* 1907814 */     GIR_EraseRootFromParent_Done,
     /* 1907815 */   // Label 25692: @1907815
     /* 1907815 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1907901), // Rule ID 19470 //
     /* 1907820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907866 */     // MIs[0] policy
     /* 1907866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907900 */     // GIR_Coverage, 19470,
     /* 1907900 */     GIR_EraseRootFromParent_Done,
     /* 1907901 */   // Label 25693: @1907901
     /* 1907901 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1907987), // Rule ID 19471 //
     /* 1907906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907952 */     // MIs[0] policy
     /* 1907952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907962 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907986 */     // GIR_Coverage, 19471,
     /* 1907986 */     GIR_EraseRootFromParent_Done,
     /* 1907987 */   // Label 25694: @1907987
     /* 1907987 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1908073), // Rule ID 19474 //
     /* 1907992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1908012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908038 */     // MIs[0] policy
     /* 1908038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908048 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1908051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908072 */     // GIR_Coverage, 19474,
     /* 1908072 */     GIR_EraseRootFromParent_Done,
     /* 1908073 */   // Label 25695: @1908073
     /* 1908073 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1908159), // Rule ID 19475 //
     /* 1908078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1908098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908124 */     // MIs[0] policy
     /* 1908124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908134 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1908137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908158 */     // GIR_Coverage, 19475,
     /* 1908158 */     GIR_EraseRootFromParent_Done,
     /* 1908159 */   // Label 25696: @1908159
     /* 1908159 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1908245), // Rule ID 19478 //
     /* 1908164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908210 */     // MIs[0] policy
     /* 1908210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908220 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1908223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908244 */     // GIR_Coverage, 19478,
     /* 1908244 */     GIR_EraseRootFromParent_Done,
     /* 1908245 */   // Label 25697: @1908245
     /* 1908245 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1908331), // Rule ID 19479 //
     /* 1908250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908296 */     // MIs[0] policy
     /* 1908296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908306 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1908309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908330 */     // GIR_Coverage, 19479,
     /* 1908330 */     GIR_EraseRootFromParent_Done,
     /* 1908331 */   // Label 25698: @1908331
     /* 1908331 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1908417), // Rule ID 19482 //
     /* 1908336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908382 */     // MIs[0] policy
     /* 1908382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908392 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908416 */     // GIR_Coverage, 19482,
     /* 1908416 */     GIR_EraseRootFromParent_Done,
     /* 1908417 */   // Label 25699: @1908417
     /* 1908417 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1908503), // Rule ID 19483 //
     /* 1908422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908468 */     // MIs[0] policy
     /* 1908468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908478 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908502 */     // GIR_Coverage, 19483,
     /* 1908502 */     GIR_EraseRootFromParent_Done,
     /* 1908503 */   // Label 25700: @1908503
     /* 1908503 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1908589), // Rule ID 19486 //
     /* 1908508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908554 */     // MIs[0] policy
     /* 1908554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908588 */     // GIR_Coverage, 19486,
     /* 1908588 */     GIR_EraseRootFromParent_Done,
     /* 1908589 */   // Label 25701: @1908589
     /* 1908589 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1908675), // Rule ID 19487 //
     /* 1908594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908640 */     // MIs[0] policy
     /* 1908640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908650 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908674 */     // GIR_Coverage, 19487,
     /* 1908674 */     GIR_EraseRootFromParent_Done,
     /* 1908675 */   // Label 25702: @1908675
     /* 1908675 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1908761), // Rule ID 19490 //
     /* 1908680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908726 */     // MIs[0] policy
     /* 1908726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908736 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908760 */     // GIR_Coverage, 19490,
     /* 1908760 */     GIR_EraseRootFromParent_Done,
     /* 1908761 */   // Label 25703: @1908761
     /* 1908761 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1908847), // Rule ID 19491 //
     /* 1908766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908812 */     // MIs[0] policy
     /* 1908812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908822 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908846 */     // GIR_Coverage, 19491,
     /* 1908846 */     GIR_EraseRootFromParent_Done,
     /* 1908847 */   // Label 25704: @1908847
     /* 1908847 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1908933), // Rule ID 19494 //
     /* 1908852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908898 */     // MIs[0] policy
     /* 1908898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908932 */     // GIR_Coverage, 19494,
     /* 1908932 */     GIR_EraseRootFromParent_Done,
     /* 1908933 */   // Label 25705: @1908933
     /* 1908933 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1909019), // Rule ID 19495 //
     /* 1908938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908984 */     // MIs[0] policy
     /* 1908984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908994 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909018 */     // GIR_Coverage, 19495,
     /* 1909018 */     GIR_EraseRootFromParent_Done,
     /* 1909019 */   // Label 25706: @1909019
     /* 1909019 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1909105), // Rule ID 19498 //
     /* 1909024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909070 */     // MIs[0] policy
     /* 1909070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909080 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1909083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909104 */     // GIR_Coverage, 19498,
     /* 1909104 */     GIR_EraseRootFromParent_Done,
     /* 1909105 */   // Label 25707: @1909105
     /* 1909105 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1909191), // Rule ID 19499 //
     /* 1909110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909156 */     // MIs[0] policy
     /* 1909156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909166 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1909169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909190 */     // GIR_Coverage, 19499,
     /* 1909190 */     GIR_EraseRootFromParent_Done,
     /* 1909191 */   // Label 25708: @1909191
     /* 1909191 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1909277), // Rule ID 19502 //
     /* 1909196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909242 */     // MIs[0] policy
     /* 1909242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909252 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1909255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909276 */     // GIR_Coverage, 19502,
     /* 1909276 */     GIR_EraseRootFromParent_Done,
     /* 1909277 */   // Label 25709: @1909277
     /* 1909277 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1909363), // Rule ID 19503 //
     /* 1909282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909328 */     // MIs[0] policy
     /* 1909328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1909341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909362 */     // GIR_Coverage, 19503,
     /* 1909362 */     GIR_EraseRootFromParent_Done,
     /* 1909363 */   // Label 25710: @1909363
     /* 1909363 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1909449), // Rule ID 19506 //
     /* 1909368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909414 */     // MIs[0] policy
     /* 1909414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909424 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909448 */     // GIR_Coverage, 19506,
     /* 1909448 */     GIR_EraseRootFromParent_Done,
     /* 1909449 */   // Label 25711: @1909449
     /* 1909449 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1909535), // Rule ID 19507 //
     /* 1909454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909500 */     // MIs[0] policy
     /* 1909500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909510 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909534 */     // GIR_Coverage, 19507,
     /* 1909534 */     GIR_EraseRootFromParent_Done,
     /* 1909535 */   // Label 25712: @1909535
     /* 1909535 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1909621), // Rule ID 19510 //
     /* 1909540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909586 */     // MIs[0] policy
     /* 1909586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909596 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909620 */     // GIR_Coverage, 19510,
     /* 1909620 */     GIR_EraseRootFromParent_Done,
     /* 1909621 */   // Label 25713: @1909621
     /* 1909621 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1909707), // Rule ID 19511 //
     /* 1909626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909672 */     // MIs[0] policy
     /* 1909672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909682 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909706 */     // GIR_Coverage, 19511,
     /* 1909706 */     GIR_EraseRootFromParent_Done,
     /* 1909707 */   // Label 25714: @1909707
     /* 1909707 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1909793), // Rule ID 19514 //
     /* 1909712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909758 */     // MIs[0] policy
     /* 1909758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909792 */     // GIR_Coverage, 19514,
     /* 1909792 */     GIR_EraseRootFromParent_Done,
     /* 1909793 */   // Label 25715: @1909793
     /* 1909793 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1909879), // Rule ID 19515 //
     /* 1909798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909844 */     // MIs[0] policy
     /* 1909844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909878 */     // GIR_Coverage, 19515,
     /* 1909878 */     GIR_EraseRootFromParent_Done,
     /* 1909879 */   // Label 25716: @1909879
     /* 1909879 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1909965), // Rule ID 19518 //
     /* 1909884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909930 */     // MIs[0] policy
     /* 1909930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909940 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909964 */     // GIR_Coverage, 19518,
     /* 1909964 */     GIR_EraseRootFromParent_Done,
     /* 1909965 */   // Label 25717: @1909965
     /* 1909965 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1910051), // Rule ID 19519 //
     /* 1909970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910016 */     // MIs[0] policy
     /* 1910016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910026 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1910029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910050 */     // GIR_Coverage, 19519,
     /* 1910050 */     GIR_EraseRootFromParent_Done,
     /* 1910051 */   // Label 25718: @1910051
     /* 1910051 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1910137), // Rule ID 19522 //
     /* 1910056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910102 */     // MIs[0] policy
     /* 1910102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910112 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1910115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910136 */     // GIR_Coverage, 19522,
     /* 1910136 */     GIR_EraseRootFromParent_Done,
     /* 1910137 */   // Label 25719: @1910137
     /* 1910137 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1910223), // Rule ID 19523 //
     /* 1910142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1910184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910188 */     // MIs[0] policy
     /* 1910188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910198 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1910201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910222 */     // GIR_Coverage, 19523,
     /* 1910222 */     GIR_EraseRootFromParent_Done,
     /* 1910223 */   // Label 25720: @1910223
     /* 1910223 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1910309), // Rule ID 19526 //
     /* 1910228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910274 */     // MIs[0] policy
     /* 1910274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1910287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910308 */     // GIR_Coverage, 19526,
     /* 1910308 */     GIR_EraseRootFromParent_Done,
     /* 1910309 */   // Label 25721: @1910309
     /* 1910309 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1910395), // Rule ID 19527 //
     /* 1910314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910360 */     // MIs[0] policy
     /* 1910360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1910373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910394 */     // GIR_Coverage, 19527,
     /* 1910394 */     GIR_EraseRootFromParent_Done,
     /* 1910395 */   // Label 25722: @1910395
     /* 1910395 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1910481), // Rule ID 19530 //
     /* 1910400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910446 */     // MIs[0] policy
     /* 1910446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910456 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910480 */     // GIR_Coverage, 19530,
     /* 1910480 */     GIR_EraseRootFromParent_Done,
     /* 1910481 */   // Label 25723: @1910481
     /* 1910481 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1910567), // Rule ID 19531 //
     /* 1910486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910532 */     // MIs[0] policy
     /* 1910532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910542 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910566 */     // GIR_Coverage, 19531,
     /* 1910566 */     GIR_EraseRootFromParent_Done,
     /* 1910567 */   // Label 25724: @1910567
     /* 1910567 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1910653), // Rule ID 19534 //
     /* 1910572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910618 */     // MIs[0] policy
     /* 1910618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910628 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910652 */     // GIR_Coverage, 19534,
     /* 1910652 */     GIR_EraseRootFromParent_Done,
     /* 1910653 */   // Label 25725: @1910653
     /* 1910653 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1910739), // Rule ID 19535 //
     /* 1910658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910704 */     // MIs[0] policy
     /* 1910704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910714 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910738 */     // GIR_Coverage, 19535,
     /* 1910738 */     GIR_EraseRootFromParent_Done,
     /* 1910739 */   // Label 25726: @1910739
     /* 1910739 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1910825), // Rule ID 19538 //
     /* 1910744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910790 */     // MIs[0] policy
     /* 1910790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910824 */     // GIR_Coverage, 19538,
     /* 1910824 */     GIR_EraseRootFromParent_Done,
     /* 1910825 */   // Label 25727: @1910825
     /* 1910825 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1910911), // Rule ID 19539 //
     /* 1910830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910876 */     // MIs[0] policy
     /* 1910876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910886 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910910 */     // GIR_Coverage, 19539,
     /* 1910910 */     GIR_EraseRootFromParent_Done,
     /* 1910911 */   // Label 25728: @1910911
     /* 1910911 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1910997), // Rule ID 19542 //
     /* 1910916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910962 */     // MIs[0] policy
     /* 1910962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910996 */     // GIR_Coverage, 19542,
     /* 1910996 */     GIR_EraseRootFromParent_Done,
     /* 1910997 */   // Label 25729: @1910997
     /* 1910997 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1911083), // Rule ID 19543 //
     /* 1911002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1911022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911048 */     // MIs[0] policy
     /* 1911048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911058 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1911061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911082 */     // GIR_Coverage, 19543,
     /* 1911082 */     GIR_EraseRootFromParent_Done,
     /* 1911083 */   // Label 25730: @1911083
     /* 1911083 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1911169), // Rule ID 19546 //
     /* 1911088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1911108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911134 */     // MIs[0] policy
     /* 1911134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911144 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1911147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911168 */     // GIR_Coverage, 19546,
     /* 1911168 */     GIR_EraseRootFromParent_Done,
     /* 1911169 */   // Label 25731: @1911169
     /* 1911169 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1911255), // Rule ID 19547 //
     /* 1911174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1911194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911220 */     // MIs[0] policy
     /* 1911220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1911233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911254 */     // GIR_Coverage, 19547,
     /* 1911254 */     GIR_EraseRootFromParent_Done,
     /* 1911255 */   // Label 25732: @1911255
     /* 1911255 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1911341), // Rule ID 19550 //
     /* 1911260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1911280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911306 */     // MIs[0] policy
     /* 1911306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911316 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1911319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911340 */     // GIR_Coverage, 19550,
     /* 1911340 */     GIR_EraseRootFromParent_Done,
     /* 1911341 */   // Label 25733: @1911341
     /* 1911341 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1911427), // Rule ID 19551 //
     /* 1911346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1911366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911392 */     // MIs[0] policy
     /* 1911392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911402 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1911405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911426 */     // GIR_Coverage, 19551,
     /* 1911426 */     GIR_EraseRootFromParent_Done,
     /* 1911427 */   // Label 25734: @1911427
     /* 1911427 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1911513), // Rule ID 19554 //
     /* 1911432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911478 */     // MIs[0] policy
     /* 1911478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911512 */     // GIR_Coverage, 19554,
     /* 1911512 */     GIR_EraseRootFromParent_Done,
     /* 1911513 */   // Label 25735: @1911513
     /* 1911513 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1911599), // Rule ID 19555 //
     /* 1911518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911564 */     // MIs[0] policy
     /* 1911564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911598 */     // GIR_Coverage, 19555,
     /* 1911598 */     GIR_EraseRootFromParent_Done,
     /* 1911599 */   // Label 25736: @1911599
     /* 1911599 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1911685), // Rule ID 19558 //
     /* 1911604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911650 */     // MIs[0] policy
     /* 1911650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911660 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911684 */     // GIR_Coverage, 19558,
     /* 1911684 */     GIR_EraseRootFromParent_Done,
     /* 1911685 */   // Label 25737: @1911685
     /* 1911685 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1911771), // Rule ID 19559 //
     /* 1911690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911736 */     // MIs[0] policy
     /* 1911736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911746 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911770 */     // GIR_Coverage, 19559,
     /* 1911770 */     GIR_EraseRootFromParent_Done,
     /* 1911771 */   // Label 25738: @1911771
     /* 1911771 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1911857), // Rule ID 19562 //
     /* 1911776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911822 */     // MIs[0] policy
     /* 1911822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911856 */     // GIR_Coverage, 19562,
     /* 1911856 */     GIR_EraseRootFromParent_Done,
     /* 1911857 */   // Label 25739: @1911857
     /* 1911857 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1911943), // Rule ID 19563 //
     /* 1911862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911908 */     // MIs[0] policy
     /* 1911908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911918 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911942 */     // GIR_Coverage, 19563,
     /* 1911942 */     GIR_EraseRootFromParent_Done,
     /* 1911943 */   // Label 25740: @1911943
     /* 1911943 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1912029), // Rule ID 19566 //
     /* 1911948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911994 */     // MIs[0] policy
     /* 1911994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1912007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912028 */     // GIR_Coverage, 19566,
     /* 1912028 */     GIR_EraseRootFromParent_Done,
     /* 1912029 */   // Label 25741: @1912029
     /* 1912029 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1912115), // Rule ID 19567 //
     /* 1912034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1912054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912080 */     // MIs[0] policy
     /* 1912080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1912093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912114 */     // GIR_Coverage, 19567,
     /* 1912114 */     GIR_EraseRootFromParent_Done,
     /* 1912115 */   // Label 25742: @1912115
     /* 1912115 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1912201), // Rule ID 19570 //
     /* 1912120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1912140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912166 */     // MIs[0] policy
     /* 1912166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912176 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1912179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912200 */     // GIR_Coverage, 19570,
     /* 1912200 */     GIR_EraseRootFromParent_Done,
     /* 1912201 */   // Label 25743: @1912201
     /* 1912201 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1912287), // Rule ID 19571 //
     /* 1912206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1912226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912252 */     // MIs[0] policy
     /* 1912252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912262 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1912265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912286 */     // GIR_Coverage, 19571,
     /* 1912286 */     GIR_EraseRootFromParent_Done,
     /* 1912287 */   // Label 25744: @1912287
     /* 1912287 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1912373), // Rule ID 19574 //
     /* 1912292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1912312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912338 */     // MIs[0] policy
     /* 1912338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1912351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912372 */     // GIR_Coverage, 19574,
     /* 1912372 */     GIR_EraseRootFromParent_Done,
     /* 1912373 */   // Label 25745: @1912373
     /* 1912373 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1912459), // Rule ID 19575 //
     /* 1912378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1912398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912424 */     // MIs[0] policy
     /* 1912424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1912437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912458 */     // GIR_Coverage, 19575,
     /* 1912458 */     GIR_EraseRootFromParent_Done,
     /* 1912459 */   // Label 25746: @1912459
     /* 1912459 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1912545), // Rule ID 19578 //
     /* 1912464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912510 */     // MIs[0] policy
     /* 1912510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912520 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912544 */     // GIR_Coverage, 19578,
     /* 1912544 */     GIR_EraseRootFromParent_Done,
     /* 1912545 */   // Label 25747: @1912545
     /* 1912545 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1912631), // Rule ID 19579 //
     /* 1912550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912596 */     // MIs[0] policy
     /* 1912596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912606 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912630 */     // GIR_Coverage, 19579,
     /* 1912630 */     GIR_EraseRootFromParent_Done,
     /* 1912631 */   // Label 25748: @1912631
     /* 1912631 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1912717), // Rule ID 19582 //
     /* 1912636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912682 */     // MIs[0] policy
     /* 1912682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912716 */     // GIR_Coverage, 19582,
     /* 1912716 */     GIR_EraseRootFromParent_Done,
     /* 1912717 */   // Label 25749: @1912717
     /* 1912717 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1912803), // Rule ID 19583 //
     /* 1912722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912768 */     // MIs[0] policy
     /* 1912768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912778 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912802 */     // GIR_Coverage, 19583,
     /* 1912802 */     GIR_EraseRootFromParent_Done,
     /* 1912803 */   // Label 25750: @1912803
     /* 1912803 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1912889), // Rule ID 19586 //
     /* 1912808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912854 */     // MIs[0] policy
     /* 1912854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912888 */     // GIR_Coverage, 19586,
     /* 1912888 */     GIR_EraseRootFromParent_Done,
     /* 1912889 */   // Label 25751: @1912889
     /* 1912889 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1912975), // Rule ID 19587 //
     /* 1912894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912940 */     // MIs[0] policy
     /* 1912940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912950 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912974 */     // GIR_Coverage, 19587,
     /* 1912974 */     GIR_EraseRootFromParent_Done,
     /* 1912975 */   // Label 25752: @1912975
     /* 1912975 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1913061), // Rule ID 19590 //
     /* 1912980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1913000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913026 */     // MIs[0] policy
     /* 1913026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913036 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1913039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913060 */     // GIR_Coverage, 19590,
     /* 1913060 */     GIR_EraseRootFromParent_Done,
     /* 1913061 */   // Label 25753: @1913061
     /* 1913061 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1913147), // Rule ID 19591 //
     /* 1913066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1913086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913112 */     // MIs[0] policy
     /* 1913112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913122 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1913125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913146 */     // GIR_Coverage, 19591,
     /* 1913146 */     GIR_EraseRootFromParent_Done,
     /* 1913147 */   // Label 25754: @1913147
     /* 1913147 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1913233), // Rule ID 19594 //
     /* 1913152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1913172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913198 */     // MIs[0] policy
     /* 1913198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913208 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1913211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913232 */     // GIR_Coverage, 19594,
     /* 1913232 */     GIR_EraseRootFromParent_Done,
     /* 1913233 */   // Label 25755: @1913233
     /* 1913233 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1913319), // Rule ID 19595 //
     /* 1913238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1913258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913284 */     // MIs[0] policy
     /* 1913284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1913297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913318 */     // GIR_Coverage, 19595,
     /* 1913318 */     GIR_EraseRootFromParent_Done,
     /* 1913319 */   // Label 25756: @1913319
     /* 1913319 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1913405), // Rule ID 19598 //
     /* 1913324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913370 */     // MIs[0] policy
     /* 1913370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913380 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913404 */     // GIR_Coverage, 19598,
     /* 1913404 */     GIR_EraseRootFromParent_Done,
     /* 1913405 */   // Label 25757: @1913405
     /* 1913405 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1913491), // Rule ID 19599 //
     /* 1913410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913456 */     // MIs[0] policy
     /* 1913456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913466 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913490 */     // GIR_Coverage, 19599,
     /* 1913490 */     GIR_EraseRootFromParent_Done,
     /* 1913491 */   // Label 25758: @1913491
     /* 1913491 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1913577), // Rule ID 19602 //
     /* 1913496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913542 */     // MIs[0] policy
     /* 1913542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913576 */     // GIR_Coverage, 19602,
     /* 1913576 */     GIR_EraseRootFromParent_Done,
     /* 1913577 */   // Label 25759: @1913577
     /* 1913577 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1913663), // Rule ID 19603 //
     /* 1913582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913628 */     // MIs[0] policy
     /* 1913628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913638 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913662 */     // GIR_Coverage, 19603,
     /* 1913662 */     GIR_EraseRootFromParent_Done,
     /* 1913663 */   // Label 25760: @1913663
     /* 1913663 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1913749), // Rule ID 19606 //
     /* 1913668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913714 */     // MIs[0] policy
     /* 1913714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913724 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913748 */     // GIR_Coverage, 19606,
     /* 1913748 */     GIR_EraseRootFromParent_Done,
     /* 1913749 */   // Label 25761: @1913749
     /* 1913749 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1913835), // Rule ID 19607 //
     /* 1913754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913800 */     // MIs[0] policy
     /* 1913800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913810 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913834 */     // GIR_Coverage, 19607,
     /* 1913834 */     GIR_EraseRootFromParent_Done,
     /* 1913835 */   // Label 25762: @1913835
     /* 1913835 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1913921), // Rule ID 19610 //
     /* 1913840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913886 */     // MIs[0] policy
     /* 1913886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913920 */     // GIR_Coverage, 19610,
     /* 1913920 */     GIR_EraseRootFromParent_Done,
     /* 1913921 */   // Label 25763: @1913921
     /* 1913921 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1914007), // Rule ID 19611 //
     /* 1913926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913972 */     // MIs[0] policy
     /* 1913972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914006 */     // GIR_Coverage, 19611,
     /* 1914006 */     GIR_EraseRootFromParent_Done,
     /* 1914007 */   // Label 25764: @1914007
     /* 1914007 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1914093), // Rule ID 19614 //
     /* 1914012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914058 */     // MIs[0] policy
     /* 1914058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914068 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1914071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914092 */     // GIR_Coverage, 19614,
     /* 1914092 */     GIR_EraseRootFromParent_Done,
     /* 1914093 */   // Label 25765: @1914093
     /* 1914093 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1914179), // Rule ID 19615 //
     /* 1914098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1914109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1914112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1914115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914144 */     // MIs[0] policy
     /* 1914144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1914157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914178 */     // GIR_Coverage, 19615,
     /* 1914178 */     GIR_EraseRootFromParent_Done,
     /* 1914179 */   // Label 25766: @1914179
     /* 1914179 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1914265), // Rule ID 19618 //
     /* 1914184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914230 */     // MIs[0] policy
     /* 1914230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914240 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1914243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914264 */     // GIR_Coverage, 19618,
     /* 1914264 */     GIR_EraseRootFromParent_Done,
     /* 1914265 */   // Label 25767: @1914265
     /* 1914265 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1914351), // Rule ID 19619 //
     /* 1914270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1914273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914316 */     // MIs[0] policy
     /* 1914316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914326 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1914329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914350 */     // GIR_Coverage, 19619,
     /* 1914350 */     GIR_EraseRootFromParent_Done,
     /* 1914351 */   // Label 25768: @1914351
     /* 1914351 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1914437), // Rule ID 19622 //
     /* 1914356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914402 */     // MIs[0] policy
     /* 1914402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914436 */     // GIR_Coverage, 19622,
     /* 1914436 */     GIR_EraseRootFromParent_Done,
     /* 1914437 */   // Label 25769: @1914437
     /* 1914437 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1914523), // Rule ID 19623 //
     /* 1914442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914488 */     // MIs[0] policy
     /* 1914488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914498 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914522 */     // GIR_Coverage, 19623,
     /* 1914522 */     GIR_EraseRootFromParent_Done,
     /* 1914523 */   // Label 25770: @1914523
     /* 1914523 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1914609), // Rule ID 19626 //
     /* 1914528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914574 */     // MIs[0] policy
     /* 1914574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914608 */     // GIR_Coverage, 19626,
     /* 1914608 */     GIR_EraseRootFromParent_Done,
     /* 1914609 */   // Label 25771: @1914609
     /* 1914609 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1914695), // Rule ID 19627 //
     /* 1914614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914660 */     // MIs[0] policy
     /* 1914660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914670 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914694 */     // GIR_Coverage, 19627,
     /* 1914694 */     GIR_EraseRootFromParent_Done,
     /* 1914695 */   // Label 25772: @1914695
     /* 1914695 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1914781), // Rule ID 19630 //
     /* 1914700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914746 */     // MIs[0] policy
     /* 1914746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914756 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914780 */     // GIR_Coverage, 19630,
     /* 1914780 */     GIR_EraseRootFromParent_Done,
     /* 1914781 */   // Label 25773: @1914781
     /* 1914781 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1914867), // Rule ID 19631 //
     /* 1914786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914832 */     // MIs[0] policy
     /* 1914832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914842 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914866 */     // GIR_Coverage, 19631,
     /* 1914866 */     GIR_EraseRootFromParent_Done,
     /* 1914867 */   // Label 25774: @1914867
     /* 1914867 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1914953), // Rule ID 19634 //
     /* 1914872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914918 */     // MIs[0] policy
     /* 1914918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914928 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914952 */     // GIR_Coverage, 19634,
     /* 1914952 */     GIR_EraseRootFromParent_Done,
     /* 1914953 */   // Label 25775: @1914953
     /* 1914953 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1915039), // Rule ID 19635 //
     /* 1914958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915004 */     // MIs[0] policy
     /* 1915004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1915017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915038 */     // GIR_Coverage, 19635,
     /* 1915038 */     GIR_EraseRootFromParent_Done,
     /* 1915039 */   // Label 25776: @1915039
     /* 1915039 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1915125), // Rule ID 19638 //
     /* 1915044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915090 */     // MIs[0] policy
     /* 1915090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915100 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1915103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915124 */     // GIR_Coverage, 19638,
     /* 1915124 */     GIR_EraseRootFromParent_Done,
     /* 1915125 */   // Label 25777: @1915125
     /* 1915125 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1915211), // Rule ID 19639 //
     /* 1915130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915176 */     // MIs[0] policy
     /* 1915176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915186 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1915189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915210 */     // GIR_Coverage, 19639,
     /* 1915210 */     GIR_EraseRootFromParent_Done,
     /* 1915211 */   // Label 25778: @1915211
     /* 1915211 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1915297), // Rule ID 19642 //
     /* 1915216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915262 */     // MIs[0] policy
     /* 1915262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915272 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1915275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915296 */     // GIR_Coverage, 19642,
     /* 1915296 */     GIR_EraseRootFromParent_Done,
     /* 1915297 */   // Label 25779: @1915297
     /* 1915297 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1915383), // Rule ID 19643 //
     /* 1915302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1915344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915348 */     // MIs[0] policy
     /* 1915348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915358 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1915361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915382 */     // GIR_Coverage, 19643,
     /* 1915382 */     GIR_EraseRootFromParent_Done,
     /* 1915383 */   // Label 25780: @1915383
     /* 1915383 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1915469), // Rule ID 19646 //
     /* 1915388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915434 */     // MIs[0] policy
     /* 1915434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915444 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915468 */     // GIR_Coverage, 19646,
     /* 1915468 */     GIR_EraseRootFromParent_Done,
     /* 1915469 */   // Label 25781: @1915469
     /* 1915469 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1915555), // Rule ID 19647 //
     /* 1915474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915520 */     // MIs[0] policy
     /* 1915520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915530 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915554 */     // GIR_Coverage, 19647,
     /* 1915554 */     GIR_EraseRootFromParent_Done,
     /* 1915555 */   // Label 25782: @1915555
     /* 1915555 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1915641), // Rule ID 19650 //
     /* 1915560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915606 */     // MIs[0] policy
     /* 1915606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915640 */     // GIR_Coverage, 19650,
     /* 1915640 */     GIR_EraseRootFromParent_Done,
     /* 1915641 */   // Label 25783: @1915641
     /* 1915641 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1915727), // Rule ID 19651 //
     /* 1915646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915692 */     // MIs[0] policy
     /* 1915692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915726 */     // GIR_Coverage, 19651,
     /* 1915726 */     GIR_EraseRootFromParent_Done,
     /* 1915727 */   // Label 25784: @1915727
     /* 1915727 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1915813), // Rule ID 19654 //
     /* 1915732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915778 */     // MIs[0] policy
     /* 1915778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915788 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915812 */     // GIR_Coverage, 19654,
     /* 1915812 */     GIR_EraseRootFromParent_Done,
     /* 1915813 */   // Label 25785: @1915813
     /* 1915813 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1915899), // Rule ID 19655 //
     /* 1915818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915864 */     // MIs[0] policy
     /* 1915864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915874 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915898 */     // GIR_Coverage, 19655,
     /* 1915898 */     GIR_EraseRootFromParent_Done,
     /* 1915899 */   // Label 25786: @1915899
     /* 1915899 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1915985), // Rule ID 19658 //
     /* 1915904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915950 */     // MIs[0] policy
     /* 1915950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915960 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915984 */     // GIR_Coverage, 19658,
     /* 1915984 */     GIR_EraseRootFromParent_Done,
     /* 1915985 */   // Label 25787: @1915985
     /* 1915985 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1916071), // Rule ID 19659 //
     /* 1915990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1916001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1916004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1916007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1916010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916036 */     // MIs[0] policy
     /* 1916036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916046 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1916049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916070 */     // GIR_Coverage, 19659,
     /* 1916070 */     GIR_EraseRootFromParent_Done,
     /* 1916071 */   // Label 25788: @1916071
     /* 1916071 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1916157), // Rule ID 19662 //
     /* 1916076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1916096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916122 */     // MIs[0] policy
     /* 1916122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1916135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916156 */     // GIR_Coverage, 19662,
     /* 1916156 */     GIR_EraseRootFromParent_Done,
     /* 1916157 */   // Label 25789: @1916157
     /* 1916157 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1916243), // Rule ID 19663 //
     /* 1916162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1916182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916208 */     // MIs[0] policy
     /* 1916208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916218 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1916221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916242 */     // GIR_Coverage, 19663,
     /* 1916242 */     GIR_EraseRootFromParent_Done,
     /* 1916243 */   // Label 25790: @1916243
     /* 1916243 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1916329), // Rule ID 19666 //
     /* 1916248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1916268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916294 */     // MIs[0] policy
     /* 1916294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1916307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916328 */     // GIR_Coverage, 19666,
     /* 1916328 */     GIR_EraseRootFromParent_Done,
     /* 1916329 */   // Label 25791: @1916329
     /* 1916329 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1916415), // Rule ID 19667 //
     /* 1916334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1916354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916380 */     // MIs[0] policy
     /* 1916380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916390 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1916393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916414 */     // GIR_Coverage, 19667,
     /* 1916414 */     GIR_EraseRootFromParent_Done,
     /* 1916415 */   // Label 25792: @1916415
     /* 1916415 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1916501), // Rule ID 19670 //
     /* 1916420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916466 */     // MIs[0] policy
     /* 1916466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916476 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916500 */     // GIR_Coverage, 19670,
     /* 1916500 */     GIR_EraseRootFromParent_Done,
     /* 1916501 */   // Label 25793: @1916501
     /* 1916501 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1916587), // Rule ID 19671 //
     /* 1916506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916552 */     // MIs[0] policy
     /* 1916552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916562 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916586 */     // GIR_Coverage, 19671,
     /* 1916586 */     GIR_EraseRootFromParent_Done,
     /* 1916587 */   // Label 25794: @1916587
     /* 1916587 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1916673), // Rule ID 19674 //
     /* 1916592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916638 */     // MIs[0] policy
     /* 1916638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916648 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916672 */     // GIR_Coverage, 19674,
     /* 1916672 */     GIR_EraseRootFromParent_Done,
     /* 1916673 */   // Label 25795: @1916673
     /* 1916673 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1916759), // Rule ID 19675 //
     /* 1916678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916724 */     // MIs[0] policy
     /* 1916724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916758 */     // GIR_Coverage, 19675,
     /* 1916758 */     GIR_EraseRootFromParent_Done,
     /* 1916759 */   // Label 25796: @1916759
     /* 1916759 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1916845), // Rule ID 19678 //
     /* 1916764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916810 */     // MIs[0] policy
     /* 1916810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916844 */     // GIR_Coverage, 19678,
     /* 1916844 */     GIR_EraseRootFromParent_Done,
     /* 1916845 */   // Label 25797: @1916845
     /* 1916845 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1916931), // Rule ID 19679 //
     /* 1916850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916896 */     // MIs[0] policy
     /* 1916896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916906 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916930 */     // GIR_Coverage, 19679,
     /* 1916930 */     GIR_EraseRootFromParent_Done,
     /* 1916931 */   // Label 25798: @1916931
     /* 1916931 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1917017), // Rule ID 19682 //
     /* 1916936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916982 */     // MIs[0] policy
     /* 1916982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916992 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1916995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917016 */     // GIR_Coverage, 19682,
     /* 1917016 */     GIR_EraseRootFromParent_Done,
     /* 1917017 */   // Label 25799: @1917017
     /* 1917017 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1917103), // Rule ID 19683 //
     /* 1917022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1917033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1917036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1917039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1917042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917068 */     // MIs[0] policy
     /* 1917068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917078 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1917081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917102 */     // GIR_Coverage, 19683,
     /* 1917102 */     GIR_EraseRootFromParent_Done,
     /* 1917103 */   // Label 25800: @1917103
     /* 1917103 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1917189), // Rule ID 19686 //
     /* 1917108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1917128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917154 */     // MIs[0] policy
     /* 1917154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917164 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1917167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917188 */     // GIR_Coverage, 19686,
     /* 1917188 */     GIR_EraseRootFromParent_Done,
     /* 1917189 */   // Label 25801: @1917189
     /* 1917189 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1917275), // Rule ID 19687 //
     /* 1917194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1917214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917240 */     // MIs[0] policy
     /* 1917240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917250 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1917253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917274 */     // GIR_Coverage, 19687,
     /* 1917274 */     GIR_EraseRootFromParent_Done,
     /* 1917275 */   // Label 25802: @1917275
     /* 1917275 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1917361), // Rule ID 19690 //
     /* 1917280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1917300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917326 */     // MIs[0] policy
     /* 1917326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917336 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1917339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917360 */     // GIR_Coverage, 19690,
     /* 1917360 */     GIR_EraseRootFromParent_Done,
     /* 1917361 */   // Label 25803: @1917361
     /* 1917361 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1917447), // Rule ID 19691 //
     /* 1917366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1917386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917412 */     // MIs[0] policy
     /* 1917412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917422 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1917425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917446 */     // GIR_Coverage, 19691,
     /* 1917446 */     GIR_EraseRootFromParent_Done,
     /* 1917447 */   // Label 25804: @1917447
     /* 1917447 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1917533), // Rule ID 19694 //
     /* 1917452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917498 */     // MIs[0] policy
     /* 1917498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917508 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917532 */     // GIR_Coverage, 19694,
     /* 1917532 */     GIR_EraseRootFromParent_Done,
     /* 1917533 */   // Label 25805: @1917533
     /* 1917533 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1917619), // Rule ID 19695 //
     /* 1917538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917584 */     // MIs[0] policy
     /* 1917584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917594 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917618 */     // GIR_Coverage, 19695,
     /* 1917618 */     GIR_EraseRootFromParent_Done,
     /* 1917619 */   // Label 25806: @1917619
     /* 1917619 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1917705), // Rule ID 19698 //
     /* 1917624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917670 */     // MIs[0] policy
     /* 1917670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917680 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917704 */     // GIR_Coverage, 19698,
     /* 1917704 */     GIR_EraseRootFromParent_Done,
     /* 1917705 */   // Label 25807: @1917705
     /* 1917705 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1917791), // Rule ID 19699 //
     /* 1917710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917756 */     // MIs[0] policy
     /* 1917756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917766 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917790 */     // GIR_Coverage, 19699,
     /* 1917790 */     GIR_EraseRootFromParent_Done,
     /* 1917791 */   // Label 25808: @1917791
     /* 1917791 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1917877), // Rule ID 19702 //
     /* 1917796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917842 */     // MIs[0] policy
     /* 1917842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917876 */     // GIR_Coverage, 19702,
     /* 1917876 */     GIR_EraseRootFromParent_Done,
     /* 1917877 */   // Label 25809: @1917877
     /* 1917877 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1917963), // Rule ID 19703 //
     /* 1917882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917928 */     // MIs[0] policy
     /* 1917928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917938 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917962 */     // GIR_Coverage, 19703,
     /* 1917962 */     GIR_EraseRootFromParent_Done,
     /* 1917963 */   // Label 25810: @1917963
     /* 1917963 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1918049), // Rule ID 19706 //
     /* 1917968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918014 */     // MIs[0] policy
     /* 1918014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1918027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918048 */     // GIR_Coverage, 19706,
     /* 1918048 */     GIR_EraseRootFromParent_Done,
     /* 1918049 */   // Label 25811: @1918049
     /* 1918049 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1918135), // Rule ID 19707 //
     /* 1918054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1918065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1918068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1918071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1918074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1918084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1918096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918100 */     // MIs[0] policy
     /* 1918100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918110 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1918113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918134 */     // GIR_Coverage, 19707,
     /* 1918134 */     GIR_EraseRootFromParent_Done,
     /* 1918135 */   // Label 25812: @1918135
     /* 1918135 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1918221), // Rule ID 19710 //
     /* 1918140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1918160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918186 */     // MIs[0] policy
     /* 1918186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918196 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1918199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918220 */     // GIR_Coverage, 19710,
     /* 1918220 */     GIR_EraseRootFromParent_Done,
     /* 1918221 */   // Label 25813: @1918221
     /* 1918221 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1918307), // Rule ID 19711 //
     /* 1918226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1918246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918272 */     // MIs[0] policy
     /* 1918272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918282 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1918285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918306 */     // GIR_Coverage, 19711,
     /* 1918306 */     GIR_EraseRootFromParent_Done,
     /* 1918307 */   // Label 25814: @1918307
     /* 1918307 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1918393), // Rule ID 19714 //
     /* 1918312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1918332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918358 */     // MIs[0] policy
     /* 1918358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918368 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1918371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918392 */     // GIR_Coverage, 19714,
     /* 1918392 */     GIR_EraseRootFromParent_Done,
     /* 1918393 */   // Label 25815: @1918393
     /* 1918393 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1918479), // Rule ID 19715 //
     /* 1918398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1918418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918444 */     // MIs[0] policy
     /* 1918444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918454 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1918457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918478 */     // GIR_Coverage, 19715,
     /* 1918478 */     GIR_EraseRootFromParent_Done,
     /* 1918479 */   // Label 25816: @1918479
     /* 1918479 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1918565), // Rule ID 19718 //
     /* 1918484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918530 */     // MIs[0] policy
     /* 1918530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918540 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918564 */     // GIR_Coverage, 19718,
     /* 1918564 */     GIR_EraseRootFromParent_Done,
     /* 1918565 */   // Label 25817: @1918565
     /* 1918565 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1918651), // Rule ID 19719 //
     /* 1918570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918616 */     // MIs[0] policy
     /* 1918616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918626 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918650 */     // GIR_Coverage, 19719,
     /* 1918650 */     GIR_EraseRootFromParent_Done,
     /* 1918651 */   // Label 25818: @1918651
     /* 1918651 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1918737), // Rule ID 19722 //
     /* 1918656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918702 */     // MIs[0] policy
     /* 1918702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918712 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918736 */     // GIR_Coverage, 19722,
     /* 1918736 */     GIR_EraseRootFromParent_Done,
     /* 1918737 */   // Label 25819: @1918737
     /* 1918737 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1918823), // Rule ID 19723 //
     /* 1918742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918788 */     // MIs[0] policy
     /* 1918788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918798 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918822 */     // GIR_Coverage, 19723,
     /* 1918822 */     GIR_EraseRootFromParent_Done,
     /* 1918823 */   // Label 25820: @1918823
     /* 1918823 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1918909), // Rule ID 19726 //
     /* 1918828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918874 */     // MIs[0] policy
     /* 1918874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918884 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918908 */     // GIR_Coverage, 19726,
     /* 1918908 */     GIR_EraseRootFromParent_Done,
     /* 1918909 */   // Label 25821: @1918909
     /* 1918909 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1918995), // Rule ID 19727 //
     /* 1918914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918960 */     // MIs[0] policy
     /* 1918960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918994 */     // GIR_Coverage, 19727,
     /* 1918994 */     GIR_EraseRootFromParent_Done,
     /* 1918995 */   // Label 25822: @1918995
     /* 1918995 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1919081), // Rule ID 19730 //
     /* 1919000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919046 */     // MIs[0] policy
     /* 1919046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919056 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1919059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919080 */     // GIR_Coverage, 19730,
     /* 1919080 */     GIR_EraseRootFromParent_Done,
     /* 1919081 */   // Label 25823: @1919081
     /* 1919081 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1919167), // Rule ID 19731 //
     /* 1919086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919132 */     // MIs[0] policy
     /* 1919132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919142 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11326:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1919145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919166 */     // GIR_Coverage, 19731,
     /* 1919166 */     GIR_EraseRootFromParent_Done,
     /* 1919167 */   // Label 25824: @1919167
     /* 1919167 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1919253), // Rule ID 19734 //
     /* 1919172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919218 */     // MIs[0] policy
     /* 1919218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919228 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1919231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919252 */     // GIR_Coverage, 19734,
     /* 1919252 */     GIR_EraseRootFromParent_Done,
     /* 1919253 */   // Label 25825: @1919253
     /* 1919253 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1919339), // Rule ID 19735 //
     /* 1919258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919304 */     // MIs[0] policy
     /* 1919304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919314 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11326:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1919317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919338 */     // GIR_Coverage, 19735,
     /* 1919338 */     GIR_EraseRootFromParent_Done,
     /* 1919339 */   // Label 25826: @1919339
     /* 1919339 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1919425), // Rule ID 19738 //
     /* 1919344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1919347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919390 */     // MIs[0] policy
     /* 1919390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919424 */     // GIR_Coverage, 19738,
     /* 1919424 */     GIR_EraseRootFromParent_Done,
     /* 1919425 */   // Label 25827: @1919425
     /* 1919425 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1919511), // Rule ID 19739 //
     /* 1919430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1919433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919476 */     // MIs[0] policy
     /* 1919476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919486 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11326:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919510 */     // GIR_Coverage, 19739,
     /* 1919510 */     GIR_EraseRootFromParent_Done,
     /* 1919511 */   // Label 25828: @1919511
     /* 1919511 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1919597), // Rule ID 19742 //
     /* 1919516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919562 */     // MIs[0] policy
     /* 1919562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919596 */     // GIR_Coverage, 19742,
     /* 1919596 */     GIR_EraseRootFromParent_Done,
     /* 1919597 */   // Label 25829: @1919597
     /* 1919597 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1919683), // Rule ID 19743 //
     /* 1919602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919648 */     // MIs[0] policy
     /* 1919648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919658 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919682 */     // GIR_Coverage, 19743,
     /* 1919682 */     GIR_EraseRootFromParent_Done,
     /* 1919683 */   // Label 25830: @1919683
     /* 1919683 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1919769), // Rule ID 19746 //
     /* 1919688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919734 */     // MIs[0] policy
     /* 1919734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919744 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919768 */     // GIR_Coverage, 19746,
     /* 1919768 */     GIR_EraseRootFromParent_Done,
     /* 1919769 */   // Label 25831: @1919769
     /* 1919769 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1919855), // Rule ID 19747 //
     /* 1919774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919820 */     // MIs[0] policy
     /* 1919820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919830 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919854 */     // GIR_Coverage, 19747,
     /* 1919854 */     GIR_EraseRootFromParent_Done,
     /* 1919855 */   // Label 25832: @1919855
     /* 1919855 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1919941), // Rule ID 19750 //
     /* 1919860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919906 */     // MIs[0] policy
     /* 1919906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919916 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919940 */     // GIR_Coverage, 19750,
     /* 1919940 */     GIR_EraseRootFromParent_Done,
     /* 1919941 */   // Label 25833: @1919941
     /* 1919941 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1920027), // Rule ID 19751 //
     /* 1919946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919992 */     // MIs[0] policy
     /* 1919992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920002 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1920005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920026 */     // GIR_Coverage, 19751,
     /* 1920026 */     GIR_EraseRootFromParent_Done,
     /* 1920027 */   // Label 25834: @1920027
     /* 1920027 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1920113), // Rule ID 19754 //
     /* 1920032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920078 */     // MIs[0] policy
     /* 1920078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1920091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920112 */     // GIR_Coverage, 19754,
     /* 1920112 */     GIR_EraseRootFromParent_Done,
     /* 1920113 */   // Label 25835: @1920113
     /* 1920113 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1920199), // Rule ID 19755 //
     /* 1920118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920164 */     // MIs[0] policy
     /* 1920164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920174 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1920177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920198 */     // GIR_Coverage, 19755,
     /* 1920198 */     GIR_EraseRootFromParent_Done,
     /* 1920199 */   // Label 25836: @1920199
     /* 1920199 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1920285), // Rule ID 19758 //
     /* 1920204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920250 */     // MIs[0] policy
     /* 1920250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920260 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1920263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920284 */     // GIR_Coverage, 19758,
     /* 1920284 */     GIR_EraseRootFromParent_Done,
     /* 1920285 */   // Label 25837: @1920285
     /* 1920285 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1920371), // Rule ID 19759 //
     /* 1920290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920336 */     // MIs[0] policy
     /* 1920336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920346 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1920349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920370 */     // GIR_Coverage, 19759,
     /* 1920370 */     GIR_EraseRootFromParent_Done,
     /* 1920371 */   // Label 25838: @1920371
     /* 1920371 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1920457), // Rule ID 19762 //
     /* 1920376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1920379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920422 */     // MIs[0] policy
     /* 1920422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920456 */     // GIR_Coverage, 19762,
     /* 1920456 */     GIR_EraseRootFromParent_Done,
     /* 1920457 */   // Label 25839: @1920457
     /* 1920457 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1920543), // Rule ID 19763 //
     /* 1920462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1920465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920508 */     // MIs[0] policy
     /* 1920508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920518 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920542 */     // GIR_Coverage, 19763,
     /* 1920542 */     GIR_EraseRootFromParent_Done,
     /* 1920543 */   // Label 25840: @1920543
     /* 1920543 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1920629), // Rule ID 19766 //
     /* 1920548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920594 */     // MIs[0] policy
     /* 1920594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920628 */     // GIR_Coverage, 19766,
     /* 1920628 */     GIR_EraseRootFromParent_Done,
     /* 1920629 */   // Label 25841: @1920629
     /* 1920629 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1920715), // Rule ID 19767 //
     /* 1920634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920680 */     // MIs[0] policy
     /* 1920680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11326:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920714 */     // GIR_Coverage, 19767,
     /* 1920714 */     GIR_EraseRootFromParent_Done,
     /* 1920715 */   // Label 25842: @1920715
     /* 1920715 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1920801), // Rule ID 19770 //
     /* 1920720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920766 */     // MIs[0] policy
     /* 1920766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920800 */     // GIR_Coverage, 19770,
     /* 1920800 */     GIR_EraseRootFromParent_Done,
     /* 1920801 */   // Label 25843: @1920801
     /* 1920801 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1920887), // Rule ID 19771 //
     /* 1920806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920852 */     // MIs[0] policy
     /* 1920852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920862 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11326:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920886 */     // GIR_Coverage, 19771,
     /* 1920886 */     GIR_EraseRootFromParent_Done,
     /* 1920887 */   // Label 25844: @1920887
     /* 1920887 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1920973), // Rule ID 19774 //
     /* 1920892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920938 */     // MIs[0] policy
     /* 1920938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920948 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920972 */     // GIR_Coverage, 19774,
     /* 1920972 */     GIR_EraseRootFromParent_Done,
     /* 1920973 */   // Label 25845: @1920973
     /* 1920973 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1921059), // Rule ID 19775 //
     /* 1920978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1921020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921024 */     // MIs[0] policy
     /* 1921024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921034 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11326:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1921037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921058 */     // GIR_Coverage, 19775,
     /* 1921058 */     GIR_EraseRootFromParent_Done,
     /* 1921059 */   // Label 25846: @1921059
     /* 1921059 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1921145), // Rule ID 23616 //
     /* 1921064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921110 */     // MIs[0] policy
     /* 1921110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1921123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921144 */     // GIR_Coverage, 23616,
     /* 1921144 */     GIR_EraseRootFromParent_Done,
     /* 1921145 */   // Label 25847: @1921145
     /* 1921145 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1921231), // Rule ID 23617 //
     /* 1921150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921196 */     // MIs[0] policy
     /* 1921196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921206 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1921209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921230 */     // GIR_Coverage, 23617,
     /* 1921230 */     GIR_EraseRootFromParent_Done,
     /* 1921231 */   // Label 25848: @1921231
     /* 1921231 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1921317), // Rule ID 23620 //
     /* 1921236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921282 */     // MIs[0] policy
     /* 1921282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921316 */     // GIR_Coverage, 23620,
     /* 1921316 */     GIR_EraseRootFromParent_Done,
     /* 1921317 */   // Label 25849: @1921317
     /* 1921317 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1921403), // Rule ID 23621 //
     /* 1921322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921368 */     // MIs[0] policy
     /* 1921368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921378 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921402 */     // GIR_Coverage, 23621,
     /* 1921402 */     GIR_EraseRootFromParent_Done,
     /* 1921403 */   // Label 25850: @1921403
     /* 1921403 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1921489), // Rule ID 23624 //
     /* 1921408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921454 */     // MIs[0] policy
     /* 1921454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921488 */     // GIR_Coverage, 23624,
     /* 1921488 */     GIR_EraseRootFromParent_Done,
     /* 1921489 */   // Label 25851: @1921489
     /* 1921489 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1921575), // Rule ID 23625 //
     /* 1921494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921540 */     // MIs[0] policy
     /* 1921540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921574 */     // GIR_Coverage, 23625,
     /* 1921574 */     GIR_EraseRootFromParent_Done,
     /* 1921575 */   // Label 25852: @1921575
     /* 1921575 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1921661), // Rule ID 23628 //
     /* 1921580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921626 */     // MIs[0] policy
     /* 1921626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921660 */     // GIR_Coverage, 23628,
     /* 1921660 */     GIR_EraseRootFromParent_Done,
     /* 1921661 */   // Label 25853: @1921661
     /* 1921661 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1921747), // Rule ID 23629 //
     /* 1921666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921712 */     // MIs[0] policy
     /* 1921712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921722 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921746 */     // GIR_Coverage, 23629,
     /* 1921746 */     GIR_EraseRootFromParent_Done,
     /* 1921747 */   // Label 25854: @1921747
     /* 1921747 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1921833), // Rule ID 23632 //
     /* 1921752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921798 */     // MIs[0] policy
     /* 1921798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921808 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921832 */     // GIR_Coverage, 23632,
     /* 1921832 */     GIR_EraseRootFromParent_Done,
     /* 1921833 */   // Label 25855: @1921833
     /* 1921833 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1921919), // Rule ID 23633 //
     /* 1921838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921884 */     // MIs[0] policy
     /* 1921884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921918 */     // GIR_Coverage, 23633,
     /* 1921918 */     GIR_EraseRootFromParent_Done,
     /* 1921919 */   // Label 25856: @1921919
     /* 1921919 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1922005), // Rule ID 23636 //
     /* 1921924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921970 */     // MIs[0] policy
     /* 1921970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922004 */     // GIR_Coverage, 23636,
     /* 1922004 */     GIR_EraseRootFromParent_Done,
     /* 1922005 */   // Label 25857: @1922005
     /* 1922005 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1922091), // Rule ID 23637 //
     /* 1922010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922056 */     // MIs[0] policy
     /* 1922056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1922069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922090 */     // GIR_Coverage, 23637,
     /* 1922090 */     GIR_EraseRootFromParent_Done,
     /* 1922091 */   // Label 25858: @1922091
     /* 1922091 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1922177), // Rule ID 23640 //
     /* 1922096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922142 */     // MIs[0] policy
     /* 1922142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922176 */     // GIR_Coverage, 23640,
     /* 1922176 */     GIR_EraseRootFromParent_Done,
     /* 1922177 */   // Label 25859: @1922177
     /* 1922177 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1922263), // Rule ID 23641 //
     /* 1922182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922228 */     // MIs[0] policy
     /* 1922228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11608:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922262 */     // GIR_Coverage, 23641,
     /* 1922262 */     GIR_EraseRootFromParent_Done,
     /* 1922263 */   // Label 25860: @1922263
     /* 1922263 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1922349), // Rule ID 23644 //
     /* 1922268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922314 */     // MIs[0] policy
     /* 1922314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922348 */     // GIR_Coverage, 23644,
     /* 1922348 */     GIR_EraseRootFromParent_Done,
     /* 1922349 */   // Label 25861: @1922349
     /* 1922349 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1922435), // Rule ID 23645 //
     /* 1922354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922400 */     // MIs[0] policy
     /* 1922400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922434 */     // GIR_Coverage, 23645,
     /* 1922434 */     GIR_EraseRootFromParent_Done,
     /* 1922435 */   // Label 25862: @1922435
     /* 1922435 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1922521), // Rule ID 23648 //
     /* 1922440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922486 */     // MIs[0] policy
     /* 1922486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922520 */     // GIR_Coverage, 23648,
     /* 1922520 */     GIR_EraseRootFromParent_Done,
     /* 1922521 */   // Label 25863: @1922521
     /* 1922521 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1922607), // Rule ID 23649 //
     /* 1922526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922572 */     // MIs[0] policy
     /* 1922572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922606 */     // GIR_Coverage, 23649,
     /* 1922606 */     GIR_EraseRootFromParent_Done,
     /* 1922607 */   // Label 25864: @1922607
     /* 1922607 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1922693), // Rule ID 23652 //
     /* 1922612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1922615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922658 */     // MIs[0] policy
     /* 1922658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922692 */     // GIR_Coverage, 23652,
     /* 1922692 */     GIR_EraseRootFromParent_Done,
     /* 1922693 */   // Label 25865: @1922693
     /* 1922693 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1922779), // Rule ID 23653 //
     /* 1922698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1922701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922744 */     // MIs[0] policy
     /* 1922744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922778 */     // GIR_Coverage, 23653,
     /* 1922778 */     GIR_EraseRootFromParent_Done,
     /* 1922779 */   // Label 25866: @1922779
     /* 1922779 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1922865), // Rule ID 23656 //
     /* 1922784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922830 */     // MIs[0] policy
     /* 1922830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922864 */     // GIR_Coverage, 23656,
     /* 1922864 */     GIR_EraseRootFromParent_Done,
     /* 1922865 */   // Label 25867: @1922865
     /* 1922865 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1922951), // Rule ID 23657 //
     /* 1922870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922916 */     // MIs[0] policy
     /* 1922916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922950 */     // GIR_Coverage, 23657,
     /* 1922950 */     GIR_EraseRootFromParent_Done,
     /* 1922951 */   // Label 25868: @1922951
     /* 1922951 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1923037), // Rule ID 23660 //
     /* 1922956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923002 */     // MIs[0] policy
     /* 1923002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923012 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923036 */     // GIR_Coverage, 23660,
     /* 1923036 */     GIR_EraseRootFromParent_Done,
     /* 1923037 */   // Label 25869: @1923037
     /* 1923037 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1923123), // Rule ID 23661 //
     /* 1923042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1923059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923088 */     // MIs[0] policy
     /* 1923088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923098 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923122 */     // GIR_Coverage, 23661,
     /* 1923122 */     GIR_EraseRootFromParent_Done,
     /* 1923123 */   // Label 25870: @1923123
     /* 1923123 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1923209), // Rule ID 23664 //
     /* 1923128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923174 */     // MIs[0] policy
     /* 1923174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923184 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923208 */     // GIR_Coverage, 23664,
     /* 1923208 */     GIR_EraseRootFromParent_Done,
     /* 1923209 */   // Label 25871: @1923209
     /* 1923209 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1923295), // Rule ID 23665 //
     /* 1923214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923260 */     // MIs[0] policy
     /* 1923260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923294 */     // GIR_Coverage, 23665,
     /* 1923294 */     GIR_EraseRootFromParent_Done,
     /* 1923295 */   // Label 25872: @1923295
     /* 1923295 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1923381), // Rule ID 23668 //
     /* 1923300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923346 */     // MIs[0] policy
     /* 1923346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923380 */     // GIR_Coverage, 23668,
     /* 1923380 */     GIR_EraseRootFromParent_Done,
     /* 1923381 */   // Label 25873: @1923381
     /* 1923381 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1923467), // Rule ID 23669 //
     /* 1923386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923432 */     // MIs[0] policy
     /* 1923432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923466 */     // GIR_Coverage, 23669,
     /* 1923466 */     GIR_EraseRootFromParent_Done,
     /* 1923467 */   // Label 25874: @1923467
     /* 1923467 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1923553), // Rule ID 23672 //
     /* 1923472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923518 */     // MIs[0] policy
     /* 1923518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923528 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923552 */     // GIR_Coverage, 23672,
     /* 1923552 */     GIR_EraseRootFromParent_Done,
     /* 1923553 */   // Label 25875: @1923553
     /* 1923553 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1923639), // Rule ID 23673 //
     /* 1923558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923604 */     // MIs[0] policy
     /* 1923604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923638 */     // GIR_Coverage, 23673,
     /* 1923638 */     GIR_EraseRootFromParent_Done,
     /* 1923639 */   // Label 25876: @1923639
     /* 1923639 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1923725), // Rule ID 23676 //
     /* 1923644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923690 */     // MIs[0] policy
     /* 1923690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923700 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923724 */     // GIR_Coverage, 23676,
     /* 1923724 */     GIR_EraseRootFromParent_Done,
     /* 1923725 */   // Label 25877: @1923725
     /* 1923725 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1923811), // Rule ID 23677 //
     /* 1923730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923776 */     // MIs[0] policy
     /* 1923776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923810 */     // GIR_Coverage, 23677,
     /* 1923810 */     GIR_EraseRootFromParent_Done,
     /* 1923811 */   // Label 25878: @1923811
     /* 1923811 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1923897), // Rule ID 23680 //
     /* 1923816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923862 */     // MIs[0] policy
     /* 1923862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923896 */     // GIR_Coverage, 23680,
     /* 1923896 */     GIR_EraseRootFromParent_Done,
     /* 1923897 */   // Label 25879: @1923897
     /* 1923897 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1923983), // Rule ID 23681 //
     /* 1923902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923948 */     // MIs[0] policy
     /* 1923948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923982 */     // GIR_Coverage, 23681,
     /* 1923982 */     GIR_EraseRootFromParent_Done,
     /* 1923983 */   // Label 25880: @1923983
     /* 1923983 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1924069), // Rule ID 23684 //
     /* 1923988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924034 */     // MIs[0] policy
     /* 1924034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924068 */     // GIR_Coverage, 23684,
     /* 1924068 */     GIR_EraseRootFromParent_Done,
     /* 1924069 */   // Label 25881: @1924069
     /* 1924069 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1924155), // Rule ID 23685 //
     /* 1924074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1924085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924120 */     // MIs[0] policy
     /* 1924120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924154 */     // GIR_Coverage, 23685,
     /* 1924154 */     GIR_EraseRootFromParent_Done,
     /* 1924155 */   // Label 25882: @1924155
     /* 1924155 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1924241), // Rule ID 23688 //
     /* 1924160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924206 */     // MIs[0] policy
     /* 1924206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924240 */     // GIR_Coverage, 23688,
     /* 1924240 */     GIR_EraseRootFromParent_Done,
     /* 1924241 */   // Label 25883: @1924241
     /* 1924241 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1924327), // Rule ID 23689 //
     /* 1924246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924292 */     // MIs[0] policy
     /* 1924292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924326 */     // GIR_Coverage, 23689,
     /* 1924326 */     GIR_EraseRootFromParent_Done,
     /* 1924327 */   // Label 25884: @1924327
     /* 1924327 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1924413), // Rule ID 23692 //
     /* 1924332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924378 */     // MIs[0] policy
     /* 1924378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924388 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924412 */     // GIR_Coverage, 23692,
     /* 1924412 */     GIR_EraseRootFromParent_Done,
     /* 1924413 */   // Label 25885: @1924413
     /* 1924413 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1924499), // Rule ID 23693 //
     /* 1924418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924464 */     // MIs[0] policy
     /* 1924464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924498 */     // GIR_Coverage, 23693,
     /* 1924498 */     GIR_EraseRootFromParent_Done,
     /* 1924499 */   // Label 25886: @1924499
     /* 1924499 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1924585), // Rule ID 23696 //
     /* 1924504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924550 */     // MIs[0] policy
     /* 1924550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924584 */     // GIR_Coverage, 23696,
     /* 1924584 */     GIR_EraseRootFromParent_Done,
     /* 1924585 */   // Label 25887: @1924585
     /* 1924585 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1924671), // Rule ID 23697 //
     /* 1924590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924636 */     // MIs[0] policy
     /* 1924636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924670 */     // GIR_Coverage, 23697,
     /* 1924670 */     GIR_EraseRootFromParent_Done,
     /* 1924671 */   // Label 25888: @1924671
     /* 1924671 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1924757), // Rule ID 23700 //
     /* 1924676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924722 */     // MIs[0] policy
     /* 1924722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924732 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924756 */     // GIR_Coverage, 23700,
     /* 1924756 */     GIR_EraseRootFromParent_Done,
     /* 1924757 */   // Label 25889: @1924757
     /* 1924757 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1924843), // Rule ID 23701 //
     /* 1924762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924808 */     // MIs[0] policy
     /* 1924808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924818 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924842 */     // GIR_Coverage, 23701,
     /* 1924842 */     GIR_EraseRootFromParent_Done,
     /* 1924843 */   // Label 25890: @1924843
     /* 1924843 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1924929), // Rule ID 23792 //
     /* 1924848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924894 */     // MIs[0] policy
     /* 1924894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924928 */     // GIR_Coverage, 23792,
     /* 1924928 */     GIR_EraseRootFromParent_Done,
     /* 1924929 */   // Label 25891: @1924929
     /* 1924929 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1925015), // Rule ID 23793 //
     /* 1924934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924980 */     // MIs[0] policy
     /* 1924980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925014 */     // GIR_Coverage, 23793,
     /* 1925014 */     GIR_EraseRootFromParent_Done,
     /* 1925015 */   // Label 25892: @1925015
     /* 1925015 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1925101), // Rule ID 23796 //
     /* 1925020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925066 */     // MIs[0] policy
     /* 1925066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925100 */     // GIR_Coverage, 23796,
     /* 1925100 */     GIR_EraseRootFromParent_Done,
     /* 1925101 */   // Label 25893: @1925101
     /* 1925101 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1925187), // Rule ID 23797 //
     /* 1925106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925152 */     // MIs[0] policy
     /* 1925152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925186 */     // GIR_Coverage, 23797,
     /* 1925186 */     GIR_EraseRootFromParent_Done,
     /* 1925187 */   // Label 25894: @1925187
     /* 1925187 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1925273), // Rule ID 23800 //
     /* 1925192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925238 */     // MIs[0] policy
     /* 1925238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925272 */     // GIR_Coverage, 23800,
     /* 1925272 */     GIR_EraseRootFromParent_Done,
     /* 1925273 */   // Label 25895: @1925273
     /* 1925273 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1925359), // Rule ID 23801 //
     /* 1925278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925324 */     // MIs[0] policy
     /* 1925324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925358 */     // GIR_Coverage, 23801,
     /* 1925358 */     GIR_EraseRootFromParent_Done,
     /* 1925359 */   // Label 25896: @1925359
     /* 1925359 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1925445), // Rule ID 23804 //
     /* 1925364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925410 */     // MIs[0] policy
     /* 1925410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925444 */     // GIR_Coverage, 23804,
     /* 1925444 */     GIR_EraseRootFromParent_Done,
     /* 1925445 */   // Label 25897: @1925445
     /* 1925445 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1925531), // Rule ID 23805 //
     /* 1925450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925496 */     // MIs[0] policy
     /* 1925496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925530 */     // GIR_Coverage, 23805,
     /* 1925530 */     GIR_EraseRootFromParent_Done,
     /* 1925531 */   // Label 25898: @1925531
     /* 1925531 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1925617), // Rule ID 23808 //
     /* 1925536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925582 */     // MIs[0] policy
     /* 1925582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925616 */     // GIR_Coverage, 23808,
     /* 1925616 */     GIR_EraseRootFromParent_Done,
     /* 1925617 */   // Label 25899: @1925617
     /* 1925617 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1925703), // Rule ID 23809 //
     /* 1925622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925668 */     // MIs[0] policy
     /* 1925668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925702 */     // GIR_Coverage, 23809,
     /* 1925702 */     GIR_EraseRootFromParent_Done,
     /* 1925703 */   // Label 25900: @1925703
     /* 1925703 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1925789), // Rule ID 23812 //
     /* 1925708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925754 */     // MIs[0] policy
     /* 1925754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925788 */     // GIR_Coverage, 23812,
     /* 1925788 */     GIR_EraseRootFromParent_Done,
     /* 1925789 */   // Label 25901: @1925789
     /* 1925789 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1925875), // Rule ID 23813 //
     /* 1925794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925840 */     // MIs[0] policy
     /* 1925840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925874 */     // GIR_Coverage, 23813,
     /* 1925874 */     GIR_EraseRootFromParent_Done,
     /* 1925875 */   // Label 25902: @1925875
     /* 1925875 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1925961), // Rule ID 23816 //
     /* 1925880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925926 */     // MIs[0] policy
     /* 1925926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925960 */     // GIR_Coverage, 23816,
     /* 1925960 */     GIR_EraseRootFromParent_Done,
     /* 1925961 */   // Label 25903: @1925961
     /* 1925961 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1926047), // Rule ID 23817 //
     /* 1925966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926012 */     // MIs[0] policy
     /* 1926012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926046 */     // GIR_Coverage, 23817,
     /* 1926046 */     GIR_EraseRootFromParent_Done,
     /* 1926047 */   // Label 25904: @1926047
     /* 1926047 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1926133), // Rule ID 23820 //
     /* 1926052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926098 */     // MIs[0] policy
     /* 1926098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926132 */     // GIR_Coverage, 23820,
     /* 1926132 */     GIR_EraseRootFromParent_Done,
     /* 1926133 */   // Label 25905: @1926133
     /* 1926133 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1926219), // Rule ID 23821 //
     /* 1926138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926184 */     // MIs[0] policy
     /* 1926184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926218 */     // GIR_Coverage, 23821,
     /* 1926218 */     GIR_EraseRootFromParent_Done,
     /* 1926219 */   // Label 25906: @1926219
     /* 1926219 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1926305), // Rule ID 23824 //
     /* 1926224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926270 */     // MIs[0] policy
     /* 1926270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926304 */     // GIR_Coverage, 23824,
     /* 1926304 */     GIR_EraseRootFromParent_Done,
     /* 1926305 */   // Label 25907: @1926305
     /* 1926305 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1926391), // Rule ID 23825 //
     /* 1926310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926356 */     // MIs[0] policy
     /* 1926356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926390 */     // GIR_Coverage, 23825,
     /* 1926390 */     GIR_EraseRootFromParent_Done,
     /* 1926391 */   // Label 25908: @1926391
     /* 1926391 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1926477), // Rule ID 23828 //
     /* 1926396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1926399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926442 */     // MIs[0] policy
     /* 1926442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926476 */     // GIR_Coverage, 23828,
     /* 1926476 */     GIR_EraseRootFromParent_Done,
     /* 1926477 */   // Label 25909: @1926477
     /* 1926477 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1926563), // Rule ID 23829 //
     /* 1926482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1926485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926528 */     // MIs[0] policy
     /* 1926528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926562 */     // GIR_Coverage, 23829,
     /* 1926562 */     GIR_EraseRootFromParent_Done,
     /* 1926563 */   // Label 25910: @1926563
     /* 1926563 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1926649), // Rule ID 23832 //
     /* 1926568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926614 */     // MIs[0] policy
     /* 1926614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926648 */     // GIR_Coverage, 23832,
     /* 1926648 */     GIR_EraseRootFromParent_Done,
     /* 1926649 */   // Label 25911: @1926649
     /* 1926649 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1926735), // Rule ID 23833 //
     /* 1926654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926700 */     // MIs[0] policy
     /* 1926700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926734 */     // GIR_Coverage, 23833,
     /* 1926734 */     GIR_EraseRootFromParent_Done,
     /* 1926735 */   // Label 25912: @1926735
     /* 1926735 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1926821), // Rule ID 23836 //
     /* 1926740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926786 */     // MIs[0] policy
     /* 1926786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926820 */     // GIR_Coverage, 23836,
     /* 1926820 */     GIR_EraseRootFromParent_Done,
     /* 1926821 */   // Label 25913: @1926821
     /* 1926821 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1926907), // Rule ID 23837 //
     /* 1926826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926872 */     // MIs[0] policy
     /* 1926872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926882 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926906 */     // GIR_Coverage, 23837,
     /* 1926906 */     GIR_EraseRootFromParent_Done,
     /* 1926907 */   // Label 25914: @1926907
     /* 1926907 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1926993), // Rule ID 23840 //
     /* 1926912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926958 */     // MIs[0] policy
     /* 1926958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926968 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926992 */     // GIR_Coverage, 23840,
     /* 1926992 */     GIR_EraseRootFromParent_Done,
     /* 1926993 */   // Label 25915: @1926993
     /* 1926993 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1927079), // Rule ID 23841 //
     /* 1926998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1927009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1927012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1927015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1927021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927044 */     // MIs[0] policy
     /* 1927044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927054 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927078 */     // GIR_Coverage, 23841,
     /* 1927078 */     GIR_EraseRootFromParent_Done,
     /* 1927079 */   // Label 25916: @1927079
     /* 1927079 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1927165), // Rule ID 23844 //
     /* 1927084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927130 */     // MIs[0] policy
     /* 1927130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927164 */     // GIR_Coverage, 23844,
     /* 1927164 */     GIR_EraseRootFromParent_Done,
     /* 1927165 */   // Label 25917: @1927165
     /* 1927165 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1927251), // Rule ID 23845 //
     /* 1927170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927216 */     // MIs[0] policy
     /* 1927216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927250 */     // GIR_Coverage, 23845,
     /* 1927250 */     GIR_EraseRootFromParent_Done,
     /* 1927251 */   // Label 25918: @1927251
     /* 1927251 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1927337), // Rule ID 23848 //
     /* 1927256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927302 */     // MIs[0] policy
     /* 1927302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927312 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927336 */     // GIR_Coverage, 23848,
     /* 1927336 */     GIR_EraseRootFromParent_Done,
     /* 1927337 */   // Label 25919: @1927337
     /* 1927337 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1927423), // Rule ID 23849 //
     /* 1927342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927388 */     // MIs[0] policy
     /* 1927388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927422 */     // GIR_Coverage, 23849,
     /* 1927422 */     GIR_EraseRootFromParent_Done,
     /* 1927423 */   // Label 25920: @1927423
     /* 1927423 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1927509), // Rule ID 23852 //
     /* 1927428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927474 */     // MIs[0] policy
     /* 1927474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927484 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927508 */     // GIR_Coverage, 23852,
     /* 1927508 */     GIR_EraseRootFromParent_Done,
     /* 1927509 */   // Label 25921: @1927509
     /* 1927509 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1927595), // Rule ID 23853 //
     /* 1927514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927560 */     // MIs[0] policy
     /* 1927560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927594 */     // GIR_Coverage, 23853,
     /* 1927594 */     GIR_EraseRootFromParent_Done,
     /* 1927595 */   // Label 25922: @1927595
     /* 1927595 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1927681), // Rule ID 23856 //
     /* 1927600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927646 */     // MIs[0] policy
     /* 1927646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927680 */     // GIR_Coverage, 23856,
     /* 1927680 */     GIR_EraseRootFromParent_Done,
     /* 1927681 */   // Label 25923: @1927681
     /* 1927681 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1927767), // Rule ID 23857 //
     /* 1927686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927732 */     // MIs[0] policy
     /* 1927732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927766 */     // GIR_Coverage, 23857,
     /* 1927766 */     GIR_EraseRootFromParent_Done,
     /* 1927767 */   // Label 25924: @1927767
     /* 1927767 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1927853), // Rule ID 23860 //
     /* 1927772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927818 */     // MIs[0] policy
     /* 1927818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927852 */     // GIR_Coverage, 23860,
     /* 1927852 */     GIR_EraseRootFromParent_Done,
     /* 1927853 */   // Label 25925: @1927853
     /* 1927853 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1927939), // Rule ID 23861 //
     /* 1927858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927904 */     // MIs[0] policy
     /* 1927904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927938 */     // GIR_Coverage, 23861,
     /* 1927938 */     GIR_EraseRootFromParent_Done,
     /* 1927939 */   // Label 25926: @1927939
     /* 1927939 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1928025), // Rule ID 23864 //
     /* 1927944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927990 */     // MIs[0] policy
     /* 1927990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928024 */     // GIR_Coverage, 23864,
     /* 1928024 */     GIR_EraseRootFromParent_Done,
     /* 1928025 */   // Label 25927: @1928025
     /* 1928025 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1928111), // Rule ID 23865 //
     /* 1928030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1928041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1928044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1928047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928076 */     // MIs[0] policy
     /* 1928076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928110 */     // GIR_Coverage, 23865,
     /* 1928110 */     GIR_EraseRootFromParent_Done,
     /* 1928111 */   // Label 25928: @1928111
     /* 1928111 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1928197), // Rule ID 23868 //
     /* 1928116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928162 */     // MIs[0] policy
     /* 1928162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1928175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928196 */     // GIR_Coverage, 23868,
     /* 1928196 */     GIR_EraseRootFromParent_Done,
     /* 1928197 */   // Label 25929: @1928197
     /* 1928197 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1928283), // Rule ID 23869 //
     /* 1928202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928248 */     // MIs[0] policy
     /* 1928248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1928261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928282 */     // GIR_Coverage, 23869,
     /* 1928282 */     GIR_EraseRootFromParent_Done,
     /* 1928283 */   // Label 25930: @1928283
     /* 1928283 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1928369), // Rule ID 23872 //
     /* 1928288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928334 */     // MIs[0] policy
     /* 1928334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1928347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928368 */     // GIR_Coverage, 23872,
     /* 1928368 */     GIR_EraseRootFromParent_Done,
     /* 1928369 */   // Label 25931: @1928369
     /* 1928369 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1928455), // Rule ID 23873 //
     /* 1928374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928420 */     // MIs[0] policy
     /* 1928420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1928433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928454 */     // GIR_Coverage, 23873,
     /* 1928454 */     GIR_EraseRootFromParent_Done,
     /* 1928455 */   // Label 25932: @1928455
     /* 1928455 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1928541), // Rule ID 23876 //
     /* 1928460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928506 */     // MIs[0] policy
     /* 1928506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928540 */     // GIR_Coverage, 23876,
     /* 1928540 */     GIR_EraseRootFromParent_Done,
     /* 1928541 */   // Label 25933: @1928541
     /* 1928541 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1928627), // Rule ID 23877 //
     /* 1928546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928592 */     // MIs[0] policy
     /* 1928592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928626 */     // GIR_Coverage, 23877,
     /* 1928626 */     GIR_EraseRootFromParent_Done,
     /* 1928627 */   // Label 25934: @1928627
     /* 1928627 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1928713), // Rule ID 23968 //
     /* 1928632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928678 */     // MIs[0] policy
     /* 1928678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928688 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928712 */     // GIR_Coverage, 23968,
     /* 1928712 */     GIR_EraseRootFromParent_Done,
     /* 1928713 */   // Label 25935: @1928713
     /* 1928713 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1928799), // Rule ID 23969 //
     /* 1928718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928764 */     // MIs[0] policy
     /* 1928764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928774 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928798 */     // GIR_Coverage, 23969,
     /* 1928798 */     GIR_EraseRootFromParent_Done,
     /* 1928799 */   // Label 25936: @1928799
     /* 1928799 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1928885), // Rule ID 23972 //
     /* 1928804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928850 */     // MIs[0] policy
     /* 1928850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928860 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928884 */     // GIR_Coverage, 23972,
     /* 1928884 */     GIR_EraseRootFromParent_Done,
     /* 1928885 */   // Label 25937: @1928885
     /* 1928885 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1928971), // Rule ID 23973 //
     /* 1928890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928936 */     // MIs[0] policy
     /* 1928936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928970 */     // GIR_Coverage, 23973,
     /* 1928970 */     GIR_EraseRootFromParent_Done,
     /* 1928971 */   // Label 25938: @1928971
     /* 1928971 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1929057), // Rule ID 23976 //
     /* 1928976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929022 */     // MIs[0] policy
     /* 1929022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929032 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929056 */     // GIR_Coverage, 23976,
     /* 1929056 */     GIR_EraseRootFromParent_Done,
     /* 1929057 */   // Label 25939: @1929057
     /* 1929057 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1929143), // Rule ID 23977 //
     /* 1929062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1929073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1929076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1929079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929108 */     // MIs[0] policy
     /* 1929108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929142 */     // GIR_Coverage, 23977,
     /* 1929142 */     GIR_EraseRootFromParent_Done,
     /* 1929143 */   // Label 25940: @1929143
     /* 1929143 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1929229), // Rule ID 23980 //
     /* 1929148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929194 */     // MIs[0] policy
     /* 1929194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929204 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1929207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929228 */     // GIR_Coverage, 23980,
     /* 1929228 */     GIR_EraseRootFromParent_Done,
     /* 1929229 */   // Label 25941: @1929229
     /* 1929229 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1929315), // Rule ID 23981 //
     /* 1929234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929280 */     // MIs[0] policy
     /* 1929280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1929293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929314 */     // GIR_Coverage, 23981,
     /* 1929314 */     GIR_EraseRootFromParent_Done,
     /* 1929315 */   // Label 25942: @1929315
     /* 1929315 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1929401), // Rule ID 23984 //
     /* 1929320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929366 */     // MIs[0] policy
     /* 1929366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929376 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929400 */     // GIR_Coverage, 23984,
     /* 1929400 */     GIR_EraseRootFromParent_Done,
     /* 1929401 */   // Label 25943: @1929401
     /* 1929401 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1929487), // Rule ID 23985 //
     /* 1929406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929452 */     // MIs[0] policy
     /* 1929452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929486 */     // GIR_Coverage, 23985,
     /* 1929486 */     GIR_EraseRootFromParent_Done,
     /* 1929487 */   // Label 25944: @1929487
     /* 1929487 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1929573), // Rule ID 23988 //
     /* 1929492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929538 */     // MIs[0] policy
     /* 1929538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929572 */     // GIR_Coverage, 23988,
     /* 1929572 */     GIR_EraseRootFromParent_Done,
     /* 1929573 */   // Label 25945: @1929573
     /* 1929573 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1929659), // Rule ID 23989 //
     /* 1929578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929624 */     // MIs[0] policy
     /* 1929624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929658 */     // GIR_Coverage, 23989,
     /* 1929658 */     GIR_EraseRootFromParent_Done,
     /* 1929659 */   // Label 25946: @1929659
     /* 1929659 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1929745), // Rule ID 23992 //
     /* 1929664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929710 */     // MIs[0] policy
     /* 1929710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929744 */     // GIR_Coverage, 23992,
     /* 1929744 */     GIR_EraseRootFromParent_Done,
     /* 1929745 */   // Label 25947: @1929745
     /* 1929745 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1929831), // Rule ID 23993 //
     /* 1929750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929796 */     // MIs[0] policy
     /* 1929796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929806 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11604:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929830 */     // GIR_Coverage, 23993,
     /* 1929830 */     GIR_EraseRootFromParent_Done,
     /* 1929831 */   // Label 25948: @1929831
     /* 1929831 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1929917), // Rule ID 23996 //
     /* 1929836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929882 */     // MIs[0] policy
     /* 1929882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929916 */     // GIR_Coverage, 23996,
     /* 1929916 */     GIR_EraseRootFromParent_Done,
     /* 1929917 */   // Label 25949: @1929917
     /* 1929917 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1930003), // Rule ID 23997 //
     /* 1929922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929968 */     // MIs[0] policy
     /* 1929968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930002 */     // GIR_Coverage, 23997,
     /* 1930002 */     GIR_EraseRootFromParent_Done,
     /* 1930003 */   // Label 25950: @1930003
     /* 1930003 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1930089), // Rule ID 24000 //
     /* 1930008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930054 */     // MIs[0] policy
     /* 1930054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930088 */     // GIR_Coverage, 24000,
     /* 1930088 */     GIR_EraseRootFromParent_Done,
     /* 1930089 */   // Label 25951: @1930089
     /* 1930089 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1930175), // Rule ID 24001 //
     /* 1930094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1930105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1930108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1930111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930140 */     // MIs[0] policy
     /* 1930140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930174 */     // GIR_Coverage, 24001,
     /* 1930174 */     GIR_EraseRootFromParent_Done,
     /* 1930175 */   // Label 25952: @1930175
     /* 1930175 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1930261), // Rule ID 24004 //
     /* 1930180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1930183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930226 */     // MIs[0] policy
     /* 1930226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930236 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930260 */     // GIR_Coverage, 24004,
     /* 1930260 */     GIR_EraseRootFromParent_Done,
     /* 1930261 */   // Label 25953: @1930261
     /* 1930261 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1930347), // Rule ID 24005 //
     /* 1930266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1930269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930312 */     // MIs[0] policy
     /* 1930312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930322 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1930325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930346 */     // GIR_Coverage, 24005,
     /* 1930346 */     GIR_EraseRootFromParent_Done,
     /* 1930347 */   // Label 25954: @1930347
     /* 1930347 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1930433), // Rule ID 24008 //
     /* 1930352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1930363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1930366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930398 */     // MIs[0] policy
     /* 1930398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930432 */     // GIR_Coverage, 24008,
     /* 1930432 */     GIR_EraseRootFromParent_Done,
     /* 1930433 */   // Label 25955: @1930433
     /* 1930433 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1930519), // Rule ID 24009 //
     /* 1930438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1930449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1930452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1930455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930484 */     // MIs[0] policy
     /* 1930484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930518 */     // GIR_Coverage, 24009,
     /* 1930518 */     GIR_EraseRootFromParent_Done,
     /* 1930519 */   // Label 25956: @1930519
     /* 1930519 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1930605), // Rule ID 24012 //
     /* 1930524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930570 */     // MIs[0] policy
     /* 1930570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930604 */     // GIR_Coverage, 24012,
     /* 1930604 */     GIR_EraseRootFromParent_Done,
     /* 1930605 */   // Label 25957: @1930605
     /* 1930605 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1930691), // Rule ID 24013 //
     /* 1930610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930656 */     // MIs[0] policy
     /* 1930656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930690 */     // GIR_Coverage, 24013,
     /* 1930690 */     GIR_EraseRootFromParent_Done,
     /* 1930691 */   // Label 25958: @1930691
     /* 1930691 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1930777), // Rule ID 24016 //
     /* 1930696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930742 */     // MIs[0] policy
     /* 1930742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930776 */     // GIR_Coverage, 24016,
     /* 1930776 */     GIR_EraseRootFromParent_Done,
     /* 1930777 */   // Label 25959: @1930777
     /* 1930777 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1930863), // Rule ID 24017 //
     /* 1930782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930828 */     // MIs[0] policy
     /* 1930828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930862 */     // GIR_Coverage, 24017,
     /* 1930862 */     GIR_EraseRootFromParent_Done,
     /* 1930863 */   // Label 25960: @1930863
     /* 1930863 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1930949), // Rule ID 24020 //
     /* 1930868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930914 */     // MIs[0] policy
     /* 1930914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930948 */     // GIR_Coverage, 24020,
     /* 1930948 */     GIR_EraseRootFromParent_Done,
     /* 1930949 */   // Label 25961: @1930949
     /* 1930949 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1931035), // Rule ID 24021 //
     /* 1930954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931000 */     // MIs[0] policy
     /* 1931000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931034 */     // GIR_Coverage, 24021,
     /* 1931034 */     GIR_EraseRootFromParent_Done,
     /* 1931035 */   // Label 25962: @1931035
     /* 1931035 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1931121), // Rule ID 24024 //
     /* 1931040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931086 */     // MIs[0] policy
     /* 1931086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931120 */     // GIR_Coverage, 24024,
     /* 1931120 */     GIR_EraseRootFromParent_Done,
     /* 1931121 */   // Label 25963: @1931121
     /* 1931121 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1931207), // Rule ID 24025 //
     /* 1931126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1931137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1931140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1931143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931172 */     // MIs[0] policy
     /* 1931172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931206 */     // GIR_Coverage, 24025,
     /* 1931206 */     GIR_EraseRootFromParent_Done,
     /* 1931207 */   // Label 25964: @1931207
     /* 1931207 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1931293), // Rule ID 24028 //
     /* 1931212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1931223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1931226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1931229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931258 */     // MIs[0] policy
     /* 1931258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931292 */     // GIR_Coverage, 24028,
     /* 1931292 */     GIR_EraseRootFromParent_Done,
     /* 1931293 */   // Label 25965: @1931293
     /* 1931293 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1931379), // Rule ID 24029 //
     /* 1931298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1931309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1931312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1931315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931344 */     // MIs[0] policy
     /* 1931344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931354 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931378 */     // GIR_Coverage, 24029,
     /* 1931378 */     GIR_EraseRootFromParent_Done,
     /* 1931379 */   // Label 25966: @1931379
     /* 1931379 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1931465), // Rule ID 24032 //
     /* 1931384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931430 */     // MIs[0] policy
     /* 1931430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931464 */     // GIR_Coverage, 24032,
     /* 1931464 */     GIR_EraseRootFromParent_Done,
     /* 1931465 */   // Label 25967: @1931465
     /* 1931465 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1931551), // Rule ID 24033 //
     /* 1931470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931516 */     // MIs[0] policy
     /* 1931516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931550 */     // GIR_Coverage, 24033,
     /* 1931550 */     GIR_EraseRootFromParent_Done,
     /* 1931551 */   // Label 25968: @1931551
     /* 1931551 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1931637), // Rule ID 24036 //
     /* 1931556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931602 */     // MIs[0] policy
     /* 1931602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931612 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931636 */     // GIR_Coverage, 24036,
     /* 1931636 */     GIR_EraseRootFromParent_Done,
     /* 1931637 */   // Label 25969: @1931637
     /* 1931637 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1931723), // Rule ID 24037 //
     /* 1931642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931688 */     // MIs[0] policy
     /* 1931688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931722 */     // GIR_Coverage, 24037,
     /* 1931722 */     GIR_EraseRootFromParent_Done,
     /* 1931723 */   // Label 25970: @1931723
     /* 1931723 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1931809), // Rule ID 24040 //
     /* 1931728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931774 */     // MIs[0] policy
     /* 1931774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931808 */     // GIR_Coverage, 24040,
     /* 1931808 */     GIR_EraseRootFromParent_Done,
     /* 1931809 */   // Label 25971: @1931809
     /* 1931809 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1931895), // Rule ID 24041 //
     /* 1931814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931860 */     // MIs[0] policy
     /* 1931860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931894 */     // GIR_Coverage, 24041,
     /* 1931894 */     GIR_EraseRootFromParent_Done,
     /* 1931895 */   // Label 25972: @1931895
     /* 1931895 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1931981), // Rule ID 24044 //
     /* 1931900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931946 */     // MIs[0] policy
     /* 1931946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931980 */     // GIR_Coverage, 24044,
     /* 1931980 */     GIR_EraseRootFromParent_Done,
     /* 1931981 */   // Label 25973: @1931981
     /* 1931981 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1932067), // Rule ID 24045 //
     /* 1931986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1932000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1932003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932032 */     // MIs[0] policy
     /* 1932032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1932045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932066 */     // GIR_Coverage, 24045,
     /* 1932066 */     GIR_EraseRootFromParent_Done,
     /* 1932067 */   // Label 25974: @1932067
     /* 1932067 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1932153), // Rule ID 24048 //
     /* 1932072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932118 */     // MIs[0] policy
     /* 1932118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932128 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1932131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932152 */     // GIR_Coverage, 24048,
     /* 1932152 */     GIR_EraseRootFromParent_Done,
     /* 1932153 */   // Label 25975: @1932153
     /* 1932153 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1932239), // Rule ID 24049 //
     /* 1932158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1932169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1932172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1932175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932204 */     // MIs[0] policy
     /* 1932204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1932217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932238 */     // GIR_Coverage, 24049,
     /* 1932238 */     GIR_EraseRootFromParent_Done,
     /* 1932239 */   // Label 25976: @1932239
     /* 1932239 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1932325), // Rule ID 24052 //
     /* 1932244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1932255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1932258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1932261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932290 */     // MIs[0] policy
     /* 1932290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932300 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1932303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932324 */     // GIR_Coverage, 24052,
     /* 1932324 */     GIR_EraseRootFromParent_Done,
     /* 1932325 */   // Label 25977: @1932325
     /* 1932325 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1932411), // Rule ID 24053 //
     /* 1932330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1932333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1932338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1932341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1932344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1932347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932376 */     // MIs[0] policy
     /* 1932376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1932389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932410 */     // GIR_Coverage, 24053,
     /* 1932410 */     GIR_EraseRootFromParent_Done,
     /* 1932411 */   // Label 25978: @1932411
     /* 1932411 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1932497), // Rule ID 24056 //
     /* 1932416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932462 */     // MIs[0] policy
     /* 1932462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932496 */     // GIR_Coverage, 24056,
     /* 1932496 */     GIR_EraseRootFromParent_Done,
     /* 1932497 */   // Label 25979: @1932497
     /* 1932497 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1932583), // Rule ID 24057 //
     /* 1932502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932548 */     // MIs[0] policy
     /* 1932548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932582 */     // GIR_Coverage, 24057,
     /* 1932582 */     GIR_EraseRootFromParent_Done,
     /* 1932583 */   // Label 25980: @1932583
     /* 1932583 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1932669), // Rule ID 24060 //
     /* 1932588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932634 */     // MIs[0] policy
     /* 1932634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932644 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932668 */     // GIR_Coverage, 24060,
     /* 1932668 */     GIR_EraseRootFromParent_Done,
     /* 1932669 */   // Label 25981: @1932669
     /* 1932669 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1932755), // Rule ID 24061 //
     /* 1932674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932720 */     // MIs[0] policy
     /* 1932720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932754 */     // GIR_Coverage, 24061,
     /* 1932754 */     GIR_EraseRootFromParent_Done,
     /* 1932755 */   // Label 25982: @1932755
     /* 1932755 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1932841), // Rule ID 24064 //
     /* 1932760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932806 */     // MIs[0] policy
     /* 1932806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932840 */     // GIR_Coverage, 24064,
     /* 1932840 */     GIR_EraseRootFromParent_Done,
     /* 1932841 */   // Label 25983: @1932841
     /* 1932841 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1932927), // Rule ID 24065 //
     /* 1932846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932892 */     // MIs[0] policy
     /* 1932892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932926 */     // GIR_Coverage, 24065,
     /* 1932926 */     GIR_EraseRootFromParent_Done,
     /* 1932927 */   // Label 25984: @1932927
     /* 1932927 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1933013), // Rule ID 24068 //
     /* 1932932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932978 */     // MIs[0] policy
     /* 1932978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932988 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933012 */     // GIR_Coverage, 24068,
     /* 1933012 */     GIR_EraseRootFromParent_Done,
     /* 1933013 */   // Label 25985: @1933013
     /* 1933013 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1933099), // Rule ID 24069 //
     /* 1933018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933064 */     // MIs[0] policy
     /* 1933064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1933077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933098 */     // GIR_Coverage, 24069,
     /* 1933098 */     GIR_EraseRootFromParent_Done,
     /* 1933099 */   // Label 25986: @1933099
     /* 1933099 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1933185), // Rule ID 24072 //
     /* 1933104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933150 */     // MIs[0] policy
     /* 1933150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933184 */     // GIR_Coverage, 24072,
     /* 1933184 */     GIR_EraseRootFromParent_Done,
     /* 1933185 */   // Label 25987: @1933185
     /* 1933185 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1933271), // Rule ID 24073 //
     /* 1933190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933236 */     // MIs[0] policy
     /* 1933236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933270 */     // GIR_Coverage, 24073,
     /* 1933270 */     GIR_EraseRootFromParent_Done,
     /* 1933271 */   // Label 25988: @1933271
     /* 1933271 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1933357), // Rule ID 24076 //
     /* 1933276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933322 */     // MIs[0] policy
     /* 1933322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933356 */     // GIR_Coverage, 24076,
     /* 1933356 */     GIR_EraseRootFromParent_Done,
     /* 1933357 */   // Label 25989: @1933357
     /* 1933357 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1933443), // Rule ID 24077 //
     /* 1933362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933408 */     // MIs[0] policy
     /* 1933408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1933421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933442 */     // GIR_Coverage, 24077,
     /* 1933442 */     GIR_EraseRootFromParent_Done,
     /* 1933443 */   // Label 25990: @1933443
     /* 1933443 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1933529), // Rule ID 24080 //
     /* 1933448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933494 */     // MIs[0] policy
     /* 1933494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933528 */     // GIR_Coverage, 24080,
     /* 1933528 */     GIR_EraseRootFromParent_Done,
     /* 1933529 */   // Label 25991: @1933529
     /* 1933529 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1933615), // Rule ID 24081 //
     /* 1933534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933580 */     // MIs[0] policy
     /* 1933580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933614 */     // GIR_Coverage, 24081,
     /* 1933614 */     GIR_EraseRootFromParent_Done,
     /* 1933615 */   // Label 25992: @1933615
     /* 1933615 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1933701), // Rule ID 24084 //
     /* 1933620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933666 */     // MIs[0] policy
     /* 1933666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933700 */     // GIR_Coverage, 24084,
     /* 1933700 */     GIR_EraseRootFromParent_Done,
     /* 1933701 */   // Label 25993: @1933701
     /* 1933701 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1933787), // Rule ID 24085 //
     /* 1933706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933752 */     // MIs[0] policy
     /* 1933752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933786 */     // GIR_Coverage, 24085,
     /* 1933786 */     GIR_EraseRootFromParent_Done,
     /* 1933787 */   // Label 25994: @1933787
     /* 1933787 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1933873), // Rule ID 24088 //
     /* 1933792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933838 */     // MIs[0] policy
     /* 1933838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933848 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933872 */     // GIR_Coverage, 24088,
     /* 1933872 */     GIR_EraseRootFromParent_Done,
     /* 1933873 */   // Label 25995: @1933873
     /* 1933873 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1933959), // Rule ID 24089 //
     /* 1933878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933924 */     // MIs[0] policy
     /* 1933924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933958 */     // GIR_Coverage, 24089,
     /* 1933958 */     GIR_EraseRootFromParent_Done,
     /* 1933959 */   // Label 25996: @1933959
     /* 1933959 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1934045), // Rule ID 24092 //
     /* 1933964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934010 */     // MIs[0] policy
     /* 1934010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1934023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934044 */     // GIR_Coverage, 24092,
     /* 1934044 */     GIR_EraseRootFromParent_Done,
     /* 1934045 */   // Label 25997: @1934045
     /* 1934045 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1934131), // Rule ID 24093 //
     /* 1934050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1934053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934096 */     // MIs[0] policy
     /* 1934096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1934109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934130 */     // GIR_Coverage, 24093,
     /* 1934130 */     GIR_EraseRootFromParent_Done,
     /* 1934131 */   // Label 25998: @1934131
     /* 1934131 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1934217), // Rule ID 24096 //
     /* 1934136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1934147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1934150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1934153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934182 */     // MIs[0] policy
     /* 1934182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934216 */     // GIR_Coverage, 24096,
     /* 1934216 */     GIR_EraseRootFromParent_Done,
     /* 1934217 */   // Label 25999: @1934217
     /* 1934217 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1934303), // Rule ID 24097 //
     /* 1934222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1934233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1934236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1934239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934268 */     // MIs[0] policy
     /* 1934268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934302 */     // GIR_Coverage, 24097,
     /* 1934302 */     GIR_EraseRootFromParent_Done,
     /* 1934303 */   // Label 26000: @1934303
     /* 1934303 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1934389), // Rule ID 24100 //
     /* 1934308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1934319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1934322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1934325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934354 */     // MIs[0] policy
     /* 1934354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934388 */     // GIR_Coverage, 24100,
     /* 1934388 */     GIR_EraseRootFromParent_Done,
     /* 1934389 */   // Label 26001: @1934389
     /* 1934389 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1934475), // Rule ID 24101 //
     /* 1934394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1934405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1934408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1934411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934440 */     // MIs[0] policy
     /* 1934440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934474 */     // GIR_Coverage, 24101,
     /* 1934474 */     GIR_EraseRootFromParent_Done,
     /* 1934475 */   // Label 26002: @1934475
     /* 1934475 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1934561), // Rule ID 24104 //
     /* 1934480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934526 */     // MIs[0] policy
     /* 1934526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934536 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934560 */     // GIR_Coverage, 24104,
     /* 1934560 */     GIR_EraseRootFromParent_Done,
     /* 1934561 */   // Label 26003: @1934561
     /* 1934561 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1934647), // Rule ID 24105 //
     /* 1934566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934612 */     // MIs[0] policy
     /* 1934612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934622 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934646 */     // GIR_Coverage, 24105,
     /* 1934646 */     GIR_EraseRootFromParent_Done,
     /* 1934647 */   // Label 26004: @1934647
     /* 1934647 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1934733), // Rule ID 24108 //
     /* 1934652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934698 */     // MIs[0] policy
     /* 1934698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934732 */     // GIR_Coverage, 24108,
     /* 1934732 */     GIR_EraseRootFromParent_Done,
     /* 1934733 */   // Label 26005: @1934733
     /* 1934733 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1934819), // Rule ID 24109 //
     /* 1934738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934784 */     // MIs[0] policy
     /* 1934784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934818 */     // GIR_Coverage, 24109,
     /* 1934818 */     GIR_EraseRootFromParent_Done,
     /* 1934819 */   // Label 26006: @1934819
     /* 1934819 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1934905), // Rule ID 24112 //
     /* 1934824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934870 */     // MIs[0] policy
     /* 1934870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934880 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934904 */     // GIR_Coverage, 24112,
     /* 1934904 */     GIR_EraseRootFromParent_Done,
     /* 1934905 */   // Label 26007: @1934905
     /* 1934905 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1934991), // Rule ID 24113 //
     /* 1934910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934956 */     // MIs[0] policy
     /* 1934956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934990 */     // GIR_Coverage, 24113,
     /* 1934990 */     GIR_EraseRootFromParent_Done,
     /* 1934991 */   // Label 26008: @1934991
     /* 1934991 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1935077), // Rule ID 24116 //
     /* 1934996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935042 */     // MIs[0] policy
     /* 1935042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935052 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935076 */     // GIR_Coverage, 24116,
     /* 1935076 */     GIR_EraseRootFromParent_Done,
     /* 1935077 */   // Label 26009: @1935077
     /* 1935077 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1935163), // Rule ID 24117 //
     /* 1935082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935128 */     // MIs[0] policy
     /* 1935128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935138 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935162 */     // GIR_Coverage, 24117,
     /* 1935162 */     GIR_EraseRootFromParent_Done,
     /* 1935163 */   // Label 26010: @1935163
     /* 1935163 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1935249), // Rule ID 24120 //
     /* 1935168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935214 */     // MIs[0] policy
     /* 1935214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935248 */     // GIR_Coverage, 24120,
     /* 1935248 */     GIR_EraseRootFromParent_Done,
     /* 1935249 */   // Label 26011: @1935249
     /* 1935249 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1935335), // Rule ID 24121 //
     /* 1935254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935300 */     // MIs[0] policy
     /* 1935300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935334 */     // GIR_Coverage, 24121,
     /* 1935334 */     GIR_EraseRootFromParent_Done,
     /* 1935335 */   // Label 26012: @1935335
     /* 1935335 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1935421), // Rule ID 24124 //
     /* 1935340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935386 */     // MIs[0] policy
     /* 1935386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935420 */     // GIR_Coverage, 24124,
     /* 1935420 */     GIR_EraseRootFromParent_Done,
     /* 1935421 */   // Label 26013: @1935421
     /* 1935421 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1935507), // Rule ID 24125 //
     /* 1935426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935472 */     // MIs[0] policy
     /* 1935472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935506 */     // GIR_Coverage, 24125,
     /* 1935506 */     GIR_EraseRootFromParent_Done,
     /* 1935507 */   // Label 26014: @1935507
     /* 1935507 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1935593), // Rule ID 24128 //
     /* 1935512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935558 */     // MIs[0] policy
     /* 1935558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935592 */     // GIR_Coverage, 24128,
     /* 1935592 */     GIR_EraseRootFromParent_Done,
     /* 1935593 */   // Label 26015: @1935593
     /* 1935593 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1935679), // Rule ID 24129 //
     /* 1935598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935644 */     // MIs[0] policy
     /* 1935644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935678 */     // GIR_Coverage, 24129,
     /* 1935678 */     GIR_EraseRootFromParent_Done,
     /* 1935679 */   // Label 26016: @1935679
     /* 1935679 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1935765), // Rule ID 24132 //
     /* 1935684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935730 */     // MIs[0] policy
     /* 1935730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935764 */     // GIR_Coverage, 24132,
     /* 1935764 */     GIR_EraseRootFromParent_Done,
     /* 1935765 */   // Label 26017: @1935765
     /* 1935765 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1935851), // Rule ID 24133 //
     /* 1935770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935816 */     // MIs[0] policy
     /* 1935816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935850 */     // GIR_Coverage, 24133,
     /* 1935850 */     GIR_EraseRootFromParent_Done,
     /* 1935851 */   // Label 26018: @1935851
     /* 1935851 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1935937), // Rule ID 24136 //
     /* 1935856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935902 */     // MIs[0] policy
     /* 1935902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935912 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935936 */     // GIR_Coverage, 24136,
     /* 1935936 */     GIR_EraseRootFromParent_Done,
     /* 1935937 */   // Label 26019: @1935937
     /* 1935937 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1936023), // Rule ID 24137 //
     /* 1935942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935988 */     // MIs[0] policy
     /* 1935988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1936001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936022 */     // GIR_Coverage, 24137,
     /* 1936022 */     GIR_EraseRootFromParent_Done,
     /* 1936023 */   // Label 26020: @1936023
     /* 1936023 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1936109), // Rule ID 24140 //
     /* 1936028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1936031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936074 */     // MIs[0] policy
     /* 1936074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936084 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1936087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936108 */     // GIR_Coverage, 24140,
     /* 1936108 */     GIR_EraseRootFromParent_Done,
     /* 1936109 */   // Label 26021: @1936109
     /* 1936109 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1936195), // Rule ID 24141 //
     /* 1936114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1936117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1936122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936160 */     // MIs[0] policy
     /* 1936160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936170 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1936173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936194 */     // GIR_Coverage, 24141,
     /* 1936194 */     GIR_EraseRootFromParent_Done,
     /* 1936195 */   // Label 26022: @1936195
     /* 1936195 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1936281), // Rule ID 24144 //
     /* 1936200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936246 */     // MIs[0] policy
     /* 1936246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936256 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1936259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936280 */     // GIR_Coverage, 24144,
     /* 1936280 */     GIR_EraseRootFromParent_Done,
     /* 1936281 */   // Label 26023: @1936281
     /* 1936281 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1936367), // Rule ID 24145 //
     /* 1936286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936332 */     // MIs[0] policy
     /* 1936332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936342 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1936345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936366 */     // GIR_Coverage, 24145,
     /* 1936366 */     GIR_EraseRootFromParent_Done,
     /* 1936367 */   // Label 26024: @1936367
     /* 1936367 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1936453), // Rule ID 24148 //
     /* 1936372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936418 */     // MIs[0] policy
     /* 1936418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936428 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936452 */     // GIR_Coverage, 24148,
     /* 1936452 */     GIR_EraseRootFromParent_Done,
     /* 1936453 */   // Label 26025: @1936453
     /* 1936453 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1936539), // Rule ID 24149 //
     /* 1936458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936504 */     // MIs[0] policy
     /* 1936504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936514 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936538 */     // GIR_Coverage, 24149,
     /* 1936538 */     GIR_EraseRootFromParent_Done,
     /* 1936539 */   // Label 26026: @1936539
     /* 1936539 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1936625), // Rule ID 24152 //
     /* 1936544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936590 */     // MIs[0] policy
     /* 1936590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936624 */     // GIR_Coverage, 24152,
     /* 1936624 */     GIR_EraseRootFromParent_Done,
     /* 1936625 */   // Label 26027: @1936625
     /* 1936625 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1936711), // Rule ID 24153 //
     /* 1936630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936676 */     // MIs[0] policy
     /* 1936676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936686 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936710 */     // GIR_Coverage, 24153,
     /* 1936710 */     GIR_EraseRootFromParent_Done,
     /* 1936711 */   // Label 26028: @1936711
     /* 1936711 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1936797), // Rule ID 24156 //
     /* 1936716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936762 */     // MIs[0] policy
     /* 1936762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936796 */     // GIR_Coverage, 24156,
     /* 1936796 */     GIR_EraseRootFromParent_Done,
     /* 1936797 */   // Label 26029: @1936797
     /* 1936797 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1936883), // Rule ID 24157 //
     /* 1936802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936848 */     // MIs[0] policy
     /* 1936848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936858 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936882 */     // GIR_Coverage, 24157,
     /* 1936882 */     GIR_EraseRootFromParent_Done,
     /* 1936883 */   // Label 26030: @1936883
     /* 1936883 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1936969), // Rule ID 24160 //
     /* 1936888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1936891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936934 */     // MIs[0] policy
     /* 1936934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936968 */     // GIR_Coverage, 24160,
     /* 1936968 */     GIR_EraseRootFromParent_Done,
     /* 1936969 */   // Label 26031: @1936969
     /* 1936969 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1937055), // Rule ID 24161 //
     /* 1936974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1936977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937020 */     // MIs[0] policy
     /* 1937020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937030 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937054 */     // GIR_Coverage, 24161,
     /* 1937054 */     GIR_EraseRootFromParent_Done,
     /* 1937055 */   // Label 26032: @1937055
     /* 1937055 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1937141), // Rule ID 24164 //
     /* 1937060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1937063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937106 */     // MIs[0] policy
     /* 1937106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937140 */     // GIR_Coverage, 24164,
     /* 1937140 */     GIR_EraseRootFromParent_Done,
     /* 1937141 */   // Label 26033: @1937141
     /* 1937141 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1937227), // Rule ID 24165 //
     /* 1937146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1937149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937192 */     // MIs[0] policy
     /* 1937192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937202 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1937205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937226 */     // GIR_Coverage, 24165,
     /* 1937226 */     GIR_EraseRootFromParent_Done,
     /* 1937227 */   // Label 26034: @1937227
     /* 1937227 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1937313), // Rule ID 24168 //
     /* 1937232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937278 */     // MIs[0] policy
     /* 1937278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937288 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937312 */     // GIR_Coverage, 24168,
     /* 1937312 */     GIR_EraseRootFromParent_Done,
     /* 1937313 */   // Label 26035: @1937313
     /* 1937313 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1937399), // Rule ID 24169 //
     /* 1937318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937364 */     // MIs[0] policy
     /* 1937364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937374 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937398 */     // GIR_Coverage, 24169,
     /* 1937398 */     GIR_EraseRootFromParent_Done,
     /* 1937399 */   // Label 26036: @1937399
     /* 1937399 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1937485), // Rule ID 24172 //
     /* 1937404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937450 */     // MIs[0] policy
     /* 1937450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937460 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937484 */     // GIR_Coverage, 24172,
     /* 1937484 */     GIR_EraseRootFromParent_Done,
     /* 1937485 */   // Label 26037: @1937485
     /* 1937485 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1937571), // Rule ID 24173 //
     /* 1937490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937536 */     // MIs[0] policy
     /* 1937536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937546 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937570 */     // GIR_Coverage, 24173,
     /* 1937570 */     GIR_EraseRootFromParent_Done,
     /* 1937571 */   // Label 26038: @1937571
     /* 1937571 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1937657), // Rule ID 24176 //
     /* 1937576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937622 */     // MIs[0] policy
     /* 1937622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937632 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937656 */     // GIR_Coverage, 24176,
     /* 1937656 */     GIR_EraseRootFromParent_Done,
     /* 1937657 */   // Label 26039: @1937657
     /* 1937657 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1937743), // Rule ID 24177 //
     /* 1937662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937708 */     // MIs[0] policy
     /* 1937708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937718 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937742 */     // GIR_Coverage, 24177,
     /* 1937742 */     GIR_EraseRootFromParent_Done,
     /* 1937743 */   // Label 26040: @1937743
     /* 1937743 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1937829), // Rule ID 24180 //
     /* 1937748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937794 */     // MIs[0] policy
     /* 1937794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937804 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937828 */     // GIR_Coverage, 24180,
     /* 1937828 */     GIR_EraseRootFromParent_Done,
     /* 1937829 */   // Label 26041: @1937829
     /* 1937829 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1937915), // Rule ID 24181 //
     /* 1937834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1937837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937880 */     // MIs[0] policy
     /* 1937880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937890 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937914 */     // GIR_Coverage, 24181,
     /* 1937914 */     GIR_EraseRootFromParent_Done,
     /* 1937915 */   // Label 26042: @1937915
     /* 1937915 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1938001), // Rule ID 24184 //
     /* 1937920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1937923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937966 */     // MIs[0] policy
     /* 1937966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937976 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938000 */     // GIR_Coverage, 24184,
     /* 1938000 */     GIR_EraseRootFromParent_Done,
     /* 1938001 */   // Label 26043: @1938001
     /* 1938001 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1938087), // Rule ID 24185 //
     /* 1938006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938052 */     // MIs[0] policy
     /* 1938052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938086 */     // GIR_Coverage, 24185,
     /* 1938086 */     GIR_EraseRootFromParent_Done,
     /* 1938087 */   // Label 26044: @1938087
     /* 1938087 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1938173), // Rule ID 24188 //
     /* 1938092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938138 */     // MIs[0] policy
     /* 1938138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938148 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938172 */     // GIR_Coverage, 24188,
     /* 1938172 */     GIR_EraseRootFromParent_Done,
     /* 1938173 */   // Label 26045: @1938173
     /* 1938173 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1938259), // Rule ID 24189 //
     /* 1938178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938224 */     // MIs[0] policy
     /* 1938224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938234 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938258 */     // GIR_Coverage, 24189,
     /* 1938258 */     GIR_EraseRootFromParent_Done,
     /* 1938259 */   // Label 26046: @1938259
     /* 1938259 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1938345), // Rule ID 24192 //
     /* 1938264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938310 */     // MIs[0] policy
     /* 1938310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938320 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1938323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938344 */     // GIR_Coverage, 24192,
     /* 1938344 */     GIR_EraseRootFromParent_Done,
     /* 1938345 */   // Label 26047: @1938345
     /* 1938345 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1938431), // Rule ID 24193 //
     /* 1938350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938396 */     // MIs[0] policy
     /* 1938396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1938409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938430 */     // GIR_Coverage, 24193,
     /* 1938430 */     GIR_EraseRootFromParent_Done,
     /* 1938431 */   // Label 26048: @1938431
     /* 1938431 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1938517), // Rule ID 24196 //
     /* 1938436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938482 */     // MIs[0] policy
     /* 1938482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938492 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938516 */     // GIR_Coverage, 24196,
     /* 1938516 */     GIR_EraseRootFromParent_Done,
     /* 1938517 */   // Label 26049: @1938517
     /* 1938517 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1938603), // Rule ID 24197 //
     /* 1938522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938568 */     // MIs[0] policy
     /* 1938568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938578 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938602 */     // GIR_Coverage, 24197,
     /* 1938602 */     GIR_EraseRootFromParent_Done,
     /* 1938603 */   // Label 26050: @1938603
     /* 1938603 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1938689), // Rule ID 24200 //
     /* 1938608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1938611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938654 */     // MIs[0] policy
     /* 1938654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938688 */     // GIR_Coverage, 24200,
     /* 1938688 */     GIR_EraseRootFromParent_Done,
     /* 1938689 */   // Label 26051: @1938689
     /* 1938689 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1938775), // Rule ID 24201 //
     /* 1938694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1938697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938740 */     // MIs[0] policy
     /* 1938740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938774 */     // GIR_Coverage, 24201,
     /* 1938774 */     GIR_EraseRootFromParent_Done,
     /* 1938775 */   // Label 26052: @1938775
     /* 1938775 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1938861), // Rule ID 24264 //
     /* 1938780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938826 */     // MIs[0] policy
     /* 1938826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938860 */     // GIR_Coverage, 24264,
     /* 1938860 */     GIR_EraseRootFromParent_Done,
     /* 1938861 */   // Label 26053: @1938861
     /* 1938861 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1938947), // Rule ID 24265 //
     /* 1938866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1938869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938912 */     // MIs[0] policy
     /* 1938912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938922 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938946 */     // GIR_Coverage, 24265,
     /* 1938946 */     GIR_EraseRootFromParent_Done,
     /* 1938947 */   // Label 26054: @1938947
     /* 1938947 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1939033), // Rule ID 24268 //
     /* 1938952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1938955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938998 */     // MIs[0] policy
     /* 1938998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939008 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939032 */     // GIR_Coverage, 24268,
     /* 1939032 */     GIR_EraseRootFromParent_Done,
     /* 1939033 */   // Label 26055: @1939033
     /* 1939033 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1939119), // Rule ID 24269 //
     /* 1939038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1939049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1939052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1939055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939084 */     // MIs[0] policy
     /* 1939084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939094 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939118 */     // GIR_Coverage, 24269,
     /* 1939118 */     GIR_EraseRootFromParent_Done,
     /* 1939119 */   // Label 26056: @1939119
     /* 1939119 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1939205), // Rule ID 24272 //
     /* 1939124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939170 */     // MIs[0] policy
     /* 1939170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939180 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939204 */     // GIR_Coverage, 24272,
     /* 1939204 */     GIR_EraseRootFromParent_Done,
     /* 1939205 */   // Label 26057: @1939205
     /* 1939205 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1939291), // Rule ID 24273 //
     /* 1939210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939256 */     // MIs[0] policy
     /* 1939256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939266 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1939269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939290 */     // GIR_Coverage, 24273,
     /* 1939290 */     GIR_EraseRootFromParent_Done,
     /* 1939291 */   // Label 26058: @1939291
     /* 1939291 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1939377), // Rule ID 24276 //
     /* 1939296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939342 */     // MIs[0] policy
     /* 1939342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939376 */     // GIR_Coverage, 24276,
     /* 1939376 */     GIR_EraseRootFromParent_Done,
     /* 1939377 */   // Label 26059: @1939377
     /* 1939377 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1939463), // Rule ID 24277 //
     /* 1939382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939428 */     // MIs[0] policy
     /* 1939428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939438 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939462 */     // GIR_Coverage, 24277,
     /* 1939462 */     GIR_EraseRootFromParent_Done,
     /* 1939463 */   // Label 26060: @1939463
     /* 1939463 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1939549), // Rule ID 24280 //
     /* 1939468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939514 */     // MIs[0] policy
     /* 1939514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939548 */     // GIR_Coverage, 24280,
     /* 1939548 */     GIR_EraseRootFromParent_Done,
     /* 1939549 */   // Label 26061: @1939549
     /* 1939549 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1939635), // Rule ID 24281 //
     /* 1939554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939600 */     // MIs[0] policy
     /* 1939600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939634 */     // GIR_Coverage, 24281,
     /* 1939634 */     GIR_EraseRootFromParent_Done,
     /* 1939635 */   // Label 26062: @1939635
     /* 1939635 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1939721), // Rule ID 24284 //
     /* 1939640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1939643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939686 */     // MIs[0] policy
     /* 1939686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939720 */     // GIR_Coverage, 24284,
     /* 1939720 */     GIR_EraseRootFromParent_Done,
     /* 1939721 */   // Label 26063: @1939721
     /* 1939721 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1939807), // Rule ID 24285 //
     /* 1939726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1939729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939772 */     // MIs[0] policy
     /* 1939772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939806 */     // GIR_Coverage, 24285,
     /* 1939806 */     GIR_EraseRootFromParent_Done,
     /* 1939807 */   // Label 26064: @1939807
     /* 1939807 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1939893), // Rule ID 24288 //
     /* 1939812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939858 */     // MIs[0] policy
     /* 1939858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939868 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939892 */     // GIR_Coverage, 24288,
     /* 1939892 */     GIR_EraseRootFromParent_Done,
     /* 1939893 */   // Label 26065: @1939893
     /* 1939893 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1939979), // Rule ID 24289 //
     /* 1939898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939944 */     // MIs[0] policy
     /* 1939944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939978 */     // GIR_Coverage, 24289,
     /* 1939978 */     GIR_EraseRootFromParent_Done,
     /* 1939979 */   // Label 26066: @1939979
     /* 1939979 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1940065), // Rule ID 24292 //
     /* 1939984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940030 */     // MIs[0] policy
     /* 1940030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940064 */     // GIR_Coverage, 24292,
     /* 1940064 */     GIR_EraseRootFromParent_Done,
     /* 1940065 */   // Label 26067: @1940065
     /* 1940065 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1940151), // Rule ID 24293 //
     /* 1940070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1940081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1940084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1940087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940116 */     // MIs[0] policy
     /* 1940116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940126 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940150 */     // GIR_Coverage, 24293,
     /* 1940150 */     GIR_EraseRootFromParent_Done,
     /* 1940151 */   // Label 26068: @1940151
     /* 1940151 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1940237), // Rule ID 24296 //
     /* 1940156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940202 */     // MIs[0] policy
     /* 1940202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940212 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940236 */     // GIR_Coverage, 24296,
     /* 1940236 */     GIR_EraseRootFromParent_Done,
     /* 1940237 */   // Label 26069: @1940237
     /* 1940237 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1940323), // Rule ID 24297 //
     /* 1940242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940288 */     // MIs[0] policy
     /* 1940288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940298 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940322 */     // GIR_Coverage, 24297,
     /* 1940322 */     GIR_EraseRootFromParent_Done,
     /* 1940323 */   // Label 26070: @1940323
     /* 1940323 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1940409), // Rule ID 24300 //
     /* 1940328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940374 */     // MIs[0] policy
     /* 1940374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940384 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940408 */     // GIR_Coverage, 24300,
     /* 1940408 */     GIR_EraseRootFromParent_Done,
     /* 1940409 */   // Label 26071: @1940409
     /* 1940409 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1940495), // Rule ID 24301 //
     /* 1940414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940460 */     // MIs[0] policy
     /* 1940460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940470 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940494 */     // GIR_Coverage, 24301,
     /* 1940494 */     GIR_EraseRootFromParent_Done,
     /* 1940495 */   // Label 26072: @1940495
     /* 1940495 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1940581), // Rule ID 24304 //
     /* 1940500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940546 */     // MIs[0] policy
     /* 1940546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940580 */     // GIR_Coverage, 24304,
     /* 1940580 */     GIR_EraseRootFromParent_Done,
     /* 1940581 */   // Label 26073: @1940581
     /* 1940581 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1940667), // Rule ID 24305 //
     /* 1940586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940632 */     // MIs[0] policy
     /* 1940632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940642 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940666 */     // GIR_Coverage, 24305,
     /* 1940666 */     GIR_EraseRootFromParent_Done,
     /* 1940667 */   // Label 26074: @1940667
     /* 1940667 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1940753), // Rule ID 24308 //
     /* 1940672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940718 */     // MIs[0] policy
     /* 1940718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940728 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940752 */     // GIR_Coverage, 24308,
     /* 1940752 */     GIR_EraseRootFromParent_Done,
     /* 1940753 */   // Label 26075: @1940753
     /* 1940753 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1940839), // Rule ID 24309 //
     /* 1940758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940804 */     // MIs[0] policy
     /* 1940804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940814 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940838 */     // GIR_Coverage, 24309,
     /* 1940838 */     GIR_EraseRootFromParent_Done,
     /* 1940839 */   // Label 26076: @1940839
     /* 1940839 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1940925), // Rule ID 24312 //
     /* 1940844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1940847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940890 */     // MIs[0] policy
     /* 1940890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940900 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940924 */     // GIR_Coverage, 24312,
     /* 1940924 */     GIR_EraseRootFromParent_Done,
     /* 1940925 */   // Label 26077: @1940925
     /* 1940925 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1941011), // Rule ID 24313 //
     /* 1940930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1940933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940976 */     // MIs[0] policy
     /* 1940976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941010 */     // GIR_Coverage, 24313,
     /* 1941010 */     GIR_EraseRootFromParent_Done,
     /* 1941011 */   // Label 26078: @1941011
     /* 1941011 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1941097), // Rule ID 24316 //
     /* 1941016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941062 */     // MIs[0] policy
     /* 1941062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941072 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1941075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941096 */     // GIR_Coverage, 24316,
     /* 1941096 */     GIR_EraseRootFromParent_Done,
     /* 1941097 */   // Label 26079: @1941097
     /* 1941097 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1941183), // Rule ID 24317 //
     /* 1941102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1941113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1941116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1941119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941148 */     // MIs[0] policy
     /* 1941148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941158 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1941161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941182 */     // GIR_Coverage, 24317,
     /* 1941182 */     GIR_EraseRootFromParent_Done,
     /* 1941183 */   // Label 26080: @1941183
     /* 1941183 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1941269), // Rule ID 24320 //
     /* 1941188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941234 */     // MIs[0] policy
     /* 1941234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941244 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1941247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941268 */     // GIR_Coverage, 24320,
     /* 1941268 */     GIR_EraseRootFromParent_Done,
     /* 1941269 */   // Label 26081: @1941269
     /* 1941269 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1941355), // Rule ID 24321 //
     /* 1941274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1941282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1941316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941320 */     // MIs[0] policy
     /* 1941320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941330 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1941333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1941337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941354 */     // GIR_Coverage, 24321,
     /* 1941354 */     GIR_EraseRootFromParent_Done,
     /* 1941355 */   // Label 26082: @1941355
     /* 1941355 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1941441), // Rule ID 24384 //
     /* 1941360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941406 */     // MIs[0] policy
     /* 1941406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941416 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941440 */     // GIR_Coverage, 24384,
     /* 1941440 */     GIR_EraseRootFromParent_Done,
     /* 1941441 */   // Label 26083: @1941441
     /* 1941441 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1941527), // Rule ID 24385 //
     /* 1941446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941492 */     // MIs[0] policy
     /* 1941492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941502 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941526 */     // GIR_Coverage, 24385,
     /* 1941526 */     GIR_EraseRootFromParent_Done,
     /* 1941527 */   // Label 26084: @1941527
     /* 1941527 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1941613), // Rule ID 24388 //
     /* 1941532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941578 */     // MIs[0] policy
     /* 1941578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941588 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941612 */     // GIR_Coverage, 24388,
     /* 1941612 */     GIR_EraseRootFromParent_Done,
     /* 1941613 */   // Label 26085: @1941613
     /* 1941613 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1941699), // Rule ID 24389 //
     /* 1941618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941664 */     // MIs[0] policy
     /* 1941664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941698 */     // GIR_Coverage, 24389,
     /* 1941698 */     GIR_EraseRootFromParent_Done,
     /* 1941699 */   // Label 26086: @1941699
     /* 1941699 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1941785), // Rule ID 24392 //
     /* 1941704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941750 */     // MIs[0] policy
     /* 1941750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941760 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941784 */     // GIR_Coverage, 24392,
     /* 1941784 */     GIR_EraseRootFromParent_Done,
     /* 1941785 */   // Label 26087: @1941785
     /* 1941785 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1941871), // Rule ID 24393 //
     /* 1941790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941836 */     // MIs[0] policy
     /* 1941836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941846 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941870 */     // GIR_Coverage, 24393,
     /* 1941870 */     GIR_EraseRootFromParent_Done,
     /* 1941871 */   // Label 26088: @1941871
     /* 1941871 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1941957), // Rule ID 24396 //
     /* 1941876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941922 */     // MIs[0] policy
     /* 1941922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941932 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941956 */     // GIR_Coverage, 24396,
     /* 1941956 */     GIR_EraseRootFromParent_Done,
     /* 1941957 */   // Label 26089: @1941957
     /* 1941957 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1942043), // Rule ID 24397 //
     /* 1941962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942008 */     // MIs[0] policy
     /* 1942008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942018 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11330:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1942021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942042 */     // GIR_Coverage, 24397,
     /* 1942042 */     GIR_EraseRootFromParent_Done,
     /* 1942043 */   // Label 26090: @1942043
     /* 1942043 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1942129), // Rule ID 24400 //
     /* 1942048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942094 */     // MIs[0] policy
     /* 1942094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1942107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942128 */     // GIR_Coverage, 24400,
     /* 1942128 */     GIR_EraseRootFromParent_Done,
     /* 1942129 */   // Label 26091: @1942129
     /* 1942129 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1942215), // Rule ID 24401 //
     /* 1942134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942180 */     // MIs[0] policy
     /* 1942180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11330:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1942193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942214 */     // GIR_Coverage, 24401,
     /* 1942214 */     GIR_EraseRootFromParent_Done,
     /* 1942215 */   // Label 26092: @1942215
     /* 1942215 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1942301), // Rule ID 24404 //
     /* 1942220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1942223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942266 */     // MIs[0] policy
     /* 1942266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1942279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942300 */     // GIR_Coverage, 24404,
     /* 1942300 */     GIR_EraseRootFromParent_Done,
     /* 1942301 */   // Label 26093: @1942301
     /* 1942301 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1942387), // Rule ID 24405 //
     /* 1942306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1942309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942352 */     // MIs[0] policy
     /* 1942352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942362 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11330:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1942365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942386 */     // GIR_Coverage, 24405,
     /* 1942386 */     GIR_EraseRootFromParent_Done,
     /* 1942387 */   // Label 26094: @1942387
     /* 1942387 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1942473), // Rule ID 24408 //
     /* 1942392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942438 */     // MIs[0] policy
     /* 1942438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942448 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942472 */     // GIR_Coverage, 24408,
     /* 1942472 */     GIR_EraseRootFromParent_Done,
     /* 1942473 */   // Label 26095: @1942473
     /* 1942473 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1942559), // Rule ID 24409 //
     /* 1942478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942524 */     // MIs[0] policy
     /* 1942524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942558 */     // GIR_Coverage, 24409,
     /* 1942558 */     GIR_EraseRootFromParent_Done,
     /* 1942559 */   // Label 26096: @1942559
     /* 1942559 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1942645), // Rule ID 24412 //
     /* 1942564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942610 */     // MIs[0] policy
     /* 1942610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942620 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942644 */     // GIR_Coverage, 24412,
     /* 1942644 */     GIR_EraseRootFromParent_Done,
     /* 1942645 */   // Label 26097: @1942645
     /* 1942645 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1942731), // Rule ID 24413 //
     /* 1942650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942696 */     // MIs[0] policy
     /* 1942696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942706 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942730 */     // GIR_Coverage, 24413,
     /* 1942730 */     GIR_EraseRootFromParent_Done,
     /* 1942731 */   // Label 26098: @1942731
     /* 1942731 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1942817), // Rule ID 24416 //
     /* 1942736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942782 */     // MIs[0] policy
     /* 1942782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942792 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942816 */     // GIR_Coverage, 24416,
     /* 1942816 */     GIR_EraseRootFromParent_Done,
     /* 1942817 */   // Label 26099: @1942817
     /* 1942817 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1942903), // Rule ID 24417 //
     /* 1942822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942868 */     // MIs[0] policy
     /* 1942868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942878 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942902 */     // GIR_Coverage, 24417,
     /* 1942902 */     GIR_EraseRootFromParent_Done,
     /* 1942903 */   // Label 26100: @1942903
     /* 1942903 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1942989), // Rule ID 24420 //
     /* 1942908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942954 */     // MIs[0] policy
     /* 1942954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942988 */     // GIR_Coverage, 24420,
     /* 1942988 */     GIR_EraseRootFromParent_Done,
     /* 1942989 */   // Label 26101: @1942989
     /* 1942989 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1943075), // Rule ID 24421 //
     /* 1942994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1943005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1943008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1943011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943040 */     // MIs[0] policy
     /* 1943040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1943053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943074 */     // GIR_Coverage, 24421,
     /* 1943074 */     GIR_EraseRootFromParent_Done,
     /* 1943075 */   // Label 26102: @1943075
     /* 1943075 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1943161), // Rule ID 24424 //
     /* 1943080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943126 */     // MIs[0] policy
     /* 1943126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943136 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1943139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943160 */     // GIR_Coverage, 24424,
     /* 1943160 */     GIR_EraseRootFromParent_Done,
     /* 1943161 */   // Label 26103: @1943161
     /* 1943161 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1943247), // Rule ID 24425 //
     /* 1943166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943212 */     // MIs[0] policy
     /* 1943212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1943225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943246 */     // GIR_Coverage, 24425,
     /* 1943246 */     GIR_EraseRootFromParent_Done,
     /* 1943247 */   // Label 26104: @1943247
     /* 1943247 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1943333), // Rule ID 24428 //
     /* 1943252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943298 */     // MIs[0] policy
     /* 1943298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943308 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1943311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943332 */     // GIR_Coverage, 24428,
     /* 1943332 */     GIR_EraseRootFromParent_Done,
     /* 1943333 */   // Label 26105: @1943333
     /* 1943333 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1943419), // Rule ID 24429 //
     /* 1943338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943384 */     // MIs[0] policy
     /* 1943384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943394 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1943397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943418 */     // GIR_Coverage, 24429,
     /* 1943418 */     GIR_EraseRootFromParent_Done,
     /* 1943419 */   // Label 26106: @1943419
     /* 1943419 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1943505), // Rule ID 24432 //
     /* 1943424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943470 */     // MIs[0] policy
     /* 1943470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943504 */     // GIR_Coverage, 24432,
     /* 1943504 */     GIR_EraseRootFromParent_Done,
     /* 1943505 */   // Label 26107: @1943505
     /* 1943505 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1943591), // Rule ID 24433 //
     /* 1943510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943556 */     // MIs[0] policy
     /* 1943556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11330:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943590 */     // GIR_Coverage, 24433,
     /* 1943590 */     GIR_EraseRootFromParent_Done,
     /* 1943591 */   // Label 26108: @1943591
     /* 1943591 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1943677), // Rule ID 24436 //
     /* 1943596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943642 */     // MIs[0] policy
     /* 1943642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943652 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943676 */     // GIR_Coverage, 24436,
     /* 1943676 */     GIR_EraseRootFromParent_Done,
     /* 1943677 */   // Label 26109: @1943677
     /* 1943677 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1943763), // Rule ID 24437 //
     /* 1943682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943728 */     // MIs[0] policy
     /* 1943728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943738 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11330:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943762 */     // GIR_Coverage, 24437,
     /* 1943762 */     GIR_EraseRootFromParent_Done,
     /* 1943763 */   // Label 26110: @1943763
     /* 1943763 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1943849), // Rule ID 24440 //
     /* 1943768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943814 */     // MIs[0] policy
     /* 1943814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943824 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943848 */     // GIR_Coverage, 24440,
     /* 1943848 */     GIR_EraseRootFromParent_Done,
     /* 1943849 */   // Label 26111: @1943849
     /* 1943849 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1943935), // Rule ID 24441 //
     /* 1943854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943900 */     // MIs[0] policy
     /* 1943900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943910 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11330:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943934 */     // GIR_Coverage, 24441,
     /* 1943934 */     GIR_EraseRootFromParent_Done,
     /* 1943935 */   // Label 26112: @1943935
     /* 1943935 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1944021), // Rule ID 24444 //
     /* 1943940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943986 */     // MIs[0] policy
     /* 1943986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1943999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944020 */     // GIR_Coverage, 24444,
     /* 1944020 */     GIR_EraseRootFromParent_Done,
     /* 1944021 */   // Label 26113: @1944021
     /* 1944021 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1944107), // Rule ID 24445 //
     /* 1944026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944072 */     // MIs[0] policy
     /* 1944072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944082 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1944085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944106 */     // GIR_Coverage, 24445,
     /* 1944106 */     GIR_EraseRootFromParent_Done,
     /* 1944107 */   // Label 26114: @1944107
     /* 1944107 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1944193), // Rule ID 24448 //
     /* 1944112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944158 */     // MIs[0] policy
     /* 1944158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944168 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1944171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944192 */     // GIR_Coverage, 24448,
     /* 1944192 */     GIR_EraseRootFromParent_Done,
     /* 1944193 */   // Label 26115: @1944193
     /* 1944193 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1944279), // Rule ID 24449 //
     /* 1944198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944244 */     // MIs[0] policy
     /* 1944244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944254 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1944257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944278 */     // GIR_Coverage, 24449,
     /* 1944278 */     GIR_EraseRootFromParent_Done,
     /* 1944279 */   // Label 26116: @1944279
     /* 1944279 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1944365), // Rule ID 24452 //
     /* 1944284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944330 */     // MIs[0] policy
     /* 1944330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944340 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1944343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944364 */     // GIR_Coverage, 24452,
     /* 1944364 */     GIR_EraseRootFromParent_Done,
     /* 1944365 */   // Label 26117: @1944365
     /* 1944365 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1944451), // Rule ID 24453 //
     /* 1944370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944416 */     // MIs[0] policy
     /* 1944416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944426 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1944429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944450 */     // GIR_Coverage, 24453,
     /* 1944450 */     GIR_EraseRootFromParent_Done,
     /* 1944451 */   // Label 26118: @1944451
     /* 1944451 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1944537), // Rule ID 24456 //
     /* 1944456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944502 */     // MIs[0] policy
     /* 1944502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944512 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944536 */     // GIR_Coverage, 24456,
     /* 1944536 */     GIR_EraseRootFromParent_Done,
     /* 1944537 */   // Label 26119: @1944537
     /* 1944537 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1944623), // Rule ID 24457 //
     /* 1944542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944588 */     // MIs[0] policy
     /* 1944588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944598 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11328:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944622 */     // GIR_Coverage, 24457,
     /* 1944622 */     GIR_EraseRootFromParent_Done,
     /* 1944623 */   // Label 26120: @1944623
     /* 1944623 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1944709), // Rule ID 24460 //
     /* 1944628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944674 */     // MIs[0] policy
     /* 1944674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944708 */     // GIR_Coverage, 24460,
     /* 1944708 */     GIR_EraseRootFromParent_Done,
     /* 1944709 */   // Label 26121: @1944709
     /* 1944709 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1944795), // Rule ID 24461 //
     /* 1944714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944760 */     // MIs[0] policy
     /* 1944760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11328:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944794 */     // GIR_Coverage, 24461,
     /* 1944794 */     GIR_EraseRootFromParent_Done,
     /* 1944795 */   // Label 26122: @1944795
     /* 1944795 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1944881), // Rule ID 24464 //
     /* 1944800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944846 */     // MIs[0] policy
     /* 1944846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944880 */     // GIR_Coverage, 24464,
     /* 1944880 */     GIR_EraseRootFromParent_Done,
     /* 1944881 */   // Label 26123: @1944881
     /* 1944881 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1944967), // Rule ID 24465 //
     /* 1944886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944932 */     // MIs[0] policy
     /* 1944932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11328:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944966 */     // GIR_Coverage, 24465,
     /* 1944966 */     GIR_EraseRootFromParent_Done,
     /* 1944967 */   // Label 26124: @1944967
     /* 1944967 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1945053), // Rule ID 24468 //
     /* 1944972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945018 */     // MIs[0] policy
     /* 1945018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1945031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945052 */     // GIR_Coverage, 24468,
     /* 1945052 */     GIR_EraseRootFromParent_Done,
     /* 1945053 */   // Label 26125: @1945053
     /* 1945053 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1945139), // Rule ID 24469 //
     /* 1945058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945104 */     // MIs[0] policy
     /* 1945104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1945117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945138 */     // GIR_Coverage, 24469,
     /* 1945138 */     GIR_EraseRootFromParent_Done,
     /* 1945139 */   // Label 26126: @1945139
     /* 1945139 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1945225), // Rule ID 24472 //
     /* 1945144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945190 */     // MIs[0] policy
     /* 1945190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945200 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1945203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945224 */     // GIR_Coverage, 24472,
     /* 1945224 */     GIR_EraseRootFromParent_Done,
     /* 1945225 */   // Label 26127: @1945225
     /* 1945225 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1945311), // Rule ID 24473 //
     /* 1945230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945276 */     // MIs[0] policy
     /* 1945276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945286 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1945289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945310 */     // GIR_Coverage, 24473,
     /* 1945310 */     GIR_EraseRootFromParent_Done,
     /* 1945311 */   // Label 26128: @1945311
     /* 1945311 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1945397), // Rule ID 24476 //
     /* 1945316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1945319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945362 */     // MIs[0] policy
     /* 1945362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945372 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1945375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945396 */     // GIR_Coverage, 24476,
     /* 1945396 */     GIR_EraseRootFromParent_Done,
     /* 1945397 */   // Label 26129: @1945397
     /* 1945397 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1945483), // Rule ID 24477 //
     /* 1945402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1945405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1945422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1945444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945448 */     // MIs[0] policy
     /* 1945448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945458 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1945461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945482 */     // GIR_Coverage, 24477,
     /* 1945482 */     GIR_EraseRootFromParent_Done,
     /* 1945483 */   // Label 26130: @1945483
     /* 1945483 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1945569), // Rule ID 24480 //
     /* 1945488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945534 */     // MIs[0] policy
     /* 1945534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945568 */     // GIR_Coverage, 24480,
     /* 1945568 */     GIR_EraseRootFromParent_Done,
     /* 1945569 */   // Label 26131: @1945569
     /* 1945569 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1945655), // Rule ID 24481 //
     /* 1945574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945620 */     // MIs[0] policy
     /* 1945620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945654 */     // GIR_Coverage, 24481,
     /* 1945654 */     GIR_EraseRootFromParent_Done,
     /* 1945655 */   // Label 26132: @1945655
     /* 1945655 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1945741), // Rule ID 24484 //
     /* 1945660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945706 */     // MIs[0] policy
     /* 1945706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945716 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945740 */     // GIR_Coverage, 24484,
     /* 1945740 */     GIR_EraseRootFromParent_Done,
     /* 1945741 */   // Label 26133: @1945741
     /* 1945741 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1945827), // Rule ID 24485 //
     /* 1945746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945792 */     // MIs[0] policy
     /* 1945792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945802 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945826 */     // GIR_Coverage, 24485,
     /* 1945826 */     GIR_EraseRootFromParent_Done,
     /* 1945827 */   // Label 26134: @1945827
     /* 1945827 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1945913), // Rule ID 24488 //
     /* 1945832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945878 */     // MIs[0] policy
     /* 1945878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945888 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945912 */     // GIR_Coverage, 24488,
     /* 1945912 */     GIR_EraseRootFromParent_Done,
     /* 1945913 */   // Label 26135: @1945913
     /* 1945913 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1945999), // Rule ID 24489 //
     /* 1945918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945964 */     // MIs[0] policy
     /* 1945964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945974 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945998 */     // GIR_Coverage, 24489,
     /* 1945998 */     GIR_EraseRootFromParent_Done,
     /* 1945999 */   // Label 26136: @1945999
     /* 1945999 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1946085), // Rule ID 24492 //
     /* 1946004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946050 */     // MIs[0] policy
     /* 1946050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1946063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946084 */     // GIR_Coverage, 24492,
     /* 1946084 */     GIR_EraseRootFromParent_Done,
     /* 1946085 */   // Label 26137: @1946085
     /* 1946085 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1946171), // Rule ID 24493 //
     /* 1946090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946136 */     // MIs[0] policy
     /* 1946136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946146 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11328:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1946149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946170 */     // GIR_Coverage, 24493,
     /* 1946170 */     GIR_EraseRootFromParent_Done,
     /* 1946171 */   // Label 26138: @1946171
     /* 1946171 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1946257), // Rule ID 24496 //
     /* 1946176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946222 */     // MIs[0] policy
     /* 1946222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946232 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1946235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946256 */     // GIR_Coverage, 24496,
     /* 1946256 */     GIR_EraseRootFromParent_Done,
     /* 1946257 */   // Label 26139: @1946257
     /* 1946257 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1946343), // Rule ID 24497 //
     /* 1946262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946308 */     // MIs[0] policy
     /* 1946308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946318 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11328:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1946321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946342 */     // GIR_Coverage, 24497,
     /* 1946342 */     GIR_EraseRootFromParent_Done,
     /* 1946343 */   // Label 26140: @1946343
     /* 1946343 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1946429), // Rule ID 24500 //
     /* 1946348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1946351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946394 */     // MIs[0] policy
     /* 1946394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946404 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946428 */     // GIR_Coverage, 24500,
     /* 1946428 */     GIR_EraseRootFromParent_Done,
     /* 1946429 */   // Label 26141: @1946429
     /* 1946429 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1946515), // Rule ID 24501 //
     /* 1946434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1946437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1946442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946480 */     // MIs[0] policy
     /* 1946480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946490 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11328:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946514 */     // GIR_Coverage, 24501,
     /* 1946514 */     GIR_EraseRootFromParent_Done,
     /* 1946515 */   // Label 26142: @1946515
     /* 1946515 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1946601), // Rule ID 24504 //
     /* 1946520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946566 */     // MIs[0] policy
     /* 1946566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946600 */     // GIR_Coverage, 24504,
     /* 1946600 */     GIR_EraseRootFromParent_Done,
     /* 1946601 */   // Label 26143: @1946601
     /* 1946601 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1946687), // Rule ID 24505 //
     /* 1946606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946652 */     // MIs[0] policy
     /* 1946652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946686 */     // GIR_Coverage, 24505,
     /* 1946686 */     GIR_EraseRootFromParent_Done,
     /* 1946687 */   // Label 26144: @1946687
     /* 1946687 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1946773), // Rule ID 24508 //
     /* 1946692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946738 */     // MIs[0] policy
     /* 1946738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946772 */     // GIR_Coverage, 24508,
     /* 1946772 */     GIR_EraseRootFromParent_Done,
     /* 1946773 */   // Label 26145: @1946773
     /* 1946773 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1946859), // Rule ID 24509 //
     /* 1946778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946824 */     // MIs[0] policy
     /* 1946824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946858 */     // GIR_Coverage, 24509,
     /* 1946858 */     GIR_EraseRootFromParent_Done,
     /* 1946859 */   // Label 26146: @1946859
     /* 1946859 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1946945), // Rule ID 24512 //
     /* 1946864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946910 */     // MIs[0] policy
     /* 1946910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946944 */     // GIR_Coverage, 24512,
     /* 1946944 */     GIR_EraseRootFromParent_Done,
     /* 1946945 */   // Label 26147: @1946945
     /* 1946945 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1947031), // Rule ID 24513 //
     /* 1946950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946996 */     // MIs[0] policy
     /* 1946996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1947009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947030 */     // GIR_Coverage, 24513,
     /* 1947030 */     GIR_EraseRootFromParent_Done,
     /* 1947031 */   // Label 26148: @1947031
     /* 1947031 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1947117), // Rule ID 24516 //
     /* 1947036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947082 */     // MIs[0] policy
     /* 1947082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947092 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1947095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947116 */     // GIR_Coverage, 24516,
     /* 1947116 */     GIR_EraseRootFromParent_Done,
     /* 1947117 */   // Label 26149: @1947117
     /* 1947117 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1947203), // Rule ID 24517 //
     /* 1947122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947168 */     // MIs[0] policy
     /* 1947168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1947181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947202 */     // GIR_Coverage, 24517,
     /* 1947202 */     GIR_EraseRootFromParent_Done,
     /* 1947203 */   // Label 26150: @1947203
     /* 1947203 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1947289), // Rule ID 24520 //
     /* 1947208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947254 */     // MIs[0] policy
     /* 1947254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1947267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947288 */     // GIR_Coverage, 24520,
     /* 1947288 */     GIR_EraseRootFromParent_Done,
     /* 1947289 */   // Label 26151: @1947289
     /* 1947289 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1947375), // Rule ID 24521 //
     /* 1947294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947340 */     // MIs[0] policy
     /* 1947340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1947353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947374 */     // GIR_Coverage, 24521,
     /* 1947374 */     GIR_EraseRootFromParent_Done,
     /* 1947375 */   // Label 26152: @1947375
     /* 1947375 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1947461), // Rule ID 24524 //
     /* 1947380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947426 */     // MIs[0] policy
     /* 1947426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947460 */     // GIR_Coverage, 24524,
     /* 1947460 */     GIR_EraseRootFromParent_Done,
     /* 1947461 */   // Label 26153: @1947461
     /* 1947461 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1947547), // Rule ID 24525 //
     /* 1947466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947512 */     // MIs[0] policy
     /* 1947512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947546 */     // GIR_Coverage, 24525,
     /* 1947546 */     GIR_EraseRootFromParent_Done,
     /* 1947547 */   // Label 26154: @1947547
     /* 1947547 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1947633), // Rule ID 24528 //
     /* 1947552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947598 */     // MIs[0] policy
     /* 1947598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947632 */     // GIR_Coverage, 24528,
     /* 1947632 */     GIR_EraseRootFromParent_Done,
     /* 1947633 */   // Label 26155: @1947633
     /* 1947633 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1947719), // Rule ID 24529 //
     /* 1947638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947684 */     // MIs[0] policy
     /* 1947684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11576:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947718 */     // GIR_Coverage, 24529,
     /* 1947718 */     GIR_EraseRootFromParent_Done,
     /* 1947719 */   // Label 26156: @1947719
     /* 1947719 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1947805), // Rule ID 24532 //
     /* 1947724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947770 */     // MIs[0] policy
     /* 1947770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947804 */     // GIR_Coverage, 24532,
     /* 1947804 */     GIR_EraseRootFromParent_Done,
     /* 1947805 */   // Label 26157: @1947805
     /* 1947805 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1947891), // Rule ID 24533 //
     /* 1947810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947856 */     // MIs[0] policy
     /* 1947856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947890 */     // GIR_Coverage, 24533,
     /* 1947890 */     GIR_EraseRootFromParent_Done,
     /* 1947891 */   // Label 26158: @1947891
     /* 1947891 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1947977), // Rule ID 24536 //
     /* 1947896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947942 */     // MIs[0] policy
     /* 1947942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947976 */     // GIR_Coverage, 24536,
     /* 1947976 */     GIR_EraseRootFromParent_Done,
     /* 1947977 */   // Label 26159: @1947977
     /* 1947977 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1948063), // Rule ID 24537 //
     /* 1947982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1948002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948028 */     // MIs[0] policy
     /* 1948028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1948041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948062 */     // GIR_Coverage, 24537,
     /* 1948062 */     GIR_EraseRootFromParent_Done,
     /* 1948063 */   // Label 26160: @1948063
     /* 1948063 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1948149), // Rule ID 24540 //
     /* 1948068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1948071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1948088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948114 */     // MIs[0] policy
     /* 1948114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1948127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948148 */     // GIR_Coverage, 24540,
     /* 1948148 */     GIR_EraseRootFromParent_Done,
     /* 1948149 */   // Label 26161: @1948149
     /* 1948149 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1948235), // Rule ID 24541 //
     /* 1948154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1948157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1948174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948200 */     // MIs[0] policy
     /* 1948200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1948213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948234 */     // GIR_Coverage, 24541,
     /* 1948234 */     GIR_EraseRootFromParent_Done,
     /* 1948235 */   // Label 26162: @1948235
     /* 1948235 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1948321), // Rule ID 24544 //
     /* 1948240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1948260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948286 */     // MIs[0] policy
     /* 1948286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1948299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948320 */     // GIR_Coverage, 24544,
     /* 1948320 */     GIR_EraseRootFromParent_Done,
     /* 1948321 */   // Label 26163: @1948321
     /* 1948321 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1948407), // Rule ID 24545 //
     /* 1948326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1948346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948372 */     // MIs[0] policy
     /* 1948372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1948385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948406 */     // GIR_Coverage, 24545,
     /* 1948406 */     GIR_EraseRootFromParent_Done,
     /* 1948407 */   // Label 26164: @1948407
     /* 1948407 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1948493), // Rule ID 24548 //
     /* 1948412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948458 */     // MIs[0] policy
     /* 1948458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948492 */     // GIR_Coverage, 24548,
     /* 1948492 */     GIR_EraseRootFromParent_Done,
     /* 1948493 */   // Label 26165: @1948493
     /* 1948493 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1948579), // Rule ID 24549 //
     /* 1948498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948544 */     // MIs[0] policy
     /* 1948544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948554 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948578 */     // GIR_Coverage, 24549,
     /* 1948578 */     GIR_EraseRootFromParent_Done,
     /* 1948579 */   // Label 26166: @1948579
     /* 1948579 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1948665), // Rule ID 24552 //
     /* 1948584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948630 */     // MIs[0] policy
     /* 1948630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948664 */     // GIR_Coverage, 24552,
     /* 1948664 */     GIR_EraseRootFromParent_Done,
     /* 1948665 */   // Label 26167: @1948665
     /* 1948665 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1948751), // Rule ID 24553 //
     /* 1948670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948716 */     // MIs[0] policy
     /* 1948716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948726 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948750 */     // GIR_Coverage, 24553,
     /* 1948750 */     GIR_EraseRootFromParent_Done,
     /* 1948751 */   // Label 26168: @1948751
     /* 1948751 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1948837), // Rule ID 24556 //
     /* 1948756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948802 */     // MIs[0] policy
     /* 1948802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948836 */     // GIR_Coverage, 24556,
     /* 1948836 */     GIR_EraseRootFromParent_Done,
     /* 1948837 */   // Label 26169: @1948837
     /* 1948837 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1948923), // Rule ID 24557 //
     /* 1948842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948888 */     // MIs[0] policy
     /* 1948888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948922 */     // GIR_Coverage, 24557,
     /* 1948922 */     GIR_EraseRootFromParent_Done,
     /* 1948923 */   // Label 26170: @1948923
     /* 1948923 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1949009), // Rule ID 24560 //
     /* 1948928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948974 */     // MIs[0] policy
     /* 1948974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949008 */     // GIR_Coverage, 24560,
     /* 1949008 */     GIR_EraseRootFromParent_Done,
     /* 1949009 */   // Label 26171: @1949009
     /* 1949009 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1949095), // Rule ID 24561 //
     /* 1949014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1949025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1949028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1949031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1949034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949060 */     // MIs[0] policy
     /* 1949060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949070 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1949073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949094 */     // GIR_Coverage, 24561,
     /* 1949094 */     GIR_EraseRootFromParent_Done,
     /* 1949095 */   // Label 26172: @1949095
     /* 1949095 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1949181), // Rule ID 24564 //
     /* 1949100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949146 */     // MIs[0] policy
     /* 1949146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1949159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949180 */     // GIR_Coverage, 24564,
     /* 1949180 */     GIR_EraseRootFromParent_Done,
     /* 1949181 */   // Label 26173: @1949181
     /* 1949181 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1949267), // Rule ID 24565 //
     /* 1949186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949232 */     // MIs[0] policy
     /* 1949232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1949245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949266 */     // GIR_Coverage, 24565,
     /* 1949266 */     GIR_EraseRootFromParent_Done,
     /* 1949267 */   // Label 26174: @1949267
     /* 1949267 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1949353), // Rule ID 24568 //
     /* 1949272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1949292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949318 */     // MIs[0] policy
     /* 1949318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1949331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949352 */     // GIR_Coverage, 24568,
     /* 1949352 */     GIR_EraseRootFromParent_Done,
     /* 1949353 */   // Label 26175: @1949353
     /* 1949353 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1949439), // Rule ID 24569 //
     /* 1949358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1949378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949404 */     // MIs[0] policy
     /* 1949404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1949417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949438 */     // GIR_Coverage, 24569,
     /* 1949438 */     GIR_EraseRootFromParent_Done,
     /* 1949439 */   // Label 26176: @1949439
     /* 1949439 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1949525), // Rule ID 24572 //
     /* 1949444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949490 */     // MIs[0] policy
     /* 1949490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949524 */     // GIR_Coverage, 24572,
     /* 1949524 */     GIR_EraseRootFromParent_Done,
     /* 1949525 */   // Label 26177: @1949525
     /* 1949525 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1949611), // Rule ID 24573 //
     /* 1949530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949576 */     // MIs[0] policy
     /* 1949576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949610 */     // GIR_Coverage, 24573,
     /* 1949610 */     GIR_EraseRootFromParent_Done,
     /* 1949611 */   // Label 26178: @1949611
     /* 1949611 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1949697), // Rule ID 24576 //
     /* 1949616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949662 */     // MIs[0] policy
     /* 1949662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949696 */     // GIR_Coverage, 24576,
     /* 1949696 */     GIR_EraseRootFromParent_Done,
     /* 1949697 */   // Label 26179: @1949697
     /* 1949697 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1949783), // Rule ID 24577 //
     /* 1949702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949748 */     // MIs[0] policy
     /* 1949748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949758 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949782 */     // GIR_Coverage, 24577,
     /* 1949782 */     GIR_EraseRootFromParent_Done,
     /* 1949783 */   // Label 26180: @1949783
     /* 1949783 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1949869), // Rule ID 24580 //
     /* 1949788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949834 */     // MIs[0] policy
     /* 1949834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949868 */     // GIR_Coverage, 24580,
     /* 1949868 */     GIR_EraseRootFromParent_Done,
     /* 1949869 */   // Label 26181: @1949869
     /* 1949869 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1949955), // Rule ID 24581 //
     /* 1949874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949920 */     // MIs[0] policy
     /* 1949920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949954 */     // GIR_Coverage, 24581,
     /* 1949954 */     GIR_EraseRootFromParent_Done,
     /* 1949955 */   // Label 26182: @1949955
     /* 1949955 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1950041), // Rule ID 24584 //
     /* 1949960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950006 */     // MIs[0] policy
     /* 1950006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1950019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950040 */     // GIR_Coverage, 24584,
     /* 1950040 */     GIR_EraseRootFromParent_Done,
     /* 1950041 */   // Label 26183: @1950041
     /* 1950041 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1950127), // Rule ID 24585 //
     /* 1950046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1950057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1950060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1950063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1950066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950092 */     // MIs[0] policy
     /* 1950092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1950105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950126 */     // GIR_Coverage, 24585,
     /* 1950126 */     GIR_EraseRootFromParent_Done,
     /* 1950127 */   // Label 26184: @1950127
     /* 1950127 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1950213), // Rule ID 24588 //
     /* 1950132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1950135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1950152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950178 */     // MIs[0] policy
     /* 1950178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1950191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950212 */     // GIR_Coverage, 24588,
     /* 1950212 */     GIR_EraseRootFromParent_Done,
     /* 1950213 */   // Label 26185: @1950213
     /* 1950213 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1950299), // Rule ID 24589 //
     /* 1950218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1950238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950264 */     // MIs[0] policy
     /* 1950264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1950277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950298 */     // GIR_Coverage, 24589,
     /* 1950298 */     GIR_EraseRootFromParent_Done,
     /* 1950299 */   // Label 26186: @1950299
     /* 1950299 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1950385), // Rule ID 24592 //
     /* 1950304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1950315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1950318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1950321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950350 */     // MIs[0] policy
     /* 1950350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950360 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1950363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950384 */     // GIR_Coverage, 24592,
     /* 1950384 */     GIR_EraseRootFromParent_Done,
     /* 1950385 */   // Label 26187: @1950385
     /* 1950385 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1950471), // Rule ID 24593 //
     /* 1950390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1950401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1950404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1950407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950436 */     // MIs[0] policy
     /* 1950436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950446 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1950449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950470 */     // GIR_Coverage, 24593,
     /* 1950470 */     GIR_EraseRootFromParent_Done,
     /* 1950471 */   // Label 26188: @1950471
     /* 1950471 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1950557), // Rule ID 24596 //
     /* 1950476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950522 */     // MIs[0] policy
     /* 1950522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950556 */     // GIR_Coverage, 24596,
     /* 1950556 */     GIR_EraseRootFromParent_Done,
     /* 1950557 */   // Label 26189: @1950557
     /* 1950557 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1950643), // Rule ID 24597 //
     /* 1950562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950608 */     // MIs[0] policy
     /* 1950608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950618 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950642 */     // GIR_Coverage, 24597,
     /* 1950642 */     GIR_EraseRootFromParent_Done,
     /* 1950643 */   // Label 26190: @1950643
     /* 1950643 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1950729), // Rule ID 24600 //
     /* 1950648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950694 */     // MIs[0] policy
     /* 1950694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950704 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950728 */     // GIR_Coverage, 24600,
     /* 1950728 */     GIR_EraseRootFromParent_Done,
     /* 1950729 */   // Label 26191: @1950729
     /* 1950729 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1950815), // Rule ID 24601 //
     /* 1950734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950780 */     // MIs[0] policy
     /* 1950780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950790 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950814 */     // GIR_Coverage, 24601,
     /* 1950814 */     GIR_EraseRootFromParent_Done,
     /* 1950815 */   // Label 26192: @1950815
     /* 1950815 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1950901), // Rule ID 24604 //
     /* 1950820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950866 */     // MIs[0] policy
     /* 1950866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950900 */     // GIR_Coverage, 24604,
     /* 1950900 */     GIR_EraseRootFromParent_Done,
     /* 1950901 */   // Label 26193: @1950901
     /* 1950901 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1950987), // Rule ID 24605 //
     /* 1950906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950952 */     // MIs[0] policy
     /* 1950952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950962 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950986 */     // GIR_Coverage, 24605,
     /* 1950986 */     GIR_EraseRootFromParent_Done,
     /* 1950987 */   // Label 26194: @1950987
     /* 1950987 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1951073), // Rule ID 24608 //
     /* 1950992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1951003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1951006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1951009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951038 */     // MIs[0] policy
     /* 1951038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951048 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951072 */     // GIR_Coverage, 24608,
     /* 1951072 */     GIR_EraseRootFromParent_Done,
     /* 1951073 */   // Label 26195: @1951073
     /* 1951073 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1951159), // Rule ID 24609 //
     /* 1951078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1951089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1951092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1951095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951124 */     // MIs[0] policy
     /* 1951124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951158 */     // GIR_Coverage, 24609,
     /* 1951158 */     GIR_EraseRootFromParent_Done,
     /* 1951159 */   // Label 26196: @1951159
     /* 1951159 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1951245), // Rule ID 24612 //
     /* 1951164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1951175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1951178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1951181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951210 */     // MIs[0] policy
     /* 1951210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951244 */     // GIR_Coverage, 24612,
     /* 1951244 */     GIR_EraseRootFromParent_Done,
     /* 1951245 */   // Label 26197: @1951245
     /* 1951245 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1951331), // Rule ID 24613 //
     /* 1951250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1951261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1951264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1951267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951296 */     // MIs[0] policy
     /* 1951296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1951309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951330 */     // GIR_Coverage, 24613,
     /* 1951330 */     GIR_EraseRootFromParent_Done,
     /* 1951331 */   // Label 26198: @1951331
     /* 1951331 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1951417), // Rule ID 24616 //
     /* 1951336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1951347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1951350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1951353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951382 */     // MIs[0] policy
     /* 1951382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951416 */     // GIR_Coverage, 24616,
     /* 1951416 */     GIR_EraseRootFromParent_Done,
     /* 1951417 */   // Label 26199: @1951417
     /* 1951417 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1951503), // Rule ID 24617 //
     /* 1951422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1951433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1951436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1951439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951468 */     // MIs[0] policy
     /* 1951468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951478 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11578:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951502 */     // GIR_Coverage, 24617,
     /* 1951502 */     GIR_EraseRootFromParent_Done,
     /* 1951503 */   // Label 26200: @1951503
     /* 1951503 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1951589), // Rule ID 24620 //
     /* 1951508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951554 */     // MIs[0] policy
     /* 1951554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951588 */     // GIR_Coverage, 24620,
     /* 1951588 */     GIR_EraseRootFromParent_Done,
     /* 1951589 */   // Label 26201: @1951589
     /* 1951589 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1951675), // Rule ID 24621 //
     /* 1951594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951640 */     // MIs[0] policy
     /* 1951640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951674 */     // GIR_Coverage, 24621,
     /* 1951674 */     GIR_EraseRootFromParent_Done,
     /* 1951675 */   // Label 26202: @1951675
     /* 1951675 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1951761), // Rule ID 24624 //
     /* 1951680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951726 */     // MIs[0] policy
     /* 1951726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951760 */     // GIR_Coverage, 24624,
     /* 1951760 */     GIR_EraseRootFromParent_Done,
     /* 1951761 */   // Label 26203: @1951761
     /* 1951761 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1951847), // Rule ID 24625 //
     /* 1951766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951812 */     // MIs[0] policy
     /* 1951812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951846 */     // GIR_Coverage, 24625,
     /* 1951846 */     GIR_EraseRootFromParent_Done,
     /* 1951847 */   // Label 26204: @1951847
     /* 1951847 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1951933), // Rule ID 24628 //
     /* 1951852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951898 */     // MIs[0] policy
     /* 1951898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951932 */     // GIR_Coverage, 24628,
     /* 1951932 */     GIR_EraseRootFromParent_Done,
     /* 1951933 */   // Label 26205: @1951933
     /* 1951933 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1952019), // Rule ID 24629 //
     /* 1951938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951984 */     // MIs[0] policy
     /* 1951984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952018 */     // GIR_Coverage, 24629,
     /* 1952018 */     GIR_EraseRootFromParent_Done,
     /* 1952019 */   // Label 26206: @1952019
     /* 1952019 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1952105), // Rule ID 24632 //
     /* 1952024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1952035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1952038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1952041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952070 */     // MIs[0] policy
     /* 1952070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952104 */     // GIR_Coverage, 24632,
     /* 1952104 */     GIR_EraseRootFromParent_Done,
     /* 1952105 */   // Label 26207: @1952105
     /* 1952105 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1952191), // Rule ID 24633 //
     /* 1952110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1952121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1952124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1952127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952156 */     // MIs[0] policy
     /* 1952156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952166 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952190 */     // GIR_Coverage, 24633,
     /* 1952190 */     GIR_EraseRootFromParent_Done,
     /* 1952191 */   // Label 26208: @1952191
     /* 1952191 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1952277), // Rule ID 24636 //
     /* 1952196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1952207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1952210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1952213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952242 */     // MIs[0] policy
     /* 1952242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952276 */     // GIR_Coverage, 24636,
     /* 1952276 */     GIR_EraseRootFromParent_Done,
     /* 1952277 */   // Label 26209: @1952277
     /* 1952277 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1952363), // Rule ID 24637 //
     /* 1952282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1952293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1952296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1952299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952328 */     // MIs[0] policy
     /* 1952328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952338 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952362 */     // GIR_Coverage, 24637,
     /* 1952362 */     GIR_EraseRootFromParent_Done,
     /* 1952363 */   // Label 26210: @1952363
     /* 1952363 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1952449), // Rule ID 24640 //
     /* 1952368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952414 */     // MIs[0] policy
     /* 1952414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952424 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952448 */     // GIR_Coverage, 24640,
     /* 1952448 */     GIR_EraseRootFromParent_Done,
     /* 1952449 */   // Label 26211: @1952449
     /* 1952449 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1952535), // Rule ID 24641 //
     /* 1952454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1952465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952500 */     // MIs[0] policy
     /* 1952500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952534 */     // GIR_Coverage, 24641,
     /* 1952534 */     GIR_EraseRootFromParent_Done,
     /* 1952535 */   // Label 26212: @1952535
     /* 1952535 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1952621), // Rule ID 24644 //
     /* 1952540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952586 */     // MIs[0] policy
     /* 1952586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952620 */     // GIR_Coverage, 24644,
     /* 1952620 */     GIR_EraseRootFromParent_Done,
     /* 1952621 */   // Label 26213: @1952621
     /* 1952621 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1952707), // Rule ID 24645 //
     /* 1952626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952672 */     // MIs[0] policy
     /* 1952672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952706 */     // GIR_Coverage, 24645,
     /* 1952706 */     GIR_EraseRootFromParent_Done,
     /* 1952707 */   // Label 26214: @1952707
     /* 1952707 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1952793), // Rule ID 24648 //
     /* 1952712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952758 */     // MIs[0] policy
     /* 1952758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952768 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952792 */     // GIR_Coverage, 24648,
     /* 1952792 */     GIR_EraseRootFromParent_Done,
     /* 1952793 */   // Label 26215: @1952793
     /* 1952793 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1952879), // Rule ID 24649 //
     /* 1952798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952844 */     // MIs[0] policy
     /* 1952844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952878 */     // GIR_Coverage, 24649,
     /* 1952878 */     GIR_EraseRootFromParent_Done,
     /* 1952879 */   // Label 26216: @1952879
     /* 1952879 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1952965), // Rule ID 24652 //
     /* 1952884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952930 */     // MIs[0] policy
     /* 1952930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952940 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952964 */     // GIR_Coverage, 24652,
     /* 1952964 */     GIR_EraseRootFromParent_Done,
     /* 1952965 */   // Label 26217: @1952965
     /* 1952965 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1953051), // Rule ID 24653 //
     /* 1952970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953016 */     // MIs[0] policy
     /* 1953016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953050 */     // GIR_Coverage, 24653,
     /* 1953050 */     GIR_EraseRootFromParent_Done,
     /* 1953051 */   // Label 26218: @1953051
     /* 1953051 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1953137), // Rule ID 24656 //
     /* 1953056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1953067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1953070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1953073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953102 */     // MIs[0] policy
     /* 1953102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953136 */     // GIR_Coverage, 24656,
     /* 1953136 */     GIR_EraseRootFromParent_Done,
     /* 1953137 */   // Label 26219: @1953137
     /* 1953137 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1953223), // Rule ID 24657 //
     /* 1953142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1953153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1953156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1953159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953188 */     // MIs[0] policy
     /* 1953188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953222 */     // GIR_Coverage, 24657,
     /* 1953222 */     GIR_EraseRootFromParent_Done,
     /* 1953223 */   // Label 26220: @1953223
     /* 1953223 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1953309), // Rule ID 24660 //
     /* 1953228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1953239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1953242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1953245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953274 */     // MIs[0] policy
     /* 1953274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953308 */     // GIR_Coverage, 24660,
     /* 1953308 */     GIR_EraseRootFromParent_Done,
     /* 1953309 */   // Label 26221: @1953309
     /* 1953309 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1953395), // Rule ID 24661 //
     /* 1953314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1953325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1953328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1953331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953360 */     // MIs[0] policy
     /* 1953360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953394 */     // GIR_Coverage, 24661,
     /* 1953394 */     GIR_EraseRootFromParent_Done,
     /* 1953395 */   // Label 26222: @1953395
     /* 1953395 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1953481), // Rule ID 24664 //
     /* 1953400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953446 */     // MIs[0] policy
     /* 1953446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953480 */     // GIR_Coverage, 24664,
     /* 1953480 */     GIR_EraseRootFromParent_Done,
     /* 1953481 */   // Label 26223: @1953481
     /* 1953481 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1953567), // Rule ID 24665 //
     /* 1953486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953532 */     // MIs[0] policy
     /* 1953532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953566 */     // GIR_Coverage, 24665,
     /* 1953566 */     GIR_EraseRootFromParent_Done,
     /* 1953567 */   // Label 26224: @1953567
     /* 1953567 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1953653), // Rule ID 24668 //
     /* 1953572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953618 */     // MIs[0] policy
     /* 1953618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953652 */     // GIR_Coverage, 24668,
     /* 1953652 */     GIR_EraseRootFromParent_Done,
     /* 1953653 */   // Label 26225: @1953653
     /* 1953653 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1953739), // Rule ID 24669 //
     /* 1953658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953704 */     // MIs[0] policy
     /* 1953704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953738 */     // GIR_Coverage, 24669,
     /* 1953738 */     GIR_EraseRootFromParent_Done,
     /* 1953739 */   // Label 26226: @1953739
     /* 1953739 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1953825), // Rule ID 24672 //
     /* 1953744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953790 */     // MIs[0] policy
     /* 1953790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953824 */     // GIR_Coverage, 24672,
     /* 1953824 */     GIR_EraseRootFromParent_Done,
     /* 1953825 */   // Label 26227: @1953825
     /* 1953825 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1953911), // Rule ID 24673 //
     /* 1953830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953876 */     // MIs[0] policy
     /* 1953876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953886 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953910 */     // GIR_Coverage, 24673,
     /* 1953910 */     GIR_EraseRootFromParent_Done,
     /* 1953911 */   // Label 26228: @1953911
     /* 1953911 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1953997), // Rule ID 24676 //
     /* 1953916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953962 */     // MIs[0] policy
     /* 1953962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953972 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953996 */     // GIR_Coverage, 24676,
     /* 1953996 */     GIR_EraseRootFromParent_Done,
     /* 1953997 */   // Label 26229: @1953997
     /* 1953997 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1954083), // Rule ID 24677 //
     /* 1954002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1954005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1954013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1954016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1954019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954048 */     // MIs[0] policy
     /* 1954048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954058 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1954061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954082 */     // GIR_Coverage, 24677,
     /* 1954082 */     GIR_EraseRootFromParent_Done,
     /* 1954083 */   // Label 26230: @1954083
     /* 1954083 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1954169), // Rule ID 24768 //
     /* 1954088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1954099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1954102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1954105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954134 */     // MIs[0] policy
     /* 1954134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1954147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954168 */     // GIR_Coverage, 24768,
     /* 1954168 */     GIR_EraseRootFromParent_Done,
     /* 1954169 */   // Label 26231: @1954169
     /* 1954169 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1954255), // Rule ID 24769 //
     /* 1954174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1954185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1954188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1954191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954220 */     // MIs[0] policy
     /* 1954220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954230 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1954233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954254 */     // GIR_Coverage, 24769,
     /* 1954254 */     GIR_EraseRootFromParent_Done,
     /* 1954255 */   // Label 26232: @1954255
     /* 1954255 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1954341), // Rule ID 24772 //
     /* 1954260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1954271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1954274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1954277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954306 */     // MIs[0] policy
     /* 1954306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1954319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954340 */     // GIR_Coverage, 24772,
     /* 1954340 */     GIR_EraseRootFromParent_Done,
     /* 1954341 */   // Label 26233: @1954341
     /* 1954341 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1954427), // Rule ID 24773 //
     /* 1954346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1954357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1954360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1954363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954392 */     // MIs[0] policy
     /* 1954392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1954405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954426 */     // GIR_Coverage, 24773,
     /* 1954426 */     GIR_EraseRootFromParent_Done,
     /* 1954427 */   // Label 26234: @1954427
     /* 1954427 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1954513), // Rule ID 24776 //
     /* 1954432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954478 */     // MIs[0] policy
     /* 1954478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954488 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954512 */     // GIR_Coverage, 24776,
     /* 1954512 */     GIR_EraseRootFromParent_Done,
     /* 1954513 */   // Label 26235: @1954513
     /* 1954513 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1954599), // Rule ID 24777 //
     /* 1954518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954564 */     // MIs[0] policy
     /* 1954564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954598 */     // GIR_Coverage, 24777,
     /* 1954598 */     GIR_EraseRootFromParent_Done,
     /* 1954599 */   // Label 26236: @1954599
     /* 1954599 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1954685), // Rule ID 24780 //
     /* 1954604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954650 */     // MIs[0] policy
     /* 1954650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954660 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954684 */     // GIR_Coverage, 24780,
     /* 1954684 */     GIR_EraseRootFromParent_Done,
     /* 1954685 */   // Label 26237: @1954685
     /* 1954685 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1954771), // Rule ID 24781 //
     /* 1954690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954736 */     // MIs[0] policy
     /* 1954736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954770 */     // GIR_Coverage, 24781,
     /* 1954770 */     GIR_EraseRootFromParent_Done,
     /* 1954771 */   // Label 26238: @1954771
     /* 1954771 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1954857), // Rule ID 24784 //
     /* 1954776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954822 */     // MIs[0] policy
     /* 1954822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954832 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954856 */     // GIR_Coverage, 24784,
     /* 1954856 */     GIR_EraseRootFromParent_Done,
     /* 1954857 */   // Label 26239: @1954857
     /* 1954857 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1954943), // Rule ID 24785 //
     /* 1954862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954908 */     // MIs[0] policy
     /* 1954908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954942 */     // GIR_Coverage, 24785,
     /* 1954942 */     GIR_EraseRootFromParent_Done,
     /* 1954943 */   // Label 26240: @1954943
     /* 1954943 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1955029), // Rule ID 24788 //
     /* 1954948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954994 */     // MIs[0] policy
     /* 1954994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1955007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955028 */     // GIR_Coverage, 24788,
     /* 1955028 */     GIR_EraseRootFromParent_Done,
     /* 1955029 */   // Label 26241: @1955029
     /* 1955029 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1955115), // Rule ID 24789 //
     /* 1955034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1955045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1955048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1955051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955080 */     // MIs[0] policy
     /* 1955080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1955093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955114 */     // GIR_Coverage, 24789,
     /* 1955114 */     GIR_EraseRootFromParent_Done,
     /* 1955115 */   // Label 26242: @1955115
     /* 1955115 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1955201), // Rule ID 24792 //
     /* 1955120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1955131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1955134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1955137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955166 */     // MIs[0] policy
     /* 1955166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955176 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1955179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955200 */     // GIR_Coverage, 24792,
     /* 1955200 */     GIR_EraseRootFromParent_Done,
     /* 1955201 */   // Label 26243: @1955201
     /* 1955201 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1955287), // Rule ID 24793 //
     /* 1955206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1955217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1955220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1955223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955252 */     // MIs[0] policy
     /* 1955252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1955265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955286 */     // GIR_Coverage, 24793,
     /* 1955286 */     GIR_EraseRootFromParent_Done,
     /* 1955287 */   // Label 26244: @1955287
     /* 1955287 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1955373), // Rule ID 24796 //
     /* 1955292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1955312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955338 */     // MIs[0] policy
     /* 1955338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1955351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955372 */     // GIR_Coverage, 24796,
     /* 1955372 */     GIR_EraseRootFromParent_Done,
     /* 1955373 */   // Label 26245: @1955373
     /* 1955373 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1955459), // Rule ID 24797 //
     /* 1955378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1955398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955424 */     // MIs[0] policy
     /* 1955424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955434 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1955437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955458 */     // GIR_Coverage, 24797,
     /* 1955458 */     GIR_EraseRootFromParent_Done,
     /* 1955459 */   // Label 26246: @1955459
     /* 1955459 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1955545), // Rule ID 24800 //
     /* 1955464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955510 */     // MIs[0] policy
     /* 1955510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955544 */     // GIR_Coverage, 24800,
     /* 1955544 */     GIR_EraseRootFromParent_Done,
     /* 1955545 */   // Label 26247: @1955545
     /* 1955545 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1955631), // Rule ID 24801 //
     /* 1955550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955596 */     // MIs[0] policy
     /* 1955596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955606 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955630 */     // GIR_Coverage, 24801,
     /* 1955630 */     GIR_EraseRootFromParent_Done,
     /* 1955631 */   // Label 26248: @1955631
     /* 1955631 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1955717), // Rule ID 24804 //
     /* 1955636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1955639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955682 */     // MIs[0] policy
     /* 1955682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955716 */     // GIR_Coverage, 24804,
     /* 1955716 */     GIR_EraseRootFromParent_Done,
     /* 1955717 */   // Label 26249: @1955717
     /* 1955717 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1955803), // Rule ID 24805 //
     /* 1955722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1955725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955768 */     // MIs[0] policy
     /* 1955768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955802 */     // GIR_Coverage, 24805,
     /* 1955802 */     GIR_EraseRootFromParent_Done,
     /* 1955803 */   // Label 26250: @1955803
     /* 1955803 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1955889), // Rule ID 24808 //
     /* 1955808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955854 */     // MIs[0] policy
     /* 1955854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955888 */     // GIR_Coverage, 24808,
     /* 1955888 */     GIR_EraseRootFromParent_Done,
     /* 1955889 */   // Label 26251: @1955889
     /* 1955889 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1955975), // Rule ID 24809 //
     /* 1955894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955940 */     // MIs[0] policy
     /* 1955940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955950 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955974 */     // GIR_Coverage, 24809,
     /* 1955974 */     GIR_EraseRootFromParent_Done,
     /* 1955975 */   // Label 26252: @1955975
     /* 1955975 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1956061), // Rule ID 24812 //
     /* 1955980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956026 */     // MIs[0] policy
     /* 1956026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956036 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1956039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1956057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956060 */     // GIR_Coverage, 24812,
     /* 1956060 */     GIR_EraseRootFromParent_Done,
     /* 1956061 */   // Label 26253: @1956061
     /* 1956061 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1956147), // Rule ID 24813 //
     /* 1956066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1956077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1956080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1956083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956112 */     // MIs[0] policy
     /* 1956112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1956125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1956143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956146 */     // GIR_Coverage, 24813,
     /* 1956146 */     GIR_EraseRootFromParent_Done,
     /* 1956147 */   // Label 26254: @1956147
     /* 1956147 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1956233), // Rule ID 24816 //
     /* 1956152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956198 */     // MIs[0] policy
     /* 1956198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956232 */     // GIR_Coverage, 24816,
     /* 1956232 */     GIR_EraseRootFromParent_Done,
     /* 1956233 */   // Label 26255: @1956233
     /* 1956233 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1956319), // Rule ID 24817 //
     /* 1956238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956284 */     // MIs[0] policy
     /* 1956284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956318 */     // GIR_Coverage, 24817,
     /* 1956318 */     GIR_EraseRootFromParent_Done,
     /* 1956319 */   // Label 26256: @1956319
     /* 1956319 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1956405), // Rule ID 24820 //
     /* 1956324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956370 */     // MIs[0] policy
     /* 1956370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956404 */     // GIR_Coverage, 24820,
     /* 1956404 */     GIR_EraseRootFromParent_Done,
     /* 1956405 */   // Label 26257: @1956405
     /* 1956405 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1956491), // Rule ID 24821 //
     /* 1956410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1956421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1956424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1956427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956456 */     // MIs[0] policy
     /* 1956456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956490 */     // GIR_Coverage, 24821,
     /* 1956490 */     GIR_EraseRootFromParent_Done,
     /* 1956491 */   // Label 26258: @1956491
     /* 1956491 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1956577), // Rule ID 24824 //
     /* 1956496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956542 */     // MIs[0] policy
     /* 1956542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956576 */     // GIR_Coverage, 24824,
     /* 1956576 */     GIR_EraseRootFromParent_Done,
     /* 1956577 */   // Label 26259: @1956577
     /* 1956577 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1956663), // Rule ID 24825 //
     /* 1956582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956628 */     // MIs[0] policy
     /* 1956628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956662 */     // GIR_Coverage, 24825,
     /* 1956662 */     GIR_EraseRootFromParent_Done,
     /* 1956663 */   // Label 26260: @1956663
     /* 1956663 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1956749), // Rule ID 24828 //
     /* 1956668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956714 */     // MIs[0] policy
     /* 1956714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956748 */     // GIR_Coverage, 24828,
     /* 1956748 */     GIR_EraseRootFromParent_Done,
     /* 1956749 */   // Label 26261: @1956749
     /* 1956749 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1956835), // Rule ID 24829 //
     /* 1956754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956800 */     // MIs[0] policy
     /* 1956800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956834 */     // GIR_Coverage, 24829,
     /* 1956834 */     GIR_EraseRootFromParent_Done,
     /* 1956835 */   // Label 26262: @1956835
     /* 1956835 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1956921), // Rule ID 24832 //
     /* 1956840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956886 */     // MIs[0] policy
     /* 1956886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956920 */     // GIR_Coverage, 24832,
     /* 1956920 */     GIR_EraseRootFromParent_Done,
     /* 1956921 */   // Label 26263: @1956921
     /* 1956921 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1957007), // Rule ID 24833 //
     /* 1956926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956972 */     // MIs[0] policy
     /* 1956972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957006 */     // GIR_Coverage, 24833,
     /* 1957006 */     GIR_EraseRootFromParent_Done,
     /* 1957007 */   // Label 26264: @1957007
     /* 1957007 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1957093), // Rule ID 24836 //
     /* 1957012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957058 */     // MIs[0] policy
     /* 1957058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957092 */     // GIR_Coverage, 24836,
     /* 1957092 */     GIR_EraseRootFromParent_Done,
     /* 1957093 */   // Label 26265: @1957093
     /* 1957093 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1957179), // Rule ID 24837 //
     /* 1957098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957144 */     // MIs[0] policy
     /* 1957144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957178 */     // GIR_Coverage, 24837,
     /* 1957178 */     GIR_EraseRootFromParent_Done,
     /* 1957179 */   // Label 26266: @1957179
     /* 1957179 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1957265), // Rule ID 24840 //
     /* 1957184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957230 */     // MIs[0] policy
     /* 1957230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1957243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957264 */     // GIR_Coverage, 24840,
     /* 1957264 */     GIR_EraseRootFromParent_Done,
     /* 1957265 */   // Label 26267: @1957265
     /* 1957265 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1957351), // Rule ID 24841 //
     /* 1957270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957316 */     // MIs[0] policy
     /* 1957316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1957329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957350 */     // GIR_Coverage, 24841,
     /* 1957350 */     GIR_EraseRootFromParent_Done,
     /* 1957351 */   // Label 26268: @1957351
     /* 1957351 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1957437), // Rule ID 24844 //
     /* 1957356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957402 */     // MIs[0] policy
     /* 1957402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957436 */     // GIR_Coverage, 24844,
     /* 1957436 */     GIR_EraseRootFromParent_Done,
     /* 1957437 */   // Label 26269: @1957437
     /* 1957437 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1957523), // Rule ID 24845 //
     /* 1957442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957488 */     // MIs[0] policy
     /* 1957488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957522 */     // GIR_Coverage, 24845,
     /* 1957522 */     GIR_EraseRootFromParent_Done,
     /* 1957523 */   // Label 26270: @1957523
     /* 1957523 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1957609), // Rule ID 24848 //
     /* 1957528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957574 */     // MIs[0] policy
     /* 1957574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957608 */     // GIR_Coverage, 24848,
     /* 1957608 */     GIR_EraseRootFromParent_Done,
     /* 1957609 */   // Label 26271: @1957609
     /* 1957609 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1957695), // Rule ID 24849 //
     /* 1957614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957660 */     // MIs[0] policy
     /* 1957660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957694 */     // GIR_Coverage, 24849,
     /* 1957694 */     GIR_EraseRootFromParent_Done,
     /* 1957695 */   // Label 26272: @1957695
     /* 1957695 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1957781), // Rule ID 24852 //
     /* 1957700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957746 */     // MIs[0] policy
     /* 1957746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957756 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957780 */     // GIR_Coverage, 24852,
     /* 1957780 */     GIR_EraseRootFromParent_Done,
     /* 1957781 */   // Label 26273: @1957781
     /* 1957781 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1957867), // Rule ID 24853 //
     /* 1957786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957832 */     // MIs[0] policy
     /* 1957832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957842 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957866 */     // GIR_Coverage, 24853,
     /* 1957866 */     GIR_EraseRootFromParent_Done,
     /* 1957867 */   // Label 26274: @1957867
     /* 1957867 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1957953), // Rule ID 24856 //
     /* 1957872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1957875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957918 */     // MIs[0] policy
     /* 1957918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957928 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957952 */     // GIR_Coverage, 24856,
     /* 1957952 */     GIR_EraseRootFromParent_Done,
     /* 1957953 */   // Label 26275: @1957953
     /* 1957953 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1958039), // Rule ID 24857 //
     /* 1957958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1957961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958004 */     // MIs[0] policy
     /* 1958004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1958017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958038 */     // GIR_Coverage, 24857,
     /* 1958038 */     GIR_EraseRootFromParent_Done,
     /* 1958039 */   // Label 26276: @1958039
     /* 1958039 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1958125), // Rule ID 24860 //
     /* 1958044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1958064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958090 */     // MIs[0] policy
     /* 1958090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958100 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1958103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958124 */     // GIR_Coverage, 24860,
     /* 1958124 */     GIR_EraseRootFromParent_Done,
     /* 1958125 */   // Label 26277: @1958125
     /* 1958125 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1958211), // Rule ID 24861 //
     /* 1958130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1958141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1958144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1958147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1958150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958176 */     // MIs[0] policy
     /* 1958176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958186 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1958189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958210 */     // GIR_Coverage, 24861,
     /* 1958210 */     GIR_EraseRootFromParent_Done,
     /* 1958211 */   // Label 26278: @1958211
     /* 1958211 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1958297), // Rule ID 24864 //
     /* 1958216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958262 */     // MIs[0] policy
     /* 1958262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958272 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958296 */     // GIR_Coverage, 24864,
     /* 1958296 */     GIR_EraseRootFromParent_Done,
     /* 1958297 */   // Label 26279: @1958297
     /* 1958297 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1958383), // Rule ID 24865 //
     /* 1958302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958348 */     // MIs[0] policy
     /* 1958348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958358 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958382 */     // GIR_Coverage, 24865,
     /* 1958382 */     GIR_EraseRootFromParent_Done,
     /* 1958383 */   // Label 26280: @1958383
     /* 1958383 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1958469), // Rule ID 24868 //
     /* 1958388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958434 */     // MIs[0] policy
     /* 1958434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958468 */     // GIR_Coverage, 24868,
     /* 1958468 */     GIR_EraseRootFromParent_Done,
     /* 1958469 */   // Label 26281: @1958469
     /* 1958469 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1958555), // Rule ID 24869 //
     /* 1958474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958520 */     // MIs[0] policy
     /* 1958520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958530 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958554 */     // GIR_Coverage, 24869,
     /* 1958554 */     GIR_EraseRootFromParent_Done,
     /* 1958555 */   // Label 26282: @1958555
     /* 1958555 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1958641), // Rule ID 24872 //
     /* 1958560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1958563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958606 */     // MIs[0] policy
     /* 1958606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958616 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958640 */     // GIR_Coverage, 24872,
     /* 1958640 */     GIR_EraseRootFromParent_Done,
     /* 1958641 */   // Label 26283: @1958641
     /* 1958641 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1958727), // Rule ID 24873 //
     /* 1958646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1958649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958692 */     // MIs[0] policy
     /* 1958692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958702 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958726 */     // GIR_Coverage, 24873,
     /* 1958726 */     GIR_EraseRootFromParent_Done,
     /* 1958727 */   // Label 26284: @1958727
     /* 1958727 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1958813), // Rule ID 24876 //
     /* 1958732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958778 */     // MIs[0] policy
     /* 1958778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958788 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958812 */     // GIR_Coverage, 24876,
     /* 1958812 */     GIR_EraseRootFromParent_Done,
     /* 1958813 */   // Label 26285: @1958813
     /* 1958813 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1958899), // Rule ID 24877 //
     /* 1958818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958864 */     // MIs[0] policy
     /* 1958864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958874 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958898 */     // GIR_Coverage, 24877,
     /* 1958898 */     GIR_EraseRootFromParent_Done,
     /* 1958899 */   // Label 26286: @1958899
     /* 1958899 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1958985), // Rule ID 24880 //
     /* 1958904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1958907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958950 */     // MIs[0] policy
     /* 1958950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958960 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958984 */     // GIR_Coverage, 24880,
     /* 1958984 */     GIR_EraseRootFromParent_Done,
     /* 1958985 */   // Label 26287: @1958985
     /* 1958985 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1959071), // Rule ID 24881 //
     /* 1958990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1958993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1959010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959036 */     // MIs[0] policy
     /* 1959036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959046 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1959049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959070 */     // GIR_Coverage, 24881,
     /* 1959070 */     GIR_EraseRootFromParent_Done,
     /* 1959071 */   // Label 26288: @1959071
     /* 1959071 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1959157), // Rule ID 24884 //
     /* 1959076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959122 */     // MIs[0] policy
     /* 1959122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959132 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959156 */     // GIR_Coverage, 24884,
     /* 1959156 */     GIR_EraseRootFromParent_Done,
     /* 1959157 */   // Label 26289: @1959157
     /* 1959157 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1959243), // Rule ID 24885 //
     /* 1959162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959208 */     // MIs[0] policy
     /* 1959208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959218 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959242 */     // GIR_Coverage, 24885,
     /* 1959242 */     GIR_EraseRootFromParent_Done,
     /* 1959243 */   // Label 26290: @1959243
     /* 1959243 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1959329), // Rule ID 24888 //
     /* 1959248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1959265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1959268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959294 */     // MIs[0] policy
     /* 1959294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1959307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959328 */     // GIR_Coverage, 24888,
     /* 1959328 */     GIR_EraseRootFromParent_Done,
     /* 1959329 */   // Label 26291: @1959329
     /* 1959329 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1959415), // Rule ID 24889 //
     /* 1959334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1959351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1959354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959380 */     // MIs[0] policy
     /* 1959380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959390 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1959393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959414 */     // GIR_Coverage, 24889,
     /* 1959414 */     GIR_EraseRootFromParent_Done,
     /* 1959415 */   // Label 26292: @1959415
     /* 1959415 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1959501), // Rule ID 24892 //
     /* 1959420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959466 */     // MIs[0] policy
     /* 1959466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959500 */     // GIR_Coverage, 24892,
     /* 1959500 */     GIR_EraseRootFromParent_Done,
     /* 1959501 */   // Label 26293: @1959501
     /* 1959501 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1959587), // Rule ID 24893 //
     /* 1959506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959552 */     // MIs[0] policy
     /* 1959552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959562 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959586 */     // GIR_Coverage, 24893,
     /* 1959586 */     GIR_EraseRootFromParent_Done,
     /* 1959587 */   // Label 26294: @1959587
     /* 1959587 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1959673), // Rule ID 24896 //
     /* 1959592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1959595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959638 */     // MIs[0] policy
     /* 1959638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959648 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959672 */     // GIR_Coverage, 24896,
     /* 1959672 */     GIR_EraseRootFromParent_Done,
     /* 1959673 */   // Label 26295: @1959673
     /* 1959673 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1959759), // Rule ID 24897 //
     /* 1959678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1959681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959724 */     // MIs[0] policy
     /* 1959724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959758 */     // GIR_Coverage, 24897,
     /* 1959758 */     GIR_EraseRootFromParent_Done,
     /* 1959759 */   // Label 26296: @1959759
     /* 1959759 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1959845), // Rule ID 24900 //
     /* 1959764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959810 */     // MIs[0] policy
     /* 1959810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959820 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959844 */     // GIR_Coverage, 24900,
     /* 1959844 */     GIR_EraseRootFromParent_Done,
     /* 1959845 */   // Label 26297: @1959845
     /* 1959845 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1959931), // Rule ID 24901 //
     /* 1959850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1959853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959896 */     // MIs[0] policy
     /* 1959896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959930 */     // GIR_Coverage, 24901,
     /* 1959930 */     GIR_EraseRootFromParent_Done,
     /* 1959931 */   // Label 26298: @1959931
     /* 1959931 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1960017), // Rule ID 24904 //
     /* 1959936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1959939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959982 */     // MIs[0] policy
     /* 1959982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959992 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1959995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960016 */     // GIR_Coverage, 24904,
     /* 1960016 */     GIR_EraseRootFromParent_Done,
     /* 1960017 */   // Label 26299: @1960017
     /* 1960017 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1960103), // Rule ID 24905 //
     /* 1960022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1960039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1960042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960068 */     // MIs[0] policy
     /* 1960068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960078 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1960081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960102 */     // GIR_Coverage, 24905,
     /* 1960102 */     GIR_EraseRootFromParent_Done,
     /* 1960103 */   // Label 26300: @1960103
     /* 1960103 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1960189), // Rule ID 24908 //
     /* 1960108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1960111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1960125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1960128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960154 */     // MIs[0] policy
     /* 1960154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960164 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1960167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960188 */     // GIR_Coverage, 24908,
     /* 1960188 */     GIR_EraseRootFromParent_Done,
     /* 1960189 */   // Label 26301: @1960189
     /* 1960189 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1960275), // Rule ID 24909 //
     /* 1960194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1960197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1960202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1960211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1960214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960240 */     // MIs[0] policy
     /* 1960240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960250 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1960253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960274 */     // GIR_Coverage, 24909,
     /* 1960274 */     GIR_EraseRootFromParent_Done,
     /* 1960275 */   // Label 26302: @1960275
     /* 1960275 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1960361), // Rule ID 24912 //
     /* 1960280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960326 */     // MIs[0] policy
     /* 1960326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1960339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960360 */     // GIR_Coverage, 24912,
     /* 1960360 */     GIR_EraseRootFromParent_Done,
     /* 1960361 */   // Label 26303: @1960361
     /* 1960361 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1960447), // Rule ID 24913 //
     /* 1960366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960412 */     // MIs[0] policy
     /* 1960412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960422 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1960425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960446 */     // GIR_Coverage, 24913,
     /* 1960446 */     GIR_EraseRootFromParent_Done,
     /* 1960447 */   // Label 26304: @1960447
     /* 1960447 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1960533), // Rule ID 24916 //
     /* 1960452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960498 */     // MIs[0] policy
     /* 1960498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960508 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960532 */     // GIR_Coverage, 24916,
     /* 1960532 */     GIR_EraseRootFromParent_Done,
     /* 1960533 */   // Label 26305: @1960533
     /* 1960533 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1960619), // Rule ID 24917 //
     /* 1960538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960584 */     // MIs[0] policy
     /* 1960584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960594 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960618 */     // GIR_Coverage, 24917,
     /* 1960618 */     GIR_EraseRootFromParent_Done,
     /* 1960619 */   // Label 26306: @1960619
     /* 1960619 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1960705), // Rule ID 24920 //
     /* 1960624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960670 */     // MIs[0] policy
     /* 1960670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960680 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960704 */     // GIR_Coverage, 24920,
     /* 1960704 */     GIR_EraseRootFromParent_Done,
     /* 1960705 */   // Label 26307: @1960705
     /* 1960705 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1960791), // Rule ID 24921 //
     /* 1960710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960756 */     // MIs[0] policy
     /* 1960756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960766 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960790 */     // GIR_Coverage, 24921,
     /* 1960790 */     GIR_EraseRootFromParent_Done,
     /* 1960791 */   // Label 26308: @1960791
     /* 1960791 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1960877), // Rule ID 24924 //
     /* 1960796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960842 */     // MIs[0] policy
     /* 1960842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960876 */     // GIR_Coverage, 24924,
     /* 1960876 */     GIR_EraseRootFromParent_Done,
     /* 1960877 */   // Label 26309: @1960877
     /* 1960877 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1960963), // Rule ID 24925 //
     /* 1960882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1960885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960928 */     // MIs[0] policy
     /* 1960928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960938 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960962 */     // GIR_Coverage, 24925,
     /* 1960962 */     GIR_EraseRootFromParent_Done,
     /* 1960963 */   // Label 26310: @1960963
     /* 1960963 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1961049), // Rule ID 24928 //
     /* 1960968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1960971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961014 */     // MIs[0] policy
     /* 1961014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961048 */     // GIR_Coverage, 24928,
     /* 1961048 */     GIR_EraseRootFromParent_Done,
     /* 1961049 */   // Label 26311: @1961049
     /* 1961049 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1961135), // Rule ID 24929 //
     /* 1961054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1961065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1961068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1961071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961100 */     // MIs[0] policy
     /* 1961100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961110 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961134 */     // GIR_Coverage, 24929,
     /* 1961134 */     GIR_EraseRootFromParent_Done,
     /* 1961135 */   // Label 26312: @1961135
     /* 1961135 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1961221), // Rule ID 24932 //
     /* 1961140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1961143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961186 */     // MIs[0] policy
     /* 1961186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961220 */     // GIR_Coverage, 24932,
     /* 1961220 */     GIR_EraseRootFromParent_Done,
     /* 1961221 */   // Label 26313: @1961221
     /* 1961221 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1961307), // Rule ID 24933 //
     /* 1961226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1961229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961272 */     // MIs[0] policy
     /* 1961272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961282 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1961285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961306 */     // GIR_Coverage, 24933,
     /* 1961306 */     GIR_EraseRootFromParent_Done,
     /* 1961307 */   // Label 26314: @1961307
     /* 1961307 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1961393), // Rule ID 24936 //
     /* 1961312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961358 */     // MIs[0] policy
     /* 1961358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961368 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961392 */     // GIR_Coverage, 24936,
     /* 1961392 */     GIR_EraseRootFromParent_Done,
     /* 1961393 */   // Label 26315: @1961393
     /* 1961393 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1961479), // Rule ID 24937 //
     /* 1961398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961444 */     // MIs[0] policy
     /* 1961444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961454 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961478 */     // GIR_Coverage, 24937,
     /* 1961478 */     GIR_EraseRootFromParent_Done,
     /* 1961479 */   // Label 26316: @1961479
     /* 1961479 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1961565), // Rule ID 24940 //
     /* 1961484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961530 */     // MIs[0] policy
     /* 1961530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961564 */     // GIR_Coverage, 24940,
     /* 1961564 */     GIR_EraseRootFromParent_Done,
     /* 1961565 */   // Label 26317: @1961565
     /* 1961565 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1961651), // Rule ID 24941 //
     /* 1961570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961616 */     // MIs[0] policy
     /* 1961616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961626 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961650 */     // GIR_Coverage, 24941,
     /* 1961650 */     GIR_EraseRootFromParent_Done,
     /* 1961651 */   // Label 26318: @1961651
     /* 1961651 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1961737), // Rule ID 24944 //
     /* 1961656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961702 */     // MIs[0] policy
     /* 1961702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961712 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961736 */     // GIR_Coverage, 24944,
     /* 1961736 */     GIR_EraseRootFromParent_Done,
     /* 1961737 */   // Label 26319: @1961737
     /* 1961737 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1961823), // Rule ID 24945 //
     /* 1961742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961788 */     // MIs[0] policy
     /* 1961788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961798 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961822 */     // GIR_Coverage, 24945,
     /* 1961822 */     GIR_EraseRootFromParent_Done,
     /* 1961823 */   // Label 26320: @1961823
     /* 1961823 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1961909), // Rule ID 24948 //
     /* 1961828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1961831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961874 */     // MIs[0] policy
     /* 1961874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961884 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961908 */     // GIR_Coverage, 24948,
     /* 1961908 */     GIR_EraseRootFromParent_Done,
     /* 1961909 */   // Label 26321: @1961909
     /* 1961909 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1961995), // Rule ID 24949 //
     /* 1961914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1961917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961960 */     // MIs[0] policy
     /* 1961960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961970 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961994 */     // GIR_Coverage, 24949,
     /* 1961994 */     GIR_EraseRootFromParent_Done,
     /* 1961995 */   // Label 26322: @1961995
     /* 1961995 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1962081), // Rule ID 24952 //
     /* 1962000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1962017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962046 */     // MIs[0] policy
     /* 1962046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962056 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962080 */     // GIR_Coverage, 24952,
     /* 1962080 */     GIR_EraseRootFromParent_Done,
     /* 1962081 */   // Label 26323: @1962081
     /* 1962081 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1962167), // Rule ID 24953 //
     /* 1962086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1962103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962132 */     // MIs[0] policy
     /* 1962132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962166 */     // GIR_Coverage, 24953,
     /* 1962166 */     GIR_EraseRootFromParent_Done,
     /* 1962167 */   // Label 26324: @1962167
     /* 1962167 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1962253), // Rule ID 24956 //
     /* 1962172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962218 */     // MIs[0] policy
     /* 1962218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962228 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962252 */     // GIR_Coverage, 24956,
     /* 1962252 */     GIR_EraseRootFromParent_Done,
     /* 1962253 */   // Label 26325: @1962253
     /* 1962253 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1962339), // Rule ID 24957 //
     /* 1962258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962304 */     // MIs[0] policy
     /* 1962304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962314 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962338 */     // GIR_Coverage, 24957,
     /* 1962338 */     GIR_EraseRootFromParent_Done,
     /* 1962339 */   // Label 26326: @1962339
     /* 1962339 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1962425), // Rule ID 24960 //
     /* 1962344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962390 */     // MIs[0] policy
     /* 1962390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962400 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962424 */     // GIR_Coverage, 24960,
     /* 1962424 */     GIR_EraseRootFromParent_Done,
     /* 1962425 */   // Label 26327: @1962425
     /* 1962425 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1962511), // Rule ID 24961 //
     /* 1962430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962476 */     // MIs[0] policy
     /* 1962476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962510 */     // GIR_Coverage, 24961,
     /* 1962510 */     GIR_EraseRootFromParent_Done,
     /* 1962511 */   // Label 26328: @1962511
     /* 1962511 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1962597), // Rule ID 24964 //
     /* 1962516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962562 */     // MIs[0] policy
     /* 1962562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962572 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962596 */     // GIR_Coverage, 24964,
     /* 1962596 */     GIR_EraseRootFromParent_Done,
     /* 1962597 */   // Label 26329: @1962597
     /* 1962597 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1962683), // Rule ID 24965 //
     /* 1962602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962648 */     // MIs[0] policy
     /* 1962648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962658 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962682 */     // GIR_Coverage, 24965,
     /* 1962682 */     GIR_EraseRootFromParent_Done,
     /* 1962683 */   // Label 26330: @1962683
     /* 1962683 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1962769), // Rule ID 24968 //
     /* 1962688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1962691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962734 */     // MIs[0] policy
     /* 1962734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962744 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962768 */     // GIR_Coverage, 24968,
     /* 1962768 */     GIR_EraseRootFromParent_Done,
     /* 1962769 */   // Label 26331: @1962769
     /* 1962769 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1962855), // Rule ID 24969 //
     /* 1962774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1962777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962820 */     // MIs[0] policy
     /* 1962820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962830 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962854 */     // GIR_Coverage, 24969,
     /* 1962854 */     GIR_EraseRootFromParent_Done,
     /* 1962855 */   // Label 26332: @1962855
     /* 1962855 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1962941), // Rule ID 25032 //
     /* 1962860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1962863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962906 */     // MIs[0] policy
     /* 1962906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962940 */     // GIR_Coverage, 25032,
     /* 1962940 */     GIR_EraseRootFromParent_Done,
     /* 1962941 */   // Label 26333: @1962941
     /* 1962941 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1963027), // Rule ID 25033 //
     /* 1962946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1962949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962992 */     // MIs[0] policy
     /* 1962992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963002 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1963005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963026 */     // GIR_Coverage, 25033,
     /* 1963026 */     GIR_EraseRootFromParent_Done,
     /* 1963027 */   // Label 26334: @1963027
     /* 1963027 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1963113), // Rule ID 25036 //
     /* 1963032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1963043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1963046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1963049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963078 */     // MIs[0] policy
     /* 1963078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963088 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1963091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963112 */     // GIR_Coverage, 25036,
     /* 1963112 */     GIR_EraseRootFromParent_Done,
     /* 1963113 */   // Label 26335: @1963113
     /* 1963113 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1963199), // Rule ID 25037 //
     /* 1963118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1963129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1963132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1963135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963164 */     // MIs[0] policy
     /* 1963164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1963177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963198 */     // GIR_Coverage, 25037,
     /* 1963198 */     GIR_EraseRootFromParent_Done,
     /* 1963199 */   // Label 26336: @1963199
     /* 1963199 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1963285), // Rule ID 25040 //
     /* 1963204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1963221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963250 */     // MIs[0] policy
     /* 1963250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963260 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1963263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963284 */     // GIR_Coverage, 25040,
     /* 1963284 */     GIR_EraseRootFromParent_Done,
     /* 1963285 */   // Label 26337: @1963285
     /* 1963285 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1963371), // Rule ID 25041 //
     /* 1963290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1963307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963336 */     // MIs[0] policy
     /* 1963336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963346 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1963349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963370 */     // GIR_Coverage, 25041,
     /* 1963370 */     GIR_EraseRootFromParent_Done,
     /* 1963371 */   // Label 26338: @1963371
     /* 1963371 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1963457), // Rule ID 25044 //
     /* 1963376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963422 */     // MIs[0] policy
     /* 1963422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963432 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963456 */     // GIR_Coverage, 25044,
     /* 1963456 */     GIR_EraseRootFromParent_Done,
     /* 1963457 */   // Label 26339: @1963457
     /* 1963457 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1963543), // Rule ID 25045 //
     /* 1963462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963508 */     // MIs[0] policy
     /* 1963508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963518 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963542 */     // GIR_Coverage, 25045,
     /* 1963542 */     GIR_EraseRootFromParent_Done,
     /* 1963543 */   // Label 26340: @1963543
     /* 1963543 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1963629), // Rule ID 25048 //
     /* 1963548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963594 */     // MIs[0] policy
     /* 1963594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963628 */     // GIR_Coverage, 25048,
     /* 1963628 */     GIR_EraseRootFromParent_Done,
     /* 1963629 */   // Label 26341: @1963629
     /* 1963629 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1963715), // Rule ID 25049 //
     /* 1963634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963680 */     // MIs[0] policy
     /* 1963680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963714 */     // GIR_Coverage, 25049,
     /* 1963714 */     GIR_EraseRootFromParent_Done,
     /* 1963715 */   // Label 26342: @1963715
     /* 1963715 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1963801), // Rule ID 25052 //
     /* 1963720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1963723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963766 */     // MIs[0] policy
     /* 1963766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963800 */     // GIR_Coverage, 25052,
     /* 1963800 */     GIR_EraseRootFromParent_Done,
     /* 1963801 */   // Label 26343: @1963801
     /* 1963801 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1963887), // Rule ID 25053 //
     /* 1963806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1963809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963852 */     // MIs[0] policy
     /* 1963852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963886 */     // GIR_Coverage, 25053,
     /* 1963886 */     GIR_EraseRootFromParent_Done,
     /* 1963887 */   // Label 26344: @1963887
     /* 1963887 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1963973), // Rule ID 25056 //
     /* 1963892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1963895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963938 */     // MIs[0] policy
     /* 1963938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963948 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963972 */     // GIR_Coverage, 25056,
     /* 1963972 */     GIR_EraseRootFromParent_Done,
     /* 1963973 */   // Label 26345: @1963973
     /* 1963973 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1964059), // Rule ID 25057 //
     /* 1963978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1963981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964024 */     // MIs[0] policy
     /* 1964024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964034 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1964037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964058 */     // GIR_Coverage, 25057,
     /* 1964058 */     GIR_EraseRootFromParent_Done,
     /* 1964059 */   // Label 26346: @1964059
     /* 1964059 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1964145), // Rule ID 25060 //
     /* 1964064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964110 */     // MIs[0] policy
     /* 1964110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1964123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964144 */     // GIR_Coverage, 25060,
     /* 1964144 */     GIR_EraseRootFromParent_Done,
     /* 1964145 */   // Label 26347: @1964145
     /* 1964145 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1964231), // Rule ID 25061 //
     /* 1964150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1964161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1964164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964196 */     // MIs[0] policy
     /* 1964196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964206 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1964209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964230 */     // GIR_Coverage, 25061,
     /* 1964230 */     GIR_EraseRootFromParent_Done,
     /* 1964231 */   // Label 26348: @1964231
     /* 1964231 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1964317), // Rule ID 25064 //
     /* 1964236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1964247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1964250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1964253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1964256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1964259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964282 */     // MIs[0] policy
     /* 1964282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964292 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1964295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964316 */     // GIR_Coverage, 25064,
     /* 1964316 */     GIR_EraseRootFromParent_Done,
     /* 1964317 */   // Label 26349: @1964317
     /* 1964317 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1964403), // Rule ID 25065 //
     /* 1964322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1964333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1964336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1964339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1964342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1964345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964368 */     // MIs[0] policy
     /* 1964368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964378 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1964381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964402 */     // GIR_Coverage, 25065,
     /* 1964402 */     GIR_EraseRootFromParent_Done,
     /* 1964403 */   // Label 26350: @1964403
     /* 1964403 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1964489), // Rule ID 25068 //
     /* 1964408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964454 */     // MIs[0] policy
     /* 1964454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964488 */     // GIR_Coverage, 25068,
     /* 1964488 */     GIR_EraseRootFromParent_Done,
     /* 1964489 */   // Label 26351: @1964489
     /* 1964489 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1964575), // Rule ID 25069 //
     /* 1964494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964540 */     // MIs[0] policy
     /* 1964540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964550 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964574 */     // GIR_Coverage, 25069,
     /* 1964574 */     GIR_EraseRootFromParent_Done,
     /* 1964575 */   // Label 26352: @1964575
     /* 1964575 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1964661), // Rule ID 25072 //
     /* 1964580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964626 */     // MIs[0] policy
     /* 1964626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964660 */     // GIR_Coverage, 25072,
     /* 1964660 */     GIR_EraseRootFromParent_Done,
     /* 1964661 */   // Label 26353: @1964661
     /* 1964661 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1964747), // Rule ID 25073 //
     /* 1964666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964712 */     // MIs[0] policy
     /* 1964712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964722 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964746 */     // GIR_Coverage, 25073,
     /* 1964746 */     GIR_EraseRootFromParent_Done,
     /* 1964747 */   // Label 26354: @1964747
     /* 1964747 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1964833), // Rule ID 25076 //
     /* 1964752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1964755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964798 */     // MIs[0] policy
     /* 1964798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964808 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964832 */     // GIR_Coverage, 25076,
     /* 1964832 */     GIR_EraseRootFromParent_Done,
     /* 1964833 */   // Label 26355: @1964833
     /* 1964833 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1964919), // Rule ID 25077 //
     /* 1964838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1964841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964884 */     // MIs[0] policy
     /* 1964884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964894 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964918 */     // GIR_Coverage, 25077,
     /* 1964918 */     GIR_EraseRootFromParent_Done,
     /* 1964919 */   // Label 26356: @1964919
     /* 1964919 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1965005), // Rule ID 25080 //
     /* 1964924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1964927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964970 */     // MIs[0] policy
     /* 1964970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964980 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965004 */     // GIR_Coverage, 25080,
     /* 1965004 */     GIR_EraseRootFromParent_Done,
     /* 1965005 */   // Label 26357: @1965005
     /* 1965005 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1965091), // Rule ID 25081 //
     /* 1965010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1965030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965056 */     // MIs[0] policy
     /* 1965056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965066 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1965069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965090 */     // GIR_Coverage, 25081,
     /* 1965090 */     GIR_EraseRootFromParent_Done,
     /* 1965091 */   // Label 26358: @1965091
     /* 1965091 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1965177), // Rule ID 25084 //
     /* 1965096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1965099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1965116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965142 */     // MIs[0] policy
     /* 1965142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965152 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1965155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965176 */     // GIR_Coverage, 25084,
     /* 1965176 */     GIR_EraseRootFromParent_Done,
     /* 1965177 */   // Label 26359: @1965177
     /* 1965177 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1965263), // Rule ID 25085 //
     /* 1965182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1965202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965228 */     // MIs[0] policy
     /* 1965228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965238 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1965241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965262 */     // GIR_Coverage, 25085,
     /* 1965262 */     GIR_EraseRootFromParent_Done,
     /* 1965263 */   // Label 26360: @1965263
     /* 1965263 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1965349), // Rule ID 25088 //
     /* 1965268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1965271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1965288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965314 */     // MIs[0] policy
     /* 1965314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965324 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1965327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965348 */     // GIR_Coverage, 25088,
     /* 1965348 */     GIR_EraseRootFromParent_Done,
     /* 1965349 */   // Label 26361: @1965349
     /* 1965349 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1965435), // Rule ID 25089 //
     /* 1965354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1965357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1965362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1965374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965400 */     // MIs[0] policy
     /* 1965400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965410 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1965413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965434 */     // GIR_Coverage, 25089,
     /* 1965434 */     GIR_EraseRootFromParent_Done,
     /* 1965435 */   // Label 26362: @1965435
     /* 1965435 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1965521), // Rule ID 60976 //
     /* 1965440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965486 */     // MIs[0] policy
     /* 1965486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965520 */     // GIR_Coverage, 60976,
     /* 1965520 */     GIR_EraseRootFromParent_Done,
     /* 1965521 */   // Label 26363: @1965521
     /* 1965521 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1965607), // Rule ID 60977 //
     /* 1965526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965572 */     // MIs[0] policy
     /* 1965572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965582 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965606 */     // GIR_Coverage, 60977,
     /* 1965606 */     GIR_EraseRootFromParent_Done,
     /* 1965607 */   // Label 26364: @1965607
     /* 1965607 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1965693), // Rule ID 60980 //
     /* 1965612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965658 */     // MIs[0] policy
     /* 1965658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965692 */     // GIR_Coverage, 60980,
     /* 1965692 */     GIR_EraseRootFromParent_Done,
     /* 1965693 */   // Label 26365: @1965693
     /* 1965693 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1965779), // Rule ID 60981 //
     /* 1965698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965744 */     // MIs[0] policy
     /* 1965744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965754 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965778 */     // GIR_Coverage, 60981,
     /* 1965778 */     GIR_EraseRootFromParent_Done,
     /* 1965779 */   // Label 26366: @1965779
     /* 1965779 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1965865), // Rule ID 60984 //
     /* 1965784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965830 */     // MIs[0] policy
     /* 1965830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965864 */     // GIR_Coverage, 60984,
     /* 1965864 */     GIR_EraseRootFromParent_Done,
     /* 1965865 */   // Label 26367: @1965865
     /* 1965865 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1965951), // Rule ID 60985 //
     /* 1965870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965916 */     // MIs[0] policy
     /* 1965916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965950 */     // GIR_Coverage, 60985,
     /* 1965950 */     GIR_EraseRootFromParent_Done,
     /* 1965951 */   // Label 26368: @1965951
     /* 1965951 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1966037), // Rule ID 60988 //
     /* 1965956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966002 */     // MIs[0] policy
     /* 1966002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966036 */     // GIR_Coverage, 60988,
     /* 1966036 */     GIR_EraseRootFromParent_Done,
     /* 1966037 */   // Label 26369: @1966037
     /* 1966037 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1966123), // Rule ID 60989 //
     /* 1966042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1966053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1966056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1966059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1966062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966088 */     // MIs[0] policy
     /* 1966088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966122 */     // GIR_Coverage, 60989,
     /* 1966122 */     GIR_EraseRootFromParent_Done,
     /* 1966123 */   // Label 26370: @1966123
     /* 1966123 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1966209), // Rule ID 60992 //
     /* 1966128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1966148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966174 */     // MIs[0] policy
     /* 1966174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966208 */     // GIR_Coverage, 60992,
     /* 1966208 */     GIR_EraseRootFromParent_Done,
     /* 1966209 */   // Label 26371: @1966209
     /* 1966209 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1966295), // Rule ID 60993 //
     /* 1966214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1966234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966260 */     // MIs[0] policy
     /* 1966260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966294 */     // GIR_Coverage, 60993,
     /* 1966294 */     GIR_EraseRootFromParent_Done,
     /* 1966295 */   // Label 26372: @1966295
     /* 1966295 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1966381), // Rule ID 60996 //
     /* 1966300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1966320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966346 */     // MIs[0] policy
     /* 1966346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966380 */     // GIR_Coverage, 60996,
     /* 1966380 */     GIR_EraseRootFromParent_Done,
     /* 1966381 */   // Label 26373: @1966381
     /* 1966381 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1966467), // Rule ID 60997 //
     /* 1966386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1966406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966432 */     // MIs[0] policy
     /* 1966432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966466 */     // GIR_Coverage, 60997,
     /* 1966466 */     GIR_EraseRootFromParent_Done,
     /* 1966467 */   // Label 26374: @1966467
     /* 1966467 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1966553), // Rule ID 61000 //
     /* 1966472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966518 */     // MIs[0] policy
     /* 1966518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966528 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966552 */     // GIR_Coverage, 61000,
     /* 1966552 */     GIR_EraseRootFromParent_Done,
     /* 1966553 */   // Label 26375: @1966553
     /* 1966553 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1966639), // Rule ID 61001 //
     /* 1966558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966604 */     // MIs[0] policy
     /* 1966604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966638 */     // GIR_Coverage, 61001,
     /* 1966638 */     GIR_EraseRootFromParent_Done,
     /* 1966639 */   // Label 26376: @1966639
     /* 1966639 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1966725), // Rule ID 61004 //
     /* 1966644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966690 */     // MIs[0] policy
     /* 1966690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966724 */     // GIR_Coverage, 61004,
     /* 1966724 */     GIR_EraseRootFromParent_Done,
     /* 1966725 */   // Label 26377: @1966725
     /* 1966725 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1966811), // Rule ID 61005 //
     /* 1966730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966776 */     // MIs[0] policy
     /* 1966776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966810 */     // GIR_Coverage, 61005,
     /* 1966810 */     GIR_EraseRootFromParent_Done,
     /* 1966811 */   // Label 26378: @1966811
     /* 1966811 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1966897), // Rule ID 61008 //
     /* 1966816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966862 */     // MIs[0] policy
     /* 1966862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966896 */     // GIR_Coverage, 61008,
     /* 1966896 */     GIR_EraseRootFromParent_Done,
     /* 1966897 */   // Label 26379: @1966897
     /* 1966897 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1966983), // Rule ID 61009 //
     /* 1966902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966948 */     // MIs[0] policy
     /* 1966948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966982 */     // GIR_Coverage, 61009,
     /* 1966982 */     GIR_EraseRootFromParent_Done,
     /* 1966983 */   // Label 26380: @1966983
     /* 1966983 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1967069), // Rule ID 61012 //
     /* 1966988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967034 */     // MIs[0] policy
     /* 1967034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967068 */     // GIR_Coverage, 61012,
     /* 1967068 */     GIR_EraseRootFromParent_Done,
     /* 1967069 */   // Label 26381: @1967069
     /* 1967069 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1967155), // Rule ID 61013 //
     /* 1967074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1967085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1967088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1967091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1967094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967120 */     // MIs[0] policy
     /* 1967120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967154 */     // GIR_Coverage, 61013,
     /* 1967154 */     GIR_EraseRootFromParent_Done,
     /* 1967155 */   // Label 26382: @1967155
     /* 1967155 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1967241), // Rule ID 61016 //
     /* 1967160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967206 */     // MIs[0] policy
     /* 1967206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967240 */     // GIR_Coverage, 61016,
     /* 1967240 */     GIR_EraseRootFromParent_Done,
     /* 1967241 */   // Label 26383: @1967241
     /* 1967241 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1967327), // Rule ID 61017 //
     /* 1967246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1967266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967292 */     // MIs[0] policy
     /* 1967292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967326 */     // GIR_Coverage, 61017,
     /* 1967326 */     GIR_EraseRootFromParent_Done,
     /* 1967327 */   // Label 26384: @1967327
     /* 1967327 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1967413), // Rule ID 61020 //
     /* 1967332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967378 */     // MIs[0] policy
     /* 1967378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967388 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967412 */     // GIR_Coverage, 61020,
     /* 1967412 */     GIR_EraseRootFromParent_Done,
     /* 1967413 */   // Label 26385: @1967413
     /* 1967413 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1967499), // Rule ID 61021 //
     /* 1967418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967464 */     // MIs[0] policy
     /* 1967464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967498 */     // GIR_Coverage, 61021,
     /* 1967498 */     GIR_EraseRootFromParent_Done,
     /* 1967499 */   // Label 26386: @1967499
     /* 1967499 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1967585), // Rule ID 61024 //
     /* 1967504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967550 */     // MIs[0] policy
     /* 1967550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967584 */     // GIR_Coverage, 61024,
     /* 1967584 */     GIR_EraseRootFromParent_Done,
     /* 1967585 */   // Label 26387: @1967585
     /* 1967585 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1967671), // Rule ID 61025 //
     /* 1967590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967636 */     // MIs[0] policy
     /* 1967636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967670 */     // GIR_Coverage, 61025,
     /* 1967670 */     GIR_EraseRootFromParent_Done,
     /* 1967671 */   // Label 26388: @1967671
     /* 1967671 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1967757), // Rule ID 61028 //
     /* 1967676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967722 */     // MIs[0] policy
     /* 1967722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967756 */     // GIR_Coverage, 61028,
     /* 1967756 */     GIR_EraseRootFromParent_Done,
     /* 1967757 */   // Label 26389: @1967757
     /* 1967757 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1967843), // Rule ID 61029 //
     /* 1967762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967808 */     // MIs[0] policy
     /* 1967808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967842 */     // GIR_Coverage, 61029,
     /* 1967842 */     GIR_EraseRootFromParent_Done,
     /* 1967843 */   // Label 26390: @1967843
     /* 1967843 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1967929), // Rule ID 61032 //
     /* 1967848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967894 */     // MIs[0] policy
     /* 1967894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967928 */     // GIR_Coverage, 61032,
     /* 1967928 */     GIR_EraseRootFromParent_Done,
     /* 1967929 */   // Label 26391: @1967929
     /* 1967929 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1968015), // Rule ID 61033 //
     /* 1967934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967980 */     // MIs[0] policy
     /* 1967980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967990 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1968011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968014 */     // GIR_Coverage, 61033,
     /* 1968014 */     GIR_EraseRootFromParent_Done,
     /* 1968015 */   // Label 26392: @1968015
     /* 1968015 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1968101), // Rule ID 61036 //
     /* 1968020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968066 */     // MIs[0] policy
     /* 1968066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1968079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968100 */     // GIR_Coverage, 61036,
     /* 1968100 */     GIR_EraseRootFromParent_Done,
     /* 1968101 */   // Label 26393: @1968101
     /* 1968101 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1968187), // Rule ID 61037 //
     /* 1968106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1968117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1968120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1968123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968152 */     // MIs[0] policy
     /* 1968152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1968165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968186 */     // GIR_Coverage, 61037,
     /* 1968186 */     GIR_EraseRootFromParent_Done,
     /* 1968187 */   // Label 26394: @1968187
     /* 1968187 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1968273), // Rule ID 61044 //
     /* 1968192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1968203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1968206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1968209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968238 */     // MIs[0] policy
     /* 1968238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968272 */     // GIR_Coverage, 61044,
     /* 1968272 */     GIR_EraseRootFromParent_Done,
     /* 1968273 */   // Label 26395: @1968273
     /* 1968273 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1968359), // Rule ID 61045 //
     /* 1968278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1968289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1968292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1968295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968324 */     // MIs[0] policy
     /* 1968324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968358 */     // GIR_Coverage, 61045,
     /* 1968358 */     GIR_EraseRootFromParent_Done,
     /* 1968359 */   // Label 26396: @1968359
     /* 1968359 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1968445), // Rule ID 61052 //
     /* 1968364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1968375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1968378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968410 */     // MIs[0] policy
     /* 1968410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968444 */     // GIR_Coverage, 61052,
     /* 1968444 */     GIR_EraseRootFromParent_Done,
     /* 1968445 */   // Label 26397: @1968445
     /* 1968445 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1968531), // Rule ID 61053 //
     /* 1968450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1968461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1968464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968496 */     // MIs[0] policy
     /* 1968496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11722:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968530 */     // GIR_Coverage, 61053,
     /* 1968530 */     GIR_EraseRootFromParent_Done,
     /* 1968531 */   // Label 26398: @1968531
     /* 1968531 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1968617), // Rule ID 61060 //
     /* 1968536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968582 */     // MIs[0] policy
     /* 1968582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968616 */     // GIR_Coverage, 61060,
     /* 1968616 */     GIR_EraseRootFromParent_Done,
     /* 1968617 */   // Label 26399: @1968617
     /* 1968617 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1968703), // Rule ID 61061 //
     /* 1968622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968668 */     // MIs[0] policy
     /* 1968668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968702 */     // GIR_Coverage, 61061,
     /* 1968702 */     GIR_EraseRootFromParent_Done,
     /* 1968703 */   // Label 26400: @1968703
     /* 1968703 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1968789), // Rule ID 61068 //
     /* 1968708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968754 */     // MIs[0] policy
     /* 1968754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968788 */     // GIR_Coverage, 61068,
     /* 1968788 */     GIR_EraseRootFromParent_Done,
     /* 1968789 */   // Label 26401: @1968789
     /* 1968789 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1968875), // Rule ID 61069 //
     /* 1968794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968840 */     // MIs[0] policy
     /* 1968840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968874 */     // GIR_Coverage, 61069,
     /* 1968874 */     GIR_EraseRootFromParent_Done,
     /* 1968875 */   // Label 26402: @1968875
     /* 1968875 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1968961), // Rule ID 61076 //
     /* 1968880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968926 */     // MIs[0] policy
     /* 1968926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968960 */     // GIR_Coverage, 61076,
     /* 1968960 */     GIR_EraseRootFromParent_Done,
     /* 1968961 */   // Label 26403: @1968961
     /* 1968961 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1969047), // Rule ID 61077 //
     /* 1968966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969012 */     // MIs[0] policy
     /* 1969012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1969043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969046 */     // GIR_Coverage, 61077,
     /* 1969046 */     GIR_EraseRootFromParent_Done,
     /* 1969047 */   // Label 26404: @1969047
     /* 1969047 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1969133), // Rule ID 61084 //
     /* 1969052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969098 */     // MIs[0] policy
     /* 1969098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1969111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969132 */     // GIR_Coverage, 61084,
     /* 1969132 */     GIR_EraseRootFromParent_Done,
     /* 1969133 */   // Label 26405: @1969133
     /* 1969133 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1969219), // Rule ID 61085 //
     /* 1969138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1969149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1969152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1969155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969184 */     // MIs[0] policy
     /* 1969184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1969197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969218 */     // GIR_Coverage, 61085,
     /* 1969218 */     GIR_EraseRootFromParent_Done,
     /* 1969219 */   // Label 26406: @1969219
     /* 1969219 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1969305), // Rule ID 61092 //
     /* 1969224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1969235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1969238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1969241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969270 */     // MIs[0] policy
     /* 1969270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969304 */     // GIR_Coverage, 61092,
     /* 1969304 */     GIR_EraseRootFromParent_Done,
     /* 1969305 */   // Label 26407: @1969305
     /* 1969305 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1969391), // Rule ID 61093 //
     /* 1969310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1969321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1969324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1969327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969356 */     // MIs[0] policy
     /* 1969356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11722:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969390 */     // GIR_Coverage, 61093,
     /* 1969390 */     GIR_EraseRootFromParent_Done,
     /* 1969391 */   // Label 26408: @1969391
     /* 1969391 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1969477), // Rule ID 61100 //
     /* 1969396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969442 */     // MIs[0] policy
     /* 1969442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969476 */     // GIR_Coverage, 61100,
     /* 1969476 */     GIR_EraseRootFromParent_Done,
     /* 1969477 */   // Label 26409: @1969477
     /* 1969477 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1969563), // Rule ID 61101 //
     /* 1969482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969528 */     // MIs[0] policy
     /* 1969528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969562 */     // GIR_Coverage, 61101,
     /* 1969562 */     GIR_EraseRootFromParent_Done,
     /* 1969563 */   // Label 26410: @1969563
     /* 1969563 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1969649), // Rule ID 61108 //
     /* 1969568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969614 */     // MIs[0] policy
     /* 1969614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969648 */     // GIR_Coverage, 61108,
     /* 1969648 */     GIR_EraseRootFromParent_Done,
     /* 1969649 */   // Label 26411: @1969649
     /* 1969649 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1969735), // Rule ID 61109 //
     /* 1969654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969700 */     // MIs[0] policy
     /* 1969700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969734 */     // GIR_Coverage, 61109,
     /* 1969734 */     GIR_EraseRootFromParent_Done,
     /* 1969735 */   // Label 26412: @1969735
     /* 1969735 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1969821), // Rule ID 61116 //
     /* 1969740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969786 */     // MIs[0] policy
     /* 1969786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969820 */     // GIR_Coverage, 61116,
     /* 1969820 */     GIR_EraseRootFromParent_Done,
     /* 1969821 */   // Label 26413: @1969821
     /* 1969821 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1969907), // Rule ID 61117 //
     /* 1969826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969872 */     // MIs[0] policy
     /* 1969872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969906 */     // GIR_Coverage, 61117,
     /* 1969906 */     GIR_EraseRootFromParent_Done,
     /* 1969907 */   // Label 26414: @1969907
     /* 1969907 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1969993), // Rule ID 61124 //
     /* 1969912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969958 */     // MIs[0] policy
     /* 1969958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969992 */     // GIR_Coverage, 61124,
     /* 1969992 */     GIR_EraseRootFromParent_Done,
     /* 1969993 */   // Label 26415: @1969993
     /* 1969993 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1970079), // Rule ID 61125 //
     /* 1969998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970044 */     // MIs[0] policy
     /* 1970044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11722:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1970057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970078 */     // GIR_Coverage, 61125,
     /* 1970078 */     GIR_EraseRootFromParent_Done,
     /* 1970079 */   // Label 26416: @1970079
     /* 1970079 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1970165), // Rule ID 61132 //
     /* 1970084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970130 */     // MIs[0] policy
     /* 1970130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1970143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970164 */     // GIR_Coverage, 61132,
     /* 1970164 */     GIR_EraseRootFromParent_Done,
     /* 1970165 */   // Label 26417: @1970165
     /* 1970165 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1970251), // Rule ID 61133 //
     /* 1970170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1970187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970216 */     // MIs[0] policy
     /* 1970216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11722:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1970229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970250 */     // GIR_Coverage, 61133,
     /* 1970250 */     GIR_EraseRootFromParent_Done,
     /* 1970251 */   // Label 26418: @1970251
     /* 1970251 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1970337), // Rule ID 61140 //
     /* 1970256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1970273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970302 */     // MIs[0] policy
     /* 1970302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970312 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1970315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970336 */     // GIR_Coverage, 61140,
     /* 1970336 */     GIR_EraseRootFromParent_Done,
     /* 1970337 */   // Label 26419: @1970337
     /* 1970337 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1970423), // Rule ID 61141 //
     /* 1970342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1970359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970388 */     // MIs[0] policy
     /* 1970388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11722:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1970401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970422 */     // GIR_Coverage, 61141,
     /* 1970422 */     GIR_EraseRootFromParent_Done,
     /* 1970423 */   // Label 26420: @1970423
     /* 1970423 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1970509), // Rule ID 61148 //
     /* 1970428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1970431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970474 */     // MIs[0] policy
     /* 1970474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970508 */     // GIR_Coverage, 61148,
     /* 1970508 */     GIR_EraseRootFromParent_Done,
     /* 1970509 */   // Label 26421: @1970509
     /* 1970509 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1970595), // Rule ID 61149 //
     /* 1970514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970560 */     // MIs[0] policy
     /* 1970560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11722:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970594 */     // GIR_Coverage, 61149,
     /* 1970594 */     GIR_EraseRootFromParent_Done,
     /* 1970595 */   // Label 26422: @1970595
     /* 1970595 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1970681), // Rule ID 61156 //
     /* 1970600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970646 */     // MIs[0] policy
     /* 1970646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970656 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970680 */     // GIR_Coverage, 61156,
     /* 1970680 */     GIR_EraseRootFromParent_Done,
     /* 1970681 */   // Label 26423: @1970681
     /* 1970681 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1970767), // Rule ID 61157 //
     /* 1970686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970732 */     // MIs[0] policy
     /* 1970732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970766 */     // GIR_Coverage, 61157,
     /* 1970766 */     GIR_EraseRootFromParent_Done,
     /* 1970767 */   // Label 26424: @1970767
     /* 1970767 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1970853), // Rule ID 61160 //
     /* 1970772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970818 */     // MIs[0] policy
     /* 1970818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970852 */     // GIR_Coverage, 61160,
     /* 1970852 */     GIR_EraseRootFromParent_Done,
     /* 1970853 */   // Label 26425: @1970853
     /* 1970853 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1970939), // Rule ID 61161 //
     /* 1970858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970904 */     // MIs[0] policy
     /* 1970904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970938 */     // GIR_Coverage, 61161,
     /* 1970938 */     GIR_EraseRootFromParent_Done,
     /* 1970939 */   // Label 26426: @1970939
     /* 1970939 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1971025), // Rule ID 61164 //
     /* 1970944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970990 */     // MIs[0] policy
     /* 1970990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1971003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971024 */     // GIR_Coverage, 61164,
     /* 1971024 */     GIR_EraseRootFromParent_Done,
     /* 1971025 */   // Label 26427: @1971025
     /* 1971025 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1971111), // Rule ID 61165 //
     /* 1971030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971076 */     // MIs[0] policy
     /* 1971076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1971089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971110 */     // GIR_Coverage, 61165,
     /* 1971110 */     GIR_EraseRootFromParent_Done,
     /* 1971111 */   // Label 26428: @1971111
     /* 1971111 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1971197), // Rule ID 61168 //
     /* 1971116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1971136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971162 */     // MIs[0] policy
     /* 1971162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1971175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971196 */     // GIR_Coverage, 61168,
     /* 1971196 */     GIR_EraseRootFromParent_Done,
     /* 1971197 */   // Label 26429: @1971197
     /* 1971197 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1971283), // Rule ID 61169 //
     /* 1971202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1971222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971248 */     // MIs[0] policy
     /* 1971248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1971261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971282 */     // GIR_Coverage, 61169,
     /* 1971282 */     GIR_EraseRootFromParent_Done,
     /* 1971283 */   // Label 26430: @1971283
     /* 1971283 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1971369), // Rule ID 61172 //
     /* 1971288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971334 */     // MIs[0] policy
     /* 1971334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1971347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971368 */     // GIR_Coverage, 61172,
     /* 1971368 */     GIR_EraseRootFromParent_Done,
     /* 1971369 */   // Label 26431: @1971369
     /* 1971369 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1971455), // Rule ID 61173 //
     /* 1971374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971420 */     // MIs[0] policy
     /* 1971420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1971433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971454 */     // GIR_Coverage, 61173,
     /* 1971454 */     GIR_EraseRootFromParent_Done,
     /* 1971455 */   // Label 26432: @1971455
     /* 1971455 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1971541), // Rule ID 61176 //
     /* 1971460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971506 */     // MIs[0] policy
     /* 1971506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971540 */     // GIR_Coverage, 61176,
     /* 1971540 */     GIR_EraseRootFromParent_Done,
     /* 1971541 */   // Label 26433: @1971541
     /* 1971541 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1971627), // Rule ID 61177 //
     /* 1971546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971592 */     // MIs[0] policy
     /* 1971592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971626 */     // GIR_Coverage, 61177,
     /* 1971626 */     GIR_EraseRootFromParent_Done,
     /* 1971627 */   // Label 26434: @1971627
     /* 1971627 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1971713), // Rule ID 61180 //
     /* 1971632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971678 */     // MIs[0] policy
     /* 1971678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971688 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971712 */     // GIR_Coverage, 61180,
     /* 1971712 */     GIR_EraseRootFromParent_Done,
     /* 1971713 */   // Label 26435: @1971713
     /* 1971713 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1971799), // Rule ID 61181 //
     /* 1971718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971764 */     // MIs[0] policy
     /* 1971764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971798 */     // GIR_Coverage, 61181,
     /* 1971798 */     GIR_EraseRootFromParent_Done,
     /* 1971799 */   // Label 26436: @1971799
     /* 1971799 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1971885), // Rule ID 61184 //
     /* 1971804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971850 */     // MIs[0] policy
     /* 1971850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971884 */     // GIR_Coverage, 61184,
     /* 1971884 */     GIR_EraseRootFromParent_Done,
     /* 1971885 */   // Label 26437: @1971885
     /* 1971885 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1971971), // Rule ID 61185 //
     /* 1971890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971936 */     // MIs[0] policy
     /* 1971936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971970 */     // GIR_Coverage, 61185,
     /* 1971970 */     GIR_EraseRootFromParent_Done,
     /* 1971971 */   // Label 26438: @1971971
     /* 1971971 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1972057), // Rule ID 61188 //
     /* 1971976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972022 */     // MIs[0] policy
     /* 1972022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1972035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972056 */     // GIR_Coverage, 61188,
     /* 1972056 */     GIR_EraseRootFromParent_Done,
     /* 1972057 */   // Label 26439: @1972057
     /* 1972057 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1972143), // Rule ID 61189 //
     /* 1972062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1972082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972108 */     // MIs[0] policy
     /* 1972108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1972121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972142 */     // GIR_Coverage, 61189,
     /* 1972142 */     GIR_EraseRootFromParent_Done,
     /* 1972143 */   // Label 26440: @1972143
     /* 1972143 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1972229), // Rule ID 61192 //
     /* 1972148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1972168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972194 */     // MIs[0] policy
     /* 1972194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1972207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972228 */     // GIR_Coverage, 61192,
     /* 1972228 */     GIR_EraseRootFromParent_Done,
     /* 1972229 */   // Label 26441: @1972229
     /* 1972229 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1972315), // Rule ID 61193 //
     /* 1972234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1972254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972280 */     // MIs[0] policy
     /* 1972280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1972293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972314 */     // GIR_Coverage, 61193,
     /* 1972314 */     GIR_EraseRootFromParent_Done,
     /* 1972315 */   // Label 26442: @1972315
     /* 1972315 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1972401), // Rule ID 61196 //
     /* 1972320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1972340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972366 */     // MIs[0] policy
     /* 1972366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1972379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972400 */     // GIR_Coverage, 61196,
     /* 1972400 */     GIR_EraseRootFromParent_Done,
     /* 1972401 */   // Label 26443: @1972401
     /* 1972401 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1972487), // Rule ID 61197 //
     /* 1972406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1972426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972452 */     // MIs[0] policy
     /* 1972452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972462 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1972465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972486 */     // GIR_Coverage, 61197,
     /* 1972486 */     GIR_EraseRootFromParent_Done,
     /* 1972487 */   // Label 26444: @1972487
     /* 1972487 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1972573), // Rule ID 61200 //
     /* 1972492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972538 */     // MIs[0] policy
     /* 1972538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972548 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972572 */     // GIR_Coverage, 61200,
     /* 1972572 */     GIR_EraseRootFromParent_Done,
     /* 1972573 */   // Label 26445: @1972573
     /* 1972573 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1972659), // Rule ID 61201 //
     /* 1972578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972624 */     // MIs[0] policy
     /* 1972624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972658 */     // GIR_Coverage, 61201,
     /* 1972658 */     GIR_EraseRootFromParent_Done,
     /* 1972659 */   // Label 26446: @1972659
     /* 1972659 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1972745), // Rule ID 61204 //
     /* 1972664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972710 */     // MIs[0] policy
     /* 1972710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972744 */     // GIR_Coverage, 61204,
     /* 1972744 */     GIR_EraseRootFromParent_Done,
     /* 1972745 */   // Label 26447: @1972745
     /* 1972745 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1972831), // Rule ID 61205 //
     /* 1972750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972796 */     // MIs[0] policy
     /* 1972796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972806 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972830 */     // GIR_Coverage, 61205,
     /* 1972830 */     GIR_EraseRootFromParent_Done,
     /* 1972831 */   // Label 26448: @1972831
     /* 1972831 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1972917), // Rule ID 61208 //
     /* 1972836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972882 */     // MIs[0] policy
     /* 1972882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972916 */     // GIR_Coverage, 61208,
     /* 1972916 */     GIR_EraseRootFromParent_Done,
     /* 1972917 */   // Label 26449: @1972917
     /* 1972917 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1973003), // Rule ID 61209 //
     /* 1972922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972968 */     // MIs[0] policy
     /* 1972968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972978 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973002 */     // GIR_Coverage, 61209,
     /* 1973002 */     GIR_EraseRootFromParent_Done,
     /* 1973003 */   // Label 26450: @1973003
     /* 1973003 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1973089), // Rule ID 61212 //
     /* 1973008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1973011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973054 */     // MIs[0] policy
     /* 1973054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1973067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973088 */     // GIR_Coverage, 61212,
     /* 1973088 */     GIR_EraseRootFromParent_Done,
     /* 1973089 */   // Label 26451: @1973089
     /* 1973089 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1973175), // Rule ID 61213 //
     /* 1973094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1973097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973140 */     // MIs[0] policy
     /* 1973140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973150 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1973153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973174 */     // GIR_Coverage, 61213,
     /* 1973174 */     GIR_EraseRootFromParent_Done,
     /* 1973175 */   // Label 26452: @1973175
     /* 1973175 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1973261), // Rule ID 61216 //
     /* 1973180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1973183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973226 */     // MIs[0] policy
     /* 1973226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973236 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1973239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973260 */     // GIR_Coverage, 61216,
     /* 1973260 */     GIR_EraseRootFromParent_Done,
     /* 1973261 */   // Label 26453: @1973261
     /* 1973261 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1973347), // Rule ID 61217 //
     /* 1973266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1973269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1973274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973312 */     // MIs[0] policy
     /* 1973312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973322 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1973325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973346 */     // GIR_Coverage, 61217,
     /* 1973346 */     GIR_EraseRootFromParent_Done,
     /* 1973347 */   // Label 26454: @1973347
     /* 1973347 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1973433), // Rule ID 61220 //
     /* 1973352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973398 */     // MIs[0] policy
     /* 1973398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973432 */     // GIR_Coverage, 61220,
     /* 1973432 */     GIR_EraseRootFromParent_Done,
     /* 1973433 */   // Label 26455: @1973433
     /* 1973433 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1973519), // Rule ID 61221 //
     /* 1973438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973484 */     // MIs[0] policy
     /* 1973484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973494 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973518 */     // GIR_Coverage, 61221,
     /* 1973518 */     GIR_EraseRootFromParent_Done,
     /* 1973519 */   // Label 26456: @1973519
     /* 1973519 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1973605), // Rule ID 61224 //
     /* 1973524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973570 */     // MIs[0] policy
     /* 1973570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973580 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973604 */     // GIR_Coverage, 61224,
     /* 1973604 */     GIR_EraseRootFromParent_Done,
     /* 1973605 */   // Label 26457: @1973605
     /* 1973605 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1973691), // Rule ID 61225 //
     /* 1973610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973656 */     // MIs[0] policy
     /* 1973656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973690 */     // GIR_Coverage, 61225,
     /* 1973690 */     GIR_EraseRootFromParent_Done,
     /* 1973691 */   // Label 26458: @1973691
     /* 1973691 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1973777), // Rule ID 61228 //
     /* 1973696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973742 */     // MIs[0] policy
     /* 1973742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973776 */     // GIR_Coverage, 61228,
     /* 1973776 */     GIR_EraseRootFromParent_Done,
     /* 1973777 */   // Label 26459: @1973777
     /* 1973777 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1973863), // Rule ID 61229 //
     /* 1973782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973828 */     // MIs[0] policy
     /* 1973828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973838 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973862 */     // GIR_Coverage, 61229,
     /* 1973862 */     GIR_EraseRootFromParent_Done,
     /* 1973863 */   // Label 26460: @1973863
     /* 1973863 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1973949), // Rule ID 61232 //
     /* 1973868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973914 */     // MIs[0] policy
     /* 1973914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973948 */     // GIR_Coverage, 61232,
     /* 1973948 */     GIR_EraseRootFromParent_Done,
     /* 1973949 */   // Label 26461: @1973949
     /* 1973949 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1974035), // Rule ID 61233 //
     /* 1973954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974000 */     // MIs[0] policy
     /* 1974000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1974013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974034 */     // GIR_Coverage, 61233,
     /* 1974034 */     GIR_EraseRootFromParent_Done,
     /* 1974035 */   // Label 26462: @1974035
     /* 1974035 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1974121), // Rule ID 61236 //
     /* 1974040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974086 */     // MIs[0] policy
     /* 1974086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974120 */     // GIR_Coverage, 61236,
     /* 1974120 */     GIR_EraseRootFromParent_Done,
     /* 1974121 */   // Label 26463: @1974121
     /* 1974121 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1974207), // Rule ID 61237 //
     /* 1974126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974172 */     // MIs[0] policy
     /* 1974172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974182 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974206 */     // GIR_Coverage, 61237,
     /* 1974206 */     GIR_EraseRootFromParent_Done,
     /* 1974207 */   // Label 26464: @1974207
     /* 1974207 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1974293), // Rule ID 61240 //
     /* 1974212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974258 */     // MIs[0] policy
     /* 1974258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974292 */     // GIR_Coverage, 61240,
     /* 1974292 */     GIR_EraseRootFromParent_Done,
     /* 1974293 */   // Label 26465: @1974293
     /* 1974293 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1974379), // Rule ID 61241 //
     /* 1974298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974344 */     // MIs[0] policy
     /* 1974344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1974357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974378 */     // GIR_Coverage, 61241,
     /* 1974378 */     GIR_EraseRootFromParent_Done,
     /* 1974379 */   // Label 26466: @1974379
     /* 1974379 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1974465), // Rule ID 61244 //
     /* 1974384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974430 */     // MIs[0] policy
     /* 1974430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974464 */     // GIR_Coverage, 61244,
     /* 1974464 */     GIR_EraseRootFromParent_Done,
     /* 1974465 */   // Label 26467: @1974465
     /* 1974465 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1974551), // Rule ID 61245 //
     /* 1974470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974516 */     // MIs[0] policy
     /* 1974516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974550 */     // GIR_Coverage, 61245,
     /* 1974550 */     GIR_EraseRootFromParent_Done,
     /* 1974551 */   // Label 26468: @1974551
     /* 1974551 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1974637), // Rule ID 61248 //
     /* 1974556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974602 */     // MIs[0] policy
     /* 1974602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974636 */     // GIR_Coverage, 61248,
     /* 1974636 */     GIR_EraseRootFromParent_Done,
     /* 1974637 */   // Label 26469: @1974637
     /* 1974637 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1974723), // Rule ID 61249 //
     /* 1974642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974688 */     // MIs[0] policy
     /* 1974688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974722 */     // GIR_Coverage, 61249,
     /* 1974722 */     GIR_EraseRootFromParent_Done,
     /* 1974723 */   // Label 26470: @1974723
     /* 1974723 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1974809), // Rule ID 61252 //
     /* 1974728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974774 */     // MIs[0] policy
     /* 1974774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974808 */     // GIR_Coverage, 61252,
     /* 1974808 */     GIR_EraseRootFromParent_Done,
     /* 1974809 */   // Label 26471: @1974809
     /* 1974809 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1974895), // Rule ID 61253 //
     /* 1974814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974860 */     // MIs[0] policy
     /* 1974860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974894 */     // GIR_Coverage, 61253,
     /* 1974894 */     GIR_EraseRootFromParent_Done,
     /* 1974895 */   // Label 26472: @1974895
     /* 1974895 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1974981), // Rule ID 61256 //
     /* 1974900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974946 */     // MIs[0] policy
     /* 1974946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974980 */     // GIR_Coverage, 61256,
     /* 1974980 */     GIR_EraseRootFromParent_Done,
     /* 1974981 */   // Label 26473: @1974981
     /* 1974981 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1975067), // Rule ID 61257 //
     /* 1974986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975032 */     // MIs[0] policy
     /* 1975032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1975045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975066 */     // GIR_Coverage, 61257,
     /* 1975066 */     GIR_EraseRootFromParent_Done,
     /* 1975067 */   // Label 26474: @1975067
     /* 1975067 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1975153), // Rule ID 61260 //
     /* 1975072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975118 */     // MIs[0] policy
     /* 1975118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975152 */     // GIR_Coverage, 61260,
     /* 1975152 */     GIR_EraseRootFromParent_Done,
     /* 1975153 */   // Label 26475: @1975153
     /* 1975153 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1975239), // Rule ID 61261 //
     /* 1975158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975204 */     // MIs[0] policy
     /* 1975204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975238 */     // GIR_Coverage, 61261,
     /* 1975238 */     GIR_EraseRootFromParent_Done,
     /* 1975239 */   // Label 26476: @1975239
     /* 1975239 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1975325), // Rule ID 61264 //
     /* 1975244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975290 */     // MIs[0] policy
     /* 1975290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975300 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975324 */     // GIR_Coverage, 61264,
     /* 1975324 */     GIR_EraseRootFromParent_Done,
     /* 1975325 */   // Label 26477: @1975325
     /* 1975325 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1975411), // Rule ID 61265 //
     /* 1975330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975376 */     // MIs[0] policy
     /* 1975376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975386 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975410 */     // GIR_Coverage, 61265,
     /* 1975410 */     GIR_EraseRootFromParent_Done,
     /* 1975411 */   // Label 26478: @1975411
     /* 1975411 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1975497), // Rule ID 61268 //
     /* 1975416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975462 */     // MIs[0] policy
     /* 1975462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975472 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975496 */     // GIR_Coverage, 61268,
     /* 1975496 */     GIR_EraseRootFromParent_Done,
     /* 1975497 */   // Label 26479: @1975497
     /* 1975497 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1975583), // Rule ID 61269 //
     /* 1975502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975548 */     // MIs[0] policy
     /* 1975548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975582 */     // GIR_Coverage, 61269,
     /* 1975582 */     GIR_EraseRootFromParent_Done,
     /* 1975583 */   // Label 26480: @1975583
     /* 1975583 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1975669), // Rule ID 61272 //
     /* 1975588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975634 */     // MIs[0] policy
     /* 1975634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975668 */     // GIR_Coverage, 61272,
     /* 1975668 */     GIR_EraseRootFromParent_Done,
     /* 1975669 */   // Label 26481: @1975669
     /* 1975669 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1975755), // Rule ID 61273 //
     /* 1975674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975720 */     // MIs[0] policy
     /* 1975720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975754 */     // GIR_Coverage, 61273,
     /* 1975754 */     GIR_EraseRootFromParent_Done,
     /* 1975755 */   // Label 26482: @1975755
     /* 1975755 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1975841), // Rule ID 61276 //
     /* 1975760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975806 */     // MIs[0] policy
     /* 1975806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975840 */     // GIR_Coverage, 61276,
     /* 1975840 */     GIR_EraseRootFromParent_Done,
     /* 1975841 */   // Label 26483: @1975841
     /* 1975841 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1975927), // Rule ID 61277 //
     /* 1975846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975892 */     // MIs[0] policy
     /* 1975892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975926 */     // GIR_Coverage, 61277,
     /* 1975926 */     GIR_EraseRootFromParent_Done,
     /* 1975927 */   // Label 26484: @1975927
     /* 1975927 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1976013), // Rule ID 61280 //
     /* 1975932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975978 */     // MIs[0] policy
     /* 1975978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976012 */     // GIR_Coverage, 61280,
     /* 1976012 */     GIR_EraseRootFromParent_Done,
     /* 1976013 */   // Label 26485: @1976013
     /* 1976013 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1976099), // Rule ID 61281 //
     /* 1976018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1976038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976064 */     // MIs[0] policy
     /* 1976064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976098 */     // GIR_Coverage, 61281,
     /* 1976098 */     GIR_EraseRootFromParent_Done,
     /* 1976099 */   // Label 26486: @1976099
     /* 1976099 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1976185), // Rule ID 61284 //
     /* 1976104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976150 */     // MIs[0] policy
     /* 1976150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976184 */     // GIR_Coverage, 61284,
     /* 1976184 */     GIR_EraseRootFromParent_Done,
     /* 1976185 */   // Label 26487: @1976185
     /* 1976185 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1976271), // Rule ID 61285 //
     /* 1976190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976236 */     // MIs[0] policy
     /* 1976236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976270 */     // GIR_Coverage, 61285,
     /* 1976270 */     GIR_EraseRootFromParent_Done,
     /* 1976271 */   // Label 26488: @1976271
     /* 1976271 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1976357), // Rule ID 61288 //
     /* 1976276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976322 */     // MIs[0] policy
     /* 1976322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976356 */     // GIR_Coverage, 61288,
     /* 1976356 */     GIR_EraseRootFromParent_Done,
     /* 1976357 */   // Label 26489: @1976357
     /* 1976357 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1976443), // Rule ID 61289 //
     /* 1976362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976408 */     // MIs[0] policy
     /* 1976408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976442 */     // GIR_Coverage, 61289,
     /* 1976442 */     GIR_EraseRootFromParent_Done,
     /* 1976443 */   // Label 26490: @1976443
     /* 1976443 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1976529), // Rule ID 61292 //
     /* 1976448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976494 */     // MIs[0] policy
     /* 1976494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976504 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976528 */     // GIR_Coverage, 61292,
     /* 1976528 */     GIR_EraseRootFromParent_Done,
     /* 1976529 */   // Label 26491: @1976529
     /* 1976529 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1976615), // Rule ID 61293 //
     /* 1976534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976580 */     // MIs[0] policy
     /* 1976580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976614 */     // GIR_Coverage, 61293,
     /* 1976614 */     GIR_EraseRootFromParent_Done,
     /* 1976615 */   // Label 26492: @1976615
     /* 1976615 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1976701), // Rule ID 61296 //
     /* 1976620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976666 */     // MIs[0] policy
     /* 1976666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976700 */     // GIR_Coverage, 61296,
     /* 1976700 */     GIR_EraseRootFromParent_Done,
     /* 1976701 */   // Label 26493: @1976701
     /* 1976701 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1976787), // Rule ID 61297 //
     /* 1976706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976752 */     // MIs[0] policy
     /* 1976752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976786 */     // GIR_Coverage, 61297,
     /* 1976786 */     GIR_EraseRootFromParent_Done,
     /* 1976787 */   // Label 26494: @1976787
     /* 1976787 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1976873), // Rule ID 61300 //
     /* 1976792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976838 */     // MIs[0] policy
     /* 1976838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976848 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976872 */     // GIR_Coverage, 61300,
     /* 1976872 */     GIR_EraseRootFromParent_Done,
     /* 1976873 */   // Label 26495: @1976873
     /* 1976873 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1976959), // Rule ID 61301 //
     /* 1976878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976924 */     // MIs[0] policy
     /* 1976924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976958 */     // GIR_Coverage, 61301,
     /* 1976958 */     GIR_EraseRootFromParent_Done,
     /* 1976959 */   // Label 26496: @1976959
     /* 1976959 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1977045), // Rule ID 61304 //
     /* 1976964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977010 */     // MIs[0] policy
     /* 1977010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1977023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977044 */     // GIR_Coverage, 61304,
     /* 1977044 */     GIR_EraseRootFromParent_Done,
     /* 1977045 */   // Label 26497: @1977045
     /* 1977045 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1977131), // Rule ID 61305 //
     /* 1977050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1977070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977096 */     // MIs[0] policy
     /* 1977096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1977109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977130 */     // GIR_Coverage, 61305,
     /* 1977130 */     GIR_EraseRootFromParent_Done,
     /* 1977131 */   // Label 26498: @1977131
     /* 1977131 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1977217), // Rule ID 61308 //
     /* 1977136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977182 */     // MIs[0] policy
     /* 1977182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1977195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977216 */     // GIR_Coverage, 61308,
     /* 1977216 */     GIR_EraseRootFromParent_Done,
     /* 1977217 */   // Label 26499: @1977217
     /* 1977217 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1977303), // Rule ID 61309 //
     /* 1977222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977268 */     // MIs[0] policy
     /* 1977268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977278 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1977281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977302 */     // GIR_Coverage, 61309,
     /* 1977302 */     GIR_EraseRootFromParent_Done,
     /* 1977303 */   // Label 26500: @1977303
     /* 1977303 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1977389), // Rule ID 61312 //
     /* 1977308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977354 */     // MIs[0] policy
     /* 1977354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977364 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977388 */     // GIR_Coverage, 61312,
     /* 1977388 */     GIR_EraseRootFromParent_Done,
     /* 1977389 */   // Label 26501: @1977389
     /* 1977389 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1977475), // Rule ID 61313 //
     /* 1977394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977440 */     // MIs[0] policy
     /* 1977440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977474 */     // GIR_Coverage, 61313,
     /* 1977474 */     GIR_EraseRootFromParent_Done,
     /* 1977475 */   // Label 26502: @1977475
     /* 1977475 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1977561), // Rule ID 61316 //
     /* 1977480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977526 */     // MIs[0] policy
     /* 1977526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977536 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977560 */     // GIR_Coverage, 61316,
     /* 1977560 */     GIR_EraseRootFromParent_Done,
     /* 1977561 */   // Label 26503: @1977561
     /* 1977561 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1977647), // Rule ID 61317 //
     /* 1977566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977612 */     // MIs[0] policy
     /* 1977612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977622 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977646 */     // GIR_Coverage, 61317,
     /* 1977646 */     GIR_EraseRootFromParent_Done,
     /* 1977647 */   // Label 26504: @1977647
     /* 1977647 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1977733), // Rule ID 61320 //
     /* 1977652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977698 */     // MIs[0] policy
     /* 1977698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977732 */     // GIR_Coverage, 61320,
     /* 1977732 */     GIR_EraseRootFromParent_Done,
     /* 1977733 */   // Label 26505: @1977733
     /* 1977733 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1977819), // Rule ID 61321 //
     /* 1977738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977784 */     // MIs[0] policy
     /* 1977784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977818 */     // GIR_Coverage, 61321,
     /* 1977818 */     GIR_EraseRootFromParent_Done,
     /* 1977819 */   // Label 26506: @1977819
     /* 1977819 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1977905), // Rule ID 61324 //
     /* 1977824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977870 */     // MIs[0] policy
     /* 1977870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977904 */     // GIR_Coverage, 61324,
     /* 1977904 */     GIR_EraseRootFromParent_Done,
     /* 1977905 */   // Label 26507: @1977905
     /* 1977905 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1977991), // Rule ID 61325 //
     /* 1977910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977956 */     // MIs[0] policy
     /* 1977956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977990 */     // GIR_Coverage, 61325,
     /* 1977990 */     GIR_EraseRootFromParent_Done,
     /* 1977991 */   // Label 26508: @1977991
     /* 1977991 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1978077), // Rule ID 61328 //
     /* 1977996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978042 */     // MIs[0] policy
     /* 1978042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1978055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978076 */     // GIR_Coverage, 61328,
     /* 1978076 */     GIR_EraseRootFromParent_Done,
     /* 1978077 */   // Label 26509: @1978077
     /* 1978077 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1978163), // Rule ID 61329 //
     /* 1978082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978128 */     // MIs[0] policy
     /* 1978128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978138 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1978141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978162 */     // GIR_Coverage, 61329,
     /* 1978162 */     GIR_EraseRootFromParent_Done,
     /* 1978163 */   // Label 26510: @1978163
     /* 1978163 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1978249), // Rule ID 61332 //
     /* 1978168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978214 */     // MIs[0] policy
     /* 1978214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978248 */     // GIR_Coverage, 61332,
     /* 1978248 */     GIR_EraseRootFromParent_Done,
     /* 1978249 */   // Label 26511: @1978249
     /* 1978249 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1978335), // Rule ID 61333 //
     /* 1978254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978300 */     // MIs[0] policy
     /* 1978300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978310 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11215:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978334 */     // GIR_Coverage, 61333,
     /* 1978334 */     GIR_EraseRootFromParent_Done,
     /* 1978335 */   // Label 26512: @1978335
     /* 1978335 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1978421), // Rule ID 61336 //
     /* 1978340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978386 */     // MIs[0] policy
     /* 1978386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978420 */     // GIR_Coverage, 61336,
     /* 1978420 */     GIR_EraseRootFromParent_Done,
     /* 1978421 */   // Label 26513: @1978421
     /* 1978421 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1978507), // Rule ID 61337 //
     /* 1978426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978472 */     // MIs[0] policy
     /* 1978472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978506 */     // GIR_Coverage, 61337,
     /* 1978506 */     GIR_EraseRootFromParent_Done,
     /* 1978507 */   // Label 26514: @1978507
     /* 1978507 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1978593), // Rule ID 61340 //
     /* 1978512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978558 */     // MIs[0] policy
     /* 1978558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978592 */     // GIR_Coverage, 61340,
     /* 1978592 */     GIR_EraseRootFromParent_Done,
     /* 1978593 */   // Label 26515: @1978593
     /* 1978593 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1978679), // Rule ID 61341 //
     /* 1978598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978644 */     // MIs[0] policy
     /* 1978644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978654 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978678 */     // GIR_Coverage, 61341,
     /* 1978678 */     GIR_EraseRootFromParent_Done,
     /* 1978679 */   // Label 26516: @1978679
     /* 1978679 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1978765), // Rule ID 61344 //
     /* 1978684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978730 */     // MIs[0] policy
     /* 1978730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978764 */     // GIR_Coverage, 61344,
     /* 1978764 */     GIR_EraseRootFromParent_Done,
     /* 1978765 */   // Label 26517: @1978765
     /* 1978765 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1978851), // Rule ID 61345 //
     /* 1978770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978816 */     // MIs[0] policy
     /* 1978816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978826 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978850 */     // GIR_Coverage, 61345,
     /* 1978850 */     GIR_EraseRootFromParent_Done,
     /* 1978851 */   // Label 26518: @1978851
     /* 1978851 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1978937), // Rule ID 61348 //
     /* 1978856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978902 */     // MIs[0] policy
     /* 1978902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978936 */     // GIR_Coverage, 61348,
     /* 1978936 */     GIR_EraseRootFromParent_Done,
     /* 1978937 */   // Label 26519: @1978937
     /* 1978937 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1979023), // Rule ID 61349 //
     /* 1978942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978988 */     // MIs[0] policy
     /* 1978988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979022 */     // GIR_Coverage, 61349,
     /* 1979022 */     GIR_EraseRootFromParent_Done,
     /* 1979023 */   // Label 26520: @1979023
     /* 1979023 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1979109), // Rule ID 61352 //
     /* 1979028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979074 */     // MIs[0] policy
     /* 1979074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979084 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979108 */     // GIR_Coverage, 61352,
     /* 1979108 */     GIR_EraseRootFromParent_Done,
     /* 1979109 */   // Label 26521: @1979109
     /* 1979109 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1979195), // Rule ID 61353 //
     /* 1979114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979160 */     // MIs[0] policy
     /* 1979160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979194 */     // GIR_Coverage, 61353,
     /* 1979194 */     GIR_EraseRootFromParent_Done,
     /* 1979195 */   // Label 26522: @1979195
     /* 1979195 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1979281), // Rule ID 61356 //
     /* 1979200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979246 */     // MIs[0] policy
     /* 1979246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979256 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979280 */     // GIR_Coverage, 61356,
     /* 1979280 */     GIR_EraseRootFromParent_Done,
     /* 1979281 */   // Label 26523: @1979281
     /* 1979281 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1979367), // Rule ID 61357 //
     /* 1979286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979332 */     // MIs[0] policy
     /* 1979332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979342 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979366 */     // GIR_Coverage, 61357,
     /* 1979366 */     GIR_EraseRootFromParent_Done,
     /* 1979367 */   // Label 26524: @1979367
     /* 1979367 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1979453), // Rule ID 61360 //
     /* 1979372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979418 */     // MIs[0] policy
     /* 1979418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979428 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979452 */     // GIR_Coverage, 61360,
     /* 1979452 */     GIR_EraseRootFromParent_Done,
     /* 1979453 */   // Label 26525: @1979453
     /* 1979453 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1979539), // Rule ID 61361 //
     /* 1979458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979504 */     // MIs[0] policy
     /* 1979504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979538 */     // GIR_Coverage, 61361,
     /* 1979538 */     GIR_EraseRootFromParent_Done,
     /* 1979539 */   // Label 26526: @1979539
     /* 1979539 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1979625), // Rule ID 61364 //
     /* 1979544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979590 */     // MIs[0] policy
     /* 1979590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979624 */     // GIR_Coverage, 61364,
     /* 1979624 */     GIR_EraseRootFromParent_Done,
     /* 1979625 */   // Label 26527: @1979625
     /* 1979625 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1979711), // Rule ID 61365 //
     /* 1979630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979676 */     // MIs[0] policy
     /* 1979676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979686 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979710 */     // GIR_Coverage, 61365,
     /* 1979710 */     GIR_EraseRootFromParent_Done,
     /* 1979711 */   // Label 26528: @1979711
     /* 1979711 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1979797), // Rule ID 61368 //
     /* 1979716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979762 */     // MIs[0] policy
     /* 1979762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979772 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979796 */     // GIR_Coverage, 61368,
     /* 1979796 */     GIR_EraseRootFromParent_Done,
     /* 1979797 */   // Label 26529: @1979797
     /* 1979797 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1979883), // Rule ID 61369 //
     /* 1979802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979848 */     // MIs[0] policy
     /* 1979848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979882 */     // GIR_Coverage, 61369,
     /* 1979882 */     GIR_EraseRootFromParent_Done,
     /* 1979883 */   // Label 26530: @1979883
     /* 1979883 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1979969), // Rule ID 61372 //
     /* 1979888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979934 */     // MIs[0] policy
     /* 1979934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979968 */     // GIR_Coverage, 61372,
     /* 1979968 */     GIR_EraseRootFromParent_Done,
     /* 1979969 */   // Label 26531: @1979969
     /* 1979969 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1980055), // Rule ID 61373 //
     /* 1979974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980020 */     // MIs[0] policy
     /* 1980020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980054 */     // GIR_Coverage, 61373,
     /* 1980054 */     GIR_EraseRootFromParent_Done,
     /* 1980055 */   // Label 26532: @1980055
     /* 1980055 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1980141), // Rule ID 61376 //
     /* 1980060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980106 */     // MIs[0] policy
     /* 1980106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980140 */     // GIR_Coverage, 61376,
     /* 1980140 */     GIR_EraseRootFromParent_Done,
     /* 1980141 */   // Label 26533: @1980141
     /* 1980141 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1980227), // Rule ID 61377 //
     /* 1980146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980192 */     // MIs[0] policy
     /* 1980192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980226 */     // GIR_Coverage, 61377,
     /* 1980226 */     GIR_EraseRootFromParent_Done,
     /* 1980227 */   // Label 26534: @1980227
     /* 1980227 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1980313), // Rule ID 61380 //
     /* 1980232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980278 */     // MIs[0] policy
     /* 1980278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980288 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980312 */     // GIR_Coverage, 61380,
     /* 1980312 */     GIR_EraseRootFromParent_Done,
     /* 1980313 */   // Label 26535: @1980313
     /* 1980313 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1980399), // Rule ID 61381 //
     /* 1980318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980364 */     // MIs[0] policy
     /* 1980364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980398 */     // GIR_Coverage, 61381,
     /* 1980398 */     GIR_EraseRootFromParent_Done,
     /* 1980399 */   // Label 26536: @1980399
     /* 1980399 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1980485), // Rule ID 61384 //
     /* 1980404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980450 */     // MIs[0] policy
     /* 1980450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980484 */     // GIR_Coverage, 61384,
     /* 1980484 */     GIR_EraseRootFromParent_Done,
     /* 1980485 */   // Label 26537: @1980485
     /* 1980485 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1980571), // Rule ID 61385 //
     /* 1980490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980536 */     // MIs[0] policy
     /* 1980536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980570 */     // GIR_Coverage, 61385,
     /* 1980570 */     GIR_EraseRootFromParent_Done,
     /* 1980571 */   // Label 26538: @1980571
     /* 1980571 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1980657), // Rule ID 61388 //
     /* 1980576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980622 */     // MIs[0] policy
     /* 1980622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980656 */     // GIR_Coverage, 61388,
     /* 1980656 */     GIR_EraseRootFromParent_Done,
     /* 1980657 */   // Label 26539: @1980657
     /* 1980657 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1980743), // Rule ID 61389 //
     /* 1980662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980708 */     // MIs[0] policy
     /* 1980708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980742 */     // GIR_Coverage, 61389,
     /* 1980742 */     GIR_EraseRootFromParent_Done,
     /* 1980743 */   // Label 26540: @1980743
     /* 1980743 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1980829), // Rule ID 61392 //
     /* 1980748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980794 */     // MIs[0] policy
     /* 1980794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980828 */     // GIR_Coverage, 61392,
     /* 1980828 */     GIR_EraseRootFromParent_Done,
     /* 1980829 */   // Label 26541: @1980829
     /* 1980829 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1980915), // Rule ID 61393 //
     /* 1980834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980880 */     // MIs[0] policy
     /* 1980880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980890 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980914 */     // GIR_Coverage, 61393,
     /* 1980914 */     GIR_EraseRootFromParent_Done,
     /* 1980915 */   // Label 26542: @1980915
     /* 1980915 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1981001), // Rule ID 61572 //
     /* 1980920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980966 */     // MIs[0] policy
     /* 1980966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980976 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981000 */     // GIR_Coverage, 61572,
     /* 1981000 */     GIR_EraseRootFromParent_Done,
     /* 1981001 */   // Label 26543: @1981001
     /* 1981001 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1981087), // Rule ID 61573 //
     /* 1981006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1981026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981052 */     // MIs[0] policy
     /* 1981052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981062 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1981065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981086 */     // GIR_Coverage, 61573,
     /* 1981086 */     GIR_EraseRootFromParent_Done,
     /* 1981087 */   // Label 26544: @1981087
     /* 1981087 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1981173), // Rule ID 61576 //
     /* 1981092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981138 */     // MIs[0] policy
     /* 1981138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981148 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981172 */     // GIR_Coverage, 61576,
     /* 1981172 */     GIR_EraseRootFromParent_Done,
     /* 1981173 */   // Label 26545: @1981173
     /* 1981173 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1981259), // Rule ID 61577 //
     /* 1981178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981224 */     // MIs[0] policy
     /* 1981224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981258 */     // GIR_Coverage, 61577,
     /* 1981258 */     GIR_EraseRootFromParent_Done,
     /* 1981259 */   // Label 26546: @1981259
     /* 1981259 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1981345), // Rule ID 61580 //
     /* 1981264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981310 */     // MIs[0] policy
     /* 1981310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981344 */     // GIR_Coverage, 61580,
     /* 1981344 */     GIR_EraseRootFromParent_Done,
     /* 1981345 */   // Label 26547: @1981345
     /* 1981345 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1981431), // Rule ID 61581 //
     /* 1981350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981396 */     // MIs[0] policy
     /* 1981396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981430 */     // GIR_Coverage, 61581,
     /* 1981430 */     GIR_EraseRootFromParent_Done,
     /* 1981431 */   // Label 26548: @1981431
     /* 1981431 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1981517), // Rule ID 61584 //
     /* 1981436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981482 */     // MIs[0] policy
     /* 1981482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981516 */     // GIR_Coverage, 61584,
     /* 1981516 */     GIR_EraseRootFromParent_Done,
     /* 1981517 */   // Label 26549: @1981517
     /* 1981517 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1981603), // Rule ID 61585 //
     /* 1981522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981568 */     // MIs[0] policy
     /* 1981568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981578 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981602 */     // GIR_Coverage, 61585,
     /* 1981602 */     GIR_EraseRootFromParent_Done,
     /* 1981603 */   // Label 26550: @1981603
     /* 1981603 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1981689), // Rule ID 61588 //
     /* 1981608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981654 */     // MIs[0] policy
     /* 1981654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981688 */     // GIR_Coverage, 61588,
     /* 1981688 */     GIR_EraseRootFromParent_Done,
     /* 1981689 */   // Label 26551: @1981689
     /* 1981689 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1981775), // Rule ID 61589 //
     /* 1981694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981740 */     // MIs[0] policy
     /* 1981740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981750 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981774 */     // GIR_Coverage, 61589,
     /* 1981774 */     GIR_EraseRootFromParent_Done,
     /* 1981775 */   // Label 26552: @1981775
     /* 1981775 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1981861), // Rule ID 61592 //
     /* 1981780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981826 */     // MIs[0] policy
     /* 1981826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981860 */     // GIR_Coverage, 61592,
     /* 1981860 */     GIR_EraseRootFromParent_Done,
     /* 1981861 */   // Label 26553: @1981861
     /* 1981861 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1981947), // Rule ID 61593 //
     /* 1981866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981912 */     // MIs[0] policy
     /* 1981912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981922 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981946 */     // GIR_Coverage, 61593,
     /* 1981946 */     GIR_EraseRootFromParent_Done,
     /* 1981947 */   // Label 26554: @1981947
     /* 1981947 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1982033), // Rule ID 61596 //
     /* 1981952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981998 */     // MIs[0] policy
     /* 1981998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982032 */     // GIR_Coverage, 61596,
     /* 1982032 */     GIR_EraseRootFromParent_Done,
     /* 1982033 */   // Label 26555: @1982033
     /* 1982033 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1982119), // Rule ID 61597 //
     /* 1982038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1982058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982084 */     // MIs[0] policy
     /* 1982084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982094 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982118 */     // GIR_Coverage, 61597,
     /* 1982118 */     GIR_EraseRootFromParent_Done,
     /* 1982119 */   // Label 26556: @1982119
     /* 1982119 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1982205), // Rule ID 61600 //
     /* 1982124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982170 */     // MIs[0] policy
     /* 1982170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982204 */     // GIR_Coverage, 61600,
     /* 1982204 */     GIR_EraseRootFromParent_Done,
     /* 1982205 */   // Label 26557: @1982205
     /* 1982205 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1982291), // Rule ID 61601 //
     /* 1982210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982256 */     // MIs[0] policy
     /* 1982256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982290 */     // GIR_Coverage, 61601,
     /* 1982290 */     GIR_EraseRootFromParent_Done,
     /* 1982291 */   // Label 26558: @1982291
     /* 1982291 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1982377), // Rule ID 61604 //
     /* 1982296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982342 */     // MIs[0] policy
     /* 1982342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982376 */     // GIR_Coverage, 61604,
     /* 1982376 */     GIR_EraseRootFromParent_Done,
     /* 1982377 */   // Label 26559: @1982377
     /* 1982377 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1982463), // Rule ID 61605 //
     /* 1982382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982428 */     // MIs[0] policy
     /* 1982428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982438 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982462 */     // GIR_Coverage, 61605,
     /* 1982462 */     GIR_EraseRootFromParent_Done,
     /* 1982463 */   // Label 26560: @1982463
     /* 1982463 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1982549), // Rule ID 61608 //
     /* 1982468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982514 */     // MIs[0] policy
     /* 1982514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982548 */     // GIR_Coverage, 61608,
     /* 1982548 */     GIR_EraseRootFromParent_Done,
     /* 1982549 */   // Label 26561: @1982549
     /* 1982549 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1982635), // Rule ID 61609 //
     /* 1982554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982600 */     // MIs[0] policy
     /* 1982600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982634 */     // GIR_Coverage, 61609,
     /* 1982634 */     GIR_EraseRootFromParent_Done,
     /* 1982635 */   // Label 26562: @1982635
     /* 1982635 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1982721), // Rule ID 61612 //
     /* 1982640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982686 */     // MIs[0] policy
     /* 1982686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982720 */     // GIR_Coverage, 61612,
     /* 1982720 */     GIR_EraseRootFromParent_Done,
     /* 1982721 */   // Label 26563: @1982721
     /* 1982721 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1982807), // Rule ID 61613 //
     /* 1982726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982772 */     // MIs[0] policy
     /* 1982772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982806 */     // GIR_Coverage, 61613,
     /* 1982806 */     GIR_EraseRootFromParent_Done,
     /* 1982807 */   // Label 26564: @1982807
     /* 1982807 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1982893), // Rule ID 61616 //
     /* 1982812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982858 */     // MIs[0] policy
     /* 1982858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982892 */     // GIR_Coverage, 61616,
     /* 1982892 */     GIR_EraseRootFromParent_Done,
     /* 1982893 */   // Label 26565: @1982893
     /* 1982893 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1982979), // Rule ID 61617 //
     /* 1982898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982944 */     // MIs[0] policy
     /* 1982944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982978 */     // GIR_Coverage, 61617,
     /* 1982978 */     GIR_EraseRootFromParent_Done,
     /* 1982979 */   // Label 26566: @1982979
     /* 1982979 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1983065), // Rule ID 61620 //
     /* 1982984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983030 */     // MIs[0] policy
     /* 1983030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983064 */     // GIR_Coverage, 61620,
     /* 1983064 */     GIR_EraseRootFromParent_Done,
     /* 1983065 */   // Label 26567: @1983065
     /* 1983065 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1983151), // Rule ID 61621 //
     /* 1983070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983116 */     // MIs[0] policy
     /* 1983116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983126 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983150 */     // GIR_Coverage, 61621,
     /* 1983150 */     GIR_EraseRootFromParent_Done,
     /* 1983151 */   // Label 26568: @1983151
     /* 1983151 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1983237), // Rule ID 61624 //
     /* 1983156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983202 */     // MIs[0] policy
     /* 1983202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983236 */     // GIR_Coverage, 61624,
     /* 1983236 */     GIR_EraseRootFromParent_Done,
     /* 1983237 */   // Label 26569: @1983237
     /* 1983237 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1983323), // Rule ID 61625 //
     /* 1983242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983288 */     // MIs[0] policy
     /* 1983288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983322 */     // GIR_Coverage, 61625,
     /* 1983322 */     GIR_EraseRootFromParent_Done,
     /* 1983323 */   // Label 26570: @1983323
     /* 1983323 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1983409), // Rule ID 61628 //
     /* 1983328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983374 */     // MIs[0] policy
     /* 1983374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983408 */     // GIR_Coverage, 61628,
     /* 1983408 */     GIR_EraseRootFromParent_Done,
     /* 1983409 */   // Label 26571: @1983409
     /* 1983409 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1983495), // Rule ID 61629 //
     /* 1983414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983460 */     // MIs[0] policy
     /* 1983460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983494 */     // GIR_Coverage, 61629,
     /* 1983494 */     GIR_EraseRootFromParent_Done,
     /* 1983495 */   // Label 26572: @1983495
     /* 1983495 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1983581), // Rule ID 61632 //
     /* 1983500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983546 */     // MIs[0] policy
     /* 1983546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983580 */     // GIR_Coverage, 61632,
     /* 1983580 */     GIR_EraseRootFromParent_Done,
     /* 1983581 */   // Label 26573: @1983581
     /* 1983581 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1983667), // Rule ID 61633 //
     /* 1983586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983632 */     // MIs[0] policy
     /* 1983632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983666 */     // GIR_Coverage, 61633,
     /* 1983666 */     GIR_EraseRootFromParent_Done,
     /* 1983667 */   // Label 26574: @1983667
     /* 1983667 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1983753), // Rule ID 61636 //
     /* 1983672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983718 */     // MIs[0] policy
     /* 1983718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983752 */     // GIR_Coverage, 61636,
     /* 1983752 */     GIR_EraseRootFromParent_Done,
     /* 1983753 */   // Label 26575: @1983753
     /* 1983753 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1983839), // Rule ID 61637 //
     /* 1983758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983804 */     // MIs[0] policy
     /* 1983804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983838 */     // GIR_Coverage, 61637,
     /* 1983838 */     GIR_EraseRootFromParent_Done,
     /* 1983839 */   // Label 26576: @1983839
     /* 1983839 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1983925), // Rule ID 61640 //
     /* 1983844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983890 */     // MIs[0] policy
     /* 1983890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983924 */     // GIR_Coverage, 61640,
     /* 1983924 */     GIR_EraseRootFromParent_Done,
     /* 1983925 */   // Label 26577: @1983925
     /* 1983925 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1984011), // Rule ID 61641 //
     /* 1983930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983976 */     // MIs[0] policy
     /* 1983976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984010 */     // GIR_Coverage, 61641,
     /* 1984010 */     GIR_EraseRootFromParent_Done,
     /* 1984011 */   // Label 26578: @1984011
     /* 1984011 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1984097), // Rule ID 61644 //
     /* 1984016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984062 */     // MIs[0] policy
     /* 1984062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984072 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984096 */     // GIR_Coverage, 61644,
     /* 1984096 */     GIR_EraseRootFromParent_Done,
     /* 1984097 */   // Label 26579: @1984097
     /* 1984097 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1984183), // Rule ID 61645 //
     /* 1984102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984148 */     // MIs[0] policy
     /* 1984148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984182 */     // GIR_Coverage, 61645,
     /* 1984182 */     GIR_EraseRootFromParent_Done,
     /* 1984183 */   // Label 26580: @1984183
     /* 1984183 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1984269), // Rule ID 61648 //
     /* 1984188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984234 */     // MIs[0] policy
     /* 1984234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1984247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984268 */     // GIR_Coverage, 61648,
     /* 1984268 */     GIR_EraseRootFromParent_Done,
     /* 1984269 */   // Label 26581: @1984269
     /* 1984269 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1984355), // Rule ID 61649 //
     /* 1984274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984320 */     // MIs[0] policy
     /* 1984320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984330 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1984333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984354 */     // GIR_Coverage, 61649,
     /* 1984354 */     GIR_EraseRootFromParent_Done,
     /* 1984355 */   // Label 26582: @1984355
     /* 1984355 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1984441), // Rule ID 61652 //
     /* 1984360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984406 */     // MIs[0] policy
     /* 1984406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984440 */     // GIR_Coverage, 61652,
     /* 1984440 */     GIR_EraseRootFromParent_Done,
     /* 1984441 */   // Label 26583: @1984441
     /* 1984441 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1984527), // Rule ID 61653 //
     /* 1984446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984492 */     // MIs[0] policy
     /* 1984492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984526 */     // GIR_Coverage, 61653,
     /* 1984526 */     GIR_EraseRootFromParent_Done,
     /* 1984527 */   // Label 26584: @1984527
     /* 1984527 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1984613), // Rule ID 61656 //
     /* 1984532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984578 */     // MIs[0] policy
     /* 1984578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984612 */     // GIR_Coverage, 61656,
     /* 1984612 */     GIR_EraseRootFromParent_Done,
     /* 1984613 */   // Label 26585: @1984613
     /* 1984613 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1984699), // Rule ID 61657 //
     /* 1984618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984664 */     // MIs[0] policy
     /* 1984664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984674 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984698 */     // GIR_Coverage, 61657,
     /* 1984698 */     GIR_EraseRootFromParent_Done,
     /* 1984699 */   // Label 26586: @1984699
     /* 1984699 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1984785), // Rule ID 61660 //
     /* 1984704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984750 */     // MIs[0] policy
     /* 1984750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984784 */     // GIR_Coverage, 61660,
     /* 1984784 */     GIR_EraseRootFromParent_Done,
     /* 1984785 */   // Label 26587: @1984785
     /* 1984785 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1984871), // Rule ID 61661 //
     /* 1984790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984836 */     // MIs[0] policy
     /* 1984836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984846 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984870 */     // GIR_Coverage, 61661,
     /* 1984870 */     GIR_EraseRootFromParent_Done,
     /* 1984871 */   // Label 26588: @1984871
     /* 1984871 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1984957), // Rule ID 61664 //
     /* 1984876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984922 */     // MIs[0] policy
     /* 1984922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984932 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984956 */     // GIR_Coverage, 61664,
     /* 1984956 */     GIR_EraseRootFromParent_Done,
     /* 1984957 */   // Label 26589: @1984957
     /* 1984957 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1985043), // Rule ID 61665 //
     /* 1984962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985008 */     // MIs[0] policy
     /* 1985008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985042 */     // GIR_Coverage, 61665,
     /* 1985042 */     GIR_EraseRootFromParent_Done,
     /* 1985043 */   // Label 26590: @1985043
     /* 1985043 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1985129), // Rule ID 61668 //
     /* 1985048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985094 */     // MIs[0] policy
     /* 1985094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985128 */     // GIR_Coverage, 61668,
     /* 1985128 */     GIR_EraseRootFromParent_Done,
     /* 1985129 */   // Label 26591: @1985129
     /* 1985129 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1985215), // Rule ID 61669 //
     /* 1985134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985180 */     // MIs[0] policy
     /* 1985180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985190 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985214 */     // GIR_Coverage, 61669,
     /* 1985214 */     GIR_EraseRootFromParent_Done,
     /* 1985215 */   // Label 26592: @1985215
     /* 1985215 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1985301), // Rule ID 61672 //
     /* 1985220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985266 */     // MIs[0] policy
     /* 1985266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985300 */     // GIR_Coverage, 61672,
     /* 1985300 */     GIR_EraseRootFromParent_Done,
     /* 1985301 */   // Label 26593: @1985301
     /* 1985301 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1985387), // Rule ID 61673 //
     /* 1985306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985352 */     // MIs[0] policy
     /* 1985352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1985365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985386 */     // GIR_Coverage, 61673,
     /* 1985386 */     GIR_EraseRootFromParent_Done,
     /* 1985387 */   // Label 26594: @1985387
     /* 1985387 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1985473), // Rule ID 61676 //
     /* 1985392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985438 */     // MIs[0] policy
     /* 1985438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985472 */     // GIR_Coverage, 61676,
     /* 1985472 */     GIR_EraseRootFromParent_Done,
     /* 1985473 */   // Label 26595: @1985473
     /* 1985473 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1985559), // Rule ID 61677 //
     /* 1985478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985524 */     // MIs[0] policy
     /* 1985524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985558 */     // GIR_Coverage, 61677,
     /* 1985558 */     GIR_EraseRootFromParent_Done,
     /* 1985559 */   // Label 26596: @1985559
     /* 1985559 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1985645), // Rule ID 61680 //
     /* 1985564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985610 */     // MIs[0] policy
     /* 1985610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985644 */     // GIR_Coverage, 61680,
     /* 1985644 */     GIR_EraseRootFromParent_Done,
     /* 1985645 */   // Label 26597: @1985645
     /* 1985645 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1985731), // Rule ID 61681 //
     /* 1985650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985696 */     // MIs[0] policy
     /* 1985696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985730 */     // GIR_Coverage, 61681,
     /* 1985730 */     GIR_EraseRootFromParent_Done,
     /* 1985731 */   // Label 26598: @1985731
     /* 1985731 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1985817), // Rule ID 61684 //
     /* 1985736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985782 */     // MIs[0] policy
     /* 1985782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985816 */     // GIR_Coverage, 61684,
     /* 1985816 */     GIR_EraseRootFromParent_Done,
     /* 1985817 */   // Label 26599: @1985817
     /* 1985817 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1985903), // Rule ID 61685 //
     /* 1985822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985868 */     // MIs[0] policy
     /* 1985868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985878 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985902 */     // GIR_Coverage, 61685,
     /* 1985902 */     GIR_EraseRootFromParent_Done,
     /* 1985903 */   // Label 26600: @1985903
     /* 1985903 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1985989), // Rule ID 61688 //
     /* 1985908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985954 */     // MIs[0] policy
     /* 1985954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985988 */     // GIR_Coverage, 61688,
     /* 1985988 */     GIR_EraseRootFromParent_Done,
     /* 1985989 */   // Label 26601: @1985989
     /* 1985989 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1986075), // Rule ID 61689 //
     /* 1985994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1986005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1986008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1986011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986040 */     // MIs[0] policy
     /* 1986040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986074 */     // GIR_Coverage, 61689,
     /* 1986074 */     GIR_EraseRootFromParent_Done,
     /* 1986075 */   // Label 26602: @1986075
     /* 1986075 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1986161), // Rule ID 61692 //
     /* 1986080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986126 */     // MIs[0] policy
     /* 1986126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986160 */     // GIR_Coverage, 61692,
     /* 1986160 */     GIR_EraseRootFromParent_Done,
     /* 1986161 */   // Label 26603: @1986161
     /* 1986161 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1986247), // Rule ID 61693 //
     /* 1986166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986212 */     // MIs[0] policy
     /* 1986212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986246 */     // GIR_Coverage, 61693,
     /* 1986246 */     GIR_EraseRootFromParent_Done,
     /* 1986247 */   // Label 26604: @1986247
     /* 1986247 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1986333), // Rule ID 61696 //
     /* 1986252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986298 */     // MIs[0] policy
     /* 1986298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986332 */     // GIR_Coverage, 61696,
     /* 1986332 */     GIR_EraseRootFromParent_Done,
     /* 1986333 */   // Label 26605: @1986333
     /* 1986333 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1986419), // Rule ID 61697 //
     /* 1986338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986384 */     // MIs[0] policy
     /* 1986384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1986397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986418 */     // GIR_Coverage, 61697,
     /* 1986418 */     GIR_EraseRootFromParent_Done,
     /* 1986419 */   // Label 26606: @1986419
     /* 1986419 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1986505), // Rule ID 61700 //
     /* 1986424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986470 */     // MIs[0] policy
     /* 1986470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986504 */     // GIR_Coverage, 61700,
     /* 1986504 */     GIR_EraseRootFromParent_Done,
     /* 1986505 */   // Label 26607: @1986505
     /* 1986505 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1986591), // Rule ID 61701 //
     /* 1986510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986556 */     // MIs[0] policy
     /* 1986556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986590 */     // GIR_Coverage, 61701,
     /* 1986590 */     GIR_EraseRootFromParent_Done,
     /* 1986591 */   // Label 26608: @1986591
     /* 1986591 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1986677), // Rule ID 61704 //
     /* 1986596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986642 */     // MIs[0] policy
     /* 1986642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986676 */     // GIR_Coverage, 61704,
     /* 1986676 */     GIR_EraseRootFromParent_Done,
     /* 1986677 */   // Label 26609: @1986677
     /* 1986677 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1986763), // Rule ID 61705 //
     /* 1986682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986728 */     // MIs[0] policy
     /* 1986728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986738 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986762 */     // GIR_Coverage, 61705,
     /* 1986762 */     GIR_EraseRootFromParent_Done,
     /* 1986763 */   // Label 26610: @1986763
     /* 1986763 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1986849), // Rule ID 61708 //
     /* 1986768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986814 */     // MIs[0] policy
     /* 1986814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986848 */     // GIR_Coverage, 61708,
     /* 1986848 */     GIR_EraseRootFromParent_Done,
     /* 1986849 */   // Label 26611: @1986849
     /* 1986849 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1986935), // Rule ID 61709 //
     /* 1986854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986900 */     // MIs[0] policy
     /* 1986900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986910 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986934 */     // GIR_Coverage, 61709,
     /* 1986934 */     GIR_EraseRootFromParent_Done,
     /* 1986935 */   // Label 26612: @1986935
     /* 1986935 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1987021), // Rule ID 61712 //
     /* 1986940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986986 */     // MIs[0] policy
     /* 1986986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987020 */     // GIR_Coverage, 61712,
     /* 1987020 */     GIR_EraseRootFromParent_Done,
     /* 1987021 */   // Label 26613: @1987021
     /* 1987021 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1987107), // Rule ID 61713 //
     /* 1987026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1987043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987072 */     // MIs[0] policy
     /* 1987072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987106 */     // GIR_Coverage, 61713,
     /* 1987106 */     GIR_EraseRootFromParent_Done,
     /* 1987107 */   // Label 26614: @1987107
     /* 1987107 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1987193), // Rule ID 61716 //
     /* 1987112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987158 */     // MIs[0] policy
     /* 1987158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987192 */     // GIR_Coverage, 61716,
     /* 1987192 */     GIR_EraseRootFromParent_Done,
     /* 1987193 */   // Label 26615: @1987193
     /* 1987193 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1987279), // Rule ID 61717 //
     /* 1987198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987244 */     // MIs[0] policy
     /* 1987244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987278 */     // GIR_Coverage, 61717,
     /* 1987278 */     GIR_EraseRootFromParent_Done,
     /* 1987279 */   // Label 26616: @1987279
     /* 1987279 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1987365), // Rule ID 61720 //
     /* 1987284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987330 */     // MIs[0] policy
     /* 1987330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987340 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987364 */     // GIR_Coverage, 61720,
     /* 1987364 */     GIR_EraseRootFromParent_Done,
     /* 1987365 */   // Label 26617: @1987365
     /* 1987365 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1987451), // Rule ID 61721 //
     /* 1987370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987416 */     // MIs[0] policy
     /* 1987416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987426 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987450 */     // GIR_Coverage, 61721,
     /* 1987450 */     GIR_EraseRootFromParent_Done,
     /* 1987451 */   // Label 26618: @1987451
     /* 1987451 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1987537), // Rule ID 61724 //
     /* 1987456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987502 */     // MIs[0] policy
     /* 1987502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987536 */     // GIR_Coverage, 61724,
     /* 1987536 */     GIR_EraseRootFromParent_Done,
     /* 1987537 */   // Label 26619: @1987537
     /* 1987537 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1987623), // Rule ID 61725 //
     /* 1987542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987588 */     // MIs[0] policy
     /* 1987588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987622 */     // GIR_Coverage, 61725,
     /* 1987622 */     GIR_EraseRootFromParent_Done,
     /* 1987623 */   // Label 26620: @1987623
     /* 1987623 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1987709), // Rule ID 61728 //
     /* 1987628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987674 */     // MIs[0] policy
     /* 1987674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987708 */     // GIR_Coverage, 61728,
     /* 1987708 */     GIR_EraseRootFromParent_Done,
     /* 1987709 */   // Label 26621: @1987709
     /* 1987709 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1987795), // Rule ID 61729 //
     /* 1987714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987760 */     // MIs[0] policy
     /* 1987760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987770 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987794 */     // GIR_Coverage, 61729,
     /* 1987794 */     GIR_EraseRootFromParent_Done,
     /* 1987795 */   // Label 26622: @1987795
     /* 1987795 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1987881), // Rule ID 61732 //
     /* 1987800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987846 */     // MIs[0] policy
     /* 1987846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987880 */     // GIR_Coverage, 61732,
     /* 1987880 */     GIR_EraseRootFromParent_Done,
     /* 1987881 */   // Label 26623: @1987881
     /* 1987881 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1987967), // Rule ID 61733 //
     /* 1987886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987932 */     // MIs[0] policy
     /* 1987932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987966 */     // GIR_Coverage, 61733,
     /* 1987966 */     GIR_EraseRootFromParent_Done,
     /* 1987967 */   // Label 26624: @1987967
     /* 1987967 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1988053), // Rule ID 61736 //
     /* 1987972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988018 */     // MIs[0] policy
     /* 1988018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1988031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988052 */     // GIR_Coverage, 61736,
     /* 1988052 */     GIR_EraseRootFromParent_Done,
     /* 1988053 */   // Label 26625: @1988053
     /* 1988053 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1988139), // Rule ID 61737 //
     /* 1988058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1988069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1988072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1988075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988104 */     // MIs[0] policy
     /* 1988104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1988117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988138 */     // GIR_Coverage, 61737,
     /* 1988138 */     GIR_EraseRootFromParent_Done,
     /* 1988139 */   // Label 26626: @1988139
     /* 1988139 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1988225), // Rule ID 61740 //
     /* 1988144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988190 */     // MIs[0] policy
     /* 1988190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1988203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988224 */     // GIR_Coverage, 61740,
     /* 1988224 */     GIR_EraseRootFromParent_Done,
     /* 1988225 */   // Label 26627: @1988225
     /* 1988225 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1988311), // Rule ID 61741 //
     /* 1988230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988276 */     // MIs[0] policy
     /* 1988276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1988289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988310 */     // GIR_Coverage, 61741,
     /* 1988310 */     GIR_EraseRootFromParent_Done,
     /* 1988311 */   // Label 26628: @1988311
     /* 1988311 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1988397), // Rule ID 61744 //
     /* 1988316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988362 */     // MIs[0] policy
     /* 1988362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1988375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988396 */     // GIR_Coverage, 61744,
     /* 1988396 */     GIR_EraseRootFromParent_Done,
     /* 1988397 */   // Label 26629: @1988397
     /* 1988397 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1988483), // Rule ID 61745 //
     /* 1988402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1988410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988448 */     // MIs[0] policy
     /* 1988448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988458 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1988461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988482 */     // GIR_Coverage, 61745,
     /* 1988482 */     GIR_EraseRootFromParent_Done,
     /* 1988483 */   // Label 26630: @1988483
     /* 1988483 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1988569), // Rule ID 61832 //
     /* 1988488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988534 */     // MIs[0] policy
     /* 1988534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988568 */     // GIR_Coverage, 61832,
     /* 1988568 */     GIR_EraseRootFromParent_Done,
     /* 1988569 */   // Label 26631: @1988569
     /* 1988569 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1988655), // Rule ID 61833 //
     /* 1988574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988620 */     // MIs[0] policy
     /* 1988620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988654 */     // GIR_Coverage, 61833,
     /* 1988654 */     GIR_EraseRootFromParent_Done,
     /* 1988655 */   // Label 26632: @1988655
     /* 1988655 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1988741), // Rule ID 61836 //
     /* 1988660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988706 */     // MIs[0] policy
     /* 1988706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988740 */     // GIR_Coverage, 61836,
     /* 1988740 */     GIR_EraseRootFromParent_Done,
     /* 1988741 */   // Label 26633: @1988741
     /* 1988741 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1988827), // Rule ID 61837 //
     /* 1988746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988792 */     // MIs[0] policy
     /* 1988792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988826 */     // GIR_Coverage, 61837,
     /* 1988826 */     GIR_EraseRootFromParent_Done,
     /* 1988827 */   // Label 26634: @1988827
     /* 1988827 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1988913), // Rule ID 61840 //
     /* 1988832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988878 */     // MIs[0] policy
     /* 1988878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988888 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988912 */     // GIR_Coverage, 61840,
     /* 1988912 */     GIR_EraseRootFromParent_Done,
     /* 1988913 */   // Label 26635: @1988913
     /* 1988913 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1988999), // Rule ID 61841 //
     /* 1988918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988964 */     // MIs[0] policy
     /* 1988964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988974 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988998 */     // GIR_Coverage, 61841,
     /* 1988998 */     GIR_EraseRootFromParent_Done,
     /* 1988999 */   // Label 26636: @1988999
     /* 1988999 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1989085), // Rule ID 61844 //
     /* 1989004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1989021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1989024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989050 */     // MIs[0] policy
     /* 1989050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1989063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989084 */     // GIR_Coverage, 61844,
     /* 1989084 */     GIR_EraseRootFromParent_Done,
     /* 1989085 */   // Label 26637: @1989085
     /* 1989085 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1989171), // Rule ID 61845 //
     /* 1989090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1989101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1989104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1989107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1989110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989136 */     // MIs[0] policy
     /* 1989136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1989149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989170 */     // GIR_Coverage, 61845,
     /* 1989170 */     GIR_EraseRootFromParent_Done,
     /* 1989171 */   // Label 26638: @1989171
     /* 1989171 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1989257), // Rule ID 61848 //
     /* 1989176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1989193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1989196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989222 */     // MIs[0] policy
     /* 1989222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989256 */     // GIR_Coverage, 61848,
     /* 1989256 */     GIR_EraseRootFromParent_Done,
     /* 1989257 */   // Label 26639: @1989257
     /* 1989257 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1989343), // Rule ID 61849 //
     /* 1989262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1989273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1989276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1989279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1989282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989308 */     // MIs[0] policy
     /* 1989308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989342 */     // GIR_Coverage, 61849,
     /* 1989342 */     GIR_EraseRootFromParent_Done,
     /* 1989343 */   // Label 26640: @1989343
     /* 1989343 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1989429), // Rule ID 61852 //
     /* 1989348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1989368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989394 */     // MIs[0] policy
     /* 1989394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989428 */     // GIR_Coverage, 61852,
     /* 1989428 */     GIR_EraseRootFromParent_Done,
     /* 1989429 */   // Label 26641: @1989429
     /* 1989429 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1989515), // Rule ID 61853 //
     /* 1989434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1989451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1989454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989480 */     // MIs[0] policy
     /* 1989480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989514 */     // GIR_Coverage, 61853,
     /* 1989514 */     GIR_EraseRootFromParent_Done,
     /* 1989515 */   // Label 26642: @1989515
     /* 1989515 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1989601), // Rule ID 61856 //
     /* 1989520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989566 */     // MIs[0] policy
     /* 1989566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989600 */     // GIR_Coverage, 61856,
     /* 1989600 */     GIR_EraseRootFromParent_Done,
     /* 1989601 */   // Label 26643: @1989601
     /* 1989601 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1989687), // Rule ID 61857 //
     /* 1989606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989652 */     // MIs[0] policy
     /* 1989652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989686 */     // GIR_Coverage, 61857,
     /* 1989686 */     GIR_EraseRootFromParent_Done,
     /* 1989687 */   // Label 26644: @1989687
     /* 1989687 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1989773), // Rule ID 61860 //
     /* 1989692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989738 */     // MIs[0] policy
     /* 1989738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989748 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989772 */     // GIR_Coverage, 61860,
     /* 1989772 */     GIR_EraseRootFromParent_Done,
     /* 1989773 */   // Label 26645: @1989773
     /* 1989773 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1989859), // Rule ID 61861 //
     /* 1989778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989824 */     // MIs[0] policy
     /* 1989824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989858 */     // GIR_Coverage, 61861,
     /* 1989858 */     GIR_EraseRootFromParent_Done,
     /* 1989859 */   // Label 26646: @1989859
     /* 1989859 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1989945), // Rule ID 61864 //
     /* 1989864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989910 */     // MIs[0] policy
     /* 1989910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989944 */     // GIR_Coverage, 61864,
     /* 1989944 */     GIR_EraseRootFromParent_Done,
     /* 1989945 */   // Label 26647: @1989945
     /* 1989945 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1990031), // Rule ID 61865 //
     /* 1989950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989996 */     // MIs[0] policy
     /* 1989996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990030 */     // GIR_Coverage, 61865,
     /* 1990030 */     GIR_EraseRootFromParent_Done,
     /* 1990031 */   // Label 26648: @1990031
     /* 1990031 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1990117), // Rule ID 61868 //
     /* 1990036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1990047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1990050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1990056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990082 */     // MIs[0] policy
     /* 1990082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1990113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990116 */     // GIR_Coverage, 61868,
     /* 1990116 */     GIR_EraseRootFromParent_Done,
     /* 1990117 */   // Label 26649: @1990117
     /* 1990117 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1990203), // Rule ID 61869 //
     /* 1990122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1990133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1990136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1990139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1990142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990168 */     // MIs[0] policy
     /* 1990168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1990181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1990199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990202 */     // GIR_Coverage, 61869,
     /* 1990202 */     GIR_EraseRootFromParent_Done,
     /* 1990203 */   // Label 26650: @1990203
     /* 1990203 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1990289), // Rule ID 61872 //
     /* 1990208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1990219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1990222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1990225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990254 */     // MIs[0] policy
     /* 1990254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990288 */     // GIR_Coverage, 61872,
     /* 1990288 */     GIR_EraseRootFromParent_Done,
     /* 1990289 */   // Label 26651: @1990289
     /* 1990289 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1990375), // Rule ID 61873 //
     /* 1990294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1990305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1990308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1990311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990340 */     // MIs[0] policy
     /* 1990340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990350 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990374 */     // GIR_Coverage, 61873,
     /* 1990374 */     GIR_EraseRootFromParent_Done,
     /* 1990375 */   // Label 26652: @1990375
     /* 1990375 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1990461), // Rule ID 61876 //
     /* 1990380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990426 */     // MIs[0] policy
     /* 1990426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990460 */     // GIR_Coverage, 61876,
     /* 1990460 */     GIR_EraseRootFromParent_Done,
     /* 1990461 */   // Label 26653: @1990461
     /* 1990461 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1990547), // Rule ID 61877 //
     /* 1990466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990512 */     // MIs[0] policy
     /* 1990512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990522 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990546 */     // GIR_Coverage, 61877,
     /* 1990546 */     GIR_EraseRootFromParent_Done,
     /* 1990547 */   // Label 26654: @1990547
     /* 1990547 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1990633), // Rule ID 61880 //
     /* 1990552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990598 */     // MIs[0] policy
     /* 1990598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990632 */     // GIR_Coverage, 61880,
     /* 1990632 */     GIR_EraseRootFromParent_Done,
     /* 1990633 */   // Label 26655: @1990633
     /* 1990633 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1990719), // Rule ID 61881 //
     /* 1990638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990684 */     // MIs[0] policy
     /* 1990684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990694 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990718 */     // GIR_Coverage, 61881,
     /* 1990718 */     GIR_EraseRootFromParent_Done,
     /* 1990719 */   // Label 26656: @1990719
     /* 1990719 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1990805), // Rule ID 61884 //
     /* 1990724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990770 */     // MIs[0] policy
     /* 1990770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990780 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990804 */     // GIR_Coverage, 61884,
     /* 1990804 */     GIR_EraseRootFromParent_Done,
     /* 1990805 */   // Label 26657: @1990805
     /* 1990805 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1990891), // Rule ID 61885 //
     /* 1990810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990856 */     // MIs[0] policy
     /* 1990856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990890 */     // GIR_Coverage, 61885,
     /* 1990890 */     GIR_EraseRootFromParent_Done,
     /* 1990891 */   // Label 26658: @1990891
     /* 1990891 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1990977), // Rule ID 61888 //
     /* 1990896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990942 */     // MIs[0] policy
     /* 1990942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990976 */     // GIR_Coverage, 61888,
     /* 1990976 */     GIR_EraseRootFromParent_Done,
     /* 1990977 */   // Label 26659: @1990977
     /* 1990977 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1991063), // Rule ID 61889 //
     /* 1990982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1991002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991028 */     // MIs[0] policy
     /* 1991028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991062 */     // GIR_Coverage, 61889,
     /* 1991062 */     GIR_EraseRootFromParent_Done,
     /* 1991063 */   // Label 26660: @1991063
     /* 1991063 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1991149), // Rule ID 61892 //
     /* 1991068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1991079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1991082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1991085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1991088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991114 */     // MIs[0] policy
     /* 1991114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991148 */     // GIR_Coverage, 61892,
     /* 1991148 */     GIR_EraseRootFromParent_Done,
     /* 1991149 */   // Label 26661: @1991149
     /* 1991149 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1991235), // Rule ID 61893 //
     /* 1991154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1991165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1991168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1991171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1991174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991200 */     // MIs[0] policy
     /* 1991200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991210 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991234 */     // GIR_Coverage, 61893,
     /* 1991234 */     GIR_EraseRootFromParent_Done,
     /* 1991235 */   // Label 26662: @1991235
     /* 1991235 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1991321), // Rule ID 61896 //
     /* 1991240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1991257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1991260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991286 */     // MIs[0] policy
     /* 1991286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991320 */     // GIR_Coverage, 61896,
     /* 1991320 */     GIR_EraseRootFromParent_Done,
     /* 1991321 */   // Label 26663: @1991321
     /* 1991321 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1991407), // Rule ID 61897 //
     /* 1991326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1991343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1991346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991372 */     // MIs[0] policy
     /* 1991372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991406 */     // GIR_Coverage, 61897,
     /* 1991406 */     GIR_EraseRootFromParent_Done,
     /* 1991407 */   // Label 26664: @1991407
     /* 1991407 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1991493), // Rule ID 61900 //
     /* 1991412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991458 */     // MIs[0] policy
     /* 1991458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991492 */     // GIR_Coverage, 61900,
     /* 1991492 */     GIR_EraseRootFromParent_Done,
     /* 1991493 */   // Label 26665: @1991493
     /* 1991493 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1991579), // Rule ID 61901 //
     /* 1991498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991544 */     // MIs[0] policy
     /* 1991544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991578 */     // GIR_Coverage, 61901,
     /* 1991578 */     GIR_EraseRootFromParent_Done,
     /* 1991579 */   // Label 26666: @1991579
     /* 1991579 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1991665), // Rule ID 61904 //
     /* 1991584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991630 */     // MIs[0] policy
     /* 1991630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991664 */     // GIR_Coverage, 61904,
     /* 1991664 */     GIR_EraseRootFromParent_Done,
     /* 1991665 */   // Label 26667: @1991665
     /* 1991665 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1991751), // Rule ID 61905 //
     /* 1991670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991716 */     // MIs[0] policy
     /* 1991716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991750 */     // GIR_Coverage, 61905,
     /* 1991750 */     GIR_EraseRootFromParent_Done,
     /* 1991751 */   // Label 26668: @1991751
     /* 1991751 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1991837), // Rule ID 61908 //
     /* 1991756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991802 */     // MIs[0] policy
     /* 1991802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991836 */     // GIR_Coverage, 61908,
     /* 1991836 */     GIR_EraseRootFromParent_Done,
     /* 1991837 */   // Label 26669: @1991837
     /* 1991837 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1991923), // Rule ID 61909 //
     /* 1991842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991888 */     // MIs[0] policy
     /* 1991888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991922 */     // GIR_Coverage, 61909,
     /* 1991922 */     GIR_EraseRootFromParent_Done,
     /* 1991923 */   // Label 26670: @1991923
     /* 1991923 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1992009), // Rule ID 61912 //
     /* 1991928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991974 */     // MIs[0] policy
     /* 1991974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992008 */     // GIR_Coverage, 61912,
     /* 1992008 */     GIR_EraseRootFromParent_Done,
     /* 1992009 */   // Label 26671: @1992009
     /* 1992009 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1992095), // Rule ID 61913 //
     /* 1992014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1992025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1992028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1992031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1992034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992060 */     // MIs[0] policy
     /* 1992060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992070 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1992073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992094 */     // GIR_Coverage, 61913,
     /* 1992094 */     GIR_EraseRootFromParent_Done,
     /* 1992095 */   // Label 26672: @1992095
     /* 1992095 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1992181), // Rule ID 61916 //
     /* 1992100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1992111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1992114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1992117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1992120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992146 */     // MIs[0] policy
     /* 1992146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1992159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992180 */     // GIR_Coverage, 61916,
     /* 1992180 */     GIR_EraseRootFromParent_Done,
     /* 1992181 */   // Label 26673: @1992181
     /* 1992181 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1992267), // Rule ID 61917 //
     /* 1992186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1992197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1992200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1992203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1992206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992232 */     // MIs[0] policy
     /* 1992232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1992245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992266 */     // GIR_Coverage, 61917,
     /* 1992266 */     GIR_EraseRootFromParent_Done,
     /* 1992267 */   // Label 26674: @1992267
     /* 1992267 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1992353), // Rule ID 61920 //
     /* 1992272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1992283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1992286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1992289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992318 */     // MIs[0] policy
     /* 1992318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992328 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1992331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992352 */     // GIR_Coverage, 61920,
     /* 1992352 */     GIR_EraseRootFromParent_Done,
     /* 1992353 */   // Label 26675: @1992353
     /* 1992353 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1992439), // Rule ID 61921 //
     /* 1992358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1992369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1992372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1992375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992404 */     // MIs[0] policy
     /* 1992404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992414 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1992417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992438 */     // GIR_Coverage, 61921,
     /* 1992438 */     GIR_EraseRootFromParent_Done,
     /* 1992439 */   // Label 26676: @1992439
     /* 1992439 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1992525), // Rule ID 61924 //
     /* 1992444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992490 */     // MIs[0] policy
     /* 1992490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992524 */     // GIR_Coverage, 61924,
     /* 1992524 */     GIR_EraseRootFromParent_Done,
     /* 1992525 */   // Label 26677: @1992525
     /* 1992525 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1992611), // Rule ID 61925 //
     /* 1992530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992576 */     // MIs[0] policy
     /* 1992576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992586 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992610 */     // GIR_Coverage, 61925,
     /* 1992610 */     GIR_EraseRootFromParent_Done,
     /* 1992611 */   // Label 26678: @1992611
     /* 1992611 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1992697), // Rule ID 61928 //
     /* 1992616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992662 */     // MIs[0] policy
     /* 1992662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992696 */     // GIR_Coverage, 61928,
     /* 1992696 */     GIR_EraseRootFromParent_Done,
     /* 1992697 */   // Label 26679: @1992697
     /* 1992697 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1992783), // Rule ID 61929 //
     /* 1992702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992748 */     // MIs[0] policy
     /* 1992748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992758 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992782 */     // GIR_Coverage, 61929,
     /* 1992782 */     GIR_EraseRootFromParent_Done,
     /* 1992783 */   // Label 26680: @1992783
     /* 1992783 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1992869), // Rule ID 61932 //
     /* 1992788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992834 */     // MIs[0] policy
     /* 1992834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992868 */     // GIR_Coverage, 61932,
     /* 1992868 */     GIR_EraseRootFromParent_Done,
     /* 1992869 */   // Label 26681: @1992869
     /* 1992869 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1992955), // Rule ID 61933 //
     /* 1992874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992920 */     // MIs[0] policy
     /* 1992920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992954 */     // GIR_Coverage, 61933,
     /* 1992954 */     GIR_EraseRootFromParent_Done,
     /* 1992955 */   // Label 26682: @1992955
     /* 1992955 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1993041), // Rule ID 61936 //
     /* 1992960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993006 */     // MIs[0] policy
     /* 1993006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993040 */     // GIR_Coverage, 61936,
     /* 1993040 */     GIR_EraseRootFromParent_Done,
     /* 1993041 */   // Label 26683: @1993041
     /* 1993041 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1993127), // Rule ID 61937 //
     /* 1993046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1993057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1993060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1993063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993092 */     // MIs[0] policy
     /* 1993092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993126 */     // GIR_Coverage, 61937,
     /* 1993126 */     GIR_EraseRootFromParent_Done,
     /* 1993127 */   // Label 26684: @1993127
     /* 1993127 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1993213), // Rule ID 61940 //
     /* 1993132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1993149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993178 */     // MIs[0] policy
     /* 1993178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993212 */     // GIR_Coverage, 61940,
     /* 1993212 */     GIR_EraseRootFromParent_Done,
     /* 1993213 */   // Label 26685: @1993213
     /* 1993213 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1993299), // Rule ID 61941 //
     /* 1993218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1993235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993264 */     // MIs[0] policy
     /* 1993264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1993277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993298 */     // GIR_Coverage, 61941,
     /* 1993298 */     GIR_EraseRootFromParent_Done,
     /* 1993299 */   // Label 26686: @1993299
     /* 1993299 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1993385), // Rule ID 61944 //
     /* 1993304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1993315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1993318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993350 */     // MIs[0] policy
     /* 1993350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993384 */     // GIR_Coverage, 61944,
     /* 1993384 */     GIR_EraseRootFromParent_Done,
     /* 1993385 */   // Label 26687: @1993385
     /* 1993385 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1993471), // Rule ID 61945 //
     /* 1993390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1993401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1993404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993436 */     // MIs[0] policy
     /* 1993436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11584:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993470 */     // GIR_Coverage, 61945,
     /* 1993470 */     GIR_EraseRootFromParent_Done,
     /* 1993471 */   // Label 26688: @1993471
     /* 1993471 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1993557), // Rule ID 61948 //
     /* 1993476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993522 */     // MIs[0] policy
     /* 1993522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993556 */     // GIR_Coverage, 61948,
     /* 1993556 */     GIR_EraseRootFromParent_Done,
     /* 1993557 */   // Label 26689: @1993557
     /* 1993557 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1993643), // Rule ID 61949 //
     /* 1993562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993608 */     // MIs[0] policy
     /* 1993608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993642 */     // GIR_Coverage, 61949,
     /* 1993642 */     GIR_EraseRootFromParent_Done,
     /* 1993643 */   // Label 26690: @1993643
     /* 1993643 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1993729), // Rule ID 61952 //
     /* 1993648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993694 */     // MIs[0] policy
     /* 1993694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993728 */     // GIR_Coverage, 61952,
     /* 1993728 */     GIR_EraseRootFromParent_Done,
     /* 1993729 */   // Label 26691: @1993729
     /* 1993729 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1993815), // Rule ID 61953 //
     /* 1993734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993780 */     // MIs[0] policy
     /* 1993780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993814 */     // GIR_Coverage, 61953,
     /* 1993814 */     GIR_EraseRootFromParent_Done,
     /* 1993815 */   // Label 26692: @1993815
     /* 1993815 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1993901), // Rule ID 61956 //
     /* 1993820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993866 */     // MIs[0] policy
     /* 1993866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993900 */     // GIR_Coverage, 61956,
     /* 1993900 */     GIR_EraseRootFromParent_Done,
     /* 1993901 */   // Label 26693: @1993901
     /* 1993901 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1993987), // Rule ID 61957 //
     /* 1993906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993952 */     // MIs[0] policy
     /* 1993952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993962 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993986 */     // GIR_Coverage, 61957,
     /* 1993986 */     GIR_EraseRootFromParent_Done,
     /* 1993987 */   // Label 26694: @1993987
     /* 1993987 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1994073), // Rule ID 61960 //
     /* 1993992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1994009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994038 */     // MIs[0] policy
     /* 1994038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994072 */     // GIR_Coverage, 61960,
     /* 1994072 */     GIR_EraseRootFromParent_Done,
     /* 1994073 */   // Label 26695: @1994073
     /* 1994073 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1994159), // Rule ID 61961 //
     /* 1994078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1994089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1994092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1994095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994124 */     // MIs[0] policy
     /* 1994124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994158 */     // GIR_Coverage, 61961,
     /* 1994158 */     GIR_EraseRootFromParent_Done,
     /* 1994159 */   // Label 26696: @1994159
     /* 1994159 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1994245), // Rule ID 61964 //
     /* 1994164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1994175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1994178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1994181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994210 */     // MIs[0] policy
     /* 1994210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994220 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994244 */     // GIR_Coverage, 61964,
     /* 1994244 */     GIR_EraseRootFromParent_Done,
     /* 1994245 */   // Label 26697: @1994245
     /* 1994245 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1994331), // Rule ID 61965 //
     /* 1994250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1994261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1994264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1994267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994296 */     // MIs[0] policy
     /* 1994296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994306 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994330 */     // GIR_Coverage, 61965,
     /* 1994330 */     GIR_EraseRootFromParent_Done,
     /* 1994331 */   // Label 26698: @1994331
     /* 1994331 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1994417), // Rule ID 61968 //
     /* 1994336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1994347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1994350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994382 */     // MIs[0] policy
     /* 1994382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994416 */     // GIR_Coverage, 61968,
     /* 1994416 */     GIR_EraseRootFromParent_Done,
     /* 1994417 */   // Label 26699: @1994417
     /* 1994417 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1994503), // Rule ID 61969 //
     /* 1994422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1994433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1994436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994468 */     // MIs[0] policy
     /* 1994468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994478 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994502 */     // GIR_Coverage, 61969,
     /* 1994502 */     GIR_EraseRootFromParent_Done,
     /* 1994503 */   // Label 26700: @1994503
     /* 1994503 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1994589), // Rule ID 61972 //
     /* 1994508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994554 */     // MIs[0] policy
     /* 1994554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994588 */     // GIR_Coverage, 61972,
     /* 1994588 */     GIR_EraseRootFromParent_Done,
     /* 1994589 */   // Label 26701: @1994589
     /* 1994589 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1994675), // Rule ID 61973 //
     /* 1994594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994640 */     // MIs[0] policy
     /* 1994640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994674 */     // GIR_Coverage, 61973,
     /* 1994674 */     GIR_EraseRootFromParent_Done,
     /* 1994675 */   // Label 26702: @1994675
     /* 1994675 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1994761), // Rule ID 61976 //
     /* 1994680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994726 */     // MIs[0] policy
     /* 1994726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994760 */     // GIR_Coverage, 61976,
     /* 1994760 */     GIR_EraseRootFromParent_Done,
     /* 1994761 */   // Label 26703: @1994761
     /* 1994761 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1994847), // Rule ID 61977 //
     /* 1994766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994812 */     // MIs[0] policy
     /* 1994812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994846 */     // GIR_Coverage, 61977,
     /* 1994846 */     GIR_EraseRootFromParent_Done,
     /* 1994847 */   // Label 26704: @1994847
     /* 1994847 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1994933), // Rule ID 61980 //
     /* 1994852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994898 */     // MIs[0] policy
     /* 1994898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994932 */     // GIR_Coverage, 61980,
     /* 1994932 */     GIR_EraseRootFromParent_Done,
     /* 1994933 */   // Label 26705: @1994933
     /* 1994933 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1995019), // Rule ID 61981 //
     /* 1994938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994984 */     // MIs[0] policy
     /* 1994984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995018 */     // GIR_Coverage, 61981,
     /* 1995018 */     GIR_EraseRootFromParent_Done,
     /* 1995019 */   // Label 26706: @1995019
     /* 1995019 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1995105), // Rule ID 61984 //
     /* 1995024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995070 */     // MIs[0] policy
     /* 1995070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995104 */     // GIR_Coverage, 61984,
     /* 1995104 */     GIR_EraseRootFromParent_Done,
     /* 1995105 */   // Label 26707: @1995105
     /* 1995105 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1995191), // Rule ID 61985 //
     /* 1995110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1995127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995156 */     // MIs[0] policy
     /* 1995156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995190 */     // GIR_Coverage, 61985,
     /* 1995190 */     GIR_EraseRootFromParent_Done,
     /* 1995191 */   // Label 26708: @1995191
     /* 1995191 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1995277), // Rule ID 61988 //
     /* 1995196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995242 */     // MIs[0] policy
     /* 1995242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995276 */     // GIR_Coverage, 61988,
     /* 1995276 */     GIR_EraseRootFromParent_Done,
     /* 1995277 */   // Label 26709: @1995277
     /* 1995277 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1995363), // Rule ID 61989 //
     /* 1995282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1995299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995328 */     // MIs[0] policy
     /* 1995328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995362 */     // GIR_Coverage, 61989,
     /* 1995362 */     GIR_EraseRootFromParent_Done,
     /* 1995363 */   // Label 26710: @1995363
     /* 1995363 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1995449), // Rule ID 61992 //
     /* 1995368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995414 */     // MIs[0] policy
     /* 1995414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995448 */     // GIR_Coverage, 61992,
     /* 1995448 */     GIR_EraseRootFromParent_Done,
     /* 1995449 */   // Label 26711: @1995449
     /* 1995449 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1995535), // Rule ID 61993 //
     /* 1995454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995500 */     // MIs[0] policy
     /* 1995500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995534 */     // GIR_Coverage, 61993,
     /* 1995534 */     GIR_EraseRootFromParent_Done,
     /* 1995535 */   // Label 26712: @1995535
     /* 1995535 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1995621), // Rule ID 61996 //
     /* 1995540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995586 */     // MIs[0] policy
     /* 1995586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995620 */     // GIR_Coverage, 61996,
     /* 1995620 */     GIR_EraseRootFromParent_Done,
     /* 1995621 */   // Label 26713: @1995621
     /* 1995621 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1995707), // Rule ID 61997 //
     /* 1995626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995672 */     // MIs[0] policy
     /* 1995672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995682 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995706 */     // GIR_Coverage, 61997,
     /* 1995706 */     GIR_EraseRootFromParent_Done,
     /* 1995707 */   // Label 26714: @1995707
     /* 1995707 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1995793), // Rule ID 62000 //
     /* 1995712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995758 */     // MIs[0] policy
     /* 1995758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995792 */     // GIR_Coverage, 62000,
     /* 1995792 */     GIR_EraseRootFromParent_Done,
     /* 1995793 */   // Label 26715: @1995793
     /* 1995793 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1995879), // Rule ID 62001 //
     /* 1995798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995844 */     // MIs[0] policy
     /* 1995844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995878 */     // GIR_Coverage, 62001,
     /* 1995878 */     GIR_EraseRootFromParent_Done,
     /* 1995879 */   // Label 26716: @1995879
     /* 1995879 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1995965), // Rule ID 62004 //
     /* 1995884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995930 */     // MIs[0] policy
     /* 1995930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995940 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995964 */     // GIR_Coverage, 62004,
     /* 1995964 */     GIR_EraseRootFromParent_Done,
     /* 1995965 */   // Label 26717: @1995965
     /* 1995965 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1996051), // Rule ID 62005 //
     /* 1995970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996016 */     // MIs[0] policy
     /* 1996016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1996029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1996033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1996047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996050 */     // GIR_Coverage, 62005,
     /* 1996050 */     GIR_EraseRootFromParent_Done,
     /* 1996051 */   // Label 26718: @1996051
     /* 1996051 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1996137), // Rule ID 62610 //
     /* 1996056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996102 */     // MIs[0] policy
     /* 1996102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1996115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996136 */     // GIR_Coverage, 62610,
     /* 1996136 */     GIR_EraseRootFromParent_Done,
     /* 1996137 */   // Label 26719: @1996137
     /* 1996137 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1996223), // Rule ID 62611 //
     /* 1996142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996188 */     // MIs[0] policy
     /* 1996188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_MF2_MASK),
     /* 1996201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996222 */     // GIR_Coverage, 62611,
     /* 1996222 */     GIR_EraseRootFromParent_Done,
     /* 1996223 */   // Label 26720: @1996223
     /* 1996223 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1996309), // Rule ID 62614 //
     /* 1996228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996274 */     // MIs[0] policy
     /* 1996274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1996287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996308 */     // GIR_Coverage, 62614,
     /* 1996308 */     GIR_EraseRootFromParent_Done,
     /* 1996309 */   // Label 26721: @1996309
     /* 1996309 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1996395), // Rule ID 62615 //
     /* 1996314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996360 */     // MIs[0] policy
     /* 1996360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M1_MASK),
     /* 1996373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996394 */     // GIR_Coverage, 62615,
     /* 1996394 */     GIR_EraseRootFromParent_Done,
     /* 1996395 */   // Label 26722: @1996395
     /* 1996395 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1996481), // Rule ID 62618 //
     /* 1996400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996446 */     // MIs[0] policy
     /* 1996446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996480 */     // GIR_Coverage, 62618,
     /* 1996480 */     GIR_EraseRootFromParent_Done,
     /* 1996481 */   // Label 26723: @1996481
     /* 1996481 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1996567), // Rule ID 62619 //
     /* 1996486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996532 */     // MIs[0] policy
     /* 1996532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M2_MASK),
     /* 1996545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996566 */     // GIR_Coverage, 62619,
     /* 1996566 */     GIR_EraseRootFromParent_Done,
     /* 1996567 */   // Label 26724: @1996567
     /* 1996567 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1996653), // Rule ID 62622 //
     /* 1996572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996618 */     // MIs[0] policy
     /* 1996618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996652 */     // GIR_Coverage, 62622,
     /* 1996652 */     GIR_EraseRootFromParent_Done,
     /* 1996653 */   // Label 26725: @1996653
     /* 1996653 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1996739), // Rule ID 62623 //
     /* 1996658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996704 */     // MIs[0] policy
     /* 1996704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M4_MASK),
     /* 1996717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996738 */     // GIR_Coverage, 62623,
     /* 1996738 */     GIR_EraseRootFromParent_Done,
     /* 1996739 */   // Label 26726: @1996739
     /* 1996739 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1996825), // Rule ID 62626 //
     /* 1996744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996790 */     // MIs[0] policy
     /* 1996790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996800 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996824 */     // GIR_Coverage, 62626,
     /* 1996824 */     GIR_EraseRootFromParent_Done,
     /* 1996825 */   // Label 26727: @1996825
     /* 1996825 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1996911), // Rule ID 62627 //
     /* 1996830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996876 */     // MIs[0] policy
     /* 1996876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VV_M8_MASK),
     /* 1996889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996910 */     // GIR_Coverage, 62627,
     /* 1996910 */     GIR_EraseRootFromParent_Done,
     /* 1996911 */   // Label 26728: @1996911
     /* 1996911 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1996997), // Rule ID 62630 //
     /* 1996916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996962 */     // MIs[0] policy
     /* 1996962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1996975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996996 */     // GIR_Coverage, 62630,
     /* 1996996 */     GIR_EraseRootFromParent_Done,
     /* 1996997 */   // Label 26729: @1996997
     /* 1996997 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1997083), // Rule ID 62631 //
     /* 1997002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997048 */     // MIs[0] policy
     /* 1997048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_MF2_MASK),
     /* 1997061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997082 */     // GIR_Coverage, 62631,
     /* 1997082 */     GIR_EraseRootFromParent_Done,
     /* 1997083 */   // Label 26730: @1997083
     /* 1997083 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1997169), // Rule ID 62634 //
     /* 1997088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997134 */     // MIs[0] policy
     /* 1997134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1997147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997168 */     // GIR_Coverage, 62634,
     /* 1997168 */     GIR_EraseRootFromParent_Done,
     /* 1997169 */   // Label 26731: @1997169
     /* 1997169 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1997255), // Rule ID 62635 //
     /* 1997174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997220 */     // MIs[0] policy
     /* 1997220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M1_MASK),
     /* 1997233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997254 */     // GIR_Coverage, 62635,
     /* 1997254 */     GIR_EraseRootFromParent_Done,
     /* 1997255 */   // Label 26732: @1997255
     /* 1997255 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1997341), // Rule ID 62638 //
     /* 1997260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997306 */     // MIs[0] policy
     /* 1997306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1997319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997340 */     // GIR_Coverage, 62638,
     /* 1997340 */     GIR_EraseRootFromParent_Done,
     /* 1997341 */   // Label 26733: @1997341
     /* 1997341 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1997427), // Rule ID 62639 //
     /* 1997346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997392 */     // MIs[0] policy
     /* 1997392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M2_MASK),
     /* 1997405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997426 */     // GIR_Coverage, 62639,
     /* 1997426 */     GIR_EraseRootFromParent_Done,
     /* 1997427 */   // Label 26734: @1997427
     /* 1997427 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1997513), // Rule ID 62642 //
     /* 1997432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997478 */     // MIs[0] policy
     /* 1997478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997512 */     // GIR_Coverage, 62642,
     /* 1997512 */     GIR_EraseRootFromParent_Done,
     /* 1997513 */   // Label 26735: @1997513
     /* 1997513 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1997599), // Rule ID 62643 //
     /* 1997518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997564 */     // MIs[0] policy
     /* 1997564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M4_MASK),
     /* 1997577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997598 */     // GIR_Coverage, 62643,
     /* 1997598 */     GIR_EraseRootFromParent_Done,
     /* 1997599 */   // Label 26736: @1997599
     /* 1997599 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1997685), // Rule ID 62646 //
     /* 1997604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997650 */     // MIs[0] policy
     /* 1997650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997684 */     // GIR_Coverage, 62646,
     /* 1997684 */     GIR_EraseRootFromParent_Done,
     /* 1997685 */   // Label 26737: @1997685
     /* 1997685 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1997771), // Rule ID 62647 //
     /* 1997690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997736 */     // MIs[0] policy
     /* 1997736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQA_VX_M8_MASK),
     /* 1997749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997770 */     // GIR_Coverage, 62647,
     /* 1997770 */     GIR_EraseRootFromParent_Done,
     /* 1997771 */   // Label 26738: @1997771
     /* 1997771 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1997857), // Rule ID 62650 //
     /* 1997776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997822 */     // MIs[0] policy
     /* 1997822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997856 */     // GIR_Coverage, 62650,
     /* 1997856 */     GIR_EraseRootFromParent_Done,
     /* 1997857 */   // Label 26739: @1997857
     /* 1997857 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(1997943), // Rule ID 62651 //
     /* 1997862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997908 */     // MIs[0] policy
     /* 1997908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_MF2_MASK),
     /* 1997921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997942 */     // GIR_Coverage, 62651,
     /* 1997942 */     GIR_EraseRootFromParent_Done,
     /* 1997943 */   // Label 26740: @1997943
     /* 1997943 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(1998029), // Rule ID 62654 //
     /* 1997948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997994 */     // MIs[0] policy
     /* 1997994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1998007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998028 */     // GIR_Coverage, 62654,
     /* 1998028 */     GIR_EraseRootFromParent_Done,
     /* 1998029 */   // Label 26741: @1998029
     /* 1998029 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(1998115), // Rule ID 62655 //
     /* 1998034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1998051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998080 */     // MIs[0] policy
     /* 1998080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M1_MASK),
     /* 1998093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998114 */     // GIR_Coverage, 62655,
     /* 1998114 */     GIR_EraseRootFromParent_Done,
     /* 1998115 */   // Label 26742: @1998115
     /* 1998115 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(1998201), // Rule ID 62658 //
     /* 1998120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1998137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998166 */     // MIs[0] policy
     /* 1998166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1998179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998200 */     // GIR_Coverage, 62658,
     /* 1998200 */     GIR_EraseRootFromParent_Done,
     /* 1998201 */   // Label 26743: @1998201
     /* 1998201 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(1998287), // Rule ID 62659 //
     /* 1998206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1998223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998252 */     // MIs[0] policy
     /* 1998252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M2_MASK),
     /* 1998265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998286 */     // GIR_Coverage, 62659,
     /* 1998286 */     GIR_EraseRootFromParent_Done,
     /* 1998287 */   // Label 26744: @1998287
     /* 1998287 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(1998373), // Rule ID 62662 //
     /* 1998292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1998309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998338 */     // MIs[0] policy
     /* 1998338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1998351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998372 */     // GIR_Coverage, 62662,
     /* 1998372 */     GIR_EraseRootFromParent_Done,
     /* 1998373 */   // Label 26745: @1998373
     /* 1998373 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(1998459), // Rule ID 62663 //
     /* 1998378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1998395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998424 */     // MIs[0] policy
     /* 1998424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M4_MASK),
     /* 1998437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998458 */     // GIR_Coverage, 62663,
     /* 1998458 */     GIR_EraseRootFromParent_Done,
     /* 1998459 */   // Label 26746: @1998459
     /* 1998459 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(1998545), // Rule ID 62666 //
     /* 1998464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998510 */     // MIs[0] policy
     /* 1998510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998544 */     // GIR_Coverage, 62666,
     /* 1998544 */     GIR_EraseRootFromParent_Done,
     /* 1998545 */   // Label 26747: @1998545
     /* 1998545 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(1998631), // Rule ID 62667 //
     /* 1998550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998596 */     // MIs[0] policy
     /* 1998596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VV_M8_MASK),
     /* 1998609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998630 */     // GIR_Coverage, 62667,
     /* 1998630 */     GIR_EraseRootFromParent_Done,
     /* 1998631 */   // Label 26748: @1998631
     /* 1998631 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(1998717), // Rule ID 62670 //
     /* 1998636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998682 */     // MIs[0] policy
     /* 1998682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998692 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998716 */     // GIR_Coverage, 62670,
     /* 1998716 */     GIR_EraseRootFromParent_Done,
     /* 1998717 */   // Label 26749: @1998717
     /* 1998717 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(1998803), // Rule ID 62671 //
     /* 1998722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998768 */     // MIs[0] policy
     /* 1998768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998778 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_MF2_MASK),
     /* 1998781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998802 */     // GIR_Coverage, 62671,
     /* 1998802 */     GIR_EraseRootFromParent_Done,
     /* 1998803 */   // Label 26750: @1998803
     /* 1998803 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(1998889), // Rule ID 62674 //
     /* 1998808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998854 */     // MIs[0] policy
     /* 1998854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998888 */     // GIR_Coverage, 62674,
     /* 1998888 */     GIR_EraseRootFromParent_Done,
     /* 1998889 */   // Label 26751: @1998889
     /* 1998889 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(1998975), // Rule ID 62675 //
     /* 1998894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998940 */     // MIs[0] policy
     /* 1998940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M1_MASK),
     /* 1998953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998974 */     // GIR_Coverage, 62675,
     /* 1998974 */     GIR_EraseRootFromParent_Done,
     /* 1998975 */   // Label 26752: @1998975
     /* 1998975 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(1999061), // Rule ID 62678 //
     /* 1998980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999026 */     // MIs[0] policy
     /* 1999026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1999039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999060 */     // GIR_Coverage, 62678,
     /* 1999060 */     GIR_EraseRootFromParent_Done,
     /* 1999061 */   // Label 26753: @1999061
     /* 1999061 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(1999147), // Rule ID 62679 //
     /* 1999066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999112 */     // MIs[0] policy
     /* 1999112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M2_MASK),
     /* 1999125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999146 */     // GIR_Coverage, 62679,
     /* 1999146 */     GIR_EraseRootFromParent_Done,
     /* 1999147 */   // Label 26754: @1999147
     /* 1999147 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(1999233), // Rule ID 62682 //
     /* 1999152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999198 */     // MIs[0] policy
     /* 1999198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999208 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1999211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999232 */     // GIR_Coverage, 62682,
     /* 1999232 */     GIR_EraseRootFromParent_Done,
     /* 1999233 */   // Label 26755: @1999233
     /* 1999233 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(1999319), // Rule ID 62683 //
     /* 1999238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999284 */     // MIs[0] policy
     /* 1999284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M4_MASK),
     /* 1999297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999318 */     // GIR_Coverage, 62683,
     /* 1999318 */     GIR_EraseRootFromParent_Done,
     /* 1999319 */   // Label 26756: @1999319
     /* 1999319 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(1999405), // Rule ID 62686 //
     /* 1999324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999370 */     // MIs[0] policy
     /* 1999370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1999383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999404 */     // GIR_Coverage, 62686,
     /* 1999404 */     GIR_EraseRootFromParent_Done,
     /* 1999405 */   // Label 26757: @1999405
     /* 1999405 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(1999491), // Rule ID 62687 //
     /* 1999410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1999418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999456 */     // MIs[0] policy
     /* 1999456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAU_VX_M8_MASK),
     /* 1999469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999490 */     // GIR_Coverage, 62687,
     /* 1999490 */     GIR_EraseRootFromParent_Done,
     /* 1999491 */   // Label 26758: @1999491
     /* 1999491 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(1999577), // Rule ID 62690 //
     /* 1999496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999542 */     // MIs[0] policy
     /* 1999542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999576 */     // GIR_Coverage, 62690,
     /* 1999576 */     GIR_EraseRootFromParent_Done,
     /* 1999577 */   // Label 26759: @1999577
     /* 1999577 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(1999663), // Rule ID 62691 //
     /* 1999582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999628 */     // MIs[0] policy
     /* 1999628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_MF2_MASK),
     /* 1999641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999662 */     // GIR_Coverage, 62691,
     /* 1999662 */     GIR_EraseRootFromParent_Done,
     /* 1999663 */   // Label 26760: @1999663
     /* 1999663 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(1999749), // Rule ID 62694 //
     /* 1999668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999714 */     // MIs[0] policy
     /* 1999714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999748 */     // GIR_Coverage, 62694,
     /* 1999748 */     GIR_EraseRootFromParent_Done,
     /* 1999749 */   // Label 26761: @1999749
     /* 1999749 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(1999835), // Rule ID 62695 //
     /* 1999754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999800 */     // MIs[0] policy
     /* 1999800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M1_MASK),
     /* 1999813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999834 */     // GIR_Coverage, 62695,
     /* 1999834 */     GIR_EraseRootFromParent_Done,
     /* 1999835 */   // Label 26762: @1999835
     /* 1999835 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(1999921), // Rule ID 62698 //
     /* 1999840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999886 */     // MIs[0] policy
     /* 1999886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999920 */     // GIR_Coverage, 62698,
     /* 1999920 */     GIR_EraseRootFromParent_Done,
     /* 1999921 */   // Label 26763: @1999921
     /* 1999921 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2000007), // Rule ID 62699 //
     /* 1999926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999972 */     // MIs[0] policy
     /* 1999972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M2_MASK),
     /* 1999985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000006 */     // GIR_Coverage, 62699,
     /* 2000006 */     GIR_EraseRootFromParent_Done,
     /* 2000007 */   // Label 26764: @2000007
     /* 2000007 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2000093), // Rule ID 62702 //
     /* 2000012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2000029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000058 */     // MIs[0] policy
     /* 2000058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 2000071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000092 */     // GIR_Coverage, 62702,
     /* 2000092 */     GIR_EraseRootFromParent_Done,
     /* 2000093 */   // Label 26765: @2000093
     /* 2000093 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2000179), // Rule ID 62703 //
     /* 2000098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2000115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000144 */     // MIs[0] policy
     /* 2000144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M4_MASK),
     /* 2000157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000178 */     // GIR_Coverage, 62703,
     /* 2000178 */     GIR_EraseRootFromParent_Done,
     /* 2000179 */   // Label 26766: @2000179
     /* 2000179 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2000265), // Rule ID 62706 //
     /* 2000184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000230 */     // MIs[0] policy
     /* 2000230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 2000243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000264 */     // GIR_Coverage, 62706,
     /* 2000264 */     GIR_EraseRootFromParent_Done,
     /* 2000265 */   // Label 26767: @2000265
     /* 2000265 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2000351), // Rule ID 62707 //
     /* 2000270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2000287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000316 */     // MIs[0] policy
     /* 2000316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VV_M8_MASK),
     /* 2000329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000350 */     // GIR_Coverage, 62707,
     /* 2000350 */     GIR_EraseRootFromParent_Done,
     /* 2000351 */   // Label 26768: @2000351
     /* 2000351 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2000437), // Rule ID 62710 //
     /* 2000356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000402 */     // MIs[0] policy
     /* 2000402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 2000415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000436 */     // GIR_Coverage, 62710,
     /* 2000436 */     GIR_EraseRootFromParent_Done,
     /* 2000437 */   // Label 26769: @2000437
     /* 2000437 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2000523), // Rule ID 62711 //
     /* 2000442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000488 */     // MIs[0] policy
     /* 2000488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_MF2_MASK),
     /* 2000501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000522 */     // GIR_Coverage, 62711,
     /* 2000522 */     GIR_EraseRootFromParent_Done,
     /* 2000523 */   // Label 26770: @2000523
     /* 2000523 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2000609), // Rule ID 62714 //
     /* 2000528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000574 */     // MIs[0] policy
     /* 2000574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000608 */     // GIR_Coverage, 62714,
     /* 2000608 */     GIR_EraseRootFromParent_Done,
     /* 2000609 */   // Label 26771: @2000609
     /* 2000609 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2000695), // Rule ID 62715 //
     /* 2000614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000660 */     // MIs[0] policy
     /* 2000660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M1_MASK),
     /* 2000673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000694 */     // GIR_Coverage, 62715,
     /* 2000694 */     GIR_EraseRootFromParent_Done,
     /* 2000695 */   // Label 26772: @2000695
     /* 2000695 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2000781), // Rule ID 62718 //
     /* 2000700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000746 */     // MIs[0] policy
     /* 2000746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000780 */     // GIR_Coverage, 62718,
     /* 2000780 */     GIR_EraseRootFromParent_Done,
     /* 2000781 */   // Label 26773: @2000781
     /* 2000781 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2000867), // Rule ID 62719 //
     /* 2000786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000832 */     // MIs[0] policy
     /* 2000832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M2_MASK),
     /* 2000845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000866 */     // GIR_Coverage, 62719,
     /* 2000866 */     GIR_EraseRootFromParent_Done,
     /* 2000867 */   // Label 26774: @2000867
     /* 2000867 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2000953), // Rule ID 62722 //
     /* 2000872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000918 */     // MIs[0] policy
     /* 2000918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2000931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000952 */     // GIR_Coverage, 62722,
     /* 2000952 */     GIR_EraseRootFromParent_Done,
     /* 2000953 */   // Label 26775: @2000953
     /* 2000953 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2001039), // Rule ID 62723 //
     /* 2000958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001004 */     // MIs[0] policy
     /* 2001004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M4_MASK),
     /* 2001017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001038 */     // GIR_Coverage, 62723,
     /* 2001038 */     GIR_EraseRootFromParent_Done,
     /* 2001039 */   // Label 26776: @2001039
     /* 2001039 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2001125), // Rule ID 62726 //
     /* 2001044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2001052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001090 */     // MIs[0] policy
     /* 2001090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2001103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001124 */     // GIR_Coverage, 62726,
     /* 2001124 */     GIR_EraseRootFromParent_Done,
     /* 2001125 */   // Label 26777: @2001125
     /* 2001125 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2001211), // Rule ID 62727 //
     /* 2001130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2001138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001176 */     // MIs[0] policy
     /* 2001176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQASU_VX_M8_MASK),
     /* 2001189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001210 */     // GIR_Coverage, 62727,
     /* 2001210 */     GIR_EraseRootFromParent_Done,
     /* 2001211 */   // Label 26778: @2001211
     /* 2001211 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2001297), // Rule ID 62730 //
     /* 2001216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001262 */     // MIs[0] policy
     /* 2001262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2001275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001296 */     // GIR_Coverage, 62730,
     /* 2001296 */     GIR_EraseRootFromParent_Done,
     /* 2001297 */   // Label 26779: @2001297
     /* 2001297 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2001383), // Rule ID 62731 //
     /* 2001302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001348 */     // MIs[0] policy
     /* 2001348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_MF2_MASK),
     /* 2001361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001382 */     // GIR_Coverage, 62731,
     /* 2001382 */     GIR_EraseRootFromParent_Done,
     /* 2001383 */   // Label 26780: @2001383
     /* 2001383 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2001469), // Rule ID 62734 //
     /* 2001388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001434 */     // MIs[0] policy
     /* 2001434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2001447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001468 */     // GIR_Coverage, 62734,
     /* 2001468 */     GIR_EraseRootFromParent_Done,
     /* 2001469 */   // Label 26781: @2001469
     /* 2001469 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2001555), // Rule ID 62735 //
     /* 2001474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001520 */     // MIs[0] policy
     /* 2001520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M1_MASK),
     /* 2001533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001554 */     // GIR_Coverage, 62735,
     /* 2001554 */     GIR_EraseRootFromParent_Done,
     /* 2001555 */   // Label 26782: @2001555
     /* 2001555 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2001641), // Rule ID 62738 //
     /* 2001560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001606 */     // MIs[0] policy
     /* 2001606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001640 */     // GIR_Coverage, 62738,
     /* 2001640 */     GIR_EraseRootFromParent_Done,
     /* 2001641 */   // Label 26783: @2001641
     /* 2001641 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2001727), // Rule ID 62739 //
     /* 2001646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001692 */     // MIs[0] policy
     /* 2001692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M2_MASK),
     /* 2001705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001726 */     // GIR_Coverage, 62739,
     /* 2001726 */     GIR_EraseRootFromParent_Done,
     /* 2001727 */   // Label 26784: @2001727
     /* 2001727 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2001813), // Rule ID 62742 //
     /* 2001732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001778 */     // MIs[0] policy
     /* 2001778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001812 */     // GIR_Coverage, 62742,
     /* 2001812 */     GIR_EraseRootFromParent_Done,
     /* 2001813 */   // Label 26785: @2001813
     /* 2001813 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2001899), // Rule ID 62743 //
     /* 2001818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001864 */     // MIs[0] policy
     /* 2001864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M4_MASK),
     /* 2001877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001898 */     // GIR_Coverage, 62743,
     /* 2001898 */     GIR_EraseRootFromParent_Done,
     /* 2001899 */   // Label 26786: @2001899
     /* 2001899 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2001985), // Rule ID 62746 //
     /* 2001904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001950 */     // MIs[0] policy
     /* 2001950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2001963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001984 */     // GIR_Coverage, 62746,
     /* 2001984 */     GIR_EraseRootFromParent_Done,
     /* 2001985 */   // Label 26787: @2001985
     /* 2001985 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2002071), // Rule ID 62747 //
     /* 2001990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2002007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2002013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2002028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002036 */     // MIs[0] policy
     /* 2002036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTH_VMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTH_VMAQAUS_VX_M8_MASK),
     /* 2002049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002070 */     // GIR_Coverage, 62747,
     /* 2002070 */     GIR_EraseRootFromParent_Done,
     /* 2002071 */   // Label 26788: @2002071
     /* 2002071 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2002157), // Rule ID 65234 //
     /* 2002076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002122 */     // MIs[0] policy
     /* 2002122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2002135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002156 */     // GIR_Coverage, 65234,
     /* 2002156 */     GIR_EraseRootFromParent_Done,
     /* 2002157 */   // Label 26789: @2002157
     /* 2002157 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2002243), // Rule ID 65235 //
     /* 2002162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2002173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2002176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2002179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2002182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002208 */     // MIs[0] policy
     /* 2002208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2002221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002242 */     // GIR_Coverage, 65235,
     /* 2002242 */     GIR_EraseRootFromParent_Done,
     /* 2002243 */   // Label 26790: @2002243
     /* 2002243 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2002329), // Rule ID 65238 //
     /* 2002248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2002265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002294 */     // MIs[0] policy
     /* 2002294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002328 */     // GIR_Coverage, 65238,
     /* 2002328 */     GIR_EraseRootFromParent_Done,
     /* 2002329 */   // Label 26791: @2002329
     /* 2002329 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2002415), // Rule ID 65239 //
     /* 2002334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2002351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2002354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002380 */     // MIs[0] policy
     /* 2002380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002414 */     // GIR_Coverage, 65239,
     /* 2002414 */     GIR_EraseRootFromParent_Done,
     /* 2002415 */   // Label 26792: @2002415
     /* 2002415 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2002501), // Rule ID 65242 //
     /* 2002420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002466 */     // MIs[0] policy
     /* 2002466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002500 */     // GIR_Coverage, 65242,
     /* 2002500 */     GIR_EraseRootFromParent_Done,
     /* 2002501 */   // Label 26793: @2002501
     /* 2002501 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2002587), // Rule ID 65243 //
     /* 2002506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002552 */     // MIs[0] policy
     /* 2002552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002586 */     // GIR_Coverage, 65243,
     /* 2002586 */     GIR_EraseRootFromParent_Done,
     /* 2002587 */   // Label 26794: @2002587
     /* 2002587 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2002673), // Rule ID 65246 //
     /* 2002592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002638 */     // MIs[0] policy
     /* 2002638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002672 */     // GIR_Coverage, 65246,
     /* 2002672 */     GIR_EraseRootFromParent_Done,
     /* 2002673 */   // Label 26795: @2002673
     /* 2002673 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2002759), // Rule ID 65247 //
     /* 2002678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002724 */     // MIs[0] policy
     /* 2002724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002758 */     // GIR_Coverage, 65247,
     /* 2002758 */     GIR_EraseRootFromParent_Done,
     /* 2002759 */   // Label 26796: @2002759
     /* 2002759 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2002845), // Rule ID 65250 //
     /* 2002764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002810 */     // MIs[0] policy
     /* 2002810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002844 */     // GIR_Coverage, 65250,
     /* 2002844 */     GIR_EraseRootFromParent_Done,
     /* 2002845 */   // Label 26797: @2002845
     /* 2002845 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2002931), // Rule ID 65251 //
     /* 2002850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002896 */     // MIs[0] policy
     /* 2002896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002930 */     // GIR_Coverage, 65251,
     /* 2002930 */     GIR_EraseRootFromParent_Done,
     /* 2002931 */   // Label 26798: @2002931
     /* 2002931 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2003017), // Rule ID 65254 //
     /* 2002936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002982 */     // MIs[0] policy
     /* 2002982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003016 */     // GIR_Coverage, 65254,
     /* 2003016 */     GIR_EraseRootFromParent_Done,
     /* 2003017 */   // Label 26799: @2003017
     /* 2003017 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2003103), // Rule ID 65255 //
     /* 2003022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2003039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003068 */     // MIs[0] policy
     /* 2003068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2003081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003102 */     // GIR_Coverage, 65255,
     /* 2003102 */     GIR_EraseRootFromParent_Done,
     /* 2003103 */   // Label 26800: @2003103
     /* 2003103 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2003189), // Rule ID 65258 //
     /* 2003108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2003119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2003122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003154 */     // MIs[0] policy
     /* 2003154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2003167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003188 */     // GIR_Coverage, 65258,
     /* 2003188 */     GIR_EraseRootFromParent_Done,
     /* 2003189 */   // Label 26801: @2003189
     /* 2003189 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2003275), // Rule ID 65259 //
     /* 2003194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2003205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2003208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2003214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003240 */     // MIs[0] policy
     /* 2003240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2003253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003274 */     // GIR_Coverage, 65259,
     /* 2003274 */     GIR_EraseRootFromParent_Done,
     /* 2003275 */   // Label 26802: @2003275
     /* 2003275 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2003361), // Rule ID 65262 //
     /* 2003280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2003291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2003294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003326 */     // MIs[0] policy
     /* 2003326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2003339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003360 */     // GIR_Coverage, 65262,
     /* 2003360 */     GIR_EraseRootFromParent_Done,
     /* 2003361 */   // Label 26803: @2003361
     /* 2003361 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2003447), // Rule ID 65263 //
     /* 2003366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2003377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2003380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2003386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003412 */     // MIs[0] policy
     /* 2003412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003422 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2003425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003446 */     // GIR_Coverage, 65263,
     /* 2003446 */     GIR_EraseRootFromParent_Done,
     /* 2003447 */   // Label 26804: @2003447
     /* 2003447 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2003533), // Rule ID 65266 //
     /* 2003452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2003455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003498 */     // MIs[0] policy
     /* 2003498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003532 */     // GIR_Coverage, 65266,
     /* 2003532 */     GIR_EraseRootFromParent_Done,
     /* 2003533 */   // Label 26805: @2003533
     /* 2003533 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2003619), // Rule ID 65267 //
     /* 2003538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003584 */     // MIs[0] policy
     /* 2003584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003618 */     // GIR_Coverage, 65267,
     /* 2003618 */     GIR_EraseRootFromParent_Done,
     /* 2003619 */   // Label 26806: @2003619
     /* 2003619 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2003705), // Rule ID 65270 //
     /* 2003624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003670 */     // MIs[0] policy
     /* 2003670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003704 */     // GIR_Coverage, 65270,
     /* 2003704 */     GIR_EraseRootFromParent_Done,
     /* 2003705 */   // Label 26807: @2003705
     /* 2003705 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2003791), // Rule ID 65271 //
     /* 2003710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003756 */     // MIs[0] policy
     /* 2003756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003790 */     // GIR_Coverage, 65271,
     /* 2003790 */     GIR_EraseRootFromParent_Done,
     /* 2003791 */   // Label 26808: @2003791
     /* 2003791 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2003877), // Rule ID 65274 //
     /* 2003796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003842 */     // MIs[0] policy
     /* 2003842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003876 */     // GIR_Coverage, 65274,
     /* 2003876 */     GIR_EraseRootFromParent_Done,
     /* 2003877 */   // Label 26809: @2003877
     /* 2003877 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2003963), // Rule ID 65275 //
     /* 2003882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003928 */     // MIs[0] policy
     /* 2003928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003962 */     // GIR_Coverage, 65275,
     /* 2003962 */     GIR_EraseRootFromParent_Done,
     /* 2003963 */   // Label 26810: @2003963
     /* 2003963 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2004049), // Rule ID 65278 //
     /* 2003968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004014 */     // MIs[0] policy
     /* 2004014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004048 */     // GIR_Coverage, 65278,
     /* 2004048 */     GIR_EraseRootFromParent_Done,
     /* 2004049 */   // Label 26811: @2004049
     /* 2004049 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2004135), // Rule ID 65279 //
     /* 2004054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2004065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2004068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2004071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2004074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004100 */     // MIs[0] policy
     /* 2004100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004134 */     // GIR_Coverage, 65279,
     /* 2004134 */     GIR_EraseRootFromParent_Done,
     /* 2004135 */   // Label 26812: @2004135
     /* 2004135 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2004221), // Rule ID 65282 //
     /* 2004140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2004157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004186 */     // MIs[0] policy
     /* 2004186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004220 */     // GIR_Coverage, 65282,
     /* 2004220 */     GIR_EraseRootFromParent_Done,
     /* 2004221 */   // Label 26813: @2004221
     /* 2004221 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2004307), // Rule ID 65283 //
     /* 2004226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2004237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2004240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2004243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2004246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004272 */     // MIs[0] policy
     /* 2004272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004306 */     // GIR_Coverage, 65283,
     /* 2004306 */     GIR_EraseRootFromParent_Done,
     /* 2004307 */   // Label 26814: @2004307
     /* 2004307 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2004393), // Rule ID 65286 //
     /* 2004312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2004329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004358 */     // MIs[0] policy
     /* 2004358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004392 */     // GIR_Coverage, 65286,
     /* 2004392 */     GIR_EraseRootFromParent_Done,
     /* 2004393 */   // Label 26815: @2004393
     /* 2004393 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2004479), // Rule ID 65287 //
     /* 2004398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2004409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2004412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2004415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2004418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004444 */     // MIs[0] policy
     /* 2004444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004454 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004478 */     // GIR_Coverage, 65287,
     /* 2004478 */     GIR_EraseRootFromParent_Done,
     /* 2004479 */   // Label 26816: @2004479
     /* 2004479 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2004565), // Rule ID 65290 //
     /* 2004484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004530 */     // MIs[0] policy
     /* 2004530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004564 */     // GIR_Coverage, 65290,
     /* 2004564 */     GIR_EraseRootFromParent_Done,
     /* 2004565 */   // Label 26817: @2004565
     /* 2004565 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2004651), // Rule ID 65291 //
     /* 2004570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004616 */     // MIs[0] policy
     /* 2004616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004650 */     // GIR_Coverage, 65291,
     /* 2004650 */     GIR_EraseRootFromParent_Done,
     /* 2004651 */   // Label 26818: @2004651
     /* 2004651 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2004737), // Rule ID 65294 //
     /* 2004656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004702 */     // MIs[0] policy
     /* 2004702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004736 */     // GIR_Coverage, 65294,
     /* 2004736 */     GIR_EraseRootFromParent_Done,
     /* 2004737 */   // Label 26819: @2004737
     /* 2004737 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2004823), // Rule ID 65295 //
     /* 2004742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004788 */     // MIs[0] policy
     /* 2004788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004822 */     // GIR_Coverage, 65295,
     /* 2004822 */     GIR_EraseRootFromParent_Done,
     /* 2004823 */   // Label 26820: @2004823
     /* 2004823 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2004909), // Rule ID 65298 //
     /* 2004828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004874 */     // MIs[0] policy
     /* 2004874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004908 */     // GIR_Coverage, 65298,
     /* 2004908 */     GIR_EraseRootFromParent_Done,
     /* 2004909 */   // Label 26821: @2004909
     /* 2004909 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2004995), // Rule ID 65299 //
     /* 2004914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004960 */     // MIs[0] policy
     /* 2004960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004994 */     // GIR_Coverage, 65299,
     /* 2004994 */     GIR_EraseRootFromParent_Done,
     /* 2004995 */   // Label 26822: @2004995
     /* 2004995 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2005081), // Rule ID 65302 //
     /* 2005000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2005008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2005011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2005014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2005017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2005020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005046 */     // MIs[0] policy
     /* 2005046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2005059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005080 */     // GIR_Coverage, 65302,
     /* 2005080 */     GIR_EraseRootFromParent_Done,
     /* 2005081 */   // Label 26823: @2005081
     /* 2005081 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2005167), // Rule ID 65303 //
     /* 2005086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2005094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2005097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2005100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2005103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2005106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005132 */     // MIs[0] policy
     /* 2005132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2005145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005166 */     // GIR_Coverage, 65303,
     /* 2005166 */     GIR_EraseRootFromParent_Done,
     /* 2005167 */   // Label 26824: @2005167
     /* 2005167 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2005253), // Rule ID 65306 //
     /* 2005172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005218 */     // MIs[0] policy
     /* 2005218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2005231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005252 */     // GIR_Coverage, 65306,
     /* 2005252 */     GIR_EraseRootFromParent_Done,
     /* 2005253 */   // Label 26825: @2005253
     /* 2005253 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2005339), // Rule ID 65307 //
     /* 2005258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2005275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2005278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005304 */     // MIs[0] policy
     /* 2005304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2005317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005338 */     // GIR_Coverage, 65307,
     /* 2005338 */     GIR_EraseRootFromParent_Done,
     /* 2005339 */   // Label 26826: @2005339
     /* 2005339 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2005425), // Rule ID 65310 //
     /* 2005344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005390 */     // MIs[0] policy
     /* 2005390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005424 */     // GIR_Coverage, 65310,
     /* 2005424 */     GIR_EraseRootFromParent_Done,
     /* 2005425 */   // Label 26827: @2005425
     /* 2005425 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2005511), // Rule ID 65311 //
     /* 2005430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2005450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005476 */     // MIs[0] policy
     /* 2005476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005510 */     // GIR_Coverage, 65311,
     /* 2005510 */     GIR_EraseRootFromParent_Done,
     /* 2005511 */   // Label 26828: @2005511
     /* 2005511 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2005597), // Rule ID 65314 //
     /* 2005516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005562 */     // MIs[0] policy
     /* 2005562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005596 */     // GIR_Coverage, 65314,
     /* 2005596 */     GIR_EraseRootFromParent_Done,
     /* 2005597 */   // Label 26829: @2005597
     /* 2005597 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2005683), // Rule ID 65315 //
     /* 2005602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005648 */     // MIs[0] policy
     /* 2005648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005682 */     // GIR_Coverage, 65315,
     /* 2005682 */     GIR_EraseRootFromParent_Done,
     /* 2005683 */   // Label 26830: @2005683
     /* 2005683 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2005769), // Rule ID 65318 //
     /* 2005688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005734 */     // MIs[0] policy
     /* 2005734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005744 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005768 */     // GIR_Coverage, 65318,
     /* 2005768 */     GIR_EraseRootFromParent_Done,
     /* 2005769 */   // Label 26831: @2005769
     /* 2005769 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2005855), // Rule ID 65319 //
     /* 2005774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005820 */     // MIs[0] policy
     /* 2005820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005854 */     // GIR_Coverage, 65319,
     /* 2005854 */     GIR_EraseRootFromParent_Done,
     /* 2005855 */   // Label 26832: @2005855
     /* 2005855 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2005941), // Rule ID 65322 //
     /* 2005860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005906 */     // MIs[0] policy
     /* 2005906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005940 */     // GIR_Coverage, 65322,
     /* 2005940 */     GIR_EraseRootFromParent_Done,
     /* 2005941 */   // Label 26833: @2005941
     /* 2005941 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2006027), // Rule ID 65323 //
     /* 2005946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005992 */     // MIs[0] policy
     /* 2005992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006026 */     // GIR_Coverage, 65323,
     /* 2006026 */     GIR_EraseRootFromParent_Done,
     /* 2006027 */   // Label 26834: @2006027
     /* 2006027 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2006113), // Rule ID 65326 //
     /* 2006032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006078 */     // MIs[0] policy
     /* 2006078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2006091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006112 */     // GIR_Coverage, 65326,
     /* 2006112 */     GIR_EraseRootFromParent_Done,
     /* 2006113 */   // Label 26835: @2006113
     /* 2006113 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2006199), // Rule ID 65327 //
     /* 2006118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006164 */     // MIs[0] policy
     /* 2006164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2006177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006198 */     // GIR_Coverage, 65327,
     /* 2006198 */     GIR_EraseRootFromParent_Done,
     /* 2006199 */   // Label 26836: @2006199
     /* 2006199 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2006285), // Rule ID 65330 //
     /* 2006204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006250 */     // MIs[0] policy
     /* 2006250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2006263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006284 */     // GIR_Coverage, 65330,
     /* 2006284 */     GIR_EraseRootFromParent_Done,
     /* 2006285 */   // Label 26837: @2006285
     /* 2006285 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2006371), // Rule ID 65331 //
     /* 2006290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2006301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2006304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2006310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006336 */     // MIs[0] policy
     /* 2006336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2006349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006370 */     // GIR_Coverage, 65331,
     /* 2006370 */     GIR_EraseRootFromParent_Done,
     /* 2006371 */   // Label 26838: @2006371
     /* 2006371 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2006457), // Rule ID 65334 //
     /* 2006376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006422 */     // MIs[0] policy
     /* 2006422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006456 */     // GIR_Coverage, 65334,
     /* 2006456 */     GIR_EraseRootFromParent_Done,
     /* 2006457 */   // Label 26839: @2006457
     /* 2006457 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2006543), // Rule ID 65335 //
     /* 2006462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006508 */     // MIs[0] policy
     /* 2006508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006542 */     // GIR_Coverage, 65335,
     /* 2006542 */     GIR_EraseRootFromParent_Done,
     /* 2006543 */   // Label 26840: @2006543
     /* 2006543 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2006629), // Rule ID 65338 //
     /* 2006548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006594 */     // MIs[0] policy
     /* 2006594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006628 */     // GIR_Coverage, 65338,
     /* 2006628 */     GIR_EraseRootFromParent_Done,
     /* 2006629 */   // Label 26841: @2006629
     /* 2006629 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2006715), // Rule ID 65339 //
     /* 2006634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006680 */     // MIs[0] policy
     /* 2006680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006714 */     // GIR_Coverage, 65339,
     /* 2006714 */     GIR_EraseRootFromParent_Done,
     /* 2006715 */   // Label 26842: @2006715
     /* 2006715 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2006804), // Rule ID 2790 //
     /* 2006720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006766 */     // MIs[0] round
     /* 2006766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006803 */     // GIR_Coverage, 2790,
     /* 2006803 */     GIR_EraseRootFromParent_Done,
     /* 2006804 */   // Label 26843: @2006804
     /* 2006804 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2006893), // Rule ID 2791 //
     /* 2006809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006855 */     // MIs[0] round
     /* 2006855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006892 */     // GIR_Coverage, 2791,
     /* 2006892 */     GIR_EraseRootFromParent_Done,
     /* 2006893 */   // Label 26844: @2006893
     /* 2006893 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2006982), // Rule ID 22836 //
     /* 2006898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006944 */     // MIs[0] round
     /* 2006944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006954 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006981 */     // GIR_Coverage, 22836,
     /* 2006981 */     GIR_EraseRootFromParent_Done,
     /* 2006982 */   // Label 26845: @2006982
     /* 2006982 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2007071), // Rule ID 22837 //
     /* 2006987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2007004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007033 */     // MIs[0] round
     /* 2007033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007043 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2007046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007070 */     // GIR_Coverage, 22837,
     /* 2007070 */     GIR_EraseRootFromParent_Done,
     /* 2007071 */   // Label 26846: @2007071
     /* 2007071 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2007160), // Rule ID 22840 //
     /* 2007076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007122 */     // MIs[0] round
     /* 2007122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2007135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007159 */     // GIR_Coverage, 22840,
     /* 2007159 */     GIR_EraseRootFromParent_Done,
     /* 2007160 */   // Label 26847: @2007160
     /* 2007160 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2007249), // Rule ID 22841 //
     /* 2007165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007211 */     // MIs[0] round
     /* 2007211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007221 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2007224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007248 */     // GIR_Coverage, 22841,
     /* 2007248 */     GIR_EraseRootFromParent_Done,
     /* 2007249 */   // Label 26848: @2007249
     /* 2007249 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2007338), // Rule ID 22844 //
     /* 2007254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007300 */     // MIs[0] round
     /* 2007300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007310 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2007313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007337 */     // GIR_Coverage, 22844,
     /* 2007337 */     GIR_EraseRootFromParent_Done,
     /* 2007338 */   // Label 26849: @2007338
     /* 2007338 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2007427), // Rule ID 22845 //
     /* 2007343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007389 */     // MIs[0] round
     /* 2007389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007399 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2007402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007426 */     // GIR_Coverage, 22845,
     /* 2007426 */     GIR_EraseRootFromParent_Done,
     /* 2007427 */   // Label 26850: @2007427
     /* 2007427 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2007516), // Rule ID 22848 //
     /* 2007432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007478 */     // MIs[0] round
     /* 2007478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007515 */     // GIR_Coverage, 22848,
     /* 2007515 */     GIR_EraseRootFromParent_Done,
     /* 2007516 */   // Label 26851: @2007516
     /* 2007516 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2007605), // Rule ID 22849 //
     /* 2007521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007567 */     // MIs[0] round
     /* 2007567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007604 */     // GIR_Coverage, 22849,
     /* 2007604 */     GIR_EraseRootFromParent_Done,
     /* 2007605 */   // Label 26852: @2007605
     /* 2007605 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2007694), // Rule ID 22852 //
     /* 2007610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007656 */     // MIs[0] round
     /* 2007656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007666 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007693 */     // GIR_Coverage, 22852,
     /* 2007693 */     GIR_EraseRootFromParent_Done,
     /* 2007694 */   // Label 26853: @2007694
     /* 2007694 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2007783), // Rule ID 22853 //
     /* 2007699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007745 */     // MIs[0] round
     /* 2007745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007755 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007782 */     // GIR_Coverage, 22853,
     /* 2007782 */     GIR_EraseRootFromParent_Done,
     /* 2007783 */   // Label 26854: @2007783
     /* 2007783 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2007872), // Rule ID 22856 //
     /* 2007788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007834 */     // MIs[0] round
     /* 2007834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007871 */     // GIR_Coverage, 22856,
     /* 2007871 */     GIR_EraseRootFromParent_Done,
     /* 2007872 */   // Label 26855: @2007872
     /* 2007872 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2007961), // Rule ID 22857 //
     /* 2007877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007923 */     // MIs[0] round
     /* 2007923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007960 */     // GIR_Coverage, 22857,
     /* 2007960 */     GIR_EraseRootFromParent_Done,
     /* 2007961 */   // Label 26856: @2007961
     /* 2007961 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2008050), // Rule ID 22860 //
     /* 2007966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008012 */     // MIs[0] round
     /* 2008012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008022 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2008025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008049 */     // GIR_Coverage, 22860,
     /* 2008049 */     GIR_EraseRootFromParent_Done,
     /* 2008050 */   // Label 26857: @2008050
     /* 2008050 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2008139), // Rule ID 22861 //
     /* 2008055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2008072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008101 */     // MIs[0] round
     /* 2008101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008111 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2008114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008138 */     // GIR_Coverage, 22861,
     /* 2008138 */     GIR_EraseRootFromParent_Done,
     /* 2008139 */   // Label 26858: @2008139
     /* 2008139 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2008228), // Rule ID 22864 //
     /* 2008144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2008167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008190 */     // MIs[0] round
     /* 2008190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008200 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2008203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008227 */     // GIR_Coverage, 22864,
     /* 2008227 */     GIR_EraseRootFromParent_Done,
     /* 2008228 */   // Label 26859: @2008228
     /* 2008228 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2008317), // Rule ID 22865 //
     /* 2008233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2008256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008279 */     // MIs[0] round
     /* 2008279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008289 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11314:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2008292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008316 */     // GIR_Coverage, 22865,
     /* 2008316 */     GIR_EraseRootFromParent_Done,
     /* 2008317 */   // Label 26860: @2008317
     /* 2008317 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2008406), // Rule ID 22868 //
     /* 2008322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008368 */     // MIs[0] round
     /* 2008368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008378 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008405 */     // GIR_Coverage, 22868,
     /* 2008405 */     GIR_EraseRootFromParent_Done,
     /* 2008406 */   // Label 26861: @2008406
     /* 2008406 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2008495), // Rule ID 22869 //
     /* 2008411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008457 */     // MIs[0] round
     /* 2008457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008467 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008494 */     // GIR_Coverage, 22869,
     /* 2008494 */     GIR_EraseRootFromParent_Done,
     /* 2008495 */   // Label 26862: @2008495
     /* 2008495 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2008584), // Rule ID 22872 //
     /* 2008500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008546 */     // MIs[0] round
     /* 2008546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008583 */     // GIR_Coverage, 22872,
     /* 2008583 */     GIR_EraseRootFromParent_Done,
     /* 2008584 */   // Label 26863: @2008584
     /* 2008584 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2008673), // Rule ID 22873 //
     /* 2008589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008635 */     // MIs[0] round
     /* 2008635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008672 */     // GIR_Coverage, 22873,
     /* 2008672 */     GIR_EraseRootFromParent_Done,
     /* 2008673 */   // Label 26864: @2008673
     /* 2008673 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2008762), // Rule ID 22876 //
     /* 2008678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008724 */     // MIs[0] round
     /* 2008724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008761 */     // GIR_Coverage, 22876,
     /* 2008761 */     GIR_EraseRootFromParent_Done,
     /* 2008762 */   // Label 26865: @2008762
     /* 2008762 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2008851), // Rule ID 22877 //
     /* 2008767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008813 */     // MIs[0] round
     /* 2008813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008823 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008850 */     // GIR_Coverage, 22877,
     /* 2008850 */     GIR_EraseRootFromParent_Done,
     /* 2008851 */   // Label 26866: @2008851
     /* 2008851 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2008940), // Rule ID 22880 //
     /* 2008856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008902 */     // MIs[0] round
     /* 2008902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008912 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008939 */     // GIR_Coverage, 22880,
     /* 2008939 */     GIR_EraseRootFromParent_Done,
     /* 2008940 */   // Label 26867: @2008940
     /* 2008940 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2009029), // Rule ID 22881 //
     /* 2008945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008991 */     // MIs[0] round
     /* 2008991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009001 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2009004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009028 */     // GIR_Coverage, 22881,
     /* 2009028 */     GIR_EraseRootFromParent_Done,
     /* 2009029 */   // Label 26868: @2009029
     /* 2009029 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2009118), // Rule ID 22884 //
     /* 2009034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2009051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009080 */     // MIs[0] round
     /* 2009080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2009093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009117 */     // GIR_Coverage, 22884,
     /* 2009117 */     GIR_EraseRootFromParent_Done,
     /* 2009118 */   // Label 26869: @2009118
     /* 2009118 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2009207), // Rule ID 22885 //
     /* 2009123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2009140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2009161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009169 */     // MIs[0] round
     /* 2009169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2009182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009206 */     // GIR_Coverage, 22885,
     /* 2009206 */     GIR_EraseRootFromParent_Done,
     /* 2009207 */   // Label 26870: @2009207
     /* 2009207 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2009296), // Rule ID 22888 //
     /* 2009212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2009229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009258 */     // MIs[0] round
     /* 2009258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2009271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009295 */     // GIR_Coverage, 22888,
     /* 2009295 */     GIR_EraseRootFromParent_Done,
     /* 2009296 */   // Label 26871: @2009296
     /* 2009296 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2009385), // Rule ID 22889 //
     /* 2009301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2009309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2009318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2009339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009347 */     // MIs[0] round
     /* 2009347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009357 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2009360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009384 */     // GIR_Coverage, 22889,
     /* 2009384 */     GIR_EraseRootFromParent_Done,
     /* 2009385 */   // Label 26872: @2009385
     /* 2009385 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2009474), // Rule ID 22892 //
     /* 2009390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009436 */     // MIs[0] round
     /* 2009436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009446 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009473 */     // GIR_Coverage, 22892,
     /* 2009473 */     GIR_EraseRootFromParent_Done,
     /* 2009474 */   // Label 26873: @2009474
     /* 2009474 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2009563), // Rule ID 22893 //
     /* 2009479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009525 */     // MIs[0] round
     /* 2009525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009535 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009562 */     // GIR_Coverage, 22893,
     /* 2009562 */     GIR_EraseRootFromParent_Done,
     /* 2009563 */   // Label 26874: @2009563
     /* 2009563 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2009652), // Rule ID 22896 //
     /* 2009568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009614 */     // MIs[0] round
     /* 2009614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009624 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009651 */     // GIR_Coverage, 22896,
     /* 2009651 */     GIR_EraseRootFromParent_Done,
     /* 2009652 */   // Label 26875: @2009652
     /* 2009652 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2009741), // Rule ID 22897 //
     /* 2009657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009703 */     // MIs[0] round
     /* 2009703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009713 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009740 */     // GIR_Coverage, 22897,
     /* 2009740 */     GIR_EraseRootFromParent_Done,
     /* 2009741 */   // Label 26876: @2009741
     /* 2009741 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2009830), // Rule ID 22900 //
     /* 2009746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009792 */     // MIs[0] round
     /* 2009792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009829 */     // GIR_Coverage, 22900,
     /* 2009829 */     GIR_EraseRootFromParent_Done,
     /* 2009830 */   // Label 26877: @2009830
     /* 2009830 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2009919), // Rule ID 22901 //
     /* 2009835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009881 */     // MIs[0] round
     /* 2009881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009891 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009918 */     // GIR_Coverage, 22901,
     /* 2009918 */     GIR_EraseRootFromParent_Done,
     /* 2009919 */   // Label 26878: @2009919
     /* 2009919 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2010008), // Rule ID 22904 //
     /* 2009924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009970 */     // MIs[0] round
     /* 2009970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009980 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010007 */     // GIR_Coverage, 22904,
     /* 2010007 */     GIR_EraseRootFromParent_Done,
     /* 2010008 */   // Label 26879: @2010008
     /* 2010008 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2010097), // Rule ID 22905 //
     /* 2010013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010059 */     // MIs[0] round
     /* 2010059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010069 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2010072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010096 */     // GIR_Coverage, 22905,
     /* 2010096 */     GIR_EraseRootFromParent_Done,
     /* 2010097 */   // Label 26880: @2010097
     /* 2010097 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2010186), // Rule ID 22908 //
     /* 2010102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010148 */     // MIs[0] round
     /* 2010148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2010161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010185 */     // GIR_Coverage, 22908,
     /* 2010185 */     GIR_EraseRootFromParent_Done,
     /* 2010186 */   // Label 26881: @2010186
     /* 2010186 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2010275), // Rule ID 22909 //
     /* 2010191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010237 */     // MIs[0] round
     /* 2010237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010247 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2010250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010274 */     // GIR_Coverage, 22909,
     /* 2010274 */     GIR_EraseRootFromParent_Done,
     /* 2010275 */   // Label 26882: @2010275
     /* 2010275 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2010364), // Rule ID 22912 //
     /* 2010280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2010283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2010300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010326 */     // MIs[0] round
     /* 2010326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2010339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010363 */     // GIR_Coverage, 22912,
     /* 2010363 */     GIR_EraseRootFromParent_Done,
     /* 2010364 */   // Label 26883: @2010364
     /* 2010364 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2010453), // Rule ID 22913 //
     /* 2010369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2010372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2010389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010415 */     // MIs[0] round
     /* 2010415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010425 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2010428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010452 */     // GIR_Coverage, 22913,
     /* 2010452 */     GIR_EraseRootFromParent_Done,
     /* 2010453 */   // Label 26884: @2010453
     /* 2010453 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2010542), // Rule ID 22916 //
     /* 2010458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010504 */     // MIs[0] round
     /* 2010504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010514 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010541 */     // GIR_Coverage, 22916,
     /* 2010541 */     GIR_EraseRootFromParent_Done,
     /* 2010542 */   // Label 26885: @2010542
     /* 2010542 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2010631), // Rule ID 22917 //
     /* 2010547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010593 */     // MIs[0] round
     /* 2010593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010603 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010630 */     // GIR_Coverage, 22917,
     /* 2010630 */     GIR_EraseRootFromParent_Done,
     /* 2010631 */   // Label 26886: @2010631
     /* 2010631 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2010720), // Rule ID 22920 //
     /* 2010636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010682 */     // MIs[0] round
     /* 2010682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010719 */     // GIR_Coverage, 22920,
     /* 2010719 */     GIR_EraseRootFromParent_Done,
     /* 2010720 */   // Label 26887: @2010720
     /* 2010720 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2010809), // Rule ID 22921 //
     /* 2010725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010771 */     // MIs[0] round
     /* 2010771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010781 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010808 */     // GIR_Coverage, 22921,
     /* 2010808 */     GIR_EraseRootFromParent_Done,
     /* 2010809 */   // Label 26888: @2010809
     /* 2010809 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2010898), // Rule ID 22924 //
     /* 2010814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010860 */     // MIs[0] round
     /* 2010860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010897 */     // GIR_Coverage, 22924,
     /* 2010897 */     GIR_EraseRootFromParent_Done,
     /* 2010898 */   // Label 26889: @2010898
     /* 2010898 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2010987), // Rule ID 22925 //
     /* 2010903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010949 */     // MIs[0] round
     /* 2010949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010959 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11316:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010986 */     // GIR_Coverage, 22925,
     /* 2010986 */     GIR_EraseRootFromParent_Done,
     /* 2010987 */   // Label 26890: @2010987
     /* 2010987 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2011076), // Rule ID 22928 //
     /* 2010992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011038 */     // MIs[0] round
     /* 2011038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011048 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2011051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011075 */     // GIR_Coverage, 22928,
     /* 2011075 */     GIR_EraseRootFromParent_Done,
     /* 2011076 */   // Label 26891: @2011076
     /* 2011076 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2011165), // Rule ID 22929 //
     /* 2011081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011127 */     // MIs[0] round
     /* 2011127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011137 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2011140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011164 */     // GIR_Coverage, 22929,
     /* 2011164 */     GIR_EraseRootFromParent_Done,
     /* 2011165 */   // Label 26892: @2011165
     /* 2011165 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2011254), // Rule ID 22932 //
     /* 2011170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011216 */     // MIs[0] round
     /* 2011216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011226 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2011229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011253 */     // GIR_Coverage, 22932,
     /* 2011253 */     GIR_EraseRootFromParent_Done,
     /* 2011254 */   // Label 26893: @2011254
     /* 2011254 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2011343), // Rule ID 22933 //
     /* 2011259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2011276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011305 */     // MIs[0] round
     /* 2011305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011315 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2011318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011342 */     // GIR_Coverage, 22933,
     /* 2011342 */     GIR_EraseRootFromParent_Done,
     /* 2011343 */   // Label 26894: @2011343
     /* 2011343 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2011432), // Rule ID 22936 //
     /* 2011348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2011365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011394 */     // MIs[0] round
     /* 2011394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011431 */     // GIR_Coverage, 22936,
     /* 2011431 */     GIR_EraseRootFromParent_Done,
     /* 2011432 */   // Label 26895: @2011432
     /* 2011432 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2011521), // Rule ID 22937 //
     /* 2011437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2011440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2011454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011483 */     // MIs[0] round
     /* 2011483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011493 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011520 */     // GIR_Coverage, 22937,
     /* 2011520 */     GIR_EraseRootFromParent_Done,
     /* 2011521 */   // Label 26896: @2011521
     /* 2011521 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2011610), // Rule ID 22940 //
     /* 2011526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011572 */     // MIs[0] round
     /* 2011572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011582 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011609 */     // GIR_Coverage, 22940,
     /* 2011609 */     GIR_EraseRootFromParent_Done,
     /* 2011610 */   // Label 26897: @2011610
     /* 2011610 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2011699), // Rule ID 22941 //
     /* 2011615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011661 */     // MIs[0] round
     /* 2011661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011671 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011698 */     // GIR_Coverage, 22941,
     /* 2011698 */     GIR_EraseRootFromParent_Done,
     /* 2011699 */   // Label 26898: @2011699
     /* 2011699 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2011788), // Rule ID 22944 //
     /* 2011704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011750 */     // MIs[0] round
     /* 2011750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011760 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011787 */     // GIR_Coverage, 22944,
     /* 2011787 */     GIR_EraseRootFromParent_Done,
     /* 2011788 */   // Label 26899: @2011788
     /* 2011788 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2011877), // Rule ID 22945 //
     /* 2011793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011839 */     // MIs[0] round
     /* 2011839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011876 */     // GIR_Coverage, 22945,
     /* 2011876 */     GIR_EraseRootFromParent_Done,
     /* 2011877 */   // Label 26900: @2011877
     /* 2011877 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2011966), // Rule ID 22948 //
     /* 2011882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011928 */     // MIs[0] round
     /* 2011928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011938 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011965 */     // GIR_Coverage, 22948,
     /* 2011965 */     GIR_EraseRootFromParent_Done,
     /* 2011966 */   // Label 26901: @2011966
     /* 2011966 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2012055), // Rule ID 22949 //
     /* 2011971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012017 */     // MIs[0] round
     /* 2012017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012027 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2012030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012054 */     // GIR_Coverage, 22949,
     /* 2012054 */     GIR_EraseRootFromParent_Done,
     /* 2012055 */   // Label 26902: @2012055
     /* 2012055 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2012144), // Rule ID 23072 //
     /* 2012060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012106 */     // MIs[0] round
     /* 2012106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2012119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012143 */     // GIR_Coverage, 23072,
     /* 2012143 */     GIR_EraseRootFromParent_Done,
     /* 2012144 */   // Label 26903: @2012144
     /* 2012144 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2012233), // Rule ID 23073 //
     /* 2012149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2012166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012195 */     // MIs[0] round
     /* 2012195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012205 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2012208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012232 */     // GIR_Coverage, 23073,
     /* 2012232 */     GIR_EraseRootFromParent_Done,
     /* 2012233 */   // Label 26904: @2012233
     /* 2012233 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2012322), // Rule ID 23076 //
     /* 2012238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012284 */     // MIs[0] round
     /* 2012284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2012297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012321 */     // GIR_Coverage, 23076,
     /* 2012321 */     GIR_EraseRootFromParent_Done,
     /* 2012322 */   // Label 26905: @2012322
     /* 2012322 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2012411), // Rule ID 23077 //
     /* 2012327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2012344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012373 */     // MIs[0] round
     /* 2012373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012383 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2012386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012410 */     // GIR_Coverage, 23077,
     /* 2012410 */     GIR_EraseRootFromParent_Done,
     /* 2012411 */   // Label 26906: @2012411
     /* 2012411 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2012500), // Rule ID 23080 //
     /* 2012416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012462 */     // MIs[0] round
     /* 2012462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012472 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012499 */     // GIR_Coverage, 23080,
     /* 2012499 */     GIR_EraseRootFromParent_Done,
     /* 2012500 */   // Label 26907: @2012500
     /* 2012500 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2012589), // Rule ID 23081 //
     /* 2012505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012551 */     // MIs[0] round
     /* 2012551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012561 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012588 */     // GIR_Coverage, 23081,
     /* 2012588 */     GIR_EraseRootFromParent_Done,
     /* 2012589 */   // Label 26908: @2012589
     /* 2012589 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2012678), // Rule ID 23084 //
     /* 2012594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012640 */     // MIs[0] round
     /* 2012640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012677 */     // GIR_Coverage, 23084,
     /* 2012677 */     GIR_EraseRootFromParent_Done,
     /* 2012678 */   // Label 26909: @2012678
     /* 2012678 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2012767), // Rule ID 23085 //
     /* 2012683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012729 */     // MIs[0] round
     /* 2012729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012766 */     // GIR_Coverage, 23085,
     /* 2012766 */     GIR_EraseRootFromParent_Done,
     /* 2012767 */   // Label 26910: @2012767
     /* 2012767 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2012856), // Rule ID 23088 //
     /* 2012772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012818 */     // MIs[0] round
     /* 2012818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012828 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012855 */     // GIR_Coverage, 23088,
     /* 2012855 */     GIR_EraseRootFromParent_Done,
     /* 2012856 */   // Label 26911: @2012856
     /* 2012856 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2012945), // Rule ID 23089 //
     /* 2012861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012907 */     // MIs[0] round
     /* 2012907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012917 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012944 */     // GIR_Coverage, 23089,
     /* 2012944 */     GIR_EraseRootFromParent_Done,
     /* 2012945 */   // Label 26912: @2012945
     /* 2012945 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2013034), // Rule ID 23092 //
     /* 2012950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012996 */     // MIs[0] round
     /* 2012996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013006 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2013009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013033 */     // GIR_Coverage, 23092,
     /* 2013033 */     GIR_EraseRootFromParent_Done,
     /* 2013034 */   // Label 26913: @2013034
     /* 2013034 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2013123), // Rule ID 23093 //
     /* 2013039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2013056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013085 */     // MIs[0] round
     /* 2013085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013095 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2013098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013122 */     // GIR_Coverage, 23093,
     /* 2013122 */     GIR_EraseRootFromParent_Done,
     /* 2013123 */   // Label 26914: @2013123
     /* 2013123 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2013212), // Rule ID 23096 //
     /* 2013128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2013145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013174 */     // MIs[0] round
     /* 2013174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2013187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013211 */     // GIR_Coverage, 23096,
     /* 2013211 */     GIR_EraseRootFromParent_Done,
     /* 2013212 */   // Label 26915: @2013212
     /* 2013212 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2013301), // Rule ID 23097 //
     /* 2013217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2013234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013263 */     // MIs[0] round
     /* 2013263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013273 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2013276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013300 */     // GIR_Coverage, 23097,
     /* 2013300 */     GIR_EraseRootFromParent_Done,
     /* 2013301 */   // Label 26916: @2013301
     /* 2013301 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2013390), // Rule ID 23100 //
     /* 2013306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2013323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2013329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013352 */     // MIs[0] round
     /* 2013352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013362 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2013365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013389 */     // GIR_Coverage, 23100,
     /* 2013389 */     GIR_EraseRootFromParent_Done,
     /* 2013390 */   // Label 26917: @2013390
     /* 2013390 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2013479), // Rule ID 23101 //
     /* 2013395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2013412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2013418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013441 */     // MIs[0] round
     /* 2013441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013451 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2013454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013478 */     // GIR_Coverage, 23101,
     /* 2013478 */     GIR_EraseRootFromParent_Done,
     /* 2013479 */   // Label 26918: @2013479
     /* 2013479 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2013568), // Rule ID 23104 //
     /* 2013484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013530 */     // MIs[0] round
     /* 2013530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013567 */     // GIR_Coverage, 23104,
     /* 2013567 */     GIR_EraseRootFromParent_Done,
     /* 2013568 */   // Label 26919: @2013568
     /* 2013568 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2013657), // Rule ID 23105 //
     /* 2013573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013619 */     // MIs[0] round
     /* 2013619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013629 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013656 */     // GIR_Coverage, 23105,
     /* 2013656 */     GIR_EraseRootFromParent_Done,
     /* 2013657 */   // Label 26920: @2013657
     /* 2013657 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2013746), // Rule ID 23108 //
     /* 2013662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013708 */     // MIs[0] round
     /* 2013708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013718 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013745 */     // GIR_Coverage, 23108,
     /* 2013745 */     GIR_EraseRootFromParent_Done,
     /* 2013746 */   // Label 26921: @2013746
     /* 2013746 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2013835), // Rule ID 23109 //
     /* 2013751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013797 */     // MIs[0] round
     /* 2013797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013807 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013834 */     // GIR_Coverage, 23109,
     /* 2013834 */     GIR_EraseRootFromParent_Done,
     /* 2013835 */   // Label 26922: @2013835
     /* 2013835 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2013924), // Rule ID 23112 //
     /* 2013840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013886 */     // MIs[0] round
     /* 2013886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013923 */     // GIR_Coverage, 23112,
     /* 2013923 */     GIR_EraseRootFromParent_Done,
     /* 2013924 */   // Label 26923: @2013924
     /* 2013924 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2014013), // Rule ID 23113 //
     /* 2013929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013975 */     // MIs[0] round
     /* 2013975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013985 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014012 */     // GIR_Coverage, 23113,
     /* 2014012 */     GIR_EraseRootFromParent_Done,
     /* 2014013 */   // Label 26924: @2014013
     /* 2014013 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2014102), // Rule ID 23116 //
     /* 2014018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2014035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014064 */     // MIs[0] round
     /* 2014064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014074 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2014077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014101 */     // GIR_Coverage, 23116,
     /* 2014101 */     GIR_EraseRootFromParent_Done,
     /* 2014102 */   // Label 26925: @2014102
     /* 2014102 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2014191), // Rule ID 23117 //
     /* 2014107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2014124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014153 */     // MIs[0] round
     /* 2014153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014163 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2014166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014190 */     // GIR_Coverage, 23117,
     /* 2014190 */     GIR_EraseRootFromParent_Done,
     /* 2014191 */   // Label 26926: @2014191
     /* 2014191 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2014280), // Rule ID 23120 //
     /* 2014196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2014213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014242 */     // MIs[0] round
     /* 2014242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2014255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014279 */     // GIR_Coverage, 23120,
     /* 2014279 */     GIR_EraseRootFromParent_Done,
     /* 2014280 */   // Label 26927: @2014280
     /* 2014280 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2014369), // Rule ID 23121 //
     /* 2014285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2014302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014331 */     // MIs[0] round
     /* 2014331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2014344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014368 */     // GIR_Coverage, 23121,
     /* 2014368 */     GIR_EraseRootFromParent_Done,
     /* 2014369 */   // Label 26928: @2014369
     /* 2014369 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2014458), // Rule ID 23124 //
     /* 2014374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014420 */     // MIs[0] round
     /* 2014420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014430 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014457 */     // GIR_Coverage, 23124,
     /* 2014457 */     GIR_EraseRootFromParent_Done,
     /* 2014458 */   // Label 26929: @2014458
     /* 2014458 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2014547), // Rule ID 23125 //
     /* 2014463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014509 */     // MIs[0] round
     /* 2014509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014519 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014546 */     // GIR_Coverage, 23125,
     /* 2014546 */     GIR_EraseRootFromParent_Done,
     /* 2014547 */   // Label 26930: @2014547
     /* 2014547 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2014636), // Rule ID 23128 //
     /* 2014552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014598 */     // MIs[0] round
     /* 2014598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014635 */     // GIR_Coverage, 23128,
     /* 2014635 */     GIR_EraseRootFromParent_Done,
     /* 2014636 */   // Label 26931: @2014636
     /* 2014636 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2014725), // Rule ID 23129 //
     /* 2014641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014687 */     // MIs[0] round
     /* 2014687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014697 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014724 */     // GIR_Coverage, 23129,
     /* 2014724 */     GIR_EraseRootFromParent_Done,
     /* 2014725 */   // Label 26932: @2014725
     /* 2014725 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2014814), // Rule ID 23132 //
     /* 2014730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014776 */     // MIs[0] round
     /* 2014776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014813 */     // GIR_Coverage, 23132,
     /* 2014813 */     GIR_EraseRootFromParent_Done,
     /* 2014814 */   // Label 26933: @2014814
     /* 2014814 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2014903), // Rule ID 23133 //
     /* 2014819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014865 */     // MIs[0] round
     /* 2014865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014875 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014902 */     // GIR_Coverage, 23133,
     /* 2014902 */     GIR_EraseRootFromParent_Done,
     /* 2014903 */   // Label 26934: @2014903
     /* 2014903 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2014992), // Rule ID 23136 //
     /* 2014908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014954 */     // MIs[0] round
     /* 2014954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014964 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014991 */     // GIR_Coverage, 23136,
     /* 2014991 */     GIR_EraseRootFromParent_Done,
     /* 2014992 */   // Label 26935: @2014992
     /* 2014992 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2015081), // Rule ID 23137 //
     /* 2014997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015043 */     // MIs[0] round
     /* 2015043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015053 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2015056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015080 */     // GIR_Coverage, 23137,
     /* 2015080 */     GIR_EraseRootFromParent_Done,
     /* 2015081 */   // Label 26936: @2015081
     /* 2015081 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2015170), // Rule ID 23140 //
     /* 2015086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2015103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015132 */     // MIs[0] round
     /* 2015132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2015145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015169 */     // GIR_Coverage, 23140,
     /* 2015169 */     GIR_EraseRootFromParent_Done,
     /* 2015170 */   // Label 26937: @2015170
     /* 2015170 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2015259), // Rule ID 23141 //
     /* 2015175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2015192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015221 */     // MIs[0] round
     /* 2015221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015231 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2015234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015258 */     // GIR_Coverage, 23141,
     /* 2015258 */     GIR_EraseRootFromParent_Done,
     /* 2015259 */   // Label 26938: @2015259
     /* 2015259 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2015348), // Rule ID 23144 //
     /* 2015264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2015267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2015281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015310 */     // MIs[0] round
     /* 2015310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2015323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015347 */     // GIR_Coverage, 23144,
     /* 2015347 */     GIR_EraseRootFromParent_Done,
     /* 2015348 */   // Label 26939: @2015348
     /* 2015348 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2015437), // Rule ID 23145 //
     /* 2015353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2015356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2015370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2015373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015399 */     // MIs[0] round
     /* 2015399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015409 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2015412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015436 */     // GIR_Coverage, 23145,
     /* 2015436 */     GIR_EraseRootFromParent_Done,
     /* 2015437 */   // Label 26940: @2015437
     /* 2015437 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2015526), // Rule ID 23148 //
     /* 2015442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015488 */     // MIs[0] round
     /* 2015488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015498 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015525 */     // GIR_Coverage, 23148,
     /* 2015525 */     GIR_EraseRootFromParent_Done,
     /* 2015526 */   // Label 26941: @2015526
     /* 2015526 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2015615), // Rule ID 23149 //
     /* 2015531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015577 */     // MIs[0] round
     /* 2015577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015587 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015614 */     // GIR_Coverage, 23149,
     /* 2015614 */     GIR_EraseRootFromParent_Done,
     /* 2015615 */   // Label 26942: @2015615
     /* 2015615 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2015704), // Rule ID 23152 //
     /* 2015620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015666 */     // MIs[0] round
     /* 2015666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015703 */     // GIR_Coverage, 23152,
     /* 2015703 */     GIR_EraseRootFromParent_Done,
     /* 2015704 */   // Label 26943: @2015704
     /* 2015704 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2015793), // Rule ID 23153 //
     /* 2015709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015755 */     // MIs[0] round
     /* 2015755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015765 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015792 */     // GIR_Coverage, 23153,
     /* 2015792 */     GIR_EraseRootFromParent_Done,
     /* 2015793 */   // Label 26944: @2015793
     /* 2015793 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2015882), // Rule ID 23156 //
     /* 2015798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015844 */     // MIs[0] round
     /* 2015844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015854 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015881 */     // GIR_Coverage, 23156,
     /* 2015881 */     GIR_EraseRootFromParent_Done,
     /* 2015882 */   // Label 26945: @2015882
     /* 2015882 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2015971), // Rule ID 23157 //
     /* 2015887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015933 */     // MIs[0] round
     /* 2015933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015943 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015970 */     // GIR_Coverage, 23157,
     /* 2015970 */     GIR_EraseRootFromParent_Done,
     /* 2015971 */   // Label 26946: @2015971
     /* 2015971 */   GIM_Reject,
     /* 2015972 */ // Label 19890: @2015972
     /* 2015972 */ GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2206457),
     /* 2015977 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2015980 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2016082), // Rule ID 15992 //
     /* 2015985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2015996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2015999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2016002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016035 */     // MIs[1] Operand 1
     /* 2016035 */     // No operand predicates
     /* 2016035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016039 */     // MIs[0] round
     /* 2016039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016042 */     // MIs[0] policy
     /* 2016042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016054 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2016057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016081 */     // GIR_Coverage, 15992,
     /* 2016081 */     GIR_EraseRootFromParent_Done,
     /* 2016082 */   // Label 26948: @2016082
     /* 2016082 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2016184), // Rule ID 15993 //
     /* 2016087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2016098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2016101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2016104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016137 */     // MIs[1] Operand 1
     /* 2016137 */     // No operand predicates
     /* 2016137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016141 */     // MIs[0] round
     /* 2016141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016144 */     // MIs[0] policy
     /* 2016144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2016159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016183 */     // GIR_Coverage, 15993,
     /* 2016183 */     GIR_EraseRootFromParent_Done,
     /* 2016184 */   // Label 26949: @2016184
     /* 2016184 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2016286), // Rule ID 15996 //
     /* 2016189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2016206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016239 */     // MIs[1] Operand 1
     /* 2016239 */     // No operand predicates
     /* 2016239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016243 */     // MIs[0] round
     /* 2016243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016246 */     // MIs[0] policy
     /* 2016246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016258 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016285 */     // GIR_Coverage, 15996,
     /* 2016285 */     GIR_EraseRootFromParent_Done,
     /* 2016286 */   // Label 26950: @2016286
     /* 2016286 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2016388), // Rule ID 15997 //
     /* 2016291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2016308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016341 */     // MIs[1] Operand 1
     /* 2016341 */     // No operand predicates
     /* 2016341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016345 */     // MIs[0] round
     /* 2016345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016348 */     // MIs[0] policy
     /* 2016348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016387 */     // GIR_Coverage, 15997,
     /* 2016387 */     GIR_EraseRootFromParent_Done,
     /* 2016388 */   // Label 26951: @2016388
     /* 2016388 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2016490), // Rule ID 16000 //
     /* 2016393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016443 */     // MIs[1] Operand 1
     /* 2016443 */     // No operand predicates
     /* 2016443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016447 */     // MIs[0] round
     /* 2016447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016450 */     // MIs[0] policy
     /* 2016450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016489 */     // GIR_Coverage, 16000,
     /* 2016489 */     GIR_EraseRootFromParent_Done,
     /* 2016490 */   // Label 26952: @2016490
     /* 2016490 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2016592), // Rule ID 16001 //
     /* 2016495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016545 */     // MIs[1] Operand 1
     /* 2016545 */     // No operand predicates
     /* 2016545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016549 */     // MIs[0] round
     /* 2016549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016552 */     // MIs[0] policy
     /* 2016552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016591 */     // GIR_Coverage, 16001,
     /* 2016591 */     GIR_EraseRootFromParent_Done,
     /* 2016592 */   // Label 26953: @2016592
     /* 2016592 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2016694), // Rule ID 16004 //
     /* 2016597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016647 */     // MIs[1] Operand 1
     /* 2016647 */     // No operand predicates
     /* 2016647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016651 */     // MIs[0] round
     /* 2016651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016654 */     // MIs[0] policy
     /* 2016654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016693 */     // GIR_Coverage, 16004,
     /* 2016693 */     GIR_EraseRootFromParent_Done,
     /* 2016694 */   // Label 26954: @2016694
     /* 2016694 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2016796), // Rule ID 16005 //
     /* 2016699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016749 */     // MIs[1] Operand 1
     /* 2016749 */     // No operand predicates
     /* 2016749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016753 */     // MIs[0] round
     /* 2016753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016756 */     // MIs[0] policy
     /* 2016756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016795 */     // GIR_Coverage, 16005,
     /* 2016795 */     GIR_EraseRootFromParent_Done,
     /* 2016796 */   // Label 26955: @2016796
     /* 2016796 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2016898), // Rule ID 16008 //
     /* 2016801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016851 */     // MIs[1] Operand 1
     /* 2016851 */     // No operand predicates
     /* 2016851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016855 */     // MIs[0] round
     /* 2016855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016858 */     // MIs[0] policy
     /* 2016858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016897 */     // GIR_Coverage, 16008,
     /* 2016897 */     GIR_EraseRootFromParent_Done,
     /* 2016898 */   // Label 26956: @2016898
     /* 2016898 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2017000), // Rule ID 16009 //
     /* 2016903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016953 */     // MIs[1] Operand 1
     /* 2016953 */     // No operand predicates
     /* 2016953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016957 */     // MIs[0] round
     /* 2016957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016960 */     // MIs[0] policy
     /* 2016960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016972 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016999 */     // GIR_Coverage, 16009,
     /* 2016999 */     GIR_EraseRootFromParent_Done,
     /* 2017000 */   // Label 26957: @2017000
     /* 2017000 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2017102), // Rule ID 16012 //
     /* 2017005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2017016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2017019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017055 */     // MIs[1] Operand 1
     /* 2017055 */     // No operand predicates
     /* 2017055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017059 */     // MIs[0] round
     /* 2017059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017062 */     // MIs[0] policy
     /* 2017062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2017077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017101 */     // GIR_Coverage, 16012,
     /* 2017101 */     GIR_EraseRootFromParent_Done,
     /* 2017102 */   // Label 26958: @2017102
     /* 2017102 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2017204), // Rule ID 16013 //
     /* 2017107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2017118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2017121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017157 */     // MIs[1] Operand 1
     /* 2017157 */     // No operand predicates
     /* 2017157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017161 */     // MIs[0] round
     /* 2017161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017164 */     // MIs[0] policy
     /* 2017164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2017179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017203 */     // GIR_Coverage, 16013,
     /* 2017203 */     GIR_EraseRootFromParent_Done,
     /* 2017204 */   // Label 26959: @2017204
     /* 2017204 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2017306), // Rule ID 16016 //
     /* 2017209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2017226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017259 */     // MIs[1] Operand 1
     /* 2017259 */     // No operand predicates
     /* 2017259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017263 */     // MIs[0] round
     /* 2017263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017266 */     // MIs[0] policy
     /* 2017266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017305 */     // GIR_Coverage, 16016,
     /* 2017305 */     GIR_EraseRootFromParent_Done,
     /* 2017306 */   // Label 26960: @2017306
     /* 2017306 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2017408), // Rule ID 16017 //
     /* 2017311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2017328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017361 */     // MIs[1] Operand 1
     /* 2017361 */     // No operand predicates
     /* 2017361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017365 */     // MIs[0] round
     /* 2017365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017368 */     // MIs[0] policy
     /* 2017368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017407 */     // GIR_Coverage, 16017,
     /* 2017407 */     GIR_EraseRootFromParent_Done,
     /* 2017408 */   // Label 26961: @2017408
     /* 2017408 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2017510), // Rule ID 16020 //
     /* 2017413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017463 */     // MIs[1] Operand 1
     /* 2017463 */     // No operand predicates
     /* 2017463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017467 */     // MIs[0] round
     /* 2017467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017470 */     // MIs[0] policy
     /* 2017470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017509 */     // GIR_Coverage, 16020,
     /* 2017509 */     GIR_EraseRootFromParent_Done,
     /* 2017510 */   // Label 26962: @2017510
     /* 2017510 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2017612), // Rule ID 16021 //
     /* 2017515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017565 */     // MIs[1] Operand 1
     /* 2017565 */     // No operand predicates
     /* 2017565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017569 */     // MIs[0] round
     /* 2017569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017572 */     // MIs[0] policy
     /* 2017572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017611 */     // GIR_Coverage, 16021,
     /* 2017611 */     GIR_EraseRootFromParent_Done,
     /* 2017612 */   // Label 26963: @2017612
     /* 2017612 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2017714), // Rule ID 16024 //
     /* 2017617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017667 */     // MIs[1] Operand 1
     /* 2017667 */     // No operand predicates
     /* 2017667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017671 */     // MIs[0] round
     /* 2017671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017674 */     // MIs[0] policy
     /* 2017674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017713 */     // GIR_Coverage, 16024,
     /* 2017713 */     GIR_EraseRootFromParent_Done,
     /* 2017714 */   // Label 26964: @2017714
     /* 2017714 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2017816), // Rule ID 16025 //
     /* 2017719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017769 */     // MIs[1] Operand 1
     /* 2017769 */     // No operand predicates
     /* 2017769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017773 */     // MIs[0] round
     /* 2017773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017776 */     // MIs[0] policy
     /* 2017776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017815 */     // GIR_Coverage, 16025,
     /* 2017815 */     GIR_EraseRootFromParent_Done,
     /* 2017816 */   // Label 26965: @2017816
     /* 2017816 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2017918), // Rule ID 16028 //
     /* 2017821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017871 */     // MIs[1] Operand 1
     /* 2017871 */     // No operand predicates
     /* 2017871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017875 */     // MIs[0] round
     /* 2017875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017878 */     // MIs[0] policy
     /* 2017878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017917 */     // GIR_Coverage, 16028,
     /* 2017917 */     GIR_EraseRootFromParent_Done,
     /* 2017918 */   // Label 26966: @2017918
     /* 2017918 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2018020), // Rule ID 16029 //
     /* 2017923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017973 */     // MIs[1] Operand 1
     /* 2017973 */     // No operand predicates
     /* 2017973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017977 */     // MIs[0] round
     /* 2017977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017980 */     // MIs[0] policy
     /* 2017980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2018016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018019 */     // GIR_Coverage, 16029,
     /* 2018019 */     GIR_EraseRootFromParent_Done,
     /* 2018020 */   // Label 26967: @2018020
     /* 2018020 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2018122), // Rule ID 16032 //
     /* 2018025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2018042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018075 */     // MIs[1] Operand 1
     /* 2018075 */     // No operand predicates
     /* 2018075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018079 */     // MIs[0] round
     /* 2018079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018082 */     // MIs[0] policy
     /* 2018082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018121 */     // GIR_Coverage, 16032,
     /* 2018121 */     GIR_EraseRootFromParent_Done,
     /* 2018122 */   // Label 26968: @2018122
     /* 2018122 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2018224), // Rule ID 16033 //
     /* 2018127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2018144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018177 */     // MIs[1] Operand 1
     /* 2018177 */     // No operand predicates
     /* 2018177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018181 */     // MIs[0] round
     /* 2018181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018184 */     // MIs[0] policy
     /* 2018184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018223 */     // GIR_Coverage, 16033,
     /* 2018223 */     GIR_EraseRootFromParent_Done,
     /* 2018224 */   // Label 26969: @2018224
     /* 2018224 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2018326), // Rule ID 16036 //
     /* 2018229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2018246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018279 */     // MIs[1] Operand 1
     /* 2018279 */     // No operand predicates
     /* 2018279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018283 */     // MIs[0] round
     /* 2018283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018286 */     // MIs[0] policy
     /* 2018286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018298 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018325 */     // GIR_Coverage, 16036,
     /* 2018325 */     GIR_EraseRootFromParent_Done,
     /* 2018326 */   // Label 26970: @2018326
     /* 2018326 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2018428), // Rule ID 16037 //
     /* 2018331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2018348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018381 */     // MIs[1] Operand 1
     /* 2018381 */     // No operand predicates
     /* 2018381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018385 */     // MIs[0] round
     /* 2018385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018388 */     // MIs[0] policy
     /* 2018388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018400 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018427 */     // GIR_Coverage, 16037,
     /* 2018427 */     GIR_EraseRootFromParent_Done,
     /* 2018428 */   // Label 26971: @2018428
     /* 2018428 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2018530), // Rule ID 16040 //
     /* 2018433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018483 */     // MIs[1] Operand 1
     /* 2018483 */     // No operand predicates
     /* 2018483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018487 */     // MIs[0] round
     /* 2018487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018490 */     // MIs[0] policy
     /* 2018490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018502 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018529 */     // GIR_Coverage, 16040,
     /* 2018529 */     GIR_EraseRootFromParent_Done,
     /* 2018530 */   // Label 26972: @2018530
     /* 2018530 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2018632), // Rule ID 16041 //
     /* 2018535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018585 */     // MIs[1] Operand 1
     /* 2018585 */     // No operand predicates
     /* 2018585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018589 */     // MIs[0] round
     /* 2018589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018592 */     // MIs[0] policy
     /* 2018592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018631 */     // GIR_Coverage, 16041,
     /* 2018631 */     GIR_EraseRootFromParent_Done,
     /* 2018632 */   // Label 26973: @2018632
     /* 2018632 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2018734), // Rule ID 16044 //
     /* 2018637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018687 */     // MIs[1] Operand 1
     /* 2018687 */     // No operand predicates
     /* 2018687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018691 */     // MIs[0] round
     /* 2018691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018694 */     // MIs[0] policy
     /* 2018694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018733 */     // GIR_Coverage, 16044,
     /* 2018733 */     GIR_EraseRootFromParent_Done,
     /* 2018734 */   // Label 26974: @2018734
     /* 2018734 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2018836), // Rule ID 16045 //
     /* 2018739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018789 */     // MIs[1] Operand 1
     /* 2018789 */     // No operand predicates
     /* 2018789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018793 */     // MIs[0] round
     /* 2018793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018796 */     // MIs[0] policy
     /* 2018796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018835 */     // GIR_Coverage, 16045,
     /* 2018835 */     GIR_EraseRootFromParent_Done,
     /* 2018836 */   // Label 26975: @2018836
     /* 2018836 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2018938), // Rule ID 16048 //
     /* 2018841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018891 */     // MIs[1] Operand 1
     /* 2018891 */     // No operand predicates
     /* 2018891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018895 */     // MIs[0] round
     /* 2018895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018898 */     // MIs[0] policy
     /* 2018898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018937 */     // GIR_Coverage, 16048,
     /* 2018937 */     GIR_EraseRootFromParent_Done,
     /* 2018938 */   // Label 26976: @2018938
     /* 2018938 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2019040), // Rule ID 16049 //
     /* 2018943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018993 */     // MIs[1] Operand 1
     /* 2018993 */     // No operand predicates
     /* 2018993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018997 */     // MIs[0] round
     /* 2018997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019000 */     // MIs[0] policy
     /* 2019000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019039 */     // GIR_Coverage, 16049,
     /* 2019039 */     GIR_EraseRootFromParent_Done,
     /* 2019040 */   // Label 26977: @2019040
     /* 2019040 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2019142), // Rule ID 16052 //
     /* 2019045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2019056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2019059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2019062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2019068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019095 */     // MIs[1] Operand 1
     /* 2019095 */     // No operand predicates
     /* 2019095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019099 */     // MIs[0] round
     /* 2019099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019102 */     // MIs[0] policy
     /* 2019102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019141 */     // GIR_Coverage, 16052,
     /* 2019141 */     GIR_EraseRootFromParent_Done,
     /* 2019142 */   // Label 26978: @2019142
     /* 2019142 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2019244), // Rule ID 16053 //
     /* 2019147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2019158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2019161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2019164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2019170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019197 */     // MIs[1] Operand 1
     /* 2019197 */     // No operand predicates
     /* 2019197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019201 */     // MIs[0] round
     /* 2019201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019204 */     // MIs[0] policy
     /* 2019204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019216 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019243 */     // GIR_Coverage, 16053,
     /* 2019243 */     GIR_EraseRootFromParent_Done,
     /* 2019244 */   // Label 26979: @2019244
     /* 2019244 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2019346), // Rule ID 16056 //
     /* 2019249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019299 */     // MIs[1] Operand 1
     /* 2019299 */     // No operand predicates
     /* 2019299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019303 */     // MIs[0] round
     /* 2019303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019306 */     // MIs[0] policy
     /* 2019306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019345 */     // GIR_Coverage, 16056,
     /* 2019345 */     GIR_EraseRootFromParent_Done,
     /* 2019346 */   // Label 26980: @2019346
     /* 2019346 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2019448), // Rule ID 16057 //
     /* 2019351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019401 */     // MIs[1] Operand 1
     /* 2019401 */     // No operand predicates
     /* 2019401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019405 */     // MIs[0] round
     /* 2019405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019408 */     // MIs[0] policy
     /* 2019408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019447 */     // GIR_Coverage, 16057,
     /* 2019447 */     GIR_EraseRootFromParent_Done,
     /* 2019448 */   // Label 26981: @2019448
     /* 2019448 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2019550), // Rule ID 16060 //
     /* 2019453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019503 */     // MIs[1] Operand 1
     /* 2019503 */     // No operand predicates
     /* 2019503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019507 */     // MIs[0] round
     /* 2019507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019510 */     // MIs[0] policy
     /* 2019510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019549 */     // GIR_Coverage, 16060,
     /* 2019549 */     GIR_EraseRootFromParent_Done,
     /* 2019550 */   // Label 26982: @2019550
     /* 2019550 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2019652), // Rule ID 16061 //
     /* 2019555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019605 */     // MIs[1] Operand 1
     /* 2019605 */     // No operand predicates
     /* 2019605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019609 */     // MIs[0] round
     /* 2019609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019612 */     // MIs[0] policy
     /* 2019612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019651 */     // GIR_Coverage, 16061,
     /* 2019651 */     GIR_EraseRootFromParent_Done,
     /* 2019652 */   // Label 26983: @2019652
     /* 2019652 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2019754), // Rule ID 16064 //
     /* 2019657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019707 */     // MIs[1] Operand 1
     /* 2019707 */     // No operand predicates
     /* 2019707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019711 */     // MIs[0] round
     /* 2019711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019714 */     // MIs[0] policy
     /* 2019714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019726 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019753 */     // GIR_Coverage, 16064,
     /* 2019753 */     GIR_EraseRootFromParent_Done,
     /* 2019754 */   // Label 26984: @2019754
     /* 2019754 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2019856), // Rule ID 16065 //
     /* 2019759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019809 */     // MIs[1] Operand 1
     /* 2019809 */     // No operand predicates
     /* 2019809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019813 */     // MIs[0] round
     /* 2019813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019816 */     // MIs[0] policy
     /* 2019816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019855 */     // GIR_Coverage, 16065,
     /* 2019855 */     GIR_EraseRootFromParent_Done,
     /* 2019856 */   // Label 26985: @2019856
     /* 2019856 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2019958), // Rule ID 16068 //
     /* 2019861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019911 */     // MIs[1] Operand 1
     /* 2019911 */     // No operand predicates
     /* 2019911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019915 */     // MIs[0] round
     /* 2019915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019918 */     // MIs[0] policy
     /* 2019918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019957 */     // GIR_Coverage, 16068,
     /* 2019957 */     GIR_EraseRootFromParent_Done,
     /* 2019958 */   // Label 26986: @2019958
     /* 2019958 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2020060), // Rule ID 16069 //
     /* 2019963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020013 */     // MIs[1] Operand 1
     /* 2020013 */     // No operand predicates
     /* 2020013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020017 */     // MIs[0] round
     /* 2020017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020020 */     // MIs[0] policy
     /* 2020020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2020035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020059 */     // GIR_Coverage, 16069,
     /* 2020059 */     GIR_EraseRootFromParent_Done,
     /* 2020060 */   // Label 26987: @2020060
     /* 2020060 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2020162), // Rule ID 16072 //
     /* 2020065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2020068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020115 */     // MIs[1] Operand 1
     /* 2020115 */     // No operand predicates
     /* 2020115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020119 */     // MIs[0] round
     /* 2020119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020122 */     // MIs[0] policy
     /* 2020122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2020137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020161 */     // GIR_Coverage, 16072,
     /* 2020161 */     GIR_EraseRootFromParent_Done,
     /* 2020162 */   // Label 26988: @2020162
     /* 2020162 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2020264), // Rule ID 16073 //
     /* 2020167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2020170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020217 */     // MIs[1] Operand 1
     /* 2020217 */     // No operand predicates
     /* 2020217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020221 */     // MIs[0] round
     /* 2020221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020224 */     // MIs[0] policy
     /* 2020224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2020239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020263 */     // GIR_Coverage, 16073,
     /* 2020263 */     GIR_EraseRootFromParent_Done,
     /* 2020264 */   // Label 26989: @2020264
     /* 2020264 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2020366), // Rule ID 16076 //
     /* 2020269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2020272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2020280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2020283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020319 */     // MIs[1] Operand 1
     /* 2020319 */     // No operand predicates
     /* 2020319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020323 */     // MIs[0] round
     /* 2020323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020326 */     // MIs[0] policy
     /* 2020326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2020341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020365 */     // GIR_Coverage, 16076,
     /* 2020365 */     GIR_EraseRootFromParent_Done,
     /* 2020366 */   // Label 26990: @2020366
     /* 2020366 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2020468), // Rule ID 16077 //
     /* 2020371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2020374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2020379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2020382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2020385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020421 */     // MIs[1] Operand 1
     /* 2020421 */     // No operand predicates
     /* 2020421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020425 */     // MIs[0] round
     /* 2020425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020428 */     // MIs[0] policy
     /* 2020428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2020443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2020464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020467 */     // GIR_Coverage, 16077,
     /* 2020467 */     GIR_EraseRootFromParent_Done,
     /* 2020468 */   // Label 26991: @2020468
     /* 2020468 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2020570), // Rule ID 16256 //
     /* 2020473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020523 */     // MIs[1] Operand 1
     /* 2020523 */     // No operand predicates
     /* 2020523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020527 */     // MIs[0] round
     /* 2020527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020530 */     // MIs[0] policy
     /* 2020530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020542 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020569 */     // GIR_Coverage, 16256,
     /* 2020569 */     GIR_EraseRootFromParent_Done,
     /* 2020570 */   // Label 26992: @2020570
     /* 2020570 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2020672), // Rule ID 16257 //
     /* 2020575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020625 */     // MIs[1] Operand 1
     /* 2020625 */     // No operand predicates
     /* 2020625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020629 */     // MIs[0] round
     /* 2020629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020632 */     // MIs[0] policy
     /* 2020632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020671 */     // GIR_Coverage, 16257,
     /* 2020671 */     GIR_EraseRootFromParent_Done,
     /* 2020672 */   // Label 26993: @2020672
     /* 2020672 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2020774), // Rule ID 16260 //
     /* 2020677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020727 */     // MIs[1] Operand 1
     /* 2020727 */     // No operand predicates
     /* 2020727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020731 */     // MIs[0] round
     /* 2020731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020734 */     // MIs[0] policy
     /* 2020734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020773 */     // GIR_Coverage, 16260,
     /* 2020773 */     GIR_EraseRootFromParent_Done,
     /* 2020774 */   // Label 26994: @2020774
     /* 2020774 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2020876), // Rule ID 16261 //
     /* 2020779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020829 */     // MIs[1] Operand 1
     /* 2020829 */     // No operand predicates
     /* 2020829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020833 */     // MIs[0] round
     /* 2020833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020836 */     // MIs[0] policy
     /* 2020836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020875 */     // GIR_Coverage, 16261,
     /* 2020875 */     GIR_EraseRootFromParent_Done,
     /* 2020876 */   // Label 26995: @2020876
     /* 2020876 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2020978), // Rule ID 16264 //
     /* 2020881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020931 */     // MIs[1] Operand 1
     /* 2020931 */     // No operand predicates
     /* 2020931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020935 */     // MIs[0] round
     /* 2020935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020938 */     // MIs[0] policy
     /* 2020938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020977 */     // GIR_Coverage, 16264,
     /* 2020977 */     GIR_EraseRootFromParent_Done,
     /* 2020978 */   // Label 26996: @2020978
     /* 2020978 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2021080), // Rule ID 16265 //
     /* 2020983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2021000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021033 */     // MIs[1] Operand 1
     /* 2021033 */     // No operand predicates
     /* 2021033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021037 */     // MIs[0] round
     /* 2021037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021040 */     // MIs[0] policy
     /* 2021040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021079 */     // GIR_Coverage, 16265,
     /* 2021079 */     GIR_EraseRootFromParent_Done,
     /* 2021080 */   // Label 26997: @2021080
     /* 2021080 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2021182), // Rule ID 16268 //
     /* 2021085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2021096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2021099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2021102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021135 */     // MIs[1] Operand 1
     /* 2021135 */     // No operand predicates
     /* 2021135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021139 */     // MIs[0] round
     /* 2021139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021142 */     // MIs[0] policy
     /* 2021142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2021157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021181 */     // GIR_Coverage, 16268,
     /* 2021181 */     GIR_EraseRootFromParent_Done,
     /* 2021182 */   // Label 26998: @2021182
     /* 2021182 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2021284), // Rule ID 16269 //
     /* 2021187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2021198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2021201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2021204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021237 */     // MIs[1] Operand 1
     /* 2021237 */     // No operand predicates
     /* 2021237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021241 */     // MIs[0] round
     /* 2021241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021244 */     // MIs[0] policy
     /* 2021244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2021259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021283 */     // GIR_Coverage, 16269,
     /* 2021283 */     GIR_EraseRootFromParent_Done,
     /* 2021284 */   // Label 26999: @2021284
     /* 2021284 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2021386), // Rule ID 16272 //
     /* 2021289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2021300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2021303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2021306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021339 */     // MIs[1] Operand 1
     /* 2021339 */     // No operand predicates
     /* 2021339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021343 */     // MIs[0] round
     /* 2021343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021346 */     // MIs[0] policy
     /* 2021346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021385 */     // GIR_Coverage, 16272,
     /* 2021385 */     GIR_EraseRootFromParent_Done,
     /* 2021386 */   // Label 27000: @2021386
     /* 2021386 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2021488), // Rule ID 16273 //
     /* 2021391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2021402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2021405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2021408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021441 */     // MIs[1] Operand 1
     /* 2021441 */     // No operand predicates
     /* 2021441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021445 */     // MIs[0] round
     /* 2021445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021448 */     // MIs[0] policy
     /* 2021448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021487 */     // GIR_Coverage, 16273,
     /* 2021487 */     GIR_EraseRootFromParent_Done,
     /* 2021488 */   // Label 27001: @2021488
     /* 2021488 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2021590), // Rule ID 16276 //
     /* 2021493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021543 */     // MIs[1] Operand 1
     /* 2021543 */     // No operand predicates
     /* 2021543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021547 */     // MIs[0] round
     /* 2021547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021550 */     // MIs[0] policy
     /* 2021550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021589 */     // GIR_Coverage, 16276,
     /* 2021589 */     GIR_EraseRootFromParent_Done,
     /* 2021590 */   // Label 27002: @2021590
     /* 2021590 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2021692), // Rule ID 16277 //
     /* 2021595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021645 */     // MIs[1] Operand 1
     /* 2021645 */     // No operand predicates
     /* 2021645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021649 */     // MIs[0] round
     /* 2021649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021652 */     // MIs[0] policy
     /* 2021652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021691 */     // GIR_Coverage, 16277,
     /* 2021691 */     GIR_EraseRootFromParent_Done,
     /* 2021692 */   // Label 27003: @2021692
     /* 2021692 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2021794), // Rule ID 16280 //
     /* 2021697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021747 */     // MIs[1] Operand 1
     /* 2021747 */     // No operand predicates
     /* 2021747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021751 */     // MIs[0] round
     /* 2021751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021754 */     // MIs[0] policy
     /* 2021754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021793 */     // GIR_Coverage, 16280,
     /* 2021793 */     GIR_EraseRootFromParent_Done,
     /* 2021794 */   // Label 27004: @2021794
     /* 2021794 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2021896), // Rule ID 16281 //
     /* 2021799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021849 */     // MIs[1] Operand 1
     /* 2021849 */     // No operand predicates
     /* 2021849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021853 */     // MIs[0] round
     /* 2021853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021856 */     // MIs[0] policy
     /* 2021856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021895 */     // GIR_Coverage, 16281,
     /* 2021895 */     GIR_EraseRootFromParent_Done,
     /* 2021896 */   // Label 27005: @2021896
     /* 2021896 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2021998), // Rule ID 16284 //
     /* 2021901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021951 */     // MIs[1] Operand 1
     /* 2021951 */     // No operand predicates
     /* 2021951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021955 */     // MIs[0] round
     /* 2021955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021958 */     // MIs[0] policy
     /* 2021958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021997 */     // GIR_Coverage, 16284,
     /* 2021997 */     GIR_EraseRootFromParent_Done,
     /* 2021998 */   // Label 27006: @2021998
     /* 2021998 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2022100), // Rule ID 16285 //
     /* 2022003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2022014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2022017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2022020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022053 */     // MIs[1] Operand 1
     /* 2022053 */     // No operand predicates
     /* 2022053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022057 */     // MIs[0] round
     /* 2022057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022060 */     // MIs[0] policy
     /* 2022060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022099 */     // GIR_Coverage, 16285,
     /* 2022099 */     GIR_EraseRootFromParent_Done,
     /* 2022100 */   // Label 27007: @2022100
     /* 2022100 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2022202), // Rule ID 16288 //
     /* 2022105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2022116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2022119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022155 */     // MIs[1] Operand 1
     /* 2022155 */     // No operand predicates
     /* 2022155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022159 */     // MIs[0] round
     /* 2022159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022162 */     // MIs[0] policy
     /* 2022162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022201 */     // GIR_Coverage, 16288,
     /* 2022201 */     GIR_EraseRootFromParent_Done,
     /* 2022202 */   // Label 27008: @2022202
     /* 2022202 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2022304), // Rule ID 16289 //
     /* 2022207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2022218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2022221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022257 */     // MIs[1] Operand 1
     /* 2022257 */     // No operand predicates
     /* 2022257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022261 */     // MIs[0] round
     /* 2022261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022264 */     // MIs[0] policy
     /* 2022264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022303 */     // GIR_Coverage, 16289,
     /* 2022303 */     GIR_EraseRootFromParent_Done,
     /* 2022304 */   // Label 27009: @2022304
     /* 2022304 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2022406), // Rule ID 16292 //
     /* 2022309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2022312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022359 */     // MIs[1] Operand 1
     /* 2022359 */     // No operand predicates
     /* 2022359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022363 */     // MIs[0] round
     /* 2022363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022366 */     // MIs[0] policy
     /* 2022366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022405 */     // GIR_Coverage, 16292,
     /* 2022405 */     GIR_EraseRootFromParent_Done,
     /* 2022406 */   // Label 27010: @2022406
     /* 2022406 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2022508), // Rule ID 16293 //
     /* 2022411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2022414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2022428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022461 */     // MIs[1] Operand 1
     /* 2022461 */     // No operand predicates
     /* 2022461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022465 */     // MIs[0] round
     /* 2022465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022468 */     // MIs[0] policy
     /* 2022468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022480 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022507 */     // GIR_Coverage, 16293,
     /* 2022507 */     GIR_EraseRootFromParent_Done,
     /* 2022508 */   // Label 27011: @2022508
     /* 2022508 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2022610), // Rule ID 16296 //
     /* 2022513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022563 */     // MIs[1] Operand 1
     /* 2022563 */     // No operand predicates
     /* 2022563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022567 */     // MIs[0] round
     /* 2022567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022570 */     // MIs[0] policy
     /* 2022570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022609 */     // GIR_Coverage, 16296,
     /* 2022609 */     GIR_EraseRootFromParent_Done,
     /* 2022610 */   // Label 27012: @2022610
     /* 2022610 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2022712), // Rule ID 16297 //
     /* 2022615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022665 */     // MIs[1] Operand 1
     /* 2022665 */     // No operand predicates
     /* 2022665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022669 */     // MIs[0] round
     /* 2022669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022672 */     // MIs[0] policy
     /* 2022672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022711 */     // GIR_Coverage, 16297,
     /* 2022711 */     GIR_EraseRootFromParent_Done,
     /* 2022712 */   // Label 27013: @2022712
     /* 2022712 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2022814), // Rule ID 16300 //
     /* 2022717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022767 */     // MIs[1] Operand 1
     /* 2022767 */     // No operand predicates
     /* 2022767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022771 */     // MIs[0] round
     /* 2022771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022774 */     // MIs[0] policy
     /* 2022774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022813 */     // GIR_Coverage, 16300,
     /* 2022813 */     GIR_EraseRootFromParent_Done,
     /* 2022814 */   // Label 27014: @2022814
     /* 2022814 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2022916), // Rule ID 16301 //
     /* 2022819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022869 */     // MIs[1] Operand 1
     /* 2022869 */     // No operand predicates
     /* 2022869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022873 */     // MIs[0] round
     /* 2022873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022876 */     // MIs[0] policy
     /* 2022876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022915 */     // GIR_Coverage, 16301,
     /* 2022915 */     GIR_EraseRootFromParent_Done,
     /* 2022916 */   // Label 27015: @2022916
     /* 2022916 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2023018), // Rule ID 16304 //
     /* 2022921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022971 */     // MIs[1] Operand 1
     /* 2022971 */     // No operand predicates
     /* 2022971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022975 */     // MIs[0] round
     /* 2022975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022978 */     // MIs[0] policy
     /* 2022978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2022993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023017 */     // GIR_Coverage, 16304,
     /* 2023017 */     GIR_EraseRootFromParent_Done,
     /* 2023018 */   // Label 27016: @2023018
     /* 2023018 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2023120), // Rule ID 16305 //
     /* 2023023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2023034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2023037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2023040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2023046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023073 */     // MIs[1] Operand 1
     /* 2023073 */     // No operand predicates
     /* 2023073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023077 */     // MIs[0] round
     /* 2023077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023080 */     // MIs[0] policy
     /* 2023080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023119 */     // GIR_Coverage, 16305,
     /* 2023119 */     GIR_EraseRootFromParent_Done,
     /* 2023120 */   // Label 27017: @2023120
     /* 2023120 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2023222), // Rule ID 16308 //
     /* 2023125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2023136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2023139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2023142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023175 */     // MIs[1] Operand 1
     /* 2023175 */     // No operand predicates
     /* 2023175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023179 */     // MIs[0] round
     /* 2023179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023182 */     // MIs[0] policy
     /* 2023182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023221 */     // GIR_Coverage, 16308,
     /* 2023221 */     GIR_EraseRootFromParent_Done,
     /* 2023222 */   // Label 27018: @2023222
     /* 2023222 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2023324), // Rule ID 16309 //
     /* 2023227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2023238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2023241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2023244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023277 */     // MIs[1] Operand 1
     /* 2023277 */     // No operand predicates
     /* 2023277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023281 */     // MIs[0] round
     /* 2023281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023284 */     // MIs[0] policy
     /* 2023284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023323 */     // GIR_Coverage, 16309,
     /* 2023323 */     GIR_EraseRootFromParent_Done,
     /* 2023324 */   // Label 27019: @2023324
     /* 2023324 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2023426), // Rule ID 16312 //
     /* 2023329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2023340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2023343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2023346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023379 */     // MIs[1] Operand 1
     /* 2023379 */     // No operand predicates
     /* 2023379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023383 */     // MIs[0] round
     /* 2023383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023386 */     // MIs[0] policy
     /* 2023386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023425 */     // GIR_Coverage, 16312,
     /* 2023425 */     GIR_EraseRootFromParent_Done,
     /* 2023426 */   // Label 27020: @2023426
     /* 2023426 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2023528), // Rule ID 16313 //
     /* 2023431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2023442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2023445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2023448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023481 */     // MIs[1] Operand 1
     /* 2023481 */     // No operand predicates
     /* 2023481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023485 */     // MIs[0] round
     /* 2023485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023488 */     // MIs[0] policy
     /* 2023488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023527 */     // GIR_Coverage, 16313,
     /* 2023527 */     GIR_EraseRootFromParent_Done,
     /* 2023528 */   // Label 27021: @2023528
     /* 2023528 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2023630), // Rule ID 16316 //
     /* 2023533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023583 */     // MIs[1] Operand 1
     /* 2023583 */     // No operand predicates
     /* 2023583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023587 */     // MIs[0] round
     /* 2023587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023590 */     // MIs[0] policy
     /* 2023590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023629 */     // GIR_Coverage, 16316,
     /* 2023629 */     GIR_EraseRootFromParent_Done,
     /* 2023630 */   // Label 27022: @2023630
     /* 2023630 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2023732), // Rule ID 16317 //
     /* 2023635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023685 */     // MIs[1] Operand 1
     /* 2023685 */     // No operand predicates
     /* 2023685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023689 */     // MIs[0] round
     /* 2023689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023692 */     // MIs[0] policy
     /* 2023692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023731 */     // GIR_Coverage, 16317,
     /* 2023731 */     GIR_EraseRootFromParent_Done,
     /* 2023732 */   // Label 27023: @2023732
     /* 2023732 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2023834), // Rule ID 16320 //
     /* 2023737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023787 */     // MIs[1] Operand 1
     /* 2023787 */     // No operand predicates
     /* 2023787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023791 */     // MIs[0] round
     /* 2023791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023794 */     // MIs[0] policy
     /* 2023794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023833 */     // GIR_Coverage, 16320,
     /* 2023833 */     GIR_EraseRootFromParent_Done,
     /* 2023834 */   // Label 27024: @2023834
     /* 2023834 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2023936), // Rule ID 16321 //
     /* 2023839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023889 */     // MIs[1] Operand 1
     /* 2023889 */     // No operand predicates
     /* 2023889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023893 */     // MIs[0] round
     /* 2023893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023896 */     // MIs[0] policy
     /* 2023896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023935 */     // GIR_Coverage, 16321,
     /* 2023935 */     GIR_EraseRootFromParent_Done,
     /* 2023936 */   // Label 27025: @2023936
     /* 2023936 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2024038), // Rule ID 16324 //
     /* 2023941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023991 */     // MIs[1] Operand 1
     /* 2023991 */     // No operand predicates
     /* 2023991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023995 */     // MIs[0] round
     /* 2023995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023998 */     // MIs[0] policy
     /* 2023998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024037 */     // GIR_Coverage, 16324,
     /* 2024037 */     GIR_EraseRootFromParent_Done,
     /* 2024038 */   // Label 27026: @2024038
     /* 2024038 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2024140), // Rule ID 16325 //
     /* 2024043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2024054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2024057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2024060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024093 */     // MIs[1] Operand 1
     /* 2024093 */     // No operand predicates
     /* 2024093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024097 */     // MIs[0] round
     /* 2024097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024100 */     // MIs[0] policy
     /* 2024100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024139 */     // GIR_Coverage, 16325,
     /* 2024139 */     GIR_EraseRootFromParent_Done,
     /* 2024140 */   // Label 27027: @2024140
     /* 2024140 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2024242), // Rule ID 16328 //
     /* 2024145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2024162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024195 */     // MIs[1] Operand 1
     /* 2024195 */     // No operand predicates
     /* 2024195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024199 */     // MIs[0] round
     /* 2024199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024202 */     // MIs[0] policy
     /* 2024202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024241 */     // GIR_Coverage, 16328,
     /* 2024241 */     GIR_EraseRootFromParent_Done,
     /* 2024242 */   // Label 27028: @2024242
     /* 2024242 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2024344), // Rule ID 16329 //
     /* 2024247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2024264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024297 */     // MIs[1] Operand 1
     /* 2024297 */     // No operand predicates
     /* 2024297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024301 */     // MIs[0] round
     /* 2024301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024304 */     // MIs[0] policy
     /* 2024304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024316 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024343 */     // GIR_Coverage, 16329,
     /* 2024343 */     GIR_EraseRootFromParent_Done,
     /* 2024344 */   // Label 27029: @2024344
     /* 2024344 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2024446), // Rule ID 16332 //
     /* 2024349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024399 */     // MIs[1] Operand 1
     /* 2024399 */     // No operand predicates
     /* 2024399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024403 */     // MIs[0] round
     /* 2024403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024406 */     // MIs[0] policy
     /* 2024406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024445 */     // GIR_Coverage, 16332,
     /* 2024445 */     GIR_EraseRootFromParent_Done,
     /* 2024446 */   // Label 27030: @2024446
     /* 2024446 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2024548), // Rule ID 16333 //
     /* 2024451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024501 */     // MIs[1] Operand 1
     /* 2024501 */     // No operand predicates
     /* 2024501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024505 */     // MIs[0] round
     /* 2024505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024508 */     // MIs[0] policy
     /* 2024508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024520 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024547 */     // GIR_Coverage, 16333,
     /* 2024547 */     GIR_EraseRootFromParent_Done,
     /* 2024548 */   // Label 27031: @2024548
     /* 2024548 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2024650), // Rule ID 16336 //
     /* 2024553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024603 */     // MIs[1] Operand 1
     /* 2024603 */     // No operand predicates
     /* 2024603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024607 */     // MIs[0] round
     /* 2024607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024610 */     // MIs[0] policy
     /* 2024610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024649 */     // GIR_Coverage, 16336,
     /* 2024649 */     GIR_EraseRootFromParent_Done,
     /* 2024650 */   // Label 27032: @2024650
     /* 2024650 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2024752), // Rule ID 16337 //
     /* 2024655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024705 */     // MIs[1] Operand 1
     /* 2024705 */     // No operand predicates
     /* 2024705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024709 */     // MIs[0] round
     /* 2024709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024712 */     // MIs[0] policy
     /* 2024712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024751 */     // GIR_Coverage, 16337,
     /* 2024751 */     GIR_EraseRootFromParent_Done,
     /* 2024752 */   // Label 27033: @2024752
     /* 2024752 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2024854), // Rule ID 16340 //
     /* 2024757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024807 */     // MIs[1] Operand 1
     /* 2024807 */     // No operand predicates
     /* 2024807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024811 */     // MIs[0] round
     /* 2024811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024814 */     // MIs[0] policy
     /* 2024814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024826 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024853 */     // GIR_Coverage, 16340,
     /* 2024853 */     GIR_EraseRootFromParent_Done,
     /* 2024854 */   // Label 27034: @2024854
     /* 2024854 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2024956), // Rule ID 16341 //
     /* 2024859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024909 */     // MIs[1] Operand 1
     /* 2024909 */     // No operand predicates
     /* 2024909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024913 */     // MIs[0] round
     /* 2024913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024916 */     // MIs[0] policy
     /* 2024916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024955 */     // GIR_Coverage, 16341,
     /* 2024955 */     GIR_EraseRootFromParent_Done,
     /* 2024956 */   // Label 27035: @2024956
     /* 2024956 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2025061), // Rule ID 16464 //
     /* 2024961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025011 */     // MIs[1] Operand 1
     /* 2025011 */     // No operand predicates
     /* 2025011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025015 */     // MIs[0] round
     /* 2025015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025018 */     // MIs[0] policy
     /* 2025018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2025033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025060 */     // GIR_Coverage, 16464,
     /* 2025060 */     GIR_EraseRootFromParent_Done,
     /* 2025061 */   // Label 27036: @2025061
     /* 2025061 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2025166), // Rule ID 16465 //
     /* 2025066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2025077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2025080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2025083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025116 */     // MIs[1] Operand 1
     /* 2025116 */     // No operand predicates
     /* 2025116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025120 */     // MIs[0] round
     /* 2025120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025123 */     // MIs[0] policy
     /* 2025123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025135 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2025138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025165 */     // GIR_Coverage, 16465,
     /* 2025165 */     GIR_EraseRootFromParent_Done,
     /* 2025166 */   // Label 27037: @2025166
     /* 2025166 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2025271), // Rule ID 16468 //
     /* 2025171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2025182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2025185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2025188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025221 */     // MIs[1] Operand 1
     /* 2025221 */     // No operand predicates
     /* 2025221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025225 */     // MIs[0] round
     /* 2025225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025228 */     // MIs[0] policy
     /* 2025228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025270 */     // GIR_Coverage, 16468,
     /* 2025270 */     GIR_EraseRootFromParent_Done,
     /* 2025271 */   // Label 27038: @2025271
     /* 2025271 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2025376), // Rule ID 16469 //
     /* 2025276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2025287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2025290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2025293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025326 */     // MIs[1] Operand 1
     /* 2025326 */     // No operand predicates
     /* 2025326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025330 */     // MIs[0] round
     /* 2025330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025333 */     // MIs[0] policy
     /* 2025333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025345 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025375 */     // GIR_Coverage, 16469,
     /* 2025375 */     GIR_EraseRootFromParent_Done,
     /* 2025376 */   // Label 27039: @2025376
     /* 2025376 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2025481), // Rule ID 16472 //
     /* 2025381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025431 */     // MIs[1] Operand 1
     /* 2025431 */     // No operand predicates
     /* 2025431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025435 */     // MIs[0] round
     /* 2025435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025438 */     // MIs[0] policy
     /* 2025438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025480 */     // GIR_Coverage, 16472,
     /* 2025480 */     GIR_EraseRootFromParent_Done,
     /* 2025481 */   // Label 27040: @2025481
     /* 2025481 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2025586), // Rule ID 16473 //
     /* 2025486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025536 */     // MIs[1] Operand 1
     /* 2025536 */     // No operand predicates
     /* 2025536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025540 */     // MIs[0] round
     /* 2025540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025543 */     // MIs[0] policy
     /* 2025543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025555 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025585 */     // GIR_Coverage, 16473,
     /* 2025585 */     GIR_EraseRootFromParent_Done,
     /* 2025586 */   // Label 27041: @2025586
     /* 2025586 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2025691), // Rule ID 16476 //
     /* 2025591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025641 */     // MIs[1] Operand 1
     /* 2025641 */     // No operand predicates
     /* 2025641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025645 */     // MIs[0] round
     /* 2025645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025648 */     // MIs[0] policy
     /* 2025648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025690 */     // GIR_Coverage, 16476,
     /* 2025690 */     GIR_EraseRootFromParent_Done,
     /* 2025691 */   // Label 27042: @2025691
     /* 2025691 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2025796), // Rule ID 16477 //
     /* 2025696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025746 */     // MIs[1] Operand 1
     /* 2025746 */     // No operand predicates
     /* 2025746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025750 */     // MIs[0] round
     /* 2025750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025753 */     // MIs[0] policy
     /* 2025753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025765 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025795 */     // GIR_Coverage, 16477,
     /* 2025795 */     GIR_EraseRootFromParent_Done,
     /* 2025796 */   // Label 27043: @2025796
     /* 2025796 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2025901), // Rule ID 16480 //
     /* 2025801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025851 */     // MIs[1] Operand 1
     /* 2025851 */     // No operand predicates
     /* 2025851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025855 */     // MIs[0] round
     /* 2025855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025858 */     // MIs[0] policy
     /* 2025858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025900 */     // GIR_Coverage, 16480,
     /* 2025900 */     GIR_EraseRootFromParent_Done,
     /* 2025901 */   // Label 27044: @2025901
     /* 2025901 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2026006), // Rule ID 16481 //
     /* 2025906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025956 */     // MIs[1] Operand 1
     /* 2025956 */     // No operand predicates
     /* 2025956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025960 */     // MIs[0] round
     /* 2025960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025963 */     // MIs[0] policy
     /* 2025963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026005 */     // GIR_Coverage, 16481,
     /* 2026005 */     GIR_EraseRootFromParent_Done,
     /* 2026006 */   // Label 27045: @2026006
     /* 2026006 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2026111), // Rule ID 16484 //
     /* 2026011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2026028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026061 */     // MIs[1] Operand 1
     /* 2026061 */     // No operand predicates
     /* 2026061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026065 */     // MIs[0] round
     /* 2026065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026068 */     // MIs[0] policy
     /* 2026068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026110 */     // GIR_Coverage, 16484,
     /* 2026110 */     GIR_EraseRootFromParent_Done,
     /* 2026111 */   // Label 27046: @2026111
     /* 2026111 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2026216), // Rule ID 16485 //
     /* 2026116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2026127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2026130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2026133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2026139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026166 */     // MIs[1] Operand 1
     /* 2026166 */     // No operand predicates
     /* 2026166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026170 */     // MIs[0] round
     /* 2026170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026173 */     // MIs[0] policy
     /* 2026173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026185 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2026209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026215 */     // GIR_Coverage, 16485,
     /* 2026215 */     GIR_EraseRootFromParent_Done,
     /* 2026216 */   // Label 27047: @2026216
     /* 2026216 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2026321), // Rule ID 16488 //
     /* 2026221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026271 */     // MIs[1] Operand 1
     /* 2026271 */     // No operand predicates
     /* 2026271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026275 */     // MIs[0] round
     /* 2026275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026278 */     // MIs[0] policy
     /* 2026278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2026293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026320 */     // GIR_Coverage, 16488,
     /* 2026320 */     GIR_EraseRootFromParent_Done,
     /* 2026321 */   // Label 27048: @2026321
     /* 2026321 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2026426), // Rule ID 16489 //
     /* 2026326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2026337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2026340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2026343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026376 */     // MIs[1] Operand 1
     /* 2026376 */     // No operand predicates
     /* 2026376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026380 */     // MIs[0] round
     /* 2026380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026383 */     // MIs[0] policy
     /* 2026383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2026398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026425 */     // GIR_Coverage, 16489,
     /* 2026425 */     GIR_EraseRootFromParent_Done,
     /* 2026426 */   // Label 27049: @2026426
     /* 2026426 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2026531), // Rule ID 16492 //
     /* 2026431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026481 */     // MIs[1] Operand 1
     /* 2026481 */     // No operand predicates
     /* 2026481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026485 */     // MIs[0] round
     /* 2026485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026488 */     // MIs[0] policy
     /* 2026488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026530 */     // GIR_Coverage, 16492,
     /* 2026530 */     GIR_EraseRootFromParent_Done,
     /* 2026531 */   // Label 27050: @2026531
     /* 2026531 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2026636), // Rule ID 16493 //
     /* 2026536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026586 */     // MIs[1] Operand 1
     /* 2026586 */     // No operand predicates
     /* 2026586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026590 */     // MIs[0] round
     /* 2026590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026593 */     // MIs[0] policy
     /* 2026593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026605 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026635 */     // GIR_Coverage, 16493,
     /* 2026635 */     GIR_EraseRootFromParent_Done,
     /* 2026636 */   // Label 27051: @2026636
     /* 2026636 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2026741), // Rule ID 16496 //
     /* 2026641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026691 */     // MIs[1] Operand 1
     /* 2026691 */     // No operand predicates
     /* 2026691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026695 */     // MIs[0] round
     /* 2026695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026698 */     // MIs[0] policy
     /* 2026698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026740 */     // GIR_Coverage, 16496,
     /* 2026740 */     GIR_EraseRootFromParent_Done,
     /* 2026741 */   // Label 27052: @2026741
     /* 2026741 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2026846), // Rule ID 16497 //
     /* 2026746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026796 */     // MIs[1] Operand 1
     /* 2026796 */     // No operand predicates
     /* 2026796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026800 */     // MIs[0] round
     /* 2026800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026803 */     // MIs[0] policy
     /* 2026803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026815 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026845 */     // GIR_Coverage, 16497,
     /* 2026845 */     GIR_EraseRootFromParent_Done,
     /* 2026846 */   // Label 27053: @2026846
     /* 2026846 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2026951), // Rule ID 16500 //
     /* 2026851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026901 */     // MIs[1] Operand 1
     /* 2026901 */     // No operand predicates
     /* 2026901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026905 */     // MIs[0] round
     /* 2026905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026908 */     // MIs[0] policy
     /* 2026908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026950 */     // GIR_Coverage, 16500,
     /* 2026950 */     GIR_EraseRootFromParent_Done,
     /* 2026951 */   // Label 27054: @2026951
     /* 2026951 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2027056), // Rule ID 16501 //
     /* 2026956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027006 */     // MIs[1] Operand 1
     /* 2027006 */     // No operand predicates
     /* 2027006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027010 */     // MIs[0] round
     /* 2027010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027013 */     // MIs[0] policy
     /* 2027013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027055 */     // GIR_Coverage, 16501,
     /* 2027055 */     GIR_EraseRootFromParent_Done,
     /* 2027056 */   // Label 27055: @2027056
     /* 2027056 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2027161), // Rule ID 16504 //
     /* 2027061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027111 */     // MIs[1] Operand 1
     /* 2027111 */     // No operand predicates
     /* 2027111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027115 */     // MIs[0] round
     /* 2027115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027118 */     // MIs[0] policy
     /* 2027118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027160 */     // GIR_Coverage, 16504,
     /* 2027160 */     GIR_EraseRootFromParent_Done,
     /* 2027161 */   // Label 27056: @2027161
     /* 2027161 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2027266), // Rule ID 16505 //
     /* 2027166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2027177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2027180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2027183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2027189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027216 */     // MIs[1] Operand 1
     /* 2027216 */     // No operand predicates
     /* 2027216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027220 */     // MIs[0] round
     /* 2027220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027223 */     // MIs[0] policy
     /* 2027223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027235 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027265 */     // GIR_Coverage, 16505,
     /* 2027265 */     GIR_EraseRootFromParent_Done,
     /* 2027266 */   // Label 27057: @2027266
     /* 2027266 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2027371), // Rule ID 16508 //
     /* 2027271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027321 */     // MIs[1] Operand 1
     /* 2027321 */     // No operand predicates
     /* 2027321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027325 */     // MIs[0] round
     /* 2027325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027328 */     // MIs[0] policy
     /* 2027328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2027343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027370 */     // GIR_Coverage, 16508,
     /* 2027370 */     GIR_EraseRootFromParent_Done,
     /* 2027371 */   // Label 27058: @2027371
     /* 2027371 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2027476), // Rule ID 16509 //
     /* 2027376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2027393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027426 */     // MIs[1] Operand 1
     /* 2027426 */     // No operand predicates
     /* 2027426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027430 */     // MIs[0] round
     /* 2027430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027433 */     // MIs[0] policy
     /* 2027433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027445 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2027448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027475 */     // GIR_Coverage, 16509,
     /* 2027475 */     GIR_EraseRootFromParent_Done,
     /* 2027476 */   // Label 27059: @2027476
     /* 2027476 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2027581), // Rule ID 16512 //
     /* 2027481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027531 */     // MIs[1] Operand 1
     /* 2027531 */     // No operand predicates
     /* 2027531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027535 */     // MIs[0] round
     /* 2027535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027538 */     // MIs[0] policy
     /* 2027538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027580 */     // GIR_Coverage, 16512,
     /* 2027580 */     GIR_EraseRootFromParent_Done,
     /* 2027581 */   // Label 27060: @2027581
     /* 2027581 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2027686), // Rule ID 16513 //
     /* 2027586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027636 */     // MIs[1] Operand 1
     /* 2027636 */     // No operand predicates
     /* 2027636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027640 */     // MIs[0] round
     /* 2027640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027643 */     // MIs[0] policy
     /* 2027643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027655 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027685 */     // GIR_Coverage, 16513,
     /* 2027685 */     GIR_EraseRootFromParent_Done,
     /* 2027686 */   // Label 27061: @2027686
     /* 2027686 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2027791), // Rule ID 16516 //
     /* 2027691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027741 */     // MIs[1] Operand 1
     /* 2027741 */     // No operand predicates
     /* 2027741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027745 */     // MIs[0] round
     /* 2027745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027748 */     // MIs[0] policy
     /* 2027748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027790 */     // GIR_Coverage, 16516,
     /* 2027790 */     GIR_EraseRootFromParent_Done,
     /* 2027791 */   // Label 27062: @2027791
     /* 2027791 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2027896), // Rule ID 16517 //
     /* 2027796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027846 */     // MIs[1] Operand 1
     /* 2027846 */     // No operand predicates
     /* 2027846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027850 */     // MIs[0] round
     /* 2027850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027853 */     // MIs[0] policy
     /* 2027853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027895 */     // GIR_Coverage, 16517,
     /* 2027895 */     GIR_EraseRootFromParent_Done,
     /* 2027896 */   // Label 27063: @2027896
     /* 2027896 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2028001), // Rule ID 16520 //
     /* 2027901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027951 */     // MIs[1] Operand 1
     /* 2027951 */     // No operand predicates
     /* 2027951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027955 */     // MIs[0] round
     /* 2027955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027958 */     // MIs[0] policy
     /* 2027958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028000 */     // GIR_Coverage, 16520,
     /* 2028000 */     GIR_EraseRootFromParent_Done,
     /* 2028001 */   // Label 27064: @2028001
     /* 2028001 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2028106), // Rule ID 16521 //
     /* 2028006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2028009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2028014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2028017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2028020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2028023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028056 */     // MIs[1] Operand 1
     /* 2028056 */     // No operand predicates
     /* 2028056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028060 */     // MIs[0] round
     /* 2028060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028063 */     // MIs[0] policy
     /* 2028063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028075 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2028078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028105 */     // GIR_Coverage, 16521,
     /* 2028105 */     GIR_EraseRootFromParent_Done,
     /* 2028106 */   // Label 27065: @2028106
     /* 2028106 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2028211), // Rule ID 16644 //
     /* 2028111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028161 */     // MIs[1] Operand 1
     /* 2028161 */     // No operand predicates
     /* 2028161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028165 */     // MIs[0] round
     /* 2028165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028168 */     // MIs[0] policy
     /* 2028168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028180 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2028183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028210 */     // GIR_Coverage, 16644,
     /* 2028210 */     GIR_EraseRootFromParent_Done,
     /* 2028211 */   // Label 27066: @2028211
     /* 2028211 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2028316), // Rule ID 16645 //
     /* 2028216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2028227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2028230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028266 */     // MIs[1] Operand 1
     /* 2028266 */     // No operand predicates
     /* 2028266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028270 */     // MIs[0] round
     /* 2028270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028273 */     // MIs[0] policy
     /* 2028273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028285 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2028288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028315 */     // GIR_Coverage, 16645,
     /* 2028315 */     GIR_EraseRootFromParent_Done,
     /* 2028316 */   // Label 27067: @2028316
     /* 2028316 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2028421), // Rule ID 16648 //
     /* 2028321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028371 */     // MIs[1] Operand 1
     /* 2028371 */     // No operand predicates
     /* 2028371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028375 */     // MIs[0] round
     /* 2028375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028378 */     // MIs[0] policy
     /* 2028378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028420 */     // GIR_Coverage, 16648,
     /* 2028420 */     GIR_EraseRootFromParent_Done,
     /* 2028421 */   // Label 27068: @2028421
     /* 2028421 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2028526), // Rule ID 16649 //
     /* 2028426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2028437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2028440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028476 */     // MIs[1] Operand 1
     /* 2028476 */     // No operand predicates
     /* 2028476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028480 */     // MIs[0] round
     /* 2028480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028483 */     // MIs[0] policy
     /* 2028483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028495 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028525 */     // GIR_Coverage, 16649,
     /* 2028525 */     GIR_EraseRootFromParent_Done,
     /* 2028526 */   // Label 27069: @2028526
     /* 2028526 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2028631), // Rule ID 16652 //
     /* 2028531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028581 */     // MIs[1] Operand 1
     /* 2028581 */     // No operand predicates
     /* 2028581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028585 */     // MIs[0] round
     /* 2028585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028588 */     // MIs[0] policy
     /* 2028588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028600 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028630 */     // GIR_Coverage, 16652,
     /* 2028630 */     GIR_EraseRootFromParent_Done,
     /* 2028631 */   // Label 27070: @2028631
     /* 2028631 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2028736), // Rule ID 16653 //
     /* 2028636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028686 */     // MIs[1] Operand 1
     /* 2028686 */     // No operand predicates
     /* 2028686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028690 */     // MIs[0] round
     /* 2028690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028693 */     // MIs[0] policy
     /* 2028693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028705 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028735 */     // GIR_Coverage, 16653,
     /* 2028735 */     GIR_EraseRootFromParent_Done,
     /* 2028736 */   // Label 27071: @2028736
     /* 2028736 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2028841), // Rule ID 16656 //
     /* 2028741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028791 */     // MIs[1] Operand 1
     /* 2028791 */     // No operand predicates
     /* 2028791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028795 */     // MIs[0] round
     /* 2028795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028798 */     // MIs[0] policy
     /* 2028798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028810 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028840 */     // GIR_Coverage, 16656,
     /* 2028840 */     GIR_EraseRootFromParent_Done,
     /* 2028841 */   // Label 27072: @2028841
     /* 2028841 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2028946), // Rule ID 16657 //
     /* 2028846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028896 */     // MIs[1] Operand 1
     /* 2028896 */     // No operand predicates
     /* 2028896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028900 */     // MIs[0] round
     /* 2028900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028903 */     // MIs[0] policy
     /* 2028903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028915 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028945 */     // GIR_Coverage, 16657,
     /* 2028945 */     GIR_EraseRootFromParent_Done,
     /* 2028946 */   // Label 27073: @2028946
     /* 2028946 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2029051), // Rule ID 16660 //
     /* 2028951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029001 */     // MIs[1] Operand 1
     /* 2029001 */     // No operand predicates
     /* 2029001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029005 */     // MIs[0] round
     /* 2029005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029008 */     // MIs[0] policy
     /* 2029008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029020 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029050 */     // GIR_Coverage, 16660,
     /* 2029050 */     GIR_EraseRootFromParent_Done,
     /* 2029051 */   // Label 27074: @2029051
     /* 2029051 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2029156), // Rule ID 16661 //
     /* 2029056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029106 */     // MIs[1] Operand 1
     /* 2029106 */     // No operand predicates
     /* 2029106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029110 */     // MIs[0] round
     /* 2029110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029113 */     // MIs[0] policy
     /* 2029113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029125 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029155 */     // GIR_Coverage, 16661,
     /* 2029155 */     GIR_EraseRootFromParent_Done,
     /* 2029156 */   // Label 27075: @2029156
     /* 2029156 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2029261), // Rule ID 16664 //
     /* 2029161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029211 */     // MIs[1] Operand 1
     /* 2029211 */     // No operand predicates
     /* 2029211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029215 */     // MIs[0] round
     /* 2029215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029218 */     // MIs[0] policy
     /* 2029218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029230 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029260 */     // GIR_Coverage, 16664,
     /* 2029260 */     GIR_EraseRootFromParent_Done,
     /* 2029261 */   // Label 27076: @2029261
     /* 2029261 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2029366), // Rule ID 16665 //
     /* 2029266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029316 */     // MIs[1] Operand 1
     /* 2029316 */     // No operand predicates
     /* 2029316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029320 */     // MIs[0] round
     /* 2029320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029323 */     // MIs[0] policy
     /* 2029323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029335 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029365 */     // GIR_Coverage, 16665,
     /* 2029365 */     GIR_EraseRootFromParent_Done,
     /* 2029366 */   // Label 27077: @2029366
     /* 2029366 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2029471), // Rule ID 16668 //
     /* 2029371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029421 */     // MIs[1] Operand 1
     /* 2029421 */     // No operand predicates
     /* 2029421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029425 */     // MIs[0] round
     /* 2029425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029428 */     // MIs[0] policy
     /* 2029428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029440 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029470 */     // GIR_Coverage, 16668,
     /* 2029470 */     GIR_EraseRootFromParent_Done,
     /* 2029471 */   // Label 27078: @2029471
     /* 2029471 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2029576), // Rule ID 16669 //
     /* 2029476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029526 */     // MIs[1] Operand 1
     /* 2029526 */     // No operand predicates
     /* 2029526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029530 */     // MIs[0] round
     /* 2029530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029533 */     // MIs[0] policy
     /* 2029533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029545 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029575 */     // GIR_Coverage, 16669,
     /* 2029575 */     GIR_EraseRootFromParent_Done,
     /* 2029576 */   // Label 27079: @2029576
     /* 2029576 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2029681), // Rule ID 16672 //
     /* 2029581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029631 */     // MIs[1] Operand 1
     /* 2029631 */     // No operand predicates
     /* 2029631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029635 */     // MIs[0] round
     /* 2029635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029638 */     // MIs[0] policy
     /* 2029638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029680 */     // GIR_Coverage, 16672,
     /* 2029680 */     GIR_EraseRootFromParent_Done,
     /* 2029681 */   // Label 27080: @2029681
     /* 2029681 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2029786), // Rule ID 16673 //
     /* 2029686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029736 */     // MIs[1] Operand 1
     /* 2029736 */     // No operand predicates
     /* 2029736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029740 */     // MIs[0] round
     /* 2029740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029743 */     // MIs[0] policy
     /* 2029743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029755 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029785 */     // GIR_Coverage, 16673,
     /* 2029785 */     GIR_EraseRootFromParent_Done,
     /* 2029786 */   // Label 27081: @2029786
     /* 2029786 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2029891), // Rule ID 16676 //
     /* 2029791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029841 */     // MIs[1] Operand 1
     /* 2029841 */     // No operand predicates
     /* 2029841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029845 */     // MIs[0] round
     /* 2029845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029848 */     // MIs[0] policy
     /* 2029848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029890 */     // GIR_Coverage, 16676,
     /* 2029890 */     GIR_EraseRootFromParent_Done,
     /* 2029891 */   // Label 27082: @2029891
     /* 2029891 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2029996), // Rule ID 16677 //
     /* 2029896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029946 */     // MIs[1] Operand 1
     /* 2029946 */     // No operand predicates
     /* 2029946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029950 */     // MIs[0] round
     /* 2029950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029953 */     // MIs[0] policy
     /* 2029953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029965 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029995 */     // GIR_Coverage, 16677,
     /* 2029995 */     GIR_EraseRootFromParent_Done,
     /* 2029996 */   // Label 27083: @2029996
     /* 2029996 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2030101), // Rule ID 16680 //
     /* 2030001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030051 */     // MIs[1] Operand 1
     /* 2030051 */     // No operand predicates
     /* 2030051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030055 */     // MIs[0] round
     /* 2030055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030058 */     // MIs[0] policy
     /* 2030058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030100 */     // GIR_Coverage, 16680,
     /* 2030100 */     GIR_EraseRootFromParent_Done,
     /* 2030101 */   // Label 27084: @2030101
     /* 2030101 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2030206), // Rule ID 16681 //
     /* 2030106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2030117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2030120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030156 */     // MIs[1] Operand 1
     /* 2030156 */     // No operand predicates
     /* 2030156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030160 */     // MIs[0] round
     /* 2030160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030163 */     // MIs[0] policy
     /* 2030163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030205 */     // GIR_Coverage, 16681,
     /* 2030205 */     GIR_EraseRootFromParent_Done,
     /* 2030206 */   // Label 27085: @2030206
     /* 2030206 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2030311), // Rule ID 16684 //
     /* 2030211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030261 */     // MIs[1] Operand 1
     /* 2030261 */     // No operand predicates
     /* 2030261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030265 */     // MIs[0] round
     /* 2030265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030268 */     // MIs[0] policy
     /* 2030268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030310 */     // GIR_Coverage, 16684,
     /* 2030310 */     GIR_EraseRootFromParent_Done,
     /* 2030311 */   // Label 27086: @2030311
     /* 2030311 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2030416), // Rule ID 16685 //
     /* 2030316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030366 */     // MIs[1] Operand 1
     /* 2030366 */     // No operand predicates
     /* 2030366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030370 */     // MIs[0] round
     /* 2030370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030373 */     // MIs[0] policy
     /* 2030373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030385 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030415 */     // GIR_Coverage, 16685,
     /* 2030415 */     GIR_EraseRootFromParent_Done,
     /* 2030416 */   // Label 27087: @2030416
     /* 2030416 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2030521), // Rule ID 16688 //
     /* 2030421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030471 */     // MIs[1] Operand 1
     /* 2030471 */     // No operand predicates
     /* 2030471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030475 */     // MIs[0] round
     /* 2030475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030478 */     // MIs[0] policy
     /* 2030478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030520 */     // GIR_Coverage, 16688,
     /* 2030520 */     GIR_EraseRootFromParent_Done,
     /* 2030521 */   // Label 27088: @2030521
     /* 2030521 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2030626), // Rule ID 16689 //
     /* 2030526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030576 */     // MIs[1] Operand 1
     /* 2030576 */     // No operand predicates
     /* 2030576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030580 */     // MIs[0] round
     /* 2030580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030583 */     // MIs[0] policy
     /* 2030583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030625 */     // GIR_Coverage, 16689,
     /* 2030625 */     GIR_EraseRootFromParent_Done,
     /* 2030626 */   // Label 27089: @2030626
     /* 2030626 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2030731), // Rule ID 16692 //
     /* 2030631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030681 */     // MIs[1] Operand 1
     /* 2030681 */     // No operand predicates
     /* 2030681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030685 */     // MIs[0] round
     /* 2030685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030688 */     // MIs[0] policy
     /* 2030688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030730 */     // GIR_Coverage, 16692,
     /* 2030730 */     GIR_EraseRootFromParent_Done,
     /* 2030731 */   // Label 27090: @2030731
     /* 2030731 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2030836), // Rule ID 16693 //
     /* 2030736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030786 */     // MIs[1] Operand 1
     /* 2030786 */     // No operand predicates
     /* 2030786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030790 */     // MIs[0] round
     /* 2030790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030793 */     // MIs[0] policy
     /* 2030793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030805 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030835 */     // GIR_Coverage, 16693,
     /* 2030835 */     GIR_EraseRootFromParent_Done,
     /* 2030836 */   // Label 27091: @2030836
     /* 2030836 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2030941), // Rule ID 16696 //
     /* 2030841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030891 */     // MIs[1] Operand 1
     /* 2030891 */     // No operand predicates
     /* 2030891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030895 */     // MIs[0] round
     /* 2030895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030898 */     // MIs[0] policy
     /* 2030898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030940 */     // GIR_Coverage, 16696,
     /* 2030940 */     GIR_EraseRootFromParent_Done,
     /* 2030941 */   // Label 27092: @2030941
     /* 2030941 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2031046), // Rule ID 16697 //
     /* 2030946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030996 */     // MIs[1] Operand 1
     /* 2030996 */     // No operand predicates
     /* 2030996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031000 */     // MIs[0] round
     /* 2031000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031003 */     // MIs[0] policy
     /* 2031003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2031018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031045 */     // GIR_Coverage, 16697,
     /* 2031045 */     GIR_EraseRootFromParent_Done,
     /* 2031046 */   // Label 27093: @2031046
     /* 2031046 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2031151), // Rule ID 16700 //
     /* 2031051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2031054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031101 */     // MIs[1] Operand 1
     /* 2031101 */     // No operand predicates
     /* 2031101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031105 */     // MIs[0] round
     /* 2031105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031108 */     // MIs[0] policy
     /* 2031108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2031123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031150 */     // GIR_Coverage, 16700,
     /* 2031150 */     GIR_EraseRootFromParent_Done,
     /* 2031151 */   // Label 27094: @2031151
     /* 2031151 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2031256), // Rule ID 16701 //
     /* 2031156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2031159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2031164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2031198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2031202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2031206 */     // MIs[1] Operand 1
     /* 2031206 */     // No operand predicates
     /* 2031206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031210 */     // MIs[0] round
     /* 2031210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031213 */     // MIs[0] policy
     /* 2031213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2031218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031225 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2031228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2031237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2031254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031255 */     // GIR_Coverage, 16701,
     /* 2031255 */     GIR_EraseRootFromParent_Done,
     /* 2031256 */   // Label 27095: @2031256
     /* 2031256 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2031343), // Rule ID 2772 //
     /* 2031261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031292 */     // MIs[0] passthru
     /* 2031292 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031305 */     // MIs[0] round
     /* 2031305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031308 */     // MIs[0] policy
     /* 2031308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031318 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2031321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031342 */     // GIR_Coverage, 2772,
     /* 2031342 */     GIR_EraseRootFromParent_Done,
     /* 2031343 */   // Label 27096: @2031343
     /* 2031343 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2031430), // Rule ID 2773 //
     /* 2031348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031379 */     // MIs[0] passthru
     /* 2031379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031392 */     // MIs[0] round
     /* 2031392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031395 */     // MIs[0] policy
     /* 2031395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031405 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2031408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031429 */     // GIR_Coverage, 2773,
     /* 2031429 */     GIR_EraseRootFromParent_Done,
     /* 2031430 */   // Label 27097: @2031430
     /* 2031430 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2031517), // Rule ID 17152 //
     /* 2031435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031466 */     // MIs[0] passthru
     /* 2031466 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031479 */     // MIs[0] round
     /* 2031479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031482 */     // MIs[0] policy
     /* 2031482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031492 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031516 */     // GIR_Coverage, 17152,
     /* 2031516 */     GIR_EraseRootFromParent_Done,
     /* 2031517 */   // Label 27098: @2031517
     /* 2031517 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2031604), // Rule ID 17153 //
     /* 2031522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031553 */     // MIs[0] passthru
     /* 2031553 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031566 */     // MIs[0] round
     /* 2031566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031569 */     // MIs[0] policy
     /* 2031569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031603 */     // GIR_Coverage, 17153,
     /* 2031603 */     GIR_EraseRootFromParent_Done,
     /* 2031604 */   // Label 27099: @2031604
     /* 2031604 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2031691), // Rule ID 17162 //
     /* 2031609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031640 */     // MIs[0] passthru
     /* 2031640 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031653 */     // MIs[0] round
     /* 2031653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031656 */     // MIs[0] policy
     /* 2031656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031666 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031690 */     // GIR_Coverage, 17162,
     /* 2031690 */     GIR_EraseRootFromParent_Done,
     /* 2031691 */   // Label 27100: @2031691
     /* 2031691 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2031778), // Rule ID 17163 //
     /* 2031696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031727 */     // MIs[0] passthru
     /* 2031727 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031740 */     // MIs[0] round
     /* 2031740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031743 */     // MIs[0] policy
     /* 2031743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031753 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031777 */     // GIR_Coverage, 17163,
     /* 2031777 */     GIR_EraseRootFromParent_Done,
     /* 2031778 */   // Label 27101: @2031778
     /* 2031778 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2031865), // Rule ID 17172 //
     /* 2031783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031814 */     // MIs[0] passthru
     /* 2031814 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031827 */     // MIs[0] round
     /* 2031827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031830 */     // MIs[0] policy
     /* 2031830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031840 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031864 */     // GIR_Coverage, 17172,
     /* 2031864 */     GIR_EraseRootFromParent_Done,
     /* 2031865 */   // Label 27102: @2031865
     /* 2031865 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2031952), // Rule ID 17173 //
     /* 2031870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031901 */     // MIs[0] passthru
     /* 2031901 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031914 */     // MIs[0] round
     /* 2031914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031917 */     // MIs[0] policy
     /* 2031917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031927 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031951 */     // GIR_Coverage, 17173,
     /* 2031951 */     GIR_EraseRootFromParent_Done,
     /* 2031952 */   // Label 27103: @2031952
     /* 2031952 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2032039), // Rule ID 17182 //
     /* 2031957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031988 */     // MIs[0] passthru
     /* 2031988 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032001 */     // MIs[0] round
     /* 2032001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032004 */     // MIs[0] policy
     /* 2032004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2032017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032038 */     // GIR_Coverage, 17182,
     /* 2032038 */     GIR_EraseRootFromParent_Done,
     /* 2032039 */   // Label 27104: @2032039
     /* 2032039 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2032126), // Rule ID 17183 //
     /* 2032044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2032055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2032058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2032061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032075 */     // MIs[0] passthru
     /* 2032075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032088 */     // MIs[0] round
     /* 2032088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032091 */     // MIs[0] policy
     /* 2032091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032101 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2032104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032125 */     // GIR_Coverage, 17183,
     /* 2032125 */     GIR_EraseRootFromParent_Done,
     /* 2032126 */   // Label 27105: @2032126
     /* 2032126 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2032213), // Rule ID 17192 //
     /* 2032131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2032148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032162 */     // MIs[0] passthru
     /* 2032162 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032175 */     // MIs[0] round
     /* 2032175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032178 */     // MIs[0] policy
     /* 2032178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2032191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032212 */     // GIR_Coverage, 17192,
     /* 2032212 */     GIR_EraseRootFromParent_Done,
     /* 2032213 */   // Label 27106: @2032213
     /* 2032213 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2032300), // Rule ID 17193 //
     /* 2032218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2032235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032249 */     // MIs[0] passthru
     /* 2032249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032262 */     // MIs[0] round
     /* 2032262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032265 */     // MIs[0] policy
     /* 2032265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032275 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2032278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032299 */     // GIR_Coverage, 17193,
     /* 2032299 */     GIR_EraseRootFromParent_Done,
     /* 2032300 */   // Label 27107: @2032300
     /* 2032300 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2032387), // Rule ID 17202 //
     /* 2032305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2032316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2032319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032336 */     // MIs[0] passthru
     /* 2032336 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032349 */     // MIs[0] round
     /* 2032349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032352 */     // MIs[0] policy
     /* 2032352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032362 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2032365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032386 */     // GIR_Coverage, 17202,
     /* 2032386 */     GIR_EraseRootFromParent_Done,
     /* 2032387 */   // Label 27108: @2032387
     /* 2032387 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2032474), // Rule ID 17203 //
     /* 2032392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2032403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2032406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032423 */     // MIs[0] passthru
     /* 2032423 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032436 */     // MIs[0] round
     /* 2032436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032439 */     // MIs[0] policy
     /* 2032439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032449 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2032452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032473 */     // GIR_Coverage, 17203,
     /* 2032473 */     GIR_EraseRootFromParent_Done,
     /* 2032474 */   // Label 27109: @2032474
     /* 2032474 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2032561), // Rule ID 17212 //
     /* 2032479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032510 */     // MIs[0] passthru
     /* 2032510 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032523 */     // MIs[0] round
     /* 2032523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032526 */     // MIs[0] policy
     /* 2032526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032536 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032560 */     // GIR_Coverage, 17212,
     /* 2032560 */     GIR_EraseRootFromParent_Done,
     /* 2032561 */   // Label 27110: @2032561
     /* 2032561 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2032648), // Rule ID 17213 //
     /* 2032566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032597 */     // MIs[0] passthru
     /* 2032597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032610 */     // MIs[0] round
     /* 2032610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032613 */     // MIs[0] policy
     /* 2032613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032623 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032647 */     // GIR_Coverage, 17213,
     /* 2032647 */     GIR_EraseRootFromParent_Done,
     /* 2032648 */   // Label 27111: @2032648
     /* 2032648 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2032735), // Rule ID 17222 //
     /* 2032653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032684 */     // MIs[0] passthru
     /* 2032684 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032697 */     // MIs[0] round
     /* 2032697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032700 */     // MIs[0] policy
     /* 2032700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032710 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032734 */     // GIR_Coverage, 17222,
     /* 2032734 */     GIR_EraseRootFromParent_Done,
     /* 2032735 */   // Label 27112: @2032735
     /* 2032735 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2032822), // Rule ID 17223 //
     /* 2032740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032771 */     // MIs[0] passthru
     /* 2032771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032784 */     // MIs[0] round
     /* 2032784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032787 */     // MIs[0] policy
     /* 2032787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032797 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032821 */     // GIR_Coverage, 17223,
     /* 2032821 */     GIR_EraseRootFromParent_Done,
     /* 2032822 */   // Label 27113: @2032822
     /* 2032822 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2032909), // Rule ID 17268 //
     /* 2032827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032858 */     // MIs[0] passthru
     /* 2032858 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032871 */     // MIs[0] round
     /* 2032871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032874 */     // MIs[0] policy
     /* 2032874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032884 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032908 */     // GIR_Coverage, 17268,
     /* 2032908 */     GIR_EraseRootFromParent_Done,
     /* 2032909 */   // Label 27114: @2032909
     /* 2032909 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2032996), // Rule ID 17269 //
     /* 2032914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032945 */     // MIs[0] passthru
     /* 2032945 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032958 */     // MIs[0] round
     /* 2032958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032961 */     // MIs[0] policy
     /* 2032961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032971 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032995 */     // GIR_Coverage, 17269,
     /* 2032995 */     GIR_EraseRootFromParent_Done,
     /* 2032996 */   // Label 27115: @2032996
     /* 2032996 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2033083), // Rule ID 17278 //
     /* 2033001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2033012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2033015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2033018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033032 */     // MIs[0] passthru
     /* 2033032 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033045 */     // MIs[0] round
     /* 2033045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033048 */     // MIs[0] policy
     /* 2033048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2033061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033082 */     // GIR_Coverage, 17278,
     /* 2033082 */     GIR_EraseRootFromParent_Done,
     /* 2033083 */   // Label 27116: @2033083
     /* 2033083 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2033170), // Rule ID 17279 //
     /* 2033088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2033099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2033102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2033105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033119 */     // MIs[0] passthru
     /* 2033119 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033132 */     // MIs[0] round
     /* 2033132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033135 */     // MIs[0] policy
     /* 2033135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033145 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2033148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033169 */     // GIR_Coverage, 17279,
     /* 2033169 */     GIR_EraseRootFromParent_Done,
     /* 2033170 */   // Label 27117: @2033170
     /* 2033170 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2033257), // Rule ID 17288 //
     /* 2033175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2033192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033206 */     // MIs[0] passthru
     /* 2033206 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033219 */     // MIs[0] round
     /* 2033219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033222 */     // MIs[0] policy
     /* 2033222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2033235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033256 */     // GIR_Coverage, 17288,
     /* 2033256 */     GIR_EraseRootFromParent_Done,
     /* 2033257 */   // Label 27118: @2033257
     /* 2033257 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2033344), // Rule ID 17289 //
     /* 2033262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2033279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033293 */     // MIs[0] passthru
     /* 2033293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033306 */     // MIs[0] round
     /* 2033306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033309 */     // MIs[0] policy
     /* 2033309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033319 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2033322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033343 */     // GIR_Coverage, 17289,
     /* 2033343 */     GIR_EraseRootFromParent_Done,
     /* 2033344 */   // Label 27119: @2033344
     /* 2033344 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2033431), // Rule ID 17298 //
     /* 2033349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033380 */     // MIs[0] passthru
     /* 2033380 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033393 */     // MIs[0] round
     /* 2033393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033396 */     // MIs[0] policy
     /* 2033396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033406 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033430 */     // GIR_Coverage, 17298,
     /* 2033430 */     GIR_EraseRootFromParent_Done,
     /* 2033431 */   // Label 27120: @2033431
     /* 2033431 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2033518), // Rule ID 17299 //
     /* 2033436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2033447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2033450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033467 */     // MIs[0] passthru
     /* 2033467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033480 */     // MIs[0] round
     /* 2033480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033483 */     // MIs[0] policy
     /* 2033483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033493 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033517 */     // GIR_Coverage, 17299,
     /* 2033517 */     GIR_EraseRootFromParent_Done,
     /* 2033518 */   // Label 27121: @2033518
     /* 2033518 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2033605), // Rule ID 17308 //
     /* 2033523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033554 */     // MIs[0] passthru
     /* 2033554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033567 */     // MIs[0] round
     /* 2033567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033570 */     // MIs[0] policy
     /* 2033570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033580 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033604 */     // GIR_Coverage, 17308,
     /* 2033604 */     GIR_EraseRootFromParent_Done,
     /* 2033605 */   // Label 27122: @2033605
     /* 2033605 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2033692), // Rule ID 17309 //
     /* 2033610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033641 */     // MIs[0] passthru
     /* 2033641 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033654 */     // MIs[0] round
     /* 2033654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033657 */     // MIs[0] policy
     /* 2033657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033667 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033691 */     // GIR_Coverage, 17309,
     /* 2033691 */     GIR_EraseRootFromParent_Done,
     /* 2033692 */   // Label 27123: @2033692
     /* 2033692 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2033779), // Rule ID 17318 //
     /* 2033697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033728 */     // MIs[0] passthru
     /* 2033728 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033741 */     // MIs[0] round
     /* 2033741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033744 */     // MIs[0] policy
     /* 2033744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033754 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033778 */     // GIR_Coverage, 17318,
     /* 2033778 */     GIR_EraseRootFromParent_Done,
     /* 2033779 */   // Label 27124: @2033779
     /* 2033779 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2033866), // Rule ID 17319 //
     /* 2033784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033815 */     // MIs[0] passthru
     /* 2033815 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033828 */     // MIs[0] round
     /* 2033828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033831 */     // MIs[0] policy
     /* 2033831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033841 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033865 */     // GIR_Coverage, 17319,
     /* 2033865 */     GIR_EraseRootFromParent_Done,
     /* 2033866 */   // Label 27125: @2033866
     /* 2033866 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2033953), // Rule ID 17328 //
     /* 2033871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033902 */     // MIs[0] passthru
     /* 2033902 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033915 */     // MIs[0] round
     /* 2033915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033918 */     // MIs[0] policy
     /* 2033918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033928 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033952 */     // GIR_Coverage, 17328,
     /* 2033952 */     GIR_EraseRootFromParent_Done,
     /* 2033953 */   // Label 27126: @2033953
     /* 2033953 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2034040), // Rule ID 17329 //
     /* 2033958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033989 */     // MIs[0] passthru
     /* 2033989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034002 */     // MIs[0] round
     /* 2034002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034005 */     // MIs[0] policy
     /* 2034005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034015 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2034018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034039 */     // GIR_Coverage, 17329,
     /* 2034039 */     GIR_EraseRootFromParent_Done,
     /* 2034040 */   // Label 27127: @2034040
     /* 2034040 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2034127), // Rule ID 17338 //
     /* 2034045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2034048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034076 */     // MIs[0] passthru
     /* 2034076 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034089 */     // MIs[0] round
     /* 2034089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034092 */     // MIs[0] policy
     /* 2034092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2034105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034126 */     // GIR_Coverage, 17338,
     /* 2034126 */     GIR_EraseRootFromParent_Done,
     /* 2034127 */   // Label 27128: @2034127
     /* 2034127 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2034214), // Rule ID 17339 //
     /* 2034132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2034135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034163 */     // MIs[0] passthru
     /* 2034163 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034176 */     // MIs[0] round
     /* 2034176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034179 */     // MIs[0] policy
     /* 2034179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034189 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2034192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034213 */     // GIR_Coverage, 17339,
     /* 2034213 */     GIR_EraseRootFromParent_Done,
     /* 2034214 */   // Label 27129: @2034214
     /* 2034214 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2034301), // Rule ID 17348 //
     /* 2034219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2034222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034250 */     // MIs[0] passthru
     /* 2034250 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034263 */     // MIs[0] round
     /* 2034263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034266 */     // MIs[0] policy
     /* 2034266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034276 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2034279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034300 */     // GIR_Coverage, 17348,
     /* 2034300 */     GIR_EraseRootFromParent_Done,
     /* 2034301 */   // Label 27130: @2034301
     /* 2034301 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2034388), // Rule ID 17349 //
     /* 2034306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2034309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2034314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034337 */     // MIs[0] passthru
     /* 2034337 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2034342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034350 */     // MIs[0] round
     /* 2034350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034353 */     // MIs[0] policy
     /* 2034353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034363 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2034366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034387 */     // GIR_Coverage, 17349,
     /* 2034387 */     GIR_EraseRootFromParent_Done,
     /* 2034388 */   // Label 27131: @2034388
     /* 2034388 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2034479), // Rule ID 2730 //
     /* 2034393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034439 */     // MIs[0] round
     /* 2034439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034442 */     // MIs[0] policy
     /* 2034442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034478 */     // GIR_Coverage, 2730,
     /* 2034478 */     GIR_EraseRootFromParent_Done,
     /* 2034479 */   // Label 27132: @2034479
     /* 2034479 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2034570), // Rule ID 2731 //
     /* 2034484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034530 */     // MIs[0] round
     /* 2034530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034533 */     // MIs[0] policy
     /* 2034533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034543 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034569 */     // GIR_Coverage, 2731,
     /* 2034569 */     GIR_EraseRootFromParent_Done,
     /* 2034570 */   // Label 27133: @2034570
     /* 2034570 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2034661), // Rule ID 2774 //
     /* 2034575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034621 */     // MIs[0] round
     /* 2034621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034624 */     // MIs[0] policy
     /* 2034624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034634 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034660 */     // GIR_Coverage, 2774,
     /* 2034660 */     GIR_EraseRootFromParent_Done,
     /* 2034661 */   // Label 27134: @2034661
     /* 2034661 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2034752), // Rule ID 2775 //
     /* 2034666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034712 */     // MIs[0] round
     /* 2034712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034715 */     // MIs[0] policy
     /* 2034715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034725 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034751 */     // GIR_Coverage, 2775,
     /* 2034751 */     GIR_EraseRootFromParent_Done,
     /* 2034752 */   // Label 27135: @2034752
     /* 2034752 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2034843), // Rule ID 2782 //
     /* 2034757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034803 */     // MIs[0] round
     /* 2034803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034806 */     // MIs[0] policy
     /* 2034806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034842 */     // GIR_Coverage, 2782,
     /* 2034842 */     GIR_EraseRootFromParent_Done,
     /* 2034843 */   // Label 27136: @2034843
     /* 2034843 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2034934), // Rule ID 2783 //
     /* 2034848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034894 */     // MIs[0] round
     /* 2034894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034897 */     // MIs[0] policy
     /* 2034897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034907 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034933 */     // GIR_Coverage, 2783,
     /* 2034933 */     GIR_EraseRootFromParent_Done,
     /* 2034934 */   // Label 27137: @2034934
     /* 2034934 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2035025), // Rule ID 14940 //
     /* 2034939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034985 */     // MIs[0] round
     /* 2034985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034988 */     // MIs[0] policy
     /* 2034988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034998 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035024 */     // GIR_Coverage, 14940,
     /* 2035024 */     GIR_EraseRootFromParent_Done,
     /* 2035025 */   // Label 27138: @2035025
     /* 2035025 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2035116), // Rule ID 14941 //
     /* 2035030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2035050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035076 */     // MIs[0] round
     /* 2035076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035079 */     // MIs[0] policy
     /* 2035079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035089 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035115 */     // GIR_Coverage, 14941,
     /* 2035115 */     GIR_EraseRootFromParent_Done,
     /* 2035116 */   // Label 27139: @2035116
     /* 2035116 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2035207), // Rule ID 14944 //
     /* 2035121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035167 */     // MIs[0] round
     /* 2035167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035170 */     // MIs[0] policy
     /* 2035170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035206 */     // GIR_Coverage, 14944,
     /* 2035206 */     GIR_EraseRootFromParent_Done,
     /* 2035207 */   // Label 27140: @2035207
     /* 2035207 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2035298), // Rule ID 14945 //
     /* 2035212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035258 */     // MIs[0] round
     /* 2035258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035261 */     // MIs[0] policy
     /* 2035261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035297 */     // GIR_Coverage, 14945,
     /* 2035297 */     GIR_EraseRootFromParent_Done,
     /* 2035298 */   // Label 27141: @2035298
     /* 2035298 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2035389), // Rule ID 14948 //
     /* 2035303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2035323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035349 */     // MIs[0] round
     /* 2035349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035352 */     // MIs[0] policy
     /* 2035352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035388 */     // GIR_Coverage, 14948,
     /* 2035388 */     GIR_EraseRootFromParent_Done,
     /* 2035389 */   // Label 27142: @2035389
     /* 2035389 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2035480), // Rule ID 14949 //
     /* 2035394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2035414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035440 */     // MIs[0] round
     /* 2035440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035443 */     // MIs[0] policy
     /* 2035443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035453 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2035456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035479 */     // GIR_Coverage, 14949,
     /* 2035479 */     GIR_EraseRootFromParent_Done,
     /* 2035480 */   // Label 27143: @2035480
     /* 2035480 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2035571), // Rule ID 14952 //
     /* 2035485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035531 */     // MIs[0] round
     /* 2035531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035534 */     // MIs[0] policy
     /* 2035534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035570 */     // GIR_Coverage, 14952,
     /* 2035570 */     GIR_EraseRootFromParent_Done,
     /* 2035571 */   // Label 27144: @2035571
     /* 2035571 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2035662), // Rule ID 14953 //
     /* 2035576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035622 */     // MIs[0] round
     /* 2035622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035625 */     // MIs[0] policy
     /* 2035625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035635 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035661 */     // GIR_Coverage, 14953,
     /* 2035661 */     GIR_EraseRootFromParent_Done,
     /* 2035662 */   // Label 27145: @2035662
     /* 2035662 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2035753), // Rule ID 14956 //
     /* 2035667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035713 */     // MIs[0] round
     /* 2035713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035716 */     // MIs[0] policy
     /* 2035716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035752 */     // GIR_Coverage, 14956,
     /* 2035752 */     GIR_EraseRootFromParent_Done,
     /* 2035753 */   // Label 27146: @2035753
     /* 2035753 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2035844), // Rule ID 14957 //
     /* 2035758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035804 */     // MIs[0] round
     /* 2035804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035807 */     // MIs[0] policy
     /* 2035807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035817 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035843 */     // GIR_Coverage, 14957,
     /* 2035843 */     GIR_EraseRootFromParent_Done,
     /* 2035844 */   // Label 27147: @2035844
     /* 2035844 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2035935), // Rule ID 14960 //
     /* 2035849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035895 */     // MIs[0] round
     /* 2035895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035898 */     // MIs[0] policy
     /* 2035898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035934 */     // GIR_Coverage, 14960,
     /* 2035934 */     GIR_EraseRootFromParent_Done,
     /* 2035935 */   // Label 27148: @2035935
     /* 2035935 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2036026), // Rule ID 14961 //
     /* 2035940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035986 */     // MIs[0] round
     /* 2035986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035989 */     // MIs[0] policy
     /* 2035989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036025 */     // GIR_Coverage, 14961,
     /* 2036025 */     GIR_EraseRootFromParent_Done,
     /* 2036026 */   // Label 27149: @2036026
     /* 2036026 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2036117), // Rule ID 14964 //
     /* 2036031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036077 */     // MIs[0] round
     /* 2036077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036080 */     // MIs[0] policy
     /* 2036080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036116 */     // GIR_Coverage, 14964,
     /* 2036116 */     GIR_EraseRootFromParent_Done,
     /* 2036117 */   // Label 27150: @2036117
     /* 2036117 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2036208), // Rule ID 14965 //
     /* 2036122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036168 */     // MIs[0] round
     /* 2036168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036171 */     // MIs[0] policy
     /* 2036171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036181 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036207 */     // GIR_Coverage, 14965,
     /* 2036207 */     GIR_EraseRootFromParent_Done,
     /* 2036208 */   // Label 27151: @2036208
     /* 2036208 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2036299), // Rule ID 14968 //
     /* 2036213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036259 */     // MIs[0] round
     /* 2036259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036262 */     // MIs[0] policy
     /* 2036262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036298 */     // GIR_Coverage, 14968,
     /* 2036298 */     GIR_EraseRootFromParent_Done,
     /* 2036299 */   // Label 27152: @2036299
     /* 2036299 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2036390), // Rule ID 14969 //
     /* 2036304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036350 */     // MIs[0] round
     /* 2036350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036353 */     // MIs[0] policy
     /* 2036353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036363 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036389 */     // GIR_Coverage, 14969,
     /* 2036389 */     GIR_EraseRootFromParent_Done,
     /* 2036390 */   // Label 27153: @2036390
     /* 2036390 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2036481), // Rule ID 14972 //
     /* 2036395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2036398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036441 */     // MIs[0] round
     /* 2036441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036444 */     // MIs[0] policy
     /* 2036444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036454 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036480 */     // GIR_Coverage, 14972,
     /* 2036480 */     GIR_EraseRootFromParent_Done,
     /* 2036481 */   // Label 27154: @2036481
     /* 2036481 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2036572), // Rule ID 14973 //
     /* 2036486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2036489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036532 */     // MIs[0] round
     /* 2036532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036535 */     // MIs[0] policy
     /* 2036535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036545 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036571 */     // GIR_Coverage, 14973,
     /* 2036571 */     GIR_EraseRootFromParent_Done,
     /* 2036572 */   // Label 27155: @2036572
     /* 2036572 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2036663), // Rule ID 14976 //
     /* 2036577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036623 */     // MIs[0] round
     /* 2036623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036626 */     // MIs[0] policy
     /* 2036626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036662 */     // GIR_Coverage, 14976,
     /* 2036662 */     GIR_EraseRootFromParent_Done,
     /* 2036663 */   // Label 27156: @2036663
     /* 2036663 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2036754), // Rule ID 14977 //
     /* 2036668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036714 */     // MIs[0] round
     /* 2036714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036717 */     // MIs[0] policy
     /* 2036717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036753 */     // GIR_Coverage, 14977,
     /* 2036753 */     GIR_EraseRootFromParent_Done,
     /* 2036754 */   // Label 27157: @2036754
     /* 2036754 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2036845), // Rule ID 14980 //
     /* 2036759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036805 */     // MIs[0] round
     /* 2036805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036808 */     // MIs[0] policy
     /* 2036808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036818 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036844 */     // GIR_Coverage, 14980,
     /* 2036844 */     GIR_EraseRootFromParent_Done,
     /* 2036845 */   // Label 27158: @2036845
     /* 2036845 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2036936), // Rule ID 14981 //
     /* 2036850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036896 */     // MIs[0] round
     /* 2036896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036899 */     // MIs[0] policy
     /* 2036899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036935 */     // GIR_Coverage, 14981,
     /* 2036935 */     GIR_EraseRootFromParent_Done,
     /* 2036936 */   // Label 27159: @2036936
     /* 2036936 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2037027), // Rule ID 14984 //
     /* 2036941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036987 */     // MIs[0] round
     /* 2036987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036990 */     // MIs[0] policy
     /* 2036990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037026 */     // GIR_Coverage, 14984,
     /* 2037026 */     GIR_EraseRootFromParent_Done,
     /* 2037027 */   // Label 27160: @2037027
     /* 2037027 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2037118), // Rule ID 14985 //
     /* 2037032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2037052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037078 */     // MIs[0] round
     /* 2037078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037081 */     // MIs[0] policy
     /* 2037081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037091 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037117 */     // GIR_Coverage, 14985,
     /* 2037117 */     GIR_EraseRootFromParent_Done,
     /* 2037118 */   // Label 27161: @2037118
     /* 2037118 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2037209), // Rule ID 14988 //
     /* 2037123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037169 */     // MIs[0] round
     /* 2037169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037172 */     // MIs[0] policy
     /* 2037172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037208 */     // GIR_Coverage, 14988,
     /* 2037208 */     GIR_EraseRootFromParent_Done,
     /* 2037209 */   // Label 27162: @2037209
     /* 2037209 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2037300), // Rule ID 14989 //
     /* 2037214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037260 */     // MIs[0] round
     /* 2037260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037263 */     // MIs[0] policy
     /* 2037263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037299 */     // GIR_Coverage, 14989,
     /* 2037299 */     GIR_EraseRootFromParent_Done,
     /* 2037300 */   // Label 27163: @2037300
     /* 2037300 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2037391), // Rule ID 14992 //
     /* 2037305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037351 */     // MIs[0] round
     /* 2037351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037354 */     // MIs[0] policy
     /* 2037354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037390 */     // GIR_Coverage, 14992,
     /* 2037390 */     GIR_EraseRootFromParent_Done,
     /* 2037391 */   // Label 27164: @2037391
     /* 2037391 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2037482), // Rule ID 14993 //
     /* 2037396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037442 */     // MIs[0] round
     /* 2037442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037445 */     // MIs[0] policy
     /* 2037445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037455 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037481 */     // GIR_Coverage, 14993,
     /* 2037481 */     GIR_EraseRootFromParent_Done,
     /* 2037482 */   // Label 27165: @2037482
     /* 2037482 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2037573), // Rule ID 14996 //
     /* 2037487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037533 */     // MIs[0] round
     /* 2037533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037536 */     // MIs[0] policy
     /* 2037536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037572 */     // GIR_Coverage, 14996,
     /* 2037572 */     GIR_EraseRootFromParent_Done,
     /* 2037573 */   // Label 27166: @2037573
     /* 2037573 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2037664), // Rule ID 14997 //
     /* 2037578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037624 */     // MIs[0] round
     /* 2037624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037627 */     // MIs[0] policy
     /* 2037627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037637 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037663 */     // GIR_Coverage, 14997,
     /* 2037663 */     GIR_EraseRootFromParent_Done,
     /* 2037664 */   // Label 27167: @2037664
     /* 2037664 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2037755), // Rule ID 15000 //
     /* 2037669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037715 */     // MIs[0] round
     /* 2037715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037718 */     // MIs[0] policy
     /* 2037718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037754 */     // GIR_Coverage, 15000,
     /* 2037754 */     GIR_EraseRootFromParent_Done,
     /* 2037755 */   // Label 27168: @2037755
     /* 2037755 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2037846), // Rule ID 15001 //
     /* 2037760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037806 */     // MIs[0] round
     /* 2037806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037809 */     // MIs[0] policy
     /* 2037809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037845 */     // GIR_Coverage, 15001,
     /* 2037845 */     GIR_EraseRootFromParent_Done,
     /* 2037846 */   // Label 27169: @2037846
     /* 2037846 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2037937), // Rule ID 15004 //
     /* 2037851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037897 */     // MIs[0] round
     /* 2037897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037900 */     // MIs[0] policy
     /* 2037900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037936 */     // GIR_Coverage, 15004,
     /* 2037936 */     GIR_EraseRootFromParent_Done,
     /* 2037937 */   // Label 27170: @2037937
     /* 2037937 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2038028), // Rule ID 15005 //
     /* 2037942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037988 */     // MIs[0] round
     /* 2037988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037991 */     // MIs[0] policy
     /* 2037991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038001 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038027 */     // GIR_Coverage, 15005,
     /* 2038027 */     GIR_EraseRootFromParent_Done,
     /* 2038028 */   // Label 27171: @2038028
     /* 2038028 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2038119), // Rule ID 15008 //
     /* 2038033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038079 */     // MIs[0] round
     /* 2038079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038082 */     // MIs[0] policy
     /* 2038082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038118 */     // GIR_Coverage, 15008,
     /* 2038118 */     GIR_EraseRootFromParent_Done,
     /* 2038119 */   // Label 27172: @2038119
     /* 2038119 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2038210), // Rule ID 15009 //
     /* 2038124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038170 */     // MIs[0] round
     /* 2038170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038173 */     // MIs[0] policy
     /* 2038173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038183 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038209 */     // GIR_Coverage, 15009,
     /* 2038209 */     GIR_EraseRootFromParent_Done,
     /* 2038210 */   // Label 27173: @2038210
     /* 2038210 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2038301), // Rule ID 15012 //
     /* 2038215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038261 */     // MIs[0] round
     /* 2038261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038264 */     // MIs[0] policy
     /* 2038264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2038277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038300 */     // GIR_Coverage, 15012,
     /* 2038300 */     GIR_EraseRootFromParent_Done,
     /* 2038301 */   // Label 27174: @2038301
     /* 2038301 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2038392), // Rule ID 15013 //
     /* 2038306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038352 */     // MIs[0] round
     /* 2038352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038355 */     // MIs[0] policy
     /* 2038355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2038368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038391 */     // GIR_Coverage, 15013,
     /* 2038391 */     GIR_EraseRootFromParent_Done,
     /* 2038392 */   // Label 27175: @2038392
     /* 2038392 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2038483), // Rule ID 15016 //
     /* 2038397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038443 */     // MIs[0] round
     /* 2038443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038446 */     // MIs[0] policy
     /* 2038446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038456 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038482 */     // GIR_Coverage, 15016,
     /* 2038482 */     GIR_EraseRootFromParent_Done,
     /* 2038483 */   // Label 27176: @2038483
     /* 2038483 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2038574), // Rule ID 15017 //
     /* 2038488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038534 */     // MIs[0] round
     /* 2038534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038537 */     // MIs[0] policy
     /* 2038537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038547 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038573 */     // GIR_Coverage, 15017,
     /* 2038573 */     GIR_EraseRootFromParent_Done,
     /* 2038574 */   // Label 27177: @2038574
     /* 2038574 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2038665), // Rule ID 15020 //
     /* 2038579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038625 */     // MIs[0] round
     /* 2038625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038628 */     // MIs[0] policy
     /* 2038628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038638 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038664 */     // GIR_Coverage, 15020,
     /* 2038664 */     GIR_EraseRootFromParent_Done,
     /* 2038665 */   // Label 27178: @2038665
     /* 2038665 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2038756), // Rule ID 15021 //
     /* 2038670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038716 */     // MIs[0] round
     /* 2038716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038719 */     // MIs[0] policy
     /* 2038719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038729 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038755 */     // GIR_Coverage, 15021,
     /* 2038755 */     GIR_EraseRootFromParent_Done,
     /* 2038756 */   // Label 27179: @2038756
     /* 2038756 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2038847), // Rule ID 15024 //
     /* 2038761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038807 */     // MIs[0] round
     /* 2038807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038810 */     // MIs[0] policy
     /* 2038810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038820 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038846 */     // GIR_Coverage, 15024,
     /* 2038846 */     GIR_EraseRootFromParent_Done,
     /* 2038847 */   // Label 27180: @2038847
     /* 2038847 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2038938), // Rule ID 15025 //
     /* 2038852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038898 */     // MIs[0] round
     /* 2038898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038901 */     // MIs[0] policy
     /* 2038901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038911 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038937 */     // GIR_Coverage, 15025,
     /* 2038937 */     GIR_EraseRootFromParent_Done,
     /* 2038938 */   // Label 27181: @2038938
     /* 2038938 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2039029), // Rule ID 15028 //
     /* 2038943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038989 */     // MIs[0] round
     /* 2038989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038992 */     // MIs[0] policy
     /* 2038992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039028 */     // GIR_Coverage, 15028,
     /* 2039028 */     GIR_EraseRootFromParent_Done,
     /* 2039029 */   // Label 27182: @2039029
     /* 2039029 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2039120), // Rule ID 15029 //
     /* 2039034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039080 */     // MIs[0] round
     /* 2039080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039083 */     // MIs[0] policy
     /* 2039083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039119 */     // GIR_Coverage, 15029,
     /* 2039119 */     GIR_EraseRootFromParent_Done,
     /* 2039120 */   // Label 27183: @2039120
     /* 2039120 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2039211), // Rule ID 15032 //
     /* 2039125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039171 */     // MIs[0] round
     /* 2039171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039174 */     // MIs[0] policy
     /* 2039174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039210 */     // GIR_Coverage, 15032,
     /* 2039210 */     GIR_EraseRootFromParent_Done,
     /* 2039211 */   // Label 27184: @2039211
     /* 2039211 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2039302), // Rule ID 15033 //
     /* 2039216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039262 */     // MIs[0] round
     /* 2039262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039265 */     // MIs[0] policy
     /* 2039265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039275 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039301 */     // GIR_Coverage, 15033,
     /* 2039301 */     GIR_EraseRootFromParent_Done,
     /* 2039302 */   // Label 27185: @2039302
     /* 2039302 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2039393), // Rule ID 15036 //
     /* 2039307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039353 */     // MIs[0] round
     /* 2039353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039356 */     // MIs[0] policy
     /* 2039356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039392 */     // GIR_Coverage, 15036,
     /* 2039392 */     GIR_EraseRootFromParent_Done,
     /* 2039393 */   // Label 27186: @2039393
     /* 2039393 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2039484), // Rule ID 15037 //
     /* 2039398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039444 */     // MIs[0] round
     /* 2039444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039447 */     // MIs[0] policy
     /* 2039447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039457 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2039460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039483 */     // GIR_Coverage, 15037,
     /* 2039483 */     GIR_EraseRootFromParent_Done,
     /* 2039484 */   // Label 27187: @2039484
     /* 2039484 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2039575), // Rule ID 15040 //
     /* 2039489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039535 */     // MIs[0] round
     /* 2039535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039538 */     // MIs[0] policy
     /* 2039538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039574 */     // GIR_Coverage, 15040,
     /* 2039574 */     GIR_EraseRootFromParent_Done,
     /* 2039575 */   // Label 27188: @2039575
     /* 2039575 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2039666), // Rule ID 15041 //
     /* 2039580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039626 */     // MIs[0] round
     /* 2039626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039629 */     // MIs[0] policy
     /* 2039629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039665 */     // GIR_Coverage, 15041,
     /* 2039665 */     GIR_EraseRootFromParent_Done,
     /* 2039666 */   // Label 27189: @2039666
     /* 2039666 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2039757), // Rule ID 15044 //
     /* 2039671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039717 */     // MIs[0] round
     /* 2039717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039720 */     // MIs[0] policy
     /* 2039720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039756 */     // GIR_Coverage, 15044,
     /* 2039756 */     GIR_EraseRootFromParent_Done,
     /* 2039757 */   // Label 27190: @2039757
     /* 2039757 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2039848), // Rule ID 15045 //
     /* 2039762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039808 */     // MIs[0] round
     /* 2039808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039811 */     // MIs[0] policy
     /* 2039811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039847 */     // GIR_Coverage, 15045,
     /* 2039847 */     GIR_EraseRootFromParent_Done,
     /* 2039848 */   // Label 27191: @2039848
     /* 2039848 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2039939), // Rule ID 15048 //
     /* 2039853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039899 */     // MIs[0] round
     /* 2039899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039902 */     // MIs[0] policy
     /* 2039902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039938 */     // GIR_Coverage, 15048,
     /* 2039938 */     GIR_EraseRootFromParent_Done,
     /* 2039939 */   // Label 27192: @2039939
     /* 2039939 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2040030), // Rule ID 15049 //
     /* 2039944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039990 */     // MIs[0] round
     /* 2039990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039993 */     // MIs[0] policy
     /* 2039993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040003 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11197:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040029 */     // GIR_Coverage, 15049,
     /* 2040029 */     GIR_EraseRootFromParent_Done,
     /* 2040030 */   // Label 27193: @2040030
     /* 2040030 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2040121), // Rule ID 15052 //
     /* 2040035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040081 */     // MIs[0] round
     /* 2040081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040084 */     // MIs[0] policy
     /* 2040084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040120 */     // GIR_Coverage, 15052,
     /* 2040120 */     GIR_EraseRootFromParent_Done,
     /* 2040121 */   // Label 27194: @2040121
     /* 2040121 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2040212), // Rule ID 15053 //
     /* 2040126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040172 */     // MIs[0] round
     /* 2040172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040175 */     // MIs[0] policy
     /* 2040175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040185 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040211 */     // GIR_Coverage, 15053,
     /* 2040211 */     GIR_EraseRootFromParent_Done,
     /* 2040212 */   // Label 27195: @2040212
     /* 2040212 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2040303), // Rule ID 15056 //
     /* 2040217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040263 */     // MIs[0] round
     /* 2040263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040266 */     // MIs[0] policy
     /* 2040266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040302 */     // GIR_Coverage, 15056,
     /* 2040302 */     GIR_EraseRootFromParent_Done,
     /* 2040303 */   // Label 27196: @2040303
     /* 2040303 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2040394), // Rule ID 15057 //
     /* 2040308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040354 */     // MIs[0] round
     /* 2040354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040357 */     // MIs[0] policy
     /* 2040357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040367 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040393 */     // GIR_Coverage, 15057,
     /* 2040393 */     GIR_EraseRootFromParent_Done,
     /* 2040394 */   // Label 27197: @2040394
     /* 2040394 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2040485), // Rule ID 15060 //
     /* 2040399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2040402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040445 */     // MIs[0] round
     /* 2040445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040448 */     // MIs[0] policy
     /* 2040448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040484 */     // GIR_Coverage, 15060,
     /* 2040484 */     GIR_EraseRootFromParent_Done,
     /* 2040485 */   // Label 27198: @2040485
     /* 2040485 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2040576), // Rule ID 15061 //
     /* 2040490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2040493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040536 */     // MIs[0] round
     /* 2040536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040539 */     // MIs[0] policy
     /* 2040539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040575 */     // GIR_Coverage, 15061,
     /* 2040575 */     GIR_EraseRootFromParent_Done,
     /* 2040576 */   // Label 27199: @2040576
     /* 2040576 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2040667), // Rule ID 15064 //
     /* 2040581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040627 */     // MIs[0] round
     /* 2040627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040630 */     // MIs[0] policy
     /* 2040630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040666 */     // GIR_Coverage, 15064,
     /* 2040666 */     GIR_EraseRootFromParent_Done,
     /* 2040667 */   // Label 27200: @2040667
     /* 2040667 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2040758), // Rule ID 15065 //
     /* 2040672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040718 */     // MIs[0] round
     /* 2040718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040721 */     // MIs[0] policy
     /* 2040721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040731 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040757 */     // GIR_Coverage, 15065,
     /* 2040757 */     GIR_EraseRootFromParent_Done,
     /* 2040758 */   // Label 27201: @2040758
     /* 2040758 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2040849), // Rule ID 15068 //
     /* 2040763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040809 */     // MIs[0] round
     /* 2040809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040812 */     // MIs[0] policy
     /* 2040812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040848 */     // GIR_Coverage, 15068,
     /* 2040848 */     GIR_EraseRootFromParent_Done,
     /* 2040849 */   // Label 27202: @2040849
     /* 2040849 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2040940), // Rule ID 15069 //
     /* 2040854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040900 */     // MIs[0] round
     /* 2040900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040903 */     // MIs[0] policy
     /* 2040903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040913 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040939 */     // GIR_Coverage, 15069,
     /* 2040939 */     GIR_EraseRootFromParent_Done,
     /* 2040940 */   // Label 27203: @2040940
     /* 2040940 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2041031), // Rule ID 15072 //
     /* 2040945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040991 */     // MIs[0] round
     /* 2040991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040994 */     // MIs[0] policy
     /* 2040994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041004 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041030 */     // GIR_Coverage, 15072,
     /* 2041030 */     GIR_EraseRootFromParent_Done,
     /* 2041031 */   // Label 27204: @2041031
     /* 2041031 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2041122), // Rule ID 15073 //
     /* 2041036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041082 */     // MIs[0] round
     /* 2041082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041085 */     // MIs[0] policy
     /* 2041085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041095 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041121 */     // GIR_Coverage, 15073,
     /* 2041121 */     GIR_EraseRootFromParent_Done,
     /* 2041122 */   // Label 27205: @2041122
     /* 2041122 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2041213), // Rule ID 15076 //
     /* 2041127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041173 */     // MIs[0] round
     /* 2041173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041176 */     // MIs[0] policy
     /* 2041176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041212 */     // GIR_Coverage, 15076,
     /* 2041212 */     GIR_EraseRootFromParent_Done,
     /* 2041213 */   // Label 27206: @2041213
     /* 2041213 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2041304), // Rule ID 15077 //
     /* 2041218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041264 */     // MIs[0] round
     /* 2041264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041267 */     // MIs[0] policy
     /* 2041267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041303 */     // GIR_Coverage, 15077,
     /* 2041303 */     GIR_EraseRootFromParent_Done,
     /* 2041304 */   // Label 27207: @2041304
     /* 2041304 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2041395), // Rule ID 15080 //
     /* 2041309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041355 */     // MIs[0] round
     /* 2041355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041358 */     // MIs[0] policy
     /* 2041358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041394 */     // GIR_Coverage, 15080,
     /* 2041394 */     GIR_EraseRootFromParent_Done,
     /* 2041395 */   // Label 27208: @2041395
     /* 2041395 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2041486), // Rule ID 15081 //
     /* 2041400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041446 */     // MIs[0] round
     /* 2041446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041449 */     // MIs[0] policy
     /* 2041449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041485 */     // GIR_Coverage, 15081,
     /* 2041485 */     GIR_EraseRootFromParent_Done,
     /* 2041486 */   // Label 27209: @2041486
     /* 2041486 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2041577), // Rule ID 15084 //
     /* 2041491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041537 */     // MIs[0] round
     /* 2041537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041540 */     // MIs[0] policy
     /* 2041540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041576 */     // GIR_Coverage, 15084,
     /* 2041576 */     GIR_EraseRootFromParent_Done,
     /* 2041577 */   // Label 27210: @2041577
     /* 2041577 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2041668), // Rule ID 15085 //
     /* 2041582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041628 */     // MIs[0] round
     /* 2041628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041631 */     // MIs[0] policy
     /* 2041631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041641 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041667 */     // GIR_Coverage, 15085,
     /* 2041667 */     GIR_EraseRootFromParent_Done,
     /* 2041668 */   // Label 27211: @2041668
     /* 2041668 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2041759), // Rule ID 15088 //
     /* 2041673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041719 */     // MIs[0] round
     /* 2041719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041722 */     // MIs[0] policy
     /* 2041722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041758 */     // GIR_Coverage, 15088,
     /* 2041758 */     GIR_EraseRootFromParent_Done,
     /* 2041759 */   // Label 27212: @2041759
     /* 2041759 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2041850), // Rule ID 15089 //
     /* 2041764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041810 */     // MIs[0] round
     /* 2041810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041813 */     // MIs[0] policy
     /* 2041813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041823 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041849 */     // GIR_Coverage, 15089,
     /* 2041849 */     GIR_EraseRootFromParent_Done,
     /* 2041850 */   // Label 27213: @2041850
     /* 2041850 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2041941), // Rule ID 15092 //
     /* 2041855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041901 */     // MIs[0] round
     /* 2041901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041904 */     // MIs[0] policy
     /* 2041904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041940 */     // GIR_Coverage, 15092,
     /* 2041940 */     GIR_EraseRootFromParent_Done,
     /* 2041941 */   // Label 27214: @2041941
     /* 2041941 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2042032), // Rule ID 15093 //
     /* 2041946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041992 */     // MIs[0] round
     /* 2041992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041995 */     // MIs[0] policy
     /* 2041995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042005 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042031 */     // GIR_Coverage, 15093,
     /* 2042031 */     GIR_EraseRootFromParent_Done,
     /* 2042032 */   // Label 27215: @2042032
     /* 2042032 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2042123), // Rule ID 15096 //
     /* 2042037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042083 */     // MIs[0] round
     /* 2042083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042086 */     // MIs[0] policy
     /* 2042086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042122 */     // GIR_Coverage, 15096,
     /* 2042122 */     GIR_EraseRootFromParent_Done,
     /* 2042123 */   // Label 27216: @2042123
     /* 2042123 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2042214), // Rule ID 15097 //
     /* 2042128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042174 */     // MIs[0] round
     /* 2042174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042177 */     // MIs[0] policy
     /* 2042177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042187 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042213 */     // GIR_Coverage, 15097,
     /* 2042213 */     GIR_EraseRootFromParent_Done,
     /* 2042214 */   // Label 27217: @2042214
     /* 2042214 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2042305), // Rule ID 15100 //
     /* 2042219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042265 */     // MIs[0] round
     /* 2042265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042268 */     // MIs[0] policy
     /* 2042268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2042281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042304 */     // GIR_Coverage, 15100,
     /* 2042304 */     GIR_EraseRootFromParent_Done,
     /* 2042305 */   // Label 27218: @2042305
     /* 2042305 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2042396), // Rule ID 15101 //
     /* 2042310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042356 */     // MIs[0] round
     /* 2042356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042359 */     // MIs[0] policy
     /* 2042359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2042372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042395 */     // GIR_Coverage, 15101,
     /* 2042395 */     GIR_EraseRootFromParent_Done,
     /* 2042396 */   // Label 27219: @2042396
     /* 2042396 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2042487), // Rule ID 15104 //
     /* 2042401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042447 */     // MIs[0] round
     /* 2042447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042450 */     // MIs[0] policy
     /* 2042450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042486 */     // GIR_Coverage, 15104,
     /* 2042486 */     GIR_EraseRootFromParent_Done,
     /* 2042487 */   // Label 27220: @2042487
     /* 2042487 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2042578), // Rule ID 15105 //
     /* 2042492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042538 */     // MIs[0] round
     /* 2042538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042541 */     // MIs[0] policy
     /* 2042541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042577 */     // GIR_Coverage, 15105,
     /* 2042577 */     GIR_EraseRootFromParent_Done,
     /* 2042578 */   // Label 27221: @2042578
     /* 2042578 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2042669), // Rule ID 15108 //
     /* 2042583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042629 */     // MIs[0] round
     /* 2042629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042632 */     // MIs[0] policy
     /* 2042632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042668 */     // GIR_Coverage, 15108,
     /* 2042668 */     GIR_EraseRootFromParent_Done,
     /* 2042669 */   // Label 27222: @2042669
     /* 2042669 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2042760), // Rule ID 15109 //
     /* 2042674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042720 */     // MIs[0] round
     /* 2042720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042723 */     // MIs[0] policy
     /* 2042723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042733 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042759 */     // GIR_Coverage, 15109,
     /* 2042759 */     GIR_EraseRootFromParent_Done,
     /* 2042760 */   // Label 27223: @2042760
     /* 2042760 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2042851), // Rule ID 15112 //
     /* 2042765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042811 */     // MIs[0] round
     /* 2042811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042814 */     // MIs[0] policy
     /* 2042814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042824 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042850 */     // GIR_Coverage, 15112,
     /* 2042850 */     GIR_EraseRootFromParent_Done,
     /* 2042851 */   // Label 27224: @2042851
     /* 2042851 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2042942), // Rule ID 15113 //
     /* 2042856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042902 */     // MIs[0] round
     /* 2042902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042905 */     // MIs[0] policy
     /* 2042905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042915 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042941 */     // GIR_Coverage, 15113,
     /* 2042941 */     GIR_EraseRootFromParent_Done,
     /* 2042942 */   // Label 27225: @2042942
     /* 2042942 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2043033), // Rule ID 15116 //
     /* 2042947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042993 */     // MIs[0] round
     /* 2042993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042996 */     // MIs[0] policy
     /* 2042996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043032 */     // GIR_Coverage, 15116,
     /* 2043032 */     GIR_EraseRootFromParent_Done,
     /* 2043033 */   // Label 27226: @2043033
     /* 2043033 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2043124), // Rule ID 15117 //
     /* 2043038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2043058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043084 */     // MIs[0] round
     /* 2043084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043087 */     // MIs[0] policy
     /* 2043087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043097 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043123 */     // GIR_Coverage, 15117,
     /* 2043123 */     GIR_EraseRootFromParent_Done,
     /* 2043124 */   // Label 27227: @2043124
     /* 2043124 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2043215), // Rule ID 15120 //
     /* 2043129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043175 */     // MIs[0] round
     /* 2043175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043178 */     // MIs[0] policy
     /* 2043178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043188 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043214 */     // GIR_Coverage, 15120,
     /* 2043214 */     GIR_EraseRootFromParent_Done,
     /* 2043215 */   // Label 27228: @2043215
     /* 2043215 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2043306), // Rule ID 15121 //
     /* 2043220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043266 */     // MIs[0] round
     /* 2043266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043269 */     // MIs[0] policy
     /* 2043269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043279 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043305 */     // GIR_Coverage, 15121,
     /* 2043305 */     GIR_EraseRootFromParent_Done,
     /* 2043306 */   // Label 27229: @2043306
     /* 2043306 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2043397), // Rule ID 15124 //
     /* 2043311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2043331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043357 */     // MIs[0] round
     /* 2043357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043360 */     // MIs[0] policy
     /* 2043360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043396 */     // GIR_Coverage, 15124,
     /* 2043396 */     GIR_EraseRootFromParent_Done,
     /* 2043397 */   // Label 27230: @2043397
     /* 2043397 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2043488), // Rule ID 15125 //
     /* 2043402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2043422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043448 */     // MIs[0] round
     /* 2043448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043451 */     // MIs[0] policy
     /* 2043451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043461 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2043464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043487 */     // GIR_Coverage, 15125,
     /* 2043487 */     GIR_EraseRootFromParent_Done,
     /* 2043488 */   // Label 27231: @2043488
     /* 2043488 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2043579), // Rule ID 15128 //
     /* 2043493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043539 */     // MIs[0] round
     /* 2043539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043542 */     // MIs[0] policy
     /* 2043542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043578 */     // GIR_Coverage, 15128,
     /* 2043578 */     GIR_EraseRootFromParent_Done,
     /* 2043579 */   // Label 27232: @2043579
     /* 2043579 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2043670), // Rule ID 15129 //
     /* 2043584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043630 */     // MIs[0] round
     /* 2043630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043633 */     // MIs[0] policy
     /* 2043633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043643 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043669 */     // GIR_Coverage, 15129,
     /* 2043669 */     GIR_EraseRootFromParent_Done,
     /* 2043670 */   // Label 27233: @2043670
     /* 2043670 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2043761), // Rule ID 15132 //
     /* 2043675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043721 */     // MIs[0] round
     /* 2043721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043724 */     // MIs[0] policy
     /* 2043724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043760 */     // GIR_Coverage, 15132,
     /* 2043760 */     GIR_EraseRootFromParent_Done,
     /* 2043761 */   // Label 27234: @2043761
     /* 2043761 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2043852), // Rule ID 15133 //
     /* 2043766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043812 */     // MIs[0] round
     /* 2043812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043815 */     // MIs[0] policy
     /* 2043815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043825 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043851 */     // GIR_Coverage, 15133,
     /* 2043851 */     GIR_EraseRootFromParent_Done,
     /* 2043852 */   // Label 27235: @2043852
     /* 2043852 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2043943), // Rule ID 15136 //
     /* 2043857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043903 */     // MIs[0] round
     /* 2043903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043906 */     // MIs[0] policy
     /* 2043906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043942 */     // GIR_Coverage, 15136,
     /* 2043942 */     GIR_EraseRootFromParent_Done,
     /* 2043943 */   // Label 27236: @2043943
     /* 2043943 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2044034), // Rule ID 15137 //
     /* 2043948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043994 */     // MIs[0] round
     /* 2043994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043997 */     // MIs[0] policy
     /* 2043997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044007 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044033 */     // GIR_Coverage, 15137,
     /* 2044033 */     GIR_EraseRootFromParent_Done,
     /* 2044034 */   // Label 27237: @2044034
     /* 2044034 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2044125), // Rule ID 15140 //
     /* 2044039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044085 */     // MIs[0] round
     /* 2044085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044088 */     // MIs[0] policy
     /* 2044088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044124 */     // GIR_Coverage, 15140,
     /* 2044124 */     GIR_EraseRootFromParent_Done,
     /* 2044125 */   // Label 27238: @2044125
     /* 2044125 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2044216), // Rule ID 15141 //
     /* 2044130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044176 */     // MIs[0] round
     /* 2044176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044179 */     // MIs[0] policy
     /* 2044179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044215 */     // GIR_Coverage, 15141,
     /* 2044215 */     GIR_EraseRootFromParent_Done,
     /* 2044216 */   // Label 27239: @2044216
     /* 2044216 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2044307), // Rule ID 15144 //
     /* 2044221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044267 */     // MIs[0] round
     /* 2044267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044270 */     // MIs[0] policy
     /* 2044270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044306 */     // GIR_Coverage, 15144,
     /* 2044306 */     GIR_EraseRootFromParent_Done,
     /* 2044307 */   // Label 27240: @2044307
     /* 2044307 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2044398), // Rule ID 15145 //
     /* 2044312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044358 */     // MIs[0] round
     /* 2044358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044361 */     // MIs[0] policy
     /* 2044361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044397 */     // GIR_Coverage, 15145,
     /* 2044397 */     GIR_EraseRootFromParent_Done,
     /* 2044398 */   // Label 27241: @2044398
     /* 2044398 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2044489), // Rule ID 15148 //
     /* 2044403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2044406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044449 */     // MIs[0] round
     /* 2044449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044452 */     // MIs[0] policy
     /* 2044452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044462 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044488 */     // GIR_Coverage, 15148,
     /* 2044488 */     GIR_EraseRootFromParent_Done,
     /* 2044489 */   // Label 27242: @2044489
     /* 2044489 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2044580), // Rule ID 15149 //
     /* 2044494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2044497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044540 */     // MIs[0] round
     /* 2044540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044543 */     // MIs[0] policy
     /* 2044543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044579 */     // GIR_Coverage, 15149,
     /* 2044579 */     GIR_EraseRootFromParent_Done,
     /* 2044580 */   // Label 27243: @2044580
     /* 2044580 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2044671), // Rule ID 15152 //
     /* 2044585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044631 */     // MIs[0] round
     /* 2044631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044634 */     // MIs[0] policy
     /* 2044634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044670 */     // GIR_Coverage, 15152,
     /* 2044670 */     GIR_EraseRootFromParent_Done,
     /* 2044671 */   // Label 27244: @2044671
     /* 2044671 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2044762), // Rule ID 15153 //
     /* 2044676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044722 */     // MIs[0] round
     /* 2044722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044725 */     // MIs[0] policy
     /* 2044725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044761 */     // GIR_Coverage, 15153,
     /* 2044761 */     GIR_EraseRootFromParent_Done,
     /* 2044762 */   // Label 27245: @2044762
     /* 2044762 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2044853), // Rule ID 15156 //
     /* 2044767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044813 */     // MIs[0] round
     /* 2044813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044816 */     // MIs[0] policy
     /* 2044816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044852 */     // GIR_Coverage, 15156,
     /* 2044852 */     GIR_EraseRootFromParent_Done,
     /* 2044853 */   // Label 27246: @2044853
     /* 2044853 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2044944), // Rule ID 15157 //
     /* 2044858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044904 */     // MIs[0] round
     /* 2044904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044907 */     // MIs[0] policy
     /* 2044907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044917 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044943 */     // GIR_Coverage, 15157,
     /* 2044943 */     GIR_EraseRootFromParent_Done,
     /* 2044944 */   // Label 27247: @2044944
     /* 2044944 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2045035), // Rule ID 15160 //
     /* 2044949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044995 */     // MIs[0] round
     /* 2044995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044998 */     // MIs[0] policy
     /* 2044998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045034 */     // GIR_Coverage, 15160,
     /* 2045034 */     GIR_EraseRootFromParent_Done,
     /* 2045035 */   // Label 27248: @2045035
     /* 2045035 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2045126), // Rule ID 15161 //
     /* 2045040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2045060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045086 */     // MIs[0] round
     /* 2045086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045089 */     // MIs[0] policy
     /* 2045089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045125 */     // GIR_Coverage, 15161,
     /* 2045125 */     GIR_EraseRootFromParent_Done,
     /* 2045126 */   // Label 27249: @2045126
     /* 2045126 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2045217), // Rule ID 15164 //
     /* 2045131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045177 */     // MIs[0] round
     /* 2045177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045180 */     // MIs[0] policy
     /* 2045180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045216 */     // GIR_Coverage, 15164,
     /* 2045216 */     GIR_EraseRootFromParent_Done,
     /* 2045217 */   // Label 27250: @2045217
     /* 2045217 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2045308), // Rule ID 15165 //
     /* 2045222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045268 */     // MIs[0] round
     /* 2045268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045271 */     // MIs[0] policy
     /* 2045271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045307 */     // GIR_Coverage, 15165,
     /* 2045307 */     GIR_EraseRootFromParent_Done,
     /* 2045308 */   // Label 27251: @2045308
     /* 2045308 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2045399), // Rule ID 15168 //
     /* 2045313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2045333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045359 */     // MIs[0] round
     /* 2045359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045362 */     // MIs[0] policy
     /* 2045362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045372 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045398 */     // GIR_Coverage, 15168,
     /* 2045398 */     GIR_EraseRootFromParent_Done,
     /* 2045399 */   // Label 27252: @2045399
     /* 2045399 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2045490), // Rule ID 15169 //
     /* 2045404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2045424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045450 */     // MIs[0] round
     /* 2045450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045453 */     // MIs[0] policy
     /* 2045453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045463 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045489 */     // GIR_Coverage, 15169,
     /* 2045489 */     GIR_EraseRootFromParent_Done,
     /* 2045490 */   // Label 27253: @2045490
     /* 2045490 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2045581), // Rule ID 15172 //
     /* 2045495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045541 */     // MIs[0] round
     /* 2045541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045544 */     // MIs[0] policy
     /* 2045544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045580 */     // GIR_Coverage, 15172,
     /* 2045580 */     GIR_EraseRootFromParent_Done,
     /* 2045581 */   // Label 27254: @2045581
     /* 2045581 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2045672), // Rule ID 15173 //
     /* 2045586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045632 */     // MIs[0] round
     /* 2045632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045635 */     // MIs[0] policy
     /* 2045635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045645 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045671 */     // GIR_Coverage, 15173,
     /* 2045671 */     GIR_EraseRootFromParent_Done,
     /* 2045672 */   // Label 27255: @2045672
     /* 2045672 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2045763), // Rule ID 15176 //
     /* 2045677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045723 */     // MIs[0] round
     /* 2045723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045726 */     // MIs[0] policy
     /* 2045726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045762 */     // GIR_Coverage, 15176,
     /* 2045762 */     GIR_EraseRootFromParent_Done,
     /* 2045763 */   // Label 27256: @2045763
     /* 2045763 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2045854), // Rule ID 15177 //
     /* 2045768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045814 */     // MIs[0] round
     /* 2045814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045817 */     // MIs[0] policy
     /* 2045817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045853 */     // GIR_Coverage, 15177,
     /* 2045853 */     GIR_EraseRootFromParent_Done,
     /* 2045854 */   // Label 27257: @2045854
     /* 2045854 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2045945), // Rule ID 15180 //
     /* 2045859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045905 */     // MIs[0] round
     /* 2045905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045908 */     // MIs[0] policy
     /* 2045908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045944 */     // GIR_Coverage, 15180,
     /* 2045944 */     GIR_EraseRootFromParent_Done,
     /* 2045945 */   // Label 27258: @2045945
     /* 2045945 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2046036), // Rule ID 15181 //
     /* 2045950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045996 */     // MIs[0] round
     /* 2045996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045999 */     // MIs[0] policy
     /* 2045999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046035 */     // GIR_Coverage, 15181,
     /* 2046035 */     GIR_EraseRootFromParent_Done,
     /* 2046036 */   // Label 27259: @2046036
     /* 2046036 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2046127), // Rule ID 15184 //
     /* 2046041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046087 */     // MIs[0] round
     /* 2046087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046090 */     // MIs[0] policy
     /* 2046090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046126 */     // GIR_Coverage, 15184,
     /* 2046126 */     GIR_EraseRootFromParent_Done,
     /* 2046127 */   // Label 27260: @2046127
     /* 2046127 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2046218), // Rule ID 15185 //
     /* 2046132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046178 */     // MIs[0] round
     /* 2046178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046181 */     // MIs[0] policy
     /* 2046181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046191 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046217 */     // GIR_Coverage, 15185,
     /* 2046217 */     GIR_EraseRootFromParent_Done,
     /* 2046218 */   // Label 27261: @2046218
     /* 2046218 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2046309), // Rule ID 15188 //
     /* 2046223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046269 */     // MIs[0] round
     /* 2046269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046272 */     // MIs[0] policy
     /* 2046272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2046285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046308 */     // GIR_Coverage, 15188,
     /* 2046308 */     GIR_EraseRootFromParent_Done,
     /* 2046309 */   // Label 27262: @2046309
     /* 2046309 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2046400), // Rule ID 15189 //
     /* 2046314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046360 */     // MIs[0] round
     /* 2046360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046363 */     // MIs[0] policy
     /* 2046363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046373 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2046376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046399 */     // GIR_Coverage, 15189,
     /* 2046399 */     GIR_EraseRootFromParent_Done,
     /* 2046400 */   // Label 27263: @2046400
     /* 2046400 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2046491), // Rule ID 15192 //
     /* 2046405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046451 */     // MIs[0] round
     /* 2046451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046454 */     // MIs[0] policy
     /* 2046454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046490 */     // GIR_Coverage, 15192,
     /* 2046490 */     GIR_EraseRootFromParent_Done,
     /* 2046491 */   // Label 27264: @2046491
     /* 2046491 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2046582), // Rule ID 15193 //
     /* 2046496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046542 */     // MIs[0] round
     /* 2046542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046545 */     // MIs[0] policy
     /* 2046545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046555 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046581 */     // GIR_Coverage, 15193,
     /* 2046581 */     GIR_EraseRootFromParent_Done,
     /* 2046582 */   // Label 27265: @2046582
     /* 2046582 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2046673), // Rule ID 15196 //
     /* 2046587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046633 */     // MIs[0] round
     /* 2046633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046636 */     // MIs[0] policy
     /* 2046636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046672 */     // GIR_Coverage, 15196,
     /* 2046672 */     GIR_EraseRootFromParent_Done,
     /* 2046673 */   // Label 27266: @2046673
     /* 2046673 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2046764), // Rule ID 15197 //
     /* 2046678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046724 */     // MIs[0] round
     /* 2046724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046727 */     // MIs[0] policy
     /* 2046727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046763 */     // GIR_Coverage, 15197,
     /* 2046763 */     GIR_EraseRootFromParent_Done,
     /* 2046764 */   // Label 27267: @2046764
     /* 2046764 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2046855), // Rule ID 15200 //
     /* 2046769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046815 */     // MIs[0] round
     /* 2046815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046818 */     // MIs[0] policy
     /* 2046818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046828 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046854 */     // GIR_Coverage, 15200,
     /* 2046854 */     GIR_EraseRootFromParent_Done,
     /* 2046855 */   // Label 27268: @2046855
     /* 2046855 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2046946), // Rule ID 15201 //
     /* 2046860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046906 */     // MIs[0] round
     /* 2046906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046909 */     // MIs[0] policy
     /* 2046909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046945 */     // GIR_Coverage, 15201,
     /* 2046945 */     GIR_EraseRootFromParent_Done,
     /* 2046946 */   // Label 27269: @2046946
     /* 2046946 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2047037), // Rule ID 15204 //
     /* 2046951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046997 */     // MIs[0] round
     /* 2046997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047000 */     // MIs[0] policy
     /* 2047000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047036 */     // GIR_Coverage, 15204,
     /* 2047036 */     GIR_EraseRootFromParent_Done,
     /* 2047037 */   // Label 27270: @2047037
     /* 2047037 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2047128), // Rule ID 15205 //
     /* 2047042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047088 */     // MIs[0] round
     /* 2047088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047091 */     // MIs[0] policy
     /* 2047091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047101 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047127 */     // GIR_Coverage, 15205,
     /* 2047127 */     GIR_EraseRootFromParent_Done,
     /* 2047128 */   // Label 27271: @2047128
     /* 2047128 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2047219), // Rule ID 15208 //
     /* 2047133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047179 */     // MIs[0] round
     /* 2047179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047182 */     // MIs[0] policy
     /* 2047182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047218 */     // GIR_Coverage, 15208,
     /* 2047218 */     GIR_EraseRootFromParent_Done,
     /* 2047219 */   // Label 27272: @2047219
     /* 2047219 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2047310), // Rule ID 15209 //
     /* 2047224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047270 */     // MIs[0] round
     /* 2047270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047273 */     // MIs[0] policy
     /* 2047273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047283 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047309 */     // GIR_Coverage, 15209,
     /* 2047309 */     GIR_EraseRootFromParent_Done,
     /* 2047310 */   // Label 27273: @2047310
     /* 2047310 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2047401), // Rule ID 15212 //
     /* 2047315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047361 */     // MIs[0] round
     /* 2047361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047364 */     // MIs[0] policy
     /* 2047364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047400 */     // GIR_Coverage, 15212,
     /* 2047400 */     GIR_EraseRootFromParent_Done,
     /* 2047401 */   // Label 27274: @2047401
     /* 2047401 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2047492), // Rule ID 15213 //
     /* 2047406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047452 */     // MIs[0] round
     /* 2047452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047455 */     // MIs[0] policy
     /* 2047455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047491 */     // GIR_Coverage, 15213,
     /* 2047491 */     GIR_EraseRootFromParent_Done,
     /* 2047492 */   // Label 27275: @2047492
     /* 2047492 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2047583), // Rule ID 15216 //
     /* 2047497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047543 */     // MIs[0] round
     /* 2047543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047546 */     // MIs[0] policy
     /* 2047546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047582 */     // GIR_Coverage, 15216,
     /* 2047582 */     GIR_EraseRootFromParent_Done,
     /* 2047583 */   // Label 27276: @2047583
     /* 2047583 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2047674), // Rule ID 15217 //
     /* 2047588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047634 */     // MIs[0] round
     /* 2047634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047637 */     // MIs[0] policy
     /* 2047637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047647 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047673 */     // GIR_Coverage, 15217,
     /* 2047673 */     GIR_EraseRootFromParent_Done,
     /* 2047674 */   // Label 27277: @2047674
     /* 2047674 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2047765), // Rule ID 15220 //
     /* 2047679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047725 */     // MIs[0] round
     /* 2047725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047728 */     // MIs[0] policy
     /* 2047728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047764 */     // GIR_Coverage, 15220,
     /* 2047764 */     GIR_EraseRootFromParent_Done,
     /* 2047765 */   // Label 27278: @2047765
     /* 2047765 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2047856), // Rule ID 15221 //
     /* 2047770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047816 */     // MIs[0] round
     /* 2047816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047819 */     // MIs[0] policy
     /* 2047819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047829 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047855 */     // GIR_Coverage, 15221,
     /* 2047855 */     GIR_EraseRootFromParent_Done,
     /* 2047856 */   // Label 27279: @2047856
     /* 2047856 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2047947), // Rule ID 15224 //
     /* 2047861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047907 */     // MIs[0] round
     /* 2047907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047910 */     // MIs[0] policy
     /* 2047910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047946 */     // GIR_Coverage, 15224,
     /* 2047946 */     GIR_EraseRootFromParent_Done,
     /* 2047947 */   // Label 27280: @2047947
     /* 2047947 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2048038), // Rule ID 15225 //
     /* 2047952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047998 */     // MIs[0] round
     /* 2047998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048001 */     // MIs[0] policy
     /* 2048001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11219:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048037 */     // GIR_Coverage, 15225,
     /* 2048037 */     GIR_EraseRootFromParent_Done,
     /* 2048038 */   // Label 27281: @2048038
     /* 2048038 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2048129), // Rule ID 15228 //
     /* 2048043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048089 */     // MIs[0] round
     /* 2048089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048092 */     // MIs[0] policy
     /* 2048092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048128 */     // GIR_Coverage, 15228,
     /* 2048128 */     GIR_EraseRootFromParent_Done,
     /* 2048129 */   // Label 27282: @2048129
     /* 2048129 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2048220), // Rule ID 15229 //
     /* 2048134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048180 */     // MIs[0] round
     /* 2048180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048183 */     // MIs[0] policy
     /* 2048183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048193 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048219 */     // GIR_Coverage, 15229,
     /* 2048219 */     GIR_EraseRootFromParent_Done,
     /* 2048220 */   // Label 27283: @2048220
     /* 2048220 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2048311), // Rule ID 15232 //
     /* 2048225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048271 */     // MIs[0] round
     /* 2048271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048274 */     // MIs[0] policy
     /* 2048274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048310 */     // GIR_Coverage, 15232,
     /* 2048310 */     GIR_EraseRootFromParent_Done,
     /* 2048311 */   // Label 27284: @2048311
     /* 2048311 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2048402), // Rule ID 15233 //
     /* 2048316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048362 */     // MIs[0] round
     /* 2048362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048365 */     // MIs[0] policy
     /* 2048365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048375 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048401 */     // GIR_Coverage, 15233,
     /* 2048401 */     GIR_EraseRootFromParent_Done,
     /* 2048402 */   // Label 27285: @2048402
     /* 2048402 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2048493), // Rule ID 15236 //
     /* 2048407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2048410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048453 */     // MIs[0] round
     /* 2048453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048456 */     // MIs[0] policy
     /* 2048456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048492 */     // GIR_Coverage, 15236,
     /* 2048492 */     GIR_EraseRootFromParent_Done,
     /* 2048493 */   // Label 27286: @2048493
     /* 2048493 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2048584), // Rule ID 15237 //
     /* 2048498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2048501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048544 */     // MIs[0] round
     /* 2048544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048547 */     // MIs[0] policy
     /* 2048547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048583 */     // GIR_Coverage, 15237,
     /* 2048583 */     GIR_EraseRootFromParent_Done,
     /* 2048584 */   // Label 27287: @2048584
     /* 2048584 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2048675), // Rule ID 15240 //
     /* 2048589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048635 */     // MIs[0] round
     /* 2048635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048638 */     // MIs[0] policy
     /* 2048638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048674 */     // GIR_Coverage, 15240,
     /* 2048674 */     GIR_EraseRootFromParent_Done,
     /* 2048675 */   // Label 27288: @2048675
     /* 2048675 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2048766), // Rule ID 15241 //
     /* 2048680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048726 */     // MIs[0] round
     /* 2048726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048729 */     // MIs[0] policy
     /* 2048729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048765 */     // GIR_Coverage, 15241,
     /* 2048765 */     GIR_EraseRootFromParent_Done,
     /* 2048766 */   // Label 27289: @2048766
     /* 2048766 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2048857), // Rule ID 15244 //
     /* 2048771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048817 */     // MIs[0] round
     /* 2048817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048820 */     // MIs[0] policy
     /* 2048820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048856 */     // GIR_Coverage, 15244,
     /* 2048856 */     GIR_EraseRootFromParent_Done,
     /* 2048857 */   // Label 27290: @2048857
     /* 2048857 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2048948), // Rule ID 15245 //
     /* 2048862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048908 */     // MIs[0] round
     /* 2048908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048911 */     // MIs[0] policy
     /* 2048911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048947 */     // GIR_Coverage, 15245,
     /* 2048947 */     GIR_EraseRootFromParent_Done,
     /* 2048948 */   // Label 27291: @2048948
     /* 2048948 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2049039), // Rule ID 15248 //
     /* 2048953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048999 */     // MIs[0] round
     /* 2048999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049002 */     // MIs[0] policy
     /* 2049002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049038 */     // GIR_Coverage, 15248,
     /* 2049038 */     GIR_EraseRootFromParent_Done,
     /* 2049039 */   // Label 27292: @2049039
     /* 2049039 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2049130), // Rule ID 15249 //
     /* 2049044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049090 */     // MIs[0] round
     /* 2049090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049093 */     // MIs[0] policy
     /* 2049093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049103 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049129 */     // GIR_Coverage, 15249,
     /* 2049129 */     GIR_EraseRootFromParent_Done,
     /* 2049130 */   // Label 27293: @2049130
     /* 2049130 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2049221), // Rule ID 15252 //
     /* 2049135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049181 */     // MIs[0] round
     /* 2049181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049184 */     // MIs[0] policy
     /* 2049184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049220 */     // GIR_Coverage, 15252,
     /* 2049220 */     GIR_EraseRootFromParent_Done,
     /* 2049221 */   // Label 27294: @2049221
     /* 2049221 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2049312), // Rule ID 15253 //
     /* 2049226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049272 */     // MIs[0] round
     /* 2049272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049275 */     // MIs[0] policy
     /* 2049275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049311 */     // GIR_Coverage, 15253,
     /* 2049311 */     GIR_EraseRootFromParent_Done,
     /* 2049312 */   // Label 27295: @2049312
     /* 2049312 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2049403), // Rule ID 15256 //
     /* 2049317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049363 */     // MIs[0] round
     /* 2049363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049366 */     // MIs[0] policy
     /* 2049366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049402 */     // GIR_Coverage, 15256,
     /* 2049402 */     GIR_EraseRootFromParent_Done,
     /* 2049403 */   // Label 27296: @2049403
     /* 2049403 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2049494), // Rule ID 15257 //
     /* 2049408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049454 */     // MIs[0] round
     /* 2049454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049457 */     // MIs[0] policy
     /* 2049457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049467 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049493 */     // GIR_Coverage, 15257,
     /* 2049493 */     GIR_EraseRootFromParent_Done,
     /* 2049494 */   // Label 27297: @2049494
     /* 2049494 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2049585), // Rule ID 15260 //
     /* 2049499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049545 */     // MIs[0] round
     /* 2049545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049548 */     // MIs[0] policy
     /* 2049548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049584 */     // GIR_Coverage, 15260,
     /* 2049584 */     GIR_EraseRootFromParent_Done,
     /* 2049585 */   // Label 27298: @2049585
     /* 2049585 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2049676), // Rule ID 15261 //
     /* 2049590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049636 */     // MIs[0] round
     /* 2049636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049639 */     // MIs[0] policy
     /* 2049639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049649 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049675 */     // GIR_Coverage, 15261,
     /* 2049675 */     GIR_EraseRootFromParent_Done,
     /* 2049676 */   // Label 27299: @2049676
     /* 2049676 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2049767), // Rule ID 15264 //
     /* 2049681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049727 */     // MIs[0] round
     /* 2049727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049730 */     // MIs[0] policy
     /* 2049730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049766 */     // GIR_Coverage, 15264,
     /* 2049766 */     GIR_EraseRootFromParent_Done,
     /* 2049767 */   // Label 27300: @2049767
     /* 2049767 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2049858), // Rule ID 15265 //
     /* 2049772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049818 */     // MIs[0] round
     /* 2049818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049821 */     // MIs[0] policy
     /* 2049821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049857 */     // GIR_Coverage, 15265,
     /* 2049857 */     GIR_EraseRootFromParent_Done,
     /* 2049858 */   // Label 27301: @2049858
     /* 2049858 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2049949), // Rule ID 15268 //
     /* 2049863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049909 */     // MIs[0] round
     /* 2049909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049912 */     // MIs[0] policy
     /* 2049912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049948 */     // GIR_Coverage, 15268,
     /* 2049948 */     GIR_EraseRootFromParent_Done,
     /* 2049949 */   // Label 27302: @2049949
     /* 2049949 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2050040), // Rule ID 15269 //
     /* 2049954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050000 */     // MIs[0] round
     /* 2050000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050003 */     // MIs[0] policy
     /* 2050003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050013 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050039 */     // GIR_Coverage, 15269,
     /* 2050039 */     GIR_EraseRootFromParent_Done,
     /* 2050040 */   // Label 27303: @2050040
     /* 2050040 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2050131), // Rule ID 15272 //
     /* 2050045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050091 */     // MIs[0] round
     /* 2050091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050094 */     // MIs[0] policy
     /* 2050094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050130 */     // GIR_Coverage, 15272,
     /* 2050130 */     GIR_EraseRootFromParent_Done,
     /* 2050131 */   // Label 27304: @2050131
     /* 2050131 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2050222), // Rule ID 15273 //
     /* 2050136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050182 */     // MIs[0] round
     /* 2050182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050185 */     // MIs[0] policy
     /* 2050185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050221 */     // GIR_Coverage, 15273,
     /* 2050221 */     GIR_EraseRootFromParent_Done,
     /* 2050222 */   // Label 27305: @2050222
     /* 2050222 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2050313), // Rule ID 15276 //
     /* 2050227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050273 */     // MIs[0] round
     /* 2050273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050276 */     // MIs[0] policy
     /* 2050276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2050289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050312 */     // GIR_Coverage, 15276,
     /* 2050312 */     GIR_EraseRootFromParent_Done,
     /* 2050313 */   // Label 27306: @2050313
     /* 2050313 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2050404), // Rule ID 15277 //
     /* 2050318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050364 */     // MIs[0] round
     /* 2050364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050367 */     // MIs[0] policy
     /* 2050367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2050380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050403 */     // GIR_Coverage, 15277,
     /* 2050403 */     GIR_EraseRootFromParent_Done,
     /* 2050404 */   // Label 27307: @2050404
     /* 2050404 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2050495), // Rule ID 15280 //
     /* 2050409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050455 */     // MIs[0] round
     /* 2050455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050458 */     // MIs[0] policy
     /* 2050458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050494 */     // GIR_Coverage, 15280,
     /* 2050494 */     GIR_EraseRootFromParent_Done,
     /* 2050495 */   // Label 27308: @2050495
     /* 2050495 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2050586), // Rule ID 15281 //
     /* 2050500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050546 */     // MIs[0] round
     /* 2050546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050549 */     // MIs[0] policy
     /* 2050549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050585 */     // GIR_Coverage, 15281,
     /* 2050585 */     GIR_EraseRootFromParent_Done,
     /* 2050586 */   // Label 27309: @2050586
     /* 2050586 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2050677), // Rule ID 15284 //
     /* 2050591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050637 */     // MIs[0] round
     /* 2050637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050640 */     // MIs[0] policy
     /* 2050640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050676 */     // GIR_Coverage, 15284,
     /* 2050676 */     GIR_EraseRootFromParent_Done,
     /* 2050677 */   // Label 27310: @2050677
     /* 2050677 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2050768), // Rule ID 15285 //
     /* 2050682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050728 */     // MIs[0] round
     /* 2050728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050731 */     // MIs[0] policy
     /* 2050731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050741 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050767 */     // GIR_Coverage, 15285,
     /* 2050767 */     GIR_EraseRootFromParent_Done,
     /* 2050768 */   // Label 27311: @2050768
     /* 2050768 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2050859), // Rule ID 15288 //
     /* 2050773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050819 */     // MIs[0] round
     /* 2050819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050822 */     // MIs[0] policy
     /* 2050822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050832 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050858 */     // GIR_Coverage, 15288,
     /* 2050858 */     GIR_EraseRootFromParent_Done,
     /* 2050859 */   // Label 27312: @2050859
     /* 2050859 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2050950), // Rule ID 15289 //
     /* 2050864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050910 */     // MIs[0] round
     /* 2050910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050913 */     // MIs[0] policy
     /* 2050913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050923 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050949 */     // GIR_Coverage, 15289,
     /* 2050949 */     GIR_EraseRootFromParent_Done,
     /* 2050950 */   // Label 27313: @2050950
     /* 2050950 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2051041), // Rule ID 15292 //
     /* 2050955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051001 */     // MIs[0] round
     /* 2051001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051004 */     // MIs[0] policy
     /* 2051004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051040 */     // GIR_Coverage, 15292,
     /* 2051040 */     GIR_EraseRootFromParent_Done,
     /* 2051041 */   // Label 27314: @2051041
     /* 2051041 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2051132), // Rule ID 15293 //
     /* 2051046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2051066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051092 */     // MIs[0] round
     /* 2051092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051095 */     // MIs[0] policy
     /* 2051095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051105 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051131 */     // GIR_Coverage, 15293,
     /* 2051131 */     GIR_EraseRootFromParent_Done,
     /* 2051132 */   // Label 27315: @2051132
     /* 2051132 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2051223), // Rule ID 15296 //
     /* 2051137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051183 */     // MIs[0] round
     /* 2051183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051186 */     // MIs[0] policy
     /* 2051186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051222 */     // GIR_Coverage, 15296,
     /* 2051222 */     GIR_EraseRootFromParent_Done,
     /* 2051223 */   // Label 27316: @2051223
     /* 2051223 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2051314), // Rule ID 15297 //
     /* 2051228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051274 */     // MIs[0] round
     /* 2051274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051277 */     // MIs[0] policy
     /* 2051277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051287 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051313 */     // GIR_Coverage, 15297,
     /* 2051313 */     GIR_EraseRootFromParent_Done,
     /* 2051314 */   // Label 27317: @2051314
     /* 2051314 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2051405), // Rule ID 15300 //
     /* 2051319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051365 */     // MIs[0] round
     /* 2051365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051368 */     // MIs[0] policy
     /* 2051368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051404 */     // GIR_Coverage, 15300,
     /* 2051404 */     GIR_EraseRootFromParent_Done,
     /* 2051405 */   // Label 27318: @2051405
     /* 2051405 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2051496), // Rule ID 15301 //
     /* 2051410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2051430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051456 */     // MIs[0] round
     /* 2051456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051459 */     // MIs[0] policy
     /* 2051459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051495 */     // GIR_Coverage, 15301,
     /* 2051495 */     GIR_EraseRootFromParent_Done,
     /* 2051496 */   // Label 27319: @2051496
     /* 2051496 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2051587), // Rule ID 15304 //
     /* 2051501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051547 */     // MIs[0] round
     /* 2051547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051550 */     // MIs[0] policy
     /* 2051550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051586 */     // GIR_Coverage, 15304,
     /* 2051586 */     GIR_EraseRootFromParent_Done,
     /* 2051587 */   // Label 27320: @2051587
     /* 2051587 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2051678), // Rule ID 15305 //
     /* 2051592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051638 */     // MIs[0] round
     /* 2051638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051641 */     // MIs[0] policy
     /* 2051641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051651 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051677 */     // GIR_Coverage, 15305,
     /* 2051677 */     GIR_EraseRootFromParent_Done,
     /* 2051678 */   // Label 27321: @2051678
     /* 2051678 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2051769), // Rule ID 15308 //
     /* 2051683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051729 */     // MIs[0] round
     /* 2051729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051732 */     // MIs[0] policy
     /* 2051732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051768 */     // GIR_Coverage, 15308,
     /* 2051768 */     GIR_EraseRootFromParent_Done,
     /* 2051769 */   // Label 27322: @2051769
     /* 2051769 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2051860), // Rule ID 15309 //
     /* 2051774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051820 */     // MIs[0] round
     /* 2051820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051823 */     // MIs[0] policy
     /* 2051823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051859 */     // GIR_Coverage, 15309,
     /* 2051859 */     GIR_EraseRootFromParent_Done,
     /* 2051860 */   // Label 27323: @2051860
     /* 2051860 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2051951), // Rule ID 15312 //
     /* 2051865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051911 */     // MIs[0] round
     /* 2051911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051914 */     // MIs[0] policy
     /* 2051914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051950 */     // GIR_Coverage, 15312,
     /* 2051950 */     GIR_EraseRootFromParent_Done,
     /* 2051951 */   // Label 27324: @2051951
     /* 2051951 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2052042), // Rule ID 15313 //
     /* 2051956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052002 */     // MIs[0] round
     /* 2052002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052005 */     // MIs[0] policy
     /* 2052005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052041 */     // GIR_Coverage, 15313,
     /* 2052041 */     GIR_EraseRootFromParent_Done,
     /* 2052042 */   // Label 27325: @2052042
     /* 2052042 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2052133), // Rule ID 15316 //
     /* 2052047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052093 */     // MIs[0] round
     /* 2052093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052096 */     // MIs[0] policy
     /* 2052096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052132 */     // GIR_Coverage, 15316,
     /* 2052132 */     GIR_EraseRootFromParent_Done,
     /* 2052133 */   // Label 27326: @2052133
     /* 2052133 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2052224), // Rule ID 15317 //
     /* 2052138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052184 */     // MIs[0] round
     /* 2052184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052187 */     // MIs[0] policy
     /* 2052187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052197 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052223 */     // GIR_Coverage, 15317,
     /* 2052223 */     GIR_EraseRootFromParent_Done,
     /* 2052224 */   // Label 27327: @2052224
     /* 2052224 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2052315), // Rule ID 15320 //
     /* 2052229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2052249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052275 */     // MIs[0] round
     /* 2052275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052278 */     // MIs[0] policy
     /* 2052278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052314 */     // GIR_Coverage, 15320,
     /* 2052314 */     GIR_EraseRootFromParent_Done,
     /* 2052315 */   // Label 27328: @2052315
     /* 2052315 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2052406), // Rule ID 15321 //
     /* 2052320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2052340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052366 */     // MIs[0] round
     /* 2052366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052369 */     // MIs[0] policy
     /* 2052369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052379 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052405 */     // GIR_Coverage, 15321,
     /* 2052405 */     GIR_EraseRootFromParent_Done,
     /* 2052406 */   // Label 27329: @2052406
     /* 2052406 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2052497), // Rule ID 15324 //
     /* 2052411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2052414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052457 */     // MIs[0] round
     /* 2052457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052460 */     // MIs[0] policy
     /* 2052460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052496 */     // GIR_Coverage, 15324,
     /* 2052496 */     GIR_EraseRootFromParent_Done,
     /* 2052497 */   // Label 27330: @2052497
     /* 2052497 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2052588), // Rule ID 15325 //
     /* 2052502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2052505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052548 */     // MIs[0] round
     /* 2052548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052551 */     // MIs[0] policy
     /* 2052551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052587 */     // GIR_Coverage, 15325,
     /* 2052587 */     GIR_EraseRootFromParent_Done,
     /* 2052588 */   // Label 27331: @2052588
     /* 2052588 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2052679), // Rule ID 15328 //
     /* 2052593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052639 */     // MIs[0] round
     /* 2052639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052642 */     // MIs[0] policy
     /* 2052642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052678 */     // GIR_Coverage, 15328,
     /* 2052678 */     GIR_EraseRootFromParent_Done,
     /* 2052679 */   // Label 27332: @2052679
     /* 2052679 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2052770), // Rule ID 15329 //
     /* 2052684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052730 */     // MIs[0] round
     /* 2052730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052733 */     // MIs[0] policy
     /* 2052733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052769 */     // GIR_Coverage, 15329,
     /* 2052769 */     GIR_EraseRootFromParent_Done,
     /* 2052770 */   // Label 27333: @2052770
     /* 2052770 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2052861), // Rule ID 15332 //
     /* 2052775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052821 */     // MIs[0] round
     /* 2052821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052824 */     // MIs[0] policy
     /* 2052824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052860 */     // GIR_Coverage, 15332,
     /* 2052860 */     GIR_EraseRootFromParent_Done,
     /* 2052861 */   // Label 27334: @2052861
     /* 2052861 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2052952), // Rule ID 15333 //
     /* 2052866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052912 */     // MIs[0] round
     /* 2052912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052915 */     // MIs[0] policy
     /* 2052915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052925 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052951 */     // GIR_Coverage, 15333,
     /* 2052951 */     GIR_EraseRootFromParent_Done,
     /* 2052952 */   // Label 27335: @2052952
     /* 2052952 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2053043), // Rule ID 15336 //
     /* 2052957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053003 */     // MIs[0] round
     /* 2053003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053006 */     // MIs[0] policy
     /* 2053006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053042 */     // GIR_Coverage, 15336,
     /* 2053042 */     GIR_EraseRootFromParent_Done,
     /* 2053043 */   // Label 27336: @2053043
     /* 2053043 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2053134), // Rule ID 15337 //
     /* 2053048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2053068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053094 */     // MIs[0] round
     /* 2053094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053097 */     // MIs[0] policy
     /* 2053097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053107 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053133 */     // GIR_Coverage, 15337,
     /* 2053133 */     GIR_EraseRootFromParent_Done,
     /* 2053134 */   // Label 27337: @2053134
     /* 2053134 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2053225), // Rule ID 15340 //
     /* 2053139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053185 */     // MIs[0] round
     /* 2053185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053188 */     // MIs[0] policy
     /* 2053188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053224 */     // GIR_Coverage, 15340,
     /* 2053224 */     GIR_EraseRootFromParent_Done,
     /* 2053225 */   // Label 27338: @2053225
     /* 2053225 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2053316), // Rule ID 15341 //
     /* 2053230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053276 */     // MIs[0] round
     /* 2053276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053279 */     // MIs[0] policy
     /* 2053279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053315 */     // GIR_Coverage, 15341,
     /* 2053315 */     GIR_EraseRootFromParent_Done,
     /* 2053316 */   // Label 27339: @2053316
     /* 2053316 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2053407), // Rule ID 15344 //
     /* 2053321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2053341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053367 */     // MIs[0] round
     /* 2053367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053370 */     // MIs[0] policy
     /* 2053370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053406 */     // GIR_Coverage, 15344,
     /* 2053406 */     GIR_EraseRootFromParent_Done,
     /* 2053407 */   // Label 27340: @2053407
     /* 2053407 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2053498), // Rule ID 15345 //
     /* 2053412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2053432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053458 */     // MIs[0] round
     /* 2053458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053461 */     // MIs[0] policy
     /* 2053461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053497 */     // GIR_Coverage, 15345,
     /* 2053497 */     GIR_EraseRootFromParent_Done,
     /* 2053498 */   // Label 27341: @2053498
     /* 2053498 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2053589), // Rule ID 15348 //
     /* 2053503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053549 */     // MIs[0] round
     /* 2053549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053552 */     // MIs[0] policy
     /* 2053552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053588 */     // GIR_Coverage, 15348,
     /* 2053588 */     GIR_EraseRootFromParent_Done,
     /* 2053589 */   // Label 27342: @2053589
     /* 2053589 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2053680), // Rule ID 15349 //
     /* 2053594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053640 */     // MIs[0] round
     /* 2053640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053643 */     // MIs[0] policy
     /* 2053643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053653 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053679 */     // GIR_Coverage, 15349,
     /* 2053679 */     GIR_EraseRootFromParent_Done,
     /* 2053680 */   // Label 27343: @2053680
     /* 2053680 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2053771), // Rule ID 15352 //
     /* 2053685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053731 */     // MIs[0] round
     /* 2053731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053734 */     // MIs[0] policy
     /* 2053734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053770 */     // GIR_Coverage, 15352,
     /* 2053770 */     GIR_EraseRootFromParent_Done,
     /* 2053771 */   // Label 27344: @2053771
     /* 2053771 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2053862), // Rule ID 15353 //
     /* 2053776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053822 */     // MIs[0] round
     /* 2053822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053825 */     // MIs[0] policy
     /* 2053825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053861 */     // GIR_Coverage, 15353,
     /* 2053861 */     GIR_EraseRootFromParent_Done,
     /* 2053862 */   // Label 27345: @2053862
     /* 2053862 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2053953), // Rule ID 15356 //
     /* 2053867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053913 */     // MIs[0] round
     /* 2053913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053916 */     // MIs[0] policy
     /* 2053916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053952 */     // GIR_Coverage, 15356,
     /* 2053952 */     GIR_EraseRootFromParent_Done,
     /* 2053953 */   // Label 27346: @2053953
     /* 2053953 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2054044), // Rule ID 15357 //
     /* 2053958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054004 */     // MIs[0] round
     /* 2054004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054007 */     // MIs[0] policy
     /* 2054007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054017 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054043 */     // GIR_Coverage, 15357,
     /* 2054043 */     GIR_EraseRootFromParent_Done,
     /* 2054044 */   // Label 27347: @2054044
     /* 2054044 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2054135), // Rule ID 15360 //
     /* 2054049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054095 */     // MIs[0] round
     /* 2054095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054098 */     // MIs[0] policy
     /* 2054098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054134 */     // GIR_Coverage, 15360,
     /* 2054134 */     GIR_EraseRootFromParent_Done,
     /* 2054135 */   // Label 27348: @2054135
     /* 2054135 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2054226), // Rule ID 15361 //
     /* 2054140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054186 */     // MIs[0] round
     /* 2054186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054189 */     // MIs[0] policy
     /* 2054189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054199 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054225 */     // GIR_Coverage, 15361,
     /* 2054225 */     GIR_EraseRootFromParent_Done,
     /* 2054226 */   // Label 27349: @2054226
     /* 2054226 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2054317), // Rule ID 15364 //
     /* 2054231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2054251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054277 */     // MIs[0] round
     /* 2054277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054280 */     // MIs[0] policy
     /* 2054280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2054293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054316 */     // GIR_Coverage, 15364,
     /* 2054316 */     GIR_EraseRootFromParent_Done,
     /* 2054317 */   // Label 27350: @2054317
     /* 2054317 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2054408), // Rule ID 15365 //
     /* 2054322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2054342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054368 */     // MIs[0] round
     /* 2054368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054371 */     // MIs[0] policy
     /* 2054371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2054384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054407 */     // GIR_Coverage, 15365,
     /* 2054407 */     GIR_EraseRootFromParent_Done,
     /* 2054408 */   // Label 27351: @2054408
     /* 2054408 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2054499), // Rule ID 15368 //
     /* 2054413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054459 */     // MIs[0] round
     /* 2054459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054462 */     // MIs[0] policy
     /* 2054462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054498 */     // GIR_Coverage, 15368,
     /* 2054498 */     GIR_EraseRootFromParent_Done,
     /* 2054499 */   // Label 27352: @2054499
     /* 2054499 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2054590), // Rule ID 15369 //
     /* 2054504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054550 */     // MIs[0] round
     /* 2054550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054553 */     // MIs[0] policy
     /* 2054553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054589 */     // GIR_Coverage, 15369,
     /* 2054589 */     GIR_EraseRootFromParent_Done,
     /* 2054590 */   // Label 27353: @2054590
     /* 2054590 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2054681), // Rule ID 15372 //
     /* 2054595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054641 */     // MIs[0] round
     /* 2054641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054644 */     // MIs[0] policy
     /* 2054644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054680 */     // GIR_Coverage, 15372,
     /* 2054680 */     GIR_EraseRootFromParent_Done,
     /* 2054681 */   // Label 27354: @2054681
     /* 2054681 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2054772), // Rule ID 15373 //
     /* 2054686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054732 */     // MIs[0] round
     /* 2054732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054735 */     // MIs[0] policy
     /* 2054735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054745 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054771 */     // GIR_Coverage, 15373,
     /* 2054771 */     GIR_EraseRootFromParent_Done,
     /* 2054772 */   // Label 27355: @2054772
     /* 2054772 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2054863), // Rule ID 15376 //
     /* 2054777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054823 */     // MIs[0] round
     /* 2054823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054826 */     // MIs[0] policy
     /* 2054826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054862 */     // GIR_Coverage, 15376,
     /* 2054862 */     GIR_EraseRootFromParent_Done,
     /* 2054863 */   // Label 27356: @2054863
     /* 2054863 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2054954), // Rule ID 15377 //
     /* 2054868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054914 */     // MIs[0] round
     /* 2054914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054917 */     // MIs[0] policy
     /* 2054917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054953 */     // GIR_Coverage, 15377,
     /* 2054953 */     GIR_EraseRootFromParent_Done,
     /* 2054954 */   // Label 27357: @2054954
     /* 2054954 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2055045), // Rule ID 15380 //
     /* 2054959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055005 */     // MIs[0] round
     /* 2055005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055008 */     // MIs[0] policy
     /* 2055008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055044 */     // GIR_Coverage, 15380,
     /* 2055044 */     GIR_EraseRootFromParent_Done,
     /* 2055045 */   // Label 27358: @2055045
     /* 2055045 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2055136), // Rule ID 15381 //
     /* 2055050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055096 */     // MIs[0] round
     /* 2055096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055099 */     // MIs[0] policy
     /* 2055099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055109 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055135 */     // GIR_Coverage, 15381,
     /* 2055135 */     GIR_EraseRootFromParent_Done,
     /* 2055136 */   // Label 27359: @2055136
     /* 2055136 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2055227), // Rule ID 15384 //
     /* 2055141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055187 */     // MIs[0] round
     /* 2055187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055190 */     // MIs[0] policy
     /* 2055190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055226 */     // GIR_Coverage, 15384,
     /* 2055226 */     GIR_EraseRootFromParent_Done,
     /* 2055227 */   // Label 27360: @2055227
     /* 2055227 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2055318), // Rule ID 15385 //
     /* 2055232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055278 */     // MIs[0] round
     /* 2055278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055281 */     // MIs[0] policy
     /* 2055281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055291 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055317 */     // GIR_Coverage, 15385,
     /* 2055317 */     GIR_EraseRootFromParent_Done,
     /* 2055318 */   // Label 27361: @2055318
     /* 2055318 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2055409), // Rule ID 15388 //
     /* 2055323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055369 */     // MIs[0] round
     /* 2055369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055372 */     // MIs[0] policy
     /* 2055372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055408 */     // GIR_Coverage, 15388,
     /* 2055408 */     GIR_EraseRootFromParent_Done,
     /* 2055409 */   // Label 27362: @2055409
     /* 2055409 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2055500), // Rule ID 15389 //
     /* 2055414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055460 */     // MIs[0] round
     /* 2055460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055463 */     // MIs[0] policy
     /* 2055463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055499 */     // GIR_Coverage, 15389,
     /* 2055499 */     GIR_EraseRootFromParent_Done,
     /* 2055500 */   // Label 27363: @2055500
     /* 2055500 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2055591), // Rule ID 15392 //
     /* 2055505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055551 */     // MIs[0] round
     /* 2055551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055554 */     // MIs[0] policy
     /* 2055554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055590 */     // GIR_Coverage, 15392,
     /* 2055590 */     GIR_EraseRootFromParent_Done,
     /* 2055591 */   // Label 27364: @2055591
     /* 2055591 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2055682), // Rule ID 15393 //
     /* 2055596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055642 */     // MIs[0] round
     /* 2055642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055645 */     // MIs[0] policy
     /* 2055645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055681 */     // GIR_Coverage, 15393,
     /* 2055681 */     GIR_EraseRootFromParent_Done,
     /* 2055682 */   // Label 27365: @2055682
     /* 2055682 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2055773), // Rule ID 15396 //
     /* 2055687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055733 */     // MIs[0] round
     /* 2055733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055736 */     // MIs[0] policy
     /* 2055736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055772 */     // GIR_Coverage, 15396,
     /* 2055772 */     GIR_EraseRootFromParent_Done,
     /* 2055773 */   // Label 27366: @2055773
     /* 2055773 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2055864), // Rule ID 15397 //
     /* 2055778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055824 */     // MIs[0] round
     /* 2055824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055827 */     // MIs[0] policy
     /* 2055827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055863 */     // GIR_Coverage, 15397,
     /* 2055863 */     GIR_EraseRootFromParent_Done,
     /* 2055864 */   // Label 27367: @2055864
     /* 2055864 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2055955), // Rule ID 15400 //
     /* 2055869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055915 */     // MIs[0] round
     /* 2055915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055918 */     // MIs[0] policy
     /* 2055918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055954 */     // GIR_Coverage, 15400,
     /* 2055954 */     GIR_EraseRootFromParent_Done,
     /* 2055955 */   // Label 27368: @2055955
     /* 2055955 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2056046), // Rule ID 15401 //
     /* 2055960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056006 */     // MIs[0] round
     /* 2056006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056009 */     // MIs[0] policy
     /* 2056009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11217:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056045 */     // GIR_Coverage, 15401,
     /* 2056045 */     GIR_EraseRootFromParent_Done,
     /* 2056046 */   // Label 27369: @2056046
     /* 2056046 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2056137), // Rule ID 15404 //
     /* 2056051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056097 */     // MIs[0] round
     /* 2056097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056100 */     // MIs[0] policy
     /* 2056100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056136 */     // GIR_Coverage, 15404,
     /* 2056136 */     GIR_EraseRootFromParent_Done,
     /* 2056137 */   // Label 27370: @2056137
     /* 2056137 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2056228), // Rule ID 15405 //
     /* 2056142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056188 */     // MIs[0] round
     /* 2056188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056191 */     // MIs[0] policy
     /* 2056191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056227 */     // GIR_Coverage, 15405,
     /* 2056227 */     GIR_EraseRootFromParent_Done,
     /* 2056228 */   // Label 27371: @2056228
     /* 2056228 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2056319), // Rule ID 15408 //
     /* 2056233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056279 */     // MIs[0] round
     /* 2056279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056282 */     // MIs[0] policy
     /* 2056282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056318 */     // GIR_Coverage, 15408,
     /* 2056318 */     GIR_EraseRootFromParent_Done,
     /* 2056319 */   // Label 27372: @2056319
     /* 2056319 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2056410), // Rule ID 15409 //
     /* 2056324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056370 */     // MIs[0] round
     /* 2056370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056373 */     // MIs[0] policy
     /* 2056373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056409 */     // GIR_Coverage, 15409,
     /* 2056409 */     GIR_EraseRootFromParent_Done,
     /* 2056410 */   // Label 27373: @2056410
     /* 2056410 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2056501), // Rule ID 15412 //
     /* 2056415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2056418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056461 */     // MIs[0] round
     /* 2056461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056464 */     // MIs[0] policy
     /* 2056464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056500 */     // GIR_Coverage, 15412,
     /* 2056500 */     GIR_EraseRootFromParent_Done,
     /* 2056501 */   // Label 27374: @2056501
     /* 2056501 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2056592), // Rule ID 15413 //
     /* 2056506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2056509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056552 */     // MIs[0] round
     /* 2056552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056555 */     // MIs[0] policy
     /* 2056555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056565 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056591 */     // GIR_Coverage, 15413,
     /* 2056591 */     GIR_EraseRootFromParent_Done,
     /* 2056592 */   // Label 27375: @2056592
     /* 2056592 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2056683), // Rule ID 15416 //
     /* 2056597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056643 */     // MIs[0] round
     /* 2056643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056646 */     // MIs[0] policy
     /* 2056646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056682 */     // GIR_Coverage, 15416,
     /* 2056682 */     GIR_EraseRootFromParent_Done,
     /* 2056683 */   // Label 27376: @2056683
     /* 2056683 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2056774), // Rule ID 15417 //
     /* 2056688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056734 */     // MIs[0] round
     /* 2056734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056737 */     // MIs[0] policy
     /* 2056737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056773 */     // GIR_Coverage, 15417,
     /* 2056773 */     GIR_EraseRootFromParent_Done,
     /* 2056774 */   // Label 27377: @2056774
     /* 2056774 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2056865), // Rule ID 15420 //
     /* 2056779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056825 */     // MIs[0] round
     /* 2056825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056828 */     // MIs[0] policy
     /* 2056828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056864 */     // GIR_Coverage, 15420,
     /* 2056864 */     GIR_EraseRootFromParent_Done,
     /* 2056865 */   // Label 27378: @2056865
     /* 2056865 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2056956), // Rule ID 15421 //
     /* 2056870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056916 */     // MIs[0] round
     /* 2056916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056919 */     // MIs[0] policy
     /* 2056919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056929 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056955 */     // GIR_Coverage, 15421,
     /* 2056955 */     GIR_EraseRootFromParent_Done,
     /* 2056956 */   // Label 27379: @2056956
     /* 2056956 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2057047), // Rule ID 15424 //
     /* 2056961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057007 */     // MIs[0] round
     /* 2057007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057010 */     // MIs[0] policy
     /* 2057010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057020 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057046 */     // GIR_Coverage, 15424,
     /* 2057046 */     GIR_EraseRootFromParent_Done,
     /* 2057047 */   // Label 27380: @2057047
     /* 2057047 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2057138), // Rule ID 15425 //
     /* 2057052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057098 */     // MIs[0] round
     /* 2057098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057101 */     // MIs[0] policy
     /* 2057101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057111 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057137 */     // GIR_Coverage, 15425,
     /* 2057137 */     GIR_EraseRootFromParent_Done,
     /* 2057138 */   // Label 27381: @2057138
     /* 2057138 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2057229), // Rule ID 15428 //
     /* 2057143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057189 */     // MIs[0] round
     /* 2057189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057192 */     // MIs[0] policy
     /* 2057192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057228 */     // GIR_Coverage, 15428,
     /* 2057228 */     GIR_EraseRootFromParent_Done,
     /* 2057229 */   // Label 27382: @2057229
     /* 2057229 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2057320), // Rule ID 15429 //
     /* 2057234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057280 */     // MIs[0] round
     /* 2057280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057283 */     // MIs[0] policy
     /* 2057283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057319 */     // GIR_Coverage, 15429,
     /* 2057319 */     GIR_EraseRootFromParent_Done,
     /* 2057320 */   // Label 27383: @2057320
     /* 2057320 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2057411), // Rule ID 15432 //
     /* 2057325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057371 */     // MIs[0] round
     /* 2057371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057374 */     // MIs[0] policy
     /* 2057374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057410 */     // GIR_Coverage, 15432,
     /* 2057410 */     GIR_EraseRootFromParent_Done,
     /* 2057411 */   // Label 27384: @2057411
     /* 2057411 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2057502), // Rule ID 15433 //
     /* 2057416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057462 */     // MIs[0] round
     /* 2057462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057465 */     // MIs[0] policy
     /* 2057465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057501 */     // GIR_Coverage, 15433,
     /* 2057501 */     GIR_EraseRootFromParent_Done,
     /* 2057502 */   // Label 27385: @2057502
     /* 2057502 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2057593), // Rule ID 15436 //
     /* 2057507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057553 */     // MIs[0] round
     /* 2057553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057556 */     // MIs[0] policy
     /* 2057556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057592 */     // GIR_Coverage, 15436,
     /* 2057592 */     GIR_EraseRootFromParent_Done,
     /* 2057593 */   // Label 27386: @2057593
     /* 2057593 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2057684), // Rule ID 15437 //
     /* 2057598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057644 */     // MIs[0] round
     /* 2057644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057647 */     // MIs[0] policy
     /* 2057647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057657 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057683 */     // GIR_Coverage, 15437,
     /* 2057683 */     GIR_EraseRootFromParent_Done,
     /* 2057684 */   // Label 27387: @2057684
     /* 2057684 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2057775), // Rule ID 15440 //
     /* 2057689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057735 */     // MIs[0] round
     /* 2057735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057738 */     // MIs[0] policy
     /* 2057738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057774 */     // GIR_Coverage, 15440,
     /* 2057774 */     GIR_EraseRootFromParent_Done,
     /* 2057775 */   // Label 27388: @2057775
     /* 2057775 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2057866), // Rule ID 15441 //
     /* 2057780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057826 */     // MIs[0] round
     /* 2057826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057829 */     // MIs[0] policy
     /* 2057829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057865 */     // GIR_Coverage, 15441,
     /* 2057865 */     GIR_EraseRootFromParent_Done,
     /* 2057866 */   // Label 27389: @2057866
     /* 2057866 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2057957), // Rule ID 15444 //
     /* 2057871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057917 */     // MIs[0] round
     /* 2057917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057920 */     // MIs[0] policy
     /* 2057920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057956 */     // GIR_Coverage, 15444,
     /* 2057956 */     GIR_EraseRootFromParent_Done,
     /* 2057957 */   // Label 27390: @2057957
     /* 2057957 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2058048), // Rule ID 15445 //
     /* 2057962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058008 */     // MIs[0] round
     /* 2058008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058011 */     // MIs[0] policy
     /* 2058011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058047 */     // GIR_Coverage, 15445,
     /* 2058047 */     GIR_EraseRootFromParent_Done,
     /* 2058048 */   // Label 27391: @2058048
     /* 2058048 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2058139), // Rule ID 15448 //
     /* 2058053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058099 */     // MIs[0] round
     /* 2058099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058102 */     // MIs[0] policy
     /* 2058102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058138 */     // GIR_Coverage, 15448,
     /* 2058138 */     GIR_EraseRootFromParent_Done,
     /* 2058139 */   // Label 27392: @2058139
     /* 2058139 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2058230), // Rule ID 15449 //
     /* 2058144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058190 */     // MIs[0] round
     /* 2058190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058193 */     // MIs[0] policy
     /* 2058193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058203 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058229 */     // GIR_Coverage, 15449,
     /* 2058229 */     GIR_EraseRootFromParent_Done,
     /* 2058230 */   // Label 27393: @2058230
     /* 2058230 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2058321), // Rule ID 15452 //
     /* 2058235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058281 */     // MIs[0] round
     /* 2058281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058284 */     // MIs[0] policy
     /* 2058284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2058297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058320 */     // GIR_Coverage, 15452,
     /* 2058320 */     GIR_EraseRootFromParent_Done,
     /* 2058321 */   // Label 27394: @2058321
     /* 2058321 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2058412), // Rule ID 15453 //
     /* 2058326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058372 */     // MIs[0] round
     /* 2058372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058375 */     // MIs[0] policy
     /* 2058375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2058388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058411 */     // GIR_Coverage, 15453,
     /* 2058411 */     GIR_EraseRootFromParent_Done,
     /* 2058412 */   // Label 27395: @2058412
     /* 2058412 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2058503), // Rule ID 15456 //
     /* 2058417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058463 */     // MIs[0] round
     /* 2058463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058466 */     // MIs[0] policy
     /* 2058466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058502 */     // GIR_Coverage, 15456,
     /* 2058502 */     GIR_EraseRootFromParent_Done,
     /* 2058503 */   // Label 27396: @2058503
     /* 2058503 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2058594), // Rule ID 15457 //
     /* 2058508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058554 */     // MIs[0] round
     /* 2058554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058557 */     // MIs[0] policy
     /* 2058557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058567 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058593 */     // GIR_Coverage, 15457,
     /* 2058593 */     GIR_EraseRootFromParent_Done,
     /* 2058594 */   // Label 27397: @2058594
     /* 2058594 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2058685), // Rule ID 15460 //
     /* 2058599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058645 */     // MIs[0] round
     /* 2058645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058648 */     // MIs[0] policy
     /* 2058648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058684 */     // GIR_Coverage, 15460,
     /* 2058684 */     GIR_EraseRootFromParent_Done,
     /* 2058685 */   // Label 27398: @2058685
     /* 2058685 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2058776), // Rule ID 15461 //
     /* 2058690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058736 */     // MIs[0] round
     /* 2058736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058739 */     // MIs[0] policy
     /* 2058739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058749 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058775 */     // GIR_Coverage, 15461,
     /* 2058775 */     GIR_EraseRootFromParent_Done,
     /* 2058776 */   // Label 27399: @2058776
     /* 2058776 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2058867), // Rule ID 15464 //
     /* 2058781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058827 */     // MIs[0] round
     /* 2058827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058830 */     // MIs[0] policy
     /* 2058830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058840 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058866 */     // GIR_Coverage, 15464,
     /* 2058866 */     GIR_EraseRootFromParent_Done,
     /* 2058867 */   // Label 27400: @2058867
     /* 2058867 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2058958), // Rule ID 15465 //
     /* 2058872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058918 */     // MIs[0] round
     /* 2058918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058921 */     // MIs[0] policy
     /* 2058921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058931 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058957 */     // GIR_Coverage, 15465,
     /* 2058957 */     GIR_EraseRootFromParent_Done,
     /* 2058958 */   // Label 27401: @2058958
     /* 2058958 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2059049), // Rule ID 15468 //
     /* 2058963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059009 */     // MIs[0] round
     /* 2059009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059012 */     // MIs[0] policy
     /* 2059012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059048 */     // GIR_Coverage, 15468,
     /* 2059048 */     GIR_EraseRootFromParent_Done,
     /* 2059049 */   // Label 27402: @2059049
     /* 2059049 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2059140), // Rule ID 15469 //
     /* 2059054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2059065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2059068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2059071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2059074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059100 */     // MIs[0] round
     /* 2059100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059103 */     // MIs[0] policy
     /* 2059103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059113 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059139 */     // GIR_Coverage, 15469,
     /* 2059139 */     GIR_EraseRootFromParent_Done,
     /* 2059140 */   // Label 27403: @2059140
     /* 2059140 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2059231), // Rule ID 15472 //
     /* 2059145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059191 */     // MIs[0] round
     /* 2059191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059194 */     // MIs[0] policy
     /* 2059194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059230 */     // GIR_Coverage, 15472,
     /* 2059230 */     GIR_EraseRootFromParent_Done,
     /* 2059231 */   // Label 27404: @2059231
     /* 2059231 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2059322), // Rule ID 15473 //
     /* 2059236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059282 */     // MIs[0] round
     /* 2059282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059285 */     // MIs[0] policy
     /* 2059285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059295 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059321 */     // GIR_Coverage, 15473,
     /* 2059321 */     GIR_EraseRootFromParent_Done,
     /* 2059322 */   // Label 27405: @2059322
     /* 2059322 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2059413), // Rule ID 15476 //
     /* 2059327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059373 */     // MIs[0] round
     /* 2059373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059376 */     // MIs[0] policy
     /* 2059376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059412 */     // GIR_Coverage, 15476,
     /* 2059412 */     GIR_EraseRootFromParent_Done,
     /* 2059413 */   // Label 27406: @2059413
     /* 2059413 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2059504), // Rule ID 15477 //
     /* 2059418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2059438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059464 */     // MIs[0] round
     /* 2059464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059467 */     // MIs[0] policy
     /* 2059467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059503 */     // GIR_Coverage, 15477,
     /* 2059503 */     GIR_EraseRootFromParent_Done,
     /* 2059504 */   // Label 27407: @2059504
     /* 2059504 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2059595), // Rule ID 15480 //
     /* 2059509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059555 */     // MIs[0] round
     /* 2059555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059558 */     // MIs[0] policy
     /* 2059558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059594 */     // GIR_Coverage, 15480,
     /* 2059594 */     GIR_EraseRootFromParent_Done,
     /* 2059595 */   // Label 27408: @2059595
     /* 2059595 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2059686), // Rule ID 15481 //
     /* 2059600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059646 */     // MIs[0] round
     /* 2059646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059649 */     // MIs[0] policy
     /* 2059649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059685 */     // GIR_Coverage, 15481,
     /* 2059685 */     GIR_EraseRootFromParent_Done,
     /* 2059686 */   // Label 27409: @2059686
     /* 2059686 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2059777), // Rule ID 15484 //
     /* 2059691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059737 */     // MIs[0] round
     /* 2059737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059740 */     // MIs[0] policy
     /* 2059740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059776 */     // GIR_Coverage, 15484,
     /* 2059776 */     GIR_EraseRootFromParent_Done,
     /* 2059777 */   // Label 27410: @2059777
     /* 2059777 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2059868), // Rule ID 15485 //
     /* 2059782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059828 */     // MIs[0] round
     /* 2059828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059831 */     // MIs[0] policy
     /* 2059831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059867 */     // GIR_Coverage, 15485,
     /* 2059867 */     GIR_EraseRootFromParent_Done,
     /* 2059868 */   // Label 27411: @2059868
     /* 2059868 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2059959), // Rule ID 15488 //
     /* 2059873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059919 */     // MIs[0] round
     /* 2059919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059922 */     // MIs[0] policy
     /* 2059922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059958 */     // GIR_Coverage, 15488,
     /* 2059958 */     GIR_EraseRootFromParent_Done,
     /* 2059959 */   // Label 27412: @2059959
     /* 2059959 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2060050), // Rule ID 15489 //
     /* 2059964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060010 */     // MIs[0] round
     /* 2060010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060013 */     // MIs[0] policy
     /* 2060013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060023 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060049 */     // GIR_Coverage, 15489,
     /* 2060049 */     GIR_EraseRootFromParent_Done,
     /* 2060050 */   // Label 27413: @2060050
     /* 2060050 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2060141), // Rule ID 15492 //
     /* 2060055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060101 */     // MIs[0] round
     /* 2060101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060104 */     // MIs[0] policy
     /* 2060104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060140 */     // GIR_Coverage, 15492,
     /* 2060140 */     GIR_EraseRootFromParent_Done,
     /* 2060141 */   // Label 27414: @2060141
     /* 2060141 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2060232), // Rule ID 15493 //
     /* 2060146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060192 */     // MIs[0] round
     /* 2060192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060195 */     // MIs[0] policy
     /* 2060195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060205 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060231 */     // GIR_Coverage, 15493,
     /* 2060231 */     GIR_EraseRootFromParent_Done,
     /* 2060232 */   // Label 27415: @2060232
     /* 2060232 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2060323), // Rule ID 15496 //
     /* 2060237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060283 */     // MIs[0] round
     /* 2060283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060286 */     // MIs[0] policy
     /* 2060286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060322 */     // GIR_Coverage, 15496,
     /* 2060322 */     GIR_EraseRootFromParent_Done,
     /* 2060323 */   // Label 27416: @2060323
     /* 2060323 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2060414), // Rule ID 15497 //
     /* 2060328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060374 */     // MIs[0] round
     /* 2060374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060377 */     // MIs[0] policy
     /* 2060377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060413 */     // GIR_Coverage, 15497,
     /* 2060413 */     GIR_EraseRootFromParent_Done,
     /* 2060414 */   // Label 27417: @2060414
     /* 2060414 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2060505), // Rule ID 15500 //
     /* 2060419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2060422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060465 */     // MIs[0] round
     /* 2060465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060468 */     // MIs[0] policy
     /* 2060468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060504 */     // GIR_Coverage, 15500,
     /* 2060504 */     GIR_EraseRootFromParent_Done,
     /* 2060505 */   // Label 27418: @2060505
     /* 2060505 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2060596), // Rule ID 15501 //
     /* 2060510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2060513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060556 */     // MIs[0] round
     /* 2060556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060559 */     // MIs[0] policy
     /* 2060559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060595 */     // GIR_Coverage, 15501,
     /* 2060595 */     GIR_EraseRootFromParent_Done,
     /* 2060596 */   // Label 27419: @2060596
     /* 2060596 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2060687), // Rule ID 15504 //
     /* 2060601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060647 */     // MIs[0] round
     /* 2060647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060650 */     // MIs[0] policy
     /* 2060650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060686 */     // GIR_Coverage, 15504,
     /* 2060686 */     GIR_EraseRootFromParent_Done,
     /* 2060687 */   // Label 27420: @2060687
     /* 2060687 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2060778), // Rule ID 15505 //
     /* 2060692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060738 */     // MIs[0] round
     /* 2060738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060741 */     // MIs[0] policy
     /* 2060741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060777 */     // GIR_Coverage, 15505,
     /* 2060777 */     GIR_EraseRootFromParent_Done,
     /* 2060778 */   // Label 27421: @2060778
     /* 2060778 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2060869), // Rule ID 15508 //
     /* 2060783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060829 */     // MIs[0] round
     /* 2060829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060832 */     // MIs[0] policy
     /* 2060832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060868 */     // GIR_Coverage, 15508,
     /* 2060868 */     GIR_EraseRootFromParent_Done,
     /* 2060869 */   // Label 27422: @2060869
     /* 2060869 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2060960), // Rule ID 15509 //
     /* 2060874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060920 */     // MIs[0] round
     /* 2060920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060923 */     // MIs[0] policy
     /* 2060923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060933 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060959 */     // GIR_Coverage, 15509,
     /* 2060959 */     GIR_EraseRootFromParent_Done,
     /* 2060960 */   // Label 27423: @2060960
     /* 2060960 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2061051), // Rule ID 15512 //
     /* 2060965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061011 */     // MIs[0] round
     /* 2061011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061014 */     // MIs[0] policy
     /* 2061014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061050 */     // GIR_Coverage, 15512,
     /* 2061050 */     GIR_EraseRootFromParent_Done,
     /* 2061051 */   // Label 27424: @2061051
     /* 2061051 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2061142), // Rule ID 15513 //
     /* 2061056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2061067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2061070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2061073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2061076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2061079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061102 */     // MIs[0] round
     /* 2061102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061105 */     // MIs[0] policy
     /* 2061105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061115 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061141 */     // GIR_Coverage, 15513,
     /* 2061141 */     GIR_EraseRootFromParent_Done,
     /* 2061142 */   // Label 27425: @2061142
     /* 2061142 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2061233), // Rule ID 15516 //
     /* 2061147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061193 */     // MIs[0] round
     /* 2061193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061196 */     // MIs[0] policy
     /* 2061196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061232 */     // GIR_Coverage, 15516,
     /* 2061232 */     GIR_EraseRootFromParent_Done,
     /* 2061233 */   // Label 27426: @2061233
     /* 2061233 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2061324), // Rule ID 15517 //
     /* 2061238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061284 */     // MIs[0] round
     /* 2061284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061287 */     // MIs[0] policy
     /* 2061287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061323 */     // GIR_Coverage, 15517,
     /* 2061323 */     GIR_EraseRootFromParent_Done,
     /* 2061324 */   // Label 27427: @2061324
     /* 2061324 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2061415), // Rule ID 15520 //
     /* 2061329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2061349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061375 */     // MIs[0] round
     /* 2061375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061378 */     // MIs[0] policy
     /* 2061378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061414 */     // GIR_Coverage, 15520,
     /* 2061414 */     GIR_EraseRootFromParent_Done,
     /* 2061415 */   // Label 27428: @2061415
     /* 2061415 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2061506), // Rule ID 15521 //
     /* 2061420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2061440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061466 */     // MIs[0] round
     /* 2061466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061469 */     // MIs[0] policy
     /* 2061469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061479 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061505 */     // GIR_Coverage, 15521,
     /* 2061505 */     GIR_EraseRootFromParent_Done,
     /* 2061506 */   // Label 27429: @2061506
     /* 2061506 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2061597), // Rule ID 15524 //
     /* 2061511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061557 */     // MIs[0] round
     /* 2061557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061560 */     // MIs[0] policy
     /* 2061560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061596 */     // GIR_Coverage, 15524,
     /* 2061596 */     GIR_EraseRootFromParent_Done,
     /* 2061597 */   // Label 27430: @2061597
     /* 2061597 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2061688), // Rule ID 15525 //
     /* 2061602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061648 */     // MIs[0] round
     /* 2061648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061651 */     // MIs[0] policy
     /* 2061651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061687 */     // GIR_Coverage, 15525,
     /* 2061687 */     GIR_EraseRootFromParent_Done,
     /* 2061688 */   // Label 27431: @2061688
     /* 2061688 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2061779), // Rule ID 15528 //
     /* 2061693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061739 */     // MIs[0] round
     /* 2061739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061742 */     // MIs[0] policy
     /* 2061742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061778 */     // GIR_Coverage, 15528,
     /* 2061778 */     GIR_EraseRootFromParent_Done,
     /* 2061779 */   // Label 27432: @2061779
     /* 2061779 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2061870), // Rule ID 15529 //
     /* 2061784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061830 */     // MIs[0] round
     /* 2061830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061833 */     // MIs[0] policy
     /* 2061833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061869 */     // GIR_Coverage, 15529,
     /* 2061869 */     GIR_EraseRootFromParent_Done,
     /* 2061870 */   // Label 27433: @2061870
     /* 2061870 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2061961), // Rule ID 15532 //
     /* 2061875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061921 */     // MIs[0] round
     /* 2061921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061924 */     // MIs[0] policy
     /* 2061924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061960 */     // GIR_Coverage, 15532,
     /* 2061960 */     GIR_EraseRootFromParent_Done,
     /* 2061961 */   // Label 27434: @2061961
     /* 2061961 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2062052), // Rule ID 15533 //
     /* 2061966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062012 */     // MIs[0] round
     /* 2062012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062015 */     // MIs[0] policy
     /* 2062015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062051 */     // GIR_Coverage, 15533,
     /* 2062051 */     GIR_EraseRootFromParent_Done,
     /* 2062052 */   // Label 27435: @2062052
     /* 2062052 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2062143), // Rule ID 15536 //
     /* 2062057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062103 */     // MIs[0] round
     /* 2062103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062106 */     // MIs[0] policy
     /* 2062106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062116 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062142 */     // GIR_Coverage, 15536,
     /* 2062142 */     GIR_EraseRootFromParent_Done,
     /* 2062143 */   // Label 27436: @2062143
     /* 2062143 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2062234), // Rule ID 15537 //
     /* 2062148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062194 */     // MIs[0] round
     /* 2062194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062197 */     // MIs[0] policy
     /* 2062197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062207 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062233 */     // GIR_Coverage, 15537,
     /* 2062233 */     GIR_EraseRootFromParent_Done,
     /* 2062234 */   // Label 27437: @2062234
     /* 2062234 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2062325), // Rule ID 15540 //
     /* 2062239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062285 */     // MIs[0] round
     /* 2062285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062288 */     // MIs[0] policy
     /* 2062288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2062301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062324 */     // GIR_Coverage, 15540,
     /* 2062324 */     GIR_EraseRootFromParent_Done,
     /* 2062325 */   // Label 27438: @2062325
     /* 2062325 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2062416), // Rule ID 15541 //
     /* 2062330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062376 */     // MIs[0] round
     /* 2062376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062379 */     // MIs[0] policy
     /* 2062379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2062392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062415 */     // GIR_Coverage, 15541,
     /* 2062415 */     GIR_EraseRootFromParent_Done,
     /* 2062416 */   // Label 27439: @2062416
     /* 2062416 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2062507), // Rule ID 15544 //
     /* 2062421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062467 */     // MIs[0] round
     /* 2062467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062470 */     // MIs[0] policy
     /* 2062470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062506 */     // GIR_Coverage, 15544,
     /* 2062506 */     GIR_EraseRootFromParent_Done,
     /* 2062507 */   // Label 27440: @2062507
     /* 2062507 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2062598), // Rule ID 15545 //
     /* 2062512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062558 */     // MIs[0] round
     /* 2062558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062561 */     // MIs[0] policy
     /* 2062561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062597 */     // GIR_Coverage, 15545,
     /* 2062597 */     GIR_EraseRootFromParent_Done,
     /* 2062598 */   // Label 27441: @2062598
     /* 2062598 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2062689), // Rule ID 15548 //
     /* 2062603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062649 */     // MIs[0] round
     /* 2062649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062652 */     // MIs[0] policy
     /* 2062652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062662 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062688 */     // GIR_Coverage, 15548,
     /* 2062688 */     GIR_EraseRootFromParent_Done,
     /* 2062689 */   // Label 27442: @2062689
     /* 2062689 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2062780), // Rule ID 15549 //
     /* 2062694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062740 */     // MIs[0] round
     /* 2062740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062743 */     // MIs[0] policy
     /* 2062743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062753 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062779 */     // GIR_Coverage, 15549,
     /* 2062779 */     GIR_EraseRootFromParent_Done,
     /* 2062780 */   // Label 27443: @2062780
     /* 2062780 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2062871), // Rule ID 15552 //
     /* 2062785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062831 */     // MIs[0] round
     /* 2062831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062834 */     // MIs[0] policy
     /* 2062834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062870 */     // GIR_Coverage, 15552,
     /* 2062870 */     GIR_EraseRootFromParent_Done,
     /* 2062871 */   // Label 27444: @2062871
     /* 2062871 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2062962), // Rule ID 15553 //
     /* 2062876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062922 */     // MIs[0] round
     /* 2062922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062925 */     // MIs[0] policy
     /* 2062925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062935 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062961 */     // GIR_Coverage, 15553,
     /* 2062961 */     GIR_EraseRootFromParent_Done,
     /* 2062962 */   // Label 27445: @2062962
     /* 2062962 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2063053), // Rule ID 15556 //
     /* 2062967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063013 */     // MIs[0] round
     /* 2063013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063016 */     // MIs[0] policy
     /* 2063016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063052 */     // GIR_Coverage, 15556,
     /* 2063052 */     GIR_EraseRootFromParent_Done,
     /* 2063053 */   // Label 27446: @2063053
     /* 2063053 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2063144), // Rule ID 15557 //
     /* 2063058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063104 */     // MIs[0] round
     /* 2063104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063107 */     // MIs[0] policy
     /* 2063107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063143 */     // GIR_Coverage, 15557,
     /* 2063143 */     GIR_EraseRootFromParent_Done,
     /* 2063144 */   // Label 27447: @2063144
     /* 2063144 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2063235), // Rule ID 15560 //
     /* 2063149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063195 */     // MIs[0] round
     /* 2063195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063198 */     // MIs[0] policy
     /* 2063198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063234 */     // GIR_Coverage, 15560,
     /* 2063234 */     GIR_EraseRootFromParent_Done,
     /* 2063235 */   // Label 27448: @2063235
     /* 2063235 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2063326), // Rule ID 15561 //
     /* 2063240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063286 */     // MIs[0] round
     /* 2063286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063289 */     // MIs[0] policy
     /* 2063289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063299 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063325 */     // GIR_Coverage, 15561,
     /* 2063325 */     GIR_EraseRootFromParent_Done,
     /* 2063326 */   // Label 27449: @2063326
     /* 2063326 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2063417), // Rule ID 15564 //
     /* 2063331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063377 */     // MIs[0] round
     /* 2063377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063380 */     // MIs[0] policy
     /* 2063380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063416 */     // GIR_Coverage, 15564,
     /* 2063416 */     GIR_EraseRootFromParent_Done,
     /* 2063417 */   // Label 27450: @2063417
     /* 2063417 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2063508), // Rule ID 15565 //
     /* 2063422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063468 */     // MIs[0] round
     /* 2063468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063471 */     // MIs[0] policy
     /* 2063471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063481 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063507 */     // GIR_Coverage, 15565,
     /* 2063507 */     GIR_EraseRootFromParent_Done,
     /* 2063508 */   // Label 27451: @2063508
     /* 2063508 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2063599), // Rule ID 15568 //
     /* 2063513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063559 */     // MIs[0] round
     /* 2063559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063562 */     // MIs[0] policy
     /* 2063562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063572 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063598 */     // GIR_Coverage, 15568,
     /* 2063598 */     GIR_EraseRootFromParent_Done,
     /* 2063599 */   // Label 27452: @2063599
     /* 2063599 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2063690), // Rule ID 15569 //
     /* 2063604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063650 */     // MIs[0] round
     /* 2063650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063653 */     // MIs[0] policy
     /* 2063653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063663 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063689 */     // GIR_Coverage, 15569,
     /* 2063689 */     GIR_EraseRootFromParent_Done,
     /* 2063690 */   // Label 27453: @2063690
     /* 2063690 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2063781), // Rule ID 15572 //
     /* 2063695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063741 */     // MIs[0] round
     /* 2063741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063744 */     // MIs[0] policy
     /* 2063744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063780 */     // GIR_Coverage, 15572,
     /* 2063780 */     GIR_EraseRootFromParent_Done,
     /* 2063781 */   // Label 27454: @2063781
     /* 2063781 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2063872), // Rule ID 15573 //
     /* 2063786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063832 */     // MIs[0] round
     /* 2063832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063835 */     // MIs[0] policy
     /* 2063835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063871 */     // GIR_Coverage, 15573,
     /* 2063871 */     GIR_EraseRootFromParent_Done,
     /* 2063872 */   // Label 27455: @2063872
     /* 2063872 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2063963), // Rule ID 15576 //
     /* 2063877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063923 */     // MIs[0] round
     /* 2063923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063926 */     // MIs[0] policy
     /* 2063926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063962 */     // GIR_Coverage, 15576,
     /* 2063962 */     GIR_EraseRootFromParent_Done,
     /* 2063963 */   // Label 27456: @2063963
     /* 2063963 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2064054), // Rule ID 15577 //
     /* 2063968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064014 */     // MIs[0] round
     /* 2064014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064017 */     // MIs[0] policy
     /* 2064017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11195:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064053 */     // GIR_Coverage, 15577,
     /* 2064053 */     GIR_EraseRootFromParent_Done,
     /* 2064054 */   // Label 27457: @2064054
     /* 2064054 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2064145), // Rule ID 15580 //
     /* 2064059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064105 */     // MIs[0] round
     /* 2064105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064108 */     // MIs[0] policy
     /* 2064108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064144 */     // GIR_Coverage, 15580,
     /* 2064144 */     GIR_EraseRootFromParent_Done,
     /* 2064145 */   // Label 27458: @2064145
     /* 2064145 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2064236), // Rule ID 15581 //
     /* 2064150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064196 */     // MIs[0] round
     /* 2064196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064199 */     // MIs[0] policy
     /* 2064199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064235 */     // GIR_Coverage, 15581,
     /* 2064235 */     GIR_EraseRootFromParent_Done,
     /* 2064236 */   // Label 27459: @2064236
     /* 2064236 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2064327), // Rule ID 15584 //
     /* 2064241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064287 */     // MIs[0] round
     /* 2064287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064290 */     // MIs[0] policy
     /* 2064290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064326 */     // GIR_Coverage, 15584,
     /* 2064326 */     GIR_EraseRootFromParent_Done,
     /* 2064327 */   // Label 27460: @2064327
     /* 2064327 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2064418), // Rule ID 15585 //
     /* 2064332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064378 */     // MIs[0] round
     /* 2064378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064381 */     // MIs[0] policy
     /* 2064381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064391 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064417 */     // GIR_Coverage, 15585,
     /* 2064417 */     GIR_EraseRootFromParent_Done,
     /* 2064418 */   // Label 27461: @2064418
     /* 2064418 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2064509), // Rule ID 15588 //
     /* 2064423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2064426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064469 */     // MIs[0] round
     /* 2064469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064472 */     // MIs[0] policy
     /* 2064472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064508 */     // GIR_Coverage, 15588,
     /* 2064508 */     GIR_EraseRootFromParent_Done,
     /* 2064509 */   // Label 27462: @2064509
     /* 2064509 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2064600), // Rule ID 15589 //
     /* 2064514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2064517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064560 */     // MIs[0] round
     /* 2064560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064563 */     // MIs[0] policy
     /* 2064563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064573 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064599 */     // GIR_Coverage, 15589,
     /* 2064599 */     GIR_EraseRootFromParent_Done,
     /* 2064600 */   // Label 27463: @2064600
     /* 2064600 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2064691), // Rule ID 15592 //
     /* 2064605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064651 */     // MIs[0] round
     /* 2064651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064654 */     // MIs[0] policy
     /* 2064654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064690 */     // GIR_Coverage, 15592,
     /* 2064690 */     GIR_EraseRootFromParent_Done,
     /* 2064691 */   // Label 27464: @2064691
     /* 2064691 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2064782), // Rule ID 15593 //
     /* 2064696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064742 */     // MIs[0] round
     /* 2064742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064745 */     // MIs[0] policy
     /* 2064745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064755 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064781 */     // GIR_Coverage, 15593,
     /* 2064781 */     GIR_EraseRootFromParent_Done,
     /* 2064782 */   // Label 27465: @2064782
     /* 2064782 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2064873), // Rule ID 15596 //
     /* 2064787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064833 */     // MIs[0] round
     /* 2064833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064836 */     // MIs[0] policy
     /* 2064836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064872 */     // GIR_Coverage, 15596,
     /* 2064872 */     GIR_EraseRootFromParent_Done,
     /* 2064873 */   // Label 27466: @2064873
     /* 2064873 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2064964), // Rule ID 15597 //
     /* 2064878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064924 */     // MIs[0] round
     /* 2064924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064927 */     // MIs[0] policy
     /* 2064927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064937 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064963 */     // GIR_Coverage, 15597,
     /* 2064963 */     GIR_EraseRootFromParent_Done,
     /* 2064964 */   // Label 27467: @2064964
     /* 2064964 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2065055), // Rule ID 15600 //
     /* 2064969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065015 */     // MIs[0] round
     /* 2065015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065018 */     // MIs[0] policy
     /* 2065018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065028 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065054 */     // GIR_Coverage, 15600,
     /* 2065054 */     GIR_EraseRootFromParent_Done,
     /* 2065055 */   // Label 27468: @2065055
     /* 2065055 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2065146), // Rule ID 15601 //
     /* 2065060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2065071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2065074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2065077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065106 */     // MIs[0] round
     /* 2065106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065109 */     // MIs[0] policy
     /* 2065109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065119 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065145 */     // GIR_Coverage, 15601,
     /* 2065145 */     GIR_EraseRootFromParent_Done,
     /* 2065146 */   // Label 27469: @2065146
     /* 2065146 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2065237), // Rule ID 15604 //
     /* 2065151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065197 */     // MIs[0] round
     /* 2065197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065200 */     // MIs[0] policy
     /* 2065200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065236 */     // GIR_Coverage, 15604,
     /* 2065236 */     GIR_EraseRootFromParent_Done,
     /* 2065237 */   // Label 27470: @2065237
     /* 2065237 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2065328), // Rule ID 15605 //
     /* 2065242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065288 */     // MIs[0] round
     /* 2065288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065291 */     // MIs[0] policy
     /* 2065291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065327 */     // GIR_Coverage, 15605,
     /* 2065327 */     GIR_EraseRootFromParent_Done,
     /* 2065328 */   // Label 27471: @2065328
     /* 2065328 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2065419), // Rule ID 15608 //
     /* 2065333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065379 */     // MIs[0] round
     /* 2065379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065382 */     // MIs[0] policy
     /* 2065382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065418 */     // GIR_Coverage, 15608,
     /* 2065418 */     GIR_EraseRootFromParent_Done,
     /* 2065419 */   // Label 27472: @2065419
     /* 2065419 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2065510), // Rule ID 15609 //
     /* 2065424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065470 */     // MIs[0] round
     /* 2065470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065473 */     // MIs[0] policy
     /* 2065473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065483 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065509 */     // GIR_Coverage, 15609,
     /* 2065509 */     GIR_EraseRootFromParent_Done,
     /* 2065510 */   // Label 27473: @2065510
     /* 2065510 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2065601), // Rule ID 15612 //
     /* 2065515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065561 */     // MIs[0] round
     /* 2065561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065564 */     // MIs[0] policy
     /* 2065564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065600 */     // GIR_Coverage, 15612,
     /* 2065600 */     GIR_EraseRootFromParent_Done,
     /* 2065601 */   // Label 27474: @2065601
     /* 2065601 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2065692), // Rule ID 15613 //
     /* 2065606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065652 */     // MIs[0] round
     /* 2065652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065655 */     // MIs[0] policy
     /* 2065655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065665 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065691 */     // GIR_Coverage, 15613,
     /* 2065691 */     GIR_EraseRootFromParent_Done,
     /* 2065692 */   // Label 27475: @2065692
     /* 2065692 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2065783), // Rule ID 15616 //
     /* 2065697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065743 */     // MIs[0] round
     /* 2065743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065746 */     // MIs[0] policy
     /* 2065746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065782 */     // GIR_Coverage, 15616,
     /* 2065782 */     GIR_EraseRootFromParent_Done,
     /* 2065783 */   // Label 27476: @2065783
     /* 2065783 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2065874), // Rule ID 15617 //
     /* 2065788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065834 */     // MIs[0] round
     /* 2065834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065837 */     // MIs[0] policy
     /* 2065837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065873 */     // GIR_Coverage, 15617,
     /* 2065873 */     GIR_EraseRootFromParent_Done,
     /* 2065874 */   // Label 27477: @2065874
     /* 2065874 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2065965), // Rule ID 15620 //
     /* 2065879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065925 */     // MIs[0] round
     /* 2065925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065928 */     // MIs[0] policy
     /* 2065928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065964 */     // GIR_Coverage, 15620,
     /* 2065964 */     GIR_EraseRootFromParent_Done,
     /* 2065965 */   // Label 27478: @2065965
     /* 2065965 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2066056), // Rule ID 15621 //
     /* 2065970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066016 */     // MIs[0] round
     /* 2066016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066019 */     // MIs[0] policy
     /* 2066019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066029 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066055 */     // GIR_Coverage, 15621,
     /* 2066055 */     GIR_EraseRootFromParent_Done,
     /* 2066056 */   // Label 27479: @2066056
     /* 2066056 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2066147), // Rule ID 15624 //
     /* 2066061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066107 */     // MIs[0] round
     /* 2066107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066110 */     // MIs[0] policy
     /* 2066110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066120 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066146 */     // GIR_Coverage, 15624,
     /* 2066146 */     GIR_EraseRootFromParent_Done,
     /* 2066147 */   // Label 27480: @2066147
     /* 2066147 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2066238), // Rule ID 15625 //
     /* 2066152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066198 */     // MIs[0] round
     /* 2066198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066201 */     // MIs[0] policy
     /* 2066201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066211 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066237 */     // GIR_Coverage, 15625,
     /* 2066237 */     GIR_EraseRootFromParent_Done,
     /* 2066238 */   // Label 27481: @2066238
     /* 2066238 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2066329), // Rule ID 15628 //
     /* 2066243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066289 */     // MIs[0] round
     /* 2066289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066292 */     // MIs[0] policy
     /* 2066292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2066305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066328 */     // GIR_Coverage, 15628,
     /* 2066328 */     GIR_EraseRootFromParent_Done,
     /* 2066329 */   // Label 27482: @2066329
     /* 2066329 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2066420), // Rule ID 15629 //
     /* 2066334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066380 */     // MIs[0] round
     /* 2066380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066383 */     // MIs[0] policy
     /* 2066383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2066396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066419 */     // GIR_Coverage, 15629,
     /* 2066419 */     GIR_EraseRootFromParent_Done,
     /* 2066420 */   // Label 27483: @2066420
     /* 2066420 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2066511), // Rule ID 15632 //
     /* 2066425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066471 */     // MIs[0] round
     /* 2066471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066474 */     // MIs[0] policy
     /* 2066474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066510 */     // GIR_Coverage, 15632,
     /* 2066510 */     GIR_EraseRootFromParent_Done,
     /* 2066511 */   // Label 27484: @2066511
     /* 2066511 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2066602), // Rule ID 15633 //
     /* 2066516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066562 */     // MIs[0] round
     /* 2066562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066565 */     // MIs[0] policy
     /* 2066565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066575 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066601 */     // GIR_Coverage, 15633,
     /* 2066601 */     GIR_EraseRootFromParent_Done,
     /* 2066602 */   // Label 27485: @2066602
     /* 2066602 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2066693), // Rule ID 15636 //
     /* 2066607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066653 */     // MIs[0] round
     /* 2066653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066656 */     // MIs[0] policy
     /* 2066656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066692 */     // GIR_Coverage, 15636,
     /* 2066692 */     GIR_EraseRootFromParent_Done,
     /* 2066693 */   // Label 27486: @2066693
     /* 2066693 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2066784), // Rule ID 15637 //
     /* 2066698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066744 */     // MIs[0] round
     /* 2066744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066747 */     // MIs[0] policy
     /* 2066747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066757 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066783 */     // GIR_Coverage, 15637,
     /* 2066783 */     GIR_EraseRootFromParent_Done,
     /* 2066784 */   // Label 27487: @2066784
     /* 2066784 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2066878), // Rule ID 15640 //
     /* 2066789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066835 */     // MIs[0] round
     /* 2066835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066838 */     // MIs[0] policy
     /* 2066838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066877 */     // GIR_Coverage, 15640,
     /* 2066877 */     GIR_EraseRootFromParent_Done,
     /* 2066878 */   // Label 27488: @2066878
     /* 2066878 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2066972), // Rule ID 15641 //
     /* 2066883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066929 */     // MIs[0] round
     /* 2066929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066932 */     // MIs[0] policy
     /* 2066932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066971 */     // GIR_Coverage, 15641,
     /* 2066971 */     GIR_EraseRootFromParent_Done,
     /* 2066972 */   // Label 27489: @2066972
     /* 2066972 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2067066), // Rule ID 15644 //
     /* 2066977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2066997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067023 */     // MIs[0] round
     /* 2067023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067026 */     // MIs[0] policy
     /* 2067026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067065 */     // GIR_Coverage, 15644,
     /* 2067065 */     GIR_EraseRootFromParent_Done,
     /* 2067066 */   // Label 27490: @2067066
     /* 2067066 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2067160), // Rule ID 15645 //
     /* 2067071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2067082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2067085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2067091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067117 */     // MIs[0] round
     /* 2067117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067120 */     // MIs[0] policy
     /* 2067120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067159 */     // GIR_Coverage, 15645,
     /* 2067159 */     GIR_EraseRootFromParent_Done,
     /* 2067160 */   // Label 27491: @2067160
     /* 2067160 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2067254), // Rule ID 15648 //
     /* 2067165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2067185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067211 */     // MIs[0] round
     /* 2067211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067214 */     // MIs[0] policy
     /* 2067214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067253 */     // GIR_Coverage, 15648,
     /* 2067253 */     GIR_EraseRootFromParent_Done,
     /* 2067254 */   // Label 27492: @2067254
     /* 2067254 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2067348), // Rule ID 15649 //
     /* 2067259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2067279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067305 */     // MIs[0] round
     /* 2067305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067308 */     // MIs[0] policy
     /* 2067308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067347 */     // GIR_Coverage, 15649,
     /* 2067347 */     GIR_EraseRootFromParent_Done,
     /* 2067348 */   // Label 27493: @2067348
     /* 2067348 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2067442), // Rule ID 15652 //
     /* 2067353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067399 */     // MIs[0] round
     /* 2067399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067402 */     // MIs[0] policy
     /* 2067402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067441 */     // GIR_Coverage, 15652,
     /* 2067441 */     GIR_EraseRootFromParent_Done,
     /* 2067442 */   // Label 27494: @2067442
     /* 2067442 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2067536), // Rule ID 15653 //
     /* 2067447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067493 */     // MIs[0] round
     /* 2067493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067496 */     // MIs[0] policy
     /* 2067496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067535 */     // GIR_Coverage, 15653,
     /* 2067535 */     GIR_EraseRootFromParent_Done,
     /* 2067536 */   // Label 27495: @2067536
     /* 2067536 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2067630), // Rule ID 15656 //
     /* 2067541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067587 */     // MIs[0] round
     /* 2067587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067590 */     // MIs[0] policy
     /* 2067590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067600 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067629 */     // GIR_Coverage, 15656,
     /* 2067629 */     GIR_EraseRootFromParent_Done,
     /* 2067630 */   // Label 27496: @2067630
     /* 2067630 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2067724), // Rule ID 15657 //
     /* 2067635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067681 */     // MIs[0] round
     /* 2067681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067684 */     // MIs[0] policy
     /* 2067684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067723 */     // GIR_Coverage, 15657,
     /* 2067723 */     GIR_EraseRootFromParent_Done,
     /* 2067724 */   // Label 27497: @2067724
     /* 2067724 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2067818), // Rule ID 15660 //
     /* 2067729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067775 */     // MIs[0] round
     /* 2067775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067778 */     // MIs[0] policy
     /* 2067778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067788 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067817 */     // GIR_Coverage, 15660,
     /* 2067817 */     GIR_EraseRootFromParent_Done,
     /* 2067818 */   // Label 27498: @2067818
     /* 2067818 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2067912), // Rule ID 15661 //
     /* 2067823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067869 */     // MIs[0] round
     /* 2067869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067872 */     // MIs[0] policy
     /* 2067872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067911 */     // GIR_Coverage, 15661,
     /* 2067911 */     GIR_EraseRootFromParent_Done,
     /* 2067912 */   // Label 27499: @2067912
     /* 2067912 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2068006), // Rule ID 15664 //
     /* 2067917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067963 */     // MIs[0] round
     /* 2067963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067966 */     // MIs[0] policy
     /* 2067966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068005 */     // GIR_Coverage, 15664,
     /* 2068005 */     GIR_EraseRootFromParent_Done,
     /* 2068006 */   // Label 27500: @2068006
     /* 2068006 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2068100), // Rule ID 15665 //
     /* 2068011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2068031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068057 */     // MIs[0] round
     /* 2068057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068060 */     // MIs[0] policy
     /* 2068060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068099 */     // GIR_Coverage, 15665,
     /* 2068099 */     GIR_EraseRootFromParent_Done,
     /* 2068100 */   // Label 27501: @2068100
     /* 2068100 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2068194), // Rule ID 15668 //
     /* 2068105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2068125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068151 */     // MIs[0] round
     /* 2068151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068154 */     // MIs[0] policy
     /* 2068154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068193 */     // GIR_Coverage, 15668,
     /* 2068193 */     GIR_EraseRootFromParent_Done,
     /* 2068194 */   // Label 27502: @2068194
     /* 2068194 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2068288), // Rule ID 15669 //
     /* 2068199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2068219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068245 */     // MIs[0] round
     /* 2068245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068248 */     // MIs[0] policy
     /* 2068248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068287 */     // GIR_Coverage, 15669,
     /* 2068287 */     GIR_EraseRootFromParent_Done,
     /* 2068288 */   // Label 27503: @2068288
     /* 2068288 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2068382), // Rule ID 15672 //
     /* 2068293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068339 */     // MIs[0] round
     /* 2068339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068342 */     // MIs[0] policy
     /* 2068342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068381 */     // GIR_Coverage, 15672,
     /* 2068381 */     GIR_EraseRootFromParent_Done,
     /* 2068382 */   // Label 27504: @2068382
     /* 2068382 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2068476), // Rule ID 15673 //
     /* 2068387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2068407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068433 */     // MIs[0] round
     /* 2068433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068436 */     // MIs[0] policy
     /* 2068436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2068449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068475 */     // GIR_Coverage, 15673,
     /* 2068475 */     GIR_EraseRootFromParent_Done,
     /* 2068476 */   // Label 27505: @2068476
     /* 2068476 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2068570), // Rule ID 15676 //
     /* 2068481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068527 */     // MIs[0] round
     /* 2068527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068530 */     // MIs[0] policy
     /* 2068530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068540 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068569 */     // GIR_Coverage, 15676,
     /* 2068569 */     GIR_EraseRootFromParent_Done,
     /* 2068570 */   // Label 27506: @2068570
     /* 2068570 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2068664), // Rule ID 15677 //
     /* 2068575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068621 */     // MIs[0] round
     /* 2068621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068624 */     // MIs[0] policy
     /* 2068624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068663 */     // GIR_Coverage, 15677,
     /* 2068663 */     GIR_EraseRootFromParent_Done,
     /* 2068664 */   // Label 27507: @2068664
     /* 2068664 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2068758), // Rule ID 15680 //
     /* 2068669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068715 */     // MIs[0] round
     /* 2068715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068718 */     // MIs[0] policy
     /* 2068718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068728 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068757 */     // GIR_Coverage, 15680,
     /* 2068757 */     GIR_EraseRootFromParent_Done,
     /* 2068758 */   // Label 27508: @2068758
     /* 2068758 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2068852), // Rule ID 15681 //
     /* 2068763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068809 */     // MIs[0] round
     /* 2068809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068812 */     // MIs[0] policy
     /* 2068812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068851 */     // GIR_Coverage, 15681,
     /* 2068851 */     GIR_EraseRootFromParent_Done,
     /* 2068852 */   // Label 27509: @2068852
     /* 2068852 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2068946), // Rule ID 15684 //
     /* 2068857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068903 */     // MIs[0] round
     /* 2068903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068906 */     // MIs[0] policy
     /* 2068906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068916 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068945 */     // GIR_Coverage, 15684,
     /* 2068945 */     GIR_EraseRootFromParent_Done,
     /* 2068946 */   // Label 27510: @2068946
     /* 2068946 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2069040), // Rule ID 15685 //
     /* 2068951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068997 */     // MIs[0] round
     /* 2068997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069000 */     // MIs[0] policy
     /* 2069000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069010 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069039 */     // GIR_Coverage, 15685,
     /* 2069039 */     GIR_EraseRootFromParent_Done,
     /* 2069040 */   // Label 27511: @2069040
     /* 2069040 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2069134), // Rule ID 15688 //
     /* 2069045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2069065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069091 */     // MIs[0] round
     /* 2069091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069094 */     // MIs[0] policy
     /* 2069094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069133 */     // GIR_Coverage, 15688,
     /* 2069133 */     GIR_EraseRootFromParent_Done,
     /* 2069134 */   // Label 27512: @2069134
     /* 2069134 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2069228), // Rule ID 15689 //
     /* 2069139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2069159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069185 */     // MIs[0] round
     /* 2069185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069188 */     // MIs[0] policy
     /* 2069188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069227 */     // GIR_Coverage, 15689,
     /* 2069227 */     GIR_EraseRootFromParent_Done,
     /* 2069228 */   // Label 27513: @2069228
     /* 2069228 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2069322), // Rule ID 15692 //
     /* 2069233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2069244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2069247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2069250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2069253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069279 */     // MIs[0] round
     /* 2069279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069282 */     // MIs[0] policy
     /* 2069282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069292 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069321 */     // GIR_Coverage, 15692,
     /* 2069321 */     GIR_EraseRootFromParent_Done,
     /* 2069322 */   // Label 27514: @2069322
     /* 2069322 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2069416), // Rule ID 15693 //
     /* 2069327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2069338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2069341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2069344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2069347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069373 */     // MIs[0] round
     /* 2069373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069376 */     // MIs[0] policy
     /* 2069376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069415 */     // GIR_Coverage, 15693,
     /* 2069415 */     GIR_EraseRootFromParent_Done,
     /* 2069416 */   // Label 27515: @2069416
     /* 2069416 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2069510), // Rule ID 15696 //
     /* 2069421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069467 */     // MIs[0] round
     /* 2069467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069470 */     // MIs[0] policy
     /* 2069470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069509 */     // GIR_Coverage, 15696,
     /* 2069509 */     GIR_EraseRootFromParent_Done,
     /* 2069510 */   // Label 27516: @2069510
     /* 2069510 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2069604), // Rule ID 15697 //
     /* 2069515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069561 */     // MIs[0] round
     /* 2069561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069564 */     // MIs[0] policy
     /* 2069564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069603 */     // GIR_Coverage, 15697,
     /* 2069603 */     GIR_EraseRootFromParent_Done,
     /* 2069604 */   // Label 27517: @2069604
     /* 2069604 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2069698), // Rule ID 15700 //
     /* 2069609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069655 */     // MIs[0] round
     /* 2069655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069658 */     // MIs[0] policy
     /* 2069658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069697 */     // GIR_Coverage, 15700,
     /* 2069697 */     GIR_EraseRootFromParent_Done,
     /* 2069698 */   // Label 27518: @2069698
     /* 2069698 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2069792), // Rule ID 15701 //
     /* 2069703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069749 */     // MIs[0] round
     /* 2069749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069752 */     // MIs[0] policy
     /* 2069752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069791 */     // GIR_Coverage, 15701,
     /* 2069791 */     GIR_EraseRootFromParent_Done,
     /* 2069792 */   // Label 27519: @2069792
     /* 2069792 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2069886), // Rule ID 15704 //
     /* 2069797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069843 */     // MIs[0] round
     /* 2069843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069846 */     // MIs[0] policy
     /* 2069846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069885 */     // GIR_Coverage, 15704,
     /* 2069885 */     GIR_EraseRootFromParent_Done,
     /* 2069886 */   // Label 27520: @2069886
     /* 2069886 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2069980), // Rule ID 15705 //
     /* 2069891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069937 */     // MIs[0] round
     /* 2069937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069940 */     // MIs[0] policy
     /* 2069940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069979 */     // GIR_Coverage, 15705,
     /* 2069979 */     GIR_EraseRootFromParent_Done,
     /* 2069980 */   // Label 27521: @2069980
     /* 2069980 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2070074), // Rule ID 15708 //
     /* 2069985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2070005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070031 */     // MIs[0] round
     /* 2070031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070034 */     // MIs[0] policy
     /* 2070034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2070047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070073 */     // GIR_Coverage, 15708,
     /* 2070073 */     GIR_EraseRootFromParent_Done,
     /* 2070074 */   // Label 27522: @2070074
     /* 2070074 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2070168), // Rule ID 15709 //
     /* 2070079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2070090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2070093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2070099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070125 */     // MIs[0] round
     /* 2070125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070128 */     // MIs[0] policy
     /* 2070128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070138 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2070141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070167 */     // GIR_Coverage, 15709,
     /* 2070167 */     GIR_EraseRootFromParent_Done,
     /* 2070168 */   // Label 27523: @2070168
     /* 2070168 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2070262), // Rule ID 15712 //
     /* 2070173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070219 */     // MIs[0] round
     /* 2070219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070222 */     // MIs[0] policy
     /* 2070222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070232 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2070235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070261 */     // GIR_Coverage, 15712,
     /* 2070261 */     GIR_EraseRootFromParent_Done,
     /* 2070262 */   // Label 27524: @2070262
     /* 2070262 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2070356), // Rule ID 15713 //
     /* 2070267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2070278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2070281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2070284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070313 */     // MIs[0] round
     /* 2070313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070316 */     // MIs[0] policy
     /* 2070316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070326 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2070329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070355 */     // GIR_Coverage, 15713,
     /* 2070355 */     GIR_EraseRootFromParent_Done,
     /* 2070356 */   // Label 27525: @2070356
     /* 2070356 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2070450), // Rule ID 15716 //
     /* 2070361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070407 */     // MIs[0] round
     /* 2070407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070410 */     // MIs[0] policy
     /* 2070410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070420 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070449 */     // GIR_Coverage, 15716,
     /* 2070449 */     GIR_EraseRootFromParent_Done,
     /* 2070450 */   // Label 27526: @2070450
     /* 2070450 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2070544), // Rule ID 15717 //
     /* 2070455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070501 */     // MIs[0] round
     /* 2070501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070504 */     // MIs[0] policy
     /* 2070504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070543 */     // GIR_Coverage, 15717,
     /* 2070543 */     GIR_EraseRootFromParent_Done,
     /* 2070544 */   // Label 27527: @2070544
     /* 2070544 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2070638), // Rule ID 15720 //
     /* 2070549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070595 */     // MIs[0] round
     /* 2070595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070598 */     // MIs[0] policy
     /* 2070598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070608 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070637 */     // GIR_Coverage, 15720,
     /* 2070637 */     GIR_EraseRootFromParent_Done,
     /* 2070638 */   // Label 27528: @2070638
     /* 2070638 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2070732), // Rule ID 15721 //
     /* 2070643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070689 */     // MIs[0] round
     /* 2070689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070692 */     // MIs[0] policy
     /* 2070692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070731 */     // GIR_Coverage, 15721,
     /* 2070731 */     GIR_EraseRootFromParent_Done,
     /* 2070732 */   // Label 27529: @2070732
     /* 2070732 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2070826), // Rule ID 15724 //
     /* 2070737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070783 */     // MIs[0] round
     /* 2070783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070786 */     // MIs[0] policy
     /* 2070786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070825 */     // GIR_Coverage, 15724,
     /* 2070825 */     GIR_EraseRootFromParent_Done,
     /* 2070826 */   // Label 27530: @2070826
     /* 2070826 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2070920), // Rule ID 15725 //
     /* 2070831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070877 */     // MIs[0] round
     /* 2070877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070880 */     // MIs[0] policy
     /* 2070880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070919 */     // GIR_Coverage, 15725,
     /* 2070919 */     GIR_EraseRootFromParent_Done,
     /* 2070920 */   // Label 27531: @2070920
     /* 2070920 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2071014), // Rule ID 15728 //
     /* 2070925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070971 */     // MIs[0] round
     /* 2070971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070974 */     // MIs[0] policy
     /* 2070974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071013 */     // GIR_Coverage, 15728,
     /* 2071013 */     GIR_EraseRootFromParent_Done,
     /* 2071014 */   // Label 27532: @2071014
     /* 2071014 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2071108), // Rule ID 15729 //
     /* 2071019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2071030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2071033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2071036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071065 */     // MIs[0] round
     /* 2071065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071068 */     // MIs[0] policy
     /* 2071068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071107 */     // GIR_Coverage, 15729,
     /* 2071107 */     GIR_EraseRootFromParent_Done,
     /* 2071108 */   // Label 27533: @2071108
     /* 2071108 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2071202), // Rule ID 15732 //
     /* 2071113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071159 */     // MIs[0] round
     /* 2071159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071162 */     // MIs[0] policy
     /* 2071162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071201 */     // GIR_Coverage, 15732,
     /* 2071201 */     GIR_EraseRootFromParent_Done,
     /* 2071202 */   // Label 27534: @2071202
     /* 2071202 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2071296), // Rule ID 15733 //
     /* 2071207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2071218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2071221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2071224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071253 */     // MIs[0] round
     /* 2071253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071256 */     // MIs[0] policy
     /* 2071256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071266 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2071269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071295 */     // GIR_Coverage, 15733,
     /* 2071295 */     GIR_EraseRootFromParent_Done,
     /* 2071296 */   // Label 27535: @2071296
     /* 2071296 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2071390), // Rule ID 15736 //
     /* 2071301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071347 */     // MIs[0] round
     /* 2071347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071350 */     // MIs[0] policy
     /* 2071350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071389 */     // GIR_Coverage, 15736,
     /* 2071389 */     GIR_EraseRootFromParent_Done,
     /* 2071390 */   // Label 27536: @2071390
     /* 2071390 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2071484), // Rule ID 15737 //
     /* 2071395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2071406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2071409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2071412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071441 */     // MIs[0] round
     /* 2071441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071444 */     // MIs[0] policy
     /* 2071444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071483 */     // GIR_Coverage, 15737,
     /* 2071483 */     GIR_EraseRootFromParent_Done,
     /* 2071484 */   // Label 27537: @2071484
     /* 2071484 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2071578), // Rule ID 15740 //
     /* 2071489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071535 */     // MIs[0] round
     /* 2071535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071538 */     // MIs[0] policy
     /* 2071538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071577 */     // GIR_Coverage, 15740,
     /* 2071577 */     GIR_EraseRootFromParent_Done,
     /* 2071578 */   // Label 27538: @2071578
     /* 2071578 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2071672), // Rule ID 15741 //
     /* 2071583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071629 */     // MIs[0] round
     /* 2071629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071632 */     // MIs[0] policy
     /* 2071632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071671 */     // GIR_Coverage, 15741,
     /* 2071671 */     GIR_EraseRootFromParent_Done,
     /* 2071672 */   // Label 27539: @2071672
     /* 2071672 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2071766), // Rule ID 15744 //
     /* 2071677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071723 */     // MIs[0] round
     /* 2071723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071726 */     // MIs[0] policy
     /* 2071726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071765 */     // GIR_Coverage, 15744,
     /* 2071765 */     GIR_EraseRootFromParent_Done,
     /* 2071766 */   // Label 27540: @2071766
     /* 2071766 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2071860), // Rule ID 15745 //
     /* 2071771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071817 */     // MIs[0] round
     /* 2071817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071820 */     // MIs[0] policy
     /* 2071820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071859 */     // GIR_Coverage, 15745,
     /* 2071859 */     GIR_EraseRootFromParent_Done,
     /* 2071860 */   // Label 27541: @2071860
     /* 2071860 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2071954), // Rule ID 15748 //
     /* 2071865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071911 */     // MIs[0] round
     /* 2071911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071914 */     // MIs[0] policy
     /* 2071914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071953 */     // GIR_Coverage, 15748,
     /* 2071953 */     GIR_EraseRootFromParent_Done,
     /* 2071954 */   // Label 27542: @2071954
     /* 2071954 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2072048), // Rule ID 15749 //
     /* 2071959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072005 */     // MIs[0] round
     /* 2072005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072008 */     // MIs[0] policy
     /* 2072008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072047 */     // GIR_Coverage, 15749,
     /* 2072047 */     GIR_EraseRootFromParent_Done,
     /* 2072048 */   // Label 27543: @2072048
     /* 2072048 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2072142), // Rule ID 15752 //
     /* 2072053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072099 */     // MIs[0] round
     /* 2072099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072102 */     // MIs[0] policy
     /* 2072102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072112 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072141 */     // GIR_Coverage, 15752,
     /* 2072141 */     GIR_EraseRootFromParent_Done,
     /* 2072142 */   // Label 27544: @2072142
     /* 2072142 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2072236), // Rule ID 15753 //
     /* 2072147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2072158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2072161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2072164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072193 */     // MIs[0] round
     /* 2072193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072196 */     // MIs[0] policy
     /* 2072196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072206 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072235 */     // GIR_Coverage, 15753,
     /* 2072235 */     GIR_EraseRootFromParent_Done,
     /* 2072236 */   // Label 27545: @2072236
     /* 2072236 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2072330), // Rule ID 15756 //
     /* 2072241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072287 */     // MIs[0] round
     /* 2072287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072290 */     // MIs[0] policy
     /* 2072290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072300 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072329 */     // GIR_Coverage, 15756,
     /* 2072329 */     GIR_EraseRootFromParent_Done,
     /* 2072330 */   // Label 27546: @2072330
     /* 2072330 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2072424), // Rule ID 15757 //
     /* 2072335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2072346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2072349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2072352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2072358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072381 */     // MIs[0] round
     /* 2072381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072384 */     // MIs[0] policy
     /* 2072384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072423 */     // GIR_Coverage, 15757,
     /* 2072423 */     GIR_EraseRootFromParent_Done,
     /* 2072424 */   // Label 27547: @2072424
     /* 2072424 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2072518), // Rule ID 15760 //
     /* 2072429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072475 */     // MIs[0] round
     /* 2072475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072478 */     // MIs[0] policy
     /* 2072478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072517 */     // GIR_Coverage, 15760,
     /* 2072517 */     GIR_EraseRootFromParent_Done,
     /* 2072518 */   // Label 27548: @2072518
     /* 2072518 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2072612), // Rule ID 15761 //
     /* 2072523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072569 */     // MIs[0] round
     /* 2072569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072572 */     // MIs[0] policy
     /* 2072572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072582 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072611 */     // GIR_Coverage, 15761,
     /* 2072611 */     GIR_EraseRootFromParent_Done,
     /* 2072612 */   // Label 27549: @2072612
     /* 2072612 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2072706), // Rule ID 15764 //
     /* 2072617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072663 */     // MIs[0] round
     /* 2072663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072666 */     // MIs[0] policy
     /* 2072666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072705 */     // GIR_Coverage, 15764,
     /* 2072705 */     GIR_EraseRootFromParent_Done,
     /* 2072706 */   // Label 27550: @2072706
     /* 2072706 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2072800), // Rule ID 15765 //
     /* 2072711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072757 */     // MIs[0] round
     /* 2072757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072760 */     // MIs[0] policy
     /* 2072760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072799 */     // GIR_Coverage, 15765,
     /* 2072799 */     GIR_EraseRootFromParent_Done,
     /* 2072800 */   // Label 27551: @2072800
     /* 2072800 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2072894), // Rule ID 15768 //
     /* 2072805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072851 */     // MIs[0] round
     /* 2072851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072854 */     // MIs[0] policy
     /* 2072854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072893 */     // GIR_Coverage, 15768,
     /* 2072893 */     GIR_EraseRootFromParent_Done,
     /* 2072894 */   // Label 27552: @2072894
     /* 2072894 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2072988), // Rule ID 15769 //
     /* 2072899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072945 */     // MIs[0] round
     /* 2072945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072948 */     // MIs[0] policy
     /* 2072948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072958 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072987 */     // GIR_Coverage, 15769,
     /* 2072987 */     GIR_EraseRootFromParent_Done,
     /* 2072988 */   // Label 27553: @2072988
     /* 2072988 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2073082), // Rule ID 15772 //
     /* 2072993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2073004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073039 */     // MIs[0] round
     /* 2073039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073042 */     // MIs[0] policy
     /* 2073042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2073055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073081 */     // GIR_Coverage, 15772,
     /* 2073081 */     GIR_EraseRootFromParent_Done,
     /* 2073082 */   // Label 27554: @2073082
     /* 2073082 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2073176), // Rule ID 15773 //
     /* 2073087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2073098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2073101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2073104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073133 */     // MIs[0] round
     /* 2073133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073136 */     // MIs[0] policy
     /* 2073136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2073149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073175 */     // GIR_Coverage, 15773,
     /* 2073175 */     GIR_EraseRootFromParent_Done,
     /* 2073176 */   // Label 27555: @2073176
     /* 2073176 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2073270), // Rule ID 15776 //
     /* 2073181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073227 */     // MIs[0] round
     /* 2073227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073230 */     // MIs[0] policy
     /* 2073230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2073243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073269 */     // GIR_Coverage, 15776,
     /* 2073269 */     GIR_EraseRootFromParent_Done,
     /* 2073270 */   // Label 27556: @2073270
     /* 2073270 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2073364), // Rule ID 15777 //
     /* 2073275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2073286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2073289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2073292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073321 */     // MIs[0] round
     /* 2073321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073324 */     // MIs[0] policy
     /* 2073324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2073337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073363 */     // GIR_Coverage, 15777,
     /* 2073363 */     GIR_EraseRootFromParent_Done,
     /* 2073364 */   // Label 27557: @2073364
     /* 2073364 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2073458), // Rule ID 15780 //
     /* 2073369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073415 */     // MIs[0] round
     /* 2073415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073418 */     // MIs[0] policy
     /* 2073418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073457 */     // GIR_Coverage, 15780,
     /* 2073457 */     GIR_EraseRootFromParent_Done,
     /* 2073458 */   // Label 27558: @2073458
     /* 2073458 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2073552), // Rule ID 15781 //
     /* 2073463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073509 */     // MIs[0] round
     /* 2073509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073512 */     // MIs[0] policy
     /* 2073512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073522 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073551 */     // GIR_Coverage, 15781,
     /* 2073551 */     GIR_EraseRootFromParent_Done,
     /* 2073552 */   // Label 27559: @2073552
     /* 2073552 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2073646), // Rule ID 15784 //
     /* 2073557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073603 */     // MIs[0] round
     /* 2073603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073606 */     // MIs[0] policy
     /* 2073606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073645 */     // GIR_Coverage, 15784,
     /* 2073645 */     GIR_EraseRootFromParent_Done,
     /* 2073646 */   // Label 27560: @2073646
     /* 2073646 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2073740), // Rule ID 15785 //
     /* 2073651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073697 */     // MIs[0] round
     /* 2073697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073700 */     // MIs[0] policy
     /* 2073700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073739 */     // GIR_Coverage, 15785,
     /* 2073739 */     GIR_EraseRootFromParent_Done,
     /* 2073740 */   // Label 27561: @2073740
     /* 2073740 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2073834), // Rule ID 15788 //
     /* 2073745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073791 */     // MIs[0] round
     /* 2073791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073794 */     // MIs[0] policy
     /* 2073794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073833 */     // GIR_Coverage, 15788,
     /* 2073833 */     GIR_EraseRootFromParent_Done,
     /* 2073834 */   // Label 27562: @2073834
     /* 2073834 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2073928), // Rule ID 15789 //
     /* 2073839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073885 */     // MIs[0] round
     /* 2073885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073888 */     // MIs[0] policy
     /* 2073888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073927 */     // GIR_Coverage, 15789,
     /* 2073927 */     GIR_EraseRootFromParent_Done,
     /* 2073928 */   // Label 27563: @2073928
     /* 2073928 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2074022), // Rule ID 15792 //
     /* 2073933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073979 */     // MIs[0] round
     /* 2073979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073982 */     // MIs[0] policy
     /* 2073982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074021 */     // GIR_Coverage, 15792,
     /* 2074021 */     GIR_EraseRootFromParent_Done,
     /* 2074022 */   // Label 27564: @2074022
     /* 2074022 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2074116), // Rule ID 15793 //
     /* 2074027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2074047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074073 */     // MIs[0] round
     /* 2074073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074076 */     // MIs[0] policy
     /* 2074076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2074089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074115 */     // GIR_Coverage, 15793,
     /* 2074115 */     GIR_EraseRootFromParent_Done,
     /* 2074116 */   // Label 27565: @2074116
     /* 2074116 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2074210), // Rule ID 15796 //
     /* 2074121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2074141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074167 */     // MIs[0] round
     /* 2074167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074170 */     // MIs[0] policy
     /* 2074170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2074183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074209 */     // GIR_Coverage, 15796,
     /* 2074209 */     GIR_EraseRootFromParent_Done,
     /* 2074210 */   // Label 27566: @2074210
     /* 2074210 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2074304), // Rule ID 15797 //
     /* 2074215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2074235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074261 */     // MIs[0] round
     /* 2074261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074264 */     // MIs[0] policy
     /* 2074264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2074277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074303 */     // GIR_Coverage, 15797,
     /* 2074303 */     GIR_EraseRootFromParent_Done,
     /* 2074304 */   // Label 27567: @2074304
     /* 2074304 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2074398), // Rule ID 15800 //
     /* 2074309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2074320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2074323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2074326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074355 */     // MIs[0] round
     /* 2074355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074358 */     // MIs[0] policy
     /* 2074358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074397 */     // GIR_Coverage, 15800,
     /* 2074397 */     GIR_EraseRootFromParent_Done,
     /* 2074398 */   // Label 27568: @2074398
     /* 2074398 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2074492), // Rule ID 15801 //
     /* 2074403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2074414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2074417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2074420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074449 */     // MIs[0] round
     /* 2074449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074452 */     // MIs[0] policy
     /* 2074452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074462 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2074465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074491 */     // GIR_Coverage, 15801,
     /* 2074491 */     GIR_EraseRootFromParent_Done,
     /* 2074492 */   // Label 27569: @2074492
     /* 2074492 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2074586), // Rule ID 15804 //
     /* 2074497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074543 */     // MIs[0] round
     /* 2074543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074546 */     // MIs[0] policy
     /* 2074546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074585 */     // GIR_Coverage, 15804,
     /* 2074585 */     GIR_EraseRootFromParent_Done,
     /* 2074586 */   // Label 27570: @2074586
     /* 2074586 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2074680), // Rule ID 15805 //
     /* 2074591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074637 */     // MIs[0] round
     /* 2074637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074640 */     // MIs[0] policy
     /* 2074640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074679 */     // GIR_Coverage, 15805,
     /* 2074679 */     GIR_EraseRootFromParent_Done,
     /* 2074680 */   // Label 27571: @2074680
     /* 2074680 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2074774), // Rule ID 15808 //
     /* 2074685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074731 */     // MIs[0] round
     /* 2074731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074734 */     // MIs[0] policy
     /* 2074734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074773 */     // GIR_Coverage, 15808,
     /* 2074773 */     GIR_EraseRootFromParent_Done,
     /* 2074774 */   // Label 27572: @2074774
     /* 2074774 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2074868), // Rule ID 15809 //
     /* 2074779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074825 */     // MIs[0] round
     /* 2074825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074828 */     // MIs[0] policy
     /* 2074828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074867 */     // GIR_Coverage, 15809,
     /* 2074867 */     GIR_EraseRootFromParent_Done,
     /* 2074868 */   // Label 27573: @2074868
     /* 2074868 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2074962), // Rule ID 15812 //
     /* 2074873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074919 */     // MIs[0] round
     /* 2074919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074922 */     // MIs[0] policy
     /* 2074922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074932 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074961 */     // GIR_Coverage, 15812,
     /* 2074961 */     GIR_EraseRootFromParent_Done,
     /* 2074962 */   // Label 27574: @2074962
     /* 2074962 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2075056), // Rule ID 15813 //
     /* 2074967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075013 */     // MIs[0] round
     /* 2075013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075016 */     // MIs[0] policy
     /* 2075016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2075029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2075054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075055 */     // GIR_Coverage, 15813,
     /* 2075055 */     GIR_EraseRootFromParent_Done,
     /* 2075056 */   // Label 27575: @2075056
     /* 2075056 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2075147), // Rule ID 15816 //
     /* 2075061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075107 */     // MIs[0] round
     /* 2075107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075110 */     // MIs[0] policy
     /* 2075110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2075123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075146 */     // GIR_Coverage, 15816,
     /* 2075146 */     GIR_EraseRootFromParent_Done,
     /* 2075147 */   // Label 27576: @2075147
     /* 2075147 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2075238), // Rule ID 15817 //
     /* 2075152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075198 */     // MIs[0] round
     /* 2075198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075201 */     // MIs[0] policy
     /* 2075201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2075214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075237 */     // GIR_Coverage, 15817,
     /* 2075237 */     GIR_EraseRootFromParent_Done,
     /* 2075238 */   // Label 27577: @2075238
     /* 2075238 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2075329), // Rule ID 15820 //
     /* 2075243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2075263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075289 */     // MIs[0] round
     /* 2075289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075292 */     // MIs[0] policy
     /* 2075292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075328 */     // GIR_Coverage, 15820,
     /* 2075328 */     GIR_EraseRootFromParent_Done,
     /* 2075329 */   // Label 27578: @2075329
     /* 2075329 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2075420), // Rule ID 15821 //
     /* 2075334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2075354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075380 */     // MIs[0] round
     /* 2075380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075383 */     // MIs[0] policy
     /* 2075383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075393 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075419 */     // GIR_Coverage, 15821,
     /* 2075419 */     GIR_EraseRootFromParent_Done,
     /* 2075420 */   // Label 27579: @2075420
     /* 2075420 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2075511), // Rule ID 15824 //
     /* 2075425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075471 */     // MIs[0] round
     /* 2075471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075474 */     // MIs[0] policy
     /* 2075474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075510 */     // GIR_Coverage, 15824,
     /* 2075510 */     GIR_EraseRootFromParent_Done,
     /* 2075511 */   // Label 27580: @2075511
     /* 2075511 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2075602), // Rule ID 15825 //
     /* 2075516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075562 */     // MIs[0] round
     /* 2075562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075565 */     // MIs[0] policy
     /* 2075565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075575 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075601 */     // GIR_Coverage, 15825,
     /* 2075601 */     GIR_EraseRootFromParent_Done,
     /* 2075602 */   // Label 27581: @2075602
     /* 2075602 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2075693), // Rule ID 15828 //
     /* 2075607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075653 */     // MIs[0] round
     /* 2075653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075656 */     // MIs[0] policy
     /* 2075656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075692 */     // GIR_Coverage, 15828,
     /* 2075692 */     GIR_EraseRootFromParent_Done,
     /* 2075693 */   // Label 27582: @2075693
     /* 2075693 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2075784), // Rule ID 15829 //
     /* 2075698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075744 */     // MIs[0] round
     /* 2075744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075747 */     // MIs[0] policy
     /* 2075747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075757 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075783 */     // GIR_Coverage, 15829,
     /* 2075783 */     GIR_EraseRootFromParent_Done,
     /* 2075784 */   // Label 27583: @2075784
     /* 2075784 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2075875), // Rule ID 15832 //
     /* 2075789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075835 */     // MIs[0] round
     /* 2075835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075838 */     // MIs[0] policy
     /* 2075838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075874 */     // GIR_Coverage, 15832,
     /* 2075874 */     GIR_EraseRootFromParent_Done,
     /* 2075875 */   // Label 27584: @2075875
     /* 2075875 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2075966), // Rule ID 15833 //
     /* 2075880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075926 */     // MIs[0] round
     /* 2075926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075929 */     // MIs[0] policy
     /* 2075929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075965 */     // GIR_Coverage, 15833,
     /* 2075965 */     GIR_EraseRootFromParent_Done,
     /* 2075966 */   // Label 27585: @2075966
     /* 2075966 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2076057), // Rule ID 15836 //
     /* 2075971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076017 */     // MIs[0] round
     /* 2076017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076020 */     // MIs[0] policy
     /* 2076020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2076033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076056 */     // GIR_Coverage, 15836,
     /* 2076056 */     GIR_EraseRootFromParent_Done,
     /* 2076057 */   // Label 27586: @2076057
     /* 2076057 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2076148), // Rule ID 15837 //
     /* 2076062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2076082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076108 */     // MIs[0] round
     /* 2076108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076111 */     // MIs[0] policy
     /* 2076111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2076124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076147 */     // GIR_Coverage, 15837,
     /* 2076147 */     GIR_EraseRootFromParent_Done,
     /* 2076148 */   // Label 27587: @2076148
     /* 2076148 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2076239), // Rule ID 15840 //
     /* 2076153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076199 */     // MIs[0] round
     /* 2076199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076202 */     // MIs[0] policy
     /* 2076202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076238 */     // GIR_Coverage, 15840,
     /* 2076238 */     GIR_EraseRootFromParent_Done,
     /* 2076239 */   // Label 27588: @2076239
     /* 2076239 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2076330), // Rule ID 15841 //
     /* 2076244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076290 */     // MIs[0] round
     /* 2076290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076293 */     // MIs[0] policy
     /* 2076293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076303 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076329 */     // GIR_Coverage, 15841,
     /* 2076329 */     GIR_EraseRootFromParent_Done,
     /* 2076330 */   // Label 27589: @2076330
     /* 2076330 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2076421), // Rule ID 15844 //
     /* 2076335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076381 */     // MIs[0] round
     /* 2076381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076384 */     // MIs[0] policy
     /* 2076384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076420 */     // GIR_Coverage, 15844,
     /* 2076420 */     GIR_EraseRootFromParent_Done,
     /* 2076421 */   // Label 27590: @2076421
     /* 2076421 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2076512), // Rule ID 15845 //
     /* 2076426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2076446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076472 */     // MIs[0] round
     /* 2076472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076475 */     // MIs[0] policy
     /* 2076475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076485 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076511 */     // GIR_Coverage, 15845,
     /* 2076511 */     GIR_EraseRootFromParent_Done,
     /* 2076512 */   // Label 27591: @2076512
     /* 2076512 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2076603), // Rule ID 15848 //
     /* 2076517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076563 */     // MIs[0] round
     /* 2076563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076566 */     // MIs[0] policy
     /* 2076566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076602 */     // GIR_Coverage, 15848,
     /* 2076602 */     GIR_EraseRootFromParent_Done,
     /* 2076603 */   // Label 27592: @2076603
     /* 2076603 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2076694), // Rule ID 15849 //
     /* 2076608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076654 */     // MIs[0] round
     /* 2076654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076657 */     // MIs[0] policy
     /* 2076657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076693 */     // GIR_Coverage, 15849,
     /* 2076693 */     GIR_EraseRootFromParent_Done,
     /* 2076694 */   // Label 27593: @2076694
     /* 2076694 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2076785), // Rule ID 15852 //
     /* 2076699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2076702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076745 */     // MIs[0] round
     /* 2076745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076748 */     // MIs[0] policy
     /* 2076748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076784 */     // GIR_Coverage, 15852,
     /* 2076784 */     GIR_EraseRootFromParent_Done,
     /* 2076785 */   // Label 27594: @2076785
     /* 2076785 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2076876), // Rule ID 15853 //
     /* 2076790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2076793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076836 */     // MIs[0] round
     /* 2076836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076839 */     // MIs[0] policy
     /* 2076839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076875 */     // GIR_Coverage, 15853,
     /* 2076875 */     GIR_EraseRootFromParent_Done,
     /* 2076876 */   // Label 27595: @2076876
     /* 2076876 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2076967), // Rule ID 15856 //
     /* 2076881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076927 */     // MIs[0] round
     /* 2076927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076930 */     // MIs[0] policy
     /* 2076930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076966 */     // GIR_Coverage, 15856,
     /* 2076966 */     GIR_EraseRootFromParent_Done,
     /* 2076967 */   // Label 27596: @2076967
     /* 2076967 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2077058), // Rule ID 15857 //
     /* 2076972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077018 */     // MIs[0] round
     /* 2077018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077021 */     // MIs[0] policy
     /* 2077021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077057 */     // GIR_Coverage, 15857,
     /* 2077057 */     GIR_EraseRootFromParent_Done,
     /* 2077058 */   // Label 27597: @2077058
     /* 2077058 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2077149), // Rule ID 15860 //
     /* 2077063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077109 */     // MIs[0] round
     /* 2077109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077112 */     // MIs[0] policy
     /* 2077112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077148 */     // GIR_Coverage, 15860,
     /* 2077148 */     GIR_EraseRootFromParent_Done,
     /* 2077149 */   // Label 27598: @2077149
     /* 2077149 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2077240), // Rule ID 15861 //
     /* 2077154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077200 */     // MIs[0] round
     /* 2077200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077203 */     // MIs[0] policy
     /* 2077203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077213 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077239 */     // GIR_Coverage, 15861,
     /* 2077239 */     GIR_EraseRootFromParent_Done,
     /* 2077240 */   // Label 27599: @2077240
     /* 2077240 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2077331), // Rule ID 15864 //
     /* 2077245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2077265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077291 */     // MIs[0] round
     /* 2077291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077294 */     // MIs[0] policy
     /* 2077294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077330 */     // GIR_Coverage, 15864,
     /* 2077330 */     GIR_EraseRootFromParent_Done,
     /* 2077331 */   // Label 27600: @2077331
     /* 2077331 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2077422), // Rule ID 15865 //
     /* 2077336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2077356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077382 */     // MIs[0] round
     /* 2077382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077385 */     // MIs[0] policy
     /* 2077385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077395 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077421 */     // GIR_Coverage, 15865,
     /* 2077421 */     GIR_EraseRootFromParent_Done,
     /* 2077422 */   // Label 27601: @2077422
     /* 2077422 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2077513), // Rule ID 15868 //
     /* 2077427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077473 */     // MIs[0] round
     /* 2077473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077476 */     // MIs[0] policy
     /* 2077476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077512 */     // GIR_Coverage, 15868,
     /* 2077512 */     GIR_EraseRootFromParent_Done,
     /* 2077513 */   // Label 27602: @2077513
     /* 2077513 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2077604), // Rule ID 15869 //
     /* 2077518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077564 */     // MIs[0] round
     /* 2077564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077567 */     // MIs[0] policy
     /* 2077567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077603 */     // GIR_Coverage, 15869,
     /* 2077603 */     GIR_EraseRootFromParent_Done,
     /* 2077604 */   // Label 27603: @2077604
     /* 2077604 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2077695), // Rule ID 15872 //
     /* 2077609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077655 */     // MIs[0] round
     /* 2077655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077658 */     // MIs[0] policy
     /* 2077658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077668 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077694 */     // GIR_Coverage, 15872,
     /* 2077694 */     GIR_EraseRootFromParent_Done,
     /* 2077695 */   // Label 27604: @2077695
     /* 2077695 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2077786), // Rule ID 15873 //
     /* 2077700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077746 */     // MIs[0] round
     /* 2077746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077749 */     // MIs[0] policy
     /* 2077749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077785 */     // GIR_Coverage, 15873,
     /* 2077785 */     GIR_EraseRootFromParent_Done,
     /* 2077786 */   // Label 27605: @2077786
     /* 2077786 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2077877), // Rule ID 15876 //
     /* 2077791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077837 */     // MIs[0] round
     /* 2077837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077840 */     // MIs[0] policy
     /* 2077840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077876 */     // GIR_Coverage, 15876,
     /* 2077876 */     GIR_EraseRootFromParent_Done,
     /* 2077877 */   // Label 27606: @2077877
     /* 2077877 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2077968), // Rule ID 15877 //
     /* 2077882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077928 */     // MIs[0] round
     /* 2077928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077931 */     // MIs[0] policy
     /* 2077931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077967 */     // GIR_Coverage, 15877,
     /* 2077967 */     GIR_EraseRootFromParent_Done,
     /* 2077968 */   // Label 27607: @2077968
     /* 2077968 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2078059), // Rule ID 15880 //
     /* 2077973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078019 */     // MIs[0] round
     /* 2078019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078022 */     // MIs[0] policy
     /* 2078022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078058 */     // GIR_Coverage, 15880,
     /* 2078058 */     GIR_EraseRootFromParent_Done,
     /* 2078059 */   // Label 27608: @2078059
     /* 2078059 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2078150), // Rule ID 15881 //
     /* 2078064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2078084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078110 */     // MIs[0] round
     /* 2078110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078113 */     // MIs[0] policy
     /* 2078113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078149 */     // GIR_Coverage, 15881,
     /* 2078149 */     GIR_EraseRootFromParent_Done,
     /* 2078150 */   // Label 27609: @2078150
     /* 2078150 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2078241), // Rule ID 15884 //
     /* 2078155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078201 */     // MIs[0] round
     /* 2078201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078204 */     // MIs[0] policy
     /* 2078204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078240 */     // GIR_Coverage, 15884,
     /* 2078240 */     GIR_EraseRootFromParent_Done,
     /* 2078241 */   // Label 27610: @2078241
     /* 2078241 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2078332), // Rule ID 15885 //
     /* 2078246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078292 */     // MIs[0] round
     /* 2078292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078295 */     // MIs[0] policy
     /* 2078295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078305 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078331 */     // GIR_Coverage, 15885,
     /* 2078331 */     GIR_EraseRootFromParent_Done,
     /* 2078332 */   // Label 27611: @2078332
     /* 2078332 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2078423), // Rule ID 15888 //
     /* 2078337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2078357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078383 */     // MIs[0] round
     /* 2078383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078386 */     // MIs[0] policy
     /* 2078386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078422 */     // GIR_Coverage, 15888,
     /* 2078422 */     GIR_EraseRootFromParent_Done,
     /* 2078423 */   // Label 27612: @2078423
     /* 2078423 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2078514), // Rule ID 15889 //
     /* 2078428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2078448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078474 */     // MIs[0] round
     /* 2078474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078477 */     // MIs[0] policy
     /* 2078477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078487 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078513 */     // GIR_Coverage, 15889,
     /* 2078513 */     GIR_EraseRootFromParent_Done,
     /* 2078514 */   // Label 27613: @2078514
     /* 2078514 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2078605), // Rule ID 15892 //
     /* 2078519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078565 */     // MIs[0] round
     /* 2078565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078568 */     // MIs[0] policy
     /* 2078568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078604 */     // GIR_Coverage, 15892,
     /* 2078604 */     GIR_EraseRootFromParent_Done,
     /* 2078605 */   // Label 27614: @2078605
     /* 2078605 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2078696), // Rule ID 15893 //
     /* 2078610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078656 */     // MIs[0] round
     /* 2078656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078659 */     // MIs[0] policy
     /* 2078659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078695 */     // GIR_Coverage, 15893,
     /* 2078695 */     GIR_EraseRootFromParent_Done,
     /* 2078696 */   // Label 27615: @2078696
     /* 2078696 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2078787), // Rule ID 15896 //
     /* 2078701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078747 */     // MIs[0] round
     /* 2078747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078750 */     // MIs[0] policy
     /* 2078750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078786 */     // GIR_Coverage, 15896,
     /* 2078786 */     GIR_EraseRootFromParent_Done,
     /* 2078787 */   // Label 27616: @2078787
     /* 2078787 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2078878), // Rule ID 15897 //
     /* 2078792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078838 */     // MIs[0] round
     /* 2078838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078841 */     // MIs[0] policy
     /* 2078841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078877 */     // GIR_Coverage, 15897,
     /* 2078877 */     GIR_EraseRootFromParent_Done,
     /* 2078878 */   // Label 27617: @2078878
     /* 2078878 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2078969), // Rule ID 15900 //
     /* 2078883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078929 */     // MIs[0] round
     /* 2078929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078932 */     // MIs[0] policy
     /* 2078932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078968 */     // GIR_Coverage, 15900,
     /* 2078968 */     GIR_EraseRootFromParent_Done,
     /* 2078969 */   // Label 27618: @2078969
     /* 2078969 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2079060), // Rule ID 15901 //
     /* 2078974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079020 */     // MIs[0] round
     /* 2079020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079023 */     // MIs[0] policy
     /* 2079023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2079036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079059 */     // GIR_Coverage, 15901,
     /* 2079059 */     GIR_EraseRootFromParent_Done,
     /* 2079060 */   // Label 27619: @2079060
     /* 2079060 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2079151), // Rule ID 15904 //
     /* 2079065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079111 */     // MIs[0] round
     /* 2079111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079114 */     // MIs[0] policy
     /* 2079114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2079127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079150 */     // GIR_Coverage, 15904,
     /* 2079150 */     GIR_EraseRootFromParent_Done,
     /* 2079151 */   // Label 27620: @2079151
     /* 2079151 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2079242), // Rule ID 15905 //
     /* 2079156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079202 */     // MIs[0] round
     /* 2079202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079205 */     // MIs[0] policy
     /* 2079205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079215 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2079218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079241 */     // GIR_Coverage, 15905,
     /* 2079241 */     GIR_EraseRootFromParent_Done,
     /* 2079242 */   // Label 27621: @2079242
     /* 2079242 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2079333), // Rule ID 15908 //
     /* 2079247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2079264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079293 */     // MIs[0] round
     /* 2079293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079296 */     // MIs[0] policy
     /* 2079296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079306 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079332 */     // GIR_Coverage, 15908,
     /* 2079332 */     GIR_EraseRootFromParent_Done,
     /* 2079333 */   // Label 27622: @2079333
     /* 2079333 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2079424), // Rule ID 15909 //
     /* 2079338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2079355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079384 */     // MIs[0] round
     /* 2079384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079387 */     // MIs[0] policy
     /* 2079387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079397 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079423 */     // GIR_Coverage, 15909,
     /* 2079423 */     GIR_EraseRootFromParent_Done,
     /* 2079424 */   // Label 27623: @2079424
     /* 2079424 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2079515), // Rule ID 15912 //
     /* 2079429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079475 */     // MIs[0] round
     /* 2079475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079478 */     // MIs[0] policy
     /* 2079478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079488 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079514 */     // GIR_Coverage, 15912,
     /* 2079514 */     GIR_EraseRootFromParent_Done,
     /* 2079515 */   // Label 27624: @2079515
     /* 2079515 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2079606), // Rule ID 15913 //
     /* 2079520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079566 */     // MIs[0] round
     /* 2079566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079569 */     // MIs[0] policy
     /* 2079569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079605 */     // GIR_Coverage, 15913,
     /* 2079605 */     GIR_EraseRootFromParent_Done,
     /* 2079606 */   // Label 27625: @2079606
     /* 2079606 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2079697), // Rule ID 15916 //
     /* 2079611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079657 */     // MIs[0] round
     /* 2079657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079660 */     // MIs[0] policy
     /* 2079660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079670 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079696 */     // GIR_Coverage, 15916,
     /* 2079696 */     GIR_EraseRootFromParent_Done,
     /* 2079697 */   // Label 27626: @2079697
     /* 2079697 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2079788), // Rule ID 15917 //
     /* 2079702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079748 */     // MIs[0] round
     /* 2079748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079751 */     // MIs[0] policy
     /* 2079751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079787 */     // GIR_Coverage, 15917,
     /* 2079787 */     GIR_EraseRootFromParent_Done,
     /* 2079788 */   // Label 27627: @2079788
     /* 2079788 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2079879), // Rule ID 15920 //
     /* 2079793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079839 */     // MIs[0] round
     /* 2079839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079842 */     // MIs[0] policy
     /* 2079842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079878 */     // GIR_Coverage, 15920,
     /* 2079878 */     GIR_EraseRootFromParent_Done,
     /* 2079879 */   // Label 27628: @2079879
     /* 2079879 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2079970), // Rule ID 15921 //
     /* 2079884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079930 */     // MIs[0] round
     /* 2079930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079933 */     // MIs[0] policy
     /* 2079933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079943 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079969 */     // GIR_Coverage, 15921,
     /* 2079969 */     GIR_EraseRootFromParent_Done,
     /* 2079970 */   // Label 27629: @2079970
     /* 2079970 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2080061), // Rule ID 15924 //
     /* 2079975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080021 */     // MIs[0] round
     /* 2080021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080024 */     // MIs[0] policy
     /* 2080024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2080037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080060 */     // GIR_Coverage, 15924,
     /* 2080060 */     GIR_EraseRootFromParent_Done,
     /* 2080061 */   // Label 27630: @2080061
     /* 2080061 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2080152), // Rule ID 15925 //
     /* 2080066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2080077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2080080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080112 */     // MIs[0] round
     /* 2080112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080115 */     // MIs[0] policy
     /* 2080115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080125 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2080128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080151 */     // GIR_Coverage, 15925,
     /* 2080151 */     GIR_EraseRootFromParent_Done,
     /* 2080152 */   // Label 27631: @2080152
     /* 2080152 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2080243), // Rule ID 15928 //
     /* 2080157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080203 */     // MIs[0] round
     /* 2080203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080206 */     // MIs[0] policy
     /* 2080206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080242 */     // GIR_Coverage, 15928,
     /* 2080242 */     GIR_EraseRootFromParent_Done,
     /* 2080243 */   // Label 27632: @2080243
     /* 2080243 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2080334), // Rule ID 15929 //
     /* 2080248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080294 */     // MIs[0] round
     /* 2080294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080297 */     // MIs[0] policy
     /* 2080297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11658:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080333 */     // GIR_Coverage, 15929,
     /* 2080333 */     GIR_EraseRootFromParent_Done,
     /* 2080334 */   // Label 27633: @2080334
     /* 2080334 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2080425), // Rule ID 15932 //
     /* 2080339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2080356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080385 */     // MIs[0] round
     /* 2080385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080388 */     // MIs[0] policy
     /* 2080388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080424 */     // GIR_Coverage, 15932,
     /* 2080424 */     GIR_EraseRootFromParent_Done,
     /* 2080425 */   // Label 27634: @2080425
     /* 2080425 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2080516), // Rule ID 15933 //
     /* 2080430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2080447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080476 */     // MIs[0] round
     /* 2080476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080479 */     // MIs[0] policy
     /* 2080479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080515 */     // GIR_Coverage, 15933,
     /* 2080515 */     GIR_EraseRootFromParent_Done,
     /* 2080516 */   // Label 27635: @2080516
     /* 2080516 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2080607), // Rule ID 15936 //
     /* 2080521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080567 */     // MIs[0] round
     /* 2080567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080570 */     // MIs[0] policy
     /* 2080570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080606 */     // GIR_Coverage, 15936,
     /* 2080606 */     GIR_EraseRootFromParent_Done,
     /* 2080607 */   // Label 27636: @2080607
     /* 2080607 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2080698), // Rule ID 15937 //
     /* 2080612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080658 */     // MIs[0] round
     /* 2080658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080661 */     // MIs[0] policy
     /* 2080661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080697 */     // GIR_Coverage, 15937,
     /* 2080697 */     GIR_EraseRootFromParent_Done,
     /* 2080698 */   // Label 27637: @2080698
     /* 2080698 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2080789), // Rule ID 15940 //
     /* 2080703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2080706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080749 */     // MIs[0] round
     /* 2080749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080752 */     // MIs[0] policy
     /* 2080752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080762 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080788 */     // GIR_Coverage, 15940,
     /* 2080788 */     GIR_EraseRootFromParent_Done,
     /* 2080789 */   // Label 27638: @2080789
     /* 2080789 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2080880), // Rule ID 15941 //
     /* 2080794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2080797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080840 */     // MIs[0] round
     /* 2080840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080843 */     // MIs[0] policy
     /* 2080843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080853 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080879 */     // GIR_Coverage, 15941,
     /* 2080879 */     GIR_EraseRootFromParent_Done,
     /* 2080880 */   // Label 27639: @2080880
     /* 2080880 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2080971), // Rule ID 15944 //
     /* 2080885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080931 */     // MIs[0] round
     /* 2080931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080934 */     // MIs[0] policy
     /* 2080934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080970 */     // GIR_Coverage, 15944,
     /* 2080970 */     GIR_EraseRootFromParent_Done,
     /* 2080971 */   // Label 27640: @2080971
     /* 2080971 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2081062), // Rule ID 15945 //
     /* 2080976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081022 */     // MIs[0] round
     /* 2081022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081025 */     // MIs[0] policy
     /* 2081025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081061 */     // GIR_Coverage, 15945,
     /* 2081061 */     GIR_EraseRootFromParent_Done,
     /* 2081062 */   // Label 27641: @2081062
     /* 2081062 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2081153), // Rule ID 15948 //
     /* 2081067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081113 */     // MIs[0] round
     /* 2081113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081116 */     // MIs[0] policy
     /* 2081116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081152 */     // GIR_Coverage, 15948,
     /* 2081152 */     GIR_EraseRootFromParent_Done,
     /* 2081153 */   // Label 27642: @2081153
     /* 2081153 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2081244), // Rule ID 15949 //
     /* 2081158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081204 */     // MIs[0] round
     /* 2081204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081207 */     // MIs[0] policy
     /* 2081207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081217 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081243 */     // GIR_Coverage, 15949,
     /* 2081243 */     GIR_EraseRootFromParent_Done,
     /* 2081244 */   // Label 27643: @2081244
     /* 2081244 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2081335), // Rule ID 15952 //
     /* 2081249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2081260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2081263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2081266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2081272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081295 */     // MIs[0] round
     /* 2081295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081298 */     // MIs[0] policy
     /* 2081298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081334 */     // GIR_Coverage, 15952,
     /* 2081334 */     GIR_EraseRootFromParent_Done,
     /* 2081335 */   // Label 27644: @2081335
     /* 2081335 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2081426), // Rule ID 15953 //
     /* 2081340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2081351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2081354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2081357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2081363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081386 */     // MIs[0] round
     /* 2081386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081389 */     // MIs[0] policy
     /* 2081389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081399 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081425 */     // GIR_Coverage, 15953,
     /* 2081425 */     GIR_EraseRootFromParent_Done,
     /* 2081426 */   // Label 27645: @2081426
     /* 2081426 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2081517), // Rule ID 15956 //
     /* 2081431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081477 */     // MIs[0] round
     /* 2081477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081480 */     // MIs[0] policy
     /* 2081480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081516 */     // GIR_Coverage, 15956,
     /* 2081516 */     GIR_EraseRootFromParent_Done,
     /* 2081517 */   // Label 27646: @2081517
     /* 2081517 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2081608), // Rule ID 15957 //
     /* 2081522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081568 */     // MIs[0] round
     /* 2081568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081571 */     // MIs[0] policy
     /* 2081571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081607 */     // GIR_Coverage, 15957,
     /* 2081607 */     GIR_EraseRootFromParent_Done,
     /* 2081608 */   // Label 27647: @2081608
     /* 2081608 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2081699), // Rule ID 15960 //
     /* 2081613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081659 */     // MIs[0] round
     /* 2081659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081662 */     // MIs[0] policy
     /* 2081662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081698 */     // GIR_Coverage, 15960,
     /* 2081698 */     GIR_EraseRootFromParent_Done,
     /* 2081699 */   // Label 27648: @2081699
     /* 2081699 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2081790), // Rule ID 15961 //
     /* 2081704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081750 */     // MIs[0] round
     /* 2081750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081753 */     // MIs[0] policy
     /* 2081753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081763 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081789 */     // GIR_Coverage, 15961,
     /* 2081789 */     GIR_EraseRootFromParent_Done,
     /* 2081790 */   // Label 27649: @2081790
     /* 2081790 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2081881), // Rule ID 15964 //
     /* 2081795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081841 */     // MIs[0] round
     /* 2081841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081844 */     // MIs[0] policy
     /* 2081844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081880 */     // GIR_Coverage, 15964,
     /* 2081880 */     GIR_EraseRootFromParent_Done,
     /* 2081881 */   // Label 27650: @2081881
     /* 2081881 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2081972), // Rule ID 15965 //
     /* 2081886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081932 */     // MIs[0] round
     /* 2081932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081935 */     // MIs[0] policy
     /* 2081935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081945 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081971 */     // GIR_Coverage, 15965,
     /* 2081971 */     GIR_EraseRootFromParent_Done,
     /* 2081972 */   // Label 27651: @2081972
     /* 2081972 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2082063), // Rule ID 15968 //
     /* 2081977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082023 */     // MIs[0] round
     /* 2082023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082026 */     // MIs[0] policy
     /* 2082026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082062 */     // GIR_Coverage, 15968,
     /* 2082062 */     GIR_EraseRootFromParent_Done,
     /* 2082063 */   // Label 27652: @2082063
     /* 2082063 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2082154), // Rule ID 15969 //
     /* 2082068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2082085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082114 */     // MIs[0] round
     /* 2082114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082117 */     // MIs[0] policy
     /* 2082117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082153 */     // GIR_Coverage, 15969,
     /* 2082153 */     GIR_EraseRootFromParent_Done,
     /* 2082154 */   // Label 27653: @2082154
     /* 2082154 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2082245), // Rule ID 15972 //
     /* 2082159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082205 */     // MIs[0] round
     /* 2082205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082208 */     // MIs[0] policy
     /* 2082208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082244 */     // GIR_Coverage, 15972,
     /* 2082244 */     GIR_EraseRootFromParent_Done,
     /* 2082245 */   // Label 27654: @2082245
     /* 2082245 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2082336), // Rule ID 15973 //
     /* 2082250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082296 */     // MIs[0] round
     /* 2082296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082299 */     // MIs[0] policy
     /* 2082299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082335 */     // GIR_Coverage, 15973,
     /* 2082335 */     GIR_EraseRootFromParent_Done,
     /* 2082336 */   // Label 27655: @2082336
     /* 2082336 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2082427), // Rule ID 15976 //
     /* 2082341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2082352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2082355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2082358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082387 */     // MIs[0] round
     /* 2082387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082390 */     // MIs[0] policy
     /* 2082390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082426 */     // GIR_Coverage, 15976,
     /* 2082426 */     GIR_EraseRootFromParent_Done,
     /* 2082427 */   // Label 27656: @2082427
     /* 2082427 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2082518), // Rule ID 15977 //
     /* 2082432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2082443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2082446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2082449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082478 */     // MIs[0] round
     /* 2082478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082481 */     // MIs[0] policy
     /* 2082481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082517 */     // GIR_Coverage, 15977,
     /* 2082517 */     GIR_EraseRootFromParent_Done,
     /* 2082518 */   // Label 27657: @2082518
     /* 2082518 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2082609), // Rule ID 15980 //
     /* 2082523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082569 */     // MIs[0] round
     /* 2082569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082572 */     // MIs[0] policy
     /* 2082572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082608 */     // GIR_Coverage, 15980,
     /* 2082608 */     GIR_EraseRootFromParent_Done,
     /* 2082609 */   // Label 27658: @2082609
     /* 2082609 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2082700), // Rule ID 15981 //
     /* 2082614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082660 */     // MIs[0] round
     /* 2082660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082663 */     // MIs[0] policy
     /* 2082663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082699 */     // GIR_Coverage, 15981,
     /* 2082699 */     GIR_EraseRootFromParent_Done,
     /* 2082700 */   // Label 27659: @2082700
     /* 2082700 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2082791), // Rule ID 15984 //
     /* 2082705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082751 */     // MIs[0] round
     /* 2082751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082754 */     // MIs[0] policy
     /* 2082754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082790 */     // GIR_Coverage, 15984,
     /* 2082790 */     GIR_EraseRootFromParent_Done,
     /* 2082791 */   // Label 27660: @2082791
     /* 2082791 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2082882), // Rule ID 15985 //
     /* 2082796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082842 */     // MIs[0] round
     /* 2082842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082845 */     // MIs[0] policy
     /* 2082845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082855 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082881 */     // GIR_Coverage, 15985,
     /* 2082881 */     GIR_EraseRootFromParent_Done,
     /* 2082882 */   // Label 27661: @2082882
     /* 2082882 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2082973), // Rule ID 15988 //
     /* 2082887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082933 */     // MIs[0] round
     /* 2082933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082936 */     // MIs[0] policy
     /* 2082936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082972 */     // GIR_Coverage, 15988,
     /* 2082972 */     GIR_EraseRootFromParent_Done,
     /* 2082973 */   // Label 27662: @2082973
     /* 2082973 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2083064), // Rule ID 15989 //
     /* 2082978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083024 */     // MIs[0] round
     /* 2083024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083027 */     // MIs[0] policy
     /* 2083027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2083040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083063 */     // GIR_Coverage, 15989,
     /* 2083063 */     GIR_EraseRootFromParent_Done,
     /* 2083064 */   // Label 27663: @2083064
     /* 2083064 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2083155), // Rule ID 16080 //
     /* 2083069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2083086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083115 */     // MIs[0] round
     /* 2083115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083118 */     // MIs[0] policy
     /* 2083118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2083131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083154 */     // GIR_Coverage, 16080,
     /* 2083154 */     GIR_EraseRootFromParent_Done,
     /* 2083155 */   // Label 27664: @2083155
     /* 2083155 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2083246), // Rule ID 16081 //
     /* 2083160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2083177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083206 */     // MIs[0] round
     /* 2083206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083209 */     // MIs[0] policy
     /* 2083209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2083222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083245 */     // GIR_Coverage, 16081,
     /* 2083245 */     GIR_EraseRootFromParent_Done,
     /* 2083246 */   // Label 27665: @2083246
     /* 2083246 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2083337), // Rule ID 16084 //
     /* 2083251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2083262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2083265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2083268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2083271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083297 */     // MIs[0] round
     /* 2083297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083300 */     // MIs[0] policy
     /* 2083300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083336 */     // GIR_Coverage, 16084,
     /* 2083336 */     GIR_EraseRootFromParent_Done,
     /* 2083337 */   // Label 27666: @2083337
     /* 2083337 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2083428), // Rule ID 16085 //
     /* 2083342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2083353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2083356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2083359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2083362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083388 */     // MIs[0] round
     /* 2083388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083391 */     // MIs[0] policy
     /* 2083391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083427 */     // GIR_Coverage, 16085,
     /* 2083427 */     GIR_EraseRootFromParent_Done,
     /* 2083428 */   // Label 27667: @2083428
     /* 2083428 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2083519), // Rule ID 16088 //
     /* 2083433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083479 */     // MIs[0] round
     /* 2083479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083482 */     // MIs[0] policy
     /* 2083482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083518 */     // GIR_Coverage, 16088,
     /* 2083518 */     GIR_EraseRootFromParent_Done,
     /* 2083519 */   // Label 27668: @2083519
     /* 2083519 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2083610), // Rule ID 16089 //
     /* 2083524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083570 */     // MIs[0] round
     /* 2083570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083573 */     // MIs[0] policy
     /* 2083573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083609 */     // GIR_Coverage, 16089,
     /* 2083609 */     GIR_EraseRootFromParent_Done,
     /* 2083610 */   // Label 27669: @2083610
     /* 2083610 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2083701), // Rule ID 16092 //
     /* 2083615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083661 */     // MIs[0] round
     /* 2083661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083664 */     // MIs[0] policy
     /* 2083664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083700 */     // GIR_Coverage, 16092,
     /* 2083700 */     GIR_EraseRootFromParent_Done,
     /* 2083701 */   // Label 27670: @2083701
     /* 2083701 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2083792), // Rule ID 16093 //
     /* 2083706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083752 */     // MIs[0] round
     /* 2083752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083755 */     // MIs[0] policy
     /* 2083755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083765 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083791 */     // GIR_Coverage, 16093,
     /* 2083791 */     GIR_EraseRootFromParent_Done,
     /* 2083792 */   // Label 27671: @2083792
     /* 2083792 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2083883), // Rule ID 16096 //
     /* 2083797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083843 */     // MIs[0] round
     /* 2083843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083846 */     // MIs[0] policy
     /* 2083846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083882 */     // GIR_Coverage, 16096,
     /* 2083882 */     GIR_EraseRootFromParent_Done,
     /* 2083883 */   // Label 27672: @2083883
     /* 2083883 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2083974), // Rule ID 16097 //
     /* 2083888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083934 */     // MIs[0] round
     /* 2083934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083937 */     // MIs[0] policy
     /* 2083937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083947 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083973 */     // GIR_Coverage, 16097,
     /* 2083973 */     GIR_EraseRootFromParent_Done,
     /* 2083974 */   // Label 27673: @2083974
     /* 2083974 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2084065), // Rule ID 16100 //
     /* 2083979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2083999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084025 */     // MIs[0] round
     /* 2084025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084028 */     // MIs[0] policy
     /* 2084028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2084041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084064 */     // GIR_Coverage, 16100,
     /* 2084064 */     GIR_EraseRootFromParent_Done,
     /* 2084065 */   // Label 27674: @2084065
     /* 2084065 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2084156), // Rule ID 16101 //
     /* 2084070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2084081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2084084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2084090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084116 */     // MIs[0] round
     /* 2084116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084119 */     // MIs[0] policy
     /* 2084119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2084132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084155 */     // GIR_Coverage, 16101,
     /* 2084155 */     GIR_EraseRootFromParent_Done,
     /* 2084156 */   // Label 27675: @2084156
     /* 2084156 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2084247), // Rule ID 16104 //
     /* 2084161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2084178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084207 */     // MIs[0] round
     /* 2084207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084210 */     // MIs[0] policy
     /* 2084210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084246 */     // GIR_Coverage, 16104,
     /* 2084246 */     GIR_EraseRootFromParent_Done,
     /* 2084247 */   // Label 27676: @2084247
     /* 2084247 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2084338), // Rule ID 16105 //
     /* 2084252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2084269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084298 */     // MIs[0] round
     /* 2084298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084301 */     // MIs[0] policy
     /* 2084301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084337 */     // GIR_Coverage, 16105,
     /* 2084337 */     GIR_EraseRootFromParent_Done,
     /* 2084338 */   // Label 27677: @2084338
     /* 2084338 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2084429), // Rule ID 16108 //
     /* 2084343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2084354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2084357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084389 */     // MIs[0] round
     /* 2084389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084392 */     // MIs[0] policy
     /* 2084392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084428 */     // GIR_Coverage, 16108,
     /* 2084428 */     GIR_EraseRootFromParent_Done,
     /* 2084429 */   // Label 27678: @2084429
     /* 2084429 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2084520), // Rule ID 16109 //
     /* 2084434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2084445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2084448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2084454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084480 */     // MIs[0] round
     /* 2084480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084483 */     // MIs[0] policy
     /* 2084483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084519 */     // GIR_Coverage, 16109,
     /* 2084519 */     GIR_EraseRootFromParent_Done,
     /* 2084520 */   // Label 27679: @2084520
     /* 2084520 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2084611), // Rule ID 16112 //
     /* 2084525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084571 */     // MIs[0] round
     /* 2084571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084574 */     // MIs[0] policy
     /* 2084574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084610 */     // GIR_Coverage, 16112,
     /* 2084610 */     GIR_EraseRootFromParent_Done,
     /* 2084611 */   // Label 27680: @2084611
     /* 2084611 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2084702), // Rule ID 16113 //
     /* 2084616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084662 */     // MIs[0] round
     /* 2084662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084665 */     // MIs[0] policy
     /* 2084665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084701 */     // GIR_Coverage, 16113,
     /* 2084701 */     GIR_EraseRootFromParent_Done,
     /* 2084702 */   // Label 27681: @2084702
     /* 2084702 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2084793), // Rule ID 16116 //
     /* 2084707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2084710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084753 */     // MIs[0] round
     /* 2084753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084756 */     // MIs[0] policy
     /* 2084756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084792 */     // GIR_Coverage, 16116,
     /* 2084792 */     GIR_EraseRootFromParent_Done,
     /* 2084793 */   // Label 27682: @2084793
     /* 2084793 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2084884), // Rule ID 16117 //
     /* 2084798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2084801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084844 */     // MIs[0] round
     /* 2084844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084847 */     // MIs[0] policy
     /* 2084847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084883 */     // GIR_Coverage, 16117,
     /* 2084883 */     GIR_EraseRootFromParent_Done,
     /* 2084884 */   // Label 27683: @2084884
     /* 2084884 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2084975), // Rule ID 16120 //
     /* 2084889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084935 */     // MIs[0] round
     /* 2084935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084938 */     // MIs[0] policy
     /* 2084938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084974 */     // GIR_Coverage, 16120,
     /* 2084974 */     GIR_EraseRootFromParent_Done,
     /* 2084975 */   // Label 27684: @2084975
     /* 2084975 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2085066), // Rule ID 16121 //
     /* 2084980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2085000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085026 */     // MIs[0] round
     /* 2085026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085029 */     // MIs[0] policy
     /* 2085029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085065 */     // GIR_Coverage, 16121,
     /* 2085065 */     GIR_EraseRootFromParent_Done,
     /* 2085066 */   // Label 27685: @2085066
     /* 2085066 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2085157), // Rule ID 16124 //
     /* 2085071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2085082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2085085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2085088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2085091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085117 */     // MIs[0] round
     /* 2085117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085120 */     // MIs[0] policy
     /* 2085120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085130 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085156 */     // GIR_Coverage, 16124,
     /* 2085156 */     GIR_EraseRootFromParent_Done,
     /* 2085157 */   // Label 27686: @2085157
     /* 2085157 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2085248), // Rule ID 16125 //
     /* 2085162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2085173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2085176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2085179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2085182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085208 */     // MIs[0] round
     /* 2085208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085211 */     // MIs[0] policy
     /* 2085211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085247 */     // GIR_Coverage, 16125,
     /* 2085247 */     GIR_EraseRootFromParent_Done,
     /* 2085248 */   // Label 27687: @2085248
     /* 2085248 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2085339), // Rule ID 16128 //
     /* 2085253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2085264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2085267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2085270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2085273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2085276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085299 */     // MIs[0] round
     /* 2085299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085302 */     // MIs[0] policy
     /* 2085302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085338 */     // GIR_Coverage, 16128,
     /* 2085338 */     GIR_EraseRootFromParent_Done,
     /* 2085339 */   // Label 27688: @2085339
     /* 2085339 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2085430), // Rule ID 16129 //
     /* 2085344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2085355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2085358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2085361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2085364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2085367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085390 */     // MIs[0] round
     /* 2085390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085393 */     // MIs[0] policy
     /* 2085393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085403 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085429 */     // GIR_Coverage, 16129,
     /* 2085429 */     GIR_EraseRootFromParent_Done,
     /* 2085430 */   // Label 27689: @2085430
     /* 2085430 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2085521), // Rule ID 16132 //
     /* 2085435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085481 */     // MIs[0] round
     /* 2085481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085484 */     // MIs[0] policy
     /* 2085484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085520 */     // GIR_Coverage, 16132,
     /* 2085520 */     GIR_EraseRootFromParent_Done,
     /* 2085521 */   // Label 27690: @2085521
     /* 2085521 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2085612), // Rule ID 16133 //
     /* 2085526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085572 */     // MIs[0] round
     /* 2085572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085575 */     // MIs[0] policy
     /* 2085575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085611 */     // GIR_Coverage, 16133,
     /* 2085611 */     GIR_EraseRootFromParent_Done,
     /* 2085612 */   // Label 27691: @2085612
     /* 2085612 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2085703), // Rule ID 16136 //
     /* 2085617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085663 */     // MIs[0] round
     /* 2085663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085666 */     // MIs[0] policy
     /* 2085666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085702 */     // GIR_Coverage, 16136,
     /* 2085702 */     GIR_EraseRootFromParent_Done,
     /* 2085703 */   // Label 27692: @2085703
     /* 2085703 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2085794), // Rule ID 16137 //
     /* 2085708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085754 */     // MIs[0] round
     /* 2085754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085757 */     // MIs[0] policy
     /* 2085757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085793 */     // GIR_Coverage, 16137,
     /* 2085793 */     GIR_EraseRootFromParent_Done,
     /* 2085794 */   // Label 27693: @2085794
     /* 2085794 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2085885), // Rule ID 16140 //
     /* 2085799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085845 */     // MIs[0] round
     /* 2085845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085848 */     // MIs[0] policy
     /* 2085848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085884 */     // GIR_Coverage, 16140,
     /* 2085884 */     GIR_EraseRootFromParent_Done,
     /* 2085885 */   // Label 27694: @2085885
     /* 2085885 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2085976), // Rule ID 16141 //
     /* 2085890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085936 */     // MIs[0] round
     /* 2085936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085939 */     // MIs[0] policy
     /* 2085939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085949 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085975 */     // GIR_Coverage, 16141,
     /* 2085975 */     GIR_EraseRootFromParent_Done,
     /* 2085976 */   // Label 27695: @2085976
     /* 2085976 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2086067), // Rule ID 16144 //
     /* 2085981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086027 */     // MIs[0] round
     /* 2086027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086030 */     // MIs[0] policy
     /* 2086030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086066 */     // GIR_Coverage, 16144,
     /* 2086066 */     GIR_EraseRootFromParent_Done,
     /* 2086067 */   // Label 27696: @2086067
     /* 2086067 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2086158), // Rule ID 16145 //
     /* 2086072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2086083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2086086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2086089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086118 */     // MIs[0] round
     /* 2086118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086121 */     // MIs[0] policy
     /* 2086121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086157 */     // GIR_Coverage, 16145,
     /* 2086157 */     GIR_EraseRootFromParent_Done,
     /* 2086158 */   // Label 27697: @2086158
     /* 2086158 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2086249), // Rule ID 16148 //
     /* 2086163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086209 */     // MIs[0] round
     /* 2086209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086212 */     // MIs[0] policy
     /* 2086212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086248 */     // GIR_Coverage, 16148,
     /* 2086248 */     GIR_EraseRootFromParent_Done,
     /* 2086249 */   // Label 27698: @2086249
     /* 2086249 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2086340), // Rule ID 16149 //
     /* 2086254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086300 */     // MIs[0] round
     /* 2086300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086303 */     // MIs[0] policy
     /* 2086303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086339 */     // GIR_Coverage, 16149,
     /* 2086339 */     GIR_EraseRootFromParent_Done,
     /* 2086340 */   // Label 27699: @2086340
     /* 2086340 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2086431), // Rule ID 16152 //
     /* 2086345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2086362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2086365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086391 */     // MIs[0] round
     /* 2086391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086394 */     // MIs[0] policy
     /* 2086394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086430 */     // GIR_Coverage, 16152,
     /* 2086430 */     GIR_EraseRootFromParent_Done,
     /* 2086431 */   // Label 27700: @2086431
     /* 2086431 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2086522), // Rule ID 16153 //
     /* 2086436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2086447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2086450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2086453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2086456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086482 */     // MIs[0] round
     /* 2086482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086485 */     // MIs[0] policy
     /* 2086485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086521 */     // GIR_Coverage, 16153,
     /* 2086521 */     GIR_EraseRootFromParent_Done,
     /* 2086522 */   // Label 27701: @2086522
     /* 2086522 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2086613), // Rule ID 16156 //
     /* 2086527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086573 */     // MIs[0] round
     /* 2086573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086576 */     // MIs[0] policy
     /* 2086576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086612 */     // GIR_Coverage, 16156,
     /* 2086612 */     GIR_EraseRootFromParent_Done,
     /* 2086613 */   // Label 27702: @2086613
     /* 2086613 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2086704), // Rule ID 16157 //
     /* 2086618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086664 */     // MIs[0] round
     /* 2086664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086667 */     // MIs[0] policy
     /* 2086667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086703 */     // GIR_Coverage, 16157,
     /* 2086703 */     GIR_EraseRootFromParent_Done,
     /* 2086704 */   // Label 27703: @2086704
     /* 2086704 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2086795), // Rule ID 16160 //
     /* 2086709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086755 */     // MIs[0] round
     /* 2086755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086758 */     // MIs[0] policy
     /* 2086758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086794 */     // GIR_Coverage, 16160,
     /* 2086794 */     GIR_EraseRootFromParent_Done,
     /* 2086795 */   // Label 27704: @2086795
     /* 2086795 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2086886), // Rule ID 16161 //
     /* 2086800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086846 */     // MIs[0] round
     /* 2086846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086849 */     // MIs[0] policy
     /* 2086849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086885 */     // GIR_Coverage, 16161,
     /* 2086885 */     GIR_EraseRootFromParent_Done,
     /* 2086886 */   // Label 27705: @2086886
     /* 2086886 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2086977), // Rule ID 16164 //
     /* 2086891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086937 */     // MIs[0] round
     /* 2086937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086940 */     // MIs[0] policy
     /* 2086940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086976 */     // GIR_Coverage, 16164,
     /* 2086976 */     GIR_EraseRootFromParent_Done,
     /* 2086977 */   // Label 27706: @2086977
     /* 2086977 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2087068), // Rule ID 16165 //
     /* 2086982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2087002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2087012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087028 */     // MIs[0] round
     /* 2087028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087031 */     // MIs[0] policy
     /* 2087031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2087044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2087064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087067 */     // GIR_Coverage, 16165,
     /* 2087067 */     GIR_EraseRootFromParent_Done,
     /* 2087068 */   // Label 27707: @2087068
     /* 2087068 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2087159), // Rule ID 16168 //
     /* 2087073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2087090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087119 */     // MIs[0] round
     /* 2087119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087122 */     // MIs[0] policy
     /* 2087122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2087135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087158 */     // GIR_Coverage, 16168,
     /* 2087158 */     GIR_EraseRootFromParent_Done,
     /* 2087159 */   // Label 27708: @2087159
     /* 2087159 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2087250), // Rule ID 16169 //
     /* 2087164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2087181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087210 */     // MIs[0] round
     /* 2087210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087213 */     // MIs[0] policy
     /* 2087213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2087226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087249 */     // GIR_Coverage, 16169,
     /* 2087249 */     GIR_EraseRootFromParent_Done,
     /* 2087250 */   // Label 27709: @2087250
     /* 2087250 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2087341), // Rule ID 16172 //
     /* 2087255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2087266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2087269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2087272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087301 */     // MIs[0] round
     /* 2087301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087304 */     // MIs[0] policy
     /* 2087304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087340 */     // GIR_Coverage, 16172,
     /* 2087340 */     GIR_EraseRootFromParent_Done,
     /* 2087341 */   // Label 27710: @2087341
     /* 2087341 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2087432), // Rule ID 16173 //
     /* 2087346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2087357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2087360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2087363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087392 */     // MIs[0] round
     /* 2087392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087395 */     // MIs[0] policy
     /* 2087395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087405 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087431 */     // GIR_Coverage, 16173,
     /* 2087431 */     GIR_EraseRootFromParent_Done,
     /* 2087432 */   // Label 27711: @2087432
     /* 2087432 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2087523), // Rule ID 16176 //
     /* 2087437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087483 */     // MIs[0] round
     /* 2087483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087486 */     // MIs[0] policy
     /* 2087486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087522 */     // GIR_Coverage, 16176,
     /* 2087522 */     GIR_EraseRootFromParent_Done,
     /* 2087523 */   // Label 27712: @2087523
     /* 2087523 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2087614), // Rule ID 16177 //
     /* 2087528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087574 */     // MIs[0] round
     /* 2087574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087577 */     // MIs[0] policy
     /* 2087577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087587 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087613 */     // GIR_Coverage, 16177,
     /* 2087613 */     GIR_EraseRootFromParent_Done,
     /* 2087614 */   // Label 27713: @2087614
     /* 2087614 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2087705), // Rule ID 16180 //
     /* 2087619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087665 */     // MIs[0] round
     /* 2087665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087668 */     // MIs[0] policy
     /* 2087668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087704 */     // GIR_Coverage, 16180,
     /* 2087704 */     GIR_EraseRootFromParent_Done,
     /* 2087705 */   // Label 27714: @2087705
     /* 2087705 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2087796), // Rule ID 16181 //
     /* 2087710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087756 */     // MIs[0] round
     /* 2087756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087759 */     // MIs[0] policy
     /* 2087759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087795 */     // GIR_Coverage, 16181,
     /* 2087795 */     GIR_EraseRootFromParent_Done,
     /* 2087796 */   // Label 27715: @2087796
     /* 2087796 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2087887), // Rule ID 16184 //
     /* 2087801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087847 */     // MIs[0] round
     /* 2087847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087850 */     // MIs[0] policy
     /* 2087850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087886 */     // GIR_Coverage, 16184,
     /* 2087886 */     GIR_EraseRootFromParent_Done,
     /* 2087887 */   // Label 27716: @2087887
     /* 2087887 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2087978), // Rule ID 16185 //
     /* 2087892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087938 */     // MIs[0] round
     /* 2087938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087941 */     // MIs[0] policy
     /* 2087941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087951 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087977 */     // GIR_Coverage, 16185,
     /* 2087977 */     GIR_EraseRootFromParent_Done,
     /* 2087978 */   // Label 27717: @2087978
     /* 2087978 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2088069), // Rule ID 16188 //
     /* 2087983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088029 */     // MIs[0] round
     /* 2088029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088032 */     // MIs[0] policy
     /* 2088032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2088045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088068 */     // GIR_Coverage, 16188,
     /* 2088068 */     GIR_EraseRootFromParent_Done,
     /* 2088069 */   // Label 27718: @2088069
     /* 2088069 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2088160), // Rule ID 16189 //
     /* 2088074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088120 */     // MIs[0] round
     /* 2088120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088123 */     // MIs[0] policy
     /* 2088123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2088136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088159 */     // GIR_Coverage, 16189,
     /* 2088159 */     GIR_EraseRootFromParent_Done,
     /* 2088160 */   // Label 27719: @2088160
     /* 2088160 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2088251), // Rule ID 16192 //
     /* 2088165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2088182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088211 */     // MIs[0] round
     /* 2088211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088214 */     // MIs[0] policy
     /* 2088214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088250 */     // GIR_Coverage, 16192,
     /* 2088250 */     GIR_EraseRootFromParent_Done,
     /* 2088251 */   // Label 27720: @2088251
     /* 2088251 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2088342), // Rule ID 16193 //
     /* 2088256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2088273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088302 */     // MIs[0] round
     /* 2088302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088305 */     // MIs[0] policy
     /* 2088305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11656:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088341 */     // GIR_Coverage, 16193,
     /* 2088341 */     GIR_EraseRootFromParent_Done,
     /* 2088342 */   // Label 27721: @2088342
     /* 2088342 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2088433), // Rule ID 16196 //
     /* 2088347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088393 */     // MIs[0] round
     /* 2088393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088396 */     // MIs[0] policy
     /* 2088396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088432 */     // GIR_Coverage, 16196,
     /* 2088432 */     GIR_EraseRootFromParent_Done,
     /* 2088433 */   // Label 27722: @2088433
     /* 2088433 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2088524), // Rule ID 16197 //
     /* 2088438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088484 */     // MIs[0] round
     /* 2088484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088487 */     // MIs[0] policy
     /* 2088487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088523 */     // GIR_Coverage, 16197,
     /* 2088523 */     GIR_EraseRootFromParent_Done,
     /* 2088524 */   // Label 27723: @2088524
     /* 2088524 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2088615), // Rule ID 16200 //
     /* 2088529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088575 */     // MIs[0] round
     /* 2088575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088578 */     // MIs[0] policy
     /* 2088578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088614 */     // GIR_Coverage, 16200,
     /* 2088614 */     GIR_EraseRootFromParent_Done,
     /* 2088615 */   // Label 27724: @2088615
     /* 2088615 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2088706), // Rule ID 16201 //
     /* 2088620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088666 */     // MIs[0] round
     /* 2088666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088669 */     // MIs[0] policy
     /* 2088669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088705 */     // GIR_Coverage, 16201,
     /* 2088705 */     GIR_EraseRootFromParent_Done,
     /* 2088706 */   // Label 27725: @2088706
     /* 2088706 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2088797), // Rule ID 16204 //
     /* 2088711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2088714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088757 */     // MIs[0] round
     /* 2088757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088760 */     // MIs[0] policy
     /* 2088760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088796 */     // GIR_Coverage, 16204,
     /* 2088796 */     GIR_EraseRootFromParent_Done,
     /* 2088797 */   // Label 27726: @2088797
     /* 2088797 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2088888), // Rule ID 16205 //
     /* 2088802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2088805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088848 */     // MIs[0] round
     /* 2088848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088851 */     // MIs[0] policy
     /* 2088851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088887 */     // GIR_Coverage, 16205,
     /* 2088887 */     GIR_EraseRootFromParent_Done,
     /* 2088888 */   // Label 27727: @2088888
     /* 2088888 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2088979), // Rule ID 16208 //
     /* 2088893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088939 */     // MIs[0] round
     /* 2088939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088942 */     // MIs[0] policy
     /* 2088942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088978 */     // GIR_Coverage, 16208,
     /* 2088978 */     GIR_EraseRootFromParent_Done,
     /* 2088979 */   // Label 27728: @2088979
     /* 2088979 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2089070), // Rule ID 16209 //
     /* 2088984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2089001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089030 */     // MIs[0] round
     /* 2089030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089033 */     // MIs[0] policy
     /* 2089033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089069 */     // GIR_Coverage, 16209,
     /* 2089069 */     GIR_EraseRootFromParent_Done,
     /* 2089070 */   // Label 27729: @2089070
     /* 2089070 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2089161), // Rule ID 16212 //
     /* 2089075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2089086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2089089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2089092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089121 */     // MIs[0] round
     /* 2089121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089124 */     // MIs[0] policy
     /* 2089124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089160 */     // GIR_Coverage, 16212,
     /* 2089160 */     GIR_EraseRootFromParent_Done,
     /* 2089161 */   // Label 27730: @2089161
     /* 2089161 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2089252), // Rule ID 16213 //
     /* 2089166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2089177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2089180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2089183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089212 */     // MIs[0] round
     /* 2089212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089215 */     // MIs[0] policy
     /* 2089215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089251 */     // GIR_Coverage, 16213,
     /* 2089251 */     GIR_EraseRootFromParent_Done,
     /* 2089252 */   // Label 27731: @2089252
     /* 2089252 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2089343), // Rule ID 16216 //
     /* 2089257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2089268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2089271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2089274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2089280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089303 */     // MIs[0] round
     /* 2089303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089306 */     // MIs[0] policy
     /* 2089306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089342 */     // GIR_Coverage, 16216,
     /* 2089342 */     GIR_EraseRootFromParent_Done,
     /* 2089343 */   // Label 27732: @2089343
     /* 2089343 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2089434), // Rule ID 16217 //
     /* 2089348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2089359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2089362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2089365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2089371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089394 */     // MIs[0] round
     /* 2089394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089397 */     // MIs[0] policy
     /* 2089397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089407 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089433 */     // GIR_Coverage, 16217,
     /* 2089433 */     GIR_EraseRootFromParent_Done,
     /* 2089434 */   // Label 27733: @2089434
     /* 2089434 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2089525), // Rule ID 16220 //
     /* 2089439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089485 */     // MIs[0] round
     /* 2089485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089488 */     // MIs[0] policy
     /* 2089488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089524 */     // GIR_Coverage, 16220,
     /* 2089524 */     GIR_EraseRootFromParent_Done,
     /* 2089525 */   // Label 27734: @2089525
     /* 2089525 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2089616), // Rule ID 16221 //
     /* 2089530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089576 */     // MIs[0] round
     /* 2089576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089579 */     // MIs[0] policy
     /* 2089579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089615 */     // GIR_Coverage, 16221,
     /* 2089615 */     GIR_EraseRootFromParent_Done,
     /* 2089616 */   // Label 27735: @2089616
     /* 2089616 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2089707), // Rule ID 16224 //
     /* 2089621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089667 */     // MIs[0] round
     /* 2089667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089670 */     // MIs[0] policy
     /* 2089670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089706 */     // GIR_Coverage, 16224,
     /* 2089706 */     GIR_EraseRootFromParent_Done,
     /* 2089707 */   // Label 27736: @2089707
     /* 2089707 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2089798), // Rule ID 16225 //
     /* 2089712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089758 */     // MIs[0] round
     /* 2089758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089761 */     // MIs[0] policy
     /* 2089761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089797 */     // GIR_Coverage, 16225,
     /* 2089797 */     GIR_EraseRootFromParent_Done,
     /* 2089798 */   // Label 27737: @2089798
     /* 2089798 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2089889), // Rule ID 16228 //
     /* 2089803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089849 */     // MIs[0] round
     /* 2089849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089852 */     // MIs[0] policy
     /* 2089852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089888 */     // GIR_Coverage, 16228,
     /* 2089888 */     GIR_EraseRootFromParent_Done,
     /* 2089889 */   // Label 27738: @2089889
     /* 2089889 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2089980), // Rule ID 16229 //
     /* 2089894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089940 */     // MIs[0] round
     /* 2089940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089943 */     // MIs[0] policy
     /* 2089943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089979 */     // GIR_Coverage, 16229,
     /* 2089979 */     GIR_EraseRootFromParent_Done,
     /* 2089980 */   // Label 27739: @2089980
     /* 2089980 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2090071), // Rule ID 16232 //
     /* 2089985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090031 */     // MIs[0] round
     /* 2090031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090034 */     // MIs[0] policy
     /* 2090034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090070 */     // GIR_Coverage, 16232,
     /* 2090070 */     GIR_EraseRootFromParent_Done,
     /* 2090071 */   // Label 27740: @2090071
     /* 2090071 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2090162), // Rule ID 16233 //
     /* 2090076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090122 */     // MIs[0] round
     /* 2090122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090125 */     // MIs[0] policy
     /* 2090125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090161 */     // GIR_Coverage, 16233,
     /* 2090161 */     GIR_EraseRootFromParent_Done,
     /* 2090162 */   // Label 27741: @2090162
     /* 2090162 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2090253), // Rule ID 16236 //
     /* 2090167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2090184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090213 */     // MIs[0] round
     /* 2090213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090216 */     // MIs[0] policy
     /* 2090216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090252 */     // GIR_Coverage, 16236,
     /* 2090252 */     GIR_EraseRootFromParent_Done,
     /* 2090253 */   // Label 27742: @2090253
     /* 2090253 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2090344), // Rule ID 16237 //
     /* 2090258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2090275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090304 */     // MIs[0] round
     /* 2090304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090307 */     // MIs[0] policy
     /* 2090307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090343 */     // GIR_Coverage, 16237,
     /* 2090343 */     GIR_EraseRootFromParent_Done,
     /* 2090344 */   // Label 27743: @2090344
     /* 2090344 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2090435), // Rule ID 16240 //
     /* 2090349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2090360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2090363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2090366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090395 */     // MIs[0] round
     /* 2090395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090398 */     // MIs[0] policy
     /* 2090398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090434 */     // GIR_Coverage, 16240,
     /* 2090434 */     GIR_EraseRootFromParent_Done,
     /* 2090435 */   // Label 27744: @2090435
     /* 2090435 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2090526), // Rule ID 16241 //
     /* 2090440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2090451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2090454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2090457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090486 */     // MIs[0] round
     /* 2090486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090489 */     // MIs[0] policy
     /* 2090489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090525 */     // GIR_Coverage, 16241,
     /* 2090525 */     GIR_EraseRootFromParent_Done,
     /* 2090526 */   // Label 27745: @2090526
     /* 2090526 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2090617), // Rule ID 16244 //
     /* 2090531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090577 */     // MIs[0] round
     /* 2090577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090580 */     // MIs[0] policy
     /* 2090580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090616 */     // GIR_Coverage, 16244,
     /* 2090616 */     GIR_EraseRootFromParent_Done,
     /* 2090617 */   // Label 27746: @2090617
     /* 2090617 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2090708), // Rule ID 16245 //
     /* 2090622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090668 */     // MIs[0] round
     /* 2090668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090671 */     // MIs[0] policy
     /* 2090671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090707 */     // GIR_Coverage, 16245,
     /* 2090707 */     GIR_EraseRootFromParent_Done,
     /* 2090708 */   // Label 27747: @2090708
     /* 2090708 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2090799), // Rule ID 16248 //
     /* 2090713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090759 */     // MIs[0] round
     /* 2090759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090762 */     // MIs[0] policy
     /* 2090762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090798 */     // GIR_Coverage, 16248,
     /* 2090798 */     GIR_EraseRootFromParent_Done,
     /* 2090799 */   // Label 27748: @2090799
     /* 2090799 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2090890), // Rule ID 16249 //
     /* 2090804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090850 */     // MIs[0] round
     /* 2090850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090853 */     // MIs[0] policy
     /* 2090853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090863 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090889 */     // GIR_Coverage, 16249,
     /* 2090889 */     GIR_EraseRootFromParent_Done,
     /* 2090890 */   // Label 27749: @2090890
     /* 2090890 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2090981), // Rule ID 16252 //
     /* 2090895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090941 */     // MIs[0] round
     /* 2090941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090944 */     // MIs[0] policy
     /* 2090944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090980 */     // GIR_Coverage, 16252,
     /* 2090980 */     GIR_EraseRootFromParent_Done,
     /* 2090981 */   // Label 27750: @2090981
     /* 2090981 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2091072), // Rule ID 16253 //
     /* 2090986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2091000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2091003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2091006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2091016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2091028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091032 */     // MIs[0] round
     /* 2091032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091035 */     // MIs[0] policy
     /* 2091035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091045 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2091048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2091068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091071 */     // GIR_Coverage, 16253,
     /* 2091071 */     GIR_EraseRootFromParent_Done,
     /* 2091072 */   // Label 27751: @2091072
     /* 2091072 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2091166), // Rule ID 16344 //
     /* 2091077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2091088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2091091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2091097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091123 */     // MIs[0] round
     /* 2091123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091126 */     // MIs[0] policy
     /* 2091126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2091139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091165 */     // GIR_Coverage, 16344,
     /* 2091165 */     GIR_EraseRootFromParent_Done,
     /* 2091166 */   // Label 27752: @2091166
     /* 2091166 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2091260), // Rule ID 16345 //
     /* 2091171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2091182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2091185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2091188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2091191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091217 */     // MIs[0] round
     /* 2091217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091220 */     // MIs[0] policy
     /* 2091220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091230 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2091233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091259 */     // GIR_Coverage, 16345,
     /* 2091259 */     GIR_EraseRootFromParent_Done,
     /* 2091260 */   // Label 27753: @2091260
     /* 2091260 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2091354), // Rule ID 16348 //
     /* 2091265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2091276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2091279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2091285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091311 */     // MIs[0] round
     /* 2091311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091314 */     // MIs[0] policy
     /* 2091314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091353 */     // GIR_Coverage, 16348,
     /* 2091353 */     GIR_EraseRootFromParent_Done,
     /* 2091354 */   // Label 27754: @2091354
     /* 2091354 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2091448), // Rule ID 16349 //
     /* 2091359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2091370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2091373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2091376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2091379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091405 */     // MIs[0] round
     /* 2091405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091408 */     // MIs[0] policy
     /* 2091408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091418 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091447 */     // GIR_Coverage, 16349,
     /* 2091447 */     GIR_EraseRootFromParent_Done,
     /* 2091448 */   // Label 27755: @2091448
     /* 2091448 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2091542), // Rule ID 16352 //
     /* 2091453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091499 */     // MIs[0] round
     /* 2091499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091502 */     // MIs[0] policy
     /* 2091502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091541 */     // GIR_Coverage, 16352,
     /* 2091541 */     GIR_EraseRootFromParent_Done,
     /* 2091542 */   // Label 27756: @2091542
     /* 2091542 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2091636), // Rule ID 16353 //
     /* 2091547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091593 */     // MIs[0] round
     /* 2091593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091596 */     // MIs[0] policy
     /* 2091596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091635 */     // GIR_Coverage, 16353,
     /* 2091635 */     GIR_EraseRootFromParent_Done,
     /* 2091636 */   // Label 27757: @2091636
     /* 2091636 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2091730), // Rule ID 16356 //
     /* 2091641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091687 */     // MIs[0] round
     /* 2091687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091690 */     // MIs[0] policy
     /* 2091690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091729 */     // GIR_Coverage, 16356,
     /* 2091729 */     GIR_EraseRootFromParent_Done,
     /* 2091730 */   // Label 27758: @2091730
     /* 2091730 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2091824), // Rule ID 16357 //
     /* 2091735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091781 */     // MIs[0] round
     /* 2091781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091784 */     // MIs[0] policy
     /* 2091784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091823 */     // GIR_Coverage, 16357,
     /* 2091823 */     GIR_EraseRootFromParent_Done,
     /* 2091824 */   // Label 27759: @2091824
     /* 2091824 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2091918), // Rule ID 16360 //
     /* 2091829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091875 */     // MIs[0] round
     /* 2091875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091878 */     // MIs[0] policy
     /* 2091878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091917 */     // GIR_Coverage, 16360,
     /* 2091917 */     GIR_EraseRootFromParent_Done,
     /* 2091918 */   // Label 27760: @2091918
     /* 2091918 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2092012), // Rule ID 16361 //
     /* 2091923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091969 */     // MIs[0] round
     /* 2091969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091972 */     // MIs[0] policy
     /* 2091972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092011 */     // GIR_Coverage, 16361,
     /* 2092011 */     GIR_EraseRootFromParent_Done,
     /* 2092012 */   // Label 27761: @2092012
     /* 2092012 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2092106), // Rule ID 16364 //
     /* 2092017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2092037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092063 */     // MIs[0] round
     /* 2092063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092066 */     // MIs[0] policy
     /* 2092066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092105 */     // GIR_Coverage, 16364,
     /* 2092105 */     GIR_EraseRootFromParent_Done,
     /* 2092106 */   // Label 27762: @2092106
     /* 2092106 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2092200), // Rule ID 16365 //
     /* 2092111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2092122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2092125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2092131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092157 */     // MIs[0] round
     /* 2092157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092160 */     // MIs[0] policy
     /* 2092160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092199 */     // GIR_Coverage, 16365,
     /* 2092199 */     GIR_EraseRootFromParent_Done,
     /* 2092200 */   // Label 27763: @2092200
     /* 2092200 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2092294), // Rule ID 16368 //
     /* 2092205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2092216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2092219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2092222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2092225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092251 */     // MIs[0] round
     /* 2092251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092254 */     // MIs[0] policy
     /* 2092254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2092267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092293 */     // GIR_Coverage, 16368,
     /* 2092293 */     GIR_EraseRootFromParent_Done,
     /* 2092294 */   // Label 27764: @2092294
     /* 2092294 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2092388), // Rule ID 16369 //
     /* 2092299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2092310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2092313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2092316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2092319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092345 */     // MIs[0] round
     /* 2092345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092348 */     // MIs[0] policy
     /* 2092348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2092361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092387 */     // GIR_Coverage, 16369,
     /* 2092387 */     GIR_EraseRootFromParent_Done,
     /* 2092388 */   // Label 27765: @2092388
     /* 2092388 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2092482), // Rule ID 16372 //
     /* 2092393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092439 */     // MIs[0] round
     /* 2092439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092442 */     // MIs[0] policy
     /* 2092442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092481 */     // GIR_Coverage, 16372,
     /* 2092481 */     GIR_EraseRootFromParent_Done,
     /* 2092482 */   // Label 27766: @2092482
     /* 2092482 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2092576), // Rule ID 16373 //
     /* 2092487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092533 */     // MIs[0] round
     /* 2092533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092536 */     // MIs[0] policy
     /* 2092536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092575 */     // GIR_Coverage, 16373,
     /* 2092575 */     GIR_EraseRootFromParent_Done,
     /* 2092576 */   // Label 27767: @2092576
     /* 2092576 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2092670), // Rule ID 16376 //
     /* 2092581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092627 */     // MIs[0] round
     /* 2092627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092630 */     // MIs[0] policy
     /* 2092630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092669 */     // GIR_Coverage, 16376,
     /* 2092669 */     GIR_EraseRootFromParent_Done,
     /* 2092670 */   // Label 27768: @2092670
     /* 2092670 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2092764), // Rule ID 16377 //
     /* 2092675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092721 */     // MIs[0] round
     /* 2092721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092724 */     // MIs[0] policy
     /* 2092724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092763 */     // GIR_Coverage, 16377,
     /* 2092763 */     GIR_EraseRootFromParent_Done,
     /* 2092764 */   // Label 27769: @2092764
     /* 2092764 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2092858), // Rule ID 16380 //
     /* 2092769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092815 */     // MIs[0] round
     /* 2092815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092818 */     // MIs[0] policy
     /* 2092818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092857 */     // GIR_Coverage, 16380,
     /* 2092857 */     GIR_EraseRootFromParent_Done,
     /* 2092858 */   // Label 27770: @2092858
     /* 2092858 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2092952), // Rule ID 16381 //
     /* 2092863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092909 */     // MIs[0] round
     /* 2092909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092912 */     // MIs[0] policy
     /* 2092912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092951 */     // GIR_Coverage, 16381,
     /* 2092951 */     GIR_EraseRootFromParent_Done,
     /* 2092952 */   // Label 27771: @2092952
     /* 2092952 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2093046), // Rule ID 16384 //
     /* 2092957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093003 */     // MIs[0] round
     /* 2093003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093006 */     // MIs[0] policy
     /* 2093006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093045 */     // GIR_Coverage, 16384,
     /* 2093045 */     GIR_EraseRootFromParent_Done,
     /* 2093046 */   // Label 27772: @2093046
     /* 2093046 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2093140), // Rule ID 16385 //
     /* 2093051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2093062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2093065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2093068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2093071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093097 */     // MIs[0] round
     /* 2093097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093100 */     // MIs[0] policy
     /* 2093100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093139 */     // GIR_Coverage, 16385,
     /* 2093139 */     GIR_EraseRootFromParent_Done,
     /* 2093140 */   // Label 27773: @2093140
     /* 2093140 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2093234), // Rule ID 16388 //
     /* 2093145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2093162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2093165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093191 */     // MIs[0] round
     /* 2093191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093194 */     // MIs[0] policy
     /* 2093194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2093207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093233 */     // GIR_Coverage, 16388,
     /* 2093233 */     GIR_EraseRootFromParent_Done,
     /* 2093234 */   // Label 27774: @2093234
     /* 2093234 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2093328), // Rule ID 16389 //
     /* 2093239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2093256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2093259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093285 */     // MIs[0] round
     /* 2093285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093288 */     // MIs[0] policy
     /* 2093288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2093301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093327 */     // GIR_Coverage, 16389,
     /* 2093327 */     GIR_EraseRootFromParent_Done,
     /* 2093328 */   // Label 27775: @2093328
     /* 2093328 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2093422), // Rule ID 16392 //
     /* 2093333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2093350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093379 */     // MIs[0] round
     /* 2093379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093382 */     // MIs[0] policy
     /* 2093382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093421 */     // GIR_Coverage, 16392,
     /* 2093421 */     GIR_EraseRootFromParent_Done,
     /* 2093422 */   // Label 27776: @2093422
     /* 2093422 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2093516), // Rule ID 16393 //
     /* 2093427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2093438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2093441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2093444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2093447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093473 */     // MIs[0] round
     /* 2093473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093476 */     // MIs[0] policy
     /* 2093476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093515 */     // GIR_Coverage, 16393,
     /* 2093515 */     GIR_EraseRootFromParent_Done,
     /* 2093516 */   // Label 27777: @2093516
     /* 2093516 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2093610), // Rule ID 16396 //
     /* 2093521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093567 */     // MIs[0] round
     /* 2093567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093570 */     // MIs[0] policy
     /* 2093570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093609 */     // GIR_Coverage, 16396,
     /* 2093609 */     GIR_EraseRootFromParent_Done,
     /* 2093610 */   // Label 27778: @2093610
     /* 2093610 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2093704), // Rule ID 16397 //
     /* 2093615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093661 */     // MIs[0] round
     /* 2093661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093664 */     // MIs[0] policy
     /* 2093664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093703 */     // GIR_Coverage, 16397,
     /* 2093703 */     GIR_EraseRootFromParent_Done,
     /* 2093704 */   // Label 27779: @2093704
     /* 2093704 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2093798), // Rule ID 16400 //
     /* 2093709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093755 */     // MIs[0] round
     /* 2093755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093758 */     // MIs[0] policy
     /* 2093758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093797 */     // GIR_Coverage, 16400,
     /* 2093797 */     GIR_EraseRootFromParent_Done,
     /* 2093798 */   // Label 27780: @2093798
     /* 2093798 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2093892), // Rule ID 16401 //
     /* 2093803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093849 */     // MIs[0] round
     /* 2093849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093852 */     // MIs[0] policy
     /* 2093852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093891 */     // GIR_Coverage, 16401,
     /* 2093891 */     GIR_EraseRootFromParent_Done,
     /* 2093892 */   // Label 27781: @2093892
     /* 2093892 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2093986), // Rule ID 16404 //
     /* 2093897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093943 */     // MIs[0] round
     /* 2093943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093946 */     // MIs[0] policy
     /* 2093946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093985 */     // GIR_Coverage, 16404,
     /* 2093985 */     GIR_EraseRootFromParent_Done,
     /* 2093986 */   // Label 27782: @2093986
     /* 2093986 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2094080), // Rule ID 16405 //
     /* 2093991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2094002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2094005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2094008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094037 */     // MIs[0] round
     /* 2094037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094040 */     // MIs[0] policy
     /* 2094040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2094053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094079 */     // GIR_Coverage, 16405,
     /* 2094079 */     GIR_EraseRootFromParent_Done,
     /* 2094080 */   // Label 27783: @2094080
     /* 2094080 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2094174), // Rule ID 16408 //
     /* 2094085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094131 */     // MIs[0] round
     /* 2094131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094134 */     // MIs[0] policy
     /* 2094134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094173 */     // GIR_Coverage, 16408,
     /* 2094173 */     GIR_EraseRootFromParent_Done,
     /* 2094174 */   // Label 27784: @2094174
     /* 2094174 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2094268), // Rule ID 16409 //
     /* 2094179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2094190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2094193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2094196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094225 */     // MIs[0] round
     /* 2094225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094228 */     // MIs[0] policy
     /* 2094228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094267 */     // GIR_Coverage, 16409,
     /* 2094267 */     GIR_EraseRootFromParent_Done,
     /* 2094268 */   // Label 27785: @2094268
     /* 2094268 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2094362), // Rule ID 16412 //
     /* 2094273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094319 */     // MIs[0] round
     /* 2094319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094322 */     // MIs[0] policy
     /* 2094322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094361 */     // GIR_Coverage, 16412,
     /* 2094361 */     GIR_EraseRootFromParent_Done,
     /* 2094362 */   // Label 27786: @2094362
     /* 2094362 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2094456), // Rule ID 16413 //
     /* 2094367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2094378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2094381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094413 */     // MIs[0] round
     /* 2094413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094416 */     // MIs[0] policy
     /* 2094416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094426 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094455 */     // GIR_Coverage, 16413,
     /* 2094455 */     GIR_EraseRootFromParent_Done,
     /* 2094456 */   // Label 27787: @2094456
     /* 2094456 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2094550), // Rule ID 16416 //
     /* 2094461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094507 */     // MIs[0] round
     /* 2094507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094510 */     // MIs[0] policy
     /* 2094510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094549 */     // GIR_Coverage, 16416,
     /* 2094549 */     GIR_EraseRootFromParent_Done,
     /* 2094550 */   // Label 27788: @2094550
     /* 2094550 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2094644), // Rule ID 16417 //
     /* 2094555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094601 */     // MIs[0] round
     /* 2094601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094604 */     // MIs[0] policy
     /* 2094604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11542:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094643 */     // GIR_Coverage, 16417,
     /* 2094643 */     GIR_EraseRootFromParent_Done,
     /* 2094644 */   // Label 27789: @2094644
     /* 2094644 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2094738), // Rule ID 16420 //
     /* 2094649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094695 */     // MIs[0] round
     /* 2094695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094698 */     // MIs[0] policy
     /* 2094698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094708 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094737 */     // GIR_Coverage, 16420,
     /* 2094737 */     GIR_EraseRootFromParent_Done,
     /* 2094738 */   // Label 27790: @2094738
     /* 2094738 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2094832), // Rule ID 16421 //
     /* 2094743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094789 */     // MIs[0] round
     /* 2094789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094792 */     // MIs[0] policy
     /* 2094792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094831 */     // GIR_Coverage, 16421,
     /* 2094831 */     GIR_EraseRootFromParent_Done,
     /* 2094832 */   // Label 27791: @2094832
     /* 2094832 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2094926), // Rule ID 16424 //
     /* 2094837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094883 */     // MIs[0] round
     /* 2094883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094886 */     // MIs[0] policy
     /* 2094886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094896 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094925 */     // GIR_Coverage, 16424,
     /* 2094925 */     GIR_EraseRootFromParent_Done,
     /* 2094926 */   // Label 27792: @2094926
     /* 2094926 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2095020), // Rule ID 16425 //
     /* 2094931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094977 */     // MIs[0] round
     /* 2094977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094980 */     // MIs[0] policy
     /* 2094980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2095013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095019 */     // GIR_Coverage, 16425,
     /* 2095019 */     GIR_EraseRootFromParent_Done,
     /* 2095020 */   // Label 27793: @2095020
     /* 2095020 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2095114), // Rule ID 16428 //
     /* 2095025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095071 */     // MIs[0] round
     /* 2095071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095074 */     // MIs[0] policy
     /* 2095074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2095087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095113 */     // GIR_Coverage, 16428,
     /* 2095113 */     GIR_EraseRootFromParent_Done,
     /* 2095114 */   // Label 27794: @2095114
     /* 2095114 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2095208), // Rule ID 16429 //
     /* 2095119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095165 */     // MIs[0] round
     /* 2095165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095168 */     // MIs[0] policy
     /* 2095168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2095181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095207 */     // GIR_Coverage, 16429,
     /* 2095207 */     GIR_EraseRootFromParent_Done,
     /* 2095208 */   // Label 27795: @2095208
     /* 2095208 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2095302), // Rule ID 16432 //
     /* 2095213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095259 */     // MIs[0] round
     /* 2095259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095262 */     // MIs[0] policy
     /* 2095262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095301 */     // GIR_Coverage, 16432,
     /* 2095301 */     GIR_EraseRootFromParent_Done,
     /* 2095302 */   // Label 27796: @2095302
     /* 2095302 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2095396), // Rule ID 16433 //
     /* 2095307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095353 */     // MIs[0] round
     /* 2095353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095356 */     // MIs[0] policy
     /* 2095356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095395 */     // GIR_Coverage, 16433,
     /* 2095395 */     GIR_EraseRootFromParent_Done,
     /* 2095396 */   // Label 27797: @2095396
     /* 2095396 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2095490), // Rule ID 16436 //
     /* 2095401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095447 */     // MIs[0] round
     /* 2095447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095450 */     // MIs[0] policy
     /* 2095450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095489 */     // GIR_Coverage, 16436,
     /* 2095489 */     GIR_EraseRootFromParent_Done,
     /* 2095490 */   // Label 27798: @2095490
     /* 2095490 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2095584), // Rule ID 16437 //
     /* 2095495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095541 */     // MIs[0] round
     /* 2095541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095544 */     // MIs[0] policy
     /* 2095544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095554 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11542:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095583 */     // GIR_Coverage, 16437,
     /* 2095583 */     GIR_EraseRootFromParent_Done,
     /* 2095584 */   // Label 27799: @2095584
     /* 2095584 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2095678), // Rule ID 16440 //
     /* 2095589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095635 */     // MIs[0] round
     /* 2095635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095638 */     // MIs[0] policy
     /* 2095638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095677 */     // GIR_Coverage, 16440,
     /* 2095677 */     GIR_EraseRootFromParent_Done,
     /* 2095678 */   // Label 27800: @2095678
     /* 2095678 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2095772), // Rule ID 16441 //
     /* 2095683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095729 */     // MIs[0] round
     /* 2095729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095732 */     // MIs[0] policy
     /* 2095732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095771 */     // GIR_Coverage, 16441,
     /* 2095771 */     GIR_EraseRootFromParent_Done,
     /* 2095772 */   // Label 27801: @2095772
     /* 2095772 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2095866), // Rule ID 16444 //
     /* 2095777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095823 */     // MIs[0] round
     /* 2095823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095826 */     // MIs[0] policy
     /* 2095826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095865 */     // GIR_Coverage, 16444,
     /* 2095865 */     GIR_EraseRootFromParent_Done,
     /* 2095866 */   // Label 27802: @2095866
     /* 2095866 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2095960), // Rule ID 16445 //
     /* 2095871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095917 */     // MIs[0] round
     /* 2095917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095920 */     // MIs[0] policy
     /* 2095920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095959 */     // GIR_Coverage, 16445,
     /* 2095959 */     GIR_EraseRootFromParent_Done,
     /* 2095960 */   // Label 27803: @2095960
     /* 2095960 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2096054), // Rule ID 16448 //
     /* 2095965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096011 */     // MIs[0] round
     /* 2096011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096014 */     // MIs[0] policy
     /* 2096014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2096027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096053 */     // GIR_Coverage, 16448,
     /* 2096053 */     GIR_EraseRootFromParent_Done,
     /* 2096054 */   // Label 27804: @2096054
     /* 2096054 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2096148), // Rule ID 16449 //
     /* 2096059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2096076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096105 */     // MIs[0] round
     /* 2096105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096108 */     // MIs[0] policy
     /* 2096108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2096121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096147 */     // GIR_Coverage, 16449,
     /* 2096147 */     GIR_EraseRootFromParent_Done,
     /* 2096148 */   // Label 27805: @2096148
     /* 2096148 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2096242), // Rule ID 16452 //
     /* 2096153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096199 */     // MIs[0] round
     /* 2096199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096202 */     // MIs[0] policy
     /* 2096202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2096215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096241 */     // GIR_Coverage, 16452,
     /* 2096241 */     GIR_EraseRootFromParent_Done,
     /* 2096242 */   // Label 27806: @2096242
     /* 2096242 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2096336), // Rule ID 16453 //
     /* 2096247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2096264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096293 */     // MIs[0] round
     /* 2096293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096296 */     // MIs[0] policy
     /* 2096296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2096309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096335 */     // GIR_Coverage, 16453,
     /* 2096335 */     GIR_EraseRootFromParent_Done,
     /* 2096336 */   // Label 27807: @2096336
     /* 2096336 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2096430), // Rule ID 16456 //
     /* 2096341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2096358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096387 */     // MIs[0] round
     /* 2096387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096390 */     // MIs[0] policy
     /* 2096390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096429 */     // GIR_Coverage, 16456,
     /* 2096429 */     GIR_EraseRootFromParent_Done,
     /* 2096430 */   // Label 27808: @2096430
     /* 2096430 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2096524), // Rule ID 16457 //
     /* 2096435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2096452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096481 */     // MIs[0] round
     /* 2096481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096484 */     // MIs[0] policy
     /* 2096484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096523 */     // GIR_Coverage, 16457,
     /* 2096523 */     GIR_EraseRootFromParent_Done,
     /* 2096524 */   // Label 27809: @2096524
     /* 2096524 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2096618), // Rule ID 16460 //
     /* 2096529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096575 */     // MIs[0] round
     /* 2096575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096578 */     // MIs[0] policy
     /* 2096578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096617 */     // GIR_Coverage, 16460,
     /* 2096617 */     GIR_EraseRootFromParent_Done,
     /* 2096618 */   // Label 27810: @2096618
     /* 2096618 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2096712), // Rule ID 16461 //
     /* 2096623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096669 */     // MIs[0] round
     /* 2096669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096672 */     // MIs[0] policy
     /* 2096672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096711 */     // GIR_Coverage, 16461,
     /* 2096711 */     GIR_EraseRootFromParent_Done,
     /* 2096712 */   // Label 27811: @2096712
     /* 2096712 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2096806), // Rule ID 16524 //
     /* 2096717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096763 */     // MIs[0] round
     /* 2096763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096766 */     // MIs[0] policy
     /* 2096766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096805 */     // GIR_Coverage, 16524,
     /* 2096805 */     GIR_EraseRootFromParent_Done,
     /* 2096806 */   // Label 27812: @2096806
     /* 2096806 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2096900), // Rule ID 16525 //
     /* 2096811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096857 */     // MIs[0] round
     /* 2096857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096860 */     // MIs[0] policy
     /* 2096860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096870 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096899 */     // GIR_Coverage, 16525,
     /* 2096899 */     GIR_EraseRootFromParent_Done,
     /* 2096900 */   // Label 27813: @2096900
     /* 2096900 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2096994), // Rule ID 16528 //
     /* 2096905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096951 */     // MIs[0] round
     /* 2096951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096954 */     // MIs[0] policy
     /* 2096954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096993 */     // GIR_Coverage, 16528,
     /* 2096993 */     GIR_EraseRootFromParent_Done,
     /* 2096994 */   // Label 27814: @2096994
     /* 2096994 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2097088), // Rule ID 16529 //
     /* 2096999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2097010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2097013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2097016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2097019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097045 */     // MIs[0] round
     /* 2097045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097048 */     // MIs[0] policy
     /* 2097048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097058 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097087 */     // GIR_Coverage, 16529,
     /* 2097087 */     GIR_EraseRootFromParent_Done,
     /* 2097088 */   // Label 27815: @2097088
     /* 2097088 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2097182), // Rule ID 16532 //
     /* 2097093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2097113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097139 */     // MIs[0] round
     /* 2097139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097142 */     // MIs[0] policy
     /* 2097142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097181 */     // GIR_Coverage, 16532,
     /* 2097181 */     GIR_EraseRootFromParent_Done,
     /* 2097182 */   // Label 27816: @2097182
     /* 2097182 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2097276), // Rule ID 16533 //
     /* 2097187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2097198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2097201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2097204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2097207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097233 */     // MIs[0] round
     /* 2097233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097236 */     // MIs[0] policy
     /* 2097236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097246 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097275 */     // GIR_Coverage, 16533,
     /* 2097275 */     GIR_EraseRootFromParent_Done,
     /* 2097276 */   // Label 27817: @2097276
     /* 2097276 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2097370), // Rule ID 16536 //
     /* 2097281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2097301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097327 */     // MIs[0] round
     /* 2097327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097330 */     // MIs[0] policy
     /* 2097330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097369 */     // GIR_Coverage, 16536,
     /* 2097369 */     GIR_EraseRootFromParent_Done,
     /* 2097370 */   // Label 27818: @2097370
     /* 2097370 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2097464), // Rule ID 16537 //
     /* 2097375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2097386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2097389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2097395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097421 */     // MIs[0] round
     /* 2097421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097424 */     // MIs[0] policy
     /* 2097424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097463 */     // GIR_Coverage, 16537,
     /* 2097463 */     GIR_EraseRootFromParent_Done,
     /* 2097464 */   // Label 27819: @2097464
     /* 2097464 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2097558), // Rule ID 16540 //
     /* 2097469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097515 */     // MIs[0] round
     /* 2097515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097518 */     // MIs[0] policy
     /* 2097518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097557 */     // GIR_Coverage, 16540,
     /* 2097557 */     GIR_EraseRootFromParent_Done,
     /* 2097558 */   // Label 27820: @2097558
     /* 2097558 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2097652), // Rule ID 16541 //
     /* 2097563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097609 */     // MIs[0] round
     /* 2097609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097612 */     // MIs[0] policy
     /* 2097612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097651 */     // GIR_Coverage, 16541,
     /* 2097651 */     GIR_EraseRootFromParent_Done,
     /* 2097652 */   // Label 27821: @2097652
     /* 2097652 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2097746), // Rule ID 16544 //
     /* 2097657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097703 */     // MIs[0] round
     /* 2097703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097706 */     // MIs[0] policy
     /* 2097706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097745 */     // GIR_Coverage, 16544,
     /* 2097745 */     GIR_EraseRootFromParent_Done,
     /* 2097746 */   // Label 27822: @2097746
     /* 2097746 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2097840), // Rule ID 16545 //
     /* 2097751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097797 */     // MIs[0] round
     /* 2097797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097800 */     // MIs[0] policy
     /* 2097800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097810 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097839 */     // GIR_Coverage, 16545,
     /* 2097839 */     GIR_EraseRootFromParent_Done,
     /* 2097840 */   // Label 27823: @2097840
     /* 2097840 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2097934), // Rule ID 16548 //
     /* 2097845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097891 */     // MIs[0] round
     /* 2097891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097894 */     // MIs[0] policy
     /* 2097894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097933 */     // GIR_Coverage, 16548,
     /* 2097933 */     GIR_EraseRootFromParent_Done,
     /* 2097934 */   // Label 27824: @2097934
     /* 2097934 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2098028), // Rule ID 16549 //
     /* 2097939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097985 */     // MIs[0] round
     /* 2097985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097988 */     // MIs[0] policy
     /* 2097988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2098001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098027 */     // GIR_Coverage, 16549,
     /* 2098027 */     GIR_EraseRootFromParent_Done,
     /* 2098028 */   // Label 27825: @2098028
     /* 2098028 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2098122), // Rule ID 16552 //
     /* 2098033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2098053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098079 */     // MIs[0] round
     /* 2098079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098082 */     // MIs[0] policy
     /* 2098082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098121 */     // GIR_Coverage, 16552,
     /* 2098121 */     GIR_EraseRootFromParent_Done,
     /* 2098122 */   // Label 27826: @2098122
     /* 2098122 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2098216), // Rule ID 16553 //
     /* 2098127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2098147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098173 */     // MIs[0] round
     /* 2098173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098176 */     // MIs[0] policy
     /* 2098176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098186 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098215 */     // GIR_Coverage, 16553,
     /* 2098215 */     GIR_EraseRootFromParent_Done,
     /* 2098216 */   // Label 27827: @2098216
     /* 2098216 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2098310), // Rule ID 16556 //
     /* 2098221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2098241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098267 */     // MIs[0] round
     /* 2098267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098270 */     // MIs[0] policy
     /* 2098270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098309 */     // GIR_Coverage, 16556,
     /* 2098309 */     GIR_EraseRootFromParent_Done,
     /* 2098310 */   // Label 27828: @2098310
     /* 2098310 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2098404), // Rule ID 16557 //
     /* 2098315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2098332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2098335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098361 */     // MIs[0] round
     /* 2098361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098364 */     // MIs[0] policy
     /* 2098364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098403 */     // GIR_Coverage, 16557,
     /* 2098403 */     GIR_EraseRootFromParent_Done,
     /* 2098404 */   // Label 27829: @2098404
     /* 2098404 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2098498), // Rule ID 16560 //
     /* 2098409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098455 */     // MIs[0] round
     /* 2098455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098458 */     // MIs[0] policy
     /* 2098458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098497 */     // GIR_Coverage, 16560,
     /* 2098497 */     GIR_EraseRootFromParent_Done,
     /* 2098498 */   // Label 27830: @2098498
     /* 2098498 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2098592), // Rule ID 16561 //
     /* 2098503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098549 */     // MIs[0] round
     /* 2098549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098552 */     // MIs[0] policy
     /* 2098552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098591 */     // GIR_Coverage, 16561,
     /* 2098591 */     GIR_EraseRootFromParent_Done,
     /* 2098592 */   // Label 27831: @2098592
     /* 2098592 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2098686), // Rule ID 16564 //
     /* 2098597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098643 */     // MIs[0] round
     /* 2098643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098646 */     // MIs[0] policy
     /* 2098646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098685 */     // GIR_Coverage, 16564,
     /* 2098685 */     GIR_EraseRootFromParent_Done,
     /* 2098686 */   // Label 27832: @2098686
     /* 2098686 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2098780), // Rule ID 16565 //
     /* 2098691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098737 */     // MIs[0] round
     /* 2098737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098740 */     // MIs[0] policy
     /* 2098740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098779 */     // GIR_Coverage, 16565,
     /* 2098779 */     GIR_EraseRootFromParent_Done,
     /* 2098780 */   // Label 27833: @2098780
     /* 2098780 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2098874), // Rule ID 16568 //
     /* 2098785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098831 */     // MIs[0] round
     /* 2098831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098834 */     // MIs[0] policy
     /* 2098834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098873 */     // GIR_Coverage, 16568,
     /* 2098873 */     GIR_EraseRootFromParent_Done,
     /* 2098874 */   // Label 27834: @2098874
     /* 2098874 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2098968), // Rule ID 16569 //
     /* 2098879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098925 */     // MIs[0] round
     /* 2098925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098928 */     // MIs[0] policy
     /* 2098928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098967 */     // GIR_Coverage, 16569,
     /* 2098967 */     GIR_EraseRootFromParent_Done,
     /* 2098968 */   // Label 27835: @2098968
     /* 2098968 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2099062), // Rule ID 16572 //
     /* 2098973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2098993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099019 */     // MIs[0] round
     /* 2099019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099022 */     // MIs[0] policy
     /* 2099022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2099035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099061 */     // GIR_Coverage, 16572,
     /* 2099061 */     GIR_EraseRootFromParent_Done,
     /* 2099062 */   // Label 27836: @2099062
     /* 2099062 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2099156), // Rule ID 16573 //
     /* 2099067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2099084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2099087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099113 */     // MIs[0] round
     /* 2099113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099116 */     // MIs[0] policy
     /* 2099116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2099129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099155 */     // GIR_Coverage, 16573,
     /* 2099155 */     GIR_EraseRootFromParent_Done,
     /* 2099156 */   // Label 27837: @2099156
     /* 2099156 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2099250), // Rule ID 16576 //
     /* 2099161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2099181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099207 */     // MIs[0] round
     /* 2099207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099210 */     // MIs[0] policy
     /* 2099210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2099223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099249 */     // GIR_Coverage, 16576,
     /* 2099249 */     GIR_EraseRootFromParent_Done,
     /* 2099250 */   // Label 27838: @2099250
     /* 2099250 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2099344), // Rule ID 16577 //
     /* 2099255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2099272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2099275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099301 */     // MIs[0] round
     /* 2099301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099304 */     // MIs[0] policy
     /* 2099304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2099317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099343 */     // GIR_Coverage, 16577,
     /* 2099343 */     GIR_EraseRootFromParent_Done,
     /* 2099344 */   // Label 27839: @2099344
     /* 2099344 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2099438), // Rule ID 16580 //
     /* 2099349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2099352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2099369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099395 */     // MIs[0] round
     /* 2099395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099398 */     // MIs[0] policy
     /* 2099398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099437 */     // GIR_Coverage, 16580,
     /* 2099437 */     GIR_EraseRootFromParent_Done,
     /* 2099438 */   // Label 27840: @2099438
     /* 2099438 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2099532), // Rule ID 16581 //
     /* 2099443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2099446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2099460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2099463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099489 */     // MIs[0] round
     /* 2099489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099492 */     // MIs[0] policy
     /* 2099492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099531 */     // GIR_Coverage, 16581,
     /* 2099531 */     GIR_EraseRootFromParent_Done,
     /* 2099532 */   // Label 27841: @2099532
     /* 2099532 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2099626), // Rule ID 16584 //
     /* 2099537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099583 */     // MIs[0] round
     /* 2099583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099586 */     // MIs[0] policy
     /* 2099586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099625 */     // GIR_Coverage, 16584,
     /* 2099625 */     GIR_EraseRootFromParent_Done,
     /* 2099626 */   // Label 27842: @2099626
     /* 2099626 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2099720), // Rule ID 16585 //
     /* 2099631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099677 */     // MIs[0] round
     /* 2099677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099680 */     // MIs[0] policy
     /* 2099680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099719 */     // GIR_Coverage, 16585,
     /* 2099719 */     GIR_EraseRootFromParent_Done,
     /* 2099720 */   // Label 27843: @2099720
     /* 2099720 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2099814), // Rule ID 16588 //
     /* 2099725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099771 */     // MIs[0] round
     /* 2099771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099774 */     // MIs[0] policy
     /* 2099774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099813 */     // GIR_Coverage, 16588,
     /* 2099813 */     GIR_EraseRootFromParent_Done,
     /* 2099814 */   // Label 27844: @2099814
     /* 2099814 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2099908), // Rule ID 16589 //
     /* 2099819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099865 */     // MIs[0] round
     /* 2099865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099868 */     // MIs[0] policy
     /* 2099868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099907 */     // GIR_Coverage, 16589,
     /* 2099907 */     GIR_EraseRootFromParent_Done,
     /* 2099908 */   // Label 27845: @2099908
     /* 2099908 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2100002), // Rule ID 16592 //
     /* 2099913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099959 */     // MIs[0] round
     /* 2099959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099962 */     // MIs[0] policy
     /* 2099962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099972 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100001 */     // GIR_Coverage, 16592,
     /* 2100001 */     GIR_EraseRootFromParent_Done,
     /* 2100002 */   // Label 27846: @2100002
     /* 2100002 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2100096), // Rule ID 16593 //
     /* 2100007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2100018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2100021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2100024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100053 */     // MIs[0] round
     /* 2100053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100056 */     // MIs[0] policy
     /* 2100056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100095 */     // GIR_Coverage, 16593,
     /* 2100095 */     GIR_EraseRootFromParent_Done,
     /* 2100096 */   // Label 27847: @2100096
     /* 2100096 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2100190), // Rule ID 16596 //
     /* 2100101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100147 */     // MIs[0] round
     /* 2100147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100150 */     // MIs[0] policy
     /* 2100150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100189 */     // GIR_Coverage, 16596,
     /* 2100189 */     GIR_EraseRootFromParent_Done,
     /* 2100190 */   // Label 27848: @2100190
     /* 2100190 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2100284), // Rule ID 16597 //
     /* 2100195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2100206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2100209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100241 */     // MIs[0] round
     /* 2100241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100244 */     // MIs[0] policy
     /* 2100244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100254 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100283 */     // GIR_Coverage, 16597,
     /* 2100283 */     GIR_EraseRootFromParent_Done,
     /* 2100284 */   // Label 27849: @2100284
     /* 2100284 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2100378), // Rule ID 16600 //
     /* 2100289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100335 */     // MIs[0] round
     /* 2100335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100338 */     // MIs[0] policy
     /* 2100338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100377 */     // GIR_Coverage, 16600,
     /* 2100377 */     GIR_EraseRootFromParent_Done,
     /* 2100378 */   // Label 27850: @2100378
     /* 2100378 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2100472), // Rule ID 16601 //
     /* 2100383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2100394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2100397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100429 */     // MIs[0] round
     /* 2100429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100432 */     // MIs[0] policy
     /* 2100432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100471 */     // GIR_Coverage, 16601,
     /* 2100471 */     GIR_EraseRootFromParent_Done,
     /* 2100472 */   // Label 27851: @2100472
     /* 2100472 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2100566), // Rule ID 16604 //
     /* 2100477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100523 */     // MIs[0] round
     /* 2100523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100526 */     // MIs[0] policy
     /* 2100526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100536 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100565 */     // GIR_Coverage, 16604,
     /* 2100565 */     GIR_EraseRootFromParent_Done,
     /* 2100566 */   // Label 27852: @2100566
     /* 2100566 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2100660), // Rule ID 16605 //
     /* 2100571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100617 */     // MIs[0] round
     /* 2100617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100620 */     // MIs[0] policy
     /* 2100620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100659 */     // GIR_Coverage, 16605,
     /* 2100659 */     GIR_EraseRootFromParent_Done,
     /* 2100660 */   // Label 27853: @2100660
     /* 2100660 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2100754), // Rule ID 16608 //
     /* 2100665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100711 */     // MIs[0] round
     /* 2100711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100714 */     // MIs[0] policy
     /* 2100714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100753 */     // GIR_Coverage, 16608,
     /* 2100753 */     GIR_EraseRootFromParent_Done,
     /* 2100754 */   // Label 27854: @2100754
     /* 2100754 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2100848), // Rule ID 16609 //
     /* 2100759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100805 */     // MIs[0] round
     /* 2100805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100808 */     // MIs[0] policy
     /* 2100808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100847 */     // GIR_Coverage, 16609,
     /* 2100847 */     GIR_EraseRootFromParent_Done,
     /* 2100848 */   // Label 27855: @2100848
     /* 2100848 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2100942), // Rule ID 16612 //
     /* 2100853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100899 */     // MIs[0] round
     /* 2100899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100902 */     // MIs[0] policy
     /* 2100902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100941 */     // GIR_Coverage, 16612,
     /* 2100941 */     GIR_EraseRootFromParent_Done,
     /* 2100942 */   // Label 27856: @2100942
     /* 2100942 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2101036), // Rule ID 16613 //
     /* 2100947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100993 */     // MIs[0] round
     /* 2100993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100996 */     // MIs[0] policy
     /* 2100996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101035 */     // GIR_Coverage, 16613,
     /* 2101035 */     GIR_EraseRootFromParent_Done,
     /* 2101036 */   // Label 27857: @2101036
     /* 2101036 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2101130), // Rule ID 16616 //
     /* 2101041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101087 */     // MIs[0] round
     /* 2101087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101090 */     // MIs[0] policy
     /* 2101090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101129 */     // GIR_Coverage, 16616,
     /* 2101129 */     GIR_EraseRootFromParent_Done,
     /* 2101130 */   // Label 27858: @2101130
     /* 2101130 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2101224), // Rule ID 16617 //
     /* 2101135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2101152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101181 */     // MIs[0] round
     /* 2101181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101184 */     // MIs[0] policy
     /* 2101184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101223 */     // GIR_Coverage, 16617,
     /* 2101223 */     GIR_EraseRootFromParent_Done,
     /* 2101224 */   // Label 27859: @2101224
     /* 2101224 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2101318), // Rule ID 16620 //
     /* 2101229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101275 */     // MIs[0] round
     /* 2101275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101278 */     // MIs[0] policy
     /* 2101278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101317 */     // GIR_Coverage, 16620,
     /* 2101317 */     GIR_EraseRootFromParent_Done,
     /* 2101318 */   // Label 27860: @2101318
     /* 2101318 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2101412), // Rule ID 16621 //
     /* 2101323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2101340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101369 */     // MIs[0] round
     /* 2101369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101372 */     // MIs[0] policy
     /* 2101372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101411 */     // GIR_Coverage, 16621,
     /* 2101411 */     GIR_EraseRootFromParent_Done,
     /* 2101412 */   // Label 27861: @2101412
     /* 2101412 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2101506), // Rule ID 16624 //
     /* 2101417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2101420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101463 */     // MIs[0] round
     /* 2101463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101466 */     // MIs[0] policy
     /* 2101466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101505 */     // GIR_Coverage, 16624,
     /* 2101505 */     GIR_EraseRootFromParent_Done,
     /* 2101506 */   // Label 27862: @2101506
     /* 2101506 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2101600), // Rule ID 16625 //
     /* 2101511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101557 */     // MIs[0] round
     /* 2101557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101560 */     // MIs[0] policy
     /* 2101560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101599 */     // GIR_Coverage, 16625,
     /* 2101599 */     GIR_EraseRootFromParent_Done,
     /* 2101600 */   // Label 27863: @2101600
     /* 2101600 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2101694), // Rule ID 16628 //
     /* 2101605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101651 */     // MIs[0] round
     /* 2101651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101654 */     // MIs[0] policy
     /* 2101654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101693 */     // GIR_Coverage, 16628,
     /* 2101693 */     GIR_EraseRootFromParent_Done,
     /* 2101694 */   // Label 27864: @2101694
     /* 2101694 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2101788), // Rule ID 16629 //
     /* 2101699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101745 */     // MIs[0] round
     /* 2101745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101748 */     // MIs[0] policy
     /* 2101748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101787 */     // GIR_Coverage, 16629,
     /* 2101787 */     GIR_EraseRootFromParent_Done,
     /* 2101788 */   // Label 27865: @2101788
     /* 2101788 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2101882), // Rule ID 16632 //
     /* 2101793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101839 */     // MIs[0] round
     /* 2101839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101842 */     // MIs[0] policy
     /* 2101842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101881 */     // GIR_Coverage, 16632,
     /* 2101881 */     GIR_EraseRootFromParent_Done,
     /* 2101882 */   // Label 27866: @2101882
     /* 2101882 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2101976), // Rule ID 16633 //
     /* 2101887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101933 */     // MIs[0] round
     /* 2101933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101936 */     // MIs[0] policy
     /* 2101936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101975 */     // GIR_Coverage, 16633,
     /* 2101975 */     GIR_EraseRootFromParent_Done,
     /* 2101976 */   // Label 27867: @2101976
     /* 2101976 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2102070), // Rule ID 16636 //
     /* 2101981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2101992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2101995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102027 */     // MIs[0] round
     /* 2102027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102030 */     // MIs[0] policy
     /* 2102030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2102043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102069 */     // GIR_Coverage, 16636,
     /* 2102069 */     GIR_EraseRootFromParent_Done,
     /* 2102070 */   // Label 27868: @2102070
     /* 2102070 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2102164), // Rule ID 16637 //
     /* 2102075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102121 */     // MIs[0] round
     /* 2102121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102124 */     // MIs[0] policy
     /* 2102124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2102137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102163 */     // GIR_Coverage, 16637,
     /* 2102163 */     GIR_EraseRootFromParent_Done,
     /* 2102164 */   // Label 27869: @2102164
     /* 2102164 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2102258), // Rule ID 16640 //
     /* 2102169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2102172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102215 */     // MIs[0] round
     /* 2102215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102218 */     // MIs[0] policy
     /* 2102218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2102231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102257 */     // GIR_Coverage, 16640,
     /* 2102257 */     GIR_EraseRootFromParent_Done,
     /* 2102258 */   // Label 27870: @2102258
     /* 2102258 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2102352), // Rule ID 16641 //
     /* 2102263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2102266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2102271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2102280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2102305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102309 */     // MIs[0] round
     /* 2102309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102312 */     // MIs[0] policy
     /* 2102312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2102325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2102350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102351 */     // GIR_Coverage, 16641,
     /* 2102351 */     GIR_EraseRootFromParent_Done,
     /* 2102352 */   // Label 27871: @2102352
     /* 2102352 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2102443), // Rule ID 16704 //
     /* 2102357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2102368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2102371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102403 */     // MIs[0] round
     /* 2102403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102406 */     // MIs[0] policy
     /* 2102406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102416 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102442 */     // GIR_Coverage, 16704,
     /* 2102442 */     GIR_EraseRootFromParent_Done,
     /* 2102443 */   // Label 27872: @2102443
     /* 2102443 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2102534), // Rule ID 16705 //
     /* 2102448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2102459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2102462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2102465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102494 */     // MIs[0] round
     /* 2102494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102497 */     // MIs[0] policy
     /* 2102497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102507 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102533 */     // GIR_Coverage, 16705,
     /* 2102533 */     GIR_EraseRootFromParent_Done,
     /* 2102534 */   // Label 27873: @2102534
     /* 2102534 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2102625), // Rule ID 16708 //
     /* 2102539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102585 */     // MIs[0] round
     /* 2102585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102588 */     // MIs[0] policy
     /* 2102588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102598 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102624 */     // GIR_Coverage, 16708,
     /* 2102624 */     GIR_EraseRootFromParent_Done,
     /* 2102625 */   // Label 27874: @2102625
     /* 2102625 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2102716), // Rule ID 16709 //
     /* 2102630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102676 */     // MIs[0] round
     /* 2102676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102679 */     // MIs[0] policy
     /* 2102679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102689 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102715 */     // GIR_Coverage, 16709,
     /* 2102715 */     GIR_EraseRootFromParent_Done,
     /* 2102716 */   // Label 27875: @2102716
     /* 2102716 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2102807), // Rule ID 16712 //
     /* 2102721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102767 */     // MIs[0] round
     /* 2102767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102770 */     // MIs[0] policy
     /* 2102770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102780 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102806 */     // GIR_Coverage, 16712,
     /* 2102806 */     GIR_EraseRootFromParent_Done,
     /* 2102807 */   // Label 27876: @2102807
     /* 2102807 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2102898), // Rule ID 16713 //
     /* 2102812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102858 */     // MIs[0] round
     /* 2102858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102861 */     // MIs[0] policy
     /* 2102861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102871 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102897 */     // GIR_Coverage, 16713,
     /* 2102897 */     GIR_EraseRootFromParent_Done,
     /* 2102898 */   // Label 27877: @2102898
     /* 2102898 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2102989), // Rule ID 16716 //
     /* 2102903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102949 */     // MIs[0] round
     /* 2102949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102952 */     // MIs[0] policy
     /* 2102952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102988 */     // GIR_Coverage, 16716,
     /* 2102988 */     GIR_EraseRootFromParent_Done,
     /* 2102989 */   // Label 27878: @2102989
     /* 2102989 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2103080), // Rule ID 16717 //
     /* 2102994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2103005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2103008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2103014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103040 */     // MIs[0] round
     /* 2103040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103043 */     // MIs[0] policy
     /* 2103043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103053 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2103056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103079 */     // GIR_Coverage, 16717,
     /* 2103079 */     GIR_EraseRootFromParent_Done,
     /* 2103080 */   // Label 27879: @2103080
     /* 2103080 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2103171), // Rule ID 16720 //
     /* 2103085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2103096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2103099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2103102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2103105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103131 */     // MIs[0] round
     /* 2103131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103134 */     // MIs[0] policy
     /* 2103134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2103147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103170 */     // GIR_Coverage, 16720,
     /* 2103170 */     GIR_EraseRootFromParent_Done,
     /* 2103171 */   // Label 27880: @2103171
     /* 2103171 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2103262), // Rule ID 16721 //
     /* 2103176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2103187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2103190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2103193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2103196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103222 */     // MIs[0] round
     /* 2103222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103225 */     // MIs[0] policy
     /* 2103225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103235 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2103238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103261 */     // GIR_Coverage, 16721,
     /* 2103261 */     GIR_EraseRootFromParent_Done,
     /* 2103262 */   // Label 27881: @2103262
     /* 2103262 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2103353), // Rule ID 16724 //
     /* 2103267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2103270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2103278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2103281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2103284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2103287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103313 */     // MIs[0] round
     /* 2103313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103316 */     // MIs[0] policy
     /* 2103316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103326 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2103329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103352 */     // GIR_Coverage, 16724,
     /* 2103352 */     GIR_EraseRootFromParent_Done,
     /* 2103353 */   // Label 27882: @2103353
     /* 2103353 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2103444), // Rule ID 16725 //
     /* 2103358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2103361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2103369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2103372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2103375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2103378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103404 */     // MIs[0] round
     /* 2103404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103407 */     // MIs[0] policy
     /* 2103407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103417 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2103420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103443 */     // GIR_Coverage, 16725,
     /* 2103443 */     GIR_EraseRootFromParent_Done,
     /* 2103444 */   // Label 27883: @2103444
     /* 2103444 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2103535), // Rule ID 16728 //
     /* 2103449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103495 */     // MIs[0] round
     /* 2103495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103498 */     // MIs[0] policy
     /* 2103498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103534 */     // GIR_Coverage, 16728,
     /* 2103534 */     GIR_EraseRootFromParent_Done,
     /* 2103535 */   // Label 27884: @2103535
     /* 2103535 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2103626), // Rule ID 16729 //
     /* 2103540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103586 */     // MIs[0] round
     /* 2103586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103589 */     // MIs[0] policy
     /* 2103589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103599 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103625 */     // GIR_Coverage, 16729,
     /* 2103625 */     GIR_EraseRootFromParent_Done,
     /* 2103626 */   // Label 27885: @2103626
     /* 2103626 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2103717), // Rule ID 16732 //
     /* 2103631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103677 */     // MIs[0] round
     /* 2103677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103680 */     // MIs[0] policy
     /* 2103680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103690 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103716 */     // GIR_Coverage, 16732,
     /* 2103716 */     GIR_EraseRootFromParent_Done,
     /* 2103717 */   // Label 27886: @2103717
     /* 2103717 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2103808), // Rule ID 16733 //
     /* 2103722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103768 */     // MIs[0] round
     /* 2103768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103771 */     // MIs[0] policy
     /* 2103771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103781 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103807 */     // GIR_Coverage, 16733,
     /* 2103807 */     GIR_EraseRootFromParent_Done,
     /* 2103808 */   // Label 27887: @2103808
     /* 2103808 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2103899), // Rule ID 16736 //
     /* 2103813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103859 */     // MIs[0] round
     /* 2103859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103862 */     // MIs[0] policy
     /* 2103862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103872 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103898 */     // GIR_Coverage, 16736,
     /* 2103898 */     GIR_EraseRootFromParent_Done,
     /* 2103899 */   // Label 27888: @2103899
     /* 2103899 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2103990), // Rule ID 16737 //
     /* 2103904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103950 */     // MIs[0] round
     /* 2103950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103953 */     // MIs[0] policy
     /* 2103953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103989 */     // GIR_Coverage, 16737,
     /* 2103989 */     GIR_EraseRootFromParent_Done,
     /* 2103990 */   // Label 27889: @2103990
     /* 2103990 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2104081), // Rule ID 16740 //
     /* 2103995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2104015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104041 */     // MIs[0] round
     /* 2104041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104044 */     // MIs[0] policy
     /* 2104044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2104057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104080 */     // GIR_Coverage, 16740,
     /* 2104080 */     GIR_EraseRootFromParent_Done,
     /* 2104081 */   // Label 27890: @2104081
     /* 2104081 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2104172), // Rule ID 16741 //
     /* 2104086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2104106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104132 */     // MIs[0] round
     /* 2104132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104135 */     // MIs[0] policy
     /* 2104135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104145 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2104148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104171 */     // GIR_Coverage, 16741,
     /* 2104171 */     GIR_EraseRootFromParent_Done,
     /* 2104172 */   // Label 27891: @2104172
     /* 2104172 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2104263), // Rule ID 16744 //
     /* 2104177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2104197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104223 */     // MIs[0] round
     /* 2104223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104226 */     // MIs[0] policy
     /* 2104226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2104239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104262 */     // GIR_Coverage, 16744,
     /* 2104262 */     GIR_EraseRootFromParent_Done,
     /* 2104263 */   // Label 27892: @2104263
     /* 2104263 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2104354), // Rule ID 16745 //
     /* 2104268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2104285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2104288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104314 */     // MIs[0] round
     /* 2104314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104317 */     // MIs[0] policy
     /* 2104317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104327 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2104330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104353 */     // GIR_Coverage, 16745,
     /* 2104353 */     GIR_EraseRootFromParent_Done,
     /* 2104354 */   // Label 27893: @2104354
     /* 2104354 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2104445), // Rule ID 16748 //
     /* 2104359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2104370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2104373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104405 */     // MIs[0] round
     /* 2104405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104408 */     // MIs[0] policy
     /* 2104408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104418 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104444 */     // GIR_Coverage, 16748,
     /* 2104444 */     GIR_EraseRootFromParent_Done,
     /* 2104445 */   // Label 27894: @2104445
     /* 2104445 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2104536), // Rule ID 16749 //
     /* 2104450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2104461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2104464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104496 */     // MIs[0] round
     /* 2104496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104499 */     // MIs[0] policy
     /* 2104499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104509 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104535 */     // GIR_Coverage, 16749,
     /* 2104535 */     GIR_EraseRootFromParent_Done,
     /* 2104536 */   // Label 27895: @2104536
     /* 2104536 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2104627), // Rule ID 16752 //
     /* 2104541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104587 */     // MIs[0] round
     /* 2104587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104590 */     // MIs[0] policy
     /* 2104590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104626 */     // GIR_Coverage, 16752,
     /* 2104626 */     GIR_EraseRootFromParent_Done,
     /* 2104627 */   // Label 27896: @2104627
     /* 2104627 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2104718), // Rule ID 16753 //
     /* 2104632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104678 */     // MIs[0] round
     /* 2104678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104681 */     // MIs[0] policy
     /* 2104681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104691 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104717 */     // GIR_Coverage, 16753,
     /* 2104717 */     GIR_EraseRootFromParent_Done,
     /* 2104718 */   // Label 27897: @2104718
     /* 2104718 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2104809), // Rule ID 16756 //
     /* 2104723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104769 */     // MIs[0] round
     /* 2104769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104772 */     // MIs[0] policy
     /* 2104772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104782 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104808 */     // GIR_Coverage, 16756,
     /* 2104808 */     GIR_EraseRootFromParent_Done,
     /* 2104809 */   // Label 27898: @2104809
     /* 2104809 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2104900), // Rule ID 16757 //
     /* 2104814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104860 */     // MIs[0] round
     /* 2104860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104863 */     // MIs[0] policy
     /* 2104863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104873 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104899 */     // GIR_Coverage, 16757,
     /* 2104899 */     GIR_EraseRootFromParent_Done,
     /* 2104900 */   // Label 27899: @2104900
     /* 2104900 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2104991), // Rule ID 16760 //
     /* 2104905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104951 */     // MIs[0] round
     /* 2104951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104954 */     // MIs[0] policy
     /* 2104954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104990 */     // GIR_Coverage, 16760,
     /* 2104990 */     GIR_EraseRootFromParent_Done,
     /* 2104991 */   // Label 27900: @2104991
     /* 2104991 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2105082), // Rule ID 16761 //
     /* 2104996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2105016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105042 */     // MIs[0] round
     /* 2105042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105045 */     // MIs[0] policy
     /* 2105045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105055 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2105058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105081 */     // GIR_Coverage, 16761,
     /* 2105081 */     GIR_EraseRootFromParent_Done,
     /* 2105082 */   // Label 27901: @2105082
     /* 2105082 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2105173), // Rule ID 16764 //
     /* 2105087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105133 */     // MIs[0] round
     /* 2105133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105136 */     // MIs[0] policy
     /* 2105136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105146 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2105149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105172 */     // GIR_Coverage, 16764,
     /* 2105172 */     GIR_EraseRootFromParent_Done,
     /* 2105173 */   // Label 27902: @2105173
     /* 2105173 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2105264), // Rule ID 16765 //
     /* 2105178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105224 */     // MIs[0] round
     /* 2105224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105227 */     // MIs[0] policy
     /* 2105227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105237 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2105240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105263 */     // GIR_Coverage, 16765,
     /* 2105263 */     GIR_EraseRootFromParent_Done,
     /* 2105264 */   // Label 27903: @2105264
     /* 2105264 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2105355), // Rule ID 16768 //
     /* 2105269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2105280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2105283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2105286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105315 */     // MIs[0] round
     /* 2105315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105318 */     // MIs[0] policy
     /* 2105318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105328 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2105331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105354 */     // GIR_Coverage, 16768,
     /* 2105354 */     GIR_EraseRootFromParent_Done,
     /* 2105355 */   // Label 27904: @2105355
     /* 2105355 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2105446), // Rule ID 16769 //
     /* 2105360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2105371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2105374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2105377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105406 */     // MIs[0] round
     /* 2105406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105409 */     // MIs[0] policy
     /* 2105409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105419 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2105422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105445 */     // GIR_Coverage, 16769,
     /* 2105445 */     GIR_EraseRootFromParent_Done,
     /* 2105446 */   // Label 27905: @2105446
     /* 2105446 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2105537), // Rule ID 16772 //
     /* 2105451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105497 */     // MIs[0] round
     /* 2105497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105500 */     // MIs[0] policy
     /* 2105500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105510 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105536 */     // GIR_Coverage, 16772,
     /* 2105536 */     GIR_EraseRootFromParent_Done,
     /* 2105537 */   // Label 27906: @2105537
     /* 2105537 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2105628), // Rule ID 16773 //
     /* 2105542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105588 */     // MIs[0] round
     /* 2105588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105591 */     // MIs[0] policy
     /* 2105591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105601 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105627 */     // GIR_Coverage, 16773,
     /* 2105627 */     GIR_EraseRootFromParent_Done,
     /* 2105628 */   // Label 27907: @2105628
     /* 2105628 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2105719), // Rule ID 16776 //
     /* 2105633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105679 */     // MIs[0] round
     /* 2105679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105682 */     // MIs[0] policy
     /* 2105682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105718 */     // GIR_Coverage, 16776,
     /* 2105718 */     GIR_EraseRootFromParent_Done,
     /* 2105719 */   // Label 27908: @2105719
     /* 2105719 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2105810), // Rule ID 16777 //
     /* 2105724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105770 */     // MIs[0] round
     /* 2105770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105773 */     // MIs[0] policy
     /* 2105773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105783 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105809 */     // GIR_Coverage, 16777,
     /* 2105809 */     GIR_EraseRootFromParent_Done,
     /* 2105810 */   // Label 27909: @2105810
     /* 2105810 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2105901), // Rule ID 16780 //
     /* 2105815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105861 */     // MIs[0] round
     /* 2105861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105864 */     // MIs[0] policy
     /* 2105864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105900 */     // GIR_Coverage, 16780,
     /* 2105900 */     GIR_EraseRootFromParent_Done,
     /* 2105901 */   // Label 27910: @2105901
     /* 2105901 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2105992), // Rule ID 16781 //
     /* 2105906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105952 */     // MIs[0] round
     /* 2105952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105955 */     // MIs[0] policy
     /* 2105955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105965 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105991 */     // GIR_Coverage, 16781,
     /* 2105991 */     GIR_EraseRootFromParent_Done,
     /* 2105992 */   // Label 27911: @2105992
     /* 2105992 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2106083), // Rule ID 16784 //
     /* 2105997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106043 */     // MIs[0] round
     /* 2106043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106046 */     // MIs[0] policy
     /* 2106046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2106059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106082 */     // GIR_Coverage, 16784,
     /* 2106082 */     GIR_EraseRootFromParent_Done,
     /* 2106083 */   // Label 27912: @2106083
     /* 2106083 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2106174), // Rule ID 16785 //
     /* 2106088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106134 */     // MIs[0] round
     /* 2106134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106137 */     // MIs[0] policy
     /* 2106137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106147 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2106150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106173 */     // GIR_Coverage, 16785,
     /* 2106173 */     GIR_EraseRootFromParent_Done,
     /* 2106174 */   // Label 27913: @2106174
     /* 2106174 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2106265), // Rule ID 16788 //
     /* 2106179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106225 */     // MIs[0] round
     /* 2106225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106228 */     // MIs[0] policy
     /* 2106228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106238 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2106241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106264 */     // GIR_Coverage, 16788,
     /* 2106264 */     GIR_EraseRootFromParent_Done,
     /* 2106265 */   // Label 27914: @2106265
     /* 2106265 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2106356), // Rule ID 16789 //
     /* 2106270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2106281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2106284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106316 */     // MIs[0] round
     /* 2106316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106319 */     // MIs[0] policy
     /* 2106319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106329 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2106332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106355 */     // GIR_Coverage, 16789,
     /* 2106355 */     GIR_EraseRootFromParent_Done,
     /* 2106356 */   // Label 27915: @2106356
     /* 2106356 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2106447), // Rule ID 16792 //
     /* 2106361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2106372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106407 */     // MIs[0] round
     /* 2106407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106410 */     // MIs[0] policy
     /* 2106410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106420 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106446 */     // GIR_Coverage, 16792,
     /* 2106446 */     GIR_EraseRootFromParent_Done,
     /* 2106447 */   // Label 27916: @2106447
     /* 2106447 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2106538), // Rule ID 16793 //
     /* 2106452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2106463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106498 */     // MIs[0] round
     /* 2106498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106501 */     // MIs[0] policy
     /* 2106501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106511 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106537 */     // GIR_Coverage, 16793,
     /* 2106537 */     GIR_EraseRootFromParent_Done,
     /* 2106538 */   // Label 27917: @2106538
     /* 2106538 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2106629), // Rule ID 16796 //
     /* 2106543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106589 */     // MIs[0] round
     /* 2106589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106592 */     // MIs[0] policy
     /* 2106592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106628 */     // GIR_Coverage, 16796,
     /* 2106628 */     GIR_EraseRootFromParent_Done,
     /* 2106629 */   // Label 27918: @2106629
     /* 2106629 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2106720), // Rule ID 16797 //
     /* 2106634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106680 */     // MIs[0] round
     /* 2106680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106683 */     // MIs[0] policy
     /* 2106683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106693 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106719 */     // GIR_Coverage, 16797,
     /* 2106719 */     GIR_EraseRootFromParent_Done,
     /* 2106720 */   // Label 27919: @2106720
     /* 2106720 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2106811), // Rule ID 16800 //
     /* 2106725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106771 */     // MIs[0] round
     /* 2106771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106774 */     // MIs[0] policy
     /* 2106774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106810 */     // GIR_Coverage, 16800,
     /* 2106810 */     GIR_EraseRootFromParent_Done,
     /* 2106811 */   // Label 27920: @2106811
     /* 2106811 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2106902), // Rule ID 16801 //
     /* 2106816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106862 */     // MIs[0] round
     /* 2106862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106865 */     // MIs[0] policy
     /* 2106865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106875 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106901 */     // GIR_Coverage, 16801,
     /* 2106901 */     GIR_EraseRootFromParent_Done,
     /* 2106902 */   // Label 27921: @2106902
     /* 2106902 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2106993), // Rule ID 16804 //
     /* 2106907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106953 */     // MIs[0] round
     /* 2106953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106956 */     // MIs[0] policy
     /* 2106956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106966 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106992 */     // GIR_Coverage, 16804,
     /* 2106992 */     GIR_EraseRootFromParent_Done,
     /* 2106993 */   // Label 27922: @2106993
     /* 2106993 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2107084), // Rule ID 16805 //
     /* 2106998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107044 */     // MIs[0] round
     /* 2107044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107047 */     // MIs[0] policy
     /* 2107047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107057 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2107060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107083 */     // GIR_Coverage, 16805,
     /* 2107083 */     GIR_EraseRootFromParent_Done,
     /* 2107084 */   // Label 27923: @2107084
     /* 2107084 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2107175), // Rule ID 16808 //
     /* 2107089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107135 */     // MIs[0] round
     /* 2107135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107138 */     // MIs[0] policy
     /* 2107138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107148 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2107151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107174 */     // GIR_Coverage, 16808,
     /* 2107174 */     GIR_EraseRootFromParent_Done,
     /* 2107175 */   // Label 27924: @2107175
     /* 2107175 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2107266), // Rule ID 16809 //
     /* 2107180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107226 */     // MIs[0] round
     /* 2107226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107229 */     // MIs[0] policy
     /* 2107229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107239 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2107242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107265 */     // GIR_Coverage, 16809,
     /* 2107265 */     GIR_EraseRootFromParent_Done,
     /* 2107266 */   // Label 27925: @2107266
     /* 2107266 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2107357), // Rule ID 16812 //
     /* 2107271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2107288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107317 */     // MIs[0] round
     /* 2107317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107320 */     // MIs[0] policy
     /* 2107320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2107333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107356 */     // GIR_Coverage, 16812,
     /* 2107356 */     GIR_EraseRootFromParent_Done,
     /* 2107357 */   // Label 27926: @2107357
     /* 2107357 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2107448), // Rule ID 16813 //
     /* 2107362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2107379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107408 */     // MIs[0] round
     /* 2107408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107411 */     // MIs[0] policy
     /* 2107411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107421 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2107424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107447 */     // GIR_Coverage, 16813,
     /* 2107447 */     GIR_EraseRootFromParent_Done,
     /* 2107448 */   // Label 27927: @2107448
     /* 2107448 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2107539), // Rule ID 16816 //
     /* 2107453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107499 */     // MIs[0] round
     /* 2107499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107502 */     // MIs[0] policy
     /* 2107502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107512 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107538 */     // GIR_Coverage, 16816,
     /* 2107538 */     GIR_EraseRootFromParent_Done,
     /* 2107539 */   // Label 27928: @2107539
     /* 2107539 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2107630), // Rule ID 16817 //
     /* 2107544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107590 */     // MIs[0] round
     /* 2107590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107593 */     // MIs[0] policy
     /* 2107593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107603 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107629 */     // GIR_Coverage, 16817,
     /* 2107629 */     GIR_EraseRootFromParent_Done,
     /* 2107630 */   // Label 27929: @2107630
     /* 2107630 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2107721), // Rule ID 16820 //
     /* 2107635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107681 */     // MIs[0] round
     /* 2107681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107684 */     // MIs[0] policy
     /* 2107684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107720 */     // GIR_Coverage, 16820,
     /* 2107720 */     GIR_EraseRootFromParent_Done,
     /* 2107721 */   // Label 27930: @2107721
     /* 2107721 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2107812), // Rule ID 16821 //
     /* 2107726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107772 */     // MIs[0] round
     /* 2107772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107775 */     // MIs[0] policy
     /* 2107775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107785 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107811 */     // GIR_Coverage, 16821,
     /* 2107811 */     GIR_EraseRootFromParent_Done,
     /* 2107812 */   // Label 27931: @2107812
     /* 2107812 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2107903), // Rule ID 16824 //
     /* 2107817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107863 */     // MIs[0] round
     /* 2107863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107866 */     // MIs[0] policy
     /* 2107866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107876 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107902 */     // GIR_Coverage, 16824,
     /* 2107902 */     GIR_EraseRootFromParent_Done,
     /* 2107903 */   // Label 27932: @2107903
     /* 2107903 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2107994), // Rule ID 16825 //
     /* 2107908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107954 */     // MIs[0] round
     /* 2107954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107957 */     // MIs[0] policy
     /* 2107957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107967 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107993 */     // GIR_Coverage, 16825,
     /* 2107993 */     GIR_EraseRootFromParent_Done,
     /* 2107994 */   // Label 27933: @2107994
     /* 2107994 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2108085), // Rule ID 16828 //
     /* 2107999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108045 */     // MIs[0] round
     /* 2108045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108048 */     // MIs[0] policy
     /* 2108048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108058 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2108061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108084 */     // GIR_Coverage, 16828,
     /* 2108084 */     GIR_EraseRootFromParent_Done,
     /* 2108085 */   // Label 27934: @2108085
     /* 2108085 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2108176), // Rule ID 16829 //
     /* 2108090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2108101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2108104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108136 */     // MIs[0] round
     /* 2108136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108139 */     // MIs[0] policy
     /* 2108139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108149 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2108152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108175 */     // GIR_Coverage, 16829,
     /* 2108175 */     GIR_EraseRootFromParent_Done,
     /* 2108176 */   // Label 27935: @2108176
     /* 2108176 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2108267), // Rule ID 16832 //
     /* 2108181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108227 */     // MIs[0] round
     /* 2108227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108230 */     // MIs[0] policy
     /* 2108230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2108243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108266 */     // GIR_Coverage, 16832,
     /* 2108266 */     GIR_EraseRootFromParent_Done,
     /* 2108267 */   // Label 27936: @2108267
     /* 2108267 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2108358), // Rule ID 16833 //
     /* 2108272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108318 */     // MIs[0] round
     /* 2108318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108321 */     // MIs[0] policy
     /* 2108321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108331 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2108334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108357 */     // GIR_Coverage, 16833,
     /* 2108357 */     GIR_EraseRootFromParent_Done,
     /* 2108358 */   // Label 27937: @2108358
     /* 2108358 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2108449), // Rule ID 16836 //
     /* 2108363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2108374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108409 */     // MIs[0] round
     /* 2108409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108412 */     // MIs[0] policy
     /* 2108412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108422 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108448 */     // GIR_Coverage, 16836,
     /* 2108448 */     GIR_EraseRootFromParent_Done,
     /* 2108449 */   // Label 27938: @2108449
     /* 2108449 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2108540), // Rule ID 16837 //
     /* 2108454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2108465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108500 */     // MIs[0] round
     /* 2108500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108503 */     // MIs[0] policy
     /* 2108503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108513 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108539 */     // GIR_Coverage, 16837,
     /* 2108539 */     GIR_EraseRootFromParent_Done,
     /* 2108540 */   // Label 27939: @2108540
     /* 2108540 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2108631), // Rule ID 16840 //
     /* 2108545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108591 */     // MIs[0] round
     /* 2108591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108594 */     // MIs[0] policy
     /* 2108594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108630 */     // GIR_Coverage, 16840,
     /* 2108630 */     GIR_EraseRootFromParent_Done,
     /* 2108631 */   // Label 27940: @2108631
     /* 2108631 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2108722), // Rule ID 16841 //
     /* 2108636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108682 */     // MIs[0] round
     /* 2108682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108685 */     // MIs[0] policy
     /* 2108685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108695 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108721 */     // GIR_Coverage, 16841,
     /* 2108721 */     GIR_EraseRootFromParent_Done,
     /* 2108722 */   // Label 27941: @2108722
     /* 2108722 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2108813), // Rule ID 16844 //
     /* 2108727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108773 */     // MIs[0] round
     /* 2108773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108776 */     // MIs[0] policy
     /* 2108776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108812 */     // GIR_Coverage, 16844,
     /* 2108812 */     GIR_EraseRootFromParent_Done,
     /* 2108813 */   // Label 27942: @2108813
     /* 2108813 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2108904), // Rule ID 16845 //
     /* 2108818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108864 */     // MIs[0] round
     /* 2108864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108867 */     // MIs[0] policy
     /* 2108867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108903 */     // GIR_Coverage, 16845,
     /* 2108903 */     GIR_EraseRootFromParent_Done,
     /* 2108904 */   // Label 27943: @2108904
     /* 2108904 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2108995), // Rule ID 16848 //
     /* 2108909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108955 */     // MIs[0] round
     /* 2108955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108958 */     // MIs[0] policy
     /* 2108958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108994 */     // GIR_Coverage, 16848,
     /* 2108994 */     GIR_EraseRootFromParent_Done,
     /* 2108995 */   // Label 27944: @2108995
     /* 2108995 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2109086), // Rule ID 16849 //
     /* 2109000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2109011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2109014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2109020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109046 */     // MIs[0] round
     /* 2109046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109049 */     // MIs[0] policy
     /* 2109049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2109062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109085 */     // GIR_Coverage, 16849,
     /* 2109085 */     GIR_EraseRootFromParent_Done,
     /* 2109086 */   // Label 27945: @2109086
     /* 2109086 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2109177), // Rule ID 16852 //
     /* 2109091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109137 */     // MIs[0] round
     /* 2109137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109140 */     // MIs[0] policy
     /* 2109140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109150 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2109153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109176 */     // GIR_Coverage, 16852,
     /* 2109176 */     GIR_EraseRootFromParent_Done,
     /* 2109177 */   // Label 27946: @2109177
     /* 2109177 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2109268), // Rule ID 16853 //
     /* 2109182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2109193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2109196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109228 */     // MIs[0] round
     /* 2109228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109231 */     // MIs[0] policy
     /* 2109231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109241 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2109244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109267 */     // GIR_Coverage, 16853,
     /* 2109267 */     GIR_EraseRootFromParent_Done,
     /* 2109268 */   // Label 27947: @2109268
     /* 2109268 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2109359), // Rule ID 16856 //
     /* 2109273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2109276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2109284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2109287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2109290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2109293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2109296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109319 */     // MIs[0] round
     /* 2109319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109322 */     // MIs[0] policy
     /* 2109322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109332 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2109335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109358 */     // GIR_Coverage, 16856,
     /* 2109358 */     GIR_EraseRootFromParent_Done,
     /* 2109359 */   // Label 27948: @2109359
     /* 2109359 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2109450), // Rule ID 16857 //
     /* 2109364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2109367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2109375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2109378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2109381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2109384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2109387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109410 */     // MIs[0] round
     /* 2109410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109413 */     // MIs[0] policy
     /* 2109413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109423 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2109426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109449 */     // GIR_Coverage, 16857,
     /* 2109449 */     GIR_EraseRootFromParent_Done,
     /* 2109450 */   // Label 27949: @2109450
     /* 2109450 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2109541), // Rule ID 16860 //
     /* 2109455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109501 */     // MIs[0] round
     /* 2109501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109504 */     // MIs[0] policy
     /* 2109504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109514 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109540 */     // GIR_Coverage, 16860,
     /* 2109540 */     GIR_EraseRootFromParent_Done,
     /* 2109541 */   // Label 27950: @2109541
     /* 2109541 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2109632), // Rule ID 16861 //
     /* 2109546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109592 */     // MIs[0] round
     /* 2109592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109595 */     // MIs[0] policy
     /* 2109595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109631 */     // GIR_Coverage, 16861,
     /* 2109631 */     GIR_EraseRootFromParent_Done,
     /* 2109632 */   // Label 27951: @2109632
     /* 2109632 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2109723), // Rule ID 16864 //
     /* 2109637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109683 */     // MIs[0] round
     /* 2109683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109686 */     // MIs[0] policy
     /* 2109686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109722 */     // GIR_Coverage, 16864,
     /* 2109722 */     GIR_EraseRootFromParent_Done,
     /* 2109723 */   // Label 27952: @2109723
     /* 2109723 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2109814), // Rule ID 16865 //
     /* 2109728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109774 */     // MIs[0] round
     /* 2109774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109777 */     // MIs[0] policy
     /* 2109777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109787 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109813 */     // GIR_Coverage, 16865,
     /* 2109813 */     GIR_EraseRootFromParent_Done,
     /* 2109814 */   // Label 27953: @2109814
     /* 2109814 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2109905), // Rule ID 16868 //
     /* 2109819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109865 */     // MIs[0] round
     /* 2109865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109868 */     // MIs[0] policy
     /* 2109868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109878 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109904 */     // GIR_Coverage, 16868,
     /* 2109904 */     GIR_EraseRootFromParent_Done,
     /* 2109905 */   // Label 27954: @2109905
     /* 2109905 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2109996), // Rule ID 16869 //
     /* 2109910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109956 */     // MIs[0] round
     /* 2109956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109959 */     // MIs[0] policy
     /* 2109959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109969 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109995 */     // GIR_Coverage, 16869,
     /* 2109995 */     GIR_EraseRootFromParent_Done,
     /* 2109996 */   // Label 27955: @2109996
     /* 2109996 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2110087), // Rule ID 16872 //
     /* 2110001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2110021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110047 */     // MIs[0] round
     /* 2110047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110050 */     // MIs[0] policy
     /* 2110050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2110063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110086 */     // GIR_Coverage, 16872,
     /* 2110086 */     GIR_EraseRootFromParent_Done,
     /* 2110087 */   // Label 27956: @2110087
     /* 2110087 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2110178), // Rule ID 16873 //
     /* 2110092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2110109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2110112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110138 */     // MIs[0] round
     /* 2110138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110141 */     // MIs[0] policy
     /* 2110141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110151 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2110154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110177 */     // GIR_Coverage, 16873,
     /* 2110177 */     GIR_EraseRootFromParent_Done,
     /* 2110178 */   // Label 27957: @2110178
     /* 2110178 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2110269), // Rule ID 16876 //
     /* 2110183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2110203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110229 */     // MIs[0] round
     /* 2110229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110232 */     // MIs[0] policy
     /* 2110232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110242 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2110245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110268 */     // GIR_Coverage, 16876,
     /* 2110268 */     GIR_EraseRootFromParent_Done,
     /* 2110269 */   // Label 27958: @2110269
     /* 2110269 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2110360), // Rule ID 16877 //
     /* 2110274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2110291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2110294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110320 */     // MIs[0] round
     /* 2110320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110323 */     // MIs[0] policy
     /* 2110323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2110336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110359 */     // GIR_Coverage, 16877,
     /* 2110359 */     GIR_EraseRootFromParent_Done,
     /* 2110360 */   // Label 27959: @2110360
     /* 2110360 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2110451), // Rule ID 16880 //
     /* 2110365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110411 */     // MIs[0] round
     /* 2110411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110414 */     // MIs[0] policy
     /* 2110414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110450 */     // GIR_Coverage, 16880,
     /* 2110450 */     GIR_EraseRootFromParent_Done,
     /* 2110451 */   // Label 27960: @2110451
     /* 2110451 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2110542), // Rule ID 16881 //
     /* 2110456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2110459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110502 */     // MIs[0] round
     /* 2110502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110505 */     // MIs[0] policy
     /* 2110505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110541 */     // GIR_Coverage, 16881,
     /* 2110541 */     GIR_EraseRootFromParent_Done,
     /* 2110542 */   // Label 27961: @2110542
     /* 2110542 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2110633), // Rule ID 16884 //
     /* 2110547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110593 */     // MIs[0] round
     /* 2110593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110596 */     // MIs[0] policy
     /* 2110596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110632 */     // GIR_Coverage, 16884,
     /* 2110632 */     GIR_EraseRootFromParent_Done,
     /* 2110633 */   // Label 27962: @2110633
     /* 2110633 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2110724), // Rule ID 16885 //
     /* 2110638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110684 */     // MIs[0] round
     /* 2110684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110687 */     // MIs[0] policy
     /* 2110687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110697 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110723 */     // GIR_Coverage, 16885,
     /* 2110723 */     GIR_EraseRootFromParent_Done,
     /* 2110724 */   // Label 27963: @2110724
     /* 2110724 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2110815), // Rule ID 16888 //
     /* 2110729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110775 */     // MIs[0] round
     /* 2110775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110778 */     // MIs[0] policy
     /* 2110778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110788 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110814 */     // GIR_Coverage, 16888,
     /* 2110814 */     GIR_EraseRootFromParent_Done,
     /* 2110815 */   // Label 27964: @2110815
     /* 2110815 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2110906), // Rule ID 16889 //
     /* 2110820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110866 */     // MIs[0] round
     /* 2110866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110869 */     // MIs[0] policy
     /* 2110869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110905 */     // GIR_Coverage, 16889,
     /* 2110905 */     GIR_EraseRootFromParent_Done,
     /* 2110906 */   // Label 27965: @2110906
     /* 2110906 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2110997), // Rule ID 16892 //
     /* 2110911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110957 */     // MIs[0] round
     /* 2110957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110960 */     // MIs[0] policy
     /* 2110960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110996 */     // GIR_Coverage, 16892,
     /* 2110996 */     GIR_EraseRootFromParent_Done,
     /* 2110997 */   // Label 27966: @2110997
     /* 2110997 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2111088), // Rule ID 16893 //
     /* 2111002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2111013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111048 */     // MIs[0] round
     /* 2111048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111051 */     // MIs[0] policy
     /* 2111051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111061 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2111064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111087 */     // GIR_Coverage, 16893,
     /* 2111087 */     GIR_EraseRootFromParent_Done,
     /* 2111088 */   // Label 27967: @2111088
     /* 2111088 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2111179), // Rule ID 16896 //
     /* 2111093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111139 */     // MIs[0] round
     /* 2111139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111142 */     // MIs[0] policy
     /* 2111142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111152 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2111155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111178 */     // GIR_Coverage, 16896,
     /* 2111178 */     GIR_EraseRootFromParent_Done,
     /* 2111179 */   // Label 27968: @2111179
     /* 2111179 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2111270), // Rule ID 16897 //
     /* 2111184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2111195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2111198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2111201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111230 */     // MIs[0] round
     /* 2111230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111233 */     // MIs[0] policy
     /* 2111233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111243 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11334:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2111246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111269 */     // GIR_Coverage, 16897,
     /* 2111269 */     GIR_EraseRootFromParent_Done,
     /* 2111270 */   // Label 27969: @2111270
     /* 2111270 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2111361), // Rule ID 16900 //
     /* 2111275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2111286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2111289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111321 */     // MIs[0] round
     /* 2111321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111324 */     // MIs[0] policy
     /* 2111324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2111337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111360 */     // GIR_Coverage, 16900,
     /* 2111360 */     GIR_EraseRootFromParent_Done,
     /* 2111361 */   // Label 27970: @2111361
     /* 2111361 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2111452), // Rule ID 16901 //
     /* 2111366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2111377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2111380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111412 */     // MIs[0] round
     /* 2111412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111415 */     // MIs[0] policy
     /* 2111415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111425 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11334:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2111428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111451 */     // GIR_Coverage, 16901,
     /* 2111451 */     GIR_EraseRootFromParent_Done,
     /* 2111452 */   // Label 27971: @2111452
     /* 2111452 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2111543), // Rule ID 16904 //
     /* 2111457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2111460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111503 */     // MIs[0] round
     /* 2111503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111506 */     // MIs[0] policy
     /* 2111506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111542 */     // GIR_Coverage, 16904,
     /* 2111542 */     GIR_EraseRootFromParent_Done,
     /* 2111543 */   // Label 27972: @2111543
     /* 2111543 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2111634), // Rule ID 16905 //
     /* 2111548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2111551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111594 */     // MIs[0] round
     /* 2111594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111597 */     // MIs[0] policy
     /* 2111597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11334:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111633 */     // GIR_Coverage, 16905,
     /* 2111633 */     GIR_EraseRootFromParent_Done,
     /* 2111634 */   // Label 27973: @2111634
     /* 2111634 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2111725), // Rule ID 16908 //
     /* 2111639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111685 */     // MIs[0] round
     /* 2111685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111688 */     // MIs[0] policy
     /* 2111688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111698 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111724 */     // GIR_Coverage, 16908,
     /* 2111724 */     GIR_EraseRootFromParent_Done,
     /* 2111725 */   // Label 27974: @2111725
     /* 2111725 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2111816), // Rule ID 16909 //
     /* 2111730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111776 */     // MIs[0] round
     /* 2111776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111779 */     // MIs[0] policy
     /* 2111779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111789 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111815 */     // GIR_Coverage, 16909,
     /* 2111815 */     GIR_EraseRootFromParent_Done,
     /* 2111816 */   // Label 27975: @2111816
     /* 2111816 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2111907), // Rule ID 16912 //
     /* 2111821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111867 */     // MIs[0] round
     /* 2111867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111870 */     // MIs[0] policy
     /* 2111870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111880 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111906 */     // GIR_Coverage, 16912,
     /* 2111906 */     GIR_EraseRootFromParent_Done,
     /* 2111907 */   // Label 27976: @2111907
     /* 2111907 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2111998), // Rule ID 16913 //
     /* 2111912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111958 */     // MIs[0] round
     /* 2111958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111961 */     // MIs[0] policy
     /* 2111961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111971 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111997 */     // GIR_Coverage, 16913,
     /* 2111997 */     GIR_EraseRootFromParent_Done,
     /* 2111998 */   // Label 27977: @2111998
     /* 2111998 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2112089), // Rule ID 16916 //
     /* 2112003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112049 */     // MIs[0] round
     /* 2112049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112052 */     // MIs[0] policy
     /* 2112052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2112065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112088 */     // GIR_Coverage, 16916,
     /* 2112088 */     GIR_EraseRootFromParent_Done,
     /* 2112089 */   // Label 27978: @2112089
     /* 2112089 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2112180), // Rule ID 16917 //
     /* 2112094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2112105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2112108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2112111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2112117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112140 */     // MIs[0] round
     /* 2112140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112143 */     // MIs[0] policy
     /* 2112143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112153 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2112156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112179 */     // GIR_Coverage, 16917,
     /* 2112179 */     GIR_EraseRootFromParent_Done,
     /* 2112180 */   // Label 27979: @2112180
     /* 2112180 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2112271), // Rule ID 16920 //
     /* 2112185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112231 */     // MIs[0] round
     /* 2112231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112234 */     // MIs[0] policy
     /* 2112234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2112247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112270 */     // GIR_Coverage, 16920,
     /* 2112270 */     GIR_EraseRootFromParent_Done,
     /* 2112271 */   // Label 27980: @2112271
     /* 2112271 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2112362), // Rule ID 16921 //
     /* 2112276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112322 */     // MIs[0] round
     /* 2112322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112325 */     // MIs[0] policy
     /* 2112325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112335 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2112338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112361 */     // GIR_Coverage, 16921,
     /* 2112361 */     GIR_EraseRootFromParent_Done,
     /* 2112362 */   // Label 27981: @2112362
     /* 2112362 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2112453), // Rule ID 16924 //
     /* 2112367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112413 */     // MIs[0] round
     /* 2112413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112416 */     // MIs[0] policy
     /* 2112416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112426 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112452 */     // GIR_Coverage, 16924,
     /* 2112452 */     GIR_EraseRootFromParent_Done,
     /* 2112453 */   // Label 27982: @2112453
     /* 2112453 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2112544), // Rule ID 16925 //
     /* 2112458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112504 */     // MIs[0] round
     /* 2112504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112507 */     // MIs[0] policy
     /* 2112507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112517 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112543 */     // GIR_Coverage, 16925,
     /* 2112543 */     GIR_EraseRootFromParent_Done,
     /* 2112544 */   // Label 27983: @2112544
     /* 2112544 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2112635), // Rule ID 16928 //
     /* 2112549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112595 */     // MIs[0] round
     /* 2112595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112598 */     // MIs[0] policy
     /* 2112598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112608 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112634 */     // GIR_Coverage, 16928,
     /* 2112634 */     GIR_EraseRootFromParent_Done,
     /* 2112635 */   // Label 27984: @2112635
     /* 2112635 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2112726), // Rule ID 16929 //
     /* 2112640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112686 */     // MIs[0] round
     /* 2112686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112689 */     // MIs[0] policy
     /* 2112689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112699 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112725 */     // GIR_Coverage, 16929,
     /* 2112725 */     GIR_EraseRootFromParent_Done,
     /* 2112726 */   // Label 27985: @2112726
     /* 2112726 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2112817), // Rule ID 16932 //
     /* 2112731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112777 */     // MIs[0] round
     /* 2112777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112780 */     // MIs[0] policy
     /* 2112780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112816 */     // GIR_Coverage, 16932,
     /* 2112816 */     GIR_EraseRootFromParent_Done,
     /* 2112817 */   // Label 27986: @2112817
     /* 2112817 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2112908), // Rule ID 16933 //
     /* 2112822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112868 */     // MIs[0] round
     /* 2112868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112871 */     // MIs[0] policy
     /* 2112871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112881 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11334:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112907 */     // GIR_Coverage, 16933,
     /* 2112907 */     GIR_EraseRootFromParent_Done,
     /* 2112908 */   // Label 27987: @2112908
     /* 2112908 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2112999), // Rule ID 16936 //
     /* 2112913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112959 */     // MIs[0] round
     /* 2112959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112962 */     // MIs[0] policy
     /* 2112962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112972 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112998 */     // GIR_Coverage, 16936,
     /* 2112998 */     GIR_EraseRootFromParent_Done,
     /* 2112999 */   // Label 27988: @2112999
     /* 2112999 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2113090), // Rule ID 16937 //
     /* 2113004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113050 */     // MIs[0] round
     /* 2113050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113053 */     // MIs[0] policy
     /* 2113053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113063 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11334:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2113066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113089 */     // GIR_Coverage, 16937,
     /* 2113089 */     GIR_EraseRootFromParent_Done,
     /* 2113090 */   // Label 27989: @2113090
     /* 2113090 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2113181), // Rule ID 16940 //
     /* 2113095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113141 */     // MIs[0] round
     /* 2113141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113144 */     // MIs[0] policy
     /* 2113144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113154 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2113157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113180 */     // GIR_Coverage, 16940,
     /* 2113180 */     GIR_EraseRootFromParent_Done,
     /* 2113181 */   // Label 27990: @2113181
     /* 2113181 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2113272), // Rule ID 16941 //
     /* 2113186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2113194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113232 */     // MIs[0] round
     /* 2113232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113235 */     // MIs[0] policy
     /* 2113235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11334:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2113248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113271 */     // GIR_Coverage, 16941,
     /* 2113271 */     GIR_EraseRootFromParent_Done,
     /* 2113272 */   // Label 27991: @2113272
     /* 2113272 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2113363), // Rule ID 16944 //
     /* 2113277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2113288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2113291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113323 */     // MIs[0] round
     /* 2113323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113326 */     // MIs[0] policy
     /* 2113326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2113339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113362 */     // GIR_Coverage, 16944,
     /* 2113362 */     GIR_EraseRootFromParent_Done,
     /* 2113363 */   // Label 27992: @2113363
     /* 2113363 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2113454), // Rule ID 16945 //
     /* 2113368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2113379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2113382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113414 */     // MIs[0] round
     /* 2113414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113417 */     // MIs[0] policy
     /* 2113417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113427 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2113430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113453 */     // GIR_Coverage, 16945,
     /* 2113453 */     GIR_EraseRootFromParent_Done,
     /* 2113454 */   // Label 27993: @2113454
     /* 2113454 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2113545), // Rule ID 16948 //
     /* 2113459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113505 */     // MIs[0] round
     /* 2113505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113508 */     // MIs[0] policy
     /* 2113508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113544 */     // GIR_Coverage, 16948,
     /* 2113544 */     GIR_EraseRootFromParent_Done,
     /* 2113545 */   // Label 27994: @2113545
     /* 2113545 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2113636), // Rule ID 16949 //
     /* 2113550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113596 */     // MIs[0] round
     /* 2113596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113599 */     // MIs[0] policy
     /* 2113599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113609 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113635 */     // GIR_Coverage, 16949,
     /* 2113635 */     GIR_EraseRootFromParent_Done,
     /* 2113636 */   // Label 27995: @2113636
     /* 2113636 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2113727), // Rule ID 16952 //
     /* 2113641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113687 */     // MIs[0] round
     /* 2113687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113690 */     // MIs[0] policy
     /* 2113690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113700 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113726 */     // GIR_Coverage, 16952,
     /* 2113726 */     GIR_EraseRootFromParent_Done,
     /* 2113727 */   // Label 27996: @2113727
     /* 2113727 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2113818), // Rule ID 16953 //
     /* 2113732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113778 */     // MIs[0] round
     /* 2113778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113781 */     // MIs[0] policy
     /* 2113781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113791 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113817 */     // GIR_Coverage, 16953,
     /* 2113817 */     GIR_EraseRootFromParent_Done,
     /* 2113818 */   // Label 27997: @2113818
     /* 2113818 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2113909), // Rule ID 16956 //
     /* 2113823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113869 */     // MIs[0] round
     /* 2113869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113872 */     // MIs[0] policy
     /* 2113872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113882 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113908 */     // GIR_Coverage, 16956,
     /* 2113908 */     GIR_EraseRootFromParent_Done,
     /* 2113909 */   // Label 27998: @2113909
     /* 2113909 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2114000), // Rule ID 16957 //
     /* 2113914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113960 */     // MIs[0] round
     /* 2113960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113963 */     // MIs[0] policy
     /* 2113963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113973 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11320:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113999 */     // GIR_Coverage, 16957,
     /* 2113999 */     GIR_EraseRootFromParent_Done,
     /* 2114000 */   // Label 27999: @2114000
     /* 2114000 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2114091), // Rule ID 16960 //
     /* 2114005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114051 */     // MIs[0] round
     /* 2114051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114054 */     // MIs[0] policy
     /* 2114054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2114067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114090 */     // GIR_Coverage, 16960,
     /* 2114090 */     GIR_EraseRootFromParent_Done,
     /* 2114091 */   // Label 28000: @2114091
     /* 2114091 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2114182), // Rule ID 16961 //
     /* 2114096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114142 */     // MIs[0] round
     /* 2114142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114145 */     // MIs[0] policy
     /* 2114145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114155 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2114158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114181 */     // GIR_Coverage, 16961,
     /* 2114181 */     GIR_EraseRootFromParent_Done,
     /* 2114182 */   // Label 28001: @2114182
     /* 2114182 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2114273), // Rule ID 16964 //
     /* 2114187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2114190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114233 */     // MIs[0] round
     /* 2114233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114236 */     // MIs[0] policy
     /* 2114236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114246 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2114249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2114269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114272 */     // GIR_Coverage, 16964,
     /* 2114272 */     GIR_EraseRootFromParent_Done,
     /* 2114273 */   // Label 28002: @2114273
     /* 2114273 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2114364), // Rule ID 16965 //
     /* 2114278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2114281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2114298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2114320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114324 */     // MIs[0] round
     /* 2114324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114327 */     // MIs[0] policy
     /* 2114327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114337 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2114340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2114360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114363 */     // GIR_Coverage, 16965,
     /* 2114363 */     GIR_EraseRootFromParent_Done,
     /* 2114364 */   // Label 28003: @2114364
     /* 2114364 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2114455), // Rule ID 16968 //
     /* 2114369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114415 */     // MIs[0] round
     /* 2114415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114418 */     // MIs[0] policy
     /* 2114418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114454 */     // GIR_Coverage, 16968,
     /* 2114454 */     GIR_EraseRootFromParent_Done,
     /* 2114455 */   // Label 28004: @2114455
     /* 2114455 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2114546), // Rule ID 16969 //
     /* 2114460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114506 */     // MIs[0] round
     /* 2114506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114509 */     // MIs[0] policy
     /* 2114509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114519 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114545 */     // GIR_Coverage, 16969,
     /* 2114545 */     GIR_EraseRootFromParent_Done,
     /* 2114546 */   // Label 28005: @2114546
     /* 2114546 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2114637), // Rule ID 16972 //
     /* 2114551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114597 */     // MIs[0] round
     /* 2114597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114600 */     // MIs[0] policy
     /* 2114600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114636 */     // GIR_Coverage, 16972,
     /* 2114636 */     GIR_EraseRootFromParent_Done,
     /* 2114637 */   // Label 28006: @2114637
     /* 2114637 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2114728), // Rule ID 16973 //
     /* 2114642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114688 */     // MIs[0] round
     /* 2114688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114691 */     // MIs[0] policy
     /* 2114691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114701 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114727 */     // GIR_Coverage, 16973,
     /* 2114727 */     GIR_EraseRootFromParent_Done,
     /* 2114728 */   // Label 28007: @2114728
     /* 2114728 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2114819), // Rule ID 16976 //
     /* 2114733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114779 */     // MIs[0] round
     /* 2114779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114782 */     // MIs[0] policy
     /* 2114782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114792 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114818 */     // GIR_Coverage, 16976,
     /* 2114818 */     GIR_EraseRootFromParent_Done,
     /* 2114819 */   // Label 28008: @2114819
     /* 2114819 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2114910), // Rule ID 16977 //
     /* 2114824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114870 */     // MIs[0] round
     /* 2114870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114873 */     // MIs[0] policy
     /* 2114873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114909 */     // GIR_Coverage, 16977,
     /* 2114909 */     GIR_EraseRootFromParent_Done,
     /* 2114910 */   // Label 28009: @2114910
     /* 2114910 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2115001), // Rule ID 16980 //
     /* 2114915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114961 */     // MIs[0] round
     /* 2114961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114964 */     // MIs[0] policy
     /* 2114964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114974 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115000 */     // GIR_Coverage, 16980,
     /* 2115000 */     GIR_EraseRootFromParent_Done,
     /* 2115001 */   // Label 28010: @2115001
     /* 2115001 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2115092), // Rule ID 16981 //
     /* 2115006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115052 */     // MIs[0] round
     /* 2115052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115055 */     // MIs[0] policy
     /* 2115055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2115068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115091 */     // GIR_Coverage, 16981,
     /* 2115091 */     GIR_EraseRootFromParent_Done,
     /* 2115092 */   // Label 28011: @2115092
     /* 2115092 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2115183), // Rule ID 16984 //
     /* 2115097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115143 */     // MIs[0] round
     /* 2115143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115146 */     // MIs[0] policy
     /* 2115146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2115159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115182 */     // GIR_Coverage, 16984,
     /* 2115182 */     GIR_EraseRootFromParent_Done,
     /* 2115183 */   // Label 28012: @2115183
     /* 2115183 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2115274), // Rule ID 16985 //
     /* 2115188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115234 */     // MIs[0] round
     /* 2115234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115237 */     // MIs[0] policy
     /* 2115237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115247 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2115250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115273 */     // GIR_Coverage, 16985,
     /* 2115273 */     GIR_EraseRootFromParent_Done,
     /* 2115274 */   // Label 28013: @2115274
     /* 2115274 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2115365), // Rule ID 16988 //
     /* 2115279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2115282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115325 */     // MIs[0] round
     /* 2115325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115328 */     // MIs[0] policy
     /* 2115328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2115341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115364 */     // GIR_Coverage, 16988,
     /* 2115364 */     GIR_EraseRootFromParent_Done,
     /* 2115365 */   // Label 28014: @2115365
     /* 2115365 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2115456), // Rule ID 16989 //
     /* 2115370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2115373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115416 */     // MIs[0] round
     /* 2115416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115419 */     // MIs[0] policy
     /* 2115419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115429 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2115432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115455 */     // GIR_Coverage, 16989,
     /* 2115455 */     GIR_EraseRootFromParent_Done,
     /* 2115456 */   // Label 28015: @2115456
     /* 2115456 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2115547), // Rule ID 16992 //
     /* 2115461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115507 */     // MIs[0] round
     /* 2115507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115510 */     // MIs[0] policy
     /* 2115510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115520 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115546 */     // GIR_Coverage, 16992,
     /* 2115546 */     GIR_EraseRootFromParent_Done,
     /* 2115547 */   // Label 28016: @2115547
     /* 2115547 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2115638), // Rule ID 16993 //
     /* 2115552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115598 */     // MIs[0] round
     /* 2115598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115601 */     // MIs[0] policy
     /* 2115601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115611 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115637 */     // GIR_Coverage, 16993,
     /* 2115637 */     GIR_EraseRootFromParent_Done,
     /* 2115638 */   // Label 28017: @2115638
     /* 2115638 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2115729), // Rule ID 16996 //
     /* 2115643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115689 */     // MIs[0] round
     /* 2115689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115692 */     // MIs[0] policy
     /* 2115692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115728 */     // GIR_Coverage, 16996,
     /* 2115728 */     GIR_EraseRootFromParent_Done,
     /* 2115729 */   // Label 28018: @2115729
     /* 2115729 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2115820), // Rule ID 16997 //
     /* 2115734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115780 */     // MIs[0] round
     /* 2115780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115783 */     // MIs[0] policy
     /* 2115783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115793 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115819 */     // GIR_Coverage, 16997,
     /* 2115819 */     GIR_EraseRootFromParent_Done,
     /* 2115820 */   // Label 28019: @2115820
     /* 2115820 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2115911), // Rule ID 17000 //
     /* 2115825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115871 */     // MIs[0] round
     /* 2115871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115874 */     // MIs[0] policy
     /* 2115874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115910 */     // GIR_Coverage, 17000,
     /* 2115910 */     GIR_EraseRootFromParent_Done,
     /* 2115911 */   // Label 28020: @2115911
     /* 2115911 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2116002), // Rule ID 17001 //
     /* 2115916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115962 */     // MIs[0] round
     /* 2115962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115965 */     // MIs[0] policy
     /* 2115965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116001 */     // GIR_Coverage, 17001,
     /* 2116001 */     GIR_EraseRootFromParent_Done,
     /* 2116002 */   // Label 28021: @2116002
     /* 2116002 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2116093), // Rule ID 17004 //
     /* 2116007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2116027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116053 */     // MIs[0] round
     /* 2116053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116056 */     // MIs[0] policy
     /* 2116056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116066 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2116069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116092 */     // GIR_Coverage, 17004,
     /* 2116092 */     GIR_EraseRootFromParent_Done,
     /* 2116093 */   // Label 28022: @2116093
     /* 2116093 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2116184), // Rule ID 17005 //
     /* 2116098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2116115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2116118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116144 */     // MIs[0] round
     /* 2116144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116147 */     // MIs[0] policy
     /* 2116147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116157 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2116160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116183 */     // GIR_Coverage, 17005,
     /* 2116183 */     GIR_EraseRootFromParent_Done,
     /* 2116184 */   // Label 28023: @2116184
     /* 2116184 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2116275), // Rule ID 17008 //
     /* 2116189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2116209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116235 */     // MIs[0] round
     /* 2116235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116238 */     // MIs[0] policy
     /* 2116238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116248 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2116251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116274 */     // GIR_Coverage, 17008,
     /* 2116274 */     GIR_EraseRootFromParent_Done,
     /* 2116275 */   // Label 28024: @2116275
     /* 2116275 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2116366), // Rule ID 17009 //
     /* 2116280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2116297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2116300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116326 */     // MIs[0] round
     /* 2116326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116329 */     // MIs[0] policy
     /* 2116329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116339 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2116342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116365 */     // GIR_Coverage, 17009,
     /* 2116365 */     GIR_EraseRootFromParent_Done,
     /* 2116366 */   // Label 28025: @2116366
     /* 2116366 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2116457), // Rule ID 17012 //
     /* 2116371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116417 */     // MIs[0] round
     /* 2116417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116420 */     // MIs[0] policy
     /* 2116420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116430 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116456 */     // GIR_Coverage, 17012,
     /* 2116456 */     GIR_EraseRootFromParent_Done,
     /* 2116457 */   // Label 28026: @2116457
     /* 2116457 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2116548), // Rule ID 17013 //
     /* 2116462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116508 */     // MIs[0] round
     /* 2116508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116511 */     // MIs[0] policy
     /* 2116511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116521 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116547 */     // GIR_Coverage, 17013,
     /* 2116547 */     GIR_EraseRootFromParent_Done,
     /* 2116548 */   // Label 28027: @2116548
     /* 2116548 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2116639), // Rule ID 17016 //
     /* 2116553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116599 */     // MIs[0] round
     /* 2116599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116602 */     // MIs[0] policy
     /* 2116602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116612 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116638 */     // GIR_Coverage, 17016,
     /* 2116638 */     GIR_EraseRootFromParent_Done,
     /* 2116639 */   // Label 28028: @2116639
     /* 2116639 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2116730), // Rule ID 17017 //
     /* 2116644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116690 */     // MIs[0] round
     /* 2116690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116693 */     // MIs[0] policy
     /* 2116693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116703 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116729 */     // GIR_Coverage, 17017,
     /* 2116729 */     GIR_EraseRootFromParent_Done,
     /* 2116730 */   // Label 28029: @2116730
     /* 2116730 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2116821), // Rule ID 17020 //
     /* 2116735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116781 */     // MIs[0] round
     /* 2116781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116784 */     // MIs[0] policy
     /* 2116784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116794 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116820 */     // GIR_Coverage, 17020,
     /* 2116820 */     GIR_EraseRootFromParent_Done,
     /* 2116821 */   // Label 28030: @2116821
     /* 2116821 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2116912), // Rule ID 17021 //
     /* 2116826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116872 */     // MIs[0] round
     /* 2116872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116875 */     // MIs[0] policy
     /* 2116875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116885 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116911 */     // GIR_Coverage, 17021,
     /* 2116911 */     GIR_EraseRootFromParent_Done,
     /* 2116912 */   // Label 28031: @2116912
     /* 2116912 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2117003), // Rule ID 17024 //
     /* 2116917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116963 */     // MIs[0] round
     /* 2116963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116966 */     // MIs[0] policy
     /* 2116966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117002 */     // GIR_Coverage, 17024,
     /* 2117002 */     GIR_EraseRootFromParent_Done,
     /* 2117003 */   // Label 28032: @2117003
     /* 2117003 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2117094), // Rule ID 17025 //
     /* 2117008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2117028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117054 */     // MIs[0] round
     /* 2117054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117057 */     // MIs[0] policy
     /* 2117057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117067 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2117070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117093 */     // GIR_Coverage, 17025,
     /* 2117093 */     GIR_EraseRootFromParent_Done,
     /* 2117094 */   // Label 28033: @2117094
     /* 2117094 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2117185), // Rule ID 17028 //
     /* 2117099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2117119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117145 */     // MIs[0] round
     /* 2117145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117148 */     // MIs[0] policy
     /* 2117148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2117161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117184 */     // GIR_Coverage, 17028,
     /* 2117184 */     GIR_EraseRootFromParent_Done,
     /* 2117185 */   // Label 28034: @2117185
     /* 2117185 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2117276), // Rule ID 17029 //
     /* 2117190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2117210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117236 */     // MIs[0] round
     /* 2117236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117239 */     // MIs[0] policy
     /* 2117239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117249 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2117252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117275 */     // GIR_Coverage, 17029,
     /* 2117275 */     GIR_EraseRootFromParent_Done,
     /* 2117276 */   // Label 28035: @2117276
     /* 2117276 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2117367), // Rule ID 17032 //
     /* 2117281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2117292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2117295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2117301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117327 */     // MIs[0] round
     /* 2117327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117330 */     // MIs[0] policy
     /* 2117330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2117343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117366 */     // GIR_Coverage, 17032,
     /* 2117366 */     GIR_EraseRootFromParent_Done,
     /* 2117367 */   // Label 28036: @2117367
     /* 2117367 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2117458), // Rule ID 17033 //
     /* 2117372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2117383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2117386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2117392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117418 */     // MIs[0] round
     /* 2117418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117421 */     // MIs[0] policy
     /* 2117421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117431 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2117434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117457 */     // GIR_Coverage, 17033,
     /* 2117457 */     GIR_EraseRootFromParent_Done,
     /* 2117458 */   // Label 28037: @2117458
     /* 2117458 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2117549), // Rule ID 17036 //
     /* 2117463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117509 */     // MIs[0] round
     /* 2117509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117512 */     // MIs[0] policy
     /* 2117512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117522 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117548 */     // GIR_Coverage, 17036,
     /* 2117548 */     GIR_EraseRootFromParent_Done,
     /* 2117549 */   // Label 28038: @2117549
     /* 2117549 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2117640), // Rule ID 17037 //
     /* 2117554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117600 */     // MIs[0] round
     /* 2117600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117603 */     // MIs[0] policy
     /* 2117603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117613 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117639 */     // GIR_Coverage, 17037,
     /* 2117639 */     GIR_EraseRootFromParent_Done,
     /* 2117640 */   // Label 28039: @2117640
     /* 2117640 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2117731), // Rule ID 17040 //
     /* 2117645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117691 */     // MIs[0] round
     /* 2117691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117694 */     // MIs[0] policy
     /* 2117694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117730 */     // GIR_Coverage, 17040,
     /* 2117730 */     GIR_EraseRootFromParent_Done,
     /* 2117731 */   // Label 28040: @2117731
     /* 2117731 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2117822), // Rule ID 17041 //
     /* 2117736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117782 */     // MIs[0] round
     /* 2117782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117785 */     // MIs[0] policy
     /* 2117785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117795 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117821 */     // GIR_Coverage, 17041,
     /* 2117821 */     GIR_EraseRootFromParent_Done,
     /* 2117822 */   // Label 28041: @2117822
     /* 2117822 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2117913), // Rule ID 17044 //
     /* 2117827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117873 */     // MIs[0] round
     /* 2117873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117876 */     // MIs[0] policy
     /* 2117876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117886 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117912 */     // GIR_Coverage, 17044,
     /* 2117912 */     GIR_EraseRootFromParent_Done,
     /* 2117913 */   // Label 28042: @2117913
     /* 2117913 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2118004), // Rule ID 17045 //
     /* 2117918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117964 */     // MIs[0] round
     /* 2117964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117967 */     // MIs[0] policy
     /* 2117967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117977 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11336:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118003 */     // GIR_Coverage, 17045,
     /* 2118003 */     GIR_EraseRootFromParent_Done,
     /* 2118004 */   // Label 28043: @2118004
     /* 2118004 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2118095), // Rule ID 17048 //
     /* 2118009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2118026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118055 */     // MIs[0] round
     /* 2118055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118058 */     // MIs[0] policy
     /* 2118058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2118071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118094 */     // GIR_Coverage, 17048,
     /* 2118094 */     GIR_EraseRootFromParent_Done,
     /* 2118095 */   // Label 28044: @2118095
     /* 2118095 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2118186), // Rule ID 17049 //
     /* 2118100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2118117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118146 */     // MIs[0] round
     /* 2118146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118149 */     // MIs[0] policy
     /* 2118149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2118162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118185 */     // GIR_Coverage, 17049,
     /* 2118185 */     GIR_EraseRootFromParent_Done,
     /* 2118186 */   // Label 28045: @2118186
     /* 2118186 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2118277), // Rule ID 17052 //
     /* 2118191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118237 */     // MIs[0] round
     /* 2118237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118240 */     // MIs[0] policy
     /* 2118240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2118253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118276 */     // GIR_Coverage, 17052,
     /* 2118276 */     GIR_EraseRootFromParent_Done,
     /* 2118277 */   // Label 28046: @2118277
     /* 2118277 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2118368), // Rule ID 17053 //
     /* 2118282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118328 */     // MIs[0] round
     /* 2118328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118331 */     // MIs[0] policy
     /* 2118331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118341 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2118344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118367 */     // GIR_Coverage, 17053,
     /* 2118367 */     GIR_EraseRootFromParent_Done,
     /* 2118368 */   // Label 28047: @2118368
     /* 2118368 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2118459), // Rule ID 17056 //
     /* 2118373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118419 */     // MIs[0] round
     /* 2118419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118422 */     // MIs[0] policy
     /* 2118422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118432 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118458 */     // GIR_Coverage, 17056,
     /* 2118458 */     GIR_EraseRootFromParent_Done,
     /* 2118459 */   // Label 28048: @2118459
     /* 2118459 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2118550), // Rule ID 17057 //
     /* 2118464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118510 */     // MIs[0] round
     /* 2118510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118513 */     // MIs[0] policy
     /* 2118513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118523 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118549 */     // GIR_Coverage, 17057,
     /* 2118549 */     GIR_EraseRootFromParent_Done,
     /* 2118550 */   // Label 28049: @2118550
     /* 2118550 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2118641), // Rule ID 17060 //
     /* 2118555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118601 */     // MIs[0] round
     /* 2118601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118604 */     // MIs[0] policy
     /* 2118604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118640 */     // GIR_Coverage, 17060,
     /* 2118640 */     GIR_EraseRootFromParent_Done,
     /* 2118641 */   // Label 28050: @2118641
     /* 2118641 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2118732), // Rule ID 17061 //
     /* 2118646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118692 */     // MIs[0] round
     /* 2118692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118695 */     // MIs[0] policy
     /* 2118695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118705 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11336:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118731 */     // GIR_Coverage, 17061,
     /* 2118731 */     GIR_EraseRootFromParent_Done,
     /* 2118732 */   // Label 28051: @2118732
     /* 2118732 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2118823), // Rule ID 17064 //
     /* 2118737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118783 */     // MIs[0] round
     /* 2118783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118786 */     // MIs[0] policy
     /* 2118786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118796 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118822 */     // GIR_Coverage, 17064,
     /* 2118822 */     GIR_EraseRootFromParent_Done,
     /* 2118823 */   // Label 28052: @2118823
     /* 2118823 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2118914), // Rule ID 17065 //
     /* 2118828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118874 */     // MIs[0] round
     /* 2118874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118877 */     // MIs[0] policy
     /* 2118877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11336:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118913 */     // GIR_Coverage, 17065,
     /* 2118913 */     GIR_EraseRootFromParent_Done,
     /* 2118914 */   // Label 28053: @2118914
     /* 2118914 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2119005), // Rule ID 17068 //
     /* 2118919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118965 */     // MIs[0] round
     /* 2118965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118968 */     // MIs[0] policy
     /* 2118968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118978 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119004 */     // GIR_Coverage, 17068,
     /* 2119004 */     GIR_EraseRootFromParent_Done,
     /* 2119005 */   // Label 28054: @2119005
     /* 2119005 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2119096), // Rule ID 17069 //
     /* 2119010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2119027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119056 */     // MIs[0] round
     /* 2119056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119059 */     // MIs[0] policy
     /* 2119059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119069 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11336:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2119072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119095 */     // GIR_Coverage, 17069,
     /* 2119095 */     GIR_EraseRootFromParent_Done,
     /* 2119096 */   // Label 28055: @2119096
     /* 2119096 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2119187), // Rule ID 17072 //
     /* 2119101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119147 */     // MIs[0] round
     /* 2119147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119150 */     // MIs[0] policy
     /* 2119150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119160 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2119163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119186 */     // GIR_Coverage, 17072,
     /* 2119186 */     GIR_EraseRootFromParent_Done,
     /* 2119187 */   // Label 28056: @2119187
     /* 2119187 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2119278), // Rule ID 17073 //
     /* 2119192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2119200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2119212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2119234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119238 */     // MIs[0] round
     /* 2119238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119241 */     // MIs[0] policy
     /* 2119241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119251 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11336:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2119254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119277 */     // GIR_Coverage, 17073,
     /* 2119277 */     GIR_EraseRootFromParent_Done,
     /* 2119278 */   // Label 28057: @2119278
     /* 2119278 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2119369), // Rule ID 17076 //
     /* 2119283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119329 */     // MIs[0] round
     /* 2119329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119332 */     // MIs[0] policy
     /* 2119332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119342 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2119345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119368 */     // GIR_Coverage, 17076,
     /* 2119368 */     GIR_EraseRootFromParent_Done,
     /* 2119369 */   // Label 28058: @2119369
     /* 2119369 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2119460), // Rule ID 17077 //
     /* 2119374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2119394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119420 */     // MIs[0] round
     /* 2119420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119423 */     // MIs[0] policy
     /* 2119423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2119436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119459 */     // GIR_Coverage, 17077,
     /* 2119459 */     GIR_EraseRootFromParent_Done,
     /* 2119460 */   // Label 28059: @2119460
     /* 2119460 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2119551), // Rule ID 17080 //
     /* 2119465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119511 */     // MIs[0] round
     /* 2119511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119514 */     // MIs[0] policy
     /* 2119514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119550 */     // GIR_Coverage, 17080,
     /* 2119550 */     GIR_EraseRootFromParent_Done,
     /* 2119551 */   // Label 28060: @2119551
     /* 2119551 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2119642), // Rule ID 17081 //
     /* 2119556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119602 */     // MIs[0] round
     /* 2119602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119605 */     // MIs[0] policy
     /* 2119605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119615 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119641 */     // GIR_Coverage, 17081,
     /* 2119641 */     GIR_EraseRootFromParent_Done,
     /* 2119642 */   // Label 28061: @2119642
     /* 2119642 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2119733), // Rule ID 17084 //
     /* 2119647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119693 */     // MIs[0] round
     /* 2119693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119696 */     // MIs[0] policy
     /* 2119696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119732 */     // GIR_Coverage, 17084,
     /* 2119732 */     GIR_EraseRootFromParent_Done,
     /* 2119733 */   // Label 28062: @2119733
     /* 2119733 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2119824), // Rule ID 17085 //
     /* 2119738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119784 */     // MIs[0] round
     /* 2119784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119787 */     // MIs[0] policy
     /* 2119787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119797 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119823 */     // GIR_Coverage, 17085,
     /* 2119823 */     GIR_EraseRootFromParent_Done,
     /* 2119824 */   // Label 28063: @2119824
     /* 2119824 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2119915), // Rule ID 17088 //
     /* 2119829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119875 */     // MIs[0] round
     /* 2119875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119878 */     // MIs[0] policy
     /* 2119878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119888 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119914 */     // GIR_Coverage, 17088,
     /* 2119914 */     GIR_EraseRootFromParent_Done,
     /* 2119915 */   // Label 28064: @2119915
     /* 2119915 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2120006), // Rule ID 17089 //
     /* 2119920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119966 */     // MIs[0] round
     /* 2119966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119969 */     // MIs[0] policy
     /* 2119969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119979 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120005 */     // GIR_Coverage, 17089,
     /* 2120005 */     GIR_EraseRootFromParent_Done,
     /* 2120006 */   // Label 28065: @2120006
     /* 2120006 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2120097), // Rule ID 17092 //
     /* 2120011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120057 */     // MIs[0] round
     /* 2120057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120060 */     // MIs[0] policy
     /* 2120060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120070 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2120073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120096 */     // GIR_Coverage, 17092,
     /* 2120096 */     GIR_EraseRootFromParent_Done,
     /* 2120097 */   // Label 28066: @2120097
     /* 2120097 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2120188), // Rule ID 17093 //
     /* 2120102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2120119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2120122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120148 */     // MIs[0] round
     /* 2120148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120151 */     // MIs[0] policy
     /* 2120151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120161 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2120164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120187 */     // GIR_Coverage, 17093,
     /* 2120187 */     GIR_EraseRootFromParent_Done,
     /* 2120188 */   // Label 28067: @2120188
     /* 2120188 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2120279), // Rule ID 17096 //
     /* 2120193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120239 */     // MIs[0] round
     /* 2120239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120242 */     // MIs[0] policy
     /* 2120242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120252 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2120255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120278 */     // GIR_Coverage, 17096,
     /* 2120278 */     GIR_EraseRootFromParent_Done,
     /* 2120279 */   // Label 28068: @2120279
     /* 2120279 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2120370), // Rule ID 17097 //
     /* 2120284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2120304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120330 */     // MIs[0] round
     /* 2120330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120333 */     // MIs[0] policy
     /* 2120333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120343 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2120346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120369 */     // GIR_Coverage, 17097,
     /* 2120369 */     GIR_EraseRootFromParent_Done,
     /* 2120370 */   // Label 28069: @2120370
     /* 2120370 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2120461), // Rule ID 17100 //
     /* 2120375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120421 */     // MIs[0] round
     /* 2120421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120424 */     // MIs[0] policy
     /* 2120424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120460 */     // GIR_Coverage, 17100,
     /* 2120460 */     GIR_EraseRootFromParent_Done,
     /* 2120461 */   // Label 28070: @2120461
     /* 2120461 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2120552), // Rule ID 17101 //
     /* 2120466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120512 */     // MIs[0] round
     /* 2120512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120515 */     // MIs[0] policy
     /* 2120515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120525 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120551 */     // GIR_Coverage, 17101,
     /* 2120551 */     GIR_EraseRootFromParent_Done,
     /* 2120552 */   // Label 28071: @2120552
     /* 2120552 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2120643), // Rule ID 17104 //
     /* 2120557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120603 */     // MIs[0] round
     /* 2120603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120606 */     // MIs[0] policy
     /* 2120606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120642 */     // GIR_Coverage, 17104,
     /* 2120642 */     GIR_EraseRootFromParent_Done,
     /* 2120643 */   // Label 28072: @2120643
     /* 2120643 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2120734), // Rule ID 17105 //
     /* 2120648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120694 */     // MIs[0] round
     /* 2120694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120697 */     // MIs[0] policy
     /* 2120697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120707 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120733 */     // GIR_Coverage, 17105,
     /* 2120733 */     GIR_EraseRootFromParent_Done,
     /* 2120734 */   // Label 28073: @2120734
     /* 2120734 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2120825), // Rule ID 17108 //
     /* 2120739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120785 */     // MIs[0] round
     /* 2120785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120788 */     // MIs[0] policy
     /* 2120788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120798 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120824 */     // GIR_Coverage, 17108,
     /* 2120824 */     GIR_EraseRootFromParent_Done,
     /* 2120825 */   // Label 28074: @2120825
     /* 2120825 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2120916), // Rule ID 17109 //
     /* 2120830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120876 */     // MIs[0] round
     /* 2120876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120879 */     // MIs[0] policy
     /* 2120879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120889 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120915 */     // GIR_Coverage, 17109,
     /* 2120915 */     GIR_EraseRootFromParent_Done,
     /* 2120916 */   // Label 28075: @2120916
     /* 2120916 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2121007), // Rule ID 17112 //
     /* 2120921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120967 */     // MIs[0] round
     /* 2120967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120970 */     // MIs[0] policy
     /* 2120970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120980 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121006 */     // GIR_Coverage, 17112,
     /* 2121006 */     GIR_EraseRootFromParent_Done,
     /* 2121007 */   // Label 28076: @2121007
     /* 2121007 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2121098), // Rule ID 17113 //
     /* 2121012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2121023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2121026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121058 */     // MIs[0] round
     /* 2121058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121061 */     // MIs[0] policy
     /* 2121061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121071 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2121074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121097 */     // GIR_Coverage, 17113,
     /* 2121097 */     GIR_EraseRootFromParent_Done,
     /* 2121098 */   // Label 28077: @2121098
     /* 2121098 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2121189), // Rule ID 17116 //
     /* 2121103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121149 */     // MIs[0] round
     /* 2121149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121152 */     // MIs[0] policy
     /* 2121152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121162 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2121165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121188 */     // GIR_Coverage, 17116,
     /* 2121188 */     GIR_EraseRootFromParent_Done,
     /* 2121189 */   // Label 28078: @2121189
     /* 2121189 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2121280), // Rule ID 17117 //
     /* 2121194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2121205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2121208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121240 */     // MIs[0] round
     /* 2121240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121243 */     // MIs[0] policy
     /* 2121243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121253 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2121256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121279 */     // GIR_Coverage, 17117,
     /* 2121279 */     GIR_EraseRootFromParent_Done,
     /* 2121280 */   // Label 28079: @2121280
     /* 2121280 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2121371), // Rule ID 17120 //
     /* 2121285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121331 */     // MIs[0] round
     /* 2121331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121334 */     // MIs[0] policy
     /* 2121334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2121347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121370 */     // GIR_Coverage, 17120,
     /* 2121370 */     GIR_EraseRootFromParent_Done,
     /* 2121371 */   // Label 28080: @2121371
     /* 2121371 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2121462), // Rule ID 17121 //
     /* 2121376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2121393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121422 */     // MIs[0] round
     /* 2121422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121425 */     // MIs[0] policy
     /* 2121425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121435 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2121438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121461 */     // GIR_Coverage, 17121,
     /* 2121461 */     GIR_EraseRootFromParent_Done,
     /* 2121462 */   // Label 28081: @2121462
     /* 2121462 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2121553), // Rule ID 17124 //
     /* 2121467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121513 */     // MIs[0] round
     /* 2121513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121516 */     // MIs[0] policy
     /* 2121516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121526 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121552 */     // GIR_Coverage, 17124,
     /* 2121552 */     GIR_EraseRootFromParent_Done,
     /* 2121553 */   // Label 28082: @2121553
     /* 2121553 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2121644), // Rule ID 17125 //
     /* 2121558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121604 */     // MIs[0] round
     /* 2121604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121607 */     // MIs[0] policy
     /* 2121607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121617 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121643 */     // GIR_Coverage, 17125,
     /* 2121643 */     GIR_EraseRootFromParent_Done,
     /* 2121644 */   // Label 28083: @2121644
     /* 2121644 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2121735), // Rule ID 17128 //
     /* 2121649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121695 */     // MIs[0] round
     /* 2121695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121698 */     // MIs[0] policy
     /* 2121698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121734 */     // GIR_Coverage, 17128,
     /* 2121734 */     GIR_EraseRootFromParent_Done,
     /* 2121735 */   // Label 28084: @2121735
     /* 2121735 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2121826), // Rule ID 17129 //
     /* 2121740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121786 */     // MIs[0] round
     /* 2121786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121789 */     // MIs[0] policy
     /* 2121789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121799 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121825 */     // GIR_Coverage, 17129,
     /* 2121825 */     GIR_EraseRootFromParent_Done,
     /* 2121826 */   // Label 28085: @2121826
     /* 2121826 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2121917), // Rule ID 17132 //
     /* 2121831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121877 */     // MIs[0] round
     /* 2121877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121880 */     // MIs[0] policy
     /* 2121880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121916 */     // GIR_Coverage, 17132,
     /* 2121916 */     GIR_EraseRootFromParent_Done,
     /* 2121917 */   // Label 28086: @2121917
     /* 2121917 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2122008), // Rule ID 17133 //
     /* 2121922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121968 */     // MIs[0] round
     /* 2121968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121971 */     // MIs[0] policy
     /* 2121971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121981 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122007 */     // GIR_Coverage, 17133,
     /* 2122007 */     GIR_EraseRootFromParent_Done,
     /* 2122008 */   // Label 28087: @2122008
     /* 2122008 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2122099), // Rule ID 17136 //
     /* 2122013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122059 */     // MIs[0] round
     /* 2122059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122062 */     // MIs[0] policy
     /* 2122062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2122075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122098 */     // GIR_Coverage, 17136,
     /* 2122098 */     GIR_EraseRootFromParent_Done,
     /* 2122099 */   // Label 28088: @2122099
     /* 2122099 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2122190), // Rule ID 17137 //
     /* 2122104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122150 */     // MIs[0] round
     /* 2122150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122153 */     // MIs[0] policy
     /* 2122153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2122166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122189 */     // GIR_Coverage, 17137,
     /* 2122189 */     GIR_EraseRootFromParent_Done,
     /* 2122190 */   // Label 28089: @2122190
     /* 2122190 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2122281), // Rule ID 17140 //
     /* 2122195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122241 */     // MIs[0] round
     /* 2122241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122244 */     // MIs[0] policy
     /* 2122244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2122257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122280 */     // GIR_Coverage, 17140,
     /* 2122280 */     GIR_EraseRootFromParent_Done,
     /* 2122281 */   // Label 28090: @2122281
     /* 2122281 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2122372), // Rule ID 17141 //
     /* 2122286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122332 */     // MIs[0] round
     /* 2122332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122335 */     // MIs[0] policy
     /* 2122335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122345 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2122348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122371 */     // GIR_Coverage, 17141,
     /* 2122371 */     GIR_EraseRootFromParent_Done,
     /* 2122372 */   // Label 28091: @2122372
     /* 2122372 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2122463), // Rule ID 17144 //
     /* 2122377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122423 */     // MIs[0] round
     /* 2122423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122426 */     // MIs[0] policy
     /* 2122426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122436 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122462 */     // GIR_Coverage, 17144,
     /* 2122462 */     GIR_EraseRootFromParent_Done,
     /* 2122463 */   // Label 28092: @2122463
     /* 2122463 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2122554), // Rule ID 17145 //
     /* 2122468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122514 */     // MIs[0] round
     /* 2122514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122517 */     // MIs[0] policy
     /* 2122517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122527 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122553 */     // GIR_Coverage, 17145,
     /* 2122553 */     GIR_EraseRootFromParent_Done,
     /* 2122554 */   // Label 28093: @2122554
     /* 2122554 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2122645), // Rule ID 17154 //
     /* 2122559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122605 */     // MIs[0] round
     /* 2122605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122608 */     // MIs[0] policy
     /* 2122608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122618 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122644 */     // GIR_Coverage, 17154,
     /* 2122644 */     GIR_EraseRootFromParent_Done,
     /* 2122645 */   // Label 28094: @2122645
     /* 2122645 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2122736), // Rule ID 17155 //
     /* 2122650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122696 */     // MIs[0] round
     /* 2122696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122699 */     // MIs[0] policy
     /* 2122699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122709 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122735 */     // GIR_Coverage, 17155,
     /* 2122735 */     GIR_EraseRootFromParent_Done,
     /* 2122736 */   // Label 28095: @2122736
     /* 2122736 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2122827), // Rule ID 17164 //
     /* 2122741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122787 */     // MIs[0] round
     /* 2122787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122790 */     // MIs[0] policy
     /* 2122790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122800 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122826 */     // GIR_Coverage, 17164,
     /* 2122826 */     GIR_EraseRootFromParent_Done,
     /* 2122827 */   // Label 28096: @2122827
     /* 2122827 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2122918), // Rule ID 17165 //
     /* 2122832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122878 */     // MIs[0] round
     /* 2122878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122881 */     // MIs[0] policy
     /* 2122881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122917 */     // GIR_Coverage, 17165,
     /* 2122917 */     GIR_EraseRootFromParent_Done,
     /* 2122918 */   // Label 28097: @2122918
     /* 2122918 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2123009), // Rule ID 17174 //
     /* 2122923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122969 */     // MIs[0] round
     /* 2122969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122972 */     // MIs[0] policy
     /* 2122972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122982 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123008 */     // GIR_Coverage, 17174,
     /* 2123008 */     GIR_EraseRootFromParent_Done,
     /* 2123009 */   // Label 28098: @2123009
     /* 2123009 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2123100), // Rule ID 17175 //
     /* 2123014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2123031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123060 */     // MIs[0] round
     /* 2123060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123063 */     // MIs[0] policy
     /* 2123063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123073 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2123076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123099 */     // GIR_Coverage, 17175,
     /* 2123099 */     GIR_EraseRootFromParent_Done,
     /* 2123100 */   // Label 28099: @2123100
     /* 2123100 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2123191), // Rule ID 17184 //
     /* 2123105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123151 */     // MIs[0] round
     /* 2123151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123154 */     // MIs[0] policy
     /* 2123154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123164 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2123167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123190 */     // GIR_Coverage, 17184,
     /* 2123190 */     GIR_EraseRootFromParent_Done,
     /* 2123191 */   // Label 28100: @2123191
     /* 2123191 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2123282), // Rule ID 17185 //
     /* 2123196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123242 */     // MIs[0] round
     /* 2123242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123245 */     // MIs[0] policy
     /* 2123245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123255 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2123258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123281 */     // GIR_Coverage, 17185,
     /* 2123281 */     GIR_EraseRootFromParent_Done,
     /* 2123282 */   // Label 28101: @2123282
     /* 2123282 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2123373), // Rule ID 17194 //
     /* 2123287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123333 */     // MIs[0] round
     /* 2123333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123336 */     // MIs[0] policy
     /* 2123336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123346 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2123349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123372 */     // GIR_Coverage, 17194,
     /* 2123372 */     GIR_EraseRootFromParent_Done,
     /* 2123373 */   // Label 28102: @2123373
     /* 2123373 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2123464), // Rule ID 17195 //
     /* 2123378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123424 */     // MIs[0] round
     /* 2123424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123427 */     // MIs[0] policy
     /* 2123427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123437 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2123440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123463 */     // GIR_Coverage, 17195,
     /* 2123463 */     GIR_EraseRootFromParent_Done,
     /* 2123464 */   // Label 28103: @2123464
     /* 2123464 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2123555), // Rule ID 17204 //
     /* 2123469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123515 */     // MIs[0] round
     /* 2123515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123518 */     // MIs[0] policy
     /* 2123518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123528 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123554 */     // GIR_Coverage, 17204,
     /* 2123554 */     GIR_EraseRootFromParent_Done,
     /* 2123555 */   // Label 28104: @2123555
     /* 2123555 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2123646), // Rule ID 17205 //
     /* 2123560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123606 */     // MIs[0] round
     /* 2123606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123609 */     // MIs[0] policy
     /* 2123609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123619 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123645 */     // GIR_Coverage, 17205,
     /* 2123645 */     GIR_EraseRootFromParent_Done,
     /* 2123646 */   // Label 28105: @2123646
     /* 2123646 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2123737), // Rule ID 17214 //
     /* 2123651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123697 */     // MIs[0] round
     /* 2123697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123700 */     // MIs[0] policy
     /* 2123700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123710 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123736 */     // GIR_Coverage, 17214,
     /* 2123736 */     GIR_EraseRootFromParent_Done,
     /* 2123737 */   // Label 28106: @2123737
     /* 2123737 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2123828), // Rule ID 17215 //
     /* 2123742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123788 */     // MIs[0] round
     /* 2123788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123791 */     // MIs[0] policy
     /* 2123791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123801 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123827 */     // GIR_Coverage, 17215,
     /* 2123827 */     GIR_EraseRootFromParent_Done,
     /* 2123828 */   // Label 28107: @2123828
     /* 2123828 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2123919), // Rule ID 17224 //
     /* 2123833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123879 */     // MIs[0] round
     /* 2123879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123882 */     // MIs[0] policy
     /* 2123882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123892 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123918 */     // GIR_Coverage, 17224,
     /* 2123918 */     GIR_EraseRootFromParent_Done,
     /* 2123919 */   // Label 28108: @2123919
     /* 2123919 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2124010), // Rule ID 17225 //
     /* 2123924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123970 */     // MIs[0] round
     /* 2123970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123973 */     // MIs[0] policy
     /* 2123973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124009 */     // GIR_Coverage, 17225,
     /* 2124009 */     GIR_EraseRootFromParent_Done,
     /* 2124010 */   // Label 28109: @2124010
     /* 2124010 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2124101), // Rule ID 17228 //
     /* 2124015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124061 */     // MIs[0] round
     /* 2124061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124064 */     // MIs[0] policy
     /* 2124064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124074 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2124077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124100 */     // GIR_Coverage, 17228,
     /* 2124100 */     GIR_EraseRootFromParent_Done,
     /* 2124101 */   // Label 28110: @2124101
     /* 2124101 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2124192), // Rule ID 17229 //
     /* 2124106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124152 */     // MIs[0] round
     /* 2124152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124155 */     // MIs[0] policy
     /* 2124155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124165 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2124168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124191 */     // GIR_Coverage, 17229,
     /* 2124191 */     GIR_EraseRootFromParent_Done,
     /* 2124192 */   // Label 28111: @2124192
     /* 2124192 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2124283), // Rule ID 17232 //
     /* 2124197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2124214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124243 */     // MIs[0] round
     /* 2124243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124246 */     // MIs[0] policy
     /* 2124246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2124259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124282 */     // GIR_Coverage, 17232,
     /* 2124282 */     GIR_EraseRootFromParent_Done,
     /* 2124283 */   // Label 28112: @2124283
     /* 2124283 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2124374), // Rule ID 17233 //
     /* 2124288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2124299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2124302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2124305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124334 */     // MIs[0] round
     /* 2124334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124337 */     // MIs[0] policy
     /* 2124337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124347 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2124350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124373 */     // GIR_Coverage, 17233,
     /* 2124373 */     GIR_EraseRootFromParent_Done,
     /* 2124374 */   // Label 28113: @2124374
     /* 2124374 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2124465), // Rule ID 17236 //
     /* 2124379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124425 */     // MIs[0] round
     /* 2124425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124428 */     // MIs[0] policy
     /* 2124428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124464 */     // GIR_Coverage, 17236,
     /* 2124464 */     GIR_EraseRootFromParent_Done,
     /* 2124465 */   // Label 28114: @2124465
     /* 2124465 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2124556), // Rule ID 17237 //
     /* 2124470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124516 */     // MIs[0] round
     /* 2124516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124519 */     // MIs[0] policy
     /* 2124519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124555 */     // GIR_Coverage, 17237,
     /* 2124555 */     GIR_EraseRootFromParent_Done,
     /* 2124556 */   // Label 28115: @2124556
     /* 2124556 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2124647), // Rule ID 17240 //
     /* 2124561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124607 */     // MIs[0] round
     /* 2124607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124610 */     // MIs[0] policy
     /* 2124610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124620 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124646 */     // GIR_Coverage, 17240,
     /* 2124646 */     GIR_EraseRootFromParent_Done,
     /* 2124647 */   // Label 28116: @2124647
     /* 2124647 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2124738), // Rule ID 17241 //
     /* 2124652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124698 */     // MIs[0] round
     /* 2124698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124701 */     // MIs[0] policy
     /* 2124701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124711 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124737 */     // GIR_Coverage, 17241,
     /* 2124737 */     GIR_EraseRootFromParent_Done,
     /* 2124738 */   // Label 28117: @2124738
     /* 2124738 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2124829), // Rule ID 17244 //
     /* 2124743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124789 */     // MIs[0] round
     /* 2124789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124792 */     // MIs[0] policy
     /* 2124792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124828 */     // GIR_Coverage, 17244,
     /* 2124828 */     GIR_EraseRootFromParent_Done,
     /* 2124829 */   // Label 28118: @2124829
     /* 2124829 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2124920), // Rule ID 17245 //
     /* 2124834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124880 */     // MIs[0] round
     /* 2124880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124883 */     // MIs[0] policy
     /* 2124883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124893 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124919 */     // GIR_Coverage, 17245,
     /* 2124919 */     GIR_EraseRootFromParent_Done,
     /* 2124920 */   // Label 28119: @2124920
     /* 2124920 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2125011), // Rule ID 17248 //
     /* 2124925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124971 */     // MIs[0] round
     /* 2124971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124974 */     // MIs[0] policy
     /* 2124974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125010 */     // GIR_Coverage, 17248,
     /* 2125010 */     GIR_EraseRootFromParent_Done,
     /* 2125011 */   // Label 28120: @2125011
     /* 2125011 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2125102), // Rule ID 17249 //
     /* 2125016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2125033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125062 */     // MIs[0] round
     /* 2125062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125065 */     // MIs[0] policy
     /* 2125065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125075 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2125078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125101 */     // GIR_Coverage, 17249,
     /* 2125101 */     GIR_EraseRootFromParent_Done,
     /* 2125102 */   // Label 28121: @2125102
     /* 2125102 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2125193), // Rule ID 17252 //
     /* 2125107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2125124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125153 */     // MIs[0] round
     /* 2125153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125156 */     // MIs[0] policy
     /* 2125156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2125169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125192 */     // GIR_Coverage, 17252,
     /* 2125192 */     GIR_EraseRootFromParent_Done,
     /* 2125193 */   // Label 28122: @2125193
     /* 2125193 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2125284), // Rule ID 17253 //
     /* 2125198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2125209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2125212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2125215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125244 */     // MIs[0] round
     /* 2125244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125247 */     // MIs[0] policy
     /* 2125247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2125260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125283 */     // GIR_Coverage, 17253,
     /* 2125283 */     GIR_EraseRootFromParent_Done,
     /* 2125284 */   // Label 28123: @2125284
     /* 2125284 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2125375), // Rule ID 17256 //
     /* 2125289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125335 */     // MIs[0] round
     /* 2125335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125338 */     // MIs[0] policy
     /* 2125338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2125351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125374 */     // GIR_Coverage, 17256,
     /* 2125374 */     GIR_EraseRootFromParent_Done,
     /* 2125375 */   // Label 28124: @2125375
     /* 2125375 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2125466), // Rule ID 17257 //
     /* 2125380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125426 */     // MIs[0] round
     /* 2125426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125429 */     // MIs[0] policy
     /* 2125429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125439 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2125442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125465 */     // GIR_Coverage, 17257,
     /* 2125465 */     GIR_EraseRootFromParent_Done,
     /* 2125466 */   // Label 28125: @2125466
     /* 2125466 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2125557), // Rule ID 17260 //
     /* 2125471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125517 */     // MIs[0] round
     /* 2125517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125520 */     // MIs[0] policy
     /* 2125520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125530 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125556 */     // GIR_Coverage, 17260,
     /* 2125556 */     GIR_EraseRootFromParent_Done,
     /* 2125557 */   // Label 28126: @2125557
     /* 2125557 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2125648), // Rule ID 17261 //
     /* 2125562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125608 */     // MIs[0] round
     /* 2125608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125611 */     // MIs[0] policy
     /* 2125611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125621 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125647 */     // GIR_Coverage, 17261,
     /* 2125647 */     GIR_EraseRootFromParent_Done,
     /* 2125648 */   // Label 28127: @2125648
     /* 2125648 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2125739), // Rule ID 17270 //
     /* 2125653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125699 */     // MIs[0] round
     /* 2125699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125702 */     // MIs[0] policy
     /* 2125702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125712 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125738 */     // GIR_Coverage, 17270,
     /* 2125738 */     GIR_EraseRootFromParent_Done,
     /* 2125739 */   // Label 28128: @2125739
     /* 2125739 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2125830), // Rule ID 17271 //
     /* 2125744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125790 */     // MIs[0] round
     /* 2125790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125793 */     // MIs[0] policy
     /* 2125793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125803 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125829 */     // GIR_Coverage, 17271,
     /* 2125829 */     GIR_EraseRootFromParent_Done,
     /* 2125830 */   // Label 28129: @2125830
     /* 2125830 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2125921), // Rule ID 17280 //
     /* 2125835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125881 */     // MIs[0] round
     /* 2125881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125884 */     // MIs[0] policy
     /* 2125884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125920 */     // GIR_Coverage, 17280,
     /* 2125920 */     GIR_EraseRootFromParent_Done,
     /* 2125921 */   // Label 28130: @2125921
     /* 2125921 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2126012), // Rule ID 17281 //
     /* 2125926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125972 */     // MIs[0] round
     /* 2125972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125975 */     // MIs[0] policy
     /* 2125975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125985 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126011 */     // GIR_Coverage, 17281,
     /* 2126011 */     GIR_EraseRootFromParent_Done,
     /* 2126012 */   // Label 28131: @2126012
     /* 2126012 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2126103), // Rule ID 17290 //
     /* 2126017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126063 */     // MIs[0] round
     /* 2126063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126066 */     // MIs[0] policy
     /* 2126066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2126079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126102 */     // GIR_Coverage, 17290,
     /* 2126102 */     GIR_EraseRootFromParent_Done,
     /* 2126103 */   // Label 28132: @2126103
     /* 2126103 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2126194), // Rule ID 17291 //
     /* 2126108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2126128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126154 */     // MIs[0] round
     /* 2126154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126157 */     // MIs[0] policy
     /* 2126157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126167 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2126170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126193 */     // GIR_Coverage, 17291,
     /* 2126193 */     GIR_EraseRootFromParent_Done,
     /* 2126194 */   // Label 28133: @2126194
     /* 2126194 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2126285), // Rule ID 17300 //
     /* 2126199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126245 */     // MIs[0] round
     /* 2126245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126248 */     // MIs[0] policy
     /* 2126248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2126261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126284 */     // GIR_Coverage, 17300,
     /* 2126284 */     GIR_EraseRootFromParent_Done,
     /* 2126285 */   // Label 28134: @2126285
     /* 2126285 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2126376), // Rule ID 17301 //
     /* 2126290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2126310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126336 */     // MIs[0] round
     /* 2126336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126339 */     // MIs[0] policy
     /* 2126339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126349 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2126352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126375 */     // GIR_Coverage, 17301,
     /* 2126375 */     GIR_EraseRootFromParent_Done,
     /* 2126376 */   // Label 28135: @2126376
     /* 2126376 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2126467), // Rule ID 17310 //
     /* 2126381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126427 */     // MIs[0] round
     /* 2126427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126430 */     // MIs[0] policy
     /* 2126430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126440 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126466 */     // GIR_Coverage, 17310,
     /* 2126466 */     GIR_EraseRootFromParent_Done,
     /* 2126467 */   // Label 28136: @2126467
     /* 2126467 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2126558), // Rule ID 17311 //
     /* 2126472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126518 */     // MIs[0] round
     /* 2126518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126521 */     // MIs[0] policy
     /* 2126521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126531 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126557 */     // GIR_Coverage, 17311,
     /* 2126557 */     GIR_EraseRootFromParent_Done,
     /* 2126558 */   // Label 28137: @2126558
     /* 2126558 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2126649), // Rule ID 17320 //
     /* 2126563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126609 */     // MIs[0] round
     /* 2126609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126612 */     // MIs[0] policy
     /* 2126612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126622 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126648 */     // GIR_Coverage, 17320,
     /* 2126648 */     GIR_EraseRootFromParent_Done,
     /* 2126649 */   // Label 28138: @2126649
     /* 2126649 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2126740), // Rule ID 17321 //
     /* 2126654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126700 */     // MIs[0] round
     /* 2126700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126703 */     // MIs[0] policy
     /* 2126703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126713 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126739 */     // GIR_Coverage, 17321,
     /* 2126739 */     GIR_EraseRootFromParent_Done,
     /* 2126740 */   // Label 28139: @2126740
     /* 2126740 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2126831), // Rule ID 17330 //
     /* 2126745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126791 */     // MIs[0] round
     /* 2126791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126794 */     // MIs[0] policy
     /* 2126794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126830 */     // GIR_Coverage, 17330,
     /* 2126830 */     GIR_EraseRootFromParent_Done,
     /* 2126831 */   // Label 28140: @2126831
     /* 2126831 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2126922), // Rule ID 17331 //
     /* 2126836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126882 */     // MIs[0] round
     /* 2126882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126885 */     // MIs[0] policy
     /* 2126885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126895 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126921 */     // GIR_Coverage, 17331,
     /* 2126921 */     GIR_EraseRootFromParent_Done,
     /* 2126922 */   // Label 28141: @2126922
     /* 2126922 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2127013), // Rule ID 17340 //
     /* 2126927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126973 */     // MIs[0] round
     /* 2126973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126976 */     // MIs[0] policy
     /* 2126976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126986 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127012 */     // GIR_Coverage, 17340,
     /* 2127012 */     GIR_EraseRootFromParent_Done,
     /* 2127013 */   // Label 28142: @2127013
     /* 2127013 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2127104), // Rule ID 17341 //
     /* 2127018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2127038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127064 */     // MIs[0] round
     /* 2127064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127067 */     // MIs[0] policy
     /* 2127067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127077 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2127080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127103 */     // GIR_Coverage, 17341,
     /* 2127103 */     GIR_EraseRootFromParent_Done,
     /* 2127104 */   // Label 28143: @2127104
     /* 2127104 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2127195), // Rule ID 17350 //
     /* 2127109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127155 */     // MIs[0] round
     /* 2127155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127158 */     // MIs[0] policy
     /* 2127158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127168 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2127171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127194 */     // GIR_Coverage, 17350,
     /* 2127194 */     GIR_EraseRootFromParent_Done,
     /* 2127195 */   // Label 28144: @2127195
     /* 2127195 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2127286), // Rule ID 17351 //
     /* 2127200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2127220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127246 */     // MIs[0] round
     /* 2127246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127249 */     // MIs[0] policy
     /* 2127249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127259 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2127262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127285 */     // GIR_Coverage, 17351,
     /* 2127285 */     GIR_EraseRootFromParent_Done,
     /* 2127286 */   // Label 28145: @2127286
     /* 2127286 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2127377), // Rule ID 17354 //
     /* 2127291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127337 */     // MIs[0] round
     /* 2127337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127340 */     // MIs[0] policy
     /* 2127340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2127353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127376 */     // GIR_Coverage, 17354,
     /* 2127376 */     GIR_EraseRootFromParent_Done,
     /* 2127377 */   // Label 28146: @2127377
     /* 2127377 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2127468), // Rule ID 17355 //
     /* 2127382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127428 */     // MIs[0] round
     /* 2127428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127431 */     // MIs[0] policy
     /* 2127431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127441 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2127444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127467 */     // GIR_Coverage, 17355,
     /* 2127467 */     GIR_EraseRootFromParent_Done,
     /* 2127468 */   // Label 28147: @2127468
     /* 2127468 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2127559), // Rule ID 17358 //
     /* 2127473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127519 */     // MIs[0] round
     /* 2127519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127522 */     // MIs[0] policy
     /* 2127522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127532 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127558 */     // GIR_Coverage, 17358,
     /* 2127558 */     GIR_EraseRootFromParent_Done,
     /* 2127559 */   // Label 28148: @2127559
     /* 2127559 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2127650), // Rule ID 17359 //
     /* 2127564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127610 */     // MIs[0] round
     /* 2127610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127613 */     // MIs[0] policy
     /* 2127613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127623 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127649 */     // GIR_Coverage, 17359,
     /* 2127649 */     GIR_EraseRootFromParent_Done,
     /* 2127650 */   // Label 28149: @2127650
     /* 2127650 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2127741), // Rule ID 17362 //
     /* 2127655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127701 */     // MIs[0] round
     /* 2127701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127704 */     // MIs[0] policy
     /* 2127704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127740 */     // GIR_Coverage, 17362,
     /* 2127740 */     GIR_EraseRootFromParent_Done,
     /* 2127741 */   // Label 28150: @2127741
     /* 2127741 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2127832), // Rule ID 17363 //
     /* 2127746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127792 */     // MIs[0] round
     /* 2127792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127795 */     // MIs[0] policy
     /* 2127795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127805 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127831 */     // GIR_Coverage, 17363,
     /* 2127831 */     GIR_EraseRootFromParent_Done,
     /* 2127832 */   // Label 28151: @2127832
     /* 2127832 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2127923), // Rule ID 17366 //
     /* 2127837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127883 */     // MIs[0] round
     /* 2127883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127886 */     // MIs[0] policy
     /* 2127886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127896 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127922 */     // GIR_Coverage, 17366,
     /* 2127922 */     GIR_EraseRootFromParent_Done,
     /* 2127923 */   // Label 28152: @2127923
     /* 2127923 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2128014), // Rule ID 17367 //
     /* 2127928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127974 */     // MIs[0] round
     /* 2127974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127977 */     // MIs[0] policy
     /* 2127977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127987 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128013 */     // GIR_Coverage, 17367,
     /* 2128013 */     GIR_EraseRootFromParent_Done,
     /* 2128014 */   // Label 28153: @2128014
     /* 2128014 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2128105), // Rule ID 17370 //
     /* 2128019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2128022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128065 */     // MIs[0] round
     /* 2128065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128068 */     // MIs[0] policy
     /* 2128068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128078 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2128081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128104 */     // GIR_Coverage, 17370,
     /* 2128104 */     GIR_EraseRootFromParent_Done,
     /* 2128105 */   // Label 28154: @2128105
     /* 2128105 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2128196), // Rule ID 17371 //
     /* 2128110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2128113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2128121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2128124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2128127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128156 */     // MIs[0] round
     /* 2128156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128159 */     // MIs[0] policy
     /* 2128159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128169 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2128172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128195 */     // GIR_Coverage, 17371,
     /* 2128195 */     GIR_EraseRootFromParent_Done,
     /* 2128196 */   // Label 28155: @2128196
     /* 2128196 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2128287), // Rule ID 17374 //
     /* 2128201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128247 */     // MIs[0] round
     /* 2128247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128250 */     // MIs[0] policy
     /* 2128250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128260 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2128263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128286 */     // GIR_Coverage, 17374,
     /* 2128286 */     GIR_EraseRootFromParent_Done,
     /* 2128287 */   // Label 28156: @2128287
     /* 2128287 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2128378), // Rule ID 17375 //
     /* 2128292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128338 */     // MIs[0] round
     /* 2128338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128341 */     // MIs[0] policy
     /* 2128341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128351 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2128354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128377 */     // GIR_Coverage, 17375,
     /* 2128377 */     GIR_EraseRootFromParent_Done,
     /* 2128378 */   // Label 28157: @2128378
     /* 2128378 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2128469), // Rule ID 17378 //
     /* 2128383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128429 */     // MIs[0] round
     /* 2128429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128432 */     // MIs[0] policy
     /* 2128432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128442 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128468 */     // GIR_Coverage, 17378,
     /* 2128468 */     GIR_EraseRootFromParent_Done,
     /* 2128469 */   // Label 28158: @2128469
     /* 2128469 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2128560), // Rule ID 17379 //
     /* 2128474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128520 */     // MIs[0] round
     /* 2128520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128523 */     // MIs[0] policy
     /* 2128523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128533 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128559 */     // GIR_Coverage, 17379,
     /* 2128559 */     GIR_EraseRootFromParent_Done,
     /* 2128560 */   // Label 28159: @2128560
     /* 2128560 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2128651), // Rule ID 17382 //
     /* 2128565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128611 */     // MIs[0] round
     /* 2128611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128614 */     // MIs[0] policy
     /* 2128614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128650 */     // GIR_Coverage, 17382,
     /* 2128650 */     GIR_EraseRootFromParent_Done,
     /* 2128651 */   // Label 28160: @2128651
     /* 2128651 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2128742), // Rule ID 17383 //
     /* 2128656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128702 */     // MIs[0] round
     /* 2128702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128705 */     // MIs[0] policy
     /* 2128705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128715 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128741 */     // GIR_Coverage, 17383,
     /* 2128741 */     GIR_EraseRootFromParent_Done,
     /* 2128742 */   // Label 28161: @2128742
     /* 2128742 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2128833), // Rule ID 17386 //
     /* 2128747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128793 */     // MIs[0] round
     /* 2128793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128796 */     // MIs[0] policy
     /* 2128796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128806 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128832 */     // GIR_Coverage, 17386,
     /* 2128832 */     GIR_EraseRootFromParent_Done,
     /* 2128833 */   // Label 28162: @2128833
     /* 2128833 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2128924), // Rule ID 17387 //
     /* 2128838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128884 */     // MIs[0] round
     /* 2128884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128887 */     // MIs[0] policy
     /* 2128887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128897 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128923 */     // GIR_Coverage, 17387,
     /* 2128923 */     GIR_EraseRootFromParent_Done,
     /* 2128924 */   // Label 28163: @2128924
     /* 2128924 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2129015), // Rule ID 17390 //
     /* 2128929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128975 */     // MIs[0] round
     /* 2128975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128978 */     // MIs[0] policy
     /* 2128978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128988 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129014 */     // GIR_Coverage, 17390,
     /* 2129014 */     GIR_EraseRootFromParent_Done,
     /* 2129015 */   // Label 28164: @2129015
     /* 2129015 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2129106), // Rule ID 17391 //
     /* 2129020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2129031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2129034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2129037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2129040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129066 */     // MIs[0] round
     /* 2129066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129069 */     // MIs[0] policy
     /* 2129069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129079 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2129082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129105 */     // GIR_Coverage, 17391,
     /* 2129105 */     GIR_EraseRootFromParent_Done,
     /* 2129106 */   // Label 28165: @2129106
     /* 2129106 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2129197), // Rule ID 17394 //
     /* 2129111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2129122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2129125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2129128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129157 */     // MIs[0] round
     /* 2129157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129160 */     // MIs[0] policy
     /* 2129160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129170 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2129173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129196 */     // GIR_Coverage, 17394,
     /* 2129196 */     GIR_EraseRootFromParent_Done,
     /* 2129197 */   // Label 28166: @2129197
     /* 2129197 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2129288), // Rule ID 17395 //
     /* 2129202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2129213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2129216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2129219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2129222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129248 */     // MIs[0] round
     /* 2129248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129251 */     // MIs[0] policy
     /* 2129251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129261 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2129264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129287 */     // GIR_Coverage, 17395,
     /* 2129287 */     GIR_EraseRootFromParent_Done,
     /* 2129288 */   // Label 28167: @2129288
     /* 2129288 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2129379), // Rule ID 17398 //
     /* 2129293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2129313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129339 */     // MIs[0] round
     /* 2129339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129342 */     // MIs[0] policy
     /* 2129342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129352 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2129355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129378 */     // GIR_Coverage, 17398,
     /* 2129378 */     GIR_EraseRootFromParent_Done,
     /* 2129379 */   // Label 28168: @2129379
     /* 2129379 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2129470), // Rule ID 17399 //
     /* 2129384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2129395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2129398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2129401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2129404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129430 */     // MIs[0] round
     /* 2129430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129433 */     // MIs[0] policy
     /* 2129433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129443 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2129446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129469 */     // GIR_Coverage, 17399,
     /* 2129469 */     GIR_EraseRootFromParent_Done,
     /* 2129470 */   // Label 28169: @2129470
     /* 2129470 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2129561), // Rule ID 17402 //
     /* 2129475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129521 */     // MIs[0] round
     /* 2129521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129524 */     // MIs[0] policy
     /* 2129524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129560 */     // GIR_Coverage, 17402,
     /* 2129560 */     GIR_EraseRootFromParent_Done,
     /* 2129561 */   // Label 28170: @2129561
     /* 2129561 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2129652), // Rule ID 17403 //
     /* 2129566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129612 */     // MIs[0] round
     /* 2129612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129615 */     // MIs[0] policy
     /* 2129615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129625 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129651 */     // GIR_Coverage, 17403,
     /* 2129651 */     GIR_EraseRootFromParent_Done,
     /* 2129652 */   // Label 28171: @2129652
     /* 2129652 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2129743), // Rule ID 17406 //
     /* 2129657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129703 */     // MIs[0] round
     /* 2129703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129706 */     // MIs[0] policy
     /* 2129706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129742 */     // GIR_Coverage, 17406,
     /* 2129742 */     GIR_EraseRootFromParent_Done,
     /* 2129743 */   // Label 28172: @2129743
     /* 2129743 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2129834), // Rule ID 17407 //
     /* 2129748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129794 */     // MIs[0] round
     /* 2129794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129797 */     // MIs[0] policy
     /* 2129797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129833 */     // GIR_Coverage, 17407,
     /* 2129833 */     GIR_EraseRootFromParent_Done,
     /* 2129834 */   // Label 28173: @2129834
     /* 2129834 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2129925), // Rule ID 17410 //
     /* 2129839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129885 */     // MIs[0] round
     /* 2129885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129888 */     // MIs[0] policy
     /* 2129888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129924 */     // GIR_Coverage, 17410,
     /* 2129924 */     GIR_EraseRootFromParent_Done,
     /* 2129925 */   // Label 28174: @2129925
     /* 2129925 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2130016), // Rule ID 17411 //
     /* 2129930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129976 */     // MIs[0] round
     /* 2129976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129979 */     // MIs[0] policy
     /* 2129979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129989 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130015 */     // GIR_Coverage, 17411,
     /* 2130015 */     GIR_EraseRootFromParent_Done,
     /* 2130016 */   // Label 28175: @2130016
     /* 2130016 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2130107), // Rule ID 17414 //
     /* 2130021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2130041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130067 */     // MIs[0] round
     /* 2130067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130070 */     // MIs[0] policy
     /* 2130070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130080 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2130083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130106 */     // GIR_Coverage, 17414,
     /* 2130106 */     GIR_EraseRootFromParent_Done,
     /* 2130107 */   // Label 28176: @2130107
     /* 2130107 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2130198), // Rule ID 17415 //
     /* 2130112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2130132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130158 */     // MIs[0] round
     /* 2130158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130161 */     // MIs[0] policy
     /* 2130161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130171 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2130174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130197 */     // GIR_Coverage, 17415,
     /* 2130197 */     GIR_EraseRootFromParent_Done,
     /* 2130198 */   // Label 28177: @2130198
     /* 2130198 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2130289), // Rule ID 17418 //
     /* 2130203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2130214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2130217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2130220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2130223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130249 */     // MIs[0] round
     /* 2130249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130252 */     // MIs[0] policy
     /* 2130252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130262 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2130265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130288 */     // GIR_Coverage, 17418,
     /* 2130288 */     GIR_EraseRootFromParent_Done,
     /* 2130289 */   // Label 28178: @2130289
     /* 2130289 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2130380), // Rule ID 17419 //
     /* 2130294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2130305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2130308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2130311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2130314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130340 */     // MIs[0] round
     /* 2130340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130343 */     // MIs[0] policy
     /* 2130343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130353 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2130356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130379 */     // GIR_Coverage, 17419,
     /* 2130379 */     GIR_EraseRootFromParent_Done,
     /* 2130380 */   // Label 28179: @2130380
     /* 2130380 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2130471), // Rule ID 17422 //
     /* 2130385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130431 */     // MIs[0] round
     /* 2130431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130434 */     // MIs[0] policy
     /* 2130434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130444 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130470 */     // GIR_Coverage, 17422,
     /* 2130470 */     GIR_EraseRootFromParent_Done,
     /* 2130471 */   // Label 28180: @2130471
     /* 2130471 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2130562), // Rule ID 17423 //
     /* 2130476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130522 */     // MIs[0] round
     /* 2130522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130525 */     // MIs[0] policy
     /* 2130525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130535 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130561 */     // GIR_Coverage, 17423,
     /* 2130561 */     GIR_EraseRootFromParent_Done,
     /* 2130562 */   // Label 28181: @2130562
     /* 2130562 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2130653), // Rule ID 17426 //
     /* 2130567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130613 */     // MIs[0] round
     /* 2130613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130616 */     // MIs[0] policy
     /* 2130616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130626 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130652 */     // GIR_Coverage, 17426,
     /* 2130652 */     GIR_EraseRootFromParent_Done,
     /* 2130653 */   // Label 28182: @2130653
     /* 2130653 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2130744), // Rule ID 17427 //
     /* 2130658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130704 */     // MIs[0] round
     /* 2130704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130707 */     // MIs[0] policy
     /* 2130707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130717 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130743 */     // GIR_Coverage, 17427,
     /* 2130743 */     GIR_EraseRootFromParent_Done,
     /* 2130744 */   // Label 28183: @2130744
     /* 2130744 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2130835), // Rule ID 17430 //
     /* 2130749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130795 */     // MIs[0] round
     /* 2130795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130798 */     // MIs[0] policy
     /* 2130798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130834 */     // GIR_Coverage, 17430,
     /* 2130834 */     GIR_EraseRootFromParent_Done,
     /* 2130835 */   // Label 28184: @2130835
     /* 2130835 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2130926), // Rule ID 17431 //
     /* 2130840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130886 */     // MIs[0] round
     /* 2130886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130889 */     // MIs[0] policy
     /* 2130889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130899 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130925 */     // GIR_Coverage, 17431,
     /* 2130925 */     GIR_EraseRootFromParent_Done,
     /* 2130926 */   // Label 28185: @2130926
     /* 2130926 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2131017), // Rule ID 17434 //
     /* 2130931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130977 */     // MIs[0] round
     /* 2130977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130980 */     // MIs[0] policy
     /* 2130980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130990 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2130993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131016 */     // GIR_Coverage, 17434,
     /* 2131016 */     GIR_EraseRootFromParent_Done,
     /* 2131017 */   // Label 28186: @2131017
     /* 2131017 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2131108), // Rule ID 17435 //
     /* 2131022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2131042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131068 */     // MIs[0] round
     /* 2131068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131071 */     // MIs[0] policy
     /* 2131071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131081 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2131084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131107 */     // GIR_Coverage, 17435,
     /* 2131107 */     GIR_EraseRootFromParent_Done,
     /* 2131108 */   // Label 28187: @2131108
     /* 2131108 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2131199), // Rule ID 17438 //
     /* 2131113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2131133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131159 */     // MIs[0] round
     /* 2131159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131162 */     // MIs[0] policy
     /* 2131162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131172 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2131175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131198 */     // GIR_Coverage, 17438,
     /* 2131198 */     GIR_EraseRootFromParent_Done,
     /* 2131199 */   // Label 28188: @2131199
     /* 2131199 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2131290), // Rule ID 17439 //
     /* 2131204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2131224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131250 */     // MIs[0] round
     /* 2131250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131253 */     // MIs[0] policy
     /* 2131253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131263 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2131266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131289 */     // GIR_Coverage, 17439,
     /* 2131289 */     GIR_EraseRootFromParent_Done,
     /* 2131290 */   // Label 28189: @2131290
     /* 2131290 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2131381), // Rule ID 17442 //
     /* 2131295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2131306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2131309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2131312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2131315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131341 */     // MIs[0] round
     /* 2131341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131344 */     // MIs[0] policy
     /* 2131344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131354 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2131357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131380 */     // GIR_Coverage, 17442,
     /* 2131380 */     GIR_EraseRootFromParent_Done,
     /* 2131381 */   // Label 28190: @2131381
     /* 2131381 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2131472), // Rule ID 17443 //
     /* 2131386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2131397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2131400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2131403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2131406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131432 */     // MIs[0] round
     /* 2131432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131435 */     // MIs[0] policy
     /* 2131435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131445 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2131448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131471 */     // GIR_Coverage, 17443,
     /* 2131471 */     GIR_EraseRootFromParent_Done,
     /* 2131472 */   // Label 28191: @2131472
     /* 2131472 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2131563), // Rule ID 17446 //
     /* 2131477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131523 */     // MIs[0] round
     /* 2131523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131526 */     // MIs[0] policy
     /* 2131526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131536 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131562 */     // GIR_Coverage, 17446,
     /* 2131562 */     GIR_EraseRootFromParent_Done,
     /* 2131563 */   // Label 28192: @2131563
     /* 2131563 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2131654), // Rule ID 17447 //
     /* 2131568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131614 */     // MIs[0] round
     /* 2131614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131617 */     // MIs[0] policy
     /* 2131617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131627 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131653 */     // GIR_Coverage, 17447,
     /* 2131653 */     GIR_EraseRootFromParent_Done,
     /* 2131654 */   // Label 28193: @2131654
     /* 2131654 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2131745), // Rule ID 17450 //
     /* 2131659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131705 */     // MIs[0] round
     /* 2131705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131708 */     // MIs[0] policy
     /* 2131708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131718 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131744 */     // GIR_Coverage, 17450,
     /* 2131744 */     GIR_EraseRootFromParent_Done,
     /* 2131745 */   // Label 28194: @2131745
     /* 2131745 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2131836), // Rule ID 17451 //
     /* 2131750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131796 */     // MIs[0] round
     /* 2131796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131799 */     // MIs[0] policy
     /* 2131799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131809 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131835 */     // GIR_Coverage, 17451,
     /* 2131835 */     GIR_EraseRootFromParent_Done,
     /* 2131836 */   // Label 28195: @2131836
     /* 2131836 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2131927), // Rule ID 17454 //
     /* 2131841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131887 */     // MIs[0] round
     /* 2131887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131890 */     // MIs[0] policy
     /* 2131890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131900 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131926 */     // GIR_Coverage, 17454,
     /* 2131926 */     GIR_EraseRootFromParent_Done,
     /* 2131927 */   // Label 28196: @2131927
     /* 2131927 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2132018), // Rule ID 17455 //
     /* 2131932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131978 */     // MIs[0] round
     /* 2131978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131981 */     // MIs[0] policy
     /* 2131981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131991 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132017 */     // GIR_Coverage, 17455,
     /* 2132017 */     GIR_EraseRootFromParent_Done,
     /* 2132018 */   // Label 28197: @2132018
     /* 2132018 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2132109), // Rule ID 17458 //
     /* 2132023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132069 */     // MIs[0] round
     /* 2132069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132072 */     // MIs[0] policy
     /* 2132072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2132085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132108 */     // GIR_Coverage, 17458,
     /* 2132108 */     GIR_EraseRootFromParent_Done,
     /* 2132109 */   // Label 28198: @2132109
     /* 2132109 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2132200), // Rule ID 17459 //
     /* 2132114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132160 */     // MIs[0] round
     /* 2132160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132163 */     // MIs[0] policy
     /* 2132163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132173 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2132176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132199 */     // GIR_Coverage, 17459,
     /* 2132199 */     GIR_EraseRootFromParent_Done,
     /* 2132200 */   // Label 28199: @2132200
     /* 2132200 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2132291), // Rule ID 17462 //
     /* 2132205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132251 */     // MIs[0] round
     /* 2132251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132254 */     // MIs[0] policy
     /* 2132254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132264 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2132267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132290 */     // GIR_Coverage, 17462,
     /* 2132290 */     GIR_EraseRootFromParent_Done,
     /* 2132291 */   // Label 28200: @2132291
     /* 2132291 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2132382), // Rule ID 17463 //
     /* 2132296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2132307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2132310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132342 */     // MIs[0] round
     /* 2132342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132345 */     // MIs[0] policy
     /* 2132345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132355 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2132358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132381 */     // GIR_Coverage, 17463,
     /* 2132381 */     GIR_EraseRootFromParent_Done,
     /* 2132382 */   // Label 28201: @2132382
     /* 2132382 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2132473), // Rule ID 17466 //
     /* 2132387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132433 */     // MIs[0] round
     /* 2132433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132436 */     // MIs[0] policy
     /* 2132436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132446 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132472 */     // GIR_Coverage, 17466,
     /* 2132472 */     GIR_EraseRootFromParent_Done,
     /* 2132473 */   // Label 28202: @2132473
     /* 2132473 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2132564), // Rule ID 17467 //
     /* 2132478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132524 */     // MIs[0] round
     /* 2132524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132527 */     // MIs[0] policy
     /* 2132527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132537 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132563 */     // GIR_Coverage, 17467,
     /* 2132563 */     GIR_EraseRootFromParent_Done,
     /* 2132564 */   // Label 28203: @2132564
     /* 2132564 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2132655), // Rule ID 17470 //
     /* 2132569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132615 */     // MIs[0] round
     /* 2132615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132618 */     // MIs[0] policy
     /* 2132618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132628 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132654 */     // GIR_Coverage, 17470,
     /* 2132654 */     GIR_EraseRootFromParent_Done,
     /* 2132655 */   // Label 28204: @2132655
     /* 2132655 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2132746), // Rule ID 17471 //
     /* 2132660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132706 */     // MIs[0] round
     /* 2132706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132709 */     // MIs[0] policy
     /* 2132709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132719 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132745 */     // GIR_Coverage, 17471,
     /* 2132745 */     GIR_EraseRootFromParent_Done,
     /* 2132746 */   // Label 28205: @2132746
     /* 2132746 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2132837), // Rule ID 17474 //
     /* 2132751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132797 */     // MIs[0] round
     /* 2132797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132800 */     // MIs[0] policy
     /* 2132800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132810 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132836 */     // GIR_Coverage, 17474,
     /* 2132836 */     GIR_EraseRootFromParent_Done,
     /* 2132837 */   // Label 28206: @2132837
     /* 2132837 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2132928), // Rule ID 17475 //
     /* 2132842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132888 */     // MIs[0] round
     /* 2132888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132891 */     // MIs[0] policy
     /* 2132891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132901 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132927 */     // GIR_Coverage, 17475,
     /* 2132927 */     GIR_EraseRootFromParent_Done,
     /* 2132928 */   // Label 28207: @2132928
     /* 2132928 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2133019), // Rule ID 17478 //
     /* 2132933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132979 */     // MIs[0] round
     /* 2132979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132982 */     // MIs[0] policy
     /* 2132982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132992 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2132995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133018 */     // GIR_Coverage, 17478,
     /* 2133018 */     GIR_EraseRootFromParent_Done,
     /* 2133019 */   // Label 28208: @2133019
     /* 2133019 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2133110), // Rule ID 17479 //
     /* 2133024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133070 */     // MIs[0] round
     /* 2133070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133073 */     // MIs[0] policy
     /* 2133073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133083 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2133086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133109 */     // GIR_Coverage, 17479,
     /* 2133109 */     GIR_EraseRootFromParent_Done,
     /* 2133110 */   // Label 28209: @2133110
     /* 2133110 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2133201), // Rule ID 17482 //
     /* 2133115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133161 */     // MIs[0] round
     /* 2133161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133164 */     // MIs[0] policy
     /* 2133164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133174 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2133177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133200 */     // GIR_Coverage, 17482,
     /* 2133200 */     GIR_EraseRootFromParent_Done,
     /* 2133201 */   // Label 28210: @2133201
     /* 2133201 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2133292), // Rule ID 17483 //
     /* 2133206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133252 */     // MIs[0] round
     /* 2133252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133255 */     // MIs[0] policy
     /* 2133255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133265 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2133268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133291 */     // GIR_Coverage, 17483,
     /* 2133291 */     GIR_EraseRootFromParent_Done,
     /* 2133292 */   // Label 28211: @2133292
     /* 2133292 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2133383), // Rule ID 17486 //
     /* 2133297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2133308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2133311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133343 */     // MIs[0] round
     /* 2133343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133346 */     // MIs[0] policy
     /* 2133346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2133359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133382 */     // GIR_Coverage, 17486,
     /* 2133382 */     GIR_EraseRootFromParent_Done,
     /* 2133383 */   // Label 28212: @2133383
     /* 2133383 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2133474), // Rule ID 17487 //
     /* 2133388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2133399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2133402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133434 */     // MIs[0] round
     /* 2133434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133437 */     // MIs[0] policy
     /* 2133437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133447 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2133450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133473 */     // GIR_Coverage, 17487,
     /* 2133473 */     GIR_EraseRootFromParent_Done,
     /* 2133474 */   // Label 28213: @2133474
     /* 2133474 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2133565), // Rule ID 17490 //
     /* 2133479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133525 */     // MIs[0] round
     /* 2133525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133528 */     // MIs[0] policy
     /* 2133528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133538 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133564 */     // GIR_Coverage, 17490,
     /* 2133564 */     GIR_EraseRootFromParent_Done,
     /* 2133565 */   // Label 28214: @2133565
     /* 2133565 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2133656), // Rule ID 17491 //
     /* 2133570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133616 */     // MIs[0] round
     /* 2133616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133619 */     // MIs[0] policy
     /* 2133619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133629 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133655 */     // GIR_Coverage, 17491,
     /* 2133655 */     GIR_EraseRootFromParent_Done,
     /* 2133656 */   // Label 28215: @2133656
     /* 2133656 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2133747), // Rule ID 17494 //
     /* 2133661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133707 */     // MIs[0] round
     /* 2133707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133710 */     // MIs[0] policy
     /* 2133710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133746 */     // GIR_Coverage, 17494,
     /* 2133746 */     GIR_EraseRootFromParent_Done,
     /* 2133747 */   // Label 28216: @2133747
     /* 2133747 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2133838), // Rule ID 17495 //
     /* 2133752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133798 */     // MIs[0] round
     /* 2133798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133801 */     // MIs[0] policy
     /* 2133801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133811 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133837 */     // GIR_Coverage, 17495,
     /* 2133837 */     GIR_EraseRootFromParent_Done,
     /* 2133838 */   // Label 28217: @2133838
     /* 2133838 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2133929), // Rule ID 17498 //
     /* 2133843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133889 */     // MIs[0] round
     /* 2133889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133892 */     // MIs[0] policy
     /* 2133892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133928 */     // GIR_Coverage, 17498,
     /* 2133928 */     GIR_EraseRootFromParent_Done,
     /* 2133929 */   // Label 28218: @2133929
     /* 2133929 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2134020), // Rule ID 17499 //
     /* 2133934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133980 */     // MIs[0] round
     /* 2133980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133983 */     // MIs[0] policy
     /* 2133983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134019 */     // GIR_Coverage, 17499,
     /* 2134019 */     GIR_EraseRootFromParent_Done,
     /* 2134020 */   // Label 28219: @2134020
     /* 2134020 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2134111), // Rule ID 17502 //
     /* 2134025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134071 */     // MIs[0] round
     /* 2134071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134074 */     // MIs[0] policy
     /* 2134074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134084 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2134087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134110 */     // GIR_Coverage, 17502,
     /* 2134110 */     GIR_EraseRootFromParent_Done,
     /* 2134111 */   // Label 28220: @2134111
     /* 2134111 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2134202), // Rule ID 17503 //
     /* 2134116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134162 */     // MIs[0] round
     /* 2134162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134165 */     // MIs[0] policy
     /* 2134165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134175 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2134178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134201 */     // GIR_Coverage, 17503,
     /* 2134201 */     GIR_EraseRootFromParent_Done,
     /* 2134202 */   // Label 28221: @2134202
     /* 2134202 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2134293), // Rule ID 17506 //
     /* 2134207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134253 */     // MIs[0] round
     /* 2134253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134256 */     // MIs[0] policy
     /* 2134256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2134269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134292 */     // GIR_Coverage, 17506,
     /* 2134292 */     GIR_EraseRootFromParent_Done,
     /* 2134293 */   // Label 28222: @2134293
     /* 2134293 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2134384), // Rule ID 17507 //
     /* 2134298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2134306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2134315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134344 */     // MIs[0] round
     /* 2134344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134347 */     // MIs[0] policy
     /* 2134347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2134360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134383 */     // GIR_Coverage, 17507,
     /* 2134383 */     GIR_EraseRootFromParent_Done,
     /* 2134384 */   // Label 28223: @2134384
     /* 2134384 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2134475), // Rule ID 17510 //
     /* 2134389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134435 */     // MIs[0] round
     /* 2134435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134438 */     // MIs[0] policy
     /* 2134438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134448 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134474 */     // GIR_Coverage, 17510,
     /* 2134474 */     GIR_EraseRootFromParent_Done,
     /* 2134475 */   // Label 28224: @2134475
     /* 2134475 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2134566), // Rule ID 17511 //
     /* 2134480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134526 */     // MIs[0] round
     /* 2134526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134529 */     // MIs[0] policy
     /* 2134529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134539 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134565 */     // GIR_Coverage, 17511,
     /* 2134565 */     GIR_EraseRootFromParent_Done,
     /* 2134566 */   // Label 28225: @2134566
     /* 2134566 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2134657), // Rule ID 17514 //
     /* 2134571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134617 */     // MIs[0] round
     /* 2134617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134620 */     // MIs[0] policy
     /* 2134620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134630 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134656 */     // GIR_Coverage, 17514,
     /* 2134656 */     GIR_EraseRootFromParent_Done,
     /* 2134657 */   // Label 28226: @2134657
     /* 2134657 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2134748), // Rule ID 17515 //
     /* 2134662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134708 */     // MIs[0] round
     /* 2134708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134711 */     // MIs[0] policy
     /* 2134711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134721 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134747 */     // GIR_Coverage, 17515,
     /* 2134747 */     GIR_EraseRootFromParent_Done,
     /* 2134748 */   // Label 28227: @2134748
     /* 2134748 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2134839), // Rule ID 17518 //
     /* 2134753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134799 */     // MIs[0] round
     /* 2134799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134802 */     // MIs[0] policy
     /* 2134802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134812 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134838 */     // GIR_Coverage, 17518,
     /* 2134838 */     GIR_EraseRootFromParent_Done,
     /* 2134839 */   // Label 28228: @2134839
     /* 2134839 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2134930), // Rule ID 17519 //
     /* 2134844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134890 */     // MIs[0] round
     /* 2134890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134893 */     // MIs[0] policy
     /* 2134893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134903 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134929 */     // GIR_Coverage, 17519,
     /* 2134929 */     GIR_EraseRootFromParent_Done,
     /* 2134930 */   // Label 28229: @2134930
     /* 2134930 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2135021), // Rule ID 17522 //
     /* 2134935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134981 */     // MIs[0] round
     /* 2134981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134984 */     // MIs[0] policy
     /* 2134984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134994 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2134997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135020 */     // GIR_Coverage, 17522,
     /* 2135020 */     GIR_EraseRootFromParent_Done,
     /* 2135021 */   // Label 28230: @2135021
     /* 2135021 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2135112), // Rule ID 17523 //
     /* 2135026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2135037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2135040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2135046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135072 */     // MIs[0] round
     /* 2135072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135075 */     // MIs[0] policy
     /* 2135075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135085 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2135088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135111 */     // GIR_Coverage, 17523,
     /* 2135111 */     GIR_EraseRootFromParent_Done,
     /* 2135112 */   // Label 28231: @2135112
     /* 2135112 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2135203), // Rule ID 17526 //
     /* 2135117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2135137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135163 */     // MIs[0] round
     /* 2135163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135166 */     // MIs[0] policy
     /* 2135166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2135179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135202 */     // GIR_Coverage, 17526,
     /* 2135202 */     GIR_EraseRootFromParent_Done,
     /* 2135203 */   // Label 28232: @2135203
     /* 2135203 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2135294), // Rule ID 17527 //
     /* 2135208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2135225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2135228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135254 */     // MIs[0] round
     /* 2135254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135257 */     // MIs[0] policy
     /* 2135257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135267 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2135270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135293 */     // GIR_Coverage, 17527,
     /* 2135293 */     GIR_EraseRootFromParent_Done,
     /* 2135294 */   // Label 28233: @2135294
     /* 2135294 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2135385), // Rule ID 17530 //
     /* 2135299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2135302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2135310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2135319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135345 */     // MIs[0] round
     /* 2135345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135348 */     // MIs[0] policy
     /* 2135348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135358 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2135361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135384 */     // GIR_Coverage, 17530,
     /* 2135384 */     GIR_EraseRootFromParent_Done,
     /* 2135385 */   // Label 28234: @2135385
     /* 2135385 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2135476), // Rule ID 17531 //
     /* 2135390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2135393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2135401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2135404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2135407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2135410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135436 */     // MIs[0] round
     /* 2135436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135439 */     // MIs[0] policy
     /* 2135439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135449 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2135452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135475 */     // GIR_Coverage, 17531,
     /* 2135475 */     GIR_EraseRootFromParent_Done,
     /* 2135476 */   // Label 28235: @2135476
     /* 2135476 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2135567), // Rule ID 17534 //
     /* 2135481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135527 */     // MIs[0] round
     /* 2135527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135530 */     // MIs[0] policy
     /* 2135530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135540 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135566 */     // GIR_Coverage, 17534,
     /* 2135566 */     GIR_EraseRootFromParent_Done,
     /* 2135567 */   // Label 28236: @2135567
     /* 2135567 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2135658), // Rule ID 17535 //
     /* 2135572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135618 */     // MIs[0] round
     /* 2135618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135621 */     // MIs[0] policy
     /* 2135621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135631 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135657 */     // GIR_Coverage, 17535,
     /* 2135657 */     GIR_EraseRootFromParent_Done,
     /* 2135658 */   // Label 28237: @2135658
     /* 2135658 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2135749), // Rule ID 17538 //
     /* 2135663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135709 */     // MIs[0] round
     /* 2135709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135712 */     // MIs[0] policy
     /* 2135712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135722 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135748 */     // GIR_Coverage, 17538,
     /* 2135748 */     GIR_EraseRootFromParent_Done,
     /* 2135749 */   // Label 28238: @2135749
     /* 2135749 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2135840), // Rule ID 17539 //
     /* 2135754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135800 */     // MIs[0] round
     /* 2135800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135803 */     // MIs[0] policy
     /* 2135803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135813 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135839 */     // GIR_Coverage, 17539,
     /* 2135839 */     GIR_EraseRootFromParent_Done,
     /* 2135840 */   // Label 28239: @2135840
     /* 2135840 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2135931), // Rule ID 17542 //
     /* 2135845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135891 */     // MIs[0] round
     /* 2135891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135894 */     // MIs[0] policy
     /* 2135894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135904 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135930 */     // GIR_Coverage, 17542,
     /* 2135930 */     GIR_EraseRootFromParent_Done,
     /* 2135931 */   // Label 28240: @2135931
     /* 2135931 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2136022), // Rule ID 17543 //
     /* 2135936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135982 */     // MIs[0] round
     /* 2135982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135985 */     // MIs[0] policy
     /* 2135985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135995 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136021 */     // GIR_Coverage, 17543,
     /* 2136021 */     GIR_EraseRootFromParent_Done,
     /* 2136022 */   // Label 28241: @2136022
     /* 2136022 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2136113), // Rule ID 17546 //
     /* 2136027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136073 */     // MIs[0] round
     /* 2136073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136076 */     // MIs[0] policy
     /* 2136076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136086 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2136089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136112 */     // GIR_Coverage, 17546,
     /* 2136112 */     GIR_EraseRootFromParent_Done,
     /* 2136113 */   // Label 28242: @2136113
     /* 2136113 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2136204), // Rule ID 17547 //
     /* 2136118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2136129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2136132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136164 */     // MIs[0] round
     /* 2136164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136167 */     // MIs[0] policy
     /* 2136167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136177 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2136180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136203 */     // GIR_Coverage, 17547,
     /* 2136203 */     GIR_EraseRootFromParent_Done,
     /* 2136204 */   // Label 28243: @2136204
     /* 2136204 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2136295), // Rule ID 17550 //
     /* 2136209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136255 */     // MIs[0] round
     /* 2136255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136258 */     // MIs[0] policy
     /* 2136258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136268 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2136271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136294 */     // GIR_Coverage, 17550,
     /* 2136294 */     GIR_EraseRootFromParent_Done,
     /* 2136295 */   // Label 28244: @2136295
     /* 2136295 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2136386), // Rule ID 17551 //
     /* 2136300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2136311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2136314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136346 */     // MIs[0] round
     /* 2136346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136349 */     // MIs[0] policy
     /* 2136349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136359 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2136362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136385 */     // GIR_Coverage, 17551,
     /* 2136385 */     GIR_EraseRootFromParent_Done,
     /* 2136386 */   // Label 28245: @2136386
     /* 2136386 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2136477), // Rule ID 17554 //
     /* 2136391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2136394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136437 */     // MIs[0] round
     /* 2136437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136440 */     // MIs[0] policy
     /* 2136440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136450 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136476 */     // GIR_Coverage, 17554,
     /* 2136476 */     GIR_EraseRootFromParent_Done,
     /* 2136477 */   // Label 28246: @2136477
     /* 2136477 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2136568), // Rule ID 17555 //
     /* 2136482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136528 */     // MIs[0] round
     /* 2136528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136531 */     // MIs[0] policy
     /* 2136531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136541 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136567 */     // GIR_Coverage, 17555,
     /* 2136567 */     GIR_EraseRootFromParent_Done,
     /* 2136568 */   // Label 28247: @2136568
     /* 2136568 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2136659), // Rule ID 17558 //
     /* 2136573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136619 */     // MIs[0] round
     /* 2136619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136622 */     // MIs[0] policy
     /* 2136622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136658 */     // GIR_Coverage, 17558,
     /* 2136658 */     GIR_EraseRootFromParent_Done,
     /* 2136659 */   // Label 28248: @2136659
     /* 2136659 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2136750), // Rule ID 17559 //
     /* 2136664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136710 */     // MIs[0] round
     /* 2136710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136713 */     // MIs[0] policy
     /* 2136713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136723 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136749 */     // GIR_Coverage, 17559,
     /* 2136749 */     GIR_EraseRootFromParent_Done,
     /* 2136750 */   // Label 28249: @2136750
     /* 2136750 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2136841), // Rule ID 17562 //
     /* 2136755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136801 */     // MIs[0] round
     /* 2136801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136804 */     // MIs[0] policy
     /* 2136804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136814 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136840 */     // GIR_Coverage, 17562,
     /* 2136840 */     GIR_EraseRootFromParent_Done,
     /* 2136841 */   // Label 28250: @2136841
     /* 2136841 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2136932), // Rule ID 17563 //
     /* 2136846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136892 */     // MIs[0] round
     /* 2136892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136895 */     // MIs[0] policy
     /* 2136895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136905 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136931 */     // GIR_Coverage, 17563,
     /* 2136931 */     GIR_EraseRootFromParent_Done,
     /* 2136932 */   // Label 28251: @2136932
     /* 2136932 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2137023), // Rule ID 17566 //
     /* 2136937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136983 */     // MIs[0] round
     /* 2136983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136986 */     // MIs[0] policy
     /* 2136986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2136999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137022 */     // GIR_Coverage, 17566,
     /* 2137022 */     GIR_EraseRootFromParent_Done,
     /* 2137023 */   // Label 28252: @2137023
     /* 2137023 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2137114), // Rule ID 17567 //
     /* 2137028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2137039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2137042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2137045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2137048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137074 */     // MIs[0] round
     /* 2137074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137077 */     // MIs[0] policy
     /* 2137077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137087 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2137090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137113 */     // GIR_Coverage, 17567,
     /* 2137113 */     GIR_EraseRootFromParent_Done,
     /* 2137114 */   // Label 28253: @2137114
     /* 2137114 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2137205), // Rule ID 17570 //
     /* 2137119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137165 */     // MIs[0] round
     /* 2137165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137168 */     // MIs[0] policy
     /* 2137168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137178 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2137181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137204 */     // GIR_Coverage, 17570,
     /* 2137204 */     GIR_EraseRootFromParent_Done,
     /* 2137205 */   // Label 28254: @2137205
     /* 2137205 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2137296), // Rule ID 17571 //
     /* 2137210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2137221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2137224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2137227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137256 */     // MIs[0] round
     /* 2137256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137259 */     // MIs[0] policy
     /* 2137259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137269 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2137272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137295 */     // GIR_Coverage, 17571,
     /* 2137295 */     GIR_EraseRootFromParent_Done,
     /* 2137296 */   // Label 28255: @2137296
     /* 2137296 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2137387), // Rule ID 17574 //
     /* 2137301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2137312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137347 */     // MIs[0] round
     /* 2137347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137350 */     // MIs[0] policy
     /* 2137350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137360 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2137363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137386 */     // GIR_Coverage, 17574,
     /* 2137386 */     GIR_EraseRootFromParent_Done,
     /* 2137387 */   // Label 28256: @2137387
     /* 2137387 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2137478), // Rule ID 17575 //
     /* 2137392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2137403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2137406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137438 */     // MIs[0] round
     /* 2137438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137441 */     // MIs[0] policy
     /* 2137441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137451 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2137454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137477 */     // GIR_Coverage, 17575,
     /* 2137477 */     GIR_EraseRootFromParent_Done,
     /* 2137478 */   // Label 28257: @2137478
     /* 2137478 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2137569), // Rule ID 17578 //
     /* 2137483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137529 */     // MIs[0] round
     /* 2137529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137532 */     // MIs[0] policy
     /* 2137532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137542 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137568 */     // GIR_Coverage, 17578,
     /* 2137568 */     GIR_EraseRootFromParent_Done,
     /* 2137569 */   // Label 28258: @2137569
     /* 2137569 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2137660), // Rule ID 17579 //
     /* 2137574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137620 */     // MIs[0] round
     /* 2137620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137623 */     // MIs[0] policy
     /* 2137623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137633 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137659 */     // GIR_Coverage, 17579,
     /* 2137659 */     GIR_EraseRootFromParent_Done,
     /* 2137660 */   // Label 28259: @2137660
     /* 2137660 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2137751), // Rule ID 17582 //
     /* 2137665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137711 */     // MIs[0] round
     /* 2137711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137714 */     // MIs[0] policy
     /* 2137714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137750 */     // GIR_Coverage, 17582,
     /* 2137750 */     GIR_EraseRootFromParent_Done,
     /* 2137751 */   // Label 28260: @2137751
     /* 2137751 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2137842), // Rule ID 17583 //
     /* 2137756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137802 */     // MIs[0] round
     /* 2137802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137805 */     // MIs[0] policy
     /* 2137805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137815 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137841 */     // GIR_Coverage, 17583,
     /* 2137841 */     GIR_EraseRootFromParent_Done,
     /* 2137842 */   // Label 28261: @2137842
     /* 2137842 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2137933), // Rule ID 17586 //
     /* 2137847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137893 */     // MIs[0] round
     /* 2137893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137896 */     // MIs[0] policy
     /* 2137896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137906 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137932 */     // GIR_Coverage, 17586,
     /* 2137932 */     GIR_EraseRootFromParent_Done,
     /* 2137933 */   // Label 28262: @2137933
     /* 2137933 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2138024), // Rule ID 17587 //
     /* 2137938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137984 */     // MIs[0] round
     /* 2137984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137987 */     // MIs[0] policy
     /* 2137987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137997 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2138000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138023 */     // GIR_Coverage, 17587,
     /* 2138023 */     GIR_EraseRootFromParent_Done,
     /* 2138024 */   // Label 28263: @2138024
     /* 2138024 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2138115), // Rule ID 17590 //
     /* 2138029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138075 */     // MIs[0] round
     /* 2138075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138078 */     // MIs[0] policy
     /* 2138078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138088 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2138091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138114 */     // GIR_Coverage, 17590,
     /* 2138114 */     GIR_EraseRootFromParent_Done,
     /* 2138115 */   // Label 28264: @2138115
     /* 2138115 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2138206), // Rule ID 17591 //
     /* 2138120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2138131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2138134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2138137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138166 */     // MIs[0] round
     /* 2138166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138169 */     // MIs[0] policy
     /* 2138169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2138182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138205 */     // GIR_Coverage, 17591,
     /* 2138205 */     GIR_EraseRootFromParent_Done,
     /* 2138206 */   // Label 28265: @2138206
     /* 2138206 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2138297), // Rule ID 17594 //
     /* 2138211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138257 */     // MIs[0] round
     /* 2138257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138260 */     // MIs[0] policy
     /* 2138260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2138273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138296 */     // GIR_Coverage, 17594,
     /* 2138296 */     GIR_EraseRootFromParent_Done,
     /* 2138297 */   // Label 28266: @2138297
     /* 2138297 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2138388), // Rule ID 17595 //
     /* 2138302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2138313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2138316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2138319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138348 */     // MIs[0] round
     /* 2138348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138351 */     // MIs[0] policy
     /* 2138351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138361 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2138364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138387 */     // GIR_Coverage, 17595,
     /* 2138387 */     GIR_EraseRootFromParent_Done,
     /* 2138388 */   // Label 28267: @2138388
     /* 2138388 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2138479), // Rule ID 17598 //
     /* 2138393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138439 */     // MIs[0] round
     /* 2138439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138442 */     // MIs[0] policy
     /* 2138442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138478 */     // GIR_Coverage, 17598,
     /* 2138478 */     GIR_EraseRootFromParent_Done,
     /* 2138479 */   // Label 28268: @2138479
     /* 2138479 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2138570), // Rule ID 17599 //
     /* 2138484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138530 */     // MIs[0] round
     /* 2138530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138533 */     // MIs[0] policy
     /* 2138533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138543 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138569 */     // GIR_Coverage, 17599,
     /* 2138569 */     GIR_EraseRootFromParent_Done,
     /* 2138570 */   // Label 28269: @2138570
     /* 2138570 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2138661), // Rule ID 17602 //
     /* 2138575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138621 */     // MIs[0] round
     /* 2138621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138624 */     // MIs[0] policy
     /* 2138624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138634 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138660 */     // GIR_Coverage, 17602,
     /* 2138660 */     GIR_EraseRootFromParent_Done,
     /* 2138661 */   // Label 28270: @2138661
     /* 2138661 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2138752), // Rule ID 17603 //
     /* 2138666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138712 */     // MIs[0] round
     /* 2138712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138715 */     // MIs[0] policy
     /* 2138715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138725 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138751 */     // GIR_Coverage, 17603,
     /* 2138751 */     GIR_EraseRootFromParent_Done,
     /* 2138752 */   // Label 28271: @2138752
     /* 2138752 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2138843), // Rule ID 17606 //
     /* 2138757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138803 */     // MIs[0] round
     /* 2138803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138806 */     // MIs[0] policy
     /* 2138806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138816 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138842 */     // GIR_Coverage, 17606,
     /* 2138842 */     GIR_EraseRootFromParent_Done,
     /* 2138843 */   // Label 28272: @2138843
     /* 2138843 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2138934), // Rule ID 17607 //
     /* 2138848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138894 */     // MIs[0] round
     /* 2138894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138897 */     // MIs[0] policy
     /* 2138897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138907 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138933 */     // GIR_Coverage, 17607,
     /* 2138933 */     GIR_EraseRootFromParent_Done,
     /* 2138934 */   // Label 28273: @2138934
     /* 2138934 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2139025), // Rule ID 17610 //
     /* 2138939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138985 */     // MIs[0] round
     /* 2138985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138988 */     // MIs[0] policy
     /* 2138988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138998 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2139001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139024 */     // GIR_Coverage, 17610,
     /* 2139024 */     GIR_EraseRootFromParent_Done,
     /* 2139025 */   // Label 28274: @2139025
     /* 2139025 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2139116), // Rule ID 17611 //
     /* 2139030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2139041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2139044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2139047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139076 */     // MIs[0] round
     /* 2139076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139079 */     // MIs[0] policy
     /* 2139079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139089 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2139092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139115 */     // GIR_Coverage, 17611,
     /* 2139115 */     GIR_EraseRootFromParent_Done,
     /* 2139116 */   // Label 28275: @2139116
     /* 2139116 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2139207), // Rule ID 17614 //
     /* 2139121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139167 */     // MIs[0] round
     /* 2139167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139170 */     // MIs[0] policy
     /* 2139170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2139183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139206 */     // GIR_Coverage, 17614,
     /* 2139206 */     GIR_EraseRootFromParent_Done,
     /* 2139207 */   // Label 28276: @2139207
     /* 2139207 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2139298), // Rule ID 17615 //
     /* 2139212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2139223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2139226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2139229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139258 */     // MIs[0] round
     /* 2139258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139261 */     // MIs[0] policy
     /* 2139261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139271 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2139274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139297 */     // GIR_Coverage, 17615,
     /* 2139297 */     GIR_EraseRootFromParent_Done,
     /* 2139298 */   // Label 28277: @2139298
     /* 2139298 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2139389), // Rule ID 17618 //
     /* 2139303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2139314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139349 */     // MIs[0] round
     /* 2139349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139352 */     // MIs[0] policy
     /* 2139352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139362 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2139365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139388 */     // GIR_Coverage, 17618,
     /* 2139388 */     GIR_EraseRootFromParent_Done,
     /* 2139389 */   // Label 28278: @2139389
     /* 2139389 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2139480), // Rule ID 17619 //
     /* 2139394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2139405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2139408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2139411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139440 */     // MIs[0] round
     /* 2139440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139443 */     // MIs[0] policy
     /* 2139443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139453 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2139456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139479 */     // GIR_Coverage, 17619,
     /* 2139479 */     GIR_EraseRootFromParent_Done,
     /* 2139480 */   // Label 28279: @2139480
     /* 2139480 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2139571), // Rule ID 17622 //
     /* 2139485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139531 */     // MIs[0] round
     /* 2139531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139534 */     // MIs[0] policy
     /* 2139534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139544 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139570 */     // GIR_Coverage, 17622,
     /* 2139570 */     GIR_EraseRootFromParent_Done,
     /* 2139571 */   // Label 28280: @2139571
     /* 2139571 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2139662), // Rule ID 17623 //
     /* 2139576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139622 */     // MIs[0] round
     /* 2139622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139625 */     // MIs[0] policy
     /* 2139625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139635 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139661 */     // GIR_Coverage, 17623,
     /* 2139661 */     GIR_EraseRootFromParent_Done,
     /* 2139662 */   // Label 28281: @2139662
     /* 2139662 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2139753), // Rule ID 17626 //
     /* 2139667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139713 */     // MIs[0] round
     /* 2139713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139716 */     // MIs[0] policy
     /* 2139716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139726 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139752 */     // GIR_Coverage, 17626,
     /* 2139752 */     GIR_EraseRootFromParent_Done,
     /* 2139753 */   // Label 28282: @2139753
     /* 2139753 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2139844), // Rule ID 17627 //
     /* 2139758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139804 */     // MIs[0] round
     /* 2139804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139807 */     // MIs[0] policy
     /* 2139807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139817 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139843 */     // GIR_Coverage, 17627,
     /* 2139843 */     GIR_EraseRootFromParent_Done,
     /* 2139844 */   // Label 28283: @2139844
     /* 2139844 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2139935), // Rule ID 17630 //
     /* 2139849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139895 */     // MIs[0] round
     /* 2139895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139898 */     // MIs[0] policy
     /* 2139898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139908 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139934 */     // GIR_Coverage, 17630,
     /* 2139934 */     GIR_EraseRootFromParent_Done,
     /* 2139935 */   // Label 28284: @2139935
     /* 2139935 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2140026), // Rule ID 17631 //
     /* 2139940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139986 */     // MIs[0] round
     /* 2139986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139989 */     // MIs[0] policy
     /* 2139989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139999 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2140002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140025 */     // GIR_Coverage, 17631,
     /* 2140025 */     GIR_EraseRootFromParent_Done,
     /* 2140026 */   // Label 28285: @2140026
     /* 2140026 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2140117), // Rule ID 17634 //
     /* 2140031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140077 */     // MIs[0] round
     /* 2140077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140080 */     // MIs[0] policy
     /* 2140080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140090 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2140093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140116 */     // GIR_Coverage, 17634,
     /* 2140116 */     GIR_EraseRootFromParent_Done,
     /* 2140117 */   // Label 28286: @2140117
     /* 2140117 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2140208), // Rule ID 17635 //
     /* 2140122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2140133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2140136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2140139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140168 */     // MIs[0] round
     /* 2140168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140171 */     // MIs[0] policy
     /* 2140171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140181 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2140184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140207 */     // GIR_Coverage, 17635,
     /* 2140207 */     GIR_EraseRootFromParent_Done,
     /* 2140208 */   // Label 28287: @2140208
     /* 2140208 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2140299), // Rule ID 17638 //
     /* 2140213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140259 */     // MIs[0] round
     /* 2140259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140262 */     // MIs[0] policy
     /* 2140262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140272 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2140275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140298 */     // GIR_Coverage, 17638,
     /* 2140298 */     GIR_EraseRootFromParent_Done,
     /* 2140299 */   // Label 28288: @2140299
     /* 2140299 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2140390), // Rule ID 17639 //
     /* 2140304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2140315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2140318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2140321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140350 */     // MIs[0] round
     /* 2140350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140353 */     // MIs[0] policy
     /* 2140353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140363 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2140366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140389 */     // GIR_Coverage, 17639,
     /* 2140389 */     GIR_EraseRootFromParent_Done,
     /* 2140390 */   // Label 28289: @2140390
     /* 2140390 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2140481), // Rule ID 17642 //
     /* 2140395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140441 */     // MIs[0] round
     /* 2140441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140444 */     // MIs[0] policy
     /* 2140444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140480 */     // GIR_Coverage, 17642,
     /* 2140480 */     GIR_EraseRootFromParent_Done,
     /* 2140481 */   // Label 28290: @2140481
     /* 2140481 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2140572), // Rule ID 17643 //
     /* 2140486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140532 */     // MIs[0] round
     /* 2140532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140535 */     // MIs[0] policy
     /* 2140535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140545 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11306:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140571 */     // GIR_Coverage, 17643,
     /* 2140571 */     GIR_EraseRootFromParent_Done,
     /* 2140572 */   // Label 28291: @2140572
     /* 2140572 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2140663), // Rule ID 17646 //
     /* 2140577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140623 */     // MIs[0] round
     /* 2140623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140626 */     // MIs[0] policy
     /* 2140626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140636 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140662 */     // GIR_Coverage, 17646,
     /* 2140662 */     GIR_EraseRootFromParent_Done,
     /* 2140663 */   // Label 28292: @2140663
     /* 2140663 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2140754), // Rule ID 17647 //
     /* 2140668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140714 */     // MIs[0] round
     /* 2140714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140717 */     // MIs[0] policy
     /* 2140717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140753 */     // GIR_Coverage, 17647,
     /* 2140753 */     GIR_EraseRootFromParent_Done,
     /* 2140754 */   // Label 28293: @2140754
     /* 2140754 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2140845), // Rule ID 17650 //
     /* 2140759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140805 */     // MIs[0] round
     /* 2140805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140808 */     // MIs[0] policy
     /* 2140808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140818 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140844 */     // GIR_Coverage, 17650,
     /* 2140844 */     GIR_EraseRootFromParent_Done,
     /* 2140845 */   // Label 28294: @2140845
     /* 2140845 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2140936), // Rule ID 17651 //
     /* 2140850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140896 */     // MIs[0] round
     /* 2140896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140899 */     // MIs[0] policy
     /* 2140899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140909 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140935 */     // GIR_Coverage, 17651,
     /* 2140935 */     GIR_EraseRootFromParent_Done,
     /* 2140936 */   // Label 28295: @2140936
     /* 2140936 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2141027), // Rule ID 17654 //
     /* 2140941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140987 */     // MIs[0] round
     /* 2140987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140990 */     // MIs[0] policy
     /* 2140990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141000 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2141003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141026 */     // GIR_Coverage, 17654,
     /* 2141026 */     GIR_EraseRootFromParent_Done,
     /* 2141027 */   // Label 28296: @2141027
     /* 2141027 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2141118), // Rule ID 17655 //
     /* 2141032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2141043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2141046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2141049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141078 */     // MIs[0] round
     /* 2141078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141081 */     // MIs[0] policy
     /* 2141081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2141094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141117 */     // GIR_Coverage, 17655,
     /* 2141117 */     GIR_EraseRootFromParent_Done,
     /* 2141118 */   // Label 28297: @2141118
     /* 2141118 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2141209), // Rule ID 17658 //
     /* 2141123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141169 */     // MIs[0] round
     /* 2141169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141172 */     // MIs[0] policy
     /* 2141172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141182 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2141185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141208 */     // GIR_Coverage, 17658,
     /* 2141208 */     GIR_EraseRootFromParent_Done,
     /* 2141209 */   // Label 28298: @2141209
     /* 2141209 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2141300), // Rule ID 17659 //
     /* 2141214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2141225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2141228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2141231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141260 */     // MIs[0] round
     /* 2141260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141263 */     // MIs[0] policy
     /* 2141263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141273 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2141276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141299 */     // GIR_Coverage, 17659,
     /* 2141299 */     GIR_EraseRootFromParent_Done,
     /* 2141300 */   // Label 28299: @2141300
     /* 2141300 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2141391), // Rule ID 17662 //
     /* 2141305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2141316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2141319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141351 */     // MIs[0] round
     /* 2141351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141354 */     // MIs[0] policy
     /* 2141354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141364 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2141367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141390 */     // GIR_Coverage, 17662,
     /* 2141390 */     GIR_EraseRootFromParent_Done,
     /* 2141391 */   // Label 28300: @2141391
     /* 2141391 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2141482), // Rule ID 17663 //
     /* 2141396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2141407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2141410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2141416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141442 */     // MIs[0] round
     /* 2141442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141445 */     // MIs[0] policy
     /* 2141445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141455 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2141458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141481 */     // GIR_Coverage, 17663,
     /* 2141481 */     GIR_EraseRootFromParent_Done,
     /* 2141482 */   // Label 28301: @2141482
     /* 2141482 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2141573), // Rule ID 17666 //
     /* 2141487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141533 */     // MIs[0] round
     /* 2141533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141536 */     // MIs[0] policy
     /* 2141536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141546 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141572 */     // GIR_Coverage, 17666,
     /* 2141572 */     GIR_EraseRootFromParent_Done,
     /* 2141573 */   // Label 28302: @2141573
     /* 2141573 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2141664), // Rule ID 17667 //
     /* 2141578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141624 */     // MIs[0] round
     /* 2141624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141627 */     // MIs[0] policy
     /* 2141627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141637 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141663 */     // GIR_Coverage, 17667,
     /* 2141663 */     GIR_EraseRootFromParent_Done,
     /* 2141664 */   // Label 28303: @2141664
     /* 2141664 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2141755), // Rule ID 17670 //
     /* 2141669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141715 */     // MIs[0] round
     /* 2141715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141718 */     // MIs[0] policy
     /* 2141718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141728 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141754 */     // GIR_Coverage, 17670,
     /* 2141754 */     GIR_EraseRootFromParent_Done,
     /* 2141755 */   // Label 28304: @2141755
     /* 2141755 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2141846), // Rule ID 17671 //
     /* 2141760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141806 */     // MIs[0] round
     /* 2141806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141809 */     // MIs[0] policy
     /* 2141809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141819 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141845 */     // GIR_Coverage, 17671,
     /* 2141845 */     GIR_EraseRootFromParent_Done,
     /* 2141846 */   // Label 28305: @2141846
     /* 2141846 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2141937), // Rule ID 17674 //
     /* 2141851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141897 */     // MIs[0] round
     /* 2141897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141900 */     // MIs[0] policy
     /* 2141900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141910 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141936 */     // GIR_Coverage, 17674,
     /* 2141936 */     GIR_EraseRootFromParent_Done,
     /* 2141937 */   // Label 28306: @2141937
     /* 2141937 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2142028), // Rule ID 17675 //
     /* 2141942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141988 */     // MIs[0] round
     /* 2141988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141991 */     // MIs[0] policy
     /* 2141991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142001 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2142004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142027 */     // GIR_Coverage, 17675,
     /* 2142027 */     GIR_EraseRootFromParent_Done,
     /* 2142028 */   // Label 28307: @2142028
     /* 2142028 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2142119), // Rule ID 17678 //
     /* 2142033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142079 */     // MIs[0] round
     /* 2142079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142082 */     // MIs[0] policy
     /* 2142082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2142095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142118 */     // GIR_Coverage, 17678,
     /* 2142118 */     GIR_EraseRootFromParent_Done,
     /* 2142119 */   // Label 28308: @2142119
     /* 2142119 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2142210), // Rule ID 17679 //
     /* 2142124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2142135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2142138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2142141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142170 */     // MIs[0] round
     /* 2142170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142173 */     // MIs[0] policy
     /* 2142173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2142186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142209 */     // GIR_Coverage, 17679,
     /* 2142209 */     GIR_EraseRootFromParent_Done,
     /* 2142210 */   // Label 28309: @2142210
     /* 2142210 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2142301), // Rule ID 17682 //
     /* 2142215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142261 */     // MIs[0] round
     /* 2142261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142264 */     // MIs[0] policy
     /* 2142264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142274 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2142277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142300 */     // GIR_Coverage, 17682,
     /* 2142300 */     GIR_EraseRootFromParent_Done,
     /* 2142301 */   // Label 28310: @2142301
     /* 2142301 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2142392), // Rule ID 17683 //
     /* 2142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2142317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2142320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2142323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142352 */     // MIs[0] round
     /* 2142352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142355 */     // MIs[0] policy
     /* 2142355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142365 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2142368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142391 */     // GIR_Coverage, 17683,
     /* 2142391 */     GIR_EraseRootFromParent_Done,
     /* 2142392 */   // Label 28311: @2142392
     /* 2142392 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2142483), // Rule ID 17686 //
     /* 2142397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2142400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142443 */     // MIs[0] round
     /* 2142443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142446 */     // MIs[0] policy
     /* 2142446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142456 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142482 */     // GIR_Coverage, 17686,
     /* 2142482 */     GIR_EraseRootFromParent_Done,
     /* 2142483 */   // Label 28312: @2142483
     /* 2142483 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2142574), // Rule ID 17687 //
     /* 2142488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142534 */     // MIs[0] round
     /* 2142534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142537 */     // MIs[0] policy
     /* 2142537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142547 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142573 */     // GIR_Coverage, 17687,
     /* 2142573 */     GIR_EraseRootFromParent_Done,
     /* 2142574 */   // Label 28313: @2142574
     /* 2142574 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2142665), // Rule ID 17690 //
     /* 2142579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142625 */     // MIs[0] round
     /* 2142625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142628 */     // MIs[0] policy
     /* 2142628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142638 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142664 */     // GIR_Coverage, 17690,
     /* 2142664 */     GIR_EraseRootFromParent_Done,
     /* 2142665 */   // Label 28314: @2142665
     /* 2142665 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2142756), // Rule ID 17691 //
     /* 2142670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142716 */     // MIs[0] round
     /* 2142716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142719 */     // MIs[0] policy
     /* 2142719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142729 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142755 */     // GIR_Coverage, 17691,
     /* 2142755 */     GIR_EraseRootFromParent_Done,
     /* 2142756 */   // Label 28315: @2142756
     /* 2142756 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2142847), // Rule ID 17694 //
     /* 2142761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142807 */     // MIs[0] round
     /* 2142807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142810 */     // MIs[0] policy
     /* 2142810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142820 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142846 */     // GIR_Coverage, 17694,
     /* 2142846 */     GIR_EraseRootFromParent_Done,
     /* 2142847 */   // Label 28316: @2142847
     /* 2142847 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2142938), // Rule ID 17695 //
     /* 2142852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142898 */     // MIs[0] round
     /* 2142898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142901 */     // MIs[0] policy
     /* 2142901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142911 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142937 */     // GIR_Coverage, 17695,
     /* 2142937 */     GIR_EraseRootFromParent_Done,
     /* 2142938 */   // Label 28317: @2142938
     /* 2142938 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2143029), // Rule ID 17698 //
     /* 2142943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142989 */     // MIs[0] round
     /* 2142989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142992 */     // MIs[0] policy
     /* 2142992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2143005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143028 */     // GIR_Coverage, 17698,
     /* 2143028 */     GIR_EraseRootFromParent_Done,
     /* 2143029 */   // Label 28318: @2143029
     /* 2143029 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2143120), // Rule ID 17699 //
     /* 2143034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2143045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2143051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2143054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143080 */     // MIs[0] round
     /* 2143080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143083 */     // MIs[0] policy
     /* 2143083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143093 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2143096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143119 */     // GIR_Coverage, 17699,
     /* 2143119 */     GIR_EraseRootFromParent_Done,
     /* 2143120 */   // Label 28319: @2143120
     /* 2143120 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2143211), // Rule ID 17702 //
     /* 2143125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2143136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143171 */     // MIs[0] round
     /* 2143171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143174 */     // MIs[0] policy
     /* 2143174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143184 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2143187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143210 */     // GIR_Coverage, 17702,
     /* 2143210 */     GIR_EraseRootFromParent_Done,
     /* 2143211 */   // Label 28320: @2143211
     /* 2143211 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2143302), // Rule ID 17703 //
     /* 2143216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2143227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2143230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2143233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143262 */     // MIs[0] round
     /* 2143262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143265 */     // MIs[0] policy
     /* 2143265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143275 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2143278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143301 */     // GIR_Coverage, 17703,
     /* 2143301 */     GIR_EraseRootFromParent_Done,
     /* 2143302 */   // Label 28321: @2143302
     /* 2143302 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2143393), // Rule ID 17706 //
     /* 2143307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2143324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143353 */     // MIs[0] round
     /* 2143353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143356 */     // MIs[0] policy
     /* 2143356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143366 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2143369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143392 */     // GIR_Coverage, 17706,
     /* 2143392 */     GIR_EraseRootFromParent_Done,
     /* 2143393 */   // Label 28322: @2143393
     /* 2143393 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2143484), // Rule ID 17707 //
     /* 2143398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2143415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143444 */     // MIs[0] round
     /* 2143444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143447 */     // MIs[0] policy
     /* 2143447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143457 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2143460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143483 */     // GIR_Coverage, 17707,
     /* 2143483 */     GIR_EraseRootFromParent_Done,
     /* 2143484 */   // Label 28323: @2143484
     /* 2143484 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2143575), // Rule ID 17710 //
     /* 2143489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143535 */     // MIs[0] round
     /* 2143535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143538 */     // MIs[0] policy
     /* 2143538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143574 */     // GIR_Coverage, 17710,
     /* 2143574 */     GIR_EraseRootFromParent_Done,
     /* 2143575 */   // Label 28324: @2143575
     /* 2143575 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2143666), // Rule ID 17711 //
     /* 2143580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143626 */     // MIs[0] round
     /* 2143626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143629 */     // MIs[0] policy
     /* 2143629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143639 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143665 */     // GIR_Coverage, 17711,
     /* 2143665 */     GIR_EraseRootFromParent_Done,
     /* 2143666 */   // Label 28325: @2143666
     /* 2143666 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2143757), // Rule ID 17714 //
     /* 2143671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143717 */     // MIs[0] round
     /* 2143717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143720 */     // MIs[0] policy
     /* 2143720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143730 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143756 */     // GIR_Coverage, 17714,
     /* 2143756 */     GIR_EraseRootFromParent_Done,
     /* 2143757 */   // Label 28326: @2143757
     /* 2143757 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2143848), // Rule ID 17715 //
     /* 2143762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143808 */     // MIs[0] round
     /* 2143808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143811 */     // MIs[0] policy
     /* 2143811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143821 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143847 */     // GIR_Coverage, 17715,
     /* 2143847 */     GIR_EraseRootFromParent_Done,
     /* 2143848 */   // Label 28327: @2143848
     /* 2143848 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2143939), // Rule ID 17718 //
     /* 2143853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143899 */     // MIs[0] round
     /* 2143899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143902 */     // MIs[0] policy
     /* 2143902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143912 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143938 */     // GIR_Coverage, 17718,
     /* 2143938 */     GIR_EraseRootFromParent_Done,
     /* 2143939 */   // Label 28328: @2143939
     /* 2143939 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2144030), // Rule ID 17719 //
     /* 2143944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143990 */     // MIs[0] round
     /* 2143990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143993 */     // MIs[0] policy
     /* 2143993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144003 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2144006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144029 */     // GIR_Coverage, 17719,
     /* 2144029 */     GIR_EraseRootFromParent_Done,
     /* 2144030 */   // Label 28329: @2144030
     /* 2144030 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2144121), // Rule ID 17722 //
     /* 2144035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144081 */     // MIs[0] round
     /* 2144081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144084 */     // MIs[0] policy
     /* 2144084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144094 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2144097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144120 */     // GIR_Coverage, 17722,
     /* 2144120 */     GIR_EraseRootFromParent_Done,
     /* 2144121 */   // Label 28330: @2144121
     /* 2144121 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2144212), // Rule ID 17723 //
     /* 2144126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2144143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144172 */     // MIs[0] round
     /* 2144172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144175 */     // MIs[0] policy
     /* 2144175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144185 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2144188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144211 */     // GIR_Coverage, 17723,
     /* 2144211 */     GIR_EraseRootFromParent_Done,
     /* 2144212 */   // Label 28331: @2144212
     /* 2144212 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2144303), // Rule ID 17726 //
     /* 2144217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2144234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144263 */     // MIs[0] round
     /* 2144263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144266 */     // MIs[0] policy
     /* 2144266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144276 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2144279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144302 */     // GIR_Coverage, 17726,
     /* 2144302 */     GIR_EraseRootFromParent_Done,
     /* 2144303 */   // Label 28332: @2144303
     /* 2144303 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2144394), // Rule ID 17727 //
     /* 2144308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2144325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144354 */     // MIs[0] round
     /* 2144354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144357 */     // MIs[0] policy
     /* 2144357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144367 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2144370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144393 */     // GIR_Coverage, 17727,
     /* 2144393 */     GIR_EraseRootFromParent_Done,
     /* 2144394 */   // Label 28333: @2144394
     /* 2144394 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2144485), // Rule ID 17730 //
     /* 2144399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144445 */     // MIs[0] round
     /* 2144445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144448 */     // MIs[0] policy
     /* 2144448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144458 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144484 */     // GIR_Coverage, 17730,
     /* 2144484 */     GIR_EraseRootFromParent_Done,
     /* 2144485 */   // Label 28334: @2144485
     /* 2144485 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2144576), // Rule ID 17731 //
     /* 2144490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144536 */     // MIs[0] round
     /* 2144536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144539 */     // MIs[0] policy
     /* 2144539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144549 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144575 */     // GIR_Coverage, 17731,
     /* 2144575 */     GIR_EraseRootFromParent_Done,
     /* 2144576 */   // Label 28335: @2144576
     /* 2144576 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2144667), // Rule ID 17734 //
     /* 2144581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144627 */     // MIs[0] round
     /* 2144627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144630 */     // MIs[0] policy
     /* 2144630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144640 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144666 */     // GIR_Coverage, 17734,
     /* 2144666 */     GIR_EraseRootFromParent_Done,
     /* 2144667 */   // Label 28336: @2144667
     /* 2144667 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2144758), // Rule ID 17735 //
     /* 2144672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144718 */     // MIs[0] round
     /* 2144718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144721 */     // MIs[0] policy
     /* 2144721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144731 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144757 */     // GIR_Coverage, 17735,
     /* 2144757 */     GIR_EraseRootFromParent_Done,
     /* 2144758 */   // Label 28337: @2144758
     /* 2144758 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2144849), // Rule ID 17738 //
     /* 2144763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144809 */     // MIs[0] round
     /* 2144809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144812 */     // MIs[0] policy
     /* 2144812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144822 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144848 */     // GIR_Coverage, 17738,
     /* 2144848 */     GIR_EraseRootFromParent_Done,
     /* 2144849 */   // Label 28338: @2144849
     /* 2144849 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2144940), // Rule ID 17739 //
     /* 2144854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144900 */     // MIs[0] round
     /* 2144900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144903 */     // MIs[0] policy
     /* 2144903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144913 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144939 */     // GIR_Coverage, 17739,
     /* 2144939 */     GIR_EraseRootFromParent_Done,
     /* 2144940 */   // Label 28339: @2144940
     /* 2144940 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2145031), // Rule ID 17742 //
     /* 2144945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144991 */     // MIs[0] round
     /* 2144991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144994 */     // MIs[0] policy
     /* 2144994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145004 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2145007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145030 */     // GIR_Coverage, 17742,
     /* 2145030 */     GIR_EraseRootFromParent_Done,
     /* 2145031 */   // Label 28340: @2145031
     /* 2145031 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2145122), // Rule ID 17743 //
     /* 2145036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2145039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2145053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2145056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2145078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145082 */     // MIs[0] round
     /* 2145082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145085 */     // MIs[0] policy
     /* 2145085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145095 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2145098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145121 */     // GIR_Coverage, 17743,
     /* 2145121 */     GIR_EraseRootFromParent_Done,
     /* 2145122 */   // Label 28341: @2145122
     /* 2145122 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2145213), // Rule ID 17746 //
     /* 2145127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145173 */     // MIs[0] round
     /* 2145173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145176 */     // MIs[0] policy
     /* 2145176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145186 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2145189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145212 */     // GIR_Coverage, 17746,
     /* 2145212 */     GIR_EraseRootFromParent_Done,
     /* 2145213 */   // Label 28342: @2145213
     /* 2145213 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2145304), // Rule ID 17747 //
     /* 2145218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145264 */     // MIs[0] round
     /* 2145264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145267 */     // MIs[0] policy
     /* 2145267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145277 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2145280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145303 */     // GIR_Coverage, 17747,
     /* 2145303 */     GIR_EraseRootFromParent_Done,
     /* 2145304 */   // Label 28343: @2145304
     /* 2145304 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2145395), // Rule ID 17750 //
     /* 2145309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145355 */     // MIs[0] round
     /* 2145355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145358 */     // MIs[0] policy
     /* 2145358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145368 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2145371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145394 */     // GIR_Coverage, 17750,
     /* 2145394 */     GIR_EraseRootFromParent_Done,
     /* 2145395 */   // Label 28344: @2145395
     /* 2145395 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2145486), // Rule ID 17751 //
     /* 2145400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145446 */     // MIs[0] round
     /* 2145446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145449 */     // MIs[0] policy
     /* 2145449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145459 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11362:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2145462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145485 */     // GIR_Coverage, 17751,
     /* 2145485 */     GIR_EraseRootFromParent_Done,
     /* 2145486 */   // Label 28345: @2145486
     /* 2145486 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2145577), // Rule ID 17754 //
     /* 2145491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145537 */     // MIs[0] round
     /* 2145537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145540 */     // MIs[0] policy
     /* 2145540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145550 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145576 */     // GIR_Coverage, 17754,
     /* 2145576 */     GIR_EraseRootFromParent_Done,
     /* 2145577 */   // Label 28346: @2145577
     /* 2145577 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2145668), // Rule ID 17755 //
     /* 2145582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145628 */     // MIs[0] round
     /* 2145628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145631 */     // MIs[0] policy
     /* 2145631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145641 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11362:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145667 */     // GIR_Coverage, 17755,
     /* 2145667 */     GIR_EraseRootFromParent_Done,
     /* 2145668 */   // Label 28347: @2145668
     /* 2145668 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2145759), // Rule ID 17758 //
     /* 2145673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145719 */     // MIs[0] round
     /* 2145719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145722 */     // MIs[0] policy
     /* 2145722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145732 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145758 */     // GIR_Coverage, 17758,
     /* 2145758 */     GIR_EraseRootFromParent_Done,
     /* 2145759 */   // Label 28348: @2145759
     /* 2145759 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2145850), // Rule ID 17759 //
     /* 2145764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145810 */     // MIs[0] round
     /* 2145810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145813 */     // MIs[0] policy
     /* 2145813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145823 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11362:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145849 */     // GIR_Coverage, 17759,
     /* 2145849 */     GIR_EraseRootFromParent_Done,
     /* 2145850 */   // Label 28349: @2145850
     /* 2145850 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2145941), // Rule ID 17762 //
     /* 2145855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145901 */     // MIs[0] round
     /* 2145901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145904 */     // MIs[0] policy
     /* 2145904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145940 */     // GIR_Coverage, 17762,
     /* 2145940 */     GIR_EraseRootFromParent_Done,
     /* 2145941 */   // Label 28350: @2145941
     /* 2145941 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2146032), // Rule ID 17763 //
     /* 2145946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145992 */     // MIs[0] round
     /* 2145992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145995 */     // MIs[0] policy
     /* 2145995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146005 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2146008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146031 */     // GIR_Coverage, 17763,
     /* 2146031 */     GIR_EraseRootFromParent_Done,
     /* 2146032 */   // Label 28351: @2146032
     /* 2146032 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2146123), // Rule ID 17766 //
     /* 2146037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146083 */     // MIs[0] round
     /* 2146083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146086 */     // MIs[0] policy
     /* 2146086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146096 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2146099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146122 */     // GIR_Coverage, 17766,
     /* 2146122 */     GIR_EraseRootFromParent_Done,
     /* 2146123 */   // Label 28352: @2146123
     /* 2146123 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2146214), // Rule ID 17767 //
     /* 2146128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2146145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146174 */     // MIs[0] round
     /* 2146174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146177 */     // MIs[0] policy
     /* 2146177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146187 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2146190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146213 */     // GIR_Coverage, 17767,
     /* 2146213 */     GIR_EraseRootFromParent_Done,
     /* 2146214 */   // Label 28353: @2146214
     /* 2146214 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2146305), // Rule ID 17770 //
     /* 2146219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2146230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2146233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146265 */     // MIs[0] round
     /* 2146265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146268 */     // MIs[0] policy
     /* 2146268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146278 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2146281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146304 */     // GIR_Coverage, 17770,
     /* 2146304 */     GIR_EraseRootFromParent_Done,
     /* 2146305 */   // Label 28354: @2146305
     /* 2146305 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2146396), // Rule ID 17771 //
     /* 2146310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2146321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2146324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2146327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2146330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146356 */     // MIs[0] round
     /* 2146356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146359 */     // MIs[0] policy
     /* 2146359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2146372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146395 */     // GIR_Coverage, 17771,
     /* 2146395 */     GIR_EraseRootFromParent_Done,
     /* 2146396 */   // Label 28355: @2146396
     /* 2146396 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2146487), // Rule ID 17774 //
     /* 2146401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146447 */     // MIs[0] round
     /* 2146447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146450 */     // MIs[0] policy
     /* 2146450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146460 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146486 */     // GIR_Coverage, 17774,
     /* 2146486 */     GIR_EraseRootFromParent_Done,
     /* 2146487 */   // Label 28356: @2146487
     /* 2146487 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2146578), // Rule ID 17775 //
     /* 2146492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146538 */     // MIs[0] round
     /* 2146538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146541 */     // MIs[0] policy
     /* 2146541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146551 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146577 */     // GIR_Coverage, 17775,
     /* 2146577 */     GIR_EraseRootFromParent_Done,
     /* 2146578 */   // Label 28357: @2146578
     /* 2146578 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2146669), // Rule ID 17778 //
     /* 2146583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146629 */     // MIs[0] round
     /* 2146629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146632 */     // MIs[0] policy
     /* 2146632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146642 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146668 */     // GIR_Coverage, 17778,
     /* 2146668 */     GIR_EraseRootFromParent_Done,
     /* 2146669 */   // Label 28358: @2146669
     /* 2146669 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2146760), // Rule ID 17779 //
     /* 2146674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146720 */     // MIs[0] round
     /* 2146720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146723 */     // MIs[0] policy
     /* 2146723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146733 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146759 */     // GIR_Coverage, 17779,
     /* 2146759 */     GIR_EraseRootFromParent_Done,
     /* 2146760 */   // Label 28359: @2146760
     /* 2146760 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2146851), // Rule ID 17782 //
     /* 2146765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146811 */     // MIs[0] round
     /* 2146811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146814 */     // MIs[0] policy
     /* 2146814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146850 */     // GIR_Coverage, 17782,
     /* 2146850 */     GIR_EraseRootFromParent_Done,
     /* 2146851 */   // Label 28360: @2146851
     /* 2146851 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2146942), // Rule ID 17783 //
     /* 2146856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146902 */     // MIs[0] round
     /* 2146902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146905 */     // MIs[0] policy
     /* 2146905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146915 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146941 */     // GIR_Coverage, 17783,
     /* 2146941 */     GIR_EraseRootFromParent_Done,
     /* 2146942 */   // Label 28361: @2146942
     /* 2146942 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2147033), // Rule ID 17786 //
     /* 2146947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146993 */     // MIs[0] round
     /* 2146993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146996 */     // MIs[0] policy
     /* 2146996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147006 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2147009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147032 */     // GIR_Coverage, 17786,
     /* 2147032 */     GIR_EraseRootFromParent_Done,
     /* 2147033 */   // Label 28362: @2147033
     /* 2147033 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2147124), // Rule ID 17787 //
     /* 2147038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2147049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2147055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2147058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147084 */     // MIs[0] round
     /* 2147084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147087 */     // MIs[0] policy
     /* 2147087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147097 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2147100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147123 */     // GIR_Coverage, 17787,
     /* 2147123 */     GIR_EraseRootFromParent_Done,
     /* 2147124 */   // Label 28363: @2147124
     /* 2147124 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2147215), // Rule ID 17790 //
     /* 2147129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2147140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2147143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2147146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2147149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2147152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147175 */     // MIs[0] round
     /* 2147175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147178 */     // MIs[0] policy
     /* 2147178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147188 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2147191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147214 */     // GIR_Coverage, 17790,
     /* 2147214 */     GIR_EraseRootFromParent_Done,
     /* 2147215 */   // Label 28364: @2147215
     /* 2147215 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2147306), // Rule ID 17791 //
     /* 2147220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2147231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2147234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2147237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2147240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2147243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147266 */     // MIs[0] round
     /* 2147266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147269 */     // MIs[0] policy
     /* 2147269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147279 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2147282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147305 */     // GIR_Coverage, 17791,
     /* 2147305 */     GIR_EraseRootFromParent_Done,
     /* 2147306 */   // Label 28365: @2147306
     /* 2147306 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2147397), // Rule ID 17794 //
     /* 2147311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2147322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2147325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147357 */     // MIs[0] round
     /* 2147357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147360 */     // MIs[0] policy
     /* 2147360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2147373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147396 */     // GIR_Coverage, 17794,
     /* 2147396 */     GIR_EraseRootFromParent_Done,
     /* 2147397 */   // Label 28366: @2147397
     /* 2147397 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2147488), // Rule ID 17795 //
     /* 2147402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2147413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2147416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2147419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2147422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147448 */     // MIs[0] round
     /* 2147448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147451 */     // MIs[0] policy
     /* 2147451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147461 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2147464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147487 */     // GIR_Coverage, 17795,
     /* 2147487 */     GIR_EraseRootFromParent_Done,
     /* 2147488 */   // Label 28367: @2147488
     /* 2147488 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2147579), // Rule ID 17798 //
     /* 2147493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147539 */     // MIs[0] round
     /* 2147539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147542 */     // MIs[0] policy
     /* 2147542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147578 */     // GIR_Coverage, 17798,
     /* 2147578 */     GIR_EraseRootFromParent_Done,
     /* 2147579 */   // Label 28368: @2147579
     /* 2147579 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2147670), // Rule ID 17799 //
     /* 2147584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147630 */     // MIs[0] round
     /* 2147630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147633 */     // MIs[0] policy
     /* 2147633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147643 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147669 */     // GIR_Coverage, 17799,
     /* 2147669 */     GIR_EraseRootFromParent_Done,
     /* 2147670 */   // Label 28369: @2147670
     /* 2147670 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2147761), // Rule ID 17802 //
     /* 2147675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147721 */     // MIs[0] round
     /* 2147721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147724 */     // MIs[0] policy
     /* 2147724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147760 */     // GIR_Coverage, 17802,
     /* 2147760 */     GIR_EraseRootFromParent_Done,
     /* 2147761 */   // Label 28370: @2147761
     /* 2147761 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2147852), // Rule ID 17803 //
     /* 2147766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147812 */     // MIs[0] round
     /* 2147812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147815 */     // MIs[0] policy
     /* 2147815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147825 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147851 */     // GIR_Coverage, 17803,
     /* 2147851 */     GIR_EraseRootFromParent_Done,
     /* 2147852 */   // Label 28371: @2147852
     /* 2147852 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2147943), // Rule ID 17806 //
     /* 2147857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147903 */     // MIs[0] round
     /* 2147903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147906 */     // MIs[0] policy
     /* 2147906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147942 */     // GIR_Coverage, 17806,
     /* 2147942 */     GIR_EraseRootFromParent_Done,
     /* 2147943 */   // Label 28372: @2147943
     /* 2147943 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2148034), // Rule ID 17807 //
     /* 2147948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147994 */     // MIs[0] round
     /* 2147994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147997 */     // MIs[0] policy
     /* 2147997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148007 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2148010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148033 */     // GIR_Coverage, 17807,
     /* 2148033 */     GIR_EraseRootFromParent_Done,
     /* 2148034 */   // Label 28373: @2148034
     /* 2148034 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2148125), // Rule ID 17810 //
     /* 2148039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2148056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148085 */     // MIs[0] round
     /* 2148085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148088 */     // MIs[0] policy
     /* 2148088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148098 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2148101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148124 */     // GIR_Coverage, 17810,
     /* 2148124 */     GIR_EraseRootFromParent_Done,
     /* 2148125 */   // Label 28374: @2148125
     /* 2148125 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2148216), // Rule ID 17811 //
     /* 2148130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2148147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148176 */     // MIs[0] round
     /* 2148176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148179 */     // MIs[0] policy
     /* 2148179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148189 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2148192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148215 */     // GIR_Coverage, 17811,
     /* 2148215 */     GIR_EraseRootFromParent_Done,
     /* 2148216 */   // Label 28375: @2148216
     /* 2148216 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2148307), // Rule ID 17814 //
     /* 2148221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2148232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2148235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2148238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2148241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148267 */     // MIs[0] round
     /* 2148267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148270 */     // MIs[0] policy
     /* 2148270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148280 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2148283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148306 */     // GIR_Coverage, 17814,
     /* 2148306 */     GIR_EraseRootFromParent_Done,
     /* 2148307 */   // Label 28376: @2148307
     /* 2148307 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2148398), // Rule ID 17815 //
     /* 2148312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2148323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2148326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2148329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2148332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148358 */     // MIs[0] round
     /* 2148358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148361 */     // MIs[0] policy
     /* 2148361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148371 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2148374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148397 */     // GIR_Coverage, 17815,
     /* 2148397 */     GIR_EraseRootFromParent_Done,
     /* 2148398 */   // Label 28377: @2148398
     /* 2148398 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2148489), // Rule ID 17818 //
     /* 2148403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148449 */     // MIs[0] round
     /* 2148449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148452 */     // MIs[0] policy
     /* 2148452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148462 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148488 */     // GIR_Coverage, 17818,
     /* 2148488 */     GIR_EraseRootFromParent_Done,
     /* 2148489 */   // Label 28378: @2148489
     /* 2148489 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2148580), // Rule ID 17819 //
     /* 2148494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148540 */     // MIs[0] round
     /* 2148540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148543 */     // MIs[0] policy
     /* 2148543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148553 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148579 */     // GIR_Coverage, 17819,
     /* 2148579 */     GIR_EraseRootFromParent_Done,
     /* 2148580 */   // Label 28379: @2148580
     /* 2148580 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2148671), // Rule ID 17822 //
     /* 2148585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148631 */     // MIs[0] round
     /* 2148631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148634 */     // MIs[0] policy
     /* 2148634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148644 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148670 */     // GIR_Coverage, 17822,
     /* 2148670 */     GIR_EraseRootFromParent_Done,
     /* 2148671 */   // Label 28380: @2148671
     /* 2148671 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2148762), // Rule ID 17823 //
     /* 2148676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148722 */     // MIs[0] round
     /* 2148722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148725 */     // MIs[0] policy
     /* 2148725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148735 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148761 */     // GIR_Coverage, 17823,
     /* 2148761 */     GIR_EraseRootFromParent_Done,
     /* 2148762 */   // Label 28381: @2148762
     /* 2148762 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2148853), // Rule ID 17826 //
     /* 2148767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148813 */     // MIs[0] round
     /* 2148813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148816 */     // MIs[0] policy
     /* 2148816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148826 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148852 */     // GIR_Coverage, 17826,
     /* 2148852 */     GIR_EraseRootFromParent_Done,
     /* 2148853 */   // Label 28382: @2148853
     /* 2148853 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2148944), // Rule ID 17827 //
     /* 2148858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148904 */     // MIs[0] round
     /* 2148904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148907 */     // MIs[0] policy
     /* 2148907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148917 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148943 */     // GIR_Coverage, 17827,
     /* 2148943 */     GIR_EraseRootFromParent_Done,
     /* 2148944 */   // Label 28383: @2148944
     /* 2148944 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2149035), // Rule ID 17830 //
     /* 2148949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148995 */     // MIs[0] round
     /* 2148995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148998 */     // MIs[0] policy
     /* 2148998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2149011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149034 */     // GIR_Coverage, 17830,
     /* 2149034 */     GIR_EraseRootFromParent_Done,
     /* 2149035 */   // Label 28384: @2149035
     /* 2149035 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2149126), // Rule ID 17831 //
     /* 2149040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149086 */     // MIs[0] round
     /* 2149086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149089 */     // MIs[0] policy
     /* 2149089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149099 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2149102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149125 */     // GIR_Coverage, 17831,
     /* 2149125 */     GIR_EraseRootFromParent_Done,
     /* 2149126 */   // Label 28385: @2149126
     /* 2149126 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2149217), // Rule ID 17834 //
     /* 2149131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149177 */     // MIs[0] round
     /* 2149177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149180 */     // MIs[0] policy
     /* 2149180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2149193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149216 */     // GIR_Coverage, 17834,
     /* 2149216 */     GIR_EraseRootFromParent_Done,
     /* 2149217 */   // Label 28386: @2149217
     /* 2149217 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2149308), // Rule ID 17835 //
     /* 2149222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149268 */     // MIs[0] round
     /* 2149268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149271 */     // MIs[0] policy
     /* 2149271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149281 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2149284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149307 */     // GIR_Coverage, 17835,
     /* 2149307 */     GIR_EraseRootFromParent_Done,
     /* 2149308 */   // Label 28387: @2149308
     /* 2149308 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2149399), // Rule ID 17838 //
     /* 2149313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2149324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2149327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2149333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149359 */     // MIs[0] round
     /* 2149359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149362 */     // MIs[0] policy
     /* 2149362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149372 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149398 */     // GIR_Coverage, 17838,
     /* 2149398 */     GIR_EraseRootFromParent_Done,
     /* 2149399 */   // Label 28388: @2149399
     /* 2149399 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2149490), // Rule ID 17839 //
     /* 2149404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2149407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2149415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2149418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2149424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149450 */     // MIs[0] round
     /* 2149450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149453 */     // MIs[0] policy
     /* 2149453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149463 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149489 */     // GIR_Coverage, 17839,
     /* 2149489 */     GIR_EraseRootFromParent_Done,
     /* 2149490 */   // Label 28389: @2149490
     /* 2149490 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2149581), // Rule ID 17842 //
     /* 2149495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149541 */     // MIs[0] round
     /* 2149541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149544 */     // MIs[0] policy
     /* 2149544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149580 */     // GIR_Coverage, 17842,
     /* 2149580 */     GIR_EraseRootFromParent_Done,
     /* 2149581 */   // Label 28390: @2149581
     /* 2149581 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2149672), // Rule ID 17843 //
     /* 2149586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149632 */     // MIs[0] round
     /* 2149632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149635 */     // MIs[0] policy
     /* 2149635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149645 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149671 */     // GIR_Coverage, 17843,
     /* 2149671 */     GIR_EraseRootFromParent_Done,
     /* 2149672 */   // Label 28391: @2149672
     /* 2149672 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2149763), // Rule ID 17846 //
     /* 2149677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149723 */     // MIs[0] round
     /* 2149723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149726 */     // MIs[0] policy
     /* 2149726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149762 */     // GIR_Coverage, 17846,
     /* 2149762 */     GIR_EraseRootFromParent_Done,
     /* 2149763 */   // Label 28392: @2149763
     /* 2149763 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2149854), // Rule ID 17847 //
     /* 2149768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149814 */     // MIs[0] round
     /* 2149814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149817 */     // MIs[0] policy
     /* 2149817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149827 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149853 */     // GIR_Coverage, 17847,
     /* 2149853 */     GIR_EraseRootFromParent_Done,
     /* 2149854 */   // Label 28393: @2149854
     /* 2149854 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2149945), // Rule ID 17850 //
     /* 2149859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149905 */     // MIs[0] round
     /* 2149905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149908 */     // MIs[0] policy
     /* 2149908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149918 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149944 */     // GIR_Coverage, 17850,
     /* 2149944 */     GIR_EraseRootFromParent_Done,
     /* 2149945 */   // Label 28394: @2149945
     /* 2149945 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2150036), // Rule ID 17851 //
     /* 2149950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149996 */     // MIs[0] round
     /* 2149996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149999 */     // MIs[0] policy
     /* 2149999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150009 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2150012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150035 */     // GIR_Coverage, 17851,
     /* 2150035 */     GIR_EraseRootFromParent_Done,
     /* 2150036 */   // Label 28395: @2150036
     /* 2150036 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2150127), // Rule ID 17854 //
     /* 2150041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150087 */     // MIs[0] round
     /* 2150087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150090 */     // MIs[0] policy
     /* 2150090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2150103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150126 */     // GIR_Coverage, 17854,
     /* 2150126 */     GIR_EraseRootFromParent_Done,
     /* 2150127 */   // Label 28396: @2150127
     /* 2150127 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2150218), // Rule ID 17855 //
     /* 2150132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150178 */     // MIs[0] round
     /* 2150178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150181 */     // MIs[0] policy
     /* 2150181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150191 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2150194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150217 */     // GIR_Coverage, 17855,
     /* 2150217 */     GIR_EraseRootFromParent_Done,
     /* 2150218 */   // Label 28397: @2150218
     /* 2150218 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2150309), // Rule ID 17858 //
     /* 2150223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150269 */     // MIs[0] round
     /* 2150269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150272 */     // MIs[0] policy
     /* 2150272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150282 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2150285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150308 */     // GIR_Coverage, 17858,
     /* 2150308 */     GIR_EraseRootFromParent_Done,
     /* 2150309 */   // Label 28398: @2150309
     /* 2150309 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2150400), // Rule ID 17859 //
     /* 2150314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2150325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2150328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2150334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150360 */     // MIs[0] round
     /* 2150360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150363 */     // MIs[0] policy
     /* 2150363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150373 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2150376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150399 */     // GIR_Coverage, 17859,
     /* 2150399 */     GIR_EraseRootFromParent_Done,
     /* 2150400 */   // Label 28399: @2150400
     /* 2150400 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2150491), // Rule ID 17862 //
     /* 2150405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150451 */     // MIs[0] round
     /* 2150451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150454 */     // MIs[0] policy
     /* 2150454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150464 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150490 */     // GIR_Coverage, 17862,
     /* 2150490 */     GIR_EraseRootFromParent_Done,
     /* 2150491 */   // Label 28400: @2150491
     /* 2150491 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2150582), // Rule ID 17863 //
     /* 2150496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150542 */     // MIs[0] round
     /* 2150542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150545 */     // MIs[0] policy
     /* 2150545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150555 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150581 */     // GIR_Coverage, 17863,
     /* 2150581 */     GIR_EraseRootFromParent_Done,
     /* 2150582 */   // Label 28401: @2150582
     /* 2150582 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2150673), // Rule ID 17866 //
     /* 2150587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150633 */     // MIs[0] round
     /* 2150633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150636 */     // MIs[0] policy
     /* 2150636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150646 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150672 */     // GIR_Coverage, 17866,
     /* 2150672 */     GIR_EraseRootFromParent_Done,
     /* 2150673 */   // Label 28402: @2150673
     /* 2150673 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2150764), // Rule ID 17867 //
     /* 2150678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150724 */     // MIs[0] round
     /* 2150724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150727 */     // MIs[0] policy
     /* 2150727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150737 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150763 */     // GIR_Coverage, 17867,
     /* 2150763 */     GIR_EraseRootFromParent_Done,
     /* 2150764 */   // Label 28403: @2150764
     /* 2150764 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2150855), // Rule ID 17870 //
     /* 2150769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150815 */     // MIs[0] round
     /* 2150815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150818 */     // MIs[0] policy
     /* 2150818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150828 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150854 */     // GIR_Coverage, 17870,
     /* 2150854 */     GIR_EraseRootFromParent_Done,
     /* 2150855 */   // Label 28404: @2150855
     /* 2150855 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2150946), // Rule ID 17871 //
     /* 2150860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150906 */     // MIs[0] round
     /* 2150906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150909 */     // MIs[0] policy
     /* 2150909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150919 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150945 */     // GIR_Coverage, 17871,
     /* 2150945 */     GIR_EraseRootFromParent_Done,
     /* 2150946 */   // Label 28405: @2150946
     /* 2150946 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2151037), // Rule ID 17874 //
     /* 2150951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150997 */     // MIs[0] round
     /* 2150997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151000 */     // MIs[0] policy
     /* 2151000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151010 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2151013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151036 */     // GIR_Coverage, 17874,
     /* 2151036 */     GIR_EraseRootFromParent_Done,
     /* 2151037 */   // Label 28406: @2151037
     /* 2151037 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2151128), // Rule ID 17875 //
     /* 2151042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2151050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2151059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2151080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151088 */     // MIs[0] round
     /* 2151088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151091 */     // MIs[0] policy
     /* 2151091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151101 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2151104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151127 */     // GIR_Coverage, 17875,
     /* 2151127 */     GIR_EraseRootFromParent_Done,
     /* 2151128 */   // Label 28407: @2151128
     /* 2151128 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2151219), // Rule ID 17878 //
     /* 2151133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2151150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151179 */     // MIs[0] round
     /* 2151179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151182 */     // MIs[0] policy
     /* 2151182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151192 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2151195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151218 */     // GIR_Coverage, 17878,
     /* 2151218 */     GIR_EraseRootFromParent_Done,
     /* 2151219 */   // Label 28408: @2151219
     /* 2151219 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2151310), // Rule ID 17879 //
     /* 2151224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2151241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151270 */     // MIs[0] round
     /* 2151270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151273 */     // MIs[0] policy
     /* 2151273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151283 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2151286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151309 */     // GIR_Coverage, 17879,
     /* 2151309 */     GIR_EraseRootFromParent_Done,
     /* 2151310 */   // Label 28409: @2151310
     /* 2151310 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2151401), // Rule ID 17882 //
     /* 2151315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2151326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2151329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2151332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2151335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151361 */     // MIs[0] round
     /* 2151361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151364 */     // MIs[0] policy
     /* 2151364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151400 */     // GIR_Coverage, 17882,
     /* 2151400 */     GIR_EraseRootFromParent_Done,
     /* 2151401 */   // Label 28410: @2151401
     /* 2151401 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2151492), // Rule ID 17883 //
     /* 2151406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2151417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2151420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2151423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2151426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151452 */     // MIs[0] round
     /* 2151452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151455 */     // MIs[0] policy
     /* 2151455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151465 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151491 */     // GIR_Coverage, 17883,
     /* 2151491 */     GIR_EraseRootFromParent_Done,
     /* 2151492 */   // Label 28411: @2151492
     /* 2151492 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2151583), // Rule ID 17886 //
     /* 2151497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151543 */     // MIs[0] round
     /* 2151543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151546 */     // MIs[0] policy
     /* 2151546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151556 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151582 */     // GIR_Coverage, 17886,
     /* 2151582 */     GIR_EraseRootFromParent_Done,
     /* 2151583 */   // Label 28412: @2151583
     /* 2151583 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2151674), // Rule ID 17887 //
     /* 2151588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151634 */     // MIs[0] round
     /* 2151634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151637 */     // MIs[0] policy
     /* 2151637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151647 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151673 */     // GIR_Coverage, 17887,
     /* 2151673 */     GIR_EraseRootFromParent_Done,
     /* 2151674 */   // Label 28413: @2151674
     /* 2151674 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2151765), // Rule ID 17890 //
     /* 2151679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151725 */     // MIs[0] round
     /* 2151725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151728 */     // MIs[0] policy
     /* 2151728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151738 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151764 */     // GIR_Coverage, 17890,
     /* 2151764 */     GIR_EraseRootFromParent_Done,
     /* 2151765 */   // Label 28414: @2151765
     /* 2151765 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2151856), // Rule ID 17891 //
     /* 2151770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151816 */     // MIs[0] round
     /* 2151816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151819 */     // MIs[0] policy
     /* 2151819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151829 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151855 */     // GIR_Coverage, 17891,
     /* 2151855 */     GIR_EraseRootFromParent_Done,
     /* 2151856 */   // Label 28415: @2151856
     /* 2151856 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2151947), // Rule ID 17894 //
     /* 2151861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151907 */     // MIs[0] round
     /* 2151907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151910 */     // MIs[0] policy
     /* 2151910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151920 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151946 */     // GIR_Coverage, 17894,
     /* 2151946 */     GIR_EraseRootFromParent_Done,
     /* 2151947 */   // Label 28416: @2151947
     /* 2151947 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2152038), // Rule ID 17895 //
     /* 2151952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151998 */     // MIs[0] round
     /* 2151998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152001 */     // MIs[0] policy
     /* 2152001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152011 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2152014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152037 */     // GIR_Coverage, 17895,
     /* 2152037 */     GIR_EraseRootFromParent_Done,
     /* 2152038 */   // Label 28417: @2152038
     /* 2152038 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2152129), // Rule ID 17898 //
     /* 2152043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2152060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152089 */     // MIs[0] round
     /* 2152089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152092 */     // MIs[0] policy
     /* 2152092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2152105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152128 */     // GIR_Coverage, 17898,
     /* 2152128 */     GIR_EraseRootFromParent_Done,
     /* 2152129 */   // Label 28418: @2152129
     /* 2152129 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2152220), // Rule ID 17899 //
     /* 2152134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2152151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152180 */     // MIs[0] round
     /* 2152180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152183 */     // MIs[0] policy
     /* 2152183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152193 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2152196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152219 */     // GIR_Coverage, 17899,
     /* 2152219 */     GIR_EraseRootFromParent_Done,
     /* 2152220 */   // Label 28419: @2152220
     /* 2152220 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2152311), // Rule ID 17902 //
     /* 2152225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2152242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152271 */     // MIs[0] round
     /* 2152271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152274 */     // MIs[0] policy
     /* 2152274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152284 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2152287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152310 */     // GIR_Coverage, 17902,
     /* 2152310 */     GIR_EraseRootFromParent_Done,
     /* 2152311 */   // Label 28420: @2152311
     /* 2152311 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2152402), // Rule ID 17903 //
     /* 2152316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2152327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2152330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2152333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2152336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152362 */     // MIs[0] round
     /* 2152362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152365 */     // MIs[0] policy
     /* 2152365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152375 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2152378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152401 */     // GIR_Coverage, 17903,
     /* 2152401 */     GIR_EraseRootFromParent_Done,
     /* 2152402 */   // Label 28421: @2152402
     /* 2152402 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2152493), // Rule ID 17906 //
     /* 2152407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152453 */     // MIs[0] round
     /* 2152453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152456 */     // MIs[0] policy
     /* 2152456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152466 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152492 */     // GIR_Coverage, 17906,
     /* 2152492 */     GIR_EraseRootFromParent_Done,
     /* 2152493 */   // Label 28422: @2152493
     /* 2152493 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2152584), // Rule ID 17907 //
     /* 2152498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152544 */     // MIs[0] round
     /* 2152544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152547 */     // MIs[0] policy
     /* 2152547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152557 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152583 */     // GIR_Coverage, 17907,
     /* 2152583 */     GIR_EraseRootFromParent_Done,
     /* 2152584 */   // Label 28423: @2152584
     /* 2152584 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2152675), // Rule ID 17910 //
     /* 2152589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152635 */     // MIs[0] round
     /* 2152635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152638 */     // MIs[0] policy
     /* 2152638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152648 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152674 */     // GIR_Coverage, 17910,
     /* 2152674 */     GIR_EraseRootFromParent_Done,
     /* 2152675 */   // Label 28424: @2152675
     /* 2152675 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2152766), // Rule ID 17911 //
     /* 2152680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152726 */     // MIs[0] round
     /* 2152726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152729 */     // MIs[0] policy
     /* 2152729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152739 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152765 */     // GIR_Coverage, 17911,
     /* 2152765 */     GIR_EraseRootFromParent_Done,
     /* 2152766 */   // Label 28425: @2152766
     /* 2152766 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2152857), // Rule ID 17914 //
     /* 2152771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152817 */     // MIs[0] round
     /* 2152817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152820 */     // MIs[0] policy
     /* 2152820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152856 */     // GIR_Coverage, 17914,
     /* 2152856 */     GIR_EraseRootFromParent_Done,
     /* 2152857 */   // Label 28426: @2152857
     /* 2152857 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2152948), // Rule ID 17915 //
     /* 2152862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152908 */     // MIs[0] round
     /* 2152908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152911 */     // MIs[0] policy
     /* 2152911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152921 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152947 */     // GIR_Coverage, 17915,
     /* 2152947 */     GIR_EraseRootFromParent_Done,
     /* 2152948 */   // Label 28427: @2152948
     /* 2152948 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2153039), // Rule ID 17918 //
     /* 2152953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152999 */     // MIs[0] round
     /* 2152999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153002 */     // MIs[0] policy
     /* 2153002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2153015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153038 */     // GIR_Coverage, 17918,
     /* 2153038 */     GIR_EraseRootFromParent_Done,
     /* 2153039 */   // Label 28428: @2153039
     /* 2153039 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2153130), // Rule ID 17919 //
     /* 2153044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2153061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153090 */     // MIs[0] round
     /* 2153090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153093 */     // MIs[0] policy
     /* 2153093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153103 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2153106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153129 */     // GIR_Coverage, 17919,
     /* 2153129 */     GIR_EraseRootFromParent_Done,
     /* 2153130 */   // Label 28429: @2153130
     /* 2153130 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2153221), // Rule ID 17922 //
     /* 2153135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2153152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153181 */     // MIs[0] round
     /* 2153181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153184 */     // MIs[0] policy
     /* 2153184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153194 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2153197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153220 */     // GIR_Coverage, 17922,
     /* 2153220 */     GIR_EraseRootFromParent_Done,
     /* 2153221 */   // Label 28430: @2153221
     /* 2153221 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2153312), // Rule ID 17923 //
     /* 2153226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2153243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2153246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153272 */     // MIs[0] round
     /* 2153272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153275 */     // MIs[0] policy
     /* 2153275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153285 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2153288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153311 */     // GIR_Coverage, 17923,
     /* 2153311 */     GIR_EraseRootFromParent_Done,
     /* 2153312 */   // Label 28431: @2153312
     /* 2153312 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2153403), // Rule ID 17926 //
     /* 2153317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2153328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2153331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2153334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2153337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153363 */     // MIs[0] round
     /* 2153363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153366 */     // MIs[0] policy
     /* 2153366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153402 */     // GIR_Coverage, 17926,
     /* 2153402 */     GIR_EraseRootFromParent_Done,
     /* 2153403 */   // Label 28432: @2153403
     /* 2153403 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2153494), // Rule ID 17927 //
     /* 2153408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2153419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2153422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2153425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2153428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153454 */     // MIs[0] round
     /* 2153454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153457 */     // MIs[0] policy
     /* 2153457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153467 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153493 */     // GIR_Coverage, 17927,
     /* 2153493 */     GIR_EraseRootFromParent_Done,
     /* 2153494 */   // Label 28433: @2153494
     /* 2153494 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2153585), // Rule ID 17930 //
     /* 2153499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153545 */     // MIs[0] round
     /* 2153545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153548 */     // MIs[0] policy
     /* 2153548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153584 */     // GIR_Coverage, 17930,
     /* 2153584 */     GIR_EraseRootFromParent_Done,
     /* 2153585 */   // Label 28434: @2153585
     /* 2153585 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2153676), // Rule ID 17931 //
     /* 2153590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153636 */     // MIs[0] round
     /* 2153636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153639 */     // MIs[0] policy
     /* 2153639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153649 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153675 */     // GIR_Coverage, 17931,
     /* 2153675 */     GIR_EraseRootFromParent_Done,
     /* 2153676 */   // Label 28435: @2153676
     /* 2153676 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2153767), // Rule ID 17934 //
     /* 2153681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153727 */     // MIs[0] round
     /* 2153727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153730 */     // MIs[0] policy
     /* 2153730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153740 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153766 */     // GIR_Coverage, 17934,
     /* 2153766 */     GIR_EraseRootFromParent_Done,
     /* 2153767 */   // Label 28436: @2153767
     /* 2153767 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2153858), // Rule ID 17935 //
     /* 2153772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153818 */     // MIs[0] round
     /* 2153818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153821 */     // MIs[0] policy
     /* 2153821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153831 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153857 */     // GIR_Coverage, 17935,
     /* 2153857 */     GIR_EraseRootFromParent_Done,
     /* 2153858 */   // Label 28437: @2153858
     /* 2153858 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2153949), // Rule ID 17938 //
     /* 2153863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153909 */     // MIs[0] round
     /* 2153909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153912 */     // MIs[0] policy
     /* 2153912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153922 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153948 */     // GIR_Coverage, 17938,
     /* 2153948 */     GIR_EraseRootFromParent_Done,
     /* 2153949 */   // Label 28438: @2153949
     /* 2153949 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2154040), // Rule ID 17939 //
     /* 2153954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154000 */     // MIs[0] round
     /* 2154000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154003 */     // MIs[0] policy
     /* 2154003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154013 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2154016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154039 */     // GIR_Coverage, 17939,
     /* 2154039 */     GIR_EraseRootFromParent_Done,
     /* 2154040 */   // Label 28439: @2154040
     /* 2154040 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2154131), // Rule ID 17942 //
     /* 2154045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154091 */     // MIs[0] round
     /* 2154091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154094 */     // MIs[0] policy
     /* 2154094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154104 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2154107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154130 */     // GIR_Coverage, 17942,
     /* 2154130 */     GIR_EraseRootFromParent_Done,
     /* 2154131 */   // Label 28440: @2154131
     /* 2154131 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2154222), // Rule ID 17943 //
     /* 2154136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154182 */     // MIs[0] round
     /* 2154182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154185 */     // MIs[0] policy
     /* 2154185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154195 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2154198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154221 */     // GIR_Coverage, 17943,
     /* 2154221 */     GIR_EraseRootFromParent_Done,
     /* 2154222 */   // Label 28441: @2154222
     /* 2154222 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2154313), // Rule ID 17946 //
     /* 2154227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154273 */     // MIs[0] round
     /* 2154273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154276 */     // MIs[0] policy
     /* 2154276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154286 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2154289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154312 */     // GIR_Coverage, 17946,
     /* 2154312 */     GIR_EraseRootFromParent_Done,
     /* 2154313 */   // Label 28442: @2154313
     /* 2154313 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2154404), // Rule ID 17947 //
     /* 2154318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2154329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2154332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2154338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154364 */     // MIs[0] round
     /* 2154364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154367 */     // MIs[0] policy
     /* 2154367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154377 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2154380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154403 */     // GIR_Coverage, 17947,
     /* 2154403 */     GIR_EraseRootFromParent_Done,
     /* 2154404 */   // Label 28443: @2154404
     /* 2154404 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2154495), // Rule ID 17950 //
     /* 2154409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154455 */     // MIs[0] round
     /* 2154455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154458 */     // MIs[0] policy
     /* 2154458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154468 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154494 */     // GIR_Coverage, 17950,
     /* 2154494 */     GIR_EraseRootFromParent_Done,
     /* 2154495 */   // Label 28444: @2154495
     /* 2154495 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2154586), // Rule ID 17951 //
     /* 2154500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154546 */     // MIs[0] round
     /* 2154546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154549 */     // MIs[0] policy
     /* 2154549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154559 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11298:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154585 */     // GIR_Coverage, 17951,
     /* 2154585 */     GIR_EraseRootFromParent_Done,
     /* 2154586 */   // Label 28445: @2154586
     /* 2154586 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2154677), // Rule ID 17954 //
     /* 2154591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154637 */     // MIs[0] round
     /* 2154637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154640 */     // MIs[0] policy
     /* 2154640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154676 */     // GIR_Coverage, 17954,
     /* 2154676 */     GIR_EraseRootFromParent_Done,
     /* 2154677 */   // Label 28446: @2154677
     /* 2154677 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2154768), // Rule ID 17955 //
     /* 2154682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154728 */     // MIs[0] round
     /* 2154728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154731 */     // MIs[0] policy
     /* 2154731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154741 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11298:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154767 */     // GIR_Coverage, 17955,
     /* 2154767 */     GIR_EraseRootFromParent_Done,
     /* 2154768 */   // Label 28447: @2154768
     /* 2154768 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2154859), // Rule ID 17958 //
     /* 2154773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154819 */     // MIs[0] round
     /* 2154819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154822 */     // MIs[0] policy
     /* 2154822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154832 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154858 */     // GIR_Coverage, 17958,
     /* 2154858 */     GIR_EraseRootFromParent_Done,
     /* 2154859 */   // Label 28448: @2154859
     /* 2154859 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2154950), // Rule ID 17959 //
     /* 2154864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154910 */     // MIs[0] round
     /* 2154910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154913 */     // MIs[0] policy
     /* 2154913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154923 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11298:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154949 */     // GIR_Coverage, 17959,
     /* 2154949 */     GIR_EraseRootFromParent_Done,
     /* 2154950 */   // Label 28449: @2154950
     /* 2154950 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2155041), // Rule ID 17962 //
     /* 2154955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155001 */     // MIs[0] round
     /* 2155001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155004 */     // MIs[0] policy
     /* 2155004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2155017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155040 */     // GIR_Coverage, 17962,
     /* 2155040 */     GIR_EraseRootFromParent_Done,
     /* 2155041 */   // Label 28450: @2155041
     /* 2155041 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2155132), // Rule ID 17963 //
     /* 2155046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155092 */     // MIs[0] round
     /* 2155092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155095 */     // MIs[0] policy
     /* 2155095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155105 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2155108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155131 */     // GIR_Coverage, 17963,
     /* 2155131 */     GIR_EraseRootFromParent_Done,
     /* 2155132 */   // Label 28451: @2155132
     /* 2155132 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2155223), // Rule ID 17966 //
     /* 2155137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155183 */     // MIs[0] round
     /* 2155183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155186 */     // MIs[0] policy
     /* 2155186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2155199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155222 */     // GIR_Coverage, 17966,
     /* 2155222 */     GIR_EraseRootFromParent_Done,
     /* 2155223 */   // Label 28452: @2155223
     /* 2155223 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2155314), // Rule ID 17967 //
     /* 2155228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2155248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155274 */     // MIs[0] round
     /* 2155274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155277 */     // MIs[0] policy
     /* 2155277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155287 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2155290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155313 */     // GIR_Coverage, 17967,
     /* 2155313 */     GIR_EraseRootFromParent_Done,
     /* 2155314 */   // Label 28453: @2155314
     /* 2155314 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2155405), // Rule ID 17970 //
     /* 2155319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2155330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2155333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2155339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2155342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155365 */     // MIs[0] round
     /* 2155365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155368 */     // MIs[0] policy
     /* 2155368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155378 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155404 */     // GIR_Coverage, 17970,
     /* 2155404 */     GIR_EraseRootFromParent_Done,
     /* 2155405 */   // Label 28454: @2155405
     /* 2155405 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2155496), // Rule ID 17971 //
     /* 2155410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2155421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2155424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2155427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2155430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2155433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2155448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155456 */     // MIs[0] round
     /* 2155456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155459 */     // MIs[0] policy
     /* 2155459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155469 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155495 */     // GIR_Coverage, 17971,
     /* 2155495 */     GIR_EraseRootFromParent_Done,
     /* 2155496 */   // Label 28455: @2155496
     /* 2155496 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2155587), // Rule ID 17974 //
     /* 2155501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155547 */     // MIs[0] round
     /* 2155547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155550 */     // MIs[0] policy
     /* 2155550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155560 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155586 */     // GIR_Coverage, 17974,
     /* 2155586 */     GIR_EraseRootFromParent_Done,
     /* 2155587 */   // Label 28456: @2155587
     /* 2155587 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2155678), // Rule ID 17975 //
     /* 2155592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155638 */     // MIs[0] round
     /* 2155638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155641 */     // MIs[0] policy
     /* 2155641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155677 */     // GIR_Coverage, 17975,
     /* 2155677 */     GIR_EraseRootFromParent_Done,
     /* 2155678 */   // Label 28457: @2155678
     /* 2155678 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2155769), // Rule ID 17978 //
     /* 2155683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155729 */     // MIs[0] round
     /* 2155729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155732 */     // MIs[0] policy
     /* 2155732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155742 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155768 */     // GIR_Coverage, 17978,
     /* 2155768 */     GIR_EraseRootFromParent_Done,
     /* 2155769 */   // Label 28458: @2155769
     /* 2155769 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2155860), // Rule ID 17979 //
     /* 2155774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155820 */     // MIs[0] round
     /* 2155820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155823 */     // MIs[0] policy
     /* 2155823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155833 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155859 */     // GIR_Coverage, 17979,
     /* 2155859 */     GIR_EraseRootFromParent_Done,
     /* 2155860 */   // Label 28459: @2155860
     /* 2155860 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2155951), // Rule ID 17982 //
     /* 2155865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155911 */     // MIs[0] round
     /* 2155911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155914 */     // MIs[0] policy
     /* 2155914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155924 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155950 */     // GIR_Coverage, 17982,
     /* 2155950 */     GIR_EraseRootFromParent_Done,
     /* 2155951 */   // Label 28460: @2155951
     /* 2155951 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2156042), // Rule ID 17983 //
     /* 2155956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156002 */     // MIs[0] round
     /* 2156002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156005 */     // MIs[0] policy
     /* 2156005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156015 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2156018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156041 */     // GIR_Coverage, 17983,
     /* 2156041 */     GIR_EraseRootFromParent_Done,
     /* 2156042 */   // Label 28461: @2156042
     /* 2156042 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2156133), // Rule ID 17986 //
     /* 2156047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156093 */     // MIs[0] round
     /* 2156093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156096 */     // MIs[0] policy
     /* 2156096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156106 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2156109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156132 */     // GIR_Coverage, 17986,
     /* 2156132 */     GIR_EraseRootFromParent_Done,
     /* 2156133 */   // Label 28462: @2156133
     /* 2156133 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2156224), // Rule ID 17987 //
     /* 2156138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156184 */     // MIs[0] round
     /* 2156184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156187 */     // MIs[0] policy
     /* 2156187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156197 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11298:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2156200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156223 */     // GIR_Coverage, 17987,
     /* 2156223 */     GIR_EraseRootFromParent_Done,
     /* 2156224 */   // Label 28463: @2156224
     /* 2156224 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2156315), // Rule ID 17990 //
     /* 2156229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156275 */     // MIs[0] round
     /* 2156275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156278 */     // MIs[0] policy
     /* 2156278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156288 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2156291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156314 */     // GIR_Coverage, 17990,
     /* 2156314 */     GIR_EraseRootFromParent_Done,
     /* 2156315 */   // Label 28464: @2156315
     /* 2156315 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2156406), // Rule ID 17991 //
     /* 2156320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2156331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2156334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2156340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156366 */     // MIs[0] round
     /* 2156366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156369 */     // MIs[0] policy
     /* 2156369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156379 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11298:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2156382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156405 */     // GIR_Coverage, 17991,
     /* 2156405 */     GIR_EraseRootFromParent_Done,
     /* 2156406 */   // Label 28465: @2156406
     /* 2156406 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2156497), // Rule ID 17994 //
     /* 2156411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156457 */     // MIs[0] round
     /* 2156457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156460 */     // MIs[0] policy
     /* 2156460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156470 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156496 */     // GIR_Coverage, 17994,
     /* 2156496 */     GIR_EraseRootFromParent_Done,
     /* 2156497 */   // Label 28466: @2156497
     /* 2156497 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2156588), // Rule ID 17995 //
     /* 2156502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156548 */     // MIs[0] round
     /* 2156548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156551 */     // MIs[0] policy
     /* 2156551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156561 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11298:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156587 */     // GIR_Coverage, 17995,
     /* 2156587 */     GIR_EraseRootFromParent_Done,
     /* 2156588 */   // Label 28467: @2156588
     /* 2156588 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2156679), // Rule ID 17998 //
     /* 2156593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156639 */     // MIs[0] round
     /* 2156639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156642 */     // MIs[0] policy
     /* 2156642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156678 */     // GIR_Coverage, 17998,
     /* 2156678 */     GIR_EraseRootFromParent_Done,
     /* 2156679 */   // Label 28468: @2156679
     /* 2156679 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2156770), // Rule ID 17999 //
     /* 2156684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156730 */     // MIs[0] round
     /* 2156730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156733 */     // MIs[0] policy
     /* 2156733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156743 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156769 */     // GIR_Coverage, 17999,
     /* 2156769 */     GIR_EraseRootFromParent_Done,
     /* 2156770 */   // Label 28469: @2156770
     /* 2156770 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2156861), // Rule ID 18002 //
     /* 2156775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156821 */     // MIs[0] round
     /* 2156821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156824 */     // MIs[0] policy
     /* 2156824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156834 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156860 */     // GIR_Coverage, 18002,
     /* 2156860 */     GIR_EraseRootFromParent_Done,
     /* 2156861 */   // Label 28470: @2156861
     /* 2156861 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2156952), // Rule ID 18003 //
     /* 2156866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156912 */     // MIs[0] round
     /* 2156912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156915 */     // MIs[0] policy
     /* 2156915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156925 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156951 */     // GIR_Coverage, 18003,
     /* 2156951 */     GIR_EraseRootFromParent_Done,
     /* 2156952 */   // Label 28471: @2156952
     /* 2156952 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2157043), // Rule ID 18006 //
     /* 2156957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157003 */     // MIs[0] round
     /* 2157003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157006 */     // MIs[0] policy
     /* 2157006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157016 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2157019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157042 */     // GIR_Coverage, 18006,
     /* 2157042 */     GIR_EraseRootFromParent_Done,
     /* 2157043 */   // Label 28472: @2157043
     /* 2157043 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2157134), // Rule ID 18007 //
     /* 2157048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2157065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157094 */     // MIs[0] round
     /* 2157094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157097 */     // MIs[0] policy
     /* 2157097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157107 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2157110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157133 */     // GIR_Coverage, 18007,
     /* 2157133 */     GIR_EraseRootFromParent_Done,
     /* 2157134 */   // Label 28473: @2157134
     /* 2157134 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2157225), // Rule ID 18010 //
     /* 2157139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157185 */     // MIs[0] round
     /* 2157185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157188 */     // MIs[0] policy
     /* 2157188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157198 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2157201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157224 */     // GIR_Coverage, 18010,
     /* 2157224 */     GIR_EraseRootFromParent_Done,
     /* 2157225 */   // Label 28474: @2157225
     /* 2157225 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2157316), // Rule ID 18011 //
     /* 2157230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2157247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2157250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157276 */     // MIs[0] round
     /* 2157276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157279 */     // MIs[0] policy
     /* 2157279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157289 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2157292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157315 */     // GIR_Coverage, 18011,
     /* 2157315 */     GIR_EraseRootFromParent_Done,
     /* 2157316 */   // Label 28475: @2157316
     /* 2157316 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2157407), // Rule ID 18014 //
     /* 2157321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2157332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2157335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2157338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2157341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157367 */     // MIs[0] round
     /* 2157367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157370 */     // MIs[0] policy
     /* 2157370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157406 */     // GIR_Coverage, 18014,
     /* 2157406 */     GIR_EraseRootFromParent_Done,
     /* 2157407 */   // Label 28476: @2157407
     /* 2157407 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2157498), // Rule ID 18015 //
     /* 2157412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2157423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2157426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2157429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2157432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157458 */     // MIs[0] round
     /* 2157458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157461 */     // MIs[0] policy
     /* 2157461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157471 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157497 */     // GIR_Coverage, 18015,
     /* 2157497 */     GIR_EraseRootFromParent_Done,
     /* 2157498 */   // Label 28477: @2157498
     /* 2157498 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2157589), // Rule ID 18018 //
     /* 2157503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157549 */     // MIs[0] round
     /* 2157549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157552 */     // MIs[0] policy
     /* 2157552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157562 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157588 */     // GIR_Coverage, 18018,
     /* 2157588 */     GIR_EraseRootFromParent_Done,
     /* 2157589 */   // Label 28478: @2157589
     /* 2157589 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2157680), // Rule ID 18019 //
     /* 2157594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157640 */     // MIs[0] round
     /* 2157640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157643 */     // MIs[0] policy
     /* 2157643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157653 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157679 */     // GIR_Coverage, 18019,
     /* 2157679 */     GIR_EraseRootFromParent_Done,
     /* 2157680 */   // Label 28479: @2157680
     /* 2157680 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2157771), // Rule ID 18022 //
     /* 2157685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157731 */     // MIs[0] round
     /* 2157731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157734 */     // MIs[0] policy
     /* 2157734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157744 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157770 */     // GIR_Coverage, 18022,
     /* 2157770 */     GIR_EraseRootFromParent_Done,
     /* 2157771 */   // Label 28480: @2157771
     /* 2157771 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2157862), // Rule ID 18023 //
     /* 2157776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157822 */     // MIs[0] round
     /* 2157822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157825 */     // MIs[0] policy
     /* 2157825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157835 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157861 */     // GIR_Coverage, 18023,
     /* 2157861 */     GIR_EraseRootFromParent_Done,
     /* 2157862 */   // Label 28481: @2157862
     /* 2157862 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2157953), // Rule ID 18026 //
     /* 2157867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157913 */     // MIs[0] round
     /* 2157913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157916 */     // MIs[0] policy
     /* 2157916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157926 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157952 */     // GIR_Coverage, 18026,
     /* 2157952 */     GIR_EraseRootFromParent_Done,
     /* 2157953 */   // Label 28482: @2157953
     /* 2157953 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2158044), // Rule ID 18027 //
     /* 2157958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158004 */     // MIs[0] round
     /* 2158004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158007 */     // MIs[0] policy
     /* 2158007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158017 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2158020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158043 */     // GIR_Coverage, 18027,
     /* 2158043 */     GIR_EraseRootFromParent_Done,
     /* 2158044 */   // Label 28483: @2158044
     /* 2158044 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2158135), // Rule ID 18030 //
     /* 2158049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2158066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158095 */     // MIs[0] round
     /* 2158095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158098 */     // MIs[0] policy
     /* 2158098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158108 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2158111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158134 */     // GIR_Coverage, 18030,
     /* 2158134 */     GIR_EraseRootFromParent_Done,
     /* 2158135 */   // Label 28484: @2158135
     /* 2158135 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2158226), // Rule ID 18031 //
     /* 2158140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2158157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158186 */     // MIs[0] round
     /* 2158186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158189 */     // MIs[0] policy
     /* 2158189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158199 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2158202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158225 */     // GIR_Coverage, 18031,
     /* 2158225 */     GIR_EraseRootFromParent_Done,
     /* 2158226 */   // Label 28485: @2158226
     /* 2158226 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2158317), // Rule ID 18034 //
     /* 2158231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2158248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158277 */     // MIs[0] round
     /* 2158277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158280 */     // MIs[0] policy
     /* 2158280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158290 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2158293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158316 */     // GIR_Coverage, 18034,
     /* 2158316 */     GIR_EraseRootFromParent_Done,
     /* 2158317 */   // Label 28486: @2158317
     /* 2158317 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2158408), // Rule ID 18035 //
     /* 2158322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2158333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2158336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2158339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2158342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158368 */     // MIs[0] round
     /* 2158368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158371 */     // MIs[0] policy
     /* 2158371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158381 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2158384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158407 */     // GIR_Coverage, 18035,
     /* 2158407 */     GIR_EraseRootFromParent_Done,
     /* 2158408 */   // Label 28487: @2158408
     /* 2158408 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2158499), // Rule ID 18038 //
     /* 2158413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158459 */     // MIs[0] round
     /* 2158459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158462 */     // MIs[0] policy
     /* 2158462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158472 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158498 */     // GIR_Coverage, 18038,
     /* 2158498 */     GIR_EraseRootFromParent_Done,
     /* 2158499 */   // Label 28488: @2158499
     /* 2158499 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2158590), // Rule ID 18039 //
     /* 2158504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158550 */     // MIs[0] round
     /* 2158550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158553 */     // MIs[0] policy
     /* 2158553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158563 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158589 */     // GIR_Coverage, 18039,
     /* 2158589 */     GIR_EraseRootFromParent_Done,
     /* 2158590 */   // Label 28489: @2158590
     /* 2158590 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2158681), // Rule ID 18042 //
     /* 2158595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158641 */     // MIs[0] round
     /* 2158641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158644 */     // MIs[0] policy
     /* 2158644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158654 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158680 */     // GIR_Coverage, 18042,
     /* 2158680 */     GIR_EraseRootFromParent_Done,
     /* 2158681 */   // Label 28490: @2158681
     /* 2158681 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2158772), // Rule ID 18043 //
     /* 2158686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158732 */     // MIs[0] round
     /* 2158732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158735 */     // MIs[0] policy
     /* 2158735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158745 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158771 */     // GIR_Coverage, 18043,
     /* 2158771 */     GIR_EraseRootFromParent_Done,
     /* 2158772 */   // Label 28491: @2158772
     /* 2158772 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2158863), // Rule ID 18046 //
     /* 2158777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158823 */     // MIs[0] round
     /* 2158823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158826 */     // MIs[0] policy
     /* 2158826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158862 */     // GIR_Coverage, 18046,
     /* 2158862 */     GIR_EraseRootFromParent_Done,
     /* 2158863 */   // Label 28492: @2158863
     /* 2158863 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2158954), // Rule ID 18047 //
     /* 2158868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158914 */     // MIs[0] round
     /* 2158914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158917 */     // MIs[0] policy
     /* 2158917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158927 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158953 */     // GIR_Coverage, 18047,
     /* 2158953 */     GIR_EraseRootFromParent_Done,
     /* 2158954 */   // Label 28493: @2158954
     /* 2158954 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2159045), // Rule ID 18050 //
     /* 2158959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159005 */     // MIs[0] round
     /* 2159005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159008 */     // MIs[0] policy
     /* 2159008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159018 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2159021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159044 */     // GIR_Coverage, 18050,
     /* 2159044 */     GIR_EraseRootFromParent_Done,
     /* 2159045 */   // Label 28494: @2159045
     /* 2159045 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2159136), // Rule ID 18051 //
     /* 2159050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2159067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159096 */     // MIs[0] round
     /* 2159096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159099 */     // MIs[0] policy
     /* 2159099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159109 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2159112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159135 */     // GIR_Coverage, 18051,
     /* 2159135 */     GIR_EraseRootFromParent_Done,
     /* 2159136 */   // Label 28495: @2159136
     /* 2159136 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2159227), // Rule ID 18054 //
     /* 2159141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2159158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159187 */     // MIs[0] round
     /* 2159187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159190 */     // MIs[0] policy
     /* 2159190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159200 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2159203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159226 */     // GIR_Coverage, 18054,
     /* 2159226 */     GIR_EraseRootFromParent_Done,
     /* 2159227 */   // Label 28496: @2159227
     /* 2159227 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2159318), // Rule ID 18055 //
     /* 2159232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2159246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2159249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2159252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159278 */     // MIs[0] round
     /* 2159278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159281 */     // MIs[0] policy
     /* 2159281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159291 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2159294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159317 */     // GIR_Coverage, 18055,
     /* 2159317 */     GIR_EraseRootFromParent_Done,
     /* 2159318 */   // Label 28497: @2159318
     /* 2159318 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2159409), // Rule ID 18058 //
     /* 2159323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2159334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2159337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2159343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159369 */     // MIs[0] round
     /* 2159369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159372 */     // MIs[0] policy
     /* 2159372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159382 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159408 */     // GIR_Coverage, 18058,
     /* 2159408 */     GIR_EraseRootFromParent_Done,
     /* 2159409 */   // Label 28498: @2159409
     /* 2159409 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2159500), // Rule ID 18059 //
     /* 2159414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2159425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2159428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2159434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159460 */     // MIs[0] round
     /* 2159460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159463 */     // MIs[0] policy
     /* 2159463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159473 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159499 */     // GIR_Coverage, 18059,
     /* 2159499 */     GIR_EraseRootFromParent_Done,
     /* 2159500 */   // Label 28499: @2159500
     /* 2159500 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2159591), // Rule ID 18062 //
     /* 2159505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159551 */     // MIs[0] round
     /* 2159551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159554 */     // MIs[0] policy
     /* 2159554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159564 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159590 */     // GIR_Coverage, 18062,
     /* 2159590 */     GIR_EraseRootFromParent_Done,
     /* 2159591 */   // Label 28500: @2159591
     /* 2159591 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2159682), // Rule ID 18063 //
     /* 2159596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159642 */     // MIs[0] round
     /* 2159642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159645 */     // MIs[0] policy
     /* 2159645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159655 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159681 */     // GIR_Coverage, 18063,
     /* 2159681 */     GIR_EraseRootFromParent_Done,
     /* 2159682 */   // Label 28501: @2159682
     /* 2159682 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2159773), // Rule ID 18066 //
     /* 2159687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159733 */     // MIs[0] round
     /* 2159733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159736 */     // MIs[0] policy
     /* 2159736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159746 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159772 */     // GIR_Coverage, 18066,
     /* 2159772 */     GIR_EraseRootFromParent_Done,
     /* 2159773 */   // Label 28502: @2159773
     /* 2159773 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2159864), // Rule ID 18067 //
     /* 2159778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159824 */     // MIs[0] round
     /* 2159824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159827 */     // MIs[0] policy
     /* 2159827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159837 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159863 */     // GIR_Coverage, 18067,
     /* 2159863 */     GIR_EraseRootFromParent_Done,
     /* 2159864 */   // Label 28503: @2159864
     /* 2159864 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2159955), // Rule ID 18070 //
     /* 2159869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159915 */     // MIs[0] round
     /* 2159915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159918 */     // MIs[0] policy
     /* 2159918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159928 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159954 */     // GIR_Coverage, 18070,
     /* 2159954 */     GIR_EraseRootFromParent_Done,
     /* 2159955 */   // Label 28504: @2159955
     /* 2159955 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2160046), // Rule ID 18071 //
     /* 2159960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160006 */     // MIs[0] round
     /* 2160006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160009 */     // MIs[0] policy
     /* 2160009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160019 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2160022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160045 */     // GIR_Coverage, 18071,
     /* 2160045 */     GIR_EraseRootFromParent_Done,
     /* 2160046 */   // Label 28505: @2160046
     /* 2160046 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2160137), // Rule ID 18074 //
     /* 2160051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160097 */     // MIs[0] round
     /* 2160097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160100 */     // MIs[0] policy
     /* 2160100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160110 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2160113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160136 */     // GIR_Coverage, 18074,
     /* 2160136 */     GIR_EraseRootFromParent_Done,
     /* 2160137 */   // Label 28506: @2160137
     /* 2160137 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2160228), // Rule ID 18075 //
     /* 2160142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160188 */     // MIs[0] round
     /* 2160188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160191 */     // MIs[0] policy
     /* 2160191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160201 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2160204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160227 */     // GIR_Coverage, 18075,
     /* 2160227 */     GIR_EraseRootFromParent_Done,
     /* 2160228 */   // Label 28507: @2160228
     /* 2160228 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2160319), // Rule ID 18078 //
     /* 2160233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2160236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160279 */     // MIs[0] round
     /* 2160279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160282 */     // MIs[0] policy
     /* 2160282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160292 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2160295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160318 */     // GIR_Coverage, 18078,
     /* 2160318 */     GIR_EraseRootFromParent_Done,
     /* 2160319 */   // Label 28508: @2160319
     /* 2160319 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2160410), // Rule ID 18079 //
     /* 2160324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2160327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2160335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2160338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2160344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160370 */     // MIs[0] round
     /* 2160370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160373 */     // MIs[0] policy
     /* 2160373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2160386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160409 */     // GIR_Coverage, 18079,
     /* 2160409 */     GIR_EraseRootFromParent_Done,
     /* 2160410 */   // Label 28509: @2160410
     /* 2160410 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2160501), // Rule ID 18082 //
     /* 2160415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160461 */     // MIs[0] round
     /* 2160461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160464 */     // MIs[0] policy
     /* 2160464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160474 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160500 */     // GIR_Coverage, 18082,
     /* 2160500 */     GIR_EraseRootFromParent_Done,
     /* 2160501 */   // Label 28510: @2160501
     /* 2160501 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2160592), // Rule ID 18083 //
     /* 2160506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160552 */     // MIs[0] round
     /* 2160552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160555 */     // MIs[0] policy
     /* 2160555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160565 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160591 */     // GIR_Coverage, 18083,
     /* 2160591 */     GIR_EraseRootFromParent_Done,
     /* 2160592 */   // Label 28511: @2160592
     /* 2160592 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2160683), // Rule ID 18086 //
     /* 2160597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160643 */     // MIs[0] round
     /* 2160643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160646 */     // MIs[0] policy
     /* 2160646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160682 */     // GIR_Coverage, 18086,
     /* 2160682 */     GIR_EraseRootFromParent_Done,
     /* 2160683 */   // Label 28512: @2160683
     /* 2160683 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2160774), // Rule ID 18087 //
     /* 2160688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160734 */     // MIs[0] round
     /* 2160734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160737 */     // MIs[0] policy
     /* 2160737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160747 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160773 */     // GIR_Coverage, 18087,
     /* 2160773 */     GIR_EraseRootFromParent_Done,
     /* 2160774 */   // Label 28513: @2160774
     /* 2160774 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2160865), // Rule ID 18090 //
     /* 2160779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160825 */     // MIs[0] round
     /* 2160825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160828 */     // MIs[0] policy
     /* 2160828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160838 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160864 */     // GIR_Coverage, 18090,
     /* 2160864 */     GIR_EraseRootFromParent_Done,
     /* 2160865 */   // Label 28514: @2160865
     /* 2160865 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2160956), // Rule ID 18091 //
     /* 2160870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160916 */     // MIs[0] round
     /* 2160916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160919 */     // MIs[0] policy
     /* 2160919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160929 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160955 */     // GIR_Coverage, 18091,
     /* 2160955 */     GIR_EraseRootFromParent_Done,
     /* 2160956 */   // Label 28515: @2160956
     /* 2160956 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2161047), // Rule ID 18094 //
     /* 2160961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161007 */     // MIs[0] round
     /* 2161007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161010 */     // MIs[0] policy
     /* 2161010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2161023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161046 */     // GIR_Coverage, 18094,
     /* 2161046 */     GIR_EraseRootFromParent_Done,
     /* 2161047 */   // Label 28516: @2161047
     /* 2161047 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2161138), // Rule ID 18095 //
     /* 2161052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161098 */     // MIs[0] round
     /* 2161098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161101 */     // MIs[0] policy
     /* 2161101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161111 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2161114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161137 */     // GIR_Coverage, 18095,
     /* 2161137 */     GIR_EraseRootFromParent_Done,
     /* 2161138 */   // Label 28517: @2161138
     /* 2161138 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2161229), // Rule ID 18098 //
     /* 2161143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161189 */     // MIs[0] round
     /* 2161189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161192 */     // MIs[0] policy
     /* 2161192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161202 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2161205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161228 */     // GIR_Coverage, 18098,
     /* 2161228 */     GIR_EraseRootFromParent_Done,
     /* 2161229 */   // Label 28518: @2161229
     /* 2161229 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2161320), // Rule ID 18099 //
     /* 2161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2161248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2161254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161280 */     // MIs[0] round
     /* 2161280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161283 */     // MIs[0] policy
     /* 2161283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161293 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2161296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161319 */     // GIR_Coverage, 18099,
     /* 2161319 */     GIR_EraseRootFromParent_Done,
     /* 2161320 */   // Label 28519: @2161320
     /* 2161320 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2161411), // Rule ID 18102 //
     /* 2161325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2161336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2161339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2161345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161371 */     // MIs[0] round
     /* 2161371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161374 */     // MIs[0] policy
     /* 2161374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161384 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161410 */     // GIR_Coverage, 18102,
     /* 2161410 */     GIR_EraseRootFromParent_Done,
     /* 2161411 */   // Label 28520: @2161411
     /* 2161411 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2161502), // Rule ID 18103 //
     /* 2161416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2161427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2161430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2161433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2161436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2161454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161462 */     // MIs[0] round
     /* 2161462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161465 */     // MIs[0] policy
     /* 2161465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161475 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161501 */     // GIR_Coverage, 18103,
     /* 2161501 */     GIR_EraseRootFromParent_Done,
     /* 2161502 */   // Label 28521: @2161502
     /* 2161502 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2161593), // Rule ID 18106 //
     /* 2161507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161553 */     // MIs[0] round
     /* 2161553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161556 */     // MIs[0] policy
     /* 2161556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161592 */     // GIR_Coverage, 18106,
     /* 2161592 */     GIR_EraseRootFromParent_Done,
     /* 2161593 */   // Label 28522: @2161593
     /* 2161593 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2161684), // Rule ID 18107 //
     /* 2161598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161644 */     // MIs[0] round
     /* 2161644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161647 */     // MIs[0] policy
     /* 2161647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161683 */     // GIR_Coverage, 18107,
     /* 2161683 */     GIR_EraseRootFromParent_Done,
     /* 2161684 */   // Label 28523: @2161684
     /* 2161684 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2161775), // Rule ID 18110 //
     /* 2161689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161735 */     // MIs[0] round
     /* 2161735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161738 */     // MIs[0] policy
     /* 2161738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161748 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161774 */     // GIR_Coverage, 18110,
     /* 2161774 */     GIR_EraseRootFromParent_Done,
     /* 2161775 */   // Label 28524: @2161775
     /* 2161775 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2161866), // Rule ID 18111 //
     /* 2161780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161826 */     // MIs[0] round
     /* 2161826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161829 */     // MIs[0] policy
     /* 2161829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161839 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161865 */     // GIR_Coverage, 18111,
     /* 2161865 */     GIR_EraseRootFromParent_Done,
     /* 2161866 */   // Label 28525: @2161866
     /* 2161866 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2161957), // Rule ID 18114 //
     /* 2161871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161917 */     // MIs[0] round
     /* 2161917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161920 */     // MIs[0] policy
     /* 2161920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161930 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161956 */     // GIR_Coverage, 18114,
     /* 2161956 */     GIR_EraseRootFromParent_Done,
     /* 2161957 */   // Label 28526: @2161957
     /* 2161957 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2162048), // Rule ID 18115 //
     /* 2161962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2162000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162008 */     // MIs[0] round
     /* 2162008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162011 */     // MIs[0] policy
     /* 2162011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162021 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2162024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162047 */     // GIR_Coverage, 18115,
     /* 2162047 */     GIR_EraseRootFromParent_Done,
     /* 2162048 */   // Label 28527: @2162048
     /* 2162048 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2162139), // Rule ID 18118 //
     /* 2162053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2162070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162099 */     // MIs[0] round
     /* 2162099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162102 */     // MIs[0] policy
     /* 2162102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162112 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2162115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162138 */     // GIR_Coverage, 18118,
     /* 2162138 */     GIR_EraseRootFromParent_Done,
     /* 2162139 */   // Label 28528: @2162139
     /* 2162139 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2162230), // Rule ID 18119 //
     /* 2162144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2162161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162190 */     // MIs[0] round
     /* 2162190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162193 */     // MIs[0] policy
     /* 2162193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162203 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2162206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162229 */     // GIR_Coverage, 18119,
     /* 2162229 */     GIR_EraseRootFromParent_Done,
     /* 2162230 */   // Label 28529: @2162230
     /* 2162230 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2162321), // Rule ID 18122 //
     /* 2162235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2162252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162281 */     // MIs[0] round
     /* 2162281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162284 */     // MIs[0] policy
     /* 2162284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162294 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2162297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162320 */     // GIR_Coverage, 18122,
     /* 2162320 */     GIR_EraseRootFromParent_Done,
     /* 2162321 */   // Label 28530: @2162321
     /* 2162321 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2162412), // Rule ID 18123 //
     /* 2162326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2162337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2162340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2162343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2162346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162372 */     // MIs[0] round
     /* 2162372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162375 */     // MIs[0] policy
     /* 2162375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162385 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2162388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162411 */     // GIR_Coverage, 18123,
     /* 2162411 */     GIR_EraseRootFromParent_Done,
     /* 2162412 */   // Label 28531: @2162412
     /* 2162412 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2162503), // Rule ID 18126 //
     /* 2162417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162463 */     // MIs[0] round
     /* 2162463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162466 */     // MIs[0] policy
     /* 2162466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162476 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162502 */     // GIR_Coverage, 18126,
     /* 2162502 */     GIR_EraseRootFromParent_Done,
     /* 2162503 */   // Label 28532: @2162503
     /* 2162503 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2162594), // Rule ID 18127 //
     /* 2162508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162554 */     // MIs[0] round
     /* 2162554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162557 */     // MIs[0] policy
     /* 2162557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162567 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162593 */     // GIR_Coverage, 18127,
     /* 2162593 */     GIR_EraseRootFromParent_Done,
     /* 2162594 */   // Label 28533: @2162594
     /* 2162594 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2162685), // Rule ID 18130 //
     /* 2162599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162645 */     // MIs[0] round
     /* 2162645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162648 */     // MIs[0] policy
     /* 2162648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162658 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162684 */     // GIR_Coverage, 18130,
     /* 2162684 */     GIR_EraseRootFromParent_Done,
     /* 2162685 */   // Label 28534: @2162685
     /* 2162685 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2162776), // Rule ID 18131 //
     /* 2162690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162736 */     // MIs[0] round
     /* 2162736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162739 */     // MIs[0] policy
     /* 2162739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162749 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162775 */     // GIR_Coverage, 18131,
     /* 2162775 */     GIR_EraseRootFromParent_Done,
     /* 2162776 */   // Label 28535: @2162776
     /* 2162776 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2162867), // Rule ID 18134 //
     /* 2162781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162827 */     // MIs[0] round
     /* 2162827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162830 */     // MIs[0] policy
     /* 2162830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162866 */     // GIR_Coverage, 18134,
     /* 2162866 */     GIR_EraseRootFromParent_Done,
     /* 2162867 */   // Label 28536: @2162867
     /* 2162867 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2162958), // Rule ID 18135 //
     /* 2162872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162918 */     // MIs[0] round
     /* 2162918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162921 */     // MIs[0] policy
     /* 2162921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162931 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162957 */     // GIR_Coverage, 18135,
     /* 2162957 */     GIR_EraseRootFromParent_Done,
     /* 2162958 */   // Label 28537: @2162958
     /* 2162958 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2163049), // Rule ID 18138 //
     /* 2162963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163009 */     // MIs[0] round
     /* 2163009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163012 */     // MIs[0] policy
     /* 2163012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2163025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163048 */     // GIR_Coverage, 18138,
     /* 2163048 */     GIR_EraseRootFromParent_Done,
     /* 2163049 */   // Label 28538: @2163049
     /* 2163049 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2163140), // Rule ID 18139 //
     /* 2163054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2163071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163100 */     // MIs[0] round
     /* 2163100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163103 */     // MIs[0] policy
     /* 2163103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163113 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2163116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163139 */     // GIR_Coverage, 18139,
     /* 2163139 */     GIR_EraseRootFromParent_Done,
     /* 2163140 */   // Label 28539: @2163140
     /* 2163140 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2163231), // Rule ID 18142 //
     /* 2163145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2163162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163191 */     // MIs[0] round
     /* 2163191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163194 */     // MIs[0] policy
     /* 2163194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2163207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163230 */     // GIR_Coverage, 18142,
     /* 2163230 */     GIR_EraseRootFromParent_Done,
     /* 2163231 */   // Label 28540: @2163231
     /* 2163231 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2163322), // Rule ID 18143 //
     /* 2163236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2163247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2163250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2163253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2163256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163282 */     // MIs[0] round
     /* 2163282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163285 */     // MIs[0] policy
     /* 2163285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163295 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2163298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163321 */     // GIR_Coverage, 18143,
     /* 2163321 */     GIR_EraseRootFromParent_Done,
     /* 2163322 */   // Label 28541: @2163322
     /* 2163322 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2163413), // Rule ID 18146 //
     /* 2163327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2163338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2163344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2163347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163373 */     // MIs[0] round
     /* 2163373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163376 */     // MIs[0] policy
     /* 2163376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163386 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163412 */     // GIR_Coverage, 18146,
     /* 2163412 */     GIR_EraseRootFromParent_Done,
     /* 2163413 */   // Label 28542: @2163413
     /* 2163413 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2163504), // Rule ID 18147 //
     /* 2163418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2163429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2163432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2163435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2163438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163464 */     // MIs[0] round
     /* 2163464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163467 */     // MIs[0] policy
     /* 2163467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163477 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163503 */     // GIR_Coverage, 18147,
     /* 2163503 */     GIR_EraseRootFromParent_Done,
     /* 2163504 */   // Label 28543: @2163504
     /* 2163504 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2163595), // Rule ID 18150 //
     /* 2163509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163555 */     // MIs[0] round
     /* 2163555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163558 */     // MIs[0] policy
     /* 2163558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163568 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163594 */     // GIR_Coverage, 18150,
     /* 2163594 */     GIR_EraseRootFromParent_Done,
     /* 2163595 */   // Label 28544: @2163595
     /* 2163595 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2163686), // Rule ID 18151 //
     /* 2163600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163646 */     // MIs[0] round
     /* 2163646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163649 */     // MIs[0] policy
     /* 2163649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163659 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163685 */     // GIR_Coverage, 18151,
     /* 2163685 */     GIR_EraseRootFromParent_Done,
     /* 2163686 */   // Label 28545: @2163686
     /* 2163686 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2163777), // Rule ID 18154 //
     /* 2163691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163737 */     // MIs[0] round
     /* 2163737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163740 */     // MIs[0] policy
     /* 2163740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163750 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163776 */     // GIR_Coverage, 18154,
     /* 2163776 */     GIR_EraseRootFromParent_Done,
     /* 2163777 */   // Label 28546: @2163777
     /* 2163777 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2163868), // Rule ID 18155 //
     /* 2163782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163828 */     // MIs[0] round
     /* 2163828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163831 */     // MIs[0] policy
     /* 2163831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163841 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163867 */     // GIR_Coverage, 18155,
     /* 2163867 */     GIR_EraseRootFromParent_Done,
     /* 2163868 */   // Label 28547: @2163868
     /* 2163868 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2163959), // Rule ID 18158 //
     /* 2163873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163919 */     // MIs[0] round
     /* 2163919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163922 */     // MIs[0] policy
     /* 2163922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163932 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163958 */     // GIR_Coverage, 18158,
     /* 2163958 */     GIR_EraseRootFromParent_Done,
     /* 2163959 */   // Label 28548: @2163959
     /* 2163959 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2164050), // Rule ID 18159 //
     /* 2163964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164010 */     // MIs[0] round
     /* 2164010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164013 */     // MIs[0] policy
     /* 2164013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164023 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2164026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164049 */     // GIR_Coverage, 18159,
     /* 2164049 */     GIR_EraseRootFromParent_Done,
     /* 2164050 */   // Label 28549: @2164050
     /* 2164050 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2164141), // Rule ID 18162 //
     /* 2164055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2164072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164101 */     // MIs[0] round
     /* 2164101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164104 */     // MIs[0] policy
     /* 2164104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164114 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2164117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164140 */     // GIR_Coverage, 18162,
     /* 2164140 */     GIR_EraseRootFromParent_Done,
     /* 2164141 */   // Label 28550: @2164141
     /* 2164141 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2164232), // Rule ID 18163 //
     /* 2164146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2164163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164192 */     // MIs[0] round
     /* 2164192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164195 */     // MIs[0] policy
     /* 2164195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164205 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2164208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164231 */     // GIR_Coverage, 18163,
     /* 2164231 */     GIR_EraseRootFromParent_Done,
     /* 2164232 */   // Label 28551: @2164232
     /* 2164232 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2164323), // Rule ID 18166 //
     /* 2164237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2164254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164283 */     // MIs[0] round
     /* 2164283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164286 */     // MIs[0] policy
     /* 2164286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164296 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2164299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164322 */     // GIR_Coverage, 18166,
     /* 2164322 */     GIR_EraseRootFromParent_Done,
     /* 2164323 */   // Label 28552: @2164323
     /* 2164323 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2164414), // Rule ID 18167 //
     /* 2164328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2164339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2164342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2164345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2164348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164374 */     // MIs[0] round
     /* 2164374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164377 */     // MIs[0] policy
     /* 2164377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164387 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2164390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164413 */     // GIR_Coverage, 18167,
     /* 2164413 */     GIR_EraseRootFromParent_Done,
     /* 2164414 */   // Label 28553: @2164414
     /* 2164414 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2164505), // Rule ID 18170 //
     /* 2164419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164465 */     // MIs[0] round
     /* 2164465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164468 */     // MIs[0] policy
     /* 2164468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164478 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164504 */     // GIR_Coverage, 18170,
     /* 2164504 */     GIR_EraseRootFromParent_Done,
     /* 2164505 */   // Label 28554: @2164505
     /* 2164505 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2164596), // Rule ID 18171 //
     /* 2164510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164556 */     // MIs[0] round
     /* 2164556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164559 */     // MIs[0] policy
     /* 2164559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164569 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164595 */     // GIR_Coverage, 18171,
     /* 2164595 */     GIR_EraseRootFromParent_Done,
     /* 2164596 */   // Label 28555: @2164596
     /* 2164596 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2164687), // Rule ID 18174 //
     /* 2164601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164647 */     // MIs[0] round
     /* 2164647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164650 */     // MIs[0] policy
     /* 2164650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164660 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164686 */     // GIR_Coverage, 18174,
     /* 2164686 */     GIR_EraseRootFromParent_Done,
     /* 2164687 */   // Label 28556: @2164687
     /* 2164687 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2164778), // Rule ID 18175 //
     /* 2164692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164738 */     // MIs[0] round
     /* 2164738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164741 */     // MIs[0] policy
     /* 2164741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164751 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164777 */     // GIR_Coverage, 18175,
     /* 2164777 */     GIR_EraseRootFromParent_Done,
     /* 2164778 */   // Label 28557: @2164778
     /* 2164778 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2164869), // Rule ID 18178 //
     /* 2164783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164829 */     // MIs[0] round
     /* 2164829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164832 */     // MIs[0] policy
     /* 2164832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164842 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164868 */     // GIR_Coverage, 18178,
     /* 2164868 */     GIR_EraseRootFromParent_Done,
     /* 2164869 */   // Label 28558: @2164869
     /* 2164869 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2164960), // Rule ID 18179 //
     /* 2164874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164920 */     // MIs[0] round
     /* 2164920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164923 */     // MIs[0] policy
     /* 2164923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164933 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164959 */     // GIR_Coverage, 18179,
     /* 2164959 */     GIR_EraseRootFromParent_Done,
     /* 2164960 */   // Label 28559: @2164960
     /* 2164960 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2165051), // Rule ID 18182 //
     /* 2164965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165011 */     // MIs[0] round
     /* 2165011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165014 */     // MIs[0] policy
     /* 2165014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165024 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2165027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165050 */     // GIR_Coverage, 18182,
     /* 2165050 */     GIR_EraseRootFromParent_Done,
     /* 2165051 */   // Label 28560: @2165051
     /* 2165051 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2165142), // Rule ID 18183 //
     /* 2165056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165102 */     // MIs[0] round
     /* 2165102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165105 */     // MIs[0] policy
     /* 2165105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165115 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2165118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165141 */     // GIR_Coverage, 18183,
     /* 2165141 */     GIR_EraseRootFromParent_Done,
     /* 2165142 */   // Label 28561: @2165142
     /* 2165142 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2165233), // Rule ID 18186 //
     /* 2165147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165193 */     // MIs[0] round
     /* 2165193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165196 */     // MIs[0] policy
     /* 2165196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165206 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2165209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165232 */     // GIR_Coverage, 18186,
     /* 2165232 */     GIR_EraseRootFromParent_Done,
     /* 2165233 */   // Label 28562: @2165233
     /* 2165233 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2165324), // Rule ID 18187 //
     /* 2165238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2165249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2165252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2165258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165284 */     // MIs[0] round
     /* 2165284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165287 */     // MIs[0] policy
     /* 2165287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165297 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2165300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165323 */     // GIR_Coverage, 18187,
     /* 2165323 */     GIR_EraseRootFromParent_Done,
     /* 2165324 */   // Label 28563: @2165324
     /* 2165324 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2165415), // Rule ID 18190 //
     /* 2165329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2165340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2165349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165375 */     // MIs[0] round
     /* 2165375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165378 */     // MIs[0] policy
     /* 2165378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165388 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165414 */     // GIR_Coverage, 18190,
     /* 2165414 */     GIR_EraseRootFromParent_Done,
     /* 2165415 */   // Label 28564: @2165415
     /* 2165415 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2165506), // Rule ID 18191 //
     /* 2165420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2165431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2165434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2165440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165466 */     // MIs[0] round
     /* 2165466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165469 */     // MIs[0] policy
     /* 2165469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11302:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165505 */     // GIR_Coverage, 18191,
     /* 2165505 */     GIR_EraseRootFromParent_Done,
     /* 2165506 */   // Label 28565: @2165506
     /* 2165506 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2165597), // Rule ID 18194 //
     /* 2165511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165557 */     // MIs[0] round
     /* 2165557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165560 */     // MIs[0] policy
     /* 2165560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165596 */     // GIR_Coverage, 18194,
     /* 2165596 */     GIR_EraseRootFromParent_Done,
     /* 2165597 */   // Label 28566: @2165597
     /* 2165597 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2165688), // Rule ID 18195 //
     /* 2165602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165648 */     // MIs[0] round
     /* 2165648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165651 */     // MIs[0] policy
     /* 2165651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165661 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11302:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165687 */     // GIR_Coverage, 18195,
     /* 2165687 */     GIR_EraseRootFromParent_Done,
     /* 2165688 */   // Label 28567: @2165688
     /* 2165688 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2165779), // Rule ID 18198 //
     /* 2165693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165739 */     // MIs[0] round
     /* 2165739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165742 */     // MIs[0] policy
     /* 2165742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165752 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165778 */     // GIR_Coverage, 18198,
     /* 2165778 */     GIR_EraseRootFromParent_Done,
     /* 2165779 */   // Label 28568: @2165779
     /* 2165779 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2165870), // Rule ID 18199 //
     /* 2165784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165830 */     // MIs[0] round
     /* 2165830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165833 */     // MIs[0] policy
     /* 2165833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165843 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11302:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165869 */     // GIR_Coverage, 18199,
     /* 2165869 */     GIR_EraseRootFromParent_Done,
     /* 2165870 */   // Label 28569: @2165870
     /* 2165870 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2165961), // Rule ID 18202 //
     /* 2165875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165921 */     // MIs[0] round
     /* 2165921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165924 */     // MIs[0] policy
     /* 2165924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165934 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165960 */     // GIR_Coverage, 18202,
     /* 2165960 */     GIR_EraseRootFromParent_Done,
     /* 2165961 */   // Label 28570: @2165961
     /* 2165961 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2166052), // Rule ID 18203 //
     /* 2165966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166012 */     // MIs[0] round
     /* 2166012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166015 */     // MIs[0] policy
     /* 2166015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166025 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2166028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166051 */     // GIR_Coverage, 18203,
     /* 2166051 */     GIR_EraseRootFromParent_Done,
     /* 2166052 */   // Label 28571: @2166052
     /* 2166052 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2166143), // Rule ID 18206 //
     /* 2166057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166103 */     // MIs[0] round
     /* 2166103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166106 */     // MIs[0] policy
     /* 2166106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2166119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166142 */     // GIR_Coverage, 18206,
     /* 2166142 */     GIR_EraseRootFromParent_Done,
     /* 2166143 */   // Label 28572: @2166143
     /* 2166143 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2166234), // Rule ID 18207 //
     /* 2166148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166194 */     // MIs[0] round
     /* 2166194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166197 */     // MIs[0] policy
     /* 2166197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166207 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2166210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166233 */     // GIR_Coverage, 18207,
     /* 2166233 */     GIR_EraseRootFromParent_Done,
     /* 2166234 */   // Label 28573: @2166234
     /* 2166234 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2166325), // Rule ID 18210 //
     /* 2166239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2166262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166285 */     // MIs[0] round
     /* 2166285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166288 */     // MIs[0] policy
     /* 2166288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166298 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2166301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166324 */     // GIR_Coverage, 18210,
     /* 2166324 */     GIR_EraseRootFromParent_Done,
     /* 2166325 */   // Label 28574: @2166325
     /* 2166325 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2166416), // Rule ID 18211 //
     /* 2166330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2166341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2166344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2166347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2166350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2166353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2166368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166376 */     // MIs[0] round
     /* 2166376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166379 */     // MIs[0] policy
     /* 2166379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166389 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2166392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166415 */     // GIR_Coverage, 18211,
     /* 2166415 */     GIR_EraseRootFromParent_Done,
     /* 2166416 */   // Label 28575: @2166416
     /* 2166416 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2166507), // Rule ID 18214 //
     /* 2166421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166467 */     // MIs[0] round
     /* 2166467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166470 */     // MIs[0] policy
     /* 2166470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166480 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166506 */     // GIR_Coverage, 18214,
     /* 2166506 */     GIR_EraseRootFromParent_Done,
     /* 2166507 */   // Label 28576: @2166507
     /* 2166507 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2166598), // Rule ID 18215 //
     /* 2166512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166558 */     // MIs[0] round
     /* 2166558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166561 */     // MIs[0] policy
     /* 2166561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166597 */     // GIR_Coverage, 18215,
     /* 2166597 */     GIR_EraseRootFromParent_Done,
     /* 2166598 */   // Label 28577: @2166598
     /* 2166598 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2166689), // Rule ID 18218 //
     /* 2166603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166649 */     // MIs[0] round
     /* 2166649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166652 */     // MIs[0] policy
     /* 2166652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166662 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166688 */     // GIR_Coverage, 18218,
     /* 2166688 */     GIR_EraseRootFromParent_Done,
     /* 2166689 */   // Label 28578: @2166689
     /* 2166689 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2166780), // Rule ID 18219 //
     /* 2166694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166740 */     // MIs[0] round
     /* 2166740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166743 */     // MIs[0] policy
     /* 2166743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166753 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166779 */     // GIR_Coverage, 18219,
     /* 2166779 */     GIR_EraseRootFromParent_Done,
     /* 2166780 */   // Label 28579: @2166780
     /* 2166780 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2166871), // Rule ID 18222 //
     /* 2166785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166831 */     // MIs[0] round
     /* 2166831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166834 */     // MIs[0] policy
     /* 2166834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166870 */     // GIR_Coverage, 18222,
     /* 2166870 */     GIR_EraseRootFromParent_Done,
     /* 2166871 */   // Label 28580: @2166871
     /* 2166871 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2166962), // Rule ID 18223 //
     /* 2166876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166922 */     // MIs[0] round
     /* 2166922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166925 */     // MIs[0] policy
     /* 2166925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166935 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166961 */     // GIR_Coverage, 18223,
     /* 2166961 */     GIR_EraseRootFromParent_Done,
     /* 2166962 */   // Label 28581: @2166962
     /* 2166962 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2167053), // Rule ID 18226 //
     /* 2166967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167013 */     // MIs[0] round
     /* 2167013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167016 */     // MIs[0] policy
     /* 2167016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167026 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2167029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167052 */     // GIR_Coverage, 18226,
     /* 2167052 */     GIR_EraseRootFromParent_Done,
     /* 2167053 */   // Label 28582: @2167053
     /* 2167053 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2167144), // Rule ID 18227 //
     /* 2167058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167104 */     // MIs[0] round
     /* 2167104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167107 */     // MIs[0] policy
     /* 2167107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167117 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11302:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2167120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167143 */     // GIR_Coverage, 18227,
     /* 2167143 */     GIR_EraseRootFromParent_Done,
     /* 2167144 */   // Label 28583: @2167144
     /* 2167144 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2167235), // Rule ID 18230 //
     /* 2167149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167195 */     // MIs[0] round
     /* 2167195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167198 */     // MIs[0] policy
     /* 2167198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167208 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2167211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167234 */     // GIR_Coverage, 18230,
     /* 2167234 */     GIR_EraseRootFromParent_Done,
     /* 2167235 */   // Label 28584: @2167235
     /* 2167235 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2167326), // Rule ID 18231 //
     /* 2167240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2167251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2167254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2167260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167286 */     // MIs[0] round
     /* 2167286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167289 */     // MIs[0] policy
     /* 2167289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167299 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11302:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2167302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167325 */     // GIR_Coverage, 18231,
     /* 2167325 */     GIR_EraseRootFromParent_Done,
     /* 2167326 */   // Label 28585: @2167326
     /* 2167326 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2167417), // Rule ID 18234 //
     /* 2167331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2167342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2167345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2167351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167377 */     // MIs[0] round
     /* 2167377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167380 */     // MIs[0] policy
     /* 2167380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167390 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167416 */     // GIR_Coverage, 18234,
     /* 2167416 */     GIR_EraseRootFromParent_Done,
     /* 2167417 */   // Label 28586: @2167417
     /* 2167417 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2167508), // Rule ID 18235 //
     /* 2167422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2167430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2167433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2167436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2167439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2167442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2167460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167468 */     // MIs[0] round
     /* 2167468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167471 */     // MIs[0] policy
     /* 2167471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167481 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11302:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167507 */     // GIR_Coverage, 18235,
     /* 2167507 */     GIR_EraseRootFromParent_Done,
     /* 2167508 */   // Label 28587: @2167508
     /* 2167508 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2167599), // Rule ID 18238 //
     /* 2167513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167559 */     // MIs[0] round
     /* 2167559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167562 */     // MIs[0] policy
     /* 2167562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167572 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167598 */     // GIR_Coverage, 18238,
     /* 2167598 */     GIR_EraseRootFromParent_Done,
     /* 2167599 */   // Label 28588: @2167599
     /* 2167599 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2167690), // Rule ID 18239 //
     /* 2167604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167650 */     // MIs[0] round
     /* 2167650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167653 */     // MIs[0] policy
     /* 2167653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167663 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167689 */     // GIR_Coverage, 18239,
     /* 2167689 */     GIR_EraseRootFromParent_Done,
     /* 2167690 */   // Label 28589: @2167690
     /* 2167690 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2167781), // Rule ID 18242 //
     /* 2167695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167741 */     // MIs[0] round
     /* 2167741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167744 */     // MIs[0] policy
     /* 2167744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167780 */     // GIR_Coverage, 18242,
     /* 2167780 */     GIR_EraseRootFromParent_Done,
     /* 2167781 */   // Label 28590: @2167781
     /* 2167781 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2167872), // Rule ID 18243 //
     /* 2167786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167832 */     // MIs[0] round
     /* 2167832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167835 */     // MIs[0] policy
     /* 2167835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167845 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167871 */     // GIR_Coverage, 18243,
     /* 2167871 */     GIR_EraseRootFromParent_Done,
     /* 2167872 */   // Label 28591: @2167872
     /* 2167872 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2167963), // Rule ID 18246 //
     /* 2167877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167923 */     // MIs[0] round
     /* 2167923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167926 */     // MIs[0] policy
     /* 2167926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167936 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167962 */     // GIR_Coverage, 18246,
     /* 2167962 */     GIR_EraseRootFromParent_Done,
     /* 2167963 */   // Label 28592: @2167963
     /* 2167963 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2168054), // Rule ID 18247 //
     /* 2167968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168014 */     // MIs[0] round
     /* 2168014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168017 */     // MIs[0] policy
     /* 2168017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2168030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168053 */     // GIR_Coverage, 18247,
     /* 2168053 */     GIR_EraseRootFromParent_Done,
     /* 2168054 */   // Label 28593: @2168054
     /* 2168054 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2168145), // Rule ID 18250 //
     /* 2168059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2168076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168105 */     // MIs[0] round
     /* 2168105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168108 */     // MIs[0] policy
     /* 2168108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168118 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2168121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168144 */     // GIR_Coverage, 18250,
     /* 2168144 */     GIR_EraseRootFromParent_Done,
     /* 2168145 */   // Label 28594: @2168145
     /* 2168145 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2168236), // Rule ID 18251 //
     /* 2168150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2168167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168196 */     // MIs[0] round
     /* 2168196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168199 */     // MIs[0] policy
     /* 2168199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168209 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2168212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168235 */     // GIR_Coverage, 18251,
     /* 2168235 */     GIR_EraseRootFromParent_Done,
     /* 2168236 */   // Label 28595: @2168236
     /* 2168236 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2168327), // Rule ID 18254 //
     /* 2168241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2168258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2168261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168287 */     // MIs[0] round
     /* 2168287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168290 */     // MIs[0] policy
     /* 2168290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2168303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168326 */     // GIR_Coverage, 18254,
     /* 2168326 */     GIR_EraseRootFromParent_Done,
     /* 2168327 */   // Label 28596: @2168327
     /* 2168327 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2168418), // Rule ID 18255 //
     /* 2168332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2168343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2168346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2168349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2168352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168378 */     // MIs[0] round
     /* 2168378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168381 */     // MIs[0] policy
     /* 2168381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168391 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2168394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168417 */     // GIR_Coverage, 18255,
     /* 2168417 */     GIR_EraseRootFromParent_Done,
     /* 2168418 */   // Label 28597: @2168418
     /* 2168418 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2168509), // Rule ID 18258 //
     /* 2168423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2168426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168469 */     // MIs[0] round
     /* 2168469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168472 */     // MIs[0] policy
     /* 2168472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168482 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168508 */     // GIR_Coverage, 18258,
     /* 2168508 */     GIR_EraseRootFromParent_Done,
     /* 2168509 */   // Label 28598: @2168509
     /* 2168509 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2168600), // Rule ID 18259 //
     /* 2168514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168560 */     // MIs[0] round
     /* 2168560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168563 */     // MIs[0] policy
     /* 2168563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168573 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168599 */     // GIR_Coverage, 18259,
     /* 2168599 */     GIR_EraseRootFromParent_Done,
     /* 2168600 */   // Label 28599: @2168600
     /* 2168600 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2168691), // Rule ID 18262 //
     /* 2168605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168651 */     // MIs[0] round
     /* 2168651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168654 */     // MIs[0] policy
     /* 2168654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168664 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168690 */     // GIR_Coverage, 18262,
     /* 2168690 */     GIR_EraseRootFromParent_Done,
     /* 2168691 */   // Label 28600: @2168691
     /* 2168691 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2168782), // Rule ID 18263 //
     /* 2168696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168742 */     // MIs[0] round
     /* 2168742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168745 */     // MIs[0] policy
     /* 2168745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168755 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168781 */     // GIR_Coverage, 18263,
     /* 2168781 */     GIR_EraseRootFromParent_Done,
     /* 2168782 */   // Label 28601: @2168782
     /* 2168782 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2168873), // Rule ID 18266 //
     /* 2168787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168833 */     // MIs[0] round
     /* 2168833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168836 */     // MIs[0] policy
     /* 2168836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168846 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168872 */     // GIR_Coverage, 18266,
     /* 2168872 */     GIR_EraseRootFromParent_Done,
     /* 2168873 */   // Label 28602: @2168873
     /* 2168873 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2168964), // Rule ID 18267 //
     /* 2168878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168924 */     // MIs[0] round
     /* 2168924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168927 */     // MIs[0] policy
     /* 2168927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168937 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168963 */     // GIR_Coverage, 18267,
     /* 2168963 */     GIR_EraseRootFromParent_Done,
     /* 2168964 */   // Label 28603: @2168964
     /* 2168964 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2169055), // Rule ID 18270 //
     /* 2168969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169015 */     // MIs[0] round
     /* 2169015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169018 */     // MIs[0] policy
     /* 2169018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169028 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2169031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169054 */     // GIR_Coverage, 18270,
     /* 2169054 */     GIR_EraseRootFromParent_Done,
     /* 2169055 */   // Label 28604: @2169055
     /* 2169055 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2169146), // Rule ID 18271 //
     /* 2169060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2169077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169106 */     // MIs[0] round
     /* 2169106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169109 */     // MIs[0] policy
     /* 2169109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169119 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2169122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169145 */     // GIR_Coverage, 18271,
     /* 2169145 */     GIR_EraseRootFromParent_Done,
     /* 2169146 */   // Label 28605: @2169146
     /* 2169146 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2169237), // Rule ID 18274 //
     /* 2169151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2169168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169197 */     // MIs[0] round
     /* 2169197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169200 */     // MIs[0] policy
     /* 2169200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169210 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2169213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169236 */     // GIR_Coverage, 18274,
     /* 2169236 */     GIR_EraseRootFromParent_Done,
     /* 2169237 */   // Label 28606: @2169237
     /* 2169237 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2169328), // Rule ID 18275 //
     /* 2169242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2169253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2169256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2169259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2169262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169288 */     // MIs[0] round
     /* 2169288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169291 */     // MIs[0] policy
     /* 2169291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169301 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2169304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169327 */     // GIR_Coverage, 18275,
     /* 2169327 */     GIR_EraseRootFromParent_Done,
     /* 2169328 */   // Label 28607: @2169328
     /* 2169328 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2169419), // Rule ID 18278 //
     /* 2169333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2169344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2169350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2169353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169379 */     // MIs[0] round
     /* 2169379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169382 */     // MIs[0] policy
     /* 2169382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169392 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169418 */     // GIR_Coverage, 18278,
     /* 2169418 */     GIR_EraseRootFromParent_Done,
     /* 2169419 */   // Label 28608: @2169419
     /* 2169419 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2169510), // Rule ID 18279 //
     /* 2169424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2169435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2169438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2169441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2169444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169470 */     // MIs[0] round
     /* 2169470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169473 */     // MIs[0] policy
     /* 2169473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169483 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169509 */     // GIR_Coverage, 18279,
     /* 2169509 */     GIR_EraseRootFromParent_Done,
     /* 2169510 */   // Label 28609: @2169510
     /* 2169510 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2169601), // Rule ID 18282 //
     /* 2169515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169561 */     // MIs[0] round
     /* 2169561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169564 */     // MIs[0] policy
     /* 2169564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169574 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169600 */     // GIR_Coverage, 18282,
     /* 2169600 */     GIR_EraseRootFromParent_Done,
     /* 2169601 */   // Label 28610: @2169601
     /* 2169601 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2169692), // Rule ID 18283 //
     /* 2169606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169652 */     // MIs[0] round
     /* 2169652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169655 */     // MIs[0] policy
     /* 2169655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169665 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169691 */     // GIR_Coverage, 18283,
     /* 2169691 */     GIR_EraseRootFromParent_Done,
     /* 2169692 */   // Label 28611: @2169692
     /* 2169692 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2169783), // Rule ID 18286 //
     /* 2169697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169743 */     // MIs[0] round
     /* 2169743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169746 */     // MIs[0] policy
     /* 2169746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169756 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169782 */     // GIR_Coverage, 18286,
     /* 2169782 */     GIR_EraseRootFromParent_Done,
     /* 2169783 */   // Label 28612: @2169783
     /* 2169783 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2169874), // Rule ID 18287 //
     /* 2169788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169834 */     // MIs[0] round
     /* 2169834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169837 */     // MIs[0] policy
     /* 2169837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169847 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169873 */     // GIR_Coverage, 18287,
     /* 2169873 */     GIR_EraseRootFromParent_Done,
     /* 2169874 */   // Label 28613: @2169874
     /* 2169874 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2169965), // Rule ID 18290 //
     /* 2169879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169925 */     // MIs[0] round
     /* 2169925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169928 */     // MIs[0] policy
     /* 2169928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169938 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169964 */     // GIR_Coverage, 18290,
     /* 2169964 */     GIR_EraseRootFromParent_Done,
     /* 2169965 */   // Label 28614: @2169965
     /* 2169965 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2170056), // Rule ID 18291 //
     /* 2169970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170016 */     // MIs[0] round
     /* 2170016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170019 */     // MIs[0] policy
     /* 2170019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170029 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2170032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170055 */     // GIR_Coverage, 18291,
     /* 2170055 */     GIR_EraseRootFromParent_Done,
     /* 2170056 */   // Label 28615: @2170056
     /* 2170056 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2170147), // Rule ID 18294 //
     /* 2170061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2170078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170107 */     // MIs[0] round
     /* 2170107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170110 */     // MIs[0] policy
     /* 2170110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170120 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2170123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170146 */     // GIR_Coverage, 18294,
     /* 2170146 */     GIR_EraseRootFromParent_Done,
     /* 2170147 */   // Label 28616: @2170147
     /* 2170147 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2170238), // Rule ID 18295 //
     /* 2170152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2170169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170198 */     // MIs[0] round
     /* 2170198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170201 */     // MIs[0] policy
     /* 2170201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170211 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2170214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170237 */     // GIR_Coverage, 18295,
     /* 2170237 */     GIR_EraseRootFromParent_Done,
     /* 2170238 */   // Label 28617: @2170238
     /* 2170238 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2170329), // Rule ID 18298 //
     /* 2170243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2170263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170289 */     // MIs[0] round
     /* 2170289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170292 */     // MIs[0] policy
     /* 2170292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170302 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2170305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170328 */     // GIR_Coverage, 18298,
     /* 2170328 */     GIR_EraseRootFromParent_Done,
     /* 2170329 */   // Label 28618: @2170329
     /* 2170329 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2170420), // Rule ID 18299 //
     /* 2170334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2170345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2170348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2170354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170380 */     // MIs[0] round
     /* 2170380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170383 */     // MIs[0] policy
     /* 2170383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170393 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2170396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170419 */     // GIR_Coverage, 18299,
     /* 2170419 */     GIR_EraseRootFromParent_Done,
     /* 2170420 */   // Label 28619: @2170420
     /* 2170420 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2170511), // Rule ID 18302 //
     /* 2170425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170471 */     // MIs[0] round
     /* 2170471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170474 */     // MIs[0] policy
     /* 2170474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170484 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170510 */     // GIR_Coverage, 18302,
     /* 2170510 */     GIR_EraseRootFromParent_Done,
     /* 2170511 */   // Label 28620: @2170511
     /* 2170511 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2170602), // Rule ID 18303 //
     /* 2170516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170562 */     // MIs[0] round
     /* 2170562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170565 */     // MIs[0] policy
     /* 2170565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170575 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170601 */     // GIR_Coverage, 18303,
     /* 2170601 */     GIR_EraseRootFromParent_Done,
     /* 2170602 */   // Label 28621: @2170602
     /* 2170602 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2170693), // Rule ID 18306 //
     /* 2170607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170653 */     // MIs[0] round
     /* 2170653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170656 */     // MIs[0] policy
     /* 2170656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170666 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170692 */     // GIR_Coverage, 18306,
     /* 2170692 */     GIR_EraseRootFromParent_Done,
     /* 2170693 */   // Label 28622: @2170693
     /* 2170693 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2170784), // Rule ID 18307 //
     /* 2170698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170744 */     // MIs[0] round
     /* 2170744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170747 */     // MIs[0] policy
     /* 2170747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170757 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170783 */     // GIR_Coverage, 18307,
     /* 2170783 */     GIR_EraseRootFromParent_Done,
     /* 2170784 */   // Label 28623: @2170784
     /* 2170784 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2170875), // Rule ID 18310 //
     /* 2170789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170835 */     // MIs[0] round
     /* 2170835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170838 */     // MIs[0] policy
     /* 2170838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170848 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170874 */     // GIR_Coverage, 18310,
     /* 2170874 */     GIR_EraseRootFromParent_Done,
     /* 2170875 */   // Label 28624: @2170875
     /* 2170875 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2170966), // Rule ID 18311 //
     /* 2170880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170926 */     // MIs[0] round
     /* 2170926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170929 */     // MIs[0] policy
     /* 2170929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170939 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170965 */     // GIR_Coverage, 18311,
     /* 2170965 */     GIR_EraseRootFromParent_Done,
     /* 2170966 */   // Label 28625: @2170966
     /* 2170966 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2171057), // Rule ID 18314 //
     /* 2170971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171017 */     // MIs[0] round
     /* 2171017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171020 */     // MIs[0] policy
     /* 2171020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171030 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2171033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171056 */     // GIR_Coverage, 18314,
     /* 2171056 */     GIR_EraseRootFromParent_Done,
     /* 2171057 */   // Label 28626: @2171057
     /* 2171057 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2171148), // Rule ID 18315 //
     /* 2171062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171108 */     // MIs[0] round
     /* 2171108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171111 */     // MIs[0] policy
     /* 2171111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171121 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2171124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171147 */     // GIR_Coverage, 18315,
     /* 2171147 */     GIR_EraseRootFromParent_Done,
     /* 2171148 */   // Label 28627: @2171148
     /* 2171148 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2171239), // Rule ID 18318 //
     /* 2171153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171199 */     // MIs[0] round
     /* 2171199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171202 */     // MIs[0] policy
     /* 2171202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171212 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2171215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171238 */     // GIR_Coverage, 18318,
     /* 2171238 */     GIR_EraseRootFromParent_Done,
     /* 2171239 */   // Label 28628: @2171239
     /* 2171239 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2171330), // Rule ID 18319 //
     /* 2171244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2171255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2171258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2171264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171290 */     // MIs[0] round
     /* 2171290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171293 */     // MIs[0] policy
     /* 2171293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171303 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2171306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171329 */     // GIR_Coverage, 18319,
     /* 2171329 */     GIR_EraseRootFromParent_Done,
     /* 2171330 */   // Label 28629: @2171330
     /* 2171330 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2171421), // Rule ID 18322 //
     /* 2171335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2171346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2171355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171381 */     // MIs[0] round
     /* 2171381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171384 */     // MIs[0] policy
     /* 2171384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171394 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171420 */     // GIR_Coverage, 18322,
     /* 2171420 */     GIR_EraseRootFromParent_Done,
     /* 2171421 */   // Label 28630: @2171421
     /* 2171421 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2171512), // Rule ID 18323 //
     /* 2171426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2171437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2171440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2171446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171472 */     // MIs[0] round
     /* 2171472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171475 */     // MIs[0] policy
     /* 2171475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171485 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171511 */     // GIR_Coverage, 18323,
     /* 2171511 */     GIR_EraseRootFromParent_Done,
     /* 2171512 */   // Label 28631: @2171512
     /* 2171512 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2171603), // Rule ID 18326 //
     /* 2171517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171563 */     // MIs[0] round
     /* 2171563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171566 */     // MIs[0] policy
     /* 2171566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171576 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171602 */     // GIR_Coverage, 18326,
     /* 2171602 */     GIR_EraseRootFromParent_Done,
     /* 2171603 */   // Label 28632: @2171603
     /* 2171603 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2171694), // Rule ID 18327 //
     /* 2171608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171654 */     // MIs[0] round
     /* 2171654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171657 */     // MIs[0] policy
     /* 2171657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171667 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171693 */     // GIR_Coverage, 18327,
     /* 2171693 */     GIR_EraseRootFromParent_Done,
     /* 2171694 */   // Label 28633: @2171694
     /* 2171694 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2171785), // Rule ID 18330 //
     /* 2171699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171745 */     // MIs[0] round
     /* 2171745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171748 */     // MIs[0] policy
     /* 2171748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171784 */     // GIR_Coverage, 18330,
     /* 2171784 */     GIR_EraseRootFromParent_Done,
     /* 2171785 */   // Label 28634: @2171785
     /* 2171785 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2171876), // Rule ID 18331 //
     /* 2171790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171836 */     // MIs[0] round
     /* 2171836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171839 */     // MIs[0] policy
     /* 2171839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171849 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171875 */     // GIR_Coverage, 18331,
     /* 2171875 */     GIR_EraseRootFromParent_Done,
     /* 2171876 */   // Label 28635: @2171876
     /* 2171876 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2171967), // Rule ID 18334 //
     /* 2171881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171927 */     // MIs[0] round
     /* 2171927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171930 */     // MIs[0] policy
     /* 2171930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171940 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171966 */     // GIR_Coverage, 18334,
     /* 2171966 */     GIR_EraseRootFromParent_Done,
     /* 2171967 */   // Label 28636: @2171967
     /* 2171967 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2172058), // Rule ID 18335 //
     /* 2171972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172018 */     // MIs[0] round
     /* 2172018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172021 */     // MIs[0] policy
     /* 2172021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172031 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2172034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172057 */     // GIR_Coverage, 18335,
     /* 2172057 */     GIR_EraseRootFromParent_Done,
     /* 2172058 */   // Label 28637: @2172058
     /* 2172058 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2172149), // Rule ID 18338 //
     /* 2172063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172109 */     // MIs[0] round
     /* 2172109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172112 */     // MIs[0] policy
     /* 2172112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172122 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2172125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172148 */     // GIR_Coverage, 18338,
     /* 2172148 */     GIR_EraseRootFromParent_Done,
     /* 2172149 */   // Label 28638: @2172149
     /* 2172149 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2172240), // Rule ID 18339 //
     /* 2172154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172200 */     // MIs[0] round
     /* 2172200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172203 */     // MIs[0] policy
     /* 2172203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172213 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2172216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172239 */     // GIR_Coverage, 18339,
     /* 2172239 */     GIR_EraseRootFromParent_Done,
     /* 2172240 */   // Label 28639: @2172240
     /* 2172240 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2172331), // Rule ID 18342 //
     /* 2172245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2172265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172291 */     // MIs[0] round
     /* 2172291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172294 */     // MIs[0] policy
     /* 2172294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172304 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2172307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172330 */     // GIR_Coverage, 18342,
     /* 2172330 */     GIR_EraseRootFromParent_Done,
     /* 2172331 */   // Label 28640: @2172331
     /* 2172331 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2172422), // Rule ID 18343 //
     /* 2172336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2172347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2172350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2172353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2172356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2172374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172382 */     // MIs[0] round
     /* 2172382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172385 */     // MIs[0] policy
     /* 2172385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172395 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2172398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172421 */     // GIR_Coverage, 18343,
     /* 2172421 */     GIR_EraseRootFromParent_Done,
     /* 2172422 */   // Label 28641: @2172422
     /* 2172422 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2172513), // Rule ID 18346 //
     /* 2172427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172473 */     // MIs[0] round
     /* 2172473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172476 */     // MIs[0] policy
     /* 2172476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172512 */     // GIR_Coverage, 18346,
     /* 2172512 */     GIR_EraseRootFromParent_Done,
     /* 2172513 */   // Label 28642: @2172513
     /* 2172513 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2172604), // Rule ID 18347 //
     /* 2172518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172564 */     // MIs[0] round
     /* 2172564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172567 */     // MIs[0] policy
     /* 2172567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172603 */     // GIR_Coverage, 18347,
     /* 2172603 */     GIR_EraseRootFromParent_Done,
     /* 2172604 */   // Label 28643: @2172604
     /* 2172604 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2172695), // Rule ID 18350 //
     /* 2172609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172655 */     // MIs[0] round
     /* 2172655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172658 */     // MIs[0] policy
     /* 2172658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172694 */     // GIR_Coverage, 18350,
     /* 2172694 */     GIR_EraseRootFromParent_Done,
     /* 2172695 */   // Label 28644: @2172695
     /* 2172695 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2172786), // Rule ID 18351 //
     /* 2172700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172746 */     // MIs[0] round
     /* 2172746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172749 */     // MIs[0] policy
     /* 2172749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172759 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172785 */     // GIR_Coverage, 18351,
     /* 2172785 */     GIR_EraseRootFromParent_Done,
     /* 2172786 */   // Label 28645: @2172786
     /* 2172786 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2172877), // Rule ID 18354 //
     /* 2172791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172837 */     // MIs[0] round
     /* 2172837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172840 */     // MIs[0] policy
     /* 2172840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172850 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172876 */     // GIR_Coverage, 18354,
     /* 2172876 */     GIR_EraseRootFromParent_Done,
     /* 2172877 */   // Label 28646: @2172877
     /* 2172877 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2172968), // Rule ID 18355 //
     /* 2172882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172928 */     // MIs[0] round
     /* 2172928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172931 */     // MIs[0] policy
     /* 2172931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172941 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172967 */     // GIR_Coverage, 18355,
     /* 2172967 */     GIR_EraseRootFromParent_Done,
     /* 2172968 */   // Label 28647: @2172968
     /* 2172968 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2173059), // Rule ID 18358 //
     /* 2172973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173019 */     // MIs[0] round
     /* 2173019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173022 */     // MIs[0] policy
     /* 2173022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173032 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2173035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173058 */     // GIR_Coverage, 18358,
     /* 2173058 */     GIR_EraseRootFromParent_Done,
     /* 2173059 */   // Label 28648: @2173059
     /* 2173059 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2173150), // Rule ID 18359 //
     /* 2173064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2173081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173110 */     // MIs[0] round
     /* 2173110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173113 */     // MIs[0] policy
     /* 2173113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173123 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2173126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173149 */     // GIR_Coverage, 18359,
     /* 2173149 */     GIR_EraseRootFromParent_Done,
     /* 2173150 */   // Label 28649: @2173150
     /* 2173150 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2173241), // Rule ID 18362 //
     /* 2173155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2173172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173201 */     // MIs[0] round
     /* 2173201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173204 */     // MIs[0] policy
     /* 2173204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173214 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2173217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173240 */     // GIR_Coverage, 18362,
     /* 2173240 */     GIR_EraseRootFromParent_Done,
     /* 2173241 */   // Label 28650: @2173241
     /* 2173241 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2173332), // Rule ID 18363 //
     /* 2173246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2173257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2173260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2173263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2173266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173292 */     // MIs[0] round
     /* 2173292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173295 */     // MIs[0] policy
     /* 2173295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173305 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2173308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173331 */     // GIR_Coverage, 18363,
     /* 2173331 */     GIR_EraseRootFromParent_Done,
     /* 2173332 */   // Label 28651: @2173332
     /* 2173332 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2173423), // Rule ID 18366 //
     /* 2173337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2173348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2173354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2173357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173383 */     // MIs[0] round
     /* 2173383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173386 */     // MIs[0] policy
     /* 2173386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173396 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173422 */     // GIR_Coverage, 18366,
     /* 2173422 */     GIR_EraseRootFromParent_Done,
     /* 2173423 */   // Label 28652: @2173423
     /* 2173423 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2173514), // Rule ID 18367 //
     /* 2173428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2173439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2173442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2173445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2173448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173474 */     // MIs[0] round
     /* 2173474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173477 */     // MIs[0] policy
     /* 2173477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173487 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173513 */     // GIR_Coverage, 18367,
     /* 2173513 */     GIR_EraseRootFromParent_Done,
     /* 2173514 */   // Label 28653: @2173514
     /* 2173514 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2173605), // Rule ID 18370 //
     /* 2173519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173565 */     // MIs[0] round
     /* 2173565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173568 */     // MIs[0] policy
     /* 2173568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173578 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173604 */     // GIR_Coverage, 18370,
     /* 2173604 */     GIR_EraseRootFromParent_Done,
     /* 2173605 */   // Label 28654: @2173605
     /* 2173605 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2173696), // Rule ID 18371 //
     /* 2173610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173656 */     // MIs[0] round
     /* 2173656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173659 */     // MIs[0] policy
     /* 2173659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173669 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173695 */     // GIR_Coverage, 18371,
     /* 2173695 */     GIR_EraseRootFromParent_Done,
     /* 2173696 */   // Label 28655: @2173696
     /* 2173696 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2173787), // Rule ID 18374 //
     /* 2173701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173747 */     // MIs[0] round
     /* 2173747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173750 */     // MIs[0] policy
     /* 2173750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173786 */     // GIR_Coverage, 18374,
     /* 2173786 */     GIR_EraseRootFromParent_Done,
     /* 2173787 */   // Label 28656: @2173787
     /* 2173787 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2173878), // Rule ID 18375 //
     /* 2173792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173838 */     // MIs[0] round
     /* 2173838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173841 */     // MIs[0] policy
     /* 2173841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173851 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173877 */     // GIR_Coverage, 18375,
     /* 2173877 */     GIR_EraseRootFromParent_Done,
     /* 2173878 */   // Label 28657: @2173878
     /* 2173878 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2173969), // Rule ID 18378 //
     /* 2173883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173929 */     // MIs[0] round
     /* 2173929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173932 */     // MIs[0] policy
     /* 2173932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173968 */     // GIR_Coverage, 18378,
     /* 2173968 */     GIR_EraseRootFromParent_Done,
     /* 2173969 */   // Label 28658: @2173969
     /* 2173969 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2174060), // Rule ID 18379 //
     /* 2173974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174020 */     // MIs[0] round
     /* 2174020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174023 */     // MIs[0] policy
     /* 2174023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174033 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2174036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174059 */     // GIR_Coverage, 18379,
     /* 2174059 */     GIR_EraseRootFromParent_Done,
     /* 2174060 */   // Label 28659: @2174060
     /* 2174060 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2174151), // Rule ID 18382 //
     /* 2174065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2174082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174111 */     // MIs[0] round
     /* 2174111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174114 */     // MIs[0] policy
     /* 2174114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2174127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174150 */     // GIR_Coverage, 18382,
     /* 2174150 */     GIR_EraseRootFromParent_Done,
     /* 2174151 */   // Label 28660: @2174151
     /* 2174151 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2174242), // Rule ID 18383 //
     /* 2174156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2174173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174202 */     // MIs[0] round
     /* 2174202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174205 */     // MIs[0] policy
     /* 2174205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174215 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2174218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174241 */     // GIR_Coverage, 18383,
     /* 2174241 */     GIR_EraseRootFromParent_Done,
     /* 2174242 */   // Label 28661: @2174242
     /* 2174242 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2174333), // Rule ID 18386 //
     /* 2174247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2174264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2174267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174293 */     // MIs[0] round
     /* 2174293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174296 */     // MIs[0] policy
     /* 2174296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174306 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2174309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174332 */     // GIR_Coverage, 18386,
     /* 2174332 */     GIR_EraseRootFromParent_Done,
     /* 2174333 */   // Label 28662: @2174333
     /* 2174333 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2174424), // Rule ID 18387 //
     /* 2174338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2174349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2174352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2174355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2174358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174384 */     // MIs[0] round
     /* 2174384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174387 */     // MIs[0] policy
     /* 2174387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174397 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2174400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174423 */     // GIR_Coverage, 18387,
     /* 2174423 */     GIR_EraseRootFromParent_Done,
     /* 2174424 */   // Label 28663: @2174424
     /* 2174424 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2174515), // Rule ID 18390 //
     /* 2174429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174475 */     // MIs[0] round
     /* 2174475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174478 */     // MIs[0] policy
     /* 2174478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174488 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174514 */     // GIR_Coverage, 18390,
     /* 2174514 */     GIR_EraseRootFromParent_Done,
     /* 2174515 */   // Label 28664: @2174515
     /* 2174515 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2174606), // Rule ID 18391 //
     /* 2174520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174566 */     // MIs[0] round
     /* 2174566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174569 */     // MIs[0] policy
     /* 2174569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174579 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174605 */     // GIR_Coverage, 18391,
     /* 2174605 */     GIR_EraseRootFromParent_Done,
     /* 2174606 */   // Label 28665: @2174606
     /* 2174606 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2174697), // Rule ID 18394 //
     /* 2174611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174657 */     // MIs[0] round
     /* 2174657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174660 */     // MIs[0] policy
     /* 2174660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174670 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174696 */     // GIR_Coverage, 18394,
     /* 2174696 */     GIR_EraseRootFromParent_Done,
     /* 2174697 */   // Label 28666: @2174697
     /* 2174697 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2174788), // Rule ID 18395 //
     /* 2174702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174748 */     // MIs[0] round
     /* 2174748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174751 */     // MIs[0] policy
     /* 2174751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174761 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174787 */     // GIR_Coverage, 18395,
     /* 2174787 */     GIR_EraseRootFromParent_Done,
     /* 2174788 */   // Label 28667: @2174788
     /* 2174788 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2174879), // Rule ID 18398 //
     /* 2174793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174839 */     // MIs[0] round
     /* 2174839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174842 */     // MIs[0] policy
     /* 2174842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174852 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174878 */     // GIR_Coverage, 18398,
     /* 2174878 */     GIR_EraseRootFromParent_Done,
     /* 2174879 */   // Label 28668: @2174879
     /* 2174879 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2174970), // Rule ID 18399 //
     /* 2174884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174930 */     // MIs[0] round
     /* 2174930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174933 */     // MIs[0] policy
     /* 2174933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174943 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174969 */     // GIR_Coverage, 18399,
     /* 2174969 */     GIR_EraseRootFromParent_Done,
     /* 2174970 */   // Label 28669: @2174970
     /* 2174970 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2175061), // Rule ID 18402 //
     /* 2174975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175021 */     // MIs[0] round
     /* 2175021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175024 */     // MIs[0] policy
     /* 2175024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175034 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2175037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175060 */     // GIR_Coverage, 18402,
     /* 2175060 */     GIR_EraseRootFromParent_Done,
     /* 2175061 */   // Label 28670: @2175061
     /* 2175061 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2175152), // Rule ID 18403 //
     /* 2175066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2175083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175112 */     // MIs[0] round
     /* 2175112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175115 */     // MIs[0] policy
     /* 2175115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175125 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2175128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175151 */     // GIR_Coverage, 18403,
     /* 2175151 */     GIR_EraseRootFromParent_Done,
     /* 2175152 */   // Label 28671: @2175152
     /* 2175152 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2175243), // Rule ID 18406 //
     /* 2175157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2175174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175203 */     // MIs[0] round
     /* 2175203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175206 */     // MIs[0] policy
     /* 2175206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175216 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2175219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175242 */     // GIR_Coverage, 18406,
     /* 2175242 */     GIR_EraseRootFromParent_Done,
     /* 2175243 */   // Label 28672: @2175243
     /* 2175243 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2175334), // Rule ID 18407 //
     /* 2175248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2175259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2175262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2175265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2175268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175294 */     // MIs[0] round
     /* 2175294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175297 */     // MIs[0] policy
     /* 2175297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175307 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2175310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175333 */     // GIR_Coverage, 18407,
     /* 2175333 */     GIR_EraseRootFromParent_Done,
     /* 2175334 */   // Label 28673: @2175334
     /* 2175334 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2175425), // Rule ID 18410 //
     /* 2175339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2175350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2175353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2175356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2175359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175385 */     // MIs[0] round
     /* 2175385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175388 */     // MIs[0] policy
     /* 2175388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175398 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175424 */     // GIR_Coverage, 18410,
     /* 2175424 */     GIR_EraseRootFromParent_Done,
     /* 2175425 */   // Label 28674: @2175425
     /* 2175425 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2175516), // Rule ID 18411 //
     /* 2175430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2175441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2175444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2175447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2175450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175476 */     // MIs[0] round
     /* 2175476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175479 */     // MIs[0] policy
     /* 2175479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175489 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175515 */     // GIR_Coverage, 18411,
     /* 2175515 */     GIR_EraseRootFromParent_Done,
     /* 2175516 */   // Label 28675: @2175516
     /* 2175516 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2175607), // Rule ID 18414 //
     /* 2175521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175567 */     // MIs[0] round
     /* 2175567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175570 */     // MIs[0] policy
     /* 2175570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175580 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175606 */     // GIR_Coverage, 18414,
     /* 2175606 */     GIR_EraseRootFromParent_Done,
     /* 2175607 */   // Label 28676: @2175607
     /* 2175607 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2175698), // Rule ID 18415 //
     /* 2175612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175658 */     // MIs[0] round
     /* 2175658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175661 */     // MIs[0] policy
     /* 2175661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175671 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175697 */     // GIR_Coverage, 18415,
     /* 2175697 */     GIR_EraseRootFromParent_Done,
     /* 2175698 */   // Label 28677: @2175698
     /* 2175698 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2175789), // Rule ID 18418 //
     /* 2175703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175749 */     // MIs[0] round
     /* 2175749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175752 */     // MIs[0] policy
     /* 2175752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175762 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175788 */     // GIR_Coverage, 18418,
     /* 2175788 */     GIR_EraseRootFromParent_Done,
     /* 2175789 */   // Label 28678: @2175789
     /* 2175789 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2175880), // Rule ID 18419 //
     /* 2175794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175840 */     // MIs[0] round
     /* 2175840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175843 */     // MIs[0] policy
     /* 2175843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175853 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175879 */     // GIR_Coverage, 18419,
     /* 2175879 */     GIR_EraseRootFromParent_Done,
     /* 2175880 */   // Label 28679: @2175880
     /* 2175880 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2175971), // Rule ID 18422 //
     /* 2175885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175931 */     // MIs[0] round
     /* 2175931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175934 */     // MIs[0] policy
     /* 2175934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175944 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175970 */     // GIR_Coverage, 18422,
     /* 2175970 */     GIR_EraseRootFromParent_Done,
     /* 2175971 */   // Label 28680: @2175971
     /* 2175971 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2176062), // Rule ID 18423 //
     /* 2175976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176022 */     // MIs[0] round
     /* 2176022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176025 */     // MIs[0] policy
     /* 2176025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176035 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2176038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176061 */     // GIR_Coverage, 18423,
     /* 2176061 */     GIR_EraseRootFromParent_Done,
     /* 2176062 */   // Label 28681: @2176062
     /* 2176062 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2176153), // Rule ID 18426 //
     /* 2176067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176113 */     // MIs[0] round
     /* 2176113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176116 */     // MIs[0] policy
     /* 2176116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176126 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2176129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176152 */     // GIR_Coverage, 18426,
     /* 2176152 */     GIR_EraseRootFromParent_Done,
     /* 2176153 */   // Label 28682: @2176153
     /* 2176153 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2176244), // Rule ID 18427 //
     /* 2176158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176204 */     // MIs[0] round
     /* 2176204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176207 */     // MIs[0] policy
     /* 2176207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176217 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2176220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176243 */     // GIR_Coverage, 18427,
     /* 2176243 */     GIR_EraseRootFromParent_Done,
     /* 2176244 */   // Label 28683: @2176244
     /* 2176244 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2176335), // Rule ID 18430 //
     /* 2176249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2176269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176295 */     // MIs[0] round
     /* 2176295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176298 */     // MIs[0] policy
     /* 2176298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176308 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2176311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176334 */     // GIR_Coverage, 18430,
     /* 2176334 */     GIR_EraseRootFromParent_Done,
     /* 2176335 */   // Label 28684: @2176335
     /* 2176335 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2176426), // Rule ID 18431 //
     /* 2176340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2176351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2176354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2176360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176386 */     // MIs[0] round
     /* 2176386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176389 */     // MIs[0] policy
     /* 2176389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176399 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11300:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2176402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176425 */     // GIR_Coverage, 18431,
     /* 2176425 */     GIR_EraseRootFromParent_Done,
     /* 2176426 */   // Label 28685: @2176426
     /* 2176426 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2176517), // Rule ID 18434 //
     /* 2176431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176477 */     // MIs[0] round
     /* 2176477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176480 */     // MIs[0] policy
     /* 2176480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176516 */     // GIR_Coverage, 18434,
     /* 2176516 */     GIR_EraseRootFromParent_Done,
     /* 2176517 */   // Label 28686: @2176517
     /* 2176517 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2176608), // Rule ID 18435 //
     /* 2176522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176568 */     // MIs[0] round
     /* 2176568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176571 */     // MIs[0] policy
     /* 2176571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176581 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176607 */     // GIR_Coverage, 18435,
     /* 2176607 */     GIR_EraseRootFromParent_Done,
     /* 2176608 */   // Label 28687: @2176608
     /* 2176608 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2176699), // Rule ID 18438 //
     /* 2176613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176659 */     // MIs[0] round
     /* 2176659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176662 */     // MIs[0] policy
     /* 2176662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176672 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176698 */     // GIR_Coverage, 18438,
     /* 2176698 */     GIR_EraseRootFromParent_Done,
     /* 2176699 */   // Label 28688: @2176699
     /* 2176699 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2176790), // Rule ID 18439 //
     /* 2176704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176750 */     // MIs[0] round
     /* 2176750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176753 */     // MIs[0] policy
     /* 2176753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176763 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176789 */     // GIR_Coverage, 18439,
     /* 2176789 */     GIR_EraseRootFromParent_Done,
     /* 2176790 */   // Label 28689: @2176790
     /* 2176790 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2176881), // Rule ID 18442 //
     /* 2176795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176841 */     // MIs[0] round
     /* 2176841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176844 */     // MIs[0] policy
     /* 2176844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176854 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176880 */     // GIR_Coverage, 18442,
     /* 2176880 */     GIR_EraseRootFromParent_Done,
     /* 2176881 */   // Label 28690: @2176881
     /* 2176881 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2176972), // Rule ID 18443 //
     /* 2176886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176932 */     // MIs[0] round
     /* 2176932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176935 */     // MIs[0] policy
     /* 2176935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176945 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176971 */     // GIR_Coverage, 18443,
     /* 2176971 */     GIR_EraseRootFromParent_Done,
     /* 2176972 */   // Label 28691: @2176972
     /* 2176972 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2177063), // Rule ID 18446 //
     /* 2176977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177023 */     // MIs[0] round
     /* 2177023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177026 */     // MIs[0] policy
     /* 2177026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2177039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177062 */     // GIR_Coverage, 18446,
     /* 2177062 */     GIR_EraseRootFromParent_Done,
     /* 2177063 */   // Label 28692: @2177063
     /* 2177063 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2177154), // Rule ID 18447 //
     /* 2177068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177114 */     // MIs[0] round
     /* 2177114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177117 */     // MIs[0] policy
     /* 2177117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177127 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2177130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177153 */     // GIR_Coverage, 18447,
     /* 2177153 */     GIR_EraseRootFromParent_Done,
     /* 2177154 */   // Label 28693: @2177154
     /* 2177154 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2177245), // Rule ID 18450 //
     /* 2177159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177205 */     // MIs[0] round
     /* 2177205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177208 */     // MIs[0] policy
     /* 2177208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177218 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2177221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177244 */     // GIR_Coverage, 18450,
     /* 2177244 */     GIR_EraseRootFromParent_Done,
     /* 2177245 */   // Label 28694: @2177245
     /* 2177245 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2177336), // Rule ID 18451 //
     /* 2177250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2177261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2177264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2177267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2177270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2177273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2177288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177296 */     // MIs[0] round
     /* 2177296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177299 */     // MIs[0] policy
     /* 2177299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177309 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2177312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177335 */     // GIR_Coverage, 18451,
     /* 2177335 */     GIR_EraseRootFromParent_Done,
     /* 2177336 */   // Label 28695: @2177336
     /* 2177336 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2177427), // Rule ID 18454 //
     /* 2177341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2177352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2177355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2177361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177387 */     // MIs[0] round
     /* 2177387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177390 */     // MIs[0] policy
     /* 2177390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177400 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177426 */     // GIR_Coverage, 18454,
     /* 2177426 */     GIR_EraseRootFromParent_Done,
     /* 2177427 */   // Label 28696: @2177427
     /* 2177427 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2177518), // Rule ID 18455 //
     /* 2177432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2177443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2177446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2177452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177478 */     // MIs[0] round
     /* 2177478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177481 */     // MIs[0] policy
     /* 2177481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177491 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177517 */     // GIR_Coverage, 18455,
     /* 2177517 */     GIR_EraseRootFromParent_Done,
     /* 2177518 */   // Label 28697: @2177518
     /* 2177518 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2177609), // Rule ID 18458 //
     /* 2177523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177569 */     // MIs[0] round
     /* 2177569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177572 */     // MIs[0] policy
     /* 2177572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177608 */     // GIR_Coverage, 18458,
     /* 2177608 */     GIR_EraseRootFromParent_Done,
     /* 2177609 */   // Label 28698: @2177609
     /* 2177609 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2177700), // Rule ID 18459 //
     /* 2177614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177660 */     // MIs[0] round
     /* 2177660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177663 */     // MIs[0] policy
     /* 2177663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177673 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177699 */     // GIR_Coverage, 18459,
     /* 2177699 */     GIR_EraseRootFromParent_Done,
     /* 2177700 */   // Label 28699: @2177700
     /* 2177700 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2177791), // Rule ID 18462 //
     /* 2177705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177751 */     // MIs[0] round
     /* 2177751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177754 */     // MIs[0] policy
     /* 2177754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177764 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177790 */     // GIR_Coverage, 18462,
     /* 2177790 */     GIR_EraseRootFromParent_Done,
     /* 2177791 */   // Label 28700: @2177791
     /* 2177791 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2177882), // Rule ID 18463 //
     /* 2177796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177842 */     // MIs[0] round
     /* 2177842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177845 */     // MIs[0] policy
     /* 2177845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177855 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177881 */     // GIR_Coverage, 18463,
     /* 2177881 */     GIR_EraseRootFromParent_Done,
     /* 2177882 */   // Label 28701: @2177882
     /* 2177882 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2177973), // Rule ID 18466 //
     /* 2177887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177933 */     // MIs[0] round
     /* 2177933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177936 */     // MIs[0] policy
     /* 2177936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177946 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177972 */     // GIR_Coverage, 18466,
     /* 2177972 */     GIR_EraseRootFromParent_Done,
     /* 2177973 */   // Label 28702: @2177973
     /* 2177973 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2178064), // Rule ID 18467 //
     /* 2177978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178024 */     // MIs[0] round
     /* 2178024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178027 */     // MIs[0] policy
     /* 2178027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178037 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2178040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178063 */     // GIR_Coverage, 18467,
     /* 2178063 */     GIR_EraseRootFromParent_Done,
     /* 2178064 */   // Label 28703: @2178064
     /* 2178064 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2178155), // Rule ID 18470 //
     /* 2178069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178115 */     // MIs[0] round
     /* 2178115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178118 */     // MIs[0] policy
     /* 2178118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2178131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178154 */     // GIR_Coverage, 18470,
     /* 2178154 */     GIR_EraseRootFromParent_Done,
     /* 2178155 */   // Label 28704: @2178155
     /* 2178155 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2178246), // Rule ID 18471 //
     /* 2178160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178206 */     // MIs[0] round
     /* 2178206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178209 */     // MIs[0] policy
     /* 2178209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178219 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2178222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178245 */     // GIR_Coverage, 18471,
     /* 2178245 */     GIR_EraseRootFromParent_Done,
     /* 2178246 */   // Label 28705: @2178246
     /* 2178246 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2178337), // Rule ID 18474 //
     /* 2178251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2178262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2178265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2178271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178297 */     // MIs[0] round
     /* 2178297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178300 */     // MIs[0] policy
     /* 2178300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178310 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2178313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178336 */     // GIR_Coverage, 18474,
     /* 2178336 */     GIR_EraseRootFromParent_Done,
     /* 2178337 */   // Label 28706: @2178337
     /* 2178337 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2178428), // Rule ID 18475 //
     /* 2178342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2178350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2178353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2178356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2178359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2178362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2178380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178388 */     // MIs[0] round
     /* 2178388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178391 */     // MIs[0] policy
     /* 2178391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178401 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2178404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178427 */     // GIR_Coverage, 18475,
     /* 2178427 */     GIR_EraseRootFromParent_Done,
     /* 2178428 */   // Label 28707: @2178428
     /* 2178428 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2178519), // Rule ID 18478 //
     /* 2178433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178479 */     // MIs[0] round
     /* 2178479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178482 */     // MIs[0] policy
     /* 2178482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178492 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178518 */     // GIR_Coverage, 18478,
     /* 2178518 */     GIR_EraseRootFromParent_Done,
     /* 2178519 */   // Label 28708: @2178519
     /* 2178519 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2178610), // Rule ID 18479 //
     /* 2178524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178570 */     // MIs[0] round
     /* 2178570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178573 */     // MIs[0] policy
     /* 2178573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178583 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178609 */     // GIR_Coverage, 18479,
     /* 2178609 */     GIR_EraseRootFromParent_Done,
     /* 2178610 */   // Label 28709: @2178610
     /* 2178610 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2178701), // Rule ID 18482 //
     /* 2178615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178661 */     // MIs[0] round
     /* 2178661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178664 */     // MIs[0] policy
     /* 2178664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178700 */     // GIR_Coverage, 18482,
     /* 2178700 */     GIR_EraseRootFromParent_Done,
     /* 2178701 */   // Label 28710: @2178701
     /* 2178701 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2178792), // Rule ID 18483 //
     /* 2178706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178752 */     // MIs[0] round
     /* 2178752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178755 */     // MIs[0] policy
     /* 2178755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178765 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178791 */     // GIR_Coverage, 18483,
     /* 2178791 */     GIR_EraseRootFromParent_Done,
     /* 2178792 */   // Label 28711: @2178792
     /* 2178792 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2178883), // Rule ID 18486 //
     /* 2178797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178843 */     // MIs[0] round
     /* 2178843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178846 */     // MIs[0] policy
     /* 2178846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178856 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178882 */     // GIR_Coverage, 18486,
     /* 2178882 */     GIR_EraseRootFromParent_Done,
     /* 2178883 */   // Label 28712: @2178883
     /* 2178883 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2178974), // Rule ID 18487 //
     /* 2178888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178934 */     // MIs[0] round
     /* 2178934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178937 */     // MIs[0] policy
     /* 2178937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178947 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178973 */     // GIR_Coverage, 18487,
     /* 2178973 */     GIR_EraseRootFromParent_Done,
     /* 2178974 */   // Label 28713: @2178974
     /* 2178974 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2179065), // Rule ID 18490 //
     /* 2178979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2178993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179025 */     // MIs[0] round
     /* 2179025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179028 */     // MIs[0] policy
     /* 2179028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179038 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2179041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179064 */     // GIR_Coverage, 18490,
     /* 2179064 */     GIR_EraseRootFromParent_Done,
     /* 2179065 */   // Label 28714: @2179065
     /* 2179065 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2179156), // Rule ID 18491 //
     /* 2179070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2179087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179116 */     // MIs[0] round
     /* 2179116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179119 */     // MIs[0] policy
     /* 2179119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179129 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2179132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179155 */     // GIR_Coverage, 18491,
     /* 2179155 */     GIR_EraseRootFromParent_Done,
     /* 2179156 */   // Label 28715: @2179156
     /* 2179156 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2179247), // Rule ID 18494 //
     /* 2179161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2179178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179207 */     // MIs[0] round
     /* 2179207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179210 */     // MIs[0] policy
     /* 2179210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179220 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2179223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179246 */     // GIR_Coverage, 18494,
     /* 2179246 */     GIR_EraseRootFromParent_Done,
     /* 2179247 */   // Label 28716: @2179247
     /* 2179247 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2179338), // Rule ID 18495 //
     /* 2179252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2179269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2179272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179298 */     // MIs[0] round
     /* 2179298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179301 */     // MIs[0] policy
     /* 2179301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179311 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2179314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179337 */     // GIR_Coverage, 18495,
     /* 2179337 */     GIR_EraseRootFromParent_Done,
     /* 2179338 */   // Label 28717: @2179338
     /* 2179338 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2179429), // Rule ID 18498 //
     /* 2179343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2179346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2179354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2179357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2179360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2179363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179389 */     // MIs[0] round
     /* 2179389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179392 */     // MIs[0] policy
     /* 2179392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179428 */     // GIR_Coverage, 18498,
     /* 2179428 */     GIR_EraseRootFromParent_Done,
     /* 2179429 */   // Label 28718: @2179429
     /* 2179429 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2179520), // Rule ID 18499 //
     /* 2179434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2179437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2179445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2179448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2179451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2179454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179480 */     // MIs[0] round
     /* 2179480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179483 */     // MIs[0] policy
     /* 2179483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179493 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179519 */     // GIR_Coverage, 18499,
     /* 2179519 */     GIR_EraseRootFromParent_Done,
     /* 2179520 */   // Label 28719: @2179520
     /* 2179520 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2179611), // Rule ID 18502 //
     /* 2179525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179571 */     // MIs[0] round
     /* 2179571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179574 */     // MIs[0] policy
     /* 2179574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179584 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179610 */     // GIR_Coverage, 18502,
     /* 2179610 */     GIR_EraseRootFromParent_Done,
     /* 2179611 */   // Label 28720: @2179611
     /* 2179611 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2179702), // Rule ID 18503 //
     /* 2179616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179662 */     // MIs[0] round
     /* 2179662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179665 */     // MIs[0] policy
     /* 2179665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179675 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179701 */     // GIR_Coverage, 18503,
     /* 2179701 */     GIR_EraseRootFromParent_Done,
     /* 2179702 */   // Label 28721: @2179702
     /* 2179702 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2179793), // Rule ID 18506 //
     /* 2179707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179753 */     // MIs[0] round
     /* 2179753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179756 */     // MIs[0] policy
     /* 2179756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179766 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179792 */     // GIR_Coverage, 18506,
     /* 2179792 */     GIR_EraseRootFromParent_Done,
     /* 2179793 */   // Label 28722: @2179793
     /* 2179793 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2179884), // Rule ID 18507 //
     /* 2179798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179844 */     // MIs[0] round
     /* 2179844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179847 */     // MIs[0] policy
     /* 2179847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179857 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179883 */     // GIR_Coverage, 18507,
     /* 2179883 */     GIR_EraseRootFromParent_Done,
     /* 2179884 */   // Label 28723: @2179884
     /* 2179884 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2179975), // Rule ID 18510 //
     /* 2179889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179935 */     // MIs[0] round
     /* 2179935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179938 */     // MIs[0] policy
     /* 2179938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179948 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179974 */     // GIR_Coverage, 18510,
     /* 2179974 */     GIR_EraseRootFromParent_Done,
     /* 2179975 */   // Label 28724: @2179975
     /* 2179975 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2180066), // Rule ID 18511 //
     /* 2179980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180026 */     // MIs[0] round
     /* 2180026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180029 */     // MIs[0] policy
     /* 2180029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180039 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2180042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180065 */     // GIR_Coverage, 18511,
     /* 2180065 */     GIR_EraseRootFromParent_Done,
     /* 2180066 */   // Label 28725: @2180066
     /* 2180066 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2180157), // Rule ID 18514 //
     /* 2180071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2180088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180117 */     // MIs[0] round
     /* 2180117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180120 */     // MIs[0] policy
     /* 2180120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180130 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2180133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180156 */     // GIR_Coverage, 18514,
     /* 2180156 */     GIR_EraseRootFromParent_Done,
     /* 2180157 */   // Label 28726: @2180157
     /* 2180157 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2180248), // Rule ID 18515 //
     /* 2180162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2180179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180208 */     // MIs[0] round
     /* 2180208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180211 */     // MIs[0] policy
     /* 2180211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180221 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2180224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180247 */     // GIR_Coverage, 18515,
     /* 2180247 */     GIR_EraseRootFromParent_Done,
     /* 2180248 */   // Label 28727: @2180248
     /* 2180248 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2180339), // Rule ID 18518 //
     /* 2180253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2180264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2180270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180299 */     // MIs[0] round
     /* 2180299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180302 */     // MIs[0] policy
     /* 2180302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180312 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2180315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180338 */     // GIR_Coverage, 18518,
     /* 2180338 */     GIR_EraseRootFromParent_Done,
     /* 2180339 */   // Label 28728: @2180339
     /* 2180339 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2180430), // Rule ID 18519 //
     /* 2180344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2180355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2180358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2180361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180390 */     // MIs[0] round
     /* 2180390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180393 */     // MIs[0] policy
     /* 2180393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180403 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2180406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180429 */     // GIR_Coverage, 18519,
     /* 2180429 */     GIR_EraseRootFromParent_Done,
     /* 2180430 */   // Label 28729: @2180430
     /* 2180430 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2180521), // Rule ID 18522 //
     /* 2180435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180481 */     // MIs[0] round
     /* 2180481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180484 */     // MIs[0] policy
     /* 2180484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180494 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180520 */     // GIR_Coverage, 18522,
     /* 2180520 */     GIR_EraseRootFromParent_Done,
     /* 2180521 */   // Label 28730: @2180521
     /* 2180521 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2180612), // Rule ID 18523 //
     /* 2180526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180572 */     // MIs[0] round
     /* 2180572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180575 */     // MIs[0] policy
     /* 2180575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180585 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180611 */     // GIR_Coverage, 18523,
     /* 2180611 */     GIR_EraseRootFromParent_Done,
     /* 2180612 */   // Label 28731: @2180612
     /* 2180612 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2180703), // Rule ID 18526 //
     /* 2180617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180663 */     // MIs[0] round
     /* 2180663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180666 */     // MIs[0] policy
     /* 2180666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180676 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180702 */     // GIR_Coverage, 18526,
     /* 2180702 */     GIR_EraseRootFromParent_Done,
     /* 2180703 */   // Label 28732: @2180703
     /* 2180703 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2180794), // Rule ID 18527 //
     /* 2180708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180754 */     // MIs[0] round
     /* 2180754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180757 */     // MIs[0] policy
     /* 2180757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180767 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180793 */     // GIR_Coverage, 18527,
     /* 2180793 */     GIR_EraseRootFromParent_Done,
     /* 2180794 */   // Label 28733: @2180794
     /* 2180794 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2180885), // Rule ID 18530 //
     /* 2180799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180845 */     // MIs[0] round
     /* 2180845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180848 */     // MIs[0] policy
     /* 2180848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180858 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180884 */     // GIR_Coverage, 18530,
     /* 2180884 */     GIR_EraseRootFromParent_Done,
     /* 2180885 */   // Label 28734: @2180885
     /* 2180885 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2180976), // Rule ID 18531 //
     /* 2180890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180936 */     // MIs[0] round
     /* 2180936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180939 */     // MIs[0] policy
     /* 2180939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180949 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180975 */     // GIR_Coverage, 18531,
     /* 2180975 */     GIR_EraseRootFromParent_Done,
     /* 2180976 */   // Label 28735: @2180976
     /* 2180976 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2181067), // Rule ID 18534 //
     /* 2180981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2180998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181027 */     // MIs[0] round
     /* 2181027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181030 */     // MIs[0] policy
     /* 2181030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181040 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2181043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181066 */     // GIR_Coverage, 18534,
     /* 2181066 */     GIR_EraseRootFromParent_Done,
     /* 2181067 */   // Label 28736: @2181067
     /* 2181067 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2181158), // Rule ID 18535 //
     /* 2181072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2181089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181118 */     // MIs[0] round
     /* 2181118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181121 */     // MIs[0] policy
     /* 2181121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181131 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2181134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181157 */     // GIR_Coverage, 18535,
     /* 2181157 */     GIR_EraseRootFromParent_Done,
     /* 2181158 */   // Label 28737: @2181158
     /* 2181158 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2181249), // Rule ID 18538 //
     /* 2181163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181209 */     // MIs[0] round
     /* 2181209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181212 */     // MIs[0] policy
     /* 2181212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2181225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181248 */     // GIR_Coverage, 18538,
     /* 2181248 */     GIR_EraseRootFromParent_Done,
     /* 2181249 */   // Label 28738: @2181249
     /* 2181249 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2181340), // Rule ID 18539 //
     /* 2181254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2181265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2181268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181300 */     // MIs[0] round
     /* 2181300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181303 */     // MIs[0] policy
     /* 2181303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181313 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2181316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181339 */     // GIR_Coverage, 18539,
     /* 2181339 */     GIR_EraseRootFromParent_Done,
     /* 2181340 */   // Label 28739: @2181340
     /* 2181340 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2181431), // Rule ID 18542 //
     /* 2181345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2181356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2181359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181391 */     // MIs[0] round
     /* 2181391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181394 */     // MIs[0] policy
     /* 2181394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181404 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181430 */     // GIR_Coverage, 18542,
     /* 2181430 */     GIR_EraseRootFromParent_Done,
     /* 2181431 */   // Label 28740: @2181431
     /* 2181431 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2181522), // Rule ID 18543 //
     /* 2181436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2181447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2181450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181482 */     // MIs[0] round
     /* 2181482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181485 */     // MIs[0] policy
     /* 2181485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181495 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181521 */     // GIR_Coverage, 18543,
     /* 2181521 */     GIR_EraseRootFromParent_Done,
     /* 2181522 */   // Label 28741: @2181522
     /* 2181522 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2181613), // Rule ID 18546 //
     /* 2181527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181573 */     // MIs[0] round
     /* 2181573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181576 */     // MIs[0] policy
     /* 2181576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181586 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181612 */     // GIR_Coverage, 18546,
     /* 2181612 */     GIR_EraseRootFromParent_Done,
     /* 2181613 */   // Label 28742: @2181613
     /* 2181613 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2181704), // Rule ID 18547 //
     /* 2181618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181664 */     // MIs[0] round
     /* 2181664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181667 */     // MIs[0] policy
     /* 2181667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181677 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181703 */     // GIR_Coverage, 18547,
     /* 2181703 */     GIR_EraseRootFromParent_Done,
     /* 2181704 */   // Label 28743: @2181704
     /* 2181704 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2181795), // Rule ID 18550 //
     /* 2181709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181755 */     // MIs[0] round
     /* 2181755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181758 */     // MIs[0] policy
     /* 2181758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181768 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181794 */     // GIR_Coverage, 18550,
     /* 2181794 */     GIR_EraseRootFromParent_Done,
     /* 2181795 */   // Label 28744: @2181795
     /* 2181795 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2181886), // Rule ID 18551 //
     /* 2181800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181846 */     // MIs[0] round
     /* 2181846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181849 */     // MIs[0] policy
     /* 2181849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181859 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181885 */     // GIR_Coverage, 18551,
     /* 2181885 */     GIR_EraseRootFromParent_Done,
     /* 2181886 */   // Label 28745: @2181886
     /* 2181886 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2181977), // Rule ID 18554 //
     /* 2181891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181937 */     // MIs[0] round
     /* 2181937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181940 */     // MIs[0] policy
     /* 2181940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181976 */     // GIR_Coverage, 18554,
     /* 2181976 */     GIR_EraseRootFromParent_Done,
     /* 2181977 */   // Label 28746: @2181977
     /* 2181977 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2182068), // Rule ID 18555 //
     /* 2181982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182028 */     // MIs[0] round
     /* 2182028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182031 */     // MIs[0] policy
     /* 2182031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182041 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2182044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182067 */     // GIR_Coverage, 18555,
     /* 2182067 */     GIR_EraseRootFromParent_Done,
     /* 2182068 */   // Label 28747: @2182068
     /* 2182068 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2182159), // Rule ID 18558 //
     /* 2182073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182119 */     // MIs[0] round
     /* 2182119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182122 */     // MIs[0] policy
     /* 2182122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2182135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182158 */     // GIR_Coverage, 18558,
     /* 2182158 */     GIR_EraseRootFromParent_Done,
     /* 2182159 */   // Label 28748: @2182159
     /* 2182159 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2182250), // Rule ID 18559 //
     /* 2182164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2182184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182210 */     // MIs[0] round
     /* 2182210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182213 */     // MIs[0] policy
     /* 2182213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182223 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2182226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182249 */     // GIR_Coverage, 18559,
     /* 2182249 */     GIR_EraseRootFromParent_Done,
     /* 2182250 */   // Label 28749: @2182250
     /* 2182250 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2182341), // Rule ID 18562 //
     /* 2182255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2182266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182301 */     // MIs[0] round
     /* 2182301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182304 */     // MIs[0] policy
     /* 2182304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182314 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2182317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182340 */     // GIR_Coverage, 18562,
     /* 2182340 */     GIR_EraseRootFromParent_Done,
     /* 2182341 */   // Label 28750: @2182341
     /* 2182341 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2182432), // Rule ID 18563 //
     /* 2182346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2182357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2182360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182392 */     // MIs[0] round
     /* 2182392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182395 */     // MIs[0] policy
     /* 2182395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182405 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2182408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182431 */     // GIR_Coverage, 18563,
     /* 2182431 */     GIR_EraseRootFromParent_Done,
     /* 2182432 */   // Label 28751: @2182432
     /* 2182432 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2182523), // Rule ID 18566 //
     /* 2182437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182483 */     // MIs[0] round
     /* 2182483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182486 */     // MIs[0] policy
     /* 2182486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182522 */     // GIR_Coverage, 18566,
     /* 2182522 */     GIR_EraseRootFromParent_Done,
     /* 2182523 */   // Label 28752: @2182523
     /* 2182523 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2182614), // Rule ID 18567 //
     /* 2182528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182574 */     // MIs[0] round
     /* 2182574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182577 */     // MIs[0] policy
     /* 2182577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182587 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182613 */     // GIR_Coverage, 18567,
     /* 2182613 */     GIR_EraseRootFromParent_Done,
     /* 2182614 */   // Label 28753: @2182614
     /* 2182614 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2182705), // Rule ID 18570 //
     /* 2182619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182665 */     // MIs[0] round
     /* 2182665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182668 */     // MIs[0] policy
     /* 2182668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182678 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182704 */     // GIR_Coverage, 18570,
     /* 2182704 */     GIR_EraseRootFromParent_Done,
     /* 2182705 */   // Label 28754: @2182705
     /* 2182705 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2182796), // Rule ID 18571 //
     /* 2182710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182756 */     // MIs[0] round
     /* 2182756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182759 */     // MIs[0] policy
     /* 2182759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182769 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182795 */     // GIR_Coverage, 18571,
     /* 2182795 */     GIR_EraseRootFromParent_Done,
     /* 2182796 */   // Label 28755: @2182796
     /* 2182796 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2182887), // Rule ID 18574 //
     /* 2182801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182847 */     // MIs[0] round
     /* 2182847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182850 */     // MIs[0] policy
     /* 2182850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182886 */     // GIR_Coverage, 18574,
     /* 2182886 */     GIR_EraseRootFromParent_Done,
     /* 2182887 */   // Label 28756: @2182887
     /* 2182887 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2182978), // Rule ID 18575 //
     /* 2182892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182938 */     // MIs[0] round
     /* 2182938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182941 */     // MIs[0] policy
     /* 2182941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182951 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182977 */     // GIR_Coverage, 18575,
     /* 2182977 */     GIR_EraseRootFromParent_Done,
     /* 2182978 */   // Label 28757: @2182978
     /* 2182978 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2183069), // Rule ID 18578 //
     /* 2182983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183029 */     // MIs[0] round
     /* 2183029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183032 */     // MIs[0] policy
     /* 2183032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183042 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2183045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183068 */     // GIR_Coverage, 18578,
     /* 2183068 */     GIR_EraseRootFromParent_Done,
     /* 2183069 */   // Label 28758: @2183069
     /* 2183069 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2183160), // Rule ID 18579 //
     /* 2183074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183120 */     // MIs[0] round
     /* 2183120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183123 */     // MIs[0] policy
     /* 2183123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183133 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2183136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183159 */     // GIR_Coverage, 18579,
     /* 2183159 */     GIR_EraseRootFromParent_Done,
     /* 2183160 */   // Label 28759: @2183160
     /* 2183160 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2183251), // Rule ID 18582 //
     /* 2183165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183211 */     // MIs[0] round
     /* 2183211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183214 */     // MIs[0] policy
     /* 2183214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183224 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2183227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183250 */     // GIR_Coverage, 18582,
     /* 2183250 */     GIR_EraseRootFromParent_Done,
     /* 2183251 */   // Label 28760: @2183251
     /* 2183251 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2183342), // Rule ID 18583 //
     /* 2183256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2183276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183302 */     // MIs[0] round
     /* 2183302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183305 */     // MIs[0] policy
     /* 2183305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183315 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2183318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183341 */     // GIR_Coverage, 18583,
     /* 2183341 */     GIR_EraseRootFromParent_Done,
     /* 2183342 */   // Label 28761: @2183342
     /* 2183342 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2183433), // Rule ID 18586 //
     /* 2183347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2183367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183393 */     // MIs[0] round
     /* 2183393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183396 */     // MIs[0] policy
     /* 2183396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183432 */     // GIR_Coverage, 18586,
     /* 2183432 */     GIR_EraseRootFromParent_Done,
     /* 2183433 */   // Label 28762: @2183433
     /* 2183433 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2183524), // Rule ID 18587 //
     /* 2183438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2183458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183484 */     // MIs[0] round
     /* 2183484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183487 */     // MIs[0] policy
     /* 2183487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183497 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183523 */     // GIR_Coverage, 18587,
     /* 2183523 */     GIR_EraseRootFromParent_Done,
     /* 2183524 */   // Label 28763: @2183524
     /* 2183524 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2183615), // Rule ID 18590 //
     /* 2183529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183575 */     // MIs[0] round
     /* 2183575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183578 */     // MIs[0] policy
     /* 2183578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183588 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183614 */     // GIR_Coverage, 18590,
     /* 2183614 */     GIR_EraseRootFromParent_Done,
     /* 2183615 */   // Label 28764: @2183615
     /* 2183615 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2183706), // Rule ID 18591 //
     /* 2183620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183666 */     // MIs[0] round
     /* 2183666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183669 */     // MIs[0] policy
     /* 2183669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183679 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183705 */     // GIR_Coverage, 18591,
     /* 2183705 */     GIR_EraseRootFromParent_Done,
     /* 2183706 */   // Label 28765: @2183706
     /* 2183706 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2183797), // Rule ID 18594 //
     /* 2183711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183757 */     // MIs[0] round
     /* 2183757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183760 */     // MIs[0] policy
     /* 2183760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183770 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183796 */     // GIR_Coverage, 18594,
     /* 2183796 */     GIR_EraseRootFromParent_Done,
     /* 2183797 */   // Label 28766: @2183797
     /* 2183797 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2183888), // Rule ID 18595 //
     /* 2183802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183848 */     // MIs[0] round
     /* 2183848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183851 */     // MIs[0] policy
     /* 2183851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183861 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183887 */     // GIR_Coverage, 18595,
     /* 2183887 */     GIR_EraseRootFromParent_Done,
     /* 2183888 */   // Label 28767: @2183888
     /* 2183888 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2183979), // Rule ID 18598 //
     /* 2183893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183939 */     // MIs[0] round
     /* 2183939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183942 */     // MIs[0] policy
     /* 2183942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183952 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183978 */     // GIR_Coverage, 18598,
     /* 2183978 */     GIR_EraseRootFromParent_Done,
     /* 2183979 */   // Label 28768: @2183979
     /* 2183979 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2184070), // Rule ID 18599 //
     /* 2183984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2184001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184030 */     // MIs[0] round
     /* 2184030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184033 */     // MIs[0] policy
     /* 2184033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184043 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2184046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184069 */     // GIR_Coverage, 18599,
     /* 2184069 */     GIR_EraseRootFromParent_Done,
     /* 2184070 */   // Label 28769: @2184070
     /* 2184070 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2184161), // Rule ID 18602 //
     /* 2184075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184121 */     // MIs[0] round
     /* 2184121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184124 */     // MIs[0] policy
     /* 2184124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2184137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184160 */     // GIR_Coverage, 18602,
     /* 2184160 */     GIR_EraseRootFromParent_Done,
     /* 2184161 */   // Label 28770: @2184161
     /* 2184161 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2184252), // Rule ID 18603 //
     /* 2184166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2184177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2184180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184212 */     // MIs[0] round
     /* 2184212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184215 */     // MIs[0] policy
     /* 2184215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184225 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2184228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184251 */     // GIR_Coverage, 18603,
     /* 2184251 */     GIR_EraseRootFromParent_Done,
     /* 2184252 */   // Label 28771: @2184252
     /* 2184252 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2184343), // Rule ID 18606 //
     /* 2184257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2184274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184303 */     // MIs[0] round
     /* 2184303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184306 */     // MIs[0] policy
     /* 2184306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184316 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2184319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184342 */     // GIR_Coverage, 18606,
     /* 2184342 */     GIR_EraseRootFromParent_Done,
     /* 2184343 */   // Label 28772: @2184343
     /* 2184343 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2184434), // Rule ID 18607 //
     /* 2184348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2184365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184394 */     // MIs[0] round
     /* 2184394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184397 */     // MIs[0] policy
     /* 2184397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184407 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2184410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184433 */     // GIR_Coverage, 18607,
     /* 2184433 */     GIR_EraseRootFromParent_Done,
     /* 2184434 */   // Label 28773: @2184434
     /* 2184434 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2184525), // Rule ID 18610 //
     /* 2184439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184485 */     // MIs[0] round
     /* 2184485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184488 */     // MIs[0] policy
     /* 2184488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184498 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184524 */     // GIR_Coverage, 18610,
     /* 2184524 */     GIR_EraseRootFromParent_Done,
     /* 2184525 */   // Label 28774: @2184525
     /* 2184525 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2184616), // Rule ID 18611 //
     /* 2184530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184576 */     // MIs[0] round
     /* 2184576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184579 */     // MIs[0] policy
     /* 2184579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184589 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184615 */     // GIR_Coverage, 18611,
     /* 2184615 */     GIR_EraseRootFromParent_Done,
     /* 2184616 */   // Label 28775: @2184616
     /* 2184616 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2184707), // Rule ID 18614 //
     /* 2184621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184667 */     // MIs[0] round
     /* 2184667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184670 */     // MIs[0] policy
     /* 2184670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184680 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184706 */     // GIR_Coverage, 18614,
     /* 2184706 */     GIR_EraseRootFromParent_Done,
     /* 2184707 */   // Label 28776: @2184707
     /* 2184707 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2184798), // Rule ID 18615 //
     /* 2184712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184758 */     // MIs[0] round
     /* 2184758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184761 */     // MIs[0] policy
     /* 2184761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184771 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184797 */     // GIR_Coverage, 18615,
     /* 2184797 */     GIR_EraseRootFromParent_Done,
     /* 2184798 */   // Label 28777: @2184798
     /* 2184798 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2184889), // Rule ID 18618 //
     /* 2184803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184849 */     // MIs[0] round
     /* 2184849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184852 */     // MIs[0] policy
     /* 2184852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184888 */     // GIR_Coverage, 18618,
     /* 2184888 */     GIR_EraseRootFromParent_Done,
     /* 2184889 */   // Label 28778: @2184889
     /* 2184889 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2184980), // Rule ID 18619 //
     /* 2184894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184940 */     // MIs[0] round
     /* 2184940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184943 */     // MIs[0] policy
     /* 2184943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184953 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184979 */     // GIR_Coverage, 18619,
     /* 2184979 */     GIR_EraseRootFromParent_Done,
     /* 2184980 */   // Label 28779: @2184980
     /* 2184980 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2185071), // Rule ID 18622 //
     /* 2184985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2184996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2184999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185031 */     // MIs[0] round
     /* 2185031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185034 */     // MIs[0] policy
     /* 2185034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185044 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2185047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185070 */     // GIR_Coverage, 18622,
     /* 2185070 */     GIR_EraseRootFromParent_Done,
     /* 2185071 */   // Label 28780: @2185071
     /* 2185071 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2185162), // Rule ID 18623 //
     /* 2185076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2185087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2185090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185122 */     // MIs[0] round
     /* 2185122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185125 */     // MIs[0] policy
     /* 2185125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185135 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2185138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185161 */     // GIR_Coverage, 18623,
     /* 2185161 */     GIR_EraseRootFromParent_Done,
     /* 2185162 */   // Label 28781: @2185162
     /* 2185162 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2185253), // Rule ID 18626 //
     /* 2185167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2185184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185213 */     // MIs[0] round
     /* 2185213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185216 */     // MIs[0] policy
     /* 2185216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185226 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2185229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185252 */     // GIR_Coverage, 18626,
     /* 2185252 */     GIR_EraseRootFromParent_Done,
     /* 2185253 */   // Label 28782: @2185253
     /* 2185253 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2185344), // Rule ID 18627 //
     /* 2185258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2185269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2185272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2185275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185304 */     // MIs[0] round
     /* 2185304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185307 */     // MIs[0] policy
     /* 2185307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185317 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2185320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185343 */     // GIR_Coverage, 18627,
     /* 2185343 */     GIR_EraseRootFromParent_Done,
     /* 2185344 */   // Label 28783: @2185344
     /* 2185344 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2185435), // Rule ID 18630 //
     /* 2185349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2185352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2185360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2185366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2185369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2185372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185395 */     // MIs[0] round
     /* 2185395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185398 */     // MIs[0] policy
     /* 2185398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185408 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185434 */     // GIR_Coverage, 18630,
     /* 2185434 */     GIR_EraseRootFromParent_Done,
     /* 2185435 */   // Label 28784: @2185435
     /* 2185435 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2185526), // Rule ID 18631 //
     /* 2185440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2185443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2185451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2185454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2185457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2185460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2185463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185486 */     // MIs[0] round
     /* 2185486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185489 */     // MIs[0] policy
     /* 2185489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185499 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185525 */     // GIR_Coverage, 18631,
     /* 2185525 */     GIR_EraseRootFromParent_Done,
     /* 2185526 */   // Label 28785: @2185526
     /* 2185526 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2185617), // Rule ID 18634 //
     /* 2185531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185577 */     // MIs[0] round
     /* 2185577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185580 */     // MIs[0] policy
     /* 2185580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185616 */     // GIR_Coverage, 18634,
     /* 2185616 */     GIR_EraseRootFromParent_Done,
     /* 2185617 */   // Label 28786: @2185617
     /* 2185617 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2185708), // Rule ID 18635 //
     /* 2185622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185668 */     // MIs[0] round
     /* 2185668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185671 */     // MIs[0] policy
     /* 2185671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185681 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185707 */     // GIR_Coverage, 18635,
     /* 2185707 */     GIR_EraseRootFromParent_Done,
     /* 2185708 */   // Label 28787: @2185708
     /* 2185708 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2185799), // Rule ID 18638 //
     /* 2185713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185759 */     // MIs[0] round
     /* 2185759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185762 */     // MIs[0] policy
     /* 2185762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185772 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185798 */     // GIR_Coverage, 18638,
     /* 2185798 */     GIR_EraseRootFromParent_Done,
     /* 2185799 */   // Label 28788: @2185799
     /* 2185799 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2185890), // Rule ID 18639 //
     /* 2185804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185850 */     // MIs[0] round
     /* 2185850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185853 */     // MIs[0] policy
     /* 2185853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185863 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185889 */     // GIR_Coverage, 18639,
     /* 2185889 */     GIR_EraseRootFromParent_Done,
     /* 2185890 */   // Label 28789: @2185890
     /* 2185890 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2185981), // Rule ID 18642 //
     /* 2185895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185941 */     // MIs[0] round
     /* 2185941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185944 */     // MIs[0] policy
     /* 2185944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185954 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185980 */     // GIR_Coverage, 18642,
     /* 2185980 */     GIR_EraseRootFromParent_Done,
     /* 2185981 */   // Label 28790: @2185981
     /* 2185981 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2186072), // Rule ID 18643 //
     /* 2185986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2186003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2186006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186032 */     // MIs[0] round
     /* 2186032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186035 */     // MIs[0] policy
     /* 2186035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186045 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2186048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186071 */     // GIR_Coverage, 18643,
     /* 2186071 */     GIR_EraseRootFromParent_Done,
     /* 2186072 */   // Label 28791: @2186072
     /* 2186072 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2186163), // Rule ID 18646 //
     /* 2186077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2186094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186123 */     // MIs[0] round
     /* 2186123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186126 */     // MIs[0] policy
     /* 2186126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186136 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2186139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186162 */     // GIR_Coverage, 18646,
     /* 2186162 */     GIR_EraseRootFromParent_Done,
     /* 2186163 */   // Label 28792: @2186163
     /* 2186163 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2186254), // Rule ID 18647 //
     /* 2186168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2186185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2186188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186214 */     // MIs[0] round
     /* 2186214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186217 */     // MIs[0] policy
     /* 2186217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186227 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2186230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186253 */     // GIR_Coverage, 18647,
     /* 2186253 */     GIR_EraseRootFromParent_Done,
     /* 2186254 */   // Label 28793: @2186254
     /* 2186254 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2186345), // Rule ID 18650 //
     /* 2186259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2186276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2186279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186305 */     // MIs[0] round
     /* 2186305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186308 */     // MIs[0] policy
     /* 2186308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186318 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2186321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186344 */     // GIR_Coverage, 18650,
     /* 2186344 */     GIR_EraseRootFromParent_Done,
     /* 2186345 */   // Label 28794: @2186345
     /* 2186345 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2186436), // Rule ID 18651 //
     /* 2186350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2186367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2186370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186396 */     // MIs[0] round
     /* 2186396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186399 */     // MIs[0] policy
     /* 2186399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186409 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2186412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186435 */     // GIR_Coverage, 18651,
     /* 2186435 */     GIR_EraseRootFromParent_Done,
     /* 2186436 */   // Label 28795: @2186436
     /* 2186436 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2186527), // Rule ID 18654 //
     /* 2186441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2186444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186487 */     // MIs[0] round
     /* 2186487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186490 */     // MIs[0] policy
     /* 2186490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186500 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186526 */     // GIR_Coverage, 18654,
     /* 2186526 */     GIR_EraseRootFromParent_Done,
     /* 2186527 */   // Label 28796: @2186527
     /* 2186527 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2186618), // Rule ID 18655 //
     /* 2186532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186578 */     // MIs[0] round
     /* 2186578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186581 */     // MIs[0] policy
     /* 2186581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186591 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186617 */     // GIR_Coverage, 18655,
     /* 2186617 */     GIR_EraseRootFromParent_Done,
     /* 2186618 */   // Label 28797: @2186618
     /* 2186618 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2186709), // Rule ID 18658 //
     /* 2186623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186669 */     // MIs[0] round
     /* 2186669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186672 */     // MIs[0] policy
     /* 2186672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186682 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186708 */     // GIR_Coverage, 18658,
     /* 2186708 */     GIR_EraseRootFromParent_Done,
     /* 2186709 */   // Label 28798: @2186709
     /* 2186709 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2186800), // Rule ID 18659 //
     /* 2186714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186760 */     // MIs[0] round
     /* 2186760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186763 */     // MIs[0] policy
     /* 2186763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186773 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186799 */     // GIR_Coverage, 18659,
     /* 2186799 */     GIR_EraseRootFromParent_Done,
     /* 2186800 */   // Label 28799: @2186800
     /* 2186800 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2186891), // Rule ID 18662 //
     /* 2186805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186851 */     // MIs[0] round
     /* 2186851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186854 */     // MIs[0] policy
     /* 2186854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186864 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186890 */     // GIR_Coverage, 18662,
     /* 2186890 */     GIR_EraseRootFromParent_Done,
     /* 2186891 */   // Label 28800: @2186891
     /* 2186891 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2186982), // Rule ID 18663 //
     /* 2186896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186942 */     // MIs[0] round
     /* 2186942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186945 */     // MIs[0] policy
     /* 2186945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186955 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186981 */     // GIR_Coverage, 18663,
     /* 2186981 */     GIR_EraseRootFromParent_Done,
     /* 2186982 */   // Label 28801: @2186982
     /* 2186982 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2187073), // Rule ID 18666 //
     /* 2186987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187033 */     // MIs[0] round
     /* 2187033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187036 */     // MIs[0] policy
     /* 2187036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187046 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2187049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187072 */     // GIR_Coverage, 18666,
     /* 2187072 */     GIR_EraseRootFromParent_Done,
     /* 2187073 */   // Label 28802: @2187073
     /* 2187073 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2187164), // Rule ID 18667 //
     /* 2187078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187124 */     // MIs[0] round
     /* 2187124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187127 */     // MIs[0] policy
     /* 2187127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187137 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2187140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187163 */     // GIR_Coverage, 18667,
     /* 2187163 */     GIR_EraseRootFromParent_Done,
     /* 2187164 */   // Label 28803: @2187164
     /* 2187164 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2187255), // Rule ID 18670 //
     /* 2187169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187215 */     // MIs[0] round
     /* 2187215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187218 */     // MIs[0] policy
     /* 2187218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187228 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2187231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187254 */     // GIR_Coverage, 18670,
     /* 2187254 */     GIR_EraseRootFromParent_Done,
     /* 2187255 */   // Label 28804: @2187255
     /* 2187255 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2187346), // Rule ID 18671 //
     /* 2187260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2187271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2187274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187306 */     // MIs[0] round
     /* 2187306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187309 */     // MIs[0] policy
     /* 2187309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187319 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11304:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2187322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187345 */     // GIR_Coverage, 18671,
     /* 2187345 */     GIR_EraseRootFromParent_Done,
     /* 2187346 */   // Label 28805: @2187346
     /* 2187346 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2187437), // Rule ID 18674 //
     /* 2187351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187397 */     // MIs[0] round
     /* 2187397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187400 */     // MIs[0] policy
     /* 2187400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187436 */     // GIR_Coverage, 18674,
     /* 2187436 */     GIR_EraseRootFromParent_Done,
     /* 2187437 */   // Label 28806: @2187437
     /* 2187437 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2187528), // Rule ID 18675 //
     /* 2187442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187488 */     // MIs[0] round
     /* 2187488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187491 */     // MIs[0] policy
     /* 2187491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187501 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187527 */     // GIR_Coverage, 18675,
     /* 2187527 */     GIR_EraseRootFromParent_Done,
     /* 2187528 */   // Label 28807: @2187528
     /* 2187528 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2187619), // Rule ID 18678 //
     /* 2187533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187579 */     // MIs[0] round
     /* 2187579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187582 */     // MIs[0] policy
     /* 2187582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187592 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187618 */     // GIR_Coverage, 18678,
     /* 2187618 */     GIR_EraseRootFromParent_Done,
     /* 2187619 */   // Label 28808: @2187619
     /* 2187619 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2187710), // Rule ID 18679 //
     /* 2187624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187670 */     // MIs[0] round
     /* 2187670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187673 */     // MIs[0] policy
     /* 2187673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187683 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187709 */     // GIR_Coverage, 18679,
     /* 2187709 */     GIR_EraseRootFromParent_Done,
     /* 2187710 */   // Label 28809: @2187710
     /* 2187710 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2187801), // Rule ID 18682 //
     /* 2187715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187761 */     // MIs[0] round
     /* 2187761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187764 */     // MIs[0] policy
     /* 2187764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187774 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187800 */     // GIR_Coverage, 18682,
     /* 2187800 */     GIR_EraseRootFromParent_Done,
     /* 2187801 */   // Label 28810: @2187801
     /* 2187801 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2187892), // Rule ID 18683 //
     /* 2187806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187852 */     // MIs[0] round
     /* 2187852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187855 */     // MIs[0] policy
     /* 2187855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187865 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187891 */     // GIR_Coverage, 18683,
     /* 2187891 */     GIR_EraseRootFromParent_Done,
     /* 2187892 */   // Label 28811: @2187892
     /* 2187892 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2187983), // Rule ID 18686 //
     /* 2187897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187943 */     // MIs[0] round
     /* 2187943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187946 */     // MIs[0] policy
     /* 2187946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187956 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187982 */     // GIR_Coverage, 18686,
     /* 2187982 */     GIR_EraseRootFromParent_Done,
     /* 2187983 */   // Label 28812: @2187983
     /* 2187983 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2188074), // Rule ID 18687 //
     /* 2187988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2188002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188034 */     // MIs[0] round
     /* 2188034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188037 */     // MIs[0] policy
     /* 2188037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188047 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2188050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188073 */     // GIR_Coverage, 18687,
     /* 2188073 */     GIR_EraseRootFromParent_Done,
     /* 2188074 */   // Label 28813: @2188074
     /* 2188074 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2188165), // Rule ID 18690 //
     /* 2188079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2188082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188125 */     // MIs[0] round
     /* 2188125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188128 */     // MIs[0] policy
     /* 2188128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188138 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2188141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188164 */     // GIR_Coverage, 18690,
     /* 2188164 */     GIR_EraseRootFromParent_Done,
     /* 2188165 */   // Label 28814: @2188165
     /* 2188165 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2188256), // Rule ID 18691 //
     /* 2188170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2188173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2188181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2188184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2188187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2188190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2188193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2188208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188216 */     // MIs[0] round
     /* 2188216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188219 */     // MIs[0] policy
     /* 2188219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188229 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2188232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188255 */     // GIR_Coverage, 18691,
     /* 2188255 */     GIR_EraseRootFromParent_Done,
     /* 2188256 */   // Label 28815: @2188256
     /* 2188256 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2188347), // Rule ID 18694 //
     /* 2188261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188307 */     // MIs[0] round
     /* 2188307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188310 */     // MIs[0] policy
     /* 2188310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188320 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2188323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188346 */     // GIR_Coverage, 18694,
     /* 2188346 */     GIR_EraseRootFromParent_Done,
     /* 2188347 */   // Label 28816: @2188347
     /* 2188347 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2188438), // Rule ID 18695 //
     /* 2188352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188398 */     // MIs[0] round
     /* 2188398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188401 */     // MIs[0] policy
     /* 2188401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2188414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188437 */     // GIR_Coverage, 18695,
     /* 2188437 */     GIR_EraseRootFromParent_Done,
     /* 2188438 */   // Label 28817: @2188438
     /* 2188438 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2188529), // Rule ID 18698 //
     /* 2188443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188489 */     // MIs[0] round
     /* 2188489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188492 */     // MIs[0] policy
     /* 2188492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188502 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188528 */     // GIR_Coverage, 18698,
     /* 2188528 */     GIR_EraseRootFromParent_Done,
     /* 2188529 */   // Label 28818: @2188529
     /* 2188529 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2188620), // Rule ID 18699 //
     /* 2188534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188580 */     // MIs[0] round
     /* 2188580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188583 */     // MIs[0] policy
     /* 2188583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188593 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188619 */     // GIR_Coverage, 18699,
     /* 2188619 */     GIR_EraseRootFromParent_Done,
     /* 2188620 */   // Label 28819: @2188620
     /* 2188620 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2188711), // Rule ID 18702 //
     /* 2188625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188671 */     // MIs[0] round
     /* 2188671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188674 */     // MIs[0] policy
     /* 2188674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188684 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188710 */     // GIR_Coverage, 18702,
     /* 2188710 */     GIR_EraseRootFromParent_Done,
     /* 2188711 */   // Label 28820: @2188711
     /* 2188711 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2188802), // Rule ID 18703 //
     /* 2188716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188762 */     // MIs[0] round
     /* 2188762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188765 */     // MIs[0] policy
     /* 2188765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188775 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188801 */     // GIR_Coverage, 18703,
     /* 2188801 */     GIR_EraseRootFromParent_Done,
     /* 2188802 */   // Label 28821: @2188802
     /* 2188802 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2188893), // Rule ID 18706 //
     /* 2188807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188853 */     // MIs[0] round
     /* 2188853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188856 */     // MIs[0] policy
     /* 2188856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188866 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188892 */     // GIR_Coverage, 18706,
     /* 2188892 */     GIR_EraseRootFromParent_Done,
     /* 2188893 */   // Label 28822: @2188893
     /* 2188893 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2188984), // Rule ID 18707 //
     /* 2188898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188944 */     // MIs[0] round
     /* 2188944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188947 */     // MIs[0] policy
     /* 2188947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188957 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188983 */     // GIR_Coverage, 18707,
     /* 2188983 */     GIR_EraseRootFromParent_Done,
     /* 2188984 */   // Label 28823: @2188984
     /* 2188984 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2189075), // Rule ID 18710 //
     /* 2188989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189035 */     // MIs[0] round
     /* 2189035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189038 */     // MIs[0] policy
     /* 2189038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2189051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189074 */     // GIR_Coverage, 18710,
     /* 2189074 */     GIR_EraseRootFromParent_Done,
     /* 2189075 */   // Label 28824: @2189075
     /* 2189075 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2189166), // Rule ID 18711 //
     /* 2189080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2189100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189126 */     // MIs[0] round
     /* 2189126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189129 */     // MIs[0] policy
     /* 2189129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189139 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2189142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189165 */     // GIR_Coverage, 18711,
     /* 2189165 */     GIR_EraseRootFromParent_Done,
     /* 2189166 */   // Label 28825: @2189166
     /* 2189166 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2189257), // Rule ID 18714 //
     /* 2189171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2189174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189217 */     // MIs[0] round
     /* 2189217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189220 */     // MIs[0] policy
     /* 2189220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189230 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2189233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189256 */     // GIR_Coverage, 18714,
     /* 2189256 */     GIR_EraseRootFromParent_Done,
     /* 2189257 */   // Label 28826: @2189257
     /* 2189257 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2189348), // Rule ID 18715 //
     /* 2189262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2189265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2189270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2189279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2189282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2189300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189308 */     // MIs[0] round
     /* 2189308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189311 */     // MIs[0] policy
     /* 2189311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189321 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2189324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2189344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189347 */     // GIR_Coverage, 18715,
     /* 2189347 */     GIR_EraseRootFromParent_Done,
     /* 2189348 */   // Label 28827: @2189348
     /* 2189348 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2189439), // Rule ID 18718 //
     /* 2189353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2189370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189399 */     // MIs[0] round
     /* 2189399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189402 */     // MIs[0] policy
     /* 2189402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189412 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189438 */     // GIR_Coverage, 18718,
     /* 2189438 */     GIR_EraseRootFromParent_Done,
     /* 2189439 */   // Label 28828: @2189439
     /* 2189439 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2189530), // Rule ID 18719 //
     /* 2189444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2189461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189490 */     // MIs[0] round
     /* 2189490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189493 */     // MIs[0] policy
     /* 2189493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189503 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189529 */     // GIR_Coverage, 18719,
     /* 2189529 */     GIR_EraseRootFromParent_Done,
     /* 2189530 */   // Label 28829: @2189530
     /* 2189530 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2189621), // Rule ID 18722 //
     /* 2189535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189581 */     // MIs[0] round
     /* 2189581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189584 */     // MIs[0] policy
     /* 2189584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189594 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189620 */     // GIR_Coverage, 18722,
     /* 2189620 */     GIR_EraseRootFromParent_Done,
     /* 2189621 */   // Label 28830: @2189621
     /* 2189621 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2189712), // Rule ID 18723 //
     /* 2189626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189672 */     // MIs[0] round
     /* 2189672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189675 */     // MIs[0] policy
     /* 2189675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189685 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189711 */     // GIR_Coverage, 18723,
     /* 2189711 */     GIR_EraseRootFromParent_Done,
     /* 2189712 */   // Label 28831: @2189712
     /* 2189712 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2189803), // Rule ID 18726 //
     /* 2189717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189763 */     // MIs[0] round
     /* 2189763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189766 */     // MIs[0] policy
     /* 2189766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189802 */     // GIR_Coverage, 18726,
     /* 2189802 */     GIR_EraseRootFromParent_Done,
     /* 2189803 */   // Label 28832: @2189803
     /* 2189803 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2189894), // Rule ID 18727 //
     /* 2189808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189854 */     // MIs[0] round
     /* 2189854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189857 */     // MIs[0] policy
     /* 2189857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189867 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189893 */     // GIR_Coverage, 18727,
     /* 2189893 */     GIR_EraseRootFromParent_Done,
     /* 2189894 */   // Label 28833: @2189894
     /* 2189894 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2189985), // Rule ID 18730 //
     /* 2189899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189945 */     // MIs[0] round
     /* 2189945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189948 */     // MIs[0] policy
     /* 2189948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189958 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189984 */     // GIR_Coverage, 18730,
     /* 2189984 */     GIR_EraseRootFromParent_Done,
     /* 2189985 */   // Label 28834: @2189985
     /* 2189985 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2190076), // Rule ID 18731 //
     /* 2189990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2190001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2190004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2190007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2190010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190036 */     // MIs[0] round
     /* 2190036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190039 */     // MIs[0] policy
     /* 2190039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190049 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2190052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190075 */     // GIR_Coverage, 18731,
     /* 2190075 */     GIR_EraseRootFromParent_Done,
     /* 2190076 */   // Label 28835: @2190076
     /* 2190076 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2190167), // Rule ID 18734 //
     /* 2190081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2190092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2190095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2190098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2190101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2190104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190127 */     // MIs[0] round
     /* 2190127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190130 */     // MIs[0] policy
     /* 2190130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2190143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190166 */     // GIR_Coverage, 18734,
     /* 2190166 */     GIR_EraseRootFromParent_Done,
     /* 2190167 */   // Label 28836: @2190167
     /* 2190167 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2190258), // Rule ID 18735 //
     /* 2190172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2190183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2190186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2190189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2190192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2190195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190218 */     // MIs[0] round
     /* 2190218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190221 */     // MIs[0] policy
     /* 2190221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190231 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2190234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190257 */     // GIR_Coverage, 18735,
     /* 2190257 */     GIR_EraseRootFromParent_Done,
     /* 2190258 */   // Label 28837: @2190258
     /* 2190258 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2190349), // Rule ID 18738 //
     /* 2190263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190309 */     // MIs[0] round
     /* 2190309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190312 */     // MIs[0] policy
     /* 2190312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2190325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190348 */     // GIR_Coverage, 18738,
     /* 2190348 */     GIR_EraseRootFromParent_Done,
     /* 2190349 */   // Label 28838: @2190349
     /* 2190349 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2190440), // Rule ID 18739 //
     /* 2190354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190400 */     // MIs[0] round
     /* 2190400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190403 */     // MIs[0] policy
     /* 2190403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190413 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2190416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190439 */     // GIR_Coverage, 18739,
     /* 2190439 */     GIR_EraseRootFromParent_Done,
     /* 2190440 */   // Label 28839: @2190440
     /* 2190440 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2190531), // Rule ID 18742 //
     /* 2190445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190491 */     // MIs[0] round
     /* 2190491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190494 */     // MIs[0] policy
     /* 2190494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190530 */     // GIR_Coverage, 18742,
     /* 2190530 */     GIR_EraseRootFromParent_Done,
     /* 2190531 */   // Label 28840: @2190531
     /* 2190531 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2190622), // Rule ID 18743 //
     /* 2190536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190582 */     // MIs[0] round
     /* 2190582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190585 */     // MIs[0] policy
     /* 2190585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190595 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190621 */     // GIR_Coverage, 18743,
     /* 2190621 */     GIR_EraseRootFromParent_Done,
     /* 2190622 */   // Label 28841: @2190622
     /* 2190622 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2190713), // Rule ID 18746 //
     /* 2190627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190673 */     // MIs[0] round
     /* 2190673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190676 */     // MIs[0] policy
     /* 2190676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190686 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190712 */     // GIR_Coverage, 18746,
     /* 2190712 */     GIR_EraseRootFromParent_Done,
     /* 2190713 */   // Label 28842: @2190713
     /* 2190713 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2190804), // Rule ID 18747 //
     /* 2190718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190764 */     // MIs[0] round
     /* 2190764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190767 */     // MIs[0] policy
     /* 2190767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190777 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190803 */     // GIR_Coverage, 18747,
     /* 2190803 */     GIR_EraseRootFromParent_Done,
     /* 2190804 */   // Label 28843: @2190804
     /* 2190804 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2190895), // Rule ID 18750 //
     /* 2190809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190855 */     // MIs[0] round
     /* 2190855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190858 */     // MIs[0] policy
     /* 2190858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190868 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190894 */     // GIR_Coverage, 18750,
     /* 2190894 */     GIR_EraseRootFromParent_Done,
     /* 2190895 */   // Label 28844: @2190895
     /* 2190895 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2190986), // Rule ID 18751 //
     /* 2190900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190946 */     // MIs[0] round
     /* 2190946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190949 */     // MIs[0] policy
     /* 2190949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190959 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190985 */     // GIR_Coverage, 18751,
     /* 2190985 */     GIR_EraseRootFromParent_Done,
     /* 2190986 */   // Label 28845: @2190986
     /* 2190986 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2191077), // Rule ID 18754 //
     /* 2190991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191037 */     // MIs[0] round
     /* 2191037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191040 */     // MIs[0] policy
     /* 2191040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2191053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191076 */     // GIR_Coverage, 18754,
     /* 2191076 */     GIR_EraseRootFromParent_Done,
     /* 2191077 */   // Label 28846: @2191077
     /* 2191077 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2191168), // Rule ID 18755 //
     /* 2191082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191128 */     // MIs[0] round
     /* 2191128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191131 */     // MIs[0] policy
     /* 2191131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191141 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2191144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191167 */     // GIR_Coverage, 18755,
     /* 2191167 */     GIR_EraseRootFromParent_Done,
     /* 2191168 */   // Label 28847: @2191168
     /* 2191168 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2191259), // Rule ID 18758 //
     /* 2191173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2191184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2191187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2191193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191219 */     // MIs[0] round
     /* 2191219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191222 */     // MIs[0] policy
     /* 2191222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191232 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2191235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191258 */     // GIR_Coverage, 18758,
     /* 2191258 */     GIR_EraseRootFromParent_Done,
     /* 2191259 */   // Label 28848: @2191259
     /* 2191259 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2191350), // Rule ID 18759 //
     /* 2191264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2191275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2191278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2191284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191310 */     // MIs[0] round
     /* 2191310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191313 */     // MIs[0] policy
     /* 2191313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191323 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2191326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191349 */     // GIR_Coverage, 18759,
     /* 2191349 */     GIR_EraseRootFromParent_Done,
     /* 2191350 */   // Label 28849: @2191350
     /* 2191350 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2191441), // Rule ID 18762 //
     /* 2191355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191401 */     // MIs[0] round
     /* 2191401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191404 */     // MIs[0] policy
     /* 2191404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191440 */     // GIR_Coverage, 18762,
     /* 2191440 */     GIR_EraseRootFromParent_Done,
     /* 2191441 */   // Label 28850: @2191441
     /* 2191441 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2191532), // Rule ID 18763 //
     /* 2191446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2191457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2191460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191492 */     // MIs[0] round
     /* 2191492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191495 */     // MIs[0] policy
     /* 2191495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191505 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191531 */     // GIR_Coverage, 18763,
     /* 2191531 */     GIR_EraseRootFromParent_Done,
     /* 2191532 */   // Label 28851: @2191532
     /* 2191532 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2191623), // Rule ID 18766 //
     /* 2191537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191583 */     // MIs[0] round
     /* 2191583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191586 */     // MIs[0] policy
     /* 2191586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191596 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191622 */     // GIR_Coverage, 18766,
     /* 2191622 */     GIR_EraseRootFromParent_Done,
     /* 2191623 */   // Label 28852: @2191623
     /* 2191623 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2191714), // Rule ID 18767 //
     /* 2191628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191674 */     // MIs[0] round
     /* 2191674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191677 */     // MIs[0] policy
     /* 2191677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191687 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191713 */     // GIR_Coverage, 18767,
     /* 2191713 */     GIR_EraseRootFromParent_Done,
     /* 2191714 */   // Label 28853: @2191714
     /* 2191714 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2191805), // Rule ID 18770 //
     /* 2191719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191765 */     // MIs[0] round
     /* 2191765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191768 */     // MIs[0] policy
     /* 2191768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191778 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191804 */     // GIR_Coverage, 18770,
     /* 2191804 */     GIR_EraseRootFromParent_Done,
     /* 2191805 */   // Label 28854: @2191805
     /* 2191805 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2191896), // Rule ID 18771 //
     /* 2191810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191856 */     // MIs[0] round
     /* 2191856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191859 */     // MIs[0] policy
     /* 2191859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191869 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191895 */     // GIR_Coverage, 18771,
     /* 2191895 */     GIR_EraseRootFromParent_Done,
     /* 2191896 */   // Label 28855: @2191896
     /* 2191896 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2191987), // Rule ID 18774 //
     /* 2191901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191947 */     // MIs[0] round
     /* 2191947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191950 */     // MIs[0] policy
     /* 2191950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191986 */     // GIR_Coverage, 18774,
     /* 2191986 */     GIR_EraseRootFromParent_Done,
     /* 2191987 */   // Label 28856: @2191987
     /* 2191987 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2192078), // Rule ID 18775 //
     /* 2191992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2192003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2192006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2192012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192038 */     // MIs[0] round
     /* 2192038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192041 */     // MIs[0] policy
     /* 2192041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192051 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2192054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192077 */     // GIR_Coverage, 18775,
     /* 2192077 */     GIR_EraseRootFromParent_Done,
     /* 2192078 */   // Label 28857: @2192078
     /* 2192078 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2192169), // Rule ID 18778 //
     /* 2192083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2192103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192129 */     // MIs[0] round
     /* 2192129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192132 */     // MIs[0] policy
     /* 2192132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2192145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192168 */     // GIR_Coverage, 18778,
     /* 2192168 */     GIR_EraseRootFromParent_Done,
     /* 2192169 */   // Label 28858: @2192169
     /* 2192169 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2192260), // Rule ID 18779 //
     /* 2192174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2192194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192220 */     // MIs[0] round
     /* 2192220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192223 */     // MIs[0] policy
     /* 2192223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192233 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2192236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192259 */     // GIR_Coverage, 18779,
     /* 2192259 */     GIR_EraseRootFromParent_Done,
     /* 2192260 */   // Label 28859: @2192260
     /* 2192260 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2192351), // Rule ID 18782 //
     /* 2192265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2192285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192311 */     // MIs[0] round
     /* 2192311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192314 */     // MIs[0] policy
     /* 2192314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2192327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192350 */     // GIR_Coverage, 18782,
     /* 2192350 */     GIR_EraseRootFromParent_Done,
     /* 2192351 */   // Label 28860: @2192351
     /* 2192351 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2192442), // Rule ID 18783 //
     /* 2192356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2192367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2192370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2192376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192402 */     // MIs[0] round
     /* 2192402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192405 */     // MIs[0] policy
     /* 2192405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192415 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2192418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192441 */     // GIR_Coverage, 18783,
     /* 2192441 */     GIR_EraseRootFromParent_Done,
     /* 2192442 */   // Label 28861: @2192442
     /* 2192442 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2192533), // Rule ID 18786 //
     /* 2192447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192493 */     // MIs[0] round
     /* 2192493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192496 */     // MIs[0] policy
     /* 2192496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192532 */     // GIR_Coverage, 18786,
     /* 2192532 */     GIR_EraseRootFromParent_Done,
     /* 2192533 */   // Label 28862: @2192533
     /* 2192533 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2192624), // Rule ID 18787 //
     /* 2192538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192584 */     // MIs[0] round
     /* 2192584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192587 */     // MIs[0] policy
     /* 2192587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192597 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192623 */     // GIR_Coverage, 18787,
     /* 2192623 */     GIR_EraseRootFromParent_Done,
     /* 2192624 */   // Label 28863: @2192624
     /* 2192624 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2192715), // Rule ID 18790 //
     /* 2192629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192675 */     // MIs[0] round
     /* 2192675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192678 */     // MIs[0] policy
     /* 2192678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192688 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192714 */     // GIR_Coverage, 18790,
     /* 2192714 */     GIR_EraseRootFromParent_Done,
     /* 2192715 */   // Label 28864: @2192715
     /* 2192715 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2192806), // Rule ID 18791 //
     /* 2192720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192766 */     // MIs[0] round
     /* 2192766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192769 */     // MIs[0] policy
     /* 2192769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192779 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192805 */     // GIR_Coverage, 18791,
     /* 2192805 */     GIR_EraseRootFromParent_Done,
     /* 2192806 */   // Label 28865: @2192806
     /* 2192806 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2192897), // Rule ID 18794 //
     /* 2192811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192857 */     // MIs[0] round
     /* 2192857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192860 */     // MIs[0] policy
     /* 2192860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192896 */     // GIR_Coverage, 18794,
     /* 2192896 */     GIR_EraseRootFromParent_Done,
     /* 2192897 */   // Label 28866: @2192897
     /* 2192897 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2192988), // Rule ID 18795 //
     /* 2192902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192948 */     // MIs[0] round
     /* 2192948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192951 */     // MIs[0] policy
     /* 2192951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192961 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192987 */     // GIR_Coverage, 18795,
     /* 2192987 */     GIR_EraseRootFromParent_Done,
     /* 2192988 */   // Label 28867: @2192988
     /* 2192988 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2193079), // Rule ID 18798 //
     /* 2192993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193039 */     // MIs[0] round
     /* 2193039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193042 */     // MIs[0] policy
     /* 2193042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193052 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2193055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193078 */     // GIR_Coverage, 18798,
     /* 2193078 */     GIR_EraseRootFromParent_Done,
     /* 2193079 */   // Label 28868: @2193079
     /* 2193079 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2193170), // Rule ID 18799 //
     /* 2193084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2193101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193130 */     // MIs[0] round
     /* 2193130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193133 */     // MIs[0] policy
     /* 2193133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193143 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2193146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193169 */     // GIR_Coverage, 18799,
     /* 2193169 */     GIR_EraseRootFromParent_Done,
     /* 2193170 */   // Label 28869: @2193170
     /* 2193170 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2193261), // Rule ID 18802 //
     /* 2193175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193221 */     // MIs[0] round
     /* 2193221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193224 */     // MIs[0] policy
     /* 2193224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2193237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193260 */     // GIR_Coverage, 18802,
     /* 2193260 */     GIR_EraseRootFromParent_Done,
     /* 2193261 */   // Label 28870: @2193261
     /* 2193261 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2193352), // Rule ID 18803 //
     /* 2193266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2193277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2193280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2193283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2193286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193312 */     // MIs[0] round
     /* 2193312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193315 */     // MIs[0] policy
     /* 2193315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193325 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2193328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193351 */     // GIR_Coverage, 18803,
     /* 2193351 */     GIR_EraseRootFromParent_Done,
     /* 2193352 */   // Label 28871: @2193352
     /* 2193352 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2193443), // Rule ID 18806 //
     /* 2193357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193403 */     // MIs[0] round
     /* 2193403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193406 */     // MIs[0] policy
     /* 2193406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193416 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193442 */     // GIR_Coverage, 18806,
     /* 2193442 */     GIR_EraseRootFromParent_Done,
     /* 2193443 */   // Label 28872: @2193443
     /* 2193443 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2193534), // Rule ID 18807 //
     /* 2193448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2193459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2193462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2193465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193494 */     // MIs[0] round
     /* 2193494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193497 */     // MIs[0] policy
     /* 2193497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193533 */     // GIR_Coverage, 18807,
     /* 2193533 */     GIR_EraseRootFromParent_Done,
     /* 2193534 */   // Label 28873: @2193534
     /* 2193534 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2193625), // Rule ID 18810 //
     /* 2193539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193585 */     // MIs[0] round
     /* 2193585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193588 */     // MIs[0] policy
     /* 2193588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193624 */     // GIR_Coverage, 18810,
     /* 2193624 */     GIR_EraseRootFromParent_Done,
     /* 2193625 */   // Label 28874: @2193625
     /* 2193625 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2193716), // Rule ID 18811 //
     /* 2193630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193676 */     // MIs[0] round
     /* 2193676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193679 */     // MIs[0] policy
     /* 2193679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193689 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193715 */     // GIR_Coverage, 18811,
     /* 2193715 */     GIR_EraseRootFromParent_Done,
     /* 2193716 */   // Label 28875: @2193716
     /* 2193716 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2193807), // Rule ID 18814 //
     /* 2193721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193767 */     // MIs[0] round
     /* 2193767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193770 */     // MIs[0] policy
     /* 2193770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193780 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193806 */     // GIR_Coverage, 18814,
     /* 2193806 */     GIR_EraseRootFromParent_Done,
     /* 2193807 */   // Label 28876: @2193807
     /* 2193807 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2193898), // Rule ID 18815 //
     /* 2193812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193858 */     // MIs[0] round
     /* 2193858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193861 */     // MIs[0] policy
     /* 2193861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193871 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193897 */     // GIR_Coverage, 18815,
     /* 2193897 */     GIR_EraseRootFromParent_Done,
     /* 2193898 */   // Label 28877: @2193898
     /* 2193898 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2193989), // Rule ID 18818 //
     /* 2193903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193949 */     // MIs[0] round
     /* 2193949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193952 */     // MIs[0] policy
     /* 2193952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193962 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193988 */     // GIR_Coverage, 18818,
     /* 2193988 */     GIR_EraseRootFromParent_Done,
     /* 2193989 */   // Label 28878: @2193989
     /* 2193989 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2194080), // Rule ID 18819 //
     /* 2193994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2194011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194040 */     // MIs[0] round
     /* 2194040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194043 */     // MIs[0] policy
     /* 2194043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194053 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2194056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194079 */     // GIR_Coverage, 18819,
     /* 2194079 */     GIR_EraseRootFromParent_Done,
     /* 2194080 */   // Label 28879: @2194080
     /* 2194080 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2194171), // Rule ID 18822 //
     /* 2194085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194131 */     // MIs[0] round
     /* 2194131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194134 */     // MIs[0] policy
     /* 2194134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194144 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2194147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194170 */     // GIR_Coverage, 18822,
     /* 2194170 */     GIR_EraseRootFromParent_Done,
     /* 2194171 */   // Label 28880: @2194171
     /* 2194171 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2194262), // Rule ID 18823 //
     /* 2194176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2194193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194222 */     // MIs[0] round
     /* 2194222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194225 */     // MIs[0] policy
     /* 2194225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194235 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2194238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194261 */     // GIR_Coverage, 18823,
     /* 2194261 */     GIR_EraseRootFromParent_Done,
     /* 2194262 */   // Label 28881: @2194262
     /* 2194262 */   GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2194353), // Rule ID 18826 //
     /* 2194267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194313 */     // MIs[0] round
     /* 2194313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194316 */     // MIs[0] policy
     /* 2194316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2194329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194352 */     // GIR_Coverage, 18826,
     /* 2194352 */     GIR_EraseRootFromParent_Done,
     /* 2194353 */   // Label 28882: @2194353
     /* 2194353 */   GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2194444), // Rule ID 18827 //
     /* 2194358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2194369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2194372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2194378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194404 */     // MIs[0] round
     /* 2194404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194407 */     // MIs[0] policy
     /* 2194407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194417 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2194420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194443 */     // GIR_Coverage, 18827,
     /* 2194443 */     GIR_EraseRootFromParent_Done,
     /* 2194444 */   // Label 28883: @2194444
     /* 2194444 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2194535), // Rule ID 18830 //
     /* 2194449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194495 */     // MIs[0] round
     /* 2194495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194498 */     // MIs[0] policy
     /* 2194498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194508 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194534 */     // GIR_Coverage, 18830,
     /* 2194534 */     GIR_EraseRootFromParent_Done,
     /* 2194535 */   // Label 28884: @2194535
     /* 2194535 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2194626), // Rule ID 18831 //
     /* 2194540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194586 */     // MIs[0] round
     /* 2194586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194589 */     // MIs[0] policy
     /* 2194589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194599 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194625 */     // GIR_Coverage, 18831,
     /* 2194625 */     GIR_EraseRootFromParent_Done,
     /* 2194626 */   // Label 28885: @2194626
     /* 2194626 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2194717), // Rule ID 18834 //
     /* 2194631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194677 */     // MIs[0] round
     /* 2194677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194680 */     // MIs[0] policy
     /* 2194680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194716 */     // GIR_Coverage, 18834,
     /* 2194716 */     GIR_EraseRootFromParent_Done,
     /* 2194717 */   // Label 28886: @2194717
     /* 2194717 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2194808), // Rule ID 18835 //
     /* 2194722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194768 */     // MIs[0] round
     /* 2194768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194771 */     // MIs[0] policy
     /* 2194771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194781 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194807 */     // GIR_Coverage, 18835,
     /* 2194807 */     GIR_EraseRootFromParent_Done,
     /* 2194808 */   // Label 28887: @2194808
     /* 2194808 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2194899), // Rule ID 18838 //
     /* 2194813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194859 */     // MIs[0] round
     /* 2194859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194862 */     // MIs[0] policy
     /* 2194862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194872 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194898 */     // GIR_Coverage, 18838,
     /* 2194898 */     GIR_EraseRootFromParent_Done,
     /* 2194899 */   // Label 28888: @2194899
     /* 2194899 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2194990), // Rule ID 18839 //
     /* 2194904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194950 */     // MIs[0] round
     /* 2194950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194953 */     // MIs[0] policy
     /* 2194953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194963 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194989 */     // GIR_Coverage, 18839,
     /* 2194989 */     GIR_EraseRootFromParent_Done,
     /* 2194990 */   // Label 28889: @2194990
     /* 2194990 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2195081), // Rule ID 18842 //
     /* 2194995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195041 */     // MIs[0] round
     /* 2195041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195044 */     // MIs[0] policy
     /* 2195044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195054 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2195057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195080 */     // GIR_Coverage, 18842,
     /* 2195080 */     GIR_EraseRootFromParent_Done,
     /* 2195081 */   // Label 28890: @2195081
     /* 2195081 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2195172), // Rule ID 18843 //
     /* 2195086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2195097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2195100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2195103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2195106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2195124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195132 */     // MIs[0] round
     /* 2195132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195135 */     // MIs[0] policy
     /* 2195135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195145 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2195148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195171 */     // GIR_Coverage, 18843,
     /* 2195171 */     GIR_EraseRootFromParent_Done,
     /* 2195172 */   // Label 28891: @2195172
     /* 2195172 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2195263), // Rule ID 18846 //
     /* 2195177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195223 */     // MIs[0] round
     /* 2195223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195226 */     // MIs[0] policy
     /* 2195226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2195239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195262 */     // GIR_Coverage, 18846,
     /* 2195262 */     GIR_EraseRootFromParent_Done,
     /* 2195263 */   // Label 28892: @2195263
     /* 2195263 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2195354), // Rule ID 18847 //
     /* 2195268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2195279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2195282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2195288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195314 */     // MIs[0] round
     /* 2195314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195317 */     // MIs[0] policy
     /* 2195317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195327 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2195330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195353 */     // GIR_Coverage, 18847,
     /* 2195353 */     GIR_EraseRootFromParent_Done,
     /* 2195354 */   // Label 28893: @2195354
     /* 2195354 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2195445), // Rule ID 18850 //
     /* 2195359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195405 */     // MIs[0] round
     /* 2195405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195408 */     // MIs[0] policy
     /* 2195408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195418 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195444 */     // GIR_Coverage, 18850,
     /* 2195444 */     GIR_EraseRootFromParent_Done,
     /* 2195445 */   // Label 28894: @2195445
     /* 2195445 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2195536), // Rule ID 18851 //
     /* 2195450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2195461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2195464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195496 */     // MIs[0] round
     /* 2195496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195499 */     // MIs[0] policy
     /* 2195499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195509 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195535 */     // GIR_Coverage, 18851,
     /* 2195535 */     GIR_EraseRootFromParent_Done,
     /* 2195536 */   // Label 28895: @2195536
     /* 2195536 */   GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2195627), // Rule ID 18854 //
     /* 2195541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195587 */     // MIs[0] round
     /* 2195587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195590 */     // MIs[0] policy
     /* 2195590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195600 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195626 */     // GIR_Coverage, 18854,
     /* 2195626 */     GIR_EraseRootFromParent_Done,
     /* 2195627 */   // Label 28896: @2195627
     /* 2195627 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2195718), // Rule ID 18855 //
     /* 2195632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195678 */     // MIs[0] round
     /* 2195678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195681 */     // MIs[0] policy
     /* 2195681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195691 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195717 */     // GIR_Coverage, 18855,
     /* 2195717 */     GIR_EraseRootFromParent_Done,
     /* 2195718 */   // Label 28897: @2195718
     /* 2195718 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2195809), // Rule ID 18858 //
     /* 2195723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195769 */     // MIs[0] round
     /* 2195769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195772 */     // MIs[0] policy
     /* 2195772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195782 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195808 */     // GIR_Coverage, 18858,
     /* 2195808 */     GIR_EraseRootFromParent_Done,
     /* 2195809 */   // Label 28898: @2195809
     /* 2195809 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2195900), // Rule ID 18859 //
     /* 2195814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195860 */     // MIs[0] round
     /* 2195860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195863 */     // MIs[0] policy
     /* 2195863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195873 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195899 */     // GIR_Coverage, 18859,
     /* 2195899 */     GIR_EraseRootFromParent_Done,
     /* 2195900 */   // Label 28899: @2195900
     /* 2195900 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2195991), // Rule ID 18862 //
     /* 2195905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195951 */     // MIs[0] round
     /* 2195951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195954 */     // MIs[0] policy
     /* 2195954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195990 */     // GIR_Coverage, 18862,
     /* 2195990 */     GIR_EraseRootFromParent_Done,
     /* 2195991 */   // Label 28900: @2195991
     /* 2195991 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2196082), // Rule ID 18863 //
     /* 2195996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2196007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2196010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2196013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2196016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196042 */     // MIs[0] round
     /* 2196042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196045 */     // MIs[0] policy
     /* 2196045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196055 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2196058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196081 */     // GIR_Coverage, 18863,
     /* 2196081 */     GIR_EraseRootFromParent_Done,
     /* 2196082 */   // Label 28901: @2196082
     /* 2196082 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2196173), // Rule ID 18866 //
     /* 2196087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196133 */     // MIs[0] round
     /* 2196133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196136 */     // MIs[0] policy
     /* 2196136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196146 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2196149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196172 */     // GIR_Coverage, 18866,
     /* 2196172 */     GIR_EraseRootFromParent_Done,
     /* 2196173 */   // Label 28902: @2196173
     /* 2196173 */   GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2196264), // Rule ID 18867 //
     /* 2196178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2196189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2196192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2196195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2196198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196224 */     // MIs[0] round
     /* 2196224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196227 */     // MIs[0] policy
     /* 2196227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196237 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2196240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196263 */     // GIR_Coverage, 18867,
     /* 2196263 */     GIR_EraseRootFromParent_Done,
     /* 2196264 */   // Label 28903: @2196264
     /* 2196264 */   GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2196355), // Rule ID 18870 //
     /* 2196269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196315 */     // MIs[0] round
     /* 2196315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196318 */     // MIs[0] policy
     /* 2196318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196328 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2196331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196354 */     // GIR_Coverage, 18870,
     /* 2196354 */     GIR_EraseRootFromParent_Done,
     /* 2196355 */   // Label 28904: @2196355
     /* 2196355 */   GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2196446), // Rule ID 18871 //
     /* 2196360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2196371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2196374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2196377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2196380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196406 */     // MIs[0] round
     /* 2196406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196409 */     // MIs[0] policy
     /* 2196409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2196422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196445 */     // GIR_Coverage, 18871,
     /* 2196445 */     GIR_EraseRootFromParent_Done,
     /* 2196446 */   // Label 28905: @2196446
     /* 2196446 */   GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2196537), // Rule ID 18874 //
     /* 2196451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196497 */     // MIs[0] round
     /* 2196497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196500 */     // MIs[0] policy
     /* 2196500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196510 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196536 */     // GIR_Coverage, 18874,
     /* 2196536 */     GIR_EraseRootFromParent_Done,
     /* 2196537 */   // Label 28906: @2196537
     /* 2196537 */   GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2196628), // Rule ID 18875 //
     /* 2196542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196588 */     // MIs[0] round
     /* 2196588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196591 */     // MIs[0] policy
     /* 2196591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196601 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196627 */     // GIR_Coverage, 18875,
     /* 2196627 */     GIR_EraseRootFromParent_Done,
     /* 2196628 */   // Label 28907: @2196628
     /* 2196628 */   GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2196719), // Rule ID 18878 //
     /* 2196633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196679 */     // MIs[0] round
     /* 2196679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196682 */     // MIs[0] policy
     /* 2196682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196718 */     // GIR_Coverage, 18878,
     /* 2196718 */     GIR_EraseRootFromParent_Done,
     /* 2196719 */   // Label 28908: @2196719
     /* 2196719 */   GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2196810), // Rule ID 18879 //
     /* 2196724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196770 */     // MIs[0] round
     /* 2196770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196773 */     // MIs[0] policy
     /* 2196773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196809 */     // GIR_Coverage, 18879,
     /* 2196809 */     GIR_EraseRootFromParent_Done,
     /* 2196810 */   // Label 28909: @2196810
     /* 2196810 */   GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2196901), // Rule ID 18882 //
     /* 2196815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196861 */     // MIs[0] round
     /* 2196861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196864 */     // MIs[0] policy
     /* 2196864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196874 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196900 */     // GIR_Coverage, 18882,
     /* 2196900 */     GIR_EraseRootFromParent_Done,
     /* 2196901 */   // Label 28910: @2196901
     /* 2196901 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2196992), // Rule ID 18883 //
     /* 2196906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196952 */     // MIs[0] round
     /* 2196952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196955 */     // MIs[0] policy
     /* 2196955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196965 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196991 */     // GIR_Coverage, 18883,
     /* 2196991 */     GIR_EraseRootFromParent_Done,
     /* 2196992 */   // Label 28911: @2196992
     /* 2196992 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2197083), // Rule ID 18886 //
     /* 2196997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197043 */     // MIs[0] round
     /* 2197043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197046 */     // MIs[0] policy
     /* 2197046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197056 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2197059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197082 */     // GIR_Coverage, 18886,
     /* 2197082 */     GIR_EraseRootFromParent_Done,
     /* 2197083 */   // Label 28912: @2197083
     /* 2197083 */   GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2197174), // Rule ID 18887 //
     /* 2197088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2197099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2197102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2197105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2197108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197134 */     // MIs[0] round
     /* 2197134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197137 */     // MIs[0] policy
     /* 2197137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197147 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2197150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197173 */     // GIR_Coverage, 18887,
     /* 2197173 */     GIR_EraseRootFromParent_Done,
     /* 2197174 */   // Label 28913: @2197174
     /* 2197174 */   GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2197265), // Rule ID 18890 //
     /* 2197179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197225 */     // MIs[0] round
     /* 2197225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197228 */     // MIs[0] policy
     /* 2197228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197238 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2197241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197264 */     // GIR_Coverage, 18890,
     /* 2197264 */     GIR_EraseRootFromParent_Done,
     /* 2197265 */   // Label 28914: @2197265
     /* 2197265 */   GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2197356), // Rule ID 18891 //
     /* 2197270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2197281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2197284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2197287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2197290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197316 */     // MIs[0] round
     /* 2197316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197319 */     // MIs[0] policy
     /* 2197319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197329 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2197332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197355 */     // GIR_Coverage, 18891,
     /* 2197355 */     GIR_EraseRootFromParent_Done,
     /* 2197356 */   // Label 28915: @2197356
     /* 2197356 */   GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2197447), // Rule ID 18894 //
     /* 2197361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197407 */     // MIs[0] round
     /* 2197407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197410 */     // MIs[0] policy
     /* 2197410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197446 */     // GIR_Coverage, 18894,
     /* 2197446 */     GIR_EraseRootFromParent_Done,
     /* 2197447 */   // Label 28916: @2197447
     /* 2197447 */   GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2197538), // Rule ID 18895 //
     /* 2197452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2197455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2197463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197498 */     // MIs[0] round
     /* 2197498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197501 */     // MIs[0] policy
     /* 2197501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197511 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197537 */     // GIR_Coverage, 18895,
     /* 2197537 */     GIR_EraseRootFromParent_Done,
     /* 2197538 */   // Label 28917: @2197538
     /* 2197538 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2197629), // Rule ID 18898 //
     /* 2197543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197589 */     // MIs[0] round
     /* 2197589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197592 */     // MIs[0] policy
     /* 2197592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197602 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197628 */     // GIR_Coverage, 18898,
     /* 2197628 */     GIR_EraseRootFromParent_Done,
     /* 2197629 */   // Label 28918: @2197629
     /* 2197629 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2197720), // Rule ID 18899 //
     /* 2197634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197680 */     // MIs[0] round
     /* 2197680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197683 */     // MIs[0] policy
     /* 2197683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197693 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197719 */     // GIR_Coverage, 18899,
     /* 2197719 */     GIR_EraseRootFromParent_Done,
     /* 2197720 */   // Label 28919: @2197720
     /* 2197720 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2197811), // Rule ID 18902 //
     /* 2197725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197771 */     // MIs[0] round
     /* 2197771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197774 */     // MIs[0] policy
     /* 2197774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197810 */     // GIR_Coverage, 18902,
     /* 2197810 */     GIR_EraseRootFromParent_Done,
     /* 2197811 */   // Label 28920: @2197811
     /* 2197811 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2197902), // Rule ID 18903 //
     /* 2197816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197862 */     // MIs[0] round
     /* 2197862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197865 */     // MIs[0] policy
     /* 2197865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197875 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197901 */     // GIR_Coverage, 18903,
     /* 2197901 */     GIR_EraseRootFromParent_Done,
     /* 2197902 */   // Label 28921: @2197902
     /* 2197902 */   GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2197993), // Rule ID 18906 //
     /* 2197907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197953 */     // MIs[0] round
     /* 2197953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197956 */     // MIs[0] policy
     /* 2197956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197966 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197992 */     // GIR_Coverage, 18906,
     /* 2197992 */     GIR_EraseRootFromParent_Done,
     /* 2197993 */   // Label 28922: @2197993
     /* 2197993 */   GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2198084), // Rule ID 18907 //
     /* 2197998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2198009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2198012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2198018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198044 */     // MIs[0] round
     /* 2198044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198047 */     // MIs[0] policy
     /* 2198047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198057 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2198060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198083 */     // GIR_Coverage, 18907,
     /* 2198083 */     GIR_EraseRootFromParent_Done,
     /* 2198084 */   // Label 28923: @2198084
     /* 2198084 */   GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2198175), // Rule ID 18910 //
     /* 2198089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198135 */     // MIs[0] round
     /* 2198135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198138 */     // MIs[0] policy
     /* 2198138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2198151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198174 */     // GIR_Coverage, 18910,
     /* 2198174 */     GIR_EraseRootFromParent_Done,
     /* 2198175 */   // Label 28924: @2198175
     /* 2198175 */   GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2198266), // Rule ID 18911 //
     /* 2198180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2198191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2198194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2198200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198226 */     // MIs[0] round
     /* 2198226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198229 */     // MIs[0] policy
     /* 2198229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198239 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2198242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198265 */     // GIR_Coverage, 18911,
     /* 2198265 */     GIR_EraseRootFromParent_Done,
     /* 2198266 */   // Label 28925: @2198266
     /* 2198266 */   GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2198357), // Rule ID 18914 //
     /* 2198271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198317 */     // MIs[0] round
     /* 2198317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198320 */     // MIs[0] policy
     /* 2198320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198330 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2198333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198356 */     // GIR_Coverage, 18914,
     /* 2198356 */     GIR_EraseRootFromParent_Done,
     /* 2198357 */   // Label 28926: @2198357
     /* 2198357 */   GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2198448), // Rule ID 18915 //
     /* 2198362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2198373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2198376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2198379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2198382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2198385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2198400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198408 */     // MIs[0] round
     /* 2198408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198411 */     // MIs[0] policy
     /* 2198411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198421 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2198424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198447 */     // GIR_Coverage, 18915,
     /* 2198447 */     GIR_EraseRootFromParent_Done,
     /* 2198448 */   // Label 28927: @2198448
     /* 2198448 */   GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2198539), // Rule ID 18918 //
     /* 2198453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198499 */     // MIs[0] round
     /* 2198499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198502 */     // MIs[0] policy
     /* 2198502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198512 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198538 */     // GIR_Coverage, 18918,
     /* 2198538 */     GIR_EraseRootFromParent_Done,
     /* 2198539 */   // Label 28928: @2198539
     /* 2198539 */   GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2198630), // Rule ID 18919 //
     /* 2198544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198590 */     // MIs[0] round
     /* 2198590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198593 */     // MIs[0] policy
     /* 2198593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198603 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198629 */     // GIR_Coverage, 18919,
     /* 2198629 */     GIR_EraseRootFromParent_Done,
     /* 2198630 */   // Label 28929: @2198630
     /* 2198630 */   GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2198721), // Rule ID 18922 //
     /* 2198635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198681 */     // MIs[0] round
     /* 2198681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198684 */     // MIs[0] policy
     /* 2198684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198694 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198720 */     // GIR_Coverage, 18922,
     /* 2198720 */     GIR_EraseRootFromParent_Done,
     /* 2198721 */   // Label 28930: @2198721
     /* 2198721 */   GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2198812), // Rule ID 18923 //
     /* 2198726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198772 */     // MIs[0] round
     /* 2198772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198775 */     // MIs[0] policy
     /* 2198775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198785 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11360:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198811 */     // GIR_Coverage, 18923,
     /* 2198811 */     GIR_EraseRootFromParent_Done,
     /* 2198812 */   // Label 28931: @2198812
     /* 2198812 */   GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2198903), // Rule ID 18926 //
     /* 2198817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198863 */     // MIs[0] round
     /* 2198863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198866 */     // MIs[0] policy
     /* 2198866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198902 */     // GIR_Coverage, 18926,
     /* 2198902 */     GIR_EraseRootFromParent_Done,
     /* 2198903 */   // Label 28932: @2198903
     /* 2198903 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2198994), // Rule ID 18927 //
     /* 2198908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198954 */     // MIs[0] round
     /* 2198954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198957 */     // MIs[0] policy
     /* 2198957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198967 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11360:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198993 */     // GIR_Coverage, 18927,
     /* 2198993 */     GIR_EraseRootFromParent_Done,
     /* 2198994 */   // Label 28933: @2198994
     /* 2198994 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2199085), // Rule ID 18930 //
     /* 2198999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199045 */     // MIs[0] round
     /* 2199045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199048 */     // MIs[0] policy
     /* 2199048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199058 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2199061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199084 */     // GIR_Coverage, 18930,
     /* 2199084 */     GIR_EraseRootFromParent_Done,
     /* 2199085 */   // Label 28934: @2199085
     /* 2199085 */   GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2199176), // Rule ID 18931 //
     /* 2199090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2199098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2199101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2199104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2199107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2199110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2199128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199136 */     // MIs[0] round
     /* 2199136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199139 */     // MIs[0] policy
     /* 2199139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199149 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11360:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2199152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199175 */     // GIR_Coverage, 18931,
     /* 2199175 */     GIR_EraseRootFromParent_Done,
     /* 2199176 */   // Label 28935: @2199176
     /* 2199176 */   GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2199267), // Rule ID 18934 //
     /* 2199181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199227 */     // MIs[0] round
     /* 2199227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199230 */     // MIs[0] policy
     /* 2199230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2199243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199266 */     // GIR_Coverage, 18934,
     /* 2199266 */     GIR_EraseRootFromParent_Done,
     /* 2199267 */   // Label 28936: @2199267
     /* 2199267 */   GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2199358), // Rule ID 18935 //
     /* 2199272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2199283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2199286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2199289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2199292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199318 */     // MIs[0] round
     /* 2199318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199321 */     // MIs[0] policy
     /* 2199321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199331 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2199334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199357 */     // GIR_Coverage, 18935,
     /* 2199357 */     GIR_EraseRootFromParent_Done,
     /* 2199358 */   // Label 28937: @2199358
     /* 2199358 */   GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2199449), // Rule ID 18938 //
     /* 2199363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199409 */     // MIs[0] round
     /* 2199409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199412 */     // MIs[0] policy
     /* 2199412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199422 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199448 */     // GIR_Coverage, 18938,
     /* 2199448 */     GIR_EraseRootFromParent_Done,
     /* 2199449 */   // Label 28938: @2199449
     /* 2199449 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2199540), // Rule ID 18939 //
     /* 2199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2199465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199500 */     // MIs[0] round
     /* 2199500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199503 */     // MIs[0] policy
     /* 2199503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199513 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199539 */     // GIR_Coverage, 18939,
     /* 2199539 */     GIR_EraseRootFromParent_Done,
     /* 2199540 */   // Label 28939: @2199540
     /* 2199540 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2199631), // Rule ID 18942 //
     /* 2199545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199591 */     // MIs[0] round
     /* 2199591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199594 */     // MIs[0] policy
     /* 2199594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199630 */     // GIR_Coverage, 18942,
     /* 2199630 */     GIR_EraseRootFromParent_Done,
     /* 2199631 */   // Label 28940: @2199631
     /* 2199631 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2199722), // Rule ID 18943 //
     /* 2199636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199682 */     // MIs[0] round
     /* 2199682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199685 */     // MIs[0] policy
     /* 2199685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199695 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199721 */     // GIR_Coverage, 18943,
     /* 2199721 */     GIR_EraseRootFromParent_Done,
     /* 2199722 */   // Label 28941: @2199722
     /* 2199722 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2199813), // Rule ID 18946 //
     /* 2199727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199773 */     // MIs[0] round
     /* 2199773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199776 */     // MIs[0] policy
     /* 2199776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199786 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199812 */     // GIR_Coverage, 18946,
     /* 2199812 */     GIR_EraseRootFromParent_Done,
     /* 2199813 */   // Label 28942: @2199813
     /* 2199813 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2199904), // Rule ID 18947 //
     /* 2199818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199864 */     // MIs[0] round
     /* 2199864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199867 */     // MIs[0] policy
     /* 2199867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199877 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199903 */     // GIR_Coverage, 18947,
     /* 2199903 */     GIR_EraseRootFromParent_Done,
     /* 2199904 */   // Label 28943: @2199904
     /* 2199904 */   GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2199995), // Rule ID 18950 //
     /* 2199909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199955 */     // MIs[0] round
     /* 2199955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199958 */     // MIs[0] policy
     /* 2199958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199968 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199994 */     // GIR_Coverage, 18950,
     /* 2199994 */     GIR_EraseRootFromParent_Done,
     /* 2199995 */   // Label 28944: @2199995
     /* 2199995 */   GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2200086), // Rule ID 18951 //
     /* 2200000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2200011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2200014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2200017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2200020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2200023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200046 */     // MIs[0] round
     /* 2200046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200049 */     // MIs[0] policy
     /* 2200049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200059 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2200062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200085 */     // GIR_Coverage, 18951,
     /* 2200085 */     GIR_EraseRootFromParent_Done,
     /* 2200086 */   // Label 28945: @2200086
     /* 2200086 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2200177), // Rule ID 18954 //
     /* 2200091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200137 */     // MIs[0] round
     /* 2200137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200140 */     // MIs[0] policy
     /* 2200140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200150 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2200153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200176 */     // GIR_Coverage, 18954,
     /* 2200176 */     GIR_EraseRootFromParent_Done,
     /* 2200177 */   // Label 28946: @2200177
     /* 2200177 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2200268), // Rule ID 18955 //
     /* 2200182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2200193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2200196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2200199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2200202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200228 */     // MIs[0] round
     /* 2200228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200231 */     // MIs[0] policy
     /* 2200231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200241 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2200244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200267 */     // GIR_Coverage, 18955,
     /* 2200267 */     GIR_EraseRootFromParent_Done,
     /* 2200268 */   // Label 28947: @2200268
     /* 2200268 */   GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2200359), // Rule ID 18958 //
     /* 2200273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200319 */     // MIs[0] round
     /* 2200319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200322 */     // MIs[0] policy
     /* 2200322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2200335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200358 */     // GIR_Coverage, 18958,
     /* 2200358 */     GIR_EraseRootFromParent_Done,
     /* 2200359 */   // Label 28948: @2200359
     /* 2200359 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2200450), // Rule ID 18959 //
     /* 2200364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2200375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2200378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2200381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2200384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200410 */     // MIs[0] round
     /* 2200410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200413 */     // MIs[0] policy
     /* 2200413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200423 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2200426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200449 */     // GIR_Coverage, 18959,
     /* 2200449 */     GIR_EraseRootFromParent_Done,
     /* 2200450 */   // Label 28949: @2200450
     /* 2200450 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2200541), // Rule ID 18962 //
     /* 2200455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200501 */     // MIs[0] round
     /* 2200501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200504 */     // MIs[0] policy
     /* 2200504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200514 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200540 */     // GIR_Coverage, 18962,
     /* 2200540 */     GIR_EraseRootFromParent_Done,
     /* 2200541 */   // Label 28950: @2200541
     /* 2200541 */   GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2200632), // Rule ID 18963 //
     /* 2200546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200592 */     // MIs[0] round
     /* 2200592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200595 */     // MIs[0] policy
     /* 2200595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200605 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200631 */     // GIR_Coverage, 18963,
     /* 2200631 */     GIR_EraseRootFromParent_Done,
     /* 2200632 */   // Label 28951: @2200632
     /* 2200632 */   GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2200723), // Rule ID 18966 //
     /* 2200637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200683 */     // MIs[0] round
     /* 2200683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200686 */     // MIs[0] policy
     /* 2200686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200696 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200722 */     // GIR_Coverage, 18966,
     /* 2200722 */     GIR_EraseRootFromParent_Done,
     /* 2200723 */   // Label 28952: @2200723
     /* 2200723 */   GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2200814), // Rule ID 18967 //
     /* 2200728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200774 */     // MIs[0] round
     /* 2200774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200777 */     // MIs[0] policy
     /* 2200777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200787 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200813 */     // GIR_Coverage, 18967,
     /* 2200813 */     GIR_EraseRootFromParent_Done,
     /* 2200814 */   // Label 28953: @2200814
     /* 2200814 */   GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2200905), // Rule ID 18970 //
     /* 2200819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200865 */     // MIs[0] round
     /* 2200865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200868 */     // MIs[0] policy
     /* 2200868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200878 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200904 */     // GIR_Coverage, 18970,
     /* 2200904 */     GIR_EraseRootFromParent_Done,
     /* 2200905 */   // Label 28954: @2200905
     /* 2200905 */   GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2200996), // Rule ID 18971 //
     /* 2200910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200956 */     // MIs[0] round
     /* 2200956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200959 */     // MIs[0] policy
     /* 2200959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200969 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200995 */     // GIR_Coverage, 18971,
     /* 2200995 */     GIR_EraseRootFromParent_Done,
     /* 2200996 */   // Label 28955: @2200996
     /* 2200996 */   GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2201087), // Rule ID 18974 //
     /* 2201001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201047 */     // MIs[0] round
     /* 2201047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201050 */     // MIs[0] policy
     /* 2201050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201060 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2201063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201086 */     // GIR_Coverage, 18974,
     /* 2201086 */     GIR_EraseRootFromParent_Done,
     /* 2201087 */   // Label 28956: @2201087
     /* 2201087 */   GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2201178), // Rule ID 18975 //
     /* 2201092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2201103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2201106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2201112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201138 */     // MIs[0] round
     /* 2201138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201141 */     // MIs[0] policy
     /* 2201141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201151 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2201154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201177 */     // GIR_Coverage, 18975,
     /* 2201177 */     GIR_EraseRootFromParent_Done,
     /* 2201178 */   // Label 28957: @2201178
     /* 2201178 */   GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2201269), // Rule ID 18978 //
     /* 2201183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201229 */     // MIs[0] round
     /* 2201229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201232 */     // MIs[0] policy
     /* 2201232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201242 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2201245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201268 */     // GIR_Coverage, 18978,
     /* 2201268 */     GIR_EraseRootFromParent_Done,
     /* 2201269 */   // Label 28958: @2201269
     /* 2201269 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2201360), // Rule ID 18979 //
     /* 2201274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2201285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2201288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2201294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201320 */     // MIs[0] round
     /* 2201320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201323 */     // MIs[0] policy
     /* 2201323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201333 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2201336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201359 */     // GIR_Coverage, 18979,
     /* 2201359 */     GIR_EraseRootFromParent_Done,
     /* 2201360 */   // Label 28959: @2201360
     /* 2201360 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2201451), // Rule ID 18982 //
     /* 2201365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201411 */     // MIs[0] round
     /* 2201411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201414 */     // MIs[0] policy
     /* 2201414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201424 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201450 */     // GIR_Coverage, 18982,
     /* 2201450 */     GIR_EraseRootFromParent_Done,
     /* 2201451 */   // Label 28960: @2201451
     /* 2201451 */   GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2201542), // Rule ID 18983 //
     /* 2201456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201502 */     // MIs[0] round
     /* 2201502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201505 */     // MIs[0] policy
     /* 2201505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201515 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201541 */     // GIR_Coverage, 18983,
     /* 2201541 */     GIR_EraseRootFromParent_Done,
     /* 2201542 */   // Label 28961: @2201542
     /* 2201542 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2201633), // Rule ID 18986 //
     /* 2201547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201593 */     // MIs[0] round
     /* 2201593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201596 */     // MIs[0] policy
     /* 2201596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201606 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201632 */     // GIR_Coverage, 18986,
     /* 2201632 */     GIR_EraseRootFromParent_Done,
     /* 2201633 */   // Label 28962: @2201633
     /* 2201633 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2201724), // Rule ID 18987 //
     /* 2201638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201684 */     // MIs[0] round
     /* 2201684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201687 */     // MIs[0] policy
     /* 2201687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201697 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201723 */     // GIR_Coverage, 18987,
     /* 2201723 */     GIR_EraseRootFromParent_Done,
     /* 2201724 */   // Label 28963: @2201724
     /* 2201724 */   GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2201815), // Rule ID 18990 //
     /* 2201729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201775 */     // MIs[0] round
     /* 2201775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201778 */     // MIs[0] policy
     /* 2201778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201788 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201814 */     // GIR_Coverage, 18990,
     /* 2201814 */     GIR_EraseRootFromParent_Done,
     /* 2201815 */   // Label 28964: @2201815
     /* 2201815 */   GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2201906), // Rule ID 18991 //
     /* 2201820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201866 */     // MIs[0] round
     /* 2201866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201869 */     // MIs[0] policy
     /* 2201869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201879 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201905 */     // GIR_Coverage, 18991,
     /* 2201905 */     GIR_EraseRootFromParent_Done,
     /* 2201906 */   // Label 28965: @2201906
     /* 2201906 */   GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2201997), // Rule ID 18994 //
     /* 2201911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201957 */     // MIs[0] round
     /* 2201957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201960 */     // MIs[0] policy
     /* 2201960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201970 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201996 */     // GIR_Coverage, 18994,
     /* 2201996 */     GIR_EraseRootFromParent_Done,
     /* 2201997 */   // Label 28966: @2201997
     /* 2201997 */   GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2202088), // Rule ID 18995 //
     /* 2202002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2202013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2202016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2202022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202048 */     // MIs[0] round
     /* 2202048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202051 */     // MIs[0] policy
     /* 2202051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202061 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2202064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202087 */     // GIR_Coverage, 18995,
     /* 2202087 */     GIR_EraseRootFromParent_Done,
     /* 2202088 */   // Label 28967: @2202088
     /* 2202088 */   GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2202179), // Rule ID 18998 //
     /* 2202093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202139 */     // MIs[0] round
     /* 2202139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202142 */     // MIs[0] policy
     /* 2202142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202152 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2202155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202178 */     // GIR_Coverage, 18998,
     /* 2202178 */     GIR_EraseRootFromParent_Done,
     /* 2202179 */   // Label 28968: @2202179
     /* 2202179 */   GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2202270), // Rule ID 18999 //
     /* 2202184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2202195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2202198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2202204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2202214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202230 */     // MIs[0] round
     /* 2202230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202233 */     // MIs[0] policy
     /* 2202233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202243 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2202246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202269 */     // GIR_Coverage, 18999,
     /* 2202269 */     GIR_EraseRootFromParent_Done,
     /* 2202270 */   // Label 28969: @2202270
     /* 2202270 */   GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2202361), // Rule ID 19002 //
     /* 2202275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2202278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202321 */     // MIs[0] round
     /* 2202321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202324 */     // MIs[0] policy
     /* 2202324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202334 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2202337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202360 */     // GIR_Coverage, 19002,
     /* 2202360 */     GIR_EraseRootFromParent_Done,
     /* 2202361 */   // Label 28970: @2202361
     /* 2202361 */   GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2202452), // Rule ID 19003 //
     /* 2202366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2202369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2202374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2202377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2202380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2202383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2202386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2202396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202412 */     // MIs[0] round
     /* 2202412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202415 */     // MIs[0] policy
     /* 2202415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202425 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2202428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2202432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202451 */     // GIR_Coverage, 19003,
     /* 2202451 */     GIR_EraseRootFromParent_Done,
     /* 2202452 */   // Label 28971: @2202452
     /* 2202452 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2202543), // Rule ID 64361 //
     /* 2202457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202503 */     // MIs[0] round
     /* 2202503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202506 */     // MIs[0] policy
     /* 2202506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202542 */     // GIR_Coverage, 64361,
     /* 2202542 */     GIR_EraseRootFromParent_Done,
     /* 2202543 */   // Label 28972: @2202543
     /* 2202543 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2202634), // Rule ID 64362 //
     /* 2202548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202594 */     // MIs[0] round
     /* 2202594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202597 */     // MIs[0] policy
     /* 2202597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202607 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202633 */     // GIR_Coverage, 64362,
     /* 2202633 */     GIR_EraseRootFromParent_Done,
     /* 2202634 */   // Label 28973: @2202634
     /* 2202634 */   GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2202725), // Rule ID 64365 //
     /* 2202639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202685 */     // MIs[0] round
     /* 2202685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202688 */     // MIs[0] policy
     /* 2202688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202724 */     // GIR_Coverage, 64365,
     /* 2202724 */     GIR_EraseRootFromParent_Done,
     /* 2202725 */   // Label 28974: @2202725
     /* 2202725 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2202816), // Rule ID 64366 //
     /* 2202730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202776 */     // MIs[0] round
     /* 2202776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202779 */     // MIs[0] policy
     /* 2202779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202789 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202815 */     // GIR_Coverage, 64366,
     /* 2202815 */     GIR_EraseRootFromParent_Done,
     /* 2202816 */   // Label 28975: @2202816
     /* 2202816 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2202907), // Rule ID 64369 //
     /* 2202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202867 */     // MIs[0] round
     /* 2202867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202870 */     // MIs[0] policy
     /* 2202870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202906 */     // GIR_Coverage, 64369,
     /* 2202906 */     GIR_EraseRootFromParent_Done,
     /* 2202907 */   // Label 28976: @2202907
     /* 2202907 */   GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2202998), // Rule ID 64370 //
     /* 2202912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202958 */     // MIs[0] round
     /* 2202958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202961 */     // MIs[0] policy
     /* 2202961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202997 */     // GIR_Coverage, 64370,
     /* 2202997 */     GIR_EraseRootFromParent_Done,
     /* 2202998 */   // Label 28977: @2202998
     /* 2202998 */   GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2203089), // Rule ID 64373 //
     /* 2203003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203049 */     // MIs[0] round
     /* 2203049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203052 */     // MIs[0] policy
     /* 2203052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2203065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203088 */     // GIR_Coverage, 64373,
     /* 2203088 */     GIR_EraseRootFromParent_Done,
     /* 2203089 */   // Label 28978: @2203089
     /* 2203089 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2203180), // Rule ID 64374 //
     /* 2203094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203140 */     // MIs[0] round
     /* 2203140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203143 */     // MIs[0] policy
     /* 2203143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203153 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11155:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M1_MASK),
     /* 2203156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203179 */     // GIR_Coverage, 64374,
     /* 2203179 */     GIR_EraseRootFromParent_Done,
     /* 2203180 */   // Label 28979: @2203180
     /* 2203180 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2203271), // Rule ID 64377 //
     /* 2203185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203231 */     // MIs[0] round
     /* 2203231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203234 */     // MIs[0] policy
     /* 2203234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2203247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203270 */     // GIR_Coverage, 64377,
     /* 2203270 */     GIR_EraseRootFromParent_Done,
     /* 2203271 */   // Label 28980: @2203271
     /* 2203271 */   GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2203362), // Rule ID 64378 //
     /* 2203276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2203284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203322 */     // MIs[0] round
     /* 2203322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203325 */     // MIs[0] policy
     /* 2203325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203335 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_XU_F_QF_M2_MASK),
     /* 2203338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203361 */     // GIR_Coverage, 64378,
     /* 2203361 */     GIR_EraseRootFromParent_Done,
     /* 2203362 */   // Label 28981: @2203362
     /* 2203362 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2203453), // Rule ID 64381 //
     /* 2203367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203413 */     // MIs[0] round
     /* 2203413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203416 */     // MIs[0] policy
     /* 2203416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203452 */     // GIR_Coverage, 64381,
     /* 2203452 */     GIR_EraseRootFromParent_Done,
     /* 2203453 */   // Label 28982: @2203453
     /* 2203453 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2203544), // Rule ID 64382 //
     /* 2203458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203504 */     // MIs[0] round
     /* 2203504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203507 */     // MIs[0] policy
     /* 2203507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203517 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203543 */     // GIR_Coverage, 64382,
     /* 2203543 */     GIR_EraseRootFromParent_Done,
     /* 2203544 */   // Label 28983: @2203544
     /* 2203544 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2203635), // Rule ID 64385 //
     /* 2203549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203595 */     // MIs[0] round
     /* 2203595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203598 */     // MIs[0] policy
     /* 2203598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203608 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203634 */     // GIR_Coverage, 64385,
     /* 2203634 */     GIR_EraseRootFromParent_Done,
     /* 2203635 */   // Label 28984: @2203635
     /* 2203635 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2203726), // Rule ID 64386 //
     /* 2203640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203686 */     // MIs[0] round
     /* 2203686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203689 */     // MIs[0] policy
     /* 2203689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203699 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203725 */     // GIR_Coverage, 64386,
     /* 2203725 */     GIR_EraseRootFromParent_Done,
     /* 2203726 */   // Label 28985: @2203726
     /* 2203726 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2203817), // Rule ID 64389 //
     /* 2203731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203777 */     // MIs[0] round
     /* 2203777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203780 */     // MIs[0] policy
     /* 2203780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203790 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203816 */     // GIR_Coverage, 64389,
     /* 2203816 */     GIR_EraseRootFromParent_Done,
     /* 2203817 */   // Label 28986: @2203817
     /* 2203817 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2203908), // Rule ID 64390 //
     /* 2203822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203868 */     // MIs[0] round
     /* 2203868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203871 */     // MIs[0] policy
     /* 2203871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203881 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203907 */     // GIR_Coverage, 64390,
     /* 2203907 */     GIR_EraseRootFromParent_Done,
     /* 2203908 */   // Label 28987: @2203908
     /* 2203908 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2203999), // Rule ID 64393 //
     /* 2203913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203959 */     // MIs[0] round
     /* 2203959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203962 */     // MIs[0] policy
     /* 2203962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203972 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2203975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203998 */     // GIR_Coverage, 64393,
     /* 2203998 */     GIR_EraseRootFromParent_Done,
     /* 2203999 */   // Label 28988: @2203999
     /* 2203999 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2204090), // Rule ID 64394 //
     /* 2204004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2204007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2204015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2204018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2204021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204050 */     // MIs[0] round
     /* 2204050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204053 */     // MIs[0] policy
     /* 2204053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204063 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11153:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M1_MASK),
     /* 2204066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204089 */     // GIR_Coverage, 64394,
     /* 2204089 */     GIR_EraseRootFromParent_Done,
     /* 2204090 */   // Label 28989: @2204090
     /* 2204090 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2204181), // Rule ID 64397 //
     /* 2204095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2204098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2204106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2204109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2204112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204141 */     // MIs[0] round
     /* 2204141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204144 */     // MIs[0] policy
     /* 2204144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2204157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204180 */     // GIR_Coverage, 64397,
     /* 2204180 */     GIR_EraseRootFromParent_Done,
     /* 2204181 */   // Label 28990: @2204181
     /* 2204181 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2204272), // Rule ID 64398 //
     /* 2204186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2204189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2204194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2204197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2204200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2204203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204232 */     // MIs[0] round
     /* 2204232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204235 */     // MIs[0] policy
     /* 2204235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoSF_VFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoSF_VFNRCLIP_X_F_QF_M2_MASK),
     /* 2204248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204271 */     // GIR_Coverage, 64398,
     /* 2204271 */     GIR_EraseRootFromParent_Done,
     /* 2204272 */   // Label 28991: @2204272
     /* 2204272 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2204363), // Rule ID 65186 //
     /* 2204277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204323 */     // MIs[0] round
     /* 2204323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204326 */     // MIs[0] policy
     /* 2204326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2204339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204362 */     // GIR_Coverage, 65186,
     /* 2204362 */     GIR_EraseRootFromParent_Done,
     /* 2204363 */   // Label 28992: @2204363
     /* 2204363 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2204454), // Rule ID 65187 //
     /* 2204368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204414 */     // MIs[0] round
     /* 2204414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204417 */     // MIs[0] policy
     /* 2204417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204427 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2204430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204453 */     // GIR_Coverage, 65187,
     /* 2204453 */     GIR_EraseRootFromParent_Done,
     /* 2204454 */   // Label 28993: @2204454
     /* 2204454 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2204545), // Rule ID 65190 //
     /* 2204459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204505 */     // MIs[0] round
     /* 2204505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204508 */     // MIs[0] policy
     /* 2204508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204544 */     // GIR_Coverage, 65190,
     /* 2204544 */     GIR_EraseRootFromParent_Done,
     /* 2204545 */   // Label 28994: @2204545
     /* 2204545 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2204636), // Rule ID 65191 //
     /* 2204550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204596 */     // MIs[0] round
     /* 2204596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204599 */     // MIs[0] policy
     /* 2204599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204609 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204635 */     // GIR_Coverage, 65191,
     /* 2204635 */     GIR_EraseRootFromParent_Done,
     /* 2204636 */   // Label 28995: @2204636
     /* 2204636 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2204727), // Rule ID 65194 //
     /* 2204641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204687 */     // MIs[0] round
     /* 2204687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204690 */     // MIs[0] policy
     /* 2204690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204726 */     // GIR_Coverage, 65194,
     /* 2204726 */     GIR_EraseRootFromParent_Done,
     /* 2204727 */   // Label 28996: @2204727
     /* 2204727 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2204818), // Rule ID 65195 //
     /* 2204732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204778 */     // MIs[0] round
     /* 2204778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204781 */     // MIs[0] policy
     /* 2204781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204791 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204817 */     // GIR_Coverage, 65195,
     /* 2204817 */     GIR_EraseRootFromParent_Done,
     /* 2204818 */   // Label 28997: @2204818
     /* 2204818 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2204909), // Rule ID 65198 //
     /* 2204823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204869 */     // MIs[0] round
     /* 2204869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204872 */     // MIs[0] policy
     /* 2204872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204908 */     // GIR_Coverage, 65198,
     /* 2204908 */     GIR_EraseRootFromParent_Done,
     /* 2204909 */   // Label 28998: @2204909
     /* 2204909 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2205000), // Rule ID 65199 //
     /* 2204914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204960 */     // MIs[0] round
     /* 2204960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204963 */     // MIs[0] policy
     /* 2204963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204973 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204999 */     // GIR_Coverage, 65199,
     /* 2204999 */     GIR_EraseRootFromParent_Done,
     /* 2205000 */   // Label 28999: @2205000
     /* 2205000 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2205091), // Rule ID 65202 //
     /* 2205005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205051 */     // MIs[0] round
     /* 2205051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205054 */     // MIs[0] policy
     /* 2205054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2205067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205090 */     // GIR_Coverage, 65202,
     /* 2205090 */     GIR_EraseRootFromParent_Done,
     /* 2205091 */   // Label 29000: @2205091
     /* 2205091 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2205182), // Rule ID 65203 //
     /* 2205096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205142 */     // MIs[0] round
     /* 2205142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205145 */     // MIs[0] policy
     /* 2205145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205155 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2205158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205181 */     // GIR_Coverage, 65203,
     /* 2205181 */     GIR_EraseRootFromParent_Done,
     /* 2205182 */   // Label 29001: @2205182
     /* 2205182 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2205273), // Rule ID 65206 //
     /* 2205187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205233 */     // MIs[0] round
     /* 2205233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205236 */     // MIs[0] policy
     /* 2205236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205246 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2205249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205272 */     // GIR_Coverage, 65206,
     /* 2205272 */     GIR_EraseRootFromParent_Done,
     /* 2205273 */   // Label 29002: @2205273
     /* 2205273 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2205364), // Rule ID 65207 //
     /* 2205278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2205286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205324 */     // MIs[0] round
     /* 2205324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205327 */     // MIs[0] policy
     /* 2205327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205337 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2205340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205363 */     // GIR_Coverage, 65207,
     /* 2205363 */     GIR_EraseRootFromParent_Done,
     /* 2205364 */   // Label 29003: @2205364
     /* 2205364 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2205455), // Rule ID 65210 //
     /* 2205369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205415 */     // MIs[0] round
     /* 2205415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205418 */     // MIs[0] policy
     /* 2205418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205428 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205454 */     // GIR_Coverage, 65210,
     /* 2205454 */     GIR_EraseRootFromParent_Done,
     /* 2205455 */   // Label 29004: @2205455
     /* 2205455 */   GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2205546), // Rule ID 65211 //
     /* 2205460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205506 */     // MIs[0] round
     /* 2205506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205509 */     // MIs[0] policy
     /* 2205509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205519 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205545 */     // GIR_Coverage, 65211,
     /* 2205545 */     GIR_EraseRootFromParent_Done,
     /* 2205546 */   // Label 29005: @2205546
     /* 2205546 */   GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2205637), // Rule ID 65214 //
     /* 2205551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205597 */     // MIs[0] round
     /* 2205597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205600 */     // MIs[0] policy
     /* 2205600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205610 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205636 */     // GIR_Coverage, 65214,
     /* 2205636 */     GIR_EraseRootFromParent_Done,
     /* 2205637 */   // Label 29006: @2205637
     /* 2205637 */   GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2205728), // Rule ID 65215 //
     /* 2205642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205688 */     // MIs[0] round
     /* 2205688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205691 */     // MIs[0] policy
     /* 2205691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205701 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205727 */     // GIR_Coverage, 65215,
     /* 2205727 */     GIR_EraseRootFromParent_Done,
     /* 2205728 */   // Label 29007: @2205728
     /* 2205728 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2205819), // Rule ID 65218 //
     /* 2205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205779 */     // MIs[0] round
     /* 2205779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205782 */     // MIs[0] policy
     /* 2205782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205792 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205818 */     // GIR_Coverage, 65218,
     /* 2205818 */     GIR_EraseRootFromParent_Done,
     /* 2205819 */   // Label 29008: @2205819
     /* 2205819 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2205910), // Rule ID 65219 //
     /* 2205824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205870 */     // MIs[0] round
     /* 2205870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205873 */     // MIs[0] policy
     /* 2205873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205883 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11086:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205909 */     // GIR_Coverage, 65219,
     /* 2205909 */     GIR_EraseRootFromParent_Done,
     /* 2205910 */   // Label 29009: @2205910
     /* 2205910 */   GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2206001), // Rule ID 65222 //
     /* 2205915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205961 */     // MIs[0] round
     /* 2205961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205964 */     // MIs[0] policy
     /* 2205964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206000 */     // GIR_Coverage, 65222,
     /* 2206000 */     GIR_EraseRootFromParent_Done,
     /* 2206001 */   // Label 29010: @2206001
     /* 2206001 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2206092), // Rule ID 65223 //
     /* 2206006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2206017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2206020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2206023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2206029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2206036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2206044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206052 */     // MIs[0] round
     /* 2206052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206055 */     // MIs[0] policy
     /* 2206055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2206068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206091 */     // GIR_Coverage, 65223,
     /* 2206091 */     GIR_EraseRootFromParent_Done,
     /* 2206092 */   // Label 29011: @2206092
     /* 2206092 */   GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2206183), // Rule ID 65226 //
     /* 2206097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2206100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2206108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2206111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2206114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2206127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206143 */     // MIs[0] round
     /* 2206143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206146 */     // MIs[0] policy
     /* 2206146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206156 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2206159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206182 */     // GIR_Coverage, 65226,
     /* 2206182 */     GIR_EraseRootFromParent_Done,
     /* 2206183 */   // Label 29012: @2206183
     /* 2206183 */   GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2206274), // Rule ID 65227 //
     /* 2206188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2206199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2206202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2206205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2206211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2206218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2206226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206234 */     // MIs[0] round
     /* 2206234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206237 */     // MIs[0] policy
     /* 2206237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206247 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2206250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206273 */     // GIR_Coverage, 65227,
     /* 2206273 */     GIR_EraseRootFromParent_Done,
     /* 2206274 */   // Label 29013: @2206274
     /* 2206274 */   GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2206365), // Rule ID 65230 //
     /* 2206279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2206282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2206290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2206293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2206296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2206302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2206305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2206309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206325 */     // MIs[0] round
     /* 2206325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206328 */     // MIs[0] policy
     /* 2206328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206338 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2206338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2206341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206364 */     // GIR_Coverage, 65230,
     /* 2206364 */     GIR_EraseRootFromParent_Done,
     /* 2206365 */   // Label 29014: @2206365
     /* 2206365 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2206456), // Rule ID 65231 //
     /* 2206370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2206373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2206378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2206381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2206384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2206387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2206393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2206396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2206400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2206408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2206412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2206416 */     // MIs[0] round
     /* 2206416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2206419 */     // MIs[0] policy
     /* 2206419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2206422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2206429 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2206429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2206432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2206436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2206438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2206440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2206442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2206444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2206449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2206454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206455 */     // GIR_Coverage, 65231,
     /* 2206455 */     GIR_EraseRootFromParent_Done,
     /* 2206456 */   // Label 29015: @2206456
     /* 2206456 */   GIM_Reject,
     /* 2206457 */ // Label 26947: @2206457
     /* 2206457 */ GIM_Reject,
     /* 2206458 */ // Label 38: @2206458
     /* 2206458 */ GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2206510),
     /* 2206463 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 2206466 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::riscv_pause),
     /* 2206471 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2206490), // Rule ID 299 //
     /* 2206476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode0),
     /* 2206479 */     // (intrinsic_void 11095:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2206479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206489 */     // GIR_Coverage, 299,
     /* 2206489 */     GIR_EraseRootFromParent_Done,
     /* 2206490 */   // Label 29017: @2206490
     /* 2206490 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2206509), // Rule ID 300 //
     /* 2206495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode1),
     /* 2206498 */     // (intrinsic_void 11095:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2206498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206508 */     // GIR_Coverage, 300,
     /* 2206508 */     GIR_EraseRootFromParent_Done,
     /* 2206509 */   // Label 29018: @2206509
     /* 2206509 */   GIM_Reject,
     /* 2206510 */ // Label 29016: @2206510
     /* 2206510 */ GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2206593), // Rule ID 41 //
     /* 2206515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2206518 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2206521 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2206526 */   // MIs[0] Operand 1
     /* 2206526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2206530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2206534 */   // MIs[0] ptr
     /* 2206534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2206542 */   // MIs[0] accessinfo
     /* 2206542 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2206545 */   // (intrinsic_void 195:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2206545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2206549 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2206559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2206562 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2206564 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2206566 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2206569 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2206572 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2206575 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2206578 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2206581 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2206584 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2206587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206592 */   // GIR_Coverage, 41,
     /* 2206592 */   GIR_EraseRootFromParent_Done,
     /* 2206593 */ // Label 29019: @2206593
     /* 2206593 */ GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2207498),
     /* 2206598 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2206601 */   GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2206673), // Rule ID 633 //
     /* 2206606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2206614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206627 */     // MIs[0] addr
     /* 2206627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206643 */     // MIs[0] ordering
     /* 2206643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206646 */     // (intrinsic_w_chain:{ *:[i32] } 11072:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206654 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206659 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206661 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206663 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206665 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206672 */     // GIR_Coverage, 633,
     /* 2206672 */     GIR_EraseRootFromParent_Done,
     /* 2206673 */   // Label 29021: @2206673
     /* 2206673 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2206745), // Rule ID 634 //
     /* 2206678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2206686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206699 */     // MIs[0] addr
     /* 2206699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206715 */     // MIs[0] ordering
     /* 2206715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206718 */     // (intrinsic_w_chain:{ *:[i32] } 11058:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206726 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206731 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206733 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206735 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206737 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206744 */     // GIR_Coverage, 634,
     /* 2206744 */     GIR_EraseRootFromParent_Done,
     /* 2206745 */   // Label 29022: @2206745
     /* 2206745 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2206817), // Rule ID 635 //
     /* 2206750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2206758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206771 */     // MIs[0] addr
     /* 2206771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206787 */     // MIs[0] ordering
     /* 2206787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206790 */     // (intrinsic_w_chain:{ *:[i32] } 11066:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206798 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206803 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206805 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206807 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206809 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206816 */     // GIR_Coverage, 635,
     /* 2206816 */     GIR_EraseRootFromParent_Done,
     /* 2206817 */   // Label 29023: @2206817
     /* 2206817 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2206889), // Rule ID 636 //
     /* 2206822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2206830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206843 */     // MIs[0] addr
     /* 2206843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206859 */     // MIs[0] ordering
     /* 2206859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206862 */     // (intrinsic_w_chain:{ *:[i32] } 11064:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206870 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206875 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206877 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206879 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206881 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206888 */     // GIR_Coverage, 636,
     /* 2206888 */     GIR_EraseRootFromParent_Done,
     /* 2206889 */   // Label 29024: @2206889
     /* 2206889 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2206969), // Rule ID 639 //
     /* 2206894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2206902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206915 */     // MIs[0] addr
     /* 2206915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206931 */     // MIs[0] ordering
     /* 2206931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206934 */     // (intrinsic_w_chain:{ *:[i32] } 11068:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206945 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206950 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206955 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206957 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206959 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206961 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206968 */     // GIR_Coverage, 639,
     /* 2206968 */     GIR_EraseRootFromParent_Done,
     /* 2206969 */   // Label 29025: @2206969
     /* 2206969 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2207049), // Rule ID 640 //
     /* 2206974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2206982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206995 */     // MIs[0] addr
     /* 2206995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207011 */     // MIs[0] ordering
     /* 2207011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207014 */     // (intrinsic_w_chain:{ *:[i32] } 11070:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207025 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207030 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207035 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207037 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207039 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207041 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207048 */     // GIR_Coverage, 640,
     /* 2207048 */     GIR_EraseRootFromParent_Done,
     /* 2207049 */   // Label 29026: @2207049
     /* 2207049 */   GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2207121), // Rule ID 646 //
     /* 2207054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2207062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207075 */     // MIs[0] addr
     /* 2207075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207091 */     // MIs[0] ordering
     /* 2207091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207094 */     // (intrinsic_w_chain:{ *:[i64] } 11073:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2207100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207102 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207107 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207109 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207111 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207113 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207120 */     // GIR_Coverage, 646,
     /* 2207120 */     GIR_EraseRootFromParent_Done,
     /* 2207121 */   // Label 29027: @2207121
     /* 2207121 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2207193), // Rule ID 647 //
     /* 2207126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2207134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207147 */     // MIs[0] addr
     /* 2207147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207163 */     // MIs[0] ordering
     /* 2207163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207166 */     // (intrinsic_w_chain:{ *:[i64] } 11059:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2207172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207174 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207179 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207181 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207183 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207185 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207192 */     // GIR_Coverage, 647,
     /* 2207192 */     GIR_EraseRootFromParent_Done,
     /* 2207193 */   // Label 29028: @2207193
     /* 2207193 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2207265), // Rule ID 648 //
     /* 2207198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2207206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207219 */     // MIs[0] addr
     /* 2207219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207235 */     // MIs[0] ordering
     /* 2207235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207238 */     // (intrinsic_w_chain:{ *:[i64] } 11067:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2207244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207246 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207251 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207253 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207255 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207257 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207264 */     // GIR_Coverage, 648,
     /* 2207264 */     GIR_EraseRootFromParent_Done,
     /* 2207265 */   // Label 29029: @2207265
     /* 2207265 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2207337), // Rule ID 649 //
     /* 2207270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2207278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207291 */     // MIs[0] addr
     /* 2207291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207307 */     // MIs[0] ordering
     /* 2207307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207310 */     // (intrinsic_w_chain:{ *:[i64] } 11065:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2207316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207318 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207323 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207325 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207327 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207329 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207336 */     // GIR_Coverage, 649,
     /* 2207336 */     GIR_EraseRootFromParent_Done,
     /* 2207337 */   // Label 29030: @2207337
     /* 2207337 */   GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2207417), // Rule ID 652 //
     /* 2207342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2207350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207363 */     // MIs[0] addr
     /* 2207363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207379 */     // MIs[0] ordering
     /* 2207379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207382 */     // (intrinsic_w_chain:{ *:[i64] } 11069:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2207391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207393 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207398 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207403 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207405 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207407 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207409 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207416 */     // GIR_Coverage, 652,
     /* 2207416 */     GIR_EraseRootFromParent_Done,
     /* 2207417 */   // Label 29031: @2207417
     /* 2207417 */   GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2207497), // Rule ID 653 //
     /* 2207422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2207430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207443 */     // MIs[0] addr
     /* 2207443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207459 */     // MIs[0] ordering
     /* 2207459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2207462 */     // (intrinsic_w_chain:{ *:[i64] } 11071:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207473 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207478 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207483 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207485 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207487 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207489 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207496 */     // GIR_Coverage, 653,
     /* 2207496 */     GIR_EraseRootFromParent_Done,
     /* 2207497 */   // Label 29032: @2207497
     /* 2207497 */   GIM_Reject,
     /* 2207498 */ // Label 29020: @2207498
     /* 2207498 */ GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2208025),
     /* 2207503 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2207506 */   GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2207595), // Rule ID 637 //
     /* 2207511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2207519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207535 */     // MIs[0] addr
     /* 2207535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207555 */     // MIs[0] ordering
     /* 2207555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207558 */     // (intrinsic_w_chain:{ *:[i32] } 11060:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207569 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207574 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207579 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207581 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207583 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207585 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207587 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207594 */     // GIR_Coverage, 637,
     /* 2207594 */     GIR_EraseRootFromParent_Done,
     /* 2207595 */   // Label 29034: @2207595
     /* 2207595 */   GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2207684), // Rule ID 638 //
     /* 2207600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2207608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207624 */     // MIs[0] addr
     /* 2207624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207644 */     // MIs[0] ordering
     /* 2207644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207647 */     // (intrinsic_w_chain:{ *:[i32] } 11062:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207658 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207663 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207668 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207670 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207672 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207674 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207676 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207683 */     // GIR_Coverage, 638,
     /* 2207683 */     GIR_EraseRootFromParent_Done,
     /* 2207684 */   // Label 29035: @2207684
     /* 2207684 */   GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2207773), // Rule ID 650 //
     /* 2207689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2207697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207713 */     // MIs[0] addr
     /* 2207713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207733 */     // MIs[0] ordering
     /* 2207733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207736 */     // (intrinsic_w_chain:{ *:[i64] } 11061:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207747 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207752 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207757 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207759 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207761 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207763 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207765 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207772 */     // GIR_Coverage, 650,
     /* 2207772 */     GIR_EraseRootFromParent_Done,
     /* 2207773 */   // Label 29036: @2207773
     /* 2207773 */   GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2207862), // Rule ID 651 //
     /* 2207778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2207786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207802 */     // MIs[0] addr
     /* 2207802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207822 */     // MIs[0] ordering
     /* 2207822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207825 */     // (intrinsic_w_chain:{ *:[i64] } 11063:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207836 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207841 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207846 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207848 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207850 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207852 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207854 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207861 */     // GIR_Coverage, 651,
     /* 2207861 */     GIR_EraseRootFromParent_Done,
     /* 2207862 */   // Label 29037: @2207862
     /* 2207862 */   GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2207943), // Rule ID 669 //
     /* 2207867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2207875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207891 */     // MIs[0] addr
     /* 2207891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207911 */     // MIs[0] ordering
     /* 2207911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207914 */     // (intrinsic_w_chain:{ *:[i32] } 11074:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207922 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207927 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207929 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207931 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207933 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207935 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207942 */     // GIR_Coverage, 669,
     /* 2207942 */     GIR_EraseRootFromParent_Done,
     /* 2207943 */   // Label 29038: @2207943
     /* 2207943 */   GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2208024), // Rule ID 670 //
     /* 2207948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2207956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207972 */     // MIs[0] addr
     /* 2207972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207992 */     // MIs[0] ordering
     /* 2207992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207995 */     // (intrinsic_w_chain:{ *:[i64] } 11075:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2208001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2208003 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2208008 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2208010 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2208012 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2208014 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2208016 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2208018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2208022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208023 */     // GIR_Coverage, 670,
     /* 2208023 */     GIR_EraseRootFromParent_Done,
     /* 2208024 */   // Label 29039: @2208024
     /* 2208024 */   GIM_Reject,
     /* 2208025 */ // Label 29033: @2208025
     /* 2208025 */ GIM_Reject,
     /* 2208026 */ // Label 39: @2208026
     /* 2208026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 29055*/ GIMT_Encode4(2211146),
     /* 2208037 */ /*GILLT_nxv1s16*//*Label 29040*/ GIMT_Encode4(2208137),
     /* 2208041 */ /*GILLT_nxv1s32*//*Label 29041*/ GIMT_Encode4(2208241),
     /* 2208045 */ /*GILLT_nxv1s64*//*Label 29042*/ GIMT_Encode4(2208458), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208057 */ /*GILLT_nxv2s16*//*Label 29043*/ GIMT_Encode4(2208783),
     /* 2208061 */ /*GILLT_nxv2s32*//*Label 29044*/ GIMT_Encode4(2208887),
     /* 2208065 */ /*GILLT_nxv2s64*//*Label 29045*/ GIMT_Encode4(2209104), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208077 */ /*GILLT_nxv4s16*//*Label 29046*/ GIMT_Encode4(2209429),
     /* 2208081 */ /*GILLT_nxv4s32*//*Label 29047*/ GIMT_Encode4(2209533),
     /* 2208085 */ /*GILLT_nxv4s64*//*Label 29048*/ GIMT_Encode4(2209750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208097 */ /*GILLT_nxv8s16*//*Label 29049*/ GIMT_Encode4(2210075),
     /* 2208101 */ /*GILLT_nxv8s32*//*Label 29050*/ GIMT_Encode4(2210179),
     /* 2208105 */ /*GILLT_nxv8s64*//*Label 29051*/ GIMT_Encode4(2210396), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208117 */ /*GILLT_nxv16s16*//*Label 29052*/ GIMT_Encode4(2210721),
     /* 2208121 */ /*GILLT_nxv16s32*//*Label 29053*/ GIMT_Encode4(2210825), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2208133 */ /*GILLT_nxv32s16*//*Label 29054*/ GIMT_Encode4(2211042),
     /* 2208137 */ // Label 29040: @2208137
     /* 2208137 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2208240),
     /* 2208142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208153 */   GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2208196), // Rule ID 47490 //
     /* 2208158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208161 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2208164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2208178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208195 */     // GIR_Coverage, 47490,
     /* 2208195 */     GIR_EraseRootFromParent_Done,
     /* 2208196 */   // Label 29057: @2208196
     /* 2208196 */   GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2208239), // Rule ID 47491 //
     /* 2208201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208204 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2208207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2208221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208238 */     // GIR_Coverage, 47491,
     /* 2208238 */     GIR_EraseRootFromParent_Done,
     /* 2208239 */   // Label 29058: @2208239
     /* 2208239 */   GIM_Reject,
     /* 2208240 */ // Label 29056: @2208240
     /* 2208240 */ GIM_Reject,
     /* 2208241 */ // Label 29041: @2208241
     /* 2208241 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2208295), // Rule ID 47514 //
     /* 2208246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208260 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208294 */   // GIR_Coverage, 47514,
     /* 2208294 */   GIR_EraseRootFromParent_Done,
     /* 2208295 */ // Label 29059: @2208295
     /* 2208295 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2208349), // Rule ID 47515 //
     /* 2208300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208314 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208336 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208348 */   // GIR_Coverage, 47515,
     /* 2208348 */   GIR_EraseRootFromParent_Done,
     /* 2208349 */ // Label 29060: @2208349
     /* 2208349 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2208403), // Rule ID 47580 //
     /* 2208354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208368 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2208385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208390 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208401 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208402 */   // GIR_Coverage, 47580,
     /* 2208402 */   GIR_EraseRootFromParent_Done,
     /* 2208403 */ // Label 29061: @2208403
     /* 2208403 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2208457), // Rule ID 47581 //
     /* 2208408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208422 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2208425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2208439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208444 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208455 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208456 */   // GIR_Coverage, 47581,
     /* 2208456 */   GIR_EraseRootFromParent_Done,
     /* 2208457 */ // Label 29062: @2208457
     /* 2208457 */ GIM_Reject,
     /* 2208458 */ // Label 29042: @2208458
     /* 2208458 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2208512), // Rule ID 47534 //
     /* 2208463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208477 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208511 */   // GIR_Coverage, 47534,
     /* 2208511 */   GIR_EraseRootFromParent_Done,
     /* 2208512 */ // Label 29063: @2208512
     /* 2208512 */ GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2208566), // Rule ID 47535 //
     /* 2208517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208531 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208553 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208565 */   // GIR_Coverage, 47535,
     /* 2208565 */   GIR_EraseRootFromParent_Done,
     /* 2208566 */ // Label 29064: @2208566
     /* 2208566 */ GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2208620), // Rule ID 47600 //
     /* 2208571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208585 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208607 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208619 */   // GIR_Coverage, 47600,
     /* 2208619 */   GIR_EraseRootFromParent_Done,
     /* 2208620 */ // Label 29065: @2208620
     /* 2208620 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2208674), // Rule ID 47601 //
     /* 2208625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208639 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208673 */   // GIR_Coverage, 47601,
     /* 2208673 */   GIR_EraseRootFromParent_Done,
     /* 2208674 */ // Label 29066: @2208674
     /* 2208674 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2208728), // Rule ID 47634 //
     /* 2208679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208693 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208715 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208727 */   // GIR_Coverage, 47634,
     /* 2208727 */   GIR_EraseRootFromParent_Done,
     /* 2208728 */ // Label 29067: @2208728
     /* 2208728 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2208782), // Rule ID 47635 //
     /* 2208733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208747 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208769 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208781 */   // GIR_Coverage, 47635,
     /* 2208781 */   GIR_EraseRootFromParent_Done,
     /* 2208782 */ // Label 29068: @2208782
     /* 2208782 */ GIM_Reject,
     /* 2208783 */ // Label 29043: @2208783
     /* 2208783 */ GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2208886),
     /* 2208788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208799 */   GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2208842), // Rule ID 47494 //
     /* 2208804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208807 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208841 */     // GIR_Coverage, 47494,
     /* 2208841 */     GIR_EraseRootFromParent_Done,
     /* 2208842 */   // Label 29070: @2208842
     /* 2208842 */   GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2208885), // Rule ID 47495 //
     /* 2208847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208850 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208884 */     // GIR_Coverage, 47495,
     /* 2208884 */     GIR_EraseRootFromParent_Done,
     /* 2208885 */   // Label 29071: @2208885
     /* 2208885 */   GIM_Reject,
     /* 2208886 */ // Label 29069: @2208886
     /* 2208886 */ GIM_Reject,
     /* 2208887 */ // Label 29044: @2208887
     /* 2208887 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2208941), // Rule ID 47518 //
     /* 2208892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208906 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208928 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208940 */   // GIR_Coverage, 47518,
     /* 2208940 */   GIR_EraseRootFromParent_Done,
     /* 2208941 */ // Label 29072: @2208941
     /* 2208941 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2208995), // Rule ID 47519 //
     /* 2208946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208960 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208994 */   // GIR_Coverage, 47519,
     /* 2208994 */   GIR_EraseRootFromParent_Done,
     /* 2208995 */ // Label 29073: @2208995
     /* 2208995 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2209049), // Rule ID 47584 //
     /* 2209000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209014 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2209017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2209031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209048 */   // GIR_Coverage, 47584,
     /* 2209048 */   GIR_EraseRootFromParent_Done,
     /* 2209049 */ // Label 29074: @2209049
     /* 2209049 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2209103), // Rule ID 47585 //
     /* 2209054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209068 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2209071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2209085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209090 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209102 */   // GIR_Coverage, 47585,
     /* 2209102 */   GIR_EraseRootFromParent_Done,
     /* 2209103 */ // Label 29075: @2209103
     /* 2209103 */ GIM_Reject,
     /* 2209104 */ // Label 29045: @2209104
     /* 2209104 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2209158), // Rule ID 47538 //
     /* 2209109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2209115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209123 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209145 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209157 */   // GIR_Coverage, 47538,
     /* 2209157 */   GIR_EraseRootFromParent_Done,
     /* 2209158 */ // Label 29076: @2209158
     /* 2209158 */ GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2209212), // Rule ID 47539 //
     /* 2209163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2209169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209177 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209210 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209211 */   // GIR_Coverage, 47539,
     /* 2209211 */   GIR_EraseRootFromParent_Done,
     /* 2209212 */ // Label 29077: @2209212
     /* 2209212 */ GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2209266), // Rule ID 47604 //
     /* 2209217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2209223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209231 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209253 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209265 */   // GIR_Coverage, 47604,
     /* 2209265 */   GIR_EraseRootFromParent_Done,
     /* 2209266 */ // Label 29078: @2209266
     /* 2209266 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2209320), // Rule ID 47605 //
     /* 2209271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2209277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209285 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209307 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209319 */   // GIR_Coverage, 47605,
     /* 2209319 */   GIR_EraseRootFromParent_Done,
     /* 2209320 */ // Label 29079: @2209320
     /* 2209320 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2209374), // Rule ID 47638 //
     /* 2209325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209339 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2209356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209361 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209373 */   // GIR_Coverage, 47638,
     /* 2209373 */   GIR_EraseRootFromParent_Done,
     /* 2209374 */ // Label 29080: @2209374
     /* 2209374 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2209428), // Rule ID 47639 //
     /* 2209379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2209385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209393 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2209396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2209410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209415 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209427 */   // GIR_Coverage, 47639,
     /* 2209427 */   GIR_EraseRootFromParent_Done,
     /* 2209428 */ // Label 29081: @2209428
     /* 2209428 */ GIM_Reject,
     /* 2209429 */ // Label 29046: @2209429
     /* 2209429 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2209532),
     /* 2209434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209445 */   GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2209488), // Rule ID 47498 //
     /* 2209450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209453 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209487 */     // GIR_Coverage, 47498,
     /* 2209487 */     GIR_EraseRootFromParent_Done,
     /* 2209488 */   // Label 29083: @2209488
     /* 2209488 */   GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2209531), // Rule ID 47499 //
     /* 2209493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209496 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209530 */     // GIR_Coverage, 47499,
     /* 2209530 */     GIR_EraseRootFromParent_Done,
     /* 2209531 */   // Label 29084: @2209531
     /* 2209531 */   GIM_Reject,
     /* 2209532 */ // Label 29082: @2209532
     /* 2209532 */ GIM_Reject,
     /* 2209533 */ // Label 29047: @2209533
     /* 2209533 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2209587), // Rule ID 47522 //
     /* 2209538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209552 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209574 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209586 */   // GIR_Coverage, 47522,
     /* 2209586 */   GIR_EraseRootFromParent_Done,
     /* 2209587 */ // Label 29085: @2209587
     /* 2209587 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2209641), // Rule ID 47523 //
     /* 2209592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209606 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209640 */   // GIR_Coverage, 47523,
     /* 2209640 */   GIR_EraseRootFromParent_Done,
     /* 2209641 */ // Label 29086: @2209641
     /* 2209641 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2209695), // Rule ID 47588 //
     /* 2209646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209660 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209682 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209694 */   // GIR_Coverage, 47588,
     /* 2209694 */   GIR_EraseRootFromParent_Done,
     /* 2209695 */ // Label 29087: @2209695
     /* 2209695 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2209749), // Rule ID 47589 //
     /* 2209700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209714 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209736 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209748 */   // GIR_Coverage, 47589,
     /* 2209748 */   GIR_EraseRootFromParent_Done,
     /* 2209749 */ // Label 29088: @2209749
     /* 2209749 */ GIM_Reject,
     /* 2209750 */ // Label 29048: @2209750
     /* 2209750 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2209804), // Rule ID 47542 //
     /* 2209755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209769 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209791 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209803 */   // GIR_Coverage, 47542,
     /* 2209803 */   GIR_EraseRootFromParent_Done,
     /* 2209804 */ // Label 29089: @2209804
     /* 2209804 */ GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2209858), // Rule ID 47543 //
     /* 2209809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209823 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209857 */   // GIR_Coverage, 47543,
     /* 2209857 */   GIR_EraseRootFromParent_Done,
     /* 2209858 */ // Label 29090: @2209858
     /* 2209858 */ GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2209912), // Rule ID 47608 //
     /* 2209863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209877 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209911 */   // GIR_Coverage, 47608,
     /* 2209911 */   GIR_EraseRootFromParent_Done,
     /* 2209912 */ // Label 29091: @2209912
     /* 2209912 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2209966), // Rule ID 47609 //
     /* 2209917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209931 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209953 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209965 */   // GIR_Coverage, 47609,
     /* 2209965 */   GIR_EraseRootFromParent_Done,
     /* 2209966 */ // Label 29092: @2209966
     /* 2209966 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2210020), // Rule ID 47642 //
     /* 2209971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209985 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2210002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210007 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210019 */   // GIR_Coverage, 47642,
     /* 2210019 */   GIR_EraseRootFromParent_Done,
     /* 2210020 */ // Label 29093: @2210020
     /* 2210020 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2210074), // Rule ID 47643 //
     /* 2210025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2210031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210039 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2210042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2210056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210061 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210072 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210073 */   // GIR_Coverage, 47643,
     /* 2210073 */   GIR_EraseRootFromParent_Done,
     /* 2210074 */ // Label 29094: @2210074
     /* 2210074 */ GIM_Reject,
     /* 2210075 */ // Label 29049: @2210075
     /* 2210075 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2210178),
     /* 2210080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210091 */   GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2210134), // Rule ID 47502 //
     /* 2210096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210099 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2210116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210133 */     // GIR_Coverage, 47502,
     /* 2210133 */     GIR_EraseRootFromParent_Done,
     /* 2210134 */   // Label 29096: @2210134
     /* 2210134 */   GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2210177), // Rule ID 47503 //
     /* 2210139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210142 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2210159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210176 */     // GIR_Coverage, 47503,
     /* 2210176 */     GIR_EraseRootFromParent_Done,
     /* 2210177 */   // Label 29097: @2210177
     /* 2210177 */   GIM_Reject,
     /* 2210178 */ // Label 29095: @2210178
     /* 2210178 */ GIM_Reject,
     /* 2210179 */ // Label 29050: @2210179
     /* 2210179 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2210233), // Rule ID 47526 //
     /* 2210184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210198 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210232 */   // GIR_Coverage, 47526,
     /* 2210232 */   GIR_EraseRootFromParent_Done,
     /* 2210233 */ // Label 29098: @2210233
     /* 2210233 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2210287), // Rule ID 47527 //
     /* 2210238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210252 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210286 */   // GIR_Coverage, 47527,
     /* 2210286 */   GIR_EraseRootFromParent_Done,
     /* 2210287 */ // Label 29099: @2210287
     /* 2210287 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2210341), // Rule ID 47592 //
     /* 2210292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210306 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2210323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210340 */   // GIR_Coverage, 47592,
     /* 2210340 */   GIR_EraseRootFromParent_Done,
     /* 2210341 */ // Label 29100: @2210341
     /* 2210341 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2210395), // Rule ID 47593 //
     /* 2210346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210360 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2210377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210382 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210394 */   // GIR_Coverage, 47593,
     /* 2210394 */   GIR_EraseRootFromParent_Done,
     /* 2210395 */ // Label 29101: @2210395
     /* 2210395 */ GIM_Reject,
     /* 2210396 */ // Label 29051: @2210396
     /* 2210396 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2210450), // Rule ID 47546 //
     /* 2210401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210415 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210449 */   // GIR_Coverage, 47546,
     /* 2210449 */   GIR_EraseRootFromParent_Done,
     /* 2210450 */ // Label 29102: @2210450
     /* 2210450 */ GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2210504), // Rule ID 47547 //
     /* 2210455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210469 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210491 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210503 */   // GIR_Coverage, 47547,
     /* 2210503 */   GIR_EraseRootFromParent_Done,
     /* 2210504 */ // Label 29103: @2210504
     /* 2210504 */ GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2210558), // Rule ID 47612 //
     /* 2210509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210523 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210545 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210557 */   // GIR_Coverage, 47612,
     /* 2210557 */   GIR_EraseRootFromParent_Done,
     /* 2210558 */ // Label 29104: @2210558
     /* 2210558 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2210612), // Rule ID 47613 //
     /* 2210563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210577 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210599 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210611 */   // GIR_Coverage, 47613,
     /* 2210611 */   GIR_EraseRootFromParent_Done,
     /* 2210612 */ // Label 29105: @2210612
     /* 2210612 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2210666), // Rule ID 47646 //
     /* 2210617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210631 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210653 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210665 */   // GIR_Coverage, 47646,
     /* 2210665 */   GIR_EraseRootFromParent_Done,
     /* 2210666 */ // Label 29106: @2210666
     /* 2210666 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2210720), // Rule ID 47647 //
     /* 2210671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210685 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210707 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210719 */   // GIR_Coverage, 47647,
     /* 2210719 */   GIR_EraseRootFromParent_Done,
     /* 2210720 */ // Label 29107: @2210720
     /* 2210720 */ GIM_Reject,
     /* 2210721 */ // Label 29052: @2210721
     /* 2210721 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2210824),
     /* 2210726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210737 */   GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2210780), // Rule ID 47506 //
     /* 2210742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210745 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210779 */     // GIR_Coverage, 47506,
     /* 2210779 */     GIR_EraseRootFromParent_Done,
     /* 2210780 */   // Label 29109: @2210780
     /* 2210780 */   GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2210823), // Rule ID 47507 //
     /* 2210785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210788 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210822 */     // GIR_Coverage, 47507,
     /* 2210822 */     GIR_EraseRootFromParent_Done,
     /* 2210823 */   // Label 29110: @2210823
     /* 2210823 */   GIM_Reject,
     /* 2210824 */ // Label 29108: @2210824
     /* 2210824 */ GIM_Reject,
     /* 2210825 */ // Label 29053: @2210825
     /* 2210825 */ GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2210879), // Rule ID 47530 //
     /* 2210830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210844 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210878 */   // GIR_Coverage, 47530,
     /* 2210878 */   GIR_EraseRootFromParent_Done,
     /* 2210879 */ // Label 29111: @2210879
     /* 2210879 */ GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2210933), // Rule ID 47531 //
     /* 2210884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210898 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210932 */   // GIR_Coverage, 47531,
     /* 2210932 */   GIR_EraseRootFromParent_Done,
     /* 2210933 */ // Label 29112: @2210933
     /* 2210933 */ GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2210987), // Rule ID 47596 //
     /* 2210938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210952 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210986 */   // GIR_Coverage, 47596,
     /* 2210986 */   GIR_EraseRootFromParent_Done,
     /* 2210987 */ // Label 29113: @2210987
     /* 2210987 */ GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2211041), // Rule ID 47597 //
     /* 2210992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211006 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2211009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2211023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211040 */   // GIR_Coverage, 47597,
     /* 2211040 */   GIR_EraseRootFromParent_Done,
     /* 2211041 */ // Label 29114: @2211041
     /* 2211041 */ GIM_Reject,
     /* 2211042 */ // Label 29054: @2211042
     /* 2211042 */ GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2211145),
     /* 2211047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2211050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211058 */   GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2211101), // Rule ID 47510 //
     /* 2211063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211066 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2211069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2211083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211100 */     // GIR_Coverage, 47510,
     /* 2211100 */     GIR_EraseRootFromParent_Done,
     /* 2211101 */   // Label 29116: @2211101
     /* 2211101 */   GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2211144), // Rule ID 47511 //
     /* 2211106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211109 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2211112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2211126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211143 */     // GIR_Coverage, 47511,
     /* 2211143 */     GIR_EraseRootFromParent_Done,
     /* 2211144 */   // Label 29117: @2211144
     /* 2211144 */   GIM_Reject,
     /* 2211145 */ // Label 29115: @2211145
     /* 2211145 */ GIM_Reject,
     /* 2211146 */ // Label 29055: @2211146
     /* 2211146 */ GIM_Reject,
     /* 2211147 */ // Label 40: @2211147
     /* 2211147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29135*/ GIMT_Encode4(2214621),
     /* 2211158 */ /*GILLT_s32*//*Label 29118*/ GIMT_Encode4(2211274),
     /* 2211162 */ /*GILLT_s64*//*Label 29119*/ GIMT_Encode4(2211448), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211174 */ /*GILLT_nxv1s16*//*Label 29120*/ GIMT_Encode4(2211612),
     /* 2211178 */ /*GILLT_nxv1s32*//*Label 29121*/ GIMT_Encode4(2211716),
     /* 2211182 */ /*GILLT_nxv1s64*//*Label 29122*/ GIMT_Encode4(2211933), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211194 */ /*GILLT_nxv2s16*//*Label 29123*/ GIMT_Encode4(2212258),
     /* 2211198 */ /*GILLT_nxv2s32*//*Label 29124*/ GIMT_Encode4(2212362),
     /* 2211202 */ /*GILLT_nxv2s64*//*Label 29125*/ GIMT_Encode4(2212579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211214 */ /*GILLT_nxv4s16*//*Label 29126*/ GIMT_Encode4(2212904),
     /* 2211218 */ /*GILLT_nxv4s32*//*Label 29127*/ GIMT_Encode4(2213008),
     /* 2211222 */ /*GILLT_nxv4s64*//*Label 29128*/ GIMT_Encode4(2213225), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211234 */ /*GILLT_nxv8s16*//*Label 29129*/ GIMT_Encode4(2213550),
     /* 2211238 */ /*GILLT_nxv8s32*//*Label 29130*/ GIMT_Encode4(2213654),
     /* 2211242 */ /*GILLT_nxv8s64*//*Label 29131*/ GIMT_Encode4(2213871), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211254 */ /*GILLT_nxv16s16*//*Label 29132*/ GIMT_Encode4(2214196),
     /* 2211258 */ /*GILLT_nxv16s32*//*Label 29133*/ GIMT_Encode4(2214300), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2211270 */ /*GILLT_nxv32s16*//*Label 29134*/ GIMT_Encode4(2214517),
     /* 2211274 */ // Label 29118: @2211274
     /* 2211274 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2211447),
     /* 2211279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211290 */   GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2211332), // Rule ID 65468 //
     /* 2211295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2211298 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2211298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2211301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211331 */     // GIR_Coverage, 65468,
     /* 2211331 */     GIR_EraseRootFromParent_Done,
     /* 2211332 */   // Label 29137: @2211332
     /* 2211332 */   GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2211374), // Rule ID 65470 //
     /* 2211337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211340 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211373 */     // GIR_Coverage, 65470,
     /* 2211373 */     GIR_EraseRootFromParent_Done,
     /* 2211374 */   // Label 29138: @2211374
     /* 2211374 */   GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2211416), // Rule ID 65471 //
     /* 2211379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2211382 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2211382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2211385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211415 */     // GIR_Coverage, 65471,
     /* 2211415 */     GIR_EraseRootFromParent_Done,
     /* 2211416 */   // Label 29139: @2211416
     /* 2211416 */   GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2211431), // Rule ID 65473 //
     /* 2211421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2211424 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2211424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211430 */     // GIR_Coverage, 65473,
     /* 2211430 */     GIR_Done,
     /* 2211431 */   // Label 29140: @2211431
     /* 2211431 */   GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2211446), // Rule ID 65474 //
     /* 2211436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2211439 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2211439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211445 */     // GIR_Coverage, 65474,
     /* 2211445 */     GIR_Done,
     /* 2211446 */   // Label 29141: @2211446
     /* 2211446 */   GIM_Reject,
     /* 2211447 */ // Label 29136: @2211447
     /* 2211447 */ GIM_Reject,
     /* 2211448 */ // Label 29119: @2211448
     /* 2211448 */ GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2211479), // Rule ID 65458 //
     /* 2211453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2211456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2211459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211467 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2211467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2211470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2211474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2211477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211478 */   // GIR_Coverage, 65458,
     /* 2211478 */   GIR_EraseRootFromParent_Done,
     /* 2211479 */ // Label 29142: @2211479
     /* 2211479 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2211532), // Rule ID 65467 //
     /* 2211484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2211487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211498 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2211498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211514 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211531 */   // GIR_Coverage, 65467,
     /* 2211531 */   GIR_EraseRootFromParent_Done,
     /* 2211532 */ // Label 29143: @2211532
     /* 2211532 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2211585), // Rule ID 65469 //
     /* 2211537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211551 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211563 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211567 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211584 */   // GIR_Coverage, 65469,
     /* 2211584 */   GIR_EraseRootFromParent_Done,
     /* 2211585 */ // Label 29144: @2211585
     /* 2211585 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2211611), // Rule ID 65475 //
     /* 2211590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2211593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211604 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2211604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211610 */   // GIR_Coverage, 65475,
     /* 2211610 */   GIR_Done,
     /* 2211611 */ // Label 29145: @2211611
     /* 2211611 */ GIM_Reject,
     /* 2211612 */ // Label 29120: @2211612
     /* 2211612 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2211715),
     /* 2211617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211628 */   GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2211671), // Rule ID 47548 //
     /* 2211633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211636 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211670 */     // GIR_Coverage, 47548,
     /* 2211670 */     GIR_EraseRootFromParent_Done,
     /* 2211671 */   // Label 29147: @2211671
     /* 2211671 */   GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2211714), // Rule ID 47549 //
     /* 2211676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211679 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211713 */     // GIR_Coverage, 47549,
     /* 2211713 */     GIR_EraseRootFromParent_Done,
     /* 2211714 */   // Label 29148: @2211714
     /* 2211714 */   GIM_Reject,
     /* 2211715 */ // Label 29146: @2211715
     /* 2211715 */ GIM_Reject,
     /* 2211716 */ // Label 29121: @2211716
     /* 2211716 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2211770), // Rule ID 47560 //
     /* 2211721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211735 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211769 */   // GIR_Coverage, 47560,
     /* 2211769 */   GIR_EraseRootFromParent_Done,
     /* 2211770 */ // Label 29149: @2211770
     /* 2211770 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2211824), // Rule ID 47561 //
     /* 2211775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211789 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211823 */   // GIR_Coverage, 47561,
     /* 2211823 */   GIR_EraseRootFromParent_Done,
     /* 2211824 */ // Label 29150: @2211824
     /* 2211824 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2211878), // Rule ID 47614 //
     /* 2211829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211843 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211877 */   // GIR_Coverage, 47614,
     /* 2211877 */   GIR_EraseRootFromParent_Done,
     /* 2211878 */ // Label 29151: @2211878
     /* 2211878 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2211932), // Rule ID 47615 //
     /* 2211883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211897 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211931 */   // GIR_Coverage, 47615,
     /* 2211931 */   GIR_EraseRootFromParent_Done,
     /* 2211932 */ // Label 29152: @2211932
     /* 2211932 */ GIM_Reject,
     /* 2211933 */ // Label 29122: @2211933
     /* 2211933 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2211987), // Rule ID 47570 //
     /* 2211938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211952 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211986 */   // GIR_Coverage, 47570,
     /* 2211986 */   GIR_EraseRootFromParent_Done,
     /* 2211987 */ // Label 29153: @2211987
     /* 2211987 */ GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2212041), // Rule ID 47571 //
     /* 2211992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212006 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212040 */   // GIR_Coverage, 47571,
     /* 2212040 */   GIR_EraseRootFromParent_Done,
     /* 2212041 */ // Label 29154: @2212041
     /* 2212041 */ GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2212095), // Rule ID 47624 //
     /* 2212046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212060 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212094 */   // GIR_Coverage, 47624,
     /* 2212094 */   GIR_EraseRootFromParent_Done,
     /* 2212095 */ // Label 29155: @2212095
     /* 2212095 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2212149), // Rule ID 47625 //
     /* 2212100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2212106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212114 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212148 */   // GIR_Coverage, 47625,
     /* 2212148 */   GIR_EraseRootFromParent_Done,
     /* 2212149 */ // Label 29156: @2212149
     /* 2212149 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2212203), // Rule ID 47648 //
     /* 2212154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212168 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2212185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212202 */   // GIR_Coverage, 47648,
     /* 2212202 */   GIR_EraseRootFromParent_Done,
     /* 2212203 */ // Label 29157: @2212203
     /* 2212203 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2212257), // Rule ID 47649 //
     /* 2212208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2212214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212222 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2212225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2212239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212256 */   // GIR_Coverage, 47649,
     /* 2212256 */   GIR_EraseRootFromParent_Done,
     /* 2212257 */ // Label 29158: @2212257
     /* 2212257 */ GIM_Reject,
     /* 2212258 */ // Label 29123: @2212258
     /* 2212258 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2212361),
     /* 2212263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212274 */   GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2212317), // Rule ID 47550 //
     /* 2212279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212282 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2212299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212316 */     // GIR_Coverage, 47550,
     /* 2212316 */     GIR_EraseRootFromParent_Done,
     /* 2212317 */   // Label 29160: @2212317
     /* 2212317 */   GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2212360), // Rule ID 47551 //
     /* 2212322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212325 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2212328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2212342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212359 */     // GIR_Coverage, 47551,
     /* 2212359 */     GIR_EraseRootFromParent_Done,
     /* 2212360 */   // Label 29161: @2212360
     /* 2212360 */   GIM_Reject,
     /* 2212361 */ // Label 29159: @2212361
     /* 2212361 */ GIM_Reject,
     /* 2212362 */ // Label 29124: @2212362
     /* 2212362 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2212416), // Rule ID 47562 //
     /* 2212367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212381 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212415 */   // GIR_Coverage, 47562,
     /* 2212415 */   GIR_EraseRootFromParent_Done,
     /* 2212416 */ // Label 29162: @2212416
     /* 2212416 */ GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2212470), // Rule ID 47563 //
     /* 2212421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212435 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212469 */   // GIR_Coverage, 47563,
     /* 2212469 */   GIR_EraseRootFromParent_Done,
     /* 2212470 */ // Label 29163: @2212470
     /* 2212470 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2212524), // Rule ID 47616 //
     /* 2212475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212489 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212523 */   // GIR_Coverage, 47616,
     /* 2212523 */   GIR_EraseRootFromParent_Done,
     /* 2212524 */ // Label 29164: @2212524
     /* 2212524 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2212578), // Rule ID 47617 //
     /* 2212529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212543 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212577 */   // GIR_Coverage, 47617,
     /* 2212577 */   GIR_EraseRootFromParent_Done,
     /* 2212578 */ // Label 29165: @2212578
     /* 2212578 */ GIM_Reject,
     /* 2212579 */ // Label 29125: @2212579
     /* 2212579 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2212633), // Rule ID 47572 //
     /* 2212584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212598 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212632 */   // GIR_Coverage, 47572,
     /* 2212632 */   GIR_EraseRootFromParent_Done,
     /* 2212633 */ // Label 29166: @2212633
     /* 2212633 */ GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2212687), // Rule ID 47573 //
     /* 2212638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212652 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212686 */   // GIR_Coverage, 47573,
     /* 2212686 */   GIR_EraseRootFromParent_Done,
     /* 2212687 */ // Label 29167: @2212687
     /* 2212687 */ GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2212741), // Rule ID 47626 //
     /* 2212692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212706 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212740 */   // GIR_Coverage, 47626,
     /* 2212740 */   GIR_EraseRootFromParent_Done,
     /* 2212741 */ // Label 29168: @2212741
     /* 2212741 */ GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2212795), // Rule ID 47627 //
     /* 2212746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212760 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212794 */   // GIR_Coverage, 47627,
     /* 2212794 */   GIR_EraseRootFromParent_Done,
     /* 2212795 */ // Label 29169: @2212795
     /* 2212795 */ GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2212849), // Rule ID 47650 //
     /* 2212800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212814 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212848 */   // GIR_Coverage, 47650,
     /* 2212848 */   GIR_EraseRootFromParent_Done,
     /* 2212849 */ // Label 29170: @2212849
     /* 2212849 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2212903), // Rule ID 47651 //
     /* 2212854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212868 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212902 */   // GIR_Coverage, 47651,
     /* 2212902 */   GIR_EraseRootFromParent_Done,
     /* 2212903 */ // Label 29171: @2212903
     /* 2212903 */ GIM_Reject,
     /* 2212904 */ // Label 29126: @2212904
     /* 2212904 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2213007),
     /* 2212909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212920 */   GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2212963), // Rule ID 47552 //
     /* 2212925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212928 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212962 */     // GIR_Coverage, 47552,
     /* 2212962 */     GIR_EraseRootFromParent_Done,
     /* 2212963 */   // Label 29173: @2212963
     /* 2212963 */   GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2213006), // Rule ID 47553 //
     /* 2212968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212971 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213005 */     // GIR_Coverage, 47553,
     /* 2213005 */     GIR_EraseRootFromParent_Done,
     /* 2213006 */   // Label 29174: @2213006
     /* 2213006 */   GIM_Reject,
     /* 2213007 */ // Label 29172: @2213007
     /* 2213007 */ GIM_Reject,
     /* 2213008 */ // Label 29127: @2213008
     /* 2213008 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2213062), // Rule ID 47564 //
     /* 2213013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213027 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213061 */   // GIR_Coverage, 47564,
     /* 2213061 */   GIR_EraseRootFromParent_Done,
     /* 2213062 */ // Label 29175: @2213062
     /* 2213062 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2213116), // Rule ID 47565 //
     /* 2213067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213081 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213103 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213115 */   // GIR_Coverage, 47565,
     /* 2213115 */   GIR_EraseRootFromParent_Done,
     /* 2213116 */ // Label 29176: @2213116
     /* 2213116 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2213170), // Rule ID 47618 //
     /* 2213121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213135 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2213152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213169 */   // GIR_Coverage, 47618,
     /* 2213169 */   GIR_EraseRootFromParent_Done,
     /* 2213170 */ // Label 29177: @2213170
     /* 2213170 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2213224), // Rule ID 47619 //
     /* 2213175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213189 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2213206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213223 */   // GIR_Coverage, 47619,
     /* 2213223 */   GIR_EraseRootFromParent_Done,
     /* 2213224 */ // Label 29178: @2213224
     /* 2213224 */ GIM_Reject,
     /* 2213225 */ // Label 29128: @2213225
     /* 2213225 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2213279), // Rule ID 47574 //
     /* 2213230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213244 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213278 */   // GIR_Coverage, 47574,
     /* 2213278 */   GIR_EraseRootFromParent_Done,
     /* 2213279 */ // Label 29179: @2213279
     /* 2213279 */ GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2213333), // Rule ID 47575 //
     /* 2213284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213298 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213332 */   // GIR_Coverage, 47575,
     /* 2213332 */   GIR_EraseRootFromParent_Done,
     /* 2213333 */ // Label 29180: @2213333
     /* 2213333 */ GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2213387), // Rule ID 47628 //
     /* 2213338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213352 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213386 */   // GIR_Coverage, 47628,
     /* 2213386 */   GIR_EraseRootFromParent_Done,
     /* 2213387 */ // Label 29181: @2213387
     /* 2213387 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2213441), // Rule ID 47629 //
     /* 2213392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213406 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213428 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213440 */   // GIR_Coverage, 47629,
     /* 2213440 */   GIR_EraseRootFromParent_Done,
     /* 2213441 */ // Label 29182: @2213441
     /* 2213441 */ GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2213495), // Rule ID 47652 //
     /* 2213446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213460 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213482 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213494 */   // GIR_Coverage, 47652,
     /* 2213494 */   GIR_EraseRootFromParent_Done,
     /* 2213495 */ // Label 29183: @2213495
     /* 2213495 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2213549), // Rule ID 47653 //
     /* 2213500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213514 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213548 */   // GIR_Coverage, 47653,
     /* 2213548 */   GIR_EraseRootFromParent_Done,
     /* 2213549 */ // Label 29184: @2213549
     /* 2213549 */ GIM_Reject,
     /* 2213550 */ // Label 29129: @2213550
     /* 2213550 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2213653),
     /* 2213555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213566 */   GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2213609), // Rule ID 47554 //
     /* 2213571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213574 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213608 */     // GIR_Coverage, 47554,
     /* 2213608 */     GIR_EraseRootFromParent_Done,
     /* 2213609 */   // Label 29186: @2213609
     /* 2213609 */   GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2213652), // Rule ID 47555 //
     /* 2213614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213617 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213651 */     // GIR_Coverage, 47555,
     /* 2213651 */     GIR_EraseRootFromParent_Done,
     /* 2213652 */   // Label 29187: @2213652
     /* 2213652 */   GIM_Reject,
     /* 2213653 */ // Label 29185: @2213653
     /* 2213653 */ GIM_Reject,
     /* 2213654 */ // Label 29130: @2213654
     /* 2213654 */ GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2213708), // Rule ID 47566 //
     /* 2213659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213673 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213707 */   // GIR_Coverage, 47566,
     /* 2213707 */   GIR_EraseRootFromParent_Done,
     /* 2213708 */ // Label 29188: @2213708
     /* 2213708 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2213762), // Rule ID 47567 //
     /* 2213713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213727 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213749 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213760 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213761 */   // GIR_Coverage, 47567,
     /* 2213761 */   GIR_EraseRootFromParent_Done,
     /* 2213762 */ // Label 29189: @2213762
     /* 2213762 */ GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2213816), // Rule ID 47620 //
     /* 2213767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213781 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213815 */   // GIR_Coverage, 47620,
     /* 2213815 */   GIR_EraseRootFromParent_Done,
     /* 2213816 */ // Label 29190: @2213816
     /* 2213816 */ GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2213870), // Rule ID 47621 //
     /* 2213821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213835 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213869 */   // GIR_Coverage, 47621,
     /* 2213869 */   GIR_EraseRootFromParent_Done,
     /* 2213870 */ // Label 29191: @2213870
     /* 2213870 */ GIM_Reject,
     /* 2213871 */ // Label 29131: @2213871
     /* 2213871 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2213925), // Rule ID 47576 //
     /* 2213876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213890 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213924 */   // GIR_Coverage, 47576,
     /* 2213924 */   GIR_EraseRootFromParent_Done,
     /* 2213925 */ // Label 29192: @2213925
     /* 2213925 */ GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2213979), // Rule ID 47577 //
     /* 2213930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213944 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213978 */   // GIR_Coverage, 47577,
     /* 2213978 */   GIR_EraseRootFromParent_Done,
     /* 2213979 */ // Label 29193: @2213979
     /* 2213979 */ GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2214033), // Rule ID 47630 //
     /* 2213984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213998 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214032 */   // GIR_Coverage, 47630,
     /* 2214032 */   GIR_EraseRootFromParent_Done,
     /* 2214033 */ // Label 29194: @2214033
     /* 2214033 */ GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2214087), // Rule ID 47631 //
     /* 2214038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214052 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214086 */   // GIR_Coverage, 47631,
     /* 2214086 */   GIR_EraseRootFromParent_Done,
     /* 2214087 */ // Label 29195: @2214087
     /* 2214087 */ GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2214141), // Rule ID 47654 //
     /* 2214092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2214095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214106 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2214123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214128 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214140 */   // GIR_Coverage, 47654,
     /* 2214140 */   GIR_EraseRootFromParent_Done,
     /* 2214141 */ // Label 29196: @2214141
     /* 2214141 */ GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2214195), // Rule ID 47655 //
     /* 2214146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214160 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2214163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2214177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214182 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214194 */   // GIR_Coverage, 47655,
     /* 2214194 */   GIR_EraseRootFromParent_Done,
     /* 2214195 */ // Label 29197: @2214195
     /* 2214195 */ GIM_Reject,
     /* 2214196 */ // Label 29132: @2214196
     /* 2214196 */ GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2214299),
     /* 2214201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214212 */   GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2214255), // Rule ID 47556 //
     /* 2214217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214220 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2214237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214254 */     // GIR_Coverage, 47556,
     /* 2214254 */     GIR_EraseRootFromParent_Done,
     /* 2214255 */   // Label 29199: @2214255
     /* 2214255 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2214298), // Rule ID 47557 //
     /* 2214260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214263 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2214266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2214280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214297 */     // GIR_Coverage, 47557,
     /* 2214297 */     GIR_EraseRootFromParent_Done,
     /* 2214298 */   // Label 29200: @2214298
     /* 2214298 */   GIM_Reject,
     /* 2214299 */ // Label 29198: @2214299
     /* 2214299 */ GIM_Reject,
     /* 2214300 */ // Label 29133: @2214300
     /* 2214300 */ GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2214354), // Rule ID 47568 //
     /* 2214305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214319 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214341 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214353 */   // GIR_Coverage, 47568,
     /* 2214353 */   GIR_EraseRootFromParent_Done,
     /* 2214354 */ // Label 29201: @2214354
     /* 2214354 */ GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2214408), // Rule ID 47569 //
     /* 2214359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2214365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214373 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214395 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214407 */   // GIR_Coverage, 47569,
     /* 2214407 */   GIR_EraseRootFromParent_Done,
     /* 2214408 */ // Label 29202: @2214408
     /* 2214408 */ GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2214462), // Rule ID 47622 //
     /* 2214413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214427 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214461 */   // GIR_Coverage, 47622,
     /* 2214461 */   GIR_EraseRootFromParent_Done,
     /* 2214462 */ // Label 29203: @2214462
     /* 2214462 */ GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2214516), // Rule ID 47623 //
     /* 2214467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214481 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214515 */   // GIR_Coverage, 47623,
     /* 2214515 */   GIR_EraseRootFromParent_Done,
     /* 2214516 */ // Label 29204: @2214516
     /* 2214516 */ GIM_Reject,
     /* 2214517 */ // Label 29134: @2214517
     /* 2214517 */ GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2214620),
     /* 2214522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2214525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214533 */   GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2214576), // Rule ID 47558 //
     /* 2214538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214541 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214575 */     // GIR_Coverage, 47558,
     /* 2214575 */     GIR_EraseRootFromParent_Done,
     /* 2214576 */   // Label 29206: @2214576
     /* 2214576 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2214619), // Rule ID 47559 //
     /* 2214581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214584 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214618 */     // GIR_Coverage, 47559,
     /* 2214618 */     GIR_EraseRootFromParent_Done,
     /* 2214619 */   // Label 29207: @2214619
     /* 2214619 */   GIM_Reject,
     /* 2214620 */ // Label 29205: @2214620
     /* 2214620 */ GIM_Reject,
     /* 2214621 */ // Label 29135: @2214621
     /* 2214621 */ GIM_Reject,
     /* 2214622 */ // Label 41: @2214622
     /* 2214622 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29210*/ GIMT_Encode4(2215664),
     /* 2214633 */ /*GILLT_s32*//*Label 29208*/ GIMT_Encode4(2214641),
     /* 2214637 */ /*GILLT_s64*//*Label 29209*/ GIMT_Encode4(2215299),
     /* 2214641 */ // Label 29208: @2214641
     /* 2214641 */ GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2215298),
     /* 2214646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214649 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2214685), // Rule ID 64474 //
     /* 2214654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214665 */     // MIs[0] Operand 2
     /* 2214665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214676 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214684 */     // GIR_Coverage, 64474,
     /* 2214684 */     GIR_EraseRootFromParent_Done,
     /* 2214685 */   // Label 29212: @2214685
     /* 2214685 */   GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2214721), // Rule ID 64476 //
     /* 2214690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214701 */     // MIs[0] Operand 2
     /* 2214701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214712 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214720 */     // GIR_Coverage, 64476,
     /* 2214720 */     GIR_EraseRootFromParent_Done,
     /* 2214721 */   // Label 29213: @2214721
     /* 2214721 */   GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2214757), // Rule ID 2527 //
     /* 2214726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214737 */     // MIs[0] Operand 2
     /* 2214737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214748 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214756 */     // GIR_Coverage, 2527,
     /* 2214756 */     GIR_EraseRootFromParent_Done,
     /* 2214757 */   // Label 29214: @2214757
     /* 2214757 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2214793), // Rule ID 2529 //
     /* 2214762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214773 */     // MIs[0] Operand 2
     /* 2214773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214784 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214792 */     // GIR_Coverage, 2529,
     /* 2214792 */     GIR_EraseRootFromParent_Done,
     /* 2214793 */   // Label 29215: @2214793
     /* 2214793 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2214835), // Rule ID 62560 //
     /* 2214798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214809 */     // MIs[0] Operand 2
     /* 2214809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214820 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214834 */     // GIR_Coverage, 62560,
     /* 2214834 */     GIR_EraseRootFromParent_Done,
     /* 2214835 */   // Label 29216: @2214835
     /* 2214835 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2214877), // Rule ID 62562 //
     /* 2214840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214851 */     // MIs[0] Operand 2
     /* 2214851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214862 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214876 */     // GIR_Coverage, 62562,
     /* 2214876 */     GIR_EraseRootFromParent_Done,
     /* 2214877 */   // Label 29217: @2214877
     /* 2214877 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2214919), // Rule ID 62564 //
     /* 2214882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214893 */     // MIs[0] Operand 2
     /* 2214893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214904 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214918 */     // GIR_Coverage, 62564,
     /* 2214918 */     GIR_EraseRootFromParent_Done,
     /* 2214919 */   // Label 29218: @2214919
     /* 2214919 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2214961), // Rule ID 64621 //
     /* 2214924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2214927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214935 */     // MIs[0] Operand 2
     /* 2214935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214946 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214960 */     // GIR_Coverage, 64621,
     /* 2214960 */     GIR_EraseRootFromParent_Done,
     /* 2214961 */   // Label 29219: @2214961
     /* 2214961 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2215003), // Rule ID 64622 //
     /* 2214966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2214969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214977 */     // MIs[0] Operand 2
     /* 2214977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214988 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215002 */     // GIR_Coverage, 64622,
     /* 2215002 */     GIR_EraseRootFromParent_Done,
     /* 2215003 */   // Label 29220: @2215003
     /* 2215003 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2215045), // Rule ID 64637 //
     /* 2215008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215019 */     // MIs[0] Operand 2
     /* 2215019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215030 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215044 */     // GIR_Coverage, 64637,
     /* 2215044 */     GIR_EraseRootFromParent_Done,
     /* 2215045 */   // Label 29221: @2215045
     /* 2215045 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2215087), // Rule ID 64638 //
     /* 2215050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215061 */     // MIs[0] Operand 2
     /* 2215061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215072 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215086 */     // GIR_Coverage, 64638,
     /* 2215086 */     GIR_EraseRootFromParent_Done,
     /* 2215087 */   // Label 29222: @2215087
     /* 2215087 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2215129), // Rule ID 64639 //
     /* 2215092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215103 */     // MIs[0] Operand 2
     /* 2215103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215114 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2215124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215128 */     // GIR_Coverage, 64639,
     /* 2215128 */     GIR_EraseRootFromParent_Done,
     /* 2215129 */   // Label 29223: @2215129
     /* 2215129 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2215171), // Rule ID 64640 //
     /* 2215134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2215141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215145 */     // MIs[0] Operand 2
     /* 2215145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215156 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2215159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2215166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215170 */     // GIR_Coverage, 64640,
     /* 2215170 */     GIR_EraseRootFromParent_Done,
     /* 2215171 */   // Label 29224: @2215171
     /* 2215171 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2215213), // Rule ID 65103 //
     /* 2215176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215187 */     // MIs[0] Operand 2
     /* 2215187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215198 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215212 */     // GIR_Coverage, 65103,
     /* 2215212 */     GIR_EraseRootFromParent_Done,
     /* 2215213 */   // Label 29225: @2215213
     /* 2215213 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2215255), // Rule ID 65105 //
     /* 2215218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215229 */     // MIs[0] Operand 2
     /* 2215229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215240 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215254 */     // GIR_Coverage, 65105,
     /* 2215254 */     GIR_EraseRootFromParent_Done,
     /* 2215255 */   // Label 29226: @2215255
     /* 2215255 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2215297), // Rule ID 65107 //
     /* 2215260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2215263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215271 */     // MIs[0] Operand 2
     /* 2215271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215282 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2215282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215296 */     // GIR_Coverage, 65107,
     /* 2215296 */     GIR_EraseRootFromParent_Done,
     /* 2215297 */   // Label 29227: @2215297
     /* 2215297 */   GIM_Reject,
     /* 2215298 */ // Label 29211: @2215298
     /* 2215298 */ GIM_Reject,
     /* 2215299 */ // Label 29209: @2215299
     /* 2215299 */ GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2215663),
     /* 2215304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2215307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215315 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2215343), // Rule ID 64473 //
     /* 2215320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2215323 */     // MIs[0] Operand 2
     /* 2215323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215334 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2215337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215342 */     // GIR_Coverage, 64473,
     /* 2215342 */     GIR_EraseRootFromParent_Done,
     /* 2215343 */   // Label 29229: @2215343
     /* 2215343 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2215371), // Rule ID 64475 //
     /* 2215348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2215351 */     // MIs[0] Operand 2
     /* 2215351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215362 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2215365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215370 */     // GIR_Coverage, 64475,
     /* 2215370 */     GIR_EraseRootFromParent_Done,
     /* 2215371 */   // Label 29230: @2215371
     /* 2215371 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2215402), // Rule ID 266 //
     /* 2215376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2215379 */     // MIs[0] Operand 2
     /* 2215379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2215390 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2215390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2215393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215401 */     // GIR_Coverage, 266,
     /* 2215401 */     GIR_EraseRootFromParent_Done,
     /* 2215402 */   // Label 29231: @2215402
     /* 2215402 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2215430), // Rule ID 2526 //
     /* 2215407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2215410 */     // MIs[0] Operand 2
     /* 2215410 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215421 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2215424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215429 */     // GIR_Coverage, 2526,
     /* 2215429 */     GIR_EraseRootFromParent_Done,
     /* 2215430 */   // Label 29232: @2215430
     /* 2215430 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2215458), // Rule ID 2528 //
     /* 2215435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2215438 */     // MIs[0] Operand 2
     /* 2215438 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215449 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2215449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2215452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215457 */     // GIR_Coverage, 2528,
     /* 2215457 */     GIR_EraseRootFromParent_Done,
     /* 2215458 */   // Label 29233: @2215458
     /* 2215458 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2215492), // Rule ID 62559 //
     /* 2215463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215466 */     // MIs[0] Operand 2
     /* 2215466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215477 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215491 */     // GIR_Coverage, 62559,
     /* 2215491 */     GIR_EraseRootFromParent_Done,
     /* 2215492 */   // Label 29234: @2215492
     /* 2215492 */   GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2215526), // Rule ID 62561 //
     /* 2215497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215500 */     // MIs[0] Operand 2
     /* 2215500 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215511 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215525 */     // GIR_Coverage, 62561,
     /* 2215525 */     GIR_EraseRootFromParent_Done,
     /* 2215526 */   // Label 29235: @2215526
     /* 2215526 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2215560), // Rule ID 62563 //
     /* 2215531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215534 */     // MIs[0] Operand 2
     /* 2215534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215545 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215559 */     // GIR_Coverage, 62563,
     /* 2215559 */     GIR_EraseRootFromParent_Done,
     /* 2215560 */   // Label 29236: @2215560
     /* 2215560 */   GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2215594), // Rule ID 65102 //
     /* 2215565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215568 */     // MIs[0] Operand 2
     /* 2215568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215579 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215593 */     // GIR_Coverage, 65102,
     /* 2215593 */     GIR_EraseRootFromParent_Done,
     /* 2215594 */   // Label 29237: @2215594
     /* 2215594 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2215628), // Rule ID 65104 //
     /* 2215599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215602 */     // MIs[0] Operand 2
     /* 2215602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215613 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215627 */     // GIR_Coverage, 65104,
     /* 2215627 */     GIR_EraseRootFromParent_Done,
     /* 2215628 */   // Label 29238: @2215628
     /* 2215628 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2215662), // Rule ID 65106 //
     /* 2215633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215636 */     // MIs[0] Operand 2
     /* 2215636 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215647 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215661 */     // GIR_Coverage, 65106,
     /* 2215661 */     GIR_EraseRootFromParent_Done,
     /* 2215662 */   // Label 29239: @2215662
     /* 2215662 */   GIM_Reject,
     /* 2215663 */ // Label 29228: @2215663
     /* 2215663 */ GIM_Reject,
     /* 2215664 */ // Label 29210: @2215664
     /* 2215664 */ GIM_Reject,
     /* 2215665 */ // Label 42: @2215665
     /* 2215665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29257*/ GIMT_Encode4(2219351),
     /* 2215676 */ /*GILLT_s32*//*Label 29240*/ GIMT_Encode4(2215792),
     /* 2215680 */ /*GILLT_s64*//*Label 29241*/ GIMT_Encode4(2216088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215692 */ /*GILLT_nxv1s16*//*Label 29242*/ GIMT_Encode4(2216342),
     /* 2215696 */ /*GILLT_nxv1s32*//*Label 29243*/ GIMT_Encode4(2216446),
     /* 2215700 */ /*GILLT_nxv1s64*//*Label 29244*/ GIMT_Encode4(2216663), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215712 */ /*GILLT_nxv2s16*//*Label 29245*/ GIMT_Encode4(2216988),
     /* 2215716 */ /*GILLT_nxv2s32*//*Label 29246*/ GIMT_Encode4(2217092),
     /* 2215720 */ /*GILLT_nxv2s64*//*Label 29247*/ GIMT_Encode4(2217309), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215732 */ /*GILLT_nxv4s16*//*Label 29248*/ GIMT_Encode4(2217634),
     /* 2215736 */ /*GILLT_nxv4s32*//*Label 29249*/ GIMT_Encode4(2217738),
     /* 2215740 */ /*GILLT_nxv4s64*//*Label 29250*/ GIMT_Encode4(2217955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215752 */ /*GILLT_nxv8s16*//*Label 29251*/ GIMT_Encode4(2218280),
     /* 2215756 */ /*GILLT_nxv8s32*//*Label 29252*/ GIMT_Encode4(2218384),
     /* 2215760 */ /*GILLT_nxv8s64*//*Label 29253*/ GIMT_Encode4(2218601), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215772 */ /*GILLT_nxv16s16*//*Label 29254*/ GIMT_Encode4(2218926),
     /* 2215776 */ /*GILLT_nxv16s32*//*Label 29255*/ GIMT_Encode4(2219030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215788 */ /*GILLT_nxv32s16*//*Label 29256*/ GIMT_Encode4(2219247),
     /* 2215792 */ // Label 29240: @2215792
     /* 2215792 */ GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2216087),
     /* 2215797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215808 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2215850), // Rule ID 65463 //
     /* 2215813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215816 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2215816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215849 */     // GIR_Coverage, 65463,
     /* 2215849 */     GIR_EraseRootFromParent_Done,
     /* 2215850 */   // Label 29259: @2215850
     /* 2215850 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2215892), // Rule ID 65465 //
     /* 2215855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215858 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215891 */     // GIR_Coverage, 65465,
     /* 2215891 */     GIR_EraseRootFromParent_Done,
     /* 2215892 */   // Label 29260: @2215892
     /* 2215892 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2215934), // Rule ID 65466 //
     /* 2215897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215900 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2215900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215933 */     // GIR_Coverage, 65466,
     /* 2215933 */     GIR_EraseRootFromParent_Done,
     /* 2215934 */   // Label 29261: @2215934
     /* 2215934 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2215949), // Rule ID 65476 //
     /* 2215939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2215942 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215948 */     // GIR_Coverage, 65476,
     /* 2215948 */     GIR_Done,
     /* 2215949 */   // Label 29262: @2215949
     /* 2215949 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2215964), // Rule ID 65477 //
     /* 2215954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2215957 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215963 */     // GIR_Coverage, 65477,
     /* 2215963 */     GIR_Done,
     /* 2215964 */   // Label 29263: @2215964
     /* 2215964 */   GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2215979), // Rule ID 65479 //
     /* 2215969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215972 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215978 */     // GIR_Coverage, 65479,
     /* 2215978 */     GIR_Done,
     /* 2215979 */   // Label 29264: @2215979
     /* 2215979 */   GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2215994), // Rule ID 65480 //
     /* 2215984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2215987 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215993 */     // GIR_Coverage, 65480,
     /* 2215993 */     GIR_Done,
     /* 2215994 */   // Label 29265: @2215994
     /* 2215994 */   GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2216017), // Rule ID 65481 //
     /* 2215999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2216002 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2216005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216016 */     // GIR_Coverage, 65481,
     /* 2216016 */     GIR_EraseRootFromParent_Done,
     /* 2216017 */   // Label 29266: @2216017
     /* 2216017 */   GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2216040), // Rule ID 65482 //
     /* 2216022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2216025 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2216025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2216028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216039 */     // GIR_Coverage, 65482,
     /* 2216039 */     GIR_EraseRootFromParent_Done,
     /* 2216040 */   // Label 29267: @2216040
     /* 2216040 */   GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2216063), // Rule ID 65484 //
     /* 2216045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2216048 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216062 */     // GIR_Coverage, 65484,
     /* 2216062 */     GIR_EraseRootFromParent_Done,
     /* 2216063 */   // Label 29268: @2216063
     /* 2216063 */   GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2216086), // Rule ID 65485 //
     /* 2216068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2216071 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2216071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216085 */     // GIR_Coverage, 65485,
     /* 2216085 */     GIR_EraseRootFromParent_Done,
     /* 2216086 */   // Label 29269: @2216086
     /* 2216086 */   GIM_Reject,
     /* 2216087 */ // Label 29258: @2216087
     /* 2216087 */ GIM_Reject,
     /* 2216088 */ // Label 29241: @2216088
     /* 2216088 */ GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2216141), // Rule ID 65461 //
     /* 2216093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2216096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216107 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2216107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216119 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216123 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2216126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2216139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216140 */   // GIR_Coverage, 65461,
     /* 2216140 */   GIR_EraseRootFromParent_Done,
     /* 2216141 */ // Label 29270: @2216141
     /* 2216141 */ GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2216194), // Rule ID 65462 //
     /* 2216146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2216149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216160 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2216160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216176 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2216179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2216192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216193 */   // GIR_Coverage, 65462,
     /* 2216193 */   GIR_EraseRootFromParent_Done,
     /* 2216194 */ // Label 29271: @2216194
     /* 2216194 */ GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2216247), // Rule ID 65464 //
     /* 2216199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2216202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216213 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2216213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2216216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2216220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2216229 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2216232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2216237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2216245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216246 */   // GIR_Coverage, 65464,
     /* 2216246 */   GIR_EraseRootFromParent_Done,
     /* 2216247 */ // Label 29272: @2216247
     /* 2216247 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2216281), // Rule ID 65472 //
     /* 2216252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2216255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216266 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2216266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2216269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216271 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2216273 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216280 */   // GIR_Coverage, 65472,
     /* 2216280 */   GIR_EraseRootFromParent_Done,
     /* 2216281 */ // Label 29273: @2216281
     /* 2216281 */ GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2216307), // Rule ID 65478 //
     /* 2216286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2216289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216300 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2216300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2216305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216306 */   // GIR_Coverage, 65478,
     /* 2216306 */   GIR_Done,
     /* 2216307 */ // Label 29274: @2216307
     /* 2216307 */ GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2216341), // Rule ID 65483 //
     /* 2216312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2216315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2216318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216326 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2216326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2216329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2216333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2216339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216340 */   // GIR_Coverage, 65483,
     /* 2216340 */   GIR_EraseRootFromParent_Done,
     /* 2216341 */ // Label 29275: @2216341
     /* 2216341 */ GIM_Reject,
     /* 2216342 */ // Label 29242: @2216342
     /* 2216342 */ GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2216445),
     /* 2216347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216358 */   GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2216401), // Rule ID 45800 //
     /* 2216363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216366 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2216369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2216383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216400 */     // GIR_Coverage, 45800,
     /* 2216400 */     GIR_EraseRootFromParent_Done,
     /* 2216401 */   // Label 29277: @2216401
     /* 2216401 */   GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2216444), // Rule ID 45801 //
     /* 2216406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216409 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2216412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2216426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216443 */     // GIR_Coverage, 45801,
     /* 2216443 */     GIR_EraseRootFromParent_Done,
     /* 2216444 */   // Label 29278: @2216444
     /* 2216444 */   GIM_Reject,
     /* 2216445 */ // Label 29276: @2216445
     /* 2216445 */ GIM_Reject,
     /* 2216446 */ // Label 29243: @2216446
     /* 2216446 */ GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2216500), // Rule ID 47512 //
     /* 2216451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216465 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216499 */   // GIR_Coverage, 47512,
     /* 2216499 */   GIR_EraseRootFromParent_Done,
     /* 2216500 */ // Label 29279: @2216500
     /* 2216500 */ GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2216554), // Rule ID 47513 //
     /* 2216505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216519 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216553 */   // GIR_Coverage, 47513,
     /* 2216553 */   GIR_EraseRootFromParent_Done,
     /* 2216554 */ // Label 29280: @2216554
     /* 2216554 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2216608), // Rule ID 47578 //
     /* 2216559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216573 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216607 */   // GIR_Coverage, 47578,
     /* 2216607 */   GIR_EraseRootFromParent_Done,
     /* 2216608 */ // Label 29281: @2216608
     /* 2216608 */ GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2216662), // Rule ID 47579 //
     /* 2216613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216627 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216649 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216661 */   // GIR_Coverage, 47579,
     /* 2216661 */   GIR_EraseRootFromParent_Done,
     /* 2216662 */ // Label 29282: @2216662
     /* 2216662 */ GIM_Reject,
     /* 2216663 */ // Label 29244: @2216663
     /* 2216663 */ GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2216717), // Rule ID 47532 //
     /* 2216668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216682 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216716 */   // GIR_Coverage, 47532,
     /* 2216716 */   GIR_EraseRootFromParent_Done,
     /* 2216717 */ // Label 29283: @2216717
     /* 2216717 */ GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2216771), // Rule ID 47533 //
     /* 2216722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216736 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216770 */   // GIR_Coverage, 47533,
     /* 2216770 */   GIR_EraseRootFromParent_Done,
     /* 2216771 */ // Label 29284: @2216771
     /* 2216771 */ GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2216825), // Rule ID 47598 //
     /* 2216776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216790 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216824 */   // GIR_Coverage, 47598,
     /* 2216824 */   GIR_EraseRootFromParent_Done,
     /* 2216825 */ // Label 29285: @2216825
     /* 2216825 */ GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2216879), // Rule ID 47599 //
     /* 2216830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216844 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216878 */   // GIR_Coverage, 47599,
     /* 2216878 */   GIR_EraseRootFromParent_Done,
     /* 2216879 */ // Label 29286: @2216879
     /* 2216879 */ GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2216933), // Rule ID 47632 //
     /* 2216884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216898 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216932 */   // GIR_Coverage, 47632,
     /* 2216932 */   GIR_EraseRootFromParent_Done,
     /* 2216933 */ // Label 29287: @2216933
     /* 2216933 */ GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2216987), // Rule ID 47633 //
     /* 2216938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216952 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216974 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216986 */   // GIR_Coverage, 47633,
     /* 2216986 */   GIR_EraseRootFromParent_Done,
     /* 2216987 */ // Label 29288: @2216987
     /* 2216987 */ GIM_Reject,
     /* 2216988 */ // Label 29245: @2216988
     /* 2216988 */ GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2217091),
     /* 2216993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217004 */   GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2217047), // Rule ID 47492 //
     /* 2217009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217012 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2217029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217046 */     // GIR_Coverage, 47492,
     /* 2217046 */     GIR_EraseRootFromParent_Done,
     /* 2217047 */   // Label 29290: @2217047
     /* 2217047 */   GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2217090), // Rule ID 47493 //
     /* 2217052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217055 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2217072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217089 */     // GIR_Coverage, 47493,
     /* 2217089 */     GIR_EraseRootFromParent_Done,
     /* 2217090 */   // Label 29291: @2217090
     /* 2217090 */   GIM_Reject,
     /* 2217091 */ // Label 29289: @2217091
     /* 2217091 */ GIM_Reject,
     /* 2217092 */ // Label 29246: @2217092
     /* 2217092 */ GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2217146), // Rule ID 47516 //
     /* 2217097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217111 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217145 */   // GIR_Coverage, 47516,
     /* 2217145 */   GIR_EraseRootFromParent_Done,
     /* 2217146 */ // Label 29292: @2217146
     /* 2217146 */ GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2217200), // Rule ID 47517 //
     /* 2217151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217165 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217199 */   // GIR_Coverage, 47517,
     /* 2217199 */   GIR_EraseRootFromParent_Done,
     /* 2217200 */ // Label 29293: @2217200
     /* 2217200 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2217254), // Rule ID 47582 //
     /* 2217205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217219 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2217236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217253 */   // GIR_Coverage, 47582,
     /* 2217253 */   GIR_EraseRootFromParent_Done,
     /* 2217254 */ // Label 29294: @2217254
     /* 2217254 */ GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2217308), // Rule ID 47583 //
     /* 2217259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217273 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2217290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217307 */   // GIR_Coverage, 47583,
     /* 2217307 */   GIR_EraseRootFromParent_Done,
     /* 2217308 */ // Label 29295: @2217308
     /* 2217308 */ GIM_Reject,
     /* 2217309 */ // Label 29247: @2217309
     /* 2217309 */ GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2217363), // Rule ID 47536 //
     /* 2217314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2217320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217328 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217362 */   // GIR_Coverage, 47536,
     /* 2217362 */   GIR_EraseRootFromParent_Done,
     /* 2217363 */ // Label 29296: @2217363
     /* 2217363 */ GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2217417), // Rule ID 47537 //
     /* 2217368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2217374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217382 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217416 */   // GIR_Coverage, 47537,
     /* 2217416 */   GIR_EraseRootFromParent_Done,
     /* 2217417 */ // Label 29297: @2217417
     /* 2217417 */ GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2217471), // Rule ID 47602 //
     /* 2217422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217436 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217470 */   // GIR_Coverage, 47602,
     /* 2217470 */   GIR_EraseRootFromParent_Done,
     /* 2217471 */ // Label 29298: @2217471
     /* 2217471 */ GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2217525), // Rule ID 47603 //
     /* 2217476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217490 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217524 */   // GIR_Coverage, 47603,
     /* 2217524 */   GIR_EraseRootFromParent_Done,
     /* 2217525 */ // Label 29299: @2217525
     /* 2217525 */ GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2217579), // Rule ID 47636 //
     /* 2217530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217544 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217578 */   // GIR_Coverage, 47636,
     /* 2217578 */   GIR_EraseRootFromParent_Done,
     /* 2217579 */ // Label 29300: @2217579
     /* 2217579 */ GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2217633), // Rule ID 47637 //
     /* 2217584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217598 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217632 */   // GIR_Coverage, 47637,
     /* 2217632 */   GIR_EraseRootFromParent_Done,
     /* 2217633 */ // Label 29301: @2217633
     /* 2217633 */ GIM_Reject,
     /* 2217634 */ // Label 29248: @2217634
     /* 2217634 */ GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2217737),
     /* 2217639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217650 */   GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2217693), // Rule ID 47496 //
     /* 2217655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217658 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217692 */     // GIR_Coverage, 47496,
     /* 2217692 */     GIR_EraseRootFromParent_Done,
     /* 2217693 */   // Label 29303: @2217693
     /* 2217693 */   GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2217736), // Rule ID 47497 //
     /* 2217698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217701 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217735 */     // GIR_Coverage, 47497,
     /* 2217735 */     GIR_EraseRootFromParent_Done,
     /* 2217736 */   // Label 29304: @2217736
     /* 2217736 */   GIM_Reject,
     /* 2217737 */ // Label 29302: @2217737
     /* 2217737 */ GIM_Reject,
     /* 2217738 */ // Label 29249: @2217738
     /* 2217738 */ GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2217792), // Rule ID 47520 //
     /* 2217743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217757 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217791 */   // GIR_Coverage, 47520,
     /* 2217791 */   GIR_EraseRootFromParent_Done,
     /* 2217792 */ // Label 29305: @2217792
     /* 2217792 */ GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2217846), // Rule ID 47521 //
     /* 2217797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217811 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217833 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217845 */   // GIR_Coverage, 47521,
     /* 2217845 */   GIR_EraseRootFromParent_Done,
     /* 2217846 */ // Label 29306: @2217846
     /* 2217846 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2217900), // Rule ID 47586 //
     /* 2217851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217865 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217899 */   // GIR_Coverage, 47586,
     /* 2217899 */   GIR_EraseRootFromParent_Done,
     /* 2217900 */ // Label 29307: @2217900
     /* 2217900 */ GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2217954), // Rule ID 47587 //
     /* 2217905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217919 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217953 */   // GIR_Coverage, 47587,
     /* 2217953 */   GIR_EraseRootFromParent_Done,
     /* 2217954 */ // Label 29308: @2217954
     /* 2217954 */ GIM_Reject,
     /* 2217955 */ // Label 29250: @2217955
     /* 2217955 */ GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2218009), // Rule ID 47540 //
     /* 2217960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217974 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217996 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218008 */   // GIR_Coverage, 47540,
     /* 2218008 */   GIR_EraseRootFromParent_Done,
     /* 2218009 */ // Label 29309: @2218009
     /* 2218009 */ GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2218063), // Rule ID 47541 //
     /* 2218014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2218020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218028 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218050 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218062 */   // GIR_Coverage, 47541,
     /* 2218062 */   GIR_EraseRootFromParent_Done,
     /* 2218063 */ // Label 29310: @2218063
     /* 2218063 */ GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2218117), // Rule ID 47606 //
     /* 2218068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218082 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218116 */   // GIR_Coverage, 47606,
     /* 2218116 */   GIR_EraseRootFromParent_Done,
     /* 2218117 */ // Label 29311: @2218117
     /* 2218117 */ GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2218171), // Rule ID 47607 //
     /* 2218122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218136 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218170 */   // GIR_Coverage, 47607,
     /* 2218170 */   GIR_EraseRootFromParent_Done,
     /* 2218171 */ // Label 29312: @2218171
     /* 2218171 */ GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2218225), // Rule ID 47640 //
     /* 2218176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2218182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218190 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2218207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218212 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218224 */   // GIR_Coverage, 47640,
     /* 2218224 */   GIR_EraseRootFromParent_Done,
     /* 2218225 */ // Label 29313: @2218225
     /* 2218225 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2218279), // Rule ID 47641 //
     /* 2218230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2218236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218244 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2218261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218278 */   // GIR_Coverage, 47641,
     /* 2218278 */   GIR_EraseRootFromParent_Done,
     /* 2218279 */ // Label 29314: @2218279
     /* 2218279 */ GIM_Reject,
     /* 2218280 */ // Label 29251: @2218280
     /* 2218280 */ GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2218383),
     /* 2218285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218296 */   GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2218339), // Rule ID 47500 //
     /* 2218301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218304 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2218321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218338 */     // GIR_Coverage, 47500,
     /* 2218338 */     GIR_EraseRootFromParent_Done,
     /* 2218339 */   // Label 29316: @2218339
     /* 2218339 */   GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2218382), // Rule ID 47501 //
     /* 2218344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218347 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2218364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218381 */     // GIR_Coverage, 47501,
     /* 2218381 */     GIR_EraseRootFromParent_Done,
     /* 2218382 */   // Label 29317: @2218382
     /* 2218382 */   GIM_Reject,
     /* 2218383 */ // Label 29315: @2218383
     /* 2218383 */ GIM_Reject,
     /* 2218384 */ // Label 29252: @2218384
     /* 2218384 */ GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2218438), // Rule ID 47524 //
     /* 2218389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218403 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218437 */   // GIR_Coverage, 47524,
     /* 2218437 */   GIR_EraseRootFromParent_Done,
     /* 2218438 */ // Label 29318: @2218438
     /* 2218438 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2218492), // Rule ID 47525 //
     /* 2218443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218457 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218491 */   // GIR_Coverage, 47525,
     /* 2218491 */   GIR_EraseRootFromParent_Done,
     /* 2218492 */ // Label 29319: @2218492
     /* 2218492 */ GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2218546), // Rule ID 47590 //
     /* 2218497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218511 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218545 */   // GIR_Coverage, 47590,
     /* 2218545 */   GIR_EraseRootFromParent_Done,
     /* 2218546 */ // Label 29320: @2218546
     /* 2218546 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2218600), // Rule ID 47591 //
     /* 2218551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218565 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218599 */   // GIR_Coverage, 47591,
     /* 2218599 */   GIR_EraseRootFromParent_Done,
     /* 2218600 */ // Label 29321: @2218600
     /* 2218600 */ GIM_Reject,
     /* 2218601 */ // Label 29253: @2218601
     /* 2218601 */ GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2218655), // Rule ID 47544 //
     /* 2218606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218620 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218654 */   // GIR_Coverage, 47544,
     /* 2218654 */   GIR_EraseRootFromParent_Done,
     /* 2218655 */ // Label 29322: @2218655
     /* 2218655 */ GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2218709), // Rule ID 47545 //
     /* 2218660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218674 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218708 */   // GIR_Coverage, 47545,
     /* 2218708 */   GIR_EraseRootFromParent_Done,
     /* 2218709 */ // Label 29323: @2218709
     /* 2218709 */ GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2218763), // Rule ID 47610 //
     /* 2218714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218728 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218762 */   // GIR_Coverage, 47610,
     /* 2218762 */   GIR_EraseRootFromParent_Done,
     /* 2218763 */ // Label 29324: @2218763
     /* 2218763 */ GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2218817), // Rule ID 47611 //
     /* 2218768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218782 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218816 */   // GIR_Coverage, 47611,
     /* 2218816 */   GIR_EraseRootFromParent_Done,
     /* 2218817 */ // Label 29325: @2218817
     /* 2218817 */ GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2218871), // Rule ID 47644 //
     /* 2218822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218836 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218870 */   // GIR_Coverage, 47644,
     /* 2218870 */   GIR_EraseRootFromParent_Done,
     /* 2218871 */ // Label 29326: @2218871
     /* 2218871 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2218925), // Rule ID 47645 //
     /* 2218876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218890 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218924 */   // GIR_Coverage, 47645,
     /* 2218924 */   GIR_EraseRootFromParent_Done,
     /* 2218925 */ // Label 29327: @2218925
     /* 2218925 */ GIM_Reject,
     /* 2218926 */ // Label 29254: @2218926
     /* 2218926 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2219029),
     /* 2218931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218942 */   GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2218985), // Rule ID 47504 //
     /* 2218947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218950 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218984 */     // GIR_Coverage, 47504,
     /* 2218984 */     GIR_EraseRootFromParent_Done,
     /* 2218985 */   // Label 29329: @2218985
     /* 2218985 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2219028), // Rule ID 47505 //
     /* 2218990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218993 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2219010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219027 */     // GIR_Coverage, 47505,
     /* 2219027 */     GIR_EraseRootFromParent_Done,
     /* 2219028 */   // Label 29330: @2219028
     /* 2219028 */   GIM_Reject,
     /* 2219029 */ // Label 29328: @2219029
     /* 2219029 */ GIM_Reject,
     /* 2219030 */ // Label 29255: @2219030
     /* 2219030 */ GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2219084), // Rule ID 47528 //
     /* 2219035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2219041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219049 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219083 */   // GIR_Coverage, 47528,
     /* 2219083 */   GIR_EraseRootFromParent_Done,
     /* 2219084 */ // Label 29331: @2219084
     /* 2219084 */ GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2219138), // Rule ID 47529 //
     /* 2219089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2219095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219103 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219137 */   // GIR_Coverage, 47529,
     /* 2219137 */   GIR_EraseRootFromParent_Done,
     /* 2219138 */ // Label 29332: @2219138
     /* 2219138 */ GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2219192), // Rule ID 47594 //
     /* 2219143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2219149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219157 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2219174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219179 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219191 */   // GIR_Coverage, 47594,
     /* 2219191 */   GIR_EraseRootFromParent_Done,
     /* 2219192 */ // Label 29333: @2219192
     /* 2219192 */ GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2219246), // Rule ID 47595 //
     /* 2219197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2219203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219211 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2219228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219233 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2219245 */   // GIR_Coverage, 47595,
     /* 2219245 */   GIR_EraseRootFromParent_Done,
     /* 2219246 */ // Label 29334: @2219246
     /* 2219246 */ GIM_Reject,
     /* 2219247 */ // Label 29256: @2219247
     /* 2219247 */ GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2219350),
     /* 2219252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2219255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219263 */   GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2219306), // Rule ID 47508 //
     /* 2219268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219271 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219305 */     // GIR_Coverage, 47508,
     /* 2219305 */     GIR_EraseRootFromParent_Done,
     /* 2219306 */   // Label 29336: @2219306
     /* 2219306 */   GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2219349), // Rule ID 47509 //
     /* 2219311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219314 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2219331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2219338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219348 */     // GIR_Coverage, 47509,
     /* 2219348 */     GIR_EraseRootFromParent_Done,
     /* 2219349 */   // Label 29337: @2219349
     /* 2219349 */   GIM_Reject,
     /* 2219350 */ // Label 29335: @2219350
     /* 2219350 */ GIM_Reject,
     /* 2219351 */ // Label 29257: @2219351
     /* 2219351 */ GIM_Reject,
     /* 2219352 */ // Label 43: @2219352
     /* 2219352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29362*/ GIMT_Encode4(2227947),
     /* 2219363 */ /*GILLT_s32*//*Label 29338*/ GIMT_Encode4(2219487),
     /* 2219367 */ /*GILLT_s64*//*Label 29339*/ GIMT_Encode4(2219612), GIMT_Encode4(0),
     /* 2219375 */ /*GILLT_nxv1s8*//*Label 29340*/ GIMT_Encode4(2219957),
     /* 2219379 */ /*GILLT_nxv1s16*//*Label 29341*/ GIMT_Encode4(2220072),
     /* 2219383 */ /*GILLT_nxv1s32*//*Label 29342*/ GIMT_Encode4(2220551),
     /* 2219387 */ /*GILLT_nxv1s64*//*Label 29343*/ GIMT_Encode4(2221030), GIMT_Encode4(0),
     /* 2219395 */ /*GILLT_nxv2s8*//*Label 29344*/ GIMT_Encode4(2221509),
     /* 2219399 */ /*GILLT_nxv2s16*//*Label 29345*/ GIMT_Encode4(2221624),
     /* 2219403 */ /*GILLT_nxv2s32*//*Label 29346*/ GIMT_Encode4(2222103),
     /* 2219407 */ /*GILLT_nxv2s64*//*Label 29347*/ GIMT_Encode4(2222582), GIMT_Encode4(0),
     /* 2219415 */ /*GILLT_nxv4s8*//*Label 29348*/ GIMT_Encode4(2223061),
     /* 2219419 */ /*GILLT_nxv4s16*//*Label 29349*/ GIMT_Encode4(2223176),
     /* 2219423 */ /*GILLT_nxv4s32*//*Label 29350*/ GIMT_Encode4(2223655),
     /* 2219427 */ /*GILLT_nxv4s64*//*Label 29351*/ GIMT_Encode4(2224134), GIMT_Encode4(0),
     /* 2219435 */ /*GILLT_nxv8s8*//*Label 29352*/ GIMT_Encode4(2224613),
     /* 2219439 */ /*GILLT_nxv8s16*//*Label 29353*/ GIMT_Encode4(2224728),
     /* 2219443 */ /*GILLT_nxv8s32*//*Label 29354*/ GIMT_Encode4(2225207),
     /* 2219447 */ /*GILLT_nxv8s64*//*Label 29355*/ GIMT_Encode4(2225686), GIMT_Encode4(0),
     /* 2219455 */ /*GILLT_nxv16s8*//*Label 29356*/ GIMT_Encode4(2226165),
     /* 2219459 */ /*GILLT_nxv16s16*//*Label 29357*/ GIMT_Encode4(2226280),
     /* 2219463 */ /*GILLT_nxv16s32*//*Label 29358*/ GIMT_Encode4(2226759), GIMT_Encode4(0),
     /* 2219471 */ /*GILLT_nxv32s8*//*Label 29359*/ GIMT_Encode4(2227238),
     /* 2219475 */ /*GILLT_nxv32s16*//*Label 29360*/ GIMT_Encode4(2227353), GIMT_Encode4(0),
     /* 2219483 */ /*GILLT_nxv64s8*//*Label 29361*/ GIMT_Encode4(2227832),
     /* 2219487 */ // Label 29338: @2219487
     /* 2219487 */ GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2219611),
     /* 2219492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2219498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219502 */   GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2219539), // Rule ID 2483 //
     /* 2219507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2219510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219521 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2219521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219538 */     // GIR_Coverage, 2483,
     /* 2219538 */     GIR_EraseRootFromParent_Done,
     /* 2219539 */   // Label 29364: @2219539
     /* 2219539 */   GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2219577), // Rule ID 97 //
     /* 2219544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219563 */     // MIs[1] Operand 1
     /* 2219563 */     // No operand predicates
     /* 2219563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219565 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219576 */     // GIR_Coverage, 97,
     /* 2219576 */     GIR_EraseRootFromParent_Done,
     /* 2219577 */   // Label 29365: @2219577
     /* 2219577 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2219610), // Rule ID 111 //
     /* 2219582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219596 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219609 */     // GIR_Coverage, 111,
     /* 2219609 */     GIR_EraseRootFromParent_Done,
     /* 2219610 */   // Label 29366: @2219610
     /* 2219610 */   GIM_Reject,
     /* 2219611 */ // Label 29363: @2219611
     /* 2219611 */ GIM_Reject,
     /* 2219612 */ // Label 29339: @2219612
     /* 2219612 */ GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2219956),
     /* 2219617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219623 */   GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2219717), // Rule ID 263 //
     /* 2219628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2219631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219656 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219679 */     // MIs[2] Operand 1
     /* 2219679 */     // No operand predicates
     /* 2219679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219681 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2219681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2219700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219710 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2219715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219716 */     // GIR_Coverage, 263,
     /* 2219716 */     GIR_EraseRootFromParent_Done,
     /* 2219717 */   // Label 29368: @2219717
     /* 2219717 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2219789), // Rule ID 2623 //
     /* 2219722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2219725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219750 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219773 */     // MIs[2] Operand 1
     /* 2219773 */     // No operand predicates
     /* 2219773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219775 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2219775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2219778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2219787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219788 */     // GIR_Coverage, 2623,
     /* 2219788 */     GIR_EraseRootFromParent_Done,
     /* 2219789 */   // Label 29369: @2219789
     /* 2219789 */   GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2219830), // Rule ID 2482 //
     /* 2219794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2219797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219812 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2219812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219829 */     // GIR_Coverage, 2482,
     /* 2219829 */     GIR_EraseRootFromParent_Done,
     /* 2219830 */   // Label 29370: @2219830
     /* 2219830 */   GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2219876), // Rule ID 278 //
     /* 2219835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2219838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219858 */     // MIs[1] Operand 1
     /* 2219858 */     // No operand predicates
     /* 2219858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10088),
     /* 2219862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219864 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10088>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2219864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2219867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219875 */     // GIR_Coverage, 278,
     /* 2219875 */     GIR_EraseRootFromParent_Done,
     /* 2219876 */   // Label 29371: @2219876
     /* 2219876 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2219918), // Rule ID 96 //
     /* 2219881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219904 */     // MIs[1] Operand 1
     /* 2219904 */     // No operand predicates
     /* 2219904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219906 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219917 */     // GIR_Coverage, 96,
     /* 2219917 */     GIR_EraseRootFromParent_Done,
     /* 2219918 */   // Label 29372: @2219918
     /* 2219918 */   GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2219955), // Rule ID 110 //
     /* 2219923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219941 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219954 */     // GIR_Coverage, 110,
     /* 2219954 */     GIR_EraseRootFromParent_Done,
     /* 2219955 */   // Label 29373: @2219955
     /* 2219955 */   GIM_Reject,
     /* 2219956 */ // Label 29367: @2219956
     /* 2219956 */ GIM_Reject,
     /* 2219957 */ // Label 29340: @2219957
     /* 2219957 */ GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2220071),
     /* 2219962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2219968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219980 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2220025), // Rule ID 48052 //
     /* 2219985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219988 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2220005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220024 */     // GIR_Coverage, 48052,
     /* 2220024 */     GIR_EraseRootFromParent_Done,
     /* 2220025 */   // Label 29375: @2220025
     /* 2220025 */   GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2220070), // Rule ID 48053 //
     /* 2220030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220033 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2220036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2220050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220069 */     // GIR_Coverage, 48053,
     /* 2220069 */     GIR_EraseRootFromParent_Done,
     /* 2220070 */   // Label 29376: @2220070
     /* 2220070 */   GIM_Reject,
     /* 2220071 */ // Label 29374: @2220071
     /* 2220071 */ GIM_Reject,
     /* 2220072 */ // Label 29341: @2220072
     /* 2220072 */ GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2220550),
     /* 2220077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2220083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220087 */   GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2220176), // Rule ID 59540 //
     /* 2220092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220107 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220126 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220135 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220175 */     // GIR_Coverage, 59540,
     /* 2220175 */     GIR_EraseRootFromParent_Done,
     /* 2220176 */   // Label 29378: @2220176
     /* 2220176 */   GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2220265), // Rule ID 59541 //
     /* 2220181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220196 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220215 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220224 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220264 */     // GIR_Coverage, 59541,
     /* 2220264 */     GIR_EraseRootFromParent_Done,
     /* 2220265 */   // Label 29379: @2220265
     /* 2220265 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2220354), // Rule ID 59542 //
     /* 2220270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220285 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220304 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220313 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220353 */     // GIR_Coverage, 59542,
     /* 2220353 */     GIR_EraseRootFromParent_Done,
     /* 2220354 */   // Label 29380: @2220354
     /* 2220354 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2220443), // Rule ID 59543 //
     /* 2220359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220374 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2220393 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220402 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2220419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220442 */     // GIR_Coverage, 59543,
     /* 2220442 */     GIR_EraseRootFromParent_Done,
     /* 2220443 */   // Label 29381: @2220443
     /* 2220443 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2220496), // Rule ID 48064 //
     /* 2220448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220459 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220495 */     // GIR_Coverage, 48064,
     /* 2220495 */     GIR_EraseRootFromParent_Done,
     /* 2220496 */   // Label 29382: @2220496
     /* 2220496 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2220549), // Rule ID 48065 //
     /* 2220501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220512 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220548 */     // GIR_Coverage, 48065,
     /* 2220548 */     GIR_EraseRootFromParent_Done,
     /* 2220549 */   // Label 29383: @2220549
     /* 2220549 */   GIM_Reject,
     /* 2220550 */ // Label 29377: @2220550
     /* 2220550 */ GIM_Reject,
     /* 2220551 */ // Label 29342: @2220551
     /* 2220551 */ GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2221029),
     /* 2220556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2220562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220566 */   GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2220655), // Rule ID 59588 //
     /* 2220571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220586 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220605 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220614 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220654 */     // GIR_Coverage, 59588,
     /* 2220654 */     GIR_EraseRootFromParent_Done,
     /* 2220655 */   // Label 29385: @2220655
     /* 2220655 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2220744), // Rule ID 59589 //
     /* 2220660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220675 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220694 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220703 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220743 */     // GIR_Coverage, 59589,
     /* 2220743 */     GIR_EraseRootFromParent_Done,
     /* 2220744 */   // Label 29386: @2220744
     /* 2220744 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2220833), // Rule ID 59590 //
     /* 2220749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220764 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220783 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220792 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220832 */     // GIR_Coverage, 59590,
     /* 2220832 */     GIR_EraseRootFromParent_Done,
     /* 2220833 */   // Label 29387: @2220833
     /* 2220833 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2220922), // Rule ID 59591 //
     /* 2220838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220853 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220872 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220881 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220921 */     // GIR_Coverage, 59591,
     /* 2220921 */     GIR_EraseRootFromParent_Done,
     /* 2220922 */   // Label 29388: @2220922
     /* 2220922 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2220975), // Rule ID 48072 //
     /* 2220927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220938 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220974 */     // GIR_Coverage, 48072,
     /* 2220974 */     GIR_EraseRootFromParent_Done,
     /* 2220975 */   // Label 29389: @2220975
     /* 2220975 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2221028), // Rule ID 48073 //
     /* 2220980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220991 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221027 */     // GIR_Coverage, 48073,
     /* 2221027 */     GIR_EraseRootFromParent_Done,
     /* 2221028 */   // Label 29390: @2221028
     /* 2221028 */   GIM_Reject,
     /* 2221029 */ // Label 29384: @2221029
     /* 2221029 */ GIM_Reject,
     /* 2221030 */ // Label 29343: @2221030
     /* 2221030 */ GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2221508),
     /* 2221035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2221038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2221041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221045 */   GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2221134), // Rule ID 59628 //
     /* 2221050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221065 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221084 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221093 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221133 */     // GIR_Coverage, 59628,
     /* 2221133 */     GIR_EraseRootFromParent_Done,
     /* 2221134 */   // Label 29392: @2221134
     /* 2221134 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2221223), // Rule ID 59629 //
     /* 2221139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221154 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221173 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221182 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221222 */     // GIR_Coverage, 59629,
     /* 2221222 */     GIR_EraseRootFromParent_Done,
     /* 2221223 */   // Label 29393: @2221223
     /* 2221223 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2221312), // Rule ID 59630 //
     /* 2221228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2221231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221243 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221262 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221271 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221311 */     // GIR_Coverage, 59630,
     /* 2221311 */     GIR_EraseRootFromParent_Done,
     /* 2221312 */   // Label 29394: @2221312
     /* 2221312 */   GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2221401), // Rule ID 59631 //
     /* 2221317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2221320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221332 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221351 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221360 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221400 */     // GIR_Coverage, 59631,
     /* 2221400 */     GIR_EraseRootFromParent_Done,
     /* 2221401 */   // Label 29395: @2221401
     /* 2221401 */   GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2221454), // Rule ID 48088 //
     /* 2221406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2221409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221417 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221453 */     // GIR_Coverage, 48088,
     /* 2221453 */     GIR_EraseRootFromParent_Done,
     /* 2221454 */   // Label 29396: @2221454
     /* 2221454 */   GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2221507), // Rule ID 48089 //
     /* 2221459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221470 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221506 */     // GIR_Coverage, 48089,
     /* 2221506 */     GIR_EraseRootFromParent_Done,
     /* 2221507 */   // Label 29397: @2221507
     /* 2221507 */   GIM_Reject,
     /* 2221508 */ // Label 29391: @2221508
     /* 2221508 */ GIM_Reject,
     /* 2221509 */ // Label 29344: @2221509
     /* 2221509 */ GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2221623),
     /* 2221514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2221520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221532 */   GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2221577), // Rule ID 48056 //
     /* 2221537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221540 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221576 */     // GIR_Coverage, 48056,
     /* 2221576 */     GIR_EraseRootFromParent_Done,
     /* 2221577 */   // Label 29399: @2221577
     /* 2221577 */   GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2221622), // Rule ID 48057 //
     /* 2221582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221585 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221621 */     // GIR_Coverage, 48057,
     /* 2221621 */     GIR_EraseRootFromParent_Done,
     /* 2221622 */   // Label 29400: @2221622
     /* 2221622 */   GIM_Reject,
     /* 2221623 */ // Label 29398: @2221623
     /* 2221623 */ GIM_Reject,
     /* 2221624 */ // Label 29345: @2221624
     /* 2221624 */ GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2222102),
     /* 2221629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2221635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221639 */   GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2221728), // Rule ID 59548 //
     /* 2221644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221659 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221678 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221687 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221727 */     // GIR_Coverage, 59548,
     /* 2221727 */     GIR_EraseRootFromParent_Done,
     /* 2221728 */   // Label 29402: @2221728
     /* 2221728 */   GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2221817), // Rule ID 59549 //
     /* 2221733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221748 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221767 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221776 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221816 */     // GIR_Coverage, 59549,
     /* 2221816 */     GIR_EraseRootFromParent_Done,
     /* 2221817 */   // Label 29403: @2221817
     /* 2221817 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2221906), // Rule ID 59550 //
     /* 2221822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221837 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221856 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221865 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221905 */     // GIR_Coverage, 59550,
     /* 2221905 */     GIR_EraseRootFromParent_Done,
     /* 2221906 */   // Label 29404: @2221906
     /* 2221906 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2221995), // Rule ID 59551 //
     /* 2221911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221926 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221945 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221954 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221994 */     // GIR_Coverage, 59551,
     /* 2221994 */     GIR_EraseRootFromParent_Done,
     /* 2221995 */   // Label 29405: @2221995
     /* 2221995 */   GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2222048), // Rule ID 48068 //
     /* 2222000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222011 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2222014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222047 */     // GIR_Coverage, 48068,
     /* 2222047 */     GIR_EraseRootFromParent_Done,
     /* 2222048 */   // Label 29406: @2222048
     /* 2222048 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2222101), // Rule ID 48069 //
     /* 2222053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222064 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2222067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222100 */     // GIR_Coverage, 48069,
     /* 2222100 */     GIR_EraseRootFromParent_Done,
     /* 2222101 */   // Label 29407: @2222101
     /* 2222101 */   GIM_Reject,
     /* 2222102 */ // Label 29401: @2222102
     /* 2222102 */ GIM_Reject,
     /* 2222103 */ // Label 29346: @2222103
     /* 2222103 */ GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2222581),
     /* 2222108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2222114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222118 */   GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2222207), // Rule ID 59596 //
     /* 2222123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222138 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222157 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222166 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222206 */     // GIR_Coverage, 59596,
     /* 2222206 */     GIR_EraseRootFromParent_Done,
     /* 2222207 */   // Label 29409: @2222207
     /* 2222207 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2222296), // Rule ID 59597 //
     /* 2222212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222227 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222246 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222255 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222295 */     // GIR_Coverage, 59597,
     /* 2222295 */     GIR_EraseRootFromParent_Done,
     /* 2222296 */   // Label 29410: @2222296
     /* 2222296 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2222385), // Rule ID 59598 //
     /* 2222301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222316 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222335 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222344 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222384 */     // GIR_Coverage, 59598,
     /* 2222384 */     GIR_EraseRootFromParent_Done,
     /* 2222385 */   // Label 29411: @2222385
     /* 2222385 */   GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2222474), // Rule ID 59599 //
     /* 2222390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222405 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2222424 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222433 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222473 */     // GIR_Coverage, 59599,
     /* 2222473 */     GIR_EraseRootFromParent_Done,
     /* 2222474 */   // Label 29412: @2222474
     /* 2222474 */   GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2222527), // Rule ID 48084 //
     /* 2222479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222490 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222526 */     // GIR_Coverage, 48084,
     /* 2222526 */     GIR_EraseRootFromParent_Done,
     /* 2222527 */   // Label 29413: @2222527
     /* 2222527 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2222580), // Rule ID 48085 //
     /* 2222532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222543 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222579 */     // GIR_Coverage, 48085,
     /* 2222579 */     GIR_EraseRootFromParent_Done,
     /* 2222580 */   // Label 29414: @2222580
     /* 2222580 */   GIM_Reject,
     /* 2222581 */ // Label 29408: @2222581
     /* 2222581 */ GIM_Reject,
     /* 2222582 */ // Label 29347: @2222582
     /* 2222582 */ GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2223060),
     /* 2222587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2222590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2222593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222597 */   GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2222686), // Rule ID 59636 //
     /* 2222602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222617 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222636 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222645 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222685 */     // GIR_Coverage, 59636,
     /* 2222685 */     GIR_EraseRootFromParent_Done,
     /* 2222686 */   // Label 29416: @2222686
     /* 2222686 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2222775), // Rule ID 59637 //
     /* 2222691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222706 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222725 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222734 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222774 */     // GIR_Coverage, 59637,
     /* 2222774 */     GIR_EraseRootFromParent_Done,
     /* 2222775 */   // Label 29417: @2222775
     /* 2222775 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2222864), // Rule ID 59638 //
     /* 2222780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222795 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222814 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222823 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222863 */     // GIR_Coverage, 59638,
     /* 2222863 */     GIR_EraseRootFromParent_Done,
     /* 2222864 */   // Label 29418: @2222864
     /* 2222864 */   GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2222953), // Rule ID 59639 //
     /* 2222869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222884 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222903 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222912 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222952 */     // GIR_Coverage, 59639,
     /* 2222952 */     GIR_EraseRootFromParent_Done,
     /* 2222953 */   // Label 29419: @2222953
     /* 2222953 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2223006), // Rule ID 48128 //
     /* 2222958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222969 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223005 */     // GIR_Coverage, 48128,
     /* 2223005 */     GIR_EraseRootFromParent_Done,
     /* 2223006 */   // Label 29420: @2223006
     /* 2223006 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2223059), // Rule ID 48129 //
     /* 2223011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2223014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223022 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223058 */     // GIR_Coverage, 48129,
     /* 2223058 */     GIR_EraseRootFromParent_Done,
     /* 2223059 */   // Label 29421: @2223059
     /* 2223059 */   GIM_Reject,
     /* 2223060 */ // Label 29415: @2223060
     /* 2223060 */ GIM_Reject,
     /* 2223061 */ // Label 29348: @2223061
     /* 2223061 */ GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2223175),
     /* 2223066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2223072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223084 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2223129), // Rule ID 48060 //
     /* 2223089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223092 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2223109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223128 */     // GIR_Coverage, 48060,
     /* 2223128 */     GIR_EraseRootFromParent_Done,
     /* 2223129 */   // Label 29423: @2223129
     /* 2223129 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2223174), // Rule ID 48061 //
     /* 2223134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223137 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2223154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223173 */     // GIR_Coverage, 48061,
     /* 2223173 */     GIR_EraseRootFromParent_Done,
     /* 2223174 */   // Label 29424: @2223174
     /* 2223174 */   GIM_Reject,
     /* 2223175 */ // Label 29422: @2223175
     /* 2223175 */ GIM_Reject,
     /* 2223176 */ // Label 29349: @2223176
     /* 2223176 */ GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2223654),
     /* 2223181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2223187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223191 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2223280), // Rule ID 59556 //
     /* 2223196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223211 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223230 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223239 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223279 */     // GIR_Coverage, 59556,
     /* 2223279 */     GIR_EraseRootFromParent_Done,
     /* 2223280 */   // Label 29426: @2223280
     /* 2223280 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2223369), // Rule ID 59557 //
     /* 2223285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223300 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223319 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223328 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223368 */     // GIR_Coverage, 59557,
     /* 2223368 */     GIR_EraseRootFromParent_Done,
     /* 2223369 */   // Label 29427: @2223369
     /* 2223369 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2223458), // Rule ID 59558 //
     /* 2223374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223389 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223408 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223417 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223457 */     // GIR_Coverage, 59558,
     /* 2223457 */     GIR_EraseRootFromParent_Done,
     /* 2223458 */   // Label 29428: @2223458
     /* 2223458 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2223547), // Rule ID 59559 //
     /* 2223463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223478 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223497 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223506 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223546 */     // GIR_Coverage, 59559,
     /* 2223546 */     GIR_EraseRootFromParent_Done,
     /* 2223547 */   // Label 29429: @2223547
     /* 2223547 */   GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2223600), // Rule ID 48080 //
     /* 2223552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223563 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223599 */     // GIR_Coverage, 48080,
     /* 2223599 */     GIR_EraseRootFromParent_Done,
     /* 2223600 */   // Label 29430: @2223600
     /* 2223600 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2223653), // Rule ID 48081 //
     /* 2223605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223616 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223652 */     // GIR_Coverage, 48081,
     /* 2223652 */     GIR_EraseRootFromParent_Done,
     /* 2223653 */   // Label 29431: @2223653
     /* 2223653 */   GIM_Reject,
     /* 2223654 */ // Label 29425: @2223654
     /* 2223654 */ GIM_Reject,
     /* 2223655 */ // Label 29350: @2223655
     /* 2223655 */ GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2224133),
     /* 2223660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2223666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223670 */   GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2223759), // Rule ID 59604 //
     /* 2223675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223690 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223709 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223718 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223758 */     // GIR_Coverage, 59604,
     /* 2223758 */     GIR_EraseRootFromParent_Done,
     /* 2223759 */   // Label 29433: @2223759
     /* 2223759 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2223848), // Rule ID 59605 //
     /* 2223764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223779 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223798 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223807 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223847 */     // GIR_Coverage, 59605,
     /* 2223847 */     GIR_EraseRootFromParent_Done,
     /* 2223848 */   // Label 29434: @2223848
     /* 2223848 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2223937), // Rule ID 59606 //
     /* 2223853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223868 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223887 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223896 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223936 */     // GIR_Coverage, 59606,
     /* 2223936 */     GIR_EraseRootFromParent_Done,
     /* 2223937 */   // Label 29435: @2223937
     /* 2223937 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2224026), // Rule ID 59607 //
     /* 2223942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223957 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223976 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223985 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224025 */     // GIR_Coverage, 59607,
     /* 2224025 */     GIR_EraseRootFromParent_Done,
     /* 2224026 */   // Label 29436: @2224026
     /* 2224026 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2224079), // Rule ID 48116 //
     /* 2224031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224042 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224078 */     // GIR_Coverage, 48116,
     /* 2224078 */     GIR_EraseRootFromParent_Done,
     /* 2224079 */   // Label 29437: @2224079
     /* 2224079 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2224132), // Rule ID 48117 //
     /* 2224084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224095 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224131 */     // GIR_Coverage, 48117,
     /* 2224131 */     GIR_EraseRootFromParent_Done,
     /* 2224132 */   // Label 29438: @2224132
     /* 2224132 */   GIM_Reject,
     /* 2224133 */ // Label 29432: @2224133
     /* 2224133 */ GIM_Reject,
     /* 2224134 */ // Label 29351: @2224134
     /* 2224134 */ GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2224612),
     /* 2224139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2224145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224149 */   GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2224238), // Rule ID 59644 //
     /* 2224154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224169 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224188 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224197 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224237 */     // GIR_Coverage, 59644,
     /* 2224237 */     GIR_EraseRootFromParent_Done,
     /* 2224238 */   // Label 29440: @2224238
     /* 2224238 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2224327), // Rule ID 59645 //
     /* 2224243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224258 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224277 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224286 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224326 */     // GIR_Coverage, 59645,
     /* 2224326 */     GIR_EraseRootFromParent_Done,
     /* 2224327 */   // Label 29441: @2224327
     /* 2224327 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2224416), // Rule ID 59646 //
     /* 2224332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2224335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224347 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224366 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224375 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224415 */     // GIR_Coverage, 59646,
     /* 2224415 */     GIR_EraseRootFromParent_Done,
     /* 2224416 */   // Label 29442: @2224416
     /* 2224416 */   GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2224505), // Rule ID 59647 //
     /* 2224421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2224424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224436 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2224455 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224464 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224504 */     // GIR_Coverage, 59647,
     /* 2224504 */     GIR_EraseRootFromParent_Done,
     /* 2224505 */   // Label 29443: @2224505
     /* 2224505 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2224558), // Rule ID 48132 //
     /* 2224510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224521 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224557 */     // GIR_Coverage, 48132,
     /* 2224557 */     GIR_EraseRootFromParent_Done,
     /* 2224558 */   // Label 29444: @2224558
     /* 2224558 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2224611), // Rule ID 48133 //
     /* 2224563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224574 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224610 */     // GIR_Coverage, 48133,
     /* 2224610 */     GIR_EraseRootFromParent_Done,
     /* 2224611 */   // Label 29445: @2224611
     /* 2224611 */   GIM_Reject,
     /* 2224612 */ // Label 29439: @2224612
     /* 2224612 */ GIM_Reject,
     /* 2224613 */ // Label 29352: @2224613
     /* 2224613 */ GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2224727),
     /* 2224618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2224624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224636 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2224681), // Rule ID 48076 //
     /* 2224641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224644 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224680 */     // GIR_Coverage, 48076,
     /* 2224680 */     GIR_EraseRootFromParent_Done,
     /* 2224681 */   // Label 29447: @2224681
     /* 2224681 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2224726), // Rule ID 48077 //
     /* 2224686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224689 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224725 */     // GIR_Coverage, 48077,
     /* 2224725 */     GIR_EraseRootFromParent_Done,
     /* 2224726 */   // Label 29448: @2224726
     /* 2224726 */   GIM_Reject,
     /* 2224727 */ // Label 29446: @2224727
     /* 2224727 */ GIM_Reject,
     /* 2224728 */ // Label 29353: @2224728
     /* 2224728 */ GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2225206),
     /* 2224733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2224739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224743 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2224832), // Rule ID 59564 //
     /* 2224748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224763 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224782 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224791 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224831 */     // GIR_Coverage, 59564,
     /* 2224831 */     GIR_EraseRootFromParent_Done,
     /* 2224832 */   // Label 29450: @2224832
     /* 2224832 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2224921), // Rule ID 59565 //
     /* 2224837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224852 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224871 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224880 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224920 */     // GIR_Coverage, 59565,
     /* 2224920 */     GIR_EraseRootFromParent_Done,
     /* 2224921 */   // Label 29451: @2224921
     /* 2224921 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2225010), // Rule ID 59566 //
     /* 2224926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224941 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224960 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224969 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225009 */     // GIR_Coverage, 59566,
     /* 2225009 */     GIR_EraseRootFromParent_Done,
     /* 2225010 */   // Label 29452: @2225010
     /* 2225010 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2225099), // Rule ID 59567 //
     /* 2225015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2225030 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2225049 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225058 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2225075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225098 */     // GIR_Coverage, 59567,
     /* 2225098 */     GIR_EraseRootFromParent_Done,
     /* 2225099 */   // Label 29453: @2225099
     /* 2225099 */   GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2225152), // Rule ID 48104 //
     /* 2225104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225115 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225151 */     // GIR_Coverage, 48104,
     /* 2225151 */     GIR_EraseRootFromParent_Done,
     /* 2225152 */   // Label 29454: @2225152
     /* 2225152 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2225205), // Rule ID 48105 //
     /* 2225157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225168 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225204 */     // GIR_Coverage, 48105,
     /* 2225204 */     GIR_EraseRootFromParent_Done,
     /* 2225205 */   // Label 29455: @2225205
     /* 2225205 */   GIM_Reject,
     /* 2225206 */ // Label 29449: @2225206
     /* 2225206 */ GIM_Reject,
     /* 2225207 */ // Label 29354: @2225207
     /* 2225207 */ GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2225685),
     /* 2225212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2225218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225222 */   GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2225311), // Rule ID 59612 //
     /* 2225227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225242 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225261 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225270 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225310 */     // GIR_Coverage, 59612,
     /* 2225310 */     GIR_EraseRootFromParent_Done,
     /* 2225311 */   // Label 29457: @2225311
     /* 2225311 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2225400), // Rule ID 59613 //
     /* 2225316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225331 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225350 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225359 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225399 */     // GIR_Coverage, 59613,
     /* 2225399 */     GIR_EraseRootFromParent_Done,
     /* 2225400 */   // Label 29458: @2225400
     /* 2225400 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2225489), // Rule ID 59614 //
     /* 2225405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225420 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225439 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225448 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225488 */     // GIR_Coverage, 59614,
     /* 2225488 */     GIR_EraseRootFromParent_Done,
     /* 2225489 */   // Label 29459: @2225489
     /* 2225489 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2225578), // Rule ID 59615 //
     /* 2225494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225509 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225528 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225537 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225577 */     // GIR_Coverage, 59615,
     /* 2225577 */     GIR_EraseRootFromParent_Done,
     /* 2225578 */   // Label 29460: @2225578
     /* 2225578 */   GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2225631), // Rule ID 48120 //
     /* 2225583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225594 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225630 */     // GIR_Coverage, 48120,
     /* 2225630 */     GIR_EraseRootFromParent_Done,
     /* 2225631 */   // Label 29461: @2225631
     /* 2225631 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2225684), // Rule ID 48121 //
     /* 2225636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225647 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225683 */     // GIR_Coverage, 48121,
     /* 2225683 */     GIR_EraseRootFromParent_Done,
     /* 2225684 */   // Label 29462: @2225684
     /* 2225684 */   GIM_Reject,
     /* 2225685 */ // Label 29456: @2225685
     /* 2225685 */ GIM_Reject,
     /* 2225686 */ // Label 29355: @2225686
     /* 2225686 */ GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2226164),
     /* 2225691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2225697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225701 */   GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2225790), // Rule ID 59652 //
     /* 2225706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225721 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225740 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225749 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225789 */     // GIR_Coverage, 59652,
     /* 2225789 */     GIR_EraseRootFromParent_Done,
     /* 2225790 */   // Label 29464: @2225790
     /* 2225790 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2225879), // Rule ID 59653 //
     /* 2225795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225810 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225829 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225838 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225878 */     // GIR_Coverage, 59653,
     /* 2225878 */     GIR_EraseRootFromParent_Done,
     /* 2225879 */   // Label 29465: @2225879
     /* 2225879 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2225968), // Rule ID 59654 //
     /* 2225884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225899 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225918 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225927 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225967 */     // GIR_Coverage, 59654,
     /* 2225967 */     GIR_EraseRootFromParent_Done,
     /* 2225968 */   // Label 29466: @2225968
     /* 2225968 */   GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2226057), // Rule ID 59655 //
     /* 2225973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225988 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2226007 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226016 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226056 */     // GIR_Coverage, 59655,
     /* 2226056 */     GIR_EraseRootFromParent_Done,
     /* 2226057 */   // Label 29467: @2226057
     /* 2226057 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2226110), // Rule ID 48136 //
     /* 2226062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2226065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226073 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226109 */     // GIR_Coverage, 48136,
     /* 2226109 */     GIR_EraseRootFromParent_Done,
     /* 2226110 */   // Label 29468: @2226110
     /* 2226110 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2226163), // Rule ID 48137 //
     /* 2226115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2226118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226126 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226162 */     // GIR_Coverage, 48137,
     /* 2226162 */     GIR_EraseRootFromParent_Done,
     /* 2226163 */   // Label 29469: @2226163
     /* 2226163 */   GIM_Reject,
     /* 2226164 */ // Label 29463: @2226164
     /* 2226164 */ GIM_Reject,
     /* 2226165 */ // Label 29356: @2226165
     /* 2226165 */ GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2226279),
     /* 2226170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2226176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226188 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2226233), // Rule ID 48092 //
     /* 2226193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226196 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226232 */     // GIR_Coverage, 48092,
     /* 2226232 */     GIR_EraseRootFromParent_Done,
     /* 2226233 */   // Label 29471: @2226233
     /* 2226233 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2226278), // Rule ID 48093 //
     /* 2226238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226241 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2226258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226277 */     // GIR_Coverage, 48093,
     /* 2226277 */     GIR_EraseRootFromParent_Done,
     /* 2226278 */   // Label 29472: @2226278
     /* 2226278 */   GIM_Reject,
     /* 2226279 */ // Label 29470: @2226279
     /* 2226279 */ GIM_Reject,
     /* 2226280 */ // Label 29357: @2226280
     /* 2226280 */ GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2226758),
     /* 2226285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2226291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226295 */   GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2226384), // Rule ID 59572 //
     /* 2226300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226315 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226334 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226343 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226383 */     // GIR_Coverage, 59572,
     /* 2226383 */     GIR_EraseRootFromParent_Done,
     /* 2226384 */   // Label 29474: @2226384
     /* 2226384 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2226473), // Rule ID 59573 //
     /* 2226389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226404 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226423 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226432 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226472 */     // GIR_Coverage, 59573,
     /* 2226472 */     GIR_EraseRootFromParent_Done,
     /* 2226473 */   // Label 29475: @2226473
     /* 2226473 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2226562), // Rule ID 59574 //
     /* 2226478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226493 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226512 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226521 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226561 */     // GIR_Coverage, 59574,
     /* 2226561 */     GIR_EraseRootFromParent_Done,
     /* 2226562 */   // Label 29476: @2226562
     /* 2226562 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2226651), // Rule ID 59575 //
     /* 2226567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226582 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226601 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226610 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226650 */     // GIR_Coverage, 59575,
     /* 2226650 */     GIR_EraseRootFromParent_Done,
     /* 2226651 */   // Label 29477: @2226651
     /* 2226651 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2226704), // Rule ID 48108 //
     /* 2226656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226667 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226703 */     // GIR_Coverage, 48108,
     /* 2226703 */     GIR_EraseRootFromParent_Done,
     /* 2226704 */   // Label 29478: @2226704
     /* 2226704 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2226757), // Rule ID 48109 //
     /* 2226709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226720 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226756 */     // GIR_Coverage, 48109,
     /* 2226756 */     GIR_EraseRootFromParent_Done,
     /* 2226757 */   // Label 29479: @2226757
     /* 2226757 */   GIM_Reject,
     /* 2226758 */ // Label 29473: @2226758
     /* 2226758 */ GIM_Reject,
     /* 2226759 */ // Label 29358: @2226759
     /* 2226759 */ GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2227237),
     /* 2226764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2226770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226774 */   GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2226863), // Rule ID 59620 //
     /* 2226779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226794 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226813 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226822 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226862 */     // GIR_Coverage, 59620,
     /* 2226862 */     GIR_EraseRootFromParent_Done,
     /* 2226863 */   // Label 29481: @2226863
     /* 2226863 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2226952), // Rule ID 59621 //
     /* 2226868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226883 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226902 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226911 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226951 */     // GIR_Coverage, 59621,
     /* 2226951 */     GIR_EraseRootFromParent_Done,
     /* 2226952 */   // Label 29482: @2226952
     /* 2226952 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2227041), // Rule ID 59622 //
     /* 2226957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226972 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226991 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227000 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227040 */     // GIR_Coverage, 59622,
     /* 2227040 */     GIR_EraseRootFromParent_Done,
     /* 2227041 */   // Label 29483: @2227041
     /* 2227041 */   GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2227130), // Rule ID 59623 //
     /* 2227046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2227061 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2227080 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227089 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227129 */     // GIR_Coverage, 59623,
     /* 2227129 */     GIR_EraseRootFromParent_Done,
     /* 2227130 */   // Label 29484: @2227130
     /* 2227130 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2227183), // Rule ID 48124 //
     /* 2227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227146 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227182 */     // GIR_Coverage, 48124,
     /* 2227182 */     GIR_EraseRootFromParent_Done,
     /* 2227183 */   // Label 29485: @2227183
     /* 2227183 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2227236), // Rule ID 48125 //
     /* 2227188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227199 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2227202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227235 */     // GIR_Coverage, 48125,
     /* 2227235 */     GIR_EraseRootFromParent_Done,
     /* 2227236 */   // Label 29486: @2227236
     /* 2227236 */   GIM_Reject,
     /* 2227237 */ // Label 29480: @2227237
     /* 2227237 */ GIM_Reject,
     /* 2227238 */ // Label 29359: @2227238
     /* 2227238 */ GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2227352),
     /* 2227243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2227249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227261 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2227306), // Rule ID 48096 //
     /* 2227266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227269 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2227272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227305 */     // GIR_Coverage, 48096,
     /* 2227305 */     GIR_EraseRootFromParent_Done,
     /* 2227306 */   // Label 29488: @2227306
     /* 2227306 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2227351), // Rule ID 48097 //
     /* 2227311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227314 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2227317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2227331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227350 */     // GIR_Coverage, 48097,
     /* 2227350 */     GIR_EraseRootFromParent_Done,
     /* 2227351 */   // Label 29489: @2227351
     /* 2227351 */   GIM_Reject,
     /* 2227352 */ // Label 29487: @2227352
     /* 2227352 */ GIM_Reject,
     /* 2227353 */ // Label 29360: @2227353
     /* 2227353 */ GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2227831),
     /* 2227358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2227361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2227364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227368 */   GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2227457), // Rule ID 59580 //
     /* 2227373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227388 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227407 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227416 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227456 */     // GIR_Coverage, 59580,
     /* 2227456 */     GIR_EraseRootFromParent_Done,
     /* 2227457 */   // Label 29491: @2227457
     /* 2227457 */   GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2227546), // Rule ID 59581 //
     /* 2227462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227477 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227496 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227505 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227545 */     // GIR_Coverage, 59581,
     /* 2227545 */     GIR_EraseRootFromParent_Done,
     /* 2227546 */   // Label 29492: @2227546
     /* 2227546 */   GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2227635), // Rule ID 59582 //
     /* 2227551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227566 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227585 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227594 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227634 */     // GIR_Coverage, 59582,
     /* 2227634 */     GIR_EraseRootFromParent_Done,
     /* 2227635 */   // Label 29493: @2227635
     /* 2227635 */   GIM_Try, /*On fail goto*//*Label 29494*/ GIMT_Encode4(2227724), // Rule ID 59583 //
     /* 2227640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227655 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227674 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227683 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227723 */     // GIR_Coverage, 59583,
     /* 2227723 */     GIR_EraseRootFromParent_Done,
     /* 2227724 */   // Label 29494: @2227724
     /* 2227724 */   GIM_Try, /*On fail goto*//*Label 29495*/ GIMT_Encode4(2227777), // Rule ID 48112 //
     /* 2227729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227740 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227776 */     // GIR_Coverage, 48112,
     /* 2227776 */     GIR_EraseRootFromParent_Done,
     /* 2227777 */   // Label 29495: @2227777
     /* 2227777 */   GIM_Try, /*On fail goto*//*Label 29496*/ GIMT_Encode4(2227830), // Rule ID 48113 //
     /* 2227782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227793 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227829 */     // GIR_Coverage, 48113,
     /* 2227829 */     GIR_EraseRootFromParent_Done,
     /* 2227830 */   // Label 29496: @2227830
     /* 2227830 */   GIM_Reject,
     /* 2227831 */ // Label 29490: @2227831
     /* 2227831 */ GIM_Reject,
     /* 2227832 */ // Label 29361: @2227832
     /* 2227832 */ GIM_Try, /*On fail goto*//*Label 29497*/ GIMT_Encode4(2227946),
     /* 2227837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2227840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2227843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227855 */   GIM_Try, /*On fail goto*//*Label 29498*/ GIMT_Encode4(2227900), // Rule ID 48100 //
     /* 2227860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227863 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227899 */     // GIR_Coverage, 48100,
     /* 2227899 */     GIR_EraseRootFromParent_Done,
     /* 2227900 */   // Label 29498: @2227900
     /* 2227900 */   GIM_Try, /*On fail goto*//*Label 29499*/ GIMT_Encode4(2227945), // Rule ID 48101 //
     /* 2227905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227908 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227944 */     // GIR_Coverage, 48101,
     /* 2227944 */     GIR_EraseRootFromParent_Done,
     /* 2227945 */   // Label 29499: @2227945
     /* 2227945 */   GIM_Reject,
     /* 2227946 */ // Label 29497: @2227946
     /* 2227946 */ GIM_Reject,
     /* 2227947 */ // Label 29362: @2227947
     /* 2227947 */ GIM_Reject,
     /* 2227948 */ // Label 44: @2227948
     /* 2227948 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29524*/ GIMT_Encode4(2230978),
     /* 2227959 */ /*GILLT_s32*//*Label 29500*/ GIMT_Encode4(2228083),
     /* 2227963 */ /*GILLT_s64*//*Label 29501*/ GIMT_Encode4(2228167), GIMT_Encode4(0),
     /* 2227971 */ /*GILLT_nxv1s8*//*Label 29502*/ GIMT_Encode4(2228448),
     /* 2227975 */ /*GILLT_nxv1s16*//*Label 29503*/ GIMT_Encode4(2228563),
     /* 2227979 */ /*GILLT_nxv1s32*//*Label 29504*/ GIMT_Encode4(2228678),
     /* 2227983 */ /*GILLT_nxv1s64*//*Label 29505*/ GIMT_Encode4(2228793), GIMT_Encode4(0),
     /* 2227991 */ /*GILLT_nxv2s8*//*Label 29506*/ GIMT_Encode4(2228908),
     /* 2227995 */ /*GILLT_nxv2s16*//*Label 29507*/ GIMT_Encode4(2229023),
     /* 2227999 */ /*GILLT_nxv2s32*//*Label 29508*/ GIMT_Encode4(2229138),
     /* 2228003 */ /*GILLT_nxv2s64*//*Label 29509*/ GIMT_Encode4(2229253), GIMT_Encode4(0),
     /* 2228011 */ /*GILLT_nxv4s8*//*Label 29510*/ GIMT_Encode4(2229368),
     /* 2228015 */ /*GILLT_nxv4s16*//*Label 29511*/ GIMT_Encode4(2229483),
     /* 2228019 */ /*GILLT_nxv4s32*//*Label 29512*/ GIMT_Encode4(2229598),
     /* 2228023 */ /*GILLT_nxv4s64*//*Label 29513*/ GIMT_Encode4(2229713), GIMT_Encode4(0),
     /* 2228031 */ /*GILLT_nxv8s8*//*Label 29514*/ GIMT_Encode4(2229828),
     /* 2228035 */ /*GILLT_nxv8s16*//*Label 29515*/ GIMT_Encode4(2229943),
     /* 2228039 */ /*GILLT_nxv8s32*//*Label 29516*/ GIMT_Encode4(2230058),
     /* 2228043 */ /*GILLT_nxv8s64*//*Label 29517*/ GIMT_Encode4(2230173), GIMT_Encode4(0),
     /* 2228051 */ /*GILLT_nxv16s8*//*Label 29518*/ GIMT_Encode4(2230288),
     /* 2228055 */ /*GILLT_nxv16s16*//*Label 29519*/ GIMT_Encode4(2230403),
     /* 2228059 */ /*GILLT_nxv16s32*//*Label 29520*/ GIMT_Encode4(2230518), GIMT_Encode4(0),
     /* 2228067 */ /*GILLT_nxv32s8*//*Label 29521*/ GIMT_Encode4(2230633),
     /* 2228071 */ /*GILLT_nxv32s16*//*Label 29522*/ GIMT_Encode4(2230748), GIMT_Encode4(0),
     /* 2228079 */ /*GILLT_nxv64s8*//*Label 29523*/ GIMT_Encode4(2230863),
     /* 2228083 */ // Label 29500: @2228083
     /* 2228083 */ GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2228166),
     /* 2228088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2228091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228102 */   GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2228136), // Rule ID 99 //
     /* 2228107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2228114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2228122 */     // MIs[1] Operand 1
     /* 2228122 */     // No operand predicates
     /* 2228122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228124 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2228124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2228127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228135 */     // GIR_Coverage, 99,
     /* 2228135 */     GIR_EraseRootFromParent_Done,
     /* 2228136 */   // Label 29526: @2228136
     /* 2228136 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2228165), // Rule ID 113 //
     /* 2228141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2228151 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2228151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2228154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2228163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228164 */     // GIR_Coverage, 113,
     /* 2228164 */     GIR_EraseRootFromParent_Done,
     /* 2228165 */   // Label 29527: @2228165
     /* 2228165 */   GIM_Reject,
     /* 2228166 */ // Label 29525: @2228166
     /* 2228166 */ GIM_Reject,
     /* 2228167 */ // Label 29501: @2228167
     /* 2228167 */ GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2228447),
     /* 2228172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228178 */   GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2228250), // Rule ID 267 //
     /* 2228183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2228186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2228198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2228222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2228234 */     // MIs[2] Operand 1
     /* 2228234 */     // No operand predicates
     /* 2228234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228236 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2228236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2228239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2228248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228249 */     // GIR_Coverage, 267,
     /* 2228249 */     GIR_EraseRootFromParent_Done,
     /* 2228250 */   // Label 29529: @2228250
     /* 2228250 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2228295), // Rule ID 62574 //
     /* 2228255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2228258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2228270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2228278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10090),
     /* 2228282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228284 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10090>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2228284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2228287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228294 */     // GIR_Coverage, 62574,
     /* 2228294 */     GIR_EraseRootFromParent_Done,
     /* 2228295 */   // Label 29530: @2228295
     /* 2228295 */   GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2228367), // Rule ID 279 //
     /* 2228300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2228303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2228311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2228315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2228319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228324 */     // MIs[1] Operand 2
     /* 2228324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2228335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2228339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2228347 */     // MIs[2] Operand 1
     /* 2228347 */     // No operand predicates
     /* 2228347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10090),
     /* 2228351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2228353 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10090>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2228353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2228356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2228362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2228365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228366 */     // GIR_Coverage, 279,
     /* 2228366 */     GIR_EraseRootFromParent_Done,
     /* 2228367 */   // Label 29531: @2228367
     /* 2228367 */   GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2228409), // Rule ID 98 //
     /* 2228372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2228387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2228395 */     // MIs[1] Operand 1
     /* 2228395 */     // No operand predicates
     /* 2228395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228397 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2228397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2228400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228408 */     // GIR_Coverage, 98,
     /* 2228408 */     GIR_EraseRootFromParent_Done,
     /* 2228409 */   // Label 29532: @2228409
     /* 2228409 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2228446), // Rule ID 112 //
     /* 2228414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2228432 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2228432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2228435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2228444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228445 */     // GIR_Coverage, 112,
     /* 2228445 */     GIR_EraseRootFromParent_Done,
     /* 2228446 */   // Label 29533: @2228446
     /* 2228446 */   GIM_Reject,
     /* 2228447 */ // Label 29528: @2228447
     /* 2228447 */ GIM_Reject,
     /* 2228448 */ // Label 29502: @2228448
     /* 2228448 */ GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2228562),
     /* 2228453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2228456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2228459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228471 */   GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2228516), // Rule ID 48184 //
     /* 2228476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228479 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228515 */     // GIR_Coverage, 48184,
     /* 2228515 */     GIR_EraseRootFromParent_Done,
     /* 2228516 */   // Label 29535: @2228516
     /* 2228516 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2228561), // Rule ID 48185 //
     /* 2228521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228524 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228560 */     // GIR_Coverage, 48185,
     /* 2228560 */     GIR_EraseRootFromParent_Done,
     /* 2228561 */   // Label 29536: @2228561
     /* 2228561 */   GIM_Reject,
     /* 2228562 */ // Label 29534: @2228562
     /* 2228562 */ GIM_Reject,
     /* 2228563 */ // Label 29503: @2228563
     /* 2228563 */ GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2228677),
     /* 2228568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2228571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2228574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228586 */   GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2228631), // Rule ID 48196 //
     /* 2228591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228594 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228630 */     // GIR_Coverage, 48196,
     /* 2228630 */     GIR_EraseRootFromParent_Done,
     /* 2228631 */   // Label 29538: @2228631
     /* 2228631 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2228676), // Rule ID 48197 //
     /* 2228636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228639 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228675 */     // GIR_Coverage, 48197,
     /* 2228675 */     GIR_EraseRootFromParent_Done,
     /* 2228676 */   // Label 29539: @2228676
     /* 2228676 */   GIM_Reject,
     /* 2228677 */ // Label 29537: @2228677
     /* 2228677 */ GIM_Reject,
     /* 2228678 */ // Label 29504: @2228678
     /* 2228678 */ GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2228792),
     /* 2228683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2228689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228701 */   GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2228746), // Rule ID 48204 //
     /* 2228706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228709 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228745 */     // GIR_Coverage, 48204,
     /* 2228745 */     GIR_EraseRootFromParent_Done,
     /* 2228746 */   // Label 29541: @2228746
     /* 2228746 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2228791), // Rule ID 48205 //
     /* 2228751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228754 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228790 */     // GIR_Coverage, 48205,
     /* 2228790 */     GIR_EraseRootFromParent_Done,
     /* 2228791 */   // Label 29542: @2228791
     /* 2228791 */   GIM_Reject,
     /* 2228792 */ // Label 29540: @2228792
     /* 2228792 */ GIM_Reject,
     /* 2228793 */ // Label 29505: @2228793
     /* 2228793 */ GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2228907),
     /* 2228798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2228804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228816 */   GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2228861), // Rule ID 48220 //
     /* 2228821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228824 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228860 */     // GIR_Coverage, 48220,
     /* 2228860 */     GIR_EraseRootFromParent_Done,
     /* 2228861 */   // Label 29544: @2228861
     /* 2228861 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2228906), // Rule ID 48221 //
     /* 2228866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228869 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228905 */     // GIR_Coverage, 48221,
     /* 2228905 */     GIR_EraseRootFromParent_Done,
     /* 2228906 */   // Label 29545: @2228906
     /* 2228906 */   GIM_Reject,
     /* 2228907 */ // Label 29543: @2228907
     /* 2228907 */ GIM_Reject,
     /* 2228908 */ // Label 29506: @2228908
     /* 2228908 */ GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2229022),
     /* 2228913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2228919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228931 */   GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2228976), // Rule ID 48188 //
     /* 2228936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228939 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228975 */     // GIR_Coverage, 48188,
     /* 2228975 */     GIR_EraseRootFromParent_Done,
     /* 2228976 */   // Label 29547: @2228976
     /* 2228976 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2229021), // Rule ID 48189 //
     /* 2228981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228984 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2229001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229020 */     // GIR_Coverage, 48189,
     /* 2229020 */     GIR_EraseRootFromParent_Done,
     /* 2229021 */   // Label 29548: @2229021
     /* 2229021 */   GIM_Reject,
     /* 2229022 */ // Label 29546: @2229022
     /* 2229022 */ GIM_Reject,
     /* 2229023 */ // Label 29507: @2229023
     /* 2229023 */ GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2229137),
     /* 2229028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2229031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2229034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229046 */   GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2229091), // Rule ID 48200 //
     /* 2229051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229054 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2229057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229090 */     // GIR_Coverage, 48200,
     /* 2229090 */     GIR_EraseRootFromParent_Done,
     /* 2229091 */   // Label 29550: @2229091
     /* 2229091 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2229136), // Rule ID 48201 //
     /* 2229096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229099 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2229102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229135 */     // GIR_Coverage, 48201,
     /* 2229135 */     GIR_EraseRootFromParent_Done,
     /* 2229136 */   // Label 29551: @2229136
     /* 2229136 */   GIM_Reject,
     /* 2229137 */ // Label 29549: @2229137
     /* 2229137 */ GIM_Reject,
     /* 2229138 */ // Label 29508: @2229138
     /* 2229138 */ GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2229252),
     /* 2229143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2229146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2229149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229161 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2229206), // Rule ID 48216 //
     /* 2229166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229169 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2229172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229205 */     // GIR_Coverage, 48216,
     /* 2229205 */     GIR_EraseRootFromParent_Done,
     /* 2229206 */   // Label 29553: @2229206
     /* 2229206 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2229251), // Rule ID 48217 //
     /* 2229211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229214 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2229217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229250 */     // GIR_Coverage, 48217,
     /* 2229250 */     GIR_EraseRootFromParent_Done,
     /* 2229251 */   // Label 29554: @2229251
     /* 2229251 */   GIM_Reject,
     /* 2229252 */ // Label 29552: @2229252
     /* 2229252 */ GIM_Reject,
     /* 2229253 */ // Label 29509: @2229253
     /* 2229253 */ GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2229367),
     /* 2229258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2229261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2229264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229276 */   GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2229321), // Rule ID 48260 //
     /* 2229281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229284 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229320 */     // GIR_Coverage, 48260,
     /* 2229320 */     GIR_EraseRootFromParent_Done,
     /* 2229321 */   // Label 29556: @2229321
     /* 2229321 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2229366), // Rule ID 48261 //
     /* 2229326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229329 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2229332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229365 */     // GIR_Coverage, 48261,
     /* 2229365 */     GIR_EraseRootFromParent_Done,
     /* 2229366 */   // Label 29557: @2229366
     /* 2229366 */   GIM_Reject,
     /* 2229367 */ // Label 29555: @2229367
     /* 2229367 */ GIM_Reject,
     /* 2229368 */ // Label 29510: @2229368
     /* 2229368 */ GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2229482),
     /* 2229373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2229376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2229379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229391 */   GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2229436), // Rule ID 48192 //
     /* 2229396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229399 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2229402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229435 */     // GIR_Coverage, 48192,
     /* 2229435 */     GIR_EraseRootFromParent_Done,
     /* 2229436 */   // Label 29559: @2229436
     /* 2229436 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2229481), // Rule ID 48193 //
     /* 2229441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229444 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2229447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2229461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229480 */     // GIR_Coverage, 48193,
     /* 2229480 */     GIR_EraseRootFromParent_Done,
     /* 2229481 */   // Label 29560: @2229481
     /* 2229481 */   GIM_Reject,
     /* 2229482 */ // Label 29558: @2229482
     /* 2229482 */ GIM_Reject,
     /* 2229483 */ // Label 29511: @2229483
     /* 2229483 */ GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2229597),
     /* 2229488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2229494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229506 */   GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2229551), // Rule ID 48212 //
     /* 2229511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229514 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229550 */     // GIR_Coverage, 48212,
     /* 2229550 */     GIR_EraseRootFromParent_Done,
     /* 2229551 */   // Label 29562: @2229551
     /* 2229551 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2229596), // Rule ID 48213 //
     /* 2229556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229559 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229595 */     // GIR_Coverage, 48213,
     /* 2229595 */     GIR_EraseRootFromParent_Done,
     /* 2229596 */   // Label 29563: @2229596
     /* 2229596 */   GIM_Reject,
     /* 2229597 */ // Label 29561: @2229597
     /* 2229597 */ GIM_Reject,
     /* 2229598 */ // Label 29512: @2229598
     /* 2229598 */ GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2229712),
     /* 2229603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2229609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229621 */   GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2229666), // Rule ID 48248 //
     /* 2229626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229629 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229665 */     // GIR_Coverage, 48248,
     /* 2229665 */     GIR_EraseRootFromParent_Done,
     /* 2229666 */   // Label 29565: @2229666
     /* 2229666 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2229711), // Rule ID 48249 //
     /* 2229671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229674 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229710 */     // GIR_Coverage, 48249,
     /* 2229710 */     GIR_EraseRootFromParent_Done,
     /* 2229711 */   // Label 29566: @2229711
     /* 2229711 */   GIM_Reject,
     /* 2229712 */ // Label 29564: @2229712
     /* 2229712 */ GIM_Reject,
     /* 2229713 */ // Label 29513: @2229713
     /* 2229713 */ GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2229827),
     /* 2229718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2229724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229736 */   GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2229781), // Rule ID 48264 //
     /* 2229741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229744 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229780 */     // GIR_Coverage, 48264,
     /* 2229780 */     GIR_EraseRootFromParent_Done,
     /* 2229781 */   // Label 29568: @2229781
     /* 2229781 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2229826), // Rule ID 48265 //
     /* 2229786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229789 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229825 */     // GIR_Coverage, 48265,
     /* 2229825 */     GIR_EraseRootFromParent_Done,
     /* 2229826 */   // Label 29569: @2229826
     /* 2229826 */   GIM_Reject,
     /* 2229827 */ // Label 29567: @2229827
     /* 2229827 */ GIM_Reject,
     /* 2229828 */ // Label 29514: @2229828
     /* 2229828 */ GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2229942),
     /* 2229833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2229836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2229839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229851 */   GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2229896), // Rule ID 48208 //
     /* 2229856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229859 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229895 */     // GIR_Coverage, 48208,
     /* 2229895 */     GIR_EraseRootFromParent_Done,
     /* 2229896 */   // Label 29571: @2229896
     /* 2229896 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2229941), // Rule ID 48209 //
     /* 2229901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229904 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229940 */     // GIR_Coverage, 48209,
     /* 2229940 */     GIR_EraseRootFromParent_Done,
     /* 2229941 */   // Label 29572: @2229941
     /* 2229941 */   GIM_Reject,
     /* 2229942 */ // Label 29570: @2229942
     /* 2229942 */ GIM_Reject,
     /* 2229943 */ // Label 29515: @2229943
     /* 2229943 */ GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2230057),
     /* 2229948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2229951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2229954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229966 */   GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2230011), // Rule ID 48236 //
     /* 2229971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229974 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230010 */     // GIR_Coverage, 48236,
     /* 2230010 */     GIR_EraseRootFromParent_Done,
     /* 2230011 */   // Label 29574: @2230011
     /* 2230011 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2230056), // Rule ID 48237 //
     /* 2230016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230019 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2230022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230055 */     // GIR_Coverage, 48237,
     /* 2230055 */     GIR_EraseRootFromParent_Done,
     /* 2230056 */   // Label 29575: @2230056
     /* 2230056 */   GIM_Reject,
     /* 2230057 */ // Label 29573: @2230057
     /* 2230057 */ GIM_Reject,
     /* 2230058 */ // Label 29516: @2230058
     /* 2230058 */ GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2230172),
     /* 2230063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2230066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2230069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230081 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2230126), // Rule ID 48252 //
     /* 2230086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230089 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230125 */     // GIR_Coverage, 48252,
     /* 2230125 */     GIR_EraseRootFromParent_Done,
     /* 2230126 */   // Label 29577: @2230126
     /* 2230126 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2230171), // Rule ID 48253 //
     /* 2230131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230134 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2230137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230170 */     // GIR_Coverage, 48253,
     /* 2230170 */     GIR_EraseRootFromParent_Done,
     /* 2230171 */   // Label 29578: @2230171
     /* 2230171 */   GIM_Reject,
     /* 2230172 */ // Label 29576: @2230172
     /* 2230172 */ GIM_Reject,
     /* 2230173 */ // Label 29517: @2230173
     /* 2230173 */ GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2230287),
     /* 2230178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2230181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2230184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230196 */   GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2230241), // Rule ID 48268 //
     /* 2230201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2230204 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230240 */     // GIR_Coverage, 48268,
     /* 2230240 */     GIR_EraseRootFromParent_Done,
     /* 2230241 */   // Label 29580: @2230241
     /* 2230241 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2230286), // Rule ID 48269 //
     /* 2230246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2230249 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2230252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2230281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230285 */     // GIR_Coverage, 48269,
     /* 2230285 */     GIR_EraseRootFromParent_Done,
     /* 2230286 */   // Label 29581: @2230286
     /* 2230286 */   GIM_Reject,
     /* 2230287 */ // Label 29579: @2230287
     /* 2230287 */ GIM_Reject,
     /* 2230288 */ // Label 29518: @2230288
     /* 2230288 */ GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2230402),
     /* 2230293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2230296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2230299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2230311 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2230356), // Rule ID 48224 //
     /* 2230316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230319 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2230322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230355 */     // GIR_Coverage, 48224,
     /* 2230355 */     GIR_EraseRootFromParent_Done,
     /* 2230356 */   // Label 29583: @2230356
     /* 2230356 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2230401), // Rule ID 48225 //
     /* 2230361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230364 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2230367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2230381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230400 */     // GIR_Coverage, 48225,
     /* 2230400 */     GIR_EraseRootFromParent_Done,
     /* 2230401 */   // Label 29584: @2230401
     /* 2230401 */   GIM_Reject,
     /* 2230402 */ // Label 29582: @2230402
     /* 2230402 */ GIM_Reject,
     /* 2230403 */ // Label 29519: @2230403
     /* 2230403 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2230517),
     /* 2230408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2230411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2230414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230426 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2230471), // Rule ID 48240 //
     /* 2230431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230434 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230470 */     // GIR_Coverage, 48240,
     /* 2230470 */     GIR_EraseRootFromParent_Done,
     /* 2230471 */   // Label 29586: @2230471
     /* 2230471 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2230516), // Rule ID 48241 //
     /* 2230476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230479 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230515 */     // GIR_Coverage, 48241,
     /* 2230515 */     GIR_EraseRootFromParent_Done,
     /* 2230516 */   // Label 29587: @2230516
     /* 2230516 */   GIM_Reject,
     /* 2230517 */ // Label 29585: @2230517
     /* 2230517 */ GIM_Reject,
     /* 2230518 */ // Label 29520: @2230518
     /* 2230518 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2230632),
     /* 2230523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2230526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2230529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230541 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2230586), // Rule ID 48256 //
     /* 2230546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230549 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230585 */     // GIR_Coverage, 48256,
     /* 2230585 */     GIR_EraseRootFromParent_Done,
     /* 2230586 */   // Label 29589: @2230586
     /* 2230586 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2230631), // Rule ID 48257 //
     /* 2230591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230594 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230630 */     // GIR_Coverage, 48257,
     /* 2230630 */     GIR_EraseRootFromParent_Done,
     /* 2230631 */   // Label 29590: @2230631
     /* 2230631 */   GIM_Reject,
     /* 2230632 */ // Label 29588: @2230632
     /* 2230632 */ GIM_Reject,
     /* 2230633 */ // Label 29521: @2230633
     /* 2230633 */ GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2230747),
     /* 2230638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2230644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230656 */   GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2230701), // Rule ID 48228 //
     /* 2230661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230664 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230700 */     // GIR_Coverage, 48228,
     /* 2230700 */     GIR_EraseRootFromParent_Done,
     /* 2230701 */   // Label 29592: @2230701
     /* 2230701 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2230746), // Rule ID 48229 //
     /* 2230706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230709 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230745 */     // GIR_Coverage, 48229,
     /* 2230745 */     GIR_EraseRootFromParent_Done,
     /* 2230746 */   // Label 29593: @2230746
     /* 2230746 */   GIM_Reject,
     /* 2230747 */ // Label 29591: @2230747
     /* 2230747 */ GIM_Reject,
     /* 2230748 */ // Label 29522: @2230748
     /* 2230748 */ GIM_Try, /*On fail goto*//*Label 29594*/ GIMT_Encode4(2230862),
     /* 2230753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2230756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2230759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230771 */   GIM_Try, /*On fail goto*//*Label 29595*/ GIMT_Encode4(2230816), // Rule ID 48244 //
     /* 2230776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230779 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230815 */     // GIR_Coverage, 48244,
     /* 2230815 */     GIR_EraseRootFromParent_Done,
     /* 2230816 */   // Label 29595: @2230816
     /* 2230816 */   GIM_Try, /*On fail goto*//*Label 29596*/ GIMT_Encode4(2230861), // Rule ID 48245 //
     /* 2230821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230824 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230860 */     // GIR_Coverage, 48245,
     /* 2230860 */     GIR_EraseRootFromParent_Done,
     /* 2230861 */   // Label 29596: @2230861
     /* 2230861 */   GIM_Reject,
     /* 2230862 */ // Label 29594: @2230862
     /* 2230862 */ GIM_Reject,
     /* 2230863 */ // Label 29523: @2230863
     /* 2230863 */ GIM_Try, /*On fail goto*//*Label 29597*/ GIMT_Encode4(2230977),
     /* 2230868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2230871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2230874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230886 */   GIM_Try, /*On fail goto*//*Label 29598*/ GIMT_Encode4(2230931), // Rule ID 48232 //
     /* 2230891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230894 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230930 */     // GIR_Coverage, 48232,
     /* 2230930 */     GIR_EraseRootFromParent_Done,
     /* 2230931 */   // Label 29598: @2230931
     /* 2230931 */   GIM_Try, /*On fail goto*//*Label 29599*/ GIMT_Encode4(2230976), // Rule ID 48233 //
     /* 2230936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230939 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230975 */     // GIR_Coverage, 48233,
     /* 2230975 */     GIR_EraseRootFromParent_Done,
     /* 2230976 */   // Label 29599: @2230976
     /* 2230976 */   GIM_Reject,
     /* 2230977 */ // Label 29597: @2230977
     /* 2230977 */ GIM_Reject,
     /* 2230978 */ // Label 29524: @2230978
     /* 2230978 */ GIM_Reject,
     /* 2230979 */ // Label 45: @2230979
     /* 2230979 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29624*/ GIMT_Encode4(2233917),
     /* 2230990 */ /*GILLT_s32*//*Label 29600*/ GIMT_Encode4(2231114),
     /* 2230994 */ /*GILLT_s64*//*Label 29601*/ GIMT_Encode4(2231198), GIMT_Encode4(0),
     /* 2231002 */ /*GILLT_nxv1s8*//*Label 29602*/ GIMT_Encode4(2231387),
     /* 2231006 */ /*GILLT_nxv1s16*//*Label 29603*/ GIMT_Encode4(2231502),
     /* 2231010 */ /*GILLT_nxv1s32*//*Label 29604*/ GIMT_Encode4(2231617),
     /* 2231014 */ /*GILLT_nxv1s64*//*Label 29605*/ GIMT_Encode4(2231732), GIMT_Encode4(0),
     /* 2231022 */ /*GILLT_nxv2s8*//*Label 29606*/ GIMT_Encode4(2231847),
     /* 2231026 */ /*GILLT_nxv2s16*//*Label 29607*/ GIMT_Encode4(2231962),
     /* 2231030 */ /*GILLT_nxv2s32*//*Label 29608*/ GIMT_Encode4(2232077),
     /* 2231034 */ /*GILLT_nxv2s64*//*Label 29609*/ GIMT_Encode4(2232192), GIMT_Encode4(0),
     /* 2231042 */ /*GILLT_nxv4s8*//*Label 29610*/ GIMT_Encode4(2232307),
     /* 2231046 */ /*GILLT_nxv4s16*//*Label 29611*/ GIMT_Encode4(2232422),
     /* 2231050 */ /*GILLT_nxv4s32*//*Label 29612*/ GIMT_Encode4(2232537),
     /* 2231054 */ /*GILLT_nxv4s64*//*Label 29613*/ GIMT_Encode4(2232652), GIMT_Encode4(0),
     /* 2231062 */ /*GILLT_nxv8s8*//*Label 29614*/ GIMT_Encode4(2232767),
     /* 2231066 */ /*GILLT_nxv8s16*//*Label 29615*/ GIMT_Encode4(2232882),
     /* 2231070 */ /*GILLT_nxv8s32*//*Label 29616*/ GIMT_Encode4(2232997),
     /* 2231074 */ /*GILLT_nxv8s64*//*Label 29617*/ GIMT_Encode4(2233112), GIMT_Encode4(0),
     /* 2231082 */ /*GILLT_nxv16s8*//*Label 29618*/ GIMT_Encode4(2233227),
     /* 2231086 */ /*GILLT_nxv16s16*//*Label 29619*/ GIMT_Encode4(2233342),
     /* 2231090 */ /*GILLT_nxv16s32*//*Label 29620*/ GIMT_Encode4(2233457), GIMT_Encode4(0),
     /* 2231098 */ /*GILLT_nxv32s8*//*Label 29621*/ GIMT_Encode4(2233572),
     /* 2231102 */ /*GILLT_nxv32s16*//*Label 29622*/ GIMT_Encode4(2233687), GIMT_Encode4(0),
     /* 2231110 */ /*GILLT_nxv64s8*//*Label 29623*/ GIMT_Encode4(2233802),
     /* 2231114 */ // Label 29600: @2231114
     /* 2231114 */ GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2231197),
     /* 2231119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2231122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231133 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2231167), // Rule ID 101 //
     /* 2231138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231153 */     // MIs[1] Operand 1
     /* 2231153 */     // No operand predicates
     /* 2231153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231155 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2231158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231166 */     // GIR_Coverage, 101,
     /* 2231166 */     GIR_EraseRootFromParent_Done,
     /* 2231167 */   // Label 29626: @2231167
     /* 2231167 */   GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2231196), // Rule ID 115 //
     /* 2231172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231182 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2231185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231195 */     // GIR_Coverage, 115,
     /* 2231195 */     GIR_EraseRootFromParent_Done,
     /* 2231196 */   // Label 29627: @2231196
     /* 2231196 */   GIM_Reject,
     /* 2231197 */ // Label 29625: @2231197
     /* 2231197 */ GIM_Reject,
     /* 2231198 */ // Label 29601: @2231198
     /* 2231198 */ GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2231386),
     /* 2231203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2231209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231213 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2231250), // Rule ID 62573 //
     /* 2231218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2231221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2231229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2231237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231239 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2231239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2231242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231249 */     // GIR_Coverage, 62573,
     /* 2231249 */     GIR_EraseRootFromParent_Done,
     /* 2231250 */   // Label 29629: @2231250
     /* 2231250 */   GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2231314), // Rule ID 269 //
     /* 2231255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2231258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2231262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2231266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2231270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231275 */     // MIs[1] Operand 2
     /* 2231275 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2231286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2231290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2231298 */     // MIs[2] Operand 1
     /* 2231298 */     // No operand predicates
     /* 2231298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2231300 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2231300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2231303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2231309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2231312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231313 */     // GIR_Coverage, 269,
     /* 2231313 */     GIR_EraseRootFromParent_Done,
     /* 2231314 */   // Label 29630: @2231314
     /* 2231314 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2231352), // Rule ID 100 //
     /* 2231319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2231330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2231338 */     // MIs[1] Operand 1
     /* 2231338 */     // No operand predicates
     /* 2231338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231340 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2231340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2231343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2231350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231351 */     // GIR_Coverage, 100,
     /* 2231351 */     GIR_EraseRootFromParent_Done,
     /* 2231352 */   // Label 29631: @2231352
     /* 2231352 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2231385), // Rule ID 114 //
     /* 2231357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2231371 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2231371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2231374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2231383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231384 */     // GIR_Coverage, 114,
     /* 2231384 */     GIR_EraseRootFromParent_Done,
     /* 2231385 */   // Label 29632: @2231385
     /* 2231385 */   GIM_Reject,
     /* 2231386 */ // Label 29628: @2231386
     /* 2231386 */ GIM_Reject,
     /* 2231387 */ // Label 29602: @2231387
     /* 2231387 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2231501),
     /* 2231392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2231395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231410 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2231455), // Rule ID 48316 //
     /* 2231415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231418 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231454 */     // GIR_Coverage, 48316,
     /* 2231454 */     GIR_EraseRootFromParent_Done,
     /* 2231455 */   // Label 29634: @2231455
     /* 2231455 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2231500), // Rule ID 48317 //
     /* 2231460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231463 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231499 */     // GIR_Coverage, 48317,
     /* 2231499 */     GIR_EraseRootFromParent_Done,
     /* 2231500 */   // Label 29635: @2231500
     /* 2231500 */   GIM_Reject,
     /* 2231501 */ // Label 29633: @2231501
     /* 2231501 */ GIM_Reject,
     /* 2231502 */ // Label 29603: @2231502
     /* 2231502 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2231616),
     /* 2231507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2231510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231525 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2231570), // Rule ID 48328 //
     /* 2231530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231533 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231569 */     // GIR_Coverage, 48328,
     /* 2231569 */     GIR_EraseRootFromParent_Done,
     /* 2231570 */   // Label 29637: @2231570
     /* 2231570 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2231615), // Rule ID 48329 //
     /* 2231575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231578 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231614 */     // GIR_Coverage, 48329,
     /* 2231614 */     GIR_EraseRootFromParent_Done,
     /* 2231615 */   // Label 29638: @2231615
     /* 2231615 */   GIM_Reject,
     /* 2231616 */ // Label 29636: @2231616
     /* 2231616 */ GIM_Reject,
     /* 2231617 */ // Label 29604: @2231617
     /* 2231617 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2231731),
     /* 2231622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2231625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231640 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2231685), // Rule ID 48336 //
     /* 2231645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231648 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231684 */     // GIR_Coverage, 48336,
     /* 2231684 */     GIR_EraseRootFromParent_Done,
     /* 2231685 */   // Label 29640: @2231685
     /* 2231685 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2231730), // Rule ID 48337 //
     /* 2231690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231693 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231729 */     // GIR_Coverage, 48337,
     /* 2231729 */     GIR_EraseRootFromParent_Done,
     /* 2231730 */   // Label 29641: @2231730
     /* 2231730 */   GIM_Reject,
     /* 2231731 */ // Label 29639: @2231731
     /* 2231731 */ GIM_Reject,
     /* 2231732 */ // Label 29605: @2231732
     /* 2231732 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2231846),
     /* 2231737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2231740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231755 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2231800), // Rule ID 48352 //
     /* 2231760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231763 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231799 */     // GIR_Coverage, 48352,
     /* 2231799 */     GIR_EraseRootFromParent_Done,
     /* 2231800 */   // Label 29643: @2231800
     /* 2231800 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2231845), // Rule ID 48353 //
     /* 2231805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231808 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231844 */     // GIR_Coverage, 48353,
     /* 2231844 */     GIR_EraseRootFromParent_Done,
     /* 2231845 */   // Label 29644: @2231845
     /* 2231845 */   GIM_Reject,
     /* 2231846 */ // Label 29642: @2231846
     /* 2231846 */ GIM_Reject,
     /* 2231847 */ // Label 29606: @2231847
     /* 2231847 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2231961),
     /* 2231852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2231855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2231858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231870 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2231915), // Rule ID 48320 //
     /* 2231875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231878 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231914 */     // GIR_Coverage, 48320,
     /* 2231914 */     GIR_EraseRootFromParent_Done,
     /* 2231915 */   // Label 29646: @2231915
     /* 2231915 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2231960), // Rule ID 48321 //
     /* 2231920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231923 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231959 */     // GIR_Coverage, 48321,
     /* 2231959 */     GIR_EraseRootFromParent_Done,
     /* 2231960 */   // Label 29647: @2231960
     /* 2231960 */   GIM_Reject,
     /* 2231961 */ // Label 29645: @2231961
     /* 2231961 */ GIM_Reject,
     /* 2231962 */ // Label 29607: @2231962
     /* 2231962 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2232076),
     /* 2231967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2231970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2231973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231985 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2232030), // Rule ID 48332 //
     /* 2231990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231993 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2231996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232029 */     // GIR_Coverage, 48332,
     /* 2232029 */     GIR_EraseRootFromParent_Done,
     /* 2232030 */   // Label 29649: @2232030
     /* 2232030 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2232075), // Rule ID 48333 //
     /* 2232035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232038 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2232041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232074 */     // GIR_Coverage, 48333,
     /* 2232074 */     GIR_EraseRootFromParent_Done,
     /* 2232075 */   // Label 29650: @2232075
     /* 2232075 */   GIM_Reject,
     /* 2232076 */ // Label 29648: @2232076
     /* 2232076 */ GIM_Reject,
     /* 2232077 */ // Label 29608: @2232077
     /* 2232077 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2232191),
     /* 2232082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2232085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2232088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232100 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2232145), // Rule ID 48348 //
     /* 2232105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232108 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232144 */     // GIR_Coverage, 48348,
     /* 2232144 */     GIR_EraseRootFromParent_Done,
     /* 2232145 */   // Label 29652: @2232145
     /* 2232145 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2232190), // Rule ID 48349 //
     /* 2232150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232153 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2232156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232189 */     // GIR_Coverage, 48349,
     /* 2232189 */     GIR_EraseRootFromParent_Done,
     /* 2232190 */   // Label 29653: @2232190
     /* 2232190 */   GIM_Reject,
     /* 2232191 */ // Label 29651: @2232191
     /* 2232191 */ GIM_Reject,
     /* 2232192 */ // Label 29609: @2232192
     /* 2232192 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2232306),
     /* 2232197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2232200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2232203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232215 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2232260), // Rule ID 48392 //
     /* 2232220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232223 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232259 */     // GIR_Coverage, 48392,
     /* 2232259 */     GIR_EraseRootFromParent_Done,
     /* 2232260 */   // Label 29655: @2232260
     /* 2232260 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2232305), // Rule ID 48393 //
     /* 2232265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232268 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2232271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232304 */     // GIR_Coverage, 48393,
     /* 2232304 */     GIR_EraseRootFromParent_Done,
     /* 2232305 */   // Label 29656: @2232305
     /* 2232305 */   GIM_Reject,
     /* 2232306 */ // Label 29654: @2232306
     /* 2232306 */ GIM_Reject,
     /* 2232307 */ // Label 29610: @2232307
     /* 2232307 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2232421),
     /* 2232312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2232315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2232318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232330 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2232375), // Rule ID 48324 //
     /* 2232335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232338 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232374 */     // GIR_Coverage, 48324,
     /* 2232374 */     GIR_EraseRootFromParent_Done,
     /* 2232375 */   // Label 29658: @2232375
     /* 2232375 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2232420), // Rule ID 48325 //
     /* 2232380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232383 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2232386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2232400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232419 */     // GIR_Coverage, 48325,
     /* 2232419 */     GIR_EraseRootFromParent_Done,
     /* 2232420 */   // Label 29659: @2232420
     /* 2232420 */   GIM_Reject,
     /* 2232421 */ // Label 29657: @2232421
     /* 2232421 */ GIM_Reject,
     /* 2232422 */ // Label 29611: @2232422
     /* 2232422 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2232536),
     /* 2232427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2232430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2232433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232445 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2232490), // Rule ID 48344 //
     /* 2232450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232453 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232489 */     // GIR_Coverage, 48344,
     /* 2232489 */     GIR_EraseRootFromParent_Done,
     /* 2232490 */   // Label 29661: @2232490
     /* 2232490 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2232535), // Rule ID 48345 //
     /* 2232495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232498 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232534 */     // GIR_Coverage, 48345,
     /* 2232534 */     GIR_EraseRootFromParent_Done,
     /* 2232535 */   // Label 29662: @2232535
     /* 2232535 */   GIM_Reject,
     /* 2232536 */ // Label 29660: @2232536
     /* 2232536 */ GIM_Reject,
     /* 2232537 */ // Label 29612: @2232537
     /* 2232537 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2232651),
     /* 2232542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2232548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232560 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2232605), // Rule ID 48380 //
     /* 2232565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232568 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232604 */     // GIR_Coverage, 48380,
     /* 2232604 */     GIR_EraseRootFromParent_Done,
     /* 2232605 */   // Label 29664: @2232605
     /* 2232605 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2232650), // Rule ID 48381 //
     /* 2232610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232613 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232649 */     // GIR_Coverage, 48381,
     /* 2232649 */     GIR_EraseRootFromParent_Done,
     /* 2232650 */   // Label 29665: @2232650
     /* 2232650 */   GIM_Reject,
     /* 2232651 */ // Label 29663: @2232651
     /* 2232651 */ GIM_Reject,
     /* 2232652 */ // Label 29613: @2232652
     /* 2232652 */ GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2232766),
     /* 2232657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2232660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2232663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232675 */   GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2232720), // Rule ID 48396 //
     /* 2232680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232683 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232719 */     // GIR_Coverage, 48396,
     /* 2232719 */     GIR_EraseRootFromParent_Done,
     /* 2232720 */   // Label 29667: @2232720
     /* 2232720 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2232765), // Rule ID 48397 //
     /* 2232725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232728 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232764 */     // GIR_Coverage, 48397,
     /* 2232764 */     GIR_EraseRootFromParent_Done,
     /* 2232765 */   // Label 29668: @2232765
     /* 2232765 */   GIM_Reject,
     /* 2232766 */ // Label 29666: @2232766
     /* 2232766 */ GIM_Reject,
     /* 2232767 */ // Label 29614: @2232767
     /* 2232767 */ GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2232881),
     /* 2232772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2232775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2232778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232790 */   GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2232835), // Rule ID 48340 //
     /* 2232795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232798 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232834 */     // GIR_Coverage, 48340,
     /* 2232834 */     GIR_EraseRootFromParent_Done,
     /* 2232835 */   // Label 29670: @2232835
     /* 2232835 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2232880), // Rule ID 48341 //
     /* 2232840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232843 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232879 */     // GIR_Coverage, 48341,
     /* 2232879 */     GIR_EraseRootFromParent_Done,
     /* 2232880 */   // Label 29671: @2232880
     /* 2232880 */   GIM_Reject,
     /* 2232881 */ // Label 29669: @2232881
     /* 2232881 */ GIM_Reject,
     /* 2232882 */ // Label 29615: @2232882
     /* 2232882 */ GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2232996),
     /* 2232887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2232890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2232893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232905 */   GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2232950), // Rule ID 48368 //
     /* 2232910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232913 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232949 */     // GIR_Coverage, 48368,
     /* 2232949 */     GIR_EraseRootFromParent_Done,
     /* 2232950 */   // Label 29673: @2232950
     /* 2232950 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2232995), // Rule ID 48369 //
     /* 2232955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232958 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232994 */     // GIR_Coverage, 48369,
     /* 2232994 */     GIR_EraseRootFromParent_Done,
     /* 2232995 */   // Label 29674: @2232995
     /* 2232995 */   GIM_Reject,
     /* 2232996 */ // Label 29672: @2232996
     /* 2232996 */ GIM_Reject,
     /* 2232997 */ // Label 29616: @2232997
     /* 2232997 */ GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2233111),
     /* 2233002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2233005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2233008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233020 */   GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2233065), // Rule ID 48384 //
     /* 2233025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233028 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233064 */     // GIR_Coverage, 48384,
     /* 2233064 */     GIR_EraseRootFromParent_Done,
     /* 2233065 */   // Label 29676: @2233065
     /* 2233065 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2233110), // Rule ID 48385 //
     /* 2233070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233073 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2233076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233109 */     // GIR_Coverage, 48385,
     /* 2233109 */     GIR_EraseRootFromParent_Done,
     /* 2233110 */   // Label 29677: @2233110
     /* 2233110 */   GIM_Reject,
     /* 2233111 */ // Label 29675: @2233111
     /* 2233111 */ GIM_Reject,
     /* 2233112 */ // Label 29617: @2233112
     /* 2233112 */ GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2233226),
     /* 2233117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2233120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2233123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233135 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2233180), // Rule ID 48400 //
     /* 2233140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233143 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233179 */     // GIR_Coverage, 48400,
     /* 2233179 */     GIR_EraseRootFromParent_Done,
     /* 2233180 */   // Label 29679: @2233180
     /* 2233180 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2233225), // Rule ID 48401 //
     /* 2233185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233188 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2233191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233224 */     // GIR_Coverage, 48401,
     /* 2233224 */     GIR_EraseRootFromParent_Done,
     /* 2233225 */   // Label 29680: @2233225
     /* 2233225 */   GIM_Reject,
     /* 2233226 */ // Label 29678: @2233226
     /* 2233226 */ GIM_Reject,
     /* 2233227 */ // Label 29618: @2233227
     /* 2233227 */ GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2233341),
     /* 2233232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2233235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2233238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2233250 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2233295), // Rule ID 48356 //
     /* 2233255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233258 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2233275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233294 */     // GIR_Coverage, 48356,
     /* 2233294 */     GIR_EraseRootFromParent_Done,
     /* 2233295 */   // Label 29682: @2233295
     /* 2233295 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2233340), // Rule ID 48357 //
     /* 2233300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233303 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2233306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2233320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233339 */     // GIR_Coverage, 48357,
     /* 2233339 */     GIR_EraseRootFromParent_Done,
     /* 2233340 */   // Label 29683: @2233340
     /* 2233340 */   GIM_Reject,
     /* 2233341 */ // Label 29681: @2233341
     /* 2233341 */ GIM_Reject,
     /* 2233342 */ // Label 29619: @2233342
     /* 2233342 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2233456),
     /* 2233347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2233350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2233353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233365 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2233410), // Rule ID 48372 //
     /* 2233370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233373 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233409 */     // GIR_Coverage, 48372,
     /* 2233409 */     GIR_EraseRootFromParent_Done,
     /* 2233410 */   // Label 29685: @2233410
     /* 2233410 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2233455), // Rule ID 48373 //
     /* 2233415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233418 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2233421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233454 */     // GIR_Coverage, 48373,
     /* 2233454 */     GIR_EraseRootFromParent_Done,
     /* 2233455 */   // Label 29686: @2233455
     /* 2233455 */   GIM_Reject,
     /* 2233456 */ // Label 29684: @2233456
     /* 2233456 */ GIM_Reject,
     /* 2233457 */ // Label 29620: @2233457
     /* 2233457 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2233571),
     /* 2233462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2233465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2233468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233480 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2233525), // Rule ID 48388 //
     /* 2233485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233488 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233524 */     // GIR_Coverage, 48388,
     /* 2233524 */     GIR_EraseRootFromParent_Done,
     /* 2233525 */   // Label 29688: @2233525
     /* 2233525 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2233570), // Rule ID 48389 //
     /* 2233530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233533 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233569 */     // GIR_Coverage, 48389,
     /* 2233569 */     GIR_EraseRootFromParent_Done,
     /* 2233570 */   // Label 29689: @2233570
     /* 2233570 */   GIM_Reject,
     /* 2233571 */ // Label 29687: @2233571
     /* 2233571 */ GIM_Reject,
     /* 2233572 */ // Label 29621: @2233572
     /* 2233572 */ GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2233686),
     /* 2233577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2233580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2233583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233595 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2233640), // Rule ID 48360 //
     /* 2233600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233603 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233639 */     // GIR_Coverage, 48360,
     /* 2233639 */     GIR_EraseRootFromParent_Done,
     /* 2233640 */   // Label 29691: @2233640
     /* 2233640 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2233685), // Rule ID 48361 //
     /* 2233645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233648 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233684 */     // GIR_Coverage, 48361,
     /* 2233684 */     GIR_EraseRootFromParent_Done,
     /* 2233685 */   // Label 29692: @2233685
     /* 2233685 */   GIM_Reject,
     /* 2233686 */ // Label 29690: @2233686
     /* 2233686 */ GIM_Reject,
     /* 2233687 */ // Label 29622: @2233687
     /* 2233687 */ GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2233801),
     /* 2233692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2233695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2233698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233710 */   GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2233755), // Rule ID 48376 //
     /* 2233715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233718 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233754 */     // GIR_Coverage, 48376,
     /* 2233754 */     GIR_EraseRootFromParent_Done,
     /* 2233755 */   // Label 29694: @2233755
     /* 2233755 */   GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2233800), // Rule ID 48377 //
     /* 2233760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233763 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233799 */     // GIR_Coverage, 48377,
     /* 2233799 */     GIR_EraseRootFromParent_Done,
     /* 2233800 */   // Label 29695: @2233800
     /* 2233800 */   GIM_Reject,
     /* 2233801 */ // Label 29693: @2233801
     /* 2233801 */ GIM_Reject,
     /* 2233802 */ // Label 29623: @2233802
     /* 2233802 */ GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2233916),
     /* 2233807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2233810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2233813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233825 */   GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2233870), // Rule ID 48364 //
     /* 2233830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233833 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233869 */     // GIR_Coverage, 48364,
     /* 2233869 */     GIR_EraseRootFromParent_Done,
     /* 2233870 */   // Label 29697: @2233870
     /* 2233870 */   GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2233915), // Rule ID 48365 //
     /* 2233875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233878 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233914 */     // GIR_Coverage, 48365,
     /* 2233914 */     GIR_EraseRootFromParent_Done,
     /* 2233915 */   // Label 29698: @2233915
     /* 2233915 */   GIM_Reject,
     /* 2233916 */ // Label 29696: @2233916
     /* 2233916 */ GIM_Reject,
     /* 2233917 */ // Label 29624: @2233917
     /* 2233917 */ GIM_Reject,
     /* 2233918 */ // Label 46: @2233918
     /* 2233918 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29723*/ GIMT_Encode4(2236857),
     /* 2233929 */ /*GILLT_s32*//*Label 29699*/ GIMT_Encode4(2234053),
     /* 2233933 */ /*GILLT_s64*//*Label 29700*/ GIMT_Encode4(2234190), GIMT_Encode4(0),
     /* 2233941 */ /*GILLT_nxv1s8*//*Label 29701*/ GIMT_Encode4(2234327),
     /* 2233945 */ /*GILLT_nxv1s16*//*Label 29702*/ GIMT_Encode4(2234442),
     /* 2233949 */ /*GILLT_nxv1s32*//*Label 29703*/ GIMT_Encode4(2234557),
     /* 2233953 */ /*GILLT_nxv1s64*//*Label 29704*/ GIMT_Encode4(2234672), GIMT_Encode4(0),
     /* 2233961 */ /*GILLT_nxv2s8*//*Label 29705*/ GIMT_Encode4(2234787),
     /* 2233965 */ /*GILLT_nxv2s16*//*Label 29706*/ GIMT_Encode4(2234902),
     /* 2233969 */ /*GILLT_nxv2s32*//*Label 29707*/ GIMT_Encode4(2235017),
     /* 2233973 */ /*GILLT_nxv2s64*//*Label 29708*/ GIMT_Encode4(2235132), GIMT_Encode4(0),
     /* 2233981 */ /*GILLT_nxv4s8*//*Label 29709*/ GIMT_Encode4(2235247),
     /* 2233985 */ /*GILLT_nxv4s16*//*Label 29710*/ GIMT_Encode4(2235362),
     /* 2233989 */ /*GILLT_nxv4s32*//*Label 29711*/ GIMT_Encode4(2235477),
     /* 2233993 */ /*GILLT_nxv4s64*//*Label 29712*/ GIMT_Encode4(2235592), GIMT_Encode4(0),
     /* 2234001 */ /*GILLT_nxv8s8*//*Label 29713*/ GIMT_Encode4(2235707),
     /* 2234005 */ /*GILLT_nxv8s16*//*Label 29714*/ GIMT_Encode4(2235822),
     /* 2234009 */ /*GILLT_nxv8s32*//*Label 29715*/ GIMT_Encode4(2235937),
     /* 2234013 */ /*GILLT_nxv8s64*//*Label 29716*/ GIMT_Encode4(2236052), GIMT_Encode4(0),
     /* 2234021 */ /*GILLT_nxv16s8*//*Label 29717*/ GIMT_Encode4(2236167),
     /* 2234025 */ /*GILLT_nxv16s16*//*Label 29718*/ GIMT_Encode4(2236282),
     /* 2234029 */ /*GILLT_nxv16s32*//*Label 29719*/ GIMT_Encode4(2236397), GIMT_Encode4(0),
     /* 2234037 */ /*GILLT_nxv32s8*//*Label 29720*/ GIMT_Encode4(2236512),
     /* 2234041 */ /*GILLT_nxv32s16*//*Label 29721*/ GIMT_Encode4(2236627), GIMT_Encode4(0),
     /* 2234049 */ /*GILLT_nxv64s8*//*Label 29722*/ GIMT_Encode4(2236742),
     /* 2234053 */ // Label 29699: @2234053
     /* 2234053 */ GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2234189),
     /* 2234058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2234061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2234064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234072 */   GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2234106), // Rule ID 2465 //
     /* 2234077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2234080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234092 */     // MIs[1] Operand 1
     /* 2234092 */     // No operand predicates
     /* 2234092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234094 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2234097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234105 */     // GIR_Coverage, 2465,
     /* 2234105 */     GIR_EraseRootFromParent_Done,
     /* 2234106 */   // Label 29725: @2234106
     /* 2234106 */   GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2234140), // Rule ID 62556 //
     /* 2234111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2234114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234126 */     // MIs[1] Operand 1
     /* 2234126 */     // No operand predicates
     /* 2234126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234128 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2234131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234139 */     // GIR_Coverage, 62556,
     /* 2234139 */     GIR_EraseRootFromParent_Done,
     /* 2234140 */   // Label 29726: @2234140
     /* 2234140 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2234169), // Rule ID 2463 //
     /* 2234145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2234148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234155 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2234155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2234158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234168 */     // GIR_Coverage, 2463,
     /* 2234168 */     GIR_EraseRootFromParent_Done,
     /* 2234169 */   // Label 29727: @2234169
     /* 2234169 */   GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2234188), // Rule ID 64450 //
     /* 2234174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2234177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234181 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2234181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2234186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234187 */     // GIR_Coverage, 64450,
     /* 2234187 */     GIR_Done,
     /* 2234188 */   // Label 29728: @2234188
     /* 2234188 */   GIM_Reject,
     /* 2234189 */ // Label 29724: @2234189
     /* 2234189 */ GIM_Reject,
     /* 2234190 */ // Label 29700: @2234190
     /* 2234190 */ GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2234326),
     /* 2234195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2234198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234209 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2234243), // Rule ID 2464 //
     /* 2234214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2234217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234229 */     // MIs[1] Operand 1
     /* 2234229 */     // No operand predicates
     /* 2234229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234231 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2234234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234242 */     // GIR_Coverage, 2464,
     /* 2234242 */     GIR_EraseRootFromParent_Done,
     /* 2234243 */   // Label 29730: @2234243
     /* 2234243 */   GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2234277), // Rule ID 62555 //
     /* 2234248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2234251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2234255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2234263 */     // MIs[1] Operand 1
     /* 2234263 */     // No operand predicates
     /* 2234263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234265 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2234265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2234268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2234275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234276 */     // GIR_Coverage, 62555,
     /* 2234276 */     GIR_EraseRootFromParent_Done,
     /* 2234277 */   // Label 29731: @2234277
     /* 2234277 */   GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2234306), // Rule ID 2462 //
     /* 2234282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2234285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2234292 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2234295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2234304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234305 */     // GIR_Coverage, 2462,
     /* 2234305 */     GIR_EraseRootFromParent_Done,
     /* 2234306 */   // Label 29732: @2234306
     /* 2234306 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2234325), // Rule ID 64449 //
     /* 2234311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2234314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234318 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2234323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234324 */     // GIR_Coverage, 64449,
     /* 2234324 */     GIR_Done,
     /* 2234325 */   // Label 29733: @2234325
     /* 2234325 */   GIM_Reject,
     /* 2234326 */ // Label 29729: @2234326
     /* 2234326 */ GIM_Reject,
     /* 2234327 */ // Label 29701: @2234327
     /* 2234327 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2234441),
     /* 2234332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2234335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234350 */   GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2234395), // Rule ID 59408 //
     /* 2234355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234358 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2234375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234394 */     // GIR_Coverage, 59408,
     /* 2234394 */     GIR_EraseRootFromParent_Done,
     /* 2234395 */   // Label 29735: @2234395
     /* 2234395 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2234440), // Rule ID 59409 //
     /* 2234400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234403 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2234406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2234420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234439 */     // GIR_Coverage, 59409,
     /* 2234439 */     GIR_EraseRootFromParent_Done,
     /* 2234440 */   // Label 29736: @2234440
     /* 2234440 */   GIM_Reject,
     /* 2234441 */ // Label 29734: @2234441
     /* 2234441 */ GIM_Reject,
     /* 2234442 */ // Label 29702: @2234442
     /* 2234442 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2234556),
     /* 2234447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2234450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234465 */   GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2234510), // Rule ID 59420 //
     /* 2234470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234473 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234509 */     // GIR_Coverage, 59420,
     /* 2234509 */     GIR_EraseRootFromParent_Done,
     /* 2234510 */   // Label 29738: @2234510
     /* 2234510 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2234555), // Rule ID 59421 //
     /* 2234515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234518 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234554 */     // GIR_Coverage, 59421,
     /* 2234554 */     GIR_EraseRootFromParent_Done,
     /* 2234555 */   // Label 29739: @2234555
     /* 2234555 */   GIM_Reject,
     /* 2234556 */ // Label 29737: @2234556
     /* 2234556 */ GIM_Reject,
     /* 2234557 */ // Label 29703: @2234557
     /* 2234557 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2234671),
     /* 2234562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2234565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234580 */   GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2234625), // Rule ID 59428 //
     /* 2234585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234588 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234624 */     // GIR_Coverage, 59428,
     /* 2234624 */     GIR_EraseRootFromParent_Done,
     /* 2234625 */   // Label 29741: @2234625
     /* 2234625 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2234670), // Rule ID 59429 //
     /* 2234630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234633 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234669 */     // GIR_Coverage, 59429,
     /* 2234669 */     GIR_EraseRootFromParent_Done,
     /* 2234670 */   // Label 29742: @2234670
     /* 2234670 */   GIM_Reject,
     /* 2234671 */ // Label 29740: @2234671
     /* 2234671 */ GIM_Reject,
     /* 2234672 */ // Label 29704: @2234672
     /* 2234672 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2234786),
     /* 2234677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2234680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234695 */   GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2234740), // Rule ID 59444 //
     /* 2234700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234703 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234739 */     // GIR_Coverage, 59444,
     /* 2234739 */     GIR_EraseRootFromParent_Done,
     /* 2234740 */   // Label 29744: @2234740
     /* 2234740 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2234785), // Rule ID 59445 //
     /* 2234745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234748 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234784 */     // GIR_Coverage, 59445,
     /* 2234784 */     GIR_EraseRootFromParent_Done,
     /* 2234785 */   // Label 29745: @2234785
     /* 2234785 */   GIM_Reject,
     /* 2234786 */ // Label 29743: @2234786
     /* 2234786 */ GIM_Reject,
     /* 2234787 */ // Label 29705: @2234787
     /* 2234787 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2234901),
     /* 2234792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2234795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234810 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2234855), // Rule ID 59412 //
     /* 2234815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234818 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234854 */     // GIR_Coverage, 59412,
     /* 2234854 */     GIR_EraseRootFromParent_Done,
     /* 2234855 */   // Label 29747: @2234855
     /* 2234855 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2234900), // Rule ID 59413 //
     /* 2234860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234863 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234899 */     // GIR_Coverage, 59413,
     /* 2234899 */     GIR_EraseRootFromParent_Done,
     /* 2234900 */   // Label 29748: @2234900
     /* 2234900 */   GIM_Reject,
     /* 2234901 */ // Label 29746: @2234901
     /* 2234901 */ GIM_Reject,
     /* 2234902 */ // Label 29706: @2234902
     /* 2234902 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2235016),
     /* 2234907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2234910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2234913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234925 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2234970), // Rule ID 59424 //
     /* 2234930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234933 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234969 */     // GIR_Coverage, 59424,
     /* 2234969 */     GIR_EraseRootFromParent_Done,
     /* 2234970 */   // Label 29750: @2234970
     /* 2234970 */   GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2235015), // Rule ID 59425 //
     /* 2234975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234978 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235014 */     // GIR_Coverage, 59425,
     /* 2235014 */     GIR_EraseRootFromParent_Done,
     /* 2235015 */   // Label 29751: @2235015
     /* 2235015 */   GIM_Reject,
     /* 2235016 */ // Label 29749: @2235016
     /* 2235016 */ GIM_Reject,
     /* 2235017 */ // Label 29707: @2235017
     /* 2235017 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2235131),
     /* 2235022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2235025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235040 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2235085), // Rule ID 59440 //
     /* 2235045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235048 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235084 */     // GIR_Coverage, 59440,
     /* 2235084 */     GIR_EraseRootFromParent_Done,
     /* 2235085 */   // Label 29753: @2235085
     /* 2235085 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2235130), // Rule ID 59441 //
     /* 2235090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235093 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2235096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235129 */     // GIR_Coverage, 59441,
     /* 2235129 */     GIR_EraseRootFromParent_Done,
     /* 2235130 */   // Label 29754: @2235130
     /* 2235130 */   GIM_Reject,
     /* 2235131 */ // Label 29752: @2235131
     /* 2235131 */ GIM_Reject,
     /* 2235132 */ // Label 29708: @2235132
     /* 2235132 */ GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2235246),
     /* 2235137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2235140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235155 */   GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2235200), // Rule ID 59484 //
     /* 2235160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235163 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235199 */     // GIR_Coverage, 59484,
     /* 2235199 */     GIR_EraseRootFromParent_Done,
     /* 2235200 */   // Label 29756: @2235200
     /* 2235200 */   GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2235245), // Rule ID 59485 //
     /* 2235205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235208 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2235211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235244 */     // GIR_Coverage, 59485,
     /* 2235244 */     GIR_EraseRootFromParent_Done,
     /* 2235245 */   // Label 29757: @2235245
     /* 2235245 */   GIM_Reject,
     /* 2235246 */ // Label 29755: @2235246
     /* 2235246 */ GIM_Reject,
     /* 2235247 */ // Label 29709: @2235247
     /* 2235247 */ GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2235361),
     /* 2235252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2235255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2235258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235270 */   GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2235315), // Rule ID 59416 //
     /* 2235275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235278 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2235295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235314 */     // GIR_Coverage, 59416,
     /* 2235314 */     GIR_EraseRootFromParent_Done,
     /* 2235315 */   // Label 29759: @2235315
     /* 2235315 */   GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2235360), // Rule ID 59417 //
     /* 2235320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235323 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2235326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2235340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235359 */     // GIR_Coverage, 59417,
     /* 2235359 */     GIR_EraseRootFromParent_Done,
     /* 2235360 */   // Label 29760: @2235360
     /* 2235360 */   GIM_Reject,
     /* 2235361 */ // Label 29758: @2235361
     /* 2235361 */ GIM_Reject,
     /* 2235362 */ // Label 29710: @2235362
     /* 2235362 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2235476),
     /* 2235367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2235370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2235373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235385 */   GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2235430), // Rule ID 59436 //
     /* 2235390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235393 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235429 */     // GIR_Coverage, 59436,
     /* 2235429 */     GIR_EraseRootFromParent_Done,
     /* 2235430 */   // Label 29762: @2235430
     /* 2235430 */   GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2235475), // Rule ID 59437 //
     /* 2235435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235438 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2235441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235474 */     // GIR_Coverage, 59437,
     /* 2235474 */     GIR_EraseRootFromParent_Done,
     /* 2235475 */   // Label 29763: @2235475
     /* 2235475 */   GIM_Reject,
     /* 2235476 */ // Label 29761: @2235476
     /* 2235476 */ GIM_Reject,
     /* 2235477 */ // Label 29711: @2235477
     /* 2235477 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2235591),
     /* 2235482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2235485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2235488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235500 */   GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2235545), // Rule ID 59472 //
     /* 2235505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235508 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235544 */     // GIR_Coverage, 59472,
     /* 2235544 */     GIR_EraseRootFromParent_Done,
     /* 2235545 */   // Label 29765: @2235545
     /* 2235545 */   GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2235590), // Rule ID 59473 //
     /* 2235550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235553 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235589 */     // GIR_Coverage, 59473,
     /* 2235589 */     GIR_EraseRootFromParent_Done,
     /* 2235590 */   // Label 29766: @2235590
     /* 2235590 */   GIM_Reject,
     /* 2235591 */ // Label 29764: @2235591
     /* 2235591 */ GIM_Reject,
     /* 2235592 */ // Label 29712: @2235592
     /* 2235592 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2235706),
     /* 2235597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2235600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2235603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235615 */   GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2235660), // Rule ID 59488 //
     /* 2235620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235623 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235659 */     // GIR_Coverage, 59488,
     /* 2235659 */     GIR_EraseRootFromParent_Done,
     /* 2235660 */   // Label 29768: @2235660
     /* 2235660 */   GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2235705), // Rule ID 59489 //
     /* 2235665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235668 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235704 */     // GIR_Coverage, 59489,
     /* 2235704 */     GIR_EraseRootFromParent_Done,
     /* 2235705 */   // Label 29769: @2235705
     /* 2235705 */   GIM_Reject,
     /* 2235706 */ // Label 29767: @2235706
     /* 2235706 */ GIM_Reject,
     /* 2235707 */ // Label 29713: @2235707
     /* 2235707 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2235821),
     /* 2235712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2235715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2235718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235730 */   GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2235775), // Rule ID 59432 //
     /* 2235735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235738 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235774 */     // GIR_Coverage, 59432,
     /* 2235774 */     GIR_EraseRootFromParent_Done,
     /* 2235775 */   // Label 29771: @2235775
     /* 2235775 */   GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2235820), // Rule ID 59433 //
     /* 2235780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235783 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235819 */     // GIR_Coverage, 59433,
     /* 2235819 */     GIR_EraseRootFromParent_Done,
     /* 2235820 */   // Label 29772: @2235820
     /* 2235820 */   GIM_Reject,
     /* 2235821 */ // Label 29770: @2235821
     /* 2235821 */ GIM_Reject,
     /* 2235822 */ // Label 29714: @2235822
     /* 2235822 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2235936),
     /* 2235827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2235830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2235833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235845 */   GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2235890), // Rule ID 59460 //
     /* 2235850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235853 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235889 */     // GIR_Coverage, 59460,
     /* 2235889 */     GIR_EraseRootFromParent_Done,
     /* 2235890 */   // Label 29774: @2235890
     /* 2235890 */   GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2235935), // Rule ID 59461 //
     /* 2235895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235898 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235934 */     // GIR_Coverage, 59461,
     /* 2235934 */     GIR_EraseRootFromParent_Done,
     /* 2235935 */   // Label 29775: @2235935
     /* 2235935 */   GIM_Reject,
     /* 2235936 */ // Label 29773: @2235936
     /* 2235936 */ GIM_Reject,
     /* 2235937 */ // Label 29715: @2235937
     /* 2235937 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2236051),
     /* 2235942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2235945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2235948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235960 */   GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2236005), // Rule ID 59476 //
     /* 2235965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235968 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236004 */     // GIR_Coverage, 59476,
     /* 2236004 */     GIR_EraseRootFromParent_Done,
     /* 2236005 */   // Label 29777: @2236005
     /* 2236005 */   GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2236050), // Rule ID 59477 //
     /* 2236010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236013 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2236016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236049 */     // GIR_Coverage, 59477,
     /* 2236049 */     GIR_EraseRootFromParent_Done,
     /* 2236050 */   // Label 29778: @2236050
     /* 2236050 */   GIM_Reject,
     /* 2236051 */ // Label 29776: @2236051
     /* 2236051 */ GIM_Reject,
     /* 2236052 */ // Label 29716: @2236052
     /* 2236052 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2236166),
     /* 2236057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2236060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2236063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236075 */   GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2236120), // Rule ID 59492 //
     /* 2236080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236083 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236119 */     // GIR_Coverage, 59492,
     /* 2236119 */     GIR_EraseRootFromParent_Done,
     /* 2236120 */   // Label 29780: @2236120
     /* 2236120 */   GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2236165), // Rule ID 59493 //
     /* 2236125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236128 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2236131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236164 */     // GIR_Coverage, 59493,
     /* 2236164 */     GIR_EraseRootFromParent_Done,
     /* 2236165 */   // Label 29781: @2236165
     /* 2236165 */   GIM_Reject,
     /* 2236166 */ // Label 29779: @2236166
     /* 2236166 */ GIM_Reject,
     /* 2236167 */ // Label 29717: @2236167
     /* 2236167 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2236281),
     /* 2236172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2236175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2236178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236190 */   GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2236235), // Rule ID 59448 //
     /* 2236195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236198 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2236215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236234 */     // GIR_Coverage, 59448,
     /* 2236234 */     GIR_EraseRootFromParent_Done,
     /* 2236235 */   // Label 29783: @2236235
     /* 2236235 */   GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2236280), // Rule ID 59449 //
     /* 2236240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236243 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2236246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2236260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236279 */     // GIR_Coverage, 59449,
     /* 2236279 */     GIR_EraseRootFromParent_Done,
     /* 2236280 */   // Label 29784: @2236280
     /* 2236280 */   GIM_Reject,
     /* 2236281 */ // Label 29782: @2236281
     /* 2236281 */ GIM_Reject,
     /* 2236282 */ // Label 29718: @2236282
     /* 2236282 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2236396),
     /* 2236287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2236290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2236293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236305 */   GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2236350), // Rule ID 59464 //
     /* 2236310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236313 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236349 */     // GIR_Coverage, 59464,
     /* 2236349 */     GIR_EraseRootFromParent_Done,
     /* 2236350 */   // Label 29786: @2236350
     /* 2236350 */   GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2236395), // Rule ID 59465 //
     /* 2236355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236358 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2236361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236394 */     // GIR_Coverage, 59465,
     /* 2236394 */     GIR_EraseRootFromParent_Done,
     /* 2236395 */   // Label 29787: @2236395
     /* 2236395 */   GIM_Reject,
     /* 2236396 */ // Label 29785: @2236396
     /* 2236396 */ GIM_Reject,
     /* 2236397 */ // Label 29719: @2236397
     /* 2236397 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2236511),
     /* 2236402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2236405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2236408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236420 */   GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2236465), // Rule ID 59480 //
     /* 2236425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236428 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236464 */     // GIR_Coverage, 59480,
     /* 2236464 */     GIR_EraseRootFromParent_Done,
     /* 2236465 */   // Label 29789: @2236465
     /* 2236465 */   GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2236510), // Rule ID 59481 //
     /* 2236470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236473 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236509 */     // GIR_Coverage, 59481,
     /* 2236509 */     GIR_EraseRootFromParent_Done,
     /* 2236510 */   // Label 29790: @2236510
     /* 2236510 */   GIM_Reject,
     /* 2236511 */ // Label 29788: @2236511
     /* 2236511 */ GIM_Reject,
     /* 2236512 */ // Label 29720: @2236512
     /* 2236512 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2236626),
     /* 2236517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2236520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2236523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236535 */   GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2236580), // Rule ID 59452 //
     /* 2236540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236543 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236579 */     // GIR_Coverage, 59452,
     /* 2236579 */     GIR_EraseRootFromParent_Done,
     /* 2236580 */   // Label 29792: @2236580
     /* 2236580 */   GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2236625), // Rule ID 59453 //
     /* 2236585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236588 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236624 */     // GIR_Coverage, 59453,
     /* 2236624 */     GIR_EraseRootFromParent_Done,
     /* 2236625 */   // Label 29793: @2236625
     /* 2236625 */   GIM_Reject,
     /* 2236626 */ // Label 29791: @2236626
     /* 2236626 */ GIM_Reject,
     /* 2236627 */ // Label 29721: @2236627
     /* 2236627 */ GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2236741),
     /* 2236632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2236635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2236638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236650 */   GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2236695), // Rule ID 59468 //
     /* 2236655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236658 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236694 */     // GIR_Coverage, 59468,
     /* 2236694 */     GIR_EraseRootFromParent_Done,
     /* 2236695 */   // Label 29795: @2236695
     /* 2236695 */   GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2236740), // Rule ID 59469 //
     /* 2236700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236703 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236739 */     // GIR_Coverage, 59469,
     /* 2236739 */     GIR_EraseRootFromParent_Done,
     /* 2236740 */   // Label 29796: @2236740
     /* 2236740 */   GIM_Reject,
     /* 2236741 */ // Label 29794: @2236741
     /* 2236741 */ GIM_Reject,
     /* 2236742 */ // Label 29722: @2236742
     /* 2236742 */ GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2236856),
     /* 2236747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2236750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2236753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236765 */   GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2236810), // Rule ID 59456 //
     /* 2236770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236773 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236809 */     // GIR_Coverage, 59456,
     /* 2236809 */     GIR_EraseRootFromParent_Done,
     /* 2236810 */   // Label 29798: @2236810
     /* 2236810 */   GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2236855), // Rule ID 59457 //
     /* 2236815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236818 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236854 */     // GIR_Coverage, 59457,
     /* 2236854 */     GIR_EraseRootFromParent_Done,
     /* 2236855 */   // Label 29799: @2236855
     /* 2236855 */   GIM_Reject,
     /* 2236856 */ // Label 29797: @2236856
     /* 2236856 */ GIM_Reject,
     /* 2236857 */ // Label 29723: @2236857
     /* 2236857 */ GIM_Reject,
     /* 2236858 */ // Label 47: @2236858
     /* 2236858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29824*/ GIMT_Encode4(2239767),
     /* 2236869 */ /*GILLT_s32*//*Label 29800*/ GIMT_Encode4(2236993),
     /* 2236873 */ /*GILLT_s64*//*Label 29801*/ GIMT_Encode4(2237115), GIMT_Encode4(0),
     /* 2236881 */ /*GILLT_nxv1s8*//*Label 29802*/ GIMT_Encode4(2237237),
     /* 2236885 */ /*GILLT_nxv1s16*//*Label 29803*/ GIMT_Encode4(2237352),
     /* 2236889 */ /*GILLT_nxv1s32*//*Label 29804*/ GIMT_Encode4(2237467),
     /* 2236893 */ /*GILLT_nxv1s64*//*Label 29805*/ GIMT_Encode4(2237582), GIMT_Encode4(0),
     /* 2236901 */ /*GILLT_nxv2s8*//*Label 29806*/ GIMT_Encode4(2237697),
     /* 2236905 */ /*GILLT_nxv2s16*//*Label 29807*/ GIMT_Encode4(2237812),
     /* 2236909 */ /*GILLT_nxv2s32*//*Label 29808*/ GIMT_Encode4(2237927),
     /* 2236913 */ /*GILLT_nxv2s64*//*Label 29809*/ GIMT_Encode4(2238042), GIMT_Encode4(0),
     /* 2236921 */ /*GILLT_nxv4s8*//*Label 29810*/ GIMT_Encode4(2238157),
     /* 2236925 */ /*GILLT_nxv4s16*//*Label 29811*/ GIMT_Encode4(2238272),
     /* 2236929 */ /*GILLT_nxv4s32*//*Label 29812*/ GIMT_Encode4(2238387),
     /* 2236933 */ /*GILLT_nxv4s64*//*Label 29813*/ GIMT_Encode4(2238502), GIMT_Encode4(0),
     /* 2236941 */ /*GILLT_nxv8s8*//*Label 29814*/ GIMT_Encode4(2238617),
     /* 2236945 */ /*GILLT_nxv8s16*//*Label 29815*/ GIMT_Encode4(2238732),
     /* 2236949 */ /*GILLT_nxv8s32*//*Label 29816*/ GIMT_Encode4(2238847),
     /* 2236953 */ /*GILLT_nxv8s64*//*Label 29817*/ GIMT_Encode4(2238962), GIMT_Encode4(0),
     /* 2236961 */ /*GILLT_nxv16s8*//*Label 29818*/ GIMT_Encode4(2239077),
     /* 2236965 */ /*GILLT_nxv16s16*//*Label 29819*/ GIMT_Encode4(2239192),
     /* 2236969 */ /*GILLT_nxv16s32*//*Label 29820*/ GIMT_Encode4(2239307), GIMT_Encode4(0),
     /* 2236977 */ /*GILLT_nxv32s8*//*Label 29821*/ GIMT_Encode4(2239422),
     /* 2236981 */ /*GILLT_nxv32s16*//*Label 29822*/ GIMT_Encode4(2239537), GIMT_Encode4(0),
     /* 2236989 */ /*GILLT_nxv64s8*//*Label 29823*/ GIMT_Encode4(2239652),
     /* 2236993 */ // Label 29800: @2236993
     /* 2236993 */ GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2237114),
     /* 2236998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2237001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2237004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237012 */   GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2237048), // Rule ID 2467 //
     /* 2237017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237032 */     // MIs[1] Operand 1
     /* 2237032 */     // No operand predicates
     /* 2237032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237034 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237041 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237047 */     // GIR_Coverage, 2467,
     /* 2237047 */     GIR_EraseRootFromParent_Done,
     /* 2237048 */   // Label 29826: @2237048
     /* 2237048 */   GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2237084), // Rule ID 62558 //
     /* 2237053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2237056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237068 */     // MIs[1] Operand 1
     /* 2237068 */     // No operand predicates
     /* 2237068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237070 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237077 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237083 */     // GIR_Coverage, 62558,
     /* 2237083 */     GIR_EraseRootFromParent_Done,
     /* 2237084 */   // Label 29827: @2237084
     /* 2237084 */   GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2237113), // Rule ID 2461 //
     /* 2237089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2237092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237099 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2237099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2237102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237112 */     // GIR_Coverage, 2461,
     /* 2237112 */     GIR_EraseRootFromParent_Done,
     /* 2237113 */   // Label 29828: @2237113
     /* 2237113 */   GIM_Reject,
     /* 2237114 */ // Label 29825: @2237114
     /* 2237114 */ GIM_Reject,
     /* 2237115 */ // Label 29801: @2237115
     /* 2237115 */ GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2237236),
     /* 2237120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2237123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2237126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2237134 */   GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2237170), // Rule ID 2466 //
     /* 2237139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237154 */     // MIs[1] Operand 1
     /* 2237154 */     // No operand predicates
     /* 2237154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237156 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2237159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237163 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237169 */     // GIR_Coverage, 2466,
     /* 2237169 */     GIR_EraseRootFromParent_Done,
     /* 2237170 */   // Label 29830: @2237170
     /* 2237170 */   GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2237206), // Rule ID 62557 //
     /* 2237175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2237178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2237182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2237186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2237190 */     // MIs[1] Operand 1
     /* 2237190 */     // No operand predicates
     /* 2237190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2237192 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2237192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2237195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237199 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2237204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237205 */     // GIR_Coverage, 62557,
     /* 2237205 */     GIR_EraseRootFromParent_Done,
     /* 2237206 */   // Label 29831: @2237206
     /* 2237206 */   GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2237235), // Rule ID 2460 //
     /* 2237211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2237214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2237221 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2237221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2237224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2237233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237234 */     // GIR_Coverage, 2460,
     /* 2237234 */     GIR_EraseRootFromParent_Done,
     /* 2237235 */   // Label 29832: @2237235
     /* 2237235 */   GIM_Reject,
     /* 2237236 */ // Label 29829: @2237236
     /* 2237236 */ GIM_Reject,
     /* 2237237 */ // Label 29802: @2237237
     /* 2237237 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2237351),
     /* 2237242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2237245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237260 */   GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2237305), // Rule ID 59276 //
     /* 2237265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237268 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2237285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237304 */     // GIR_Coverage, 59276,
     /* 2237304 */     GIR_EraseRootFromParent_Done,
     /* 2237305 */   // Label 29834: @2237305
     /* 2237305 */   GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2237350), // Rule ID 59277 //
     /* 2237310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237313 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2237316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2237330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237349 */     // GIR_Coverage, 59277,
     /* 2237349 */     GIR_EraseRootFromParent_Done,
     /* 2237350 */   // Label 29835: @2237350
     /* 2237350 */   GIM_Reject,
     /* 2237351 */ // Label 29833: @2237351
     /* 2237351 */ GIM_Reject,
     /* 2237352 */ // Label 29803: @2237352
     /* 2237352 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2237466),
     /* 2237357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2237360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237375 */   GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2237420), // Rule ID 59288 //
     /* 2237380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237383 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237419 */     // GIR_Coverage, 59288,
     /* 2237419 */     GIR_EraseRootFromParent_Done,
     /* 2237420 */   // Label 29837: @2237420
     /* 2237420 */   GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2237465), // Rule ID 59289 //
     /* 2237425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237428 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2237431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237464 */     // GIR_Coverage, 59289,
     /* 2237464 */     GIR_EraseRootFromParent_Done,
     /* 2237465 */   // Label 29838: @2237465
     /* 2237465 */   GIM_Reject,
     /* 2237466 */ // Label 29836: @2237466
     /* 2237466 */ GIM_Reject,
     /* 2237467 */ // Label 29804: @2237467
     /* 2237467 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2237581),
     /* 2237472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2237475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237490 */   GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2237535), // Rule ID 59296 //
     /* 2237495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237498 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237534 */     // GIR_Coverage, 59296,
     /* 2237534 */     GIR_EraseRootFromParent_Done,
     /* 2237535 */   // Label 29840: @2237535
     /* 2237535 */   GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2237580), // Rule ID 59297 //
     /* 2237540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237543 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237579 */     // GIR_Coverage, 59297,
     /* 2237579 */     GIR_EraseRootFromParent_Done,
     /* 2237580 */   // Label 29841: @2237580
     /* 2237580 */   GIM_Reject,
     /* 2237581 */ // Label 29839: @2237581
     /* 2237581 */ GIM_Reject,
     /* 2237582 */ // Label 29805: @2237582
     /* 2237582 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2237696),
     /* 2237587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2237590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237605 */   GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2237650), // Rule ID 59312 //
     /* 2237610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237613 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237649 */     // GIR_Coverage, 59312,
     /* 2237649 */     GIR_EraseRootFromParent_Done,
     /* 2237650 */   // Label 29843: @2237650
     /* 2237650 */   GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2237695), // Rule ID 59313 //
     /* 2237655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237658 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237694 */     // GIR_Coverage, 59313,
     /* 2237694 */     GIR_EraseRootFromParent_Done,
     /* 2237695 */   // Label 29844: @2237695
     /* 2237695 */   GIM_Reject,
     /* 2237696 */ // Label 29842: @2237696
     /* 2237696 */ GIM_Reject,
     /* 2237697 */ // Label 29806: @2237697
     /* 2237697 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2237811),
     /* 2237702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2237705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237720 */   GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2237765), // Rule ID 59280 //
     /* 2237725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237728 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237764 */     // GIR_Coverage, 59280,
     /* 2237764 */     GIR_EraseRootFromParent_Done,
     /* 2237765 */   // Label 29846: @2237765
     /* 2237765 */   GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2237810), // Rule ID 59281 //
     /* 2237770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237773 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237809 */     // GIR_Coverage, 59281,
     /* 2237809 */     GIR_EraseRootFromParent_Done,
     /* 2237810 */   // Label 29847: @2237810
     /* 2237810 */   GIM_Reject,
     /* 2237811 */ // Label 29845: @2237811
     /* 2237811 */ GIM_Reject,
     /* 2237812 */ // Label 29807: @2237812
     /* 2237812 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2237926),
     /* 2237817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2237820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237835 */   GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2237880), // Rule ID 59292 //
     /* 2237840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237843 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237879 */     // GIR_Coverage, 59292,
     /* 2237879 */     GIR_EraseRootFromParent_Done,
     /* 2237880 */   // Label 29849: @2237880
     /* 2237880 */   GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2237925), // Rule ID 59293 //
     /* 2237885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237888 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237924 */     // GIR_Coverage, 59293,
     /* 2237924 */     GIR_EraseRootFromParent_Done,
     /* 2237925 */   // Label 29850: @2237925
     /* 2237925 */   GIM_Reject,
     /* 2237926 */ // Label 29848: @2237926
     /* 2237926 */ GIM_Reject,
     /* 2237927 */ // Label 29808: @2237927
     /* 2237927 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2238041),
     /* 2237932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237950 */   GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2237995), // Rule ID 59308 //
     /* 2237955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237958 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237994 */     // GIR_Coverage, 59308,
     /* 2237994 */     GIR_EraseRootFromParent_Done,
     /* 2237995 */   // Label 29852: @2237995
     /* 2237995 */   GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2238040), // Rule ID 59309 //
     /* 2238000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238003 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2238006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238039 */     // GIR_Coverage, 59309,
     /* 2238039 */     GIR_EraseRootFromParent_Done,
     /* 2238040 */   // Label 29853: @2238040
     /* 2238040 */   GIM_Reject,
     /* 2238041 */ // Label 29851: @2238041
     /* 2238041 */ GIM_Reject,
     /* 2238042 */ // Label 29809: @2238042
     /* 2238042 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2238156),
     /* 2238047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2238050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238065 */   GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2238110), // Rule ID 59352 //
     /* 2238070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238073 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238109 */     // GIR_Coverage, 59352,
     /* 2238109 */     GIR_EraseRootFromParent_Done,
     /* 2238110 */   // Label 29855: @2238110
     /* 2238110 */   GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2238155), // Rule ID 59353 //
     /* 2238115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238118 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2238121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238154 */     // GIR_Coverage, 59353,
     /* 2238154 */     GIR_EraseRootFromParent_Done,
     /* 2238155 */   // Label 29856: @2238155
     /* 2238155 */   GIM_Reject,
     /* 2238156 */ // Label 29854: @2238156
     /* 2238156 */ GIM_Reject,
     /* 2238157 */ // Label 29810: @2238157
     /* 2238157 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2238271),
     /* 2238162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2238165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2238168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238180 */   GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2238225), // Rule ID 59284 //
     /* 2238185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238188 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2238205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238224 */     // GIR_Coverage, 59284,
     /* 2238224 */     GIR_EraseRootFromParent_Done,
     /* 2238225 */   // Label 29858: @2238225
     /* 2238225 */   GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2238270), // Rule ID 59285 //
     /* 2238230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238233 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2238236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2238250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238269 */     // GIR_Coverage, 59285,
     /* 2238269 */     GIR_EraseRootFromParent_Done,
     /* 2238270 */   // Label 29859: @2238270
     /* 2238270 */   GIM_Reject,
     /* 2238271 */ // Label 29857: @2238271
     /* 2238271 */ GIM_Reject,
     /* 2238272 */ // Label 29811: @2238272
     /* 2238272 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2238386),
     /* 2238277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2238280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2238283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238295 */   GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2238340), // Rule ID 59304 //
     /* 2238300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238303 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238339 */     // GIR_Coverage, 59304,
     /* 2238339 */     GIR_EraseRootFromParent_Done,
     /* 2238340 */   // Label 29861: @2238340
     /* 2238340 */   GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2238385), // Rule ID 59305 //
     /* 2238345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238348 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2238351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238384 */     // GIR_Coverage, 59305,
     /* 2238384 */     GIR_EraseRootFromParent_Done,
     /* 2238385 */   // Label 29862: @2238385
     /* 2238385 */   GIM_Reject,
     /* 2238386 */ // Label 29860: @2238386
     /* 2238386 */ GIM_Reject,
     /* 2238387 */ // Label 29812: @2238387
     /* 2238387 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2238501),
     /* 2238392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2238395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2238398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238410 */   GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2238455), // Rule ID 59340 //
     /* 2238415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238418 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238454 */     // GIR_Coverage, 59340,
     /* 2238454 */     GIR_EraseRootFromParent_Done,
     /* 2238455 */   // Label 29864: @2238455
     /* 2238455 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2238500), // Rule ID 59341 //
     /* 2238460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238463 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238499 */     // GIR_Coverage, 59341,
     /* 2238499 */     GIR_EraseRootFromParent_Done,
     /* 2238500 */   // Label 29865: @2238500
     /* 2238500 */   GIM_Reject,
     /* 2238501 */ // Label 29863: @2238501
     /* 2238501 */ GIM_Reject,
     /* 2238502 */ // Label 29813: @2238502
     /* 2238502 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2238616),
     /* 2238507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238525 */   GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2238570), // Rule ID 59356 //
     /* 2238530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238533 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238569 */     // GIR_Coverage, 59356,
     /* 2238569 */     GIR_EraseRootFromParent_Done,
     /* 2238570 */   // Label 29867: @2238570
     /* 2238570 */   GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2238615), // Rule ID 59357 //
     /* 2238575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238578 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238614 */     // GIR_Coverage, 59357,
     /* 2238614 */     GIR_EraseRootFromParent_Done,
     /* 2238615 */   // Label 29868: @2238615
     /* 2238615 */   GIM_Reject,
     /* 2238616 */ // Label 29866: @2238616
     /* 2238616 */ GIM_Reject,
     /* 2238617 */ // Label 29814: @2238617
     /* 2238617 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2238731),
     /* 2238622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2238625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2238628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238640 */   GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2238685), // Rule ID 59300 //
     /* 2238645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238648 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238684 */     // GIR_Coverage, 59300,
     /* 2238684 */     GIR_EraseRootFromParent_Done,
     /* 2238685 */   // Label 29870: @2238685
     /* 2238685 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2238730), // Rule ID 59301 //
     /* 2238690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238693 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238729 */     // GIR_Coverage, 59301,
     /* 2238729 */     GIR_EraseRootFromParent_Done,
     /* 2238730 */   // Label 29871: @2238730
     /* 2238730 */   GIM_Reject,
     /* 2238731 */ // Label 29869: @2238731
     /* 2238731 */ GIM_Reject,
     /* 2238732 */ // Label 29815: @2238732
     /* 2238732 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2238846),
     /* 2238737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2238743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238755 */   GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2238800), // Rule ID 59328 //
     /* 2238760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238763 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238799 */     // GIR_Coverage, 59328,
     /* 2238799 */     GIR_EraseRootFromParent_Done,
     /* 2238800 */   // Label 29873: @2238800
     /* 2238800 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2238845), // Rule ID 59329 //
     /* 2238805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238808 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238844 */     // GIR_Coverage, 59329,
     /* 2238844 */     GIR_EraseRootFromParent_Done,
     /* 2238845 */   // Label 29874: @2238845
     /* 2238845 */   GIM_Reject,
     /* 2238846 */ // Label 29872: @2238846
     /* 2238846 */ GIM_Reject,
     /* 2238847 */ // Label 29816: @2238847
     /* 2238847 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2238961),
     /* 2238852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2238858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238870 */   GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2238915), // Rule ID 59344 //
     /* 2238875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238878 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238914 */     // GIR_Coverage, 59344,
     /* 2238914 */     GIR_EraseRootFromParent_Done,
     /* 2238915 */   // Label 29876: @2238915
     /* 2238915 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2238960), // Rule ID 59345 //
     /* 2238920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238923 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238959 */     // GIR_Coverage, 59345,
     /* 2238959 */     GIR_EraseRootFromParent_Done,
     /* 2238960 */   // Label 29877: @2238960
     /* 2238960 */   GIM_Reject,
     /* 2238961 */ // Label 29875: @2238961
     /* 2238961 */ GIM_Reject,
     /* 2238962 */ // Label 29817: @2238962
     /* 2238962 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2239076),
     /* 2238967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2238973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238985 */   GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2239030), // Rule ID 59360 //
     /* 2238990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238993 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239029 */     // GIR_Coverage, 59360,
     /* 2239029 */     GIR_EraseRootFromParent_Done,
     /* 2239030 */   // Label 29879: @2239030
     /* 2239030 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2239075), // Rule ID 59361 //
     /* 2239035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239038 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2239041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239074 */     // GIR_Coverage, 59361,
     /* 2239074 */     GIR_EraseRootFromParent_Done,
     /* 2239075 */   // Label 29880: @2239075
     /* 2239075 */   GIM_Reject,
     /* 2239076 */ // Label 29878: @2239076
     /* 2239076 */ GIM_Reject,
     /* 2239077 */ // Label 29818: @2239077
     /* 2239077 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2239191),
     /* 2239082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2239085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2239088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239100 */   GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2239145), // Rule ID 59316 //
     /* 2239105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239108 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2239125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239144 */     // GIR_Coverage, 59316,
     /* 2239144 */     GIR_EraseRootFromParent_Done,
     /* 2239145 */   // Label 29882: @2239145
     /* 2239145 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2239190), // Rule ID 59317 //
     /* 2239150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239153 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2239156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2239170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239189 */     // GIR_Coverage, 59317,
     /* 2239189 */     GIR_EraseRootFromParent_Done,
     /* 2239190 */   // Label 29883: @2239190
     /* 2239190 */   GIM_Reject,
     /* 2239191 */ // Label 29881: @2239191
     /* 2239191 */ GIM_Reject,
     /* 2239192 */ // Label 29819: @2239192
     /* 2239192 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2239306),
     /* 2239197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2239200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2239203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239215 */   GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2239260), // Rule ID 59332 //
     /* 2239220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239223 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239259 */     // GIR_Coverage, 59332,
     /* 2239259 */     GIR_EraseRootFromParent_Done,
     /* 2239260 */   // Label 29885: @2239260
     /* 2239260 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2239305), // Rule ID 59333 //
     /* 2239265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239268 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2239271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239304 */     // GIR_Coverage, 59333,
     /* 2239304 */     GIR_EraseRootFromParent_Done,
     /* 2239305 */   // Label 29886: @2239305
     /* 2239305 */   GIM_Reject,
     /* 2239306 */ // Label 29884: @2239306
     /* 2239306 */ GIM_Reject,
     /* 2239307 */ // Label 29820: @2239307
     /* 2239307 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2239421),
     /* 2239312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2239315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2239318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239330 */   GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2239375), // Rule ID 59348 //
     /* 2239335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239338 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239374 */     // GIR_Coverage, 59348,
     /* 2239374 */     GIR_EraseRootFromParent_Done,
     /* 2239375 */   // Label 29888: @2239375
     /* 2239375 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2239420), // Rule ID 59349 //
     /* 2239380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239383 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2239386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239419 */     // GIR_Coverage, 59349,
     /* 2239419 */     GIR_EraseRootFromParent_Done,
     /* 2239420 */   // Label 29889: @2239420
     /* 2239420 */   GIM_Reject,
     /* 2239421 */ // Label 29887: @2239421
     /* 2239421 */ GIM_Reject,
     /* 2239422 */ // Label 29821: @2239422
     /* 2239422 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2239536),
     /* 2239427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2239430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2239433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239445 */   GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2239490), // Rule ID 59320 //
     /* 2239450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239453 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239489 */     // GIR_Coverage, 59320,
     /* 2239489 */     GIR_EraseRootFromParent_Done,
     /* 2239490 */   // Label 29891: @2239490
     /* 2239490 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2239535), // Rule ID 59321 //
     /* 2239495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239498 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239534 */     // GIR_Coverage, 59321,
     /* 2239534 */     GIR_EraseRootFromParent_Done,
     /* 2239535 */   // Label 29892: @2239535
     /* 2239535 */   GIM_Reject,
     /* 2239536 */ // Label 29890: @2239536
     /* 2239536 */ GIM_Reject,
     /* 2239537 */ // Label 29822: @2239537
     /* 2239537 */ GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2239651),
     /* 2239542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2239548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239560 */   GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2239605), // Rule ID 59336 //
     /* 2239565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239568 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239604 */     // GIR_Coverage, 59336,
     /* 2239604 */     GIR_EraseRootFromParent_Done,
     /* 2239605 */   // Label 29894: @2239605
     /* 2239605 */   GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2239650), // Rule ID 59337 //
     /* 2239610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239613 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239649 */     // GIR_Coverage, 59337,
     /* 2239649 */     GIR_EraseRootFromParent_Done,
     /* 2239650 */   // Label 29895: @2239650
     /* 2239650 */   GIM_Reject,
     /* 2239651 */ // Label 29893: @2239651
     /* 2239651 */ GIM_Reject,
     /* 2239652 */ // Label 29823: @2239652
     /* 2239652 */ GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2239766),
     /* 2239657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2239660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2239663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239675 */   GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2239720), // Rule ID 59324 //
     /* 2239680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239683 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239719 */     // GIR_Coverage, 59324,
     /* 2239719 */     GIR_EraseRootFromParent_Done,
     /* 2239720 */   // Label 29897: @2239720
     /* 2239720 */   GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2239765), // Rule ID 59325 //
     /* 2239725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239728 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239764 */     // GIR_Coverage, 59325,
     /* 2239764 */     GIR_EraseRootFromParent_Done,
     /* 2239765 */   // Label 29898: @2239765
     /* 2239765 */   GIM_Reject,
     /* 2239766 */ // Label 29896: @2239766
     /* 2239766 */ GIM_Reject,
     /* 2239767 */ // Label 29824: @2239767
     /* 2239767 */ GIM_Reject,
     /* 2239768 */ // Label 48: @2239768
     /* 2239768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29908*/ GIMT_Encode4(2266844),
     /* 2239779 */ /*GILLT_s32*//*Label 29899*/ GIMT_Encode4(2239899),
     /* 2239783 */ /*GILLT_s64*//*Label 29900*/ GIMT_Encode4(2242900),
     /* 2239787 */ /*GILLT_nxv1s1*//*Label 29901*/ GIMT_Encode4(2245901), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239807 */ /*GILLT_nxv2s1*//*Label 29902*/ GIMT_Encode4(2249742), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239827 */ /*GILLT_nxv4s1*//*Label 29903*/ GIMT_Encode4(2253583), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239847 */ /*GILLT_nxv8s1*//*Label 29904*/ GIMT_Encode4(2257424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239867 */ /*GILLT_nxv16s1*//*Label 29905*/ GIMT_Encode4(2261265), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239883 */ /*GILLT_nxv32s1*//*Label 29906*/ GIMT_Encode4(2264146), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239895 */ /*GILLT_nxv64s1*//*Label 29907*/ GIMT_Encode4(2266067),
     /* 2239899 */ // Label 29899: @2239899
     /* 2239899 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2240001), // Rule ID 167 //
     /* 2239904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239917 */   // MIs[0] Operand 1
     /* 2239917 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2239926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2239930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2239934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239943 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2239947 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239951 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2239955 */   // MIs[2] Operand 1
     /* 2239955 */   // No operand predicates
     /* 2239955 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2239959 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2239965 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), 1:{ *:[i32] })
     /* 2239965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2239968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2239972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2239981 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2239986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240000 */   // GIR_Coverage, 167,
     /* 2240000 */   GIR_EraseRootFromParent_Done,
     /* 2240001 */ // Label 29909: @2240001
     /* 2240001 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2240106), // Rule ID 169 //
     /* 2240006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240019 */   // MIs[0] Operand 1
     /* 2240019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2240028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2240032 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2240036 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240040 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240045 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2240049 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240053 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2240057 */   // MIs[2] Operand 1
     /* 2240057 */   // No operand predicates
     /* 2240057 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2240061 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240065 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2240067 */   // (setcc:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)))
     /* 2240067 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2240070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2240074 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2240083 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2240088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240095 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240105 */   // GIR_Coverage, 169,
     /* 2240105 */   GIR_EraseRootFromParent_Done,
     /* 2240106 */ // Label 29910: @2240106
     /* 2240106 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2240149), // Rule ID 165 //
     /* 2240111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240124 */   // MIs[0] Operand 1
     /* 2240124 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240133 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2240137 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2240137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240142 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240148 */   // GIR_Coverage, 165,
     /* 2240148 */   GIR_EraseRootFromParent_Done,
     /* 2240149 */ // Label 29911: @2240149
     /* 2240149 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2240192), // Rule ID 65349 //
     /* 2240154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2240163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240167 */   // MIs[0] Operand 1
     /* 2240167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240176 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240180 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2240180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240185 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240191 */   // GIR_Coverage, 65349,
     /* 2240191 */   GIR_EraseRootFromParent_Done,
     /* 2240192 */ // Label 29912: @2240192
     /* 2240192 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2240238), // Rule ID 65355 //
     /* 2240197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2240206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240210 */   // MIs[0] Operand 1
     /* 2240210 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240219 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240223 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2240223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240228 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240237 */   // GIR_Coverage, 65355,
     /* 2240237 */   GIR_EraseRootFromParent_Done,
     /* 2240238 */ // Label 29913: @2240238
     /* 2240238 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2240281), // Rule ID 65385 //
     /* 2240243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240256 */   // MIs[0] Operand 1
     /* 2240256 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240265 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240269 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2240269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240280 */   // GIR_Coverage, 65385,
     /* 2240280 */   GIR_EraseRootFromParent_Done,
     /* 2240281 */ // Label 29914: @2240281
     /* 2240281 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2240327), // Rule ID 65391 //
     /* 2240286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240299 */   // MIs[0] Operand 1
     /* 2240299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240308 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2240312 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2240312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240317 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240326 */   // GIR_Coverage, 65391,
     /* 2240326 */   GIR_EraseRootFromParent_Done,
     /* 2240327 */ // Label 29915: @2240327
     /* 2240327 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2240380), // Rule ID 155 //
     /* 2240332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240345 */   // MIs[0] Operand 1
     /* 2240345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240362 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240366 */   // MIs[1] Operand 1
     /* 2240366 */   // No operand predicates
     /* 2240366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240368 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2240368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240373 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240375 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2240378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240379 */   // GIR_Coverage, 155,
     /* 2240379 */   GIR_EraseRootFromParent_Done,
     /* 2240380 */ // Label 29916: @2240380
     /* 2240380 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2240433), // Rule ID 159 //
     /* 2240385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240398 */   // MIs[0] Operand 1
     /* 2240398 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240415 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240419 */   // MIs[1] Operand 1
     /* 2240419 */   // No operand predicates
     /* 2240419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240421 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2240421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240428 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2240431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240432 */   // GIR_Coverage, 159,
     /* 2240432 */   GIR_EraseRootFromParent_Done,
     /* 2240433 */ // Label 29917: @2240433
     /* 2240433 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2240486), // Rule ID 65341 //
     /* 2240438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240451 */   // MIs[0] Operand 1
     /* 2240451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240468 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240472 */   // MIs[1] Operand 1
     /* 2240472 */   // No operand predicates
     /* 2240472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240474 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240479 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240481 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240485 */   // GIR_Coverage, 65341,
     /* 2240485 */   GIR_EraseRootFromParent_Done,
     /* 2240486 */ // Label 29918: @2240486
     /* 2240486 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2240539), // Rule ID 65345 //
     /* 2240491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240504 */   // MIs[0] Operand 1
     /* 2240504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240513 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240517 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240521 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240525 */   // MIs[1] Operand 1
     /* 2240525 */   // No operand predicates
     /* 2240525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240527 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2240527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240532 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240534 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2240537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240538 */   // GIR_Coverage, 65345,
     /* 2240538 */   GIR_EraseRootFromParent_Done,
     /* 2240539 */ // Label 29919: @2240539
     /* 2240539 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2240616), // Rule ID 65351 //
     /* 2240544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240557 */   // MIs[0] Operand 1
     /* 2240557 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240574 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240578 */   // MIs[1] Operand 1
     /* 2240578 */   // No operand predicates
     /* 2240578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240580 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2240580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240596 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240615 */   // GIR_Coverage, 65351,
     /* 2240615 */   GIR_EraseRootFromParent_Done,
     /* 2240616 */ // Label 29920: @2240616
     /* 2240616 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2240696), // Rule ID 65357 //
     /* 2240621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240634 */   // MIs[0] Operand 1
     /* 2240634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240651 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240655 */   // MIs[1] Operand 1
     /* 2240655 */   // No operand predicates
     /* 2240655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240657 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2240657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240673 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240685 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240695 */   // GIR_Coverage, 65357,
     /* 2240695 */   GIR_EraseRootFromParent_Done,
     /* 2240696 */ // Label 29921: @2240696
     /* 2240696 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2240773), // Rule ID 65361 //
     /* 2240701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240714 */   // MIs[0] Operand 1
     /* 2240714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240731 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240735 */   // MIs[1] Operand 1
     /* 2240735 */   // No operand predicates
     /* 2240735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240737 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240753 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240772 */   // GIR_Coverage, 65361,
     /* 2240772 */   GIR_EraseRootFromParent_Done,
     /* 2240773 */ // Label 29922: @2240773
     /* 2240773 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2240850), // Rule ID 65365 //
     /* 2240778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240791 */   // MIs[0] Operand 1
     /* 2240791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240808 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240812 */   // MIs[1] Operand 1
     /* 2240812 */   // No operand predicates
     /* 2240812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240814 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240826 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240830 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240849 */   // GIR_Coverage, 65365,
     /* 2240849 */   GIR_EraseRootFromParent_Done,
     /* 2240850 */ // Label 29923: @2240850
     /* 2240850 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2240925), // Rule ID 65369 //
     /* 2240855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240868 */   // MIs[0] Operand 1
     /* 2240868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240885 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240889 */   // MIs[1] Operand 1
     /* 2240889 */   // No operand predicates
     /* 2240889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240891 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240924 */   // GIR_Coverage, 65369,
     /* 2240924 */   GIR_EraseRootFromParent_Done,
     /* 2240925 */ // Label 29924: @2240925
     /* 2240925 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2241000), // Rule ID 65373 //
     /* 2240930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240943 */   // MIs[0] Operand 1
     /* 2240943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2240948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240960 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240964 */   // MIs[1] Operand 1
     /* 2240964 */   // No operand predicates
     /* 2240964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240966 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240978 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240982 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240999 */   // GIR_Coverage, 65373,
     /* 2240999 */   GIR_EraseRootFromParent_Done,
     /* 2241000 */ // Label 29925: @2241000
     /* 2241000 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2241055), // Rule ID 65377 //
     /* 2241005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241018 */   // MIs[0] Operand 1
     /* 2241018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241035 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241039 */   // MIs[1] Operand 1
     /* 2241039 */   // No operand predicates
     /* 2241039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241041 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2241041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241046 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241048 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241054 */   // GIR_Coverage, 65377,
     /* 2241054 */   GIR_EraseRootFromParent_Done,
     /* 2241055 */ // Label 29926: @2241055
     /* 2241055 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2241110), // Rule ID 65381 //
     /* 2241060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241073 */   // MIs[0] Operand 1
     /* 2241073 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241090 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241094 */   // MIs[1] Operand 1
     /* 2241094 */   // No operand predicates
     /* 2241094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241096 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2241096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241101 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241103 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241109 */   // GIR_Coverage, 65381,
     /* 2241109 */   GIR_EraseRootFromParent_Done,
     /* 2241110 */ // Label 29927: @2241110
     /* 2241110 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2241187), // Rule ID 65387 //
     /* 2241115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241128 */   // MIs[0] Operand 1
     /* 2241128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241145 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2241149 */   // MIs[1] Operand 1
     /* 2241149 */   // No operand predicates
     /* 2241149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241151 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2241151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2241158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241163 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241167 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2241172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241186 */   // GIR_Coverage, 65387,
     /* 2241186 */   GIR_EraseRootFromParent_Done,
     /* 2241187 */ // Label 29928: @2241187
     /* 2241187 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2241267), // Rule ID 65393 //
     /* 2241192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241205 */   // MIs[0] Operand 1
     /* 2241205 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2241210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241214 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241222 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2241226 */   // MIs[1] Operand 1
     /* 2241226 */   // No operand predicates
     /* 2241226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241228 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2241228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2241235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241240 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241244 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2241249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241256 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2241262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241266 */   // GIR_Coverage, 65393,
     /* 2241266 */   GIR_EraseRootFromParent_Done,
     /* 2241267 */ // Label 29929: @2241267
     /* 2241267 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2241344), // Rule ID 65397 //
     /* 2241272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241285 */   // MIs[0] Operand 1
     /* 2241285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241302 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241306 */   // MIs[1] Operand 1
     /* 2241306 */   // No operand predicates
     /* 2241306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241308 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2241308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241320 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241324 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241343 */   // GIR_Coverage, 65397,
     /* 2241343 */   GIR_EraseRootFromParent_Done,
     /* 2241344 */ // Label 29930: @2241344
     /* 2241344 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2241421), // Rule ID 65401 //
     /* 2241349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241362 */   // MIs[0] Operand 1
     /* 2241362 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2241367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241379 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241383 */   // MIs[1] Operand 1
     /* 2241383 */   // No operand predicates
     /* 2241383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241385 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2241385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241401 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241420 */   // GIR_Coverage, 65401,
     /* 2241420 */   GIR_EraseRootFromParent_Done,
     /* 2241421 */ // Label 29931: @2241421
     /* 2241421 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2241496), // Rule ID 65405 //
     /* 2241426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241439 */   // MIs[0] Operand 1
     /* 2241439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2241444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241456 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241460 */   // MIs[1] Operand 1
     /* 2241460 */   // No operand predicates
     /* 2241460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241462 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241474 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241478 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241495 */   // GIR_Coverage, 65405,
     /* 2241495 */   GIR_EraseRootFromParent_Done,
     /* 2241496 */ // Label 29932: @2241496
     /* 2241496 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2241571), // Rule ID 65409 //
     /* 2241501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241514 */   // MIs[0] Operand 1
     /* 2241514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241523 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241531 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2241535 */   // MIs[1] Operand 1
     /* 2241535 */   // No operand predicates
     /* 2241535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241537 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2241537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241553 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2241556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241570 */   // GIR_Coverage, 65409,
     /* 2241570 */   GIR_EraseRootFromParent_Done,
     /* 2241571 */ // Label 29933: @2241571
     /* 2241571 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2241626), // Rule ID 65413 //
     /* 2241576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241589 */   // MIs[0] Operand 1
     /* 2241589 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241606 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2241610 */   // MIs[1] Operand 1
     /* 2241610 */   // No operand predicates
     /* 2241610 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241612 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2241612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241619 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241625 */   // GIR_Coverage, 65413,
     /* 2241625 */   GIR_EraseRootFromParent_Done,
     /* 2241626 */ // Label 29934: @2241626
     /* 2241626 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2241681), // Rule ID 65417 //
     /* 2241631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241644 */   // MIs[0] Operand 1
     /* 2241644 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2241657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2241661 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2241665 */   // MIs[1] Operand 1
     /* 2241665 */   // No operand predicates
     /* 2241665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2241667 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2241667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2241670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241674 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241680 */   // GIR_Coverage, 65417,
     /* 2241680 */   GIR_EraseRootFromParent_Done,
     /* 2241681 */ // Label 29935: @2241681
     /* 2241681 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2241723), // Rule ID 64462 //
     /* 2241686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241699 */   // MIs[0] Operand 1
     /* 2241699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241712 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2241715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241719 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241722 */   // GIR_Coverage, 64462,
     /* 2241722 */   GIR_EraseRootFromParent_Done,
     /* 2241723 */ // Label 29936: @2241723
     /* 2241723 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2241765), // Rule ID 64464 //
     /* 2241728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241741 */   // MIs[0] Operand 1
     /* 2241741 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241750 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241754 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2241757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241759 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241761 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241764 */   // GIR_Coverage, 64464,
     /* 2241764 */   GIR_EraseRootFromParent_Done,
     /* 2241765 */ // Label 29937: @2241765
     /* 2241765 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2241807), // Rule ID 153 //
     /* 2241770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241783 */   // MIs[0] Operand 1
     /* 2241783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241796 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241801 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241806 */   // GIR_Coverage, 153,
     /* 2241806 */   GIR_EraseRootFromParent_Done,
     /* 2241807 */ // Label 29938: @2241807
     /* 2241807 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2241849), // Rule ID 157 //
     /* 2241812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241825 */   // MIs[0] Operand 1
     /* 2241825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241838 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241848 */   // GIR_Coverage, 157,
     /* 2241848 */   GIR_EraseRootFromParent_Done,
     /* 2241849 */ // Label 29939: @2241849
     /* 2241849 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2241891), // Rule ID 65343 //
     /* 2241854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241867 */   // MIs[0] Operand 1
     /* 2241867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241880 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241887 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241890 */   // GIR_Coverage, 65343,
     /* 2241890 */   GIR_EraseRootFromParent_Done,
     /* 2241891 */ // Label 29940: @2241891
     /* 2241891 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2241933), // Rule ID 65347 //
     /* 2241896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241909 */   // MIs[0] Operand 1
     /* 2241909 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241922 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241927 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241929 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241932 */   // GIR_Coverage, 65347,
     /* 2241932 */   GIR_EraseRootFromParent_Done,
     /* 2241933 */ // Label 29941: @2241933
     /* 2241933 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2241999), // Rule ID 65353 //
     /* 2241938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241951 */   // MIs[0] Operand 1
     /* 2241951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241964 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241976 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241998 */   // GIR_Coverage, 65353,
     /* 2241998 */   GIR_EraseRootFromParent_Done,
     /* 2241999 */ // Label 29942: @2241999
     /* 2241999 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2242068), // Rule ID 65359 //
     /* 2242004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242017 */   // MIs[0] Operand 1
     /* 2242017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242030 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2242030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242042 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242046 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242057 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242067 */   // GIR_Coverage, 65359,
     /* 2242067 */   GIR_EraseRootFromParent_Done,
     /* 2242068 */ // Label 29943: @2242068
     /* 2242068 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2242110), // Rule ID 65363 //
     /* 2242073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242086 */   // MIs[0] Operand 1
     /* 2242086 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242095 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242099 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242104 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242109 */   // GIR_Coverage, 65363,
     /* 2242109 */   GIR_EraseRootFromParent_Done,
     /* 2242110 */ // Label 29944: @2242110
     /* 2242110 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2242152), // Rule ID 65367 //
     /* 2242115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242128 */   // MIs[0] Operand 1
     /* 2242128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242141 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242151 */   // GIR_Coverage, 65367,
     /* 2242151 */   GIR_EraseRootFromParent_Done,
     /* 2242152 */ // Label 29945: @2242152
     /* 2242152 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2242218), // Rule ID 65371 //
     /* 2242157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242170 */   // MIs[0] Operand 1
     /* 2242170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242183 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242217 */   // GIR_Coverage, 65371,
     /* 2242217 */   GIR_EraseRootFromParent_Done,
     /* 2242218 */ // Label 29946: @2242218
     /* 2242218 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2242284), // Rule ID 65375 //
     /* 2242223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242236 */   // MIs[0] Operand 1
     /* 2242236 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242245 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242249 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242265 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242283 */   // GIR_Coverage, 65375,
     /* 2242283 */   GIR_EraseRootFromParent_Done,
     /* 2242284 */ // Label 29947: @2242284
     /* 2242284 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2242350), // Rule ID 65379 //
     /* 2242289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242302 */   // MIs[0] Operand 1
     /* 2242302 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242311 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242315 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242327 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242331 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242349 */   // GIR_Coverage, 65379,
     /* 2242349 */   GIR_EraseRootFromParent_Done,
     /* 2242350 */ // Label 29948: @2242350
     /* 2242350 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2242416), // Rule ID 65383 //
     /* 2242355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2242361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2242364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242368 */   // MIs[0] Operand 1
     /* 2242368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242381 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242393 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242415 */   // GIR_Coverage, 65383,
     /* 2242415 */   GIR_EraseRootFromParent_Done,
     /* 2242416 */ // Label 29949: @2242416
     /* 2242416 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2242482), // Rule ID 65389 //
     /* 2242421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242434 */   // MIs[0] Operand 1
     /* 2242434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242447 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242463 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242481 */   // GIR_Coverage, 65389,
     /* 2242481 */   GIR_EraseRootFromParent_Done,
     /* 2242482 */ // Label 29950: @2242482
     /* 2242482 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2242551), // Rule ID 65395 //
     /* 2242487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242500 */   // MIs[0] Operand 1
     /* 2242500 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242509 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242513 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2242513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2242520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242525 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242550 */   // GIR_Coverage, 65395,
     /* 2242550 */   GIR_EraseRootFromParent_Done,
     /* 2242551 */ // Label 29951: @2242551
     /* 2242551 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2242593), // Rule ID 65399 //
     /* 2242556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242569 */   // MIs[0] Operand 1
     /* 2242569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242582 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242589 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242592 */   // GIR_Coverage, 65399,
     /* 2242592 */   GIR_EraseRootFromParent_Done,
     /* 2242593 */ // Label 29952: @2242593
     /* 2242593 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2242635), // Rule ID 65403 //
     /* 2242598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242611 */   // MIs[0] Operand 1
     /* 2242611 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242620 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242624 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2242624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242631 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242634 */   // GIR_Coverage, 65403,
     /* 2242634 */   GIR_EraseRootFromParent_Done,
     /* 2242635 */ // Label 29953: @2242635
     /* 2242635 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2242701), // Rule ID 65407 //
     /* 2242640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242653 */   // MIs[0] Operand 1
     /* 2242653 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242662 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242666 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242682 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242700 */   // GIR_Coverage, 65407,
     /* 2242700 */   GIR_EraseRootFromParent_Done,
     /* 2242701 */ // Label 29954: @2242701
     /* 2242701 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2242767), // Rule ID 65411 //
     /* 2242706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242719 */   // MIs[0] Operand 1
     /* 2242719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242732 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242744 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242748 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242766 */   // GIR_Coverage, 65411,
     /* 2242766 */   GIR_EraseRootFromParent_Done,
     /* 2242767 */ // Label 29955: @2242767
     /* 2242767 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2242833), // Rule ID 65415 //
     /* 2242772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242785 */   // MIs[0] Operand 1
     /* 2242785 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242794 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242798 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242814 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242832 */   // GIR_Coverage, 65415,
     /* 2242832 */   GIR_EraseRootFromParent_Done,
     /* 2242833 */ // Label 29956: @2242833
     /* 2242833 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2242899), // Rule ID 65419 //
     /* 2242838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242851 */   // MIs[0] Operand 1
     /* 2242851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242860 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242864 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242876 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242880 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242898 */   // GIR_Coverage, 65419,
     /* 2242898 */   GIR_EraseRootFromParent_Done,
     /* 2242899 */ // Label 29957: @2242899
     /* 2242899 */ GIM_Reject,
     /* 2242900 */ // Label 29900: @2242900
     /* 2242900 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2243002), // Rule ID 166 //
     /* 2242905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242918 */   // MIs[0] Operand 1
     /* 2242918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2242927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2242931 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2242935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242939 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242944 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2242948 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242952 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2242956 */   // MIs[2] Operand 1
     /* 2242956 */   // No operand predicates
     /* 2242956 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2242960 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242964 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2242966 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), 1:{ *:[i64] })
     /* 2242966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2242969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2242973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242978 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2242982 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2242987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243001 */   // GIR_Coverage, 166,
     /* 2243001 */   GIR_EraseRootFromParent_Done,
     /* 2243002 */ // Label 29958: @2243002
     /* 2243002 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2243107), // Rule ID 168 //
     /* 2243007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243020 */   // MIs[0] Operand 1
     /* 2243020 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2243029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2243033 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2243037 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243046 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2243050 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243054 */   GIM_CheckAPIntImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /* 2243058 */   // MIs[2] Operand 1
     /* 2243058 */   // No operand predicates
     /* 2243058 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9978),
     /* 2243062 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243066 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2243068 */   // (setcc:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9978>><<X:XLenSubTrailingOnes>>:$mask), 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)))
     /* 2243068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2243071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2243075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243080 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 2243084 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /* 2243089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243096 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243106 */   // GIR_Coverage, 168,
     /* 2243106 */   GIR_EraseRootFromParent_Done,
     /* 2243107 */ // Label 29959: @2243107
     /* 2243107 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2243150), // Rule ID 164 //
     /* 2243112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243125 */   // MIs[0] Operand 1
     /* 2243125 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243134 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2243138 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2243138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243149 */   // GIR_Coverage, 164,
     /* 2243149 */   GIR_EraseRootFromParent_Done,
     /* 2243150 */ // Label 29960: @2243150
     /* 2243150 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2243193), // Rule ID 65348 //
     /* 2243155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2243164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243168 */   // MIs[0] Operand 1
     /* 2243168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243177 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243181 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2243181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243192 */   // GIR_Coverage, 65348,
     /* 2243192 */   GIR_EraseRootFromParent_Done,
     /* 2243193 */ // Label 29961: @2243193
     /* 2243193 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2243239), // Rule ID 65354 //
     /* 2243198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2243207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243211 */   // MIs[0] Operand 1
     /* 2243211 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243220 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243224 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2243224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243229 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243238 */   // GIR_Coverage, 65354,
     /* 2243238 */   GIR_EraseRootFromParent_Done,
     /* 2243239 */ // Label 29962: @2243239
     /* 2243239 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2243282), // Rule ID 65384 //
     /* 2243244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243257 */   // MIs[0] Operand 1
     /* 2243257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243266 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243270 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2243270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243281 */   // GIR_Coverage, 65384,
     /* 2243281 */   GIR_EraseRootFromParent_Done,
     /* 2243282 */ // Label 29963: @2243282
     /* 2243282 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2243328), // Rule ID 65390 //
     /* 2243287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243300 */   // MIs[0] Operand 1
     /* 2243300 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243309 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2243313 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2243313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243324 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243327 */   // GIR_Coverage, 65390,
     /* 2243327 */   GIR_EraseRootFromParent_Done,
     /* 2243328 */ // Label 29964: @2243328
     /* 2243328 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2243381), // Rule ID 154 //
     /* 2243333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243346 */   // MIs[0] Operand 1
     /* 2243346 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243363 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243367 */   // MIs[1] Operand 1
     /* 2243367 */   // No operand predicates
     /* 2243367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243369 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2243369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243376 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243380 */   // GIR_Coverage, 154,
     /* 2243380 */   GIR_EraseRootFromParent_Done,
     /* 2243381 */ // Label 29965: @2243381
     /* 2243381 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2243434), // Rule ID 158 //
     /* 2243386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243399 */   // MIs[0] Operand 1
     /* 2243399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243416 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243420 */   // MIs[1] Operand 1
     /* 2243420 */   // No operand predicates
     /* 2243420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243422 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2243422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243427 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2243432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243433 */   // GIR_Coverage, 158,
     /* 2243433 */   GIR_EraseRootFromParent_Done,
     /* 2243434 */ // Label 29966: @2243434
     /* 2243434 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2243487), // Rule ID 65340 //
     /* 2243439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243452 */   // MIs[0] Operand 1
     /* 2243452 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243469 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243473 */   // MIs[1] Operand 1
     /* 2243473 */   // No operand predicates
     /* 2243473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243475 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243482 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243486 */   // GIR_Coverage, 65340,
     /* 2243486 */   GIR_EraseRootFromParent_Done,
     /* 2243487 */ // Label 29967: @2243487
     /* 2243487 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2243540), // Rule ID 65344 //
     /* 2243492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243505 */   // MIs[0] Operand 1
     /* 2243505 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243522 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243526 */   // MIs[1] Operand 1
     /* 2243526 */   // No operand predicates
     /* 2243526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243528 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2243528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243535 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2243538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243539 */   // GIR_Coverage, 65344,
     /* 2243539 */   GIR_EraseRootFromParent_Done,
     /* 2243540 */ // Label 29968: @2243540
     /* 2243540 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2243617), // Rule ID 65350 //
     /* 2243545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243558 */   // MIs[0] Operand 1
     /* 2243558 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243575 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243579 */   // MIs[1] Operand 1
     /* 2243579 */   // No operand predicates
     /* 2243579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243581 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2243581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243597 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243616 */   // GIR_Coverage, 65350,
     /* 2243616 */   GIR_EraseRootFromParent_Done,
     /* 2243617 */ // Label 29969: @2243617
     /* 2243617 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2243697), // Rule ID 65356 //
     /* 2243622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243635 */   // MIs[0] Operand 1
     /* 2243635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243652 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243656 */   // MIs[1] Operand 1
     /* 2243656 */   // No operand predicates
     /* 2243656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243658 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243670 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243674 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243686 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243696 */   // GIR_Coverage, 65356,
     /* 2243696 */   GIR_EraseRootFromParent_Done,
     /* 2243697 */ // Label 29970: @2243697
     /* 2243697 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2243774), // Rule ID 65360 //
     /* 2243702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243715 */   // MIs[0] Operand 1
     /* 2243715 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243724 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243732 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243736 */   // MIs[1] Operand 1
     /* 2243736 */   // No operand predicates
     /* 2243736 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243738 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2243738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243750 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243754 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243773 */   // GIR_Coverage, 65360,
     /* 2243773 */   GIR_EraseRootFromParent_Done,
     /* 2243774 */ // Label 29971: @2243774
     /* 2243774 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2243851), // Rule ID 65364 //
     /* 2243779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243792 */   // MIs[0] Operand 1
     /* 2243792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243809 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243813 */   // MIs[1] Operand 1
     /* 2243813 */   // No operand predicates
     /* 2243813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243815 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2243815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243831 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243850 */   // GIR_Coverage, 65364,
     /* 2243850 */   GIR_EraseRootFromParent_Done,
     /* 2243851 */ // Label 29972: @2243851
     /* 2243851 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2243926), // Rule ID 65368 //
     /* 2243856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243862 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243869 */   // MIs[0] Operand 1
     /* 2243869 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243886 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243890 */   // MIs[1] Operand 1
     /* 2243890 */   // No operand predicates
     /* 2243890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243892 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243904 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243908 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243925 */   // GIR_Coverage, 65368,
     /* 2243925 */   GIR_EraseRootFromParent_Done,
     /* 2243926 */ // Label 29973: @2243926
     /* 2243926 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2244001), // Rule ID 65372 //
     /* 2243931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243944 */   // MIs[0] Operand 1
     /* 2243944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2243949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243961 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243965 */   // MIs[1] Operand 1
     /* 2243965 */   // No operand predicates
     /* 2243965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243967 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243979 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243983 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244000 */   // GIR_Coverage, 65372,
     /* 2244000 */   GIR_EraseRootFromParent_Done,
     /* 2244001 */ // Label 29974: @2244001
     /* 2244001 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2244056), // Rule ID 65376 //
     /* 2244006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244019 */   // MIs[0] Operand 1
     /* 2244019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244036 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244040 */   // MIs[1] Operand 1
     /* 2244040 */   // No operand predicates
     /* 2244040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244042 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244049 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244055 */   // GIR_Coverage, 65376,
     /* 2244055 */   GIR_EraseRootFromParent_Done,
     /* 2244056 */ // Label 29975: @2244056
     /* 2244056 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2244111), // Rule ID 65380 //
     /* 2244061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244074 */   // MIs[0] Operand 1
     /* 2244074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244091 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244095 */   // MIs[1] Operand 1
     /* 2244095 */   // No operand predicates
     /* 2244095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244097 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244104 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244110 */   // GIR_Coverage, 65380,
     /* 2244110 */   GIR_EraseRootFromParent_Done,
     /* 2244111 */ // Label 29976: @2244111
     /* 2244111 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2244188), // Rule ID 65386 //
     /* 2244116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244129 */   // MIs[0] Operand 1
     /* 2244129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244146 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244150 */   // MIs[1] Operand 1
     /* 2244150 */   // No operand predicates
     /* 2244150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244152 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2244152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244168 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244187 */   // GIR_Coverage, 65386,
     /* 2244187 */   GIR_EraseRootFromParent_Done,
     /* 2244188 */ // Label 29977: @2244188
     /* 2244188 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2244268), // Rule ID 65392 //
     /* 2244193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244199 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244206 */   // MIs[0] Operand 1
     /* 2244206 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244215 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244219 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244223 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2244227 */   // MIs[1] Operand 1
     /* 2244227 */   // No operand predicates
     /* 2244227 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244229 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2244229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2244236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244241 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244245 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2244250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244257 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244267 */   // GIR_Coverage, 65392,
     /* 2244267 */   GIR_EraseRootFromParent_Done,
     /* 2244268 */ // Label 29978: @2244268
     /* 2244268 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2244345), // Rule ID 65396 //
     /* 2244273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244286 */   // MIs[0] Operand 1
     /* 2244286 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244303 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244307 */   // MIs[1] Operand 1
     /* 2244307 */   // No operand predicates
     /* 2244307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244309 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2244309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244325 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244344 */   // GIR_Coverage, 65396,
     /* 2244344 */   GIR_EraseRootFromParent_Done,
     /* 2244345 */ // Label 29979: @2244345
     /* 2244345 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2244422), // Rule ID 65400 //
     /* 2244350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244363 */   // MIs[0] Operand 1
     /* 2244363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244380 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244384 */   // MIs[1] Operand 1
     /* 2244384 */   // No operand predicates
     /* 2244384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244386 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2244386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244402 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244421 */   // GIR_Coverage, 65400,
     /* 2244421 */   GIR_EraseRootFromParent_Done,
     /* 2244422 */ // Label 29980: @2244422
     /* 2244422 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2244497), // Rule ID 65404 //
     /* 2244427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244440 */   // MIs[0] Operand 1
     /* 2244440 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244457 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244461 */   // MIs[1] Operand 1
     /* 2244461 */   // No operand predicates
     /* 2244461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244463 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244475 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244479 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244496 */   // GIR_Coverage, 65404,
     /* 2244496 */   GIR_EraseRootFromParent_Done,
     /* 2244497 */ // Label 29981: @2244497
     /* 2244497 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2244572), // Rule ID 65408 //
     /* 2244502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244515 */   // MIs[0] Operand 1
     /* 2244515 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244532 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2244536 */   // MIs[1] Operand 1
     /* 2244536 */   // No operand predicates
     /* 2244536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244538 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2244538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244554 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2244557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244571 */   // GIR_Coverage, 65408,
     /* 2244571 */   GIR_EraseRootFromParent_Done,
     /* 2244572 */ // Label 29982: @2244572
     /* 2244572 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2244627), // Rule ID 65412 //
     /* 2244577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244590 */   // MIs[0] Operand 1
     /* 2244590 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244607 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2244611 */   // MIs[1] Operand 1
     /* 2244611 */   // No operand predicates
     /* 2244611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244613 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2244613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244620 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244626 */   // GIR_Coverage, 65412,
     /* 2244626 */   GIR_EraseRootFromParent_Done,
     /* 2244627 */ // Label 29983: @2244627
     /* 2244627 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2244682), // Rule ID 65416 //
     /* 2244632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244645 */   // MIs[0] Operand 1
     /* 2244645 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244654 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2244658 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2244662 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2244666 */   // MIs[1] Operand 1
     /* 2244666 */   // No operand predicates
     /* 2244666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2244668 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2244668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2244671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244675 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2244680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244681 */   // GIR_Coverage, 65416,
     /* 2244681 */   GIR_EraseRootFromParent_Done,
     /* 2244682 */ // Label 29984: @2244682
     /* 2244682 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2244724), // Rule ID 64461 //
     /* 2244687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244700 */   // MIs[0] Operand 1
     /* 2244700 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244709 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244713 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2244716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244720 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244723 */   // GIR_Coverage, 64461,
     /* 2244723 */   GIR_EraseRootFromParent_Done,
     /* 2244724 */ // Label 29985: @2244724
     /* 2244724 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2244766), // Rule ID 64463 //
     /* 2244729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2244732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244742 */   // MIs[0] Operand 1
     /* 2244742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244755 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2244758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244765 */   // GIR_Coverage, 64463,
     /* 2244765 */   GIR_EraseRootFromParent_Done,
     /* 2244766 */ // Label 29986: @2244766
     /* 2244766 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2244808), // Rule ID 152 //
     /* 2244771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244784 */   // MIs[0] Operand 1
     /* 2244784 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244797 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244802 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244804 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244807 */   // GIR_Coverage, 152,
     /* 2244807 */   GIR_EraseRootFromParent_Done,
     /* 2244808 */ // Label 29987: @2244808
     /* 2244808 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2244850), // Rule ID 156 //
     /* 2244813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244826 */   // MIs[0] Operand 1
     /* 2244826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244839 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244849 */   // GIR_Coverage, 156,
     /* 2244849 */   GIR_EraseRootFromParent_Done,
     /* 2244850 */ // Label 29988: @2244850
     /* 2244850 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2244892), // Rule ID 65342 //
     /* 2244855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244868 */   // MIs[0] Operand 1
     /* 2244868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244881 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244886 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244888 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244891 */   // GIR_Coverage, 65342,
     /* 2244891 */   GIR_EraseRootFromParent_Done,
     /* 2244892 */ // Label 29989: @2244892
     /* 2244892 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2244934), // Rule ID 65346 //
     /* 2244897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244910 */   // MIs[0] Operand 1
     /* 2244910 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244919 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244923 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244930 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244933 */   // GIR_Coverage, 65346,
     /* 2244933 */   GIR_EraseRootFromParent_Done,
     /* 2244934 */ // Label 29990: @2244934
     /* 2244934 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2245000), // Rule ID 65352 //
     /* 2244939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244952 */   // MIs[0] Operand 1
     /* 2244952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244965 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244999 */   // GIR_Coverage, 65352,
     /* 2244999 */   GIR_EraseRootFromParent_Done,
     /* 2245000 */ // Label 29991: @2245000
     /* 2245000 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2245069), // Rule ID 65358 //
     /* 2245005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245018 */   // MIs[0] Operand 1
     /* 2245018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245031 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2245031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245058 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245068 */   // GIR_Coverage, 65358,
     /* 2245068 */   GIR_EraseRootFromParent_Done,
     /* 2245069 */ // Label 29992: @2245069
     /* 2245069 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2245111), // Rule ID 65362 //
     /* 2245074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245087 */   // MIs[0] Operand 1
     /* 2245087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245100 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245105 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245110 */   // GIR_Coverage, 65362,
     /* 2245110 */   GIR_EraseRootFromParent_Done,
     /* 2245111 */ // Label 29993: @2245111
     /* 2245111 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2245153), // Rule ID 65366 //
     /* 2245116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245129 */   // MIs[0] Operand 1
     /* 2245129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245142 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245149 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245152 */   // GIR_Coverage, 65366,
     /* 2245152 */   GIR_EraseRootFromParent_Done,
     /* 2245153 */ // Label 29994: @2245153
     /* 2245153 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2245219), // Rule ID 65370 //
     /* 2245158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245171 */   // MIs[0] Operand 1
     /* 2245171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245184 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245218 */   // GIR_Coverage, 65370,
     /* 2245218 */   GIR_EraseRootFromParent_Done,
     /* 2245219 */ // Label 29995: @2245219
     /* 2245219 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2245285), // Rule ID 65374 //
     /* 2245224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245230 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245237 */   // MIs[0] Operand 1
     /* 2245237 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245250 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245262 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245284 */   // GIR_Coverage, 65374,
     /* 2245284 */   GIR_EraseRootFromParent_Done,
     /* 2245285 */ // Label 29996: @2245285
     /* 2245285 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2245351), // Rule ID 65378 //
     /* 2245290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245303 */   // MIs[0] Operand 1
     /* 2245303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245316 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245332 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245350 */   // GIR_Coverage, 65378,
     /* 2245350 */   GIR_EraseRootFromParent_Done,
     /* 2245351 */ // Label 29997: @2245351
     /* 2245351 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2245417), // Rule ID 65382 //
     /* 2245356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2245362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2245365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245369 */   // MIs[0] Operand 1
     /* 2245369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245382 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245394 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245416 */   // GIR_Coverage, 65382,
     /* 2245416 */   GIR_EraseRootFromParent_Done,
     /* 2245417 */ // Label 29998: @2245417
     /* 2245417 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2245483), // Rule ID 65388 //
     /* 2245422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245435 */   // MIs[0] Operand 1
     /* 2245435 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245448 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245460 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2245473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245482 */   // GIR_Coverage, 65388,
     /* 2245482 */   GIR_EraseRootFromParent_Done,
     /* 2245483 */ // Label 29999: @2245483
     /* 2245483 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2245552), // Rule ID 65394 //
     /* 2245488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245501 */   // MIs[0] Operand 1
     /* 2245501 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245514 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2245514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2245521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245541 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2245547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245551 */   // GIR_Coverage, 65394,
     /* 2245551 */   GIR_EraseRootFromParent_Done,
     /* 2245552 */ // Label 30000: @2245552
     /* 2245552 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2245594), // Rule ID 65398 //
     /* 2245557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245570 */   // MIs[0] Operand 1
     /* 2245570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245583 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245588 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245590 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245593 */   // GIR_Coverage, 65398,
     /* 2245593 */   GIR_EraseRootFromParent_Done,
     /* 2245594 */ // Label 30001: @2245594
     /* 2245594 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2245636), // Rule ID 65402 //
     /* 2245599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245612 */   // MIs[0] Operand 1
     /* 2245612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245625 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2245625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245632 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245635 */   // GIR_Coverage, 65402,
     /* 2245635 */   GIR_EraseRootFromParent_Done,
     /* 2245636 */ // Label 30002: @2245636
     /* 2245636 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2245702), // Rule ID 65406 //
     /* 2245641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245654 */   // MIs[0] Operand 1
     /* 2245654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2245659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245667 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245679 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245683 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245701 */   // GIR_Coverage, 65406,
     /* 2245701 */   GIR_EraseRootFromParent_Done,
     /* 2245702 */ // Label 30003: @2245702
     /* 2245702 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2245768), // Rule ID 65410 //
     /* 2245707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245720 */   // MIs[0] Operand 1
     /* 2245720 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245729 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245733 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2245733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245767 */   // GIR_Coverage, 65410,
     /* 2245767 */   GIR_EraseRootFromParent_Done,
     /* 2245768 */ // Label 30004: @2245768
     /* 2245768 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2245834), // Rule ID 65414 //
     /* 2245773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245786 */   // MIs[0] Operand 1
     /* 2245786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245799 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2245806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245833 */   // GIR_Coverage, 65414,
     /* 2245833 */   GIR_EraseRootFromParent_Done,
     /* 2245834 */ // Label 30005: @2245834
     /* 2245834 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2245900), // Rule ID 65418 //
     /* 2245839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2245842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2245845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2245848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245852 */   // MIs[0] Operand 1
     /* 2245852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245861 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2245865 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2245865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2245868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2245872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2245877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245881 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245899 */   // GIR_Coverage, 65418,
     /* 2245899 */   GIR_EraseRootFromParent_Done,
     /* 2245900 */ // Label 30006: @2245900
     /* 2245900 */ GIM_Reject,
     /* 2245901 */ // Label 29901: @2245901
     /* 2245901 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2245949), // Rule ID 45782 //
     /* 2245906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245919 */   // MIs[0] Operand 1
     /* 2245919 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245928 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245932 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245937 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245948 */   // GIR_Coverage, 45782,
     /* 2245948 */   GIR_EraseRootFromParent_Done,
     /* 2245949 */ // Label 30007: @2245949
     /* 2245949 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2245997), // Rule ID 45783 //
     /* 2245954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245967 */   // MIs[0] Operand 1
     /* 2245967 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245980 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245985 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245996 */   // GIR_Coverage, 45783,
     /* 2245996 */   GIR_EraseRootFromParent_Done,
     /* 2245997 */ // Label 30008: @2245997
     /* 2245997 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2246045), // Rule ID 45784 //
     /* 2246002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246015 */   // MIs[0] Operand 1
     /* 2246015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246028 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246033 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246035 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246044 */   // GIR_Coverage, 45784,
     /* 2246044 */   GIR_EraseRootFromParent_Done,
     /* 2246045 */ // Label 30009: @2246045
     /* 2246045 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2246093), // Rule ID 45785 //
     /* 2246050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246056 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246063 */   // MIs[0] Operand 1
     /* 2246063 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246072 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246076 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246081 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246092 */   // GIR_Coverage, 45785,
     /* 2246092 */   GIR_EraseRootFromParent_Done,
     /* 2246093 */ // Label 30010: @2246093
     /* 2246093 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2246141), // Rule ID 48496 //
     /* 2246098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246111 */   // MIs[0] Operand 1
     /* 2246111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246124 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2246127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246129 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246140 */   // GIR_Coverage, 48496,
     /* 2246140 */   GIR_EraseRootFromParent_Done,
     /* 2246141 */ // Label 30011: @2246141
     /* 2246141 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2246189), // Rule ID 48497 //
     /* 2246146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246159 */   // MIs[0] Operand 1
     /* 2246159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246172 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2246175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246188 */   // GIR_Coverage, 48497,
     /* 2246188 */   GIR_EraseRootFromParent_Done,
     /* 2246189 */ // Label 30012: @2246189
     /* 2246189 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2246237), // Rule ID 48500 //
     /* 2246194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246207 */   // MIs[0] Operand 1
     /* 2246207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246220 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2246223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246225 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246236 */   // GIR_Coverage, 48500,
     /* 2246236 */   GIR_EraseRootFromParent_Done,
     /* 2246237 */ // Label 30013: @2246237
     /* 2246237 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2246285), // Rule ID 48501 //
     /* 2246242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246255 */   // MIs[0] Operand 1
     /* 2246255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246268 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2246271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246273 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246284 */   // GIR_Coverage, 48501,
     /* 2246284 */   GIR_EraseRootFromParent_Done,
     /* 2246285 */ // Label 30014: @2246285
     /* 2246285 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2246333), // Rule ID 48508 //
     /* 2246290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246303 */   // MIs[0] Operand 1
     /* 2246303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246316 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246321 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246323 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246332 */   // GIR_Coverage, 48508,
     /* 2246332 */   GIR_EraseRootFromParent_Done,
     /* 2246333 */ // Label 30015: @2246333
     /* 2246333 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2246381), // Rule ID 48509 //
     /* 2246338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246351 */   // MIs[0] Operand 1
     /* 2246351 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246364 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246369 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246380 */   // GIR_Coverage, 48509,
     /* 2246380 */   GIR_EraseRootFromParent_Done,
     /* 2246381 */ // Label 30016: @2246381
     /* 2246381 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2246429), // Rule ID 48534 //
     /* 2246386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246399 */   // MIs[0] Operand 1
     /* 2246399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246412 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2246415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246428 */   // GIR_Coverage, 48534,
     /* 2246428 */   GIR_EraseRootFromParent_Done,
     /* 2246429 */ // Label 30017: @2246429
     /* 2246429 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2246477), // Rule ID 48535 //
     /* 2246434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246447 */   // MIs[0] Operand 1
     /* 2246447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246460 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2246463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246476 */   // GIR_Coverage, 48535,
     /* 2246476 */   GIR_EraseRootFromParent_Done,
     /* 2246477 */ // Label 30018: @2246477
     /* 2246477 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2246525), // Rule ID 48540 //
     /* 2246482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246495 */   // MIs[0] Operand 1
     /* 2246495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246508 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246524 */   // GIR_Coverage, 48540,
     /* 2246524 */   GIR_EraseRootFromParent_Done,
     /* 2246525 */ // Label 30019: @2246525
     /* 2246525 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2246573), // Rule ID 48541 //
     /* 2246530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246543 */   // MIs[0] Operand 1
     /* 2246543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246556 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2246559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246572 */   // GIR_Coverage, 48541,
     /* 2246572 */   GIR_EraseRootFromParent_Done,
     /* 2246573 */ // Label 30020: @2246573
     /* 2246573 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2246621), // Rule ID 48544 //
     /* 2246578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246591 */   // MIs[0] Operand 1
     /* 2246591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246604 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246609 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246611 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246620 */   // GIR_Coverage, 48544,
     /* 2246620 */   GIR_EraseRootFromParent_Done,
     /* 2246621 */ // Label 30021: @2246621
     /* 2246621 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2246669), // Rule ID 48545 //
     /* 2246626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246639 */   // MIs[0] Operand 1
     /* 2246639 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246652 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2246655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246657 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246659 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246668 */   // GIR_Coverage, 48545,
     /* 2246668 */   GIR_EraseRootFromParent_Done,
     /* 2246669 */ // Label 30022: @2246669
     /* 2246669 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2246717), // Rule ID 48552 //
     /* 2246674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246687 */   // MIs[0] Operand 1
     /* 2246687 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246696 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246700 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246705 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246707 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246716 */   // GIR_Coverage, 48552,
     /* 2246716 */   GIR_EraseRootFromParent_Done,
     /* 2246717 */ // Label 30023: @2246717
     /* 2246717 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2246765), // Rule ID 48553 //
     /* 2246722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246735 */   // MIs[0] Operand 1
     /* 2246735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246748 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2246751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246753 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246755 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246764 */   // GIR_Coverage, 48553,
     /* 2246764 */   GIR_EraseRootFromParent_Done,
     /* 2246765 */ // Label 30024: @2246765
     /* 2246765 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2246813), // Rule ID 48578 //
     /* 2246770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246783 */   // MIs[0] Operand 1
     /* 2246783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246796 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246801 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246812 */   // GIR_Coverage, 48578,
     /* 2246812 */   GIR_EraseRootFromParent_Done,
     /* 2246813 */ // Label 30025: @2246813
     /* 2246813 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2246861), // Rule ID 48579 //
     /* 2246818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246831 */   // MIs[0] Operand 1
     /* 2246831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246844 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2246847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246849 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246860 */   // GIR_Coverage, 48579,
     /* 2246860 */   GIR_EraseRootFromParent_Done,
     /* 2246861 */ // Label 30026: @2246861
     /* 2246861 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2246909), // Rule ID 48584 //
     /* 2246866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246879 */   // MIs[0] Operand 1
     /* 2246879 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246888 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246892 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246897 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246899 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246908 */   // GIR_Coverage, 48584,
     /* 2246908 */   GIR_EraseRootFromParent_Done,
     /* 2246909 */ // Label 30027: @2246909
     /* 2246909 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2246957), // Rule ID 48585 //
     /* 2246914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246927 */   // MIs[0] Operand 1
     /* 2246927 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246936 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246940 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246945 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246947 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246956 */   // GIR_Coverage, 48585,
     /* 2246956 */   GIR_EraseRootFromParent_Done,
     /* 2246957 */ // Label 30028: @2246957
     /* 2246957 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2247005), // Rule ID 48588 //
     /* 2246962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246975 */   // MIs[0] Operand 1
     /* 2246975 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246984 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246988 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246993 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247004 */   // GIR_Coverage, 48588,
     /* 2247004 */   GIR_EraseRootFromParent_Done,
     /* 2247005 */ // Label 30029: @2247005
     /* 2247005 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2247053), // Rule ID 48589 //
     /* 2247010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247023 */   // MIs[0] Operand 1
     /* 2247023 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247036 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247041 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247043 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247052 */   // GIR_Coverage, 48589,
     /* 2247052 */   GIR_EraseRootFromParent_Done,
     /* 2247053 */ // Label 30030: @2247053
     /* 2247053 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2247101), // Rule ID 48596 //
     /* 2247058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247071 */   // MIs[0] Operand 1
     /* 2247071 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247084 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247089 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247091 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247100 */   // GIR_Coverage, 48596,
     /* 2247100 */   GIR_EraseRootFromParent_Done,
     /* 2247101 */ // Label 30031: @2247101
     /* 2247101 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2247149), // Rule ID 48597 //
     /* 2247106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247119 */   // MIs[0] Operand 1
     /* 2247119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247132 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247137 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247139 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247148 */   // GIR_Coverage, 48597,
     /* 2247148 */   GIR_EraseRootFromParent_Done,
     /* 2247149 */ // Label 30032: @2247149
     /* 2247149 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2247197), // Rule ID 48626 //
     /* 2247154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247160 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247167 */   // MIs[0] Operand 1
     /* 2247167 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247176 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247180 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2247183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247185 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247187 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247196 */   // GIR_Coverage, 48626,
     /* 2247196 */   GIR_EraseRootFromParent_Done,
     /* 2247197 */ // Label 30033: @2247197
     /* 2247197 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2247245), // Rule ID 48627 //
     /* 2247202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247215 */   // MIs[0] Operand 1
     /* 2247215 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247228 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2247231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247233 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247244 */   // GIR_Coverage, 48627,
     /* 2247244 */   GIR_EraseRootFromParent_Done,
     /* 2247245 */ // Label 30034: @2247245
     /* 2247245 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2247293), // Rule ID 48630 //
     /* 2247250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247263 */   // MIs[0] Operand 1
     /* 2247263 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247276 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247292 */   // GIR_Coverage, 48630,
     /* 2247292 */   GIR_EraseRootFromParent_Done,
     /* 2247293 */ // Label 30035: @2247293
     /* 2247293 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2247341), // Rule ID 48631 //
     /* 2247298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247304 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247311 */   // MIs[0] Operand 1
     /* 2247311 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247320 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247324 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2247327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247339 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247340 */   // GIR_Coverage, 48631,
     /* 2247340 */   GIR_EraseRootFromParent_Done,
     /* 2247341 */ // Label 30036: @2247341
     /* 2247341 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2247389), // Rule ID 48638 //
     /* 2247346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247359 */   // MIs[0] Operand 1
     /* 2247359 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247372 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247388 */   // GIR_Coverage, 48638,
     /* 2247388 */   GIR_EraseRootFromParent_Done,
     /* 2247389 */ // Label 30037: @2247389
     /* 2247389 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2247437), // Rule ID 48639 //
     /* 2247394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247407 */   // MIs[0] Operand 1
     /* 2247407 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247416 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247420 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247427 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247436 */   // GIR_Coverage, 48639,
     /* 2247436 */   GIR_EraseRootFromParent_Done,
     /* 2247437 */ // Label 30038: @2247437
     /* 2247437 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2247485), // Rule ID 48664 //
     /* 2247442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247455 */   // MIs[0] Operand 1
     /* 2247455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247468 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247473 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247484 */   // GIR_Coverage, 48664,
     /* 2247484 */   GIR_EraseRootFromParent_Done,
     /* 2247485 */ // Label 30039: @2247485
     /* 2247485 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2247533), // Rule ID 48665 //
     /* 2247490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247503 */   // MIs[0] Operand 1
     /* 2247503 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247512 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247516 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247521 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247532 */   // GIR_Coverage, 48665,
     /* 2247532 */   GIR_EraseRootFromParent_Done,
     /* 2247533 */ // Label 30040: @2247533
     /* 2247533 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2247581), // Rule ID 48670 //
     /* 2247538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247551 */   // MIs[0] Operand 1
     /* 2247551 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247560 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247564 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247569 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247580 */   // GIR_Coverage, 48670,
     /* 2247580 */   GIR_EraseRootFromParent_Done,
     /* 2247581 */ // Label 30041: @2247581
     /* 2247581 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2247629), // Rule ID 48671 //
     /* 2247586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247599 */   // MIs[0] Operand 1
     /* 2247599 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247612 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247617 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247628 */   // GIR_Coverage, 48671,
     /* 2247628 */   GIR_EraseRootFromParent_Done,
     /* 2247629 */ // Label 30042: @2247629
     /* 2247629 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2247677), // Rule ID 48674 //
     /* 2247634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247647 */   // MIs[0] Operand 1
     /* 2247647 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247656 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247660 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247676 */   // GIR_Coverage, 48674,
     /* 2247676 */   GIR_EraseRootFromParent_Done,
     /* 2247677 */ // Label 30043: @2247677
     /* 2247677 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2247725), // Rule ID 48675 //
     /* 2247682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247695 */   // MIs[0] Operand 1
     /* 2247695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247708 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247724 */   // GIR_Coverage, 48675,
     /* 2247724 */   GIR_EraseRootFromParent_Done,
     /* 2247725 */ // Label 30044: @2247725
     /* 2247725 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2247773), // Rule ID 48682 //
     /* 2247730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247736 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247743 */   // MIs[0] Operand 1
     /* 2247743 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247752 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247756 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247772 */   // GIR_Coverage, 48682,
     /* 2247772 */   GIR_EraseRootFromParent_Done,
     /* 2247773 */ // Label 30045: @2247773
     /* 2247773 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2247821), // Rule ID 48683 //
     /* 2247778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247791 */   // MIs[0] Operand 1
     /* 2247791 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247800 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247804 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247811 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247820 */   // GIR_Coverage, 48683,
     /* 2247820 */   GIR_EraseRootFromParent_Done,
     /* 2247821 */ // Label 30046: @2247821
     /* 2247821 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2247869), // Rule ID 48708 //
     /* 2247826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247839 */   // MIs[0] Operand 1
     /* 2247839 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247848 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247852 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247857 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247868 */   // GIR_Coverage, 48708,
     /* 2247868 */   GIR_EraseRootFromParent_Done,
     /* 2247869 */ // Label 30047: @2247869
     /* 2247869 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2247917), // Rule ID 48709 //
     /* 2247874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247887 */   // MIs[0] Operand 1
     /* 2247887 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247896 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247900 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247905 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247916 */   // GIR_Coverage, 48709,
     /* 2247916 */   GIR_EraseRootFromParent_Done,
     /* 2247917 */ // Label 30048: @2247917
     /* 2247917 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2247965), // Rule ID 48714 //
     /* 2247922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247935 */   // MIs[0] Operand 1
     /* 2247935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247948 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247953 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247955 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247964 */   // GIR_Coverage, 48714,
     /* 2247964 */   GIR_EraseRootFromParent_Done,
     /* 2247965 */ // Label 30049: @2247965
     /* 2247965 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2248013), // Rule ID 48715 //
     /* 2247970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247983 */   // MIs[0] Operand 1
     /* 2247983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247996 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248001 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248012 */   // GIR_Coverage, 48715,
     /* 2248012 */   GIR_EraseRootFromParent_Done,
     /* 2248013 */ // Label 30050: @2248013
     /* 2248013 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2248061), // Rule ID 48718 //
     /* 2248018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248031 */   // MIs[0] Operand 1
     /* 2248031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248044 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2248047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248049 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248060 */   // GIR_Coverage, 48718,
     /* 2248060 */   GIR_EraseRootFromParent_Done,
     /* 2248061 */ // Label 30051: @2248061
     /* 2248061 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2248109), // Rule ID 48719 //
     /* 2248066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248079 */   // MIs[0] Operand 1
     /* 2248079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248092 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2248095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248097 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248108 */   // GIR_Coverage, 48719,
     /* 2248108 */   GIR_EraseRootFromParent_Done,
     /* 2248109 */ // Label 30052: @2248109
     /* 2248109 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2248157), // Rule ID 48726 //
     /* 2248114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248127 */   // MIs[0] Operand 1
     /* 2248127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248140 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248156 */   // GIR_Coverage, 48726,
     /* 2248156 */   GIR_EraseRootFromParent_Done,
     /* 2248157 */ // Label 30053: @2248157
     /* 2248157 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2248205), // Rule ID 48727 //
     /* 2248162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248175 */   // MIs[0] Operand 1
     /* 2248175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248188 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248204 */   // GIR_Coverage, 48727,
     /* 2248204 */   GIR_EraseRootFromParent_Done,
     /* 2248205 */ // Label 30054: @2248205
     /* 2248205 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2248253), // Rule ID 48752 //
     /* 2248210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248223 */   // MIs[0] Operand 1
     /* 2248223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248236 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248241 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248252 */   // GIR_Coverage, 48752,
     /* 2248252 */   GIR_EraseRootFromParent_Done,
     /* 2248253 */ // Label 30055: @2248253
     /* 2248253 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2248301), // Rule ID 48753 //
     /* 2248258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248271 */   // MIs[0] Operand 1
     /* 2248271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248284 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248300 */   // GIR_Coverage, 48753,
     /* 2248300 */   GIR_EraseRootFromParent_Done,
     /* 2248301 */ // Label 30056: @2248301
     /* 2248301 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2248349), // Rule ID 48758 //
     /* 2248306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248319 */   // MIs[0] Operand 1
     /* 2248319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248332 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248348 */   // GIR_Coverage, 48758,
     /* 2248348 */   GIR_EraseRootFromParent_Done,
     /* 2248349 */ // Label 30057: @2248349
     /* 2248349 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2248397), // Rule ID 48759 //
     /* 2248354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248367 */   // MIs[0] Operand 1
     /* 2248367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248380 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248396 */   // GIR_Coverage, 48759,
     /* 2248396 */   GIR_EraseRootFromParent_Done,
     /* 2248397 */ // Label 30058: @2248397
     /* 2248397 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2248445), // Rule ID 48762 //
     /* 2248402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248415 */   // MIs[0] Operand 1
     /* 2248415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248428 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248444 */   // GIR_Coverage, 48762,
     /* 2248444 */   GIR_EraseRootFromParent_Done,
     /* 2248445 */ // Label 30059: @2248445
     /* 2248445 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2248493), // Rule ID 48763 //
     /* 2248450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248463 */   // MIs[0] Operand 1
     /* 2248463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248476 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248492 */   // GIR_Coverage, 48763,
     /* 2248492 */   GIR_EraseRootFromParent_Done,
     /* 2248493 */ // Label 30060: @2248493
     /* 2248493 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2248541), // Rule ID 48770 //
     /* 2248498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248511 */   // MIs[0] Operand 1
     /* 2248511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248524 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248540 */   // GIR_Coverage, 48770,
     /* 2248540 */   GIR_EraseRootFromParent_Done,
     /* 2248541 */ // Label 30061: @2248541
     /* 2248541 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2248589), // Rule ID 48771 //
     /* 2248546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248559 */   // MIs[0] Operand 1
     /* 2248559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248572 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248588 */   // GIR_Coverage, 48771,
     /* 2248588 */   GIR_EraseRootFromParent_Done,
     /* 2248589 */ // Label 30062: @2248589
     /* 2248589 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2248637), // Rule ID 48796 //
     /* 2248594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248607 */   // MIs[0] Operand 1
     /* 2248607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248620 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248625 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248636 */   // GIR_Coverage, 48796,
     /* 2248636 */   GIR_EraseRootFromParent_Done,
     /* 2248637 */ // Label 30063: @2248637
     /* 2248637 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2248685), // Rule ID 48797 //
     /* 2248642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248655 */   // MIs[0] Operand 1
     /* 2248655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248668 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2248671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248673 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248684 */   // GIR_Coverage, 48797,
     /* 2248684 */   GIR_EraseRootFromParent_Done,
     /* 2248685 */ // Label 30064: @2248685
     /* 2248685 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2248733), // Rule ID 48802 //
     /* 2248690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248703 */   // MIs[0] Operand 1
     /* 2248703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248716 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248721 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248732 */   // GIR_Coverage, 48802,
     /* 2248732 */   GIR_EraseRootFromParent_Done,
     /* 2248733 */ // Label 30065: @2248733
     /* 2248733 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2248781), // Rule ID 48803 //
     /* 2248738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248751 */   // MIs[0] Operand 1
     /* 2248751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248764 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2248767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248769 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248780 */   // GIR_Coverage, 48803,
     /* 2248780 */   GIR_EraseRootFromParent_Done,
     /* 2248781 */ // Label 30066: @2248781
     /* 2248781 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2248829), // Rule ID 48806 //
     /* 2248786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248799 */   // MIs[0] Operand 1
     /* 2248799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248812 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248817 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248828 */   // GIR_Coverage, 48806,
     /* 2248828 */   GIR_EraseRootFromParent_Done,
     /* 2248829 */ // Label 30067: @2248829
     /* 2248829 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2248877), // Rule ID 48807 //
     /* 2248834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248847 */   // MIs[0] Operand 1
     /* 2248847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248860 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2248863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248865 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248876 */   // GIR_Coverage, 48807,
     /* 2248876 */   GIR_EraseRootFromParent_Done,
     /* 2248877 */ // Label 30068: @2248877
     /* 2248877 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2248925), // Rule ID 48814 //
     /* 2248882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248895 */   // MIs[0] Operand 1
     /* 2248895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248908 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248913 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248924 */   // GIR_Coverage, 48814,
     /* 2248924 */   GIR_EraseRootFromParent_Done,
     /* 2248925 */ // Label 30069: @2248925
     /* 2248925 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2248973), // Rule ID 48815 //
     /* 2248930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248943 */   // MIs[0] Operand 1
     /* 2248943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248956 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248961 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248972 */   // GIR_Coverage, 48815,
     /* 2248972 */   GIR_EraseRootFromParent_Done,
     /* 2248973 */ // Label 30070: @2248973
     /* 2248973 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2249021), // Rule ID 48840 //
     /* 2248978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248991 */   // MIs[0] Operand 1
     /* 2248991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249004 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249020 */   // GIR_Coverage, 48840,
     /* 2249020 */   GIR_EraseRootFromParent_Done,
     /* 2249021 */ // Label 30071: @2249021
     /* 2249021 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2249069), // Rule ID 48841 //
     /* 2249026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249039 */   // MIs[0] Operand 1
     /* 2249039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249052 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249068 */   // GIR_Coverage, 48841,
     /* 2249068 */   GIR_EraseRootFromParent_Done,
     /* 2249069 */ // Label 30072: @2249069
     /* 2249069 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2249117), // Rule ID 48846 //
     /* 2249074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249087 */   // MIs[0] Operand 1
     /* 2249087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249100 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249116 */   // GIR_Coverage, 48846,
     /* 2249116 */   GIR_EraseRootFromParent_Done,
     /* 2249117 */ // Label 30073: @2249117
     /* 2249117 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2249165), // Rule ID 48847 //
     /* 2249122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249135 */   // MIs[0] Operand 1
     /* 2249135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249148 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249164 */   // GIR_Coverage, 48847,
     /* 2249164 */   GIR_EraseRootFromParent_Done,
     /* 2249165 */ // Label 30074: @2249165
     /* 2249165 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2249213), // Rule ID 48850 //
     /* 2249170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249183 */   // MIs[0] Operand 1
     /* 2249183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249196 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249212 */   // GIR_Coverage, 48850,
     /* 2249212 */   GIR_EraseRootFromParent_Done,
     /* 2249213 */ // Label 30075: @2249213
     /* 2249213 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2249261), // Rule ID 48851 //
     /* 2249218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249231 */   // MIs[0] Operand 1
     /* 2249231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249244 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249260 */   // GIR_Coverage, 48851,
     /* 2249260 */   GIR_EraseRootFromParent_Done,
     /* 2249261 */ // Label 30076: @2249261
     /* 2249261 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2249309), // Rule ID 48858 //
     /* 2249266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249279 */   // MIs[0] Operand 1
     /* 2249279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249292 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249308 */   // GIR_Coverage, 48858,
     /* 2249308 */   GIR_EraseRootFromParent_Done,
     /* 2249309 */ // Label 30077: @2249309
     /* 2249309 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2249357), // Rule ID 48859 //
     /* 2249314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249327 */   // MIs[0] Operand 1
     /* 2249327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249340 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249356 */   // GIR_Coverage, 48859,
     /* 2249356 */   GIR_EraseRootFromParent_Done,
     /* 2249357 */ // Label 30078: @2249357
     /* 2249357 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2249405), // Rule ID 48884 //
     /* 2249362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249375 */   // MIs[0] Operand 1
     /* 2249375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249388 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249393 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249404 */   // GIR_Coverage, 48884,
     /* 2249404 */   GIR_EraseRootFromParent_Done,
     /* 2249405 */ // Label 30079: @2249405
     /* 2249405 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2249453), // Rule ID 48885 //
     /* 2249410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2249416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2249419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249423 */   // MIs[0] Operand 1
     /* 2249423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249436 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2249439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249441 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249452 */   // GIR_Coverage, 48885,
     /* 2249452 */   GIR_EraseRootFromParent_Done,
     /* 2249453 */ // Label 30080: @2249453
     /* 2249453 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2249501), // Rule ID 48890 //
     /* 2249458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249471 */   // MIs[0] Operand 1
     /* 2249471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249484 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249500 */   // GIR_Coverage, 48890,
     /* 2249500 */   GIR_EraseRootFromParent_Done,
     /* 2249501 */ // Label 30081: @2249501
     /* 2249501 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2249549), // Rule ID 48891 //
     /* 2249506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2249512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2249515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249519 */   // MIs[0] Operand 1
     /* 2249519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249532 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2249535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249537 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249548 */   // GIR_Coverage, 48891,
     /* 2249548 */   GIR_EraseRootFromParent_Done,
     /* 2249549 */ // Label 30082: @2249549
     /* 2249549 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2249597), // Rule ID 48894 //
     /* 2249554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249567 */   // MIs[0] Operand 1
     /* 2249567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249580 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249585 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249596 */   // GIR_Coverage, 48894,
     /* 2249596 */   GIR_EraseRootFromParent_Done,
     /* 2249597 */ // Label 30083: @2249597
     /* 2249597 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2249645), // Rule ID 48895 //
     /* 2249602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2249608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2249611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249615 */   // MIs[0] Operand 1
     /* 2249615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249628 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2249631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249633 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249635 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249644 */   // GIR_Coverage, 48895,
     /* 2249644 */   GIR_EraseRootFromParent_Done,
     /* 2249645 */ // Label 30084: @2249645
     /* 2249645 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2249693), // Rule ID 48902 //
     /* 2249650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249663 */   // MIs[0] Operand 1
     /* 2249663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249676 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249681 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249683 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249692 */   // GIR_Coverage, 48902,
     /* 2249692 */   GIR_EraseRootFromParent_Done,
     /* 2249693 */ // Label 30085: @2249693
     /* 2249693 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2249741), // Rule ID 48903 //
     /* 2249698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2249704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2249707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249711 */   // MIs[0] Operand 1
     /* 2249711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249724 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2249727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249729 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249740 */   // GIR_Coverage, 48903,
     /* 2249740 */   GIR_EraseRootFromParent_Done,
     /* 2249741 */ // Label 30086: @2249741
     /* 2249741 */ GIM_Reject,
     /* 2249742 */ // Label 29902: @2249742
     /* 2249742 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2249790), // Rule ID 48492 //
     /* 2249747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249760 */   // MIs[0] Operand 1
     /* 2249760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249773 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249789 */   // GIR_Coverage, 48492,
     /* 2249789 */   GIR_EraseRootFromParent_Done,
     /* 2249790 */ // Label 30087: @2249790
     /* 2249790 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2249838), // Rule ID 48493 //
     /* 2249795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249808 */   // MIs[0] Operand 1
     /* 2249808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249821 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2249824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249826 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249837 */   // GIR_Coverage, 48493,
     /* 2249837 */   GIR_EraseRootFromParent_Done,
     /* 2249838 */ // Label 30088: @2249838
     /* 2249838 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2249886), // Rule ID 48498 //
     /* 2249843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249856 */   // MIs[0] Operand 1
     /* 2249856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249869 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249874 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249885 */   // GIR_Coverage, 48498,
     /* 2249885 */   GIR_EraseRootFromParent_Done,
     /* 2249886 */ // Label 30089: @2249886
     /* 2249886 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2249934), // Rule ID 48499 //
     /* 2249891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249904 */   // MIs[0] Operand 1
     /* 2249904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249917 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249933 */   // GIR_Coverage, 48499,
     /* 2249933 */   GIR_EraseRootFromParent_Done,
     /* 2249934 */ // Label 30090: @2249934
     /* 2249934 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2249982), // Rule ID 48506 //
     /* 2249939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249952 */   // MIs[0] Operand 1
     /* 2249952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249965 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249981 */   // GIR_Coverage, 48506,
     /* 2249981 */   GIR_EraseRootFromParent_Done,
     /* 2249982 */ // Label 30091: @2249982
     /* 2249982 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2250030), // Rule ID 48507 //
     /* 2249987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250000 */   // MIs[0] Operand 1
     /* 2250000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250013 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2250016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250029 */   // GIR_Coverage, 48507,
     /* 2250029 */   GIR_EraseRootFromParent_Done,
     /* 2250030 */ // Label 30092: @2250030
     /* 2250030 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2250078), // Rule ID 48528 //
     /* 2250035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250048 */   // MIs[0] Operand 1
     /* 2250048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250061 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250077 */   // GIR_Coverage, 48528,
     /* 2250077 */   GIR_EraseRootFromParent_Done,
     /* 2250078 */ // Label 30093: @2250078
     /* 2250078 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2250126), // Rule ID 48529 //
     /* 2250083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250096 */   // MIs[0] Operand 1
     /* 2250096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250109 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250125 */   // GIR_Coverage, 48529,
     /* 2250125 */   GIR_EraseRootFromParent_Done,
     /* 2250126 */ // Label 30094: @2250126
     /* 2250126 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2250174), // Rule ID 48536 //
     /* 2250131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250144 */   // MIs[0] Operand 1
     /* 2250144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250157 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2250160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250173 */   // GIR_Coverage, 48536,
     /* 2250173 */   GIR_EraseRootFromParent_Done,
     /* 2250174 */ // Label 30095: @2250174
     /* 2250174 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2250222), // Rule ID 48537 //
     /* 2250179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250192 */   // MIs[0] Operand 1
     /* 2250192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250205 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2250208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250221 */   // GIR_Coverage, 48537,
     /* 2250221 */   GIR_EraseRootFromParent_Done,
     /* 2250222 */ // Label 30096: @2250222
     /* 2250222 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2250270), // Rule ID 48542 //
     /* 2250227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250240 */   // MIs[0] Operand 1
     /* 2250240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250253 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2250256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250269 */   // GIR_Coverage, 48542,
     /* 2250269 */   GIR_EraseRootFromParent_Done,
     /* 2250270 */ // Label 30097: @2250270
     /* 2250270 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2250318), // Rule ID 48543 //
     /* 2250275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250288 */   // MIs[0] Operand 1
     /* 2250288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250301 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2250304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250317 */   // GIR_Coverage, 48543,
     /* 2250317 */   GIR_EraseRootFromParent_Done,
     /* 2250318 */ // Label 30098: @2250318
     /* 2250318 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2250366), // Rule ID 48550 //
     /* 2250323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250336 */   // MIs[0] Operand 1
     /* 2250336 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250349 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2250352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250356 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250365 */   // GIR_Coverage, 48550,
     /* 2250365 */   GIR_EraseRootFromParent_Done,
     /* 2250366 */ // Label 30099: @2250366
     /* 2250366 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2250414), // Rule ID 48551 //
     /* 2250371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250384 */   // MIs[0] Operand 1
     /* 2250384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250397 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2250400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250404 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250413 */   // GIR_Coverage, 48551,
     /* 2250413 */   GIR_EraseRootFromParent_Done,
     /* 2250414 */ // Label 30100: @2250414
     /* 2250414 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2250462), // Rule ID 48572 //
     /* 2250419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250432 */   // MIs[0] Operand 1
     /* 2250432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250445 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2250448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250452 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250461 */   // GIR_Coverage, 48572,
     /* 2250461 */   GIR_EraseRootFromParent_Done,
     /* 2250462 */ // Label 30101: @2250462
     /* 2250462 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2250510), // Rule ID 48573 //
     /* 2250467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250480 */   // MIs[0] Operand 1
     /* 2250480 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2250485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250493 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2250496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250498 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250500 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250509 */   // GIR_Coverage, 48573,
     /* 2250509 */   GIR_EraseRootFromParent_Done,
     /* 2250510 */ // Label 30102: @2250510
     /* 2250510 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2250558), // Rule ID 48580 //
     /* 2250515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250528 */   // MIs[0] Operand 1
     /* 2250528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250541 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250546 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250557 */   // GIR_Coverage, 48580,
     /* 2250557 */   GIR_EraseRootFromParent_Done,
     /* 2250558 */ // Label 30103: @2250558
     /* 2250558 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2250606), // Rule ID 48581 //
     /* 2250563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250576 */   // MIs[0] Operand 1
     /* 2250576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250589 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250594 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250605 */   // GIR_Coverage, 48581,
     /* 2250605 */   GIR_EraseRootFromParent_Done,
     /* 2250606 */ // Label 30104: @2250606
     /* 2250606 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2250654), // Rule ID 48586 //
     /* 2250611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250624 */   // MIs[0] Operand 1
     /* 2250624 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250633 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250637 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250642 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250644 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250653 */   // GIR_Coverage, 48586,
     /* 2250653 */   GIR_EraseRootFromParent_Done,
     /* 2250654 */ // Label 30105: @2250654
     /* 2250654 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2250702), // Rule ID 48587 //
     /* 2250659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250672 */   // MIs[0] Operand 1
     /* 2250672 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250681 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250685 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250690 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250692 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250701 */   // GIR_Coverage, 48587,
     /* 2250701 */   GIR_EraseRootFromParent_Done,
     /* 2250702 */ // Label 30106: @2250702
     /* 2250702 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2250750), // Rule ID 48594 //
     /* 2250707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250720 */   // MIs[0] Operand 1
     /* 2250720 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250729 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250733 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250738 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250740 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250749 */   // GIR_Coverage, 48594,
     /* 2250749 */   GIR_EraseRootFromParent_Done,
     /* 2250750 */ // Label 30107: @2250750
     /* 2250750 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2250798), // Rule ID 48595 //
     /* 2250755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250768 */   // MIs[0] Operand 1
     /* 2250768 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250781 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250788 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250797 */   // GIR_Coverage, 48595,
     /* 2250797 */   GIR_EraseRootFromParent_Done,
     /* 2250798 */ // Label 30108: @2250798
     /* 2250798 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2250846), // Rule ID 48616 //
     /* 2250803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250816 */   // MIs[0] Operand 1
     /* 2250816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250829 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250845 */   // GIR_Coverage, 48616,
     /* 2250845 */   GIR_EraseRootFromParent_Done,
     /* 2250846 */ // Label 30109: @2250846
     /* 2250846 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2250894), // Rule ID 48617 //
     /* 2250851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250864 */   // MIs[0] Operand 1
     /* 2250864 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2250869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250877 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250884 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250893 */   // GIR_Coverage, 48617,
     /* 2250893 */   GIR_EraseRootFromParent_Done,
     /* 2250894 */ // Label 30110: @2250894
     /* 2250894 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2250942), // Rule ID 48622 //
     /* 2250899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250912 */   // MIs[0] Operand 1
     /* 2250912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250921 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250925 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250930 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250932 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250941 */   // GIR_Coverage, 48622,
     /* 2250941 */   GIR_EraseRootFromParent_Done,
     /* 2250942 */ // Label 30111: @2250942
     /* 2250942 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2250990), // Rule ID 48623 //
     /* 2250947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250960 */   // MIs[0] Operand 1
     /* 2250960 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250973 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250978 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250980 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250989 */   // GIR_Coverage, 48623,
     /* 2250989 */   GIR_EraseRootFromParent_Done,
     /* 2250990 */ // Label 30112: @2250990
     /* 2250990 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2251038), // Rule ID 48628 //
     /* 2250995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251008 */   // MIs[0] Operand 1
     /* 2251008 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251021 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2251024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251026 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251028 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251037 */   // GIR_Coverage, 48628,
     /* 2251037 */   GIR_EraseRootFromParent_Done,
     /* 2251038 */ // Label 30113: @2251038
     /* 2251038 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2251086), // Rule ID 48629 //
     /* 2251043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251056 */   // MIs[0] Operand 1
     /* 2251056 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251065 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251069 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2251072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251074 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251076 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251085 */   // GIR_Coverage, 48629,
     /* 2251085 */   GIR_EraseRootFromParent_Done,
     /* 2251086 */ // Label 30114: @2251086
     /* 2251086 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2251134), // Rule ID 48636 //
     /* 2251091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251104 */   // MIs[0] Operand 1
     /* 2251104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251113 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251117 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2251120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251122 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251124 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251133 */   // GIR_Coverage, 48636,
     /* 2251133 */   GIR_EraseRootFromParent_Done,
     /* 2251134 */ // Label 30115: @2251134
     /* 2251134 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2251182), // Rule ID 48637 //
     /* 2251139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251152 */   // MIs[0] Operand 1
     /* 2251152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251165 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2251168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251172 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251181 */   // GIR_Coverage, 48637,
     /* 2251181 */   GIR_EraseRootFromParent_Done,
     /* 2251182 */ // Label 30116: @2251182
     /* 2251182 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2251230), // Rule ID 48658 //
     /* 2251187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251193 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251200 */   // MIs[0] Operand 1
     /* 2251200 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251209 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251213 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251220 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251229 */   // GIR_Coverage, 48658,
     /* 2251229 */   GIR_EraseRootFromParent_Done,
     /* 2251230 */ // Label 30117: @2251230
     /* 2251230 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2251278), // Rule ID 48659 //
     /* 2251235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251241 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251248 */   // MIs[0] Operand 1
     /* 2251248 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251257 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251261 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251268 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251277 */   // GIR_Coverage, 48659,
     /* 2251277 */   GIR_EraseRootFromParent_Done,
     /* 2251278 */ // Label 30118: @2251278
     /* 2251278 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2251326), // Rule ID 48666 //
     /* 2251283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251296 */   // MIs[0] Operand 1
     /* 2251296 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251305 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251309 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251314 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251316 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251325 */   // GIR_Coverage, 48666,
     /* 2251325 */   GIR_EraseRootFromParent_Done,
     /* 2251326 */ // Label 30119: @2251326
     /* 2251326 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2251374), // Rule ID 48667 //
     /* 2251331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251344 */   // MIs[0] Operand 1
     /* 2251344 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251353 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251357 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251362 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251364 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251372 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251373 */   // GIR_Coverage, 48667,
     /* 2251373 */   GIR_EraseRootFromParent_Done,
     /* 2251374 */ // Label 30120: @2251374
     /* 2251374 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2251422), // Rule ID 48672 //
     /* 2251379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251385 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251392 */   // MIs[0] Operand 1
     /* 2251392 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251405 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251410 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251412 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251421 */   // GIR_Coverage, 48672,
     /* 2251421 */   GIR_EraseRootFromParent_Done,
     /* 2251422 */ // Label 30121: @2251422
     /* 2251422 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2251470), // Rule ID 48673 //
     /* 2251427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251440 */   // MIs[0] Operand 1
     /* 2251440 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251449 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251453 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251458 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251460 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251469 */   // GIR_Coverage, 48673,
     /* 2251469 */   GIR_EraseRootFromParent_Done,
     /* 2251470 */ // Label 30122: @2251470
     /* 2251470 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2251518), // Rule ID 48680 //
     /* 2251475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251488 */   // MIs[0] Operand 1
     /* 2251488 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251497 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251501 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251506 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251508 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251517 */   // GIR_Coverage, 48680,
     /* 2251517 */   GIR_EraseRootFromParent_Done,
     /* 2251518 */ // Label 30123: @2251518
     /* 2251518 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2251566), // Rule ID 48681 //
     /* 2251523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251536 */   // MIs[0] Operand 1
     /* 2251536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251545 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251549 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251565 */   // GIR_Coverage, 48681,
     /* 2251565 */   GIR_EraseRootFromParent_Done,
     /* 2251566 */ // Label 30124: @2251566
     /* 2251566 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2251614), // Rule ID 48702 //
     /* 2251571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251577 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251584 */   // MIs[0] Operand 1
     /* 2251584 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251593 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251597 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251602 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251604 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251613 */   // GIR_Coverage, 48702,
     /* 2251613 */   GIR_EraseRootFromParent_Done,
     /* 2251614 */ // Label 30125: @2251614
     /* 2251614 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2251662), // Rule ID 48703 //
     /* 2251619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251632 */   // MIs[0] Operand 1
     /* 2251632 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251641 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251645 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251652 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251661 */   // GIR_Coverage, 48703,
     /* 2251661 */   GIR_EraseRootFromParent_Done,
     /* 2251662 */ // Label 30126: @2251662
     /* 2251662 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2251710), // Rule ID 48710 //
     /* 2251667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251680 */   // MIs[0] Operand 1
     /* 2251680 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251689 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251693 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251698 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251709 */   // GIR_Coverage, 48710,
     /* 2251709 */   GIR_EraseRootFromParent_Done,
     /* 2251710 */ // Label 30127: @2251710
     /* 2251710 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2251758), // Rule ID 48711 //
     /* 2251715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251728 */   // MIs[0] Operand 1
     /* 2251728 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251737 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251741 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2251744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251746 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251757 */   // GIR_Coverage, 48711,
     /* 2251757 */   GIR_EraseRootFromParent_Done,
     /* 2251758 */ // Label 30128: @2251758
     /* 2251758 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2251806), // Rule ID 48716 //
     /* 2251763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251776 */   // MIs[0] Operand 1
     /* 2251776 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251789 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251794 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251796 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251805 */   // GIR_Coverage, 48716,
     /* 2251805 */   GIR_EraseRootFromParent_Done,
     /* 2251806 */ // Label 30129: @2251806
     /* 2251806 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2251854), // Rule ID 48717 //
     /* 2251811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251817 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251824 */   // MIs[0] Operand 1
     /* 2251824 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251833 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251837 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2251840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251842 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251853 */   // GIR_Coverage, 48717,
     /* 2251853 */   GIR_EraseRootFromParent_Done,
     /* 2251854 */ // Label 30130: @2251854
     /* 2251854 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2251902), // Rule ID 48724 //
     /* 2251859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251872 */   // MIs[0] Operand 1
     /* 2251872 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251881 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251885 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251901 */   // GIR_Coverage, 48724,
     /* 2251901 */   GIR_EraseRootFromParent_Done,
     /* 2251902 */ // Label 30131: @2251902
     /* 2251902 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2251950), // Rule ID 48725 //
     /* 2251907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251920 */   // MIs[0] Operand 1
     /* 2251920 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251933 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251949 */   // GIR_Coverage, 48725,
     /* 2251949 */   GIR_EraseRootFromParent_Done,
     /* 2251950 */ // Label 30132: @2251950
     /* 2251950 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2251998), // Rule ID 48746 //
     /* 2251955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251968 */   // MIs[0] Operand 1
     /* 2251968 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251977 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251981 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251986 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251997 */   // GIR_Coverage, 48746,
     /* 2251997 */   GIR_EraseRootFromParent_Done,
     /* 2251998 */ // Label 30133: @2251998
     /* 2251998 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2252046), // Rule ID 48747 //
     /* 2252003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252016 */   // MIs[0] Operand 1
     /* 2252016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252029 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2252032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252034 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252045 */   // GIR_Coverage, 48747,
     /* 2252045 */   GIR_EraseRootFromParent_Done,
     /* 2252046 */ // Label 30134: @2252046
     /* 2252046 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2252094), // Rule ID 48754 //
     /* 2252051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252064 */   // MIs[0] Operand 1
     /* 2252064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252073 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252077 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252082 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252084 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252093 */   // GIR_Coverage, 48754,
     /* 2252093 */   GIR_EraseRootFromParent_Done,
     /* 2252094 */ // Label 30135: @2252094
     /* 2252094 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2252142), // Rule ID 48755 //
     /* 2252099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252112 */   // MIs[0] Operand 1
     /* 2252112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252125 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252130 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252132 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252141 */   // GIR_Coverage, 48755,
     /* 2252141 */   GIR_EraseRootFromParent_Done,
     /* 2252142 */ // Label 30136: @2252142
     /* 2252142 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2252190), // Rule ID 48760 //
     /* 2252147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252160 */   // MIs[0] Operand 1
     /* 2252160 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252173 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252178 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252180 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252189 */   // GIR_Coverage, 48760,
     /* 2252189 */   GIR_EraseRootFromParent_Done,
     /* 2252190 */ // Label 30137: @2252190
     /* 2252190 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2252238), // Rule ID 48761 //
     /* 2252195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252208 */   // MIs[0] Operand 1
     /* 2252208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252221 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252226 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252228 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252237 */   // GIR_Coverage, 48761,
     /* 2252237 */   GIR_EraseRootFromParent_Done,
     /* 2252238 */ // Label 30138: @2252238
     /* 2252238 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2252286), // Rule ID 48768 //
     /* 2252243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252256 */   // MIs[0] Operand 1
     /* 2252256 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252269 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252276 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252285 */   // GIR_Coverage, 48768,
     /* 2252285 */   GIR_EraseRootFromParent_Done,
     /* 2252286 */ // Label 30139: @2252286
     /* 2252286 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2252334), // Rule ID 48769 //
     /* 2252291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252304 */   // MIs[0] Operand 1
     /* 2252304 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252317 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252333 */   // GIR_Coverage, 48769,
     /* 2252333 */   GIR_EraseRootFromParent_Done,
     /* 2252334 */ // Label 30140: @2252334
     /* 2252334 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2252382), // Rule ID 48790 //
     /* 2252339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252352 */   // MIs[0] Operand 1
     /* 2252352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252365 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252381 */   // GIR_Coverage, 48790,
     /* 2252381 */   GIR_EraseRootFromParent_Done,
     /* 2252382 */ // Label 30141: @2252382
     /* 2252382 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2252430), // Rule ID 48791 //
     /* 2252387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252400 */   // MIs[0] Operand 1
     /* 2252400 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252409 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252413 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252418 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252420 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252429 */   // GIR_Coverage, 48791,
     /* 2252429 */   GIR_EraseRootFromParent_Done,
     /* 2252430 */ // Label 30142: @2252430
     /* 2252430 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2252478), // Rule ID 48798 //
     /* 2252435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252448 */   // MIs[0] Operand 1
     /* 2252448 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252457 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252461 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252466 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252477 */   // GIR_Coverage, 48798,
     /* 2252477 */   GIR_EraseRootFromParent_Done,
     /* 2252478 */ // Label 30143: @2252478
     /* 2252478 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2252526), // Rule ID 48799 //
     /* 2252483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252496 */   // MIs[0] Operand 1
     /* 2252496 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252505 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252509 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2252512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252514 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252525 */   // GIR_Coverage, 48799,
     /* 2252525 */   GIR_EraseRootFromParent_Done,
     /* 2252526 */ // Label 30144: @2252526
     /* 2252526 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2252574), // Rule ID 48804 //
     /* 2252531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252544 */   // MIs[0] Operand 1
     /* 2252544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252557 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252562 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252573 */   // GIR_Coverage, 48804,
     /* 2252573 */   GIR_EraseRootFromParent_Done,
     /* 2252574 */ // Label 30145: @2252574
     /* 2252574 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2252622), // Rule ID 48805 //
     /* 2252579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252592 */   // MIs[0] Operand 1
     /* 2252592 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252601 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252605 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2252608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252610 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252621 */   // GIR_Coverage, 48805,
     /* 2252621 */   GIR_EraseRootFromParent_Done,
     /* 2252622 */ // Label 30146: @2252622
     /* 2252622 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2252670), // Rule ID 48812 //
     /* 2252627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252640 */   // MIs[0] Operand 1
     /* 2252640 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252649 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252653 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252658 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252669 */   // GIR_Coverage, 48812,
     /* 2252669 */   GIR_EraseRootFromParent_Done,
     /* 2252670 */ // Label 30147: @2252670
     /* 2252670 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2252718), // Rule ID 48813 //
     /* 2252675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252688 */   // MIs[0] Operand 1
     /* 2252688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252701 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2252704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252706 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252717 */   // GIR_Coverage, 48813,
     /* 2252717 */   GIR_EraseRootFromParent_Done,
     /* 2252718 */ // Label 30148: @2252718
     /* 2252718 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2252766), // Rule ID 48834 //
     /* 2252723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252729 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252736 */   // MIs[0] Operand 1
     /* 2252736 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252745 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252749 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252765 */   // GIR_Coverage, 48834,
     /* 2252765 */   GIR_EraseRootFromParent_Done,
     /* 2252766 */ // Label 30149: @2252766
     /* 2252766 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2252814), // Rule ID 48835 //
     /* 2252771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252784 */   // MIs[0] Operand 1
     /* 2252784 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252797 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252813 */   // GIR_Coverage, 48835,
     /* 2252813 */   GIR_EraseRootFromParent_Done,
     /* 2252814 */ // Label 30150: @2252814
     /* 2252814 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2252862), // Rule ID 48842 //
     /* 2252819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252832 */   // MIs[0] Operand 1
     /* 2252832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252841 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252845 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252850 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252861 */   // GIR_Coverage, 48842,
     /* 2252861 */   GIR_EraseRootFromParent_Done,
     /* 2252862 */ // Label 30151: @2252862
     /* 2252862 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2252910), // Rule ID 48843 //
     /* 2252867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252880 */   // MIs[0] Operand 1
     /* 2252880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252893 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252909 */   // GIR_Coverage, 48843,
     /* 2252909 */   GIR_EraseRootFromParent_Done,
     /* 2252910 */ // Label 30152: @2252910
     /* 2252910 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2252958), // Rule ID 48848 //
     /* 2252915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252928 */   // MIs[0] Operand 1
     /* 2252928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252941 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252957 */   // GIR_Coverage, 48848,
     /* 2252957 */   GIR_EraseRootFromParent_Done,
     /* 2252958 */ // Label 30153: @2252958
     /* 2252958 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2253006), // Rule ID 48849 //
     /* 2252963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252976 */   // MIs[0] Operand 1
     /* 2252976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252989 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253005 */   // GIR_Coverage, 48849,
     /* 2253005 */   GIR_EraseRootFromParent_Done,
     /* 2253006 */ // Label 30154: @2253006
     /* 2253006 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2253054), // Rule ID 48856 //
     /* 2253011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253024 */   // MIs[0] Operand 1
     /* 2253024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253037 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253053 */   // GIR_Coverage, 48856,
     /* 2253053 */   GIR_EraseRootFromParent_Done,
     /* 2253054 */ // Label 30155: @2253054
     /* 2253054 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2253102), // Rule ID 48857 //
     /* 2253059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253072 */   // MIs[0] Operand 1
     /* 2253072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253085 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253092 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253101 */   // GIR_Coverage, 48857,
     /* 2253101 */   GIR_EraseRootFromParent_Done,
     /* 2253102 */ // Label 30156: @2253102
     /* 2253102 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2253150), // Rule ID 48878 //
     /* 2253107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253120 */   // MIs[0] Operand 1
     /* 2253120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253133 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253138 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253140 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253149 */   // GIR_Coverage, 48878,
     /* 2253149 */   GIR_EraseRootFromParent_Done,
     /* 2253150 */ // Label 30157: @2253150
     /* 2253150 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2253198), // Rule ID 48879 //
     /* 2253155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253168 */   // MIs[0] Operand 1
     /* 2253168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253181 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253188 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253197 */   // GIR_Coverage, 48879,
     /* 2253197 */   GIR_EraseRootFromParent_Done,
     /* 2253198 */ // Label 30158: @2253198
     /* 2253198 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2253246), // Rule ID 48886 //
     /* 2253203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253216 */   // MIs[0] Operand 1
     /* 2253216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253229 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2253232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253245 */   // GIR_Coverage, 48886,
     /* 2253245 */   GIR_EraseRootFromParent_Done,
     /* 2253246 */ // Label 30159: @2253246
     /* 2253246 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2253294), // Rule ID 48887 //
     /* 2253251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2253257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2253260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253264 */   // MIs[0] Operand 1
     /* 2253264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253277 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2253280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253293 */   // GIR_Coverage, 48887,
     /* 2253293 */   GIR_EraseRootFromParent_Done,
     /* 2253294 */ // Label 30160: @2253294
     /* 2253294 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2253342), // Rule ID 48892 //
     /* 2253299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253312 */   // MIs[0] Operand 1
     /* 2253312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253325 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2253328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253341 */   // GIR_Coverage, 48892,
     /* 2253341 */   GIR_EraseRootFromParent_Done,
     /* 2253342 */ // Label 30161: @2253342
     /* 2253342 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2253390), // Rule ID 48893 //
     /* 2253347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2253353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2253356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253360 */   // MIs[0] Operand 1
     /* 2253360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253373 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2253376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253380 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253389 */   // GIR_Coverage, 48893,
     /* 2253389 */   GIR_EraseRootFromParent_Done,
     /* 2253390 */ // Label 30162: @2253390
     /* 2253390 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2253438), // Rule ID 48900 //
     /* 2253395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253408 */   // MIs[0] Operand 1
     /* 2253408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253421 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253437 */   // GIR_Coverage, 48900,
     /* 2253437 */   GIR_EraseRootFromParent_Done,
     /* 2253438 */ // Label 30163: @2253438
     /* 2253438 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2253486), // Rule ID 48901 //
     /* 2253443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2253449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2253452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253456 */   // MIs[0] Operand 1
     /* 2253456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253469 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2253472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253476 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253485 */   // GIR_Coverage, 48901,
     /* 2253485 */   GIR_EraseRootFromParent_Done,
     /* 2253486 */ // Label 30164: @2253486
     /* 2253486 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2253534), // Rule ID 48922 //
     /* 2253491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253504 */   // MIs[0] Operand 1
     /* 2253504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253517 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253524 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253533 */   // GIR_Coverage, 48922,
     /* 2253533 */   GIR_EraseRootFromParent_Done,
     /* 2253534 */ // Label 30165: @2253534
     /* 2253534 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2253582), // Rule ID 48923 //
     /* 2253539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2253545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2253548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253552 */   // MIs[0] Operand 1
     /* 2253552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253565 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253572 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253581 */   // GIR_Coverage, 48923,
     /* 2253581 */   GIR_EraseRootFromParent_Done,
     /* 2253582 */ // Label 30166: @2253582
     /* 2253582 */ GIM_Reject,
     /* 2253583 */ // Label 29903: @2253583
     /* 2253583 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2253631), // Rule ID 48494 //
     /* 2253588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253601 */   // MIs[0] Operand 1
     /* 2253601 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253610 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253614 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253619 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253621 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253630 */   // GIR_Coverage, 48494,
     /* 2253630 */   GIR_EraseRootFromParent_Done,
     /* 2253631 */ // Label 30167: @2253631
     /* 2253631 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2253679), // Rule ID 48495 //
     /* 2253636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253649 */   // MIs[0] Operand 1
     /* 2253649 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253658 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253662 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2253665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253667 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253669 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253678 */   // GIR_Coverage, 48495,
     /* 2253678 */   GIR_EraseRootFromParent_Done,
     /* 2253679 */ // Label 30168: @2253679
     /* 2253679 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2253727), // Rule ID 48504 //
     /* 2253684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253697 */   // MIs[0] Operand 1
     /* 2253697 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253706 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253710 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253715 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253717 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253726 */   // GIR_Coverage, 48504,
     /* 2253726 */   GIR_EraseRootFromParent_Done,
     /* 2253727 */ // Label 30169: @2253727
     /* 2253727 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2253775), // Rule ID 48505 //
     /* 2253732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253745 */   // MIs[0] Operand 1
     /* 2253745 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253758 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2253761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253763 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253765 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253774 */   // GIR_Coverage, 48505,
     /* 2253774 */   GIR_EraseRootFromParent_Done,
     /* 2253775 */ // Label 30170: @2253775
     /* 2253775 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2253823), // Rule ID 48522 //
     /* 2253780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253793 */   // MIs[0] Operand 1
     /* 2253793 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253806 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253811 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253813 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253822 */   // GIR_Coverage, 48522,
     /* 2253822 */   GIR_EraseRootFromParent_Done,
     /* 2253823 */ // Label 30171: @2253823
     /* 2253823 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2253871), // Rule ID 48523 //
     /* 2253828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253841 */   // MIs[0] Operand 1
     /* 2253841 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253850 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253854 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2253857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253861 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253870 */   // GIR_Coverage, 48523,
     /* 2253870 */   GIR_EraseRootFromParent_Done,
     /* 2253871 */ // Label 30172: @2253871
     /* 2253871 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2253919), // Rule ID 48530 //
     /* 2253876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253889 */   // MIs[0] Operand 1
     /* 2253889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253902 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253918 */   // GIR_Coverage, 48530,
     /* 2253918 */   GIR_EraseRootFromParent_Done,
     /* 2253919 */ // Label 30173: @2253919
     /* 2253919 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2253967), // Rule ID 48531 //
     /* 2253924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253937 */   // MIs[0] Operand 1
     /* 2253937 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253946 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253950 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253955 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253966 */   // GIR_Coverage, 48531,
     /* 2253966 */   GIR_EraseRootFromParent_Done,
     /* 2253967 */ // Label 30174: @2253967
     /* 2253967 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2254015), // Rule ID 48538 //
     /* 2253972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253985 */   // MIs[0] Operand 1
     /* 2253985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253998 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2254001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254014 */   // GIR_Coverage, 48538,
     /* 2254014 */   GIR_EraseRootFromParent_Done,
     /* 2254015 */ // Label 30175: @2254015
     /* 2254015 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2254063), // Rule ID 48539 //
     /* 2254020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254033 */   // MIs[0] Operand 1
     /* 2254033 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254042 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254046 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2254049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254062 */   // GIR_Coverage, 48539,
     /* 2254062 */   GIR_EraseRootFromParent_Done,
     /* 2254063 */ // Label 30176: @2254063
     /* 2254063 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2254111), // Rule ID 48548 //
     /* 2254068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254081 */   // MIs[0] Operand 1
     /* 2254081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254090 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254094 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2254097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254110 */   // GIR_Coverage, 48548,
     /* 2254110 */   GIR_EraseRootFromParent_Done,
     /* 2254111 */ // Label 30177: @2254111
     /* 2254111 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2254159), // Rule ID 48549 //
     /* 2254116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254129 */   // MIs[0] Operand 1
     /* 2254129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254142 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2254145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254158 */   // GIR_Coverage, 48549,
     /* 2254158 */   GIR_EraseRootFromParent_Done,
     /* 2254159 */ // Label 30178: @2254159
     /* 2254159 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2254207), // Rule ID 48566 //
     /* 2254164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254177 */   // MIs[0] Operand 1
     /* 2254177 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254190 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2254193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254197 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254206 */   // GIR_Coverage, 48566,
     /* 2254206 */   GIR_EraseRootFromParent_Done,
     /* 2254207 */ // Label 30179: @2254207
     /* 2254207 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2254255), // Rule ID 48567 //
     /* 2254212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254225 */   // MIs[0] Operand 1
     /* 2254225 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254234 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254238 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2254241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254245 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254254 */   // GIR_Coverage, 48567,
     /* 2254254 */   GIR_EraseRootFromParent_Done,
     /* 2254255 */ // Label 30180: @2254255
     /* 2254255 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2254303), // Rule ID 48574 //
     /* 2254260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254266 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254273 */   // MIs[0] Operand 1
     /* 2254273 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254282 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254286 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2254289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254291 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254293 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254302 */   // GIR_Coverage, 48574,
     /* 2254302 */   GIR_EraseRootFromParent_Done,
     /* 2254303 */ // Label 30181: @2254303
     /* 2254303 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2254351), // Rule ID 48575 //
     /* 2254308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254321 */   // MIs[0] Operand 1
     /* 2254321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2254326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254334 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2254337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254350 */   // GIR_Coverage, 48575,
     /* 2254350 */   GIR_EraseRootFromParent_Done,
     /* 2254351 */ // Label 30182: @2254351
     /* 2254351 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2254399), // Rule ID 48582 //
     /* 2254356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254369 */   // MIs[0] Operand 1
     /* 2254369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254382 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254398 */   // GIR_Coverage, 48582,
     /* 2254398 */   GIR_EraseRootFromParent_Done,
     /* 2254399 */ // Label 30183: @2254399
     /* 2254399 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2254447), // Rule ID 48583 //
     /* 2254404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254417 */   // MIs[0] Operand 1
     /* 2254417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254430 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254446 */   // GIR_Coverage, 48583,
     /* 2254446 */   GIR_EraseRootFromParent_Done,
     /* 2254447 */ // Label 30184: @2254447
     /* 2254447 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2254495), // Rule ID 48592 //
     /* 2254452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254465 */   // MIs[0] Operand 1
     /* 2254465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254478 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254483 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254494 */   // GIR_Coverage, 48592,
     /* 2254494 */   GIR_EraseRootFromParent_Done,
     /* 2254495 */ // Label 30185: @2254495
     /* 2254495 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2254543), // Rule ID 48593 //
     /* 2254500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254513 */   // MIs[0] Operand 1
     /* 2254513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254526 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254531 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254533 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254542 */   // GIR_Coverage, 48593,
     /* 2254542 */   GIR_EraseRootFromParent_Done,
     /* 2254543 */ // Label 30186: @2254543
     /* 2254543 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2254591), // Rule ID 48610 //
     /* 2254548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254561 */   // MIs[0] Operand 1
     /* 2254561 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254574 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254579 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254581 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254590 */   // GIR_Coverage, 48610,
     /* 2254590 */   GIR_EraseRootFromParent_Done,
     /* 2254591 */ // Label 30187: @2254591
     /* 2254591 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2254639), // Rule ID 48611 //
     /* 2254596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254609 */   // MIs[0] Operand 1
     /* 2254609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254622 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254638 */   // GIR_Coverage, 48611,
     /* 2254638 */   GIR_EraseRootFromParent_Done,
     /* 2254639 */ // Label 30188: @2254639
     /* 2254639 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2254687), // Rule ID 48618 //
     /* 2254644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254657 */   // MIs[0] Operand 1
     /* 2254657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254670 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254686 */   // GIR_Coverage, 48618,
     /* 2254686 */   GIR_EraseRootFromParent_Done,
     /* 2254687 */ // Label 30189: @2254687
     /* 2254687 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2254735), // Rule ID 48619 //
     /* 2254692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254705 */   // MIs[0] Operand 1
     /* 2254705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254718 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254734 */   // GIR_Coverage, 48619,
     /* 2254734 */   GIR_EraseRootFromParent_Done,
     /* 2254735 */ // Label 30190: @2254735
     /* 2254735 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2254783), // Rule ID 48624 //
     /* 2254740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254753 */   // MIs[0] Operand 1
     /* 2254753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254766 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254773 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254782 */   // GIR_Coverage, 48624,
     /* 2254782 */   GIR_EraseRootFromParent_Done,
     /* 2254783 */ // Label 30191: @2254783
     /* 2254783 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2254831), // Rule ID 48625 //
     /* 2254788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254801 */   // MIs[0] Operand 1
     /* 2254801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254814 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2254817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254821 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254830 */   // GIR_Coverage, 48625,
     /* 2254830 */   GIR_EraseRootFromParent_Done,
     /* 2254831 */ // Label 30192: @2254831
     /* 2254831 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2254879), // Rule ID 48634 //
     /* 2254836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254849 */   // MIs[0] Operand 1
     /* 2254849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254862 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254869 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254878 */   // GIR_Coverage, 48634,
     /* 2254878 */   GIR_EraseRootFromParent_Done,
     /* 2254879 */ // Label 30193: @2254879
     /* 2254879 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2254927), // Rule ID 48635 //
     /* 2254884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254897 */   // MIs[0] Operand 1
     /* 2254897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254910 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254917 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254926 */   // GIR_Coverage, 48635,
     /* 2254926 */   GIR_EraseRootFromParent_Done,
     /* 2254927 */ // Label 30194: @2254927
     /* 2254927 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2254975), // Rule ID 48652 //
     /* 2254932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254945 */   // MIs[0] Operand 1
     /* 2254945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254958 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254965 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254974 */   // GIR_Coverage, 48652,
     /* 2254974 */   GIR_EraseRootFromParent_Done,
     /* 2254975 */ // Label 30195: @2254975
     /* 2254975 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2255023), // Rule ID 48653 //
     /* 2254980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254993 */   // MIs[0] Operand 1
     /* 2254993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255006 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2255009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255013 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255022 */   // GIR_Coverage, 48653,
     /* 2255022 */   GIR_EraseRootFromParent_Done,
     /* 2255023 */ // Label 30196: @2255023
     /* 2255023 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2255071), // Rule ID 48660 //
     /* 2255028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255041 */   // MIs[0] Operand 1
     /* 2255041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255054 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2255057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255061 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255070 */   // GIR_Coverage, 48660,
     /* 2255070 */   GIR_EraseRootFromParent_Done,
     /* 2255071 */ // Label 30197: @2255071
     /* 2255071 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2255119), // Rule ID 48661 //
     /* 2255076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255089 */   // MIs[0] Operand 1
     /* 2255089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255102 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2255105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255109 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255118 */   // GIR_Coverage, 48661,
     /* 2255118 */   GIR_EraseRootFromParent_Done,
     /* 2255119 */ // Label 30198: @2255119
     /* 2255119 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2255167), // Rule ID 48668 //
     /* 2255124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255137 */   // MIs[0] Operand 1
     /* 2255137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255150 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255166 */   // GIR_Coverage, 48668,
     /* 2255166 */   GIR_EraseRootFromParent_Done,
     /* 2255167 */ // Label 30199: @2255167
     /* 2255167 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2255215), // Rule ID 48669 //
     /* 2255172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255185 */   // MIs[0] Operand 1
     /* 2255185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255198 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255214 */   // GIR_Coverage, 48669,
     /* 2255214 */   GIR_EraseRootFromParent_Done,
     /* 2255215 */ // Label 30200: @2255215
     /* 2255215 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2255263), // Rule ID 48678 //
     /* 2255220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255233 */   // MIs[0] Operand 1
     /* 2255233 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255246 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255262 */   // GIR_Coverage, 48678,
     /* 2255262 */   GIR_EraseRootFromParent_Done,
     /* 2255263 */ // Label 30201: @2255263
     /* 2255263 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2255311), // Rule ID 48679 //
     /* 2255268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255281 */   // MIs[0] Operand 1
     /* 2255281 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255290 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255294 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255301 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255310 */   // GIR_Coverage, 48679,
     /* 2255310 */   GIR_EraseRootFromParent_Done,
     /* 2255311 */ // Label 30202: @2255311
     /* 2255311 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2255359), // Rule ID 48696 //
     /* 2255316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255329 */   // MIs[0] Operand 1
     /* 2255329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255342 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255349 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255358 */   // GIR_Coverage, 48696,
     /* 2255358 */   GIR_EraseRootFromParent_Done,
     /* 2255359 */ // Label 30203: @2255359
     /* 2255359 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2255407), // Rule ID 48697 //
     /* 2255364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255377 */   // MIs[0] Operand 1
     /* 2255377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255386 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255390 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255397 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255406 */   // GIR_Coverage, 48697,
     /* 2255406 */   GIR_EraseRootFromParent_Done,
     /* 2255407 */ // Label 30204: @2255407
     /* 2255407 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2255455), // Rule ID 48704 //
     /* 2255412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255425 */   // MIs[0] Operand 1
     /* 2255425 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255438 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255445 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255454 */   // GIR_Coverage, 48704,
     /* 2255454 */   GIR_EraseRootFromParent_Done,
     /* 2255455 */ // Label 30205: @2255455
     /* 2255455 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2255503), // Rule ID 48705 //
     /* 2255460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255473 */   // MIs[0] Operand 1
     /* 2255473 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255486 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255502 */   // GIR_Coverage, 48705,
     /* 2255502 */   GIR_EraseRootFromParent_Done,
     /* 2255503 */ // Label 30206: @2255503
     /* 2255503 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2255551), // Rule ID 48712 //
     /* 2255508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255521 */   // MIs[0] Operand 1
     /* 2255521 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255534 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255539 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255541 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255550 */   // GIR_Coverage, 48712,
     /* 2255550 */   GIR_EraseRootFromParent_Done,
     /* 2255551 */ // Label 30207: @2255551
     /* 2255551 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2255599), // Rule ID 48713 //
     /* 2255556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255569 */   // MIs[0] Operand 1
     /* 2255569 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255578 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255582 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2255585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255589 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255597 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255598 */   // GIR_Coverage, 48713,
     /* 2255598 */   GIR_EraseRootFromParent_Done,
     /* 2255599 */ // Label 30208: @2255599
     /* 2255599 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2255647), // Rule ID 48722 //
     /* 2255604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255617 */   // MIs[0] Operand 1
     /* 2255617 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255626 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255630 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255637 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255646 */   // GIR_Coverage, 48722,
     /* 2255646 */   GIR_EraseRootFromParent_Done,
     /* 2255647 */ // Label 30209: @2255647
     /* 2255647 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2255695), // Rule ID 48723 //
     /* 2255652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255665 */   // MIs[0] Operand 1
     /* 2255665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255674 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255678 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2255681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255685 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255694 */   // GIR_Coverage, 48723,
     /* 2255694 */   GIR_EraseRootFromParent_Done,
     /* 2255695 */ // Label 30210: @2255695
     /* 2255695 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2255743), // Rule ID 48740 //
     /* 2255700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255706 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255713 */   // MIs[0] Operand 1
     /* 2255713 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255722 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255726 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255733 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255742 */   // GIR_Coverage, 48740,
     /* 2255742 */   GIR_EraseRootFromParent_Done,
     /* 2255743 */ // Label 30211: @2255743
     /* 2255743 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2255791), // Rule ID 48741 //
     /* 2255748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255761 */   // MIs[0] Operand 1
     /* 2255761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255774 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2255777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255790 */   // GIR_Coverage, 48741,
     /* 2255790 */   GIR_EraseRootFromParent_Done,
     /* 2255791 */ // Label 30212: @2255791
     /* 2255791 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2255839), // Rule ID 48748 //
     /* 2255796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255809 */   // MIs[0] Operand 1
     /* 2255809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255822 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255829 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255838 */   // GIR_Coverage, 48748,
     /* 2255838 */   GIR_EraseRootFromParent_Done,
     /* 2255839 */ // Label 30213: @2255839
     /* 2255839 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2255887), // Rule ID 48749 //
     /* 2255844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255857 */   // MIs[0] Operand 1
     /* 2255857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255870 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2255873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255886 */   // GIR_Coverage, 48749,
     /* 2255886 */   GIR_EraseRootFromParent_Done,
     /* 2255887 */ // Label 30214: @2255887
     /* 2255887 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2255935), // Rule ID 48756 //
     /* 2255892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255905 */   // MIs[0] Operand 1
     /* 2255905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255918 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255923 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255925 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255934 */   // GIR_Coverage, 48756,
     /* 2255934 */   GIR_EraseRootFromParent_Done,
     /* 2255935 */ // Label 30215: @2255935
     /* 2255935 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2255983), // Rule ID 48757 //
     /* 2255940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255953 */   // MIs[0] Operand 1
     /* 2255953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255966 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255971 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255973 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255982 */   // GIR_Coverage, 48757,
     /* 2255982 */   GIR_EraseRootFromParent_Done,
     /* 2255983 */ // Label 30216: @2255983
     /* 2255983 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2256031), // Rule ID 48766 //
     /* 2255988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256001 */   // MIs[0] Operand 1
     /* 2256001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256014 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256021 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256030 */   // GIR_Coverage, 48766,
     /* 2256030 */   GIR_EraseRootFromParent_Done,
     /* 2256031 */ // Label 30217: @2256031
     /* 2256031 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2256079), // Rule ID 48767 //
     /* 2256036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256049 */   // MIs[0] Operand 1
     /* 2256049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256062 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256078 */   // GIR_Coverage, 48767,
     /* 2256078 */   GIR_EraseRootFromParent_Done,
     /* 2256079 */ // Label 30218: @2256079
     /* 2256079 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2256127), // Rule ID 48784 //
     /* 2256084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256097 */   // MIs[0] Operand 1
     /* 2256097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256110 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256126 */   // GIR_Coverage, 48784,
     /* 2256126 */   GIR_EraseRootFromParent_Done,
     /* 2256127 */ // Label 30219: @2256127
     /* 2256127 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2256175), // Rule ID 48785 //
     /* 2256132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256145 */   // MIs[0] Operand 1
     /* 2256145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256158 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256174 */   // GIR_Coverage, 48785,
     /* 2256174 */   GIR_EraseRootFromParent_Done,
     /* 2256175 */ // Label 30220: @2256175
     /* 2256175 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2256223), // Rule ID 48792 //
     /* 2256180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256193 */   // MIs[0] Operand 1
     /* 2256193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256206 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256222 */   // GIR_Coverage, 48792,
     /* 2256222 */   GIR_EraseRootFromParent_Done,
     /* 2256223 */ // Label 30221: @2256223
     /* 2256223 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2256271), // Rule ID 48793 //
     /* 2256228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256241 */   // MIs[0] Operand 1
     /* 2256241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256254 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256270 */   // GIR_Coverage, 48793,
     /* 2256270 */   GIR_EraseRootFromParent_Done,
     /* 2256271 */ // Label 30222: @2256271
     /* 2256271 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2256319), // Rule ID 48800 //
     /* 2256276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256289 */   // MIs[0] Operand 1
     /* 2256289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256302 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2256305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256307 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256318 */   // GIR_Coverage, 48800,
     /* 2256318 */   GIR_EraseRootFromParent_Done,
     /* 2256319 */ // Label 30223: @2256319
     /* 2256319 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2256367), // Rule ID 48801 //
     /* 2256324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256337 */   // MIs[0] Operand 1
     /* 2256337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256350 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2256353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256355 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256357 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256366 */   // GIR_Coverage, 48801,
     /* 2256366 */   GIR_EraseRootFromParent_Done,
     /* 2256367 */ // Label 30224: @2256367
     /* 2256367 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2256415), // Rule ID 48810 //
     /* 2256372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256385 */   // MIs[0] Operand 1
     /* 2256385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256398 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256405 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256414 */   // GIR_Coverage, 48810,
     /* 2256414 */   GIR_EraseRootFromParent_Done,
     /* 2256415 */ // Label 30225: @2256415
     /* 2256415 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2256463), // Rule ID 48811 //
     /* 2256420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256433 */   // MIs[0] Operand 1
     /* 2256433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256446 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2256449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256451 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256453 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256462 */   // GIR_Coverage, 48811,
     /* 2256462 */   GIR_EraseRootFromParent_Done,
     /* 2256463 */ // Label 30226: @2256463
     /* 2256463 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2256511), // Rule ID 48828 //
     /* 2256468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256481 */   // MIs[0] Operand 1
     /* 2256481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256494 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256499 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256510 */   // GIR_Coverage, 48828,
     /* 2256510 */   GIR_EraseRootFromParent_Done,
     /* 2256511 */ // Label 30227: @2256511
     /* 2256511 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2256559), // Rule ID 48829 //
     /* 2256516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256529 */   // MIs[0] Operand 1
     /* 2256529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256542 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2256545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256547 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256558 */   // GIR_Coverage, 48829,
     /* 2256558 */   GIR_EraseRootFromParent_Done,
     /* 2256559 */ // Label 30228: @2256559
     /* 2256559 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2256607), // Rule ID 48836 //
     /* 2256564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256577 */   // MIs[0] Operand 1
     /* 2256577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256590 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256606 */   // GIR_Coverage, 48836,
     /* 2256606 */   GIR_EraseRootFromParent_Done,
     /* 2256607 */ // Label 30229: @2256607
     /* 2256607 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2256655), // Rule ID 48837 //
     /* 2256612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256625 */   // MIs[0] Operand 1
     /* 2256625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256638 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2256641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256654 */   // GIR_Coverage, 48837,
     /* 2256654 */   GIR_EraseRootFromParent_Done,
     /* 2256655 */ // Label 30230: @2256655
     /* 2256655 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2256703), // Rule ID 48844 //
     /* 2256660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256673 */   // MIs[0] Operand 1
     /* 2256673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256686 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256691 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256702 */   // GIR_Coverage, 48844,
     /* 2256702 */   GIR_EraseRootFromParent_Done,
     /* 2256703 */ // Label 30231: @2256703
     /* 2256703 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2256751), // Rule ID 48845 //
     /* 2256708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256721 */   // MIs[0] Operand 1
     /* 2256721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256734 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256750 */   // GIR_Coverage, 48845,
     /* 2256750 */   GIR_EraseRootFromParent_Done,
     /* 2256751 */ // Label 30232: @2256751
     /* 2256751 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2256799), // Rule ID 48854 //
     /* 2256756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256769 */   // MIs[0] Operand 1
     /* 2256769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256782 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256798 */   // GIR_Coverage, 48854,
     /* 2256798 */   GIR_EraseRootFromParent_Done,
     /* 2256799 */ // Label 30233: @2256799
     /* 2256799 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2256847), // Rule ID 48855 //
     /* 2256804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256817 */   // MIs[0] Operand 1
     /* 2256817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256830 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256846 */   // GIR_Coverage, 48855,
     /* 2256846 */   GIR_EraseRootFromParent_Done,
     /* 2256847 */ // Label 30234: @2256847
     /* 2256847 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2256895), // Rule ID 48872 //
     /* 2256852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256865 */   // MIs[0] Operand 1
     /* 2256865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256878 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256894 */   // GIR_Coverage, 48872,
     /* 2256894 */   GIR_EraseRootFromParent_Done,
     /* 2256895 */ // Label 30235: @2256895
     /* 2256895 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2256943), // Rule ID 48873 //
     /* 2256900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256913 */   // MIs[0] Operand 1
     /* 2256913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256926 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256942 */   // GIR_Coverage, 48873,
     /* 2256942 */   GIR_EraseRootFromParent_Done,
     /* 2256943 */ // Label 30236: @2256943
     /* 2256943 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2256991), // Rule ID 48880 //
     /* 2256948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256961 */   // MIs[0] Operand 1
     /* 2256961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256974 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256990 */   // GIR_Coverage, 48880,
     /* 2256990 */   GIR_EraseRootFromParent_Done,
     /* 2256991 */ // Label 30237: @2256991
     /* 2256991 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2257039), // Rule ID 48881 //
     /* 2256996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257009 */   // MIs[0] Operand 1
     /* 2257009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2257014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257022 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257038 */   // GIR_Coverage, 48881,
     /* 2257038 */   GIR_EraseRootFromParent_Done,
     /* 2257039 */ // Label 30238: @2257039
     /* 2257039 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2257087), // Rule ID 48888 //
     /* 2257044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257057 */   // MIs[0] Operand 1
     /* 2257057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257070 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2257073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257075 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257086 */   // GIR_Coverage, 48888,
     /* 2257086 */   GIR_EraseRootFromParent_Done,
     /* 2257087 */ // Label 30239: @2257087
     /* 2257087 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2257135), // Rule ID 48889 //
     /* 2257092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2257098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2257101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257105 */   // MIs[0] Operand 1
     /* 2257105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257118 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2257121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257123 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257134 */   // GIR_Coverage, 48889,
     /* 2257134 */   GIR_EraseRootFromParent_Done,
     /* 2257135 */ // Label 30240: @2257135
     /* 2257135 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2257183), // Rule ID 48898 //
     /* 2257140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257153 */   // MIs[0] Operand 1
     /* 2257153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257166 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2257169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257182 */   // GIR_Coverage, 48898,
     /* 2257182 */   GIR_EraseRootFromParent_Done,
     /* 2257183 */ // Label 30241: @2257183
     /* 2257183 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2257231), // Rule ID 48899 //
     /* 2257188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2257194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2257197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257201 */   // MIs[0] Operand 1
     /* 2257201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257214 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2257217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257230 */   // GIR_Coverage, 48899,
     /* 2257230 */   GIR_EraseRootFromParent_Done,
     /* 2257231 */ // Label 30242: @2257231
     /* 2257231 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2257279), // Rule ID 48916 //
     /* 2257236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257249 */   // MIs[0] Operand 1
     /* 2257249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257262 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2257265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257278 */   // GIR_Coverage, 48916,
     /* 2257278 */   GIR_EraseRootFromParent_Done,
     /* 2257279 */ // Label 30243: @2257279
     /* 2257279 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2257327), // Rule ID 48917 //
     /* 2257284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257297 */   // MIs[0] Operand 1
     /* 2257297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257310 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2257313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257317 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257326 */   // GIR_Coverage, 48917,
     /* 2257326 */   GIR_EraseRootFromParent_Done,
     /* 2257327 */ // Label 30244: @2257327
     /* 2257327 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2257375), // Rule ID 48924 //
     /* 2257332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257345 */   // MIs[0] Operand 1
     /* 2257345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257358 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257365 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257374 */   // GIR_Coverage, 48924,
     /* 2257374 */   GIR_EraseRootFromParent_Done,
     /* 2257375 */ // Label 30245: @2257375
     /* 2257375 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2257423), // Rule ID 48925 //
     /* 2257380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257393 */   // MIs[0] Operand 1
     /* 2257393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2257398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257406 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2257409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257422 */   // GIR_Coverage, 48925,
     /* 2257422 */   GIR_EraseRootFromParent_Done,
     /* 2257423 */ // Label 30246: @2257423
     /* 2257423 */ GIM_Reject,
     /* 2257424 */ // Label 29904: @2257424
     /* 2257424 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2257472), // Rule ID 48502 //
     /* 2257429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257442 */   // MIs[0] Operand 1
     /* 2257442 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257451 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257455 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257460 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257462 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257471 */   // GIR_Coverage, 48502,
     /* 2257471 */   GIR_EraseRootFromParent_Done,
     /* 2257472 */ // Label 30247: @2257472
     /* 2257472 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2257520), // Rule ID 48503 //
     /* 2257477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257490 */   // MIs[0] Operand 1
     /* 2257490 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257503 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2257506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257508 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257510 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257519 */   // GIR_Coverage, 48503,
     /* 2257519 */   GIR_EraseRootFromParent_Done,
     /* 2257520 */ // Label 30248: @2257520
     /* 2257520 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2257568), // Rule ID 48516 //
     /* 2257525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257538 */   // MIs[0] Operand 1
     /* 2257538 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257551 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257556 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257558 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257567 */   // GIR_Coverage, 48516,
     /* 2257567 */   GIR_EraseRootFromParent_Done,
     /* 2257568 */ // Label 30249: @2257568
     /* 2257568 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2257616), // Rule ID 48517 //
     /* 2257573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257586 */   // MIs[0] Operand 1
     /* 2257586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257599 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2257602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257604 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257606 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257615 */   // GIR_Coverage, 48517,
     /* 2257615 */   GIR_EraseRootFromParent_Done,
     /* 2257616 */ // Label 30250: @2257616
     /* 2257616 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2257664), // Rule ID 48524 //
     /* 2257621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257634 */   // MIs[0] Operand 1
     /* 2257634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257647 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257652 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257654 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257663 */   // GIR_Coverage, 48524,
     /* 2257663 */   GIR_EraseRootFromParent_Done,
     /* 2257664 */ // Label 30251: @2257664
     /* 2257664 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2257712), // Rule ID 48525 //
     /* 2257669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257682 */   // MIs[0] Operand 1
     /* 2257682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257691 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257695 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2257698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257702 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257711 */   // GIR_Coverage, 48525,
     /* 2257711 */   GIR_EraseRootFromParent_Done,
     /* 2257712 */ // Label 30252: @2257712
     /* 2257712 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2257760), // Rule ID 48532 //
     /* 2257717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257730 */   // MIs[0] Operand 1
     /* 2257730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257743 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257759 */   // GIR_Coverage, 48532,
     /* 2257759 */   GIR_EraseRootFromParent_Done,
     /* 2257760 */ // Label 30253: @2257760
     /* 2257760 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2257808), // Rule ID 48533 //
     /* 2257765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257778 */   // MIs[0] Operand 1
     /* 2257778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2257783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257791 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2257794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257796 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257807 */   // GIR_Coverage, 48533,
     /* 2257807 */   GIR_EraseRootFromParent_Done,
     /* 2257808 */ // Label 30254: @2257808
     /* 2257808 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2257856), // Rule ID 48546 //
     /* 2257813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257826 */   // MIs[0] Operand 1
     /* 2257826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257839 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257855 */   // GIR_Coverage, 48546,
     /* 2257855 */   GIR_EraseRootFromParent_Done,
     /* 2257856 */ // Label 30255: @2257856
     /* 2257856 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2257904), // Rule ID 48547 //
     /* 2257861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257874 */   // MIs[0] Operand 1
     /* 2257874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257887 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257903 */   // GIR_Coverage, 48547,
     /* 2257903 */   GIR_EraseRootFromParent_Done,
     /* 2257904 */ // Label 30256: @2257904
     /* 2257904 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2257952), // Rule ID 48560 //
     /* 2257909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257922 */   // MIs[0] Operand 1
     /* 2257922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257935 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257951 */   // GIR_Coverage, 48560,
     /* 2257951 */   GIR_EraseRootFromParent_Done,
     /* 2257952 */ // Label 30257: @2257952
     /* 2257952 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2258000), // Rule ID 48561 //
     /* 2257957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257970 */   // MIs[0] Operand 1
     /* 2257970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257983 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257999 */   // GIR_Coverage, 48561,
     /* 2257999 */   GIR_EraseRootFromParent_Done,
     /* 2258000 */ // Label 30258: @2258000
     /* 2258000 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2258048), // Rule ID 48568 //
     /* 2258005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258018 */   // MIs[0] Operand 1
     /* 2258018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258031 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2258034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258038 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258047 */   // GIR_Coverage, 48568,
     /* 2258047 */   GIR_EraseRootFromParent_Done,
     /* 2258048 */ // Label 30259: @2258048
     /* 2258048 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2258096), // Rule ID 48569 //
     /* 2258053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258066 */   // MIs[0] Operand 1
     /* 2258066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258079 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2258082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258095 */   // GIR_Coverage, 48569,
     /* 2258095 */   GIR_EraseRootFromParent_Done,
     /* 2258096 */ // Label 30260: @2258096
     /* 2258096 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2258144), // Rule ID 48576 //
     /* 2258101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258114 */   // MIs[0] Operand 1
     /* 2258114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258127 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2258130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258143 */   // GIR_Coverage, 48576,
     /* 2258143 */   GIR_EraseRootFromParent_Done,
     /* 2258144 */ // Label 30261: @2258144
     /* 2258144 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2258192), // Rule ID 48577 //
     /* 2258149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258162 */   // MIs[0] Operand 1
     /* 2258162 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2258167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258171 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258175 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2258178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258180 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258182 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258191 */   // GIR_Coverage, 48577,
     /* 2258191 */   GIR_EraseRootFromParent_Done,
     /* 2258192 */ // Label 30262: @2258192
     /* 2258192 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2258240), // Rule ID 48590 //
     /* 2258197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258210 */   // MIs[0] Operand 1
     /* 2258210 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258219 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258223 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258228 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258230 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258239 */   // GIR_Coverage, 48590,
     /* 2258239 */   GIR_EraseRootFromParent_Done,
     /* 2258240 */ // Label 30263: @2258240
     /* 2258240 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2258288), // Rule ID 48591 //
     /* 2258245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258258 */   // MIs[0] Operand 1
     /* 2258258 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258271 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258276 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258278 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258287 */   // GIR_Coverage, 48591,
     /* 2258287 */   GIR_EraseRootFromParent_Done,
     /* 2258288 */ // Label 30264: @2258288
     /* 2258288 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2258336), // Rule ID 48604 //
     /* 2258293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258306 */   // MIs[0] Operand 1
     /* 2258306 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258319 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258324 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258326 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258335 */   // GIR_Coverage, 48604,
     /* 2258335 */   GIR_EraseRootFromParent_Done,
     /* 2258336 */ // Label 30265: @2258336
     /* 2258336 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2258384), // Rule ID 48605 //
     /* 2258341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258354 */   // MIs[0] Operand 1
     /* 2258354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258367 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258372 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258374 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258383 */   // GIR_Coverage, 48605,
     /* 2258383 */   GIR_EraseRootFromParent_Done,
     /* 2258384 */ // Label 30266: @2258384
     /* 2258384 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2258432), // Rule ID 48612 //
     /* 2258389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258402 */   // MIs[0] Operand 1
     /* 2258402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258415 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258431 */   // GIR_Coverage, 48612,
     /* 2258431 */   GIR_EraseRootFromParent_Done,
     /* 2258432 */ // Label 30267: @2258432
     /* 2258432 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2258480), // Rule ID 48613 //
     /* 2258437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258450 */   // MIs[0] Operand 1
     /* 2258450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258463 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258479 */   // GIR_Coverage, 48613,
     /* 2258479 */   GIR_EraseRootFromParent_Done,
     /* 2258480 */ // Label 30268: @2258480
     /* 2258480 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2258528), // Rule ID 48620 //
     /* 2258485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258498 */   // MIs[0] Operand 1
     /* 2258498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258511 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258527 */   // GIR_Coverage, 48620,
     /* 2258527 */   GIR_EraseRootFromParent_Done,
     /* 2258528 */ // Label 30269: @2258528
     /* 2258528 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2258576), // Rule ID 48621 //
     /* 2258533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258546 */   // MIs[0] Operand 1
     /* 2258546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2258551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258559 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258575 */   // GIR_Coverage, 48621,
     /* 2258575 */   GIR_EraseRootFromParent_Done,
     /* 2258576 */ // Label 30270: @2258576
     /* 2258576 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2258624), // Rule ID 48632 //
     /* 2258581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258594 */   // MIs[0] Operand 1
     /* 2258594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258607 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258612 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258614 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258623 */   // GIR_Coverage, 48632,
     /* 2258623 */   GIR_EraseRootFromParent_Done,
     /* 2258624 */ // Label 30271: @2258624
     /* 2258624 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2258672), // Rule ID 48633 //
     /* 2258629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258642 */   // MIs[0] Operand 1
     /* 2258642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258655 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2258658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258660 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258662 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258671 */   // GIR_Coverage, 48633,
     /* 2258671 */   GIR_EraseRootFromParent_Done,
     /* 2258672 */ // Label 30272: @2258672
     /* 2258672 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2258720), // Rule ID 48646 //
     /* 2258677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258690 */   // MIs[0] Operand 1
     /* 2258690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258703 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258710 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258719 */   // GIR_Coverage, 48646,
     /* 2258719 */   GIR_EraseRootFromParent_Done,
     /* 2258720 */ // Label 30273: @2258720
     /* 2258720 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2258768), // Rule ID 48647 //
     /* 2258725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258738 */   // MIs[0] Operand 1
     /* 2258738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258751 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2258754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258756 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258758 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258767 */   // GIR_Coverage, 48647,
     /* 2258767 */   GIR_EraseRootFromParent_Done,
     /* 2258768 */ // Label 30274: @2258768
     /* 2258768 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2258816), // Rule ID 48654 //
     /* 2258773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258786 */   // MIs[0] Operand 1
     /* 2258786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258799 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258804 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258806 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258815 */   // GIR_Coverage, 48654,
     /* 2258815 */   GIR_EraseRootFromParent_Done,
     /* 2258816 */ // Label 30275: @2258816
     /* 2258816 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2258864), // Rule ID 48655 //
     /* 2258821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258834 */   // MIs[0] Operand 1
     /* 2258834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258847 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2258850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258854 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258863 */   // GIR_Coverage, 48655,
     /* 2258863 */   GIR_EraseRootFromParent_Done,
     /* 2258864 */ // Label 30276: @2258864
     /* 2258864 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2258912), // Rule ID 48662 //
     /* 2258869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258882 */   // MIs[0] Operand 1
     /* 2258882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258895 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258902 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258911 */   // GIR_Coverage, 48662,
     /* 2258911 */   GIR_EraseRootFromParent_Done,
     /* 2258912 */ // Label 30277: @2258912
     /* 2258912 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2258960), // Rule ID 48663 //
     /* 2258917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258930 */   // MIs[0] Operand 1
     /* 2258930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258943 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258950 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258959 */   // GIR_Coverage, 48663,
     /* 2258959 */   GIR_EraseRootFromParent_Done,
     /* 2258960 */ // Label 30278: @2258960
     /* 2258960 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2259008), // Rule ID 48676 //
     /* 2258965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258978 */   // MIs[0] Operand 1
     /* 2258978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258991 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259007 */   // GIR_Coverage, 48676,
     /* 2259007 */   GIR_EraseRootFromParent_Done,
     /* 2259008 */ // Label 30279: @2259008
     /* 2259008 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2259056), // Rule ID 48677 //
     /* 2259013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259026 */   // MIs[0] Operand 1
     /* 2259026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259039 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259055 */   // GIR_Coverage, 48677,
     /* 2259055 */   GIR_EraseRootFromParent_Done,
     /* 2259056 */ // Label 30280: @2259056
     /* 2259056 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2259104), // Rule ID 48690 //
     /* 2259061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259074 */   // MIs[0] Operand 1
     /* 2259074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259087 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259103 */   // GIR_Coverage, 48690,
     /* 2259103 */   GIR_EraseRootFromParent_Done,
     /* 2259104 */ // Label 30281: @2259104
     /* 2259104 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2259152), // Rule ID 48691 //
     /* 2259109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259122 */   // MIs[0] Operand 1
     /* 2259122 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259131 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259135 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259142 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259151 */   // GIR_Coverage, 48691,
     /* 2259151 */   GIR_EraseRootFromParent_Done,
     /* 2259152 */ // Label 30282: @2259152
     /* 2259152 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2259200), // Rule ID 48698 //
     /* 2259157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259170 */   // MIs[0] Operand 1
     /* 2259170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259183 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259190 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259199 */   // GIR_Coverage, 48698,
     /* 2259199 */   GIR_EraseRootFromParent_Done,
     /* 2259200 */ // Label 30283: @2259200
     /* 2259200 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2259248), // Rule ID 48699 //
     /* 2259205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259218 */   // MIs[0] Operand 1
     /* 2259218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259227 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259231 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259238 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259247 */   // GIR_Coverage, 48699,
     /* 2259247 */   GIR_EraseRootFromParent_Done,
     /* 2259248 */ // Label 30284: @2259248
     /* 2259248 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2259296), // Rule ID 48706 //
     /* 2259253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259266 */   // MIs[0] Operand 1
     /* 2259266 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259279 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259286 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259295 */   // GIR_Coverage, 48706,
     /* 2259295 */   GIR_EraseRootFromParent_Done,
     /* 2259296 */ // Label 30285: @2259296
     /* 2259296 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2259344), // Rule ID 48707 //
     /* 2259301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259314 */   // MIs[0] Operand 1
     /* 2259314 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2259319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259323 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259327 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259334 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259343 */   // GIR_Coverage, 48707,
     /* 2259343 */   GIR_EraseRootFromParent_Done,
     /* 2259344 */ // Label 30286: @2259344
     /* 2259344 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2259392), // Rule ID 48720 //
     /* 2259349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259362 */   // MIs[0] Operand 1
     /* 2259362 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259371 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259375 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259391 */   // GIR_Coverage, 48720,
     /* 2259391 */   GIR_EraseRootFromParent_Done,
     /* 2259392 */ // Label 30287: @2259392
     /* 2259392 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2259440), // Rule ID 48721 //
     /* 2259397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259410 */   // MIs[0] Operand 1
     /* 2259410 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259423 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2259426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259430 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259439 */   // GIR_Coverage, 48721,
     /* 2259439 */   GIR_EraseRootFromParent_Done,
     /* 2259440 */ // Label 30288: @2259440
     /* 2259440 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2259488), // Rule ID 48734 //
     /* 2259445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259458 */   // MIs[0] Operand 1
     /* 2259458 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259467 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259471 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259478 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259487 */   // GIR_Coverage, 48734,
     /* 2259487 */   GIR_EraseRootFromParent_Done,
     /* 2259488 */ // Label 30289: @2259488
     /* 2259488 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2259536), // Rule ID 48735 //
     /* 2259493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259506 */   // MIs[0] Operand 1
     /* 2259506 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259515 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259519 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2259522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259526 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259535 */   // GIR_Coverage, 48735,
     /* 2259535 */   GIR_EraseRootFromParent_Done,
     /* 2259536 */ // Label 30290: @2259536
     /* 2259536 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2259584), // Rule ID 48742 //
     /* 2259541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259554 */   // MIs[0] Operand 1
     /* 2259554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259563 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259567 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259574 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259583 */   // GIR_Coverage, 48742,
     /* 2259583 */   GIR_EraseRootFromParent_Done,
     /* 2259584 */ // Label 30291: @2259584
     /* 2259584 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2259632), // Rule ID 48743 //
     /* 2259589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259602 */   // MIs[0] Operand 1
     /* 2259602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259615 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2259618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259631 */   // GIR_Coverage, 48743,
     /* 2259631 */   GIR_EraseRootFromParent_Done,
     /* 2259632 */ // Label 30292: @2259632
     /* 2259632 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2259680), // Rule ID 48750 //
     /* 2259637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259650 */   // MIs[0] Operand 1
     /* 2259650 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259663 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259670 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259679 */   // GIR_Coverage, 48750,
     /* 2259679 */   GIR_EraseRootFromParent_Done,
     /* 2259680 */ // Label 30293: @2259680
     /* 2259680 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2259728), // Rule ID 48751 //
     /* 2259685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259698 */   // MIs[0] Operand 1
     /* 2259698 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2259703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259711 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2259714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259727 */   // GIR_Coverage, 48751,
     /* 2259727 */   GIR_EraseRootFromParent_Done,
     /* 2259728 */ // Label 30294: @2259728
     /* 2259728 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2259776), // Rule ID 48764 //
     /* 2259733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259746 */   // MIs[0] Operand 1
     /* 2259746 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259759 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259764 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259766 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259775 */   // GIR_Coverage, 48764,
     /* 2259775 */   GIR_EraseRootFromParent_Done,
     /* 2259776 */ // Label 30295: @2259776
     /* 2259776 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2259824), // Rule ID 48765 //
     /* 2259781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259794 */   // MIs[0] Operand 1
     /* 2259794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259807 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259812 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259814 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259823 */   // GIR_Coverage, 48765,
     /* 2259823 */   GIR_EraseRootFromParent_Done,
     /* 2259824 */ // Label 30296: @2259824
     /* 2259824 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2259872), // Rule ID 48778 //
     /* 2259829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259842 */   // MIs[0] Operand 1
     /* 2259842 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259855 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259862 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259871 */   // GIR_Coverage, 48778,
     /* 2259871 */   GIR_EraseRootFromParent_Done,
     /* 2259872 */ // Label 30297: @2259872
     /* 2259872 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2259920), // Rule ID 48779 //
     /* 2259877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259890 */   // MIs[0] Operand 1
     /* 2259890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259903 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259919 */   // GIR_Coverage, 48779,
     /* 2259919 */   GIR_EraseRootFromParent_Done,
     /* 2259920 */ // Label 30298: @2259920
     /* 2259920 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2259968), // Rule ID 48786 //
     /* 2259925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259938 */   // MIs[0] Operand 1
     /* 2259938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259951 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259958 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259967 */   // GIR_Coverage, 48786,
     /* 2259967 */   GIR_EraseRootFromParent_Done,
     /* 2259968 */ // Label 30299: @2259968
     /* 2259968 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2260016), // Rule ID 48787 //
     /* 2259973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259986 */   // MIs[0] Operand 1
     /* 2259986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259999 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260015 */   // GIR_Coverage, 48787,
     /* 2260015 */   GIR_EraseRootFromParent_Done,
     /* 2260016 */ // Label 30300: @2260016
     /* 2260016 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2260064), // Rule ID 48794 //
     /* 2260021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260034 */   // MIs[0] Operand 1
     /* 2260034 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2260039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260043 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260047 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260054 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260063 */   // GIR_Coverage, 48794,
     /* 2260063 */   GIR_EraseRootFromParent_Done,
     /* 2260064 */ // Label 30301: @2260064
     /* 2260064 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2260112), // Rule ID 48795 //
     /* 2260069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260082 */   // MIs[0] Operand 1
     /* 2260082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2260087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260095 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260102 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260111 */   // GIR_Coverage, 48795,
     /* 2260111 */   GIR_EraseRootFromParent_Done,
     /* 2260112 */ // Label 30302: @2260112
     /* 2260112 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2260160), // Rule ID 48808 //
     /* 2260117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260130 */   // MIs[0] Operand 1
     /* 2260130 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260143 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2260146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260159 */   // GIR_Coverage, 48808,
     /* 2260159 */   GIR_EraseRootFromParent_Done,
     /* 2260160 */ // Label 30303: @2260160
     /* 2260160 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2260208), // Rule ID 48809 //
     /* 2260165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260178 */   // MIs[0] Operand 1
     /* 2260178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260191 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2260194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260196 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260198 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260207 */   // GIR_Coverage, 48809,
     /* 2260207 */   GIR_EraseRootFromParent_Done,
     /* 2260208 */ // Label 30304: @2260208
     /* 2260208 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2260256), // Rule ID 48822 //
     /* 2260213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260226 */   // MIs[0] Operand 1
     /* 2260226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260239 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2260242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260246 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260255 */   // GIR_Coverage, 48822,
     /* 2260255 */   GIR_EraseRootFromParent_Done,
     /* 2260256 */ // Label 30305: @2260256
     /* 2260256 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2260304), // Rule ID 48823 //
     /* 2260261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260274 */   // MIs[0] Operand 1
     /* 2260274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260287 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2260290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260303 */   // GIR_Coverage, 48823,
     /* 2260303 */   GIR_EraseRootFromParent_Done,
     /* 2260304 */ // Label 30306: @2260304
     /* 2260304 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2260352), // Rule ID 48830 //
     /* 2260309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260322 */   // MIs[0] Operand 1
     /* 2260322 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260331 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260335 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260351 */   // GIR_Coverage, 48830,
     /* 2260351 */   GIR_EraseRootFromParent_Done,
     /* 2260352 */ // Label 30307: @2260352
     /* 2260352 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2260400), // Rule ID 48831 //
     /* 2260357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260370 */   // MIs[0] Operand 1
     /* 2260370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260379 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260383 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2260386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260399 */   // GIR_Coverage, 48831,
     /* 2260399 */   GIR_EraseRootFromParent_Done,
     /* 2260400 */ // Label 30308: @2260400
     /* 2260400 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2260448), // Rule ID 48838 //
     /* 2260405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260418 */   // MIs[0] Operand 1
     /* 2260418 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260431 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260447 */   // GIR_Coverage, 48838,
     /* 2260447 */   GIR_EraseRootFromParent_Done,
     /* 2260448 */ // Label 30309: @2260448
     /* 2260448 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2260496), // Rule ID 48839 //
     /* 2260453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260466 */   // MIs[0] Operand 1
     /* 2260466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2260471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260475 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260479 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2260482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260495 */   // GIR_Coverage, 48839,
     /* 2260495 */   GIR_EraseRootFromParent_Done,
     /* 2260496 */ // Label 30310: @2260496
     /* 2260496 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2260544), // Rule ID 48852 //
     /* 2260501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260514 */   // MIs[0] Operand 1
     /* 2260514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260527 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260532 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260534 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260543 */   // GIR_Coverage, 48852,
     /* 2260543 */   GIR_EraseRootFromParent_Done,
     /* 2260544 */ // Label 30311: @2260544
     /* 2260544 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2260592), // Rule ID 48853 //
     /* 2260549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260562 */   // MIs[0] Operand 1
     /* 2260562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260575 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260582 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260591 */   // GIR_Coverage, 48853,
     /* 2260591 */   GIR_EraseRootFromParent_Done,
     /* 2260592 */ // Label 30312: @2260592
     /* 2260592 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2260640), // Rule ID 48866 //
     /* 2260597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260610 */   // MIs[0] Operand 1
     /* 2260610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260623 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260639 */   // GIR_Coverage, 48866,
     /* 2260639 */   GIR_EraseRootFromParent_Done,
     /* 2260640 */ // Label 30313: @2260640
     /* 2260640 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2260688), // Rule ID 48867 //
     /* 2260645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260658 */   // MIs[0] Operand 1
     /* 2260658 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260671 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260678 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260687 */   // GIR_Coverage, 48867,
     /* 2260687 */   GIR_EraseRootFromParent_Done,
     /* 2260688 */ // Label 30314: @2260688
     /* 2260688 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2260736), // Rule ID 48874 //
     /* 2260693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260706 */   // MIs[0] Operand 1
     /* 2260706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260719 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260726 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260735 */   // GIR_Coverage, 48874,
     /* 2260735 */   GIR_EraseRootFromParent_Done,
     /* 2260736 */ // Label 30315: @2260736
     /* 2260736 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2260784), // Rule ID 48875 //
     /* 2260741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260754 */   // MIs[0] Operand 1
     /* 2260754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260767 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260774 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260783 */   // GIR_Coverage, 48875,
     /* 2260783 */   GIR_EraseRootFromParent_Done,
     /* 2260784 */ // Label 30316: @2260784
     /* 2260784 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2260832), // Rule ID 48882 //
     /* 2260789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260802 */   // MIs[0] Operand 1
     /* 2260802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260815 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260822 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260831 */   // GIR_Coverage, 48882,
     /* 2260831 */   GIR_EraseRootFromParent_Done,
     /* 2260832 */ // Label 30317: @2260832
     /* 2260832 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2260880), // Rule ID 48883 //
     /* 2260837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260850 */   // MIs[0] Operand 1
     /* 2260850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2260855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260863 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260870 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260879 */   // GIR_Coverage, 48883,
     /* 2260879 */   GIR_EraseRootFromParent_Done,
     /* 2260880 */ // Label 30318: @2260880
     /* 2260880 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2260928), // Rule ID 48896 //
     /* 2260885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260898 */   // MIs[0] Operand 1
     /* 2260898 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260911 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260918 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260927 */   // GIR_Coverage, 48896,
     /* 2260927 */   GIR_EraseRootFromParent_Done,
     /* 2260928 */ // Label 30319: @2260928
     /* 2260928 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2260976), // Rule ID 48897 //
     /* 2260933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260946 */   // MIs[0] Operand 1
     /* 2260946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260959 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260966 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260975 */   // GIR_Coverage, 48897,
     /* 2260975 */   GIR_EraseRootFromParent_Done,
     /* 2260976 */ // Label 30320: @2260976
     /* 2260976 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2261024), // Rule ID 48910 //
     /* 2260981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260994 */   // MIs[0] Operand 1
     /* 2260994 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261007 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2261010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261023 */   // GIR_Coverage, 48910,
     /* 2261023 */   GIR_EraseRootFromParent_Done,
     /* 2261024 */ // Label 30321: @2261024
     /* 2261024 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2261072), // Rule ID 48911 //
     /* 2261029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261042 */   // MIs[0] Operand 1
     /* 2261042 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261055 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2261058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261062 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261071 */   // GIR_Coverage, 48911,
     /* 2261071 */   GIR_EraseRootFromParent_Done,
     /* 2261072 */ // Label 30322: @2261072
     /* 2261072 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2261120), // Rule ID 48918 //
     /* 2261077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261090 */   // MIs[0] Operand 1
     /* 2261090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261103 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2261106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261119 */   // GIR_Coverage, 48918,
     /* 2261119 */   GIR_EraseRootFromParent_Done,
     /* 2261120 */ // Label 30323: @2261120
     /* 2261120 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2261168), // Rule ID 48919 //
     /* 2261125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261138 */   // MIs[0] Operand 1
     /* 2261138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261151 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2261154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261158 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261167 */   // GIR_Coverage, 48919,
     /* 2261167 */   GIR_EraseRootFromParent_Done,
     /* 2261168 */ // Label 30324: @2261168
     /* 2261168 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2261216), // Rule ID 48926 //
     /* 2261173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261186 */   // MIs[0] Operand 1
     /* 2261186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261199 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2261202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261206 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261215 */   // GIR_Coverage, 48926,
     /* 2261215 */   GIR_EraseRootFromParent_Done,
     /* 2261216 */ // Label 30325: @2261216
     /* 2261216 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2261264), // Rule ID 48927 //
     /* 2261221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261234 */   // MIs[0] Operand 1
     /* 2261234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2261239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261247 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2261250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261254 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261263 */   // GIR_Coverage, 48927,
     /* 2261263 */   GIR_EraseRootFromParent_Done,
     /* 2261264 */ // Label 30326: @2261264
     /* 2261264 */ GIM_Reject,
     /* 2261265 */ // Label 29905: @2261265
     /* 2261265 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2261313), // Rule ID 48510 //
     /* 2261270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261276 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261283 */   // MIs[0] Operand 1
     /* 2261283 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261292 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261296 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2261299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261301 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261303 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261312 */   // GIR_Coverage, 48510,
     /* 2261312 */   GIR_EraseRootFromParent_Done,
     /* 2261313 */ // Label 30327: @2261313
     /* 2261313 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2261361), // Rule ID 48511 //
     /* 2261318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261331 */   // MIs[0] Operand 1
     /* 2261331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261340 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261344 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2261347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261349 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261351 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261360 */   // GIR_Coverage, 48511,
     /* 2261360 */   GIR_EraseRootFromParent_Done,
     /* 2261361 */ // Label 30328: @2261361
     /* 2261361 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2261409), // Rule ID 48518 //
     /* 2261366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261372 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261379 */   // MIs[0] Operand 1
     /* 2261379 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261388 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261392 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2261395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261397 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261399 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261408 */   // GIR_Coverage, 48518,
     /* 2261408 */   GIR_EraseRootFromParent_Done,
     /* 2261409 */ // Label 30329: @2261409
     /* 2261409 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2261457), // Rule ID 48519 //
     /* 2261414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261427 */   // MIs[0] Operand 1
     /* 2261427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261440 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2261443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261445 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261447 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261455 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261456 */   // GIR_Coverage, 48519,
     /* 2261456 */   GIR_EraseRootFromParent_Done,
     /* 2261457 */ // Label 30330: @2261457
     /* 2261457 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2261505), // Rule ID 48526 //
     /* 2261462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261468 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261475 */   // MIs[0] Operand 1
     /* 2261475 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261484 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261488 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261493 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261495 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261504 */   // GIR_Coverage, 48526,
     /* 2261504 */   GIR_EraseRootFromParent_Done,
     /* 2261505 */ // Label 30331: @2261505
     /* 2261505 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2261553), // Rule ID 48527 //
     /* 2261510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261523 */   // MIs[0] Operand 1
     /* 2261523 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2261528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261532 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261536 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2261539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261541 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261543 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261552 */   // GIR_Coverage, 48527,
     /* 2261552 */   GIR_EraseRootFromParent_Done,
     /* 2261553 */ // Label 30332: @2261553
     /* 2261553 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2261601), // Rule ID 48554 //
     /* 2261558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261571 */   // MIs[0] Operand 1
     /* 2261571 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261580 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261584 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261589 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261591 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261600 */   // GIR_Coverage, 48554,
     /* 2261600 */   GIR_EraseRootFromParent_Done,
     /* 2261601 */ // Label 30333: @2261601
     /* 2261601 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2261649), // Rule ID 48555 //
     /* 2261606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261619 */   // MIs[0] Operand 1
     /* 2261619 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261632 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2261635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261637 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261639 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261648 */   // GIR_Coverage, 48555,
     /* 2261648 */   GIR_EraseRootFromParent_Done,
     /* 2261649 */ // Label 30334: @2261649
     /* 2261649 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2261697), // Rule ID 48562 //
     /* 2261654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261660 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261667 */   // MIs[0] Operand 1
     /* 2261667 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261676 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261680 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261685 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261687 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261696 */   // GIR_Coverage, 48562,
     /* 2261696 */   GIR_EraseRootFromParent_Done,
     /* 2261697 */ // Label 30335: @2261697
     /* 2261697 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2261745), // Rule ID 48563 //
     /* 2261702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261715 */   // MIs[0] Operand 1
     /* 2261715 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261724 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261728 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2261731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261733 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261735 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261744 */   // GIR_Coverage, 48563,
     /* 2261744 */   GIR_EraseRootFromParent_Done,
     /* 2261745 */ // Label 30336: @2261745
     /* 2261745 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2261793), // Rule ID 48570 //
     /* 2261750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261763 */   // MIs[0] Operand 1
     /* 2261763 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261772 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261776 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261783 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261791 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261792 */   // GIR_Coverage, 48570,
     /* 2261792 */   GIR_EraseRootFromParent_Done,
     /* 2261793 */ // Label 30337: @2261793
     /* 2261793 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2261841), // Rule ID 48571 //
     /* 2261798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261811 */   // MIs[0] Operand 1
     /* 2261811 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2261816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261820 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261824 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2261827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261829 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261831 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261840 */   // GIR_Coverage, 48571,
     /* 2261840 */   GIR_EraseRootFromParent_Done,
     /* 2261841 */ // Label 30338: @2261841
     /* 2261841 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2261889), // Rule ID 48598 //
     /* 2261846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261859 */   // MIs[0] Operand 1
     /* 2261859 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261872 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261879 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261888 */   // GIR_Coverage, 48598,
     /* 2261888 */   GIR_EraseRootFromParent_Done,
     /* 2261889 */ // Label 30339: @2261889
     /* 2261889 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2261937), // Rule ID 48599 //
     /* 2261894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261907 */   // MIs[0] Operand 1
     /* 2261907 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261916 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261920 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261925 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261927 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261936 */   // GIR_Coverage, 48599,
     /* 2261936 */   GIR_EraseRootFromParent_Done,
     /* 2261937 */ // Label 30340: @2261937
     /* 2261937 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2261985), // Rule ID 48606 //
     /* 2261942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261955 */   // MIs[0] Operand 1
     /* 2261955 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261964 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261968 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261973 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261975 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261984 */   // GIR_Coverage, 48606,
     /* 2261984 */   GIR_EraseRootFromParent_Done,
     /* 2261985 */ // Label 30341: @2261985
     /* 2261985 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2262033), // Rule ID 48607 //
     /* 2261990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261996 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262003 */   // MIs[0] Operand 1
     /* 2262003 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262012 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262016 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262021 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262023 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262032 */   // GIR_Coverage, 48607,
     /* 2262032 */   GIR_EraseRootFromParent_Done,
     /* 2262033 */ // Label 30342: @2262033
     /* 2262033 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2262081), // Rule ID 48614 //
     /* 2262038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262051 */   // MIs[0] Operand 1
     /* 2262051 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262060 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262064 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262069 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262071 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262080 */   // GIR_Coverage, 48614,
     /* 2262080 */   GIR_EraseRootFromParent_Done,
     /* 2262081 */ // Label 30343: @2262081
     /* 2262081 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2262129), // Rule ID 48615 //
     /* 2262086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262092 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262099 */   // MIs[0] Operand 1
     /* 2262099 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2262104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262108 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262112 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262117 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262119 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262128 */   // GIR_Coverage, 48615,
     /* 2262128 */   GIR_EraseRootFromParent_Done,
     /* 2262129 */ // Label 30344: @2262129
     /* 2262129 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2262177), // Rule ID 48640 //
     /* 2262134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262147 */   // MIs[0] Operand 1
     /* 2262147 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262156 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262160 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2262163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262167 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262176 */   // GIR_Coverage, 48640,
     /* 2262176 */   GIR_EraseRootFromParent_Done,
     /* 2262177 */ // Label 30345: @2262177
     /* 2262177 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2262225), // Rule ID 48641 //
     /* 2262182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262195 */   // MIs[0] Operand 1
     /* 2262195 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262208 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2262211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262215 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262224 */   // GIR_Coverage, 48641,
     /* 2262224 */   GIR_EraseRootFromParent_Done,
     /* 2262225 */ // Label 30346: @2262225
     /* 2262225 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2262273), // Rule ID 48648 //
     /* 2262230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262243 */   // MIs[0] Operand 1
     /* 2262243 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262256 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262263 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262272 */   // GIR_Coverage, 48648,
     /* 2262272 */   GIR_EraseRootFromParent_Done,
     /* 2262273 */ // Label 30347: @2262273
     /* 2262273 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2262321), // Rule ID 48649 //
     /* 2262278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262291 */   // MIs[0] Operand 1
     /* 2262291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262304 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2262307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262311 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262320 */   // GIR_Coverage, 48649,
     /* 2262320 */   GIR_EraseRootFromParent_Done,
     /* 2262321 */ // Label 30348: @2262321
     /* 2262321 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2262369), // Rule ID 48656 //
     /* 2262326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262339 */   // MIs[0] Operand 1
     /* 2262339 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262352 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262359 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262368 */   // GIR_Coverage, 48656,
     /* 2262368 */   GIR_EraseRootFromParent_Done,
     /* 2262369 */ // Label 30349: @2262369
     /* 2262369 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2262417), // Rule ID 48657 //
     /* 2262374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262387 */   // MIs[0] Operand 1
     /* 2262387 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2262392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262396 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262400 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2262403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262407 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262416 */   // GIR_Coverage, 48657,
     /* 2262416 */   GIR_EraseRootFromParent_Done,
     /* 2262417 */ // Label 30350: @2262417
     /* 2262417 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2262465), // Rule ID 48684 //
     /* 2262422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262435 */   // MIs[0] Operand 1
     /* 2262435 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262448 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262453 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262455 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262464 */   // GIR_Coverage, 48684,
     /* 2262464 */   GIR_EraseRootFromParent_Done,
     /* 2262465 */ // Label 30351: @2262465
     /* 2262465 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2262513), // Rule ID 48685 //
     /* 2262470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262483 */   // MIs[0] Operand 1
     /* 2262483 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262496 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262501 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262503 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262512 */   // GIR_Coverage, 48685,
     /* 2262512 */   GIR_EraseRootFromParent_Done,
     /* 2262513 */ // Label 30352: @2262513
     /* 2262513 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2262561), // Rule ID 48692 //
     /* 2262518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262531 */   // MIs[0] Operand 1
     /* 2262531 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262544 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262551 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262560 */   // GIR_Coverage, 48692,
     /* 2262560 */   GIR_EraseRootFromParent_Done,
     /* 2262561 */ // Label 30353: @2262561
     /* 2262561 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2262609), // Rule ID 48693 //
     /* 2262566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262579 */   // MIs[0] Operand 1
     /* 2262579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262592 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262608 */   // GIR_Coverage, 48693,
     /* 2262608 */   GIR_EraseRootFromParent_Done,
     /* 2262609 */ // Label 30354: @2262609
     /* 2262609 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2262657), // Rule ID 48700 //
     /* 2262614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262627 */   // MIs[0] Operand 1
     /* 2262627 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262636 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262640 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262647 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262656 */   // GIR_Coverage, 48700,
     /* 2262656 */   GIR_EraseRootFromParent_Done,
     /* 2262657 */ // Label 30355: @2262657
     /* 2262657 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2262705), // Rule ID 48701 //
     /* 2262662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262675 */   // MIs[0] Operand 1
     /* 2262675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2262680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262688 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262695 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262704 */   // GIR_Coverage, 48701,
     /* 2262704 */   GIR_EraseRootFromParent_Done,
     /* 2262705 */ // Label 30356: @2262705
     /* 2262705 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2262753), // Rule ID 48728 //
     /* 2262710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262716 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262723 */   // MIs[0] Operand 1
     /* 2262723 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262732 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262736 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262743 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262752 */   // GIR_Coverage, 48728,
     /* 2262752 */   GIR_EraseRootFromParent_Done,
     /* 2262753 */ // Label 30357: @2262753
     /* 2262753 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2262801), // Rule ID 48729 //
     /* 2262758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262771 */   // MIs[0] Operand 1
     /* 2262771 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262784 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2262787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262791 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262800 */   // GIR_Coverage, 48729,
     /* 2262800 */   GIR_EraseRootFromParent_Done,
     /* 2262801 */ // Label 30358: @2262801
     /* 2262801 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2262849), // Rule ID 48736 //
     /* 2262806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262819 */   // MIs[0] Operand 1
     /* 2262819 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262828 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262832 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262839 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262848 */   // GIR_Coverage, 48736,
     /* 2262848 */   GIR_EraseRootFromParent_Done,
     /* 2262849 */ // Label 30359: @2262849
     /* 2262849 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2262897), // Rule ID 48737 //
     /* 2262854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262867 */   // MIs[0] Operand 1
     /* 2262867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262880 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262887 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262896 */   // GIR_Coverage, 48737,
     /* 2262896 */   GIR_EraseRootFromParent_Done,
     /* 2262897 */ // Label 30360: @2262897
     /* 2262897 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2262945), // Rule ID 48744 //
     /* 2262902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262915 */   // MIs[0] Operand 1
     /* 2262915 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262928 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262935 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262944 */   // GIR_Coverage, 48744,
     /* 2262944 */   GIR_EraseRootFromParent_Done,
     /* 2262945 */ // Label 30361: @2262945
     /* 2262945 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2262993), // Rule ID 48745 //
     /* 2262950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262963 */   // MIs[0] Operand 1
     /* 2262963 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262972 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262976 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262983 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262992 */   // GIR_Coverage, 48745,
     /* 2262992 */   GIR_EraseRootFromParent_Done,
     /* 2262993 */ // Label 30362: @2262993
     /* 2262993 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2263041), // Rule ID 48772 //
     /* 2262998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263011 */   // MIs[0] Operand 1
     /* 2263011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263024 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263029 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263031 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263039 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263040 */   // GIR_Coverage, 48772,
     /* 2263040 */   GIR_EraseRootFromParent_Done,
     /* 2263041 */ // Label 30363: @2263041
     /* 2263041 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2263089), // Rule ID 48773 //
     /* 2263046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263059 */   // MIs[0] Operand 1
     /* 2263059 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263068 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263072 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263079 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263088 */   // GIR_Coverage, 48773,
     /* 2263088 */   GIR_EraseRootFromParent_Done,
     /* 2263089 */ // Label 30364: @2263089
     /* 2263089 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2263137), // Rule ID 48780 //
     /* 2263094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263100 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263107 */   // MIs[0] Operand 1
     /* 2263107 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263116 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263120 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263127 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263136 */   // GIR_Coverage, 48780,
     /* 2263136 */   GIR_EraseRootFromParent_Done,
     /* 2263137 */ // Label 30365: @2263137
     /* 2263137 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2263185), // Rule ID 48781 //
     /* 2263142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263155 */   // MIs[0] Operand 1
     /* 2263155 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263164 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263168 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263175 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263184 */   // GIR_Coverage, 48781,
     /* 2263184 */   GIR_EraseRootFromParent_Done,
     /* 2263185 */ // Label 30366: @2263185
     /* 2263185 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2263233), // Rule ID 48788 //
     /* 2263190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263203 */   // MIs[0] Operand 1
     /* 2263203 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263216 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263223 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263232 */   // GIR_Coverage, 48788,
     /* 2263232 */   GIR_EraseRootFromParent_Done,
     /* 2263233 */ // Label 30367: @2263233
     /* 2263233 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2263281), // Rule ID 48789 //
     /* 2263238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263251 */   // MIs[0] Operand 1
     /* 2263251 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2263256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263264 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263271 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263280 */   // GIR_Coverage, 48789,
     /* 2263280 */   GIR_EraseRootFromParent_Done,
     /* 2263281 */ // Label 30368: @2263281
     /* 2263281 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2263329), // Rule ID 48816 //
     /* 2263286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263299 */   // MIs[0] Operand 1
     /* 2263299 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263312 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263328 */   // GIR_Coverage, 48816,
     /* 2263328 */   GIR_EraseRootFromParent_Done,
     /* 2263329 */ // Label 30369: @2263329
     /* 2263329 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2263377), // Rule ID 48817 //
     /* 2263334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263347 */   // MIs[0] Operand 1
     /* 2263347 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263356 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263360 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2263363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263367 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263376 */   // GIR_Coverage, 48817,
     /* 2263376 */   GIR_EraseRootFromParent_Done,
     /* 2263377 */ // Label 30370: @2263377
     /* 2263377 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2263425), // Rule ID 48824 //
     /* 2263382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263395 */   // MIs[0] Operand 1
     /* 2263395 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263404 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263408 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263424 */   // GIR_Coverage, 48824,
     /* 2263424 */   GIR_EraseRootFromParent_Done,
     /* 2263425 */ // Label 30371: @2263425
     /* 2263425 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2263473), // Rule ID 48825 //
     /* 2263430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263443 */   // MIs[0] Operand 1
     /* 2263443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263456 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2263459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263461 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263472 */   // GIR_Coverage, 48825,
     /* 2263472 */   GIR_EraseRootFromParent_Done,
     /* 2263473 */ // Label 30372: @2263473
     /* 2263473 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2263521), // Rule ID 48832 //
     /* 2263478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263491 */   // MIs[0] Operand 1
     /* 2263491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263504 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263511 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263520 */   // GIR_Coverage, 48832,
     /* 2263520 */   GIR_EraseRootFromParent_Done,
     /* 2263521 */ // Label 30373: @2263521
     /* 2263521 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2263569), // Rule ID 48833 //
     /* 2263526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263539 */   // MIs[0] Operand 1
     /* 2263539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2263544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263552 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2263555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263559 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263568 */   // GIR_Coverage, 48833,
     /* 2263568 */   GIR_EraseRootFromParent_Done,
     /* 2263569 */ // Label 30374: @2263569
     /* 2263569 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2263617), // Rule ID 48860 //
     /* 2263574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263587 */   // MIs[0] Operand 1
     /* 2263587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263600 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263616 */   // GIR_Coverage, 48860,
     /* 2263616 */   GIR_EraseRootFromParent_Done,
     /* 2263617 */ // Label 30375: @2263617
     /* 2263617 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2263665), // Rule ID 48861 //
     /* 2263622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263635 */   // MIs[0] Operand 1
     /* 2263635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263648 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263655 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263664 */   // GIR_Coverage, 48861,
     /* 2263664 */   GIR_EraseRootFromParent_Done,
     /* 2263665 */ // Label 30376: @2263665
     /* 2263665 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2263713), // Rule ID 48868 //
     /* 2263670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263683 */   // MIs[0] Operand 1
     /* 2263683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263696 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263712 */   // GIR_Coverage, 48868,
     /* 2263712 */   GIR_EraseRootFromParent_Done,
     /* 2263713 */ // Label 30377: @2263713
     /* 2263713 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2263761), // Rule ID 48869 //
     /* 2263718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263731 */   // MIs[0] Operand 1
     /* 2263731 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263744 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263749 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263751 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263760 */   // GIR_Coverage, 48869,
     /* 2263760 */   GIR_EraseRootFromParent_Done,
     /* 2263761 */ // Label 30378: @2263761
     /* 2263761 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2263809), // Rule ID 48876 //
     /* 2263766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263779 */   // MIs[0] Operand 1
     /* 2263779 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263788 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263792 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263797 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263799 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263808 */   // GIR_Coverage, 48876,
     /* 2263808 */   GIR_EraseRootFromParent_Done,
     /* 2263809 */ // Label 30379: @2263809
     /* 2263809 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2263857), // Rule ID 48877 //
     /* 2263814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263827 */   // MIs[0] Operand 1
     /* 2263827 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2263832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263840 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263845 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263847 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263856 */   // GIR_Coverage, 48877,
     /* 2263856 */   GIR_EraseRootFromParent_Done,
     /* 2263857 */ // Label 30380: @2263857
     /* 2263857 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2263905), // Rule ID 48904 //
     /* 2263862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263875 */   // MIs[0] Operand 1
     /* 2263875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263888 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263904 */   // GIR_Coverage, 48904,
     /* 2263904 */   GIR_EraseRootFromParent_Done,
     /* 2263905 */ // Label 30381: @2263905
     /* 2263905 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2263953), // Rule ID 48905 //
     /* 2263910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263923 */   // MIs[0] Operand 1
     /* 2263923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263932 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263936 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263941 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263952 */   // GIR_Coverage, 48905,
     /* 2263952 */   GIR_EraseRootFromParent_Done,
     /* 2263953 */ // Label 30382: @2263953
     /* 2263953 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2264001), // Rule ID 48912 //
     /* 2263958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263971 */   // MIs[0] Operand 1
     /* 2263971 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263984 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263989 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264000 */   // GIR_Coverage, 48912,
     /* 2264000 */   GIR_EraseRootFromParent_Done,
     /* 2264001 */ // Label 30383: @2264001
     /* 2264001 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2264049), // Rule ID 48913 //
     /* 2264006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2264012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2264015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264019 */   // MIs[0] Operand 1
     /* 2264019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264032 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264037 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264039 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264048 */   // GIR_Coverage, 48913,
     /* 2264048 */   GIR_EraseRootFromParent_Done,
     /* 2264049 */ // Label 30384: @2264049
     /* 2264049 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2264097), // Rule ID 48920 //
     /* 2264054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264067 */   // MIs[0] Operand 1
     /* 2264067 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264080 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264085 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264096 */   // GIR_Coverage, 48920,
     /* 2264096 */   GIR_EraseRootFromParent_Done,
     /* 2264097 */ // Label 30385: @2264097
     /* 2264097 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2264145), // Rule ID 48921 //
     /* 2264102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2264108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2264111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264115 */   // MIs[0] Operand 1
     /* 2264115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2264120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264128 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264144 */   // GIR_Coverage, 48921,
     /* 2264144 */   GIR_EraseRootFromParent_Done,
     /* 2264145 */ // Label 30386: @2264145
     /* 2264145 */ GIM_Reject,
     /* 2264146 */ // Label 29906: @2264146
     /* 2264146 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2264194), // Rule ID 48512 //
     /* 2264151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264164 */   // MIs[0] Operand 1
     /* 2264164 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264173 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264177 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264182 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264184 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264193 */   // GIR_Coverage, 48512,
     /* 2264193 */   GIR_EraseRootFromParent_Done,
     /* 2264194 */ // Label 30387: @2264194
     /* 2264194 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2264242), // Rule ID 48513 //
     /* 2264199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264212 */   // MIs[0] Operand 1
     /* 2264212 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264221 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264225 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2264228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264230 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264232 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264241 */   // GIR_Coverage, 48513,
     /* 2264241 */   GIR_EraseRootFromParent_Done,
     /* 2264242 */ // Label 30388: @2264242
     /* 2264242 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2264290), // Rule ID 48520 //
     /* 2264247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264260 */   // MIs[0] Operand 1
     /* 2264260 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264269 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264273 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264278 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264280 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264289 */   // GIR_Coverage, 48520,
     /* 2264289 */   GIR_EraseRootFromParent_Done,
     /* 2264290 */ // Label 30389: @2264290
     /* 2264290 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2264338), // Rule ID 48521 //
     /* 2264295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264301 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264308 */   // MIs[0] Operand 1
     /* 2264308 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2264313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264317 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264321 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2264324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264326 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264328 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264337 */   // GIR_Coverage, 48521,
     /* 2264337 */   GIR_EraseRootFromParent_Done,
     /* 2264338 */ // Label 30390: @2264338
     /* 2264338 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2264386), // Rule ID 48556 //
     /* 2264343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264349 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264356 */   // MIs[0] Operand 1
     /* 2264356 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264365 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264369 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264376 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264385 */   // GIR_Coverage, 48556,
     /* 2264385 */   GIR_EraseRootFromParent_Done,
     /* 2264386 */ // Label 30391: @2264386
     /* 2264386 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2264434), // Rule ID 48557 //
     /* 2264391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264404 */   // MIs[0] Operand 1
     /* 2264404 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264417 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2264420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264422 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264424 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264433 */   // GIR_Coverage, 48557,
     /* 2264433 */   GIR_EraseRootFromParent_Done,
     /* 2264434 */ // Label 30392: @2264434
     /* 2264434 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2264482), // Rule ID 48564 //
     /* 2264439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264452 */   // MIs[0] Operand 1
     /* 2264452 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264461 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264465 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264470 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264472 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264481 */   // GIR_Coverage, 48564,
     /* 2264481 */   GIR_EraseRootFromParent_Done,
     /* 2264482 */ // Label 30393: @2264482
     /* 2264482 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2264530), // Rule ID 48565 //
     /* 2264487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264500 */   // MIs[0] Operand 1
     /* 2264500 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2264505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264509 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264513 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2264516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264518 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264520 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264529 */   // GIR_Coverage, 48565,
     /* 2264529 */   GIR_EraseRootFromParent_Done,
     /* 2264530 */ // Label 30394: @2264530
     /* 2264530 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2264578), // Rule ID 48600 //
     /* 2264535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264548 */   // MIs[0] Operand 1
     /* 2264548 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264557 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264561 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264566 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264568 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264577 */   // GIR_Coverage, 48600,
     /* 2264577 */   GIR_EraseRootFromParent_Done,
     /* 2264578 */ // Label 30395: @2264578
     /* 2264578 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2264626), // Rule ID 48601 //
     /* 2264583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264596 */   // MIs[0] Operand 1
     /* 2264596 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264605 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264609 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264614 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264616 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264625 */   // GIR_Coverage, 48601,
     /* 2264625 */   GIR_EraseRootFromParent_Done,
     /* 2264626 */ // Label 30396: @2264626
     /* 2264626 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2264674), // Rule ID 48608 //
     /* 2264631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264644 */   // MIs[0] Operand 1
     /* 2264644 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264653 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264657 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264662 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264664 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264673 */   // GIR_Coverage, 48608,
     /* 2264673 */   GIR_EraseRootFromParent_Done,
     /* 2264674 */ // Label 30397: @2264674
     /* 2264674 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2264722), // Rule ID 48609 //
     /* 2264679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264692 */   // MIs[0] Operand 1
     /* 2264692 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2264697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264701 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264705 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264710 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264712 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264720 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264721 */   // GIR_Coverage, 48609,
     /* 2264721 */   GIR_EraseRootFromParent_Done,
     /* 2264722 */ // Label 30398: @2264722
     /* 2264722 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2264770), // Rule ID 48642 //
     /* 2264727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264740 */   // MIs[0] Operand 1
     /* 2264740 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264749 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264753 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264769 */   // GIR_Coverage, 48642,
     /* 2264769 */   GIR_EraseRootFromParent_Done,
     /* 2264770 */ // Label 30399: @2264770
     /* 2264770 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2264818), // Rule ID 48643 //
     /* 2264775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264788 */   // MIs[0] Operand 1
     /* 2264788 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264797 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264801 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2264804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264817 */   // GIR_Coverage, 48643,
     /* 2264817 */   GIR_EraseRootFromParent_Done,
     /* 2264818 */ // Label 30400: @2264818
     /* 2264818 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2264866), // Rule ID 48650 //
     /* 2264823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264829 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264836 */   // MIs[0] Operand 1
     /* 2264836 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264845 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264849 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264865 */   // GIR_Coverage, 48650,
     /* 2264865 */   GIR_EraseRootFromParent_Done,
     /* 2264866 */ // Label 30401: @2264866
     /* 2264866 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2264914), // Rule ID 48651 //
     /* 2264871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264884 */   // MIs[0] Operand 1
     /* 2264884 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264893 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264897 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264913 */   // GIR_Coverage, 48651,
     /* 2264913 */   GIR_EraseRootFromParent_Done,
     /* 2264914 */ // Label 30402: @2264914
     /* 2264914 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2264962), // Rule ID 48686 //
     /* 2264919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264925 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264932 */   // MIs[0] Operand 1
     /* 2264932 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264945 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264950 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264952 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264961 */   // GIR_Coverage, 48686,
     /* 2264961 */   GIR_EraseRootFromParent_Done,
     /* 2264962 */ // Label 30403: @2264962
     /* 2264962 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2265010), // Rule ID 48687 //
     /* 2264967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264980 */   // MIs[0] Operand 1
     /* 2264980 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264993 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264998 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265000 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265009 */   // GIR_Coverage, 48687,
     /* 2265009 */   GIR_EraseRootFromParent_Done,
     /* 2265010 */ // Label 30404: @2265010
     /* 2265010 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2265058), // Rule ID 48694 //
     /* 2265015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265028 */   // MIs[0] Operand 1
     /* 2265028 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265037 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265041 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265046 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265048 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265057 */   // GIR_Coverage, 48694,
     /* 2265057 */   GIR_EraseRootFromParent_Done,
     /* 2265058 */ // Label 30405: @2265058
     /* 2265058 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2265106), // Rule ID 48695 //
     /* 2265063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265069 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265076 */   // MIs[0] Operand 1
     /* 2265076 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265085 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265089 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265094 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265096 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265105 */   // GIR_Coverage, 48695,
     /* 2265105 */   GIR_EraseRootFromParent_Done,
     /* 2265106 */ // Label 30406: @2265106
     /* 2265106 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2265154), // Rule ID 48730 //
     /* 2265111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265124 */   // MIs[0] Operand 1
     /* 2265124 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265133 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265137 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265142 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265144 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265153 */   // GIR_Coverage, 48730,
     /* 2265153 */   GIR_EraseRootFromParent_Done,
     /* 2265154 */ // Label 30407: @2265154
     /* 2265154 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2265202), // Rule ID 48731 //
     /* 2265159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265172 */   // MIs[0] Operand 1
     /* 2265172 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265181 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265185 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2265188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265190 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265192 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265201 */   // GIR_Coverage, 48731,
     /* 2265201 */   GIR_EraseRootFromParent_Done,
     /* 2265202 */ // Label 30408: @2265202
     /* 2265202 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2265250), // Rule ID 48738 //
     /* 2265207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265220 */   // MIs[0] Operand 1
     /* 2265220 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265229 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265233 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265238 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265240 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265249 */   // GIR_Coverage, 48738,
     /* 2265249 */   GIR_EraseRootFromParent_Done,
     /* 2265250 */ // Label 30409: @2265250
     /* 2265250 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2265298), // Rule ID 48739 //
     /* 2265255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265268 */   // MIs[0] Operand 1
     /* 2265268 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265277 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265281 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265286 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265297 */   // GIR_Coverage, 48739,
     /* 2265297 */   GIR_EraseRootFromParent_Done,
     /* 2265298 */ // Label 30410: @2265298
     /* 2265298 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2265346), // Rule ID 48774 //
     /* 2265303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265316 */   // MIs[0] Operand 1
     /* 2265316 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265325 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265329 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265334 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265336 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265344 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265345 */   // GIR_Coverage, 48774,
     /* 2265345 */   GIR_EraseRootFromParent_Done,
     /* 2265346 */ // Label 30411: @2265346
     /* 2265346 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2265394), // Rule ID 48775 //
     /* 2265351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265364 */   // MIs[0] Operand 1
     /* 2265364 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265373 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265377 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265384 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265393 */   // GIR_Coverage, 48775,
     /* 2265393 */   GIR_EraseRootFromParent_Done,
     /* 2265394 */ // Label 30412: @2265394
     /* 2265394 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2265442), // Rule ID 48782 //
     /* 2265399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265412 */   // MIs[0] Operand 1
     /* 2265412 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265421 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265425 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265430 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265432 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265441 */   // GIR_Coverage, 48782,
     /* 2265441 */   GIR_EraseRootFromParent_Done,
     /* 2265442 */ // Label 30413: @2265442
     /* 2265442 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2265490), // Rule ID 48783 //
     /* 2265447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265460 */   // MIs[0] Operand 1
     /* 2265460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265469 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265473 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265478 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265480 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265489 */   // GIR_Coverage, 48783,
     /* 2265489 */   GIR_EraseRootFromParent_Done,
     /* 2265490 */ // Label 30414: @2265490
     /* 2265490 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2265538), // Rule ID 48818 //
     /* 2265495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265508 */   // MIs[0] Operand 1
     /* 2265508 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265517 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265521 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265526 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265537 */   // GIR_Coverage, 48818,
     /* 2265537 */   GIR_EraseRootFromParent_Done,
     /* 2265538 */ // Label 30415: @2265538
     /* 2265538 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2265586), // Rule ID 48819 //
     /* 2265543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265556 */   // MIs[0] Operand 1
     /* 2265556 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265565 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265569 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2265572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265574 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265576 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265585 */   // GIR_Coverage, 48819,
     /* 2265585 */   GIR_EraseRootFromParent_Done,
     /* 2265586 */ // Label 30416: @2265586
     /* 2265586 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2265634), // Rule ID 48826 //
     /* 2265591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265604 */   // MIs[0] Operand 1
     /* 2265604 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265613 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265617 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265622 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265624 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265633 */   // GIR_Coverage, 48826,
     /* 2265633 */   GIR_EraseRootFromParent_Done,
     /* 2265634 */ // Label 30417: @2265634
     /* 2265634 */ GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2265682), // Rule ID 48827 //
     /* 2265639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265652 */   // MIs[0] Operand 1
     /* 2265652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265661 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265665 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265670 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265681 */   // GIR_Coverage, 48827,
     /* 2265681 */   GIR_EraseRootFromParent_Done,
     /* 2265682 */ // Label 30418: @2265682
     /* 2265682 */ GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2265730), // Rule ID 48862 //
     /* 2265687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265700 */   // MIs[0] Operand 1
     /* 2265700 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265709 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265713 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265720 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265728 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265729 */   // GIR_Coverage, 48862,
     /* 2265729 */   GIR_EraseRootFromParent_Done,
     /* 2265730 */ // Label 30419: @2265730
     /* 2265730 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2265778), // Rule ID 48863 //
     /* 2265735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265741 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265748 */   // MIs[0] Operand 1
     /* 2265748 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265757 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265761 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265766 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265768 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265777 */   // GIR_Coverage, 48863,
     /* 2265777 */   GIR_EraseRootFromParent_Done,
     /* 2265778 */ // Label 30420: @2265778
     /* 2265778 */ GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2265826), // Rule ID 48870 //
     /* 2265783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265796 */   // MIs[0] Operand 1
     /* 2265796 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265809 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265814 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265816 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265825 */   // GIR_Coverage, 48870,
     /* 2265825 */   GIR_EraseRootFromParent_Done,
     /* 2265826 */ // Label 30421: @2265826
     /* 2265826 */ GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2265874), // Rule ID 48871 //
     /* 2265831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265844 */   // MIs[0] Operand 1
     /* 2265844 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265853 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265857 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265862 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265864 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265873 */   // GIR_Coverage, 48871,
     /* 2265873 */   GIR_EraseRootFromParent_Done,
     /* 2265874 */ // Label 30422: @2265874
     /* 2265874 */ GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2265922), // Rule ID 48906 //
     /* 2265879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265892 */   // MIs[0] Operand 1
     /* 2265892 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265901 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265905 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265912 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265921 */   // GIR_Coverage, 48906,
     /* 2265921 */   GIR_EraseRootFromParent_Done,
     /* 2265922 */ // Label 30423: @2265922
     /* 2265922 */ GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2265970), // Rule ID 48907 //
     /* 2265927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265940 */   // MIs[0] Operand 1
     /* 2265940 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265949 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265953 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265958 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265960 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265969 */   // GIR_Coverage, 48907,
     /* 2265969 */   GIR_EraseRootFromParent_Done,
     /* 2265970 */ // Label 30424: @2265970
     /* 2265970 */ GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2266018), // Rule ID 48914 //
     /* 2265975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265988 */   // MIs[0] Operand 1
     /* 2265988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266001 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266008 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266017 */   // GIR_Coverage, 48914,
     /* 2266017 */   GIR_EraseRootFromParent_Done,
     /* 2266018 */ // Label 30425: @2266018
     /* 2266018 */ GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2266066), // Rule ID 48915 //
     /* 2266023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2266029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2266032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266036 */   // MIs[0] Operand 1
     /* 2266036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266049 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266054 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266056 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266065 */   // GIR_Coverage, 48915,
     /* 2266065 */   GIR_EraseRootFromParent_Done,
     /* 2266066 */ // Label 30426: @2266066
     /* 2266066 */ GIM_Reject,
     /* 2266067 */ // Label 29907: @2266067
     /* 2266067 */ GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2266843),
     /* 2266072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2266075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2266078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266082 */   GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2266120), // Rule ID 48514 //
     /* 2266087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266090 */     // MIs[0] Operand 1
     /* 2266090 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2266095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266103 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2266106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266119 */     // GIR_Coverage, 48514,
     /* 2266119 */     GIR_EraseRootFromParent_Done,
     /* 2266120 */   // Label 30428: @2266120
     /* 2266120 */   GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2266158), // Rule ID 48515 //
     /* 2266125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266128 */     // MIs[0] Operand 1
     /* 2266128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2266133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266141 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2266144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266157 */     // GIR_Coverage, 48515,
     /* 2266157 */     GIR_EraseRootFromParent_Done,
     /* 2266158 */   // Label 30429: @2266158
     /* 2266158 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2266196), // Rule ID 48558 //
     /* 2266163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266166 */     // MIs[0] Operand 1
     /* 2266166 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2266171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266179 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2266182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266195 */     // GIR_Coverage, 48558,
     /* 2266195 */     GIR_EraseRootFromParent_Done,
     /* 2266196 */   // Label 30430: @2266196
     /* 2266196 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2266234), // Rule ID 48559 //
     /* 2266201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266204 */     // MIs[0] Operand 1
     /* 2266204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2266209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266217 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2266220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266233 */     // GIR_Coverage, 48559,
     /* 2266233 */     GIR_EraseRootFromParent_Done,
     /* 2266234 */   // Label 30431: @2266234
     /* 2266234 */   GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2266272), // Rule ID 48602 //
     /* 2266239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266242 */     // MIs[0] Operand 1
     /* 2266242 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2266247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266255 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266271 */     // GIR_Coverage, 48602,
     /* 2266271 */     GIR_EraseRootFromParent_Done,
     /* 2266272 */   // Label 30432: @2266272
     /* 2266272 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2266310), // Rule ID 48603 //
     /* 2266277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266280 */     // MIs[0] Operand 1
     /* 2266280 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2266285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266293 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266309 */     // GIR_Coverage, 48603,
     /* 2266309 */     GIR_EraseRootFromParent_Done,
     /* 2266310 */   // Label 30433: @2266310
     /* 2266310 */   GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2266348), // Rule ID 48644 //
     /* 2266315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266318 */     // MIs[0] Operand 1
     /* 2266318 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2266323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266331 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266347 */     // GIR_Coverage, 48644,
     /* 2266347 */     GIR_EraseRootFromParent_Done,
     /* 2266348 */   // Label 30434: @2266348
     /* 2266348 */   GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2266386), // Rule ID 48645 //
     /* 2266353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266356 */     // MIs[0] Operand 1
     /* 2266356 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2266361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266369 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2266372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266385 */     // GIR_Coverage, 48645,
     /* 2266385 */     GIR_EraseRootFromParent_Done,
     /* 2266386 */   // Label 30435: @2266386
     /* 2266386 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2266424), // Rule ID 48688 //
     /* 2266391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266394 */     // MIs[0] Operand 1
     /* 2266394 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2266399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266407 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266423 */     // GIR_Coverage, 48688,
     /* 2266423 */     GIR_EraseRootFromParent_Done,
     /* 2266424 */   // Label 30436: @2266424
     /* 2266424 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2266462), // Rule ID 48689 //
     /* 2266429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266432 */     // MIs[0] Operand 1
     /* 2266432 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2266437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266445 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266461 */     // GIR_Coverage, 48689,
     /* 2266461 */     GIR_EraseRootFromParent_Done,
     /* 2266462 */   // Label 30437: @2266462
     /* 2266462 */   GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2266500), // Rule ID 48732 //
     /* 2266467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266470 */     // MIs[0] Operand 1
     /* 2266470 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266483 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266499 */     // GIR_Coverage, 48732,
     /* 2266499 */     GIR_EraseRootFromParent_Done,
     /* 2266500 */   // Label 30438: @2266500
     /* 2266500 */   GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2266538), // Rule ID 48733 //
     /* 2266505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266508 */     // MIs[0] Operand 1
     /* 2266508 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2266513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266521 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2266524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266537 */     // GIR_Coverage, 48733,
     /* 2266537 */     GIR_EraseRootFromParent_Done,
     /* 2266538 */   // Label 30439: @2266538
     /* 2266538 */   GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2266576), // Rule ID 48776 //
     /* 2266543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266546 */     // MIs[0] Operand 1
     /* 2266546 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266559 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266575 */     // GIR_Coverage, 48776,
     /* 2266575 */     GIR_EraseRootFromParent_Done,
     /* 2266576 */   // Label 30440: @2266576
     /* 2266576 */   GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2266614), // Rule ID 48777 //
     /* 2266581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266584 */     // MIs[0] Operand 1
     /* 2266584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2266589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266597 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266613 */     // GIR_Coverage, 48777,
     /* 2266613 */     GIR_EraseRootFromParent_Done,
     /* 2266614 */   // Label 30441: @2266614
     /* 2266614 */   GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2266652), // Rule ID 48820 //
     /* 2266619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266622 */     // MIs[0] Operand 1
     /* 2266622 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266635 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266651 */     // GIR_Coverage, 48820,
     /* 2266651 */     GIR_EraseRootFromParent_Done,
     /* 2266652 */   // Label 30442: @2266652
     /* 2266652 */   GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2266690), // Rule ID 48821 //
     /* 2266657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266660 */     // MIs[0] Operand 1
     /* 2266660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2266665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266673 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2266676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266689 */     // GIR_Coverage, 48821,
     /* 2266689 */     GIR_EraseRootFromParent_Done,
     /* 2266690 */   // Label 30443: @2266690
     /* 2266690 */   GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2266728), // Rule ID 48864 //
     /* 2266695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266698 */     // MIs[0] Operand 1
     /* 2266698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266711 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266727 */     // GIR_Coverage, 48864,
     /* 2266727 */     GIR_EraseRootFromParent_Done,
     /* 2266728 */   // Label 30444: @2266728
     /* 2266728 */   GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2266766), // Rule ID 48865 //
     /* 2266733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266736 */     // MIs[0] Operand 1
     /* 2266736 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2266741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266749 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266765 */     // GIR_Coverage, 48865,
     /* 2266765 */     GIR_EraseRootFromParent_Done,
     /* 2266766 */   // Label 30445: @2266766
     /* 2266766 */   GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2266804), // Rule ID 48908 //
     /* 2266771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266774 */     // MIs[0] Operand 1
     /* 2266774 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266787 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266803 */     // GIR_Coverage, 48908,
     /* 2266803 */     GIR_EraseRootFromParent_Done,
     /* 2266804 */   // Label 30446: @2266804
     /* 2266804 */   GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2266842), // Rule ID 48909 //
     /* 2266809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266812 */     // MIs[0] Operand 1
     /* 2266812 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2266817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266825 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2266828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2266832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266841 */     // GIR_Coverage, 48909,
     /* 2266841 */     GIR_EraseRootFromParent_Done,
     /* 2266842 */   // Label 30447: @2266842
     /* 2266842 */   GIM_Reject,
     /* 2266843 */ // Label 30427: @2266843
     /* 2266843 */ GIM_Reject,
     /* 2266844 */ // Label 29908: @2266844
     /* 2266844 */ GIM_Reject,
     /* 2266845 */ // Label 49: @2266845
     /* 2266845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30456*/ GIMT_Encode4(2274306),
     /* 2266856 */ /*GILLT_s32*//*Label 30448*/ GIMT_Encode4(2266964),
     /* 2266860 */ /*GILLT_s64*//*Label 30449*/ GIMT_Encode4(2267721),
     /* 2266864 */ /*GILLT_nxv1s1*//*Label 30450*/ GIMT_Encode4(2268604), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266884 */ /*GILLT_nxv2s1*//*Label 30451*/ GIMT_Encode4(2269757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266904 */ /*GILLT_nxv4s1*//*Label 30452*/ GIMT_Encode4(2270910), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266924 */ /*GILLT_nxv8s1*//*Label 30453*/ GIMT_Encode4(2272063), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266944 */ /*GILLT_nxv16s1*//*Label 30454*/ GIMT_Encode4(2273216), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266960 */ /*GILLT_nxv32s1*//*Label 30455*/ GIMT_Encode4(2273985),
     /* 2266964 */ // Label 30448: @2266964
     /* 2266964 */ GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2267006), // Rule ID 1366 //
     /* 2266969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266982 */   // MIs[0] Operand 1
     /* 2266982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266995 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2266998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267000 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267005 */   // GIR_Coverage, 1366,
     /* 2267005 */   GIR_EraseRootFromParent_Done,
     /* 2267006 */ // Label 30457: @2267006
     /* 2267006 */ GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2267048), // Rule ID 1370 //
     /* 2267011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267024 */   // MIs[0] Operand 1
     /* 2267024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267037 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2267040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267047 */   // GIR_Coverage, 1370,
     /* 2267047 */   GIR_EraseRootFromParent_Done,
     /* 2267048 */ // Label 30458: @2267048
     /* 2267048 */ GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2267090), // Rule ID 1414 //
     /* 2267053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2267056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267066 */   // MIs[0] Operand 1
     /* 2267066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267079 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2267082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267089 */   // GIR_Coverage, 1414,
     /* 2267089 */   GIR_EraseRootFromParent_Done,
     /* 2267090 */ // Label 30459: @2267090
     /* 2267090 */ GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2267132), // Rule ID 1418 //
     /* 2267095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267108 */   // MIs[0] Operand 1
     /* 2267108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267121 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267128 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267131 */   // GIR_Coverage, 1418,
     /* 2267131 */   GIR_EraseRootFromParent_Done,
     /* 2267132 */ // Label 30460: @2267132
     /* 2267132 */ GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2267174), // Rule ID 1430 //
     /* 2267137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2267140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267150 */   // MIs[0] Operand 1
     /* 2267150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267163 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267173 */   // GIR_Coverage, 1430,
     /* 2267173 */   GIR_EraseRootFromParent_Done,
     /* 2267174 */ // Label 30461: @2267174
     /* 2267174 */ GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2267216), // Rule ID 1434 //
     /* 2267179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2267182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267192 */   // MIs[0] Operand 1
     /* 2267192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267205 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267215 */   // GIR_Coverage, 1434,
     /* 2267215 */   GIR_EraseRootFromParent_Done,
     /* 2267216 */ // Label 30462: @2267216
     /* 2267216 */ GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2267258), // Rule ID 1746 //
     /* 2267221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267234 */   // MIs[0] Operand 1
     /* 2267234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267247 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2267250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267257 */   // GIR_Coverage, 1746,
     /* 2267257 */   GIR_EraseRootFromParent_Done,
     /* 2267258 */ // Label 30463: @2267258
     /* 2267258 */ GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2267300), // Rule ID 1750 //
     /* 2267263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267276 */   // MIs[0] Operand 1
     /* 2267276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267289 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2267292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267296 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267299 */   // GIR_Coverage, 1750,
     /* 2267299 */   GIR_EraseRootFromParent_Done,
     /* 2267300 */ // Label 30464: @2267300
     /* 2267300 */ GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2267342), // Rule ID 1788 //
     /* 2267305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267318 */   // MIs[0] Operand 1
     /* 2267318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267331 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2267334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267336 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267341 */   // GIR_Coverage, 1788,
     /* 2267341 */   GIR_EraseRootFromParent_Done,
     /* 2267342 */ // Label 30465: @2267342
     /* 2267342 */ GIM_Try, /*On fail goto*//*Label 30466*/ GIMT_Encode4(2267384), // Rule ID 1796 //
     /* 2267347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2267350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267360 */   // MIs[0] Operand 1
     /* 2267360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267373 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2267376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267378 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267383 */   // GIR_Coverage, 1796,
     /* 2267383 */   GIR_EraseRootFromParent_Done,
     /* 2267384 */ // Label 30466: @2267384
     /* 2267384 */ GIM_Try, /*On fail goto*//*Label 30467*/ GIMT_Encode4(2267426), // Rule ID 1824 //
     /* 2267389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267402 */   // MIs[0] Operand 1
     /* 2267402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267415 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2267418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267425 */   // GIR_Coverage, 1824,
     /* 2267425 */   GIR_EraseRootFromParent_Done,
     /* 2267426 */ // Label 30467: @2267426
     /* 2267426 */ GIM_Try, /*On fail goto*//*Label 30468*/ GIMT_Encode4(2267468), // Rule ID 1832 //
     /* 2267431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2267434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267444 */   // MIs[0] Operand 1
     /* 2267444 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267453 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267457 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2267460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267462 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267464 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267467 */   // GIR_Coverage, 1832,
     /* 2267467 */   GIR_EraseRootFromParent_Done,
     /* 2267468 */ // Label 30468: @2267468
     /* 2267468 */ GIM_Try, /*On fail goto*//*Label 30469*/ GIMT_Encode4(2267510), // Rule ID 2079 //
     /* 2267473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267486 */   // MIs[0] Operand 1
     /* 2267486 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267495 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267499 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2267502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267504 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267506 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267509 */   // GIR_Coverage, 2079,
     /* 2267509 */   GIR_EraseRootFromParent_Done,
     /* 2267510 */ // Label 30469: @2267510
     /* 2267510 */ GIM_Try, /*On fail goto*//*Label 30470*/ GIMT_Encode4(2267552), // Rule ID 2083 //
     /* 2267515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267528 */   // MIs[0] Operand 1
     /* 2267528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267541 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2267544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267546 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267551 */   // GIR_Coverage, 2083,
     /* 2267551 */   GIR_EraseRootFromParent_Done,
     /* 2267552 */ // Label 30470: @2267552
     /* 2267552 */ GIM_Try, /*On fail goto*//*Label 30471*/ GIMT_Encode4(2267594), // Rule ID 2127 //
     /* 2267557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267570 */   // MIs[0] Operand 1
     /* 2267570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267583 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2267586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267593 */   // GIR_Coverage, 2127,
     /* 2267593 */   GIR_EraseRootFromParent_Done,
     /* 2267594 */ // Label 30471: @2267594
     /* 2267594 */ GIM_Try, /*On fail goto*//*Label 30472*/ GIMT_Encode4(2267636), // Rule ID 2131 //
     /* 2267599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267612 */   // MIs[0] Operand 1
     /* 2267612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267625 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2267628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267635 */   // GIR_Coverage, 2131,
     /* 2267635 */   GIR_EraseRootFromParent_Done,
     /* 2267636 */ // Label 30472: @2267636
     /* 2267636 */ GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2267678), // Rule ID 2143 //
     /* 2267641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2267644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267654 */   // MIs[0] Operand 1
     /* 2267654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267667 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2267670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267674 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267677 */   // GIR_Coverage, 2143,
     /* 2267677 */   GIR_EraseRootFromParent_Done,
     /* 2267678 */ // Label 30473: @2267678
     /* 2267678 */ GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2267720), // Rule ID 2147 //
     /* 2267683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2267686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267696 */   // MIs[0] Operand 1
     /* 2267696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267709 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2267712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267719 */   // GIR_Coverage, 2147,
     /* 2267719 */   GIR_EraseRootFromParent_Done,
     /* 2267720 */ // Label 30474: @2267720
     /* 2267720 */ GIM_Reject,
     /* 2267721 */ // Label 30449: @2267721
     /* 2267721 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2267763), // Rule ID 1365 //
     /* 2267726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267739 */   // MIs[0] Operand 1
     /* 2267739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267752 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2267755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267762 */   // GIR_Coverage, 1365,
     /* 2267762 */   GIR_EraseRootFromParent_Done,
     /* 2267763 */ // Label 30475: @2267763
     /* 2267763 */ GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2267805), // Rule ID 1369 //
     /* 2267768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267781 */   // MIs[0] Operand 1
     /* 2267781 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267790 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267794 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2267797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267799 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267804 */   // GIR_Coverage, 1369,
     /* 2267804 */   GIR_EraseRootFromParent_Done,
     /* 2267805 */ // Label 30476: @2267805
     /* 2267805 */ GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2267847), // Rule ID 1413 //
     /* 2267810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267823 */   // MIs[0] Operand 1
     /* 2267823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267836 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2267839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267841 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267843 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267846 */   // GIR_Coverage, 1413,
     /* 2267846 */   GIR_EraseRootFromParent_Done,
     /* 2267847 */ // Label 30477: @2267847
     /* 2267847 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2267889), // Rule ID 1417 //
     /* 2267852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267865 */   // MIs[0] Operand 1
     /* 2267865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267878 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267887 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267888 */   // GIR_Coverage, 1417,
     /* 2267888 */   GIR_EraseRootFromParent_Done,
     /* 2267889 */ // Label 30478: @2267889
     /* 2267889 */ GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2267931), // Rule ID 1429 //
     /* 2267894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267907 */   // MIs[0] Operand 1
     /* 2267907 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267916 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267920 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267925 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267927 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267930 */   // GIR_Coverage, 1429,
     /* 2267930 */   GIR_EraseRootFromParent_Done,
     /* 2267931 */ // Label 30479: @2267931
     /* 2267931 */ GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2267973), // Rule ID 1433 //
     /* 2267936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267942 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267949 */   // MIs[0] Operand 1
     /* 2267949 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267958 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267962 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267967 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267969 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267972 */   // GIR_Coverage, 1433,
     /* 2267972 */   GIR_EraseRootFromParent_Done,
     /* 2267973 */ // Label 30480: @2267973
     /* 2267973 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2268015), // Rule ID 1745 //
     /* 2267978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267991 */   // MIs[0] Operand 1
     /* 2267991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268004 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2268007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268014 */   // GIR_Coverage, 1745,
     /* 2268014 */   GIR_EraseRootFromParent_Done,
     /* 2268015 */ // Label 30481: @2268015
     /* 2268015 */ GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2268057), // Rule ID 1749 //
     /* 2268020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268033 */   // MIs[0] Operand 1
     /* 2268033 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268042 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268046 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2268049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268056 */   // GIR_Coverage, 1749,
     /* 2268056 */   GIR_EraseRootFromParent_Done,
     /* 2268057 */ // Label 30482: @2268057
     /* 2268057 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2268099), // Rule ID 1752 //
     /* 2268062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268075 */   // MIs[0] Operand 1
     /* 2268075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268088 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2268091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268093 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268095 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268098 */   // GIR_Coverage, 1752,
     /* 2268098 */   GIR_EraseRootFromParent_Done,
     /* 2268099 */ // Label 30483: @2268099
     /* 2268099 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2268141), // Rule ID 1787 //
     /* 2268104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2268107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268117 */   // MIs[0] Operand 1
     /* 2268117 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268130 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2268133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268137 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268140 */   // GIR_Coverage, 1787,
     /* 2268140 */   GIR_EraseRootFromParent_Done,
     /* 2268141 */ // Label 30484: @2268141
     /* 2268141 */ GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2268183), // Rule ID 1795 //
     /* 2268146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2268149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268159 */   // MIs[0] Operand 1
     /* 2268159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2268172 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2268175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268182 */   // GIR_Coverage, 1795,
     /* 2268182 */   GIR_EraseRootFromParent_Done,
     /* 2268183 */ // Label 30485: @2268183
     /* 2268183 */ GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2268225), // Rule ID 1804 //
     /* 2268188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268201 */   // MIs[0] Operand 1
     /* 2268201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268214 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2268217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268224 */   // GIR_Coverage, 1804,
     /* 2268224 */   GIR_EraseRootFromParent_Done,
     /* 2268225 */ // Label 30486: @2268225
     /* 2268225 */ GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2268267), // Rule ID 1808 //
     /* 2268230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2268233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268243 */   // MIs[0] Operand 1
     /* 2268243 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268256 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2268259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268261 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268263 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268266 */   // GIR_Coverage, 1808,
     /* 2268266 */   GIR_EraseRootFromParent_Done,
     /* 2268267 */ // Label 30487: @2268267
     /* 2268267 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2268309), // Rule ID 1823 //
     /* 2268272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268285 */   // MIs[0] Operand 1
     /* 2268285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268294 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268298 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2268301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268303 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268308 */   // GIR_Coverage, 1823,
     /* 2268308 */   GIR_EraseRootFromParent_Done,
     /* 2268309 */ // Label 30488: @2268309
     /* 2268309 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2268351), // Rule ID 1831 //
     /* 2268314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2268317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2268323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268327 */   // MIs[0] Operand 1
     /* 2268327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2268340 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2268340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2268343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268350 */   // GIR_Coverage, 1831,
     /* 2268350 */   GIR_EraseRootFromParent_Done,
     /* 2268351 */ // Label 30489: @2268351
     /* 2268351 */ GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2268393), // Rule ID 2078 //
     /* 2268356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268369 */   // MIs[0] Operand 1
     /* 2268369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268382 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2268385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268392 */   // GIR_Coverage, 2078,
     /* 2268392 */   GIR_EraseRootFromParent_Done,
     /* 2268393 */ // Label 30490: @2268393
     /* 2268393 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2268435), // Rule ID 2082 //
     /* 2268398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268411 */   // MIs[0] Operand 1
     /* 2268411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268424 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2268427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268434 */   // GIR_Coverage, 2082,
     /* 2268434 */   GIR_EraseRootFromParent_Done,
     /* 2268435 */ // Label 30491: @2268435
     /* 2268435 */ GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2268477), // Rule ID 2126 //
     /* 2268440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268453 */   // MIs[0] Operand 1
     /* 2268453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268462 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268466 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2268469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268476 */   // GIR_Coverage, 2126,
     /* 2268476 */   GIR_EraseRootFromParent_Done,
     /* 2268477 */ // Label 30492: @2268477
     /* 2268477 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2268519), // Rule ID 2130 //
     /* 2268482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268495 */   // MIs[0] Operand 1
     /* 2268495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268508 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2268511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268518 */   // GIR_Coverage, 2130,
     /* 2268518 */   GIR_EraseRootFromParent_Done,
     /* 2268519 */ // Label 30493: @2268519
     /* 2268519 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2268561), // Rule ID 2142 //
     /* 2268524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2268527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268537 */   // MIs[0] Operand 1
     /* 2268537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2268550 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2268553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268560 */   // GIR_Coverage, 2142,
     /* 2268560 */   GIR_EraseRootFromParent_Done,
     /* 2268561 */ // Label 30494: @2268561
     /* 2268561 */ GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2268603), // Rule ID 2146 //
     /* 2268566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2268569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2268572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2268575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268579 */   // MIs[0] Operand 1
     /* 2268579 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2268592 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2268592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2268595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268597 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268599 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268602 */   // GIR_Coverage, 2146,
     /* 2268602 */   GIR_EraseRootFromParent_Done,
     /* 2268603 */ // Label 30495: @2268603
     /* 2268603 */ GIM_Reject,
     /* 2268604 */ // Label 30450: @2268604
     /* 2268604 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2268652), // Rule ID 57034 //
     /* 2268609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268622 */   // MIs[0] Operand 1
     /* 2268622 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268631 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268635 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268651 */   // GIR_Coverage, 57034,
     /* 2268651 */   GIR_EraseRootFromParent_Done,
     /* 2268652 */ // Label 30496: @2268652
     /* 2268652 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2268700), // Rule ID 57035 //
     /* 2268657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268670 */   // MIs[0] Operand 1
     /* 2268670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268683 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2268686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268699 */   // GIR_Coverage, 57035,
     /* 2268699 */   GIR_EraseRootFromParent_Done,
     /* 2268700 */ // Label 30497: @2268700
     /* 2268700 */ GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2268748), // Rule ID 57054 //
     /* 2268705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268718 */   // MIs[0] Operand 1
     /* 2268718 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268727 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268731 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268736 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268738 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268747 */   // GIR_Coverage, 57054,
     /* 2268747 */   GIR_EraseRootFromParent_Done,
     /* 2268748 */ // Label 30498: @2268748
     /* 2268748 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2268796), // Rule ID 57055 //
     /* 2268753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268766 */   // MIs[0] Operand 1
     /* 2268766 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268775 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268779 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268784 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268786 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268795 */   // GIR_Coverage, 57055,
     /* 2268795 */   GIR_EraseRootFromParent_Done,
     /* 2268796 */ // Label 30499: @2268796
     /* 2268796 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2268844), // Rule ID 57084 //
     /* 2268801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268814 */   // MIs[0] Operand 1
     /* 2268814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268827 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268832 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268834 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268843 */   // GIR_Coverage, 57084,
     /* 2268843 */   GIR_EraseRootFromParent_Done,
     /* 2268844 */ // Label 30500: @2268844
     /* 2268844 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2268892), // Rule ID 57085 //
     /* 2268849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268862 */   // MIs[0] Operand 1
     /* 2268862 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268875 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2268878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268880 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268882 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268891 */   // GIR_Coverage, 57085,
     /* 2268891 */   GIR_EraseRootFromParent_Done,
     /* 2268892 */ // Label 30501: @2268892
     /* 2268892 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2268940), // Rule ID 57334 //
     /* 2268897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268910 */   // MIs[0] Operand 1
     /* 2268910 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268919 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268923 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268930 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268939 */   // GIR_Coverage, 57334,
     /* 2268939 */   GIR_EraseRootFromParent_Done,
     /* 2268940 */ // Label 30502: @2268940
     /* 2268940 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2268988), // Rule ID 57335 //
     /* 2268945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268958 */   // MIs[0] Operand 1
     /* 2268958 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268967 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268971 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268976 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268978 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268987 */   // GIR_Coverage, 57335,
     /* 2268987 */   GIR_EraseRootFromParent_Done,
     /* 2268988 */ // Label 30503: @2268988
     /* 2268988 */ GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2269036), // Rule ID 57354 //
     /* 2268993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269006 */   // MIs[0] Operand 1
     /* 2269006 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269015 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269019 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269026 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269035 */   // GIR_Coverage, 57354,
     /* 2269035 */   GIR_EraseRootFromParent_Done,
     /* 2269036 */ // Label 30504: @2269036
     /* 2269036 */ GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2269084), // Rule ID 57355 //
     /* 2269041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269054 */   // MIs[0] Operand 1
     /* 2269054 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269063 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269067 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269072 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269074 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269083 */   // GIR_Coverage, 57355,
     /* 2269083 */   GIR_EraseRootFromParent_Done,
     /* 2269084 */ // Label 30505: @2269084
     /* 2269084 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2269132), // Rule ID 57384 //
     /* 2269089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269102 */   // MIs[0] Operand 1
     /* 2269102 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269111 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269115 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269120 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269122 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269131 */   // GIR_Coverage, 57384,
     /* 2269131 */   GIR_EraseRootFromParent_Done,
     /* 2269132 */ // Label 30506: @2269132
     /* 2269132 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2269180), // Rule ID 57385 //
     /* 2269137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269150 */   // MIs[0] Operand 1
     /* 2269150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269163 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269179 */   // GIR_Coverage, 57385,
     /* 2269179 */   GIR_EraseRootFromParent_Done,
     /* 2269180 */ // Label 30507: @2269180
     /* 2269180 */ GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2269228), // Rule ID 57634 //
     /* 2269185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269198 */   // MIs[0] Operand 1
     /* 2269198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269211 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2269214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269227 */   // GIR_Coverage, 57634,
     /* 2269227 */   GIR_EraseRootFromParent_Done,
     /* 2269228 */ // Label 30508: @2269228
     /* 2269228 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2269276), // Rule ID 57635 //
     /* 2269233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269246 */   // MIs[0] Operand 1
     /* 2269246 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269259 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2269262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269275 */   // GIR_Coverage, 57635,
     /* 2269275 */   GIR_EraseRootFromParent_Done,
     /* 2269276 */ // Label 30509: @2269276
     /* 2269276 */ GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2269324), // Rule ID 57654 //
     /* 2269281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269294 */   // MIs[0] Operand 1
     /* 2269294 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269307 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269312 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269323 */   // GIR_Coverage, 57654,
     /* 2269323 */   GIR_EraseRootFromParent_Done,
     /* 2269324 */ // Label 30510: @2269324
     /* 2269324 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2269372), // Rule ID 57655 //
     /* 2269329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269342 */   // MIs[0] Operand 1
     /* 2269342 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269351 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269355 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269360 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269362 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269371 */   // GIR_Coverage, 57655,
     /* 2269371 */   GIR_EraseRootFromParent_Done,
     /* 2269372 */ // Label 30511: @2269372
     /* 2269372 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2269420), // Rule ID 57684 //
     /* 2269377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269390 */   // MIs[0] Operand 1
     /* 2269390 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269403 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269408 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269410 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269419 */   // GIR_Coverage, 57684,
     /* 2269419 */   GIR_EraseRootFromParent_Done,
     /* 2269420 */ // Label 30512: @2269420
     /* 2269420 */ GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2269468), // Rule ID 57685 //
     /* 2269425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269438 */   // MIs[0] Operand 1
     /* 2269438 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269447 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269451 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269456 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269458 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269467 */   // GIR_Coverage, 57685,
     /* 2269467 */   GIR_EraseRootFromParent_Done,
     /* 2269468 */ // Label 30513: @2269468
     /* 2269468 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2269516), // Rule ID 57934 //
     /* 2269473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269486 */   // MIs[0] Operand 1
     /* 2269486 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269495 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269499 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269504 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269506 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269515 */   // GIR_Coverage, 57934,
     /* 2269515 */   GIR_EraseRootFromParent_Done,
     /* 2269516 */ // Label 30514: @2269516
     /* 2269516 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2269564), // Rule ID 57935 //
     /* 2269521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2269530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269534 */   // MIs[0] Operand 1
     /* 2269534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269547 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2269550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269552 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269554 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269563 */   // GIR_Coverage, 57935,
     /* 2269563 */   GIR_EraseRootFromParent_Done,
     /* 2269564 */ // Label 30515: @2269564
     /* 2269564 */ GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2269612), // Rule ID 57954 //
     /* 2269569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269582 */   // MIs[0] Operand 1
     /* 2269582 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269591 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269595 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269600 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269602 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269611 */   // GIR_Coverage, 57954,
     /* 2269611 */   GIR_EraseRootFromParent_Done,
     /* 2269612 */ // Label 30516: @2269612
     /* 2269612 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2269660), // Rule ID 57955 //
     /* 2269617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2269626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269630 */   // MIs[0] Operand 1
     /* 2269630 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269639 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269643 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269648 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269650 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269659 */   // GIR_Coverage, 57955,
     /* 2269659 */   GIR_EraseRootFromParent_Done,
     /* 2269660 */ // Label 30517: @2269660
     /* 2269660 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2269708), // Rule ID 57984 //
     /* 2269665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269678 */   // MIs[0] Operand 1
     /* 2269678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269691 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269696 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269698 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269707 */   // GIR_Coverage, 57984,
     /* 2269707 */   GIR_EraseRootFromParent_Done,
     /* 2269708 */ // Label 30518: @2269708
     /* 2269708 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2269756), // Rule ID 57985 //
     /* 2269713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2269722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269726 */   // MIs[0] Operand 1
     /* 2269726 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269735 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269739 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269744 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269746 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269755 */   // GIR_Coverage, 57985,
     /* 2269755 */   GIR_EraseRootFromParent_Done,
     /* 2269756 */ // Label 30519: @2269756
     /* 2269756 */ GIM_Reject,
     /* 2269757 */ // Label 30451: @2269757
     /* 2269757 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2269805), // Rule ID 57044 //
     /* 2269762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269775 */   // MIs[0] Operand 1
     /* 2269775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269788 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269793 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269795 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269804 */   // GIR_Coverage, 57044,
     /* 2269804 */   GIR_EraseRootFromParent_Done,
     /* 2269805 */ // Label 30520: @2269805
     /* 2269805 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2269853), // Rule ID 57045 //
     /* 2269810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269823 */   // MIs[0] Operand 1
     /* 2269823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269836 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2269839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269841 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269843 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269852 */   // GIR_Coverage, 57045,
     /* 2269852 */   GIR_EraseRootFromParent_Done,
     /* 2269853 */ // Label 30521: @2269853
     /* 2269853 */ GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2269901), // Rule ID 57074 //
     /* 2269858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269871 */   // MIs[0] Operand 1
     /* 2269871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269884 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269889 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269900 */   // GIR_Coverage, 57074,
     /* 2269900 */   GIR_EraseRootFromParent_Done,
     /* 2269901 */ // Label 30522: @2269901
     /* 2269901 */ GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2269949), // Rule ID 57075 //
     /* 2269906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269919 */   // MIs[0] Operand 1
     /* 2269919 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269928 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269932 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269937 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269948 */   // GIR_Coverage, 57075,
     /* 2269948 */   GIR_EraseRootFromParent_Done,
     /* 2269949 */ // Label 30523: @2269949
     /* 2269949 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2269997), // Rule ID 57154 //
     /* 2269954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269967 */   // MIs[0] Operand 1
     /* 2269967 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269980 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269985 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269996 */   // GIR_Coverage, 57154,
     /* 2269996 */   GIR_EraseRootFromParent_Done,
     /* 2269997 */ // Label 30524: @2269997
     /* 2269997 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2270045), // Rule ID 57155 //
     /* 2270002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270015 */   // MIs[0] Operand 1
     /* 2270015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270028 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270033 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270044 */   // GIR_Coverage, 57155,
     /* 2270044 */   GIR_EraseRootFromParent_Done,
     /* 2270045 */ // Label 30525: @2270045
     /* 2270045 */ GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2270093), // Rule ID 57344 //
     /* 2270050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270056 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270063 */   // MIs[0] Operand 1
     /* 2270063 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270072 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270076 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2270079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270081 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270083 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270092 */   // GIR_Coverage, 57344,
     /* 2270092 */   GIR_EraseRootFromParent_Done,
     /* 2270093 */ // Label 30526: @2270093
     /* 2270093 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2270141), // Rule ID 57345 //
     /* 2270098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270111 */   // MIs[0] Operand 1
     /* 2270111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270124 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2270127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270129 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270140 */   // GIR_Coverage, 57345,
     /* 2270140 */   GIR_EraseRootFromParent_Done,
     /* 2270141 */ // Label 30527: @2270141
     /* 2270141 */ GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2270189), // Rule ID 57374 //
     /* 2270146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270159 */   // MIs[0] Operand 1
     /* 2270159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270172 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270188 */   // GIR_Coverage, 57374,
     /* 2270188 */   GIR_EraseRootFromParent_Done,
     /* 2270189 */ // Label 30528: @2270189
     /* 2270189 */ GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2270237), // Rule ID 57375 //
     /* 2270194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270207 */   // MIs[0] Operand 1
     /* 2270207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270220 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270225 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270236 */   // GIR_Coverage, 57375,
     /* 2270236 */   GIR_EraseRootFromParent_Done,
     /* 2270237 */ // Label 30529: @2270237
     /* 2270237 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2270285), // Rule ID 57454 //
     /* 2270242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270255 */   // MIs[0] Operand 1
     /* 2270255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270268 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270273 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270284 */   // GIR_Coverage, 57454,
     /* 2270284 */   GIR_EraseRootFromParent_Done,
     /* 2270285 */ // Label 30530: @2270285
     /* 2270285 */ GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2270333), // Rule ID 57455 //
     /* 2270290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270303 */   // MIs[0] Operand 1
     /* 2270303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270316 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270321 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270323 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270332 */   // GIR_Coverage, 57455,
     /* 2270332 */   GIR_EraseRootFromParent_Done,
     /* 2270333 */ // Label 30531: @2270333
     /* 2270333 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2270381), // Rule ID 57644 //
     /* 2270338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270351 */   // MIs[0] Operand 1
     /* 2270351 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270364 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2270367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270369 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270380 */   // GIR_Coverage, 57644,
     /* 2270380 */   GIR_EraseRootFromParent_Done,
     /* 2270381 */ // Label 30532: @2270381
     /* 2270381 */ GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2270429), // Rule ID 57645 //
     /* 2270386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270399 */   // MIs[0] Operand 1
     /* 2270399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270412 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2270415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270428 */   // GIR_Coverage, 57645,
     /* 2270428 */   GIR_EraseRootFromParent_Done,
     /* 2270429 */ // Label 30533: @2270429
     /* 2270429 */ GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2270477), // Rule ID 57674 //
     /* 2270434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270447 */   // MIs[0] Operand 1
     /* 2270447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270460 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270476 */   // GIR_Coverage, 57674,
     /* 2270476 */   GIR_EraseRootFromParent_Done,
     /* 2270477 */ // Label 30534: @2270477
     /* 2270477 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2270525), // Rule ID 57675 //
     /* 2270482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270495 */   // MIs[0] Operand 1
     /* 2270495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270508 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270524 */   // GIR_Coverage, 57675,
     /* 2270524 */   GIR_EraseRootFromParent_Done,
     /* 2270525 */ // Label 30535: @2270525
     /* 2270525 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2270573), // Rule ID 57754 //
     /* 2270530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270543 */   // MIs[0] Operand 1
     /* 2270543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270556 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270572 */   // GIR_Coverage, 57754,
     /* 2270572 */   GIR_EraseRootFromParent_Done,
     /* 2270573 */ // Label 30536: @2270573
     /* 2270573 */ GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2270621), // Rule ID 57755 //
     /* 2270578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270591 */   // MIs[0] Operand 1
     /* 2270591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270604 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270609 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270611 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270620 */   // GIR_Coverage, 57755,
     /* 2270620 */   GIR_EraseRootFromParent_Done,
     /* 2270621 */ // Label 30537: @2270621
     /* 2270621 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2270669), // Rule ID 57944 //
     /* 2270626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270639 */   // MIs[0] Operand 1
     /* 2270639 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270652 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270657 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270659 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270668 */   // GIR_Coverage, 57944,
     /* 2270668 */   GIR_EraseRootFromParent_Done,
     /* 2270669 */ // Label 30538: @2270669
     /* 2270669 */ GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2270717), // Rule ID 57945 //
     /* 2270674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2270683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270687 */   // MIs[0] Operand 1
     /* 2270687 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270696 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270700 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2270703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270705 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270707 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270716 */   // GIR_Coverage, 57945,
     /* 2270716 */   GIR_EraseRootFromParent_Done,
     /* 2270717 */ // Label 30539: @2270717
     /* 2270717 */ GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2270765), // Rule ID 57974 //
     /* 2270722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270735 */   // MIs[0] Operand 1
     /* 2270735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270748 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270753 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270755 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270764 */   // GIR_Coverage, 57974,
     /* 2270764 */   GIR_EraseRootFromParent_Done,
     /* 2270765 */ // Label 30540: @2270765
     /* 2270765 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2270813), // Rule ID 57975 //
     /* 2270770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2270779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270783 */   // MIs[0] Operand 1
     /* 2270783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270796 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270801 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270812 */   // GIR_Coverage, 57975,
     /* 2270812 */   GIR_EraseRootFromParent_Done,
     /* 2270813 */ // Label 30541: @2270813
     /* 2270813 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2270861), // Rule ID 58054 //
     /* 2270818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270831 */   // MIs[0] Operand 1
     /* 2270831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270844 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270849 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270860 */   // GIR_Coverage, 58054,
     /* 2270860 */   GIR_EraseRootFromParent_Done,
     /* 2270861 */ // Label 30542: @2270861
     /* 2270861 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2270909), // Rule ID 58055 //
     /* 2270866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2270875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270879 */   // MIs[0] Operand 1
     /* 2270879 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270888 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270892 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270897 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270899 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270908 */   // GIR_Coverage, 58055,
     /* 2270908 */   GIR_EraseRootFromParent_Done,
     /* 2270909 */ // Label 30543: @2270909
     /* 2270909 */ GIM_Reject,
     /* 2270910 */ // Label 30452: @2270910
     /* 2270910 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2270958), // Rule ID 57064 //
     /* 2270915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270928 */   // MIs[0] Operand 1
     /* 2270928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270941 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270957 */   // GIR_Coverage, 57064,
     /* 2270957 */   GIR_EraseRootFromParent_Done,
     /* 2270958 */ // Label 30544: @2270958
     /* 2270958 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2271006), // Rule ID 57065 //
     /* 2270963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270976 */   // MIs[0] Operand 1
     /* 2270976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270989 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271005 */   // GIR_Coverage, 57065,
     /* 2271005 */   GIR_EraseRootFromParent_Done,
     /* 2271006 */ // Label 30545: @2271006
     /* 2271006 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2271054), // Rule ID 57124 //
     /* 2271011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271024 */   // MIs[0] Operand 1
     /* 2271024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271037 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271053 */   // GIR_Coverage, 57124,
     /* 2271053 */   GIR_EraseRootFromParent_Done,
     /* 2271054 */ // Label 30546: @2271054
     /* 2271054 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2271102), // Rule ID 57125 //
     /* 2271059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271072 */   // MIs[0] Operand 1
     /* 2271072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271085 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271092 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271101 */   // GIR_Coverage, 57125,
     /* 2271101 */   GIR_EraseRootFromParent_Done,
     /* 2271102 */ // Label 30547: @2271102
     /* 2271102 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2271150), // Rule ID 57164 //
     /* 2271107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271120 */   // MIs[0] Operand 1
     /* 2271120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271133 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271138 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271140 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271149 */   // GIR_Coverage, 57164,
     /* 2271149 */   GIR_EraseRootFromParent_Done,
     /* 2271150 */ // Label 30548: @2271150
     /* 2271150 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2271198), // Rule ID 57165 //
     /* 2271155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271168 */   // MIs[0] Operand 1
     /* 2271168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271181 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271188 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271197 */   // GIR_Coverage, 57165,
     /* 2271197 */   GIR_EraseRootFromParent_Done,
     /* 2271198 */ // Label 30549: @2271198
     /* 2271198 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2271246), // Rule ID 57364 //
     /* 2271203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271216 */   // MIs[0] Operand 1
     /* 2271216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271229 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2271232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271236 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271245 */   // GIR_Coverage, 57364,
     /* 2271245 */   GIR_EraseRootFromParent_Done,
     /* 2271246 */ // Label 30550: @2271246
     /* 2271246 */ GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2271294), // Rule ID 57365 //
     /* 2271251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271264 */   // MIs[0] Operand 1
     /* 2271264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271277 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2271280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271284 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271293 */   // GIR_Coverage, 57365,
     /* 2271293 */   GIR_EraseRootFromParent_Done,
     /* 2271294 */ // Label 30551: @2271294
     /* 2271294 */ GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2271342), // Rule ID 57424 //
     /* 2271299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271312 */   // MIs[0] Operand 1
     /* 2271312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271325 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271341 */   // GIR_Coverage, 57424,
     /* 2271341 */   GIR_EraseRootFromParent_Done,
     /* 2271342 */ // Label 30552: @2271342
     /* 2271342 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2271390), // Rule ID 57425 //
     /* 2271347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271360 */   // MIs[0] Operand 1
     /* 2271360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271373 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271378 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271389 */   // GIR_Coverage, 57425,
     /* 2271389 */   GIR_EraseRootFromParent_Done,
     /* 2271390 */ // Label 30553: @2271390
     /* 2271390 */ GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2271438), // Rule ID 57464 //
     /* 2271395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271408 */   // MIs[0] Operand 1
     /* 2271408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271421 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271437 */   // GIR_Coverage, 57464,
     /* 2271437 */   GIR_EraseRootFromParent_Done,
     /* 2271438 */ // Label 30554: @2271438
     /* 2271438 */ GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2271486), // Rule ID 57465 //
     /* 2271443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271456 */   // MIs[0] Operand 1
     /* 2271456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271469 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271485 */   // GIR_Coverage, 57465,
     /* 2271485 */   GIR_EraseRootFromParent_Done,
     /* 2271486 */ // Label 30555: @2271486
     /* 2271486 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2271534), // Rule ID 57664 //
     /* 2271491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271504 */   // MIs[0] Operand 1
     /* 2271504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271517 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271522 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271533 */   // GIR_Coverage, 57664,
     /* 2271533 */   GIR_EraseRootFromParent_Done,
     /* 2271534 */ // Label 30556: @2271534
     /* 2271534 */ GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2271582), // Rule ID 57665 //
     /* 2271539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271552 */   // MIs[0] Operand 1
     /* 2271552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271565 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2271568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271581 */   // GIR_Coverage, 57665,
     /* 2271581 */   GIR_EraseRootFromParent_Done,
     /* 2271582 */ // Label 30557: @2271582
     /* 2271582 */ GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2271630), // Rule ID 57724 //
     /* 2271587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271600 */   // MIs[0] Operand 1
     /* 2271600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271613 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271629 */   // GIR_Coverage, 57724,
     /* 2271629 */   GIR_EraseRootFromParent_Done,
     /* 2271630 */ // Label 30558: @2271630
     /* 2271630 */ GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2271678), // Rule ID 57725 //
     /* 2271635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271648 */   // MIs[0] Operand 1
     /* 2271648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271661 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271677 */   // GIR_Coverage, 57725,
     /* 2271677 */   GIR_EraseRootFromParent_Done,
     /* 2271678 */ // Label 30559: @2271678
     /* 2271678 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2271726), // Rule ID 57764 //
     /* 2271683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271696 */   // MIs[0] Operand 1
     /* 2271696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271709 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271725 */   // GIR_Coverage, 57764,
     /* 2271725 */   GIR_EraseRootFromParent_Done,
     /* 2271726 */ // Label 30560: @2271726
     /* 2271726 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2271774), // Rule ID 57765 //
     /* 2271731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271744 */   // MIs[0] Operand 1
     /* 2271744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271757 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271773 */   // GIR_Coverage, 57765,
     /* 2271773 */   GIR_EraseRootFromParent_Done,
     /* 2271774 */ // Label 30561: @2271774
     /* 2271774 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2271822), // Rule ID 57964 //
     /* 2271779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271792 */   // MIs[0] Operand 1
     /* 2271792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271805 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271821 */   // GIR_Coverage, 57964,
     /* 2271821 */   GIR_EraseRootFromParent_Done,
     /* 2271822 */ // Label 30562: @2271822
     /* 2271822 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2271870), // Rule ID 57965 //
     /* 2271827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2271833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2271836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271840 */   // MIs[0] Operand 1
     /* 2271840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271853 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2271856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271858 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271860 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271869 */   // GIR_Coverage, 57965,
     /* 2271869 */   GIR_EraseRootFromParent_Done,
     /* 2271870 */ // Label 30563: @2271870
     /* 2271870 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2271918), // Rule ID 58024 //
     /* 2271875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271888 */   // MIs[0] Operand 1
     /* 2271888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271901 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271906 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271908 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271917 */   // GIR_Coverage, 58024,
     /* 2271917 */   GIR_EraseRootFromParent_Done,
     /* 2271918 */ // Label 30564: @2271918
     /* 2271918 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2271966), // Rule ID 58025 //
     /* 2271923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271936 */   // MIs[0] Operand 1
     /* 2271936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271949 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271965 */   // GIR_Coverage, 58025,
     /* 2271965 */   GIR_EraseRootFromParent_Done,
     /* 2271966 */ // Label 30565: @2271966
     /* 2271966 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2272014), // Rule ID 58064 //
     /* 2271971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271984 */   // MIs[0] Operand 1
     /* 2271984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271997 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272013 */   // GIR_Coverage, 58064,
     /* 2272013 */   GIR_EraseRootFromParent_Done,
     /* 2272014 */ // Label 30566: @2272014
     /* 2272014 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2272062), // Rule ID 58065 //
     /* 2272019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2272025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2272028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272032 */   // MIs[0] Operand 1
     /* 2272032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272045 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272061 */   // GIR_Coverage, 58065,
     /* 2272061 */   GIR_EraseRootFromParent_Done,
     /* 2272062 */ // Label 30567: @2272062
     /* 2272062 */ GIM_Reject,
     /* 2272063 */ // Label 30453: @2272063
     /* 2272063 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2272111), // Rule ID 57094 //
     /* 2272068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272081 */   // MIs[0] Operand 1
     /* 2272081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272090 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272094 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272110 */   // GIR_Coverage, 57094,
     /* 2272110 */   GIR_EraseRootFromParent_Done,
     /* 2272111 */ // Label 30568: @2272111
     /* 2272111 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2272159), // Rule ID 57095 //
     /* 2272116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272129 */   // MIs[0] Operand 1
     /* 2272129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272142 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2272145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272158 */   // GIR_Coverage, 57095,
     /* 2272158 */   GIR_EraseRootFromParent_Done,
     /* 2272159 */ // Label 30569: @2272159
     /* 2272159 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2272207), // Rule ID 57134 //
     /* 2272164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272177 */   // MIs[0] Operand 1
     /* 2272177 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272190 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272197 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272206 */   // GIR_Coverage, 57134,
     /* 2272206 */   GIR_EraseRootFromParent_Done,
     /* 2272207 */ // Label 30570: @2272207
     /* 2272207 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2272255), // Rule ID 57135 //
     /* 2272212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272225 */   // MIs[0] Operand 1
     /* 2272225 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272234 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272238 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272245 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272254 */   // GIR_Coverage, 57135,
     /* 2272254 */   GIR_EraseRootFromParent_Done,
     /* 2272255 */ // Label 30571: @2272255
     /* 2272255 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2272303), // Rule ID 57174 //
     /* 2272260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272266 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272273 */   // MIs[0] Operand 1
     /* 2272273 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272282 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272286 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272291 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272293 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272302 */   // GIR_Coverage, 57174,
     /* 2272302 */   GIR_EraseRootFromParent_Done,
     /* 2272303 */ // Label 30572: @2272303
     /* 2272303 */ GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2272351), // Rule ID 57175 //
     /* 2272308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272321 */   // MIs[0] Operand 1
     /* 2272321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272334 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272350 */   // GIR_Coverage, 57175,
     /* 2272350 */   GIR_EraseRootFromParent_Done,
     /* 2272351 */ // Label 30573: @2272351
     /* 2272351 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2272399), // Rule ID 57394 //
     /* 2272356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272369 */   // MIs[0] Operand 1
     /* 2272369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272382 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2272385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272387 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272389 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272398 */   // GIR_Coverage, 57394,
     /* 2272398 */   GIR_EraseRootFromParent_Done,
     /* 2272399 */ // Label 30574: @2272399
     /* 2272399 */ GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2272447), // Rule ID 57395 //
     /* 2272404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272417 */   // MIs[0] Operand 1
     /* 2272417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272430 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2272433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272446 */   // GIR_Coverage, 57395,
     /* 2272446 */   GIR_EraseRootFromParent_Done,
     /* 2272447 */ // Label 30575: @2272447
     /* 2272447 */ GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2272495), // Rule ID 57434 //
     /* 2272452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272465 */   // MIs[0] Operand 1
     /* 2272465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272478 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272483 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272494 */   // GIR_Coverage, 57434,
     /* 2272494 */   GIR_EraseRootFromParent_Done,
     /* 2272495 */ // Label 30576: @2272495
     /* 2272495 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2272543), // Rule ID 57435 //
     /* 2272500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272513 */   // MIs[0] Operand 1
     /* 2272513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272526 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272531 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272533 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272542 */   // GIR_Coverage, 57435,
     /* 2272542 */   GIR_EraseRootFromParent_Done,
     /* 2272543 */ // Label 30577: @2272543
     /* 2272543 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2272591), // Rule ID 57474 //
     /* 2272548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272554 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272561 */   // MIs[0] Operand 1
     /* 2272561 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272574 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272579 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272581 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272590 */   // GIR_Coverage, 57474,
     /* 2272590 */   GIR_EraseRootFromParent_Done,
     /* 2272591 */ // Label 30578: @2272591
     /* 2272591 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2272639), // Rule ID 57475 //
     /* 2272596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272609 */   // MIs[0] Operand 1
     /* 2272609 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272618 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272622 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272638 */   // GIR_Coverage, 57475,
     /* 2272638 */   GIR_EraseRootFromParent_Done,
     /* 2272639 */ // Label 30579: @2272639
     /* 2272639 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2272687), // Rule ID 57694 //
     /* 2272644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272657 */   // MIs[0] Operand 1
     /* 2272657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272670 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272685 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272686 */   // GIR_Coverage, 57694,
     /* 2272686 */   GIR_EraseRootFromParent_Done,
     /* 2272687 */ // Label 30580: @2272687
     /* 2272687 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2272735), // Rule ID 57695 //
     /* 2272692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272705 */   // MIs[0] Operand 1
     /* 2272705 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272718 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2272721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272723 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272725 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272734 */   // GIR_Coverage, 57695,
     /* 2272734 */   GIR_EraseRootFromParent_Done,
     /* 2272735 */ // Label 30581: @2272735
     /* 2272735 */ GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2272783), // Rule ID 57734 //
     /* 2272740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272753 */   // MIs[0] Operand 1
     /* 2272753 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272762 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272766 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272771 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272773 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272782 */   // GIR_Coverage, 57734,
     /* 2272782 */   GIR_EraseRootFromParent_Done,
     /* 2272783 */ // Label 30582: @2272783
     /* 2272783 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2272831), // Rule ID 57735 //
     /* 2272788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272801 */   // MIs[0] Operand 1
     /* 2272801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272814 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272819 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272821 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272830 */   // GIR_Coverage, 57735,
     /* 2272830 */   GIR_EraseRootFromParent_Done,
     /* 2272831 */ // Label 30583: @2272831
     /* 2272831 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2272879), // Rule ID 57774 //
     /* 2272836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272849 */   // MIs[0] Operand 1
     /* 2272849 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272858 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272862 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272867 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272869 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272878 */   // GIR_Coverage, 57774,
     /* 2272878 */   GIR_EraseRootFromParent_Done,
     /* 2272879 */ // Label 30584: @2272879
     /* 2272879 */ GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2272927), // Rule ID 57775 //
     /* 2272884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272897 */   // MIs[0] Operand 1
     /* 2272897 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272910 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272915 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272917 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272926 */   // GIR_Coverage, 57775,
     /* 2272926 */   GIR_EraseRootFromParent_Done,
     /* 2272927 */ // Label 30585: @2272927
     /* 2272927 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2272975), // Rule ID 57994 //
     /* 2272932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272945 */   // MIs[0] Operand 1
     /* 2272945 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272954 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272958 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272963 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272965 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272974 */   // GIR_Coverage, 57994,
     /* 2272974 */   GIR_EraseRootFromParent_Done,
     /* 2272975 */ // Label 30586: @2272975
     /* 2272975 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2273023), // Rule ID 57995 //
     /* 2272980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272993 */   // MIs[0] Operand 1
     /* 2272993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273002 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273006 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2273009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273022 */   // GIR_Coverage, 57995,
     /* 2273022 */   GIR_EraseRootFromParent_Done,
     /* 2273023 */ // Label 30587: @2273023
     /* 2273023 */ GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2273071), // Rule ID 58034 //
     /* 2273028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2273034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2273037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273041 */   // MIs[0] Operand 1
     /* 2273041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273050 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273054 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273059 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273070 */   // GIR_Coverage, 58034,
     /* 2273070 */   GIR_EraseRootFromParent_Done,
     /* 2273071 */ // Label 30588: @2273071
     /* 2273071 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2273119), // Rule ID 58035 //
     /* 2273076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2273082 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2273085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273089 */   // MIs[0] Operand 1
     /* 2273089 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273098 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273102 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273107 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273118 */   // GIR_Coverage, 58035,
     /* 2273118 */   GIR_EraseRootFromParent_Done,
     /* 2273119 */ // Label 30589: @2273119
     /* 2273119 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2273167), // Rule ID 58074 //
     /* 2273124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2273127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2273130 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2273133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273137 */   // MIs[0] Operand 1
     /* 2273137 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273150 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2273150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273166 */   // GIR_Coverage, 58074,
     /* 2273166 */   GIR_EraseRootFromParent_Done,
     /* 2273167 */ // Label 30590: @2273167
     /* 2273167 */ GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2273215), // Rule ID 58075 //
     /* 2273172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2273175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2273178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2273181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273185 */   // MIs[0] Operand 1
     /* 2273185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273198 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2273198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273214 */   // GIR_Coverage, 58075,
     /* 2273214 */   GIR_EraseRootFromParent_Done,
     /* 2273215 */ // Label 30591: @2273215
     /* 2273215 */ GIM_Reject,
     /* 2273216 */ // Label 30454: @2273216
     /* 2273216 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2273264), // Rule ID 57104 //
     /* 2273221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273234 */   // MIs[0] Operand 1
     /* 2273234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273247 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2273250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273263 */   // GIR_Coverage, 57104,
     /* 2273263 */   GIR_EraseRootFromParent_Done,
     /* 2273264 */ // Label 30592: @2273264
     /* 2273264 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2273312), // Rule ID 57105 //
     /* 2273269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273282 */   // MIs[0] Operand 1
     /* 2273282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273295 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2273298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273300 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273311 */   // GIR_Coverage, 57105,
     /* 2273311 */   GIR_EraseRootFromParent_Done,
     /* 2273312 */ // Label 30593: @2273312
     /* 2273312 */ GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2273360), // Rule ID 57144 //
     /* 2273317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273330 */   // MIs[0] Operand 1
     /* 2273330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273343 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273348 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273359 */   // GIR_Coverage, 57144,
     /* 2273359 */   GIR_EraseRootFromParent_Done,
     /* 2273360 */ // Label 30594: @2273360
     /* 2273360 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2273408), // Rule ID 57145 //
     /* 2273365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273378 */   // MIs[0] Operand 1
     /* 2273378 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273387 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273391 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273407 */   // GIR_Coverage, 57145,
     /* 2273407 */   GIR_EraseRootFromParent_Done,
     /* 2273408 */ // Label 30595: @2273408
     /* 2273408 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2273456), // Rule ID 57404 //
     /* 2273413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273426 */   // MIs[0] Operand 1
     /* 2273426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273439 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2273442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273455 */   // GIR_Coverage, 57404,
     /* 2273455 */   GIR_EraseRootFromParent_Done,
     /* 2273456 */ // Label 30596: @2273456
     /* 2273456 */ GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2273504), // Rule ID 57405 //
     /* 2273461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273474 */   // MIs[0] Operand 1
     /* 2273474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273487 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2273490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273503 */   // GIR_Coverage, 57405,
     /* 2273503 */   GIR_EraseRootFromParent_Done,
     /* 2273504 */ // Label 30597: @2273504
     /* 2273504 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2273552), // Rule ID 57444 //
     /* 2273509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273522 */   // MIs[0] Operand 1
     /* 2273522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273535 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273551 */   // GIR_Coverage, 57444,
     /* 2273551 */   GIR_EraseRootFromParent_Done,
     /* 2273552 */ // Label 30598: @2273552
     /* 2273552 */ GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2273600), // Rule ID 57445 //
     /* 2273557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273570 */   // MIs[0] Operand 1
     /* 2273570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273583 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273599 */   // GIR_Coverage, 57445,
     /* 2273599 */   GIR_EraseRootFromParent_Done,
     /* 2273600 */ // Label 30599: @2273600
     /* 2273600 */ GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2273648), // Rule ID 57704 //
     /* 2273605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273618 */   // MIs[0] Operand 1
     /* 2273618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273631 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273647 */   // GIR_Coverage, 57704,
     /* 2273647 */   GIR_EraseRootFromParent_Done,
     /* 2273648 */ // Label 30600: @2273648
     /* 2273648 */ GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2273696), // Rule ID 57705 //
     /* 2273653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273666 */   // MIs[0] Operand 1
     /* 2273666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273679 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2273682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273695 */   // GIR_Coverage, 57705,
     /* 2273695 */   GIR_EraseRootFromParent_Done,
     /* 2273696 */ // Label 30601: @2273696
     /* 2273696 */ GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2273744), // Rule ID 57744 //
     /* 2273701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273714 */   // MIs[0] Operand 1
     /* 2273714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273727 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273734 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273743 */   // GIR_Coverage, 57744,
     /* 2273743 */   GIR_EraseRootFromParent_Done,
     /* 2273744 */ // Label 30602: @2273744
     /* 2273744 */ GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2273792), // Rule ID 57745 //
     /* 2273749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273762 */   // MIs[0] Operand 1
     /* 2273762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273775 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273782 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273791 */   // GIR_Coverage, 57745,
     /* 2273791 */   GIR_EraseRootFromParent_Done,
     /* 2273792 */ // Label 30603: @2273792
     /* 2273792 */ GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2273840), // Rule ID 58004 //
     /* 2273797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273810 */   // MIs[0] Operand 1
     /* 2273810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273823 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273828 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273830 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273839 */   // GIR_Coverage, 58004,
     /* 2273839 */   GIR_EraseRootFromParent_Done,
     /* 2273840 */ // Label 30604: @2273840
     /* 2273840 */ GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2273888), // Rule ID 58005 //
     /* 2273845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2273854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273858 */   // MIs[0] Operand 1
     /* 2273858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273871 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2273874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273878 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273887 */   // GIR_Coverage, 58005,
     /* 2273887 */   GIR_EraseRootFromParent_Done,
     /* 2273888 */ // Label 30605: @2273888
     /* 2273888 */ GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2273936), // Rule ID 58044 //
     /* 2273893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273906 */   // MIs[0] Operand 1
     /* 2273906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273919 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273935 */   // GIR_Coverage, 58044,
     /* 2273935 */   GIR_EraseRootFromParent_Done,
     /* 2273936 */ // Label 30606: @2273936
     /* 2273936 */ GIM_Try, /*On fail goto*//*Label 30607*/ GIMT_Encode4(2273984), // Rule ID 58045 //
     /* 2273941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273954 */   // MIs[0] Operand 1
     /* 2273954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273967 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273983 */   // GIR_Coverage, 58045,
     /* 2273983 */   GIR_EraseRootFromParent_Done,
     /* 2273984 */ // Label 30607: @2273984
     /* 2273984 */ GIM_Reject,
     /* 2273985 */ // Label 30455: @2273985
     /* 2273985 */ GIM_Try, /*On fail goto*//*Label 30608*/ GIMT_Encode4(2274305),
     /* 2273990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2273993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2273996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274000 */   GIM_Try, /*On fail goto*//*Label 30609*/ GIMT_Encode4(2274038), // Rule ID 57114 //
     /* 2274005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274008 */     // MIs[0] Operand 1
     /* 2274008 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274021 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2274024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274037 */     // GIR_Coverage, 57114,
     /* 2274037 */     GIR_EraseRootFromParent_Done,
     /* 2274038 */   // Label 30609: @2274038
     /* 2274038 */   GIM_Try, /*On fail goto*//*Label 30610*/ GIMT_Encode4(2274076), // Rule ID 57115 //
     /* 2274043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274046 */     // MIs[0] Operand 1
     /* 2274046 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2274051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274059 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2274062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274075 */     // GIR_Coverage, 57115,
     /* 2274075 */     GIR_EraseRootFromParent_Done,
     /* 2274076 */   // Label 30610: @2274076
     /* 2274076 */   GIM_Try, /*On fail goto*//*Label 30611*/ GIMT_Encode4(2274114), // Rule ID 57414 //
     /* 2274081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274084 */     // MIs[0] Operand 1
     /* 2274084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274097 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2274100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274113 */     // GIR_Coverage, 57414,
     /* 2274113 */     GIR_EraseRootFromParent_Done,
     /* 2274114 */   // Label 30611: @2274114
     /* 2274114 */   GIM_Try, /*On fail goto*//*Label 30612*/ GIMT_Encode4(2274152), // Rule ID 57415 //
     /* 2274119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274122 */     // MIs[0] Operand 1
     /* 2274122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2274127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274135 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2274138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274151 */     // GIR_Coverage, 57415,
     /* 2274151 */     GIR_EraseRootFromParent_Done,
     /* 2274152 */   // Label 30612: @2274152
     /* 2274152 */   GIM_Try, /*On fail goto*//*Label 30613*/ GIMT_Encode4(2274190), // Rule ID 57714 //
     /* 2274157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274160 */     // MIs[0] Operand 1
     /* 2274160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274173 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2274176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274189 */     // GIR_Coverage, 57714,
     /* 2274189 */     GIR_EraseRootFromParent_Done,
     /* 2274190 */   // Label 30613: @2274190
     /* 2274190 */   GIM_Try, /*On fail goto*//*Label 30614*/ GIMT_Encode4(2274228), // Rule ID 57715 //
     /* 2274195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274198 */     // MIs[0] Operand 1
     /* 2274198 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2274203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274211 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2274214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274227 */     // GIR_Coverage, 57715,
     /* 2274227 */     GIR_EraseRootFromParent_Done,
     /* 2274228 */   // Label 30614: @2274228
     /* 2274228 */   GIM_Try, /*On fail goto*//*Label 30615*/ GIMT_Encode4(2274266), // Rule ID 58014 //
     /* 2274233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2274236 */     // MIs[0] Operand 1
     /* 2274236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274249 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2274249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2274252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274265 */     // GIR_Coverage, 58014,
     /* 2274265 */     GIR_EraseRootFromParent_Done,
     /* 2274266 */   // Label 30615: @2274266
     /* 2274266 */   GIM_Try, /*On fail goto*//*Label 30616*/ GIMT_Encode4(2274304), // Rule ID 58015 //
     /* 2274271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2274274 */     // MIs[0] Operand 1
     /* 2274274 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2274279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274287 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2274287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2274290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2274296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274303 */     // GIR_Coverage, 58015,
     /* 2274303 */     GIR_EraseRootFromParent_Done,
     /* 2274304 */   // Label 30616: @2274304
     /* 2274304 */   GIM_Reject,
     /* 2274305 */ // Label 30608: @2274305
     /* 2274305 */ GIM_Reject,
     /* 2274306 */ // Label 30456: @2274306
     /* 2274306 */ GIM_Reject,
     /* 2274307 */ // Label 50: @2274307
     /* 2274307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30641*/ GIMT_Encode4(2285291),
     /* 2274318 */ /*GILLT_s32*//*Label 30617*/ GIMT_Encode4(2274442),
     /* 2274322 */ /*GILLT_s64*//*Label 30618*/ GIMT_Encode4(2278708), GIMT_Encode4(0),
     /* 2274330 */ /*GILLT_nxv1s8*//*Label 30619*/ GIMT_Encode4(2281331),
     /* 2274334 */ /*GILLT_nxv1s16*//*Label 30620*/ GIMT_Encode4(2281451),
     /* 2274338 */ /*GILLT_nxv1s32*//*Label 30621*/ GIMT_Encode4(2281659),
     /* 2274342 */ /*GILLT_nxv1s64*//*Label 30622*/ GIMT_Encode4(2281867), GIMT_Encode4(0),
     /* 2274350 */ /*GILLT_nxv2s8*//*Label 30623*/ GIMT_Encode4(2282075),
     /* 2274354 */ /*GILLT_nxv2s16*//*Label 30624*/ GIMT_Encode4(2282195),
     /* 2274358 */ /*GILLT_nxv2s32*//*Label 30625*/ GIMT_Encode4(2282403),
     /* 2274362 */ /*GILLT_nxv2s64*//*Label 30626*/ GIMT_Encode4(2282611), GIMT_Encode4(0),
     /* 2274370 */ /*GILLT_nxv4s8*//*Label 30627*/ GIMT_Encode4(2282819),
     /* 2274374 */ /*GILLT_nxv4s16*//*Label 30628*/ GIMT_Encode4(2282939),
     /* 2274378 */ /*GILLT_nxv4s32*//*Label 30629*/ GIMT_Encode4(2283147),
     /* 2274382 */ /*GILLT_nxv4s64*//*Label 30630*/ GIMT_Encode4(2283355), GIMT_Encode4(0),
     /* 2274390 */ /*GILLT_nxv8s8*//*Label 30631*/ GIMT_Encode4(2283563),
     /* 2274394 */ /*GILLT_nxv8s16*//*Label 30632*/ GIMT_Encode4(2283683),
     /* 2274398 */ /*GILLT_nxv8s32*//*Label 30633*/ GIMT_Encode4(2283891),
     /* 2274402 */ /*GILLT_nxv8s64*//*Label 30634*/ GIMT_Encode4(2284099), GIMT_Encode4(0),
     /* 2274410 */ /*GILLT_nxv16s8*//*Label 30635*/ GIMT_Encode4(2284307),
     /* 2274414 */ /*GILLT_nxv16s16*//*Label 30636*/ GIMT_Encode4(2284427),
     /* 2274418 */ /*GILLT_nxv16s32*//*Label 30637*/ GIMT_Encode4(2284635), GIMT_Encode4(0),
     /* 2274426 */ /*GILLT_nxv32s8*//*Label 30638*/ GIMT_Encode4(2284843),
     /* 2274430 */ /*GILLT_nxv32s16*//*Label 30639*/ GIMT_Encode4(2284963), GIMT_Encode4(0),
     /* 2274438 */ /*GILLT_nxv64s8*//*Label 30640*/ GIMT_Encode4(2285171),
     /* 2274442 */ // Label 30617: @2274442
     /* 2274442 */ GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2278707),
     /* 2274447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2274450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274456 */   GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2274543), // Rule ID 64672 //
     /* 2274461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274484 */     // MIs[1] Operand 1
     /* 2274484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274506 */     // MIs[2] Operand 1
     /* 2274506 */     // No operand predicates
     /* 2274506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274514 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274518 */     // MIs[3] Operand 1
     /* 2274518 */     // No operand predicates
     /* 2274518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274524 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2274527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274542 */     // GIR_Coverage, 64672,
     /* 2274542 */     GIR_EraseRootFromParent_Done,
     /* 2274543 */   // Label 30643: @2274543
     /* 2274543 */   GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2274630), // Rule ID 64674 //
     /* 2274548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274571 */     // MIs[1] Operand 1
     /* 2274571 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274593 */     // MIs[2] Operand 1
     /* 2274593 */     // No operand predicates
     /* 2274593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274601 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274605 */     // MIs[3] Operand 1
     /* 2274605 */     // No operand predicates
     /* 2274605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274611 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2274614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274629 */     // GIR_Coverage, 64674,
     /* 2274629 */     GIR_EraseRootFromParent_Done,
     /* 2274630 */   // Label 30644: @2274630
     /* 2274630 */   GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2274717), // Rule ID 64676 //
     /* 2274635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274654 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274658 */     // MIs[1] Operand 1
     /* 2274658 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274680 */     // MIs[2] Operand 1
     /* 2274680 */     // No operand predicates
     /* 2274680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274688 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274692 */     // MIs[3] Operand 1
     /* 2274692 */     // No operand predicates
     /* 2274692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274698 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2274701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274716 */     // GIR_Coverage, 64676,
     /* 2274716 */     GIR_EraseRootFromParent_Done,
     /* 2274717 */   // Label 30645: @2274717
     /* 2274717 */   GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2274804), // Rule ID 64678 //
     /* 2274722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274741 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274745 */     // MIs[1] Operand 1
     /* 2274745 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2274750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274767 */     // MIs[2] Operand 1
     /* 2274767 */     // No operand predicates
     /* 2274767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274775 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274779 */     // MIs[3] Operand 1
     /* 2274779 */     // No operand predicates
     /* 2274779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274785 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2274788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274803 */     // GIR_Coverage, 64678,
     /* 2274803 */     GIR_EraseRootFromParent_Done,
     /* 2274804 */   // Label 30646: @2274804
     /* 2274804 */   GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2274891), // Rule ID 64680 //
     /* 2274809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274832 */     // MIs[1] Operand 1
     /* 2274832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274850 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2274854 */     // MIs[2] Operand 1
     /* 2274854 */     // No operand predicates
     /* 2274854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274862 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274866 */     // MIs[3] Operand 1
     /* 2274866 */     // No operand predicates
     /* 2274866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274872 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2274875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274890 */     // GIR_Coverage, 64680,
     /* 2274890 */     GIR_EraseRootFromParent_Done,
     /* 2274891 */   // Label 30647: @2274891
     /* 2274891 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2274978), // Rule ID 64682 //
     /* 2274896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2274899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274919 */     // MIs[1] Operand 1
     /* 2274919 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2274924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2274941 */     // MIs[2] Operand 1
     /* 2274941 */     // No operand predicates
     /* 2274941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2274945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274953 */     // MIs[3] Operand 1
     /* 2274953 */     // No operand predicates
     /* 2274953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2274959 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2274959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2274962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2274976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274977 */     // GIR_Coverage, 64682,
     /* 2274977 */     GIR_EraseRootFromParent_Done,
     /* 2274978 */   // Label 30648: @2274978
     /* 2274978 */   GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2275065), // Rule ID 64714 //
     /* 2274983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2274986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275002 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275006 */     // MIs[1] Operand 1
     /* 2275006 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275024 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275028 */     // MIs[2] Operand 1
     /* 2275028 */     // No operand predicates
     /* 2275028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2275032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275036 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275040 */     // MIs[3] Operand 1
     /* 2275040 */     // No operand predicates
     /* 2275040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275046 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2275049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275064 */     // GIR_Coverage, 64714,
     /* 2275064 */     GIR_EraseRootFromParent_Done,
     /* 2275065 */   // Label 30649: @2275065
     /* 2275065 */   GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2275152), // Rule ID 64715 //
     /* 2275070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275089 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275093 */     // MIs[1] Operand 1
     /* 2275093 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275115 */     // MIs[2] Operand 1
     /* 2275115 */     // No operand predicates
     /* 2275115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2275119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275123 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275127 */     // MIs[3] Operand 1
     /* 2275127 */     // No operand predicates
     /* 2275127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275133 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2275136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275151 */     // GIR_Coverage, 64715,
     /* 2275151 */     GIR_EraseRootFromParent_Done,
     /* 2275152 */   // Label 30650: @2275152
     /* 2275152 */   GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2275239), // Rule ID 64696 //
     /* 2275157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275176 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275180 */     // MIs[1] Operand 1
     /* 2275180 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275202 */     // MIs[2] Operand 1
     /* 2275202 */     // No operand predicates
     /* 2275202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275214 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275218 */     // MIs[3] Operand 1
     /* 2275218 */     // No operand predicates
     /* 2275218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275220 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2275223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275238 */     // GIR_Coverage, 64696,
     /* 2275238 */     GIR_EraseRootFromParent_Done,
     /* 2275239 */   // Label 30651: @2275239
     /* 2275239 */   GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2275326), // Rule ID 64698 //
     /* 2275244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275263 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275267 */     // MIs[1] Operand 1
     /* 2275267 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275289 */     // MIs[2] Operand 1
     /* 2275289 */     // No operand predicates
     /* 2275289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275305 */     // MIs[3] Operand 1
     /* 2275305 */     // No operand predicates
     /* 2275305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275307 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2275310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275325 */     // GIR_Coverage, 64698,
     /* 2275325 */     GIR_EraseRootFromParent_Done,
     /* 2275326 */   // Label 30652: @2275326
     /* 2275326 */   GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2275413), // Rule ID 64700 //
     /* 2275331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275350 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275354 */     // MIs[1] Operand 1
     /* 2275354 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2275359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275372 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275376 */     // MIs[2] Operand 1
     /* 2275376 */     // No operand predicates
     /* 2275376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275388 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275392 */     // MIs[3] Operand 1
     /* 2275392 */     // No operand predicates
     /* 2275392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275394 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2275397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275412 */     // GIR_Coverage, 64700,
     /* 2275412 */     GIR_EraseRootFromParent_Done,
     /* 2275413 */   // Label 30653: @2275413
     /* 2275413 */   GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2275500), // Rule ID 64702 //
     /* 2275418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275441 */     // MIs[1] Operand 1
     /* 2275441 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2275446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275463 */     // MIs[2] Operand 1
     /* 2275463 */     // No operand predicates
     /* 2275463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275475 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275479 */     // MIs[3] Operand 1
     /* 2275479 */     // No operand predicates
     /* 2275479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275481 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2275484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275499 */     // GIR_Coverage, 64702,
     /* 2275499 */     GIR_EraseRootFromParent_Done,
     /* 2275500 */   // Label 30654: @2275500
     /* 2275500 */   GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2275587), // Rule ID 64704 //
     /* 2275505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275528 */     // MIs[1] Operand 1
     /* 2275528 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2275533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275546 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2275550 */     // MIs[2] Operand 1
     /* 2275550 */     // No operand predicates
     /* 2275550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275566 */     // MIs[3] Operand 1
     /* 2275566 */     // No operand predicates
     /* 2275566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275568 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2275571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275586 */     // GIR_Coverage, 64704,
     /* 2275586 */     GIR_EraseRootFromParent_Done,
     /* 2275587 */   // Label 30655: @2275587
     /* 2275587 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2275674), // Rule ID 64706 //
     /* 2275592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2275595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275615 */     // MIs[1] Operand 1
     /* 2275615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2275620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2275637 */     // MIs[2] Operand 1
     /* 2275637 */     // No operand predicates
     /* 2275637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275653 */     // MIs[3] Operand 1
     /* 2275653 */     // No operand predicates
     /* 2275653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275655 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2275655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2275658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2275672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275673 */     // GIR_Coverage, 64706,
     /* 2275673 */     GIR_EraseRootFromParent_Done,
     /* 2275674 */   // Label 30656: @2275674
     /* 2275674 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2275761), // Rule ID 64712 //
     /* 2275679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275698 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275702 */     // MIs[1] Operand 1
     /* 2275702 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275724 */     // MIs[2] Operand 1
     /* 2275724 */     // No operand predicates
     /* 2275724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275736 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275740 */     // MIs[3] Operand 1
     /* 2275740 */     // No operand predicates
     /* 2275740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275742 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2275745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275760 */     // GIR_Coverage, 64712,
     /* 2275760 */     GIR_EraseRootFromParent_Done,
     /* 2275761 */   // Label 30657: @2275761
     /* 2275761 */   GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2275848), // Rule ID 64713 //
     /* 2275766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275785 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275789 */     // MIs[1] Operand 1
     /* 2275789 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2275803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275811 */     // MIs[2] Operand 1
     /* 2275811 */     // No operand predicates
     /* 2275811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275827 */     // MIs[3] Operand 1
     /* 2275827 */     // No operand predicates
     /* 2275827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275829 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2275832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2275841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275847 */     // GIR_Coverage, 64713,
     /* 2275847 */     GIR_EraseRootFromParent_Done,
     /* 2275848 */   // Label 30658: @2275848
     /* 2275848 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2275938), // Rule ID 64721 //
     /* 2275853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275876 */     // MIs[1] Operand 1
     /* 2275876 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2275881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2275895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275903 */     // MIs[2] Operand 1
     /* 2275903 */     // No operand predicates
     /* 2275903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275915 */     // MIs[3] Operand 1
     /* 2275915 */     // No operand predicates
     /* 2275915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2275917 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2275917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIIEQ),
     /* 2275920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2275926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2275930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2275933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2275936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275937 */     // GIR_Coverage, 64721,
     /* 2275937 */     GIR_EraseRootFromParent_Done,
     /* 2275938 */   // Label 30659: @2275938
     /* 2275938 */   GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2276028), // Rule ID 64723 //
     /* 2275943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2275946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275962 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2275966 */     // MIs[1] Operand 1
     /* 2275966 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2275971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2275985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2275989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2275993 */     // MIs[2] Operand 1
     /* 2275993 */     // No operand predicates
     /* 2275993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2275997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276005 */     // MIs[3] Operand 1
     /* 2276005 */     // No operand predicates
     /* 2276005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2276007 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2276007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIINE),
     /* 2276010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2276020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2276023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2276026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276027 */     // GIR_Coverage, 64723,
     /* 2276027 */     GIR_EraseRootFromParent_Done,
     /* 2276028 */   // Label 30660: @2276028
     /* 2276028 */   GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2276106), // Rule ID 64655 //
     /* 2276033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2276036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276056 */     // MIs[1] Operand 1
     /* 2276056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2276061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276078 */     // MIs[2] Operand 1
     /* 2276078 */     // No operand predicates
     /* 2276078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276088 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2276091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276105 */     // GIR_Coverage, 64655,
     /* 2276105 */     GIR_EraseRootFromParent_Done,
     /* 2276106 */   // Label 30661: @2276106
     /* 2276106 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2276184), // Rule ID 64656 //
     /* 2276111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2276114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276130 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276134 */     // MIs[1] Operand 1
     /* 2276134 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2276139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2276156 */     // MIs[2] Operand 1
     /* 2276156 */     // No operand predicates
     /* 2276156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276166 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2276169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276183 */     // GIR_Coverage, 64656,
     /* 2276183 */     GIR_EraseRootFromParent_Done,
     /* 2276184 */   // Label 30662: @2276184
     /* 2276184 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2276262), // Rule ID 64657 //
     /* 2276189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1),
     /* 2276192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276208 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276212 */     // MIs[1] Operand 1
     /* 2276212 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276234 */     // MIs[2] Operand 1
     /* 2276234 */     // No operand predicates
     /* 2276234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276244 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2276247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276261 */     // GIR_Coverage, 64657,
     /* 2276261 */     GIR_EraseRootFromParent_Done,
     /* 2276262 */   // Label 30663: @2276262
     /* 2276262 */   GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2276340), // Rule ID 64658 //
     /* 2276267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_NoVendorXqcics_HwMode1),
     /* 2276270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276290 */     // MIs[1] Operand 1
     /* 2276290 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276312 */     // MIs[2] Operand 1
     /* 2276312 */     // No operand predicates
     /* 2276312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276322 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2276325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2276338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276339 */     // GIR_Coverage, 64658,
     /* 2276339 */     GIR_EraseRootFromParent_Done,
     /* 2276340 */   // Label 30664: @2276340
     /* 2276340 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2276418), // Rule ID 64710 //
     /* 2276345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276364 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276368 */     // MIs[1] Operand 1
     /* 2276368 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276386 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276390 */     // MIs[2] Operand 1
     /* 2276390 */     // No operand predicates
     /* 2276390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276400 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTEQI),
     /* 2276403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2276416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276417 */     // GIR_Coverage, 64710,
     /* 2276417 */     GIR_EraseRootFromParent_Done,
     /* 2276418 */   // Label 30665: @2276418
     /* 2276418 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2276496), // Rule ID 64711 //
     /* 2276423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276442 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276446 */     // MIs[1] Operand 1
     /* 2276446 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2276460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276468 */     // MIs[2] Operand 1
     /* 2276468 */     // No operand predicates
     /* 2276468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276478 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2276478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTNEI),
     /* 2276481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2276487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2276490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2276494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276495 */     // GIR_Coverage, 64711,
     /* 2276495 */     GIR_EraseRootFromParent_Done,
     /* 2276496 */   // Label 30666: @2276496
     /* 2276496 */   GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2276577), // Rule ID 64660 //
     /* 2276501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276524 */     // MIs[1] Operand 1
     /* 2276524 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2276529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276551 */     // MIs[2] Operand 1
     /* 2276551 */     // No operand predicates
     /* 2276551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276557 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2276560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276576 */     // GIR_Coverage, 64660,
     /* 2276576 */     GIR_EraseRootFromParent_Done,
     /* 2276577 */   // Label 30667: @2276577
     /* 2276577 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2276658), // Rule ID 64662 //
     /* 2276582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276601 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276605 */     // MIs[1] Operand 1
     /* 2276605 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2276610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276632 */     // MIs[2] Operand 1
     /* 2276632 */     // No operand predicates
     /* 2276632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276638 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2276641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276657 */     // GIR_Coverage, 64662,
     /* 2276657 */     GIR_EraseRootFromParent_Done,
     /* 2276658 */   // Label 30668: @2276658
     /* 2276658 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2276739), // Rule ID 64664 //
     /* 2276663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276682 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276686 */     // MIs[1] Operand 1
     /* 2276686 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2276691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276713 */     // MIs[2] Operand 1
     /* 2276713 */     // No operand predicates
     /* 2276713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276719 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2276722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276738 */     // GIR_Coverage, 64664,
     /* 2276738 */     GIR_EraseRootFromParent_Done,
     /* 2276739 */   // Label 30669: @2276739
     /* 2276739 */   GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2276820), // Rule ID 64666 //
     /* 2276744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276767 */     // MIs[1] Operand 1
     /* 2276767 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2276772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276794 */     // MIs[2] Operand 1
     /* 2276794 */     // No operand predicates
     /* 2276794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276800 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2276803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276819 */     // GIR_Coverage, 64666,
     /* 2276819 */     GIR_EraseRootFromParent_Done,
     /* 2276820 */   // Label 30670: @2276820
     /* 2276820 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2276901), // Rule ID 64668 //
     /* 2276825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276844 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276848 */     // MIs[1] Operand 1
     /* 2276848 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2276853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276875 */     // MIs[2] Operand 1
     /* 2276875 */     // No operand predicates
     /* 2276875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276881 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LILTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2276884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276900 */     // GIR_Coverage, 64668,
     /* 2276900 */     GIR_EraseRootFromParent_Done,
     /* 2276901 */   // Label 30671: @2276901
     /* 2276901 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2276982), // Rule ID 64670 //
     /* 2276906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2276909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2276921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276925 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2276929 */     // MIs[1] Operand 1
     /* 2276929 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2276934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2276948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2276952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2276956 */     // MIs[2] Operand 1
     /* 2276956 */     // No operand predicates
     /* 2276956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2276962 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_LIGEU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2276962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2276965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2276967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2276969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2276973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2276977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2276980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276981 */     // GIR_Coverage, 64670,
     /* 2276981 */     GIR_EraseRootFromParent_Done,
     /* 2276982 */   // Label 30672: @2276982
     /* 2276982 */   GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2277063), // Rule ID 64718 //
     /* 2276987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2276990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2276998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277006 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277010 */     // MIs[1] Operand 1
     /* 2277010 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2277029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277037 */     // MIs[2] Operand 1
     /* 2277037 */     // No operand predicates
     /* 2277037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277043 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINE),
     /* 2277046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277062 */     // GIR_Coverage, 64718,
     /* 2277062 */     GIR_EraseRootFromParent_Done,
     /* 2277063 */   // Label 30673: @2277063
     /* 2277063 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2277144), // Rule ID 64719 //
     /* 2277068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277091 */     // MIs[1] Operand 1
     /* 2277091 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2277110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277114 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277118 */     // MIs[2] Operand 1
     /* 2277118 */     // No operand predicates
     /* 2277118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277124 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQ),
     /* 2277127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277143 */     // GIR_Coverage, 64719,
     /* 2277143 */     GIR_EraseRootFromParent_Done,
     /* 2277144 */   // Label 30674: @2277144
     /* 2277144 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2277225), // Rule ID 64684 //
     /* 2277149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277168 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277172 */     // MIs[1] Operand 1
     /* 2277172 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277199 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277203 */     // MIs[2] Operand 1
     /* 2277203 */     // No operand predicates
     /* 2277203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277205 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2277208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277224 */     // GIR_Coverage, 64684,
     /* 2277224 */     GIR_EraseRootFromParent_Done,
     /* 2277225 */   // Label 30675: @2277225
     /* 2277225 */   GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2277306), // Rule ID 64686 //
     /* 2277230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277249 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277253 */     // MIs[1] Operand 1
     /* 2277253 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277284 */     // MIs[2] Operand 1
     /* 2277284 */     // No operand predicates
     /* 2277284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277286 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2277289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277305 */     // GIR_Coverage, 64686,
     /* 2277305 */     GIR_EraseRootFromParent_Done,
     /* 2277306 */   // Label 30676: @2277306
     /* 2277306 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2277387), // Rule ID 64688 //
     /* 2277311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277330 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277334 */     // MIs[1] Operand 1
     /* 2277334 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2277339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277365 */     // MIs[2] Operand 1
     /* 2277365 */     // No operand predicates
     /* 2277365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277367 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2277370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277386 */     // GIR_Coverage, 64688,
     /* 2277386 */     GIR_EraseRootFromParent_Done,
     /* 2277387 */   // Label 30677: @2277387
     /* 2277387 */   GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2277468), // Rule ID 64690 //
     /* 2277392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277415 */     // MIs[1] Operand 1
     /* 2277415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2277420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277446 */     // MIs[2] Operand 1
     /* 2277446 */     // No operand predicates
     /* 2277446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277448 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2277451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277467 */     // GIR_Coverage, 64690,
     /* 2277467 */     GIR_EraseRootFromParent_Done,
     /* 2277468 */   // Label 30678: @2277468
     /* 2277468 */   GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2277549), // Rule ID 64692 //
     /* 2277473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277496 */     // MIs[1] Operand 1
     /* 2277496 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2277501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277527 */     // MIs[2] Operand 1
     /* 2277527 */     // No operand predicates
     /* 2277527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277529 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2277532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277548 */     // GIR_Coverage, 64692,
     /* 2277548 */     GIR_EraseRootFromParent_Done,
     /* 2277549 */   // Label 30679: @2277549
     /* 2277549 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2277630), // Rule ID 64694 //
     /* 2277554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode1),
     /* 2277557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277573 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277577 */     // MIs[1] Operand 1
     /* 2277577 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2277582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277604 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277608 */     // MIs[2] Operand 1
     /* 2277608 */     // No operand predicates
     /* 2277608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277610 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm)
     /* 2277610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2277613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2277617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2277621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2277625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2277628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277629 */     // GIR_Coverage, 64694,
     /* 2277629 */     GIR_EraseRootFromParent_Done,
     /* 2277630 */   // Label 30680: @2277630
     /* 2277630 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2277711), // Rule ID 64716 //
     /* 2277635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277654 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277658 */     // MIs[1] Operand 1
     /* 2277658 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2277663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277689 */     // MIs[2] Operand 1
     /* 2277689 */     // No operand predicates
     /* 2277689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277691 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQ),
     /* 2277694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277710 */     // GIR_Coverage, 64716,
     /* 2277710 */     GIR_EraseRootFromParent_Done,
     /* 2277711 */   // Label 30681: @2277711
     /* 2277711 */   GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2277792), // Rule ID 64717 //
     /* 2277716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2277735 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2277739 */     // MIs[1] Operand 1
     /* 2277739 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2277744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2277762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277766 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277770 */     // MIs[2] Operand 1
     /* 2277770 */     // No operand predicates
     /* 2277770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2277772 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINE),
     /* 2277775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2277781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2277785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm2
     /* 2277790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277791 */     // GIR_Coverage, 64717,
     /* 2277791 */     GIR_EraseRootFromParent_Done,
     /* 2277792 */   // Label 30682: @2277792
     /* 2277792 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2277833), // Rule ID 62585 //
     /* 2277797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2277812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277816 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2277819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277821 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2277823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277829 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277832 */     // GIR_Coverage, 62585,
     /* 2277832 */     GIR_EraseRootFromParent_Done,
     /* 2277833 */   // Label 30683: @2277833
     /* 2277833 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2277874), // Rule ID 62583 //
     /* 2277838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2277841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2277853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2277857 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2277857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2277860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277862 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2277864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2277870 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277873 */     // GIR_Coverage, 62583,
     /* 2277873 */     GIR_EraseRootFromParent_Done,
     /* 2277874 */   // Label 30684: @2277874
     /* 2277874 */   GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2277925), // Rule ID 64709 //
     /* 2277879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2277894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277902 */     // MIs[1] Operand 1
     /* 2277902 */     // No operand predicates
     /* 2277902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2277908 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SELECTIEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIEQI),
     /* 2277911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2277915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2277918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // simm2
     /* 2277923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277924 */     // GIR_Coverage, 64709,
     /* 2277924 */     GIR_EraseRootFromParent_Done,
     /* 2277925 */   // Label 30685: @2277925
     /* 2277925 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2277976), // Rule ID 64708 //
     /* 2277930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2277933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2277949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2277953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2277957 */     // MIs[1] Operand 1
     /* 2277957 */     // No operand predicates
     /* 2277957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2277959 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTINEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$simm2)
     /* 2277959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTINEI),
     /* 2277962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2277964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2277966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2277969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // simm2
     /* 2277974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277975 */     // GIR_Coverage, 64708,
     /* 2277975 */     GIR_EraseRootFromParent_Done,
     /* 2277976 */   // Label 30686: @2277976
     /* 2277976 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2278048), // Rule ID 64647 //
     /* 2277981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2277984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2277988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2277992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2277996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278004 */     // MIs[1] Operand 1
     /* 2278004 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278029 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2278032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278047 */     // GIR_Coverage, 64647,
     /* 2278047 */     GIR_EraseRootFromParent_Done,
     /* 2278048 */   // Label 30687: @2278048
     /* 2278048 */   GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2278120), // Rule ID 64648 //
     /* 2278053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278076 */     // MIs[1] Operand 1
     /* 2278076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278101 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2278104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278119 */     // GIR_Coverage, 64648,
     /* 2278119 */     GIR_EraseRootFromParent_Done,
     /* 2278120 */   // Label 30688: @2278120
     /* 2278120 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2278192), // Rule ID 64649 //
     /* 2278125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278148 */     // MIs[1] Operand 1
     /* 2278148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278173 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2278176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278191 */     // GIR_Coverage, 64649,
     /* 2278191 */     GIR_EraseRootFromParent_Done,
     /* 2278192 */   // Label 30689: @2278192
     /* 2278192 */   GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2278264), // Rule ID 64650 //
     /* 2278197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278220 */     // MIs[1] Operand 1
     /* 2278220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278245 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2278248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278263 */     // GIR_Coverage, 64650,
     /* 2278263 */     GIR_EraseRootFromParent_Done,
     /* 2278264 */   // Label 30690: @2278264
     /* 2278264 */   GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2278336), // Rule ID 64651 //
     /* 2278269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278288 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278292 */     // MIs[1] Operand 1
     /* 2278292 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278317 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2278320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278335 */     // GIR_Coverage, 64651,
     /* 2278335 */     GIR_EraseRootFromParent_Done,
     /* 2278336 */   // Label 30691: @2278336
     /* 2278336 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2278408), // Rule ID 64652 //
     /* 2278341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278364 */     // MIs[1] Operand 1
     /* 2278364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278389 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2278392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278407 */     // GIR_Coverage, 64652,
     /* 2278407 */     GIR_EraseRootFromParent_Done,
     /* 2278408 */   // Label 30692: @2278408
     /* 2278408 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2278480), // Rule ID 64653 //
     /* 2278413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2278416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278432 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278436 */     // MIs[1] Operand 1
     /* 2278436 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2278441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278461 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2278464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278479 */     // GIR_Coverage, 64653,
     /* 2278479 */     GIR_EraseRootFromParent_Done,
     /* 2278480 */   // Label 30693: @2278480
     /* 2278480 */   GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2278552), // Rule ID 64654 //
     /* 2278485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278504 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2278508 */     // MIs[1] Operand 1
     /* 2278508 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2278513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2278533 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2278536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2278548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2278550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278551 */     // GIR_Coverage, 64654,
     /* 2278551 */     GIR_EraseRootFromParent_Done,
     /* 2278552 */   // Label 30694: @2278552
     /* 2278552 */   GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2278589), // Rule ID 62581 //
     /* 2278557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2278560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278576 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2278576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2278579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278581 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2278583 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2278585 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2278587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278588 */     // GIR_Coverage, 62581,
     /* 2278588 */     GIR_EraseRootFromParent_Done,
     /* 2278589 */   // Label 30695: @2278589
     /* 2278589 */   GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2278629), // Rule ID 64646 //
     /* 2278594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2278597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278613 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2278616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2278620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2278625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278628 */     // GIR_Coverage, 64646,
     /* 2278628 */     GIR_EraseRootFromParent_Done,
     /* 2278629 */   // Label 30696: @2278629
     /* 2278629 */   GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2278669), // Rule ID 64707 //
     /* 2278634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode1),
     /* 2278637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278653 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_SELECTNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2278653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTNEI),
     /* 2278656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2278660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2278663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278668 */     // GIR_Coverage, 64707,
     /* 2278668 */     GIR_EraseRootFromParent_Done,
     /* 2278669 */   // Label 30697: @2278669
     /* 2278669 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2278706), // Rule ID 64733 //
     /* 2278674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2278677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2278693 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2278693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2278696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2278702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2278704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278705 */     // GIR_Coverage, 64733,
     /* 2278705 */     GIR_EraseRootFromParent_Done,
     /* 2278706 */   // Label 30698: @2278706
     /* 2278706 */   GIM_Reject,
     /* 2278707 */ // Label 30642: @2278707
     /* 2278707 */ GIM_Reject,
     /* 2278708 */ // Label 30618: @2278708
     /* 2278708 */ GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2278804), // Rule ID 64671 //
     /* 2278713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278741 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278745 */   // MIs[1] Operand 1
     /* 2278745 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2278750 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278755 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278759 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278763 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278767 */   // MIs[2] Operand 1
     /* 2278767 */   // No operand predicates
     /* 2278767 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278771 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278775 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278779 */   // MIs[3] Operand 1
     /* 2278779 */   // No operand predicates
     /* 2278779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278783 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278785 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2278788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278792 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278796 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278799 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2278802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2278803 */   // GIR_Coverage, 64671,
     /* 2278803 */   GIR_EraseRootFromParent_Done,
     /* 2278804 */ // Label 30699: @2278804
     /* 2278804 */ GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2278900), // Rule ID 64673 //
     /* 2278809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278837 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278841 */   // MIs[1] Operand 1
     /* 2278841 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2278846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278851 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278855 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278859 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278863 */   // MIs[2] Operand 1
     /* 2278863 */   // No operand predicates
     /* 2278863 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278867 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278871 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278875 */   // MIs[3] Operand 1
     /* 2278875 */   // No operand predicates
     /* 2278875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278879 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278881 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LINEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2278884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278888 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278892 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278895 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2278898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2278899 */   // GIR_Coverage, 64673,
     /* 2278899 */   GIR_EraseRootFromParent_Done,
     /* 2278900 */ // Label 30700: @2278900
     /* 2278900 */ GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2278996), // Rule ID 64675 //
     /* 2278905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2278908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2278911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2278929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2278933 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2278937 */   // MIs[1] Operand 1
     /* 2278937 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2278942 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2278951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278955 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278959 */   // MIs[2] Operand 1
     /* 2278959 */   // No operand predicates
     /* 2278959 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2278963 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2278967 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2278971 */   // MIs[3] Operand 1
     /* 2278971 */   // No operand predicates
     /* 2278971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278975 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2278977 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2278977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2278980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2278982 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2278984 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2278988 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2278991 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2278994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2278995 */   // GIR_Coverage, 64675,
     /* 2278995 */   GIR_EraseRootFromParent_Done,
     /* 2278996 */ // Label 30701: @2278996
     /* 2278996 */ GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2279092), // Rule ID 64677 //
     /* 2279001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279029 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279033 */   // MIs[1] Operand 1
     /* 2279033 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2279038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279043 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279047 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279051 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279055 */   // MIs[2] Operand 1
     /* 2279055 */   // No operand predicates
     /* 2279055 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279059 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279063 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279067 */   // MIs[3] Operand 1
     /* 2279067 */   // No operand predicates
     /* 2279067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279071 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279073 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2279076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279078 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279080 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279084 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279087 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279091 */   // GIR_Coverage, 64677,
     /* 2279091 */   GIR_EraseRootFromParent_Done,
     /* 2279092 */ // Label 30702: @2279092
     /* 2279092 */ GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2279188), // Rule ID 64679 //
     /* 2279097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279121 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279125 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279129 */   // MIs[1] Operand 1
     /* 2279129 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2279134 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279139 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279143 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279147 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279151 */   // MIs[2] Operand 1
     /* 2279151 */   // No operand predicates
     /* 2279151 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279155 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279159 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279163 */   // MIs[3] Operand 1
     /* 2279163 */   // No operand predicates
     /* 2279163 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279167 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279169 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2279172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279174 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279176 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279180 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279183 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279187 */   // GIR_Coverage, 64679,
     /* 2279187 */   GIR_EraseRootFromParent_Done,
     /* 2279188 */ // Label 30703: @2279188
     /* 2279188 */ GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2279284), // Rule ID 64681 //
     /* 2279193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279221 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279225 */   // MIs[1] Operand 1
     /* 2279225 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2279230 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279235 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279239 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279243 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279247 */   // MIs[2] Operand 1
     /* 2279247 */   // No operand predicates
     /* 2279247 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2279251 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279255 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279259 */   // MIs[3] Operand 1
     /* 2279259 */   // No operand predicates
     /* 2279259 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279263 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279265 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2279268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279270 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2279272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279276 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279283 */   // GIR_Coverage, 64681,
     /* 2279283 */   GIR_EraseRootFromParent_Done,
     /* 2279284 */ // Label 30704: @2279284
     /* 2279284 */ GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2279380), // Rule ID 64695 //
     /* 2279289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279305 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279317 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279321 */   // MIs[1] Operand 1
     /* 2279321 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2279326 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279331 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279335 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279339 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279343 */   // MIs[2] Operand 1
     /* 2279343 */   // No operand predicates
     /* 2279343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279347 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279351 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279355 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279359 */   // MIs[3] Operand 1
     /* 2279359 */   // No operand predicates
     /* 2279359 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279361 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQI),
     /* 2279364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279366 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279368 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279375 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279379 */   // GIR_Coverage, 64695,
     /* 2279379 */   GIR_EraseRootFromParent_Done,
     /* 2279380 */ // Label 30705: @2279380
     /* 2279380 */ GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2279476), // Rule ID 64697 //
     /* 2279385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279409 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279413 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279417 */   // MIs[1] Operand 1
     /* 2279417 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2279422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279435 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279439 */   // MIs[2] Operand 1
     /* 2279439 */   // No operand predicates
     /* 2279439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279443 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279447 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279451 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279455 */   // MIs[3] Operand 1
     /* 2279455 */   // No operand predicates
     /* 2279455 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279457 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINEI),
     /* 2279460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279462 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279464 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279468 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279471 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279475 */   // GIR_Coverage, 64697,
     /* 2279475 */   GIR_EraseRootFromParent_Done,
     /* 2279476 */ // Label 30706: @2279476
     /* 2279476 */ GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2279572), // Rule ID 64699 //
     /* 2279481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279505 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279509 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279513 */   // MIs[1] Operand 1
     /* 2279513 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2279518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279523 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279527 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279531 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279535 */   // MIs[2] Operand 1
     /* 2279535 */   // No operand predicates
     /* 2279535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279539 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279543 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279547 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279551 */   // MIs[3] Operand 1
     /* 2279551 */   // No operand predicates
     /* 2279551 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279553 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTI),
     /* 2279556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279558 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279564 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279567 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279571 */   // GIR_Coverage, 64699,
     /* 2279571 */   GIR_EraseRootFromParent_Done,
     /* 2279572 */ // Label 30707: @2279572
     /* 2279572 */ GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2279668), // Rule ID 64701 //
     /* 2279577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279609 */   // MIs[1] Operand 1
     /* 2279609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2279614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279619 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279623 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279627 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279631 */   // MIs[2] Operand 1
     /* 2279631 */   // No operand predicates
     /* 2279631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279635 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279639 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279643 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279647 */   // MIs[3] Operand 1
     /* 2279647 */   // No operand predicates
     /* 2279647 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279649 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEI),
     /* 2279652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279654 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279656 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279660 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279663 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279667 */   // GIR_Coverage, 64701,
     /* 2279667 */   GIR_EraseRootFromParent_Done,
     /* 2279668 */ // Label 30708: @2279668
     /* 2279668 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2279764), // Rule ID 64703 //
     /* 2279673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279701 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279705 */   // MIs[1] Operand 1
     /* 2279705 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2279710 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279715 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279719 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279723 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279727 */   // MIs[2] Operand 1
     /* 2279727 */   // No operand predicates
     /* 2279727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279731 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279735 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279739 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279743 */   // MIs[3] Operand 1
     /* 2279743 */   // No operand predicates
     /* 2279743 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279745 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTUI),
     /* 2279748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279750 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279752 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279756 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279759 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279763 */   // GIR_Coverage, 64703,
     /* 2279763 */   GIR_EraseRootFromParent_Done,
     /* 2279764 */ // Label 30709: @2279764
     /* 2279764 */ GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2279860), // Rule ID 64705 //
     /* 2279769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2279772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279793 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279797 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279801 */   // MIs[1] Operand 1
     /* 2279801 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2279806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279811 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2279815 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279819 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2279823 */   // MIs[2] Operand 1
     /* 2279823 */   // No operand predicates
     /* 2279823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279827 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279831 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279835 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279839 */   // MIs[3] Operand 1
     /* 2279839 */   // No operand predicates
     /* 2279839 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279841 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2279841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEUI),
     /* 2279844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279846 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2279848 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2279852 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2279855 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm
     /* 2279858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279859 */   // GIR_Coverage, 64705,
     /* 2279859 */   GIR_EraseRootFromParent_Done,
     /* 2279860 */ // Label 30710: @2279860
     /* 2279860 */ GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2279959), // Rule ID 64720 //
     /* 2279865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode0),
     /* 2279868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279889 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279893 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2279897 */   // MIs[1] Operand 1
     /* 2279897 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2279902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279912 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2279916 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279920 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279924 */   // MIs[2] Operand 1
     /* 2279924 */   // No operand predicates
     /* 2279924 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2279928 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2279932 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2279936 */   // MIs[3] Operand 1
     /* 2279936 */   // No operand predicates
     /* 2279936 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2279938 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIIEQ:{ *:[i64] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)
     /* 2279938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIIEQ),
     /* 2279941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2279943 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2279947 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2279951 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2279954 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2279957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279958 */   // GIR_Coverage, 64720,
     /* 2279958 */   GIR_EraseRootFromParent_Done,
     /* 2279959 */ // Label 30711: @2279959
     /* 2279959 */ GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2280058), // Rule ID 64722 //
     /* 2279964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcics_IsRV32_HwMode0),
     /* 2279967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2279976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2279984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2279988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279992 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2279996 */   // MIs[1] Operand 1
     /* 2279996 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280001 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280006 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280011 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280015 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280019 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280023 */   // MIs[2] Operand 1
     /* 2280023 */   // No operand predicates
     /* 2280023 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 2280027 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280031 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280035 */   // MIs[3] Operand 1
     /* 2280035 */   // No operand predicates
     /* 2280035 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2280037 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)  =>  (QC_SELECTIINE:{ *:[i64] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm2)
     /* 2280037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SELECTIINE),
     /* 2280040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280042 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /* 2280046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs1
     /* 2280050 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm1
     /* 2280053 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // simm2
     /* 2280056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280057 */   // GIR_Coverage, 64722,
     /* 2280057 */   GIR_EraseRootFromParent_Done,
     /* 2280058 */ // Label 30712: @2280058
     /* 2280058 */ GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2280148), // Rule ID 64659 //
     /* 2280063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280087 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280091 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280095 */   // MIs[1] Operand 1
     /* 2280095 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2280100 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280110 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280114 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280118 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280122 */   // MIs[2] Operand 1
     /* 2280122 */   // No operand predicates
     /* 2280122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280126 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280128 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2280131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280139 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280143 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280147 */   // GIR_Coverage, 64659,
     /* 2280147 */   GIR_EraseRootFromParent_Done,
     /* 2280148 */ // Label 30713: @2280148
     /* 2280148 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2280238), // Rule ID 64661 //
     /* 2280153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280177 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280181 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280185 */   // MIs[1] Operand 1
     /* 2280185 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280190 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280200 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280204 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280208 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280212 */   // MIs[2] Operand 1
     /* 2280212 */   // No operand predicates
     /* 2280212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280218 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LINE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2280221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280223 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280229 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280233 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280237 */   // GIR_Coverage, 64661,
     /* 2280237 */   GIR_EraseRootFromParent_Done,
     /* 2280238 */ // Label 30714: @2280238
     /* 2280238 */ GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2280328), // Rule ID 64663 //
     /* 2280243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280271 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280275 */   // MIs[1] Operand 1
     /* 2280275 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2280280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280285 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280290 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280294 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280298 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280302 */   // MIs[2] Operand 1
     /* 2280302 */   // No operand predicates
     /* 2280302 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280306 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280308 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2280311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280313 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280315 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280319 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280323 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280327 */   // GIR_Coverage, 64663,
     /* 2280327 */   GIR_EraseRootFromParent_Done,
     /* 2280328 */ // Label 30715: @2280328
     /* 2280328 */ GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2280418), // Rule ID 64665 //
     /* 2280333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280349 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280353 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280357 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280361 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280365 */   // MIs[1] Operand 1
     /* 2280365 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2280370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280388 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280392 */   // MIs[2] Operand 1
     /* 2280392 */   // No operand predicates
     /* 2280392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280396 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280398 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2280401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280405 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280409 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280413 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280417 */   // GIR_Coverage, 64665,
     /* 2280417 */   GIR_EraseRootFromParent_Done,
     /* 2280418 */ // Label 30716: @2280418
     /* 2280418 */ GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2280508), // Rule ID 64667 //
     /* 2280423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280447 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280451 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280455 */   // MIs[1] Operand 1
     /* 2280455 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2280460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280465 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280470 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280474 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280478 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280482 */   // MIs[2] Operand 1
     /* 2280482 */   // No operand predicates
     /* 2280482 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280486 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280488 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LILTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2280491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280493 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280503 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280507 */   // GIR_Coverage, 64667,
     /* 2280507 */   GIR_EraseRootFromParent_Done,
     /* 2280508 */ // Label 30717: @2280508
     /* 2280508 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2280598), // Rule ID 64669 //
     /* 2280513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280537 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280541 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280545 */   // MIs[1] Operand 1
     /* 2280545 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2280550 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280560 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2280564 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280568 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280572 */   // MIs[2] Operand 1
     /* 2280572 */   // No operand predicates
     /* 2280572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280576 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280578 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_LIGEU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2280581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280583 */   GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2280585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280589 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280593 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280597 */   // GIR_Coverage, 64669,
     /* 2280597 */   GIR_EraseRootFromParent_Done,
     /* 2280598 */ // Label 30718: @2280598
     /* 2280598 */ GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2280688), // Rule ID 64683 //
     /* 2280603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280612 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280627 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280631 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280635 */   // MIs[1] Operand 1
     /* 2280635 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2280640 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280645 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280654 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280658 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280662 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280666 */   // MIs[2] Operand 1
     /* 2280666 */   // No operand predicates
     /* 2280666 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280668 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIEQ),
     /* 2280671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280675 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280679 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280683 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280687 */   // GIR_Coverage, 64683,
     /* 2280687 */   GIR_EraseRootFromParent_Done,
     /* 2280688 */ // Label 30719: @2280688
     /* 2280688 */ GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2280778), // Rule ID 64685 //
     /* 2280693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280717 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280721 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280725 */   // MIs[1] Operand 1
     /* 2280725 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2280730 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280744 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280748 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280752 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280756 */   // MIs[2] Operand 1
     /* 2280756 */   // No operand predicates
     /* 2280756 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280758 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LINE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LINE),
     /* 2280761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280763 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280765 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280769 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280773 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280777 */   // GIR_Coverage, 64685,
     /* 2280777 */   GIR_EraseRootFromParent_Done,
     /* 2280778 */ // Label 30720: @2280778
     /* 2280778 */ GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2280868), // Rule ID 64687 //
     /* 2280783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280799 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280807 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280811 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280815 */   // MIs[1] Operand 1
     /* 2280815 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2280820 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280834 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280838 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280842 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280846 */   // MIs[2] Operand 1
     /* 2280846 */   // No operand predicates
     /* 2280846 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280848 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILT),
     /* 2280851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280859 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280863 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280867 */   // GIR_Coverage, 64687,
     /* 2280867 */   GIR_EraseRootFromParent_Done,
     /* 2280868 */ // Label 30721: @2280868
     /* 2280868 */ GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2280958), // Rule ID 64689 //
     /* 2280873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280901 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280905 */   // MIs[1] Operand 1
     /* 2280905 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2280910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280915 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280924 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2280928 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2280932 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2280936 */   // MIs[2] Operand 1
     /* 2280936 */   // No operand predicates
     /* 2280936 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2280938 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2280938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGE),
     /* 2280941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2280943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2280945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2280949 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2280953 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2280956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2280957 */   // GIR_Coverage, 64689,
     /* 2280957 */   GIR_EraseRootFromParent_Done,
     /* 2280958 */ // Label 30722: @2280958
     /* 2280958 */ GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2281048), // Rule ID 64691 //
     /* 2280963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2280966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2280969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2280983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2280987 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2280991 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2280995 */   // MIs[1] Operand 1
     /* 2280995 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2281000 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281014 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2281018 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2281022 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2281026 */   // MIs[2] Operand 1
     /* 2281026 */   // No operand predicates
     /* 2281026 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2281028 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LILTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2281028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LILTU),
     /* 2281031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281033 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2281035 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2281039 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2281043 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2281046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281047 */   // GIR_Coverage, 64691,
     /* 2281047 */   GIR_EraseRootFromParent_Done,
     /* 2281048 */ // Label 30723: @2281048
     /* 2281048 */ GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2281138), // Rule ID 64693 //
     /* 2281053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicli_HasVendorXqcicsOrXqcicm_IsRV32_HwMode0),
     /* 2281056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2281073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2281077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281081 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281085 */   // MIs[1] Operand 1
     /* 2281085 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2281090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281095 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2281104 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2281108 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2281112 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2281116 */   // MIs[2] Operand 1
     /* 2281116 */   // No operand predicates
     /* 2281116 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2281118 */   // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rd, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)  =>  (QC_LIGEU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$simm)
     /* 2281118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LIGEU),
     /* 2281121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2281125 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2281129 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2281133 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // simm
     /* 2281136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281137 */   // GIR_Coverage, 64693,
     /* 2281137 */   GIR_EraseRootFromParent_Done,
     /* 2281138 */ // Label 30724: @2281138
     /* 2281138 */ GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2281188), // Rule ID 62584 //
     /* 2281143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281163 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2281167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281171 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2281171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2281174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281176 */   GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2281178 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2281184 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281187 */   // GIR_Coverage, 62584,
     /* 2281187 */   GIR_EraseRootFromParent_Done,
     /* 2281188 */ // Label 30725: @2281188
     /* 2281188 */ GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2281238), // Rule ID 62582 //
     /* 2281193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281217 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2281221 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2281221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2281224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281226 */   GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2281228 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2281234 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281237 */   // GIR_Coverage, 62582,
     /* 2281237 */   GIR_EraseRootFromParent_Done,
     /* 2281238 */ // Label 30726: @2281238
     /* 2281238 */ GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2281284), // Rule ID 62580 //
     /* 2281243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2281246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281271 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2281271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2281274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2281276 */   GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2281278 */   GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2281280 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2281282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281283 */   // GIR_Coverage, 62580,
     /* 2281283 */   GIR_EraseRootFromParent_Done,
     /* 2281284 */ // Label 30727: @2281284
     /* 2281284 */ GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2281330), // Rule ID 64732 //
     /* 2281289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2281292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2281301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281317 */   // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2281317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2281320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281324 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2281326 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2281328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2281329 */   // GIR_Coverage, 64732,
     /* 2281329 */   GIR_EraseRootFromParent_Done,
     /* 2281330 */ // Label 30728: @2281330
     /* 2281330 */ GIM_Reject,
     /* 2281331 */ // Label 30619: @2281331
     /* 2281331 */ GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2281450),
     /* 2281336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2281342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2281345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281357 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281361 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2281405), // Rule ID 52244 //
     /* 2281366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281369 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2281386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281395 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281404 */     // GIR_Coverage, 52244,
     /* 2281404 */     GIR_EraseRootFromParent_Done,
     /* 2281405 */   // Label 30730: @2281405
     /* 2281405 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2281449), // Rule ID 52245 //
     /* 2281410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281413 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2281416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2281430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281439 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281448 */     // GIR_Coverage, 52245,
     /* 2281448 */     GIR_EraseRootFromParent_Done,
     /* 2281449 */   // Label 30731: @2281449
     /* 2281449 */   GIM_Reject,
     /* 2281450 */ // Label 30729: @2281450
     /* 2281450 */ GIM_Reject,
     /* 2281451 */ // Label 30620: @2281451
     /* 2281451 */ GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2281658),
     /* 2281456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2281462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2281465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281481 */   GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2281525), // Rule ID 52262 //
     /* 2281486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281489 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281515 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281524 */     // GIR_Coverage, 52262,
     /* 2281524 */     GIR_EraseRootFromParent_Done,
     /* 2281525 */   // Label 30733: @2281525
     /* 2281525 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2281569), // Rule ID 52263 //
     /* 2281530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281533 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281559 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281568 */     // GIR_Coverage, 52263,
     /* 2281568 */     GIR_EraseRootFromParent_Done,
     /* 2281569 */   // Label 30734: @2281569
     /* 2281569 */   GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2281613), // Rule ID 58084 //
     /* 2281574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281577 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2281577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281603 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281612 */     // GIR_Coverage, 58084,
     /* 2281612 */     GIR_EraseRootFromParent_Done,
     /* 2281613 */   // Label 30735: @2281613
     /* 2281613 */   GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2281657), // Rule ID 58085 //
     /* 2281618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281621 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2281621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2281638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281647 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281656 */     // GIR_Coverage, 58085,
     /* 2281656 */     GIR_EraseRootFromParent_Done,
     /* 2281657 */   // Label 30736: @2281657
     /* 2281657 */   GIM_Reject,
     /* 2281658 */ // Label 30732: @2281658
     /* 2281658 */ GIM_Reject,
     /* 2281659 */ // Label 30621: @2281659
     /* 2281659 */ GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2281866),
     /* 2281664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2281670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2281673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281685 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281689 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2281733), // Rule ID 52274 //
     /* 2281694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281697 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281732 */     // GIR_Coverage, 52274,
     /* 2281732 */     GIR_EraseRootFromParent_Done,
     /* 2281733 */   // Label 30738: @2281733
     /* 2281733 */   GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2281777), // Rule ID 52275 //
     /* 2281738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281741 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281767 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281776 */     // GIR_Coverage, 52275,
     /* 2281776 */     GIR_EraseRootFromParent_Done,
     /* 2281777 */   // Label 30739: @2281777
     /* 2281777 */   GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2281821), // Rule ID 58104 //
     /* 2281782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281785 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2281785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281811 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281820 */     // GIR_Coverage, 58104,
     /* 2281820 */     GIR_EraseRootFromParent_Done,
     /* 2281821 */   // Label 30740: @2281821
     /* 2281821 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2281865), // Rule ID 58105 //
     /* 2281826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281829 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2281829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2281846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281855 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281864 */     // GIR_Coverage, 58105,
     /* 2281864 */     GIR_EraseRootFromParent_Done,
     /* 2281865 */   // Label 30741: @2281865
     /* 2281865 */   GIM_Reject,
     /* 2281866 */ // Label 30737: @2281866
     /* 2281866 */ GIM_Reject,
     /* 2281867 */ // Label 30622: @2281867
     /* 2281867 */ GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2282074),
     /* 2281872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2281875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2281878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2281881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2281885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2281889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281893 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281897 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2281941), // Rule ID 52298 //
     /* 2281902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2281905 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2281905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2281922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281931 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281940 */     // GIR_Coverage, 52298,
     /* 2281940 */     GIR_EraseRootFromParent_Done,
     /* 2281941 */   // Label 30743: @2281941
     /* 2281941 */   GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2281985), // Rule ID 52299 //
     /* 2281946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2281949 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2281949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2281966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2281973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2281975 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2281977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281984 */     // GIR_Coverage, 52299,
     /* 2281984 */     GIR_EraseRootFromParent_Done,
     /* 2281985 */   // Label 30744: @2281985
     /* 2281985 */   GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2282029), // Rule ID 58134 //
     /* 2281990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2281993 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2281993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282019 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282028 */     // GIR_Coverage, 58134,
     /* 2282028 */     GIR_EraseRootFromParent_Done,
     /* 2282029 */   // Label 30745: @2282029
     /* 2282029 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2282073), // Rule ID 58135 //
     /* 2282034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282037 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282063 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282072 */     // GIR_Coverage, 58135,
     /* 2282072 */     GIR_EraseRootFromParent_Done,
     /* 2282073 */   // Label 30746: @2282073
     /* 2282073 */   GIM_Reject,
     /* 2282074 */ // Label 30742: @2282074
     /* 2282074 */ GIM_Reject,
     /* 2282075 */ // Label 30623: @2282075
     /* 2282075 */ GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2282194),
     /* 2282080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2282089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282101 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282105 */   GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2282149), // Rule ID 52250 //
     /* 2282110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282113 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2282130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282139 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282148 */     // GIR_Coverage, 52250,
     /* 2282148 */     GIR_EraseRootFromParent_Done,
     /* 2282149 */   // Label 30748: @2282149
     /* 2282149 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2282193), // Rule ID 52251 //
     /* 2282154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282157 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2282174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282183 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282192 */     // GIR_Coverage, 52251,
     /* 2282192 */     GIR_EraseRootFromParent_Done,
     /* 2282193 */   // Label 30749: @2282193
     /* 2282193 */   GIM_Reject,
     /* 2282194 */ // Label 30747: @2282194
     /* 2282194 */ GIM_Reject,
     /* 2282195 */ // Label 30624: @2282195
     /* 2282195 */ GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2282402),
     /* 2282200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2282206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2282209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282221 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282225 */   GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2282269), // Rule ID 52268 //
     /* 2282230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282233 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282259 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282268 */     // GIR_Coverage, 52268,
     /* 2282268 */     GIR_EraseRootFromParent_Done,
     /* 2282269 */   // Label 30751: @2282269
     /* 2282269 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2282313), // Rule ID 52269 //
     /* 2282274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282277 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2282277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282303 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282312 */     // GIR_Coverage, 52269,
     /* 2282312 */     GIR_EraseRootFromParent_Done,
     /* 2282313 */   // Label 30752: @2282313
     /* 2282313 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2282357), // Rule ID 58094 //
     /* 2282318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282321 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282347 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282356 */     // GIR_Coverage, 58094,
     /* 2282356 */     GIR_EraseRootFromParent_Done,
     /* 2282357 */   // Label 30753: @2282357
     /* 2282357 */   GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2282401), // Rule ID 58095 //
     /* 2282362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282365 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2282365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282391 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282400 */     // GIR_Coverage, 58095,
     /* 2282400 */     GIR_EraseRootFromParent_Done,
     /* 2282401 */   // Label 30754: @2282401
     /* 2282401 */   GIM_Reject,
     /* 2282402 */ // Label 30750: @2282402
     /* 2282402 */ GIM_Reject,
     /* 2282403 */ // Label 30625: @2282403
     /* 2282403 */ GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2282610),
     /* 2282408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2282414 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2282417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282433 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2282477), // Rule ID 52292 //
     /* 2282438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282441 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2282441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282467 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282476 */     // GIR_Coverage, 52292,
     /* 2282476 */     GIR_EraseRootFromParent_Done,
     /* 2282477 */   // Label 30756: @2282477
     /* 2282477 */   GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2282521), // Rule ID 52293 //
     /* 2282482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282485 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2282485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282511 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282520 */     // GIR_Coverage, 52293,
     /* 2282520 */     GIR_EraseRootFromParent_Done,
     /* 2282521 */   // Label 30757: @2282521
     /* 2282521 */   GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2282565), // Rule ID 58124 //
     /* 2282526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282529 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2282529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282555 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282564 */     // GIR_Coverage, 58124,
     /* 2282564 */     GIR_EraseRootFromParent_Done,
     /* 2282565 */   // Label 30758: @2282565
     /* 2282565 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2282609), // Rule ID 58125 //
     /* 2282570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282573 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2282573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282599 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282608 */     // GIR_Coverage, 58125,
     /* 2282608 */     GIR_EraseRootFromParent_Done,
     /* 2282609 */   // Label 30759: @2282609
     /* 2282609 */   GIM_Reject,
     /* 2282610 */ // Label 30755: @2282610
     /* 2282610 */ GIM_Reject,
     /* 2282611 */ // Label 30626: @2282611
     /* 2282611 */ GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2282818),
     /* 2282616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2282619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2282622 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2282625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2282629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282641 */   GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2282685), // Rule ID 52358 //
     /* 2282646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282649 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2282649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282684 */     // GIR_Coverage, 52358,
     /* 2282684 */     GIR_EraseRootFromParent_Done,
     /* 2282685 */   // Label 30761: @2282685
     /* 2282685 */   GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2282729), // Rule ID 52359 //
     /* 2282690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282693 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282719 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282728 */     // GIR_Coverage, 52359,
     /* 2282728 */     GIR_EraseRootFromParent_Done,
     /* 2282729 */   // Label 30762: @2282729
     /* 2282729 */   GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2282773), // Rule ID 58204 //
     /* 2282734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282737 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2282737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282763 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282772 */     // GIR_Coverage, 58204,
     /* 2282772 */     GIR_EraseRootFromParent_Done,
     /* 2282773 */   // Label 30763: @2282773
     /* 2282773 */   GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2282817), // Rule ID 58205 //
     /* 2282778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282781 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2282781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2282798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282807 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282816 */     // GIR_Coverage, 58205,
     /* 2282816 */     GIR_EraseRootFromParent_Done,
     /* 2282817 */   // Label 30764: @2282817
     /* 2282817 */   GIM_Reject,
     /* 2282818 */ // Label 30760: @2282818
     /* 2282818 */ GIM_Reject,
     /* 2282819 */ // Label 30627: @2282819
     /* 2282819 */ GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2282938),
     /* 2282824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2282827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2282830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2282833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282845 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282849 */   GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2282893), // Rule ID 52256 //
     /* 2282854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282857 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282883 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282892 */     // GIR_Coverage, 52256,
     /* 2282892 */     GIR_EraseRootFromParent_Done,
     /* 2282893 */   // Label 30766: @2282893
     /* 2282893 */   GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2282937), // Rule ID 52257 //
     /* 2282898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282901 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2282904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2282918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2282925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2282927 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2282929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282936 */     // GIR_Coverage, 52257,
     /* 2282936 */     GIR_EraseRootFromParent_Done,
     /* 2282937 */   // Label 30767: @2282937
     /* 2282937 */   GIM_Reject,
     /* 2282938 */ // Label 30765: @2282938
     /* 2282938 */ GIM_Reject,
     /* 2282939 */ // Label 30628: @2282939
     /* 2282939 */ GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2283146),
     /* 2282944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2282947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2282950 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2282953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2282957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2282961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282965 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282969 */   GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2283013), // Rule ID 52286 //
     /* 2282974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282977 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2282977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2282994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283003 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283012 */     // GIR_Coverage, 52286,
     /* 2283012 */     GIR_EraseRootFromParent_Done,
     /* 2283013 */   // Label 30769: @2283013
     /* 2283013 */   GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2283057), // Rule ID 52287 //
     /* 2283018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283021 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283047 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283056 */     // GIR_Coverage, 52287,
     /* 2283056 */     GIR_EraseRootFromParent_Done,
     /* 2283057 */   // Label 30770: @2283057
     /* 2283057 */   GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2283101), // Rule ID 58114 //
     /* 2283062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283065 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283091 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283100 */     // GIR_Coverage, 58114,
     /* 2283100 */     GIR_EraseRootFromParent_Done,
     /* 2283101 */   // Label 30771: @2283101
     /* 2283101 */   GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2283145), // Rule ID 58115 //
     /* 2283106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283109 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283135 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283144 */     // GIR_Coverage, 58115,
     /* 2283144 */     GIR_EraseRootFromParent_Done,
     /* 2283145 */   // Label 30772: @2283145
     /* 2283145 */   GIM_Reject,
     /* 2283146 */ // Label 30768: @2283146
     /* 2283146 */ GIM_Reject,
     /* 2283147 */ // Label 30629: @2283147
     /* 2283147 */ GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2283354),
     /* 2283152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2283155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2283161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2283165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283173 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283177 */   GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2283221), // Rule ID 52340 //
     /* 2283182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283185 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283211 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283220 */     // GIR_Coverage, 52340,
     /* 2283220 */     GIR_EraseRootFromParent_Done,
     /* 2283221 */   // Label 30774: @2283221
     /* 2283221 */   GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2283265), // Rule ID 52341 //
     /* 2283226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283229 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283255 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283264 */     // GIR_Coverage, 52341,
     /* 2283264 */     GIR_EraseRootFromParent_Done,
     /* 2283265 */   // Label 30775: @2283265
     /* 2283265 */   GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2283309), // Rule ID 58174 //
     /* 2283270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283273 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283308 */     // GIR_Coverage, 58174,
     /* 2283308 */     GIR_EraseRootFromParent_Done,
     /* 2283309 */   // Label 30776: @2283309
     /* 2283309 */   GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2283353), // Rule ID 58175 //
     /* 2283314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283317 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283343 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283352 */     // GIR_Coverage, 58175,
     /* 2283352 */     GIR_EraseRootFromParent_Done,
     /* 2283353 */   // Label 30777: @2283353
     /* 2283353 */   GIM_Reject,
     /* 2283354 */ // Label 30773: @2283354
     /* 2283354 */ GIM_Reject,
     /* 2283355 */ // Label 30630: @2283355
     /* 2283355 */ GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2283562),
     /* 2283360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2283363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283366 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2283369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2283373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283385 */   GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2283429), // Rule ID 52364 //
     /* 2283390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283393 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2283393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283419 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283428 */     // GIR_Coverage, 52364,
     /* 2283428 */     GIR_EraseRootFromParent_Done,
     /* 2283429 */   // Label 30779: @2283429
     /* 2283429 */   GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2283473), // Rule ID 52365 //
     /* 2283434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283437 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2283437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283463 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283472 */     // GIR_Coverage, 52365,
     /* 2283472 */     GIR_EraseRootFromParent_Done,
     /* 2283473 */   // Label 30780: @2283473
     /* 2283473 */   GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2283517), // Rule ID 58214 //
     /* 2283478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283481 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2283481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283507 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283516 */     // GIR_Coverage, 58214,
     /* 2283516 */     GIR_EraseRootFromParent_Done,
     /* 2283517 */   // Label 30781: @2283517
     /* 2283517 */   GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2283561), // Rule ID 58215 //
     /* 2283522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283525 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2283525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283551 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283560 */     // GIR_Coverage, 58215,
     /* 2283560 */     GIR_EraseRootFromParent_Done,
     /* 2283561 */   // Label 30782: @2283561
     /* 2283561 */   GIM_Reject,
     /* 2283562 */ // Label 30778: @2283562
     /* 2283562 */ GIM_Reject,
     /* 2283563 */ // Label 30631: @2283563
     /* 2283563 */ GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2283682),
     /* 2283568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283574 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2283577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2283581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283593 */   GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2283637), // Rule ID 52280 //
     /* 2283598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283601 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283627 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283636 */     // GIR_Coverage, 52280,
     /* 2283636 */     GIR_EraseRootFromParent_Done,
     /* 2283637 */   // Label 30784: @2283637
     /* 2283637 */   GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2283681), // Rule ID 52281 //
     /* 2283642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283645 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2283662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283671 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283680 */     // GIR_Coverage, 52281,
     /* 2283680 */     GIR_EraseRootFromParent_Done,
     /* 2283681 */   // Label 30785: @2283681
     /* 2283681 */   GIM_Reject,
     /* 2283682 */ // Label 30783: @2283682
     /* 2283682 */ GIM_Reject,
     /* 2283683 */ // Label 30632: @2283683
     /* 2283683 */ GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2283890),
     /* 2283688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2283694 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2283697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2283701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283709 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283713 */   GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2283757), // Rule ID 52322 //
     /* 2283718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283721 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283747 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283756 */     // GIR_Coverage, 52322,
     /* 2283756 */     GIR_EraseRootFromParent_Done,
     /* 2283757 */   // Label 30787: @2283757
     /* 2283757 */   GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2283801), // Rule ID 52323 //
     /* 2283762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283765 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283791 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283800 */     // GIR_Coverage, 52323,
     /* 2283800 */     GIR_EraseRootFromParent_Done,
     /* 2283801 */   // Label 30788: @2283801
     /* 2283801 */   GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2283845), // Rule ID 58144 //
     /* 2283806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283809 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2283809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283835 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283844 */     // GIR_Coverage, 58144,
     /* 2283844 */     GIR_EraseRootFromParent_Done,
     /* 2283845 */   // Label 30789: @2283845
     /* 2283845 */   GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2283889), // Rule ID 58145 //
     /* 2283850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283853 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2283853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2283870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283879 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283888 */     // GIR_Coverage, 58145,
     /* 2283888 */     GIR_EraseRootFromParent_Done,
     /* 2283889 */   // Label 30790: @2283889
     /* 2283889 */   GIM_Reject,
     /* 2283890 */ // Label 30786: @2283890
     /* 2283890 */ GIM_Reject,
     /* 2283891 */ // Label 30633: @2283891
     /* 2283891 */ GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2284098),
     /* 2283896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2283899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2283902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2283905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2283909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2283913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283917 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283921 */   GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2283965), // Rule ID 52346 //
     /* 2283926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283929 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2283929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283955 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2283957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283964 */     // GIR_Coverage, 52346,
     /* 2283964 */     GIR_EraseRootFromParent_Done,
     /* 2283965 */   // Label 30792: @2283965
     /* 2283965 */   GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2284009), // Rule ID 52347 //
     /* 2283970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283973 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2283973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2283990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2283997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2283999 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284008 */     // GIR_Coverage, 52347,
     /* 2284008 */     GIR_EraseRootFromParent_Done,
     /* 2284009 */   // Label 30793: @2284009
     /* 2284009 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2284053), // Rule ID 58184 //
     /* 2284014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284017 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284043 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284052 */     // GIR_Coverage, 58184,
     /* 2284052 */     GIR_EraseRootFromParent_Done,
     /* 2284053 */   // Label 30794: @2284053
     /* 2284053 */   GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2284097), // Rule ID 58185 //
     /* 2284058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284061 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284087 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284096 */     // GIR_Coverage, 58185,
     /* 2284096 */     GIR_EraseRootFromParent_Done,
     /* 2284097 */   // Label 30795: @2284097
     /* 2284097 */   GIM_Reject,
     /* 2284098 */ // Label 30791: @2284098
     /* 2284098 */ GIM_Reject,
     /* 2284099 */ // Label 30634: @2284099
     /* 2284099 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2284306),
     /* 2284104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2284107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2284110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2284113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284129 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2284173), // Rule ID 52370 //
     /* 2284134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2284137 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2284137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284163 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284172 */     // GIR_Coverage, 52370,
     /* 2284172 */     GIR_EraseRootFromParent_Done,
     /* 2284173 */   // Label 30797: @2284173
     /* 2284173 */   GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2284217), // Rule ID 52371 //
     /* 2284178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2284181 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2284181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284207 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284216 */     // GIR_Coverage, 52371,
     /* 2284216 */     GIR_EraseRootFromParent_Done,
     /* 2284217 */   // Label 30798: @2284217
     /* 2284217 */   GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2284261), // Rule ID 58224 //
     /* 2284222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2284225 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2284225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284260 */     // GIR_Coverage, 58224,
     /* 2284260 */     GIR_EraseRootFromParent_Done,
     /* 2284261 */   // Label 30799: @2284261
     /* 2284261 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2284305), // Rule ID 58225 //
     /* 2284266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2284269 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2284269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284295 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284304 */     // GIR_Coverage, 58225,
     /* 2284304 */     GIR_EraseRootFromParent_Done,
     /* 2284305 */   // Label 30800: @2284305
     /* 2284305 */   GIM_Reject,
     /* 2284306 */ // Label 30796: @2284306
     /* 2284306 */ GIM_Reject,
     /* 2284307 */ // Label 30635: @2284307
     /* 2284307 */ GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2284426),
     /* 2284312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2284318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2284321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2284325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284337 */   GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2284381), // Rule ID 52304 //
     /* 2284342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284345 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2284362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284371 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284380 */     // GIR_Coverage, 52304,
     /* 2284380 */     GIR_EraseRootFromParent_Done,
     /* 2284381 */   // Label 30802: @2284381
     /* 2284381 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2284425), // Rule ID 52305 //
     /* 2284386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284389 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2284406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284415 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284424 */     // GIR_Coverage, 52305,
     /* 2284424 */     GIR_EraseRootFromParent_Done,
     /* 2284425 */   // Label 30803: @2284425
     /* 2284425 */   GIM_Reject,
     /* 2284426 */ // Label 30801: @2284426
     /* 2284426 */ GIM_Reject,
     /* 2284427 */ // Label 30636: @2284427
     /* 2284427 */ GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2284634),
     /* 2284432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2284438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2284441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2284445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284453 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284457 */   GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2284501), // Rule ID 52328 //
     /* 2284462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284465 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2284465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284491 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284500 */     // GIR_Coverage, 52328,
     /* 2284500 */     GIR_EraseRootFromParent_Done,
     /* 2284501 */   // Label 30805: @2284501
     /* 2284501 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2284545), // Rule ID 52329 //
     /* 2284506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284509 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2284509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284535 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284544 */     // GIR_Coverage, 52329,
     /* 2284544 */     GIR_EraseRootFromParent_Done,
     /* 2284545 */   // Label 30806: @2284545
     /* 2284545 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2284589), // Rule ID 58154 //
     /* 2284550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284553 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2284553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284579 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284588 */     // GIR_Coverage, 58154,
     /* 2284588 */     GIR_EraseRootFromParent_Done,
     /* 2284589 */   // Label 30807: @2284589
     /* 2284589 */   GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2284633), // Rule ID 58155 //
     /* 2284594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284597 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2284597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284623 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284632 */     // GIR_Coverage, 58155,
     /* 2284632 */     GIR_EraseRootFromParent_Done,
     /* 2284633 */   // Label 30808: @2284633
     /* 2284633 */   GIM_Reject,
     /* 2284634 */ // Label 30804: @2284634
     /* 2284634 */ GIM_Reject,
     /* 2284635 */ // Label 30637: @2284635
     /* 2284635 */ GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2284842),
     /* 2284640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2284643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2284646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2284649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284661 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284665 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2284709), // Rule ID 52352 //
     /* 2284670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284673 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284699 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284708 */     // GIR_Coverage, 52352,
     /* 2284708 */     GIR_EraseRootFromParent_Done,
     /* 2284709 */   // Label 30810: @2284709
     /* 2284709 */   GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2284753), // Rule ID 52353 //
     /* 2284714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284717 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284743 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284752 */     // GIR_Coverage, 52353,
     /* 2284752 */     GIR_EraseRootFromParent_Done,
     /* 2284753 */   // Label 30811: @2284753
     /* 2284753 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2284797), // Rule ID 58194 //
     /* 2284758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284761 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2284761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284787 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284796 */     // GIR_Coverage, 58194,
     /* 2284796 */     GIR_EraseRootFromParent_Done,
     /* 2284797 */   // Label 30812: @2284797
     /* 2284797 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2284841), // Rule ID 58195 //
     /* 2284802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284805 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2284805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2284822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284831 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284840 */     // GIR_Coverage, 58195,
     /* 2284840 */     GIR_EraseRootFromParent_Done,
     /* 2284841 */   // Label 30813: @2284841
     /* 2284841 */   GIM_Reject,
     /* 2284842 */ // Label 30809: @2284842
     /* 2284842 */ GIM_Reject,
     /* 2284843 */ // Label 30638: @2284843
     /* 2284843 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2284962),
     /* 2284848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2284851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284854 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2284857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2284861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284873 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2284917), // Rule ID 52310 //
     /* 2284878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284881 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284907 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284916 */     // GIR_Coverage, 52310,
     /* 2284916 */     GIR_EraseRootFromParent_Done,
     /* 2284917 */   // Label 30815: @2284917
     /* 2284917 */   GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2284961), // Rule ID 52311 //
     /* 2284922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284925 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2284942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2284949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2284951 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2284953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284960 */     // GIR_Coverage, 52311,
     /* 2284960 */     GIR_EraseRootFromParent_Done,
     /* 2284961 */   // Label 30816: @2284961
     /* 2284961 */   GIM_Reject,
     /* 2284962 */ // Label 30814: @2284962
     /* 2284962 */ GIM_Reject,
     /* 2284963 */ // Label 30639: @2284963
     /* 2284963 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2285170),
     /* 2284968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2284971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2284977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2284981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2284985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284993 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2285037), // Rule ID 52334 //
     /* 2284998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285001 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2285001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285027 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285036 */     // GIR_Coverage, 52334,
     /* 2285036 */     GIR_EraseRootFromParent_Done,
     /* 2285037 */   // Label 30818: @2285037
     /* 2285037 */   GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2285081), // Rule ID 52335 //
     /* 2285042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285045 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2285045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285080 */     // GIR_Coverage, 52335,
     /* 2285080 */     GIR_EraseRootFromParent_Done,
     /* 2285081 */   // Label 30819: @2285081
     /* 2285081 */   GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2285125), // Rule ID 58164 //
     /* 2285086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285089 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2285089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285115 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285124 */     // GIR_Coverage, 58164,
     /* 2285124 */     GIR_EraseRootFromParent_Done,
     /* 2285125 */   // Label 30820: @2285125
     /* 2285125 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2285169), // Rule ID 58165 //
     /* 2285130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285133 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2285133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285168 */     // GIR_Coverage, 58165,
     /* 2285168 */     GIR_EraseRootFromParent_Done,
     /* 2285169 */   // Label 30821: @2285169
     /* 2285169 */   GIM_Reject,
     /* 2285170 */ // Label 30817: @2285170
     /* 2285170 */ GIM_Reject,
     /* 2285171 */ // Label 30640: @2285171
     /* 2285171 */ GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2285290),
     /* 2285176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2285179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2285182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2285185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2285189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2285193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285201 */   GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2285245), // Rule ID 52316 //
     /* 2285206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285209 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285235 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285244 */     // GIR_Coverage, 52316,
     /* 2285244 */     GIR_EraseRootFromParent_Done,
     /* 2285245 */   // Label 30823: @2285245
     /* 2285245 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2285289), // Rule ID 52317 //
     /* 2285250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285253 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2285270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2285277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2285279 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2285281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285288 */     // GIR_Coverage, 52317,
     /* 2285288 */     GIR_EraseRootFromParent_Done,
     /* 2285289 */   // Label 30824: @2285289
     /* 2285289 */   GIM_Reject,
     /* 2285290 */ // Label 30822: @2285290
     /* 2285290 */ GIM_Reject,
     /* 2285291 */ // Label 30641: @2285291
     /* 2285291 */ GIM_Reject,
     /* 2285292 */ // Label 51: @2285292
     /* 2285292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30849*/ GIMT_Encode4(2288025),
     /* 2285303 */ /*GILLT_s32*//*Label 30825*/ GIMT_Encode4(2285427),
     /* 2285307 */ /*GILLT_s64*//*Label 30826*/ GIMT_Encode4(2285461), GIMT_Encode4(0),
     /* 2285315 */ /*GILLT_nxv1s8*//*Label 30827*/ GIMT_Encode4(2285495),
     /* 2285319 */ /*GILLT_nxv1s16*//*Label 30828*/ GIMT_Encode4(2285610),
     /* 2285323 */ /*GILLT_nxv1s32*//*Label 30829*/ GIMT_Encode4(2285725),
     /* 2285327 */ /*GILLT_nxv1s64*//*Label 30830*/ GIMT_Encode4(2285840), GIMT_Encode4(0),
     /* 2285335 */ /*GILLT_nxv2s8*//*Label 30831*/ GIMT_Encode4(2285955),
     /* 2285339 */ /*GILLT_nxv2s16*//*Label 30832*/ GIMT_Encode4(2286070),
     /* 2285343 */ /*GILLT_nxv2s32*//*Label 30833*/ GIMT_Encode4(2286185),
     /* 2285347 */ /*GILLT_nxv2s64*//*Label 30834*/ GIMT_Encode4(2286300), GIMT_Encode4(0),
     /* 2285355 */ /*GILLT_nxv4s8*//*Label 30835*/ GIMT_Encode4(2286415),
     /* 2285359 */ /*GILLT_nxv4s16*//*Label 30836*/ GIMT_Encode4(2286530),
     /* 2285363 */ /*GILLT_nxv4s32*//*Label 30837*/ GIMT_Encode4(2286645),
     /* 2285367 */ /*GILLT_nxv4s64*//*Label 30838*/ GIMT_Encode4(2286760), GIMT_Encode4(0),
     /* 2285375 */ /*GILLT_nxv8s8*//*Label 30839*/ GIMT_Encode4(2286875),
     /* 2285379 */ /*GILLT_nxv8s16*//*Label 30840*/ GIMT_Encode4(2286990),
     /* 2285383 */ /*GILLT_nxv8s32*//*Label 30841*/ GIMT_Encode4(2287105),
     /* 2285387 */ /*GILLT_nxv8s64*//*Label 30842*/ GIMT_Encode4(2287220), GIMT_Encode4(0),
     /* 2285395 */ /*GILLT_nxv16s8*//*Label 30843*/ GIMT_Encode4(2287335),
     /* 2285399 */ /*GILLT_nxv16s16*//*Label 30844*/ GIMT_Encode4(2287450),
     /* 2285403 */ /*GILLT_nxv16s32*//*Label 30845*/ GIMT_Encode4(2287565), GIMT_Encode4(0),
     /* 2285411 */ /*GILLT_nxv32s8*//*Label 30846*/ GIMT_Encode4(2287680),
     /* 2285415 */ /*GILLT_nxv32s16*//*Label 30847*/ GIMT_Encode4(2287795), GIMT_Encode4(0),
     /* 2285423 */ /*GILLT_nxv64s8*//*Label 30848*/ GIMT_Encode4(2287910),
     /* 2285427 */ // Label 30825: @2285427
     /* 2285427 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2285460), // Rule ID 306 //
     /* 2285432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2285435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285453 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2285453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2285458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2285459 */   // GIR_Coverage, 306,
     /* 2285459 */   GIR_Done,
     /* 2285460 */ // Label 30850: @2285460
     /* 2285460 */ GIM_Reject,
     /* 2285461 */ // Label 30826: @2285461
     /* 2285461 */ GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2285494), // Rule ID 305 //
     /* 2285466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2285469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2285475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285487 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2285487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2285492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2285493 */   // GIR_Coverage, 305,
     /* 2285493 */   GIR_Done,
     /* 2285494 */ // Label 30851: @2285494
     /* 2285494 */ GIM_Reject,
     /* 2285495 */ // Label 30827: @2285495
     /* 2285495 */ GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2285609),
     /* 2285500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2285503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2285506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285518 */   GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2285563), // Rule ID 51020 //
     /* 2285523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285526 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2285543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285562 */     // GIR_Coverage, 51020,
     /* 2285562 */     GIR_EraseRootFromParent_Done,
     /* 2285563 */   // Label 30853: @2285563
     /* 2285563 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2285608), // Rule ID 51021 //
     /* 2285568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285571 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2285574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2285588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285607 */     // GIR_Coverage, 51021,
     /* 2285607 */     GIR_EraseRootFromParent_Done,
     /* 2285608 */   // Label 30854: @2285608
     /* 2285608 */   GIM_Reject,
     /* 2285609 */ // Label 30852: @2285609
     /* 2285609 */ GIM_Reject,
     /* 2285610 */ // Label 30828: @2285610
     /* 2285610 */ GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2285724),
     /* 2285615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2285618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2285621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285633 */   GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2285678), // Rule ID 51032 //
     /* 2285638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285641 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2285658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285677 */     // GIR_Coverage, 51032,
     /* 2285677 */     GIR_EraseRootFromParent_Done,
     /* 2285678 */   // Label 30856: @2285678
     /* 2285678 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2285723), // Rule ID 51033 //
     /* 2285683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285686 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2285703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285722 */     // GIR_Coverage, 51033,
     /* 2285722 */     GIR_EraseRootFromParent_Done,
     /* 2285723 */   // Label 30857: @2285723
     /* 2285723 */   GIM_Reject,
     /* 2285724 */ // Label 30855: @2285724
     /* 2285724 */ GIM_Reject,
     /* 2285725 */ // Label 30829: @2285725
     /* 2285725 */ GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2285839),
     /* 2285730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2285733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2285736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285748 */   GIM_Try, /*On fail goto*//*Label 30859*/ GIMT_Encode4(2285793), // Rule ID 51040 //
     /* 2285753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285756 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2285773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285792 */     // GIR_Coverage, 51040,
     /* 2285792 */     GIR_EraseRootFromParent_Done,
     /* 2285793 */   // Label 30859: @2285793
     /* 2285793 */   GIM_Try, /*On fail goto*//*Label 30860*/ GIMT_Encode4(2285838), // Rule ID 51041 //
     /* 2285798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285801 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2285818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285837 */     // GIR_Coverage, 51041,
     /* 2285837 */     GIR_EraseRootFromParent_Done,
     /* 2285838 */   // Label 30860: @2285838
     /* 2285838 */   GIM_Reject,
     /* 2285839 */ // Label 30858: @2285839
     /* 2285839 */ GIM_Reject,
     /* 2285840 */ // Label 30830: @2285840
     /* 2285840 */ GIM_Try, /*On fail goto*//*Label 30861*/ GIMT_Encode4(2285954),
     /* 2285845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2285848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2285851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285863 */   GIM_Try, /*On fail goto*//*Label 30862*/ GIMT_Encode4(2285908), // Rule ID 51108 //
     /* 2285868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2285871 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2285888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285907 */     // GIR_Coverage, 51108,
     /* 2285907 */     GIR_EraseRootFromParent_Done,
     /* 2285908 */   // Label 30862: @2285908
     /* 2285908 */   GIM_Try, /*On fail goto*//*Label 30863*/ GIMT_Encode4(2285953), // Rule ID 51109 //
     /* 2285913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2285916 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2285933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285952 */     // GIR_Coverage, 51109,
     /* 2285952 */     GIR_EraseRootFromParent_Done,
     /* 2285953 */   // Label 30863: @2285953
     /* 2285953 */   GIM_Reject,
     /* 2285954 */ // Label 30861: @2285954
     /* 2285954 */ GIM_Reject,
     /* 2285955 */ // Label 30831: @2285955
     /* 2285955 */ GIM_Try, /*On fail goto*//*Label 30864*/ GIMT_Encode4(2286069),
     /* 2285960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2285963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2285966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285978 */   GIM_Try, /*On fail goto*//*Label 30865*/ GIMT_Encode4(2286023), // Rule ID 51024 //
     /* 2285983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285986 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2286003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286022 */     // GIR_Coverage, 51024,
     /* 2286022 */     GIR_EraseRootFromParent_Done,
     /* 2286023 */   // Label 30865: @2286023
     /* 2286023 */   GIM_Try, /*On fail goto*//*Label 30866*/ GIMT_Encode4(2286068), // Rule ID 51025 //
     /* 2286028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286031 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2286034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2286048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286067 */     // GIR_Coverage, 51025,
     /* 2286067 */     GIR_EraseRootFromParent_Done,
     /* 2286068 */   // Label 30866: @2286068
     /* 2286068 */   GIM_Reject,
     /* 2286069 */ // Label 30864: @2286069
     /* 2286069 */ GIM_Reject,
     /* 2286070 */ // Label 30832: @2286070
     /* 2286070 */ GIM_Try, /*On fail goto*//*Label 30867*/ GIMT_Encode4(2286184),
     /* 2286075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2286078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2286081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286093 */   GIM_Try, /*On fail goto*//*Label 30868*/ GIMT_Encode4(2286138), // Rule ID 51036 //
     /* 2286098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286101 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286137 */     // GIR_Coverage, 51036,
     /* 2286137 */     GIR_EraseRootFromParent_Done,
     /* 2286138 */   // Label 30868: @2286138
     /* 2286138 */   GIM_Try, /*On fail goto*//*Label 30869*/ GIMT_Encode4(2286183), // Rule ID 51037 //
     /* 2286143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286146 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286182 */     // GIR_Coverage, 51037,
     /* 2286182 */     GIR_EraseRootFromParent_Done,
     /* 2286183 */   // Label 30869: @2286183
     /* 2286183 */   GIM_Reject,
     /* 2286184 */ // Label 30867: @2286184
     /* 2286184 */ GIM_Reject,
     /* 2286185 */ // Label 30833: @2286185
     /* 2286185 */ GIM_Try, /*On fail goto*//*Label 30870*/ GIMT_Encode4(2286299),
     /* 2286190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2286193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2286196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286208 */   GIM_Try, /*On fail goto*//*Label 30871*/ GIMT_Encode4(2286253), // Rule ID 51052 //
     /* 2286213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286216 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286252 */     // GIR_Coverage, 51052,
     /* 2286252 */     GIR_EraseRootFromParent_Done,
     /* 2286253 */   // Label 30871: @2286253
     /* 2286253 */   GIM_Try, /*On fail goto*//*Label 30872*/ GIMT_Encode4(2286298), // Rule ID 51053 //
     /* 2286258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286261 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286297 */     // GIR_Coverage, 51053,
     /* 2286297 */     GIR_EraseRootFromParent_Done,
     /* 2286298 */   // Label 30872: @2286298
     /* 2286298 */   GIM_Reject,
     /* 2286299 */ // Label 30870: @2286299
     /* 2286299 */ GIM_Reject,
     /* 2286300 */ // Label 30834: @2286300
     /* 2286300 */ GIM_Try, /*On fail goto*//*Label 30873*/ GIMT_Encode4(2286414),
     /* 2286305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2286308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2286311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286323 */   GIM_Try, /*On fail goto*//*Label 30874*/ GIMT_Encode4(2286368), // Rule ID 51112 //
     /* 2286328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2286331 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286367 */     // GIR_Coverage, 51112,
     /* 2286367 */     GIR_EraseRootFromParent_Done,
     /* 2286368 */   // Label 30874: @2286368
     /* 2286368 */   GIM_Try, /*On fail goto*//*Label 30875*/ GIMT_Encode4(2286413), // Rule ID 51113 //
     /* 2286373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2286376 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286412 */     // GIR_Coverage, 51113,
     /* 2286412 */     GIR_EraseRootFromParent_Done,
     /* 2286413 */   // Label 30875: @2286413
     /* 2286413 */   GIM_Reject,
     /* 2286414 */ // Label 30873: @2286414
     /* 2286414 */ GIM_Reject,
     /* 2286415 */ // Label 30835: @2286415
     /* 2286415 */ GIM_Try, /*On fail goto*//*Label 30876*/ GIMT_Encode4(2286529),
     /* 2286420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2286423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2286426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286438 */   GIM_Try, /*On fail goto*//*Label 30877*/ GIMT_Encode4(2286483), // Rule ID 51028 //
     /* 2286443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286446 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286482 */     // GIR_Coverage, 51028,
     /* 2286482 */     GIR_EraseRootFromParent_Done,
     /* 2286483 */   // Label 30877: @2286483
     /* 2286483 */   GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2286528), // Rule ID 51029 //
     /* 2286488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286491 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2286494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2286508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286527 */     // GIR_Coverage, 51029,
     /* 2286527 */     GIR_EraseRootFromParent_Done,
     /* 2286528 */   // Label 30878: @2286528
     /* 2286528 */   GIM_Reject,
     /* 2286529 */ // Label 30876: @2286529
     /* 2286529 */ GIM_Reject,
     /* 2286530 */ // Label 30836: @2286530
     /* 2286530 */ GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2286644),
     /* 2286535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2286538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2286541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286553 */   GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2286598), // Rule ID 51048 //
     /* 2286558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286561 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286597 */     // GIR_Coverage, 51048,
     /* 2286597 */     GIR_EraseRootFromParent_Done,
     /* 2286598 */   // Label 30880: @2286598
     /* 2286598 */   GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2286643), // Rule ID 51049 //
     /* 2286603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286606 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286642 */     // GIR_Coverage, 51049,
     /* 2286642 */     GIR_EraseRootFromParent_Done,
     /* 2286643 */   // Label 30881: @2286643
     /* 2286643 */   GIM_Reject,
     /* 2286644 */ // Label 30879: @2286644
     /* 2286644 */ GIM_Reject,
     /* 2286645 */ // Label 30837: @2286645
     /* 2286645 */ GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2286759),
     /* 2286650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2286653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2286656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286668 */   GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2286713), // Rule ID 51080 //
     /* 2286673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286676 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286712 */     // GIR_Coverage, 51080,
     /* 2286712 */     GIR_EraseRootFromParent_Done,
     /* 2286713 */   // Label 30883: @2286713
     /* 2286713 */   GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2286758), // Rule ID 51081 //
     /* 2286718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286721 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2286738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286757 */     // GIR_Coverage, 51081,
     /* 2286757 */     GIR_EraseRootFromParent_Done,
     /* 2286758 */   // Label 30884: @2286758
     /* 2286758 */   GIM_Reject,
     /* 2286759 */ // Label 30882: @2286759
     /* 2286759 */ GIM_Reject,
     /* 2286760 */ // Label 30838: @2286760
     /* 2286760 */ GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2286874),
     /* 2286765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2286768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2286771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286783 */   GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2286828), // Rule ID 51116 //
     /* 2286788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2286791 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2286808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286827 */     // GIR_Coverage, 51116,
     /* 2286827 */     GIR_EraseRootFromParent_Done,
     /* 2286828 */   // Label 30886: @2286828
     /* 2286828 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2286873), // Rule ID 51117 //
     /* 2286833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2286836 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2286853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286872 */     // GIR_Coverage, 51117,
     /* 2286872 */     GIR_EraseRootFromParent_Done,
     /* 2286873 */   // Label 30887: @2286873
     /* 2286873 */   GIM_Reject,
     /* 2286874 */ // Label 30885: @2286874
     /* 2286874 */ GIM_Reject,
     /* 2286875 */ // Label 30839: @2286875
     /* 2286875 */ GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2286989),
     /* 2286880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2286883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2286886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286898 */   GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2286943), // Rule ID 51044 //
     /* 2286903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286906 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286942 */     // GIR_Coverage, 51044,
     /* 2286942 */     GIR_EraseRootFromParent_Done,
     /* 2286943 */   // Label 30889: @2286943
     /* 2286943 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2286988), // Rule ID 51045 //
     /* 2286948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286951 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2286968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286987 */     // GIR_Coverage, 51045,
     /* 2286987 */     GIR_EraseRootFromParent_Done,
     /* 2286988 */   // Label 30890: @2286988
     /* 2286988 */   GIM_Reject,
     /* 2286989 */ // Label 30888: @2286989
     /* 2286989 */ GIM_Reject,
     /* 2286990 */ // Label 30840: @2286990
     /* 2286990 */ GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2287104),
     /* 2286995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2286998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2287001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287013 */   GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2287058), // Rule ID 51068 //
     /* 2287018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287021 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287057 */     // GIR_Coverage, 51068,
     /* 2287057 */     GIR_EraseRootFromParent_Done,
     /* 2287058 */   // Label 30892: @2287058
     /* 2287058 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2287103), // Rule ID 51069 //
     /* 2287063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287066 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287102 */     // GIR_Coverage, 51069,
     /* 2287102 */     GIR_EraseRootFromParent_Done,
     /* 2287103 */   // Label 30893: @2287103
     /* 2287103 */   GIM_Reject,
     /* 2287104 */ // Label 30891: @2287104
     /* 2287104 */ GIM_Reject,
     /* 2287105 */ // Label 30841: @2287105
     /* 2287105 */ GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2287219),
     /* 2287110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2287113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2287116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287128 */   GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2287173), // Rule ID 51084 //
     /* 2287133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287136 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287172 */     // GIR_Coverage, 51084,
     /* 2287172 */     GIR_EraseRootFromParent_Done,
     /* 2287173 */   // Label 30895: @2287173
     /* 2287173 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2287218), // Rule ID 51085 //
     /* 2287178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287181 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287217 */     // GIR_Coverage, 51085,
     /* 2287217 */     GIR_EraseRootFromParent_Done,
     /* 2287218 */   // Label 30896: @2287218
     /* 2287218 */   GIM_Reject,
     /* 2287219 */ // Label 30894: @2287219
     /* 2287219 */ GIM_Reject,
     /* 2287220 */ // Label 30842: @2287220
     /* 2287220 */ GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2287334),
     /* 2287225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2287228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2287231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287243 */   GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2287288), // Rule ID 51120 //
     /* 2287248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2287251 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287287 */     // GIR_Coverage, 51120,
     /* 2287287 */     GIR_EraseRootFromParent_Done,
     /* 2287288 */   // Label 30898: @2287288
     /* 2287288 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2287333), // Rule ID 51121 //
     /* 2287293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2287296 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287332 */     // GIR_Coverage, 51121,
     /* 2287332 */     GIR_EraseRootFromParent_Done,
     /* 2287333 */   // Label 30899: @2287333
     /* 2287333 */   GIM_Reject,
     /* 2287334 */ // Label 30897: @2287334
     /* 2287334 */ GIM_Reject,
     /* 2287335 */ // Label 30843: @2287335
     /* 2287335 */ GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2287449),
     /* 2287340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2287343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2287346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287358 */   GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2287403), // Rule ID 51056 //
     /* 2287363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287366 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287402 */     // GIR_Coverage, 51056,
     /* 2287402 */     GIR_EraseRootFromParent_Done,
     /* 2287403 */   // Label 30901: @2287403
     /* 2287403 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2287448), // Rule ID 51057 //
     /* 2287408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287411 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2287414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2287428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287447 */     // GIR_Coverage, 51057,
     /* 2287447 */     GIR_EraseRootFromParent_Done,
     /* 2287448 */   // Label 30902: @2287448
     /* 2287448 */   GIM_Reject,
     /* 2287449 */ // Label 30900: @2287449
     /* 2287449 */ GIM_Reject,
     /* 2287450 */ // Label 30844: @2287450
     /* 2287450 */ GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2287564),
     /* 2287455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2287458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2287461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287473 */   GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2287518), // Rule ID 51072 //
     /* 2287478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287481 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287517 */     // GIR_Coverage, 51072,
     /* 2287517 */     GIR_EraseRootFromParent_Done,
     /* 2287518 */   // Label 30904: @2287518
     /* 2287518 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2287563), // Rule ID 51073 //
     /* 2287523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287526 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287562 */     // GIR_Coverage, 51073,
     /* 2287562 */     GIR_EraseRootFromParent_Done,
     /* 2287563 */   // Label 30905: @2287563
     /* 2287563 */   GIM_Reject,
     /* 2287564 */ // Label 30903: @2287564
     /* 2287564 */ GIM_Reject,
     /* 2287565 */ // Label 30845: @2287565
     /* 2287565 */ GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2287679),
     /* 2287570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2287573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2287576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287588 */   GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2287633), // Rule ID 51088 //
     /* 2287593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287596 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287632 */     // GIR_Coverage, 51088,
     /* 2287632 */     GIR_EraseRootFromParent_Done,
     /* 2287633 */   // Label 30907: @2287633
     /* 2287633 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2287678), // Rule ID 51089 //
     /* 2287638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287641 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287677 */     // GIR_Coverage, 51089,
     /* 2287677 */     GIR_EraseRootFromParent_Done,
     /* 2287678 */   // Label 30908: @2287678
     /* 2287678 */   GIM_Reject,
     /* 2287679 */ // Label 30906: @2287679
     /* 2287679 */ GIM_Reject,
     /* 2287680 */ // Label 30846: @2287680
     /* 2287680 */ GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2287794),
     /* 2287685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2287688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2287691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287703 */   GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2287748), // Rule ID 51060 //
     /* 2287708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287711 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287747 */     // GIR_Coverage, 51060,
     /* 2287747 */     GIR_EraseRootFromParent_Done,
     /* 2287748 */   // Label 30910: @2287748
     /* 2287748 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2287793), // Rule ID 51061 //
     /* 2287753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287756 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2287773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287792 */     // GIR_Coverage, 51061,
     /* 2287792 */     GIR_EraseRootFromParent_Done,
     /* 2287793 */   // Label 30911: @2287793
     /* 2287793 */   GIM_Reject,
     /* 2287794 */ // Label 30909: @2287794
     /* 2287794 */ GIM_Reject,
     /* 2287795 */ // Label 30847: @2287795
     /* 2287795 */ GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2287909),
     /* 2287800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2287803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2287806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287818 */   GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2287863), // Rule ID 51076 //
     /* 2287823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287826 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287862 */     // GIR_Coverage, 51076,
     /* 2287862 */     GIR_EraseRootFromParent_Done,
     /* 2287863 */   // Label 30913: @2287863
     /* 2287863 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2287908), // Rule ID 51077 //
     /* 2287868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287871 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287907 */     // GIR_Coverage, 51077,
     /* 2287907 */     GIR_EraseRootFromParent_Done,
     /* 2287908 */   // Label 30914: @2287908
     /* 2287908 */   GIM_Reject,
     /* 2287909 */ // Label 30912: @2287909
     /* 2287909 */ GIM_Reject,
     /* 2287910 */ // Label 30848: @2287910
     /* 2287910 */ GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2288024),
     /* 2287915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2287918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2287921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287933 */   GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2287978), // Rule ID 51064 //
     /* 2287938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287941 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2287958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287977 */     // GIR_Coverage, 51064,
     /* 2287977 */     GIR_EraseRootFromParent_Done,
     /* 2287978 */   // Label 30916: @2287978
     /* 2287978 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2288023), // Rule ID 51065 //
     /* 2287983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287986 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2288003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288022 */     // GIR_Coverage, 51065,
     /* 2288022 */     GIR_EraseRootFromParent_Done,
     /* 2288023 */   // Label 30917: @2288023
     /* 2288023 */   GIM_Reject,
     /* 2288024 */ // Label 30915: @2288024
     /* 2288024 */ GIM_Reject,
     /* 2288025 */ // Label 30849: @2288025
     /* 2288025 */ GIM_Reject,
     /* 2288026 */ // Label 52: @2288026
     /* 2288026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30942*/ GIMT_Encode4(2290759),
     /* 2288037 */ /*GILLT_s32*//*Label 30918*/ GIMT_Encode4(2288161),
     /* 2288041 */ /*GILLT_s64*//*Label 30919*/ GIMT_Encode4(2288195), GIMT_Encode4(0),
     /* 2288049 */ /*GILLT_nxv1s8*//*Label 30920*/ GIMT_Encode4(2288229),
     /* 2288053 */ /*GILLT_nxv1s16*//*Label 30921*/ GIMT_Encode4(2288344),
     /* 2288057 */ /*GILLT_nxv1s32*//*Label 30922*/ GIMT_Encode4(2288459),
     /* 2288061 */ /*GILLT_nxv1s64*//*Label 30923*/ GIMT_Encode4(2288574), GIMT_Encode4(0),
     /* 2288069 */ /*GILLT_nxv2s8*//*Label 30924*/ GIMT_Encode4(2288689),
     /* 2288073 */ /*GILLT_nxv2s16*//*Label 30925*/ GIMT_Encode4(2288804),
     /* 2288077 */ /*GILLT_nxv2s32*//*Label 30926*/ GIMT_Encode4(2288919),
     /* 2288081 */ /*GILLT_nxv2s64*//*Label 30927*/ GIMT_Encode4(2289034), GIMT_Encode4(0),
     /* 2288089 */ /*GILLT_nxv4s8*//*Label 30928*/ GIMT_Encode4(2289149),
     /* 2288093 */ /*GILLT_nxv4s16*//*Label 30929*/ GIMT_Encode4(2289264),
     /* 2288097 */ /*GILLT_nxv4s32*//*Label 30930*/ GIMT_Encode4(2289379),
     /* 2288101 */ /*GILLT_nxv4s64*//*Label 30931*/ GIMT_Encode4(2289494), GIMT_Encode4(0),
     /* 2288109 */ /*GILLT_nxv8s8*//*Label 30932*/ GIMT_Encode4(2289609),
     /* 2288113 */ /*GILLT_nxv8s16*//*Label 30933*/ GIMT_Encode4(2289724),
     /* 2288117 */ /*GILLT_nxv8s32*//*Label 30934*/ GIMT_Encode4(2289839),
     /* 2288121 */ /*GILLT_nxv8s64*//*Label 30935*/ GIMT_Encode4(2289954), GIMT_Encode4(0),
     /* 2288129 */ /*GILLT_nxv16s8*//*Label 30936*/ GIMT_Encode4(2290069),
     /* 2288133 */ /*GILLT_nxv16s16*//*Label 30937*/ GIMT_Encode4(2290184),
     /* 2288137 */ /*GILLT_nxv16s32*//*Label 30938*/ GIMT_Encode4(2290299), GIMT_Encode4(0),
     /* 2288145 */ /*GILLT_nxv32s8*//*Label 30939*/ GIMT_Encode4(2290414),
     /* 2288149 */ /*GILLT_nxv32s16*//*Label 30940*/ GIMT_Encode4(2290529), GIMT_Encode4(0),
     /* 2288157 */ /*GILLT_nxv64s8*//*Label 30941*/ GIMT_Encode4(2290644),
     /* 2288161 */ // Label 30918: @2288161
     /* 2288161 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2288194), // Rule ID 304 //
     /* 2288166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2288169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2288172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2288175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288187 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2288187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2288192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2288193 */   // GIR_Coverage, 304,
     /* 2288193 */   GIR_Done,
     /* 2288194 */ // Label 30943: @2288194
     /* 2288194 */ GIM_Reject,
     /* 2288195 */ // Label 30919: @2288195
     /* 2288195 */ GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2288228), // Rule ID 303 //
     /* 2288200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2288203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2288206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2288209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288221 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2288221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2288226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2288227 */   // GIR_Coverage, 303,
     /* 2288227 */   GIR_Done,
     /* 2288228 */ // Label 30944: @2288228
     /* 2288228 */ GIM_Reject,
     /* 2288229 */ // Label 30920: @2288229
     /* 2288229 */ GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2288343),
     /* 2288234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2288237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2288240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288252 */   GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2288297), // Rule ID 50948 //
     /* 2288257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288260 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2288277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288296 */     // GIR_Coverage, 50948,
     /* 2288296 */     GIR_EraseRootFromParent_Done,
     /* 2288297 */   // Label 30946: @2288297
     /* 2288297 */   GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2288342), // Rule ID 50949 //
     /* 2288302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288305 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2288308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2288322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288341 */     // GIR_Coverage, 50949,
     /* 2288341 */     GIR_EraseRootFromParent_Done,
     /* 2288342 */   // Label 30947: @2288342
     /* 2288342 */   GIM_Reject,
     /* 2288343 */ // Label 30945: @2288343
     /* 2288343 */ GIM_Reject,
     /* 2288344 */ // Label 30921: @2288344
     /* 2288344 */ GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2288458),
     /* 2288349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2288352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2288355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288367 */   GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2288412), // Rule ID 50960 //
     /* 2288372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288375 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288411 */     // GIR_Coverage, 50960,
     /* 2288411 */     GIR_EraseRootFromParent_Done,
     /* 2288412 */   // Label 30949: @2288412
     /* 2288412 */   GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2288457), // Rule ID 50961 //
     /* 2288417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288420 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288456 */     // GIR_Coverage, 50961,
     /* 2288456 */     GIR_EraseRootFromParent_Done,
     /* 2288457 */   // Label 30950: @2288457
     /* 2288457 */   GIM_Reject,
     /* 2288458 */ // Label 30948: @2288458
     /* 2288458 */ GIM_Reject,
     /* 2288459 */ // Label 30922: @2288459
     /* 2288459 */ GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2288573),
     /* 2288464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2288470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288482 */   GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2288527), // Rule ID 50968 //
     /* 2288487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288490 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288526 */     // GIR_Coverage, 50968,
     /* 2288526 */     GIR_EraseRootFromParent_Done,
     /* 2288527 */   // Label 30952: @2288527
     /* 2288527 */   GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2288572), // Rule ID 50969 //
     /* 2288532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288535 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288571 */     // GIR_Coverage, 50969,
     /* 2288571 */     GIR_EraseRootFromParent_Done,
     /* 2288572 */   // Label 30953: @2288572
     /* 2288572 */   GIM_Reject,
     /* 2288573 */ // Label 30951: @2288573
     /* 2288573 */ GIM_Reject,
     /* 2288574 */ // Label 30923: @2288574
     /* 2288574 */ GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2288688),
     /* 2288579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288597 */   GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2288642), // Rule ID 51092 //
     /* 2288602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2288605 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288641 */     // GIR_Coverage, 51092,
     /* 2288641 */     GIR_EraseRootFromParent_Done,
     /* 2288642 */   // Label 30955: @2288642
     /* 2288642 */   GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2288687), // Rule ID 51093 //
     /* 2288647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2288650 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288686 */     // GIR_Coverage, 51093,
     /* 2288686 */     GIR_EraseRootFromParent_Done,
     /* 2288687 */   // Label 30956: @2288687
     /* 2288687 */   GIM_Reject,
     /* 2288688 */ // Label 30954: @2288688
     /* 2288688 */ GIM_Reject,
     /* 2288689 */ // Label 30924: @2288689
     /* 2288689 */ GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2288803),
     /* 2288694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2288697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2288700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288712 */   GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2288757), // Rule ID 50952 //
     /* 2288717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288720 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288756 */     // GIR_Coverage, 50952,
     /* 2288756 */     GIR_EraseRootFromParent_Done,
     /* 2288757 */   // Label 30958: @2288757
     /* 2288757 */   GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2288802), // Rule ID 50953 //
     /* 2288762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288765 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2288782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288801 */     // GIR_Coverage, 50953,
     /* 2288801 */     GIR_EraseRootFromParent_Done,
     /* 2288802 */   // Label 30959: @2288802
     /* 2288802 */   GIM_Reject,
     /* 2288803 */ // Label 30957: @2288803
     /* 2288803 */ GIM_Reject,
     /* 2288804 */ // Label 30925: @2288804
     /* 2288804 */ GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2288918),
     /* 2288809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2288812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2288815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288827 */   GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2288872), // Rule ID 50964 //
     /* 2288832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288835 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288871 */     // GIR_Coverage, 50964,
     /* 2288871 */     GIR_EraseRootFromParent_Done,
     /* 2288872 */   // Label 30961: @2288872
     /* 2288872 */   GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2288917), // Rule ID 50965 //
     /* 2288877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288880 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2288897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288916 */     // GIR_Coverage, 50965,
     /* 2288916 */     GIR_EraseRootFromParent_Done,
     /* 2288917 */   // Label 30962: @2288917
     /* 2288917 */   GIM_Reject,
     /* 2288918 */ // Label 30960: @2288918
     /* 2288918 */ GIM_Reject,
     /* 2288919 */ // Label 30926: @2288919
     /* 2288919 */ GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2289033),
     /* 2288924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288942 */   GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2288987), // Rule ID 50980 //
     /* 2288947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288950 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2288967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288986 */     // GIR_Coverage, 50980,
     /* 2288986 */     GIR_EraseRootFromParent_Done,
     /* 2288987 */   // Label 30964: @2288987
     /* 2288987 */   GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2289032), // Rule ID 50981 //
     /* 2288992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288995 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289031 */     // GIR_Coverage, 50981,
     /* 2289031 */     GIR_EraseRootFromParent_Done,
     /* 2289032 */   // Label 30965: @2289032
     /* 2289032 */   GIM_Reject,
     /* 2289033 */ // Label 30963: @2289033
     /* 2289033 */ GIM_Reject,
     /* 2289034 */ // Label 30927: @2289034
     /* 2289034 */ GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2289148),
     /* 2289039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2289042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2289045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289057 */   GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2289102), // Rule ID 51096 //
     /* 2289062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289065 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2289068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289101 */     // GIR_Coverage, 51096,
     /* 2289101 */     GIR_EraseRootFromParent_Done,
     /* 2289102 */   // Label 30967: @2289102
     /* 2289102 */   GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2289147), // Rule ID 51097 //
     /* 2289107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2289110 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2289113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289146 */     // GIR_Coverage, 51097,
     /* 2289146 */     GIR_EraseRootFromParent_Done,
     /* 2289147 */   // Label 30968: @2289147
     /* 2289147 */   GIM_Reject,
     /* 2289148 */ // Label 30966: @2289148
     /* 2289148 */ GIM_Reject,
     /* 2289149 */ // Label 30928: @2289149
     /* 2289149 */ GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2289263),
     /* 2289154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2289157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2289160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289172 */   GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2289217), // Rule ID 50956 //
     /* 2289177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289180 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2289197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289216 */     // GIR_Coverage, 50956,
     /* 2289216 */     GIR_EraseRootFromParent_Done,
     /* 2289217 */   // Label 30970: @2289217
     /* 2289217 */   GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2289262), // Rule ID 50957 //
     /* 2289222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289225 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2289228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2289242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289261 */     // GIR_Coverage, 50957,
     /* 2289261 */     GIR_EraseRootFromParent_Done,
     /* 2289262 */   // Label 30971: @2289262
     /* 2289262 */   GIM_Reject,
     /* 2289263 */ // Label 30969: @2289263
     /* 2289263 */ GIM_Reject,
     /* 2289264 */ // Label 30929: @2289264
     /* 2289264 */ GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2289378),
     /* 2289269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2289272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2289275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289287 */   GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2289332), // Rule ID 50976 //
     /* 2289292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289295 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289331 */     // GIR_Coverage, 50976,
     /* 2289331 */     GIR_EraseRootFromParent_Done,
     /* 2289332 */   // Label 30973: @2289332
     /* 2289332 */   GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2289377), // Rule ID 50977 //
     /* 2289337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289340 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289376 */     // GIR_Coverage, 50977,
     /* 2289376 */     GIR_EraseRootFromParent_Done,
     /* 2289377 */   // Label 30974: @2289377
     /* 2289377 */   GIM_Reject,
     /* 2289378 */ // Label 30972: @2289378
     /* 2289378 */ GIM_Reject,
     /* 2289379 */ // Label 30930: @2289379
     /* 2289379 */ GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2289493),
     /* 2289384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2289387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2289390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289402 */   GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2289447), // Rule ID 51008 //
     /* 2289407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289410 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289446 */     // GIR_Coverage, 51008,
     /* 2289446 */     GIR_EraseRootFromParent_Done,
     /* 2289447 */   // Label 30976: @2289447
     /* 2289447 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2289492), // Rule ID 51009 //
     /* 2289452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289455 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289491 */     // GIR_Coverage, 51009,
     /* 2289491 */     GIR_EraseRootFromParent_Done,
     /* 2289492 */   // Label 30977: @2289492
     /* 2289492 */   GIM_Reject,
     /* 2289493 */ // Label 30975: @2289493
     /* 2289493 */ GIM_Reject,
     /* 2289494 */ // Label 30931: @2289494
     /* 2289494 */ GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2289608),
     /* 2289499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2289502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2289505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289517 */   GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2289562), // Rule ID 51100 //
     /* 2289522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289525 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289561 */     // GIR_Coverage, 51100,
     /* 2289561 */     GIR_EraseRootFromParent_Done,
     /* 2289562 */   // Label 30979: @2289562
     /* 2289562 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2289607), // Rule ID 51101 //
     /* 2289567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2289570 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289606 */     // GIR_Coverage, 51101,
     /* 2289606 */     GIR_EraseRootFromParent_Done,
     /* 2289607 */   // Label 30980: @2289607
     /* 2289607 */   GIM_Reject,
     /* 2289608 */ // Label 30978: @2289608
     /* 2289608 */ GIM_Reject,
     /* 2289609 */ // Label 30932: @2289609
     /* 2289609 */ GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2289723),
     /* 2289614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2289617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2289620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289632 */   GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2289677), // Rule ID 50972 //
     /* 2289637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289640 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289676 */     // GIR_Coverage, 50972,
     /* 2289676 */     GIR_EraseRootFromParent_Done,
     /* 2289677 */   // Label 30982: @2289677
     /* 2289677 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2289722), // Rule ID 50973 //
     /* 2289682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289685 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2289702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289721 */     // GIR_Coverage, 50973,
     /* 2289721 */     GIR_EraseRootFromParent_Done,
     /* 2289722 */   // Label 30983: @2289722
     /* 2289722 */   GIM_Reject,
     /* 2289723 */ // Label 30981: @2289723
     /* 2289723 */ GIM_Reject,
     /* 2289724 */ // Label 30933: @2289724
     /* 2289724 */ GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2289838),
     /* 2289729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2289732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2289735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289747 */   GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2289792), // Rule ID 50996 //
     /* 2289752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289755 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289791 */     // GIR_Coverage, 50996,
     /* 2289791 */     GIR_EraseRootFromParent_Done,
     /* 2289792 */   // Label 30985: @2289792
     /* 2289792 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2289837), // Rule ID 50997 //
     /* 2289797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289800 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2289817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289836 */     // GIR_Coverage, 50997,
     /* 2289836 */     GIR_EraseRootFromParent_Done,
     /* 2289837 */   // Label 30986: @2289837
     /* 2289837 */   GIM_Reject,
     /* 2289838 */ // Label 30984: @2289838
     /* 2289838 */ GIM_Reject,
     /* 2289839 */ // Label 30934: @2289839
     /* 2289839 */ GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2289953),
     /* 2289844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289862 */   GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2289907), // Rule ID 51012 //
     /* 2289867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289870 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289906 */     // GIR_Coverage, 51012,
     /* 2289906 */     GIR_EraseRootFromParent_Done,
     /* 2289907 */   // Label 30988: @2289907
     /* 2289907 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2289952), // Rule ID 51013 //
     /* 2289912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289915 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2289932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289951 */     // GIR_Coverage, 51013,
     /* 2289951 */     GIR_EraseRootFromParent_Done,
     /* 2289952 */   // Label 30989: @2289952
     /* 2289952 */   GIM_Reject,
     /* 2289953 */ // Label 30987: @2289953
     /* 2289953 */ GIM_Reject,
     /* 2289954 */ // Label 30935: @2289954
     /* 2289954 */ GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2290068),
     /* 2289959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289977 */   GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2290022), // Rule ID 51104 //
     /* 2289982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2289985 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290021 */     // GIR_Coverage, 51104,
     /* 2290021 */     GIR_EraseRootFromParent_Done,
     /* 2290022 */   // Label 30991: @2290022
     /* 2290022 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2290067), // Rule ID 51105 //
     /* 2290027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2290030 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2290033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290066 */     // GIR_Coverage, 51105,
     /* 2290066 */     GIR_EraseRootFromParent_Done,
     /* 2290067 */   // Label 30992: @2290067
     /* 2290067 */   GIM_Reject,
     /* 2290068 */ // Label 30990: @2290068
     /* 2290068 */ GIM_Reject,
     /* 2290069 */ // Label 30936: @2290069
     /* 2290069 */ GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2290183),
     /* 2290074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2290077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2290080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2290092 */   GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2290137), // Rule ID 50984 //
     /* 2290097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290100 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2290117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290136 */     // GIR_Coverage, 50984,
     /* 2290136 */     GIR_EraseRootFromParent_Done,
     /* 2290137 */   // Label 30994: @2290137
     /* 2290137 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2290182), // Rule ID 50985 //
     /* 2290142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290145 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2290148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2290162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290181 */     // GIR_Coverage, 50985,
     /* 2290181 */     GIR_EraseRootFromParent_Done,
     /* 2290182 */   // Label 30995: @2290182
     /* 2290182 */   GIM_Reject,
     /* 2290183 */ // Label 30993: @2290183
     /* 2290183 */ GIM_Reject,
     /* 2290184 */ // Label 30937: @2290184
     /* 2290184 */ GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2290298),
     /* 2290189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2290192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2290195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290207 */   GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2290252), // Rule ID 51000 //
     /* 2290212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290215 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290251 */     // GIR_Coverage, 51000,
     /* 2290251 */     GIR_EraseRootFromParent_Done,
     /* 2290252 */   // Label 30997: @2290252
     /* 2290252 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2290297), // Rule ID 51001 //
     /* 2290257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290260 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2290263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290296 */     // GIR_Coverage, 51001,
     /* 2290296 */     GIR_EraseRootFromParent_Done,
     /* 2290297 */   // Label 30998: @2290297
     /* 2290297 */   GIM_Reject,
     /* 2290298 */ // Label 30996: @2290298
     /* 2290298 */ GIM_Reject,
     /* 2290299 */ // Label 30938: @2290299
     /* 2290299 */ GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2290413),
     /* 2290304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2290307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2290310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290322 */   GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2290367), // Rule ID 51016 //
     /* 2290327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290330 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290366 */     // GIR_Coverage, 51016,
     /* 2290366 */     GIR_EraseRootFromParent_Done,
     /* 2290367 */   // Label 31000: @2290367
     /* 2290367 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2290412), // Rule ID 51017 //
     /* 2290372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290375 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2290378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290411 */     // GIR_Coverage, 51017,
     /* 2290411 */     GIR_EraseRootFromParent_Done,
     /* 2290412 */   // Label 31001: @2290412
     /* 2290412 */   GIM_Reject,
     /* 2290413 */ // Label 30999: @2290413
     /* 2290413 */ GIM_Reject,
     /* 2290414 */ // Label 30939: @2290414
     /* 2290414 */ GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2290528),
     /* 2290419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2290422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2290425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2290437 */   GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2290482), // Rule ID 50988 //
     /* 2290442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290445 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290481 */     // GIR_Coverage, 50988,
     /* 2290481 */     GIR_EraseRootFromParent_Done,
     /* 2290482 */   // Label 31003: @2290482
     /* 2290482 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2290527), // Rule ID 50989 //
     /* 2290487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290490 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2290507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290526 */     // GIR_Coverage, 50989,
     /* 2290526 */     GIR_EraseRootFromParent_Done,
     /* 2290527 */   // Label 31004: @2290527
     /* 2290527 */   GIM_Reject,
     /* 2290528 */ // Label 31002: @2290528
     /* 2290528 */ GIM_Reject,
     /* 2290529 */ // Label 30940: @2290529
     /* 2290529 */ GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2290643),
     /* 2290534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2290537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2290540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290552 */   GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2290597), // Rule ID 51004 //
     /* 2290557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290560 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290596 */     // GIR_Coverage, 51004,
     /* 2290596 */     GIR_EraseRootFromParent_Done,
     /* 2290597 */   // Label 31006: @2290597
     /* 2290597 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2290642), // Rule ID 51005 //
     /* 2290602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290605 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290641 */     // GIR_Coverage, 51005,
     /* 2290641 */     GIR_EraseRootFromParent_Done,
     /* 2290642 */   // Label 31007: @2290642
     /* 2290642 */   GIM_Reject,
     /* 2290643 */ // Label 31005: @2290643
     /* 2290643 */ GIM_Reject,
     /* 2290644 */ // Label 30941: @2290644
     /* 2290644 */ GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2290758),
     /* 2290649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2290652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2290655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290667 */   GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2290712), // Rule ID 50992 //
     /* 2290672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290675 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290711 */     // GIR_Coverage, 50992,
     /* 2290711 */     GIR_EraseRootFromParent_Done,
     /* 2290712 */   // Label 31009: @2290712
     /* 2290712 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2290757), // Rule ID 50993 //
     /* 2290717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290720 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2290737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290756 */     // GIR_Coverage, 50993,
     /* 2290756 */     GIR_EraseRootFromParent_Done,
     /* 2290757 */   // Label 31010: @2290757
     /* 2290757 */   GIM_Reject,
     /* 2290758 */ // Label 31008: @2290758
     /* 2290758 */ GIM_Reject,
     /* 2290759 */ // Label 30942: @2290759
     /* 2290759 */ GIM_Reject,
     /* 2290760 */ // Label 53: @2290760
     /* 2290760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31034*/ GIMT_Encode4(2293612),
     /* 2290771 */ /*GILLT_s32*//*Label 31011*/ GIMT_Encode4(2290895), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290783 */ /*GILLT_nxv1s8*//*Label 31012*/ GIMT_Encode4(2290950),
     /* 2290787 */ /*GILLT_nxv1s16*//*Label 31013*/ GIMT_Encode4(2291071),
     /* 2290791 */ /*GILLT_nxv1s32*//*Label 31014*/ GIMT_Encode4(2291192),
     /* 2290795 */ /*GILLT_nxv1s64*//*Label 31015*/ GIMT_Encode4(2291313), GIMT_Encode4(0),
     /* 2290803 */ /*GILLT_nxv2s8*//*Label 31016*/ GIMT_Encode4(2291434),
     /* 2290807 */ /*GILLT_nxv2s16*//*Label 31017*/ GIMT_Encode4(2291555),
     /* 2290811 */ /*GILLT_nxv2s32*//*Label 31018*/ GIMT_Encode4(2291676),
     /* 2290815 */ /*GILLT_nxv2s64*//*Label 31019*/ GIMT_Encode4(2291797), GIMT_Encode4(0),
     /* 2290823 */ /*GILLT_nxv4s8*//*Label 31020*/ GIMT_Encode4(2291918),
     /* 2290827 */ /*GILLT_nxv4s16*//*Label 31021*/ GIMT_Encode4(2292039),
     /* 2290831 */ /*GILLT_nxv4s32*//*Label 31022*/ GIMT_Encode4(2292160),
     /* 2290835 */ /*GILLT_nxv4s64*//*Label 31023*/ GIMT_Encode4(2292281), GIMT_Encode4(0),
     /* 2290843 */ /*GILLT_nxv8s8*//*Label 31024*/ GIMT_Encode4(2292402),
     /* 2290847 */ /*GILLT_nxv8s16*//*Label 31025*/ GIMT_Encode4(2292523),
     /* 2290851 */ /*GILLT_nxv8s32*//*Label 31026*/ GIMT_Encode4(2292644),
     /* 2290855 */ /*GILLT_nxv8s64*//*Label 31027*/ GIMT_Encode4(2292765), GIMT_Encode4(0),
     /* 2290863 */ /*GILLT_nxv16s8*//*Label 31028*/ GIMT_Encode4(2292886),
     /* 2290867 */ /*GILLT_nxv16s16*//*Label 31029*/ GIMT_Encode4(2293007),
     /* 2290871 */ /*GILLT_nxv16s32*//*Label 31030*/ GIMT_Encode4(2293128), GIMT_Encode4(0),
     /* 2290879 */ /*GILLT_nxv32s8*//*Label 31031*/ GIMT_Encode4(2293249),
     /* 2290883 */ /*GILLT_nxv32s16*//*Label 31032*/ GIMT_Encode4(2293370), GIMT_Encode4(0),
     /* 2290891 */ /*GILLT_nxv64s8*//*Label 31033*/ GIMT_Encode4(2293491),
     /* 2290895 */ // Label 31011: @2290895
     /* 2290895 */ GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2290949),
     /* 2290900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290918 */   GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2290933), // Rule ID 64587 //
     /* 2290923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2290926 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2290931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290932 */     // GIR_Coverage, 64587,
     /* 2290932 */     GIR_Done,
     /* 2290933 */   // Label 31036: @2290933
     /* 2290933 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2290948), // Rule ID 64588 //
     /* 2290938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2290941 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2290946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290947 */     // GIR_Coverage, 64588,
     /* 2290947 */     GIR_Done,
     /* 2290948 */   // Label 31037: @2290948
     /* 2290948 */   GIM_Reject,
     /* 2290949 */ // Label 31035: @2290949
     /* 2290949 */ GIM_Reject,
     /* 2290950 */ // Label 31012: @2290950
     /* 2290950 */ GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2291070),
     /* 2290955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2290958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2290961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290973 */   GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2291021), // Rule ID 52508 //
     /* 2290978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290981 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2290998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291020 */     // GIR_Coverage, 52508,
     /* 2291020 */     GIR_EraseRootFromParent_Done,
     /* 2291021 */   // Label 31039: @2291021
     /* 2291021 */   GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2291069), // Rule ID 52509 //
     /* 2291026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291029 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2291032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2291046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291068 */     // GIR_Coverage, 52509,
     /* 2291068 */     GIR_EraseRootFromParent_Done,
     /* 2291069 */   // Label 31040: @2291069
     /* 2291069 */   GIM_Reject,
     /* 2291070 */ // Label 31038: @2291070
     /* 2291070 */ GIM_Reject,
     /* 2291071 */ // Label 31013: @2291071
     /* 2291071 */ GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2291191),
     /* 2291076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2291079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2291082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291094 */   GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2291142), // Rule ID 52520 //
     /* 2291099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291102 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291141 */     // GIR_Coverage, 52520,
     /* 2291141 */     GIR_EraseRootFromParent_Done,
     /* 2291142 */   // Label 31042: @2291142
     /* 2291142 */   GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2291190), // Rule ID 52521 //
     /* 2291147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291150 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2291153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291189 */     // GIR_Coverage, 52521,
     /* 2291189 */     GIR_EraseRootFromParent_Done,
     /* 2291190 */   // Label 31043: @2291190
     /* 2291190 */   GIM_Reject,
     /* 2291191 */ // Label 31041: @2291191
     /* 2291191 */ GIM_Reject,
     /* 2291192 */ // Label 31014: @2291192
     /* 2291192 */ GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2291312),
     /* 2291197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2291200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2291203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291215 */   GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2291263), // Rule ID 52528 //
     /* 2291220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291223 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291262 */     // GIR_Coverage, 52528,
     /* 2291262 */     GIR_EraseRootFromParent_Done,
     /* 2291263 */   // Label 31045: @2291263
     /* 2291263 */   GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2291311), // Rule ID 52529 //
     /* 2291268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291271 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2291274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291310 */     // GIR_Coverage, 52529,
     /* 2291310 */     GIR_EraseRootFromParent_Done,
     /* 2291311 */   // Label 31046: @2291311
     /* 2291311 */   GIM_Reject,
     /* 2291312 */ // Label 31044: @2291312
     /* 2291312 */ GIM_Reject,
     /* 2291313 */ // Label 31015: @2291313
     /* 2291313 */ GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2291433),
     /* 2291318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2291321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2291324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291336 */   GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2291384), // Rule ID 52544 //
     /* 2291341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291344 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291383 */     // GIR_Coverage, 52544,
     /* 2291383 */     GIR_EraseRootFromParent_Done,
     /* 2291384 */   // Label 31048: @2291384
     /* 2291384 */   GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2291432), // Rule ID 52545 //
     /* 2291389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291392 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2291395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291431 */     // GIR_Coverage, 52545,
     /* 2291431 */     GIR_EraseRootFromParent_Done,
     /* 2291432 */   // Label 31049: @2291432
     /* 2291432 */   GIM_Reject,
     /* 2291433 */ // Label 31047: @2291433
     /* 2291433 */ GIM_Reject,
     /* 2291434 */ // Label 31016: @2291434
     /* 2291434 */ GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2291554),
     /* 2291439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2291442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2291445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291457 */   GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2291505), // Rule ID 52512 //
     /* 2291462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291465 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291504 */     // GIR_Coverage, 52512,
     /* 2291504 */     GIR_EraseRootFromParent_Done,
     /* 2291505 */   // Label 31051: @2291505
     /* 2291505 */   GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2291553), // Rule ID 52513 //
     /* 2291510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291513 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2291530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291552 */     // GIR_Coverage, 52513,
     /* 2291552 */     GIR_EraseRootFromParent_Done,
     /* 2291553 */   // Label 31052: @2291553
     /* 2291553 */   GIM_Reject,
     /* 2291554 */ // Label 31050: @2291554
     /* 2291554 */ GIM_Reject,
     /* 2291555 */ // Label 31017: @2291555
     /* 2291555 */ GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2291675),
     /* 2291560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2291563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2291566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291578 */   GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2291626), // Rule ID 52524 //
     /* 2291583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291586 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291625 */     // GIR_Coverage, 52524,
     /* 2291625 */     GIR_EraseRootFromParent_Done,
     /* 2291626 */   // Label 31054: @2291626
     /* 2291626 */   GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2291674), // Rule ID 52525 //
     /* 2291631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291634 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291673 */     // GIR_Coverage, 52525,
     /* 2291673 */     GIR_EraseRootFromParent_Done,
     /* 2291674 */   // Label 31055: @2291674
     /* 2291674 */   GIM_Reject,
     /* 2291675 */ // Label 31053: @2291675
     /* 2291675 */ GIM_Reject,
     /* 2291676 */ // Label 31018: @2291676
     /* 2291676 */ GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2291796),
     /* 2291681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2291684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2291687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291699 */   GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2291747), // Rule ID 52540 //
     /* 2291704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291707 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291746 */     // GIR_Coverage, 52540,
     /* 2291746 */     GIR_EraseRootFromParent_Done,
     /* 2291747 */   // Label 31057: @2291747
     /* 2291747 */   GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2291795), // Rule ID 52541 //
     /* 2291752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291755 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291794 */     // GIR_Coverage, 52541,
     /* 2291794 */     GIR_EraseRootFromParent_Done,
     /* 2291795 */   // Label 31058: @2291795
     /* 2291795 */   GIM_Reject,
     /* 2291796 */ // Label 31056: @2291796
     /* 2291796 */ GIM_Reject,
     /* 2291797 */ // Label 31019: @2291797
     /* 2291797 */ GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2291917),
     /* 2291802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291820 */   GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2291868), // Rule ID 52584 //
     /* 2291825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291828 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2291845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291867 */     // GIR_Coverage, 52584,
     /* 2291867 */     GIR_EraseRootFromParent_Done,
     /* 2291868 */   // Label 31060: @2291868
     /* 2291868 */   GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2291916), // Rule ID 52585 //
     /* 2291873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291876 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2291893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291915 */     // GIR_Coverage, 52585,
     /* 2291915 */     GIR_EraseRootFromParent_Done,
     /* 2291916 */   // Label 31061: @2291916
     /* 2291916 */   GIM_Reject,
     /* 2291917 */ // Label 31059: @2291917
     /* 2291917 */ GIM_Reject,
     /* 2291918 */ // Label 31020: @2291918
     /* 2291918 */ GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2292038),
     /* 2291923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2291926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2291929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291941 */   GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2291989), // Rule ID 52516 //
     /* 2291946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291949 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2291966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291988 */     // GIR_Coverage, 52516,
     /* 2291988 */     GIR_EraseRootFromParent_Done,
     /* 2291989 */   // Label 31063: @2291989
     /* 2291989 */   GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2292037), // Rule ID 52517 //
     /* 2291994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291997 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2292000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2292014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292036 */     // GIR_Coverage, 52517,
     /* 2292036 */     GIR_EraseRootFromParent_Done,
     /* 2292037 */   // Label 31064: @2292037
     /* 2292037 */   GIM_Reject,
     /* 2292038 */ // Label 31062: @2292038
     /* 2292038 */ GIM_Reject,
     /* 2292039 */ // Label 31021: @2292039
     /* 2292039 */ GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2292159),
     /* 2292044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2292047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2292050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292062 */   GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2292110), // Rule ID 52536 //
     /* 2292067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292070 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292109 */     // GIR_Coverage, 52536,
     /* 2292109 */     GIR_EraseRootFromParent_Done,
     /* 2292110 */   // Label 31066: @2292110
     /* 2292110 */   GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2292158), // Rule ID 52537 //
     /* 2292115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292118 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2292121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292157 */     // GIR_Coverage, 52537,
     /* 2292157 */     GIR_EraseRootFromParent_Done,
     /* 2292158 */   // Label 31067: @2292158
     /* 2292158 */   GIM_Reject,
     /* 2292159 */ // Label 31065: @2292159
     /* 2292159 */ GIM_Reject,
     /* 2292160 */ // Label 31022: @2292160
     /* 2292160 */ GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2292280),
     /* 2292165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2292168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2292171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292183 */   GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2292231), // Rule ID 52572 //
     /* 2292188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292191 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292230 */     // GIR_Coverage, 52572,
     /* 2292230 */     GIR_EraseRootFromParent_Done,
     /* 2292231 */   // Label 31069: @2292231
     /* 2292231 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2292279), // Rule ID 52573 //
     /* 2292236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292239 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2292242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292278 */     // GIR_Coverage, 52573,
     /* 2292278 */     GIR_EraseRootFromParent_Done,
     /* 2292279 */   // Label 31070: @2292279
     /* 2292279 */   GIM_Reject,
     /* 2292280 */ // Label 31068: @2292280
     /* 2292280 */ GIM_Reject,
     /* 2292281 */ // Label 31023: @2292281
     /* 2292281 */ GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2292401),
     /* 2292286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2292289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2292292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292304 */   GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2292352), // Rule ID 52588 //
     /* 2292309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292312 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292351 */     // GIR_Coverage, 52588,
     /* 2292351 */     GIR_EraseRootFromParent_Done,
     /* 2292352 */   // Label 31072: @2292352
     /* 2292352 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2292400), // Rule ID 52589 //
     /* 2292357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292360 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2292363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292399 */     // GIR_Coverage, 52589,
     /* 2292399 */     GIR_EraseRootFromParent_Done,
     /* 2292400 */   // Label 31073: @2292400
     /* 2292400 */   GIM_Reject,
     /* 2292401 */ // Label 31071: @2292401
     /* 2292401 */ GIM_Reject,
     /* 2292402 */ // Label 31024: @2292402
     /* 2292402 */ GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2292522),
     /* 2292407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2292410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2292413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292425 */   GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2292473), // Rule ID 52532 //
     /* 2292430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292433 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292472 */     // GIR_Coverage, 52532,
     /* 2292472 */     GIR_EraseRootFromParent_Done,
     /* 2292473 */   // Label 31075: @2292473
     /* 2292473 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2292521), // Rule ID 52533 //
     /* 2292478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292481 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2292498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292520 */     // GIR_Coverage, 52533,
     /* 2292520 */     GIR_EraseRootFromParent_Done,
     /* 2292521 */   // Label 31076: @2292521
     /* 2292521 */   GIM_Reject,
     /* 2292522 */ // Label 31074: @2292522
     /* 2292522 */ GIM_Reject,
     /* 2292523 */ // Label 31025: @2292523
     /* 2292523 */ GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2292643),
     /* 2292528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2292531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2292534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292546 */   GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2292594), // Rule ID 52560 //
     /* 2292551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292554 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292593 */     // GIR_Coverage, 52560,
     /* 2292593 */     GIR_EraseRootFromParent_Done,
     /* 2292594 */   // Label 31078: @2292594
     /* 2292594 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2292642), // Rule ID 52561 //
     /* 2292599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292602 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292641 */     // GIR_Coverage, 52561,
     /* 2292641 */     GIR_EraseRootFromParent_Done,
     /* 2292642 */   // Label 31079: @2292642
     /* 2292642 */   GIM_Reject,
     /* 2292643 */ // Label 31077: @2292643
     /* 2292643 */ GIM_Reject,
     /* 2292644 */ // Label 31026: @2292644
     /* 2292644 */ GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2292764),
     /* 2292649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2292652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2292655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292667 */   GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2292715), // Rule ID 52576 //
     /* 2292672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292675 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292714 */     // GIR_Coverage, 52576,
     /* 2292714 */     GIR_EraseRootFromParent_Done,
     /* 2292715 */   // Label 31081: @2292715
     /* 2292715 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2292763), // Rule ID 52577 //
     /* 2292720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292723 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2292740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292762 */     // GIR_Coverage, 52577,
     /* 2292762 */     GIR_EraseRootFromParent_Done,
     /* 2292763 */   // Label 31082: @2292763
     /* 2292763 */   GIM_Reject,
     /* 2292764 */ // Label 31080: @2292764
     /* 2292764 */ GIM_Reject,
     /* 2292765 */ // Label 31027: @2292765
     /* 2292765 */ GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2292885),
     /* 2292770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2292773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2292776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292788 */   GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2292836), // Rule ID 52592 //
     /* 2292793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292796 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2292813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292835 */     // GIR_Coverage, 52592,
     /* 2292835 */     GIR_EraseRootFromParent_Done,
     /* 2292836 */   // Label 31084: @2292836
     /* 2292836 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2292884), // Rule ID 52593 //
     /* 2292841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292844 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2292861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292883 */     // GIR_Coverage, 52593,
     /* 2292883 */     GIR_EraseRootFromParent_Done,
     /* 2292884 */   // Label 31085: @2292884
     /* 2292884 */   GIM_Reject,
     /* 2292885 */ // Label 31083: @2292885
     /* 2292885 */ GIM_Reject,
     /* 2292886 */ // Label 31028: @2292886
     /* 2292886 */ GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2293006),
     /* 2292891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2292894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2292897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292909 */   GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2292957), // Rule ID 52548 //
     /* 2292914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292917 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292956 */     // GIR_Coverage, 52548,
     /* 2292956 */     GIR_EraseRootFromParent_Done,
     /* 2292957 */   // Label 31087: @2292957
     /* 2292957 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2293005), // Rule ID 52549 //
     /* 2292962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292965 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2292982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293004 */     // GIR_Coverage, 52549,
     /* 2293004 */     GIR_EraseRootFromParent_Done,
     /* 2293005 */   // Label 31088: @2293005
     /* 2293005 */   GIM_Reject,
     /* 2293006 */ // Label 31086: @2293006
     /* 2293006 */ GIM_Reject,
     /* 2293007 */ // Label 31029: @2293007
     /* 2293007 */ GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2293127),
     /* 2293012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2293015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2293018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293030 */   GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2293078), // Rule ID 52564 //
     /* 2293035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293038 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293077 */     // GIR_Coverage, 52564,
     /* 2293077 */     GIR_EraseRootFromParent_Done,
     /* 2293078 */   // Label 31090: @2293078
     /* 2293078 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2293126), // Rule ID 52565 //
     /* 2293083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293086 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2293089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293125 */     // GIR_Coverage, 52565,
     /* 2293125 */     GIR_EraseRootFromParent_Done,
     /* 2293126 */   // Label 31091: @2293126
     /* 2293126 */   GIM_Reject,
     /* 2293127 */ // Label 31089: @2293127
     /* 2293127 */ GIM_Reject,
     /* 2293128 */ // Label 31030: @2293128
     /* 2293128 */ GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2293248),
     /* 2293133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2293136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2293139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293151 */   GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2293199), // Rule ID 52580 //
     /* 2293156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293159 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293198 */     // GIR_Coverage, 52580,
     /* 2293198 */     GIR_EraseRootFromParent_Done,
     /* 2293199 */   // Label 31093: @2293199
     /* 2293199 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2293247), // Rule ID 52581 //
     /* 2293204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293207 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2293210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293246 */     // GIR_Coverage, 52581,
     /* 2293246 */     GIR_EraseRootFromParent_Done,
     /* 2293247 */   // Label 31094: @2293247
     /* 2293247 */   GIM_Reject,
     /* 2293248 */ // Label 31092: @2293248
     /* 2293248 */ GIM_Reject,
     /* 2293249 */ // Label 31031: @2293249
     /* 2293249 */ GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2293369),
     /* 2293254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2293257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2293260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2293272 */   GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2293320), // Rule ID 52552 //
     /* 2293277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293280 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293319 */     // GIR_Coverage, 52552,
     /* 2293319 */     GIR_EraseRootFromParent_Done,
     /* 2293320 */   // Label 31096: @2293320
     /* 2293320 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2293368), // Rule ID 52553 //
     /* 2293325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293328 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2293331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2293345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293367 */     // GIR_Coverage, 52553,
     /* 2293367 */     GIR_EraseRootFromParent_Done,
     /* 2293368 */   // Label 31097: @2293368
     /* 2293368 */   GIM_Reject,
     /* 2293369 */ // Label 31095: @2293369
     /* 2293369 */ GIM_Reject,
     /* 2293370 */ // Label 31032: @2293370
     /* 2293370 */ GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2293490),
     /* 2293375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2293378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2293381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293393 */   GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2293441), // Rule ID 52568 //
     /* 2293398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293401 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293440 */     // GIR_Coverage, 52568,
     /* 2293440 */     GIR_EraseRootFromParent_Done,
     /* 2293441 */   // Label 31099: @2293441
     /* 2293441 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2293489), // Rule ID 52569 //
     /* 2293446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293449 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293488 */     // GIR_Coverage, 52569,
     /* 2293488 */     GIR_EraseRootFromParent_Done,
     /* 2293489 */   // Label 31100: @2293489
     /* 2293489 */   GIM_Reject,
     /* 2293490 */ // Label 31098: @2293490
     /* 2293490 */ GIM_Reject,
     /* 2293491 */ // Label 31033: @2293491
     /* 2293491 */ GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2293611),
     /* 2293496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2293499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2293502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293514 */   GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2293562), // Rule ID 52556 //
     /* 2293519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293522 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293561 */     // GIR_Coverage, 52556,
     /* 2293561 */     GIR_EraseRootFromParent_Done,
     /* 2293562 */   // Label 31102: @2293562
     /* 2293562 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2293610), // Rule ID 52557 //
     /* 2293567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293570 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2293587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293609 */     // GIR_Coverage, 52557,
     /* 2293609 */     GIR_EraseRootFromParent_Done,
     /* 2293610 */   // Label 31103: @2293610
     /* 2293610 */   GIM_Reject,
     /* 2293611 */ // Label 31101: @2293611
     /* 2293611 */ GIM_Reject,
     /* 2293612 */ // Label 31034: @2293612
     /* 2293612 */ GIM_Reject,
     /* 2293613 */ // Label 54: @2293613
     /* 2293613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31127*/ GIMT_Encode4(2296465),
     /* 2293624 */ /*GILLT_s32*//*Label 31104*/ GIMT_Encode4(2293748), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2293636 */ /*GILLT_nxv1s8*//*Label 31105*/ GIMT_Encode4(2293803),
     /* 2293640 */ /*GILLT_nxv1s16*//*Label 31106*/ GIMT_Encode4(2293924),
     /* 2293644 */ /*GILLT_nxv1s32*//*Label 31107*/ GIMT_Encode4(2294045),
     /* 2293648 */ /*GILLT_nxv1s64*//*Label 31108*/ GIMT_Encode4(2294166), GIMT_Encode4(0),
     /* 2293656 */ /*GILLT_nxv2s8*//*Label 31109*/ GIMT_Encode4(2294287),
     /* 2293660 */ /*GILLT_nxv2s16*//*Label 31110*/ GIMT_Encode4(2294408),
     /* 2293664 */ /*GILLT_nxv2s32*//*Label 31111*/ GIMT_Encode4(2294529),
     /* 2293668 */ /*GILLT_nxv2s64*//*Label 31112*/ GIMT_Encode4(2294650), GIMT_Encode4(0),
     /* 2293676 */ /*GILLT_nxv4s8*//*Label 31113*/ GIMT_Encode4(2294771),
     /* 2293680 */ /*GILLT_nxv4s16*//*Label 31114*/ GIMT_Encode4(2294892),
     /* 2293684 */ /*GILLT_nxv4s32*//*Label 31115*/ GIMT_Encode4(2295013),
     /* 2293688 */ /*GILLT_nxv4s64*//*Label 31116*/ GIMT_Encode4(2295134), GIMT_Encode4(0),
     /* 2293696 */ /*GILLT_nxv8s8*//*Label 31117*/ GIMT_Encode4(2295255),
     /* 2293700 */ /*GILLT_nxv8s16*//*Label 31118*/ GIMT_Encode4(2295376),
     /* 2293704 */ /*GILLT_nxv8s32*//*Label 31119*/ GIMT_Encode4(2295497),
     /* 2293708 */ /*GILLT_nxv8s64*//*Label 31120*/ GIMT_Encode4(2295618), GIMT_Encode4(0),
     /* 2293716 */ /*GILLT_nxv16s8*//*Label 31121*/ GIMT_Encode4(2295739),
     /* 2293720 */ /*GILLT_nxv16s16*//*Label 31122*/ GIMT_Encode4(2295860),
     /* 2293724 */ /*GILLT_nxv16s32*//*Label 31123*/ GIMT_Encode4(2295981), GIMT_Encode4(0),
     /* 2293732 */ /*GILLT_nxv32s8*//*Label 31124*/ GIMT_Encode4(2296102),
     /* 2293736 */ /*GILLT_nxv32s16*//*Label 31125*/ GIMT_Encode4(2296223), GIMT_Encode4(0),
     /* 2293744 */ /*GILLT_nxv64s8*//*Label 31126*/ GIMT_Encode4(2296344),
     /* 2293748 */ // Label 31104: @2293748
     /* 2293748 */ GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2293802),
     /* 2293753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2293756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2293759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293771 */   GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2293786), // Rule ID 64585 //
     /* 2293776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2293779 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2293784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293785 */     // GIR_Coverage, 64585,
     /* 2293785 */     GIR_Done,
     /* 2293786 */   // Label 31129: @2293786
     /* 2293786 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2293801), // Rule ID 64586 //
     /* 2293791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2293794 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2293799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293800 */     // GIR_Coverage, 64586,
     /* 2293800 */     GIR_Done,
     /* 2293801 */   // Label 31130: @2293801
     /* 2293801 */   GIM_Reject,
     /* 2293802 */ // Label 31128: @2293802
     /* 2293802 */ GIM_Reject,
     /* 2293803 */ // Label 31105: @2293803
     /* 2293803 */ GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2293923),
     /* 2293808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2293811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2293814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293826 */   GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2293874), // Rule ID 52376 //
     /* 2293831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293834 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2293851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293873 */     // GIR_Coverage, 52376,
     /* 2293873 */     GIR_EraseRootFromParent_Done,
     /* 2293874 */   // Label 31132: @2293874
     /* 2293874 */   GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2293922), // Rule ID 52377 //
     /* 2293879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293882 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2293899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293921 */     // GIR_Coverage, 52377,
     /* 2293921 */     GIR_EraseRootFromParent_Done,
     /* 2293922 */   // Label 31133: @2293922
     /* 2293922 */   GIM_Reject,
     /* 2293923 */ // Label 31131: @2293923
     /* 2293923 */ GIM_Reject,
     /* 2293924 */ // Label 31106: @2293924
     /* 2293924 */ GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2294044),
     /* 2293929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2293935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293947 */   GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2293995), // Rule ID 52388 //
     /* 2293952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293955 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2293972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293994 */     // GIR_Coverage, 52388,
     /* 2293994 */     GIR_EraseRootFromParent_Done,
     /* 2293995 */   // Label 31135: @2293995
     /* 2293995 */   GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2294043), // Rule ID 52389 //
     /* 2294000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294003 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2294006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294042 */     // GIR_Coverage, 52389,
     /* 2294042 */     GIR_EraseRootFromParent_Done,
     /* 2294043 */   // Label 31136: @2294043
     /* 2294043 */   GIM_Reject,
     /* 2294044 */ // Label 31134: @2294044
     /* 2294044 */ GIM_Reject,
     /* 2294045 */ // Label 31107: @2294045
     /* 2294045 */ GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2294165),
     /* 2294050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2294056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294068 */   GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2294116), // Rule ID 52396 //
     /* 2294073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294076 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294115 */     // GIR_Coverage, 52396,
     /* 2294115 */     GIR_EraseRootFromParent_Done,
     /* 2294116 */   // Label 31138: @2294116
     /* 2294116 */   GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2294164), // Rule ID 52397 //
     /* 2294121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294124 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2294127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294163 */     // GIR_Coverage, 52397,
     /* 2294163 */     GIR_EraseRootFromParent_Done,
     /* 2294164 */   // Label 31139: @2294164
     /* 2294164 */   GIM_Reject,
     /* 2294165 */ // Label 31137: @2294165
     /* 2294165 */ GIM_Reject,
     /* 2294166 */ // Label 31108: @2294166
     /* 2294166 */ GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2294286),
     /* 2294171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2294177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294189 */   GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2294237), // Rule ID 52412 //
     /* 2294194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294197 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294236 */     // GIR_Coverage, 52412,
     /* 2294236 */     GIR_EraseRootFromParent_Done,
     /* 2294237 */   // Label 31141: @2294237
     /* 2294237 */   GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2294285), // Rule ID 52413 //
     /* 2294242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294245 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2294248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294284 */     // GIR_Coverage, 52413,
     /* 2294284 */     GIR_EraseRootFromParent_Done,
     /* 2294285 */   // Label 31142: @2294285
     /* 2294285 */   GIM_Reject,
     /* 2294286 */ // Label 31140: @2294286
     /* 2294286 */ GIM_Reject,
     /* 2294287 */ // Label 31109: @2294287
     /* 2294287 */ GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2294407),
     /* 2294292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2294295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2294298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294310 */   GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2294358), // Rule ID 52380 //
     /* 2294315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294318 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294357 */     // GIR_Coverage, 52380,
     /* 2294357 */     GIR_EraseRootFromParent_Done,
     /* 2294358 */   // Label 31144: @2294358
     /* 2294358 */   GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2294406), // Rule ID 52381 //
     /* 2294363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294366 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2294369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2294383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294405 */     // GIR_Coverage, 52381,
     /* 2294405 */     GIR_EraseRootFromParent_Done,
     /* 2294406 */   // Label 31145: @2294406
     /* 2294406 */   GIM_Reject,
     /* 2294407 */ // Label 31143: @2294407
     /* 2294407 */ GIM_Reject,
     /* 2294408 */ // Label 31110: @2294408
     /* 2294408 */ GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2294528),
     /* 2294413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2294416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2294419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294431 */   GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2294479), // Rule ID 52392 //
     /* 2294436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294439 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294478 */     // GIR_Coverage, 52392,
     /* 2294478 */     GIR_EraseRootFromParent_Done,
     /* 2294479 */   // Label 31147: @2294479
     /* 2294479 */   GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2294527), // Rule ID 52393 //
     /* 2294484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294487 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294526 */     // GIR_Coverage, 52393,
     /* 2294526 */     GIR_EraseRootFromParent_Done,
     /* 2294527 */   // Label 31148: @2294527
     /* 2294527 */   GIM_Reject,
     /* 2294528 */ // Label 31146: @2294528
     /* 2294528 */ GIM_Reject,
     /* 2294529 */ // Label 31111: @2294529
     /* 2294529 */ GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2294649),
     /* 2294534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2294537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2294540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294552 */   GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2294600), // Rule ID 52408 //
     /* 2294557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294560 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294599 */     // GIR_Coverage, 52408,
     /* 2294599 */     GIR_EraseRootFromParent_Done,
     /* 2294600 */   // Label 31150: @2294600
     /* 2294600 */   GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2294648), // Rule ID 52409 //
     /* 2294605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294608 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294647 */     // GIR_Coverage, 52409,
     /* 2294647 */     GIR_EraseRootFromParent_Done,
     /* 2294648 */   // Label 31151: @2294648
     /* 2294648 */   GIM_Reject,
     /* 2294649 */ // Label 31149: @2294649
     /* 2294649 */ GIM_Reject,
     /* 2294650 */ // Label 31112: @2294650
     /* 2294650 */ GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2294770),
     /* 2294655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2294658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2294661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294673 */   GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2294721), // Rule ID 52452 //
     /* 2294678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294681 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2294698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294720 */     // GIR_Coverage, 52452,
     /* 2294720 */     GIR_EraseRootFromParent_Done,
     /* 2294721 */   // Label 31153: @2294721
     /* 2294721 */   GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2294769), // Rule ID 52453 //
     /* 2294726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294729 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2294746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294768 */     // GIR_Coverage, 52453,
     /* 2294768 */     GIR_EraseRootFromParent_Done,
     /* 2294769 */   // Label 31154: @2294769
     /* 2294769 */   GIM_Reject,
     /* 2294770 */ // Label 31152: @2294770
     /* 2294770 */ GIM_Reject,
     /* 2294771 */ // Label 31113: @2294771
     /* 2294771 */ GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2294891),
     /* 2294776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2294779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2294782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294794 */   GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2294842), // Rule ID 52384 //
     /* 2294799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294802 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294841 */     // GIR_Coverage, 52384,
     /* 2294841 */     GIR_EraseRootFromParent_Done,
     /* 2294842 */   // Label 31156: @2294842
     /* 2294842 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2294890), // Rule ID 52385 //
     /* 2294847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294850 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2294867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294889 */     // GIR_Coverage, 52385,
     /* 2294889 */     GIR_EraseRootFromParent_Done,
     /* 2294890 */   // Label 31157: @2294890
     /* 2294890 */   GIM_Reject,
     /* 2294891 */ // Label 31155: @2294891
     /* 2294891 */ GIM_Reject,
     /* 2294892 */ // Label 31114: @2294892
     /* 2294892 */ GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2295012),
     /* 2294897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2294900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2294903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294915 */   GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2294963), // Rule ID 52404 //
     /* 2294920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294923 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294962 */     // GIR_Coverage, 52404,
     /* 2294962 */     GIR_EraseRootFromParent_Done,
     /* 2294963 */   // Label 31159: @2294963
     /* 2294963 */   GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2295011), // Rule ID 52405 //
     /* 2294968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294971 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2294988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295010 */     // GIR_Coverage, 52405,
     /* 2295010 */     GIR_EraseRootFromParent_Done,
     /* 2295011 */   // Label 31160: @2295011
     /* 2295011 */   GIM_Reject,
     /* 2295012 */ // Label 31158: @2295012
     /* 2295012 */ GIM_Reject,
     /* 2295013 */ // Label 31115: @2295013
     /* 2295013 */ GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2295133),
     /* 2295018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2295021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2295024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295036 */   GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2295084), // Rule ID 52440 //
     /* 2295041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295044 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295083 */     // GIR_Coverage, 52440,
     /* 2295083 */     GIR_EraseRootFromParent_Done,
     /* 2295084 */   // Label 31162: @2295084
     /* 2295084 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2295132), // Rule ID 52441 //
     /* 2295089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295092 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2295095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295131 */     // GIR_Coverage, 52441,
     /* 2295131 */     GIR_EraseRootFromParent_Done,
     /* 2295132 */   // Label 31163: @2295132
     /* 2295132 */   GIM_Reject,
     /* 2295133 */ // Label 31161: @2295133
     /* 2295133 */ GIM_Reject,
     /* 2295134 */ // Label 31116: @2295134
     /* 2295134 */ GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2295254),
     /* 2295139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2295142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2295145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295157 */   GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2295205), // Rule ID 52456 //
     /* 2295162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295165 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295204 */     // GIR_Coverage, 52456,
     /* 2295204 */     GIR_EraseRootFromParent_Done,
     /* 2295205 */   // Label 31165: @2295205
     /* 2295205 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2295253), // Rule ID 52457 //
     /* 2295210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295213 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2295216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295252 */     // GIR_Coverage, 52457,
     /* 2295252 */     GIR_EraseRootFromParent_Done,
     /* 2295253 */   // Label 31166: @2295253
     /* 2295253 */   GIM_Reject,
     /* 2295254 */ // Label 31164: @2295254
     /* 2295254 */ GIM_Reject,
     /* 2295255 */ // Label 31117: @2295255
     /* 2295255 */ GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2295375),
     /* 2295260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2295263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2295266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295278 */   GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2295326), // Rule ID 52400 //
     /* 2295283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295286 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2295303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295325 */     // GIR_Coverage, 52400,
     /* 2295325 */     GIR_EraseRootFromParent_Done,
     /* 2295326 */   // Label 31168: @2295326
     /* 2295326 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2295374), // Rule ID 52401 //
     /* 2295331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295334 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2295337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2295351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295373 */     // GIR_Coverage, 52401,
     /* 2295373 */     GIR_EraseRootFromParent_Done,
     /* 2295374 */   // Label 31169: @2295374
     /* 2295374 */   GIM_Reject,
     /* 2295375 */ // Label 31167: @2295375
     /* 2295375 */ GIM_Reject,
     /* 2295376 */ // Label 31118: @2295376
     /* 2295376 */ GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2295496),
     /* 2295381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2295384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2295387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295399 */   GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2295447), // Rule ID 52428 //
     /* 2295404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295407 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295446 */     // GIR_Coverage, 52428,
     /* 2295446 */     GIR_EraseRootFromParent_Done,
     /* 2295447 */   // Label 31171: @2295447
     /* 2295447 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2295495), // Rule ID 52429 //
     /* 2295452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295455 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295494 */     // GIR_Coverage, 52429,
     /* 2295494 */     GIR_EraseRootFromParent_Done,
     /* 2295495 */   // Label 31172: @2295495
     /* 2295495 */   GIM_Reject,
     /* 2295496 */ // Label 31170: @2295496
     /* 2295496 */ GIM_Reject,
     /* 2295497 */ // Label 31119: @2295497
     /* 2295497 */ GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2295617),
     /* 2295502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2295508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295520 */   GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2295568), // Rule ID 52444 //
     /* 2295525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295528 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295567 */     // GIR_Coverage, 52444,
     /* 2295567 */     GIR_EraseRootFromParent_Done,
     /* 2295568 */   // Label 31174: @2295568
     /* 2295568 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2295616), // Rule ID 52445 //
     /* 2295573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295576 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295615 */     // GIR_Coverage, 52445,
     /* 2295615 */     GIR_EraseRootFromParent_Done,
     /* 2295616 */   // Label 31175: @2295616
     /* 2295616 */   GIM_Reject,
     /* 2295617 */ // Label 31173: @2295617
     /* 2295617 */ GIM_Reject,
     /* 2295618 */ // Label 31120: @2295618
     /* 2295618 */ GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2295738),
     /* 2295623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2295629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295641 */   GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2295689), // Rule ID 52460 //
     /* 2295646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295649 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2295666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295688 */     // GIR_Coverage, 52460,
     /* 2295688 */     GIR_EraseRootFromParent_Done,
     /* 2295689 */   // Label 31177: @2295689
     /* 2295689 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2295737), // Rule ID 52461 //
     /* 2295694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295697 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2295714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295736 */     // GIR_Coverage, 52461,
     /* 2295736 */     GIR_EraseRootFromParent_Done,
     /* 2295737 */   // Label 31178: @2295737
     /* 2295737 */   GIM_Reject,
     /* 2295738 */ // Label 31176: @2295738
     /* 2295738 */ GIM_Reject,
     /* 2295739 */ // Label 31121: @2295739
     /* 2295739 */ GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2295859),
     /* 2295744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2295747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2295750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295762 */   GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2295810), // Rule ID 52416 //
     /* 2295767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295770 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295809 */     // GIR_Coverage, 52416,
     /* 2295809 */     GIR_EraseRootFromParent_Done,
     /* 2295810 */   // Label 31180: @2295810
     /* 2295810 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2295858), // Rule ID 52417 //
     /* 2295815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295818 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2295835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295857 */     // GIR_Coverage, 52417,
     /* 2295857 */     GIR_EraseRootFromParent_Done,
     /* 2295858 */   // Label 31181: @2295858
     /* 2295858 */   GIM_Reject,
     /* 2295859 */ // Label 31179: @2295859
     /* 2295859 */ GIM_Reject,
     /* 2295860 */ // Label 31122: @2295860
     /* 2295860 */ GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2295980),
     /* 2295865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2295868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2295871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295883 */   GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2295931), // Rule ID 52432 //
     /* 2295888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295891 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295930 */     // GIR_Coverage, 52432,
     /* 2295930 */     GIR_EraseRootFromParent_Done,
     /* 2295931 */   // Label 31183: @2295931
     /* 2295931 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2295979), // Rule ID 52433 //
     /* 2295936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295939 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2295956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295978 */     // GIR_Coverage, 52433,
     /* 2295978 */     GIR_EraseRootFromParent_Done,
     /* 2295979 */   // Label 31184: @2295979
     /* 2295979 */   GIM_Reject,
     /* 2295980 */ // Label 31182: @2295980
     /* 2295980 */ GIM_Reject,
     /* 2295981 */ // Label 31123: @2295981
     /* 2295981 */ GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2296101),
     /* 2295986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2295989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2295992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296004 */   GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2296052), // Rule ID 52448 //
     /* 2296009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296012 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296051 */     // GIR_Coverage, 52448,
     /* 2296051 */     GIR_EraseRootFromParent_Done,
     /* 2296052 */   // Label 31186: @2296052
     /* 2296052 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2296100), // Rule ID 52449 //
     /* 2296057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296060 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2296063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296099 */     // GIR_Coverage, 52449,
     /* 2296099 */     GIR_EraseRootFromParent_Done,
     /* 2296100 */   // Label 31187: @2296100
     /* 2296100 */   GIM_Reject,
     /* 2296101 */ // Label 31185: @2296101
     /* 2296101 */ GIM_Reject,
     /* 2296102 */ // Label 31124: @2296102
     /* 2296102 */ GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2296222),
     /* 2296107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2296110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2296113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2296125 */   GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2296173), // Rule ID 52420 //
     /* 2296130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296133 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2296150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296172 */     // GIR_Coverage, 52420,
     /* 2296172 */     GIR_EraseRootFromParent_Done,
     /* 2296173 */   // Label 31189: @2296173
     /* 2296173 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2296221), // Rule ID 52421 //
     /* 2296178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296181 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2296184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2296198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296220 */     // GIR_Coverage, 52421,
     /* 2296220 */     GIR_EraseRootFromParent_Done,
     /* 2296221 */   // Label 31190: @2296221
     /* 2296221 */   GIM_Reject,
     /* 2296222 */ // Label 31188: @2296222
     /* 2296222 */ GIM_Reject,
     /* 2296223 */ // Label 31125: @2296223
     /* 2296223 */ GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2296343),
     /* 2296228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2296231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2296234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296246 */   GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2296294), // Rule ID 52436 //
     /* 2296251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296254 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296293 */     // GIR_Coverage, 52436,
     /* 2296293 */     GIR_EraseRootFromParent_Done,
     /* 2296294 */   // Label 31192: @2296294
     /* 2296294 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2296342), // Rule ID 52437 //
     /* 2296299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296302 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2296305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296341 */     // GIR_Coverage, 52437,
     /* 2296341 */     GIR_EraseRootFromParent_Done,
     /* 2296342 */   // Label 31193: @2296342
     /* 2296342 */   GIM_Reject,
     /* 2296343 */ // Label 31191: @2296343
     /* 2296343 */ GIM_Reject,
     /* 2296344 */ // Label 31126: @2296344
     /* 2296344 */ GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2296464),
     /* 2296349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2296352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2296355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2296367 */   GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2296415), // Rule ID 52424 //
     /* 2296372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296375 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296414 */     // GIR_Coverage, 52424,
     /* 2296414 */     GIR_EraseRootFromParent_Done,
     /* 2296415 */   // Label 31195: @2296415
     /* 2296415 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2296463), // Rule ID 52425 //
     /* 2296420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296423 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2296426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2296440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296462 */     // GIR_Coverage, 52425,
     /* 2296462 */     GIR_EraseRootFromParent_Done,
     /* 2296463 */   // Label 31196: @2296463
     /* 2296463 */   GIM_Reject,
     /* 2296464 */ // Label 31194: @2296464
     /* 2296464 */ GIM_Reject,
     /* 2296465 */ // Label 31127: @2296465
     /* 2296465 */ GIM_Reject,
     /* 2296466 */ // Label 55: @2296466
     /* 2296466 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31220*/ GIMT_Encode4(2299318),
     /* 2296477 */ /*GILLT_s32*//*Label 31197*/ GIMT_Encode4(2296601), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296489 */ /*GILLT_nxv1s8*//*Label 31198*/ GIMT_Encode4(2296656),
     /* 2296493 */ /*GILLT_nxv1s16*//*Label 31199*/ GIMT_Encode4(2296777),
     /* 2296497 */ /*GILLT_nxv1s32*//*Label 31200*/ GIMT_Encode4(2296898),
     /* 2296501 */ /*GILLT_nxv1s64*//*Label 31201*/ GIMT_Encode4(2297019), GIMT_Encode4(0),
     /* 2296509 */ /*GILLT_nxv2s8*//*Label 31202*/ GIMT_Encode4(2297140),
     /* 2296513 */ /*GILLT_nxv2s16*//*Label 31203*/ GIMT_Encode4(2297261),
     /* 2296517 */ /*GILLT_nxv2s32*//*Label 31204*/ GIMT_Encode4(2297382),
     /* 2296521 */ /*GILLT_nxv2s64*//*Label 31205*/ GIMT_Encode4(2297503), GIMT_Encode4(0),
     /* 2296529 */ /*GILLT_nxv4s8*//*Label 31206*/ GIMT_Encode4(2297624),
     /* 2296533 */ /*GILLT_nxv4s16*//*Label 31207*/ GIMT_Encode4(2297745),
     /* 2296537 */ /*GILLT_nxv4s32*//*Label 31208*/ GIMT_Encode4(2297866),
     /* 2296541 */ /*GILLT_nxv4s64*//*Label 31209*/ GIMT_Encode4(2297987), GIMT_Encode4(0),
     /* 2296549 */ /*GILLT_nxv8s8*//*Label 31210*/ GIMT_Encode4(2298108),
     /* 2296553 */ /*GILLT_nxv8s16*//*Label 31211*/ GIMT_Encode4(2298229),
     /* 2296557 */ /*GILLT_nxv8s32*//*Label 31212*/ GIMT_Encode4(2298350),
     /* 2296561 */ /*GILLT_nxv8s64*//*Label 31213*/ GIMT_Encode4(2298471), GIMT_Encode4(0),
     /* 2296569 */ /*GILLT_nxv16s8*//*Label 31214*/ GIMT_Encode4(2298592),
     /* 2296573 */ /*GILLT_nxv16s16*//*Label 31215*/ GIMT_Encode4(2298713),
     /* 2296577 */ /*GILLT_nxv16s32*//*Label 31216*/ GIMT_Encode4(2298834), GIMT_Encode4(0),
     /* 2296585 */ /*GILLT_nxv32s8*//*Label 31217*/ GIMT_Encode4(2298955),
     /* 2296589 */ /*GILLT_nxv32s16*//*Label 31218*/ GIMT_Encode4(2299076), GIMT_Encode4(0),
     /* 2296597 */ /*GILLT_nxv64s8*//*Label 31219*/ GIMT_Encode4(2299197),
     /* 2296601 */ // Label 31197: @2296601
     /* 2296601 */ GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2296655),
     /* 2296606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296624 */   GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2296639), // Rule ID 64591 //
     /* 2296629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296632 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2296637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296638 */     // GIR_Coverage, 64591,
     /* 2296638 */     GIR_Done,
     /* 2296639 */   // Label 31222: @2296639
     /* 2296639 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2296654), // Rule ID 64592 //
     /* 2296644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296647 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2296652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296653 */     // GIR_Coverage, 64592,
     /* 2296653 */     GIR_Done,
     /* 2296654 */   // Label 31223: @2296654
     /* 2296654 */   GIM_Reject,
     /* 2296655 */ // Label 31221: @2296655
     /* 2296655 */ GIM_Reject,
     /* 2296656 */ // Label 31198: @2296656
     /* 2296656 */ GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2296776),
     /* 2296661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2296664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2296667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296679 */   GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2296727), // Rule ID 52728 //
     /* 2296684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296687 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2296690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2296704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296726 */     // GIR_Coverage, 52728,
     /* 2296726 */     GIR_EraseRootFromParent_Done,
     /* 2296727 */   // Label 31225: @2296727
     /* 2296727 */   GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2296775), // Rule ID 52729 //
     /* 2296732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296735 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2296738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2296752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296774 */     // GIR_Coverage, 52729,
     /* 2296774 */     GIR_EraseRootFromParent_Done,
     /* 2296775 */   // Label 31226: @2296775
     /* 2296775 */   GIM_Reject,
     /* 2296776 */ // Label 31224: @2296776
     /* 2296776 */ GIM_Reject,
     /* 2296777 */ // Label 31199: @2296777
     /* 2296777 */ GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2296897),
     /* 2296782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2296785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2296788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296800 */   GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2296848), // Rule ID 52740 //
     /* 2296805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296808 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2296825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296847 */     // GIR_Coverage, 52740,
     /* 2296847 */     GIR_EraseRootFromParent_Done,
     /* 2296848 */   // Label 31228: @2296848
     /* 2296848 */   GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2296896), // Rule ID 52741 //
     /* 2296853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296856 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2296873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296895 */     // GIR_Coverage, 52741,
     /* 2296895 */     GIR_EraseRootFromParent_Done,
     /* 2296896 */   // Label 31229: @2296896
     /* 2296896 */   GIM_Reject,
     /* 2296897 */ // Label 31227: @2296897
     /* 2296897 */ GIM_Reject,
     /* 2296898 */ // Label 31200: @2296898
     /* 2296898 */ GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2297018),
     /* 2296903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2296906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2296909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296921 */   GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2296969), // Rule ID 52748 //
     /* 2296926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2296929 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2296946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296968 */     // GIR_Coverage, 52748,
     /* 2296968 */     GIR_EraseRootFromParent_Done,
     /* 2296969 */   // Label 31231: @2296969
     /* 2296969 */   GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2297017), // Rule ID 52749 //
     /* 2296974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2296977 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2296994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297016 */     // GIR_Coverage, 52749,
     /* 2297016 */     GIR_EraseRootFromParent_Done,
     /* 2297017 */   // Label 31232: @2297017
     /* 2297017 */   GIM_Reject,
     /* 2297018 */ // Label 31230: @2297018
     /* 2297018 */ GIM_Reject,
     /* 2297019 */ // Label 31201: @2297019
     /* 2297019 */ GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2297139),
     /* 2297024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2297027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2297030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297042 */   GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2297090), // Rule ID 52764 //
     /* 2297047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297050 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297089 */     // GIR_Coverage, 52764,
     /* 2297089 */     GIR_EraseRootFromParent_Done,
     /* 2297090 */   // Label 31234: @2297090
     /* 2297090 */   GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2297138), // Rule ID 52765 //
     /* 2297095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297098 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297137 */     // GIR_Coverage, 52765,
     /* 2297137 */     GIR_EraseRootFromParent_Done,
     /* 2297138 */   // Label 31235: @2297138
     /* 2297138 */   GIM_Reject,
     /* 2297139 */ // Label 31233: @2297139
     /* 2297139 */ GIM_Reject,
     /* 2297140 */ // Label 31202: @2297140
     /* 2297140 */ GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2297260),
     /* 2297145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2297148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2297151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297163 */   GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2297211), // Rule ID 52732 //
     /* 2297168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297171 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2297174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2297188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297210 */     // GIR_Coverage, 52732,
     /* 2297210 */     GIR_EraseRootFromParent_Done,
     /* 2297211 */   // Label 31237: @2297211
     /* 2297211 */   GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2297259), // Rule ID 52733 //
     /* 2297216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297219 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2297222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2297236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297258 */     // GIR_Coverage, 52733,
     /* 2297258 */     GIR_EraseRootFromParent_Done,
     /* 2297259 */   // Label 31238: @2297259
     /* 2297259 */   GIM_Reject,
     /* 2297260 */ // Label 31236: @2297260
     /* 2297260 */ GIM_Reject,
     /* 2297261 */ // Label 31203: @2297261
     /* 2297261 */ GIM_Try, /*On fail goto*//*Label 31239*/ GIMT_Encode4(2297381),
     /* 2297266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2297269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2297272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297284 */   GIM_Try, /*On fail goto*//*Label 31240*/ GIMT_Encode4(2297332), // Rule ID 52744 //
     /* 2297289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297292 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297331 */     // GIR_Coverage, 52744,
     /* 2297331 */     GIR_EraseRootFromParent_Done,
     /* 2297332 */   // Label 31240: @2297332
     /* 2297332 */   GIM_Try, /*On fail goto*//*Label 31241*/ GIMT_Encode4(2297380), // Rule ID 52745 //
     /* 2297337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297340 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297379 */     // GIR_Coverage, 52745,
     /* 2297379 */     GIR_EraseRootFromParent_Done,
     /* 2297380 */   // Label 31241: @2297380
     /* 2297380 */   GIM_Reject,
     /* 2297381 */ // Label 31239: @2297381
     /* 2297381 */ GIM_Reject,
     /* 2297382 */ // Label 31204: @2297382
     /* 2297382 */ GIM_Try, /*On fail goto*//*Label 31242*/ GIMT_Encode4(2297502),
     /* 2297387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2297390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2297393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297405 */   GIM_Try, /*On fail goto*//*Label 31243*/ GIMT_Encode4(2297453), // Rule ID 52760 //
     /* 2297410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297413 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297452 */     // GIR_Coverage, 52760,
     /* 2297452 */     GIR_EraseRootFromParent_Done,
     /* 2297453 */   // Label 31243: @2297453
     /* 2297453 */   GIM_Try, /*On fail goto*//*Label 31244*/ GIMT_Encode4(2297501), // Rule ID 52761 //
     /* 2297458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297461 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297500 */     // GIR_Coverage, 52761,
     /* 2297500 */     GIR_EraseRootFromParent_Done,
     /* 2297501 */   // Label 31244: @2297501
     /* 2297501 */   GIM_Reject,
     /* 2297502 */ // Label 31242: @2297502
     /* 2297502 */ GIM_Reject,
     /* 2297503 */ // Label 31205: @2297503
     /* 2297503 */ GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2297623),
     /* 2297508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2297514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297526 */   GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2297574), // Rule ID 52804 //
     /* 2297531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2297534 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297573 */     // GIR_Coverage, 52804,
     /* 2297573 */     GIR_EraseRootFromParent_Done,
     /* 2297574 */   // Label 31246: @2297574
     /* 2297574 */   GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2297622), // Rule ID 52805 //
     /* 2297579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2297582 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297621 */     // GIR_Coverage, 52805,
     /* 2297621 */     GIR_EraseRootFromParent_Done,
     /* 2297622 */   // Label 31247: @2297622
     /* 2297622 */   GIM_Reject,
     /* 2297623 */ // Label 31245: @2297623
     /* 2297623 */ GIM_Reject,
     /* 2297624 */ // Label 31206: @2297624
     /* 2297624 */ GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2297744),
     /* 2297629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2297632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2297635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297647 */   GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2297695), // Rule ID 52736 //
     /* 2297652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297655 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2297658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297694 */     // GIR_Coverage, 52736,
     /* 2297694 */     GIR_EraseRootFromParent_Done,
     /* 2297695 */   // Label 31249: @2297695
     /* 2297695 */   GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2297743), // Rule ID 52737 //
     /* 2297700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297703 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2297706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2297720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297742 */     // GIR_Coverage, 52737,
     /* 2297742 */     GIR_EraseRootFromParent_Done,
     /* 2297743 */   // Label 31250: @2297743
     /* 2297743 */   GIM_Reject,
     /* 2297744 */ // Label 31248: @2297744
     /* 2297744 */ GIM_Reject,
     /* 2297745 */ // Label 31207: @2297745
     /* 2297745 */ GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2297865),
     /* 2297750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2297756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297768 */   GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2297816), // Rule ID 52756 //
     /* 2297773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297776 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297815 */     // GIR_Coverage, 52756,
     /* 2297815 */     GIR_EraseRootFromParent_Done,
     /* 2297816 */   // Label 31252: @2297816
     /* 2297816 */   GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2297864), // Rule ID 52757 //
     /* 2297821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297824 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2297841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297863 */     // GIR_Coverage, 52757,
     /* 2297863 */     GIR_EraseRootFromParent_Done,
     /* 2297864 */   // Label 31253: @2297864
     /* 2297864 */   GIM_Reject,
     /* 2297865 */ // Label 31251: @2297865
     /* 2297865 */ GIM_Reject,
     /* 2297866 */ // Label 31208: @2297866
     /* 2297866 */ GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2297986),
     /* 2297871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2297874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2297877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297889 */   GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2297937), // Rule ID 52792 //
     /* 2297894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2297897 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297936 */     // GIR_Coverage, 52792,
     /* 2297936 */     GIR_EraseRootFromParent_Done,
     /* 2297937 */   // Label 31255: @2297937
     /* 2297937 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2297985), // Rule ID 52793 //
     /* 2297942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2297945 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2297962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2297983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297984 */     // GIR_Coverage, 52793,
     /* 2297984 */     GIR_EraseRootFromParent_Done,
     /* 2297985 */   // Label 31256: @2297985
     /* 2297985 */   GIM_Reject,
     /* 2297986 */ // Label 31254: @2297986
     /* 2297986 */ GIM_Reject,
     /* 2297987 */ // Label 31209: @2297987
     /* 2297987 */ GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2298107),
     /* 2297992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2297995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2297998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298010 */   GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2298058), // Rule ID 52808 //
     /* 2298015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2298018 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298057 */     // GIR_Coverage, 52808,
     /* 2298057 */     GIR_EraseRootFromParent_Done,
     /* 2298058 */   // Label 31258: @2298058
     /* 2298058 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2298106), // Rule ID 52809 //
     /* 2298063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2298066 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2298069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298105 */     // GIR_Coverage, 52809,
     /* 2298105 */     GIR_EraseRootFromParent_Done,
     /* 2298106 */   // Label 31259: @2298106
     /* 2298106 */   GIM_Reject,
     /* 2298107 */ // Label 31257: @2298107
     /* 2298107 */ GIM_Reject,
     /* 2298108 */ // Label 31210: @2298108
     /* 2298108 */ GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2298228),
     /* 2298113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2298116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2298119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298131 */   GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2298179), // Rule ID 52752 //
     /* 2298136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298139 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2298142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2298156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298178 */     // GIR_Coverage, 52752,
     /* 2298178 */     GIR_EraseRootFromParent_Done,
     /* 2298179 */   // Label 31261: @2298179
     /* 2298179 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2298227), // Rule ID 52753 //
     /* 2298184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298187 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2298190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2298204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298226 */     // GIR_Coverage, 52753,
     /* 2298226 */     GIR_EraseRootFromParent_Done,
     /* 2298227 */   // Label 31262: @2298227
     /* 2298227 */   GIM_Reject,
     /* 2298228 */ // Label 31260: @2298228
     /* 2298228 */ GIM_Reject,
     /* 2298229 */ // Label 31211: @2298229
     /* 2298229 */ GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2298349),
     /* 2298234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2298237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2298240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298252 */   GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2298300), // Rule ID 52780 //
     /* 2298257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298260 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298299 */     // GIR_Coverage, 52780,
     /* 2298299 */     GIR_EraseRootFromParent_Done,
     /* 2298300 */   // Label 31264: @2298300
     /* 2298300 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2298348), // Rule ID 52781 //
     /* 2298305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298308 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2298311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298347 */     // GIR_Coverage, 52781,
     /* 2298347 */     GIR_EraseRootFromParent_Done,
     /* 2298348 */   // Label 31265: @2298348
     /* 2298348 */   GIM_Reject,
     /* 2298349 */ // Label 31263: @2298349
     /* 2298349 */ GIM_Reject,
     /* 2298350 */ // Label 31212: @2298350
     /* 2298350 */ GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2298470),
     /* 2298355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2298358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2298361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298373 */   GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2298421), // Rule ID 52796 //
     /* 2298378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298381 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298420 */     // GIR_Coverage, 52796,
     /* 2298420 */     GIR_EraseRootFromParent_Done,
     /* 2298421 */   // Label 31267: @2298421
     /* 2298421 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2298469), // Rule ID 52797 //
     /* 2298426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298429 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298468 */     // GIR_Coverage, 52797,
     /* 2298468 */     GIR_EraseRootFromParent_Done,
     /* 2298469 */   // Label 31268: @2298469
     /* 2298469 */   GIM_Reject,
     /* 2298470 */ // Label 31266: @2298470
     /* 2298470 */ GIM_Reject,
     /* 2298471 */ // Label 31213: @2298471
     /* 2298471 */ GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2298591),
     /* 2298476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2298479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2298482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298494 */   GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2298542), // Rule ID 52812 //
     /* 2298499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2298502 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298541 */     // GIR_Coverage, 52812,
     /* 2298541 */     GIR_EraseRootFromParent_Done,
     /* 2298542 */   // Label 31270: @2298542
     /* 2298542 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2298590), // Rule ID 52813 //
     /* 2298547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2298550 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298589 */     // GIR_Coverage, 52813,
     /* 2298589 */     GIR_EraseRootFromParent_Done,
     /* 2298590 */   // Label 31271: @2298590
     /* 2298590 */   GIM_Reject,
     /* 2298591 */ // Label 31269: @2298591
     /* 2298591 */ GIM_Reject,
     /* 2298592 */ // Label 31214: @2298592
     /* 2298592 */ GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2298712),
     /* 2298597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2298600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2298603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298615 */   GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2298663), // Rule ID 52768 //
     /* 2298620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298623 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2298626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298662 */     // GIR_Coverage, 52768,
     /* 2298662 */     GIR_EraseRootFromParent_Done,
     /* 2298663 */   // Label 31273: @2298663
     /* 2298663 */   GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2298711), // Rule ID 52769 //
     /* 2298668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298671 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2298674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2298688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298710 */     // GIR_Coverage, 52769,
     /* 2298710 */     GIR_EraseRootFromParent_Done,
     /* 2298711 */   // Label 31274: @2298711
     /* 2298711 */   GIM_Reject,
     /* 2298712 */ // Label 31272: @2298712
     /* 2298712 */ GIM_Reject,
     /* 2298713 */ // Label 31215: @2298713
     /* 2298713 */ GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2298833),
     /* 2298718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2298721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2298724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298736 */   GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2298784), // Rule ID 52784 //
     /* 2298741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298744 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298783 */     // GIR_Coverage, 52784,
     /* 2298783 */     GIR_EraseRootFromParent_Done,
     /* 2298784 */   // Label 31276: @2298784
     /* 2298784 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2298832), // Rule ID 52785 //
     /* 2298789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298792 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2298809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298831 */     // GIR_Coverage, 52785,
     /* 2298831 */     GIR_EraseRootFromParent_Done,
     /* 2298832 */   // Label 31277: @2298832
     /* 2298832 */   GIM_Reject,
     /* 2298833 */ // Label 31275: @2298833
     /* 2298833 */ GIM_Reject,
     /* 2298834 */ // Label 31216: @2298834
     /* 2298834 */ GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2298954),
     /* 2298839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2298842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2298845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298857 */   GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2298905), // Rule ID 52800 //
     /* 2298862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298865 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298904 */     // GIR_Coverage, 52800,
     /* 2298904 */     GIR_EraseRootFromParent_Done,
     /* 2298905 */   // Label 31279: @2298905
     /* 2298905 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2298953), // Rule ID 52801 //
     /* 2298910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2298913 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2298930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2298951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298952 */     // GIR_Coverage, 52801,
     /* 2298952 */     GIR_EraseRootFromParent_Done,
     /* 2298953 */   // Label 31280: @2298953
     /* 2298953 */   GIM_Reject,
     /* 2298954 */ // Label 31278: @2298954
     /* 2298954 */ GIM_Reject,
     /* 2298955 */ // Label 31217: @2298955
     /* 2298955 */ GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2299075),
     /* 2298960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2298963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2298966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298978 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2299026), // Rule ID 52772 //
     /* 2298983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2298986 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2298989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2299003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299025 */     // GIR_Coverage, 52772,
     /* 2299025 */     GIR_EraseRootFromParent_Done,
     /* 2299026 */   // Label 31282: @2299026
     /* 2299026 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2299074), // Rule ID 52773 //
     /* 2299031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299034 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2299037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2299051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299073 */     // GIR_Coverage, 52773,
     /* 2299073 */     GIR_EraseRootFromParent_Done,
     /* 2299074 */   // Label 31283: @2299074
     /* 2299074 */   GIM_Reject,
     /* 2299075 */ // Label 31281: @2299075
     /* 2299075 */ GIM_Reject,
     /* 2299076 */ // Label 31218: @2299076
     /* 2299076 */ GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2299196),
     /* 2299081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2299084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2299087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299099 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2299147), // Rule ID 52788 //
     /* 2299104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299107 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2299110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299146 */     // GIR_Coverage, 52788,
     /* 2299146 */     GIR_EraseRootFromParent_Done,
     /* 2299147 */   // Label 31285: @2299147
     /* 2299147 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2299195), // Rule ID 52789 //
     /* 2299152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299155 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2299158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299194 */     // GIR_Coverage, 52789,
     /* 2299194 */     GIR_EraseRootFromParent_Done,
     /* 2299195 */   // Label 31286: @2299195
     /* 2299195 */   GIM_Reject,
     /* 2299196 */ // Label 31284: @2299196
     /* 2299196 */ GIM_Reject,
     /* 2299197 */ // Label 31219: @2299197
     /* 2299197 */ GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2299317),
     /* 2299202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2299205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2299208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2299220 */   GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2299268), // Rule ID 52776 //
     /* 2299225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299228 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2299231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299267 */     // GIR_Coverage, 52776,
     /* 2299267 */     GIR_EraseRootFromParent_Done,
     /* 2299268 */   // Label 31288: @2299268
     /* 2299268 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2299316), // Rule ID 52777 //
     /* 2299273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299276 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2299279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2299293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299315 */     // GIR_Coverage, 52777,
     /* 2299315 */     GIR_EraseRootFromParent_Done,
     /* 2299316 */   // Label 31289: @2299316
     /* 2299316 */   GIM_Reject,
     /* 2299317 */ // Label 31287: @2299317
     /* 2299317 */ GIM_Reject,
     /* 2299318 */ // Label 31220: @2299318
     /* 2299318 */ GIM_Reject,
     /* 2299319 */ // Label 56: @2299319
     /* 2299319 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31313*/ GIMT_Encode4(2302171),
     /* 2299330 */ /*GILLT_s32*//*Label 31290*/ GIMT_Encode4(2299454), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2299342 */ /*GILLT_nxv1s8*//*Label 31291*/ GIMT_Encode4(2299509),
     /* 2299346 */ /*GILLT_nxv1s16*//*Label 31292*/ GIMT_Encode4(2299630),
     /* 2299350 */ /*GILLT_nxv1s32*//*Label 31293*/ GIMT_Encode4(2299751),
     /* 2299354 */ /*GILLT_nxv1s64*//*Label 31294*/ GIMT_Encode4(2299872), GIMT_Encode4(0),
     /* 2299362 */ /*GILLT_nxv2s8*//*Label 31295*/ GIMT_Encode4(2299993),
     /* 2299366 */ /*GILLT_nxv2s16*//*Label 31296*/ GIMT_Encode4(2300114),
     /* 2299370 */ /*GILLT_nxv2s32*//*Label 31297*/ GIMT_Encode4(2300235),
     /* 2299374 */ /*GILLT_nxv2s64*//*Label 31298*/ GIMT_Encode4(2300356), GIMT_Encode4(0),
     /* 2299382 */ /*GILLT_nxv4s8*//*Label 31299*/ GIMT_Encode4(2300477),
     /* 2299386 */ /*GILLT_nxv4s16*//*Label 31300*/ GIMT_Encode4(2300598),
     /* 2299390 */ /*GILLT_nxv4s32*//*Label 31301*/ GIMT_Encode4(2300719),
     /* 2299394 */ /*GILLT_nxv4s64*//*Label 31302*/ GIMT_Encode4(2300840), GIMT_Encode4(0),
     /* 2299402 */ /*GILLT_nxv8s8*//*Label 31303*/ GIMT_Encode4(2300961),
     /* 2299406 */ /*GILLT_nxv8s16*//*Label 31304*/ GIMT_Encode4(2301082),
     /* 2299410 */ /*GILLT_nxv8s32*//*Label 31305*/ GIMT_Encode4(2301203),
     /* 2299414 */ /*GILLT_nxv8s64*//*Label 31306*/ GIMT_Encode4(2301324), GIMT_Encode4(0),
     /* 2299422 */ /*GILLT_nxv16s8*//*Label 31307*/ GIMT_Encode4(2301445),
     /* 2299426 */ /*GILLT_nxv16s16*//*Label 31308*/ GIMT_Encode4(2301566),
     /* 2299430 */ /*GILLT_nxv16s32*//*Label 31309*/ GIMT_Encode4(2301687), GIMT_Encode4(0),
     /* 2299438 */ /*GILLT_nxv32s8*//*Label 31310*/ GIMT_Encode4(2301808),
     /* 2299442 */ /*GILLT_nxv32s16*//*Label 31311*/ GIMT_Encode4(2301929), GIMT_Encode4(0),
     /* 2299450 */ /*GILLT_nxv64s8*//*Label 31312*/ GIMT_Encode4(2302050),
     /* 2299454 */ // Label 31290: @2299454
     /* 2299454 */ GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2299508),
     /* 2299459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2299462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2299465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2299477 */   GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2299492), // Rule ID 64589 //
     /* 2299482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2299485 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2299485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2299490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299491 */     // GIR_Coverage, 64589,
     /* 2299491 */     GIR_Done,
     /* 2299492 */   // Label 31315: @2299492
     /* 2299492 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2299507), // Rule ID 64590 //
     /* 2299497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2299500 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2299500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2299505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299506 */     // GIR_Coverage, 64590,
     /* 2299506 */     GIR_Done,
     /* 2299507 */   // Label 31316: @2299507
     /* 2299507 */   GIM_Reject,
     /* 2299508 */ // Label 31314: @2299508
     /* 2299508 */ GIM_Reject,
     /* 2299509 */ // Label 31291: @2299509
     /* 2299509 */ GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2299629),
     /* 2299514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2299517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2299520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299532 */   GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2299580), // Rule ID 52640 //
     /* 2299537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299540 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2299543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2299557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299579 */     // GIR_Coverage, 52640,
     /* 2299579 */     GIR_EraseRootFromParent_Done,
     /* 2299580 */   // Label 31318: @2299580
     /* 2299580 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2299628), // Rule ID 52641 //
     /* 2299585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299588 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2299591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2299605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299627 */     // GIR_Coverage, 52641,
     /* 2299627 */     GIR_EraseRootFromParent_Done,
     /* 2299628 */   // Label 31319: @2299628
     /* 2299628 */   GIM_Reject,
     /* 2299629 */ // Label 31317: @2299629
     /* 2299629 */ GIM_Reject,
     /* 2299630 */ // Label 31292: @2299630
     /* 2299630 */ GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2299750),
     /* 2299635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2299641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299653 */   GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2299701), // Rule ID 52652 //
     /* 2299658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299661 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2299678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299700 */     // GIR_Coverage, 52652,
     /* 2299700 */     GIR_EraseRootFromParent_Done,
     /* 2299701 */   // Label 31321: @2299701
     /* 2299701 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2299749), // Rule ID 52653 //
     /* 2299706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299709 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2299726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299748 */     // GIR_Coverage, 52653,
     /* 2299748 */     GIR_EraseRootFromParent_Done,
     /* 2299749 */   // Label 31322: @2299749
     /* 2299749 */   GIM_Reject,
     /* 2299750 */ // Label 31320: @2299750
     /* 2299750 */ GIM_Reject,
     /* 2299751 */ // Label 31293: @2299751
     /* 2299751 */ GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2299871),
     /* 2299756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2299762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299774 */   GIM_Try, /*On fail goto*//*Label 31324*/ GIMT_Encode4(2299822), // Rule ID 52660 //
     /* 2299779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2299782 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2299799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299821 */     // GIR_Coverage, 52660,
     /* 2299821 */     GIR_EraseRootFromParent_Done,
     /* 2299822 */   // Label 31324: @2299822
     /* 2299822 */   GIM_Try, /*On fail goto*//*Label 31325*/ GIMT_Encode4(2299870), // Rule ID 52661 //
     /* 2299827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2299830 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2299847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299869 */     // GIR_Coverage, 52661,
     /* 2299869 */     GIR_EraseRootFromParent_Done,
     /* 2299870 */   // Label 31325: @2299870
     /* 2299870 */   GIM_Reject,
     /* 2299871 */ // Label 31323: @2299871
     /* 2299871 */ GIM_Reject,
     /* 2299872 */ // Label 31294: @2299872
     /* 2299872 */ GIM_Try, /*On fail goto*//*Label 31326*/ GIMT_Encode4(2299992),
     /* 2299877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2299883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299895 */   GIM_Try, /*On fail goto*//*Label 31327*/ GIMT_Encode4(2299943), // Rule ID 52676 //
     /* 2299900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2299903 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2299920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299942 */     // GIR_Coverage, 52676,
     /* 2299942 */     GIR_EraseRootFromParent_Done,
     /* 2299943 */   // Label 31327: @2299943
     /* 2299943 */   GIM_Try, /*On fail goto*//*Label 31328*/ GIMT_Encode4(2299991), // Rule ID 52677 //
     /* 2299948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2299951 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2299968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2299989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299990 */     // GIR_Coverage, 52677,
     /* 2299990 */     GIR_EraseRootFromParent_Done,
     /* 2299991 */   // Label 31328: @2299991
     /* 2299991 */   GIM_Reject,
     /* 2299992 */ // Label 31326: @2299992
     /* 2299992 */ GIM_Reject,
     /* 2299993 */ // Label 31295: @2299993
     /* 2299993 */ GIM_Try, /*On fail goto*//*Label 31329*/ GIMT_Encode4(2300113),
     /* 2299998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2300001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2300004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300016 */   GIM_Try, /*On fail goto*//*Label 31330*/ GIMT_Encode4(2300064), // Rule ID 52644 //
     /* 2300021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300024 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2300027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2300041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300063 */     // GIR_Coverage, 52644,
     /* 2300063 */     GIR_EraseRootFromParent_Done,
     /* 2300064 */   // Label 31330: @2300064
     /* 2300064 */   GIM_Try, /*On fail goto*//*Label 31331*/ GIMT_Encode4(2300112), // Rule ID 52645 //
     /* 2300069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300072 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2300075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2300089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300111 */     // GIR_Coverage, 52645,
     /* 2300111 */     GIR_EraseRootFromParent_Done,
     /* 2300112 */   // Label 31331: @2300112
     /* 2300112 */   GIM_Reject,
     /* 2300113 */ // Label 31329: @2300113
     /* 2300113 */ GIM_Reject,
     /* 2300114 */ // Label 31296: @2300114
     /* 2300114 */ GIM_Try, /*On fail goto*//*Label 31332*/ GIMT_Encode4(2300234),
     /* 2300119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2300125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300137 */   GIM_Try, /*On fail goto*//*Label 31333*/ GIMT_Encode4(2300185), // Rule ID 52656 //
     /* 2300142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300145 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300184 */     // GIR_Coverage, 52656,
     /* 2300184 */     GIR_EraseRootFromParent_Done,
     /* 2300185 */   // Label 31333: @2300185
     /* 2300185 */   GIM_Try, /*On fail goto*//*Label 31334*/ GIMT_Encode4(2300233), // Rule ID 52657 //
     /* 2300190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300193 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2300196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300232 */     // GIR_Coverage, 52657,
     /* 2300232 */     GIR_EraseRootFromParent_Done,
     /* 2300233 */   // Label 31334: @2300233
     /* 2300233 */   GIM_Reject,
     /* 2300234 */ // Label 31332: @2300234
     /* 2300234 */ GIM_Reject,
     /* 2300235 */ // Label 31297: @2300235
     /* 2300235 */ GIM_Try, /*On fail goto*//*Label 31335*/ GIMT_Encode4(2300355),
     /* 2300240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2300246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300258 */   GIM_Try, /*On fail goto*//*Label 31336*/ GIMT_Encode4(2300306), // Rule ID 52672 //
     /* 2300263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300266 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300305 */     // GIR_Coverage, 52672,
     /* 2300305 */     GIR_EraseRootFromParent_Done,
     /* 2300306 */   // Label 31336: @2300306
     /* 2300306 */   GIM_Try, /*On fail goto*//*Label 31337*/ GIMT_Encode4(2300354), // Rule ID 52673 //
     /* 2300311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300314 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2300317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300353 */     // GIR_Coverage, 52673,
     /* 2300353 */     GIR_EraseRootFromParent_Done,
     /* 2300354 */   // Label 31337: @2300354
     /* 2300354 */   GIM_Reject,
     /* 2300355 */ // Label 31335: @2300355
     /* 2300355 */ GIM_Reject,
     /* 2300356 */ // Label 31298: @2300356
     /* 2300356 */ GIM_Try, /*On fail goto*//*Label 31338*/ GIMT_Encode4(2300476),
     /* 2300361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2300364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2300367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300379 */   GIM_Try, /*On fail goto*//*Label 31339*/ GIMT_Encode4(2300427), // Rule ID 52716 //
     /* 2300384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2300387 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300426 */     // GIR_Coverage, 52716,
     /* 2300426 */     GIR_EraseRootFromParent_Done,
     /* 2300427 */   // Label 31339: @2300427
     /* 2300427 */   GIM_Try, /*On fail goto*//*Label 31340*/ GIMT_Encode4(2300475), // Rule ID 52717 //
     /* 2300432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2300435 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2300438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300474 */     // GIR_Coverage, 52717,
     /* 2300474 */     GIR_EraseRootFromParent_Done,
     /* 2300475 */   // Label 31340: @2300475
     /* 2300475 */   GIM_Reject,
     /* 2300476 */ // Label 31338: @2300476
     /* 2300476 */ GIM_Reject,
     /* 2300477 */ // Label 31299: @2300477
     /* 2300477 */ GIM_Try, /*On fail goto*//*Label 31341*/ GIMT_Encode4(2300597),
     /* 2300482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2300485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2300488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300500 */   GIM_Try, /*On fail goto*//*Label 31342*/ GIMT_Encode4(2300548), // Rule ID 52648 //
     /* 2300505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300508 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2300511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300547 */     // GIR_Coverage, 52648,
     /* 2300547 */     GIR_EraseRootFromParent_Done,
     /* 2300548 */   // Label 31342: @2300548
     /* 2300548 */   GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2300596), // Rule ID 52649 //
     /* 2300553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300556 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2300559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2300573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300595 */     // GIR_Coverage, 52649,
     /* 2300595 */     GIR_EraseRootFromParent_Done,
     /* 2300596 */   // Label 31343: @2300596
     /* 2300596 */   GIM_Reject,
     /* 2300597 */ // Label 31341: @2300597
     /* 2300597 */ GIM_Reject,
     /* 2300598 */ // Label 31300: @2300598
     /* 2300598 */ GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2300718),
     /* 2300603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2300606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2300609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300621 */   GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2300669), // Rule ID 52668 //
     /* 2300626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300629 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300668 */     // GIR_Coverage, 52668,
     /* 2300668 */     GIR_EraseRootFromParent_Done,
     /* 2300669 */   // Label 31345: @2300669
     /* 2300669 */   GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2300717), // Rule ID 52669 //
     /* 2300674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300677 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2300680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2300694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300716 */     // GIR_Coverage, 52669,
     /* 2300716 */     GIR_EraseRootFromParent_Done,
     /* 2300717 */   // Label 31346: @2300717
     /* 2300717 */   GIM_Reject,
     /* 2300718 */ // Label 31344: @2300718
     /* 2300718 */ GIM_Reject,
     /* 2300719 */ // Label 31301: @2300719
     /* 2300719 */ GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2300839),
     /* 2300724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2300727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2300730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300742 */   GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2300790), // Rule ID 52704 //
     /* 2300747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300750 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300789 */     // GIR_Coverage, 52704,
     /* 2300789 */     GIR_EraseRootFromParent_Done,
     /* 2300790 */   // Label 31348: @2300790
     /* 2300790 */   GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2300838), // Rule ID 52705 //
     /* 2300795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2300798 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2300815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300837 */     // GIR_Coverage, 52705,
     /* 2300837 */     GIR_EraseRootFromParent_Done,
     /* 2300838 */   // Label 31349: @2300838
     /* 2300838 */   GIM_Reject,
     /* 2300839 */ // Label 31347: @2300839
     /* 2300839 */ GIM_Reject,
     /* 2300840 */ // Label 31302: @2300840
     /* 2300840 */ GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2300960),
     /* 2300845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2300848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2300851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300863 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2300911), // Rule ID 52720 //
     /* 2300868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2300871 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2300888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300910 */     // GIR_Coverage, 52720,
     /* 2300910 */     GIR_EraseRootFromParent_Done,
     /* 2300911 */   // Label 31351: @2300911
     /* 2300911 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2300959), // Rule ID 52721 //
     /* 2300916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2300919 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2300936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2300957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300958 */     // GIR_Coverage, 52721,
     /* 2300958 */     GIR_EraseRootFromParent_Done,
     /* 2300959 */   // Label 31352: @2300959
     /* 2300959 */   GIM_Reject,
     /* 2300960 */ // Label 31350: @2300960
     /* 2300960 */ GIM_Reject,
     /* 2300961 */ // Label 31303: @2300961
     /* 2300961 */ GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2301081),
     /* 2300966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2300969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2300972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300984 */   GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2301032), // Rule ID 52664 //
     /* 2300989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2300992 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2300995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2301009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301031 */     // GIR_Coverage, 52664,
     /* 2301031 */     GIR_EraseRootFromParent_Done,
     /* 2301032 */   // Label 31354: @2301032
     /* 2301032 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2301080), // Rule ID 52665 //
     /* 2301037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301040 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2301043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2301057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301079 */     // GIR_Coverage, 52665,
     /* 2301079 */     GIR_EraseRootFromParent_Done,
     /* 2301080 */   // Label 31355: @2301080
     /* 2301080 */   GIM_Reject,
     /* 2301081 */ // Label 31353: @2301081
     /* 2301081 */ GIM_Reject,
     /* 2301082 */ // Label 31304: @2301082
     /* 2301082 */ GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2301202),
     /* 2301087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2301090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2301093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301105 */   GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2301153), // Rule ID 52692 //
     /* 2301110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301113 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2301116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301152 */     // GIR_Coverage, 52692,
     /* 2301152 */     GIR_EraseRootFromParent_Done,
     /* 2301153 */   // Label 31357: @2301153
     /* 2301153 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2301201), // Rule ID 52693 //
     /* 2301158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301161 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2301164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301200 */     // GIR_Coverage, 52693,
     /* 2301200 */     GIR_EraseRootFromParent_Done,
     /* 2301201 */   // Label 31358: @2301201
     /* 2301201 */   GIM_Reject,
     /* 2301202 */ // Label 31356: @2301202
     /* 2301202 */ GIM_Reject,
     /* 2301203 */ // Label 31305: @2301203
     /* 2301203 */ GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2301323),
     /* 2301208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2301214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301226 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2301274), // Rule ID 52708 //
     /* 2301231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301234 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2301237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301273 */     // GIR_Coverage, 52708,
     /* 2301273 */     GIR_EraseRootFromParent_Done,
     /* 2301274 */   // Label 31360: @2301274
     /* 2301274 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2301322), // Rule ID 52709 //
     /* 2301279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301282 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2301285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301321 */     // GIR_Coverage, 52709,
     /* 2301321 */     GIR_EraseRootFromParent_Done,
     /* 2301322 */   // Label 31361: @2301322
     /* 2301322 */   GIM_Reject,
     /* 2301323 */ // Label 31359: @2301323
     /* 2301323 */ GIM_Reject,
     /* 2301324 */ // Label 31306: @2301324
     /* 2301324 */ GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2301444),
     /* 2301329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2301335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301347 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2301395), // Rule ID 52724 //
     /* 2301352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2301355 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2301358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301394 */     // GIR_Coverage, 52724,
     /* 2301394 */     GIR_EraseRootFromParent_Done,
     /* 2301395 */   // Label 31363: @2301395
     /* 2301395 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2301443), // Rule ID 52725 //
     /* 2301400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2301403 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2301406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301442 */     // GIR_Coverage, 52725,
     /* 2301442 */     GIR_EraseRootFromParent_Done,
     /* 2301443 */   // Label 31364: @2301443
     /* 2301443 */   GIM_Reject,
     /* 2301444 */ // Label 31362: @2301444
     /* 2301444 */ GIM_Reject,
     /* 2301445 */ // Label 31307: @2301445
     /* 2301445 */ GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2301565),
     /* 2301450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2301453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2301456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301468 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2301516), // Rule ID 52680 //
     /* 2301473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301476 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2301479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301515 */     // GIR_Coverage, 52680,
     /* 2301515 */     GIR_EraseRootFromParent_Done,
     /* 2301516 */   // Label 31366: @2301516
     /* 2301516 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2301564), // Rule ID 52681 //
     /* 2301521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301524 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2301527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2301541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301563 */     // GIR_Coverage, 52681,
     /* 2301563 */     GIR_EraseRootFromParent_Done,
     /* 2301564 */   // Label 31367: @2301564
     /* 2301564 */   GIM_Reject,
     /* 2301565 */ // Label 31365: @2301565
     /* 2301565 */ GIM_Reject,
     /* 2301566 */ // Label 31308: @2301566
     /* 2301566 */ GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2301686),
     /* 2301571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2301574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2301577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301589 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2301637), // Rule ID 52696 //
     /* 2301594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301597 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301636 */     // GIR_Coverage, 52696,
     /* 2301636 */     GIR_EraseRootFromParent_Done,
     /* 2301637 */   // Label 31369: @2301637
     /* 2301637 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2301685), // Rule ID 52697 //
     /* 2301642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301645 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2301648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301684 */     // GIR_Coverage, 52697,
     /* 2301684 */     GIR_EraseRootFromParent_Done,
     /* 2301685 */   // Label 31370: @2301685
     /* 2301685 */   GIM_Reject,
     /* 2301686 */ // Label 31368: @2301686
     /* 2301686 */ GIM_Reject,
     /* 2301687 */ // Label 31309: @2301687
     /* 2301687 */ GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2301807),
     /* 2301692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2301695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2301698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301710 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2301758), // Rule ID 52712 //
     /* 2301715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301718 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301757 */     // GIR_Coverage, 52712,
     /* 2301757 */     GIR_EraseRootFromParent_Done,
     /* 2301758 */   // Label 31372: @2301758
     /* 2301758 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2301806), // Rule ID 52713 //
     /* 2301763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301766 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2301769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301805 */     // GIR_Coverage, 52713,
     /* 2301805 */     GIR_EraseRootFromParent_Done,
     /* 2301806 */   // Label 31373: @2301806
     /* 2301806 */   GIM_Reject,
     /* 2301807 */ // Label 31371: @2301807
     /* 2301807 */ GIM_Reject,
     /* 2301808 */ // Label 31310: @2301808
     /* 2301808 */ GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2301928),
     /* 2301813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2301816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2301819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301831 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2301879), // Rule ID 52684 //
     /* 2301836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301839 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2301842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301878 */     // GIR_Coverage, 52684,
     /* 2301878 */     GIR_EraseRootFromParent_Done,
     /* 2301879 */   // Label 31375: @2301879
     /* 2301879 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2301927), // Rule ID 52685 //
     /* 2301884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2301887 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2301890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2301904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301926 */     // GIR_Coverage, 52685,
     /* 2301926 */     GIR_EraseRootFromParent_Done,
     /* 2301927 */   // Label 31376: @2301927
     /* 2301927 */   GIM_Reject,
     /* 2301928 */ // Label 31374: @2301928
     /* 2301928 */ GIM_Reject,
     /* 2301929 */ // Label 31311: @2301929
     /* 2301929 */ GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2302049),
     /* 2301934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2301937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2301940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301952 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2302000), // Rule ID 52700 //
     /* 2301957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2301960 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2301963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2301977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2301998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301999 */     // GIR_Coverage, 52700,
     /* 2301999 */     GIR_EraseRootFromParent_Done,
     /* 2302000 */   // Label 31378: @2302000
     /* 2302000 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2302048), // Rule ID 52701 //
     /* 2302005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302008 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2302011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302047 */     // GIR_Coverage, 52701,
     /* 2302047 */     GIR_EraseRootFromParent_Done,
     /* 2302048 */   // Label 31379: @2302048
     /* 2302048 */   GIM_Reject,
     /* 2302049 */ // Label 31377: @2302049
     /* 2302049 */ GIM_Reject,
     /* 2302050 */ // Label 31312: @2302050
     /* 2302050 */ GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2302170),
     /* 2302055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2302058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2302061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302073 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2302121), // Rule ID 52688 //
     /* 2302078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2302081 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2302084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302120 */     // GIR_Coverage, 52688,
     /* 2302120 */     GIR_EraseRootFromParent_Done,
     /* 2302121 */   // Label 31381: @2302121
     /* 2302121 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2302169), // Rule ID 52689 //
     /* 2302126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2302129 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2302132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2302146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2302167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302168 */     // GIR_Coverage, 52689,
     /* 2302168 */     GIR_EraseRootFromParent_Done,
     /* 2302169 */   // Label 31382: @2302169
     /* 2302169 */   GIM_Reject,
     /* 2302170 */ // Label 31380: @2302170
     /* 2302170 */ GIM_Reject,
     /* 2302171 */ // Label 31313: @2302171
     /* 2302171 */ GIM_Reject,
     /* 2302172 */ // Label 57: @2302172
     /* 2302172 */ GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2302229),
     /* 2302177 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2302180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302198 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2302213), // Rule ID 64593 //
     /* 2302203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2302206 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2302211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302212 */     // GIR_Coverage, 64593,
     /* 2302212 */     GIR_Done,
     /* 2302213 */   // Label 31384: @2302213
     /* 2302213 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2302228), // Rule ID 64594 //
     /* 2302218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2302221 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2302226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302227 */     // GIR_Coverage, 64594,
     /* 2302227 */     GIR_Done,
     /* 2302228 */   // Label 31385: @2302228
     /* 2302228 */   GIM_Reject,
     /* 2302229 */ // Label 31383: @2302229
     /* 2302229 */ GIM_Reject,
     /* 2302230 */ // Label 58: @2302230
     /* 2302230 */ GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2302287),
     /* 2302235 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2302238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2302256 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2302271), // Rule ID 64595 //
     /* 2302261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2302264 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2302269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302270 */     // GIR_Coverage, 64595,
     /* 2302270 */     GIR_Done,
     /* 2302271 */   // Label 31387: @2302271
     /* 2302271 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2302286), // Rule ID 64596 //
     /* 2302276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2302279 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2302279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2302284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302285 */     // GIR_Coverage, 64596,
     /* 2302285 */     GIR_Done,
     /* 2302286 */   // Label 31388: @2302286
     /* 2302286 */   GIM_Reject,
     /* 2302287 */ // Label 31386: @2302287
     /* 2302287 */ GIM_Reject,
     /* 2302288 */ // Label 59: @2302288
     /* 2302288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31407*/ GIMT_Encode4(2304715),
     /* 2302299 */ /*GILLT_s16*//*Label 31389*/ GIMT_Encode4(2302419),
     /* 2302303 */ /*GILLT_s32*//*Label 31390*/ GIMT_Encode4(2302568),
     /* 2302307 */ /*GILLT_s64*//*Label 31391*/ GIMT_Encode4(2302717), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302319 */ /*GILLT_nxv1s16*//*Label 31392*/ GIMT_Encode4(2302900),
     /* 2302323 */ /*GILLT_nxv1s32*//*Label 31393*/ GIMT_Encode4(2303021),
     /* 2302327 */ /*GILLT_nxv1s64*//*Label 31394*/ GIMT_Encode4(2303142), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302339 */ /*GILLT_nxv2s16*//*Label 31395*/ GIMT_Encode4(2303263),
     /* 2302343 */ /*GILLT_nxv2s32*//*Label 31396*/ GIMT_Encode4(2303384),
     /* 2302347 */ /*GILLT_nxv2s64*//*Label 31397*/ GIMT_Encode4(2303505), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302359 */ /*GILLT_nxv4s16*//*Label 31398*/ GIMT_Encode4(2303626),
     /* 2302363 */ /*GILLT_nxv4s32*//*Label 31399*/ GIMT_Encode4(2303747),
     /* 2302367 */ /*GILLT_nxv4s64*//*Label 31400*/ GIMT_Encode4(2303868), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302379 */ /*GILLT_nxv8s16*//*Label 31401*/ GIMT_Encode4(2303989),
     /* 2302383 */ /*GILLT_nxv8s32*//*Label 31402*/ GIMT_Encode4(2304110),
     /* 2302387 */ /*GILLT_nxv8s64*//*Label 31403*/ GIMT_Encode4(2304231), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302399 */ /*GILLT_nxv16s16*//*Label 31404*/ GIMT_Encode4(2304352),
     /* 2302403 */ /*GILLT_nxv16s32*//*Label 31405*/ GIMT_Encode4(2304473), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2302415 */ /*GILLT_nxv32s16*//*Label 31406*/ GIMT_Encode4(2304594),
     /* 2302419 */ // Label 31389: @2302419
     /* 2302419 */ GIM_Try, /*On fail goto*//*Label 31408*/ GIMT_Encode4(2302567),
     /* 2302424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2302427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2302430 */   GIM_Try, /*On fail goto*//*Label 31409*/ GIMT_Encode4(2302464), // Rule ID 1958 //
     /* 2302435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2302438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302450 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2302450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2302453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302463 */     // GIR_Coverage, 1958,
     /* 2302463 */     GIR_EraseRootFromParent_Done,
     /* 2302464 */   // Label 31409: @2302464
     /* 2302464 */   GIM_Try, /*On fail goto*//*Label 31410*/ GIMT_Encode4(2302498), // Rule ID 1959 //
     /* 2302469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2302472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2302484 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2302484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2302487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302497 */     // GIR_Coverage, 1959,
     /* 2302497 */     GIR_EraseRootFromParent_Done,
     /* 2302498 */   // Label 31410: @2302498
     /* 2302498 */   GIM_Try, /*On fail goto*//*Label 31411*/ GIMT_Encode4(2302532), // Rule ID 1962 //
     /* 2302503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2302506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302518 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2302518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2302521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302531 */     // GIR_Coverage, 1962,
     /* 2302531 */     GIR_EraseRootFromParent_Done,
     /* 2302532 */   // Label 31411: @2302532
     /* 2302532 */   GIM_Try, /*On fail goto*//*Label 31412*/ GIMT_Encode4(2302566), // Rule ID 1963 //
     /* 2302537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2302540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2302552 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2302552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2302555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302565 */     // GIR_Coverage, 1963,
     /* 2302565 */     GIR_EraseRootFromParent_Done,
     /* 2302566 */   // Label 31412: @2302566
     /* 2302566 */   GIM_Reject,
     /* 2302567 */ // Label 31408: @2302567
     /* 2302567 */ GIM_Reject,
     /* 2302568 */ // Label 31390: @2302568
     /* 2302568 */ GIM_Try, /*On fail goto*//*Label 31413*/ GIMT_Encode4(2302716),
     /* 2302573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2302576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2302579 */   GIM_Try, /*On fail goto*//*Label 31414*/ GIMT_Encode4(2302613), // Rule ID 1249 //
     /* 2302584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2302587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302599 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2302599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2302602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302612 */     // GIR_Coverage, 1249,
     /* 2302612 */     GIR_EraseRootFromParent_Done,
     /* 2302613 */   // Label 31414: @2302613
     /* 2302613 */   GIM_Try, /*On fail goto*//*Label 31415*/ GIMT_Encode4(2302647), // Rule ID 1250 //
     /* 2302618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2302621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2302633 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2302633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2302636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302646 */     // GIR_Coverage, 1250,
     /* 2302646 */     GIR_EraseRootFromParent_Done,
     /* 2302647 */   // Label 31415: @2302647
     /* 2302647 */   GIM_Try, /*On fail goto*//*Label 31416*/ GIMT_Encode4(2302681), // Rule ID 1253 //
     /* 2302652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2302655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302667 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2302667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2302670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302680 */     // GIR_Coverage, 1253,
     /* 2302680 */     GIR_EraseRootFromParent_Done,
     /* 2302681 */   // Label 31416: @2302681
     /* 2302681 */   GIM_Try, /*On fail goto*//*Label 31417*/ GIMT_Encode4(2302715), // Rule ID 1254 //
     /* 2302686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2302689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2302701 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2302701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2302704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302714 */     // GIR_Coverage, 1254,
     /* 2302714 */     GIR_EraseRootFromParent_Done,
     /* 2302715 */   // Label 31417: @2302715
     /* 2302715 */   GIM_Reject,
     /* 2302716 */ // Label 31413: @2302716
     /* 2302716 */ GIM_Reject,
     /* 2302717 */ // Label 31391: @2302717
     /* 2302717 */ GIM_Try, /*On fail goto*//*Label 31418*/ GIMT_Encode4(2302899),
     /* 2302722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2302725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2302728 */   GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2302762), // Rule ID 1584 //
     /* 2302733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2302736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302748 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2302751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302761 */     // GIR_Coverage, 1584,
     /* 2302761 */     GIR_EraseRootFromParent_Done,
     /* 2302762 */   // Label 31419: @2302762
     /* 2302762 */   GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2302796), // Rule ID 1585 //
     /* 2302767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2302770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2302782 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2302782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2302785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302795 */     // GIR_Coverage, 1585,
     /* 2302795 */     GIR_EraseRootFromParent_Done,
     /* 2302796 */   // Label 31420: @2302796
     /* 2302796 */   GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2302830), // Rule ID 1588 //
     /* 2302801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2302804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302816 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2302819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302829 */     // GIR_Coverage, 1588,
     /* 2302829 */     GIR_EraseRootFromParent_Done,
     /* 2302830 */   // Label 31421: @2302830
     /* 2302830 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2302864), // Rule ID 1589 //
     /* 2302835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2302838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2302850 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2302850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2302853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302863 */     // GIR_Coverage, 1589,
     /* 2302863 */     GIR_EraseRootFromParent_Done,
     /* 2302864 */   // Label 31422: @2302864
     /* 2302864 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2302898), // Rule ID 1591 //
     /* 2302869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2302872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2302884 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2302884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2302887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302897 */     // GIR_Coverage, 1591,
     /* 2302897 */     GIR_EraseRootFromParent_Done,
     /* 2302898 */   // Label 31423: @2302898
     /* 2302898 */   GIM_Reject,
     /* 2302899 */ // Label 31418: @2302899
     /* 2302899 */ GIM_Reject,
     /* 2302900 */ // Label 31392: @2302900
     /* 2302900 */ GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2303020),
     /* 2302905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2302908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2302911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302923 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2302971), // Rule ID 45764 //
     /* 2302928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302931 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2302948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302970 */     // GIR_Coverage, 45764,
     /* 2302970 */     GIR_EraseRootFromParent_Done,
     /* 2302971 */   // Label 31425: @2302971
     /* 2302971 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2303019), // Rule ID 45765 //
     /* 2302976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302979 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2302982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2302996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303018 */     // GIR_Coverage, 45765,
     /* 2303018 */     GIR_EraseRootFromParent_Done,
     /* 2303019 */   // Label 31426: @2303019
     /* 2303019 */   GIM_Reject,
     /* 2303020 */ // Label 31424: @2303020
     /* 2303020 */ GIM_Reject,
     /* 2303021 */ // Label 31393: @2303021
     /* 2303021 */ GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2303141),
     /* 2303026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2303029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2303032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303044 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2303092), // Rule ID 53304 //
     /* 2303049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303052 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2303055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2303069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303091 */     // GIR_Coverage, 53304,
     /* 2303091 */     GIR_EraseRootFromParent_Done,
     /* 2303092 */   // Label 31428: @2303092
     /* 2303092 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2303140), // Rule ID 53305 //
     /* 2303097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303100 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2303103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2303117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303139 */     // GIR_Coverage, 53305,
     /* 2303139 */     GIR_EraseRootFromParent_Done,
     /* 2303140 */   // Label 31429: @2303140
     /* 2303140 */   GIM_Reject,
     /* 2303141 */ // Label 31427: @2303141
     /* 2303141 */ GIM_Reject,
     /* 2303142 */ // Label 31394: @2303142
     /* 2303142 */ GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2303262),
     /* 2303147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2303150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2303153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303165 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2303213), // Rule ID 53340 //
     /* 2303170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303173 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2303176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2303190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303212 */     // GIR_Coverage, 53340,
     /* 2303212 */     GIR_EraseRootFromParent_Done,
     /* 2303213 */   // Label 31431: @2303213
     /* 2303213 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2303261), // Rule ID 53341 //
     /* 2303218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303221 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2303224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2303238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303260 */     // GIR_Coverage, 53341,
     /* 2303260 */     GIR_EraseRootFromParent_Done,
     /* 2303261 */   // Label 31432: @2303261
     /* 2303261 */   GIM_Reject,
     /* 2303262 */ // Label 31430: @2303262
     /* 2303262 */ GIM_Reject,
     /* 2303263 */ // Label 31395: @2303263
     /* 2303263 */ GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2303383),
     /* 2303268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2303271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2303274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303286 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2303334), // Rule ID 53292 //
     /* 2303291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303294 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2303297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2303311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303333 */     // GIR_Coverage, 53292,
     /* 2303333 */     GIR_EraseRootFromParent_Done,
     /* 2303334 */   // Label 31434: @2303334
     /* 2303334 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2303382), // Rule ID 53293 //
     /* 2303339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303342 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2303345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2303359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303381 */     // GIR_Coverage, 53293,
     /* 2303381 */     GIR_EraseRootFromParent_Done,
     /* 2303382 */   // Label 31435: @2303382
     /* 2303382 */   GIM_Reject,
     /* 2303383 */ // Label 31433: @2303383
     /* 2303383 */ GIM_Reject,
     /* 2303384 */ // Label 31396: @2303384
     /* 2303384 */ GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2303504),
     /* 2303389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2303392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2303395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303407 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2303455), // Rule ID 53328 //
     /* 2303412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303415 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2303418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2303432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303454 */     // GIR_Coverage, 53328,
     /* 2303454 */     GIR_EraseRootFromParent_Done,
     /* 2303455 */   // Label 31437: @2303455
     /* 2303455 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2303503), // Rule ID 53329 //
     /* 2303460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303463 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2303466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2303480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303502 */     // GIR_Coverage, 53329,
     /* 2303502 */     GIR_EraseRootFromParent_Done,
     /* 2303503 */   // Label 31438: @2303503
     /* 2303503 */   GIM_Reject,
     /* 2303504 */ // Label 31436: @2303504
     /* 2303504 */ GIM_Reject,
     /* 2303505 */ // Label 31397: @2303505
     /* 2303505 */ GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2303625),
     /* 2303510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2303513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2303516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303528 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2303576), // Rule ID 53424 //
     /* 2303533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303536 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2303539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2303553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303575 */     // GIR_Coverage, 53424,
     /* 2303575 */     GIR_EraseRootFromParent_Done,
     /* 2303576 */   // Label 31440: @2303576
     /* 2303576 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2303624), // Rule ID 53425 //
     /* 2303581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303584 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2303587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2303601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303623 */     // GIR_Coverage, 53425,
     /* 2303623 */     GIR_EraseRootFromParent_Done,
     /* 2303624 */   // Label 31441: @2303624
     /* 2303624 */   GIM_Reject,
     /* 2303625 */ // Label 31439: @2303625
     /* 2303625 */ GIM_Reject,
     /* 2303626 */ // Label 31398: @2303626
     /* 2303626 */ GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2303746),
     /* 2303631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2303634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2303637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2303649 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2303697), // Rule ID 53316 //
     /* 2303654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303657 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2303660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2303674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303696 */     // GIR_Coverage, 53316,
     /* 2303696 */     GIR_EraseRootFromParent_Done,
     /* 2303697 */   // Label 31443: @2303697
     /* 2303697 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2303745), // Rule ID 53317 //
     /* 2303702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303705 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2303708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2303722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303744 */     // GIR_Coverage, 53317,
     /* 2303744 */     GIR_EraseRootFromParent_Done,
     /* 2303745 */   // Label 31444: @2303745
     /* 2303745 */   GIM_Reject,
     /* 2303746 */ // Label 31442: @2303746
     /* 2303746 */ GIM_Reject,
     /* 2303747 */ // Label 31399: @2303747
     /* 2303747 */ GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2303867),
     /* 2303752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2303758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303770 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2303818), // Rule ID 53388 //
     /* 2303775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303778 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2303781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2303795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303817 */     // GIR_Coverage, 53388,
     /* 2303817 */     GIR_EraseRootFromParent_Done,
     /* 2303818 */   // Label 31446: @2303818
     /* 2303818 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2303866), // Rule ID 53389 //
     /* 2303823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303826 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2303829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2303843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303865 */     // GIR_Coverage, 53389,
     /* 2303865 */     GIR_EraseRootFromParent_Done,
     /* 2303866 */   // Label 31447: @2303866
     /* 2303866 */   GIM_Reject,
     /* 2303867 */ // Label 31445: @2303867
     /* 2303867 */ GIM_Reject,
     /* 2303868 */ // Label 31400: @2303868
     /* 2303868 */ GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2303988),
     /* 2303873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2303879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303891 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2303939), // Rule ID 53436 //
     /* 2303896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303899 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2303916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303938 */     // GIR_Coverage, 53436,
     /* 2303938 */     GIR_EraseRootFromParent_Done,
     /* 2303939 */   // Label 31449: @2303939
     /* 2303939 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2303987), // Rule ID 53437 //
     /* 2303944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303947 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2303950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2303964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303986 */     // GIR_Coverage, 53437,
     /* 2303986 */     GIR_EraseRootFromParent_Done,
     /* 2303987 */   // Label 31450: @2303987
     /* 2303987 */   GIM_Reject,
     /* 2303988 */ // Label 31448: @2303988
     /* 2303988 */ GIM_Reject,
     /* 2303989 */ // Label 31401: @2303989
     /* 2303989 */ GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2304109),
     /* 2303994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2303997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2304000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304012 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2304060), // Rule ID 53352 //
     /* 2304017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304020 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2304023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2304037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304059 */     // GIR_Coverage, 53352,
     /* 2304059 */     GIR_EraseRootFromParent_Done,
     /* 2304060 */   // Label 31452: @2304060
     /* 2304060 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2304108), // Rule ID 53353 //
     /* 2304065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304068 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2304071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2304085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304107 */     // GIR_Coverage, 53353,
     /* 2304107 */     GIR_EraseRootFromParent_Done,
     /* 2304108 */   // Label 31453: @2304108
     /* 2304108 */   GIM_Reject,
     /* 2304109 */ // Label 31451: @2304109
     /* 2304109 */ GIM_Reject,
     /* 2304110 */ // Label 31402: @2304110
     /* 2304110 */ GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2304230),
     /* 2304115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2304118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2304121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304133 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2304181), // Rule ID 53400 //
     /* 2304138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304141 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2304144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2304158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304180 */     // GIR_Coverage, 53400,
     /* 2304180 */     GIR_EraseRootFromParent_Done,
     /* 2304181 */   // Label 31455: @2304181
     /* 2304181 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2304229), // Rule ID 53401 //
     /* 2304186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304189 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2304192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2304206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304228 */     // GIR_Coverage, 53401,
     /* 2304228 */     GIR_EraseRootFromParent_Done,
     /* 2304229 */   // Label 31456: @2304229
     /* 2304229 */   GIM_Reject,
     /* 2304230 */ // Label 31454: @2304230
     /* 2304230 */ GIM_Reject,
     /* 2304231 */ // Label 31403: @2304231
     /* 2304231 */ GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2304351),
     /* 2304236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2304239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2304242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304254 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2304302), // Rule ID 53448 //
     /* 2304259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304262 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2304265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2304279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304301 */     // GIR_Coverage, 53448,
     /* 2304301 */     GIR_EraseRootFromParent_Done,
     /* 2304302 */   // Label 31458: @2304302
     /* 2304302 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2304350), // Rule ID 53449 //
     /* 2304307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304310 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2304313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2304327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304349 */     // GIR_Coverage, 53449,
     /* 2304349 */     GIR_EraseRootFromParent_Done,
     /* 2304350 */   // Label 31459: @2304350
     /* 2304350 */   GIM_Reject,
     /* 2304351 */ // Label 31457: @2304351
     /* 2304351 */ GIM_Reject,
     /* 2304352 */ // Label 31404: @2304352
     /* 2304352 */ GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2304472),
     /* 2304357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2304360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2304363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304375 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2304423), // Rule ID 53364 //
     /* 2304380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304383 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2304386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2304400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304422 */     // GIR_Coverage, 53364,
     /* 2304422 */     GIR_EraseRootFromParent_Done,
     /* 2304423 */   // Label 31461: @2304423
     /* 2304423 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2304471), // Rule ID 53365 //
     /* 2304428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304431 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2304434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2304448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304470 */     // GIR_Coverage, 53365,
     /* 2304470 */     GIR_EraseRootFromParent_Done,
     /* 2304471 */   // Label 31462: @2304471
     /* 2304471 */   GIM_Reject,
     /* 2304472 */ // Label 31460: @2304472
     /* 2304472 */ GIM_Reject,
     /* 2304473 */ // Label 31405: @2304473
     /* 2304473 */ GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2304593),
     /* 2304478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2304481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2304484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304496 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2304544), // Rule ID 53412 //
     /* 2304501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2304504 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2304507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2304521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304543 */     // GIR_Coverage, 53412,
     /* 2304543 */     GIR_EraseRootFromParent_Done,
     /* 2304544 */   // Label 31464: @2304544
     /* 2304544 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2304592), // Rule ID 53413 //
     /* 2304549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2304552 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2304555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2304569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2304587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304591 */     // GIR_Coverage, 53413,
     /* 2304591 */     GIR_EraseRootFromParent_Done,
     /* 2304592 */   // Label 31465: @2304592
     /* 2304592 */   GIM_Reject,
     /* 2304593 */ // Label 31463: @2304593
     /* 2304593 */ GIM_Reject,
     /* 2304594 */ // Label 31406: @2304594
     /* 2304594 */ GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2304714),
     /* 2304599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2304605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304617 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2304665), // Rule ID 53376 //
     /* 2304622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304625 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2304625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2304628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2304642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304664 */     // GIR_Coverage, 53376,
     /* 2304664 */     GIR_EraseRootFromParent_Done,
     /* 2304665 */   // Label 31467: @2304665
     /* 2304665 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2304713), // Rule ID 53377 //
     /* 2304670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304673 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2304673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2304676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2304680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2304685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2304687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2304690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2304695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2304711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304712 */     // GIR_Coverage, 53377,
     /* 2304712 */     GIR_EraseRootFromParent_Done,
     /* 2304713 */   // Label 31468: @2304713
     /* 2304713 */   GIM_Reject,
     /* 2304714 */ // Label 31466: @2304714
     /* 2304714 */ GIM_Reject,
     /* 2304715 */ // Label 31407: @2304715
     /* 2304715 */ GIM_Reject,
     /* 2304716 */ // Label 60: @2304716
     /* 2304716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31487*/ GIMT_Encode4(2307143),
     /* 2304727 */ /*GILLT_s16*//*Label 31469*/ GIMT_Encode4(2304847),
     /* 2304731 */ /*GILLT_s32*//*Label 31470*/ GIMT_Encode4(2304996),
     /* 2304735 */ /*GILLT_s64*//*Label 31471*/ GIMT_Encode4(2305145), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304747 */ /*GILLT_nxv1s16*//*Label 31472*/ GIMT_Encode4(2305328),
     /* 2304751 */ /*GILLT_nxv1s32*//*Label 31473*/ GIMT_Encode4(2305449),
     /* 2304755 */ /*GILLT_nxv1s64*//*Label 31474*/ GIMT_Encode4(2305570), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304767 */ /*GILLT_nxv2s16*//*Label 31475*/ GIMT_Encode4(2305691),
     /* 2304771 */ /*GILLT_nxv2s32*//*Label 31476*/ GIMT_Encode4(2305812),
     /* 2304775 */ /*GILLT_nxv2s64*//*Label 31477*/ GIMT_Encode4(2305933), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304787 */ /*GILLT_nxv4s16*//*Label 31478*/ GIMT_Encode4(2306054),
     /* 2304791 */ /*GILLT_nxv4s32*//*Label 31479*/ GIMT_Encode4(2306175),
     /* 2304795 */ /*GILLT_nxv4s64*//*Label 31480*/ GIMT_Encode4(2306296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304807 */ /*GILLT_nxv8s16*//*Label 31481*/ GIMT_Encode4(2306417),
     /* 2304811 */ /*GILLT_nxv8s32*//*Label 31482*/ GIMT_Encode4(2306538),
     /* 2304815 */ /*GILLT_nxv8s64*//*Label 31483*/ GIMT_Encode4(2306659), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304827 */ /*GILLT_nxv16s16*//*Label 31484*/ GIMT_Encode4(2306780),
     /* 2304831 */ /*GILLT_nxv16s32*//*Label 31485*/ GIMT_Encode4(2306901), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304843 */ /*GILLT_nxv32s16*//*Label 31486*/ GIMT_Encode4(2307022),
     /* 2304847 */ // Label 31469: @2304847
     /* 2304847 */ GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2304995),
     /* 2304852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2304858 */   GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2304892), // Rule ID 1966 //
     /* 2304863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304878 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2304878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2304881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304891 */     // GIR_Coverage, 1966,
     /* 2304891 */     GIR_EraseRootFromParent_Done,
     /* 2304892 */   // Label 31489: @2304892
     /* 2304892 */   GIM_Try, /*On fail goto*//*Label 31490*/ GIMT_Encode4(2304926), // Rule ID 1967 //
     /* 2304897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304912 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2304912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2304915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304925 */     // GIR_Coverage, 1967,
     /* 2304925 */     GIR_EraseRootFromParent_Done,
     /* 2304926 */   // Label 31490: @2304926
     /* 2304926 */   GIM_Try, /*On fail goto*//*Label 31491*/ GIMT_Encode4(2304960), // Rule ID 1970 //
     /* 2304931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304946 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2304946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2304949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304959 */     // GIR_Coverage, 1970,
     /* 2304959 */     GIR_EraseRootFromParent_Done,
     /* 2304960 */   // Label 31491: @2304960
     /* 2304960 */   GIM_Try, /*On fail goto*//*Label 31492*/ GIMT_Encode4(2304994), // Rule ID 1971 //
     /* 2304965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304980 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2304980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2304983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304993 */     // GIR_Coverage, 1971,
     /* 2304993 */     GIR_EraseRootFromParent_Done,
     /* 2304994 */   // Label 31492: @2304994
     /* 2304994 */   GIM_Reject,
     /* 2304995 */ // Label 31488: @2304995
     /* 2304995 */ GIM_Reject,
     /* 2304996 */ // Label 31470: @2304996
     /* 2304996 */ GIM_Try, /*On fail goto*//*Label 31493*/ GIMT_Encode4(2305144),
     /* 2305001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2305007 */   GIM_Try, /*On fail goto*//*Label 31494*/ GIMT_Encode4(2305041), // Rule ID 1257 //
     /* 2305012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305027 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2305030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305040 */     // GIR_Coverage, 1257,
     /* 2305040 */     GIR_EraseRootFromParent_Done,
     /* 2305041 */   // Label 31494: @2305041
     /* 2305041 */   GIM_Try, /*On fail goto*//*Label 31495*/ GIMT_Encode4(2305075), // Rule ID 1258 //
     /* 2305046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305061 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2305064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305074 */     // GIR_Coverage, 1258,
     /* 2305074 */     GIR_EraseRootFromParent_Done,
     /* 2305075 */   // Label 31495: @2305075
     /* 2305075 */   GIM_Try, /*On fail goto*//*Label 31496*/ GIMT_Encode4(2305109), // Rule ID 1261 //
     /* 2305080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305095 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2305098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305108 */     // GIR_Coverage, 1261,
     /* 2305108 */     GIR_EraseRootFromParent_Done,
     /* 2305109 */   // Label 31496: @2305109
     /* 2305109 */   GIM_Try, /*On fail goto*//*Label 31497*/ GIMT_Encode4(2305143), // Rule ID 1262 //
     /* 2305114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305129 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2305132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305142 */     // GIR_Coverage, 1262,
     /* 2305142 */     GIR_EraseRootFromParent_Done,
     /* 2305143 */   // Label 31497: @2305143
     /* 2305143 */   GIM_Reject,
     /* 2305144 */ // Label 31493: @2305144
     /* 2305144 */ GIM_Reject,
     /* 2305145 */ // Label 31471: @2305145
     /* 2305145 */ GIM_Try, /*On fail goto*//*Label 31498*/ GIMT_Encode4(2305327),
     /* 2305150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2305153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2305156 */   GIM_Try, /*On fail goto*//*Label 31499*/ GIMT_Encode4(2305190), // Rule ID 1594 //
     /* 2305161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2305164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305176 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2305179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305189 */     // GIR_Coverage, 1594,
     /* 2305189 */     GIR_EraseRootFromParent_Done,
     /* 2305190 */   // Label 31499: @2305190
     /* 2305190 */   GIM_Try, /*On fail goto*//*Label 31500*/ GIMT_Encode4(2305224), // Rule ID 1595 //
     /* 2305195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2305198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305210 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2305213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305223 */     // GIR_Coverage, 1595,
     /* 2305223 */     GIR_EraseRootFromParent_Done,
     /* 2305224 */   // Label 31500: @2305224
     /* 2305224 */   GIM_Try, /*On fail goto*//*Label 31501*/ GIMT_Encode4(2305258), // Rule ID 1598 //
     /* 2305229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2305232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305244 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2305247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305257 */     // GIR_Coverage, 1598,
     /* 2305257 */     GIR_EraseRootFromParent_Done,
     /* 2305258 */   // Label 31501: @2305258
     /* 2305258 */   GIM_Try, /*On fail goto*//*Label 31502*/ GIMT_Encode4(2305292), // Rule ID 1599 //
     /* 2305263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2305266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305278 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2305281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305291 */     // GIR_Coverage, 1599,
     /* 2305291 */     GIR_EraseRootFromParent_Done,
     /* 2305292 */   // Label 31502: @2305292
     /* 2305292 */   GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2305326), // Rule ID 1601 //
     /* 2305297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2305300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305312 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2305315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305325 */     // GIR_Coverage, 1601,
     /* 2305325 */     GIR_EraseRootFromParent_Done,
     /* 2305326 */   // Label 31503: @2305326
     /* 2305326 */   GIM_Reject,
     /* 2305327 */ // Label 31498: @2305327
     /* 2305327 */ GIM_Reject,
     /* 2305328 */ // Label 31472: @2305328
     /* 2305328 */ GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2305448),
     /* 2305333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2305336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2305339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305351 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2305399), // Rule ID 53460 //
     /* 2305356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305359 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2305376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305398 */     // GIR_Coverage, 53460,
     /* 2305398 */     GIR_EraseRootFromParent_Done,
     /* 2305399 */   // Label 31505: @2305399
     /* 2305399 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2305447), // Rule ID 53461 //
     /* 2305404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305407 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2305424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305446 */     // GIR_Coverage, 53461,
     /* 2305446 */     GIR_EraseRootFromParent_Done,
     /* 2305447 */   // Label 31506: @2305447
     /* 2305447 */   GIM_Reject,
     /* 2305448 */ // Label 31504: @2305448
     /* 2305448 */ GIM_Reject,
     /* 2305449 */ // Label 31473: @2305449
     /* 2305449 */ GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2305569),
     /* 2305454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2305457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2305460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305472 */   GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2305520), // Rule ID 53484 //
     /* 2305477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305480 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2305497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305519 */     // GIR_Coverage, 53484,
     /* 2305519 */     GIR_EraseRootFromParent_Done,
     /* 2305520 */   // Label 31508: @2305520
     /* 2305520 */   GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2305568), // Rule ID 53485 //
     /* 2305525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305528 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2305545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305567 */     // GIR_Coverage, 53485,
     /* 2305567 */     GIR_EraseRootFromParent_Done,
     /* 2305568 */   // Label 31509: @2305568
     /* 2305568 */   GIM_Reject,
     /* 2305569 */ // Label 31507: @2305569
     /* 2305569 */ GIM_Reject,
     /* 2305570 */ // Label 31474: @2305570
     /* 2305570 */ GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2305690),
     /* 2305575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2305578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2305581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305593 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2305641), // Rule ID 53520 //
     /* 2305598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305601 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2305618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305640 */     // GIR_Coverage, 53520,
     /* 2305640 */     GIR_EraseRootFromParent_Done,
     /* 2305641 */   // Label 31511: @2305641
     /* 2305641 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2305689), // Rule ID 53521 //
     /* 2305646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2305649 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2305666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305688 */     // GIR_Coverage, 53521,
     /* 2305688 */     GIR_EraseRootFromParent_Done,
     /* 2305689 */   // Label 31512: @2305689
     /* 2305689 */   GIM_Reject,
     /* 2305690 */ // Label 31510: @2305690
     /* 2305690 */ GIM_Reject,
     /* 2305691 */ // Label 31475: @2305691
     /* 2305691 */ GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2305811),
     /* 2305696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2305699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2305702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305714 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2305762), // Rule ID 53472 //
     /* 2305719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305722 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2305739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305761 */     // GIR_Coverage, 53472,
     /* 2305761 */     GIR_EraseRootFromParent_Done,
     /* 2305762 */   // Label 31514: @2305762
     /* 2305762 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2305810), // Rule ID 53473 //
     /* 2305767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305770 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2305787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305809 */     // GIR_Coverage, 53473,
     /* 2305809 */     GIR_EraseRootFromParent_Done,
     /* 2305810 */   // Label 31515: @2305810
     /* 2305810 */   GIM_Reject,
     /* 2305811 */ // Label 31513: @2305811
     /* 2305811 */ GIM_Reject,
     /* 2305812 */ // Label 31476: @2305812
     /* 2305812 */ GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2305932),
     /* 2305817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2305820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2305823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305835 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2305883), // Rule ID 53508 //
     /* 2305840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305843 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2305860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305882 */     // GIR_Coverage, 53508,
     /* 2305882 */     GIR_EraseRootFromParent_Done,
     /* 2305883 */   // Label 31517: @2305883
     /* 2305883 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2305931), // Rule ID 53509 //
     /* 2305888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305891 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2305908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305930 */     // GIR_Coverage, 53509,
     /* 2305930 */     GIR_EraseRootFromParent_Done,
     /* 2305931 */   // Label 31518: @2305931
     /* 2305931 */   GIM_Reject,
     /* 2305932 */ // Label 31516: @2305932
     /* 2305932 */ GIM_Reject,
     /* 2305933 */ // Label 31477: @2305933
     /* 2305933 */ GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2306053),
     /* 2305938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2305941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2305944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305956 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2306004), // Rule ID 53604 //
     /* 2305961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305964 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2305967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2305981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306003 */     // GIR_Coverage, 53604,
     /* 2306003 */     GIR_EraseRootFromParent_Done,
     /* 2306004 */   // Label 31520: @2306004
     /* 2306004 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2306052), // Rule ID 53605 //
     /* 2306009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306012 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2306015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2306029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306051 */     // GIR_Coverage, 53605,
     /* 2306051 */     GIR_EraseRootFromParent_Done,
     /* 2306052 */   // Label 31521: @2306052
     /* 2306052 */   GIM_Reject,
     /* 2306053 */ // Label 31519: @2306053
     /* 2306053 */ GIM_Reject,
     /* 2306054 */ // Label 31478: @2306054
     /* 2306054 */ GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2306174),
     /* 2306059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2306062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2306065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306077 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2306125), // Rule ID 53496 //
     /* 2306082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306085 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2306102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306124 */     // GIR_Coverage, 53496,
     /* 2306124 */     GIR_EraseRootFromParent_Done,
     /* 2306125 */   // Label 31523: @2306125
     /* 2306125 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2306173), // Rule ID 53497 //
     /* 2306130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306133 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2306150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306172 */     // GIR_Coverage, 53497,
     /* 2306172 */     GIR_EraseRootFromParent_Done,
     /* 2306173 */   // Label 31524: @2306173
     /* 2306173 */   GIM_Reject,
     /* 2306174 */ // Label 31522: @2306174
     /* 2306174 */ GIM_Reject,
     /* 2306175 */ // Label 31479: @2306175
     /* 2306175 */ GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2306295),
     /* 2306180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2306183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2306186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306198 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2306246), // Rule ID 53568 //
     /* 2306203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306206 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2306223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306245 */     // GIR_Coverage, 53568,
     /* 2306245 */     GIR_EraseRootFromParent_Done,
     /* 2306246 */   // Label 31526: @2306246
     /* 2306246 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2306294), // Rule ID 53569 //
     /* 2306251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306254 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2306271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306293 */     // GIR_Coverage, 53569,
     /* 2306293 */     GIR_EraseRootFromParent_Done,
     /* 2306294 */   // Label 31527: @2306294
     /* 2306294 */   GIM_Reject,
     /* 2306295 */ // Label 31525: @2306295
     /* 2306295 */ GIM_Reject,
     /* 2306296 */ // Label 31480: @2306296
     /* 2306296 */ GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2306416),
     /* 2306301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2306304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2306307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306319 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2306367), // Rule ID 53616 //
     /* 2306324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306327 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2306344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306366 */     // GIR_Coverage, 53616,
     /* 2306366 */     GIR_EraseRootFromParent_Done,
     /* 2306367 */   // Label 31529: @2306367
     /* 2306367 */   GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2306415), // Rule ID 53617 //
     /* 2306372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306375 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2306392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306414 */     // GIR_Coverage, 53617,
     /* 2306414 */     GIR_EraseRootFromParent_Done,
     /* 2306415 */   // Label 31530: @2306415
     /* 2306415 */   GIM_Reject,
     /* 2306416 */ // Label 31528: @2306416
     /* 2306416 */ GIM_Reject,
     /* 2306417 */ // Label 31481: @2306417
     /* 2306417 */ GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2306537),
     /* 2306422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2306425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2306428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306440 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2306488), // Rule ID 53532 //
     /* 2306445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306448 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2306465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306487 */     // GIR_Coverage, 53532,
     /* 2306487 */     GIR_EraseRootFromParent_Done,
     /* 2306488 */   // Label 31532: @2306488
     /* 2306488 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2306536), // Rule ID 53533 //
     /* 2306493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306496 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2306513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306535 */     // GIR_Coverage, 53533,
     /* 2306535 */     GIR_EraseRootFromParent_Done,
     /* 2306536 */   // Label 31533: @2306536
     /* 2306536 */   GIM_Reject,
     /* 2306537 */ // Label 31531: @2306537
     /* 2306537 */ GIM_Reject,
     /* 2306538 */ // Label 31482: @2306538
     /* 2306538 */ GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2306658),
     /* 2306543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2306546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2306549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306561 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2306609), // Rule ID 53580 //
     /* 2306566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306569 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2306586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306608 */     // GIR_Coverage, 53580,
     /* 2306608 */     GIR_EraseRootFromParent_Done,
     /* 2306609 */   // Label 31535: @2306609
     /* 2306609 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2306657), // Rule ID 53581 //
     /* 2306614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306617 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2306634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306656 */     // GIR_Coverage, 53581,
     /* 2306656 */     GIR_EraseRootFromParent_Done,
     /* 2306657 */   // Label 31536: @2306657
     /* 2306657 */   GIM_Reject,
     /* 2306658 */ // Label 31534: @2306658
     /* 2306658 */ GIM_Reject,
     /* 2306659 */ // Label 31483: @2306659
     /* 2306659 */ GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2306779),
     /* 2306664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2306670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306682 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2306730), // Rule ID 53628 //
     /* 2306687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306690 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2306707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306729 */     // GIR_Coverage, 53628,
     /* 2306729 */     GIR_EraseRootFromParent_Done,
     /* 2306730 */   // Label 31538: @2306730
     /* 2306730 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2306778), // Rule ID 53629 //
     /* 2306735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306738 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2306755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306777 */     // GIR_Coverage, 53629,
     /* 2306777 */     GIR_EraseRootFromParent_Done,
     /* 2306778 */   // Label 31539: @2306778
     /* 2306778 */   GIM_Reject,
     /* 2306779 */ // Label 31537: @2306779
     /* 2306779 */ GIM_Reject,
     /* 2306780 */ // Label 31484: @2306780
     /* 2306780 */ GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2306900),
     /* 2306785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2306791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306803 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2306851), // Rule ID 53544 //
     /* 2306808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306811 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2306828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306850 */     // GIR_Coverage, 53544,
     /* 2306850 */     GIR_EraseRootFromParent_Done,
     /* 2306851 */   // Label 31541: @2306851
     /* 2306851 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2306899), // Rule ID 53545 //
     /* 2306856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306859 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2306876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306898 */     // GIR_Coverage, 53545,
     /* 2306898 */     GIR_EraseRootFromParent_Done,
     /* 2306899 */   // Label 31542: @2306899
     /* 2306899 */   GIM_Reject,
     /* 2306900 */ // Label 31540: @2306900
     /* 2306900 */ GIM_Reject,
     /* 2306901 */ // Label 31485: @2306901
     /* 2306901 */ GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2307021),
     /* 2306906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2306909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2306912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306924 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2306972), // Rule ID 53592 //
     /* 2306929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306932 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2306935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2306949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306971 */     // GIR_Coverage, 53592,
     /* 2306971 */     GIR_EraseRootFromParent_Done,
     /* 2306972 */   // Label 31544: @2306972
     /* 2306972 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2307020), // Rule ID 53593 //
     /* 2306977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306980 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2306983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2306997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307019 */     // GIR_Coverage, 53593,
     /* 2307019 */     GIR_EraseRootFromParent_Done,
     /* 2307020 */   // Label 31545: @2307020
     /* 2307020 */   GIM_Reject,
     /* 2307021 */ // Label 31543: @2307021
     /* 2307021 */ GIM_Reject,
     /* 2307022 */ // Label 31486: @2307022
     /* 2307022 */ GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2307142),
     /* 2307027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2307030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2307033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307045 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2307093), // Rule ID 53556 //
     /* 2307050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307053 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2307070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307092 */     // GIR_Coverage, 53556,
     /* 2307092 */     GIR_EraseRootFromParent_Done,
     /* 2307093 */   // Label 31547: @2307093
     /* 2307093 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2307141), // Rule ID 53557 //
     /* 2307098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307101 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2307118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307140 */     // GIR_Coverage, 53557,
     /* 2307140 */     GIR_EraseRootFromParent_Done,
     /* 2307141 */   // Label 31548: @2307141
     /* 2307141 */   GIM_Reject,
     /* 2307142 */ // Label 31546: @2307142
     /* 2307142 */ GIM_Reject,
     /* 2307143 */ // Label 31487: @2307143
     /* 2307143 */ GIM_Reject,
     /* 2307144 */ // Label 61: @2307144
     /* 2307144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31567*/ GIMT_Encode4(2309571),
     /* 2307155 */ /*GILLT_s16*//*Label 31549*/ GIMT_Encode4(2307275),
     /* 2307159 */ /*GILLT_s32*//*Label 31550*/ GIMT_Encode4(2307424),
     /* 2307163 */ /*GILLT_s64*//*Label 31551*/ GIMT_Encode4(2307573), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307175 */ /*GILLT_nxv1s16*//*Label 31552*/ GIMT_Encode4(2307756),
     /* 2307179 */ /*GILLT_nxv1s32*//*Label 31553*/ GIMT_Encode4(2307877),
     /* 2307183 */ /*GILLT_nxv1s64*//*Label 31554*/ GIMT_Encode4(2307998), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307195 */ /*GILLT_nxv2s16*//*Label 31555*/ GIMT_Encode4(2308119),
     /* 2307199 */ /*GILLT_nxv2s32*//*Label 31556*/ GIMT_Encode4(2308240),
     /* 2307203 */ /*GILLT_nxv2s64*//*Label 31557*/ GIMT_Encode4(2308361), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307215 */ /*GILLT_nxv4s16*//*Label 31558*/ GIMT_Encode4(2308482),
     /* 2307219 */ /*GILLT_nxv4s32*//*Label 31559*/ GIMT_Encode4(2308603),
     /* 2307223 */ /*GILLT_nxv4s64*//*Label 31560*/ GIMT_Encode4(2308724), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307235 */ /*GILLT_nxv8s16*//*Label 31561*/ GIMT_Encode4(2308845),
     /* 2307239 */ /*GILLT_nxv8s32*//*Label 31562*/ GIMT_Encode4(2308966),
     /* 2307243 */ /*GILLT_nxv8s64*//*Label 31563*/ GIMT_Encode4(2309087), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307255 */ /*GILLT_nxv16s16*//*Label 31564*/ GIMT_Encode4(2309208),
     /* 2307259 */ /*GILLT_nxv16s32*//*Label 31565*/ GIMT_Encode4(2309329), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307271 */ /*GILLT_nxv32s16*//*Label 31566*/ GIMT_Encode4(2309450),
     /* 2307275 */ // Label 31549: @2307275
     /* 2307275 */ GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2307423),
     /* 2307280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2307286 */   GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2307320), // Rule ID 1974 //
     /* 2307291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2307294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307306 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2307306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2307309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307319 */     // GIR_Coverage, 1974,
     /* 2307319 */     GIR_EraseRootFromParent_Done,
     /* 2307320 */   // Label 31569: @2307320
     /* 2307320 */   GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2307354), // Rule ID 1975 //
     /* 2307325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2307328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307340 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2307340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2307343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307353 */     // GIR_Coverage, 1975,
     /* 2307353 */     GIR_EraseRootFromParent_Done,
     /* 2307354 */   // Label 31570: @2307354
     /* 2307354 */   GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2307388), // Rule ID 1978 //
     /* 2307359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2307362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307374 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2307374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2307377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307387 */     // GIR_Coverage, 1978,
     /* 2307387 */     GIR_EraseRootFromParent_Done,
     /* 2307388 */   // Label 31571: @2307388
     /* 2307388 */   GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2307422), // Rule ID 1979 //
     /* 2307393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2307396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307408 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2307408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2307411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307421 */     // GIR_Coverage, 1979,
     /* 2307421 */     GIR_EraseRootFromParent_Done,
     /* 2307422 */   // Label 31572: @2307422
     /* 2307422 */   GIM_Reject,
     /* 2307423 */ // Label 31568: @2307423
     /* 2307423 */ GIM_Reject,
     /* 2307424 */ // Label 31550: @2307424
     /* 2307424 */ GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2307572),
     /* 2307429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2307435 */   GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2307469), // Rule ID 1265 //
     /* 2307440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2307443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307455 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2307455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2307458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307468 */     // GIR_Coverage, 1265,
     /* 2307468 */     GIR_EraseRootFromParent_Done,
     /* 2307469 */   // Label 31574: @2307469
     /* 2307469 */   GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2307503), // Rule ID 1266 //
     /* 2307474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2307477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307489 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2307489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2307492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307502 */     // GIR_Coverage, 1266,
     /* 2307502 */     GIR_EraseRootFromParent_Done,
     /* 2307503 */   // Label 31575: @2307503
     /* 2307503 */   GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2307537), // Rule ID 1269 //
     /* 2307508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2307511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307523 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2307523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2307526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307536 */     // GIR_Coverage, 1269,
     /* 2307536 */     GIR_EraseRootFromParent_Done,
     /* 2307537 */   // Label 31576: @2307537
     /* 2307537 */   GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2307571), // Rule ID 1270 //
     /* 2307542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2307545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307557 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2307557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2307560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307570 */     // GIR_Coverage, 1270,
     /* 2307570 */     GIR_EraseRootFromParent_Done,
     /* 2307571 */   // Label 31577: @2307571
     /* 2307571 */   GIM_Reject,
     /* 2307572 */ // Label 31573: @2307572
     /* 2307572 */ GIM_Reject,
     /* 2307573 */ // Label 31551: @2307573
     /* 2307573 */ GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2307755),
     /* 2307578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2307584 */   GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2307618), // Rule ID 1604 //
     /* 2307589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307604 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2307607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307617 */     // GIR_Coverage, 1604,
     /* 2307617 */     GIR_EraseRootFromParent_Done,
     /* 2307618 */   // Label 31579: @2307618
     /* 2307618 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2307652), // Rule ID 1605 //
     /* 2307623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307638 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2307638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2307641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307651 */     // GIR_Coverage, 1605,
     /* 2307651 */     GIR_EraseRootFromParent_Done,
     /* 2307652 */   // Label 31580: @2307652
     /* 2307652 */   GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2307686), // Rule ID 1608 //
     /* 2307657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307672 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2307675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307685 */     // GIR_Coverage, 1608,
     /* 2307685 */     GIR_EraseRootFromParent_Done,
     /* 2307686 */   // Label 31581: @2307686
     /* 2307686 */   GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2307720), // Rule ID 1609 //
     /* 2307691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307706 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2307706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2307709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307719 */     // GIR_Coverage, 1609,
     /* 2307719 */     GIR_EraseRootFromParent_Done,
     /* 2307720 */   // Label 31582: @2307720
     /* 2307720 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2307754), // Rule ID 1611 //
     /* 2307725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307740 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2307740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2307743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307753 */     // GIR_Coverage, 1611,
     /* 2307753 */     GIR_EraseRootFromParent_Done,
     /* 2307754 */   // Label 31583: @2307754
     /* 2307754 */   GIM_Reject,
     /* 2307755 */ // Label 31578: @2307755
     /* 2307755 */ GIM_Reject,
     /* 2307756 */ // Label 31552: @2307756
     /* 2307756 */ GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2307876),
     /* 2307761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2307764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2307767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307779 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2307827), // Rule ID 54228 //
     /* 2307784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307787 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2307804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307826 */     // GIR_Coverage, 54228,
     /* 2307826 */     GIR_EraseRootFromParent_Done,
     /* 2307827 */   // Label 31585: @2307827
     /* 2307827 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2307875), // Rule ID 54229 //
     /* 2307832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307835 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2307852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307874 */     // GIR_Coverage, 54229,
     /* 2307874 */     GIR_EraseRootFromParent_Done,
     /* 2307875 */   // Label 31586: @2307875
     /* 2307875 */   GIM_Reject,
     /* 2307876 */ // Label 31584: @2307876
     /* 2307876 */ GIM_Reject,
     /* 2307877 */ // Label 31553: @2307877
     /* 2307877 */ GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2307997),
     /* 2307882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2307885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2307888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307900 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2307948), // Rule ID 54252 //
     /* 2307905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307908 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2307925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307947 */     // GIR_Coverage, 54252,
     /* 2307947 */     GIR_EraseRootFromParent_Done,
     /* 2307948 */   // Label 31588: @2307948
     /* 2307948 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2307996), // Rule ID 54253 //
     /* 2307953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307956 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2307973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307995 */     // GIR_Coverage, 54253,
     /* 2307995 */     GIR_EraseRootFromParent_Done,
     /* 2307996 */   // Label 31589: @2307996
     /* 2307996 */   GIM_Reject,
     /* 2307997 */ // Label 31587: @2307997
     /* 2307997 */ GIM_Reject,
     /* 2307998 */ // Label 31554: @2307998
     /* 2307998 */ GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2308118),
     /* 2308003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2308006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2308009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308021 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2308069), // Rule ID 54288 //
     /* 2308026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308029 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2308032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2308046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308068 */     // GIR_Coverage, 54288,
     /* 2308068 */     GIR_EraseRootFromParent_Done,
     /* 2308069 */   // Label 31591: @2308069
     /* 2308069 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2308117), // Rule ID 54289 //
     /* 2308074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308077 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2308080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2308094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308116 */     // GIR_Coverage, 54289,
     /* 2308116 */     GIR_EraseRootFromParent_Done,
     /* 2308117 */   // Label 31592: @2308117
     /* 2308117 */   GIM_Reject,
     /* 2308118 */ // Label 31590: @2308118
     /* 2308118 */ GIM_Reject,
     /* 2308119 */ // Label 31555: @2308119
     /* 2308119 */ GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2308239),
     /* 2308124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2308127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2308130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308142 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2308190), // Rule ID 54240 //
     /* 2308147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308150 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2308153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2308167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308189 */     // GIR_Coverage, 54240,
     /* 2308189 */     GIR_EraseRootFromParent_Done,
     /* 2308190 */   // Label 31594: @2308190
     /* 2308190 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2308238), // Rule ID 54241 //
     /* 2308195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308198 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2308201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2308215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308237 */     // GIR_Coverage, 54241,
     /* 2308237 */     GIR_EraseRootFromParent_Done,
     /* 2308238 */   // Label 31595: @2308238
     /* 2308238 */   GIM_Reject,
     /* 2308239 */ // Label 31593: @2308239
     /* 2308239 */ GIM_Reject,
     /* 2308240 */ // Label 31556: @2308240
     /* 2308240 */ GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2308360),
     /* 2308245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2308248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2308251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308263 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2308311), // Rule ID 54276 //
     /* 2308268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308271 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2308288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308310 */     // GIR_Coverage, 54276,
     /* 2308310 */     GIR_EraseRootFromParent_Done,
     /* 2308311 */   // Label 31597: @2308311
     /* 2308311 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2308359), // Rule ID 54277 //
     /* 2308316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308319 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2308336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308358 */     // GIR_Coverage, 54277,
     /* 2308358 */     GIR_EraseRootFromParent_Done,
     /* 2308359 */   // Label 31598: @2308359
     /* 2308359 */   GIM_Reject,
     /* 2308360 */ // Label 31596: @2308360
     /* 2308360 */ GIM_Reject,
     /* 2308361 */ // Label 31557: @2308361
     /* 2308361 */ GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2308481),
     /* 2308366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2308369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2308372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308384 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2308432), // Rule ID 54372 //
     /* 2308389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308392 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2308409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308431 */     // GIR_Coverage, 54372,
     /* 2308431 */     GIR_EraseRootFromParent_Done,
     /* 2308432 */   // Label 31600: @2308432
     /* 2308432 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2308480), // Rule ID 54373 //
     /* 2308437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308440 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2308457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308479 */     // GIR_Coverage, 54373,
     /* 2308479 */     GIR_EraseRootFromParent_Done,
     /* 2308480 */   // Label 31601: @2308480
     /* 2308480 */   GIM_Reject,
     /* 2308481 */ // Label 31599: @2308481
     /* 2308481 */ GIM_Reject,
     /* 2308482 */ // Label 31558: @2308482
     /* 2308482 */ GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2308602),
     /* 2308487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2308490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2308493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308505 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2308553), // Rule ID 54264 //
     /* 2308510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308513 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2308530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308552 */     // GIR_Coverage, 54264,
     /* 2308552 */     GIR_EraseRootFromParent_Done,
     /* 2308553 */   // Label 31603: @2308553
     /* 2308553 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2308601), // Rule ID 54265 //
     /* 2308558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308561 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2308578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308600 */     // GIR_Coverage, 54265,
     /* 2308600 */     GIR_EraseRootFromParent_Done,
     /* 2308601 */   // Label 31604: @2308601
     /* 2308601 */   GIM_Reject,
     /* 2308602 */ // Label 31602: @2308602
     /* 2308602 */ GIM_Reject,
     /* 2308603 */ // Label 31559: @2308603
     /* 2308603 */ GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2308723),
     /* 2308608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2308611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2308614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308626 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2308674), // Rule ID 54336 //
     /* 2308631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308634 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2308651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308673 */     // GIR_Coverage, 54336,
     /* 2308673 */     GIR_EraseRootFromParent_Done,
     /* 2308674 */   // Label 31606: @2308674
     /* 2308674 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2308722), // Rule ID 54337 //
     /* 2308679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308682 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2308699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308721 */     // GIR_Coverage, 54337,
     /* 2308721 */     GIR_EraseRootFromParent_Done,
     /* 2308722 */   // Label 31607: @2308722
     /* 2308722 */   GIM_Reject,
     /* 2308723 */ // Label 31605: @2308723
     /* 2308723 */ GIM_Reject,
     /* 2308724 */ // Label 31560: @2308724
     /* 2308724 */ GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2308844),
     /* 2308729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2308732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2308735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308747 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2308795), // Rule ID 54384 //
     /* 2308752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308755 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2308772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308794 */     // GIR_Coverage, 54384,
     /* 2308794 */     GIR_EraseRootFromParent_Done,
     /* 2308795 */   // Label 31609: @2308795
     /* 2308795 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2308843), // Rule ID 54385 //
     /* 2308800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308803 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2308820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308842 */     // GIR_Coverage, 54385,
     /* 2308842 */     GIR_EraseRootFromParent_Done,
     /* 2308843 */   // Label 31610: @2308843
     /* 2308843 */   GIM_Reject,
     /* 2308844 */ // Label 31608: @2308844
     /* 2308844 */ GIM_Reject,
     /* 2308845 */ // Label 31561: @2308845
     /* 2308845 */ GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2308965),
     /* 2308850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2308853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2308856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308868 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2308916), // Rule ID 54300 //
     /* 2308873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308876 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2308893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308915 */     // GIR_Coverage, 54300,
     /* 2308915 */     GIR_EraseRootFromParent_Done,
     /* 2308916 */   // Label 31612: @2308916
     /* 2308916 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2308964), // Rule ID 54301 //
     /* 2308921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308924 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2308941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308963 */     // GIR_Coverage, 54301,
     /* 2308963 */     GIR_EraseRootFromParent_Done,
     /* 2308964 */   // Label 31613: @2308964
     /* 2308964 */   GIM_Reject,
     /* 2308965 */ // Label 31611: @2308965
     /* 2308965 */ GIM_Reject,
     /* 2308966 */ // Label 31562: @2308966
     /* 2308966 */ GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2309086),
     /* 2308971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2308974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2308977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308989 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2309037), // Rule ID 54348 //
     /* 2308994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308997 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2309000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2309014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309036 */     // GIR_Coverage, 54348,
     /* 2309036 */     GIR_EraseRootFromParent_Done,
     /* 2309037 */   // Label 31615: @2309037
     /* 2309037 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2309085), // Rule ID 54349 //
     /* 2309042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309045 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2309048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2309062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309084 */     // GIR_Coverage, 54349,
     /* 2309084 */     GIR_EraseRootFromParent_Done,
     /* 2309085 */   // Label 31616: @2309085
     /* 2309085 */   GIM_Reject,
     /* 2309086 */ // Label 31614: @2309086
     /* 2309086 */ GIM_Reject,
     /* 2309087 */ // Label 31563: @2309087
     /* 2309087 */ GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2309207),
     /* 2309092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2309095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2309098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309110 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2309158), // Rule ID 54396 //
     /* 2309115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2309118 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2309121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2309135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309157 */     // GIR_Coverage, 54396,
     /* 2309157 */     GIR_EraseRootFromParent_Done,
     /* 2309158 */   // Label 31618: @2309158
     /* 2309158 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2309206), // Rule ID 54397 //
     /* 2309163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2309166 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2309169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2309183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309205 */     // GIR_Coverage, 54397,
     /* 2309205 */     GIR_EraseRootFromParent_Done,
     /* 2309206 */   // Label 31619: @2309206
     /* 2309206 */   GIM_Reject,
     /* 2309207 */ // Label 31617: @2309207
     /* 2309207 */ GIM_Reject,
     /* 2309208 */ // Label 31564: @2309208
     /* 2309208 */ GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2309328),
     /* 2309213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2309216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2309219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2309231 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2309279), // Rule ID 54312 //
     /* 2309236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309239 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2309242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2309256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309278 */     // GIR_Coverage, 54312,
     /* 2309278 */     GIR_EraseRootFromParent_Done,
     /* 2309279 */   // Label 31621: @2309279
     /* 2309279 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2309327), // Rule ID 54313 //
     /* 2309284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309287 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2309290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2309304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309326 */     // GIR_Coverage, 54313,
     /* 2309326 */     GIR_EraseRootFromParent_Done,
     /* 2309327 */   // Label 31622: @2309327
     /* 2309327 */   GIM_Reject,
     /* 2309328 */ // Label 31620: @2309328
     /* 2309328 */ GIM_Reject,
     /* 2309329 */ // Label 31565: @2309329
     /* 2309329 */ GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2309449),
     /* 2309334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2309337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2309340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309352 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2309400), // Rule ID 54360 //
     /* 2309357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309360 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2309363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2309377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309399 */     // GIR_Coverage, 54360,
     /* 2309399 */     GIR_EraseRootFromParent_Done,
     /* 2309400 */   // Label 31624: @2309400
     /* 2309400 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2309448), // Rule ID 54361 //
     /* 2309405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309408 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2309411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2309425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309447 */     // GIR_Coverage, 54361,
     /* 2309447 */     GIR_EraseRootFromParent_Done,
     /* 2309448 */   // Label 31625: @2309448
     /* 2309448 */   GIM_Reject,
     /* 2309449 */ // Label 31623: @2309449
     /* 2309449 */ GIM_Reject,
     /* 2309450 */ // Label 31566: @2309450
     /* 2309450 */ GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2309570),
     /* 2309455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2309458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2309461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309473 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2309521), // Rule ID 54324 //
     /* 2309478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309481 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2309498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309520 */     // GIR_Coverage, 54324,
     /* 2309520 */     GIR_EraseRootFromParent_Done,
     /* 2309521 */   // Label 31627: @2309521
     /* 2309521 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2309569), // Rule ID 54325 //
     /* 2309526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309529 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2309546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309568 */     // GIR_Coverage, 54325,
     /* 2309568 */     GIR_EraseRootFromParent_Done,
     /* 2309569 */   // Label 31628: @2309569
     /* 2309569 */   GIM_Reject,
     /* 2309570 */ // Label 31626: @2309570
     /* 2309570 */ GIM_Reject,
     /* 2309571 */ // Label 31567: @2309571
     /* 2309571 */ GIM_Reject,
     /* 2309572 */ // Label 62: @2309572
     /* 2309572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31647*/ GIMT_Encode4(2326216),
     /* 2309583 */ /*GILLT_s16*//*Label 31629*/ GIMT_Encode4(2309703),
     /* 2309587 */ /*GILLT_s32*//*Label 31630*/ GIMT_Encode4(2311139),
     /* 2309591 */ /*GILLT_s64*//*Label 31631*/ GIMT_Encode4(2312575), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309603 */ /*GILLT_nxv1s16*//*Label 31632*/ GIMT_Encode4(2314366),
     /* 2309607 */ /*GILLT_nxv1s32*//*Label 31633*/ GIMT_Encode4(2315156),
     /* 2309611 */ /*GILLT_nxv1s64*//*Label 31634*/ GIMT_Encode4(2315946), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309623 */ /*GILLT_nxv2s16*//*Label 31635*/ GIMT_Encode4(2316736),
     /* 2309627 */ /*GILLT_nxv2s32*//*Label 31636*/ GIMT_Encode4(2317526),
     /* 2309631 */ /*GILLT_nxv2s64*//*Label 31637*/ GIMT_Encode4(2318316), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309643 */ /*GILLT_nxv4s16*//*Label 31638*/ GIMT_Encode4(2319106),
     /* 2309647 */ /*GILLT_nxv4s32*//*Label 31639*/ GIMT_Encode4(2319896),
     /* 2309651 */ /*GILLT_nxv4s64*//*Label 31640*/ GIMT_Encode4(2320686), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309663 */ /*GILLT_nxv8s16*//*Label 31641*/ GIMT_Encode4(2321476),
     /* 2309667 */ /*GILLT_nxv8s32*//*Label 31642*/ GIMT_Encode4(2322266),
     /* 2309671 */ /*GILLT_nxv8s64*//*Label 31643*/ GIMT_Encode4(2323056), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309683 */ /*GILLT_nxv16s16*//*Label 31644*/ GIMT_Encode4(2323846),
     /* 2309687 */ /*GILLT_nxv16s32*//*Label 31645*/ GIMT_Encode4(2324636), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309699 */ /*GILLT_nxv32s16*//*Label 31646*/ GIMT_Encode4(2325426),
     /* 2309703 */ // Label 31629: @2309703
     /* 2309703 */ GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2311138),
     /* 2309708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2309714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2309717 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2309789), // Rule ID 2015 //
     /* 2309722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2309725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309769 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2309769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2309772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309788 */     // GIR_Coverage, 2015,
     /* 2309788 */     GIR_EraseRootFromParent_Done,
     /* 2309789 */   // Label 31649: @2309789
     /* 2309789 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2309861), // Rule ID 2016 //
     /* 2309794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2309797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309841 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2309841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2309844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309860 */     // GIR_Coverage, 2016,
     /* 2309860 */     GIR_EraseRootFromParent_Done,
     /* 2309861 */   // Label 31650: @2309861
     /* 2309861 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2309933), // Rule ID 2048 //
     /* 2309866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2309869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309913 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2309913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2309916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2309928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309932 */     // GIR_Coverage, 2048,
     /* 2309932 */     GIR_EraseRootFromParent_Done,
     /* 2309933 */   // Label 31651: @2309933
     /* 2309933 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2310005), // Rule ID 2049 //
     /* 2309938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2309941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309985 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2309985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2309988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310004 */     // GIR_Coverage, 2049,
     /* 2310004 */     GIR_EraseRootFromParent_Done,
     /* 2310005 */   // Label 31652: @2310005
     /* 2310005 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2310077), // Rule ID 65529 //
     /* 2310010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310057 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2310060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310076 */     // GIR_Coverage, 65529,
     /* 2310076 */     GIR_EraseRootFromParent_Done,
     /* 2310077 */   // Label 31653: @2310077
     /* 2310077 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2310149), // Rule ID 65530 //
     /* 2310082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310129 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2310132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310148 */     // GIR_Coverage, 65530,
     /* 2310148 */     GIR_EraseRootFromParent_Done,
     /* 2310149 */   // Label 31654: @2310149
     /* 2310149 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2310221), // Rule ID 65537 //
     /* 2310154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310201 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2310204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310220 */     // GIR_Coverage, 65537,
     /* 2310220 */     GIR_EraseRootFromParent_Done,
     /* 2310221 */   // Label 31655: @2310221
     /* 2310221 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2310293), // Rule ID 65538 //
     /* 2310226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310273 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2310276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2310288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310292 */     // GIR_Coverage, 65538,
     /* 2310292 */     GIR_EraseRootFromParent_Done,
     /* 2310293 */   // Label 31656: @2310293
     /* 2310293 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2310350), // Rule ID 2011 //
     /* 2310298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310332 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310349 */     // GIR_Coverage, 2011,
     /* 2310349 */     GIR_EraseRootFromParent_Done,
     /* 2310350 */   // Label 31657: @2310350
     /* 2310350 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2310407), // Rule ID 2012 //
     /* 2310355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310389 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310406 */     // GIR_Coverage, 2012,
     /* 2310406 */     GIR_EraseRootFromParent_Done,
     /* 2310407 */   // Label 31658: @2310407
     /* 2310407 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2310464), // Rule ID 2044 //
     /* 2310412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310446 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310463 */     // GIR_Coverage, 2044,
     /* 2310463 */     GIR_EraseRootFromParent_Done,
     /* 2310464 */   // Label 31659: @2310464
     /* 2310464 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2310521), // Rule ID 2045 //
     /* 2310469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310503 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310520 */     // GIR_Coverage, 2045,
     /* 2310520 */     GIR_EraseRootFromParent_Done,
     /* 2310521 */   // Label 31660: @2310521
     /* 2310521 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2310578), // Rule ID 65525 //
     /* 2310526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310560 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310577 */     // GIR_Coverage, 65525,
     /* 2310577 */     GIR_EraseRootFromParent_Done,
     /* 2310578 */   // Label 31661: @2310578
     /* 2310578 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2310635), // Rule ID 65526 //
     /* 2310583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310617 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2310620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310634 */     // GIR_Coverage, 65526,
     /* 2310634 */     GIR_EraseRootFromParent_Done,
     /* 2310635 */   // Label 31662: @2310635
     /* 2310635 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2310692), // Rule ID 65533 //
     /* 2310640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310674 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310691 */     // GIR_Coverage, 65533,
     /* 2310691 */     GIR_EraseRootFromParent_Done,
     /* 2310692 */   // Label 31663: @2310692
     /* 2310692 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2310749), // Rule ID 65534 //
     /* 2310697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310731 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2310734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2310742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2310744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310748 */     // GIR_Coverage, 65534,
     /* 2310748 */     GIR_EraseRootFromParent_Done,
     /* 2310749 */   // Label 31664: @2310749
     /* 2310749 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2310806), // Rule ID 2007 //
     /* 2310754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310788 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2310791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310805 */     // GIR_Coverage, 2007,
     /* 2310805 */     GIR_EraseRootFromParent_Done,
     /* 2310806 */   // Label 31665: @2310806
     /* 2310806 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2310863), // Rule ID 2008 //
     /* 2310811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2310814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310845 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2310848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310862 */     // GIR_Coverage, 2008,
     /* 2310862 */     GIR_EraseRootFromParent_Done,
     /* 2310863 */   // Label 31666: @2310863
     /* 2310863 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2310920), // Rule ID 2040 //
     /* 2310868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2310871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310902 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2310902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2310905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310919 */     // GIR_Coverage, 2040,
     /* 2310919 */     GIR_EraseRootFromParent_Done,
     /* 2310920 */   // Label 31667: @2310920
     /* 2310920 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2310977), // Rule ID 2041 //
     /* 2310925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2310928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2310952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310959 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2310959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2310962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2310972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310976 */     // GIR_Coverage, 2041,
     /* 2310976 */     GIR_EraseRootFromParent_Done,
     /* 2310977 */   // Label 31668: @2310977
     /* 2310977 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2311017), // Rule ID 2003 //
     /* 2310982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2310985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2310997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311001 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2311001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2311004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311016 */     // GIR_Coverage, 2003,
     /* 2311016 */     GIR_EraseRootFromParent_Done,
     /* 2311017 */   // Label 31669: @2311017
     /* 2311017 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2311057), // Rule ID 2004 //
     /* 2311022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2311025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311041 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2311041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2311044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311056 */     // GIR_Coverage, 2004,
     /* 2311056 */     GIR_EraseRootFromParent_Done,
     /* 2311057 */   // Label 31670: @2311057
     /* 2311057 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2311097), // Rule ID 2036 //
     /* 2311062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2311065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311081 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2311081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2311084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311096 */     // GIR_Coverage, 2036,
     /* 2311096 */     GIR_EraseRootFromParent_Done,
     /* 2311097 */   // Label 31671: @2311097
     /* 2311097 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2311137), // Rule ID 2037 //
     /* 2311102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2311105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311121 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2311121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2311124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311136 */     // GIR_Coverage, 2037,
     /* 2311136 */     GIR_EraseRootFromParent_Done,
     /* 2311137 */   // Label 31672: @2311137
     /* 2311137 */   GIM_Reject,
     /* 2311138 */ // Label 31648: @2311138
     /* 2311138 */ GIM_Reject,
     /* 2311139 */ // Label 31630: @2311139
     /* 2311139 */ GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2312574),
     /* 2311144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2311150 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2311153 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2311225), // Rule ID 1314 //
     /* 2311158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311205 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311224 */     // GIR_Coverage, 1314,
     /* 2311224 */     GIR_EraseRootFromParent_Done,
     /* 2311225 */   // Label 31674: @2311225
     /* 2311225 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2311297), // Rule ID 1315 //
     /* 2311230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311277 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311296 */     // GIR_Coverage, 1315,
     /* 2311296 */     GIR_EraseRootFromParent_Done,
     /* 2311297 */   // Label 31675: @2311297
     /* 2311297 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2311369), // Rule ID 1335 //
     /* 2311302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311349 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311368 */     // GIR_Coverage, 1335,
     /* 2311368 */     GIR_EraseRootFromParent_Done,
     /* 2311369 */   // Label 31676: @2311369
     /* 2311369 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2311441), // Rule ID 1336 //
     /* 2311374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311421 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311440 */     // GIR_Coverage, 1336,
     /* 2311440 */     GIR_EraseRootFromParent_Done,
     /* 2311441 */   // Label 31677: @2311441
     /* 2311441 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2311513), // Rule ID 65493 //
     /* 2311446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311493 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311512 */     // GIR_Coverage, 65493,
     /* 2311512 */     GIR_EraseRootFromParent_Done,
     /* 2311513 */   // Label 31678: @2311513
     /* 2311513 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2311585), // Rule ID 65494 //
     /* 2311518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311565 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2311568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311584 */     // GIR_Coverage, 65494,
     /* 2311584 */     GIR_EraseRootFromParent_Done,
     /* 2311585 */   // Label 31679: @2311585
     /* 2311585 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2311657), // Rule ID 65501 //
     /* 2311590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311637 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311656 */     // GIR_Coverage, 65501,
     /* 2311656 */     GIR_EraseRootFromParent_Done,
     /* 2311657 */   // Label 31680: @2311657
     /* 2311657 */   GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2311729), // Rule ID 65502 //
     /* 2311662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311709 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2311712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2311720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2311724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311728 */     // GIR_Coverage, 65502,
     /* 2311728 */     GIR_EraseRootFromParent_Done,
     /* 2311729 */   // Label 31681: @2311729
     /* 2311729 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2311786), // Rule ID 1310 //
     /* 2311734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311768 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2311771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311785 */     // GIR_Coverage, 1310,
     /* 2311785 */     GIR_EraseRootFromParent_Done,
     /* 2311786 */   // Label 31682: @2311786
     /* 2311786 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2311843), // Rule ID 1311 //
     /* 2311791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2311794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311825 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2311828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311842 */     // GIR_Coverage, 1311,
     /* 2311842 */     GIR_EraseRootFromParent_Done,
     /* 2311843 */   // Label 31683: @2311843
     /* 2311843 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2311900), // Rule ID 1331 //
     /* 2311848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2311851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311882 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2311885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311899 */     // GIR_Coverage, 1331,
     /* 2311899 */     GIR_EraseRootFromParent_Done,
     /* 2311900 */   // Label 31684: @2311900
     /* 2311900 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2311957), // Rule ID 1332 //
     /* 2311905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2311908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311939 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2311939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2311942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2311952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311956 */     // GIR_Coverage, 1332,
     /* 2311956 */     GIR_EraseRootFromParent_Done,
     /* 2311957 */   // Label 31685: @2311957
     /* 2311957 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2312014), // Rule ID 65489 //
     /* 2311962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2311965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311996 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2311996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2311999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312013 */     // GIR_Coverage, 65489,
     /* 2312013 */     GIR_EraseRootFromParent_Done,
     /* 2312014 */   // Label 31686: @2312014
     /* 2312014 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2312071), // Rule ID 65490 //
     /* 2312019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312053 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2312056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312070 */     // GIR_Coverage, 65490,
     /* 2312070 */     GIR_EraseRootFromParent_Done,
     /* 2312071 */   // Label 31687: @2312071
     /* 2312071 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2312128), // Rule ID 65497 //
     /* 2312076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312110 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2312113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312127 */     // GIR_Coverage, 65497,
     /* 2312127 */     GIR_EraseRootFromParent_Done,
     /* 2312128 */   // Label 31688: @2312128
     /* 2312128 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2312185), // Rule ID 65498 //
     /* 2312133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312167 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2312170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2312178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312184 */     // GIR_Coverage, 65498,
     /* 2312184 */     GIR_EraseRootFromParent_Done,
     /* 2312185 */   // Label 31689: @2312185
     /* 2312185 */   GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2312242), // Rule ID 1306 //
     /* 2312190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2312193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312224 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2312227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312241 */     // GIR_Coverage, 1306,
     /* 2312241 */     GIR_EraseRootFromParent_Done,
     /* 2312242 */   // Label 31690: @2312242
     /* 2312242 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2312299), // Rule ID 1307 //
     /* 2312247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312281 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2312284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312298 */     // GIR_Coverage, 1307,
     /* 2312298 */     GIR_EraseRootFromParent_Done,
     /* 2312299 */   // Label 31691: @2312299
     /* 2312299 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2312356), // Rule ID 1327 //
     /* 2312304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312338 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2312341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312355 */     // GIR_Coverage, 1327,
     /* 2312355 */     GIR_EraseRootFromParent_Done,
     /* 2312356 */   // Label 31692: @2312356
     /* 2312356 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2312413), // Rule ID 1328 //
     /* 2312361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2312388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312395 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2312398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2312408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312412 */     // GIR_Coverage, 1328,
     /* 2312412 */     GIR_EraseRootFromParent_Done,
     /* 2312413 */   // Label 31693: @2312413
     /* 2312413 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2312453), // Rule ID 1302 //
     /* 2312418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2312421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312437 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2312440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312452 */     // GIR_Coverage, 1302,
     /* 2312452 */     GIR_EraseRootFromParent_Done,
     /* 2312453 */   // Label 31694: @2312453
     /* 2312453 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2312493), // Rule ID 1303 //
     /* 2312458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2312461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2312477 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2312480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312492 */     // GIR_Coverage, 1303,
     /* 2312492 */     GIR_EraseRootFromParent_Done,
     /* 2312493 */   // Label 31695: @2312493
     /* 2312493 */   GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2312533), // Rule ID 1323 //
     /* 2312498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2312501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312517 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2312517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2312520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312532 */     // GIR_Coverage, 1323,
     /* 2312532 */     GIR_EraseRootFromParent_Done,
     /* 2312533 */   // Label 31696: @2312533
     /* 2312533 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2312573), // Rule ID 1324 //
     /* 2312538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2312541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2312557 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2312557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2312560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2312568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312572 */     // GIR_Coverage, 1324,
     /* 2312572 */     GIR_EraseRootFromParent_Done,
     /* 2312573 */   // Label 31697: @2312573
     /* 2312573 */   GIM_Reject,
     /* 2312574 */ // Label 31673: @2312574
     /* 2312574 */ GIM_Reject,
     /* 2312575 */ // Label 31631: @2312575
     /* 2312575 */ GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2314365),
     /* 2312580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2312586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2312589 */   GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2312661), // Rule ID 1651 //
     /* 2312594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2312597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312641 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2312644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312660 */     // GIR_Coverage, 1651,
     /* 2312660 */     GIR_EraseRootFromParent_Done,
     /* 2312661 */   // Label 31699: @2312661
     /* 2312661 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2312733), // Rule ID 1652 //
     /* 2312666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2312669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312713 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2312713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2312716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312732 */     // GIR_Coverage, 1652,
     /* 2312732 */     GIR_EraseRootFromParent_Done,
     /* 2312733 */   // Label 31700: @2312733
     /* 2312733 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2312805), // Rule ID 1674 //
     /* 2312738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2312741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2312783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312785 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2312788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312804 */     // GIR_Coverage, 1674,
     /* 2312804 */     GIR_EraseRootFromParent_Done,
     /* 2312805 */   // Label 31701: @2312805
     /* 2312805 */   GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2312877), // Rule ID 1706 //
     /* 2312810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2312813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312857 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2312857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2312860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312876 */     // GIR_Coverage, 1706,
     /* 2312876 */     GIR_EraseRootFromParent_Done,
     /* 2312877 */   // Label 31702: @2312877
     /* 2312877 */   GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2312949), // Rule ID 1707 //
     /* 2312882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2312885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2312927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312929 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2312929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2312932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2312940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2312944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312948 */     // GIR_Coverage, 1707,
     /* 2312948 */     GIR_EraseRootFromParent_Done,
     /* 2312949 */   // Label 31703: @2312949
     /* 2312949 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2313021), // Rule ID 65509 //
     /* 2312954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2312957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2312994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2312999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313001 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2313004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313020 */     // GIR_Coverage, 65509,
     /* 2313020 */     GIR_EraseRootFromParent_Done,
     /* 2313021 */   // Label 31704: @2313021
     /* 2313021 */   GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2313093), // Rule ID 65510 //
     /* 2313026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313073 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2313076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313092 */     // GIR_Coverage, 65510,
     /* 2313092 */     GIR_EraseRootFromParent_Done,
     /* 2313093 */   // Label 31705: @2313093
     /* 2313093 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2313165), // Rule ID 65514 //
     /* 2313098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313145 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2313148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313164 */     // GIR_Coverage, 65514,
     /* 2313164 */     GIR_EraseRootFromParent_Done,
     /* 2313165 */   // Label 31706: @2313165
     /* 2313165 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2313237), // Rule ID 65521 //
     /* 2313170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313217 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2313220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313236 */     // GIR_Coverage, 65521,
     /* 2313236 */     GIR_EraseRootFromParent_Done,
     /* 2313237 */   // Label 31707: @2313237
     /* 2313237 */   GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2313309), // Rule ID 65522 //
     /* 2313242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313289 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2313292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2313304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313308 */     // GIR_Coverage, 65522,
     /* 2313308 */     GIR_EraseRootFromParent_Done,
     /* 2313309 */   // Label 31708: @2313309
     /* 2313309 */   GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2313366), // Rule ID 1647 //
     /* 2313314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313348 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313365 */     // GIR_Coverage, 1647,
     /* 2313365 */     GIR_EraseRootFromParent_Done,
     /* 2313366 */   // Label 31709: @2313366
     /* 2313366 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2313423), // Rule ID 1648 //
     /* 2313371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313405 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313422 */     // GIR_Coverage, 1648,
     /* 2313422 */     GIR_EraseRootFromParent_Done,
     /* 2313423 */   // Label 31710: @2313423
     /* 2313423 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2313480), // Rule ID 1672 //
     /* 2313428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313462 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2313465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313479 */     // GIR_Coverage, 1672,
     /* 2313479 */     GIR_EraseRootFromParent_Done,
     /* 2313480 */   // Label 31711: @2313480
     /* 2313480 */   GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2313537), // Rule ID 1702 //
     /* 2313485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313519 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313536 */     // GIR_Coverage, 1702,
     /* 2313536 */     GIR_EraseRootFromParent_Done,
     /* 2313537 */   // Label 31712: @2313537
     /* 2313537 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2313594), // Rule ID 1703 //
     /* 2313542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313576 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313593 */     // GIR_Coverage, 1703,
     /* 2313593 */     GIR_EraseRootFromParent_Done,
     /* 2313594 */   // Label 31713: @2313594
     /* 2313594 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2313651), // Rule ID 65505 //
     /* 2313599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313633 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313650 */     // GIR_Coverage, 65505,
     /* 2313650 */     GIR_EraseRootFromParent_Done,
     /* 2313651 */   // Label 31714: @2313651
     /* 2313651 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2313708), // Rule ID 65506 //
     /* 2313656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313690 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2313693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313707 */     // GIR_Coverage, 65506,
     /* 2313707 */     GIR_EraseRootFromParent_Done,
     /* 2313708 */   // Label 31715: @2313708
     /* 2313708 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2313765), // Rule ID 65512 //
     /* 2313713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313747 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2313750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313764 */     // GIR_Coverage, 65512,
     /* 2313764 */     GIR_EraseRootFromParent_Done,
     /* 2313765 */   // Label 31716: @2313765
     /* 2313765 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2313822), // Rule ID 65517 //
     /* 2313770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313804 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313821 */     // GIR_Coverage, 65517,
     /* 2313821 */     GIR_EraseRootFromParent_Done,
     /* 2313822 */   // Label 31717: @2313822
     /* 2313822 */   GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2313879), // Rule ID 65518 //
     /* 2313827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313861 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2313864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2313872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2313874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313878 */     // GIR_Coverage, 65518,
     /* 2313878 */     GIR_EraseRootFromParent_Done,
     /* 2313879 */   // Label 31718: @2313879
     /* 2313879 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2313936), // Rule ID 1643 //
     /* 2313884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313918 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2313918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2313921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2313931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313935 */     // GIR_Coverage, 1643,
     /* 2313935 */     GIR_EraseRootFromParent_Done,
     /* 2313936 */   // Label 31719: @2313936
     /* 2313936 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2313993), // Rule ID 1644 //
     /* 2313941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2313968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313975 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2313975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2313978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2313984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2313988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313992 */     // GIR_Coverage, 1644,
     /* 2313992 */     GIR_EraseRootFromParent_Done,
     /* 2313993 */   // Label 31720: @2313993
     /* 2313993 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2314050), // Rule ID 1670 //
     /* 2313998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2314001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314032 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2314035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314049 */     // GIR_Coverage, 1670,
     /* 2314049 */     GIR_EraseRootFromParent_Done,
     /* 2314050 */   // Label 31721: @2314050
     /* 2314050 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2314107), // Rule ID 1698 //
     /* 2314055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2314058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314089 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2314092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314106 */     // GIR_Coverage, 1698,
     /* 2314106 */     GIR_EraseRootFromParent_Done,
     /* 2314107 */   // Label 31722: @2314107
     /* 2314107 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2314164), // Rule ID 1699 //
     /* 2314112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2314115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314146 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2314149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2314159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314163 */     // GIR_Coverage, 1699,
     /* 2314163 */     GIR_EraseRootFromParent_Done,
     /* 2314164 */   // Label 31723: @2314164
     /* 2314164 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2314204), // Rule ID 1639 //
     /* 2314169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2314172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314188 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2314191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314203 */     // GIR_Coverage, 1639,
     /* 2314203 */     GIR_EraseRootFromParent_Done,
     /* 2314204 */   // Label 31724: @2314204
     /* 2314204 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2314244), // Rule ID 1640 //
     /* 2314209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2314212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314228 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2314231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314243 */     // GIR_Coverage, 1640,
     /* 2314243 */     GIR_EraseRootFromParent_Done,
     /* 2314244 */   // Label 31725: @2314244
     /* 2314244 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2314284), // Rule ID 1668 //
     /* 2314249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2314252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314268 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2314271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314283 */     // GIR_Coverage, 1668,
     /* 2314283 */     GIR_EraseRootFromParent_Done,
     /* 2314284 */   // Label 31726: @2314284
     /* 2314284 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2314324), // Rule ID 1694 //
     /* 2314289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2314292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314308 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2314308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2314311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314323 */     // GIR_Coverage, 1694,
     /* 2314323 */     GIR_EraseRootFromParent_Done,
     /* 2314324 */   // Label 31727: @2314324
     /* 2314324 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2314364), // Rule ID 1695 //
     /* 2314329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2314332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314348 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2314348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2314351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2314357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2314359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314363 */     // GIR_Coverage, 1695,
     /* 2314363 */     GIR_EraseRootFromParent_Done,
     /* 2314364 */   // Label 31728: @2314364
     /* 2314364 */   GIM_Reject,
     /* 2314365 */ // Label 31698: @2314365
     /* 2314365 */ GIM_Reject,
     /* 2314366 */ // Label 31632: @2314366
     /* 2314366 */ GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2315155),
     /* 2314371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2314377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2314380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314384 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2314461), // Rule ID 54842 //
     /* 2314389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314432 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314460 */     // GIR_Coverage, 54842,
     /* 2314460 */     GIR_EraseRootFromParent_Done,
     /* 2314461 */   // Label 31730: @2314461
     /* 2314461 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2314538), // Rule ID 54843 //
     /* 2314466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314509 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314537 */     // GIR_Coverage, 54843,
     /* 2314537 */     GIR_EraseRootFromParent_Done,
     /* 2314538 */   // Label 31731: @2314538
     /* 2314538 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2314615), // Rule ID 72493 //
     /* 2314543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314586 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314614 */     // GIR_Coverage, 72493,
     /* 2314614 */     GIR_EraseRootFromParent_Done,
     /* 2314615 */   // Label 31732: @2314615
     /* 2314615 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2314692), // Rule ID 72494 //
     /* 2314620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314663 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2314666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314691 */     // GIR_Coverage, 72494,
     /* 2314691 */     GIR_EraseRootFromParent_Done,
     /* 2314692 */   // Label 31733: @2314692
     /* 2314692 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2314754), // Rule ID 54846 //
     /* 2314697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314727 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314753 */     // GIR_Coverage, 54846,
     /* 2314753 */     GIR_EraseRootFromParent_Done,
     /* 2314754 */   // Label 31734: @2314754
     /* 2314754 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2314816), // Rule ID 54847 //
     /* 2314759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314789 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314815 */     // GIR_Coverage, 54847,
     /* 2314815 */     GIR_EraseRootFromParent_Done,
     /* 2314816 */   // Label 31735: @2314816
     /* 2314816 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2314878), // Rule ID 72497 //
     /* 2314821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314851 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314877 */     // GIR_Coverage, 72497,
     /* 2314877 */     GIR_EraseRootFromParent_Done,
     /* 2314878 */   // Label 31736: @2314878
     /* 2314878 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2314940), // Rule ID 72498 //
     /* 2314883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2314886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314913 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2314916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314939 */     // GIR_Coverage, 72498,
     /* 2314939 */     GIR_EraseRootFromParent_Done,
     /* 2314940 */   // Label 31737: @2314940
     /* 2314940 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2315002), // Rule ID 54838 //
     /* 2314945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2314948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2314968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314975 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2314978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315001 */     // GIR_Coverage, 54838,
     /* 2315001 */     GIR_EraseRootFromParent_Done,
     /* 2315002 */   // Label 31738: @2315002
     /* 2315002 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2315064), // Rule ID 54839 //
     /* 2315007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2315030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315037 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2315040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315063 */     // GIR_Coverage, 54839,
     /* 2315063 */     GIR_EraseRootFromParent_Done,
     /* 2315064 */   // Label 31739: @2315064
     /* 2315064 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2315109), // Rule ID 54834 //
     /* 2315069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315084 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2315087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315108 */     // GIR_Coverage, 54834,
     /* 2315108 */     GIR_EraseRootFromParent_Done,
     /* 2315109 */   // Label 31740: @2315109
     /* 2315109 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2315154), // Rule ID 54835 //
     /* 2315114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315129 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2315132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315153 */     // GIR_Coverage, 54835,
     /* 2315153 */     GIR_EraseRootFromParent_Done,
     /* 2315154 */   // Label 31741: @2315154
     /* 2315154 */   GIM_Reject,
     /* 2315155 */ // Label 31729: @2315155
     /* 2315155 */ GIM_Reject,
     /* 2315156 */ // Label 31633: @2315156
     /* 2315156 */ GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2315945),
     /* 2315161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2315167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2315170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315174 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2315251), // Rule ID 54970 //
     /* 2315179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315222 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315250 */     // GIR_Coverage, 54970,
     /* 2315250 */     GIR_EraseRootFromParent_Done,
     /* 2315251 */   // Label 31743: @2315251
     /* 2315251 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2315328), // Rule ID 54971 //
     /* 2315256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315299 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315327 */     // GIR_Coverage, 54971,
     /* 2315327 */     GIR_EraseRootFromParent_Done,
     /* 2315328 */   // Label 31744: @2315328
     /* 2315328 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2315405), // Rule ID 72605 //
     /* 2315333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315376 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315404 */     // GIR_Coverage, 72605,
     /* 2315404 */     GIR_EraseRootFromParent_Done,
     /* 2315405 */   // Label 31745: @2315405
     /* 2315405 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2315482), // Rule ID 72606 //
     /* 2315410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315453 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2315456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315481 */     // GIR_Coverage, 72606,
     /* 2315481 */     GIR_EraseRootFromParent_Done,
     /* 2315482 */   // Label 31746: @2315482
     /* 2315482 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2315544), // Rule ID 54974 //
     /* 2315487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315517 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315543 */     // GIR_Coverage, 54974,
     /* 2315543 */     GIR_EraseRootFromParent_Done,
     /* 2315544 */   // Label 31747: @2315544
     /* 2315544 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2315606), // Rule ID 54975 //
     /* 2315549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315579 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315605 */     // GIR_Coverage, 54975,
     /* 2315605 */     GIR_EraseRootFromParent_Done,
     /* 2315606 */   // Label 31748: @2315606
     /* 2315606 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2315668), // Rule ID 72609 //
     /* 2315611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315641 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315667 */     // GIR_Coverage, 72609,
     /* 2315667 */     GIR_EraseRootFromParent_Done,
     /* 2315668 */   // Label 31749: @2315668
     /* 2315668 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2315730), // Rule ID 72610 //
     /* 2315673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315703 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2315706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315729 */     // GIR_Coverage, 72610,
     /* 2315729 */     GIR_EraseRootFromParent_Done,
     /* 2315730 */   // Label 31750: @2315730
     /* 2315730 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2315792), // Rule ID 54966 //
     /* 2315735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315765 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2315768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315791 */     // GIR_Coverage, 54966,
     /* 2315791 */     GIR_EraseRootFromParent_Done,
     /* 2315792 */   // Label 31751: @2315792
     /* 2315792 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2315854), // Rule ID 54967 //
     /* 2315797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2315820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315827 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2315830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315853 */     // GIR_Coverage, 54967,
     /* 2315853 */     GIR_EraseRootFromParent_Done,
     /* 2315854 */   // Label 31752: @2315854
     /* 2315854 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2315899), // Rule ID 54962 //
     /* 2315859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2315862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315874 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2315877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315898 */     // GIR_Coverage, 54962,
     /* 2315898 */     GIR_EraseRootFromParent_Done,
     /* 2315899 */   // Label 31753: @2315899
     /* 2315899 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2315944), // Rule ID 54963 //
     /* 2315904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2315907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315919 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2315922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315943 */     // GIR_Coverage, 54963,
     /* 2315943 */     GIR_EraseRootFromParent_Done,
     /* 2315944 */   // Label 31754: @2315944
     /* 2315944 */   GIM_Reject,
     /* 2315945 */ // Label 31742: @2315945
     /* 2315945 */ GIM_Reject,
     /* 2315946 */ // Label 31634: @2315946
     /* 2315946 */ GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2316735),
     /* 2315951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2315954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2315957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2315960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315964 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2316041), // Rule ID 55162 //
     /* 2315969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2315984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2315993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316012 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316040 */     // GIR_Coverage, 55162,
     /* 2316040 */     GIR_EraseRootFromParent_Done,
     /* 2316041 */   // Label 31756: @2316041
     /* 2316041 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2316118), // Rule ID 55163 //
     /* 2316046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316089 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316117 */     // GIR_Coverage, 55163,
     /* 2316117 */     GIR_EraseRootFromParent_Done,
     /* 2316118 */   // Label 31757: @2316118
     /* 2316118 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2316195), // Rule ID 72773 //
     /* 2316123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316166 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316194 */     // GIR_Coverage, 72773,
     /* 2316194 */     GIR_EraseRootFromParent_Done,
     /* 2316195 */   // Label 31758: @2316195
     /* 2316195 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2316272), // Rule ID 72774 //
     /* 2316200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316243 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2316246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316271 */     // GIR_Coverage, 72774,
     /* 2316271 */     GIR_EraseRootFromParent_Done,
     /* 2316272 */   // Label 31759: @2316272
     /* 2316272 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2316334), // Rule ID 55166 //
     /* 2316277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316307 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316333 */     // GIR_Coverage, 55166,
     /* 2316333 */     GIR_EraseRootFromParent_Done,
     /* 2316334 */   // Label 31760: @2316334
     /* 2316334 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2316396), // Rule ID 55167 //
     /* 2316339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316369 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316395 */     // GIR_Coverage, 55167,
     /* 2316395 */     GIR_EraseRootFromParent_Done,
     /* 2316396 */   // Label 31761: @2316396
     /* 2316396 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2316458), // Rule ID 72777 //
     /* 2316401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316431 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316457 */     // GIR_Coverage, 72777,
     /* 2316457 */     GIR_EraseRootFromParent_Done,
     /* 2316458 */   // Label 31762: @2316458
     /* 2316458 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2316520), // Rule ID 72778 //
     /* 2316463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316493 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2316496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316519 */     // GIR_Coverage, 72778,
     /* 2316519 */     GIR_EraseRootFromParent_Done,
     /* 2316520 */   // Label 31763: @2316520
     /* 2316520 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2316582), // Rule ID 55158 //
     /* 2316525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316555 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2316558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316581 */     // GIR_Coverage, 55158,
     /* 2316581 */     GIR_EraseRootFromParent_Done,
     /* 2316582 */   // Label 31764: @2316582
     /* 2316582 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2316644), // Rule ID 55159 //
     /* 2316587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316617 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2316620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316643 */     // GIR_Coverage, 55159,
     /* 2316643 */     GIR_EraseRootFromParent_Done,
     /* 2316644 */   // Label 31765: @2316644
     /* 2316644 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2316689), // Rule ID 55154 //
     /* 2316649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316664 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2316667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316688 */     // GIR_Coverage, 55154,
     /* 2316688 */     GIR_EraseRootFromParent_Done,
     /* 2316689 */   // Label 31766: @2316689
     /* 2316689 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2316734), // Rule ID 55155 //
     /* 2316694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2316697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316709 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2316712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316733 */     // GIR_Coverage, 55155,
     /* 2316733 */     GIR_EraseRootFromParent_Done,
     /* 2316734 */   // Label 31767: @2316734
     /* 2316734 */   GIM_Reject,
     /* 2316735 */ // Label 31755: @2316735
     /* 2316735 */ GIM_Reject,
     /* 2316736 */ // Label 31635: @2316736
     /* 2316736 */ GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2317525),
     /* 2316741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2316747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2316750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316754 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2316831), // Rule ID 54906 //
     /* 2316759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316802 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316830 */     // GIR_Coverage, 54906,
     /* 2316830 */     GIR_EraseRootFromParent_Done,
     /* 2316831 */   // Label 31769: @2316831
     /* 2316831 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2316908), // Rule ID 54907 //
     /* 2316836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316879 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316907 */     // GIR_Coverage, 54907,
     /* 2316907 */     GIR_EraseRootFromParent_Done,
     /* 2316908 */   // Label 31770: @2316908
     /* 2316908 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2316985), // Rule ID 72549 //
     /* 2316913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2316949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316956 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2316959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316984 */     // GIR_Coverage, 72549,
     /* 2316984 */     GIR_EraseRootFromParent_Done,
     /* 2316985 */   // Label 31771: @2316985
     /* 2316985 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2317062), // Rule ID 72550 //
     /* 2316990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317033 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2317036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317061 */     // GIR_Coverage, 72550,
     /* 2317061 */     GIR_EraseRootFromParent_Done,
     /* 2317062 */   // Label 31772: @2317062
     /* 2317062 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2317124), // Rule ID 54910 //
     /* 2317067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317097 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317123 */     // GIR_Coverage, 54910,
     /* 2317123 */     GIR_EraseRootFromParent_Done,
     /* 2317124 */   // Label 31773: @2317124
     /* 2317124 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2317186), // Rule ID 54911 //
     /* 2317129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317159 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317185 */     // GIR_Coverage, 54911,
     /* 2317185 */     GIR_EraseRootFromParent_Done,
     /* 2317186 */   // Label 31774: @2317186
     /* 2317186 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2317248), // Rule ID 72553 //
     /* 2317191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317221 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317247 */     // GIR_Coverage, 72553,
     /* 2317247 */     GIR_EraseRootFromParent_Done,
     /* 2317248 */   // Label 31775: @2317248
     /* 2317248 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2317310), // Rule ID 72554 //
     /* 2317253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317283 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2317286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317309 */     // GIR_Coverage, 72554,
     /* 2317309 */     GIR_EraseRootFromParent_Done,
     /* 2317310 */   // Label 31776: @2317310
     /* 2317310 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2317372), // Rule ID 54902 //
     /* 2317315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317345 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2317348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317371 */     // GIR_Coverage, 54902,
     /* 2317371 */     GIR_EraseRootFromParent_Done,
     /* 2317372 */   // Label 31777: @2317372
     /* 2317372 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2317434), // Rule ID 54903 //
     /* 2317377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317407 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2317410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317433 */     // GIR_Coverage, 54903,
     /* 2317433 */     GIR_EraseRootFromParent_Done,
     /* 2317434 */   // Label 31778: @2317434
     /* 2317434 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2317479), // Rule ID 54898 //
     /* 2317439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317454 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2317457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317478 */     // GIR_Coverage, 54898,
     /* 2317478 */     GIR_EraseRootFromParent_Done,
     /* 2317479 */   // Label 31779: @2317479
     /* 2317479 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2317524), // Rule ID 54899 //
     /* 2317484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317499 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2317502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317523 */     // GIR_Coverage, 54899,
     /* 2317523 */     GIR_EraseRootFromParent_Done,
     /* 2317524 */   // Label 31780: @2317524
     /* 2317524 */   GIM_Reject,
     /* 2317525 */ // Label 31768: @2317525
     /* 2317525 */ GIM_Reject,
     /* 2317526 */ // Label 31636: @2317526
     /* 2317526 */ GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2318315),
     /* 2317531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2317537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2317540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317544 */   GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2317621), // Rule ID 55098 //
     /* 2317549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317592 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317620 */     // GIR_Coverage, 55098,
     /* 2317620 */     GIR_EraseRootFromParent_Done,
     /* 2317621 */   // Label 31782: @2317621
     /* 2317621 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2317698), // Rule ID 55099 //
     /* 2317626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317669 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317697 */     // GIR_Coverage, 55099,
     /* 2317697 */     GIR_EraseRootFromParent_Done,
     /* 2317698 */   // Label 31783: @2317698
     /* 2317698 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2317775), // Rule ID 72717 //
     /* 2317703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317746 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317774 */     // GIR_Coverage, 72717,
     /* 2317774 */     GIR_EraseRootFromParent_Done,
     /* 2317775 */   // Label 31784: @2317775
     /* 2317775 */   GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2317852), // Rule ID 72718 //
     /* 2317780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317823 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2317826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317851 */     // GIR_Coverage, 72718,
     /* 2317851 */     GIR_EraseRootFromParent_Done,
     /* 2317852 */   // Label 31785: @2317852
     /* 2317852 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2317914), // Rule ID 55102 //
     /* 2317857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317887 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2317890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317913 */     // GIR_Coverage, 55102,
     /* 2317913 */     GIR_EraseRootFromParent_Done,
     /* 2317914 */   // Label 31786: @2317914
     /* 2317914 */   GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2317976), // Rule ID 55103 //
     /* 2317919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2317922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317949 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2317952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317975 */     // GIR_Coverage, 55103,
     /* 2317975 */     GIR_EraseRootFromParent_Done,
     /* 2317976 */   // Label 31787: @2317976
     /* 2317976 */   GIM_Try, /*On fail goto*//*Label 31788*/ GIMT_Encode4(2318038), // Rule ID 72721 //
     /* 2317981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2317984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318011 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2318014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318037 */     // GIR_Coverage, 72721,
     /* 2318037 */     GIR_EraseRootFromParent_Done,
     /* 2318038 */   // Label 31788: @2318038
     /* 2318038 */   GIM_Try, /*On fail goto*//*Label 31789*/ GIMT_Encode4(2318100), // Rule ID 72722 //
     /* 2318043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318073 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2318076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318099 */     // GIR_Coverage, 72722,
     /* 2318099 */     GIR_EraseRootFromParent_Done,
     /* 2318100 */   // Label 31789: @2318100
     /* 2318100 */   GIM_Try, /*On fail goto*//*Label 31790*/ GIMT_Encode4(2318162), // Rule ID 55094 //
     /* 2318105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318135 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2318138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318161 */     // GIR_Coverage, 55094,
     /* 2318161 */     GIR_EraseRootFromParent_Done,
     /* 2318162 */   // Label 31790: @2318162
     /* 2318162 */   GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2318224), // Rule ID 55095 //
     /* 2318167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318197 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2318200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318223 */     // GIR_Coverage, 55095,
     /* 2318223 */     GIR_EraseRootFromParent_Done,
     /* 2318224 */   // Label 31791: @2318224
     /* 2318224 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2318269), // Rule ID 55090 //
     /* 2318229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318244 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2318247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318268 */     // GIR_Coverage, 55090,
     /* 2318268 */     GIR_EraseRootFromParent_Done,
     /* 2318269 */   // Label 31792: @2318269
     /* 2318269 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2318314), // Rule ID 55091 //
     /* 2318274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318289 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2318292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318313 */     // GIR_Coverage, 55091,
     /* 2318313 */     GIR_EraseRootFromParent_Done,
     /* 2318314 */   // Label 31793: @2318314
     /* 2318314 */   GIM_Reject,
     /* 2318315 */ // Label 31781: @2318315
     /* 2318315 */ GIM_Reject,
     /* 2318316 */ // Label 31637: @2318316
     /* 2318316 */ GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2319105),
     /* 2318321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2318327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2318330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318334 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2318411), // Rule ID 55610 //
     /* 2318339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318382 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318410 */     // GIR_Coverage, 55610,
     /* 2318410 */     GIR_EraseRootFromParent_Done,
     /* 2318411 */   // Label 31795: @2318411
     /* 2318411 */   GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2318488), // Rule ID 55611 //
     /* 2318416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318459 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318487 */     // GIR_Coverage, 55611,
     /* 2318487 */     GIR_EraseRootFromParent_Done,
     /* 2318488 */   // Label 31796: @2318488
     /* 2318488 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2318565), // Rule ID 73165 //
     /* 2318493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318536 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318564 */     // GIR_Coverage, 73165,
     /* 2318564 */     GIR_EraseRootFromParent_Done,
     /* 2318565 */   // Label 31797: @2318565
     /* 2318565 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2318642), // Rule ID 73166 //
     /* 2318570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318613 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2318616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318641 */     // GIR_Coverage, 73166,
     /* 2318641 */     GIR_EraseRootFromParent_Done,
     /* 2318642 */   // Label 31798: @2318642
     /* 2318642 */   GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2318704), // Rule ID 55614 //
     /* 2318647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318677 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318703 */     // GIR_Coverage, 55614,
     /* 2318703 */     GIR_EraseRootFromParent_Done,
     /* 2318704 */   // Label 31799: @2318704
     /* 2318704 */   GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2318766), // Rule ID 55615 //
     /* 2318709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318739 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318765 */     // GIR_Coverage, 55615,
     /* 2318765 */     GIR_EraseRootFromParent_Done,
     /* 2318766 */   // Label 31800: @2318766
     /* 2318766 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2318828), // Rule ID 73169 //
     /* 2318771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318801 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318827 */     // GIR_Coverage, 73169,
     /* 2318827 */     GIR_EraseRootFromParent_Done,
     /* 2318828 */   // Label 31801: @2318828
     /* 2318828 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2318890), // Rule ID 73170 //
     /* 2318833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318863 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2318866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318889 */     // GIR_Coverage, 73170,
     /* 2318889 */     GIR_EraseRootFromParent_Done,
     /* 2318890 */   // Label 31802: @2318890
     /* 2318890 */   GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2318952), // Rule ID 55606 //
     /* 2318895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2318898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318925 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2318928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318951 */     // GIR_Coverage, 55606,
     /* 2318951 */     GIR_EraseRootFromParent_Done,
     /* 2318952 */   // Label 31803: @2318952
     /* 2318952 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2319014), // Rule ID 55607 //
     /* 2318957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2318960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318987 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2318990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319013 */     // GIR_Coverage, 55607,
     /* 2319013 */     GIR_EraseRootFromParent_Done,
     /* 2319014 */   // Label 31804: @2319014
     /* 2319014 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2319059), // Rule ID 55602 //
     /* 2319019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2319022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319034 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2319037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319058 */     // GIR_Coverage, 55602,
     /* 2319058 */     GIR_EraseRootFromParent_Done,
     /* 2319059 */   // Label 31805: @2319059
     /* 2319059 */   GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2319104), // Rule ID 55603 //
     /* 2319064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2319067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319079 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2319082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319103 */     // GIR_Coverage, 55603,
     /* 2319103 */     GIR_EraseRootFromParent_Done,
     /* 2319104 */   // Label 31806: @2319104
     /* 2319104 */   GIM_Reject,
     /* 2319105 */ // Label 31794: @2319105
     /* 2319105 */ GIM_Reject,
     /* 2319106 */ // Label 31638: @2319106
     /* 2319106 */ GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2319895),
     /* 2319111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2319117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2319120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319124 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2319201), // Rule ID 55034 //
     /* 2319129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319172 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319200 */     // GIR_Coverage, 55034,
     /* 2319200 */     GIR_EraseRootFromParent_Done,
     /* 2319201 */   // Label 31808: @2319201
     /* 2319201 */   GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2319278), // Rule ID 55035 //
     /* 2319206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319249 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319277 */     // GIR_Coverage, 55035,
     /* 2319277 */     GIR_EraseRootFromParent_Done,
     /* 2319278 */   // Label 31809: @2319278
     /* 2319278 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2319355), // Rule ID 72661 //
     /* 2319283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319326 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319354 */     // GIR_Coverage, 72661,
     /* 2319354 */     GIR_EraseRootFromParent_Done,
     /* 2319355 */   // Label 31810: @2319355
     /* 2319355 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2319432), // Rule ID 72662 //
     /* 2319360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319403 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2319406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319431 */     // GIR_Coverage, 72662,
     /* 2319431 */     GIR_EraseRootFromParent_Done,
     /* 2319432 */   // Label 31811: @2319432
     /* 2319432 */   GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2319494), // Rule ID 55038 //
     /* 2319437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319467 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319493 */     // GIR_Coverage, 55038,
     /* 2319493 */     GIR_EraseRootFromParent_Done,
     /* 2319494 */   // Label 31812: @2319494
     /* 2319494 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2319556), // Rule ID 55039 //
     /* 2319499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319529 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319555 */     // GIR_Coverage, 55039,
     /* 2319555 */     GIR_EraseRootFromParent_Done,
     /* 2319556 */   // Label 31813: @2319556
     /* 2319556 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2319618), // Rule ID 72665 //
     /* 2319561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319591 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319617 */     // GIR_Coverage, 72665,
     /* 2319617 */     GIR_EraseRootFromParent_Done,
     /* 2319618 */   // Label 31814: @2319618
     /* 2319618 */   GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2319680), // Rule ID 72666 //
     /* 2319623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319653 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2319656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319679 */     // GIR_Coverage, 72666,
     /* 2319679 */     GIR_EraseRootFromParent_Done,
     /* 2319680 */   // Label 31815: @2319680
     /* 2319680 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2319742), // Rule ID 55030 //
     /* 2319685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319715 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2319718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319741 */     // GIR_Coverage, 55030,
     /* 2319741 */     GIR_EraseRootFromParent_Done,
     /* 2319742 */   // Label 31816: @2319742
     /* 2319742 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2319804), // Rule ID 55031 //
     /* 2319747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2319770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319777 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2319780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319803 */     // GIR_Coverage, 55031,
     /* 2319803 */     GIR_EraseRootFromParent_Done,
     /* 2319804 */   // Label 31817: @2319804
     /* 2319804 */   GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2319849), // Rule ID 55026 //
     /* 2319809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319824 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2319827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319848 */     // GIR_Coverage, 55026,
     /* 2319848 */     GIR_EraseRootFromParent_Done,
     /* 2319849 */   // Label 31818: @2319849
     /* 2319849 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2319894), // Rule ID 55027 //
     /* 2319854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319869 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2319872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319893 */     // GIR_Coverage, 55027,
     /* 2319893 */     GIR_EraseRootFromParent_Done,
     /* 2319894 */   // Label 31819: @2319894
     /* 2319894 */   GIM_Reject,
     /* 2319895 */ // Label 31807: @2319895
     /* 2319895 */ GIM_Reject,
     /* 2319896 */ // Label 31639: @2319896
     /* 2319896 */ GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2320685),
     /* 2319901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2319907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2319910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319914 */   GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2319991), // Rule ID 55418 //
     /* 2319919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319962 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2319965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319990 */     // GIR_Coverage, 55418,
     /* 2319990 */     GIR_EraseRootFromParent_Done,
     /* 2319991 */   // Label 31821: @2319991
     /* 2319991 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2320068), // Rule ID 55419 //
     /* 2319996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320039 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320067 */     // GIR_Coverage, 55419,
     /* 2320067 */     GIR_EraseRootFromParent_Done,
     /* 2320068 */   // Label 31822: @2320068
     /* 2320068 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2320145), // Rule ID 72997 //
     /* 2320073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320116 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320144 */     // GIR_Coverage, 72997,
     /* 2320144 */     GIR_EraseRootFromParent_Done,
     /* 2320145 */   // Label 31823: @2320145
     /* 2320145 */   GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2320222), // Rule ID 72998 //
     /* 2320150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320193 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2320196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320221 */     // GIR_Coverage, 72998,
     /* 2320221 */     GIR_EraseRootFromParent_Done,
     /* 2320222 */   // Label 31824: @2320222
     /* 2320222 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2320284), // Rule ID 55422 //
     /* 2320227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320257 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320283 */     // GIR_Coverage, 55422,
     /* 2320283 */     GIR_EraseRootFromParent_Done,
     /* 2320284 */   // Label 31825: @2320284
     /* 2320284 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2320346), // Rule ID 55423 //
     /* 2320289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320319 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320345 */     // GIR_Coverage, 55423,
     /* 2320345 */     GIR_EraseRootFromParent_Done,
     /* 2320346 */   // Label 31826: @2320346
     /* 2320346 */   GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2320408), // Rule ID 73001 //
     /* 2320351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320381 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320407 */     // GIR_Coverage, 73001,
     /* 2320407 */     GIR_EraseRootFromParent_Done,
     /* 2320408 */   // Label 31827: @2320408
     /* 2320408 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2320470), // Rule ID 73002 //
     /* 2320413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320443 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2320446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320469 */     // GIR_Coverage, 73002,
     /* 2320469 */     GIR_EraseRootFromParent_Done,
     /* 2320470 */   // Label 31828: @2320470
     /* 2320470 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2320532), // Rule ID 55414 //
     /* 2320475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320505 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2320508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320531 */     // GIR_Coverage, 55414,
     /* 2320531 */     GIR_EraseRootFromParent_Done,
     /* 2320532 */   // Label 31829: @2320532
     /* 2320532 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2320594), // Rule ID 55415 //
     /* 2320537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2320552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2320560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2320567 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2320570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2320580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320593 */     // GIR_Coverage, 55415,
     /* 2320593 */     GIR_EraseRootFromParent_Done,
     /* 2320594 */   // Label 31830: @2320594
     /* 2320594 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2320639), // Rule ID 55410 //
     /* 2320599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320614 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2320617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320638 */     // GIR_Coverage, 55410,
     /* 2320638 */     GIR_EraseRootFromParent_Done,
     /* 2320639 */   // Label 31831: @2320639
     /* 2320639 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2320684), // Rule ID 55411 //
     /* 2320644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320659 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2320662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320683 */     // GIR_Coverage, 55411,
     /* 2320683 */     GIR_EraseRootFromParent_Done,
     /* 2320684 */   // Label 31832: @2320684
     /* 2320684 */   GIM_Reject,
     /* 2320685 */ // Label 31820: @2320685
     /* 2320685 */ GIM_Reject,
     /* 2320686 */ // Label 31640: @2320686
     /* 2320686 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2321475),
     /* 2320691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2320697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2320700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320704 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2320781), // Rule ID 55674 //
     /* 2320709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320752 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320780 */     // GIR_Coverage, 55674,
     /* 2320780 */     GIR_EraseRootFromParent_Done,
     /* 2320781 */   // Label 31834: @2320781
     /* 2320781 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2320858), // Rule ID 55675 //
     /* 2320786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320829 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320857 */     // GIR_Coverage, 55675,
     /* 2320857 */     GIR_EraseRootFromParent_Done,
     /* 2320858 */   // Label 31835: @2320858
     /* 2320858 */   GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2320935), // Rule ID 73221 //
     /* 2320863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320906 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2320906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320934 */     // GIR_Coverage, 73221,
     /* 2320934 */     GIR_EraseRootFromParent_Done,
     /* 2320935 */   // Label 31836: @2320935
     /* 2320935 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2321012), // Rule ID 73222 //
     /* 2320940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2320943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2320951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2320968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2320972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2320976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2320983 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2320986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2320990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2320994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2320998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321011 */     // GIR_Coverage, 73222,
     /* 2321011 */     GIR_EraseRootFromParent_Done,
     /* 2321012 */   // Label 31837: @2321012
     /* 2321012 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2321074), // Rule ID 55678 //
     /* 2321017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321047 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321073 */     // GIR_Coverage, 55678,
     /* 2321073 */     GIR_EraseRootFromParent_Done,
     /* 2321074 */   // Label 31838: @2321074
     /* 2321074 */   GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2321136), // Rule ID 55679 //
     /* 2321079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321109 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321135 */     // GIR_Coverage, 55679,
     /* 2321135 */     GIR_EraseRootFromParent_Done,
     /* 2321136 */   // Label 31839: @2321136
     /* 2321136 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2321198), // Rule ID 73225 //
     /* 2321141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321171 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321197 */     // GIR_Coverage, 73225,
     /* 2321197 */     GIR_EraseRootFromParent_Done,
     /* 2321198 */   // Label 31840: @2321198
     /* 2321198 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2321260), // Rule ID 73226 //
     /* 2321203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321233 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2321236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321259 */     // GIR_Coverage, 73226,
     /* 2321259 */     GIR_EraseRootFromParent_Done,
     /* 2321260 */   // Label 31841: @2321260
     /* 2321260 */   GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2321322), // Rule ID 55670 //
     /* 2321265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321295 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2321298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321321 */     // GIR_Coverage, 55670,
     /* 2321321 */     GIR_EraseRootFromParent_Done,
     /* 2321322 */   // Label 31842: @2321322
     /* 2321322 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2321384), // Rule ID 55671 //
     /* 2321327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2321342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321357 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2321360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2321370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321383 */     // GIR_Coverage, 55671,
     /* 2321383 */     GIR_EraseRootFromParent_Done,
     /* 2321384 */   // Label 31843: @2321384
     /* 2321384 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2321429), // Rule ID 55666 //
     /* 2321389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321404 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2321407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321428 */     // GIR_Coverage, 55666,
     /* 2321428 */     GIR_EraseRootFromParent_Done,
     /* 2321429 */   // Label 31844: @2321429
     /* 2321429 */   GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2321474), // Rule ID 55667 //
     /* 2321434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321449 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2321452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321473 */     // GIR_Coverage, 55667,
     /* 2321473 */     GIR_EraseRootFromParent_Done,
     /* 2321474 */   // Label 31845: @2321474
     /* 2321474 */   GIM_Reject,
     /* 2321475 */ // Label 31833: @2321475
     /* 2321475 */ GIM_Reject,
     /* 2321476 */ // Label 31641: @2321476
     /* 2321476 */ GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2322265),
     /* 2321481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2321487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2321490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321494 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2321571), // Rule ID 55226 //
     /* 2321499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321535 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321542 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321570 */     // GIR_Coverage, 55226,
     /* 2321570 */     GIR_EraseRootFromParent_Done,
     /* 2321571 */   // Label 31847: @2321571
     /* 2321571 */   GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2321648), // Rule ID 55227 //
     /* 2321576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321619 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321647 */     // GIR_Coverage, 55227,
     /* 2321647 */     GIR_EraseRootFromParent_Done,
     /* 2321648 */   // Label 31848: @2321648
     /* 2321648 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2321725), // Rule ID 72829 //
     /* 2321653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321696 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321724 */     // GIR_Coverage, 72829,
     /* 2321724 */     GIR_EraseRootFromParent_Done,
     /* 2321725 */   // Label 31849: @2321725
     /* 2321725 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2321802), // Rule ID 72830 //
     /* 2321730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2321758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2321773 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2321776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2321788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321801 */     // GIR_Coverage, 72830,
     /* 2321801 */     GIR_EraseRootFromParent_Done,
     /* 2321802 */   // Label 31850: @2321802
     /* 2321802 */   GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2321864), // Rule ID 55230 //
     /* 2321807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321837 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321863 */     // GIR_Coverage, 55230,
     /* 2321863 */     GIR_EraseRootFromParent_Done,
     /* 2321864 */   // Label 31851: @2321864
     /* 2321864 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2321926), // Rule ID 55231 //
     /* 2321869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2321876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321899 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2321899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2321906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321925 */     // GIR_Coverage, 55231,
     /* 2321925 */     GIR_EraseRootFromParent_Done,
     /* 2321926 */   // Label 31852: @2321926
     /* 2321926 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2321988), // Rule ID 72833 //
     /* 2321931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2321942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2321946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2321961 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2321961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2321964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2321968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2321972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2321974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321987 */     // GIR_Coverage, 72833,
     /* 2321987 */     GIR_EraseRootFromParent_Done,
     /* 2321988 */   // Label 31853: @2321988
     /* 2321988 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2322050), // Rule ID 72834 //
     /* 2321993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322023 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2322026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322049 */     // GIR_Coverage, 72834,
     /* 2322049 */     GIR_EraseRootFromParent_Done,
     /* 2322050 */   // Label 31854: @2322050
     /* 2322050 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2322112), // Rule ID 55222 //
     /* 2322055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322085 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2322088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322111 */     // GIR_Coverage, 55222,
     /* 2322111 */     GIR_EraseRootFromParent_Done,
     /* 2322112 */   // Label 31855: @2322112
     /* 2322112 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2322174), // Rule ID 55223 //
     /* 2322117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2322140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322147 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2322150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322173 */     // GIR_Coverage, 55223,
     /* 2322173 */     GIR_EraseRootFromParent_Done,
     /* 2322174 */   // Label 31856: @2322174
     /* 2322174 */   GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2322219), // Rule ID 55218 //
     /* 2322179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322194 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2322197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322218 */     // GIR_Coverage, 55218,
     /* 2322218 */     GIR_EraseRootFromParent_Done,
     /* 2322219 */   // Label 31857: @2322219
     /* 2322219 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2322264), // Rule ID 55219 //
     /* 2322224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322239 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2322242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322263 */     // GIR_Coverage, 55219,
     /* 2322263 */     GIR_EraseRootFromParent_Done,
     /* 2322264 */   // Label 31858: @2322264
     /* 2322264 */   GIM_Reject,
     /* 2322265 */ // Label 31846: @2322265
     /* 2322265 */ GIM_Reject,
     /* 2322266 */ // Label 31642: @2322266
     /* 2322266 */ GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2323055),
     /* 2322271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2322277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2322280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322284 */   GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2322361), // Rule ID 55482 //
     /* 2322289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322332 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322360 */     // GIR_Coverage, 55482,
     /* 2322360 */     GIR_EraseRootFromParent_Done,
     /* 2322361 */   // Label 31860: @2322361
     /* 2322361 */   GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2322438), // Rule ID 55483 //
     /* 2322366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322409 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322437 */     // GIR_Coverage, 55483,
     /* 2322437 */     GIR_EraseRootFromParent_Done,
     /* 2322438 */   // Label 31861: @2322438
     /* 2322438 */   GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2322515), // Rule ID 73053 //
     /* 2322443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322486 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322514 */     // GIR_Coverage, 73053,
     /* 2322514 */     GIR_EraseRootFromParent_Done,
     /* 2322515 */   // Label 31862: @2322515
     /* 2322515 */   GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2322592), // Rule ID 73054 //
     /* 2322520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2322548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2322563 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2322566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2322578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322591 */     // GIR_Coverage, 73054,
     /* 2322591 */     GIR_EraseRootFromParent_Done,
     /* 2322592 */   // Label 31863: @2322592
     /* 2322592 */   GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2322654), // Rule ID 55486 //
     /* 2322597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322627 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322653 */     // GIR_Coverage, 55486,
     /* 2322653 */     GIR_EraseRootFromParent_Done,
     /* 2322654 */   // Label 31864: @2322654
     /* 2322654 */   GIM_Try, /*On fail goto*//*Label 31865*/ GIMT_Encode4(2322716), // Rule ID 55487 //
     /* 2322659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2322666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322689 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322715 */     // GIR_Coverage, 55487,
     /* 2322715 */     GIR_EraseRootFromParent_Done,
     /* 2322716 */   // Label 31865: @2322716
     /* 2322716 */   GIM_Try, /*On fail goto*//*Label 31866*/ GIMT_Encode4(2322778), // Rule ID 73057 //
     /* 2322721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322751 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322777 */     // GIR_Coverage, 73057,
     /* 2322777 */     GIR_EraseRootFromParent_Done,
     /* 2322778 */   // Label 31866: @2322778
     /* 2322778 */   GIM_Try, /*On fail goto*//*Label 31867*/ GIMT_Encode4(2322840), // Rule ID 73058 //
     /* 2322783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2322794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322813 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2322816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2322820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2322824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322839 */     // GIR_Coverage, 73058,
     /* 2322839 */     GIR_EraseRootFromParent_Done,
     /* 2322840 */   // Label 31867: @2322840
     /* 2322840 */   GIM_Try, /*On fail goto*//*Label 31868*/ GIMT_Encode4(2322902), // Rule ID 55478 //
     /* 2322845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322875 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2322878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322901 */     // GIR_Coverage, 55478,
     /* 2322901 */     GIR_EraseRootFromParent_Done,
     /* 2322902 */   // Label 31868: @2322902
     /* 2322902 */   GIM_Try, /*On fail goto*//*Label 31869*/ GIMT_Encode4(2322964), // Rule ID 55479 //
     /* 2322907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2322922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2322926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2322930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2322937 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2322937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2322940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2322950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2322962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322963 */     // GIR_Coverage, 55479,
     /* 2322963 */     GIR_EraseRootFromParent_Done,
     /* 2322964 */   // Label 31869: @2322964
     /* 2322964 */   GIM_Try, /*On fail goto*//*Label 31870*/ GIMT_Encode4(2323009), // Rule ID 55474 //
     /* 2322969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322984 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2322984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2322987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2322991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2322995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323008 */     // GIR_Coverage, 55474,
     /* 2323008 */     GIR_EraseRootFromParent_Done,
     /* 2323009 */   // Label 31870: @2323009
     /* 2323009 */   GIM_Try, /*On fail goto*//*Label 31871*/ GIMT_Encode4(2323054), // Rule ID 55475 //
     /* 2323014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323029 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2323032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323053 */     // GIR_Coverage, 55475,
     /* 2323053 */     GIR_EraseRootFromParent_Done,
     /* 2323054 */   // Label 31871: @2323054
     /* 2323054 */   GIM_Reject,
     /* 2323055 */ // Label 31859: @2323055
     /* 2323055 */ GIM_Reject,
     /* 2323056 */ // Label 31643: @2323056
     /* 2323056 */ GIM_Try, /*On fail goto*//*Label 31872*/ GIMT_Encode4(2323845),
     /* 2323061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2323067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2323070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323074 */   GIM_Try, /*On fail goto*//*Label 31873*/ GIMT_Encode4(2323151), // Rule ID 55738 //
     /* 2323079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323122 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323150 */     // GIR_Coverage, 55738,
     /* 2323150 */     GIR_EraseRootFromParent_Done,
     /* 2323151 */   // Label 31873: @2323151
     /* 2323151 */   GIM_Try, /*On fail goto*//*Label 31874*/ GIMT_Encode4(2323228), // Rule ID 55739 //
     /* 2323156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323199 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323227 */     // GIR_Coverage, 55739,
     /* 2323227 */     GIR_EraseRootFromParent_Done,
     /* 2323228 */   // Label 31874: @2323228
     /* 2323228 */   GIM_Try, /*On fail goto*//*Label 31875*/ GIMT_Encode4(2323305), // Rule ID 73277 //
     /* 2323233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323276 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323304 */     // GIR_Coverage, 73277,
     /* 2323304 */     GIR_EraseRootFromParent_Done,
     /* 2323305 */   // Label 31875: @2323305
     /* 2323305 */   GIM_Try, /*On fail goto*//*Label 31876*/ GIMT_Encode4(2323382), // Rule ID 73278 //
     /* 2323310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323353 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2323356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323381 */     // GIR_Coverage, 73278,
     /* 2323381 */     GIR_EraseRootFromParent_Done,
     /* 2323382 */   // Label 31876: @2323382
     /* 2323382 */   GIM_Try, /*On fail goto*//*Label 31877*/ GIMT_Encode4(2323444), // Rule ID 55742 //
     /* 2323387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323417 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323443 */     // GIR_Coverage, 55742,
     /* 2323443 */     GIR_EraseRootFromParent_Done,
     /* 2323444 */   // Label 31877: @2323444
     /* 2323444 */   GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2323506), // Rule ID 55743 //
     /* 2323449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323479 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323505 */     // GIR_Coverage, 55743,
     /* 2323505 */     GIR_EraseRootFromParent_Done,
     /* 2323506 */   // Label 31878: @2323506
     /* 2323506 */   GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2323568), // Rule ID 73281 //
     /* 2323511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323541 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323567 */     // GIR_Coverage, 73281,
     /* 2323567 */     GIR_EraseRootFromParent_Done,
     /* 2323568 */   // Label 31879: @2323568
     /* 2323568 */   GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2323630), // Rule ID 73282 //
     /* 2323573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2323584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323603 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2323606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2323610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323629 */     // GIR_Coverage, 73282,
     /* 2323629 */     GIR_EraseRootFromParent_Done,
     /* 2323630 */   // Label 31880: @2323630
     /* 2323630 */   GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2323692), // Rule ID 55734 //
     /* 2323635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323665 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2323668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2323678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323691 */     // GIR_Coverage, 55734,
     /* 2323691 */     GIR_EraseRootFromParent_Done,
     /* 2323692 */   // Label 31881: @2323692
     /* 2323692 */   GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2323754), // Rule ID 55735 //
     /* 2323697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2323712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2323720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2323727 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2323730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2323740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323753 */     // GIR_Coverage, 55735,
     /* 2323753 */     GIR_EraseRootFromParent_Done,
     /* 2323754 */   // Label 31882: @2323754
     /* 2323754 */   GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2323799), // Rule ID 55730 //
     /* 2323759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323774 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2323777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323798 */     // GIR_Coverage, 55730,
     /* 2323798 */     GIR_EraseRootFromParent_Done,
     /* 2323799 */   // Label 31883: @2323799
     /* 2323799 */   GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2323844), // Rule ID 55731 //
     /* 2323804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2323819 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2323822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2323830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323843 */     // GIR_Coverage, 55731,
     /* 2323843 */     GIR_EraseRootFromParent_Done,
     /* 2323844 */   // Label 31884: @2323844
     /* 2323844 */   GIM_Reject,
     /* 2323845 */ // Label 31872: @2323845
     /* 2323845 */ GIM_Reject,
     /* 2323846 */ // Label 31644: @2323846
     /* 2323846 */ GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2324635),
     /* 2323851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2323857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2323860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323864 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2323941), // Rule ID 55290 //
     /* 2323869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323912 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2323912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2323915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2323923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2323927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2323939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323940 */     // GIR_Coverage, 55290,
     /* 2323940 */     GIR_EraseRootFromParent_Done,
     /* 2323941 */   // Label 31886: @2323941
     /* 2323941 */   GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2324018), // Rule ID 55291 //
     /* 2323946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2323953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2323974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2323978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2323982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2323989 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2323989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2323992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2323996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324017 */     // GIR_Coverage, 55291,
     /* 2324017 */     GIR_EraseRootFromParent_Done,
     /* 2324018 */   // Label 31887: @2324018
     /* 2324018 */   GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2324095), // Rule ID 72885 //
     /* 2324023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324066 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2324069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324094 */     // GIR_Coverage, 72885,
     /* 2324094 */     GIR_EraseRootFromParent_Done,
     /* 2324095 */   // Label 31888: @2324095
     /* 2324095 */   GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2324172), // Rule ID 72886 //
     /* 2324100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324143 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2324146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324171 */     // GIR_Coverage, 72886,
     /* 2324171 */     GIR_EraseRootFromParent_Done,
     /* 2324172 */   // Label 31889: @2324172
     /* 2324172 */   GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2324234), // Rule ID 55294 //
     /* 2324177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324207 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324233 */     // GIR_Coverage, 55294,
     /* 2324233 */     GIR_EraseRootFromParent_Done,
     /* 2324234 */   // Label 31890: @2324234
     /* 2324234 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2324296), // Rule ID 55295 //
     /* 2324239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324269 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324295 */     // GIR_Coverage, 55295,
     /* 2324295 */     GIR_EraseRootFromParent_Done,
     /* 2324296 */   // Label 31891: @2324296
     /* 2324296 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2324358), // Rule ID 72889 //
     /* 2324301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324331 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324357 */     // GIR_Coverage, 72889,
     /* 2324357 */     GIR_EraseRootFromParent_Done,
     /* 2324358 */   // Label 31892: @2324358
     /* 2324358 */   GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2324420), // Rule ID 72890 //
     /* 2324363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324393 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2324396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324419 */     // GIR_Coverage, 72890,
     /* 2324419 */     GIR_EraseRootFromParent_Done,
     /* 2324420 */   // Label 31893: @2324420
     /* 2324420 */   GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2324482), // Rule ID 55286 //
     /* 2324425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324455 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2324458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2324468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324481 */     // GIR_Coverage, 55286,
     /* 2324481 */     GIR_EraseRootFromParent_Done,
     /* 2324482 */   // Label 31894: @2324482
     /* 2324482 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2324544), // Rule ID 55287 //
     /* 2324487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2324502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324517 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2324520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2324530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324543 */     // GIR_Coverage, 55287,
     /* 2324543 */     GIR_EraseRootFromParent_Done,
     /* 2324544 */   // Label 31895: @2324544
     /* 2324544 */   GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2324589), // Rule ID 55282 //
     /* 2324549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324564 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2324567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324588 */     // GIR_Coverage, 55282,
     /* 2324588 */     GIR_EraseRootFromParent_Done,
     /* 2324589 */   // Label 31896: @2324589
     /* 2324589 */   GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2324634), // Rule ID 55283 //
     /* 2324594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324609 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2324612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2324620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324633 */     // GIR_Coverage, 55283,
     /* 2324633 */     GIR_EraseRootFromParent_Done,
     /* 2324634 */   // Label 31897: @2324634
     /* 2324634 */   GIM_Reject,
     /* 2324635 */ // Label 31885: @2324635
     /* 2324635 */ GIM_Reject,
     /* 2324636 */ // Label 31645: @2324636
     /* 2324636 */ GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2325425),
     /* 2324641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2324647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2324650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324654 */   GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2324731), // Rule ID 55546 //
     /* 2324659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324702 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324730 */     // GIR_Coverage, 55546,
     /* 2324730 */     GIR_EraseRootFromParent_Done,
     /* 2324731 */   // Label 31899: @2324731
     /* 2324731 */   GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2324808), // Rule ID 55547 //
     /* 2324736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324779 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2324786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324807 */     // GIR_Coverage, 55547,
     /* 2324807 */     GIR_EraseRootFromParent_Done,
     /* 2324808 */   // Label 31900: @2324808
     /* 2324808 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2324885), // Rule ID 73109 //
     /* 2324813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324856 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324884 */     // GIR_Coverage, 73109,
     /* 2324884 */     GIR_EraseRootFromParent_Done,
     /* 2324885 */   // Label 31901: @2324885
     /* 2324885 */   GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2324962), // Rule ID 73110 //
     /* 2324890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2324901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2324918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2324933 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2324933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2324936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2324940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2324944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2324948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2324960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324961 */     // GIR_Coverage, 73110,
     /* 2324961 */     GIR_EraseRootFromParent_Done,
     /* 2324962 */   // Label 31902: @2324962
     /* 2324962 */   GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2325024), // Rule ID 55550 //
     /* 2324967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2324978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2324997 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2324997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325023 */     // GIR_Coverage, 55550,
     /* 2325023 */     GIR_EraseRootFromParent_Done,
     /* 2325024 */   // Label 31903: @2325024
     /* 2325024 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2325086), // Rule ID 55551 //
     /* 2325029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325059 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325085 */     // GIR_Coverage, 55551,
     /* 2325085 */     GIR_EraseRootFromParent_Done,
     /* 2325086 */   // Label 31904: @2325086
     /* 2325086 */   GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2325148), // Rule ID 73113 //
     /* 2325091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325121 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325147 */     // GIR_Coverage, 73113,
     /* 2325147 */     GIR_EraseRootFromParent_Done,
     /* 2325148 */   // Label 31905: @2325148
     /* 2325148 */   GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2325210), // Rule ID 73114 //
     /* 2325153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325183 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2325186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325209 */     // GIR_Coverage, 73114,
     /* 2325209 */     GIR_EraseRootFromParent_Done,
     /* 2325210 */   // Label 31906: @2325210
     /* 2325210 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2325272), // Rule ID 55542 //
     /* 2325215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325245 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2325248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2325258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325271 */     // GIR_Coverage, 55542,
     /* 2325271 */     GIR_EraseRootFromParent_Done,
     /* 2325272 */   // Label 31907: @2325272
     /* 2325272 */   GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2325334), // Rule ID 55543 //
     /* 2325277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2325292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325307 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2325310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2325320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325333 */     // GIR_Coverage, 55543,
     /* 2325333 */     GIR_EraseRootFromParent_Done,
     /* 2325334 */   // Label 31908: @2325334
     /* 2325334 */   GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2325379), // Rule ID 55538 //
     /* 2325339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2325342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325354 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2325357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325378 */     // GIR_Coverage, 55538,
     /* 2325378 */     GIR_EraseRootFromParent_Done,
     /* 2325379 */   // Label 31909: @2325379
     /* 2325379 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2325424), // Rule ID 55539 //
     /* 2325384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2325387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325399 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2325402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325423 */     // GIR_Coverage, 55539,
     /* 2325423 */     GIR_EraseRootFromParent_Done,
     /* 2325424 */   // Label 31910: @2325424
     /* 2325424 */   GIM_Reject,
     /* 2325425 */ // Label 31898: @2325425
     /* 2325425 */ GIM_Reject,
     /* 2325426 */ // Label 31646: @2325426
     /* 2325426 */ GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2326215),
     /* 2325431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2325437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2325440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325444 */   GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2325521), // Rule ID 55354 //
     /* 2325449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325492 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325520 */     // GIR_Coverage, 55354,
     /* 2325520 */     GIR_EraseRootFromParent_Done,
     /* 2325521 */   // Label 31912: @2325521
     /* 2325521 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2325598), // Rule ID 55355 //
     /* 2325526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325569 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325597 */     // GIR_Coverage, 55355,
     /* 2325597 */     GIR_EraseRootFromParent_Done,
     /* 2325598 */   // Label 31913: @2325598
     /* 2325598 */   GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2325675), // Rule ID 72941 //
     /* 2325603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325646 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325674 */     // GIR_Coverage, 72941,
     /* 2325674 */     GIR_EraseRootFromParent_Done,
     /* 2325675 */   // Label 31914: @2325675
     /* 2325675 */   GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2325752), // Rule ID 72942 //
     /* 2325680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2325708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2325723 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2325726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2325738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325751 */     // GIR_Coverage, 72942,
     /* 2325751 */     GIR_EraseRootFromParent_Done,
     /* 2325752 */   // Label 31915: @2325752
     /* 2325752 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2325814), // Rule ID 55358 //
     /* 2325757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325787 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325813 */     // GIR_Coverage, 55358,
     /* 2325813 */     GIR_EraseRootFromParent_Done,
     /* 2325814 */   // Label 31916: @2325814
     /* 2325814 */   GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2325876), // Rule ID 55359 //
     /* 2325819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2325826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325849 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2325856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325875 */     // GIR_Coverage, 55359,
     /* 2325875 */     GIR_EraseRootFromParent_Done,
     /* 2325876 */   // Label 31917: @2325876
     /* 2325876 */   GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2325938), // Rule ID 72945 //
     /* 2325881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2325884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325911 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2325911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325937 */     // GIR_Coverage, 72945,
     /* 2325937 */     GIR_EraseRootFromParent_Done,
     /* 2325938 */   // Label 31918: @2325938
     /* 2325938 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2326000), // Rule ID 72946 //
     /* 2325943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2325946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2325954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2325958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2325973 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2325973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2325976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2325980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2325984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2325986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2325998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325999 */     // GIR_Coverage, 72946,
     /* 2325999 */     GIR_EraseRootFromParent_Done,
     /* 2326000 */   // Label 31919: @2326000
     /* 2326000 */   GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2326062), // Rule ID 55350 //
     /* 2326005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2326024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326035 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2326035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2326038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2326048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326061 */     // GIR_Coverage, 55350,
     /* 2326061 */     GIR_EraseRootFromParent_Done,
     /* 2326062 */   // Label 31920: @2326062
     /* 2326062 */   GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2326124), // Rule ID 55351 //
     /* 2326067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2326082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2326086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2326097 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2326097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2326100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2326110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326123 */     // GIR_Coverage, 55351,
     /* 2326123 */     GIR_EraseRootFromParent_Done,
     /* 2326124 */   // Label 31921: @2326124
     /* 2326124 */   GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2326169), // Rule ID 55346 //
     /* 2326129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326144 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2326144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2326147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326168 */     // GIR_Coverage, 55346,
     /* 2326168 */     GIR_EraseRootFromParent_Done,
     /* 2326169 */   // Label 31922: @2326169
     /* 2326169 */   GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2326214), // Rule ID 55347 //
     /* 2326174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326189 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2326189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2326192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2326196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2326200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326213 */     // GIR_Coverage, 55347,
     /* 2326213 */     GIR_EraseRootFromParent_Done,
     /* 2326214 */   // Label 31923: @2326214
     /* 2326214 */   GIM_Reject,
     /* 2326215 */ // Label 31911: @2326215
     /* 2326215 */ GIM_Reject,
     /* 2326216 */ // Label 31647: @2326216
     /* 2326216 */ GIM_Reject,
     /* 2326217 */ // Label 63: @2326217
     /* 2326217 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31942*/ GIMT_Encode4(2328644),
     /* 2326228 */ /*GILLT_s16*//*Label 31924*/ GIMT_Encode4(2326348),
     /* 2326232 */ /*GILLT_s32*//*Label 31925*/ GIMT_Encode4(2326497),
     /* 2326236 */ /*GILLT_s64*//*Label 31926*/ GIMT_Encode4(2326646), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326248 */ /*GILLT_nxv1s16*//*Label 31927*/ GIMT_Encode4(2326829),
     /* 2326252 */ /*GILLT_nxv1s32*//*Label 31928*/ GIMT_Encode4(2326950),
     /* 2326256 */ /*GILLT_nxv1s64*//*Label 31929*/ GIMT_Encode4(2327071), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326268 */ /*GILLT_nxv2s16*//*Label 31930*/ GIMT_Encode4(2327192),
     /* 2326272 */ /*GILLT_nxv2s32*//*Label 31931*/ GIMT_Encode4(2327313),
     /* 2326276 */ /*GILLT_nxv2s64*//*Label 31932*/ GIMT_Encode4(2327434), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326288 */ /*GILLT_nxv4s16*//*Label 31933*/ GIMT_Encode4(2327555),
     /* 2326292 */ /*GILLT_nxv4s32*//*Label 31934*/ GIMT_Encode4(2327676),
     /* 2326296 */ /*GILLT_nxv4s64*//*Label 31935*/ GIMT_Encode4(2327797), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326308 */ /*GILLT_nxv8s16*//*Label 31936*/ GIMT_Encode4(2327918),
     /* 2326312 */ /*GILLT_nxv8s32*//*Label 31937*/ GIMT_Encode4(2328039),
     /* 2326316 */ /*GILLT_nxv8s64*//*Label 31938*/ GIMT_Encode4(2328160), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326328 */ /*GILLT_nxv16s16*//*Label 31939*/ GIMT_Encode4(2328281),
     /* 2326332 */ /*GILLT_nxv16s32*//*Label 31940*/ GIMT_Encode4(2328402), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326344 */ /*GILLT_nxv32s16*//*Label 31941*/ GIMT_Encode4(2328523),
     /* 2326348 */ // Label 31924: @2326348
     /* 2326348 */ GIM_Try, /*On fail goto*//*Label 31943*/ GIMT_Encode4(2326496),
     /* 2326353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2326359 */   GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2326393), // Rule ID 1982 //
     /* 2326364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2326367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326379 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2326379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2326382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326392 */     // GIR_Coverage, 1982,
     /* 2326392 */     GIR_EraseRootFromParent_Done,
     /* 2326393 */   // Label 31944: @2326393
     /* 2326393 */   GIM_Try, /*On fail goto*//*Label 31945*/ GIMT_Encode4(2326427), // Rule ID 1983 //
     /* 2326398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2326401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326413 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2326413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2326416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326426 */     // GIR_Coverage, 1983,
     /* 2326426 */     GIR_EraseRootFromParent_Done,
     /* 2326427 */   // Label 31945: @2326427
     /* 2326427 */   GIM_Try, /*On fail goto*//*Label 31946*/ GIMT_Encode4(2326461), // Rule ID 1986 //
     /* 2326432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2326435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326447 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2326447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2326450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326460 */     // GIR_Coverage, 1986,
     /* 2326460 */     GIR_EraseRootFromParent_Done,
     /* 2326461 */   // Label 31946: @2326461
     /* 2326461 */   GIM_Try, /*On fail goto*//*Label 31947*/ GIMT_Encode4(2326495), // Rule ID 1987 //
     /* 2326466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2326469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326481 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2326481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2326484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326494 */     // GIR_Coverage, 1987,
     /* 2326494 */     GIR_EraseRootFromParent_Done,
     /* 2326495 */   // Label 31947: @2326495
     /* 2326495 */   GIM_Reject,
     /* 2326496 */ // Label 31943: @2326496
     /* 2326496 */ GIM_Reject,
     /* 2326497 */ // Label 31925: @2326497
     /* 2326497 */ GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2326645),
     /* 2326502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2326508 */   GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2326542), // Rule ID 1273 //
     /* 2326513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2326516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326528 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2326528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2326531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326541 */     // GIR_Coverage, 1273,
     /* 2326541 */     GIR_EraseRootFromParent_Done,
     /* 2326542 */   // Label 31949: @2326542
     /* 2326542 */   GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2326576), // Rule ID 1274 //
     /* 2326547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2326550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326562 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2326562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2326565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326575 */     // GIR_Coverage, 1274,
     /* 2326575 */     GIR_EraseRootFromParent_Done,
     /* 2326576 */   // Label 31950: @2326576
     /* 2326576 */   GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2326610), // Rule ID 1277 //
     /* 2326581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2326584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326596 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2326596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2326599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326609 */     // GIR_Coverage, 1277,
     /* 2326609 */     GIR_EraseRootFromParent_Done,
     /* 2326610 */   // Label 31951: @2326610
     /* 2326610 */   GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2326644), // Rule ID 1278 //
     /* 2326615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2326618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326630 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2326630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2326633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326643 */     // GIR_Coverage, 1278,
     /* 2326643 */     GIR_EraseRootFromParent_Done,
     /* 2326644 */   // Label 31952: @2326644
     /* 2326644 */   GIM_Reject,
     /* 2326645 */ // Label 31948: @2326645
     /* 2326645 */ GIM_Reject,
     /* 2326646 */ // Label 31926: @2326646
     /* 2326646 */ GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2326828),
     /* 2326651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2326657 */   GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2326691), // Rule ID 1614 //
     /* 2326662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2326665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326677 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2326680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326690 */     // GIR_Coverage, 1614,
     /* 2326690 */     GIR_EraseRootFromParent_Done,
     /* 2326691 */   // Label 31954: @2326691
     /* 2326691 */   GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2326725), // Rule ID 1615 //
     /* 2326696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2326699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326711 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2326711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2326714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326724 */     // GIR_Coverage, 1615,
     /* 2326724 */     GIR_EraseRootFromParent_Done,
     /* 2326725 */   // Label 31955: @2326725
     /* 2326725 */   GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2326759), // Rule ID 1618 //
     /* 2326730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2326733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326745 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2326748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326758 */     // GIR_Coverage, 1618,
     /* 2326758 */     GIR_EraseRootFromParent_Done,
     /* 2326759 */   // Label 31956: @2326759
     /* 2326759 */   GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2326793), // Rule ID 1619 //
     /* 2326764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2326767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326779 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2326779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2326782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326792 */     // GIR_Coverage, 1619,
     /* 2326792 */     GIR_EraseRootFromParent_Done,
     /* 2326793 */   // Label 31957: @2326793
     /* 2326793 */   GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2326827), // Rule ID 1621 //
     /* 2326798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2326801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326813 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2326813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2326816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326826 */     // GIR_Coverage, 1621,
     /* 2326826 */     GIR_EraseRootFromParent_Done,
     /* 2326827 */   // Label 31958: @2326827
     /* 2326827 */   GIM_Reject,
     /* 2326828 */ // Label 31953: @2326828
     /* 2326828 */ GIM_Reject,
     /* 2326829 */ // Label 31927: @2326829
     /* 2326829 */ GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2326949),
     /* 2326834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2326840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326852 */   GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2326900), // Rule ID 54408 //
     /* 2326857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2326860 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2326877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326899 */     // GIR_Coverage, 54408,
     /* 2326899 */     GIR_EraseRootFromParent_Done,
     /* 2326900 */   // Label 31960: @2326900
     /* 2326900 */   GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2326948), // Rule ID 54409 //
     /* 2326905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2326908 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2326925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2326934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326947 */     // GIR_Coverage, 54409,
     /* 2326947 */     GIR_EraseRootFromParent_Done,
     /* 2326948 */   // Label 31961: @2326948
     /* 2326948 */   GIM_Reject,
     /* 2326949 */ // Label 31959: @2326949
     /* 2326949 */ GIM_Reject,
     /* 2326950 */ // Label 31928: @2326950
     /* 2326950 */ GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2327070),
     /* 2326955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2326961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326973 */   GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2327021), // Rule ID 54432 //
     /* 2326978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2326981 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2326998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327020 */     // GIR_Coverage, 54432,
     /* 2327020 */     GIR_EraseRootFromParent_Done,
     /* 2327021 */   // Label 31963: @2327021
     /* 2327021 */   GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2327069), // Rule ID 54433 //
     /* 2327026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327029 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2327046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327068 */     // GIR_Coverage, 54433,
     /* 2327068 */     GIR_EraseRootFromParent_Done,
     /* 2327069 */   // Label 31964: @2327069
     /* 2327069 */   GIM_Reject,
     /* 2327070 */ // Label 31962: @2327070
     /* 2327070 */ GIM_Reject,
     /* 2327071 */ // Label 31929: @2327071
     /* 2327071 */ GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2327191),
     /* 2327076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2327082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327094 */   GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2327142), // Rule ID 54468 //
     /* 2327099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327102 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2327119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327141 */     // GIR_Coverage, 54468,
     /* 2327141 */     GIR_EraseRootFromParent_Done,
     /* 2327142 */   // Label 31966: @2327142
     /* 2327142 */   GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2327190), // Rule ID 54469 //
     /* 2327147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327150 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2327167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327189 */     // GIR_Coverage, 54469,
     /* 2327189 */     GIR_EraseRootFromParent_Done,
     /* 2327190 */   // Label 31967: @2327190
     /* 2327190 */   GIM_Reject,
     /* 2327191 */ // Label 31965: @2327191
     /* 2327191 */ GIM_Reject,
     /* 2327192 */ // Label 31930: @2327192
     /* 2327192 */ GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2327312),
     /* 2327197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2327203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327215 */   GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2327263), // Rule ID 54420 //
     /* 2327220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327223 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2327240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327262 */     // GIR_Coverage, 54420,
     /* 2327262 */     GIR_EraseRootFromParent_Done,
     /* 2327263 */   // Label 31969: @2327263
     /* 2327263 */   GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2327311), // Rule ID 54421 //
     /* 2327268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2327271 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2327288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327310 */     // GIR_Coverage, 54421,
     /* 2327310 */     GIR_EraseRootFromParent_Done,
     /* 2327311 */   // Label 31970: @2327311
     /* 2327311 */   GIM_Reject,
     /* 2327312 */ // Label 31968: @2327312
     /* 2327312 */ GIM_Reject,
     /* 2327313 */ // Label 31931: @2327313
     /* 2327313 */ GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2327433),
     /* 2327318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2327324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327336 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2327384), // Rule ID 54456 //
     /* 2327341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2327344 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2327361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327383 */     // GIR_Coverage, 54456,
     /* 2327383 */     GIR_EraseRootFromParent_Done,
     /* 2327384 */   // Label 31972: @2327384
     /* 2327384 */   GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2327432), // Rule ID 54457 //
     /* 2327389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327392 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2327409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327431 */     // GIR_Coverage, 54457,
     /* 2327431 */     GIR_EraseRootFromParent_Done,
     /* 2327432 */   // Label 31973: @2327432
     /* 2327432 */   GIM_Reject,
     /* 2327433 */ // Label 31971: @2327433
     /* 2327433 */ GIM_Reject,
     /* 2327434 */ // Label 31932: @2327434
     /* 2327434 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2327554),
     /* 2327439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2327445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327457 */   GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2327505), // Rule ID 54552 //
     /* 2327462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327465 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2327482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327504 */     // GIR_Coverage, 54552,
     /* 2327504 */     GIR_EraseRootFromParent_Done,
     /* 2327505 */   // Label 31975: @2327505
     /* 2327505 */   GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2327553), // Rule ID 54553 //
     /* 2327510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327513 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2327530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327552 */     // GIR_Coverage, 54553,
     /* 2327552 */     GIR_EraseRootFromParent_Done,
     /* 2327553 */   // Label 31976: @2327553
     /* 2327553 */   GIM_Reject,
     /* 2327554 */ // Label 31974: @2327554
     /* 2327554 */ GIM_Reject,
     /* 2327555 */ // Label 31933: @2327555
     /* 2327555 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2327675),
     /* 2327560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2327563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2327566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327578 */   GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2327626), // Rule ID 54444 //
     /* 2327583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327586 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2327589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2327603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327625 */     // GIR_Coverage, 54444,
     /* 2327625 */     GIR_EraseRootFromParent_Done,
     /* 2327626 */   // Label 31978: @2327626
     /* 2327626 */   GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2327674), // Rule ID 54445 //
     /* 2327631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2327634 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2327637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2327651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327673 */     // GIR_Coverage, 54445,
     /* 2327673 */     GIR_EraseRootFromParent_Done,
     /* 2327674 */   // Label 31979: @2327674
     /* 2327674 */   GIM_Reject,
     /* 2327675 */ // Label 31977: @2327675
     /* 2327675 */ GIM_Reject,
     /* 2327676 */ // Label 31934: @2327676
     /* 2327676 */ GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2327796),
     /* 2327681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2327684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2327687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327699 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2327747), // Rule ID 54516 //
     /* 2327704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2327707 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2327710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2327724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327746 */     // GIR_Coverage, 54516,
     /* 2327746 */     GIR_EraseRootFromParent_Done,
     /* 2327747 */   // Label 31981: @2327747
     /* 2327747 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2327795), // Rule ID 54517 //
     /* 2327752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2327755 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2327758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2327772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327794 */     // GIR_Coverage, 54517,
     /* 2327794 */     GIR_EraseRootFromParent_Done,
     /* 2327795 */   // Label 31982: @2327795
     /* 2327795 */   GIM_Reject,
     /* 2327796 */ // Label 31980: @2327796
     /* 2327796 */ GIM_Reject,
     /* 2327797 */ // Label 31935: @2327797
     /* 2327797 */ GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2327917),
     /* 2327802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2327805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2327808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2327820 */   GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2327868), // Rule ID 54564 //
     /* 2327825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2327828 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2327831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2327845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327867 */     // GIR_Coverage, 54564,
     /* 2327867 */     GIR_EraseRootFromParent_Done,
     /* 2327868 */   // Label 31984: @2327868
     /* 2327868 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2327916), // Rule ID 54565 //
     /* 2327873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2327876 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2327879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2327893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327915 */     // GIR_Coverage, 54565,
     /* 2327915 */     GIR_EraseRootFromParent_Done,
     /* 2327916 */   // Label 31985: @2327916
     /* 2327916 */   GIM_Reject,
     /* 2327917 */ // Label 31983: @2327917
     /* 2327917 */ GIM_Reject,
     /* 2327918 */ // Label 31936: @2327918
     /* 2327918 */ GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2328038),
     /* 2327923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2327926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2327929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327941 */   GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2327989), // Rule ID 54480 //
     /* 2327946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2327949 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2327952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2327966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2327975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327988 */     // GIR_Coverage, 54480,
     /* 2327988 */     GIR_EraseRootFromParent_Done,
     /* 2327989 */   // Label 31987: @2327989
     /* 2327989 */   GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2328037), // Rule ID 54481 //
     /* 2327994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2327997 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2328014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328036 */     // GIR_Coverage, 54481,
     /* 2328036 */     GIR_EraseRootFromParent_Done,
     /* 2328037 */   // Label 31988: @2328037
     /* 2328037 */   GIM_Reject,
     /* 2328038 */ // Label 31986: @2328038
     /* 2328038 */ GIM_Reject,
     /* 2328039 */ // Label 31937: @2328039
     /* 2328039 */ GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2328159),
     /* 2328044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2328047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2328050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328062 */   GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2328110), // Rule ID 54528 //
     /* 2328067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2328070 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2328087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328109 */     // GIR_Coverage, 54528,
     /* 2328109 */     GIR_EraseRootFromParent_Done,
     /* 2328110 */   // Label 31990: @2328110
     /* 2328110 */   GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2328158), // Rule ID 54529 //
     /* 2328115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2328118 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2328121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2328135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328157 */     // GIR_Coverage, 54529,
     /* 2328157 */     GIR_EraseRootFromParent_Done,
     /* 2328158 */   // Label 31991: @2328158
     /* 2328158 */   GIM_Reject,
     /* 2328159 */ // Label 31989: @2328159
     /* 2328159 */ GIM_Reject,
     /* 2328160 */ // Label 31938: @2328160
     /* 2328160 */ GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2328280),
     /* 2328165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2328168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2328171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328183 */   GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2328231), // Rule ID 54576 //
     /* 2328188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2328191 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2328194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2328208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328230 */     // GIR_Coverage, 54576,
     /* 2328230 */     GIR_EraseRootFromParent_Done,
     /* 2328231 */   // Label 31993: @2328231
     /* 2328231 */   GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2328279), // Rule ID 54577 //
     /* 2328236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2328239 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2328242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2328256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328278 */     // GIR_Coverage, 54577,
     /* 2328278 */     GIR_EraseRootFromParent_Done,
     /* 2328279 */   // Label 31994: @2328279
     /* 2328279 */   GIM_Reject,
     /* 2328280 */ // Label 31992: @2328280
     /* 2328280 */ GIM_Reject,
     /* 2328281 */ // Label 31939: @2328281
     /* 2328281 */ GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2328401),
     /* 2328286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2328289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2328292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328304 */   GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2328352), // Rule ID 54492 //
     /* 2328309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2328312 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2328329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328351 */     // GIR_Coverage, 54492,
     /* 2328351 */     GIR_EraseRootFromParent_Done,
     /* 2328352 */   // Label 31996: @2328352
     /* 2328352 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2328400), // Rule ID 54493 //
     /* 2328357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2328360 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2328363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2328377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328399 */     // GIR_Coverage, 54493,
     /* 2328399 */     GIR_EraseRootFromParent_Done,
     /* 2328400 */   // Label 31997: @2328400
     /* 2328400 */   GIM_Reject,
     /* 2328401 */ // Label 31995: @2328401
     /* 2328401 */ GIM_Reject,
     /* 2328402 */ // Label 31940: @2328402
     /* 2328402 */ GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2328522),
     /* 2328407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2328410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2328413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328425 */   GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2328473), // Rule ID 54540 //
     /* 2328430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2328433 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2328436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2328450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328472 */     // GIR_Coverage, 54540,
     /* 2328472 */     GIR_EraseRootFromParent_Done,
     /* 2328473 */   // Label 31999: @2328473
     /* 2328473 */   GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2328521), // Rule ID 54541 //
     /* 2328478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2328481 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2328484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2328498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328520 */     // GIR_Coverage, 54541,
     /* 2328520 */     GIR_EraseRootFromParent_Done,
     /* 2328521 */   // Label 32000: @2328521
     /* 2328521 */   GIM_Reject,
     /* 2328522 */ // Label 31998: @2328522
     /* 2328522 */ GIM_Reject,
     /* 2328523 */ // Label 31941: @2328523
     /* 2328523 */ GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2328643),
     /* 2328528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2328531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2328534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2328546 */   GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2328594), // Rule ID 54504 //
     /* 2328551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2328554 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2328557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2328571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328593 */     // GIR_Coverage, 54504,
     /* 2328593 */     GIR_EraseRootFromParent_Done,
     /* 2328594 */   // Label 32002: @2328594
     /* 2328594 */   GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2328642), // Rule ID 54505 //
     /* 2328599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2328602 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2328605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2328619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2328628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328641 */     // GIR_Coverage, 54505,
     /* 2328641 */     GIR_EraseRootFromParent_Done,
     /* 2328642 */   // Label 32003: @2328642
     /* 2328642 */   GIM_Reject,
     /* 2328643 */ // Label 32001: @2328643
     /* 2328643 */ GIM_Reject,
     /* 2328644 */ // Label 31942: @2328644
     /* 2328644 */ GIM_Reject,
     /* 2328645 */ // Label 64: @2328645
     /* 2328645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32022*/ GIMT_Encode4(2330615),
     /* 2328656 */ /*GILLT_s16*//*Label 32004*/ GIMT_Encode4(2328776),
     /* 2328660 */ /*GILLT_s32*//*Label 32005*/ GIMT_Encode4(2328840),
     /* 2328664 */ /*GILLT_s64*//*Label 32006*/ GIMT_Encode4(2328904), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328676 */ /*GILLT_nxv1s16*//*Label 32007*/ GIMT_Encode4(2328995),
     /* 2328680 */ /*GILLT_nxv1s32*//*Label 32008*/ GIMT_Encode4(2329103),
     /* 2328684 */ /*GILLT_nxv1s64*//*Label 32009*/ GIMT_Encode4(2329211), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328696 */ /*GILLT_nxv2s16*//*Label 32010*/ GIMT_Encode4(2329319),
     /* 2328700 */ /*GILLT_nxv2s32*//*Label 32011*/ GIMT_Encode4(2329427),
     /* 2328704 */ /*GILLT_nxv2s64*//*Label 32012*/ GIMT_Encode4(2329535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328716 */ /*GILLT_nxv4s16*//*Label 32013*/ GIMT_Encode4(2329643),
     /* 2328720 */ /*GILLT_nxv4s32*//*Label 32014*/ GIMT_Encode4(2329751),
     /* 2328724 */ /*GILLT_nxv4s64*//*Label 32015*/ GIMT_Encode4(2329859), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328736 */ /*GILLT_nxv8s16*//*Label 32016*/ GIMT_Encode4(2329967),
     /* 2328740 */ /*GILLT_nxv8s32*//*Label 32017*/ GIMT_Encode4(2330075),
     /* 2328744 */ /*GILLT_nxv8s64*//*Label 32018*/ GIMT_Encode4(2330183), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328756 */ /*GILLT_nxv16s16*//*Label 32019*/ GIMT_Encode4(2330291),
     /* 2328760 */ /*GILLT_nxv16s32*//*Label 32020*/ GIMT_Encode4(2330399), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2328772 */ /*GILLT_nxv32s16*//*Label 32021*/ GIMT_Encode4(2330507),
     /* 2328776 */ // Label 32004: @2328776
     /* 2328776 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2328839),
     /* 2328781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2328784 */   GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2328811), // Rule ID 1992 //
     /* 2328789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2328792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2328796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2328800 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2328800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2328803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328810 */     // GIR_Coverage, 1992,
     /* 2328810 */     GIR_EraseRootFromParent_Done,
     /* 2328811 */   // Label 32024: @2328811
     /* 2328811 */   GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2328838), // Rule ID 2025 //
     /* 2328816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2328819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2328823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2328827 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2328827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2328830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328837 */     // GIR_Coverage, 2025,
     /* 2328837 */     GIR_EraseRootFromParent_Done,
     /* 2328838 */   // Label 32025: @2328838
     /* 2328838 */   GIM_Reject,
     /* 2328839 */ // Label 32023: @2328839
     /* 2328839 */ GIM_Reject,
     /* 2328840 */ // Label 32005: @2328840
     /* 2328840 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2328903),
     /* 2328845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2328848 */   GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2328875), // Rule ID 1283 //
     /* 2328853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2328856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2328860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2328864 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2328864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2328867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328874 */     // GIR_Coverage, 1283,
     /* 2328874 */     GIR_EraseRootFromParent_Done,
     /* 2328875 */   // Label 32027: @2328875
     /* 2328875 */   GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2328902), // Rule ID 1291 //
     /* 2328880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2328883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2328887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2328891 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2328891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2328894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328901 */     // GIR_Coverage, 1291,
     /* 2328901 */     GIR_EraseRootFromParent_Done,
     /* 2328902 */   // Label 32028: @2328902
     /* 2328902 */   GIM_Reject,
     /* 2328903 */ // Label 32026: @2328903
     /* 2328903 */ GIM_Reject,
     /* 2328904 */ // Label 32006: @2328904
     /* 2328904 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2328994),
     /* 2328909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2328912 */   GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2328939), // Rule ID 1626 //
     /* 2328917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2328920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2328924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2328928 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2328931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328938 */     // GIR_Coverage, 1626,
     /* 2328938 */     GIR_EraseRootFromParent_Done,
     /* 2328939 */   // Label 32030: @2328939
     /* 2328939 */   GIM_Try, /*On fail goto*//*Label 32031*/ GIMT_Encode4(2328966), // Rule ID 1659 //
     /* 2328944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2328947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2328955 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2328958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328965 */     // GIR_Coverage, 1659,
     /* 2328965 */     GIR_EraseRootFromParent_Done,
     /* 2328966 */   // Label 32031: @2328966
     /* 2328966 */   GIM_Try, /*On fail goto*//*Label 32032*/ GIMT_Encode4(2328993), // Rule ID 1681 //
     /* 2328971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2328974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2328978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2328982 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2328982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2328985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328992 */     // GIR_Coverage, 1681,
     /* 2328992 */     GIR_EraseRootFromParent_Done,
     /* 2328993 */   // Label 32032: @2328993
     /* 2328993 */   GIM_Reject,
     /* 2328994 */ // Label 32029: @2328994
     /* 2328994 */ GIM_Reject,
     /* 2328995 */ // Label 32007: @2328995
     /* 2328995 */ GIM_Try, /*On fail goto*//*Label 32033*/ GIMT_Encode4(2329102),
     /* 2329000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2329003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329011 */   GIM_Try, /*On fail goto*//*Label 32034*/ GIMT_Encode4(2329056), // Rule ID 56246 //
     /* 2329016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329019 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2329036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329055 */     // GIR_Coverage, 56246,
     /* 2329055 */     GIR_EraseRootFromParent_Done,
     /* 2329056 */   // Label 32034: @2329056
     /* 2329056 */   GIM_Try, /*On fail goto*//*Label 32035*/ GIMT_Encode4(2329101), // Rule ID 56247 //
     /* 2329061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329064 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2329067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2329081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329100 */     // GIR_Coverage, 56247,
     /* 2329100 */     GIR_EraseRootFromParent_Done,
     /* 2329101 */   // Label 32035: @2329101
     /* 2329101 */   GIM_Reject,
     /* 2329102 */ // Label 32033: @2329102
     /* 2329102 */ GIM_Reject,
     /* 2329103 */ // Label 32008: @2329103
     /* 2329103 */ GIM_Try, /*On fail goto*//*Label 32036*/ GIMT_Encode4(2329210),
     /* 2329108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2329111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329119 */   GIM_Try, /*On fail goto*//*Label 32037*/ GIMT_Encode4(2329164), // Rule ID 56286 //
     /* 2329124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329127 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2329130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2329144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329163 */     // GIR_Coverage, 56286,
     /* 2329163 */     GIR_EraseRootFromParent_Done,
     /* 2329164 */   // Label 32037: @2329164
     /* 2329164 */   GIM_Try, /*On fail goto*//*Label 32038*/ GIMT_Encode4(2329209), // Rule ID 56287 //
     /* 2329169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329172 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2329175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2329189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329208 */     // GIR_Coverage, 56287,
     /* 2329208 */     GIR_EraseRootFromParent_Done,
     /* 2329209 */   // Label 32038: @2329209
     /* 2329209 */   GIM_Reject,
     /* 2329210 */ // Label 32036: @2329210
     /* 2329210 */ GIM_Reject,
     /* 2329211 */ // Label 32009: @2329211
     /* 2329211 */ GIM_Try, /*On fail goto*//*Label 32039*/ GIMT_Encode4(2329318),
     /* 2329216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2329219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329227 */   GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2329272), // Rule ID 56346 //
     /* 2329232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329235 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2329238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2329252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329271 */     // GIR_Coverage, 56346,
     /* 2329271 */     GIR_EraseRootFromParent_Done,
     /* 2329272 */   // Label 32040: @2329272
     /* 2329272 */   GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2329317), // Rule ID 56347 //
     /* 2329277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329280 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2329283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2329297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329316 */     // GIR_Coverage, 56347,
     /* 2329316 */     GIR_EraseRootFromParent_Done,
     /* 2329317 */   // Label 32041: @2329317
     /* 2329317 */   GIM_Reject,
     /* 2329318 */ // Label 32039: @2329318
     /* 2329318 */ GIM_Reject,
     /* 2329319 */ // Label 32010: @2329319
     /* 2329319 */ GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2329426),
     /* 2329324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2329327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329335 */   GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2329380), // Rule ID 56266 //
     /* 2329340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329343 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2329346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2329360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329379 */     // GIR_Coverage, 56266,
     /* 2329379 */     GIR_EraseRootFromParent_Done,
     /* 2329380 */   // Label 32043: @2329380
     /* 2329380 */   GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2329425), // Rule ID 56267 //
     /* 2329385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329388 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2329391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2329405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329424 */     // GIR_Coverage, 56267,
     /* 2329424 */     GIR_EraseRootFromParent_Done,
     /* 2329425 */   // Label 32044: @2329425
     /* 2329425 */   GIM_Reject,
     /* 2329426 */ // Label 32042: @2329426
     /* 2329426 */ GIM_Reject,
     /* 2329427 */ // Label 32011: @2329427
     /* 2329427 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2329534),
     /* 2329432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2329435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329443 */   GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2329488), // Rule ID 56326 //
     /* 2329448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329451 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2329454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2329468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329487 */     // GIR_Coverage, 56326,
     /* 2329487 */     GIR_EraseRootFromParent_Done,
     /* 2329488 */   // Label 32046: @2329488
     /* 2329488 */   GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2329533), // Rule ID 56327 //
     /* 2329493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329496 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2329499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2329513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329532 */     // GIR_Coverage, 56327,
     /* 2329532 */     GIR_EraseRootFromParent_Done,
     /* 2329533 */   // Label 32047: @2329533
     /* 2329533 */   GIM_Reject,
     /* 2329534 */ // Label 32045: @2329534
     /* 2329534 */ GIM_Reject,
     /* 2329535 */ // Label 32012: @2329535
     /* 2329535 */ GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2329642),
     /* 2329540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2329543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329551 */   GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2329596), // Rule ID 56486 //
     /* 2329556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329559 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2329576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329595 */     // GIR_Coverage, 56486,
     /* 2329595 */     GIR_EraseRootFromParent_Done,
     /* 2329596 */   // Label 32049: @2329596
     /* 2329596 */   GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2329641), // Rule ID 56487 //
     /* 2329601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329604 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2329607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2329621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329640 */     // GIR_Coverage, 56487,
     /* 2329640 */     GIR_EraseRootFromParent_Done,
     /* 2329641 */   // Label 32050: @2329641
     /* 2329641 */   GIM_Reject,
     /* 2329642 */ // Label 32048: @2329642
     /* 2329642 */ GIM_Reject,
     /* 2329643 */ // Label 32013: @2329643
     /* 2329643 */ GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2329750),
     /* 2329648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329659 */   GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2329704), // Rule ID 56306 //
     /* 2329664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329667 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2329684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329703 */     // GIR_Coverage, 56306,
     /* 2329703 */     GIR_EraseRootFromParent_Done,
     /* 2329704 */   // Label 32052: @2329704
     /* 2329704 */   GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2329749), // Rule ID 56307 //
     /* 2329709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2329712 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2329729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329748 */     // GIR_Coverage, 56307,
     /* 2329748 */     GIR_EraseRootFromParent_Done,
     /* 2329749 */   // Label 32053: @2329749
     /* 2329749 */   GIM_Reject,
     /* 2329750 */ // Label 32051: @2329750
     /* 2329750 */ GIM_Reject,
     /* 2329751 */ // Label 32014: @2329751
     /* 2329751 */ GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2329858),
     /* 2329756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329767 */   GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2329812), // Rule ID 56426 //
     /* 2329772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2329775 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2329792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329811 */     // GIR_Coverage, 56426,
     /* 2329811 */     GIR_EraseRootFromParent_Done,
     /* 2329812 */   // Label 32055: @2329812
     /* 2329812 */   GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2329857), // Rule ID 56427 //
     /* 2329817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2329820 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2329837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329856 */     // GIR_Coverage, 56427,
     /* 2329856 */     GIR_EraseRootFromParent_Done,
     /* 2329857 */   // Label 32056: @2329857
     /* 2329857 */   GIM_Reject,
     /* 2329858 */ // Label 32054: @2329858
     /* 2329858 */ GIM_Reject,
     /* 2329859 */ // Label 32015: @2329859
     /* 2329859 */ GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2329966),
     /* 2329864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329875 */   GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2329920), // Rule ID 56506 //
     /* 2329880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2329883 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2329900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329919 */     // GIR_Coverage, 56506,
     /* 2329919 */     GIR_EraseRootFromParent_Done,
     /* 2329920 */   // Label 32058: @2329920
     /* 2329920 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2329965), // Rule ID 56507 //
     /* 2329925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2329928 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2329945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2329954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329964 */     // GIR_Coverage, 56507,
     /* 2329964 */     GIR_EraseRootFromParent_Done,
     /* 2329965 */   // Label 32059: @2329965
     /* 2329965 */   GIM_Reject,
     /* 2329966 */ // Label 32057: @2329966
     /* 2329966 */ GIM_Reject,
     /* 2329967 */ // Label 32016: @2329967
     /* 2329967 */ GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2330074),
     /* 2329972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329983 */   GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2330028), // Rule ID 56366 //
     /* 2329988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2329991 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2330008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330027 */     // GIR_Coverage, 56366,
     /* 2330027 */     GIR_EraseRootFromParent_Done,
     /* 2330028 */   // Label 32061: @2330028
     /* 2330028 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2330073), // Rule ID 56367 //
     /* 2330033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330036 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2330053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330072 */     // GIR_Coverage, 56367,
     /* 2330072 */     GIR_EraseRootFromParent_Done,
     /* 2330073 */   // Label 32062: @2330073
     /* 2330073 */   GIM_Reject,
     /* 2330074 */ // Label 32060: @2330074
     /* 2330074 */ GIM_Reject,
     /* 2330075 */ // Label 32017: @2330075
     /* 2330075 */ GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2330182),
     /* 2330080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330091 */   GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2330136), // Rule ID 56446 //
     /* 2330096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2330099 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2330116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330135 */     // GIR_Coverage, 56446,
     /* 2330135 */     GIR_EraseRootFromParent_Done,
     /* 2330136 */   // Label 32064: @2330136
     /* 2330136 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2330181), // Rule ID 56447 //
     /* 2330141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2330144 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2330161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330180 */     // GIR_Coverage, 56447,
     /* 2330180 */     GIR_EraseRootFromParent_Done,
     /* 2330181 */   // Label 32065: @2330181
     /* 2330181 */   GIM_Reject,
     /* 2330182 */ // Label 32063: @2330182
     /* 2330182 */ GIM_Reject,
     /* 2330183 */ // Label 32018: @2330183
     /* 2330183 */ GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2330290),
     /* 2330188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330199 */   GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2330244), // Rule ID 56526 //
     /* 2330204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2330207 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2330224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330243 */     // GIR_Coverage, 56526,
     /* 2330243 */     GIR_EraseRootFromParent_Done,
     /* 2330244 */   // Label 32067: @2330244
     /* 2330244 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2330289), // Rule ID 56527 //
     /* 2330249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2330252 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2330269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330288 */     // GIR_Coverage, 56527,
     /* 2330288 */     GIR_EraseRootFromParent_Done,
     /* 2330289 */   // Label 32068: @2330289
     /* 2330289 */   GIM_Reject,
     /* 2330290 */ // Label 32066: @2330290
     /* 2330290 */ GIM_Reject,
     /* 2330291 */ // Label 32019: @2330291
     /* 2330291 */ GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2330398),
     /* 2330296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330307 */   GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2330352), // Rule ID 56386 //
     /* 2330312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2330315 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2330332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330351 */     // GIR_Coverage, 56386,
     /* 2330351 */     GIR_EraseRootFromParent_Done,
     /* 2330352 */   // Label 32070: @2330352
     /* 2330352 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2330397), // Rule ID 56387 //
     /* 2330357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330360 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2330377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330396 */     // GIR_Coverage, 56387,
     /* 2330396 */     GIR_EraseRootFromParent_Done,
     /* 2330397 */   // Label 32071: @2330397
     /* 2330397 */   GIM_Reject,
     /* 2330398 */ // Label 32069: @2330398
     /* 2330398 */ GIM_Reject,
     /* 2330399 */ // Label 32020: @2330399
     /* 2330399 */ GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2330506),
     /* 2330404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330415 */   GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2330460), // Rule ID 56466 //
     /* 2330420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2330423 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2330440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330459 */     // GIR_Coverage, 56466,
     /* 2330459 */     GIR_EraseRootFromParent_Done,
     /* 2330460 */   // Label 32073: @2330460
     /* 2330460 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2330505), // Rule ID 56467 //
     /* 2330465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2330468 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2330485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330504 */     // GIR_Coverage, 56467,
     /* 2330504 */     GIR_EraseRootFromParent_Done,
     /* 2330505 */   // Label 32074: @2330505
     /* 2330505 */   GIM_Reject,
     /* 2330506 */ // Label 32072: @2330506
     /* 2330506 */ GIM_Reject,
     /* 2330507 */ // Label 32021: @2330507
     /* 2330507 */ GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2330614),
     /* 2330512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2330515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330523 */   GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2330568), // Rule ID 56406 //
     /* 2330528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2330531 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2330548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330567 */     // GIR_Coverage, 56406,
     /* 2330567 */     GIR_EraseRootFromParent_Done,
     /* 2330568 */   // Label 32076: @2330568
     /* 2330568 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2330613), // Rule ID 56407 //
     /* 2330573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2330576 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2330593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2330602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330612 */     // GIR_Coverage, 56407,
     /* 2330612 */     GIR_EraseRootFromParent_Done,
     /* 2330613 */   // Label 32077: @2330613
     /* 2330613 */   GIM_Reject,
     /* 2330614 */ // Label 32075: @2330614
     /* 2330614 */ GIM_Reject,
     /* 2330615 */ // Label 32022: @2330615
     /* 2330615 */ GIM_Reject,
     /* 2330616 */ // Label 65: @2330616
     /* 2330616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 32080*/ GIMT_Encode4(2331068),
     /* 2330627 */ /*GILLT_s32*//*Label 32078*/ GIMT_Encode4(2330635),
     /* 2330631 */ /*GILLT_s64*//*Label 32079*/ GIMT_Encode4(2330757),
     /* 2330635 */ // Label 32078: @2330635
     /* 2330635 */ GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2330756),
     /* 2330640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330643 */   GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2330671), // Rule ID 2166 //
     /* 2330648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2330651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330659 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2330662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330670 */     // GIR_Coverage, 2166,
     /* 2330670 */     GIR_EraseRootFromParent_Done,
     /* 2330671 */   // Label 32082: @2330671
     /* 2330671 */   GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2330699), // Rule ID 2167 //
     /* 2330676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2330679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330687 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2330690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330698 */     // GIR_Coverage, 2167,
     /* 2330698 */     GIR_EraseRootFromParent_Done,
     /* 2330699 */   // Label 32083: @2330699
     /* 2330699 */   GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2330727), // Rule ID 2182 //
     /* 2330704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2330707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330715 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2330718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330726 */     // GIR_Coverage, 2182,
     /* 2330726 */     GIR_EraseRootFromParent_Done,
     /* 2330727 */   // Label 32084: @2330727
     /* 2330727 */   GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2330755), // Rule ID 2183 //
     /* 2330732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2330735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330743 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2330746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330754 */     // GIR_Coverage, 2183,
     /* 2330754 */     GIR_EraseRootFromParent_Done,
     /* 2330755 */   // Label 32085: @2330755
     /* 2330755 */   GIM_Reject,
     /* 2330756 */ // Label 32081: @2330756
     /* 2330756 */ GIM_Reject,
     /* 2330757 */ // Label 32079: @2330757
     /* 2330757 */ GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2330788), // Rule ID 1568 //
     /* 2330762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2330765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330776 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2330779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330787 */   // GIR_Coverage, 1568,
     /* 2330787 */   GIR_EraseRootFromParent_Done,
     /* 2330788 */ // Label 32086: @2330788
     /* 2330788 */ GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2330819), // Rule ID 1569 //
     /* 2330793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2330796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330807 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2330807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2330810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330818 */   // GIR_Coverage, 1569,
     /* 2330818 */   GIR_EraseRootFromParent_Done,
     /* 2330819 */ // Label 32087: @2330819
     /* 2330819 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2330850), // Rule ID 1573 //
     /* 2330824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2330827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330838 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2330841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330843 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330849 */   // GIR_Coverage, 1573,
     /* 2330849 */   GIR_EraseRootFromParent_Done,
     /* 2330850 */ // Label 32088: @2330850
     /* 2330850 */ GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2330881), // Rule ID 1580 //
     /* 2330855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2330858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330869 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2330869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2330872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330874 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330880 */   // GIR_Coverage, 1580,
     /* 2330880 */   GIR_EraseRootFromParent_Done,
     /* 2330881 */ // Label 32089: @2330881
     /* 2330881 */ GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2330912), // Rule ID 1581 //
     /* 2330886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2330889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330900 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2330900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2330903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330905 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330911 */   // GIR_Coverage, 1581,
     /* 2330911 */   GIR_EraseRootFromParent_Done,
     /* 2330912 */ // Label 32090: @2330912
     /* 2330912 */ GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2330943), // Rule ID 2300 //
     /* 2330917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2330920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330931 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2330934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330936 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330942 */   // GIR_Coverage, 2300,
     /* 2330942 */   GIR_EraseRootFromParent_Done,
     /* 2330943 */ // Label 32091: @2330943
     /* 2330943 */ GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2330974), // Rule ID 2301 //
     /* 2330948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2330951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2330958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330962 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2330962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2330965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330967 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2330972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330973 */   // GIR_Coverage, 2301,
     /* 2330973 */   GIR_EraseRootFromParent_Done,
     /* 2330974 */ // Label 32092: @2330974
     /* 2330974 */ GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2331005), // Rule ID 2312 //
     /* 2330979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2330982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2330985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2330989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330993 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2330993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2330996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331004 */   // GIR_Coverage, 2312,
     /* 2331004 */   GIR_EraseRootFromParent_Done,
     /* 2331005 */ // Label 32093: @2331005
     /* 2331005 */ GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2331036), // Rule ID 2313 //
     /* 2331010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2331013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331024 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2331024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2331027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331029 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331035 */   // GIR_Coverage, 2313,
     /* 2331035 */   GIR_EraseRootFromParent_Done,
     /* 2331036 */ // Label 32094: @2331036
     /* 2331036 */ GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2331067), // Rule ID 2321 //
     /* 2331041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2331044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331055 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2331055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2331058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331060 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331066 */   // GIR_Coverage, 2321,
     /* 2331066 */   GIR_EraseRootFromParent_Done,
     /* 2331067 */ // Label 32095: @2331067
     /* 2331067 */ GIM_Reject,
     /* 2331068 */ // Label 32080: @2331068
     /* 2331068 */ GIM_Reject,
     /* 2331069 */ // Label 66: @2331069
     /* 2331069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 32107*/ GIMT_Encode4(2332604),
     /* 2331080 */ /*GILLT_s16*//*Label 32096*/ GIMT_Encode4(2331184),
     /* 2331084 */ /*GILLT_s32*//*Label 32097*/ GIMT_Encode4(2331464), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331100 */ /*GILLT_nxv1s16*//*Label 32098*/ GIMT_Encode4(2331614),
     /* 2331104 */ /*GILLT_nxv1s32*//*Label 32099*/ GIMT_Encode4(2331724), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331120 */ /*GILLT_nxv2s16*//*Label 32100*/ GIMT_Encode4(2331834),
     /* 2331124 */ /*GILLT_nxv2s32*//*Label 32101*/ GIMT_Encode4(2331944), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331140 */ /*GILLT_nxv4s16*//*Label 32102*/ GIMT_Encode4(2332054),
     /* 2331144 */ /*GILLT_nxv4s32*//*Label 32103*/ GIMT_Encode4(2332164), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331160 */ /*GILLT_nxv8s16*//*Label 32104*/ GIMT_Encode4(2332274),
     /* 2331164 */ /*GILLT_nxv8s32*//*Label 32105*/ GIMT_Encode4(2332384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331180 */ /*GILLT_nxv16s16*//*Label 32106*/ GIMT_Encode4(2332494),
     /* 2331184 */ // Label 32096: @2331184
     /* 2331184 */ GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2331215), // Rule ID 2162 //
     /* 2331189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2331192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331203 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2331203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2331206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331208 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331214 */   // GIR_Coverage, 2162,
     /* 2331214 */   GIR_EraseRootFromParent_Done,
     /* 2331215 */ // Label 32108: @2331215
     /* 2331215 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2331246), // Rule ID 2163 //
     /* 2331220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2331223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331234 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2331234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2331237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331239 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331245 */   // GIR_Coverage, 2163,
     /* 2331245 */   GIR_EraseRootFromParent_Done,
     /* 2331246 */ // Label 32109: @2331246
     /* 2331246 */ GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2331277), // Rule ID 2178 //
     /* 2331251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2331254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331265 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2331265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2331268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331270 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331276 */   // GIR_Coverage, 2178,
     /* 2331276 */   GIR_EraseRootFromParent_Done,
     /* 2331277 */ // Label 32110: @2331277
     /* 2331277 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2331308), // Rule ID 2179 //
     /* 2331282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2331285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331296 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2331296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2331299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331307 */   // GIR_Coverage, 2179,
     /* 2331307 */   GIR_EraseRootFromParent_Done,
     /* 2331308 */ // Label 32111: @2331308
     /* 2331308 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2331339), // Rule ID 2296 //
     /* 2331313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2331316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331327 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2331330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331338 */   // GIR_Coverage, 2296,
     /* 2331338 */   GIR_EraseRootFromParent_Done,
     /* 2331339 */ // Label 32112: @2331339
     /* 2331339 */ GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2331370), // Rule ID 2297 //
     /* 2331344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2331347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331358 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2331361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331363 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331369 */   // GIR_Coverage, 2297,
     /* 2331369 */   GIR_EraseRootFromParent_Done,
     /* 2331370 */ // Label 32113: @2331370
     /* 2331370 */ GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2331401), // Rule ID 2308 //
     /* 2331375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2331378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331389 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2331392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331394 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331400 */   // GIR_Coverage, 2308,
     /* 2331400 */   GIR_EraseRootFromParent_Done,
     /* 2331401 */ // Label 32114: @2331401
     /* 2331401 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2331432), // Rule ID 2309 //
     /* 2331406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2331409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331420 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2331423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331431 */   // GIR_Coverage, 2309,
     /* 2331431 */   GIR_EraseRootFromParent_Done,
     /* 2331432 */ // Label 32115: @2331432
     /* 2331432 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2331463), // Rule ID 2319 //
     /* 2331437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2331440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331451 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2331454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331456 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331462 */   // GIR_Coverage, 2319,
     /* 2331462 */   GIR_EraseRootFromParent_Done,
     /* 2331463 */ // Label 32116: @2331463
     /* 2331463 */ GIM_Reject,
     /* 2331464 */ // Label 32097: @2331464
     /* 2331464 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2331613),
     /* 2331469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331472 */   GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2331500), // Rule ID 1564 //
     /* 2331477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2331480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331488 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2331491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331499 */     // GIR_Coverage, 1564,
     /* 2331499 */     GIR_EraseRootFromParent_Done,
     /* 2331500 */   // Label 32118: @2331500
     /* 2331500 */   GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2331528), // Rule ID 1565 //
     /* 2331505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2331508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331516 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2331519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331527 */     // GIR_Coverage, 1565,
     /* 2331527 */     GIR_EraseRootFromParent_Done,
     /* 2331528 */   // Label 32119: @2331528
     /* 2331528 */   GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2331556), // Rule ID 1571 //
     /* 2331533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331544 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2331547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331555 */     // GIR_Coverage, 1571,
     /* 2331555 */     GIR_EraseRootFromParent_Done,
     /* 2331556 */   // Label 32120: @2331556
     /* 2331556 */   GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2331584), // Rule ID 1576 //
     /* 2331561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2331564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331572 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2331572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2331575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331583 */     // GIR_Coverage, 1576,
     /* 2331583 */     GIR_EraseRootFromParent_Done,
     /* 2331584 */   // Label 32121: @2331584
     /* 2331584 */   GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2331612), // Rule ID 1577 //
     /* 2331589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2331592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331600 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2331600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2331603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331611 */     // GIR_Coverage, 1577,
     /* 2331611 */     GIR_EraseRootFromParent_Done,
     /* 2331612 */   // Label 32122: @2331612
     /* 2331612 */   GIM_Reject,
     /* 2331613 */ // Label 32117: @2331613
     /* 2331613 */ GIM_Reject,
     /* 2331614 */ // Label 32098: @2331614
     /* 2331614 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2331723),
     /* 2331619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331630 */   GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2331676), // Rule ID 58894 //
     /* 2331635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2331638 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2331655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331675 */     // GIR_Coverage, 58894,
     /* 2331675 */     GIR_EraseRootFromParent_Done,
     /* 2331676 */   // Label 32124: @2331676
     /* 2331676 */   GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2331722), // Rule ID 58895 //
     /* 2331681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2331684 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2331701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331721 */     // GIR_Coverage, 58895,
     /* 2331721 */     GIR_EraseRootFromParent_Done,
     /* 2331722 */   // Label 32125: @2331722
     /* 2331722 */   GIM_Reject,
     /* 2331723 */ // Label 32123: @2331723
     /* 2331723 */ GIM_Reject,
     /* 2331724 */ // Label 32099: @2331724
     /* 2331724 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2331833),
     /* 2331729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2331732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331740 */   GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2331786), // Rule ID 58904 //
     /* 2331745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2331748 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2331765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331785 */     // GIR_Coverage, 58904,
     /* 2331785 */     GIR_EraseRootFromParent_Done,
     /* 2331786 */   // Label 32127: @2331786
     /* 2331786 */   GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2331832), // Rule ID 58905 //
     /* 2331791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2331794 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2331811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331831 */     // GIR_Coverage, 58905,
     /* 2331831 */     GIR_EraseRootFromParent_Done,
     /* 2331832 */   // Label 32128: @2331832
     /* 2331832 */   GIM_Reject,
     /* 2331833 */ // Label 32126: @2331833
     /* 2331833 */ GIM_Reject,
     /* 2331834 */ // Label 32100: @2331834
     /* 2331834 */ GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2331943),
     /* 2331839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2331842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331850 */   GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2331896), // Rule ID 58896 //
     /* 2331855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2331858 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2331861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2331875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331895 */     // GIR_Coverage, 58896,
     /* 2331895 */     GIR_EraseRootFromParent_Done,
     /* 2331896 */   // Label 32130: @2331896
     /* 2331896 */   GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2331942), // Rule ID 58897 //
     /* 2331901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2331904 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2331907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2331921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331941 */     // GIR_Coverage, 58897,
     /* 2331941 */     GIR_EraseRootFromParent_Done,
     /* 2331942 */   // Label 32131: @2331942
     /* 2331942 */   GIM_Reject,
     /* 2331943 */ // Label 32129: @2331943
     /* 2331943 */ GIM_Reject,
     /* 2331944 */ // Label 32101: @2331944
     /* 2331944 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2332053),
     /* 2331949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2331952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2331960 */   GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2332006), // Rule ID 58906 //
     /* 2331965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2331968 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2331971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2331985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332005 */     // GIR_Coverage, 58906,
     /* 2332005 */     GIR_EraseRootFromParent_Done,
     /* 2332006 */   // Label 32133: @2332006
     /* 2332006 */   GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2332052), // Rule ID 58907 //
     /* 2332011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332014 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2332031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332051 */     // GIR_Coverage, 58907,
     /* 2332051 */     GIR_EraseRootFromParent_Done,
     /* 2332052 */   // Label 32134: @2332052
     /* 2332052 */   GIM_Reject,
     /* 2332053 */ // Label 32132: @2332053
     /* 2332053 */ GIM_Reject,
     /* 2332054 */ // Label 32102: @2332054
     /* 2332054 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2332163),
     /* 2332059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2332062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332070 */   GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2332116), // Rule ID 58898 //
     /* 2332075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332078 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2332095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332115 */     // GIR_Coverage, 58898,
     /* 2332115 */     GIR_EraseRootFromParent_Done,
     /* 2332116 */   // Label 32136: @2332116
     /* 2332116 */   GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2332162), // Rule ID 58899 //
     /* 2332121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332124 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2332141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332161 */     // GIR_Coverage, 58899,
     /* 2332161 */     GIR_EraseRootFromParent_Done,
     /* 2332162 */   // Label 32137: @2332162
     /* 2332162 */   GIM_Reject,
     /* 2332163 */ // Label 32135: @2332163
     /* 2332163 */ GIM_Reject,
     /* 2332164 */ // Label 32103: @2332164
     /* 2332164 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2332273),
     /* 2332169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2332172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332180 */   GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2332226), // Rule ID 58908 //
     /* 2332185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2332188 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2332205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332225 */     // GIR_Coverage, 58908,
     /* 2332225 */     GIR_EraseRootFromParent_Done,
     /* 2332226 */   // Label 32139: @2332226
     /* 2332226 */   GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2332272), // Rule ID 58909 //
     /* 2332231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332234 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2332251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332271 */     // GIR_Coverage, 58909,
     /* 2332271 */     GIR_EraseRootFromParent_Done,
     /* 2332272 */   // Label 32140: @2332272
     /* 2332272 */   GIM_Reject,
     /* 2332273 */ // Label 32138: @2332273
     /* 2332273 */ GIM_Reject,
     /* 2332274 */ // Label 32104: @2332274
     /* 2332274 */ GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2332383),
     /* 2332279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332290 */   GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2332336), // Rule ID 58900 //
     /* 2332295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332298 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2332315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332335 */     // GIR_Coverage, 58900,
     /* 2332335 */     GIR_EraseRootFromParent_Done,
     /* 2332336 */   // Label 32142: @2332336
     /* 2332336 */   GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2332382), // Rule ID 58901 //
     /* 2332341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332344 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2332361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332381 */     // GIR_Coverage, 58901,
     /* 2332381 */     GIR_EraseRootFromParent_Done,
     /* 2332382 */   // Label 32143: @2332382
     /* 2332382 */   GIM_Reject,
     /* 2332383 */ // Label 32141: @2332383
     /* 2332383 */ GIM_Reject,
     /* 2332384 */ // Label 32105: @2332384
     /* 2332384 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2332493),
     /* 2332389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2332392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332400 */   GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2332446), // Rule ID 58910 //
     /* 2332405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2332408 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2332425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332445 */     // GIR_Coverage, 58910,
     /* 2332445 */     GIR_EraseRootFromParent_Done,
     /* 2332446 */   // Label 32145: @2332446
     /* 2332446 */   GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2332492), // Rule ID 58911 //
     /* 2332451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2332454 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2332471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332491 */     // GIR_Coverage, 58911,
     /* 2332491 */     GIR_EraseRootFromParent_Done,
     /* 2332492 */   // Label 32146: @2332492
     /* 2332492 */   GIM_Reject,
     /* 2332493 */ // Label 32144: @2332493
     /* 2332493 */ GIM_Reject,
     /* 2332494 */ // Label 32106: @2332494
     /* 2332494 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2332603),
     /* 2332499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2332502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2332510 */   GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2332556), // Rule ID 58902 //
     /* 2332515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2332518 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2332521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2332535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332555 */     // GIR_Coverage, 58902,
     /* 2332555 */     GIR_EraseRootFromParent_Done,
     /* 2332556 */   // Label 32148: @2332556
     /* 2332556 */   GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2332602), // Rule ID 58903 //
     /* 2332561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2332564 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2332567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2332581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332601 */     // GIR_Coverage, 58903,
     /* 2332601 */     GIR_EraseRootFromParent_Done,
     /* 2332602 */   // Label 32149: @2332602
     /* 2332602 */   GIM_Reject,
     /* 2332603 */ // Label 32147: @2332603
     /* 2332603 */ GIM_Reject,
     /* 2332604 */ // Label 32107: @2332604
     /* 2332604 */ GIM_Reject,
     /* 2332605 */ // Label 67: @2332605
     /* 2332605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32173*/ GIMT_Encode4(2337490),
     /* 2332616 */ /*GILLT_s32*//*Label 32150*/ GIMT_Encode4(2332732),
     /* 2332620 */ /*GILLT_s64*//*Label 32151*/ GIMT_Encode4(2333105), GIMT_Encode4(0),
     /* 2332628 */ /*GILLT_nxv1s8*//*Label 32152*/ GIMT_Encode4(2333292),
     /* 2332632 */ /*GILLT_nxv1s16*//*Label 32153*/ GIMT_Encode4(2333396),
     /* 2332636 */ /*GILLT_nxv1s32*//*Label 32154*/ GIMT_Encode4(2333613),
     /* 2332640 */ /*GILLT_nxv1s64*//*Label 32155*/ GIMT_Encode4(2333938), GIMT_Encode4(0),
     /* 2332648 */ /*GILLT_nxv2s8*//*Label 32156*/ GIMT_Encode4(2334155),
     /* 2332652 */ /*GILLT_nxv2s16*//*Label 32157*/ GIMT_Encode4(2334259),
     /* 2332656 */ /*GILLT_nxv2s32*//*Label 32158*/ GIMT_Encode4(2334476),
     /* 2332660 */ /*GILLT_nxv2s64*//*Label 32159*/ GIMT_Encode4(2334801), GIMT_Encode4(0),
     /* 2332668 */ /*GILLT_nxv4s8*//*Label 32160*/ GIMT_Encode4(2335018),
     /* 2332672 */ /*GILLT_nxv4s16*//*Label 32161*/ GIMT_Encode4(2335122),
     /* 2332676 */ /*GILLT_nxv4s32*//*Label 32162*/ GIMT_Encode4(2335339),
     /* 2332680 */ /*GILLT_nxv4s64*//*Label 32163*/ GIMT_Encode4(2335664), GIMT_Encode4(0),
     /* 2332688 */ /*GILLT_nxv8s8*//*Label 32164*/ GIMT_Encode4(2335881),
     /* 2332692 */ /*GILLT_nxv8s16*//*Label 32165*/ GIMT_Encode4(2335985),
     /* 2332696 */ /*GILLT_nxv8s32*//*Label 32166*/ GIMT_Encode4(2336202),
     /* 2332700 */ /*GILLT_nxv8s64*//*Label 32167*/ GIMT_Encode4(2336527), GIMT_Encode4(0),
     /* 2332708 */ /*GILLT_nxv16s8*//*Label 32168*/ GIMT_Encode4(2336744),
     /* 2332712 */ /*GILLT_nxv16s16*//*Label 32169*/ GIMT_Encode4(2336848),
     /* 2332716 */ /*GILLT_nxv16s32*//*Label 32170*/ GIMT_Encode4(2337065), GIMT_Encode4(0),
     /* 2332724 */ /*GILLT_nxv32s8*//*Label 32171*/ GIMT_Encode4(2337282),
     /* 2332728 */ /*GILLT_nxv32s16*//*Label 32172*/ GIMT_Encode4(2337386),
     /* 2332732 */ // Label 32150: @2332732
     /* 2332732 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2332763), // Rule ID 1456 //
     /* 2332737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2332740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2332751 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2332754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332756 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332762 */   // GIR_Coverage, 1456,
     /* 2332762 */   GIR_EraseRootFromParent_Done,
     /* 2332763 */ // Label 32174: @2332763
     /* 2332763 */ GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2332794), // Rule ID 1457 //
     /* 2332768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2332771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2332782 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2332782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2332785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332787 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332793 */   // GIR_Coverage, 1457,
     /* 2332793 */   GIR_EraseRootFromParent_Done,
     /* 2332794 */ // Label 32175: @2332794
     /* 2332794 */ GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2332825), // Rule ID 1482 //
     /* 2332799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2332802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332813 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2332813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2332816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332818 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332824 */   // GIR_Coverage, 1482,
     /* 2332824 */   GIR_EraseRootFromParent_Done,
     /* 2332825 */ // Label 32176: @2332825
     /* 2332825 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2332856), // Rule ID 1483 //
     /* 2332830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2332833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2332836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2332844 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2332844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2332847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332849 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332855 */   // GIR_Coverage, 1483,
     /* 2332855 */   GIR_EraseRootFromParent_Done,
     /* 2332856 */ // Label 32177: @2332856
     /* 2332856 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2332887), // Rule ID 1850 //
     /* 2332861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2332864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332875 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2332878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332880 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332886 */   // GIR_Coverage, 1850,
     /* 2332886 */   GIR_EraseRootFromParent_Done,
     /* 2332887 */ // Label 32178: @2332887
     /* 2332887 */ GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2332918), // Rule ID 1851 //
     /* 2332892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2332895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2332906 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2332909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332917 */   // GIR_Coverage, 1851,
     /* 2332917 */   GIR_EraseRootFromParent_Done,
     /* 2332918 */ // Label 32179: @2332918
     /* 2332918 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2332949), // Rule ID 1876 //
     /* 2332923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2332926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332937 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2332937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2332940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332942 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332948 */   // GIR_Coverage, 1876,
     /* 2332948 */   GIR_EraseRootFromParent_Done,
     /* 2332949 */ // Label 32180: @2332949
     /* 2332949 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2332980), // Rule ID 1877 //
     /* 2332954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2332957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2332960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2332968 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2332968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2332971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332979 */   // GIR_Coverage, 1877,
     /* 2332979 */   GIR_EraseRootFromParent_Done,
     /* 2332980 */ // Label 32181: @2332980
     /* 2332980 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2333011), // Rule ID 2192 //
     /* 2332985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2332988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2332999 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2333002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333004 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333010 */   // GIR_Coverage, 2192,
     /* 2333010 */   GIR_EraseRootFromParent_Done,
     /* 2333011 */ // Label 32182: @2333011
     /* 2333011 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2333042), // Rule ID 2193 //
     /* 2333016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2333019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333030 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2333030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2333033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333035 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333041 */   // GIR_Coverage, 2193,
     /* 2333041 */   GIR_EraseRootFromParent_Done,
     /* 2333042 */ // Label 32183: @2333042
     /* 2333042 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2333073), // Rule ID 2218 //
     /* 2333047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2333050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333061 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2333064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333066 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333072 */   // GIR_Coverage, 2218,
     /* 2333072 */   GIR_EraseRootFromParent_Done,
     /* 2333073 */ // Label 32184: @2333073
     /* 2333073 */ GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2333104), // Rule ID 2219 //
     /* 2333078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2333081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333092 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2333092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2333095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333097 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333103 */   // GIR_Coverage, 2219,
     /* 2333103 */   GIR_EraseRootFromParent_Done,
     /* 2333104 */ // Label 32185: @2333104
     /* 2333104 */ GIM_Reject,
     /* 2333105 */ // Label 32151: @2333105
     /* 2333105 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2333136), // Rule ID 1513 //
     /* 2333110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2333113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2333116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2333124 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2333124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2333127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333135 */   // GIR_Coverage, 1513,
     /* 2333135 */   GIR_EraseRootFromParent_Done,
     /* 2333136 */ // Label 32186: @2333136
     /* 2333136 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2333167), // Rule ID 1541 //
     /* 2333141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2333144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2333147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2333155 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2333155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2333158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333160 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333166 */   // GIR_Coverage, 1541,
     /* 2333166 */   GIR_EraseRootFromParent_Done,
     /* 2333167 */ // Label 32187: @2333167
     /* 2333167 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2333198), // Rule ID 1913 //
     /* 2333172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2333175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2333178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2333186 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2333186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2333189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333191 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333197 */   // GIR_Coverage, 1913,
     /* 2333197 */   GIR_EraseRootFromParent_Done,
     /* 2333198 */ // Label 32188: @2333198
     /* 2333198 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2333229), // Rule ID 1941 //
     /* 2333203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2333206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2333209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333217 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2333217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2333220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333222 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333228 */   // GIR_Coverage, 1941,
     /* 2333228 */   GIR_EraseRootFromParent_Done,
     /* 2333229 */ // Label 32189: @2333229
     /* 2333229 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2333260), // Rule ID 2247 //
     /* 2333234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2333237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333248 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2333251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333253 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333259 */   // GIR_Coverage, 2247,
     /* 2333259 */   GIR_EraseRootFromParent_Done,
     /* 2333260 */ // Label 32190: @2333260
     /* 2333260 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2333291), // Rule ID 2273 //
     /* 2333265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2333268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2333275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333279 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2333279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2333282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333284 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2333289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333290 */   // GIR_Coverage, 2273,
     /* 2333290 */   GIR_EraseRootFromParent_Done,
     /* 2333291 */ // Label 32191: @2333291
     /* 2333291 */ GIM_Reject,
     /* 2333292 */ // Label 32152: @2333292
     /* 2333292 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2333395),
     /* 2333297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333308 */   GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2333351), // Rule ID 45824 //
     /* 2333313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333316 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2333319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2333333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333350 */     // GIR_Coverage, 45824,
     /* 2333350 */     GIR_EraseRootFromParent_Done,
     /* 2333351 */   // Label 32193: @2333351
     /* 2333351 */   GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2333394), // Rule ID 45825 //
     /* 2333356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333359 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2333362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2333376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333393 */     // GIR_Coverage, 45825,
     /* 2333393 */     GIR_EraseRootFromParent_Done,
     /* 2333394 */   // Label 32194: @2333394
     /* 2333394 */   GIM_Reject,
     /* 2333395 */ // Label 32192: @2333395
     /* 2333395 */ GIM_Reject,
     /* 2333396 */ // Label 32153: @2333396
     /* 2333396 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2333450), // Rule ID 45808 //
     /* 2333401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333415 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2333432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333449 */   // GIR_Coverage, 45808,
     /* 2333449 */   GIR_EraseRootFromParent_Done,
     /* 2333450 */ // Label 32195: @2333450
     /* 2333450 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2333504), // Rule ID 45809 //
     /* 2333455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333469 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2333486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333491 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333503 */   // GIR_Coverage, 45809,
     /* 2333503 */   GIR_EraseRootFromParent_Done,
     /* 2333504 */ // Label 32196: @2333504
     /* 2333504 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2333558), // Rule ID 58732 //
     /* 2333509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333523 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2333540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333545 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333557 */   // GIR_Coverage, 58732,
     /* 2333557 */   GIR_EraseRootFromParent_Done,
     /* 2333558 */ // Label 32197: @2333558
     /* 2333558 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2333612), // Rule ID 58733 //
     /* 2333563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333577 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2333580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2333594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333599 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333611 */   // GIR_Coverage, 58733,
     /* 2333611 */   GIR_EraseRootFromParent_Done,
     /* 2333612 */ // Label 32198: @2333612
     /* 2333612 */ GIM_Reject,
     /* 2333613 */ // Label 32154: @2333613
     /* 2333613 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2333667), // Rule ID 45816 //
     /* 2333618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333632 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2333649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333654 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333666 */   // GIR_Coverage, 45816,
     /* 2333666 */   GIR_EraseRootFromParent_Done,
     /* 2333667 */ // Label 32199: @2333667
     /* 2333667 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2333721), // Rule ID 45817 //
     /* 2333672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2333678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333686 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2333703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333708 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333720 */   // GIR_Coverage, 45817,
     /* 2333720 */   GIR_EraseRootFromParent_Done,
     /* 2333721 */ // Label 32200: @2333721
     /* 2333721 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2333775), // Rule ID 58300 //
     /* 2333726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333740 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2333757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333762 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333774 */   // GIR_Coverage, 58300,
     /* 2333774 */   GIR_EraseRootFromParent_Done,
     /* 2333775 */ // Label 32201: @2333775
     /* 2333775 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2333829), // Rule ID 58301 //
     /* 2333780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2333786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333794 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2333811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333816 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333828 */   // GIR_Coverage, 58301,
     /* 2333828 */   GIR_EraseRootFromParent_Done,
     /* 2333829 */ // Label 32202: @2333829
     /* 2333829 */ GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2333883), // Rule ID 58752 //
     /* 2333834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333848 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2333865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333882 */   // GIR_Coverage, 58752,
     /* 2333882 */   GIR_EraseRootFromParent_Done,
     /* 2333883 */ // Label 32203: @2333883
     /* 2333883 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2333937), // Rule ID 58753 //
     /* 2333888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333902 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2333905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2333919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333936 */   // GIR_Coverage, 58753,
     /* 2333936 */   GIR_EraseRootFromParent_Done,
     /* 2333937 */ // Label 32204: @2333937
     /* 2333937 */ GIM_Reject,
     /* 2333938 */ // Label 32155: @2333938
     /* 2333938 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2333992), // Rule ID 58312 //
     /* 2333943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2333949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333957 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2333960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2333974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333979 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333991 */   // GIR_Coverage, 58312,
     /* 2333991 */   GIR_EraseRootFromParent_Done,
     /* 2333992 */ // Label 32205: @2333992
     /* 2333992 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2334046), // Rule ID 58313 //
     /* 2333997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2334003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334011 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334033 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334045 */   // GIR_Coverage, 58313,
     /* 2334045 */   GIR_EraseRootFromParent_Done,
     /* 2334046 */ // Label 32206: @2334046
     /* 2334046 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2334100), // Rule ID 58544 //
     /* 2334051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334065 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334099 */   // GIR_Coverage, 58544,
     /* 2334099 */   GIR_EraseRootFromParent_Done,
     /* 2334100 */ // Label 32207: @2334100
     /* 2334100 */ GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2334154), // Rule ID 58545 //
     /* 2334105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2334111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334119 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2334122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334153 */   // GIR_Coverage, 58545,
     /* 2334153 */   GIR_EraseRootFromParent_Done,
     /* 2334154 */ // Label 32208: @2334154
     /* 2334154 */ GIM_Reject,
     /* 2334155 */ // Label 32156: @2334155
     /* 2334155 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2334258),
     /* 2334160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334171 */   GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2334214), // Rule ID 58712 //
     /* 2334176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334179 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2334182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2334196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334213 */     // GIR_Coverage, 58712,
     /* 2334213 */     GIR_EraseRootFromParent_Done,
     /* 2334214 */   // Label 32210: @2334214
     /* 2334214 */   GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2334257), // Rule ID 58713 //
     /* 2334219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334222 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2334225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2334239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334256 */     // GIR_Coverage, 58713,
     /* 2334256 */     GIR_EraseRootFromParent_Done,
     /* 2334257 */   // Label 32211: @2334257
     /* 2334257 */   GIM_Reject,
     /* 2334258 */ // Label 32209: @2334258
     /* 2334258 */ GIM_Reject,
     /* 2334259 */ // Label 32157: @2334259
     /* 2334259 */ GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2334313), // Rule ID 58296 //
     /* 2334264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334278 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2334295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334312 */   // GIR_Coverage, 58296,
     /* 2334312 */   GIR_EraseRootFromParent_Done,
     /* 2334313 */ // Label 32212: @2334313
     /* 2334313 */ GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2334367), // Rule ID 58297 //
     /* 2334318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334332 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2334349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334366 */   // GIR_Coverage, 58297,
     /* 2334366 */   GIR_EraseRootFromParent_Done,
     /* 2334367 */ // Label 32213: @2334367
     /* 2334367 */ GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2334421), // Rule ID 58736 //
     /* 2334372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334386 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2334403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334408 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334420 */   // GIR_Coverage, 58736,
     /* 2334420 */   GIR_EraseRootFromParent_Done,
     /* 2334421 */ // Label 32214: @2334421
     /* 2334421 */ GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2334475), // Rule ID 58737 //
     /* 2334426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334440 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2334443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2334457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334462 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334474 */   // GIR_Coverage, 58737,
     /* 2334474 */   GIR_EraseRootFromParent_Done,
     /* 2334475 */ // Label 32215: @2334475
     /* 2334475 */ GIM_Reject,
     /* 2334476 */ // Label 32158: @2334476
     /* 2334476 */ GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2334530), // Rule ID 58308 //
     /* 2334481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334495 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334517 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334529 */   // GIR_Coverage, 58308,
     /* 2334529 */   GIR_EraseRootFromParent_Done,
     /* 2334530 */ // Label 32216: @2334530
     /* 2334530 */ GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2334584), // Rule ID 58309 //
     /* 2334535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334549 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2334566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334583 */   // GIR_Coverage, 58309,
     /* 2334583 */   GIR_EraseRootFromParent_Done,
     /* 2334584 */ // Label 32217: @2334584
     /* 2334584 */ GIM_Try, /*On fail goto*//*Label 32218*/ GIMT_Encode4(2334638), // Rule ID 58528 //
     /* 2334589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334603 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334625 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334637 */   // GIR_Coverage, 58528,
     /* 2334637 */   GIR_EraseRootFromParent_Done,
     /* 2334638 */ // Label 32218: @2334638
     /* 2334638 */ GIM_Try, /*On fail goto*//*Label 32219*/ GIMT_Encode4(2334692), // Rule ID 58529 //
     /* 2334643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2334649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334657 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2334674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334679 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334691 */   // GIR_Coverage, 58529,
     /* 2334691 */   GIR_EraseRootFromParent_Done,
     /* 2334692 */ // Label 32219: @2334692
     /* 2334692 */ GIM_Try, /*On fail goto*//*Label 32220*/ GIMT_Encode4(2334746), // Rule ID 58756 //
     /* 2334697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334711 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2334728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334733 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334745 */   // GIR_Coverage, 58756,
     /* 2334745 */   GIR_EraseRootFromParent_Done,
     /* 2334746 */ // Label 32220: @2334746
     /* 2334746 */ GIM_Try, /*On fail goto*//*Label 32221*/ GIMT_Encode4(2334800), // Rule ID 58757 //
     /* 2334751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2334754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334765 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2334768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2334782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334787 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334799 */   // GIR_Coverage, 58757,
     /* 2334799 */   GIR_EraseRootFromParent_Done,
     /* 2334800 */ // Label 32221: @2334800
     /* 2334800 */ GIM_Reject,
     /* 2334801 */ // Label 32159: @2334801
     /* 2334801 */ GIM_Try, /*On fail goto*//*Label 32222*/ GIMT_Encode4(2334855), // Rule ID 58340 //
     /* 2334806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2334809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334820 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2334837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334842 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334854 */   // GIR_Coverage, 58340,
     /* 2334854 */   GIR_EraseRootFromParent_Done,
     /* 2334855 */ // Label 32222: @2334855
     /* 2334855 */ GIM_Try, /*On fail goto*//*Label 32223*/ GIMT_Encode4(2334909), // Rule ID 58341 //
     /* 2334860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2334866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334874 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2334891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334896 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334908 */   // GIR_Coverage, 58341,
     /* 2334908 */   GIR_EraseRootFromParent_Done,
     /* 2334909 */ // Label 32223: @2334909
     /* 2334909 */ GIM_Try, /*On fail goto*//*Label 32224*/ GIMT_Encode4(2334963), // Rule ID 58548 //
     /* 2334914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334928 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2334945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334950 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334962 */   // GIR_Coverage, 58548,
     /* 2334962 */   GIR_EraseRootFromParent_Done,
     /* 2334963 */ // Label 32224: @2334963
     /* 2334963 */ GIM_Try, /*On fail goto*//*Label 32225*/ GIMT_Encode4(2335017), // Rule ID 58549 //
     /* 2334968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2334974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334982 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2334985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2334999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335004 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335016 */   // GIR_Coverage, 58549,
     /* 2335016 */   GIR_EraseRootFromParent_Done,
     /* 2335017 */ // Label 32225: @2335017
     /* 2335017 */ GIM_Reject,
     /* 2335018 */ // Label 32160: @2335018
     /* 2335018 */ GIM_Try, /*On fail goto*//*Label 32226*/ GIMT_Encode4(2335121),
     /* 2335023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335034 */   GIM_Try, /*On fail goto*//*Label 32227*/ GIMT_Encode4(2335077), // Rule ID 58716 //
     /* 2335039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335042 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2335045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2335059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335076 */     // GIR_Coverage, 58716,
     /* 2335076 */     GIR_EraseRootFromParent_Done,
     /* 2335077 */   // Label 32227: @2335077
     /* 2335077 */   GIM_Try, /*On fail goto*//*Label 32228*/ GIMT_Encode4(2335120), // Rule ID 58717 //
     /* 2335082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335085 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2335088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2335102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335119 */     // GIR_Coverage, 58717,
     /* 2335119 */     GIR_EraseRootFromParent_Done,
     /* 2335120 */   // Label 32228: @2335120
     /* 2335120 */   GIM_Reject,
     /* 2335121 */ // Label 32226: @2335121
     /* 2335121 */ GIM_Reject,
     /* 2335122 */ // Label 32161: @2335122
     /* 2335122 */ GIM_Try, /*On fail goto*//*Label 32229*/ GIMT_Encode4(2335176), // Rule ID 58304 //
     /* 2335127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335141 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2335158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335163 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335175 */   // GIR_Coverage, 58304,
     /* 2335175 */   GIR_EraseRootFromParent_Done,
     /* 2335176 */ // Label 32229: @2335176
     /* 2335176 */ GIM_Try, /*On fail goto*//*Label 32230*/ GIMT_Encode4(2335230), // Rule ID 58305 //
     /* 2335181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335195 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2335212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335229 */   // GIR_Coverage, 58305,
     /* 2335229 */   GIR_EraseRootFromParent_Done,
     /* 2335230 */ // Label 32230: @2335230
     /* 2335230 */ GIM_Try, /*On fail goto*//*Label 32231*/ GIMT_Encode4(2335284), // Rule ID 58740 //
     /* 2335235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335249 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335271 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335283 */   // GIR_Coverage, 58740,
     /* 2335283 */   GIR_EraseRootFromParent_Done,
     /* 2335284 */ // Label 32231: @2335284
     /* 2335284 */ GIM_Try, /*On fail goto*//*Label 32232*/ GIMT_Encode4(2335338), // Rule ID 58741 //
     /* 2335289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335303 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2335306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335325 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335337 */   // GIR_Coverage, 58741,
     /* 2335337 */   GIR_EraseRootFromParent_Done,
     /* 2335338 */ // Label 32232: @2335338
     /* 2335338 */ GIM_Reject,
     /* 2335339 */ // Label 32162: @2335339
     /* 2335339 */ GIM_Try, /*On fail goto*//*Label 32233*/ GIMT_Encode4(2335393), // Rule ID 58328 //
     /* 2335344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335358 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2335375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335392 */   // GIR_Coverage, 58328,
     /* 2335392 */   GIR_EraseRootFromParent_Done,
     /* 2335393 */ // Label 32233: @2335393
     /* 2335393 */ GIM_Try, /*On fail goto*//*Label 32234*/ GIMT_Encode4(2335447), // Rule ID 58329 //
     /* 2335398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335412 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2335429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335446 */   // GIR_Coverage, 58329,
     /* 2335446 */   GIR_EraseRootFromParent_Done,
     /* 2335447 */ // Label 32234: @2335447
     /* 2335447 */ GIM_Try, /*On fail goto*//*Label 32235*/ GIMT_Encode4(2335501), // Rule ID 58532 //
     /* 2335452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335466 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2335483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335488 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335500 */   // GIR_Coverage, 58532,
     /* 2335500 */   GIR_EraseRootFromParent_Done,
     /* 2335501 */ // Label 32235: @2335501
     /* 2335501 */ GIM_Try, /*On fail goto*//*Label 32236*/ GIMT_Encode4(2335555), // Rule ID 58533 //
     /* 2335506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2335512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335520 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2335537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335542 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335554 */   // GIR_Coverage, 58533,
     /* 2335554 */   GIR_EraseRootFromParent_Done,
     /* 2335555 */ // Label 32236: @2335555
     /* 2335555 */ GIM_Try, /*On fail goto*//*Label 32237*/ GIMT_Encode4(2335609), // Rule ID 58760 //
     /* 2335560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335574 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2335591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335608 */   // GIR_Coverage, 58760,
     /* 2335608 */   GIR_EraseRootFromParent_Done,
     /* 2335609 */ // Label 32237: @2335609
     /* 2335609 */ GIM_Try, /*On fail goto*//*Label 32238*/ GIMT_Encode4(2335663), // Rule ID 58761 //
     /* 2335614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335628 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2335631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2335645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335662 */   // GIR_Coverage, 58761,
     /* 2335662 */   GIR_EraseRootFromParent_Done,
     /* 2335663 */ // Label 32238: @2335663
     /* 2335663 */ GIM_Reject,
     /* 2335664 */ // Label 32163: @2335664
     /* 2335664 */ GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2335718), // Rule ID 58344 //
     /* 2335669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2335672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335683 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2335700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335705 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335717 */   // GIR_Coverage, 58344,
     /* 2335717 */   GIR_EraseRootFromParent_Done,
     /* 2335718 */ // Label 32239: @2335718
     /* 2335718 */ GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2335772), // Rule ID 58345 //
     /* 2335723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2335726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2335729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335737 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2335754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335759 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335771 */   // GIR_Coverage, 58345,
     /* 2335771 */   GIR_EraseRootFromParent_Done,
     /* 2335772 */ // Label 32240: @2335772
     /* 2335772 */ GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2335826), // Rule ID 58552 //
     /* 2335777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2335780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335791 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2335808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335813 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335825 */   // GIR_Coverage, 58552,
     /* 2335825 */   GIR_EraseRootFromParent_Done,
     /* 2335826 */ // Label 32241: @2335826
     /* 2335826 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2335880), // Rule ID 58553 //
     /* 2335831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2335837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335845 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2335848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2335862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335879 */   // GIR_Coverage, 58553,
     /* 2335879 */   GIR_EraseRootFromParent_Done,
     /* 2335880 */ // Label 32242: @2335880
     /* 2335880 */ GIM_Reject,
     /* 2335881 */ // Label 32164: @2335881
     /* 2335881 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2335984),
     /* 2335886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335897 */   GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2335940), // Rule ID 58720 //
     /* 2335902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335905 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335939 */     // GIR_Coverage, 58720,
     /* 2335939 */     GIR_EraseRootFromParent_Done,
     /* 2335940 */   // Label 32244: @2335940
     /* 2335940 */   GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2335983), // Rule ID 58721 //
     /* 2335945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335948 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2335951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2335965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335982 */     // GIR_Coverage, 58721,
     /* 2335982 */     GIR_EraseRootFromParent_Done,
     /* 2335983 */   // Label 32245: @2335983
     /* 2335983 */   GIM_Reject,
     /* 2335984 */ // Label 32243: @2335984
     /* 2335984 */ GIM_Reject,
     /* 2335985 */ // Label 32165: @2335985
     /* 2335985 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2336039), // Rule ID 58316 //
     /* 2335990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336004 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2336021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336026 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336038 */   // GIR_Coverage, 58316,
     /* 2336038 */   GIR_EraseRootFromParent_Done,
     /* 2336039 */ // Label 32246: @2336039
     /* 2336039 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2336093), // Rule ID 58317 //
     /* 2336044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336058 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2336075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336080 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336092 */   // GIR_Coverage, 58317,
     /* 2336092 */   GIR_EraseRootFromParent_Done,
     /* 2336093 */ // Label 32247: @2336093
     /* 2336093 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2336147), // Rule ID 58744 //
     /* 2336098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336112 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336134 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336146 */   // GIR_Coverage, 58744,
     /* 2336146 */   GIR_EraseRootFromParent_Done,
     /* 2336147 */ // Label 32248: @2336147
     /* 2336147 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2336201), // Rule ID 58745 //
     /* 2336152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336166 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2336169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336188 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336200 */   // GIR_Coverage, 58745,
     /* 2336200 */   GIR_EraseRootFromParent_Done,
     /* 2336201 */ // Label 32249: @2336201
     /* 2336201 */ GIM_Reject,
     /* 2336202 */ // Label 32166: @2336202
     /* 2336202 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2336256), // Rule ID 58332 //
     /* 2336207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336221 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336255 */   // GIR_Coverage, 58332,
     /* 2336255 */   GIR_EraseRootFromParent_Done,
     /* 2336256 */ // Label 32250: @2336256
     /* 2336256 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2336310), // Rule ID 58333 //
     /* 2336261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2336264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336275 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336309 */   // GIR_Coverage, 58333,
     /* 2336309 */   GIR_EraseRootFromParent_Done,
     /* 2336310 */ // Label 32251: @2336310
     /* 2336310 */ GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2336364), // Rule ID 58536 //
     /* 2336315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336329 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2336346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336351 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336363 */   // GIR_Coverage, 58536,
     /* 2336363 */   GIR_EraseRootFromParent_Done,
     /* 2336364 */ // Label 32252: @2336364
     /* 2336364 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2336418), // Rule ID 58537 //
     /* 2336369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2336375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336383 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2336400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336405 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336417 */   // GIR_Coverage, 58537,
     /* 2336417 */   GIR_EraseRootFromParent_Done,
     /* 2336418 */ // Label 32253: @2336418
     /* 2336418 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2336472), // Rule ID 58764 //
     /* 2336423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2336426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336437 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2336454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336459 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336471 */   // GIR_Coverage, 58764,
     /* 2336471 */   GIR_EraseRootFromParent_Done,
     /* 2336472 */ // Label 32254: @2336472
     /* 2336472 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2336526), // Rule ID 58765 //
     /* 2336477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2336480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336491 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2336494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2336508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336513 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336525 */   // GIR_Coverage, 58765,
     /* 2336525 */   GIR_EraseRootFromParent_Done,
     /* 2336526 */ // Label 32255: @2336526
     /* 2336526 */ GIM_Reject,
     /* 2336527 */ // Label 32167: @2336527
     /* 2336527 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2336581), // Rule ID 58348 //
     /* 2336532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2336535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336546 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2336563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336580 */   // GIR_Coverage, 58348,
     /* 2336580 */   GIR_EraseRootFromParent_Done,
     /* 2336581 */ // Label 32256: @2336581
     /* 2336581 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2336635), // Rule ID 58349 //
     /* 2336586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2336589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2336592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336600 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2336617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336622 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336634 */   // GIR_Coverage, 58349,
     /* 2336634 */   GIR_EraseRootFromParent_Done,
     /* 2336635 */ // Label 32257: @2336635
     /* 2336635 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2336689), // Rule ID 58556 //
     /* 2336640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2336643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336654 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2336671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336676 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336688 */   // GIR_Coverage, 58556,
     /* 2336688 */   GIR_EraseRootFromParent_Done,
     /* 2336689 */ // Label 32258: @2336689
     /* 2336689 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2336743), // Rule ID 58557 //
     /* 2336694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2336697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2336700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336708 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2336711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2336725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336730 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336742 */   // GIR_Coverage, 58557,
     /* 2336742 */   GIR_EraseRootFromParent_Done,
     /* 2336743 */ // Label 32259: @2336743
     /* 2336743 */ GIM_Reject,
     /* 2336744 */ // Label 32168: @2336744
     /* 2336744 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2336847),
     /* 2336749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336760 */   GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2336803), // Rule ID 58724 //
     /* 2336765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336768 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2336771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336802 */     // GIR_Coverage, 58724,
     /* 2336802 */     GIR_EraseRootFromParent_Done,
     /* 2336803 */   // Label 32261: @2336803
     /* 2336803 */   GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2336846), // Rule ID 58725 //
     /* 2336808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336811 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2336814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2336828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336845 */     // GIR_Coverage, 58725,
     /* 2336845 */     GIR_EraseRootFromParent_Done,
     /* 2336846 */   // Label 32262: @2336846
     /* 2336846 */   GIM_Reject,
     /* 2336847 */ // Label 32260: @2336847
     /* 2336847 */ GIM_Reject,
     /* 2336848 */ // Label 32169: @2336848
     /* 2336848 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2336902), // Rule ID 58320 //
     /* 2336853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336867 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336901 */   // GIR_Coverage, 58320,
     /* 2336901 */   GIR_EraseRootFromParent_Done,
     /* 2336902 */ // Label 32263: @2336902
     /* 2336902 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2336956), // Rule ID 58321 //
     /* 2336907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2336913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336921 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2336938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336943 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336955 */   // GIR_Coverage, 58321,
     /* 2336955 */   GIR_EraseRootFromParent_Done,
     /* 2336956 */ // Label 32264: @2336956
     /* 2336956 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2337010), // Rule ID 58748 //
     /* 2336961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2336964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2336967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336975 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2336978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2336992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336997 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337009 */   // GIR_Coverage, 58748,
     /* 2337009 */   GIR_EraseRootFromParent_Done,
     /* 2337010 */ // Label 32265: @2337010
     /* 2337010 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2337064), // Rule ID 58749 //
     /* 2337015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337029 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2337032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337051 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337063 */   // GIR_Coverage, 58749,
     /* 2337063 */   GIR_EraseRootFromParent_Done,
     /* 2337064 */ // Label 32266: @2337064
     /* 2337064 */ GIM_Reject,
     /* 2337065 */ // Label 32170: @2337065
     /* 2337065 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2337119), // Rule ID 58336 //
     /* 2337070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337084 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337106 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337118 */   // GIR_Coverage, 58336,
     /* 2337118 */   GIR_EraseRootFromParent_Done,
     /* 2337119 */ // Label 32267: @2337119
     /* 2337119 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2337173), // Rule ID 58337 //
     /* 2337124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337138 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337160 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337172 */   // GIR_Coverage, 58337,
     /* 2337172 */   GIR_EraseRootFromParent_Done,
     /* 2337173 */ // Label 32268: @2337173
     /* 2337173 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2337227), // Rule ID 58540 //
     /* 2337178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2337184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337192 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2337209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337214 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337225 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337226 */   // GIR_Coverage, 58540,
     /* 2337226 */   GIR_EraseRootFromParent_Done,
     /* 2337227 */ // Label 32269: @2337227
     /* 2337227 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2337281), // Rule ID 58541 //
     /* 2337232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2337238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337246 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2337263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337268 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337279 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337280 */   // GIR_Coverage, 58541,
     /* 2337280 */   GIR_EraseRootFromParent_Done,
     /* 2337281 */ // Label 32270: @2337281
     /* 2337281 */ GIM_Reject,
     /* 2337282 */ // Label 32171: @2337282
     /* 2337282 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2337385),
     /* 2337287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2337290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337298 */   GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2337341), // Rule ID 58728 //
     /* 2337303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337306 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2337309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337340 */     // GIR_Coverage, 58728,
     /* 2337340 */     GIR_EraseRootFromParent_Done,
     /* 2337341 */   // Label 32272: @2337341
     /* 2337341 */   GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2337384), // Rule ID 58729 //
     /* 2337346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337349 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2337352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2337366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337383 */     // GIR_Coverage, 58729,
     /* 2337383 */     GIR_EraseRootFromParent_Done,
     /* 2337384 */   // Label 32273: @2337384
     /* 2337384 */   GIM_Reject,
     /* 2337385 */ // Label 32271: @2337385
     /* 2337385 */ GIM_Reject,
     /* 2337386 */ // Label 32172: @2337386
     /* 2337386 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2337489),
     /* 2337391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2337394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337402 */   GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2337445), // Rule ID 58324 //
     /* 2337407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337410 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337444 */     // GIR_Coverage, 58324,
     /* 2337444 */     GIR_EraseRootFromParent_Done,
     /* 2337445 */   // Label 32275: @2337445
     /* 2337445 */   GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2337488), // Rule ID 58325 //
     /* 2337450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337453 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2337470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337487 */     // GIR_Coverage, 58325,
     /* 2337487 */     GIR_EraseRootFromParent_Done,
     /* 2337488 */   // Label 32276: @2337488
     /* 2337488 */   GIM_Reject,
     /* 2337489 */ // Label 32274: @2337489
     /* 2337489 */ GIM_Reject,
     /* 2337490 */ // Label 32173: @2337490
     /* 2337490 */ GIM_Reject,
     /* 2337491 */ // Label 68: @2337491
     /* 2337491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32300*/ GIMT_Encode4(2342376),
     /* 2337502 */ /*GILLT_s32*//*Label 32277*/ GIMT_Encode4(2337618),
     /* 2337506 */ /*GILLT_s64*//*Label 32278*/ GIMT_Encode4(2337991), GIMT_Encode4(0),
     /* 2337514 */ /*GILLT_nxv1s8*//*Label 32279*/ GIMT_Encode4(2338178),
     /* 2337518 */ /*GILLT_nxv1s16*//*Label 32280*/ GIMT_Encode4(2338282),
     /* 2337522 */ /*GILLT_nxv1s32*//*Label 32281*/ GIMT_Encode4(2338499),
     /* 2337526 */ /*GILLT_nxv1s64*//*Label 32282*/ GIMT_Encode4(2338824), GIMT_Encode4(0),
     /* 2337534 */ /*GILLT_nxv2s8*//*Label 32283*/ GIMT_Encode4(2339041),
     /* 2337538 */ /*GILLT_nxv2s16*//*Label 32284*/ GIMT_Encode4(2339145),
     /* 2337542 */ /*GILLT_nxv2s32*//*Label 32285*/ GIMT_Encode4(2339362),
     /* 2337546 */ /*GILLT_nxv2s64*//*Label 32286*/ GIMT_Encode4(2339687), GIMT_Encode4(0),
     /* 2337554 */ /*GILLT_nxv4s8*//*Label 32287*/ GIMT_Encode4(2339904),
     /* 2337558 */ /*GILLT_nxv4s16*//*Label 32288*/ GIMT_Encode4(2340008),
     /* 2337562 */ /*GILLT_nxv4s32*//*Label 32289*/ GIMT_Encode4(2340225),
     /* 2337566 */ /*GILLT_nxv4s64*//*Label 32290*/ GIMT_Encode4(2340550), GIMT_Encode4(0),
     /* 2337574 */ /*GILLT_nxv8s8*//*Label 32291*/ GIMT_Encode4(2340767),
     /* 2337578 */ /*GILLT_nxv8s16*//*Label 32292*/ GIMT_Encode4(2340871),
     /* 2337582 */ /*GILLT_nxv8s32*//*Label 32293*/ GIMT_Encode4(2341088),
     /* 2337586 */ /*GILLT_nxv8s64*//*Label 32294*/ GIMT_Encode4(2341413), GIMT_Encode4(0),
     /* 2337594 */ /*GILLT_nxv16s8*//*Label 32295*/ GIMT_Encode4(2341630),
     /* 2337598 */ /*GILLT_nxv16s16*//*Label 32296*/ GIMT_Encode4(2341734),
     /* 2337602 */ /*GILLT_nxv16s32*//*Label 32297*/ GIMT_Encode4(2341951), GIMT_Encode4(0),
     /* 2337610 */ /*GILLT_nxv32s8*//*Label 32298*/ GIMT_Encode4(2342168),
     /* 2337614 */ /*GILLT_nxv32s16*//*Label 32299*/ GIMT_Encode4(2342272),
     /* 2337618 */ // Label 32277: @2337618
     /* 2337618 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2337649), // Rule ID 1460 //
     /* 2337623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2337626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337637 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2337637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2337640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337648 */   // GIR_Coverage, 1460,
     /* 2337648 */   GIR_EraseRootFromParent_Done,
     /* 2337649 */ // Label 32301: @2337649
     /* 2337649 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2337680), // Rule ID 1461 //
     /* 2337654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2337657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2337668 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2337668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2337671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337679 */   // GIR_Coverage, 1461,
     /* 2337679 */   GIR_EraseRootFromParent_Done,
     /* 2337680 */ // Label 32302: @2337680
     /* 2337680 */ GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2337711), // Rule ID 1486 //
     /* 2337685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2337688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337699 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2337699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2337702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337710 */   // GIR_Coverage, 1486,
     /* 2337710 */   GIR_EraseRootFromParent_Done,
     /* 2337711 */ // Label 32303: @2337711
     /* 2337711 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2337742), // Rule ID 1487 //
     /* 2337716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2337719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2337730 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2337730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2337733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337735 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337741 */   // GIR_Coverage, 1487,
     /* 2337741 */   GIR_EraseRootFromParent_Done,
     /* 2337742 */ // Label 32304: @2337742
     /* 2337742 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2337773), // Rule ID 1854 //
     /* 2337747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2337750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337761 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2337761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2337764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337772 */   // GIR_Coverage, 1854,
     /* 2337772 */   GIR_EraseRootFromParent_Done,
     /* 2337773 */ // Label 32305: @2337773
     /* 2337773 */ GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2337804), // Rule ID 1855 //
     /* 2337778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2337781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337792 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2337792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2337795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337797 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337803 */   // GIR_Coverage, 1855,
     /* 2337803 */   GIR_EraseRootFromParent_Done,
     /* 2337804 */ // Label 32306: @2337804
     /* 2337804 */ GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2337835), // Rule ID 1880 //
     /* 2337809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2337812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337823 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2337823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2337826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337834 */   // GIR_Coverage, 1880,
     /* 2337834 */   GIR_EraseRootFromParent_Done,
     /* 2337835 */ // Label 32307: @2337835
     /* 2337835 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2337866), // Rule ID 1881 //
     /* 2337840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2337843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337854 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2337854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2337857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337865 */   // GIR_Coverage, 1881,
     /* 2337865 */   GIR_EraseRootFromParent_Done,
     /* 2337866 */ // Label 32308: @2337866
     /* 2337866 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2337897), // Rule ID 2196 //
     /* 2337871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2337874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337885 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2337885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2337888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337896 */   // GIR_Coverage, 2196,
     /* 2337896 */   GIR_EraseRootFromParent_Done,
     /* 2337897 */ // Label 32309: @2337897
     /* 2337897 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2337928), // Rule ID 2197 //
     /* 2337902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2337905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337916 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2337916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2337919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337921 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337927 */   // GIR_Coverage, 2197,
     /* 2337927 */   GIR_EraseRootFromParent_Done,
     /* 2337928 */ // Label 32310: @2337928
     /* 2337928 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2337959), // Rule ID 2222 //
     /* 2337933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2337936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2337947 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2337947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2337950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337952 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337958 */   // GIR_Coverage, 2222,
     /* 2337958 */   GIR_EraseRootFromParent_Done,
     /* 2337959 */ // Label 32311: @2337959
     /* 2337959 */ GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2337990), // Rule ID 2223 //
     /* 2337964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2337967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2337978 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2337978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2337981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2337988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337989 */   // GIR_Coverage, 2223,
     /* 2337989 */   GIR_EraseRootFromParent_Done,
     /* 2337990 */ // Label 32312: @2337990
     /* 2337990 */ GIM_Reject,
     /* 2337991 */ // Label 32278: @2337991
     /* 2337991 */ GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2338022), // Rule ID 1515 //
     /* 2337996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2337999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338010 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2338010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2338013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338021 */   // GIR_Coverage, 1515,
     /* 2338021 */   GIR_EraseRootFromParent_Done,
     /* 2338022 */ // Label 32313: @2338022
     /* 2338022 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2338053), // Rule ID 1543 //
     /* 2338027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2338030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338041 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2338041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2338044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338052 */   // GIR_Coverage, 1543,
     /* 2338052 */   GIR_EraseRootFromParent_Done,
     /* 2338053 */ // Label 32314: @2338053
     /* 2338053 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2338084), // Rule ID 1915 //
     /* 2338058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2338061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338072 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2338072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2338075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338077 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338083 */   // GIR_Coverage, 1915,
     /* 2338083 */   GIR_EraseRootFromParent_Done,
     /* 2338084 */ // Label 32315: @2338084
     /* 2338084 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2338115), // Rule ID 1943 //
     /* 2338089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2338092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2338095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338103 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2338103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2338106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338114 */   // GIR_Coverage, 1943,
     /* 2338114 */   GIR_EraseRootFromParent_Done,
     /* 2338115 */ // Label 32316: @2338115
     /* 2338115 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2338146), // Rule ID 2249 //
     /* 2338120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2338123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2338126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338134 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2338134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2338137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338145 */   // GIR_Coverage, 2249,
     /* 2338145 */   GIR_EraseRootFromParent_Done,
     /* 2338146 */ // Label 32317: @2338146
     /* 2338146 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2338177), // Rule ID 2275 //
     /* 2338151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2338154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2338157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338165 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2338165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2338168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338170 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2338175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338176 */   // GIR_Coverage, 2275,
     /* 2338176 */   GIR_EraseRootFromParent_Done,
     /* 2338177 */ // Label 32318: @2338177
     /* 2338177 */ GIM_Reject,
     /* 2338178 */ // Label 32279: @2338178
     /* 2338178 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2338281),
     /* 2338183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338194 */   GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2338237), // Rule ID 58768 //
     /* 2338199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338202 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2338205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2338219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338236 */     // GIR_Coverage, 58768,
     /* 2338236 */     GIR_EraseRootFromParent_Done,
     /* 2338237 */   // Label 32320: @2338237
     /* 2338237 */   GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2338280), // Rule ID 58769 //
     /* 2338242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338245 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2338248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2338262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338279 */     // GIR_Coverage, 58769,
     /* 2338279 */     GIR_EraseRootFromParent_Done,
     /* 2338280 */   // Label 32321: @2338280
     /* 2338280 */   GIM_Reject,
     /* 2338281 */ // Label 32319: @2338281
     /* 2338281 */ GIM_Reject,
     /* 2338282 */ // Label 32280: @2338282
     /* 2338282 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2338336), // Rule ID 58352 //
     /* 2338287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338301 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2338318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338335 */   // GIR_Coverage, 58352,
     /* 2338335 */   GIR_EraseRootFromParent_Done,
     /* 2338336 */ // Label 32322: @2338336
     /* 2338336 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2338390), // Rule ID 58353 //
     /* 2338341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338355 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2338372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338377 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338389 */   // GIR_Coverage, 58353,
     /* 2338389 */   GIR_EraseRootFromParent_Done,
     /* 2338390 */ // Label 32323: @2338390
     /* 2338390 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2338444), // Rule ID 58792 //
     /* 2338395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338409 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2338426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338431 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338443 */   // GIR_Coverage, 58792,
     /* 2338443 */   GIR_EraseRootFromParent_Done,
     /* 2338444 */ // Label 32324: @2338444
     /* 2338444 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2338498), // Rule ID 58793 //
     /* 2338449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338463 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2338466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2338480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338485 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338497 */   // GIR_Coverage, 58793,
     /* 2338497 */   GIR_EraseRootFromParent_Done,
     /* 2338498 */ // Label 32325: @2338498
     /* 2338498 */ GIM_Reject,
     /* 2338499 */ // Label 32281: @2338499
     /* 2338499 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2338553), // Rule ID 58360 //
     /* 2338504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338518 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2338535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338540 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338552 */   // GIR_Coverage, 58360,
     /* 2338552 */   GIR_EraseRootFromParent_Done,
     /* 2338553 */ // Label 32326: @2338553
     /* 2338553 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2338607), // Rule ID 58361 //
     /* 2338558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338572 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2338589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338606 */   // GIR_Coverage, 58361,
     /* 2338606 */   GIR_EraseRootFromParent_Done,
     /* 2338607 */ // Label 32327: @2338607
     /* 2338607 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2338661), // Rule ID 58560 //
     /* 2338612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338626 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2338643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338648 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338660 */   // GIR_Coverage, 58560,
     /* 2338660 */   GIR_EraseRootFromParent_Done,
     /* 2338661 */ // Label 32328: @2338661
     /* 2338661 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2338715), // Rule ID 58561 //
     /* 2338666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2338672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338680 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2338697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338702 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338714 */   // GIR_Coverage, 58561,
     /* 2338714 */   GIR_EraseRootFromParent_Done,
     /* 2338715 */ // Label 32329: @2338715
     /* 2338715 */ GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2338769), // Rule ID 58812 //
     /* 2338720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2338723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338734 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2338751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338756 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338768 */   // GIR_Coverage, 58812,
     /* 2338768 */   GIR_EraseRootFromParent_Done,
     /* 2338769 */ // Label 32330: @2338769
     /* 2338769 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2338823), // Rule ID 58813 //
     /* 2338774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2338777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338788 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2338791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2338805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338810 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338822 */   // GIR_Coverage, 58813,
     /* 2338822 */   GIR_EraseRootFromParent_Done,
     /* 2338823 */ // Label 32331: @2338823
     /* 2338823 */ GIM_Reject,
     /* 2338824 */ // Label 32282: @2338824
     /* 2338824 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2338878), // Rule ID 58372 //
     /* 2338829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2338832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338843 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2338860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338877 */   // GIR_Coverage, 58372,
     /* 2338877 */   GIR_EraseRootFromParent_Done,
     /* 2338878 */ // Label 32332: @2338878
     /* 2338878 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2338932), // Rule ID 58373 //
     /* 2338883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2338886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2338889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338897 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2338914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338931 */   // GIR_Coverage, 58373,
     /* 2338931 */   GIR_EraseRootFromParent_Done,
     /* 2338932 */ // Label 32333: @2338932
     /* 2338932 */ GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2338986), // Rule ID 58580 //
     /* 2338937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2338940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338951 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2338968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338985 */   // GIR_Coverage, 58580,
     /* 2338985 */   GIR_EraseRootFromParent_Done,
     /* 2338986 */ // Label 32334: @2338986
     /* 2338986 */ GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2339040), // Rule ID 58581 //
     /* 2338991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2338994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2338997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339005 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2339008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339039 */   // GIR_Coverage, 58581,
     /* 2339039 */   GIR_EraseRootFromParent_Done,
     /* 2339040 */ // Label 32335: @2339040
     /* 2339040 */ GIM_Reject,
     /* 2339041 */ // Label 32283: @2339041
     /* 2339041 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2339144),
     /* 2339046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339057 */   GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2339100), // Rule ID 58772 //
     /* 2339062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339065 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2339068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2339082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339099 */     // GIR_Coverage, 58772,
     /* 2339099 */     GIR_EraseRootFromParent_Done,
     /* 2339100 */   // Label 32337: @2339100
     /* 2339100 */   GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2339143), // Rule ID 58773 //
     /* 2339105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339108 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2339111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2339125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339142 */     // GIR_Coverage, 58773,
     /* 2339142 */     GIR_EraseRootFromParent_Done,
     /* 2339143 */   // Label 32338: @2339143
     /* 2339143 */   GIM_Reject,
     /* 2339144 */ // Label 32336: @2339144
     /* 2339144 */ GIM_Reject,
     /* 2339145 */ // Label 32284: @2339145
     /* 2339145 */ GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2339199), // Rule ID 58356 //
     /* 2339150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339164 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2339181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339198 */   // GIR_Coverage, 58356,
     /* 2339198 */   GIR_EraseRootFromParent_Done,
     /* 2339199 */ // Label 32339: @2339199
     /* 2339199 */ GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2339253), // Rule ID 58357 //
     /* 2339204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339218 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2339235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339240 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339252 */   // GIR_Coverage, 58357,
     /* 2339252 */   GIR_EraseRootFromParent_Done,
     /* 2339253 */ // Label 32340: @2339253
     /* 2339253 */ GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2339307), // Rule ID 58796 //
     /* 2339258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339272 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339306 */   // GIR_Coverage, 58796,
     /* 2339306 */   GIR_EraseRootFromParent_Done,
     /* 2339307 */ // Label 32341: @2339307
     /* 2339307 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2339361), // Rule ID 58797 //
     /* 2339312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339326 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2339329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339360 */   // GIR_Coverage, 58797,
     /* 2339360 */   GIR_EraseRootFromParent_Done,
     /* 2339361 */ // Label 32342: @2339361
     /* 2339361 */ GIM_Reject,
     /* 2339362 */ // Label 32285: @2339362
     /* 2339362 */ GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2339416), // Rule ID 58368 //
     /* 2339367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339381 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2339398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339415 */   // GIR_Coverage, 58368,
     /* 2339415 */   GIR_EraseRootFromParent_Done,
     /* 2339416 */ // Label 32343: @2339416
     /* 2339416 */ GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2339470), // Rule ID 58369 //
     /* 2339421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339435 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2339452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339469 */   // GIR_Coverage, 58369,
     /* 2339469 */   GIR_EraseRootFromParent_Done,
     /* 2339470 */ // Label 32344: @2339470
     /* 2339470 */ GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2339524), // Rule ID 58564 //
     /* 2339475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339489 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339511 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339523 */   // GIR_Coverage, 58564,
     /* 2339523 */   GIR_EraseRootFromParent_Done,
     /* 2339524 */ // Label 32345: @2339524
     /* 2339524 */ GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2339578), // Rule ID 58565 //
     /* 2339529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2339535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339543 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2339560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339577 */   // GIR_Coverage, 58565,
     /* 2339577 */   GIR_EraseRootFromParent_Done,
     /* 2339578 */ // Label 32346: @2339578
     /* 2339578 */ GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2339632), // Rule ID 58816 //
     /* 2339583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2339586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339597 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2339614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339631 */   // GIR_Coverage, 58816,
     /* 2339631 */   GIR_EraseRootFromParent_Done,
     /* 2339632 */ // Label 32347: @2339632
     /* 2339632 */ GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2339686), // Rule ID 58817 //
     /* 2339637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2339640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339651 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2339654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2339668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339685 */   // GIR_Coverage, 58817,
     /* 2339685 */   GIR_EraseRootFromParent_Done,
     /* 2339686 */ // Label 32348: @2339686
     /* 2339686 */ GIM_Reject,
     /* 2339687 */ // Label 32286: @2339687
     /* 2339687 */ GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2339741), // Rule ID 58400 //
     /* 2339692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2339695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339706 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2339723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339740 */   // GIR_Coverage, 58400,
     /* 2339740 */   GIR_EraseRootFromParent_Done,
     /* 2339741 */ // Label 32349: @2339741
     /* 2339741 */ GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2339795), // Rule ID 58401 //
     /* 2339746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2339749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2339752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339760 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2339777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339794 */   // GIR_Coverage, 58401,
     /* 2339794 */   GIR_EraseRootFromParent_Done,
     /* 2339795 */ // Label 32350: @2339795
     /* 2339795 */ GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2339849), // Rule ID 58584 //
     /* 2339800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2339803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339814 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2339831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339836 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339848 */   // GIR_Coverage, 58584,
     /* 2339848 */   GIR_EraseRootFromParent_Done,
     /* 2339849 */ // Label 32351: @2339849
     /* 2339849 */ GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2339903), // Rule ID 58585 //
     /* 2339854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2339860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339868 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2339871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2339885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339902 */   // GIR_Coverage, 58585,
     /* 2339902 */   GIR_EraseRootFromParent_Done,
     /* 2339903 */ // Label 32352: @2339903
     /* 2339903 */ GIM_Reject,
     /* 2339904 */ // Label 32287: @2339904
     /* 2339904 */ GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2340007),
     /* 2339909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339920 */   GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2339963), // Rule ID 58776 //
     /* 2339925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339928 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2339931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339962 */     // GIR_Coverage, 58776,
     /* 2339962 */     GIR_EraseRootFromParent_Done,
     /* 2339963 */   // Label 32354: @2339963
     /* 2339963 */   GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2340006), // Rule ID 58777 //
     /* 2339968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339971 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2339974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2339988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340005 */     // GIR_Coverage, 58777,
     /* 2340005 */     GIR_EraseRootFromParent_Done,
     /* 2340006 */   // Label 32355: @2340006
     /* 2340006 */   GIM_Reject,
     /* 2340007 */ // Label 32353: @2340007
     /* 2340007 */ GIM_Reject,
     /* 2340008 */ // Label 32288: @2340008
     /* 2340008 */ GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2340062), // Rule ID 58364 //
     /* 2340013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340027 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2340044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340061 */   // GIR_Coverage, 58364,
     /* 2340061 */   GIR_EraseRootFromParent_Done,
     /* 2340062 */ // Label 32356: @2340062
     /* 2340062 */ GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2340116), // Rule ID 58365 //
     /* 2340067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340081 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2340098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340103 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340115 */   // GIR_Coverage, 58365,
     /* 2340115 */   GIR_EraseRootFromParent_Done,
     /* 2340116 */ // Label 32357: @2340116
     /* 2340116 */ GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2340170), // Rule ID 58800 //
     /* 2340121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340135 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340169 */   // GIR_Coverage, 58800,
     /* 2340169 */   GIR_EraseRootFromParent_Done,
     /* 2340170 */ // Label 32358: @2340170
     /* 2340170 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2340224), // Rule ID 58801 //
     /* 2340175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340189 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340223 */   // GIR_Coverage, 58801,
     /* 2340223 */   GIR_EraseRootFromParent_Done,
     /* 2340224 */ // Label 32359: @2340224
     /* 2340224 */ GIM_Reject,
     /* 2340225 */ // Label 32289: @2340225
     /* 2340225 */ GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2340279), // Rule ID 58388 //
     /* 2340230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340244 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340278 */   // GIR_Coverage, 58388,
     /* 2340278 */   GIR_EraseRootFromParent_Done,
     /* 2340279 */ // Label 32360: @2340279
     /* 2340279 */ GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2340333), // Rule ID 58389 //
     /* 2340284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340298 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340332 */   // GIR_Coverage, 58389,
     /* 2340332 */   GIR_EraseRootFromParent_Done,
     /* 2340333 */ // Label 32361: @2340333
     /* 2340333 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2340387), // Rule ID 58568 //
     /* 2340338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340352 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2340369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340386 */   // GIR_Coverage, 58568,
     /* 2340386 */   GIR_EraseRootFromParent_Done,
     /* 2340387 */ // Label 32362: @2340387
     /* 2340387 */ GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2340441), // Rule ID 58569 //
     /* 2340392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340406 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2340423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340428 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340440 */   // GIR_Coverage, 58569,
     /* 2340440 */   GIR_EraseRootFromParent_Done,
     /* 2340441 */ // Label 32363: @2340441
     /* 2340441 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2340495), // Rule ID 58820 //
     /* 2340446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2340449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340460 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2340477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340482 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340494 */   // GIR_Coverage, 58820,
     /* 2340494 */   GIR_EraseRootFromParent_Done,
     /* 2340495 */ // Label 32364: @2340495
     /* 2340495 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2340549), // Rule ID 58821 //
     /* 2340500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2340503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340514 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2340531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340548 */   // GIR_Coverage, 58821,
     /* 2340548 */   GIR_EraseRootFromParent_Done,
     /* 2340549 */ // Label 32365: @2340549
     /* 2340549 */ GIM_Reject,
     /* 2340550 */ // Label 32290: @2340550
     /* 2340550 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2340604), // Rule ID 58404 //
     /* 2340555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340569 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340569 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340576 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2340586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340591 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340603 */   // GIR_Coverage, 58404,
     /* 2340603 */   GIR_EraseRootFromParent_Done,
     /* 2340604 */ // Label 32366: @2340604
     /* 2340604 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2340658), // Rule ID 58405 //
     /* 2340609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2340612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2340615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340623 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2340640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340645 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340657 */   // GIR_Coverage, 58405,
     /* 2340657 */   GIR_EraseRootFromParent_Done,
     /* 2340658 */ // Label 32367: @2340658
     /* 2340658 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2340712), // Rule ID 58588 //
     /* 2340663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2340666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340677 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2340694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340699 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340711 */   // GIR_Coverage, 58588,
     /* 2340711 */   GIR_EraseRootFromParent_Done,
     /* 2340712 */ // Label 32368: @2340712
     /* 2340712 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2340766), // Rule ID 58589 //
     /* 2340717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2340720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340731 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2340734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2340748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340765 */   // GIR_Coverage, 58589,
     /* 2340765 */   GIR_EraseRootFromParent_Done,
     /* 2340766 */ // Label 32369: @2340766
     /* 2340766 */ GIM_Reject,
     /* 2340767 */ // Label 32291: @2340767
     /* 2340767 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2340870),
     /* 2340772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340783 */   GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2340826), // Rule ID 58780 //
     /* 2340788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340791 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2340794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340825 */     // GIR_Coverage, 58780,
     /* 2340825 */     GIR_EraseRootFromParent_Done,
     /* 2340826 */   // Label 32371: @2340826
     /* 2340826 */   GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2340869), // Rule ID 58781 //
     /* 2340831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340834 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2340837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2340851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340868 */     // GIR_Coverage, 58781,
     /* 2340868 */     GIR_EraseRootFromParent_Done,
     /* 2340869 */   // Label 32372: @2340869
     /* 2340869 */   GIM_Reject,
     /* 2340870 */ // Label 32370: @2340870
     /* 2340870 */ GIM_Reject,
     /* 2340871 */ // Label 32292: @2340871
     /* 2340871 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2340925), // Rule ID 58376 //
     /* 2340876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340890 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340924 */   // GIR_Coverage, 58376,
     /* 2340924 */   GIR_EraseRootFromParent_Done,
     /* 2340925 */ // Label 32373: @2340925
     /* 2340925 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2340979), // Rule ID 58377 //
     /* 2340930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340944 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2340961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340978 */   // GIR_Coverage, 58377,
     /* 2340978 */   GIR_EraseRootFromParent_Done,
     /* 2340979 */ // Label 32374: @2340979
     /* 2340979 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2341033), // Rule ID 58804 //
     /* 2340984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340998 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341032 */   // GIR_Coverage, 58804,
     /* 2341032 */   GIR_EraseRootFromParent_Done,
     /* 2341033 */ // Label 32375: @2341033
     /* 2341033 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2341087), // Rule ID 58805 //
     /* 2341038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341052 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341086 */   // GIR_Coverage, 58805,
     /* 2341086 */   GIR_EraseRootFromParent_Done,
     /* 2341087 */ // Label 32376: @2341087
     /* 2341087 */ GIM_Reject,
     /* 2341088 */ // Label 32293: @2341088
     /* 2341088 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2341142), // Rule ID 58392 //
     /* 2341093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341107 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341141 */   // GIR_Coverage, 58392,
     /* 2341141 */   GIR_EraseRootFromParent_Done,
     /* 2341142 */ // Label 32377: @2341142
     /* 2341142 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2341196), // Rule ID 58393 //
     /* 2341147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341161 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341195 */   // GIR_Coverage, 58393,
     /* 2341195 */   GIR_EraseRootFromParent_Done,
     /* 2341196 */ // Label 32378: @2341196
     /* 2341196 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2341250), // Rule ID 58572 //
     /* 2341201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2341207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341215 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2341232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341237 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341249 */   // GIR_Coverage, 58572,
     /* 2341249 */   GIR_EraseRootFromParent_Done,
     /* 2341250 */ // Label 32379: @2341250
     /* 2341250 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2341304), // Rule ID 58573 //
     /* 2341255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2341261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341269 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2341286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341303 */   // GIR_Coverage, 58573,
     /* 2341303 */   GIR_EraseRootFromParent_Done,
     /* 2341304 */ // Label 32380: @2341304
     /* 2341304 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2341358), // Rule ID 58824 //
     /* 2341309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2341312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341323 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341345 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341357 */   // GIR_Coverage, 58824,
     /* 2341357 */   GIR_EraseRootFromParent_Done,
     /* 2341358 */ // Label 32381: @2341358
     /* 2341358 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2341412), // Rule ID 58825 //
     /* 2341363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2341366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341377 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341399 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341411 */   // GIR_Coverage, 58825,
     /* 2341411 */   GIR_EraseRootFromParent_Done,
     /* 2341412 */ // Label 32382: @2341412
     /* 2341412 */ GIM_Reject,
     /* 2341413 */ // Label 32294: @2341413
     /* 2341413 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2341467), // Rule ID 58408 //
     /* 2341418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2341421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341432 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341466 */   // GIR_Coverage, 58408,
     /* 2341466 */   GIR_EraseRootFromParent_Done,
     /* 2341467 */ // Label 32383: @2341467
     /* 2341467 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2341521), // Rule ID 58409 //
     /* 2341472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2341475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341486 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341520 */   // GIR_Coverage, 58409,
     /* 2341520 */   GIR_EraseRootFromParent_Done,
     /* 2341521 */ // Label 32384: @2341521
     /* 2341521 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2341575), // Rule ID 58592 //
     /* 2341526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2341529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341540 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2341557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341574 */   // GIR_Coverage, 58592,
     /* 2341574 */   GIR_EraseRootFromParent_Done,
     /* 2341575 */ // Label 32385: @2341575
     /* 2341575 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2341629), // Rule ID 58593 //
     /* 2341580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2341583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341594 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2341611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341628 */   // GIR_Coverage, 58593,
     /* 2341628 */   GIR_EraseRootFromParent_Done,
     /* 2341629 */ // Label 32386: @2341629
     /* 2341629 */ GIM_Reject,
     /* 2341630 */ // Label 32295: @2341630
     /* 2341630 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2341733),
     /* 2341635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341646 */   GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2341689), // Rule ID 58784 //
     /* 2341651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341654 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2341657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341688 */     // GIR_Coverage, 58784,
     /* 2341688 */     GIR_EraseRootFromParent_Done,
     /* 2341689 */   // Label 32388: @2341689
     /* 2341689 */   GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2341732), // Rule ID 58785 //
     /* 2341694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341697 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2341700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2341714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341731 */     // GIR_Coverage, 58785,
     /* 2341731 */     GIR_EraseRootFromParent_Done,
     /* 2341732 */   // Label 32389: @2341732
     /* 2341732 */   GIM_Reject,
     /* 2341733 */ // Label 32387: @2341733
     /* 2341733 */ GIM_Reject,
     /* 2341734 */ // Label 32296: @2341734
     /* 2341734 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2341788), // Rule ID 58380 //
     /* 2341739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341753 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341787 */   // GIR_Coverage, 58380,
     /* 2341787 */   GIR_EraseRootFromParent_Done,
     /* 2341788 */ // Label 32390: @2341788
     /* 2341788 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2341842), // Rule ID 58381 //
     /* 2341793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341807 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2341824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341829 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341841 */   // GIR_Coverage, 58381,
     /* 2341841 */   GIR_EraseRootFromParent_Done,
     /* 2341842 */ // Label 32391: @2341842
     /* 2341842 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2341896), // Rule ID 58808 //
     /* 2341847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341861 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341883 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341895 */   // GIR_Coverage, 58808,
     /* 2341895 */   GIR_EraseRootFromParent_Done,
     /* 2341896 */ // Label 32392: @2341896
     /* 2341896 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2341950), // Rule ID 58809 //
     /* 2341901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341915 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2341932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341949 */   // GIR_Coverage, 58809,
     /* 2341949 */   GIR_EraseRootFromParent_Done,
     /* 2341950 */ // Label 32393: @2341950
     /* 2341950 */ GIM_Reject,
     /* 2341951 */ // Label 32297: @2341951
     /* 2341951 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2342005), // Rule ID 58396 //
     /* 2341956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341970 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2341987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342004 */   // GIR_Coverage, 58396,
     /* 2342004 */   GIR_EraseRootFromParent_Done,
     /* 2342005 */ // Label 32394: @2342005
     /* 2342005 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2342059), // Rule ID 58397 //
     /* 2342010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2342016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342024 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342057 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342058 */   // GIR_Coverage, 58397,
     /* 2342058 */   GIR_EraseRootFromParent_Done,
     /* 2342059 */ // Label 32395: @2342059
     /* 2342059 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2342113), // Rule ID 58576 //
     /* 2342064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2342070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342078 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2342095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342100 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342112 */   // GIR_Coverage, 58576,
     /* 2342112 */   GIR_EraseRootFromParent_Done,
     /* 2342113 */ // Label 32396: @2342113
     /* 2342113 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2342167), // Rule ID 58577 //
     /* 2342118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2342124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342132 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2342135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2342149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342154 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342166 */   // GIR_Coverage, 58577,
     /* 2342166 */   GIR_EraseRootFromParent_Done,
     /* 2342167 */ // Label 32397: @2342167
     /* 2342167 */ GIM_Reject,
     /* 2342168 */ // Label 32298: @2342168
     /* 2342168 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2342271),
     /* 2342173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2342176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342184 */   GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2342227), // Rule ID 58788 //
     /* 2342189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342192 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2342195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2342209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342226 */     // GIR_Coverage, 58788,
     /* 2342226 */     GIR_EraseRootFromParent_Done,
     /* 2342227 */   // Label 32399: @2342227
     /* 2342227 */   GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2342270), // Rule ID 58789 //
     /* 2342232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342235 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2342238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2342252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342269 */     // GIR_Coverage, 58789,
     /* 2342269 */     GIR_EraseRootFromParent_Done,
     /* 2342270 */   // Label 32400: @2342270
     /* 2342270 */   GIM_Reject,
     /* 2342271 */ // Label 32398: @2342271
     /* 2342271 */ GIM_Reject,
     /* 2342272 */ // Label 32299: @2342272
     /* 2342272 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2342375),
     /* 2342277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2342280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342288 */   GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2342331), // Rule ID 58384 //
     /* 2342293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342296 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2342299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342330 */     // GIR_Coverage, 58384,
     /* 2342330 */     GIR_EraseRootFromParent_Done,
     /* 2342331 */   // Label 32402: @2342331
     /* 2342331 */   GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2342374), // Rule ID 58385 //
     /* 2342336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342339 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2342342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2342356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342373 */     // GIR_Coverage, 58385,
     /* 2342373 */     GIR_EraseRootFromParent_Done,
     /* 2342374 */   // Label 32403: @2342374
     /* 2342374 */   GIM_Reject,
     /* 2342375 */ // Label 32401: @2342375
     /* 2342375 */ GIM_Reject,
     /* 2342376 */ // Label 32300: @2342376
     /* 2342376 */ GIM_Reject,
     /* 2342377 */ // Label 69: @2342377
     /* 2342377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32422*/ GIMT_Encode4(2347662),
     /* 2342388 */ /*GILLT_s16*//*Label 32404*/ GIMT_Encode4(2342508),
     /* 2342392 */ /*GILLT_s32*//*Label 32405*/ GIMT_Encode4(2342769),
     /* 2342396 */ /*GILLT_s64*//*Label 32406*/ GIMT_Encode4(2343030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342408 */ /*GILLT_nxv1s16*//*Label 32407*/ GIMT_Encode4(2343291),
     /* 2342412 */ /*GILLT_nxv1s32*//*Label 32408*/ GIMT_Encode4(2343628),
     /* 2342416 */ /*GILLT_nxv1s64*//*Label 32409*/ GIMT_Encode4(2343965), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342428 */ /*GILLT_nxv2s16*//*Label 32410*/ GIMT_Encode4(2344188),
     /* 2342432 */ /*GILLT_nxv2s32*//*Label 32411*/ GIMT_Encode4(2344525),
     /* 2342436 */ /*GILLT_nxv2s64*//*Label 32412*/ GIMT_Encode4(2344862), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342448 */ /*GILLT_nxv4s16*//*Label 32413*/ GIMT_Encode4(2345085),
     /* 2342452 */ /*GILLT_nxv4s32*//*Label 32414*/ GIMT_Encode4(2345422),
     /* 2342456 */ /*GILLT_nxv4s64*//*Label 32415*/ GIMT_Encode4(2345759), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342468 */ /*GILLT_nxv8s16*//*Label 32416*/ GIMT_Encode4(2345982),
     /* 2342472 */ /*GILLT_nxv8s32*//*Label 32417*/ GIMT_Encode4(2346319),
     /* 2342476 */ /*GILLT_nxv8s64*//*Label 32418*/ GIMT_Encode4(2346656), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342488 */ /*GILLT_nxv16s16*//*Label 32419*/ GIMT_Encode4(2346879),
     /* 2342492 */ /*GILLT_nxv16s32*//*Label 32420*/ GIMT_Encode4(2347216), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2342504 */ /*GILLT_nxv32s16*//*Label 32421*/ GIMT_Encode4(2347439),
     /* 2342508 */ // Label 32404: @2342508
     /* 2342508 */ GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2342545), // Rule ID 2261 //
     /* 2342513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342530 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342544 */   // GIR_Coverage, 2261,
     /* 2342544 */   GIR_EraseRootFromParent_Done,
     /* 2342545 */ // Label 32423: @2342545
     /* 2342545 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2342582), // Rule ID 2287 //
     /* 2342550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342567 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342581 */   // GIR_Coverage, 2287,
     /* 2342581 */   GIR_EraseRootFromParent_Done,
     /* 2342582 */ // Label 32424: @2342582
     /* 2342582 */ GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2342613), // Rule ID 2210 //
     /* 2342587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2342590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342601 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342606 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342612 */   // GIR_Coverage, 2210,
     /* 2342612 */   GIR_EraseRootFromParent_Done,
     /* 2342613 */ // Label 32425: @2342613
     /* 2342613 */ GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2342644), // Rule ID 2211 //
     /* 2342618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2342621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342632 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2342635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342637 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342643 */   // GIR_Coverage, 2211,
     /* 2342643 */   GIR_EraseRootFromParent_Done,
     /* 2342644 */ // Label 32426: @2342644
     /* 2342644 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2342675), // Rule ID 2236 //
     /* 2342649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2342652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342663 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342668 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342674 */   // GIR_Coverage, 2236,
     /* 2342674 */   GIR_EraseRootFromParent_Done,
     /* 2342675 */ // Label 32427: @2342675
     /* 2342675 */ GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2342706), // Rule ID 2237 //
     /* 2342680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2342683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342694 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2342697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342699 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342705 */   // GIR_Coverage, 2237,
     /* 2342705 */   GIR_EraseRootFromParent_Done,
     /* 2342706 */ // Label 32428: @2342706
     /* 2342706 */ GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2342737), // Rule ID 2265 //
     /* 2342711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2342714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2342721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342725 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2342728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342730 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342736 */   // GIR_Coverage, 2265,
     /* 2342736 */   GIR_EraseRootFromParent_Done,
     /* 2342737 */ // Label 32429: @2342737
     /* 2342737 */ GIM_Try, /*On fail goto*//*Label 32430*/ GIMT_Encode4(2342768), // Rule ID 2291 //
     /* 2342742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2342745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342756 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2342759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342767 */   // GIR_Coverage, 2291,
     /* 2342767 */   GIR_EraseRootFromParent_Done,
     /* 2342768 */ // Label 32430: @2342768
     /* 2342768 */ GIM_Reject,
     /* 2342769 */ // Label 32405: @2342769
     /* 2342769 */ GIM_Try, /*On fail goto*//*Label 32431*/ GIMT_Encode4(2342806), // Rule ID 1527 //
     /* 2342774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342791 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342805 */   // GIR_Coverage, 1527,
     /* 2342805 */   GIR_EraseRootFromParent_Done,
     /* 2342806 */ // Label 32431: @2342806
     /* 2342806 */ GIM_Try, /*On fail goto*//*Label 32432*/ GIMT_Encode4(2342843), // Rule ID 1555 //
     /* 2342811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2342814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2342828 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342842 */   // GIR_Coverage, 1555,
     /* 2342842 */   GIR_EraseRootFromParent_Done,
     /* 2342843 */ // Label 32432: @2342843
     /* 2342843 */ GIM_Try, /*On fail goto*//*Label 32433*/ GIMT_Encode4(2342874), // Rule ID 1474 //
     /* 2342848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2342851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342862 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342873 */   // GIR_Coverage, 1474,
     /* 2342873 */   GIR_EraseRootFromParent_Done,
     /* 2342874 */ // Label 32433: @2342874
     /* 2342874 */ GIM_Try, /*On fail goto*//*Label 32434*/ GIMT_Encode4(2342905), // Rule ID 1475 //
     /* 2342879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2342882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342893 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2342896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342898 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342904 */   // GIR_Coverage, 1475,
     /* 2342904 */   GIR_EraseRootFromParent_Done,
     /* 2342905 */ // Label 32434: @2342905
     /* 2342905 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2342936), // Rule ID 1500 //
     /* 2342910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2342913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342924 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342935 */   // GIR_Coverage, 1500,
     /* 2342935 */   GIR_EraseRootFromParent_Done,
     /* 2342936 */ // Label 32435: @2342936
     /* 2342936 */ GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2342967), // Rule ID 1501 //
     /* 2342941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2342944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342955 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2342958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342960 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342966 */   // GIR_Coverage, 1501,
     /* 2342966 */   GIR_EraseRootFromParent_Done,
     /* 2342967 */ // Label 32436: @2342967
     /* 2342967 */ GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2342998), // Rule ID 1531 //
     /* 2342972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342986 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2342989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342997 */   // GIR_Coverage, 1531,
     /* 2342997 */   GIR_EraseRootFromParent_Done,
     /* 2342998 */ // Label 32437: @2342998
     /* 2342998 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2343029), // Rule ID 1559 //
     /* 2343003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2343006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2343013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343017 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2343020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343022 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343028 */   // GIR_Coverage, 1559,
     /* 2343028 */   GIR_EraseRootFromParent_Done,
     /* 2343029 */ // Label 32438: @2343029
     /* 2343029 */ GIM_Reject,
     /* 2343030 */ // Label 32406: @2343030
     /* 2343030 */ GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2343067), // Rule ID 1907 //
     /* 2343035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2343038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343045 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2343052 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2343052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2343062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343066 */   // GIR_Coverage, 1907,
     /* 2343066 */   GIR_EraseRootFromParent_Done,
     /* 2343067 */ // Label 32439: @2343067
     /* 2343067 */ GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2343104), // Rule ID 1935 //
     /* 2343072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2343075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2343089 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2343089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2343092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2343099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343103 */   // GIR_Coverage, 1935,
     /* 2343103 */   GIR_EraseRootFromParent_Done,
     /* 2343104 */ // Label 32440: @2343104
     /* 2343104 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2343135), // Rule ID 1868 //
     /* 2343109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2343112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343123 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2343123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343128 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343134 */   // GIR_Coverage, 1868,
     /* 2343134 */   GIR_EraseRootFromParent_Done,
     /* 2343135 */ // Label 32441: @2343135
     /* 2343135 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2343166), // Rule ID 1869 //
     /* 2343140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2343143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343154 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2343154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2343157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343159 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343165 */   // GIR_Coverage, 1869,
     /* 2343165 */   GIR_EraseRootFromParent_Done,
     /* 2343166 */ // Label 32442: @2343166
     /* 2343166 */ GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2343197), // Rule ID 1894 //
     /* 2343171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2343174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2343181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343185 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2343185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2343188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343195 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343196 */   // GIR_Coverage, 1894,
     /* 2343196 */   GIR_EraseRootFromParent_Done,
     /* 2343197 */ // Label 32443: @2343197
     /* 2343197 */ GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2343228), // Rule ID 1895 //
     /* 2343202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2343205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2343212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343216 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2343216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2343219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343221 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2343226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343227 */   // GIR_Coverage, 1895,
     /* 2343227 */   GIR_EraseRootFromParent_Done,
     /* 2343228 */ // Label 32444: @2343228
     /* 2343228 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2343259), // Rule ID 1925 //
     /* 2343233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2343236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2343243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343247 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2343250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343258 */   // GIR_Coverage, 1925,
     /* 2343258 */   GIR_EraseRootFromParent_Done,
     /* 2343259 */ // Label 32445: @2343259
     /* 2343259 */ GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2343290), // Rule ID 1953 //
     /* 2343264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2343267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2343278 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2343278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2343281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343289 */   // GIR_Coverage, 1953,
     /* 2343289 */   GIR_EraseRootFromParent_Done,
     /* 2343290 */ // Label 32446: @2343290
     /* 2343290 */ GIM_Reject,
     /* 2343291 */ // Label 32407: @2343291
     /* 2343291 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2343348), // Rule ID 45804 //
     /* 2343296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343310 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2343327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343347 */   // GIR_Coverage, 45804,
     /* 2343347 */   GIR_EraseRootFromParent_Done,
     /* 2343348 */ // Label 32447: @2343348
     /* 2343348 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2343405), // Rule ID 45805 //
     /* 2343353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343367 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2343384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343389 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343404 */   // GIR_Coverage, 45805,
     /* 2343404 */   GIR_EraseRootFromParent_Done,
     /* 2343405 */ // Label 32448: @2343405
     /* 2343405 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2343459), // Rule ID 45812 //
     /* 2343410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2343416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343424 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2343441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343446 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343458 */   // GIR_Coverage, 45812,
     /* 2343458 */   GIR_EraseRootFromParent_Done,
     /* 2343459 */ // Label 32449: @2343459
     /* 2343459 */ GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2343513), // Rule ID 45813 //
     /* 2343464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2343470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343478 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2343495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343500 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343512 */   // GIR_Coverage, 45813,
     /* 2343512 */   GIR_EraseRootFromParent_Done,
     /* 2343513 */ // Label 32450: @2343513
     /* 2343513 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2343570), // Rule ID 45820 //
     /* 2343518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343532 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2343549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343569 */   // GIR_Coverage, 45820,
     /* 2343569 */   GIR_EraseRootFromParent_Done,
     /* 2343570 */ // Label 32451: @2343570
     /* 2343570 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2343627), // Rule ID 45821 //
     /* 2343575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343589 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2343592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2343606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343626 */   // GIR_Coverage, 45821,
     /* 2343626 */   GIR_EraseRootFromParent_Done,
     /* 2343627 */ // Label 32452: @2343627
     /* 2343627 */ GIM_Reject,
     /* 2343628 */ // Label 32408: @2343628
     /* 2343628 */ GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2343685), // Rule ID 58416 //
     /* 2343633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343647 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2343664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343669 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343684 */   // GIR_Coverage, 58416,
     /* 2343684 */   GIR_EraseRootFromParent_Done,
     /* 2343685 */ // Label 32453: @2343685
     /* 2343685 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2343742), // Rule ID 58417 //
     /* 2343690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343704 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343704 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343707 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343711 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2343721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343726 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343741 */   // GIR_Coverage, 58417,
     /* 2343741 */   GIR_EraseRootFromParent_Done,
     /* 2343742 */ // Label 32454: @2343742
     /* 2343742 */ GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2343796), // Rule ID 58616 //
     /* 2343747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343761 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2343778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343783 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343795 */   // GIR_Coverage, 58616,
     /* 2343795 */   GIR_EraseRootFromParent_Done,
     /* 2343796 */ // Label 32455: @2343796
     /* 2343796 */ GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2343850), // Rule ID 58617 //
     /* 2343801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2343807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343815 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2343832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343837 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343849 */   // GIR_Coverage, 58617,
     /* 2343849 */   GIR_EraseRootFromParent_Done,
     /* 2343850 */ // Label 32456: @2343850
     /* 2343850 */ GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2343907), // Rule ID 58844 //
     /* 2343855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2343858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343869 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2343886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343891 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343906 */   // GIR_Coverage, 58844,
     /* 2343906 */   GIR_EraseRootFromParent_Done,
     /* 2343907 */ // Label 32457: @2343907
     /* 2343907 */ GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2343964), // Rule ID 58845 //
     /* 2343912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2343915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343926 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2343943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343948 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343963 */   // GIR_Coverage, 58845,
     /* 2343963 */   GIR_EraseRootFromParent_Done,
     /* 2343964 */ // Label 32458: @2343964
     /* 2343964 */ GIM_Reject,
     /* 2343965 */ // Label 32409: @2343965
     /* 2343965 */ GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2344022), // Rule ID 58428 //
     /* 2343970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2343973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343984 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2344001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344006 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344021 */   // GIR_Coverage, 58428,
     /* 2344021 */   GIR_EraseRootFromParent_Done,
     /* 2344022 */ // Label 32459: @2344022
     /* 2344022 */ GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2344079), // Rule ID 58429 //
     /* 2344027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2344033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344041 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2344058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344063 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344078 */   // GIR_Coverage, 58429,
     /* 2344078 */   GIR_EraseRootFromParent_Done,
     /* 2344079 */ // Label 32460: @2344079
     /* 2344079 */ GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2344133), // Rule ID 58636 //
     /* 2344084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344098 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2344115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344120 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344132 */   // GIR_Coverage, 58636,
     /* 2344132 */   GIR_EraseRootFromParent_Done,
     /* 2344133 */ // Label 32461: @2344133
     /* 2344133 */ GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2344187), // Rule ID 58637 //
     /* 2344138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2344141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344152 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2344169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344174 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344186 */   // GIR_Coverage, 58637,
     /* 2344186 */   GIR_EraseRootFromParent_Done,
     /* 2344187 */ // Label 32462: @2344187
     /* 2344187 */ GIM_Reject,
     /* 2344188 */ // Label 32410: @2344188
     /* 2344188 */ GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2344245), // Rule ID 58412 //
     /* 2344193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344207 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2344224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344244 */   // GIR_Coverage, 58412,
     /* 2344244 */   GIR_EraseRootFromParent_Done,
     /* 2344245 */ // Label 32463: @2344245
     /* 2344245 */ GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2344302), // Rule ID 58413 //
     /* 2344250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344264 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2344281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344301 */   // GIR_Coverage, 58413,
     /* 2344301 */   GIR_EraseRootFromParent_Done,
     /* 2344302 */ // Label 32464: @2344302
     /* 2344302 */ GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2344356), // Rule ID 58596 //
     /* 2344307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2344313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344321 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2344338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344343 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344355 */   // GIR_Coverage, 58596,
     /* 2344355 */   GIR_EraseRootFromParent_Done,
     /* 2344356 */ // Label 32465: @2344356
     /* 2344356 */ GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2344410), // Rule ID 58597 //
     /* 2344361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2344367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344375 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2344392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344397 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344409 */   // GIR_Coverage, 58597,
     /* 2344409 */   GIR_EraseRootFromParent_Done,
     /* 2344410 */ // Label 32466: @2344410
     /* 2344410 */ GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2344467), // Rule ID 58828 //
     /* 2344415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344429 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2344446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344466 */   // GIR_Coverage, 58828,
     /* 2344466 */   GIR_EraseRootFromParent_Done,
     /* 2344467 */ // Label 32467: @2344467
     /* 2344467 */ GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2344524), // Rule ID 58829 //
     /* 2344472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344486 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2344503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344523 */   // GIR_Coverage, 58829,
     /* 2344523 */   GIR_EraseRootFromParent_Done,
     /* 2344524 */ // Label 32468: @2344524
     /* 2344524 */ GIM_Reject,
     /* 2344525 */ // Label 32411: @2344525
     /* 2344525 */ GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2344582), // Rule ID 58424 //
     /* 2344530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344544 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2344561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344581 */   // GIR_Coverage, 58424,
     /* 2344581 */   GIR_EraseRootFromParent_Done,
     /* 2344582 */ // Label 32469: @2344582
     /* 2344582 */ GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2344639), // Rule ID 58425 //
     /* 2344587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344601 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2344618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344623 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344638 */   // GIR_Coverage, 58425,
     /* 2344638 */   GIR_EraseRootFromParent_Done,
     /* 2344639 */ // Label 32470: @2344639
     /* 2344639 */ GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2344693), // Rule ID 58620 //
     /* 2344644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344658 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2344675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344680 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344692 */   // GIR_Coverage, 58620,
     /* 2344692 */   GIR_EraseRootFromParent_Done,
     /* 2344693 */ // Label 32471: @2344693
     /* 2344693 */ GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2344747), // Rule ID 58621 //
     /* 2344698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344712 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2344729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344734 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344746 */   // GIR_Coverage, 58621,
     /* 2344746 */   GIR_EraseRootFromParent_Done,
     /* 2344747 */ // Label 32472: @2344747
     /* 2344747 */ GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2344804), // Rule ID 58848 //
     /* 2344752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2344755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344766 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2344783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344803 */   // GIR_Coverage, 58848,
     /* 2344803 */   GIR_EraseRootFromParent_Done,
     /* 2344804 */ // Label 32473: @2344804
     /* 2344804 */ GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2344861), // Rule ID 58849 //
     /* 2344809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2344812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344823 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2344840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344860 */   // GIR_Coverage, 58849,
     /* 2344860 */   GIR_EraseRootFromParent_Done,
     /* 2344861 */ // Label 32474: @2344861
     /* 2344861 */ GIM_Reject,
     /* 2344862 */ // Label 32412: @2344862
     /* 2344862 */ GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2344919), // Rule ID 58456 //
     /* 2344867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2344870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344881 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2344898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344903 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344918 */   // GIR_Coverage, 58456,
     /* 2344918 */   GIR_EraseRootFromParent_Done,
     /* 2344919 */ // Label 32475: @2344919
     /* 2344919 */ GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2344976), // Rule ID 58457 //
     /* 2344924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344938 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2344955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344960 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344975 */   // GIR_Coverage, 58457,
     /* 2344975 */   GIR_EraseRootFromParent_Done,
     /* 2344976 */ // Label 32476: @2344976
     /* 2344976 */ GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2345030), // Rule ID 58640 //
     /* 2344981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344995 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2345012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345017 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345029 */   // GIR_Coverage, 58640,
     /* 2345029 */   GIR_EraseRootFromParent_Done,
     /* 2345030 */ // Label 32477: @2345030
     /* 2345030 */ GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2345084), // Rule ID 58641 //
     /* 2345035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2345041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345049 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2345066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345083 */   // GIR_Coverage, 58641,
     /* 2345083 */   GIR_EraseRootFromParent_Done,
     /* 2345084 */ // Label 32478: @2345084
     /* 2345084 */ GIM_Reject,
     /* 2345085 */ // Label 32413: @2345085
     /* 2345085 */ GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2345142), // Rule ID 58420 //
     /* 2345090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345104 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2345121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345126 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345141 */   // GIR_Coverage, 58420,
     /* 2345141 */   GIR_EraseRootFromParent_Done,
     /* 2345142 */ // Label 32479: @2345142
     /* 2345142 */ GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2345199), // Rule ID 58421 //
     /* 2345147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345161 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2345178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345198 */   // GIR_Coverage, 58421,
     /* 2345198 */   GIR_EraseRootFromParent_Done,
     /* 2345199 */ // Label 32480: @2345199
     /* 2345199 */ GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2345253), // Rule ID 58600 //
     /* 2345204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2345210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345218 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2345235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345240 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345252 */   // GIR_Coverage, 58600,
     /* 2345252 */   GIR_EraseRootFromParent_Done,
     /* 2345253 */ // Label 32481: @2345253
     /* 2345253 */ GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2345307), // Rule ID 58601 //
     /* 2345258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2345264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345272 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2345289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345294 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345306 */   // GIR_Coverage, 58601,
     /* 2345306 */   GIR_EraseRootFromParent_Done,
     /* 2345307 */ // Label 32482: @2345307
     /* 2345307 */ GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2345364), // Rule ID 58832 //
     /* 2345312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345326 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2345343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345363 */   // GIR_Coverage, 58832,
     /* 2345363 */   GIR_EraseRootFromParent_Done,
     /* 2345364 */ // Label 32483: @2345364
     /* 2345364 */ GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2345421), // Rule ID 58833 //
     /* 2345369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345383 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2345400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345405 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345420 */   // GIR_Coverage, 58833,
     /* 2345420 */   GIR_EraseRootFromParent_Done,
     /* 2345421 */ // Label 32484: @2345421
     /* 2345421 */ GIM_Reject,
     /* 2345422 */ // Label 32414: @2345422
     /* 2345422 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2345479), // Rule ID 58444 //
     /* 2345427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345441 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2345458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345463 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345478 */   // GIR_Coverage, 58444,
     /* 2345478 */   GIR_EraseRootFromParent_Done,
     /* 2345479 */ // Label 32485: @2345479
     /* 2345479 */ GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2345536), // Rule ID 58445 //
     /* 2345484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345498 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2345515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345520 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345535 */   // GIR_Coverage, 58445,
     /* 2345535 */   GIR_EraseRootFromParent_Done,
     /* 2345536 */ // Label 32486: @2345536
     /* 2345536 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2345590), // Rule ID 58624 //
     /* 2345541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345555 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2345572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345577 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345589 */   // GIR_Coverage, 58624,
     /* 2345589 */   GIR_EraseRootFromParent_Done,
     /* 2345590 */ // Label 32487: @2345590
     /* 2345590 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2345644), // Rule ID 58625 //
     /* 2345595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345609 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2345626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345631 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345643 */   // GIR_Coverage, 58625,
     /* 2345643 */   GIR_EraseRootFromParent_Done,
     /* 2345644 */ // Label 32488: @2345644
     /* 2345644 */ GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2345701), // Rule ID 58852 //
     /* 2345649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2345652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345663 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2345680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345685 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345700 */   // GIR_Coverage, 58852,
     /* 2345700 */   GIR_EraseRootFromParent_Done,
     /* 2345701 */ // Label 32489: @2345701
     /* 2345701 */ GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2345758), // Rule ID 58853 //
     /* 2345706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2345709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345720 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2345737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345742 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345757 */   // GIR_Coverage, 58853,
     /* 2345757 */   GIR_EraseRootFromParent_Done,
     /* 2345758 */ // Label 32490: @2345758
     /* 2345758 */ GIM_Reject,
     /* 2345759 */ // Label 32415: @2345759
     /* 2345759 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2345816), // Rule ID 58460 //
     /* 2345764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2345767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345778 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2345795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345800 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345815 */   // GIR_Coverage, 58460,
     /* 2345815 */   GIR_EraseRootFromParent_Done,
     /* 2345816 */ // Label 32491: @2345816
     /* 2345816 */ GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2345873), // Rule ID 58461 //
     /* 2345821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2345824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345835 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2345852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345872 */   // GIR_Coverage, 58461,
     /* 2345872 */   GIR_EraseRootFromParent_Done,
     /* 2345873 */ // Label 32492: @2345873
     /* 2345873 */ GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2345927), // Rule ID 58644 //
     /* 2345878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345892 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2345909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345914 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345926 */   // GIR_Coverage, 58644,
     /* 2345926 */   GIR_EraseRootFromParent_Done,
     /* 2345927 */ // Label 32493: @2345927
     /* 2345927 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2345981), // Rule ID 58645 //
     /* 2345932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345946 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2345963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345968 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345980 */   // GIR_Coverage, 58645,
     /* 2345980 */   GIR_EraseRootFromParent_Done,
     /* 2345981 */ // Label 32494: @2345981
     /* 2345981 */ GIM_Reject,
     /* 2345982 */ // Label 32416: @2345982
     /* 2345982 */ GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2346039), // Rule ID 58432 //
     /* 2345987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346001 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2346018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346023 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346038 */   // GIR_Coverage, 58432,
     /* 2346038 */   GIR_EraseRootFromParent_Done,
     /* 2346039 */ // Label 32495: @2346039
     /* 2346039 */ GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2346096), // Rule ID 58433 //
     /* 2346044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346058 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2346075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346080 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346095 */   // GIR_Coverage, 58433,
     /* 2346095 */   GIR_EraseRootFromParent_Done,
     /* 2346096 */ // Label 32496: @2346096
     /* 2346096 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2346150), // Rule ID 58604 //
     /* 2346101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2346107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346115 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2346132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346149 */   // GIR_Coverage, 58604,
     /* 2346149 */   GIR_EraseRootFromParent_Done,
     /* 2346150 */ // Label 32497: @2346150
     /* 2346150 */ GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2346204), // Rule ID 58605 //
     /* 2346155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2346161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346169 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2346186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346191 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346203 */   // GIR_Coverage, 58605,
     /* 2346203 */   GIR_EraseRootFromParent_Done,
     /* 2346204 */ // Label 32498: @2346204
     /* 2346204 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2346261), // Rule ID 58836 //
     /* 2346209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346223 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2346240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346245 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346260 */   // GIR_Coverage, 58836,
     /* 2346260 */   GIR_EraseRootFromParent_Done,
     /* 2346261 */ // Label 32499: @2346261
     /* 2346261 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2346318), // Rule ID 58837 //
     /* 2346266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346280 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2346283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2346297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346302 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346317 */   // GIR_Coverage, 58837,
     /* 2346317 */   GIR_EraseRootFromParent_Done,
     /* 2346318 */ // Label 32500: @2346318
     /* 2346318 */ GIM_Reject,
     /* 2346319 */ // Label 32417: @2346319
     /* 2346319 */ GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2346376), // Rule ID 58448 //
     /* 2346324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346338 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2346355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346360 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346375 */   // GIR_Coverage, 58448,
     /* 2346375 */   GIR_EraseRootFromParent_Done,
     /* 2346376 */ // Label 32501: @2346376
     /* 2346376 */ GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2346433), // Rule ID 58449 //
     /* 2346381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346395 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2346412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346417 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346432 */   // GIR_Coverage, 58449,
     /* 2346432 */   GIR_EraseRootFromParent_Done,
     /* 2346433 */ // Label 32502: @2346433
     /* 2346433 */ GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2346487), // Rule ID 58628 //
     /* 2346438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346452 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2346469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346474 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346486 */   // GIR_Coverage, 58628,
     /* 2346486 */   GIR_EraseRootFromParent_Done,
     /* 2346487 */ // Label 32503: @2346487
     /* 2346487 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2346541), // Rule ID 58629 //
     /* 2346492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2346498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346506 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2346523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346540 */   // GIR_Coverage, 58629,
     /* 2346540 */   GIR_EraseRootFromParent_Done,
     /* 2346541 */ // Label 32504: @2346541
     /* 2346541 */ GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2346598), // Rule ID 58856 //
     /* 2346546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2346549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346560 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2346577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346597 */   // GIR_Coverage, 58856,
     /* 2346597 */   GIR_EraseRootFromParent_Done,
     /* 2346598 */ // Label 32505: @2346598
     /* 2346598 */ GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2346655), // Rule ID 58857 //
     /* 2346603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2346606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346617 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2346620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2346634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346639 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346654 */   // GIR_Coverage, 58857,
     /* 2346654 */   GIR_EraseRootFromParent_Done,
     /* 2346655 */ // Label 32506: @2346655
     /* 2346655 */ GIM_Reject,
     /* 2346656 */ // Label 32418: @2346656
     /* 2346656 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2346713), // Rule ID 58464 //
     /* 2346661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2346664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346675 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2346692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346697 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346712 */   // GIR_Coverage, 58464,
     /* 2346712 */   GIR_EraseRootFromParent_Done,
     /* 2346713 */ // Label 32507: @2346713
     /* 2346713 */ GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2346770), // Rule ID 58465 //
     /* 2346718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2346721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2346724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346732 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2346749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346754 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346769 */   // GIR_Coverage, 58465,
     /* 2346769 */   GIR_EraseRootFromParent_Done,
     /* 2346770 */ // Label 32508: @2346770
     /* 2346770 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2346824), // Rule ID 58648 //
     /* 2346775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2346778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346789 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2346806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346811 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346823 */   // GIR_Coverage, 58648,
     /* 2346823 */   GIR_EraseRootFromParent_Done,
     /* 2346824 */ // Label 32509: @2346824
     /* 2346824 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2346878), // Rule ID 58649 //
     /* 2346829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2346832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2346835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346843 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2346846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2346860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346877 */   // GIR_Coverage, 58649,
     /* 2346877 */   GIR_EraseRootFromParent_Done,
     /* 2346878 */ // Label 32510: @2346878
     /* 2346878 */ GIM_Reject,
     /* 2346879 */ // Label 32419: @2346879
     /* 2346879 */ GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2346936), // Rule ID 58436 //
     /* 2346884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346898 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2346915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346935 */   // GIR_Coverage, 58436,
     /* 2346935 */   GIR_EraseRootFromParent_Done,
     /* 2346936 */ // Label 32511: @2346936
     /* 2346936 */ GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2346993), // Rule ID 58437 //
     /* 2346941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346955 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2346972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346977 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346992 */   // GIR_Coverage, 58437,
     /* 2346992 */   GIR_EraseRootFromParent_Done,
     /* 2346993 */ // Label 32512: @2346993
     /* 2346993 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2347047), // Rule ID 58608 //
     /* 2346998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2347004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347012 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2347029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347034 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347046 */   // GIR_Coverage, 58608,
     /* 2347046 */   GIR_EraseRootFromParent_Done,
     /* 2347047 */ // Label 32513: @2347047
     /* 2347047 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2347101), // Rule ID 58609 //
     /* 2347052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2347058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347066 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2347083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347088 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347100 */   // GIR_Coverage, 58609,
     /* 2347100 */   GIR_EraseRootFromParent_Done,
     /* 2347101 */ // Label 32514: @2347101
     /* 2347101 */ GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2347158), // Rule ID 58840 //
     /* 2347106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347120 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2347137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347142 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347157 */   // GIR_Coverage, 58840,
     /* 2347157 */   GIR_EraseRootFromParent_Done,
     /* 2347158 */ // Label 32515: @2347158
     /* 2347158 */ GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2347215), // Rule ID 58841 //
     /* 2347163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347177 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2347194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347214 */   // GIR_Coverage, 58841,
     /* 2347214 */   GIR_EraseRootFromParent_Done,
     /* 2347215 */ // Label 32516: @2347215
     /* 2347215 */ GIM_Reject,
     /* 2347216 */ // Label 32420: @2347216
     /* 2347216 */ GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2347273), // Rule ID 58452 //
     /* 2347221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347235 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2347252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347257 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347272 */   // GIR_Coverage, 58452,
     /* 2347272 */   GIR_EraseRootFromParent_Done,
     /* 2347273 */ // Label 32517: @2347273
     /* 2347273 */ GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2347330), // Rule ID 58453 //
     /* 2347278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2347284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347292 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2347309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347329 */   // GIR_Coverage, 58453,
     /* 2347329 */   GIR_EraseRootFromParent_Done,
     /* 2347330 */ // Label 32518: @2347330
     /* 2347330 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2347384), // Rule ID 58632 //
     /* 2347335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2347338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347349 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2347366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347371 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347383 */   // GIR_Coverage, 58632,
     /* 2347383 */   GIR_EraseRootFromParent_Done,
     /* 2347384 */ // Label 32519: @2347384
     /* 2347384 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2347438), // Rule ID 58633 //
     /* 2347389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2347392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347403 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2347406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2347420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347437 */   // GIR_Coverage, 58633,
     /* 2347437 */   GIR_EraseRootFromParent_Done,
     /* 2347438 */ // Label 32520: @2347438
     /* 2347438 */ GIM_Reject,
     /* 2347439 */ // Label 32421: @2347439
     /* 2347439 */ GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2347496), // Rule ID 58440 //
     /* 2347444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347458 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2347475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347480 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347495 */   // GIR_Coverage, 58440,
     /* 2347495 */   GIR_EraseRootFromParent_Done,
     /* 2347496 */ // Label 32521: @2347496
     /* 2347496 */ GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2347553), // Rule ID 58441 //
     /* 2347501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2347507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347515 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2347532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347537 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347552 */   // GIR_Coverage, 58441,
     /* 2347552 */   GIR_EraseRootFromParent_Done,
     /* 2347553 */ // Label 32522: @2347553
     /* 2347553 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2347607), // Rule ID 58612 //
     /* 2347558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2347561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347572 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2347589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347606 */   // GIR_Coverage, 58612,
     /* 2347606 */   GIR_EraseRootFromParent_Done,
     /* 2347607 */ // Label 32523: @2347607
     /* 2347607 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2347661), // Rule ID 58613 //
     /* 2347612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2347615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2347618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347626 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2347629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2347643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347648 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347660 */   // GIR_Coverage, 58613,
     /* 2347660 */   GIR_EraseRootFromParent_Done,
     /* 2347661 */ // Label 32524: @2347661
     /* 2347661 */ GIM_Reject,
     /* 2347662 */ // Label 32422: @2347662
     /* 2347662 */ GIM_Reject,
     /* 2347663 */ // Label 70: @2347663
     /* 2347663 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32543*/ GIMT_Encode4(2352948),
     /* 2347674 */ /*GILLT_s16*//*Label 32525*/ GIMT_Encode4(2347794),
     /* 2347678 */ /*GILLT_s32*//*Label 32526*/ GIMT_Encode4(2348055),
     /* 2347682 */ /*GILLT_s64*//*Label 32527*/ GIMT_Encode4(2348316), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347694 */ /*GILLT_nxv1s16*//*Label 32528*/ GIMT_Encode4(2348577),
     /* 2347698 */ /*GILLT_nxv1s32*//*Label 32529*/ GIMT_Encode4(2348914),
     /* 2347702 */ /*GILLT_nxv1s64*//*Label 32530*/ GIMT_Encode4(2349251), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347714 */ /*GILLT_nxv2s16*//*Label 32531*/ GIMT_Encode4(2349474),
     /* 2347718 */ /*GILLT_nxv2s32*//*Label 32532*/ GIMT_Encode4(2349811),
     /* 2347722 */ /*GILLT_nxv2s64*//*Label 32533*/ GIMT_Encode4(2350148), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347734 */ /*GILLT_nxv4s16*//*Label 32534*/ GIMT_Encode4(2350371),
     /* 2347738 */ /*GILLT_nxv4s32*//*Label 32535*/ GIMT_Encode4(2350708),
     /* 2347742 */ /*GILLT_nxv4s64*//*Label 32536*/ GIMT_Encode4(2351045), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347754 */ /*GILLT_nxv8s16*//*Label 32537*/ GIMT_Encode4(2351268),
     /* 2347758 */ /*GILLT_nxv8s32*//*Label 32538*/ GIMT_Encode4(2351605),
     /* 2347762 */ /*GILLT_nxv8s64*//*Label 32539*/ GIMT_Encode4(2351942), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347774 */ /*GILLT_nxv16s16*//*Label 32540*/ GIMT_Encode4(2352165),
     /* 2347778 */ /*GILLT_nxv16s32*//*Label 32541*/ GIMT_Encode4(2352502), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2347790 */ /*GILLT_nxv32s16*//*Label 32542*/ GIMT_Encode4(2352725),
     /* 2347794 */ // Label 32525: @2347794
     /* 2347794 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2347831), // Rule ID 2263 //
     /* 2347799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2347802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2347816 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2347816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2347826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347830 */   // GIR_Coverage, 2263,
     /* 2347830 */   GIR_EraseRootFromParent_Done,
     /* 2347831 */ // Label 32544: @2347831
     /* 2347831 */ GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2347868), // Rule ID 2289 //
     /* 2347836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2347839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2347853 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2347853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2347863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347867 */   // GIR_Coverage, 2289,
     /* 2347867 */   GIR_EraseRootFromParent_Done,
     /* 2347868 */ // Label 32545: @2347868
     /* 2347868 */ GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2347899), // Rule ID 2214 //
     /* 2347873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2347876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347887 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2347887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347892 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347898 */   // GIR_Coverage, 2214,
     /* 2347898 */   GIR_EraseRootFromParent_Done,
     /* 2347899 */ // Label 32546: @2347899
     /* 2347899 */ GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2347930), // Rule ID 2215 //
     /* 2347904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2347907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2347914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347918 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2347918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2347921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347929 */   // GIR_Coverage, 2215,
     /* 2347929 */   GIR_EraseRootFromParent_Done,
     /* 2347930 */ // Label 32547: @2347930
     /* 2347930 */ GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2347961), // Rule ID 2240 //
     /* 2347935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2347938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347949 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2347949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347960 */   // GIR_Coverage, 2240,
     /* 2347960 */   GIR_EraseRootFromParent_Done,
     /* 2347961 */ // Label 32548: @2347961
     /* 2347961 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2347992), // Rule ID 2241 //
     /* 2347966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2347969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2347976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347980 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2347980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2347983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2347990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2347991 */   // GIR_Coverage, 2241,
     /* 2347991 */   GIR_EraseRootFromParent_Done,
     /* 2347992 */ // Label 32549: @2347992
     /* 2347992 */ GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2348023), // Rule ID 2267 //
     /* 2347997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2348000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348011 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2348014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348022 */   // GIR_Coverage, 2267,
     /* 2348022 */   GIR_EraseRootFromParent_Done,
     /* 2348023 */ // Label 32550: @2348023
     /* 2348023 */ GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2348054), // Rule ID 2293 //
     /* 2348028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2348031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348042 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2348045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348053 */   // GIR_Coverage, 2293,
     /* 2348053 */   GIR_EraseRootFromParent_Done,
     /* 2348054 */ // Label 32551: @2348054
     /* 2348054 */ GIM_Reject,
     /* 2348055 */ // Label 32526: @2348055
     /* 2348055 */ GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2348092), // Rule ID 1529 //
     /* 2348060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2348063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348077 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348091 */   // GIR_Coverage, 1529,
     /* 2348091 */   GIR_EraseRootFromParent_Done,
     /* 2348092 */ // Label 32552: @2348092
     /* 2348092 */ GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2348129), // Rule ID 1557 //
     /* 2348097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2348100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348114 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348127 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348128 */   // GIR_Coverage, 1557,
     /* 2348128 */   GIR_EraseRootFromParent_Done,
     /* 2348129 */ // Label 32553: @2348129
     /* 2348129 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2348160), // Rule ID 1478 //
     /* 2348134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2348137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348148 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2348148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348153 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348159 */   // GIR_Coverage, 1478,
     /* 2348159 */   GIR_EraseRootFromParent_Done,
     /* 2348160 */ // Label 32554: @2348160
     /* 2348160 */ GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2348191), // Rule ID 1479 //
     /* 2348165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2348168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348179 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2348179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2348182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348184 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348190 */   // GIR_Coverage, 1479,
     /* 2348190 */   GIR_EraseRootFromParent_Done,
     /* 2348191 */ // Label 32555: @2348191
     /* 2348191 */ GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2348222), // Rule ID 1504 //
     /* 2348196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2348199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348210 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2348210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348221 */   // GIR_Coverage, 1504,
     /* 2348221 */   GIR_EraseRootFromParent_Done,
     /* 2348222 */ // Label 32556: @2348222
     /* 2348222 */ GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2348253), // Rule ID 1505 //
     /* 2348227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2348230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348241 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2348241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2348244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348246 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348252 */   // GIR_Coverage, 1505,
     /* 2348252 */   GIR_EraseRootFromParent_Done,
     /* 2348253 */ // Label 32557: @2348253
     /* 2348253 */ GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2348284), // Rule ID 1533 //
     /* 2348258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2348261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348272 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2348275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348277 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348283 */   // GIR_Coverage, 1533,
     /* 2348283 */   GIR_EraseRootFromParent_Done,
     /* 2348284 */ // Label 32558: @2348284
     /* 2348284 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2348315), // Rule ID 1561 //
     /* 2348289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2348292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348303 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2348306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348308 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348314 */   // GIR_Coverage, 1561,
     /* 2348314 */   GIR_EraseRootFromParent_Done,
     /* 2348315 */ // Label 32559: @2348315
     /* 2348315 */ GIM_Reject,
     /* 2348316 */ // Label 32527: @2348316
     /* 2348316 */ GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2348353), // Rule ID 1909 //
     /* 2348321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2348324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348338 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2348338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348352 */   // GIR_Coverage, 1909,
     /* 2348352 */   GIR_EraseRootFromParent_Done,
     /* 2348353 */ // Label 32560: @2348353
     /* 2348353 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2348390), // Rule ID 1937 //
     /* 2348358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2348361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2348375 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2348375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2348378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2348385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348389 */   // GIR_Coverage, 1937,
     /* 2348389 */   GIR_EraseRootFromParent_Done,
     /* 2348390 */ // Label 32561: @2348390
     /* 2348390 */ GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2348421), // Rule ID 1872 //
     /* 2348395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2348398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348409 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2348409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348414 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348420 */   // GIR_Coverage, 1872,
     /* 2348420 */   GIR_EraseRootFromParent_Done,
     /* 2348421 */ // Label 32562: @2348421
     /* 2348421 */ GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2348452), // Rule ID 1873 //
     /* 2348426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2348429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348440 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2348440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2348443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348445 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348451 */   // GIR_Coverage, 1873,
     /* 2348451 */   GIR_EraseRootFromParent_Done,
     /* 2348452 */ // Label 32563: @2348452
     /* 2348452 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2348483), // Rule ID 1898 //
     /* 2348457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2348460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348471 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2348471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2348474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348476 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348482 */   // GIR_Coverage, 1898,
     /* 2348482 */   GIR_EraseRootFromParent_Done,
     /* 2348483 */ // Label 32564: @2348483
     /* 2348483 */ GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2348514), // Rule ID 1899 //
     /* 2348488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2348491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348502 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2348502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2348505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348507 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2348512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348513 */   // GIR_Coverage, 1899,
     /* 2348513 */   GIR_EraseRootFromParent_Done,
     /* 2348514 */ // Label 32565: @2348514
     /* 2348514 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2348545), // Rule ID 1927 //
     /* 2348519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2348522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348533 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2348536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348538 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348544 */   // GIR_Coverage, 1927,
     /* 2348544 */   GIR_EraseRootFromParent_Done,
     /* 2348545 */ // Label 32566: @2348545
     /* 2348545 */ GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2348576), // Rule ID 1955 //
     /* 2348550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2348553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348564 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2348564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2348567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348569 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348575 */   // GIR_Coverage, 1955,
     /* 2348575 */   GIR_EraseRootFromParent_Done,
     /* 2348576 */ // Label 32567: @2348576
     /* 2348576 */ GIM_Reject,
     /* 2348577 */ // Label 32528: @2348577
     /* 2348577 */ GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2348634), // Rule ID 58468 //
     /* 2348582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348596 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2348613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348618 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348633 */   // GIR_Coverage, 58468,
     /* 2348633 */   GIR_EraseRootFromParent_Done,
     /* 2348634 */ // Label 32568: @2348634
     /* 2348634 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2348691), // Rule ID 58469 //
     /* 2348639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348653 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2348670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348675 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348690 */   // GIR_Coverage, 58469,
     /* 2348690 */   GIR_EraseRootFromParent_Done,
     /* 2348691 */ // Label 32569: @2348691
     /* 2348691 */ GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2348745), // Rule ID 58652 //
     /* 2348696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2348702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348710 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2348727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348732 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348744 */   // GIR_Coverage, 58652,
     /* 2348744 */   GIR_EraseRootFromParent_Done,
     /* 2348745 */ // Label 32570: @2348745
     /* 2348745 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2348799), // Rule ID 58653 //
     /* 2348750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2348756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348764 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2348781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348786 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348798 */   // GIR_Coverage, 58653,
     /* 2348798 */   GIR_EraseRootFromParent_Done,
     /* 2348799 */ // Label 32571: @2348799
     /* 2348799 */ GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2348856), // Rule ID 58860 //
     /* 2348804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2348807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348818 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2348835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348840 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348855 */   // GIR_Coverage, 58860,
     /* 2348855 */   GIR_EraseRootFromParent_Done,
     /* 2348856 */ // Label 32572: @2348856
     /* 2348856 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2348913), // Rule ID 58861 //
     /* 2348861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2348864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348875 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2348892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348897 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348912 */   // GIR_Coverage, 58861,
     /* 2348912 */   GIR_EraseRootFromParent_Done,
     /* 2348913 */ // Label 32573: @2348913
     /* 2348913 */ GIM_Reject,
     /* 2348914 */ // Label 32529: @2348914
     /* 2348914 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2348971), // Rule ID 58476 //
     /* 2348919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2348922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348933 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2348950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348955 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2348960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348970 */   // GIR_Coverage, 58476,
     /* 2348970 */   GIR_EraseRootFromParent_Done,
     /* 2348971 */ // Label 32574: @2348971
     /* 2348971 */ GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2349028), // Rule ID 58477 //
     /* 2348976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2348979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348990 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2349007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349027 */   // GIR_Coverage, 58477,
     /* 2349027 */   GIR_EraseRootFromParent_Done,
     /* 2349028 */ // Label 32575: @2349028
     /* 2349028 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2349082), // Rule ID 58676 //
     /* 2349033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2349039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349047 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2349064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349081 */   // GIR_Coverage, 58676,
     /* 2349081 */   GIR_EraseRootFromParent_Done,
     /* 2349082 */ // Label 32576: @2349082
     /* 2349082 */ GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2349136), // Rule ID 58677 //
     /* 2349087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2349093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349101 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2349118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349123 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349135 */   // GIR_Coverage, 58677,
     /* 2349135 */   GIR_EraseRootFromParent_Done,
     /* 2349136 */ // Label 32577: @2349136
     /* 2349136 */ GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2349193), // Rule ID 58880 //
     /* 2349141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2349144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349155 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2349172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349177 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349192 */   // GIR_Coverage, 58880,
     /* 2349192 */   GIR_EraseRootFromParent_Done,
     /* 2349193 */ // Label 32578: @2349193
     /* 2349193 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2349250), // Rule ID 58881 //
     /* 2349198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2349201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349212 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2349229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349234 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349249 */   // GIR_Coverage, 58881,
     /* 2349249 */   GIR_EraseRootFromParent_Done,
     /* 2349250 */ // Label 32579: @2349250
     /* 2349250 */ GIM_Reject,
     /* 2349251 */ // Label 32530: @2349251
     /* 2349251 */ GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2349308), // Rule ID 58488 //
     /* 2349256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2349259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349270 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2349287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349307 */   // GIR_Coverage, 58488,
     /* 2349307 */   GIR_EraseRootFromParent_Done,
     /* 2349308 */ // Label 32580: @2349308
     /* 2349308 */ GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2349365), // Rule ID 58489 //
     /* 2349313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2349316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349327 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2349344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349364 */   // GIR_Coverage, 58489,
     /* 2349364 */   GIR_EraseRootFromParent_Done,
     /* 2349365 */ // Label 32581: @2349365
     /* 2349365 */ GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2349419), // Rule ID 58696 //
     /* 2349370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2349373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2349376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349384 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2349401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349418 */   // GIR_Coverage, 58696,
     /* 2349418 */   GIR_EraseRootFromParent_Done,
     /* 2349419 */ // Label 32582: @2349419
     /* 2349419 */ GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2349473), // Rule ID 58697 //
     /* 2349424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2349427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2349430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349438 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2349455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349460 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349472 */   // GIR_Coverage, 58697,
     /* 2349472 */   GIR_EraseRootFromParent_Done,
     /* 2349473 */ // Label 32583: @2349473
     /* 2349473 */ GIM_Reject,
     /* 2349474 */ // Label 32531: @2349474
     /* 2349474 */ GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2349531), // Rule ID 58472 //
     /* 2349479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349493 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2349510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349515 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349530 */   // GIR_Coverage, 58472,
     /* 2349530 */   GIR_EraseRootFromParent_Done,
     /* 2349531 */ // Label 32584: @2349531
     /* 2349531 */ GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2349588), // Rule ID 58473 //
     /* 2349536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349550 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2349567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349572 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349587 */   // GIR_Coverage, 58473,
     /* 2349587 */   GIR_EraseRootFromParent_Done,
     /* 2349588 */ // Label 32585: @2349588
     /* 2349588 */ GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2349642), // Rule ID 58656 //
     /* 2349593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2349599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349607 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2349624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349629 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349641 */   // GIR_Coverage, 58656,
     /* 2349641 */   GIR_EraseRootFromParent_Done,
     /* 2349642 */ // Label 32586: @2349642
     /* 2349642 */ GIM_Try, /*On fail goto*//*Label 32587*/ GIMT_Encode4(2349696), // Rule ID 58657 //
     /* 2349647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2349653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349661 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2349678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349683 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349695 */   // GIR_Coverage, 58657,
     /* 2349695 */   GIR_EraseRootFromParent_Done,
     /* 2349696 */ // Label 32587: @2349696
     /* 2349696 */ GIM_Try, /*On fail goto*//*Label 32588*/ GIMT_Encode4(2349753), // Rule ID 58864 //
     /* 2349701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2349704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349715 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2349732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349752 */   // GIR_Coverage, 58864,
     /* 2349752 */   GIR_EraseRootFromParent_Done,
     /* 2349753 */ // Label 32588: @2349753
     /* 2349753 */ GIM_Try, /*On fail goto*//*Label 32589*/ GIMT_Encode4(2349810), // Rule ID 58865 //
     /* 2349758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2349761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349772 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2349789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349809 */   // GIR_Coverage, 58865,
     /* 2349809 */   GIR_EraseRootFromParent_Done,
     /* 2349810 */ // Label 32589: @2349810
     /* 2349810 */ GIM_Reject,
     /* 2349811 */ // Label 32532: @2349811
     /* 2349811 */ GIM_Try, /*On fail goto*//*Label 32590*/ GIMT_Encode4(2349868), // Rule ID 58484 //
     /* 2349816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349830 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2349847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349852 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349867 */   // GIR_Coverage, 58484,
     /* 2349867 */   GIR_EraseRootFromParent_Done,
     /* 2349868 */ // Label 32590: @2349868
     /* 2349868 */ GIM_Try, /*On fail goto*//*Label 32591*/ GIMT_Encode4(2349925), // Rule ID 58485 //
     /* 2349873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349887 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2349904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349909 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2349914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349924 */   // GIR_Coverage, 58485,
     /* 2349924 */   GIR_EraseRootFromParent_Done,
     /* 2349925 */ // Label 32591: @2349925
     /* 2349925 */ GIM_Try, /*On fail goto*//*Label 32592*/ GIMT_Encode4(2349979), // Rule ID 58680 //
     /* 2349930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2349933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349944 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2349961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2349978 */   // GIR_Coverage, 58680,
     /* 2349978 */   GIR_EraseRootFromParent_Done,
     /* 2349979 */ // Label 32592: @2349979
     /* 2349979 */ GIM_Try, /*On fail goto*//*Label 32593*/ GIMT_Encode4(2350033), // Rule ID 58681 //
     /* 2349984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2349987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349998 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2350015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350020 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350032 */   // GIR_Coverage, 58681,
     /* 2350032 */   GIR_EraseRootFromParent_Done,
     /* 2350033 */ // Label 32593: @2350033
     /* 2350033 */ GIM_Try, /*On fail goto*//*Label 32594*/ GIMT_Encode4(2350090), // Rule ID 58884 //
     /* 2350038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2350041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350052 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2350069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350089 */   // GIR_Coverage, 58884,
     /* 2350089 */   GIR_EraseRootFromParent_Done,
     /* 2350090 */ // Label 32594: @2350090
     /* 2350090 */ GIM_Try, /*On fail goto*//*Label 32595*/ GIMT_Encode4(2350147), // Rule ID 58885 //
     /* 2350095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2350098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350109 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2350112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2350126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350146 */   // GIR_Coverage, 58885,
     /* 2350146 */   GIR_EraseRootFromParent_Done,
     /* 2350147 */ // Label 32595: @2350147
     /* 2350147 */ GIM_Reject,
     /* 2350148 */ // Label 32533: @2350148
     /* 2350148 */ GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2350205), // Rule ID 58516 //
     /* 2350153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2350156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350167 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2350184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350204 */   // GIR_Coverage, 58516,
     /* 2350204 */   GIR_EraseRootFromParent_Done,
     /* 2350205 */ // Label 32596: @2350205
     /* 2350205 */ GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2350262), // Rule ID 58517 //
     /* 2350210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2350213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2350216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350224 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2350241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350246 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350261 */   // GIR_Coverage, 58517,
     /* 2350261 */   GIR_EraseRootFromParent_Done,
     /* 2350262 */ // Label 32597: @2350262
     /* 2350262 */ GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2350316), // Rule ID 58700 //
     /* 2350267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2350270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2350273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350281 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2350298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350303 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350315 */   // GIR_Coverage, 58700,
     /* 2350315 */   GIR_EraseRootFromParent_Done,
     /* 2350316 */ // Label 32598: @2350316
     /* 2350316 */ GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2350370), // Rule ID 58701 //
     /* 2350321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2350324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2350327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350335 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2350338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2350352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350357 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350369 */   // GIR_Coverage, 58701,
     /* 2350369 */   GIR_EraseRootFromParent_Done,
     /* 2350370 */ // Label 32599: @2350370
     /* 2350370 */ GIM_Reject,
     /* 2350371 */ // Label 32534: @2350371
     /* 2350371 */ GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2350428), // Rule ID 58480 //
     /* 2350376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350390 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2350407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350427 */   // GIR_Coverage, 58480,
     /* 2350427 */   GIR_EraseRootFromParent_Done,
     /* 2350428 */ // Label 32600: @2350428
     /* 2350428 */ GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2350485), // Rule ID 58481 //
     /* 2350433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350447 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2350464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350469 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350484 */   // GIR_Coverage, 58481,
     /* 2350484 */   GIR_EraseRootFromParent_Done,
     /* 2350485 */ // Label 32601: @2350485
     /* 2350485 */ GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2350539), // Rule ID 58660 //
     /* 2350490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2350496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350504 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2350521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350526 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350538 */   // GIR_Coverage, 58660,
     /* 2350538 */   GIR_EraseRootFromParent_Done,
     /* 2350539 */ // Label 32602: @2350539
     /* 2350539 */ GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2350593), // Rule ID 58661 //
     /* 2350544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2350550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350558 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2350575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350580 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350592 */   // GIR_Coverage, 58661,
     /* 2350592 */   GIR_EraseRootFromParent_Done,
     /* 2350593 */ // Label 32603: @2350593
     /* 2350593 */ GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2350650), // Rule ID 58868 //
     /* 2350598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2350601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350612 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2350629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350634 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350649 */   // GIR_Coverage, 58868,
     /* 2350649 */   GIR_EraseRootFromParent_Done,
     /* 2350650 */ // Label 32604: @2350650
     /* 2350650 */ GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2350707), // Rule ID 58869 //
     /* 2350655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2350658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350669 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2350672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2350686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350706 */   // GIR_Coverage, 58869,
     /* 2350706 */   GIR_EraseRootFromParent_Done,
     /* 2350707 */ // Label 32605: @2350707
     /* 2350707 */ GIM_Reject,
     /* 2350708 */ // Label 32535: @2350708
     /* 2350708 */ GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2350765), // Rule ID 58504 //
     /* 2350713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2350716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350727 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2350744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350749 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350764 */   // GIR_Coverage, 58504,
     /* 2350764 */   GIR_EraseRootFromParent_Done,
     /* 2350765 */ // Label 32606: @2350765
     /* 2350765 */ GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2350822), // Rule ID 58505 //
     /* 2350770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2350773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2350776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350784 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2350801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350806 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350821 */   // GIR_Coverage, 58505,
     /* 2350821 */   GIR_EraseRootFromParent_Done,
     /* 2350822 */ // Label 32607: @2350822
     /* 2350822 */ GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2350876), // Rule ID 58684 //
     /* 2350827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2350830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350841 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2350858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350863 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350875 */   // GIR_Coverage, 58684,
     /* 2350875 */   GIR_EraseRootFromParent_Done,
     /* 2350876 */ // Label 32608: @2350876
     /* 2350876 */ GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2350930), // Rule ID 58685 //
     /* 2350881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2350884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2350887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350895 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2350912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350917 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350929 */   // GIR_Coverage, 58685,
     /* 2350929 */   GIR_EraseRootFromParent_Done,
     /* 2350930 */ // Label 32609: @2350930
     /* 2350930 */ GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2350987), // Rule ID 58888 //
     /* 2350935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2350938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2350941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350949 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2350952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2350966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350971 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2350976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2350986 */   // GIR_Coverage, 58888,
     /* 2350986 */   GIR_EraseRootFromParent_Done,
     /* 2350987 */ // Label 32610: @2350987
     /* 2350987 */ GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2351044), // Rule ID 58889 //
     /* 2350992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2350995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2350998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351006 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2351009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2351023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351043 */   // GIR_Coverage, 58889,
     /* 2351043 */   GIR_EraseRootFromParent_Done,
     /* 2351044 */ // Label 32611: @2351044
     /* 2351044 */ GIM_Reject,
     /* 2351045 */ // Label 32536: @2351045
     /* 2351045 */ GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2351102), // Rule ID 58520 //
     /* 2351050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2351053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351064 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2351081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351086 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351101 */   // GIR_Coverage, 58520,
     /* 2351101 */   GIR_EraseRootFromParent_Done,
     /* 2351102 */ // Label 32612: @2351102
     /* 2351102 */ GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2351159), // Rule ID 58521 //
     /* 2351107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2351110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351121 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351121 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351128 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2351138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351143 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351158 */   // GIR_Coverage, 58521,
     /* 2351158 */   GIR_EraseRootFromParent_Done,
     /* 2351159 */ // Label 32613: @2351159
     /* 2351159 */ GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2351213), // Rule ID 58704 //
     /* 2351164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2351167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2351170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351178 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2351195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351200 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351212 */   // GIR_Coverage, 58704,
     /* 2351212 */   GIR_EraseRootFromParent_Done,
     /* 2351213 */ // Label 32614: @2351213
     /* 2351213 */ GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2351267), // Rule ID 58705 //
     /* 2351218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2351221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2351224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351232 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2351249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351266 */   // GIR_Coverage, 58705,
     /* 2351266 */   GIR_EraseRootFromParent_Done,
     /* 2351267 */ // Label 32615: @2351267
     /* 2351267 */ GIM_Reject,
     /* 2351268 */ // Label 32537: @2351268
     /* 2351268 */ GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2351325), // Rule ID 58492 //
     /* 2351273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351287 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2351304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351324 */   // GIR_Coverage, 58492,
     /* 2351324 */   GIR_EraseRootFromParent_Done,
     /* 2351325 */ // Label 32616: @2351325
     /* 2351325 */ GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2351382), // Rule ID 58493 //
     /* 2351330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351344 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2351361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351366 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351381 */   // GIR_Coverage, 58493,
     /* 2351381 */   GIR_EraseRootFromParent_Done,
     /* 2351382 */ // Label 32617: @2351382
     /* 2351382 */ GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2351436), // Rule ID 58664 //
     /* 2351387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2351393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351401 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2351418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351423 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351435 */   // GIR_Coverage, 58664,
     /* 2351435 */   GIR_EraseRootFromParent_Done,
     /* 2351436 */ // Label 32618: @2351436
     /* 2351436 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2351490), // Rule ID 58665 //
     /* 2351441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2351447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351455 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2351472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351477 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351489 */   // GIR_Coverage, 58665,
     /* 2351489 */   GIR_EraseRootFromParent_Done,
     /* 2351490 */ // Label 32619: @2351490
     /* 2351490 */ GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2351547), // Rule ID 58872 //
     /* 2351495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2351498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351509 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2351526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351531 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351546 */   // GIR_Coverage, 58872,
     /* 2351546 */   GIR_EraseRootFromParent_Done,
     /* 2351547 */ // Label 32620: @2351547
     /* 2351547 */ GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2351604), // Rule ID 58873 //
     /* 2351552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2351555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351566 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2351583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351603 */   // GIR_Coverage, 58873,
     /* 2351603 */   GIR_EraseRootFromParent_Done,
     /* 2351604 */ // Label 32621: @2351604
     /* 2351604 */ GIM_Reject,
     /* 2351605 */ // Label 32538: @2351605
     /* 2351605 */ GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2351662), // Rule ID 58508 //
     /* 2351610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2351613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351624 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2351641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351646 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351661 */   // GIR_Coverage, 58508,
     /* 2351661 */   GIR_EraseRootFromParent_Done,
     /* 2351662 */ // Label 32622: @2351662
     /* 2351662 */ GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2351719), // Rule ID 58509 //
     /* 2351667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2351670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2351673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351681 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2351698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351718 */   // GIR_Coverage, 58509,
     /* 2351718 */   GIR_EraseRootFromParent_Done,
     /* 2351719 */ // Label 32623: @2351719
     /* 2351719 */ GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2351773), // Rule ID 58688 //
     /* 2351724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2351727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351738 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2351755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351772 */   // GIR_Coverage, 58688,
     /* 2351772 */   GIR_EraseRootFromParent_Done,
     /* 2351773 */ // Label 32624: @2351773
     /* 2351773 */ GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2351827), // Rule ID 58689 //
     /* 2351778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2351781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351792 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2351809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351814 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351826 */   // GIR_Coverage, 58689,
     /* 2351826 */   GIR_EraseRootFromParent_Done,
     /* 2351827 */ // Label 32625: @2351827
     /* 2351827 */ GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2351884), // Rule ID 58892 //
     /* 2351832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2351835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351846 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2351863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351868 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351883 */   // GIR_Coverage, 58892,
     /* 2351883 */   GIR_EraseRootFromParent_Done,
     /* 2351884 */ // Label 32626: @2351884
     /* 2351884 */ GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2351941), // Rule ID 58893 //
     /* 2351889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2351892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351903 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2351906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2351920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351940 */   // GIR_Coverage, 58893,
     /* 2351940 */   GIR_EraseRootFromParent_Done,
     /* 2351941 */ // Label 32627: @2351941
     /* 2351941 */ GIM_Reject,
     /* 2351942 */ // Label 32539: @2351942
     /* 2351942 */ GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2351999), // Rule ID 58524 //
     /* 2351947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2351950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2351953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351961 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2351964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2351978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2351988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2351998 */   // GIR_Coverage, 58524,
     /* 2351998 */   GIR_EraseRootFromParent_Done,
     /* 2351999 */ // Label 32628: @2351999
     /* 2351999 */ GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2352056), // Rule ID 58525 //
     /* 2352004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2352007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2352010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352018 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2352035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352055 */   // GIR_Coverage, 58525,
     /* 2352055 */   GIR_EraseRootFromParent_Done,
     /* 2352056 */ // Label 32629: @2352056
     /* 2352056 */ GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2352110), // Rule ID 58708 //
     /* 2352061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2352064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352075 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2352092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352097 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352109 */   // GIR_Coverage, 58708,
     /* 2352109 */   GIR_EraseRootFromParent_Done,
     /* 2352110 */ // Label 32630: @2352110
     /* 2352110 */ GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2352164), // Rule ID 58709 //
     /* 2352115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2352118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352129 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2352146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352151 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352163 */   // GIR_Coverage, 58709,
     /* 2352163 */   GIR_EraseRootFromParent_Done,
     /* 2352164 */ // Label 32631: @2352164
     /* 2352164 */ GIM_Reject,
     /* 2352165 */ // Label 32540: @2352165
     /* 2352165 */ GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2352222), // Rule ID 58496 //
     /* 2352170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352184 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2352201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352206 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352221 */   // GIR_Coverage, 58496,
     /* 2352221 */   GIR_EraseRootFromParent_Done,
     /* 2352222 */ // Label 32632: @2352222
     /* 2352222 */ GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2352279), // Rule ID 58497 //
     /* 2352227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352241 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2352258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352278 */   // GIR_Coverage, 58497,
     /* 2352278 */   GIR_EraseRootFromParent_Done,
     /* 2352279 */ // Label 32633: @2352279
     /* 2352279 */ GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2352333), // Rule ID 58668 //
     /* 2352284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2352290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352298 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2352315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352332 */   // GIR_Coverage, 58668,
     /* 2352332 */   GIR_EraseRootFromParent_Done,
     /* 2352333 */ // Label 32634: @2352333
     /* 2352333 */ GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2352387), // Rule ID 58669 //
     /* 2352338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2352344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352352 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2352369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352374 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352386 */   // GIR_Coverage, 58669,
     /* 2352386 */   GIR_EraseRootFromParent_Done,
     /* 2352387 */ // Label 32635: @2352387
     /* 2352387 */ GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2352444), // Rule ID 58876 //
     /* 2352392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352406 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2352423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352428 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352443 */   // GIR_Coverage, 58876,
     /* 2352443 */   GIR_EraseRootFromParent_Done,
     /* 2352444 */ // Label 32636: @2352444
     /* 2352444 */ GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2352501), // Rule ID 58877 //
     /* 2352449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352463 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2352480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352485 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352500 */   // GIR_Coverage, 58877,
     /* 2352500 */   GIR_EraseRootFromParent_Done,
     /* 2352501 */ // Label 32637: @2352501
     /* 2352501 */ GIM_Reject,
     /* 2352502 */ // Label 32541: @2352502
     /* 2352502 */ GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2352559), // Rule ID 58512 //
     /* 2352507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2352510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352521 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2352538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352543 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352558 */   // GIR_Coverage, 58512,
     /* 2352558 */   GIR_EraseRootFromParent_Done,
     /* 2352559 */ // Label 32638: @2352559
     /* 2352559 */ GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2352616), // Rule ID 58513 //
     /* 2352564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2352567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352578 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2352595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352600 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352615 */   // GIR_Coverage, 58513,
     /* 2352615 */   GIR_EraseRootFromParent_Done,
     /* 2352616 */ // Label 32639: @2352616
     /* 2352616 */ GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2352670), // Rule ID 58692 //
     /* 2352621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2352624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352635 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2352652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352657 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352669 */   // GIR_Coverage, 58692,
     /* 2352669 */   GIR_EraseRootFromParent_Done,
     /* 2352670 */ // Label 32640: @2352670
     /* 2352670 */ GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2352724), // Rule ID 58693 //
     /* 2352675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2352678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352689 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352692 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352696 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2352706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352711 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352723 */   // GIR_Coverage, 58693,
     /* 2352723 */   GIR_EraseRootFromParent_Done,
     /* 2352724 */ // Label 32641: @2352724
     /* 2352724 */ GIM_Reject,
     /* 2352725 */ // Label 32542: @2352725
     /* 2352725 */ GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2352782), // Rule ID 58500 //
     /* 2352730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2352736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352744 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2352761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352781 */   // GIR_Coverage, 58500,
     /* 2352781 */   GIR_EraseRootFromParent_Done,
     /* 2352782 */ // Label 32642: @2352782
     /* 2352782 */ GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2352839), // Rule ID 58501 //
     /* 2352787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2352793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352801 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2352818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2352828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352838 */   // GIR_Coverage, 58501,
     /* 2352838 */   GIR_EraseRootFromParent_Done,
     /* 2352839 */ // Label 32643: @2352839
     /* 2352839 */ GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2352893), // Rule ID 58672 //
     /* 2352844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2352847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2352850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352858 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2352875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352880 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352892 */   // GIR_Coverage, 58672,
     /* 2352892 */   GIR_EraseRootFromParent_Done,
     /* 2352893 */ // Label 32644: @2352893
     /* 2352893 */ GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2352947), // Rule ID 58673 //
     /* 2352898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2352901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2352904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352912 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2352929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352934 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2352946 */   // GIR_Coverage, 58673,
     /* 2352946 */   GIR_EraseRootFromParent_Done,
     /* 2352947 */ // Label 32645: @2352947
     /* 2352947 */ GIM_Reject,
     /* 2352948 */ // Label 32543: @2352948
     /* 2352948 */ GIM_Reject,
     /* 2352949 */ // Label 71: @2352949
     /* 2352949 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32664*/ GIMT_Encode4(2354919),
     /* 2352960 */ /*GILLT_s16*//*Label 32646*/ GIMT_Encode4(2353080),
     /* 2352964 */ /*GILLT_s32*//*Label 32647*/ GIMT_Encode4(2353144),
     /* 2352968 */ /*GILLT_s64*//*Label 32648*/ GIMT_Encode4(2353208), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2352980 */ /*GILLT_nxv1s16*//*Label 32649*/ GIMT_Encode4(2353299),
     /* 2352984 */ /*GILLT_nxv1s32*//*Label 32650*/ GIMT_Encode4(2353407),
     /* 2352988 */ /*GILLT_nxv1s64*//*Label 32651*/ GIMT_Encode4(2353515), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353000 */ /*GILLT_nxv2s16*//*Label 32652*/ GIMT_Encode4(2353623),
     /* 2353004 */ /*GILLT_nxv2s32*//*Label 32653*/ GIMT_Encode4(2353731),
     /* 2353008 */ /*GILLT_nxv2s64*//*Label 32654*/ GIMT_Encode4(2353839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353020 */ /*GILLT_nxv4s16*//*Label 32655*/ GIMT_Encode4(2353947),
     /* 2353024 */ /*GILLT_nxv4s32*//*Label 32656*/ GIMT_Encode4(2354055),
     /* 2353028 */ /*GILLT_nxv4s64*//*Label 32657*/ GIMT_Encode4(2354163), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353040 */ /*GILLT_nxv8s16*//*Label 32658*/ GIMT_Encode4(2354271),
     /* 2353044 */ /*GILLT_nxv8s32*//*Label 32659*/ GIMT_Encode4(2354379),
     /* 2353048 */ /*GILLT_nxv8s64*//*Label 32660*/ GIMT_Encode4(2354487), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353060 */ /*GILLT_nxv16s16*//*Label 32661*/ GIMT_Encode4(2354595),
     /* 2353064 */ /*GILLT_nxv16s32*//*Label 32662*/ GIMT_Encode4(2354703), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2353076 */ /*GILLT_nxv32s16*//*Label 32663*/ GIMT_Encode4(2354811),
     /* 2353080 */ // Label 32646: @2353080
     /* 2353080 */ GIM_Try, /*On fail goto*//*Label 32665*/ GIMT_Encode4(2353143),
     /* 2353085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2353088 */   GIM_Try, /*On fail goto*//*Label 32666*/ GIMT_Encode4(2353115), // Rule ID 1993 //
     /* 2353093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2353096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2353104 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2353104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2353107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353114 */     // GIR_Coverage, 1993,
     /* 2353114 */     GIR_EraseRootFromParent_Done,
     /* 2353115 */   // Label 32666: @2353115
     /* 2353115 */   GIM_Try, /*On fail goto*//*Label 32667*/ GIMT_Encode4(2353142), // Rule ID 2026 //
     /* 2353120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2353123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2353131 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2353131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2353134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353141 */     // GIR_Coverage, 2026,
     /* 2353141 */     GIR_EraseRootFromParent_Done,
     /* 2353142 */   // Label 32667: @2353142
     /* 2353142 */   GIM_Reject,
     /* 2353143 */ // Label 32665: @2353143
     /* 2353143 */ GIM_Reject,
     /* 2353144 */ // Label 32647: @2353144
     /* 2353144 */ GIM_Try, /*On fail goto*//*Label 32668*/ GIMT_Encode4(2353207),
     /* 2353149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2353152 */   GIM_Try, /*On fail goto*//*Label 32669*/ GIMT_Encode4(2353179), // Rule ID 1284 //
     /* 2353157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2353160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2353164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2353168 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2353168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2353171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353178 */     // GIR_Coverage, 1284,
     /* 2353178 */     GIR_EraseRootFromParent_Done,
     /* 2353179 */   // Label 32669: @2353179
     /* 2353179 */   GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2353206), // Rule ID 1292 //
     /* 2353184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2353187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2353195 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2353195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2353198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353205 */     // GIR_Coverage, 1292,
     /* 2353205 */     GIR_EraseRootFromParent_Done,
     /* 2353206 */   // Label 32670: @2353206
     /* 2353206 */   GIM_Reject,
     /* 2353207 */ // Label 32668: @2353207
     /* 2353207 */ GIM_Reject,
     /* 2353208 */ // Label 32648: @2353208
     /* 2353208 */ GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2353298),
     /* 2353213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2353216 */   GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2353243), // Rule ID 1627 //
     /* 2353221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2353224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2353232 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2353235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353242 */     // GIR_Coverage, 1627,
     /* 2353242 */     GIR_EraseRootFromParent_Done,
     /* 2353243 */   // Label 32672: @2353243
     /* 2353243 */   GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2353270), // Rule ID 1660 //
     /* 2353248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2353251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2353259 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2353262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353269 */     // GIR_Coverage, 1660,
     /* 2353269 */     GIR_EraseRootFromParent_Done,
     /* 2353270 */   // Label 32673: @2353270
     /* 2353270 */   GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2353297), // Rule ID 1682 //
     /* 2353275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2353278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2353286 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2353286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2353289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353296 */     // GIR_Coverage, 1682,
     /* 2353296 */     GIR_EraseRootFromParent_Done,
     /* 2353297 */   // Label 32674: @2353297
     /* 2353297 */   GIM_Reject,
     /* 2353298 */ // Label 32671: @2353298
     /* 2353298 */ GIM_Reject,
     /* 2353299 */ // Label 32649: @2353299
     /* 2353299 */ GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2353406),
     /* 2353304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353315 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2353360), // Rule ID 56244 //
     /* 2353320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353323 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2353340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353359 */     // GIR_Coverage, 56244,
     /* 2353359 */     GIR_EraseRootFromParent_Done,
     /* 2353360 */   // Label 32676: @2353360
     /* 2353360 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2353405), // Rule ID 56245 //
     /* 2353365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353368 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2353385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353404 */     // GIR_Coverage, 56245,
     /* 2353404 */     GIR_EraseRootFromParent_Done,
     /* 2353405 */   // Label 32677: @2353405
     /* 2353405 */   GIM_Reject,
     /* 2353406 */ // Label 32675: @2353406
     /* 2353406 */ GIM_Reject,
     /* 2353407 */ // Label 32650: @2353407
     /* 2353407 */ GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2353514),
     /* 2353412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353423 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2353468), // Rule ID 56284 //
     /* 2353428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353431 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2353448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353467 */     // GIR_Coverage, 56284,
     /* 2353467 */     GIR_EraseRootFromParent_Done,
     /* 2353468 */   // Label 32679: @2353468
     /* 2353468 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2353513), // Rule ID 56285 //
     /* 2353473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353476 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2353493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353512 */     // GIR_Coverage, 56285,
     /* 2353512 */     GIR_EraseRootFromParent_Done,
     /* 2353513 */   // Label 32680: @2353513
     /* 2353513 */   GIM_Reject,
     /* 2353514 */ // Label 32678: @2353514
     /* 2353514 */ GIM_Reject,
     /* 2353515 */ // Label 32651: @2353515
     /* 2353515 */ GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2353622),
     /* 2353520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2353523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353531 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2353576), // Rule ID 56344 //
     /* 2353536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353539 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2353556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353575 */     // GIR_Coverage, 56344,
     /* 2353575 */     GIR_EraseRootFromParent_Done,
     /* 2353576 */   // Label 32682: @2353576
     /* 2353576 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2353621), // Rule ID 56345 //
     /* 2353581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353584 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2353601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353620 */     // GIR_Coverage, 56345,
     /* 2353620 */     GIR_EraseRootFromParent_Done,
     /* 2353621 */   // Label 32683: @2353621
     /* 2353621 */   GIM_Reject,
     /* 2353622 */ // Label 32681: @2353622
     /* 2353622 */ GIM_Reject,
     /* 2353623 */ // Label 32652: @2353623
     /* 2353623 */ GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2353730),
     /* 2353628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2353631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353639 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2353684), // Rule ID 56264 //
     /* 2353644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353647 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2353664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353683 */     // GIR_Coverage, 56264,
     /* 2353683 */     GIR_EraseRootFromParent_Done,
     /* 2353684 */   // Label 32685: @2353684
     /* 2353684 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2353729), // Rule ID 56265 //
     /* 2353689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353692 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2353709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353728 */     // GIR_Coverage, 56265,
     /* 2353728 */     GIR_EraseRootFromParent_Done,
     /* 2353729 */   // Label 32686: @2353729
     /* 2353729 */   GIM_Reject,
     /* 2353730 */ // Label 32684: @2353730
     /* 2353730 */ GIM_Reject,
     /* 2353731 */ // Label 32653: @2353731
     /* 2353731 */ GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2353838),
     /* 2353736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2353739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353747 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2353792), // Rule ID 56324 //
     /* 2353752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353755 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2353772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353791 */     // GIR_Coverage, 56324,
     /* 2353791 */     GIR_EraseRootFromParent_Done,
     /* 2353792 */   // Label 32688: @2353792
     /* 2353792 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2353837), // Rule ID 56325 //
     /* 2353797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353800 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2353817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353836 */     // GIR_Coverage, 56325,
     /* 2353836 */     GIR_EraseRootFromParent_Done,
     /* 2353837 */   // Label 32689: @2353837
     /* 2353837 */   GIM_Reject,
     /* 2353838 */ // Label 32687: @2353838
     /* 2353838 */ GIM_Reject,
     /* 2353839 */ // Label 32654: @2353839
     /* 2353839 */ GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2353946),
     /* 2353844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2353847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353855 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2353900), // Rule ID 56484 //
     /* 2353860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353863 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2353880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353899 */     // GIR_Coverage, 56484,
     /* 2353899 */     GIR_EraseRootFromParent_Done,
     /* 2353900 */   // Label 32691: @2353900
     /* 2353900 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2353945), // Rule ID 56485 //
     /* 2353905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353908 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2353925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353944 */     // GIR_Coverage, 56485,
     /* 2353944 */     GIR_EraseRootFromParent_Done,
     /* 2353945 */   // Label 32692: @2353945
     /* 2353945 */   GIM_Reject,
     /* 2353946 */ // Label 32690: @2353946
     /* 2353946 */ GIM_Reject,
     /* 2353947 */ // Label 32655: @2353947
     /* 2353947 */ GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2354054),
     /* 2353952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353963 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2354008), // Rule ID 56304 //
     /* 2353968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353971 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2353988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2353997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354007 */     // GIR_Coverage, 56304,
     /* 2354007 */     GIR_EraseRootFromParent_Done,
     /* 2354008 */   // Label 32694: @2354008
     /* 2354008 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2354053), // Rule ID 56305 //
     /* 2354013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354016 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2354019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2354033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354052 */     // GIR_Coverage, 56305,
     /* 2354052 */     GIR_EraseRootFromParent_Done,
     /* 2354053 */   // Label 32695: @2354053
     /* 2354053 */   GIM_Reject,
     /* 2354054 */ // Label 32693: @2354054
     /* 2354054 */ GIM_Reject,
     /* 2354055 */ // Label 32656: @2354055
     /* 2354055 */ GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2354162),
     /* 2354060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2354063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354071 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2354116), // Rule ID 56424 //
     /* 2354076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354079 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2354096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354115 */     // GIR_Coverage, 56424,
     /* 2354115 */     GIR_EraseRootFromParent_Done,
     /* 2354116 */   // Label 32697: @2354116
     /* 2354116 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2354161), // Rule ID 56425 //
     /* 2354121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354124 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2354141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354160 */     // GIR_Coverage, 56425,
     /* 2354160 */     GIR_EraseRootFromParent_Done,
     /* 2354161 */   // Label 32698: @2354161
     /* 2354161 */   GIM_Reject,
     /* 2354162 */ // Label 32696: @2354162
     /* 2354162 */ GIM_Reject,
     /* 2354163 */ // Label 32657: @2354163
     /* 2354163 */ GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2354270),
     /* 2354168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2354171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354179 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2354224), // Rule ID 56504 //
     /* 2354184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354187 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2354204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354223 */     // GIR_Coverage, 56504,
     /* 2354223 */     GIR_EraseRootFromParent_Done,
     /* 2354224 */   // Label 32700: @2354224
     /* 2354224 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2354269), // Rule ID 56505 //
     /* 2354229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354232 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2354249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354268 */     // GIR_Coverage, 56505,
     /* 2354268 */     GIR_EraseRootFromParent_Done,
     /* 2354269 */   // Label 32701: @2354269
     /* 2354269 */   GIM_Reject,
     /* 2354270 */ // Label 32699: @2354270
     /* 2354270 */ GIM_Reject,
     /* 2354271 */ // Label 32658: @2354271
     /* 2354271 */ GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2354378),
     /* 2354276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2354279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354287 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2354332), // Rule ID 56364 //
     /* 2354292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354295 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2354312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354331 */     // GIR_Coverage, 56364,
     /* 2354331 */     GIR_EraseRootFromParent_Done,
     /* 2354332 */   // Label 32703: @2354332
     /* 2354332 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2354377), // Rule ID 56365 //
     /* 2354337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354340 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2354357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354376 */     // GIR_Coverage, 56365,
     /* 2354376 */     GIR_EraseRootFromParent_Done,
     /* 2354377 */   // Label 32704: @2354377
     /* 2354377 */   GIM_Reject,
     /* 2354378 */ // Label 32702: @2354378
     /* 2354378 */ GIM_Reject,
     /* 2354379 */ // Label 32659: @2354379
     /* 2354379 */ GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2354486),
     /* 2354384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354395 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2354440), // Rule ID 56444 //
     /* 2354400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354403 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2354420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354439 */     // GIR_Coverage, 56444,
     /* 2354439 */     GIR_EraseRootFromParent_Done,
     /* 2354440 */   // Label 32706: @2354440
     /* 2354440 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2354485), // Rule ID 56445 //
     /* 2354445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354448 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2354465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354484 */     // GIR_Coverage, 56445,
     /* 2354484 */     GIR_EraseRootFromParent_Done,
     /* 2354485 */   // Label 32707: @2354485
     /* 2354485 */   GIM_Reject,
     /* 2354486 */ // Label 32705: @2354486
     /* 2354486 */ GIM_Reject,
     /* 2354487 */ // Label 32660: @2354487
     /* 2354487 */ GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2354594),
     /* 2354492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354503 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2354548), // Rule ID 56524 //
     /* 2354508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2354511 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2354528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354547 */     // GIR_Coverage, 56524,
     /* 2354547 */     GIR_EraseRootFromParent_Done,
     /* 2354548 */   // Label 32709: @2354548
     /* 2354548 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2354593), // Rule ID 56525 //
     /* 2354553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354556 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2354573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354592 */     // GIR_Coverage, 56525,
     /* 2354592 */     GIR_EraseRootFromParent_Done,
     /* 2354593 */   // Label 32710: @2354593
     /* 2354593 */   GIM_Reject,
     /* 2354594 */ // Label 32708: @2354594
     /* 2354594 */ GIM_Reject,
     /* 2354595 */ // Label 32661: @2354595
     /* 2354595 */ GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2354702),
     /* 2354600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354611 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2354656), // Rule ID 56384 //
     /* 2354616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354619 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2354636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354655 */     // GIR_Coverage, 56384,
     /* 2354655 */     GIR_EraseRootFromParent_Done,
     /* 2354656 */   // Label 32712: @2354656
     /* 2354656 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2354701), // Rule ID 56385 //
     /* 2354661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354664 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2354681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354700 */     // GIR_Coverage, 56385,
     /* 2354700 */     GIR_EraseRootFromParent_Done,
     /* 2354701 */   // Label 32713: @2354701
     /* 2354701 */   GIM_Reject,
     /* 2354702 */ // Label 32711: @2354702
     /* 2354702 */ GIM_Reject,
     /* 2354703 */ // Label 32662: @2354703
     /* 2354703 */ GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2354810),
     /* 2354708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354719 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2354764), // Rule ID 56464 //
     /* 2354724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354727 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2354744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354763 */     // GIR_Coverage, 56464,
     /* 2354763 */     GIR_EraseRootFromParent_Done,
     /* 2354764 */   // Label 32715: @2354764
     /* 2354764 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2354809), // Rule ID 56465 //
     /* 2354769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354772 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2354789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354808 */     // GIR_Coverage, 56465,
     /* 2354808 */     GIR_EraseRootFromParent_Done,
     /* 2354809 */   // Label 32716: @2354809
     /* 2354809 */   GIM_Reject,
     /* 2354810 */ // Label 32714: @2354810
     /* 2354810 */ GIM_Reject,
     /* 2354811 */ // Label 32663: @2354811
     /* 2354811 */ GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2354918),
     /* 2354816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2354819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354827 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2354872), // Rule ID 56404 //
     /* 2354832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354835 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2354852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354871 */     // GIR_Coverage, 56404,
     /* 2354871 */     GIR_EraseRootFromParent_Done,
     /* 2354872 */   // Label 32718: @2354872
     /* 2354872 */   GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2354917), // Rule ID 56405 //
     /* 2354877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354880 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2354897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2354906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354916 */     // GIR_Coverage, 56405,
     /* 2354916 */     GIR_EraseRootFromParent_Done,
     /* 2354917 */   // Label 32719: @2354917
     /* 2354917 */   GIM_Reject,
     /* 2354918 */ // Label 32717: @2354918
     /* 2354918 */ GIM_Reject,
     /* 2354919 */ // Label 32664: @2354919
     /* 2354919 */ GIM_Reject,
     /* 2354920 */ // Label 72: @2354920
     /* 2354920 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32738*/ GIMT_Encode4(2360981),
     /* 2354931 */ /*GILLT_s16*//*Label 32720*/ GIMT_Encode4(2355051),
     /* 2354935 */ /*GILLT_s32*//*Label 32721*/ GIMT_Encode4(2355727),
     /* 2354939 */ /*GILLT_s64*//*Label 32722*/ GIMT_Encode4(2356403), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354951 */ /*GILLT_nxv1s16*//*Label 32723*/ GIMT_Encode4(2357216),
     /* 2354955 */ /*GILLT_nxv1s32*//*Label 32724*/ GIMT_Encode4(2357467),
     /* 2354959 */ /*GILLT_nxv1s64*//*Label 32725*/ GIMT_Encode4(2357718), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354971 */ /*GILLT_nxv2s16*//*Label 32726*/ GIMT_Encode4(2357969),
     /* 2354975 */ /*GILLT_nxv2s32*//*Label 32727*/ GIMT_Encode4(2358220),
     /* 2354979 */ /*GILLT_nxv2s64*//*Label 32728*/ GIMT_Encode4(2358471), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2354991 */ /*GILLT_nxv4s16*//*Label 32729*/ GIMT_Encode4(2358722),
     /* 2354995 */ /*GILLT_nxv4s32*//*Label 32730*/ GIMT_Encode4(2358973),
     /* 2354999 */ /*GILLT_nxv4s64*//*Label 32731*/ GIMT_Encode4(2359224), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355011 */ /*GILLT_nxv8s16*//*Label 32732*/ GIMT_Encode4(2359475),
     /* 2355015 */ /*GILLT_nxv8s32*//*Label 32733*/ GIMT_Encode4(2359726),
     /* 2355019 */ /*GILLT_nxv8s64*//*Label 32734*/ GIMT_Encode4(2359977), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355031 */ /*GILLT_nxv16s16*//*Label 32735*/ GIMT_Encode4(2360228),
     /* 2355035 */ /*GILLT_nxv16s32*//*Label 32736*/ GIMT_Encode4(2360479), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355047 */ /*GILLT_nxv32s16*//*Label 32737*/ GIMT_Encode4(2360730),
     /* 2355051 */ // Label 32720: @2355051
     /* 2355051 */ GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2355726),
     /* 2355056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355059 */   GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2355110), // Rule ID 1998 //
     /* 2355064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355097 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2355097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2355100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355109 */     // GIR_Coverage, 1998,
     /* 2355109 */     GIR_EraseRootFromParent_Done,
     /* 2355110 */   // Label 32740: @2355110
     /* 2355110 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2355161), // Rule ID 2031 //
     /* 2355115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355148 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2355148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2355151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355160 */     // GIR_Coverage, 2031,
     /* 2355160 */     GIR_EraseRootFromParent_Done,
     /* 2355161 */   // Label 32741: @2355161
     /* 2355161 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2355191), // Rule ID 1996 //
     /* 2355166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355184 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355190 */     // GIR_Coverage, 1996,
     /* 2355190 */     GIR_Done,
     /* 2355191 */   // Label 32742: @2355191
     /* 2355191 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2355247), // Rule ID 1999 //
     /* 2355196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2355199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355214 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2355214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2355221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355246 */     // GIR_Coverage, 1999,
     /* 2355246 */     GIR_EraseRootFromParent_Done,
     /* 2355247 */   // Label 32743: @2355247
     /* 2355247 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2355303), // Rule ID 2000 //
     /* 2355252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2355255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355270 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2355270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2355277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355302 */     // GIR_Coverage, 2000,
     /* 2355302 */     GIR_EraseRootFromParent_Done,
     /* 2355303 */   // Label 32744: @2355303
     /* 2355303 */   GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2355333), // Rule ID 2029 //
     /* 2355308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355326 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355332 */     // GIR_Coverage, 2029,
     /* 2355332 */     GIR_Done,
     /* 2355333 */   // Label 32745: @2355333
     /* 2355333 */   GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2355389), // Rule ID 2032 //
     /* 2355338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2355341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355356 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2355356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2355363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355388 */     // GIR_Coverage, 2032,
     /* 2355388 */     GIR_EraseRootFromParent_Done,
     /* 2355389 */   // Label 32746: @2355389
     /* 2355389 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2355445), // Rule ID 2033 //
     /* 2355394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2355397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355412 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2355412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2355419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355444 */     // GIR_Coverage, 2033,
     /* 2355444 */     GIR_EraseRootFromParent_Done,
     /* 2355445 */   // Label 32747: @2355445
     /* 2355445 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2355501), // Rule ID 2302 //
     /* 2355450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2355453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355468 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2355475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355500 */     // GIR_Coverage, 2302,
     /* 2355500 */     GIR_EraseRootFromParent_Done,
     /* 2355501 */   // Label 32748: @2355501
     /* 2355501 */   GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2355557), // Rule ID 2303 //
     /* 2355506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2355509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355524 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2355531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2355548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355556 */     // GIR_Coverage, 2303,
     /* 2355556 */     GIR_EraseRootFromParent_Done,
     /* 2355557 */   // Label 32749: @2355557
     /* 2355557 */   GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2355613), // Rule ID 2314 //
     /* 2355562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2355565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355580 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2355587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355612 */     // GIR_Coverage, 2314,
     /* 2355612 */     GIR_EraseRootFromParent_Done,
     /* 2355613 */   // Label 32750: @2355613
     /* 2355613 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2355669), // Rule ID 2315 //
     /* 2355618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2355621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355636 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2355643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355668 */     // GIR_Coverage, 2315,
     /* 2355668 */     GIR_EraseRootFromParent_Done,
     /* 2355669 */   // Label 32751: @2355669
     /* 2355669 */   GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2355725), // Rule ID 2322 //
     /* 2355674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2355677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355692 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2355695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2355699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2355716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355724 */     // GIR_Coverage, 2322,
     /* 2355724 */     GIR_EraseRootFromParent_Done,
     /* 2355725 */   // Label 32752: @2355725
     /* 2355725 */   GIM_Reject,
     /* 2355726 */ // Label 32739: @2355726
     /* 2355726 */ GIM_Reject,
     /* 2355727 */ // Label 32721: @2355727
     /* 2355727 */ GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2356402),
     /* 2355732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355735 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2355786), // Rule ID 1299 //
     /* 2355740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355773 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2355773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2355776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355785 */     // GIR_Coverage, 1299,
     /* 2355785 */     GIR_EraseRootFromParent_Done,
     /* 2355786 */   // Label 32754: @2355786
     /* 2355786 */   GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2355837), // Rule ID 1320 //
     /* 2355791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2355809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2355813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2355824 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2355824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2355827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2355835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355836 */     // GIR_Coverage, 1320,
     /* 2355836 */     GIR_EraseRootFromParent_Done,
     /* 2355837 */   // Label 32755: @2355837
     /* 2355837 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2355867), // Rule ID 1295 //
     /* 2355842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355860 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2355865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355866 */     // GIR_Coverage, 1295,
     /* 2355866 */     GIR_Done,
     /* 2355867 */   // Label 32756: @2355867
     /* 2355867 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2355897), // Rule ID 1296 //
     /* 2355872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355890 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2355895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355896 */     // GIR_Coverage, 1296,
     /* 2355896 */     GIR_Done,
     /* 2355897 */   // Label 32757: @2355897
     /* 2355897 */   GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2355953), // Rule ID 1635 //
     /* 2355902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2355905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355920 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2355920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2355923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2355927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2355944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355952 */     // GIR_Coverage, 1635,
     /* 2355952 */     GIR_EraseRootFromParent_Done,
     /* 2355953 */   // Label 32758: @2355953
     /* 2355953 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2356009), // Rule ID 1636 //
     /* 2355958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2355961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355976 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2355976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2355979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2355983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2355992 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2355995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356008 */     // GIR_Coverage, 1636,
     /* 2356008 */     GIR_EraseRootFromParent_Done,
     /* 2356009 */   // Label 32759: @2356009
     /* 2356009 */   GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2356065), // Rule ID 1666 //
     /* 2356014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356032 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2356032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2356039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356064 */     // GIR_Coverage, 1666,
     /* 2356064 */     GIR_EraseRootFromParent_Done,
     /* 2356065 */   // Label 32760: @2356065
     /* 2356065 */   GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2356121), // Rule ID 1690 //
     /* 2356070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2356073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356088 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2356088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2356095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356120 */     // GIR_Coverage, 1690,
     /* 2356120 */     GIR_EraseRootFromParent_Done,
     /* 2356121 */   // Label 32761: @2356121
     /* 2356121 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2356177), // Rule ID 1691 //
     /* 2356126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2356129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356144 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2356144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2356151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2356163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356176 */     // GIR_Coverage, 1691,
     /* 2356176 */     GIR_EraseRootFromParent_Done,
     /* 2356177 */   // Label 32762: @2356177
     /* 2356177 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2356233), // Rule ID 2174 //
     /* 2356182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2356185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356200 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2356207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356232 */     // GIR_Coverage, 2174,
     /* 2356232 */     GIR_EraseRootFromParent_Done,
     /* 2356233 */   // Label 32763: @2356233
     /* 2356233 */   GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2356289), // Rule ID 2175 //
     /* 2356238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2356241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356256 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2356256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2356263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2356280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356288 */     // GIR_Coverage, 2175,
     /* 2356288 */     GIR_EraseRootFromParent_Done,
     /* 2356289 */   // Label 32764: @2356289
     /* 2356289 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2356345), // Rule ID 2188 //
     /* 2356294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2356297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2356312 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2356319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356344 */     // GIR_Coverage, 2188,
     /* 2356344 */     GIR_EraseRootFromParent_Done,
     /* 2356345 */   // Label 32765: @2356345
     /* 2356345 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2356401), // Rule ID 2189 //
     /* 2356350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2356353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2356368 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2356368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2356371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2356375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2356392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356400 */     // GIR_Coverage, 2189,
     /* 2356400 */     GIR_EraseRootFromParent_Done,
     /* 2356401 */   // Label 32766: @2356401
     /* 2356401 */   GIM_Reject,
     /* 2356402 */ // Label 32753: @2356402
     /* 2356402 */ GIM_Reject,
     /* 2356403 */ // Label 32722: @2356403
     /* 2356403 */ GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2357215),
     /* 2356408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356411 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2356462), // Rule ID 1632 //
     /* 2356416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2356419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356449 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2356449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2356452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356461 */     // GIR_Coverage, 1632,
     /* 2356461 */     GIR_EraseRootFromParent_Done,
     /* 2356462 */   // Label 32768: @2356462
     /* 2356462 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2356513), // Rule ID 1664 //
     /* 2356467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356500 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2356500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2356503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356512 */     // GIR_Coverage, 1664,
     /* 2356512 */     GIR_EraseRootFromParent_Done,
     /* 2356513 */   // Label 32769: @2356513
     /* 2356513 */   GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2356564), // Rule ID 1687 //
     /* 2356518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2356521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2356536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2356540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2356551 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2356551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2356554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2356562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356563 */     // GIR_Coverage, 1687,
     /* 2356563 */     GIR_EraseRootFromParent_Done,
     /* 2356564 */   // Label 32770: @2356564
     /* 2356564 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2356594), // Rule ID 1630 //
     /* 2356569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2356572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356587 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356593 */     // GIR_Coverage, 1630,
     /* 2356593 */     GIR_Done,
     /* 2356594 */   // Label 32771: @2356594
     /* 2356594 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2356650), // Rule ID 1633 //
     /* 2356599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2356602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356617 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2356624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356649 */     // GIR_Coverage, 1633,
     /* 2356649 */     GIR_EraseRootFromParent_Done,
     /* 2356650 */   // Label 32772: @2356650
     /* 2356650 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2356706), // Rule ID 1634 //
     /* 2356655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2356658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2356673 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2356673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2356680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356689 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356705 */     // GIR_Coverage, 1634,
     /* 2356705 */     GIR_EraseRootFromParent_Done,
     /* 2356706 */   // Label 32773: @2356706
     /* 2356706 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2356736), // Rule ID 1662 //
     /* 2356711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356729 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2356734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356735 */     // GIR_Coverage, 1662,
     /* 2356735 */     GIR_Done,
     /* 2356736 */   // Label 32774: @2356736
     /* 2356736 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2356792), // Rule ID 1665 //
     /* 2356741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2356744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356759 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2356766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2356783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356791 */     // GIR_Coverage, 1665,
     /* 2356791 */     GIR_EraseRootFromParent_Done,
     /* 2356792 */   // Label 32775: @2356792
     /* 2356792 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2356822), // Rule ID 1685 //
     /* 2356797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2356800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356815 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2356815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356821 */     // GIR_Coverage, 1685,
     /* 2356821 */     GIR_Done,
     /* 2356822 */   // Label 32776: @2356822
     /* 2356822 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2356878), // Rule ID 1688 //
     /* 2356827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2356830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356845 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2356845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2356852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356877 */     // GIR_Coverage, 1688,
     /* 2356877 */     GIR_EraseRootFromParent_Done,
     /* 2356878 */   // Label 32777: @2356878
     /* 2356878 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2356934), // Rule ID 1689 //
     /* 2356883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2356886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2356897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2356901 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2356901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2356908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2356925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356933 */     // GIR_Coverage, 1689,
     /* 2356933 */     GIR_EraseRootFromParent_Done,
     /* 2356934 */   // Label 32778: @2356934
     /* 2356934 */   GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2356990), // Rule ID 2304 //
     /* 2356939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2356942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2356945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2356953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2356957 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2356957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2356960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2356964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2356973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2356976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2356981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356989 */     // GIR_Coverage, 2304,
     /* 2356989 */     GIR_EraseRootFromParent_Done,
     /* 2356990 */   // Label 32779: @2356990
     /* 2356990 */   GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2357046), // Rule ID 2305 //
     /* 2356995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2356998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357013 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2357013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2357020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2357037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357045 */     // GIR_Coverage, 2305,
     /* 2357045 */     GIR_EraseRootFromParent_Done,
     /* 2357046 */   // Label 32780: @2357046
     /* 2357046 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2357102), // Rule ID 2316 //
     /* 2357051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2357054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357069 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2357069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2357076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357085 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2357093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357101 */     // GIR_Coverage, 2316,
     /* 2357101 */     GIR_EraseRootFromParent_Done,
     /* 2357102 */   // Label 32781: @2357102
     /* 2357102 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2357158), // Rule ID 2317 //
     /* 2357107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2357110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357125 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2357125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2357132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2357149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357157 */     // GIR_Coverage, 2317,
     /* 2357157 */     GIR_EraseRootFromParent_Done,
     /* 2357158 */   // Label 32782: @2357158
     /* 2357158 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2357214), // Rule ID 2323 //
     /* 2357163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2357166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357181 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2357181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2357184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2357188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2357197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2357200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2357205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357213 */     // GIR_Coverage, 2323,
     /* 2357213 */     GIR_EraseRootFromParent_Done,
     /* 2357214 */   // Label 32783: @2357214
     /* 2357214 */   GIM_Reject,
     /* 2357215 */ // Label 32767: @2357215
     /* 2357215 */ GIM_Reject,
     /* 2357216 */ // Label 32723: @2357216
     /* 2357216 */ GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2357466),
     /* 2357221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357235 */   GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2357301), // Rule ID 56254 //
     /* 2357240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357262 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2357279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357300 */     // GIR_Coverage, 56254,
     /* 2357300 */     GIR_EraseRootFromParent_Done,
     /* 2357301 */   // Label 32785: @2357301
     /* 2357301 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2357367), // Rule ID 56255 //
     /* 2357306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357328 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2357345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357366 */     // GIR_Coverage, 56255,
     /* 2357366 */     GIR_EraseRootFromParent_Done,
     /* 2357367 */   // Label 32786: @2357367
     /* 2357367 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2357416), // Rule ID 56248 //
     /* 2357372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357379 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2357396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357415 */     // GIR_Coverage, 56248,
     /* 2357415 */     GIR_EraseRootFromParent_Done,
     /* 2357416 */   // Label 32787: @2357416
     /* 2357416 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2357465), // Rule ID 56249 //
     /* 2357421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357428 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2357445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357464 */     // GIR_Coverage, 56249,
     /* 2357464 */     GIR_EraseRootFromParent_Done,
     /* 2357465 */   // Label 32788: @2357465
     /* 2357465 */   GIM_Reject,
     /* 2357466 */ // Label 32784: @2357466
     /* 2357466 */ GIM_Reject,
     /* 2357467 */ // Label 32724: @2357467
     /* 2357467 */ GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2357717),
     /* 2357472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2357478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357486 */   GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2357552), // Rule ID 56294 //
     /* 2357491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357513 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2357530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357551 */     // GIR_Coverage, 56294,
     /* 2357551 */     GIR_EraseRootFromParent_Done,
     /* 2357552 */   // Label 32790: @2357552
     /* 2357552 */   GIM_Try, /*On fail goto*//*Label 32791*/ GIMT_Encode4(2357618), // Rule ID 56295 //
     /* 2357557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357579 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2357596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357617 */     // GIR_Coverage, 56295,
     /* 2357617 */     GIR_EraseRootFromParent_Done,
     /* 2357618 */   // Label 32791: @2357618
     /* 2357618 */   GIM_Try, /*On fail goto*//*Label 32792*/ GIMT_Encode4(2357667), // Rule ID 56288 //
     /* 2357623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357630 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2357647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357666 */     // GIR_Coverage, 56288,
     /* 2357666 */     GIR_EraseRootFromParent_Done,
     /* 2357667 */   // Label 32792: @2357667
     /* 2357667 */   GIM_Try, /*On fail goto*//*Label 32793*/ GIMT_Encode4(2357716), // Rule ID 56289 //
     /* 2357672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357679 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2357696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357715 */     // GIR_Coverage, 56289,
     /* 2357715 */     GIR_EraseRootFromParent_Done,
     /* 2357716 */   // Label 32793: @2357716
     /* 2357716 */   GIM_Reject,
     /* 2357717 */ // Label 32789: @2357717
     /* 2357717 */ GIM_Reject,
     /* 2357718 */ // Label 32725: @2357718
     /* 2357718 */ GIM_Try, /*On fail goto*//*Label 32794*/ GIMT_Encode4(2357968),
     /* 2357723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2357729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357737 */   GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2357803), // Rule ID 56354 //
     /* 2357742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357764 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2357781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357802 */     // GIR_Coverage, 56354,
     /* 2357802 */     GIR_EraseRootFromParent_Done,
     /* 2357803 */   // Label 32795: @2357803
     /* 2357803 */   GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2357869), // Rule ID 56355 //
     /* 2357808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2357815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2357819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2357830 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2357847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2357858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357868 */     // GIR_Coverage, 56355,
     /* 2357868 */     GIR_EraseRootFromParent_Done,
     /* 2357869 */   // Label 32796: @2357869
     /* 2357869 */   GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2357918), // Rule ID 56348 //
     /* 2357874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357881 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2357898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357917 */     // GIR_Coverage, 56348,
     /* 2357917 */     GIR_EraseRootFromParent_Done,
     /* 2357918 */   // Label 32797: @2357918
     /* 2357918 */   GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2357967), // Rule ID 56349 //
     /* 2357923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357930 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2357947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357966 */     // GIR_Coverage, 56349,
     /* 2357966 */     GIR_EraseRootFromParent_Done,
     /* 2357967 */   // Label 32798: @2357967
     /* 2357967 */   GIM_Reject,
     /* 2357968 */ // Label 32794: @2357968
     /* 2357968 */ GIM_Reject,
     /* 2357969 */ // Label 32726: @2357969
     /* 2357969 */ GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2358219),
     /* 2357974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2357977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2357980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357988 */   GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2358054), // Rule ID 56274 //
     /* 2357993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358015 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2358032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358053 */     // GIR_Coverage, 56274,
     /* 2358053 */     GIR_EraseRootFromParent_Done,
     /* 2358054 */   // Label 32800: @2358054
     /* 2358054 */   GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2358120), // Rule ID 56275 //
     /* 2358059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2358074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358081 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2358098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358119 */     // GIR_Coverage, 56275,
     /* 2358119 */     GIR_EraseRootFromParent_Done,
     /* 2358120 */   // Label 32801: @2358120
     /* 2358120 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2358169), // Rule ID 56268 //
     /* 2358125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358132 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2358149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358168 */     // GIR_Coverage, 56268,
     /* 2358168 */     GIR_EraseRootFromParent_Done,
     /* 2358169 */   // Label 32802: @2358169
     /* 2358169 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2358218), // Rule ID 56269 //
     /* 2358174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358181 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2358184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2358198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358217 */     // GIR_Coverage, 56269,
     /* 2358217 */     GIR_EraseRootFromParent_Done,
     /* 2358218 */   // Label 32803: @2358218
     /* 2358218 */   GIM_Reject,
     /* 2358219 */ // Label 32799: @2358219
     /* 2358219 */ GIM_Reject,
     /* 2358220 */ // Label 32727: @2358220
     /* 2358220 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2358470),
     /* 2358225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2358231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358239 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2358305), // Rule ID 56334 //
     /* 2358244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358266 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2358283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358304 */     // GIR_Coverage, 56334,
     /* 2358304 */     GIR_EraseRootFromParent_Done,
     /* 2358305 */   // Label 32805: @2358305
     /* 2358305 */   GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2358371), // Rule ID 56335 //
     /* 2358310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2358325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358332 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2358349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358370 */     // GIR_Coverage, 56335,
     /* 2358370 */     GIR_EraseRootFromParent_Done,
     /* 2358371 */   // Label 32806: @2358371
     /* 2358371 */   GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2358420), // Rule ID 56328 //
     /* 2358376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358383 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2358400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358419 */     // GIR_Coverage, 56328,
     /* 2358419 */     GIR_EraseRootFromParent_Done,
     /* 2358420 */   // Label 32807: @2358420
     /* 2358420 */   GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2358469), // Rule ID 56329 //
     /* 2358425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358432 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2358449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358468 */     // GIR_Coverage, 56329,
     /* 2358468 */     GIR_EraseRootFromParent_Done,
     /* 2358469 */   // Label 32808: @2358469
     /* 2358469 */   GIM_Reject,
     /* 2358470 */ // Label 32804: @2358470
     /* 2358470 */ GIM_Reject,
     /* 2358471 */ // Label 32728: @2358471
     /* 2358471 */ GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2358721),
     /* 2358476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2358482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358490 */   GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2358556), // Rule ID 56494 //
     /* 2358495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358517 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2358534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358555 */     // GIR_Coverage, 56494,
     /* 2358555 */     GIR_EraseRootFromParent_Done,
     /* 2358556 */   // Label 32810: @2358556
     /* 2358556 */   GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2358622), // Rule ID 56495 //
     /* 2358561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358583 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2358600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358621 */     // GIR_Coverage, 56495,
     /* 2358621 */     GIR_EraseRootFromParent_Done,
     /* 2358622 */   // Label 32811: @2358622
     /* 2358622 */   GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2358671), // Rule ID 56488 //
     /* 2358627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358634 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2358651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358670 */     // GIR_Coverage, 56488,
     /* 2358670 */     GIR_EraseRootFromParent_Done,
     /* 2358671 */   // Label 32812: @2358671
     /* 2358671 */   GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2358720), // Rule ID 56489 //
     /* 2358676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358683 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2358700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358719 */     // GIR_Coverage, 56489,
     /* 2358719 */     GIR_EraseRootFromParent_Done,
     /* 2358720 */   // Label 32813: @2358720
     /* 2358720 */   GIM_Reject,
     /* 2358721 */ // Label 32809: @2358721
     /* 2358721 */ GIM_Reject,
     /* 2358722 */ // Label 32729: @2358722
     /* 2358722 */ GIM_Try, /*On fail goto*//*Label 32814*/ GIMT_Encode4(2358972),
     /* 2358727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2358733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358741 */   GIM_Try, /*On fail goto*//*Label 32815*/ GIMT_Encode4(2358807), // Rule ID 56314 //
     /* 2358746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358768 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2358785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358806 */     // GIR_Coverage, 56314,
     /* 2358806 */     GIR_EraseRootFromParent_Done,
     /* 2358807 */   // Label 32815: @2358807
     /* 2358807 */   GIM_Try, /*On fail goto*//*Label 32816*/ GIMT_Encode4(2358873), // Rule ID 56315 //
     /* 2358812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2358819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2358823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2358834 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2358851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2358862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358872 */     // GIR_Coverage, 56315,
     /* 2358872 */     GIR_EraseRootFromParent_Done,
     /* 2358873 */   // Label 32816: @2358873
     /* 2358873 */   GIM_Try, /*On fail goto*//*Label 32817*/ GIMT_Encode4(2358922), // Rule ID 56308 //
     /* 2358878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358885 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2358902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358921 */     // GIR_Coverage, 56308,
     /* 2358921 */     GIR_EraseRootFromParent_Done,
     /* 2358922 */   // Label 32817: @2358922
     /* 2358922 */   GIM_Try, /*On fail goto*//*Label 32818*/ GIMT_Encode4(2358971), // Rule ID 56309 //
     /* 2358927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358934 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2358951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358970 */     // GIR_Coverage, 56309,
     /* 2358970 */     GIR_EraseRootFromParent_Done,
     /* 2358971 */   // Label 32818: @2358971
     /* 2358971 */   GIM_Reject,
     /* 2358972 */ // Label 32814: @2358972
     /* 2358972 */ GIM_Reject,
     /* 2358973 */ // Label 32730: @2358973
     /* 2358973 */ GIM_Try, /*On fail goto*//*Label 32819*/ GIMT_Encode4(2359223),
     /* 2358978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358992 */   GIM_Try, /*On fail goto*//*Label 32820*/ GIMT_Encode4(2359058), // Rule ID 56434 //
     /* 2358997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2359012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359019 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2359036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359057 */     // GIR_Coverage, 56434,
     /* 2359057 */     GIR_EraseRootFromParent_Done,
     /* 2359058 */   // Label 32820: @2359058
     /* 2359058 */   GIM_Try, /*On fail goto*//*Label 32821*/ GIMT_Encode4(2359124), // Rule ID 56435 //
     /* 2359063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2359078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359085 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2359102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359123 */     // GIR_Coverage, 56435,
     /* 2359123 */     GIR_EraseRootFromParent_Done,
     /* 2359124 */   // Label 32821: @2359124
     /* 2359124 */   GIM_Try, /*On fail goto*//*Label 32822*/ GIMT_Encode4(2359173), // Rule ID 56428 //
     /* 2359129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359136 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2359153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359172 */     // GIR_Coverage, 56428,
     /* 2359172 */     GIR_EraseRootFromParent_Done,
     /* 2359173 */   // Label 32822: @2359173
     /* 2359173 */   GIM_Try, /*On fail goto*//*Label 32823*/ GIMT_Encode4(2359222), // Rule ID 56429 //
     /* 2359178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359185 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2359202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359221 */     // GIR_Coverage, 56429,
     /* 2359221 */     GIR_EraseRootFromParent_Done,
     /* 2359222 */   // Label 32823: @2359222
     /* 2359222 */   GIM_Reject,
     /* 2359223 */ // Label 32819: @2359223
     /* 2359223 */ GIM_Reject,
     /* 2359224 */ // Label 32731: @2359224
     /* 2359224 */ GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2359474),
     /* 2359229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2359235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359243 */   GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2359309), // Rule ID 56514 //
     /* 2359248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359270 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2359287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359308 */     // GIR_Coverage, 56514,
     /* 2359308 */     GIR_EraseRootFromParent_Done,
     /* 2359309 */   // Label 32825: @2359309
     /* 2359309 */   GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2359375), // Rule ID 56515 //
     /* 2359314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359336 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2359353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359374 */     // GIR_Coverage, 56515,
     /* 2359374 */     GIR_EraseRootFromParent_Done,
     /* 2359375 */   // Label 32826: @2359375
     /* 2359375 */   GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2359424), // Rule ID 56508 //
     /* 2359380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2359383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359387 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2359404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359423 */     // GIR_Coverage, 56508,
     /* 2359423 */     GIR_EraseRootFromParent_Done,
     /* 2359424 */   // Label 32827: @2359424
     /* 2359424 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2359473), // Rule ID 56509 //
     /* 2359429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2359432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359436 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2359453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359472 */     // GIR_Coverage, 56509,
     /* 2359472 */     GIR_EraseRootFromParent_Done,
     /* 2359473 */   // Label 32828: @2359473
     /* 2359473 */   GIM_Reject,
     /* 2359474 */ // Label 32824: @2359474
     /* 2359474 */ GIM_Reject,
     /* 2359475 */ // Label 32732: @2359475
     /* 2359475 */ GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2359725),
     /* 2359480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2359486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359494 */   GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2359560), // Rule ID 56374 //
     /* 2359499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359521 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2359538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359559 */     // GIR_Coverage, 56374,
     /* 2359559 */     GIR_EraseRootFromParent_Done,
     /* 2359560 */   // Label 32830: @2359560
     /* 2359560 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2359626), // Rule ID 56375 //
     /* 2359565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359587 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2359604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359625 */     // GIR_Coverage, 56375,
     /* 2359625 */     GIR_EraseRootFromParent_Done,
     /* 2359626 */   // Label 32831: @2359626
     /* 2359626 */   GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2359675), // Rule ID 56368 //
     /* 2359631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359638 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2359655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359674 */     // GIR_Coverage, 56368,
     /* 2359674 */     GIR_EraseRootFromParent_Done,
     /* 2359675 */   // Label 32832: @2359675
     /* 2359675 */   GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2359724), // Rule ID 56369 //
     /* 2359680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359687 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2359704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359723 */     // GIR_Coverage, 56369,
     /* 2359723 */     GIR_EraseRootFromParent_Done,
     /* 2359724 */   // Label 32833: @2359724
     /* 2359724 */   GIM_Reject,
     /* 2359725 */ // Label 32829: @2359725
     /* 2359725 */ GIM_Reject,
     /* 2359726 */ // Label 32733: @2359726
     /* 2359726 */ GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2359976),
     /* 2359731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2359737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359745 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2359811), // Rule ID 56454 //
     /* 2359750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359772 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2359789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359810 */     // GIR_Coverage, 56454,
     /* 2359810 */     GIR_EraseRootFromParent_Done,
     /* 2359811 */   // Label 32835: @2359811
     /* 2359811 */   GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2359877), // Rule ID 56455 //
     /* 2359816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2359823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2359827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2359831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359838 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2359855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2359866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359876 */     // GIR_Coverage, 56455,
     /* 2359876 */     GIR_EraseRootFromParent_Done,
     /* 2359877 */   // Label 32836: @2359877
     /* 2359877 */   GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2359926), // Rule ID 56448 //
     /* 2359882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359889 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2359906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359925 */     // GIR_Coverage, 56448,
     /* 2359925 */     GIR_EraseRootFromParent_Done,
     /* 2359926 */   // Label 32837: @2359926
     /* 2359926 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2359975), // Rule ID 56449 //
     /* 2359931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359938 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2359941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2359955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359974 */     // GIR_Coverage, 56449,
     /* 2359974 */     GIR_EraseRootFromParent_Done,
     /* 2359975 */   // Label 32838: @2359975
     /* 2359975 */   GIM_Reject,
     /* 2359976 */ // Label 32834: @2359976
     /* 2359976 */ GIM_Reject,
     /* 2359977 */ // Label 32734: @2359977
     /* 2359977 */ GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2360227),
     /* 2359982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2359985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2359988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359996 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2360062), // Rule ID 56534 //
     /* 2360001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2360016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360023 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2360040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360061 */     // GIR_Coverage, 56534,
     /* 2360061 */     GIR_EraseRootFromParent_Done,
     /* 2360062 */   // Label 32840: @2360062
     /* 2360062 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2360128), // Rule ID 56535 //
     /* 2360067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2360082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360089 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2360106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360127 */     // GIR_Coverage, 56535,
     /* 2360127 */     GIR_EraseRootFromParent_Done,
     /* 2360128 */   // Label 32841: @2360128
     /* 2360128 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2360177), // Rule ID 56528 //
     /* 2360133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360140 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2360157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360176 */     // GIR_Coverage, 56528,
     /* 2360176 */     GIR_EraseRootFromParent_Done,
     /* 2360177 */   // Label 32842: @2360177
     /* 2360177 */   GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2360226), // Rule ID 56529 //
     /* 2360182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360189 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2360206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360225 */     // GIR_Coverage, 56529,
     /* 2360225 */     GIR_EraseRootFromParent_Done,
     /* 2360226 */   // Label 32843: @2360226
     /* 2360226 */   GIM_Reject,
     /* 2360227 */ // Label 32839: @2360227
     /* 2360227 */ GIM_Reject,
     /* 2360228 */ // Label 32735: @2360228
     /* 2360228 */ GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2360478),
     /* 2360233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2360239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360247 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2360313), // Rule ID 56394 //
     /* 2360252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360274 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2360291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360312 */     // GIR_Coverage, 56394,
     /* 2360312 */     GIR_EraseRootFromParent_Done,
     /* 2360313 */   // Label 32845: @2360313
     /* 2360313 */   GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2360379), // Rule ID 56395 //
     /* 2360318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360340 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2360357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360378 */     // GIR_Coverage, 56395,
     /* 2360378 */     GIR_EraseRootFromParent_Done,
     /* 2360379 */   // Label 32846: @2360379
     /* 2360379 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2360428), // Rule ID 56388 //
     /* 2360384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360391 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2360408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360427 */     // GIR_Coverage, 56388,
     /* 2360427 */     GIR_EraseRootFromParent_Done,
     /* 2360428 */   // Label 32847: @2360428
     /* 2360428 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2360477), // Rule ID 56389 //
     /* 2360433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360440 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2360457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360476 */     // GIR_Coverage, 56389,
     /* 2360476 */     GIR_EraseRootFromParent_Done,
     /* 2360477 */   // Label 32848: @2360477
     /* 2360477 */   GIM_Reject,
     /* 2360478 */ // Label 32844: @2360478
     /* 2360478 */ GIM_Reject,
     /* 2360479 */ // Label 32736: @2360479
     /* 2360479 */ GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2360729),
     /* 2360484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2360490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360498 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2360564), // Rule ID 56474 //
     /* 2360503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360525 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2360542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360563 */     // GIR_Coverage, 56474,
     /* 2360563 */     GIR_EraseRootFromParent_Done,
     /* 2360564 */   // Label 32850: @2360564
     /* 2360564 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2360630), // Rule ID 56475 //
     /* 2360569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360591 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2360608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360629 */     // GIR_Coverage, 56475,
     /* 2360629 */     GIR_EraseRootFromParent_Done,
     /* 2360630 */   // Label 32851: @2360630
     /* 2360630 */   GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2360679), // Rule ID 56468 //
     /* 2360635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360642 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2360659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360678 */     // GIR_Coverage, 56468,
     /* 2360678 */     GIR_EraseRootFromParent_Done,
     /* 2360679 */   // Label 32852: @2360679
     /* 2360679 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2360728), // Rule ID 56469 //
     /* 2360684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360691 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2360708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360727 */     // GIR_Coverage, 56469,
     /* 2360727 */     GIR_EraseRootFromParent_Done,
     /* 2360728 */   // Label 32853: @2360728
     /* 2360728 */   GIM_Reject,
     /* 2360729 */ // Label 32849: @2360729
     /* 2360729 */ GIM_Reject,
     /* 2360730 */ // Label 32737: @2360730
     /* 2360730 */ GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2360980),
     /* 2360735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2360741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360749 */   GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2360815), // Rule ID 56414 //
     /* 2360754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360776 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2360793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360814 */     // GIR_Coverage, 56414,
     /* 2360814 */     GIR_EraseRootFromParent_Done,
     /* 2360815 */   // Label 32855: @2360815
     /* 2360815 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2360881), // Rule ID 56415 //
     /* 2360820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2360827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2360831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2360842 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2360859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2360870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360880 */     // GIR_Coverage, 56415,
     /* 2360880 */     GIR_EraseRootFromParent_Done,
     /* 2360881 */   // Label 32856: @2360881
     /* 2360881 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2360930), // Rule ID 56408 //
     /* 2360886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360893 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2360910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360929 */     // GIR_Coverage, 56408,
     /* 2360929 */     GIR_EraseRootFromParent_Done,
     /* 2360930 */   // Label 32857: @2360930
     /* 2360930 */   GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2360979), // Rule ID 56409 //
     /* 2360935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360942 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2360959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360978 */     // GIR_Coverage, 56409,
     /* 2360978 */     GIR_EraseRootFromParent_Done,
     /* 2360979 */   // Label 32858: @2360979
     /* 2360979 */   GIM_Reject,
     /* 2360980 */ // Label 32854: @2360980
     /* 2360980 */ GIM_Reject,
     /* 2360981 */ // Label 32738: @2360981
     /* 2360981 */ GIM_Reject,
     /* 2360982 */ // Label 73: @2360982
     /* 2360982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32862*/ GIMT_Encode4(2361171),
     /* 2360993 */ /*GILLT_s16*//*Label 32859*/ GIMT_Encode4(2361005),
     /* 2360997 */ /*GILLT_s32*//*Label 32860*/ GIMT_Encode4(2361055),
     /* 2361001 */ /*GILLT_s64*//*Label 32861*/ GIMT_Encode4(2361105),
     /* 2361005 */ // Label 32859: @2361005
     /* 2361005 */ GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2361054),
     /* 2361010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361021 */   GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2361037), // Rule ID 2066 //
     /* 2361026 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2361026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361036 */     // GIR_Coverage, 2066,
     /* 2361036 */     GIR_EraseRootFromParent_Done,
     /* 2361037 */   // Label 32864: @2361037
     /* 2361037 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2361053), // Rule ID 2067 //
     /* 2361042 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2361042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361052 */     // GIR_Coverage, 2067,
     /* 2361052 */     GIR_EraseRootFromParent_Done,
     /* 2361053 */   // Label 32865: @2361053
     /* 2361053 */   GIM_Reject,
     /* 2361054 */ // Label 32863: @2361054
     /* 2361054 */ GIM_Reject,
     /* 2361055 */ // Label 32860: @2361055
     /* 2361055 */ GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2361104),
     /* 2361060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361071 */   GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2361087), // Rule ID 1353 //
     /* 2361076 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2361076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361086 */     // GIR_Coverage, 1353,
     /* 2361086 */     GIR_EraseRootFromParent_Done,
     /* 2361087 */   // Label 32867: @2361087
     /* 2361087 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2361103), // Rule ID 1354 //
     /* 2361092 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2361092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361102 */     // GIR_Coverage, 1354,
     /* 2361102 */     GIR_EraseRootFromParent_Done,
     /* 2361103 */   // Label 32868: @2361103
     /* 2361103 */   GIM_Reject,
     /* 2361104 */ // Label 32866: @2361104
     /* 2361104 */ GIM_Reject,
     /* 2361105 */ // Label 32861: @2361105
     /* 2361105 */ GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2361170),
     /* 2361110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361121 */   GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2361137), // Rule ID 1730 //
     /* 2361126 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361136 */     // GIR_Coverage, 1730,
     /* 2361136 */     GIR_EraseRootFromParent_Done,
     /* 2361137 */   // Label 32870: @2361137
     /* 2361137 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2361153), // Rule ID 1731 //
     /* 2361142 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361152 */     // GIR_Coverage, 1731,
     /* 2361152 */     GIR_EraseRootFromParent_Done,
     /* 2361153 */   // Label 32871: @2361153
     /* 2361153 */   GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2361169), // Rule ID 1732 //
     /* 2361158 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2361158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361168 */     // GIR_Coverage, 1732,
     /* 2361168 */     GIR_EraseRootFromParent_Done,
     /* 2361169 */   // Label 32872: @2361169
     /* 2361169 */   GIM_Reject,
     /* 2361170 */ // Label 32869: @2361170
     /* 2361170 */ GIM_Reject,
     /* 2361171 */ // Label 32862: @2361171
     /* 2361171 */ GIM_Reject,
     /* 2361172 */ // Label 74: @2361172
     /* 2361172 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32891*/ GIMT_Encode4(2363256),
     /* 2361183 */ /*GILLT_s16*//*Label 32873*/ GIMT_Encode4(2361303),
     /* 2361187 */ /*GILLT_s32*//*Label 32874*/ GIMT_Encode4(2361370),
     /* 2361191 */ /*GILLT_s64*//*Label 32875*/ GIMT_Encode4(2361437), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361203 */ /*GILLT_nxv1s16*//*Label 32876*/ GIMT_Encode4(2361531),
     /* 2361207 */ /*GILLT_nxv1s32*//*Label 32877*/ GIMT_Encode4(2361646),
     /* 2361211 */ /*GILLT_nxv1s64*//*Label 32878*/ GIMT_Encode4(2361761), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361223 */ /*GILLT_nxv2s16*//*Label 32879*/ GIMT_Encode4(2361876),
     /* 2361227 */ /*GILLT_nxv2s32*//*Label 32880*/ GIMT_Encode4(2361991),
     /* 2361231 */ /*GILLT_nxv2s64*//*Label 32881*/ GIMT_Encode4(2362106), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361243 */ /*GILLT_nxv4s16*//*Label 32882*/ GIMT_Encode4(2362221),
     /* 2361247 */ /*GILLT_nxv4s32*//*Label 32883*/ GIMT_Encode4(2362336),
     /* 2361251 */ /*GILLT_nxv4s64*//*Label 32884*/ GIMT_Encode4(2362451), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361263 */ /*GILLT_nxv8s16*//*Label 32885*/ GIMT_Encode4(2362566),
     /* 2361267 */ /*GILLT_nxv8s32*//*Label 32886*/ GIMT_Encode4(2362681),
     /* 2361271 */ /*GILLT_nxv8s64*//*Label 32887*/ GIMT_Encode4(2362796), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361283 */ /*GILLT_nxv16s16*//*Label 32888*/ GIMT_Encode4(2362911),
     /* 2361287 */ /*GILLT_nxv16s32*//*Label 32889*/ GIMT_Encode4(2363026), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361299 */ /*GILLT_nxv32s16*//*Label 32890*/ GIMT_Encode4(2363141),
     /* 2361303 */ // Label 32873: @2361303
     /* 2361303 */ GIM_Try, /*On fail goto*//*Label 32892*/ GIMT_Encode4(2361369),
     /* 2361308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2361314 */   GIM_Try, /*On fail goto*//*Label 32893*/ GIMT_Encode4(2361341), // Rule ID 2054 //
     /* 2361319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2361322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361334 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2361339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361340 */     // GIR_Coverage, 2054,
     /* 2361340 */     GIR_Done,
     /* 2361341 */   // Label 32893: @2361341
     /* 2361341 */   GIM_Try, /*On fail goto*//*Label 32894*/ GIMT_Encode4(2361368), // Rule ID 2055 //
     /* 2361346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2361349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361361 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2361366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361367 */     // GIR_Coverage, 2055,
     /* 2361367 */     GIR_Done,
     /* 2361368 */   // Label 32894: @2361368
     /* 2361368 */   GIM_Reject,
     /* 2361369 */ // Label 32892: @2361369
     /* 2361369 */ GIM_Reject,
     /* 2361370 */ // Label 32874: @2361370
     /* 2361370 */ GIM_Try, /*On fail goto*//*Label 32895*/ GIMT_Encode4(2361436),
     /* 2361375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361381 */   GIM_Try, /*On fail goto*//*Label 32896*/ GIMT_Encode4(2361408), // Rule ID 1341 //
     /* 2361386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2361389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361401 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2361406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361407 */     // GIR_Coverage, 1341,
     /* 2361407 */     GIR_Done,
     /* 2361408 */   // Label 32896: @2361408
     /* 2361408 */   GIM_Try, /*On fail goto*//*Label 32897*/ GIMT_Encode4(2361435), // Rule ID 1342 //
     /* 2361413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2361416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361428 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2361433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361434 */     // GIR_Coverage, 1342,
     /* 2361434 */     GIR_Done,
     /* 2361435 */   // Label 32897: @2361435
     /* 2361435 */   GIM_Reject,
     /* 2361436 */ // Label 32895: @2361436
     /* 2361436 */ GIM_Reject,
     /* 2361437 */ // Label 32875: @2361437
     /* 2361437 */ GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2361530),
     /* 2361442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361448 */   GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2361475), // Rule ID 1712 //
     /* 2361453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2361456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361468 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2361473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361474 */     // GIR_Coverage, 1712,
     /* 2361474 */     GIR_Done,
     /* 2361475 */   // Label 32899: @2361475
     /* 2361475 */   GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2361502), // Rule ID 1713 //
     /* 2361480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2361483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361495 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2361500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361501 */     // GIR_Coverage, 1713,
     /* 2361501 */     GIR_Done,
     /* 2361502 */   // Label 32900: @2361502
     /* 2361502 */   GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2361529), // Rule ID 1714 //
     /* 2361507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2361510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361522 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2361527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361528 */     // GIR_Coverage, 1714,
     /* 2361528 */     GIR_Done,
     /* 2361529 */   // Label 32901: @2361529
     /* 2361529 */   GIM_Reject,
     /* 2361530 */ // Label 32898: @2361530
     /* 2361530 */ GIM_Reject,
     /* 2361531 */ // Label 32876: @2361531
     /* 2361531 */ GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2361645),
     /* 2361536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2361539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2361542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361554 */   GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2361599), // Rule ID 45756 //
     /* 2361559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361562 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2361579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361598 */     // GIR_Coverage, 45756,
     /* 2361598 */     GIR_EraseRootFromParent_Done,
     /* 2361599 */   // Label 32903: @2361599
     /* 2361599 */   GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2361644), // Rule ID 45757 //
     /* 2361604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361607 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2361624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361643 */     // GIR_Coverage, 45757,
     /* 2361643 */     GIR_EraseRootFromParent_Done,
     /* 2361644 */   // Label 32904: @2361644
     /* 2361644 */   GIM_Reject,
     /* 2361645 */ // Label 32902: @2361645
     /* 2361645 */ GIM_Reject,
     /* 2361646 */ // Label 32877: @2361646
     /* 2361646 */ GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2361760),
     /* 2361651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2361654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2361657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361669 */   GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2361714), // Rule ID 56546 //
     /* 2361674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361677 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2361694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361713 */     // GIR_Coverage, 56546,
     /* 2361713 */     GIR_EraseRootFromParent_Done,
     /* 2361714 */   // Label 32906: @2361714
     /* 2361714 */   GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2361759), // Rule ID 56547 //
     /* 2361719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361722 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2361739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361758 */     // GIR_Coverage, 56547,
     /* 2361758 */     GIR_EraseRootFromParent_Done,
     /* 2361759 */   // Label 32907: @2361759
     /* 2361759 */   GIM_Reject,
     /* 2361760 */ // Label 32905: @2361760
     /* 2361760 */ GIM_Reject,
     /* 2361761 */ // Label 32878: @2361761
     /* 2361761 */ GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2361875),
     /* 2361766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2361769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2361772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361784 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2361829), // Rule ID 56564 //
     /* 2361789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361792 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2361809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361828 */     // GIR_Coverage, 56564,
     /* 2361828 */     GIR_EraseRootFromParent_Done,
     /* 2361829 */   // Label 32909: @2361829
     /* 2361829 */   GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2361874), // Rule ID 56565 //
     /* 2361834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361837 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2361854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361873 */     // GIR_Coverage, 56565,
     /* 2361873 */     GIR_EraseRootFromParent_Done,
     /* 2361874 */   // Label 32910: @2361874
     /* 2361874 */   GIM_Reject,
     /* 2361875 */ // Label 32908: @2361875
     /* 2361875 */ GIM_Reject,
     /* 2361876 */ // Label 32879: @2361876
     /* 2361876 */ GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2361990),
     /* 2361881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2361884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2361887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361899 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2361944), // Rule ID 56540 //
     /* 2361904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361907 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2361924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361943 */     // GIR_Coverage, 56540,
     /* 2361943 */     GIR_EraseRootFromParent_Done,
     /* 2361944 */   // Label 32912: @2361944
     /* 2361944 */   GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2361989), // Rule ID 56541 //
     /* 2361949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361952 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2361969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361988 */     // GIR_Coverage, 56541,
     /* 2361988 */     GIR_EraseRootFromParent_Done,
     /* 2361989 */   // Label 32913: @2361989
     /* 2361989 */   GIM_Reject,
     /* 2361990 */ // Label 32911: @2361990
     /* 2361990 */ GIM_Reject,
     /* 2361991 */ // Label 32880: @2361991
     /* 2361991 */ GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2362105),
     /* 2361996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2361999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2362002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362014 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2362059), // Rule ID 56558 //
     /* 2362019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362022 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362058 */     // GIR_Coverage, 56558,
     /* 2362058 */     GIR_EraseRootFromParent_Done,
     /* 2362059 */   // Label 32915: @2362059
     /* 2362059 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2362104), // Rule ID 56559 //
     /* 2362064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362067 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2362084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362103 */     // GIR_Coverage, 56559,
     /* 2362103 */     GIR_EraseRootFromParent_Done,
     /* 2362104 */   // Label 32916: @2362104
     /* 2362104 */   GIM_Reject,
     /* 2362105 */ // Label 32914: @2362105
     /* 2362105 */ GIM_Reject,
     /* 2362106 */ // Label 32881: @2362106
     /* 2362106 */ GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2362220),
     /* 2362111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362129 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2362174), // Rule ID 56606 //
     /* 2362134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362137 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362173 */     // GIR_Coverage, 56606,
     /* 2362173 */     GIR_EraseRootFromParent_Done,
     /* 2362174 */   // Label 32918: @2362174
     /* 2362174 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2362219), // Rule ID 56607 //
     /* 2362179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362182 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2362199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362218 */     // GIR_Coverage, 56607,
     /* 2362218 */     GIR_EraseRootFromParent_Done,
     /* 2362219 */   // Label 32919: @2362219
     /* 2362219 */   GIM_Reject,
     /* 2362220 */ // Label 32917: @2362220
     /* 2362220 */ GIM_Reject,
     /* 2362221 */ // Label 32882: @2362221
     /* 2362221 */ GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2362335),
     /* 2362226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2362229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2362232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362244 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2362289), // Rule ID 56552 //
     /* 2362249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362252 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2362269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362288 */     // GIR_Coverage, 56552,
     /* 2362288 */     GIR_EraseRootFromParent_Done,
     /* 2362289 */   // Label 32921: @2362289
     /* 2362289 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2362334), // Rule ID 56553 //
     /* 2362294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362297 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2362314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362333 */     // GIR_Coverage, 56553,
     /* 2362333 */     GIR_EraseRootFromParent_Done,
     /* 2362334 */   // Label 32922: @2362334
     /* 2362334 */   GIM_Reject,
     /* 2362335 */ // Label 32920: @2362335
     /* 2362335 */ GIM_Reject,
     /* 2362336 */ // Label 32883: @2362336
     /* 2362336 */ GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2362450),
     /* 2362341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2362344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2362347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362359 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2362404), // Rule ID 56588 //
     /* 2362364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362367 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2362384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362403 */     // GIR_Coverage, 56588,
     /* 2362403 */     GIR_EraseRootFromParent_Done,
     /* 2362404 */   // Label 32924: @2362404
     /* 2362404 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2362449), // Rule ID 56589 //
     /* 2362409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362412 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2362429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362448 */     // GIR_Coverage, 56589,
     /* 2362448 */     GIR_EraseRootFromParent_Done,
     /* 2362449 */   // Label 32925: @2362449
     /* 2362449 */   GIM_Reject,
     /* 2362450 */ // Label 32923: @2362450
     /* 2362450 */ GIM_Reject,
     /* 2362451 */ // Label 32884: @2362451
     /* 2362451 */ GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2362565),
     /* 2362456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2362459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2362462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362474 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2362519), // Rule ID 56612 //
     /* 2362479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362482 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2362499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362518 */     // GIR_Coverage, 56612,
     /* 2362518 */     GIR_EraseRootFromParent_Done,
     /* 2362519 */   // Label 32927: @2362519
     /* 2362519 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2362564), // Rule ID 56613 //
     /* 2362524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362527 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2362544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362563 */     // GIR_Coverage, 56613,
     /* 2362563 */     GIR_EraseRootFromParent_Done,
     /* 2362564 */   // Label 32928: @2362564
     /* 2362564 */   GIM_Reject,
     /* 2362565 */ // Label 32926: @2362565
     /* 2362565 */ GIM_Reject,
     /* 2362566 */ // Label 32885: @2362566
     /* 2362566 */ GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2362680),
     /* 2362571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2362574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2362577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362589 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2362634), // Rule ID 56570 //
     /* 2362594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362597 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2362614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362633 */     // GIR_Coverage, 56570,
     /* 2362633 */     GIR_EraseRootFromParent_Done,
     /* 2362634 */   // Label 32930: @2362634
     /* 2362634 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2362679), // Rule ID 56571 //
     /* 2362639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362642 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2362659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362678 */     // GIR_Coverage, 56571,
     /* 2362678 */     GIR_EraseRootFromParent_Done,
     /* 2362679 */   // Label 32931: @2362679
     /* 2362679 */   GIM_Reject,
     /* 2362680 */ // Label 32929: @2362680
     /* 2362680 */ GIM_Reject,
     /* 2362681 */ // Label 32886: @2362681
     /* 2362681 */ GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2362795),
     /* 2362686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2362689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2362692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362704 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2362749), // Rule ID 56594 //
     /* 2362709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362712 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2362729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362748 */     // GIR_Coverage, 56594,
     /* 2362748 */     GIR_EraseRootFromParent_Done,
     /* 2362749 */   // Label 32933: @2362749
     /* 2362749 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2362794), // Rule ID 56595 //
     /* 2362754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362757 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2362774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362793 */     // GIR_Coverage, 56595,
     /* 2362793 */     GIR_EraseRootFromParent_Done,
     /* 2362794 */   // Label 32934: @2362794
     /* 2362794 */   GIM_Reject,
     /* 2362795 */ // Label 32932: @2362795
     /* 2362795 */ GIM_Reject,
     /* 2362796 */ // Label 32887: @2362796
     /* 2362796 */ GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2362910),
     /* 2362801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2362804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2362807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362819 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2362864), // Rule ID 56618 //
     /* 2362824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362827 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2362844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362863 */     // GIR_Coverage, 56618,
     /* 2362863 */     GIR_EraseRootFromParent_Done,
     /* 2362864 */   // Label 32936: @2362864
     /* 2362864 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2362909), // Rule ID 56619 //
     /* 2362869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362872 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2362889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362908 */     // GIR_Coverage, 56619,
     /* 2362908 */     GIR_EraseRootFromParent_Done,
     /* 2362909 */   // Label 32937: @2362909
     /* 2362909 */   GIM_Reject,
     /* 2362910 */ // Label 32935: @2362910
     /* 2362910 */ GIM_Reject,
     /* 2362911 */ // Label 32888: @2362911
     /* 2362911 */ GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2363025),
     /* 2362916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2362919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2362922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362934 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2362979), // Rule ID 56576 //
     /* 2362939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362942 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2362959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362978 */     // GIR_Coverage, 56576,
     /* 2362978 */     GIR_EraseRootFromParent_Done,
     /* 2362979 */   // Label 32939: @2362979
     /* 2362979 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2363024), // Rule ID 56577 //
     /* 2362984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362987 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2363004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363023 */     // GIR_Coverage, 56577,
     /* 2363023 */     GIR_EraseRootFromParent_Done,
     /* 2363024 */   // Label 32940: @2363024
     /* 2363024 */   GIM_Reject,
     /* 2363025 */ // Label 32938: @2363025
     /* 2363025 */ GIM_Reject,
     /* 2363026 */ // Label 32889: @2363026
     /* 2363026 */ GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2363140),
     /* 2363031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363049 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2363094), // Rule ID 56600 //
     /* 2363054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363057 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363093 */     // GIR_Coverage, 56600,
     /* 2363093 */     GIR_EraseRootFromParent_Done,
     /* 2363094 */   // Label 32942: @2363094
     /* 2363094 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2363139), // Rule ID 56601 //
     /* 2363099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363102 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2363119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363138 */     // GIR_Coverage, 56601,
     /* 2363138 */     GIR_EraseRootFromParent_Done,
     /* 2363139 */   // Label 32943: @2363139
     /* 2363139 */   GIM_Reject,
     /* 2363140 */ // Label 32941: @2363140
     /* 2363140 */ GIM_Reject,
     /* 2363141 */ // Label 32890: @2363141
     /* 2363141 */ GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2363255),
     /* 2363146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363164 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2363209), // Rule ID 56582 //
     /* 2363169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363172 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2363189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363208 */     // GIR_Coverage, 56582,
     /* 2363208 */     GIR_EraseRootFromParent_Done,
     /* 2363209 */   // Label 32945: @2363209
     /* 2363209 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2363254), // Rule ID 56583 //
     /* 2363214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363217 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2363234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363253 */     // GIR_Coverage, 56583,
     /* 2363253 */     GIR_EraseRootFromParent_Done,
     /* 2363254 */   // Label 32946: @2363254
     /* 2363254 */   GIM_Reject,
     /* 2363255 */ // Label 32944: @2363255
     /* 2363255 */ GIM_Reject,
     /* 2363256 */ // Label 32891: @2363256
     /* 2363256 */ GIM_Reject,
     /* 2363257 */ // Label 75: @2363257
     /* 2363257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32965*/ GIMT_Encode4(2365341),
     /* 2363268 */ /*GILLT_s16*//*Label 32947*/ GIMT_Encode4(2363388),
     /* 2363272 */ /*GILLT_s32*//*Label 32948*/ GIMT_Encode4(2363455),
     /* 2363276 */ /*GILLT_s64*//*Label 32949*/ GIMT_Encode4(2363522), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363288 */ /*GILLT_nxv1s16*//*Label 32950*/ GIMT_Encode4(2363616),
     /* 2363292 */ /*GILLT_nxv1s32*//*Label 32951*/ GIMT_Encode4(2363731),
     /* 2363296 */ /*GILLT_nxv1s64*//*Label 32952*/ GIMT_Encode4(2363846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363308 */ /*GILLT_nxv2s16*//*Label 32953*/ GIMT_Encode4(2363961),
     /* 2363312 */ /*GILLT_nxv2s32*//*Label 32954*/ GIMT_Encode4(2364076),
     /* 2363316 */ /*GILLT_nxv2s64*//*Label 32955*/ GIMT_Encode4(2364191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363328 */ /*GILLT_nxv4s16*//*Label 32956*/ GIMT_Encode4(2364306),
     /* 2363332 */ /*GILLT_nxv4s32*//*Label 32957*/ GIMT_Encode4(2364421),
     /* 2363336 */ /*GILLT_nxv4s64*//*Label 32958*/ GIMT_Encode4(2364536), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363348 */ /*GILLT_nxv8s16*//*Label 32959*/ GIMT_Encode4(2364651),
     /* 2363352 */ /*GILLT_nxv8s32*//*Label 32960*/ GIMT_Encode4(2364766),
     /* 2363356 */ /*GILLT_nxv8s64*//*Label 32961*/ GIMT_Encode4(2364881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363368 */ /*GILLT_nxv16s16*//*Label 32962*/ GIMT_Encode4(2364996),
     /* 2363372 */ /*GILLT_nxv16s32*//*Label 32963*/ GIMT_Encode4(2365111), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2363384 */ /*GILLT_nxv32s16*//*Label 32964*/ GIMT_Encode4(2365226),
     /* 2363388 */ // Label 32947: @2363388
     /* 2363388 */ GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2363454),
     /* 2363393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2363396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2363399 */   GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2363426), // Rule ID 2056 //
     /* 2363404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2363407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2363419 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2363419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2363424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363425 */     // GIR_Coverage, 2056,
     /* 2363425 */     GIR_Done,
     /* 2363426 */   // Label 32967: @2363426
     /* 2363426 */   GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2363453), // Rule ID 2057 //
     /* 2363431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2363434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2363446 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2363446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2363451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363452 */     // GIR_Coverage, 2057,
     /* 2363452 */     GIR_Done,
     /* 2363453 */   // Label 32968: @2363453
     /* 2363453 */   GIM_Reject,
     /* 2363454 */ // Label 32966: @2363454
     /* 2363454 */ GIM_Reject,
     /* 2363455 */ // Label 32948: @2363455
     /* 2363455 */ GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2363521),
     /* 2363460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2363466 */   GIM_Try, /*On fail goto*//*Label 32970*/ GIMT_Encode4(2363493), // Rule ID 1343 //
     /* 2363471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2363474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363486 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2363486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2363491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363492 */     // GIR_Coverage, 1343,
     /* 2363492 */     GIR_Done,
     /* 2363493 */   // Label 32970: @2363493
     /* 2363493 */   GIM_Try, /*On fail goto*//*Label 32971*/ GIMT_Encode4(2363520), // Rule ID 1344 //
     /* 2363498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2363501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2363513 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2363513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2363518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363519 */     // GIR_Coverage, 1344,
     /* 2363519 */     GIR_Done,
     /* 2363520 */   // Label 32971: @2363520
     /* 2363520 */   GIM_Reject,
     /* 2363521 */ // Label 32969: @2363521
     /* 2363521 */ GIM_Reject,
     /* 2363522 */ // Label 32949: @2363522
     /* 2363522 */ GIM_Try, /*On fail goto*//*Label 32972*/ GIMT_Encode4(2363615),
     /* 2363527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2363533 */   GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2363560), // Rule ID 1715 //
     /* 2363538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2363541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2363553 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2363558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363559 */     // GIR_Coverage, 1715,
     /* 2363559 */     GIR_Done,
     /* 2363560 */   // Label 32973: @2363560
     /* 2363560 */   GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2363587), // Rule ID 1716 //
     /* 2363565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2363568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2363580 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2363585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363586 */     // GIR_Coverage, 1716,
     /* 2363586 */     GIR_Done,
     /* 2363587 */   // Label 32974: @2363587
     /* 2363587 */   GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2363614), // Rule ID 1717 //
     /* 2363592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2363595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363607 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2363607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2363612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363613 */     // GIR_Coverage, 1717,
     /* 2363613 */     GIR_Done,
     /* 2363614 */   // Label 32975: @2363614
     /* 2363614 */   GIM_Reject,
     /* 2363615 */ // Label 32972: @2363615
     /* 2363615 */ GIM_Reject,
     /* 2363616 */ // Label 32950: @2363616
     /* 2363616 */ GIM_Try, /*On fail goto*//*Label 32976*/ GIMT_Encode4(2363730),
     /* 2363621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2363624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2363627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363639 */   GIM_Try, /*On fail goto*//*Label 32977*/ GIMT_Encode4(2363684), // Rule ID 56624 //
     /* 2363644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363647 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2363664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363683 */     // GIR_Coverage, 56624,
     /* 2363683 */     GIR_EraseRootFromParent_Done,
     /* 2363684 */   // Label 32977: @2363684
     /* 2363684 */   GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2363729), // Rule ID 56625 //
     /* 2363689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363692 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2363709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363728 */     // GIR_Coverage, 56625,
     /* 2363728 */     GIR_EraseRootFromParent_Done,
     /* 2363729 */   // Label 32978: @2363729
     /* 2363729 */   GIM_Reject,
     /* 2363730 */ // Label 32976: @2363730
     /* 2363730 */ GIM_Reject,
     /* 2363731 */ // Label 32951: @2363731
     /* 2363731 */ GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2363845),
     /* 2363736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2363739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2363742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363754 */   GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2363799), // Rule ID 56636 //
     /* 2363759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363762 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2363779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363798 */     // GIR_Coverage, 56636,
     /* 2363798 */     GIR_EraseRootFromParent_Done,
     /* 2363799 */   // Label 32980: @2363799
     /* 2363799 */   GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2363844), // Rule ID 56637 //
     /* 2363804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363807 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2363824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363843 */     // GIR_Coverage, 56637,
     /* 2363843 */     GIR_EraseRootFromParent_Done,
     /* 2363844 */   // Label 32981: @2363844
     /* 2363844 */   GIM_Reject,
     /* 2363845 */ // Label 32979: @2363845
     /* 2363845 */ GIM_Reject,
     /* 2363846 */ // Label 32952: @2363846
     /* 2363846 */ GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2363960),
     /* 2363851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2363854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2363857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363869 */   GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2363914), // Rule ID 56654 //
     /* 2363874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363877 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2363894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363913 */     // GIR_Coverage, 56654,
     /* 2363913 */     GIR_EraseRootFromParent_Done,
     /* 2363914 */   // Label 32983: @2363914
     /* 2363914 */   GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2363959), // Rule ID 56655 //
     /* 2363919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363922 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2363939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363958 */     // GIR_Coverage, 56655,
     /* 2363958 */     GIR_EraseRootFromParent_Done,
     /* 2363959 */   // Label 32984: @2363959
     /* 2363959 */   GIM_Reject,
     /* 2363960 */ // Label 32982: @2363960
     /* 2363960 */ GIM_Reject,
     /* 2363961 */ // Label 32953: @2363961
     /* 2363961 */ GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2364075),
     /* 2363966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2363969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2363972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363984 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2364029), // Rule ID 56630 //
     /* 2363989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363992 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2363995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364028 */     // GIR_Coverage, 56630,
     /* 2364028 */     GIR_EraseRootFromParent_Done,
     /* 2364029 */   // Label 32986: @2364029
     /* 2364029 */   GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2364074), // Rule ID 56631 //
     /* 2364034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364037 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2364054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364073 */     // GIR_Coverage, 56631,
     /* 2364073 */     GIR_EraseRootFromParent_Done,
     /* 2364074 */   // Label 32987: @2364074
     /* 2364074 */   GIM_Reject,
     /* 2364075 */ // Label 32985: @2364075
     /* 2364075 */ GIM_Reject,
     /* 2364076 */ // Label 32954: @2364076
     /* 2364076 */ GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2364190),
     /* 2364081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2364084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2364087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364099 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2364144), // Rule ID 56648 //
     /* 2364104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364107 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364143 */     // GIR_Coverage, 56648,
     /* 2364143 */     GIR_EraseRootFromParent_Done,
     /* 2364144 */   // Label 32989: @2364144
     /* 2364144 */   GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2364189), // Rule ID 56649 //
     /* 2364149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364152 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2364169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364188 */     // GIR_Coverage, 56649,
     /* 2364188 */     GIR_EraseRootFromParent_Done,
     /* 2364189 */   // Label 32990: @2364189
     /* 2364189 */   GIM_Reject,
     /* 2364190 */ // Label 32988: @2364190
     /* 2364190 */ GIM_Reject,
     /* 2364191 */ // Label 32955: @2364191
     /* 2364191 */ GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2364305),
     /* 2364196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2364199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2364202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364214 */   GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2364259), // Rule ID 56696 //
     /* 2364219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364222 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2364239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364258 */     // GIR_Coverage, 56696,
     /* 2364258 */     GIR_EraseRootFromParent_Done,
     /* 2364259 */   // Label 32992: @2364259
     /* 2364259 */   GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2364304), // Rule ID 56697 //
     /* 2364264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364267 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2364284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364303 */     // GIR_Coverage, 56697,
     /* 2364303 */     GIR_EraseRootFromParent_Done,
     /* 2364304 */   // Label 32993: @2364304
     /* 2364304 */   GIM_Reject,
     /* 2364305 */ // Label 32991: @2364305
     /* 2364305 */ GIM_Reject,
     /* 2364306 */ // Label 32956: @2364306
     /* 2364306 */ GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2364420),
     /* 2364311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2364314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2364317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364329 */   GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2364374), // Rule ID 56642 //
     /* 2364334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364337 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2364354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364373 */     // GIR_Coverage, 56642,
     /* 2364373 */     GIR_EraseRootFromParent_Done,
     /* 2364374 */   // Label 32995: @2364374
     /* 2364374 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2364419), // Rule ID 56643 //
     /* 2364379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364382 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2364399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364418 */     // GIR_Coverage, 56643,
     /* 2364418 */     GIR_EraseRootFromParent_Done,
     /* 2364419 */   // Label 32996: @2364419
     /* 2364419 */   GIM_Reject,
     /* 2364420 */ // Label 32994: @2364420
     /* 2364420 */ GIM_Reject,
     /* 2364421 */ // Label 32957: @2364421
     /* 2364421 */ GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2364535),
     /* 2364426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2364429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2364432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364444 */   GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2364489), // Rule ID 56678 //
     /* 2364449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364452 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2364469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364488 */     // GIR_Coverage, 56678,
     /* 2364488 */     GIR_EraseRootFromParent_Done,
     /* 2364489 */   // Label 32998: @2364489
     /* 2364489 */   GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2364534), // Rule ID 56679 //
     /* 2364494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364497 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2364514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364533 */     // GIR_Coverage, 56679,
     /* 2364533 */     GIR_EraseRootFromParent_Done,
     /* 2364534 */   // Label 32999: @2364534
     /* 2364534 */   GIM_Reject,
     /* 2364535 */ // Label 32997: @2364535
     /* 2364535 */ GIM_Reject,
     /* 2364536 */ // Label 32958: @2364536
     /* 2364536 */ GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2364650),
     /* 2364541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2364544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2364547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364559 */   GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2364604), // Rule ID 56702 //
     /* 2364564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364567 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2364584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364603 */     // GIR_Coverage, 56702,
     /* 2364603 */     GIR_EraseRootFromParent_Done,
     /* 2364604 */   // Label 33001: @2364604
     /* 2364604 */   GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2364649), // Rule ID 56703 //
     /* 2364609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364612 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2364629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364648 */     // GIR_Coverage, 56703,
     /* 2364648 */     GIR_EraseRootFromParent_Done,
     /* 2364649 */   // Label 33002: @2364649
     /* 2364649 */   GIM_Reject,
     /* 2364650 */ // Label 33000: @2364650
     /* 2364650 */ GIM_Reject,
     /* 2364651 */ // Label 32959: @2364651
     /* 2364651 */ GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2364765),
     /* 2364656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2364659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2364662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364674 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2364719), // Rule ID 56660 //
     /* 2364679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2364682 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2364699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364718 */     // GIR_Coverage, 56660,
     /* 2364718 */     GIR_EraseRootFromParent_Done,
     /* 2364719 */   // Label 33004: @2364719
     /* 2364719 */   GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2364764), // Rule ID 56661 //
     /* 2364724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2364727 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2364744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364763 */     // GIR_Coverage, 56661,
     /* 2364763 */     GIR_EraseRootFromParent_Done,
     /* 2364764 */   // Label 33005: @2364764
     /* 2364764 */   GIM_Reject,
     /* 2364765 */ // Label 33003: @2364765
     /* 2364765 */ GIM_Reject,
     /* 2364766 */ // Label 32960: @2364766
     /* 2364766 */ GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2364880),
     /* 2364771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2364774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2364777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364789 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2364834), // Rule ID 56684 //
     /* 2364794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2364797 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2364814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364833 */     // GIR_Coverage, 56684,
     /* 2364833 */     GIR_EraseRootFromParent_Done,
     /* 2364834 */   // Label 33007: @2364834
     /* 2364834 */   GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2364879), // Rule ID 56685 //
     /* 2364839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2364842 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2364859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364878 */     // GIR_Coverage, 56685,
     /* 2364878 */     GIR_EraseRootFromParent_Done,
     /* 2364879 */   // Label 33008: @2364879
     /* 2364879 */   GIM_Reject,
     /* 2364880 */ // Label 33006: @2364880
     /* 2364880 */ GIM_Reject,
     /* 2364881 */ // Label 32961: @2364881
     /* 2364881 */ GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2364995),
     /* 2364886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2364889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2364892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364904 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2364949), // Rule ID 56708 //
     /* 2364909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2364912 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2364929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364948 */     // GIR_Coverage, 56708,
     /* 2364948 */     GIR_EraseRootFromParent_Done,
     /* 2364949 */   // Label 33010: @2364949
     /* 2364949 */   GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2364994), // Rule ID 56709 //
     /* 2364954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2364957 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2364974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364993 */     // GIR_Coverage, 56709,
     /* 2364993 */     GIR_EraseRootFromParent_Done,
     /* 2364994 */   // Label 33011: @2364994
     /* 2364994 */   GIM_Reject,
     /* 2364995 */ // Label 33009: @2364995
     /* 2364995 */ GIM_Reject,
     /* 2364996 */ // Label 32962: @2364996
     /* 2364996 */ GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2365110),
     /* 2365001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2365004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2365007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365019 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2365064), // Rule ID 56666 //
     /* 2365024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365027 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365063 */     // GIR_Coverage, 56666,
     /* 2365063 */     GIR_EraseRootFromParent_Done,
     /* 2365064 */   // Label 33013: @2365064
     /* 2365064 */   GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2365109), // Rule ID 56667 //
     /* 2365069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365072 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2365089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365108 */     // GIR_Coverage, 56667,
     /* 2365108 */     GIR_EraseRootFromParent_Done,
     /* 2365109 */   // Label 33014: @2365109
     /* 2365109 */   GIM_Reject,
     /* 2365110 */ // Label 33012: @2365110
     /* 2365110 */ GIM_Reject,
     /* 2365111 */ // Label 32963: @2365111
     /* 2365111 */ GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2365225),
     /* 2365116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2365119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2365122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365134 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2365179), // Rule ID 56690 //
     /* 2365139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2365142 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365178 */     // GIR_Coverage, 56690,
     /* 2365178 */     GIR_EraseRootFromParent_Done,
     /* 2365179 */   // Label 33016: @2365179
     /* 2365179 */   GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2365224), // Rule ID 56691 //
     /* 2365184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2365187 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2365204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365223 */     // GIR_Coverage, 56691,
     /* 2365223 */     GIR_EraseRootFromParent_Done,
     /* 2365224 */   // Label 33017: @2365224
     /* 2365224 */   GIM_Reject,
     /* 2365225 */ // Label 33015: @2365225
     /* 2365225 */ GIM_Reject,
     /* 2365226 */ // Label 32964: @2365226
     /* 2365226 */ GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2365340),
     /* 2365231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2365234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2365237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365249 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2365294), // Rule ID 56672 //
     /* 2365254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365257 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2365274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365293 */     // GIR_Coverage, 56672,
     /* 2365293 */     GIR_EraseRootFromParent_Done,
     /* 2365294 */   // Label 33019: @2365294
     /* 2365294 */   GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2365339), // Rule ID 56673 //
     /* 2365299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2365302 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2365319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365338 */     // GIR_Coverage, 56673,
     /* 2365338 */     GIR_EraseRootFromParent_Done,
     /* 2365339 */   // Label 33020: @2365339
     /* 2365339 */   GIM_Reject,
     /* 2365340 */ // Label 33018: @2365340
     /* 2365340 */ GIM_Reject,
     /* 2365341 */ // Label 32965: @2365341
     /* 2365341 */ GIM_Reject,
     /* 2365342 */ // Label 76: @2365342
     /* 2365342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33024*/ GIMT_Encode4(2365467),
     /* 2365353 */ /*GILLT_s16*//*Label 33021*/ GIMT_Encode4(2365365),
     /* 2365357 */ /*GILLT_s32*//*Label 33022*/ GIMT_Encode4(2365399),
     /* 2365361 */ /*GILLT_s64*//*Label 33023*/ GIMT_Encode4(2365433),
     /* 2365365 */ // Label 33021: @2365365
     /* 2365365 */ GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2365398), // Rule ID 2408 //
     /* 2365370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2365373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365391 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2365396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365397 */   // GIR_Coverage, 2408,
     /* 2365397 */   GIR_Done,
     /* 2365398 */ // Label 33025: @2365398
     /* 2365398 */ GIM_Reject,
     /* 2365399 */ // Label 33022: @2365399
     /* 2365399 */ GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2365432), // Rule ID 2326 //
     /* 2365404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2365407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365425 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2365430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365431 */   // GIR_Coverage, 2326,
     /* 2365431 */   GIR_Done,
     /* 2365432 */ // Label 33026: @2365432
     /* 2365432 */ GIM_Reject,
     /* 2365433 */ // Label 33023: @2365433
     /* 2365433 */ GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2365466), // Rule ID 2366 //
     /* 2365438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2365441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365459 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2365464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365465 */   // GIR_Coverage, 2366,
     /* 2365465 */   GIR_Done,
     /* 2365466 */ // Label 33027: @2365466
     /* 2365466 */ GIM_Reject,
     /* 2365467 */ // Label 33024: @2365467
     /* 2365467 */ GIM_Reject,
     /* 2365468 */ // Label 77: @2365468
     /* 2365468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33031*/ GIMT_Encode4(2365593),
     /* 2365479 */ /*GILLT_s16*//*Label 33028*/ GIMT_Encode4(2365491),
     /* 2365483 */ /*GILLT_s32*//*Label 33029*/ GIMT_Encode4(2365525),
     /* 2365487 */ /*GILLT_s64*//*Label 33030*/ GIMT_Encode4(2365559),
     /* 2365491 */ // Label 33028: @2365491
     /* 2365491 */ GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2365524), // Rule ID 2409 //
     /* 2365496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2365499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365517 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2365522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365523 */   // GIR_Coverage, 2409,
     /* 2365523 */   GIR_Done,
     /* 2365524 */ // Label 33032: @2365524
     /* 2365524 */ GIM_Reject,
     /* 2365525 */ // Label 33029: @2365525
     /* 2365525 */ GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2365558), // Rule ID 2327 //
     /* 2365530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2365533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365551 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2365556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365557 */   // GIR_Coverage, 2327,
     /* 2365557 */   GIR_Done,
     /* 2365558 */ // Label 33033: @2365558
     /* 2365558 */ GIM_Reject,
     /* 2365559 */ // Label 33030: @2365559
     /* 2365559 */ GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2365592), // Rule ID 2367 //
     /* 2365564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2365567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365585 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2365590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2365591 */   // GIR_Coverage, 2367,
     /* 2365591 */   GIR_Done,
     /* 2365592 */ // Label 33034: @2365592
     /* 2365592 */ GIM_Reject,
     /* 2365593 */ // Label 33031: @2365593
     /* 2365593 */ GIM_Reject,
     /* 2365594 */ // Label 78: @2365594
     /* 2365594 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33053*/ GIMT_Encode4(2367678),
     /* 2365605 */ /*GILLT_s16*//*Label 33035*/ GIMT_Encode4(2365725),
     /* 2365609 */ /*GILLT_s32*//*Label 33036*/ GIMT_Encode4(2365792),
     /* 2365613 */ /*GILLT_s64*//*Label 33037*/ GIMT_Encode4(2365859), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365625 */ /*GILLT_nxv1s16*//*Label 33038*/ GIMT_Encode4(2365953),
     /* 2365629 */ /*GILLT_nxv1s32*//*Label 33039*/ GIMT_Encode4(2366068),
     /* 2365633 */ /*GILLT_nxv1s64*//*Label 33040*/ GIMT_Encode4(2366183), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365645 */ /*GILLT_nxv2s16*//*Label 33041*/ GIMT_Encode4(2366298),
     /* 2365649 */ /*GILLT_nxv2s32*//*Label 33042*/ GIMT_Encode4(2366413),
     /* 2365653 */ /*GILLT_nxv2s64*//*Label 33043*/ GIMT_Encode4(2366528), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365665 */ /*GILLT_nxv4s16*//*Label 33044*/ GIMT_Encode4(2366643),
     /* 2365669 */ /*GILLT_nxv4s32*//*Label 33045*/ GIMT_Encode4(2366758),
     /* 2365673 */ /*GILLT_nxv4s64*//*Label 33046*/ GIMT_Encode4(2366873), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365685 */ /*GILLT_nxv8s16*//*Label 33047*/ GIMT_Encode4(2366988),
     /* 2365689 */ /*GILLT_nxv8s32*//*Label 33048*/ GIMT_Encode4(2367103),
     /* 2365693 */ /*GILLT_nxv8s64*//*Label 33049*/ GIMT_Encode4(2367218), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365705 */ /*GILLT_nxv16s16*//*Label 33050*/ GIMT_Encode4(2367333),
     /* 2365709 */ /*GILLT_nxv16s32*//*Label 33051*/ GIMT_Encode4(2367448), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2365721 */ /*GILLT_nxv32s16*//*Label 33052*/ GIMT_Encode4(2367563),
     /* 2365725 */ // Label 33035: @2365725
     /* 2365725 */ GIM_Try, /*On fail goto*//*Label 33054*/ GIMT_Encode4(2365791),
     /* 2365730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2365733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2365736 */   GIM_Try, /*On fail goto*//*Label 33055*/ GIMT_Encode4(2365763), // Rule ID 2058 //
     /* 2365741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2365744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2365756 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2365761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365762 */     // GIR_Coverage, 2058,
     /* 2365762 */     GIR_Done,
     /* 2365763 */   // Label 33055: @2365763
     /* 2365763 */   GIM_Try, /*On fail goto*//*Label 33056*/ GIMT_Encode4(2365790), // Rule ID 2059 //
     /* 2365768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2365771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2365783 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2365783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2365788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365789 */     // GIR_Coverage, 2059,
     /* 2365789 */     GIR_Done,
     /* 2365790 */   // Label 33056: @2365790
     /* 2365790 */   GIM_Reject,
     /* 2365791 */ // Label 33054: @2365791
     /* 2365791 */ GIM_Reject,
     /* 2365792 */ // Label 33036: @2365792
     /* 2365792 */ GIM_Try, /*On fail goto*//*Label 33057*/ GIMT_Encode4(2365858),
     /* 2365797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2365803 */   GIM_Try, /*On fail goto*//*Label 33058*/ GIMT_Encode4(2365830), // Rule ID 1345 //
     /* 2365808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2365811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2365823 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2365828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365829 */     // GIR_Coverage, 1345,
     /* 2365829 */     GIR_Done,
     /* 2365830 */   // Label 33058: @2365830
     /* 2365830 */   GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2365857), // Rule ID 1346 //
     /* 2365835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2365838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2365850 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2365850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2365855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365856 */     // GIR_Coverage, 1346,
     /* 2365856 */     GIR_Done,
     /* 2365857 */   // Label 33059: @2365857
     /* 2365857 */   GIM_Reject,
     /* 2365858 */ // Label 33057: @2365858
     /* 2365858 */ GIM_Reject,
     /* 2365859 */ // Label 33037: @2365859
     /* 2365859 */ GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2365952),
     /* 2365864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2365870 */   GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2365897), // Rule ID 1718 //
     /* 2365875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2365878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2365890 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2365895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365896 */     // GIR_Coverage, 1718,
     /* 2365896 */     GIR_Done,
     /* 2365897 */   // Label 33061: @2365897
     /* 2365897 */   GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2365924), // Rule ID 1719 //
     /* 2365902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2365905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2365917 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2365922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365923 */     // GIR_Coverage, 1719,
     /* 2365923 */     GIR_Done,
     /* 2365924 */   // Label 33062: @2365924
     /* 2365924 */   GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2365951), // Rule ID 1720 //
     /* 2365929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2365932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365944 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2365944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2365949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365950 */     // GIR_Coverage, 1720,
     /* 2365950 */     GIR_Done,
     /* 2365951 */   // Label 33063: @2365951
     /* 2365951 */   GIM_Reject,
     /* 2365952 */ // Label 33060: @2365952
     /* 2365952 */ GIM_Reject,
     /* 2365953 */ // Label 33038: @2365953
     /* 2365953 */ GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2366067),
     /* 2365958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2365961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2365964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365976 */   GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2366021), // Rule ID 56714 //
     /* 2365981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2365984 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2365987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2366001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366020 */     // GIR_Coverage, 56714,
     /* 2366020 */     GIR_EraseRootFromParent_Done,
     /* 2366021 */   // Label 33065: @2366021
     /* 2366021 */   GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2366066), // Rule ID 56715 //
     /* 2366026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366029 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2366046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366065 */     // GIR_Coverage, 56715,
     /* 2366065 */     GIR_EraseRootFromParent_Done,
     /* 2366066 */   // Label 33066: @2366066
     /* 2366066 */   GIM_Reject,
     /* 2366067 */ // Label 33064: @2366067
     /* 2366067 */ GIM_Reject,
     /* 2366068 */ // Label 33039: @2366068
     /* 2366068 */ GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2366182),
     /* 2366073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2366076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2366079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366091 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2366136), // Rule ID 56726 //
     /* 2366096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366099 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2366116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366135 */     // GIR_Coverage, 56726,
     /* 2366135 */     GIR_EraseRootFromParent_Done,
     /* 2366136 */   // Label 33068: @2366136
     /* 2366136 */   GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2366181), // Rule ID 56727 //
     /* 2366141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366144 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2366161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366180 */     // GIR_Coverage, 56727,
     /* 2366180 */     GIR_EraseRootFromParent_Done,
     /* 2366181 */   // Label 33069: @2366181
     /* 2366181 */   GIM_Reject,
     /* 2366182 */ // Label 33067: @2366182
     /* 2366182 */ GIM_Reject,
     /* 2366183 */ // Label 33040: @2366183
     /* 2366183 */ GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2366297),
     /* 2366188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2366191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2366194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366206 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2366251), // Rule ID 56744 //
     /* 2366211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366214 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2366231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366250 */     // GIR_Coverage, 56744,
     /* 2366250 */     GIR_EraseRootFromParent_Done,
     /* 2366251 */   // Label 33071: @2366251
     /* 2366251 */   GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2366296), // Rule ID 56745 //
     /* 2366256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366259 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2366276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366295 */     // GIR_Coverage, 56745,
     /* 2366295 */     GIR_EraseRootFromParent_Done,
     /* 2366296 */   // Label 33072: @2366296
     /* 2366296 */   GIM_Reject,
     /* 2366297 */ // Label 33070: @2366297
     /* 2366297 */ GIM_Reject,
     /* 2366298 */ // Label 33041: @2366298
     /* 2366298 */ GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2366412),
     /* 2366303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2366306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2366309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366321 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2366366), // Rule ID 56720 //
     /* 2366326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2366329 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2366346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366365 */     // GIR_Coverage, 56720,
     /* 2366365 */     GIR_EraseRootFromParent_Done,
     /* 2366366 */   // Label 33074: @2366366
     /* 2366366 */   GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2366411), // Rule ID 56721 //
     /* 2366371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366374 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2366391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366410 */     // GIR_Coverage, 56721,
     /* 2366410 */     GIR_EraseRootFromParent_Done,
     /* 2366411 */   // Label 33075: @2366411
     /* 2366411 */   GIM_Reject,
     /* 2366412 */ // Label 33073: @2366412
     /* 2366412 */ GIM_Reject,
     /* 2366413 */ // Label 33042: @2366413
     /* 2366413 */ GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2366527),
     /* 2366418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2366421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2366424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366436 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2366481), // Rule ID 56738 //
     /* 2366441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366444 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2366461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366480 */     // GIR_Coverage, 56738,
     /* 2366480 */     GIR_EraseRootFromParent_Done,
     /* 2366481 */   // Label 33077: @2366481
     /* 2366481 */   GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2366526), // Rule ID 56739 //
     /* 2366486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366489 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2366506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366525 */     // GIR_Coverage, 56739,
     /* 2366525 */     GIR_EraseRootFromParent_Done,
     /* 2366526 */   // Label 33078: @2366526
     /* 2366526 */   GIM_Reject,
     /* 2366527 */ // Label 33076: @2366527
     /* 2366527 */ GIM_Reject,
     /* 2366528 */ // Label 33043: @2366528
     /* 2366528 */ GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2366642),
     /* 2366533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2366536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2366539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366551 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2366596), // Rule ID 56786 //
     /* 2366556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366559 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2366576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366595 */     // GIR_Coverage, 56786,
     /* 2366595 */     GIR_EraseRootFromParent_Done,
     /* 2366596 */   // Label 33080: @2366596
     /* 2366596 */   GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2366641), // Rule ID 56787 //
     /* 2366601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366604 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2366621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366640 */     // GIR_Coverage, 56787,
     /* 2366640 */     GIR_EraseRootFromParent_Done,
     /* 2366641 */   // Label 33081: @2366641
     /* 2366641 */   GIM_Reject,
     /* 2366642 */ // Label 33079: @2366642
     /* 2366642 */ GIM_Reject,
     /* 2366643 */ // Label 33044: @2366643
     /* 2366643 */ GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2366757),
     /* 2366648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2366651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2366654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366666 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2366711), // Rule ID 56732 //
     /* 2366671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2366674 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2366691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366710 */     // GIR_Coverage, 56732,
     /* 2366710 */     GIR_EraseRootFromParent_Done,
     /* 2366711 */   // Label 33083: @2366711
     /* 2366711 */   GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2366756), // Rule ID 56733 //
     /* 2366716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2366719 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2366736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366755 */     // GIR_Coverage, 56733,
     /* 2366755 */     GIR_EraseRootFromParent_Done,
     /* 2366756 */   // Label 33084: @2366756
     /* 2366756 */   GIM_Reject,
     /* 2366757 */ // Label 33082: @2366757
     /* 2366757 */ GIM_Reject,
     /* 2366758 */ // Label 33045: @2366758
     /* 2366758 */ GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2366872),
     /* 2366763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2366766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2366769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366781 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2366826), // Rule ID 56768 //
     /* 2366786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2366789 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2366806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366825 */     // GIR_Coverage, 56768,
     /* 2366825 */     GIR_EraseRootFromParent_Done,
     /* 2366826 */   // Label 33086: @2366826
     /* 2366826 */   GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2366871), // Rule ID 56769 //
     /* 2366831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2366834 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2366851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366870 */     // GIR_Coverage, 56769,
     /* 2366870 */     GIR_EraseRootFromParent_Done,
     /* 2366871 */   // Label 33087: @2366871
     /* 2366871 */   GIM_Reject,
     /* 2366872 */ // Label 33085: @2366872
     /* 2366872 */ GIM_Reject,
     /* 2366873 */ // Label 33046: @2366873
     /* 2366873 */ GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2366987),
     /* 2366878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2366881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2366884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366896 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2366941), // Rule ID 56792 //
     /* 2366901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2366904 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2366921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366940 */     // GIR_Coverage, 56792,
     /* 2366940 */     GIR_EraseRootFromParent_Done,
     /* 2366941 */   // Label 33089: @2366941
     /* 2366941 */   GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2366986), // Rule ID 56793 //
     /* 2366946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2366949 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2366966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366985 */     // GIR_Coverage, 56793,
     /* 2366985 */     GIR_EraseRootFromParent_Done,
     /* 2366986 */   // Label 33090: @2366986
     /* 2366986 */   GIM_Reject,
     /* 2366987 */ // Label 33088: @2366987
     /* 2366987 */ GIM_Reject,
     /* 2366988 */ // Label 33047: @2366988
     /* 2366988 */ GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2367102),
     /* 2366993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2366996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2366999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367011 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2367056), // Rule ID 56750 //
     /* 2367016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367019 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2367036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367055 */     // GIR_Coverage, 56750,
     /* 2367055 */     GIR_EraseRootFromParent_Done,
     /* 2367056 */   // Label 33092: @2367056
     /* 2367056 */   GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2367101), // Rule ID 56751 //
     /* 2367061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367064 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2367081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367100 */     // GIR_Coverage, 56751,
     /* 2367100 */     GIR_EraseRootFromParent_Done,
     /* 2367101 */   // Label 33093: @2367101
     /* 2367101 */   GIM_Reject,
     /* 2367102 */ // Label 33091: @2367102
     /* 2367102 */ GIM_Reject,
     /* 2367103 */ // Label 33048: @2367103
     /* 2367103 */ GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2367217),
     /* 2367108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2367111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2367114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367126 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2367171), // Rule ID 56774 //
     /* 2367131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2367134 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2367151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367170 */     // GIR_Coverage, 56774,
     /* 2367170 */     GIR_EraseRootFromParent_Done,
     /* 2367171 */   // Label 33095: @2367171
     /* 2367171 */   GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2367216), // Rule ID 56775 //
     /* 2367176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2367179 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2367196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367215 */     // GIR_Coverage, 56775,
     /* 2367215 */     GIR_EraseRootFromParent_Done,
     /* 2367216 */   // Label 33096: @2367216
     /* 2367216 */   GIM_Reject,
     /* 2367217 */ // Label 33094: @2367217
     /* 2367217 */ GIM_Reject,
     /* 2367218 */ // Label 33049: @2367218
     /* 2367218 */ GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2367332),
     /* 2367223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2367226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2367229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367241 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2367286), // Rule ID 56798 //
     /* 2367246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2367249 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2367266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367285 */     // GIR_Coverage, 56798,
     /* 2367285 */     GIR_EraseRootFromParent_Done,
     /* 2367286 */   // Label 33098: @2367286
     /* 2367286 */   GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2367331), // Rule ID 56799 //
     /* 2367291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2367294 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2367311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367330 */     // GIR_Coverage, 56799,
     /* 2367330 */     GIR_EraseRootFromParent_Done,
     /* 2367331 */   // Label 33099: @2367331
     /* 2367331 */   GIM_Reject,
     /* 2367332 */ // Label 33097: @2367332
     /* 2367332 */ GIM_Reject,
     /* 2367333 */ // Label 33050: @2367333
     /* 2367333 */ GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2367447),
     /* 2367338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2367341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2367344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367356 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2367401), // Rule ID 56756 //
     /* 2367361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367364 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2367381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367400 */     // GIR_Coverage, 56756,
     /* 2367400 */     GIR_EraseRootFromParent_Done,
     /* 2367401 */   // Label 33101: @2367401
     /* 2367401 */   GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2367446), // Rule ID 56757 //
     /* 2367406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367409 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2367426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367445 */     // GIR_Coverage, 56757,
     /* 2367445 */     GIR_EraseRootFromParent_Done,
     /* 2367446 */   // Label 33102: @2367446
     /* 2367446 */   GIM_Reject,
     /* 2367447 */ // Label 33100: @2367447
     /* 2367447 */ GIM_Reject,
     /* 2367448 */ // Label 33051: @2367448
     /* 2367448 */ GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2367562),
     /* 2367453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2367456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2367459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367471 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2367516), // Rule ID 56780 //
     /* 2367476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2367479 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2367496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367515 */     // GIR_Coverage, 56780,
     /* 2367515 */     GIR_EraseRootFromParent_Done,
     /* 2367516 */   // Label 33104: @2367516
     /* 2367516 */   GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2367561), // Rule ID 56781 //
     /* 2367521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2367524 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2367541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367560 */     // GIR_Coverage, 56781,
     /* 2367560 */     GIR_EraseRootFromParent_Done,
     /* 2367561 */   // Label 33105: @2367561
     /* 2367561 */   GIM_Reject,
     /* 2367562 */ // Label 33103: @2367562
     /* 2367562 */ GIM_Reject,
     /* 2367563 */ // Label 33052: @2367563
     /* 2367563 */ GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2367677),
     /* 2367568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2367571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2367574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367586 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2367631), // Rule ID 56762 //
     /* 2367591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2367594 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2367611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367630 */     // GIR_Coverage, 56762,
     /* 2367630 */     GIR_EraseRootFromParent_Done,
     /* 2367631 */   // Label 33107: @2367631
     /* 2367631 */   GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2367676), // Rule ID 56763 //
     /* 2367636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2367639 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2367656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367675 */     // GIR_Coverage, 56763,
     /* 2367675 */     GIR_EraseRootFromParent_Done,
     /* 2367676 */   // Label 33108: @2367676
     /* 2367676 */   GIM_Reject,
     /* 2367677 */ // Label 33106: @2367677
     /* 2367677 */ GIM_Reject,
     /* 2367678 */ // Label 33053: @2367678
     /* 2367678 */ GIM_Reject,
     /* 2367679 */ // Label 79: @2367679
     /* 2367679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33127*/ GIMT_Encode4(2369763),
     /* 2367690 */ /*GILLT_s16*//*Label 33109*/ GIMT_Encode4(2367810),
     /* 2367694 */ /*GILLT_s32*//*Label 33110*/ GIMT_Encode4(2367877),
     /* 2367698 */ /*GILLT_s64*//*Label 33111*/ GIMT_Encode4(2367944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367710 */ /*GILLT_nxv1s16*//*Label 33112*/ GIMT_Encode4(2368038),
     /* 2367714 */ /*GILLT_nxv1s32*//*Label 33113*/ GIMT_Encode4(2368153),
     /* 2367718 */ /*GILLT_nxv1s64*//*Label 33114*/ GIMT_Encode4(2368268), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367730 */ /*GILLT_nxv2s16*//*Label 33115*/ GIMT_Encode4(2368383),
     /* 2367734 */ /*GILLT_nxv2s32*//*Label 33116*/ GIMT_Encode4(2368498),
     /* 2367738 */ /*GILLT_nxv2s64*//*Label 33117*/ GIMT_Encode4(2368613), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367750 */ /*GILLT_nxv4s16*//*Label 33118*/ GIMT_Encode4(2368728),
     /* 2367754 */ /*GILLT_nxv4s32*//*Label 33119*/ GIMT_Encode4(2368843),
     /* 2367758 */ /*GILLT_nxv4s64*//*Label 33120*/ GIMT_Encode4(2368958), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367770 */ /*GILLT_nxv8s16*//*Label 33121*/ GIMT_Encode4(2369073),
     /* 2367774 */ /*GILLT_nxv8s32*//*Label 33122*/ GIMT_Encode4(2369188),
     /* 2367778 */ /*GILLT_nxv8s64*//*Label 33123*/ GIMT_Encode4(2369303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367790 */ /*GILLT_nxv16s16*//*Label 33124*/ GIMT_Encode4(2369418),
     /* 2367794 */ /*GILLT_nxv16s32*//*Label 33125*/ GIMT_Encode4(2369533), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2367806 */ /*GILLT_nxv32s16*//*Label 33126*/ GIMT_Encode4(2369648),
     /* 2367810 */ // Label 33109: @2367810
     /* 2367810 */ GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2367876),
     /* 2367815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2367818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2367821 */   GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2367848), // Rule ID 2060 //
     /* 2367826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2367829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2367841 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2367841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2367846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367847 */     // GIR_Coverage, 2060,
     /* 2367847 */     GIR_Done,
     /* 2367848 */   // Label 33129: @2367848
     /* 2367848 */   GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2367875), // Rule ID 2061 //
     /* 2367853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2367856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2367868 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2367868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2367873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367874 */     // GIR_Coverage, 2061,
     /* 2367874 */     GIR_Done,
     /* 2367875 */   // Label 33130: @2367875
     /* 2367875 */   GIM_Reject,
     /* 2367876 */ // Label 33128: @2367876
     /* 2367876 */ GIM_Reject,
     /* 2367877 */ // Label 33110: @2367877
     /* 2367877 */ GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2367943),
     /* 2367882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2367885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2367888 */   GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2367915), // Rule ID 1347 //
     /* 2367893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2367896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2367908 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2367908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2367913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367914 */     // GIR_Coverage, 1347,
     /* 2367914 */     GIR_Done,
     /* 2367915 */   // Label 33132: @2367915
     /* 2367915 */   GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2367942), // Rule ID 1348 //
     /* 2367920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2367923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2367935 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2367935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2367940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367941 */     // GIR_Coverage, 1348,
     /* 2367941 */     GIR_Done,
     /* 2367942 */   // Label 33133: @2367942
     /* 2367942 */   GIM_Reject,
     /* 2367943 */ // Label 33131: @2367943
     /* 2367943 */ GIM_Reject,
     /* 2367944 */ // Label 33111: @2367944
     /* 2367944 */ GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2368037),
     /* 2367949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2367952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2367955 */   GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2367982), // Rule ID 1721 //
     /* 2367960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2367963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2367975 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2367975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2367980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367981 */     // GIR_Coverage, 1721,
     /* 2367981 */     GIR_Done,
     /* 2367982 */   // Label 33135: @2367982
     /* 2367982 */   GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2368009), // Rule ID 1722 //
     /* 2367987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2367990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2367994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2367998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2368002 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2368002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2368007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368008 */     // GIR_Coverage, 1722,
     /* 2368008 */     GIR_Done,
     /* 2368009 */   // Label 33136: @2368009
     /* 2368009 */   GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2368036), // Rule ID 1723 //
     /* 2368014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2368017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368029 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2368029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2368034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368035 */     // GIR_Coverage, 1723,
     /* 2368035 */     GIR_Done,
     /* 2368036 */   // Label 33137: @2368036
     /* 2368036 */   GIM_Reject,
     /* 2368037 */ // Label 33134: @2368037
     /* 2368037 */ GIM_Reject,
     /* 2368038 */ // Label 33112: @2368038
     /* 2368038 */ GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2368152),
     /* 2368043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2368046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2368049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368061 */   GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2368106), // Rule ID 56804 //
     /* 2368066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368069 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2368086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368105 */     // GIR_Coverage, 56804,
     /* 2368105 */     GIR_EraseRootFromParent_Done,
     /* 2368106 */   // Label 33139: @2368106
     /* 2368106 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2368151), // Rule ID 56805 //
     /* 2368111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368114 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2368131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368150 */     // GIR_Coverage, 56805,
     /* 2368150 */     GIR_EraseRootFromParent_Done,
     /* 2368151 */   // Label 33140: @2368151
     /* 2368151 */   GIM_Reject,
     /* 2368152 */ // Label 33138: @2368152
     /* 2368152 */ GIM_Reject,
     /* 2368153 */ // Label 33113: @2368153
     /* 2368153 */ GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2368267),
     /* 2368158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2368161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2368164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368176 */   GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2368221), // Rule ID 56816 //
     /* 2368181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368184 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2368201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368220 */     // GIR_Coverage, 56816,
     /* 2368220 */     GIR_EraseRootFromParent_Done,
     /* 2368221 */   // Label 33142: @2368221
     /* 2368221 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2368266), // Rule ID 56817 //
     /* 2368226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368229 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2368246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368265 */     // GIR_Coverage, 56817,
     /* 2368265 */     GIR_EraseRootFromParent_Done,
     /* 2368266 */   // Label 33143: @2368266
     /* 2368266 */   GIM_Reject,
     /* 2368267 */ // Label 33141: @2368267
     /* 2368267 */ GIM_Reject,
     /* 2368268 */ // Label 33114: @2368268
     /* 2368268 */ GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2368382),
     /* 2368273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2368276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2368279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368291 */   GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2368336), // Rule ID 56834 //
     /* 2368296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368299 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2368316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368335 */     // GIR_Coverage, 56834,
     /* 2368335 */     GIR_EraseRootFromParent_Done,
     /* 2368336 */   // Label 33145: @2368336
     /* 2368336 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2368381), // Rule ID 56835 //
     /* 2368341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2368344 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2368361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368380 */     // GIR_Coverage, 56835,
     /* 2368380 */     GIR_EraseRootFromParent_Done,
     /* 2368381 */   // Label 33146: @2368381
     /* 2368381 */   GIM_Reject,
     /* 2368382 */ // Label 33144: @2368382
     /* 2368382 */ GIM_Reject,
     /* 2368383 */ // Label 33115: @2368383
     /* 2368383 */ GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2368497),
     /* 2368388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2368391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2368394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368406 */   GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2368451), // Rule ID 56810 //
     /* 2368411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368414 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2368431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368450 */     // GIR_Coverage, 56810,
     /* 2368450 */     GIR_EraseRootFromParent_Done,
     /* 2368451 */   // Label 33148: @2368451
     /* 2368451 */   GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2368496), // Rule ID 56811 //
     /* 2368456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368459 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2368476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368495 */     // GIR_Coverage, 56811,
     /* 2368495 */     GIR_EraseRootFromParent_Done,
     /* 2368496 */   // Label 33149: @2368496
     /* 2368496 */   GIM_Reject,
     /* 2368497 */ // Label 33147: @2368497
     /* 2368497 */ GIM_Reject,
     /* 2368498 */ // Label 33116: @2368498
     /* 2368498 */ GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2368612),
     /* 2368503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2368506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2368509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368521 */   GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2368566), // Rule ID 56828 //
     /* 2368526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368529 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2368546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368565 */     // GIR_Coverage, 56828,
     /* 2368565 */     GIR_EraseRootFromParent_Done,
     /* 2368566 */   // Label 33151: @2368566
     /* 2368566 */   GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2368611), // Rule ID 56829 //
     /* 2368571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368574 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2368591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368610 */     // GIR_Coverage, 56829,
     /* 2368610 */     GIR_EraseRootFromParent_Done,
     /* 2368611 */   // Label 33152: @2368611
     /* 2368611 */   GIM_Reject,
     /* 2368612 */ // Label 33150: @2368612
     /* 2368612 */ GIM_Reject,
     /* 2368613 */ // Label 33117: @2368613
     /* 2368613 */ GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2368727),
     /* 2368618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2368621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2368624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368636 */   GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2368681), // Rule ID 56876 //
     /* 2368641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368644 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2368661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368680 */     // GIR_Coverage, 56876,
     /* 2368680 */     GIR_EraseRootFromParent_Done,
     /* 2368681 */   // Label 33154: @2368681
     /* 2368681 */   GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2368726), // Rule ID 56877 //
     /* 2368686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2368689 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2368706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368725 */     // GIR_Coverage, 56877,
     /* 2368725 */     GIR_EraseRootFromParent_Done,
     /* 2368726 */   // Label 33155: @2368726
     /* 2368726 */   GIM_Reject,
     /* 2368727 */ // Label 33153: @2368727
     /* 2368727 */ GIM_Reject,
     /* 2368728 */ // Label 33118: @2368728
     /* 2368728 */ GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2368842),
     /* 2368733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2368736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2368739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368751 */   GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2368796), // Rule ID 56822 //
     /* 2368756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2368759 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2368776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368795 */     // GIR_Coverage, 56822,
     /* 2368795 */     GIR_EraseRootFromParent_Done,
     /* 2368796 */   // Label 33157: @2368796
     /* 2368796 */   GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2368841), // Rule ID 56823 //
     /* 2368801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2368804 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2368821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368840 */     // GIR_Coverage, 56823,
     /* 2368840 */     GIR_EraseRootFromParent_Done,
     /* 2368841 */   // Label 33158: @2368841
     /* 2368841 */   GIM_Reject,
     /* 2368842 */ // Label 33156: @2368842
     /* 2368842 */ GIM_Reject,
     /* 2368843 */ // Label 33119: @2368843
     /* 2368843 */ GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2368957),
     /* 2368848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2368851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2368854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368866 */   GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2368911), // Rule ID 56858 //
     /* 2368871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2368874 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2368891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368910 */     // GIR_Coverage, 56858,
     /* 2368910 */     GIR_EraseRootFromParent_Done,
     /* 2368911 */   // Label 33160: @2368911
     /* 2368911 */   GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2368956), // Rule ID 56859 //
     /* 2368916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2368919 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2368936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368955 */     // GIR_Coverage, 56859,
     /* 2368955 */     GIR_EraseRootFromParent_Done,
     /* 2368956 */   // Label 33161: @2368956
     /* 2368956 */   GIM_Reject,
     /* 2368957 */ // Label 33159: @2368957
     /* 2368957 */ GIM_Reject,
     /* 2368958 */ // Label 33120: @2368958
     /* 2368958 */ GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2369072),
     /* 2368963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2368966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2368969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368981 */   GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2369026), // Rule ID 56882 //
     /* 2368986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2368989 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2368992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2369006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369025 */     // GIR_Coverage, 56882,
     /* 2369025 */     GIR_EraseRootFromParent_Done,
     /* 2369026 */   // Label 33163: @2369026
     /* 2369026 */   GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2369071), // Rule ID 56883 //
     /* 2369031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2369034 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2369037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2369051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369070 */     // GIR_Coverage, 56883,
     /* 2369070 */     GIR_EraseRootFromParent_Done,
     /* 2369071 */   // Label 33164: @2369071
     /* 2369071 */   GIM_Reject,
     /* 2369072 */ // Label 33162: @2369072
     /* 2369072 */ GIM_Reject,
     /* 2369073 */ // Label 33121: @2369073
     /* 2369073 */ GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2369187),
     /* 2369078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2369081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2369084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369096 */   GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2369141), // Rule ID 56840 //
     /* 2369101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369104 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2369121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369140 */     // GIR_Coverage, 56840,
     /* 2369140 */     GIR_EraseRootFromParent_Done,
     /* 2369141 */   // Label 33166: @2369141
     /* 2369141 */   GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2369186), // Rule ID 56841 //
     /* 2369146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369149 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2369166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369185 */     // GIR_Coverage, 56841,
     /* 2369185 */     GIR_EraseRootFromParent_Done,
     /* 2369186 */   // Label 33167: @2369186
     /* 2369186 */   GIM_Reject,
     /* 2369187 */ // Label 33165: @2369187
     /* 2369187 */ GIM_Reject,
     /* 2369188 */ // Label 33122: @2369188
     /* 2369188 */ GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2369302),
     /* 2369193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2369196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2369199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369211 */   GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2369256), // Rule ID 56864 //
     /* 2369216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2369219 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2369236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369255 */     // GIR_Coverage, 56864,
     /* 2369255 */     GIR_EraseRootFromParent_Done,
     /* 2369256 */   // Label 33169: @2369256
     /* 2369256 */   GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2369301), // Rule ID 56865 //
     /* 2369261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2369264 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2369281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369300 */     // GIR_Coverage, 56865,
     /* 2369300 */     GIR_EraseRootFromParent_Done,
     /* 2369301 */   // Label 33170: @2369301
     /* 2369301 */   GIM_Reject,
     /* 2369302 */ // Label 33168: @2369302
     /* 2369302 */ GIM_Reject,
     /* 2369303 */ // Label 33123: @2369303
     /* 2369303 */ GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2369417),
     /* 2369308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2369311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2369314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369326 */   GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2369371), // Rule ID 56888 //
     /* 2369331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2369334 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2369351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369370 */     // GIR_Coverage, 56888,
     /* 2369370 */     GIR_EraseRootFromParent_Done,
     /* 2369371 */   // Label 33172: @2369371
     /* 2369371 */   GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2369416), // Rule ID 56889 //
     /* 2369376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2369379 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2369396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369415 */     // GIR_Coverage, 56889,
     /* 2369415 */     GIR_EraseRootFromParent_Done,
     /* 2369416 */   // Label 33173: @2369416
     /* 2369416 */   GIM_Reject,
     /* 2369417 */ // Label 33171: @2369417
     /* 2369417 */ GIM_Reject,
     /* 2369418 */ // Label 33124: @2369418
     /* 2369418 */ GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2369532),
     /* 2369423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2369426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2369429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369441 */   GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2369486), // Rule ID 56846 //
     /* 2369446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369449 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2369466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369485 */     // GIR_Coverage, 56846,
     /* 2369485 */     GIR_EraseRootFromParent_Done,
     /* 2369486 */   // Label 33175: @2369486
     /* 2369486 */   GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2369531), // Rule ID 56847 //
     /* 2369491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369494 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2369511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369530 */     // GIR_Coverage, 56847,
     /* 2369530 */     GIR_EraseRootFromParent_Done,
     /* 2369531 */   // Label 33176: @2369531
     /* 2369531 */   GIM_Reject,
     /* 2369532 */ // Label 33174: @2369532
     /* 2369532 */ GIM_Reject,
     /* 2369533 */ // Label 33125: @2369533
     /* 2369533 */ GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2369647),
     /* 2369538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2369541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2369544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369556 */   GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2369601), // Rule ID 56870 //
     /* 2369561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2369564 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2369581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369600 */     // GIR_Coverage, 56870,
     /* 2369600 */     GIR_EraseRootFromParent_Done,
     /* 2369601 */   // Label 33178: @2369601
     /* 2369601 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2369646), // Rule ID 56871 //
     /* 2369606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2369609 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2369626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369645 */     // GIR_Coverage, 56871,
     /* 2369645 */     GIR_EraseRootFromParent_Done,
     /* 2369646 */   // Label 33179: @2369646
     /* 2369646 */   GIM_Reject,
     /* 2369647 */ // Label 33177: @2369647
     /* 2369647 */ GIM_Reject,
     /* 2369648 */ // Label 33126: @2369648
     /* 2369648 */ GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2369762),
     /* 2369653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2369656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2369659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369671 */   GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2369716), // Rule ID 56852 //
     /* 2369676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2369679 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2369696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369715 */     // GIR_Coverage, 56852,
     /* 2369715 */     GIR_EraseRootFromParent_Done,
     /* 2369716 */   // Label 33181: @2369716
     /* 2369716 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2369761), // Rule ID 56853 //
     /* 2369721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2369724 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2369741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369760 */     // GIR_Coverage, 56853,
     /* 2369760 */     GIR_EraseRootFromParent_Done,
     /* 2369761 */   // Label 33182: @2369761
     /* 2369761 */   GIM_Reject,
     /* 2369762 */ // Label 33180: @2369762
     /* 2369762 */ GIM_Reject,
     /* 2369763 */ // Label 33127: @2369763
     /* 2369763 */ GIM_Reject,
     /* 2369764 */ // Label 80: @2369764
     /* 2369764 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33207*/ GIMT_Encode4(2372539),
     /* 2369775 */ /*GILLT_s32*//*Label 33183*/ GIMT_Encode4(2369899),
     /* 2369779 */ /*GILLT_s64*//*Label 33184*/ GIMT_Encode4(2369954), GIMT_Encode4(0),
     /* 2369787 */ /*GILLT_nxv1s8*//*Label 33185*/ GIMT_Encode4(2370009),
     /* 2369791 */ /*GILLT_nxv1s16*//*Label 33186*/ GIMT_Encode4(2370124),
     /* 2369795 */ /*GILLT_nxv1s32*//*Label 33187*/ GIMT_Encode4(2370239),
     /* 2369799 */ /*GILLT_nxv1s64*//*Label 33188*/ GIMT_Encode4(2370354), GIMT_Encode4(0),
     /* 2369807 */ /*GILLT_nxv2s8*//*Label 33189*/ GIMT_Encode4(2370469),
     /* 2369811 */ /*GILLT_nxv2s16*//*Label 33190*/ GIMT_Encode4(2370584),
     /* 2369815 */ /*GILLT_nxv2s32*//*Label 33191*/ GIMT_Encode4(2370699),
     /* 2369819 */ /*GILLT_nxv2s64*//*Label 33192*/ GIMT_Encode4(2370814), GIMT_Encode4(0),
     /* 2369827 */ /*GILLT_nxv4s8*//*Label 33193*/ GIMT_Encode4(2370929),
     /* 2369831 */ /*GILLT_nxv4s16*//*Label 33194*/ GIMT_Encode4(2371044),
     /* 2369835 */ /*GILLT_nxv4s32*//*Label 33195*/ GIMT_Encode4(2371159),
     /* 2369839 */ /*GILLT_nxv4s64*//*Label 33196*/ GIMT_Encode4(2371274), GIMT_Encode4(0),
     /* 2369847 */ /*GILLT_nxv8s8*//*Label 33197*/ GIMT_Encode4(2371389),
     /* 2369851 */ /*GILLT_nxv8s16*//*Label 33198*/ GIMT_Encode4(2371504),
     /* 2369855 */ /*GILLT_nxv8s32*//*Label 33199*/ GIMT_Encode4(2371619),
     /* 2369859 */ /*GILLT_nxv8s64*//*Label 33200*/ GIMT_Encode4(2371734), GIMT_Encode4(0),
     /* 2369867 */ /*GILLT_nxv16s8*//*Label 33201*/ GIMT_Encode4(2371849),
     /* 2369871 */ /*GILLT_nxv16s16*//*Label 33202*/ GIMT_Encode4(2371964),
     /* 2369875 */ /*GILLT_nxv16s32*//*Label 33203*/ GIMT_Encode4(2372079), GIMT_Encode4(0),
     /* 2369883 */ /*GILLT_nxv32s8*//*Label 33204*/ GIMT_Encode4(2372194),
     /* 2369887 */ /*GILLT_nxv32s16*//*Label 33205*/ GIMT_Encode4(2372309), GIMT_Encode4(0),
     /* 2369895 */ /*GILLT_nxv64s8*//*Label 33206*/ GIMT_Encode4(2372424),
     /* 2369899 */ // Label 33183: @2369899
     /* 2369899 */ GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2369953),
     /* 2369904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2369907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2369910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369922 */   GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2369937), // Rule ID 64466 //
     /* 2369927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2369930 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2369935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369936 */     // GIR_Coverage, 64466,
     /* 2369936 */     GIR_Done,
     /* 2369937 */   // Label 33209: @2369937
     /* 2369937 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2369952), // Rule ID 2531 //
     /* 2369942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2369945 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2369950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369951 */     // GIR_Coverage, 2531,
     /* 2369951 */     GIR_Done,
     /* 2369952 */   // Label 33210: @2369952
     /* 2369952 */   GIM_Reject,
     /* 2369953 */ // Label 33208: @2369953
     /* 2369953 */ GIM_Reject,
     /* 2369954 */ // Label 33184: @2369954
     /* 2369954 */ GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2370008),
     /* 2369959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2369962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2369965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369977 */   GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2369992), // Rule ID 64465 //
     /* 2369982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2369985 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2369990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369991 */     // GIR_Coverage, 64465,
     /* 2369991 */     GIR_Done,
     /* 2369992 */   // Label 33212: @2369992
     /* 2369992 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2370007), // Rule ID 2530 //
     /* 2369997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2370000 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2370000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2370005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370006 */     // GIR_Coverage, 2530,
     /* 2370006 */     GIR_Done,
     /* 2370007 */   // Label 33213: @2370007
     /* 2370007 */   GIM_Reject,
     /* 2370008 */ // Label 33211: @2370008
     /* 2370008 */ GIM_Reject,
     /* 2370009 */ // Label 33185: @2370009
     /* 2370009 */ GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2370123),
     /* 2370014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2370017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2370020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370032 */   GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2370077), // Rule ID 50596 //
     /* 2370037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370040 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2370057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370076 */     // GIR_Coverage, 50596,
     /* 2370076 */     GIR_EraseRootFromParent_Done,
     /* 2370077 */   // Label 33215: @2370077
     /* 2370077 */   GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2370122), // Rule ID 50597 //
     /* 2370082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370085 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2370102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370121 */     // GIR_Coverage, 50597,
     /* 2370121 */     GIR_EraseRootFromParent_Done,
     /* 2370122 */   // Label 33216: @2370122
     /* 2370122 */   GIM_Reject,
     /* 2370123 */ // Label 33214: @2370123
     /* 2370123 */ GIM_Reject,
     /* 2370124 */ // Label 33186: @2370124
     /* 2370124 */ GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2370238),
     /* 2370129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2370132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2370135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370147 */   GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2370192), // Rule ID 50608 //
     /* 2370152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370155 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370191 */     // GIR_Coverage, 50608,
     /* 2370191 */     GIR_EraseRootFromParent_Done,
     /* 2370192 */   // Label 33218: @2370192
     /* 2370192 */   GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2370237), // Rule ID 50609 //
     /* 2370197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370200 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370236 */     // GIR_Coverage, 50609,
     /* 2370236 */     GIR_EraseRootFromParent_Done,
     /* 2370237 */   // Label 33219: @2370237
     /* 2370237 */   GIM_Reject,
     /* 2370238 */ // Label 33217: @2370238
     /* 2370238 */ GIM_Reject,
     /* 2370239 */ // Label 33187: @2370239
     /* 2370239 */ GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2370353),
     /* 2370244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2370247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2370250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370262 */   GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2370307), // Rule ID 50616 //
     /* 2370267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370270 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370306 */     // GIR_Coverage, 50616,
     /* 2370306 */     GIR_EraseRootFromParent_Done,
     /* 2370307 */   // Label 33221: @2370307
     /* 2370307 */   GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2370352), // Rule ID 50617 //
     /* 2370312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370315 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370351 */     // GIR_Coverage, 50617,
     /* 2370351 */     GIR_EraseRootFromParent_Done,
     /* 2370352 */   // Label 33222: @2370352
     /* 2370352 */   GIM_Reject,
     /* 2370353 */ // Label 33220: @2370353
     /* 2370353 */ GIM_Reject,
     /* 2370354 */ // Label 33188: @2370354
     /* 2370354 */ GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2370468),
     /* 2370359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2370362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2370365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370377 */   GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2370422), // Rule ID 50632 //
     /* 2370382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370385 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370421 */     // GIR_Coverage, 50632,
     /* 2370421 */     GIR_EraseRootFromParent_Done,
     /* 2370422 */   // Label 33224: @2370422
     /* 2370422 */   GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2370467), // Rule ID 50633 //
     /* 2370427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370430 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370466 */     // GIR_Coverage, 50633,
     /* 2370466 */     GIR_EraseRootFromParent_Done,
     /* 2370467 */   // Label 33225: @2370467
     /* 2370467 */   GIM_Reject,
     /* 2370468 */ // Label 33223: @2370468
     /* 2370468 */ GIM_Reject,
     /* 2370469 */ // Label 33189: @2370469
     /* 2370469 */ GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2370583),
     /* 2370474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2370477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2370480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370492 */   GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2370537), // Rule ID 50600 //
     /* 2370497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370500 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370536 */     // GIR_Coverage, 50600,
     /* 2370536 */     GIR_EraseRootFromParent_Done,
     /* 2370537 */   // Label 33227: @2370537
     /* 2370537 */   GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2370582), // Rule ID 50601 //
     /* 2370542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370545 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2370562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370581 */     // GIR_Coverage, 50601,
     /* 2370581 */     GIR_EraseRootFromParent_Done,
     /* 2370582 */   // Label 33228: @2370582
     /* 2370582 */   GIM_Reject,
     /* 2370583 */ // Label 33226: @2370583
     /* 2370583 */ GIM_Reject,
     /* 2370584 */ // Label 33190: @2370584
     /* 2370584 */ GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2370698),
     /* 2370589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2370592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2370595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370607 */   GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2370652), // Rule ID 50612 //
     /* 2370612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370615 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370651 */     // GIR_Coverage, 50612,
     /* 2370651 */     GIR_EraseRootFromParent_Done,
     /* 2370652 */   // Label 33230: @2370652
     /* 2370652 */   GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2370697), // Rule ID 50613 //
     /* 2370657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370660 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370696 */     // GIR_Coverage, 50613,
     /* 2370696 */     GIR_EraseRootFromParent_Done,
     /* 2370697 */   // Label 33231: @2370697
     /* 2370697 */   GIM_Reject,
     /* 2370698 */ // Label 33229: @2370698
     /* 2370698 */ GIM_Reject,
     /* 2370699 */ // Label 33191: @2370699
     /* 2370699 */ GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2370813),
     /* 2370704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2370707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2370710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370722 */   GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2370767), // Rule ID 50628 //
     /* 2370727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370730 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370766 */     // GIR_Coverage, 50628,
     /* 2370766 */     GIR_EraseRootFromParent_Done,
     /* 2370767 */   // Label 33233: @2370767
     /* 2370767 */   GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2370812), // Rule ID 50629 //
     /* 2370772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370775 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2370792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370811 */     // GIR_Coverage, 50629,
     /* 2370811 */     GIR_EraseRootFromParent_Done,
     /* 2370812 */   // Label 33234: @2370812
     /* 2370812 */   GIM_Reject,
     /* 2370813 */ // Label 33232: @2370813
     /* 2370813 */ GIM_Reject,
     /* 2370814 */ // Label 33192: @2370814
     /* 2370814 */ GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2370928),
     /* 2370819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2370822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2370825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370837 */   GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2370882), // Rule ID 50672 //
     /* 2370842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370845 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2370862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370881 */     // GIR_Coverage, 50672,
     /* 2370881 */     GIR_EraseRootFromParent_Done,
     /* 2370882 */   // Label 33236: @2370882
     /* 2370882 */   GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2370927), // Rule ID 50673 //
     /* 2370887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370890 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2370907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370926 */     // GIR_Coverage, 50673,
     /* 2370926 */     GIR_EraseRootFromParent_Done,
     /* 2370927 */   // Label 33237: @2370927
     /* 2370927 */   GIM_Reject,
     /* 2370928 */ // Label 33235: @2370928
     /* 2370928 */ GIM_Reject,
     /* 2370929 */ // Label 33193: @2370929
     /* 2370929 */ GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2371043),
     /* 2370934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2370940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370952 */   GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2370997), // Rule ID 50604 //
     /* 2370957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370960 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2370977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370996 */     // GIR_Coverage, 50604,
     /* 2370996 */     GIR_EraseRootFromParent_Done,
     /* 2370997 */   // Label 33239: @2370997
     /* 2370997 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2371042), // Rule ID 50605 //
     /* 2371002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371005 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2371022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371041 */     // GIR_Coverage, 50605,
     /* 2371041 */     GIR_EraseRootFromParent_Done,
     /* 2371042 */   // Label 33240: @2371042
     /* 2371042 */   GIM_Reject,
     /* 2371043 */ // Label 33238: @2371043
     /* 2371043 */ GIM_Reject,
     /* 2371044 */ // Label 33194: @2371044
     /* 2371044 */ GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2371158),
     /* 2371049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2371052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2371055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371067 */   GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2371112), // Rule ID 50624 //
     /* 2371072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371075 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371111 */     // GIR_Coverage, 50624,
     /* 2371111 */     GIR_EraseRootFromParent_Done,
     /* 2371112 */   // Label 33242: @2371112
     /* 2371112 */   GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2371157), // Rule ID 50625 //
     /* 2371117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371120 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371156 */     // GIR_Coverage, 50625,
     /* 2371156 */     GIR_EraseRootFromParent_Done,
     /* 2371157 */   // Label 33243: @2371157
     /* 2371157 */   GIM_Reject,
     /* 2371158 */ // Label 33241: @2371158
     /* 2371158 */ GIM_Reject,
     /* 2371159 */ // Label 33195: @2371159
     /* 2371159 */ GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2371273),
     /* 2371164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2371167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2371170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371182 */   GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2371227), // Rule ID 50660 //
     /* 2371187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371190 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371226 */     // GIR_Coverage, 50660,
     /* 2371226 */     GIR_EraseRootFromParent_Done,
     /* 2371227 */   // Label 33245: @2371227
     /* 2371227 */   GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2371272), // Rule ID 50661 //
     /* 2371232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371235 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371271 */     // GIR_Coverage, 50661,
     /* 2371271 */     GIR_EraseRootFromParent_Done,
     /* 2371272 */   // Label 33246: @2371272
     /* 2371272 */   GIM_Reject,
     /* 2371273 */ // Label 33244: @2371273
     /* 2371273 */ GIM_Reject,
     /* 2371274 */ // Label 33196: @2371274
     /* 2371274 */ GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2371388),
     /* 2371279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2371282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2371285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371297 */   GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2371342), // Rule ID 50676 //
     /* 2371302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371305 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371341 */     // GIR_Coverage, 50676,
     /* 2371341 */     GIR_EraseRootFromParent_Done,
     /* 2371342 */   // Label 33248: @2371342
     /* 2371342 */   GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2371387), // Rule ID 50677 //
     /* 2371347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371350 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371386 */     // GIR_Coverage, 50677,
     /* 2371386 */     GIR_EraseRootFromParent_Done,
     /* 2371387 */   // Label 33249: @2371387
     /* 2371387 */   GIM_Reject,
     /* 2371388 */ // Label 33247: @2371388
     /* 2371388 */ GIM_Reject,
     /* 2371389 */ // Label 33197: @2371389
     /* 2371389 */ GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2371503),
     /* 2371394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2371397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2371400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371412 */   GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2371457), // Rule ID 50620 //
     /* 2371417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371420 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371456 */     // GIR_Coverage, 50620,
     /* 2371456 */     GIR_EraseRootFromParent_Done,
     /* 2371457 */   // Label 33251: @2371457
     /* 2371457 */   GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2371502), // Rule ID 50621 //
     /* 2371462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371465 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2371482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371501 */     // GIR_Coverage, 50621,
     /* 2371501 */     GIR_EraseRootFromParent_Done,
     /* 2371502 */   // Label 33252: @2371502
     /* 2371502 */   GIM_Reject,
     /* 2371503 */ // Label 33250: @2371503
     /* 2371503 */ GIM_Reject,
     /* 2371504 */ // Label 33198: @2371504
     /* 2371504 */ GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2371618),
     /* 2371509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2371512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2371515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371527 */   GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2371572), // Rule ID 50648 //
     /* 2371532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371535 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371571 */     // GIR_Coverage, 50648,
     /* 2371571 */     GIR_EraseRootFromParent_Done,
     /* 2371572 */   // Label 33254: @2371572
     /* 2371572 */   GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2371617), // Rule ID 50649 //
     /* 2371577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371580 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371616 */     // GIR_Coverage, 50649,
     /* 2371616 */     GIR_EraseRootFromParent_Done,
     /* 2371617 */   // Label 33255: @2371617
     /* 2371617 */   GIM_Reject,
     /* 2371618 */ // Label 33253: @2371618
     /* 2371618 */ GIM_Reject,
     /* 2371619 */ // Label 33199: @2371619
     /* 2371619 */ GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2371733),
     /* 2371624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2371627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2371630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371642 */   GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2371687), // Rule ID 50664 //
     /* 2371647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371650 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371686 */     // GIR_Coverage, 50664,
     /* 2371686 */     GIR_EraseRootFromParent_Done,
     /* 2371687 */   // Label 33257: @2371687
     /* 2371687 */   GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2371732), // Rule ID 50665 //
     /* 2371692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371695 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2371712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371731 */     // GIR_Coverage, 50665,
     /* 2371731 */     GIR_EraseRootFromParent_Done,
     /* 2371732 */   // Label 33258: @2371732
     /* 2371732 */   GIM_Reject,
     /* 2371733 */ // Label 33256: @2371733
     /* 2371733 */ GIM_Reject,
     /* 2371734 */ // Label 33200: @2371734
     /* 2371734 */ GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2371848),
     /* 2371739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2371742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2371745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371757 */   GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2371802), // Rule ID 50680 //
     /* 2371762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371765 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2371782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371801 */     // GIR_Coverage, 50680,
     /* 2371801 */     GIR_EraseRootFromParent_Done,
     /* 2371802 */   // Label 33260: @2371802
     /* 2371802 */   GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2371847), // Rule ID 50681 //
     /* 2371807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371810 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2371827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371846 */     // GIR_Coverage, 50681,
     /* 2371846 */     GIR_EraseRootFromParent_Done,
     /* 2371847 */   // Label 33261: @2371847
     /* 2371847 */   GIM_Reject,
     /* 2371848 */ // Label 33259: @2371848
     /* 2371848 */ GIM_Reject,
     /* 2371849 */ // Label 33201: @2371849
     /* 2371849 */ GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2371963),
     /* 2371854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2371860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371872 */   GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2371917), // Rule ID 50636 //
     /* 2371877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371880 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371916 */     // GIR_Coverage, 50636,
     /* 2371916 */     GIR_EraseRootFromParent_Done,
     /* 2371917 */   // Label 33263: @2371917
     /* 2371917 */   GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2371962), // Rule ID 50637 //
     /* 2371922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371925 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2371942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371961 */     // GIR_Coverage, 50637,
     /* 2371961 */     GIR_EraseRootFromParent_Done,
     /* 2371962 */   // Label 33264: @2371962
     /* 2371962 */   GIM_Reject,
     /* 2371963 */ // Label 33262: @2371963
     /* 2371963 */ GIM_Reject,
     /* 2371964 */ // Label 33202: @2371964
     /* 2371964 */ GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2372078),
     /* 2371969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2371975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371987 */   GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2372032), // Rule ID 50652 //
     /* 2371992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371995 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372031 */     // GIR_Coverage, 50652,
     /* 2372031 */     GIR_EraseRootFromParent_Done,
     /* 2372032 */   // Label 33266: @2372032
     /* 2372032 */   GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2372077), // Rule ID 50653 //
     /* 2372037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372040 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2372043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372076 */     // GIR_Coverage, 50653,
     /* 2372076 */     GIR_EraseRootFromParent_Done,
     /* 2372077 */   // Label 33267: @2372077
     /* 2372077 */   GIM_Reject,
     /* 2372078 */ // Label 33265: @2372078
     /* 2372078 */ GIM_Reject,
     /* 2372079 */ // Label 33203: @2372079
     /* 2372079 */ GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2372193),
     /* 2372084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2372087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2372090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372102 */   GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2372147), // Rule ID 50668 //
     /* 2372107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372110 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372146 */     // GIR_Coverage, 50668,
     /* 2372146 */     GIR_EraseRootFromParent_Done,
     /* 2372147 */   // Label 33269: @2372147
     /* 2372147 */   GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2372192), // Rule ID 50669 //
     /* 2372152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372155 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372191 */     // GIR_Coverage, 50669,
     /* 2372191 */     GIR_EraseRootFromParent_Done,
     /* 2372192 */   // Label 33270: @2372192
     /* 2372192 */   GIM_Reject,
     /* 2372193 */ // Label 33268: @2372193
     /* 2372193 */ GIM_Reject,
     /* 2372194 */ // Label 33204: @2372194
     /* 2372194 */ GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2372308),
     /* 2372199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2372202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2372205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372217 */   GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2372262), // Rule ID 50640 //
     /* 2372222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372225 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372261 */     // GIR_Coverage, 50640,
     /* 2372261 */     GIR_EraseRootFromParent_Done,
     /* 2372262 */   // Label 33272: @2372262
     /* 2372262 */   GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2372307), // Rule ID 50641 //
     /* 2372267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372270 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2372287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372306 */     // GIR_Coverage, 50641,
     /* 2372306 */     GIR_EraseRootFromParent_Done,
     /* 2372307 */   // Label 33273: @2372307
     /* 2372307 */   GIM_Reject,
     /* 2372308 */ // Label 33271: @2372308
     /* 2372308 */ GIM_Reject,
     /* 2372309 */ // Label 33205: @2372309
     /* 2372309 */ GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2372423),
     /* 2372314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2372317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2372320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372332 */   GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2372377), // Rule ID 50656 //
     /* 2372337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372340 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372376 */     // GIR_Coverage, 50656,
     /* 2372376 */     GIR_EraseRootFromParent_Done,
     /* 2372377 */   // Label 33275: @2372377
     /* 2372377 */   GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2372422), // Rule ID 50657 //
     /* 2372382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372385 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372421 */     // GIR_Coverage, 50657,
     /* 2372421 */     GIR_EraseRootFromParent_Done,
     /* 2372422 */   // Label 33276: @2372422
     /* 2372422 */   GIM_Reject,
     /* 2372423 */ // Label 33274: @2372423
     /* 2372423 */ GIM_Reject,
     /* 2372424 */ // Label 33206: @2372424
     /* 2372424 */ GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2372538),
     /* 2372429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2372432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2372435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372447 */   GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2372492), // Rule ID 50644 //
     /* 2372452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372455 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372491 */     // GIR_Coverage, 50644,
     /* 2372491 */     GIR_EraseRootFromParent_Done,
     /* 2372492 */   // Label 33278: @2372492
     /* 2372492 */   GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2372537), // Rule ID 50645 //
     /* 2372497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372500 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2372517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372536 */     // GIR_Coverage, 50645,
     /* 2372536 */     GIR_EraseRootFromParent_Done,
     /* 2372537 */   // Label 33279: @2372537
     /* 2372537 */   GIM_Reject,
     /* 2372538 */ // Label 33277: @2372538
     /* 2372538 */ GIM_Reject,
     /* 2372539 */ // Label 33207: @2372539
     /* 2372539 */ GIM_Reject,
     /* 2372540 */ // Label 81: @2372540
     /* 2372540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33304*/ GIMT_Encode4(2375315),
     /* 2372551 */ /*GILLT_s32*//*Label 33280*/ GIMT_Encode4(2372675),
     /* 2372555 */ /*GILLT_s64*//*Label 33281*/ GIMT_Encode4(2372730), GIMT_Encode4(0),
     /* 2372563 */ /*GILLT_nxv1s8*//*Label 33282*/ GIMT_Encode4(2372785),
     /* 2372567 */ /*GILLT_nxv1s16*//*Label 33283*/ GIMT_Encode4(2372900),
     /* 2372571 */ /*GILLT_nxv1s32*//*Label 33284*/ GIMT_Encode4(2373015),
     /* 2372575 */ /*GILLT_nxv1s64*//*Label 33285*/ GIMT_Encode4(2373130), GIMT_Encode4(0),
     /* 2372583 */ /*GILLT_nxv2s8*//*Label 33286*/ GIMT_Encode4(2373245),
     /* 2372587 */ /*GILLT_nxv2s16*//*Label 33287*/ GIMT_Encode4(2373360),
     /* 2372591 */ /*GILLT_nxv2s32*//*Label 33288*/ GIMT_Encode4(2373475),
     /* 2372595 */ /*GILLT_nxv2s64*//*Label 33289*/ GIMT_Encode4(2373590), GIMT_Encode4(0),
     /* 2372603 */ /*GILLT_nxv4s8*//*Label 33290*/ GIMT_Encode4(2373705),
     /* 2372607 */ /*GILLT_nxv4s16*//*Label 33291*/ GIMT_Encode4(2373820),
     /* 2372611 */ /*GILLT_nxv4s32*//*Label 33292*/ GIMT_Encode4(2373935),
     /* 2372615 */ /*GILLT_nxv4s64*//*Label 33293*/ GIMT_Encode4(2374050), GIMT_Encode4(0),
     /* 2372623 */ /*GILLT_nxv8s8*//*Label 33294*/ GIMT_Encode4(2374165),
     /* 2372627 */ /*GILLT_nxv8s16*//*Label 33295*/ GIMT_Encode4(2374280),
     /* 2372631 */ /*GILLT_nxv8s32*//*Label 33296*/ GIMT_Encode4(2374395),
     /* 2372635 */ /*GILLT_nxv8s64*//*Label 33297*/ GIMT_Encode4(2374510), GIMT_Encode4(0),
     /* 2372643 */ /*GILLT_nxv16s8*//*Label 33298*/ GIMT_Encode4(2374625),
     /* 2372647 */ /*GILLT_nxv16s16*//*Label 33299*/ GIMT_Encode4(2374740),
     /* 2372651 */ /*GILLT_nxv16s32*//*Label 33300*/ GIMT_Encode4(2374855), GIMT_Encode4(0),
     /* 2372659 */ /*GILLT_nxv32s8*//*Label 33301*/ GIMT_Encode4(2374970),
     /* 2372663 */ /*GILLT_nxv32s16*//*Label 33302*/ GIMT_Encode4(2375085), GIMT_Encode4(0),
     /* 2372671 */ /*GILLT_nxv64s8*//*Label 33303*/ GIMT_Encode4(2375200),
     /* 2372675 */ // Label 33280: @2372675
     /* 2372675 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2372729),
     /* 2372680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2372683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2372686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372698 */   GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2372713), // Rule ID 64470 //
     /* 2372703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2372706 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2372711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372712 */     // GIR_Coverage, 64470,
     /* 2372712 */     GIR_Done,
     /* 2372713 */   // Label 33306: @2372713
     /* 2372713 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2372728), // Rule ID 2533 //
     /* 2372718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2372721 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2372726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372727 */     // GIR_Coverage, 2533,
     /* 2372727 */     GIR_Done,
     /* 2372728 */   // Label 33307: @2372728
     /* 2372728 */   GIM_Reject,
     /* 2372729 */ // Label 33305: @2372729
     /* 2372729 */ GIM_Reject,
     /* 2372730 */ // Label 33281: @2372730
     /* 2372730 */ GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2372784),
     /* 2372735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2372738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2372741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372753 */   GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2372768), // Rule ID 64469 //
     /* 2372758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2372761 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2372766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372767 */     // GIR_Coverage, 64469,
     /* 2372767 */     GIR_Done,
     /* 2372768 */   // Label 33309: @2372768
     /* 2372768 */   GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2372783), // Rule ID 2532 //
     /* 2372773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2372776 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2372781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372782 */     // GIR_Coverage, 2532,
     /* 2372782 */     GIR_Done,
     /* 2372783 */   // Label 33310: @2372783
     /* 2372783 */   GIM_Reject,
     /* 2372784 */ // Label 33308: @2372784
     /* 2372784 */ GIM_Reject,
     /* 2372785 */ // Label 33282: @2372785
     /* 2372785 */ GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2372899),
     /* 2372790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2372793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2372796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372808 */   GIM_Try, /*On fail goto*//*Label 33312*/ GIMT_Encode4(2372853), // Rule ID 50772 //
     /* 2372813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372816 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2372833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372852 */     // GIR_Coverage, 50772,
     /* 2372852 */     GIR_EraseRootFromParent_Done,
     /* 2372853 */   // Label 33312: @2372853
     /* 2372853 */   GIM_Try, /*On fail goto*//*Label 33313*/ GIMT_Encode4(2372898), // Rule ID 50773 //
     /* 2372858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372861 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2372878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372897 */     // GIR_Coverage, 50773,
     /* 2372897 */     GIR_EraseRootFromParent_Done,
     /* 2372898 */   // Label 33313: @2372898
     /* 2372898 */   GIM_Reject,
     /* 2372899 */ // Label 33311: @2372899
     /* 2372899 */ GIM_Reject,
     /* 2372900 */ // Label 33283: @2372900
     /* 2372900 */ GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2373014),
     /* 2372905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2372911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372923 */   GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2372968), // Rule ID 50784 //
     /* 2372928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372931 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2372948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372967 */     // GIR_Coverage, 50784,
     /* 2372967 */     GIR_EraseRootFromParent_Done,
     /* 2372968 */   // Label 33315: @2372968
     /* 2372968 */   GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2373013), // Rule ID 50785 //
     /* 2372973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372976 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2372993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373012 */     // GIR_Coverage, 50785,
     /* 2373012 */     GIR_EraseRootFromParent_Done,
     /* 2373013 */   // Label 33316: @2373013
     /* 2373013 */   GIM_Reject,
     /* 2373014 */ // Label 33314: @2373014
     /* 2373014 */ GIM_Reject,
     /* 2373015 */ // Label 33284: @2373015
     /* 2373015 */ GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2373129),
     /* 2373020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2373023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2373026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373038 */   GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2373083), // Rule ID 50792 //
     /* 2373043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373046 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2373049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373082 */     // GIR_Coverage, 50792,
     /* 2373082 */     GIR_EraseRootFromParent_Done,
     /* 2373083 */   // Label 33318: @2373083
     /* 2373083 */   GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2373128), // Rule ID 50793 //
     /* 2373088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373091 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2373094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373127 */     // GIR_Coverage, 50793,
     /* 2373127 */     GIR_EraseRootFromParent_Done,
     /* 2373128 */   // Label 33319: @2373128
     /* 2373128 */   GIM_Reject,
     /* 2373129 */ // Label 33317: @2373129
     /* 2373129 */ GIM_Reject,
     /* 2373130 */ // Label 33285: @2373130
     /* 2373130 */ GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2373244),
     /* 2373135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2373138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2373141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373153 */   GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2373198), // Rule ID 50808 //
     /* 2373158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373161 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373197 */     // GIR_Coverage, 50808,
     /* 2373197 */     GIR_EraseRootFromParent_Done,
     /* 2373198 */   // Label 33321: @2373198
     /* 2373198 */   GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2373243), // Rule ID 50809 //
     /* 2373203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373206 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373242 */     // GIR_Coverage, 50809,
     /* 2373242 */     GIR_EraseRootFromParent_Done,
     /* 2373243 */   // Label 33322: @2373243
     /* 2373243 */   GIM_Reject,
     /* 2373244 */ // Label 33320: @2373244
     /* 2373244 */ GIM_Reject,
     /* 2373245 */ // Label 33286: @2373245
     /* 2373245 */ GIM_Try, /*On fail goto*//*Label 33323*/ GIMT_Encode4(2373359),
     /* 2373250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2373253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2373256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373268 */   GIM_Try, /*On fail goto*//*Label 33324*/ GIMT_Encode4(2373313), // Rule ID 50776 //
     /* 2373273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373276 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2373293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373312 */     // GIR_Coverage, 50776,
     /* 2373312 */     GIR_EraseRootFromParent_Done,
     /* 2373313 */   // Label 33324: @2373313
     /* 2373313 */   GIM_Try, /*On fail goto*//*Label 33325*/ GIMT_Encode4(2373358), // Rule ID 50777 //
     /* 2373318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373321 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2373338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373357 */     // GIR_Coverage, 50777,
     /* 2373357 */     GIR_EraseRootFromParent_Done,
     /* 2373358 */   // Label 33325: @2373358
     /* 2373358 */   GIM_Reject,
     /* 2373359 */ // Label 33323: @2373359
     /* 2373359 */ GIM_Reject,
     /* 2373360 */ // Label 33287: @2373360
     /* 2373360 */ GIM_Try, /*On fail goto*//*Label 33326*/ GIMT_Encode4(2373474),
     /* 2373365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2373368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2373371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373383 */   GIM_Try, /*On fail goto*//*Label 33327*/ GIMT_Encode4(2373428), // Rule ID 50788 //
     /* 2373388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373391 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373427 */     // GIR_Coverage, 50788,
     /* 2373427 */     GIR_EraseRootFromParent_Done,
     /* 2373428 */   // Label 33327: @2373428
     /* 2373428 */   GIM_Try, /*On fail goto*//*Label 33328*/ GIMT_Encode4(2373473), // Rule ID 50789 //
     /* 2373433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373436 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373472 */     // GIR_Coverage, 50789,
     /* 2373472 */     GIR_EraseRootFromParent_Done,
     /* 2373473 */   // Label 33328: @2373473
     /* 2373473 */   GIM_Reject,
     /* 2373474 */ // Label 33326: @2373474
     /* 2373474 */ GIM_Reject,
     /* 2373475 */ // Label 33288: @2373475
     /* 2373475 */ GIM_Try, /*On fail goto*//*Label 33329*/ GIMT_Encode4(2373589),
     /* 2373480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2373483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2373486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373498 */   GIM_Try, /*On fail goto*//*Label 33330*/ GIMT_Encode4(2373543), // Rule ID 50804 //
     /* 2373503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373506 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373542 */     // GIR_Coverage, 50804,
     /* 2373542 */     GIR_EraseRootFromParent_Done,
     /* 2373543 */   // Label 33330: @2373543
     /* 2373543 */   GIM_Try, /*On fail goto*//*Label 33331*/ GIMT_Encode4(2373588), // Rule ID 50805 //
     /* 2373548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373551 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373587 */     // GIR_Coverage, 50805,
     /* 2373587 */     GIR_EraseRootFromParent_Done,
     /* 2373588 */   // Label 33331: @2373588
     /* 2373588 */   GIM_Reject,
     /* 2373589 */ // Label 33329: @2373589
     /* 2373589 */ GIM_Reject,
     /* 2373590 */ // Label 33289: @2373590
     /* 2373590 */ GIM_Try, /*On fail goto*//*Label 33332*/ GIMT_Encode4(2373704),
     /* 2373595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2373598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2373601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373613 */   GIM_Try, /*On fail goto*//*Label 33333*/ GIMT_Encode4(2373658), // Rule ID 50848 //
     /* 2373618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373621 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373657 */     // GIR_Coverage, 50848,
     /* 2373657 */     GIR_EraseRootFromParent_Done,
     /* 2373658 */   // Label 33333: @2373658
     /* 2373658 */   GIM_Try, /*On fail goto*//*Label 33334*/ GIMT_Encode4(2373703), // Rule ID 50849 //
     /* 2373663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373666 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373702 */     // GIR_Coverage, 50849,
     /* 2373702 */     GIR_EraseRootFromParent_Done,
     /* 2373703 */   // Label 33334: @2373703
     /* 2373703 */   GIM_Reject,
     /* 2373704 */ // Label 33332: @2373704
     /* 2373704 */ GIM_Reject,
     /* 2373705 */ // Label 33290: @2373705
     /* 2373705 */ GIM_Try, /*On fail goto*//*Label 33335*/ GIMT_Encode4(2373819),
     /* 2373710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2373713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2373716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373728 */   GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2373773), // Rule ID 50780 //
     /* 2373733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373736 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373772 */     // GIR_Coverage, 50780,
     /* 2373772 */     GIR_EraseRootFromParent_Done,
     /* 2373773 */   // Label 33336: @2373773
     /* 2373773 */   GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2373818), // Rule ID 50781 //
     /* 2373778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373781 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2373798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373817 */     // GIR_Coverage, 50781,
     /* 2373817 */     GIR_EraseRootFromParent_Done,
     /* 2373818 */   // Label 33337: @2373818
     /* 2373818 */   GIM_Reject,
     /* 2373819 */ // Label 33335: @2373819
     /* 2373819 */ GIM_Reject,
     /* 2373820 */ // Label 33291: @2373820
     /* 2373820 */ GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2373934),
     /* 2373825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2373828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2373831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373843 */   GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2373888), // Rule ID 50800 //
     /* 2373848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373851 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373887 */     // GIR_Coverage, 50800,
     /* 2373887 */     GIR_EraseRootFromParent_Done,
     /* 2373888 */   // Label 33339: @2373888
     /* 2373888 */   GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2373933), // Rule ID 50801 //
     /* 2373893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373896 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2373913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373932 */     // GIR_Coverage, 50801,
     /* 2373932 */     GIR_EraseRootFromParent_Done,
     /* 2373933 */   // Label 33340: @2373933
     /* 2373933 */   GIM_Reject,
     /* 2373934 */ // Label 33338: @2373934
     /* 2373934 */ GIM_Reject,
     /* 2373935 */ // Label 33292: @2373935
     /* 2373935 */ GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2374049),
     /* 2373940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2373946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373958 */   GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2374003), // Rule ID 50836 //
     /* 2373963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373966 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2373983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374002 */     // GIR_Coverage, 50836,
     /* 2374002 */     GIR_EraseRootFromParent_Done,
     /* 2374003 */   // Label 33342: @2374003
     /* 2374003 */   GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2374048), // Rule ID 50837 //
     /* 2374008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374011 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2374014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374047 */     // GIR_Coverage, 50837,
     /* 2374047 */     GIR_EraseRootFromParent_Done,
     /* 2374048 */   // Label 33343: @2374048
     /* 2374048 */   GIM_Reject,
     /* 2374049 */ // Label 33341: @2374049
     /* 2374049 */ GIM_Reject,
     /* 2374050 */ // Label 33293: @2374050
     /* 2374050 */ GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2374164),
     /* 2374055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2374058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2374061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374073 */   GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2374118), // Rule ID 50852 //
     /* 2374078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2374081 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374117 */     // GIR_Coverage, 50852,
     /* 2374117 */     GIR_EraseRootFromParent_Done,
     /* 2374118 */   // Label 33345: @2374118
     /* 2374118 */   GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2374163), // Rule ID 50853 //
     /* 2374123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2374126 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374162 */     // GIR_Coverage, 50853,
     /* 2374162 */     GIR_EraseRootFromParent_Done,
     /* 2374163 */   // Label 33346: @2374163
     /* 2374163 */   GIM_Reject,
     /* 2374164 */ // Label 33344: @2374164
     /* 2374164 */ GIM_Reject,
     /* 2374165 */ // Label 33294: @2374165
     /* 2374165 */ GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2374279),
     /* 2374170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2374173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2374176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374188 */   GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2374233), // Rule ID 50796 //
     /* 2374193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374196 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2374213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374232 */     // GIR_Coverage, 50796,
     /* 2374232 */     GIR_EraseRootFromParent_Done,
     /* 2374233 */   // Label 33348: @2374233
     /* 2374233 */   GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2374278), // Rule ID 50797 //
     /* 2374238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374241 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2374258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374277 */     // GIR_Coverage, 50797,
     /* 2374277 */     GIR_EraseRootFromParent_Done,
     /* 2374278 */   // Label 33349: @2374278
     /* 2374278 */   GIM_Reject,
     /* 2374279 */ // Label 33347: @2374279
     /* 2374279 */ GIM_Reject,
     /* 2374280 */ // Label 33295: @2374280
     /* 2374280 */ GIM_Try, /*On fail goto*//*Label 33350*/ GIMT_Encode4(2374394),
     /* 2374285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2374288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2374291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374303 */   GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2374348), // Rule ID 50824 //
     /* 2374308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374311 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374347 */     // GIR_Coverage, 50824,
     /* 2374347 */     GIR_EraseRootFromParent_Done,
     /* 2374348 */   // Label 33351: @2374348
     /* 2374348 */   GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2374393), // Rule ID 50825 //
     /* 2374353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374356 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374392 */     // GIR_Coverage, 50825,
     /* 2374392 */     GIR_EraseRootFromParent_Done,
     /* 2374393 */   // Label 33352: @2374393
     /* 2374393 */   GIM_Reject,
     /* 2374394 */ // Label 33350: @2374394
     /* 2374394 */ GIM_Reject,
     /* 2374395 */ // Label 33296: @2374395
     /* 2374395 */ GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2374509),
     /* 2374400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2374403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2374406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374418 */   GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2374463), // Rule ID 50840 //
     /* 2374423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374426 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374462 */     // GIR_Coverage, 50840,
     /* 2374462 */     GIR_EraseRootFromParent_Done,
     /* 2374463 */   // Label 33354: @2374463
     /* 2374463 */   GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2374508), // Rule ID 50841 //
     /* 2374468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374471 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374507 */     // GIR_Coverage, 50841,
     /* 2374507 */     GIR_EraseRootFromParent_Done,
     /* 2374508 */   // Label 33355: @2374508
     /* 2374508 */   GIM_Reject,
     /* 2374509 */ // Label 33353: @2374509
     /* 2374509 */ GIM_Reject,
     /* 2374510 */ // Label 33297: @2374510
     /* 2374510 */ GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2374624),
     /* 2374515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2374518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2374521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374533 */   GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2374578), // Rule ID 50856 //
     /* 2374538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2374541 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374577 */     // GIR_Coverage, 50856,
     /* 2374577 */     GIR_EraseRootFromParent_Done,
     /* 2374578 */   // Label 33357: @2374578
     /* 2374578 */   GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2374623), // Rule ID 50857 //
     /* 2374583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2374586 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374622 */     // GIR_Coverage, 50857,
     /* 2374622 */     GIR_EraseRootFromParent_Done,
     /* 2374623 */   // Label 33358: @2374623
     /* 2374623 */   GIM_Reject,
     /* 2374624 */ // Label 33356: @2374624
     /* 2374624 */ GIM_Reject,
     /* 2374625 */ // Label 33298: @2374625
     /* 2374625 */ GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2374739),
     /* 2374630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2374633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2374636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374648 */   GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2374693), // Rule ID 50812 //
     /* 2374653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374656 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374692 */     // GIR_Coverage, 50812,
     /* 2374692 */     GIR_EraseRootFromParent_Done,
     /* 2374693 */   // Label 33360: @2374693
     /* 2374693 */   GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2374738), // Rule ID 50813 //
     /* 2374698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374701 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2374718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374737 */     // GIR_Coverage, 50813,
     /* 2374737 */     GIR_EraseRootFromParent_Done,
     /* 2374738 */   // Label 33361: @2374738
     /* 2374738 */   GIM_Reject,
     /* 2374739 */ // Label 33359: @2374739
     /* 2374739 */ GIM_Reject,
     /* 2374740 */ // Label 33299: @2374740
     /* 2374740 */ GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2374854),
     /* 2374745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2374748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2374751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374763 */   GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2374808), // Rule ID 50828 //
     /* 2374768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374771 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374807 */     // GIR_Coverage, 50828,
     /* 2374807 */     GIR_EraseRootFromParent_Done,
     /* 2374808 */   // Label 33363: @2374808
     /* 2374808 */   GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2374853), // Rule ID 50829 //
     /* 2374813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374816 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2374833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374852 */     // GIR_Coverage, 50829,
     /* 2374852 */     GIR_EraseRootFromParent_Done,
     /* 2374853 */   // Label 33364: @2374853
     /* 2374853 */   GIM_Reject,
     /* 2374854 */ // Label 33362: @2374854
     /* 2374854 */ GIM_Reject,
     /* 2374855 */ // Label 33300: @2374855
     /* 2374855 */ GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2374969),
     /* 2374860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2374866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374878 */   GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2374923), // Rule ID 50844 //
     /* 2374883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374886 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374922 */     // GIR_Coverage, 50844,
     /* 2374922 */     GIR_EraseRootFromParent_Done,
     /* 2374923 */   // Label 33366: @2374923
     /* 2374923 */   GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2374968), // Rule ID 50845 //
     /* 2374928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374931 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2374948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374967 */     // GIR_Coverage, 50845,
     /* 2374967 */     GIR_EraseRootFromParent_Done,
     /* 2374968 */   // Label 33367: @2374968
     /* 2374968 */   GIM_Reject,
     /* 2374969 */ // Label 33365: @2374969
     /* 2374969 */ GIM_Reject,
     /* 2374970 */ // Label 33301: @2374970
     /* 2374970 */ GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2375084),
     /* 2374975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2374981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374993 */   GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2375038), // Rule ID 50816 //
     /* 2374998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375001 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2375004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2375018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375037 */     // GIR_Coverage, 50816,
     /* 2375037 */     GIR_EraseRootFromParent_Done,
     /* 2375038 */   // Label 33369: @2375038
     /* 2375038 */   GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2375083), // Rule ID 50817 //
     /* 2375043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375046 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2375049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2375063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375082 */     // GIR_Coverage, 50817,
     /* 2375082 */     GIR_EraseRootFromParent_Done,
     /* 2375083 */   // Label 33370: @2375083
     /* 2375083 */   GIM_Reject,
     /* 2375084 */ // Label 33368: @2375084
     /* 2375084 */ GIM_Reject,
     /* 2375085 */ // Label 33302: @2375085
     /* 2375085 */ GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2375199),
     /* 2375090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2375093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2375096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375108 */   GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2375153), // Rule ID 50832 //
     /* 2375113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375116 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375152 */     // GIR_Coverage, 50832,
     /* 2375152 */     GIR_EraseRootFromParent_Done,
     /* 2375153 */   // Label 33372: @2375153
     /* 2375153 */   GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2375198), // Rule ID 50833 //
     /* 2375158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375161 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375197 */     // GIR_Coverage, 50833,
     /* 2375197 */     GIR_EraseRootFromParent_Done,
     /* 2375198 */   // Label 33373: @2375198
     /* 2375198 */   GIM_Reject,
     /* 2375199 */ // Label 33371: @2375199
     /* 2375199 */ GIM_Reject,
     /* 2375200 */ // Label 33303: @2375200
     /* 2375200 */ GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2375314),
     /* 2375205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2375208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2375211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375223 */   GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2375268), // Rule ID 50820 //
     /* 2375228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375231 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375267 */     // GIR_Coverage, 50820,
     /* 2375267 */     GIR_EraseRootFromParent_Done,
     /* 2375268 */   // Label 33375: @2375268
     /* 2375268 */   GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2375313), // Rule ID 50821 //
     /* 2375273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375276 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2375279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2375293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375312 */     // GIR_Coverage, 50821,
     /* 2375312 */     GIR_EraseRootFromParent_Done,
     /* 2375313 */   // Label 33376: @2375313
     /* 2375313 */   GIM_Reject,
     /* 2375314 */ // Label 33374: @2375314
     /* 2375314 */ GIM_Reject,
     /* 2375315 */ // Label 33304: @2375315
     /* 2375315 */ GIM_Reject,
     /* 2375316 */ // Label 82: @2375316
     /* 2375316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33401*/ GIMT_Encode4(2378091),
     /* 2375327 */ /*GILLT_s32*//*Label 33377*/ GIMT_Encode4(2375451),
     /* 2375331 */ /*GILLT_s64*//*Label 33378*/ GIMT_Encode4(2375506), GIMT_Encode4(0),
     /* 2375339 */ /*GILLT_nxv1s8*//*Label 33379*/ GIMT_Encode4(2375561),
     /* 2375343 */ /*GILLT_nxv1s16*//*Label 33380*/ GIMT_Encode4(2375676),
     /* 2375347 */ /*GILLT_nxv1s32*//*Label 33381*/ GIMT_Encode4(2375791),
     /* 2375351 */ /*GILLT_nxv1s64*//*Label 33382*/ GIMT_Encode4(2375906), GIMT_Encode4(0),
     /* 2375359 */ /*GILLT_nxv2s8*//*Label 33383*/ GIMT_Encode4(2376021),
     /* 2375363 */ /*GILLT_nxv2s16*//*Label 33384*/ GIMT_Encode4(2376136),
     /* 2375367 */ /*GILLT_nxv2s32*//*Label 33385*/ GIMT_Encode4(2376251),
     /* 2375371 */ /*GILLT_nxv2s64*//*Label 33386*/ GIMT_Encode4(2376366), GIMT_Encode4(0),
     /* 2375379 */ /*GILLT_nxv4s8*//*Label 33387*/ GIMT_Encode4(2376481),
     /* 2375383 */ /*GILLT_nxv4s16*//*Label 33388*/ GIMT_Encode4(2376596),
     /* 2375387 */ /*GILLT_nxv4s32*//*Label 33389*/ GIMT_Encode4(2376711),
     /* 2375391 */ /*GILLT_nxv4s64*//*Label 33390*/ GIMT_Encode4(2376826), GIMT_Encode4(0),
     /* 2375399 */ /*GILLT_nxv8s8*//*Label 33391*/ GIMT_Encode4(2376941),
     /* 2375403 */ /*GILLT_nxv8s16*//*Label 33392*/ GIMT_Encode4(2377056),
     /* 2375407 */ /*GILLT_nxv8s32*//*Label 33393*/ GIMT_Encode4(2377171),
     /* 2375411 */ /*GILLT_nxv8s64*//*Label 33394*/ GIMT_Encode4(2377286), GIMT_Encode4(0),
     /* 2375419 */ /*GILLT_nxv16s8*//*Label 33395*/ GIMT_Encode4(2377401),
     /* 2375423 */ /*GILLT_nxv16s16*//*Label 33396*/ GIMT_Encode4(2377516),
     /* 2375427 */ /*GILLT_nxv16s32*//*Label 33397*/ GIMT_Encode4(2377631), GIMT_Encode4(0),
     /* 2375435 */ /*GILLT_nxv32s8*//*Label 33398*/ GIMT_Encode4(2377746),
     /* 2375439 */ /*GILLT_nxv32s16*//*Label 33399*/ GIMT_Encode4(2377861), GIMT_Encode4(0),
     /* 2375447 */ /*GILLT_nxv64s8*//*Label 33400*/ GIMT_Encode4(2377976),
     /* 2375451 */ // Label 33377: @2375451
     /* 2375451 */ GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2375505),
     /* 2375456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2375462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375474 */   GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2375489), // Rule ID 64468 //
     /* 2375479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2375482 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2375482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2375487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375488 */     // GIR_Coverage, 64468,
     /* 2375488 */     GIR_Done,
     /* 2375489 */   // Label 33403: @2375489
     /* 2375489 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2375504), // Rule ID 2535 //
     /* 2375494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2375497 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2375497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2375502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375503 */     // GIR_Coverage, 2535,
     /* 2375503 */     GIR_Done,
     /* 2375504 */   // Label 33404: @2375504
     /* 2375504 */   GIM_Reject,
     /* 2375505 */ // Label 33402: @2375505
     /* 2375505 */ GIM_Reject,
     /* 2375506 */ // Label 33378: @2375506
     /* 2375506 */ GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2375560),
     /* 2375511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2375517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375529 */   GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2375544), // Rule ID 64467 //
     /* 2375534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2375537 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2375537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2375542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375543 */     // GIR_Coverage, 64467,
     /* 2375543 */     GIR_Done,
     /* 2375544 */   // Label 33406: @2375544
     /* 2375544 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2375559), // Rule ID 2534 //
     /* 2375549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2375552 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2375552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2375557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375558 */     // GIR_Coverage, 2534,
     /* 2375558 */     GIR_Done,
     /* 2375559 */   // Label 33407: @2375559
     /* 2375559 */   GIM_Reject,
     /* 2375560 */ // Label 33405: @2375560
     /* 2375560 */ GIM_Reject,
     /* 2375561 */ // Label 33379: @2375561
     /* 2375561 */ GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2375675),
     /* 2375566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2375569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2375572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375584 */   GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2375629), // Rule ID 50508 //
     /* 2375589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375592 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2375609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375628 */     // GIR_Coverage, 50508,
     /* 2375628 */     GIR_EraseRootFromParent_Done,
     /* 2375629 */   // Label 33409: @2375629
     /* 2375629 */   GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2375674), // Rule ID 50509 //
     /* 2375634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375637 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2375654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375673 */     // GIR_Coverage, 50509,
     /* 2375673 */     GIR_EraseRootFromParent_Done,
     /* 2375674 */   // Label 33410: @2375674
     /* 2375674 */   GIM_Reject,
     /* 2375675 */ // Label 33408: @2375675
     /* 2375675 */ GIM_Reject,
     /* 2375676 */ // Label 33380: @2375676
     /* 2375676 */ GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2375790),
     /* 2375681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2375684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2375687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375699 */   GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2375744), // Rule ID 50520 //
     /* 2375704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375707 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2375724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375743 */     // GIR_Coverage, 50520,
     /* 2375743 */     GIR_EraseRootFromParent_Done,
     /* 2375744 */   // Label 33412: @2375744
     /* 2375744 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2375789), // Rule ID 50521 //
     /* 2375749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375752 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2375769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375788 */     // GIR_Coverage, 50521,
     /* 2375788 */     GIR_EraseRootFromParent_Done,
     /* 2375789 */   // Label 33413: @2375789
     /* 2375789 */   GIM_Reject,
     /* 2375790 */ // Label 33411: @2375790
     /* 2375790 */ GIM_Reject,
     /* 2375791 */ // Label 33381: @2375791
     /* 2375791 */ GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2375905),
     /* 2375796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2375799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2375802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375814 */   GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2375859), // Rule ID 50528 //
     /* 2375819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2375822 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2375839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375858 */     // GIR_Coverage, 50528,
     /* 2375858 */     GIR_EraseRootFromParent_Done,
     /* 2375859 */   // Label 33415: @2375859
     /* 2375859 */   GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2375904), // Rule ID 50529 //
     /* 2375864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2375867 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2375884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375903 */     // GIR_Coverage, 50529,
     /* 2375903 */     GIR_EraseRootFromParent_Done,
     /* 2375904 */   // Label 33416: @2375904
     /* 2375904 */   GIM_Reject,
     /* 2375905 */ // Label 33414: @2375905
     /* 2375905 */ GIM_Reject,
     /* 2375906 */ // Label 33382: @2375906
     /* 2375906 */ GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2376020),
     /* 2375911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2375914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2375917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375929 */   GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2375974), // Rule ID 50544 //
     /* 2375934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2375937 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2375954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2375963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375973 */     // GIR_Coverage, 50544,
     /* 2375973 */     GIR_EraseRootFromParent_Done,
     /* 2375974 */   // Label 33418: @2375974
     /* 2375974 */   GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2376019), // Rule ID 50545 //
     /* 2375979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2375982 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2375999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376018 */     // GIR_Coverage, 50545,
     /* 2376018 */     GIR_EraseRootFromParent_Done,
     /* 2376019 */   // Label 33419: @2376019
     /* 2376019 */   GIM_Reject,
     /* 2376020 */ // Label 33417: @2376020
     /* 2376020 */ GIM_Reject,
     /* 2376021 */ // Label 33383: @2376021
     /* 2376021 */ GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2376135),
     /* 2376026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2376029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2376032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376044 */   GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2376089), // Rule ID 50512 //
     /* 2376049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376052 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2376069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376088 */     // GIR_Coverage, 50512,
     /* 2376088 */     GIR_EraseRootFromParent_Done,
     /* 2376089 */   // Label 33421: @2376089
     /* 2376089 */   GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2376134), // Rule ID 50513 //
     /* 2376094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376097 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2376114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376133 */     // GIR_Coverage, 50513,
     /* 2376133 */     GIR_EraseRootFromParent_Done,
     /* 2376134 */   // Label 33422: @2376134
     /* 2376134 */   GIM_Reject,
     /* 2376135 */ // Label 33420: @2376135
     /* 2376135 */ GIM_Reject,
     /* 2376136 */ // Label 33384: @2376136
     /* 2376136 */ GIM_Try, /*On fail goto*//*Label 33423*/ GIMT_Encode4(2376250),
     /* 2376141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2376144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2376147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376159 */   GIM_Try, /*On fail goto*//*Label 33424*/ GIMT_Encode4(2376204), // Rule ID 50524 //
     /* 2376164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376167 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376203 */     // GIR_Coverage, 50524,
     /* 2376203 */     GIR_EraseRootFromParent_Done,
     /* 2376204 */   // Label 33424: @2376204
     /* 2376204 */   GIM_Try, /*On fail goto*//*Label 33425*/ GIMT_Encode4(2376249), // Rule ID 50525 //
     /* 2376209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376212 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376248 */     // GIR_Coverage, 50525,
     /* 2376248 */     GIR_EraseRootFromParent_Done,
     /* 2376249 */   // Label 33425: @2376249
     /* 2376249 */   GIM_Reject,
     /* 2376250 */ // Label 33423: @2376250
     /* 2376250 */ GIM_Reject,
     /* 2376251 */ // Label 33385: @2376251
     /* 2376251 */ GIM_Try, /*On fail goto*//*Label 33426*/ GIMT_Encode4(2376365),
     /* 2376256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2376259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2376262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376274 */   GIM_Try, /*On fail goto*//*Label 33427*/ GIMT_Encode4(2376319), // Rule ID 50540 //
     /* 2376279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376282 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376318 */     // GIR_Coverage, 50540,
     /* 2376318 */     GIR_EraseRootFromParent_Done,
     /* 2376319 */   // Label 33427: @2376319
     /* 2376319 */   GIM_Try, /*On fail goto*//*Label 33428*/ GIMT_Encode4(2376364), // Rule ID 50541 //
     /* 2376324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376327 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376363 */     // GIR_Coverage, 50541,
     /* 2376363 */     GIR_EraseRootFromParent_Done,
     /* 2376364 */   // Label 33428: @2376364
     /* 2376364 */   GIM_Reject,
     /* 2376365 */ // Label 33426: @2376365
     /* 2376365 */ GIM_Reject,
     /* 2376366 */ // Label 33386: @2376366
     /* 2376366 */ GIM_Try, /*On fail goto*//*Label 33429*/ GIMT_Encode4(2376480),
     /* 2376371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2376374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2376377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376389 */   GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2376434), // Rule ID 50584 //
     /* 2376394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376397 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376433 */     // GIR_Coverage, 50584,
     /* 2376433 */     GIR_EraseRootFromParent_Done,
     /* 2376434 */   // Label 33430: @2376434
     /* 2376434 */   GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2376479), // Rule ID 50585 //
     /* 2376439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376442 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376478 */     // GIR_Coverage, 50585,
     /* 2376478 */     GIR_EraseRootFromParent_Done,
     /* 2376479 */   // Label 33431: @2376479
     /* 2376479 */   GIM_Reject,
     /* 2376480 */ // Label 33429: @2376480
     /* 2376480 */ GIM_Reject,
     /* 2376481 */ // Label 33387: @2376481
     /* 2376481 */ GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2376595),
     /* 2376486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2376489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2376492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376504 */   GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2376549), // Rule ID 50516 //
     /* 2376509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376512 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376548 */     // GIR_Coverage, 50516,
     /* 2376548 */     GIR_EraseRootFromParent_Done,
     /* 2376549 */   // Label 33433: @2376549
     /* 2376549 */   GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2376594), // Rule ID 50517 //
     /* 2376554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376557 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2376574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376593 */     // GIR_Coverage, 50517,
     /* 2376593 */     GIR_EraseRootFromParent_Done,
     /* 2376594 */   // Label 33434: @2376594
     /* 2376594 */   GIM_Reject,
     /* 2376595 */ // Label 33432: @2376595
     /* 2376595 */ GIM_Reject,
     /* 2376596 */ // Label 33388: @2376596
     /* 2376596 */ GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2376710),
     /* 2376601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2376604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2376607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376619 */   GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2376664), // Rule ID 50536 //
     /* 2376624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376627 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376663 */     // GIR_Coverage, 50536,
     /* 2376663 */     GIR_EraseRootFromParent_Done,
     /* 2376664 */   // Label 33436: @2376664
     /* 2376664 */   GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2376709), // Rule ID 50537 //
     /* 2376669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376672 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376708 */     // GIR_Coverage, 50537,
     /* 2376708 */     GIR_EraseRootFromParent_Done,
     /* 2376709 */   // Label 33437: @2376709
     /* 2376709 */   GIM_Reject,
     /* 2376710 */ // Label 33435: @2376710
     /* 2376710 */ GIM_Reject,
     /* 2376711 */ // Label 33389: @2376711
     /* 2376711 */ GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2376825),
     /* 2376716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2376719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2376722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376734 */   GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2376779), // Rule ID 50572 //
     /* 2376739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376742 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376778 */     // GIR_Coverage, 50572,
     /* 2376778 */     GIR_EraseRootFromParent_Done,
     /* 2376779 */   // Label 33439: @2376779
     /* 2376779 */   GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2376824), // Rule ID 50573 //
     /* 2376784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2376787 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2376804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376823 */     // GIR_Coverage, 50573,
     /* 2376823 */     GIR_EraseRootFromParent_Done,
     /* 2376824 */   // Label 33440: @2376824
     /* 2376824 */   GIM_Reject,
     /* 2376825 */ // Label 33438: @2376825
     /* 2376825 */ GIM_Reject,
     /* 2376826 */ // Label 33390: @2376826
     /* 2376826 */ GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2376940),
     /* 2376831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2376834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2376837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376849 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2376894), // Rule ID 50588 //
     /* 2376854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2376857 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2376874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376893 */     // GIR_Coverage, 50588,
     /* 2376893 */     GIR_EraseRootFromParent_Done,
     /* 2376894 */   // Label 33442: @2376894
     /* 2376894 */   GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2376939), // Rule ID 50589 //
     /* 2376899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2376902 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2376919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376938 */     // GIR_Coverage, 50589,
     /* 2376938 */     GIR_EraseRootFromParent_Done,
     /* 2376939 */   // Label 33443: @2376939
     /* 2376939 */   GIM_Reject,
     /* 2376940 */ // Label 33441: @2376940
     /* 2376940 */ GIM_Reject,
     /* 2376941 */ // Label 33391: @2376941
     /* 2376941 */ GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2377055),
     /* 2376946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2376949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2376952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376964 */   GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2377009), // Rule ID 50532 //
     /* 2376969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2376972 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2376989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377008 */     // GIR_Coverage, 50532,
     /* 2377008 */     GIR_EraseRootFromParent_Done,
     /* 2377009 */   // Label 33445: @2377009
     /* 2377009 */   GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2377054), // Rule ID 50533 //
     /* 2377014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377017 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2377034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377053 */     // GIR_Coverage, 50533,
     /* 2377053 */     GIR_EraseRootFromParent_Done,
     /* 2377054 */   // Label 33446: @2377054
     /* 2377054 */   GIM_Reject,
     /* 2377055 */ // Label 33444: @2377055
     /* 2377055 */ GIM_Reject,
     /* 2377056 */ // Label 33392: @2377056
     /* 2377056 */ GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2377170),
     /* 2377061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2377064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2377067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377079 */   GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2377124), // Rule ID 50560 //
     /* 2377084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377087 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377123 */     // GIR_Coverage, 50560,
     /* 2377123 */     GIR_EraseRootFromParent_Done,
     /* 2377124 */   // Label 33448: @2377124
     /* 2377124 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2377169), // Rule ID 50561 //
     /* 2377129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377132 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377168 */     // GIR_Coverage, 50561,
     /* 2377168 */     GIR_EraseRootFromParent_Done,
     /* 2377169 */   // Label 33449: @2377169
     /* 2377169 */   GIM_Reject,
     /* 2377170 */ // Label 33447: @2377170
     /* 2377170 */ GIM_Reject,
     /* 2377171 */ // Label 33393: @2377171
     /* 2377171 */ GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2377285),
     /* 2377176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2377179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2377182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377194 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2377239), // Rule ID 50576 //
     /* 2377199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377202 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377238 */     // GIR_Coverage, 50576,
     /* 2377238 */     GIR_EraseRootFromParent_Done,
     /* 2377239 */   // Label 33451: @2377239
     /* 2377239 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2377284), // Rule ID 50577 //
     /* 2377244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377247 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377283 */     // GIR_Coverage, 50577,
     /* 2377283 */     GIR_EraseRootFromParent_Done,
     /* 2377284 */   // Label 33452: @2377284
     /* 2377284 */   GIM_Reject,
     /* 2377285 */ // Label 33450: @2377285
     /* 2377285 */ GIM_Reject,
     /* 2377286 */ // Label 33394: @2377286
     /* 2377286 */ GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2377400),
     /* 2377291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2377294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2377297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377309 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2377354), // Rule ID 50592 //
     /* 2377314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2377317 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377353 */     // GIR_Coverage, 50592,
     /* 2377353 */     GIR_EraseRootFromParent_Done,
     /* 2377354 */   // Label 33454: @2377354
     /* 2377354 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2377399), // Rule ID 50593 //
     /* 2377359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2377362 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377398 */     // GIR_Coverage, 50593,
     /* 2377398 */     GIR_EraseRootFromParent_Done,
     /* 2377399 */   // Label 33455: @2377399
     /* 2377399 */   GIM_Reject,
     /* 2377400 */ // Label 33453: @2377400
     /* 2377400 */ GIM_Reject,
     /* 2377401 */ // Label 33395: @2377401
     /* 2377401 */ GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2377515),
     /* 2377406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2377409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2377412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377424 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2377469), // Rule ID 50548 //
     /* 2377429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377432 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377468 */     // GIR_Coverage, 50548,
     /* 2377468 */     GIR_EraseRootFromParent_Done,
     /* 2377469 */   // Label 33457: @2377469
     /* 2377469 */   GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2377514), // Rule ID 50549 //
     /* 2377474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377477 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2377494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377513 */     // GIR_Coverage, 50549,
     /* 2377513 */     GIR_EraseRootFromParent_Done,
     /* 2377514 */   // Label 33458: @2377514
     /* 2377514 */   GIM_Reject,
     /* 2377515 */ // Label 33456: @2377515
     /* 2377515 */ GIM_Reject,
     /* 2377516 */ // Label 33396: @2377516
     /* 2377516 */ GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2377630),
     /* 2377521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2377524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2377527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377539 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2377584), // Rule ID 50564 //
     /* 2377544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377547 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377583 */     // GIR_Coverage, 50564,
     /* 2377583 */     GIR_EraseRootFromParent_Done,
     /* 2377584 */   // Label 33460: @2377584
     /* 2377584 */   GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2377629), // Rule ID 50565 //
     /* 2377589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377592 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377628 */     // GIR_Coverage, 50565,
     /* 2377628 */     GIR_EraseRootFromParent_Done,
     /* 2377629 */   // Label 33461: @2377629
     /* 2377629 */   GIM_Reject,
     /* 2377630 */ // Label 33459: @2377630
     /* 2377630 */ GIM_Reject,
     /* 2377631 */ // Label 33397: @2377631
     /* 2377631 */ GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2377745),
     /* 2377636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2377639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2377642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377654 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2377699), // Rule ID 50580 //
     /* 2377659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377662 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377698 */     // GIR_Coverage, 50580,
     /* 2377698 */     GIR_EraseRootFromParent_Done,
     /* 2377699 */   // Label 33463: @2377699
     /* 2377699 */   GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2377744), // Rule ID 50581 //
     /* 2377704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377707 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377743 */     // GIR_Coverage, 50581,
     /* 2377743 */     GIR_EraseRootFromParent_Done,
     /* 2377744 */   // Label 33464: @2377744
     /* 2377744 */   GIM_Reject,
     /* 2377745 */ // Label 33462: @2377745
     /* 2377745 */ GIM_Reject,
     /* 2377746 */ // Label 33398: @2377746
     /* 2377746 */ GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2377860),
     /* 2377751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2377754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2377757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377769 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2377814), // Rule ID 50552 //
     /* 2377774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377777 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377813 */     // GIR_Coverage, 50552,
     /* 2377813 */     GIR_EraseRootFromParent_Done,
     /* 2377814 */   // Label 33466: @2377814
     /* 2377814 */   GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2377859), // Rule ID 50553 //
     /* 2377819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377822 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2377839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377858 */     // GIR_Coverage, 50553,
     /* 2377858 */     GIR_EraseRootFromParent_Done,
     /* 2377859 */   // Label 33467: @2377859
     /* 2377859 */   GIM_Reject,
     /* 2377860 */ // Label 33465: @2377860
     /* 2377860 */ GIM_Reject,
     /* 2377861 */ // Label 33399: @2377861
     /* 2377861 */ GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2377975),
     /* 2377866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2377869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2377872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377884 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2377929), // Rule ID 50568 //
     /* 2377889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2377892 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377928 */     // GIR_Coverage, 50568,
     /* 2377928 */     GIR_EraseRootFromParent_Done,
     /* 2377929 */   // Label 33469: @2377929
     /* 2377929 */   GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2377974), // Rule ID 50569 //
     /* 2377934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2377937 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2377954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377973 */     // GIR_Coverage, 50569,
     /* 2377973 */     GIR_EraseRootFromParent_Done,
     /* 2377974 */   // Label 33470: @2377974
     /* 2377974 */   GIM_Reject,
     /* 2377975 */ // Label 33468: @2377975
     /* 2377975 */ GIM_Reject,
     /* 2377976 */ // Label 33400: @2377976
     /* 2377976 */ GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2378090),
     /* 2377981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2377984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2377987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377999 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2378044), // Rule ID 50556 //
     /* 2378004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378007 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2378024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378043 */     // GIR_Coverage, 50556,
     /* 2378043 */     GIR_EraseRootFromParent_Done,
     /* 2378044 */   // Label 33472: @2378044
     /* 2378044 */   GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2378089), // Rule ID 50557 //
     /* 2378049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378052 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2378069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378088 */     // GIR_Coverage, 50557,
     /* 2378088 */     GIR_EraseRootFromParent_Done,
     /* 2378089 */   // Label 33473: @2378089
     /* 2378089 */   GIM_Reject,
     /* 2378090 */ // Label 33471: @2378090
     /* 2378090 */ GIM_Reject,
     /* 2378091 */ // Label 33401: @2378091
     /* 2378091 */ GIM_Reject,
     /* 2378092 */ // Label 83: @2378092
     /* 2378092 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33498*/ GIMT_Encode4(2380867),
     /* 2378103 */ /*GILLT_s32*//*Label 33474*/ GIMT_Encode4(2378227),
     /* 2378107 */ /*GILLT_s64*//*Label 33475*/ GIMT_Encode4(2378282), GIMT_Encode4(0),
     /* 2378115 */ /*GILLT_nxv1s8*//*Label 33476*/ GIMT_Encode4(2378337),
     /* 2378119 */ /*GILLT_nxv1s16*//*Label 33477*/ GIMT_Encode4(2378452),
     /* 2378123 */ /*GILLT_nxv1s32*//*Label 33478*/ GIMT_Encode4(2378567),
     /* 2378127 */ /*GILLT_nxv1s64*//*Label 33479*/ GIMT_Encode4(2378682), GIMT_Encode4(0),
     /* 2378135 */ /*GILLT_nxv2s8*//*Label 33480*/ GIMT_Encode4(2378797),
     /* 2378139 */ /*GILLT_nxv2s16*//*Label 33481*/ GIMT_Encode4(2378912),
     /* 2378143 */ /*GILLT_nxv2s32*//*Label 33482*/ GIMT_Encode4(2379027),
     /* 2378147 */ /*GILLT_nxv2s64*//*Label 33483*/ GIMT_Encode4(2379142), GIMT_Encode4(0),
     /* 2378155 */ /*GILLT_nxv4s8*//*Label 33484*/ GIMT_Encode4(2379257),
     /* 2378159 */ /*GILLT_nxv4s16*//*Label 33485*/ GIMT_Encode4(2379372),
     /* 2378163 */ /*GILLT_nxv4s32*//*Label 33486*/ GIMT_Encode4(2379487),
     /* 2378167 */ /*GILLT_nxv4s64*//*Label 33487*/ GIMT_Encode4(2379602), GIMT_Encode4(0),
     /* 2378175 */ /*GILLT_nxv8s8*//*Label 33488*/ GIMT_Encode4(2379717),
     /* 2378179 */ /*GILLT_nxv8s16*//*Label 33489*/ GIMT_Encode4(2379832),
     /* 2378183 */ /*GILLT_nxv8s32*//*Label 33490*/ GIMT_Encode4(2379947),
     /* 2378187 */ /*GILLT_nxv8s64*//*Label 33491*/ GIMT_Encode4(2380062), GIMT_Encode4(0),
     /* 2378195 */ /*GILLT_nxv16s8*//*Label 33492*/ GIMT_Encode4(2380177),
     /* 2378199 */ /*GILLT_nxv16s16*//*Label 33493*/ GIMT_Encode4(2380292),
     /* 2378203 */ /*GILLT_nxv16s32*//*Label 33494*/ GIMT_Encode4(2380407), GIMT_Encode4(0),
     /* 2378211 */ /*GILLT_nxv32s8*//*Label 33495*/ GIMT_Encode4(2380522),
     /* 2378215 */ /*GILLT_nxv32s16*//*Label 33496*/ GIMT_Encode4(2380637), GIMT_Encode4(0),
     /* 2378223 */ /*GILLT_nxv64s8*//*Label 33497*/ GIMT_Encode4(2380752),
     /* 2378227 */ // Label 33474: @2378227
     /* 2378227 */ GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2378281),
     /* 2378232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378250 */   GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2378265), // Rule ID 64472 //
     /* 2378255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2378258 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2378258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2378263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378264 */     // GIR_Coverage, 64472,
     /* 2378264 */     GIR_Done,
     /* 2378265 */   // Label 33500: @2378265
     /* 2378265 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2378280), // Rule ID 2537 //
     /* 2378270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2378273 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2378273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2378278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378279 */     // GIR_Coverage, 2537,
     /* 2378279 */     GIR_Done,
     /* 2378280 */   // Label 33501: @2378280
     /* 2378280 */   GIM_Reject,
     /* 2378281 */ // Label 33499: @2378281
     /* 2378281 */ GIM_Reject,
     /* 2378282 */ // Label 33475: @2378282
     /* 2378282 */ GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2378336),
     /* 2378287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2378293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378305 */   GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2378320), // Rule ID 64471 //
     /* 2378310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2378313 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2378313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2378318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378319 */     // GIR_Coverage, 64471,
     /* 2378319 */     GIR_Done,
     /* 2378320 */   // Label 33503: @2378320
     /* 2378320 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2378335), // Rule ID 2536 //
     /* 2378325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2378328 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2378328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2378333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378334 */     // GIR_Coverage, 2536,
     /* 2378334 */     GIR_Done,
     /* 2378335 */   // Label 33504: @2378335
     /* 2378335 */   GIM_Reject,
     /* 2378336 */ // Label 33502: @2378336
     /* 2378336 */ GIM_Reject,
     /* 2378337 */ // Label 33476: @2378337
     /* 2378337 */ GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2378451),
     /* 2378342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2378345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2378348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378360 */   GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2378405), // Rule ID 50684 //
     /* 2378365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378368 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2378385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378404 */     // GIR_Coverage, 50684,
     /* 2378404 */     GIR_EraseRootFromParent_Done,
     /* 2378405 */   // Label 33506: @2378405
     /* 2378405 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2378450), // Rule ID 50685 //
     /* 2378410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378413 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2378430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378449 */     // GIR_Coverage, 50685,
     /* 2378449 */     GIR_EraseRootFromParent_Done,
     /* 2378450 */   // Label 33507: @2378450
     /* 2378450 */   GIM_Reject,
     /* 2378451 */ // Label 33505: @2378451
     /* 2378451 */ GIM_Reject,
     /* 2378452 */ // Label 33477: @2378452
     /* 2378452 */ GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2378566),
     /* 2378457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2378460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2378463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378475 */   GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2378520), // Rule ID 50696 //
     /* 2378480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378483 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378519 */     // GIR_Coverage, 50696,
     /* 2378519 */     GIR_EraseRootFromParent_Done,
     /* 2378520 */   // Label 33509: @2378520
     /* 2378520 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2378565), // Rule ID 50697 //
     /* 2378525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378528 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378564 */     // GIR_Coverage, 50697,
     /* 2378564 */     GIR_EraseRootFromParent_Done,
     /* 2378565 */   // Label 33510: @2378565
     /* 2378565 */   GIM_Reject,
     /* 2378566 */ // Label 33508: @2378566
     /* 2378566 */ GIM_Reject,
     /* 2378567 */ // Label 33478: @2378567
     /* 2378567 */ GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2378681),
     /* 2378572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2378575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2378578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378590 */   GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2378635), // Rule ID 50704 //
     /* 2378595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378598 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378634 */     // GIR_Coverage, 50704,
     /* 2378634 */     GIR_EraseRootFromParent_Done,
     /* 2378635 */   // Label 33512: @2378635
     /* 2378635 */   GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2378680), // Rule ID 50705 //
     /* 2378640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378643 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378679 */     // GIR_Coverage, 50705,
     /* 2378679 */     GIR_EraseRootFromParent_Done,
     /* 2378680 */   // Label 33513: @2378680
     /* 2378680 */   GIM_Reject,
     /* 2378681 */ // Label 33511: @2378681
     /* 2378681 */ GIM_Reject,
     /* 2378682 */ // Label 33479: @2378682
     /* 2378682 */ GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2378796),
     /* 2378687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2378690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2378693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378705 */   GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2378750), // Rule ID 50720 //
     /* 2378710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2378713 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2378730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378749 */     // GIR_Coverage, 50720,
     /* 2378749 */     GIR_EraseRootFromParent_Done,
     /* 2378750 */   // Label 33515: @2378750
     /* 2378750 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2378795), // Rule ID 50721 //
     /* 2378755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2378758 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2378775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378794 */     // GIR_Coverage, 50721,
     /* 2378794 */     GIR_EraseRootFromParent_Done,
     /* 2378795 */   // Label 33516: @2378795
     /* 2378795 */   GIM_Reject,
     /* 2378796 */ // Label 33514: @2378796
     /* 2378796 */ GIM_Reject,
     /* 2378797 */ // Label 33480: @2378797
     /* 2378797 */ GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2378911),
     /* 2378802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2378805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2378808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378820 */   GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2378865), // Rule ID 50688 //
     /* 2378825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378828 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378864 */     // GIR_Coverage, 50688,
     /* 2378864 */     GIR_EraseRootFromParent_Done,
     /* 2378865 */   // Label 33518: @2378865
     /* 2378865 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2378910), // Rule ID 50689 //
     /* 2378870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378873 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2378876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2378890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378909 */     // GIR_Coverage, 50689,
     /* 2378909 */     GIR_EraseRootFromParent_Done,
     /* 2378910 */   // Label 33519: @2378910
     /* 2378910 */   GIM_Reject,
     /* 2378911 */ // Label 33517: @2378911
     /* 2378911 */ GIM_Reject,
     /* 2378912 */ // Label 33481: @2378912
     /* 2378912 */ GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2379026),
     /* 2378917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2378920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2378923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378935 */   GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2378980), // Rule ID 50700 //
     /* 2378940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2378943 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2378960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378979 */     // GIR_Coverage, 50700,
     /* 2378979 */     GIR_EraseRootFromParent_Done,
     /* 2378980 */   // Label 33521: @2378980
     /* 2378980 */   GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2379025), // Rule ID 50701 //
     /* 2378985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2378988 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379024 */     // GIR_Coverage, 50701,
     /* 2379024 */     GIR_EraseRootFromParent_Done,
     /* 2379025 */   // Label 33522: @2379025
     /* 2379025 */   GIM_Reject,
     /* 2379026 */ // Label 33520: @2379026
     /* 2379026 */ GIM_Reject,
     /* 2379027 */ // Label 33482: @2379027
     /* 2379027 */ GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2379141),
     /* 2379032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2379038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379050 */   GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2379095), // Rule ID 50716 //
     /* 2379055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379058 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379094 */     // GIR_Coverage, 50716,
     /* 2379094 */     GIR_EraseRootFromParent_Done,
     /* 2379095 */   // Label 33524: @2379095
     /* 2379095 */   GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2379140), // Rule ID 50717 //
     /* 2379100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379103 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379139 */     // GIR_Coverage, 50717,
     /* 2379139 */     GIR_EraseRootFromParent_Done,
     /* 2379140 */   // Label 33525: @2379140
     /* 2379140 */   GIM_Reject,
     /* 2379141 */ // Label 33523: @2379141
     /* 2379141 */ GIM_Reject,
     /* 2379142 */ // Label 33483: @2379142
     /* 2379142 */ GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2379256),
     /* 2379147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2379153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379165 */   GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2379210), // Rule ID 50760 //
     /* 2379170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2379173 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379209 */     // GIR_Coverage, 50760,
     /* 2379209 */     GIR_EraseRootFromParent_Done,
     /* 2379210 */   // Label 33527: @2379210
     /* 2379210 */   GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2379255), // Rule ID 50761 //
     /* 2379215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2379218 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379254 */     // GIR_Coverage, 50761,
     /* 2379254 */     GIR_EraseRootFromParent_Done,
     /* 2379255 */   // Label 33528: @2379255
     /* 2379255 */   GIM_Reject,
     /* 2379256 */ // Label 33526: @2379256
     /* 2379256 */ GIM_Reject,
     /* 2379257 */ // Label 33484: @2379257
     /* 2379257 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2379371),
     /* 2379262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2379265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2379268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379280 */   GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2379325), // Rule ID 50692 //
     /* 2379285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379288 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379324 */     // GIR_Coverage, 50692,
     /* 2379324 */     GIR_EraseRootFromParent_Done,
     /* 2379325 */   // Label 33530: @2379325
     /* 2379325 */   GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2379370), // Rule ID 50693 //
     /* 2379330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379333 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2379350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379369 */     // GIR_Coverage, 50693,
     /* 2379369 */     GIR_EraseRootFromParent_Done,
     /* 2379370 */   // Label 33531: @2379370
     /* 2379370 */   GIM_Reject,
     /* 2379371 */ // Label 33529: @2379371
     /* 2379371 */ GIM_Reject,
     /* 2379372 */ // Label 33485: @2379372
     /* 2379372 */ GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2379486),
     /* 2379377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2379380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2379383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379395 */   GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2379440), // Rule ID 50712 //
     /* 2379400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379403 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379439 */     // GIR_Coverage, 50712,
     /* 2379439 */     GIR_EraseRootFromParent_Done,
     /* 2379440 */   // Label 33533: @2379440
     /* 2379440 */   GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2379485), // Rule ID 50713 //
     /* 2379445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379448 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379484 */     // GIR_Coverage, 50713,
     /* 2379484 */     GIR_EraseRootFromParent_Done,
     /* 2379485 */   // Label 33534: @2379485
     /* 2379485 */   GIM_Reject,
     /* 2379486 */ // Label 33532: @2379486
     /* 2379486 */ GIM_Reject,
     /* 2379487 */ // Label 33486: @2379487
     /* 2379487 */ GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2379601),
     /* 2379492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2379495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2379498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379510 */   GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2379555), // Rule ID 50748 //
     /* 2379515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379518 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379554 */     // GIR_Coverage, 50748,
     /* 2379554 */     GIR_EraseRootFromParent_Done,
     /* 2379555 */   // Label 33536: @2379555
     /* 2379555 */   GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2379600), // Rule ID 50749 //
     /* 2379560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379563 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379599 */     // GIR_Coverage, 50749,
     /* 2379599 */     GIR_EraseRootFromParent_Done,
     /* 2379600 */   // Label 33537: @2379600
     /* 2379600 */   GIM_Reject,
     /* 2379601 */ // Label 33535: @2379601
     /* 2379601 */ GIM_Reject,
     /* 2379602 */ // Label 33487: @2379602
     /* 2379602 */ GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2379716),
     /* 2379607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2379610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2379613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379625 */   GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2379670), // Rule ID 50764 //
     /* 2379630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2379633 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2379650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379669 */     // GIR_Coverage, 50764,
     /* 2379669 */     GIR_EraseRootFromParent_Done,
     /* 2379670 */   // Label 33539: @2379670
     /* 2379670 */   GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2379715), // Rule ID 50765 //
     /* 2379675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2379678 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2379695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379714 */     // GIR_Coverage, 50765,
     /* 2379714 */     GIR_EraseRootFromParent_Done,
     /* 2379715 */   // Label 33540: @2379715
     /* 2379715 */   GIM_Reject,
     /* 2379716 */ // Label 33538: @2379716
     /* 2379716 */ GIM_Reject,
     /* 2379717 */ // Label 33488: @2379717
     /* 2379717 */ GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2379831),
     /* 2379722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2379725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2379728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379740 */   GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2379785), // Rule ID 50708 //
     /* 2379745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379748 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379784 */     // GIR_Coverage, 50708,
     /* 2379784 */     GIR_EraseRootFromParent_Done,
     /* 2379785 */   // Label 33542: @2379785
     /* 2379785 */   GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2379830), // Rule ID 50709 //
     /* 2379790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379793 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2379796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2379810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379829 */     // GIR_Coverage, 50709,
     /* 2379829 */     GIR_EraseRootFromParent_Done,
     /* 2379830 */   // Label 33543: @2379830
     /* 2379830 */   GIM_Reject,
     /* 2379831 */ // Label 33541: @2379831
     /* 2379831 */ GIM_Reject,
     /* 2379832 */ // Label 33489: @2379832
     /* 2379832 */ GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2379946),
     /* 2379837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2379840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2379843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379855 */   GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2379900), // Rule ID 50736 //
     /* 2379860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379863 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379899 */     // GIR_Coverage, 50736,
     /* 2379899 */     GIR_EraseRootFromParent_Done,
     /* 2379900 */   // Label 33545: @2379900
     /* 2379900 */   GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2379945), // Rule ID 50737 //
     /* 2379905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2379908 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2379925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379944 */     // GIR_Coverage, 50737,
     /* 2379944 */     GIR_EraseRootFromParent_Done,
     /* 2379945 */   // Label 33546: @2379945
     /* 2379945 */   GIM_Reject,
     /* 2379946 */ // Label 33544: @2379946
     /* 2379946 */ GIM_Reject,
     /* 2379947 */ // Label 33490: @2379947
     /* 2379947 */ GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2380061),
     /* 2379952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2379955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2379958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379970 */   GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2380015), // Rule ID 50752 //
     /* 2379975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2379978 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2379995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380014 */     // GIR_Coverage, 50752,
     /* 2380014 */     GIR_EraseRootFromParent_Done,
     /* 2380015 */   // Label 33548: @2380015
     /* 2380015 */   GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2380060), // Rule ID 50753 //
     /* 2380020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380023 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380059 */     // GIR_Coverage, 50753,
     /* 2380059 */     GIR_EraseRootFromParent_Done,
     /* 2380060 */   // Label 33549: @2380060
     /* 2380060 */   GIM_Reject,
     /* 2380061 */ // Label 33547: @2380061
     /* 2380061 */ GIM_Reject,
     /* 2380062 */ // Label 33491: @2380062
     /* 2380062 */ GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2380176),
     /* 2380067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2380073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380085 */   GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2380130), // Rule ID 50768 //
     /* 2380090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2380093 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380129 */     // GIR_Coverage, 50768,
     /* 2380129 */     GIR_EraseRootFromParent_Done,
     /* 2380130 */   // Label 33551: @2380130
     /* 2380130 */   GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2380175), // Rule ID 50769 //
     /* 2380135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2380138 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380174 */     // GIR_Coverage, 50769,
     /* 2380174 */     GIR_EraseRootFromParent_Done,
     /* 2380175 */   // Label 33552: @2380175
     /* 2380175 */   GIM_Reject,
     /* 2380176 */ // Label 33550: @2380176
     /* 2380176 */ GIM_Reject,
     /* 2380177 */ // Label 33492: @2380177
     /* 2380177 */ GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2380291),
     /* 2380182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2380185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2380188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380200 */   GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2380245), // Rule ID 50724 //
     /* 2380205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380208 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2380225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380244 */     // GIR_Coverage, 50724,
     /* 2380244 */     GIR_EraseRootFromParent_Done,
     /* 2380245 */   // Label 33554: @2380245
     /* 2380245 */   GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2380290), // Rule ID 50725 //
     /* 2380250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380253 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2380270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380289 */     // GIR_Coverage, 50725,
     /* 2380289 */     GIR_EraseRootFromParent_Done,
     /* 2380290 */   // Label 33555: @2380290
     /* 2380290 */   GIM_Reject,
     /* 2380291 */ // Label 33553: @2380291
     /* 2380291 */ GIM_Reject,
     /* 2380292 */ // Label 33493: @2380292
     /* 2380292 */ GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2380406),
     /* 2380297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2380303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380315 */   GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2380360), // Rule ID 50740 //
     /* 2380320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380323 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380359 */     // GIR_Coverage, 50740,
     /* 2380359 */     GIR_EraseRootFromParent_Done,
     /* 2380360 */   // Label 33557: @2380360
     /* 2380360 */   GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2380405), // Rule ID 50741 //
     /* 2380365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380368 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380404 */     // GIR_Coverage, 50741,
     /* 2380404 */     GIR_EraseRootFromParent_Done,
     /* 2380405 */   // Label 33558: @2380405
     /* 2380405 */   GIM_Reject,
     /* 2380406 */ // Label 33556: @2380406
     /* 2380406 */ GIM_Reject,
     /* 2380407 */ // Label 33494: @2380407
     /* 2380407 */ GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2380521),
     /* 2380412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2380415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2380418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380430 */   GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2380475), // Rule ID 50756 //
     /* 2380435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380438 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380474 */     // GIR_Coverage, 50756,
     /* 2380474 */     GIR_EraseRootFromParent_Done,
     /* 2380475 */   // Label 33560: @2380475
     /* 2380475 */   GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2380520), // Rule ID 50757 //
     /* 2380480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380483 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380519 */     // GIR_Coverage, 50757,
     /* 2380519 */     GIR_EraseRootFromParent_Done,
     /* 2380520 */   // Label 33561: @2380520
     /* 2380520 */   GIM_Reject,
     /* 2380521 */ // Label 33559: @2380521
     /* 2380521 */ GIM_Reject,
     /* 2380522 */ // Label 33495: @2380522
     /* 2380522 */ GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2380636),
     /* 2380527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2380530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2380533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380545 */   GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2380590), // Rule ID 50728 //
     /* 2380550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380553 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380589 */     // GIR_Coverage, 50728,
     /* 2380589 */     GIR_EraseRootFromParent_Done,
     /* 2380590 */   // Label 33563: @2380590
     /* 2380590 */   GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2380635), // Rule ID 50729 //
     /* 2380595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380598 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2380615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380634 */     // GIR_Coverage, 50729,
     /* 2380634 */     GIR_EraseRootFromParent_Done,
     /* 2380635 */   // Label 33564: @2380635
     /* 2380635 */   GIM_Reject,
     /* 2380636 */ // Label 33562: @2380636
     /* 2380636 */ GIM_Reject,
     /* 2380637 */ // Label 33496: @2380637
     /* 2380637 */ GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2380751),
     /* 2380642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2380645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2380648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380660 */   GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2380705), // Rule ID 50744 //
     /* 2380665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380668 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380704 */     // GIR_Coverage, 50744,
     /* 2380704 */     GIR_EraseRootFromParent_Done,
     /* 2380705 */   // Label 33566: @2380705
     /* 2380705 */   GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2380750), // Rule ID 50745 //
     /* 2380710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380713 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380749 */     // GIR_Coverage, 50745,
     /* 2380749 */     GIR_EraseRootFromParent_Done,
     /* 2380750 */   // Label 33567: @2380750
     /* 2380750 */   GIM_Reject,
     /* 2380751 */ // Label 33565: @2380751
     /* 2380751 */ GIM_Reject,
     /* 2380752 */ // Label 33497: @2380752
     /* 2380752 */ GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2380866),
     /* 2380757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2380760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2380763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380775 */   GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2380820), // Rule ID 50732 //
     /* 2380780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2380783 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380819 */     // GIR_Coverage, 50732,
     /* 2380819 */     GIR_EraseRootFromParent_Done,
     /* 2380820 */   // Label 33569: @2380820
     /* 2380820 */   GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2380865), // Rule ID 50733 //
     /* 2380825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2380828 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2380831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2380845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380864 */     // GIR_Coverage, 50733,
     /* 2380864 */     GIR_EraseRootFromParent_Done,
     /* 2380865 */   // Label 33570: @2380865
     /* 2380865 */   GIM_Reject,
     /* 2380866 */ // Label 33568: @2380866
     /* 2380866 */ GIM_Reject,
     /* 2380867 */ // Label 33498: @2380867
     /* 2380867 */ GIM_Reject,
     /* 2380868 */ // Label 84: @2380868
     /* 2380868 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33573*/ GIMT_Encode4(2381025),
     /* 2380879 */ /*GILLT_s32*//*Label 33571*/ GIMT_Encode4(2380887),
     /* 2380883 */ /*GILLT_s64*//*Label 33572*/ GIMT_Encode4(2380956),
     /* 2380887 */ // Label 33571: @2380887
     /* 2380887 */ GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2380955),
     /* 2380892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380903 */   GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2380918), // Rule ID 64460 //
     /* 2380908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2380911 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2380911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2380916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380917 */     // GIR_Coverage, 64460,
     /* 2380917 */     GIR_Done,
     /* 2380918 */   // Label 33575: @2380918
     /* 2380918 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2380954), // Rule ID 62515 //
     /* 2380923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2380926 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2380926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2380929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2380931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2380939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2380942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2380950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380953 */     // GIR_Coverage, 62515,
     /* 2380953 */     GIR_EraseRootFromParent_Done,
     /* 2380954 */   // Label 33576: @2380954
     /* 2380954 */   GIM_Reject,
     /* 2380955 */ // Label 33574: @2380955
     /* 2380955 */ GIM_Reject,
     /* 2380956 */ // Label 33572: @2380956
     /* 2380956 */ GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2381024),
     /* 2380961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2380972 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2380987), // Rule ID 64459 //
     /* 2380977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2380980 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2380980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2380985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380986 */     // GIR_Coverage, 64459,
     /* 2380986 */     GIR_Done,
     /* 2380987 */   // Label 33578: @2380987
     /* 2380987 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2381023), // Rule ID 62514 //
     /* 2380992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2380995 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2380995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2380998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2381000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2381008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2381011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2381019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381022 */     // GIR_Coverage, 62514,
     /* 2381022 */     GIR_EraseRootFromParent_Done,
     /* 2381023 */   // Label 33579: @2381023
     /* 2381023 */   GIM_Reject,
     /* 2381024 */ // Label 33577: @2381024
     /* 2381024 */ GIM_Reject,
     /* 2381025 */ // Label 33573: @2381025
     /* 2381025 */ GIM_Reject,
     /* 2381026 */ // Label 85: @2381026
     /* 2381026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33582*/ GIMT_Encode4(2381605),
     /* 2381037 */ /*GILLT_s32*//*Label 33580*/ GIMT_Encode4(2381045),
     /* 2381041 */ /*GILLT_s64*//*Label 33581*/ GIMT_Encode4(2381418),
     /* 2381045 */ // Label 33580: @2381045
     /* 2381045 */ GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2381076), // Rule ID 1470 //
     /* 2381050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2381053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381064 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2381067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381075 */   // GIR_Coverage, 1470,
     /* 2381075 */   GIR_EraseRootFromParent_Done,
     /* 2381076 */ // Label 33583: @2381076
     /* 2381076 */ GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2381107), // Rule ID 1471 //
     /* 2381081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2381084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381095 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2381095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2381098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381100 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381106 */   // GIR_Coverage, 1471,
     /* 2381106 */   GIR_EraseRootFromParent_Done,
     /* 2381107 */ // Label 33584: @2381107
     /* 2381107 */ GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2381138), // Rule ID 1496 //
     /* 2381112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2381115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381126 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2381129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381137 */   // GIR_Coverage, 1496,
     /* 2381137 */   GIR_EraseRootFromParent_Done,
     /* 2381138 */ // Label 33585: @2381138
     /* 2381138 */ GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2381169), // Rule ID 1497 //
     /* 2381143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2381146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381157 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2381157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2381160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381162 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381168 */   // GIR_Coverage, 1497,
     /* 2381168 */   GIR_EraseRootFromParent_Done,
     /* 2381169 */ // Label 33586: @2381169
     /* 2381169 */ GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2381200), // Rule ID 1864 //
     /* 2381174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2381177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381188 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2381191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381193 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381199 */   // GIR_Coverage, 1864,
     /* 2381199 */   GIR_EraseRootFromParent_Done,
     /* 2381200 */ // Label 33587: @2381200
     /* 2381200 */ GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2381231), // Rule ID 1865 //
     /* 2381205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2381208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381219 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2381219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2381222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381224 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381230 */   // GIR_Coverage, 1865,
     /* 2381230 */   GIR_EraseRootFromParent_Done,
     /* 2381231 */ // Label 33588: @2381231
     /* 2381231 */ GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2381262), // Rule ID 1890 //
     /* 2381236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2381239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381250 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2381253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381255 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381261 */   // GIR_Coverage, 1890,
     /* 2381261 */   GIR_EraseRootFromParent_Done,
     /* 2381262 */ // Label 33589: @2381262
     /* 2381262 */ GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2381293), // Rule ID 1891 //
     /* 2381267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2381270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381281 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2381281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2381284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381292 */   // GIR_Coverage, 1891,
     /* 2381292 */   GIR_EraseRootFromParent_Done,
     /* 2381293 */ // Label 33590: @2381293
     /* 2381293 */ GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2381324), // Rule ID 2206 //
     /* 2381298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2381301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381312 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2381315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381317 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381323 */   // GIR_Coverage, 2206,
     /* 2381323 */   GIR_EraseRootFromParent_Done,
     /* 2381324 */ // Label 33591: @2381324
     /* 2381324 */ GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2381355), // Rule ID 2207 //
     /* 2381329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2381332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381343 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2381343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2381346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381354 */   // GIR_Coverage, 2207,
     /* 2381354 */   GIR_EraseRootFromParent_Done,
     /* 2381355 */ // Label 33592: @2381355
     /* 2381355 */ GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2381386), // Rule ID 2232 //
     /* 2381360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2381363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381374 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2381377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381385 */   // GIR_Coverage, 2232,
     /* 2381385 */   GIR_EraseRootFromParent_Done,
     /* 2381386 */ // Label 33593: @2381386
     /* 2381386 */ GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2381417), // Rule ID 2233 //
     /* 2381391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2381394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381405 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2381405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2381408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381410 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381416 */   // GIR_Coverage, 2233,
     /* 2381416 */   GIR_EraseRootFromParent_Done,
     /* 2381417 */ // Label 33594: @2381417
     /* 2381417 */ GIM_Reject,
     /* 2381418 */ // Label 33581: @2381418
     /* 2381418 */ GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2381449), // Rule ID 1523 //
     /* 2381423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2381426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381437 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2381440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381442 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381448 */   // GIR_Coverage, 1523,
     /* 2381448 */   GIR_EraseRootFromParent_Done,
     /* 2381449 */ // Label 33595: @2381449
     /* 2381449 */ GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2381480), // Rule ID 1551 //
     /* 2381454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2381457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381468 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2381471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381473 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381479 */   // GIR_Coverage, 1551,
     /* 2381479 */   GIR_EraseRootFromParent_Done,
     /* 2381480 */ // Label 33596: @2381480
     /* 2381480 */ GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2381511), // Rule ID 1921 //
     /* 2381485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2381488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381499 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2381502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381504 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381510 */   // GIR_Coverage, 1921,
     /* 2381510 */   GIR_EraseRootFromParent_Done,
     /* 2381511 */ // Label 33597: @2381511
     /* 2381511 */ GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2381542), // Rule ID 1949 //
     /* 2381516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381530 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2381533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381541 */   // GIR_Coverage, 1949,
     /* 2381541 */   GIR_EraseRootFromParent_Done,
     /* 2381542 */ // Label 33598: @2381542
     /* 2381542 */ GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2381573), // Rule ID 2257 //
     /* 2381547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2381550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381561 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2381564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381572 */   // GIR_Coverage, 2257,
     /* 2381572 */   GIR_EraseRootFromParent_Done,
     /* 2381573 */ // Label 33599: @2381573
     /* 2381573 */ GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2381604), // Rule ID 2283 //
     /* 2381578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2381581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381592 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2381595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381597 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381603 */   // GIR_Coverage, 2283,
     /* 2381603 */   GIR_EraseRootFromParent_Done,
     /* 2381604 */ // Label 33600: @2381604
     /* 2381604 */ GIM_Reject,
     /* 2381605 */ // Label 33582: @2381605
     /* 2381605 */ GIM_Reject,
     /* 2381606 */ // Label 86: @2381606
     /* 2381606 */ GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2381815),
     /* 2381611 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2381614 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33605*/ GIMT_Encode4(2381814),
     /* 2381625 */   /*GILLT_s16*//*Label 33602*/ GIMT_Encode4(2381637),
     /* 2381629 */   /*GILLT_s32*//*Label 33603*/ GIMT_Encode4(2381696),
     /* 2381633 */   /*GILLT_s64*//*Label 33604*/ GIMT_Encode4(2381755),
     /* 2381637 */   // Label 33602: @2381637
     /* 2381637 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2381695),
     /* 2381642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381646 */     GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2381670), // Rule ID 2259 //
     /* 2381651 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2381654 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381658 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2381661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381663 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381665 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381668 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381669 */       // GIR_Coverage, 2259,
     /* 2381669 */       GIR_EraseRootFromParent_Done,
     /* 2381670 */     // Label 33607: @2381670
     /* 2381670 */     GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2381694), // Rule ID 2285 //
     /* 2381675 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2381678 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381682 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2381682 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2381685 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381687 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381689 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381692 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381693 */       // GIR_Coverage, 2285,
     /* 2381693 */       GIR_EraseRootFromParent_Done,
     /* 2381694 */     // Label 33608: @2381694
     /* 2381694 */     GIM_Reject,
     /* 2381695 */   // Label 33606: @2381695
     /* 2381695 */   GIM_Reject,
     /* 2381696 */   // Label 33603: @2381696
     /* 2381696 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2381754),
     /* 2381701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381705 */     GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2381729), // Rule ID 1525 //
     /* 2381710 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2381713 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381717 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381717 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2381720 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381722 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381724 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381727 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381728 */       // GIR_Coverage, 1525,
     /* 2381728 */       GIR_EraseRootFromParent_Done,
     /* 2381729 */     // Label 33610: @2381729
     /* 2381729 */     GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2381753), // Rule ID 1553 //
     /* 2381734 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2381737 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381741 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2381741 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2381744 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381746 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381751 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381752 */       // GIR_Coverage, 1553,
     /* 2381752 */       GIR_EraseRootFromParent_Done,
     /* 2381753 */     // Label 33611: @2381753
     /* 2381753 */     GIM_Reject,
     /* 2381754 */   // Label 33609: @2381754
     /* 2381754 */   GIM_Reject,
     /* 2381755 */   // Label 33604: @2381755
     /* 2381755 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2381813),
     /* 2381760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381764 */     GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2381788), // Rule ID 1923 //
     /* 2381769 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2381772 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381776 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381776 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2381779 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381781 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381783 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381786 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381787 */       // GIR_Coverage, 1923,
     /* 2381787 */       GIR_EraseRootFromParent_Done,
     /* 2381788 */     // Label 33613: @2381788
     /* 2381788 */     GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2381812), // Rule ID 1951 //
     /* 2381793 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381796 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381800 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2381800 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2381803 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381805 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381807 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381810 */       GIR_RootConstrainSelectedInstOperands,
     /* 2381811 */       // GIR_Coverage, 1951,
     /* 2381811 */       GIR_EraseRootFromParent_Done,
     /* 2381812 */     // Label 33614: @2381812
     /* 2381812 */     GIM_Reject,
     /* 2381813 */   // Label 33612: @2381813
     /* 2381813 */   GIM_Reject,
     /* 2381814 */   // Label 33605: @2381814
     /* 2381814 */   GIM_Reject,
     /* 2381815 */ // Label 33601: @2381815
     /* 2381815 */ GIM_Reject,
     /* 2381816 */ // Label 87: @2381816
     /* 2381816 */ GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2381831), // Rule ID 4 //
     /* 2381821 */   // MIs[0] imm20
     /* 2381821 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2381824 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2381824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2381829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2381830 */   // GIR_Coverage, 4,
     /* 2381830 */   GIR_Done,
     /* 2381831 */ // Label 33615: @2381831
     /* 2381831 */ GIM_Reject,
     /* 2381832 */ // Label 88: @2381832
     /* 2381832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33640*/ GIMT_Encode4(2384459),
     /* 2381843 */ /*GILLT_s32*//*Label 33616*/ GIMT_Encode4(2381967),
     /* 2381847 */ /*GILLT_s64*//*Label 33617*/ GIMT_Encode4(2382123), GIMT_Encode4(0),
     /* 2381855 */ /*GILLT_nxv1s8*//*Label 33618*/ GIMT_Encode4(2382171),
     /* 2381859 */ /*GILLT_nxv1s16*//*Label 33619*/ GIMT_Encode4(2382275),
     /* 2381863 */ /*GILLT_nxv1s32*//*Label 33620*/ GIMT_Encode4(2382379),
     /* 2381867 */ /*GILLT_nxv1s64*//*Label 33621*/ GIMT_Encode4(2382483), GIMT_Encode4(0),
     /* 2381875 */ /*GILLT_nxv2s8*//*Label 33622*/ GIMT_Encode4(2382587),
     /* 2381879 */ /*GILLT_nxv2s16*//*Label 33623*/ GIMT_Encode4(2382691),
     /* 2381883 */ /*GILLT_nxv2s32*//*Label 33624*/ GIMT_Encode4(2382795),
     /* 2381887 */ /*GILLT_nxv2s64*//*Label 33625*/ GIMT_Encode4(2382899), GIMT_Encode4(0),
     /* 2381895 */ /*GILLT_nxv4s8*//*Label 33626*/ GIMT_Encode4(2383003),
     /* 2381899 */ /*GILLT_nxv4s16*//*Label 33627*/ GIMT_Encode4(2383107),
     /* 2381903 */ /*GILLT_nxv4s32*//*Label 33628*/ GIMT_Encode4(2383211),
     /* 2381907 */ /*GILLT_nxv4s64*//*Label 33629*/ GIMT_Encode4(2383315), GIMT_Encode4(0),
     /* 2381915 */ /*GILLT_nxv8s8*//*Label 33630*/ GIMT_Encode4(2383419),
     /* 2381919 */ /*GILLT_nxv8s16*//*Label 33631*/ GIMT_Encode4(2383523),
     /* 2381923 */ /*GILLT_nxv8s32*//*Label 33632*/ GIMT_Encode4(2383627),
     /* 2381927 */ /*GILLT_nxv8s64*//*Label 33633*/ GIMT_Encode4(2383731), GIMT_Encode4(0),
     /* 2381935 */ /*GILLT_nxv16s8*//*Label 33634*/ GIMT_Encode4(2383835),
     /* 2381939 */ /*GILLT_nxv16s16*//*Label 33635*/ GIMT_Encode4(2383939),
     /* 2381943 */ /*GILLT_nxv16s32*//*Label 33636*/ GIMT_Encode4(2384043), GIMT_Encode4(0),
     /* 2381951 */ /*GILLT_nxv32s8*//*Label 33637*/ GIMT_Encode4(2384147),
     /* 2381955 */ /*GILLT_nxv32s16*//*Label 33638*/ GIMT_Encode4(2384251), GIMT_Encode4(0),
     /* 2381963 */ /*GILLT_nxv64s8*//*Label 33639*/ GIMT_Encode4(2384355),
     /* 2381967 */ // Label 33616: @2381967
     /* 2381967 */ GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2382122),
     /* 2381972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381975 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2382025), // Rule ID 64641 //
     /* 2381980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2381983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2381987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2381991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2381995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2382003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2382012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2382014 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2382017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2382023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382024 */     // GIR_Coverage, 64641,
     /* 2382024 */     GIR_EraseRootFromParent_Done,
     /* 2382025 */   // Label 33642: @2382025
     /* 2382025 */   GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2382075), // Rule ID 64642 //
     /* 2382030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2382033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2382037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2382041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2382045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2382049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2382053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382058 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2382062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2382064 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2382067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2382073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382074 */     // GIR_Coverage, 64642,
     /* 2382074 */     GIR_EraseRootFromParent_Done,
     /* 2382075 */   // Label 33643: @2382075
     /* 2382075 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2382098), // Rule ID 2519 //
     /* 2382080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2382083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382091 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2382096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382097 */     // GIR_Coverage, 2519,
     /* 2382097 */     GIR_Done,
     /* 2382098 */   // Label 33644: @2382098
     /* 2382098 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2382121), // Rule ID 64443 //
     /* 2382103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2382106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382114 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2382114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2382119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382120 */     // GIR_Coverage, 64443,
     /* 2382120 */     GIR_Done,
     /* 2382121 */   // Label 33645: @2382121
     /* 2382121 */   GIM_Reject,
     /* 2382122 */ // Label 33641: @2382122
     /* 2382122 */ GIM_Reject,
     /* 2382123 */ // Label 33617: @2382123
     /* 2382123 */ GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2382170),
     /* 2382128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2382131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2382139 */   GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2382154), // Rule ID 2518 //
     /* 2382144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2382147 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2382147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2382152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382153 */     // GIR_Coverage, 2518,
     /* 2382153 */     GIR_Done,
     /* 2382154 */   // Label 33647: @2382154
     /* 2382154 */   GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2382169), // Rule ID 64442 //
     /* 2382159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2382162 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2382162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2382167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382168 */     // GIR_Coverage, 64442,
     /* 2382168 */     GIR_Done,
     /* 2382169 */   // Label 33648: @2382169
     /* 2382169 */   GIM_Reject,
     /* 2382170 */ // Label 33646: @2382170
     /* 2382170 */ GIM_Reject,
     /* 2382171 */ // Label 33618: @2382171
     /* 2382171 */ GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2382274),
     /* 2382176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2382179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382187 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2382230), // Rule ID 59188 //
     /* 2382192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382195 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2382198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2382212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382229 */     // GIR_Coverage, 59188,
     /* 2382229 */     GIR_EraseRootFromParent_Done,
     /* 2382230 */   // Label 33650: @2382230
     /* 2382230 */   GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2382273), // Rule ID 59189 //
     /* 2382235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382238 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2382241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2382255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382272 */     // GIR_Coverage, 59189,
     /* 2382272 */     GIR_EraseRootFromParent_Done,
     /* 2382273 */   // Label 33651: @2382273
     /* 2382273 */   GIM_Reject,
     /* 2382274 */ // Label 33649: @2382274
     /* 2382274 */ GIM_Reject,
     /* 2382275 */ // Label 33619: @2382275
     /* 2382275 */ GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2382378),
     /* 2382280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2382283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382291 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2382334), // Rule ID 59194 //
     /* 2382296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382299 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2382302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382333 */     // GIR_Coverage, 59194,
     /* 2382333 */     GIR_EraseRootFromParent_Done,
     /* 2382334 */   // Label 33653: @2382334
     /* 2382334 */   GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2382377), // Rule ID 59195 //
     /* 2382339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382342 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2382345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382376 */     // GIR_Coverage, 59195,
     /* 2382376 */     GIR_EraseRootFromParent_Done,
     /* 2382377 */   // Label 33654: @2382377
     /* 2382377 */   GIM_Reject,
     /* 2382378 */ // Label 33652: @2382378
     /* 2382378 */ GIM_Reject,
     /* 2382379 */ // Label 33620: @2382379
     /* 2382379 */ GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2382482),
     /* 2382384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2382387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382395 */   GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2382438), // Rule ID 59198 //
     /* 2382400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382403 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382437 */     // GIR_Coverage, 59198,
     /* 2382437 */     GIR_EraseRootFromParent_Done,
     /* 2382438 */   // Label 33656: @2382438
     /* 2382438 */   GIM_Try, /*On fail goto*//*Label 33657*/ GIMT_Encode4(2382481), // Rule ID 59199 //
     /* 2382443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382446 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2382449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382480 */     // GIR_Coverage, 59199,
     /* 2382480 */     GIR_EraseRootFromParent_Done,
     /* 2382481 */   // Label 33657: @2382481
     /* 2382481 */   GIM_Reject,
     /* 2382482 */ // Label 33655: @2382482
     /* 2382482 */ GIM_Reject,
     /* 2382483 */ // Label 33621: @2382483
     /* 2382483 */ GIM_Try, /*On fail goto*//*Label 33658*/ GIMT_Encode4(2382586),
     /* 2382488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2382491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382499 */   GIM_Try, /*On fail goto*//*Label 33659*/ GIMT_Encode4(2382542), // Rule ID 59206 //
     /* 2382504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382507 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382541 */     // GIR_Coverage, 59206,
     /* 2382541 */     GIR_EraseRootFromParent_Done,
     /* 2382542 */   // Label 33659: @2382542
     /* 2382542 */   GIM_Try, /*On fail goto*//*Label 33660*/ GIMT_Encode4(2382585), // Rule ID 59207 //
     /* 2382547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382550 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2382553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382584 */     // GIR_Coverage, 59207,
     /* 2382584 */     GIR_EraseRootFromParent_Done,
     /* 2382585 */   // Label 33660: @2382585
     /* 2382585 */   GIM_Reject,
     /* 2382586 */ // Label 33658: @2382586
     /* 2382586 */ GIM_Reject,
     /* 2382587 */ // Label 33622: @2382587
     /* 2382587 */ GIM_Try, /*On fail goto*//*Label 33661*/ GIMT_Encode4(2382690),
     /* 2382592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2382595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382603 */   GIM_Try, /*On fail goto*//*Label 33662*/ GIMT_Encode4(2382646), // Rule ID 59190 //
     /* 2382608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382611 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382645 */     // GIR_Coverage, 59190,
     /* 2382645 */     GIR_EraseRootFromParent_Done,
     /* 2382646 */   // Label 33662: @2382646
     /* 2382646 */   GIM_Try, /*On fail goto*//*Label 33663*/ GIMT_Encode4(2382689), // Rule ID 59191 //
     /* 2382651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382654 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2382657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2382671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382688 */     // GIR_Coverage, 59191,
     /* 2382688 */     GIR_EraseRootFromParent_Done,
     /* 2382689 */   // Label 33663: @2382689
     /* 2382689 */   GIM_Reject,
     /* 2382690 */ // Label 33661: @2382690
     /* 2382690 */ GIM_Reject,
     /* 2382691 */ // Label 33623: @2382691
     /* 2382691 */ GIM_Try, /*On fail goto*//*Label 33664*/ GIMT_Encode4(2382794),
     /* 2382696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2382699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382707 */   GIM_Try, /*On fail goto*//*Label 33665*/ GIMT_Encode4(2382750), // Rule ID 59196 //
     /* 2382712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382715 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382749 */     // GIR_Coverage, 59196,
     /* 2382749 */     GIR_EraseRootFromParent_Done,
     /* 2382750 */   // Label 33665: @2382750
     /* 2382750 */   GIM_Try, /*On fail goto*//*Label 33666*/ GIMT_Encode4(2382793), // Rule ID 59197 //
     /* 2382755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382758 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2382775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382792 */     // GIR_Coverage, 59197,
     /* 2382792 */     GIR_EraseRootFromParent_Done,
     /* 2382793 */   // Label 33666: @2382793
     /* 2382793 */   GIM_Reject,
     /* 2382794 */ // Label 33664: @2382794
     /* 2382794 */ GIM_Reject,
     /* 2382795 */ // Label 33624: @2382795
     /* 2382795 */ GIM_Try, /*On fail goto*//*Label 33667*/ GIMT_Encode4(2382898),
     /* 2382800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2382803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382811 */   GIM_Try, /*On fail goto*//*Label 33668*/ GIMT_Encode4(2382854), // Rule ID 59204 //
     /* 2382816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382819 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382853 */     // GIR_Coverage, 59204,
     /* 2382853 */     GIR_EraseRootFromParent_Done,
     /* 2382854 */   // Label 33668: @2382854
     /* 2382854 */   GIM_Try, /*On fail goto*//*Label 33669*/ GIMT_Encode4(2382897), // Rule ID 59205 //
     /* 2382859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382862 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2382879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382896 */     // GIR_Coverage, 59205,
     /* 2382896 */     GIR_EraseRootFromParent_Done,
     /* 2382897 */   // Label 33669: @2382897
     /* 2382897 */   GIM_Reject,
     /* 2382898 */ // Label 33667: @2382898
     /* 2382898 */ GIM_Reject,
     /* 2382899 */ // Label 33625: @2382899
     /* 2382899 */ GIM_Try, /*On fail goto*//*Label 33670*/ GIMT_Encode4(2383002),
     /* 2382904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2382907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382915 */   GIM_Try, /*On fail goto*//*Label 33671*/ GIMT_Encode4(2382958), // Rule ID 59226 //
     /* 2382920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382923 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2382940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382957 */     // GIR_Coverage, 59226,
     /* 2382957 */     GIR_EraseRootFromParent_Done,
     /* 2382958 */   // Label 33671: @2382958
     /* 2382958 */   GIM_Try, /*On fail goto*//*Label 33672*/ GIMT_Encode4(2383001), // Rule ID 59227 //
     /* 2382963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382966 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2382983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383000 */     // GIR_Coverage, 59227,
     /* 2383000 */     GIR_EraseRootFromParent_Done,
     /* 2383001 */   // Label 33672: @2383001
     /* 2383001 */   GIM_Reject,
     /* 2383002 */ // Label 33670: @2383002
     /* 2383002 */ GIM_Reject,
     /* 2383003 */ // Label 33626: @2383003
     /* 2383003 */ GIM_Try, /*On fail goto*//*Label 33673*/ GIMT_Encode4(2383106),
     /* 2383008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2383011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383019 */   GIM_Try, /*On fail goto*//*Label 33674*/ GIMT_Encode4(2383062), // Rule ID 59192 //
     /* 2383024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383027 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2383030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2383044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383061 */     // GIR_Coverage, 59192,
     /* 2383061 */     GIR_EraseRootFromParent_Done,
     /* 2383062 */   // Label 33674: @2383062
     /* 2383062 */   GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2383105), // Rule ID 59193 //
     /* 2383067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383070 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2383073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2383087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383104 */     // GIR_Coverage, 59193,
     /* 2383104 */     GIR_EraseRootFromParent_Done,
     /* 2383105 */   // Label 33675: @2383105
     /* 2383105 */   GIM_Reject,
     /* 2383106 */ // Label 33673: @2383106
     /* 2383106 */ GIM_Reject,
     /* 2383107 */ // Label 33627: @2383107
     /* 2383107 */ GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2383210),
     /* 2383112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2383115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383123 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2383166), // Rule ID 59202 //
     /* 2383128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383131 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2383134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383165 */     // GIR_Coverage, 59202,
     /* 2383165 */     GIR_EraseRootFromParent_Done,
     /* 2383166 */   // Label 33677: @2383166
     /* 2383166 */   GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2383209), // Rule ID 59203 //
     /* 2383171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383174 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2383177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383208 */     // GIR_Coverage, 59203,
     /* 2383208 */     GIR_EraseRootFromParent_Done,
     /* 2383209 */   // Label 33678: @2383209
     /* 2383209 */   GIM_Reject,
     /* 2383210 */ // Label 33676: @2383210
     /* 2383210 */ GIM_Reject,
     /* 2383211 */ // Label 33628: @2383211
     /* 2383211 */ GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2383314),
     /* 2383216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2383219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383227 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2383270), // Rule ID 59220 //
     /* 2383232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383235 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2383238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383269 */     // GIR_Coverage, 59220,
     /* 2383269 */     GIR_EraseRootFromParent_Done,
     /* 2383270 */   // Label 33680: @2383270
     /* 2383270 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2383313), // Rule ID 59221 //
     /* 2383275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383278 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2383281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383312 */     // GIR_Coverage, 59221,
     /* 2383312 */     GIR_EraseRootFromParent_Done,
     /* 2383313 */   // Label 33681: @2383313
     /* 2383313 */   GIM_Reject,
     /* 2383314 */ // Label 33679: @2383314
     /* 2383314 */ GIM_Reject,
     /* 2383315 */ // Label 33629: @2383315
     /* 2383315 */ GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2383418),
     /* 2383320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2383323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383331 */   GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2383374), // Rule ID 59228 //
     /* 2383336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383339 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2383342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383373 */     // GIR_Coverage, 59228,
     /* 2383373 */     GIR_EraseRootFromParent_Done,
     /* 2383374 */   // Label 33683: @2383374
     /* 2383374 */   GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2383417), // Rule ID 59229 //
     /* 2383379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2383382 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2383385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383416 */     // GIR_Coverage, 59229,
     /* 2383416 */     GIR_EraseRootFromParent_Done,
     /* 2383417 */   // Label 33684: @2383417
     /* 2383417 */   GIM_Reject,
     /* 2383418 */ // Label 33682: @2383418
     /* 2383418 */ GIM_Reject,
     /* 2383419 */ // Label 33630: @2383419
     /* 2383419 */ GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2383522),
     /* 2383424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2383427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383435 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2383478), // Rule ID 59200 //
     /* 2383440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383443 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383477 */     // GIR_Coverage, 59200,
     /* 2383477 */     GIR_EraseRootFromParent_Done,
     /* 2383478 */   // Label 33686: @2383478
     /* 2383478 */   GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2383521), // Rule ID 59201 //
     /* 2383483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383486 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2383489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2383503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383520 */     // GIR_Coverage, 59201,
     /* 2383520 */     GIR_EraseRootFromParent_Done,
     /* 2383521 */   // Label 33687: @2383521
     /* 2383521 */   GIM_Reject,
     /* 2383522 */ // Label 33685: @2383522
     /* 2383522 */ GIM_Reject,
     /* 2383523 */ // Label 33631: @2383523
     /* 2383523 */ GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2383626),
     /* 2383528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2383531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383539 */   GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2383582), // Rule ID 59214 //
     /* 2383544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383547 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383581 */     // GIR_Coverage, 59214,
     /* 2383581 */     GIR_EraseRootFromParent_Done,
     /* 2383582 */   // Label 33689: @2383582
     /* 2383582 */   GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2383625), // Rule ID 59215 //
     /* 2383587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383590 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2383593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383624 */     // GIR_Coverage, 59215,
     /* 2383624 */     GIR_EraseRootFromParent_Done,
     /* 2383625 */   // Label 33690: @2383625
     /* 2383625 */   GIM_Reject,
     /* 2383626 */ // Label 33688: @2383626
     /* 2383626 */ GIM_Reject,
     /* 2383627 */ // Label 33632: @2383627
     /* 2383627 */ GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2383730),
     /* 2383632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2383635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383643 */   GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2383686), // Rule ID 59222 //
     /* 2383648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383651 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383685 */     // GIR_Coverage, 59222,
     /* 2383685 */     GIR_EraseRootFromParent_Done,
     /* 2383686 */   // Label 33692: @2383686
     /* 2383686 */   GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2383729), // Rule ID 59223 //
     /* 2383691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383694 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2383697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383728 */     // GIR_Coverage, 59223,
     /* 2383728 */     GIR_EraseRootFromParent_Done,
     /* 2383729 */   // Label 33693: @2383729
     /* 2383729 */   GIM_Reject,
     /* 2383730 */ // Label 33691: @2383730
     /* 2383730 */ GIM_Reject,
     /* 2383731 */ // Label 33633: @2383731
     /* 2383731 */ GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2383834),
     /* 2383736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2383739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383747 */   GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2383790), // Rule ID 59230 //
     /* 2383752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2383755 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2383772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383789 */     // GIR_Coverage, 59230,
     /* 2383789 */     GIR_EraseRootFromParent_Done,
     /* 2383790 */   // Label 33695: @2383790
     /* 2383790 */   GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2383833), // Rule ID 59231 //
     /* 2383795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2383798 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2383815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383832 */     // GIR_Coverage, 59231,
     /* 2383832 */     GIR_EraseRootFromParent_Done,
     /* 2383833 */   // Label 33696: @2383833
     /* 2383833 */   GIM_Reject,
     /* 2383834 */ // Label 33694: @2383834
     /* 2383834 */ GIM_Reject,
     /* 2383835 */ // Label 33634: @2383835
     /* 2383835 */ GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2383938),
     /* 2383840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2383843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383851 */   GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2383894), // Rule ID 59208 //
     /* 2383856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383859 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383893 */     // GIR_Coverage, 59208,
     /* 2383893 */     GIR_EraseRootFromParent_Done,
     /* 2383894 */   // Label 33698: @2383894
     /* 2383894 */   GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2383937), // Rule ID 59209 //
     /* 2383899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383902 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2383919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383936 */     // GIR_Coverage, 59209,
     /* 2383936 */     GIR_EraseRootFromParent_Done,
     /* 2383937 */   // Label 33699: @2383937
     /* 2383937 */   GIM_Reject,
     /* 2383938 */ // Label 33697: @2383938
     /* 2383938 */ GIM_Reject,
     /* 2383939 */ // Label 33635: @2383939
     /* 2383939 */ GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2384042),
     /* 2383944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2383947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383955 */   GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2383998), // Rule ID 59216 //
     /* 2383960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383963 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2383980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383997 */     // GIR_Coverage, 59216,
     /* 2383997 */     GIR_EraseRootFromParent_Done,
     /* 2383998 */   // Label 33701: @2383998
     /* 2383998 */   GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2384041), // Rule ID 59217 //
     /* 2384003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384006 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2384009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384040 */     // GIR_Coverage, 59217,
     /* 2384040 */     GIR_EraseRootFromParent_Done,
     /* 2384041 */   // Label 33702: @2384041
     /* 2384041 */   GIM_Reject,
     /* 2384042 */ // Label 33700: @2384042
     /* 2384042 */ GIM_Reject,
     /* 2384043 */ // Label 33636: @2384043
     /* 2384043 */ GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2384146),
     /* 2384048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2384051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384059 */   GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2384102), // Rule ID 59224 //
     /* 2384064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384067 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2384070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384101 */     // GIR_Coverage, 59224,
     /* 2384101 */     GIR_EraseRootFromParent_Done,
     /* 2384102 */   // Label 33704: @2384102
     /* 2384102 */   GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2384145), // Rule ID 59225 //
     /* 2384107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384110 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2384113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384144 */     // GIR_Coverage, 59225,
     /* 2384144 */     GIR_EraseRootFromParent_Done,
     /* 2384145 */   // Label 33705: @2384145
     /* 2384145 */   GIM_Reject,
     /* 2384146 */ // Label 33703: @2384146
     /* 2384146 */ GIM_Reject,
     /* 2384147 */ // Label 33637: @2384147
     /* 2384147 */ GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2384250),
     /* 2384152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2384155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384163 */   GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2384206), // Rule ID 59210 //
     /* 2384168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384171 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2384174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384205 */     // GIR_Coverage, 59210,
     /* 2384205 */     GIR_EraseRootFromParent_Done,
     /* 2384206 */   // Label 33707: @2384206
     /* 2384206 */   GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2384249), // Rule ID 59211 //
     /* 2384211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384214 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2384217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2384231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384248 */     // GIR_Coverage, 59211,
     /* 2384248 */     GIR_EraseRootFromParent_Done,
     /* 2384249 */   // Label 33708: @2384249
     /* 2384249 */   GIM_Reject,
     /* 2384250 */ // Label 33706: @2384250
     /* 2384250 */ GIM_Reject,
     /* 2384251 */ // Label 33638: @2384251
     /* 2384251 */ GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2384354),
     /* 2384256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2384259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384267 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2384310), // Rule ID 59218 //
     /* 2384272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384275 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2384278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384309 */     // GIR_Coverage, 59218,
     /* 2384309 */     GIR_EraseRootFromParent_Done,
     /* 2384310 */   // Label 33710: @2384310
     /* 2384310 */   GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2384353), // Rule ID 59219 //
     /* 2384315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384318 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2384321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384352 */     // GIR_Coverage, 59219,
     /* 2384352 */     GIR_EraseRootFromParent_Done,
     /* 2384353 */   // Label 33711: @2384353
     /* 2384353 */   GIM_Reject,
     /* 2384354 */ // Label 33709: @2384354
     /* 2384354 */ GIM_Reject,
     /* 2384355 */ // Label 33639: @2384355
     /* 2384355 */ GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2384458),
     /* 2384360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2384363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384371 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2384414), // Rule ID 59212 //
     /* 2384376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384379 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2384382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384413 */     // GIR_Coverage, 59212,
     /* 2384413 */     GIR_EraseRootFromParent_Done,
     /* 2384414 */   // Label 33713: @2384414
     /* 2384414 */   GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2384457), // Rule ID 59213 //
     /* 2384419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2384422 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2384425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2384439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384456 */     // GIR_Coverage, 59213,
     /* 2384456 */     GIR_EraseRootFromParent_Done,
     /* 2384457 */   // Label 33714: @2384457
     /* 2384457 */   GIM_Reject,
     /* 2384458 */ // Label 33712: @2384458
     /* 2384458 */ GIM_Reject,
     /* 2384459 */ // Label 33640: @2384459
     /* 2384459 */ GIM_Reject,
     /* 2384460 */ // Label 89: @2384460
     /* 2384460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33739*/ GIMT_Encode4(2387229),
     /* 2384471 */ /*GILLT_s32*//*Label 33715*/ GIMT_Encode4(2384595),
     /* 2384475 */ /*GILLT_s64*//*Label 33716*/ GIMT_Encode4(2384824), GIMT_Encode4(0),
     /* 2384483 */ /*GILLT_nxv1s8*//*Label 33717*/ GIMT_Encode4(2384941),
     /* 2384487 */ /*GILLT_nxv1s16*//*Label 33718*/ GIMT_Encode4(2385045),
     /* 2384491 */ /*GILLT_nxv1s32*//*Label 33719*/ GIMT_Encode4(2385149),
     /* 2384495 */ /*GILLT_nxv1s64*//*Label 33720*/ GIMT_Encode4(2385253), GIMT_Encode4(0),
     /* 2384503 */ /*GILLT_nxv2s8*//*Label 33721*/ GIMT_Encode4(2385357),
     /* 2384507 */ /*GILLT_nxv2s16*//*Label 33722*/ GIMT_Encode4(2385461),
     /* 2384511 */ /*GILLT_nxv2s32*//*Label 33723*/ GIMT_Encode4(2385565),
     /* 2384515 */ /*GILLT_nxv2s64*//*Label 33724*/ GIMT_Encode4(2385669), GIMT_Encode4(0),
     /* 2384523 */ /*GILLT_nxv4s8*//*Label 33725*/ GIMT_Encode4(2385773),
     /* 2384527 */ /*GILLT_nxv4s16*//*Label 33726*/ GIMT_Encode4(2385877),
     /* 2384531 */ /*GILLT_nxv4s32*//*Label 33727*/ GIMT_Encode4(2385981),
     /* 2384535 */ /*GILLT_nxv4s64*//*Label 33728*/ GIMT_Encode4(2386085), GIMT_Encode4(0),
     /* 2384543 */ /*GILLT_nxv8s8*//*Label 33729*/ GIMT_Encode4(2386189),
     /* 2384547 */ /*GILLT_nxv8s16*//*Label 33730*/ GIMT_Encode4(2386293),
     /* 2384551 */ /*GILLT_nxv8s32*//*Label 33731*/ GIMT_Encode4(2386397),
     /* 2384555 */ /*GILLT_nxv8s64*//*Label 33732*/ GIMT_Encode4(2386501), GIMT_Encode4(0),
     /* 2384563 */ /*GILLT_nxv16s8*//*Label 33733*/ GIMT_Encode4(2386605),
     /* 2384567 */ /*GILLT_nxv16s16*//*Label 33734*/ GIMT_Encode4(2386709),
     /* 2384571 */ /*GILLT_nxv16s32*//*Label 33735*/ GIMT_Encode4(2386813), GIMT_Encode4(0),
     /* 2384579 */ /*GILLT_nxv32s8*//*Label 33736*/ GIMT_Encode4(2386917),
     /* 2384583 */ /*GILLT_nxv32s16*//*Label 33737*/ GIMT_Encode4(2387021), GIMT_Encode4(0),
     /* 2384591 */ /*GILLT_nxv64s8*//*Label 33738*/ GIMT_Encode4(2387125),
     /* 2384595 */ // Label 33715: @2384595
     /* 2384595 */ GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2384823),
     /* 2384600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384603 */   GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2384653), // Rule ID 62568 //
     /* 2384608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2384611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384642 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2384645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384652 */     // GIR_Coverage, 62568,
     /* 2384652 */     GIR_EraseRootFromParent_Done,
     /* 2384653 */   // Label 33741: @2384653
     /* 2384653 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2384703), // Rule ID 64643 //
     /* 2384658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2384661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2384665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384692 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2384695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384702 */     // GIR_Coverage, 64643,
     /* 2384702 */     GIR_EraseRootFromParent_Done,
     /* 2384703 */   // Label 33742: @2384703
     /* 2384703 */   GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2384753), // Rule ID 64644 //
     /* 2384708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2384711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2384715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2384727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2384731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384742 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2384745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384752 */     // GIR_Coverage, 64644,
     /* 2384752 */     GIR_EraseRootFromParent_Done,
     /* 2384753 */   // Label 33743: @2384753
     /* 2384753 */   GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2384776), // Rule ID 2517 //
     /* 2384758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2384761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384769 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2384774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384775 */     // GIR_Coverage, 2517,
     /* 2384775 */     GIR_Done,
     /* 2384776 */   // Label 33744: @2384776
     /* 2384776 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2384799), // Rule ID 62566 //
     /* 2384781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2384784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384792 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2384797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384798 */     // GIR_Coverage, 62566,
     /* 2384798 */     GIR_Done,
     /* 2384799 */   // Label 33745: @2384799
     /* 2384799 */   GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2384822), // Rule ID 64445 //
     /* 2384804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2384807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384815 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2384815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2384820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384821 */     // GIR_Coverage, 64445,
     /* 2384821 */     GIR_Done,
     /* 2384822 */   // Label 33746: @2384822
     /* 2384822 */   GIM_Reject,
     /* 2384823 */ // Label 33740: @2384823
     /* 2384823 */ GIM_Reject,
     /* 2384824 */ // Label 33716: @2384824
     /* 2384824 */ GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2384940),
     /* 2384829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2384832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384836 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2384882), // Rule ID 62567 //
     /* 2384841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2384844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2384848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2384852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2384856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2384860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2384869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2384871 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2384874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2384880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384881 */     // GIR_Coverage, 62567,
     /* 2384881 */     GIR_EraseRootFromParent_Done,
     /* 2384882 */   // Label 33748: @2384882
     /* 2384882 */   GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2384901), // Rule ID 2516 //
     /* 2384887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2384890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384894 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2384899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384900 */     // GIR_Coverage, 2516,
     /* 2384900 */     GIR_Done,
     /* 2384901 */   // Label 33749: @2384901
     /* 2384901 */   GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2384920), // Rule ID 62565 //
     /* 2384906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2384909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384913 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2384918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384919 */     // GIR_Coverage, 62565,
     /* 2384919 */     GIR_Done,
     /* 2384920 */   // Label 33750: @2384920
     /* 2384920 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2384939), // Rule ID 64444 //
     /* 2384925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2384928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384932 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2384932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2384937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384938 */     // GIR_Coverage, 64444,
     /* 2384938 */     GIR_Done,
     /* 2384939 */   // Label 33751: @2384939
     /* 2384939 */   GIM_Reject,
     /* 2384940 */ // Label 33747: @2384940
     /* 2384940 */ GIM_Reject,
     /* 2384941 */ // Label 33717: @2384941
     /* 2384941 */ GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2385044),
     /* 2384946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2384949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384957 */   GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2385000), // Rule ID 59144 //
     /* 2384962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2384965 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2384968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2384982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384999 */     // GIR_Coverage, 59144,
     /* 2384999 */     GIR_EraseRootFromParent_Done,
     /* 2385000 */   // Label 33753: @2385000
     /* 2385000 */   GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2385043), // Rule ID 59145 //
     /* 2385005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385008 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2385011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2385025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385042 */     // GIR_Coverage, 59145,
     /* 2385042 */     GIR_EraseRootFromParent_Done,
     /* 2385043 */   // Label 33754: @2385043
     /* 2385043 */   GIM_Reject,
     /* 2385044 */ // Label 33752: @2385044
     /* 2385044 */ GIM_Reject,
     /* 2385045 */ // Label 33718: @2385045
     /* 2385045 */ GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2385148),
     /* 2385050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2385053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385061 */   GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2385104), // Rule ID 59150 //
     /* 2385066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385069 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385103 */     // GIR_Coverage, 59150,
     /* 2385103 */     GIR_EraseRootFromParent_Done,
     /* 2385104 */   // Label 33756: @2385104
     /* 2385104 */   GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2385147), // Rule ID 59151 //
     /* 2385109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385112 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385146 */     // GIR_Coverage, 59151,
     /* 2385146 */     GIR_EraseRootFromParent_Done,
     /* 2385147 */   // Label 33757: @2385147
     /* 2385147 */   GIM_Reject,
     /* 2385148 */ // Label 33755: @2385148
     /* 2385148 */ GIM_Reject,
     /* 2385149 */ // Label 33719: @2385149
     /* 2385149 */ GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2385252),
     /* 2385154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2385157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385165 */   GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2385208), // Rule ID 59154 //
     /* 2385170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385173 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2385176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385207 */     // GIR_Coverage, 59154,
     /* 2385207 */     GIR_EraseRootFromParent_Done,
     /* 2385208 */   // Label 33759: @2385208
     /* 2385208 */   GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2385251), // Rule ID 59155 //
     /* 2385213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385216 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2385219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385250 */     // GIR_Coverage, 59155,
     /* 2385250 */     GIR_EraseRootFromParent_Done,
     /* 2385251 */   // Label 33760: @2385251
     /* 2385251 */   GIM_Reject,
     /* 2385252 */ // Label 33758: @2385252
     /* 2385252 */ GIM_Reject,
     /* 2385253 */ // Label 33720: @2385253
     /* 2385253 */ GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2385356),
     /* 2385258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2385261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385269 */   GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2385312), // Rule ID 59162 //
     /* 2385274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2385277 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2385280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385311 */     // GIR_Coverage, 59162,
     /* 2385311 */     GIR_EraseRootFromParent_Done,
     /* 2385312 */   // Label 33762: @2385312
     /* 2385312 */   GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2385355), // Rule ID 59163 //
     /* 2385317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2385320 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2385323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385354 */     // GIR_Coverage, 59163,
     /* 2385354 */     GIR_EraseRootFromParent_Done,
     /* 2385355 */   // Label 33763: @2385355
     /* 2385355 */   GIM_Reject,
     /* 2385356 */ // Label 33761: @2385356
     /* 2385356 */ GIM_Reject,
     /* 2385357 */ // Label 33721: @2385357
     /* 2385357 */ GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2385460),
     /* 2385362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2385365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385373 */   GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2385416), // Rule ID 59146 //
     /* 2385378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385381 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2385384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385415 */     // GIR_Coverage, 59146,
     /* 2385415 */     GIR_EraseRootFromParent_Done,
     /* 2385416 */   // Label 33765: @2385416
     /* 2385416 */   GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2385459), // Rule ID 59147 //
     /* 2385421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385424 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2385427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2385441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385458 */     // GIR_Coverage, 59147,
     /* 2385458 */     GIR_EraseRootFromParent_Done,
     /* 2385459 */   // Label 33766: @2385459
     /* 2385459 */   GIM_Reject,
     /* 2385460 */ // Label 33764: @2385460
     /* 2385460 */ GIM_Reject,
     /* 2385461 */ // Label 33722: @2385461
     /* 2385461 */ GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2385564),
     /* 2385466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2385469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385477 */   GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2385520), // Rule ID 59152 //
     /* 2385482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385485 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2385488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385519 */     // GIR_Coverage, 59152,
     /* 2385519 */     GIR_EraseRootFromParent_Done,
     /* 2385520 */   // Label 33768: @2385520
     /* 2385520 */   GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2385563), // Rule ID 59153 //
     /* 2385525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385528 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2385531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385562 */     // GIR_Coverage, 59153,
     /* 2385562 */     GIR_EraseRootFromParent_Done,
     /* 2385563 */   // Label 33769: @2385563
     /* 2385563 */   GIM_Reject,
     /* 2385564 */ // Label 33767: @2385564
     /* 2385564 */ GIM_Reject,
     /* 2385565 */ // Label 33723: @2385565
     /* 2385565 */ GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2385668),
     /* 2385570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2385573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385581 */   GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2385624), // Rule ID 59160 //
     /* 2385586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385589 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2385592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385623 */     // GIR_Coverage, 59160,
     /* 2385623 */     GIR_EraseRootFromParent_Done,
     /* 2385624 */   // Label 33771: @2385624
     /* 2385624 */   GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2385667), // Rule ID 59161 //
     /* 2385629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385632 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2385635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385666 */     // GIR_Coverage, 59161,
     /* 2385666 */     GIR_EraseRootFromParent_Done,
     /* 2385667 */   // Label 33772: @2385667
     /* 2385667 */   GIM_Reject,
     /* 2385668 */ // Label 33770: @2385668
     /* 2385668 */ GIM_Reject,
     /* 2385669 */ // Label 33724: @2385669
     /* 2385669 */ GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2385772),
     /* 2385674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2385677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385685 */   GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2385728), // Rule ID 59182 //
     /* 2385690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2385693 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2385710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385727 */     // GIR_Coverage, 59182,
     /* 2385727 */     GIR_EraseRootFromParent_Done,
     /* 2385728 */   // Label 33774: @2385728
     /* 2385728 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2385771), // Rule ID 59183 //
     /* 2385733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2385736 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2385739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2385753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385770 */     // GIR_Coverage, 59183,
     /* 2385770 */     GIR_EraseRootFromParent_Done,
     /* 2385771 */   // Label 33775: @2385771
     /* 2385771 */   GIM_Reject,
     /* 2385772 */ // Label 33773: @2385772
     /* 2385772 */ GIM_Reject,
     /* 2385773 */ // Label 33725: @2385773
     /* 2385773 */ GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2385876),
     /* 2385778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2385781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385789 */   GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2385832), // Rule ID 59148 //
     /* 2385794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385797 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385831 */     // GIR_Coverage, 59148,
     /* 2385831 */     GIR_EraseRootFromParent_Done,
     /* 2385832 */   // Label 33777: @2385832
     /* 2385832 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2385875), // Rule ID 59149 //
     /* 2385837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385840 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2385843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2385857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385874 */     // GIR_Coverage, 59149,
     /* 2385874 */     GIR_EraseRootFromParent_Done,
     /* 2385875 */   // Label 33778: @2385875
     /* 2385875 */   GIM_Reject,
     /* 2385876 */ // Label 33776: @2385876
     /* 2385876 */ GIM_Reject,
     /* 2385877 */ // Label 33726: @2385877
     /* 2385877 */ GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2385980),
     /* 2385882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2385885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385893 */   GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2385936), // Rule ID 59158 //
     /* 2385898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2385901 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385935 */     // GIR_Coverage, 59158,
     /* 2385935 */     GIR_EraseRootFromParent_Done,
     /* 2385936 */   // Label 33780: @2385936
     /* 2385936 */   GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2385979), // Rule ID 59159 //
     /* 2385941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2385944 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2385947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2385961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385978 */     // GIR_Coverage, 59159,
     /* 2385978 */     GIR_EraseRootFromParent_Done,
     /* 2385979 */   // Label 33781: @2385979
     /* 2385979 */   GIM_Reject,
     /* 2385980 */ // Label 33779: @2385980
     /* 2385980 */ GIM_Reject,
     /* 2385981 */ // Label 33727: @2385981
     /* 2385981 */ GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2386084),
     /* 2385986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2385989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385997 */   GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2386040), // Rule ID 59176 //
     /* 2386002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386005 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386039 */     // GIR_Coverage, 59176,
     /* 2386039 */     GIR_EraseRootFromParent_Done,
     /* 2386040 */   // Label 33783: @2386040
     /* 2386040 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2386083), // Rule ID 59177 //
     /* 2386045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386048 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386082 */     // GIR_Coverage, 59177,
     /* 2386082 */     GIR_EraseRootFromParent_Done,
     /* 2386083 */   // Label 33784: @2386083
     /* 2386083 */   GIM_Reject,
     /* 2386084 */ // Label 33782: @2386084
     /* 2386084 */ GIM_Reject,
     /* 2386085 */ // Label 33728: @2386085
     /* 2386085 */ GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2386188),
     /* 2386090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2386093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386101 */   GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2386144), // Rule ID 59184 //
     /* 2386106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2386109 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386143 */     // GIR_Coverage, 59184,
     /* 2386143 */     GIR_EraseRootFromParent_Done,
     /* 2386144 */   // Label 33786: @2386144
     /* 2386144 */   GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2386187), // Rule ID 59185 //
     /* 2386149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2386152 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386186 */     // GIR_Coverage, 59185,
     /* 2386186 */     GIR_EraseRootFromParent_Done,
     /* 2386187 */   // Label 33787: @2386187
     /* 2386187 */   GIM_Reject,
     /* 2386188 */ // Label 33785: @2386188
     /* 2386188 */ GIM_Reject,
     /* 2386189 */ // Label 33729: @2386189
     /* 2386189 */ GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2386292),
     /* 2386194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2386197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386205 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2386248), // Rule ID 59156 //
     /* 2386210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386213 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2386216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2386230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386247 */     // GIR_Coverage, 59156,
     /* 2386247 */     GIR_EraseRootFromParent_Done,
     /* 2386248 */   // Label 33789: @2386248
     /* 2386248 */   GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2386291), // Rule ID 59157 //
     /* 2386253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386256 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2386259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2386273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386290 */     // GIR_Coverage, 59157,
     /* 2386290 */     GIR_EraseRootFromParent_Done,
     /* 2386291 */   // Label 33790: @2386291
     /* 2386291 */   GIM_Reject,
     /* 2386292 */ // Label 33788: @2386292
     /* 2386292 */ GIM_Reject,
     /* 2386293 */ // Label 33730: @2386293
     /* 2386293 */ GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2386396),
     /* 2386298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2386301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386309 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2386352), // Rule ID 59170 //
     /* 2386314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386317 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2386320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386351 */     // GIR_Coverage, 59170,
     /* 2386351 */     GIR_EraseRootFromParent_Done,
     /* 2386352 */   // Label 33792: @2386352
     /* 2386352 */   GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2386395), // Rule ID 59171 //
     /* 2386357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386360 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2386363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386394 */     // GIR_Coverage, 59171,
     /* 2386394 */     GIR_EraseRootFromParent_Done,
     /* 2386395 */   // Label 33793: @2386395
     /* 2386395 */   GIM_Reject,
     /* 2386396 */ // Label 33791: @2386396
     /* 2386396 */ GIM_Reject,
     /* 2386397 */ // Label 33731: @2386397
     /* 2386397 */ GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2386500),
     /* 2386402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2386405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386413 */   GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2386456), // Rule ID 59178 //
     /* 2386418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386421 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2386424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386455 */     // GIR_Coverage, 59178,
     /* 2386455 */     GIR_EraseRootFromParent_Done,
     /* 2386456 */   // Label 33795: @2386456
     /* 2386456 */   GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2386499), // Rule ID 59179 //
     /* 2386461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386464 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2386467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386498 */     // GIR_Coverage, 59179,
     /* 2386498 */     GIR_EraseRootFromParent_Done,
     /* 2386499 */   // Label 33796: @2386499
     /* 2386499 */   GIM_Reject,
     /* 2386500 */ // Label 33794: @2386500
     /* 2386500 */ GIM_Reject,
     /* 2386501 */ // Label 33732: @2386501
     /* 2386501 */ GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2386604),
     /* 2386506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2386509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386517 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2386560), // Rule ID 59186 //
     /* 2386522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2386525 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2386528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386559 */     // GIR_Coverage, 59186,
     /* 2386559 */     GIR_EraseRootFromParent_Done,
     /* 2386560 */   // Label 33798: @2386560
     /* 2386560 */   GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2386603), // Rule ID 59187 //
     /* 2386565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2386568 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2386571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386602 */     // GIR_Coverage, 59187,
     /* 2386602 */     GIR_EraseRootFromParent_Done,
     /* 2386603 */   // Label 33799: @2386603
     /* 2386603 */   GIM_Reject,
     /* 2386604 */ // Label 33797: @2386604
     /* 2386604 */ GIM_Reject,
     /* 2386605 */ // Label 33733: @2386605
     /* 2386605 */ GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2386708),
     /* 2386610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2386613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386621 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2386664), // Rule ID 59164 //
     /* 2386626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386629 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2386632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386663 */     // GIR_Coverage, 59164,
     /* 2386663 */     GIR_EraseRootFromParent_Done,
     /* 2386664 */   // Label 33801: @2386664
     /* 2386664 */   GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2386707), // Rule ID 59165 //
     /* 2386669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386672 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2386675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2386689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386706 */     // GIR_Coverage, 59165,
     /* 2386706 */     GIR_EraseRootFromParent_Done,
     /* 2386707 */   // Label 33802: @2386707
     /* 2386707 */   GIM_Reject,
     /* 2386708 */ // Label 33800: @2386708
     /* 2386708 */ GIM_Reject,
     /* 2386709 */ // Label 33734: @2386709
     /* 2386709 */ GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2386812),
     /* 2386714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2386717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386725 */   GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2386768), // Rule ID 59172 //
     /* 2386730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386733 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386767 */     // GIR_Coverage, 59172,
     /* 2386767 */     GIR_EraseRootFromParent_Done,
     /* 2386768 */   // Label 33804: @2386768
     /* 2386768 */   GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2386811), // Rule ID 59173 //
     /* 2386773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386776 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2386779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386810 */     // GIR_Coverage, 59173,
     /* 2386810 */     GIR_EraseRootFromParent_Done,
     /* 2386811 */   // Label 33805: @2386811
     /* 2386811 */   GIM_Reject,
     /* 2386812 */ // Label 33803: @2386812
     /* 2386812 */ GIM_Reject,
     /* 2386813 */ // Label 33735: @2386813
     /* 2386813 */ GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2386916),
     /* 2386818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2386821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386829 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2386872), // Rule ID 59180 //
     /* 2386834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386837 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386871 */     // GIR_Coverage, 59180,
     /* 2386871 */     GIR_EraseRootFromParent_Done,
     /* 2386872 */   // Label 33807: @2386872
     /* 2386872 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2386915), // Rule ID 59181 //
     /* 2386877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386880 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2386883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2386897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386914 */     // GIR_Coverage, 59181,
     /* 2386914 */     GIR_EraseRootFromParent_Done,
     /* 2386915 */   // Label 33808: @2386915
     /* 2386915 */   GIM_Reject,
     /* 2386916 */ // Label 33806: @2386916
     /* 2386916 */ GIM_Reject,
     /* 2386917 */ // Label 33736: @2386917
     /* 2386917 */ GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2387020),
     /* 2386922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2386925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386933 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2386976), // Rule ID 59166 //
     /* 2386938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386941 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2386958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386975 */     // GIR_Coverage, 59166,
     /* 2386975 */     GIR_EraseRootFromParent_Done,
     /* 2386976 */   // Label 33810: @2386976
     /* 2386976 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2387019), // Rule ID 59167 //
     /* 2386981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386984 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2386987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2387001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387018 */     // GIR_Coverage, 59167,
     /* 2387018 */     GIR_EraseRootFromParent_Done,
     /* 2387019 */   // Label 33811: @2387019
     /* 2387019 */   GIM_Reject,
     /* 2387020 */ // Label 33809: @2387020
     /* 2387020 */ GIM_Reject,
     /* 2387021 */ // Label 33737: @2387021
     /* 2387021 */ GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2387124),
     /* 2387026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2387029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387037 */   GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2387080), // Rule ID 59174 //
     /* 2387042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387045 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387079 */     // GIR_Coverage, 59174,
     /* 2387079 */     GIR_EraseRootFromParent_Done,
     /* 2387080 */   // Label 33813: @2387080
     /* 2387080 */   GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2387123), // Rule ID 59175 //
     /* 2387085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387088 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387122 */     // GIR_Coverage, 59175,
     /* 2387122 */     GIR_EraseRootFromParent_Done,
     /* 2387123 */   // Label 33814: @2387123
     /* 2387123 */   GIM_Reject,
     /* 2387124 */ // Label 33812: @2387124
     /* 2387124 */ GIM_Reject,
     /* 2387125 */ // Label 33738: @2387125
     /* 2387125 */ GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2387228),
     /* 2387130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2387133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387141 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2387184), // Rule ID 59168 //
     /* 2387146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387149 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2387152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387183 */     // GIR_Coverage, 59168,
     /* 2387183 */     GIR_EraseRootFromParent_Done,
     /* 2387184 */   // Label 33816: @2387184
     /* 2387184 */   GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2387227), // Rule ID 59169 //
     /* 2387189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387192 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2387195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2387209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387226 */     // GIR_Coverage, 59169,
     /* 2387226 */     GIR_EraseRootFromParent_Done,
     /* 2387227 */   // Label 33817: @2387227
     /* 2387227 */   GIM_Reject,
     /* 2387228 */ // Label 33815: @2387228
     /* 2387228 */ GIM_Reject,
     /* 2387229 */ // Label 33739: @2387229
     /* 2387229 */ GIM_Reject,
     /* 2387230 */ // Label 90: @2387230
     /* 2387230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33842*/ GIMT_Encode4(2389780),
     /* 2387241 */ /*GILLT_s32*//*Label 33818*/ GIMT_Encode4(2387365),
     /* 2387245 */ /*GILLT_s64*//*Label 33819*/ GIMT_Encode4(2387413), GIMT_Encode4(0),
     /* 2387253 */ /*GILLT_nxv1s8*//*Label 33820*/ GIMT_Encode4(2387492),
     /* 2387257 */ /*GILLT_nxv1s16*//*Label 33821*/ GIMT_Encode4(2387596),
     /* 2387261 */ /*GILLT_nxv1s32*//*Label 33822*/ GIMT_Encode4(2387700),
     /* 2387265 */ /*GILLT_nxv1s64*//*Label 33823*/ GIMT_Encode4(2387804), GIMT_Encode4(0),
     /* 2387273 */ /*GILLT_nxv2s8*//*Label 33824*/ GIMT_Encode4(2387908),
     /* 2387277 */ /*GILLT_nxv2s16*//*Label 33825*/ GIMT_Encode4(2388012),
     /* 2387281 */ /*GILLT_nxv2s32*//*Label 33826*/ GIMT_Encode4(2388116),
     /* 2387285 */ /*GILLT_nxv2s64*//*Label 33827*/ GIMT_Encode4(2388220), GIMT_Encode4(0),
     /* 2387293 */ /*GILLT_nxv4s8*//*Label 33828*/ GIMT_Encode4(2388324),
     /* 2387297 */ /*GILLT_nxv4s16*//*Label 33829*/ GIMT_Encode4(2388428),
     /* 2387301 */ /*GILLT_nxv4s32*//*Label 33830*/ GIMT_Encode4(2388532),
     /* 2387305 */ /*GILLT_nxv4s64*//*Label 33831*/ GIMT_Encode4(2388636), GIMT_Encode4(0),
     /* 2387313 */ /*GILLT_nxv8s8*//*Label 33832*/ GIMT_Encode4(2388740),
     /* 2387317 */ /*GILLT_nxv8s16*//*Label 33833*/ GIMT_Encode4(2388844),
     /* 2387321 */ /*GILLT_nxv8s32*//*Label 33834*/ GIMT_Encode4(2388948),
     /* 2387325 */ /*GILLT_nxv8s64*//*Label 33835*/ GIMT_Encode4(2389052), GIMT_Encode4(0),
     /* 2387333 */ /*GILLT_nxv16s8*//*Label 33836*/ GIMT_Encode4(2389156),
     /* 2387337 */ /*GILLT_nxv16s16*//*Label 33837*/ GIMT_Encode4(2389260),
     /* 2387341 */ /*GILLT_nxv16s32*//*Label 33838*/ GIMT_Encode4(2389364), GIMT_Encode4(0),
     /* 2387349 */ /*GILLT_nxv32s8*//*Label 33839*/ GIMT_Encode4(2389468),
     /* 2387353 */ /*GILLT_nxv32s16*//*Label 33840*/ GIMT_Encode4(2389572), GIMT_Encode4(0),
     /* 2387361 */ /*GILLT_nxv64s8*//*Label 33841*/ GIMT_Encode4(2389676),
     /* 2387365 */ // Label 33818: @2387365
     /* 2387365 */ GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2387412),
     /* 2387370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387381 */   GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2387396), // Rule ID 2521 //
     /* 2387386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2387389 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2387389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2387394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387395 */     // GIR_Coverage, 2521,
     /* 2387395 */     GIR_Done,
     /* 2387396 */   // Label 33844: @2387396
     /* 2387396 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2387411), // Rule ID 64448 //
     /* 2387401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2387404 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2387404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2387409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387410 */     // GIR_Coverage, 64448,
     /* 2387410 */     GIR_Done,
     /* 2387411 */   // Label 33845: @2387411
     /* 2387411 */   GIM_Reject,
     /* 2387412 */ // Label 33843: @2387412
     /* 2387412 */ GIM_Reject,
     /* 2387413 */ // Label 33819: @2387413
     /* 2387413 */ GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2387491),
     /* 2387418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2387421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387425 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2387452), // Rule ID 2524 //
     /* 2387430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2387433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2387440 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2387443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2387450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387451 */     // GIR_Coverage, 2524,
     /* 2387451 */     GIR_EraseRootFromParent_Done,
     /* 2387452 */   // Label 33847: @2387452
     /* 2387452 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2387471), // Rule ID 2520 //
     /* 2387457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2387460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387464 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2387469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387470 */     // GIR_Coverage, 2520,
     /* 2387470 */     GIR_Done,
     /* 2387471 */   // Label 33848: @2387471
     /* 2387471 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2387490), // Rule ID 64447 //
     /* 2387476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2387479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2387483 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2387483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2387488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387489 */     // GIR_Coverage, 64447,
     /* 2387489 */     GIR_Done,
     /* 2387490 */   // Label 33849: @2387490
     /* 2387490 */   GIM_Reject,
     /* 2387491 */ // Label 33846: @2387491
     /* 2387491 */ GIM_Reject,
     /* 2387492 */ // Label 33820: @2387492
     /* 2387492 */ GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2387595),
     /* 2387497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2387500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387508 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2387551), // Rule ID 59232 //
     /* 2387513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387516 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2387519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2387533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387550 */     // GIR_Coverage, 59232,
     /* 2387550 */     GIR_EraseRootFromParent_Done,
     /* 2387551 */   // Label 33851: @2387551
     /* 2387551 */   GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2387594), // Rule ID 59233 //
     /* 2387556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387559 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2387562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2387576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387593 */     // GIR_Coverage, 59233,
     /* 2387593 */     GIR_EraseRootFromParent_Done,
     /* 2387594 */   // Label 33852: @2387594
     /* 2387594 */   GIM_Reject,
     /* 2387595 */ // Label 33850: @2387595
     /* 2387595 */ GIM_Reject,
     /* 2387596 */ // Label 33821: @2387596
     /* 2387596 */ GIM_Try, /*On fail goto*//*Label 33853*/ GIMT_Encode4(2387699),
     /* 2387601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2387604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387612 */   GIM_Try, /*On fail goto*//*Label 33854*/ GIMT_Encode4(2387655), // Rule ID 59238 //
     /* 2387617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387620 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2387623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387654 */     // GIR_Coverage, 59238,
     /* 2387654 */     GIR_EraseRootFromParent_Done,
     /* 2387655 */   // Label 33854: @2387655
     /* 2387655 */   GIM_Try, /*On fail goto*//*Label 33855*/ GIMT_Encode4(2387698), // Rule ID 59239 //
     /* 2387660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387663 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2387666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387697 */     // GIR_Coverage, 59239,
     /* 2387697 */     GIR_EraseRootFromParent_Done,
     /* 2387698 */   // Label 33855: @2387698
     /* 2387698 */   GIM_Reject,
     /* 2387699 */ // Label 33853: @2387699
     /* 2387699 */ GIM_Reject,
     /* 2387700 */ // Label 33822: @2387700
     /* 2387700 */ GIM_Try, /*On fail goto*//*Label 33856*/ GIMT_Encode4(2387803),
     /* 2387705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2387708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387716 */   GIM_Try, /*On fail goto*//*Label 33857*/ GIMT_Encode4(2387759), // Rule ID 59242 //
     /* 2387721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387724 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2387741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387758 */     // GIR_Coverage, 59242,
     /* 2387758 */     GIR_EraseRootFromParent_Done,
     /* 2387759 */   // Label 33857: @2387759
     /* 2387759 */   GIM_Try, /*On fail goto*//*Label 33858*/ GIMT_Encode4(2387802), // Rule ID 59243 //
     /* 2387764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387767 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2387770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2387784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387801 */     // GIR_Coverage, 59243,
     /* 2387801 */     GIR_EraseRootFromParent_Done,
     /* 2387802 */   // Label 33858: @2387802
     /* 2387802 */   GIM_Reject,
     /* 2387803 */ // Label 33856: @2387803
     /* 2387803 */ GIM_Reject,
     /* 2387804 */ // Label 33823: @2387804
     /* 2387804 */ GIM_Try, /*On fail goto*//*Label 33859*/ GIMT_Encode4(2387907),
     /* 2387809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2387812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387820 */   GIM_Try, /*On fail goto*//*Label 33860*/ GIMT_Encode4(2387863), // Rule ID 59250 //
     /* 2387825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387828 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2387845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387862 */     // GIR_Coverage, 59250,
     /* 2387862 */     GIR_EraseRootFromParent_Done,
     /* 2387863 */   // Label 33860: @2387863
     /* 2387863 */   GIM_Try, /*On fail goto*//*Label 33861*/ GIMT_Encode4(2387906), // Rule ID 59251 //
     /* 2387868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387871 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2387874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2387888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387905 */     // GIR_Coverage, 59251,
     /* 2387905 */     GIR_EraseRootFromParent_Done,
     /* 2387906 */   // Label 33861: @2387906
     /* 2387906 */   GIM_Reject,
     /* 2387907 */ // Label 33859: @2387907
     /* 2387907 */ GIM_Reject,
     /* 2387908 */ // Label 33824: @2387908
     /* 2387908 */ GIM_Try, /*On fail goto*//*Label 33862*/ GIMT_Encode4(2388011),
     /* 2387913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2387916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387924 */   GIM_Try, /*On fail goto*//*Label 33863*/ GIMT_Encode4(2387967), // Rule ID 59234 //
     /* 2387929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387932 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387966 */     // GIR_Coverage, 59234,
     /* 2387966 */     GIR_EraseRootFromParent_Done,
     /* 2387967 */   // Label 33863: @2387967
     /* 2387967 */   GIM_Try, /*On fail goto*//*Label 33864*/ GIMT_Encode4(2388010), // Rule ID 59235 //
     /* 2387972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387975 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2387978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2387992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388009 */     // GIR_Coverage, 59235,
     /* 2388009 */     GIR_EraseRootFromParent_Done,
     /* 2388010 */   // Label 33864: @2388010
     /* 2388010 */   GIM_Reject,
     /* 2388011 */ // Label 33862: @2388011
     /* 2388011 */ GIM_Reject,
     /* 2388012 */ // Label 33825: @2388012
     /* 2388012 */ GIM_Try, /*On fail goto*//*Label 33865*/ GIMT_Encode4(2388115),
     /* 2388017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2388020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388028 */   GIM_Try, /*On fail goto*//*Label 33866*/ GIMT_Encode4(2388071), // Rule ID 59240 //
     /* 2388033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388036 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388070 */     // GIR_Coverage, 59240,
     /* 2388070 */     GIR_EraseRootFromParent_Done,
     /* 2388071 */   // Label 33866: @2388071
     /* 2388071 */   GIM_Try, /*On fail goto*//*Label 33867*/ GIMT_Encode4(2388114), // Rule ID 59241 //
     /* 2388076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388079 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388113 */     // GIR_Coverage, 59241,
     /* 2388113 */     GIR_EraseRootFromParent_Done,
     /* 2388114 */   // Label 33867: @2388114
     /* 2388114 */   GIM_Reject,
     /* 2388115 */ // Label 33865: @2388115
     /* 2388115 */ GIM_Reject,
     /* 2388116 */ // Label 33826: @2388116
     /* 2388116 */ GIM_Try, /*On fail goto*//*Label 33868*/ GIMT_Encode4(2388219),
     /* 2388121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2388124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388132 */   GIM_Try, /*On fail goto*//*Label 33869*/ GIMT_Encode4(2388175), // Rule ID 59248 //
     /* 2388137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388140 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388174 */     // GIR_Coverage, 59248,
     /* 2388174 */     GIR_EraseRootFromParent_Done,
     /* 2388175 */   // Label 33869: @2388175
     /* 2388175 */   GIM_Try, /*On fail goto*//*Label 33870*/ GIMT_Encode4(2388218), // Rule ID 59249 //
     /* 2388180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388183 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388217 */     // GIR_Coverage, 59249,
     /* 2388217 */     GIR_EraseRootFromParent_Done,
     /* 2388218 */   // Label 33870: @2388218
     /* 2388218 */   GIM_Reject,
     /* 2388219 */ // Label 33868: @2388219
     /* 2388219 */ GIM_Reject,
     /* 2388220 */ // Label 33827: @2388220
     /* 2388220 */ GIM_Try, /*On fail goto*//*Label 33871*/ GIMT_Encode4(2388323),
     /* 2388225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2388228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388236 */   GIM_Try, /*On fail goto*//*Label 33872*/ GIMT_Encode4(2388279), // Rule ID 59270 //
     /* 2388241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388244 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2388247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388278 */     // GIR_Coverage, 59270,
     /* 2388278 */     GIR_EraseRootFromParent_Done,
     /* 2388279 */   // Label 33872: @2388279
     /* 2388279 */   GIM_Try, /*On fail goto*//*Label 33873*/ GIMT_Encode4(2388322), // Rule ID 59271 //
     /* 2388284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388287 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2388290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388321 */     // GIR_Coverage, 59271,
     /* 2388321 */     GIR_EraseRootFromParent_Done,
     /* 2388322 */   // Label 33873: @2388322
     /* 2388322 */   GIM_Reject,
     /* 2388323 */ // Label 33871: @2388323
     /* 2388323 */ GIM_Reject,
     /* 2388324 */ // Label 33828: @2388324
     /* 2388324 */ GIM_Try, /*On fail goto*//*Label 33874*/ GIMT_Encode4(2388427),
     /* 2388329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2388332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388340 */   GIM_Try, /*On fail goto*//*Label 33875*/ GIMT_Encode4(2388383), // Rule ID 59236 //
     /* 2388345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388348 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2388351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388382 */     // GIR_Coverage, 59236,
     /* 2388382 */     GIR_EraseRootFromParent_Done,
     /* 2388383 */   // Label 33875: @2388383
     /* 2388383 */   GIM_Try, /*On fail goto*//*Label 33876*/ GIMT_Encode4(2388426), // Rule ID 59237 //
     /* 2388388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388391 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2388394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2388408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388425 */     // GIR_Coverage, 59237,
     /* 2388425 */     GIR_EraseRootFromParent_Done,
     /* 2388426 */   // Label 33876: @2388426
     /* 2388426 */   GIM_Reject,
     /* 2388427 */ // Label 33874: @2388427
     /* 2388427 */ GIM_Reject,
     /* 2388428 */ // Label 33829: @2388428
     /* 2388428 */ GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2388531),
     /* 2388433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2388436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388444 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2388487), // Rule ID 59246 //
     /* 2388449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388452 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2388455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388486 */     // GIR_Coverage, 59246,
     /* 2388486 */     GIR_EraseRootFromParent_Done,
     /* 2388487 */   // Label 33878: @2388487
     /* 2388487 */   GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2388530), // Rule ID 59247 //
     /* 2388492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388495 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2388498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388529 */     // GIR_Coverage, 59247,
     /* 2388529 */     GIR_EraseRootFromParent_Done,
     /* 2388530 */   // Label 33879: @2388530
     /* 2388530 */   GIM_Reject,
     /* 2388531 */ // Label 33877: @2388531
     /* 2388531 */ GIM_Reject,
     /* 2388532 */ // Label 33830: @2388532
     /* 2388532 */ GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2388635),
     /* 2388537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2388540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388548 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2388591), // Rule ID 59264 //
     /* 2388553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388556 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2388559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388590 */     // GIR_Coverage, 59264,
     /* 2388590 */     GIR_EraseRootFromParent_Done,
     /* 2388591 */   // Label 33881: @2388591
     /* 2388591 */   GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2388634), // Rule ID 59265 //
     /* 2388596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388599 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2388602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388633 */     // GIR_Coverage, 59265,
     /* 2388633 */     GIR_EraseRootFromParent_Done,
     /* 2388634 */   // Label 33882: @2388634
     /* 2388634 */   GIM_Reject,
     /* 2388635 */ // Label 33880: @2388635
     /* 2388635 */ GIM_Reject,
     /* 2388636 */ // Label 33831: @2388636
     /* 2388636 */ GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2388739),
     /* 2388641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2388644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388652 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2388695), // Rule ID 59272 //
     /* 2388657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388660 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388694 */     // GIR_Coverage, 59272,
     /* 2388694 */     GIR_EraseRootFromParent_Done,
     /* 2388695 */   // Label 33884: @2388695
     /* 2388695 */   GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2388738), // Rule ID 59273 //
     /* 2388700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388703 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2388706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388737 */     // GIR_Coverage, 59273,
     /* 2388737 */     GIR_EraseRootFromParent_Done,
     /* 2388738 */   // Label 33885: @2388738
     /* 2388738 */   GIM_Reject,
     /* 2388739 */ // Label 33883: @2388739
     /* 2388739 */ GIM_Reject,
     /* 2388740 */ // Label 33832: @2388740
     /* 2388740 */ GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2388843),
     /* 2388745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2388748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388756 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2388799), // Rule ID 59244 //
     /* 2388761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388764 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388798 */     // GIR_Coverage, 59244,
     /* 2388798 */     GIR_EraseRootFromParent_Done,
     /* 2388799 */   // Label 33887: @2388799
     /* 2388799 */   GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2388842), // Rule ID 59245 //
     /* 2388804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388807 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2388810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2388824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388841 */     // GIR_Coverage, 59245,
     /* 2388841 */     GIR_EraseRootFromParent_Done,
     /* 2388842 */   // Label 33888: @2388842
     /* 2388842 */   GIM_Reject,
     /* 2388843 */ // Label 33886: @2388843
     /* 2388843 */ GIM_Reject,
     /* 2388844 */ // Label 33833: @2388844
     /* 2388844 */ GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2388947),
     /* 2388849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2388852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388860 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2388903), // Rule ID 59258 //
     /* 2388865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388868 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388902 */     // GIR_Coverage, 59258,
     /* 2388902 */     GIR_EraseRootFromParent_Done,
     /* 2388903 */   // Label 33890: @2388903
     /* 2388903 */   GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2388946), // Rule ID 59259 //
     /* 2388908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388911 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2388914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2388928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388945 */     // GIR_Coverage, 59259,
     /* 2388945 */     GIR_EraseRootFromParent_Done,
     /* 2388946 */   // Label 33891: @2388946
     /* 2388946 */   GIM_Reject,
     /* 2388947 */ // Label 33889: @2388947
     /* 2388947 */ GIM_Reject,
     /* 2388948 */ // Label 33834: @2388948
     /* 2388948 */ GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2389051),
     /* 2388953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2388956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388964 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2389007), // Rule ID 59266 //
     /* 2388969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388972 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2388975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2388989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389006 */     // GIR_Coverage, 59266,
     /* 2389006 */     GIR_EraseRootFromParent_Done,
     /* 2389007 */   // Label 33893: @2389007
     /* 2389007 */   GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2389050), // Rule ID 59267 //
     /* 2389012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389015 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2389018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389049 */     // GIR_Coverage, 59267,
     /* 2389049 */     GIR_EraseRootFromParent_Done,
     /* 2389050 */   // Label 33894: @2389050
     /* 2389050 */   GIM_Reject,
     /* 2389051 */ // Label 33892: @2389051
     /* 2389051 */ GIM_Reject,
     /* 2389052 */ // Label 33835: @2389052
     /* 2389052 */ GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2389155),
     /* 2389057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2389060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389068 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2389111), // Rule ID 59274 //
     /* 2389073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2389076 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389110 */     // GIR_Coverage, 59274,
     /* 2389110 */     GIR_EraseRootFromParent_Done,
     /* 2389111 */   // Label 33896: @2389111
     /* 2389111 */   GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2389154), // Rule ID 59275 //
     /* 2389116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2389119 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389153 */     // GIR_Coverage, 59275,
     /* 2389153 */     GIR_EraseRootFromParent_Done,
     /* 2389154 */   // Label 33897: @2389154
     /* 2389154 */   GIM_Reject,
     /* 2389155 */ // Label 33895: @2389155
     /* 2389155 */ GIM_Reject,
     /* 2389156 */ // Label 33836: @2389156
     /* 2389156 */ GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2389259),
     /* 2389161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2389164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389172 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2389215), // Rule ID 59252 //
     /* 2389177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389180 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2389183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2389197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389214 */     // GIR_Coverage, 59252,
     /* 2389214 */     GIR_EraseRootFromParent_Done,
     /* 2389215 */   // Label 33899: @2389215
     /* 2389215 */   GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2389258), // Rule ID 59253 //
     /* 2389220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389223 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2389226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2389240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389257 */     // GIR_Coverage, 59253,
     /* 2389257 */     GIR_EraseRootFromParent_Done,
     /* 2389258 */   // Label 33900: @2389258
     /* 2389258 */   GIM_Reject,
     /* 2389259 */ // Label 33898: @2389259
     /* 2389259 */ GIM_Reject,
     /* 2389260 */ // Label 33837: @2389260
     /* 2389260 */ GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2389363),
     /* 2389265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2389268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389276 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2389319), // Rule ID 59260 //
     /* 2389281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389284 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389318 */     // GIR_Coverage, 59260,
     /* 2389318 */     GIR_EraseRootFromParent_Done,
     /* 2389319 */   // Label 33902: @2389319
     /* 2389319 */   GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2389362), // Rule ID 59261 //
     /* 2389324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389327 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389361 */     // GIR_Coverage, 59261,
     /* 2389361 */     GIR_EraseRootFromParent_Done,
     /* 2389362 */   // Label 33903: @2389362
     /* 2389362 */   GIM_Reject,
     /* 2389363 */ // Label 33901: @2389363
     /* 2389363 */ GIM_Reject,
     /* 2389364 */ // Label 33838: @2389364
     /* 2389364 */ GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2389467),
     /* 2389369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2389372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389380 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2389423), // Rule ID 59268 //
     /* 2389385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389388 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389422 */     // GIR_Coverage, 59268,
     /* 2389422 */     GIR_EraseRootFromParent_Done,
     /* 2389423 */   // Label 33905: @2389423
     /* 2389423 */   GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2389466), // Rule ID 59269 //
     /* 2389428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389431 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389465 */     // GIR_Coverage, 59269,
     /* 2389465 */     GIR_EraseRootFromParent_Done,
     /* 2389466 */   // Label 33906: @2389466
     /* 2389466 */   GIM_Reject,
     /* 2389467 */ // Label 33904: @2389467
     /* 2389467 */ GIM_Reject,
     /* 2389468 */ // Label 33839: @2389468
     /* 2389468 */ GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2389571),
     /* 2389473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2389476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389484 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2389527), // Rule ID 59254 //
     /* 2389489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389492 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2389495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389526 */     // GIR_Coverage, 59254,
     /* 2389526 */     GIR_EraseRootFromParent_Done,
     /* 2389527 */   // Label 33908: @2389527
     /* 2389527 */   GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2389570), // Rule ID 59255 //
     /* 2389532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389535 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2389538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2389552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389569 */     // GIR_Coverage, 59255,
     /* 2389569 */     GIR_EraseRootFromParent_Done,
     /* 2389570 */   // Label 33909: @2389570
     /* 2389570 */   GIM_Reject,
     /* 2389571 */ // Label 33907: @2389571
     /* 2389571 */ GIM_Reject,
     /* 2389572 */ // Label 33840: @2389572
     /* 2389572 */ GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2389675),
     /* 2389577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2389580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389588 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2389631), // Rule ID 59262 //
     /* 2389593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389596 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2389599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389630 */     // GIR_Coverage, 59262,
     /* 2389630 */     GIR_EraseRootFromParent_Done,
     /* 2389631 */   // Label 33911: @2389631
     /* 2389631 */   GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2389674), // Rule ID 59263 //
     /* 2389636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389639 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2389642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389673 */     // GIR_Coverage, 59263,
     /* 2389673 */     GIR_EraseRootFromParent_Done,
     /* 2389674 */   // Label 33912: @2389674
     /* 2389674 */   GIM_Reject,
     /* 2389675 */ // Label 33910: @2389675
     /* 2389675 */ GIM_Reject,
     /* 2389676 */ // Label 33841: @2389676
     /* 2389676 */ GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2389779),
     /* 2389681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2389684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389692 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2389735), // Rule ID 59256 //
     /* 2389697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2389700 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389734 */     // GIR_Coverage, 59256,
     /* 2389734 */     GIR_EraseRootFromParent_Done,
     /* 2389735 */   // Label 33914: @2389735
     /* 2389735 */   GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2389778), // Rule ID 59257 //
     /* 2389740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2389743 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2389746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2389760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389777 */     // GIR_Coverage, 59257,
     /* 2389777 */     GIR_EraseRootFromParent_Done,
     /* 2389778 */   // Label 33915: @2389778
     /* 2389778 */   GIM_Reject,
     /* 2389779 */ // Label 33913: @2389779
     /* 2389779 */ GIM_Reject,
     /* 2389780 */ // Label 33842: @2389780
     /* 2389780 */ GIM_Reject,
     /* 2389781 */ // Label 91: @2389781
     /* 2389781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33940*/ GIMT_Encode4(2392315),
     /* 2389792 */ /*GILLT_s32*//*Label 33916*/ GIMT_Encode4(2389916),
     /* 2389796 */ /*GILLT_s64*//*Label 33917*/ GIMT_Encode4(2389979), GIMT_Encode4(0),
     /* 2389804 */ /*GILLT_nxv1s8*//*Label 33918*/ GIMT_Encode4(2390027),
     /* 2389808 */ /*GILLT_nxv1s16*//*Label 33919*/ GIMT_Encode4(2390131),
     /* 2389812 */ /*GILLT_nxv1s32*//*Label 33920*/ GIMT_Encode4(2390235),
     /* 2389816 */ /*GILLT_nxv1s64*//*Label 33921*/ GIMT_Encode4(2390339), GIMT_Encode4(0),
     /* 2389824 */ /*GILLT_nxv2s8*//*Label 33922*/ GIMT_Encode4(2390443),
     /* 2389828 */ /*GILLT_nxv2s16*//*Label 33923*/ GIMT_Encode4(2390547),
     /* 2389832 */ /*GILLT_nxv2s32*//*Label 33924*/ GIMT_Encode4(2390651),
     /* 2389836 */ /*GILLT_nxv2s64*//*Label 33925*/ GIMT_Encode4(2390755), GIMT_Encode4(0),
     /* 2389844 */ /*GILLT_nxv4s8*//*Label 33926*/ GIMT_Encode4(2390859),
     /* 2389848 */ /*GILLT_nxv4s16*//*Label 33927*/ GIMT_Encode4(2390963),
     /* 2389852 */ /*GILLT_nxv4s32*//*Label 33928*/ GIMT_Encode4(2391067),
     /* 2389856 */ /*GILLT_nxv4s64*//*Label 33929*/ GIMT_Encode4(2391171), GIMT_Encode4(0),
     /* 2389864 */ /*GILLT_nxv8s8*//*Label 33930*/ GIMT_Encode4(2391275),
     /* 2389868 */ /*GILLT_nxv8s16*//*Label 33931*/ GIMT_Encode4(2391379),
     /* 2389872 */ /*GILLT_nxv8s32*//*Label 33932*/ GIMT_Encode4(2391483),
     /* 2389876 */ /*GILLT_nxv8s64*//*Label 33933*/ GIMT_Encode4(2391587), GIMT_Encode4(0),
     /* 2389884 */ /*GILLT_nxv16s8*//*Label 33934*/ GIMT_Encode4(2391691),
     /* 2389888 */ /*GILLT_nxv16s16*//*Label 33935*/ GIMT_Encode4(2391795),
     /* 2389892 */ /*GILLT_nxv16s32*//*Label 33936*/ GIMT_Encode4(2391899), GIMT_Encode4(0),
     /* 2389900 */ /*GILLT_nxv32s8*//*Label 33937*/ GIMT_Encode4(2392003),
     /* 2389904 */ /*GILLT_nxv32s16*//*Label 33938*/ GIMT_Encode4(2392107), GIMT_Encode4(0),
     /* 2389912 */ /*GILLT_nxv64s8*//*Label 33939*/ GIMT_Encode4(2392211),
     /* 2389916 */ // Label 33916: @2389916
     /* 2389916 */ GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2389978),
     /* 2389921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2389924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389932 */   GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2389947), // Rule ID 2538 //
     /* 2389937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2389940 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2389945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389946 */     // GIR_Coverage, 2538,
     /* 2389946 */     GIR_Done,
     /* 2389947 */   // Label 33942: @2389947
     /* 2389947 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2389962), // Rule ID 2539 //
     /* 2389952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2389955 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2389960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389961 */     // GIR_Coverage, 2539,
     /* 2389961 */     GIR_Done,
     /* 2389962 */   // Label 33943: @2389962
     /* 2389962 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2389977), // Rule ID 62570 //
     /* 2389967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2389970 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2389970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2389975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389976 */     // GIR_Coverage, 62570,
     /* 2389976 */     GIR_Done,
     /* 2389977 */   // Label 33944: @2389977
     /* 2389977 */   GIM_Reject,
     /* 2389978 */ // Label 33941: @2389978
     /* 2389978 */ GIM_Reject,
     /* 2389979 */ // Label 33917: @2389979
     /* 2389979 */ GIM_Try, /*On fail goto*//*Label 33945*/ GIMT_Encode4(2390026),
     /* 2389984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389995 */   GIM_Try, /*On fail goto*//*Label 33946*/ GIMT_Encode4(2390010), // Rule ID 2540 //
     /* 2390000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2390003 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2390003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2390008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390009 */     // GIR_Coverage, 2540,
     /* 2390009 */     GIR_Done,
     /* 2390010 */   // Label 33946: @2390010
     /* 2390010 */   GIM_Try, /*On fail goto*//*Label 33947*/ GIMT_Encode4(2390025), // Rule ID 62569 //
     /* 2390015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2390018 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2390018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2390023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390024 */     // GIR_Coverage, 62569,
     /* 2390024 */     GIR_Done,
     /* 2390025 */   // Label 33947: @2390025
     /* 2390025 */   GIM_Reject,
     /* 2390026 */ // Label 33945: @2390026
     /* 2390026 */ GIM_Reject,
     /* 2390027 */ // Label 33918: @2390027
     /* 2390027 */ GIM_Try, /*On fail goto*//*Label 33948*/ GIMT_Encode4(2390130),
     /* 2390032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2390035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390043 */   GIM_Try, /*On fail goto*//*Label 33949*/ GIMT_Encode4(2390086), // Rule ID 59100 //
     /* 2390048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390051 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2390054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2390068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390085 */     // GIR_Coverage, 59100,
     /* 2390085 */     GIR_EraseRootFromParent_Done,
     /* 2390086 */   // Label 33949: @2390086
     /* 2390086 */   GIM_Try, /*On fail goto*//*Label 33950*/ GIMT_Encode4(2390129), // Rule ID 59101 //
     /* 2390091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390094 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2390097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2390111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390128 */     // GIR_Coverage, 59101,
     /* 2390128 */     GIR_EraseRootFromParent_Done,
     /* 2390129 */   // Label 33950: @2390129
     /* 2390129 */   GIM_Reject,
     /* 2390130 */ // Label 33948: @2390130
     /* 2390130 */ GIM_Reject,
     /* 2390131 */ // Label 33919: @2390131
     /* 2390131 */ GIM_Try, /*On fail goto*//*Label 33951*/ GIMT_Encode4(2390234),
     /* 2390136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390147 */   GIM_Try, /*On fail goto*//*Label 33952*/ GIMT_Encode4(2390190), // Rule ID 59106 //
     /* 2390152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390155 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2390158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390189 */     // GIR_Coverage, 59106,
     /* 2390189 */     GIR_EraseRootFromParent_Done,
     /* 2390190 */   // Label 33952: @2390190
     /* 2390190 */   GIM_Try, /*On fail goto*//*Label 33953*/ GIMT_Encode4(2390233), // Rule ID 59107 //
     /* 2390195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390198 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2390201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390232 */     // GIR_Coverage, 59107,
     /* 2390232 */     GIR_EraseRootFromParent_Done,
     /* 2390233 */   // Label 33953: @2390233
     /* 2390233 */   GIM_Reject,
     /* 2390234 */ // Label 33951: @2390234
     /* 2390234 */ GIM_Reject,
     /* 2390235 */ // Label 33920: @2390235
     /* 2390235 */ GIM_Try, /*On fail goto*//*Label 33954*/ GIMT_Encode4(2390338),
     /* 2390240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2390243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390251 */   GIM_Try, /*On fail goto*//*Label 33955*/ GIMT_Encode4(2390294), // Rule ID 59110 //
     /* 2390256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390259 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390293 */     // GIR_Coverage, 59110,
     /* 2390293 */     GIR_EraseRootFromParent_Done,
     /* 2390294 */   // Label 33955: @2390294
     /* 2390294 */   GIM_Try, /*On fail goto*//*Label 33956*/ GIMT_Encode4(2390337), // Rule ID 59111 //
     /* 2390299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390302 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2390305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390336 */     // GIR_Coverage, 59111,
     /* 2390336 */     GIR_EraseRootFromParent_Done,
     /* 2390337 */   // Label 33956: @2390337
     /* 2390337 */   GIM_Reject,
     /* 2390338 */ // Label 33954: @2390338
     /* 2390338 */ GIM_Reject,
     /* 2390339 */ // Label 33921: @2390339
     /* 2390339 */ GIM_Try, /*On fail goto*//*Label 33957*/ GIMT_Encode4(2390442),
     /* 2390344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2390347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390355 */   GIM_Try, /*On fail goto*//*Label 33958*/ GIMT_Encode4(2390398), // Rule ID 59118 //
     /* 2390360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2390363 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390397 */     // GIR_Coverage, 59118,
     /* 2390397 */     GIR_EraseRootFromParent_Done,
     /* 2390398 */   // Label 33958: @2390398
     /* 2390398 */   GIM_Try, /*On fail goto*//*Label 33959*/ GIMT_Encode4(2390441), // Rule ID 59119 //
     /* 2390403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2390406 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2390409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390440 */     // GIR_Coverage, 59119,
     /* 2390440 */     GIR_EraseRootFromParent_Done,
     /* 2390441 */   // Label 33959: @2390441
     /* 2390441 */   GIM_Reject,
     /* 2390442 */ // Label 33957: @2390442
     /* 2390442 */ GIM_Reject,
     /* 2390443 */ // Label 33922: @2390443
     /* 2390443 */ GIM_Try, /*On fail goto*//*Label 33960*/ GIMT_Encode4(2390546),
     /* 2390448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2390451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390459 */   GIM_Try, /*On fail goto*//*Label 33961*/ GIMT_Encode4(2390502), // Rule ID 59102 //
     /* 2390464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390467 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2390470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390501 */     // GIR_Coverage, 59102,
     /* 2390501 */     GIR_EraseRootFromParent_Done,
     /* 2390502 */   // Label 33961: @2390502
     /* 2390502 */   GIM_Try, /*On fail goto*//*Label 33962*/ GIMT_Encode4(2390545), // Rule ID 59103 //
     /* 2390507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390510 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2390513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2390527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390544 */     // GIR_Coverage, 59103,
     /* 2390544 */     GIR_EraseRootFromParent_Done,
     /* 2390545 */   // Label 33962: @2390545
     /* 2390545 */   GIM_Reject,
     /* 2390546 */ // Label 33960: @2390546
     /* 2390546 */ GIM_Reject,
     /* 2390547 */ // Label 33923: @2390547
     /* 2390547 */ GIM_Try, /*On fail goto*//*Label 33963*/ GIMT_Encode4(2390650),
     /* 2390552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2390555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390563 */   GIM_Try, /*On fail goto*//*Label 33964*/ GIMT_Encode4(2390606), // Rule ID 59108 //
     /* 2390568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390571 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390605 */     // GIR_Coverage, 59108,
     /* 2390605 */     GIR_EraseRootFromParent_Done,
     /* 2390606 */   // Label 33964: @2390606
     /* 2390606 */   GIM_Try, /*On fail goto*//*Label 33965*/ GIMT_Encode4(2390649), // Rule ID 59109 //
     /* 2390611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390614 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2390617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390648 */     // GIR_Coverage, 59109,
     /* 2390648 */     GIR_EraseRootFromParent_Done,
     /* 2390649 */   // Label 33965: @2390649
     /* 2390649 */   GIM_Reject,
     /* 2390650 */ // Label 33963: @2390650
     /* 2390650 */ GIM_Reject,
     /* 2390651 */ // Label 33924: @2390651
     /* 2390651 */ GIM_Try, /*On fail goto*//*Label 33966*/ GIMT_Encode4(2390754),
     /* 2390656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2390659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390667 */   GIM_Try, /*On fail goto*//*Label 33967*/ GIMT_Encode4(2390710), // Rule ID 59116 //
     /* 2390672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390675 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390709 */     // GIR_Coverage, 59116,
     /* 2390709 */     GIR_EraseRootFromParent_Done,
     /* 2390710 */   // Label 33967: @2390710
     /* 2390710 */   GIM_Try, /*On fail goto*//*Label 33968*/ GIMT_Encode4(2390753), // Rule ID 59117 //
     /* 2390715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390718 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2390721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2390735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390752 */     // GIR_Coverage, 59117,
     /* 2390752 */     GIR_EraseRootFromParent_Done,
     /* 2390753 */   // Label 33968: @2390753
     /* 2390753 */   GIM_Reject,
     /* 2390754 */ // Label 33966: @2390754
     /* 2390754 */ GIM_Reject,
     /* 2390755 */ // Label 33925: @2390755
     /* 2390755 */ GIM_Try, /*On fail goto*//*Label 33969*/ GIMT_Encode4(2390858),
     /* 2390760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2390763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390771 */   GIM_Try, /*On fail goto*//*Label 33970*/ GIMT_Encode4(2390814), // Rule ID 59138 //
     /* 2390776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2390779 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2390796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390813 */     // GIR_Coverage, 59138,
     /* 2390813 */     GIR_EraseRootFromParent_Done,
     /* 2390814 */   // Label 33970: @2390814
     /* 2390814 */   GIM_Try, /*On fail goto*//*Label 33971*/ GIMT_Encode4(2390857), // Rule ID 59139 //
     /* 2390819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2390822 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2390839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390856 */     // GIR_Coverage, 59139,
     /* 2390856 */     GIR_EraseRootFromParent_Done,
     /* 2390857 */   // Label 33971: @2390857
     /* 2390857 */   GIM_Reject,
     /* 2390858 */ // Label 33969: @2390858
     /* 2390858 */ GIM_Reject,
     /* 2390859 */ // Label 33926: @2390859
     /* 2390859 */ GIM_Try, /*On fail goto*//*Label 33972*/ GIMT_Encode4(2390962),
     /* 2390864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2390867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390875 */   GIM_Try, /*On fail goto*//*Label 33973*/ GIMT_Encode4(2390918), // Rule ID 59104 //
     /* 2390880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390883 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2390886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390917 */     // GIR_Coverage, 59104,
     /* 2390917 */     GIR_EraseRootFromParent_Done,
     /* 2390918 */   // Label 33973: @2390918
     /* 2390918 */   GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2390961), // Rule ID 59105 //
     /* 2390923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2390926 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2390929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2390943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390960 */     // GIR_Coverage, 59105,
     /* 2390960 */     GIR_EraseRootFromParent_Done,
     /* 2390961 */   // Label 33974: @2390961
     /* 2390961 */   GIM_Reject,
     /* 2390962 */ // Label 33972: @2390962
     /* 2390962 */ GIM_Reject,
     /* 2390963 */ // Label 33927: @2390963
     /* 2390963 */ GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2391066),
     /* 2390968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2390971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390979 */   GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2391022), // Rule ID 59114 //
     /* 2390984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2390987 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391021 */     // GIR_Coverage, 59114,
     /* 2391021 */     GIR_EraseRootFromParent_Done,
     /* 2391022 */   // Label 33976: @2391022
     /* 2391022 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2391065), // Rule ID 59115 //
     /* 2391027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391030 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2391033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391064 */     // GIR_Coverage, 59115,
     /* 2391064 */     GIR_EraseRootFromParent_Done,
     /* 2391065 */   // Label 33977: @2391065
     /* 2391065 */   GIM_Reject,
     /* 2391066 */ // Label 33975: @2391066
     /* 2391066 */ GIM_Reject,
     /* 2391067 */ // Label 33928: @2391067
     /* 2391067 */ GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2391170),
     /* 2391072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2391075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391083 */   GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2391126), // Rule ID 59132 //
     /* 2391088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391091 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2391094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391125 */     // GIR_Coverage, 59132,
     /* 2391125 */     GIR_EraseRootFromParent_Done,
     /* 2391126 */   // Label 33979: @2391126
     /* 2391126 */   GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2391169), // Rule ID 59133 //
     /* 2391131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391134 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2391137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391168 */     // GIR_Coverage, 59133,
     /* 2391168 */     GIR_EraseRootFromParent_Done,
     /* 2391169 */   // Label 33980: @2391169
     /* 2391169 */   GIM_Reject,
     /* 2391170 */ // Label 33978: @2391170
     /* 2391170 */ GIM_Reject,
     /* 2391171 */ // Label 33929: @2391171
     /* 2391171 */ GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2391274),
     /* 2391176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2391179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391187 */   GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2391230), // Rule ID 59140 //
     /* 2391192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2391195 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2391198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391229 */     // GIR_Coverage, 59140,
     /* 2391229 */     GIR_EraseRootFromParent_Done,
     /* 2391230 */   // Label 33982: @2391230
     /* 2391230 */   GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2391273), // Rule ID 59141 //
     /* 2391235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2391238 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2391241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391272 */     // GIR_Coverage, 59141,
     /* 2391272 */     GIR_EraseRootFromParent_Done,
     /* 2391273 */   // Label 33983: @2391273
     /* 2391273 */   GIM_Reject,
     /* 2391274 */ // Label 33981: @2391274
     /* 2391274 */ GIM_Reject,
     /* 2391275 */ // Label 33930: @2391275
     /* 2391275 */ GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2391378),
     /* 2391280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2391283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391291 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2391334), // Rule ID 59112 //
     /* 2391296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391299 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2391302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391333 */     // GIR_Coverage, 59112,
     /* 2391333 */     GIR_EraseRootFromParent_Done,
     /* 2391334 */   // Label 33985: @2391334
     /* 2391334 */   GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2391377), // Rule ID 59113 //
     /* 2391339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391342 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2391345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2391359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391376 */     // GIR_Coverage, 59113,
     /* 2391376 */     GIR_EraseRootFromParent_Done,
     /* 2391377 */   // Label 33986: @2391377
     /* 2391377 */   GIM_Reject,
     /* 2391378 */ // Label 33984: @2391378
     /* 2391378 */ GIM_Reject,
     /* 2391379 */ // Label 33931: @2391379
     /* 2391379 */ GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2391482),
     /* 2391384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2391387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391395 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2391438), // Rule ID 59126 //
     /* 2391400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391403 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2391406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391437 */     // GIR_Coverage, 59126,
     /* 2391437 */     GIR_EraseRootFromParent_Done,
     /* 2391438 */   // Label 33988: @2391438
     /* 2391438 */   GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2391481), // Rule ID 59127 //
     /* 2391443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391446 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2391449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391480 */     // GIR_Coverage, 59127,
     /* 2391480 */     GIR_EraseRootFromParent_Done,
     /* 2391481 */   // Label 33989: @2391481
     /* 2391481 */   GIM_Reject,
     /* 2391482 */ // Label 33987: @2391482
     /* 2391482 */ GIM_Reject,
     /* 2391483 */ // Label 33932: @2391483
     /* 2391483 */ GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2391586),
     /* 2391488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2391491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391499 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2391542), // Rule ID 59134 //
     /* 2391504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391507 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2391510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391541 */     // GIR_Coverage, 59134,
     /* 2391541 */     GIR_EraseRootFromParent_Done,
     /* 2391542 */   // Label 33991: @2391542
     /* 2391542 */   GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2391585), // Rule ID 59135 //
     /* 2391547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391550 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2391553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391584 */     // GIR_Coverage, 59135,
     /* 2391584 */     GIR_EraseRootFromParent_Done,
     /* 2391585 */   // Label 33992: @2391585
     /* 2391585 */   GIM_Reject,
     /* 2391586 */ // Label 33990: @2391586
     /* 2391586 */ GIM_Reject,
     /* 2391587 */ // Label 33933: @2391587
     /* 2391587 */ GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2391690),
     /* 2391592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2391595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391603 */   GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2391646), // Rule ID 59142 //
     /* 2391608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2391611 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391645 */     // GIR_Coverage, 59142,
     /* 2391645 */     GIR_EraseRootFromParent_Done,
     /* 2391646 */   // Label 33994: @2391646
     /* 2391646 */   GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2391689), // Rule ID 59143 //
     /* 2391651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2391654 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2391657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2391684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391688 */     // GIR_Coverage, 59143,
     /* 2391688 */     GIR_EraseRootFromParent_Done,
     /* 2391689 */   // Label 33995: @2391689
     /* 2391689 */   GIM_Reject,
     /* 2391690 */ // Label 33993: @2391690
     /* 2391690 */ GIM_Reject,
     /* 2391691 */ // Label 33934: @2391691
     /* 2391691 */ GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2391794),
     /* 2391696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2391699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2391707 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2391750), // Rule ID 59120 //
     /* 2391712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391715 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2391718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391749 */     // GIR_Coverage, 59120,
     /* 2391749 */     GIR_EraseRootFromParent_Done,
     /* 2391750 */   // Label 33997: @2391750
     /* 2391750 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2391793), // Rule ID 59121 //
     /* 2391755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391758 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2391761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2391775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391792 */     // GIR_Coverage, 59121,
     /* 2391792 */     GIR_EraseRootFromParent_Done,
     /* 2391793 */   // Label 33998: @2391793
     /* 2391793 */   GIM_Reject,
     /* 2391794 */ // Label 33996: @2391794
     /* 2391794 */ GIM_Reject,
     /* 2391795 */ // Label 33935: @2391795
     /* 2391795 */ GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2391898),
     /* 2391800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2391803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2391811 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2391854), // Rule ID 59128 //
     /* 2391816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391819 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391853 */     // GIR_Coverage, 59128,
     /* 2391853 */     GIR_EraseRootFromParent_Done,
     /* 2391854 */   // Label 34000: @2391854
     /* 2391854 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2391897), // Rule ID 59129 //
     /* 2391859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391862 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2391865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2391879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391896 */     // GIR_Coverage, 59129,
     /* 2391896 */     GIR_EraseRootFromParent_Done,
     /* 2391897 */   // Label 34001: @2391897
     /* 2391897 */   GIM_Reject,
     /* 2391898 */ // Label 33999: @2391898
     /* 2391898 */ GIM_Reject,
     /* 2391899 */ // Label 33936: @2391899
     /* 2391899 */ GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2392002),
     /* 2391904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2391907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2391915 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2391958), // Rule ID 59136 //
     /* 2391920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2391923 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391957 */     // GIR_Coverage, 59136,
     /* 2391957 */     GIR_EraseRootFromParent_Done,
     /* 2391958 */   // Label 34003: @2391958
     /* 2391958 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2392001), // Rule ID 59137 //
     /* 2391963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2391966 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2391969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2391983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392000 */     // GIR_Coverage, 59137,
     /* 2392000 */     GIR_EraseRootFromParent_Done,
     /* 2392001 */   // Label 34004: @2392001
     /* 2392001 */   GIM_Reject,
     /* 2392002 */ // Label 34002: @2392002
     /* 2392002 */ GIM_Reject,
     /* 2392003 */ // Label 33937: @2392003
     /* 2392003 */ GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2392106),
     /* 2392008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2392011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2392019 */   GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2392062), // Rule ID 59122 //
     /* 2392024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392027 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2392030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2392044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392061 */     // GIR_Coverage, 59122,
     /* 2392061 */     GIR_EraseRootFromParent_Done,
     /* 2392062 */   // Label 34006: @2392062
     /* 2392062 */   GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2392105), // Rule ID 59123 //
     /* 2392067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392070 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2392073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2392087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392104 */     // GIR_Coverage, 59123,
     /* 2392104 */     GIR_EraseRootFromParent_Done,
     /* 2392105 */   // Label 34007: @2392105
     /* 2392105 */   GIM_Reject,
     /* 2392106 */ // Label 34005: @2392106
     /* 2392106 */ GIM_Reject,
     /* 2392107 */ // Label 33938: @2392107
     /* 2392107 */ GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2392210),
     /* 2392112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2392115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392123 */   GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2392166), // Rule ID 59130 //
     /* 2392128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392131 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2392134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392165 */     // GIR_Coverage, 59130,
     /* 2392165 */     GIR_EraseRootFromParent_Done,
     /* 2392166 */   // Label 34009: @2392166
     /* 2392166 */   GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2392209), // Rule ID 59131 //
     /* 2392171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392174 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2392177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392208 */     // GIR_Coverage, 59131,
     /* 2392208 */     GIR_EraseRootFromParent_Done,
     /* 2392209 */   // Label 34010: @2392209
     /* 2392209 */   GIM_Reject,
     /* 2392210 */ // Label 34008: @2392210
     /* 2392210 */ GIM_Reject,
     /* 2392211 */ // Label 33939: @2392211
     /* 2392211 */ GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2392314),
     /* 2392216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2392219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2392227 */   GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2392270), // Rule ID 59124 //
     /* 2392232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2392235 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2392238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392269 */     // GIR_Coverage, 59124,
     /* 2392269 */     GIR_EraseRootFromParent_Done,
     /* 2392270 */   // Label 34012: @2392270
     /* 2392270 */   GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2392313), // Rule ID 59125 //
     /* 2392275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2392278 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2392281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2392295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392312 */     // GIR_Coverage, 59125,
     /* 2392312 */     GIR_EraseRootFromParent_Done,
     /* 2392313 */   // Label 34013: @2392313
     /* 2392313 */   GIM_Reject,
     /* 2392314 */ // Label 34011: @2392314
     /* 2392314 */ GIM_Reject,
     /* 2392315 */ // Label 33940: @2392315
     /* 2392315 */ GIM_Reject,
     /* 2392316 */ // Label 92: @2392316
     /* 2392316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 34038*/ GIMT_Encode4(2394861),
     /* 2392327 */ /*GILLT_s32*//*Label 34014*/ GIMT_Encode4(2392451),
     /* 2392331 */ /*GILLT_s64*//*Label 34015*/ GIMT_Encode4(2392538), GIMT_Encode4(0),
     /* 2392339 */ /*GILLT_nxv1s8*//*Label 34016*/ GIMT_Encode4(2392573),
     /* 2392343 */ /*GILLT_nxv1s16*//*Label 34017*/ GIMT_Encode4(2392677),
     /* 2392347 */ /*GILLT_nxv1s32*//*Label 34018*/ GIMT_Encode4(2392781),
     /* 2392351 */ /*GILLT_nxv1s64*//*Label 34019*/ GIMT_Encode4(2392885), GIMT_Encode4(0),
     /* 2392359 */ /*GILLT_nxv2s8*//*Label 34020*/ GIMT_Encode4(2392989),
     /* 2392363 */ /*GILLT_nxv2s16*//*Label 34021*/ GIMT_Encode4(2393093),
     /* 2392367 */ /*GILLT_nxv2s32*//*Label 34022*/ GIMT_Encode4(2393197),
     /* 2392371 */ /*GILLT_nxv2s64*//*Label 34023*/ GIMT_Encode4(2393301), GIMT_Encode4(0),
     /* 2392379 */ /*GILLT_nxv4s8*//*Label 34024*/ GIMT_Encode4(2393405),
     /* 2392383 */ /*GILLT_nxv4s16*//*Label 34025*/ GIMT_Encode4(2393509),
     /* 2392387 */ /*GILLT_nxv4s32*//*Label 34026*/ GIMT_Encode4(2393613),
     /* 2392391 */ /*GILLT_nxv4s64*//*Label 34027*/ GIMT_Encode4(2393717), GIMT_Encode4(0),
     /* 2392399 */ /*GILLT_nxv8s8*//*Label 34028*/ GIMT_Encode4(2393821),
     /* 2392403 */ /*GILLT_nxv8s16*//*Label 34029*/ GIMT_Encode4(2393925),
     /* 2392407 */ /*GILLT_nxv8s32*//*Label 34030*/ GIMT_Encode4(2394029),
     /* 2392411 */ /*GILLT_nxv8s64*//*Label 34031*/ GIMT_Encode4(2394133), GIMT_Encode4(0),
     /* 2392419 */ /*GILLT_nxv16s8*//*Label 34032*/ GIMT_Encode4(2394237),
     /* 2392423 */ /*GILLT_nxv16s16*//*Label 34033*/ GIMT_Encode4(2394341),
     /* 2392427 */ /*GILLT_nxv16s32*//*Label 34034*/ GIMT_Encode4(2394445), GIMT_Encode4(0),
     /* 2392435 */ /*GILLT_nxv32s8*//*Label 34035*/ GIMT_Encode4(2394549),
     /* 2392439 */ /*GILLT_nxv32s16*//*Label 34036*/ GIMT_Encode4(2394653), GIMT_Encode4(0),
     /* 2392447 */ /*GILLT_nxv64s8*//*Label 34037*/ GIMT_Encode4(2394757),
     /* 2392451 */ // Label 34014: @2392451
     /* 2392451 */ GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2392537),
     /* 2392456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392459 */   GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2392490), // Rule ID 64453 //
     /* 2392464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2392467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392475 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2392475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2392478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2392482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392489 */     // GIR_Coverage, 64453,
     /* 2392489 */     GIR_EraseRootFromParent_Done,
     /* 2392490 */   // Label 34040: @2392490
     /* 2392490 */   GIM_Try, /*On fail goto*//*Label 34041*/ GIMT_Encode4(2392513), // Rule ID 64635 //
     /* 2392495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2392498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392506 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2392506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2392511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392512 */     // GIR_Coverage, 64635,
     /* 2392512 */     GIR_Done,
     /* 2392513 */   // Label 34041: @2392513
     /* 2392513 */   GIM_Try, /*On fail goto*//*Label 34042*/ GIMT_Encode4(2392536), // Rule ID 64636 //
     /* 2392518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2392521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2392529 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2392529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2392534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392535 */     // GIR_Coverage, 64636,
     /* 2392535 */     GIR_Done,
     /* 2392536 */   // Label 34042: @2392536
     /* 2392536 */   GIM_Reject,
     /* 2392537 */ // Label 34039: @2392537
     /* 2392537 */ GIM_Reject,
     /* 2392538 */ // Label 34015: @2392538
     /* 2392538 */ GIM_Try, /*On fail goto*//*Label 34043*/ GIMT_Encode4(2392572), // Rule ID 64452 //
     /* 2392543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2392546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2392549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392557 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2392557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2392560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2392564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2392570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2392571 */   // GIR_Coverage, 64452,
     /* 2392571 */   GIR_EraseRootFromParent_Done,
     /* 2392572 */ // Label 34043: @2392572
     /* 2392572 */ GIM_Reject,
     /* 2392573 */ // Label 34016: @2392573
     /* 2392573 */ GIM_Try, /*On fail goto*//*Label 34044*/ GIMT_Encode4(2392676),
     /* 2392578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2392581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392589 */   GIM_Try, /*On fail goto*//*Label 34045*/ GIMT_Encode4(2392632), // Rule ID 58924 //
     /* 2392594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392597 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2392600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2392614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392631 */     // GIR_Coverage, 58924,
     /* 2392631 */     GIR_EraseRootFromParent_Done,
     /* 2392632 */   // Label 34045: @2392632
     /* 2392632 */   GIM_Try, /*On fail goto*//*Label 34046*/ GIMT_Encode4(2392675), // Rule ID 58925 //
     /* 2392637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392640 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2392643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2392657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392674 */     // GIR_Coverage, 58925,
     /* 2392674 */     GIR_EraseRootFromParent_Done,
     /* 2392675 */   // Label 34046: @2392675
     /* 2392675 */   GIM_Reject,
     /* 2392676 */ // Label 34044: @2392676
     /* 2392676 */ GIM_Reject,
     /* 2392677 */ // Label 34017: @2392677
     /* 2392677 */ GIM_Try, /*On fail goto*//*Label 34047*/ GIMT_Encode4(2392780),
     /* 2392682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2392685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392693 */   GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2392736), // Rule ID 59062 //
     /* 2392698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392701 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2392718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392735 */     // GIR_Coverage, 59062,
     /* 2392735 */     GIR_EraseRootFromParent_Done,
     /* 2392736 */   // Label 34048: @2392736
     /* 2392736 */   GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2392779), // Rule ID 59063 //
     /* 2392741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392744 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2392761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392778 */     // GIR_Coverage, 59063,
     /* 2392778 */     GIR_EraseRootFromParent_Done,
     /* 2392779 */   // Label 34049: @2392779
     /* 2392779 */   GIM_Reject,
     /* 2392780 */ // Label 34047: @2392780
     /* 2392780 */ GIM_Reject,
     /* 2392781 */ // Label 34018: @2392781
     /* 2392781 */ GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2392884),
     /* 2392786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392797 */   GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2392840), // Rule ID 59066 //
     /* 2392802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2392805 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2392822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392839 */     // GIR_Coverage, 59066,
     /* 2392839 */     GIR_EraseRootFromParent_Done,
     /* 2392840 */   // Label 34051: @2392840
     /* 2392840 */   GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2392883), // Rule ID 59067 //
     /* 2392845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2392848 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2392865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392882 */     // GIR_Coverage, 59067,
     /* 2392882 */     GIR_EraseRootFromParent_Done,
     /* 2392883 */   // Label 34052: @2392883
     /* 2392883 */   GIM_Reject,
     /* 2392884 */ // Label 34050: @2392884
     /* 2392884 */ GIM_Reject,
     /* 2392885 */ // Label 34019: @2392885
     /* 2392885 */ GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2392988),
     /* 2392890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392901 */   GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2392944), // Rule ID 59074 //
     /* 2392906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2392909 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2392926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392943 */     // GIR_Coverage, 59074,
     /* 2392943 */     GIR_EraseRootFromParent_Done,
     /* 2392944 */   // Label 34054: @2392944
     /* 2392944 */   GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2392987), // Rule ID 59075 //
     /* 2392949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2392952 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2392969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392986 */     // GIR_Coverage, 59075,
     /* 2392986 */     GIR_EraseRootFromParent_Done,
     /* 2392987 */   // Label 34055: @2392987
     /* 2392987 */   GIM_Reject,
     /* 2392988 */ // Label 34053: @2392988
     /* 2392988 */ GIM_Reject,
     /* 2392989 */ // Label 34020: @2392989
     /* 2392989 */ GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2393092),
     /* 2392994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2392997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393005 */   GIM_Try, /*On fail goto*//*Label 34057*/ GIMT_Encode4(2393048), // Rule ID 59058 //
     /* 2393010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393013 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2393016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2393030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393047 */     // GIR_Coverage, 59058,
     /* 2393047 */     GIR_EraseRootFromParent_Done,
     /* 2393048 */   // Label 34057: @2393048
     /* 2393048 */   GIM_Try, /*On fail goto*//*Label 34058*/ GIMT_Encode4(2393091), // Rule ID 59059 //
     /* 2393053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393056 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2393059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2393073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393090 */     // GIR_Coverage, 59059,
     /* 2393090 */     GIR_EraseRootFromParent_Done,
     /* 2393091 */   // Label 34058: @2393091
     /* 2393091 */   GIM_Reject,
     /* 2393092 */ // Label 34056: @2393092
     /* 2393092 */ GIM_Reject,
     /* 2393093 */ // Label 34021: @2393093
     /* 2393093 */ GIM_Try, /*On fail goto*//*Label 34059*/ GIMT_Encode4(2393196),
     /* 2393098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393109 */   GIM_Try, /*On fail goto*//*Label 34060*/ GIMT_Encode4(2393152), // Rule ID 59064 //
     /* 2393114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393117 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393151 */     // GIR_Coverage, 59064,
     /* 2393151 */     GIR_EraseRootFromParent_Done,
     /* 2393152 */   // Label 34060: @2393152
     /* 2393152 */   GIM_Try, /*On fail goto*//*Label 34061*/ GIMT_Encode4(2393195), // Rule ID 59065 //
     /* 2393157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393160 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2393163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393194 */     // GIR_Coverage, 59065,
     /* 2393194 */     GIR_EraseRootFromParent_Done,
     /* 2393195 */   // Label 34061: @2393195
     /* 2393195 */   GIM_Reject,
     /* 2393196 */ // Label 34059: @2393196
     /* 2393196 */ GIM_Reject,
     /* 2393197 */ // Label 34022: @2393197
     /* 2393197 */ GIM_Try, /*On fail goto*//*Label 34062*/ GIMT_Encode4(2393300),
     /* 2393202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393213 */   GIM_Try, /*On fail goto*//*Label 34063*/ GIMT_Encode4(2393256), // Rule ID 59072 //
     /* 2393218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393221 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393255 */     // GIR_Coverage, 59072,
     /* 2393255 */     GIR_EraseRootFromParent_Done,
     /* 2393256 */   // Label 34063: @2393256
     /* 2393256 */   GIM_Try, /*On fail goto*//*Label 34064*/ GIMT_Encode4(2393299), // Rule ID 59073 //
     /* 2393261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393264 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2393267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393298 */     // GIR_Coverage, 59073,
     /* 2393298 */     GIR_EraseRootFromParent_Done,
     /* 2393299 */   // Label 34064: @2393299
     /* 2393299 */   GIM_Reject,
     /* 2393300 */ // Label 34062: @2393300
     /* 2393300 */ GIM_Reject,
     /* 2393301 */ // Label 34023: @2393301
     /* 2393301 */ GIM_Try, /*On fail goto*//*Label 34065*/ GIMT_Encode4(2393404),
     /* 2393306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2393309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393317 */   GIM_Try, /*On fail goto*//*Label 34066*/ GIMT_Encode4(2393360), // Rule ID 59094 //
     /* 2393322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2393325 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393359 */     // GIR_Coverage, 59094,
     /* 2393359 */     GIR_EraseRootFromParent_Done,
     /* 2393360 */   // Label 34066: @2393360
     /* 2393360 */   GIM_Try, /*On fail goto*//*Label 34067*/ GIMT_Encode4(2393403), // Rule ID 59095 //
     /* 2393365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2393368 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2393371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393402 */     // GIR_Coverage, 59095,
     /* 2393402 */     GIR_EraseRootFromParent_Done,
     /* 2393403 */   // Label 34067: @2393403
     /* 2393403 */   GIM_Reject,
     /* 2393404 */ // Label 34065: @2393404
     /* 2393404 */ GIM_Reject,
     /* 2393405 */ // Label 34024: @2393405
     /* 2393405 */ GIM_Try, /*On fail goto*//*Label 34068*/ GIMT_Encode4(2393508),
     /* 2393410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2393413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393421 */   GIM_Try, /*On fail goto*//*Label 34069*/ GIMT_Encode4(2393464), // Rule ID 59060 //
     /* 2393426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393429 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2393432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393463 */     // GIR_Coverage, 59060,
     /* 2393463 */     GIR_EraseRootFromParent_Done,
     /* 2393464 */   // Label 34069: @2393464
     /* 2393464 */   GIM_Try, /*On fail goto*//*Label 34070*/ GIMT_Encode4(2393507), // Rule ID 59061 //
     /* 2393469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393472 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2393475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2393489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393506 */     // GIR_Coverage, 59061,
     /* 2393506 */     GIR_EraseRootFromParent_Done,
     /* 2393507 */   // Label 34070: @2393507
     /* 2393507 */   GIM_Reject,
     /* 2393508 */ // Label 34068: @2393508
     /* 2393508 */ GIM_Reject,
     /* 2393509 */ // Label 34025: @2393509
     /* 2393509 */ GIM_Try, /*On fail goto*//*Label 34071*/ GIMT_Encode4(2393612),
     /* 2393514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2393517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393525 */   GIM_Try, /*On fail goto*//*Label 34072*/ GIMT_Encode4(2393568), // Rule ID 59070 //
     /* 2393530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393533 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393567 */     // GIR_Coverage, 59070,
     /* 2393567 */     GIR_EraseRootFromParent_Done,
     /* 2393568 */   // Label 34072: @2393568
     /* 2393568 */   GIM_Try, /*On fail goto*//*Label 34073*/ GIMT_Encode4(2393611), // Rule ID 59071 //
     /* 2393573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393576 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393610 */     // GIR_Coverage, 59071,
     /* 2393610 */     GIR_EraseRootFromParent_Done,
     /* 2393611 */   // Label 34073: @2393611
     /* 2393611 */   GIM_Reject,
     /* 2393612 */ // Label 34071: @2393612
     /* 2393612 */ GIM_Reject,
     /* 2393613 */ // Label 34026: @2393613
     /* 2393613 */ GIM_Try, /*On fail goto*//*Label 34074*/ GIMT_Encode4(2393716),
     /* 2393618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2393621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393629 */   GIM_Try, /*On fail goto*//*Label 34075*/ GIMT_Encode4(2393672), // Rule ID 59088 //
     /* 2393634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393637 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393671 */     // GIR_Coverage, 59088,
     /* 2393671 */     GIR_EraseRootFromParent_Done,
     /* 2393672 */   // Label 34075: @2393672
     /* 2393672 */   GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2393715), // Rule ID 59089 //
     /* 2393677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393680 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393714 */     // GIR_Coverage, 59089,
     /* 2393714 */     GIR_EraseRootFromParent_Done,
     /* 2393715 */   // Label 34076: @2393715
     /* 2393715 */   GIM_Reject,
     /* 2393716 */ // Label 34074: @2393716
     /* 2393716 */ GIM_Reject,
     /* 2393717 */ // Label 34027: @2393717
     /* 2393717 */ GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2393820),
     /* 2393722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2393725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393733 */   GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2393776), // Rule ID 59096 //
     /* 2393738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2393741 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2393758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393775 */     // GIR_Coverage, 59096,
     /* 2393775 */     GIR_EraseRootFromParent_Done,
     /* 2393776 */   // Label 34078: @2393776
     /* 2393776 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2393819), // Rule ID 59097 //
     /* 2393781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2393784 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2393801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393818 */     // GIR_Coverage, 59097,
     /* 2393818 */     GIR_EraseRootFromParent_Done,
     /* 2393819 */   // Label 34079: @2393819
     /* 2393819 */   GIM_Reject,
     /* 2393820 */ // Label 34077: @2393820
     /* 2393820 */ GIM_Reject,
     /* 2393821 */ // Label 34028: @2393821
     /* 2393821 */ GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2393924),
     /* 2393826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2393829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393837 */   GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2393880), // Rule ID 59068 //
     /* 2393842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393845 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2393848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393879 */     // GIR_Coverage, 59068,
     /* 2393879 */     GIR_EraseRootFromParent_Done,
     /* 2393880 */   // Label 34081: @2393880
     /* 2393880 */   GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2393923), // Rule ID 59069 //
     /* 2393885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393888 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2393891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2393905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393922 */     // GIR_Coverage, 59069,
     /* 2393922 */     GIR_EraseRootFromParent_Done,
     /* 2393923 */   // Label 34082: @2393923
     /* 2393923 */   GIM_Reject,
     /* 2393924 */ // Label 34080: @2393924
     /* 2393924 */ GIM_Reject,
     /* 2393925 */ // Label 34029: @2393925
     /* 2393925 */ GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2394028),
     /* 2393930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2393933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393941 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2393984), // Rule ID 59082 //
     /* 2393946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2393949 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2393966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393983 */     // GIR_Coverage, 59082,
     /* 2393983 */     GIR_EraseRootFromParent_Done,
     /* 2393984 */   // Label 34084: @2393984
     /* 2393984 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2394027), // Rule ID 59083 //
     /* 2393989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2393992 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394026 */     // GIR_Coverage, 59083,
     /* 2394026 */     GIR_EraseRootFromParent_Done,
     /* 2394027 */   // Label 34085: @2394027
     /* 2394027 */   GIM_Reject,
     /* 2394028 */ // Label 34083: @2394028
     /* 2394028 */ GIM_Reject,
     /* 2394029 */ // Label 34030: @2394029
     /* 2394029 */ GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2394132),
     /* 2394034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2394037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394045 */   GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2394088), // Rule ID 59090 //
     /* 2394050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394053 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2394056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394087 */     // GIR_Coverage, 59090,
     /* 2394087 */     GIR_EraseRootFromParent_Done,
     /* 2394088 */   // Label 34087: @2394088
     /* 2394088 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2394131), // Rule ID 59091 //
     /* 2394093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394096 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2394099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394130 */     // GIR_Coverage, 59091,
     /* 2394130 */     GIR_EraseRootFromParent_Done,
     /* 2394131 */   // Label 34088: @2394131
     /* 2394131 */   GIM_Reject,
     /* 2394132 */ // Label 34086: @2394132
     /* 2394132 */ GIM_Reject,
     /* 2394133 */ // Label 34031: @2394133
     /* 2394133 */ GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2394236),
     /* 2394138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2394141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394149 */   GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2394192), // Rule ID 59098 //
     /* 2394154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2394157 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394191 */     // GIR_Coverage, 59098,
     /* 2394191 */     GIR_EraseRootFromParent_Done,
     /* 2394192 */   // Label 34090: @2394192
     /* 2394192 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2394235), // Rule ID 59099 //
     /* 2394197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2394200 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2394203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394234 */     // GIR_Coverage, 59099,
     /* 2394234 */     GIR_EraseRootFromParent_Done,
     /* 2394235 */   // Label 34091: @2394235
     /* 2394235 */   GIM_Reject,
     /* 2394236 */ // Label 34089: @2394236
     /* 2394236 */ GIM_Reject,
     /* 2394237 */ // Label 34032: @2394237
     /* 2394237 */ GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2394340),
     /* 2394242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2394245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394253 */   GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2394296), // Rule ID 59076 //
     /* 2394258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394261 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2394264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394295 */     // GIR_Coverage, 59076,
     /* 2394295 */     GIR_EraseRootFromParent_Done,
     /* 2394296 */   // Label 34093: @2394296
     /* 2394296 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2394339), // Rule ID 59077 //
     /* 2394301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394304 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2394307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2394321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394338 */     // GIR_Coverage, 59077,
     /* 2394338 */     GIR_EraseRootFromParent_Done,
     /* 2394339 */   // Label 34094: @2394339
     /* 2394339 */   GIM_Reject,
     /* 2394340 */ // Label 34092: @2394340
     /* 2394340 */ GIM_Reject,
     /* 2394341 */ // Label 34033: @2394341
     /* 2394341 */ GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2394444),
     /* 2394346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2394349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394357 */   GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2394400), // Rule ID 59084 //
     /* 2394362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394365 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394399 */     // GIR_Coverage, 59084,
     /* 2394399 */     GIR_EraseRootFromParent_Done,
     /* 2394400 */   // Label 34096: @2394400
     /* 2394400 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2394443), // Rule ID 59085 //
     /* 2394405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394408 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2394411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394442 */     // GIR_Coverage, 59085,
     /* 2394442 */     GIR_EraseRootFromParent_Done,
     /* 2394443 */   // Label 34097: @2394443
     /* 2394443 */   GIM_Reject,
     /* 2394444 */ // Label 34095: @2394444
     /* 2394444 */ GIM_Reject,
     /* 2394445 */ // Label 34034: @2394445
     /* 2394445 */ GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2394548),
     /* 2394450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2394453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394461 */   GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2394504), // Rule ID 59092 //
     /* 2394466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394469 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394503 */     // GIR_Coverage, 59092,
     /* 2394503 */     GIR_EraseRootFromParent_Done,
     /* 2394504 */   // Label 34099: @2394504
     /* 2394504 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2394547), // Rule ID 59093 //
     /* 2394509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394512 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2394515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394546 */     // GIR_Coverage, 59093,
     /* 2394546 */     GIR_EraseRootFromParent_Done,
     /* 2394547 */   // Label 34100: @2394547
     /* 2394547 */   GIM_Reject,
     /* 2394548 */ // Label 34098: @2394548
     /* 2394548 */ GIM_Reject,
     /* 2394549 */ // Label 34035: @2394549
     /* 2394549 */ GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2394652),
     /* 2394554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2394557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2394565 */   GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2394608), // Rule ID 59078 //
     /* 2394570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394573 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2394576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394607 */     // GIR_Coverage, 59078,
     /* 2394607 */     GIR_EraseRootFromParent_Done,
     /* 2394608 */   // Label 34102: @2394608
     /* 2394608 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2394651), // Rule ID 59079 //
     /* 2394613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394616 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2394619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2394633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394650 */     // GIR_Coverage, 59079,
     /* 2394650 */     GIR_EraseRootFromParent_Done,
     /* 2394651 */   // Label 34103: @2394651
     /* 2394651 */   GIM_Reject,
     /* 2394652 */ // Label 34101: @2394652
     /* 2394652 */ GIM_Reject,
     /* 2394653 */ // Label 34036: @2394653
     /* 2394653 */ GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2394756),
     /* 2394658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2394661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394669 */   GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2394712), // Rule ID 59086 //
     /* 2394674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394677 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394711 */     // GIR_Coverage, 59086,
     /* 2394711 */     GIR_EraseRootFromParent_Done,
     /* 2394712 */   // Label 34105: @2394712
     /* 2394712 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2394755), // Rule ID 59087 //
     /* 2394717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394720 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394754 */     // GIR_Coverage, 59087,
     /* 2394754 */     GIR_EraseRootFromParent_Done,
     /* 2394755 */   // Label 34106: @2394755
     /* 2394755 */   GIM_Reject,
     /* 2394756 */ // Label 34104: @2394756
     /* 2394756 */ GIM_Reject,
     /* 2394757 */ // Label 34037: @2394757
     /* 2394757 */ GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2394860),
     /* 2394762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2394765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394773 */   GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2394816), // Rule ID 59080 //
     /* 2394778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2394781 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2394784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394815 */     // GIR_Coverage, 59080,
     /* 2394815 */     GIR_EraseRootFromParent_Done,
     /* 2394816 */   // Label 34108: @2394816
     /* 2394816 */   GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2394859), // Rule ID 59081 //
     /* 2394821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2394824 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2394827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2394841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394858 */     // GIR_Coverage, 59081,
     /* 2394858 */     GIR_EraseRootFromParent_Done,
     /* 2394859 */   // Label 34109: @2394859
     /* 2394859 */   GIM_Reject,
     /* 2394860 */ // Label 34107: @2394860
     /* 2394860 */ GIM_Reject,
     /* 2394861 */ // Label 34038: @2394861
     /* 2394861 */ GIM_Reject,
     /* 2394862 */ // Label 93: @2394862
     /* 2394862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34113*/ GIMT_Encode4(2395059),
     /* 2394873 */ /*GILLT_s16*//*Label 34110*/ GIMT_Encode4(2394885),
     /* 2394877 */ /*GILLT_s32*//*Label 34111*/ GIMT_Encode4(2394943),
     /* 2394881 */ /*GILLT_s64*//*Label 34112*/ GIMT_Encode4(2395001),
     /* 2394885 */ // Label 34110: @2394885
     /* 2394885 */ GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2394942),
     /* 2394890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2394893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394901 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2394921), // Rule ID 2432 //
     /* 2394906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2394909 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2394909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2394912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394920 */     // GIR_Coverage, 2432,
     /* 2394920 */     GIR_EraseRootFromParent_Done,
     /* 2394921 */   // Label 34115: @2394921
     /* 2394921 */   GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2394941), // Rule ID 2433 //
     /* 2394926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2394929 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2394929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2394932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394940 */     // GIR_Coverage, 2433,
     /* 2394940 */     GIR_EraseRootFromParent_Done,
     /* 2394941 */   // Label 34116: @2394941
     /* 2394941 */   GIM_Reject,
     /* 2394942 */ // Label 34114: @2394942
     /* 2394942 */ GIM_Reject,
     /* 2394943 */ // Label 34111: @2394943
     /* 2394943 */ GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2395000),
     /* 2394948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2394951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394959 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2394979), // Rule ID 2350 //
     /* 2394964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2394967 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2394967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2394970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394978 */     // GIR_Coverage, 2350,
     /* 2394978 */     GIR_EraseRootFromParent_Done,
     /* 2394979 */   // Label 34118: @2394979
     /* 2394979 */   GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2394999), // Rule ID 2351 //
     /* 2394984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2394987 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2394987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2394990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394998 */     // GIR_Coverage, 2351,
     /* 2394998 */     GIR_EraseRootFromParent_Done,
     /* 2394999 */   // Label 34119: @2394999
     /* 2394999 */   GIM_Reject,
     /* 2395000 */ // Label 34117: @2395000
     /* 2395000 */ GIM_Reject,
     /* 2395001 */ // Label 34112: @2395001
     /* 2395001 */ GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2395058),
     /* 2395006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2395009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395017 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2395037), // Rule ID 2390 //
     /* 2395022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2395025 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2395025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2395028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395036 */     // GIR_Coverage, 2390,
     /* 2395036 */     GIR_EraseRootFromParent_Done,
     /* 2395037 */   // Label 34121: @2395037
     /* 2395037 */   GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2395057), // Rule ID 2391 //
     /* 2395042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2395045 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2395045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2395048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395056 */     // GIR_Coverage, 2391,
     /* 2395056 */     GIR_EraseRootFromParent_Done,
     /* 2395057 */   // Label 34122: @2395057
     /* 2395057 */   GIM_Reject,
     /* 2395058 */ // Label 34120: @2395058
     /* 2395058 */ GIM_Reject,
     /* 2395059 */ // Label 34113: @2395059
     /* 2395059 */ GIM_Reject,
     /* 2395060 */ // Label 94: @2395060
     /* 2395060 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34141*/ GIMT_Encode4(2397235),
     /* 2395071 */ /*GILLT_s16*//*Label 34123*/ GIMT_Encode4(2395191),
     /* 2395075 */ /*GILLT_s32*//*Label 34124*/ GIMT_Encode4(2395313),
     /* 2395079 */ /*GILLT_s64*//*Label 34125*/ GIMT_Encode4(2395435), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395091 */ /*GILLT_nxv1s16*//*Label 34126*/ GIMT_Encode4(2395585),
     /* 2395095 */ /*GILLT_nxv1s32*//*Label 34127*/ GIMT_Encode4(2395695),
     /* 2395099 */ /*GILLT_nxv1s64*//*Label 34128*/ GIMT_Encode4(2395805), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395111 */ /*GILLT_nxv2s16*//*Label 34129*/ GIMT_Encode4(2395915),
     /* 2395115 */ /*GILLT_nxv2s32*//*Label 34130*/ GIMT_Encode4(2396025),
     /* 2395119 */ /*GILLT_nxv2s64*//*Label 34131*/ GIMT_Encode4(2396135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395131 */ /*GILLT_nxv4s16*//*Label 34132*/ GIMT_Encode4(2396245),
     /* 2395135 */ /*GILLT_nxv4s32*//*Label 34133*/ GIMT_Encode4(2396355),
     /* 2395139 */ /*GILLT_nxv4s64*//*Label 34134*/ GIMT_Encode4(2396465), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395151 */ /*GILLT_nxv8s16*//*Label 34135*/ GIMT_Encode4(2396575),
     /* 2395155 */ /*GILLT_nxv8s32*//*Label 34136*/ GIMT_Encode4(2396685),
     /* 2395159 */ /*GILLT_nxv8s64*//*Label 34137*/ GIMT_Encode4(2396795), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395171 */ /*GILLT_nxv16s16*//*Label 34138*/ GIMT_Encode4(2396905),
     /* 2395175 */ /*GILLT_nxv16s32*//*Label 34139*/ GIMT_Encode4(2397015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2395187 */ /*GILLT_nxv32s16*//*Label 34140*/ GIMT_Encode4(2397125),
     /* 2395191 */ // Label 34123: @2395191
     /* 2395191 */ GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2395312),
     /* 2395196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2395199 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2395227), // Rule ID 1990 //
     /* 2395204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2395207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395215 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2395215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2395218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395226 */     // GIR_Coverage, 1990,
     /* 2395226 */     GIR_EraseRootFromParent_Done,
     /* 2395227 */   // Label 34143: @2395227
     /* 2395227 */   GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2395255), // Rule ID 1991 //
     /* 2395232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2395235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2395243 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2395243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2395246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395254 */     // GIR_Coverage, 1991,
     /* 2395254 */     GIR_EraseRootFromParent_Done,
     /* 2395255 */   // Label 34144: @2395255
     /* 2395255 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2395283), // Rule ID 2023 //
     /* 2395260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2395263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395271 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2395271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2395274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395282 */     // GIR_Coverage, 2023,
     /* 2395282 */     GIR_EraseRootFromParent_Done,
     /* 2395283 */   // Label 34145: @2395283
     /* 2395283 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2395311), // Rule ID 2024 //
     /* 2395288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2395291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2395299 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2395299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2395302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395310 */     // GIR_Coverage, 2024,
     /* 2395310 */     GIR_EraseRootFromParent_Done,
     /* 2395311 */   // Label 34146: @2395311
     /* 2395311 */   GIM_Reject,
     /* 2395312 */ // Label 34142: @2395312
     /* 2395312 */ GIM_Reject,
     /* 2395313 */ // Label 34124: @2395313
     /* 2395313 */ GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2395434),
     /* 2395318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2395321 */   GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2395349), // Rule ID 1281 //
     /* 2395326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2395329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395337 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2395337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2395340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395348 */     // GIR_Coverage, 1281,
     /* 2395348 */     GIR_EraseRootFromParent_Done,
     /* 2395349 */   // Label 34148: @2395349
     /* 2395349 */   GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2395377), // Rule ID 1282 //
     /* 2395354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2395357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2395365 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2395365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2395368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395376 */     // GIR_Coverage, 1282,
     /* 2395376 */     GIR_EraseRootFromParent_Done,
     /* 2395377 */   // Label 34149: @2395377
     /* 2395377 */   GIM_Try, /*On fail goto*//*Label 34150*/ GIMT_Encode4(2395405), // Rule ID 1289 //
     /* 2395382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2395385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395393 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2395393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2395396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395404 */     // GIR_Coverage, 1289,
     /* 2395404 */     GIR_EraseRootFromParent_Done,
     /* 2395405 */   // Label 34150: @2395405
     /* 2395405 */   GIM_Try, /*On fail goto*//*Label 34151*/ GIMT_Encode4(2395433), // Rule ID 1290 //
     /* 2395410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2395413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2395421 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2395421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2395424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395432 */     // GIR_Coverage, 1290,
     /* 2395432 */     GIR_EraseRootFromParent_Done,
     /* 2395433 */   // Label 34151: @2395433
     /* 2395433 */   GIM_Reject,
     /* 2395434 */ // Label 34147: @2395434
     /* 2395434 */ GIM_Reject,
     /* 2395435 */ // Label 34125: @2395435
     /* 2395435 */ GIM_Try, /*On fail goto*//*Label 34152*/ GIMT_Encode4(2395584),
     /* 2395440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2395443 */   GIM_Try, /*On fail goto*//*Label 34153*/ GIMT_Encode4(2395471), // Rule ID 1624 //
     /* 2395448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2395451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395459 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2395462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395470 */     // GIR_Coverage, 1624,
     /* 2395470 */     GIR_EraseRootFromParent_Done,
     /* 2395471 */   // Label 34153: @2395471
     /* 2395471 */   GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2395499), // Rule ID 1625 //
     /* 2395476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2395479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2395487 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2395487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2395490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395498 */     // GIR_Coverage, 1625,
     /* 2395498 */     GIR_EraseRootFromParent_Done,
     /* 2395499 */   // Label 34154: @2395499
     /* 2395499 */   GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2395527), // Rule ID 1658 //
     /* 2395504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2395507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2395515 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2395518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395526 */     // GIR_Coverage, 1658,
     /* 2395526 */     GIR_EraseRootFromParent_Done,
     /* 2395527 */   // Label 34155: @2395527
     /* 2395527 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2395555), // Rule ID 1679 //
     /* 2395532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2395535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395543 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2395543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2395546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395554 */     // GIR_Coverage, 1679,
     /* 2395554 */     GIR_EraseRootFromParent_Done,
     /* 2395555 */   // Label 34156: @2395555
     /* 2395555 */   GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2395583), // Rule ID 1680 //
     /* 2395560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2395563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2395571 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2395571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2395574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395582 */     // GIR_Coverage, 1680,
     /* 2395582 */     GIR_EraseRootFromParent_Done,
     /* 2395583 */   // Label 34157: @2395583
     /* 2395583 */   GIM_Reject,
     /* 2395584 */ // Label 34152: @2395584
     /* 2395584 */ GIM_Reject,
     /* 2395585 */ // Label 34126: @2395585
     /* 2395585 */ GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2395694),
     /* 2395590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395601 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2395647), // Rule ID 56242 //
     /* 2395606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395609 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2395626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395646 */     // GIR_Coverage, 56242,
     /* 2395646 */     GIR_EraseRootFromParent_Done,
     /* 2395647 */   // Label 34159: @2395647
     /* 2395647 */   GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2395693), // Rule ID 56243 //
     /* 2395652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395655 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2395658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2395672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395692 */     // GIR_Coverage, 56243,
     /* 2395692 */     GIR_EraseRootFromParent_Done,
     /* 2395693 */   // Label 34160: @2395693
     /* 2395693 */   GIM_Reject,
     /* 2395694 */ // Label 34158: @2395694
     /* 2395694 */ GIM_Reject,
     /* 2395695 */ // Label 34127: @2395695
     /* 2395695 */ GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2395804),
     /* 2395700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395711 */   GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2395757), // Rule ID 56282 //
     /* 2395716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395719 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2395736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395756 */     // GIR_Coverage, 56282,
     /* 2395756 */     GIR_EraseRootFromParent_Done,
     /* 2395757 */   // Label 34162: @2395757
     /* 2395757 */   GIM_Try, /*On fail goto*//*Label 34163*/ GIMT_Encode4(2395803), // Rule ID 56283 //
     /* 2395762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395765 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2395768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2395782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395802 */     // GIR_Coverage, 56283,
     /* 2395802 */     GIR_EraseRootFromParent_Done,
     /* 2395803 */   // Label 34163: @2395803
     /* 2395803 */   GIM_Reject,
     /* 2395804 */ // Label 34161: @2395804
     /* 2395804 */ GIM_Reject,
     /* 2395805 */ // Label 34128: @2395805
     /* 2395805 */ GIM_Try, /*On fail goto*//*Label 34164*/ GIMT_Encode4(2395914),
     /* 2395810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2395813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395821 */   GIM_Try, /*On fail goto*//*Label 34165*/ GIMT_Encode4(2395867), // Rule ID 56342 //
     /* 2395826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395829 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2395846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395866 */     // GIR_Coverage, 56342,
     /* 2395866 */     GIR_EraseRootFromParent_Done,
     /* 2395867 */   // Label 34165: @2395867
     /* 2395867 */   GIM_Try, /*On fail goto*//*Label 34166*/ GIMT_Encode4(2395913), // Rule ID 56343 //
     /* 2395872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395875 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2395892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395912 */     // GIR_Coverage, 56343,
     /* 2395912 */     GIR_EraseRootFromParent_Done,
     /* 2395913 */   // Label 34166: @2395913
     /* 2395913 */   GIM_Reject,
     /* 2395914 */ // Label 34164: @2395914
     /* 2395914 */ GIM_Reject,
     /* 2395915 */ // Label 34129: @2395915
     /* 2395915 */ GIM_Try, /*On fail goto*//*Label 34167*/ GIMT_Encode4(2396024),
     /* 2395920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2395923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395931 */   GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2395977), // Rule ID 56262 //
     /* 2395936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395939 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2395956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2395963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395976 */     // GIR_Coverage, 56262,
     /* 2395976 */     GIR_EraseRootFromParent_Done,
     /* 2395977 */   // Label 34168: @2395977
     /* 2395977 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2396023), // Rule ID 56263 //
     /* 2395982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395985 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2396002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396022 */     // GIR_Coverage, 56263,
     /* 2396022 */     GIR_EraseRootFromParent_Done,
     /* 2396023 */   // Label 34169: @2396023
     /* 2396023 */   GIM_Reject,
     /* 2396024 */ // Label 34167: @2396024
     /* 2396024 */ GIM_Reject,
     /* 2396025 */ // Label 34130: @2396025
     /* 2396025 */ GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2396134),
     /* 2396030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2396033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396041 */   GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2396087), // Rule ID 56322 //
     /* 2396046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396049 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2396052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2396066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396086 */     // GIR_Coverage, 56322,
     /* 2396086 */     GIR_EraseRootFromParent_Done,
     /* 2396087 */   // Label 34171: @2396087
     /* 2396087 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2396133), // Rule ID 56323 //
     /* 2396092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396095 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2396098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2396112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396132 */     // GIR_Coverage, 56323,
     /* 2396132 */     GIR_EraseRootFromParent_Done,
     /* 2396133 */   // Label 34172: @2396133
     /* 2396133 */   GIM_Reject,
     /* 2396134 */ // Label 34170: @2396134
     /* 2396134 */ GIM_Reject,
     /* 2396135 */ // Label 34131: @2396135
     /* 2396135 */ GIM_Try, /*On fail goto*//*Label 34173*/ GIMT_Encode4(2396244),
     /* 2396140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2396143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396151 */   GIM_Try, /*On fail goto*//*Label 34174*/ GIMT_Encode4(2396197), // Rule ID 56482 //
     /* 2396156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396159 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2396162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2396176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396196 */     // GIR_Coverage, 56482,
     /* 2396196 */     GIR_EraseRootFromParent_Done,
     /* 2396197 */   // Label 34174: @2396197
     /* 2396197 */   GIM_Try, /*On fail goto*//*Label 34175*/ GIMT_Encode4(2396243), // Rule ID 56483 //
     /* 2396202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396205 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2396208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2396222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396242 */     // GIR_Coverage, 56483,
     /* 2396242 */     GIR_EraseRootFromParent_Done,
     /* 2396243 */   // Label 34175: @2396243
     /* 2396243 */   GIM_Reject,
     /* 2396244 */ // Label 34173: @2396244
     /* 2396244 */ GIM_Reject,
     /* 2396245 */ // Label 34132: @2396245
     /* 2396245 */ GIM_Try, /*On fail goto*//*Label 34176*/ GIMT_Encode4(2396354),
     /* 2396250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2396253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396261 */   GIM_Try, /*On fail goto*//*Label 34177*/ GIMT_Encode4(2396307), // Rule ID 56302 //
     /* 2396266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396269 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2396272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2396286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396306 */     // GIR_Coverage, 56302,
     /* 2396306 */     GIR_EraseRootFromParent_Done,
     /* 2396307 */   // Label 34177: @2396307
     /* 2396307 */   GIM_Try, /*On fail goto*//*Label 34178*/ GIMT_Encode4(2396353), // Rule ID 56303 //
     /* 2396312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396315 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2396318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2396332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396352 */     // GIR_Coverage, 56303,
     /* 2396352 */     GIR_EraseRootFromParent_Done,
     /* 2396353 */   // Label 34178: @2396353
     /* 2396353 */   GIM_Reject,
     /* 2396354 */ // Label 34176: @2396354
     /* 2396354 */ GIM_Reject,
     /* 2396355 */ // Label 34133: @2396355
     /* 2396355 */ GIM_Try, /*On fail goto*//*Label 34179*/ GIMT_Encode4(2396464),
     /* 2396360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396371 */   GIM_Try, /*On fail goto*//*Label 34180*/ GIMT_Encode4(2396417), // Rule ID 56422 //
     /* 2396376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396379 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2396396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396416 */     // GIR_Coverage, 56422,
     /* 2396416 */     GIR_EraseRootFromParent_Done,
     /* 2396417 */   // Label 34180: @2396417
     /* 2396417 */   GIM_Try, /*On fail goto*//*Label 34181*/ GIMT_Encode4(2396463), // Rule ID 56423 //
     /* 2396422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396425 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2396428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2396442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396462 */     // GIR_Coverage, 56423,
     /* 2396462 */     GIR_EraseRootFromParent_Done,
     /* 2396463 */   // Label 34181: @2396463
     /* 2396463 */   GIM_Reject,
     /* 2396464 */ // Label 34179: @2396464
     /* 2396464 */ GIM_Reject,
     /* 2396465 */ // Label 34134: @2396465
     /* 2396465 */ GIM_Try, /*On fail goto*//*Label 34182*/ GIMT_Encode4(2396574),
     /* 2396470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2396473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396481 */   GIM_Try, /*On fail goto*//*Label 34183*/ GIMT_Encode4(2396527), // Rule ID 56502 //
     /* 2396486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396489 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2396506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396526 */     // GIR_Coverage, 56502,
     /* 2396526 */     GIR_EraseRootFromParent_Done,
     /* 2396527 */   // Label 34183: @2396527
     /* 2396527 */   GIM_Try, /*On fail goto*//*Label 34184*/ GIMT_Encode4(2396573), // Rule ID 56503 //
     /* 2396532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396535 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2396538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2396552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396572 */     // GIR_Coverage, 56503,
     /* 2396572 */     GIR_EraseRootFromParent_Done,
     /* 2396573 */   // Label 34184: @2396573
     /* 2396573 */   GIM_Reject,
     /* 2396574 */ // Label 34182: @2396574
     /* 2396574 */ GIM_Reject,
     /* 2396575 */ // Label 34135: @2396575
     /* 2396575 */ GIM_Try, /*On fail goto*//*Label 34185*/ GIMT_Encode4(2396684),
     /* 2396580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2396583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396591 */   GIM_Try, /*On fail goto*//*Label 34186*/ GIMT_Encode4(2396637), // Rule ID 56362 //
     /* 2396596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396599 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2396616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396636 */     // GIR_Coverage, 56362,
     /* 2396636 */     GIR_EraseRootFromParent_Done,
     /* 2396637 */   // Label 34186: @2396637
     /* 2396637 */   GIM_Try, /*On fail goto*//*Label 34187*/ GIMT_Encode4(2396683), // Rule ID 56363 //
     /* 2396642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396645 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2396648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2396662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396682 */     // GIR_Coverage, 56363,
     /* 2396682 */     GIR_EraseRootFromParent_Done,
     /* 2396683 */   // Label 34187: @2396683
     /* 2396683 */   GIM_Reject,
     /* 2396684 */ // Label 34185: @2396684
     /* 2396684 */ GIM_Reject,
     /* 2396685 */ // Label 34136: @2396685
     /* 2396685 */ GIM_Try, /*On fail goto*//*Label 34188*/ GIMT_Encode4(2396794),
     /* 2396690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2396693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396701 */   GIM_Try, /*On fail goto*//*Label 34189*/ GIMT_Encode4(2396747), // Rule ID 56442 //
     /* 2396706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396709 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2396726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396746 */     // GIR_Coverage, 56442,
     /* 2396746 */     GIR_EraseRootFromParent_Done,
     /* 2396747 */   // Label 34189: @2396747
     /* 2396747 */   GIM_Try, /*On fail goto*//*Label 34190*/ GIMT_Encode4(2396793), // Rule ID 56443 //
     /* 2396752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396755 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2396772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396792 */     // GIR_Coverage, 56443,
     /* 2396792 */     GIR_EraseRootFromParent_Done,
     /* 2396793 */   // Label 34190: @2396793
     /* 2396793 */   GIM_Reject,
     /* 2396794 */ // Label 34188: @2396794
     /* 2396794 */ GIM_Reject,
     /* 2396795 */ // Label 34137: @2396795
     /* 2396795 */ GIM_Try, /*On fail goto*//*Label 34191*/ GIMT_Encode4(2396904),
     /* 2396800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2396803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396811 */   GIM_Try, /*On fail goto*//*Label 34192*/ GIMT_Encode4(2396857), // Rule ID 56522 //
     /* 2396816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396819 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2396836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396856 */     // GIR_Coverage, 56522,
     /* 2396856 */     GIR_EraseRootFromParent_Done,
     /* 2396857 */   // Label 34192: @2396857
     /* 2396857 */   GIM_Try, /*On fail goto*//*Label 34193*/ GIMT_Encode4(2396903), // Rule ID 56523 //
     /* 2396862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396865 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2396882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396902 */     // GIR_Coverage, 56523,
     /* 2396902 */     GIR_EraseRootFromParent_Done,
     /* 2396903 */   // Label 34193: @2396903
     /* 2396903 */   GIM_Reject,
     /* 2396904 */ // Label 34191: @2396904
     /* 2396904 */ GIM_Reject,
     /* 2396905 */ // Label 34138: @2396905
     /* 2396905 */ GIM_Try, /*On fail goto*//*Label 34194*/ GIMT_Encode4(2397014),
     /* 2396910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2396913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396921 */   GIM_Try, /*On fail goto*//*Label 34195*/ GIMT_Encode4(2396967), // Rule ID 56382 //
     /* 2396926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396929 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2396946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396966 */     // GIR_Coverage, 56382,
     /* 2396966 */     GIR_EraseRootFromParent_Done,
     /* 2396967 */   // Label 34195: @2396967
     /* 2396967 */   GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2397013), // Rule ID 56383 //
     /* 2396972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396975 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2396992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2396999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397012 */     // GIR_Coverage, 56383,
     /* 2397012 */     GIR_EraseRootFromParent_Done,
     /* 2397013 */   // Label 34196: @2397013
     /* 2397013 */   GIM_Reject,
     /* 2397014 */ // Label 34194: @2397014
     /* 2397014 */ GIM_Reject,
     /* 2397015 */ // Label 34139: @2397015
     /* 2397015 */ GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2397124),
     /* 2397020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2397023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397031 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2397077), // Rule ID 56462 //
     /* 2397036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397039 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2397042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2397056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397076 */     // GIR_Coverage, 56462,
     /* 2397076 */     GIR_EraseRootFromParent_Done,
     /* 2397077 */   // Label 34198: @2397077
     /* 2397077 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2397123), // Rule ID 56463 //
     /* 2397082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397085 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2397088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2397102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397122 */     // GIR_Coverage, 56463,
     /* 2397122 */     GIR_EraseRootFromParent_Done,
     /* 2397123 */   // Label 34199: @2397123
     /* 2397123 */   GIM_Reject,
     /* 2397124 */ // Label 34197: @2397124
     /* 2397124 */ GIM_Reject,
     /* 2397125 */ // Label 34140: @2397125
     /* 2397125 */ GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2397234),
     /* 2397130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2397133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2397141 */   GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2397187), // Rule ID 56402 //
     /* 2397146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397149 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2397152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2397166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397186 */     // GIR_Coverage, 56402,
     /* 2397186 */     GIR_EraseRootFromParent_Done,
     /* 2397187 */   // Label 34201: @2397187
     /* 2397187 */   GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2397233), // Rule ID 56403 //
     /* 2397192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397195 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2397198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2397212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2397219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397232 */     // GIR_Coverage, 56403,
     /* 2397232 */     GIR_EraseRootFromParent_Done,
     /* 2397233 */   // Label 34202: @2397233
     /* 2397233 */   GIM_Reject,
     /* 2397234 */ // Label 34200: @2397234
     /* 2397234 */ GIM_Reject,
     /* 2397235 */ // Label 34141: @2397235
     /* 2397235 */ GIM_Reject,
     /* 2397236 */ // Label 95: @2397236
     /* 2397236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34206*/ GIMT_Encode4(2397433),
     /* 2397247 */ /*GILLT_s16*//*Label 34203*/ GIMT_Encode4(2397259),
     /* 2397251 */ /*GILLT_s32*//*Label 34204*/ GIMT_Encode4(2397317),
     /* 2397255 */ /*GILLT_s64*//*Label 34205*/ GIMT_Encode4(2397375),
     /* 2397259 */ // Label 34203: @2397259
     /* 2397259 */ GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2397316),
     /* 2397264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397275 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2397295), // Rule ID 2428 //
     /* 2397280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397283 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2397283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397294 */     // GIR_Coverage, 2428,
     /* 2397294 */     GIR_EraseRootFromParent_Done,
     /* 2397295 */   // Label 34208: @2397295
     /* 2397295 */   GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2397315), // Rule ID 2429 //
     /* 2397300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397303 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2397303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397314 */     // GIR_Coverage, 2429,
     /* 2397314 */     GIR_EraseRootFromParent_Done,
     /* 2397315 */   // Label 34209: @2397315
     /* 2397315 */   GIM_Reject,
     /* 2397316 */ // Label 34207: @2397316
     /* 2397316 */ GIM_Reject,
     /* 2397317 */ // Label 34204: @2397317
     /* 2397317 */ GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2397374),
     /* 2397322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397333 */   GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2397353), // Rule ID 2346 //
     /* 2397338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397341 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2397341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397352 */     // GIR_Coverage, 2346,
     /* 2397352 */     GIR_EraseRootFromParent_Done,
     /* 2397353 */   // Label 34211: @2397353
     /* 2397353 */   GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2397373), // Rule ID 2347 //
     /* 2397358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397361 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2397361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397372 */     // GIR_Coverage, 2347,
     /* 2397372 */     GIR_EraseRootFromParent_Done,
     /* 2397373 */   // Label 34212: @2397373
     /* 2397373 */   GIM_Reject,
     /* 2397374 */ // Label 34210: @2397374
     /* 2397374 */ GIM_Reject,
     /* 2397375 */ // Label 34205: @2397375
     /* 2397375 */ GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2397432),
     /* 2397380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397391 */   GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2397411), // Rule ID 2386 //
     /* 2397396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397399 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2397399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397410 */     // GIR_Coverage, 2386,
     /* 2397410 */     GIR_EraseRootFromParent_Done,
     /* 2397411 */   // Label 34214: @2397411
     /* 2397411 */   GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2397431), // Rule ID 2387 //
     /* 2397416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397419 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2397419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2397429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397430 */     // GIR_Coverage, 2387,
     /* 2397430 */     GIR_EraseRootFromParent_Done,
     /* 2397431 */   // Label 34215: @2397431
     /* 2397431 */   GIM_Reject,
     /* 2397432 */ // Label 34213: @2397432
     /* 2397432 */ GIM_Reject,
     /* 2397433 */ // Label 34206: @2397433
     /* 2397433 */ GIM_Reject,
     /* 2397434 */ // Label 96: @2397434
     /* 2397434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34219*/ GIMT_Encode4(2397631),
     /* 2397445 */ /*GILLT_s16*//*Label 34216*/ GIMT_Encode4(2397457),
     /* 2397449 */ /*GILLT_s32*//*Label 34217*/ GIMT_Encode4(2397515),
     /* 2397453 */ /*GILLT_s64*//*Label 34218*/ GIMT_Encode4(2397573),
     /* 2397457 */ // Label 34216: @2397457
     /* 2397457 */ GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2397514),
     /* 2397462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397473 */   GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2397493), // Rule ID 2412 //
     /* 2397478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397481 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2397481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2397484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397492 */     // GIR_Coverage, 2412,
     /* 2397492 */     GIR_EraseRootFromParent_Done,
     /* 2397493 */   // Label 34221: @2397493
     /* 2397493 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2397513), // Rule ID 2413 //
     /* 2397498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397501 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2397501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2397504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397512 */     // GIR_Coverage, 2413,
     /* 2397512 */     GIR_EraseRootFromParent_Done,
     /* 2397513 */   // Label 34222: @2397513
     /* 2397513 */   GIM_Reject,
     /* 2397514 */ // Label 34220: @2397514
     /* 2397514 */ GIM_Reject,
     /* 2397515 */ // Label 34217: @2397515
     /* 2397515 */ GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2397572),
     /* 2397520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397531 */   GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2397551), // Rule ID 2330 //
     /* 2397536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397539 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2397539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2397542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397550 */     // GIR_Coverage, 2330,
     /* 2397550 */     GIR_EraseRootFromParent_Done,
     /* 2397551 */   // Label 34224: @2397551
     /* 2397551 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2397571), // Rule ID 2331 //
     /* 2397556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397559 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2397559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2397562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397570 */     // GIR_Coverage, 2331,
     /* 2397570 */     GIR_EraseRootFromParent_Done,
     /* 2397571 */   // Label 34225: @2397571
     /* 2397571 */   GIM_Reject,
     /* 2397572 */ // Label 34223: @2397572
     /* 2397572 */ GIM_Reject,
     /* 2397573 */ // Label 34218: @2397573
     /* 2397573 */ GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2397630),
     /* 2397578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397589 */   GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2397609), // Rule ID 2370 //
     /* 2397594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397597 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2397597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2397600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397608 */     // GIR_Coverage, 2370,
     /* 2397608 */     GIR_EraseRootFromParent_Done,
     /* 2397609 */   // Label 34227: @2397609
     /* 2397609 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2397629), // Rule ID 2371 //
     /* 2397614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397617 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2397617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2397620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397628 */     // GIR_Coverage, 2371,
     /* 2397628 */     GIR_EraseRootFromParent_Done,
     /* 2397629 */   // Label 34228: @2397629
     /* 2397629 */   GIM_Reject,
     /* 2397630 */ // Label 34226: @2397630
     /* 2397630 */ GIM_Reject,
     /* 2397631 */ // Label 34219: @2397631
     /* 2397631 */ GIM_Reject,
     /* 2397632 */ // Label 97: @2397632
     /* 2397632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34232*/ GIMT_Encode4(2397829),
     /* 2397643 */ /*GILLT_s16*//*Label 34229*/ GIMT_Encode4(2397655),
     /* 2397647 */ /*GILLT_s32*//*Label 34230*/ GIMT_Encode4(2397713),
     /* 2397651 */ /*GILLT_s64*//*Label 34231*/ GIMT_Encode4(2397771),
     /* 2397655 */ // Label 34229: @2397655
     /* 2397655 */ GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2397712),
     /* 2397660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397671 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2397691), // Rule ID 2416 //
     /* 2397676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2397679 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2397679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397690 */     // GIR_Coverage, 2416,
     /* 2397690 */     GIR_EraseRootFromParent_Done,
     /* 2397691 */   // Label 34234: @2397691
     /* 2397691 */   GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2397711), // Rule ID 2417 //
     /* 2397696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2397699 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2397699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2397702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397710 */     // GIR_Coverage, 2417,
     /* 2397710 */     GIR_EraseRootFromParent_Done,
     /* 2397711 */   // Label 34235: @2397711
     /* 2397711 */   GIM_Reject,
     /* 2397712 */ // Label 34233: @2397712
     /* 2397712 */ GIM_Reject,
     /* 2397713 */ // Label 34230: @2397713
     /* 2397713 */ GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2397770),
     /* 2397718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2397721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2397729 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2397749), // Rule ID 2334 //
     /* 2397734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2397737 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2397737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397748 */     // GIR_Coverage, 2334,
     /* 2397748 */     GIR_EraseRootFromParent_Done,
     /* 2397749 */   // Label 34237: @2397749
     /* 2397749 */   GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2397769), // Rule ID 2335 //
     /* 2397754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2397757 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2397757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2397760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397768 */     // GIR_Coverage, 2335,
     /* 2397768 */     GIR_EraseRootFromParent_Done,
     /* 2397769 */   // Label 34238: @2397769
     /* 2397769 */   GIM_Reject,
     /* 2397770 */ // Label 34236: @2397770
     /* 2397770 */ GIM_Reject,
     /* 2397771 */ // Label 34231: @2397771
     /* 2397771 */ GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2397828),
     /* 2397776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2397779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397787 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2397807), // Rule ID 2374 //
     /* 2397792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2397795 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2397795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397806 */     // GIR_Coverage, 2374,
     /* 2397806 */     GIR_EraseRootFromParent_Done,
     /* 2397807 */   // Label 34240: @2397807
     /* 2397807 */   GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2397827), // Rule ID 2375 //
     /* 2397812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2397815 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2397815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2397818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397826 */     // GIR_Coverage, 2375,
     /* 2397826 */     GIR_EraseRootFromParent_Done,
     /* 2397827 */   // Label 34241: @2397827
     /* 2397827 */   GIM_Reject,
     /* 2397828 */ // Label 34239: @2397828
     /* 2397828 */ GIM_Reject,
     /* 2397829 */ // Label 34232: @2397829
     /* 2397829 */ GIM_Reject,
     /* 2397830 */ // Label 98: @2397830
     /* 2397830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34260*/ GIMT_Encode4(2400257),
     /* 2397841 */ /*GILLT_s16*//*Label 34242*/ GIMT_Encode4(2397961),
     /* 2397845 */ /*GILLT_s32*//*Label 34243*/ GIMT_Encode4(2398110),
     /* 2397849 */ /*GILLT_s64*//*Label 34244*/ GIMT_Encode4(2398259), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397861 */ /*GILLT_nxv1s16*//*Label 34245*/ GIMT_Encode4(2398442),
     /* 2397865 */ /*GILLT_nxv1s32*//*Label 34246*/ GIMT_Encode4(2398563),
     /* 2397869 */ /*GILLT_nxv1s64*//*Label 34247*/ GIMT_Encode4(2398684), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397881 */ /*GILLT_nxv2s16*//*Label 34248*/ GIMT_Encode4(2398805),
     /* 2397885 */ /*GILLT_nxv2s32*//*Label 34249*/ GIMT_Encode4(2398926),
     /* 2397889 */ /*GILLT_nxv2s64*//*Label 34250*/ GIMT_Encode4(2399047), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397901 */ /*GILLT_nxv4s16*//*Label 34251*/ GIMT_Encode4(2399168),
     /* 2397905 */ /*GILLT_nxv4s32*//*Label 34252*/ GIMT_Encode4(2399289),
     /* 2397909 */ /*GILLT_nxv4s64*//*Label 34253*/ GIMT_Encode4(2399410), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397921 */ /*GILLT_nxv8s16*//*Label 34254*/ GIMT_Encode4(2399531),
     /* 2397925 */ /*GILLT_nxv8s32*//*Label 34255*/ GIMT_Encode4(2399652),
     /* 2397929 */ /*GILLT_nxv8s64*//*Label 34256*/ GIMT_Encode4(2399773), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397941 */ /*GILLT_nxv16s16*//*Label 34257*/ GIMT_Encode4(2399894),
     /* 2397945 */ /*GILLT_nxv16s32*//*Label 34258*/ GIMT_Encode4(2400015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2397957 */ /*GILLT_nxv32s16*//*Label 34259*/ GIMT_Encode4(2400136),
     /* 2397961 */ // Label 34242: @2397961
     /* 2397961 */ GIM_Try, /*On fail goto*//*Label 34261*/ GIMT_Encode4(2398109),
     /* 2397966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2397969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2397972 */   GIM_Try, /*On fail goto*//*Label 34262*/ GIMT_Encode4(2398006), // Rule ID 1956 //
     /* 2397977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2397980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2397992 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2397992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2397995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398005 */     // GIR_Coverage, 1956,
     /* 2398005 */     GIR_EraseRootFromParent_Done,
     /* 2398006 */   // Label 34262: @2398006
     /* 2398006 */   GIM_Try, /*On fail goto*//*Label 34263*/ GIMT_Encode4(2398040), // Rule ID 1957 //
     /* 2398011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2398014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2398026 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2398026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2398029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398039 */     // GIR_Coverage, 1957,
     /* 2398039 */     GIR_EraseRootFromParent_Done,
     /* 2398040 */   // Label 34263: @2398040
     /* 2398040 */   GIM_Try, /*On fail goto*//*Label 34264*/ GIMT_Encode4(2398074), // Rule ID 1960 //
     /* 2398045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2398048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398060 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2398060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2398063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398073 */     // GIR_Coverage, 1960,
     /* 2398073 */     GIR_EraseRootFromParent_Done,
     /* 2398074 */   // Label 34264: @2398074
     /* 2398074 */   GIM_Try, /*On fail goto*//*Label 34265*/ GIMT_Encode4(2398108), // Rule ID 1961 //
     /* 2398079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2398082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2398094 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2398094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2398097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398107 */     // GIR_Coverage, 1961,
     /* 2398107 */     GIR_EraseRootFromParent_Done,
     /* 2398108 */   // Label 34265: @2398108
     /* 2398108 */   GIM_Reject,
     /* 2398109 */ // Label 34261: @2398109
     /* 2398109 */ GIM_Reject,
     /* 2398110 */ // Label 34243: @2398110
     /* 2398110 */ GIM_Try, /*On fail goto*//*Label 34266*/ GIMT_Encode4(2398258),
     /* 2398115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2398118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2398121 */   GIM_Try, /*On fail goto*//*Label 34267*/ GIMT_Encode4(2398155), // Rule ID 1247 //
     /* 2398126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2398129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398141 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2398141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2398144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398154 */     // GIR_Coverage, 1247,
     /* 2398154 */     GIR_EraseRootFromParent_Done,
     /* 2398155 */   // Label 34267: @2398155
     /* 2398155 */   GIM_Try, /*On fail goto*//*Label 34268*/ GIMT_Encode4(2398189), // Rule ID 1248 //
     /* 2398160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2398163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2398175 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2398175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2398178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398188 */     // GIR_Coverage, 1248,
     /* 2398188 */     GIR_EraseRootFromParent_Done,
     /* 2398189 */   // Label 34268: @2398189
     /* 2398189 */   GIM_Try, /*On fail goto*//*Label 34269*/ GIMT_Encode4(2398223), // Rule ID 1251 //
     /* 2398194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2398197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398209 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2398209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2398212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398222 */     // GIR_Coverage, 1251,
     /* 2398222 */     GIR_EraseRootFromParent_Done,
     /* 2398223 */   // Label 34269: @2398223
     /* 2398223 */   GIM_Try, /*On fail goto*//*Label 34270*/ GIMT_Encode4(2398257), // Rule ID 1252 //
     /* 2398228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2398231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2398243 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2398243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2398246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398256 */     // GIR_Coverage, 1252,
     /* 2398256 */     GIR_EraseRootFromParent_Done,
     /* 2398257 */   // Label 34270: @2398257
     /* 2398257 */   GIM_Reject,
     /* 2398258 */ // Label 34266: @2398258
     /* 2398258 */ GIM_Reject,
     /* 2398259 */ // Label 34244: @2398259
     /* 2398259 */ GIM_Try, /*On fail goto*//*Label 34271*/ GIMT_Encode4(2398441),
     /* 2398264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2398267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2398270 */   GIM_Try, /*On fail goto*//*Label 34272*/ GIMT_Encode4(2398304), // Rule ID 1582 //
     /* 2398275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2398278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398290 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2398293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398303 */     // GIR_Coverage, 1582,
     /* 2398303 */     GIR_EraseRootFromParent_Done,
     /* 2398304 */   // Label 34272: @2398304
     /* 2398304 */   GIM_Try, /*On fail goto*//*Label 34273*/ GIMT_Encode4(2398338), // Rule ID 1583 //
     /* 2398309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2398312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2398324 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2398324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2398327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398337 */     // GIR_Coverage, 1583,
     /* 2398337 */     GIR_EraseRootFromParent_Done,
     /* 2398338 */   // Label 34273: @2398338
     /* 2398338 */   GIM_Try, /*On fail goto*//*Label 34274*/ GIMT_Encode4(2398372), // Rule ID 1586 //
     /* 2398343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2398346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398358 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2398361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398371 */     // GIR_Coverage, 1586,
     /* 2398371 */     GIR_EraseRootFromParent_Done,
     /* 2398372 */   // Label 34274: @2398372
     /* 2398372 */   GIM_Try, /*On fail goto*//*Label 34275*/ GIMT_Encode4(2398406), // Rule ID 1587 //
     /* 2398377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2398380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2398392 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2398392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2398395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398405 */     // GIR_Coverage, 1587,
     /* 2398405 */     GIR_EraseRootFromParent_Done,
     /* 2398406 */   // Label 34275: @2398406
     /* 2398406 */   GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2398440), // Rule ID 1590 //
     /* 2398411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2398414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2398426 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2398426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2398429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398439 */     // GIR_Coverage, 1590,
     /* 2398439 */     GIR_EraseRootFromParent_Done,
     /* 2398440 */   // Label 34276: @2398440
     /* 2398440 */   GIM_Reject,
     /* 2398441 */ // Label 34271: @2398441
     /* 2398441 */ GIM_Reject,
     /* 2398442 */ // Label 34245: @2398442
     /* 2398442 */ GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2398562),
     /* 2398447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2398450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2398453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398465 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2398513), // Rule ID 45762 //
     /* 2398470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398473 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2398476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2398490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398512 */     // GIR_Coverage, 45762,
     /* 2398512 */     GIR_EraseRootFromParent_Done,
     /* 2398513 */   // Label 34278: @2398513
     /* 2398513 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2398561), // Rule ID 45763 //
     /* 2398518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398521 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2398524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2398538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398560 */     // GIR_Coverage, 45763,
     /* 2398560 */     GIR_EraseRootFromParent_Done,
     /* 2398561 */   // Label 34279: @2398561
     /* 2398561 */   GIM_Reject,
     /* 2398562 */ // Label 34277: @2398562
     /* 2398562 */ GIM_Reject,
     /* 2398563 */ // Label 34246: @2398563
     /* 2398563 */ GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2398683),
     /* 2398568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2398571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2398574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398586 */   GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2398634), // Rule ID 53302 //
     /* 2398591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398594 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2398597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2398611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398633 */     // GIR_Coverage, 53302,
     /* 2398633 */     GIR_EraseRootFromParent_Done,
     /* 2398634 */   // Label 34281: @2398634
     /* 2398634 */   GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2398682), // Rule ID 53303 //
     /* 2398639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398642 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2398645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2398659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398681 */     // GIR_Coverage, 53303,
     /* 2398681 */     GIR_EraseRootFromParent_Done,
     /* 2398682 */   // Label 34282: @2398682
     /* 2398682 */   GIM_Reject,
     /* 2398683 */ // Label 34280: @2398683
     /* 2398683 */ GIM_Reject,
     /* 2398684 */ // Label 34247: @2398684
     /* 2398684 */ GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2398804),
     /* 2398689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2398692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2398695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398707 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2398755), // Rule ID 53338 //
     /* 2398712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398715 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2398718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2398732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398754 */     // GIR_Coverage, 53338,
     /* 2398754 */     GIR_EraseRootFromParent_Done,
     /* 2398755 */   // Label 34284: @2398755
     /* 2398755 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2398803), // Rule ID 53339 //
     /* 2398760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398763 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2398766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2398780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398802 */     // GIR_Coverage, 53339,
     /* 2398802 */     GIR_EraseRootFromParent_Done,
     /* 2398803 */   // Label 34285: @2398803
     /* 2398803 */   GIM_Reject,
     /* 2398804 */ // Label 34283: @2398804
     /* 2398804 */ GIM_Reject,
     /* 2398805 */ // Label 34248: @2398805
     /* 2398805 */ GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2398925),
     /* 2398810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2398813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2398816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398828 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2398876), // Rule ID 53290 //
     /* 2398833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398836 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2398839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2398853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398875 */     // GIR_Coverage, 53290,
     /* 2398875 */     GIR_EraseRootFromParent_Done,
     /* 2398876 */   // Label 34287: @2398876
     /* 2398876 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2398924), // Rule ID 53291 //
     /* 2398881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398884 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2398887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2398901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398923 */     // GIR_Coverage, 53291,
     /* 2398923 */     GIR_EraseRootFromParent_Done,
     /* 2398924 */   // Label 34288: @2398924
     /* 2398924 */   GIM_Reject,
     /* 2398925 */ // Label 34286: @2398925
     /* 2398925 */ GIM_Reject,
     /* 2398926 */ // Label 34249: @2398926
     /* 2398926 */ GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2399046),
     /* 2398931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2398937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398949 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2398997), // Rule ID 53326 //
     /* 2398954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398957 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2398960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2398974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398996 */     // GIR_Coverage, 53326,
     /* 2398996 */     GIR_EraseRootFromParent_Done,
     /* 2398997 */   // Label 34290: @2398997
     /* 2398997 */   GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2399045), // Rule ID 53327 //
     /* 2399002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399005 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2399008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2399022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399044 */     // GIR_Coverage, 53327,
     /* 2399044 */     GIR_EraseRootFromParent_Done,
     /* 2399045 */   // Label 34291: @2399045
     /* 2399045 */   GIM_Reject,
     /* 2399046 */ // Label 34289: @2399046
     /* 2399046 */ GIM_Reject,
     /* 2399047 */ // Label 34250: @2399047
     /* 2399047 */ GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2399167),
     /* 2399052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2399058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399070 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2399118), // Rule ID 53422 //
     /* 2399075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399078 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2399081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2399095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399117 */     // GIR_Coverage, 53422,
     /* 2399117 */     GIR_EraseRootFromParent_Done,
     /* 2399118 */   // Label 34293: @2399118
     /* 2399118 */   GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2399166), // Rule ID 53423 //
     /* 2399123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399126 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2399129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2399143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399165 */     // GIR_Coverage, 53423,
     /* 2399165 */     GIR_EraseRootFromParent_Done,
     /* 2399166 */   // Label 34294: @2399166
     /* 2399166 */   GIM_Reject,
     /* 2399167 */ // Label 34292: @2399167
     /* 2399167 */ GIM_Reject,
     /* 2399168 */ // Label 34251: @2399168
     /* 2399168 */ GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2399288),
     /* 2399173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2399179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399191 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2399239), // Rule ID 53314 //
     /* 2399196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399199 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2399202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2399216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399238 */     // GIR_Coverage, 53314,
     /* 2399238 */     GIR_EraseRootFromParent_Done,
     /* 2399239 */   // Label 34296: @2399239
     /* 2399239 */   GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2399287), // Rule ID 53315 //
     /* 2399244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399247 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2399250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2399264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399286 */     // GIR_Coverage, 53315,
     /* 2399286 */     GIR_EraseRootFromParent_Done,
     /* 2399287 */   // Label 34297: @2399287
     /* 2399287 */   GIM_Reject,
     /* 2399288 */ // Label 34295: @2399288
     /* 2399288 */ GIM_Reject,
     /* 2399289 */ // Label 34252: @2399289
     /* 2399289 */ GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2399409),
     /* 2399294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2399297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2399300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399312 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2399360), // Rule ID 53386 //
     /* 2399317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399320 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2399323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2399337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399359 */     // GIR_Coverage, 53386,
     /* 2399359 */     GIR_EraseRootFromParent_Done,
     /* 2399360 */   // Label 34299: @2399360
     /* 2399360 */   GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2399408), // Rule ID 53387 //
     /* 2399365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399368 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2399371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2399385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399407 */     // GIR_Coverage, 53387,
     /* 2399407 */     GIR_EraseRootFromParent_Done,
     /* 2399408 */   // Label 34300: @2399408
     /* 2399408 */   GIM_Reject,
     /* 2399409 */ // Label 34298: @2399409
     /* 2399409 */ GIM_Reject,
     /* 2399410 */ // Label 34253: @2399410
     /* 2399410 */ GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2399530),
     /* 2399415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2399418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2399421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399433 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2399481), // Rule ID 53434 //
     /* 2399438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399441 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2399444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2399458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399480 */     // GIR_Coverage, 53434,
     /* 2399480 */     GIR_EraseRootFromParent_Done,
     /* 2399481 */   // Label 34302: @2399481
     /* 2399481 */   GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2399529), // Rule ID 53435 //
     /* 2399486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399489 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2399492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2399506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399528 */     // GIR_Coverage, 53435,
     /* 2399528 */     GIR_EraseRootFromParent_Done,
     /* 2399529 */   // Label 34303: @2399529
     /* 2399529 */   GIM_Reject,
     /* 2399530 */ // Label 34301: @2399530
     /* 2399530 */ GIM_Reject,
     /* 2399531 */ // Label 34254: @2399531
     /* 2399531 */ GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2399651),
     /* 2399536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2399539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2399542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399554 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2399602), // Rule ID 53350 //
     /* 2399559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399562 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2399565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2399579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399601 */     // GIR_Coverage, 53350,
     /* 2399601 */     GIR_EraseRootFromParent_Done,
     /* 2399602 */   // Label 34305: @2399602
     /* 2399602 */   GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2399650), // Rule ID 53351 //
     /* 2399607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399610 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2399613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2399627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399649 */     // GIR_Coverage, 53351,
     /* 2399649 */     GIR_EraseRootFromParent_Done,
     /* 2399650 */   // Label 34306: @2399650
     /* 2399650 */   GIM_Reject,
     /* 2399651 */ // Label 34304: @2399651
     /* 2399651 */ GIM_Reject,
     /* 2399652 */ // Label 34255: @2399652
     /* 2399652 */ GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2399772),
     /* 2399657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2399663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399675 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2399723), // Rule ID 53398 //
     /* 2399680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399683 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2399686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2399700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399722 */     // GIR_Coverage, 53398,
     /* 2399722 */     GIR_EraseRootFromParent_Done,
     /* 2399723 */   // Label 34308: @2399723
     /* 2399723 */   GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2399771), // Rule ID 53399 //
     /* 2399728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399731 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2399734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2399748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399770 */     // GIR_Coverage, 53399,
     /* 2399770 */     GIR_EraseRootFromParent_Done,
     /* 2399771 */   // Label 34309: @2399771
     /* 2399771 */   GIM_Reject,
     /* 2399772 */ // Label 34307: @2399772
     /* 2399772 */ GIM_Reject,
     /* 2399773 */ // Label 34256: @2399773
     /* 2399773 */ GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2399893),
     /* 2399778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2399784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399796 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2399844), // Rule ID 53446 //
     /* 2399801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399804 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2399807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2399821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399843 */     // GIR_Coverage, 53446,
     /* 2399843 */     GIR_EraseRootFromParent_Done,
     /* 2399844 */   // Label 34311: @2399844
     /* 2399844 */   GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2399892), // Rule ID 53447 //
     /* 2399849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399852 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2399855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2399869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399891 */     // GIR_Coverage, 53447,
     /* 2399891 */     GIR_EraseRootFromParent_Done,
     /* 2399892 */   // Label 34312: @2399892
     /* 2399892 */   GIM_Reject,
     /* 2399893 */ // Label 34310: @2399893
     /* 2399893 */ GIM_Reject,
     /* 2399894 */ // Label 34257: @2399894
     /* 2399894 */ GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2400014),
     /* 2399899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2399902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2399905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399917 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2399965), // Rule ID 53362 //
     /* 2399922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399925 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2399942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399964 */     // GIR_Coverage, 53362,
     /* 2399964 */     GIR_EraseRootFromParent_Done,
     /* 2399965 */   // Label 34314: @2399965
     /* 2399965 */   GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2400013), // Rule ID 53363 //
     /* 2399970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399973 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2399976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2399990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400012 */     // GIR_Coverage, 53363,
     /* 2400012 */     GIR_EraseRootFromParent_Done,
     /* 2400013 */   // Label 34315: @2400013
     /* 2400013 */   GIM_Reject,
     /* 2400014 */ // Label 34313: @2400014
     /* 2400014 */ GIM_Reject,
     /* 2400015 */ // Label 34258: @2400015
     /* 2400015 */ GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2400135),
     /* 2400020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2400026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400038 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2400086), // Rule ID 53410 //
     /* 2400043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400046 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2400049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2400063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400085 */     // GIR_Coverage, 53410,
     /* 2400085 */     GIR_EraseRootFromParent_Done,
     /* 2400086 */   // Label 34317: @2400086
     /* 2400086 */   GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2400134), // Rule ID 53411 //
     /* 2400091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400094 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2400097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2400111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400133 */     // GIR_Coverage, 53411,
     /* 2400133 */     GIR_EraseRootFromParent_Done,
     /* 2400134 */   // Label 34318: @2400134
     /* 2400134 */   GIM_Reject,
     /* 2400135 */ // Label 34316: @2400135
     /* 2400135 */ GIM_Reject,
     /* 2400136 */ // Label 34259: @2400136
     /* 2400136 */ GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2400256),
     /* 2400141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2400144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2400147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400159 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2400207), // Rule ID 53374 //
     /* 2400164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400167 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2400170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2400184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400206 */     // GIR_Coverage, 53374,
     /* 2400206 */     GIR_EraseRootFromParent_Done,
     /* 2400207 */   // Label 34320: @2400207
     /* 2400207 */   GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2400255), // Rule ID 53375 //
     /* 2400212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400215 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2400218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2400232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400254 */     // GIR_Coverage, 53375,
     /* 2400254 */     GIR_EraseRootFromParent_Done,
     /* 2400255 */   // Label 34321: @2400255
     /* 2400255 */   GIM_Reject,
     /* 2400256 */ // Label 34319: @2400256
     /* 2400256 */ GIM_Reject,
     /* 2400257 */ // Label 34260: @2400257
     /* 2400257 */ GIM_Reject,
     /* 2400258 */ // Label 99: @2400258
     /* 2400258 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34340*/ GIMT_Encode4(2402685),
     /* 2400269 */ /*GILLT_s16*//*Label 34322*/ GIMT_Encode4(2400389),
     /* 2400273 */ /*GILLT_s32*//*Label 34323*/ GIMT_Encode4(2400538),
     /* 2400277 */ /*GILLT_s64*//*Label 34324*/ GIMT_Encode4(2400687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400289 */ /*GILLT_nxv1s16*//*Label 34325*/ GIMT_Encode4(2400870),
     /* 2400293 */ /*GILLT_nxv1s32*//*Label 34326*/ GIMT_Encode4(2400991),
     /* 2400297 */ /*GILLT_nxv1s64*//*Label 34327*/ GIMT_Encode4(2401112), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400309 */ /*GILLT_nxv2s16*//*Label 34328*/ GIMT_Encode4(2401233),
     /* 2400313 */ /*GILLT_nxv2s32*//*Label 34329*/ GIMT_Encode4(2401354),
     /* 2400317 */ /*GILLT_nxv2s64*//*Label 34330*/ GIMT_Encode4(2401475), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400329 */ /*GILLT_nxv4s16*//*Label 34331*/ GIMT_Encode4(2401596),
     /* 2400333 */ /*GILLT_nxv4s32*//*Label 34332*/ GIMT_Encode4(2401717),
     /* 2400337 */ /*GILLT_nxv4s64*//*Label 34333*/ GIMT_Encode4(2401838), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400349 */ /*GILLT_nxv8s16*//*Label 34334*/ GIMT_Encode4(2401959),
     /* 2400353 */ /*GILLT_nxv8s32*//*Label 34335*/ GIMT_Encode4(2402080),
     /* 2400357 */ /*GILLT_nxv8s64*//*Label 34336*/ GIMT_Encode4(2402201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400369 */ /*GILLT_nxv16s16*//*Label 34337*/ GIMT_Encode4(2402322),
     /* 2400373 */ /*GILLT_nxv16s32*//*Label 34338*/ GIMT_Encode4(2402443), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2400385 */ /*GILLT_nxv32s16*//*Label 34339*/ GIMT_Encode4(2402564),
     /* 2400389 */ // Label 34322: @2400389
     /* 2400389 */ GIM_Try, /*On fail goto*//*Label 34341*/ GIMT_Encode4(2400537),
     /* 2400394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2400397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2400400 */   GIM_Try, /*On fail goto*//*Label 34342*/ GIMT_Encode4(2400434), // Rule ID 1964 //
     /* 2400405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2400408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400420 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2400420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2400423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400433 */     // GIR_Coverage, 1964,
     /* 2400433 */     GIR_EraseRootFromParent_Done,
     /* 2400434 */   // Label 34342: @2400434
     /* 2400434 */   GIM_Try, /*On fail goto*//*Label 34343*/ GIMT_Encode4(2400468), // Rule ID 1965 //
     /* 2400439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2400442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2400454 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2400454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2400457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400467 */     // GIR_Coverage, 1965,
     /* 2400467 */     GIR_EraseRootFromParent_Done,
     /* 2400468 */   // Label 34343: @2400468
     /* 2400468 */   GIM_Try, /*On fail goto*//*Label 34344*/ GIMT_Encode4(2400502), // Rule ID 1968 //
     /* 2400473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2400476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400488 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2400488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2400491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400501 */     // GIR_Coverage, 1968,
     /* 2400501 */     GIR_EraseRootFromParent_Done,
     /* 2400502 */   // Label 34344: @2400502
     /* 2400502 */   GIM_Try, /*On fail goto*//*Label 34345*/ GIMT_Encode4(2400536), // Rule ID 1969 //
     /* 2400507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2400510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2400522 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2400522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2400525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400535 */     // GIR_Coverage, 1969,
     /* 2400535 */     GIR_EraseRootFromParent_Done,
     /* 2400536 */   // Label 34345: @2400536
     /* 2400536 */   GIM_Reject,
     /* 2400537 */ // Label 34341: @2400537
     /* 2400537 */ GIM_Reject,
     /* 2400538 */ // Label 34323: @2400538
     /* 2400538 */ GIM_Try, /*On fail goto*//*Label 34346*/ GIMT_Encode4(2400686),
     /* 2400543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2400546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2400549 */   GIM_Try, /*On fail goto*//*Label 34347*/ GIMT_Encode4(2400583), // Rule ID 1255 //
     /* 2400554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2400557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400569 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2400569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2400572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400582 */     // GIR_Coverage, 1255,
     /* 2400582 */     GIR_EraseRootFromParent_Done,
     /* 2400583 */   // Label 34347: @2400583
     /* 2400583 */   GIM_Try, /*On fail goto*//*Label 34348*/ GIMT_Encode4(2400617), // Rule ID 1256 //
     /* 2400588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2400591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2400603 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2400603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2400606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400616 */     // GIR_Coverage, 1256,
     /* 2400616 */     GIR_EraseRootFromParent_Done,
     /* 2400617 */   // Label 34348: @2400617
     /* 2400617 */   GIM_Try, /*On fail goto*//*Label 34349*/ GIMT_Encode4(2400651), // Rule ID 1259 //
     /* 2400622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2400625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400637 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2400637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2400640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400650 */     // GIR_Coverage, 1259,
     /* 2400650 */     GIR_EraseRootFromParent_Done,
     /* 2400651 */   // Label 34349: @2400651
     /* 2400651 */   GIM_Try, /*On fail goto*//*Label 34350*/ GIMT_Encode4(2400685), // Rule ID 1260 //
     /* 2400656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2400659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2400671 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2400671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2400674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400684 */     // GIR_Coverage, 1260,
     /* 2400684 */     GIR_EraseRootFromParent_Done,
     /* 2400685 */   // Label 34350: @2400685
     /* 2400685 */   GIM_Reject,
     /* 2400686 */ // Label 34346: @2400686
     /* 2400686 */ GIM_Reject,
     /* 2400687 */ // Label 34324: @2400687
     /* 2400687 */ GIM_Try, /*On fail goto*//*Label 34351*/ GIMT_Encode4(2400869),
     /* 2400692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2400695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2400698 */   GIM_Try, /*On fail goto*//*Label 34352*/ GIMT_Encode4(2400732), // Rule ID 1592 //
     /* 2400703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2400706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400718 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2400721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400731 */     // GIR_Coverage, 1592,
     /* 2400731 */     GIR_EraseRootFromParent_Done,
     /* 2400732 */   // Label 34352: @2400732
     /* 2400732 */   GIM_Try, /*On fail goto*//*Label 34353*/ GIMT_Encode4(2400766), // Rule ID 1593 //
     /* 2400737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2400740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2400752 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2400752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2400755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400765 */     // GIR_Coverage, 1593,
     /* 2400765 */     GIR_EraseRootFromParent_Done,
     /* 2400766 */   // Label 34353: @2400766
     /* 2400766 */   GIM_Try, /*On fail goto*//*Label 34354*/ GIMT_Encode4(2400800), // Rule ID 1596 //
     /* 2400771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2400774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400786 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2400789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400799 */     // GIR_Coverage, 1596,
     /* 2400799 */     GIR_EraseRootFromParent_Done,
     /* 2400800 */   // Label 34354: @2400800
     /* 2400800 */   GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2400834), // Rule ID 1597 //
     /* 2400805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2400808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2400820 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2400820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2400823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400833 */     // GIR_Coverage, 1597,
     /* 2400833 */     GIR_EraseRootFromParent_Done,
     /* 2400834 */   // Label 34355: @2400834
     /* 2400834 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2400868), // Rule ID 1600 //
     /* 2400839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2400842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2400854 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2400854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2400857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400867 */     // GIR_Coverage, 1600,
     /* 2400867 */     GIR_EraseRootFromParent_Done,
     /* 2400868 */   // Label 34356: @2400868
     /* 2400868 */   GIM_Reject,
     /* 2400869 */ // Label 34351: @2400869
     /* 2400869 */ GIM_Reject,
     /* 2400870 */ // Label 34325: @2400870
     /* 2400870 */ GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2400990),
     /* 2400875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2400878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2400881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400893 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2400941), // Rule ID 53458 //
     /* 2400898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400901 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2400918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400940 */     // GIR_Coverage, 53458,
     /* 2400940 */     GIR_EraseRootFromParent_Done,
     /* 2400941 */   // Label 34358: @2400941
     /* 2400941 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2400989), // Rule ID 53459 //
     /* 2400946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400949 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2400952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2400966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400988 */     // GIR_Coverage, 53459,
     /* 2400988 */     GIR_EraseRootFromParent_Done,
     /* 2400989 */   // Label 34359: @2400989
     /* 2400989 */   GIM_Reject,
     /* 2400990 */ // Label 34357: @2400990
     /* 2400990 */ GIM_Reject,
     /* 2400991 */ // Label 34326: @2400991
     /* 2400991 */ GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2401111),
     /* 2400996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2400999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2401002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401014 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2401062), // Rule ID 53482 //
     /* 2401019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401022 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2401025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2401039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401061 */     // GIR_Coverage, 53482,
     /* 2401061 */     GIR_EraseRootFromParent_Done,
     /* 2401062 */   // Label 34361: @2401062
     /* 2401062 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2401110), // Rule ID 53483 //
     /* 2401067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401070 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2401073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2401087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401109 */     // GIR_Coverage, 53483,
     /* 2401109 */     GIR_EraseRootFromParent_Done,
     /* 2401110 */   // Label 34362: @2401110
     /* 2401110 */   GIM_Reject,
     /* 2401111 */ // Label 34360: @2401111
     /* 2401111 */ GIM_Reject,
     /* 2401112 */ // Label 34327: @2401112
     /* 2401112 */ GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2401232),
     /* 2401117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2401120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2401123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401135 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2401183), // Rule ID 53518 //
     /* 2401140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401143 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2401146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2401160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401182 */     // GIR_Coverage, 53518,
     /* 2401182 */     GIR_EraseRootFromParent_Done,
     /* 2401183 */   // Label 34364: @2401183
     /* 2401183 */   GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2401231), // Rule ID 53519 //
     /* 2401188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401191 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2401194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2401208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401230 */     // GIR_Coverage, 53519,
     /* 2401230 */     GIR_EraseRootFromParent_Done,
     /* 2401231 */   // Label 34365: @2401231
     /* 2401231 */   GIM_Reject,
     /* 2401232 */ // Label 34363: @2401232
     /* 2401232 */ GIM_Reject,
     /* 2401233 */ // Label 34328: @2401233
     /* 2401233 */ GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2401353),
     /* 2401238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2401241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2401244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401256 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2401304), // Rule ID 53470 //
     /* 2401261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401264 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2401267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2401281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401303 */     // GIR_Coverage, 53470,
     /* 2401303 */     GIR_EraseRootFromParent_Done,
     /* 2401304 */   // Label 34367: @2401304
     /* 2401304 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2401352), // Rule ID 53471 //
     /* 2401309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401312 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2401315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2401329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401351 */     // GIR_Coverage, 53471,
     /* 2401351 */     GIR_EraseRootFromParent_Done,
     /* 2401352 */   // Label 34368: @2401352
     /* 2401352 */   GIM_Reject,
     /* 2401353 */ // Label 34366: @2401353
     /* 2401353 */ GIM_Reject,
     /* 2401354 */ // Label 34329: @2401354
     /* 2401354 */ GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2401474),
     /* 2401359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2401362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2401365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401377 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2401425), // Rule ID 53506 //
     /* 2401382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401385 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2401388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2401402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401424 */     // GIR_Coverage, 53506,
     /* 2401424 */     GIR_EraseRootFromParent_Done,
     /* 2401425 */   // Label 34370: @2401425
     /* 2401425 */   GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2401473), // Rule ID 53507 //
     /* 2401430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401433 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2401436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2401450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401472 */     // GIR_Coverage, 53507,
     /* 2401472 */     GIR_EraseRootFromParent_Done,
     /* 2401473 */   // Label 34371: @2401473
     /* 2401473 */   GIM_Reject,
     /* 2401474 */ // Label 34369: @2401474
     /* 2401474 */ GIM_Reject,
     /* 2401475 */ // Label 34330: @2401475
     /* 2401475 */ GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2401595),
     /* 2401480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2401483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2401486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401498 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2401546), // Rule ID 53602 //
     /* 2401503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401506 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2401509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2401523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401545 */     // GIR_Coverage, 53602,
     /* 2401545 */     GIR_EraseRootFromParent_Done,
     /* 2401546 */   // Label 34373: @2401546
     /* 2401546 */   GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2401594), // Rule ID 53603 //
     /* 2401551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401554 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2401557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2401571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401593 */     // GIR_Coverage, 53603,
     /* 2401593 */     GIR_EraseRootFromParent_Done,
     /* 2401594 */   // Label 34374: @2401594
     /* 2401594 */   GIM_Reject,
     /* 2401595 */ // Label 34372: @2401595
     /* 2401595 */ GIM_Reject,
     /* 2401596 */ // Label 34331: @2401596
     /* 2401596 */ GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2401716),
     /* 2401601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2401604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2401607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2401619 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2401667), // Rule ID 53494 //
     /* 2401624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401627 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2401630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2401644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401666 */     // GIR_Coverage, 53494,
     /* 2401666 */     GIR_EraseRootFromParent_Done,
     /* 2401667 */   // Label 34376: @2401667
     /* 2401667 */   GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2401715), // Rule ID 53495 //
     /* 2401672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401675 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2401678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2401692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401714 */     // GIR_Coverage, 53495,
     /* 2401714 */     GIR_EraseRootFromParent_Done,
     /* 2401715 */   // Label 34377: @2401715
     /* 2401715 */   GIM_Reject,
     /* 2401716 */ // Label 34375: @2401716
     /* 2401716 */ GIM_Reject,
     /* 2401717 */ // Label 34332: @2401717
     /* 2401717 */ GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2401837),
     /* 2401722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2401725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2401728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401740 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2401788), // Rule ID 53566 //
     /* 2401745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401748 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2401751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2401765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401787 */     // GIR_Coverage, 53566,
     /* 2401787 */     GIR_EraseRootFromParent_Done,
     /* 2401788 */   // Label 34379: @2401788
     /* 2401788 */   GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2401836), // Rule ID 53567 //
     /* 2401793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401796 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2401799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2401813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401835 */     // GIR_Coverage, 53567,
     /* 2401835 */     GIR_EraseRootFromParent_Done,
     /* 2401836 */   // Label 34380: @2401836
     /* 2401836 */   GIM_Reject,
     /* 2401837 */ // Label 34378: @2401837
     /* 2401837 */ GIM_Reject,
     /* 2401838 */ // Label 34333: @2401838
     /* 2401838 */ GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2401958),
     /* 2401843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2401849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401861 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2401909), // Rule ID 53614 //
     /* 2401866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401869 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2401886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401908 */     // GIR_Coverage, 53614,
     /* 2401908 */     GIR_EraseRootFromParent_Done,
     /* 2401909 */   // Label 34382: @2401909
     /* 2401909 */   GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2401957), // Rule ID 53615 //
     /* 2401914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401917 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2401920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2401934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401956 */     // GIR_Coverage, 53615,
     /* 2401956 */     GIR_EraseRootFromParent_Done,
     /* 2401957 */   // Label 34383: @2401957
     /* 2401957 */   GIM_Reject,
     /* 2401958 */ // Label 34381: @2401958
     /* 2401958 */ GIM_Reject,
     /* 2401959 */ // Label 34334: @2401959
     /* 2401959 */ GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2402079),
     /* 2401964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2401967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2401970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401982 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2402030), // Rule ID 53530 //
     /* 2401987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401990 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2401993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2402007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402029 */     // GIR_Coverage, 53530,
     /* 2402029 */     GIR_EraseRootFromParent_Done,
     /* 2402030 */   // Label 34385: @2402030
     /* 2402030 */   GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2402078), // Rule ID 53531 //
     /* 2402035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402038 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2402041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2402055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402077 */     // GIR_Coverage, 53531,
     /* 2402077 */     GIR_EraseRootFromParent_Done,
     /* 2402078 */   // Label 34386: @2402078
     /* 2402078 */   GIM_Reject,
     /* 2402079 */ // Label 34384: @2402079
     /* 2402079 */ GIM_Reject,
     /* 2402080 */ // Label 34335: @2402080
     /* 2402080 */ GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2402200),
     /* 2402085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2402091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402103 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2402151), // Rule ID 53578 //
     /* 2402108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402111 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2402114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2402128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402150 */     // GIR_Coverage, 53578,
     /* 2402150 */     GIR_EraseRootFromParent_Done,
     /* 2402151 */   // Label 34388: @2402151
     /* 2402151 */   GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2402199), // Rule ID 53579 //
     /* 2402156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402159 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2402162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2402176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402198 */     // GIR_Coverage, 53579,
     /* 2402198 */     GIR_EraseRootFromParent_Done,
     /* 2402199 */   // Label 34389: @2402199
     /* 2402199 */   GIM_Reject,
     /* 2402200 */ // Label 34387: @2402200
     /* 2402200 */ GIM_Reject,
     /* 2402201 */ // Label 34336: @2402201
     /* 2402201 */ GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2402321),
     /* 2402206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2402209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2402212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402224 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2402272), // Rule ID 53626 //
     /* 2402229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2402232 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2402235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2402249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402271 */     // GIR_Coverage, 53626,
     /* 2402271 */     GIR_EraseRootFromParent_Done,
     /* 2402272 */   // Label 34391: @2402272
     /* 2402272 */   GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2402320), // Rule ID 53627 //
     /* 2402277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402280 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2402283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2402297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402319 */     // GIR_Coverage, 53627,
     /* 2402319 */     GIR_EraseRootFromParent_Done,
     /* 2402320 */   // Label 34392: @2402320
     /* 2402320 */   GIM_Reject,
     /* 2402321 */ // Label 34390: @2402321
     /* 2402321 */ GIM_Reject,
     /* 2402322 */ // Label 34337: @2402322
     /* 2402322 */ GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2402442),
     /* 2402327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2402330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2402333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402345 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2402393), // Rule ID 53542 //
     /* 2402350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402353 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2402356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2402370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402392 */     // GIR_Coverage, 53542,
     /* 2402392 */     GIR_EraseRootFromParent_Done,
     /* 2402393 */   // Label 34394: @2402393
     /* 2402393 */   GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2402441), // Rule ID 53543 //
     /* 2402398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402401 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2402404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2402418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402440 */     // GIR_Coverage, 53543,
     /* 2402440 */     GIR_EraseRootFromParent_Done,
     /* 2402441 */   // Label 34395: @2402441
     /* 2402441 */   GIM_Reject,
     /* 2402442 */ // Label 34393: @2402442
     /* 2402442 */ GIM_Reject,
     /* 2402443 */ // Label 34338: @2402443
     /* 2402443 */ GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2402563),
     /* 2402448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2402451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2402454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402466 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2402514), // Rule ID 53590 //
     /* 2402471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402474 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2402477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2402491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402513 */     // GIR_Coverage, 53590,
     /* 2402513 */     GIR_EraseRootFromParent_Done,
     /* 2402514 */   // Label 34397: @2402514
     /* 2402514 */   GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2402562), // Rule ID 53591 //
     /* 2402519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402522 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2402525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2402539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402561 */     // GIR_Coverage, 53591,
     /* 2402561 */     GIR_EraseRootFromParent_Done,
     /* 2402562 */   // Label 34398: @2402562
     /* 2402562 */   GIM_Reject,
     /* 2402563 */ // Label 34396: @2402563
     /* 2402563 */ GIM_Reject,
     /* 2402564 */ // Label 34339: @2402564
     /* 2402564 */ GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2402684),
     /* 2402569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2402575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402587 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2402635), // Rule ID 53554 //
     /* 2402592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402595 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2402595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2402598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2402612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402634 */     // GIR_Coverage, 53554,
     /* 2402634 */     GIR_EraseRootFromParent_Done,
     /* 2402635 */   // Label 34400: @2402635
     /* 2402635 */   GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2402683), // Rule ID 53555 //
     /* 2402640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402643 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2402643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2402646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2402650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2402655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2402657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2402660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2402665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2402681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402682 */     // GIR_Coverage, 53555,
     /* 2402682 */     GIR_EraseRootFromParent_Done,
     /* 2402683 */   // Label 34401: @2402683
     /* 2402683 */   GIM_Reject,
     /* 2402684 */ // Label 34399: @2402684
     /* 2402684 */ GIM_Reject,
     /* 2402685 */ // Label 34340: @2402685
     /* 2402685 */ GIM_Reject,
     /* 2402686 */ // Label 100: @2402686
     /* 2402686 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34420*/ GIMT_Encode4(2405113),
     /* 2402697 */ /*GILLT_s16*//*Label 34402*/ GIMT_Encode4(2402817),
     /* 2402701 */ /*GILLT_s32*//*Label 34403*/ GIMT_Encode4(2402966),
     /* 2402705 */ /*GILLT_s64*//*Label 34404*/ GIMT_Encode4(2403115), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402717 */ /*GILLT_nxv1s16*//*Label 34405*/ GIMT_Encode4(2403298),
     /* 2402721 */ /*GILLT_nxv1s32*//*Label 34406*/ GIMT_Encode4(2403419),
     /* 2402725 */ /*GILLT_nxv1s64*//*Label 34407*/ GIMT_Encode4(2403540), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402737 */ /*GILLT_nxv2s16*//*Label 34408*/ GIMT_Encode4(2403661),
     /* 2402741 */ /*GILLT_nxv2s32*//*Label 34409*/ GIMT_Encode4(2403782),
     /* 2402745 */ /*GILLT_nxv2s64*//*Label 34410*/ GIMT_Encode4(2403903), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402757 */ /*GILLT_nxv4s16*//*Label 34411*/ GIMT_Encode4(2404024),
     /* 2402761 */ /*GILLT_nxv4s32*//*Label 34412*/ GIMT_Encode4(2404145),
     /* 2402765 */ /*GILLT_nxv4s64*//*Label 34413*/ GIMT_Encode4(2404266), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402777 */ /*GILLT_nxv8s16*//*Label 34414*/ GIMT_Encode4(2404387),
     /* 2402781 */ /*GILLT_nxv8s32*//*Label 34415*/ GIMT_Encode4(2404508),
     /* 2402785 */ /*GILLT_nxv8s64*//*Label 34416*/ GIMT_Encode4(2404629), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402797 */ /*GILLT_nxv16s16*//*Label 34417*/ GIMT_Encode4(2404750),
     /* 2402801 */ /*GILLT_nxv16s32*//*Label 34418*/ GIMT_Encode4(2404871), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402813 */ /*GILLT_nxv32s16*//*Label 34419*/ GIMT_Encode4(2404992),
     /* 2402817 */ // Label 34402: @2402817
     /* 2402817 */ GIM_Try, /*On fail goto*//*Label 34421*/ GIMT_Encode4(2402965),
     /* 2402822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2402828 */   GIM_Try, /*On fail goto*//*Label 34422*/ GIMT_Encode4(2402862), // Rule ID 1972 //
     /* 2402833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402848 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2402848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2402851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402861 */     // GIR_Coverage, 1972,
     /* 2402861 */     GIR_EraseRootFromParent_Done,
     /* 2402862 */   // Label 34422: @2402862
     /* 2402862 */   GIM_Try, /*On fail goto*//*Label 34423*/ GIMT_Encode4(2402896), // Rule ID 1973 //
     /* 2402867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402882 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2402882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2402885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402895 */     // GIR_Coverage, 1973,
     /* 2402895 */     GIR_EraseRootFromParent_Done,
     /* 2402896 */   // Label 34423: @2402896
     /* 2402896 */   GIM_Try, /*On fail goto*//*Label 34424*/ GIMT_Encode4(2402930), // Rule ID 1976 //
     /* 2402901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402916 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2402916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2402919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402929 */     // GIR_Coverage, 1976,
     /* 2402929 */     GIR_EraseRootFromParent_Done,
     /* 2402930 */   // Label 34424: @2402930
     /* 2402930 */   GIM_Try, /*On fail goto*//*Label 34425*/ GIMT_Encode4(2402964), // Rule ID 1977 //
     /* 2402935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402950 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2402950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2402953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402963 */     // GIR_Coverage, 1977,
     /* 2402963 */     GIR_EraseRootFromParent_Done,
     /* 2402964 */   // Label 34425: @2402964
     /* 2402964 */   GIM_Reject,
     /* 2402965 */ // Label 34421: @2402965
     /* 2402965 */ GIM_Reject,
     /* 2402966 */ // Label 34403: @2402966
     /* 2402966 */ GIM_Try, /*On fail goto*//*Label 34426*/ GIMT_Encode4(2403114),
     /* 2402971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2402974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2402977 */   GIM_Try, /*On fail goto*//*Label 34427*/ GIMT_Encode4(2403011), // Rule ID 1263 //
     /* 2402982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2402985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402997 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2402997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2403000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403010 */     // GIR_Coverage, 1263,
     /* 2403010 */     GIR_EraseRootFromParent_Done,
     /* 2403011 */   // Label 34427: @2403011
     /* 2403011 */   GIM_Try, /*On fail goto*//*Label 34428*/ GIMT_Encode4(2403045), // Rule ID 1264 //
     /* 2403016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403031 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2403031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2403034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403044 */     // GIR_Coverage, 1264,
     /* 2403044 */     GIR_EraseRootFromParent_Done,
     /* 2403045 */   // Label 34428: @2403045
     /* 2403045 */   GIM_Try, /*On fail goto*//*Label 34429*/ GIMT_Encode4(2403079), // Rule ID 1267 //
     /* 2403050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403065 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2403065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2403068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403078 */     // GIR_Coverage, 1267,
     /* 2403078 */     GIR_EraseRootFromParent_Done,
     /* 2403079 */   // Label 34429: @2403079
     /* 2403079 */   GIM_Try, /*On fail goto*//*Label 34430*/ GIMT_Encode4(2403113), // Rule ID 1268 //
     /* 2403084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403099 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2403099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2403102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403112 */     // GIR_Coverage, 1268,
     /* 2403112 */     GIR_EraseRootFromParent_Done,
     /* 2403113 */   // Label 34430: @2403113
     /* 2403113 */   GIM_Reject,
     /* 2403114 */ // Label 34426: @2403114
     /* 2403114 */ GIM_Reject,
     /* 2403115 */ // Label 34404: @2403115
     /* 2403115 */ GIM_Try, /*On fail goto*//*Label 34431*/ GIMT_Encode4(2403297),
     /* 2403120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2403123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2403126 */   GIM_Try, /*On fail goto*//*Label 34432*/ GIMT_Encode4(2403160), // Rule ID 1602 //
     /* 2403131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2403134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403146 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2403149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403159 */     // GIR_Coverage, 1602,
     /* 2403159 */     GIR_EraseRootFromParent_Done,
     /* 2403160 */   // Label 34432: @2403160
     /* 2403160 */   GIM_Try, /*On fail goto*//*Label 34433*/ GIMT_Encode4(2403194), // Rule ID 1603 //
     /* 2403165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2403168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2403180 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2403180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2403183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403193 */     // GIR_Coverage, 1603,
     /* 2403193 */     GIR_EraseRootFromParent_Done,
     /* 2403194 */   // Label 34433: @2403194
     /* 2403194 */   GIM_Try, /*On fail goto*//*Label 34434*/ GIMT_Encode4(2403228), // Rule ID 1606 //
     /* 2403199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2403202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403214 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2403217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403227 */     // GIR_Coverage, 1606,
     /* 2403227 */     GIR_EraseRootFromParent_Done,
     /* 2403228 */   // Label 34434: @2403228
     /* 2403228 */   GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2403262), // Rule ID 1607 //
     /* 2403233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2403236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2403248 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2403248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2403251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403261 */     // GIR_Coverage, 1607,
     /* 2403261 */     GIR_EraseRootFromParent_Done,
     /* 2403262 */   // Label 34435: @2403262
     /* 2403262 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2403296), // Rule ID 1610 //
     /* 2403267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2403270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2403282 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2403282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2403285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403295 */     // GIR_Coverage, 1610,
     /* 2403295 */     GIR_EraseRootFromParent_Done,
     /* 2403296 */   // Label 34436: @2403296
     /* 2403296 */   GIM_Reject,
     /* 2403297 */ // Label 34431: @2403297
     /* 2403297 */ GIM_Reject,
     /* 2403298 */ // Label 34405: @2403298
     /* 2403298 */ GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2403418),
     /* 2403303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2403306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2403309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403321 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2403369), // Rule ID 54226 //
     /* 2403326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403329 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2403346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403368 */     // GIR_Coverage, 54226,
     /* 2403368 */     GIR_EraseRootFromParent_Done,
     /* 2403369 */   // Label 34438: @2403369
     /* 2403369 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2403417), // Rule ID 54227 //
     /* 2403374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403377 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2403394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403416 */     // GIR_Coverage, 54227,
     /* 2403416 */     GIR_EraseRootFromParent_Done,
     /* 2403417 */   // Label 34439: @2403417
     /* 2403417 */   GIM_Reject,
     /* 2403418 */ // Label 34437: @2403418
     /* 2403418 */ GIM_Reject,
     /* 2403419 */ // Label 34406: @2403419
     /* 2403419 */ GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2403539),
     /* 2403424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2403427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2403430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403442 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2403490), // Rule ID 54250 //
     /* 2403447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403450 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2403467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403489 */     // GIR_Coverage, 54250,
     /* 2403489 */     GIR_EraseRootFromParent_Done,
     /* 2403490 */   // Label 34441: @2403490
     /* 2403490 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2403538), // Rule ID 54251 //
     /* 2403495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403498 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2403515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403537 */     // GIR_Coverage, 54251,
     /* 2403537 */     GIR_EraseRootFromParent_Done,
     /* 2403538 */   // Label 34442: @2403538
     /* 2403538 */   GIM_Reject,
     /* 2403539 */ // Label 34440: @2403539
     /* 2403539 */ GIM_Reject,
     /* 2403540 */ // Label 34407: @2403540
     /* 2403540 */ GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2403660),
     /* 2403545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2403548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2403551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403563 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2403611), // Rule ID 54286 //
     /* 2403568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403571 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2403588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403610 */     // GIR_Coverage, 54286,
     /* 2403610 */     GIR_EraseRootFromParent_Done,
     /* 2403611 */   // Label 34444: @2403611
     /* 2403611 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2403659), // Rule ID 54287 //
     /* 2403616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403619 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2403636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403658 */     // GIR_Coverage, 54287,
     /* 2403658 */     GIR_EraseRootFromParent_Done,
     /* 2403659 */   // Label 34445: @2403659
     /* 2403659 */   GIM_Reject,
     /* 2403660 */ // Label 34443: @2403660
     /* 2403660 */ GIM_Reject,
     /* 2403661 */ // Label 34408: @2403661
     /* 2403661 */ GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2403781),
     /* 2403666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2403669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2403672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403684 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2403732), // Rule ID 54238 //
     /* 2403689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403692 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2403709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403731 */     // GIR_Coverage, 54238,
     /* 2403731 */     GIR_EraseRootFromParent_Done,
     /* 2403732 */   // Label 34447: @2403732
     /* 2403732 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2403780), // Rule ID 54239 //
     /* 2403737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403740 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2403757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403779 */     // GIR_Coverage, 54239,
     /* 2403779 */     GIR_EraseRootFromParent_Done,
     /* 2403780 */   // Label 34448: @2403780
     /* 2403780 */   GIM_Reject,
     /* 2403781 */ // Label 34446: @2403781
     /* 2403781 */ GIM_Reject,
     /* 2403782 */ // Label 34409: @2403782
     /* 2403782 */ GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2403902),
     /* 2403787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2403790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2403793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403805 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2403853), // Rule ID 54274 //
     /* 2403810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403813 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2403830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403852 */     // GIR_Coverage, 54274,
     /* 2403852 */     GIR_EraseRootFromParent_Done,
     /* 2403853 */   // Label 34450: @2403853
     /* 2403853 */   GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2403901), // Rule ID 54275 //
     /* 2403858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403861 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2403878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403900 */     // GIR_Coverage, 54275,
     /* 2403900 */     GIR_EraseRootFromParent_Done,
     /* 2403901 */   // Label 34451: @2403901
     /* 2403901 */   GIM_Reject,
     /* 2403902 */ // Label 34449: @2403902
     /* 2403902 */ GIM_Reject,
     /* 2403903 */ // Label 34410: @2403903
     /* 2403903 */ GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2404023),
     /* 2403908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2403911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2403914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403926 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2403974), // Rule ID 54370 //
     /* 2403931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403934 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2403951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403973 */     // GIR_Coverage, 54370,
     /* 2403973 */     GIR_EraseRootFromParent_Done,
     /* 2403974 */   // Label 34453: @2403974
     /* 2403974 */   GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2404022), // Rule ID 54371 //
     /* 2403979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403982 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2403999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404021 */     // GIR_Coverage, 54371,
     /* 2404021 */     GIR_EraseRootFromParent_Done,
     /* 2404022 */   // Label 34454: @2404022
     /* 2404022 */   GIM_Reject,
     /* 2404023 */ // Label 34452: @2404023
     /* 2404023 */ GIM_Reject,
     /* 2404024 */ // Label 34411: @2404024
     /* 2404024 */ GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2404144),
     /* 2404029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2404032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2404035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2404047 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2404095), // Rule ID 54262 //
     /* 2404052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404055 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2404058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2404072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404094 */     // GIR_Coverage, 54262,
     /* 2404094 */     GIR_EraseRootFromParent_Done,
     /* 2404095 */   // Label 34456: @2404095
     /* 2404095 */   GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2404143), // Rule ID 54263 //
     /* 2404100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404103 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2404106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2404120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404142 */     // GIR_Coverage, 54263,
     /* 2404142 */     GIR_EraseRootFromParent_Done,
     /* 2404143 */   // Label 34457: @2404143
     /* 2404143 */   GIM_Reject,
     /* 2404144 */ // Label 34455: @2404144
     /* 2404144 */ GIM_Reject,
     /* 2404145 */ // Label 34412: @2404145
     /* 2404145 */ GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2404265),
     /* 2404150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2404153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2404156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404168 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2404216), // Rule ID 54334 //
     /* 2404173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404176 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2404179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2404193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404215 */     // GIR_Coverage, 54334,
     /* 2404215 */     GIR_EraseRootFromParent_Done,
     /* 2404216 */   // Label 34459: @2404216
     /* 2404216 */   GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2404264), // Rule ID 54335 //
     /* 2404221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404224 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2404227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2404241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404263 */     // GIR_Coverage, 54335,
     /* 2404263 */     GIR_EraseRootFromParent_Done,
     /* 2404264 */   // Label 34460: @2404264
     /* 2404264 */   GIM_Reject,
     /* 2404265 */ // Label 34458: @2404265
     /* 2404265 */ GIM_Reject,
     /* 2404266 */ // Label 34413: @2404266
     /* 2404266 */ GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2404386),
     /* 2404271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2404274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2404277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404289 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2404337), // Rule ID 54382 //
     /* 2404294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404297 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2404300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2404314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404336 */     // GIR_Coverage, 54382,
     /* 2404336 */     GIR_EraseRootFromParent_Done,
     /* 2404337 */   // Label 34462: @2404337
     /* 2404337 */   GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2404385), // Rule ID 54383 //
     /* 2404342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404345 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2404348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2404362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404384 */     // GIR_Coverage, 54383,
     /* 2404384 */     GIR_EraseRootFromParent_Done,
     /* 2404385 */   // Label 34463: @2404385
     /* 2404385 */   GIM_Reject,
     /* 2404386 */ // Label 34461: @2404386
     /* 2404386 */ GIM_Reject,
     /* 2404387 */ // Label 34414: @2404387
     /* 2404387 */ GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2404507),
     /* 2404392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2404395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2404398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404410 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2404458), // Rule ID 54298 //
     /* 2404415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404418 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2404435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404457 */     // GIR_Coverage, 54298,
     /* 2404457 */     GIR_EraseRootFromParent_Done,
     /* 2404458 */   // Label 34465: @2404458
     /* 2404458 */   GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2404506), // Rule ID 54299 //
     /* 2404463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404466 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2404483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404505 */     // GIR_Coverage, 54299,
     /* 2404505 */     GIR_EraseRootFromParent_Done,
     /* 2404506 */   // Label 34466: @2404506
     /* 2404506 */   GIM_Reject,
     /* 2404507 */ // Label 34464: @2404507
     /* 2404507 */ GIM_Reject,
     /* 2404508 */ // Label 34415: @2404508
     /* 2404508 */ GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2404628),
     /* 2404513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2404516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2404519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404531 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2404579), // Rule ID 54346 //
     /* 2404536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404539 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2404556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404578 */     // GIR_Coverage, 54346,
     /* 2404578 */     GIR_EraseRootFromParent_Done,
     /* 2404579 */   // Label 34468: @2404579
     /* 2404579 */   GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2404627), // Rule ID 54347 //
     /* 2404584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404587 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2404604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404626 */     // GIR_Coverage, 54347,
     /* 2404626 */     GIR_EraseRootFromParent_Done,
     /* 2404627 */   // Label 34469: @2404627
     /* 2404627 */   GIM_Reject,
     /* 2404628 */ // Label 34467: @2404628
     /* 2404628 */ GIM_Reject,
     /* 2404629 */ // Label 34416: @2404629
     /* 2404629 */ GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2404749),
     /* 2404634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2404640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404652 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2404700), // Rule ID 54394 //
     /* 2404657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404660 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2404677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404699 */     // GIR_Coverage, 54394,
     /* 2404699 */     GIR_EraseRootFromParent_Done,
     /* 2404700 */   // Label 34471: @2404700
     /* 2404700 */   GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2404748), // Rule ID 54395 //
     /* 2404705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404708 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2404725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404747 */     // GIR_Coverage, 54395,
     /* 2404747 */     GIR_EraseRootFromParent_Done,
     /* 2404748 */   // Label 34472: @2404748
     /* 2404748 */   GIM_Reject,
     /* 2404749 */ // Label 34470: @2404749
     /* 2404749 */ GIM_Reject,
     /* 2404750 */ // Label 34417: @2404750
     /* 2404750 */ GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2404870),
     /* 2404755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2404761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404773 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2404821), // Rule ID 54310 //
     /* 2404778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404781 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2404798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404820 */     // GIR_Coverage, 54310,
     /* 2404820 */     GIR_EraseRootFromParent_Done,
     /* 2404821 */   // Label 34474: @2404821
     /* 2404821 */   GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2404869), // Rule ID 54311 //
     /* 2404826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404829 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2404846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404868 */     // GIR_Coverage, 54311,
     /* 2404868 */     GIR_EraseRootFromParent_Done,
     /* 2404869 */   // Label 34475: @2404869
     /* 2404869 */   GIM_Reject,
     /* 2404870 */ // Label 34473: @2404870
     /* 2404870 */ GIM_Reject,
     /* 2404871 */ // Label 34418: @2404871
     /* 2404871 */ GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2404991),
     /* 2404876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2404879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2404882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404894 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2404942), // Rule ID 54358 //
     /* 2404899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404902 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2404919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404941 */     // GIR_Coverage, 54358,
     /* 2404941 */     GIR_EraseRootFromParent_Done,
     /* 2404942 */   // Label 34477: @2404942
     /* 2404942 */   GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2404990), // Rule ID 54359 //
     /* 2404947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404950 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2404967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404989 */     // GIR_Coverage, 54359,
     /* 2404989 */     GIR_EraseRootFromParent_Done,
     /* 2404990 */   // Label 34478: @2404990
     /* 2404990 */   GIM_Reject,
     /* 2404991 */ // Label 34476: @2404991
     /* 2404991 */ GIM_Reject,
     /* 2404992 */ // Label 34419: @2404992
     /* 2404992 */ GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2405112),
     /* 2404997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2405000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2405003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405015 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2405063), // Rule ID 54322 //
     /* 2405020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405023 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2405026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2405040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405062 */     // GIR_Coverage, 54322,
     /* 2405062 */     GIR_EraseRootFromParent_Done,
     /* 2405063 */   // Label 34480: @2405063
     /* 2405063 */   GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2405111), // Rule ID 54323 //
     /* 2405068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405071 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2405074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2405088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405110 */     // GIR_Coverage, 54323,
     /* 2405110 */     GIR_EraseRootFromParent_Done,
     /* 2405111 */   // Label 34481: @2405111
     /* 2405111 */   GIM_Reject,
     /* 2405112 */ // Label 34479: @2405112
     /* 2405112 */ GIM_Reject,
     /* 2405113 */ // Label 34420: @2405113
     /* 2405113 */ GIM_Reject,
     /* 2405114 */ // Label 101: @2405114
     /* 2405114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34500*/ GIMT_Encode4(2407541),
     /* 2405125 */ /*GILLT_s16*//*Label 34482*/ GIMT_Encode4(2405245),
     /* 2405129 */ /*GILLT_s32*//*Label 34483*/ GIMT_Encode4(2405394),
     /* 2405133 */ /*GILLT_s64*//*Label 34484*/ GIMT_Encode4(2405543), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405145 */ /*GILLT_nxv1s16*//*Label 34485*/ GIMT_Encode4(2405726),
     /* 2405149 */ /*GILLT_nxv1s32*//*Label 34486*/ GIMT_Encode4(2405847),
     /* 2405153 */ /*GILLT_nxv1s64*//*Label 34487*/ GIMT_Encode4(2405968), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405165 */ /*GILLT_nxv2s16*//*Label 34488*/ GIMT_Encode4(2406089),
     /* 2405169 */ /*GILLT_nxv2s32*//*Label 34489*/ GIMT_Encode4(2406210),
     /* 2405173 */ /*GILLT_nxv2s64*//*Label 34490*/ GIMT_Encode4(2406331), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405185 */ /*GILLT_nxv4s16*//*Label 34491*/ GIMT_Encode4(2406452),
     /* 2405189 */ /*GILLT_nxv4s32*//*Label 34492*/ GIMT_Encode4(2406573),
     /* 2405193 */ /*GILLT_nxv4s64*//*Label 34493*/ GIMT_Encode4(2406694), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405205 */ /*GILLT_nxv8s16*//*Label 34494*/ GIMT_Encode4(2406815),
     /* 2405209 */ /*GILLT_nxv8s32*//*Label 34495*/ GIMT_Encode4(2406936),
     /* 2405213 */ /*GILLT_nxv8s64*//*Label 34496*/ GIMT_Encode4(2407057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405225 */ /*GILLT_nxv16s16*//*Label 34497*/ GIMT_Encode4(2407178),
     /* 2405229 */ /*GILLT_nxv16s32*//*Label 34498*/ GIMT_Encode4(2407299), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2405241 */ /*GILLT_nxv32s16*//*Label 34499*/ GIMT_Encode4(2407420),
     /* 2405245 */ // Label 34482: @2405245
     /* 2405245 */ GIM_Try, /*On fail goto*//*Label 34501*/ GIMT_Encode4(2405393),
     /* 2405250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2405256 */   GIM_Try, /*On fail goto*//*Label 34502*/ GIMT_Encode4(2405290), // Rule ID 1980 //
     /* 2405261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2405264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405276 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2405276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2405279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405289 */     // GIR_Coverage, 1980,
     /* 2405289 */     GIR_EraseRootFromParent_Done,
     /* 2405290 */   // Label 34502: @2405290
     /* 2405290 */   GIM_Try, /*On fail goto*//*Label 34503*/ GIMT_Encode4(2405324), // Rule ID 1981 //
     /* 2405295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2405298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405310 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2405310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2405313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405323 */     // GIR_Coverage, 1981,
     /* 2405323 */     GIR_EraseRootFromParent_Done,
     /* 2405324 */   // Label 34503: @2405324
     /* 2405324 */   GIM_Try, /*On fail goto*//*Label 34504*/ GIMT_Encode4(2405358), // Rule ID 1984 //
     /* 2405329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2405332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405344 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2405344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2405347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405357 */     // GIR_Coverage, 1984,
     /* 2405357 */     GIR_EraseRootFromParent_Done,
     /* 2405358 */   // Label 34504: @2405358
     /* 2405358 */   GIM_Try, /*On fail goto*//*Label 34505*/ GIMT_Encode4(2405392), // Rule ID 1985 //
     /* 2405363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2405366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405378 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2405378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2405381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405391 */     // GIR_Coverage, 1985,
     /* 2405391 */     GIR_EraseRootFromParent_Done,
     /* 2405392 */   // Label 34505: @2405392
     /* 2405392 */   GIM_Reject,
     /* 2405393 */ // Label 34501: @2405393
     /* 2405393 */ GIM_Reject,
     /* 2405394 */ // Label 34483: @2405394
     /* 2405394 */ GIM_Try, /*On fail goto*//*Label 34506*/ GIMT_Encode4(2405542),
     /* 2405399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2405405 */   GIM_Try, /*On fail goto*//*Label 34507*/ GIMT_Encode4(2405439), // Rule ID 1271 //
     /* 2405410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405425 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2405425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2405428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405438 */     // GIR_Coverage, 1271,
     /* 2405438 */     GIR_EraseRootFromParent_Done,
     /* 2405439 */   // Label 34507: @2405439
     /* 2405439 */   GIM_Try, /*On fail goto*//*Label 34508*/ GIMT_Encode4(2405473), // Rule ID 1272 //
     /* 2405444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2405447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405459 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2405459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2405462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405472 */     // GIR_Coverage, 1272,
     /* 2405472 */     GIR_EraseRootFromParent_Done,
     /* 2405473 */   // Label 34508: @2405473
     /* 2405473 */   GIM_Try, /*On fail goto*//*Label 34509*/ GIMT_Encode4(2405507), // Rule ID 1275 //
     /* 2405478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405493 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2405493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2405496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405506 */     // GIR_Coverage, 1275,
     /* 2405506 */     GIR_EraseRootFromParent_Done,
     /* 2405507 */   // Label 34509: @2405507
     /* 2405507 */   GIM_Try, /*On fail goto*//*Label 34510*/ GIMT_Encode4(2405541), // Rule ID 1276 //
     /* 2405512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2405515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405527 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2405527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2405530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405540 */     // GIR_Coverage, 1276,
     /* 2405540 */     GIR_EraseRootFromParent_Done,
     /* 2405541 */   // Label 34510: @2405541
     /* 2405541 */   GIM_Reject,
     /* 2405542 */ // Label 34506: @2405542
     /* 2405542 */ GIM_Reject,
     /* 2405543 */ // Label 34484: @2405543
     /* 2405543 */ GIM_Try, /*On fail goto*//*Label 34511*/ GIMT_Encode4(2405725),
     /* 2405548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405554 */   GIM_Try, /*On fail goto*//*Label 34512*/ GIMT_Encode4(2405588), // Rule ID 1612 //
     /* 2405559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405574 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2405577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405587 */     // GIR_Coverage, 1612,
     /* 2405587 */     GIR_EraseRootFromParent_Done,
     /* 2405588 */   // Label 34512: @2405588
     /* 2405588 */   GIM_Try, /*On fail goto*//*Label 34513*/ GIMT_Encode4(2405622), // Rule ID 1613 //
     /* 2405593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405608 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2405608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2405611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405621 */     // GIR_Coverage, 1613,
     /* 2405621 */     GIR_EraseRootFromParent_Done,
     /* 2405622 */   // Label 34513: @2405622
     /* 2405622 */   GIM_Try, /*On fail goto*//*Label 34514*/ GIMT_Encode4(2405656), // Rule ID 1616 //
     /* 2405627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405642 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2405645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405655 */     // GIR_Coverage, 1616,
     /* 2405655 */     GIR_EraseRootFromParent_Done,
     /* 2405656 */   // Label 34514: @2405656
     /* 2405656 */   GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2405690), // Rule ID 1617 //
     /* 2405661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405676 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2405676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2405679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405689 */     // GIR_Coverage, 1617,
     /* 2405689 */     GIR_EraseRootFromParent_Done,
     /* 2405690 */   // Label 34515: @2405690
     /* 2405690 */   GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2405724), // Rule ID 1620 //
     /* 2405695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405710 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2405710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2405713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405723 */     // GIR_Coverage, 1620,
     /* 2405723 */     GIR_EraseRootFromParent_Done,
     /* 2405724 */   // Label 34516: @2405724
     /* 2405724 */   GIM_Reject,
     /* 2405725 */ // Label 34511: @2405725
     /* 2405725 */ GIM_Reject,
     /* 2405726 */ // Label 34485: @2405726
     /* 2405726 */ GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2405846),
     /* 2405731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2405734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2405737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405749 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2405797), // Rule ID 54406 //
     /* 2405754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405757 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2405760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2405774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405796 */     // GIR_Coverage, 54406,
     /* 2405796 */     GIR_EraseRootFromParent_Done,
     /* 2405797 */   // Label 34518: @2405797
     /* 2405797 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2405845), // Rule ID 54407 //
     /* 2405802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405805 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2405808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2405822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405844 */     // GIR_Coverage, 54407,
     /* 2405844 */     GIR_EraseRootFromParent_Done,
     /* 2405845 */   // Label 34519: @2405845
     /* 2405845 */   GIM_Reject,
     /* 2405846 */ // Label 34517: @2405846
     /* 2405846 */ GIM_Reject,
     /* 2405847 */ // Label 34486: @2405847
     /* 2405847 */ GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2405967),
     /* 2405852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2405855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2405858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405870 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2405918), // Rule ID 54430 //
     /* 2405875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405878 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2405881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2405895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405917 */     // GIR_Coverage, 54430,
     /* 2405917 */     GIR_EraseRootFromParent_Done,
     /* 2405918 */   // Label 34521: @2405918
     /* 2405918 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2405966), // Rule ID 54431 //
     /* 2405923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405926 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2405926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2405929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2405933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2405938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2405940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2405943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2405948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2405964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405965 */     // GIR_Coverage, 54431,
     /* 2405965 */     GIR_EraseRootFromParent_Done,
     /* 2405966 */   // Label 34522: @2405966
     /* 2405966 */   GIM_Reject,
     /* 2405967 */ // Label 34520: @2405967
     /* 2405967 */ GIM_Reject,
     /* 2405968 */ // Label 34487: @2405968
     /* 2405968 */ GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2406088),
     /* 2405973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2405976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2405979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2405991 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2406039), // Rule ID 54466 //
     /* 2405996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2405999 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2405999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2406002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2406016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406038 */     // GIR_Coverage, 54466,
     /* 2406038 */     GIR_EraseRootFromParent_Done,
     /* 2406039 */   // Label 34524: @2406039
     /* 2406039 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2406087), // Rule ID 54467 //
     /* 2406044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406047 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2406050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2406064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406086 */     // GIR_Coverage, 54467,
     /* 2406086 */     GIR_EraseRootFromParent_Done,
     /* 2406087 */   // Label 34525: @2406087
     /* 2406087 */   GIM_Reject,
     /* 2406088 */ // Label 34523: @2406088
     /* 2406088 */ GIM_Reject,
     /* 2406089 */ // Label 34488: @2406089
     /* 2406089 */ GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2406209),
     /* 2406094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2406097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2406100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406112 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2406160), // Rule ID 54418 //
     /* 2406117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406120 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2406123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2406137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406159 */     // GIR_Coverage, 54418,
     /* 2406159 */     GIR_EraseRootFromParent_Done,
     /* 2406160 */   // Label 34527: @2406160
     /* 2406160 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2406208), // Rule ID 54419 //
     /* 2406165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406168 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2406171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2406185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406207 */     // GIR_Coverage, 54419,
     /* 2406207 */     GIR_EraseRootFromParent_Done,
     /* 2406208 */   // Label 34528: @2406208
     /* 2406208 */   GIM_Reject,
     /* 2406209 */ // Label 34526: @2406209
     /* 2406209 */ GIM_Reject,
     /* 2406210 */ // Label 34489: @2406210
     /* 2406210 */ GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2406330),
     /* 2406215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2406218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2406221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406233 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2406281), // Rule ID 54454 //
     /* 2406238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406241 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2406244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2406258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406280 */     // GIR_Coverage, 54454,
     /* 2406280 */     GIR_EraseRootFromParent_Done,
     /* 2406281 */   // Label 34530: @2406281
     /* 2406281 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2406329), // Rule ID 54455 //
     /* 2406286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2406289 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2406292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2406306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406328 */     // GIR_Coverage, 54455,
     /* 2406328 */     GIR_EraseRootFromParent_Done,
     /* 2406329 */   // Label 34531: @2406329
     /* 2406329 */   GIM_Reject,
     /* 2406330 */ // Label 34529: @2406330
     /* 2406330 */ GIM_Reject,
     /* 2406331 */ // Label 34490: @2406331
     /* 2406331 */ GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2406451),
     /* 2406336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2406339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2406342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406354 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2406402), // Rule ID 54550 //
     /* 2406359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2406362 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2406365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2406379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406401 */     // GIR_Coverage, 54550,
     /* 2406401 */     GIR_EraseRootFromParent_Done,
     /* 2406402 */   // Label 34533: @2406402
     /* 2406402 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2406450), // Rule ID 54551 //
     /* 2406407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406410 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2406413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2406427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406449 */     // GIR_Coverage, 54551,
     /* 2406449 */     GIR_EraseRootFromParent_Done,
     /* 2406450 */   // Label 34534: @2406450
     /* 2406450 */   GIM_Reject,
     /* 2406451 */ // Label 34532: @2406451
     /* 2406451 */ GIM_Reject,
     /* 2406452 */ // Label 34491: @2406452
     /* 2406452 */ GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2406572),
     /* 2406457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2406460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2406463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406475 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2406523), // Rule ID 54442 //
     /* 2406480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406483 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2406486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2406500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406522 */     // GIR_Coverage, 54442,
     /* 2406522 */     GIR_EraseRootFromParent_Done,
     /* 2406523 */   // Label 34536: @2406523
     /* 2406523 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2406571), // Rule ID 54443 //
     /* 2406528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406531 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2406534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2406548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406570 */     // GIR_Coverage, 54443,
     /* 2406570 */     GIR_EraseRootFromParent_Done,
     /* 2406571 */   // Label 34537: @2406571
     /* 2406571 */   GIM_Reject,
     /* 2406572 */ // Label 34535: @2406572
     /* 2406572 */ GIM_Reject,
     /* 2406573 */ // Label 34492: @2406573
     /* 2406573 */ GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2406693),
     /* 2406578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2406581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2406584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406596 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2406644), // Rule ID 54514 //
     /* 2406601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406604 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2406607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2406621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406643 */     // GIR_Coverage, 54514,
     /* 2406643 */     GIR_EraseRootFromParent_Done,
     /* 2406644 */   // Label 34539: @2406644
     /* 2406644 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2406692), // Rule ID 54515 //
     /* 2406649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2406652 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2406655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2406669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406691 */     // GIR_Coverage, 54515,
     /* 2406691 */     GIR_EraseRootFromParent_Done,
     /* 2406692 */   // Label 34540: @2406692
     /* 2406692 */   GIM_Reject,
     /* 2406693 */ // Label 34538: @2406693
     /* 2406693 */ GIM_Reject,
     /* 2406694 */ // Label 34493: @2406694
     /* 2406694 */ GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2406814),
     /* 2406699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2406702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2406705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406717 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2406765), // Rule ID 54562 //
     /* 2406722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2406725 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2406728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2406742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406764 */     // GIR_Coverage, 54562,
     /* 2406764 */     GIR_EraseRootFromParent_Done,
     /* 2406765 */   // Label 34542: @2406765
     /* 2406765 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2406813), // Rule ID 54563 //
     /* 2406770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2406773 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2406776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2406790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2406808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406812 */     // GIR_Coverage, 54563,
     /* 2406812 */     GIR_EraseRootFromParent_Done,
     /* 2406813 */   // Label 34543: @2406813
     /* 2406813 */   GIM_Reject,
     /* 2406814 */ // Label 34541: @2406814
     /* 2406814 */ GIM_Reject,
     /* 2406815 */ // Label 34494: @2406815
     /* 2406815 */ GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2406935),
     /* 2406820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2406823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2406826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2406838 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2406886), // Rule ID 54478 //
     /* 2406843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406846 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2406849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2406863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406885 */     // GIR_Coverage, 54478,
     /* 2406885 */     GIR_EraseRootFromParent_Done,
     /* 2406886 */   // Label 34545: @2406886
     /* 2406886 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2406934), // Rule ID 54479 //
     /* 2406891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406894 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2406894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2406897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2406911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2406932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406933 */     // GIR_Coverage, 54479,
     /* 2406933 */     GIR_EraseRootFromParent_Done,
     /* 2406934 */   // Label 34546: @2406934
     /* 2406934 */   GIM_Reject,
     /* 2406935 */ // Label 34544: @2406935
     /* 2406935 */ GIM_Reject,
     /* 2406936 */ // Label 34495: @2406936
     /* 2406936 */ GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2407056),
     /* 2406941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2406944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2406947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2406959 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2407007), // Rule ID 54526 //
     /* 2406964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2406967 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2406967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2406970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2406974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2406979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2406981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2406984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2406989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407006 */     // GIR_Coverage, 54526,
     /* 2407006 */     GIR_EraseRootFromParent_Done,
     /* 2407007 */   // Label 34548: @2407007
     /* 2407007 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2407055), // Rule ID 54527 //
     /* 2407012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407015 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2407018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2407032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407054 */     // GIR_Coverage, 54527,
     /* 2407054 */     GIR_EraseRootFromParent_Done,
     /* 2407055 */   // Label 34549: @2407055
     /* 2407055 */   GIM_Reject,
     /* 2407056 */ // Label 34547: @2407056
     /* 2407056 */ GIM_Reject,
     /* 2407057 */ // Label 34496: @2407057
     /* 2407057 */ GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2407177),
     /* 2407062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2407065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2407068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407080 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2407128), // Rule ID 54574 //
     /* 2407085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407088 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2407091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2407105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407127 */     // GIR_Coverage, 54574,
     /* 2407127 */     GIR_EraseRootFromParent_Done,
     /* 2407128 */   // Label 34551: @2407128
     /* 2407128 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2407176), // Rule ID 54575 //
     /* 2407133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2407136 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2407139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2407153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407175 */     // GIR_Coverage, 54575,
     /* 2407175 */     GIR_EraseRootFromParent_Done,
     /* 2407176 */   // Label 34552: @2407176
     /* 2407176 */   GIM_Reject,
     /* 2407177 */ // Label 34550: @2407177
     /* 2407177 */ GIM_Reject,
     /* 2407178 */ // Label 34497: @2407178
     /* 2407178 */ GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2407298),
     /* 2407183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2407186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2407189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2407201 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2407249), // Rule ID 54490 //
     /* 2407206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407209 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2407212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2407226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407248 */     // GIR_Coverage, 54490,
     /* 2407248 */     GIR_EraseRootFromParent_Done,
     /* 2407249 */   // Label 34554: @2407249
     /* 2407249 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2407297), // Rule ID 54491 //
     /* 2407254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407257 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2407260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2407274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407296 */     // GIR_Coverage, 54491,
     /* 2407296 */     GIR_EraseRootFromParent_Done,
     /* 2407297 */   // Label 34555: @2407297
     /* 2407297 */   GIM_Reject,
     /* 2407298 */ // Label 34553: @2407298
     /* 2407298 */ GIM_Reject,
     /* 2407299 */ // Label 34498: @2407299
     /* 2407299 */ GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2407419),
     /* 2407304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2407307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2407310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407322 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2407370), // Rule ID 54538 //
     /* 2407327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407330 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2407333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2407347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407369 */     // GIR_Coverage, 54538,
     /* 2407369 */     GIR_EraseRootFromParent_Done,
     /* 2407370 */   // Label 34557: @2407370
     /* 2407370 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2407418), // Rule ID 54539 //
     /* 2407375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407378 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2407381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2407395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407417 */     // GIR_Coverage, 54539,
     /* 2407417 */     GIR_EraseRootFromParent_Done,
     /* 2407418 */   // Label 34558: @2407418
     /* 2407418 */   GIM_Reject,
     /* 2407419 */ // Label 34556: @2407419
     /* 2407419 */ GIM_Reject,
     /* 2407420 */ // Label 34499: @2407420
     /* 2407420 */ GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2407540),
     /* 2407425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2407428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2407431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2407443 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2407491), // Rule ID 54502 //
     /* 2407448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407451 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2407454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2407468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407490 */     // GIR_Coverage, 54502,
     /* 2407490 */     GIR_EraseRootFromParent_Done,
     /* 2407491 */   // Label 34560: @2407491
     /* 2407491 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2407539), // Rule ID 54503 //
     /* 2407496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407499 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2407502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2407516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407538 */     // GIR_Coverage, 54503,
     /* 2407538 */     GIR_EraseRootFromParent_Done,
     /* 2407539 */   // Label 34561: @2407539
     /* 2407539 */   GIM_Reject,
     /* 2407540 */ // Label 34559: @2407540
     /* 2407540 */ GIM_Reject,
     /* 2407541 */ // Label 34500: @2407541
     /* 2407541 */ GIM_Reject,
     /* 2407542 */ // Label 102: @2407542
     /* 2407542 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34580*/ GIMT_Encode4(2424186),
     /* 2407553 */ /*GILLT_s16*//*Label 34562*/ GIMT_Encode4(2407673),
     /* 2407557 */ /*GILLT_s32*//*Label 34563*/ GIMT_Encode4(2409109),
     /* 2407561 */ /*GILLT_s64*//*Label 34564*/ GIMT_Encode4(2410545), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407573 */ /*GILLT_nxv1s16*//*Label 34565*/ GIMT_Encode4(2412336),
     /* 2407577 */ /*GILLT_nxv1s32*//*Label 34566*/ GIMT_Encode4(2413126),
     /* 2407581 */ /*GILLT_nxv1s64*//*Label 34567*/ GIMT_Encode4(2413916), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407593 */ /*GILLT_nxv2s16*//*Label 34568*/ GIMT_Encode4(2414706),
     /* 2407597 */ /*GILLT_nxv2s32*//*Label 34569*/ GIMT_Encode4(2415496),
     /* 2407601 */ /*GILLT_nxv2s64*//*Label 34570*/ GIMT_Encode4(2416286), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407613 */ /*GILLT_nxv4s16*//*Label 34571*/ GIMT_Encode4(2417076),
     /* 2407617 */ /*GILLT_nxv4s32*//*Label 34572*/ GIMT_Encode4(2417866),
     /* 2407621 */ /*GILLT_nxv4s64*//*Label 34573*/ GIMT_Encode4(2418656), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407633 */ /*GILLT_nxv8s16*//*Label 34574*/ GIMT_Encode4(2419446),
     /* 2407637 */ /*GILLT_nxv8s32*//*Label 34575*/ GIMT_Encode4(2420236),
     /* 2407641 */ /*GILLT_nxv8s64*//*Label 34576*/ GIMT_Encode4(2421026), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407653 */ /*GILLT_nxv16s16*//*Label 34577*/ GIMT_Encode4(2421816),
     /* 2407657 */ /*GILLT_nxv16s32*//*Label 34578*/ GIMT_Encode4(2422606), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2407669 */ /*GILLT_nxv32s16*//*Label 34579*/ GIMT_Encode4(2423396),
     /* 2407673 */ // Label 34562: @2407673
     /* 2407673 */ GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2409108),
     /* 2407678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2407684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2407687 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2407759), // Rule ID 2013 //
     /* 2407692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2407695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407739 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2407739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2407742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407758 */     // GIR_Coverage, 2013,
     /* 2407758 */     GIR_EraseRootFromParent_Done,
     /* 2407759 */   // Label 34582: @2407759
     /* 2407759 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2407831), // Rule ID 2014 //
     /* 2407764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2407767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407811 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2407811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2407814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407830 */     // GIR_Coverage, 2014,
     /* 2407830 */     GIR_EraseRootFromParent_Done,
     /* 2407831 */   // Label 34583: @2407831
     /* 2407831 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2407903), // Rule ID 2046 //
     /* 2407836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2407839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407883 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2407883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2407886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407902 */     // GIR_Coverage, 2046,
     /* 2407902 */     GIR_EraseRootFromParent_Done,
     /* 2407903 */   // Label 34584: @2407903
     /* 2407903 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2407975), // Rule ID 2047 //
     /* 2407908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2407911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2407948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407955 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2407955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2407958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2407970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407974 */     // GIR_Coverage, 2047,
     /* 2407974 */     GIR_EraseRootFromParent_Done,
     /* 2407975 */   // Label 34585: @2407975
     /* 2407975 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2408047), // Rule ID 65527 //
     /* 2407980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2407983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2407991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408027 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2408030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408046 */     // GIR_Coverage, 65527,
     /* 2408046 */     GIR_EraseRootFromParent_Done,
     /* 2408047 */   // Label 34586: @2408047
     /* 2408047 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2408119), // Rule ID 65528 //
     /* 2408052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408099 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2408102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408118 */     // GIR_Coverage, 65528,
     /* 2408118 */     GIR_EraseRootFromParent_Done,
     /* 2408119 */   // Label 34587: @2408119
     /* 2408119 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2408191), // Rule ID 65535 //
     /* 2408124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408171 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2408174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408190 */     // GIR_Coverage, 65535,
     /* 2408190 */     GIR_EraseRootFromParent_Done,
     /* 2408191 */   // Label 34588: @2408191
     /* 2408191 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2408263), // Rule ID 65536 //
     /* 2408196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408243 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2408246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2408258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408262 */     // GIR_Coverage, 65536,
     /* 2408262 */     GIR_EraseRootFromParent_Done,
     /* 2408263 */   // Label 34589: @2408263
     /* 2408263 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2408320), // Rule ID 2009 //
     /* 2408268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408302 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408319 */     // GIR_Coverage, 2009,
     /* 2408319 */     GIR_EraseRootFromParent_Done,
     /* 2408320 */   // Label 34590: @2408320
     /* 2408320 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2408377), // Rule ID 2010 //
     /* 2408325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408359 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408376 */     // GIR_Coverage, 2010,
     /* 2408376 */     GIR_EraseRootFromParent_Done,
     /* 2408377 */   // Label 34591: @2408377
     /* 2408377 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2408434), // Rule ID 2042 //
     /* 2408382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408416 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408433 */     // GIR_Coverage, 2042,
     /* 2408433 */     GIR_EraseRootFromParent_Done,
     /* 2408434 */   // Label 34592: @2408434
     /* 2408434 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2408491), // Rule ID 2043 //
     /* 2408439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408473 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408490 */     // GIR_Coverage, 2043,
     /* 2408490 */     GIR_EraseRootFromParent_Done,
     /* 2408491 */   // Label 34593: @2408491
     /* 2408491 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2408548), // Rule ID 65523 //
     /* 2408496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408530 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408547 */     // GIR_Coverage, 65523,
     /* 2408547 */     GIR_EraseRootFromParent_Done,
     /* 2408548 */   // Label 34594: @2408548
     /* 2408548 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2408605), // Rule ID 65524 //
     /* 2408553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408587 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2408590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408604 */     // GIR_Coverage, 65524,
     /* 2408604 */     GIR_EraseRootFromParent_Done,
     /* 2408605 */   // Label 34595: @2408605
     /* 2408605 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2408662), // Rule ID 65531 //
     /* 2408610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408644 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408661 */     // GIR_Coverage, 65531,
     /* 2408661 */     GIR_EraseRootFromParent_Done,
     /* 2408662 */   // Label 34596: @2408662
     /* 2408662 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2408719), // Rule ID 65532 //
     /* 2408667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408701 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2408704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408718 */     // GIR_Coverage, 65532,
     /* 2408718 */     GIR_EraseRootFromParent_Done,
     /* 2408719 */   // Label 34597: @2408719
     /* 2408719 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2408776), // Rule ID 2005 //
     /* 2408724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408758 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2408761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408775 */     // GIR_Coverage, 2005,
     /* 2408775 */     GIR_EraseRootFromParent_Done,
     /* 2408776 */   // Label 34598: @2408776
     /* 2408776 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2408833), // Rule ID 2006 //
     /* 2408781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408815 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2408818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408832 */     // GIR_Coverage, 2006,
     /* 2408832 */     GIR_EraseRootFromParent_Done,
     /* 2408833 */   // Label 34599: @2408833
     /* 2408833 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2408890), // Rule ID 2038 //
     /* 2408838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2408841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408872 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2408875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408889 */     // GIR_Coverage, 2038,
     /* 2408889 */     GIR_EraseRootFromParent_Done,
     /* 2408890 */   // Label 34600: @2408890
     /* 2408890 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2408947), // Rule ID 2039 //
     /* 2408895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2408898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2408922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2408927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408929 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2408929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2408932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2408942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408946 */     // GIR_Coverage, 2039,
     /* 2408946 */     GIR_EraseRootFromParent_Done,
     /* 2408947 */   // Label 34601: @2408947
     /* 2408947 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2408987), // Rule ID 2001 //
     /* 2408952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2408955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408971 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2408971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2408974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2408982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408986 */     // GIR_Coverage, 2001,
     /* 2408986 */     GIR_EraseRootFromParent_Done,
     /* 2408987 */   // Label 34602: @2408987
     /* 2408987 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2409027), // Rule ID 2002 //
     /* 2408992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2408995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2408999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409011 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2409011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2409014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409026 */     // GIR_Coverage, 2002,
     /* 2409026 */     GIR_EraseRootFromParent_Done,
     /* 2409027 */   // Label 34603: @2409027
     /* 2409027 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2409067), // Rule ID 2034 //
     /* 2409032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2409035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409051 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2409051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2409054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409066 */     // GIR_Coverage, 2034,
     /* 2409066 */     GIR_EraseRootFromParent_Done,
     /* 2409067 */   // Label 34604: @2409067
     /* 2409067 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2409107), // Rule ID 2035 //
     /* 2409072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2409075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409091 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2409091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2409094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409106 */     // GIR_Coverage, 2035,
     /* 2409106 */     GIR_EraseRootFromParent_Done,
     /* 2409107 */   // Label 34605: @2409107
     /* 2409107 */   GIM_Reject,
     /* 2409108 */ // Label 34581: @2409108
     /* 2409108 */ GIM_Reject,
     /* 2409109 */ // Label 34563: @2409109
     /* 2409109 */ GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2410544),
     /* 2409114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2409120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409123 */   GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2409195), // Rule ID 1312 //
     /* 2409128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409175 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409194 */     // GIR_Coverage, 1312,
     /* 2409194 */     GIR_EraseRootFromParent_Done,
     /* 2409195 */   // Label 34607: @2409195
     /* 2409195 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2409267), // Rule ID 1313 //
     /* 2409200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409247 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409266 */     // GIR_Coverage, 1313,
     /* 2409266 */     GIR_EraseRootFromParent_Done,
     /* 2409267 */   // Label 34608: @2409267
     /* 2409267 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2409339), // Rule ID 1333 //
     /* 2409272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409319 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409338 */     // GIR_Coverage, 1333,
     /* 2409338 */     GIR_EraseRootFromParent_Done,
     /* 2409339 */   // Label 34609: @2409339
     /* 2409339 */   GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2409411), // Rule ID 1334 //
     /* 2409344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409391 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409410 */     // GIR_Coverage, 1334,
     /* 2409410 */     GIR_EraseRootFromParent_Done,
     /* 2409411 */   // Label 34610: @2409411
     /* 2409411 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2409483), // Rule ID 65491 //
     /* 2409416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409463 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409482 */     // GIR_Coverage, 65491,
     /* 2409482 */     GIR_EraseRootFromParent_Done,
     /* 2409483 */   // Label 34611: @2409483
     /* 2409483 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2409555), // Rule ID 65492 //
     /* 2409488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409535 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2409538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409554 */     // GIR_Coverage, 65492,
     /* 2409554 */     GIR_EraseRootFromParent_Done,
     /* 2409555 */   // Label 34612: @2409555
     /* 2409555 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2409627), // Rule ID 65499 //
     /* 2409560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409607 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409626 */     // GIR_Coverage, 65499,
     /* 2409626 */     GIR_EraseRootFromParent_Done,
     /* 2409627 */   // Label 34613: @2409627
     /* 2409627 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2409699), // Rule ID 65500 //
     /* 2409632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409679 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2409682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2409694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409698 */     // GIR_Coverage, 65500,
     /* 2409698 */     GIR_EraseRootFromParent_Done,
     /* 2409699 */   // Label 34614: @2409699
     /* 2409699 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2409756), // Rule ID 1308 //
     /* 2409704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409738 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409755 */     // GIR_Coverage, 1308,
     /* 2409755 */     GIR_EraseRootFromParent_Done,
     /* 2409756 */   // Label 34615: @2409756
     /* 2409756 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2409813), // Rule ID 1309 //
     /* 2409761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409795 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409812 */     // GIR_Coverage, 1309,
     /* 2409812 */     GIR_EraseRootFromParent_Done,
     /* 2409813 */   // Label 34616: @2409813
     /* 2409813 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2409870), // Rule ID 1329 //
     /* 2409818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409852 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2409855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409869 */     // GIR_Coverage, 1329,
     /* 2409869 */     GIR_EraseRootFromParent_Done,
     /* 2409870 */   // Label 34617: @2409870
     /* 2409870 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2409927), // Rule ID 1330 //
     /* 2409875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409909 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2409909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2409912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409926 */     // GIR_Coverage, 1330,
     /* 2409926 */     GIR_EraseRootFromParent_Done,
     /* 2409927 */   // Label 34618: @2409927
     /* 2409927 */   GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2409984), // Rule ID 65487 //
     /* 2409932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409966 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2409966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2409969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2409977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2409979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409983 */     // GIR_Coverage, 65487,
     /* 2409983 */     GIR_EraseRootFromParent_Done,
     /* 2409984 */   // Label 34619: @2409984
     /* 2409984 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2410041), // Rule ID 65488 //
     /* 2409989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410023 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2410026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410040 */     // GIR_Coverage, 65488,
     /* 2410040 */     GIR_EraseRootFromParent_Done,
     /* 2410041 */   // Label 34620: @2410041
     /* 2410041 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2410098), // Rule ID 65495 //
     /* 2410046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410080 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2410083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410097 */     // GIR_Coverage, 65495,
     /* 2410097 */     GIR_EraseRootFromParent_Done,
     /* 2410098 */   // Label 34621: @2410098
     /* 2410098 */   GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2410155), // Rule ID 65496 //
     /* 2410103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410137 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2410140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410154 */     // GIR_Coverage, 65496,
     /* 2410154 */     GIR_EraseRootFromParent_Done,
     /* 2410155 */   // Label 34622: @2410155
     /* 2410155 */   GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2410212), // Rule ID 1304 //
     /* 2410160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2410163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410194 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2410197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410211 */     // GIR_Coverage, 1304,
     /* 2410211 */     GIR_EraseRootFromParent_Done,
     /* 2410212 */   // Label 34623: @2410212
     /* 2410212 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2410269), // Rule ID 1305 //
     /* 2410217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2410220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410251 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2410254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410268 */     // GIR_Coverage, 1305,
     /* 2410268 */     GIR_EraseRootFromParent_Done,
     /* 2410269 */   // Label 34624: @2410269
     /* 2410269 */   GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2410326), // Rule ID 1325 //
     /* 2410274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410308 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2410311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410325 */     // GIR_Coverage, 1325,
     /* 2410325 */     GIR_EraseRootFromParent_Done,
     /* 2410326 */   // Label 34625: @2410326
     /* 2410326 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2410383), // Rule ID 1326 //
     /* 2410331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410365 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2410368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2410378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410382 */     // GIR_Coverage, 1326,
     /* 2410382 */     GIR_EraseRootFromParent_Done,
     /* 2410383 */   // Label 34626: @2410383
     /* 2410383 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2410423), // Rule ID 1300 //
     /* 2410388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2410391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410407 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2410410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410422 */     // GIR_Coverage, 1300,
     /* 2410422 */     GIR_EraseRootFromParent_Done,
     /* 2410423 */   // Label 34627: @2410423
     /* 2410423 */   GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2410463), // Rule ID 1301 //
     /* 2410428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2410431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2410447 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2410450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410462 */     // GIR_Coverage, 1301,
     /* 2410462 */     GIR_EraseRootFromParent_Done,
     /* 2410463 */   // Label 34628: @2410463
     /* 2410463 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2410503), // Rule ID 1321 //
     /* 2410468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2410471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410487 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2410487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2410490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410502 */     // GIR_Coverage, 1321,
     /* 2410502 */     GIR_EraseRootFromParent_Done,
     /* 2410503 */   // Label 34629: @2410503
     /* 2410503 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2410543), // Rule ID 1322 //
     /* 2410508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2410511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2410527 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2410527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2410530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2410538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410542 */     // GIR_Coverage, 1322,
     /* 2410542 */     GIR_EraseRootFromParent_Done,
     /* 2410543 */   // Label 34630: @2410543
     /* 2410543 */   GIM_Reject,
     /* 2410544 */ // Label 34606: @2410544
     /* 2410544 */ GIM_Reject,
     /* 2410545 */ // Label 34564: @2410545
     /* 2410545 */ GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2412335),
     /* 2410550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410559 */   GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2410631), // Rule ID 1649 //
     /* 2410564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2410567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410611 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410630 */     // GIR_Coverage, 1649,
     /* 2410630 */     GIR_EraseRootFromParent_Done,
     /* 2410631 */   // Label 34632: @2410631
     /* 2410631 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2410703), // Rule ID 1650 //
     /* 2410636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2410639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410683 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2410683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410702 */     // GIR_Coverage, 1650,
     /* 2410702 */     GIR_EraseRootFromParent_Done,
     /* 2410703 */   // Label 34633: @2410703
     /* 2410703 */   GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2410775), // Rule ID 1673 //
     /* 2410708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2410711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410755 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2410758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410774 */     // GIR_Coverage, 1673,
     /* 2410774 */     GIR_EraseRootFromParent_Done,
     /* 2410775 */   // Label 34634: @2410775
     /* 2410775 */   GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2410847), // Rule ID 1704 //
     /* 2410780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2410783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410827 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2410830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410846 */     // GIR_Coverage, 1704,
     /* 2410846 */     GIR_EraseRootFromParent_Done,
     /* 2410847 */   // Label 34635: @2410847
     /* 2410847 */   GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2410919), // Rule ID 1705 //
     /* 2410852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2410855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2410897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410899 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2410899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2410902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410918 */     // GIR_Coverage, 1705,
     /* 2410918 */     GIR_EraseRootFromParent_Done,
     /* 2410919 */   // Label 34636: @2410919
     /* 2410919 */   GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2410991), // Rule ID 65507 //
     /* 2410924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2410927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2410969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410971 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2410971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2410974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2410982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2410986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410990 */     // GIR_Coverage, 65507,
     /* 2410990 */     GIR_EraseRootFromParent_Done,
     /* 2410991 */   // Label 34637: @2410991
     /* 2410991 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2411063), // Rule ID 65508 //
     /* 2410996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2410999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411043 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2411046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411062 */     // GIR_Coverage, 65508,
     /* 2411062 */     GIR_EraseRootFromParent_Done,
     /* 2411063 */   // Label 34638: @2411063
     /* 2411063 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2411135), // Rule ID 65513 //
     /* 2411068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411115 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2411118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411134 */     // GIR_Coverage, 65513,
     /* 2411134 */     GIR_EraseRootFromParent_Done,
     /* 2411135 */   // Label 34639: @2411135
     /* 2411135 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2411207), // Rule ID 65519 //
     /* 2411140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411187 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2411190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411206 */     // GIR_Coverage, 65519,
     /* 2411206 */     GIR_EraseRootFromParent_Done,
     /* 2411207 */   // Label 34640: @2411207
     /* 2411207 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2411279), // Rule ID 65520 //
     /* 2411212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411259 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2411262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2411274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411278 */     // GIR_Coverage, 65520,
     /* 2411278 */     GIR_EraseRootFromParent_Done,
     /* 2411279 */   // Label 34641: @2411279
     /* 2411279 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2411336), // Rule ID 1645 //
     /* 2411284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411318 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411335 */     // GIR_Coverage, 1645,
     /* 2411335 */     GIR_EraseRootFromParent_Done,
     /* 2411336 */   // Label 34642: @2411336
     /* 2411336 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2411393), // Rule ID 1646 //
     /* 2411341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411375 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411392 */     // GIR_Coverage, 1646,
     /* 2411392 */     GIR_EraseRootFromParent_Done,
     /* 2411393 */   // Label 34643: @2411393
     /* 2411393 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2411450), // Rule ID 1671 //
     /* 2411398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411432 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2411435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411449 */     // GIR_Coverage, 1671,
     /* 2411449 */     GIR_EraseRootFromParent_Done,
     /* 2411450 */   // Label 34644: @2411450
     /* 2411450 */   GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2411507), // Rule ID 1700 //
     /* 2411455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411489 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411506 */     // GIR_Coverage, 1700,
     /* 2411506 */     GIR_EraseRootFromParent_Done,
     /* 2411507 */   // Label 34645: @2411507
     /* 2411507 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2411564), // Rule ID 1701 //
     /* 2411512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411546 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411563 */     // GIR_Coverage, 1701,
     /* 2411563 */     GIR_EraseRootFromParent_Done,
     /* 2411564 */   // Label 34646: @2411564
     /* 2411564 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2411621), // Rule ID 65503 //
     /* 2411569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411603 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411620 */     // GIR_Coverage, 65503,
     /* 2411620 */     GIR_EraseRootFromParent_Done,
     /* 2411621 */   // Label 34647: @2411621
     /* 2411621 */   GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2411678), // Rule ID 65504 //
     /* 2411626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411660 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2411663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411677 */     // GIR_Coverage, 65504,
     /* 2411677 */     GIR_EraseRootFromParent_Done,
     /* 2411678 */   // Label 34648: @2411678
     /* 2411678 */   GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2411735), // Rule ID 65511 //
     /* 2411683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411717 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2411720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411734 */     // GIR_Coverage, 65511,
     /* 2411734 */     GIR_EraseRootFromParent_Done,
     /* 2411735 */   // Label 34649: @2411735
     /* 2411735 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2411792), // Rule ID 65515 //
     /* 2411740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2411743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411774 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411791 */     // GIR_Coverage, 65515,
     /* 2411791 */     GIR_EraseRootFromParent_Done,
     /* 2411792 */   // Label 34650: @2411792
     /* 2411792 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2411849), // Rule ID 65516 //
     /* 2411797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2411800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2411829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411831 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2411834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2411842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2411844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411848 */     // GIR_Coverage, 65516,
     /* 2411848 */     GIR_EraseRootFromParent_Done,
     /* 2411849 */   // Label 34651: @2411849
     /* 2411849 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2411906), // Rule ID 1641 //
     /* 2411854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2411857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411888 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2411888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2411891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2411901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411905 */     // GIR_Coverage, 1641,
     /* 2411905 */     GIR_EraseRootFromParent_Done,
     /* 2411906 */   // Label 34652: @2411906
     /* 2411906 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2411963), // Rule ID 1642 //
     /* 2411911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2411914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2411943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411945 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2411945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2411948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2411958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411962 */     // GIR_Coverage, 1642,
     /* 2411962 */     GIR_EraseRootFromParent_Done,
     /* 2411963 */   // Label 34653: @2411963
     /* 2411963 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2412020), // Rule ID 1669 //
     /* 2411968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2411971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2411983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412002 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2412005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412019 */     // GIR_Coverage, 1669,
     /* 2412019 */     GIR_EraseRootFromParent_Done,
     /* 2412020 */   // Label 34654: @2412020
     /* 2412020 */   GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2412077), // Rule ID 1696 //
     /* 2412025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2412028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412059 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2412062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412076 */     // GIR_Coverage, 1696,
     /* 2412076 */     GIR_EraseRootFromParent_Done,
     /* 2412077 */   // Label 34655: @2412077
     /* 2412077 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2412134), // Rule ID 1697 //
     /* 2412082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2412085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412116 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2412119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2412129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412133 */     // GIR_Coverage, 1697,
     /* 2412133 */     GIR_EraseRootFromParent_Done,
     /* 2412134 */   // Label 34656: @2412134
     /* 2412134 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2412174), // Rule ID 1637 //
     /* 2412139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2412142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412158 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2412161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412173 */     // GIR_Coverage, 1637,
     /* 2412173 */     GIR_EraseRootFromParent_Done,
     /* 2412174 */   // Label 34657: @2412174
     /* 2412174 */   GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2412214), // Rule ID 1638 //
     /* 2412179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2412182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2412198 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2412201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412213 */     // GIR_Coverage, 1638,
     /* 2412213 */     GIR_EraseRootFromParent_Done,
     /* 2412214 */   // Label 34658: @2412214
     /* 2412214 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2412254), // Rule ID 1667 //
     /* 2412219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2412222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412238 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2412241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412253 */     // GIR_Coverage, 1667,
     /* 2412253 */     GIR_EraseRootFromParent_Done,
     /* 2412254 */   // Label 34659: @2412254
     /* 2412254 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2412294), // Rule ID 1692 //
     /* 2412259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2412262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412278 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2412278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2412281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412293 */     // GIR_Coverage, 1692,
     /* 2412293 */     GIR_EraseRootFromParent_Done,
     /* 2412294 */   // Label 34660: @2412294
     /* 2412294 */   GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2412334), // Rule ID 1693 //
     /* 2412299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2412302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2412318 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2412318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2412321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2412329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412333 */     // GIR_Coverage, 1693,
     /* 2412333 */     GIR_EraseRootFromParent_Done,
     /* 2412334 */   // Label 34661: @2412334
     /* 2412334 */   GIM_Reject,
     /* 2412335 */ // Label 34631: @2412335
     /* 2412335 */ GIM_Reject,
     /* 2412336 */ // Label 34565: @2412336
     /* 2412336 */ GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2413125),
     /* 2412341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2412347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2412350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412354 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2412431), // Rule ID 54840 //
     /* 2412359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412402 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412430 */     // GIR_Coverage, 54840,
     /* 2412430 */     GIR_EraseRootFromParent_Done,
     /* 2412431 */   // Label 34663: @2412431
     /* 2412431 */   GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2412508), // Rule ID 54841 //
     /* 2412436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412479 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412507 */     // GIR_Coverage, 54841,
     /* 2412507 */     GIR_EraseRootFromParent_Done,
     /* 2412508 */   // Label 34664: @2412508
     /* 2412508 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2412585), // Rule ID 72491 //
     /* 2412513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412556 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412584 */     // GIR_Coverage, 72491,
     /* 2412584 */     GIR_EraseRootFromParent_Done,
     /* 2412585 */   // Label 34665: @2412585
     /* 2412585 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2412662), // Rule ID 72492 //
     /* 2412590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412633 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2412636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412661 */     // GIR_Coverage, 72492,
     /* 2412661 */     GIR_EraseRootFromParent_Done,
     /* 2412662 */   // Label 34666: @2412662
     /* 2412662 */   GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2412724), // Rule ID 54844 //
     /* 2412667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412697 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412723 */     // GIR_Coverage, 54844,
     /* 2412723 */     GIR_EraseRootFromParent_Done,
     /* 2412724 */   // Label 34667: @2412724
     /* 2412724 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2412786), // Rule ID 54845 //
     /* 2412729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412759 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412785 */     // GIR_Coverage, 54845,
     /* 2412785 */     GIR_EraseRootFromParent_Done,
     /* 2412786 */   // Label 34668: @2412786
     /* 2412786 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2412848), // Rule ID 72495 //
     /* 2412791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412821 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412847 */     // GIR_Coverage, 72495,
     /* 2412847 */     GIR_EraseRootFromParent_Done,
     /* 2412848 */   // Label 34669: @2412848
     /* 2412848 */   GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2412910), // Rule ID 72496 //
     /* 2412853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412883 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2412886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412909 */     // GIR_Coverage, 72496,
     /* 2412909 */     GIR_EraseRootFromParent_Done,
     /* 2412910 */   // Label 34670: @2412910
     /* 2412910 */   GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2412972), // Rule ID 54836 //
     /* 2412915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2412918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412945 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2412948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412971 */     // GIR_Coverage, 54836,
     /* 2412971 */     GIR_EraseRootFromParent_Done,
     /* 2412972 */   // Label 34671: @2412972
     /* 2412972 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2413034), // Rule ID 54837 //
     /* 2412977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2412980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2413000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413007 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2413010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413033 */     // GIR_Coverage, 54837,
     /* 2413033 */     GIR_EraseRootFromParent_Done,
     /* 2413034 */   // Label 34672: @2413034
     /* 2413034 */   GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2413079), // Rule ID 54832 //
     /* 2413039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413054 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2413057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413078 */     // GIR_Coverage, 54832,
     /* 2413078 */     GIR_EraseRootFromParent_Done,
     /* 2413079 */   // Label 34673: @2413079
     /* 2413079 */   GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2413124), // Rule ID 54833 //
     /* 2413084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413099 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2413102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413123 */     // GIR_Coverage, 54833,
     /* 2413123 */     GIR_EraseRootFromParent_Done,
     /* 2413124 */   // Label 34674: @2413124
     /* 2413124 */   GIM_Reject,
     /* 2413125 */ // Label 34662: @2413125
     /* 2413125 */ GIM_Reject,
     /* 2413126 */ // Label 34566: @2413126
     /* 2413126 */ GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2413915),
     /* 2413131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2413137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2413140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413144 */   GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2413221), // Rule ID 54968 //
     /* 2413149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413192 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413220 */     // GIR_Coverage, 54968,
     /* 2413220 */     GIR_EraseRootFromParent_Done,
     /* 2413221 */   // Label 34676: @2413221
     /* 2413221 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2413298), // Rule ID 54969 //
     /* 2413226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413269 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413297 */     // GIR_Coverage, 54969,
     /* 2413297 */     GIR_EraseRootFromParent_Done,
     /* 2413298 */   // Label 34677: @2413298
     /* 2413298 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2413375), // Rule ID 72603 //
     /* 2413303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413346 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413374 */     // GIR_Coverage, 72603,
     /* 2413374 */     GIR_EraseRootFromParent_Done,
     /* 2413375 */   // Label 34678: @2413375
     /* 2413375 */   GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2413452), // Rule ID 72604 //
     /* 2413380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413423 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2413426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413451 */     // GIR_Coverage, 72604,
     /* 2413451 */     GIR_EraseRootFromParent_Done,
     /* 2413452 */   // Label 34679: @2413452
     /* 2413452 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2413514), // Rule ID 54972 //
     /* 2413457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413487 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413513 */     // GIR_Coverage, 54972,
     /* 2413513 */     GIR_EraseRootFromParent_Done,
     /* 2413514 */   // Label 34680: @2413514
     /* 2413514 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2413576), // Rule ID 54973 //
     /* 2413519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413549 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413575 */     // GIR_Coverage, 54973,
     /* 2413575 */     GIR_EraseRootFromParent_Done,
     /* 2413576 */   // Label 34681: @2413576
     /* 2413576 */   GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2413638), // Rule ID 72607 //
     /* 2413581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413611 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413637 */     // GIR_Coverage, 72607,
     /* 2413637 */     GIR_EraseRootFromParent_Done,
     /* 2413638 */   // Label 34682: @2413638
     /* 2413638 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2413700), // Rule ID 72608 //
     /* 2413643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413673 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2413676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413699 */     // GIR_Coverage, 72608,
     /* 2413699 */     GIR_EraseRootFromParent_Done,
     /* 2413700 */   // Label 34683: @2413700
     /* 2413700 */   GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2413762), // Rule ID 54964 //
     /* 2413705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413735 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2413738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413761 */     // GIR_Coverage, 54964,
     /* 2413761 */     GIR_EraseRootFromParent_Done,
     /* 2413762 */   // Label 34684: @2413762
     /* 2413762 */   GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2413824), // Rule ID 54965 //
     /* 2413767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2413790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413797 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2413800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413823 */     // GIR_Coverage, 54965,
     /* 2413823 */     GIR_EraseRootFromParent_Done,
     /* 2413824 */   // Label 34685: @2413824
     /* 2413824 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2413869), // Rule ID 54960 //
     /* 2413829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2413832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413844 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2413847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413868 */     // GIR_Coverage, 54960,
     /* 2413868 */     GIR_EraseRootFromParent_Done,
     /* 2413869 */   // Label 34686: @2413869
     /* 2413869 */   GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2413914), // Rule ID 54961 //
     /* 2413874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2413877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413889 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2413892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413913 */     // GIR_Coverage, 54961,
     /* 2413913 */     GIR_EraseRootFromParent_Done,
     /* 2413914 */   // Label 34687: @2413914
     /* 2413914 */   GIM_Reject,
     /* 2413915 */ // Label 34675: @2413915
     /* 2413915 */ GIM_Reject,
     /* 2413916 */ // Label 34567: @2413916
     /* 2413916 */ GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2414705),
     /* 2413921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2413927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2413930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413934 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2414011), // Rule ID 55160 //
     /* 2413939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413982 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2413985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414010 */     // GIR_Coverage, 55160,
     /* 2414010 */     GIR_EraseRootFromParent_Done,
     /* 2414011 */   // Label 34689: @2414011
     /* 2414011 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2414088), // Rule ID 55161 //
     /* 2414016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414059 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414087 */     // GIR_Coverage, 55161,
     /* 2414087 */     GIR_EraseRootFromParent_Done,
     /* 2414088 */   // Label 34690: @2414088
     /* 2414088 */   GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2414165), // Rule ID 72771 //
     /* 2414093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414136 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414164 */     // GIR_Coverage, 72771,
     /* 2414164 */     GIR_EraseRootFromParent_Done,
     /* 2414165 */   // Label 34691: @2414165
     /* 2414165 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2414242), // Rule ID 72772 //
     /* 2414170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414213 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2414216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414241 */     // GIR_Coverage, 72772,
     /* 2414241 */     GIR_EraseRootFromParent_Done,
     /* 2414242 */   // Label 34692: @2414242
     /* 2414242 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2414304), // Rule ID 55164 //
     /* 2414247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414277 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414303 */     // GIR_Coverage, 55164,
     /* 2414303 */     GIR_EraseRootFromParent_Done,
     /* 2414304 */   // Label 34693: @2414304
     /* 2414304 */   GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2414366), // Rule ID 55165 //
     /* 2414309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414339 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414365 */     // GIR_Coverage, 55165,
     /* 2414365 */     GIR_EraseRootFromParent_Done,
     /* 2414366 */   // Label 34694: @2414366
     /* 2414366 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2414428), // Rule ID 72775 //
     /* 2414371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414401 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414427 */     // GIR_Coverage, 72775,
     /* 2414427 */     GIR_EraseRootFromParent_Done,
     /* 2414428 */   // Label 34695: @2414428
     /* 2414428 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2414490), // Rule ID 72776 //
     /* 2414433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414463 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2414466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414489 */     // GIR_Coverage, 72776,
     /* 2414489 */     GIR_EraseRootFromParent_Done,
     /* 2414490 */   // Label 34696: @2414490
     /* 2414490 */   GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2414552), // Rule ID 55156 //
     /* 2414495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414525 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2414528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414551 */     // GIR_Coverage, 55156,
     /* 2414551 */     GIR_EraseRootFromParent_Done,
     /* 2414552 */   // Label 34697: @2414552
     /* 2414552 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2414614), // Rule ID 55157 //
     /* 2414557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2414580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414587 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2414590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414613 */     // GIR_Coverage, 55157,
     /* 2414613 */     GIR_EraseRootFromParent_Done,
     /* 2414614 */   // Label 34698: @2414614
     /* 2414614 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2414659), // Rule ID 55152 //
     /* 2414619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414634 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2414637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414658 */     // GIR_Coverage, 55152,
     /* 2414658 */     GIR_EraseRootFromParent_Done,
     /* 2414659 */   // Label 34699: @2414659
     /* 2414659 */   GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2414704), // Rule ID 55153 //
     /* 2414664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414679 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2414682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414703 */     // GIR_Coverage, 55153,
     /* 2414703 */     GIR_EraseRootFromParent_Done,
     /* 2414704 */   // Label 34700: @2414704
     /* 2414704 */   GIM_Reject,
     /* 2414705 */ // Label 34688: @2414705
     /* 2414705 */ GIM_Reject,
     /* 2414706 */ // Label 34568: @2414706
     /* 2414706 */ GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2415495),
     /* 2414711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2414717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2414720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414724 */   GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2414801), // Rule ID 54904 //
     /* 2414729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414772 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414800 */     // GIR_Coverage, 54904,
     /* 2414800 */     GIR_EraseRootFromParent_Done,
     /* 2414801 */   // Label 34702: @2414801
     /* 2414801 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2414878), // Rule ID 54905 //
     /* 2414806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414849 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414877 */     // GIR_Coverage, 54905,
     /* 2414877 */     GIR_EraseRootFromParent_Done,
     /* 2414878 */   // Label 34703: @2414878
     /* 2414878 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2414955), // Rule ID 72547 //
     /* 2414883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414926 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2414929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414954 */     // GIR_Coverage, 72547,
     /* 2414954 */     GIR_EraseRootFromParent_Done,
     /* 2414955 */   // Label 34704: @2414955
     /* 2414955 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2415032), // Rule ID 72548 //
     /* 2414960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415003 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2415006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415031 */     // GIR_Coverage, 72548,
     /* 2415031 */     GIR_EraseRootFromParent_Done,
     /* 2415032 */   // Label 34705: @2415032
     /* 2415032 */   GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2415094), // Rule ID 54908 //
     /* 2415037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415067 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415093 */     // GIR_Coverage, 54908,
     /* 2415093 */     GIR_EraseRootFromParent_Done,
     /* 2415094 */   // Label 34706: @2415094
     /* 2415094 */   GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2415156), // Rule ID 54909 //
     /* 2415099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415129 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415155 */     // GIR_Coverage, 54909,
     /* 2415155 */     GIR_EraseRootFromParent_Done,
     /* 2415156 */   // Label 34707: @2415156
     /* 2415156 */   GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2415218), // Rule ID 72551 //
     /* 2415161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415191 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415217 */     // GIR_Coverage, 72551,
     /* 2415217 */     GIR_EraseRootFromParent_Done,
     /* 2415218 */   // Label 34708: @2415218
     /* 2415218 */   GIM_Try, /*On fail goto*//*Label 34709*/ GIMT_Encode4(2415280), // Rule ID 72552 //
     /* 2415223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415253 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2415256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415279 */     // GIR_Coverage, 72552,
     /* 2415279 */     GIR_EraseRootFromParent_Done,
     /* 2415280 */   // Label 34709: @2415280
     /* 2415280 */   GIM_Try, /*On fail goto*//*Label 34710*/ GIMT_Encode4(2415342), // Rule ID 54900 //
     /* 2415285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415315 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2415318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415341 */     // GIR_Coverage, 54900,
     /* 2415341 */     GIR_EraseRootFromParent_Done,
     /* 2415342 */   // Label 34710: @2415342
     /* 2415342 */   GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2415404), // Rule ID 54901 //
     /* 2415347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2415370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415377 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2415380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415403 */     // GIR_Coverage, 54901,
     /* 2415403 */     GIR_EraseRootFromParent_Done,
     /* 2415404 */   // Label 34711: @2415404
     /* 2415404 */   GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2415449), // Rule ID 54896 //
     /* 2415409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415424 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2415427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415448 */     // GIR_Coverage, 54896,
     /* 2415448 */     GIR_EraseRootFromParent_Done,
     /* 2415449 */   // Label 34712: @2415449
     /* 2415449 */   GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2415494), // Rule ID 54897 //
     /* 2415454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415469 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2415472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415493 */     // GIR_Coverage, 54897,
     /* 2415493 */     GIR_EraseRootFromParent_Done,
     /* 2415494 */   // Label 34713: @2415494
     /* 2415494 */   GIM_Reject,
     /* 2415495 */ // Label 34701: @2415495
     /* 2415495 */ GIM_Reject,
     /* 2415496 */ // Label 34569: @2415496
     /* 2415496 */ GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2416285),
     /* 2415501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2415507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2415510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415514 */   GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2415591), // Rule ID 55096 //
     /* 2415519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415562 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415590 */     // GIR_Coverage, 55096,
     /* 2415590 */     GIR_EraseRootFromParent_Done,
     /* 2415591 */   // Label 34715: @2415591
     /* 2415591 */   GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2415668), // Rule ID 55097 //
     /* 2415596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415639 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415667 */     // GIR_Coverage, 55097,
     /* 2415667 */     GIR_EraseRootFromParent_Done,
     /* 2415668 */   // Label 34716: @2415668
     /* 2415668 */   GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2415745), // Rule ID 72715 //
     /* 2415673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415716 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415744 */     // GIR_Coverage, 72715,
     /* 2415744 */     GIR_EraseRootFromParent_Done,
     /* 2415745 */   // Label 34717: @2415745
     /* 2415745 */   GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2415822), // Rule ID 72716 //
     /* 2415750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415793 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2415796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415821 */     // GIR_Coverage, 72716,
     /* 2415821 */     GIR_EraseRootFromParent_Done,
     /* 2415822 */   // Label 34718: @2415822
     /* 2415822 */   GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2415884), // Rule ID 55100 //
     /* 2415827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415857 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415883 */     // GIR_Coverage, 55100,
     /* 2415883 */     GIR_EraseRootFromParent_Done,
     /* 2415884 */   // Label 34719: @2415884
     /* 2415884 */   GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2415946), // Rule ID 55101 //
     /* 2415889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2415892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415919 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415945 */     // GIR_Coverage, 55101,
     /* 2415945 */     GIR_EraseRootFromParent_Done,
     /* 2415946 */   // Label 34720: @2415946
     /* 2415946 */   GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2416008), // Rule ID 72719 //
     /* 2415951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2415954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2415970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415981 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2415984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416007 */     // GIR_Coverage, 72719,
     /* 2416007 */     GIR_EraseRootFromParent_Done,
     /* 2416008 */   // Label 34721: @2416008
     /* 2416008 */   GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2416070), // Rule ID 72720 //
     /* 2416013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416043 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2416046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416069 */     // GIR_Coverage, 72720,
     /* 2416069 */     GIR_EraseRootFromParent_Done,
     /* 2416070 */   // Label 34722: @2416070
     /* 2416070 */   GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2416132), // Rule ID 55092 //
     /* 2416075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416105 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2416108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416131 */     // GIR_Coverage, 55092,
     /* 2416131 */     GIR_EraseRootFromParent_Done,
     /* 2416132 */   // Label 34723: @2416132
     /* 2416132 */   GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2416194), // Rule ID 55093 //
     /* 2416137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2416160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416167 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2416170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416193 */     // GIR_Coverage, 55093,
     /* 2416193 */     GIR_EraseRootFromParent_Done,
     /* 2416194 */   // Label 34724: @2416194
     /* 2416194 */   GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2416239), // Rule ID 55088 //
     /* 2416199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416214 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2416217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416238 */     // GIR_Coverage, 55088,
     /* 2416238 */     GIR_EraseRootFromParent_Done,
     /* 2416239 */   // Label 34725: @2416239
     /* 2416239 */   GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2416284), // Rule ID 55089 //
     /* 2416244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416259 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2416262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416283 */     // GIR_Coverage, 55089,
     /* 2416283 */     GIR_EraseRootFromParent_Done,
     /* 2416284 */   // Label 34726: @2416284
     /* 2416284 */   GIM_Reject,
     /* 2416285 */ // Label 34714: @2416285
     /* 2416285 */ GIM_Reject,
     /* 2416286 */ // Label 34570: @2416286
     /* 2416286 */ GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2417075),
     /* 2416291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2416297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2416300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416304 */   GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2416381), // Rule ID 55608 //
     /* 2416309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416352 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416380 */     // GIR_Coverage, 55608,
     /* 2416380 */     GIR_EraseRootFromParent_Done,
     /* 2416381 */   // Label 34728: @2416381
     /* 2416381 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2416458), // Rule ID 55609 //
     /* 2416386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416429 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416457 */     // GIR_Coverage, 55609,
     /* 2416457 */     GIR_EraseRootFromParent_Done,
     /* 2416458 */   // Label 34729: @2416458
     /* 2416458 */   GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2416535), // Rule ID 73163 //
     /* 2416463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416506 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416534 */     // GIR_Coverage, 73163,
     /* 2416534 */     GIR_EraseRootFromParent_Done,
     /* 2416535 */   // Label 34730: @2416535
     /* 2416535 */   GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2416612), // Rule ID 73164 //
     /* 2416540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416583 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2416586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416611 */     // GIR_Coverage, 73164,
     /* 2416611 */     GIR_EraseRootFromParent_Done,
     /* 2416612 */   // Label 34731: @2416612
     /* 2416612 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2416674), // Rule ID 55612 //
     /* 2416617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416647 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416673 */     // GIR_Coverage, 55612,
     /* 2416673 */     GIR_EraseRootFromParent_Done,
     /* 2416674 */   // Label 34732: @2416674
     /* 2416674 */   GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2416736), // Rule ID 55613 //
     /* 2416679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416709 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416735 */     // GIR_Coverage, 55613,
     /* 2416735 */     GIR_EraseRootFromParent_Done,
     /* 2416736 */   // Label 34733: @2416736
     /* 2416736 */   GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2416798), // Rule ID 73167 //
     /* 2416741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416771 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416797 */     // GIR_Coverage, 73167,
     /* 2416797 */     GIR_EraseRootFromParent_Done,
     /* 2416798 */   // Label 34734: @2416798
     /* 2416798 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2416860), // Rule ID 73168 //
     /* 2416803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416833 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2416836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416859 */     // GIR_Coverage, 73168,
     /* 2416859 */     GIR_EraseRootFromParent_Done,
     /* 2416860 */   // Label 34735: @2416860
     /* 2416860 */   GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2416922), // Rule ID 55604 //
     /* 2416865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416895 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2416898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416921 */     // GIR_Coverage, 55604,
     /* 2416921 */     GIR_EraseRootFromParent_Done,
     /* 2416922 */   // Label 34736: @2416922
     /* 2416922 */   GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2416984), // Rule ID 55605 //
     /* 2416927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2416930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2416950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416957 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2416960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416983 */     // GIR_Coverage, 55605,
     /* 2416983 */     GIR_EraseRootFromParent_Done,
     /* 2416984 */   // Label 34737: @2416984
     /* 2416984 */   GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2417029), // Rule ID 55600 //
     /* 2416989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2416992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417004 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2417007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417028 */     // GIR_Coverage, 55600,
     /* 2417028 */     GIR_EraseRootFromParent_Done,
     /* 2417029 */   // Label 34738: @2417029
     /* 2417029 */   GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2417074), // Rule ID 55601 //
     /* 2417034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2417037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417049 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2417052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417073 */     // GIR_Coverage, 55601,
     /* 2417073 */     GIR_EraseRootFromParent_Done,
     /* 2417074 */   // Label 34739: @2417074
     /* 2417074 */   GIM_Reject,
     /* 2417075 */ // Label 34727: @2417075
     /* 2417075 */ GIM_Reject,
     /* 2417076 */ // Label 34571: @2417076
     /* 2417076 */ GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2417865),
     /* 2417081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2417087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2417090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417094 */   GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2417171), // Rule ID 55032 //
     /* 2417099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417142 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417170 */     // GIR_Coverage, 55032,
     /* 2417170 */     GIR_EraseRootFromParent_Done,
     /* 2417171 */   // Label 34741: @2417171
     /* 2417171 */   GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2417248), // Rule ID 55033 //
     /* 2417176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417219 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417247 */     // GIR_Coverage, 55033,
     /* 2417247 */     GIR_EraseRootFromParent_Done,
     /* 2417248 */   // Label 34742: @2417248
     /* 2417248 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2417325), // Rule ID 72659 //
     /* 2417253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417296 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417324 */     // GIR_Coverage, 72659,
     /* 2417324 */     GIR_EraseRootFromParent_Done,
     /* 2417325 */   // Label 34743: @2417325
     /* 2417325 */   GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2417402), // Rule ID 72660 //
     /* 2417330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417373 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2417376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417401 */     // GIR_Coverage, 72660,
     /* 2417401 */     GIR_EraseRootFromParent_Done,
     /* 2417402 */   // Label 34744: @2417402
     /* 2417402 */   GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2417464), // Rule ID 55036 //
     /* 2417407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417437 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417463 */     // GIR_Coverage, 55036,
     /* 2417463 */     GIR_EraseRootFromParent_Done,
     /* 2417464 */   // Label 34745: @2417464
     /* 2417464 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2417526), // Rule ID 55037 //
     /* 2417469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417499 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417525 */     // GIR_Coverage, 55037,
     /* 2417525 */     GIR_EraseRootFromParent_Done,
     /* 2417526 */   // Label 34746: @2417526
     /* 2417526 */   GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2417588), // Rule ID 72663 //
     /* 2417531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417561 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417587 */     // GIR_Coverage, 72663,
     /* 2417587 */     GIR_EraseRootFromParent_Done,
     /* 2417588 */   // Label 34747: @2417588
     /* 2417588 */   GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2417650), // Rule ID 72664 //
     /* 2417593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417623 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2417626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417649 */     // GIR_Coverage, 72664,
     /* 2417649 */     GIR_EraseRootFromParent_Done,
     /* 2417650 */   // Label 34748: @2417650
     /* 2417650 */   GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2417712), // Rule ID 55028 //
     /* 2417655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417685 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2417688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417711 */     // GIR_Coverage, 55028,
     /* 2417711 */     GIR_EraseRootFromParent_Done,
     /* 2417712 */   // Label 34749: @2417712
     /* 2417712 */   GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2417774), // Rule ID 55029 //
     /* 2417717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2417740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417747 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2417750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417773 */     // GIR_Coverage, 55029,
     /* 2417773 */     GIR_EraseRootFromParent_Done,
     /* 2417774 */   // Label 34750: @2417774
     /* 2417774 */   GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2417819), // Rule ID 55024 //
     /* 2417779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417794 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2417797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417818 */     // GIR_Coverage, 55024,
     /* 2417818 */     GIR_EraseRootFromParent_Done,
     /* 2417819 */   // Label 34751: @2417819
     /* 2417819 */   GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2417864), // Rule ID 55025 //
     /* 2417824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417839 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2417842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417863 */     // GIR_Coverage, 55025,
     /* 2417863 */     GIR_EraseRootFromParent_Done,
     /* 2417864 */   // Label 34752: @2417864
     /* 2417864 */   GIM_Reject,
     /* 2417865 */ // Label 34740: @2417865
     /* 2417865 */ GIM_Reject,
     /* 2417866 */ // Label 34572: @2417866
     /* 2417866 */ GIM_Try, /*On fail goto*//*Label 34753*/ GIMT_Encode4(2418655),
     /* 2417871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2417877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2417880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417884 */   GIM_Try, /*On fail goto*//*Label 34754*/ GIMT_Encode4(2417961), // Rule ID 55416 //
     /* 2417889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417932 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2417935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417960 */     // GIR_Coverage, 55416,
     /* 2417960 */     GIR_EraseRootFromParent_Done,
     /* 2417961 */   // Label 34754: @2417961
     /* 2417961 */   GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2418038), // Rule ID 55417 //
     /* 2417966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418009 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418037 */     // GIR_Coverage, 55417,
     /* 2418037 */     GIR_EraseRootFromParent_Done,
     /* 2418038 */   // Label 34755: @2418038
     /* 2418038 */   GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2418115), // Rule ID 72995 //
     /* 2418043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418086 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418114 */     // GIR_Coverage, 72995,
     /* 2418114 */     GIR_EraseRootFromParent_Done,
     /* 2418115 */   // Label 34756: @2418115
     /* 2418115 */   GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2418192), // Rule ID 72996 //
     /* 2418120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418163 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2418166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418191 */     // GIR_Coverage, 72996,
     /* 2418191 */     GIR_EraseRootFromParent_Done,
     /* 2418192 */   // Label 34757: @2418192
     /* 2418192 */   GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2418254), // Rule ID 55420 //
     /* 2418197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418227 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418253 */     // GIR_Coverage, 55420,
     /* 2418253 */     GIR_EraseRootFromParent_Done,
     /* 2418254 */   // Label 34758: @2418254
     /* 2418254 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2418316), // Rule ID 55421 //
     /* 2418259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418289 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418315 */     // GIR_Coverage, 55421,
     /* 2418315 */     GIR_EraseRootFromParent_Done,
     /* 2418316 */   // Label 34759: @2418316
     /* 2418316 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2418378), // Rule ID 72999 //
     /* 2418321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418351 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418377 */     // GIR_Coverage, 72999,
     /* 2418377 */     GIR_EraseRootFromParent_Done,
     /* 2418378 */   // Label 34760: @2418378
     /* 2418378 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2418440), // Rule ID 73000 //
     /* 2418383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418413 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2418416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418439 */     // GIR_Coverage, 73000,
     /* 2418439 */     GIR_EraseRootFromParent_Done,
     /* 2418440 */   // Label 34761: @2418440
     /* 2418440 */   GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2418502), // Rule ID 55412 //
     /* 2418445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418475 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2418478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418501 */     // GIR_Coverage, 55412,
     /* 2418501 */     GIR_EraseRootFromParent_Done,
     /* 2418502 */   // Label 34762: @2418502
     /* 2418502 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2418564), // Rule ID 55413 //
     /* 2418507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2418530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418537 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2418540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2418550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418563 */     // GIR_Coverage, 55413,
     /* 2418563 */     GIR_EraseRootFromParent_Done,
     /* 2418564 */   // Label 34763: @2418564
     /* 2418564 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2418609), // Rule ID 55408 //
     /* 2418569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418584 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2418587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418608 */     // GIR_Coverage, 55408,
     /* 2418608 */     GIR_EraseRootFromParent_Done,
     /* 2418609 */   // Label 34764: @2418609
     /* 2418609 */   GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2418654), // Rule ID 55409 //
     /* 2418614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418629 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2418632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418653 */     // GIR_Coverage, 55409,
     /* 2418653 */     GIR_EraseRootFromParent_Done,
     /* 2418654 */   // Label 34765: @2418654
     /* 2418654 */   GIM_Reject,
     /* 2418655 */ // Label 34753: @2418655
     /* 2418655 */ GIM_Reject,
     /* 2418656 */ // Label 34573: @2418656
     /* 2418656 */ GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2419445),
     /* 2418661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2418667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2418670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418674 */   GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2418751), // Rule ID 55672 //
     /* 2418679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418722 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418750 */     // GIR_Coverage, 55672,
     /* 2418750 */     GIR_EraseRootFromParent_Done,
     /* 2418751 */   // Label 34767: @2418751
     /* 2418751 */   GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2418828), // Rule ID 55673 //
     /* 2418756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2418759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418799 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418827 */     // GIR_Coverage, 55673,
     /* 2418827 */     GIR_EraseRootFromParent_Done,
     /* 2418828 */   // Label 34768: @2418828
     /* 2418828 */   GIM_Try, /*On fail goto*//*Label 34769*/ GIMT_Encode4(2418905), // Rule ID 73219 //
     /* 2418833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418876 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2418876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418904 */     // GIR_Coverage, 73219,
     /* 2418904 */     GIR_EraseRootFromParent_Done,
     /* 2418905 */   // Label 34769: @2418905
     /* 2418905 */   GIM_Try, /*On fail goto*//*Label 34770*/ GIMT_Encode4(2418982), // Rule ID 73220 //
     /* 2418910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2418913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2418921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2418938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2418946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2418953 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2418956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2418964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2418968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418981 */     // GIR_Coverage, 73220,
     /* 2418981 */     GIR_EraseRootFromParent_Done,
     /* 2418982 */   // Label 34770: @2418982
     /* 2418982 */   GIM_Try, /*On fail goto*//*Label 34771*/ GIMT_Encode4(2419044), // Rule ID 55676 //
     /* 2418987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2418994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2418998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419017 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419043 */     // GIR_Coverage, 55676,
     /* 2419043 */     GIR_EraseRootFromParent_Done,
     /* 2419044 */   // Label 34771: @2419044
     /* 2419044 */   GIM_Try, /*On fail goto*//*Label 34772*/ GIMT_Encode4(2419106), // Rule ID 55677 //
     /* 2419049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419079 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419105 */     // GIR_Coverage, 55677,
     /* 2419105 */     GIR_EraseRootFromParent_Done,
     /* 2419106 */   // Label 34772: @2419106
     /* 2419106 */   GIM_Try, /*On fail goto*//*Label 34773*/ GIMT_Encode4(2419168), // Rule ID 73223 //
     /* 2419111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419141 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419167 */     // GIR_Coverage, 73223,
     /* 2419167 */     GIR_EraseRootFromParent_Done,
     /* 2419168 */   // Label 34773: @2419168
     /* 2419168 */   GIM_Try, /*On fail goto*//*Label 34774*/ GIMT_Encode4(2419230), // Rule ID 73224 //
     /* 2419173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419203 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2419206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419229 */     // GIR_Coverage, 73224,
     /* 2419229 */     GIR_EraseRootFromParent_Done,
     /* 2419230 */   // Label 34774: @2419230
     /* 2419230 */   GIM_Try, /*On fail goto*//*Label 34775*/ GIMT_Encode4(2419292), // Rule ID 55668 //
     /* 2419235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419265 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2419268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419291 */     // GIR_Coverage, 55668,
     /* 2419291 */     GIR_EraseRootFromParent_Done,
     /* 2419292 */   // Label 34775: @2419292
     /* 2419292 */   GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2419354), // Rule ID 55669 //
     /* 2419297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419327 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2419330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2419340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419353 */     // GIR_Coverage, 55669,
     /* 2419353 */     GIR_EraseRootFromParent_Done,
     /* 2419354 */   // Label 34776: @2419354
     /* 2419354 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2419399), // Rule ID 55664 //
     /* 2419359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419374 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2419377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419398 */     // GIR_Coverage, 55664,
     /* 2419398 */     GIR_EraseRootFromParent_Done,
     /* 2419399 */   // Label 34777: @2419399
     /* 2419399 */   GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2419444), // Rule ID 55665 //
     /* 2419404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419419 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2419422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2419428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419443 */     // GIR_Coverage, 55665,
     /* 2419443 */     GIR_EraseRootFromParent_Done,
     /* 2419444 */   // Label 34778: @2419444
     /* 2419444 */   GIM_Reject,
     /* 2419445 */ // Label 34766: @2419445
     /* 2419445 */ GIM_Reject,
     /* 2419446 */ // Label 34574: @2419446
     /* 2419446 */ GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2420235),
     /* 2419451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2419457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2419460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419464 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2419541), // Rule ID 55224 //
     /* 2419469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419512 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419540 */     // GIR_Coverage, 55224,
     /* 2419540 */     GIR_EraseRootFromParent_Done,
     /* 2419541 */   // Label 34780: @2419541
     /* 2419541 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2419618), // Rule ID 55225 //
     /* 2419546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419589 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419617 */     // GIR_Coverage, 55225,
     /* 2419617 */     GIR_EraseRootFromParent_Done,
     /* 2419618 */   // Label 34781: @2419618
     /* 2419618 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2419695), // Rule ID 72827 //
     /* 2419623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419666 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419694 */     // GIR_Coverage, 72827,
     /* 2419694 */     GIR_EraseRootFromParent_Done,
     /* 2419695 */   // Label 34782: @2419695
     /* 2419695 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2419772), // Rule ID 72828 //
     /* 2419700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2419728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2419743 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2419746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2419758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419771 */     // GIR_Coverage, 72828,
     /* 2419771 */     GIR_EraseRootFromParent_Done,
     /* 2419772 */   // Label 34783: @2419772
     /* 2419772 */   GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2419834), // Rule ID 55228 //
     /* 2419777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419807 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419833 */     // GIR_Coverage, 55228,
     /* 2419833 */     GIR_EraseRootFromParent_Done,
     /* 2419834 */   // Label 34784: @2419834
     /* 2419834 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2419896), // Rule ID 55229 //
     /* 2419839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2419846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419869 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2419876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419895 */     // GIR_Coverage, 55229,
     /* 2419895 */     GIR_EraseRootFromParent_Done,
     /* 2419896 */   // Label 34785: @2419896
     /* 2419896 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2419958), // Rule ID 72831 //
     /* 2419901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419931 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2419931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2419942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2419956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419957 */     // GIR_Coverage, 72831,
     /* 2419957 */     GIR_EraseRootFromParent_Done,
     /* 2419958 */   // Label 34786: @2419958
     /* 2419958 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2420020), // Rule ID 72832 //
     /* 2419963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2419974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2419978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419993 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2419993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2419996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420019 */     // GIR_Coverage, 72832,
     /* 2420019 */     GIR_EraseRootFromParent_Done,
     /* 2420020 */   // Label 34787: @2420020
     /* 2420020 */   GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2420082), // Rule ID 55220 //
     /* 2420025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2420048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420055 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2420058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420081 */     // GIR_Coverage, 55220,
     /* 2420081 */     GIR_EraseRootFromParent_Done,
     /* 2420082 */   // Label 34788: @2420082
     /* 2420082 */   GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2420144), // Rule ID 55221 //
     /* 2420087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2420110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420117 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2420120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420143 */     // GIR_Coverage, 55221,
     /* 2420143 */     GIR_EraseRootFromParent_Done,
     /* 2420144 */   // Label 34789: @2420144
     /* 2420144 */   GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2420189), // Rule ID 55216 //
     /* 2420149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420164 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2420167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420188 */     // GIR_Coverage, 55216,
     /* 2420188 */     GIR_EraseRootFromParent_Done,
     /* 2420189 */   // Label 34790: @2420189
     /* 2420189 */   GIM_Try, /*On fail goto*//*Label 34791*/ GIMT_Encode4(2420234), // Rule ID 55217 //
     /* 2420194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420209 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2420212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420233 */     // GIR_Coverage, 55217,
     /* 2420233 */     GIR_EraseRootFromParent_Done,
     /* 2420234 */   // Label 34791: @2420234
     /* 2420234 */   GIM_Reject,
     /* 2420235 */ // Label 34779: @2420235
     /* 2420235 */ GIM_Reject,
     /* 2420236 */ // Label 34575: @2420236
     /* 2420236 */ GIM_Try, /*On fail goto*//*Label 34792*/ GIMT_Encode4(2421025),
     /* 2420241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2420247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2420250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420254 */   GIM_Try, /*On fail goto*//*Label 34793*/ GIMT_Encode4(2420331), // Rule ID 55480 //
     /* 2420259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420302 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420330 */     // GIR_Coverage, 55480,
     /* 2420330 */     GIR_EraseRootFromParent_Done,
     /* 2420331 */   // Label 34793: @2420331
     /* 2420331 */   GIM_Try, /*On fail goto*//*Label 34794*/ GIMT_Encode4(2420408), // Rule ID 55481 //
     /* 2420336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420379 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420407 */     // GIR_Coverage, 55481,
     /* 2420407 */     GIR_EraseRootFromParent_Done,
     /* 2420408 */   // Label 34794: @2420408
     /* 2420408 */   GIM_Try, /*On fail goto*//*Label 34795*/ GIMT_Encode4(2420485), // Rule ID 73051 //
     /* 2420413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420456 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420484 */     // GIR_Coverage, 73051,
     /* 2420484 */     GIR_EraseRootFromParent_Done,
     /* 2420485 */   // Label 34795: @2420485
     /* 2420485 */   GIM_Try, /*On fail goto*//*Label 34796*/ GIMT_Encode4(2420562), // Rule ID 73052 //
     /* 2420490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2420518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2420533 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2420536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2420548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420561 */     // GIR_Coverage, 73052,
     /* 2420561 */     GIR_EraseRootFromParent_Done,
     /* 2420562 */   // Label 34796: @2420562
     /* 2420562 */   GIM_Try, /*On fail goto*//*Label 34797*/ GIMT_Encode4(2420624), // Rule ID 55484 //
     /* 2420567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420597 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420623 */     // GIR_Coverage, 55484,
     /* 2420623 */     GIR_EraseRootFromParent_Done,
     /* 2420624 */   // Label 34797: @2420624
     /* 2420624 */   GIM_Try, /*On fail goto*//*Label 34798*/ GIMT_Encode4(2420686), // Rule ID 55485 //
     /* 2420629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2420636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420659 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420685 */     // GIR_Coverage, 55485,
     /* 2420685 */     GIR_EraseRootFromParent_Done,
     /* 2420686 */   // Label 34798: @2420686
     /* 2420686 */   GIM_Try, /*On fail goto*//*Label 34799*/ GIMT_Encode4(2420748), // Rule ID 73055 //
     /* 2420691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420721 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420747 */     // GIR_Coverage, 73055,
     /* 2420747 */     GIR_EraseRootFromParent_Done,
     /* 2420748 */   // Label 34799: @2420748
     /* 2420748 */   GIM_Try, /*On fail goto*//*Label 34800*/ GIMT_Encode4(2420810), // Rule ID 73056 //
     /* 2420753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2420764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420783 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2420786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2420794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420809 */     // GIR_Coverage, 73056,
     /* 2420809 */     GIR_EraseRootFromParent_Done,
     /* 2420810 */   // Label 34800: @2420810
     /* 2420810 */   GIM_Try, /*On fail goto*//*Label 34801*/ GIMT_Encode4(2420872), // Rule ID 55476 //
     /* 2420815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420845 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2420848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420871 */     // GIR_Coverage, 55476,
     /* 2420871 */     GIR_EraseRootFromParent_Done,
     /* 2420872 */   // Label 34801: @2420872
     /* 2420872 */   GIM_Try, /*On fail goto*//*Label 34802*/ GIMT_Encode4(2420934), // Rule ID 55477 //
     /* 2420877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2420896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2420900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420907 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2420910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2420920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420933 */     // GIR_Coverage, 55477,
     /* 2420933 */     GIR_EraseRootFromParent_Done,
     /* 2420934 */   // Label 34802: @2420934
     /* 2420934 */   GIM_Try, /*On fail goto*//*Label 34803*/ GIMT_Encode4(2420979), // Rule ID 55472 //
     /* 2420939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420954 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2420954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2420957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2420961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2420963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2420977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420978 */     // GIR_Coverage, 55472,
     /* 2420978 */     GIR_EraseRootFromParent_Done,
     /* 2420979 */   // Label 34803: @2420979
     /* 2420979 */   GIM_Try, /*On fail goto*//*Label 34804*/ GIMT_Encode4(2421024), // Rule ID 55473 //
     /* 2420984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420999 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2420999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2421002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421023 */     // GIR_Coverage, 55473,
     /* 2421023 */     GIR_EraseRootFromParent_Done,
     /* 2421024 */   // Label 34804: @2421024
     /* 2421024 */   GIM_Reject,
     /* 2421025 */ // Label 34792: @2421025
     /* 2421025 */ GIM_Reject,
     /* 2421026 */ // Label 34576: @2421026
     /* 2421026 */ GIM_Try, /*On fail goto*//*Label 34805*/ GIMT_Encode4(2421815),
     /* 2421031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2421037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2421040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421044 */   GIM_Try, /*On fail goto*//*Label 34806*/ GIMT_Encode4(2421121), // Rule ID 55736 //
     /* 2421049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421092 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421120 */     // GIR_Coverage, 55736,
     /* 2421120 */     GIR_EraseRootFromParent_Done,
     /* 2421121 */   // Label 34806: @2421121
     /* 2421121 */   GIM_Try, /*On fail goto*//*Label 34807*/ GIMT_Encode4(2421198), // Rule ID 55737 //
     /* 2421126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421169 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421197 */     // GIR_Coverage, 55737,
     /* 2421197 */     GIR_EraseRootFromParent_Done,
     /* 2421198 */   // Label 34807: @2421198
     /* 2421198 */   GIM_Try, /*On fail goto*//*Label 34808*/ GIMT_Encode4(2421275), // Rule ID 73275 //
     /* 2421203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421246 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421274 */     // GIR_Coverage, 73275,
     /* 2421274 */     GIR_EraseRootFromParent_Done,
     /* 2421275 */   // Label 34808: @2421275
     /* 2421275 */   GIM_Try, /*On fail goto*//*Label 34809*/ GIMT_Encode4(2421352), // Rule ID 73276 //
     /* 2421280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421323 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2421326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421351 */     // GIR_Coverage, 73276,
     /* 2421351 */     GIR_EraseRootFromParent_Done,
     /* 2421352 */   // Label 34809: @2421352
     /* 2421352 */   GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2421414), // Rule ID 55740 //
     /* 2421357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421387 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421413 */     // GIR_Coverage, 55740,
     /* 2421413 */     GIR_EraseRootFromParent_Done,
     /* 2421414 */   // Label 34810: @2421414
     /* 2421414 */   GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2421476), // Rule ID 55741 //
     /* 2421419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421449 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421475 */     // GIR_Coverage, 55741,
     /* 2421475 */     GIR_EraseRootFromParent_Done,
     /* 2421476 */   // Label 34811: @2421476
     /* 2421476 */   GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2421538), // Rule ID 73279 //
     /* 2421481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421511 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421537 */     // GIR_Coverage, 73279,
     /* 2421537 */     GIR_EraseRootFromParent_Done,
     /* 2421538 */   // Label 34812: @2421538
     /* 2421538 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2421600), // Rule ID 73280 //
     /* 2421543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421573 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2421576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421599 */     // GIR_Coverage, 73280,
     /* 2421599 */     GIR_EraseRootFromParent_Done,
     /* 2421600 */   // Label 34813: @2421600
     /* 2421600 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2421662), // Rule ID 55732 //
     /* 2421605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421635 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2421638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2421648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421661 */     // GIR_Coverage, 55732,
     /* 2421661 */     GIR_EraseRootFromParent_Done,
     /* 2421662 */   // Label 34814: @2421662
     /* 2421662 */   GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2421724), // Rule ID 55733 //
     /* 2421667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2421690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421697 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2421700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2421710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421723 */     // GIR_Coverage, 55733,
     /* 2421723 */     GIR_EraseRootFromParent_Done,
     /* 2421724 */   // Label 34815: @2421724
     /* 2421724 */   GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2421769), // Rule ID 55728 //
     /* 2421729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2421732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421744 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2421747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421768 */     // GIR_Coverage, 55728,
     /* 2421768 */     GIR_EraseRootFromParent_Done,
     /* 2421769 */   // Label 34816: @2421769
     /* 2421769 */   GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2421814), // Rule ID 55729 //
     /* 2421774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2421777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421789 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2421792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2421809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421813 */     // GIR_Coverage, 55729,
     /* 2421813 */     GIR_EraseRootFromParent_Done,
     /* 2421814 */   // Label 34817: @2421814
     /* 2421814 */   GIM_Reject,
     /* 2421815 */ // Label 34805: @2421815
     /* 2421815 */ GIM_Reject,
     /* 2421816 */ // Label 34577: @2421816
     /* 2421816 */ GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2422605),
     /* 2421821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2421827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2421830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421834 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2421911), // Rule ID 55288 //
     /* 2421839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421882 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2421882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2421885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421910 */     // GIR_Coverage, 55288,
     /* 2421910 */     GIR_EraseRootFromParent_Done,
     /* 2421911 */   // Label 34819: @2421911
     /* 2421911 */   GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2421988), // Rule ID 55289 //
     /* 2421916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2421919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2421923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2421944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2421948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2421959 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2421959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2421962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2421966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2421970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2421974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2421977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2421980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2421986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421987 */     // GIR_Coverage, 55289,
     /* 2421987 */     GIR_EraseRootFromParent_Done,
     /* 2421988 */   // Label 34820: @2421988
     /* 2421988 */   GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2422065), // Rule ID 72883 //
     /* 2421993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2421996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422036 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2422039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422064 */     // GIR_Coverage, 72883,
     /* 2422064 */     GIR_EraseRootFromParent_Done,
     /* 2422065 */   // Label 34821: @2422065
     /* 2422065 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2422142), // Rule ID 72884 //
     /* 2422070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422113 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2422116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422141 */     // GIR_Coverage, 72884,
     /* 2422141 */     GIR_EraseRootFromParent_Done,
     /* 2422142 */   // Label 34822: @2422142
     /* 2422142 */   GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2422204), // Rule ID 55292 //
     /* 2422147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422177 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422203 */     // GIR_Coverage, 55292,
     /* 2422203 */     GIR_EraseRootFromParent_Done,
     /* 2422204 */   // Label 34823: @2422204
     /* 2422204 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2422266), // Rule ID 55293 //
     /* 2422209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422239 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422265 */     // GIR_Coverage, 55293,
     /* 2422265 */     GIR_EraseRootFromParent_Done,
     /* 2422266 */   // Label 34824: @2422266
     /* 2422266 */   GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2422328), // Rule ID 72887 //
     /* 2422271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422301 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422327 */     // GIR_Coverage, 72887,
     /* 2422327 */     GIR_EraseRootFromParent_Done,
     /* 2422328 */   // Label 34825: @2422328
     /* 2422328 */   GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2422390), // Rule ID 72888 //
     /* 2422333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422363 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2422366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422389 */     // GIR_Coverage, 72888,
     /* 2422389 */     GIR_EraseRootFromParent_Done,
     /* 2422390 */   // Label 34826: @2422390
     /* 2422390 */   GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2422452), // Rule ID 55284 //
     /* 2422395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422425 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2422428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2422438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422451 */     // GIR_Coverage, 55284,
     /* 2422451 */     GIR_EraseRootFromParent_Done,
     /* 2422452 */   // Label 34827: @2422452
     /* 2422452 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2422514), // Rule ID 55285 //
     /* 2422457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2422480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422487 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2422490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2422500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422513 */     // GIR_Coverage, 55285,
     /* 2422513 */     GIR_EraseRootFromParent_Done,
     /* 2422514 */   // Label 34828: @2422514
     /* 2422514 */   GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2422559), // Rule ID 55280 //
     /* 2422519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2422522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422534 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2422537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422558 */     // GIR_Coverage, 55280,
     /* 2422558 */     GIR_EraseRootFromParent_Done,
     /* 2422559 */   // Label 34829: @2422559
     /* 2422559 */   GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2422604), // Rule ID 55281 //
     /* 2422564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2422567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422579 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2422582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2422588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422603 */     // GIR_Coverage, 55281,
     /* 2422603 */     GIR_EraseRootFromParent_Done,
     /* 2422604 */   // Label 34830: @2422604
     /* 2422604 */   GIM_Reject,
     /* 2422605 */ // Label 34818: @2422605
     /* 2422605 */ GIM_Reject,
     /* 2422606 */ // Label 34578: @2422606
     /* 2422606 */ GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2423395),
     /* 2422611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2422617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2422620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422624 */   GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2422701), // Rule ID 55544 //
     /* 2422629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422672 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422700 */     // GIR_Coverage, 55544,
     /* 2422700 */     GIR_EraseRootFromParent_Done,
     /* 2422701 */   // Label 34832: @2422701
     /* 2422701 */   GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2422778), // Rule ID 55545 //
     /* 2422706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2422709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422749 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422777 */     // GIR_Coverage, 55545,
     /* 2422777 */     GIR_EraseRootFromParent_Done,
     /* 2422778 */   // Label 34833: @2422778
     /* 2422778 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2422855), // Rule ID 73107 //
     /* 2422783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422826 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422854 */     // GIR_Coverage, 73107,
     /* 2422854 */     GIR_EraseRootFromParent_Done,
     /* 2422855 */   // Label 34834: @2422855
     /* 2422855 */   GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2422932), // Rule ID 73108 //
     /* 2422860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2422863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2422871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2422888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2422903 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2422903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2422906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2422918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422931 */     // GIR_Coverage, 73108,
     /* 2422931 */     GIR_EraseRootFromParent_Done,
     /* 2422932 */   // Label 34835: @2422932
     /* 2422932 */   GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2422994), // Rule ID 55548 //
     /* 2422937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2422940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2422948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2422952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422967 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2422967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2422970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2422974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2422978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2422983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2422986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2422992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422993 */     // GIR_Coverage, 55548,
     /* 2422993 */     GIR_EraseRootFromParent_Done,
     /* 2422994 */   // Label 34836: @2422994
     /* 2422994 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2423056), // Rule ID 55549 //
     /* 2422999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423029 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423055 */     // GIR_Coverage, 55549,
     /* 2423055 */     GIR_EraseRootFromParent_Done,
     /* 2423056 */   // Label 34837: @2423056
     /* 2423056 */   GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2423118), // Rule ID 73111 //
     /* 2423061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423091 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423117 */     // GIR_Coverage, 73111,
     /* 2423117 */     GIR_EraseRootFromParent_Done,
     /* 2423118 */   // Label 34838: @2423118
     /* 2423118 */   GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2423180), // Rule ID 73112 //
     /* 2423123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423153 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2423156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423179 */     // GIR_Coverage, 73112,
     /* 2423179 */     GIR_EraseRootFromParent_Done,
     /* 2423180 */   // Label 34839: @2423180
     /* 2423180 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2423242), // Rule ID 55540 //
     /* 2423185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423215 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2423218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2423228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423241 */     // GIR_Coverage, 55540,
     /* 2423241 */     GIR_EraseRootFromParent_Done,
     /* 2423242 */   // Label 34840: @2423242
     /* 2423242 */   GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2423304), // Rule ID 55541 //
     /* 2423247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2423270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423277 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2423280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2423290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423303 */     // GIR_Coverage, 55541,
     /* 2423303 */     GIR_EraseRootFromParent_Done,
     /* 2423304 */   // Label 34841: @2423304
     /* 2423304 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2423349), // Rule ID 55536 //
     /* 2423309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2423312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423324 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2423327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423348 */     // GIR_Coverage, 55536,
     /* 2423348 */     GIR_EraseRootFromParent_Done,
     /* 2423349 */   // Label 34842: @2423349
     /* 2423349 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2423394), // Rule ID 55537 //
     /* 2423354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2423357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423369 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2423372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2423378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423393 */     // GIR_Coverage, 55537,
     /* 2423393 */     GIR_EraseRootFromParent_Done,
     /* 2423394 */   // Label 34843: @2423394
     /* 2423394 */   GIM_Reject,
     /* 2423395 */ // Label 34831: @2423395
     /* 2423395 */ GIM_Reject,
     /* 2423396 */ // Label 34579: @2423396
     /* 2423396 */ GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2424185),
     /* 2423401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2423407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2423410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423414 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2423491), // Rule ID 55352 //
     /* 2423419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423462 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423490 */     // GIR_Coverage, 55352,
     /* 2423490 */     GIR_EraseRootFromParent_Done,
     /* 2423491 */   // Label 34845: @2423491
     /* 2423491 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2423568), // Rule ID 55353 //
     /* 2423496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423539 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423567 */     // GIR_Coverage, 55353,
     /* 2423567 */     GIR_EraseRootFromParent_Done,
     /* 2423568 */   // Label 34846: @2423568
     /* 2423568 */   GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2423645), // Rule ID 72939 //
     /* 2423573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423616 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423644 */     // GIR_Coverage, 72939,
     /* 2423644 */     GIR_EraseRootFromParent_Done,
     /* 2423645 */   // Label 34847: @2423645
     /* 2423645 */   GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2423722), // Rule ID 72940 //
     /* 2423650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2423678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2423693 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2423696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2423708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423721 */     // GIR_Coverage, 72940,
     /* 2423721 */     GIR_EraseRootFromParent_Done,
     /* 2423722 */   // Label 34848: @2423722
     /* 2423722 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2423784), // Rule ID 55356 //
     /* 2423727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423757 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423783 */     // GIR_Coverage, 55356,
     /* 2423783 */     GIR_EraseRootFromParent_Done,
     /* 2423784 */   // Label 34849: @2423784
     /* 2423784 */   GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2423846), // Rule ID 55357 //
     /* 2423789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2423796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423819 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2423826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423845 */     // GIR_Coverage, 55357,
     /* 2423845 */     GIR_EraseRootFromParent_Done,
     /* 2423846 */   // Label 34850: @2423846
     /* 2423846 */   GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2423908), // Rule ID 72943 //
     /* 2423851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423881 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2423881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423907 */     // GIR_Coverage, 72943,
     /* 2423907 */     GIR_EraseRootFromParent_Done,
     /* 2423908 */   // Label 34851: @2423908
     /* 2423908 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2423970), // Rule ID 72944 //
     /* 2423913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2423916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2423924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423943 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2423943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2423946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2423954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2423959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2423962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2423968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423969 */     // GIR_Coverage, 72944,
     /* 2423969 */     GIR_EraseRootFromParent_Done,
     /* 2423970 */   // Label 34852: @2423970
     /* 2423970 */   GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2424032), // Rule ID 55348 //
     /* 2423975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2423978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2423994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2423998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424005 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2424005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2424008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2424018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424031 */     // GIR_Coverage, 55348,
     /* 2424031 */     GIR_EraseRootFromParent_Done,
     /* 2424032 */   // Label 34853: @2424032
     /* 2424032 */   GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2424094), // Rule ID 55349 //
     /* 2424037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2424056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2424060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424067 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2424067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2424070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2424080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424093 */     // GIR_Coverage, 55349,
     /* 2424093 */     GIR_EraseRootFromParent_Done,
     /* 2424094 */   // Label 34854: @2424094
     /* 2424094 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2424139), // Rule ID 55344 //
     /* 2424099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2424102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424114 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2424114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2424117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424138 */     // GIR_Coverage, 55344,
     /* 2424138 */     GIR_EraseRootFromParent_Done,
     /* 2424139 */   // Label 34855: @2424139
     /* 2424139 */   GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2424184), // Rule ID 55345 //
     /* 2424144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424159 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2424159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2424162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2424166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2424182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424183 */     // GIR_Coverage, 55345,
     /* 2424183 */     GIR_EraseRootFromParent_Done,
     /* 2424184 */   // Label 34856: @2424184
     /* 2424184 */   GIM_Reject,
     /* 2424185 */ // Label 34844: @2424185
     /* 2424185 */ GIM_Reject,
     /* 2424186 */ // Label 34580: @2424186
     /* 2424186 */ GIM_Reject,
     /* 2424187 */ // Label 103: @2424187
     /* 2424187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34875*/ GIMT_Encode4(2426362),
     /* 2424198 */ /*GILLT_s16*//*Label 34857*/ GIMT_Encode4(2424318),
     /* 2424202 */ /*GILLT_s32*//*Label 34858*/ GIMT_Encode4(2424440),
     /* 2424206 */ /*GILLT_s64*//*Label 34859*/ GIMT_Encode4(2424562), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424218 */ /*GILLT_nxv1s16*//*Label 34860*/ GIMT_Encode4(2424712),
     /* 2424222 */ /*GILLT_nxv1s32*//*Label 34861*/ GIMT_Encode4(2424822),
     /* 2424226 */ /*GILLT_nxv1s64*//*Label 34862*/ GIMT_Encode4(2424932), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424238 */ /*GILLT_nxv2s16*//*Label 34863*/ GIMT_Encode4(2425042),
     /* 2424242 */ /*GILLT_nxv2s32*//*Label 34864*/ GIMT_Encode4(2425152),
     /* 2424246 */ /*GILLT_nxv2s64*//*Label 34865*/ GIMT_Encode4(2425262), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424258 */ /*GILLT_nxv4s16*//*Label 34866*/ GIMT_Encode4(2425372),
     /* 2424262 */ /*GILLT_nxv4s32*//*Label 34867*/ GIMT_Encode4(2425482),
     /* 2424266 */ /*GILLT_nxv4s64*//*Label 34868*/ GIMT_Encode4(2425592), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424278 */ /*GILLT_nxv8s16*//*Label 34869*/ GIMT_Encode4(2425702),
     /* 2424282 */ /*GILLT_nxv8s32*//*Label 34870*/ GIMT_Encode4(2425812),
     /* 2424286 */ /*GILLT_nxv8s64*//*Label 34871*/ GIMT_Encode4(2425922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424298 */ /*GILLT_nxv16s16*//*Label 34872*/ GIMT_Encode4(2426032),
     /* 2424302 */ /*GILLT_nxv16s32*//*Label 34873*/ GIMT_Encode4(2426142), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2424314 */ /*GILLT_nxv32s16*//*Label 34874*/ GIMT_Encode4(2426252),
     /* 2424318 */ // Label 34857: @2424318
     /* 2424318 */ GIM_Try, /*On fail goto*//*Label 34876*/ GIMT_Encode4(2424439),
     /* 2424323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2424326 */   GIM_Try, /*On fail goto*//*Label 34877*/ GIMT_Encode4(2424354), // Rule ID 1988 //
     /* 2424331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2424334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424342 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2424342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2424345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424353 */     // GIR_Coverage, 1988,
     /* 2424353 */     GIR_EraseRootFromParent_Done,
     /* 2424354 */   // Label 34877: @2424354
     /* 2424354 */   GIM_Try, /*On fail goto*//*Label 34878*/ GIMT_Encode4(2424382), // Rule ID 1989 //
     /* 2424359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2424362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2424370 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2424370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2424373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424381 */     // GIR_Coverage, 1989,
     /* 2424381 */     GIR_EraseRootFromParent_Done,
     /* 2424382 */   // Label 34878: @2424382
     /* 2424382 */   GIM_Try, /*On fail goto*//*Label 34879*/ GIMT_Encode4(2424410), // Rule ID 2021 //
     /* 2424387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2424390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424398 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2424398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2424401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424409 */     // GIR_Coverage, 2021,
     /* 2424409 */     GIR_EraseRootFromParent_Done,
     /* 2424410 */   // Label 34879: @2424410
     /* 2424410 */   GIM_Try, /*On fail goto*//*Label 34880*/ GIMT_Encode4(2424438), // Rule ID 2022 //
     /* 2424415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2424418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2424426 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2424426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2424429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424437 */     // GIR_Coverage, 2022,
     /* 2424437 */     GIR_EraseRootFromParent_Done,
     /* 2424438 */   // Label 34880: @2424438
     /* 2424438 */   GIM_Reject,
     /* 2424439 */ // Label 34876: @2424439
     /* 2424439 */ GIM_Reject,
     /* 2424440 */ // Label 34858: @2424440
     /* 2424440 */ GIM_Try, /*On fail goto*//*Label 34881*/ GIMT_Encode4(2424561),
     /* 2424445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2424448 */   GIM_Try, /*On fail goto*//*Label 34882*/ GIMT_Encode4(2424476), // Rule ID 1279 //
     /* 2424453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2424456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424464 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2424464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2424467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424475 */     // GIR_Coverage, 1279,
     /* 2424475 */     GIR_EraseRootFromParent_Done,
     /* 2424476 */   // Label 34882: @2424476
     /* 2424476 */   GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2424504), // Rule ID 1280 //
     /* 2424481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2424484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2424492 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2424492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2424495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424503 */     // GIR_Coverage, 1280,
     /* 2424503 */     GIR_EraseRootFromParent_Done,
     /* 2424504 */   // Label 34883: @2424504
     /* 2424504 */   GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2424532), // Rule ID 1287 //
     /* 2424509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2424512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424520 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2424520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2424523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424531 */     // GIR_Coverage, 1287,
     /* 2424531 */     GIR_EraseRootFromParent_Done,
     /* 2424532 */   // Label 34884: @2424532
     /* 2424532 */   GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2424560), // Rule ID 1288 //
     /* 2424537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2424540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2424548 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2424548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2424551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424559 */     // GIR_Coverage, 1288,
     /* 2424559 */     GIR_EraseRootFromParent_Done,
     /* 2424560 */   // Label 34885: @2424560
     /* 2424560 */   GIM_Reject,
     /* 2424561 */ // Label 34881: @2424561
     /* 2424561 */ GIM_Reject,
     /* 2424562 */ // Label 34859: @2424562
     /* 2424562 */ GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2424711),
     /* 2424567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2424570 */   GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2424598), // Rule ID 1622 //
     /* 2424575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2424578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424586 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2424589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424597 */     // GIR_Coverage, 1622,
     /* 2424597 */     GIR_EraseRootFromParent_Done,
     /* 2424598 */   // Label 34887: @2424598
     /* 2424598 */   GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2424626), // Rule ID 1623 //
     /* 2424603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2424606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2424614 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2424614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2424617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424625 */     // GIR_Coverage, 1623,
     /* 2424625 */     GIR_EraseRootFromParent_Done,
     /* 2424626 */   // Label 34888: @2424626
     /* 2424626 */   GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2424654), // Rule ID 1657 //
     /* 2424631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2424634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424642 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2424645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424653 */     // GIR_Coverage, 1657,
     /* 2424653 */     GIR_EraseRootFromParent_Done,
     /* 2424654 */   // Label 34889: @2424654
     /* 2424654 */   GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2424682), // Rule ID 1677 //
     /* 2424659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2424662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424670 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2424670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2424673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424681 */     // GIR_Coverage, 1677,
     /* 2424681 */     GIR_EraseRootFromParent_Done,
     /* 2424682 */   // Label 34890: @2424682
     /* 2424682 */   GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2424710), // Rule ID 1678 //
     /* 2424687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2424690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2424698 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2424698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2424701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2424705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424709 */     // GIR_Coverage, 1678,
     /* 2424709 */     GIR_EraseRootFromParent_Done,
     /* 2424710 */   // Label 34891: @2424710
     /* 2424710 */   GIM_Reject,
     /* 2424711 */ // Label 34886: @2424711
     /* 2424711 */ GIM_Reject,
     /* 2424712 */ // Label 34860: @2424712
     /* 2424712 */ GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2424821),
     /* 2424717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2424720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424728 */   GIM_Try, /*On fail goto*//*Label 34893*/ GIMT_Encode4(2424774), // Rule ID 56240 //
     /* 2424733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2424736 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2424739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2424753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424773 */     // GIR_Coverage, 56240,
     /* 2424773 */     GIR_EraseRootFromParent_Done,
     /* 2424774 */   // Label 34893: @2424774
     /* 2424774 */   GIM_Try, /*On fail goto*//*Label 34894*/ GIMT_Encode4(2424820), // Rule ID 56241 //
     /* 2424779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2424782 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2424782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2424785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2424799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424819 */     // GIR_Coverage, 56241,
     /* 2424819 */     GIR_EraseRootFromParent_Done,
     /* 2424820 */   // Label 34894: @2424820
     /* 2424820 */   GIM_Reject,
     /* 2424821 */ // Label 34892: @2424821
     /* 2424821 */ GIM_Reject,
     /* 2424822 */ // Label 34861: @2424822
     /* 2424822 */ GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2424931),
     /* 2424827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2424830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424838 */   GIM_Try, /*On fail goto*//*Label 34896*/ GIMT_Encode4(2424884), // Rule ID 56280 //
     /* 2424843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2424846 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2424849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2424863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424883 */     // GIR_Coverage, 56280,
     /* 2424883 */     GIR_EraseRootFromParent_Done,
     /* 2424884 */   // Label 34896: @2424884
     /* 2424884 */   GIM_Try, /*On fail goto*//*Label 34897*/ GIMT_Encode4(2424930), // Rule ID 56281 //
     /* 2424889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2424892 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2424892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2424895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2424909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424929 */     // GIR_Coverage, 56281,
     /* 2424929 */     GIR_EraseRootFromParent_Done,
     /* 2424930 */   // Label 34897: @2424930
     /* 2424930 */   GIM_Reject,
     /* 2424931 */ // Label 34895: @2424931
     /* 2424931 */ GIM_Reject,
     /* 2424932 */ // Label 34862: @2424932
     /* 2424932 */ GIM_Try, /*On fail goto*//*Label 34898*/ GIMT_Encode4(2425041),
     /* 2424937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2424940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424948 */   GIM_Try, /*On fail goto*//*Label 34899*/ GIMT_Encode4(2424994), // Rule ID 56340 //
     /* 2424953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2424956 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2424956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2424959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2424963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2424968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2424970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2424973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2424978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2424980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2424983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2424986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424993 */     // GIR_Coverage, 56340,
     /* 2424993 */     GIR_EraseRootFromParent_Done,
     /* 2424994 */   // Label 34899: @2424994
     /* 2424994 */   GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2425040), // Rule ID 56341 //
     /* 2424999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425002 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2425005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2425019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425039 */     // GIR_Coverage, 56341,
     /* 2425039 */     GIR_EraseRootFromParent_Done,
     /* 2425040 */   // Label 34900: @2425040
     /* 2425040 */   GIM_Reject,
     /* 2425041 */ // Label 34898: @2425041
     /* 2425041 */ GIM_Reject,
     /* 2425042 */ // Label 34863: @2425042
     /* 2425042 */ GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2425151),
     /* 2425047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2425050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425058 */   GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2425104), // Rule ID 56260 //
     /* 2425063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425066 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2425069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2425083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425103 */     // GIR_Coverage, 56260,
     /* 2425103 */     GIR_EraseRootFromParent_Done,
     /* 2425104 */   // Label 34902: @2425104
     /* 2425104 */   GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2425150), // Rule ID 56261 //
     /* 2425109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425112 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2425115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2425129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425149 */     // GIR_Coverage, 56261,
     /* 2425149 */     GIR_EraseRootFromParent_Done,
     /* 2425150 */   // Label 34903: @2425150
     /* 2425150 */   GIM_Reject,
     /* 2425151 */ // Label 34901: @2425151
     /* 2425151 */ GIM_Reject,
     /* 2425152 */ // Label 34864: @2425152
     /* 2425152 */ GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2425261),
     /* 2425157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2425160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425168 */   GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2425214), // Rule ID 56320 //
     /* 2425173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425176 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2425179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2425193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425213 */     // GIR_Coverage, 56320,
     /* 2425213 */     GIR_EraseRootFromParent_Done,
     /* 2425214 */   // Label 34905: @2425214
     /* 2425214 */   GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2425260), // Rule ID 56321 //
     /* 2425219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425222 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2425225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2425239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425259 */     // GIR_Coverage, 56321,
     /* 2425259 */     GIR_EraseRootFromParent_Done,
     /* 2425260 */   // Label 34906: @2425260
     /* 2425260 */   GIM_Reject,
     /* 2425261 */ // Label 34904: @2425261
     /* 2425261 */ GIM_Reject,
     /* 2425262 */ // Label 34865: @2425262
     /* 2425262 */ GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2425371),
     /* 2425267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2425270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425278 */   GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2425324), // Rule ID 56480 //
     /* 2425283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425286 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2425289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2425303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425323 */     // GIR_Coverage, 56480,
     /* 2425323 */     GIR_EraseRootFromParent_Done,
     /* 2425324 */   // Label 34908: @2425324
     /* 2425324 */   GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2425370), // Rule ID 56481 //
     /* 2425329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425332 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2425335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2425349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425369 */     // GIR_Coverage, 56481,
     /* 2425369 */     GIR_EraseRootFromParent_Done,
     /* 2425370 */   // Label 34909: @2425370
     /* 2425370 */   GIM_Reject,
     /* 2425371 */ // Label 34907: @2425371
     /* 2425371 */ GIM_Reject,
     /* 2425372 */ // Label 34866: @2425372
     /* 2425372 */ GIM_Try, /*On fail goto*//*Label 34910*/ GIMT_Encode4(2425481),
     /* 2425377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2425380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425388 */   GIM_Try, /*On fail goto*//*Label 34911*/ GIMT_Encode4(2425434), // Rule ID 56300 //
     /* 2425393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425396 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2425399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2425413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425433 */     // GIR_Coverage, 56300,
     /* 2425433 */     GIR_EraseRootFromParent_Done,
     /* 2425434 */   // Label 34911: @2425434
     /* 2425434 */   GIM_Try, /*On fail goto*//*Label 34912*/ GIMT_Encode4(2425480), // Rule ID 56301 //
     /* 2425439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425442 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2425445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2425459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425479 */     // GIR_Coverage, 56301,
     /* 2425479 */     GIR_EraseRootFromParent_Done,
     /* 2425480 */   // Label 34912: @2425480
     /* 2425480 */   GIM_Reject,
     /* 2425481 */ // Label 34910: @2425481
     /* 2425481 */ GIM_Reject,
     /* 2425482 */ // Label 34867: @2425482
     /* 2425482 */ GIM_Try, /*On fail goto*//*Label 34913*/ GIMT_Encode4(2425591),
     /* 2425487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2425490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425498 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2425544), // Rule ID 56420 //
     /* 2425503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425506 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2425509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2425523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425543 */     // GIR_Coverage, 56420,
     /* 2425543 */     GIR_EraseRootFromParent_Done,
     /* 2425544 */   // Label 34914: @2425544
     /* 2425544 */   GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2425590), // Rule ID 56421 //
     /* 2425549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425552 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2425555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2425569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425589 */     // GIR_Coverage, 56421,
     /* 2425589 */     GIR_EraseRootFromParent_Done,
     /* 2425590 */   // Label 34915: @2425590
     /* 2425590 */   GIM_Reject,
     /* 2425591 */ // Label 34913: @2425591
     /* 2425591 */ GIM_Reject,
     /* 2425592 */ // Label 34868: @2425592
     /* 2425592 */ GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2425701),
     /* 2425597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2425600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425608 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2425654), // Rule ID 56500 //
     /* 2425613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425616 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2425619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2425633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425653 */     // GIR_Coverage, 56500,
     /* 2425653 */     GIR_EraseRootFromParent_Done,
     /* 2425654 */   // Label 34917: @2425654
     /* 2425654 */   GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2425700), // Rule ID 56501 //
     /* 2425659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425662 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2425665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2425679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425699 */     // GIR_Coverage, 56501,
     /* 2425699 */     GIR_EraseRootFromParent_Done,
     /* 2425700 */   // Label 34918: @2425700
     /* 2425700 */   GIM_Reject,
     /* 2425701 */ // Label 34916: @2425701
     /* 2425701 */ GIM_Reject,
     /* 2425702 */ // Label 34869: @2425702
     /* 2425702 */ GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2425811),
     /* 2425707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2425710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425718 */   GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2425764), // Rule ID 56360 //
     /* 2425723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2425726 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2425729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2425743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425763 */     // GIR_Coverage, 56360,
     /* 2425763 */     GIR_EraseRootFromParent_Done,
     /* 2425764 */   // Label 34920: @2425764
     /* 2425764 */   GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2425810), // Rule ID 56361 //
     /* 2425769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2425772 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2425775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2425789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425809 */     // GIR_Coverage, 56361,
     /* 2425809 */     GIR_EraseRootFromParent_Done,
     /* 2425810 */   // Label 34921: @2425810
     /* 2425810 */   GIM_Reject,
     /* 2425811 */ // Label 34919: @2425811
     /* 2425811 */ GIM_Reject,
     /* 2425812 */ // Label 34870: @2425812
     /* 2425812 */ GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2425921),
     /* 2425817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2425820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425828 */   GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2425874), // Rule ID 56440 //
     /* 2425833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2425836 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2425839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2425853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425873 */     // GIR_Coverage, 56440,
     /* 2425873 */     GIR_EraseRootFromParent_Done,
     /* 2425874 */   // Label 34923: @2425874
     /* 2425874 */   GIM_Try, /*On fail goto*//*Label 34924*/ GIMT_Encode4(2425920), // Rule ID 56441 //
     /* 2425879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2425882 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2425885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2425899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425919 */     // GIR_Coverage, 56441,
     /* 2425919 */     GIR_EraseRootFromParent_Done,
     /* 2425920 */   // Label 34924: @2425920
     /* 2425920 */   GIM_Reject,
     /* 2425921 */ // Label 34922: @2425921
     /* 2425921 */ GIM_Reject,
     /* 2425922 */ // Label 34871: @2425922
     /* 2425922 */ GIM_Try, /*On fail goto*//*Label 34925*/ GIMT_Encode4(2426031),
     /* 2425927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2425930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2425934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2425938 */   GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2425984), // Rule ID 56520 //
     /* 2425943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2425946 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2425946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2425949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2425958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2425960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2425963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2425968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2425970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2425973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2425976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425983 */     // GIR_Coverage, 56520,
     /* 2425983 */     GIR_EraseRootFromParent_Done,
     /* 2425984 */   // Label 34926: @2425984
     /* 2425984 */   GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2426030), // Rule ID 56521 //
     /* 2425989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2425992 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2425992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2425995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2425999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2426009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426029 */     // GIR_Coverage, 56521,
     /* 2426029 */     GIR_EraseRootFromParent_Done,
     /* 2426030 */   // Label 34927: @2426030
     /* 2426030 */   GIM_Reject,
     /* 2426031 */ // Label 34925: @2426031
     /* 2426031 */ GIM_Reject,
     /* 2426032 */ // Label 34872: @2426032
     /* 2426032 */ GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2426141),
     /* 2426037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2426040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426048 */   GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2426094), // Rule ID 56380 //
     /* 2426053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2426056 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2426059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2426073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426093 */     // GIR_Coverage, 56380,
     /* 2426093 */     GIR_EraseRootFromParent_Done,
     /* 2426094 */   // Label 34929: @2426094
     /* 2426094 */   GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2426140), // Rule ID 56381 //
     /* 2426099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2426102 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2426105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2426119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426139 */     // GIR_Coverage, 56381,
     /* 2426139 */     GIR_EraseRootFromParent_Done,
     /* 2426140 */   // Label 34930: @2426140
     /* 2426140 */   GIM_Reject,
     /* 2426141 */ // Label 34928: @2426141
     /* 2426141 */ GIM_Reject,
     /* 2426142 */ // Label 34873: @2426142
     /* 2426142 */ GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2426251),
     /* 2426147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2426150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426158 */   GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2426204), // Rule ID 56460 //
     /* 2426163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2426166 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2426169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2426183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426203 */     // GIR_Coverage, 56460,
     /* 2426203 */     GIR_EraseRootFromParent_Done,
     /* 2426204 */   // Label 34932: @2426204
     /* 2426204 */   GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2426250), // Rule ID 56461 //
     /* 2426209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2426212 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2426215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2426229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426249 */     // GIR_Coverage, 56461,
     /* 2426249 */     GIR_EraseRootFromParent_Done,
     /* 2426250 */   // Label 34933: @2426250
     /* 2426250 */   GIM_Reject,
     /* 2426251 */ // Label 34931: @2426251
     /* 2426251 */ GIM_Reject,
     /* 2426252 */ // Label 34874: @2426252
     /* 2426252 */ GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2426361),
     /* 2426257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2426260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426268 */   GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2426314), // Rule ID 56400 //
     /* 2426273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2426276 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2426276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2426279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2426293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426313 */     // GIR_Coverage, 56400,
     /* 2426313 */     GIR_EraseRootFromParent_Done,
     /* 2426314 */   // Label 34935: @2426314
     /* 2426314 */   GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2426360), // Rule ID 56401 //
     /* 2426319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2426322 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2426322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2426325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2426329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2426339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2426346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2426349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2426352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426359 */     // GIR_Coverage, 56401,
     /* 2426359 */     GIR_EraseRootFromParent_Done,
     /* 2426360 */   // Label 34936: @2426360
     /* 2426360 */   GIM_Reject,
     /* 2426361 */ // Label 34934: @2426361
     /* 2426361 */ GIM_Reject,
     /* 2426362 */ // Label 34875: @2426362
     /* 2426362 */ GIM_Reject,
     /* 2426363 */ // Label 104: @2426363
     /* 2426363 */ GIM_Try, /*On fail goto*//*Label 34937*/ GIMT_Encode4(2426375), // Rule ID 293 //
     /* 2426368 */   // (trap)  =>  (UNIMP)
     /* 2426368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2426373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426374 */   // GIR_Coverage, 293,
     /* 2426374 */   GIR_Done,
     /* 2426375 */ // Label 34937: @2426375
     /* 2426375 */ GIM_Reject,
     /* 2426376 */ // Label 105: @2426376
     /* 2426376 */ GIM_Try, /*On fail goto*//*Label 34938*/ GIMT_Encode4(2426388), // Rule ID 294 //
     /* 2426381 */   // (debugtrap)  =>  (EBREAK)
     /* 2426381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2426386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426387 */   // GIR_Coverage, 294,
     /* 2426387 */   GIR_Done,
     /* 2426388 */ // Label 34938: @2426388
     /* 2426388 */ GIM_Reject,
     /* 2426389 */ // Label 106: @2426389
     /* 2426389 */ GIM_Try, /*On fail goto*//*Label 34939*/ GIMT_Encode4(2426483),
     /* 2426394 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426404 */   GIM_Try, /*On fail goto*//*Label 34940*/ GIMT_Encode4(2426423), // Rule ID 2522 //
     /* 2426409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2426412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426416 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2426416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2426421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426422 */     // GIR_Coverage, 2522,
     /* 2426422 */     GIR_Done,
     /* 2426423 */   // Label 34940: @2426423
     /* 2426423 */   GIM_Try, /*On fail goto*//*Label 34941*/ GIMT_Encode4(2426482), // Rule ID 62575 //
     /* 2426428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2426431 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2426431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2426434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2426438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2426447 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2426450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2426452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2426455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2426459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2426464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2426467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2426470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2426472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2426475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2426480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426481 */     // GIR_Coverage, 62575,
     /* 2426481 */     GIR_EraseRootFromParent_Done,
     /* 2426482 */   // Label 34941: @2426482
     /* 2426482 */   GIM_Reject,
     /* 2426483 */ // Label 34939: @2426483
     /* 2426483 */ GIM_Reject,
     /* 2426484 */ // Label 107: @2426484
     /* 2426484 */ GIM_Try, /*On fail goto*//*Label 34942*/ GIMT_Encode4(2426513), // Rule ID 2523 //
     /* 2426489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2426492 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426506 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2426506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2426511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426512 */   // GIR_Coverage, 2523,
     /* 2426512 */   GIR_Done,
     /* 2426513 */ // Label 34942: @2426513
     /* 2426513 */ GIM_Reject,
     /* 2426514 */ // Label 108: @2426514
     /* 2426514 */ GIM_Try, /*On fail goto*//*Label 34943*/ GIMT_Encode4(2426550), // Rule ID 319 //
     /* 2426519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2426522 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2426531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426543 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2426543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2426548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426549 */   // GIR_Coverage, 319,
     /* 2426549 */   GIR_Done,
     /* 2426550 */ // Label 34943: @2426550
     /* 2426550 */ GIM_Reject,
     /* 2426551 */ // Label 109: @2426551
     /* 2426551 */ GIM_Try, /*On fail goto*//*Label 34944*/ GIMT_Encode4(2426587), // Rule ID 318 //
     /* 2426556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2426559 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2426568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426580 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2426580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2426585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426586 */   // GIR_Coverage, 318,
     /* 2426586 */   GIR_Done,
     /* 2426587 */ // Label 34944: @2426587
     /* 2426587 */ GIM_Reject,
     /* 2426588 */ // Label 110: @2426588
     /* 2426588 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34947*/ GIMT_Encode4(2426947),
     /* 2426599 */ /*GILLT_s32*//*Label 34945*/ GIMT_Encode4(2426607),
     /* 2426603 */ /*GILLT_s64*//*Label 34946*/ GIMT_Encode4(2426764),
     /* 2426607 */ // Label 34945: @2426607
     /* 2426607 */ GIM_Try, /*On fail goto*//*Label 34948*/ GIMT_Encode4(2426633), // Rule ID 1286 //
     /* 2426612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2426615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2426626 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2426626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2426631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426632 */   // GIR_Coverage, 1286,
     /* 2426632 */   GIR_Done,
     /* 2426633 */ // Label 34948: @2426633
     /* 2426633 */ GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2426659), // Rule ID 1294 //
     /* 2426638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2426641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2426652 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2426652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2426657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426658 */   // GIR_Coverage, 1294,
     /* 2426658 */   GIR_Done,
     /* 2426659 */ // Label 34949: @2426659
     /* 2426659 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2426685), // Rule ID 1629 //
     /* 2426664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2426667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2426678 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2426678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2426683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426684 */   // GIR_Coverage, 1629,
     /* 2426684 */   GIR_Done,
     /* 2426685 */ // Label 34950: @2426685
     /* 2426685 */ GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2426711), // Rule ID 1684 //
     /* 2426690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2426693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2426704 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2426704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2426709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426710 */   // GIR_Coverage, 1684,
     /* 2426710 */   GIR_Done,
     /* 2426711 */ // Label 34951: @2426711
     /* 2426711 */ GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2426737), // Rule ID 1995 //
     /* 2426716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2426719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2426730 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2426730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2426735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426736 */   // GIR_Coverage, 1995,
     /* 2426736 */   GIR_Done,
     /* 2426737 */ // Label 34952: @2426737
     /* 2426737 */ GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2426763), // Rule ID 2028 //
     /* 2426742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2426745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2426756 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2426756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2426761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426762 */   // GIR_Coverage, 2028,
     /* 2426762 */   GIR_Done,
     /* 2426763 */ // Label 34953: @2426763
     /* 2426763 */ GIM_Reject,
     /* 2426764 */ // Label 34946: @2426764
     /* 2426764 */ GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2426790), // Rule ID 1285 //
     /* 2426769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2426772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2426783 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2426783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2426788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426789 */   // GIR_Coverage, 1285,
     /* 2426789 */   GIR_Done,
     /* 2426790 */ // Label 34954: @2426790
     /* 2426790 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2426816), // Rule ID 1293 //
     /* 2426795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2426798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2426801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2426809 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2426809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2426814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426815 */   // GIR_Coverage, 1293,
     /* 2426815 */   GIR_Done,
     /* 2426816 */ // Label 34955: @2426816
     /* 2426816 */ GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2426842), // Rule ID 1628 //
     /* 2426821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2426824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2426835 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2426840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426841 */   // GIR_Coverage, 1628,
     /* 2426841 */   GIR_Done,
     /* 2426842 */ // Label 34956: @2426842
     /* 2426842 */ GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2426868), // Rule ID 1661 //
     /* 2426847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2426850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426861 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2426866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426867 */   // GIR_Coverage, 1661,
     /* 2426867 */   GIR_Done,
     /* 2426868 */ // Label 34957: @2426868
     /* 2426868 */ GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2426894), // Rule ID 1683 //
     /* 2426873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2426876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2426879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2426887 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2426887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2426892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426893 */   // GIR_Coverage, 1683,
     /* 2426893 */   GIR_Done,
     /* 2426894 */ // Label 34958: @2426894
     /* 2426894 */ GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2426920), // Rule ID 1994 //
     /* 2426899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2426902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2426913 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2426913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2426918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426919 */   // GIR_Coverage, 1994,
     /* 2426919 */   GIR_Done,
     /* 2426920 */ // Label 34959: @2426920
     /* 2426920 */ GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2426946), // Rule ID 2027 //
     /* 2426925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2426928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2426931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2426939 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2426939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2426944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2426945 */   // GIR_Coverage, 2027,
     /* 2426945 */   GIR_Done,
     /* 2426946 */ // Label 34960: @2426946
     /* 2426946 */ GIM_Reject,
     /* 2426947 */ // Label 34947: @2426947
     /* 2426947 */ GIM_Reject,
     /* 2426948 */ // Label 111: @2426948
     /* 2426948 */ GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2427145),
     /* 2426953 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2426956 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34965*/ GIMT_Encode4(2427144),
     /* 2426967 */   /*GILLT_s16*//*Label 34962*/ GIMT_Encode4(2426979),
     /* 2426971 */   /*GILLT_s32*//*Label 34963*/ GIMT_Encode4(2427034),
     /* 2426975 */   /*GILLT_s64*//*Label 34964*/ GIMT_Encode4(2427089),
     /* 2426979 */   // Label 34962: @2426979
     /* 2426979 */   GIM_Try, /*On fail goto*//*Label 34966*/ GIMT_Encode4(2427033),
     /* 2426984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426988 */     GIM_Try, /*On fail goto*//*Label 34967*/ GIMT_Encode4(2427010), // Rule ID 2245 //
     /* 2426993 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2426996 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2427000 */       // MIs[0] frm
     /* 2427000 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427003 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427003 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2427008 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427009 */       // GIR_Coverage, 2245,
     /* 2427009 */       GIR_Done,
     /* 2427010 */     // Label 34967: @2427010
     /* 2427010 */     GIM_Try, /*On fail goto*//*Label 34968*/ GIMT_Encode4(2427032), // Rule ID 2271 //
     /* 2427015 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2427018 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2427022 */       // MIs[0] frm
     /* 2427022 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427025 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427025 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2427030 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427031 */       // GIR_Coverage, 2271,
     /* 2427031 */       GIR_Done,
     /* 2427032 */     // Label 34968: @2427032
     /* 2427032 */     GIM_Reject,
     /* 2427033 */   // Label 34966: @2427033
     /* 2427033 */   GIM_Reject,
     /* 2427034 */   // Label 34963: @2427034
     /* 2427034 */   GIM_Try, /*On fail goto*//*Label 34969*/ GIMT_Encode4(2427088),
     /* 2427039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427043 */     GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2427065), // Rule ID 1511 //
     /* 2427048 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2427051 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2427055 */       // MIs[0] frm
     /* 2427055 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427058 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427058 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2427063 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427064 */       // GIR_Coverage, 1511,
     /* 2427064 */       GIR_Done,
     /* 2427065 */     // Label 34970: @2427065
     /* 2427065 */     GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2427087), // Rule ID 1539 //
     /* 2427070 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2427073 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2427077 */       // MIs[0] frm
     /* 2427077 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427080 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427080 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2427085 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427086 */       // GIR_Coverage, 1539,
     /* 2427086 */       GIR_Done,
     /* 2427087 */     // Label 34971: @2427087
     /* 2427087 */     GIM_Reject,
     /* 2427088 */   // Label 34969: @2427088
     /* 2427088 */   GIM_Reject,
     /* 2427089 */   // Label 34964: @2427089
     /* 2427089 */   GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2427143),
     /* 2427094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427098 */     GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2427120), // Rule ID 1905 //
     /* 2427103 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2427106 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2427110 */       // MIs[0] frm
     /* 2427110 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427113 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427113 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2427118 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427119 */       // GIR_Coverage, 1905,
     /* 2427119 */       GIR_Done,
     /* 2427120 */     // Label 34973: @2427120
     /* 2427120 */     GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2427142), // Rule ID 1933 //
     /* 2427125 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2427128 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427132 */       // MIs[0] frm
     /* 2427132 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427135 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427135 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2427140 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427141 */       // GIR_Coverage, 1933,
     /* 2427141 */       GIR_Done,
     /* 2427142 */     // Label 34974: @2427142
     /* 2427142 */     GIM_Reject,
     /* 2427143 */   // Label 34972: @2427143
     /* 2427143 */   GIM_Reject,
     /* 2427144 */   // Label 34965: @2427144
     /* 2427144 */   GIM_Reject,
     /* 2427145 */ // Label 34961: @2427145
     /* 2427145 */ GIM_Reject,
     /* 2427146 */ // Label 112: @2427146
     /* 2427146 */ GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2427343),
     /* 2427151 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427154 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34979*/ GIMT_Encode4(2427342),
     /* 2427165 */   /*GILLT_s16*//*Label 34976*/ GIMT_Encode4(2427177),
     /* 2427169 */   /*GILLT_s32*//*Label 34977*/ GIMT_Encode4(2427232),
     /* 2427173 */   /*GILLT_s64*//*Label 34978*/ GIMT_Encode4(2427287),
     /* 2427177 */   // Label 34976: @2427177
     /* 2427177 */   GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2427231),
     /* 2427182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427186 */     GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2427208), // Rule ID 2243 //
     /* 2427191 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2427194 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2427198 */       // MIs[0] frm
     /* 2427198 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427201 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427201 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2427206 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427207 */       // GIR_Coverage, 2243,
     /* 2427207 */       GIR_Done,
     /* 2427208 */     // Label 34981: @2427208
     /* 2427208 */     GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2427230), // Rule ID 2269 //
     /* 2427213 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2427216 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2427220 */       // MIs[0] frm
     /* 2427220 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427223 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427223 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2427228 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427229 */       // GIR_Coverage, 2269,
     /* 2427229 */       GIR_Done,
     /* 2427230 */     // Label 34982: @2427230
     /* 2427230 */     GIM_Reject,
     /* 2427231 */   // Label 34980: @2427231
     /* 2427231 */   GIM_Reject,
     /* 2427232 */   // Label 34977: @2427232
     /* 2427232 */   GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2427286),
     /* 2427237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427241 */     GIM_Try, /*On fail goto*//*Label 34984*/ GIMT_Encode4(2427263), // Rule ID 1509 //
     /* 2427246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2427249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2427253 */       // MIs[0] frm
     /* 2427253 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427256 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427256 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2427261 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427262 */       // GIR_Coverage, 1509,
     /* 2427262 */       GIR_Done,
     /* 2427263 */     // Label 34984: @2427263
     /* 2427263 */     GIM_Try, /*On fail goto*//*Label 34985*/ GIMT_Encode4(2427285), // Rule ID 1537 //
     /* 2427268 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2427271 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2427275 */       // MIs[0] frm
     /* 2427275 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427278 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427278 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2427283 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427284 */       // GIR_Coverage, 1537,
     /* 2427284 */       GIR_Done,
     /* 2427285 */     // Label 34985: @2427285
     /* 2427285 */     GIM_Reject,
     /* 2427286 */   // Label 34983: @2427286
     /* 2427286 */   GIM_Reject,
     /* 2427287 */   // Label 34978: @2427287
     /* 2427287 */   GIM_Try, /*On fail goto*//*Label 34986*/ GIMT_Encode4(2427341),
     /* 2427292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427296 */     GIM_Try, /*On fail goto*//*Label 34987*/ GIMT_Encode4(2427318), // Rule ID 1903 //
     /* 2427301 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2427304 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2427308 */       // MIs[0] frm
     /* 2427308 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427311 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427311 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2427316 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427317 */       // GIR_Coverage, 1903,
     /* 2427317 */       GIR_Done,
     /* 2427318 */     // Label 34987: @2427318
     /* 2427318 */     GIM_Try, /*On fail goto*//*Label 34988*/ GIMT_Encode4(2427340), // Rule ID 1931 //
     /* 2427323 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2427326 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427330 */       // MIs[0] frm
     /* 2427330 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2427333 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2427333 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2427338 */       GIR_RootConstrainSelectedInstOperands,
     /* 2427339 */       // GIR_Coverage, 1931,
     /* 2427339 */       GIR_Done,
     /* 2427340 */     // Label 34988: @2427340
     /* 2427340 */     GIM_Reject,
     /* 2427341 */   // Label 34986: @2427341
     /* 2427341 */   GIM_Reject,
     /* 2427342 */   // Label 34979: @2427342
     /* 2427342 */   GIM_Reject,
     /* 2427343 */ // Label 34975: @2427343
     /* 2427343 */ GIM_Reject,
     /* 2427344 */ // Label 113: @2427344
     /* 2427344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34991*/ GIMT_Encode4(2427403),
     /* 2427355 */ /*GILLT_s32*//*Label 34989*/ GIMT_Encode4(2427363),
     /* 2427359 */ /*GILLT_s64*//*Label 34990*/ GIMT_Encode4(2427383),
     /* 2427363 */ // Label 34989: @2427363
     /* 2427363 */ GIM_Try, /*On fail goto*//*Label 34992*/ GIMT_Encode4(2427382), // Rule ID 73 //
     /* 2427368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427375 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2427375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2427380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427381 */   // GIR_Coverage, 73,
     /* 2427381 */   GIR_Done,
     /* 2427382 */ // Label 34992: @2427382
     /* 2427382 */ GIM_Reject,
     /* 2427383 */ // Label 34990: @2427383
     /* 2427383 */ GIM_Try, /*On fail goto*//*Label 34993*/ GIMT_Encode4(2427402), // Rule ID 72 //
     /* 2427388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427395 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2427395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2427400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427401 */   // GIR_Coverage, 72,
     /* 2427401 */   GIR_Done,
     /* 2427402 */ // Label 34993: @2427402
     /* 2427402 */ GIM_Reject,
     /* 2427403 */ // Label 34991: @2427403
     /* 2427403 */ GIM_Reject,
     /* 2427404 */ // Label 114: @2427404
     /* 2427404 */ GIM_Try, /*On fail goto*//*Label 34994*/ GIMT_Encode4(2427440), // Rule ID 320 //
     /* 2427409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2427412 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427433 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2427438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427439 */   // GIR_Coverage, 320,
     /* 2427439 */   GIR_Done,
     /* 2427440 */ // Label 34994: @2427440
     /* 2427440 */ GIM_Reject,
     /* 2427441 */ // Label 115: @2427441
     /* 2427441 */ GIM_Try, /*On fail goto*//*Label 34995*/ GIMT_Encode4(2427565),
     /* 2427446 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427463 */   GIM_Try, /*On fail goto*//*Label 34996*/ GIMT_Encode4(2427499), // Rule ID 2471 //
     /* 2427468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427483 */     // MIs[1] Operand 1
     /* 2427483 */     // No operand predicates
     /* 2427483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427485 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2427485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2427488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427492 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2427497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427498 */     // GIR_Coverage, 2471,
     /* 2427498 */     GIR_EraseRootFromParent_Done,
     /* 2427499 */   // Label 34996: @2427499
     /* 2427499 */   GIM_Try, /*On fail goto*//*Label 34997*/ GIMT_Encode4(2427535), // Rule ID 62572 //
     /* 2427504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2427507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427519 */     // MIs[1] Operand 1
     /* 2427519 */     // No operand predicates
     /* 2427519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427521 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2427521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2427524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427528 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2427533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427534 */     // GIR_Coverage, 62572,
     /* 2427534 */     GIR_EraseRootFromParent_Done,
     /* 2427535 */   // Label 34997: @2427535
     /* 2427535 */   GIM_Try, /*On fail goto*//*Label 34998*/ GIMT_Encode4(2427564), // Rule ID 2468 //
     /* 2427540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427550 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2427553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427563 */     // GIR_Coverage, 2468,
     /* 2427563 */     GIR_EraseRootFromParent_Done,
     /* 2427564 */   // Label 34998: @2427564
     /* 2427564 */   GIM_Reject,
     /* 2427565 */ // Label 34995: @2427565
     /* 2427565 */ GIM_Reject,
     /* 2427566 */ // Label 116: @2427566
     /* 2427566 */ GIM_Try, /*On fail goto*//*Label 34999*/ GIMT_Encode4(2427686),
     /* 2427571 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427588 */   GIM_Try, /*On fail goto*//*Label 35000*/ GIMT_Encode4(2427622), // Rule ID 2470 //
     /* 2427593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427608 */     // MIs[1] Operand 1
     /* 2427608 */     // No operand predicates
     /* 2427608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427610 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2427610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2427613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2427620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427621 */     // GIR_Coverage, 2470,
     /* 2427621 */     GIR_EraseRootFromParent_Done,
     /* 2427622 */   // Label 35000: @2427622
     /* 2427622 */   GIM_Try, /*On fail goto*//*Label 35001*/ GIMT_Encode4(2427656), // Rule ID 62571 //
     /* 2427627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2427630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2427634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427642 */     // MIs[1] Operand 1
     /* 2427642 */     // No operand predicates
     /* 2427642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427644 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2427644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2427647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2427654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427655 */     // GIR_Coverage, 62571,
     /* 2427655 */     GIR_EraseRootFromParent_Done,
     /* 2427656 */   // Label 35001: @2427656
     /* 2427656 */   GIM_Try, /*On fail goto*//*Label 35002*/ GIMT_Encode4(2427685), // Rule ID 2469 //
     /* 2427661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2427664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427671 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2427674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427684 */     // GIR_Coverage, 2469,
     /* 2427684 */     GIR_EraseRootFromParent_Done,
     /* 2427685 */   // Label 35002: @2427685
     /* 2427685 */   GIM_Reject,
     /* 2427686 */ // Label 34999: @2427686
     /* 2427686 */ GIM_Reject,
     /* 2427687 */ // Label 117: @2427687
     /* 2427687 */ GIM_Try, /*On fail goto*//*Label 35003*/ GIMT_Encode4(2427733), // Rule ID 271 //
     /* 2427692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427695 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427719 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2427722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427724 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427732 */   // GIR_Coverage, 271,
     /* 2427732 */   GIR_EraseRootFromParent_Done,
     /* 2427733 */ // Label 35003: @2427733
     /* 2427733 */ GIM_Reject,
     /* 2427734 */ // Label 118: @2427734
     /* 2427734 */ GIM_Try, /*On fail goto*//*Label 35004*/ GIMT_Encode4(2427780), // Rule ID 273 //
     /* 2427739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427742 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427766 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2427769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427771 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427779 */   // GIR_Coverage, 273,
     /* 2427779 */   GIR_EraseRootFromParent_Done,
     /* 2427780 */ // Label 35004: @2427780
     /* 2427780 */ GIM_Reject,
     /* 2427781 */ // Label 119: @2427781
     /* 2427781 */ GIM_Try, /*On fail goto*//*Label 35005*/ GIMT_Encode4(2427827), // Rule ID 272 //
     /* 2427786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2427789 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2427792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2427798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427806 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2427813 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2427813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2427816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427818 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2427820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2427825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427826 */   // GIR_Coverage, 272,
     /* 2427826 */   GIR_EraseRootFromParent_Done,
     /* 2427827 */ // Label 35005: @2427827
     /* 2427827 */ GIM_Reject,
     /* 2427828 */ // Label 120: @2427828
     /* 2427828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 35013*/ GIMT_Encode4(2428476),
     /* 2427839 */ /*GILLT_nxv1s1*//*Label 35006*/ GIMT_Encode4(2427951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427859 */ /*GILLT_nxv2s1*//*Label 35007*/ GIMT_Encode4(2428026), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427879 */ /*GILLT_nxv4s1*//*Label 35008*/ GIMT_Encode4(2428101), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427899 */ /*GILLT_nxv8s1*//*Label 35009*/ GIMT_Encode4(2428176), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427919 */ /*GILLT_nxv16s1*//*Label 35010*/ GIMT_Encode4(2428251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427935 */ /*GILLT_nxv32s1*//*Label 35011*/ GIMT_Encode4(2428326), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2427947 */ /*GILLT_nxv64s1*//*Label 35012*/ GIMT_Encode4(2428401),
     /* 2427951 */ // Label 35006: @2427951
     /* 2427951 */ GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2427988), // Rule ID 44718 //
     /* 2427956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2427962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427973 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2427973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2427976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2427987 */   // GIR_Coverage, 44718,
     /* 2427987 */   GIR_EraseRootFromParent_Done,
     /* 2427988 */ // Label 35014: @2427988
     /* 2427988 */ GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2428025), // Rule ID 44719 //
     /* 2427993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2427999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428010 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2428013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428024 */   // GIR_Coverage, 44719,
     /* 2428024 */   GIR_EraseRootFromParent_Done,
     /* 2428025 */ // Label 35015: @2428025
     /* 2428025 */ GIM_Reject,
     /* 2428026 */ // Label 35007: @2428026
     /* 2428026 */ GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2428063), // Rule ID 44746 //
     /* 2428031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428048 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2428051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428062 */   // GIR_Coverage, 44746,
     /* 2428062 */   GIR_EraseRootFromParent_Done,
     /* 2428063 */ // Label 35016: @2428063
     /* 2428063 */ GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2428100), // Rule ID 44747 //
     /* 2428068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428085 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2428088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428099 */   // GIR_Coverage, 44747,
     /* 2428099 */   GIR_EraseRootFromParent_Done,
     /* 2428100 */ // Label 35017: @2428100
     /* 2428100 */ GIM_Reject,
     /* 2428101 */ // Label 35008: @2428101
     /* 2428101 */ GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2428138), // Rule ID 44774 //
     /* 2428106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428123 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2428126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428137 */   // GIR_Coverage, 44774,
     /* 2428137 */   GIR_EraseRootFromParent_Done,
     /* 2428138 */ // Label 35018: @2428138
     /* 2428138 */ GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2428175), // Rule ID 44775 //
     /* 2428143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428160 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2428163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428174 */   // GIR_Coverage, 44775,
     /* 2428174 */   GIR_EraseRootFromParent_Done,
     /* 2428175 */ // Label 35019: @2428175
     /* 2428175 */ GIM_Reject,
     /* 2428176 */ // Label 35009: @2428176
     /* 2428176 */ GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2428213), // Rule ID 44802 //
     /* 2428181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428198 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2428201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428212 */   // GIR_Coverage, 44802,
     /* 2428212 */   GIR_EraseRootFromParent_Done,
     /* 2428213 */ // Label 35020: @2428213
     /* 2428213 */ GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2428250), // Rule ID 44803 //
     /* 2428218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428235 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2428238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428249 */   // GIR_Coverage, 44803,
     /* 2428249 */   GIR_EraseRootFromParent_Done,
     /* 2428250 */ // Label 35021: @2428250
     /* 2428250 */ GIM_Reject,
     /* 2428251 */ // Label 35010: @2428251
     /* 2428251 */ GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2428288), // Rule ID 44830 //
     /* 2428256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428273 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2428276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428287 */   // GIR_Coverage, 44830,
     /* 2428287 */   GIR_EraseRootFromParent_Done,
     /* 2428288 */ // Label 35022: @2428288
     /* 2428288 */ GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2428325), // Rule ID 44831 //
     /* 2428293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428310 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2428313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428324 */   // GIR_Coverage, 44831,
     /* 2428324 */   GIR_EraseRootFromParent_Done,
     /* 2428325 */ // Label 35023: @2428325
     /* 2428325 */ GIM_Reject,
     /* 2428326 */ // Label 35011: @2428326
     /* 2428326 */ GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2428363), // Rule ID 44858 //
     /* 2428331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428348 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2428351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428362 */   // GIR_Coverage, 44858,
     /* 2428362 */   GIR_EraseRootFromParent_Done,
     /* 2428363 */ // Label 35024: @2428363
     /* 2428363 */ GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2428400), // Rule ID 44859 //
     /* 2428368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428385 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2428388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428399 */   // GIR_Coverage, 44859,
     /* 2428399 */   GIR_EraseRootFromParent_Done,
     /* 2428400 */ // Label 35025: @2428400
     /* 2428400 */ GIM_Reject,
     /* 2428401 */ // Label 35012: @2428401
     /* 2428401 */ GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2428438), // Rule ID 44886 //
     /* 2428406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428423 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2428426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428437 */   // GIR_Coverage, 44886,
     /* 2428437 */   GIR_EraseRootFromParent_Done,
     /* 2428438 */ // Label 35026: @2428438
     /* 2428438 */ GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2428475), // Rule ID 44887 //
     /* 2428443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428460 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2428463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428474 */   // GIR_Coverage, 44887,
     /* 2428474 */   GIR_EraseRootFromParent_Done,
     /* 2428475 */ // Label 35027: @2428475
     /* 2428475 */ GIM_Reject,
     /* 2428476 */ // Label 35013: @2428476
     /* 2428476 */ GIM_Reject,
     /* 2428477 */ // Label 121: @2428477
     /* 2428477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 35035*/ GIMT_Encode4(2429125),
     /* 2428488 */ /*GILLT_nxv1s1*//*Label 35028*/ GIMT_Encode4(2428600), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428508 */ /*GILLT_nxv2s1*//*Label 35029*/ GIMT_Encode4(2428675), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428528 */ /*GILLT_nxv4s1*//*Label 35030*/ GIMT_Encode4(2428750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428548 */ /*GILLT_nxv8s1*//*Label 35031*/ GIMT_Encode4(2428825), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428568 */ /*GILLT_nxv16s1*//*Label 35032*/ GIMT_Encode4(2428900), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428584 */ /*GILLT_nxv32s1*//*Label 35033*/ GIMT_Encode4(2428975), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2428596 */ /*GILLT_nxv64s1*//*Label 35034*/ GIMT_Encode4(2429050),
     /* 2428600 */ // Label 35028: @2428600
     /* 2428600 */ GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2428637), // Rule ID 44716 //
     /* 2428605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428615 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428622 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2428625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428636 */   // GIR_Coverage, 44716,
     /* 2428636 */   GIR_EraseRootFromParent_Done,
     /* 2428637 */ // Label 35036: @2428637
     /* 2428637 */ GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2428674), // Rule ID 44717 //
     /* 2428642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428652 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428659 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2428662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428673 */   // GIR_Coverage, 44717,
     /* 2428673 */   GIR_EraseRootFromParent_Done,
     /* 2428674 */ // Label 35037: @2428674
     /* 2428674 */ GIM_Reject,
     /* 2428675 */ // Label 35029: @2428675
     /* 2428675 */ GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2428712), // Rule ID 44744 //
     /* 2428680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428697 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2428700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428711 */   // GIR_Coverage, 44744,
     /* 2428711 */   GIR_EraseRootFromParent_Done,
     /* 2428712 */ // Label 35038: @2428712
     /* 2428712 */ GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2428749), // Rule ID 44745 //
     /* 2428717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428734 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2428737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428748 */   // GIR_Coverage, 44745,
     /* 2428748 */   GIR_EraseRootFromParent_Done,
     /* 2428749 */ // Label 35039: @2428749
     /* 2428749 */ GIM_Reject,
     /* 2428750 */ // Label 35030: @2428750
     /* 2428750 */ GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2428787), // Rule ID 44772 //
     /* 2428755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428772 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2428775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428786 */   // GIR_Coverage, 44772,
     /* 2428786 */   GIR_EraseRootFromParent_Done,
     /* 2428787 */ // Label 35040: @2428787
     /* 2428787 */ GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2428824), // Rule ID 44773 //
     /* 2428792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428809 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2428812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428823 */   // GIR_Coverage, 44773,
     /* 2428823 */   GIR_EraseRootFromParent_Done,
     /* 2428824 */ // Label 35041: @2428824
     /* 2428824 */ GIM_Reject,
     /* 2428825 */ // Label 35031: @2428825
     /* 2428825 */ GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2428862), // Rule ID 44800 //
     /* 2428830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428847 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2428850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428861 */   // GIR_Coverage, 44800,
     /* 2428861 */   GIR_EraseRootFromParent_Done,
     /* 2428862 */ // Label 35042: @2428862
     /* 2428862 */ GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2428899), // Rule ID 44801 //
     /* 2428867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428884 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2428887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428898 */   // GIR_Coverage, 44801,
     /* 2428898 */   GIR_EraseRootFromParent_Done,
     /* 2428899 */ // Label 35043: @2428899
     /* 2428899 */ GIM_Reject,
     /* 2428900 */ // Label 35032: @2428900
     /* 2428900 */ GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2428937), // Rule ID 44828 //
     /* 2428905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428922 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2428925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428936 */   // GIR_Coverage, 44828,
     /* 2428936 */   GIR_EraseRootFromParent_Done,
     /* 2428937 */ // Label 35044: @2428937
     /* 2428937 */ GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2428974), // Rule ID 44829 //
     /* 2428942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2428948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428959 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2428959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2428962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2428972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2428973 */   // GIR_Coverage, 44829,
     /* 2428973 */   GIR_EraseRootFromParent_Done,
     /* 2428974 */ // Label 35045: @2428974
     /* 2428974 */ GIM_Reject,
     /* 2428975 */ // Label 35033: @2428975
     /* 2428975 */ GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2429012), // Rule ID 44856 //
     /* 2428980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2428986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428997 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2428997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2429000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429011 */   // GIR_Coverage, 44856,
     /* 2429011 */   GIR_EraseRootFromParent_Done,
     /* 2429012 */ // Label 35046: @2429012
     /* 2429012 */ GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2429049), // Rule ID 44857 //
     /* 2429017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2429023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429034 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2429034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2429037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429048 */   // GIR_Coverage, 44857,
     /* 2429048 */   GIR_EraseRootFromParent_Done,
     /* 2429049 */ // Label 35047: @2429049
     /* 2429049 */ GIM_Reject,
     /* 2429050 */ // Label 35034: @2429050
     /* 2429050 */ GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2429087), // Rule ID 44884 //
     /* 2429055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2429061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429072 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2429072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2429075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429086 */   // GIR_Coverage, 44884,
     /* 2429086 */   GIR_EraseRootFromParent_Done,
     /* 2429087 */ // Label 35048: @2429087
     /* 2429087 */ GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2429124), // Rule ID 44885 //
     /* 2429092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2429098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429109 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2429109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2429112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429122 */   GIR_RootConstrainSelectedInstOperands,
     /* 2429123 */   // GIR_Coverage, 44885,
     /* 2429123 */   GIR_EraseRootFromParent_Done,
     /* 2429124 */ // Label 35049: @2429124
     /* 2429124 */ GIM_Reject,
     /* 2429125 */ // Label 35035: @2429125
     /* 2429125 */ GIM_Reject,
     /* 2429126 */ // Label 122: @2429126
     /* 2429126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35072*/ GIMT_Encode4(2433383),
     /* 2429137 */ /*GILLT_nxv1s8*//*Label 35050*/ GIMT_Encode4(2429249),
     /* 2429141 */ /*GILLT_nxv1s16*//*Label 35051*/ GIMT_Encode4(2429366),
     /* 2429145 */ /*GILLT_nxv1s32*//*Label 35052*/ GIMT_Encode4(2429587),
     /* 2429149 */ /*GILLT_nxv1s64*//*Label 35053*/ GIMT_Encode4(2429808), GIMT_Encode4(0),
     /* 2429157 */ /*GILLT_nxv2s8*//*Label 35054*/ GIMT_Encode4(2430029),
     /* 2429161 */ /*GILLT_nxv2s16*//*Label 35055*/ GIMT_Encode4(2430146),
     /* 2429165 */ /*GILLT_nxv2s32*//*Label 35056*/ GIMT_Encode4(2430367),
     /* 2429169 */ /*GILLT_nxv2s64*//*Label 35057*/ GIMT_Encode4(2430588), GIMT_Encode4(0),
     /* 2429177 */ /*GILLT_nxv4s8*//*Label 35058*/ GIMT_Encode4(2430809),
     /* 2429181 */ /*GILLT_nxv4s16*//*Label 35059*/ GIMT_Encode4(2430926),
     /* 2429185 */ /*GILLT_nxv4s32*//*Label 35060*/ GIMT_Encode4(2431147),
     /* 2429189 */ /*GILLT_nxv4s64*//*Label 35061*/ GIMT_Encode4(2431368), GIMT_Encode4(0),
     /* 2429197 */ /*GILLT_nxv8s8*//*Label 35062*/ GIMT_Encode4(2431589),
     /* 2429201 */ /*GILLT_nxv8s16*//*Label 35063*/ GIMT_Encode4(2431706),
     /* 2429205 */ /*GILLT_nxv8s32*//*Label 35064*/ GIMT_Encode4(2431927),
     /* 2429209 */ /*GILLT_nxv8s64*//*Label 35065*/ GIMT_Encode4(2432148), GIMT_Encode4(0),
     /* 2429217 */ /*GILLT_nxv16s8*//*Label 35066*/ GIMT_Encode4(2432369),
     /* 2429221 */ /*GILLT_nxv16s16*//*Label 35067*/ GIMT_Encode4(2432486),
     /* 2429225 */ /*GILLT_nxv16s32*//*Label 35068*/ GIMT_Encode4(2432707), GIMT_Encode4(0),
     /* 2429233 */ /*GILLT_nxv32s8*//*Label 35069*/ GIMT_Encode4(2432928),
     /* 2429237 */ /*GILLT_nxv32s16*//*Label 35070*/ GIMT_Encode4(2433045), GIMT_Encode4(0),
     /* 2429245 */ /*GILLT_nxv64s8*//*Label 35071*/ GIMT_Encode4(2433266),
     /* 2429249 */ // Label 35050: @2429249
     /* 2429249 */ GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2429365),
     /* 2429254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2429257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2429260 */   GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2429312), // Rule ID 32306 //
     /* 2429265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429290 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2429293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429295 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429311 */     // GIR_Coverage, 32306,
     /* 2429311 */     GIR_EraseRootFromParent_Done,
     /* 2429312 */   // Label 35074: @2429312
     /* 2429312 */   GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2429364), // Rule ID 32307 //
     /* 2429317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429342 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2429345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429347 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429363 */     // GIR_Coverage, 32307,
     /* 2429363 */     GIR_EraseRootFromParent_Done,
     /* 2429364 */   // Label 35075: @2429364
     /* 2429364 */   GIM_Reject,
     /* 2429365 */ // Label 35073: @2429365
     /* 2429365 */ GIM_Reject,
     /* 2429366 */ // Label 35051: @2429366
     /* 2429366 */ GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2429586),
     /* 2429371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2429374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2429377 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2429429), // Rule ID 32576 //
     /* 2429382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429407 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429412 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429428 */     // GIR_Coverage, 32576,
     /* 2429428 */     GIR_EraseRootFromParent_Done,
     /* 2429429 */   // Label 35077: @2429429
     /* 2429429 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2429481), // Rule ID 32577 //
     /* 2429434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429459 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429464 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429480 */     // GIR_Coverage, 32577,
     /* 2429480 */     GIR_EraseRootFromParent_Done,
     /* 2429481 */   // Label 35078: @2429481
     /* 2429481 */   GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2429533), // Rule ID 34286 //
     /* 2429486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429511 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429516 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429532 */     // GIR_Coverage, 34286,
     /* 2429532 */     GIR_EraseRootFromParent_Done,
     /* 2429533 */   // Label 35079: @2429533
     /* 2429533 */   GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2429585), // Rule ID 34287 //
     /* 2429538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429563 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2429566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429568 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429584 */     // GIR_Coverage, 34287,
     /* 2429584 */     GIR_EraseRootFromParent_Done,
     /* 2429585 */   // Label 35080: @2429585
     /* 2429585 */   GIM_Reject,
     /* 2429586 */ // Label 35076: @2429586
     /* 2429586 */ GIM_Reject,
     /* 2429587 */ // Label 35052: @2429587
     /* 2429587 */ GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2429807),
     /* 2429592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2429595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2429598 */   GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2429650), // Rule ID 32756 //
     /* 2429603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429628 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429633 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429649 */     // GIR_Coverage, 32756,
     /* 2429649 */     GIR_EraseRootFromParent_Done,
     /* 2429650 */   // Label 35082: @2429650
     /* 2429650 */   GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2429702), // Rule ID 32757 //
     /* 2429655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429680 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429685 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429701 */     // GIR_Coverage, 32757,
     /* 2429701 */     GIR_EraseRootFromParent_Done,
     /* 2429702 */   // Label 35083: @2429702
     /* 2429702 */   GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2429754), // Rule ID 34466 //
     /* 2429707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429732 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429737 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429753 */     // GIR_Coverage, 34466,
     /* 2429753 */     GIR_EraseRootFromParent_Done,
     /* 2429754 */   // Label 35084: @2429754
     /* 2429754 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2429806), // Rule ID 34467 //
     /* 2429759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429784 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2429787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429789 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429805 */     // GIR_Coverage, 34467,
     /* 2429805 */     GIR_EraseRootFromParent_Done,
     /* 2429806 */   // Label 35085: @2429806
     /* 2429806 */   GIM_Reject,
     /* 2429807 */ // Label 35081: @2429807
     /* 2429807 */ GIM_Reject,
     /* 2429808 */ // Label 35053: @2429808
     /* 2429808 */ GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2430028),
     /* 2429813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2429816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2429819 */   GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2429871), // Rule ID 33116 //
     /* 2429824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429849 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429854 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429870 */     // GIR_Coverage, 33116,
     /* 2429870 */     GIR_EraseRootFromParent_Done,
     /* 2429871 */   // Label 35087: @2429871
     /* 2429871 */   GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2429923), // Rule ID 33117 //
     /* 2429876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429901 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2429901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429906 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429922 */     // GIR_Coverage, 33117,
     /* 2429922 */     GIR_EraseRootFromParent_Done,
     /* 2429923 */   // Label 35088: @2429923
     /* 2429923 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2429975), // Rule ID 34912 //
     /* 2429928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429953 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2429953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2429956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429958 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2429960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2429962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2429973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429974 */     // GIR_Coverage, 34912,
     /* 2429974 */     GIR_EraseRootFromParent_Done,
     /* 2429975 */   // Label 35089: @2429975
     /* 2429975 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2430027), // Rule ID 34913 //
     /* 2429980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430005 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430010 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430026 */     // GIR_Coverage, 34913,
     /* 2430026 */     GIR_EraseRootFromParent_Done,
     /* 2430027 */   // Label 35090: @2430027
     /* 2430027 */   GIM_Reject,
     /* 2430028 */ // Label 35086: @2430028
     /* 2430028 */ GIM_Reject,
     /* 2430029 */ // Label 35054: @2430029
     /* 2430029 */ GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2430145),
     /* 2430034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2430037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2430040 */   GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2430092), // Rule ID 32396 //
     /* 2430045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430070 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2430073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430075 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430091 */     // GIR_Coverage, 32396,
     /* 2430091 */     GIR_EraseRootFromParent_Done,
     /* 2430092 */   // Label 35092: @2430092
     /* 2430092 */   GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2430144), // Rule ID 32397 //
     /* 2430097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430122 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2430125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430127 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430143 */     // GIR_Coverage, 32397,
     /* 2430143 */     GIR_EraseRootFromParent_Done,
     /* 2430144 */   // Label 35093: @2430144
     /* 2430144 */   GIM_Reject,
     /* 2430145 */ // Label 35091: @2430145
     /* 2430145 */ GIM_Reject,
     /* 2430146 */ // Label 35055: @2430146
     /* 2430146 */ GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2430366),
     /* 2430151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2430154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2430157 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2430209), // Rule ID 32666 //
     /* 2430162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430187 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430192 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430208 */     // GIR_Coverage, 32666,
     /* 2430208 */     GIR_EraseRootFromParent_Done,
     /* 2430209 */   // Label 35095: @2430209
     /* 2430209 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2430261), // Rule ID 32667 //
     /* 2430214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430239 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430244 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430260 */     // GIR_Coverage, 32667,
     /* 2430260 */     GIR_EraseRootFromParent_Done,
     /* 2430261 */   // Label 35096: @2430261
     /* 2430261 */   GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2430313), // Rule ID 34376 //
     /* 2430266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430291 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430296 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430312 */     // GIR_Coverage, 34376,
     /* 2430312 */     GIR_EraseRootFromParent_Done,
     /* 2430313 */   // Label 35097: @2430313
     /* 2430313 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2430365), // Rule ID 34377 //
     /* 2430318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430343 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430348 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430364 */     // GIR_Coverage, 34377,
     /* 2430364 */     GIR_EraseRootFromParent_Done,
     /* 2430365 */   // Label 35098: @2430365
     /* 2430365 */   GIM_Reject,
     /* 2430366 */ // Label 35094: @2430366
     /* 2430366 */ GIM_Reject,
     /* 2430367 */ // Label 35056: @2430367
     /* 2430367 */ GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2430587),
     /* 2430372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2430375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2430378 */   GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2430430), // Rule ID 33026 //
     /* 2430383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430408 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430413 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430429 */     // GIR_Coverage, 33026,
     /* 2430429 */     GIR_EraseRootFromParent_Done,
     /* 2430430 */   // Label 35100: @2430430
     /* 2430430 */   GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2430482), // Rule ID 33027 //
     /* 2430435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430460 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430465 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430481 */     // GIR_Coverage, 33027,
     /* 2430481 */     GIR_EraseRootFromParent_Done,
     /* 2430482 */   // Label 35101: @2430482
     /* 2430482 */   GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2430534), // Rule ID 34822 //
     /* 2430487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430512 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430517 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430533 */     // GIR_Coverage, 34822,
     /* 2430533 */     GIR_EraseRootFromParent_Done,
     /* 2430534 */   // Label 35102: @2430534
     /* 2430534 */   GIM_Try, /*On fail goto*//*Label 35103*/ GIMT_Encode4(2430586), // Rule ID 34823 //
     /* 2430539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430564 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430569 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430585 */     // GIR_Coverage, 34823,
     /* 2430585 */     GIR_EraseRootFromParent_Done,
     /* 2430586 */   // Label 35103: @2430586
     /* 2430586 */   GIM_Reject,
     /* 2430587 */ // Label 35099: @2430587
     /* 2430587 */ GIM_Reject,
     /* 2430588 */ // Label 35057: @2430588
     /* 2430588 */ GIM_Try, /*On fail goto*//*Label 35104*/ GIMT_Encode4(2430808),
     /* 2430593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2430596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2430599 */   GIM_Try, /*On fail goto*//*Label 35105*/ GIMT_Encode4(2430651), // Rule ID 34016 //
     /* 2430604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430629 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430634 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430650 */     // GIR_Coverage, 34016,
     /* 2430650 */     GIR_EraseRootFromParent_Done,
     /* 2430651 */   // Label 35105: @2430651
     /* 2430651 */   GIM_Try, /*On fail goto*//*Label 35106*/ GIMT_Encode4(2430703), // Rule ID 34017 //
     /* 2430656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430681 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430686 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430702 */     // GIR_Coverage, 34017,
     /* 2430702 */     GIR_EraseRootFromParent_Done,
     /* 2430703 */   // Label 35106: @2430703
     /* 2430703 */   GIM_Try, /*On fail goto*//*Label 35107*/ GIMT_Encode4(2430755), // Rule ID 35630 //
     /* 2430708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430733 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430738 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430754 */     // GIR_Coverage, 35630,
     /* 2430754 */     GIR_EraseRootFromParent_Done,
     /* 2430755 */   // Label 35107: @2430755
     /* 2430755 */   GIM_Try, /*On fail goto*//*Label 35108*/ GIMT_Encode4(2430807), // Rule ID 35631 //
     /* 2430760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430785 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2430788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430790 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430806 */     // GIR_Coverage, 35631,
     /* 2430806 */     GIR_EraseRootFromParent_Done,
     /* 2430807 */   // Label 35108: @2430807
     /* 2430807 */   GIM_Reject,
     /* 2430808 */ // Label 35104: @2430808
     /* 2430808 */ GIM_Reject,
     /* 2430809 */ // Label 35058: @2430809
     /* 2430809 */ GIM_Try, /*On fail goto*//*Label 35109*/ GIMT_Encode4(2430925),
     /* 2430814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2430817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2430820 */   GIM_Try, /*On fail goto*//*Label 35110*/ GIMT_Encode4(2430872), // Rule ID 32486 //
     /* 2430825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430850 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430855 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430871 */     // GIR_Coverage, 32486,
     /* 2430871 */     GIR_EraseRootFromParent_Done,
     /* 2430872 */   // Label 35110: @2430872
     /* 2430872 */   GIM_Try, /*On fail goto*//*Label 35111*/ GIMT_Encode4(2430924), // Rule ID 32487 //
     /* 2430877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430902 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2430902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2430905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430907 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430923 */     // GIR_Coverage, 32487,
     /* 2430923 */     GIR_EraseRootFromParent_Done,
     /* 2430924 */   // Label 35111: @2430924
     /* 2430924 */   GIM_Reject,
     /* 2430925 */ // Label 35109: @2430925
     /* 2430925 */ GIM_Reject,
     /* 2430926 */ // Label 35059: @2430926
     /* 2430926 */ GIM_Try, /*On fail goto*//*Label 35112*/ GIMT_Encode4(2431146),
     /* 2430931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2430934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2430937 */   GIM_Try, /*On fail goto*//*Label 35113*/ GIMT_Encode4(2430989), // Rule ID 32936 //
     /* 2430942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430967 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2430967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2430970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430972 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2430974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2430976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2430987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430988 */     // GIR_Coverage, 32936,
     /* 2430988 */     GIR_EraseRootFromParent_Done,
     /* 2430989 */   // Label 35113: @2430989
     /* 2430989 */   GIM_Try, /*On fail goto*//*Label 35114*/ GIMT_Encode4(2431041), // Rule ID 32937 //
     /* 2430994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431019 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431024 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431040 */     // GIR_Coverage, 32937,
     /* 2431040 */     GIR_EraseRootFromParent_Done,
     /* 2431041 */   // Label 35114: @2431041
     /* 2431041 */   GIM_Try, /*On fail goto*//*Label 35115*/ GIMT_Encode4(2431093), // Rule ID 34732 //
     /* 2431046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431071 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431076 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431092 */     // GIR_Coverage, 34732,
     /* 2431092 */     GIR_EraseRootFromParent_Done,
     /* 2431093 */   // Label 35115: @2431093
     /* 2431093 */   GIM_Try, /*On fail goto*//*Label 35116*/ GIMT_Encode4(2431145), // Rule ID 34733 //
     /* 2431098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431123 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431128 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431144 */     // GIR_Coverage, 34733,
     /* 2431144 */     GIR_EraseRootFromParent_Done,
     /* 2431145 */   // Label 35116: @2431145
     /* 2431145 */   GIM_Reject,
     /* 2431146 */ // Label 35112: @2431146
     /* 2431146 */ GIM_Reject,
     /* 2431147 */ // Label 35060: @2431147
     /* 2431147 */ GIM_Try, /*On fail goto*//*Label 35117*/ GIMT_Encode4(2431367),
     /* 2431152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2431155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2431158 */   GIM_Try, /*On fail goto*//*Label 35118*/ GIMT_Encode4(2431210), // Rule ID 33746 //
     /* 2431163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431188 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431193 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431209 */     // GIR_Coverage, 33746,
     /* 2431209 */     GIR_EraseRootFromParent_Done,
     /* 2431210 */   // Label 35118: @2431210
     /* 2431210 */   GIM_Try, /*On fail goto*//*Label 35119*/ GIMT_Encode4(2431262), // Rule ID 33747 //
     /* 2431215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431240 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431245 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431261 */     // GIR_Coverage, 33747,
     /* 2431261 */     GIR_EraseRootFromParent_Done,
     /* 2431262 */   // Label 35119: @2431262
     /* 2431262 */   GIM_Try, /*On fail goto*//*Label 35120*/ GIMT_Encode4(2431314), // Rule ID 35360 //
     /* 2431267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431292 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431297 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431313 */     // GIR_Coverage, 35360,
     /* 2431313 */     GIR_EraseRootFromParent_Done,
     /* 2431314 */   // Label 35120: @2431314
     /* 2431314 */   GIM_Try, /*On fail goto*//*Label 35121*/ GIMT_Encode4(2431366), // Rule ID 35361 //
     /* 2431319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431344 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431349 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431365 */     // GIR_Coverage, 35361,
     /* 2431365 */     GIR_EraseRootFromParent_Done,
     /* 2431366 */   // Label 35121: @2431366
     /* 2431366 */   GIM_Reject,
     /* 2431367 */ // Label 35117: @2431367
     /* 2431367 */ GIM_Reject,
     /* 2431368 */ // Label 35061: @2431368
     /* 2431368 */ GIM_Try, /*On fail goto*//*Label 35122*/ GIMT_Encode4(2431588),
     /* 2431373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2431376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2431379 */   GIM_Try, /*On fail goto*//*Label 35123*/ GIMT_Encode4(2431431), // Rule ID 34106 //
     /* 2431384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431409 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431414 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431430 */     // GIR_Coverage, 34106,
     /* 2431430 */     GIR_EraseRootFromParent_Done,
     /* 2431431 */   // Label 35123: @2431431
     /* 2431431 */   GIM_Try, /*On fail goto*//*Label 35124*/ GIMT_Encode4(2431483), // Rule ID 34107 //
     /* 2431436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431461 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431466 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431482 */     // GIR_Coverage, 34107,
     /* 2431482 */     GIR_EraseRootFromParent_Done,
     /* 2431483 */   // Label 35124: @2431483
     /* 2431483 */   GIM_Try, /*On fail goto*//*Label 35125*/ GIMT_Encode4(2431535), // Rule ID 35720 //
     /* 2431488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431513 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431518 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431534 */     // GIR_Coverage, 35720,
     /* 2431534 */     GIR_EraseRootFromParent_Done,
     /* 2431535 */   // Label 35125: @2431535
     /* 2431535 */   GIM_Try, /*On fail goto*//*Label 35126*/ GIMT_Encode4(2431587), // Rule ID 35721 //
     /* 2431540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431565 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431570 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431586 */     // GIR_Coverage, 35721,
     /* 2431586 */     GIR_EraseRootFromParent_Done,
     /* 2431587 */   // Label 35126: @2431587
     /* 2431587 */   GIM_Reject,
     /* 2431588 */ // Label 35122: @2431588
     /* 2431588 */ GIM_Reject,
     /* 2431589 */ // Label 35062: @2431589
     /* 2431589 */ GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2431705),
     /* 2431594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2431597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2431600 */   GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2431652), // Rule ID 32846 //
     /* 2431605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431630 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431635 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431651 */     // GIR_Coverage, 32846,
     /* 2431651 */     GIR_EraseRootFromParent_Done,
     /* 2431652 */   // Label 35128: @2431652
     /* 2431652 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2431704), // Rule ID 32847 //
     /* 2431657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431682 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2431685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431687 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431703 */     // GIR_Coverage, 32847,
     /* 2431703 */     GIR_EraseRootFromParent_Done,
     /* 2431704 */   // Label 35129: @2431704
     /* 2431704 */   GIM_Reject,
     /* 2431705 */ // Label 35127: @2431705
     /* 2431705 */ GIM_Reject,
     /* 2431706 */ // Label 35063: @2431706
     /* 2431706 */ GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2431926),
     /* 2431711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2431714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2431717 */   GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2431769), // Rule ID 33476 //
     /* 2431722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431747 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431752 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431768 */     // GIR_Coverage, 33476,
     /* 2431768 */     GIR_EraseRootFromParent_Done,
     /* 2431769 */   // Label 35131: @2431769
     /* 2431769 */   GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2431821), // Rule ID 33477 //
     /* 2431774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431799 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431804 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431820 */     // GIR_Coverage, 33477,
     /* 2431820 */     GIR_EraseRootFromParent_Done,
     /* 2431821 */   // Label 35132: @2431821
     /* 2431821 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2431873), // Rule ID 35090 //
     /* 2431826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431851 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431856 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431872 */     // GIR_Coverage, 35090,
     /* 2431872 */     GIR_EraseRootFromParent_Done,
     /* 2431873 */   // Label 35133: @2431873
     /* 2431873 */   GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2431925), // Rule ID 35091 //
     /* 2431878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431903 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2431903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2431906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431908 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431924 */     // GIR_Coverage, 35091,
     /* 2431924 */     GIR_EraseRootFromParent_Done,
     /* 2431925 */   // Label 35134: @2431925
     /* 2431925 */   GIM_Reject,
     /* 2431926 */ // Label 35130: @2431926
     /* 2431926 */ GIM_Reject,
     /* 2431927 */ // Label 35064: @2431927
     /* 2431927 */ GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2432147),
     /* 2431932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2431935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2431938 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2431990), // Rule ID 33836 //
     /* 2431943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431968 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2431968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2431971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431973 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2431975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2431977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2431988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431989 */     // GIR_Coverage, 33836,
     /* 2431989 */     GIR_EraseRootFromParent_Done,
     /* 2431990 */   // Label 35136: @2431990
     /* 2431990 */   GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2432042), // Rule ID 33837 //
     /* 2431995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432020 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432025 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432041 */     // GIR_Coverage, 33837,
     /* 2432041 */     GIR_EraseRootFromParent_Done,
     /* 2432042 */   // Label 35137: @2432042
     /* 2432042 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2432094), // Rule ID 35450 //
     /* 2432047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432072 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432077 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432093 */     // GIR_Coverage, 35450,
     /* 2432093 */     GIR_EraseRootFromParent_Done,
     /* 2432094 */   // Label 35138: @2432094
     /* 2432094 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2432146), // Rule ID 35451 //
     /* 2432099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432124 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432129 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432145 */     // GIR_Coverage, 35451,
     /* 2432145 */     GIR_EraseRootFromParent_Done,
     /* 2432146 */   // Label 35139: @2432146
     /* 2432146 */   GIM_Reject,
     /* 2432147 */ // Label 35135: @2432147
     /* 2432147 */ GIM_Reject,
     /* 2432148 */ // Label 35065: @2432148
     /* 2432148 */ GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2432368),
     /* 2432153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2432156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2432159 */   GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2432211), // Rule ID 34196 //
     /* 2432164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432189 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432194 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432210 */     // GIR_Coverage, 34196,
     /* 2432210 */     GIR_EraseRootFromParent_Done,
     /* 2432211 */   // Label 35141: @2432211
     /* 2432211 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2432263), // Rule ID 34197 //
     /* 2432216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432241 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432246 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432262 */     // GIR_Coverage, 34197,
     /* 2432262 */     GIR_EraseRootFromParent_Done,
     /* 2432263 */   // Label 35142: @2432263
     /* 2432263 */   GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2432315), // Rule ID 35810 //
     /* 2432268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432293 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432298 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432314 */     // GIR_Coverage, 35810,
     /* 2432314 */     GIR_EraseRootFromParent_Done,
     /* 2432315 */   // Label 35143: @2432315
     /* 2432315 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2432367), // Rule ID 35811 //
     /* 2432320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432345 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432350 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432366 */     // GIR_Coverage, 35811,
     /* 2432366 */     GIR_EraseRootFromParent_Done,
     /* 2432367 */   // Label 35144: @2432367
     /* 2432367 */   GIM_Reject,
     /* 2432368 */ // Label 35140: @2432368
     /* 2432368 */ GIM_Reject,
     /* 2432369 */ // Label 35066: @2432369
     /* 2432369 */ GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2432485),
     /* 2432374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2432377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2432380 */   GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2432432), // Rule ID 33206 //
     /* 2432385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432410 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2432413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432415 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432431 */     // GIR_Coverage, 33206,
     /* 2432431 */     GIR_EraseRootFromParent_Done,
     /* 2432432 */   // Label 35146: @2432432
     /* 2432432 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2432484), // Rule ID 33207 //
     /* 2432437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432462 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2432465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432467 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432483 */     // GIR_Coverage, 33207,
     /* 2432483 */     GIR_EraseRootFromParent_Done,
     /* 2432484 */   // Label 35147: @2432484
     /* 2432484 */   GIM_Reject,
     /* 2432485 */ // Label 35145: @2432485
     /* 2432485 */ GIM_Reject,
     /* 2432486 */ // Label 35067: @2432486
     /* 2432486 */ GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2432706),
     /* 2432491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2432494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2432497 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2432549), // Rule ID 33566 //
     /* 2432502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432527 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432532 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432548 */     // GIR_Coverage, 33566,
     /* 2432548 */     GIR_EraseRootFromParent_Done,
     /* 2432549 */   // Label 35149: @2432549
     /* 2432549 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2432601), // Rule ID 33567 //
     /* 2432554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432579 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432584 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432600 */     // GIR_Coverage, 33567,
     /* 2432600 */     GIR_EraseRootFromParent_Done,
     /* 2432601 */   // Label 35150: @2432601
     /* 2432601 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2432653), // Rule ID 35180 //
     /* 2432606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432631 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432636 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432652 */     // GIR_Coverage, 35180,
     /* 2432652 */     GIR_EraseRootFromParent_Done,
     /* 2432653 */   // Label 35151: @2432653
     /* 2432653 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2432705), // Rule ID 35181 //
     /* 2432658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432683 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432688 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432704 */     // GIR_Coverage, 35181,
     /* 2432704 */     GIR_EraseRootFromParent_Done,
     /* 2432705 */   // Label 35152: @2432705
     /* 2432705 */   GIM_Reject,
     /* 2432706 */ // Label 35148: @2432706
     /* 2432706 */ GIM_Reject,
     /* 2432707 */ // Label 35068: @2432707
     /* 2432707 */ GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2432927),
     /* 2432712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2432715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2432718 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2432770), // Rule ID 33926 //
     /* 2432723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432748 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432753 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432769 */     // GIR_Coverage, 33926,
     /* 2432769 */     GIR_EraseRootFromParent_Done,
     /* 2432770 */   // Label 35154: @2432770
     /* 2432770 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2432822), // Rule ID 33927 //
     /* 2432775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432800 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432805 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432821 */     // GIR_Coverage, 33927,
     /* 2432821 */     GIR_EraseRootFromParent_Done,
     /* 2432822 */   // Label 35155: @2432822
     /* 2432822 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2432874), // Rule ID 35540 //
     /* 2432827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432852 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432857 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432873 */     // GIR_Coverage, 35540,
     /* 2432873 */     GIR_EraseRootFromParent_Done,
     /* 2432874 */   // Label 35156: @2432874
     /* 2432874 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2432926), // Rule ID 35541 //
     /* 2432879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432904 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2432904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2432907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432909 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432925 */     // GIR_Coverage, 35541,
     /* 2432925 */     GIR_EraseRootFromParent_Done,
     /* 2432926 */   // Label 35157: @2432926
     /* 2432926 */   GIM_Reject,
     /* 2432927 */ // Label 35153: @2432927
     /* 2432927 */ GIM_Reject,
     /* 2432928 */ // Label 35069: @2432928
     /* 2432928 */ GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2433044),
     /* 2432933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2432936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2432939 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2432991), // Rule ID 33296 //
     /* 2432944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432969 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2432969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2432972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432974 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2432976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2432978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2432989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432990 */     // GIR_Coverage, 33296,
     /* 2432990 */     GIR_EraseRootFromParent_Done,
     /* 2432991 */   // Label 35159: @2432991
     /* 2432991 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2433043), // Rule ID 33297 //
     /* 2432996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433021 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2433024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433026 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433042 */     // GIR_Coverage, 33297,
     /* 2433042 */     GIR_EraseRootFromParent_Done,
     /* 2433043 */   // Label 35160: @2433043
     /* 2433043 */   GIM_Reject,
     /* 2433044 */ // Label 35158: @2433044
     /* 2433044 */ GIM_Reject,
     /* 2433045 */ // Label 35070: @2433045
     /* 2433045 */ GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2433265),
     /* 2433050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2433053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2433056 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2433108), // Rule ID 33656 //
     /* 2433061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433086 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433091 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433107 */     // GIR_Coverage, 33656,
     /* 2433107 */     GIR_EraseRootFromParent_Done,
     /* 2433108 */   // Label 35162: @2433108
     /* 2433108 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2433160), // Rule ID 33657 //
     /* 2433113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433138 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433143 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433159 */     // GIR_Coverage, 33657,
     /* 2433159 */     GIR_EraseRootFromParent_Done,
     /* 2433160 */   // Label 35163: @2433160
     /* 2433160 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2433212), // Rule ID 35270 //
     /* 2433165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433190 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433195 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433211 */     // GIR_Coverage, 35270,
     /* 2433211 */     GIR_EraseRootFromParent_Done,
     /* 2433212 */   // Label 35164: @2433212
     /* 2433212 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2433264), // Rule ID 35271 //
     /* 2433217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433242 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433247 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433263 */     // GIR_Coverage, 35271,
     /* 2433263 */     GIR_EraseRootFromParent_Done,
     /* 2433264 */   // Label 35165: @2433264
     /* 2433264 */   GIM_Reject,
     /* 2433265 */ // Label 35161: @2433265
     /* 2433265 */ GIM_Reject,
     /* 2433266 */ // Label 35071: @2433266
     /* 2433266 */ GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2433382),
     /* 2433271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2433274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2433277 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2433329), // Rule ID 33386 //
     /* 2433282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433307 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2433307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433312 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433328 */     // GIR_Coverage, 33386,
     /* 2433328 */     GIR_EraseRootFromParent_Done,
     /* 2433329 */   // Label 35167: @2433329
     /* 2433329 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2433381), // Rule ID 33387 //
     /* 2433334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433359 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2433359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2433362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433364 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2433366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2433368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2433379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433380 */     // GIR_Coverage, 33387,
     /* 2433380 */     GIR_EraseRootFromParent_Done,
     /* 2433381 */   // Label 35168: @2433381
     /* 2433381 */   GIM_Reject,
     /* 2433382 */ // Label 35166: @2433382
     /* 2433382 */ GIM_Reject,
     /* 2433383 */ // Label 35072: @2433383
     /* 2433383 */ GIM_Reject,
     /* 2433384 */ // Label 123: @2433384
     /* 2433384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35191*/ GIMT_Encode4(2445263),
     /* 2433395 */ /*GILLT_nxv1s8*//*Label 35169*/ GIMT_Encode4(2433507),
     /* 2433399 */ /*GILLT_nxv1s16*//*Label 35170*/ GIMT_Encode4(2433830),
     /* 2433403 */ /*GILLT_nxv1s32*//*Label 35171*/ GIMT_Encode4(2434463),
     /* 2433407 */ /*GILLT_nxv1s64*//*Label 35172*/ GIMT_Encode4(2435096), GIMT_Encode4(0),
     /* 2433415 */ /*GILLT_nxv2s8*//*Label 35173*/ GIMT_Encode4(2435729),
     /* 2433419 */ /*GILLT_nxv2s16*//*Label 35174*/ GIMT_Encode4(2436052),
     /* 2433423 */ /*GILLT_nxv2s32*//*Label 35175*/ GIMT_Encode4(2436685),
     /* 2433427 */ /*GILLT_nxv2s64*//*Label 35176*/ GIMT_Encode4(2437318), GIMT_Encode4(0),
     /* 2433435 */ /*GILLT_nxv4s8*//*Label 35177*/ GIMT_Encode4(2437951),
     /* 2433439 */ /*GILLT_nxv4s16*//*Label 35178*/ GIMT_Encode4(2438274),
     /* 2433443 */ /*GILLT_nxv4s32*//*Label 35179*/ GIMT_Encode4(2438907),
     /* 2433447 */ /*GILLT_nxv4s64*//*Label 35180*/ GIMT_Encode4(2439540), GIMT_Encode4(0),
     /* 2433455 */ /*GILLT_nxv8s8*//*Label 35181*/ GIMT_Encode4(2440173),
     /* 2433459 */ /*GILLT_nxv8s16*//*Label 35182*/ GIMT_Encode4(2440496),
     /* 2433463 */ /*GILLT_nxv8s32*//*Label 35183*/ GIMT_Encode4(2441129),
     /* 2433467 */ /*GILLT_nxv8s64*//*Label 35184*/ GIMT_Encode4(2441762), GIMT_Encode4(0),
     /* 2433475 */ /*GILLT_nxv16s8*//*Label 35185*/ GIMT_Encode4(2442395),
     /* 2433479 */ /*GILLT_nxv16s16*//*Label 35186*/ GIMT_Encode4(2442718),
     /* 2433483 */ /*GILLT_nxv16s32*//*Label 35187*/ GIMT_Encode4(2443351), GIMT_Encode4(0),
     /* 2433491 */ /*GILLT_nxv32s8*//*Label 35188*/ GIMT_Encode4(2443984),
     /* 2433495 */ /*GILLT_nxv32s16*//*Label 35189*/ GIMT_Encode4(2444307), GIMT_Encode4(0),
     /* 2433503 */ /*GILLT_nxv64s8*//*Label 35190*/ GIMT_Encode4(2444940),
     /* 2433507 */ // Label 35169: @2433507
     /* 2433507 */ GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2433829),
     /* 2433512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2433515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2433518 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2433601), // Rule ID 45450 //
     /* 2433523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433559 */     // MIs[1] Operand 1
     /* 2433559 */     // No operand predicates
     /* 2433559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433563 */     // MIs[0] policy
     /* 2433563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433575 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2433578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433600 */     // GIR_Coverage, 45450,
     /* 2433600 */     GIR_EraseRootFromParent_Done,
     /* 2433601 */   // Label 35193: @2433601
     /* 2433601 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2433684), // Rule ID 45451 //
     /* 2433606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433642 */     // MIs[1] Operand 1
     /* 2433642 */     // No operand predicates
     /* 2433642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433646 */     // MIs[0] policy
     /* 2433646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433658 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2433661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433683 */     // GIR_Coverage, 45451,
     /* 2433683 */     GIR_EraseRootFromParent_Done,
     /* 2433684 */   // Label 35194: @2433684
     /* 2433684 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2433756), // Rule ID 45452 //
     /* 2433689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433721 */     // MIs[0] policy
     /* 2433721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433731 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2433734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433755 */     // GIR_Coverage, 45452,
     /* 2433755 */     GIR_EraseRootFromParent_Done,
     /* 2433756 */   // Label 35195: @2433756
     /* 2433756 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2433828), // Rule ID 45453 //
     /* 2433761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433793 */     // MIs[0] policy
     /* 2433793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433803 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2433806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2433824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433827 */     // GIR_Coverage, 45453,
     /* 2433827 */     GIR_EraseRootFromParent_Done,
     /* 2433828 */   // Label 35196: @2433828
     /* 2433828 */   GIM_Reject,
     /* 2433829 */ // Label 35192: @2433829
     /* 2433829 */ GIM_Reject,
     /* 2433830 */ // Label 35170: @2433830
     /* 2433830 */ GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2434462),
     /* 2433835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2433838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2433841 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2433924), // Rule ID 45462 //
     /* 2433846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433882 */     // MIs[1] Operand 1
     /* 2433882 */     // No operand predicates
     /* 2433882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433886 */     // MIs[0] policy
     /* 2433886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433898 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2433901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433923 */     // GIR_Coverage, 45462,
     /* 2433923 */     GIR_EraseRootFromParent_Done,
     /* 2433924 */   // Label 35198: @2433924
     /* 2433924 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2434007), // Rule ID 45463 //
     /* 2433929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2433938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433965 */     // MIs[1] Operand 1
     /* 2433965 */     // No operand predicates
     /* 2433965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433969 */     // MIs[0] policy
     /* 2433969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433981 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2433984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434006 */     // GIR_Coverage, 45463,
     /* 2434006 */     GIR_EraseRootFromParent_Done,
     /* 2434007 */   // Label 35199: @2434007
     /* 2434007 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2434090), // Rule ID 45538 //
     /* 2434012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434048 */     // MIs[1] Operand 1
     /* 2434048 */     // No operand predicates
     /* 2434048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434052 */     // MIs[0] policy
     /* 2434052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434064 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2434067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434089 */     // GIR_Coverage, 45538,
     /* 2434089 */     GIR_EraseRootFromParent_Done,
     /* 2434090 */   // Label 35200: @2434090
     /* 2434090 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2434173), // Rule ID 45539 //
     /* 2434095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434131 */     // MIs[1] Operand 1
     /* 2434131 */     // No operand predicates
     /* 2434131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434135 */     // MIs[0] policy
     /* 2434135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434147 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2434150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434172 */     // GIR_Coverage, 45539,
     /* 2434172 */     GIR_EraseRootFromParent_Done,
     /* 2434173 */   // Label 35201: @2434173
     /* 2434173 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2434245), // Rule ID 45464 //
     /* 2434178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434210 */     // MIs[0] policy
     /* 2434210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434220 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434244 */     // GIR_Coverage, 45464,
     /* 2434244 */     GIR_EraseRootFromParent_Done,
     /* 2434245 */   // Label 35202: @2434245
     /* 2434245 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2434317), // Rule ID 45465 //
     /* 2434250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434282 */     // MIs[0] policy
     /* 2434282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434292 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434316 */     // GIR_Coverage, 45465,
     /* 2434316 */     GIR_EraseRootFromParent_Done,
     /* 2434317 */   // Label 35203: @2434317
     /* 2434317 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2434389), // Rule ID 45540 //
     /* 2434322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434354 */     // MIs[0] policy
     /* 2434354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434364 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434388 */     // GIR_Coverage, 45540,
     /* 2434388 */     GIR_EraseRootFromParent_Done,
     /* 2434389 */   // Label 35204: @2434389
     /* 2434389 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2434461), // Rule ID 45541 //
     /* 2434394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434426 */     // MIs[0] policy
     /* 2434426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434436 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2434439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434460 */     // GIR_Coverage, 45541,
     /* 2434460 */     GIR_EraseRootFromParent_Done,
     /* 2434461 */   // Label 35205: @2434461
     /* 2434461 */   GIM_Reject,
     /* 2434462 */ // Label 35197: @2434462
     /* 2434462 */ GIM_Reject,
     /* 2434463 */ // Label 35171: @2434463
     /* 2434463 */ GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2435095),
     /* 2434468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2434471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2434474 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2434557), // Rule ID 45470 //
     /* 2434479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434515 */     // MIs[1] Operand 1
     /* 2434515 */     // No operand predicates
     /* 2434515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434519 */     // MIs[0] policy
     /* 2434519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434531 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434556 */     // GIR_Coverage, 45470,
     /* 2434556 */     GIR_EraseRootFromParent_Done,
     /* 2434557 */   // Label 35207: @2434557
     /* 2434557 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2434640), // Rule ID 45471 //
     /* 2434562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434598 */     // MIs[1] Operand 1
     /* 2434598 */     // No operand predicates
     /* 2434598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434602 */     // MIs[0] policy
     /* 2434602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434614 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434639 */     // GIR_Coverage, 45471,
     /* 2434639 */     GIR_EraseRootFromParent_Done,
     /* 2434640 */   // Label 35208: @2434640
     /* 2434640 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2434723), // Rule ID 45546 //
     /* 2434645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434681 */     // MIs[1] Operand 1
     /* 2434681 */     // No operand predicates
     /* 2434681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434685 */     // MIs[0] policy
     /* 2434685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434697 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434722 */     // GIR_Coverage, 45546,
     /* 2434722 */     GIR_EraseRootFromParent_Done,
     /* 2434723 */   // Label 35209: @2434723
     /* 2434723 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2434806), // Rule ID 45547 //
     /* 2434728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434764 */     // MIs[1] Operand 1
     /* 2434764 */     // No operand predicates
     /* 2434764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434768 */     // MIs[0] policy
     /* 2434768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434780 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2434783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434805 */     // GIR_Coverage, 45547,
     /* 2434805 */     GIR_EraseRootFromParent_Done,
     /* 2434806 */   // Label 35210: @2434806
     /* 2434806 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2434878), // Rule ID 45472 //
     /* 2434811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434843 */     // MIs[0] policy
     /* 2434843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434853 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434877 */     // GIR_Coverage, 45472,
     /* 2434877 */     GIR_EraseRootFromParent_Done,
     /* 2434878 */   // Label 35211: @2434878
     /* 2434878 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2434950), // Rule ID 45473 //
     /* 2434883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434915 */     // MIs[0] policy
     /* 2434915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434925 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2434928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434949 */     // GIR_Coverage, 45473,
     /* 2434949 */     GIR_EraseRootFromParent_Done,
     /* 2434950 */   // Label 35212: @2434950
     /* 2434950 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2435022), // Rule ID 45548 //
     /* 2434955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2434964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434987 */     // MIs[0] policy
     /* 2434987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434997 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2435000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435021 */     // GIR_Coverage, 45548,
     /* 2435021 */     GIR_EraseRootFromParent_Done,
     /* 2435022 */   // Label 35213: @2435022
     /* 2435022 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2435094), // Rule ID 45549 //
     /* 2435027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435059 */     // MIs[0] policy
     /* 2435059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435069 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2435072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435093 */     // GIR_Coverage, 45549,
     /* 2435093 */     GIR_EraseRootFromParent_Done,
     /* 2435094 */   // Label 35214: @2435094
     /* 2435094 */   GIM_Reject,
     /* 2435095 */ // Label 35206: @2435095
     /* 2435095 */ GIM_Reject,
     /* 2435096 */ // Label 35172: @2435096
     /* 2435096 */ GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2435728),
     /* 2435101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2435104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2435107 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2435190), // Rule ID 45486 //
     /* 2435112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435148 */     // MIs[1] Operand 1
     /* 2435148 */     // No operand predicates
     /* 2435148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435152 */     // MIs[0] policy
     /* 2435152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435164 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435189 */     // GIR_Coverage, 45486,
     /* 2435189 */     GIR_EraseRootFromParent_Done,
     /* 2435190 */   // Label 35216: @2435190
     /* 2435190 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2435273), // Rule ID 45487 //
     /* 2435195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435231 */     // MIs[1] Operand 1
     /* 2435231 */     // No operand predicates
     /* 2435231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435235 */     // MIs[0] policy
     /* 2435235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435247 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435272 */     // GIR_Coverage, 45487,
     /* 2435272 */     GIR_EraseRootFromParent_Done,
     /* 2435273 */   // Label 35217: @2435273
     /* 2435273 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2435356), // Rule ID 45558 //
     /* 2435278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435314 */     // MIs[1] Operand 1
     /* 2435314 */     // No operand predicates
     /* 2435314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435318 */     // MIs[0] policy
     /* 2435318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435330 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435355 */     // GIR_Coverage, 45558,
     /* 2435355 */     GIR_EraseRootFromParent_Done,
     /* 2435356 */   // Label 35218: @2435356
     /* 2435356 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2435439), // Rule ID 45559 //
     /* 2435361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435397 */     // MIs[1] Operand 1
     /* 2435397 */     // No operand predicates
     /* 2435397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435401 */     // MIs[0] policy
     /* 2435401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435413 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2435416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435438 */     // GIR_Coverage, 45559,
     /* 2435438 */     GIR_EraseRootFromParent_Done,
     /* 2435439 */   // Label 35219: @2435439
     /* 2435439 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2435511), // Rule ID 45488 //
     /* 2435444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435476 */     // MIs[0] policy
     /* 2435476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435486 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435510 */     // GIR_Coverage, 45488,
     /* 2435510 */     GIR_EraseRootFromParent_Done,
     /* 2435511 */   // Label 35220: @2435511
     /* 2435511 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2435583), // Rule ID 45489 //
     /* 2435516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435548 */     // MIs[0] policy
     /* 2435548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435558 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435582 */     // GIR_Coverage, 45489,
     /* 2435582 */     GIR_EraseRootFromParent_Done,
     /* 2435583 */   // Label 35221: @2435583
     /* 2435583 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2435655), // Rule ID 45560 //
     /* 2435588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435620 */     // MIs[0] policy
     /* 2435620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435630 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435654 */     // GIR_Coverage, 45560,
     /* 2435654 */     GIR_EraseRootFromParent_Done,
     /* 2435655 */   // Label 35222: @2435655
     /* 2435655 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2435727), // Rule ID 45561 //
     /* 2435660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2435669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435692 */     // MIs[0] policy
     /* 2435692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435702 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2435705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435726 */     // GIR_Coverage, 45561,
     /* 2435726 */     GIR_EraseRootFromParent_Done,
     /* 2435727 */   // Label 35223: @2435727
     /* 2435727 */   GIM_Reject,
     /* 2435728 */ // Label 35215: @2435728
     /* 2435728 */ GIM_Reject,
     /* 2435729 */ // Label 35173: @2435729
     /* 2435729 */ GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2436051),
     /* 2435734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2435737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2435740 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2435823), // Rule ID 45454 //
     /* 2435745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435781 */     // MIs[1] Operand 1
     /* 2435781 */     // No operand predicates
     /* 2435781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435785 */     // MIs[0] policy
     /* 2435785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435797 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2435800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435822 */     // GIR_Coverage, 45454,
     /* 2435822 */     GIR_EraseRootFromParent_Done,
     /* 2435823 */   // Label 35225: @2435823
     /* 2435823 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2435906), // Rule ID 45455 //
     /* 2435828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435864 */     // MIs[1] Operand 1
     /* 2435864 */     // No operand predicates
     /* 2435864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435868 */     // MIs[0] policy
     /* 2435868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435880 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2435883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435905 */     // GIR_Coverage, 45455,
     /* 2435905 */     GIR_EraseRootFromParent_Done,
     /* 2435906 */   // Label 35226: @2435906
     /* 2435906 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2435978), // Rule ID 45456 //
     /* 2435911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2435935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435943 */     // MIs[0] policy
     /* 2435943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435953 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2435956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435977 */     // GIR_Coverage, 45456,
     /* 2435977 */     GIR_EraseRootFromParent_Done,
     /* 2435978 */   // Label 35227: @2435978
     /* 2435978 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2436050), // Rule ID 45457 //
     /* 2435983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2435992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2435999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436015 */     // MIs[0] policy
     /* 2436015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436025 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2436028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436049 */     // GIR_Coverage, 45457,
     /* 2436049 */     GIR_EraseRootFromParent_Done,
     /* 2436050 */   // Label 35228: @2436050
     /* 2436050 */   GIM_Reject,
     /* 2436051 */ // Label 35224: @2436051
     /* 2436051 */ GIM_Reject,
     /* 2436052 */ // Label 35174: @2436052
     /* 2436052 */ GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2436684),
     /* 2436057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2436060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2436063 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2436146), // Rule ID 45466 //
     /* 2436068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436104 */     // MIs[1] Operand 1
     /* 2436104 */     // No operand predicates
     /* 2436104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436108 */     // MIs[0] policy
     /* 2436108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436120 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436145 */     // GIR_Coverage, 45466,
     /* 2436145 */     GIR_EraseRootFromParent_Done,
     /* 2436146 */   // Label 35230: @2436146
     /* 2436146 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2436229), // Rule ID 45467 //
     /* 2436151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436187 */     // MIs[1] Operand 1
     /* 2436187 */     // No operand predicates
     /* 2436187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436191 */     // MIs[0] policy
     /* 2436191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436203 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436228 */     // GIR_Coverage, 45467,
     /* 2436228 */     GIR_EraseRootFromParent_Done,
     /* 2436229 */   // Label 35231: @2436229
     /* 2436229 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2436312), // Rule ID 45542 //
     /* 2436234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436270 */     // MIs[1] Operand 1
     /* 2436270 */     // No operand predicates
     /* 2436270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436274 */     // MIs[0] policy
     /* 2436274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436286 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436311 */     // GIR_Coverage, 45542,
     /* 2436311 */     GIR_EraseRootFromParent_Done,
     /* 2436312 */   // Label 35232: @2436312
     /* 2436312 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2436395), // Rule ID 45543 //
     /* 2436317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436353 */     // MIs[1] Operand 1
     /* 2436353 */     // No operand predicates
     /* 2436353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436357 */     // MIs[0] policy
     /* 2436357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436369 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2436372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436394 */     // GIR_Coverage, 45543,
     /* 2436394 */     GIR_EraseRootFromParent_Done,
     /* 2436395 */   // Label 35233: @2436395
     /* 2436395 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2436467), // Rule ID 45468 //
     /* 2436400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436432 */     // MIs[0] policy
     /* 2436432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436442 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436466 */     // GIR_Coverage, 45468,
     /* 2436466 */     GIR_EraseRootFromParent_Done,
     /* 2436467 */   // Label 35234: @2436467
     /* 2436467 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2436539), // Rule ID 45469 //
     /* 2436472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436504 */     // MIs[0] policy
     /* 2436504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436514 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436538 */     // GIR_Coverage, 45469,
     /* 2436538 */     GIR_EraseRootFromParent_Done,
     /* 2436539 */   // Label 35235: @2436539
     /* 2436539 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2436611), // Rule ID 45544 //
     /* 2436544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436576 */     // MIs[0] policy
     /* 2436576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436586 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436610 */     // GIR_Coverage, 45544,
     /* 2436610 */     GIR_EraseRootFromParent_Done,
     /* 2436611 */   // Label 35236: @2436611
     /* 2436611 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2436683), // Rule ID 45545 //
     /* 2436616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436648 */     // MIs[0] policy
     /* 2436648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436658 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2436661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436682 */     // GIR_Coverage, 45545,
     /* 2436682 */     GIR_EraseRootFromParent_Done,
     /* 2436683 */   // Label 35237: @2436683
     /* 2436683 */   GIM_Reject,
     /* 2436684 */ // Label 35229: @2436684
     /* 2436684 */ GIM_Reject,
     /* 2436685 */ // Label 35175: @2436685
     /* 2436685 */ GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2437317),
     /* 2436690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2436693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2436696 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2436779), // Rule ID 45482 //
     /* 2436701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436737 */     // MIs[1] Operand 1
     /* 2436737 */     // No operand predicates
     /* 2436737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436741 */     // MIs[0] policy
     /* 2436741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436753 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436778 */     // GIR_Coverage, 45482,
     /* 2436778 */     GIR_EraseRootFromParent_Done,
     /* 2436779 */   // Label 35239: @2436779
     /* 2436779 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2436862), // Rule ID 45483 //
     /* 2436784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436820 */     // MIs[1] Operand 1
     /* 2436820 */     // No operand predicates
     /* 2436820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436824 */     // MIs[0] policy
     /* 2436824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436836 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436861 */     // GIR_Coverage, 45483,
     /* 2436861 */     GIR_EraseRootFromParent_Done,
     /* 2436862 */   // Label 35240: @2436862
     /* 2436862 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2436945), // Rule ID 45554 //
     /* 2436867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436903 */     // MIs[1] Operand 1
     /* 2436903 */     // No operand predicates
     /* 2436903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436907 */     // MIs[0] policy
     /* 2436907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436919 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2436922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436944 */     // GIR_Coverage, 45554,
     /* 2436944 */     GIR_EraseRootFromParent_Done,
     /* 2436945 */   // Label 35241: @2436945
     /* 2436945 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2437028), // Rule ID 45555 //
     /* 2436950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2436959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2436966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2436974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436986 */     // MIs[1] Operand 1
     /* 2436986 */     // No operand predicates
     /* 2436986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436990 */     // MIs[0] policy
     /* 2436990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437002 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2437005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437027 */     // GIR_Coverage, 45555,
     /* 2437027 */     GIR_EraseRootFromParent_Done,
     /* 2437028 */   // Label 35242: @2437028
     /* 2437028 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2437100), // Rule ID 45484 //
     /* 2437033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437065 */     // MIs[0] policy
     /* 2437065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437075 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437099 */     // GIR_Coverage, 45484,
     /* 2437099 */     GIR_EraseRootFromParent_Done,
     /* 2437100 */   // Label 35243: @2437100
     /* 2437100 */   GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2437172), // Rule ID 45485 //
     /* 2437105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437137 */     // MIs[0] policy
     /* 2437137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437147 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437171 */     // GIR_Coverage, 45485,
     /* 2437171 */     GIR_EraseRootFromParent_Done,
     /* 2437172 */   // Label 35244: @2437172
     /* 2437172 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2437244), // Rule ID 45556 //
     /* 2437177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437209 */     // MIs[0] policy
     /* 2437209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437219 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437243 */     // GIR_Coverage, 45556,
     /* 2437243 */     GIR_EraseRootFromParent_Done,
     /* 2437244 */   // Label 35245: @2437244
     /* 2437244 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2437316), // Rule ID 45557 //
     /* 2437249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437281 */     // MIs[0] policy
     /* 2437281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437291 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2437294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437315 */     // GIR_Coverage, 45557,
     /* 2437315 */     GIR_EraseRootFromParent_Done,
     /* 2437316 */   // Label 35246: @2437316
     /* 2437316 */   GIM_Reject,
     /* 2437317 */ // Label 35238: @2437317
     /* 2437317 */ GIM_Reject,
     /* 2437318 */ // Label 35176: @2437318
     /* 2437318 */ GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2437950),
     /* 2437323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2437326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2437329 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2437412), // Rule ID 45526 //
     /* 2437334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437370 */     // MIs[1] Operand 1
     /* 2437370 */     // No operand predicates
     /* 2437370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437374 */     // MIs[0] policy
     /* 2437374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437386 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437411 */     // GIR_Coverage, 45526,
     /* 2437411 */     GIR_EraseRootFromParent_Done,
     /* 2437412 */   // Label 35248: @2437412
     /* 2437412 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2437495), // Rule ID 45527 //
     /* 2437417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437453 */     // MIs[1] Operand 1
     /* 2437453 */     // No operand predicates
     /* 2437453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437457 */     // MIs[0] policy
     /* 2437457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437469 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437494 */     // GIR_Coverage, 45527,
     /* 2437494 */     GIR_EraseRootFromParent_Done,
     /* 2437495 */   // Label 35249: @2437495
     /* 2437495 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2437578), // Rule ID 45586 //
     /* 2437500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437536 */     // MIs[1] Operand 1
     /* 2437536 */     // No operand predicates
     /* 2437536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437540 */     // MIs[0] policy
     /* 2437540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437552 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437577 */     // GIR_Coverage, 45586,
     /* 2437577 */     GIR_EraseRootFromParent_Done,
     /* 2437578 */   // Label 35250: @2437578
     /* 2437578 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2437661), // Rule ID 45587 //
     /* 2437583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437619 */     // MIs[1] Operand 1
     /* 2437619 */     // No operand predicates
     /* 2437619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437623 */     // MIs[0] policy
     /* 2437623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437635 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2437638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437660 */     // GIR_Coverage, 45587,
     /* 2437660 */     GIR_EraseRootFromParent_Done,
     /* 2437661 */   // Label 35251: @2437661
     /* 2437661 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2437733), // Rule ID 45528 //
     /* 2437666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437698 */     // MIs[0] policy
     /* 2437698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437708 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437732 */     // GIR_Coverage, 45528,
     /* 2437732 */     GIR_EraseRootFromParent_Done,
     /* 2437733 */   // Label 35252: @2437733
     /* 2437733 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2437805), // Rule ID 45529 //
     /* 2437738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437770 */     // MIs[0] policy
     /* 2437770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437780 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437804 */     // GIR_Coverage, 45529,
     /* 2437804 */     GIR_EraseRootFromParent_Done,
     /* 2437805 */   // Label 35253: @2437805
     /* 2437805 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2437877), // Rule ID 45588 //
     /* 2437810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2437813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437842 */     // MIs[0] policy
     /* 2437842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437852 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437876 */     // GIR_Coverage, 45588,
     /* 2437876 */     GIR_EraseRootFromParent_Done,
     /* 2437877 */   // Label 35254: @2437877
     /* 2437877 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2437949), // Rule ID 45589 //
     /* 2437882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2437885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2437891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437914 */     // MIs[0] policy
     /* 2437914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437924 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2437927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2437945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437948 */     // GIR_Coverage, 45589,
     /* 2437948 */     GIR_EraseRootFromParent_Done,
     /* 2437949 */   // Label 35255: @2437949
     /* 2437949 */   GIM_Reject,
     /* 2437950 */ // Label 35247: @2437950
     /* 2437950 */ GIM_Reject,
     /* 2437951 */ // Label 35177: @2437951
     /* 2437951 */ GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2438273),
     /* 2437956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2437959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2437962 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2438045), // Rule ID 45458 //
     /* 2437967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2437976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2437983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2437991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438003 */     // MIs[1] Operand 1
     /* 2438003 */     // No operand predicates
     /* 2438003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438007 */     // MIs[0] policy
     /* 2438007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438019 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2438022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438044 */     // GIR_Coverage, 45458,
     /* 2438044 */     GIR_EraseRootFromParent_Done,
     /* 2438045 */   // Label 35257: @2438045
     /* 2438045 */   GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2438128), // Rule ID 45459 //
     /* 2438050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438086 */     // MIs[1] Operand 1
     /* 2438086 */     // No operand predicates
     /* 2438086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438090 */     // MIs[0] policy
     /* 2438090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438102 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2438105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438127 */     // GIR_Coverage, 45459,
     /* 2438127 */     GIR_EraseRootFromParent_Done,
     /* 2438128 */   // Label 35258: @2438128
     /* 2438128 */   GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2438200), // Rule ID 45460 //
     /* 2438133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438165 */     // MIs[0] policy
     /* 2438165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438175 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2438178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438199 */     // GIR_Coverage, 45460,
     /* 2438199 */     GIR_EraseRootFromParent_Done,
     /* 2438200 */   // Label 35259: @2438200
     /* 2438200 */   GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2438272), // Rule ID 45461 //
     /* 2438205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438237 */     // MIs[0] policy
     /* 2438237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438247 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2438250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438271 */     // GIR_Coverage, 45461,
     /* 2438271 */     GIR_EraseRootFromParent_Done,
     /* 2438272 */   // Label 35260: @2438272
     /* 2438272 */   GIM_Reject,
     /* 2438273 */ // Label 35256: @2438273
     /* 2438273 */ GIM_Reject,
     /* 2438274 */ // Label 35178: @2438274
     /* 2438274 */ GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2438906),
     /* 2438279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2438282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2438285 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2438368), // Rule ID 45478 //
     /* 2438290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438326 */     // MIs[1] Operand 1
     /* 2438326 */     // No operand predicates
     /* 2438326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438330 */     // MIs[0] policy
     /* 2438330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438342 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438367 */     // GIR_Coverage, 45478,
     /* 2438367 */     GIR_EraseRootFromParent_Done,
     /* 2438368 */   // Label 35262: @2438368
     /* 2438368 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2438451), // Rule ID 45479 //
     /* 2438373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438409 */     // MIs[1] Operand 1
     /* 2438409 */     // No operand predicates
     /* 2438409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438413 */     // MIs[0] policy
     /* 2438413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438425 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438450 */     // GIR_Coverage, 45479,
     /* 2438450 */     GIR_EraseRootFromParent_Done,
     /* 2438451 */   // Label 35263: @2438451
     /* 2438451 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2438534), // Rule ID 45550 //
     /* 2438456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438492 */     // MIs[1] Operand 1
     /* 2438492 */     // No operand predicates
     /* 2438492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438496 */     // MIs[0] policy
     /* 2438496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438508 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438533 */     // GIR_Coverage, 45550,
     /* 2438533 */     GIR_EraseRootFromParent_Done,
     /* 2438534 */   // Label 35264: @2438534
     /* 2438534 */   GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2438617), // Rule ID 45551 //
     /* 2438539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438575 */     // MIs[1] Operand 1
     /* 2438575 */     // No operand predicates
     /* 2438575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438579 */     // MIs[0] policy
     /* 2438579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438591 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2438594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438616 */     // GIR_Coverage, 45551,
     /* 2438616 */     GIR_EraseRootFromParent_Done,
     /* 2438617 */   // Label 35265: @2438617
     /* 2438617 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2438689), // Rule ID 45480 //
     /* 2438622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438654 */     // MIs[0] policy
     /* 2438654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438664 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438688 */     // GIR_Coverage, 45480,
     /* 2438688 */     GIR_EraseRootFromParent_Done,
     /* 2438689 */   // Label 35266: @2438689
     /* 2438689 */   GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2438761), // Rule ID 45481 //
     /* 2438694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438726 */     // MIs[0] policy
     /* 2438726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438736 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438760 */     // GIR_Coverage, 45481,
     /* 2438760 */     GIR_EraseRootFromParent_Done,
     /* 2438761 */   // Label 35267: @2438761
     /* 2438761 */   GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2438833), // Rule ID 45552 //
     /* 2438766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438798 */     // MIs[0] policy
     /* 2438798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438808 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438832 */     // GIR_Coverage, 45552,
     /* 2438832 */     GIR_EraseRootFromParent_Done,
     /* 2438833 */   // Label 35268: @2438833
     /* 2438833 */   GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2438905), // Rule ID 45553 //
     /* 2438838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2438854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2438862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438870 */     // MIs[0] policy
     /* 2438870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438880 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2438883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438904 */     // GIR_Coverage, 45553,
     /* 2438904 */     GIR_EraseRootFromParent_Done,
     /* 2438905 */   // Label 35269: @2438905
     /* 2438905 */   GIM_Reject,
     /* 2438906 */ // Label 35261: @2438906
     /* 2438906 */ GIM_Reject,
     /* 2438907 */ // Label 35179: @2438907
     /* 2438907 */ GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2439539),
     /* 2438912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2438915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2438918 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2439001), // Rule ID 45514 //
     /* 2438923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2438932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2438939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2438947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438959 */     // MIs[1] Operand 1
     /* 2438959 */     // No operand predicates
     /* 2438959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438963 */     // MIs[0] policy
     /* 2438963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438975 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2438978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439000 */     // GIR_Coverage, 45514,
     /* 2439000 */     GIR_EraseRootFromParent_Done,
     /* 2439001 */   // Label 35271: @2439001
     /* 2439001 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2439084), // Rule ID 45515 //
     /* 2439006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439042 */     // MIs[1] Operand 1
     /* 2439042 */     // No operand predicates
     /* 2439042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439046 */     // MIs[0] policy
     /* 2439046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439058 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439083 */     // GIR_Coverage, 45515,
     /* 2439083 */     GIR_EraseRootFromParent_Done,
     /* 2439084 */   // Label 35272: @2439084
     /* 2439084 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2439167), // Rule ID 45574 //
     /* 2439089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439125 */     // MIs[1] Operand 1
     /* 2439125 */     // No operand predicates
     /* 2439125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439129 */     // MIs[0] policy
     /* 2439129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439141 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439166 */     // GIR_Coverage, 45574,
     /* 2439166 */     GIR_EraseRootFromParent_Done,
     /* 2439167 */   // Label 35273: @2439167
     /* 2439167 */   GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2439250), // Rule ID 45575 //
     /* 2439172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439208 */     // MIs[1] Operand 1
     /* 2439208 */     // No operand predicates
     /* 2439208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439212 */     // MIs[0] policy
     /* 2439212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439224 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2439227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439249 */     // GIR_Coverage, 45575,
     /* 2439249 */     GIR_EraseRootFromParent_Done,
     /* 2439250 */   // Label 35274: @2439250
     /* 2439250 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2439322), // Rule ID 45516 //
     /* 2439255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439287 */     // MIs[0] policy
     /* 2439287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439297 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439321 */     // GIR_Coverage, 45516,
     /* 2439321 */     GIR_EraseRootFromParent_Done,
     /* 2439322 */   // Label 35275: @2439322
     /* 2439322 */   GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2439394), // Rule ID 45517 //
     /* 2439327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439359 */     // MIs[0] policy
     /* 2439359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439369 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439393 */     // GIR_Coverage, 45517,
     /* 2439393 */     GIR_EraseRootFromParent_Done,
     /* 2439394 */   // Label 35276: @2439394
     /* 2439394 */   GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2439466), // Rule ID 45576 //
     /* 2439399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439431 */     // MIs[0] policy
     /* 2439431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439441 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439465 */     // GIR_Coverage, 45576,
     /* 2439465 */     GIR_EraseRootFromParent_Done,
     /* 2439466 */   // Label 35277: @2439466
     /* 2439466 */   GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2439538), // Rule ID 45577 //
     /* 2439471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2439487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2439495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439503 */     // MIs[0] policy
     /* 2439503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439513 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2439516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2439534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439537 */     // GIR_Coverage, 45577,
     /* 2439537 */     GIR_EraseRootFromParent_Done,
     /* 2439538 */   // Label 35278: @2439538
     /* 2439538 */   GIM_Reject,
     /* 2439539 */ // Label 35270: @2439539
     /* 2439539 */ GIM_Reject,
     /* 2439540 */ // Label 35180: @2439540
     /* 2439540 */ GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2440172),
     /* 2439545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2439548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2439551 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2439634), // Rule ID 45530 //
     /* 2439556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439592 */     // MIs[1] Operand 1
     /* 2439592 */     // No operand predicates
     /* 2439592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439596 */     // MIs[0] policy
     /* 2439596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439608 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439633 */     // GIR_Coverage, 45530,
     /* 2439633 */     GIR_EraseRootFromParent_Done,
     /* 2439634 */   // Label 35280: @2439634
     /* 2439634 */   GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2439717), // Rule ID 45531 //
     /* 2439639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439675 */     // MIs[1] Operand 1
     /* 2439675 */     // No operand predicates
     /* 2439675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439679 */     // MIs[0] policy
     /* 2439679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439691 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439716 */     // GIR_Coverage, 45531,
     /* 2439716 */     GIR_EraseRootFromParent_Done,
     /* 2439717 */   // Label 35281: @2439717
     /* 2439717 */   GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2439800), // Rule ID 45590 //
     /* 2439722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439758 */     // MIs[1] Operand 1
     /* 2439758 */     // No operand predicates
     /* 2439758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439762 */     // MIs[0] policy
     /* 2439762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439774 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439799 */     // GIR_Coverage, 45590,
     /* 2439799 */     GIR_EraseRootFromParent_Done,
     /* 2439800 */   // Label 35282: @2439800
     /* 2439800 */   GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2439883), // Rule ID 45591 //
     /* 2439805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439841 */     // MIs[1] Operand 1
     /* 2439841 */     // No operand predicates
     /* 2439841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439845 */     // MIs[0] policy
     /* 2439845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439857 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2439860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439882 */     // GIR_Coverage, 45591,
     /* 2439882 */     GIR_EraseRootFromParent_Done,
     /* 2439883 */   // Label 35283: @2439883
     /* 2439883 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2439955), // Rule ID 45532 //
     /* 2439888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2439891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439920 */     // MIs[0] policy
     /* 2439920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439930 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2439933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2439951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439954 */     // GIR_Coverage, 45532,
     /* 2439954 */     GIR_EraseRootFromParent_Done,
     /* 2439955 */   // Label 35284: @2439955
     /* 2439955 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2440027), // Rule ID 45533 //
     /* 2439960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2439963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2439969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2439976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2439984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439992 */     // MIs[0] policy
     /* 2439992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440002 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440026 */     // GIR_Coverage, 45533,
     /* 2440026 */     GIR_EraseRootFromParent_Done,
     /* 2440027 */   // Label 35285: @2440027
     /* 2440027 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2440099), // Rule ID 45592 //
     /* 2440032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2440035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2440041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440064 */     // MIs[0] policy
     /* 2440064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440074 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440098 */     // GIR_Coverage, 45592,
     /* 2440098 */     GIR_EraseRootFromParent_Done,
     /* 2440099 */   // Label 35286: @2440099
     /* 2440099 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2440171), // Rule ID 45593 //
     /* 2440104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2440107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2440113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2440120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2440128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440136 */     // MIs[0] policy
     /* 2440136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440146 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2440149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440170 */     // GIR_Coverage, 45593,
     /* 2440170 */     GIR_EraseRootFromParent_Done,
     /* 2440171 */   // Label 35287: @2440171
     /* 2440171 */   GIM_Reject,
     /* 2440172 */ // Label 35279: @2440172
     /* 2440172 */ GIM_Reject,
     /* 2440173 */ // Label 35181: @2440173
     /* 2440173 */ GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2440495),
     /* 2440178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2440181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2440184 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2440267), // Rule ID 45474 //
     /* 2440189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440225 */     // MIs[1] Operand 1
     /* 2440225 */     // No operand predicates
     /* 2440225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440229 */     // MIs[0] policy
     /* 2440229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440241 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2440244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440266 */     // GIR_Coverage, 45474,
     /* 2440266 */     GIR_EraseRootFromParent_Done,
     /* 2440267 */   // Label 35289: @2440267
     /* 2440267 */   GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2440350), // Rule ID 45475 //
     /* 2440272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440308 */     // MIs[1] Operand 1
     /* 2440308 */     // No operand predicates
     /* 2440308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440312 */     // MIs[0] policy
     /* 2440312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440324 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2440327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440349 */     // GIR_Coverage, 45475,
     /* 2440349 */     GIR_EraseRootFromParent_Done,
     /* 2440350 */   // Label 35290: @2440350
     /* 2440350 */   GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2440422), // Rule ID 45476 //
     /* 2440355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440387 */     // MIs[0] policy
     /* 2440387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440397 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2440400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440421 */     // GIR_Coverage, 45476,
     /* 2440421 */     GIR_EraseRootFromParent_Done,
     /* 2440422 */   // Label 35291: @2440422
     /* 2440422 */   GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2440494), // Rule ID 45477 //
     /* 2440427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440459 */     // MIs[0] policy
     /* 2440459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440469 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2440472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2440490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440493 */     // GIR_Coverage, 45477,
     /* 2440493 */     GIR_EraseRootFromParent_Done,
     /* 2440494 */   // Label 35292: @2440494
     /* 2440494 */   GIM_Reject,
     /* 2440495 */ // Label 35288: @2440495
     /* 2440495 */ GIM_Reject,
     /* 2440496 */ // Label 35182: @2440496
     /* 2440496 */ GIM_Try, /*On fail goto*//*Label 35293*/ GIMT_Encode4(2441128),
     /* 2440501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2440504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2440507 */   GIM_Try, /*On fail goto*//*Label 35294*/ GIMT_Encode4(2440590), // Rule ID 45502 //
     /* 2440512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440548 */     // MIs[1] Operand 1
     /* 2440548 */     // No operand predicates
     /* 2440548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440552 */     // MIs[0] policy
     /* 2440552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440564 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440589 */     // GIR_Coverage, 45502,
     /* 2440589 */     GIR_EraseRootFromParent_Done,
     /* 2440590 */   // Label 35294: @2440590
     /* 2440590 */   GIM_Try, /*On fail goto*//*Label 35295*/ GIMT_Encode4(2440673), // Rule ID 45503 //
     /* 2440595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440631 */     // MIs[1] Operand 1
     /* 2440631 */     // No operand predicates
     /* 2440631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440635 */     // MIs[0] policy
     /* 2440635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440647 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440672 */     // GIR_Coverage, 45503,
     /* 2440672 */     GIR_EraseRootFromParent_Done,
     /* 2440673 */   // Label 35295: @2440673
     /* 2440673 */   GIM_Try, /*On fail goto*//*Label 35296*/ GIMT_Encode4(2440756), // Rule ID 45562 //
     /* 2440678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440714 */     // MIs[1] Operand 1
     /* 2440714 */     // No operand predicates
     /* 2440714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440718 */     // MIs[0] policy
     /* 2440718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440730 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440755 */     // GIR_Coverage, 45562,
     /* 2440755 */     GIR_EraseRootFromParent_Done,
     /* 2440756 */   // Label 35296: @2440756
     /* 2440756 */   GIM_Try, /*On fail goto*//*Label 35297*/ GIMT_Encode4(2440839), // Rule ID 45563 //
     /* 2440761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440797 */     // MIs[1] Operand 1
     /* 2440797 */     // No operand predicates
     /* 2440797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440801 */     // MIs[0] policy
     /* 2440801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440813 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2440816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440838 */     // GIR_Coverage, 45563,
     /* 2440838 */     GIR_EraseRootFromParent_Done,
     /* 2440839 */   // Label 35297: @2440839
     /* 2440839 */   GIM_Try, /*On fail goto*//*Label 35298*/ GIMT_Encode4(2440911), // Rule ID 45504 //
     /* 2440844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440876 */     // MIs[0] policy
     /* 2440876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440886 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2440889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440910 */     // GIR_Coverage, 45504,
     /* 2440910 */     GIR_EraseRootFromParent_Done,
     /* 2440911 */   // Label 35298: @2440911
     /* 2440911 */   GIM_Try, /*On fail goto*//*Label 35299*/ GIMT_Encode4(2440983), // Rule ID 45505 //
     /* 2440916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2440932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2440940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440948 */     // MIs[0] policy
     /* 2440948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440958 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2440961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440982 */     // GIR_Coverage, 45505,
     /* 2440982 */     GIR_EraseRootFromParent_Done,
     /* 2440983 */   // Label 35299: @2440983
     /* 2440983 */   GIM_Try, /*On fail goto*//*Label 35300*/ GIMT_Encode4(2441055), // Rule ID 45564 //
     /* 2440988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2440997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2441004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441020 */     // MIs[0] policy
     /* 2441020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441030 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2441033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441054 */     // GIR_Coverage, 45564,
     /* 2441054 */     GIR_EraseRootFromParent_Done,
     /* 2441055 */   // Label 35300: @2441055
     /* 2441055 */   GIM_Try, /*On fail goto*//*Label 35301*/ GIMT_Encode4(2441127), // Rule ID 45565 //
     /* 2441060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2441076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2441084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441092 */     // MIs[0] policy
     /* 2441092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441102 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2441105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441126 */     // GIR_Coverage, 45565,
     /* 2441126 */     GIR_EraseRootFromParent_Done,
     /* 2441127 */   // Label 35301: @2441127
     /* 2441127 */   GIM_Reject,
     /* 2441128 */ // Label 35293: @2441128
     /* 2441128 */ GIM_Reject,
     /* 2441129 */ // Label 35183: @2441129
     /* 2441129 */ GIM_Try, /*On fail goto*//*Label 35302*/ GIMT_Encode4(2441761),
     /* 2441134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2441137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2441140 */   GIM_Try, /*On fail goto*//*Label 35303*/ GIMT_Encode4(2441223), // Rule ID 45518 //
     /* 2441145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441181 */     // MIs[1] Operand 1
     /* 2441181 */     // No operand predicates
     /* 2441181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441185 */     // MIs[0] policy
     /* 2441185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441197 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441222 */     // GIR_Coverage, 45518,
     /* 2441222 */     GIR_EraseRootFromParent_Done,
     /* 2441223 */   // Label 35303: @2441223
     /* 2441223 */   GIM_Try, /*On fail goto*//*Label 35304*/ GIMT_Encode4(2441306), // Rule ID 45519 //
     /* 2441228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441264 */     // MIs[1] Operand 1
     /* 2441264 */     // No operand predicates
     /* 2441264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441268 */     // MIs[0] policy
     /* 2441268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441280 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441305 */     // GIR_Coverage, 45519,
     /* 2441305 */     GIR_EraseRootFromParent_Done,
     /* 2441306 */   // Label 35304: @2441306
     /* 2441306 */   GIM_Try, /*On fail goto*//*Label 35305*/ GIMT_Encode4(2441389), // Rule ID 45578 //
     /* 2441311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441347 */     // MIs[1] Operand 1
     /* 2441347 */     // No operand predicates
     /* 2441347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441351 */     // MIs[0] policy
     /* 2441351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441363 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441388 */     // GIR_Coverage, 45578,
     /* 2441388 */     GIR_EraseRootFromParent_Done,
     /* 2441389 */   // Label 35305: @2441389
     /* 2441389 */   GIM_Try, /*On fail goto*//*Label 35306*/ GIMT_Encode4(2441472), // Rule ID 45579 //
     /* 2441394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441430 */     // MIs[1] Operand 1
     /* 2441430 */     // No operand predicates
     /* 2441430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441434 */     // MIs[0] policy
     /* 2441434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441446 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2441449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441471 */     // GIR_Coverage, 45579,
     /* 2441471 */     GIR_EraseRootFromParent_Done,
     /* 2441472 */   // Label 35306: @2441472
     /* 2441472 */   GIM_Try, /*On fail goto*//*Label 35307*/ GIMT_Encode4(2441544), // Rule ID 45520 //
     /* 2441477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441509 */     // MIs[0] policy
     /* 2441509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441519 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441543 */     // GIR_Coverage, 45520,
     /* 2441543 */     GIR_EraseRootFromParent_Done,
     /* 2441544 */   // Label 35307: @2441544
     /* 2441544 */   GIM_Try, /*On fail goto*//*Label 35308*/ GIMT_Encode4(2441616), // Rule ID 45521 //
     /* 2441549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441581 */     // MIs[0] policy
     /* 2441581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441591 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441615 */     // GIR_Coverage, 45521,
     /* 2441615 */     GIR_EraseRootFromParent_Done,
     /* 2441616 */   // Label 35308: @2441616
     /* 2441616 */   GIM_Try, /*On fail goto*//*Label 35309*/ GIMT_Encode4(2441688), // Rule ID 45580 //
     /* 2441621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441653 */     // MIs[0] policy
     /* 2441653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441663 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441687 */     // GIR_Coverage, 45580,
     /* 2441687 */     GIR_EraseRootFromParent_Done,
     /* 2441688 */   // Label 35309: @2441688
     /* 2441688 */   GIM_Try, /*On fail goto*//*Label 35310*/ GIMT_Encode4(2441760), // Rule ID 45581 //
     /* 2441693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2441709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2441717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441725 */     // MIs[0] policy
     /* 2441725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441735 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2441738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2441756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441759 */     // GIR_Coverage, 45581,
     /* 2441759 */     GIR_EraseRootFromParent_Done,
     /* 2441760 */   // Label 35310: @2441760
     /* 2441760 */   GIM_Reject,
     /* 2441761 */ // Label 35302: @2441761
     /* 2441761 */ GIM_Reject,
     /* 2441762 */ // Label 35184: @2441762
     /* 2441762 */ GIM_Try, /*On fail goto*//*Label 35311*/ GIMT_Encode4(2442394),
     /* 2441767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2441770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2441773 */   GIM_Try, /*On fail goto*//*Label 35312*/ GIMT_Encode4(2441856), // Rule ID 45534 //
     /* 2441778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441814 */     // MIs[1] Operand 1
     /* 2441814 */     // No operand predicates
     /* 2441814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441818 */     // MIs[0] policy
     /* 2441818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441830 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441855 */     // GIR_Coverage, 45534,
     /* 2441855 */     GIR_EraseRootFromParent_Done,
     /* 2441856 */   // Label 35312: @2441856
     /* 2441856 */   GIM_Try, /*On fail goto*//*Label 35313*/ GIMT_Encode4(2441939), // Rule ID 45535 //
     /* 2441861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441897 */     // MIs[1] Operand 1
     /* 2441897 */     // No operand predicates
     /* 2441897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441901 */     // MIs[0] policy
     /* 2441901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441913 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441938 */     // GIR_Coverage, 45535,
     /* 2441938 */     GIR_EraseRootFromParent_Done,
     /* 2441939 */   // Label 35313: @2441939
     /* 2441939 */   GIM_Try, /*On fail goto*//*Label 35314*/ GIMT_Encode4(2442022), // Rule ID 45594 //
     /* 2441944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2441953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2441960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2441968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441980 */     // MIs[1] Operand 1
     /* 2441980 */     // No operand predicates
     /* 2441980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441984 */     // MIs[0] policy
     /* 2441984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441996 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2441999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442021 */     // GIR_Coverage, 45594,
     /* 2442021 */     GIR_EraseRootFromParent_Done,
     /* 2442022 */   // Label 35314: @2442022
     /* 2442022 */   GIM_Try, /*On fail goto*//*Label 35315*/ GIMT_Encode4(2442105), // Rule ID 45595 //
     /* 2442027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442063 */     // MIs[1] Operand 1
     /* 2442063 */     // No operand predicates
     /* 2442063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442067 */     // MIs[0] policy
     /* 2442067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442079 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2442082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442104 */     // GIR_Coverage, 45595,
     /* 2442104 */     GIR_EraseRootFromParent_Done,
     /* 2442105 */   // Label 35315: @2442105
     /* 2442105 */   GIM_Try, /*On fail goto*//*Label 35316*/ GIMT_Encode4(2442177), // Rule ID 45536 //
     /* 2442110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2442113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442142 */     // MIs[0] policy
     /* 2442142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442152 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442176 */     // GIR_Coverage, 45536,
     /* 2442176 */     GIR_EraseRootFromParent_Done,
     /* 2442177 */   // Label 35316: @2442177
     /* 2442177 */   GIM_Try, /*On fail goto*//*Label 35317*/ GIMT_Encode4(2442249), // Rule ID 45537 //
     /* 2442182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442214 */     // MIs[0] policy
     /* 2442214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442224 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442248 */     // GIR_Coverage, 45537,
     /* 2442248 */     GIR_EraseRootFromParent_Done,
     /* 2442249 */   // Label 35317: @2442249
     /* 2442249 */   GIM_Try, /*On fail goto*//*Label 35318*/ GIMT_Encode4(2442321), // Rule ID 45596 //
     /* 2442254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2442257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442286 */     // MIs[0] policy
     /* 2442286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442296 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442320 */     // GIR_Coverage, 45596,
     /* 2442320 */     GIR_EraseRootFromParent_Done,
     /* 2442321 */   // Label 35318: @2442321
     /* 2442321 */   GIM_Try, /*On fail goto*//*Label 35319*/ GIMT_Encode4(2442393), // Rule ID 45597 //
     /* 2442326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2442329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2442335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2442342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2442350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442358 */     // MIs[0] policy
     /* 2442358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442368 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2442371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2442389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442392 */     // GIR_Coverage, 45597,
     /* 2442392 */     GIR_EraseRootFromParent_Done,
     /* 2442393 */   // Label 35319: @2442393
     /* 2442393 */   GIM_Reject,
     /* 2442394 */ // Label 35311: @2442394
     /* 2442394 */ GIM_Reject,
     /* 2442395 */ // Label 35185: @2442395
     /* 2442395 */ GIM_Try, /*On fail goto*//*Label 35320*/ GIMT_Encode4(2442717),
     /* 2442400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2442403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2442406 */   GIM_Try, /*On fail goto*//*Label 35321*/ GIMT_Encode4(2442489), // Rule ID 45490 //
     /* 2442411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442447 */     // MIs[1] Operand 1
     /* 2442447 */     // No operand predicates
     /* 2442447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442451 */     // MIs[0] policy
     /* 2442451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442463 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2442466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442488 */     // GIR_Coverage, 45490,
     /* 2442488 */     GIR_EraseRootFromParent_Done,
     /* 2442489 */   // Label 35321: @2442489
     /* 2442489 */   GIM_Try, /*On fail goto*//*Label 35322*/ GIMT_Encode4(2442572), // Rule ID 45491 //
     /* 2442494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442530 */     // MIs[1] Operand 1
     /* 2442530 */     // No operand predicates
     /* 2442530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442534 */     // MIs[0] policy
     /* 2442534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442546 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2442549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442571 */     // GIR_Coverage, 45491,
     /* 2442571 */     GIR_EraseRootFromParent_Done,
     /* 2442572 */   // Label 35322: @2442572
     /* 2442572 */   GIM_Try, /*On fail goto*//*Label 35323*/ GIMT_Encode4(2442644), // Rule ID 45492 //
     /* 2442577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442609 */     // MIs[0] policy
     /* 2442609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442619 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2442622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442643 */     // GIR_Coverage, 45492,
     /* 2442643 */     GIR_EraseRootFromParent_Done,
     /* 2442644 */   // Label 35323: @2442644
     /* 2442644 */   GIM_Try, /*On fail goto*//*Label 35324*/ GIMT_Encode4(2442716), // Rule ID 45493 //
     /* 2442649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2442665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2442673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442681 */     // MIs[0] policy
     /* 2442681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442691 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2442694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2442712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442715 */     // GIR_Coverage, 45493,
     /* 2442715 */     GIR_EraseRootFromParent_Done,
     /* 2442716 */   // Label 35324: @2442716
     /* 2442716 */   GIM_Reject,
     /* 2442717 */ // Label 35320: @2442717
     /* 2442717 */ GIM_Reject,
     /* 2442718 */ // Label 35186: @2442718
     /* 2442718 */ GIM_Try, /*On fail goto*//*Label 35325*/ GIMT_Encode4(2443350),
     /* 2442723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2442726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2442729 */   GIM_Try, /*On fail goto*//*Label 35326*/ GIMT_Encode4(2442812), // Rule ID 45506 //
     /* 2442734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442770 */     // MIs[1] Operand 1
     /* 2442770 */     // No operand predicates
     /* 2442770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442774 */     // MIs[0] policy
     /* 2442774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442786 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442811 */     // GIR_Coverage, 45506,
     /* 2442811 */     GIR_EraseRootFromParent_Done,
     /* 2442812 */   // Label 35326: @2442812
     /* 2442812 */   GIM_Try, /*On fail goto*//*Label 35327*/ GIMT_Encode4(2442895), // Rule ID 45507 //
     /* 2442817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442853 */     // MIs[1] Operand 1
     /* 2442853 */     // No operand predicates
     /* 2442853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442857 */     // MIs[0] policy
     /* 2442857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442869 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442894 */     // GIR_Coverage, 45507,
     /* 2442894 */     GIR_EraseRootFromParent_Done,
     /* 2442895 */   // Label 35327: @2442895
     /* 2442895 */   GIM_Try, /*On fail goto*//*Label 35328*/ GIMT_Encode4(2442978), // Rule ID 45566 //
     /* 2442900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2442924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442936 */     // MIs[1] Operand 1
     /* 2442936 */     // No operand predicates
     /* 2442936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442940 */     // MIs[0] policy
     /* 2442940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442952 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2442955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442977 */     // GIR_Coverage, 45566,
     /* 2442977 */     GIR_EraseRootFromParent_Done,
     /* 2442978 */   // Label 35328: @2442978
     /* 2442978 */   GIM_Try, /*On fail goto*//*Label 35329*/ GIMT_Encode4(2443061), // Rule ID 45567 //
     /* 2442983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2442992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2442999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443019 */     // MIs[1] Operand 1
     /* 2443019 */     // No operand predicates
     /* 2443019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443023 */     // MIs[0] policy
     /* 2443023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443035 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2443038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443060 */     // GIR_Coverage, 45567,
     /* 2443060 */     GIR_EraseRootFromParent_Done,
     /* 2443061 */   // Label 35329: @2443061
     /* 2443061 */   GIM_Try, /*On fail goto*//*Label 35330*/ GIMT_Encode4(2443133), // Rule ID 45508 //
     /* 2443066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443098 */     // MIs[0] policy
     /* 2443098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443108 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443132 */     // GIR_Coverage, 45508,
     /* 2443132 */     GIR_EraseRootFromParent_Done,
     /* 2443133 */   // Label 35330: @2443133
     /* 2443133 */   GIM_Try, /*On fail goto*//*Label 35331*/ GIMT_Encode4(2443205), // Rule ID 45509 //
     /* 2443138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443170 */     // MIs[0] policy
     /* 2443170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443180 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443204 */     // GIR_Coverage, 45509,
     /* 2443204 */     GIR_EraseRootFromParent_Done,
     /* 2443205 */   // Label 35331: @2443205
     /* 2443205 */   GIM_Try, /*On fail goto*//*Label 35332*/ GIMT_Encode4(2443277), // Rule ID 45568 //
     /* 2443210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443242 */     // MIs[0] policy
     /* 2443242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443252 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443276 */     // GIR_Coverage, 45568,
     /* 2443276 */     GIR_EraseRootFromParent_Done,
     /* 2443277 */   // Label 35332: @2443277
     /* 2443277 */   GIM_Try, /*On fail goto*//*Label 35333*/ GIMT_Encode4(2443349), // Rule ID 45569 //
     /* 2443282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2443298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2443306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443314 */     // MIs[0] policy
     /* 2443314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443324 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2443327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2443345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443348 */     // GIR_Coverage, 45569,
     /* 2443348 */     GIR_EraseRootFromParent_Done,
     /* 2443349 */   // Label 35333: @2443349
     /* 2443349 */   GIM_Reject,
     /* 2443350 */ // Label 35325: @2443350
     /* 2443350 */ GIM_Reject,
     /* 2443351 */ // Label 35187: @2443351
     /* 2443351 */ GIM_Try, /*On fail goto*//*Label 35334*/ GIMT_Encode4(2443983),
     /* 2443356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2443359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2443362 */   GIM_Try, /*On fail goto*//*Label 35335*/ GIMT_Encode4(2443445), // Rule ID 45522 //
     /* 2443367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443403 */     // MIs[1] Operand 1
     /* 2443403 */     // No operand predicates
     /* 2443403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443407 */     // MIs[0] policy
     /* 2443407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443419 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443444 */     // GIR_Coverage, 45522,
     /* 2443444 */     GIR_EraseRootFromParent_Done,
     /* 2443445 */   // Label 35335: @2443445
     /* 2443445 */   GIM_Try, /*On fail goto*//*Label 35336*/ GIMT_Encode4(2443528), // Rule ID 45523 //
     /* 2443450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443486 */     // MIs[1] Operand 1
     /* 2443486 */     // No operand predicates
     /* 2443486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443490 */     // MIs[0] policy
     /* 2443490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443502 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443527 */     // GIR_Coverage, 45523,
     /* 2443527 */     GIR_EraseRootFromParent_Done,
     /* 2443528 */   // Label 35336: @2443528
     /* 2443528 */   GIM_Try, /*On fail goto*//*Label 35337*/ GIMT_Encode4(2443611), // Rule ID 45582 //
     /* 2443533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443569 */     // MIs[1] Operand 1
     /* 2443569 */     // No operand predicates
     /* 2443569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443573 */     // MIs[0] policy
     /* 2443573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443585 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443610 */     // GIR_Coverage, 45582,
     /* 2443610 */     GIR_EraseRootFromParent_Done,
     /* 2443611 */   // Label 35337: @2443611
     /* 2443611 */   GIM_Try, /*On fail goto*//*Label 35338*/ GIMT_Encode4(2443694), // Rule ID 45583 //
     /* 2443616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443652 */     // MIs[1] Operand 1
     /* 2443652 */     // No operand predicates
     /* 2443652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443656 */     // MIs[0] policy
     /* 2443656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443668 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2443671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443693 */     // GIR_Coverage, 45583,
     /* 2443693 */     GIR_EraseRootFromParent_Done,
     /* 2443694 */   // Label 35338: @2443694
     /* 2443694 */   GIM_Try, /*On fail goto*//*Label 35339*/ GIMT_Encode4(2443766), // Rule ID 45524 //
     /* 2443699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443731 */     // MIs[0] policy
     /* 2443731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443741 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443765 */     // GIR_Coverage, 45524,
     /* 2443765 */     GIR_EraseRootFromParent_Done,
     /* 2443766 */   // Label 35339: @2443766
     /* 2443766 */   GIM_Try, /*On fail goto*//*Label 35340*/ GIMT_Encode4(2443838), // Rule ID 45525 //
     /* 2443771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443803 */     // MIs[0] policy
     /* 2443803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443813 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443837 */     // GIR_Coverage, 45525,
     /* 2443837 */     GIR_EraseRootFromParent_Done,
     /* 2443838 */   // Label 35340: @2443838
     /* 2443838 */   GIM_Try, /*On fail goto*//*Label 35341*/ GIMT_Encode4(2443910), // Rule ID 45584 //
     /* 2443843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443875 */     // MIs[0] policy
     /* 2443875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443885 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443909 */     // GIR_Coverage, 45584,
     /* 2443909 */     GIR_EraseRootFromParent_Done,
     /* 2443910 */   // Label 35341: @2443910
     /* 2443910 */   GIM_Try, /*On fail goto*//*Label 35342*/ GIMT_Encode4(2443982), // Rule ID 45585 //
     /* 2443915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2443924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2443931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2443939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443947 */     // MIs[0] policy
     /* 2443947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443957 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2443960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443981 */     // GIR_Coverage, 45585,
     /* 2443981 */     GIR_EraseRootFromParent_Done,
     /* 2443982 */   // Label 35342: @2443982
     /* 2443982 */   GIM_Reject,
     /* 2443983 */ // Label 35334: @2443983
     /* 2443983 */ GIM_Reject,
     /* 2443984 */ // Label 35188: @2443984
     /* 2443984 */ GIM_Try, /*On fail goto*//*Label 35343*/ GIMT_Encode4(2444306),
     /* 2443989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2443992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2443995 */   GIM_Try, /*On fail goto*//*Label 35344*/ GIMT_Encode4(2444078), // Rule ID 45494 //
     /* 2444000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444036 */     // MIs[1] Operand 1
     /* 2444036 */     // No operand predicates
     /* 2444036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444040 */     // MIs[0] policy
     /* 2444040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444052 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2444055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444077 */     // GIR_Coverage, 45494,
     /* 2444077 */     GIR_EraseRootFromParent_Done,
     /* 2444078 */   // Label 35344: @2444078
     /* 2444078 */   GIM_Try, /*On fail goto*//*Label 35345*/ GIMT_Encode4(2444161), // Rule ID 45495 //
     /* 2444083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444119 */     // MIs[1] Operand 1
     /* 2444119 */     // No operand predicates
     /* 2444119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444123 */     // MIs[0] policy
     /* 2444123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444135 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2444138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444160 */     // GIR_Coverage, 45495,
     /* 2444160 */     GIR_EraseRootFromParent_Done,
     /* 2444161 */   // Label 35345: @2444161
     /* 2444161 */   GIM_Try, /*On fail goto*//*Label 35346*/ GIMT_Encode4(2444233), // Rule ID 45496 //
     /* 2444166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444198 */     // MIs[0] policy
     /* 2444198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444208 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2444211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444232 */     // GIR_Coverage, 45496,
     /* 2444232 */     GIR_EraseRootFromParent_Done,
     /* 2444233 */   // Label 35346: @2444233
     /* 2444233 */   GIM_Try, /*On fail goto*//*Label 35347*/ GIMT_Encode4(2444305), // Rule ID 45497 //
     /* 2444238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2444254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2444262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444270 */     // MIs[0] policy
     /* 2444270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444280 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2444283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444304 */     // GIR_Coverage, 45497,
     /* 2444304 */     GIR_EraseRootFromParent_Done,
     /* 2444305 */   // Label 35347: @2444305
     /* 2444305 */   GIM_Reject,
     /* 2444306 */ // Label 35343: @2444306
     /* 2444306 */ GIM_Reject,
     /* 2444307 */ // Label 35189: @2444307
     /* 2444307 */ GIM_Try, /*On fail goto*//*Label 35348*/ GIMT_Encode4(2444939),
     /* 2444312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2444315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2444318 */   GIM_Try, /*On fail goto*//*Label 35349*/ GIMT_Encode4(2444401), // Rule ID 45510 //
     /* 2444323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444359 */     // MIs[1] Operand 1
     /* 2444359 */     // No operand predicates
     /* 2444359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444363 */     // MIs[0] policy
     /* 2444363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444375 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444400 */     // GIR_Coverage, 45510,
     /* 2444400 */     GIR_EraseRootFromParent_Done,
     /* 2444401 */   // Label 35349: @2444401
     /* 2444401 */   GIM_Try, /*On fail goto*//*Label 35350*/ GIMT_Encode4(2444484), // Rule ID 45511 //
     /* 2444406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444442 */     // MIs[1] Operand 1
     /* 2444442 */     // No operand predicates
     /* 2444442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444446 */     // MIs[0] policy
     /* 2444446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444458 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444483 */     // GIR_Coverage, 45511,
     /* 2444483 */     GIR_EraseRootFromParent_Done,
     /* 2444484 */   // Label 35350: @2444484
     /* 2444484 */   GIM_Try, /*On fail goto*//*Label 35351*/ GIMT_Encode4(2444567), // Rule ID 45570 //
     /* 2444489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444525 */     // MIs[1] Operand 1
     /* 2444525 */     // No operand predicates
     /* 2444525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444529 */     // MIs[0] policy
     /* 2444529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444541 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444566 */     // GIR_Coverage, 45570,
     /* 2444566 */     GIR_EraseRootFromParent_Done,
     /* 2444567 */   // Label 35351: @2444567
     /* 2444567 */   GIM_Try, /*On fail goto*//*Label 35352*/ GIMT_Encode4(2444650), // Rule ID 45571 //
     /* 2444572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444608 */     // MIs[1] Operand 1
     /* 2444608 */     // No operand predicates
     /* 2444608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444612 */     // MIs[0] policy
     /* 2444612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444624 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2444627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444649 */     // GIR_Coverage, 45571,
     /* 2444649 */     GIR_EraseRootFromParent_Done,
     /* 2444650 */   // Label 35352: @2444650
     /* 2444650 */   GIM_Try, /*On fail goto*//*Label 35353*/ GIMT_Encode4(2444722), // Rule ID 45512 //
     /* 2444655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444687 */     // MIs[0] policy
     /* 2444687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444697 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444721 */     // GIR_Coverage, 45512,
     /* 2444721 */     GIR_EraseRootFromParent_Done,
     /* 2444722 */   // Label 35353: @2444722
     /* 2444722 */   GIM_Try, /*On fail goto*//*Label 35354*/ GIMT_Encode4(2444794), // Rule ID 45513 //
     /* 2444727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444759 */     // MIs[0] policy
     /* 2444759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444769 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444793 */     // GIR_Coverage, 45513,
     /* 2444793 */     GIR_EraseRootFromParent_Done,
     /* 2444794 */   // Label 35354: @2444794
     /* 2444794 */   GIM_Try, /*On fail goto*//*Label 35355*/ GIMT_Encode4(2444866), // Rule ID 45572 //
     /* 2444799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444831 */     // MIs[0] policy
     /* 2444831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444841 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444865 */     // GIR_Coverage, 45572,
     /* 2444865 */     GIR_EraseRootFromParent_Done,
     /* 2444866 */   // Label 35355: @2444866
     /* 2444866 */   GIM_Try, /*On fail goto*//*Label 35356*/ GIMT_Encode4(2444938), // Rule ID 45573 //
     /* 2444871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2444880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444903 */     // MIs[0] policy
     /* 2444903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444913 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2444916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444937 */     // GIR_Coverage, 45573,
     /* 2444937 */     GIR_EraseRootFromParent_Done,
     /* 2444938 */   // Label 35356: @2444938
     /* 2444938 */   GIM_Reject,
     /* 2444939 */ // Label 35348: @2444939
     /* 2444939 */ GIM_Reject,
     /* 2444940 */ // Label 35190: @2444940
     /* 2444940 */ GIM_Try, /*On fail goto*//*Label 35357*/ GIMT_Encode4(2445262),
     /* 2444945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2444948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2444951 */   GIM_Try, /*On fail goto*//*Label 35358*/ GIMT_Encode4(2445034), // Rule ID 45498 //
     /* 2444956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2444965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2444972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2444980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444992 */     // MIs[1] Operand 1
     /* 2444992 */     // No operand predicates
     /* 2444992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444996 */     // MIs[0] policy
     /* 2444996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445008 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2445011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445033 */     // GIR_Coverage, 45498,
     /* 2445033 */     GIR_EraseRootFromParent_Done,
     /* 2445034 */   // Label 35358: @2445034
     /* 2445034 */   GIM_Try, /*On fail goto*//*Label 35359*/ GIMT_Encode4(2445117), // Rule ID 45499 //
     /* 2445039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445075 */     // MIs[1] Operand 1
     /* 2445075 */     // No operand predicates
     /* 2445075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445079 */     // MIs[0] policy
     /* 2445079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445091 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2445094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445116 */     // GIR_Coverage, 45499,
     /* 2445116 */     GIR_EraseRootFromParent_Done,
     /* 2445117 */   // Label 35359: @2445117
     /* 2445117 */   GIM_Try, /*On fail goto*//*Label 35360*/ GIMT_Encode4(2445189), // Rule ID 45500 //
     /* 2445122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445154 */     // MIs[0] policy
     /* 2445154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445164 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2445167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445188 */     // GIR_Coverage, 45500,
     /* 2445188 */     GIR_EraseRootFromParent_Done,
     /* 2445189 */   // Label 35360: @2445189
     /* 2445189 */   GIM_Try, /*On fail goto*//*Label 35361*/ GIMT_Encode4(2445261), // Rule ID 45501 //
     /* 2445194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2445203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2445210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2445218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445226 */     // MIs[0] policy
     /* 2445226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445236 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2445239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445260 */     // GIR_Coverage, 45501,
     /* 2445260 */     GIR_EraseRootFromParent_Done,
     /* 2445261 */   // Label 35361: @2445261
     /* 2445261 */   GIM_Reject,
     /* 2445262 */ // Label 35357: @2445262
     /* 2445262 */ GIM_Reject,
     /* 2445263 */ // Label 35191: @2445263
     /* 2445263 */ GIM_Reject,
     /* 2445264 */ // Label 124: @2445264
     /* 2445264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35384*/ GIMT_Encode4(2457143),
     /* 2445275 */ /*GILLT_nxv1s8*//*Label 35362*/ GIMT_Encode4(2445387),
     /* 2445279 */ /*GILLT_nxv1s16*//*Label 35363*/ GIMT_Encode4(2445710),
     /* 2445283 */ /*GILLT_nxv1s32*//*Label 35364*/ GIMT_Encode4(2446343),
     /* 2445287 */ /*GILLT_nxv1s64*//*Label 35365*/ GIMT_Encode4(2446976), GIMT_Encode4(0),
     /* 2445295 */ /*GILLT_nxv2s8*//*Label 35366*/ GIMT_Encode4(2447609),
     /* 2445299 */ /*GILLT_nxv2s16*//*Label 35367*/ GIMT_Encode4(2447932),
     /* 2445303 */ /*GILLT_nxv2s32*//*Label 35368*/ GIMT_Encode4(2448565),
     /* 2445307 */ /*GILLT_nxv2s64*//*Label 35369*/ GIMT_Encode4(2449198), GIMT_Encode4(0),
     /* 2445315 */ /*GILLT_nxv4s8*//*Label 35370*/ GIMT_Encode4(2449831),
     /* 2445319 */ /*GILLT_nxv4s16*//*Label 35371*/ GIMT_Encode4(2450154),
     /* 2445323 */ /*GILLT_nxv4s32*//*Label 35372*/ GIMT_Encode4(2450787),
     /* 2445327 */ /*GILLT_nxv4s64*//*Label 35373*/ GIMT_Encode4(2451420), GIMT_Encode4(0),
     /* 2445335 */ /*GILLT_nxv8s8*//*Label 35374*/ GIMT_Encode4(2452053),
     /* 2445339 */ /*GILLT_nxv8s16*//*Label 35375*/ GIMT_Encode4(2452376),
     /* 2445343 */ /*GILLT_nxv8s32*//*Label 35376*/ GIMT_Encode4(2453009),
     /* 2445347 */ /*GILLT_nxv8s64*//*Label 35377*/ GIMT_Encode4(2453642), GIMT_Encode4(0),
     /* 2445355 */ /*GILLT_nxv16s8*//*Label 35378*/ GIMT_Encode4(2454275),
     /* 2445359 */ /*GILLT_nxv16s16*//*Label 35379*/ GIMT_Encode4(2454598),
     /* 2445363 */ /*GILLT_nxv16s32*//*Label 35380*/ GIMT_Encode4(2455231), GIMT_Encode4(0),
     /* 2445371 */ /*GILLT_nxv32s8*//*Label 35381*/ GIMT_Encode4(2455864),
     /* 2445375 */ /*GILLT_nxv32s16*//*Label 35382*/ GIMT_Encode4(2456187), GIMT_Encode4(0),
     /* 2445383 */ /*GILLT_nxv64s8*//*Label 35383*/ GIMT_Encode4(2456820),
     /* 2445387 */ // Label 35362: @2445387
     /* 2445387 */ GIM_Try, /*On fail goto*//*Label 35385*/ GIMT_Encode4(2445709),
     /* 2445392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2445395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2445398 */   GIM_Try, /*On fail goto*//*Label 35386*/ GIMT_Encode4(2445481), // Rule ID 25364 //
     /* 2445403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445439 */     // MIs[1] Operand 1
     /* 2445439 */     // No operand predicates
     /* 2445439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445443 */     // MIs[0] policy
     /* 2445443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445455 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2445458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445480 */     // GIR_Coverage, 25364,
     /* 2445480 */     GIR_EraseRootFromParent_Done,
     /* 2445481 */   // Label 35386: @2445481
     /* 2445481 */   GIM_Try, /*On fail goto*//*Label 35387*/ GIMT_Encode4(2445564), // Rule ID 25365 //
     /* 2445486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445522 */     // MIs[1] Operand 1
     /* 2445522 */     // No operand predicates
     /* 2445522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445526 */     // MIs[0] policy
     /* 2445526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445538 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2445541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445563 */     // GIR_Coverage, 25365,
     /* 2445563 */     GIR_EraseRootFromParent_Done,
     /* 2445564 */   // Label 35387: @2445564
     /* 2445564 */   GIM_Try, /*On fail goto*//*Label 35388*/ GIMT_Encode4(2445636), // Rule ID 25366 //
     /* 2445569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445601 */     // MIs[0] policy
     /* 2445601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445611 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2445614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445635 */     // GIR_Coverage, 25366,
     /* 2445635 */     GIR_EraseRootFromParent_Done,
     /* 2445636 */   // Label 35388: @2445636
     /* 2445636 */   GIM_Try, /*On fail goto*//*Label 35389*/ GIMT_Encode4(2445708), // Rule ID 25367 //
     /* 2445641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445673 */     // MIs[0] policy
     /* 2445673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445683 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2445686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445707 */     // GIR_Coverage, 25367,
     /* 2445707 */     GIR_EraseRootFromParent_Done,
     /* 2445708 */   // Label 35389: @2445708
     /* 2445708 */   GIM_Reject,
     /* 2445709 */ // Label 35385: @2445709
     /* 2445709 */ GIM_Reject,
     /* 2445710 */ // Label 35363: @2445710
     /* 2445710 */ GIM_Try, /*On fail goto*//*Label 35390*/ GIMT_Encode4(2446342),
     /* 2445715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2445718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2445721 */   GIM_Try, /*On fail goto*//*Label 35391*/ GIMT_Encode4(2445804), // Rule ID 45314 //
     /* 2445726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445762 */     // MIs[1] Operand 1
     /* 2445762 */     // No operand predicates
     /* 2445762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445766 */     // MIs[0] policy
     /* 2445766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445778 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445803 */     // GIR_Coverage, 45314,
     /* 2445803 */     GIR_EraseRootFromParent_Done,
     /* 2445804 */   // Label 35391: @2445804
     /* 2445804 */   GIM_Try, /*On fail goto*//*Label 35392*/ GIMT_Encode4(2445887), // Rule ID 45315 //
     /* 2445809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445845 */     // MIs[1] Operand 1
     /* 2445845 */     // No operand predicates
     /* 2445845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445849 */     // MIs[0] policy
     /* 2445849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445861 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445886 */     // GIR_Coverage, 45315,
     /* 2445886 */     GIR_EraseRootFromParent_Done,
     /* 2445887 */   // Label 35392: @2445887
     /* 2445887 */   GIM_Try, /*On fail goto*//*Label 35393*/ GIMT_Encode4(2445970), // Rule ID 45390 //
     /* 2445892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445928 */     // MIs[1] Operand 1
     /* 2445928 */     // No operand predicates
     /* 2445928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445932 */     // MIs[0] policy
     /* 2445932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445944 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2445947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445956 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2445966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445969 */     // GIR_Coverage, 45390,
     /* 2445969 */     GIR_EraseRootFromParent_Done,
     /* 2445970 */   // Label 35393: @2445970
     /* 2445970 */   GIM_Try, /*On fail goto*//*Label 35394*/ GIMT_Encode4(2446053), // Rule ID 45391 //
     /* 2445975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2445984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446011 */     // MIs[1] Operand 1
     /* 2446011 */     // No operand predicates
     /* 2446011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446015 */     // MIs[0] policy
     /* 2446015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446027 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2446030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446052 */     // GIR_Coverage, 45391,
     /* 2446052 */     GIR_EraseRootFromParent_Done,
     /* 2446053 */   // Label 35394: @2446053
     /* 2446053 */   GIM_Try, /*On fail goto*//*Label 35395*/ GIMT_Encode4(2446125), // Rule ID 45316 //
     /* 2446058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446090 */     // MIs[0] policy
     /* 2446090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446100 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446124 */     // GIR_Coverage, 45316,
     /* 2446124 */     GIR_EraseRootFromParent_Done,
     /* 2446125 */   // Label 35395: @2446125
     /* 2446125 */   GIM_Try, /*On fail goto*//*Label 35396*/ GIMT_Encode4(2446197), // Rule ID 45317 //
     /* 2446130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446162 */     // MIs[0] policy
     /* 2446162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446172 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446196 */     // GIR_Coverage, 45317,
     /* 2446196 */     GIR_EraseRootFromParent_Done,
     /* 2446197 */   // Label 35396: @2446197
     /* 2446197 */   GIM_Try, /*On fail goto*//*Label 35397*/ GIMT_Encode4(2446269), // Rule ID 45392 //
     /* 2446202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446234 */     // MIs[0] policy
     /* 2446234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446244 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446268 */     // GIR_Coverage, 45392,
     /* 2446268 */     GIR_EraseRootFromParent_Done,
     /* 2446269 */   // Label 35397: @2446269
     /* 2446269 */   GIM_Try, /*On fail goto*//*Label 35398*/ GIMT_Encode4(2446341), // Rule ID 45393 //
     /* 2446274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446306 */     // MIs[0] policy
     /* 2446306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446316 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2446319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446340 */     // GIR_Coverage, 45393,
     /* 2446340 */     GIR_EraseRootFromParent_Done,
     /* 2446341 */   // Label 35398: @2446341
     /* 2446341 */   GIM_Reject,
     /* 2446342 */ // Label 35390: @2446342
     /* 2446342 */ GIM_Reject,
     /* 2446343 */ // Label 35364: @2446343
     /* 2446343 */ GIM_Try, /*On fail goto*//*Label 35399*/ GIMT_Encode4(2446975),
     /* 2446348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2446351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2446354 */   GIM_Try, /*On fail goto*//*Label 35400*/ GIMT_Encode4(2446437), // Rule ID 45322 //
     /* 2446359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446395 */     // MIs[1] Operand 1
     /* 2446395 */     // No operand predicates
     /* 2446395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446399 */     // MIs[0] policy
     /* 2446399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446411 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446436 */     // GIR_Coverage, 45322,
     /* 2446436 */     GIR_EraseRootFromParent_Done,
     /* 2446437 */   // Label 35400: @2446437
     /* 2446437 */   GIM_Try, /*On fail goto*//*Label 35401*/ GIMT_Encode4(2446520), // Rule ID 45323 //
     /* 2446442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446478 */     // MIs[1] Operand 1
     /* 2446478 */     // No operand predicates
     /* 2446478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446482 */     // MIs[0] policy
     /* 2446482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446494 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446519 */     // GIR_Coverage, 45323,
     /* 2446519 */     GIR_EraseRootFromParent_Done,
     /* 2446520 */   // Label 35401: @2446520
     /* 2446520 */   GIM_Try, /*On fail goto*//*Label 35402*/ GIMT_Encode4(2446603), // Rule ID 45398 //
     /* 2446525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446561 */     // MIs[1] Operand 1
     /* 2446561 */     // No operand predicates
     /* 2446561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446565 */     // MIs[0] policy
     /* 2446565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446577 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446602 */     // GIR_Coverage, 45398,
     /* 2446602 */     GIR_EraseRootFromParent_Done,
     /* 2446603 */   // Label 35402: @2446603
     /* 2446603 */   GIM_Try, /*On fail goto*//*Label 35403*/ GIMT_Encode4(2446686), // Rule ID 45399 //
     /* 2446608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446644 */     // MIs[1] Operand 1
     /* 2446644 */     // No operand predicates
     /* 2446644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446648 */     // MIs[0] policy
     /* 2446648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446660 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2446663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446685 */     // GIR_Coverage, 45399,
     /* 2446685 */     GIR_EraseRootFromParent_Done,
     /* 2446686 */   // Label 35403: @2446686
     /* 2446686 */   GIM_Try, /*On fail goto*//*Label 35404*/ GIMT_Encode4(2446758), // Rule ID 45324 //
     /* 2446691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446723 */     // MIs[0] policy
     /* 2446723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446733 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446757 */     // GIR_Coverage, 45324,
     /* 2446757 */     GIR_EraseRootFromParent_Done,
     /* 2446758 */   // Label 35404: @2446758
     /* 2446758 */   GIM_Try, /*On fail goto*//*Label 35405*/ GIMT_Encode4(2446830), // Rule ID 45325 //
     /* 2446763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446795 */     // MIs[0] policy
     /* 2446795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446805 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446829 */     // GIR_Coverage, 45325,
     /* 2446829 */     GIR_EraseRootFromParent_Done,
     /* 2446830 */   // Label 35405: @2446830
     /* 2446830 */   GIM_Try, /*On fail goto*//*Label 35406*/ GIMT_Encode4(2446902), // Rule ID 45400 //
     /* 2446835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446867 */     // MIs[0] policy
     /* 2446867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446877 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446901 */     // GIR_Coverage, 45400,
     /* 2446901 */     GIR_EraseRootFromParent_Done,
     /* 2446902 */   // Label 35406: @2446902
     /* 2446902 */   GIM_Try, /*On fail goto*//*Label 35407*/ GIMT_Encode4(2446974), // Rule ID 45401 //
     /* 2446907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2446916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446939 */     // MIs[0] policy
     /* 2446939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446949 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2446952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446973 */     // GIR_Coverage, 45401,
     /* 2446973 */     GIR_EraseRootFromParent_Done,
     /* 2446974 */   // Label 35407: @2446974
     /* 2446974 */   GIM_Reject,
     /* 2446975 */ // Label 35399: @2446975
     /* 2446975 */ GIM_Reject,
     /* 2446976 */ // Label 35365: @2446976
     /* 2446976 */ GIM_Try, /*On fail goto*//*Label 35408*/ GIMT_Encode4(2447608),
     /* 2446981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2446984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2446987 */   GIM_Try, /*On fail goto*//*Label 35409*/ GIMT_Encode4(2447070), // Rule ID 45338 //
     /* 2446992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2446995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447028 */     // MIs[1] Operand 1
     /* 2447028 */     // No operand predicates
     /* 2447028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447032 */     // MIs[0] policy
     /* 2447032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447044 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447069 */     // GIR_Coverage, 45338,
     /* 2447069 */     GIR_EraseRootFromParent_Done,
     /* 2447070 */   // Label 35409: @2447070
     /* 2447070 */   GIM_Try, /*On fail goto*//*Label 35410*/ GIMT_Encode4(2447153), // Rule ID 45339 //
     /* 2447075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447111 */     // MIs[1] Operand 1
     /* 2447111 */     // No operand predicates
     /* 2447111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447115 */     // MIs[0] policy
     /* 2447115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447127 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447152 */     // GIR_Coverage, 45339,
     /* 2447152 */     GIR_EraseRootFromParent_Done,
     /* 2447153 */   // Label 35410: @2447153
     /* 2447153 */   GIM_Try, /*On fail goto*//*Label 35411*/ GIMT_Encode4(2447236), // Rule ID 45410 //
     /* 2447158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447194 */     // MIs[1] Operand 1
     /* 2447194 */     // No operand predicates
     /* 2447194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447198 */     // MIs[0] policy
     /* 2447198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447210 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447235 */     // GIR_Coverage, 45410,
     /* 2447235 */     GIR_EraseRootFromParent_Done,
     /* 2447236 */   // Label 35411: @2447236
     /* 2447236 */   GIM_Try, /*On fail goto*//*Label 35412*/ GIMT_Encode4(2447319), // Rule ID 45411 //
     /* 2447241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447277 */     // MIs[1] Operand 1
     /* 2447277 */     // No operand predicates
     /* 2447277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447281 */     // MIs[0] policy
     /* 2447281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447293 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2447296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447318 */     // GIR_Coverage, 45411,
     /* 2447318 */     GIR_EraseRootFromParent_Done,
     /* 2447319 */   // Label 35412: @2447319
     /* 2447319 */   GIM_Try, /*On fail goto*//*Label 35413*/ GIMT_Encode4(2447391), // Rule ID 45340 //
     /* 2447324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447356 */     // MIs[0] policy
     /* 2447356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447366 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447390 */     // GIR_Coverage, 45340,
     /* 2447390 */     GIR_EraseRootFromParent_Done,
     /* 2447391 */   // Label 35413: @2447391
     /* 2447391 */   GIM_Try, /*On fail goto*//*Label 35414*/ GIMT_Encode4(2447463), // Rule ID 45341 //
     /* 2447396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447428 */     // MIs[0] policy
     /* 2447428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447438 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447462 */     // GIR_Coverage, 45341,
     /* 2447462 */     GIR_EraseRootFromParent_Done,
     /* 2447463 */   // Label 35414: @2447463
     /* 2447463 */   GIM_Try, /*On fail goto*//*Label 35415*/ GIMT_Encode4(2447535), // Rule ID 45412 //
     /* 2447468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447500 */     // MIs[0] policy
     /* 2447500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447510 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447534 */     // GIR_Coverage, 45412,
     /* 2447534 */     GIR_EraseRootFromParent_Done,
     /* 2447535 */   // Label 35415: @2447535
     /* 2447535 */   GIM_Try, /*On fail goto*//*Label 35416*/ GIMT_Encode4(2447607), // Rule ID 45413 //
     /* 2447540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2447549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447572 */     // MIs[0] policy
     /* 2447572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447582 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2447585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447606 */     // GIR_Coverage, 45413,
     /* 2447606 */     GIR_EraseRootFromParent_Done,
     /* 2447607 */   // Label 35416: @2447607
     /* 2447607 */   GIM_Reject,
     /* 2447608 */ // Label 35408: @2447608
     /* 2447608 */ GIM_Reject,
     /* 2447609 */ // Label 35366: @2447609
     /* 2447609 */ GIM_Try, /*On fail goto*//*Label 35417*/ GIMT_Encode4(2447931),
     /* 2447614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2447617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2447620 */   GIM_Try, /*On fail goto*//*Label 35418*/ GIMT_Encode4(2447703), // Rule ID 45306 //
     /* 2447625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447661 */     // MIs[1] Operand 1
     /* 2447661 */     // No operand predicates
     /* 2447661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447665 */     // MIs[0] policy
     /* 2447665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447677 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2447680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447702 */     // GIR_Coverage, 45306,
     /* 2447702 */     GIR_EraseRootFromParent_Done,
     /* 2447703 */   // Label 35418: @2447703
     /* 2447703 */   GIM_Try, /*On fail goto*//*Label 35419*/ GIMT_Encode4(2447786), // Rule ID 45307 //
     /* 2447708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447744 */     // MIs[1] Operand 1
     /* 2447744 */     // No operand predicates
     /* 2447744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447748 */     // MIs[0] policy
     /* 2447748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447760 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2447763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447785 */     // GIR_Coverage, 45307,
     /* 2447785 */     GIR_EraseRootFromParent_Done,
     /* 2447786 */   // Label 35419: @2447786
     /* 2447786 */   GIM_Try, /*On fail goto*//*Label 35420*/ GIMT_Encode4(2447858), // Rule ID 45308 //
     /* 2447791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447823 */     // MIs[0] policy
     /* 2447823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447833 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2447836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447857 */     // GIR_Coverage, 45308,
     /* 2447857 */     GIR_EraseRootFromParent_Done,
     /* 2447858 */   // Label 35420: @2447858
     /* 2447858 */   GIM_Try, /*On fail goto*//*Label 35421*/ GIMT_Encode4(2447930), // Rule ID 45309 //
     /* 2447863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447895 */     // MIs[0] policy
     /* 2447895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447905 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2447908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2447926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447929 */     // GIR_Coverage, 45309,
     /* 2447929 */     GIR_EraseRootFromParent_Done,
     /* 2447930 */   // Label 35421: @2447930
     /* 2447930 */   GIM_Reject,
     /* 2447931 */ // Label 35417: @2447931
     /* 2447931 */ GIM_Reject,
     /* 2447932 */ // Label 35367: @2447932
     /* 2447932 */ GIM_Try, /*On fail goto*//*Label 35422*/ GIMT_Encode4(2448564),
     /* 2447937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2447940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2447943 */   GIM_Try, /*On fail goto*//*Label 35423*/ GIMT_Encode4(2448026), // Rule ID 45318 //
     /* 2447948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2447957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2447964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2447972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447984 */     // MIs[1] Operand 1
     /* 2447984 */     // No operand predicates
     /* 2447984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447988 */     // MIs[0] policy
     /* 2447988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448000 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448025 */     // GIR_Coverage, 45318,
     /* 2448025 */     GIR_EraseRootFromParent_Done,
     /* 2448026 */   // Label 35423: @2448026
     /* 2448026 */   GIM_Try, /*On fail goto*//*Label 35424*/ GIMT_Encode4(2448109), // Rule ID 45319 //
     /* 2448031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448067 */     // MIs[1] Operand 1
     /* 2448067 */     // No operand predicates
     /* 2448067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448071 */     // MIs[0] policy
     /* 2448071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448083 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448108 */     // GIR_Coverage, 45319,
     /* 2448108 */     GIR_EraseRootFromParent_Done,
     /* 2448109 */   // Label 35424: @2448109
     /* 2448109 */   GIM_Try, /*On fail goto*//*Label 35425*/ GIMT_Encode4(2448192), // Rule ID 45394 //
     /* 2448114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448150 */     // MIs[1] Operand 1
     /* 2448150 */     // No operand predicates
     /* 2448150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448154 */     // MIs[0] policy
     /* 2448154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448166 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448191 */     // GIR_Coverage, 45394,
     /* 2448191 */     GIR_EraseRootFromParent_Done,
     /* 2448192 */   // Label 35425: @2448192
     /* 2448192 */   GIM_Try, /*On fail goto*//*Label 35426*/ GIMT_Encode4(2448275), // Rule ID 45395 //
     /* 2448197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448233 */     // MIs[1] Operand 1
     /* 2448233 */     // No operand predicates
     /* 2448233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448237 */     // MIs[0] policy
     /* 2448237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448249 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2448252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448274 */     // GIR_Coverage, 45395,
     /* 2448274 */     GIR_EraseRootFromParent_Done,
     /* 2448275 */   // Label 35426: @2448275
     /* 2448275 */   GIM_Try, /*On fail goto*//*Label 35427*/ GIMT_Encode4(2448347), // Rule ID 45320 //
     /* 2448280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448312 */     // MIs[0] policy
     /* 2448312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448322 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448346 */     // GIR_Coverage, 45320,
     /* 2448346 */     GIR_EraseRootFromParent_Done,
     /* 2448347 */   // Label 35427: @2448347
     /* 2448347 */   GIM_Try, /*On fail goto*//*Label 35428*/ GIMT_Encode4(2448419), // Rule ID 45321 //
     /* 2448352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448384 */     // MIs[0] policy
     /* 2448384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448394 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448418 */     // GIR_Coverage, 45321,
     /* 2448418 */     GIR_EraseRootFromParent_Done,
     /* 2448419 */   // Label 35428: @2448419
     /* 2448419 */   GIM_Try, /*On fail goto*//*Label 35429*/ GIMT_Encode4(2448491), // Rule ID 45396 //
     /* 2448424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448456 */     // MIs[0] policy
     /* 2448456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448466 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448490 */     // GIR_Coverage, 45396,
     /* 2448490 */     GIR_EraseRootFromParent_Done,
     /* 2448491 */   // Label 35429: @2448491
     /* 2448491 */   GIM_Try, /*On fail goto*//*Label 35430*/ GIMT_Encode4(2448563), // Rule ID 45397 //
     /* 2448496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448528 */     // MIs[0] policy
     /* 2448528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448538 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2448541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448562 */     // GIR_Coverage, 45397,
     /* 2448562 */     GIR_EraseRootFromParent_Done,
     /* 2448563 */   // Label 35430: @2448563
     /* 2448563 */   GIM_Reject,
     /* 2448564 */ // Label 35422: @2448564
     /* 2448564 */ GIM_Reject,
     /* 2448565 */ // Label 35368: @2448565
     /* 2448565 */ GIM_Try, /*On fail goto*//*Label 35431*/ GIMT_Encode4(2449197),
     /* 2448570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2448573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2448576 */   GIM_Try, /*On fail goto*//*Label 35432*/ GIMT_Encode4(2448659), // Rule ID 45334 //
     /* 2448581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448617 */     // MIs[1] Operand 1
     /* 2448617 */     // No operand predicates
     /* 2448617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448621 */     // MIs[0] policy
     /* 2448621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448633 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448658 */     // GIR_Coverage, 45334,
     /* 2448658 */     GIR_EraseRootFromParent_Done,
     /* 2448659 */   // Label 35432: @2448659
     /* 2448659 */   GIM_Try, /*On fail goto*//*Label 35433*/ GIMT_Encode4(2448742), // Rule ID 45335 //
     /* 2448664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448700 */     // MIs[1] Operand 1
     /* 2448700 */     // No operand predicates
     /* 2448700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448704 */     // MIs[0] policy
     /* 2448704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448716 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448741 */     // GIR_Coverage, 45335,
     /* 2448741 */     GIR_EraseRootFromParent_Done,
     /* 2448742 */   // Label 35433: @2448742
     /* 2448742 */   GIM_Try, /*On fail goto*//*Label 35434*/ GIMT_Encode4(2448825), // Rule ID 45406 //
     /* 2448747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448783 */     // MIs[1] Operand 1
     /* 2448783 */     // No operand predicates
     /* 2448783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448787 */     // MIs[0] policy
     /* 2448787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448799 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448824 */     // GIR_Coverage, 45406,
     /* 2448824 */     GIR_EraseRootFromParent_Done,
     /* 2448825 */   // Label 35434: @2448825
     /* 2448825 */   GIM_Try, /*On fail goto*//*Label 35435*/ GIMT_Encode4(2448908), // Rule ID 45407 //
     /* 2448830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448866 */     // MIs[1] Operand 1
     /* 2448866 */     // No operand predicates
     /* 2448866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448870 */     // MIs[0] policy
     /* 2448870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448882 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2448885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448907 */     // GIR_Coverage, 45407,
     /* 2448907 */     GIR_EraseRootFromParent_Done,
     /* 2448908 */   // Label 35435: @2448908
     /* 2448908 */   GIM_Try, /*On fail goto*//*Label 35436*/ GIMT_Encode4(2448980), // Rule ID 45336 //
     /* 2448913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2448929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2448937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448945 */     // MIs[0] policy
     /* 2448945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448955 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2448958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2448976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448979 */     // GIR_Coverage, 45336,
     /* 2448979 */     GIR_EraseRootFromParent_Done,
     /* 2448980 */   // Label 35436: @2448980
     /* 2448980 */   GIM_Try, /*On fail goto*//*Label 35437*/ GIMT_Encode4(2449052), // Rule ID 45337 //
     /* 2448985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2448994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449017 */     // MIs[0] policy
     /* 2449017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449027 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449051 */     // GIR_Coverage, 45337,
     /* 2449051 */     GIR_EraseRootFromParent_Done,
     /* 2449052 */   // Label 35437: @2449052
     /* 2449052 */   GIM_Try, /*On fail goto*//*Label 35438*/ GIMT_Encode4(2449124), // Rule ID 45408 //
     /* 2449057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449089 */     // MIs[0] policy
     /* 2449089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449099 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449123 */     // GIR_Coverage, 45408,
     /* 2449123 */     GIR_EraseRootFromParent_Done,
     /* 2449124 */   // Label 35438: @2449124
     /* 2449124 */   GIM_Try, /*On fail goto*//*Label 35439*/ GIMT_Encode4(2449196), // Rule ID 45409 //
     /* 2449129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449161 */     // MIs[0] policy
     /* 2449161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449171 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2449174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449195 */     // GIR_Coverage, 45409,
     /* 2449195 */     GIR_EraseRootFromParent_Done,
     /* 2449196 */   // Label 35439: @2449196
     /* 2449196 */   GIM_Reject,
     /* 2449197 */ // Label 35431: @2449197
     /* 2449197 */ GIM_Reject,
     /* 2449198 */ // Label 35369: @2449198
     /* 2449198 */ GIM_Try, /*On fail goto*//*Label 35440*/ GIMT_Encode4(2449830),
     /* 2449203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2449206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2449209 */   GIM_Try, /*On fail goto*//*Label 35441*/ GIMT_Encode4(2449292), // Rule ID 45378 //
     /* 2449214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449250 */     // MIs[1] Operand 1
     /* 2449250 */     // No operand predicates
     /* 2449250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449254 */     // MIs[0] policy
     /* 2449254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449266 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449291 */     // GIR_Coverage, 45378,
     /* 2449291 */     GIR_EraseRootFromParent_Done,
     /* 2449292 */   // Label 35441: @2449292
     /* 2449292 */   GIM_Try, /*On fail goto*//*Label 35442*/ GIMT_Encode4(2449375), // Rule ID 45379 //
     /* 2449297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449333 */     // MIs[1] Operand 1
     /* 2449333 */     // No operand predicates
     /* 2449333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449337 */     // MIs[0] policy
     /* 2449337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449349 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449374 */     // GIR_Coverage, 45379,
     /* 2449374 */     GIR_EraseRootFromParent_Done,
     /* 2449375 */   // Label 35442: @2449375
     /* 2449375 */   GIM_Try, /*On fail goto*//*Label 35443*/ GIMT_Encode4(2449458), // Rule ID 45438 //
     /* 2449380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449416 */     // MIs[1] Operand 1
     /* 2449416 */     // No operand predicates
     /* 2449416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449420 */     // MIs[0] policy
     /* 2449420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449432 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449457 */     // GIR_Coverage, 45438,
     /* 2449457 */     GIR_EraseRootFromParent_Done,
     /* 2449458 */   // Label 35443: @2449458
     /* 2449458 */   GIM_Try, /*On fail goto*//*Label 35444*/ GIMT_Encode4(2449541), // Rule ID 45439 //
     /* 2449463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449499 */     // MIs[1] Operand 1
     /* 2449499 */     // No operand predicates
     /* 2449499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449503 */     // MIs[0] policy
     /* 2449503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449515 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2449518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449540 */     // GIR_Coverage, 45439,
     /* 2449540 */     GIR_EraseRootFromParent_Done,
     /* 2449541 */   // Label 35444: @2449541
     /* 2449541 */   GIM_Try, /*On fail goto*//*Label 35445*/ GIMT_Encode4(2449613), // Rule ID 45380 //
     /* 2449546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449578 */     // MIs[0] policy
     /* 2449578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449588 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449612 */     // GIR_Coverage, 45380,
     /* 2449612 */     GIR_EraseRootFromParent_Done,
     /* 2449613 */   // Label 35445: @2449613
     /* 2449613 */   GIM_Try, /*On fail goto*//*Label 35446*/ GIMT_Encode4(2449685), // Rule ID 45381 //
     /* 2449618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449650 */     // MIs[0] policy
     /* 2449650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449660 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449684 */     // GIR_Coverage, 45381,
     /* 2449684 */     GIR_EraseRootFromParent_Done,
     /* 2449685 */   // Label 35446: @2449685
     /* 2449685 */   GIM_Try, /*On fail goto*//*Label 35447*/ GIMT_Encode4(2449757), // Rule ID 45440 //
     /* 2449690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2449693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449722 */     // MIs[0] policy
     /* 2449722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449732 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449756 */     // GIR_Coverage, 45440,
     /* 2449756 */     GIR_EraseRootFromParent_Done,
     /* 2449757 */   // Label 35447: @2449757
     /* 2449757 */   GIM_Try, /*On fail goto*//*Label 35448*/ GIMT_Encode4(2449829), // Rule ID 45441 //
     /* 2449762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2449765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2449771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2449778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2449786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449794 */     // MIs[0] policy
     /* 2449794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449804 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2449807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2449825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449828 */     // GIR_Coverage, 45441,
     /* 2449828 */     GIR_EraseRootFromParent_Done,
     /* 2449829 */   // Label 35448: @2449829
     /* 2449829 */   GIM_Reject,
     /* 2449830 */ // Label 35440: @2449830
     /* 2449830 */ GIM_Reject,
     /* 2449831 */ // Label 35370: @2449831
     /* 2449831 */ GIM_Try, /*On fail goto*//*Label 35449*/ GIMT_Encode4(2450153),
     /* 2449836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2449839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2449842 */   GIM_Try, /*On fail goto*//*Label 35450*/ GIMT_Encode4(2449925), // Rule ID 45310 //
     /* 2449847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2449856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449883 */     // MIs[1] Operand 1
     /* 2449883 */     // No operand predicates
     /* 2449883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449887 */     // MIs[0] policy
     /* 2449887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449899 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2449902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2449921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449924 */     // GIR_Coverage, 45310,
     /* 2449924 */     GIR_EraseRootFromParent_Done,
     /* 2449925 */   // Label 35450: @2449925
     /* 2449925 */   GIM_Try, /*On fail goto*//*Label 35451*/ GIMT_Encode4(2450008), // Rule ID 45311 //
     /* 2449930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2449939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2449946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2449954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449966 */     // MIs[1] Operand 1
     /* 2449966 */     // No operand predicates
     /* 2449966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449970 */     // MIs[0] policy
     /* 2449970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449982 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2449985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450007 */     // GIR_Coverage, 45311,
     /* 2450007 */     GIR_EraseRootFromParent_Done,
     /* 2450008 */   // Label 35451: @2450008
     /* 2450008 */   GIM_Try, /*On fail goto*//*Label 35452*/ GIMT_Encode4(2450080), // Rule ID 45312 //
     /* 2450013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450045 */     // MIs[0] policy
     /* 2450045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450055 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2450058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450079 */     // GIR_Coverage, 45312,
     /* 2450079 */     GIR_EraseRootFromParent_Done,
     /* 2450080 */   // Label 35452: @2450080
     /* 2450080 */   GIM_Try, /*On fail goto*//*Label 35453*/ GIMT_Encode4(2450152), // Rule ID 45313 //
     /* 2450085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450117 */     // MIs[0] policy
     /* 2450117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450127 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2450130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450151 */     // GIR_Coverage, 45313,
     /* 2450151 */     GIR_EraseRootFromParent_Done,
     /* 2450152 */   // Label 35453: @2450152
     /* 2450152 */   GIM_Reject,
     /* 2450153 */ // Label 35449: @2450153
     /* 2450153 */ GIM_Reject,
     /* 2450154 */ // Label 35371: @2450154
     /* 2450154 */ GIM_Try, /*On fail goto*//*Label 35454*/ GIMT_Encode4(2450786),
     /* 2450159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2450162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2450165 */   GIM_Try, /*On fail goto*//*Label 35455*/ GIMT_Encode4(2450248), // Rule ID 45330 //
     /* 2450170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450206 */     // MIs[1] Operand 1
     /* 2450206 */     // No operand predicates
     /* 2450206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450210 */     // MIs[0] policy
     /* 2450210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450222 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450247 */     // GIR_Coverage, 45330,
     /* 2450247 */     GIR_EraseRootFromParent_Done,
     /* 2450248 */   // Label 35455: @2450248
     /* 2450248 */   GIM_Try, /*On fail goto*//*Label 35456*/ GIMT_Encode4(2450331), // Rule ID 45331 //
     /* 2450253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450289 */     // MIs[1] Operand 1
     /* 2450289 */     // No operand predicates
     /* 2450289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450293 */     // MIs[0] policy
     /* 2450293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450305 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450330 */     // GIR_Coverage, 45331,
     /* 2450330 */     GIR_EraseRootFromParent_Done,
     /* 2450331 */   // Label 35456: @2450331
     /* 2450331 */   GIM_Try, /*On fail goto*//*Label 35457*/ GIMT_Encode4(2450414), // Rule ID 45402 //
     /* 2450336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450372 */     // MIs[1] Operand 1
     /* 2450372 */     // No operand predicates
     /* 2450372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450376 */     // MIs[0] policy
     /* 2450376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450388 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450413 */     // GIR_Coverage, 45402,
     /* 2450413 */     GIR_EraseRootFromParent_Done,
     /* 2450414 */   // Label 35457: @2450414
     /* 2450414 */   GIM_Try, /*On fail goto*//*Label 35458*/ GIMT_Encode4(2450497), // Rule ID 45403 //
     /* 2450419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450455 */     // MIs[1] Operand 1
     /* 2450455 */     // No operand predicates
     /* 2450455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450459 */     // MIs[0] policy
     /* 2450459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450471 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2450474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450496 */     // GIR_Coverage, 45403,
     /* 2450496 */     GIR_EraseRootFromParent_Done,
     /* 2450497 */   // Label 35458: @2450497
     /* 2450497 */   GIM_Try, /*On fail goto*//*Label 35459*/ GIMT_Encode4(2450569), // Rule ID 45332 //
     /* 2450502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450534 */     // MIs[0] policy
     /* 2450534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450544 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450568 */     // GIR_Coverage, 45332,
     /* 2450568 */     GIR_EraseRootFromParent_Done,
     /* 2450569 */   // Label 35459: @2450569
     /* 2450569 */   GIM_Try, /*On fail goto*//*Label 35460*/ GIMT_Encode4(2450641), // Rule ID 45333 //
     /* 2450574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450606 */     // MIs[0] policy
     /* 2450606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450616 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450640 */     // GIR_Coverage, 45333,
     /* 2450640 */     GIR_EraseRootFromParent_Done,
     /* 2450641 */   // Label 35460: @2450641
     /* 2450641 */   GIM_Try, /*On fail goto*//*Label 35461*/ GIMT_Encode4(2450713), // Rule ID 45404 //
     /* 2450646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450678 */     // MIs[0] policy
     /* 2450678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450688 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450712 */     // GIR_Coverage, 45404,
     /* 2450712 */     GIR_EraseRootFromParent_Done,
     /* 2450713 */   // Label 35461: @2450713
     /* 2450713 */   GIM_Try, /*On fail goto*//*Label 35462*/ GIMT_Encode4(2450785), // Rule ID 45405 //
     /* 2450718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2450734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2450742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450750 */     // MIs[0] policy
     /* 2450750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450760 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2450763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450784 */     // GIR_Coverage, 45405,
     /* 2450784 */     GIR_EraseRootFromParent_Done,
     /* 2450785 */   // Label 35462: @2450785
     /* 2450785 */   GIM_Reject,
     /* 2450786 */ // Label 35454: @2450786
     /* 2450786 */ GIM_Reject,
     /* 2450787 */ // Label 35372: @2450787
     /* 2450787 */ GIM_Try, /*On fail goto*//*Label 35463*/ GIMT_Encode4(2451419),
     /* 2450792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2450795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2450798 */   GIM_Try, /*On fail goto*//*Label 35464*/ GIMT_Encode4(2450881), // Rule ID 45366 //
     /* 2450803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450839 */     // MIs[1] Operand 1
     /* 2450839 */     // No operand predicates
     /* 2450839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450843 */     // MIs[0] policy
     /* 2450843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450855 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450880 */     // GIR_Coverage, 45366,
     /* 2450880 */     GIR_EraseRootFromParent_Done,
     /* 2450881 */   // Label 35464: @2450881
     /* 2450881 */   GIM_Try, /*On fail goto*//*Label 35465*/ GIMT_Encode4(2450964), // Rule ID 45367 //
     /* 2450886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450922 */     // MIs[1] Operand 1
     /* 2450922 */     // No operand predicates
     /* 2450922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450926 */     // MIs[0] policy
     /* 2450926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450938 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2450941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2450960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450963 */     // GIR_Coverage, 45367,
     /* 2450963 */     GIR_EraseRootFromParent_Done,
     /* 2450964 */   // Label 35465: @2450964
     /* 2450964 */   GIM_Try, /*On fail goto*//*Label 35466*/ GIMT_Encode4(2451047), // Rule ID 45426 //
     /* 2450969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2450978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2450985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2450993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451005 */     // MIs[1] Operand 1
     /* 2451005 */     // No operand predicates
     /* 2451005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451009 */     // MIs[0] policy
     /* 2451009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451021 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2451024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451046 */     // GIR_Coverage, 45426,
     /* 2451046 */     GIR_EraseRootFromParent_Done,
     /* 2451047 */   // Label 35466: @2451047
     /* 2451047 */   GIM_Try, /*On fail goto*//*Label 35467*/ GIMT_Encode4(2451130), // Rule ID 45427 //
     /* 2451052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451088 */     // MIs[1] Operand 1
     /* 2451088 */     // No operand predicates
     /* 2451088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451092 */     // MIs[0] policy
     /* 2451092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451104 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2451107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451129 */     // GIR_Coverage, 45427,
     /* 2451129 */     GIR_EraseRootFromParent_Done,
     /* 2451130 */   // Label 35467: @2451130
     /* 2451130 */   GIM_Try, /*On fail goto*//*Label 35468*/ GIMT_Encode4(2451202), // Rule ID 45368 //
     /* 2451135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451167 */     // MIs[0] policy
     /* 2451167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451177 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451201 */     // GIR_Coverage, 45368,
     /* 2451201 */     GIR_EraseRootFromParent_Done,
     /* 2451202 */   // Label 35468: @2451202
     /* 2451202 */   GIM_Try, /*On fail goto*//*Label 35469*/ GIMT_Encode4(2451274), // Rule ID 45369 //
     /* 2451207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451239 */     // MIs[0] policy
     /* 2451239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451249 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451273 */     // GIR_Coverage, 45369,
     /* 2451273 */     GIR_EraseRootFromParent_Done,
     /* 2451274 */   // Label 35469: @2451274
     /* 2451274 */   GIM_Try, /*On fail goto*//*Label 35470*/ GIMT_Encode4(2451346), // Rule ID 45428 //
     /* 2451279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2451282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451311 */     // MIs[0] policy
     /* 2451311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451321 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451345 */     // GIR_Coverage, 45428,
     /* 2451345 */     GIR_EraseRootFromParent_Done,
     /* 2451346 */   // Label 35470: @2451346
     /* 2451346 */   GIM_Try, /*On fail goto*//*Label 35471*/ GIMT_Encode4(2451418), // Rule ID 45429 //
     /* 2451351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2451354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2451367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2451375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451383 */     // MIs[0] policy
     /* 2451383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451393 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2451396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2451414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451417 */     // GIR_Coverage, 45429,
     /* 2451417 */     GIR_EraseRootFromParent_Done,
     /* 2451418 */   // Label 35471: @2451418
     /* 2451418 */   GIM_Reject,
     /* 2451419 */ // Label 35463: @2451419
     /* 2451419 */ GIM_Reject,
     /* 2451420 */ // Label 35373: @2451420
     /* 2451420 */ GIM_Try, /*On fail goto*//*Label 35472*/ GIMT_Encode4(2452052),
     /* 2451425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2451428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2451431 */   GIM_Try, /*On fail goto*//*Label 35473*/ GIMT_Encode4(2451514), // Rule ID 45382 //
     /* 2451436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451472 */     // MIs[1] Operand 1
     /* 2451472 */     // No operand predicates
     /* 2451472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451476 */     // MIs[0] policy
     /* 2451476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451488 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451513 */     // GIR_Coverage, 45382,
     /* 2451513 */     GIR_EraseRootFromParent_Done,
     /* 2451514 */   // Label 35473: @2451514
     /* 2451514 */   GIM_Try, /*On fail goto*//*Label 35474*/ GIMT_Encode4(2451597), // Rule ID 45383 //
     /* 2451519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451555 */     // MIs[1] Operand 1
     /* 2451555 */     // No operand predicates
     /* 2451555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451559 */     // MIs[0] policy
     /* 2451559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451571 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451596 */     // GIR_Coverage, 45383,
     /* 2451596 */     GIR_EraseRootFromParent_Done,
     /* 2451597 */   // Label 35474: @2451597
     /* 2451597 */   GIM_Try, /*On fail goto*//*Label 35475*/ GIMT_Encode4(2451680), // Rule ID 45442 //
     /* 2451602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451638 */     // MIs[1] Operand 1
     /* 2451638 */     // No operand predicates
     /* 2451638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451642 */     // MIs[0] policy
     /* 2451642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451654 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451679 */     // GIR_Coverage, 45442,
     /* 2451679 */     GIR_EraseRootFromParent_Done,
     /* 2451680 */   // Label 35475: @2451680
     /* 2451680 */   GIM_Try, /*On fail goto*//*Label 35476*/ GIMT_Encode4(2451763), // Rule ID 45443 //
     /* 2451685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2451713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2451717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2451721 */     // MIs[1] Operand 1
     /* 2451721 */     // No operand predicates
     /* 2451721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451725 */     // MIs[0] policy
     /* 2451725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2451730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451737 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2451740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2451749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451762 */     // GIR_Coverage, 45443,
     /* 2451762 */     GIR_EraseRootFromParent_Done,
     /* 2451763 */   // Label 35476: @2451763
     /* 2451763 */   GIM_Try, /*On fail goto*//*Label 35477*/ GIMT_Encode4(2451835), // Rule ID 45384 //
     /* 2451768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451800 */     // MIs[0] policy
     /* 2451800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451810 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451834 */     // GIR_Coverage, 45384,
     /* 2451834 */     GIR_EraseRootFromParent_Done,
     /* 2451835 */   // Label 35477: @2451835
     /* 2451835 */   GIM_Try, /*On fail goto*//*Label 35478*/ GIMT_Encode4(2451907), // Rule ID 45385 //
     /* 2451840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451872 */     // MIs[0] policy
     /* 2451872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451882 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2451882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451906 */     // GIR_Coverage, 45385,
     /* 2451906 */     GIR_EraseRootFromParent_Done,
     /* 2451907 */   // Label 35478: @2451907
     /* 2451907 */   GIM_Try, /*On fail goto*//*Label 35479*/ GIMT_Encode4(2451979), // Rule ID 45444 //
     /* 2451912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2451915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2451918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2451924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2451928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2451936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2451940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2451944 */     // MIs[0] policy
     /* 2451944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2451947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2451954 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2451954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2451957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2451959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2451961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2451963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2451965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2451967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2451972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2451975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2451977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2451978 */     // GIR_Coverage, 45444,
     /* 2451978 */     GIR_EraseRootFromParent_Done,
     /* 2451979 */   // Label 35479: @2451979
     /* 2451979 */   GIM_Try, /*On fail goto*//*Label 35480*/ GIMT_Encode4(2452051), // Rule ID 45445 //
     /* 2451984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2451987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2451990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2451993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2451996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2452000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2452008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452016 */     // MIs[0] policy
     /* 2452016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452026 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2452029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2452047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452050 */     // GIR_Coverage, 45445,
     /* 2452050 */     GIR_EraseRootFromParent_Done,
     /* 2452051 */   // Label 35480: @2452051
     /* 2452051 */   GIM_Reject,
     /* 2452052 */ // Label 35472: @2452052
     /* 2452052 */ GIM_Reject,
     /* 2452053 */ // Label 35374: @2452053
     /* 2452053 */ GIM_Try, /*On fail goto*//*Label 35481*/ GIMT_Encode4(2452375),
     /* 2452058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2452061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2452064 */   GIM_Try, /*On fail goto*//*Label 35482*/ GIMT_Encode4(2452147), // Rule ID 45326 //
     /* 2452069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452105 */     // MIs[1] Operand 1
     /* 2452105 */     // No operand predicates
     /* 2452105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452109 */     // MIs[0] policy
     /* 2452109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452121 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2452124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452146 */     // GIR_Coverage, 45326,
     /* 2452146 */     GIR_EraseRootFromParent_Done,
     /* 2452147 */   // Label 35482: @2452147
     /* 2452147 */   GIM_Try, /*On fail goto*//*Label 35483*/ GIMT_Encode4(2452230), // Rule ID 45327 //
     /* 2452152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452188 */     // MIs[1] Operand 1
     /* 2452188 */     // No operand predicates
     /* 2452188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452192 */     // MIs[0] policy
     /* 2452192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452204 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2452207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452229 */     // GIR_Coverage, 45327,
     /* 2452229 */     GIR_EraseRootFromParent_Done,
     /* 2452230 */   // Label 35483: @2452230
     /* 2452230 */   GIM_Try, /*On fail goto*//*Label 35484*/ GIMT_Encode4(2452302), // Rule ID 45328 //
     /* 2452235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452267 */     // MIs[0] policy
     /* 2452267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452277 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2452280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452301 */     // GIR_Coverage, 45328,
     /* 2452301 */     GIR_EraseRootFromParent_Done,
     /* 2452302 */   // Label 35484: @2452302
     /* 2452302 */   GIM_Try, /*On fail goto*//*Label 35485*/ GIMT_Encode4(2452374), // Rule ID 45329 //
     /* 2452307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2452323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2452331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452339 */     // MIs[0] policy
     /* 2452339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452349 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2452352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2452370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452373 */     // GIR_Coverage, 45329,
     /* 2452373 */     GIR_EraseRootFromParent_Done,
     /* 2452374 */   // Label 35485: @2452374
     /* 2452374 */   GIM_Reject,
     /* 2452375 */ // Label 35481: @2452375
     /* 2452375 */ GIM_Reject,
     /* 2452376 */ // Label 35375: @2452376
     /* 2452376 */ GIM_Try, /*On fail goto*//*Label 35486*/ GIMT_Encode4(2453008),
     /* 2452381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2452384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2452387 */   GIM_Try, /*On fail goto*//*Label 35487*/ GIMT_Encode4(2452470), // Rule ID 45354 //
     /* 2452392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452428 */     // MIs[1] Operand 1
     /* 2452428 */     // No operand predicates
     /* 2452428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452432 */     // MIs[0] policy
     /* 2452432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452444 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452469 */     // GIR_Coverage, 45354,
     /* 2452469 */     GIR_EraseRootFromParent_Done,
     /* 2452470 */   // Label 35487: @2452470
     /* 2452470 */   GIM_Try, /*On fail goto*//*Label 35488*/ GIMT_Encode4(2452553), // Rule ID 45355 //
     /* 2452475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452511 */     // MIs[1] Operand 1
     /* 2452511 */     // No operand predicates
     /* 2452511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452515 */     // MIs[0] policy
     /* 2452515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452527 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452552 */     // GIR_Coverage, 45355,
     /* 2452552 */     GIR_EraseRootFromParent_Done,
     /* 2452553 */   // Label 35488: @2452553
     /* 2452553 */   GIM_Try, /*On fail goto*//*Label 35489*/ GIMT_Encode4(2452636), // Rule ID 45414 //
     /* 2452558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452594 */     // MIs[1] Operand 1
     /* 2452594 */     // No operand predicates
     /* 2452594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452598 */     // MIs[0] policy
     /* 2452598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452610 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452635 */     // GIR_Coverage, 45414,
     /* 2452635 */     GIR_EraseRootFromParent_Done,
     /* 2452636 */   // Label 35489: @2452636
     /* 2452636 */   GIM_Try, /*On fail goto*//*Label 35490*/ GIMT_Encode4(2452719), // Rule ID 45415 //
     /* 2452641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2452669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2452673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2452677 */     // MIs[1] Operand 1
     /* 2452677 */     // No operand predicates
     /* 2452677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452681 */     // MIs[0] policy
     /* 2452681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2452686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452693 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2452696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2452705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452718 */     // GIR_Coverage, 45415,
     /* 2452718 */     GIR_EraseRootFromParent_Done,
     /* 2452719 */   // Label 35490: @2452719
     /* 2452719 */   GIM_Try, /*On fail goto*//*Label 35491*/ GIMT_Encode4(2452791), // Rule ID 45356 //
     /* 2452724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452756 */     // MIs[0] policy
     /* 2452756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452766 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452790 */     // GIR_Coverage, 45356,
     /* 2452790 */     GIR_EraseRootFromParent_Done,
     /* 2452791 */   // Label 35491: @2452791
     /* 2452791 */   GIM_Try, /*On fail goto*//*Label 35492*/ GIMT_Encode4(2452863), // Rule ID 45357 //
     /* 2452796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452828 */     // MIs[0] policy
     /* 2452828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452838 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452862 */     // GIR_Coverage, 45357,
     /* 2452862 */     GIR_EraseRootFromParent_Done,
     /* 2452863 */   // Label 35492: @2452863
     /* 2452863 */   GIM_Try, /*On fail goto*//*Label 35493*/ GIMT_Encode4(2452935), // Rule ID 45416 //
     /* 2452868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2452871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2452874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2452880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452900 */     // MIs[0] policy
     /* 2452900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452910 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2452910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2452928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2452931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2452933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2452934 */     // GIR_Coverage, 45416,
     /* 2452934 */     GIR_EraseRootFromParent_Done,
     /* 2452935 */   // Label 35493: @2452935
     /* 2452935 */   GIM_Try, /*On fail goto*//*Label 35494*/ GIMT_Encode4(2453007), // Rule ID 45417 //
     /* 2452940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2452943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2452946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2452949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2452952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2452956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2452964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2452968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2452972 */     // MIs[0] policy
     /* 2452972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2452975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2452982 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2452982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2452985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2452987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2452989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2452991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2452993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2452995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2453003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453006 */     // GIR_Coverage, 45417,
     /* 2453006 */     GIR_EraseRootFromParent_Done,
     /* 2453007 */   // Label 35494: @2453007
     /* 2453007 */   GIM_Reject,
     /* 2453008 */ // Label 35486: @2453008
     /* 2453008 */ GIM_Reject,
     /* 2453009 */ // Label 35376: @2453009
     /* 2453009 */ GIM_Try, /*On fail goto*//*Label 35495*/ GIMT_Encode4(2453641),
     /* 2453014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2453017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2453020 */   GIM_Try, /*On fail goto*//*Label 35496*/ GIMT_Encode4(2453103), // Rule ID 45370 //
     /* 2453025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453061 */     // MIs[1] Operand 1
     /* 2453061 */     // No operand predicates
     /* 2453061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453065 */     // MIs[0] policy
     /* 2453065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453077 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453102 */     // GIR_Coverage, 45370,
     /* 2453102 */     GIR_EraseRootFromParent_Done,
     /* 2453103 */   // Label 35496: @2453103
     /* 2453103 */   GIM_Try, /*On fail goto*//*Label 35497*/ GIMT_Encode4(2453186), // Rule ID 45371 //
     /* 2453108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453144 */     // MIs[1] Operand 1
     /* 2453144 */     // No operand predicates
     /* 2453144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453148 */     // MIs[0] policy
     /* 2453148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453160 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453185 */     // GIR_Coverage, 45371,
     /* 2453185 */     GIR_EraseRootFromParent_Done,
     /* 2453186 */   // Label 35497: @2453186
     /* 2453186 */   GIM_Try, /*On fail goto*//*Label 35498*/ GIMT_Encode4(2453269), // Rule ID 45430 //
     /* 2453191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453227 */     // MIs[1] Operand 1
     /* 2453227 */     // No operand predicates
     /* 2453227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453231 */     // MIs[0] policy
     /* 2453231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453243 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453268 */     // GIR_Coverage, 45430,
     /* 2453268 */     GIR_EraseRootFromParent_Done,
     /* 2453269 */   // Label 35498: @2453269
     /* 2453269 */   GIM_Try, /*On fail goto*//*Label 35499*/ GIMT_Encode4(2453352), // Rule ID 45431 //
     /* 2453274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453310 */     // MIs[1] Operand 1
     /* 2453310 */     // No operand predicates
     /* 2453310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453314 */     // MIs[0] policy
     /* 2453314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453326 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2453329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453351 */     // GIR_Coverage, 45431,
     /* 2453351 */     GIR_EraseRootFromParent_Done,
     /* 2453352 */   // Label 35499: @2453352
     /* 2453352 */   GIM_Try, /*On fail goto*//*Label 35500*/ GIMT_Encode4(2453424), // Rule ID 45372 //
     /* 2453357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453389 */     // MIs[0] policy
     /* 2453389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453399 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453423 */     // GIR_Coverage, 45372,
     /* 2453423 */     GIR_EraseRootFromParent_Done,
     /* 2453424 */   // Label 35500: @2453424
     /* 2453424 */   GIM_Try, /*On fail goto*//*Label 35501*/ GIMT_Encode4(2453496), // Rule ID 45373 //
     /* 2453429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453461 */     // MIs[0] policy
     /* 2453461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453471 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453495 */     // GIR_Coverage, 45373,
     /* 2453495 */     GIR_EraseRootFromParent_Done,
     /* 2453496 */   // Label 35501: @2453496
     /* 2453496 */   GIM_Try, /*On fail goto*//*Label 35502*/ GIMT_Encode4(2453568), // Rule ID 45432 //
     /* 2453501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2453504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453533 */     // MIs[0] policy
     /* 2453533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453543 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453567 */     // GIR_Coverage, 45432,
     /* 2453567 */     GIR_EraseRootFromParent_Done,
     /* 2453568 */   // Label 35502: @2453568
     /* 2453568 */   GIM_Try, /*On fail goto*//*Label 35503*/ GIMT_Encode4(2453640), // Rule ID 45433 //
     /* 2453573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2453576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2453589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2453597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2453601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453605 */     // MIs[0] policy
     /* 2453605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453615 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2453618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2453626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2453636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453639 */     // GIR_Coverage, 45433,
     /* 2453639 */     GIR_EraseRootFromParent_Done,
     /* 2453640 */   // Label 35503: @2453640
     /* 2453640 */   GIM_Reject,
     /* 2453641 */ // Label 35495: @2453641
     /* 2453641 */ GIM_Reject,
     /* 2453642 */ // Label 35377: @2453642
     /* 2453642 */ GIM_Try, /*On fail goto*//*Label 35504*/ GIMT_Encode4(2454274),
     /* 2453647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2453650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2453653 */   GIM_Try, /*On fail goto*//*Label 35505*/ GIMT_Encode4(2453736), // Rule ID 45386 //
     /* 2453658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2453661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453694 */     // MIs[1] Operand 1
     /* 2453694 */     // No operand predicates
     /* 2453694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453698 */     // MIs[0] policy
     /* 2453698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453710 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453735 */     // GIR_Coverage, 45386,
     /* 2453735 */     GIR_EraseRootFromParent_Done,
     /* 2453736 */   // Label 35505: @2453736
     /* 2453736 */   GIM_Try, /*On fail goto*//*Label 35506*/ GIMT_Encode4(2453819), // Rule ID 45387 //
     /* 2453741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2453744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453777 */     // MIs[1] Operand 1
     /* 2453777 */     // No operand predicates
     /* 2453777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453781 */     // MIs[0] policy
     /* 2453781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453793 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453818 */     // GIR_Coverage, 45387,
     /* 2453818 */     GIR_EraseRootFromParent_Done,
     /* 2453819 */   // Label 35506: @2453819
     /* 2453819 */   GIM_Try, /*On fail goto*//*Label 35507*/ GIMT_Encode4(2453902), // Rule ID 45446 //
     /* 2453824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2453827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2453836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453860 */     // MIs[1] Operand 1
     /* 2453860 */     // No operand predicates
     /* 2453860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453864 */     // MIs[0] policy
     /* 2453864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453876 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2453876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453901 */     // GIR_Coverage, 45446,
     /* 2453901 */     GIR_EraseRootFromParent_Done,
     /* 2453902 */   // Label 35507: @2453902
     /* 2453902 */   GIM_Try, /*On fail goto*//*Label 35508*/ GIMT_Encode4(2453985), // Rule ID 45447 //
     /* 2453907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2453910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2453913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2453919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2453923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2453931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2453935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2453939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2453943 */     // MIs[1] Operand 1
     /* 2453943 */     // No operand predicates
     /* 2453943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2453947 */     // MIs[0] policy
     /* 2453947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2453950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2453952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2453959 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2453959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2453962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2453964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2453966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2453968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2453971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2453973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2453978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2453981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2453983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453984 */     // GIR_Coverage, 45447,
     /* 2453984 */     GIR_EraseRootFromParent_Done,
     /* 2453985 */   // Label 35508: @2453985
     /* 2453985 */   GIM_Try, /*On fail goto*//*Label 35509*/ GIMT_Encode4(2454057), // Rule ID 45388 //
     /* 2453990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2453993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2453996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2453999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454022 */     // MIs[0] policy
     /* 2454022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454032 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454056 */     // GIR_Coverage, 45388,
     /* 2454056 */     GIR_EraseRootFromParent_Done,
     /* 2454057 */   // Label 35509: @2454057
     /* 2454057 */   GIM_Try, /*On fail goto*//*Label 35510*/ GIMT_Encode4(2454129), // Rule ID 45389 //
     /* 2454062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2454065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454094 */     // MIs[0] policy
     /* 2454094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454104 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454128 */     // GIR_Coverage, 45389,
     /* 2454128 */     GIR_EraseRootFromParent_Done,
     /* 2454129 */   // Label 35510: @2454129
     /* 2454129 */   GIM_Try, /*On fail goto*//*Label 35511*/ GIMT_Encode4(2454201), // Rule ID 45448 //
     /* 2454134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2454137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454166 */     // MIs[0] policy
     /* 2454166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454176 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454200 */     // GIR_Coverage, 45448,
     /* 2454200 */     GIR_EraseRootFromParent_Done,
     /* 2454201 */   // Label 35511: @2454201
     /* 2454201 */   GIM_Try, /*On fail goto*//*Label 35512*/ GIMT_Encode4(2454273), // Rule ID 45449 //
     /* 2454206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2454209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2454215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2454222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2454230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454238 */     // MIs[0] policy
     /* 2454238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454248 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2454251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2454269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454272 */     // GIR_Coverage, 45449,
     /* 2454272 */     GIR_EraseRootFromParent_Done,
     /* 2454273 */   // Label 35512: @2454273
     /* 2454273 */   GIM_Reject,
     /* 2454274 */ // Label 35504: @2454274
     /* 2454274 */ GIM_Reject,
     /* 2454275 */ // Label 35378: @2454275
     /* 2454275 */ GIM_Try, /*On fail goto*//*Label 35513*/ GIMT_Encode4(2454597),
     /* 2454280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2454283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2454286 */   GIM_Try, /*On fail goto*//*Label 35514*/ GIMT_Encode4(2454369), // Rule ID 45342 //
     /* 2454291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454327 */     // MIs[1] Operand 1
     /* 2454327 */     // No operand predicates
     /* 2454327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454331 */     // MIs[0] policy
     /* 2454331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454343 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2454346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454368 */     // GIR_Coverage, 45342,
     /* 2454368 */     GIR_EraseRootFromParent_Done,
     /* 2454369 */   // Label 35514: @2454369
     /* 2454369 */   GIM_Try, /*On fail goto*//*Label 35515*/ GIMT_Encode4(2454452), // Rule ID 45343 //
     /* 2454374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454410 */     // MIs[1] Operand 1
     /* 2454410 */     // No operand predicates
     /* 2454410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454414 */     // MIs[0] policy
     /* 2454414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454426 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2454429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454451 */     // GIR_Coverage, 45343,
     /* 2454451 */     GIR_EraseRootFromParent_Done,
     /* 2454452 */   // Label 35515: @2454452
     /* 2454452 */   GIM_Try, /*On fail goto*//*Label 35516*/ GIMT_Encode4(2454524), // Rule ID 45344 //
     /* 2454457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454489 */     // MIs[0] policy
     /* 2454489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454499 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2454502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454523 */     // GIR_Coverage, 45344,
     /* 2454523 */     GIR_EraseRootFromParent_Done,
     /* 2454524 */   // Label 35516: @2454524
     /* 2454524 */   GIM_Try, /*On fail goto*//*Label 35517*/ GIMT_Encode4(2454596), // Rule ID 45345 //
     /* 2454529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2454545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2454553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454561 */     // MIs[0] policy
     /* 2454561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454571 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2454574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2454592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454595 */     // GIR_Coverage, 45345,
     /* 2454595 */     GIR_EraseRootFromParent_Done,
     /* 2454596 */   // Label 35517: @2454596
     /* 2454596 */   GIM_Reject,
     /* 2454597 */ // Label 35513: @2454597
     /* 2454597 */ GIM_Reject,
     /* 2454598 */ // Label 35379: @2454598
     /* 2454598 */ GIM_Try, /*On fail goto*//*Label 35518*/ GIMT_Encode4(2455230),
     /* 2454603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2454606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2454609 */   GIM_Try, /*On fail goto*//*Label 35519*/ GIMT_Encode4(2454692), // Rule ID 45358 //
     /* 2454614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454650 */     // MIs[1] Operand 1
     /* 2454650 */     // No operand predicates
     /* 2454650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454654 */     // MIs[0] policy
     /* 2454654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454666 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454691 */     // GIR_Coverage, 45358,
     /* 2454691 */     GIR_EraseRootFromParent_Done,
     /* 2454692 */   // Label 35519: @2454692
     /* 2454692 */   GIM_Try, /*On fail goto*//*Label 35520*/ GIMT_Encode4(2454775), // Rule ID 45359 //
     /* 2454697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454733 */     // MIs[1] Operand 1
     /* 2454733 */     // No operand predicates
     /* 2454733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454737 */     // MIs[0] policy
     /* 2454737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454749 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454774 */     // GIR_Coverage, 45359,
     /* 2454774 */     GIR_EraseRootFromParent_Done,
     /* 2454775 */   // Label 35520: @2454775
     /* 2454775 */   GIM_Try, /*On fail goto*//*Label 35521*/ GIMT_Encode4(2454858), // Rule ID 45418 //
     /* 2454780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454816 */     // MIs[1] Operand 1
     /* 2454816 */     // No operand predicates
     /* 2454816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454820 */     // MIs[0] policy
     /* 2454820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454832 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454857 */     // GIR_Coverage, 45418,
     /* 2454857 */     GIR_EraseRootFromParent_Done,
     /* 2454858 */   // Label 35521: @2454858
     /* 2454858 */   GIM_Try, /*On fail goto*//*Label 35522*/ GIMT_Encode4(2454941), // Rule ID 45419 //
     /* 2454863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2454866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2454869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2454875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2454891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2454895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2454899 */     // MIs[1] Operand 1
     /* 2454899 */     // No operand predicates
     /* 2454899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454903 */     // MIs[0] policy
     /* 2454903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2454908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454915 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2454915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2454918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2454927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2454929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2454934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2454937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2454939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2454940 */     // GIR_Coverage, 45419,
     /* 2454940 */     GIR_EraseRootFromParent_Done,
     /* 2454941 */   // Label 35522: @2454941
     /* 2454941 */   GIM_Try, /*On fail goto*//*Label 35523*/ GIMT_Encode4(2455013), // Rule ID 45360 //
     /* 2454946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2454949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2454952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2454955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2454958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2454962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2454970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2454974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2454978 */     // MIs[0] policy
     /* 2454978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2454981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2454988 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2454988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2454991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2454993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2454995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2454997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2454999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455012 */     // GIR_Coverage, 45360,
     /* 2455012 */     GIR_EraseRootFromParent_Done,
     /* 2455013 */   // Label 35523: @2455013
     /* 2455013 */   GIM_Try, /*On fail goto*//*Label 35524*/ GIMT_Encode4(2455085), // Rule ID 45361 //
     /* 2455018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455050 */     // MIs[0] policy
     /* 2455050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455060 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455084 */     // GIR_Coverage, 45361,
     /* 2455084 */     GIR_EraseRootFromParent_Done,
     /* 2455085 */   // Label 35524: @2455085
     /* 2455085 */   GIM_Try, /*On fail goto*//*Label 35525*/ GIMT_Encode4(2455157), // Rule ID 45420 //
     /* 2455090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455122 */     // MIs[0] policy
     /* 2455122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455132 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455156 */     // GIR_Coverage, 45420,
     /* 2455156 */     GIR_EraseRootFromParent_Done,
     /* 2455157 */   // Label 35525: @2455157
     /* 2455157 */   GIM_Try, /*On fail goto*//*Label 35526*/ GIMT_Encode4(2455229), // Rule ID 45421 //
     /* 2455162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455194 */     // MIs[0] policy
     /* 2455194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455204 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2455207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2455225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455228 */     // GIR_Coverage, 45421,
     /* 2455228 */     GIR_EraseRootFromParent_Done,
     /* 2455229 */   // Label 35526: @2455229
     /* 2455229 */   GIM_Reject,
     /* 2455230 */ // Label 35518: @2455230
     /* 2455230 */ GIM_Reject,
     /* 2455231 */ // Label 35380: @2455231
     /* 2455231 */ GIM_Try, /*On fail goto*//*Label 35527*/ GIMT_Encode4(2455863),
     /* 2455236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2455239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2455242 */   GIM_Try, /*On fail goto*//*Label 35528*/ GIMT_Encode4(2455325), // Rule ID 45374 //
     /* 2455247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455283 */     // MIs[1] Operand 1
     /* 2455283 */     // No operand predicates
     /* 2455283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455287 */     // MIs[0] policy
     /* 2455287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455299 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455324 */     // GIR_Coverage, 45374,
     /* 2455324 */     GIR_EraseRootFromParent_Done,
     /* 2455325 */   // Label 35528: @2455325
     /* 2455325 */   GIM_Try, /*On fail goto*//*Label 35529*/ GIMT_Encode4(2455408), // Rule ID 45375 //
     /* 2455330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455366 */     // MIs[1] Operand 1
     /* 2455366 */     // No operand predicates
     /* 2455366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455370 */     // MIs[0] policy
     /* 2455370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455382 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455407 */     // GIR_Coverage, 45375,
     /* 2455407 */     GIR_EraseRootFromParent_Done,
     /* 2455408 */   // Label 35529: @2455408
     /* 2455408 */   GIM_Try, /*On fail goto*//*Label 35530*/ GIMT_Encode4(2455491), // Rule ID 45434 //
     /* 2455413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455449 */     // MIs[1] Operand 1
     /* 2455449 */     // No operand predicates
     /* 2455449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455453 */     // MIs[0] policy
     /* 2455453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455465 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455490 */     // GIR_Coverage, 45434,
     /* 2455490 */     GIR_EraseRootFromParent_Done,
     /* 2455491 */   // Label 35530: @2455491
     /* 2455491 */   GIM_Try, /*On fail goto*//*Label 35531*/ GIMT_Encode4(2455574), // Rule ID 45435 //
     /* 2455496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455532 */     // MIs[1] Operand 1
     /* 2455532 */     // No operand predicates
     /* 2455532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455536 */     // MIs[0] policy
     /* 2455536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455548 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2455551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455573 */     // GIR_Coverage, 45435,
     /* 2455573 */     GIR_EraseRootFromParent_Done,
     /* 2455574 */   // Label 35531: @2455574
     /* 2455574 */   GIM_Try, /*On fail goto*//*Label 35532*/ GIMT_Encode4(2455646), // Rule ID 45376 //
     /* 2455579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455611 */     // MIs[0] policy
     /* 2455611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455621 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455645 */     // GIR_Coverage, 45376,
     /* 2455645 */     GIR_EraseRootFromParent_Done,
     /* 2455646 */   // Label 35532: @2455646
     /* 2455646 */   GIM_Try, /*On fail goto*//*Label 35533*/ GIMT_Encode4(2455718), // Rule ID 45377 //
     /* 2455651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455683 */     // MIs[0] policy
     /* 2455683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455693 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455717 */     // GIR_Coverage, 45377,
     /* 2455717 */     GIR_EraseRootFromParent_Done,
     /* 2455718 */   // Label 35533: @2455718
     /* 2455718 */   GIM_Try, /*On fail goto*//*Label 35534*/ GIMT_Encode4(2455790), // Rule ID 45436 //
     /* 2455723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455755 */     // MIs[0] policy
     /* 2455755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455765 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455789 */     // GIR_Coverage, 45436,
     /* 2455789 */     GIR_EraseRootFromParent_Done,
     /* 2455790 */   // Label 35534: @2455790
     /* 2455790 */   GIM_Try, /*On fail goto*//*Label 35535*/ GIMT_Encode4(2455862), // Rule ID 45437 //
     /* 2455795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2455804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2455811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2455819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2455823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455827 */     // MIs[0] policy
     /* 2455827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455837 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2455837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2455840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2455848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2455858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455861 */     // GIR_Coverage, 45437,
     /* 2455861 */     GIR_EraseRootFromParent_Done,
     /* 2455862 */   // Label 35535: @2455862
     /* 2455862 */   GIM_Reject,
     /* 2455863 */ // Label 35527: @2455863
     /* 2455863 */ GIM_Reject,
     /* 2455864 */ // Label 35381: @2455864
     /* 2455864 */ GIM_Try, /*On fail goto*//*Label 35536*/ GIMT_Encode4(2456186),
     /* 2455869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2455872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2455875 */   GIM_Try, /*On fail goto*//*Label 35537*/ GIMT_Encode4(2455958), // Rule ID 45346 //
     /* 2455880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2455883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2455886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2455889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2455892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455916 */     // MIs[1] Operand 1
     /* 2455916 */     // No operand predicates
     /* 2455916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2455920 */     // MIs[0] policy
     /* 2455920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2455923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2455925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2455932 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2455932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2455935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2455937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2455939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2455941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2455944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2455946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2455951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2455954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2455956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2455957 */     // GIR_Coverage, 45346,
     /* 2455957 */     GIR_EraseRootFromParent_Done,
     /* 2455958 */   // Label 35537: @2455958
     /* 2455958 */   GIM_Try, /*On fail goto*//*Label 35538*/ GIMT_Encode4(2456041), // Rule ID 45347 //
     /* 2455963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2455966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2455969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2455972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2455975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2455979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2455987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2455991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2455995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2455999 */     // MIs[1] Operand 1
     /* 2455999 */     // No operand predicates
     /* 2455999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456003 */     // MIs[0] policy
     /* 2456003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456015 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2456018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456040 */     // GIR_Coverage, 45347,
     /* 2456040 */     GIR_EraseRootFromParent_Done,
     /* 2456041 */   // Label 35538: @2456041
     /* 2456041 */   GIM_Try, /*On fail goto*//*Label 35539*/ GIMT_Encode4(2456113), // Rule ID 45348 //
     /* 2456046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2456062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456078 */     // MIs[0] policy
     /* 2456078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456088 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2456091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456112 */     // GIR_Coverage, 45348,
     /* 2456112 */     GIR_EraseRootFromParent_Done,
     /* 2456113 */   // Label 35539: @2456113
     /* 2456113 */   GIM_Try, /*On fail goto*//*Label 35540*/ GIMT_Encode4(2456185), // Rule ID 45349 //
     /* 2456118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2456134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2456142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456150 */     // MIs[0] policy
     /* 2456150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456160 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2456163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456184 */     // GIR_Coverage, 45349,
     /* 2456184 */     GIR_EraseRootFromParent_Done,
     /* 2456185 */   // Label 35540: @2456185
     /* 2456185 */   GIM_Reject,
     /* 2456186 */ // Label 35536: @2456186
     /* 2456186 */ GIM_Reject,
     /* 2456187 */ // Label 35382: @2456187
     /* 2456187 */ GIM_Try, /*On fail goto*//*Label 35541*/ GIMT_Encode4(2456819),
     /* 2456192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2456195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2456198 */   GIM_Try, /*On fail goto*//*Label 35542*/ GIMT_Encode4(2456281), // Rule ID 45362 //
     /* 2456203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456239 */     // MIs[1] Operand 1
     /* 2456239 */     // No operand predicates
     /* 2456239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456243 */     // MIs[0] policy
     /* 2456243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456255 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456280 */     // GIR_Coverage, 45362,
     /* 2456280 */     GIR_EraseRootFromParent_Done,
     /* 2456281 */   // Label 35542: @2456281
     /* 2456281 */   GIM_Try, /*On fail goto*//*Label 35543*/ GIMT_Encode4(2456364), // Rule ID 45363 //
     /* 2456286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456322 */     // MIs[1] Operand 1
     /* 2456322 */     // No operand predicates
     /* 2456322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456326 */     // MIs[0] policy
     /* 2456326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456338 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456363 */     // GIR_Coverage, 45363,
     /* 2456363 */     GIR_EraseRootFromParent_Done,
     /* 2456364 */   // Label 35543: @2456364
     /* 2456364 */   GIM_Try, /*On fail goto*//*Label 35544*/ GIMT_Encode4(2456447), // Rule ID 45422 //
     /* 2456369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456405 */     // MIs[1] Operand 1
     /* 2456405 */     // No operand predicates
     /* 2456405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456409 */     // MIs[0] policy
     /* 2456409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456421 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456446 */     // GIR_Coverage, 45422,
     /* 2456446 */     GIR_EraseRootFromParent_Done,
     /* 2456447 */   // Label 35544: @2456447
     /* 2456447 */   GIM_Try, /*On fail goto*//*Label 35545*/ GIMT_Encode4(2456530), // Rule ID 45423 //
     /* 2456452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456488 */     // MIs[1] Operand 1
     /* 2456488 */     // No operand predicates
     /* 2456488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456492 */     // MIs[0] policy
     /* 2456492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456504 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456529 */     // GIR_Coverage, 45423,
     /* 2456529 */     GIR_EraseRootFromParent_Done,
     /* 2456530 */   // Label 35545: @2456530
     /* 2456530 */   GIM_Try, /*On fail goto*//*Label 35546*/ GIMT_Encode4(2456602), // Rule ID 45364 //
     /* 2456535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456567 */     // MIs[0] policy
     /* 2456567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456577 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456601 */     // GIR_Coverage, 45364,
     /* 2456601 */     GIR_EraseRootFromParent_Done,
     /* 2456602 */   // Label 35546: @2456602
     /* 2456602 */   GIM_Try, /*On fail goto*//*Label 35547*/ GIMT_Encode4(2456674), // Rule ID 45365 //
     /* 2456607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456639 */     // MIs[0] policy
     /* 2456639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456649 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456673 */     // GIR_Coverage, 45365,
     /* 2456673 */     GIR_EraseRootFromParent_Done,
     /* 2456674 */   // Label 35547: @2456674
     /* 2456674 */   GIM_Try, /*On fail goto*//*Label 35548*/ GIMT_Encode4(2456746), // Rule ID 45424 //
     /* 2456679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456711 */     // MIs[0] policy
     /* 2456711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456721 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456745 */     // GIR_Coverage, 45424,
     /* 2456745 */     GIR_EraseRootFromParent_Done,
     /* 2456746 */   // Label 35548: @2456746
     /* 2456746 */   GIM_Try, /*On fail goto*//*Label 35549*/ GIMT_Encode4(2456818), // Rule ID 45425 //
     /* 2456751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2456760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2456779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456783 */     // MIs[0] policy
     /* 2456783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456793 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2456796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2456804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2456814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456817 */     // GIR_Coverage, 45425,
     /* 2456817 */     GIR_EraseRootFromParent_Done,
     /* 2456818 */   // Label 35549: @2456818
     /* 2456818 */   GIM_Reject,
     /* 2456819 */ // Label 35541: @2456819
     /* 2456819 */ GIM_Reject,
     /* 2456820 */ // Label 35383: @2456820
     /* 2456820 */ GIM_Try, /*On fail goto*//*Label 35550*/ GIMT_Encode4(2457142),
     /* 2456825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2456828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2456831 */   GIM_Try, /*On fail goto*//*Label 35551*/ GIMT_Encode4(2456914), // Rule ID 45350 //
     /* 2456836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2456839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2456842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2456845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2456848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456872 */     // MIs[1] Operand 1
     /* 2456872 */     // No operand predicates
     /* 2456872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456876 */     // MIs[0] policy
     /* 2456876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456888 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2456888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456913 */     // GIR_Coverage, 45350,
     /* 2456913 */     GIR_EraseRootFromParent_Done,
     /* 2456914 */   // Label 35551: @2456914
     /* 2456914 */   GIM_Try, /*On fail goto*//*Label 35552*/ GIMT_Encode4(2456997), // Rule ID 45351 //
     /* 2456919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2456922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2456925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2456928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2456931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2456935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2456943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2456947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2456951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2456955 */     // MIs[1] Operand 1
     /* 2456955 */     // No operand predicates
     /* 2456955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2456959 */     // MIs[0] policy
     /* 2456959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2456962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2456964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2456971 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2456971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2456974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2456976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2456978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2456980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2456983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2456985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2456990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2456993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2456995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2456996 */     // GIR_Coverage, 45351,
     /* 2456996 */     GIR_EraseRootFromParent_Done,
     /* 2456997 */   // Label 35552: @2456997
     /* 2456997 */   GIM_Try, /*On fail goto*//*Label 35553*/ GIMT_Encode4(2457069), // Rule ID 45352 //
     /* 2457002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2457005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2457008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2457011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2457014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2457018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2457030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2457034 */     // MIs[0] policy
     /* 2457034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2457037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2457044 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2457044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2457047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2457049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2457051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2457053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2457055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2457057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2457062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2457065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2457067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2457068 */     // GIR_Coverage, 45352,
     /* 2457068 */     GIR_EraseRootFromParent_Done,
     /* 2457069 */   // Label 35553: @2457069
     /* 2457069 */   GIM_Try, /*On fail goto*//*Label 35554*/ GIMT_Encode4(2457141), // Rule ID 45353 //
     /* 2457074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2457077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2457080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2457083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2457086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2457090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2457098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2457102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2457106 */     // MIs[0] policy
     /* 2457106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2457109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2457116 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2457116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2457119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2457121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2457123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2457125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2457127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2457129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2457134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2457137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2457139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2457140 */     // GIR_Coverage, 45353,
     /* 2457140 */     GIR_EraseRootFromParent_Done,
     /* 2457141 */   // Label 35554: @2457141
     /* 2457141 */   GIM_Reject,
     /* 2457142 */ // Label 35550: @2457142
     /* 2457142 */ GIM_Reject,
     /* 2457143 */ // Label 35384: @2457143
     /* 2457143 */ GIM_Reject,
     /* 2457144 */ // Label 125: @2457144
     /* 2457144 */ GIM_Reject,
     /* 2457145 */ }; // Size: 2457145 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
